/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the RISCV target                           *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 102;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(4),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s32,
  GILLT_p0s64,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_nxv1s1,
  GILLT_nxv1s8,
  GILLT_nxv1s16,
  GILLT_nxv1s32,
  GILLT_nxv1s64,
  GILLT_nxv2s1,
  GILLT_nxv2s8,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s8,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv4s64,
  GILLT_nxv8s1,
  GILLT_nxv8s8,
  GILLT_nxv8s16,
  GILLT_nxv8s32,
  GILLT_nxv8s64,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
  GILLT_nxv16s16,
  GILLT_nxv16s32,
  GILLT_nxv32s1,
  GILLT_nxv32s8,
  GILLT_nxv32s16,
  GILLT_nxv64s1,
  GILLT_nxv64s8,
};
const static size_t NumTypeObjects = 34;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 32),
  LLT::pointer(0, 64),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(1), 8),
  LLT::vector(ElementCount::getScalable(1), 16),
  LLT::vector(ElementCount::getScalable(1), 32),
  LLT::vector(ElementCount::getScalable(1), 64),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 8),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 8),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(4), 64),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 8),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(8), 32),
  LLT::vector(ElementCount::getScalable(8), 64),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
  LLT::vector(ElementCount::getScalable(16), 16),
  LLT::vector(ElementCount::getScalable(16), 32),
  LLT::vector(ElementCount::getScalable(32), 1),
  LLT::vector(ElementCount::getScalable(32), 8),
  LLT::vector(ElementCount::getScalable(32), 16),
  LLT::vector(ElementCount::getScalable(64), 1),
  LLT::vector(ElementCount::getScalable(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasStdExtZicbopBit = 34,
  Feature_HasStdExtZicondBit = 36,
  Feature_HasStdExtZihintpauseBit = 22,
  Feature_HasStdExtZimopBit = 33,
  Feature_HasStdExtZicfilpBit = 2,
  Feature_NoStdExtZicfilpBit = 1,
  Feature_HasStdExtZilsdBit = 37,
  Feature_HasStdExtZmmulBit = 23,
  Feature_HasStdExtMBit = 24,
  Feature_HasStdExtABit = 26,
  Feature_HasStdExtZtsoBit = 28,
  Feature_NotHasStdExtZtsoBit = 27,
  Feature_HasStdExtZabhaBit = 31,
  Feature_HasStdExtZacasBit = 30,
  Feature_NoStdExtZacasBit = 29,
  Feature_HasStdExtZalasrBit = 32,
  Feature_HasStdExtFBit = 5,
  Feature_HasStdExtDBit = 7,
  Feature_HasStdExtZfhminBit = 12,
  Feature_HasStdExtZfhBit = 10,
  Feature_HasStdExtZfaBit = 38,
  Feature_NoStdExtZfaBit = 8,
  Feature_HasStdExtZfinxBit = 6,
  Feature_HasStdExtZdinxBit = 9,
  Feature_HasStdExtZhinxminBit = 13,
  Feature_HasStdExtZhinxBit = 11,
  Feature_HasStdExtZcaBit = 20,
  Feature_HasStdExtCBit = 18,
  Feature_HasStdExtZbaBit = 44,
  Feature_NotHasStdExtZbaBit = 21,
  Feature_HasStdExtZbbBit = 41,
  Feature_NoStdExtZbbBit = 43,
  Feature_HasStdExtZbcBit = 46,
  Feature_HasStdExtZbsBit = 40,
  Feature_HasStdExtZbkbBit = 42,
  Feature_NoStdExtZbkbBit = 99,
  Feature_HasStdExtZbkxBit = 47,
  Feature_HasStdExtZbbOrZbkbBit = 39,
  Feature_HasStdExtZbcOrZbkcBit = 45,
  Feature_HasStdExtZkndBit = 48,
  Feature_HasStdExtZkneBit = 50,
  Feature_HasStdExtZkndOrZkneBit = 49,
  Feature_HasStdExtZknhBit = 51,
  Feature_HasStdExtZksedBit = 52,
  Feature_HasStdExtZkshBit = 53,
  Feature_HasStdExtZvkbBit = 61,
  Feature_HasStdExtZvbbBit = 60,
  Feature_HasStdExtZvbcBit = 65,
  Feature_HasStdExtZvkgBit = 62,
  Feature_HasStdExtZvknedBit = 63,
  Feature_HasStdExtZvknhaBit = 66,
  Feature_HasStdExtZvknhbBit = 67,
  Feature_HasStdExtZvksedBit = 68,
  Feature_HasStdExtZvkshBit = 64,
  Feature_HasVInstructionsBit = 14,
  Feature_HasVInstructionsI64Bit = 56,
  Feature_HasVInstructionsAnyFBit = 55,
  Feature_HasVInstructionsF16MinimalBit = 58,
  Feature_HasVInstructionsF16Bit = 54,
  Feature_HasVInstructionsF64Bit = 59,
  Feature_HasVInstructionsFullMultiplyBit = 57,
  Feature_HasVendorXVentanaCondOpsBit = 69,
  Feature_HasVendorXTHeadBaBit = 70,
  Feature_HasVendorXTHeadBbBit = 71,
  Feature_HasVendorXTHeadBsBit = 72,
  Feature_HasVendorXTHeadCondMovBit = 73,
  Feature_HasVendorXTHeadFMemIdxBit = 78,
  Feature_HasVendorXTHeadMacBit = 74,
  Feature_HasVendorXTHeadMemIdxBit = 77,
  Feature_HasVendorXTHeadMemPairBit = 76,
  Feature_HasVendorXTHeadVdotBit = 75,
  Feature_HasVendorXSfvcpBit = 79,
  Feature_HasVendorXSfvqmaccdodBit = 80,
  Feature_HasVendorXSfvqmaccqoqBit = 81,
  Feature_HasVendorXSfvfnrclipxfqfBit = 82,
  Feature_HasVendorXCVbitmanipBit = 84,
  Feature_HasVendorXCVmacBit = 87,
  Feature_HasVendorXCVmemBit = 83,
  Feature_HasVendorXCValuBit = 85,
  Feature_HasVendorXCVbiBit = 86,
  Feature_UseCCMovInsnBit = 97,
  Feature_HasVendorXMIPSCBOPBit = 96,
  Feature_NotHasVendorXMIPSCBOPBit = 35,
  Feature_HasVendorXqciaBit = 91,
  Feature_HasVendorXqcibiBit = 92,
  Feature_HasVendorXqcibmBit = 93,
  Feature_HasVendorXqcicmBit = 95,
  Feature_HasVendorXqciintBit = 94,
  Feature_HasVendorXqciliaBit = 88,
  Feature_HasVendorXqciloBit = 89,
  Feature_HasVendorXqcislsBit = 90,
  Feature_HasVendorXAndesPerfBit = 98,
  Feature_IsRV64Bit = 4,
  Feature_IsRV32Bit = 3,
  Feature_HasShortForwardBranchOptBit = 15,
  Feature_NoShortForwardBranchOptBit = 17,
  Feature_HasConditionalMoveFusionBit = 16,
  Feature_NoConditionalMoveFusionBit = 0,
  Feature_HasAtomicLdStBit = 25,
  Feature_OptForMinSizeBit = 19,
  Feature_HwMode1Bit = 101,
  Feature_HwMode0Bit = 100,
};

PredicateBitset RISCVInstructionSelector::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasStdExtZicbop())
    Features.set(Feature_HasStdExtZicbopBit);
  if (Subtarget->hasStdExtZicond())
    Features.set(Feature_HasStdExtZicondBit);
  if (Subtarget->hasStdExtZihintpause())
    Features.set(Feature_HasStdExtZihintpauseBit);
  if (Subtarget->hasStdExtZimop())
    Features.set(Feature_HasStdExtZimopBit);
  if (Subtarget->hasStdExtZicfilp())
    Features.set(Feature_HasStdExtZicfilpBit);
  if (!Subtarget->hasStdExtZicfilp())
    Features.set(Feature_NoStdExtZicfilpBit);
  if (Subtarget->hasStdExtZilsd())
    Features.set(Feature_HasStdExtZilsdBit);
  if (Subtarget->hasStdExtZmmul())
    Features.set(Feature_HasStdExtZmmulBit);
  if (Subtarget->hasStdExtM())
    Features.set(Feature_HasStdExtMBit);
  if (Subtarget->hasStdExtA())
    Features.set(Feature_HasStdExtABit);
  if (Subtarget->hasStdExtZtso())
    Features.set(Feature_HasStdExtZtsoBit);
  if (!Subtarget->hasStdExtZtso())
    Features.set(Feature_NotHasStdExtZtsoBit);
  if (Subtarget->hasStdExtZabha())
    Features.set(Feature_HasStdExtZabhaBit);
  if (Subtarget->hasStdExtZacas())
    Features.set(Feature_HasStdExtZacasBit);
  if (!Subtarget->hasStdExtZacas())
    Features.set(Feature_NoStdExtZacasBit);
  if (Subtarget->hasStdExtZalasr())
    Features.set(Feature_HasStdExtZalasrBit);
  if (Subtarget->hasStdExtF())
    Features.set(Feature_HasStdExtFBit);
  if (Subtarget->hasStdExtD())
    Features.set(Feature_HasStdExtDBit);
  if (Subtarget->hasStdExtZfhmin())
    Features.set(Feature_HasStdExtZfhminBit);
  if (Subtarget->hasStdExtZfh())
    Features.set(Feature_HasStdExtZfhBit);
  if (Subtarget->hasStdExtZfa())
    Features.set(Feature_HasStdExtZfaBit);
  if (!Subtarget->hasStdExtZfa())
    Features.set(Feature_NoStdExtZfaBit);
  if (Subtarget->hasStdExtZfinx())
    Features.set(Feature_HasStdExtZfinxBit);
  if (Subtarget->hasStdExtZdinx())
    Features.set(Feature_HasStdExtZdinxBit);
  if (Subtarget->hasStdExtZhinxmin())
    Features.set(Feature_HasStdExtZhinxminBit);
  if (Subtarget->hasStdExtZhinx())
    Features.set(Feature_HasStdExtZhinxBit);
  if (Subtarget->hasStdExtZca())
    Features.set(Feature_HasStdExtZcaBit);
  if (Subtarget->hasStdExtC())
    Features.set(Feature_HasStdExtCBit);
  if (Subtarget->hasStdExtZba())
    Features.set(Feature_HasStdExtZbaBit);
  if (!Subtarget->hasStdExtZba())
    Features.set(Feature_NotHasStdExtZbaBit);
  if (Subtarget->hasStdExtZbb())
    Features.set(Feature_HasStdExtZbbBit);
  if (!Subtarget->hasStdExtZbb())
    Features.set(Feature_NoStdExtZbbBit);
  if (Subtarget->hasStdExtZbc())
    Features.set(Feature_HasStdExtZbcBit);
  if (Subtarget->hasStdExtZbs())
    Features.set(Feature_HasStdExtZbsBit);
  if (Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbkbBit);
  if (!Subtarget->hasStdExtZbkb())
    Features.set(Feature_NoStdExtZbkbBit);
  if (Subtarget->hasStdExtZbkx())
    Features.set(Feature_HasStdExtZbkxBit);
  if (Subtarget->hasStdExtZbb() || Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbbOrZbkbBit);
  if (Subtarget->hasStdExtZbc() || Subtarget->hasStdExtZbkc())
    Features.set(Feature_HasStdExtZbcOrZbkcBit);
  if (Subtarget->hasStdExtZknd())
    Features.set(Feature_HasStdExtZkndBit);
  if (Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkneBit);
  if (Subtarget->hasStdExtZknd() || Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkndOrZkneBit);
  if (Subtarget->hasStdExtZknh())
    Features.set(Feature_HasStdExtZknhBit);
  if (Subtarget->hasStdExtZksed())
    Features.set(Feature_HasStdExtZksedBit);
  if (Subtarget->hasStdExtZksh())
    Features.set(Feature_HasStdExtZkshBit);
  if (Subtarget->hasStdExtZvkb())
    Features.set(Feature_HasStdExtZvkbBit);
  if (Subtarget->hasStdExtZvbb())
    Features.set(Feature_HasStdExtZvbbBit);
  if (Subtarget->hasStdExtZvbc())
    Features.set(Feature_HasStdExtZvbcBit);
  if (Subtarget->hasStdExtZvkg())
    Features.set(Feature_HasStdExtZvkgBit);
  if (Subtarget->hasStdExtZvkned())
    Features.set(Feature_HasStdExtZvknedBit);
  if (Subtarget->hasStdExtZvknha())
    Features.set(Feature_HasStdExtZvknhaBit);
  if (Subtarget->hasStdExtZvknhb())
    Features.set(Feature_HasStdExtZvknhbBit);
  if (Subtarget->hasStdExtZvksed())
    Features.set(Feature_HasStdExtZvksedBit);
  if (Subtarget->hasStdExtZvksh())
    Features.set(Feature_HasStdExtZvkshBit);
  if (Subtarget->hasVInstructions())
    Features.set(Feature_HasVInstructionsBit);
  if (Subtarget->hasVInstructionsI64())
    Features.set(Feature_HasVInstructionsI64Bit);
  if (Subtarget->hasVInstructionsAnyF())
    Features.set(Feature_HasVInstructionsAnyFBit);
  if (Subtarget->hasVInstructionsF16Minimal())
    Features.set(Feature_HasVInstructionsF16MinimalBit);
  if (Subtarget->hasVInstructionsF16())
    Features.set(Feature_HasVInstructionsF16Bit);
  if (Subtarget->hasVInstructionsF64())
    Features.set(Feature_HasVInstructionsF64Bit);
  if (Subtarget->hasVInstructionsFullMultiply())
    Features.set(Feature_HasVInstructionsFullMultiplyBit);
  if (Subtarget->hasVendorXVentanaCondOps())
    Features.set(Feature_HasVendorXVentanaCondOpsBit);
  if (Subtarget->hasVendorXTHeadBa())
    Features.set(Feature_HasVendorXTHeadBaBit);
  if (Subtarget->hasVendorXTHeadBb())
    Features.set(Feature_HasVendorXTHeadBbBit);
  if (Subtarget->hasVendorXTHeadBs())
    Features.set(Feature_HasVendorXTHeadBsBit);
  if (Subtarget->hasVendorXTHeadCondMov())
    Features.set(Feature_HasVendorXTHeadCondMovBit);
  if (Subtarget->hasVendorXTHeadFMemIdx())
    Features.set(Feature_HasVendorXTHeadFMemIdxBit);
  if (Subtarget->hasVendorXTHeadMac())
    Features.set(Feature_HasVendorXTHeadMacBit);
  if (Subtarget->hasVendorXTHeadMemIdx())
    Features.set(Feature_HasVendorXTHeadMemIdxBit);
  if (Subtarget->hasVendorXTHeadMemPair())
    Features.set(Feature_HasVendorXTHeadMemPairBit);
  if (Subtarget->hasVendorXTHeadVdot())
    Features.set(Feature_HasVendorXTHeadVdotBit);
  if (Subtarget->hasVendorXSfvcp())
    Features.set(Feature_HasVendorXSfvcpBit);
  if (Subtarget->hasVendorXSfvqmaccdod())
    Features.set(Feature_HasVendorXSfvqmaccdodBit);
  if (Subtarget->hasVendorXSfvqmaccqoq())
    Features.set(Feature_HasVendorXSfvqmaccqoqBit);
  if (Subtarget->hasVendorXSfvfnrclipxfqf())
    Features.set(Feature_HasVendorXSfvfnrclipxfqfBit);
  if (Subtarget->hasVendorXCVbitmanip())
    Features.set(Feature_HasVendorXCVbitmanipBit);
  if (Subtarget->hasVendorXCVmac())
    Features.set(Feature_HasVendorXCVmacBit);
  if (Subtarget->hasVendorXCVmem())
    Features.set(Feature_HasVendorXCVmemBit);
  if (Subtarget->hasVendorXCValu())
    Features.set(Feature_HasVendorXCValuBit);
  if (Subtarget->hasVendorXCVbi())
    Features.set(Feature_HasVendorXCVbiBit);
  if (Subtarget->useCCMovInsn())
    Features.set(Feature_UseCCMovInsnBit);
  if (Subtarget->hasVendorXMIPSCBOP())
    Features.set(Feature_HasVendorXMIPSCBOPBit);
  if (!Subtarget->hasVendorXMIPSCBOP())
    Features.set(Feature_NotHasVendorXMIPSCBOPBit);
  if (Subtarget->hasVendorXqcia())
    Features.set(Feature_HasVendorXqciaBit);
  if (Subtarget->hasVendorXqcibi())
    Features.set(Feature_HasVendorXqcibiBit);
  if (Subtarget->hasVendorXqcibm())
    Features.set(Feature_HasVendorXqcibmBit);
  if (Subtarget->hasVendorXqcicm())
    Features.set(Feature_HasVendorXqcicmBit);
  if (Subtarget->hasVendorXqciint())
    Features.set(Feature_HasVendorXqciintBit);
  if (Subtarget->hasVendorXqcilia())
    Features.set(Feature_HasVendorXqciliaBit);
  if (Subtarget->hasVendorXqcilo())
    Features.set(Feature_HasVendorXqciloBit);
  if (Subtarget->hasVendorXqcisls())
    Features.set(Feature_HasVendorXqcislsBit);
  if (Subtarget->hasVendorXAndesPerf())
    Features.set(Feature_HasVendorXAndesPerfBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_IsRV64Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_IsRV32Bit);
  if (Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_HasShortForwardBranchOptBit);
  if (!Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_NoShortForwardBranchOptBit);
  if (Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_HasConditionalMoveFusionBit);
  if (!Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_NoConditionalMoveFusionBit);
  if (Subtarget->hasStdExtA() || Subtarget->hasForcedAtomics())
    Features.set(Feature_HasAtomicLdStBit);
  if (MF ? MF->getFunction().hasMinSize() : false)
    Features.set(Feature_OptForMinSizeBit);
  if (!((Subtarget->is64Bit())))
    Features.set(Feature_HwMode1Bit);
  if ((Subtarget->is64Bit()))
    Features.set(Feature_HwMode0Bit);
  return Features;
}

void RISCVInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVInstructionSelector::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HwMode0,
  GIFBS_HwMode1,
  GIFBS_HasAtomicLdSt_HwMode0,
  GIFBS_HasAtomicLdSt_HwMode1,
  GIFBS_HasShortForwardBranchOpt_HwMode0,
  GIFBS_HasShortForwardBranchOpt_HwMode1,
  GIFBS_HasStdExtA_HwMode0,
  GIFBS_HasStdExtA_HwMode1,
  GIFBS_HasStdExtD,
  GIFBS_HasStdExtD_HwMode0,
  GIFBS_HasStdExtD_HwMode1,
  GIFBS_HasStdExtF,
  GIFBS_HasStdExtF_HwMode0,
  GIFBS_HasStdExtF_HwMode1,
  GIFBS_HasStdExtM_HwMode0,
  GIFBS_HasStdExtM_HwMode1,
  GIFBS_HasStdExtZalasr_HwMode0,
  GIFBS_HasStdExtZalasr_HwMode1,
  GIFBS_HasStdExtZba_HwMode0,
  GIFBS_HasStdExtZba_HwMode1,
  GIFBS_HasStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_HwMode1,
  GIFBS_HasStdExtZbkb_HwMode0,
  GIFBS_HasStdExtZbkb_HwMode1,
  GIFBS_HasStdExtZbkx_HwMode0,
  GIFBS_HasStdExtZbkx_HwMode1,
  GIFBS_HasStdExtZbs_HwMode0,
  GIFBS_HasStdExtZbs_HwMode1,
  GIFBS_HasStdExtZfa,
  GIFBS_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtZfh,
  GIFBS_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtZfinx,
  GIFBS_HasStdExtZfinx_HwMode0,
  GIFBS_HasStdExtZfinx_HwMode1,
  GIFBS_HasStdExtZhinx,
  GIFBS_HasStdExtZhinx_HwMode0,
  GIFBS_HasStdExtZhinx_HwMode1,
  GIFBS_HasStdExtZhinxmin_HwMode0,
  GIFBS_HasStdExtZhinxmin_HwMode1,
  GIFBS_HasStdExtZihintpause_HwMode0,
  GIFBS_HasStdExtZihintpause_HwMode1,
  GIFBS_HasStdExtZmmul_HwMode0,
  GIFBS_HasStdExtZmmul_HwMode1,
  GIFBS_HasStdExtZvbb_HwMode0,
  GIFBS_HasStdExtZvbb_HwMode1,
  GIFBS_HasStdExtZvbc_HwMode0,
  GIFBS_HasStdExtZvbc_HwMode1,
  GIFBS_HasStdExtZvkb_HwMode0,
  GIFBS_HasStdExtZvkb_HwMode1,
  GIFBS_HasStdExtZvkg_HwMode0,
  GIFBS_HasStdExtZvkg_HwMode1,
  GIFBS_HasStdExtZvkned_HwMode0,
  GIFBS_HasStdExtZvkned_HwMode1,
  GIFBS_HasStdExtZvknha_HwMode0,
  GIFBS_HasStdExtZvknha_HwMode1,
  GIFBS_HasStdExtZvknhb_HwMode0,
  GIFBS_HasStdExtZvknhb_HwMode1,
  GIFBS_HasStdExtZvksed_HwMode0,
  GIFBS_HasStdExtZvksed_HwMode1,
  GIFBS_HasStdExtZvksh_HwMode0,
  GIFBS_HasStdExtZvksh_HwMode1,
  GIFBS_HasVInstructions_HwMode0,
  GIFBS_HasVInstructions_HwMode1,
  GIFBS_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsFullMultiply_HwMode0,
  GIFBS_HasVInstructionsFullMultiply_HwMode1,
  GIFBS_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXAndesPerf_HwMode0,
  GIFBS_HasVendorXAndesPerf_HwMode1,
  GIFBS_HasVendorXCVmac_HwMode0,
  GIFBS_HasVendorXCVmac_HwMode1,
  GIFBS_HasVendorXSfvcp_HwMode0,
  GIFBS_HasVendorXSfvcp_HwMode1,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1,
  GIFBS_HasVendorXSfvqmaccdod_HwMode0,
  GIFBS_HasVendorXSfvqmaccdod_HwMode1,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode0,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode1,
  GIFBS_HasVendorXTHeadBa_HwMode0,
  GIFBS_HasVendorXTHeadBa_HwMode1,
  GIFBS_HasVendorXTHeadBb_HwMode0,
  GIFBS_HasVendorXTHeadBb_HwMode1,
  GIFBS_HasVendorXTHeadBs_HwMode0,
  GIFBS_HasVendorXTHeadBs_HwMode1,
  GIFBS_HasVendorXTHeadCondMov_HwMode0,
  GIFBS_HasVendorXTHeadCondMov_HwMode1,
  GIFBS_HasVendorXTHeadMac_HwMode0,
  GIFBS_HasVendorXTHeadMac_HwMode1,
  GIFBS_HasVendorXTHeadVdot_HwMode0,
  GIFBS_HasVendorXTHeadVdot_HwMode1,
  GIFBS_IsRV32_HwMode0,
  GIFBS_IsRV32_HwMode1,
  GIFBS_IsRV64_HwMode0,
  GIFBS_IsRV64_HwMode1,
  GIFBS_UseCCMovInsn_HwMode0,
  GIFBS_UseCCMovInsn_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_IsRV64_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode1,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfa,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtD_IsRV32_HwMode0,
  GIFBS_HasStdExtD_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV64_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode1,
  GIFBS_HasStdExtF_IsRV64_HwMode0,
  GIFBS_HasStdExtM_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode1,
  GIFBS_HasStdExtZba_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV64_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfh_IsRV32_HwMode0,
  GIFBS_HasStdExtZfh_IsRV32_HwMode1,
  GIFBS_HasStdExtZfh_IsRV64_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZfinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZhinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZknd_IsRV32_HwMode1,
  GIFBS_HasStdExtZknd_IsRV64_HwMode0,
  GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZkne_IsRV32_HwMode1,
  GIFBS_HasStdExtZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZknh_IsRV32_HwMode1,
  GIFBS_HasStdExtZknh_IsRV64_HwMode0,
  GIFBS_HasStdExtZmmul_IsRV64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode1,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1,
  GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0,
  GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode1,
  GIFBS_HasVendorXqcibm_IsRV32_HwMode0,
  GIFBS_HasVendorXqcibm_IsRV32_HwMode1,
  GIFBS_HasVendorXqcicm_IsRV32_HwMode0,
  GIFBS_HasVendorXqcicm_IsRV32_HwMode1,
  GIFBS_HasVendorXqcilia_IsRV32_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode0,
  GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1,
  GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HwMode0Bit, },
  {Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode1Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode0Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, },
  {Feature_HasStdExtDBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, },
  {Feature_HasStdExtFBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZihintpauseBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZihintpauseBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode0Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndOrZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcicmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcicmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqciliaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZilsdBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZilsdBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_GIAddrRegImm,
  GICP_GIShiftMask32,
  GICP_GIShiftMaskXLen,
  GICP_GIVLOp,
  GICP_gi_sexti32,
  GICP_gi_sh1add_op,
  GICP_gi_sh1add_uw_op,
  GICP_gi_sh2add_op,
  GICP_gi_sh2add_uw_op,
  GICP_gi_sh3add_op,
  GICP_gi_sh3add_uw_op,
  GICP_gi_zexti16,
  GICP_gi_zexti32,
  GICP_gi_zexti8,
};
// See constructor for table contents

RISCVInstructionSelector::ComplexMatcherMemFn
RISCVInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &RISCVInstructionSelector::selectAddrRegImm, // GIAddrRegImm
  &RISCVInstructionSelector::selectShiftMask32, // GIShiftMask32
  &RISCVInstructionSelector::selectShiftMaskXLen, // GIShiftMaskXLen
  &RISCVInstructionSelector::renderVLOp, // GIVLOp
  &RISCVInstructionSelector::selectSExtBits<32>, // gi_sexti32
  &RISCVInstructionSelector::selectSHXADDOp<1>, // gi_sh1add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<1>, // gi_sh1add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<2>, // gi_sh2add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<2>, // gi_sh2add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<3>, // gi_sh3add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<3>, // gi_sh3add_uw_op
  &RISCVInstructionSelector::selectZExtBits<16>, // gi_zexti16
  &RISCVInstructionSelector::selectZExtBits<32>, // gi_zexti32
  &RISCVInstructionSelector::selectZExtBits<8>, // gi_zexti8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_like_non_imm12 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_add_non_imm12,
  GICXXPred_MI_Predicate_anonymous_9935,
  GICXXPred_MI_Predicate_anonymous_9937,
  GICXXPred_MI_Predicate_anonymous_10027,
  GICXXPred_MI_Predicate_anonymous_10041,
  GICXXPred_MI_Predicate_anonymous_10045,
  GICXXPred_MI_Predicate_anonymous_10047,
  GICXXPred_MI_Predicate_anonymous_10049,
  GICXXPred_MI_Predicate_anonymous_10051,
  GICXXPred_MI_Predicate_anonymous_10054,
  GICXXPred_MI_Predicate_anonymous_10056,
  GICXXPred_MI_Predicate_anonymous_10069,
  GICXXPred_MI_Predicate_anonymous_10082,
  GICXXPred_MI_Predicate_anonymous_11278,
  GICXXPred_MI_Predicate_or_disjoint,
};
bool RISCVInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_like_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_like_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_add_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_9935: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9937: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10027: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10041: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10045: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10047: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10049: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10051: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10054: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10056: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10069: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10082: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_11278: {
     return hasAllHUsers(MI); 
  }
  case GICXXPred_MI_Predicate_or_disjoint: {
    
        return MI.getFlag(MachineInstr::Disjoint);
      
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AddiPair = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BCLRMask,
  GICXXPred_I64_Predicate_LeadingOnesMask,
  GICXXPred_I64_Predicate_LeadingOnesWMask,
  GICXXPred_I64_Predicate_SingleBitSetMask,
  GICXXPred_I64_Predicate_allonessew8,
  GICXXPred_I64_Predicate_allonessew16,
  GICXXPred_I64_Predicate_allonessew32,
  GICXXPred_I64_Predicate_allonessew64,
  GICXXPred_I64_Predicate_bare_simm9_lsb0,
  GICXXPred_I64_Predicate_bare_simm12_lsb0,
  GICXXPred_I64_Predicate_bare_simm13_lsb0,
  GICXXPred_I64_Predicate_byteselect,
  GICXXPred_I64_Predicate_c_lui_imm,
  GICXXPred_I64_Predicate_csr_sysreg,
  GICXXPred_I64_Predicate_cv_tuimm2,
  GICXXPred_I64_Predicate_cv_tuimm5,
  GICXXPred_I64_Predicate_cv_uimm10,
  GICXXPred_I64_Predicate_immzero,
  GICXXPred_I64_Predicate_payload1,
  GICXXPred_I64_Predicate_payload2,
  GICXXPred_I64_Predicate_payload5,
  GICXXPred_I64_Predicate_powerOf2Minus1,
  GICXXPred_I64_Predicate_rnum,
  GICXXPred_I64_Predicate_simm5,
  GICXXPred_I64_Predicate_simm5_plus1,
  GICXXPred_I64_Predicate_simm5_plus1_nonzero,
  GICXXPred_I64_Predicate_simm5nonzero,
  GICXXPred_I64_Predicate_simm6,
  GICXXPred_I64_Predicate_simm6nonzero,
  GICXXPred_I64_Predicate_simm10,
  GICXXPred_I64_Predicate_simm10_lsb0000nonzero,
  GICXXPred_I64_Predicate_simm11,
  GICXXPred_I64_Predicate_simm12,
  GICXXPred_I64_Predicate_simm12Minus1Nonzero,
  GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1,
  GICXXPred_I64_Predicate_simm12Plus1,
  GICXXPred_I64_Predicate_simm12Plus1i32,
  GICXXPred_I64_Predicate_simm12_lsb00000,
  GICXXPred_I64_Predicate_simm12_no6,
  GICXXPred_I64_Predicate_simm12_plus1,
  GICXXPred_I64_Predicate_simm16nonzero,
  GICXXPred_I64_Predicate_simm20_li,
  GICXXPred_I64_Predicate_simm21_lsb0_jal,
  GICXXPred_I64_Predicate_simm26,
  GICXXPred_I64_Predicate_simm26_nosimm12,
  GICXXPred_I64_Predicate_simm32_nosimm26,
  GICXXPred_I64_Predicate_tsimm5,
  GICXXPred_I64_Predicate_tuimm5,
  GICXXPred_I64_Predicate_u32simm12,
  GICXXPred_I64_Predicate_uimm1,
  GICXXPred_I64_Predicate_uimm2,
  GICXXPred_I64_Predicate_uimm2_3,
  GICXXPred_I64_Predicate_uimm2_4,
  GICXXPred_I64_Predicate_uimm2_lsb0,
  GICXXPred_I64_Predicate_uimm3,
  GICXXPred_I64_Predicate_uimm4,
  GICXXPred_I64_Predicate_uimm5,
  GICXXPred_I64_Predicate_uimm5_lsb0,
  GICXXPred_I64_Predicate_uimm5_plus1,
  GICXXPred_I64_Predicate_uimm5ge6_plus1,
  GICXXPred_I64_Predicate_uimm5gt3,
  GICXXPred_I64_Predicate_uimm5i32,
  GICXXPred_I64_Predicate_uimm5nonzero,
  GICXXPred_I64_Predicate_uimm5slist,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_lsb0,
  GICXXPred_I64_Predicate_uimm6gt32,
  GICXXPred_I64_Predicate_uimm7,
  GICXXPred_I64_Predicate_uimm7_lsb00,
  GICXXPred_I64_Predicate_uimm7_lsb000,
  GICXXPred_I64_Predicate_uimm8_lsb00,
  GICXXPred_I64_Predicate_uimm8_lsb000,
  GICXXPred_I64_Predicate_uimm9_lsb000,
  GICXXPred_I64_Predicate_uimm10,
  GICXXPred_I64_Predicate_uimm10_lsb00nonzero,
  GICXXPred_I64_Predicate_uimm11,
  GICXXPred_I64_Predicate_uimm14lsb00,
  GICXXPred_I64_Predicate_uimm16nonzero,
  GICXXPred_I64_Predicate_uimmlog2xlen,
  GICXXPred_I64_Predicate_uimmlog2xlennonzero,
};
bool RISCVInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AddiPair: {
    
      // The immediate operand must be in range [-4096,-2049] or [2048,4094].
      return (-4096 <= Imm && Imm <= -2049) || (2048 <= Imm && Imm <= 4094);
    
    llvm_unreachable("AddiPair should have returned");
  }
  case GICXXPred_I64_Predicate_BCLRMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(~Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(~Imm);
    
    llvm_unreachable("BCLRMask should have returned");
  }
  case GICXXPred_I64_Predicate_LeadingOnesMask: {
    
      return !isInt<32>(Imm) && isMask_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_LeadingOnesWMask: {
    
      // If the value is a uint32 but not an int32, it must have bit 31 set and
      // bits 63:32 cleared. After that we're looking for a shifted mask but not
      // an all ones mask.
      return !isInt<32>(Imm) && isUInt<32>(Imm) && isShiftedMask_64(Imm) &&
             Imm != UINT64_C(0xffffffff);
    
    llvm_unreachable("LeadingOnesWMask should have returned");
  }
  case GICXXPred_I64_Predicate_SingleBitSetMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(Imm);
    
    llvm_unreachable("SingleBitSetMask should have returned");
  }
  case GICXXPred_I64_Predicate_allonessew8: {
    return SignExtend64<8>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew16: {
    return SignExtend64<16>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew32: {
    return SignExtend64<32>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew64: {
    return Imm == -1LL;
  }
  case GICXXPred_I64_Predicate_bare_simm9_lsb0: {
    return isShiftedInt<8, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_bare_simm12_lsb0: {
    return isShiftedInt<11, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_bare_simm13_lsb0: {
    return isShiftedInt<12, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_byteselect: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_c_lui_imm: {
    return (Imm != 0) &&
                                     (isUInt<5>(Imm) ||
                                      (Imm >= 0xfffe0 && Imm <= 0xfffff));
  }
  case GICXXPred_I64_Predicate_csr_sysreg: {
    return isUInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immzero: {
    return (Imm == 0);
  }
  case GICXXPred_I64_Predicate_payload1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_payload2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_payload5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_powerOf2Minus1: {
     return isPowerOf2_32(Imm+1); 
  }
  case GICXXPred_I64_Predicate_rnum: {
    return (Imm >= 0 && Imm <= 10);
  }
  case GICXXPred_I64_Predicate_simm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm5_plus1: {
    return (isInt<5>(Imm) && Imm != -16) || Imm == 16;
  }
  case GICXXPred_I64_Predicate_simm5_plus1_nonzero: {
    return Imm != 0 && ((isInt<5>(Imm) && Imm != -16) || Imm == 16);
  }
  case GICXXPred_I64_Predicate_simm5nonzero: {
    return (Imm != 0) && isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6nonzero: {
    return (Imm != 0) && isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm10: {
    return isInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_simm10_lsb0000nonzero: {
    return (Imm != 0) && isShiftedInt<6, 4>(Imm);
  }
  case GICXXPred_I64_Predicate_simm11: {
    return isInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12: {
    return isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12Minus1Nonzero: {
    
      return (Imm >= -2049 && Imm < 0) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1: {
    
      return (Imm >= -2049 && Imm < -1) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Plus1: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12Plus1i32: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12_lsb00000: {
    return isShiftedInt<7, 5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12_no6: {
    
      return isInt<12>(Imm) && !isInt<6>(Imm) && isInt<12>(-Imm);
  }
  case GICXXPred_I64_Predicate_simm12_plus1: {
    return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm16nonzero: {
    return (Imm != 0) && isInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_simm20_li: {
    return isInt<20>(Imm);
  }
  case GICXXPred_I64_Predicate_simm21_lsb0_jal: {
    return isShiftedInt<20, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26: {
    return isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26_nosimm12: {
    
      return isInt<26>(Imm) && !isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm32_nosimm26: {
    
      return isInt<32>(Imm) && !isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_tsimm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_u32simm12: {
    
      return isUInt<32>(Imm) && isInt<12>(SignExtend64<32>(Imm));
    
  }
  case GICXXPred_I64_Predicate_uimm1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2_3: {
    
      return isShiftedUInt<2, 3>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_4: {
    
      return isShiftedUInt<2, 4>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_lsb0: {
    return isShiftedUInt<1, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_lsb0: {
    return isShiftedUInt<4, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_plus1: {
    return (isUInt<5>(Imm) && (Imm != 0)) || (Imm == 32);
  }
  case GICXXPred_I64_Predicate_uimm5ge6_plus1: {
    return (Imm >= 6) && (isUInt<5>(Imm) || (Imm == 32));
  }
  case GICXXPred_I64_Predicate_uimm5gt3: {
    return (Imm > 3) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5i32: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5nonzero: {
    return (Imm != 0) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5slist: {
    return ((Imm == 0)  ||
                (Imm == 1)  ||
                (Imm == 2)  ||
                (Imm == 4)  ||
                (Imm == 8)  ||
                (Imm == 16) ||
                (Imm == 15) ||
                (Imm == 31));
  }
  case GICXXPred_I64_Predicate_uimm6: {
    return isUInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6_lsb0: {
    return isShiftedUInt<5, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6gt32: {
    
      return isUInt<6>(Imm) && Imm > 32;
    
  }
  case GICXXPred_I64_Predicate_uimm7: {
    return isUInt<7>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm7_lsb00: {
    return isShiftedUInt<5, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm7_lsb000: {
    return isShiftedUInt<4, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb00: {
    return isShiftedUInt<6, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb000: {
    return isShiftedUInt<5, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm9_lsb000: {
    return isShiftedUInt<6, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10_lsb00nonzero: {
    return isShiftedUInt<8, 2>(Imm) && (Imm != 0);
  }
  case GICXXPred_I64_Predicate_uimm11: {
    return isUInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm14lsb00: {
    return isShiftedUInt<12, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm16nonzero: {
    return (Imm != 0) && isUInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_uimmlog2xlen: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm);
      return isUInt<5>(Imm);
    
    llvm_unreachable("uimmlog2xlen should have returned");
  }
  case GICXXPred_I64_Predicate_uimmlog2xlennonzero: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm) && (Imm != 0);
      return isUInt<5>(Imm) && (Imm != 0);
    
    llvm_unreachable("uimmlog2xlennonzero should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_Shifted32OnesMask = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_TrailingOnesMask,
};
bool RISCVInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_Shifted32OnesMask: {
    
      if (!Imm.isShiftedMask())
        return false;
    
      unsigned TrailingZeros = Imm.countr_zero();
      return TrailingZeros > 0 && TrailingZeros < 32 &&
             Imm == UINT64_C(0xFFFFFFFF) << TrailingZeros;
    
    llvm_unreachable("Shifted32OnesMask should have returned");
  }
  case GICXXPred_APInt_Predicate_TrailingOnesMask: {
    
      return !isInt<12>(Imm.getSExtValue()) && isMask_64(Imm.getZExtValue());
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("RISCVInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderAddiPairImmLarge,
  GICR_renderAddiPairImmSmall,
  GICR_renderFrameIndex,
  GICR_renderImmPlus1,
  GICR_renderImmSubFrom32,
  GICR_renderImmSubFromXLen,
  GICR_renderNegImm,
  GICR_renderTrailingZeros,
  GICR_renderXLenSubTrailingOnes,
};
RISCVInstructionSelector::CustomRendererFn
RISCVInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &RISCVInstructionSelector::renderAddiPairImmLarge,
  &RISCVInstructionSelector::renderAddiPairImmSmall,
  &RISCVInstructionSelector::renderFrameIndex,
  &RISCVInstructionSelector::renderImmPlus1,
  &RISCVInstructionSelector::renderImmSubFrom32,
  &RISCVInstructionSelector::renderImmSubFromXLen,
  &RISCVInstructionSelector::renderNegImm,
  &RISCVInstructionSelector::renderTrailingZeros,
  &RISCVInstructionSelector::renderXLenSubTrailingOnes,
};

bool RISCVInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool RISCVInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("RISCVInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*       0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(336), /*)*//*default:*//*Label 125*/ GIMT_Encode4(2451425),
     /*      10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1142),
     /*      14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(61083),
     /*      18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(80316),
     /*      22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(107370),
     /*      26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(110104),
     /*      30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(112838),
     /*      34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(115617), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(118351),
     /*      50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(128309),
     /*      54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(140930), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      74 */ /*TargetOpcode::G_FRAME_INDEX*//*Label 10*/ GIMT_Encode4(155837), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      94 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 11*/ GIMT_Encode4(155898), GIMT_Encode4(0),
     /*     102 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 12*/ GIMT_Encode4(155959), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     126 */ /*TargetOpcode::G_BITCAST*//*Label 13*/ GIMT_Encode4(156050), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 14*/ GIMT_Encode4(156417),
     /*     146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 15*/ GIMT_Encode4(156615),
     /*     150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 16*/ GIMT_Encode4(156813),
     /*     154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 17*/ GIMT_Encode4(157393),
     /*     158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 18*/ GIMT_Encode4(157603),
     /*     162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 19*/ GIMT_Encode4(157801),
     /*     166 */ /*TargetOpcode::G_READSTEADYCOUNTER*//*Label 20*/ GIMT_Encode4(157840),
     /*     170 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(157879),
     /*     174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(166857),
     /*     178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(167971), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     194 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(168605), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 25*/ GIMT_Encode4(175505),
     /*     210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 26*/ GIMT_Encode4(180391),
     /*     214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 27*/ GIMT_Encode4(183301), GIMT_Encode4(0),
     /*     222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 28*/ GIMT_Encode4(186211),
     /*     226 */ /*TargetOpcode::G_ATOMICRMW_NAND*//*Label 29*/ GIMT_Encode4(189121),
     /*     230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 30*/ GIMT_Encode4(190033),
     /*     234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 31*/ GIMT_Encode4(192943),
     /*     238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 32*/ GIMT_Encode4(195853),
     /*     242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 33*/ GIMT_Encode4(198763),
     /*     246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 34*/ GIMT_Encode4(201673),
     /*     250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 35*/ GIMT_Encode4(204583), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(207493), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(207711),
     /*     318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(2206004), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(2207572), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     366 */ /*TargetOpcode::G_SEXT*//*Label 40*/ GIMT_Encode4(2210693),
     /*     370 */ /*TargetOpcode::G_SEXT_INREG*//*Label 41*/ GIMT_Encode4(2214168),
     /*     374 */ /*TargetOpcode::G_ZEXT*//*Label 42*/ GIMT_Encode4(2215211),
     /*     378 */ /*TargetOpcode::G_SHL*//*Label 43*/ GIMT_Encode4(2218898),
     /*     382 */ /*TargetOpcode::G_LSHR*//*Label 44*/ GIMT_Encode4(2227494),
     /*     386 */ /*TargetOpcode::G_ASHR*//*Label 45*/ GIMT_Encode4(2230525), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     398 */ /*TargetOpcode::G_ROTR*//*Label 46*/ GIMT_Encode4(2233464),
     /*     402 */ /*TargetOpcode::G_ROTL*//*Label 47*/ GIMT_Encode4(2236404),
     /*     406 */ /*TargetOpcode::G_ICMP*//*Label 48*/ GIMT_Encode4(2239314),
     /*     410 */ /*TargetOpcode::G_FCMP*//*Label 49*/ GIMT_Encode4(2266391), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     422 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(2273853), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     466 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(2279573),
     /*     470 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(2282307),
     /*     474 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(2285041),
     /*     478 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(2287894),
     /*     482 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(2290747),
     /*     486 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(2293600),
     /*     490 */ /*TargetOpcode::G_USHLSAT*//*Label 57*/ GIMT_Encode4(2296453),
     /*     494 */ /*TargetOpcode::G_SSHLSAT*//*Label 58*/ GIMT_Encode4(2296511), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     530 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(2296569),
     /*     534 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(2298997),
     /*     538 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(2301425),
     /*     542 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(2303853), GIMT_Encode4(0),
     /*     550 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(2320498), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     598 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(2322926),
     /*     602 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(2324897),
     /*     606 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(2325350),
     /*     610 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(2326886),
     /*     614 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(2331772),
     /*     618 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(2336658),
     /*     622 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(2341944), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     634 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(2347230),
     /*     638 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 72*/ GIMT_Encode4(2349201), GIMT_Encode4(0),
     /*     646 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 73*/ GIMT_Encode4(2355263),
     /*     650 */ /*TargetOpcode::G_FMINNUM*//*Label 74*/ GIMT_Encode4(2355453),
     /*     654 */ /*TargetOpcode::G_FMAXNUM*//*Label 75*/ GIMT_Encode4(2357538), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     666 */ /*TargetOpcode::G_FMINIMUM*//*Label 76*/ GIMT_Encode4(2359623),
     /*     670 */ /*TargetOpcode::G_FMAXIMUM*//*Label 77*/ GIMT_Encode4(2359749),
     /*     674 */ /*TargetOpcode::G_FMINIMUMNUM*//*Label 78*/ GIMT_Encode4(2359875),
     /*     678 */ /*TargetOpcode::G_FMAXIMUMNUM*//*Label 79*/ GIMT_Encode4(2361960), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     714 */ /*TargetOpcode::G_SMIN*//*Label 80*/ GIMT_Encode4(2364045),
     /*     718 */ /*TargetOpcode::G_SMAX*//*Label 81*/ GIMT_Encode4(2366821),
     /*     722 */ /*TargetOpcode::G_UMIN*//*Label 82*/ GIMT_Encode4(2369597),
     /*     726 */ /*TargetOpcode::G_UMAX*//*Label 83*/ GIMT_Encode4(2372373),
     /*     730 */ /*TargetOpcode::G_ABS*//*Label 84*/ GIMT_Encode4(2375149),
     /*     734 */ /*TargetOpcode::G_LROUND*//*Label 85*/ GIMT_Encode4(2375307),
     /*     738 */ /*TargetOpcode::G_LLROUND*//*Label 86*/ GIMT_Encode4(2375887),
     /*     742 */ /*TargetOpcode::G_BR*//*Label 87*/ GIMT_Encode4(2376097), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     786 */ /*TargetOpcode::G_CTTZ*//*Label 88*/ GIMT_Encode4(2376113), GIMT_Encode4(0),
     /*     794 */ /*TargetOpcode::G_CTLZ*//*Label 89*/ GIMT_Encode4(2378741), GIMT_Encode4(0),
     /*     802 */ /*TargetOpcode::G_CTPOP*//*Label 90*/ GIMT_Encode4(2381511),
     /*     806 */ /*TargetOpcode::G_BSWAP*//*Label 91*/ GIMT_Encode4(2384062),
     /*     810 */ /*TargetOpcode::G_BITREVERSE*//*Label 92*/ GIMT_Encode4(2386597),
     /*     814 */ /*TargetOpcode::G_FCEIL*//*Label 93*/ GIMT_Encode4(2389143), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     862 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(2389341),
     /*     866 */ /*TargetOpcode::G_FFLOOR*//*Label 95*/ GIMT_Encode4(2391517),
     /*     870 */ /*TargetOpcode::G_FRINT*//*Label 96*/ GIMT_Encode4(2391715),
     /*     874 */ /*TargetOpcode::G_FNEARBYINT*//*Label 97*/ GIMT_Encode4(2391913), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     902 */ /*TargetOpcode::G_STRICT_FADD*//*Label 98*/ GIMT_Encode4(2392111),
     /*     906 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 99*/ GIMT_Encode4(2394539),
     /*     910 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 100*/ GIMT_Encode4(2396967),
     /*     914 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 101*/ GIMT_Encode4(2399395), GIMT_Encode4(0),
     /*     922 */ /*TargetOpcode::G_STRICT_FMA*//*Label 102*/ GIMT_Encode4(2401823),
     /*     926 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 103*/ GIMT_Encode4(2418468), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     962 */ /*TargetOpcode::G_TRAP*//*Label 104*/ GIMT_Encode4(2420644),
     /*     966 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 105*/ GIMT_Encode4(2420657), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    1062 */ /*RISCV::G_CLZW*//*Label 106*/ GIMT_Encode4(2420670),
     /*    1066 */ /*RISCV::G_CTZW*//*Label 107*/ GIMT_Encode4(2420765),
     /*    1070 */ /*RISCV::G_DIVUW*//*Label 108*/ GIMT_Encode4(2420795),
     /*    1074 */ /*RISCV::G_DIVW*//*Label 109*/ GIMT_Encode4(2420832),
     /*    1078 */ /*RISCV::G_FCLASS*//*Label 110*/ GIMT_Encode4(2420869),
     /*    1082 */ /*RISCV::G_FCVT_WU_RV64*//*Label 111*/ GIMT_Encode4(2421229),
     /*    1086 */ /*RISCV::G_FCVT_W_RV64*//*Label 112*/ GIMT_Encode4(2421427),
     /*    1090 */ /*RISCV::G_READ_VLENB*//*Label 113*/ GIMT_Encode4(2421625),
     /*    1094 */ /*RISCV::G_REMUW*//*Label 114*/ GIMT_Encode4(2421685),
     /*    1098 */ /*RISCV::G_ROLW*//*Label 115*/ GIMT_Encode4(2421722),
     /*    1102 */ /*RISCV::G_RORW*//*Label 116*/ GIMT_Encode4(2421847),
     /*    1106 */ /*RISCV::G_SLLW*//*Label 117*/ GIMT_Encode4(2421968), GIMT_Encode4(0),
     /*    1114 */ /*RISCV::G_SRAW*//*Label 118*/ GIMT_Encode4(2422015),
     /*    1118 */ /*RISCV::G_SRLW*//*Label 119*/ GIMT_Encode4(2422062),
     /*    1122 */ /*RISCV::G_VMCLR_VL*//*Label 120*/ GIMT_Encode4(2422109),
     /*    1126 */ /*RISCV::G_VMSET_VL*//*Label 121*/ GIMT_Encode4(2422758),
     /*    1130 */ /*RISCV::G_VMV_V_V_VL*//*Label 122*/ GIMT_Encode4(2423407),
     /*    1134 */ /*RISCV::G_VSLIDEDOWN_VL*//*Label 123*/ GIMT_Encode4(2427665),
     /*    1138 */ /*RISCV::G_VSLIDEUP_VL*//*Label 124*/ GIMT_Encode4(2439545),
     /*    1142 */ // Label 0: @1142
     /*    1142 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 150*/ GIMT_Encode4(61082),
     /*    1153 */ /*GILLT_s32*//*Label 126*/ GIMT_Encode4(1277),
     /*    1157 */ /*GILLT_s64*//*Label 127*/ GIMT_Encode4(3542), GIMT_Encode4(0),
     /*    1165 */ /*GILLT_nxv1s8*//*Label 128*/ GIMT_Encode4(11442),
     /*    1169 */ /*GILLT_nxv1s16*//*Label 129*/ GIMT_Encode4(11837),
     /*    1173 */ /*GILLT_nxv1s32*//*Label 130*/ GIMT_Encode4(14962),
     /*    1177 */ /*GILLT_nxv1s64*//*Label 131*/ GIMT_Encode4(18087), GIMT_Encode4(0),
     /*    1185 */ /*GILLT_nxv2s8*//*Label 132*/ GIMT_Encode4(21212),
     /*    1189 */ /*GILLT_nxv2s16*//*Label 133*/ GIMT_Encode4(21607),
     /*    1193 */ /*GILLT_nxv2s32*//*Label 134*/ GIMT_Encode4(24732),
     /*    1197 */ /*GILLT_nxv2s64*//*Label 135*/ GIMT_Encode4(27857), GIMT_Encode4(0),
     /*    1205 */ /*GILLT_nxv4s8*//*Label 136*/ GIMT_Encode4(30982),
     /*    1209 */ /*GILLT_nxv4s16*//*Label 137*/ GIMT_Encode4(31377),
     /*    1213 */ /*GILLT_nxv4s32*//*Label 138*/ GIMT_Encode4(34502),
     /*    1217 */ /*GILLT_nxv4s64*//*Label 139*/ GIMT_Encode4(37627), GIMT_Encode4(0),
     /*    1225 */ /*GILLT_nxv8s8*//*Label 140*/ GIMT_Encode4(40752),
     /*    1229 */ /*GILLT_nxv8s16*//*Label 141*/ GIMT_Encode4(41147),
     /*    1233 */ /*GILLT_nxv8s32*//*Label 142*/ GIMT_Encode4(44272),
     /*    1237 */ /*GILLT_nxv8s64*//*Label 143*/ GIMT_Encode4(47397), GIMT_Encode4(0),
     /*    1245 */ /*GILLT_nxv16s8*//*Label 144*/ GIMT_Encode4(50522),
     /*    1249 */ /*GILLT_nxv16s16*//*Label 145*/ GIMT_Encode4(50917),
     /*    1253 */ /*GILLT_nxv16s32*//*Label 146*/ GIMT_Encode4(54042), GIMT_Encode4(0),
     /*    1261 */ /*GILLT_nxv32s8*//*Label 147*/ GIMT_Encode4(57167),
     /*    1265 */ /*GILLT_nxv32s16*//*Label 148*/ GIMT_Encode4(57562), GIMT_Encode4(0),
     /*    1273 */ /*GILLT_nxv64s8*//*Label 149*/ GIMT_Encode4(60687),
     /*    1277 */ // Label 126: @1277
     /*    1277 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(3541),
     /*    1282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*    1285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*    1288 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(1336), // Rule ID 2572 //
     /*    1293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1300 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    1304 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    1308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1312 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1323 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:2:x, GPR:{ *:[i32] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1328 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1334 */     GIR_RootConstrainSelectedInstOperands,
     /*    1335 */     // GIR_Coverage, 2572,
     /*    1335 */     GIR_EraseRootFromParent_Done,
     /*    1336 */   // Label 152: @1336
     /*    1336 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(1384), // Rule ID 2582 //
     /*    1341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1348 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    1352 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    1356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1371 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:4:x, GPR:{ *:[i32] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1376 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1382 */     GIR_RootConstrainSelectedInstOperands,
     /*    1383 */     // GIR_Coverage, 2582,
     /*    1383 */     GIR_EraseRootFromParent_Done,
     /*    1384 */   // Label 153: @1384
     /*    1384 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(1432), // Rule ID 2592 //
     /*    1389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1396 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    1400 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    1404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1419 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:6:x, GPR:{ *:[i32] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1424 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1430 */     GIR_RootConstrainSelectedInstOperands,
     /*    1431 */     // GIR_Coverage, 2592,
     /*    1431 */     GIR_EraseRootFromParent_Done,
     /*    1432 */   // Label 154: @1432
     /*    1432 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(1483), // Rule ID 62538 //
     /*    1437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1444 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    1448 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    1452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1467 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs2:$pred:24:x, GPR:{ *:[i32] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1474 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1481 */     GIR_RootConstrainSelectedInstOperands,
     /*    1482 */     // GIR_Coverage, 62538,
     /*    1482 */     GIR_EraseRootFromParent_Done,
     /*    1483 */   // Label 155: @1483
     /*    1483 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(1534), // Rule ID 62542 //
     /*    1488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1495 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    1499 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    1503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1518 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs2:$pred:25:x, GPR:{ *:[i32] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1525 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1532 */     GIR_RootConstrainSelectedInstOperands,
     /*    1533 */     // GIR_Coverage, 62542,
     /*    1533 */     GIR_EraseRootFromParent_Done,
     /*    1534 */   // Label 156: @1534
     /*    1534 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(1585), // Rule ID 62546 //
     /*    1539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1546 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    1550 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    1554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1569 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs2:$pred:26:x, GPR:{ *:[i32] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    1569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    1583 */     GIR_RootConstrainSelectedInstOperands,
     /*    1584 */     // GIR_Coverage, 62546,
     /*    1584 */     GIR_EraseRootFromParent_Done,
     /*    1585 */   // Label 157: @1585
     /*    1585 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(1633), // Rule ID 65062 //
     /*    1590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1597 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:28:x
     /*    1601 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:28:y
     /*    1605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1620 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:28:x, GPR:{ *:[i32] }:$rs2:$pred:28:y)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    1623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1631 */     GIR_RootConstrainSelectedInstOperands,
     /*    1632 */     // GIR_Coverage, 65062,
     /*    1632 */     GIR_EraseRootFromParent_Done,
     /*    1633 */   // Label 158: @1633
     /*    1633 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(1681), // Rule ID 65072 //
     /*    1638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1645 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:30:x
     /*    1649 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:30:y
     /*    1653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1668 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:30:x, GPR:{ *:[i32] }:$rs2:$pred:30:y)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    1671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1679 */     GIR_RootConstrainSelectedInstOperands,
     /*    1680 */     // GIR_Coverage, 65072,
     /*    1680 */     GIR_EraseRootFromParent_Done,
     /*    1681 */   // Label 159: @1681
     /*    1681 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(1729), // Rule ID 65082 //
     /*    1686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1693 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:32:x
     /*    1697 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:32:y
     /*    1701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1716 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:32:x, GPR:{ *:[i32] }:$rs2:$pred:32:y)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    1719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1727 */     GIR_RootConstrainSelectedInstOperands,
     /*    1728 */     // GIR_Coverage, 65082,
     /*    1728 */     GIR_EraseRootFromParent_Done,
     /*    1729 */   // Label 160: @1729
     /*    1729 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(1777), // Rule ID 65541 //
     /*    1734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1741 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    1745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1749 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    1753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1764 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:2:y, sh1add_op:{ *:[i32] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1769 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1775 */     GIR_RootConstrainSelectedInstOperands,
     /*    1776 */     // GIR_Coverage, 65541,
     /*    1776 */     GIR_EraseRootFromParent_Done,
     /*    1777 */   // Label 161: @1777
     /*    1777 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(1825), // Rule ID 65549 //
     /*    1782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1789 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    1793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1797 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    1801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1812 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:4:y, sh2add_op:{ *:[i32] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1823 */     GIR_RootConstrainSelectedInstOperands,
     /*    1824 */     // GIR_Coverage, 65549,
     /*    1824 */     GIR_EraseRootFromParent_Done,
     /*    1825 */   // Label 162: @1825
     /*    1825 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(1873), // Rule ID 65557 //
     /*    1830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1837 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    1841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1845 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    1849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1860 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:6:y, sh3add_op:{ *:[i32] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1871 */     GIR_RootConstrainSelectedInstOperands,
     /*    1872 */     // GIR_Coverage, 65557,
     /*    1872 */     GIR_EraseRootFromParent_Done,
     /*    1873 */   // Label 163: @1873
     /*    1873 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(1924), // Rule ID 74375 //
     /*    1878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1885 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    1889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1893 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    1897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1908 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:24:y, sh1add_op:{ *:[i32] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1922 */     GIR_RootConstrainSelectedInstOperands,
     /*    1923 */     // GIR_Coverage, 74375,
     /*    1923 */     GIR_EraseRootFromParent_Done,
     /*    1924 */   // Label 164: @1924
     /*    1924 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(1975), // Rule ID 74379 //
     /*    1929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1936 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    1940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1944 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    1948 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1959 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:25:y, sh2add_op:{ *:[i32] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1973 */     GIR_RootConstrainSelectedInstOperands,
     /*    1974 */     // GIR_Coverage, 74379,
     /*    1974 */     GIR_EraseRootFromParent_Done,
     /*    1975 */   // Label 165: @1975
     /*    1975 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2026), // Rule ID 74383 //
     /*    1980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1987 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    1991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1995 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    1999 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    2010 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:26:y, sh3add_op:{ *:[i32] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    2010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    2013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    2017 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    2021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    2024 */     GIR_RootConstrainSelectedInstOperands,
     /*    2025 */     // GIR_Coverage, 74383,
     /*    2025 */     GIR_EraseRootFromParent_Done,
     /*    2026 */   // Label 166: @2026
     /*    2026 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2074), // Rule ID 74396 //
     /*    2031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2038 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:28:y
     /*    2042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2046 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:28:x
     /*    2050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    2061 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:28:y, sh1add_op:{ *:[i32] }:$rs1:$pred:28:x)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2066 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2072 */     GIR_RootConstrainSelectedInstOperands,
     /*    2073 */     // GIR_Coverage, 74396,
     /*    2073 */     GIR_EraseRootFromParent_Done,
     /*    2074 */   // Label 167: @2074
     /*    2074 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2122), // Rule ID 74404 //
     /*    2079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2086 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:30:y
     /*    2090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2094 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:30:x
     /*    2098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    2109 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:30:y, sh2add_op:{ *:[i32] }:$rs1:$pred:30:x)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2120 */     GIR_RootConstrainSelectedInstOperands,
     /*    2121 */     // GIR_Coverage, 74404,
     /*    2121 */     GIR_EraseRootFromParent_Done,
     /*    2122 */   // Label 168: @2122
     /*    2122 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2170), // Rule ID 74412 //
     /*    2127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2134 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:32:y
     /*    2138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2142 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:32:x
     /*    2146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    2157 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:32:y, sh3add_op:{ *:[i32] }:$rs1:$pred:32:x)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2168 */     GIR_RootConstrainSelectedInstOperands,
     /*    2169 */     // GIR_Coverage, 74412,
     /*    2169 */     GIR_EraseRootFromParent_Done,
     /*    2170 */   // Label 169: @2170
     /*    2170 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2238), // Rule ID 2566 //
     /*    2175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2182 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    2186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2211 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    2215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2219 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2225 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x, GPR:{ *:[i32] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2236 */     GIR_RootConstrainSelectedInstOperands,
     /*    2237 */     // GIR_Coverage, 2566,
     /*    2237 */     GIR_EraseRootFromParent_Done,
     /*    2238 */   // Label 170: @2238
     /*    2238 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2306), // Rule ID 2576 //
     /*    2243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2250 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    2254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2275 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2279 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    2283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2287 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2293 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x, GPR:{ *:[i32] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2304 */     GIR_RootConstrainSelectedInstOperands,
     /*    2305 */     // GIR_Coverage, 2576,
     /*    2305 */     GIR_EraseRootFromParent_Done,
     /*    2306 */   // Label 171: @2306
     /*    2306 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2374), // Rule ID 2586 //
     /*    2311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2318 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    2322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2343 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2347 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    2351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2361 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x, GPR:{ *:[i32] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2372 */     GIR_RootConstrainSelectedInstOperands,
     /*    2373 */     // GIR_Coverage, 2586,
     /*    2373 */     GIR_EraseRootFromParent_Done,
     /*    2374 */   // Label 172: @2374
     /*    2374 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2442), // Rule ID 65056 //
     /*    2379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2386 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:27:x
     /*    2390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2411 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2415 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:27:y
     /*    2419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2423 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2429 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:27:x, GPR:{ *:[i32] }:$rs2:$pred:27:y)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2440 */     GIR_RootConstrainSelectedInstOperands,
     /*    2441 */     // GIR_Coverage, 65056,
     /*    2441 */     GIR_EraseRootFromParent_Done,
     /*    2442 */   // Label 173: @2442
     /*    2442 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2510), // Rule ID 65066 //
     /*    2447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2454 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:29:x
     /*    2458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2479 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2483 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:29:y
     /*    2487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2497 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:29:x, GPR:{ *:[i32] }:$rs2:$pred:29:y)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2508 */     GIR_RootConstrainSelectedInstOperands,
     /*    2509 */     // GIR_Coverage, 65066,
     /*    2509 */     GIR_EraseRootFromParent_Done,
     /*    2510 */   // Label 174: @2510
     /*    2510 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2578), // Rule ID 65076 //
     /*    2515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2522 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:31:x
     /*    2526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2547 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2551 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:31:y
     /*    2555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2565 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:31:x, GPR:{ *:[i32] }:$rs2:$pred:31:y)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2576 */     GIR_RootConstrainSelectedInstOperands,
     /*    2577 */     // GIR_Coverage, 65076,
     /*    2577 */     GIR_EraseRootFromParent_Done,
     /*    2578 */   // Label 175: @2578
     /*    2578 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2646), // Rule ID 65537 //
     /*    2583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2590 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*    2594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2598 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*    2602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2623 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2627 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2633 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:1:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2644 */     GIR_RootConstrainSelectedInstOperands,
     /*    2645 */     // GIR_Coverage, 65537,
     /*    2645 */     GIR_EraseRootFromParent_Done,
     /*    2646 */   // Label 176: @2646
     /*    2646 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2714), // Rule ID 65545 //
     /*    2651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2658 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*    2662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2666 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*    2670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2691 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2701 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:3:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2712 */     GIR_RootConstrainSelectedInstOperands,
     /*    2713 */     // GIR_Coverage, 65545,
     /*    2713 */     GIR_EraseRootFromParent_Done,
     /*    2714 */   // Label 177: @2714
     /*    2714 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2782), // Rule ID 65553 //
     /*    2719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2726 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*    2730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2734 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*    2738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2759 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2769 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:5:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2780 */     GIR_RootConstrainSelectedInstOperands,
     /*    2781 */     // GIR_Coverage, 65553,
     /*    2781 */     GIR_EraseRootFromParent_Done,
     /*    2782 */   // Label 178: @2782
     /*    2782 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2850), // Rule ID 74392 //
     /*    2787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2794 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:27:y
     /*    2798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2802 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:27:x
     /*    2806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2827 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2831 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2837 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:27:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:27:x)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2848 */     GIR_RootConstrainSelectedInstOperands,
     /*    2849 */     // GIR_Coverage, 74392,
     /*    2849 */     GIR_EraseRootFromParent_Done,
     /*    2850 */   // Label 179: @2850
     /*    2850 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2918), // Rule ID 74400 //
     /*    2855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2862 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:29:y
     /*    2866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2870 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:29:x
     /*    2874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2895 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2905 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:29:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:29:x)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2916 */     GIR_RootConstrainSelectedInstOperands,
     /*    2917 */     // GIR_Coverage, 74400,
     /*    2917 */     GIR_EraseRootFromParent_Done,
     /*    2918 */   // Label 180: @2918
     /*    2918 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2986), // Rule ID 74408 //
     /*    2923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2930 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:31:y
     /*    2934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2938 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:31:x
     /*    2942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2963 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2967 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2973 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:31:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:31:x)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2984 */     GIR_RootConstrainSelectedInstOperands,
     /*    2985 */     // GIR_Coverage, 74408,
     /*    2985 */     GIR_EraseRootFromParent_Done,
     /*    2986 */   // Label 181: @2986
     /*    2986 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(3065), // Rule ID 62532 //
     /*    2991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    2994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2998 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*    3002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3031 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    3035 */     // MIs[2] Operand 1
     /*    3035 */     // No operand predicates
     /*    3035 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*    3039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3043 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3049 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i32] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    3049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    3052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    3056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    3060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    3063 */     GIR_RootConstrainSelectedInstOperands,
     /*    3064 */     // GIR_Coverage, 62532,
     /*    3064 */     GIR_EraseRootFromParent_Done,
     /*    3065 */   // Label 182: @3065
     /*    3065 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(3144), // Rule ID 74371 //
     /*    3070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    3073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3077 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*    3081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3085 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*    3089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3118 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    3122 */     // MIs[2] Operand 1
     /*    3122 */     // No operand predicates
     /*    3122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3128 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:23:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    3128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    3131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    3139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    3142 */     GIR_RootConstrainSelectedInstOperands,
     /*    3143 */     // GIR_Coverage, 74371,
     /*    3143 */     GIR_EraseRootFromParent_Done,
     /*    3144 */   // Label 183: @3144
     /*    3144 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(3193), // Rule ID 121 //
     /*    3149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*    3164 */     // MIs[1] Operand 1
     /*    3164 */     // No operand predicates
     /*    3164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    3168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3176 */     // MIs[2] Operand 1
     /*    3176 */     // No operand predicates
     /*    3176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3178 */     // (add:{ *:[i32] } (frameindex:{ *:[i32] }):$fi, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i32] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i32] }:$fi), (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)
     /*    3178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3183 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*    3188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*    3191 */     GIR_RootConstrainSelectedInstOperands,
     /*    3192 */     // GIR_Coverage, 121,
     /*    3192 */     GIR_EraseRootFromParent_Done,
     /*    3193 */   // Label 184: @3193
     /*    3193 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3235), // Rule ID 81 //
     /*    3198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3221 */     // MIs[1] Operand 1
     /*    3221 */     // No operand predicates
     /*    3221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3223 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*    3223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3233 */     GIR_RootConstrainSelectedInstOperands,
     /*    3234 */     // GIR_Coverage, 81,
     /*    3234 */     GIR_EraseRootFromParent_Done,
     /*    3235 */   // Label 185: @3235
     /*    3235 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3307), // Rule ID 296 //
     /*    3240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*    3263 */     // MIs[1] Operand 1
     /*    3263 */     // No operand predicates
     /*    3263 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10069),
     /*    3267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3269 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10069>>:$rs2)  =>  (ADDI:{ *:[i32] } (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (AddiPairImmLarge:{ *:[i32] } (imm:{ *:[i32] }):$rs2)), (AddiPairImmSmall:{ *:[i32] } (imm:{ *:[i32] }):$rs2))
     /*    3269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*    3272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    3281 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*    3285 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*    3290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    3292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    3300 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*    3305 */     GIR_RootConstrainSelectedInstOperands,
     /*    3306 */     // GIR_Coverage, 296,
     /*    3306 */     GIR_EraseRootFromParent_Done,
     /*    3307 */   // Label 186: @3307
     /*    3307 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3349), // Rule ID 64530 //
     /*    3312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    3315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*    3335 */     // MIs[1] Operand 1
     /*    3335 */     // No operand predicates
     /*    3335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3337 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ADDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*    3337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDAI),
     /*    3340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3347 */     GIR_RootConstrainSelectedInstOperands,
     /*    3348 */     // GIR_Coverage, 64530,
     /*    3348 */     GIR_EraseRootFromParent_Done,
     /*    3349 */   // Label 187: @3349
     /*    3349 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(3391), // Rule ID 64534 //
     /*    3354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    3357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*    3377 */     // MIs[1] Operand 1
     /*    3377 */     // No operand predicates
     /*    3377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3379 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ADDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*    3379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDI),
     /*    3382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3389 */     GIR_RootConstrainSelectedInstOperands,
     /*    3390 */     // GIR_Coverage, 64534,
     /*    3390 */     GIR_EraseRootFromParent_Done,
     /*    3391 */   // Label 188: @3391
     /*    3391 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(3452), // Rule ID 74385 //
     /*    3396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    3399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3435 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rd)  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    3438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    3442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    3450 */     GIR_RootConstrainSelectedInstOperands,
     /*    3451 */     // GIR_Coverage, 74385,
     /*    3451 */     GIR_EraseRootFromParent_Done,
     /*    3452 */   // Label 189: @3452
     /*    3452 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(3513), // Rule ID 62599 //
     /*    3457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    3460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3496 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    3499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    3503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    3511 */     GIR_RootConstrainSelectedInstOperands,
     /*    3512 */     // GIR_Coverage, 62599,
     /*    3512 */     GIR_EraseRootFromParent_Done,
     /*    3513 */   // Label 190: @3513
     /*    3513 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(3540), // Rule ID 79 //
     /*    3518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3533 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*    3538 */     GIR_RootConstrainSelectedInstOperands,
     /*    3539 */     // GIR_Coverage, 79,
     /*    3539 */     GIR_Done,
     /*    3540 */   // Label 191: @3540
     /*    3540 */   GIM_Reject,
     /*    3541 */ // Label 151: @3541
     /*    3541 */ GIM_Reject,
     /*    3542 */ // Label 127: @3542
     /*    3542 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(11441),
     /*    3547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*    3550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*    3553 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3648), // Rule ID 2612 //
     /*    3558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3565 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*    3569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3606 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    3610 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    3621 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*    3625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3629 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3635 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:10:x, GPR:{ *:[i64] }:$rs2:$pred:10:y)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    3638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3646 */     GIR_RootConstrainSelectedInstOperands,
     /*    3647 */     // GIR_Coverage, 2612,
     /*    3647 */     GIR_EraseRootFromParent_Done,
     /*    3648 */   // Label 193: @3648
     /*    3648 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3743), // Rule ID 2616 //
     /*    3653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3660 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:12:x
     /*    3664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3701 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    3705 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    3716 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:12:y
     /*    3720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3724 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3730 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x, GPR:{ *:[i64] }:$rs2:$pred:12:y)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    3733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3741 */     GIR_RootConstrainSelectedInstOperands,
     /*    3742 */     // GIR_Coverage, 2616,
     /*    3742 */     GIR_EraseRootFromParent_Done,
     /*    3743 */   // Label 194: @3743
     /*    3743 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3838), // Rule ID 65112 //
     /*    3748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    3751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3755 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:40:x
     /*    3759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3796 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    3800 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    3811 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:40:y
     /*    3815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3825 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:40:x, GPR:{ *:[i64] }:$rs2:$pred:40:y)<<P:40:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    3828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3836 */     GIR_RootConstrainSelectedInstOperands,
     /*    3837 */     // GIR_Coverage, 65112,
     /*    3837 */     GIR_EraseRootFromParent_Done,
     /*    3838 */   // Label 195: @3838
     /*    3838 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3933), // Rule ID 65116 //
     /*    3843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    3846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3850 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:42:x
     /*    3854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3891 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    3895 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    3906 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:42:y
     /*    3910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3920 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:42:x, GPR:{ *:[i64] }:$rs2:$pred:42:y)<<P:42:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    3923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3931 */     GIR_RootConstrainSelectedInstOperands,
     /*    3932 */     // GIR_Coverage, 65116,
     /*    3932 */     GIR_EraseRootFromParent_Done,
     /*    3933 */   // Label 196: @3933
     /*    3933 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(4028), // Rule ID 2607 //
     /*    3938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3945 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*    3949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3986 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3997 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    4001 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*    4005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4015 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x, GPR:{ *:[i64] }:$rs2:$pred:8:y)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4026 */     GIR_RootConstrainSelectedInstOperands,
     /*    4027 */     // GIR_Coverage, 2607,
     /*    4027 */     GIR_EraseRootFromParent_Done,
     /*    4028 */   // Label 197: @4028
     /*    4028 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(4123), // Rule ID 2626 //
     /*    4033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4040 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*    4044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4081 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4092 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    4096 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*    4100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4110 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:16:x, GPR:{ *:[i64] }:$rs2:$pred:16:y)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4121 */     GIR_RootConstrainSelectedInstOperands,
     /*    4122 */     // GIR_Coverage, 2626,
     /*    4122 */     GIR_EraseRootFromParent_Done,
     /*    4123 */   // Label 198: @4123
     /*    4123 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(4218), // Rule ID 2631 //
     /*    4128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4135 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:18:x
     /*    4139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4176 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4187 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    4191 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:18:y
     /*    4195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4199 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4205 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:18:x, GPR:{ *:[i64] }:$rs2:$pred:18:y)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    4208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4216 */     GIR_RootConstrainSelectedInstOperands,
     /*    4217 */     // GIR_Coverage, 2631,
     /*    4217 */     GIR_EraseRootFromParent_Done,
     /*    4218 */   // Label 199: @4218
     /*    4218 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(4313), // Rule ID 65097 //
     /*    4223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4230 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:34:x
     /*    4234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4271 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4282 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    4286 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:34:y
     /*    4290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4300 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:34:x, GPR:{ *:[i64] }:$rs2:$pred:34:y)<<P:34:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    4303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4311 */     GIR_RootConstrainSelectedInstOperands,
     /*    4312 */     // GIR_Coverage, 65097,
     /*    4312 */     GIR_EraseRootFromParent_Done,
     /*    4313 */   // Label 200: @4313
     /*    4313 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(4408), // Rule ID 65102 //
     /*    4318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4325 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:36:x
     /*    4329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4366 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4377 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    4381 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:36:y
     /*    4385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4389 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4395 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:36:x, GPR:{ *:[i64] }:$rs2:$pred:36:y)<<P:36:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    4398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4406 */     GIR_RootConstrainSelectedInstOperands,
     /*    4407 */     // GIR_Coverage, 65102,
     /*    4407 */     GIR_EraseRootFromParent_Done,
     /*    4408 */   // Label 201: @4408
     /*    4408 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(4503), // Rule ID 65107 //
     /*    4413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4420 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:38:x
     /*    4424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4461 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4472 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    4476 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:38:y
     /*    4480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4490 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:38:x, GPR:{ *:[i64] }:$rs2:$pred:38:y)<<P:38:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    4493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4501 */     GIR_RootConstrainSelectedInstOperands,
     /*    4502 */     // GIR_Coverage, 65107,
     /*    4502 */     GIR_EraseRootFromParent_Done,
     /*    4503 */   // Label 202: @4503
     /*    4503 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(4598), // Rule ID 65567 //
     /*    4508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4515 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:10:y
     /*    4519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4523 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:10:x
     /*    4527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4564 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    4568 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    4579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4585 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:10:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:10:x)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4596 */     GIR_RootConstrainSelectedInstOperands,
     /*    4597 */     // GIR_Coverage, 65567,
     /*    4597 */     GIR_EraseRootFromParent_Done,
     /*    4598 */   // Label 203: @4598
     /*    4598 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(4693), // Rule ID 65571 //
     /*    4603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4610 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:12:y
     /*    4614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4618 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:12:x
     /*    4622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4659 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    4663 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    4674 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4680 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:12:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4691 */     GIR_RootConstrainSelectedInstOperands,
     /*    4692 */     // GIR_Coverage, 65571,
     /*    4692 */     GIR_EraseRootFromParent_Done,
     /*    4693 */   // Label 204: @4693
     /*    4693 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(4788), // Rule ID 74430 //
     /*    4698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4705 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:40:y
     /*    4709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4713 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:40:x
     /*    4717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4754 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    4758 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    4769 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4775 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:40:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:40:x)<<P:40:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    4778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4786 */     GIR_RootConstrainSelectedInstOperands,
     /*    4787 */     // GIR_Coverage, 74430,
     /*    4787 */     GIR_EraseRootFromParent_Done,
     /*    4788 */   // Label 205: @4788
     /*    4788 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(4883), // Rule ID 74434 //
     /*    4793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4800 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:42:y
     /*    4804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4808 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:42:x
     /*    4812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4849 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    4853 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    4864 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4870 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:42:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:42:x)<<P:42:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    4873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4881 */     GIR_RootConstrainSelectedInstOperands,
     /*    4882 */     // GIR_Coverage, 74434,
     /*    4882 */     GIR_EraseRootFromParent_Done,
     /*    4883 */   // Label 206: @4883
     /*    4883 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(4978), // Rule ID 65563 //
     /*    4888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4895 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:8:y
     /*    4899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4903 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:8:x
     /*    4907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4935 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4944 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4955 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    4959 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4965 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:8:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4976 */     GIR_RootConstrainSelectedInstOperands,
     /*    4977 */     // GIR_Coverage, 65563,
     /*    4977 */     GIR_EraseRootFromParent_Done,
     /*    4978 */   // Label 207: @4978
     /*    4978 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(5073), // Rule ID 65579 //
     /*    4983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4990 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:16:y
     /*    4994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4998 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:16:x
     /*    5002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5039 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5050 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5054 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5060 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:16:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:16:x)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5071 */     GIR_RootConstrainSelectedInstOperands,
     /*    5072 */     // GIR_Coverage, 65579,
     /*    5072 */     GIR_EraseRootFromParent_Done,
     /*    5073 */   // Label 208: @5073
     /*    5073 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(5168), // Rule ID 65583 //
     /*    5078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5085 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:18:y
     /*    5089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5093 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:18:x
     /*    5097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5125 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5134 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5145 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5155 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:18:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:18:x)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    5158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5166 */     GIR_RootConstrainSelectedInstOperands,
     /*    5167 */     // GIR_Coverage, 65583,
     /*    5167 */     GIR_EraseRootFromParent_Done,
     /*    5168 */   // Label 209: @5168
     /*    5168 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(5263), // Rule ID 74418 //
     /*    5173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5180 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:34:y
     /*    5184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5188 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:34:x
     /*    5192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5229 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5240 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    5244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5250 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:34:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:34:x)<<P:34:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    5253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5261 */     GIR_RootConstrainSelectedInstOperands,
     /*    5262 */     // GIR_Coverage, 74418,
     /*    5262 */     GIR_EraseRootFromParent_Done,
     /*    5263 */   // Label 210: @5263
     /*    5263 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(5358), // Rule ID 74422 //
     /*    5268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5275 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:36:y
     /*    5279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5283 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:36:x
     /*    5287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5324 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5335 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5345 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:36:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:36:x)<<P:36:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    5348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5356 */     GIR_RootConstrainSelectedInstOperands,
     /*    5357 */     // GIR_Coverage, 74422,
     /*    5357 */     GIR_EraseRootFromParent_Done,
     /*    5358 */   // Label 211: @5358
     /*    5358 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(5453), // Rule ID 74426 //
     /*    5363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5370 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:38:y
     /*    5374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5378 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:38:x
     /*    5382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5419 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5440 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:38:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:38:x)<<P:38:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    5443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5451 */     GIR_RootConstrainSelectedInstOperands,
     /*    5452 */     // GIR_Coverage, 74426,
     /*    5452 */     GIR_EraseRootFromParent_Done,
     /*    5453 */   // Label 212: @5453
     /*    5453 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5501), // Rule ID 2571 //
     /*    5458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5465 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    5469 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    5473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5477 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5488 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:2:x, GPR:{ *:[i64] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    5491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5499 */     GIR_RootConstrainSelectedInstOperands,
     /*    5500 */     // GIR_Coverage, 2571,
     /*    5500 */     GIR_EraseRootFromParent_Done,
     /*    5501 */   // Label 213: @5501
     /*    5501 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(5549), // Rule ID 2581 //
     /*    5506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5513 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    5517 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    5521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5525 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5536 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:4:x, GPR:{ *:[i64] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    5539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5547 */     GIR_RootConstrainSelectedInstOperands,
     /*    5548 */     // GIR_Coverage, 2581,
     /*    5548 */     GIR_EraseRootFromParent_Done,
     /*    5549 */   // Label 214: @5549
     /*    5549 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(5597), // Rule ID 2591 //
     /*    5554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5561 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    5565 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    5569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5573 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    5584 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:6:x, GPR:{ *:[i64] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    5587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5595 */     GIR_RootConstrainSelectedInstOperands,
     /*    5596 */     // GIR_Coverage, 2591,
     /*    5596 */     GIR_EraseRootFromParent_Done,
     /*    5597 */   // Label 215: @5597
     /*    5597 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(5645), // Rule ID 2610 //
     /*    5602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5609 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*    5613 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*    5617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    5632 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:9:x, GPR:{ *:[i64] }:$rs2:$pred:9:y)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    5635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5637 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5643 */     GIR_RootConstrainSelectedInstOperands,
     /*    5644 */     // GIR_Coverage, 2610,
     /*    5644 */     GIR_EraseRootFromParent_Done,
     /*    5645 */   // Label 216: @5645
     /*    5645 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(5693), // Rule ID 2629 //
     /*    5650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5657 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:17:x
     /*    5661 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:17:y
     /*    5665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    5680 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:17:x, GPR:{ *:[i64] }:$rs2:$pred:17:y)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5685 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5691 */     GIR_RootConstrainSelectedInstOperands,
     /*    5692 */     // GIR_Coverage, 2629,
     /*    5692 */     GIR_EraseRootFromParent_Done,
     /*    5693 */   // Label 217: @5693
     /*    5693 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(5741), // Rule ID 2634 //
     /*    5698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5705 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:19:x
     /*    5709 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:19:y
     /*    5713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    5728 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:19:x, GPR:{ *:[i64] }:$rs2:$pred:19:y)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    5731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5739 */     GIR_RootConstrainSelectedInstOperands,
     /*    5740 */     // GIR_Coverage, 2634,
     /*    5740 */     GIR_EraseRootFromParent_Done,
     /*    5741 */   // Label 218: @5741
     /*    5741 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(5792), // Rule ID 62537 //
     /*    5746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    5749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5753 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    5757 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    5761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5776 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs2:$pred:24:x, GPR:{ *:[i64] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    5776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    5779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    5783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    5787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    5790 */     GIR_RootConstrainSelectedInstOperands,
     /*    5791 */     // GIR_Coverage, 62537,
     /*    5791 */     GIR_EraseRootFromParent_Done,
     /*    5792 */   // Label 219: @5792
     /*    5792 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(5843), // Rule ID 62541 //
     /*    5797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    5800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5804 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    5808 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    5812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5827 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs2:$pred:25:x, GPR:{ *:[i64] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    5827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    5830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    5834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    5838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    5841 */     GIR_RootConstrainSelectedInstOperands,
     /*    5842 */     // GIR_Coverage, 62541,
     /*    5842 */     GIR_EraseRootFromParent_Done,
     /*    5843 */   // Label 220: @5843
     /*    5843 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(5894), // Rule ID 62545 //
     /*    5848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    5851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5855 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    5859 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    5863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    5878 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs2:$pred:26:x, GPR:{ *:[i64] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    5878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    5881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    5885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    5889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    5892 */     GIR_RootConstrainSelectedInstOperands,
     /*    5893 */     // GIR_Coverage, 62545,
     /*    5893 */     GIR_EraseRootFromParent_Done,
     /*    5894 */   // Label 221: @5894
     /*    5894 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(5942), // Rule ID 65061 //
     /*    5899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    5902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5906 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:28:x
     /*    5910 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:28:y
     /*    5914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5918 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5929 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:28:x, GPR:{ *:[i64] }:$rs2:$pred:28:y)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    5932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5934 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5940 */     GIR_RootConstrainSelectedInstOperands,
     /*    5941 */     // GIR_Coverage, 65061,
     /*    5941 */     GIR_EraseRootFromParent_Done,
     /*    5942 */   // Label 222: @5942
     /*    5942 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(5990), // Rule ID 65071 //
     /*    5947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    5950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5954 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:30:x
     /*    5958 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:30:y
     /*    5962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5977 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:30:x, GPR:{ *:[i64] }:$rs2:$pred:30:y)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    5980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5982 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5988 */     GIR_RootConstrainSelectedInstOperands,
     /*    5989 */     // GIR_Coverage, 65071,
     /*    5989 */     GIR_EraseRootFromParent_Done,
     /*    5990 */   // Label 223: @5990
     /*    5990 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6038), // Rule ID 65081 //
     /*    5995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    5998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6002 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:32:x
     /*    6006 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:32:y
     /*    6010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6014 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6025 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:32:x, GPR:{ *:[i64] }:$rs2:$pred:32:y)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    6028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6036 */     GIR_RootConstrainSelectedInstOperands,
     /*    6037 */     // GIR_Coverage, 65081,
     /*    6037 */     GIR_EraseRootFromParent_Done,
     /*    6038 */   // Label 224: @6038
     /*    6038 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6086), // Rule ID 65100 //
     /*    6043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6050 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:35:x
     /*    6054 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:35:y
     /*    6058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6073 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:35:x, GPR:{ *:[i64] }:$rs2:$pred:35:y)<<P:35:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    6076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6084 */     GIR_RootConstrainSelectedInstOperands,
     /*    6085 */     // GIR_Coverage, 65100,
     /*    6085 */     GIR_EraseRootFromParent_Done,
     /*    6086 */   // Label 225: @6086
     /*    6086 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(6134), // Rule ID 65105 //
     /*    6091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6098 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:37:x
     /*    6102 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:37:y
     /*    6106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6121 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:37:x, GPR:{ *:[i64] }:$rs2:$pred:37:y)<<P:37:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    6124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6132 */     GIR_RootConstrainSelectedInstOperands,
     /*    6133 */     // GIR_Coverage, 65105,
     /*    6133 */     GIR_EraseRootFromParent_Done,
     /*    6134 */   // Label 226: @6134
     /*    6134 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6182), // Rule ID 65110 //
     /*    6139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6146 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:39:x
     /*    6150 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:39:y
     /*    6154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6169 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:39:x, GPR:{ *:[i64] }:$rs2:$pred:39:y)<<P:39:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    6172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6180 */     GIR_RootConstrainSelectedInstOperands,
     /*    6181 */     // GIR_Coverage, 65110,
     /*    6181 */     GIR_EraseRootFromParent_Done,
     /*    6182 */   // Label 227: @6182
     /*    6182 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6230), // Rule ID 65540 //
     /*    6187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6194 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    6198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6202 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    6206 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6217 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:2:y, sh1add_op:{ *:[i64] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    6220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6228 */     GIR_RootConstrainSelectedInstOperands,
     /*    6229 */     // GIR_Coverage, 65540,
     /*    6229 */     GIR_EraseRootFromParent_Done,
     /*    6230 */   // Label 228: @6230
     /*    6230 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6278), // Rule ID 65548 //
     /*    6235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6242 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    6246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6250 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    6254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6265 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:4:y, sh2add_op:{ *:[i64] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    6268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6270 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6276 */     GIR_RootConstrainSelectedInstOperands,
     /*    6277 */     // GIR_Coverage, 65548,
     /*    6277 */     GIR_EraseRootFromParent_Done,
     /*    6278 */   // Label 229: @6278
     /*    6278 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(6326), // Rule ID 65556 //
     /*    6283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6290 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    6294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6298 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    6302 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6313 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:6:y, sh3add_op:{ *:[i64] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    6316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6318 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6324 */     GIR_RootConstrainSelectedInstOperands,
     /*    6325 */     // GIR_Coverage, 65556,
     /*    6325 */     GIR_EraseRootFromParent_Done,
     /*    6326 */   // Label 230: @6326
     /*    6326 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(6374), // Rule ID 65565 //
     /*    6331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6338 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:9:y
     /*    6342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6346 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:9:x
     /*    6350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6361 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:9:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:9:x)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    6364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6366 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6372 */     GIR_RootConstrainSelectedInstOperands,
     /*    6373 */     // GIR_Coverage, 65565,
     /*    6373 */     GIR_EraseRootFromParent_Done,
     /*    6374 */   // Label 231: @6374
     /*    6374 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(6422), // Rule ID 65581 //
     /*    6379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6386 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:17:y
     /*    6390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6394 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:17:x
     /*    6398 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6409 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:17:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:17:x)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    6412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6420 */     GIR_RootConstrainSelectedInstOperands,
     /*    6421 */     // GIR_Coverage, 65581,
     /*    6421 */     GIR_EraseRootFromParent_Done,
     /*    6422 */   // Label 232: @6422
     /*    6422 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(6470), // Rule ID 65585 //
     /*    6427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6434 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:19:y
     /*    6438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6442 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:19:x
     /*    6446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6457 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:19:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:19:x)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    6460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6468 */     GIR_RootConstrainSelectedInstOperands,
     /*    6469 */     // GIR_Coverage, 65585,
     /*    6469 */     GIR_EraseRootFromParent_Done,
     /*    6470 */   // Label 233: @6470
     /*    6470 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(6521), // Rule ID 74374 //
     /*    6475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6482 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    6486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6490 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    6494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6505 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:24:y, sh1add_op:{ *:[i64] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    6505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    6519 */     GIR_RootConstrainSelectedInstOperands,
     /*    6520 */     // GIR_Coverage, 74374,
     /*    6520 */     GIR_EraseRootFromParent_Done,
     /*    6521 */   // Label 234: @6521
     /*    6521 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(6572), // Rule ID 74378 //
     /*    6526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6533 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    6537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6541 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    6545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6556 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:25:y, sh2add_op:{ *:[i64] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    6556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    6570 */     GIR_RootConstrainSelectedInstOperands,
     /*    6571 */     // GIR_Coverage, 74378,
     /*    6571 */     GIR_EraseRootFromParent_Done,
     /*    6572 */   // Label 235: @6572
     /*    6572 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(6623), // Rule ID 74382 //
     /*    6577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6584 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    6588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6592 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    6596 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6607 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:26:y, sh3add_op:{ *:[i64] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    6607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6614 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    6621 */     GIR_RootConstrainSelectedInstOperands,
     /*    6622 */     // GIR_Coverage, 74382,
     /*    6622 */     GIR_EraseRootFromParent_Done,
     /*    6623 */   // Label 236: @6623
     /*    6623 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(6671), // Rule ID 74395 //
     /*    6628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6635 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:28:y
     /*    6639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6643 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:28:x
     /*    6647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6658 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:28:y, sh1add_op:{ *:[i64] }:$rs1:$pred:28:x)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    6661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6669 */     GIR_RootConstrainSelectedInstOperands,
     /*    6670 */     // GIR_Coverage, 74395,
     /*    6670 */     GIR_EraseRootFromParent_Done,
     /*    6671 */   // Label 237: @6671
     /*    6671 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(6719), // Rule ID 74403 //
     /*    6676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6683 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:30:y
     /*    6687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6691 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:30:x
     /*    6695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6706 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:30:y, sh2add_op:{ *:[i64] }:$rs1:$pred:30:x)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    6709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6711 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6717 */     GIR_RootConstrainSelectedInstOperands,
     /*    6718 */     // GIR_Coverage, 74403,
     /*    6718 */     GIR_EraseRootFromParent_Done,
     /*    6719 */   // Label 238: @6719
     /*    6719 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(6767), // Rule ID 74411 //
     /*    6724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6731 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:32:y
     /*    6735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6739 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:32:x
     /*    6743 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6754 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:32:y, sh3add_op:{ *:[i64] }:$rs1:$pred:32:x)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    6757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6765 */     GIR_RootConstrainSelectedInstOperands,
     /*    6766 */     // GIR_Coverage, 74411,
     /*    6766 */     GIR_EraseRootFromParent_Done,
     /*    6767 */   // Label 239: @6767
     /*    6767 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(6815), // Rule ID 74420 //
     /*    6772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6779 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:35:y
     /*    6783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6787 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:35:x
     /*    6791 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6802 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:35:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:35:x)<<P:35:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    6805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6807 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6813 */     GIR_RootConstrainSelectedInstOperands,
     /*    6814 */     // GIR_Coverage, 74420,
     /*    6814 */     GIR_EraseRootFromParent_Done,
     /*    6815 */   // Label 240: @6815
     /*    6815 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(6863), // Rule ID 74424 //
     /*    6820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6827 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:37:y
     /*    6831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6835 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:37:x
     /*    6839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6850 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:37:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:37:x)<<P:37:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    6853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6855 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6861 */     GIR_RootConstrainSelectedInstOperands,
     /*    6862 */     // GIR_Coverage, 74424,
     /*    6862 */     GIR_EraseRootFromParent_Done,
     /*    6863 */   // Label 241: @6863
     /*    6863 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(6911), // Rule ID 74428 //
     /*    6868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6875 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:39:y
     /*    6879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6883 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:39:x
     /*    6887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6898 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:39:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:39:x)<<P:39:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    6901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6909 */     GIR_RootConstrainSelectedInstOperands,
     /*    6910 */     // GIR_Coverage, 74428,
     /*    6910 */     GIR_EraseRootFromParent_Done,
     /*    6911 */   // Label 242: @6911
     /*    6911 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(6986), // Rule ID 2602 //
     /*    6916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6923 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*    6927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    6931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6948 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    6959 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*    6963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6967 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6973 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x, GPR:{ *:[i64] }:$rs2:$pred:7:y)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    6976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6984 */     GIR_RootConstrainSelectedInstOperands,
     /*    6985 */     // GIR_Coverage, 2602,
     /*    6985 */     GIR_EraseRootFromParent_Done,
     /*    6986 */   // Label 243: @6986
     /*    6986 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(7081), // Rule ID 2614 //
     /*    6991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6998 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*    7002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7023 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    7034 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*    7038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7048 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:11:x, GPR:{ *:[i64] }:$rs2:$pred:11:y)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7060 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7064 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    7072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7079 */     GIR_RootConstrainSelectedInstOperands,
     /*    7080 */     // GIR_Coverage, 2614,
     /*    7080 */     GIR_EraseRootFromParent_Done,
     /*    7081 */   // Label 244: @7081
     /*    7081 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(7176), // Rule ID 2618 //
     /*    7086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7093 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*    7097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7118 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    7129 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*    7133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7143 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:13:x, GPR:{ *:[i64] }:$rs2:$pred:13:y)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7159 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    7167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7174 */     GIR_RootConstrainSelectedInstOperands,
     /*    7175 */     // GIR_Coverage, 2618,
     /*    7175 */     GIR_EraseRootFromParent_Done,
     /*    7176 */   // Label 245: @7176
     /*    7176 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(7271), // Rule ID 2620 //
     /*    7181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7188 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*    7192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7213 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7224 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*    7228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7238 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:14:x, GPR:{ *:[i64] }:$rs2:$pred:14:y)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7254 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    7262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7269 */     GIR_RootConstrainSelectedInstOperands,
     /*    7270 */     // GIR_Coverage, 2620,
     /*    7270 */     GIR_EraseRootFromParent_Done,
     /*    7271 */   // Label 246: @7271
     /*    7271 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(7366), // Rule ID 2622 //
     /*    7276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7283 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:15:x
     /*    7287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7308 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    7319 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:15:y
     /*    7323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7333 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:15:x, GPR:{ *:[i64] }:$rs2:$pred:15:y)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7349 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    7357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7364 */     GIR_RootConstrainSelectedInstOperands,
     /*    7365 */     // GIR_Coverage, 2622,
     /*    7365 */     GIR_EraseRootFromParent_Done,
     /*    7366 */   // Label 247: @7366
     /*    7366 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(7461), // Rule ID 2636 //
     /*    7371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7378 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:20:x
     /*    7382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7403 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    7414 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:20:y
     /*    7418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7422 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7428 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:20:x, GPR:{ *:[i64] }:$rs2:$pred:20:y)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7444 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    7452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7459 */     GIR_RootConstrainSelectedInstOperands,
     /*    7460 */     // GIR_Coverage, 2636,
     /*    7460 */     GIR_EraseRootFromParent_Done,
     /*    7461 */   // Label 248: @7461
     /*    7461 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(7556), // Rule ID 2638 //
     /*    7466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7473 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:21:x
     /*    7477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7498 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    7509 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:21:y
     /*    7513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7517 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7523 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:21:x, GPR:{ *:[i64] }:$rs2:$pred:21:y)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7535 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7539 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    7547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7554 */     GIR_RootConstrainSelectedInstOperands,
     /*    7555 */     // GIR_Coverage, 2638,
     /*    7555 */     GIR_EraseRootFromParent_Done,
     /*    7556 */   // Label 249: @7556
     /*    7556 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(7651), // Rule ID 2640 //
     /*    7561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7568 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:22:x
     /*    7572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7593 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7604 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:22:y
     /*    7608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7618 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:22:x, GPR:{ *:[i64] }:$rs2:$pred:22:y)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7634 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    7642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7649 */     GIR_RootConstrainSelectedInstOperands,
     /*    7650 */     // GIR_Coverage, 2640,
     /*    7650 */     GIR_EraseRootFromParent_Done,
     /*    7651 */   // Label 250: @7651
     /*    7651 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(7726), // Rule ID 65092 //
     /*    7656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7663 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:33:x
     /*    7667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7688 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    7699 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:33:y
     /*    7703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7713 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:33:x, GPR:{ *:[i64] }:$rs2:$pred:33:y)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*    7716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7724 */     GIR_RootConstrainSelectedInstOperands,
     /*    7725 */     // GIR_Coverage, 65092,
     /*    7725 */     GIR_EraseRootFromParent_Done,
     /*    7726 */   // Label 251: @7726
     /*    7726 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(7821), // Rule ID 65114 //
     /*    7731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7738 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:41:x
     /*    7742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7763 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    7774 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:41:y
     /*    7778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7782 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7788 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:41:x, GPR:{ *:[i64] }:$rs2:$pred:41:y)<<P:41:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7800 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7804 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    7812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7819 */     GIR_RootConstrainSelectedInstOperands,
     /*    7820 */     // GIR_Coverage, 65114,
     /*    7820 */     GIR_EraseRootFromParent_Done,
     /*    7821 */   // Label 252: @7821
     /*    7821 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(7916), // Rule ID 65118 //
     /*    7826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7833 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:43:x
     /*    7837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7858 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    7869 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:43:y
     /*    7873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7877 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7883 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:43:x, GPR:{ *:[i64] }:$rs2:$pred:43:y)<<P:43:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    7907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7914 */     GIR_RootConstrainSelectedInstOperands,
     /*    7915 */     // GIR_Coverage, 65118,
     /*    7915 */     GIR_EraseRootFromParent_Done,
     /*    7916 */   // Label 253: @7916
     /*    7916 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(8011), // Rule ID 65120 //
     /*    7921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7928 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:44:x
     /*    7932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7953 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7964 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:44:y
     /*    7968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7978 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:44:x, GPR:{ *:[i64] }:$rs2:$pred:44:y)<<P:44:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7994 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8009 */     GIR_RootConstrainSelectedInstOperands,
     /*    8010 */     // GIR_Coverage, 65120,
     /*    8010 */     GIR_EraseRootFromParent_Done,
     /*    8011 */   // Label 254: @8011
     /*    8011 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(8106), // Rule ID 65122 //
     /*    8016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8023 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:45:x
     /*    8027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8048 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    8059 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:45:y
     /*    8063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8067 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8073 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:45:x, GPR:{ *:[i64] }:$rs2:$pred:45:y)<<P:45:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8089 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8104 */     GIR_RootConstrainSelectedInstOperands,
     /*    8105 */     // GIR_Coverage, 65122,
     /*    8105 */     GIR_EraseRootFromParent_Done,
     /*    8106 */   // Label 255: @8106
     /*    8106 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(8201), // Rule ID 65124 //
     /*    8111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8118 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:46:x
     /*    8122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8143 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    8154 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:46:y
     /*    8158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8168 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:46:x, GPR:{ *:[i64] }:$rs2:$pred:46:y)<<P:46:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8180 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8184 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    8187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    8192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8199 */     GIR_RootConstrainSelectedInstOperands,
     /*    8200 */     // GIR_Coverage, 65124,
     /*    8200 */     GIR_EraseRootFromParent_Done,
     /*    8201 */   // Label 256: @8201
     /*    8201 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(8296), // Rule ID 65126 //
     /*    8206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8213 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:47:x
     /*    8217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8238 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    8249 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:47:y
     /*    8253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8263 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:47:x, GPR:{ *:[i64] }:$rs2:$pred:47:y)<<P:47:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8275 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8279 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    8282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    8287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8294 */     GIR_RootConstrainSelectedInstOperands,
     /*    8295 */     // GIR_Coverage, 65126,
     /*    8295 */     GIR_EraseRootFromParent_Done,
     /*    8296 */   // Label 257: @8296
     /*    8296 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(8391), // Rule ID 65128 //
     /*    8301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8308 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:48:x
     /*    8312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8333 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    8344 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:48:y
     /*    8348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8352 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8358 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:48:x, GPR:{ *:[i64] }:$rs2:$pred:48:y)<<P:48:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8374 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8389 */     GIR_RootConstrainSelectedInstOperands,
     /*    8390 */     // GIR_Coverage, 65128,
     /*    8390 */     GIR_EraseRootFromParent_Done,
     /*    8391 */   // Label 258: @8391
     /*    8391 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(8459), // Rule ID 2565 //
     /*    8396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8403 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    8407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8428 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    8432 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    8436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8446 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x, GPR:{ *:[i64] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    8449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8457 */     GIR_RootConstrainSelectedInstOperands,
     /*    8458 */     // GIR_Coverage, 2565,
     /*    8458 */     GIR_EraseRootFromParent_Done,
     /*    8459 */   // Label 259: @8459
     /*    8459 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(8527), // Rule ID 2575 //
     /*    8464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8471 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    8475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8496 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    8500 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    8504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8508 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8514 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x, GPR:{ *:[i64] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    8517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8525 */     GIR_RootConstrainSelectedInstOperands,
     /*    8526 */     // GIR_Coverage, 2575,
     /*    8526 */     GIR_EraseRootFromParent_Done,
     /*    8527 */   // Label 260: @8527
     /*    8527 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(8595), // Rule ID 2585 //
     /*    8532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8539 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    8543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8564 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    8568 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    8572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8582 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x, GPR:{ *:[i64] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    8585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8593 */     GIR_RootConstrainSelectedInstOperands,
     /*    8594 */     // GIR_Coverage, 2585,
     /*    8594 */     GIR_EraseRootFromParent_Done,
     /*    8595 */   // Label 261: @8595
     /*    8595 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(8663), // Rule ID 65055 //
     /*    8600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    8603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8607 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:27:x
     /*    8611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8632 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    8636 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:27:y
     /*    8640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8644 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8650 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:27:x, GPR:{ *:[i64] }:$rs2:$pred:27:y)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    8653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8661 */     GIR_RootConstrainSelectedInstOperands,
     /*    8662 */     // GIR_Coverage, 65055,
     /*    8662 */     GIR_EraseRootFromParent_Done,
     /*    8663 */   // Label 262: @8663
     /*    8663 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(8731), // Rule ID 65065 //
     /*    8668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    8671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8675 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:29:x
     /*    8679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8700 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    8704 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:29:y
     /*    8708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8712 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8718 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:29:x, GPR:{ *:[i64] }:$rs2:$pred:29:y)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    8721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8729 */     GIR_RootConstrainSelectedInstOperands,
     /*    8730 */     // GIR_Coverage, 65065,
     /*    8730 */     GIR_EraseRootFromParent_Done,
     /*    8731 */   // Label 263: @8731
     /*    8731 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(8799), // Rule ID 65075 //
     /*    8736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    8739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8743 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:31:x
     /*    8747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8768 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    8772 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:31:y
     /*    8776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8780 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8786 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:31:x, GPR:{ *:[i64] }:$rs2:$pred:31:y)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    8789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8797 */     GIR_RootConstrainSelectedInstOperands,
     /*    8798 */     // GIR_Coverage, 65075,
     /*    8798 */     GIR_EraseRootFromParent_Done,
     /*    8799 */   // Label 264: @8799
     /*    8799 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(8874), // Rule ID 65559 //
     /*    8804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8811 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:7:y
     /*    8815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8819 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:7:x
     /*    8823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8844 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    8855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8861 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:7:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    8864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    8872 */     GIR_RootConstrainSelectedInstOperands,
     /*    8873 */     // GIR_Coverage, 65559,
     /*    8873 */     GIR_EraseRootFromParent_Done,
     /*    8874 */   // Label 265: @8874
     /*    8874 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(8969), // Rule ID 65569 //
     /*    8879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8886 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:11:y
     /*    8890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8894 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:11:x
     /*    8898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8919 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    8930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8936 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:11:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:11:x)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8952 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    8955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    8960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    8967 */     GIR_RootConstrainSelectedInstOperands,
     /*    8968 */     // GIR_Coverage, 65569,
     /*    8968 */     GIR_EraseRootFromParent_Done,
     /*    8969 */   // Label 266: @8969
     /*    8969 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(9064), // Rule ID 65573 //
     /*    8974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8981 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:13:y
     /*    8985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8989 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:13:x
     /*    8993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9014 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    9025 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9031 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:13:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:13:x)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9047 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    9055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9062 */     GIR_RootConstrainSelectedInstOperands,
     /*    9063 */     // GIR_Coverage, 65573,
     /*    9063 */     GIR_EraseRootFromParent_Done,
     /*    9064 */   // Label 267: @9064
     /*    9064 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(9159), // Rule ID 65575 //
     /*    9069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9076 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:14:y
     /*    9080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9084 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:14:x
     /*    9088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9109 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9120 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9126 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:14:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:14:x)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9138 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9142 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    9150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9157 */     GIR_RootConstrainSelectedInstOperands,
     /*    9158 */     // GIR_Coverage, 65575,
     /*    9158 */     GIR_EraseRootFromParent_Done,
     /*    9159 */   // Label 268: @9159
     /*    9159 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(9254), // Rule ID 65577 //
     /*    9164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9171 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:15:y
     /*    9175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9179 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:15:x
     /*    9183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9204 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    9215 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9221 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:15:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:15:x)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    9245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9252 */     GIR_RootConstrainSelectedInstOperands,
     /*    9253 */     // GIR_Coverage, 65577,
     /*    9253 */     GIR_EraseRootFromParent_Done,
     /*    9254 */   // Label 269: @9254
     /*    9254 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(9349), // Rule ID 65587 //
     /*    9259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9266 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:20:y
     /*    9270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9274 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:20:x
     /*    9278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9299 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    9310 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9316 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:20:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:20:x)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9328 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9332 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    9335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    9340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9347 */     GIR_RootConstrainSelectedInstOperands,
     /*    9348 */     // GIR_Coverage, 65587,
     /*    9348 */     GIR_EraseRootFromParent_Done,
     /*    9349 */   // Label 270: @9349
     /*    9349 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(9444), // Rule ID 65589 //
     /*    9354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9361 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:21:y
     /*    9365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9369 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:21:x
     /*    9373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9394 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    9405 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9411 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:21:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:21:x)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9423 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9427 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    9435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9442 */     GIR_RootConstrainSelectedInstOperands,
     /*    9443 */     // GIR_Coverage, 65589,
     /*    9443 */     GIR_EraseRootFromParent_Done,
     /*    9444 */   // Label 271: @9444
     /*    9444 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(9539), // Rule ID 65591 //
     /*    9449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9456 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:22:y
     /*    9460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9464 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:22:x
     /*    9468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9489 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9500 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9506 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:22:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:22:x)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9522 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    9530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9537 */     GIR_RootConstrainSelectedInstOperands,
     /*    9538 */     // GIR_Coverage, 65591,
     /*    9538 */     GIR_EraseRootFromParent_Done,
     /*    9539 */   // Label 272: @9539
     /*    9539 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(9614), // Rule ID 74414 //
     /*    9544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9551 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:33:y
     /*    9555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9559 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:33:x
     /*    9563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9584 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    9595 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9601 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:33:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:33:x)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*    9604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9612 */     GIR_RootConstrainSelectedInstOperands,
     /*    9613 */     // GIR_Coverage, 74414,
     /*    9613 */     GIR_EraseRootFromParent_Done,
     /*    9614 */   // Label 273: @9614
     /*    9614 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(9709), // Rule ID 74432 //
     /*    9619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9626 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:41:y
     /*    9630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9634 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:41:x
     /*    9638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9659 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    9670 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9676 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:41:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:41:x)<<P:41:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9692 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    9695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    9700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9707 */     GIR_RootConstrainSelectedInstOperands,
     /*    9708 */     // GIR_Coverage, 74432,
     /*    9708 */     GIR_EraseRootFromParent_Done,
     /*    9709 */   // Label 274: @9709
     /*    9709 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(9804), // Rule ID 74436 //
     /*    9714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9721 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:43:y
     /*    9725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9729 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:43:x
     /*    9733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9754 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    9765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9771 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:43:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:43:x)<<P:43:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9783 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9787 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    9795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9802 */     GIR_RootConstrainSelectedInstOperands,
     /*    9803 */     // GIR_Coverage, 74436,
     /*    9803 */     GIR_EraseRootFromParent_Done,
     /*    9804 */   // Label 275: @9804
     /*    9804 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(9899), // Rule ID 74438 //
     /*    9809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9816 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:44:y
     /*    9820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9824 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:44:x
     /*    9828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9849 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9860 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9866 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:44:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:44:x)<<P:44:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9882 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    9890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9897 */     GIR_RootConstrainSelectedInstOperands,
     /*    9898 */     // GIR_Coverage, 74438,
     /*    9898 */     GIR_EraseRootFromParent_Done,
     /*    9899 */   // Label 276: @9899
     /*    9899 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(9994), // Rule ID 74440 //
     /*    9904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9911 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:45:y
     /*    9915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9919 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:45:x
     /*    9923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9944 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    9955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9961 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:45:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:45:x)<<P:45:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9977 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    9985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9992 */     GIR_RootConstrainSelectedInstOperands,
     /*    9993 */     // GIR_Coverage, 74440,
     /*    9993 */     GIR_EraseRootFromParent_Done,
     /*    9994 */   // Label 277: @9994
     /*    9994 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(10089), // Rule ID 74442 //
     /*    9999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10006 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:46:y
     /*   10010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10014 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:46:x
     /*   10018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10039 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*   10050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10056 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:46:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:46:x)<<P:46:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10072 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   10075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*   10080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10087 */     GIR_RootConstrainSelectedInstOperands,
     /*   10088 */     // GIR_Coverage, 74442,
     /*   10088 */     GIR_EraseRootFromParent_Done,
     /*   10089 */   // Label 278: @10089
     /*   10089 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(10184), // Rule ID 74444 //
     /*   10094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10101 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:47:y
     /*   10105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10109 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:47:x
     /*   10113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10134 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*   10145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10151 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:47:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:47:x)<<P:47:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10163 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10167 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*   10170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*   10175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10182 */     GIR_RootConstrainSelectedInstOperands,
     /*   10183 */     // GIR_Coverage, 74444,
     /*   10183 */     GIR_EraseRootFromParent_Done,
     /*   10184 */   // Label 279: @10184
     /*   10184 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(10279), // Rule ID 74446 //
     /*   10189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10196 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:48:y
     /*   10200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10204 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:48:x
     /*   10208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10229 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*   10240 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10246 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:48:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:48:x)<<P:48:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10262 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*   10265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*   10270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10277 */     GIR_RootConstrainSelectedInstOperands,
     /*   10278 */     // GIR_Coverage, 74446,
     /*   10278 */     GIR_EraseRootFromParent_Done,
     /*   10279 */   // Label 280: @10279
     /*   10279 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(10347), // Rule ID 65536 //
     /*   10284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10291 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*   10295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10299 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*   10303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10324 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   10328 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10334 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:1:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*   10337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10345 */     GIR_RootConstrainSelectedInstOperands,
     /*   10346 */     // GIR_Coverage, 65536,
     /*   10346 */     GIR_EraseRootFromParent_Done,
     /*   10347 */   // Label 281: @10347
     /*   10347 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(10415), // Rule ID 65544 //
     /*   10352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10359 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*   10363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10367 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*   10371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10392 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*   10396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10402 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:3:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*   10405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10413 */     GIR_RootConstrainSelectedInstOperands,
     /*   10414 */     // GIR_Coverage, 65544,
     /*   10414 */     GIR_EraseRootFromParent_Done,
     /*   10415 */   // Label 282: @10415
     /*   10415 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(10483), // Rule ID 65552 //
     /*   10420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10427 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*   10431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10435 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*   10439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10460 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*   10464 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10470 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:5:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*   10473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10481 */     GIR_RootConstrainSelectedInstOperands,
     /*   10482 */     // GIR_Coverage, 65552,
     /*   10482 */     GIR_EraseRootFromParent_Done,
     /*   10483 */   // Label 283: @10483
     /*   10483 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(10551), // Rule ID 74391 //
     /*   10488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10495 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:27:y
     /*   10499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10503 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:27:x
     /*   10507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10528 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   10532 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10538 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:27:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:27:x)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*   10541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10549 */     GIR_RootConstrainSelectedInstOperands,
     /*   10550 */     // GIR_Coverage, 74391,
     /*   10550 */     GIR_EraseRootFromParent_Done,
     /*   10551 */   // Label 284: @10551
     /*   10551 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(10619), // Rule ID 74399 //
     /*   10556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10563 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:29:y
     /*   10567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10571 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:29:x
     /*   10575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*   10600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10606 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:29:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:29:x)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*   10609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10617 */     GIR_RootConstrainSelectedInstOperands,
     /*   10618 */     // GIR_Coverage, 74399,
     /*   10618 */     GIR_EraseRootFromParent_Done,
     /*   10619 */   // Label 285: @10619
     /*   10619 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(10687), // Rule ID 74407 //
     /*   10624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10631 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:31:y
     /*   10635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10639 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:31:x
     /*   10643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10664 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*   10668 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10674 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:31:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:31:x)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*   10677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10685 */     GIR_RootConstrainSelectedInstOperands,
     /*   10686 */     // GIR_Coverage, 74407,
     /*   10686 */     GIR_EraseRootFromParent_Done,
     /*   10687 */   // Label 286: @10687
     /*   10687 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(10766), // Rule ID 62531 //
     /*   10692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*   10695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10699 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*   10703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   10728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10732 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*   10736 */     // MIs[2] Operand 1
     /*   10736 */     // No operand predicates
     /*   10736 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*   10740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10744 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   10750 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i64] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*   10750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*   10753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   10757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   10761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*   10764 */     GIR_RootConstrainSelectedInstOperands,
     /*   10765 */     // GIR_Coverage, 62531,
     /*   10765 */     GIR_EraseRootFromParent_Done,
     /*   10766 */   // Label 287: @10766
     /*   10766 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(10845), // Rule ID 74370 //
     /*   10771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*   10774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10778 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*   10782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10786 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*   10790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   10815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10819 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*   10823 */     // MIs[2] Operand 1
     /*   10823 */     // No operand predicates
     /*   10823 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   10829 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:23:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*   10829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*   10832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   10840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*   10843 */     GIR_RootConstrainSelectedInstOperands,
     /*   10844 */     // GIR_Coverage, 74370,
     /*   10844 */     GIR_EraseRootFromParent_Done,
     /*   10845 */   // Label 288: @10845
     /*   10845 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(10894), // Rule ID 120 //
     /*   10850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   10853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*   10865 */     // MIs[1] Operand 1
     /*   10865 */     // No operand predicates
     /*   10865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   10869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10873 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   10877 */     // MIs[2] Operand 1
     /*   10877 */     // No operand predicates
     /*   10877 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   10879 */     // (add:{ *:[i64] } (frameindex:{ *:[i64] }):$fi, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i64] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i64] }:$fi), (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)
     /*   10879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   10882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10884 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*   10889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*   10892 */     GIR_RootConstrainSelectedInstOperands,
     /*   10893 */     // GIR_Coverage, 120,
     /*   10893 */     GIR_EraseRootFromParent_Done,
     /*   10894 */   // Label 289: @10894
     /*   10894 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(10940), // Rule ID 275 //
     /*   10899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   10902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   10922 */     // MIs[1] Operand 1
     /*   10922 */     // No operand predicates
     /*   10922 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10041),
     /*   10926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10928 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)<<P:Predicate_anonymous_10041>>  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   10928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   10931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   10938 */     GIR_RootConstrainSelectedInstOperands,
     /*   10939 */     // GIR_Coverage, 275,
     /*   10939 */     GIR_EraseRootFromParent_Done,
     /*   10940 */   // Label 290: @10940
     /*   10940 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(11016), // Rule ID 297 //
     /*   10945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   10948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*   10968 */     // MIs[1] Operand 1
     /*   10968 */     // No operand predicates
     /*   10968 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10069),
     /*   10972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10041),
     /*   10976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10978 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10069>>:$rs2)<<P:Predicate_anonymous_10041>>  =>  (ADDIW:{ *:[i64] } (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*   10978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   10985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   10994 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*   10999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   11004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11009 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*   11014 */     GIR_RootConstrainSelectedInstOperands,
     /*   11015 */     // GIR_Coverage, 297,
     /*   11015 */     GIR_EraseRootFromParent_Done,
     /*   11016 */   // Label 291: @11016
     /*   11016 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(11081), // Rule ID 74386 //
     /*   11021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   11024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11058 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10041),
     /*   11062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11064 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)<<P:Predicate_anonymous_10041>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*   11067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11079 */     GIR_RootConstrainSelectedInstOperands,
     /*   11080 */     // GIR_Coverage, 74386,
     /*   11080 */     GIR_EraseRootFromParent_Done,
     /*   11081 */   // Label 292: @11081
     /*   11081 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(11146), // Rule ID 62602 //
     /*   11086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   11089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10041),
     /*   11127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11129 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10041>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*   11132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11144 */     GIR_RootConstrainSelectedInstOperands,
     /*   11145 */     // GIR_Coverage, 62602,
     /*   11145 */     GIR_EraseRootFromParent_Done,
     /*   11146 */   // Label 293: @11146
     /*   11146 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(11188), // Rule ID 80 //
     /*   11151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   11174 */     // MIs[1] Operand 1
     /*   11174 */     // No operand predicates
     /*   11174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11176 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   11176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   11186 */     GIR_RootConstrainSelectedInstOperands,
     /*   11187 */     // GIR_Coverage, 80,
     /*   11187 */     GIR_EraseRootFromParent_Done,
     /*   11188 */   // Label 294: @11188
     /*   11188 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(11260), // Rule ID 295 //
     /*   11193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*   11216 */     // MIs[1] Operand 1
     /*   11216 */     // No operand predicates
     /*   11216 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10069),
     /*   11220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11222 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10069>>:$rs2)  =>  (ADDI:{ *:[i64] } (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*   11222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   11225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   11238 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*   11243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11253 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*   11258 */     GIR_RootConstrainSelectedInstOperands,
     /*   11259 */     // GIR_Coverage, 295,
     /*   11259 */     GIR_EraseRootFromParent_Done,
     /*   11260 */   // Label 295: @11260
     /*   11260 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(11321), // Rule ID 74384 //
     /*   11265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   11268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11304 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*   11307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11319 */     GIR_RootConstrainSelectedInstOperands,
     /*   11320 */     // GIR_Coverage, 74384,
     /*   11320 */     GIR_EraseRootFromParent_Done,
     /*   11321 */   // Label 296: @11321
     /*   11321 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(11382), // Rule ID 62598 //
     /*   11326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   11329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11365 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*   11368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11380 */     GIR_RootConstrainSelectedInstOperands,
     /*   11381 */     // GIR_Coverage, 62598,
     /*   11381 */     GIR_EraseRootFromParent_Done,
     /*   11382 */   // Label 297: @11382
     /*   11382 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(11413), // Rule ID 274 //
     /*   11387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   11390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11402 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10041),
     /*   11406 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10041>>  =>  (ADDW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADDW),
     /*   11411 */     GIR_RootConstrainSelectedInstOperands,
     /*   11412 */     // GIR_Coverage, 274,
     /*   11412 */     GIR_Done,
     /*   11413 */   // Label 298: @11413
     /*   11413 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(11440), // Rule ID 78 //
     /*   11418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11433 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*   11438 */     GIR_RootConstrainSelectedInstOperands,
     /*   11439 */     // GIR_Coverage, 78,
     /*   11439 */     GIR_Done,
     /*   11440 */   // Label 299: @11440
     /*   11440 */   GIM_Reject,
     /*   11441 */ // Label 192: @11441
     /*   11441 */ GIM_Reject,
     /*   11442 */ // Label 128: @11442
     /*   11442 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(11836),
     /*   11447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11457 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(11525), // Rule ID 69334 //
     /*   11462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11481 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11499 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11523 */     GIR_RootConstrainSelectedInstOperands,
     /*   11524 */     // GIR_Coverage, 69334,
     /*   11524 */     GIR_EraseRootFromParent_Done,
     /*   11525 */   // Label 301: @11525
     /*   11525 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(11593), // Rule ID 69335 //
     /*   11530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11549 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11567 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   11567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11591 */     GIR_RootConstrainSelectedInstOperands,
     /*   11592 */     // GIR_Coverage, 69335,
     /*   11592 */     GIR_EraseRootFromParent_Done,
     /*   11593 */   // Label 302: @11593
     /*   11593 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(11661), // Rule ID 45922 //
     /*   11598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11621 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11635 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11659 */     GIR_RootConstrainSelectedInstOperands,
     /*   11660 */     // GIR_Coverage, 45922,
     /*   11660 */     GIR_EraseRootFromParent_Done,
     /*   11661 */   // Label 303: @11661
     /*   11661 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(11729), // Rule ID 45923 //
     /*   11666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11703 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   11703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11727 */     GIR_RootConstrainSelectedInstOperands,
     /*   11728 */     // GIR_Coverage, 45923,
     /*   11728 */     GIR_EraseRootFromParent_Done,
     /*   11729 */   // Label 304: @11729
     /*   11729 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(11782), // Rule ID 45750 //
     /*   11734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11745 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   11745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   11748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*   11762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11780 */     GIR_RootConstrainSelectedInstOperands,
     /*   11781 */     // GIR_Coverage, 45750,
     /*   11781 */     GIR_EraseRootFromParent_Done,
     /*   11782 */   // Label 305: @11782
     /*   11782 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(11835), // Rule ID 45751 //
     /*   11787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11798 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   11798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   11801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*   11815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11833 */     GIR_RootConstrainSelectedInstOperands,
     /*   11834 */     // GIR_Coverage, 45751,
     /*   11834 */     GIR_EraseRootFromParent_Done,
     /*   11835 */   // Label 306: @11835
     /*   11835 */   GIM_Reject,
     /*   11836 */ // Label 300: @11836
     /*   11836 */ GIM_Reject,
     /*   11837 */ // Label 129: @11837
     /*   11837 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14961),
     /*   11842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   11848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11852 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(11948), // Rule ID 69248 //
     /*   11857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   11876 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11890 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11905 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11909 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11911 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11922 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   11925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   11933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   11937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11946 */     GIR_RootConstrainSelectedInstOperands,
     /*   11947 */     // GIR_Coverage, 69248,
     /*   11947 */     GIR_EraseRootFromParent_Done,
     /*   11948 */   // Label 308: @11948
     /*   11948 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(12044), // Rule ID 69249 //
     /*   11953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   11972 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11986 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11988 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12001 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12005 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12007 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12016 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12018 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12042 */     GIR_RootConstrainSelectedInstOperands,
     /*   12043 */     // GIR_Coverage, 69249,
     /*   12043 */     GIR_EraseRootFromParent_Done,
     /*   12044 */   // Label 309: @12044
     /*   12044 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(12140), // Rule ID 71074 //
     /*   12049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12068 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12082 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12097 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12101 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12103 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12114 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12138 */     GIR_RootConstrainSelectedInstOperands,
     /*   12139 */     // GIR_Coverage, 71074,
     /*   12139 */     GIR_EraseRootFromParent_Done,
     /*   12140 */   // Label 310: @12140
     /*   12140 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(12236), // Rule ID 71075 //
     /*   12145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12164 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12178 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12193 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12197 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12199 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12210 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12234 */     GIR_RootConstrainSelectedInstOperands,
     /*   12235 */     // GIR_Coverage, 71075,
     /*   12235 */     GIR_EraseRootFromParent_Done,
     /*   12236 */   // Label 311: @12236
     /*   12236 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(12332), // Rule ID 71076 //
     /*   12241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12260 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12274 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12289 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12293 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12295 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12306 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12330 */     GIR_RootConstrainSelectedInstOperands,
     /*   12331 */     // GIR_Coverage, 71076,
     /*   12331 */     GIR_EraseRootFromParent_Done,
     /*   12332 */   // Label 312: @12332
     /*   12332 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(12428), // Rule ID 71077 //
     /*   12337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12356 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12370 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12385 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12389 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12391 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12402 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12426 */     GIR_RootConstrainSelectedInstOperands,
     /*   12427 */     // GIR_Coverage, 71077,
     /*   12427 */     GIR_EraseRootFromParent_Done,
     /*   12428 */   // Label 313: @12428
     /*   12428 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(12524), // Rule ID 70952 //
     /*   12433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12452 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12466 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12481 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12485 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12487 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12498 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   12501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12522 */     GIR_RootConstrainSelectedInstOperands,
     /*   12523 */     // GIR_Coverage, 70952,
     /*   12523 */     GIR_EraseRootFromParent_Done,
     /*   12524 */   // Label 314: @12524
     /*   12524 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(12620), // Rule ID 70953 //
     /*   12529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12548 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12562 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12577 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12581 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12583 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12594 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   12597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12618 */     GIR_RootConstrainSelectedInstOperands,
     /*   12619 */     // GIR_Coverage, 70953,
     /*   12619 */     GIR_EraseRootFromParent_Done,
     /*   12620 */   // Label 315: @12620
     /*   12620 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(12716), // Rule ID 45834 //
     /*   12625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12648 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12662 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12677 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12681 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12683 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12690 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12714 */     GIR_RootConstrainSelectedInstOperands,
     /*   12715 */     // GIR_Coverage, 45834,
     /*   12715 */     GIR_EraseRootFromParent_Done,
     /*   12716 */   // Label 316: @12716
     /*   12716 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(12812), // Rule ID 45835 //
     /*   12721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12744 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12758 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12777 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12779 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12786 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12810 */     GIR_RootConstrainSelectedInstOperands,
     /*   12811 */     // GIR_Coverage, 45835,
     /*   12811 */     GIR_EraseRootFromParent_Done,
     /*   12812 */   // Label 317: @12812
     /*   12812 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(12908), // Rule ID 52154 //
     /*   12817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12840 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12854 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12856 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12869 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12873 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12875 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12882 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12906 */     GIR_RootConstrainSelectedInstOperands,
     /*   12907 */     // GIR_Coverage, 52154,
     /*   12907 */     GIR_EraseRootFromParent_Done,
     /*   12908 */   // Label 318: @12908
     /*   12908 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(13004), // Rule ID 52155 //
     /*   12913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12936 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12950 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12965 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12969 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12971 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12978 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13002 */     GIR_RootConstrainSelectedInstOperands,
     /*   13003 */     // GIR_Coverage, 52155,
     /*   13003 */     GIR_EraseRootFromParent_Done,
     /*   13004 */   // Label 319: @13004
     /*   13004 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(13100), // Rule ID 71072 //
     /*   13009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13032 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13046 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13065 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13067 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13074 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   13085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   13089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13098 */     GIR_RootConstrainSelectedInstOperands,
     /*   13099 */     // GIR_Coverage, 71072,
     /*   13099 */     GIR_EraseRootFromParent_Done,
     /*   13100 */   // Label 320: @13100
     /*   13100 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(13196), // Rule ID 71073 //
     /*   13105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13128 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13142 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13157 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13161 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13163 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13170 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   13181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   13185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13194 */     GIR_RootConstrainSelectedInstOperands,
     /*   13195 */     // GIR_Coverage, 71073,
     /*   13195 */     GIR_EraseRootFromParent_Done,
     /*   13196 */   // Label 321: @13196
     /*   13196 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(13292), // Rule ID 52094 //
     /*   13201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13224 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13238 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13253 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13257 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13259 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13266 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13290 */     GIR_RootConstrainSelectedInstOperands,
     /*   13291 */     // GIR_Coverage, 52094,
     /*   13291 */     GIR_EraseRootFromParent_Done,
     /*   13292 */   // Label 322: @13292
     /*   13292 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(13388), // Rule ID 52095 //
     /*   13297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13320 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13334 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13349 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13353 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13355 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13362 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13386 */     GIR_RootConstrainSelectedInstOperands,
     /*   13387 */     // GIR_Coverage, 52095,
     /*   13387 */     GIR_EraseRootFromParent_Done,
     /*   13388 */   // Label 323: @13388
     /*   13388 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(13477), // Rule ID 46680 //
     /*   13393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13408 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13427 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13436 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13475 */     GIR_RootConstrainSelectedInstOperands,
     /*   13476 */     // GIR_Coverage, 46680,
     /*   13476 */     GIR_EraseRootFromParent_Done,
     /*   13477 */   // Label 324: @13477
     /*   13477 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(13566), // Rule ID 46681 //
     /*   13482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13497 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13516 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13525 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13564 */     GIR_RootConstrainSelectedInstOperands,
     /*   13565 */     // GIR_Coverage, 46681,
     /*   13565 */     GIR_EraseRootFromParent_Done,
     /*   13566 */   // Label 325: @13566
     /*   13566 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(13655), // Rule ID 45826 //
     /*   13571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13586 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13605 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13614 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*   13631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13653 */     GIR_RootConstrainSelectedInstOperands,
     /*   13654 */     // GIR_Coverage, 45826,
     /*   13654 */     GIR_EraseRootFromParent_Done,
     /*   13655 */   // Label 326: @13655
     /*   13655 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(13744), // Rule ID 45827 //
     /*   13660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13675 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13694 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13703 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*   13720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13742 */     GIR_RootConstrainSelectedInstOperands,
     /*   13743 */     // GIR_Coverage, 45827,
     /*   13743 */     GIR_EraseRootFromParent_Done,
     /*   13744 */   // Label 327: @13744
     /*   13744 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(13833), // Rule ID 46560 //
     /*   13749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13764 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13783 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13792 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13831 */     GIR_RootConstrainSelectedInstOperands,
     /*   13832 */     // GIR_Coverage, 46560,
     /*   13832 */     GIR_EraseRootFromParent_Done,
     /*   13833 */   // Label 328: @13833
     /*   13833 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(13922), // Rule ID 46561 //
     /*   13838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13853 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13872 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13881 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13920 */     GIR_RootConstrainSelectedInstOperands,
     /*   13921 */     // GIR_Coverage, 46561,
     /*   13921 */     GIR_EraseRootFromParent_Done,
     /*   13922 */   // Label 329: @13922
     /*   13922 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(13990), // Rule ID 70644 //
     /*   13927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13964 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   13964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   13967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   13973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13988 */     GIR_RootConstrainSelectedInstOperands,
     /*   13989 */     // GIR_Coverage, 70644,
     /*   13989 */     GIR_EraseRootFromParent_Done,
     /*   13990 */   // Label 330: @13990
     /*   13990 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(14058), // Rule ID 70645 //
     /*   13995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14014 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14032 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   14032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14056 */     GIR_RootConstrainSelectedInstOperands,
     /*   14057 */     // GIR_Coverage, 70645,
     /*   14057 */     GIR_EraseRootFromParent_Done,
     /*   14058 */   // Label 331: @14058
     /*   14058 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(14113), // Rule ID 69636 //
     /*   14063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14078 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14091 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14111 */     GIR_RootConstrainSelectedInstOperands,
     /*   14112 */     // GIR_Coverage, 69636,
     /*   14112 */     GIR_EraseRootFromParent_Done,
     /*   14113 */   // Label 332: @14113
     /*   14113 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(14168), // Rule ID 69637 //
     /*   14118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14133 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14146 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14166 */     GIR_RootConstrainSelectedInstOperands,
     /*   14167 */     // GIR_Coverage, 69637,
     /*   14167 */     GIR_EraseRootFromParent_Done,
     /*   14168 */   // Label 333: @14168
     /*   14168 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(14223), // Rule ID 69244 //
     /*   14173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14188 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14201 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14221 */     GIR_RootConstrainSelectedInstOperands,
     /*   14222 */     // GIR_Coverage, 69244,
     /*   14222 */     GIR_EraseRootFromParent_Done,
     /*   14223 */   // Label 334: @14223
     /*   14223 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(14278), // Rule ID 69245 //
     /*   14228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14243 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14256 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14276 */     GIR_RootConstrainSelectedInstOperands,
     /*   14277 */     // GIR_Coverage, 69245,
     /*   14277 */     GIR_EraseRootFromParent_Done,
     /*   14278 */   // Label 335: @14278
     /*   14278 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(14333), // Rule ID 69546 //
     /*   14283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14298 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14311 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14331 */     GIR_RootConstrainSelectedInstOperands,
     /*   14332 */     // GIR_Coverage, 69546,
     /*   14332 */     GIR_EraseRootFromParent_Done,
     /*   14333 */   // Label 336: @14333
     /*   14333 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(14388), // Rule ID 69547 //
     /*   14338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14353 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14366 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14386 */     GIR_RootConstrainSelectedInstOperands,
     /*   14387 */     // GIR_Coverage, 69547,
     /*   14387 */     GIR_EraseRootFromParent_Done,
     /*   14388 */   // Label 337: @14388
     /*   14388 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(14456), // Rule ID 51874 //
     /*   14393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14416 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14430 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   14430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14454 */     GIR_RootConstrainSelectedInstOperands,
     /*   14455 */     // GIR_Coverage, 51874,
     /*   14455 */     GIR_EraseRootFromParent_Done,
     /*   14456 */   // Label 338: @14456
     /*   14456 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(14524), // Rule ID 51875 //
     /*   14461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14484 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14498 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   14498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14522 */     GIR_RootConstrainSelectedInstOperands,
     /*   14523 */     // GIR_Coverage, 51875,
     /*   14523 */     GIR_EraseRootFromParent_Done,
     /*   14524 */   // Label 339: @14524
     /*   14524 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(14579), // Rule ID 46740 //
     /*   14529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14548 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14557 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14577 */     GIR_RootConstrainSelectedInstOperands,
     /*   14578 */     // GIR_Coverage, 46740,
     /*   14578 */     GIR_EraseRootFromParent_Done,
     /*   14579 */   // Label 340: @14579
     /*   14579 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(14634), // Rule ID 46741 //
     /*   14584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14603 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14612 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14632 */     GIR_RootConstrainSelectedInstOperands,
     /*   14633 */     // GIR_Coverage, 46741,
     /*   14633 */     GIR_EraseRootFromParent_Done,
     /*   14634 */   // Label 341: @14634
     /*   14634 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(14689), // Rule ID 45830 //
     /*   14639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14658 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14667 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14687 */     GIR_RootConstrainSelectedInstOperands,
     /*   14688 */     // GIR_Coverage, 45830,
     /*   14688 */     GIR_EraseRootFromParent_Done,
     /*   14689 */   // Label 342: @14689
     /*   14689 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(14744), // Rule ID 45831 //
     /*   14694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14713 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14722 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14742 */     GIR_RootConstrainSelectedInstOperands,
     /*   14743 */     // GIR_Coverage, 45831,
     /*   14743 */     GIR_EraseRootFromParent_Done,
     /*   14744 */   // Label 343: @14744
     /*   14744 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(14799), // Rule ID 46620 //
     /*   14749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14768 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14777 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14797 */     GIR_RootConstrainSelectedInstOperands,
     /*   14798 */     // GIR_Coverage, 46620,
     /*   14798 */     GIR_EraseRootFromParent_Done,
     /*   14799 */   // Label 344: @14799
     /*   14799 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(14854), // Rule ID 46621 //
     /*   14804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14823 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14832 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14852 */     GIR_RootConstrainSelectedInstOperands,
     /*   14853 */     // GIR_Coverage, 46621,
     /*   14853 */     GIR_EraseRootFromParent_Done,
     /*   14854 */   // Label 345: @14854
     /*   14854 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(14907), // Rule ID 46106 //
     /*   14859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14870 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   14870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   14887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14905 */     GIR_RootConstrainSelectedInstOperands,
     /*   14906 */     // GIR_Coverage, 46106,
     /*   14906 */     GIR_EraseRootFromParent_Done,
     /*   14907 */   // Label 346: @14907
     /*   14907 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(14960), // Rule ID 46107 //
     /*   14912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14923 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   14923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   14940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14958 */     GIR_RootConstrainSelectedInstOperands,
     /*   14959 */     // GIR_Coverage, 46107,
     /*   14959 */     GIR_EraseRootFromParent_Done,
     /*   14960 */   // Label 347: @14960
     /*   14960 */   GIM_Reject,
     /*   14961 */ // Label 307: @14961
     /*   14961 */ GIM_Reject,
     /*   14962 */ // Label 130: @14962
     /*   14962 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(18086),
     /*   14967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   14973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14977 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15073), // Rule ID 70850 //
     /*   14982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15001 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15015 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15030 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15034 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15036 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15047 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15071 */     GIR_RootConstrainSelectedInstOperands,
     /*   15072 */     // GIR_Coverage, 70850,
     /*   15072 */     GIR_EraseRootFromParent_Done,
     /*   15073 */   // Label 349: @15073
     /*   15073 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15169), // Rule ID 70851 //
     /*   15078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15097 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15111 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15126 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15130 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15132 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15143 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15167 */     GIR_RootConstrainSelectedInstOperands,
     /*   15168 */     // GIR_Coverage, 70851,
     /*   15168 */     GIR_EraseRootFromParent_Done,
     /*   15169 */   // Label 350: @15169
     /*   15169 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15265), // Rule ID 71110 //
     /*   15174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15193 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15207 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15222 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15226 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15228 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15239 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15263 */     GIR_RootConstrainSelectedInstOperands,
     /*   15264 */     // GIR_Coverage, 71110,
     /*   15264 */     GIR_EraseRootFromParent_Done,
     /*   15265 */   // Label 351: @15265
     /*   15265 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15361), // Rule ID 71111 //
     /*   15270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15289 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15303 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15318 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15322 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15324 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15335 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15359 */     GIR_RootConstrainSelectedInstOperands,
     /*   15360 */     // GIR_Coverage, 71111,
     /*   15360 */     GIR_EraseRootFromParent_Done,
     /*   15361 */   // Label 352: @15361
     /*   15361 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15457), // Rule ID 71112 //
     /*   15366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15385 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15399 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15414 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15418 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15420 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15431 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   15442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   15446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15455 */     GIR_RootConstrainSelectedInstOperands,
     /*   15456 */     // GIR_Coverage, 71112,
     /*   15456 */     GIR_EraseRootFromParent_Done,
     /*   15457 */   // Label 353: @15457
     /*   15457 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15553), // Rule ID 71113 //
     /*   15462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15481 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15495 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15510 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15514 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15516 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15527 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   15538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   15542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15551 */     GIR_RootConstrainSelectedInstOperands,
     /*   15552 */     // GIR_Coverage, 71113,
     /*   15552 */     GIR_EraseRootFromParent_Done,
     /*   15553 */   // Label 354: @15553
     /*   15553 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15649), // Rule ID 70964 //
     /*   15558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15577 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15591 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15606 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15610 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15612 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15623 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   15626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15647 */     GIR_RootConstrainSelectedInstOperands,
     /*   15648 */     // GIR_Coverage, 70964,
     /*   15648 */     GIR_EraseRootFromParent_Done,
     /*   15649 */   // Label 355: @15649
     /*   15649 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(15745), // Rule ID 70965 //
     /*   15654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15673 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15687 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15702 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15706 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15708 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15719 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   15722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15743 */     GIR_RootConstrainSelectedInstOperands,
     /*   15744 */     // GIR_Coverage, 70965,
     /*   15744 */     GIR_EraseRootFromParent_Done,
     /*   15745 */   // Label 356: @15745
     /*   15745 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(15841), // Rule ID 52048 //
     /*   15750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15773 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15787 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15806 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15808 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15815 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15839 */     GIR_RootConstrainSelectedInstOperands,
     /*   15840 */     // GIR_Coverage, 52048,
     /*   15840 */     GIR_EraseRootFromParent_Done,
     /*   15841 */   // Label 357: @15841
     /*   15841 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(15937), // Rule ID 52049 //
     /*   15846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15869 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15883 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15885 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15898 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15902 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15904 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15911 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15935 */     GIR_RootConstrainSelectedInstOperands,
     /*   15936 */     // GIR_Coverage, 52049,
     /*   15936 */     GIR_EraseRootFromParent_Done,
     /*   15937 */   // Label 358: @15937
     /*   15937 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16033), // Rule ID 52166 //
     /*   15942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15965 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15979 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15994 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15998 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16000 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16007 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16031 */     GIR_RootConstrainSelectedInstOperands,
     /*   16032 */     // GIR_Coverage, 52166,
     /*   16032 */     GIR_EraseRootFromParent_Done,
     /*   16033 */   // Label 359: @16033
     /*   16033 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16129), // Rule ID 52167 //
     /*   16038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16061 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16075 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16077 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16090 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16094 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16096 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16103 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16127 */     GIR_RootConstrainSelectedInstOperands,
     /*   16128 */     // GIR_Coverage, 52167,
     /*   16128 */     GIR_EraseRootFromParent_Done,
     /*   16129 */   // Label 360: @16129
     /*   16129 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16225), // Rule ID 71108 //
     /*   16134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16157 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16171 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16186 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16190 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16192 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16199 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   16210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   16214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16223 */     GIR_RootConstrainSelectedInstOperands,
     /*   16224 */     // GIR_Coverage, 71108,
     /*   16224 */     GIR_EraseRootFromParent_Done,
     /*   16225 */   // Label 361: @16225
     /*   16225 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16321), // Rule ID 71109 //
     /*   16230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16253 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16267 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16282 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16286 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16288 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16295 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   16306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   16310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16319 */     GIR_RootConstrainSelectedInstOperands,
     /*   16320 */     // GIR_Coverage, 71109,
     /*   16320 */     GIR_EraseRootFromParent_Done,
     /*   16321 */   // Label 362: @16321
     /*   16321 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16417), // Rule ID 52106 //
     /*   16326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16349 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16363 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16378 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16382 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16384 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16389 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16391 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16415 */     GIR_RootConstrainSelectedInstOperands,
     /*   16416 */     // GIR_Coverage, 52106,
     /*   16416 */     GIR_EraseRootFromParent_Done,
     /*   16417 */   // Label 363: @16417
     /*   16417 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16513), // Rule ID 52107 //
     /*   16422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16445 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16459 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16474 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16478 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16480 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16485 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16487 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16511 */     GIR_RootConstrainSelectedInstOperands,
     /*   16512 */     // GIR_Coverage, 52107,
     /*   16512 */     GIR_EraseRootFromParent_Done,
     /*   16513 */   // Label 364: @16513
     /*   16513 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16602), // Rule ID 46704 //
     /*   16518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16533 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16552 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16561 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   16578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16600 */     GIR_RootConstrainSelectedInstOperands,
     /*   16601 */     // GIR_Coverage, 46704,
     /*   16601 */     GIR_EraseRootFromParent_Done,
     /*   16602 */   // Label 365: @16602
     /*   16602 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16691), // Rule ID 46705 //
     /*   16607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16622 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16641 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16650 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   16667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16689 */     GIR_RootConstrainSelectedInstOperands,
     /*   16690 */     // GIR_Coverage, 46705,
     /*   16690 */     GIR_EraseRootFromParent_Done,
     /*   16691 */   // Label 366: @16691
     /*   16691 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16780), // Rule ID 46468 //
     /*   16696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16711 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16730 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16739 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   16756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16778 */     GIR_RootConstrainSelectedInstOperands,
     /*   16779 */     // GIR_Coverage, 46468,
     /*   16779 */     GIR_EraseRootFromParent_Done,
     /*   16780 */   // Label 367: @16780
     /*   16780 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16869), // Rule ID 46469 //
     /*   16785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16800 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16819 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16828 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   16845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16867 */     GIR_RootConstrainSelectedInstOperands,
     /*   16868 */     // GIR_Coverage, 46469,
     /*   16868 */     GIR_EraseRootFromParent_Done,
     /*   16869 */   // Label 368: @16869
     /*   16869 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16958), // Rule ID 46584 //
     /*   16874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16889 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16908 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16917 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   16934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16956 */     GIR_RootConstrainSelectedInstOperands,
     /*   16957 */     // GIR_Coverage, 46584,
     /*   16957 */     GIR_EraseRootFromParent_Done,
     /*   16958 */   // Label 369: @16958
     /*   16958 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17047), // Rule ID 46585 //
     /*   16963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16978 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16997 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   17006 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   17006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   17023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17045 */     GIR_RootConstrainSelectedInstOperands,
     /*   17046 */     // GIR_Coverage, 46585,
     /*   17046 */     GIR_EraseRootFromParent_Done,
     /*   17047 */   // Label 370: @17047
     /*   17047 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17115), // Rule ID 70660 //
     /*   17052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17071 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17089 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   17089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17113 */     GIR_RootConstrainSelectedInstOperands,
     /*   17114 */     // GIR_Coverage, 70660,
     /*   17114 */     GIR_EraseRootFromParent_Done,
     /*   17115 */   // Label 371: @17115
     /*   17115 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17183), // Rule ID 70661 //
     /*   17120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17139 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17157 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   17157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17181 */     GIR_RootConstrainSelectedInstOperands,
     /*   17182 */     // GIR_Coverage, 70661,
     /*   17182 */     GIR_EraseRootFromParent_Done,
     /*   17183 */   // Label 372: @17183
     /*   17183 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17238), // Rule ID 69660 //
     /*   17188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17203 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17216 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17236 */     GIR_RootConstrainSelectedInstOperands,
     /*   17237 */     // GIR_Coverage, 69660,
     /*   17237 */     GIR_EraseRootFromParent_Done,
     /*   17238 */   // Label 373: @17238
     /*   17238 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17293), // Rule ID 69661 //
     /*   17243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17258 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17271 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17291 */     GIR_RootConstrainSelectedInstOperands,
     /*   17292 */     // GIR_Coverage, 69661,
     /*   17292 */     GIR_EraseRootFromParent_Done,
     /*   17293 */   // Label 374: @17293
     /*   17293 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17348), // Rule ID 69480 //
     /*   17298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17313 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17326 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17346 */     GIR_RootConstrainSelectedInstOperands,
     /*   17347 */     // GIR_Coverage, 69480,
     /*   17347 */     GIR_EraseRootFromParent_Done,
     /*   17348 */   // Label 375: @17348
     /*   17348 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17403), // Rule ID 69481 //
     /*   17353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17368 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17381 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17401 */     GIR_RootConstrainSelectedInstOperands,
     /*   17402 */     // GIR_Coverage, 69481,
     /*   17402 */     GIR_EraseRootFromParent_Done,
     /*   17403 */   // Label 376: @17403
     /*   17403 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17458), // Rule ID 69570 //
     /*   17408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17423 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17436 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17456 */     GIR_RootConstrainSelectedInstOperands,
     /*   17457 */     // GIR_Coverage, 69570,
     /*   17457 */     GIR_EraseRootFromParent_Done,
     /*   17458 */   // Label 377: @17458
     /*   17458 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17513), // Rule ID 69571 //
     /*   17463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17478 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17491 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17511 */     GIR_RootConstrainSelectedInstOperands,
     /*   17512 */     // GIR_Coverage, 69571,
     /*   17512 */     GIR_EraseRootFromParent_Done,
     /*   17513 */   // Label 378: @17513
     /*   17513 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17581), // Rule ID 51882 //
     /*   17518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17555 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   17555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17579 */     GIR_RootConstrainSelectedInstOperands,
     /*   17580 */     // GIR_Coverage, 51882,
     /*   17580 */     GIR_EraseRootFromParent_Done,
     /*   17581 */   // Label 379: @17581
     /*   17581 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17649), // Rule ID 51883 //
     /*   17586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17609 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17623 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   17623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17647 */     GIR_RootConstrainSelectedInstOperands,
     /*   17648 */     // GIR_Coverage, 51883,
     /*   17648 */     GIR_EraseRootFromParent_Done,
     /*   17649 */   // Label 380: @17649
     /*   17649 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17704), // Rule ID 46764 //
     /*   17654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17673 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17682 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17702 */     GIR_RootConstrainSelectedInstOperands,
     /*   17703 */     // GIR_Coverage, 46764,
     /*   17703 */     GIR_EraseRootFromParent_Done,
     /*   17704 */   // Label 381: @17704
     /*   17704 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17759), // Rule ID 46765 //
     /*   17709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17728 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17737 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17757 */     GIR_RootConstrainSelectedInstOperands,
     /*   17758 */     // GIR_Coverage, 46765,
     /*   17758 */     GIR_EraseRootFromParent_Done,
     /*   17759 */   // Label 382: @17759
     /*   17759 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17814), // Rule ID 46524 //
     /*   17764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17783 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17792 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17812 */     GIR_RootConstrainSelectedInstOperands,
     /*   17813 */     // GIR_Coverage, 46524,
     /*   17813 */     GIR_EraseRootFromParent_Done,
     /*   17814 */   // Label 383: @17814
     /*   17814 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17869), // Rule ID 46525 //
     /*   17819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17838 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17847 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17867 */     GIR_RootConstrainSelectedInstOperands,
     /*   17868 */     // GIR_Coverage, 46525,
     /*   17868 */     GIR_EraseRootFromParent_Done,
     /*   17869 */   // Label 384: @17869
     /*   17869 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17924), // Rule ID 46644 //
     /*   17874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17893 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17902 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17922 */     GIR_RootConstrainSelectedInstOperands,
     /*   17923 */     // GIR_Coverage, 46644,
     /*   17923 */     GIR_EraseRootFromParent_Done,
     /*   17924 */   // Label 385: @17924
     /*   17924 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17979), // Rule ID 46645 //
     /*   17929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17948 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17957 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17977 */     GIR_RootConstrainSelectedInstOperands,
     /*   17978 */     // GIR_Coverage, 46645,
     /*   17978 */     GIR_EraseRootFromParent_Done,
     /*   17979 */   // Label 386: @17979
     /*   17979 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18032), // Rule ID 46114 //
     /*   17984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17995 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   17995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   18012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18030 */     GIR_RootConstrainSelectedInstOperands,
     /*   18031 */     // GIR_Coverage, 46114,
     /*   18031 */     GIR_EraseRootFromParent_Done,
     /*   18032 */   // Label 387: @18032
     /*   18032 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18085), // Rule ID 46115 //
     /*   18037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18048 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   18048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   18051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   18065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18083 */     GIR_RootConstrainSelectedInstOperands,
     /*   18084 */     // GIR_Coverage, 46115,
     /*   18084 */     GIR_EraseRootFromParent_Done,
     /*   18085 */   // Label 388: @18085
     /*   18085 */   GIM_Reject,
     /*   18086 */ // Label 348: @18086
     /*   18086 */ GIM_Reject,
     /*   18087 */ // Label 131: @18087
     /*   18087 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(21211),
     /*   18092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18102 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18198), // Rule ID 70860 //
     /*   18107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18140 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18151 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18155 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18159 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18161 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18172 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18196 */     GIR_RootConstrainSelectedInstOperands,
     /*   18197 */     // GIR_Coverage, 70860,
     /*   18197 */     GIR_EraseRootFromParent_Done,
     /*   18198 */   // Label 390: @18198
     /*   18198 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18294), // Rule ID 70861 //
     /*   18203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18222 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18236 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18251 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18255 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18257 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18268 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18292 */     GIR_RootConstrainSelectedInstOperands,
     /*   18293 */     // GIR_Coverage, 70861,
     /*   18293 */     GIR_EraseRootFromParent_Done,
     /*   18294 */   // Label 391: @18294
     /*   18294 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18390), // Rule ID 71140 //
     /*   18299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18318 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18332 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18347 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18351 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18353 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18364 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18388 */     GIR_RootConstrainSelectedInstOperands,
     /*   18389 */     // GIR_Coverage, 71140,
     /*   18389 */     GIR_EraseRootFromParent_Done,
     /*   18390 */   // Label 392: @18390
     /*   18390 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18486), // Rule ID 71141 //
     /*   18395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18414 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18428 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18443 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18447 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18449 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18460 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18484 */     GIR_RootConstrainSelectedInstOperands,
     /*   18485 */     // GIR_Coverage, 71141,
     /*   18485 */     GIR_EraseRootFromParent_Done,
     /*   18486 */   // Label 393: @18486
     /*   18486 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18582), // Rule ID 71142 //
     /*   18491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18510 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18524 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18539 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18543 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18556 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   18567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   18571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18580 */     GIR_RootConstrainSelectedInstOperands,
     /*   18581 */     // GIR_Coverage, 71142,
     /*   18581 */     GIR_EraseRootFromParent_Done,
     /*   18582 */   // Label 394: @18582
     /*   18582 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18678), // Rule ID 71143 //
     /*   18587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18606 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18620 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18635 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18639 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18641 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18652 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   18663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   18667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18676 */     GIR_RootConstrainSelectedInstOperands,
     /*   18677 */     // GIR_Coverage, 71143,
     /*   18677 */     GIR_EraseRootFromParent_Done,
     /*   18678 */   // Label 395: @18678
     /*   18678 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18774), // Rule ID 70974 //
     /*   18683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18702 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18716 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18731 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18735 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18737 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18748 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   18751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18772 */     GIR_RootConstrainSelectedInstOperands,
     /*   18773 */     // GIR_Coverage, 70974,
     /*   18773 */     GIR_EraseRootFromParent_Done,
     /*   18774 */   // Label 396: @18774
     /*   18774 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18870), // Rule ID 70975 //
     /*   18779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18812 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18827 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18831 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18833 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18844 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   18847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18868 */     GIR_RootConstrainSelectedInstOperands,
     /*   18869 */     // GIR_Coverage, 70975,
     /*   18869 */     GIR_EraseRootFromParent_Done,
     /*   18870 */   // Label 397: @18870
     /*   18870 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18966), // Rule ID 52058 //
     /*   18875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18898 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18912 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18927 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18931 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18940 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   18947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18964 */     GIR_RootConstrainSelectedInstOperands,
     /*   18965 */     // GIR_Coverage, 52058,
     /*   18965 */     GIR_EraseRootFromParent_Done,
     /*   18966 */   // Label 398: @18966
     /*   18966 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(19062), // Rule ID 52059 //
     /*   18971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18994 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19008 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19023 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19027 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19029 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19036 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   19039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19060 */     GIR_RootConstrainSelectedInstOperands,
     /*   19061 */     // GIR_Coverage, 52059,
     /*   19061 */     GIR_EraseRootFromParent_Done,
     /*   19062 */   // Label 399: @19062
     /*   19062 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(19158), // Rule ID 52176 //
     /*   19067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19090 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19104 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19119 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19123 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19125 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19132 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19156 */     GIR_RootConstrainSelectedInstOperands,
     /*   19157 */     // GIR_Coverage, 52176,
     /*   19157 */     GIR_EraseRootFromParent_Done,
     /*   19158 */   // Label 400: @19158
     /*   19158 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(19254), // Rule ID 52177 //
     /*   19163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19186 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19200 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19215 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19219 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19221 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19226 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19228 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19252 */     GIR_RootConstrainSelectedInstOperands,
     /*   19253 */     // GIR_Coverage, 52177,
     /*   19253 */     GIR_EraseRootFromParent_Done,
     /*   19254 */   // Label 401: @19254
     /*   19254 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(19350), // Rule ID 71138 //
     /*   19259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19282 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19296 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19311 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19315 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19317 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19324 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19348 */     GIR_RootConstrainSelectedInstOperands,
     /*   19349 */     // GIR_Coverage, 71138,
     /*   19349 */     GIR_EraseRootFromParent_Done,
     /*   19350 */   // Label 402: @19350
     /*   19350 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(19446), // Rule ID 71139 //
     /*   19355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19378 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19392 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19407 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19411 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19413 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19420 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19444 */     GIR_RootConstrainSelectedInstOperands,
     /*   19445 */     // GIR_Coverage, 71139,
     /*   19445 */     GIR_EraseRootFromParent_Done,
     /*   19446 */   // Label 403: @19446
     /*   19446 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(19542), // Rule ID 52116 //
     /*   19451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19474 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19488 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19503 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19507 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19509 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19516 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19540 */     GIR_RootConstrainSelectedInstOperands,
     /*   19541 */     // GIR_Coverage, 52116,
     /*   19541 */     GIR_EraseRootFromParent_Done,
     /*   19542 */   // Label 404: @19542
     /*   19542 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(19638), // Rule ID 52117 //
     /*   19547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19570 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19584 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19599 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19603 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19605 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19612 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19636 */     GIR_RootConstrainSelectedInstOperands,
     /*   19637 */     // GIR_Coverage, 52117,
     /*   19637 */     GIR_EraseRootFromParent_Done,
     /*   19638 */   // Label 405: @19638
     /*   19638 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(19727), // Rule ID 46724 //
     /*   19643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19658 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19677 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19686 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   19686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   19703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19725 */     GIR_RootConstrainSelectedInstOperands,
     /*   19726 */     // GIR_Coverage, 46724,
     /*   19726 */     GIR_EraseRootFromParent_Done,
     /*   19727 */   // Label 406: @19727
     /*   19727 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(19816), // Rule ID 46725 //
     /*   19732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19747 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19766 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19775 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   19775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   19792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19814 */     GIR_RootConstrainSelectedInstOperands,
     /*   19815 */     // GIR_Coverage, 46725,
     /*   19815 */     GIR_EraseRootFromParent_Done,
     /*   19816 */   // Label 407: @19816
     /*   19816 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(19905), // Rule ID 46488 //
     /*   19821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19855 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19864 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   19864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   19881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19903 */     GIR_RootConstrainSelectedInstOperands,
     /*   19904 */     // GIR_Coverage, 46488,
     /*   19904 */     GIR_EraseRootFromParent_Done,
     /*   19905 */   // Label 408: @19905
     /*   19905 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(19994), // Rule ID 46489 //
     /*   19910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19925 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19944 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19953 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   19953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   19970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19992 */     GIR_RootConstrainSelectedInstOperands,
     /*   19993 */     // GIR_Coverage, 46489,
     /*   19993 */     GIR_EraseRootFromParent_Done,
     /*   19994 */   // Label 409: @19994
     /*   19994 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(20083), // Rule ID 46604 //
     /*   19999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20014 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20033 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20042 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   20042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20081 */     GIR_RootConstrainSelectedInstOperands,
     /*   20082 */     // GIR_Coverage, 46604,
     /*   20082 */     GIR_EraseRootFromParent_Done,
     /*   20083 */   // Label 410: @20083
     /*   20083 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(20172), // Rule ID 46605 //
     /*   20088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20103 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20122 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20131 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   20131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20170 */     GIR_RootConstrainSelectedInstOperands,
     /*   20171 */     // GIR_Coverage, 46605,
     /*   20171 */     GIR_EraseRootFromParent_Done,
     /*   20172 */   // Label 411: @20172
     /*   20172 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(20240), // Rule ID 70692 //
     /*   20177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   20180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20214 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   20214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20238 */     GIR_RootConstrainSelectedInstOperands,
     /*   20239 */     // GIR_Coverage, 70692,
     /*   20239 */     GIR_EraseRootFromParent_Done,
     /*   20240 */   // Label 412: @20240
     /*   20240 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(20308), // Rule ID 70693 //
     /*   20245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   20248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20264 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20282 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   20282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20306 */     GIR_RootConstrainSelectedInstOperands,
     /*   20307 */     // GIR_Coverage, 70693,
     /*   20307 */     GIR_EraseRootFromParent_Done,
     /*   20308 */   // Label 413: @20308
     /*   20308 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(20363), // Rule ID 69680 //
     /*   20313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20341 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20361 */     GIR_RootConstrainSelectedInstOperands,
     /*   20362 */     // GIR_Coverage, 69680,
     /*   20362 */     GIR_EraseRootFromParent_Done,
     /*   20363 */   // Label 414: @20363
     /*   20363 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(20418), // Rule ID 69681 //
     /*   20368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20383 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20396 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20416 */     GIR_RootConstrainSelectedInstOperands,
     /*   20417 */     // GIR_Coverage, 69681,
     /*   20417 */     GIR_EraseRootFromParent_Done,
     /*   20418 */   // Label 415: @20418
     /*   20418 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(20473), // Rule ID 69500 //
     /*   20423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20438 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20451 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20471 */     GIR_RootConstrainSelectedInstOperands,
     /*   20472 */     // GIR_Coverage, 69500,
     /*   20472 */     GIR_EraseRootFromParent_Done,
     /*   20473 */   // Label 416: @20473
     /*   20473 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(20528), // Rule ID 69501 //
     /*   20478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20493 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20506 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20526 */     GIR_RootConstrainSelectedInstOperands,
     /*   20527 */     // GIR_Coverage, 69501,
     /*   20527 */     GIR_EraseRootFromParent_Done,
     /*   20528 */   // Label 417: @20528
     /*   20528 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(20583), // Rule ID 69590 //
     /*   20533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20548 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20561 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20581 */     GIR_RootConstrainSelectedInstOperands,
     /*   20582 */     // GIR_Coverage, 69590,
     /*   20582 */     GIR_EraseRootFromParent_Done,
     /*   20583 */   // Label 418: @20583
     /*   20583 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(20638), // Rule ID 69591 //
     /*   20588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20603 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20616 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20636 */     GIR_RootConstrainSelectedInstOperands,
     /*   20637 */     // GIR_Coverage, 69591,
     /*   20637 */     GIR_EraseRootFromParent_Done,
     /*   20638 */   // Label 419: @20638
     /*   20638 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(20706), // Rule ID 51898 //
     /*   20643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   20646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20680 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   20680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20704 */     GIR_RootConstrainSelectedInstOperands,
     /*   20705 */     // GIR_Coverage, 51898,
     /*   20705 */     GIR_EraseRootFromParent_Done,
     /*   20706 */   // Label 420: @20706
     /*   20706 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(20774), // Rule ID 51899 //
     /*   20711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   20714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20734 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20748 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   20748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20772 */     GIR_RootConstrainSelectedInstOperands,
     /*   20773 */     // GIR_Coverage, 51899,
     /*   20773 */     GIR_EraseRootFromParent_Done,
     /*   20774 */   // Label 421: @20774
     /*   20774 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(20829), // Rule ID 46784 //
     /*   20779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20807 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20827 */     GIR_RootConstrainSelectedInstOperands,
     /*   20828 */     // GIR_Coverage, 46784,
     /*   20828 */     GIR_EraseRootFromParent_Done,
     /*   20829 */   // Label 422: @20829
     /*   20829 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(20884), // Rule ID 46785 //
     /*   20834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20853 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20862 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20882 */     GIR_RootConstrainSelectedInstOperands,
     /*   20883 */     // GIR_Coverage, 46785,
     /*   20883 */     GIR_EraseRootFromParent_Done,
     /*   20884 */   // Label 423: @20884
     /*   20884 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(20939), // Rule ID 46544 //
     /*   20889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20917 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20937 */     GIR_RootConstrainSelectedInstOperands,
     /*   20938 */     // GIR_Coverage, 46544,
     /*   20938 */     GIR_EraseRootFromParent_Done,
     /*   20939 */   // Label 424: @20939
     /*   20939 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20994), // Rule ID 46545 //
     /*   20944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20963 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20972 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20992 */     GIR_RootConstrainSelectedInstOperands,
     /*   20993 */     // GIR_Coverage, 46545,
     /*   20993 */     GIR_EraseRootFromParent_Done,
     /*   20994 */   // Label 425: @20994
     /*   20994 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(21049), // Rule ID 46664 //
     /*   20999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   21002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21018 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21027 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   21027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21047 */     GIR_RootConstrainSelectedInstOperands,
     /*   21048 */     // GIR_Coverage, 46664,
     /*   21048 */     GIR_EraseRootFromParent_Done,
     /*   21049 */   // Label 426: @21049
     /*   21049 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(21104), // Rule ID 46665 //
     /*   21054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   21057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21073 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21082 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   21082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21102 */     GIR_RootConstrainSelectedInstOperands,
     /*   21103 */     // GIR_Coverage, 46665,
     /*   21103 */     GIR_EraseRootFromParent_Done,
     /*   21104 */   // Label 427: @21104
     /*   21104 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(21157), // Rule ID 46130 //
     /*   21109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   21112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21120 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   21120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   21137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21155 */     GIR_RootConstrainSelectedInstOperands,
     /*   21156 */     // GIR_Coverage, 46130,
     /*   21156 */     GIR_EraseRootFromParent_Done,
     /*   21157 */   // Label 428: @21157
     /*   21157 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(21210), // Rule ID 46131 //
     /*   21162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   21165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21173 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   21173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   21190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21208 */     GIR_RootConstrainSelectedInstOperands,
     /*   21209 */     // GIR_Coverage, 46131,
     /*   21209 */     GIR_EraseRootFromParent_Done,
     /*   21210 */   // Label 429: @21210
     /*   21210 */   GIM_Reject,
     /*   21211 */ // Label 389: @21211
     /*   21211 */ GIM_Reject,
     /*   21212 */ // Label 132: @21212
     /*   21212 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(21606),
     /*   21217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21227 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(21295), // Rule ID 70628 //
     /*   21232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21269 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21293 */     GIR_RootConstrainSelectedInstOperands,
     /*   21294 */     // GIR_Coverage, 70628,
     /*   21294 */     GIR_EraseRootFromParent_Done,
     /*   21295 */   // Label 431: @21295
     /*   21295 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(21363), // Rule ID 70629 //
     /*   21300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21319 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21337 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21361 */     GIR_RootConstrainSelectedInstOperands,
     /*   21362 */     // GIR_Coverage, 70629,
     /*   21362 */     GIR_EraseRootFromParent_Done,
     /*   21363 */   // Label 432: @21363
     /*   21363 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21431), // Rule ID 51866 //
     /*   21368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21391 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21405 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21429 */     GIR_RootConstrainSelectedInstOperands,
     /*   21430 */     // GIR_Coverage, 51866,
     /*   21430 */     GIR_EraseRootFromParent_Done,
     /*   21431 */   // Label 433: @21431
     /*   21431 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21499), // Rule ID 51867 //
     /*   21436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21459 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21473 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21497 */     GIR_RootConstrainSelectedInstOperands,
     /*   21498 */     // GIR_Coverage, 51867,
     /*   21498 */     GIR_EraseRootFromParent_Done,
     /*   21499 */   // Label 434: @21499
     /*   21499 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21552), // Rule ID 46098 //
     /*   21504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21515 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   21515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   21518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   21532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21550 */     GIR_RootConstrainSelectedInstOperands,
     /*   21551 */     // GIR_Coverage, 46098,
     /*   21551 */     GIR_EraseRootFromParent_Done,
     /*   21552 */   // Label 435: @21552
     /*   21552 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21605), // Rule ID 46099 //
     /*   21557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21568 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   21568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   21571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   21585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21603 */     GIR_RootConstrainSelectedInstOperands,
     /*   21604 */     // GIR_Coverage, 46099,
     /*   21604 */     GIR_EraseRootFromParent_Done,
     /*   21605 */   // Label 436: @21605
     /*   21605 */   GIM_Reject,
     /*   21606 */ // Label 430: @21606
     /*   21606 */ GIM_Reject,
     /*   21607 */ // Label 133: @21607
     /*   21607 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(24731),
     /*   21612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21622 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21718), // Rule ID 70840 //
     /*   21627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21646 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21660 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21675 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21679 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21681 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21692 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   21695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21716 */     GIR_RootConstrainSelectedInstOperands,
     /*   21717 */     // GIR_Coverage, 70840,
     /*   21717 */     GIR_EraseRootFromParent_Done,
     /*   21718 */   // Label 438: @21718
     /*   21718 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21814), // Rule ID 70841 //
     /*   21723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21742 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21756 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21771 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21775 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21777 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21788 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   21791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21812 */     GIR_RootConstrainSelectedInstOperands,
     /*   21813 */     // GIR_Coverage, 70841,
     /*   21813 */     GIR_EraseRootFromParent_Done,
     /*   21814 */   // Label 439: @21814
     /*   21814 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21910), // Rule ID 71080 //
     /*   21819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21838 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21852 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21867 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21871 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21873 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21884 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   21887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21908 */     GIR_RootConstrainSelectedInstOperands,
     /*   21909 */     // GIR_Coverage, 71080,
     /*   21909 */     GIR_EraseRootFromParent_Done,
     /*   21910 */   // Label 440: @21910
     /*   21910 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(22006), // Rule ID 71081 //
     /*   21915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21934 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21948 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21963 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21967 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21969 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21980 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   21983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22004 */     GIR_RootConstrainSelectedInstOperands,
     /*   22005 */     // GIR_Coverage, 71081,
     /*   22005 */     GIR_EraseRootFromParent_Done,
     /*   22006 */   // Label 441: @22006
     /*   22006 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22102), // Rule ID 71082 //
     /*   22011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22030 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22044 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22059 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22063 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22065 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22076 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22100 */     GIR_RootConstrainSelectedInstOperands,
     /*   22101 */     // GIR_Coverage, 71082,
     /*   22101 */     GIR_EraseRootFromParent_Done,
     /*   22102 */   // Label 442: @22102
     /*   22102 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22198), // Rule ID 71083 //
     /*   22107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22140 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22151 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22155 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22159 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22161 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22172 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22196 */     GIR_RootConstrainSelectedInstOperands,
     /*   22197 */     // GIR_Coverage, 71083,
     /*   22197 */     GIR_EraseRootFromParent_Done,
     /*   22198 */   // Label 443: @22198
     /*   22198 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22294), // Rule ID 70954 //
     /*   22203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22222 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22236 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22251 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22255 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22257 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22268 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   22271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22292 */     GIR_RootConstrainSelectedInstOperands,
     /*   22293 */     // GIR_Coverage, 70954,
     /*   22293 */     GIR_EraseRootFromParent_Done,
     /*   22294 */   // Label 444: @22294
     /*   22294 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22390), // Rule ID 70955 //
     /*   22299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22318 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22332 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22347 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22351 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22353 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22364 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   22367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22388 */     GIR_RootConstrainSelectedInstOperands,
     /*   22389 */     // GIR_Coverage, 70955,
     /*   22389 */     GIR_EraseRootFromParent_Done,
     /*   22390 */   // Label 445: @22390
     /*   22390 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22486), // Rule ID 52038 //
     /*   22395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22418 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22432 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22447 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22451 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22453 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22460 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22484 */     GIR_RootConstrainSelectedInstOperands,
     /*   22485 */     // GIR_Coverage, 52038,
     /*   22485 */     GIR_EraseRootFromParent_Done,
     /*   22486 */   // Label 446: @22486
     /*   22486 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22582), // Rule ID 52039 //
     /*   22491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22514 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22528 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22543 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22547 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22549 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22556 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22580 */     GIR_RootConstrainSelectedInstOperands,
     /*   22581 */     // GIR_Coverage, 52039,
     /*   22581 */     GIR_EraseRootFromParent_Done,
     /*   22582 */   // Label 447: @22582
     /*   22582 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22678), // Rule ID 52156 //
     /*   22587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22610 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22624 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22639 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22643 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22645 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22652 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22676 */     GIR_RootConstrainSelectedInstOperands,
     /*   22677 */     // GIR_Coverage, 52156,
     /*   22677 */     GIR_EraseRootFromParent_Done,
     /*   22678 */   // Label 448: @22678
     /*   22678 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22774), // Rule ID 52157 //
     /*   22683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22706 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22720 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22735 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22739 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22741 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22748 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22772 */     GIR_RootConstrainSelectedInstOperands,
     /*   22773 */     // GIR_Coverage, 52157,
     /*   22773 */     GIR_EraseRootFromParent_Done,
     /*   22774 */   // Label 449: @22774
     /*   22774 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22870), // Rule ID 71078 //
     /*   22779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22802 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22816 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22831 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22835 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22837 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22844 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22868 */     GIR_RootConstrainSelectedInstOperands,
     /*   22869 */     // GIR_Coverage, 71078,
     /*   22869 */     GIR_EraseRootFromParent_Done,
     /*   22870 */   // Label 450: @22870
     /*   22870 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22966), // Rule ID 71079 //
     /*   22875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22898 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22912 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22927 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22931 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22940 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22964 */     GIR_RootConstrainSelectedInstOperands,
     /*   22965 */     // GIR_Coverage, 71079,
     /*   22965 */     GIR_EraseRootFromParent_Done,
     /*   22966 */   // Label 451: @22966
     /*   22966 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(23062), // Rule ID 52096 //
     /*   22971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22994 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23008 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23023 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23027 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23029 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23036 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   23039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23060 */     GIR_RootConstrainSelectedInstOperands,
     /*   23061 */     // GIR_Coverage, 52096,
     /*   23061 */     GIR_EraseRootFromParent_Done,
     /*   23062 */   // Label 452: @23062
     /*   23062 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23158), // Rule ID 52097 //
     /*   23067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23090 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23104 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23119 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23123 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23125 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23132 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   23135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23156 */     GIR_RootConstrainSelectedInstOperands,
     /*   23157 */     // GIR_Coverage, 52097,
     /*   23157 */     GIR_EraseRootFromParent_Done,
     /*   23158 */   // Label 453: @23158
     /*   23158 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23247), // Rule ID 46684 //
     /*   23163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23178 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23197 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23199 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23206 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23245 */     GIR_RootConstrainSelectedInstOperands,
     /*   23246 */     // GIR_Coverage, 46684,
     /*   23246 */     GIR_EraseRootFromParent_Done,
     /*   23247 */   // Label 454: @23247
     /*   23247 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23336), // Rule ID 46685 //
     /*   23252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23267 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23286 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23295 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23334 */     GIR_RootConstrainSelectedInstOperands,
     /*   23335 */     // GIR_Coverage, 46685,
     /*   23335 */     GIR_EraseRootFromParent_Done,
     /*   23336 */   // Label 455: @23336
     /*   23336 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23425), // Rule ID 46448 //
     /*   23341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23356 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23375 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23384 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   23401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23423 */     GIR_RootConstrainSelectedInstOperands,
     /*   23424 */     // GIR_Coverage, 46448,
     /*   23424 */     GIR_EraseRootFromParent_Done,
     /*   23425 */   // Label 456: @23425
     /*   23425 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23514), // Rule ID 46449 //
     /*   23430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23445 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23464 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23473 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   23490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23512 */     GIR_RootConstrainSelectedInstOperands,
     /*   23513 */     // GIR_Coverage, 46449,
     /*   23513 */     GIR_EraseRootFromParent_Done,
     /*   23514 */   // Label 457: @23514
     /*   23514 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23603), // Rule ID 46564 //
     /*   23519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23534 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23553 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23562 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23601 */     GIR_RootConstrainSelectedInstOperands,
     /*   23602 */     // GIR_Coverage, 46564,
     /*   23602 */     GIR_EraseRootFromParent_Done,
     /*   23603 */   // Label 458: @23603
     /*   23603 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23692), // Rule ID 46565 //
     /*   23608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23623 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23642 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23651 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23690 */     GIR_RootConstrainSelectedInstOperands,
     /*   23691 */     // GIR_Coverage, 46565,
     /*   23691 */     GIR_EraseRootFromParent_Done,
     /*   23692 */   // Label 459: @23692
     /*   23692 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23760), // Rule ID 70652 //
     /*   23697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23734 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   23734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   23737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   23743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23758 */     GIR_RootConstrainSelectedInstOperands,
     /*   23759 */     // GIR_Coverage, 70652,
     /*   23759 */     GIR_EraseRootFromParent_Done,
     /*   23760 */   // Label 460: @23760
     /*   23760 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23828), // Rule ID 70653 //
     /*   23765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23784 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23802 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   23802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   23805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   23811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23826 */     GIR_RootConstrainSelectedInstOperands,
     /*   23827 */     // GIR_Coverage, 70653,
     /*   23827 */     GIR_EraseRootFromParent_Done,
     /*   23828 */   // Label 461: @23828
     /*   23828 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23883), // Rule ID 69640 //
     /*   23833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23848 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23861 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   23864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23881 */     GIR_RootConstrainSelectedInstOperands,
     /*   23882 */     // GIR_Coverage, 69640,
     /*   23882 */     GIR_EraseRootFromParent_Done,
     /*   23883 */   // Label 462: @23883
     /*   23883 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23938), // Rule ID 69641 //
     /*   23888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23903 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23916 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   23919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23936 */     GIR_RootConstrainSelectedInstOperands,
     /*   23937 */     // GIR_Coverage, 69641,
     /*   23937 */     GIR_EraseRootFromParent_Done,
     /*   23938 */   // Label 463: @23938
     /*   23938 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23993), // Rule ID 69460 //
     /*   23943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23958 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23971 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   23974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23991 */     GIR_RootConstrainSelectedInstOperands,
     /*   23992 */     // GIR_Coverage, 69460,
     /*   23992 */     GIR_EraseRootFromParent_Done,
     /*   23993 */   // Label 464: @23993
     /*   23993 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(24048), // Rule ID 69461 //
     /*   23998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24013 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24026 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24046 */     GIR_RootConstrainSelectedInstOperands,
     /*   24047 */     // GIR_Coverage, 69461,
     /*   24047 */     GIR_EraseRootFromParent_Done,
     /*   24048 */   // Label 465: @24048
     /*   24048 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(24103), // Rule ID 69550 //
     /*   24053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24068 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24081 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24101 */     GIR_RootConstrainSelectedInstOperands,
     /*   24102 */     // GIR_Coverage, 69550,
     /*   24102 */     GIR_EraseRootFromParent_Done,
     /*   24103 */   // Label 466: @24103
     /*   24103 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(24158), // Rule ID 69551 //
     /*   24108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24123 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24136 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24156 */     GIR_RootConstrainSelectedInstOperands,
     /*   24157 */     // GIR_Coverage, 69551,
     /*   24157 */     GIR_EraseRootFromParent_Done,
     /*   24158 */   // Label 467: @24158
     /*   24158 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(24226), // Rule ID 51878 //
     /*   24163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24186 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24200 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24224 */     GIR_RootConstrainSelectedInstOperands,
     /*   24225 */     // GIR_Coverage, 51878,
     /*   24225 */     GIR_EraseRootFromParent_Done,
     /*   24226 */   // Label 468: @24226
     /*   24226 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(24294), // Rule ID 51879 //
     /*   24231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24254 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24268 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   24268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24292 */     GIR_RootConstrainSelectedInstOperands,
     /*   24293 */     // GIR_Coverage, 51879,
     /*   24293 */     GIR_EraseRootFromParent_Done,
     /*   24294 */   // Label 469: @24294
     /*   24294 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(24349), // Rule ID 46744 //
     /*   24299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24318 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24327 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24347 */     GIR_RootConstrainSelectedInstOperands,
     /*   24348 */     // GIR_Coverage, 46744,
     /*   24348 */     GIR_EraseRootFromParent_Done,
     /*   24349 */   // Label 470: @24349
     /*   24349 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(24404), // Rule ID 46745 //
     /*   24354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24373 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24382 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24402 */     GIR_RootConstrainSelectedInstOperands,
     /*   24403 */     // GIR_Coverage, 46745,
     /*   24403 */     GIR_EraseRootFromParent_Done,
     /*   24404 */   // Label 471: @24404
     /*   24404 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24459), // Rule ID 46504 //
     /*   24409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24428 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24437 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24457 */     GIR_RootConstrainSelectedInstOperands,
     /*   24458 */     // GIR_Coverage, 46504,
     /*   24458 */     GIR_EraseRootFromParent_Done,
     /*   24459 */   // Label 472: @24459
     /*   24459 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24514), // Rule ID 46505 //
     /*   24464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24483 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24492 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24512 */     GIR_RootConstrainSelectedInstOperands,
     /*   24513 */     // GIR_Coverage, 46505,
     /*   24513 */     GIR_EraseRootFromParent_Done,
     /*   24514 */   // Label 473: @24514
     /*   24514 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24569), // Rule ID 46624 //
     /*   24519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24538 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24547 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24567 */     GIR_RootConstrainSelectedInstOperands,
     /*   24568 */     // GIR_Coverage, 46624,
     /*   24568 */     GIR_EraseRootFromParent_Done,
     /*   24569 */   // Label 474: @24569
     /*   24569 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24624), // Rule ID 46625 //
     /*   24574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24593 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24602 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24622 */     GIR_RootConstrainSelectedInstOperands,
     /*   24623 */     // GIR_Coverage, 46625,
     /*   24623 */     GIR_EraseRootFromParent_Done,
     /*   24624 */   // Label 475: @24624
     /*   24624 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24677), // Rule ID 46110 //
     /*   24629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24640 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   24640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   24657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24675 */     GIR_RootConstrainSelectedInstOperands,
     /*   24676 */     // GIR_Coverage, 46110,
     /*   24676 */     GIR_EraseRootFromParent_Done,
     /*   24677 */   // Label 476: @24677
     /*   24677 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24730), // Rule ID 46111 //
     /*   24682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24693 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   24693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   24710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24728 */     GIR_RootConstrainSelectedInstOperands,
     /*   24729 */     // GIR_Coverage, 46111,
     /*   24729 */     GIR_EraseRootFromParent_Done,
     /*   24730 */   // Label 477: @24730
     /*   24730 */   GIM_Reject,
     /*   24731 */ // Label 437: @24731
     /*   24731 */ GIM_Reject,
     /*   24732 */ // Label 134: @24732
     /*   24732 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(27856),
     /*   24737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24747 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24843), // Rule ID 70852 //
     /*   24752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24771 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24785 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24787 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24792 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24796 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24800 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24804 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24806 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24817 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   24820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24841 */     GIR_RootConstrainSelectedInstOperands,
     /*   24842 */     // GIR_Coverage, 70852,
     /*   24842 */     GIR_EraseRootFromParent_Done,
     /*   24843 */   // Label 479: @24843
     /*   24843 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(24939), // Rule ID 70853 //
     /*   24848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24867 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24881 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24896 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24900 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24902 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24913 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   24913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   24916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24937 */     GIR_RootConstrainSelectedInstOperands,
     /*   24938 */     // GIR_Coverage, 70853,
     /*   24938 */     GIR_EraseRootFromParent_Done,
     /*   24939 */   // Label 480: @24939
     /*   24939 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(25035), // Rule ID 71116 //
     /*   24944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24963 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24977 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24992 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24996 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24998 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25009 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25033 */     GIR_RootConstrainSelectedInstOperands,
     /*   25034 */     // GIR_Coverage, 71116,
     /*   25034 */     GIR_EraseRootFromParent_Done,
     /*   25035 */   // Label 481: @25035
     /*   25035 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(25131), // Rule ID 71117 //
     /*   25040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25059 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25073 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25075 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25088 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25092 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25094 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25105 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25129 */     GIR_RootConstrainSelectedInstOperands,
     /*   25130 */     // GIR_Coverage, 71117,
     /*   25130 */     GIR_EraseRootFromParent_Done,
     /*   25131 */   // Label 482: @25131
     /*   25131 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(25227), // Rule ID 71118 //
     /*   25136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25155 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25169 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25188 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25190 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25201 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25225 */     GIR_RootConstrainSelectedInstOperands,
     /*   25226 */     // GIR_Coverage, 71118,
     /*   25226 */     GIR_EraseRootFromParent_Done,
     /*   25227 */   // Label 483: @25227
     /*   25227 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(25323), // Rule ID 71119 //
     /*   25232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25265 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25280 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25284 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25286 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25297 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25321 */     GIR_RootConstrainSelectedInstOperands,
     /*   25322 */     // GIR_Coverage, 71119,
     /*   25322 */     GIR_EraseRootFromParent_Done,
     /*   25323 */   // Label 484: @25323
     /*   25323 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(25419), // Rule ID 70966 //
     /*   25328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25347 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25361 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25363 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25376 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25380 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25382 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25393 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   25396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25417 */     GIR_RootConstrainSelectedInstOperands,
     /*   25418 */     // GIR_Coverage, 70966,
     /*   25418 */     GIR_EraseRootFromParent_Done,
     /*   25419 */   // Label 485: @25419
     /*   25419 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(25515), // Rule ID 70967 //
     /*   25424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25443 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25457 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25472 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25476 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25478 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25489 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   25492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25513 */     GIR_RootConstrainSelectedInstOperands,
     /*   25514 */     // GIR_Coverage, 70967,
     /*   25514 */     GIR_EraseRootFromParent_Done,
     /*   25515 */   // Label 486: @25515
     /*   25515 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(25611), // Rule ID 52050 //
     /*   25520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25543 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25557 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25576 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25578 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25585 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   25588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25609 */     GIR_RootConstrainSelectedInstOperands,
     /*   25610 */     // GIR_Coverage, 52050,
     /*   25610 */     GIR_EraseRootFromParent_Done,
     /*   25611 */   // Label 487: @25611
     /*   25611 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(25707), // Rule ID 52051 //
     /*   25616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25639 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25653 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25668 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25672 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25674 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25681 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   25684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25705 */     GIR_RootConstrainSelectedInstOperands,
     /*   25706 */     // GIR_Coverage, 52051,
     /*   25706 */     GIR_EraseRootFromParent_Done,
     /*   25707 */   // Label 488: @25707
     /*   25707 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(25803), // Rule ID 52168 //
     /*   25712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25735 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25749 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25768 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25770 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25777 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25801 */     GIR_RootConstrainSelectedInstOperands,
     /*   25802 */     // GIR_Coverage, 52168,
     /*   25802 */     GIR_EraseRootFromParent_Done,
     /*   25803 */   // Label 489: @25803
     /*   25803 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(25899), // Rule ID 52169 //
     /*   25808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25845 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25860 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25864 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25866 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25873 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25897 */     GIR_RootConstrainSelectedInstOperands,
     /*   25898 */     // GIR_Coverage, 52169,
     /*   25898 */     GIR_EraseRootFromParent_Done,
     /*   25899 */   // Label 490: @25899
     /*   25899 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(25995), // Rule ID 71114 //
     /*   25904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25927 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25941 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25956 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25960 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25962 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25967 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25969 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25993 */     GIR_RootConstrainSelectedInstOperands,
     /*   25994 */     // GIR_Coverage, 71114,
     /*   25994 */     GIR_EraseRootFromParent_Done,
     /*   25995 */   // Label 491: @25995
     /*   25995 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(26091), // Rule ID 71115 //
     /*   26000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26023 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26037 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26052 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26056 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26058 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26065 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   26068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   26076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   26080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26089 */     GIR_RootConstrainSelectedInstOperands,
     /*   26090 */     // GIR_Coverage, 71115,
     /*   26090 */     GIR_EraseRootFromParent_Done,
     /*   26091 */   // Label 492: @26091
     /*   26091 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(26187), // Rule ID 52108 //
     /*   26096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26119 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26133 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26152 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26154 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26161 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   26164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26185 */     GIR_RootConstrainSelectedInstOperands,
     /*   26186 */     // GIR_Coverage, 52108,
     /*   26186 */     GIR_EraseRootFromParent_Done,
     /*   26187 */   // Label 493: @26187
     /*   26187 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(26283), // Rule ID 52109 //
     /*   26192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26215 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26229 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26244 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26248 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26250 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26257 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   26260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26281 */     GIR_RootConstrainSelectedInstOperands,
     /*   26282 */     // GIR_Coverage, 52109,
     /*   26282 */     GIR_EraseRootFromParent_Done,
     /*   26283 */   // Label 494: @26283
     /*   26283 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(26372), // Rule ID 46708 //
     /*   26288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26303 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26322 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26331 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26370 */     GIR_RootConstrainSelectedInstOperands,
     /*   26371 */     // GIR_Coverage, 46708,
     /*   26371 */     GIR_EraseRootFromParent_Done,
     /*   26372 */   // Label 495: @26372
     /*   26372 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(26461), // Rule ID 46709 //
     /*   26377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26392 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26411 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26420 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26459 */     GIR_RootConstrainSelectedInstOperands,
     /*   26460 */     // GIR_Coverage, 46709,
     /*   26460 */     GIR_EraseRootFromParent_Done,
     /*   26461 */   // Label 496: @26461
     /*   26461 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(26550), // Rule ID 46472 //
     /*   26466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26481 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26500 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26509 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   26526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26548 */     GIR_RootConstrainSelectedInstOperands,
     /*   26549 */     // GIR_Coverage, 46472,
     /*   26549 */     GIR_EraseRootFromParent_Done,
     /*   26550 */   // Label 497: @26550
     /*   26550 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(26639), // Rule ID 46473 //
     /*   26555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26570 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26589 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26598 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   26615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26637 */     GIR_RootConstrainSelectedInstOperands,
     /*   26638 */     // GIR_Coverage, 46473,
     /*   26638 */     GIR_EraseRootFromParent_Done,
     /*   26639 */   // Label 498: @26639
     /*   26639 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(26728), // Rule ID 46588 //
     /*   26644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26659 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26678 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26687 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26726 */     GIR_RootConstrainSelectedInstOperands,
     /*   26727 */     // GIR_Coverage, 46588,
     /*   26727 */     GIR_EraseRootFromParent_Done,
     /*   26728 */   // Label 499: @26728
     /*   26728 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(26817), // Rule ID 46589 //
     /*   26733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26748 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26767 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26776 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26815 */     GIR_RootConstrainSelectedInstOperands,
     /*   26816 */     // GIR_Coverage, 46589,
     /*   26816 */     GIR_EraseRootFromParent_Done,
     /*   26817 */   // Label 500: @26817
     /*   26817 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(26885), // Rule ID 70684 //
     /*   26822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26859 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   26859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   26862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   26868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26883 */     GIR_RootConstrainSelectedInstOperands,
     /*   26884 */     // GIR_Coverage, 70684,
     /*   26884 */     GIR_EraseRootFromParent_Done,
     /*   26885 */   // Label 501: @26885
     /*   26885 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(26953), // Rule ID 70685 //
     /*   26890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26909 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26927 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   26927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   26930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   26936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26951 */     GIR_RootConstrainSelectedInstOperands,
     /*   26952 */     // GIR_Coverage, 70685,
     /*   26952 */     GIR_EraseRootFromParent_Done,
     /*   26953 */   // Label 502: @26953
     /*   26953 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(27008), // Rule ID 69664 //
     /*   26958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26986 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   26989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27006 */     GIR_RootConstrainSelectedInstOperands,
     /*   27007 */     // GIR_Coverage, 69664,
     /*   27007 */     GIR_EraseRootFromParent_Done,
     /*   27008 */   // Label 503: @27008
     /*   27008 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(27063), // Rule ID 69665 //
     /*   27013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27028 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27041 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27061 */     GIR_RootConstrainSelectedInstOperands,
     /*   27062 */     // GIR_Coverage, 69665,
     /*   27062 */     GIR_EraseRootFromParent_Done,
     /*   27063 */   // Label 504: @27063
     /*   27063 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(27118), // Rule ID 69484 //
     /*   27068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27083 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27096 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27116 */     GIR_RootConstrainSelectedInstOperands,
     /*   27117 */     // GIR_Coverage, 69484,
     /*   27117 */     GIR_EraseRootFromParent_Done,
     /*   27118 */   // Label 505: @27118
     /*   27118 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(27173), // Rule ID 69485 //
     /*   27123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27138 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27151 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27171 */     GIR_RootConstrainSelectedInstOperands,
     /*   27172 */     // GIR_Coverage, 69485,
     /*   27172 */     GIR_EraseRootFromParent_Done,
     /*   27173 */   // Label 506: @27173
     /*   27173 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(27228), // Rule ID 69574 //
     /*   27178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27193 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27206 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27226 */     GIR_RootConstrainSelectedInstOperands,
     /*   27227 */     // GIR_Coverage, 69574,
     /*   27227 */     GIR_EraseRootFromParent_Done,
     /*   27228 */   // Label 507: @27228
     /*   27228 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(27283), // Rule ID 69575 //
     /*   27233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27248 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27261 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27281 */     GIR_RootConstrainSelectedInstOperands,
     /*   27282 */     // GIR_Coverage, 69575,
     /*   27282 */     GIR_EraseRootFromParent_Done,
     /*   27283 */   // Label 508: @27283
     /*   27283 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(27351), // Rule ID 51894 //
     /*   27288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27311 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27325 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   27325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27349 */     GIR_RootConstrainSelectedInstOperands,
     /*   27350 */     // GIR_Coverage, 51894,
     /*   27350 */     GIR_EraseRootFromParent_Done,
     /*   27351 */   // Label 509: @27351
     /*   27351 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(27419), // Rule ID 51895 //
     /*   27356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27379 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27393 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   27393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27417 */     GIR_RootConstrainSelectedInstOperands,
     /*   27418 */     // GIR_Coverage, 51895,
     /*   27418 */     GIR_EraseRootFromParent_Done,
     /*   27419 */   // Label 510: @27419
     /*   27419 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(27474), // Rule ID 46768 //
     /*   27424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27443 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27452 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27472 */     GIR_RootConstrainSelectedInstOperands,
     /*   27473 */     // GIR_Coverage, 46768,
     /*   27473 */     GIR_EraseRootFromParent_Done,
     /*   27474 */   // Label 511: @27474
     /*   27474 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(27529), // Rule ID 46769 //
     /*   27479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27498 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27507 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27527 */     GIR_RootConstrainSelectedInstOperands,
     /*   27528 */     // GIR_Coverage, 46769,
     /*   27528 */     GIR_EraseRootFromParent_Done,
     /*   27529 */   // Label 512: @27529
     /*   27529 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(27584), // Rule ID 46528 //
     /*   27534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27553 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27562 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27582 */     GIR_RootConstrainSelectedInstOperands,
     /*   27583 */     // GIR_Coverage, 46528,
     /*   27583 */     GIR_EraseRootFromParent_Done,
     /*   27584 */   // Label 513: @27584
     /*   27584 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(27639), // Rule ID 46529 //
     /*   27589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27608 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27617 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27637 */     GIR_RootConstrainSelectedInstOperands,
     /*   27638 */     // GIR_Coverage, 46529,
     /*   27638 */     GIR_EraseRootFromParent_Done,
     /*   27639 */   // Label 514: @27639
     /*   27639 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(27694), // Rule ID 46648 //
     /*   27644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27663 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27672 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27692 */     GIR_RootConstrainSelectedInstOperands,
     /*   27693 */     // GIR_Coverage, 46648,
     /*   27693 */     GIR_EraseRootFromParent_Done,
     /*   27694 */   // Label 515: @27694
     /*   27694 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(27749), // Rule ID 46649 //
     /*   27699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27718 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27727 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27747 */     GIR_RootConstrainSelectedInstOperands,
     /*   27748 */     // GIR_Coverage, 46649,
     /*   27748 */     GIR_EraseRootFromParent_Done,
     /*   27749 */   // Label 516: @27749
     /*   27749 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(27802), // Rule ID 46126 //
     /*   27754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27765 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   27765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   27782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27800 */     GIR_RootConstrainSelectedInstOperands,
     /*   27801 */     // GIR_Coverage, 46126,
     /*   27801 */     GIR_EraseRootFromParent_Done,
     /*   27802 */   // Label 517: @27802
     /*   27802 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(27855), // Rule ID 46127 //
     /*   27807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27818 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   27818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   27835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27853 */     GIR_RootConstrainSelectedInstOperands,
     /*   27854 */     // GIR_Coverage, 46127,
     /*   27854 */     GIR_EraseRootFromParent_Done,
     /*   27855 */   // Label 518: @27855
     /*   27855 */   GIM_Reject,
     /*   27856 */ // Label 478: @27856
     /*   27856 */ GIM_Reject,
     /*   27857 */ // Label 135: @27857
     /*   27857 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(30981),
     /*   27862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   27865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   27868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   27872 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(27968), // Rule ID 70862 //
     /*   27877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   27880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   27892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   27896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27910 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   27921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27925 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27929 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   27931 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   27940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   27942 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   27942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   27945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   27949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   27957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27966 */     GIR_RootConstrainSelectedInstOperands,
     /*   27967 */     // GIR_Coverage, 70862,
     /*   27967 */     GIR_EraseRootFromParent_Done,
     /*   27968 */   // Label 520: @27968
     /*   27968 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(28064), // Rule ID 70863 //
     /*   27973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   27976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   27988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   27992 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28006 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28021 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28025 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28027 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28038 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28062 */     GIR_RootConstrainSelectedInstOperands,
     /*   28063 */     // GIR_Coverage, 70863,
     /*   28063 */     GIR_EraseRootFromParent_Done,
     /*   28064 */   // Label 521: @28064
     /*   28064 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(28160), // Rule ID 71146 //
     /*   28069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28088 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28102 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28117 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28121 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28123 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28134 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28158 */     GIR_RootConstrainSelectedInstOperands,
     /*   28159 */     // GIR_Coverage, 71146,
     /*   28159 */     GIR_EraseRootFromParent_Done,
     /*   28160 */   // Label 522: @28160
     /*   28160 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(28256), // Rule ID 71147 //
     /*   28165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28184 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28198 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28213 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28217 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28219 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28230 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28254 */     GIR_RootConstrainSelectedInstOperands,
     /*   28255 */     // GIR_Coverage, 71147,
     /*   28255 */     GIR_EraseRootFromParent_Done,
     /*   28256 */   // Label 523: @28256
     /*   28256 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(28352), // Rule ID 71148 //
     /*   28261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28280 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28294 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28309 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28313 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28315 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28326 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28350 */     GIR_RootConstrainSelectedInstOperands,
     /*   28351 */     // GIR_Coverage, 71148,
     /*   28351 */     GIR_EraseRootFromParent_Done,
     /*   28352 */   // Label 524: @28352
     /*   28352 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(28448), // Rule ID 71149 //
     /*   28357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28376 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28390 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28405 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28409 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28411 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28422 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28446 */     GIR_RootConstrainSelectedInstOperands,
     /*   28447 */     // GIR_Coverage, 71149,
     /*   28447 */     GIR_EraseRootFromParent_Done,
     /*   28448 */   // Label 525: @28448
     /*   28448 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(28544), // Rule ID 70976 //
     /*   28453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28472 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28486 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28501 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28505 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28507 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28518 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   28521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28542 */     GIR_RootConstrainSelectedInstOperands,
     /*   28543 */     // GIR_Coverage, 70976,
     /*   28543 */     GIR_EraseRootFromParent_Done,
     /*   28544 */   // Label 526: @28544
     /*   28544 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(28640), // Rule ID 70977 //
     /*   28549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28568 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28582 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28593 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28597 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28601 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28603 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28614 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   28617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28638 */     GIR_RootConstrainSelectedInstOperands,
     /*   28639 */     // GIR_Coverage, 70977,
     /*   28639 */     GIR_EraseRootFromParent_Done,
     /*   28640 */   // Label 527: @28640
     /*   28640 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(28736), // Rule ID 52060 //
     /*   28645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28668 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28682 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28697 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28701 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28703 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28710 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28734 */     GIR_RootConstrainSelectedInstOperands,
     /*   28735 */     // GIR_Coverage, 52060,
     /*   28735 */     GIR_EraseRootFromParent_Done,
     /*   28736 */   // Label 528: @28736
     /*   28736 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(28832), // Rule ID 52061 //
     /*   28741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28764 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28778 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28793 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28797 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28799 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28804 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28806 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28830 */     GIR_RootConstrainSelectedInstOperands,
     /*   28831 */     // GIR_Coverage, 52061,
     /*   28831 */     GIR_EraseRootFromParent_Done,
     /*   28832 */   // Label 529: @28832
     /*   28832 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(28928), // Rule ID 52178 //
     /*   28837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28860 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28874 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28889 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28893 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28895 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28900 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28902 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28926 */     GIR_RootConstrainSelectedInstOperands,
     /*   28927 */     // GIR_Coverage, 52178,
     /*   28927 */     GIR_EraseRootFromParent_Done,
     /*   28928 */   // Label 530: @28928
     /*   28928 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(29024), // Rule ID 52179 //
     /*   28933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28970 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28985 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28989 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28991 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28998 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29022 */     GIR_RootConstrainSelectedInstOperands,
     /*   29023 */     // GIR_Coverage, 52179,
     /*   29023 */     GIR_EraseRootFromParent_Done,
     /*   29024 */   // Label 531: @29024
     /*   29024 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(29120), // Rule ID 71144 //
     /*   29029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29052 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29066 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29081 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29085 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29087 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29094 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   29105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   29109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29118 */     GIR_RootConstrainSelectedInstOperands,
     /*   29119 */     // GIR_Coverage, 71144,
     /*   29119 */     GIR_EraseRootFromParent_Done,
     /*   29120 */   // Label 532: @29120
     /*   29120 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(29216), // Rule ID 71145 //
     /*   29125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29148 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29162 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29177 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29181 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29183 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29190 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   29201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   29205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29214 */     GIR_RootConstrainSelectedInstOperands,
     /*   29215 */     // GIR_Coverage, 71145,
     /*   29215 */     GIR_EraseRootFromParent_Done,
     /*   29216 */   // Label 533: @29216
     /*   29216 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(29312), // Rule ID 52118 //
     /*   29221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29244 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29258 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29273 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29277 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29279 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29286 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29310 */     GIR_RootConstrainSelectedInstOperands,
     /*   29311 */     // GIR_Coverage, 52118,
     /*   29311 */     GIR_EraseRootFromParent_Done,
     /*   29312 */   // Label 534: @29312
     /*   29312 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(29408), // Rule ID 52119 //
     /*   29317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29340 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29354 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29369 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29373 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29375 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29382 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29406 */     GIR_RootConstrainSelectedInstOperands,
     /*   29407 */     // GIR_Coverage, 52119,
     /*   29407 */     GIR_EraseRootFromParent_Done,
     /*   29408 */   // Label 535: @29408
     /*   29408 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(29497), // Rule ID 46728 //
     /*   29413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29428 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29447 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29456 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29495 */     GIR_RootConstrainSelectedInstOperands,
     /*   29496 */     // GIR_Coverage, 46728,
     /*   29496 */     GIR_EraseRootFromParent_Done,
     /*   29497 */   // Label 536: @29497
     /*   29497 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(29586), // Rule ID 46729 //
     /*   29502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29517 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29536 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29545 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29584 */     GIR_RootConstrainSelectedInstOperands,
     /*   29585 */     // GIR_Coverage, 46729,
     /*   29585 */     GIR_EraseRootFromParent_Done,
     /*   29586 */   // Label 537: @29586
     /*   29586 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(29675), // Rule ID 46492 //
     /*   29591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29606 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29625 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29634 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   29651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29673 */     GIR_RootConstrainSelectedInstOperands,
     /*   29674 */     // GIR_Coverage, 46492,
     /*   29674 */     GIR_EraseRootFromParent_Done,
     /*   29675 */   // Label 538: @29675
     /*   29675 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(29764), // Rule ID 46493 //
     /*   29680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29695 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29714 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29723 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   29740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29762 */     GIR_RootConstrainSelectedInstOperands,
     /*   29763 */     // GIR_Coverage, 46493,
     /*   29763 */     GIR_EraseRootFromParent_Done,
     /*   29764 */   // Label 539: @29764
     /*   29764 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(29853), // Rule ID 46608 //
     /*   29769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29784 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29803 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29812 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29851 */     GIR_RootConstrainSelectedInstOperands,
     /*   29852 */     // GIR_Coverage, 46608,
     /*   29852 */     GIR_EraseRootFromParent_Done,
     /*   29853 */   // Label 540: @29853
     /*   29853 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(29942), // Rule ID 46609 //
     /*   29858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29873 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29892 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29901 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29940 */     GIR_RootConstrainSelectedInstOperands,
     /*   29941 */     // GIR_Coverage, 46609,
     /*   29941 */     GIR_EraseRootFromParent_Done,
     /*   29942 */   // Label 541: @29942
     /*   29942 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(30010), // Rule ID 70772 //
     /*   29947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   29950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29984 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   29984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   29987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   29993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30008 */     GIR_RootConstrainSelectedInstOperands,
     /*   30009 */     // GIR_Coverage, 70772,
     /*   30009 */     GIR_EraseRootFromParent_Done,
     /*   30010 */   // Label 542: @30010
     /*   30010 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(30078), // Rule ID 70773 //
     /*   30015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30034 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30052 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   30052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30076 */     GIR_RootConstrainSelectedInstOperands,
     /*   30077 */     // GIR_Coverage, 70773,
     /*   30077 */     GIR_EraseRootFromParent_Done,
     /*   30078 */   // Label 543: @30078
     /*   30078 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(30133), // Rule ID 69684 //
     /*   30083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30098 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30111 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30131 */     GIR_RootConstrainSelectedInstOperands,
     /*   30132 */     // GIR_Coverage, 69684,
     /*   30132 */     GIR_EraseRootFromParent_Done,
     /*   30133 */   // Label 544: @30133
     /*   30133 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(30188), // Rule ID 69685 //
     /*   30138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30153 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30166 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30186 */     GIR_RootConstrainSelectedInstOperands,
     /*   30187 */     // GIR_Coverage, 69685,
     /*   30187 */     GIR_EraseRootFromParent_Done,
     /*   30188 */   // Label 545: @30188
     /*   30188 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(30243), // Rule ID 69504 //
     /*   30193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30221 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30241 */     GIR_RootConstrainSelectedInstOperands,
     /*   30242 */     // GIR_Coverage, 69504,
     /*   30242 */     GIR_EraseRootFromParent_Done,
     /*   30243 */   // Label 546: @30243
     /*   30243 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(30298), // Rule ID 69505 //
     /*   30248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30263 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30276 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30296 */     GIR_RootConstrainSelectedInstOperands,
     /*   30297 */     // GIR_Coverage, 69505,
     /*   30297 */     GIR_EraseRootFromParent_Done,
     /*   30298 */   // Label 547: @30298
     /*   30298 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(30353), // Rule ID 69594 //
     /*   30303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30318 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30331 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30351 */     GIR_RootConstrainSelectedInstOperands,
     /*   30352 */     // GIR_Coverage, 69594,
     /*   30352 */     GIR_EraseRootFromParent_Done,
     /*   30353 */   // Label 548: @30353
     /*   30353 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(30408), // Rule ID 69595 //
     /*   30358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30373 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30386 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30406 */     GIR_RootConstrainSelectedInstOperands,
     /*   30407 */     // GIR_Coverage, 69595,
     /*   30407 */     GIR_EraseRootFromParent_Done,
     /*   30408 */   // Label 549: @30408
     /*   30408 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(30476), // Rule ID 51938 //
     /*   30413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   30416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30450 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   30450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30474 */     GIR_RootConstrainSelectedInstOperands,
     /*   30475 */     // GIR_Coverage, 51938,
     /*   30475 */     GIR_EraseRootFromParent_Done,
     /*   30476 */   // Label 550: @30476
     /*   30476 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(30544), // Rule ID 51939 //
     /*   30481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30504 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30518 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   30518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30542 */     GIR_RootConstrainSelectedInstOperands,
     /*   30543 */     // GIR_Coverage, 51939,
     /*   30543 */     GIR_EraseRootFromParent_Done,
     /*   30544 */   // Label 551: @30544
     /*   30544 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(30599), // Rule ID 46788 //
     /*   30549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30568 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30577 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30597 */     GIR_RootConstrainSelectedInstOperands,
     /*   30598 */     // GIR_Coverage, 46788,
     /*   30598 */     GIR_EraseRootFromParent_Done,
     /*   30599 */   // Label 552: @30599
     /*   30599 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(30654), // Rule ID 46789 //
     /*   30604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30623 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30632 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30652 */     GIR_RootConstrainSelectedInstOperands,
     /*   30653 */     // GIR_Coverage, 46789,
     /*   30653 */     GIR_EraseRootFromParent_Done,
     /*   30654 */   // Label 553: @30654
     /*   30654 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(30709), // Rule ID 46548 //
     /*   30659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30678 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30687 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30707 */     GIR_RootConstrainSelectedInstOperands,
     /*   30708 */     // GIR_Coverage, 46548,
     /*   30708 */     GIR_EraseRootFromParent_Done,
     /*   30709 */   // Label 554: @30709
     /*   30709 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(30764), // Rule ID 46549 //
     /*   30714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30733 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30742 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30762 */     GIR_RootConstrainSelectedInstOperands,
     /*   30763 */     // GIR_Coverage, 46549,
     /*   30763 */     GIR_EraseRootFromParent_Done,
     /*   30764 */   // Label 555: @30764
     /*   30764 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(30819), // Rule ID 46668 //
     /*   30769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30797 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30817 */     GIR_RootConstrainSelectedInstOperands,
     /*   30818 */     // GIR_Coverage, 46668,
     /*   30818 */     GIR_EraseRootFromParent_Done,
     /*   30819 */   // Label 556: @30819
     /*   30819 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(30874), // Rule ID 46669 //
     /*   30824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30843 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30852 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30872 */     GIR_RootConstrainSelectedInstOperands,
     /*   30873 */     // GIR_Coverage, 46669,
     /*   30873 */     GIR_EraseRootFromParent_Done,
     /*   30874 */   // Label 557: @30874
     /*   30874 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(30927), // Rule ID 46170 //
     /*   30879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   30882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30890 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   30890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   30907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30925 */     GIR_RootConstrainSelectedInstOperands,
     /*   30926 */     // GIR_Coverage, 46170,
     /*   30926 */     GIR_EraseRootFromParent_Done,
     /*   30927 */   // Label 558: @30927
     /*   30927 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(30980), // Rule ID 46171 //
     /*   30932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30943 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   30943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   30960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30978 */     GIR_RootConstrainSelectedInstOperands,
     /*   30979 */     // GIR_Coverage, 46171,
     /*   30979 */     GIR_EraseRootFromParent_Done,
     /*   30980 */   // Label 559: @30980
     /*   30980 */   GIM_Reject,
     /*   30981 */ // Label 519: @30981
     /*   30981 */ GIM_Reject,
     /*   30982 */ // Label 136: @30982
     /*   30982 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(31376),
     /*   30987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   30990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   30993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30997 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(31065), // Rule ID 70636 //
     /*   31002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31021 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31039 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31063 */     GIR_RootConstrainSelectedInstOperands,
     /*   31064 */     // GIR_Coverage, 70636,
     /*   31064 */     GIR_EraseRootFromParent_Done,
     /*   31065 */   // Label 561: @31065
     /*   31065 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(31133), // Rule ID 70637 //
     /*   31070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31089 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31107 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31131 */     GIR_RootConstrainSelectedInstOperands,
     /*   31132 */     // GIR_Coverage, 70637,
     /*   31132 */     GIR_EraseRootFromParent_Done,
     /*   31133 */   // Label 562: @31133
     /*   31133 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(31201), // Rule ID 51870 //
     /*   31138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31161 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31175 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31199 */     GIR_RootConstrainSelectedInstOperands,
     /*   31200 */     // GIR_Coverage, 51870,
     /*   31200 */     GIR_EraseRootFromParent_Done,
     /*   31201 */   // Label 563: @31201
     /*   31201 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(31269), // Rule ID 51871 //
     /*   31206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31229 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31243 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31267 */     GIR_RootConstrainSelectedInstOperands,
     /*   31268 */     // GIR_Coverage, 51871,
     /*   31268 */     GIR_EraseRootFromParent_Done,
     /*   31269 */   // Label 564: @31269
     /*   31269 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(31322), // Rule ID 46102 //
     /*   31274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31285 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   31285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   31302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31320 */     GIR_RootConstrainSelectedInstOperands,
     /*   31321 */     // GIR_Coverage, 46102,
     /*   31321 */     GIR_EraseRootFromParent_Done,
     /*   31322 */   // Label 565: @31322
     /*   31322 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(31375), // Rule ID 46103 //
     /*   31327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31338 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   31338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   31355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31373 */     GIR_RootConstrainSelectedInstOperands,
     /*   31374 */     // GIR_Coverage, 46103,
     /*   31374 */     GIR_EraseRootFromParent_Done,
     /*   31375 */   // Label 566: @31375
     /*   31375 */   GIM_Reject,
     /*   31376 */ // Label 560: @31376
     /*   31376 */ GIM_Reject,
     /*   31377 */ // Label 137: @31377
     /*   31377 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(34501),
     /*   31382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31392 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(31488), // Rule ID 70842 //
     /*   31397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31416 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31430 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31445 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31449 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31451 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31462 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   31465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31486 */     GIR_RootConstrainSelectedInstOperands,
     /*   31487 */     // GIR_Coverage, 70842,
     /*   31487 */     GIR_EraseRootFromParent_Done,
     /*   31488 */   // Label 568: @31488
     /*   31488 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(31584), // Rule ID 70843 //
     /*   31493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31512 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31526 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31541 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31545 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31547 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31558 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   31561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31582 */     GIR_RootConstrainSelectedInstOperands,
     /*   31583 */     // GIR_Coverage, 70843,
     /*   31583 */     GIR_EraseRootFromParent_Done,
     /*   31584 */   // Label 569: @31584
     /*   31584 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(31680), // Rule ID 71086 //
     /*   31589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31608 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31622 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31637 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31641 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31643 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31654 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31678 */     GIR_RootConstrainSelectedInstOperands,
     /*   31679 */     // GIR_Coverage, 71086,
     /*   31679 */     GIR_EraseRootFromParent_Done,
     /*   31680 */   // Label 570: @31680
     /*   31680 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(31776), // Rule ID 71087 //
     /*   31685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31704 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31718 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31733 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31737 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31739 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31750 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31774 */     GIR_RootConstrainSelectedInstOperands,
     /*   31775 */     // GIR_Coverage, 71087,
     /*   31775 */     GIR_EraseRootFromParent_Done,
     /*   31776 */   // Label 571: @31776
     /*   31776 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(31872), // Rule ID 71088 //
     /*   31781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31800 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31814 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31829 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31833 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31835 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31846 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   31857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   31861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31870 */     GIR_RootConstrainSelectedInstOperands,
     /*   31871 */     // GIR_Coverage, 71088,
     /*   31871 */     GIR_EraseRootFromParent_Done,
     /*   31872 */   // Label 572: @31872
     /*   31872 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(31968), // Rule ID 71089 //
     /*   31877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31910 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31925 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31929 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31931 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31942 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   31953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   31957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31966 */     GIR_RootConstrainSelectedInstOperands,
     /*   31967 */     // GIR_Coverage, 71089,
     /*   31967 */     GIR_EraseRootFromParent_Done,
     /*   31968 */   // Label 573: @31968
     /*   31968 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(32064), // Rule ID 70956 //
     /*   31973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31992 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32006 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32021 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32025 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32027 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32038 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32062 */     GIR_RootConstrainSelectedInstOperands,
     /*   32063 */     // GIR_Coverage, 70956,
     /*   32063 */     GIR_EraseRootFromParent_Done,
     /*   32064 */   // Label 574: @32064
     /*   32064 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(32160), // Rule ID 70957 //
     /*   32069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32088 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32102 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32117 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32121 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32123 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32134 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32158 */     GIR_RootConstrainSelectedInstOperands,
     /*   32159 */     // GIR_Coverage, 70957,
     /*   32159 */     GIR_EraseRootFromParent_Done,
     /*   32160 */   // Label 575: @32160
     /*   32160 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(32256), // Rule ID 52040 //
     /*   32165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32188 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32202 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32217 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32221 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32223 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32230 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32254 */     GIR_RootConstrainSelectedInstOperands,
     /*   32255 */     // GIR_Coverage, 52040,
     /*   32255 */     GIR_EraseRootFromParent_Done,
     /*   32256 */   // Label 576: @32256
     /*   32256 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(32352), // Rule ID 52041 //
     /*   32261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32284 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32298 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32313 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32317 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32319 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32326 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32350 */     GIR_RootConstrainSelectedInstOperands,
     /*   32351 */     // GIR_Coverage, 52041,
     /*   32351 */     GIR_EraseRootFromParent_Done,
     /*   32352 */   // Label 577: @32352
     /*   32352 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(32448), // Rule ID 52158 //
     /*   32357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32380 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32394 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32396 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32409 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32413 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32415 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32422 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32446 */     GIR_RootConstrainSelectedInstOperands,
     /*   32447 */     // GIR_Coverage, 52158,
     /*   32447 */     GIR_EraseRootFromParent_Done,
     /*   32448 */   // Label 578: @32448
     /*   32448 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(32544), // Rule ID 52159 //
     /*   32453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32476 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32490 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32505 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32509 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32511 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32518 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32542 */     GIR_RootConstrainSelectedInstOperands,
     /*   32543 */     // GIR_Coverage, 52159,
     /*   32543 */     GIR_EraseRootFromParent_Done,
     /*   32544 */   // Label 579: @32544
     /*   32544 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(32640), // Rule ID 71084 //
     /*   32549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32572 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32586 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32601 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32605 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32607 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32614 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   32625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   32629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32638 */     GIR_RootConstrainSelectedInstOperands,
     /*   32639 */     // GIR_Coverage, 71084,
     /*   32639 */     GIR_EraseRootFromParent_Done,
     /*   32640 */   // Label 580: @32640
     /*   32640 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(32736), // Rule ID 71085 //
     /*   32645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32668 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32682 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32697 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32701 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32703 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32710 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   32721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   32725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32734 */     GIR_RootConstrainSelectedInstOperands,
     /*   32735 */     // GIR_Coverage, 71085,
     /*   32735 */     GIR_EraseRootFromParent_Done,
     /*   32736 */   // Label 581: @32736
     /*   32736 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(32832), // Rule ID 52098 //
     /*   32741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32764 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32778 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32793 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32797 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32799 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32804 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32806 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32830 */     GIR_RootConstrainSelectedInstOperands,
     /*   32831 */     // GIR_Coverage, 52098,
     /*   32831 */     GIR_EraseRootFromParent_Done,
     /*   32832 */   // Label 582: @32832
     /*   32832 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(32928), // Rule ID 52099 //
     /*   32837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32860 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32874 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32889 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32893 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32895 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32900 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32902 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32926 */     GIR_RootConstrainSelectedInstOperands,
     /*   32927 */     // GIR_Coverage, 52099,
     /*   32927 */     GIR_EraseRootFromParent_Done,
     /*   32928 */   // Label 583: @32928
     /*   32928 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(33017), // Rule ID 46688 //
     /*   32933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   32944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32948 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   32959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   32963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32967 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32976 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   32976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   32979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   32993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33015 */     GIR_RootConstrainSelectedInstOperands,
     /*   33016 */     // GIR_Coverage, 46688,
     /*   33016 */     GIR_EraseRootFromParent_Done,
     /*   33017 */   // Label 584: @33017
     /*   33017 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(33106), // Rule ID 46689 //
     /*   33022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33037 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33056 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33065 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33104 */     GIR_RootConstrainSelectedInstOperands,
     /*   33105 */     // GIR_Coverage, 46689,
     /*   33105 */     GIR_EraseRootFromParent_Done,
     /*   33106 */   // Label 585: @33106
     /*   33106 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(33195), // Rule ID 46452 //
     /*   33111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33145 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33154 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   33171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33193 */     GIR_RootConstrainSelectedInstOperands,
     /*   33194 */     // GIR_Coverage, 46452,
     /*   33194 */     GIR_EraseRootFromParent_Done,
     /*   33195 */   // Label 586: @33195
     /*   33195 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(33284), // Rule ID 46453 //
     /*   33200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33215 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33234 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33243 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   33260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33282 */     GIR_RootConstrainSelectedInstOperands,
     /*   33283 */     // GIR_Coverage, 46453,
     /*   33283 */     GIR_EraseRootFromParent_Done,
     /*   33284 */   // Label 587: @33284
     /*   33284 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(33373), // Rule ID 46568 //
     /*   33289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33304 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33323 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33332 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33371 */     GIR_RootConstrainSelectedInstOperands,
     /*   33372 */     // GIR_Coverage, 46568,
     /*   33372 */     GIR_EraseRootFromParent_Done,
     /*   33373 */   // Label 588: @33373
     /*   33373 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(33462), // Rule ID 46569 //
     /*   33378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33393 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33412 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33421 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33460 */     GIR_RootConstrainSelectedInstOperands,
     /*   33461 */     // GIR_Coverage, 46569,
     /*   33461 */     GIR_EraseRootFromParent_Done,
     /*   33462 */   // Label 589: @33462
     /*   33462 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(33530), // Rule ID 70676 //
     /*   33467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33504 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   33504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33528 */     GIR_RootConstrainSelectedInstOperands,
     /*   33529 */     // GIR_Coverage, 70676,
     /*   33529 */     GIR_EraseRootFromParent_Done,
     /*   33530 */   // Label 590: @33530
     /*   33530 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(33598), // Rule ID 70677 //
     /*   33535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33554 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33572 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   33572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33596 */     GIR_RootConstrainSelectedInstOperands,
     /*   33597 */     // GIR_Coverage, 70677,
     /*   33597 */     GIR_EraseRootFromParent_Done,
     /*   33598 */   // Label 591: @33598
     /*   33598 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(33653), // Rule ID 69644 //
     /*   33603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33618 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33631 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33651 */     GIR_RootConstrainSelectedInstOperands,
     /*   33652 */     // GIR_Coverage, 69644,
     /*   33652 */     GIR_EraseRootFromParent_Done,
     /*   33653 */   // Label 592: @33653
     /*   33653 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(33708), // Rule ID 69645 //
     /*   33658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33673 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33686 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33706 */     GIR_RootConstrainSelectedInstOperands,
     /*   33707 */     // GIR_Coverage, 69645,
     /*   33707 */     GIR_EraseRootFromParent_Done,
     /*   33708 */   // Label 593: @33708
     /*   33708 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(33763), // Rule ID 69464 //
     /*   33713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33728 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33741 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   33744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33761 */     GIR_RootConstrainSelectedInstOperands,
     /*   33762 */     // GIR_Coverage, 69464,
     /*   33762 */     GIR_EraseRootFromParent_Done,
     /*   33763 */   // Label 594: @33763
     /*   33763 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(33818), // Rule ID 69465 //
     /*   33768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33783 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33796 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   33799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33816 */     GIR_RootConstrainSelectedInstOperands,
     /*   33817 */     // GIR_Coverage, 69465,
     /*   33817 */     GIR_EraseRootFromParent_Done,
     /*   33818 */   // Label 595: @33818
     /*   33818 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(33873), // Rule ID 69554 //
     /*   33823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33838 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33851 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33871 */     GIR_RootConstrainSelectedInstOperands,
     /*   33872 */     // GIR_Coverage, 69554,
     /*   33872 */     GIR_EraseRootFromParent_Done,
     /*   33873 */   // Label 596: @33873
     /*   33873 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(33928), // Rule ID 69555 //
     /*   33878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33893 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33906 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33926 */     GIR_RootConstrainSelectedInstOperands,
     /*   33927 */     // GIR_Coverage, 69555,
     /*   33927 */     GIR_EraseRootFromParent_Done,
     /*   33928 */   // Label 597: @33928
     /*   33928 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(33996), // Rule ID 51890 //
     /*   33933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33970 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   33970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   33985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33994 */     GIR_RootConstrainSelectedInstOperands,
     /*   33995 */     // GIR_Coverage, 51890,
     /*   33995 */     GIR_EraseRootFromParent_Done,
     /*   33996 */   // Label 598: @33996
     /*   33996 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(34064), // Rule ID 51891 //
     /*   34001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   34024 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34038 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   34041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   34047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34062 */     GIR_RootConstrainSelectedInstOperands,
     /*   34063 */     // GIR_Coverage, 51891,
     /*   34063 */     GIR_EraseRootFromParent_Done,
     /*   34064 */   // Label 599: @34064
     /*   34064 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(34119), // Rule ID 46748 //
     /*   34069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34088 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34097 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34117 */     GIR_RootConstrainSelectedInstOperands,
     /*   34118 */     // GIR_Coverage, 46748,
     /*   34118 */     GIR_EraseRootFromParent_Done,
     /*   34119 */   // Label 600: @34119
     /*   34119 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(34174), // Rule ID 46749 //
     /*   34124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34143 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34152 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34172 */     GIR_RootConstrainSelectedInstOperands,
     /*   34173 */     // GIR_Coverage, 46749,
     /*   34173 */     GIR_EraseRootFromParent_Done,
     /*   34174 */   // Label 601: @34174
     /*   34174 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(34229), // Rule ID 46508 //
     /*   34179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34198 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34207 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34227 */     GIR_RootConstrainSelectedInstOperands,
     /*   34228 */     // GIR_Coverage, 46508,
     /*   34228 */     GIR_EraseRootFromParent_Done,
     /*   34229 */   // Label 602: @34229
     /*   34229 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(34284), // Rule ID 46509 //
     /*   34234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34253 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34262 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34282 */     GIR_RootConstrainSelectedInstOperands,
     /*   34283 */     // GIR_Coverage, 46509,
     /*   34283 */     GIR_EraseRootFromParent_Done,
     /*   34284 */   // Label 603: @34284
     /*   34284 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(34339), // Rule ID 46628 //
     /*   34289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34308 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34317 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34337 */     GIR_RootConstrainSelectedInstOperands,
     /*   34338 */     // GIR_Coverage, 46628,
     /*   34338 */     GIR_EraseRootFromParent_Done,
     /*   34339 */   // Label 604: @34339
     /*   34339 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(34394), // Rule ID 46629 //
     /*   34344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34363 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34372 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34392 */     GIR_RootConstrainSelectedInstOperands,
     /*   34393 */     // GIR_Coverage, 46629,
     /*   34393 */     GIR_EraseRootFromParent_Done,
     /*   34394 */   // Label 605: @34394
     /*   34394 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(34447), // Rule ID 46122 //
     /*   34399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34410 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   34410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   34413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   34427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34445 */     GIR_RootConstrainSelectedInstOperands,
     /*   34446 */     // GIR_Coverage, 46122,
     /*   34446 */     GIR_EraseRootFromParent_Done,
     /*   34447 */   // Label 606: @34447
     /*   34447 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(34500), // Rule ID 46123 //
     /*   34452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34463 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   34463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   34466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   34480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34498 */     GIR_RootConstrainSelectedInstOperands,
     /*   34499 */     // GIR_Coverage, 46123,
     /*   34499 */     GIR_EraseRootFromParent_Done,
     /*   34500 */   // Label 607: @34500
     /*   34500 */   GIM_Reject,
     /*   34501 */ // Label 567: @34501
     /*   34501 */ GIM_Reject,
     /*   34502 */ // Label 138: @34502
     /*   34502 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37626),
     /*   34507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34517 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(34613), // Rule ID 70854 //
     /*   34522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34555 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34570 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34574 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34576 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34587 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   34590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34611 */     GIR_RootConstrainSelectedInstOperands,
     /*   34612 */     // GIR_Coverage, 70854,
     /*   34612 */     GIR_EraseRootFromParent_Done,
     /*   34613 */   // Label 609: @34613
     /*   34613 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(34709), // Rule ID 70855 //
     /*   34618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34637 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34651 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34666 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34670 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34672 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34683 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   34686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34707 */     GIR_RootConstrainSelectedInstOperands,
     /*   34708 */     // GIR_Coverage, 70855,
     /*   34708 */     GIR_EraseRootFromParent_Done,
     /*   34709 */   // Label 610: @34709
     /*   34709 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(34805), // Rule ID 71122 //
     /*   34714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34733 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34747 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34762 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34766 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34779 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   34782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34803 */     GIR_RootConstrainSelectedInstOperands,
     /*   34804 */     // GIR_Coverage, 71122,
     /*   34804 */     GIR_EraseRootFromParent_Done,
     /*   34805 */   // Label 611: @34805
     /*   34805 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(34901), // Rule ID 71123 //
     /*   34810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34829 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34843 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34858 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34862 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34864 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34875 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   34878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34899 */     GIR_RootConstrainSelectedInstOperands,
     /*   34900 */     // GIR_Coverage, 71123,
     /*   34900 */     GIR_EraseRootFromParent_Done,
     /*   34901 */   // Label 612: @34901
     /*   34901 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(34997), // Rule ID 71124 //
     /*   34906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34925 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34939 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34958 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34960 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34971 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   34974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   34982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   34986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34995 */     GIR_RootConstrainSelectedInstOperands,
     /*   34996 */     // GIR_Coverage, 71124,
     /*   34996 */     GIR_EraseRootFromParent_Done,
     /*   34997 */   // Label 613: @34997
     /*   34997 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(35093), // Rule ID 71125 //
     /*   35002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35021 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35035 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35054 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35056 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35067 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35091 */     GIR_RootConstrainSelectedInstOperands,
     /*   35092 */     // GIR_Coverage, 71125,
     /*   35092 */     GIR_EraseRootFromParent_Done,
     /*   35093 */   // Label 614: @35093
     /*   35093 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(35189), // Rule ID 70968 //
     /*   35098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35117 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35131 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35146 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35150 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35152 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35163 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35187 */     GIR_RootConstrainSelectedInstOperands,
     /*   35188 */     // GIR_Coverage, 70968,
     /*   35188 */     GIR_EraseRootFromParent_Done,
     /*   35189 */   // Label 615: @35189
     /*   35189 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(35285), // Rule ID 70969 //
     /*   35194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35213 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35227 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35242 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35246 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35248 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35259 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35283 */     GIR_RootConstrainSelectedInstOperands,
     /*   35284 */     // GIR_Coverage, 70969,
     /*   35284 */     GIR_EraseRootFromParent_Done,
     /*   35285 */   // Label 616: @35285
     /*   35285 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(35381), // Rule ID 52052 //
     /*   35290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35313 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35327 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35342 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35346 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35348 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35353 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35355 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35379 */     GIR_RootConstrainSelectedInstOperands,
     /*   35380 */     // GIR_Coverage, 52052,
     /*   35380 */     GIR_EraseRootFromParent_Done,
     /*   35381 */   // Label 617: @35381
     /*   35381 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(35477), // Rule ID 52053 //
     /*   35386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35409 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35423 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35438 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35442 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35444 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35449 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35451 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35475 */     GIR_RootConstrainSelectedInstOperands,
     /*   35476 */     // GIR_Coverage, 52053,
     /*   35476 */     GIR_EraseRootFromParent_Done,
     /*   35477 */   // Label 618: @35477
     /*   35477 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(35573), // Rule ID 52170 //
     /*   35482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35505 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35519 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35534 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35538 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35540 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35547 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35571 */     GIR_RootConstrainSelectedInstOperands,
     /*   35572 */     // GIR_Coverage, 52170,
     /*   35572 */     GIR_EraseRootFromParent_Done,
     /*   35573 */   // Label 619: @35573
     /*   35573 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(35669), // Rule ID 52171 //
     /*   35578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35601 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35615 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35617 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35630 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35634 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35636 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35643 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35667 */     GIR_RootConstrainSelectedInstOperands,
     /*   35668 */     // GIR_Coverage, 52171,
     /*   35668 */     GIR_EraseRootFromParent_Done,
     /*   35669 */   // Label 620: @35669
     /*   35669 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(35765), // Rule ID 71120 //
     /*   35674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35711 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35730 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35732 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35737 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35739 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35763 */     GIR_RootConstrainSelectedInstOperands,
     /*   35764 */     // GIR_Coverage, 71120,
     /*   35764 */     GIR_EraseRootFromParent_Done,
     /*   35765 */   // Label 621: @35765
     /*   35765 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(35861), // Rule ID 71121 //
     /*   35770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35793 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35807 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35826 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35828 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35835 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35859 */     GIR_RootConstrainSelectedInstOperands,
     /*   35860 */     // GIR_Coverage, 71121,
     /*   35860 */     GIR_EraseRootFromParent_Done,
     /*   35861 */   // Label 622: @35861
     /*   35861 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(35957), // Rule ID 52110 //
     /*   35866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35889 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35903 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35918 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35922 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35924 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35931 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35955 */     GIR_RootConstrainSelectedInstOperands,
     /*   35956 */     // GIR_Coverage, 52110,
     /*   35956 */     GIR_EraseRootFromParent_Done,
     /*   35957 */   // Label 623: @35957
     /*   35957 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(36053), // Rule ID 52111 //
     /*   35962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35985 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35999 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   36010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36014 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36018 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36020 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36027 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   36030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   36042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36051 */     GIR_RootConstrainSelectedInstOperands,
     /*   36052 */     // GIR_Coverage, 52111,
     /*   36052 */     GIR_EraseRootFromParent_Done,
     /*   36053 */   // Label 624: @36053
     /*   36053 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(36142), // Rule ID 46712 //
     /*   36058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36073 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36092 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36101 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36140 */     GIR_RootConstrainSelectedInstOperands,
     /*   36141 */     // GIR_Coverage, 46712,
     /*   36141 */     GIR_EraseRootFromParent_Done,
     /*   36142 */   // Label 625: @36142
     /*   36142 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(36231), // Rule ID 46713 //
     /*   36147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36162 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36181 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36190 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36229 */     GIR_RootConstrainSelectedInstOperands,
     /*   36230 */     // GIR_Coverage, 46713,
     /*   36230 */     GIR_EraseRootFromParent_Done,
     /*   36231 */   // Label 626: @36231
     /*   36231 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(36320), // Rule ID 46476 //
     /*   36236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36270 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36279 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   36296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36318 */     GIR_RootConstrainSelectedInstOperands,
     /*   36319 */     // GIR_Coverage, 46476,
     /*   36319 */     GIR_EraseRootFromParent_Done,
     /*   36320 */   // Label 627: @36320
     /*   36320 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(36409), // Rule ID 46477 //
     /*   36325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36340 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36359 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36368 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   36385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36407 */     GIR_RootConstrainSelectedInstOperands,
     /*   36408 */     // GIR_Coverage, 46477,
     /*   36408 */     GIR_EraseRootFromParent_Done,
     /*   36409 */   // Label 628: @36409
     /*   36409 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(36498), // Rule ID 46592 //
     /*   36414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36429 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36448 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36457 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36496 */     GIR_RootConstrainSelectedInstOperands,
     /*   36497 */     // GIR_Coverage, 46592,
     /*   36497 */     GIR_EraseRootFromParent_Done,
     /*   36498 */   // Label 629: @36498
     /*   36498 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(36587), // Rule ID 46593 //
     /*   36503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36518 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36537 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36546 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36585 */     GIR_RootConstrainSelectedInstOperands,
     /*   36586 */     // GIR_Coverage, 46593,
     /*   36586 */     GIR_EraseRootFromParent_Done,
     /*   36587 */   // Label 630: @36587
     /*   36587 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(36655), // Rule ID 70748 //
     /*   36592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36629 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   36629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   36632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36653 */     GIR_RootConstrainSelectedInstOperands,
     /*   36654 */     // GIR_Coverage, 70748,
     /*   36654 */     GIR_EraseRootFromParent_Done,
     /*   36655 */   // Label 631: @36655
     /*   36655 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(36723), // Rule ID 70749 //
     /*   36660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36679 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36697 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   36697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   36700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36721 */     GIR_RootConstrainSelectedInstOperands,
     /*   36722 */     // GIR_Coverage, 70749,
     /*   36722 */     GIR_EraseRootFromParent_Done,
     /*   36723 */   // Label 632: @36723
     /*   36723 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(36778), // Rule ID 69668 //
     /*   36728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36743 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36756 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   36759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36776 */     GIR_RootConstrainSelectedInstOperands,
     /*   36777 */     // GIR_Coverage, 69668,
     /*   36777 */     GIR_EraseRootFromParent_Done,
     /*   36778 */   // Label 633: @36778
     /*   36778 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(36833), // Rule ID 69669 //
     /*   36783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36811 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   36814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36831 */     GIR_RootConstrainSelectedInstOperands,
     /*   36832 */     // GIR_Coverage, 69669,
     /*   36832 */     GIR_EraseRootFromParent_Done,
     /*   36833 */   // Label 634: @36833
     /*   36833 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(36888), // Rule ID 69488 //
     /*   36838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36853 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36866 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   36869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36886 */     GIR_RootConstrainSelectedInstOperands,
     /*   36887 */     // GIR_Coverage, 69488,
     /*   36887 */     GIR_EraseRootFromParent_Done,
     /*   36888 */   // Label 635: @36888
     /*   36888 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(36943), // Rule ID 69489 //
     /*   36893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36921 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   36924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36941 */     GIR_RootConstrainSelectedInstOperands,
     /*   36942 */     // GIR_Coverage, 69489,
     /*   36942 */     GIR_EraseRootFromParent_Done,
     /*   36943 */   // Label 636: @36943
     /*   36943 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(36998), // Rule ID 69578 //
     /*   36948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36963 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36976 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   36979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36996 */     GIR_RootConstrainSelectedInstOperands,
     /*   36997 */     // GIR_Coverage, 69578,
     /*   36997 */     GIR_EraseRootFromParent_Done,
     /*   36998 */   // Label 637: @36998
     /*   36998 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(37053), // Rule ID 69579 //
     /*   37003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37018 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37031 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37051 */     GIR_RootConstrainSelectedInstOperands,
     /*   37052 */     // GIR_Coverage, 69579,
     /*   37052 */     GIR_EraseRootFromParent_Done,
     /*   37053 */   // Label 638: @37053
     /*   37053 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(37121), // Rule ID 51926 //
     /*   37058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37081 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37095 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37119 */     GIR_RootConstrainSelectedInstOperands,
     /*   37120 */     // GIR_Coverage, 51926,
     /*   37120 */     GIR_EraseRootFromParent_Done,
     /*   37121 */   // Label 639: @37121
     /*   37121 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(37189), // Rule ID 51927 //
     /*   37126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37163 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37187 */     GIR_RootConstrainSelectedInstOperands,
     /*   37188 */     // GIR_Coverage, 51927,
     /*   37188 */     GIR_EraseRootFromParent_Done,
     /*   37189 */   // Label 640: @37189
     /*   37189 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(37244), // Rule ID 46772 //
     /*   37194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37213 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37222 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37242 */     GIR_RootConstrainSelectedInstOperands,
     /*   37243 */     // GIR_Coverage, 46772,
     /*   37243 */     GIR_EraseRootFromParent_Done,
     /*   37244 */   // Label 641: @37244
     /*   37244 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(37299), // Rule ID 46773 //
     /*   37249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37268 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37277 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37297 */     GIR_RootConstrainSelectedInstOperands,
     /*   37298 */     // GIR_Coverage, 46773,
     /*   37298 */     GIR_EraseRootFromParent_Done,
     /*   37299 */   // Label 642: @37299
     /*   37299 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(37354), // Rule ID 46532 //
     /*   37304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37323 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37332 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37352 */     GIR_RootConstrainSelectedInstOperands,
     /*   37353 */     // GIR_Coverage, 46532,
     /*   37353 */     GIR_EraseRootFromParent_Done,
     /*   37354 */   // Label 643: @37354
     /*   37354 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(37409), // Rule ID 46533 //
     /*   37359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37378 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37387 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37407 */     GIR_RootConstrainSelectedInstOperands,
     /*   37408 */     // GIR_Coverage, 46533,
     /*   37408 */     GIR_EraseRootFromParent_Done,
     /*   37409 */   // Label 644: @37409
     /*   37409 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(37464), // Rule ID 46652 //
     /*   37414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37433 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37442 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37462 */     GIR_RootConstrainSelectedInstOperands,
     /*   37463 */     // GIR_Coverage, 46652,
     /*   37463 */     GIR_EraseRootFromParent_Done,
     /*   37464 */   // Label 645: @37464
     /*   37464 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(37519), // Rule ID 46653 //
     /*   37469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37488 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37497 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37517 */     GIR_RootConstrainSelectedInstOperands,
     /*   37518 */     // GIR_Coverage, 46653,
     /*   37518 */     GIR_EraseRootFromParent_Done,
     /*   37519 */   // Label 646: @37519
     /*   37519 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(37572), // Rule ID 46158 //
     /*   37524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37535 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   37535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   37538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   37542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   37552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   37559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37570 */     GIR_RootConstrainSelectedInstOperands,
     /*   37571 */     // GIR_Coverage, 46158,
     /*   37571 */     GIR_EraseRootFromParent_Done,
     /*   37572 */   // Label 647: @37572
     /*   37572 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(37625), // Rule ID 46159 //
     /*   37577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37588 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   37588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   37591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   37595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   37605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   37612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37623 */     GIR_RootConstrainSelectedInstOperands,
     /*   37624 */     // GIR_Coverage, 46159,
     /*   37624 */     GIR_EraseRootFromParent_Done,
     /*   37625 */   // Label 648: @37625
     /*   37625 */   GIM_Reject,
     /*   37626 */ // Label 608: @37626
     /*   37626 */ GIM_Reject,
     /*   37627 */ // Label 139: @37627
     /*   37627 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(40751),
     /*   37632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37642 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(37738), // Rule ID 70864 //
     /*   37647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   37650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37680 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37695 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37699 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37701 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37712 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   37715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37736 */     GIR_RootConstrainSelectedInstOperands,
     /*   37737 */     // GIR_Coverage, 70864,
     /*   37737 */     GIR_EraseRootFromParent_Done,
     /*   37738 */   // Label 650: @37738
     /*   37738 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(37834), // Rule ID 70865 //
     /*   37743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   37746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37762 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37776 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37791 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37795 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37797 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37808 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   37811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37832 */     GIR_RootConstrainSelectedInstOperands,
     /*   37833 */     // GIR_Coverage, 70865,
     /*   37833 */     GIR_EraseRootFromParent_Done,
     /*   37834 */   // Label 651: @37834
     /*   37834 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(37930), // Rule ID 71152 //
     /*   37839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   37842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37858 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37872 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37887 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37891 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37893 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37904 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   37907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37928 */     GIR_RootConstrainSelectedInstOperands,
     /*   37929 */     // GIR_Coverage, 71152,
     /*   37929 */     GIR_EraseRootFromParent_Done,
     /*   37930 */   // Label 652: @37930
     /*   37930 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(38026), // Rule ID 71153 //
     /*   37935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   37938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37954 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37968 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37983 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37987 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37989 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38000 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38024 */     GIR_RootConstrainSelectedInstOperands,
     /*   38025 */     // GIR_Coverage, 71153,
     /*   38025 */     GIR_EraseRootFromParent_Done,
     /*   38026 */   // Label 653: @38026
     /*   38026 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(38122), // Rule ID 71154 //
     /*   38031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38050 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38064 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38079 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38083 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38085 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38096 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38120 */     GIR_RootConstrainSelectedInstOperands,
     /*   38121 */     // GIR_Coverage, 71154,
     /*   38121 */     GIR_EraseRootFromParent_Done,
     /*   38122 */   // Label 654: @38122
     /*   38122 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(38218), // Rule ID 71155 //
     /*   38127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38146 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38160 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38167 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38171 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38175 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38179 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38181 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38192 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38216 */     GIR_RootConstrainSelectedInstOperands,
     /*   38217 */     // GIR_Coverage, 71155,
     /*   38217 */     GIR_EraseRootFromParent_Done,
     /*   38218 */   // Label 655: @38218
     /*   38218 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(38314), // Rule ID 70978 //
     /*   38223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38242 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38256 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38258 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38271 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38275 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38277 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38286 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38288 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   38291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38312 */     GIR_RootConstrainSelectedInstOperands,
     /*   38313 */     // GIR_Coverage, 70978,
     /*   38313 */     GIR_EraseRootFromParent_Done,
     /*   38314 */   // Label 656: @38314
     /*   38314 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(38410), // Rule ID 70979 //
     /*   38319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38338 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38352 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38367 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38371 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38373 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38384 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   38387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38408 */     GIR_RootConstrainSelectedInstOperands,
     /*   38409 */     // GIR_Coverage, 70979,
     /*   38409 */     GIR_EraseRootFromParent_Done,
     /*   38410 */   // Label 657: @38410
     /*   38410 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(38506), // Rule ID 52062 //
     /*   38415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38438 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38452 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38467 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38471 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38473 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38480 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38504 */     GIR_RootConstrainSelectedInstOperands,
     /*   38505 */     // GIR_Coverage, 52062,
     /*   38505 */     GIR_EraseRootFromParent_Done,
     /*   38506 */   // Label 658: @38506
     /*   38506 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(38602), // Rule ID 52063 //
     /*   38511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38534 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38548 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38563 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38567 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38569 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38576 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38600 */     GIR_RootConstrainSelectedInstOperands,
     /*   38601 */     // GIR_Coverage, 52063,
     /*   38601 */     GIR_EraseRootFromParent_Done,
     /*   38602 */   // Label 659: @38602
     /*   38602 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(38698), // Rule ID 52180 //
     /*   38607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38630 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38644 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38659 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38663 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38665 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38670 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38672 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38696 */     GIR_RootConstrainSelectedInstOperands,
     /*   38697 */     // GIR_Coverage, 52180,
     /*   38697 */     GIR_EraseRootFromParent_Done,
     /*   38698 */   // Label 660: @38698
     /*   38698 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(38794), // Rule ID 52181 //
     /*   38703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38740 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38747 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38751 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38755 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38759 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38761 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38768 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38792 */     GIR_RootConstrainSelectedInstOperands,
     /*   38793 */     // GIR_Coverage, 52181,
     /*   38793 */     GIR_EraseRootFromParent_Done,
     /*   38794 */   // Label 661: @38794
     /*   38794 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(38890), // Rule ID 71150 //
     /*   38799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38822 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38836 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38851 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38855 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38857 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38864 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38888 */     GIR_RootConstrainSelectedInstOperands,
     /*   38889 */     // GIR_Coverage, 71150,
     /*   38889 */     GIR_EraseRootFromParent_Done,
     /*   38890 */   // Label 662: @38890
     /*   38890 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(38986), // Rule ID 71151 //
     /*   38895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38932 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38943 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38947 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38951 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38953 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38960 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38984 */     GIR_RootConstrainSelectedInstOperands,
     /*   38985 */     // GIR_Coverage, 71151,
     /*   38985 */     GIR_EraseRootFromParent_Done,
     /*   38986 */   // Label 663: @38986
     /*   38986 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(39082), // Rule ID 52120 //
     /*   38991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39014 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39028 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39043 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39047 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39049 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39056 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   39059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39080 */     GIR_RootConstrainSelectedInstOperands,
     /*   39081 */     // GIR_Coverage, 52120,
     /*   39081 */     GIR_EraseRootFromParent_Done,
     /*   39082 */   // Label 664: @39082
     /*   39082 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(39178), // Rule ID 52121 //
     /*   39087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39110 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39124 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39139 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39143 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39145 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39152 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   39155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39176 */     GIR_RootConstrainSelectedInstOperands,
     /*   39177 */     // GIR_Coverage, 52121,
     /*   39177 */     GIR_EraseRootFromParent_Done,
     /*   39178 */   // Label 665: @39178
     /*   39178 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(39267), // Rule ID 46732 //
     /*   39183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39198 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39217 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39226 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39265 */     GIR_RootConstrainSelectedInstOperands,
     /*   39266 */     // GIR_Coverage, 46732,
     /*   39266 */     GIR_EraseRootFromParent_Done,
     /*   39267 */   // Label 666: @39267
     /*   39267 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(39356), // Rule ID 46733 //
     /*   39272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39287 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39315 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39354 */     GIR_RootConstrainSelectedInstOperands,
     /*   39355 */     // GIR_Coverage, 46733,
     /*   39355 */     GIR_EraseRootFromParent_Done,
     /*   39356 */   // Label 667: @39356
     /*   39356 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(39445), // Rule ID 46496 //
     /*   39361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39376 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39395 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39404 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   39421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39443 */     GIR_RootConstrainSelectedInstOperands,
     /*   39444 */     // GIR_Coverage, 46496,
     /*   39444 */     GIR_EraseRootFromParent_Done,
     /*   39445 */   // Label 668: @39445
     /*   39445 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(39534), // Rule ID 46497 //
     /*   39450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39465 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39484 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39493 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   39510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39532 */     GIR_RootConstrainSelectedInstOperands,
     /*   39533 */     // GIR_Coverage, 46497,
     /*   39533 */     GIR_EraseRootFromParent_Done,
     /*   39534 */   // Label 669: @39534
     /*   39534 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(39623), // Rule ID 46612 //
     /*   39539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39554 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39573 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39582 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39621 */     GIR_RootConstrainSelectedInstOperands,
     /*   39622 */     // GIR_Coverage, 46612,
     /*   39622 */     GIR_EraseRootFromParent_Done,
     /*   39623 */   // Label 670: @39623
     /*   39623 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(39712), // Rule ID 46613 //
     /*   39628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39643 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39662 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39671 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39710 */     GIR_RootConstrainSelectedInstOperands,
     /*   39711 */     // GIR_Coverage, 46613,
     /*   39711 */     GIR_EraseRootFromParent_Done,
     /*   39712 */   // Label 671: @39712
     /*   39712 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(39780), // Rule ID 70780 //
     /*   39717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   39720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39754 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   39754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   39757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   39763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   39775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39778 */     GIR_RootConstrainSelectedInstOperands,
     /*   39779 */     // GIR_Coverage, 70780,
     /*   39779 */     GIR_EraseRootFromParent_Done,
     /*   39780 */   // Label 672: @39780
     /*   39780 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(39848), // Rule ID 70781 //
     /*   39785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   39788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39804 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39822 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   39822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   39825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   39831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   39843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39846 */     GIR_RootConstrainSelectedInstOperands,
     /*   39847 */     // GIR_Coverage, 70781,
     /*   39847 */     GIR_EraseRootFromParent_Done,
     /*   39848 */   // Label 673: @39848
     /*   39848 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(39903), // Rule ID 69688 //
     /*   39853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39868 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39881 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   39884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39901 */     GIR_RootConstrainSelectedInstOperands,
     /*   39902 */     // GIR_Coverage, 69688,
     /*   39902 */     GIR_EraseRootFromParent_Done,
     /*   39903 */   // Label 674: @39903
     /*   39903 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(39958), // Rule ID 69689 //
     /*   39908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39923 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39936 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   39939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39956 */     GIR_RootConstrainSelectedInstOperands,
     /*   39957 */     // GIR_Coverage, 69689,
     /*   39957 */     GIR_EraseRootFromParent_Done,
     /*   39958 */   // Label 675: @39958
     /*   39958 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(40013), // Rule ID 69508 //
     /*   39963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39978 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39991 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   39994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40011 */     GIR_RootConstrainSelectedInstOperands,
     /*   40012 */     // GIR_Coverage, 69508,
     /*   40012 */     GIR_EraseRootFromParent_Done,
     /*   40013 */   // Label 676: @40013
     /*   40013 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(40068), // Rule ID 69509 //
     /*   40018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40033 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40046 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40066 */     GIR_RootConstrainSelectedInstOperands,
     /*   40067 */     // GIR_Coverage, 69509,
     /*   40067 */     GIR_EraseRootFromParent_Done,
     /*   40068 */   // Label 677: @40068
     /*   40068 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(40123), // Rule ID 69598 //
     /*   40073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40088 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40101 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40121 */     GIR_RootConstrainSelectedInstOperands,
     /*   40122 */     // GIR_Coverage, 69598,
     /*   40122 */     GIR_EraseRootFromParent_Done,
     /*   40123 */   // Label 678: @40123
     /*   40123 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(40178), // Rule ID 69599 //
     /*   40128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40143 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40156 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40176 */     GIR_RootConstrainSelectedInstOperands,
     /*   40177 */     // GIR_Coverage, 69599,
     /*   40177 */     GIR_EraseRootFromParent_Done,
     /*   40178 */   // Label 679: @40178
     /*   40178 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(40246), // Rule ID 51942 //
     /*   40183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   40186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40220 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   40220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40244 */     GIR_RootConstrainSelectedInstOperands,
     /*   40245 */     // GIR_Coverage, 51942,
     /*   40245 */     GIR_EraseRootFromParent_Done,
     /*   40246 */   // Label 680: @40246
     /*   40246 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(40314), // Rule ID 51943 //
     /*   40251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   40254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40274 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40288 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   40288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40312 */     GIR_RootConstrainSelectedInstOperands,
     /*   40313 */     // GIR_Coverage, 51943,
     /*   40313 */     GIR_EraseRootFromParent_Done,
     /*   40314 */   // Label 681: @40314
     /*   40314 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(40369), // Rule ID 46792 //
     /*   40319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40338 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40347 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40367 */     GIR_RootConstrainSelectedInstOperands,
     /*   40368 */     // GIR_Coverage, 46792,
     /*   40368 */     GIR_EraseRootFromParent_Done,
     /*   40369 */   // Label 682: @40369
     /*   40369 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(40424), // Rule ID 46793 //
     /*   40374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40393 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40402 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40422 */     GIR_RootConstrainSelectedInstOperands,
     /*   40423 */     // GIR_Coverage, 46793,
     /*   40423 */     GIR_EraseRootFromParent_Done,
     /*   40424 */   // Label 683: @40424
     /*   40424 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(40479), // Rule ID 46552 //
     /*   40429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40448 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40457 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40477 */     GIR_RootConstrainSelectedInstOperands,
     /*   40478 */     // GIR_Coverage, 46552,
     /*   40478 */     GIR_EraseRootFromParent_Done,
     /*   40479 */   // Label 684: @40479
     /*   40479 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(40534), // Rule ID 46553 //
     /*   40484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40503 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40512 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40532 */     GIR_RootConstrainSelectedInstOperands,
     /*   40533 */     // GIR_Coverage, 46553,
     /*   40533 */     GIR_EraseRootFromParent_Done,
     /*   40534 */   // Label 685: @40534
     /*   40534 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(40589), // Rule ID 46672 //
     /*   40539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40567 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40587 */     GIR_RootConstrainSelectedInstOperands,
     /*   40588 */     // GIR_Coverage, 46672,
     /*   40588 */     GIR_EraseRootFromParent_Done,
     /*   40589 */   // Label 686: @40589
     /*   40589 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(40644), // Rule ID 46673 //
     /*   40594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40613 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40622 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40642 */     GIR_RootConstrainSelectedInstOperands,
     /*   40643 */     // GIR_Coverage, 46673,
     /*   40643 */     GIR_EraseRootFromParent_Done,
     /*   40644 */   // Label 687: @40644
     /*   40644 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(40697), // Rule ID 46174 //
     /*   40649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   40652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40660 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   40660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   40663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   40677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   40684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40695 */     GIR_RootConstrainSelectedInstOperands,
     /*   40696 */     // GIR_Coverage, 46174,
     /*   40696 */     GIR_EraseRootFromParent_Done,
     /*   40697 */   // Label 688: @40697
     /*   40697 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(40750), // Rule ID 46175 //
     /*   40702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   40705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40713 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   40713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   40716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   40730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   40737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40748 */     GIR_RootConstrainSelectedInstOperands,
     /*   40749 */     // GIR_Coverage, 46175,
     /*   40749 */     GIR_EraseRootFromParent_Done,
     /*   40750 */   // Label 689: @40750
     /*   40750 */   GIM_Reject,
     /*   40751 */ // Label 649: @40751
     /*   40751 */ GIM_Reject,
     /*   40752 */ // Label 140: @40752
     /*   40752 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(41146),
     /*   40757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40767 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(40835), // Rule ID 70668 //
     /*   40772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40809 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   40809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   40812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40833 */     GIR_RootConstrainSelectedInstOperands,
     /*   40834 */     // GIR_Coverage, 70668,
     /*   40834 */     GIR_EraseRootFromParent_Done,
     /*   40835 */   // Label 691: @40835
     /*   40835 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(40903), // Rule ID 70669 //
     /*   40840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   40843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40859 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40877 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   40877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   40880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40901 */     GIR_RootConstrainSelectedInstOperands,
     /*   40902 */     // GIR_Coverage, 70669,
     /*   40902 */     GIR_EraseRootFromParent_Done,
     /*   40903 */   // Label 692: @40903
     /*   40903 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(40971), // Rule ID 51886 //
     /*   40908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40945 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   40945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   40948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40969 */     GIR_RootConstrainSelectedInstOperands,
     /*   40970 */     // GIR_Coverage, 51886,
     /*   40970 */     GIR_EraseRootFromParent_Done,
     /*   40971 */   // Label 693: @40971
     /*   40971 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(41039), // Rule ID 51887 //
     /*   40976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   40979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40999 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41013 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   41016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   41022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   41028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41037 */     GIR_RootConstrainSelectedInstOperands,
     /*   41038 */     // GIR_Coverage, 51887,
     /*   41038 */     GIR_EraseRootFromParent_Done,
     /*   41039 */   // Label 694: @41039
     /*   41039 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(41092), // Rule ID 46118 //
     /*   41044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41055 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   41055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   41058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   41072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41090 */     GIR_RootConstrainSelectedInstOperands,
     /*   41091 */     // GIR_Coverage, 46118,
     /*   41091 */     GIR_EraseRootFromParent_Done,
     /*   41092 */   // Label 695: @41092
     /*   41092 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(41145), // Rule ID 46119 //
     /*   41097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41108 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   41108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   41111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   41125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41143 */     GIR_RootConstrainSelectedInstOperands,
     /*   41144 */     // GIR_Coverage, 46119,
     /*   41144 */     GIR_EraseRootFromParent_Done,
     /*   41145 */   // Label 696: @41145
     /*   41145 */   GIM_Reject,
     /*   41146 */ // Label 690: @41146
     /*   41146 */ GIM_Reject,
     /*   41147 */ // Label 141: @41147
     /*   41147 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(44271),
     /*   41152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41162 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(41258), // Rule ID 70844 //
     /*   41167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41186 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41200 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41215 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41219 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41221 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41232 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41256 */     GIR_RootConstrainSelectedInstOperands,
     /*   41257 */     // GIR_Coverage, 70844,
     /*   41257 */     GIR_EraseRootFromParent_Done,
     /*   41258 */   // Label 698: @41258
     /*   41258 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(41354), // Rule ID 70845 //
     /*   41263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41282 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41296 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41311 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41315 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41317 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41328 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41352 */     GIR_RootConstrainSelectedInstOperands,
     /*   41353 */     // GIR_Coverage, 70845,
     /*   41353 */     GIR_EraseRootFromParent_Done,
     /*   41354 */   // Label 699: @41354
     /*   41354 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(41450), // Rule ID 71092 //
     /*   41359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41378 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41392 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41407 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41411 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41413 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41424 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41448 */     GIR_RootConstrainSelectedInstOperands,
     /*   41449 */     // GIR_Coverage, 71092,
     /*   41449 */     GIR_EraseRootFromParent_Done,
     /*   41450 */   // Label 700: @41450
     /*   41450 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(41546), // Rule ID 71093 //
     /*   41455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41474 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41488 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41503 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41507 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41509 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41520 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41544 */     GIR_RootConstrainSelectedInstOperands,
     /*   41545 */     // GIR_Coverage, 71093,
     /*   41545 */     GIR_EraseRootFromParent_Done,
     /*   41546 */   // Label 701: @41546
     /*   41546 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(41642), // Rule ID 71094 //
     /*   41551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41570 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41584 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41599 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41603 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41605 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41616 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   41627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   41631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41640 */     GIR_RootConstrainSelectedInstOperands,
     /*   41641 */     // GIR_Coverage, 71094,
     /*   41641 */     GIR_EraseRootFromParent_Done,
     /*   41642 */   // Label 702: @41642
     /*   41642 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(41738), // Rule ID 71095 //
     /*   41647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41680 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41695 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41699 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41701 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41712 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   41723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   41727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41736 */     GIR_RootConstrainSelectedInstOperands,
     /*   41737 */     // GIR_Coverage, 71095,
     /*   41737 */     GIR_EraseRootFromParent_Done,
     /*   41738 */   // Label 703: @41738
     /*   41738 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(41834), // Rule ID 70958 //
     /*   41743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41762 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41776 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41791 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41795 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41797 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41808 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   41811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41832 */     GIR_RootConstrainSelectedInstOperands,
     /*   41833 */     // GIR_Coverage, 70958,
     /*   41833 */     GIR_EraseRootFromParent_Done,
     /*   41834 */   // Label 704: @41834
     /*   41834 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(41930), // Rule ID 70959 //
     /*   41839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41858 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41872 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41887 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41891 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41893 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41904 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   41907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41928 */     GIR_RootConstrainSelectedInstOperands,
     /*   41929 */     // GIR_Coverage, 70959,
     /*   41929 */     GIR_EraseRootFromParent_Done,
     /*   41930 */   // Label 705: @41930
     /*   41930 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(42026), // Rule ID 52042 //
     /*   41935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41958 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41972 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41987 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41991 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41993 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42000 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   42003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42024 */     GIR_RootConstrainSelectedInstOperands,
     /*   42025 */     // GIR_Coverage, 52042,
     /*   42025 */     GIR_EraseRootFromParent_Done,
     /*   42026 */   // Label 706: @42026
     /*   42026 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(42122), // Rule ID 52043 //
     /*   42031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42054 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42068 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42083 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42087 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42089 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42096 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   42099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42120 */     GIR_RootConstrainSelectedInstOperands,
     /*   42121 */     // GIR_Coverage, 52043,
     /*   42121 */     GIR_EraseRootFromParent_Done,
     /*   42122 */   // Label 707: @42122
     /*   42122 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(42218), // Rule ID 52160 //
     /*   42127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42164 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42183 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42192 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42216 */     GIR_RootConstrainSelectedInstOperands,
     /*   42217 */     // GIR_Coverage, 52160,
     /*   42217 */     GIR_EraseRootFromParent_Done,
     /*   42218 */   // Label 708: @42218
     /*   42218 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(42314), // Rule ID 52161 //
     /*   42223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42260 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42275 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42279 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42281 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42286 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42288 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42312 */     GIR_RootConstrainSelectedInstOperands,
     /*   42313 */     // GIR_Coverage, 52161,
     /*   42313 */     GIR_EraseRootFromParent_Done,
     /*   42314 */   // Label 709: @42314
     /*   42314 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(42410), // Rule ID 71090 //
     /*   42319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42342 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42356 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42371 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42375 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42377 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42384 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42408 */     GIR_RootConstrainSelectedInstOperands,
     /*   42409 */     // GIR_Coverage, 71090,
     /*   42409 */     GIR_EraseRootFromParent_Done,
     /*   42410 */   // Label 710: @42410
     /*   42410 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(42506), // Rule ID 71091 //
     /*   42415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42438 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42452 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42467 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42471 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42473 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42480 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42504 */     GIR_RootConstrainSelectedInstOperands,
     /*   42505 */     // GIR_Coverage, 71091,
     /*   42505 */     GIR_EraseRootFromParent_Done,
     /*   42506 */   // Label 711: @42506
     /*   42506 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(42602), // Rule ID 52100 //
     /*   42511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42534 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42548 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42563 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42567 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42569 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42576 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   42579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42600 */     GIR_RootConstrainSelectedInstOperands,
     /*   42601 */     // GIR_Coverage, 52100,
     /*   42601 */     GIR_EraseRootFromParent_Done,
     /*   42602 */   // Label 712: @42602
     /*   42602 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(42698), // Rule ID 52101 //
     /*   42607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42630 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42644 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42659 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42663 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42665 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42670 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42672 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   42675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42696 */     GIR_RootConstrainSelectedInstOperands,
     /*   42697 */     // GIR_Coverage, 52101,
     /*   42697 */     GIR_EraseRootFromParent_Done,
     /*   42698 */   // Label 713: @42698
     /*   42698 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(42787), // Rule ID 46692 //
     /*   42703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42718 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42737 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42739 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42746 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   42746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   42749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   42763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42785 */     GIR_RootConstrainSelectedInstOperands,
     /*   42786 */     // GIR_Coverage, 46692,
     /*   42786 */     GIR_EraseRootFromParent_Done,
     /*   42787 */   // Label 714: @42787
     /*   42787 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(42876), // Rule ID 46693 //
     /*   42792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42807 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42826 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42835 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   42835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   42838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   42852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42874 */     GIR_RootConstrainSelectedInstOperands,
     /*   42875 */     // GIR_Coverage, 46693,
     /*   42875 */     GIR_EraseRootFromParent_Done,
     /*   42876 */   // Label 715: @42876
     /*   42876 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(42965), // Rule ID 46456 //
     /*   42881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42915 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42924 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   42924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   42927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   42941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42963 */     GIR_RootConstrainSelectedInstOperands,
     /*   42964 */     // GIR_Coverage, 46456,
     /*   42964 */     GIR_EraseRootFromParent_Done,
     /*   42965 */   // Label 716: @42965
     /*   42965 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(43054), // Rule ID 46457 //
     /*   42970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42985 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43004 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43013 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   43030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43052 */     GIR_RootConstrainSelectedInstOperands,
     /*   43053 */     // GIR_Coverage, 46457,
     /*   43053 */     GIR_EraseRootFromParent_Done,
     /*   43054 */   // Label 717: @43054
     /*   43054 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(43143), // Rule ID 46572 //
     /*   43059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43074 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43093 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43102 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   43102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43141 */     GIR_RootConstrainSelectedInstOperands,
     /*   43142 */     // GIR_Coverage, 46572,
     /*   43142 */     GIR_EraseRootFromParent_Done,
     /*   43143 */   // Label 718: @43143
     /*   43143 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(43232), // Rule ID 46573 //
     /*   43148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43182 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43191 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43230 */     GIR_RootConstrainSelectedInstOperands,
     /*   43231 */     // GIR_Coverage, 46573,
     /*   43231 */     GIR_EraseRootFromParent_Done,
     /*   43232 */   // Label 719: @43232
     /*   43232 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(43300), // Rule ID 70724 //
     /*   43237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43274 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   43274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43298 */     GIR_RootConstrainSelectedInstOperands,
     /*   43299 */     // GIR_Coverage, 70724,
     /*   43299 */     GIR_EraseRootFromParent_Done,
     /*   43300 */   // Label 720: @43300
     /*   43300 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(43368), // Rule ID 70725 //
     /*   43305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43324 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43342 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   43342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43366 */     GIR_RootConstrainSelectedInstOperands,
     /*   43367 */     // GIR_Coverage, 70725,
     /*   43367 */     GIR_EraseRootFromParent_Done,
     /*   43368 */   // Label 721: @43368
     /*   43368 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(43423), // Rule ID 69648 //
     /*   43373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43401 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43421 */     GIR_RootConstrainSelectedInstOperands,
     /*   43422 */     // GIR_Coverage, 69648,
     /*   43422 */     GIR_EraseRootFromParent_Done,
     /*   43423 */   // Label 722: @43423
     /*   43423 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(43478), // Rule ID 69649 //
     /*   43428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43443 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43456 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43476 */     GIR_RootConstrainSelectedInstOperands,
     /*   43477 */     // GIR_Coverage, 69649,
     /*   43477 */     GIR_EraseRootFromParent_Done,
     /*   43478 */   // Label 723: @43478
     /*   43478 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(43533), // Rule ID 69468 //
     /*   43483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43498 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43511 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43531 */     GIR_RootConstrainSelectedInstOperands,
     /*   43532 */     // GIR_Coverage, 69468,
     /*   43532 */     GIR_EraseRootFromParent_Done,
     /*   43533 */   // Label 724: @43533
     /*   43533 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(43588), // Rule ID 69469 //
     /*   43538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43553 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43566 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43586 */     GIR_RootConstrainSelectedInstOperands,
     /*   43587 */     // GIR_Coverage, 69469,
     /*   43587 */     GIR_EraseRootFromParent_Done,
     /*   43588 */   // Label 725: @43588
     /*   43588 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(43643), // Rule ID 69558 //
     /*   43593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43608 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43621 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43641 */     GIR_RootConstrainSelectedInstOperands,
     /*   43642 */     // GIR_Coverage, 69558,
     /*   43642 */     GIR_EraseRootFromParent_Done,
     /*   43643 */   // Label 726: @43643
     /*   43643 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(43698), // Rule ID 69559 //
     /*   43648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43663 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43676 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43696 */     GIR_RootConstrainSelectedInstOperands,
     /*   43697 */     // GIR_Coverage, 69559,
     /*   43697 */     GIR_EraseRootFromParent_Done,
     /*   43698 */   // Label 727: @43698
     /*   43698 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(43766), // Rule ID 51914 //
     /*   43703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43740 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   43740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43764 */     GIR_RootConstrainSelectedInstOperands,
     /*   43765 */     // GIR_Coverage, 51914,
     /*   43765 */     GIR_EraseRootFromParent_Done,
     /*   43766 */   // Label 728: @43766
     /*   43766 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(43834), // Rule ID 51915 //
     /*   43771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43794 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43808 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   43808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43832 */     GIR_RootConstrainSelectedInstOperands,
     /*   43833 */     // GIR_Coverage, 51915,
     /*   43833 */     GIR_EraseRootFromParent_Done,
     /*   43834 */   // Label 729: @43834
     /*   43834 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(43889), // Rule ID 46752 //
     /*   43839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43858 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43867 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43887 */     GIR_RootConstrainSelectedInstOperands,
     /*   43888 */     // GIR_Coverage, 46752,
     /*   43888 */     GIR_EraseRootFromParent_Done,
     /*   43889 */   // Label 730: @43889
     /*   43889 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(43944), // Rule ID 46753 //
     /*   43894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43913 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43922 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43942 */     GIR_RootConstrainSelectedInstOperands,
     /*   43943 */     // GIR_Coverage, 46753,
     /*   43943 */     GIR_EraseRootFromParent_Done,
     /*   43944 */   // Label 731: @43944
     /*   43944 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(43999), // Rule ID 46512 //
     /*   43949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43977 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43997 */     GIR_RootConstrainSelectedInstOperands,
     /*   43998 */     // GIR_Coverage, 46512,
     /*   43998 */     GIR_EraseRootFromParent_Done,
     /*   43999 */   // Label 732: @43999
     /*   43999 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(44054), // Rule ID 46513 //
     /*   44004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44023 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44032 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   44035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44052 */     GIR_RootConstrainSelectedInstOperands,
     /*   44053 */     // GIR_Coverage, 46513,
     /*   44053 */     GIR_EraseRootFromParent_Done,
     /*   44054 */   // Label 733: @44054
     /*   44054 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(44109), // Rule ID 46632 //
     /*   44059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44078 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44087 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   44087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44107 */     GIR_RootConstrainSelectedInstOperands,
     /*   44108 */     // GIR_Coverage, 46632,
     /*   44108 */     GIR_EraseRootFromParent_Done,
     /*   44109 */   // Label 734: @44109
     /*   44109 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(44164), // Rule ID 46633 //
     /*   44114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44133 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44142 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44162 */     GIR_RootConstrainSelectedInstOperands,
     /*   44163 */     // GIR_Coverage, 46633,
     /*   44163 */     GIR_EraseRootFromParent_Done,
     /*   44164 */   // Label 735: @44164
     /*   44164 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(44217), // Rule ID 46146 //
     /*   44169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44180 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   44180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   44183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   44197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44215 */     GIR_RootConstrainSelectedInstOperands,
     /*   44216 */     // GIR_Coverage, 46146,
     /*   44216 */     GIR_EraseRootFromParent_Done,
     /*   44217 */   // Label 736: @44217
     /*   44217 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(44270), // Rule ID 46147 //
     /*   44222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44233 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   44233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   44236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   44250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44268 */     GIR_RootConstrainSelectedInstOperands,
     /*   44269 */     // GIR_Coverage, 46147,
     /*   44269 */     GIR_EraseRootFromParent_Done,
     /*   44270 */   // Label 737: @44270
     /*   44270 */   GIM_Reject,
     /*   44271 */ // Label 697: @44271
     /*   44271 */ GIM_Reject,
     /*   44272 */ // Label 142: @44272
     /*   44272 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(47396),
     /*   44277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44287 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(44383), // Rule ID 70856 //
     /*   44292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44311 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44325 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44327 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44340 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44344 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44346 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44357 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   44360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44381 */     GIR_RootConstrainSelectedInstOperands,
     /*   44382 */     // GIR_Coverage, 70856,
     /*   44382 */     GIR_EraseRootFromParent_Done,
     /*   44383 */   // Label 739: @44383
     /*   44383 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(44479), // Rule ID 70857 //
     /*   44388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44407 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44421 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44423 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44436 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44440 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44442 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44453 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   44456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44477 */     GIR_RootConstrainSelectedInstOperands,
     /*   44478 */     // GIR_Coverage, 70857,
     /*   44478 */     GIR_EraseRootFromParent_Done,
     /*   44479 */   // Label 740: @44479
     /*   44479 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(44575), // Rule ID 71128 //
     /*   44484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44503 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44517 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44536 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44538 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44549 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44573 */     GIR_RootConstrainSelectedInstOperands,
     /*   44574 */     // GIR_Coverage, 71128,
     /*   44574 */     GIR_EraseRootFromParent_Done,
     /*   44575 */   // Label 741: @44575
     /*   44575 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(44671), // Rule ID 71129 //
     /*   44580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44599 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44613 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44632 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44634 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44643 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44645 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44669 */     GIR_RootConstrainSelectedInstOperands,
     /*   44670 */     // GIR_Coverage, 71129,
     /*   44670 */     GIR_EraseRootFromParent_Done,
     /*   44671 */   // Label 742: @44671
     /*   44671 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(44767), // Rule ID 71130 //
     /*   44676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44695 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44709 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44724 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44728 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44730 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44741 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   44752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   44756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44765 */     GIR_RootConstrainSelectedInstOperands,
     /*   44766 */     // GIR_Coverage, 71130,
     /*   44766 */     GIR_EraseRootFromParent_Done,
     /*   44767 */   // Label 743: @44767
     /*   44767 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(44863), // Rule ID 71131 //
     /*   44772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44805 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44820 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44824 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44826 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44837 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   44848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   44852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44861 */     GIR_RootConstrainSelectedInstOperands,
     /*   44862 */     // GIR_Coverage, 71131,
     /*   44862 */     GIR_EraseRootFromParent_Done,
     /*   44863 */   // Label 744: @44863
     /*   44863 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(44959), // Rule ID 70970 //
     /*   44868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44901 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44916 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44920 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44922 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44931 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44933 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   44936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44957 */     GIR_RootConstrainSelectedInstOperands,
     /*   44958 */     // GIR_Coverage, 70970,
     /*   44958 */     GIR_EraseRootFromParent_Done,
     /*   44959 */   // Label 745: @44959
     /*   44959 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(45055), // Rule ID 70971 //
     /*   44964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44983 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44997 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45012 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45016 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45018 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45029 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45053 */     GIR_RootConstrainSelectedInstOperands,
     /*   45054 */     // GIR_Coverage, 70971,
     /*   45054 */     GIR_EraseRootFromParent_Done,
     /*   45055 */   // Label 746: @45055
     /*   45055 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(45151), // Rule ID 52054 //
     /*   45060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45083 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45097 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45112 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45116 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45118 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45125 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   45128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45149 */     GIR_RootConstrainSelectedInstOperands,
     /*   45150 */     // GIR_Coverage, 52054,
     /*   45150 */     GIR_EraseRootFromParent_Done,
     /*   45151 */   // Label 747: @45151
     /*   45151 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(45247), // Rule ID 52055 //
     /*   45156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45179 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45193 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45208 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45212 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45214 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45219 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45221 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   45224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45245 */     GIR_RootConstrainSelectedInstOperands,
     /*   45246 */     // GIR_Coverage, 52055,
     /*   45246 */     GIR_EraseRootFromParent_Done,
     /*   45247 */   // Label 748: @45247
     /*   45247 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(45343), // Rule ID 52172 //
     /*   45252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45275 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45289 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45304 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45308 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45310 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45317 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45341 */     GIR_RootConstrainSelectedInstOperands,
     /*   45342 */     // GIR_Coverage, 52172,
     /*   45342 */     GIR_EraseRootFromParent_Done,
     /*   45343 */   // Label 749: @45343
     /*   45343 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(45439), // Rule ID 52173 //
     /*   45348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45385 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45400 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45404 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45406 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45413 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45437 */     GIR_RootConstrainSelectedInstOperands,
     /*   45438 */     // GIR_Coverage, 52173,
     /*   45438 */     GIR_EraseRootFromParent_Done,
     /*   45439 */   // Label 750: @45439
     /*   45439 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(45535), // Rule ID 71126 //
     /*   45444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45467 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45481 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45496 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45500 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45502 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45507 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45509 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45533 */     GIR_RootConstrainSelectedInstOperands,
     /*   45534 */     // GIR_Coverage, 71126,
     /*   45534 */     GIR_EraseRootFromParent_Done,
     /*   45535 */   // Label 751: @45535
     /*   45535 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(45631), // Rule ID 71127 //
     /*   45540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45563 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45577 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45592 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45596 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45598 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45605 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45629 */     GIR_RootConstrainSelectedInstOperands,
     /*   45630 */     // GIR_Coverage, 71127,
     /*   45630 */     GIR_EraseRootFromParent_Done,
     /*   45631 */   // Label 752: @45631
     /*   45631 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(45727), // Rule ID 52112 //
     /*   45636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45659 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45673 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45688 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45692 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45694 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45699 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45701 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45725 */     GIR_RootConstrainSelectedInstOperands,
     /*   45726 */     // GIR_Coverage, 52112,
     /*   45726 */     GIR_EraseRootFromParent_Done,
     /*   45727 */   // Label 753: @45727
     /*   45727 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(45823), // Rule ID 52113 //
     /*   45732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45755 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45769 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45788 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45790 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45797 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45821 */     GIR_RootConstrainSelectedInstOperands,
     /*   45822 */     // GIR_Coverage, 52113,
     /*   45822 */     GIR_EraseRootFromParent_Done,
     /*   45823 */   // Label 754: @45823
     /*   45823 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(45912), // Rule ID 46716 //
     /*   45828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45843 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   45854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45862 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45869 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45871 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   45871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   45874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   45888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45910 */     GIR_RootConstrainSelectedInstOperands,
     /*   45911 */     // GIR_Coverage, 46716,
     /*   45911 */     GIR_EraseRootFromParent_Done,
     /*   45912 */   // Label 755: @45912
     /*   45912 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(46001), // Rule ID 46717 //
     /*   45917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45932 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   45943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45951 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45960 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   45960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   45963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   45977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45999 */     GIR_RootConstrainSelectedInstOperands,
     /*   46000 */     // GIR_Coverage, 46717,
     /*   46000 */     GIR_EraseRootFromParent_Done,
     /*   46001 */   // Label 756: @46001
     /*   46001 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(46090), // Rule ID 46480 //
     /*   46006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46021 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46040 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46049 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   46066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46088 */     GIR_RootConstrainSelectedInstOperands,
     /*   46089 */     // GIR_Coverage, 46480,
     /*   46089 */     GIR_EraseRootFromParent_Done,
     /*   46090 */   // Label 757: @46090
     /*   46090 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(46179), // Rule ID 46481 //
     /*   46095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46110 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46129 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46138 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   46155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46177 */     GIR_RootConstrainSelectedInstOperands,
     /*   46178 */     // GIR_Coverage, 46481,
     /*   46178 */     GIR_EraseRootFromParent_Done,
     /*   46179 */   // Label 758: @46179
     /*   46179 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(46268), // Rule ID 46596 //
     /*   46184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46199 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46218 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46227 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46266 */     GIR_RootConstrainSelectedInstOperands,
     /*   46267 */     // GIR_Coverage, 46596,
     /*   46267 */     GIR_EraseRootFromParent_Done,
     /*   46268 */   // Label 759: @46268
     /*   46268 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(46357), // Rule ID 46597 //
     /*   46273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46288 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46307 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46316 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46355 */     GIR_RootConstrainSelectedInstOperands,
     /*   46356 */     // GIR_Coverage, 46597,
     /*   46356 */     GIR_EraseRootFromParent_Done,
     /*   46357 */   // Label 760: @46357
     /*   46357 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(46425), // Rule ID 70756 //
     /*   46362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46399 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   46399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46423 */     GIR_RootConstrainSelectedInstOperands,
     /*   46424 */     // GIR_Coverage, 70756,
     /*   46424 */     GIR_EraseRootFromParent_Done,
     /*   46425 */   // Label 761: @46425
     /*   46425 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(46493), // Rule ID 70757 //
     /*   46430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46449 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46467 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   46467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46491 */     GIR_RootConstrainSelectedInstOperands,
     /*   46492 */     // GIR_Coverage, 70757,
     /*   46492 */     GIR_EraseRootFromParent_Done,
     /*   46493 */   // Label 762: @46493
     /*   46493 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(46548), // Rule ID 69672 //
     /*   46498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46513 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46526 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46546 */     GIR_RootConstrainSelectedInstOperands,
     /*   46547 */     // GIR_Coverage, 69672,
     /*   46547 */     GIR_EraseRootFromParent_Done,
     /*   46548 */   // Label 763: @46548
     /*   46548 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(46603), // Rule ID 69673 //
     /*   46553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46568 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46581 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46601 */     GIR_RootConstrainSelectedInstOperands,
     /*   46602 */     // GIR_Coverage, 69673,
     /*   46602 */     GIR_EraseRootFromParent_Done,
     /*   46603 */   // Label 764: @46603
     /*   46603 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(46658), // Rule ID 69492 //
     /*   46608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46623 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46636 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   46639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46656 */     GIR_RootConstrainSelectedInstOperands,
     /*   46657 */     // GIR_Coverage, 69492,
     /*   46657 */     GIR_EraseRootFromParent_Done,
     /*   46658 */   // Label 765: @46658
     /*   46658 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(46713), // Rule ID 69493 //
     /*   46663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46678 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46691 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   46694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46711 */     GIR_RootConstrainSelectedInstOperands,
     /*   46712 */     // GIR_Coverage, 69493,
     /*   46712 */     GIR_EraseRootFromParent_Done,
     /*   46713 */   // Label 766: @46713
     /*   46713 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(46768), // Rule ID 69582 //
     /*   46718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46733 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46746 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46766 */     GIR_RootConstrainSelectedInstOperands,
     /*   46767 */     // GIR_Coverage, 69582,
     /*   46767 */     GIR_EraseRootFromParent_Done,
     /*   46768 */   // Label 767: @46768
     /*   46768 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(46823), // Rule ID 69583 //
     /*   46773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46801 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46821 */     GIR_RootConstrainSelectedInstOperands,
     /*   46822 */     // GIR_Coverage, 69583,
     /*   46822 */     GIR_EraseRootFromParent_Done,
     /*   46823 */   // Label 768: @46823
     /*   46823 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(46891), // Rule ID 51930 //
     /*   46828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46851 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46865 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   46865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46889 */     GIR_RootConstrainSelectedInstOperands,
     /*   46890 */     // GIR_Coverage, 51930,
     /*   46890 */     GIR_EraseRootFromParent_Done,
     /*   46891 */   // Label 769: @46891
     /*   46891 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(46959), // Rule ID 51931 //
     /*   46896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46919 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46933 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   46933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46957 */     GIR_RootConstrainSelectedInstOperands,
     /*   46958 */     // GIR_Coverage, 51931,
     /*   46958 */     GIR_EraseRootFromParent_Done,
     /*   46959 */   // Label 770: @46959
     /*   46959 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(47014), // Rule ID 46776 //
     /*   46964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46983 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46992 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47012 */     GIR_RootConstrainSelectedInstOperands,
     /*   47013 */     // GIR_Coverage, 46776,
     /*   47013 */     GIR_EraseRootFromParent_Done,
     /*   47014 */   // Label 771: @47014
     /*   47014 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(47069), // Rule ID 46777 //
     /*   47019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   47034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47038 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47047 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47067 */     GIR_RootConstrainSelectedInstOperands,
     /*   47068 */     // GIR_Coverage, 46777,
     /*   47068 */     GIR_EraseRootFromParent_Done,
     /*   47069 */   // Label 772: @47069
     /*   47069 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(47124), // Rule ID 46536 //
     /*   47074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47093 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47102 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47122 */     GIR_RootConstrainSelectedInstOperands,
     /*   47123 */     // GIR_Coverage, 46536,
     /*   47123 */     GIR_EraseRootFromParent_Done,
     /*   47124 */   // Label 773: @47124
     /*   47124 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(47179), // Rule ID 46537 //
     /*   47129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47148 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47157 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47177 */     GIR_RootConstrainSelectedInstOperands,
     /*   47178 */     // GIR_Coverage, 46537,
     /*   47178 */     GIR_EraseRootFromParent_Done,
     /*   47179 */   // Label 774: @47179
     /*   47179 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(47234), // Rule ID 46656 //
     /*   47184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47203 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47212 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47232 */     GIR_RootConstrainSelectedInstOperands,
     /*   47233 */     // GIR_Coverage, 46656,
     /*   47233 */     GIR_EraseRootFromParent_Done,
     /*   47234 */   // Label 775: @47234
     /*   47234 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(47289), // Rule ID 46657 //
     /*   47239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47258 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47267 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47287 */     GIR_RootConstrainSelectedInstOperands,
     /*   47288 */     // GIR_Coverage, 46657,
     /*   47288 */     GIR_EraseRootFromParent_Done,
     /*   47289 */   // Label 776: @47289
     /*   47289 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(47342), // Rule ID 46162 //
     /*   47294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47305 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   47305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   47308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   47322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47340 */     GIR_RootConstrainSelectedInstOperands,
     /*   47341 */     // GIR_Coverage, 46162,
     /*   47341 */     GIR_EraseRootFromParent_Done,
     /*   47342 */   // Label 777: @47342
     /*   47342 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(47395), // Rule ID 46163 //
     /*   47347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47358 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   47358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   47361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   47375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47393 */     GIR_RootConstrainSelectedInstOperands,
     /*   47394 */     // GIR_Coverage, 46163,
     /*   47394 */     GIR_EraseRootFromParent_Done,
     /*   47395 */   // Label 778: @47395
     /*   47395 */   GIM_Reject,
     /*   47396 */ // Label 738: @47396
     /*   47396 */ GIM_Reject,
     /*   47397 */ // Label 143: @47397
     /*   47397 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50521),
     /*   47402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47412 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(47508), // Rule ID 70866 //
     /*   47417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47450 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47465 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47469 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47471 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47480 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47482 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   47485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47506 */     GIR_RootConstrainSelectedInstOperands,
     /*   47507 */     // GIR_Coverage, 70866,
     /*   47507 */     GIR_EraseRootFromParent_Done,
     /*   47508 */   // Label 780: @47508
     /*   47508 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(47604), // Rule ID 70867 //
     /*   47513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47532 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47546 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47561 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47565 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47567 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47576 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47578 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   47581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47602 */     GIR_RootConstrainSelectedInstOperands,
     /*   47603 */     // GIR_Coverage, 70867,
     /*   47603 */     GIR_EraseRootFromParent_Done,
     /*   47604 */   // Label 781: @47604
     /*   47604 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(47700), // Rule ID 71158 //
     /*   47609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47628 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47642 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47657 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47661 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47663 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47672 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47674 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47698 */     GIR_RootConstrainSelectedInstOperands,
     /*   47699 */     // GIR_Coverage, 71158,
     /*   47699 */     GIR_EraseRootFromParent_Done,
     /*   47700 */   // Label 782: @47700
     /*   47700 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(47796), // Rule ID 71159 //
     /*   47705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47724 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47738 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47753 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47757 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47759 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47770 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47794 */     GIR_RootConstrainSelectedInstOperands,
     /*   47795 */     // GIR_Coverage, 71159,
     /*   47795 */     GIR_EraseRootFromParent_Done,
     /*   47796 */   // Label 783: @47796
     /*   47796 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(47892), // Rule ID 71160 //
     /*   47801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47820 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47834 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47849 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47853 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47855 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47866 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   47877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   47881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47890 */     GIR_RootConstrainSelectedInstOperands,
     /*   47891 */     // GIR_Coverage, 71160,
     /*   47891 */     GIR_EraseRootFromParent_Done,
     /*   47892 */   // Label 784: @47892
     /*   47892 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(47988), // Rule ID 71161 //
     /*   47897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47916 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47930 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47945 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47949 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47951 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47962 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   47973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   47977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47986 */     GIR_RootConstrainSelectedInstOperands,
     /*   47987 */     // GIR_Coverage, 71161,
     /*   47987 */     GIR_EraseRootFromParent_Done,
     /*   47988 */   // Label 785: @47988
     /*   47988 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(48084), // Rule ID 70980 //
     /*   47993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48012 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48026 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48041 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48045 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48047 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48056 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48058 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48082 */     GIR_RootConstrainSelectedInstOperands,
     /*   48083 */     // GIR_Coverage, 70980,
     /*   48083 */     GIR_EraseRootFromParent_Done,
     /*   48084 */   // Label 786: @48084
     /*   48084 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(48180), // Rule ID 70981 //
     /*   48089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48108 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48122 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48137 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48141 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48143 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48154 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48178 */     GIR_RootConstrainSelectedInstOperands,
     /*   48179 */     // GIR_Coverage, 70981,
     /*   48179 */     GIR_EraseRootFromParent_Done,
     /*   48180 */   // Label 787: @48180
     /*   48180 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(48276), // Rule ID 52064 //
     /*   48185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48222 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48237 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48241 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48243 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48250 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48274 */     GIR_RootConstrainSelectedInstOperands,
     /*   48275 */     // GIR_Coverage, 52064,
     /*   48275 */     GIR_EraseRootFromParent_Done,
     /*   48276 */   // Label 788: @48276
     /*   48276 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(48372), // Rule ID 52065 //
     /*   48281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48304 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48318 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48329 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48333 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48337 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48339 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48344 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48346 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48370 */     GIR_RootConstrainSelectedInstOperands,
     /*   48371 */     // GIR_Coverage, 52065,
     /*   48371 */     GIR_EraseRootFromParent_Done,
     /*   48372 */   // Label 789: @48372
     /*   48372 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(48468), // Rule ID 52182 //
     /*   48377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48400 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48414 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48429 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48433 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48435 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48442 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48466 */     GIR_RootConstrainSelectedInstOperands,
     /*   48467 */     // GIR_Coverage, 52182,
     /*   48467 */     GIR_EraseRootFromParent_Done,
     /*   48468 */   // Label 790: @48468
     /*   48468 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(48564), // Rule ID 52183 //
     /*   48473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48496 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48510 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48525 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48529 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48531 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48538 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48562 */     GIR_RootConstrainSelectedInstOperands,
     /*   48563 */     // GIR_Coverage, 52183,
     /*   48563 */     GIR_EraseRootFromParent_Done,
     /*   48564 */   // Label 791: @48564
     /*   48564 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(48660), // Rule ID 71156 //
     /*   48569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48592 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48606 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48621 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48625 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48627 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48634 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48658 */     GIR_RootConstrainSelectedInstOperands,
     /*   48659 */     // GIR_Coverage, 71156,
     /*   48659 */     GIR_EraseRootFromParent_Done,
     /*   48660 */   // Label 792: @48660
     /*   48660 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(48756), // Rule ID 71157 //
     /*   48665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48688 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48702 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48717 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48721 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48723 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48730 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48754 */     GIR_RootConstrainSelectedInstOperands,
     /*   48755 */     // GIR_Coverage, 71157,
     /*   48755 */     GIR_EraseRootFromParent_Done,
     /*   48756 */   // Label 793: @48756
     /*   48756 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(48852), // Rule ID 52122 //
     /*   48761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48784 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48798 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48813 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48817 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48819 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48826 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48850 */     GIR_RootConstrainSelectedInstOperands,
     /*   48851 */     // GIR_Coverage, 52122,
     /*   48851 */     GIR_EraseRootFromParent_Done,
     /*   48852 */   // Label 794: @48852
     /*   48852 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(48948), // Rule ID 52123 //
     /*   48857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48880 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48894 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48909 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48913 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48915 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48922 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48946 */     GIR_RootConstrainSelectedInstOperands,
     /*   48947 */     // GIR_Coverage, 52123,
     /*   48947 */     GIR_EraseRootFromParent_Done,
     /*   48948 */   // Label 795: @48948
     /*   48948 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(49037), // Rule ID 46736 //
     /*   48953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   48964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   48979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   48983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48996 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   48996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   48999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49035 */     GIR_RootConstrainSelectedInstOperands,
     /*   49036 */     // GIR_Coverage, 46736,
     /*   49036 */     GIR_EraseRootFromParent_Done,
     /*   49037 */   // Label 796: @49037
     /*   49037 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(49126), // Rule ID 46737 //
     /*   49042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49057 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49076 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49085 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49124 */     GIR_RootConstrainSelectedInstOperands,
     /*   49125 */     // GIR_Coverage, 46737,
     /*   49125 */     GIR_EraseRootFromParent_Done,
     /*   49126 */   // Label 797: @49126
     /*   49126 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(49215), // Rule ID 46500 //
     /*   49131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49146 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49165 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49174 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   49191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49213 */     GIR_RootConstrainSelectedInstOperands,
     /*   49214 */     // GIR_Coverage, 46500,
     /*   49214 */     GIR_EraseRootFromParent_Done,
     /*   49215 */   // Label 798: @49215
     /*   49215 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(49304), // Rule ID 46501 //
     /*   49220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49235 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49254 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49263 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   49280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49302 */     GIR_RootConstrainSelectedInstOperands,
     /*   49303 */     // GIR_Coverage, 46501,
     /*   49303 */     GIR_EraseRootFromParent_Done,
     /*   49304 */   // Label 799: @49304
     /*   49304 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(49393), // Rule ID 46616 //
     /*   49309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49324 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49343 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49352 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49391 */     GIR_RootConstrainSelectedInstOperands,
     /*   49392 */     // GIR_Coverage, 46616,
     /*   49392 */     GIR_EraseRootFromParent_Done,
     /*   49393 */   // Label 800: @49393
     /*   49393 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(49482), // Rule ID 46617 //
     /*   49398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49413 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49432 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49441 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49480 */     GIR_RootConstrainSelectedInstOperands,
     /*   49481 */     // GIR_Coverage, 46617,
     /*   49481 */     GIR_EraseRootFromParent_Done,
     /*   49482 */   // Label 801: @49482
     /*   49482 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(49550), // Rule ID 70788 //
     /*   49487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   49490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49506 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49524 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   49524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   49545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49548 */     GIR_RootConstrainSelectedInstOperands,
     /*   49549 */     // GIR_Coverage, 70788,
     /*   49549 */     GIR_EraseRootFromParent_Done,
     /*   49550 */   // Label 802: @49550
     /*   49550 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(49618), // Rule ID 70789 //
     /*   49555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   49558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49574 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49592 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   49592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   49613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49616 */     GIR_RootConstrainSelectedInstOperands,
     /*   49617 */     // GIR_Coverage, 70789,
     /*   49617 */     GIR_EraseRootFromParent_Done,
     /*   49618 */   // Label 803: @49618
     /*   49618 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(49673), // Rule ID 69692 //
     /*   49623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49638 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49651 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49671 */     GIR_RootConstrainSelectedInstOperands,
     /*   49672 */     // GIR_Coverage, 69692,
     /*   49672 */     GIR_EraseRootFromParent_Done,
     /*   49673 */   // Label 804: @49673
     /*   49673 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(49728), // Rule ID 69693 //
     /*   49678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49693 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49706 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49726 */     GIR_RootConstrainSelectedInstOperands,
     /*   49727 */     // GIR_Coverage, 69693,
     /*   49727 */     GIR_EraseRootFromParent_Done,
     /*   49728 */   // Label 805: @49728
     /*   49728 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(49783), // Rule ID 69512 //
     /*   49733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49748 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49761 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   49764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49781 */     GIR_RootConstrainSelectedInstOperands,
     /*   49782 */     // GIR_Coverage, 69512,
     /*   49782 */     GIR_EraseRootFromParent_Done,
     /*   49783 */   // Label 806: @49783
     /*   49783 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(49838), // Rule ID 69513 //
     /*   49788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49803 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49816 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   49819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49836 */     GIR_RootConstrainSelectedInstOperands,
     /*   49837 */     // GIR_Coverage, 69513,
     /*   49837 */     GIR_EraseRootFromParent_Done,
     /*   49838 */   // Label 807: @49838
     /*   49838 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(49893), // Rule ID 69602 //
     /*   49843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49858 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49871 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49891 */     GIR_RootConstrainSelectedInstOperands,
     /*   49892 */     // GIR_Coverage, 69602,
     /*   49892 */     GIR_EraseRootFromParent_Done,
     /*   49893 */   // Label 808: @49893
     /*   49893 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(49948), // Rule ID 69603 //
     /*   49898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49913 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49926 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49946 */     GIR_RootConstrainSelectedInstOperands,
     /*   49947 */     // GIR_Coverage, 69603,
     /*   49947 */     GIR_EraseRootFromParent_Done,
     /*   49948 */   // Label 809: @49948
     /*   49948 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(50016), // Rule ID 51946 //
     /*   49953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   49956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49990 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   49990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50014 */     GIR_RootConstrainSelectedInstOperands,
     /*   50015 */     // GIR_Coverage, 51946,
     /*   50015 */     GIR_EraseRootFromParent_Done,
     /*   50016 */   // Label 810: @50016
     /*   50016 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(50084), // Rule ID 51947 //
     /*   50021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   50040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   50044 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50058 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   50058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   50061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50082 */     GIR_RootConstrainSelectedInstOperands,
     /*   50083 */     // GIR_Coverage, 51947,
     /*   50083 */     GIR_EraseRootFromParent_Done,
     /*   50084 */   // Label 811: @50084
     /*   50084 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(50139), // Rule ID 46796 //
     /*   50089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50108 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50117 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50137 */     GIR_RootConstrainSelectedInstOperands,
     /*   50138 */     // GIR_Coverage, 46796,
     /*   50138 */     GIR_EraseRootFromParent_Done,
     /*   50139 */   // Label 812: @50139
     /*   50139 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(50194), // Rule ID 46797 //
     /*   50144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50172 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50192 */     GIR_RootConstrainSelectedInstOperands,
     /*   50193 */     // GIR_Coverage, 46797,
     /*   50193 */     GIR_EraseRootFromParent_Done,
     /*   50194 */   // Label 813: @50194
     /*   50194 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(50249), // Rule ID 46556 //
     /*   50199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50227 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50247 */     GIR_RootConstrainSelectedInstOperands,
     /*   50248 */     // GIR_Coverage, 46556,
     /*   50248 */     GIR_EraseRootFromParent_Done,
     /*   50249 */   // Label 814: @50249
     /*   50249 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(50304), // Rule ID 46557 //
     /*   50254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50273 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50282 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50302 */     GIR_RootConstrainSelectedInstOperands,
     /*   50303 */     // GIR_Coverage, 46557,
     /*   50303 */     GIR_EraseRootFromParent_Done,
     /*   50304 */   // Label 815: @50304
     /*   50304 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(50359), // Rule ID 46676 //
     /*   50309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50337 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50357 */     GIR_RootConstrainSelectedInstOperands,
     /*   50358 */     // GIR_Coverage, 46676,
     /*   50358 */     GIR_EraseRootFromParent_Done,
     /*   50359 */   // Label 816: @50359
     /*   50359 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(50414), // Rule ID 46677 //
     /*   50364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50383 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50392 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50412 */     GIR_RootConstrainSelectedInstOperands,
     /*   50413 */     // GIR_Coverage, 46677,
     /*   50413 */     GIR_EraseRootFromParent_Done,
     /*   50414 */   // Label 817: @50414
     /*   50414 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(50467), // Rule ID 46178 //
     /*   50419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   50422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50430 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   50430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   50433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   50447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50465 */     GIR_RootConstrainSelectedInstOperands,
     /*   50466 */     // GIR_Coverage, 46178,
     /*   50466 */     GIR_EraseRootFromParent_Done,
     /*   50467 */   // Label 818: @50467
     /*   50467 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(50520), // Rule ID 46179 //
     /*   50472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50483 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   50483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   50486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   50500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50518 */     GIR_RootConstrainSelectedInstOperands,
     /*   50519 */     // GIR_Coverage, 46179,
     /*   50519 */     GIR_EraseRootFromParent_Done,
     /*   50520 */   // Label 819: @50520
     /*   50520 */   GIM_Reject,
     /*   50521 */ // Label 779: @50521
     /*   50521 */ GIM_Reject,
     /*   50522 */ // Label 144: @50522
     /*   50522 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(50916),
     /*   50527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50537 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(50605), // Rule ID 70700 //
     /*   50542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50561 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50579 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   50579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50603 */     GIR_RootConstrainSelectedInstOperands,
     /*   50604 */     // GIR_Coverage, 70700,
     /*   50604 */     GIR_EraseRootFromParent_Done,
     /*   50605 */   // Label 821: @50605
     /*   50605 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(50673), // Rule ID 70701 //
     /*   50610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50629 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50647 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   50647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50671 */     GIR_RootConstrainSelectedInstOperands,
     /*   50672 */     // GIR_Coverage, 70701,
     /*   50672 */     GIR_EraseRootFromParent_Done,
     /*   50673 */   // Label 822: @50673
     /*   50673 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(50741), // Rule ID 51902 //
     /*   50678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50701 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50715 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   50715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50739 */     GIR_RootConstrainSelectedInstOperands,
     /*   50740 */     // GIR_Coverage, 51902,
     /*   50740 */     GIR_EraseRootFromParent_Done,
     /*   50741 */   // Label 823: @50741
     /*   50741 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(50809), // Rule ID 51903 //
     /*   50746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50769 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50783 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   50783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50807 */     GIR_RootConstrainSelectedInstOperands,
     /*   50808 */     // GIR_Coverage, 51903,
     /*   50808 */     GIR_EraseRootFromParent_Done,
     /*   50809 */   // Label 824: @50809
     /*   50809 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(50862), // Rule ID 46134 //
     /*   50814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50825 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   50825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   50828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   50842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50860 */     GIR_RootConstrainSelectedInstOperands,
     /*   50861 */     // GIR_Coverage, 46134,
     /*   50861 */     GIR_EraseRootFromParent_Done,
     /*   50862 */   // Label 825: @50862
     /*   50862 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(50915), // Rule ID 46135 //
     /*   50867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50878 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   50878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   50881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   50895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50913 */     GIR_RootConstrainSelectedInstOperands,
     /*   50914 */     // GIR_Coverage, 46135,
     /*   50914 */     GIR_EraseRootFromParent_Done,
     /*   50915 */   // Label 826: @50915
     /*   50915 */   GIM_Reject,
     /*   50916 */ // Label 820: @50916
     /*   50916 */ GIM_Reject,
     /*   50917 */ // Label 145: @50917
     /*   50917 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(54041),
     /*   50922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   50928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50932 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(51028), // Rule ID 70846 //
     /*   50937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   50956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50970 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50985 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50989 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50991 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51002 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51026 */     GIR_RootConstrainSelectedInstOperands,
     /*   51027 */     // GIR_Coverage, 70846,
     /*   51027 */     GIR_EraseRootFromParent_Done,
     /*   51028 */   // Label 828: @51028
     /*   51028 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(51124), // Rule ID 70847 //
     /*   51033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51052 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51066 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51081 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51085 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51087 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51098 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51122 */     GIR_RootConstrainSelectedInstOperands,
     /*   51123 */     // GIR_Coverage, 70847,
     /*   51123 */     GIR_EraseRootFromParent_Done,
     /*   51124 */   // Label 829: @51124
     /*   51124 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(51220), // Rule ID 71098 //
     /*   51129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51148 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51162 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51177 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51181 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51183 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51194 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51218 */     GIR_RootConstrainSelectedInstOperands,
     /*   51219 */     // GIR_Coverage, 71098,
     /*   51219 */     GIR_EraseRootFromParent_Done,
     /*   51220 */   // Label 830: @51220
     /*   51220 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(51316), // Rule ID 71099 //
     /*   51225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51244 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51258 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51273 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51277 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51279 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51290 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51314 */     GIR_RootConstrainSelectedInstOperands,
     /*   51315 */     // GIR_Coverage, 71099,
     /*   51315 */     GIR_EraseRootFromParent_Done,
     /*   51316 */   // Label 831: @51316
     /*   51316 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(51412), // Rule ID 71100 //
     /*   51321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51340 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51354 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51369 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51373 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51375 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51384 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51386 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51410 */     GIR_RootConstrainSelectedInstOperands,
     /*   51411 */     // GIR_Coverage, 71100,
     /*   51411 */     GIR_EraseRootFromParent_Done,
     /*   51412 */   // Label 832: @51412
     /*   51412 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(51508), // Rule ID 71101 //
     /*   51417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51450 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51465 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51469 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51471 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51480 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51482 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51506 */     GIR_RootConstrainSelectedInstOperands,
     /*   51507 */     // GIR_Coverage, 71101,
     /*   51507 */     GIR_EraseRootFromParent_Done,
     /*   51508 */   // Label 833: @51508
     /*   51508 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(51604), // Rule ID 70960 //
     /*   51513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51532 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51546 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51561 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51565 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51567 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51576 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51578 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   51581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51602 */     GIR_RootConstrainSelectedInstOperands,
     /*   51603 */     // GIR_Coverage, 70960,
     /*   51603 */     GIR_EraseRootFromParent_Done,
     /*   51604 */   // Label 834: @51604
     /*   51604 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(51700), // Rule ID 70961 //
     /*   51609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51628 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51642 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51657 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51661 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51663 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51672 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51674 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   51677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51698 */     GIR_RootConstrainSelectedInstOperands,
     /*   51699 */     // GIR_Coverage, 70961,
     /*   51699 */     GIR_EraseRootFromParent_Done,
     /*   51700 */   // Label 835: @51700
     /*   51700 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(51796), // Rule ID 52044 //
     /*   51705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51728 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51742 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51757 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51761 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51763 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51770 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51794 */     GIR_RootConstrainSelectedInstOperands,
     /*   51795 */     // GIR_Coverage, 52044,
     /*   51795 */     GIR_EraseRootFromParent_Done,
     /*   51796 */   // Label 836: @51796
     /*   51796 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(51892), // Rule ID 52045 //
     /*   51801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51824 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51838 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51853 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51857 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51859 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51866 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51890 */     GIR_RootConstrainSelectedInstOperands,
     /*   51891 */     // GIR_Coverage, 52045,
     /*   51891 */     GIR_EraseRootFromParent_Done,
     /*   51892 */   // Label 837: @51892
     /*   51892 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(51988), // Rule ID 52162 //
     /*   51897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51934 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51949 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51953 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51955 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51962 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51986 */     GIR_RootConstrainSelectedInstOperands,
     /*   51987 */     // GIR_Coverage, 52162,
     /*   51987 */     GIR_EraseRootFromParent_Done,
     /*   51988 */   // Label 838: @51988
     /*   51988 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(52084), // Rule ID 52163 //
     /*   51993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52030 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52049 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52051 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52056 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52058 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52082 */     GIR_RootConstrainSelectedInstOperands,
     /*   52083 */     // GIR_Coverage, 52163,
     /*   52083 */     GIR_EraseRootFromParent_Done,
     /*   52084 */   // Label 839: @52084
     /*   52084 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(52180), // Rule ID 71096 //
     /*   52089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52112 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52126 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52141 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52145 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52147 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52154 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   52165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   52169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52178 */     GIR_RootConstrainSelectedInstOperands,
     /*   52179 */     // GIR_Coverage, 71096,
     /*   52179 */     GIR_EraseRootFromParent_Done,
     /*   52180 */   // Label 840: @52180
     /*   52180 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(52276), // Rule ID 71097 //
     /*   52185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52222 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52237 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52241 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52243 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52250 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   52261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   52265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52274 */     GIR_RootConstrainSelectedInstOperands,
     /*   52275 */     // GIR_Coverage, 71097,
     /*   52275 */     GIR_EraseRootFromParent_Done,
     /*   52276 */   // Label 841: @52276
     /*   52276 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(52372), // Rule ID 52102 //
     /*   52281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52304 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52318 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52329 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52333 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52337 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52339 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52344 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52346 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52370 */     GIR_RootConstrainSelectedInstOperands,
     /*   52371 */     // GIR_Coverage, 52102,
     /*   52371 */     GIR_EraseRootFromParent_Done,
     /*   52372 */   // Label 842: @52372
     /*   52372 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(52468), // Rule ID 52103 //
     /*   52377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52400 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52414 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52429 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52433 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52435 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52442 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52466 */     GIR_RootConstrainSelectedInstOperands,
     /*   52467 */     // GIR_Coverage, 52103,
     /*   52467 */     GIR_EraseRootFromParent_Done,
     /*   52468 */   // Label 843: @52468
     /*   52468 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(52557), // Rule ID 46696 //
     /*   52473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52488 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52507 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52516 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52555 */     GIR_RootConstrainSelectedInstOperands,
     /*   52556 */     // GIR_Coverage, 46696,
     /*   52556 */     GIR_EraseRootFromParent_Done,
     /*   52557 */   // Label 844: @52557
     /*   52557 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(52646), // Rule ID 46697 //
     /*   52562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52577 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52596 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52605 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   52605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52644 */     GIR_RootConstrainSelectedInstOperands,
     /*   52645 */     // GIR_Coverage, 46697,
     /*   52645 */     GIR_EraseRootFromParent_Done,
     /*   52646 */   // Label 845: @52646
     /*   52646 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(52735), // Rule ID 46460 //
     /*   52651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52685 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52694 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   52711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52733 */     GIR_RootConstrainSelectedInstOperands,
     /*   52734 */     // GIR_Coverage, 46460,
     /*   52734 */     GIR_EraseRootFromParent_Done,
     /*   52735 */   // Label 846: @52735
     /*   52735 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(52824), // Rule ID 46461 //
     /*   52740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52755 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52774 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52783 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   52783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   52800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52822 */     GIR_RootConstrainSelectedInstOperands,
     /*   52823 */     // GIR_Coverage, 46461,
     /*   52823 */     GIR_EraseRootFromParent_Done,
     /*   52824 */   // Label 847: @52824
     /*   52824 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(52913), // Rule ID 46576 //
     /*   52829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52844 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52863 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52872 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52911 */     GIR_RootConstrainSelectedInstOperands,
     /*   52912 */     // GIR_Coverage, 46576,
     /*   52912 */     GIR_EraseRootFromParent_Done,
     /*   52913 */   // Label 848: @52913
     /*   52913 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(53002), // Rule ID 46577 //
     /*   52918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52933 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52952 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52961 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   52961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53000 */     GIR_RootConstrainSelectedInstOperands,
     /*   53001 */     // GIR_Coverage, 46577,
     /*   53001 */     GIR_EraseRootFromParent_Done,
     /*   53002 */   // Label 849: @53002
     /*   53002 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(53070), // Rule ID 70732 //
     /*   53007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53044 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   53044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53068 */     GIR_RootConstrainSelectedInstOperands,
     /*   53069 */     // GIR_Coverage, 70732,
     /*   53069 */     GIR_EraseRootFromParent_Done,
     /*   53070 */   // Label 850: @53070
     /*   53070 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(53138), // Rule ID 70733 //
     /*   53075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53094 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53112 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   53112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53136 */     GIR_RootConstrainSelectedInstOperands,
     /*   53137 */     // GIR_Coverage, 70733,
     /*   53137 */     GIR_EraseRootFromParent_Done,
     /*   53138 */   // Label 851: @53138
     /*   53138 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(53193), // Rule ID 69652 //
     /*   53143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53158 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53171 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53191 */     GIR_RootConstrainSelectedInstOperands,
     /*   53192 */     // GIR_Coverage, 69652,
     /*   53192 */     GIR_EraseRootFromParent_Done,
     /*   53193 */   // Label 852: @53193
     /*   53193 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(53248), // Rule ID 69653 //
     /*   53198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53213 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53226 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53246 */     GIR_RootConstrainSelectedInstOperands,
     /*   53247 */     // GIR_Coverage, 69653,
     /*   53247 */     GIR_EraseRootFromParent_Done,
     /*   53248 */   // Label 853: @53248
     /*   53248 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(53303), // Rule ID 69472 //
     /*   53253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53268 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53281 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53301 */     GIR_RootConstrainSelectedInstOperands,
     /*   53302 */     // GIR_Coverage, 69472,
     /*   53302 */     GIR_EraseRootFromParent_Done,
     /*   53303 */   // Label 854: @53303
     /*   53303 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(53358), // Rule ID 69473 //
     /*   53308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53323 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53336 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53356 */     GIR_RootConstrainSelectedInstOperands,
     /*   53357 */     // GIR_Coverage, 69473,
     /*   53357 */     GIR_EraseRootFromParent_Done,
     /*   53358 */   // Label 855: @53358
     /*   53358 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(53413), // Rule ID 69562 //
     /*   53363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53378 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53391 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53411 */     GIR_RootConstrainSelectedInstOperands,
     /*   53412 */     // GIR_Coverage, 69562,
     /*   53412 */     GIR_EraseRootFromParent_Done,
     /*   53413 */   // Label 856: @53413
     /*   53413 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(53468), // Rule ID 69563 //
     /*   53418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53433 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53446 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53466 */     GIR_RootConstrainSelectedInstOperands,
     /*   53467 */     // GIR_Coverage, 69563,
     /*   53467 */     GIR_EraseRootFromParent_Done,
     /*   53468 */   // Label 857: @53468
     /*   53468 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(53536), // Rule ID 51918 //
     /*   53473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53496 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53510 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   53510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53534 */     GIR_RootConstrainSelectedInstOperands,
     /*   53535 */     // GIR_Coverage, 51918,
     /*   53535 */     GIR_EraseRootFromParent_Done,
     /*   53536 */   // Label 858: @53536
     /*   53536 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53604), // Rule ID 51919 //
     /*   53541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53564 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53578 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   53578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53602 */     GIR_RootConstrainSelectedInstOperands,
     /*   53603 */     // GIR_Coverage, 51919,
     /*   53603 */     GIR_EraseRootFromParent_Done,
     /*   53604 */   // Label 859: @53604
     /*   53604 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53659), // Rule ID 46756 //
     /*   53609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53628 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53637 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53657 */     GIR_RootConstrainSelectedInstOperands,
     /*   53658 */     // GIR_Coverage, 46756,
     /*   53658 */     GIR_EraseRootFromParent_Done,
     /*   53659 */   // Label 860: @53659
     /*   53659 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53714), // Rule ID 46757 //
     /*   53664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53683 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53692 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53712 */     GIR_RootConstrainSelectedInstOperands,
     /*   53713 */     // GIR_Coverage, 46757,
     /*   53713 */     GIR_EraseRootFromParent_Done,
     /*   53714 */   // Label 861: @53714
     /*   53714 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53769), // Rule ID 46516 //
     /*   53719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53738 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53747 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53767 */     GIR_RootConstrainSelectedInstOperands,
     /*   53768 */     // GIR_Coverage, 46516,
     /*   53768 */     GIR_EraseRootFromParent_Done,
     /*   53769 */   // Label 862: @53769
     /*   53769 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53824), // Rule ID 46517 //
     /*   53774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53793 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53802 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53822 */     GIR_RootConstrainSelectedInstOperands,
     /*   53823 */     // GIR_Coverage, 46517,
     /*   53823 */     GIR_EraseRootFromParent_Done,
     /*   53824 */   // Label 863: @53824
     /*   53824 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53879), // Rule ID 46636 //
     /*   53829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53848 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53857 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53877 */     GIR_RootConstrainSelectedInstOperands,
     /*   53878 */     // GIR_Coverage, 46636,
     /*   53878 */     GIR_EraseRootFromParent_Done,
     /*   53879 */   // Label 864: @53879
     /*   53879 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53934), // Rule ID 46637 //
     /*   53884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53903 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53912 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53932 */     GIR_RootConstrainSelectedInstOperands,
     /*   53933 */     // GIR_Coverage, 46637,
     /*   53933 */     GIR_EraseRootFromParent_Done,
     /*   53934 */   // Label 865: @53934
     /*   53934 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53987), // Rule ID 46150 //
     /*   53939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53950 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   53950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   53967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53985 */     GIR_RootConstrainSelectedInstOperands,
     /*   53986 */     // GIR_Coverage, 46150,
     /*   53986 */     GIR_EraseRootFromParent_Done,
     /*   53987 */   // Label 866: @53987
     /*   53987 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(54040), // Rule ID 46151 //
     /*   53992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54003 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   54003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   54006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   54010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   54015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   54017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   54020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   54025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   54027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   54029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54038 */     GIR_RootConstrainSelectedInstOperands,
     /*   54039 */     // GIR_Coverage, 46151,
     /*   54039 */     GIR_EraseRootFromParent_Done,
     /*   54040 */   // Label 867: @54040
     /*   54040 */   GIM_Reject,
     /*   54041 */ // Label 827: @54041
     /*   54041 */ GIM_Reject,
     /*   54042 */ // Label 146: @54042
     /*   54042 */ GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(57166),
     /*   54047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54057 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(54153), // Rule ID 70858 //
     /*   54062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54081 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54095 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54110 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54114 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54116 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54127 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54151 */     GIR_RootConstrainSelectedInstOperands,
     /*   54152 */     // GIR_Coverage, 70858,
     /*   54152 */     GIR_EraseRootFromParent_Done,
     /*   54153 */   // Label 869: @54153
     /*   54153 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(54249), // Rule ID 70859 //
     /*   54158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54177 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54191 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54206 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54210 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54212 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54223 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54247 */     GIR_RootConstrainSelectedInstOperands,
     /*   54248 */     // GIR_Coverage, 70859,
     /*   54248 */     GIR_EraseRootFromParent_Done,
     /*   54249 */   // Label 870: @54249
     /*   54249 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(54345), // Rule ID 71134 //
     /*   54254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54273 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54287 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54302 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54306 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54308 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54319 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54343 */     GIR_RootConstrainSelectedInstOperands,
     /*   54344 */     // GIR_Coverage, 71134,
     /*   54344 */     GIR_EraseRootFromParent_Done,
     /*   54345 */   // Label 871: @54345
     /*   54345 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54441), // Rule ID 71135 //
     /*   54350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54369 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54383 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54398 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54402 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54404 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54415 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54439 */     GIR_RootConstrainSelectedInstOperands,
     /*   54440 */     // GIR_Coverage, 71135,
     /*   54440 */     GIR_EraseRootFromParent_Done,
     /*   54441 */   // Label 872: @54441
     /*   54441 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54537), // Rule ID 71136 //
     /*   54446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54465 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54479 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54494 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54498 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54500 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54509 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54511 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   54522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   54526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54535 */     GIR_RootConstrainSelectedInstOperands,
     /*   54536 */     // GIR_Coverage, 71136,
     /*   54536 */     GIR_EraseRootFromParent_Done,
     /*   54537 */   // Label 873: @54537
     /*   54537 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(54633), // Rule ID 71137 //
     /*   54542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54561 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54575 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54590 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54594 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54596 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54607 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   54618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   54622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54631 */     GIR_RootConstrainSelectedInstOperands,
     /*   54632 */     // GIR_Coverage, 71137,
     /*   54632 */     GIR_EraseRootFromParent_Done,
     /*   54633 */   // Label 874: @54633
     /*   54633 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54729), // Rule ID 70972 //
     /*   54638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54657 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54671 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54673 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54686 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54690 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54692 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54701 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54703 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   54706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54727 */     GIR_RootConstrainSelectedInstOperands,
     /*   54728 */     // GIR_Coverage, 70972,
     /*   54728 */     GIR_EraseRootFromParent_Done,
     /*   54729 */   // Label 875: @54729
     /*   54729 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54825), // Rule ID 70973 //
     /*   54734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54753 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54767 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54782 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54786 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54788 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54797 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54799 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   54802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54823 */     GIR_RootConstrainSelectedInstOperands,
     /*   54824 */     // GIR_Coverage, 70973,
     /*   54824 */     GIR_EraseRootFromParent_Done,
     /*   54825 */   // Label 876: @54825
     /*   54825 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54921), // Rule ID 52056 //
     /*   54830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54853 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54867 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54869 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54882 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54886 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54888 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54895 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54919 */     GIR_RootConstrainSelectedInstOperands,
     /*   54920 */     // GIR_Coverage, 52056,
     /*   54920 */     GIR_EraseRootFromParent_Done,
     /*   54921 */   // Label 877: @54921
     /*   54921 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(55017), // Rule ID 52057 //
     /*   54926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54949 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54963 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54978 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54982 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54984 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54989 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54991 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55015 */     GIR_RootConstrainSelectedInstOperands,
     /*   55016 */     // GIR_Coverage, 52057,
     /*   55016 */     GIR_EraseRootFromParent_Done,
     /*   55017 */   // Label 878: @55017
     /*   55017 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(55113), // Rule ID 52174 //
     /*   55022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55045 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55059 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55074 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55078 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55080 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55087 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55111 */     GIR_RootConstrainSelectedInstOperands,
     /*   55112 */     // GIR_Coverage, 52174,
     /*   55112 */     GIR_EraseRootFromParent_Done,
     /*   55113 */   // Label 879: @55113
     /*   55113 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(55209), // Rule ID 52175 //
     /*   55118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55141 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55155 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55170 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55174 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55176 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55181 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55183 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55207 */     GIR_RootConstrainSelectedInstOperands,
     /*   55208 */     // GIR_Coverage, 52175,
     /*   55208 */     GIR_EraseRootFromParent_Done,
     /*   55209 */   // Label 880: @55209
     /*   55209 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(55305), // Rule ID 71132 //
     /*   55214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55237 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55251 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55270 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55272 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55277 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55279 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55303 */     GIR_RootConstrainSelectedInstOperands,
     /*   55304 */     // GIR_Coverage, 71132,
     /*   55304 */     GIR_EraseRootFromParent_Done,
     /*   55305 */   // Label 881: @55305
     /*   55305 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(55401), // Rule ID 71133 //
     /*   55310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55333 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55347 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55358 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55362 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55366 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55368 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55375 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55399 */     GIR_RootConstrainSelectedInstOperands,
     /*   55400 */     // GIR_Coverage, 71133,
     /*   55400 */     GIR_EraseRootFromParent_Done,
     /*   55401 */   // Label 882: @55401
     /*   55401 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55497), // Rule ID 52114 //
     /*   55406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55429 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55443 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55458 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55462 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55464 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55471 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55495 */     GIR_RootConstrainSelectedInstOperands,
     /*   55496 */     // GIR_Coverage, 52114,
     /*   55496 */     GIR_EraseRootFromParent_Done,
     /*   55497 */   // Label 883: @55497
     /*   55497 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55593), // Rule ID 52115 //
     /*   55502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55525 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55539 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55554 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55558 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55560 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55565 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55567 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55591 */     GIR_RootConstrainSelectedInstOperands,
     /*   55592 */     // GIR_Coverage, 52115,
     /*   55592 */     GIR_EraseRootFromParent_Done,
     /*   55593 */   // Label 884: @55593
     /*   55593 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55682), // Rule ID 46720 //
     /*   55598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55613 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55632 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55641 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   55641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   55658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55680 */     GIR_RootConstrainSelectedInstOperands,
     /*   55681 */     // GIR_Coverage, 46720,
     /*   55681 */     GIR_EraseRootFromParent_Done,
     /*   55682 */   // Label 885: @55682
     /*   55682 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55771), // Rule ID 46721 //
     /*   55687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55702 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55721 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55730 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   55730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   55747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55769 */     GIR_RootConstrainSelectedInstOperands,
     /*   55770 */     // GIR_Coverage, 46721,
     /*   55770 */     GIR_EraseRootFromParent_Done,
     /*   55771 */   // Label 886: @55771
     /*   55771 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55860), // Rule ID 46484 //
     /*   55776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55810 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55819 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   55819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   55836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55858 */     GIR_RootConstrainSelectedInstOperands,
     /*   55859 */     // GIR_Coverage, 46484,
     /*   55859 */     GIR_EraseRootFromParent_Done,
     /*   55860 */   // Label 887: @55860
     /*   55860 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55949), // Rule ID 46485 //
     /*   55865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55880 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55899 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55908 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   55908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   55925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55947 */     GIR_RootConstrainSelectedInstOperands,
     /*   55948 */     // GIR_Coverage, 46485,
     /*   55948 */     GIR_EraseRootFromParent_Done,
     /*   55949 */   // Label 888: @55949
     /*   55949 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(56038), // Rule ID 46600 //
     /*   55954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55969 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55988 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55997 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   55997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56036 */     GIR_RootConstrainSelectedInstOperands,
     /*   56037 */     // GIR_Coverage, 46600,
     /*   56037 */     GIR_EraseRootFromParent_Done,
     /*   56038 */   // Label 889: @56038
     /*   56038 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(56127), // Rule ID 46601 //
     /*   56043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56058 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56077 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56086 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   56086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56125 */     GIR_RootConstrainSelectedInstOperands,
     /*   56126 */     // GIR_Coverage, 46601,
     /*   56126 */     GIR_EraseRootFromParent_Done,
     /*   56127 */   // Label 890: @56127
     /*   56127 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(56195), // Rule ID 70764 //
     /*   56132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56169 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   56169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56193 */     GIR_RootConstrainSelectedInstOperands,
     /*   56194 */     // GIR_Coverage, 70764,
     /*   56194 */     GIR_EraseRootFromParent_Done,
     /*   56195 */   // Label 891: @56195
     /*   56195 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(56263), // Rule ID 70765 //
     /*   56200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56219 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56237 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   56237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56261 */     GIR_RootConstrainSelectedInstOperands,
     /*   56262 */     // GIR_Coverage, 70765,
     /*   56262 */     GIR_EraseRootFromParent_Done,
     /*   56263 */   // Label 892: @56263
     /*   56263 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(56318), // Rule ID 69676 //
     /*   56268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56283 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56296 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56316 */     GIR_RootConstrainSelectedInstOperands,
     /*   56317 */     // GIR_Coverage, 69676,
     /*   56317 */     GIR_EraseRootFromParent_Done,
     /*   56318 */   // Label 893: @56318
     /*   56318 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(56373), // Rule ID 69677 //
     /*   56323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56338 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56351 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56371 */     GIR_RootConstrainSelectedInstOperands,
     /*   56372 */     // GIR_Coverage, 69677,
     /*   56372 */     GIR_EraseRootFromParent_Done,
     /*   56373 */   // Label 894: @56373
     /*   56373 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(56428), // Rule ID 69496 //
     /*   56378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56393 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56406 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56426 */     GIR_RootConstrainSelectedInstOperands,
     /*   56427 */     // GIR_Coverage, 69496,
     /*   56427 */     GIR_EraseRootFromParent_Done,
     /*   56428 */   // Label 895: @56428
     /*   56428 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(56483), // Rule ID 69497 //
     /*   56433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56448 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56461 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56481 */     GIR_RootConstrainSelectedInstOperands,
     /*   56482 */     // GIR_Coverage, 69497,
     /*   56482 */     GIR_EraseRootFromParent_Done,
     /*   56483 */   // Label 896: @56483
     /*   56483 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(56538), // Rule ID 69586 //
     /*   56488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56503 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56516 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56536 */     GIR_RootConstrainSelectedInstOperands,
     /*   56537 */     // GIR_Coverage, 69586,
     /*   56537 */     GIR_EraseRootFromParent_Done,
     /*   56538 */   // Label 897: @56538
     /*   56538 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(56593), // Rule ID 69587 //
     /*   56543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56571 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56591 */     GIR_RootConstrainSelectedInstOperands,
     /*   56592 */     // GIR_Coverage, 69587,
     /*   56592 */     GIR_EraseRootFromParent_Done,
     /*   56593 */   // Label 898: @56593
     /*   56593 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(56661), // Rule ID 51934 //
     /*   56598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56621 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56635 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   56635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56659 */     GIR_RootConstrainSelectedInstOperands,
     /*   56660 */     // GIR_Coverage, 51934,
     /*   56660 */     GIR_EraseRootFromParent_Done,
     /*   56661 */   // Label 899: @56661
     /*   56661 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(56729), // Rule ID 51935 //
     /*   56666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56703 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   56703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56727 */     GIR_RootConstrainSelectedInstOperands,
     /*   56728 */     // GIR_Coverage, 51935,
     /*   56728 */     GIR_EraseRootFromParent_Done,
     /*   56729 */   // Label 900: @56729
     /*   56729 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(56784), // Rule ID 46780 //
     /*   56734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56753 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56762 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56782 */     GIR_RootConstrainSelectedInstOperands,
     /*   56783 */     // GIR_Coverage, 46780,
     /*   56783 */     GIR_EraseRootFromParent_Done,
     /*   56784 */   // Label 901: @56784
     /*   56784 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(56839), // Rule ID 46781 //
     /*   56789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56808 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56817 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56837 */     GIR_RootConstrainSelectedInstOperands,
     /*   56838 */     // GIR_Coverage, 46781,
     /*   56838 */     GIR_EraseRootFromParent_Done,
     /*   56839 */   // Label 902: @56839
     /*   56839 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(56894), // Rule ID 46540 //
     /*   56844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56863 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56872 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56892 */     GIR_RootConstrainSelectedInstOperands,
     /*   56893 */     // GIR_Coverage, 46540,
     /*   56893 */     GIR_EraseRootFromParent_Done,
     /*   56894 */   // Label 903: @56894
     /*   56894 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(56949), // Rule ID 46541 //
     /*   56899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56927 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56947 */     GIR_RootConstrainSelectedInstOperands,
     /*   56948 */     // GIR_Coverage, 46541,
     /*   56948 */     GIR_EraseRootFromParent_Done,
     /*   56949 */   // Label 904: @56949
     /*   56949 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(57004), // Rule ID 46660 //
     /*   56954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56982 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57002 */     GIR_RootConstrainSelectedInstOperands,
     /*   57003 */     // GIR_Coverage, 46660,
     /*   57003 */     GIR_EraseRootFromParent_Done,
     /*   57004 */   // Label 905: @57004
     /*   57004 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(57059), // Rule ID 46661 //
     /*   57009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57028 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57037 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   57037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57057 */     GIR_RootConstrainSelectedInstOperands,
     /*   57058 */     // GIR_Coverage, 46661,
     /*   57058 */     GIR_EraseRootFromParent_Done,
     /*   57059 */   // Label 906: @57059
     /*   57059 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(57112), // Rule ID 46166 //
     /*   57064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57075 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   57075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   57078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   57092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57110 */     GIR_RootConstrainSelectedInstOperands,
     /*   57111 */     // GIR_Coverage, 46166,
     /*   57111 */     GIR_EraseRootFromParent_Done,
     /*   57112 */   // Label 907: @57112
     /*   57112 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(57165), // Rule ID 46167 //
     /*   57117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57128 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   57128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   57131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   57145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57163 */     GIR_RootConstrainSelectedInstOperands,
     /*   57164 */     // GIR_Coverage, 46167,
     /*   57164 */     GIR_EraseRootFromParent_Done,
     /*   57165 */   // Label 908: @57165
     /*   57165 */   GIM_Reject,
     /*   57166 */ // Label 868: @57166
     /*   57166 */ GIM_Reject,
     /*   57167 */ // Label 147: @57167
     /*   57167 */ GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(57561),
     /*   57172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57182 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(57250), // Rule ID 70708 //
     /*   57187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57224 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57248 */     GIR_RootConstrainSelectedInstOperands,
     /*   57249 */     // GIR_Coverage, 70708,
     /*   57249 */     GIR_EraseRootFromParent_Done,
     /*   57250 */   // Label 910: @57250
     /*   57250 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(57318), // Rule ID 70709 //
     /*   57255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57274 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57292 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57316 */     GIR_RootConstrainSelectedInstOperands,
     /*   57317 */     // GIR_Coverage, 70709,
     /*   57317 */     GIR_EraseRootFromParent_Done,
     /*   57318 */   // Label 911: @57318
     /*   57318 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(57386), // Rule ID 51906 //
     /*   57323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57346 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57360 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57384 */     GIR_RootConstrainSelectedInstOperands,
     /*   57385 */     // GIR_Coverage, 51906,
     /*   57385 */     GIR_EraseRootFromParent_Done,
     /*   57386 */   // Label 912: @57386
     /*   57386 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(57454), // Rule ID 51907 //
     /*   57391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57414 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57428 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57452 */     GIR_RootConstrainSelectedInstOperands,
     /*   57453 */     // GIR_Coverage, 51907,
     /*   57453 */     GIR_EraseRootFromParent_Done,
     /*   57454 */   // Label 913: @57454
     /*   57454 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(57507), // Rule ID 46138 //
     /*   57459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57470 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   57470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   57473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   57487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57505 */     GIR_RootConstrainSelectedInstOperands,
     /*   57506 */     // GIR_Coverage, 46138,
     /*   57506 */     GIR_EraseRootFromParent_Done,
     /*   57507 */   // Label 914: @57507
     /*   57507 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(57560), // Rule ID 46139 //
     /*   57512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57523 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   57523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   57526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   57540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57558 */     GIR_RootConstrainSelectedInstOperands,
     /*   57559 */     // GIR_Coverage, 46139,
     /*   57559 */     GIR_EraseRootFromParent_Done,
     /*   57560 */   // Label 915: @57560
     /*   57560 */   GIM_Reject,
     /*   57561 */ // Label 909: @57561
     /*   57561 */ GIM_Reject,
     /*   57562 */ // Label 148: @57562
     /*   57562 */ GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(60686),
     /*   57567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57577 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(57673), // Rule ID 70848 //
     /*   57582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57601 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57615 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57617 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57630 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57634 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57636 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57647 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   57650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57671 */     GIR_RootConstrainSelectedInstOperands,
     /*   57672 */     // GIR_Coverage, 70848,
     /*   57672 */     GIR_EraseRootFromParent_Done,
     /*   57673 */   // Label 917: @57673
     /*   57673 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(57769), // Rule ID 70849 //
     /*   57678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57711 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57730 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57732 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57741 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57743 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   57746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57767 */     GIR_RootConstrainSelectedInstOperands,
     /*   57768 */     // GIR_Coverage, 70849,
     /*   57768 */     GIR_EraseRootFromParent_Done,
     /*   57769 */   // Label 918: @57769
     /*   57769 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57865), // Rule ID 71104 //
     /*   57774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57793 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57807 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57826 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57828 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57837 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57839 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   57842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57863 */     GIR_RootConstrainSelectedInstOperands,
     /*   57864 */     // GIR_Coverage, 71104,
     /*   57864 */     GIR_EraseRootFromParent_Done,
     /*   57865 */   // Label 919: @57865
     /*   57865 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(57961), // Rule ID 71105 //
     /*   57870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57889 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57903 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57918 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57922 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57924 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57935 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   57938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57959 */     GIR_RootConstrainSelectedInstOperands,
     /*   57960 */     // GIR_Coverage, 71105,
     /*   57960 */     GIR_EraseRootFromParent_Done,
     /*   57961 */   // Label 920: @57961
     /*   57961 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(58057), // Rule ID 71106 //
     /*   57966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57985 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57999 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58014 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58018 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58020 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58031 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58055 */     GIR_RootConstrainSelectedInstOperands,
     /*   58056 */     // GIR_Coverage, 71106,
     /*   58056 */     GIR_EraseRootFromParent_Done,
     /*   58057 */   // Label 921: @58057
     /*   58057 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(58153), // Rule ID 71107 //
     /*   58062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58081 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58095 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58110 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58114 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58116 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58127 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58151 */     GIR_RootConstrainSelectedInstOperands,
     /*   58152 */     // GIR_Coverage, 71107,
     /*   58152 */     GIR_EraseRootFromParent_Done,
     /*   58153 */   // Label 922: @58153
     /*   58153 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(58249), // Rule ID 70962 //
     /*   58158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58177 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58191 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58206 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58210 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58212 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58223 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58247 */     GIR_RootConstrainSelectedInstOperands,
     /*   58248 */     // GIR_Coverage, 70962,
     /*   58248 */     GIR_EraseRootFromParent_Done,
     /*   58249 */   // Label 923: @58249
     /*   58249 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(58345), // Rule ID 70963 //
     /*   58254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58273 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58287 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58302 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58306 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58308 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58319 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58343 */     GIR_RootConstrainSelectedInstOperands,
     /*   58344 */     // GIR_Coverage, 70963,
     /*   58344 */     GIR_EraseRootFromParent_Done,
     /*   58345 */   // Label 924: @58345
     /*   58345 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(58441), // Rule ID 52046 //
     /*   58350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58373 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58387 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58402 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58406 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58408 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58415 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58439 */     GIR_RootConstrainSelectedInstOperands,
     /*   58440 */     // GIR_Coverage, 52046,
     /*   58440 */     GIR_EraseRootFromParent_Done,
     /*   58441 */   // Label 925: @58441
     /*   58441 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(58537), // Rule ID 52047 //
     /*   58446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58483 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58498 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58502 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58504 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58509 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58511 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58535 */     GIR_RootConstrainSelectedInstOperands,
     /*   58536 */     // GIR_Coverage, 52047,
     /*   58536 */     GIR_EraseRootFromParent_Done,
     /*   58537 */   // Label 926: @58537
     /*   58537 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(58633), // Rule ID 52164 //
     /*   58542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58565 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58579 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58594 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58598 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58600 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58607 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58631 */     GIR_RootConstrainSelectedInstOperands,
     /*   58632 */     // GIR_Coverage, 52164,
     /*   58632 */     GIR_EraseRootFromParent_Done,
     /*   58633 */   // Label 927: @58633
     /*   58633 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(58729), // Rule ID 52165 //
     /*   58638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58675 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58690 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58694 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58696 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58701 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58703 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58727 */     GIR_RootConstrainSelectedInstOperands,
     /*   58728 */     // GIR_Coverage, 52165,
     /*   58728 */     GIR_EraseRootFromParent_Done,
     /*   58729 */   // Label 928: @58729
     /*   58729 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(58825), // Rule ID 71102 //
     /*   58734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58757 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58771 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58786 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58790 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58792 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58797 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58799 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58823 */     GIR_RootConstrainSelectedInstOperands,
     /*   58824 */     // GIR_Coverage, 71102,
     /*   58824 */     GIR_EraseRootFromParent_Done,
     /*   58825 */   // Label 929: @58825
     /*   58825 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(58921), // Rule ID 71103 //
     /*   58830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58853 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58867 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58869 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58882 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58886 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58888 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58895 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58919 */     GIR_RootConstrainSelectedInstOperands,
     /*   58920 */     // GIR_Coverage, 71103,
     /*   58920 */     GIR_EraseRootFromParent_Done,
     /*   58921 */   // Label 930: @58921
     /*   58921 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(59017), // Rule ID 52104 //
     /*   58926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58949 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58963 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58978 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58982 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58984 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58989 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58991 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   59006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59015 */     GIR_RootConstrainSelectedInstOperands,
     /*   59016 */     // GIR_Coverage, 52104,
     /*   59016 */     GIR_EraseRootFromParent_Done,
     /*   59017 */   // Label 931: @59017
     /*   59017 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(59113), // Rule ID 52105 //
     /*   59022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59045 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59059 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59074 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59078 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59080 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59087 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   59090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   59102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59111 */     GIR_RootConstrainSelectedInstOperands,
     /*   59112 */     // GIR_Coverage, 52105,
     /*   59112 */     GIR_EraseRootFromParent_Done,
     /*   59113 */   // Label 932: @59113
     /*   59113 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(59202), // Rule ID 46700 //
     /*   59118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59133 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59152 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59161 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59200 */     GIR_RootConstrainSelectedInstOperands,
     /*   59201 */     // GIR_Coverage, 46700,
     /*   59201 */     GIR_EraseRootFromParent_Done,
     /*   59202 */   // Label 933: @59202
     /*   59202 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(59291), // Rule ID 46701 //
     /*   59207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59222 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59241 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59250 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59289 */     GIR_RootConstrainSelectedInstOperands,
     /*   59290 */     // GIR_Coverage, 46701,
     /*   59290 */     GIR_EraseRootFromParent_Done,
     /*   59291 */   // Label 934: @59291
     /*   59291 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(59380), // Rule ID 46464 //
     /*   59296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59311 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59330 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59339 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   59356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59378 */     GIR_RootConstrainSelectedInstOperands,
     /*   59379 */     // GIR_Coverage, 46464,
     /*   59379 */     GIR_EraseRootFromParent_Done,
     /*   59380 */   // Label 935: @59380
     /*   59380 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(59469), // Rule ID 46465 //
     /*   59385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59400 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59419 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59421 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59428 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   59445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59467 */     GIR_RootConstrainSelectedInstOperands,
     /*   59468 */     // GIR_Coverage, 46465,
     /*   59468 */     GIR_EraseRootFromParent_Done,
     /*   59469 */   // Label 936: @59469
     /*   59469 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(59558), // Rule ID 46580 //
     /*   59474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59489 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59508 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59517 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59556 */     GIR_RootConstrainSelectedInstOperands,
     /*   59557 */     // GIR_Coverage, 46580,
     /*   59557 */     GIR_EraseRootFromParent_Done,
     /*   59558 */   // Label 937: @59558
     /*   59558 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(59647), // Rule ID 46581 //
     /*   59563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59578 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59597 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59606 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59645 */     GIR_RootConstrainSelectedInstOperands,
     /*   59646 */     // GIR_Coverage, 46581,
     /*   59646 */     GIR_EraseRootFromParent_Done,
     /*   59647 */   // Label 938: @59647
     /*   59647 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(59715), // Rule ID 70740 //
     /*   59652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59671 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59689 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   59689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   59692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   59698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59713 */     GIR_RootConstrainSelectedInstOperands,
     /*   59714 */     // GIR_Coverage, 70740,
     /*   59714 */     GIR_EraseRootFromParent_Done,
     /*   59715 */   // Label 939: @59715
     /*   59715 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(59783), // Rule ID 70741 //
     /*   59720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59739 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59757 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   59757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   59760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   59766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59781 */     GIR_RootConstrainSelectedInstOperands,
     /*   59782 */     // GIR_Coverage, 70741,
     /*   59782 */     GIR_EraseRootFromParent_Done,
     /*   59783 */   // Label 940: @59783
     /*   59783 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(59838), // Rule ID 69656 //
     /*   59788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59803 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59816 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   59819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59836 */     GIR_RootConstrainSelectedInstOperands,
     /*   59837 */     // GIR_Coverage, 69656,
     /*   59837 */     GIR_EraseRootFromParent_Done,
     /*   59838 */   // Label 941: @59838
     /*   59838 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(59893), // Rule ID 69657 //
     /*   59843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59858 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59871 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   59874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59891 */     GIR_RootConstrainSelectedInstOperands,
     /*   59892 */     // GIR_Coverage, 69657,
     /*   59892 */     GIR_EraseRootFromParent_Done,
     /*   59893 */   // Label 942: @59893
     /*   59893 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(59948), // Rule ID 69476 //
     /*   59898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59913 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59926 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   59929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59946 */     GIR_RootConstrainSelectedInstOperands,
     /*   59947 */     // GIR_Coverage, 69476,
     /*   59947 */     GIR_EraseRootFromParent_Done,
     /*   59948 */   // Label 943: @59948
     /*   59948 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(60003), // Rule ID 69477 //
     /*   59953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59981 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   59984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60001 */     GIR_RootConstrainSelectedInstOperands,
     /*   60002 */     // GIR_Coverage, 69477,
     /*   60002 */     GIR_EraseRootFromParent_Done,
     /*   60003 */   // Label 944: @60003
     /*   60003 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(60058), // Rule ID 69566 //
     /*   60008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60023 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60036 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60056 */     GIR_RootConstrainSelectedInstOperands,
     /*   60057 */     // GIR_Coverage, 69566,
     /*   60057 */     GIR_EraseRootFromParent_Done,
     /*   60058 */   // Label 945: @60058
     /*   60058 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(60113), // Rule ID 69567 //
     /*   60063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60078 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60091 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60111 */     GIR_RootConstrainSelectedInstOperands,
     /*   60112 */     // GIR_Coverage, 69567,
     /*   60112 */     GIR_EraseRootFromParent_Done,
     /*   60113 */   // Label 946: @60113
     /*   60113 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(60181), // Rule ID 51922 //
     /*   60118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60141 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60155 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   60155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60179 */     GIR_RootConstrainSelectedInstOperands,
     /*   60180 */     // GIR_Coverage, 51922,
     /*   60180 */     GIR_EraseRootFromParent_Done,
     /*   60181 */   // Label 947: @60181
     /*   60181 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(60249), // Rule ID 51923 //
     /*   60186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60209 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60223 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   60223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60247 */     GIR_RootConstrainSelectedInstOperands,
     /*   60248 */     // GIR_Coverage, 51923,
     /*   60248 */     GIR_EraseRootFromParent_Done,
     /*   60249 */   // Label 948: @60249
     /*   60249 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(60304), // Rule ID 46760 //
     /*   60254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60273 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60282 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60302 */     GIR_RootConstrainSelectedInstOperands,
     /*   60303 */     // GIR_Coverage, 46760,
     /*   60303 */     GIR_EraseRootFromParent_Done,
     /*   60304 */   // Label 949: @60304
     /*   60304 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(60359), // Rule ID 46761 //
     /*   60309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60337 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60357 */     GIR_RootConstrainSelectedInstOperands,
     /*   60358 */     // GIR_Coverage, 46761,
     /*   60358 */     GIR_EraseRootFromParent_Done,
     /*   60359 */   // Label 950: @60359
     /*   60359 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(60414), // Rule ID 46520 //
     /*   60364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60383 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60392 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60412 */     GIR_RootConstrainSelectedInstOperands,
     /*   60413 */     // GIR_Coverage, 46520,
     /*   60413 */     GIR_EraseRootFromParent_Done,
     /*   60414 */   // Label 951: @60414
     /*   60414 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(60469), // Rule ID 46521 //
     /*   60419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60438 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60447 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60467 */     GIR_RootConstrainSelectedInstOperands,
     /*   60468 */     // GIR_Coverage, 46521,
     /*   60468 */     GIR_EraseRootFromParent_Done,
     /*   60469 */   // Label 952: @60469
     /*   60469 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(60524), // Rule ID 46640 //
     /*   60474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60493 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60502 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60522 */     GIR_RootConstrainSelectedInstOperands,
     /*   60523 */     // GIR_Coverage, 46640,
     /*   60523 */     GIR_EraseRootFromParent_Done,
     /*   60524 */   // Label 953: @60524
     /*   60524 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(60579), // Rule ID 46641 //
     /*   60529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60548 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60557 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60577 */     GIR_RootConstrainSelectedInstOperands,
     /*   60578 */     // GIR_Coverage, 46641,
     /*   60578 */     GIR_EraseRootFromParent_Done,
     /*   60579 */   // Label 954: @60579
     /*   60579 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(60632), // Rule ID 46154 //
     /*   60584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60595 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   60595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   60598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   60612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   60619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60630 */     GIR_RootConstrainSelectedInstOperands,
     /*   60631 */     // GIR_Coverage, 46154,
     /*   60631 */     GIR_EraseRootFromParent_Done,
     /*   60632 */   // Label 955: @60632
     /*   60632 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(60685), // Rule ID 46155 //
     /*   60637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60648 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   60648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   60651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   60665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   60672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60683 */     GIR_RootConstrainSelectedInstOperands,
     /*   60684 */     // GIR_Coverage, 46155,
     /*   60684 */     GIR_EraseRootFromParent_Done,
     /*   60685 */   // Label 956: @60685
     /*   60685 */   GIM_Reject,
     /*   60686 */ // Label 916: @60686
     /*   60686 */ GIM_Reject,
     /*   60687 */ // Label 149: @60687
     /*   60687 */ GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(61081),
     /*   60692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60702 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(60770), // Rule ID 70716 //
     /*   60707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60744 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60768 */     GIR_RootConstrainSelectedInstOperands,
     /*   60769 */     // GIR_Coverage, 70716,
     /*   60769 */     GIR_EraseRootFromParent_Done,
     /*   60770 */   // Label 958: @60770
     /*   60770 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(60838), // Rule ID 70717 //
     /*   60775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60794 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60812 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60836 */     GIR_RootConstrainSelectedInstOperands,
     /*   60837 */     // GIR_Coverage, 70717,
     /*   60837 */     GIR_EraseRootFromParent_Done,
     /*   60838 */   // Label 959: @60838
     /*   60838 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(60906), // Rule ID 51910 //
     /*   60843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60866 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60880 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60904 */     GIR_RootConstrainSelectedInstOperands,
     /*   60905 */     // GIR_Coverage, 51910,
     /*   60905 */     GIR_EraseRootFromParent_Done,
     /*   60906 */   // Label 960: @60906
     /*   60906 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(60974), // Rule ID 51911 //
     /*   60911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60934 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60948 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60972 */     GIR_RootConstrainSelectedInstOperands,
     /*   60973 */     // GIR_Coverage, 51911,
     /*   60973 */     GIR_EraseRootFromParent_Done,
     /*   60974 */   // Label 961: @60974
     /*   60974 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(61027), // Rule ID 46142 //
     /*   60979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60990 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   60990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   60993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   61007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61025 */     GIR_RootConstrainSelectedInstOperands,
     /*   61026 */     // GIR_Coverage, 46142,
     /*   61026 */     GIR_EraseRootFromParent_Done,
     /*   61027 */   // Label 962: @61027
     /*   61027 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(61080), // Rule ID 46143 //
     /*   61032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61043 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   61046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   61060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61078 */     GIR_RootConstrainSelectedInstOperands,
     /*   61079 */     // GIR_Coverage, 46143,
     /*   61079 */     GIR_EraseRootFromParent_Done,
     /*   61080 */   // Label 963: @61080
     /*   61080 */   GIM_Reject,
     /*   61081 */ // Label 957: @61081
     /*   61081 */ GIM_Reject,
     /*   61082 */ // Label 150: @61082
     /*   61082 */ GIM_Reject,
     /*   61083 */ // Label 1: @61083
     /*   61083 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 988*/ GIMT_Encode4(80315),
     /*   61094 */ /*GILLT_s32*//*Label 964*/ GIMT_Encode4(61218),
     /*   61098 */ /*GILLT_s64*//*Label 965*/ GIMT_Encode4(61465), GIMT_Encode4(0),
     /*   61106 */ /*GILLT_nxv1s8*//*Label 966*/ GIMT_Encode4(61741),
     /*   61110 */ /*GILLT_nxv1s16*//*Label 967*/ GIMT_Encode4(61988),
     /*   61114 */ /*GILLT_nxv1s32*//*Label 968*/ GIMT_Encode4(63111),
     /*   61118 */ /*GILLT_nxv1s64*//*Label 969*/ GIMT_Encode4(64234), GIMT_Encode4(0),
     /*   61126 */ /*GILLT_nxv2s8*//*Label 970*/ GIMT_Encode4(65357),
     /*   61130 */ /*GILLT_nxv2s16*//*Label 971*/ GIMT_Encode4(65604),
     /*   61134 */ /*GILLT_nxv2s32*//*Label 972*/ GIMT_Encode4(66727),
     /*   61138 */ /*GILLT_nxv2s64*//*Label 973*/ GIMT_Encode4(67850), GIMT_Encode4(0),
     /*   61146 */ /*GILLT_nxv4s8*//*Label 974*/ GIMT_Encode4(68973),
     /*   61150 */ /*GILLT_nxv4s16*//*Label 975*/ GIMT_Encode4(69220),
     /*   61154 */ /*GILLT_nxv4s32*//*Label 976*/ GIMT_Encode4(70343),
     /*   61158 */ /*GILLT_nxv4s64*//*Label 977*/ GIMT_Encode4(71466), GIMT_Encode4(0),
     /*   61166 */ /*GILLT_nxv8s8*//*Label 978*/ GIMT_Encode4(72589),
     /*   61170 */ /*GILLT_nxv8s16*//*Label 979*/ GIMT_Encode4(72836),
     /*   61174 */ /*GILLT_nxv8s32*//*Label 980*/ GIMT_Encode4(73959),
     /*   61178 */ /*GILLT_nxv8s64*//*Label 981*/ GIMT_Encode4(75082), GIMT_Encode4(0),
     /*   61186 */ /*GILLT_nxv16s8*//*Label 982*/ GIMT_Encode4(76205),
     /*   61190 */ /*GILLT_nxv16s16*//*Label 983*/ GIMT_Encode4(76452),
     /*   61194 */ /*GILLT_nxv16s32*//*Label 984*/ GIMT_Encode4(77575), GIMT_Encode4(0),
     /*   61202 */ /*GILLT_nxv32s8*//*Label 985*/ GIMT_Encode4(78698),
     /*   61206 */ /*GILLT_nxv32s16*//*Label 986*/ GIMT_Encode4(78945), GIMT_Encode4(0),
     /*   61214 */ /*GILLT_nxv64s8*//*Label 987*/ GIMT_Encode4(80068),
     /*   61218 */ // Label 964: @61218
     /*   61218 */ GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(61464),
     /*   61223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   61226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   61229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61233 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(61308), // Rule ID 104 //
     /*   61238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*   61241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61268 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61274 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i64] }), 31:{ *:[i64] })
     /*   61274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   61277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61290 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   61293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   61306 */     GIR_RootConstrainSelectedInstOperands,
     /*   61307 */     // GIR_Coverage, 104,
     /*   61307 */     GIR_EraseRootFromParent_Done,
     /*   61308 */   // Label 990: @61308
     /*   61308 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(61383), // Rule ID 105 //
     /*   61313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*   61316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61336 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61343 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61349 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i32] }), 31:{ *:[i32] })
     /*   61349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   61352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61361 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61365 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   61368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   61381 */     GIR_RootConstrainSelectedInstOperands,
     /*   61382 */     // GIR_Coverage, 105,
     /*   61382 */     GIR_EraseRootFromParent_Done,
     /*   61383 */   // Label 991: @61383
     /*   61383 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(61440), // Rule ID 62601 //
     /*   61388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*   61391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61423 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULS:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   61423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   61426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61438 */     GIR_RootConstrainSelectedInstOperands,
     /*   61439 */     // GIR_Coverage, 62601,
     /*   61439 */     GIR_EraseRootFromParent_Done,
     /*   61440 */   // Label 992: @61440
     /*   61440 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(61463), // Rule ID 83 //
     /*   61445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   61448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61456 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   61456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   61461 */     GIR_RootConstrainSelectedInstOperands,
     /*   61462 */     // GIR_Coverage, 83,
     /*   61462 */     GIR_Done,
     /*   61463 */   // Label 993: @61463
     /*   61463 */   GIM_Reject,
     /*   61464 */ // Label 989: @61464
     /*   61464 */ GIM_Reject,
     /*   61465 */ // Label 965: @61465
     /*   61465 */ GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(61740),
     /*   61470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   61473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   61476 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(61555), // Rule ID 106 //
     /*   61481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   61484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61508 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61515 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61521 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 1:{ *:[i64] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, 63:{ *:[i64] }), 63:{ *:[i64] })
     /*   61521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   61524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61537 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*   61540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /*   61553 */     GIR_RootConstrainSelectedInstOperands,
     /*   61554 */     // GIR_Coverage, 106,
     /*   61554 */     GIR_EraseRootFromParent_Done,
     /*   61555 */   // Label 995: @61555
     /*   61555 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(61620), // Rule ID 62603 //
     /*   61560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   61563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10045),
     /*   61601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61603 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10045>>  =>  (TH_MULSW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULSW),
     /*   61606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61618 */     GIR_RootConstrainSelectedInstOperands,
     /*   61619 */     // GIR_Coverage, 62603,
     /*   61619 */     GIR_EraseRootFromParent_Done,
     /*   61620 */   // Label 996: @61620
     /*   61620 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(61681), // Rule ID 62600 //
     /*   61625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   61628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61664 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULS:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   61667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61679 */     GIR_RootConstrainSelectedInstOperands,
     /*   61680 */     // GIR_Coverage, 62600,
     /*   61680 */     GIR_EraseRootFromParent_Done,
     /*   61681 */   // Label 997: @61681
     /*   61681 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(61712), // Rule ID 277 //
     /*   61686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   61689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10045),
     /*   61705 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10045>>  =>  (SUBW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUBW),
     /*   61710 */     GIR_RootConstrainSelectedInstOperands,
     /*   61711 */     // GIR_Coverage, 277,
     /*   61711 */     GIR_Done,
     /*   61712 */   // Label 998: @61712
     /*   61712 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(61739), // Rule ID 82 //
     /*   61717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   61720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61732 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (SUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   61737 */     GIR_RootConstrainSelectedInstOperands,
     /*   61738 */     // GIR_Coverage, 82,
     /*   61738 */     GIR_Done,
     /*   61739 */   // Label 999: @61739
     /*   61739 */   GIM_Reject,
     /*   61740 */ // Label 994: @61740
     /*   61740 */ GIM_Reject,
     /*   61741 */ // Label 966: @61741
     /*   61741 */ GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(61987),
     /*   61746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   61749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   61752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61760 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(61824), // Rule ID 51950 //
     /*   61765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   61780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   61784 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61798 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   61798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   61801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61822 */     GIR_RootConstrainSelectedInstOperands,
     /*   61823 */     // GIR_Coverage, 51950,
     /*   61823 */     GIR_EraseRootFromParent_Done,
     /*   61824 */   // Label 1001: @61824
     /*   61824 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(61888), // Rule ID 51951 //
     /*   61829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   61844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   61848 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61862 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   61862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   61865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61886 */     GIR_RootConstrainSelectedInstOperands,
     /*   61887 */     // GIR_Coverage, 51951,
     /*   61887 */     GIR_EraseRootFromParent_Done,
     /*   61888 */   // Label 1002: @61888
     /*   61888 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(61937), // Rule ID 46224 //
     /*   61893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61900 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   61900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   61903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   61917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61935 */     GIR_RootConstrainSelectedInstOperands,
     /*   61936 */     // GIR_Coverage, 46224,
     /*   61936 */     GIR_EraseRootFromParent_Done,
     /*   61937 */   // Label 1003: @61937
     /*   61937 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61986), // Rule ID 46225 //
     /*   61942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61949 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   61952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   61966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61984 */     GIR_RootConstrainSelectedInstOperands,
     /*   61985 */     // GIR_Coverage, 46225,
     /*   61985 */     GIR_EraseRootFromParent_Done,
     /*   61986 */   // Label 1004: @61986
     /*   61986 */   GIM_Reject,
     /*   61987 */ // Label 1000: @61987
     /*   61987 */ GIM_Reject,
     /*   61988 */ // Label 967: @61988
     /*   61988 */ GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(63110),
     /*   61993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   61996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   61999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62003 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(62092), // Rule ID 47220 //
     /*   62008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62023 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62042 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62051 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62090 */     GIR_RootConstrainSelectedInstOperands,
     /*   62091 */     // GIR_Coverage, 47220,
     /*   62091 */     GIR_EraseRootFromParent_Done,
     /*   62092 */   // Label 1006: @62092
     /*   62092 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(62181), // Rule ID 47221 //
     /*   62097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62112 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62131 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62140 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62179 */     GIR_RootConstrainSelectedInstOperands,
     /*   62180 */     // GIR_Coverage, 47221,
     /*   62180 */     GIR_EraseRootFromParent_Done,
     /*   62181 */   // Label 1007: @62181
     /*   62181 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(62270), // Rule ID 46980 //
     /*   62186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62220 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62229 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   62246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62268 */     GIR_RootConstrainSelectedInstOperands,
     /*   62269 */     // GIR_Coverage, 46980,
     /*   62269 */     GIR_EraseRootFromParent_Done,
     /*   62270 */   // Label 1008: @62270
     /*   62270 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(62359), // Rule ID 46981 //
     /*   62275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62290 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62309 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62318 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   62335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62357 */     GIR_RootConstrainSelectedInstOperands,
     /*   62358 */     // GIR_Coverage, 46981,
     /*   62358 */     GIR_EraseRootFromParent_Done,
     /*   62359 */   // Label 1009: @62359
     /*   62359 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(62448), // Rule ID 47100 //
     /*   62364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62379 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62398 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62407 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62446 */     GIR_RootConstrainSelectedInstOperands,
     /*   62447 */     // GIR_Coverage, 47100,
     /*   62447 */     GIR_EraseRootFromParent_Done,
     /*   62448 */   // Label 1010: @62448
     /*   62448 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(62537), // Rule ID 47101 //
     /*   62453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62468 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62487 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62496 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62535 */     GIR_RootConstrainSelectedInstOperands,
     /*   62536 */     // GIR_Coverage, 47101,
     /*   62536 */     GIR_EraseRootFromParent_Done,
     /*   62537 */   // Label 1011: @62537
     /*   62537 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(62605), // Rule ID 51962 //
     /*   62542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   62561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   62565 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62579 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   62579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   62582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62603 */     GIR_RootConstrainSelectedInstOperands,
     /*   62604 */     // GIR_Coverage, 51962,
     /*   62604 */     GIR_EraseRootFromParent_Done,
     /*   62605 */   // Label 1012: @62605
     /*   62605 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(62673), // Rule ID 51963 //
     /*   62610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   62629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   62633 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62647 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   62647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   62650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62671 */     GIR_RootConstrainSelectedInstOperands,
     /*   62672 */     // GIR_Coverage, 51963,
     /*   62672 */     GIR_EraseRootFromParent_Done,
     /*   62673 */   // Label 1013: @62673
     /*   62673 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(62728), // Rule ID 47280 //
     /*   62678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62706 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62726 */     GIR_RootConstrainSelectedInstOperands,
     /*   62727 */     // GIR_Coverage, 47280,
     /*   62727 */     GIR_EraseRootFromParent_Done,
     /*   62728 */   // Label 1014: @62728
     /*   62728 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(62783), // Rule ID 47281 //
     /*   62733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62761 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62781 */     GIR_RootConstrainSelectedInstOperands,
     /*   62782 */     // GIR_Coverage, 47281,
     /*   62782 */     GIR_EraseRootFromParent_Done,
     /*   62783 */   // Label 1015: @62783
     /*   62783 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(62838), // Rule ID 47040 //
     /*   62788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62807 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62816 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   62819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62836 */     GIR_RootConstrainSelectedInstOperands,
     /*   62837 */     // GIR_Coverage, 47040,
     /*   62837 */     GIR_EraseRootFromParent_Done,
     /*   62838 */   // Label 1016: @62838
     /*   62838 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(62893), // Rule ID 47041 //
     /*   62843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62862 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62871 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   62874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62891 */     GIR_RootConstrainSelectedInstOperands,
     /*   62892 */     // GIR_Coverage, 47041,
     /*   62892 */     GIR_EraseRootFromParent_Done,
     /*   62893 */   // Label 1017: @62893
     /*   62893 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(62948), // Rule ID 47160 //
     /*   62898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62917 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62926 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62946 */     GIR_RootConstrainSelectedInstOperands,
     /*   62947 */     // GIR_Coverage, 47160,
     /*   62947 */     GIR_EraseRootFromParent_Done,
     /*   62948 */   // Label 1018: @62948
     /*   62948 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(63003), // Rule ID 47161 //
     /*   62953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62972 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62981 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63001 */     GIR_RootConstrainSelectedInstOperands,
     /*   63002 */     // GIR_Coverage, 47161,
     /*   63002 */     GIR_EraseRootFromParent_Done,
     /*   63003 */   // Label 1019: @63003
     /*   63003 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(63056), // Rule ID 46236 //
     /*   63008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63019 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   63022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   63036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63054 */     GIR_RootConstrainSelectedInstOperands,
     /*   63055 */     // GIR_Coverage, 46236,
     /*   63055 */     GIR_EraseRootFromParent_Done,
     /*   63056 */   // Label 1020: @63056
     /*   63056 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(63109), // Rule ID 46237 //
     /*   63061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63072 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   63075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   63089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63107 */     GIR_RootConstrainSelectedInstOperands,
     /*   63108 */     // GIR_Coverage, 46237,
     /*   63108 */     GIR_EraseRootFromParent_Done,
     /*   63109 */   // Label 1021: @63109
     /*   63109 */   GIM_Reject,
     /*   63110 */ // Label 1005: @63110
     /*   63110 */ GIM_Reject,
     /*   63111 */ // Label 968: @63111
     /*   63111 */ GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(64233),
     /*   63116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63126 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(63215), // Rule ID 47244 //
     /*   63131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63146 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63165 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63174 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63213 */     GIR_RootConstrainSelectedInstOperands,
     /*   63214 */     // GIR_Coverage, 47244,
     /*   63214 */     GIR_EraseRootFromParent_Done,
     /*   63215 */   // Label 1023: @63215
     /*   63215 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(63304), // Rule ID 47245 //
     /*   63220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63235 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63254 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63263 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63302 */     GIR_RootConstrainSelectedInstOperands,
     /*   63303 */     // GIR_Coverage, 47245,
     /*   63303 */     GIR_EraseRootFromParent_Done,
     /*   63304 */   // Label 1024: @63304
     /*   63304 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(63393), // Rule ID 47004 //
     /*   63309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63324 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63343 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63352 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   63369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63391 */     GIR_RootConstrainSelectedInstOperands,
     /*   63392 */     // GIR_Coverage, 47004,
     /*   63392 */     GIR_EraseRootFromParent_Done,
     /*   63393 */   // Label 1025: @63393
     /*   63393 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(63482), // Rule ID 47005 //
     /*   63398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63413 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63432 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63441 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   63458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63480 */     GIR_RootConstrainSelectedInstOperands,
     /*   63481 */     // GIR_Coverage, 47005,
     /*   63481 */     GIR_EraseRootFromParent_Done,
     /*   63482 */   // Label 1026: @63482
     /*   63482 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(63571), // Rule ID 47124 //
     /*   63487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63502 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63521 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63523 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63530 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63569 */     GIR_RootConstrainSelectedInstOperands,
     /*   63570 */     // GIR_Coverage, 47124,
     /*   63570 */     GIR_EraseRootFromParent_Done,
     /*   63571 */   // Label 1027: @63571
     /*   63571 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(63660), // Rule ID 47125 //
     /*   63576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63591 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63610 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63619 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63658 */     GIR_RootConstrainSelectedInstOperands,
     /*   63659 */     // GIR_Coverage, 47125,
     /*   63659 */     GIR_EraseRootFromParent_Done,
     /*   63660 */   // Label 1028: @63660
     /*   63660 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(63728), // Rule ID 51970 //
     /*   63665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63688 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63702 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   63702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   63705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63726 */     GIR_RootConstrainSelectedInstOperands,
     /*   63727 */     // GIR_Coverage, 51970,
     /*   63727 */     GIR_EraseRootFromParent_Done,
     /*   63728 */   // Label 1029: @63728
     /*   63728 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(63796), // Rule ID 51971 //
     /*   63733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63756 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63770 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   63770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   63773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63794 */     GIR_RootConstrainSelectedInstOperands,
     /*   63795 */     // GIR_Coverage, 51971,
     /*   63795 */     GIR_EraseRootFromParent_Done,
     /*   63796 */   // Label 1030: @63796
     /*   63796 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(63851), // Rule ID 47304 //
     /*   63801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63820 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63829 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   63829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   63832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63849 */     GIR_RootConstrainSelectedInstOperands,
     /*   63850 */     // GIR_Coverage, 47304,
     /*   63850 */     GIR_EraseRootFromParent_Done,
     /*   63851 */   // Label 1031: @63851
     /*   63851 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(63906), // Rule ID 47305 //
     /*   63856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63875 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63884 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   63884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   63887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63904 */     GIR_RootConstrainSelectedInstOperands,
     /*   63905 */     // GIR_Coverage, 47305,
     /*   63905 */     GIR_EraseRootFromParent_Done,
     /*   63906 */   // Label 1032: @63906
     /*   63906 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(63961), // Rule ID 47064 //
     /*   63911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63930 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63939 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   63939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   63942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63959 */     GIR_RootConstrainSelectedInstOperands,
     /*   63960 */     // GIR_Coverage, 47064,
     /*   63960 */     GIR_EraseRootFromParent_Done,
     /*   63961 */   // Label 1033: @63961
     /*   63961 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(64016), // Rule ID 47065 //
     /*   63966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63985 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63994 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   63994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   63997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64014 */     GIR_RootConstrainSelectedInstOperands,
     /*   64015 */     // GIR_Coverage, 47065,
     /*   64015 */     GIR_EraseRootFromParent_Done,
     /*   64016 */   // Label 1034: @64016
     /*   64016 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(64071), // Rule ID 47184 //
     /*   64021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64049 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   64049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64069 */     GIR_RootConstrainSelectedInstOperands,
     /*   64070 */     // GIR_Coverage, 47184,
     /*   64070 */     GIR_EraseRootFromParent_Done,
     /*   64071 */   // Label 1035: @64071
     /*   64071 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(64126), // Rule ID 47185 //
     /*   64076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64095 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64104 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   64104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64124 */     GIR_RootConstrainSelectedInstOperands,
     /*   64125 */     // GIR_Coverage, 47185,
     /*   64125 */     GIR_EraseRootFromParent_Done,
     /*   64126 */   // Label 1036: @64126
     /*   64126 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(64179), // Rule ID 46244 //
     /*   64131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64142 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   64159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64177 */     GIR_RootConstrainSelectedInstOperands,
     /*   64178 */     // GIR_Coverage, 46244,
     /*   64178 */     GIR_EraseRootFromParent_Done,
     /*   64179 */   // Label 1037: @64179
     /*   64179 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(64232), // Rule ID 46245 //
     /*   64184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64195 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   64212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64230 */     GIR_RootConstrainSelectedInstOperands,
     /*   64231 */     // GIR_Coverage, 46245,
     /*   64231 */     GIR_EraseRootFromParent_Done,
     /*   64232 */   // Label 1038: @64232
     /*   64232 */   GIM_Reject,
     /*   64233 */ // Label 1022: @64233
     /*   64233 */ GIM_Reject,
     /*   64234 */ // Label 969: @64234
     /*   64234 */ GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(65356),
     /*   64239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64249 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(64338), // Rule ID 47264 //
     /*   64254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64269 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64288 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64297 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64336 */     GIR_RootConstrainSelectedInstOperands,
     /*   64337 */     // GIR_Coverage, 47264,
     /*   64337 */     GIR_EraseRootFromParent_Done,
     /*   64338 */   // Label 1040: @64338
     /*   64338 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(64427), // Rule ID 47265 //
     /*   64343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64358 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64377 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64379 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64386 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64425 */     GIR_RootConstrainSelectedInstOperands,
     /*   64426 */     // GIR_Coverage, 47265,
     /*   64426 */     GIR_EraseRootFromParent_Done,
     /*   64427 */   // Label 1041: @64427
     /*   64427 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(64516), // Rule ID 47024 //
     /*   64432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64447 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64466 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64475 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   64492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64514 */     GIR_RootConstrainSelectedInstOperands,
     /*   64515 */     // GIR_Coverage, 47024,
     /*   64515 */     GIR_EraseRootFromParent_Done,
     /*   64516 */   // Label 1042: @64516
     /*   64516 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(64605), // Rule ID 47025 //
     /*   64521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64555 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64564 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   64581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64603 */     GIR_RootConstrainSelectedInstOperands,
     /*   64604 */     // GIR_Coverage, 47025,
     /*   64604 */     GIR_EraseRootFromParent_Done,
     /*   64605 */   // Label 1043: @64605
     /*   64605 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(64694), // Rule ID 47144 //
     /*   64610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64625 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64644 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64653 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64692 */     GIR_RootConstrainSelectedInstOperands,
     /*   64693 */     // GIR_Coverage, 47144,
     /*   64693 */     GIR_EraseRootFromParent_Done,
     /*   64694 */   // Label 1044: @64694
     /*   64694 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(64783), // Rule ID 47145 //
     /*   64699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64714 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64733 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64742 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64781 */     GIR_RootConstrainSelectedInstOperands,
     /*   64782 */     // GIR_Coverage, 47145,
     /*   64782 */     GIR_EraseRootFromParent_Done,
     /*   64783 */   // Label 1045: @64783
     /*   64783 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(64851), // Rule ID 51986 //
     /*   64788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   64791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64811 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64825 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   64825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   64828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   64846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64849 */     GIR_RootConstrainSelectedInstOperands,
     /*   64850 */     // GIR_Coverage, 51986,
     /*   64850 */     GIR_EraseRootFromParent_Done,
     /*   64851 */   // Label 1046: @64851
     /*   64851 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(64919), // Rule ID 51987 //
     /*   64856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   64859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64879 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64893 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   64893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   64896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   64914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64917 */     GIR_RootConstrainSelectedInstOperands,
     /*   64918 */     // GIR_Coverage, 51987,
     /*   64918 */     GIR_EraseRootFromParent_Done,
     /*   64919 */   // Label 1047: @64919
     /*   64919 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(64974), // Rule ID 47324 //
     /*   64924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64943 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64952 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   64952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   64955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64972 */     GIR_RootConstrainSelectedInstOperands,
     /*   64973 */     // GIR_Coverage, 47324,
     /*   64973 */     GIR_EraseRootFromParent_Done,
     /*   64974 */   // Label 1048: @64974
     /*   64974 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(65029), // Rule ID 47325 //
     /*   64979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64998 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65007 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65027 */     GIR_RootConstrainSelectedInstOperands,
     /*   65028 */     // GIR_Coverage, 47325,
     /*   65028 */     GIR_EraseRootFromParent_Done,
     /*   65029 */   // Label 1049: @65029
     /*   65029 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(65084), // Rule ID 47084 //
     /*   65034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65053 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65062 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65082 */     GIR_RootConstrainSelectedInstOperands,
     /*   65083 */     // GIR_Coverage, 47084,
     /*   65083 */     GIR_EraseRootFromParent_Done,
     /*   65084 */   // Label 1050: @65084
     /*   65084 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(65139), // Rule ID 47085 //
     /*   65089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65108 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65117 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65137 */     GIR_RootConstrainSelectedInstOperands,
     /*   65138 */     // GIR_Coverage, 47085,
     /*   65138 */     GIR_EraseRootFromParent_Done,
     /*   65139 */   // Label 1051: @65139
     /*   65139 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(65194), // Rule ID 47204 //
     /*   65144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65172 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65192 */     GIR_RootConstrainSelectedInstOperands,
     /*   65193 */     // GIR_Coverage, 47204,
     /*   65193 */     GIR_EraseRootFromParent_Done,
     /*   65194 */   // Label 1052: @65194
     /*   65194 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(65249), // Rule ID 47205 //
     /*   65199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65227 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65247 */     GIR_RootConstrainSelectedInstOperands,
     /*   65248 */     // GIR_Coverage, 47205,
     /*   65248 */     GIR_EraseRootFromParent_Done,
     /*   65249 */   // Label 1053: @65249
     /*   65249 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(65302), // Rule ID 46260 //
     /*   65254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   65257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65265 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   65265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   65282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65300 */     GIR_RootConstrainSelectedInstOperands,
     /*   65301 */     // GIR_Coverage, 46260,
     /*   65301 */     GIR_EraseRootFromParent_Done,
     /*   65302 */   // Label 1054: @65302
     /*   65302 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(65355), // Rule ID 46261 //
     /*   65307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   65310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65318 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   65318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   65335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65353 */     GIR_RootConstrainSelectedInstOperands,
     /*   65354 */     // GIR_Coverage, 46261,
     /*   65354 */     GIR_EraseRootFromParent_Done,
     /*   65355 */   // Label 1055: @65355
     /*   65355 */   GIM_Reject,
     /*   65356 */ // Label 1039: @65356
     /*   65356 */ GIM_Reject,
     /*   65357 */ // Label 970: @65357
     /*   65357 */ GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(65603),
     /*   65362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65376 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(65440), // Rule ID 51954 //
     /*   65381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65400 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65414 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   65414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   65417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65438 */     GIR_RootConstrainSelectedInstOperands,
     /*   65439 */     // GIR_Coverage, 51954,
     /*   65439 */     GIR_EraseRootFromParent_Done,
     /*   65440 */   // Label 1057: @65440
     /*   65440 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(65504), // Rule ID 51955 //
     /*   65445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65464 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65478 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   65478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   65481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65502 */     GIR_RootConstrainSelectedInstOperands,
     /*   65503 */     // GIR_Coverage, 51955,
     /*   65503 */     GIR_EraseRootFromParent_Done,
     /*   65504 */   // Label 1058: @65504
     /*   65504 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(65553), // Rule ID 46228 //
     /*   65509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65516 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   65519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   65533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65551 */     GIR_RootConstrainSelectedInstOperands,
     /*   65552 */     // GIR_Coverage, 46228,
     /*   65552 */     GIR_EraseRootFromParent_Done,
     /*   65553 */   // Label 1059: @65553
     /*   65553 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(65602), // Rule ID 46229 //
     /*   65558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65565 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   65568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   65582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65600 */     GIR_RootConstrainSelectedInstOperands,
     /*   65601 */     // GIR_Coverage, 46229,
     /*   65601 */     GIR_EraseRootFromParent_Done,
     /*   65602 */   // Label 1060: @65602
     /*   65602 */   GIM_Reject,
     /*   65603 */ // Label 1056: @65603
     /*   65603 */ GIM_Reject,
     /*   65604 */ // Label 971: @65604
     /*   65604 */ GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(66726),
     /*   65609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   65612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   65615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65619 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(65708), // Rule ID 47224 //
     /*   65624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65639 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65658 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65667 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   65684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65706 */     GIR_RootConstrainSelectedInstOperands,
     /*   65707 */     // GIR_Coverage, 47224,
     /*   65707 */     GIR_EraseRootFromParent_Done,
     /*   65708 */   // Label 1062: @65708
     /*   65708 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(65797), // Rule ID 47225 //
     /*   65713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65728 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65747 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65756 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   65773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65795 */     GIR_RootConstrainSelectedInstOperands,
     /*   65796 */     // GIR_Coverage, 47225,
     /*   65796 */     GIR_EraseRootFromParent_Done,
     /*   65797 */   // Label 1063: @65797
     /*   65797 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(65886), // Rule ID 46984 //
     /*   65802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65817 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65836 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65845 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   65862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65884 */     GIR_RootConstrainSelectedInstOperands,
     /*   65885 */     // GIR_Coverage, 46984,
     /*   65885 */     GIR_EraseRootFromParent_Done,
     /*   65886 */   // Label 1064: @65886
     /*   65886 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(65975), // Rule ID 46985 //
     /*   65891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65906 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65925 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65934 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   65951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65973 */     GIR_RootConstrainSelectedInstOperands,
     /*   65974 */     // GIR_Coverage, 46985,
     /*   65974 */     GIR_EraseRootFromParent_Done,
     /*   65975 */   // Label 1065: @65975
     /*   65975 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(66064), // Rule ID 47104 //
     /*   65980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65995 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66014 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66023 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   66023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66062 */     GIR_RootConstrainSelectedInstOperands,
     /*   66063 */     // GIR_Coverage, 47104,
     /*   66063 */     GIR_EraseRootFromParent_Done,
     /*   66064 */   // Label 1066: @66064
     /*   66064 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(66153), // Rule ID 47105 //
     /*   66069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66084 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66103 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66112 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   66112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66151 */     GIR_RootConstrainSelectedInstOperands,
     /*   66152 */     // GIR_Coverage, 47105,
     /*   66152 */     GIR_EraseRootFromParent_Done,
     /*   66153 */   // Label 1067: @66153
     /*   66153 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(66221), // Rule ID 51966 //
     /*   66158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66181 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66195 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   66195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   66198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66219 */     GIR_RootConstrainSelectedInstOperands,
     /*   66220 */     // GIR_Coverage, 51966,
     /*   66220 */     GIR_EraseRootFromParent_Done,
     /*   66221 */   // Label 1068: @66221
     /*   66221 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(66289), // Rule ID 51967 //
     /*   66226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66249 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66263 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   66263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   66266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66287 */     GIR_RootConstrainSelectedInstOperands,
     /*   66288 */     // GIR_Coverage, 51967,
     /*   66288 */     GIR_EraseRootFromParent_Done,
     /*   66289 */   // Label 1069: @66289
     /*   66289 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(66344), // Rule ID 47284 //
     /*   66294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66313 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66322 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66342 */     GIR_RootConstrainSelectedInstOperands,
     /*   66343 */     // GIR_Coverage, 47284,
     /*   66343 */     GIR_EraseRootFromParent_Done,
     /*   66344 */   // Label 1070: @66344
     /*   66344 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(66399), // Rule ID 47285 //
     /*   66349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66368 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66377 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66397 */     GIR_RootConstrainSelectedInstOperands,
     /*   66398 */     // GIR_Coverage, 47285,
     /*   66398 */     GIR_EraseRootFromParent_Done,
     /*   66399 */   // Label 1071: @66399
     /*   66399 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(66454), // Rule ID 47044 //
     /*   66404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66423 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66432 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   66435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66452 */     GIR_RootConstrainSelectedInstOperands,
     /*   66453 */     // GIR_Coverage, 47044,
     /*   66453 */     GIR_EraseRootFromParent_Done,
     /*   66454 */   // Label 1072: @66454
     /*   66454 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(66509), // Rule ID 47045 //
     /*   66459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66478 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66487 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   66490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66507 */     GIR_RootConstrainSelectedInstOperands,
     /*   66508 */     // GIR_Coverage, 47045,
     /*   66508 */     GIR_EraseRootFromParent_Done,
     /*   66509 */   // Label 1073: @66509
     /*   66509 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(66564), // Rule ID 47164 //
     /*   66514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66533 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66542 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66562 */     GIR_RootConstrainSelectedInstOperands,
     /*   66563 */     // GIR_Coverage, 47164,
     /*   66563 */     GIR_EraseRootFromParent_Done,
     /*   66564 */   // Label 1074: @66564
     /*   66564 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(66619), // Rule ID 47165 //
     /*   66569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66588 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66597 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66617 */     GIR_RootConstrainSelectedInstOperands,
     /*   66618 */     // GIR_Coverage, 47165,
     /*   66618 */     GIR_EraseRootFromParent_Done,
     /*   66619 */   // Label 1075: @66619
     /*   66619 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(66672), // Rule ID 46240 //
     /*   66624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66635 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   66652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   66659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   66661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66670 */     GIR_RootConstrainSelectedInstOperands,
     /*   66671 */     // GIR_Coverage, 46240,
     /*   66671 */     GIR_EraseRootFromParent_Done,
     /*   66672 */   // Label 1076: @66672
     /*   66672 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(66725), // Rule ID 46241 //
     /*   66677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66688 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   66688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   66705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   66712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   66714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66723 */     GIR_RootConstrainSelectedInstOperands,
     /*   66724 */     // GIR_Coverage, 46241,
     /*   66724 */     GIR_EraseRootFromParent_Done,
     /*   66725 */   // Label 1077: @66725
     /*   66725 */   GIM_Reject,
     /*   66726 */ // Label 1061: @66726
     /*   66726 */ GIM_Reject,
     /*   66727 */ // Label 972: @66727
     /*   66727 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(67849),
     /*   66732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   66735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   66738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66742 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(66831), // Rule ID 47248 //
     /*   66747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66762 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66781 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66790 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   66793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   66807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66829 */     GIR_RootConstrainSelectedInstOperands,
     /*   66830 */     // GIR_Coverage, 47248,
     /*   66830 */     GIR_EraseRootFromParent_Done,
     /*   66831 */   // Label 1079: @66831
     /*   66831 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(66920), // Rule ID 47249 //
     /*   66836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66851 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66870 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66877 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66879 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   66879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   66882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   66896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66918 */     GIR_RootConstrainSelectedInstOperands,
     /*   66919 */     // GIR_Coverage, 47249,
     /*   66919 */     GIR_EraseRootFromParent_Done,
     /*   66920 */   // Label 1080: @66920
     /*   66920 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(67009), // Rule ID 47008 //
     /*   66925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66940 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66959 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66961 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66968 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   66971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   66985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67007 */     GIR_RootConstrainSelectedInstOperands,
     /*   67008 */     // GIR_Coverage, 47008,
     /*   67008 */     GIR_EraseRootFromParent_Done,
     /*   67009 */   // Label 1081: @67009
     /*   67009 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(67098), // Rule ID 47009 //
     /*   67014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67029 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67048 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67057 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   67074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67096 */     GIR_RootConstrainSelectedInstOperands,
     /*   67097 */     // GIR_Coverage, 47009,
     /*   67097 */     GIR_EraseRootFromParent_Done,
     /*   67098 */   // Label 1082: @67098
     /*   67098 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(67187), // Rule ID 47128 //
     /*   67103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67118 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67137 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67146 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   67146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67185 */     GIR_RootConstrainSelectedInstOperands,
     /*   67186 */     // GIR_Coverage, 47128,
     /*   67186 */     GIR_EraseRootFromParent_Done,
     /*   67187 */   // Label 1083: @67187
     /*   67187 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(67276), // Rule ID 47129 //
     /*   67192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67207 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67226 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67235 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67274 */     GIR_RootConstrainSelectedInstOperands,
     /*   67275 */     // GIR_Coverage, 47129,
     /*   67275 */     GIR_EraseRootFromParent_Done,
     /*   67276 */   // Label 1084: @67276
     /*   67276 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(67344), // Rule ID 51982 //
     /*   67281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67304 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67318 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   67318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   67321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   67327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67342 */     GIR_RootConstrainSelectedInstOperands,
     /*   67343 */     // GIR_Coverage, 51982,
     /*   67343 */     GIR_EraseRootFromParent_Done,
     /*   67344 */   // Label 1085: @67344
     /*   67344 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(67412), // Rule ID 51983 //
     /*   67349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67372 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67386 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   67386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   67389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   67395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67410 */     GIR_RootConstrainSelectedInstOperands,
     /*   67411 */     // GIR_Coverage, 51983,
     /*   67411 */     GIR_EraseRootFromParent_Done,
     /*   67412 */   // Label 1086: @67412
     /*   67412 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(67467), // Rule ID 47308 //
     /*   67417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67445 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67465 */     GIR_RootConstrainSelectedInstOperands,
     /*   67466 */     // GIR_Coverage, 47308,
     /*   67466 */     GIR_EraseRootFromParent_Done,
     /*   67467 */   // Label 1087: @67467
     /*   67467 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(67522), // Rule ID 47309 //
     /*   67472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67500 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67520 */     GIR_RootConstrainSelectedInstOperands,
     /*   67521 */     // GIR_Coverage, 47309,
     /*   67521 */     GIR_EraseRootFromParent_Done,
     /*   67522 */   // Label 1088: @67522
     /*   67522 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(67577), // Rule ID 47068 //
     /*   67527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67555 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   67558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67575 */     GIR_RootConstrainSelectedInstOperands,
     /*   67576 */     // GIR_Coverage, 47068,
     /*   67576 */     GIR_EraseRootFromParent_Done,
     /*   67577 */   // Label 1089: @67577
     /*   67577 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(67632), // Rule ID 47069 //
     /*   67582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67601 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67610 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   67613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67630 */     GIR_RootConstrainSelectedInstOperands,
     /*   67631 */     // GIR_Coverage, 47069,
     /*   67631 */     GIR_EraseRootFromParent_Done,
     /*   67632 */   // Label 1090: @67632
     /*   67632 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(67687), // Rule ID 47188 //
     /*   67637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67665 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67685 */     GIR_RootConstrainSelectedInstOperands,
     /*   67686 */     // GIR_Coverage, 47188,
     /*   67686 */     GIR_EraseRootFromParent_Done,
     /*   67687 */   // Label 1091: @67687
     /*   67687 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(67742), // Rule ID 47189 //
     /*   67692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67711 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67720 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67740 */     GIR_RootConstrainSelectedInstOperands,
     /*   67741 */     // GIR_Coverage, 47189,
     /*   67741 */     GIR_EraseRootFromParent_Done,
     /*   67742 */   // Label 1092: @67742
     /*   67742 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(67795), // Rule ID 46256 //
     /*   67747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67758 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   67758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   67775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67793 */     GIR_RootConstrainSelectedInstOperands,
     /*   67794 */     // GIR_Coverage, 46256,
     /*   67794 */     GIR_EraseRootFromParent_Done,
     /*   67795 */   // Label 1093: @67795
     /*   67795 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(67848), // Rule ID 46257 //
     /*   67800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67811 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   67811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   67828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67846 */     GIR_RootConstrainSelectedInstOperands,
     /*   67847 */     // GIR_Coverage, 46257,
     /*   67847 */     GIR_EraseRootFromParent_Done,
     /*   67848 */   // Label 1094: @67848
     /*   67848 */   GIM_Reject,
     /*   67849 */ // Label 1078: @67849
     /*   67849 */ GIM_Reject,
     /*   67850 */ // Label 973: @67850
     /*   67850 */ GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(68972),
     /*   67855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   67858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   67861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67865 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(67954), // Rule ID 47268 //
     /*   67870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   67873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67885 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67904 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67913 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   67913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   67916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   67930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67952 */     GIR_RootConstrainSelectedInstOperands,
     /*   67953 */     // GIR_Coverage, 47268,
     /*   67953 */     GIR_EraseRootFromParent_Done,
     /*   67954 */   // Label 1096: @67954
     /*   67954 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(68043), // Rule ID 47269 //
     /*   67959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   67962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67974 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67993 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68002 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68041 */     GIR_RootConstrainSelectedInstOperands,
     /*   68042 */     // GIR_Coverage, 47269,
     /*   68042 */     GIR_EraseRootFromParent_Done,
     /*   68043 */   // Label 1097: @68043
     /*   68043 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(68132), // Rule ID 47028 //
     /*   68048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68063 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68082 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68091 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   68108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68130 */     GIR_RootConstrainSelectedInstOperands,
     /*   68131 */     // GIR_Coverage, 47028,
     /*   68131 */     GIR_EraseRootFromParent_Done,
     /*   68132 */   // Label 1098: @68132
     /*   68132 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(68221), // Rule ID 47029 //
     /*   68137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68152 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68171 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68180 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   68197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68219 */     GIR_RootConstrainSelectedInstOperands,
     /*   68220 */     // GIR_Coverage, 47029,
     /*   68220 */     GIR_EraseRootFromParent_Done,
     /*   68221 */   // Label 1099: @68221
     /*   68221 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(68310), // Rule ID 47148 //
     /*   68226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68241 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68260 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68269 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68308 */     GIR_RootConstrainSelectedInstOperands,
     /*   68309 */     // GIR_Coverage, 47148,
     /*   68309 */     GIR_EraseRootFromParent_Done,
     /*   68310 */   // Label 1100: @68310
     /*   68310 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(68399), // Rule ID 47149 //
     /*   68315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68330 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68349 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68358 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68397 */     GIR_RootConstrainSelectedInstOperands,
     /*   68398 */     // GIR_Coverage, 47149,
     /*   68398 */     GIR_EraseRootFromParent_Done,
     /*   68399 */   // Label 1101: @68399
     /*   68399 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(68467), // Rule ID 52026 //
     /*   68404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   68407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68427 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68441 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   68441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   68444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68465 */     GIR_RootConstrainSelectedInstOperands,
     /*   68466 */     // GIR_Coverage, 52026,
     /*   68466 */     GIR_EraseRootFromParent_Done,
     /*   68467 */   // Label 1102: @68467
     /*   68467 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(68535), // Rule ID 52027 //
     /*   68472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   68475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68495 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68509 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   68509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   68512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68533 */     GIR_RootConstrainSelectedInstOperands,
     /*   68534 */     // GIR_Coverage, 52027,
     /*   68534 */     GIR_EraseRootFromParent_Done,
     /*   68535 */   // Label 1103: @68535
     /*   68535 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(68590), // Rule ID 47328 //
     /*   68540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68559 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68568 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68588 */     GIR_RootConstrainSelectedInstOperands,
     /*   68589 */     // GIR_Coverage, 47328,
     /*   68589 */     GIR_EraseRootFromParent_Done,
     /*   68590 */   // Label 1104: @68590
     /*   68590 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(68645), // Rule ID 47329 //
     /*   68595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68614 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68623 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68643 */     GIR_RootConstrainSelectedInstOperands,
     /*   68644 */     // GIR_Coverage, 47329,
     /*   68644 */     GIR_EraseRootFromParent_Done,
     /*   68645 */   // Label 1105: @68645
     /*   68645 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(68700), // Rule ID 47088 //
     /*   68650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68669 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68678 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   68681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68698 */     GIR_RootConstrainSelectedInstOperands,
     /*   68699 */     // GIR_Coverage, 47088,
     /*   68699 */     GIR_EraseRootFromParent_Done,
     /*   68700 */   // Label 1106: @68700
     /*   68700 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(68755), // Rule ID 47089 //
     /*   68705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68724 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68733 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   68736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68753 */     GIR_RootConstrainSelectedInstOperands,
     /*   68754 */     // GIR_Coverage, 47089,
     /*   68754 */     GIR_EraseRootFromParent_Done,
     /*   68755 */   // Label 1107: @68755
     /*   68755 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(68810), // Rule ID 47208 //
     /*   68760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68788 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68808 */     GIR_RootConstrainSelectedInstOperands,
     /*   68809 */     // GIR_Coverage, 47208,
     /*   68809 */     GIR_EraseRootFromParent_Done,
     /*   68810 */   // Label 1108: @68810
     /*   68810 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(68865), // Rule ID 47209 //
     /*   68815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68843 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68863 */     GIR_RootConstrainSelectedInstOperands,
     /*   68864 */     // GIR_Coverage, 47209,
     /*   68864 */     GIR_EraseRootFromParent_Done,
     /*   68865 */   // Label 1109: @68865
     /*   68865 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(68918), // Rule ID 46300 //
     /*   68870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   68873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68881 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   68881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   68898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68916 */     GIR_RootConstrainSelectedInstOperands,
     /*   68917 */     // GIR_Coverage, 46300,
     /*   68917 */     GIR_EraseRootFromParent_Done,
     /*   68918 */   // Label 1110: @68918
     /*   68918 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(68971), // Rule ID 46301 //
     /*   68923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   68926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68934 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   68934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   68951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68969 */     GIR_RootConstrainSelectedInstOperands,
     /*   68970 */     // GIR_Coverage, 46301,
     /*   68970 */     GIR_EraseRootFromParent_Done,
     /*   68971 */   // Label 1111: @68971
     /*   68971 */   GIM_Reject,
     /*   68972 */ // Label 1095: @68972
     /*   68972 */ GIM_Reject,
     /*   68973 */ // Label 974: @68973
     /*   68973 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(69219),
     /*   68978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   68981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   68984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68992 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(69056), // Rule ID 51958 //
     /*   68997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69030 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   69030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   69033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69054 */     GIR_RootConstrainSelectedInstOperands,
     /*   69055 */     // GIR_Coverage, 51958,
     /*   69055 */     GIR_EraseRootFromParent_Done,
     /*   69056 */   // Label 1113: @69056
     /*   69056 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(69120), // Rule ID 51959 //
     /*   69061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69080 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69094 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   69094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   69097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69118 */     GIR_RootConstrainSelectedInstOperands,
     /*   69119 */     // GIR_Coverage, 51959,
     /*   69119 */     GIR_EraseRootFromParent_Done,
     /*   69120 */   // Label 1114: @69120
     /*   69120 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(69169), // Rule ID 46232 //
     /*   69125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69132 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   69135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   69149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69167 */     GIR_RootConstrainSelectedInstOperands,
     /*   69168 */     // GIR_Coverage, 46232,
     /*   69168 */     GIR_EraseRootFromParent_Done,
     /*   69169 */   // Label 1115: @69169
     /*   69169 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(69218), // Rule ID 46233 //
     /*   69174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69181 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   69184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   69198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69216 */     GIR_RootConstrainSelectedInstOperands,
     /*   69217 */     // GIR_Coverage, 46233,
     /*   69217 */     GIR_EraseRootFromParent_Done,
     /*   69218 */   // Label 1116: @69218
     /*   69218 */   GIM_Reject,
     /*   69219 */ // Label 1112: @69219
     /*   69219 */ GIM_Reject,
     /*   69220 */ // Label 975: @69220
     /*   69220 */ GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(70342),
     /*   69225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69235 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(69324), // Rule ID 47228 //
     /*   69240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69255 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69274 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69283 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69322 */     GIR_RootConstrainSelectedInstOperands,
     /*   69323 */     // GIR_Coverage, 47228,
     /*   69323 */     GIR_EraseRootFromParent_Done,
     /*   69324 */   // Label 1118: @69324
     /*   69324 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(69413), // Rule ID 47229 //
     /*   69329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69344 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69363 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69372 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69411 */     GIR_RootConstrainSelectedInstOperands,
     /*   69412 */     // GIR_Coverage, 47229,
     /*   69412 */     GIR_EraseRootFromParent_Done,
     /*   69413 */   // Label 1119: @69413
     /*   69413 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(69502), // Rule ID 46988 //
     /*   69418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69433 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69452 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69461 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   69478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69500 */     GIR_RootConstrainSelectedInstOperands,
     /*   69501 */     // GIR_Coverage, 46988,
     /*   69501 */     GIR_EraseRootFromParent_Done,
     /*   69502 */   // Label 1120: @69502
     /*   69502 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(69591), // Rule ID 46989 //
     /*   69507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69522 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69541 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69550 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   69567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69589 */     GIR_RootConstrainSelectedInstOperands,
     /*   69590 */     // GIR_Coverage, 46989,
     /*   69590 */     GIR_EraseRootFromParent_Done,
     /*   69591 */   // Label 1121: @69591
     /*   69591 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(69680), // Rule ID 47108 //
     /*   69596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69630 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69639 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69678 */     GIR_RootConstrainSelectedInstOperands,
     /*   69679 */     // GIR_Coverage, 47108,
     /*   69679 */     GIR_EraseRootFromParent_Done,
     /*   69680 */   // Label 1122: @69680
     /*   69680 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(69769), // Rule ID 47109 //
     /*   69685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69700 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69719 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69721 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69726 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69728 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69767 */     GIR_RootConstrainSelectedInstOperands,
     /*   69768 */     // GIR_Coverage, 47109,
     /*   69768 */     GIR_EraseRootFromParent_Done,
     /*   69769 */   // Label 1123: @69769
     /*   69769 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(69837), // Rule ID 51978 //
     /*   69774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69797 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69811 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   69811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   69814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69835 */     GIR_RootConstrainSelectedInstOperands,
     /*   69836 */     // GIR_Coverage, 51978,
     /*   69836 */     GIR_EraseRootFromParent_Done,
     /*   69837 */   // Label 1124: @69837
     /*   69837 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(69905), // Rule ID 51979 //
     /*   69842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69865 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69879 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   69879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   69882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69903 */     GIR_RootConstrainSelectedInstOperands,
     /*   69904 */     // GIR_Coverage, 51979,
     /*   69904 */     GIR_EraseRootFromParent_Done,
     /*   69905 */   // Label 1125: @69905
     /*   69905 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(69960), // Rule ID 47288 //
     /*   69910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69929 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69938 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   69938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   69941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69958 */     GIR_RootConstrainSelectedInstOperands,
     /*   69959 */     // GIR_Coverage, 47288,
     /*   69959 */     GIR_EraseRootFromParent_Done,
     /*   69960 */   // Label 1126: @69960
     /*   69960 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(70015), // Rule ID 47289 //
     /*   69965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69984 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69993 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   69993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   69996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70013 */     GIR_RootConstrainSelectedInstOperands,
     /*   70014 */     // GIR_Coverage, 47289,
     /*   70014 */     GIR_EraseRootFromParent_Done,
     /*   70015 */   // Label 1127: @70015
     /*   70015 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(70070), // Rule ID 47048 //
     /*   70020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70039 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70048 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   70051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70068 */     GIR_RootConstrainSelectedInstOperands,
     /*   70069 */     // GIR_Coverage, 47048,
     /*   70069 */     GIR_EraseRootFromParent_Done,
     /*   70070 */   // Label 1128: @70070
     /*   70070 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(70125), // Rule ID 47049 //
     /*   70075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70094 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70103 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   70106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70123 */     GIR_RootConstrainSelectedInstOperands,
     /*   70124 */     // GIR_Coverage, 47049,
     /*   70124 */     GIR_EraseRootFromParent_Done,
     /*   70125 */   // Label 1129: @70125
     /*   70125 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(70180), // Rule ID 47168 //
     /*   70130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70158 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70178 */     GIR_RootConstrainSelectedInstOperands,
     /*   70179 */     // GIR_Coverage, 47168,
     /*   70179 */     GIR_EraseRootFromParent_Done,
     /*   70180 */   // Label 1130: @70180
     /*   70180 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(70235), // Rule ID 47169 //
     /*   70185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70204 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70213 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70233 */     GIR_RootConstrainSelectedInstOperands,
     /*   70234 */     // GIR_Coverage, 47169,
     /*   70234 */     GIR_EraseRootFromParent_Done,
     /*   70235 */   // Label 1131: @70235
     /*   70235 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(70288), // Rule ID 46252 //
     /*   70240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70251 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   70268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70286 */     GIR_RootConstrainSelectedInstOperands,
     /*   70287 */     // GIR_Coverage, 46252,
     /*   70287 */     GIR_EraseRootFromParent_Done,
     /*   70288 */   // Label 1132: @70288
     /*   70288 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(70341), // Rule ID 46253 //
     /*   70293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70304 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   70321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70339 */     GIR_RootConstrainSelectedInstOperands,
     /*   70340 */     // GIR_Coverage, 46253,
     /*   70340 */     GIR_EraseRootFromParent_Done,
     /*   70341 */   // Label 1133: @70341
     /*   70341 */   GIM_Reject,
     /*   70342 */ // Label 1117: @70342
     /*   70342 */ GIM_Reject,
     /*   70343 */ // Label 976: @70343
     /*   70343 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(71465),
     /*   70348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70358 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(70447), // Rule ID 47252 //
     /*   70363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70378 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70397 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70406 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70445 */     GIR_RootConstrainSelectedInstOperands,
     /*   70446 */     // GIR_Coverage, 47252,
     /*   70446 */     GIR_EraseRootFromParent_Done,
     /*   70447 */   // Label 1135: @70447
     /*   70447 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(70536), // Rule ID 47253 //
     /*   70452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70467 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70486 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70495 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70534 */     GIR_RootConstrainSelectedInstOperands,
     /*   70535 */     // GIR_Coverage, 47253,
     /*   70535 */     GIR_EraseRootFromParent_Done,
     /*   70536 */   // Label 1136: @70536
     /*   70536 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(70625), // Rule ID 47012 //
     /*   70541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70575 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70584 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   70601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70623 */     GIR_RootConstrainSelectedInstOperands,
     /*   70624 */     // GIR_Coverage, 47012,
     /*   70624 */     GIR_EraseRootFromParent_Done,
     /*   70625 */   // Label 1137: @70625
     /*   70625 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(70714), // Rule ID 47013 //
     /*   70630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70645 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70664 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70673 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   70690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70712 */     GIR_RootConstrainSelectedInstOperands,
     /*   70713 */     // GIR_Coverage, 47013,
     /*   70713 */     GIR_EraseRootFromParent_Done,
     /*   70714 */   // Label 1138: @70714
     /*   70714 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(70803), // Rule ID 47132 //
     /*   70719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70734 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70753 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70762 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70801 */     GIR_RootConstrainSelectedInstOperands,
     /*   70802 */     // GIR_Coverage, 47132,
     /*   70802 */     GIR_EraseRootFromParent_Done,
     /*   70803 */   // Label 1139: @70803
     /*   70803 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(70892), // Rule ID 47133 //
     /*   70808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70823 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70842 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70851 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70890 */     GIR_RootConstrainSelectedInstOperands,
     /*   70891 */     // GIR_Coverage, 47133,
     /*   70891 */     GIR_EraseRootFromParent_Done,
     /*   70892 */   // Label 1140: @70892
     /*   70892 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(70960), // Rule ID 52014 //
     /*   70897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70934 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   70934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   70937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   70943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   70955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70958 */     GIR_RootConstrainSelectedInstOperands,
     /*   70959 */     // GIR_Coverage, 52014,
     /*   70959 */     GIR_EraseRootFromParent_Done,
     /*   70960 */   // Label 1141: @70960
     /*   70960 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(71028), // Rule ID 52015 //
     /*   70965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70988 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71002 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   71002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   71005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   71011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71026 */     GIR_RootConstrainSelectedInstOperands,
     /*   71027 */     // GIR_Coverage, 52015,
     /*   71027 */     GIR_EraseRootFromParent_Done,
     /*   71028 */   // Label 1142: @71028
     /*   71028 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(71083), // Rule ID 47312 //
     /*   71033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71052 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71061 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71081 */     GIR_RootConstrainSelectedInstOperands,
     /*   71082 */     // GIR_Coverage, 47312,
     /*   71082 */     GIR_EraseRootFromParent_Done,
     /*   71083 */   // Label 1143: @71083
     /*   71083 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(71138), // Rule ID 47313 //
     /*   71088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71116 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71136 */     GIR_RootConstrainSelectedInstOperands,
     /*   71137 */     // GIR_Coverage, 47313,
     /*   71137 */     GIR_EraseRootFromParent_Done,
     /*   71138 */   // Label 1144: @71138
     /*   71138 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(71193), // Rule ID 47072 //
     /*   71143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71162 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71171 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   71174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71191 */     GIR_RootConstrainSelectedInstOperands,
     /*   71192 */     // GIR_Coverage, 47072,
     /*   71192 */     GIR_EraseRootFromParent_Done,
     /*   71193 */   // Label 1145: @71193
     /*   71193 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(71248), // Rule ID 47073 //
     /*   71198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71217 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71226 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   71229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71246 */     GIR_RootConstrainSelectedInstOperands,
     /*   71247 */     // GIR_Coverage, 47073,
     /*   71247 */     GIR_EraseRootFromParent_Done,
     /*   71248 */   // Label 1146: @71248
     /*   71248 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(71303), // Rule ID 47192 //
     /*   71253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71281 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71301 */     GIR_RootConstrainSelectedInstOperands,
     /*   71302 */     // GIR_Coverage, 47192,
     /*   71302 */     GIR_EraseRootFromParent_Done,
     /*   71303 */   // Label 1147: @71303
     /*   71303 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71358), // Rule ID 47193 //
     /*   71308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71327 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71336 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71356 */     GIR_RootConstrainSelectedInstOperands,
     /*   71357 */     // GIR_Coverage, 47193,
     /*   71357 */     GIR_EraseRootFromParent_Done,
     /*   71358 */   // Label 1148: @71358
     /*   71358 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(71411), // Rule ID 46288 //
     /*   71363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71374 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   71391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   71400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71409 */     GIR_RootConstrainSelectedInstOperands,
     /*   71410 */     // GIR_Coverage, 46288,
     /*   71410 */     GIR_EraseRootFromParent_Done,
     /*   71411 */   // Label 1149: @71411
     /*   71411 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(71464), // Rule ID 46289 //
     /*   71416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71427 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   71444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   71453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71462 */     GIR_RootConstrainSelectedInstOperands,
     /*   71463 */     // GIR_Coverage, 46289,
     /*   71463 */     GIR_EraseRootFromParent_Done,
     /*   71464 */   // Label 1150: @71464
     /*   71464 */   GIM_Reject,
     /*   71465 */ // Label 1134: @71465
     /*   71465 */ GIM_Reject,
     /*   71466 */ // Label 977: @71466
     /*   71466 */ GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(72588),
     /*   71471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   71474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   71477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71481 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(71570), // Rule ID 47272 //
     /*   71486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71501 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71520 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71529 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71568 */     GIR_RootConstrainSelectedInstOperands,
     /*   71569 */     // GIR_Coverage, 47272,
     /*   71569 */     GIR_EraseRootFromParent_Done,
     /*   71570 */   // Label 1152: @71570
     /*   71570 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71659), // Rule ID 47273 //
     /*   71575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71590 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71609 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71618 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71657 */     GIR_RootConstrainSelectedInstOperands,
     /*   71658 */     // GIR_Coverage, 47273,
     /*   71658 */     GIR_EraseRootFromParent_Done,
     /*   71659 */   // Label 1153: @71659
     /*   71659 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(71748), // Rule ID 47032 //
     /*   71664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71679 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71698 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71707 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   71724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71746 */     GIR_RootConstrainSelectedInstOperands,
     /*   71747 */     // GIR_Coverage, 47032,
     /*   71747 */     GIR_EraseRootFromParent_Done,
     /*   71748 */   // Label 1154: @71748
     /*   71748 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(71837), // Rule ID 47033 //
     /*   71753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71768 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71787 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71796 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   71813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71835 */     GIR_RootConstrainSelectedInstOperands,
     /*   71836 */     // GIR_Coverage, 47033,
     /*   71836 */     GIR_EraseRootFromParent_Done,
     /*   71837 */   // Label 1155: @71837
     /*   71837 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(71926), // Rule ID 47152 //
     /*   71842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71857 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71876 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71885 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71924 */     GIR_RootConstrainSelectedInstOperands,
     /*   71925 */     // GIR_Coverage, 47152,
     /*   71925 */     GIR_EraseRootFromParent_Done,
     /*   71926 */   // Label 1156: @71926
     /*   71926 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(72015), // Rule ID 47153 //
     /*   71931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71965 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71974 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72013 */     GIR_RootConstrainSelectedInstOperands,
     /*   72014 */     // GIR_Coverage, 47153,
     /*   72014 */     GIR_EraseRootFromParent_Done,
     /*   72015 */   // Label 1157: @72015
     /*   72015 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(72083), // Rule ID 52030 //
     /*   72020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   72023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   72039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   72043 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72057 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   72057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72081 */     GIR_RootConstrainSelectedInstOperands,
     /*   72082 */     // GIR_Coverage, 52030,
     /*   72082 */     GIR_EraseRootFromParent_Done,
     /*   72083 */   // Label 1158: @72083
     /*   72083 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(72151), // Rule ID 52031 //
     /*   72088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   72091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   72107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   72111 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72125 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   72125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72149 */     GIR_RootConstrainSelectedInstOperands,
     /*   72150 */     // GIR_Coverage, 52031,
     /*   72150 */     GIR_EraseRootFromParent_Done,
     /*   72151 */   // Label 1159: @72151
     /*   72151 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(72206), // Rule ID 47332 //
     /*   72156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72184 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72204 */     GIR_RootConstrainSelectedInstOperands,
     /*   72205 */     // GIR_Coverage, 47332,
     /*   72205 */     GIR_EraseRootFromParent_Done,
     /*   72206 */   // Label 1160: @72206
     /*   72206 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(72261), // Rule ID 47333 //
     /*   72211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72230 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72239 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72259 */     GIR_RootConstrainSelectedInstOperands,
     /*   72260 */     // GIR_Coverage, 47333,
     /*   72260 */     GIR_EraseRootFromParent_Done,
     /*   72261 */   // Label 1161: @72261
     /*   72261 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(72316), // Rule ID 47092 //
     /*   72266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72285 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72294 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   72297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72314 */     GIR_RootConstrainSelectedInstOperands,
     /*   72315 */     // GIR_Coverage, 47092,
     /*   72315 */     GIR_EraseRootFromParent_Done,
     /*   72316 */   // Label 1162: @72316
     /*   72316 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(72371), // Rule ID 47093 //
     /*   72321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72340 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72349 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   72352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72369 */     GIR_RootConstrainSelectedInstOperands,
     /*   72370 */     // GIR_Coverage, 47093,
     /*   72370 */     GIR_EraseRootFromParent_Done,
     /*   72371 */   // Label 1163: @72371
     /*   72371 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72426), // Rule ID 47212 //
     /*   72376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72395 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72404 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72424 */     GIR_RootConstrainSelectedInstOperands,
     /*   72425 */     // GIR_Coverage, 47212,
     /*   72425 */     GIR_EraseRootFromParent_Done,
     /*   72426 */   // Label 1164: @72426
     /*   72426 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(72481), // Rule ID 47213 //
     /*   72431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72450 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72459 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72479 */     GIR_RootConstrainSelectedInstOperands,
     /*   72480 */     // GIR_Coverage, 47213,
     /*   72480 */     GIR_EraseRootFromParent_Done,
     /*   72481 */   // Label 1165: @72481
     /*   72481 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(72534), // Rule ID 46304 //
     /*   72486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   72489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72497 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   72497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   72514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72532 */     GIR_RootConstrainSelectedInstOperands,
     /*   72533 */     // GIR_Coverage, 46304,
     /*   72533 */     GIR_EraseRootFromParent_Done,
     /*   72534 */   // Label 1166: @72534
     /*   72534 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(72587), // Rule ID 46305 //
     /*   72539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   72542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72550 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   72550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   72567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72585 */     GIR_RootConstrainSelectedInstOperands,
     /*   72586 */     // GIR_Coverage, 46305,
     /*   72586 */     GIR_EraseRootFromParent_Done,
     /*   72587 */   // Label 1167: @72587
     /*   72587 */   GIM_Reject,
     /*   72588 */ // Label 1151: @72588
     /*   72588 */ GIM_Reject,
     /*   72589 */ // Label 978: @72589
     /*   72589 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(72835),
     /*   72594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   72600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72608 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72672), // Rule ID 51974 //
     /*   72613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   72632 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72646 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   72646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   72649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72670 */     GIR_RootConstrainSelectedInstOperands,
     /*   72671 */     // GIR_Coverage, 51974,
     /*   72671 */     GIR_EraseRootFromParent_Done,
     /*   72672 */   // Label 1169: @72672
     /*   72672 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72736), // Rule ID 51975 //
     /*   72677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   72696 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72710 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   72710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   72713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72734 */     GIR_RootConstrainSelectedInstOperands,
     /*   72735 */     // GIR_Coverage, 51975,
     /*   72735 */     GIR_EraseRootFromParent_Done,
     /*   72736 */   // Label 1170: @72736
     /*   72736 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72785), // Rule ID 46248 //
     /*   72741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72748 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   72748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   72751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   72765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72783 */     GIR_RootConstrainSelectedInstOperands,
     /*   72784 */     // GIR_Coverage, 46248,
     /*   72784 */     GIR_EraseRootFromParent_Done,
     /*   72785 */   // Label 1171: @72785
     /*   72785 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72834), // Rule ID 46249 //
     /*   72790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72797 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   72797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   72800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   72814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72832 */     GIR_RootConstrainSelectedInstOperands,
     /*   72833 */     // GIR_Coverage, 46249,
     /*   72833 */     GIR_EraseRootFromParent_Done,
     /*   72834 */   // Label 1172: @72834
     /*   72834 */   GIM_Reject,
     /*   72835 */ // Label 1168: @72835
     /*   72835 */ GIM_Reject,
     /*   72836 */ // Label 979: @72836
     /*   72836 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(73958),
     /*   72841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   72844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   72847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72851 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72940), // Rule ID 47232 //
     /*   72856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72871 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72890 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72899 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   72899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   72902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   72916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72938 */     GIR_RootConstrainSelectedInstOperands,
     /*   72939 */     // GIR_Coverage, 47232,
     /*   72939 */     GIR_EraseRootFromParent_Done,
     /*   72940 */   // Label 1174: @72940
     /*   72940 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(73029), // Rule ID 47233 //
     /*   72945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72960 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72979 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72988 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   72988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   72991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73027 */     GIR_RootConstrainSelectedInstOperands,
     /*   73028 */     // GIR_Coverage, 47233,
     /*   73028 */     GIR_EraseRootFromParent_Done,
     /*   73029 */   // Label 1175: @73029
     /*   73029 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(73118), // Rule ID 46992 //
     /*   73034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73049 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73068 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73077 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   73094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73116 */     GIR_RootConstrainSelectedInstOperands,
     /*   73117 */     // GIR_Coverage, 46992,
     /*   73117 */     GIR_EraseRootFromParent_Done,
     /*   73118 */   // Label 1176: @73118
     /*   73118 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(73207), // Rule ID 46993 //
     /*   73123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73138 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73157 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73166 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   73183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73205 */     GIR_RootConstrainSelectedInstOperands,
     /*   73206 */     // GIR_Coverage, 46993,
     /*   73206 */     GIR_EraseRootFromParent_Done,
     /*   73207 */   // Label 1177: @73207
     /*   73207 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(73296), // Rule ID 47112 //
     /*   73212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73227 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73246 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73255 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73294 */     GIR_RootConstrainSelectedInstOperands,
     /*   73295 */     // GIR_Coverage, 47112,
     /*   73295 */     GIR_EraseRootFromParent_Done,
     /*   73296 */   // Label 1178: @73296
     /*   73296 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(73385), // Rule ID 47113 //
     /*   73301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73335 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73344 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73383 */     GIR_RootConstrainSelectedInstOperands,
     /*   73384 */     // GIR_Coverage, 47113,
     /*   73384 */     GIR_EraseRootFromParent_Done,
     /*   73385 */   // Label 1179: @73385
     /*   73385 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(73453), // Rule ID 52002 //
     /*   73390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73413 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73427 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   73427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   73430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73451 */     GIR_RootConstrainSelectedInstOperands,
     /*   73452 */     // GIR_Coverage, 52002,
     /*   73452 */     GIR_EraseRootFromParent_Done,
     /*   73453 */   // Label 1180: @73453
     /*   73453 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(73521), // Rule ID 52003 //
     /*   73458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73481 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73495 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   73495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   73498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73519 */     GIR_RootConstrainSelectedInstOperands,
     /*   73520 */     // GIR_Coverage, 52003,
     /*   73520 */     GIR_EraseRootFromParent_Done,
     /*   73521 */   // Label 1181: @73521
     /*   73521 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73576), // Rule ID 47292 //
     /*   73526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73545 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73554 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73574 */     GIR_RootConstrainSelectedInstOperands,
     /*   73575 */     // GIR_Coverage, 47292,
     /*   73575 */     GIR_EraseRootFromParent_Done,
     /*   73576 */   // Label 1182: @73576
     /*   73576 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73631), // Rule ID 47293 //
     /*   73581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73600 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73609 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73629 */     GIR_RootConstrainSelectedInstOperands,
     /*   73630 */     // GIR_Coverage, 47293,
     /*   73630 */     GIR_EraseRootFromParent_Done,
     /*   73631 */   // Label 1183: @73631
     /*   73631 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73686), // Rule ID 47052 //
     /*   73636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73655 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73664 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   73667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73684 */     GIR_RootConstrainSelectedInstOperands,
     /*   73685 */     // GIR_Coverage, 47052,
     /*   73685 */     GIR_EraseRootFromParent_Done,
     /*   73686 */   // Label 1184: @73686
     /*   73686 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73741), // Rule ID 47053 //
     /*   73691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73710 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73719 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   73722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73739 */     GIR_RootConstrainSelectedInstOperands,
     /*   73740 */     // GIR_Coverage, 47053,
     /*   73740 */     GIR_EraseRootFromParent_Done,
     /*   73741 */   // Label 1185: @73741
     /*   73741 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73796), // Rule ID 47172 //
     /*   73746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73765 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73774 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73794 */     GIR_RootConstrainSelectedInstOperands,
     /*   73795 */     // GIR_Coverage, 47172,
     /*   73795 */     GIR_EraseRootFromParent_Done,
     /*   73796 */   // Label 1186: @73796
     /*   73796 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73851), // Rule ID 47173 //
     /*   73801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73820 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73829 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73849 */     GIR_RootConstrainSelectedInstOperands,
     /*   73850 */     // GIR_Coverage, 47173,
     /*   73850 */     GIR_EraseRootFromParent_Done,
     /*   73851 */   // Label 1187: @73851
     /*   73851 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73904), // Rule ID 46276 //
     /*   73856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73867 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   73867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   73884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73902 */     GIR_RootConstrainSelectedInstOperands,
     /*   73903 */     // GIR_Coverage, 46276,
     /*   73903 */     GIR_EraseRootFromParent_Done,
     /*   73904 */   // Label 1188: @73904
     /*   73904 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73957), // Rule ID 46277 //
     /*   73909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73920 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   73920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   73937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73955 */     GIR_RootConstrainSelectedInstOperands,
     /*   73956 */     // GIR_Coverage, 46277,
     /*   73956 */     GIR_EraseRootFromParent_Done,
     /*   73957 */   // Label 1189: @73957
     /*   73957 */   GIM_Reject,
     /*   73958 */ // Label 1173: @73958
     /*   73958 */ GIM_Reject,
     /*   73959 */ // Label 980: @73959
     /*   73959 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(75081),
     /*   73964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   73967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   73970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73974 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(74063), // Rule ID 47256 //
     /*   73979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73994 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74013 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74015 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74022 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74061 */     GIR_RootConstrainSelectedInstOperands,
     /*   74062 */     // GIR_Coverage, 47256,
     /*   74062 */     GIR_EraseRootFromParent_Done,
     /*   74063 */   // Label 1191: @74063
     /*   74063 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(74152), // Rule ID 47257 //
     /*   74068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74083 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74102 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74111 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74150 */     GIR_RootConstrainSelectedInstOperands,
     /*   74151 */     // GIR_Coverage, 47257,
     /*   74151 */     GIR_EraseRootFromParent_Done,
     /*   74152 */   // Label 1192: @74152
     /*   74152 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(74241), // Rule ID 47016 //
     /*   74157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74172 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74191 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74200 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   74217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74239 */     GIR_RootConstrainSelectedInstOperands,
     /*   74240 */     // GIR_Coverage, 47016,
     /*   74240 */     GIR_EraseRootFromParent_Done,
     /*   74241 */   // Label 1193: @74241
     /*   74241 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74330), // Rule ID 47017 //
     /*   74246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74280 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74282 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74289 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   74306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74328 */     GIR_RootConstrainSelectedInstOperands,
     /*   74329 */     // GIR_Coverage, 47017,
     /*   74329 */     GIR_EraseRootFromParent_Done,
     /*   74330 */   // Label 1194: @74330
     /*   74330 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74419), // Rule ID 47136 //
     /*   74335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74350 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74369 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74378 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74417 */     GIR_RootConstrainSelectedInstOperands,
     /*   74418 */     // GIR_Coverage, 47136,
     /*   74418 */     GIR_EraseRootFromParent_Done,
     /*   74419 */   // Label 1195: @74419
     /*   74419 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74508), // Rule ID 47137 //
     /*   74424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74439 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74458 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74467 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74506 */     GIR_RootConstrainSelectedInstOperands,
     /*   74507 */     // GIR_Coverage, 47137,
     /*   74507 */     GIR_EraseRootFromParent_Done,
     /*   74508 */   // Label 1196: @74508
     /*   74508 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74576), // Rule ID 52018 //
     /*   74513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   74532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   74536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74550 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   74550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   74553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   74559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   74571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74574 */     GIR_RootConstrainSelectedInstOperands,
     /*   74575 */     // GIR_Coverage, 52018,
     /*   74575 */     GIR_EraseRootFromParent_Done,
     /*   74576 */   // Label 1197: @74576
     /*   74576 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74644), // Rule ID 52019 //
     /*   74581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   74600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   74604 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74618 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   74618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   74621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   74627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   74639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74642 */     GIR_RootConstrainSelectedInstOperands,
     /*   74643 */     // GIR_Coverage, 52019,
     /*   74643 */     GIR_EraseRootFromParent_Done,
     /*   74644 */   // Label 1198: @74644
     /*   74644 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74699), // Rule ID 47316 //
     /*   74649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74668 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74677 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74697 */     GIR_RootConstrainSelectedInstOperands,
     /*   74698 */     // GIR_Coverage, 47316,
     /*   74698 */     GIR_EraseRootFromParent_Done,
     /*   74699 */   // Label 1199: @74699
     /*   74699 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74754), // Rule ID 47317 //
     /*   74704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74723 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74732 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74752 */     GIR_RootConstrainSelectedInstOperands,
     /*   74753 */     // GIR_Coverage, 47317,
     /*   74753 */     GIR_EraseRootFromParent_Done,
     /*   74754 */   // Label 1200: @74754
     /*   74754 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74809), // Rule ID 47076 //
     /*   74759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74778 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74787 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   74790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74807 */     GIR_RootConstrainSelectedInstOperands,
     /*   74808 */     // GIR_Coverage, 47076,
     /*   74808 */     GIR_EraseRootFromParent_Done,
     /*   74809 */   // Label 1201: @74809
     /*   74809 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74864), // Rule ID 47077 //
     /*   74814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74833 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74842 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   74845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74862 */     GIR_RootConstrainSelectedInstOperands,
     /*   74863 */     // GIR_Coverage, 47077,
     /*   74863 */     GIR_EraseRootFromParent_Done,
     /*   74864 */   // Label 1202: @74864
     /*   74864 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74919), // Rule ID 47196 //
     /*   74869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74888 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74897 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74917 */     GIR_RootConstrainSelectedInstOperands,
     /*   74918 */     // GIR_Coverage, 47196,
     /*   74918 */     GIR_EraseRootFromParent_Done,
     /*   74919 */   // Label 1203: @74919
     /*   74919 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74974), // Rule ID 47197 //
     /*   74924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74943 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74952 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74972 */     GIR_RootConstrainSelectedInstOperands,
     /*   74973 */     // GIR_Coverage, 47197,
     /*   74973 */     GIR_EraseRootFromParent_Done,
     /*   74974 */   // Label 1204: @74974
     /*   74974 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(75027), // Rule ID 46292 //
     /*   74979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74990 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   74990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   75007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75025 */     GIR_RootConstrainSelectedInstOperands,
     /*   75026 */     // GIR_Coverage, 46292,
     /*   75026 */     GIR_EraseRootFromParent_Done,
     /*   75027 */   // Label 1205: @75027
     /*   75027 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75080), // Rule ID 46293 //
     /*   75032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75043 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   75046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   75060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75078 */     GIR_RootConstrainSelectedInstOperands,
     /*   75079 */     // GIR_Coverage, 46293,
     /*   75079 */     GIR_EraseRootFromParent_Done,
     /*   75080 */   // Label 1206: @75080
     /*   75080 */   GIM_Reject,
     /*   75081 */ // Label 1190: @75081
     /*   75081 */ GIM_Reject,
     /*   75082 */ // Label 981: @75082
     /*   75082 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(76204),
     /*   75087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75097 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75186), // Rule ID 47276 //
     /*   75102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75117 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75136 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75145 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75184 */     GIR_RootConstrainSelectedInstOperands,
     /*   75185 */     // GIR_Coverage, 47276,
     /*   75185 */     GIR_EraseRootFromParent_Done,
     /*   75186 */   // Label 1208: @75186
     /*   75186 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75275), // Rule ID 47277 //
     /*   75191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75225 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75234 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75273 */     GIR_RootConstrainSelectedInstOperands,
     /*   75274 */     // GIR_Coverage, 47277,
     /*   75274 */     GIR_EraseRootFromParent_Done,
     /*   75275 */   // Label 1209: @75275
     /*   75275 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75364), // Rule ID 47036 //
     /*   75280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75295 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75314 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75323 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75362 */     GIR_RootConstrainSelectedInstOperands,
     /*   75363 */     // GIR_Coverage, 47036,
     /*   75363 */     GIR_EraseRootFromParent_Done,
     /*   75364 */   // Label 1210: @75364
     /*   75364 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75453), // Rule ID 47037 //
     /*   75369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75384 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75403 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75412 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75451 */     GIR_RootConstrainSelectedInstOperands,
     /*   75452 */     // GIR_Coverage, 47037,
     /*   75452 */     GIR_EraseRootFromParent_Done,
     /*   75453 */   // Label 1211: @75453
     /*   75453 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75542), // Rule ID 47156 //
     /*   75458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75473 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75492 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75501 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75540 */     GIR_RootConstrainSelectedInstOperands,
     /*   75541 */     // GIR_Coverage, 47156,
     /*   75541 */     GIR_EraseRootFromParent_Done,
     /*   75542 */   // Label 1212: @75542
     /*   75542 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75631), // Rule ID 47157 //
     /*   75547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75562 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75581 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75590 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75629 */     GIR_RootConstrainSelectedInstOperands,
     /*   75630 */     // GIR_Coverage, 47157,
     /*   75630 */     GIR_EraseRootFromParent_Done,
     /*   75631 */   // Label 1213: @75631
     /*   75631 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75699), // Rule ID 52034 //
     /*   75636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   75639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   75651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75659 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75673 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   75673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   75676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   75694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75697 */     GIR_RootConstrainSelectedInstOperands,
     /*   75698 */     // GIR_Coverage, 52034,
     /*   75698 */     GIR_EraseRootFromParent_Done,
     /*   75699 */   // Label 1214: @75699
     /*   75699 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(75767), // Rule ID 52035 //
     /*   75704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   75707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   75719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75727 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75741 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   75741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   75744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   75762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75765 */     GIR_RootConstrainSelectedInstOperands,
     /*   75766 */     // GIR_Coverage, 52035,
     /*   75766 */     GIR_EraseRootFromParent_Done,
     /*   75767 */   // Label 1215: @75767
     /*   75767 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(75822), // Rule ID 47336 //
     /*   75772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75800 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   75800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   75803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75820 */     GIR_RootConstrainSelectedInstOperands,
     /*   75821 */     // GIR_Coverage, 47336,
     /*   75821 */     GIR_EraseRootFromParent_Done,
     /*   75822 */   // Label 1216: @75822
     /*   75822 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(75877), // Rule ID 47337 //
     /*   75827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75855 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   75855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   75858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75875 */     GIR_RootConstrainSelectedInstOperands,
     /*   75876 */     // GIR_Coverage, 47337,
     /*   75876 */     GIR_EraseRootFromParent_Done,
     /*   75877 */   // Label 1217: @75877
     /*   75877 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(75932), // Rule ID 47096 //
     /*   75882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75910 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   75910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   75913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75930 */     GIR_RootConstrainSelectedInstOperands,
     /*   75931 */     // GIR_Coverage, 47096,
     /*   75931 */     GIR_EraseRootFromParent_Done,
     /*   75932 */   // Label 1218: @75932
     /*   75932 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(75987), // Rule ID 47097 //
     /*   75937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75965 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   75965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   75968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75985 */     GIR_RootConstrainSelectedInstOperands,
     /*   75986 */     // GIR_Coverage, 47097,
     /*   75986 */     GIR_EraseRootFromParent_Done,
     /*   75987 */   // Label 1219: @75987
     /*   75987 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76042), // Rule ID 47216 //
     /*   75992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76020 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   76020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76040 */     GIR_RootConstrainSelectedInstOperands,
     /*   76041 */     // GIR_Coverage, 47216,
     /*   76041 */     GIR_EraseRootFromParent_Done,
     /*   76042 */   // Label 1220: @76042
     /*   76042 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76097), // Rule ID 47217 //
     /*   76047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   76050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76075 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   76075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76095 */     GIR_RootConstrainSelectedInstOperands,
     /*   76096 */     // GIR_Coverage, 47217,
     /*   76096 */     GIR_EraseRootFromParent_Done,
     /*   76097 */   // Label 1221: @76097
     /*   76097 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76150), // Rule ID 46308 //
     /*   76102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   76105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76113 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   76113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76148 */     GIR_RootConstrainSelectedInstOperands,
     /*   76149 */     // GIR_Coverage, 46308,
     /*   76149 */     GIR_EraseRootFromParent_Done,
     /*   76150 */   // Label 1222: @76150
     /*   76150 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76203), // Rule ID 46309 //
     /*   76155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   76158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76166 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   76166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76201 */     GIR_RootConstrainSelectedInstOperands,
     /*   76202 */     // GIR_Coverage, 46309,
     /*   76202 */     GIR_EraseRootFromParent_Done,
     /*   76203 */   // Label 1223: @76203
     /*   76203 */   GIM_Reject,
     /*   76204 */ // Label 1207: @76204
     /*   76204 */ GIM_Reject,
     /*   76205 */ // Label 982: @76205
     /*   76205 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(76451),
     /*   76210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76224 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(76288), // Rule ID 51990 //
     /*   76229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76248 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76262 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   76262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   76265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76286 */     GIR_RootConstrainSelectedInstOperands,
     /*   76287 */     // GIR_Coverage, 51990,
     /*   76287 */     GIR_EraseRootFromParent_Done,
     /*   76288 */   // Label 1225: @76288
     /*   76288 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(76352), // Rule ID 51991 //
     /*   76293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76326 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   76326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   76329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76350 */     GIR_RootConstrainSelectedInstOperands,
     /*   76351 */     // GIR_Coverage, 51991,
     /*   76351 */     GIR_EraseRootFromParent_Done,
     /*   76352 */   // Label 1226: @76352
     /*   76352 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(76401), // Rule ID 46264 //
     /*   76357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76364 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   76367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   76381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76399 */     GIR_RootConstrainSelectedInstOperands,
     /*   76400 */     // GIR_Coverage, 46264,
     /*   76400 */     GIR_EraseRootFromParent_Done,
     /*   76401 */   // Label 1227: @76401
     /*   76401 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(76450), // Rule ID 46265 //
     /*   76406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76413 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   76416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   76430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76448 */     GIR_RootConstrainSelectedInstOperands,
     /*   76449 */     // GIR_Coverage, 46265,
     /*   76449 */     GIR_EraseRootFromParent_Done,
     /*   76450 */   // Label 1228: @76450
     /*   76450 */   GIM_Reject,
     /*   76451 */ // Label 1224: @76451
     /*   76451 */ GIM_Reject,
     /*   76452 */ // Label 983: @76452
     /*   76452 */ GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(77574),
     /*   76457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   76460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   76463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76467 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(76556), // Rule ID 47236 //
     /*   76472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76487 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76506 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76515 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76554 */     GIR_RootConstrainSelectedInstOperands,
     /*   76555 */     // GIR_Coverage, 47236,
     /*   76555 */     GIR_EraseRootFromParent_Done,
     /*   76556 */   // Label 1230: @76556
     /*   76556 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(76645), // Rule ID 47237 //
     /*   76561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76576 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76595 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76604 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76643 */     GIR_RootConstrainSelectedInstOperands,
     /*   76644 */     // GIR_Coverage, 47237,
     /*   76644 */     GIR_EraseRootFromParent_Done,
     /*   76645 */   // Label 1231: @76645
     /*   76645 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(76734), // Rule ID 46996 //
     /*   76650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76665 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76684 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76693 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   76710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76732 */     GIR_RootConstrainSelectedInstOperands,
     /*   76733 */     // GIR_Coverage, 46996,
     /*   76733 */     GIR_EraseRootFromParent_Done,
     /*   76734 */   // Label 1232: @76734
     /*   76734 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(76823), // Rule ID 46997 //
     /*   76739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76754 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76773 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76782 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   76799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76821 */     GIR_RootConstrainSelectedInstOperands,
     /*   76822 */     // GIR_Coverage, 46997,
     /*   76822 */     GIR_EraseRootFromParent_Done,
     /*   76823 */   // Label 1233: @76823
     /*   76823 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(76912), // Rule ID 47116 //
     /*   76828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76843 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76862 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76869 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76871 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76910 */     GIR_RootConstrainSelectedInstOperands,
     /*   76911 */     // GIR_Coverage, 47116,
     /*   76911 */     GIR_EraseRootFromParent_Done,
     /*   76912 */   // Label 1234: @76912
     /*   76912 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(77001), // Rule ID 47117 //
     /*   76917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76932 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76951 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76960 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76999 */     GIR_RootConstrainSelectedInstOperands,
     /*   77000 */     // GIR_Coverage, 47117,
     /*   77000 */     GIR_EraseRootFromParent_Done,
     /*   77001 */   // Label 1235: @77001
     /*   77001 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(77069), // Rule ID 52006 //
     /*   77006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   77021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   77029 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77043 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   77043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   77046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   77052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77067 */     GIR_RootConstrainSelectedInstOperands,
     /*   77068 */     // GIR_Coverage, 52006,
     /*   77068 */     GIR_EraseRootFromParent_Done,
     /*   77069 */   // Label 1236: @77069
     /*   77069 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(77137), // Rule ID 52007 //
     /*   77074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   77089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   77097 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77111 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   77111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   77114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   77120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77135 */     GIR_RootConstrainSelectedInstOperands,
     /*   77136 */     // GIR_Coverage, 52007,
     /*   77136 */     GIR_EraseRootFromParent_Done,
     /*   77137 */   // Label 1237: @77137
     /*   77137 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(77192), // Rule ID 47296 //
     /*   77142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77161 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77170 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77190 */     GIR_RootConstrainSelectedInstOperands,
     /*   77191 */     // GIR_Coverage, 47296,
     /*   77191 */     GIR_EraseRootFromParent_Done,
     /*   77192 */   // Label 1238: @77192
     /*   77192 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(77247), // Rule ID 47297 //
     /*   77197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77216 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77225 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77245 */     GIR_RootConstrainSelectedInstOperands,
     /*   77246 */     // GIR_Coverage, 47297,
     /*   77246 */     GIR_EraseRootFromParent_Done,
     /*   77247 */   // Label 1239: @77247
     /*   77247 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(77302), // Rule ID 47056 //
     /*   77252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77271 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77280 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   77283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77300 */     GIR_RootConstrainSelectedInstOperands,
     /*   77301 */     // GIR_Coverage, 47056,
     /*   77301 */     GIR_EraseRootFromParent_Done,
     /*   77302 */   // Label 1240: @77302
     /*   77302 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(77357), // Rule ID 47057 //
     /*   77307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77335 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   77338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77355 */     GIR_RootConstrainSelectedInstOperands,
     /*   77356 */     // GIR_Coverage, 47057,
     /*   77356 */     GIR_EraseRootFromParent_Done,
     /*   77357 */   // Label 1241: @77357
     /*   77357 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(77412), // Rule ID 47176 //
     /*   77362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77390 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77410 */     GIR_RootConstrainSelectedInstOperands,
     /*   77411 */     // GIR_Coverage, 47176,
     /*   77411 */     GIR_EraseRootFromParent_Done,
     /*   77412 */   // Label 1242: @77412
     /*   77412 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(77467), // Rule ID 47177 //
     /*   77417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77445 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77465 */     GIR_RootConstrainSelectedInstOperands,
     /*   77466 */     // GIR_Coverage, 47177,
     /*   77466 */     GIR_EraseRootFromParent_Done,
     /*   77467 */   // Label 1243: @77467
     /*   77467 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(77520), // Rule ID 46280 //
     /*   77472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77483 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   77500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   77509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77518 */     GIR_RootConstrainSelectedInstOperands,
     /*   77519 */     // GIR_Coverage, 46280,
     /*   77519 */     GIR_EraseRootFromParent_Done,
     /*   77520 */   // Label 1244: @77520
     /*   77520 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(77573), // Rule ID 46281 //
     /*   77525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77536 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   77553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   77562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77571 */     GIR_RootConstrainSelectedInstOperands,
     /*   77572 */     // GIR_Coverage, 46281,
     /*   77572 */     GIR_EraseRootFromParent_Done,
     /*   77573 */   // Label 1245: @77573
     /*   77573 */   GIM_Reject,
     /*   77574 */ // Label 1229: @77574
     /*   77574 */ GIM_Reject,
     /*   77575 */ // Label 984: @77575
     /*   77575 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(78697),
     /*   77580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   77583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   77586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   77590 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(77679), // Rule ID 47260 //
     /*   77595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77610 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77629 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77638 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   77655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77677 */     GIR_RootConstrainSelectedInstOperands,
     /*   77678 */     // GIR_Coverage, 47260,
     /*   77678 */     GIR_EraseRootFromParent_Done,
     /*   77679 */   // Label 1247: @77679
     /*   77679 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(77768), // Rule ID 47261 //
     /*   77684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77699 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77718 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77727 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   77744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77766 */     GIR_RootConstrainSelectedInstOperands,
     /*   77767 */     // GIR_Coverage, 47261,
     /*   77767 */     GIR_EraseRootFromParent_Done,
     /*   77768 */   // Label 1248: @77768
     /*   77768 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(77857), // Rule ID 47020 //
     /*   77773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77807 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77816 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   77833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77855 */     GIR_RootConstrainSelectedInstOperands,
     /*   77856 */     // GIR_Coverage, 47020,
     /*   77856 */     GIR_EraseRootFromParent_Done,
     /*   77857 */   // Label 1249: @77857
     /*   77857 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(77946), // Rule ID 47021 //
     /*   77862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77896 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77905 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   77922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77944 */     GIR_RootConstrainSelectedInstOperands,
     /*   77945 */     // GIR_Coverage, 47021,
     /*   77945 */     GIR_EraseRootFromParent_Done,
     /*   77946 */   // Label 1250: @77946
     /*   77946 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(78035), // Rule ID 47140 //
     /*   77951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77985 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77994 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   78011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78033 */     GIR_RootConstrainSelectedInstOperands,
     /*   78034 */     // GIR_Coverage, 47140,
     /*   78034 */     GIR_EraseRootFromParent_Done,
     /*   78035 */   // Label 1251: @78035
     /*   78035 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(78124), // Rule ID 47141 //
     /*   78040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78055 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78074 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78083 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   78100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78122 */     GIR_RootConstrainSelectedInstOperands,
     /*   78123 */     // GIR_Coverage, 47141,
     /*   78123 */     GIR_EraseRootFromParent_Done,
     /*   78124 */   // Label 1252: @78124
     /*   78124 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(78192), // Rule ID 52022 //
     /*   78129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78152 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78166 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   78166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   78169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78190 */     GIR_RootConstrainSelectedInstOperands,
     /*   78191 */     // GIR_Coverage, 52022,
     /*   78191 */     GIR_EraseRootFromParent_Done,
     /*   78192 */   // Label 1253: @78192
     /*   78192 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(78260), // Rule ID 52023 //
     /*   78197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78220 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78234 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   78234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   78237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78258 */     GIR_RootConstrainSelectedInstOperands,
     /*   78259 */     // GIR_Coverage, 52023,
     /*   78259 */     GIR_EraseRootFromParent_Done,
     /*   78260 */   // Label 1254: @78260
     /*   78260 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(78315), // Rule ID 47320 //
     /*   78265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78284 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78293 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78313 */     GIR_RootConstrainSelectedInstOperands,
     /*   78314 */     // GIR_Coverage, 47320,
     /*   78314 */     GIR_EraseRootFromParent_Done,
     /*   78315 */   // Label 1255: @78315
     /*   78315 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(78370), // Rule ID 47321 //
     /*   78320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78339 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78348 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78368 */     GIR_RootConstrainSelectedInstOperands,
     /*   78369 */     // GIR_Coverage, 47321,
     /*   78369 */     GIR_EraseRootFromParent_Done,
     /*   78370 */   // Label 1256: @78370
     /*   78370 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(78425), // Rule ID 47080 //
     /*   78375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78394 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78403 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   78406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78423 */     GIR_RootConstrainSelectedInstOperands,
     /*   78424 */     // GIR_Coverage, 47080,
     /*   78424 */     GIR_EraseRootFromParent_Done,
     /*   78425 */   // Label 1257: @78425
     /*   78425 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(78480), // Rule ID 47081 //
     /*   78430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78449 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78458 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   78461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78478 */     GIR_RootConstrainSelectedInstOperands,
     /*   78479 */     // GIR_Coverage, 47081,
     /*   78479 */     GIR_EraseRootFromParent_Done,
     /*   78480 */   // Label 1258: @78480
     /*   78480 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(78535), // Rule ID 47200 //
     /*   78485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78504 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78513 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78533 */     GIR_RootConstrainSelectedInstOperands,
     /*   78534 */     // GIR_Coverage, 47200,
     /*   78534 */     GIR_EraseRootFromParent_Done,
     /*   78535 */   // Label 1259: @78535
     /*   78535 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(78590), // Rule ID 47201 //
     /*   78540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78559 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78568 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78588 */     GIR_RootConstrainSelectedInstOperands,
     /*   78589 */     // GIR_Coverage, 47201,
     /*   78589 */     GIR_EraseRootFromParent_Done,
     /*   78590 */   // Label 1260: @78590
     /*   78590 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(78643), // Rule ID 46296 //
     /*   78595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78606 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   78606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   78623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78641 */     GIR_RootConstrainSelectedInstOperands,
     /*   78642 */     // GIR_Coverage, 46296,
     /*   78642 */     GIR_EraseRootFromParent_Done,
     /*   78643 */   // Label 1261: @78643
     /*   78643 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(78696), // Rule ID 46297 //
     /*   78648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78659 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   78659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   78676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78694 */     GIR_RootConstrainSelectedInstOperands,
     /*   78695 */     // GIR_Coverage, 46297,
     /*   78695 */     GIR_EraseRootFromParent_Done,
     /*   78696 */   // Label 1262: @78696
     /*   78696 */   GIM_Reject,
     /*   78697 */ // Label 1246: @78697
     /*   78697 */ GIM_Reject,
     /*   78698 */ // Label 985: @78698
     /*   78698 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(78944),
     /*   78703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   78709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78717 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(78781), // Rule ID 51994 //
     /*   78722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   78741 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78755 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   78755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   78758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78779 */     GIR_RootConstrainSelectedInstOperands,
     /*   78780 */     // GIR_Coverage, 51994,
     /*   78780 */     GIR_EraseRootFromParent_Done,
     /*   78781 */   // Label 1264: @78781
     /*   78781 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(78845), // Rule ID 51995 //
     /*   78786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   78805 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78819 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   78819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   78822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78843 */     GIR_RootConstrainSelectedInstOperands,
     /*   78844 */     // GIR_Coverage, 51995,
     /*   78844 */     GIR_EraseRootFromParent_Done,
     /*   78845 */   // Label 1265: @78845
     /*   78845 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(78894), // Rule ID 46268 //
     /*   78850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78857 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   78857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   78860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   78874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78892 */     GIR_RootConstrainSelectedInstOperands,
     /*   78893 */     // GIR_Coverage, 46268,
     /*   78893 */     GIR_EraseRootFromParent_Done,
     /*   78894 */   // Label 1266: @78894
     /*   78894 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(78943), // Rule ID 46269 //
     /*   78899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78906 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   78906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   78909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   78923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78941 */     GIR_RootConstrainSelectedInstOperands,
     /*   78942 */     // GIR_Coverage, 46269,
     /*   78942 */     GIR_EraseRootFromParent_Done,
     /*   78943 */   // Label 1267: @78943
     /*   78943 */   GIM_Reject,
     /*   78944 */ // Label 1263: @78944
     /*   78944 */ GIM_Reject,
     /*   78945 */ // Label 986: @78945
     /*   78945 */ GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(80067),
     /*   78950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   78953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   78956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78960 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(79049), // Rule ID 47240 //
     /*   78965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78980 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78999 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79008 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79047 */     GIR_RootConstrainSelectedInstOperands,
     /*   79048 */     // GIR_Coverage, 47240,
     /*   79048 */     GIR_EraseRootFromParent_Done,
     /*   79049 */   // Label 1269: @79049
     /*   79049 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(79138), // Rule ID 47241 //
     /*   79054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79069 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79088 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79097 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79136 */     GIR_RootConstrainSelectedInstOperands,
     /*   79137 */     // GIR_Coverage, 47241,
     /*   79137 */     GIR_EraseRootFromParent_Done,
     /*   79138 */   // Label 1270: @79138
     /*   79138 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(79227), // Rule ID 47000 //
     /*   79143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79158 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79177 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79186 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   79203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79225 */     GIR_RootConstrainSelectedInstOperands,
     /*   79226 */     // GIR_Coverage, 47000,
     /*   79226 */     GIR_EraseRootFromParent_Done,
     /*   79227 */   // Label 1271: @79227
     /*   79227 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(79316), // Rule ID 47001 //
     /*   79232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79247 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79266 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79275 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   79292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79314 */     GIR_RootConstrainSelectedInstOperands,
     /*   79315 */     // GIR_Coverage, 47001,
     /*   79315 */     GIR_EraseRootFromParent_Done,
     /*   79316 */   // Label 1272: @79316
     /*   79316 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(79405), // Rule ID 47120 //
     /*   79321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79336 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79355 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79364 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79403 */     GIR_RootConstrainSelectedInstOperands,
     /*   79404 */     // GIR_Coverage, 47120,
     /*   79404 */     GIR_EraseRootFromParent_Done,
     /*   79405 */   // Label 1273: @79405
     /*   79405 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(79494), // Rule ID 47121 //
     /*   79410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79425 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79444 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79453 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79492 */     GIR_RootConstrainSelectedInstOperands,
     /*   79493 */     // GIR_Coverage, 47121,
     /*   79493 */     GIR_EraseRootFromParent_Done,
     /*   79494 */   // Label 1274: @79494
     /*   79494 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(79562), // Rule ID 52010 //
     /*   79499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   79518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   79522 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79536 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   79536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   79539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   79545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79560 */     GIR_RootConstrainSelectedInstOperands,
     /*   79561 */     // GIR_Coverage, 52010,
     /*   79561 */     GIR_EraseRootFromParent_Done,
     /*   79562 */   // Label 1275: @79562
     /*   79562 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(79630), // Rule ID 52011 //
     /*   79567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   79586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   79590 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79604 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   79604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   79607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   79613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79628 */     GIR_RootConstrainSelectedInstOperands,
     /*   79629 */     // GIR_Coverage, 52011,
     /*   79629 */     GIR_EraseRootFromParent_Done,
     /*   79630 */   // Label 1276: @79630
     /*   79630 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(79685), // Rule ID 47300 //
     /*   79635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79654 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79663 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79683 */     GIR_RootConstrainSelectedInstOperands,
     /*   79684 */     // GIR_Coverage, 47300,
     /*   79684 */     GIR_EraseRootFromParent_Done,
     /*   79685 */   // Label 1277: @79685
     /*   79685 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(79740), // Rule ID 47301 //
     /*   79690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79718 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79738 */     GIR_RootConstrainSelectedInstOperands,
     /*   79739 */     // GIR_Coverage, 47301,
     /*   79739 */     GIR_EraseRootFromParent_Done,
     /*   79740 */   // Label 1278: @79740
     /*   79740 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(79795), // Rule ID 47060 //
     /*   79745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79764 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79773 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   79776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79793 */     GIR_RootConstrainSelectedInstOperands,
     /*   79794 */     // GIR_Coverage, 47060,
     /*   79794 */     GIR_EraseRootFromParent_Done,
     /*   79795 */   // Label 1279: @79795
     /*   79795 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(79850), // Rule ID 47061 //
     /*   79800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79819 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79828 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   79831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79848 */     GIR_RootConstrainSelectedInstOperands,
     /*   79849 */     // GIR_Coverage, 47061,
     /*   79849 */     GIR_EraseRootFromParent_Done,
     /*   79850 */   // Label 1280: @79850
     /*   79850 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(79905), // Rule ID 47180 //
     /*   79855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79874 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79883 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79903 */     GIR_RootConstrainSelectedInstOperands,
     /*   79904 */     // GIR_Coverage, 47180,
     /*   79904 */     GIR_EraseRootFromParent_Done,
     /*   79905 */   // Label 1281: @79905
     /*   79905 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(79960), // Rule ID 47181 //
     /*   79910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79929 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79938 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79958 */     GIR_RootConstrainSelectedInstOperands,
     /*   79959 */     // GIR_Coverage, 47181,
     /*   79959 */     GIR_EraseRootFromParent_Done,
     /*   79960 */   // Label 1282: @79960
     /*   79960 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(80013), // Rule ID 46284 //
     /*   79965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79976 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   79976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   79993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80011 */     GIR_RootConstrainSelectedInstOperands,
     /*   80012 */     // GIR_Coverage, 46284,
     /*   80012 */     GIR_EraseRootFromParent_Done,
     /*   80013 */   // Label 1283: @80013
     /*   80013 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(80066), // Rule ID 46285 //
     /*   80018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80029 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   80029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   80032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80064 */     GIR_RootConstrainSelectedInstOperands,
     /*   80065 */     // GIR_Coverage, 46285,
     /*   80065 */     GIR_EraseRootFromParent_Done,
     /*   80066 */   // Label 1284: @80066
     /*   80066 */   GIM_Reject,
     /*   80067 */ // Label 1268: @80067
     /*   80067 */ GIM_Reject,
     /*   80068 */ // Label 987: @80068
     /*   80068 */ GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(80314),
     /*   80073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80087 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(80151), // Rule ID 51998 //
     /*   80092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80111 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80125 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   80125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80149 */     GIR_RootConstrainSelectedInstOperands,
     /*   80150 */     // GIR_Coverage, 51998,
     /*   80150 */     GIR_EraseRootFromParent_Done,
     /*   80151 */   // Label 1286: @80151
     /*   80151 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(80215), // Rule ID 51999 //
     /*   80156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80189 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   80189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80213 */     GIR_RootConstrainSelectedInstOperands,
     /*   80214 */     // GIR_Coverage, 51999,
     /*   80214 */     GIR_EraseRootFromParent_Done,
     /*   80215 */   // Label 1287: @80215
     /*   80215 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(80264), // Rule ID 46272 //
     /*   80220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80227 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   80230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80262 */     GIR_RootConstrainSelectedInstOperands,
     /*   80263 */     // GIR_Coverage, 46272,
     /*   80263 */     GIR_EraseRootFromParent_Done,
     /*   80264 */   // Label 1288: @80264
     /*   80264 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(80313), // Rule ID 46273 //
     /*   80269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80276 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   80279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80311 */     GIR_RootConstrainSelectedInstOperands,
     /*   80312 */     // GIR_Coverage, 46273,
     /*   80312 */     GIR_EraseRootFromParent_Done,
     /*   80313 */   // Label 1289: @80313
     /*   80313 */   GIM_Reject,
     /*   80314 */ // Label 1285: @80314
     /*   80314 */ GIM_Reject,
     /*   80315 */ // Label 988: @80315
     /*   80315 */ GIM_Reject,
     /*   80316 */ // Label 2: @80316
     /*   80316 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1314*/ GIMT_Encode4(107369),
     /*   80327 */ /*GILLT_s32*//*Label 1290*/ GIMT_Encode4(80451),
     /*   80331 */ /*GILLT_s64*//*Label 1291*/ GIMT_Encode4(80485), GIMT_Encode4(0),
     /*   80339 */ /*GILLT_nxv1s8*//*Label 1292*/ GIMT_Encode4(80689),
     /*   80343 */ /*GILLT_nxv1s16*//*Label 1293*/ GIMT_Encode4(80804),
     /*   80347 */ /*GILLT_nxv1s32*//*Label 1294*/ GIMT_Encode4(82529),
     /*   80351 */ /*GILLT_nxv1s64*//*Label 1295*/ GIMT_Encode4(84254), GIMT_Encode4(0),
     /*   80359 */ /*GILLT_nxv2s8*//*Label 1296*/ GIMT_Encode4(85979),
     /*   80363 */ /*GILLT_nxv2s16*//*Label 1297*/ GIMT_Encode4(86094),
     /*   80367 */ /*GILLT_nxv2s32*//*Label 1298*/ GIMT_Encode4(87819),
     /*   80371 */ /*GILLT_nxv2s64*//*Label 1299*/ GIMT_Encode4(89544), GIMT_Encode4(0),
     /*   80379 */ /*GILLT_nxv4s8*//*Label 1300*/ GIMT_Encode4(91269),
     /*   80383 */ /*GILLT_nxv4s16*//*Label 1301*/ GIMT_Encode4(91384),
     /*   80387 */ /*GILLT_nxv4s32*//*Label 1302*/ GIMT_Encode4(93109),
     /*   80391 */ /*GILLT_nxv4s64*//*Label 1303*/ GIMT_Encode4(94834), GIMT_Encode4(0),
     /*   80399 */ /*GILLT_nxv8s8*//*Label 1304*/ GIMT_Encode4(96559),
     /*   80403 */ /*GILLT_nxv8s16*//*Label 1305*/ GIMT_Encode4(96674),
     /*   80407 */ /*GILLT_nxv8s32*//*Label 1306*/ GIMT_Encode4(98399),
     /*   80411 */ /*GILLT_nxv8s64*//*Label 1307*/ GIMT_Encode4(100124), GIMT_Encode4(0),
     /*   80419 */ /*GILLT_nxv16s8*//*Label 1308*/ GIMT_Encode4(101849),
     /*   80423 */ /*GILLT_nxv16s16*//*Label 1309*/ GIMT_Encode4(101964),
     /*   80427 */ /*GILLT_nxv16s32*//*Label 1310*/ GIMT_Encode4(103689), GIMT_Encode4(0),
     /*   80435 */ /*GILLT_nxv32s8*//*Label 1311*/ GIMT_Encode4(105414),
     /*   80439 */ /*GILLT_nxv32s16*//*Label 1312*/ GIMT_Encode4(105529), GIMT_Encode4(0),
     /*   80447 */ /*GILLT_nxv64s8*//*Label 1313*/ GIMT_Encode4(107254),
     /*   80451 */ // Label 1290: @80451
     /*   80451 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(80484), // Rule ID 302 //
     /*   80456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /*   80459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   80462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   80465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80477 */   // (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MUL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   80477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   80482 */   GIR_RootConstrainSelectedInstOperands,
     /*   80483 */   // GIR_Coverage, 302,
     /*   80483 */   GIR_Done,
     /*   80484 */ // Label 1315: @80484
     /*   80484 */ GIM_Reject,
     /*   80485 */ // Label 1291: @80485
     /*   80485 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(80688),
     /*   80490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   80493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   80496 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(80629), // Rule ID 324 //
     /*   80501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0),
     /*   80504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   80516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   80520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   80524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80529 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*   80540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   80548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   80552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   80556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80561 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*   80572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80574 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 4294967295:{ *:[i64] }))  =>  (MULHU:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))
     /*   80574 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   80577 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   80581 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80586 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   80590 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*   80593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   80595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   80598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   80602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80607 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80611 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*   80614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /*   80619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   80627 */     GIR_RootConstrainSelectedInstOperands,
     /*   80628 */     // GIR_Coverage, 324,
     /*   80628 */     GIR_EraseRootFromParent_Done,
     /*   80629 */   // Label 1317: @80629
     /*   80629 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(80660), // Rule ID 317 //
     /*   80634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_HwMode0),
     /*   80637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10082),
     /*   80653 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10082>>  =>  (MULW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   80653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULW),
     /*   80658 */     GIR_RootConstrainSelectedInstOperands,
     /*   80659 */     // GIR_Coverage, 317,
     /*   80659 */     GIR_Done,
     /*   80660 */   // Label 1318: @80660
     /*   80660 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(80687), // Rule ID 301 //
     /*   80665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /*   80668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80680 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MUL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   80680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   80685 */     GIR_RootConstrainSelectedInstOperands,
     /*   80686 */     // GIR_Coverage, 301,
     /*   80686 */     GIR_Done,
     /*   80687 */   // Label 1319: @80687
     /*   80687 */   GIM_Reject,
     /*   80688 */ // Label 1316: @80688
     /*   80688 */ GIM_Reject,
     /*   80689 */ // Label 1292: @80689
     /*   80689 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(80803),
     /*   80694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   80700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80712 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(80757), // Rule ID 50860 //
     /*   80717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80720 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   80723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   80737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80755 */     GIR_RootConstrainSelectedInstOperands,
     /*   80756 */     // GIR_Coverage, 50860,
     /*   80756 */     GIR_EraseRootFromParent_Done,
     /*   80757 */   // Label 1321: @80757
     /*   80757 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(80802), // Rule ID 50861 //
     /*   80762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80765 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   80768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   80782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80800 */     GIR_RootConstrainSelectedInstOperands,
     /*   80801 */     // GIR_Coverage, 50861,
     /*   80801 */     GIR_EraseRootFromParent_Done,
     /*   80802 */   // Label 1322: @80802
     /*   80802 */   GIM_Reject,
     /*   80803 */ // Label 1320: @80803
     /*   80803 */ GIM_Reject,
     /*   80804 */ // Label 1293: @80804
     /*   80804 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(82528),
     /*   80809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   80812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   80815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80819 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(80908), // Rule ID 51626 //
     /*   80824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80839 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80858 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80867 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   80870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   80884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80906 */     GIR_RootConstrainSelectedInstOperands,
     /*   80907 */     // GIR_Coverage, 51626,
     /*   80907 */     GIR_EraseRootFromParent_Done,
     /*   80908 */   // Label 1324: @80908
     /*   80908 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(80997), // Rule ID 51627 //
     /*   80913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80928 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80947 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80956 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   80959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   80973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80995 */     GIR_RootConstrainSelectedInstOperands,
     /*   80996 */     // GIR_Coverage, 51627,
     /*   80996 */     GIR_EraseRootFromParent_Done,
     /*   80997 */   // Label 1325: @80997
     /*   80997 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(81086), // Rule ID 70568 //
     /*   81002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81017 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81036 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81045 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81084 */     GIR_RootConstrainSelectedInstOperands,
     /*   81085 */     // GIR_Coverage, 70568,
     /*   81085 */     GIR_EraseRootFromParent_Done,
     /*   81086 */   // Label 1326: @81086
     /*   81086 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(81175), // Rule ID 70569 //
     /*   81091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81106 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81125 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81134 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81173 */     GIR_RootConstrainSelectedInstOperands,
     /*   81174 */     // GIR_Coverage, 70569,
     /*   81174 */     GIR_EraseRootFromParent_Done,
     /*   81175 */   // Label 1327: @81175
     /*   81175 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(81264), // Rule ID 70448 //
     /*   81180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81195 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81214 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81223 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81262 */     GIR_RootConstrainSelectedInstOperands,
     /*   81263 */     // GIR_Coverage, 70448,
     /*   81263 */     GIR_EraseRootFromParent_Done,
     /*   81264 */   // Label 1328: @81264
     /*   81264 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(81353), // Rule ID 70449 //
     /*   81269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81284 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81303 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81312 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81351 */     GIR_RootConstrainSelectedInstOperands,
     /*   81352 */     // GIR_Coverage, 70449,
     /*   81352 */     GIR_EraseRootFromParent_Done,
     /*   81353 */   // Label 1329: @81353
     /*   81353 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(81442), // Rule ID 51806 //
     /*   81358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81373 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81392 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81399 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81401 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81440 */     GIR_RootConstrainSelectedInstOperands,
     /*   81441 */     // GIR_Coverage, 51806,
     /*   81441 */     GIR_EraseRootFromParent_Done,
     /*   81442 */   // Label 1330: @81442
     /*   81442 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(81531), // Rule ID 51807 //
     /*   81447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81462 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81481 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81490 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81529 */     GIR_RootConstrainSelectedInstOperands,
     /*   81530 */     // GIR_Coverage, 51807,
     /*   81530 */     GIR_EraseRootFromParent_Done,
     /*   81531 */   // Label 1331: @81531
     /*   81531 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(81620), // Rule ID 51506 //
     /*   81536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81551 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81570 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81579 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   81596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81618 */     GIR_RootConstrainSelectedInstOperands,
     /*   81619 */     // GIR_Coverage, 51506,
     /*   81619 */     GIR_EraseRootFromParent_Done,
     /*   81620 */   // Label 1332: @81620
     /*   81620 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(81709), // Rule ID 51507 //
     /*   81625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81640 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81659 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81668 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   81685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81707 */     GIR_RootConstrainSelectedInstOperands,
     /*   81708 */     // GIR_Coverage, 51507,
     /*   81708 */     GIR_EraseRootFromParent_Done,
     /*   81709 */   // Label 1333: @81709
     /*   81709 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(81798), // Rule ID 51746 //
     /*   81714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81729 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81748 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81757 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81796 */     GIR_RootConstrainSelectedInstOperands,
     /*   81797 */     // GIR_Coverage, 51746,
     /*   81797 */     GIR_EraseRootFromParent_Done,
     /*   81798 */   // Label 1334: @81798
     /*   81798 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(81887), // Rule ID 51747 //
     /*   81803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81818 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81837 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81839 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81846 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81885 */     GIR_RootConstrainSelectedInstOperands,
     /*   81886 */     // GIR_Coverage, 51747,
     /*   81886 */     GIR_EraseRootFromParent_Done,
     /*   81887 */   // Label 1335: @81887
     /*   81887 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(81976), // Rule ID 51686 //
     /*   81892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81907 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81926 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81935 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81974 */     GIR_RootConstrainSelectedInstOperands,
     /*   81975 */     // GIR_Coverage, 51686,
     /*   81975 */     GIR_EraseRootFromParent_Done,
     /*   81976 */   // Label 1336: @81976
     /*   81976 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(82065), // Rule ID 51687 //
     /*   81981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81996 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82015 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82024 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82063 */     GIR_RootConstrainSelectedInstOperands,
     /*   82064 */     // GIR_Coverage, 51687,
     /*   82064 */     GIR_EraseRootFromParent_Done,
     /*   82065 */   // Label 1337: @82065
     /*   82065 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(82154), // Rule ID 70508 //
     /*   82070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82085 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82104 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82113 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82152 */     GIR_RootConstrainSelectedInstOperands,
     /*   82153 */     // GIR_Coverage, 70508,
     /*   82153 */     GIR_EraseRootFromParent_Done,
     /*   82154 */   // Label 1338: @82154
     /*   82154 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(82243), // Rule ID 70509 //
     /*   82159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82174 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82193 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82202 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82241 */     GIR_RootConstrainSelectedInstOperands,
     /*   82242 */     // GIR_Coverage, 70509,
     /*   82242 */     GIR_EraseRootFromParent_Done,
     /*   82243 */   // Label 1339: @82243
     /*   82243 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(82332), // Rule ID 51566 //
     /*   82248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82263 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82282 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82291 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82330 */     GIR_RootConstrainSelectedInstOperands,
     /*   82331 */     // GIR_Coverage, 51566,
     /*   82331 */     GIR_EraseRootFromParent_Done,
     /*   82332 */   // Label 1340: @82332
     /*   82332 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(82421), // Rule ID 51567 //
     /*   82337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82352 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82371 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82380 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82419 */     GIR_RootConstrainSelectedInstOperands,
     /*   82420 */     // GIR_Coverage, 51567,
     /*   82420 */     GIR_EraseRootFromParent_Done,
     /*   82421 */   // Label 1341: @82421
     /*   82421 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(82474), // Rule ID 50872 //
     /*   82426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82437 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   82454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   82461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   82463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82472 */     GIR_RootConstrainSelectedInstOperands,
     /*   82473 */     // GIR_Coverage, 50872,
     /*   82473 */     GIR_EraseRootFromParent_Done,
     /*   82474 */   // Label 1342: @82474
     /*   82474 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(82527), // Rule ID 50873 //
     /*   82479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82490 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   82507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   82514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   82516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82525 */     GIR_RootConstrainSelectedInstOperands,
     /*   82526 */     // GIR_Coverage, 50873,
     /*   82526 */     GIR_EraseRootFromParent_Done,
     /*   82527 */   // Label 1343: @82527
     /*   82527 */   GIM_Reject,
     /*   82528 */ // Label 1323: @82528
     /*   82528 */ GIM_Reject,
     /*   82529 */ // Label 1294: @82529
     /*   82529 */ GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(84253),
     /*   82534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   82537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   82540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82544 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(82633), // Rule ID 51650 //
     /*   82549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82564 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82583 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82592 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82631 */     GIR_RootConstrainSelectedInstOperands,
     /*   82632 */     // GIR_Coverage, 51650,
     /*   82632 */     GIR_EraseRootFromParent_Done,
     /*   82633 */   // Label 1345: @82633
     /*   82633 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(82722), // Rule ID 51651 //
     /*   82638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82653 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82672 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82681 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82720 */     GIR_RootConstrainSelectedInstOperands,
     /*   82721 */     // GIR_Coverage, 51651,
     /*   82721 */     GIR_EraseRootFromParent_Done,
     /*   82722 */   // Label 1346: @82722
     /*   82722 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(82811), // Rule ID 70592 //
     /*   82727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82742 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82761 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82770 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   82787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82809 */     GIR_RootConstrainSelectedInstOperands,
     /*   82810 */     // GIR_Coverage, 70592,
     /*   82810 */     GIR_EraseRootFromParent_Done,
     /*   82811 */   // Label 1347: @82811
     /*   82811 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(82900), // Rule ID 70593 //
     /*   82816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82850 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82859 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   82876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82898 */     GIR_RootConstrainSelectedInstOperands,
     /*   82899 */     // GIR_Coverage, 70593,
     /*   82899 */     GIR_EraseRootFromParent_Done,
     /*   82900 */   // Label 1348: @82900
     /*   82900 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(82989), // Rule ID 70472 //
     /*   82905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82939 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82948 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82987 */     GIR_RootConstrainSelectedInstOperands,
     /*   82988 */     // GIR_Coverage, 70472,
     /*   82988 */     GIR_EraseRootFromParent_Done,
     /*   82989 */   // Label 1349: @82989
     /*   82989 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(83078), // Rule ID 70473 //
     /*   82994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83009 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83028 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83037 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83076 */     GIR_RootConstrainSelectedInstOperands,
     /*   83077 */     // GIR_Coverage, 70473,
     /*   83077 */     GIR_EraseRootFromParent_Done,
     /*   83078 */   // Label 1350: @83078
     /*   83078 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(83167), // Rule ID 51830 //
     /*   83083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83098 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83117 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83126 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83165 */     GIR_RootConstrainSelectedInstOperands,
     /*   83166 */     // GIR_Coverage, 51830,
     /*   83166 */     GIR_EraseRootFromParent_Done,
     /*   83167 */   // Label 1351: @83167
     /*   83167 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(83256), // Rule ID 51831 //
     /*   83172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83187 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83206 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83215 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83254 */     GIR_RootConstrainSelectedInstOperands,
     /*   83255 */     // GIR_Coverage, 51831,
     /*   83255 */     GIR_EraseRootFromParent_Done,
     /*   83256 */   // Label 1352: @83256
     /*   83256 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(83345), // Rule ID 51530 //
     /*   83261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83276 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83295 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83304 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   83321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83343 */     GIR_RootConstrainSelectedInstOperands,
     /*   83344 */     // GIR_Coverage, 51530,
     /*   83344 */     GIR_EraseRootFromParent_Done,
     /*   83345 */   // Label 1353: @83345
     /*   83345 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(83434), // Rule ID 51531 //
     /*   83350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83365 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83384 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83393 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   83410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83432 */     GIR_RootConstrainSelectedInstOperands,
     /*   83433 */     // GIR_Coverage, 51531,
     /*   83433 */     GIR_EraseRootFromParent_Done,
     /*   83434 */   // Label 1354: @83434
     /*   83434 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(83523), // Rule ID 51770 //
     /*   83439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83454 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83473 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83482 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83521 */     GIR_RootConstrainSelectedInstOperands,
     /*   83522 */     // GIR_Coverage, 51770,
     /*   83522 */     GIR_EraseRootFromParent_Done,
     /*   83523 */   // Label 1355: @83523
     /*   83523 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(83612), // Rule ID 51771 //
     /*   83528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83543 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83562 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83571 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83610 */     GIR_RootConstrainSelectedInstOperands,
     /*   83611 */     // GIR_Coverage, 51771,
     /*   83611 */     GIR_EraseRootFromParent_Done,
     /*   83612 */   // Label 1356: @83612
     /*   83612 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(83701), // Rule ID 51710 //
     /*   83617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83632 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83651 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83660 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83699 */     GIR_RootConstrainSelectedInstOperands,
     /*   83700 */     // GIR_Coverage, 51710,
     /*   83700 */     GIR_EraseRootFromParent_Done,
     /*   83701 */   // Label 1357: @83701
     /*   83701 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(83790), // Rule ID 51711 //
     /*   83706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83740 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83749 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83788 */     GIR_RootConstrainSelectedInstOperands,
     /*   83789 */     // GIR_Coverage, 51711,
     /*   83789 */     GIR_EraseRootFromParent_Done,
     /*   83790 */   // Label 1358: @83790
     /*   83790 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(83879), // Rule ID 70532 //
     /*   83795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83810 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83829 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83838 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83877 */     GIR_RootConstrainSelectedInstOperands,
     /*   83878 */     // GIR_Coverage, 70532,
     /*   83878 */     GIR_EraseRootFromParent_Done,
     /*   83879 */   // Label 1359: @83879
     /*   83879 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(83968), // Rule ID 70533 //
     /*   83884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83899 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83918 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83927 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83966 */     GIR_RootConstrainSelectedInstOperands,
     /*   83967 */     // GIR_Coverage, 70533,
     /*   83967 */     GIR_EraseRootFromParent_Done,
     /*   83968 */   // Label 1360: @83968
     /*   83968 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(84057), // Rule ID 51590 //
     /*   83973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83988 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84007 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84016 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84055 */     GIR_RootConstrainSelectedInstOperands,
     /*   84056 */     // GIR_Coverage, 51590,
     /*   84056 */     GIR_EraseRootFromParent_Done,
     /*   84057 */   // Label 1361: @84057
     /*   84057 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(84146), // Rule ID 51591 //
     /*   84062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84077 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84096 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84105 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84144 */     GIR_RootConstrainSelectedInstOperands,
     /*   84145 */     // GIR_Coverage, 51591,
     /*   84145 */     GIR_EraseRootFromParent_Done,
     /*   84146 */   // Label 1362: @84146
     /*   84146 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(84199), // Rule ID 50880 //
     /*   84151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84162 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   84179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   84186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   84188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84197 */     GIR_RootConstrainSelectedInstOperands,
     /*   84198 */     // GIR_Coverage, 50880,
     /*   84198 */     GIR_EraseRootFromParent_Done,
     /*   84199 */   // Label 1363: @84199
     /*   84199 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(84252), // Rule ID 50881 //
     /*   84204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84215 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   84232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   84239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   84241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84250 */     GIR_RootConstrainSelectedInstOperands,
     /*   84251 */     // GIR_Coverage, 50881,
     /*   84251 */     GIR_EraseRootFromParent_Done,
     /*   84252 */   // Label 1364: @84252
     /*   84252 */   GIM_Reject,
     /*   84253 */ // Label 1344: @84253
     /*   84253 */ GIM_Reject,
     /*   84254 */ // Label 1295: @84254
     /*   84254 */ GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(85978),
     /*   84259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   84262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   84265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84269 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(84358), // Rule ID 51670 //
     /*   84274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84289 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84308 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84317 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84356 */     GIR_RootConstrainSelectedInstOperands,
     /*   84357 */     // GIR_Coverage, 51670,
     /*   84357 */     GIR_EraseRootFromParent_Done,
     /*   84358 */   // Label 1366: @84358
     /*   84358 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(84447), // Rule ID 51671 //
     /*   84363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84378 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84397 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84406 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84445 */     GIR_RootConstrainSelectedInstOperands,
     /*   84446 */     // GIR_Coverage, 51671,
     /*   84446 */     GIR_EraseRootFromParent_Done,
     /*   84447 */   // Label 1367: @84447
     /*   84447 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(84536), // Rule ID 70612 //
     /*   84452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84467 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84486 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84495 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84534 */     GIR_RootConstrainSelectedInstOperands,
     /*   84535 */     // GIR_Coverage, 70612,
     /*   84535 */     GIR_EraseRootFromParent_Done,
     /*   84536 */   // Label 1368: @84536
     /*   84536 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(84625), // Rule ID 70613 //
     /*   84541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84575 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84584 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84623 */     GIR_RootConstrainSelectedInstOperands,
     /*   84624 */     // GIR_Coverage, 70613,
     /*   84624 */     GIR_EraseRootFromParent_Done,
     /*   84625 */   // Label 1369: @84625
     /*   84625 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(84714), // Rule ID 70492 //
     /*   84630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84645 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84664 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84673 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84712 */     GIR_RootConstrainSelectedInstOperands,
     /*   84713 */     // GIR_Coverage, 70492,
     /*   84713 */     GIR_EraseRootFromParent_Done,
     /*   84714 */   // Label 1370: @84714
     /*   84714 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(84803), // Rule ID 70493 //
     /*   84719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84734 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84753 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84762 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84801 */     GIR_RootConstrainSelectedInstOperands,
     /*   84802 */     // GIR_Coverage, 70493,
     /*   84802 */     GIR_EraseRootFromParent_Done,
     /*   84803 */   // Label 1371: @84803
     /*   84803 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(84892), // Rule ID 51850 //
     /*   84808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84823 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84842 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84851 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84890 */     GIR_RootConstrainSelectedInstOperands,
     /*   84891 */     // GIR_Coverage, 51850,
     /*   84891 */     GIR_EraseRootFromParent_Done,
     /*   84892 */   // Label 1372: @84892
     /*   84892 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(84981), // Rule ID 51851 //
     /*   84897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84912 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84931 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84933 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84940 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84979 */     GIR_RootConstrainSelectedInstOperands,
     /*   84980 */     // GIR_Coverage, 51851,
     /*   84980 */     GIR_EraseRootFromParent_Done,
     /*   84981 */   // Label 1373: @84981
     /*   84981 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(85070), // Rule ID 51550 //
     /*   84986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85001 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85020 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85029 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   85046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85068 */     GIR_RootConstrainSelectedInstOperands,
     /*   85069 */     // GIR_Coverage, 51550,
     /*   85069 */     GIR_EraseRootFromParent_Done,
     /*   85070 */   // Label 1374: @85070
     /*   85070 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(85159), // Rule ID 51551 //
     /*   85075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85090 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85109 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85118 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   85135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85157 */     GIR_RootConstrainSelectedInstOperands,
     /*   85158 */     // GIR_Coverage, 51551,
     /*   85158 */     GIR_EraseRootFromParent_Done,
     /*   85159 */   // Label 1375: @85159
     /*   85159 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(85248), // Rule ID 51790 //
     /*   85164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85179 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85198 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85207 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85246 */     GIR_RootConstrainSelectedInstOperands,
     /*   85247 */     // GIR_Coverage, 51790,
     /*   85247 */     GIR_EraseRootFromParent_Done,
     /*   85248 */   // Label 1376: @85248
     /*   85248 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(85337), // Rule ID 51791 //
     /*   85253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85268 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85287 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85296 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85335 */     GIR_RootConstrainSelectedInstOperands,
     /*   85336 */     // GIR_Coverage, 51791,
     /*   85336 */     GIR_EraseRootFromParent_Done,
     /*   85337 */   // Label 1377: @85337
     /*   85337 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(85426), // Rule ID 51730 //
     /*   85342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85357 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85376 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85385 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85424 */     GIR_RootConstrainSelectedInstOperands,
     /*   85425 */     // GIR_Coverage, 51730,
     /*   85425 */     GIR_EraseRootFromParent_Done,
     /*   85426 */   // Label 1378: @85426
     /*   85426 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(85515), // Rule ID 51731 //
     /*   85431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85446 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85465 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85474 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85513 */     GIR_RootConstrainSelectedInstOperands,
     /*   85514 */     // GIR_Coverage, 51731,
     /*   85514 */     GIR_EraseRootFromParent_Done,
     /*   85515 */   // Label 1379: @85515
     /*   85515 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(85604), // Rule ID 70552 //
     /*   85520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85535 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85554 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85563 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85602 */     GIR_RootConstrainSelectedInstOperands,
     /*   85603 */     // GIR_Coverage, 70552,
     /*   85603 */     GIR_EraseRootFromParent_Done,
     /*   85604 */   // Label 1380: @85604
     /*   85604 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(85693), // Rule ID 70553 //
     /*   85609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85624 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85643 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85652 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85691 */     GIR_RootConstrainSelectedInstOperands,
     /*   85692 */     // GIR_Coverage, 70553,
     /*   85692 */     GIR_EraseRootFromParent_Done,
     /*   85693 */   // Label 1381: @85693
     /*   85693 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(85782), // Rule ID 51610 //
     /*   85698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85713 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85732 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85741 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85780 */     GIR_RootConstrainSelectedInstOperands,
     /*   85781 */     // GIR_Coverage, 51610,
     /*   85781 */     GIR_EraseRootFromParent_Done,
     /*   85782 */   // Label 1382: @85782
     /*   85782 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(85871), // Rule ID 51611 //
     /*   85787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85802 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85821 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85823 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85830 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85869 */     GIR_RootConstrainSelectedInstOperands,
     /*   85870 */     // GIR_Coverage, 51611,
     /*   85870 */     GIR_EraseRootFromParent_Done,
     /*   85871 */   // Label 1383: @85871
     /*   85871 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(85924), // Rule ID 50896 //
     /*   85876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   85879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85887 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   85887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   85904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   85911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   85913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   85919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85922 */     GIR_RootConstrainSelectedInstOperands,
     /*   85923 */     // GIR_Coverage, 50896,
     /*   85923 */     GIR_EraseRootFromParent_Done,
     /*   85924 */   // Label 1384: @85924
     /*   85924 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(85977), // Rule ID 50897 //
     /*   85929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   85932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85940 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   85940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   85957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   85964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   85966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   85972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85975 */     GIR_RootConstrainSelectedInstOperands,
     /*   85976 */     // GIR_Coverage, 50897,
     /*   85976 */     GIR_EraseRootFromParent_Done,
     /*   85977 */   // Label 1385: @85977
     /*   85977 */   GIM_Reject,
     /*   85978 */ // Label 1365: @85978
     /*   85978 */ GIM_Reject,
     /*   85979 */ // Label 1296: @85979
     /*   85979 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(86093),
     /*   85984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   85987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   85990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86002 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(86047), // Rule ID 50864 //
     /*   86007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86010 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   86013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   86027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86045 */     GIR_RootConstrainSelectedInstOperands,
     /*   86046 */     // GIR_Coverage, 50864,
     /*   86046 */     GIR_EraseRootFromParent_Done,
     /*   86047 */   // Label 1387: @86047
     /*   86047 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(86092), // Rule ID 50865 //
     /*   86052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86055 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   86058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   86072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86090 */     GIR_RootConstrainSelectedInstOperands,
     /*   86091 */     // GIR_Coverage, 50865,
     /*   86091 */     GIR_EraseRootFromParent_Done,
     /*   86092 */   // Label 1388: @86092
     /*   86092 */   GIM_Reject,
     /*   86093 */ // Label 1386: @86093
     /*   86093 */ GIM_Reject,
     /*   86094 */ // Label 1297: @86094
     /*   86094 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(87818),
     /*   86099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   86102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   86105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86109 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(86198), // Rule ID 51630 //
     /*   86114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86129 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86148 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86157 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86196 */     GIR_RootConstrainSelectedInstOperands,
     /*   86197 */     // GIR_Coverage, 51630,
     /*   86197 */     GIR_EraseRootFromParent_Done,
     /*   86198 */   // Label 1390: @86198
     /*   86198 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(86287), // Rule ID 51631 //
     /*   86203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86237 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86239 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86246 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86285 */     GIR_RootConstrainSelectedInstOperands,
     /*   86286 */     // GIR_Coverage, 51631,
     /*   86286 */     GIR_EraseRootFromParent_Done,
     /*   86287 */   // Label 1391: @86287
     /*   86287 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(86376), // Rule ID 70572 //
     /*   86292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86307 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86326 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86335 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86374 */     GIR_RootConstrainSelectedInstOperands,
     /*   86375 */     // GIR_Coverage, 70572,
     /*   86375 */     GIR_EraseRootFromParent_Done,
     /*   86376 */   // Label 1392: @86376
     /*   86376 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(86465), // Rule ID 70573 //
     /*   86381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86396 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86415 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86424 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86463 */     GIR_RootConstrainSelectedInstOperands,
     /*   86464 */     // GIR_Coverage, 70573,
     /*   86464 */     GIR_EraseRootFromParent_Done,
     /*   86465 */   // Label 1393: @86465
     /*   86465 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(86554), // Rule ID 70452 //
     /*   86470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86485 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86504 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86513 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86552 */     GIR_RootConstrainSelectedInstOperands,
     /*   86553 */     // GIR_Coverage, 70452,
     /*   86553 */     GIR_EraseRootFromParent_Done,
     /*   86554 */   // Label 1394: @86554
     /*   86554 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(86643), // Rule ID 70453 //
     /*   86559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86574 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86593 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86602 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86641 */     GIR_RootConstrainSelectedInstOperands,
     /*   86642 */     // GIR_Coverage, 70453,
     /*   86642 */     GIR_EraseRootFromParent_Done,
     /*   86643 */   // Label 1395: @86643
     /*   86643 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(86732), // Rule ID 51810 //
     /*   86648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86663 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86682 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86691 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86730 */     GIR_RootConstrainSelectedInstOperands,
     /*   86731 */     // GIR_Coverage, 51810,
     /*   86731 */     GIR_EraseRootFromParent_Done,
     /*   86732 */   // Label 1396: @86732
     /*   86732 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(86821), // Rule ID 51811 //
     /*   86737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86771 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86780 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86819 */     GIR_RootConstrainSelectedInstOperands,
     /*   86820 */     // GIR_Coverage, 51811,
     /*   86820 */     GIR_EraseRootFromParent_Done,
     /*   86821 */   // Label 1397: @86821
     /*   86821 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(86910), // Rule ID 51510 //
     /*   86826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86860 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86869 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   86886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86908 */     GIR_RootConstrainSelectedInstOperands,
     /*   86909 */     // GIR_Coverage, 51510,
     /*   86909 */     GIR_EraseRootFromParent_Done,
     /*   86910 */   // Label 1398: @86910
     /*   86910 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(86999), // Rule ID 51511 //
     /*   86915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86930 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86949 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86958 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   86975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86997 */     GIR_RootConstrainSelectedInstOperands,
     /*   86998 */     // GIR_Coverage, 51511,
     /*   86998 */     GIR_EraseRootFromParent_Done,
     /*   86999 */   // Label 1399: @86999
     /*   86999 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(87088), // Rule ID 51750 //
     /*   87004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87019 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87038 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87047 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87086 */     GIR_RootConstrainSelectedInstOperands,
     /*   87087 */     // GIR_Coverage, 51750,
     /*   87087 */     GIR_EraseRootFromParent_Done,
     /*   87088 */   // Label 1400: @87088
     /*   87088 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(87177), // Rule ID 51751 //
     /*   87093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87108 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87127 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87136 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87175 */     GIR_RootConstrainSelectedInstOperands,
     /*   87176 */     // GIR_Coverage, 51751,
     /*   87176 */     GIR_EraseRootFromParent_Done,
     /*   87177 */   // Label 1401: @87177
     /*   87177 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(87266), // Rule ID 51690 //
     /*   87182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87197 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87216 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87225 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87264 */     GIR_RootConstrainSelectedInstOperands,
     /*   87265 */     // GIR_Coverage, 51690,
     /*   87265 */     GIR_EraseRootFromParent_Done,
     /*   87266 */   // Label 1402: @87266
     /*   87266 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(87355), // Rule ID 51691 //
     /*   87271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87286 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87305 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87314 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87353 */     GIR_RootConstrainSelectedInstOperands,
     /*   87354 */     // GIR_Coverage, 51691,
     /*   87354 */     GIR_EraseRootFromParent_Done,
     /*   87355 */   // Label 1403: @87355
     /*   87355 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(87444), // Rule ID 70512 //
     /*   87360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87375 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87394 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87396 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87403 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87442 */     GIR_RootConstrainSelectedInstOperands,
     /*   87443 */     // GIR_Coverage, 70512,
     /*   87443 */     GIR_EraseRootFromParent_Done,
     /*   87444 */   // Label 1404: @87444
     /*   87444 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(87533), // Rule ID 70513 //
     /*   87449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87464 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87483 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87492 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87531 */     GIR_RootConstrainSelectedInstOperands,
     /*   87532 */     // GIR_Coverage, 70513,
     /*   87532 */     GIR_EraseRootFromParent_Done,
     /*   87533 */   // Label 1405: @87533
     /*   87533 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(87622), // Rule ID 51570 //
     /*   87538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87553 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87572 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87581 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87620 */     GIR_RootConstrainSelectedInstOperands,
     /*   87621 */     // GIR_Coverage, 51570,
     /*   87621 */     GIR_EraseRootFromParent_Done,
     /*   87622 */   // Label 1406: @87622
     /*   87622 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(87711), // Rule ID 51571 //
     /*   87627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87642 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87661 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87670 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87709 */     GIR_RootConstrainSelectedInstOperands,
     /*   87710 */     // GIR_Coverage, 51571,
     /*   87710 */     GIR_EraseRootFromParent_Done,
     /*   87711 */   // Label 1407: @87711
     /*   87711 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(87764), // Rule ID 50876 //
     /*   87716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87727 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   87727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   87744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   87751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   87753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87762 */     GIR_RootConstrainSelectedInstOperands,
     /*   87763 */     // GIR_Coverage, 50876,
     /*   87763 */     GIR_EraseRootFromParent_Done,
     /*   87764 */   // Label 1408: @87764
     /*   87764 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(87817), // Rule ID 50877 //
     /*   87769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87780 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   87780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   87797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   87804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   87806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87815 */     GIR_RootConstrainSelectedInstOperands,
     /*   87816 */     // GIR_Coverage, 50877,
     /*   87816 */     GIR_EraseRootFromParent_Done,
     /*   87817 */   // Label 1409: @87817
     /*   87817 */   GIM_Reject,
     /*   87818 */ // Label 1389: @87818
     /*   87818 */ GIM_Reject,
     /*   87819 */ // Label 1298: @87819
     /*   87819 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(89543),
     /*   87824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   87827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   87830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87834 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(87923), // Rule ID 51654 //
     /*   87839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87873 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87882 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   87882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   87885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   87899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87921 */     GIR_RootConstrainSelectedInstOperands,
     /*   87922 */     // GIR_Coverage, 51654,
     /*   87922 */     GIR_EraseRootFromParent_Done,
     /*   87923 */   // Label 1411: @87923
     /*   87923 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(88012), // Rule ID 51655 //
     /*   87928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87943 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87962 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87971 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   87971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   87974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   87988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88010 */     GIR_RootConstrainSelectedInstOperands,
     /*   88011 */     // GIR_Coverage, 51655,
     /*   88011 */     GIR_EraseRootFromParent_Done,
     /*   88012 */   // Label 1412: @88012
     /*   88012 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(88101), // Rule ID 70596 //
     /*   88017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88032 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88051 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88060 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88099 */     GIR_RootConstrainSelectedInstOperands,
     /*   88100 */     // GIR_Coverage, 70596,
     /*   88100 */     GIR_EraseRootFromParent_Done,
     /*   88101 */   // Label 1413: @88101
     /*   88101 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(88190), // Rule ID 70597 //
     /*   88106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88140 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88149 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88188 */     GIR_RootConstrainSelectedInstOperands,
     /*   88189 */     // GIR_Coverage, 70597,
     /*   88189 */     GIR_EraseRootFromParent_Done,
     /*   88190 */   // Label 1414: @88190
     /*   88190 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(88279), // Rule ID 70476 //
     /*   88195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88229 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88238 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88277 */     GIR_RootConstrainSelectedInstOperands,
     /*   88278 */     // GIR_Coverage, 70476,
     /*   88278 */     GIR_EraseRootFromParent_Done,
     /*   88279 */   // Label 1415: @88279
     /*   88279 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(88368), // Rule ID 70477 //
     /*   88284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88299 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88318 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88327 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88366 */     GIR_RootConstrainSelectedInstOperands,
     /*   88367 */     // GIR_Coverage, 70477,
     /*   88367 */     GIR_EraseRootFromParent_Done,
     /*   88368 */   // Label 1416: @88368
     /*   88368 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(88457), // Rule ID 51834 //
     /*   88373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88407 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88416 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88455 */     GIR_RootConstrainSelectedInstOperands,
     /*   88456 */     // GIR_Coverage, 51834,
     /*   88456 */     GIR_EraseRootFromParent_Done,
     /*   88457 */   // Label 1417: @88457
     /*   88457 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(88546), // Rule ID 51835 //
     /*   88462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88477 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88496 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88505 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88544 */     GIR_RootConstrainSelectedInstOperands,
     /*   88545 */     // GIR_Coverage, 51835,
     /*   88545 */     GIR_EraseRootFromParent_Done,
     /*   88546 */   // Label 1418: @88546
     /*   88546 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(88635), // Rule ID 51534 //
     /*   88551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88566 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88585 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88594 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   88611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88633 */     GIR_RootConstrainSelectedInstOperands,
     /*   88634 */     // GIR_Coverage, 51534,
     /*   88634 */     GIR_EraseRootFromParent_Done,
     /*   88635 */   // Label 1419: @88635
     /*   88635 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(88724), // Rule ID 51535 //
     /*   88640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88655 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88674 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88683 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   88700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88722 */     GIR_RootConstrainSelectedInstOperands,
     /*   88723 */     // GIR_Coverage, 51535,
     /*   88723 */     GIR_EraseRootFromParent_Done,
     /*   88724 */   // Label 1420: @88724
     /*   88724 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(88813), // Rule ID 51774 //
     /*   88729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88744 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88763 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88772 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88811 */     GIR_RootConstrainSelectedInstOperands,
     /*   88812 */     // GIR_Coverage, 51774,
     /*   88812 */     GIR_EraseRootFromParent_Done,
     /*   88813 */   // Label 1421: @88813
     /*   88813 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(88902), // Rule ID 51775 //
     /*   88818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88833 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88852 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88861 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88900 */     GIR_RootConstrainSelectedInstOperands,
     /*   88901 */     // GIR_Coverage, 51775,
     /*   88901 */     GIR_EraseRootFromParent_Done,
     /*   88902 */   // Label 1422: @88902
     /*   88902 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(88991), // Rule ID 51714 //
     /*   88907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88922 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88941 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88950 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88989 */     GIR_RootConstrainSelectedInstOperands,
     /*   88990 */     // GIR_Coverage, 51714,
     /*   88990 */     GIR_EraseRootFromParent_Done,
     /*   88991 */   // Label 1423: @88991
     /*   88991 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(89080), // Rule ID 51715 //
     /*   88996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89030 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89039 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89078 */     GIR_RootConstrainSelectedInstOperands,
     /*   89079 */     // GIR_Coverage, 51715,
     /*   89079 */     GIR_EraseRootFromParent_Done,
     /*   89080 */   // Label 1424: @89080
     /*   89080 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(89169), // Rule ID 70536 //
     /*   89085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89100 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89119 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89128 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89167 */     GIR_RootConstrainSelectedInstOperands,
     /*   89168 */     // GIR_Coverage, 70536,
     /*   89168 */     GIR_EraseRootFromParent_Done,
     /*   89169 */   // Label 1425: @89169
     /*   89169 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(89258), // Rule ID 70537 //
     /*   89174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89189 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89208 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89217 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89256 */     GIR_RootConstrainSelectedInstOperands,
     /*   89257 */     // GIR_Coverage, 70537,
     /*   89257 */     GIR_EraseRootFromParent_Done,
     /*   89258 */   // Label 1426: @89258
     /*   89258 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(89347), // Rule ID 51594 //
     /*   89263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89278 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89297 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89299 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89306 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89345 */     GIR_RootConstrainSelectedInstOperands,
     /*   89346 */     // GIR_Coverage, 51594,
     /*   89346 */     GIR_EraseRootFromParent_Done,
     /*   89347 */   // Label 1427: @89347
     /*   89347 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(89436), // Rule ID 51595 //
     /*   89352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89367 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89386 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89395 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89434 */     GIR_RootConstrainSelectedInstOperands,
     /*   89435 */     // GIR_Coverage, 51595,
     /*   89435 */     GIR_EraseRootFromParent_Done,
     /*   89436 */   // Label 1428: @89436
     /*   89436 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(89489), // Rule ID 50892 //
     /*   89441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89452 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   89469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   89476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   89478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89487 */     GIR_RootConstrainSelectedInstOperands,
     /*   89488 */     // GIR_Coverage, 50892,
     /*   89488 */     GIR_EraseRootFromParent_Done,
     /*   89489 */   // Label 1429: @89489
     /*   89489 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(89542), // Rule ID 50893 //
     /*   89494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89505 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   89522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   89529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   89531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89540 */     GIR_RootConstrainSelectedInstOperands,
     /*   89541 */     // GIR_Coverage, 50893,
     /*   89541 */     GIR_EraseRootFromParent_Done,
     /*   89542 */   // Label 1430: @89542
     /*   89542 */   GIM_Reject,
     /*   89543 */ // Label 1410: @89543
     /*   89543 */ GIM_Reject,
     /*   89544 */ // Label 1299: @89544
     /*   89544 */ GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91268),
     /*   89549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   89552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   89555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   89559 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(89648), // Rule ID 51674 //
     /*   89564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   89567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89579 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89598 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89607 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89646 */     GIR_RootConstrainSelectedInstOperands,
     /*   89647 */     // GIR_Coverage, 51674,
     /*   89647 */     GIR_EraseRootFromParent_Done,
     /*   89648 */   // Label 1432: @89648
     /*   89648 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(89737), // Rule ID 51675 //
     /*   89653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   89656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89668 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89687 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89696 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89735 */     GIR_RootConstrainSelectedInstOperands,
     /*   89736 */     // GIR_Coverage, 51675,
     /*   89736 */     GIR_EraseRootFromParent_Done,
     /*   89737 */   // Label 1433: @89737
     /*   89737 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(89826), // Rule ID 70616 //
     /*   89742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   89745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89757 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89776 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89785 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   89802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89824 */     GIR_RootConstrainSelectedInstOperands,
     /*   89825 */     // GIR_Coverage, 70616,
     /*   89825 */     GIR_EraseRootFromParent_Done,
     /*   89826 */   // Label 1434: @89826
     /*   89826 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(89915), // Rule ID 70617 //
     /*   89831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   89834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89865 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89874 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   89891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89913 */     GIR_RootConstrainSelectedInstOperands,
     /*   89914 */     // GIR_Coverage, 70617,
     /*   89914 */     GIR_EraseRootFromParent_Done,
     /*   89915 */   // Label 1435: @89915
     /*   89915 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(90004), // Rule ID 70496 //
     /*   89920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   89923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89935 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89954 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89963 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90002 */     GIR_RootConstrainSelectedInstOperands,
     /*   90003 */     // GIR_Coverage, 70496,
     /*   90003 */     GIR_EraseRootFromParent_Done,
     /*   90004 */   // Label 1436: @90004
     /*   90004 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(90093), // Rule ID 70497 //
     /*   90009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90024 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90043 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90052 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90091 */     GIR_RootConstrainSelectedInstOperands,
     /*   90092 */     // GIR_Coverage, 70497,
     /*   90092 */     GIR_EraseRootFromParent_Done,
     /*   90093 */   // Label 1437: @90093
     /*   90093 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(90182), // Rule ID 51854 //
     /*   90098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90113 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90132 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90141 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90180 */     GIR_RootConstrainSelectedInstOperands,
     /*   90181 */     // GIR_Coverage, 51854,
     /*   90181 */     GIR_EraseRootFromParent_Done,
     /*   90182 */   // Label 1438: @90182
     /*   90182 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(90271), // Rule ID 51855 //
     /*   90187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90202 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90221 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90230 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90269 */     GIR_RootConstrainSelectedInstOperands,
     /*   90270 */     // GIR_Coverage, 51855,
     /*   90270 */     GIR_EraseRootFromParent_Done,
     /*   90271 */   // Label 1439: @90271
     /*   90271 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(90360), // Rule ID 51554 //
     /*   90276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90291 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90310 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90319 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   90336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90358 */     GIR_RootConstrainSelectedInstOperands,
     /*   90359 */     // GIR_Coverage, 51554,
     /*   90359 */     GIR_EraseRootFromParent_Done,
     /*   90360 */   // Label 1440: @90360
     /*   90360 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(90449), // Rule ID 51555 //
     /*   90365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90380 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90399 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90408 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   90425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90447 */     GIR_RootConstrainSelectedInstOperands,
     /*   90448 */     // GIR_Coverage, 51555,
     /*   90448 */     GIR_EraseRootFromParent_Done,
     /*   90449 */   // Label 1441: @90449
     /*   90449 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(90538), // Rule ID 51794 //
     /*   90454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90488 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90497 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90536 */     GIR_RootConstrainSelectedInstOperands,
     /*   90537 */     // GIR_Coverage, 51794,
     /*   90537 */     GIR_EraseRootFromParent_Done,
     /*   90538 */   // Label 1442: @90538
     /*   90538 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(90627), // Rule ID 51795 //
     /*   90543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90577 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90586 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90625 */     GIR_RootConstrainSelectedInstOperands,
     /*   90626 */     // GIR_Coverage, 51795,
     /*   90626 */     GIR_EraseRootFromParent_Done,
     /*   90627 */   // Label 1443: @90627
     /*   90627 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(90716), // Rule ID 51734 //
     /*   90632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90666 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90675 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90714 */     GIR_RootConstrainSelectedInstOperands,
     /*   90715 */     // GIR_Coverage, 51734,
     /*   90715 */     GIR_EraseRootFromParent_Done,
     /*   90716 */   // Label 1444: @90716
     /*   90716 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(90805), // Rule ID 51735 //
     /*   90721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90755 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90764 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90803 */     GIR_RootConstrainSelectedInstOperands,
     /*   90804 */     // GIR_Coverage, 51735,
     /*   90804 */     GIR_EraseRootFromParent_Done,
     /*   90805 */   // Label 1445: @90805
     /*   90805 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(90894), // Rule ID 70556 //
     /*   90810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90825 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90844 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90853 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90892 */     GIR_RootConstrainSelectedInstOperands,
     /*   90893 */     // GIR_Coverage, 70556,
     /*   90893 */     GIR_EraseRootFromParent_Done,
     /*   90894 */   // Label 1446: @90894
     /*   90894 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(90983), // Rule ID 70557 //
     /*   90899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90914 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90933 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90942 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90981 */     GIR_RootConstrainSelectedInstOperands,
     /*   90982 */     // GIR_Coverage, 70557,
     /*   90982 */     GIR_EraseRootFromParent_Done,
     /*   90983 */   // Label 1447: @90983
     /*   90983 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(91072), // Rule ID 51614 //
     /*   90988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91003 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91022 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91031 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91070 */     GIR_RootConstrainSelectedInstOperands,
     /*   91071 */     // GIR_Coverage, 51614,
     /*   91071 */     GIR_EraseRootFromParent_Done,
     /*   91072 */   // Label 1448: @91072
     /*   91072 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(91161), // Rule ID 51615 //
     /*   91077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91092 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91111 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91120 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91159 */     GIR_RootConstrainSelectedInstOperands,
     /*   91160 */     // GIR_Coverage, 51615,
     /*   91160 */     GIR_EraseRootFromParent_Done,
     /*   91161 */   // Label 1449: @91161
     /*   91161 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(91214), // Rule ID 50936 //
     /*   91166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   91169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91177 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   91177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   91194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   91209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91212 */     GIR_RootConstrainSelectedInstOperands,
     /*   91213 */     // GIR_Coverage, 50936,
     /*   91213 */     GIR_EraseRootFromParent_Done,
     /*   91214 */   // Label 1450: @91214
     /*   91214 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(91267), // Rule ID 50937 //
     /*   91219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   91222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91230 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   91230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   91247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   91262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91265 */     GIR_RootConstrainSelectedInstOperands,
     /*   91266 */     // GIR_Coverage, 50937,
     /*   91266 */     GIR_EraseRootFromParent_Done,
     /*   91267 */   // Label 1451: @91267
     /*   91267 */   GIM_Reject,
     /*   91268 */ // Label 1431: @91268
     /*   91268 */ GIM_Reject,
     /*   91269 */ // Label 1300: @91269
     /*   91269 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(91383),
     /*   91274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   91280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91292 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(91337), // Rule ID 50868 //
     /*   91297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91300 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   91303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   91317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91335 */     GIR_RootConstrainSelectedInstOperands,
     /*   91336 */     // GIR_Coverage, 50868,
     /*   91336 */     GIR_EraseRootFromParent_Done,
     /*   91337 */   // Label 1453: @91337
     /*   91337 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(91382), // Rule ID 50869 //
     /*   91342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91345 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   91348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   91362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91380 */     GIR_RootConstrainSelectedInstOperands,
     /*   91381 */     // GIR_Coverage, 50869,
     /*   91381 */     GIR_EraseRootFromParent_Done,
     /*   91382 */   // Label 1454: @91382
     /*   91382 */   GIM_Reject,
     /*   91383 */ // Label 1452: @91383
     /*   91383 */ GIM_Reject,
     /*   91384 */ // Label 1301: @91384
     /*   91384 */ GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(93108),
     /*   91389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   91392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   91395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91399 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(91488), // Rule ID 51634 //
     /*   91404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91419 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91438 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91447 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91486 */     GIR_RootConstrainSelectedInstOperands,
     /*   91487 */     // GIR_Coverage, 51634,
     /*   91487 */     GIR_EraseRootFromParent_Done,
     /*   91488 */   // Label 1456: @91488
     /*   91488 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(91577), // Rule ID 51635 //
     /*   91493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91508 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91527 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91536 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91575 */     GIR_RootConstrainSelectedInstOperands,
     /*   91576 */     // GIR_Coverage, 51635,
     /*   91576 */     GIR_EraseRootFromParent_Done,
     /*   91577 */   // Label 1457: @91577
     /*   91577 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(91666), // Rule ID 70576 //
     /*   91582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91597 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91616 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91625 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   91642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91664 */     GIR_RootConstrainSelectedInstOperands,
     /*   91665 */     // GIR_Coverage, 70576,
     /*   91665 */     GIR_EraseRootFromParent_Done,
     /*   91666 */   // Label 1458: @91666
     /*   91666 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(91755), // Rule ID 70577 //
     /*   91671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91686 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91705 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91714 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   91731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91753 */     GIR_RootConstrainSelectedInstOperands,
     /*   91754 */     // GIR_Coverage, 70577,
     /*   91754 */     GIR_EraseRootFromParent_Done,
     /*   91755 */   // Label 1459: @91755
     /*   91755 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(91844), // Rule ID 70456 //
     /*   91760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91775 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91794 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91801 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91803 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91842 */     GIR_RootConstrainSelectedInstOperands,
     /*   91843 */     // GIR_Coverage, 70456,
     /*   91843 */     GIR_EraseRootFromParent_Done,
     /*   91844 */   // Label 1460: @91844
     /*   91844 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(91933), // Rule ID 70457 //
     /*   91849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91864 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91883 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91885 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91892 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91931 */     GIR_RootConstrainSelectedInstOperands,
     /*   91932 */     // GIR_Coverage, 70457,
     /*   91932 */     GIR_EraseRootFromParent_Done,
     /*   91933 */   // Label 1461: @91933
     /*   91933 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(92022), // Rule ID 51814 //
     /*   91938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91953 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91972 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91981 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   91998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92020 */     GIR_RootConstrainSelectedInstOperands,
     /*   92021 */     // GIR_Coverage, 51814,
     /*   92021 */     GIR_EraseRootFromParent_Done,
     /*   92022 */   // Label 1462: @92022
     /*   92022 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(92111), // Rule ID 51815 //
     /*   92027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92042 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92061 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92070 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92109 */     GIR_RootConstrainSelectedInstOperands,
     /*   92110 */     // GIR_Coverage, 51815,
     /*   92110 */     GIR_EraseRootFromParent_Done,
     /*   92111 */   // Label 1463: @92111
     /*   92111 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(92200), // Rule ID 51514 //
     /*   92116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92131 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92150 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92159 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   92176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92198 */     GIR_RootConstrainSelectedInstOperands,
     /*   92199 */     // GIR_Coverage, 51514,
     /*   92199 */     GIR_EraseRootFromParent_Done,
     /*   92200 */   // Label 1464: @92200
     /*   92200 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(92289), // Rule ID 51515 //
     /*   92205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92220 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92239 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92248 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   92265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92287 */     GIR_RootConstrainSelectedInstOperands,
     /*   92288 */     // GIR_Coverage, 51515,
     /*   92288 */     GIR_EraseRootFromParent_Done,
     /*   92289 */   // Label 1465: @92289
     /*   92289 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(92378), // Rule ID 51754 //
     /*   92294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92309 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92328 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92337 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92376 */     GIR_RootConstrainSelectedInstOperands,
     /*   92377 */     // GIR_Coverage, 51754,
     /*   92377 */     GIR_EraseRootFromParent_Done,
     /*   92378 */   // Label 1466: @92378
     /*   92378 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(92467), // Rule ID 51755 //
     /*   92383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92398 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92417 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92426 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92465 */     GIR_RootConstrainSelectedInstOperands,
     /*   92466 */     // GIR_Coverage, 51755,
     /*   92466 */     GIR_EraseRootFromParent_Done,
     /*   92467 */   // Label 1467: @92467
     /*   92467 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(92556), // Rule ID 51694 //
     /*   92472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92487 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92506 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92515 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92554 */     GIR_RootConstrainSelectedInstOperands,
     /*   92555 */     // GIR_Coverage, 51694,
     /*   92555 */     GIR_EraseRootFromParent_Done,
     /*   92556 */   // Label 1468: @92556
     /*   92556 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(92645), // Rule ID 51695 //
     /*   92561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92576 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92595 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92604 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92643 */     GIR_RootConstrainSelectedInstOperands,
     /*   92644 */     // GIR_Coverage, 51695,
     /*   92644 */     GIR_EraseRootFromParent_Done,
     /*   92645 */   // Label 1469: @92645
     /*   92645 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(92734), // Rule ID 70516 //
     /*   92650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92665 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92684 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92693 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92732 */     GIR_RootConstrainSelectedInstOperands,
     /*   92733 */     // GIR_Coverage, 70516,
     /*   92733 */     GIR_EraseRootFromParent_Done,
     /*   92734 */   // Label 1470: @92734
     /*   92734 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(92823), // Rule ID 70517 //
     /*   92739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92754 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92773 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92782 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92821 */     GIR_RootConstrainSelectedInstOperands,
     /*   92822 */     // GIR_Coverage, 70517,
     /*   92822 */     GIR_EraseRootFromParent_Done,
     /*   92823 */   // Label 1471: @92823
     /*   92823 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(92912), // Rule ID 51574 //
     /*   92828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92843 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92862 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92869 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92871 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92910 */     GIR_RootConstrainSelectedInstOperands,
     /*   92911 */     // GIR_Coverage, 51574,
     /*   92911 */     GIR_EraseRootFromParent_Done,
     /*   92912 */   // Label 1472: @92912
     /*   92912 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(93001), // Rule ID 51575 //
     /*   92917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92932 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92951 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92960 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92999 */     GIR_RootConstrainSelectedInstOperands,
     /*   93000 */     // GIR_Coverage, 51575,
     /*   93000 */     GIR_EraseRootFromParent_Done,
     /*   93001 */   // Label 1473: @93001
     /*   93001 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(93054), // Rule ID 50888 //
     /*   93006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93017 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   93034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   93041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   93043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93052 */     GIR_RootConstrainSelectedInstOperands,
     /*   93053 */     // GIR_Coverage, 50888,
     /*   93053 */     GIR_EraseRootFromParent_Done,
     /*   93054 */   // Label 1474: @93054
     /*   93054 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(93107), // Rule ID 50889 //
     /*   93059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93070 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   93087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   93094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   93096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93105 */     GIR_RootConstrainSelectedInstOperands,
     /*   93106 */     // GIR_Coverage, 50889,
     /*   93106 */     GIR_EraseRootFromParent_Done,
     /*   93107 */   // Label 1475: @93107
     /*   93107 */   GIM_Reject,
     /*   93108 */ // Label 1455: @93108
     /*   93108 */ GIM_Reject,
     /*   93109 */ // Label 1302: @93109
     /*   93109 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(94833),
     /*   93114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   93117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   93120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   93124 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(93213), // Rule ID 51658 //
     /*   93129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93144 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93163 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93172 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93211 */     GIR_RootConstrainSelectedInstOperands,
     /*   93212 */     // GIR_Coverage, 51658,
     /*   93212 */     GIR_EraseRootFromParent_Done,
     /*   93213 */   // Label 1477: @93213
     /*   93213 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(93302), // Rule ID 51659 //
     /*   93218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93233 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93252 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93261 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93300 */     GIR_RootConstrainSelectedInstOperands,
     /*   93301 */     // GIR_Coverage, 51659,
     /*   93301 */     GIR_EraseRootFromParent_Done,
     /*   93302 */   // Label 1478: @93302
     /*   93302 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(93391), // Rule ID 70600 //
     /*   93307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93322 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93341 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93350 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93389 */     GIR_RootConstrainSelectedInstOperands,
     /*   93390 */     // GIR_Coverage, 70600,
     /*   93390 */     GIR_EraseRootFromParent_Done,
     /*   93391 */   // Label 1479: @93391
     /*   93391 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(93480), // Rule ID 70601 //
     /*   93396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93430 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93439 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93478 */     GIR_RootConstrainSelectedInstOperands,
     /*   93479 */     // GIR_Coverage, 70601,
     /*   93479 */     GIR_EraseRootFromParent_Done,
     /*   93480 */   // Label 1480: @93480
     /*   93480 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(93569), // Rule ID 70480 //
     /*   93485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93519 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93528 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93567 */     GIR_RootConstrainSelectedInstOperands,
     /*   93568 */     // GIR_Coverage, 70480,
     /*   93568 */     GIR_EraseRootFromParent_Done,
     /*   93569 */   // Label 1481: @93569
     /*   93569 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(93658), // Rule ID 70481 //
     /*   93574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93589 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93608 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93617 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93656 */     GIR_RootConstrainSelectedInstOperands,
     /*   93657 */     // GIR_Coverage, 70481,
     /*   93657 */     GIR_EraseRootFromParent_Done,
     /*   93658 */   // Label 1482: @93658
     /*   93658 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(93747), // Rule ID 51838 //
     /*   93663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93678 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93697 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93706 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93745 */     GIR_RootConstrainSelectedInstOperands,
     /*   93746 */     // GIR_Coverage, 51838,
     /*   93746 */     GIR_EraseRootFromParent_Done,
     /*   93747 */   // Label 1483: @93747
     /*   93747 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(93836), // Rule ID 51839 //
     /*   93752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93767 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93786 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93795 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93834 */     GIR_RootConstrainSelectedInstOperands,
     /*   93835 */     // GIR_Coverage, 51839,
     /*   93835 */     GIR_EraseRootFromParent_Done,
     /*   93836 */   // Label 1484: @93836
     /*   93836 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(93925), // Rule ID 51538 //
     /*   93841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93856 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93875 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93884 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   93901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93923 */     GIR_RootConstrainSelectedInstOperands,
     /*   93924 */     // GIR_Coverage, 51538,
     /*   93924 */     GIR_EraseRootFromParent_Done,
     /*   93925 */   // Label 1485: @93925
     /*   93925 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(94014), // Rule ID 51539 //
     /*   93930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93945 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93964 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93973 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   93990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94012 */     GIR_RootConstrainSelectedInstOperands,
     /*   94013 */     // GIR_Coverage, 51539,
     /*   94013 */     GIR_EraseRootFromParent_Done,
     /*   94014 */   // Label 1486: @94014
     /*   94014 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(94103), // Rule ID 51778 //
     /*   94019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94034 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94053 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94062 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94101 */     GIR_RootConstrainSelectedInstOperands,
     /*   94102 */     // GIR_Coverage, 51778,
     /*   94102 */     GIR_EraseRootFromParent_Done,
     /*   94103 */   // Label 1487: @94103
     /*   94103 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(94192), // Rule ID 51779 //
     /*   94108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94123 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94142 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94151 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94190 */     GIR_RootConstrainSelectedInstOperands,
     /*   94191 */     // GIR_Coverage, 51779,
     /*   94191 */     GIR_EraseRootFromParent_Done,
     /*   94192 */   // Label 1488: @94192
     /*   94192 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(94281), // Rule ID 51718 //
     /*   94197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94212 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94231 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94233 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94240 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94279 */     GIR_RootConstrainSelectedInstOperands,
     /*   94280 */     // GIR_Coverage, 51718,
     /*   94280 */     GIR_EraseRootFromParent_Done,
     /*   94281 */   // Label 1489: @94281
     /*   94281 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(94370), // Rule ID 51719 //
     /*   94286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94320 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94329 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94368 */     GIR_RootConstrainSelectedInstOperands,
     /*   94369 */     // GIR_Coverage, 51719,
     /*   94369 */     GIR_EraseRootFromParent_Done,
     /*   94370 */   // Label 1490: @94370
     /*   94370 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(94459), // Rule ID 70540 //
     /*   94375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94390 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94409 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94418 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94457 */     GIR_RootConstrainSelectedInstOperands,
     /*   94458 */     // GIR_Coverage, 70540,
     /*   94458 */     GIR_EraseRootFromParent_Done,
     /*   94459 */   // Label 1491: @94459
     /*   94459 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(94548), // Rule ID 70541 //
     /*   94464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94479 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94498 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94507 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94546 */     GIR_RootConstrainSelectedInstOperands,
     /*   94547 */     // GIR_Coverage, 70541,
     /*   94547 */     GIR_EraseRootFromParent_Done,
     /*   94548 */   // Label 1492: @94548
     /*   94548 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(94637), // Rule ID 51598 //
     /*   94553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94568 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94587 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94596 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94635 */     GIR_RootConstrainSelectedInstOperands,
     /*   94636 */     // GIR_Coverage, 51598,
     /*   94636 */     GIR_EraseRootFromParent_Done,
     /*   94637 */   // Label 1493: @94637
     /*   94637 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(94726), // Rule ID 51599 //
     /*   94642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94657 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94676 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94685 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94724 */     GIR_RootConstrainSelectedInstOperands,
     /*   94725 */     // GIR_Coverage, 51599,
     /*   94725 */     GIR_EraseRootFromParent_Done,
     /*   94726 */   // Label 1494: @94726
     /*   94726 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(94779), // Rule ID 50924 //
     /*   94731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94742 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   94742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   94759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   94766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   94768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   94774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94777 */     GIR_RootConstrainSelectedInstOperands,
     /*   94778 */     // GIR_Coverage, 50924,
     /*   94778 */     GIR_EraseRootFromParent_Done,
     /*   94779 */   // Label 1495: @94779
     /*   94779 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(94832), // Rule ID 50925 //
     /*   94784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94795 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   94795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   94812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   94819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   94821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   94827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94830 */     GIR_RootConstrainSelectedInstOperands,
     /*   94831 */     // GIR_Coverage, 50925,
     /*   94831 */     GIR_EraseRootFromParent_Done,
     /*   94832 */   // Label 1496: @94832
     /*   94832 */   GIM_Reject,
     /*   94833 */ // Label 1476: @94833
     /*   94833 */ GIM_Reject,
     /*   94834 */ // Label 1303: @94834
     /*   94834 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(96558),
     /*   94839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   94842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   94845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   94849 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(94938), // Rule ID 51678 //
     /*   94854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   94857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94869 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94888 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94897 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   94897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   94900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   94914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   94933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94936 */     GIR_RootConstrainSelectedInstOperands,
     /*   94937 */     // GIR_Coverage, 51678,
     /*   94937 */     GIR_EraseRootFromParent_Done,
     /*   94938 */   // Label 1498: @94938
     /*   94938 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(95027), // Rule ID 51679 //
     /*   94943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   94946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94958 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94977 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94986 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   94986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   94989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95025 */     GIR_RootConstrainSelectedInstOperands,
     /*   95026 */     // GIR_Coverage, 51679,
     /*   95026 */     GIR_EraseRootFromParent_Done,
     /*   95027 */   // Label 1499: @95027
     /*   95027 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(95116), // Rule ID 70620 //
     /*   95032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95047 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95066 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95075 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95114 */     GIR_RootConstrainSelectedInstOperands,
     /*   95115 */     // GIR_Coverage, 70620,
     /*   95115 */     GIR_EraseRootFromParent_Done,
     /*   95116 */   // Label 1500: @95116
     /*   95116 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(95205), // Rule ID 70621 //
     /*   95121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95155 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95164 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95203 */     GIR_RootConstrainSelectedInstOperands,
     /*   95204 */     // GIR_Coverage, 70621,
     /*   95204 */     GIR_EraseRootFromParent_Done,
     /*   95205 */   // Label 1501: @95205
     /*   95205 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(95294), // Rule ID 70500 //
     /*   95210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95225 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95244 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95253 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95292 */     GIR_RootConstrainSelectedInstOperands,
     /*   95293 */     // GIR_Coverage, 70500,
     /*   95293 */     GIR_EraseRootFromParent_Done,
     /*   95294 */   // Label 1502: @95294
     /*   95294 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(95383), // Rule ID 70501 //
     /*   95299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95314 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95333 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95342 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95381 */     GIR_RootConstrainSelectedInstOperands,
     /*   95382 */     // GIR_Coverage, 70501,
     /*   95382 */     GIR_EraseRootFromParent_Done,
     /*   95383 */   // Label 1503: @95383
     /*   95383 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(95472), // Rule ID 51858 //
     /*   95388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95403 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95422 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95431 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95470 */     GIR_RootConstrainSelectedInstOperands,
     /*   95471 */     // GIR_Coverage, 51858,
     /*   95471 */     GIR_EraseRootFromParent_Done,
     /*   95472 */   // Label 1504: @95472
     /*   95472 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(95561), // Rule ID 51859 //
     /*   95477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95511 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95520 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95559 */     GIR_RootConstrainSelectedInstOperands,
     /*   95560 */     // GIR_Coverage, 51859,
     /*   95560 */     GIR_EraseRootFromParent_Done,
     /*   95561 */   // Label 1505: @95561
     /*   95561 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(95650), // Rule ID 51558 //
     /*   95566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95581 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95600 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95609 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   95626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95648 */     GIR_RootConstrainSelectedInstOperands,
     /*   95649 */     // GIR_Coverage, 51558,
     /*   95649 */     GIR_EraseRootFromParent_Done,
     /*   95650 */   // Label 1506: @95650
     /*   95650 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(95739), // Rule ID 51559 //
     /*   95655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95670 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95689 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95698 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   95715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95737 */     GIR_RootConstrainSelectedInstOperands,
     /*   95738 */     // GIR_Coverage, 51559,
     /*   95738 */     GIR_EraseRootFromParent_Done,
     /*   95739 */   // Label 1507: @95739
     /*   95739 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(95828), // Rule ID 51798 //
     /*   95744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95759 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95778 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95787 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95826 */     GIR_RootConstrainSelectedInstOperands,
     /*   95827 */     // GIR_Coverage, 51798,
     /*   95827 */     GIR_EraseRootFromParent_Done,
     /*   95828 */   // Label 1508: @95828
     /*   95828 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(95917), // Rule ID 51799 //
     /*   95833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95848 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95867 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95869 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95876 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95915 */     GIR_RootConstrainSelectedInstOperands,
     /*   95916 */     // GIR_Coverage, 51799,
     /*   95916 */     GIR_EraseRootFromParent_Done,
     /*   95917 */   // Label 1509: @95917
     /*   95917 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(96006), // Rule ID 51738 //
     /*   95922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95937 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95956 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95958 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95965 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96004 */     GIR_RootConstrainSelectedInstOperands,
     /*   96005 */     // GIR_Coverage, 51738,
     /*   96005 */     GIR_EraseRootFromParent_Done,
     /*   96006 */   // Label 1510: @96006
     /*   96006 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(96095), // Rule ID 51739 //
     /*   96011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96045 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96054 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96093 */     GIR_RootConstrainSelectedInstOperands,
     /*   96094 */     // GIR_Coverage, 51739,
     /*   96094 */     GIR_EraseRootFromParent_Done,
     /*   96095 */   // Label 1511: @96095
     /*   96095 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(96184), // Rule ID 70560 //
     /*   96100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96115 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96134 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96143 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96182 */     GIR_RootConstrainSelectedInstOperands,
     /*   96183 */     // GIR_Coverage, 70560,
     /*   96183 */     GIR_EraseRootFromParent_Done,
     /*   96184 */   // Label 1512: @96184
     /*   96184 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(96273), // Rule ID 70561 //
     /*   96189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96204 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96223 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96232 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96271 */     GIR_RootConstrainSelectedInstOperands,
     /*   96272 */     // GIR_Coverage, 70561,
     /*   96272 */     GIR_EraseRootFromParent_Done,
     /*   96273 */   // Label 1513: @96273
     /*   96273 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(96362), // Rule ID 51618 //
     /*   96278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96293 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96312 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96321 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96360 */     GIR_RootConstrainSelectedInstOperands,
     /*   96361 */     // GIR_Coverage, 51618,
     /*   96361 */     GIR_EraseRootFromParent_Done,
     /*   96362 */   // Label 1514: @96362
     /*   96362 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(96451), // Rule ID 51619 //
     /*   96367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96382 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96401 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96410 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96449 */     GIR_RootConstrainSelectedInstOperands,
     /*   96450 */     // GIR_Coverage, 51619,
     /*   96450 */     GIR_EraseRootFromParent_Done,
     /*   96451 */   // Label 1515: @96451
     /*   96451 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(96504), // Rule ID 50940 //
     /*   96456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   96459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96467 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   96467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   96484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   96499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96502 */     GIR_RootConstrainSelectedInstOperands,
     /*   96503 */     // GIR_Coverage, 50940,
     /*   96503 */     GIR_EraseRootFromParent_Done,
     /*   96504 */   // Label 1516: @96504
     /*   96504 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(96557), // Rule ID 50941 //
     /*   96509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   96512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96520 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   96520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   96537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   96552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96555 */     GIR_RootConstrainSelectedInstOperands,
     /*   96556 */     // GIR_Coverage, 50941,
     /*   96556 */     GIR_EraseRootFromParent_Done,
     /*   96557 */   // Label 1517: @96557
     /*   96557 */   GIM_Reject,
     /*   96558 */ // Label 1497: @96558
     /*   96558 */ GIM_Reject,
     /*   96559 */ // Label 1304: @96559
     /*   96559 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(96673),
     /*   96564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   96570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96582 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(96627), // Rule ID 50884 //
     /*   96587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   96590 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   96590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   96593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   96607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96625 */     GIR_RootConstrainSelectedInstOperands,
     /*   96626 */     // GIR_Coverage, 50884,
     /*   96626 */     GIR_EraseRootFromParent_Done,
     /*   96627 */   // Label 1519: @96627
     /*   96627 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(96672), // Rule ID 50885 //
     /*   96632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   96635 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   96635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   96638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   96652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96670 */     GIR_RootConstrainSelectedInstOperands,
     /*   96671 */     // GIR_Coverage, 50885,
     /*   96671 */     GIR_EraseRootFromParent_Done,
     /*   96672 */   // Label 1520: @96672
     /*   96672 */   GIM_Reject,
     /*   96673 */ // Label 1518: @96673
     /*   96673 */ GIM_Reject,
     /*   96674 */ // Label 1305: @96674
     /*   96674 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(98398),
     /*   96679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   96682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   96685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96689 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(96778), // Rule ID 51638 //
     /*   96694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   96697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96737 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   96737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   96754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96776 */     GIR_RootConstrainSelectedInstOperands,
     /*   96777 */     // GIR_Coverage, 51638,
     /*   96777 */     GIR_EraseRootFromParent_Done,
     /*   96778 */   // Label 1522: @96778
     /*   96778 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(96867), // Rule ID 51639 //
     /*   96783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   96786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96817 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96826 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   96826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   96843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96865 */     GIR_RootConstrainSelectedInstOperands,
     /*   96866 */     // GIR_Coverage, 51639,
     /*   96866 */     GIR_EraseRootFromParent_Done,
     /*   96867 */   // Label 1523: @96867
     /*   96867 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(96956), // Rule ID 70580 //
     /*   96872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   96875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96915 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   96915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   96932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96954 */     GIR_RootConstrainSelectedInstOperands,
     /*   96955 */     // GIR_Coverage, 70580,
     /*   96955 */     GIR_EraseRootFromParent_Done,
     /*   96956 */   // Label 1524: @96956
     /*   96956 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(97045), // Rule ID 70581 //
     /*   96961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   96964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96995 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97004 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97043 */     GIR_RootConstrainSelectedInstOperands,
     /*   97044 */     // GIR_Coverage, 70581,
     /*   97044 */     GIR_EraseRootFromParent_Done,
     /*   97045 */   // Label 1525: @97045
     /*   97045 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(97134), // Rule ID 70460 //
     /*   97050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97084 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97093 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97132 */     GIR_RootConstrainSelectedInstOperands,
     /*   97133 */     // GIR_Coverage, 70460,
     /*   97133 */     GIR_EraseRootFromParent_Done,
     /*   97134 */   // Label 1526: @97134
     /*   97134 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(97223), // Rule ID 70461 //
     /*   97139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97154 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97173 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97182 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97221 */     GIR_RootConstrainSelectedInstOperands,
     /*   97222 */     // GIR_Coverage, 70461,
     /*   97222 */     GIR_EraseRootFromParent_Done,
     /*   97223 */   // Label 1527: @97223
     /*   97223 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(97312), // Rule ID 51818 //
     /*   97228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97243 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97262 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97271 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97310 */     GIR_RootConstrainSelectedInstOperands,
     /*   97311 */     // GIR_Coverage, 51818,
     /*   97311 */     GIR_EraseRootFromParent_Done,
     /*   97312 */   // Label 1528: @97312
     /*   97312 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(97401), // Rule ID 51819 //
     /*   97317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97332 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97351 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97360 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97399 */     GIR_RootConstrainSelectedInstOperands,
     /*   97400 */     // GIR_Coverage, 51819,
     /*   97400 */     GIR_EraseRootFromParent_Done,
     /*   97401 */   // Label 1529: @97401
     /*   97401 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(97490), // Rule ID 51518 //
     /*   97406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97449 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   97466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97488 */     GIR_RootConstrainSelectedInstOperands,
     /*   97489 */     // GIR_Coverage, 51518,
     /*   97489 */     GIR_EraseRootFromParent_Done,
     /*   97490 */   // Label 1530: @97490
     /*   97490 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(97579), // Rule ID 51519 //
     /*   97495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97510 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97529 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97538 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   97555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97577 */     GIR_RootConstrainSelectedInstOperands,
     /*   97578 */     // GIR_Coverage, 51519,
     /*   97578 */     GIR_EraseRootFromParent_Done,
     /*   97579 */   // Label 1531: @97579
     /*   97579 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(97668), // Rule ID 51758 //
     /*   97584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97599 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97618 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97627 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97666 */     GIR_RootConstrainSelectedInstOperands,
     /*   97667 */     // GIR_Coverage, 51758,
     /*   97667 */     GIR_EraseRootFromParent_Done,
     /*   97668 */   // Label 1532: @97668
     /*   97668 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(97757), // Rule ID 51759 //
     /*   97673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97688 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97707 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97716 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97755 */     GIR_RootConstrainSelectedInstOperands,
     /*   97756 */     // GIR_Coverage, 51759,
     /*   97756 */     GIR_EraseRootFromParent_Done,
     /*   97757 */   // Label 1533: @97757
     /*   97757 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(97846), // Rule ID 51698 //
     /*   97762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97777 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97796 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97805 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97844 */     GIR_RootConstrainSelectedInstOperands,
     /*   97845 */     // GIR_Coverage, 51698,
     /*   97845 */     GIR_EraseRootFromParent_Done,
     /*   97846 */   // Label 1534: @97846
     /*   97846 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(97935), // Rule ID 51699 //
     /*   97851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97866 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97885 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97894 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97933 */     GIR_RootConstrainSelectedInstOperands,
     /*   97934 */     // GIR_Coverage, 51699,
     /*   97934 */     GIR_EraseRootFromParent_Done,
     /*   97935 */   // Label 1535: @97935
     /*   97935 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(98024), // Rule ID 70520 //
     /*   97940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97955 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97974 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97983 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   98000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98022 */     GIR_RootConstrainSelectedInstOperands,
     /*   98023 */     // GIR_Coverage, 70520,
     /*   98023 */     GIR_EraseRootFromParent_Done,
     /*   98024 */   // Label 1536: @98024
     /*   98024 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(98113), // Rule ID 70521 //
     /*   98029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98044 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98063 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98072 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   98089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98111 */     GIR_RootConstrainSelectedInstOperands,
     /*   98112 */     // GIR_Coverage, 70521,
     /*   98112 */     GIR_EraseRootFromParent_Done,
     /*   98113 */   // Label 1537: @98113
     /*   98113 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(98202), // Rule ID 51578 //
     /*   98118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98133 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98152 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98161 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98200 */     GIR_RootConstrainSelectedInstOperands,
     /*   98201 */     // GIR_Coverage, 51578,
     /*   98201 */     GIR_EraseRootFromParent_Done,
     /*   98202 */   // Label 1538: @98202
     /*   98202 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(98291), // Rule ID 51579 //
     /*   98207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98222 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98241 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98250 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98289 */     GIR_RootConstrainSelectedInstOperands,
     /*   98290 */     // GIR_Coverage, 51579,
     /*   98290 */     GIR_EraseRootFromParent_Done,
     /*   98291 */   // Label 1539: @98291
     /*   98291 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(98344), // Rule ID 50912 //
     /*   98296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98307 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   98324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   98331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   98333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98342 */     GIR_RootConstrainSelectedInstOperands,
     /*   98343 */     // GIR_Coverage, 50912,
     /*   98343 */     GIR_EraseRootFromParent_Done,
     /*   98344 */   // Label 1540: @98344
     /*   98344 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(98397), // Rule ID 50913 //
     /*   98349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98360 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   98377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   98384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   98386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98395 */     GIR_RootConstrainSelectedInstOperands,
     /*   98396 */     // GIR_Coverage, 50913,
     /*   98396 */     GIR_EraseRootFromParent_Done,
     /*   98397 */   // Label 1541: @98397
     /*   98397 */   GIM_Reject,
     /*   98398 */ // Label 1521: @98398
     /*   98398 */ GIM_Reject,
     /*   98399 */ // Label 1306: @98399
     /*   98399 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(100123),
     /*   98404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   98407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   98410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   98414 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(98503), // Rule ID 51662 //
     /*   98419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98434 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98453 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98462 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98501 */     GIR_RootConstrainSelectedInstOperands,
     /*   98502 */     // GIR_Coverage, 51662,
     /*   98502 */     GIR_EraseRootFromParent_Done,
     /*   98503 */   // Label 1543: @98503
     /*   98503 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(98592), // Rule ID 51663 //
     /*   98508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98523 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98542 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98551 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98590 */     GIR_RootConstrainSelectedInstOperands,
     /*   98591 */     // GIR_Coverage, 51663,
     /*   98591 */     GIR_EraseRootFromParent_Done,
     /*   98592 */   // Label 1544: @98592
     /*   98592 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(98681), // Rule ID 70604 //
     /*   98597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98612 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98631 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98640 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98679 */     GIR_RootConstrainSelectedInstOperands,
     /*   98680 */     // GIR_Coverage, 70604,
     /*   98680 */     GIR_EraseRootFromParent_Done,
     /*   98681 */   // Label 1545: @98681
     /*   98681 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(98770), // Rule ID 70605 //
     /*   98686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98701 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98720 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98729 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98768 */     GIR_RootConstrainSelectedInstOperands,
     /*   98769 */     // GIR_Coverage, 70605,
     /*   98769 */     GIR_EraseRootFromParent_Done,
     /*   98770 */   // Label 1546: @98770
     /*   98770 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(98859), // Rule ID 70484 //
     /*   98775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98790 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98809 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98811 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98818 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98857 */     GIR_RootConstrainSelectedInstOperands,
     /*   98858 */     // GIR_Coverage, 70484,
     /*   98858 */     GIR_EraseRootFromParent_Done,
     /*   98859 */   // Label 1547: @98859
     /*   98859 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(98948), // Rule ID 70485 //
     /*   98864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98879 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98898 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98907 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98946 */     GIR_RootConstrainSelectedInstOperands,
     /*   98947 */     // GIR_Coverage, 70485,
     /*   98947 */     GIR_EraseRootFromParent_Done,
     /*   98948 */   // Label 1548: @98948
     /*   98948 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(99037), // Rule ID 51842 //
     /*   98953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98996 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99035 */     GIR_RootConstrainSelectedInstOperands,
     /*   99036 */     // GIR_Coverage, 51842,
     /*   99036 */     GIR_EraseRootFromParent_Done,
     /*   99037 */   // Label 1549: @99037
     /*   99037 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(99126), // Rule ID 51843 //
     /*   99042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99057 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99076 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99085 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99124 */     GIR_RootConstrainSelectedInstOperands,
     /*   99125 */     // GIR_Coverage, 51843,
     /*   99125 */     GIR_EraseRootFromParent_Done,
     /*   99126 */   // Label 1550: @99126
     /*   99126 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(99215), // Rule ID 51542 //
     /*   99131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99146 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99165 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99174 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   99191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99213 */     GIR_RootConstrainSelectedInstOperands,
     /*   99214 */     // GIR_Coverage, 51542,
     /*   99214 */     GIR_EraseRootFromParent_Done,
     /*   99215 */   // Label 1551: @99215
     /*   99215 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(99304), // Rule ID 51543 //
     /*   99220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99235 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99254 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99263 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   99280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99302 */     GIR_RootConstrainSelectedInstOperands,
     /*   99303 */     // GIR_Coverage, 51543,
     /*   99303 */     GIR_EraseRootFromParent_Done,
     /*   99304 */   // Label 1552: @99304
     /*   99304 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(99393), // Rule ID 51782 //
     /*   99309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99324 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99343 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99352 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99391 */     GIR_RootConstrainSelectedInstOperands,
     /*   99392 */     // GIR_Coverage, 51782,
     /*   99392 */     GIR_EraseRootFromParent_Done,
     /*   99393 */   // Label 1553: @99393
     /*   99393 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(99482), // Rule ID 51783 //
     /*   99398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99413 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99432 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99441 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99480 */     GIR_RootConstrainSelectedInstOperands,
     /*   99481 */     // GIR_Coverage, 51783,
     /*   99481 */     GIR_EraseRootFromParent_Done,
     /*   99482 */   // Label 1554: @99482
     /*   99482 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(99571), // Rule ID 51722 //
     /*   99487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99502 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99521 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99523 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99530 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99569 */     GIR_RootConstrainSelectedInstOperands,
     /*   99570 */     // GIR_Coverage, 51722,
     /*   99570 */     GIR_EraseRootFromParent_Done,
     /*   99571 */   // Label 1555: @99571
     /*   99571 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(99660), // Rule ID 51723 //
     /*   99576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99591 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99610 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99619 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99658 */     GIR_RootConstrainSelectedInstOperands,
     /*   99659 */     // GIR_Coverage, 51723,
     /*   99659 */     GIR_EraseRootFromParent_Done,
     /*   99660 */   // Label 1556: @99660
     /*   99660 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(99749), // Rule ID 70544 //
     /*   99665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99680 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99699 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99708 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99747 */     GIR_RootConstrainSelectedInstOperands,
     /*   99748 */     // GIR_Coverage, 70544,
     /*   99748 */     GIR_EraseRootFromParent_Done,
     /*   99749 */   // Label 1557: @99749
     /*   99749 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(99838), // Rule ID 70545 //
     /*   99754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99769 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99788 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99797 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99836 */     GIR_RootConstrainSelectedInstOperands,
     /*   99837 */     // GIR_Coverage, 70545,
     /*   99837 */     GIR_EraseRootFromParent_Done,
     /*   99838 */   // Label 1558: @99838
     /*   99838 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(99927), // Rule ID 51602 //
     /*   99843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99858 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99877 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99879 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99886 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99925 */     GIR_RootConstrainSelectedInstOperands,
     /*   99926 */     // GIR_Coverage, 51602,
     /*   99926 */     GIR_EraseRootFromParent_Done,
     /*   99927 */   // Label 1559: @99927
     /*   99927 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(100016), // Rule ID 51603 //
     /*   99932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99947 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99966 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99975 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100014 */     GIR_RootConstrainSelectedInstOperands,
     /*  100015 */     // GIR_Coverage, 51603,
     /*  100015 */     GIR_EraseRootFromParent_Done,
     /*  100016 */   // Label 1560: @100016
     /*  100016 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(100069), // Rule ID 50928 //
     /*  100021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100032 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  100049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  100056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  100058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100067 */     GIR_RootConstrainSelectedInstOperands,
     /*  100068 */     // GIR_Coverage, 50928,
     /*  100068 */     GIR_EraseRootFromParent_Done,
     /*  100069 */   // Label 1561: @100069
     /*  100069 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(100122), // Rule ID 50929 //
     /*  100074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100085 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  100102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  100109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  100111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100120 */     GIR_RootConstrainSelectedInstOperands,
     /*  100121 */     // GIR_Coverage, 50929,
     /*  100121 */     GIR_EraseRootFromParent_Done,
     /*  100122 */   // Label 1562: @100122
     /*  100122 */   GIM_Reject,
     /*  100123 */ // Label 1542: @100123
     /*  100123 */ GIM_Reject,
     /*  100124 */ // Label 1307: @100124
     /*  100124 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(101848),
     /*  100129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  100132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  100135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  100139 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(100228), // Rule ID 51682 //
     /*  100144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100159 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100178 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100187 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100226 */     GIR_RootConstrainSelectedInstOperands,
     /*  100227 */     // GIR_Coverage, 51682,
     /*  100227 */     GIR_EraseRootFromParent_Done,
     /*  100228 */   // Label 1564: @100228
     /*  100228 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(100317), // Rule ID 51683 //
     /*  100233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100248 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100267 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100276 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100315 */     GIR_RootConstrainSelectedInstOperands,
     /*  100316 */     // GIR_Coverage, 51683,
     /*  100316 */     GIR_EraseRootFromParent_Done,
     /*  100317 */   // Label 1565: @100317
     /*  100317 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(100406), // Rule ID 70624 //
     /*  100322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100337 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100356 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100365 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100404 */     GIR_RootConstrainSelectedInstOperands,
     /*  100405 */     // GIR_Coverage, 70624,
     /*  100405 */     GIR_EraseRootFromParent_Done,
     /*  100406 */   // Label 1566: @100406
     /*  100406 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(100495), // Rule ID 70625 //
     /*  100411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100445 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100454 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100493 */     GIR_RootConstrainSelectedInstOperands,
     /*  100494 */     // GIR_Coverage, 70625,
     /*  100494 */     GIR_EraseRootFromParent_Done,
     /*  100495 */   // Label 1567: @100495
     /*  100495 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(100584), // Rule ID 70504 //
     /*  100500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100515 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100534 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100543 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100582 */     GIR_RootConstrainSelectedInstOperands,
     /*  100583 */     // GIR_Coverage, 70504,
     /*  100583 */     GIR_EraseRootFromParent_Done,
     /*  100584 */   // Label 1568: @100584
     /*  100584 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(100673), // Rule ID 70505 //
     /*  100589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100604 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100623 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100632 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100671 */     GIR_RootConstrainSelectedInstOperands,
     /*  100672 */     // GIR_Coverage, 70505,
     /*  100672 */     GIR_EraseRootFromParent_Done,
     /*  100673 */   // Label 1569: @100673
     /*  100673 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(100762), // Rule ID 51862 //
     /*  100678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100693 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100712 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100721 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100760 */     GIR_RootConstrainSelectedInstOperands,
     /*  100761 */     // GIR_Coverage, 51862,
     /*  100761 */     GIR_EraseRootFromParent_Done,
     /*  100762 */   // Label 1570: @100762
     /*  100762 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(100851), // Rule ID 51863 //
     /*  100767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100782 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100801 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100810 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100849 */     GIR_RootConstrainSelectedInstOperands,
     /*  100850 */     // GIR_Coverage, 51863,
     /*  100850 */     GIR_EraseRootFromParent_Done,
     /*  100851 */   // Label 1571: @100851
     /*  100851 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(100940), // Rule ID 51562 //
     /*  100856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100871 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100890 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100899 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  100916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100938 */     GIR_RootConstrainSelectedInstOperands,
     /*  100939 */     // GIR_Coverage, 51562,
     /*  100939 */     GIR_EraseRootFromParent_Done,
     /*  100940 */   // Label 1572: @100940
     /*  100940 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(101029), // Rule ID 51563 //
     /*  100945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100960 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100979 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100988 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  101005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101027 */     GIR_RootConstrainSelectedInstOperands,
     /*  101028 */     // GIR_Coverage, 51563,
     /*  101028 */     GIR_EraseRootFromParent_Done,
     /*  101029 */   // Label 1573: @101029
     /*  101029 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(101118), // Rule ID 51802 //
     /*  101034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101049 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101068 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101077 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101116 */     GIR_RootConstrainSelectedInstOperands,
     /*  101117 */     // GIR_Coverage, 51802,
     /*  101117 */     GIR_EraseRootFromParent_Done,
     /*  101118 */   // Label 1574: @101118
     /*  101118 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(101207), // Rule ID 51803 //
     /*  101123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101138 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101157 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101166 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101205 */     GIR_RootConstrainSelectedInstOperands,
     /*  101206 */     // GIR_Coverage, 51803,
     /*  101206 */     GIR_EraseRootFromParent_Done,
     /*  101207 */   // Label 1575: @101207
     /*  101207 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(101296), // Rule ID 51742 //
     /*  101212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101227 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101246 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101255 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101294 */     GIR_RootConstrainSelectedInstOperands,
     /*  101295 */     // GIR_Coverage, 51742,
     /*  101295 */     GIR_EraseRootFromParent_Done,
     /*  101296 */   // Label 1576: @101296
     /*  101296 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(101385), // Rule ID 51743 //
     /*  101301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101335 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101344 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101383 */     GIR_RootConstrainSelectedInstOperands,
     /*  101384 */     // GIR_Coverage, 51743,
     /*  101384 */     GIR_EraseRootFromParent_Done,
     /*  101385 */   // Label 1577: @101385
     /*  101385 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(101474), // Rule ID 70564 //
     /*  101390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101405 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101424 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101433 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101472 */     GIR_RootConstrainSelectedInstOperands,
     /*  101473 */     // GIR_Coverage, 70564,
     /*  101473 */     GIR_EraseRootFromParent_Done,
     /*  101474 */   // Label 1578: @101474
     /*  101474 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(101563), // Rule ID 70565 //
     /*  101479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101494 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101513 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101522 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101561 */     GIR_RootConstrainSelectedInstOperands,
     /*  101562 */     // GIR_Coverage, 70565,
     /*  101562 */     GIR_EraseRootFromParent_Done,
     /*  101563 */   // Label 1579: @101563
     /*  101563 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(101652), // Rule ID 51622 //
     /*  101568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101583 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101602 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101611 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101650 */     GIR_RootConstrainSelectedInstOperands,
     /*  101651 */     // GIR_Coverage, 51622,
     /*  101651 */     GIR_EraseRootFromParent_Done,
     /*  101652 */   // Label 1580: @101652
     /*  101652 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(101741), // Rule ID 51623 //
     /*  101657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101672 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101691 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101700 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101739 */     GIR_RootConstrainSelectedInstOperands,
     /*  101740 */     // GIR_Coverage, 51623,
     /*  101740 */     GIR_EraseRootFromParent_Done,
     /*  101741 */   // Label 1581: @101741
     /*  101741 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(101794), // Rule ID 50944 //
     /*  101746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  101749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101757 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  101757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  101774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  101789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101792 */     GIR_RootConstrainSelectedInstOperands,
     /*  101793 */     // GIR_Coverage, 50944,
     /*  101793 */     GIR_EraseRootFromParent_Done,
     /*  101794 */   // Label 1582: @101794
     /*  101794 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(101847), // Rule ID 50945 //
     /*  101799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  101802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101810 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  101810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  101827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  101842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101845 */     GIR_RootConstrainSelectedInstOperands,
     /*  101846 */     // GIR_Coverage, 50945,
     /*  101846 */     GIR_EraseRootFromParent_Done,
     /*  101847 */   // Label 1583: @101847
     /*  101847 */   GIM_Reject,
     /*  101848 */ // Label 1563: @101848
     /*  101848 */ GIM_Reject,
     /*  101849 */ // Label 1308: @101849
     /*  101849 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(101963),
     /*  101854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  101857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  101860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101872 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(101917), // Rule ID 50900 //
     /*  101877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101880 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  101880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  101883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  101897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101915 */     GIR_RootConstrainSelectedInstOperands,
     /*  101916 */     // GIR_Coverage, 50900,
     /*  101916 */     GIR_EraseRootFromParent_Done,
     /*  101917 */   // Label 1585: @101917
     /*  101917 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(101962), // Rule ID 50901 //
     /*  101922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  101925 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  101925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  101928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  101942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101960 */     GIR_RootConstrainSelectedInstOperands,
     /*  101961 */     // GIR_Coverage, 50901,
     /*  101961 */     GIR_EraseRootFromParent_Done,
     /*  101962 */   // Label 1586: @101962
     /*  101962 */   GIM_Reject,
     /*  101963 */ // Label 1584: @101963
     /*  101963 */ GIM_Reject,
     /*  101964 */ // Label 1309: @101964
     /*  101964 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(103688),
     /*  101969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  101972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  101975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101979 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(102068), // Rule ID 51642 //
     /*  101984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  101999 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102018 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102027 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102066 */     GIR_RootConstrainSelectedInstOperands,
     /*  102067 */     // GIR_Coverage, 51642,
     /*  102067 */     GIR_EraseRootFromParent_Done,
     /*  102068 */   // Label 1588: @102068
     /*  102068 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(102157), // Rule ID 51643 //
     /*  102073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102088 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102107 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102116 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102155 */     GIR_RootConstrainSelectedInstOperands,
     /*  102156 */     // GIR_Coverage, 51643,
     /*  102156 */     GIR_EraseRootFromParent_Done,
     /*  102157 */   // Label 1589: @102157
     /*  102157 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(102246), // Rule ID 70584 //
     /*  102162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102177 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102196 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102205 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102244 */     GIR_RootConstrainSelectedInstOperands,
     /*  102245 */     // GIR_Coverage, 70584,
     /*  102245 */     GIR_EraseRootFromParent_Done,
     /*  102246 */   // Label 1590: @102246
     /*  102246 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(102335), // Rule ID 70585 //
     /*  102251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102266 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102285 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102294 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102333 */     GIR_RootConstrainSelectedInstOperands,
     /*  102334 */     // GIR_Coverage, 70585,
     /*  102334 */     GIR_EraseRootFromParent_Done,
     /*  102335 */   // Label 1591: @102335
     /*  102335 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(102424), // Rule ID 70464 //
     /*  102340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102355 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102374 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102383 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102422 */     GIR_RootConstrainSelectedInstOperands,
     /*  102423 */     // GIR_Coverage, 70464,
     /*  102423 */     GIR_EraseRootFromParent_Done,
     /*  102424 */   // Label 1592: @102424
     /*  102424 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(102513), // Rule ID 70465 //
     /*  102429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102444 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102463 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102472 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102511 */     GIR_RootConstrainSelectedInstOperands,
     /*  102512 */     // GIR_Coverage, 70465,
     /*  102512 */     GIR_EraseRootFromParent_Done,
     /*  102513 */   // Label 1593: @102513
     /*  102513 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(102602), // Rule ID 51822 //
     /*  102518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102533 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102552 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102561 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102600 */     GIR_RootConstrainSelectedInstOperands,
     /*  102601 */     // GIR_Coverage, 51822,
     /*  102601 */     GIR_EraseRootFromParent_Done,
     /*  102602 */   // Label 1594: @102602
     /*  102602 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(102691), // Rule ID 51823 //
     /*  102607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102622 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102641 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102650 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102689 */     GIR_RootConstrainSelectedInstOperands,
     /*  102690 */     // GIR_Coverage, 51823,
     /*  102690 */     GIR_EraseRootFromParent_Done,
     /*  102691 */   // Label 1595: @102691
     /*  102691 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(102780), // Rule ID 51522 //
     /*  102696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102711 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102730 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102739 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  102756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102778 */     GIR_RootConstrainSelectedInstOperands,
     /*  102779 */     // GIR_Coverage, 51522,
     /*  102779 */     GIR_EraseRootFromParent_Done,
     /*  102780 */   // Label 1596: @102780
     /*  102780 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(102869), // Rule ID 51523 //
     /*  102785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102800 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102819 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102828 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  102845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102867 */     GIR_RootConstrainSelectedInstOperands,
     /*  102868 */     // GIR_Coverage, 51523,
     /*  102868 */     GIR_EraseRootFromParent_Done,
     /*  102869 */   // Label 1597: @102869
     /*  102869 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(102958), // Rule ID 51762 //
     /*  102874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102889 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102908 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102917 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102956 */     GIR_RootConstrainSelectedInstOperands,
     /*  102957 */     // GIR_Coverage, 51762,
     /*  102957 */     GIR_EraseRootFromParent_Done,
     /*  102958 */   // Label 1598: @102958
     /*  102958 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(103047), // Rule ID 51763 //
     /*  102963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102978 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102997 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103006 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103045 */     GIR_RootConstrainSelectedInstOperands,
     /*  103046 */     // GIR_Coverage, 51763,
     /*  103046 */     GIR_EraseRootFromParent_Done,
     /*  103047 */   // Label 1599: @103047
     /*  103047 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(103136), // Rule ID 51702 //
     /*  103052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103067 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103086 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103095 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103134 */     GIR_RootConstrainSelectedInstOperands,
     /*  103135 */     // GIR_Coverage, 51702,
     /*  103135 */     GIR_EraseRootFromParent_Done,
     /*  103136 */   // Label 1600: @103136
     /*  103136 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(103225), // Rule ID 51703 //
     /*  103141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103156 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103175 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103184 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103223 */     GIR_RootConstrainSelectedInstOperands,
     /*  103224 */     // GIR_Coverage, 51703,
     /*  103224 */     GIR_EraseRootFromParent_Done,
     /*  103225 */   // Label 1601: @103225
     /*  103225 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(103314), // Rule ID 70524 //
     /*  103230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103245 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103264 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103273 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103312 */     GIR_RootConstrainSelectedInstOperands,
     /*  103313 */     // GIR_Coverage, 70524,
     /*  103313 */     GIR_EraseRootFromParent_Done,
     /*  103314 */   // Label 1602: @103314
     /*  103314 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(103403), // Rule ID 70525 //
     /*  103319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103334 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103353 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103362 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103401 */     GIR_RootConstrainSelectedInstOperands,
     /*  103402 */     // GIR_Coverage, 70525,
     /*  103402 */     GIR_EraseRootFromParent_Done,
     /*  103403 */   // Label 1603: @103403
     /*  103403 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(103492), // Rule ID 51582 //
     /*  103408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103423 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103442 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103451 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103490 */     GIR_RootConstrainSelectedInstOperands,
     /*  103491 */     // GIR_Coverage, 51582,
     /*  103491 */     GIR_EraseRootFromParent_Done,
     /*  103492 */   // Label 1604: @103492
     /*  103492 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(103581), // Rule ID 51583 //
     /*  103497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103512 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103531 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103540 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103579 */     GIR_RootConstrainSelectedInstOperands,
     /*  103580 */     // GIR_Coverage, 51583,
     /*  103580 */     GIR_EraseRootFromParent_Done,
     /*  103581 */   // Label 1605: @103581
     /*  103581 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(103634), // Rule ID 50916 //
     /*  103586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103597 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  103614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103632 */     GIR_RootConstrainSelectedInstOperands,
     /*  103633 */     // GIR_Coverage, 50916,
     /*  103633 */     GIR_EraseRootFromParent_Done,
     /*  103634 */   // Label 1606: @103634
     /*  103634 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(103687), // Rule ID 50917 //
     /*  103639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103650 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  103650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  103667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103685 */     GIR_RootConstrainSelectedInstOperands,
     /*  103686 */     // GIR_Coverage, 50917,
     /*  103686 */     GIR_EraseRootFromParent_Done,
     /*  103687 */   // Label 1607: @103687
     /*  103687 */   GIM_Reject,
     /*  103688 */ // Label 1587: @103688
     /*  103688 */ GIM_Reject,
     /*  103689 */ // Label 1310: @103689
     /*  103689 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(105413),
     /*  103694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  103697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  103700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  103704 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(103793), // Rule ID 51666 //
     /*  103709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103724 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103743 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103752 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  103755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  103769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103791 */     GIR_RootConstrainSelectedInstOperands,
     /*  103792 */     // GIR_Coverage, 51666,
     /*  103792 */     GIR_EraseRootFromParent_Done,
     /*  103793 */   // Label 1609: @103793
     /*  103793 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(103882), // Rule ID 51667 //
     /*  103798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103813 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103832 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103841 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  103841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  103844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  103858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103880 */     GIR_RootConstrainSelectedInstOperands,
     /*  103881 */     // GIR_Coverage, 51667,
     /*  103881 */     GIR_EraseRootFromParent_Done,
     /*  103882 */   // Label 1610: @103882
     /*  103882 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(103971), // Rule ID 70608 //
     /*  103887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103902 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103921 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103930 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  103933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  103947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103969 */     GIR_RootConstrainSelectedInstOperands,
     /*  103970 */     // GIR_Coverage, 70608,
     /*  103970 */     GIR_EraseRootFromParent_Done,
     /*  103971 */   // Label 1611: @103971
     /*  103971 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(104060), // Rule ID 70609 //
     /*  103976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103991 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104010 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104019 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104058 */     GIR_RootConstrainSelectedInstOperands,
     /*  104059 */     // GIR_Coverage, 70609,
     /*  104059 */     GIR_EraseRootFromParent_Done,
     /*  104060 */   // Label 1612: @104060
     /*  104060 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(104149), // Rule ID 70488 //
     /*  104065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104080 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104099 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104108 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104147 */     GIR_RootConstrainSelectedInstOperands,
     /*  104148 */     // GIR_Coverage, 70488,
     /*  104148 */     GIR_EraseRootFromParent_Done,
     /*  104149 */   // Label 1613: @104149
     /*  104149 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(104238), // Rule ID 70489 //
     /*  104154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104169 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104188 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104197 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104236 */     GIR_RootConstrainSelectedInstOperands,
     /*  104237 */     // GIR_Coverage, 70489,
     /*  104237 */     GIR_EraseRootFromParent_Done,
     /*  104238 */   // Label 1614: @104238
     /*  104238 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(104327), // Rule ID 51846 //
     /*  104243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104258 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104277 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104286 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104325 */     GIR_RootConstrainSelectedInstOperands,
     /*  104326 */     // GIR_Coverage, 51846,
     /*  104326 */     GIR_EraseRootFromParent_Done,
     /*  104327 */   // Label 1615: @104327
     /*  104327 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(104416), // Rule ID 51847 //
     /*  104332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104347 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104366 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104375 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104414 */     GIR_RootConstrainSelectedInstOperands,
     /*  104415 */     // GIR_Coverage, 51847,
     /*  104415 */     GIR_EraseRootFromParent_Done,
     /*  104416 */   // Label 1616: @104416
     /*  104416 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(104505), // Rule ID 51546 //
     /*  104421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104455 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104464 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  104481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104503 */     GIR_RootConstrainSelectedInstOperands,
     /*  104504 */     // GIR_Coverage, 51546,
     /*  104504 */     GIR_EraseRootFromParent_Done,
     /*  104505 */   // Label 1617: @104505
     /*  104505 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(104594), // Rule ID 51547 //
     /*  104510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104525 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104544 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104553 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  104570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104592 */     GIR_RootConstrainSelectedInstOperands,
     /*  104593 */     // GIR_Coverage, 51547,
     /*  104593 */     GIR_EraseRootFromParent_Done,
     /*  104594 */   // Label 1618: @104594
     /*  104594 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(104683), // Rule ID 51786 //
     /*  104599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104614 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104633 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104642 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104681 */     GIR_RootConstrainSelectedInstOperands,
     /*  104682 */     // GIR_Coverage, 51786,
     /*  104682 */     GIR_EraseRootFromParent_Done,
     /*  104683 */   // Label 1619: @104683
     /*  104683 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(104772), // Rule ID 51787 //
     /*  104688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104703 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104722 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104731 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104770 */     GIR_RootConstrainSelectedInstOperands,
     /*  104771 */     // GIR_Coverage, 51787,
     /*  104771 */     GIR_EraseRootFromParent_Done,
     /*  104772 */   // Label 1620: @104772
     /*  104772 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(104861), // Rule ID 51726 //
     /*  104777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104792 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104811 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104813 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104820 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104859 */     GIR_RootConstrainSelectedInstOperands,
     /*  104860 */     // GIR_Coverage, 51726,
     /*  104860 */     GIR_EraseRootFromParent_Done,
     /*  104861 */   // Label 1621: @104861
     /*  104861 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(104950), // Rule ID 51727 //
     /*  104866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104881 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104900 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104909 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104948 */     GIR_RootConstrainSelectedInstOperands,
     /*  104949 */     // GIR_Coverage, 51727,
     /*  104949 */     GIR_EraseRootFromParent_Done,
     /*  104950 */   // Label 1622: @104950
     /*  104950 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(105039), // Rule ID 70548 //
     /*  104955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104970 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104989 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104998 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105037 */     GIR_RootConstrainSelectedInstOperands,
     /*  105038 */     // GIR_Coverage, 70548,
     /*  105038 */     GIR_EraseRootFromParent_Done,
     /*  105039 */   // Label 1623: @105039
     /*  105039 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(105128), // Rule ID 70549 //
     /*  105044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105059 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105078 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105080 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105087 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105126 */     GIR_RootConstrainSelectedInstOperands,
     /*  105127 */     // GIR_Coverage, 70549,
     /*  105127 */     GIR_EraseRootFromParent_Done,
     /*  105128 */   // Label 1624: @105128
     /*  105128 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(105217), // Rule ID 51606 //
     /*  105133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105148 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105167 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105176 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105215 */     GIR_RootConstrainSelectedInstOperands,
     /*  105216 */     // GIR_Coverage, 51606,
     /*  105216 */     GIR_EraseRootFromParent_Done,
     /*  105217 */   // Label 1625: @105217
     /*  105217 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(105306), // Rule ID 51607 //
     /*  105222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105237 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105256 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105258 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105265 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105304 */     GIR_RootConstrainSelectedInstOperands,
     /*  105305 */     // GIR_Coverage, 51607,
     /*  105305 */     GIR_EraseRootFromParent_Done,
     /*  105306 */   // Label 1626: @105306
     /*  105306 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(105359), // Rule ID 50932 //
     /*  105311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105322 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  105322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  105339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105357 */     GIR_RootConstrainSelectedInstOperands,
     /*  105358 */     // GIR_Coverage, 50932,
     /*  105358 */     GIR_EraseRootFromParent_Done,
     /*  105359 */   // Label 1627: @105359
     /*  105359 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(105412), // Rule ID 50933 //
     /*  105364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105375 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  105375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  105392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105410 */     GIR_RootConstrainSelectedInstOperands,
     /*  105411 */     // GIR_Coverage, 50933,
     /*  105411 */     GIR_EraseRootFromParent_Done,
     /*  105412 */   // Label 1628: @105412
     /*  105412 */   GIM_Reject,
     /*  105413 */ // Label 1608: @105413
     /*  105413 */ GIM_Reject,
     /*  105414 */ // Label 1311: @105414
     /*  105414 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(105528),
     /*  105419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  105425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105437 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(105482), // Rule ID 50904 //
     /*  105442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105445 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  105462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105480 */     GIR_RootConstrainSelectedInstOperands,
     /*  105481 */     // GIR_Coverage, 50904,
     /*  105481 */     GIR_EraseRootFromParent_Done,
     /*  105482 */   // Label 1630: @105482
     /*  105482 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(105527), // Rule ID 50905 //
     /*  105487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105490 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  105507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105525 */     GIR_RootConstrainSelectedInstOperands,
     /*  105526 */     // GIR_Coverage, 50905,
     /*  105526 */     GIR_EraseRootFromParent_Done,
     /*  105527 */   // Label 1631: @105527
     /*  105527 */   GIM_Reject,
     /*  105528 */ // Label 1629: @105528
     /*  105528 */ GIM_Reject,
     /*  105529 */ // Label 1312: @105529
     /*  105529 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(107253),
     /*  105534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  105537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  105540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105544 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(105633), // Rule ID 51646 //
     /*  105549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105564 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105583 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105592 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105631 */     GIR_RootConstrainSelectedInstOperands,
     /*  105632 */     // GIR_Coverage, 51646,
     /*  105632 */     GIR_EraseRootFromParent_Done,
     /*  105633 */   // Label 1633: @105633
     /*  105633 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(105722), // Rule ID 51647 //
     /*  105638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105653 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105672 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105681 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105720 */     GIR_RootConstrainSelectedInstOperands,
     /*  105721 */     // GIR_Coverage, 51647,
     /*  105721 */     GIR_EraseRootFromParent_Done,
     /*  105722 */   // Label 1634: @105722
     /*  105722 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(105811), // Rule ID 70588 //
     /*  105727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105742 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105761 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105770 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105809 */     GIR_RootConstrainSelectedInstOperands,
     /*  105810 */     // GIR_Coverage, 70588,
     /*  105810 */     GIR_EraseRootFromParent_Done,
     /*  105811 */   // Label 1635: @105811
     /*  105811 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(105900), // Rule ID 70589 //
     /*  105816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105850 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105859 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105898 */     GIR_RootConstrainSelectedInstOperands,
     /*  105899 */     // GIR_Coverage, 70589,
     /*  105899 */     GIR_EraseRootFromParent_Done,
     /*  105900 */   // Label 1636: @105900
     /*  105900 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(105989), // Rule ID 70468 //
     /*  105905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105939 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105948 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105987 */     GIR_RootConstrainSelectedInstOperands,
     /*  105988 */     // GIR_Coverage, 70468,
     /*  105988 */     GIR_EraseRootFromParent_Done,
     /*  105989 */   // Label 1637: @105989
     /*  105989 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(106078), // Rule ID 70469 //
     /*  105994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106009 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106028 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106037 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106076 */     GIR_RootConstrainSelectedInstOperands,
     /*  106077 */     // GIR_Coverage, 70469,
     /*  106077 */     GIR_EraseRootFromParent_Done,
     /*  106078 */   // Label 1638: @106078
     /*  106078 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(106167), // Rule ID 51826 //
     /*  106083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106098 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106117 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106126 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106165 */     GIR_RootConstrainSelectedInstOperands,
     /*  106166 */     // GIR_Coverage, 51826,
     /*  106166 */     GIR_EraseRootFromParent_Done,
     /*  106167 */   // Label 1639: @106167
     /*  106167 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(106256), // Rule ID 51827 //
     /*  106172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106187 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106206 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106215 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106254 */     GIR_RootConstrainSelectedInstOperands,
     /*  106255 */     // GIR_Coverage, 51827,
     /*  106255 */     GIR_EraseRootFromParent_Done,
     /*  106256 */   // Label 1640: @106256
     /*  106256 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106345), // Rule ID 51526 //
     /*  106261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106276 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106295 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106304 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  106321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106343 */     GIR_RootConstrainSelectedInstOperands,
     /*  106344 */     // GIR_Coverage, 51526,
     /*  106344 */     GIR_EraseRootFromParent_Done,
     /*  106345 */   // Label 1641: @106345
     /*  106345 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106434), // Rule ID 51527 //
     /*  106350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106365 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106384 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106393 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  106410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106432 */     GIR_RootConstrainSelectedInstOperands,
     /*  106433 */     // GIR_Coverage, 51527,
     /*  106433 */     GIR_EraseRootFromParent_Done,
     /*  106434 */   // Label 1642: @106434
     /*  106434 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106523), // Rule ID 51766 //
     /*  106439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106454 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106473 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106482 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106521 */     GIR_RootConstrainSelectedInstOperands,
     /*  106522 */     // GIR_Coverage, 51766,
     /*  106522 */     GIR_EraseRootFromParent_Done,
     /*  106523 */   // Label 1643: @106523
     /*  106523 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(106612), // Rule ID 51767 //
     /*  106528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106543 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106562 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106571 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106610 */     GIR_RootConstrainSelectedInstOperands,
     /*  106611 */     // GIR_Coverage, 51767,
     /*  106611 */     GIR_EraseRootFromParent_Done,
     /*  106612 */   // Label 1644: @106612
     /*  106612 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(106701), // Rule ID 51706 //
     /*  106617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106632 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106651 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106660 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106699 */     GIR_RootConstrainSelectedInstOperands,
     /*  106700 */     // GIR_Coverage, 51706,
     /*  106700 */     GIR_EraseRootFromParent_Done,
     /*  106701 */   // Label 1645: @106701
     /*  106701 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(106790), // Rule ID 51707 //
     /*  106706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106740 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106749 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106788 */     GIR_RootConstrainSelectedInstOperands,
     /*  106789 */     // GIR_Coverage, 51707,
     /*  106789 */     GIR_EraseRootFromParent_Done,
     /*  106790 */   // Label 1646: @106790
     /*  106790 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(106879), // Rule ID 70528 //
     /*  106795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106810 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106829 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106838 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106877 */     GIR_RootConstrainSelectedInstOperands,
     /*  106878 */     // GIR_Coverage, 70528,
     /*  106878 */     GIR_EraseRootFromParent_Done,
     /*  106879 */   // Label 1647: @106879
     /*  106879 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(106968), // Rule ID 70529 //
     /*  106884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106899 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106918 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106927 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106966 */     GIR_RootConstrainSelectedInstOperands,
     /*  106967 */     // GIR_Coverage, 70529,
     /*  106967 */     GIR_EraseRootFromParent_Done,
     /*  106968 */   // Label 1648: @106968
     /*  106968 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(107057), // Rule ID 51586 //
     /*  106973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106988 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107007 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107016 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107055 */     GIR_RootConstrainSelectedInstOperands,
     /*  107056 */     // GIR_Coverage, 51586,
     /*  107056 */     GIR_EraseRootFromParent_Done,
     /*  107057 */   // Label 1649: @107057
     /*  107057 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(107146), // Rule ID 51587 //
     /*  107062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107077 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107096 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107105 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107144 */     GIR_RootConstrainSelectedInstOperands,
     /*  107145 */     // GIR_Coverage, 51587,
     /*  107145 */     GIR_EraseRootFromParent_Done,
     /*  107146 */   // Label 1650: @107146
     /*  107146 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(107199), // Rule ID 50920 //
     /*  107151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107162 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  107162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107197 */     GIR_RootConstrainSelectedInstOperands,
     /*  107198 */     // GIR_Coverage, 50920,
     /*  107198 */     GIR_EraseRootFromParent_Done,
     /*  107199 */   // Label 1651: @107199
     /*  107199 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(107252), // Rule ID 50921 //
     /*  107204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107215 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  107215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107250 */     GIR_RootConstrainSelectedInstOperands,
     /*  107251 */     // GIR_Coverage, 50921,
     /*  107251 */     GIR_EraseRootFromParent_Done,
     /*  107252 */   // Label 1652: @107252
     /*  107252 */   GIM_Reject,
     /*  107253 */ // Label 1632: @107253
     /*  107253 */ GIM_Reject,
     /*  107254 */ // Label 1313: @107254
     /*  107254 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(107368),
     /*  107259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  107262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  107265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107277 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(107322), // Rule ID 50908 //
     /*  107282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107285 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  107288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107320 */     GIR_RootConstrainSelectedInstOperands,
     /*  107321 */     // GIR_Coverage, 50908,
     /*  107321 */     GIR_EraseRootFromParent_Done,
     /*  107322 */   // Label 1654: @107322
     /*  107322 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(107367), // Rule ID 50909 //
     /*  107327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107330 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  107333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107365 */     GIR_RootConstrainSelectedInstOperands,
     /*  107366 */     // GIR_Coverage, 50909,
     /*  107366 */     GIR_EraseRootFromParent_Done,
     /*  107367 */   // Label 1655: @107367
     /*  107367 */   GIM_Reject,
     /*  107368 */ // Label 1653: @107368
     /*  107368 */ GIM_Reject,
     /*  107369 */ // Label 1314: @107369
     /*  107369 */ GIM_Reject,
     /*  107370 */ // Label 3: @107370
     /*  107370 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1680*/ GIMT_Encode4(110103),
     /*  107381 */ /*GILLT_s32*//*Label 1656*/ GIMT_Encode4(107505),
     /*  107385 */ /*GILLT_s64*//*Label 1657*/ GIMT_Encode4(107539), GIMT_Encode4(0),
     /*  107393 */ /*GILLT_nxv1s8*//*Label 1658*/ GIMT_Encode4(107573),
     /*  107397 */ /*GILLT_nxv1s16*//*Label 1659*/ GIMT_Encode4(107688),
     /*  107401 */ /*GILLT_nxv1s32*//*Label 1660*/ GIMT_Encode4(107803),
     /*  107405 */ /*GILLT_nxv1s64*//*Label 1661*/ GIMT_Encode4(107918), GIMT_Encode4(0),
     /*  107413 */ /*GILLT_nxv2s8*//*Label 1662*/ GIMT_Encode4(108033),
     /*  107417 */ /*GILLT_nxv2s16*//*Label 1663*/ GIMT_Encode4(108148),
     /*  107421 */ /*GILLT_nxv2s32*//*Label 1664*/ GIMT_Encode4(108263),
     /*  107425 */ /*GILLT_nxv2s64*//*Label 1665*/ GIMT_Encode4(108378), GIMT_Encode4(0),
     /*  107433 */ /*GILLT_nxv4s8*//*Label 1666*/ GIMT_Encode4(108493),
     /*  107437 */ /*GILLT_nxv4s16*//*Label 1667*/ GIMT_Encode4(108608),
     /*  107441 */ /*GILLT_nxv4s32*//*Label 1668*/ GIMT_Encode4(108723),
     /*  107445 */ /*GILLT_nxv4s64*//*Label 1669*/ GIMT_Encode4(108838), GIMT_Encode4(0),
     /*  107453 */ /*GILLT_nxv8s8*//*Label 1670*/ GIMT_Encode4(108953),
     /*  107457 */ /*GILLT_nxv8s16*//*Label 1671*/ GIMT_Encode4(109068),
     /*  107461 */ /*GILLT_nxv8s32*//*Label 1672*/ GIMT_Encode4(109183),
     /*  107465 */ /*GILLT_nxv8s64*//*Label 1673*/ GIMT_Encode4(109298), GIMT_Encode4(0),
     /*  107473 */ /*GILLT_nxv16s8*//*Label 1674*/ GIMT_Encode4(109413),
     /*  107477 */ /*GILLT_nxv16s16*//*Label 1675*/ GIMT_Encode4(109528),
     /*  107481 */ /*GILLT_nxv16s32*//*Label 1676*/ GIMT_Encode4(109643), GIMT_Encode4(0),
     /*  107489 */ /*GILLT_nxv32s8*//*Label 1677*/ GIMT_Encode4(109758),
     /*  107493 */ /*GILLT_nxv32s16*//*Label 1678*/ GIMT_Encode4(109873), GIMT_Encode4(0),
     /*  107501 */ /*GILLT_nxv64s8*//*Label 1679*/ GIMT_Encode4(109988),
     /*  107505 */ // Label 1656: @107505
     /*  107505 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(107538), // Rule ID 310 //
     /*  107510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  107513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  107516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  107519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107531 */   // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  107536 */   GIR_RootConstrainSelectedInstOperands,
     /*  107537 */   // GIR_Coverage, 310,
     /*  107537 */   GIR_Done,
     /*  107538 */ // Label 1681: @107538
     /*  107538 */ GIM_Reject,
     /*  107539 */ // Label 1657: @107539
     /*  107539 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(107572), // Rule ID 309 //
     /*  107544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  107547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  107550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  107553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107565 */   // (sdiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  107565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  107570 */   GIR_RootConstrainSelectedInstOperands,
     /*  107571 */   // GIR_Coverage, 309,
     /*  107571 */   GIR_Done,
     /*  107572 */ // Label 1682: @107572
     /*  107572 */ GIM_Reject,
     /*  107573 */ // Label 1658: @107573
     /*  107573 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(107687),
     /*  107578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  107581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  107584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107596 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(107641), // Rule ID 51212 //
     /*  107601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107604 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  107607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  107621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107639 */     GIR_RootConstrainSelectedInstOperands,
     /*  107640 */     // GIR_Coverage, 51212,
     /*  107640 */     GIR_EraseRootFromParent_Done,
     /*  107641 */   // Label 1684: @107641
     /*  107641 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(107686), // Rule ID 51213 //
     /*  107646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107649 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  107652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  107666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107684 */     GIR_RootConstrainSelectedInstOperands,
     /*  107685 */     // GIR_Coverage, 51213,
     /*  107685 */     GIR_EraseRootFromParent_Done,
     /*  107686 */   // Label 1685: @107686
     /*  107686 */   GIM_Reject,
     /*  107687 */ // Label 1683: @107687
     /*  107687 */ GIM_Reject,
     /*  107688 */ // Label 1659: @107688
     /*  107688 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(107802),
     /*  107693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  107696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  107699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107711 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(107756), // Rule ID 51224 //
     /*  107716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107719 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  107719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  107722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  107736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107754 */     GIR_RootConstrainSelectedInstOperands,
     /*  107755 */     // GIR_Coverage, 51224,
     /*  107755 */     GIR_EraseRootFromParent_Done,
     /*  107756 */   // Label 1687: @107756
     /*  107756 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(107801), // Rule ID 51225 //
     /*  107761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107764 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  107764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  107767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  107781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107799 */     GIR_RootConstrainSelectedInstOperands,
     /*  107800 */     // GIR_Coverage, 51225,
     /*  107800 */     GIR_EraseRootFromParent_Done,
     /*  107801 */   // Label 1688: @107801
     /*  107801 */   GIM_Reject,
     /*  107802 */ // Label 1686: @107802
     /*  107802 */ GIM_Reject,
     /*  107803 */ // Label 1660: @107803
     /*  107803 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(107917),
     /*  107808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  107811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  107814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107826 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(107871), // Rule ID 51232 //
     /*  107831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107834 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  107834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  107837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  107851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  107866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107869 */     GIR_RootConstrainSelectedInstOperands,
     /*  107870 */     // GIR_Coverage, 51232,
     /*  107870 */     GIR_EraseRootFromParent_Done,
     /*  107871 */   // Label 1690: @107871
     /*  107871 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(107916), // Rule ID 51233 //
     /*  107876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107879 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  107879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  107882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  107896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  107911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107914 */     GIR_RootConstrainSelectedInstOperands,
     /*  107915 */     // GIR_Coverage, 51233,
     /*  107915 */     GIR_EraseRootFromParent_Done,
     /*  107916 */   // Label 1691: @107916
     /*  107916 */   GIM_Reject,
     /*  107917 */ // Label 1689: @107917
     /*  107917 */ GIM_Reject,
     /*  107918 */ // Label 1661: @107918
     /*  107918 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(108032),
     /*  107923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  107926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  107929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107941 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(107986), // Rule ID 51248 //
     /*  107946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  107949 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  107949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  107952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  107966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  107981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107984 */     GIR_RootConstrainSelectedInstOperands,
     /*  107985 */     // GIR_Coverage, 51248,
     /*  107985 */     GIR_EraseRootFromParent_Done,
     /*  107986 */   // Label 1693: @107986
     /*  107986 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(108031), // Rule ID 51249 //
     /*  107991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  107994 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  107994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  107997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  108011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108029 */     GIR_RootConstrainSelectedInstOperands,
     /*  108030 */     // GIR_Coverage, 51249,
     /*  108030 */     GIR_EraseRootFromParent_Done,
     /*  108031 */   // Label 1694: @108031
     /*  108031 */   GIM_Reject,
     /*  108032 */ // Label 1692: @108032
     /*  108032 */ GIM_Reject,
     /*  108033 */ // Label 1662: @108033
     /*  108033 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(108147),
     /*  108038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  108041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  108044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108056 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(108101), // Rule ID 51216 //
     /*  108061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108064 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  108067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  108081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108099 */     GIR_RootConstrainSelectedInstOperands,
     /*  108100 */     // GIR_Coverage, 51216,
     /*  108100 */     GIR_EraseRootFromParent_Done,
     /*  108101 */   // Label 1696: @108101
     /*  108101 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(108146), // Rule ID 51217 //
     /*  108106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108109 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  108112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  108126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108144 */     GIR_RootConstrainSelectedInstOperands,
     /*  108145 */     // GIR_Coverage, 51217,
     /*  108145 */     GIR_EraseRootFromParent_Done,
     /*  108146 */   // Label 1697: @108146
     /*  108146 */   GIM_Reject,
     /*  108147 */ // Label 1695: @108147
     /*  108147 */ GIM_Reject,
     /*  108148 */ // Label 1663: @108148
     /*  108148 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(108262),
     /*  108153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  108156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  108159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108167 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108171 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(108216), // Rule ID 51228 //
     /*  108176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108179 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  108182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  108196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108214 */     GIR_RootConstrainSelectedInstOperands,
     /*  108215 */     // GIR_Coverage, 51228,
     /*  108215 */     GIR_EraseRootFromParent_Done,
     /*  108216 */   // Label 1699: @108216
     /*  108216 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(108261), // Rule ID 51229 //
     /*  108221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108224 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  108227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  108241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108259 */     GIR_RootConstrainSelectedInstOperands,
     /*  108260 */     // GIR_Coverage, 51229,
     /*  108260 */     GIR_EraseRootFromParent_Done,
     /*  108261 */   // Label 1700: @108261
     /*  108261 */   GIM_Reject,
     /*  108262 */ // Label 1698: @108262
     /*  108262 */ GIM_Reject,
     /*  108263 */ // Label 1664: @108263
     /*  108263 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(108377),
     /*  108268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  108271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  108274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108286 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(108331), // Rule ID 51244 //
     /*  108291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108294 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  108294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  108297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  108311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108329 */     GIR_RootConstrainSelectedInstOperands,
     /*  108330 */     // GIR_Coverage, 51244,
     /*  108330 */     GIR_EraseRootFromParent_Done,
     /*  108331 */   // Label 1702: @108331
     /*  108331 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(108376), // Rule ID 51245 //
     /*  108336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108339 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  108339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  108342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  108356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108374 */     GIR_RootConstrainSelectedInstOperands,
     /*  108375 */     // GIR_Coverage, 51245,
     /*  108375 */     GIR_EraseRootFromParent_Done,
     /*  108376 */   // Label 1703: @108376
     /*  108376 */   GIM_Reject,
     /*  108377 */ // Label 1701: @108377
     /*  108377 */ GIM_Reject,
     /*  108378 */ // Label 1665: @108378
     /*  108378 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(108492),
     /*  108383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  108386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  108389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108401 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(108446), // Rule ID 51288 //
     /*  108406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  108409 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  108409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  108412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  108426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108444 */     GIR_RootConstrainSelectedInstOperands,
     /*  108445 */     // GIR_Coverage, 51288,
     /*  108445 */     GIR_EraseRootFromParent_Done,
     /*  108446 */   // Label 1705: @108446
     /*  108446 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(108491), // Rule ID 51289 //
     /*  108451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  108454 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  108454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  108457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  108471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108489 */     GIR_RootConstrainSelectedInstOperands,
     /*  108490 */     // GIR_Coverage, 51289,
     /*  108490 */     GIR_EraseRootFromParent_Done,
     /*  108491 */   // Label 1706: @108491
     /*  108491 */   GIM_Reject,
     /*  108492 */ // Label 1704: @108492
     /*  108492 */ GIM_Reject,
     /*  108493 */ // Label 1666: @108493
     /*  108493 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(108607),
     /*  108498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  108501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  108504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108516 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(108561), // Rule ID 51220 //
     /*  108521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108524 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  108527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  108541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108559 */     GIR_RootConstrainSelectedInstOperands,
     /*  108560 */     // GIR_Coverage, 51220,
     /*  108560 */     GIR_EraseRootFromParent_Done,
     /*  108561 */   // Label 1708: @108561
     /*  108561 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(108606), // Rule ID 51221 //
     /*  108566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108569 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  108572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  108586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108604 */     GIR_RootConstrainSelectedInstOperands,
     /*  108605 */     // GIR_Coverage, 51221,
     /*  108605 */     GIR_EraseRootFromParent_Done,
     /*  108606 */   // Label 1709: @108606
     /*  108606 */   GIM_Reject,
     /*  108607 */ // Label 1707: @108607
     /*  108607 */ GIM_Reject,
     /*  108608 */ // Label 1667: @108608
     /*  108608 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(108722),
     /*  108613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  108616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  108619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108627 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108631 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(108676), // Rule ID 51240 //
     /*  108636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108639 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  108642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  108656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108674 */     GIR_RootConstrainSelectedInstOperands,
     /*  108675 */     // GIR_Coverage, 51240,
     /*  108675 */     GIR_EraseRootFromParent_Done,
     /*  108676 */   // Label 1711: @108676
     /*  108676 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(108721), // Rule ID 51241 //
     /*  108681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108684 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  108687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  108701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108719 */     GIR_RootConstrainSelectedInstOperands,
     /*  108720 */     // GIR_Coverage, 51241,
     /*  108720 */     GIR_EraseRootFromParent_Done,
     /*  108721 */   // Label 1712: @108721
     /*  108721 */   GIM_Reject,
     /*  108722 */ // Label 1710: @108722
     /*  108722 */ GIM_Reject,
     /*  108723 */ // Label 1668: @108723
     /*  108723 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(108837),
     /*  108728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  108731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  108734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108746 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(108791), // Rule ID 51276 //
     /*  108751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108754 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  108754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  108757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  108771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108789 */     GIR_RootConstrainSelectedInstOperands,
     /*  108790 */     // GIR_Coverage, 51276,
     /*  108790 */     GIR_EraseRootFromParent_Done,
     /*  108791 */   // Label 1714: @108791
     /*  108791 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(108836), // Rule ID 51277 //
     /*  108796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108799 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  108799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  108802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  108816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108834 */     GIR_RootConstrainSelectedInstOperands,
     /*  108835 */     // GIR_Coverage, 51277,
     /*  108835 */     GIR_EraseRootFromParent_Done,
     /*  108836 */   // Label 1715: @108836
     /*  108836 */   GIM_Reject,
     /*  108837 */ // Label 1713: @108837
     /*  108837 */ GIM_Reject,
     /*  108838 */ // Label 1669: @108838
     /*  108838 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(108952),
     /*  108843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  108846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  108849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108861 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(108906), // Rule ID 51292 //
     /*  108866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  108869 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  108869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  108872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  108886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108904 */     GIR_RootConstrainSelectedInstOperands,
     /*  108905 */     // GIR_Coverage, 51292,
     /*  108905 */     GIR_EraseRootFromParent_Done,
     /*  108906 */   // Label 1717: @108906
     /*  108906 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(108951), // Rule ID 51293 //
     /*  108911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  108914 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  108914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  108917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  108931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108949 */     GIR_RootConstrainSelectedInstOperands,
     /*  108950 */     // GIR_Coverage, 51293,
     /*  108950 */     GIR_EraseRootFromParent_Done,
     /*  108951 */   // Label 1718: @108951
     /*  108951 */   GIM_Reject,
     /*  108952 */ // Label 1716: @108952
     /*  108952 */ GIM_Reject,
     /*  108953 */ // Label 1670: @108953
     /*  108953 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(109067),
     /*  108958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  108961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  108964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108976 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(109021), // Rule ID 51236 //
     /*  108981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108984 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  108987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  109001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109019 */     GIR_RootConstrainSelectedInstOperands,
     /*  109020 */     // GIR_Coverage, 51236,
     /*  109020 */     GIR_EraseRootFromParent_Done,
     /*  109021 */   // Label 1720: @109021
     /*  109021 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(109066), // Rule ID 51237 //
     /*  109026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109029 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  109032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  109046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109064 */     GIR_RootConstrainSelectedInstOperands,
     /*  109065 */     // GIR_Coverage, 51237,
     /*  109065 */     GIR_EraseRootFromParent_Done,
     /*  109066 */   // Label 1721: @109066
     /*  109066 */   GIM_Reject,
     /*  109067 */ // Label 1719: @109067
     /*  109067 */ GIM_Reject,
     /*  109068 */ // Label 1671: @109068
     /*  109068 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(109182),
     /*  109073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  109076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  109079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109091 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(109136), // Rule ID 51264 //
     /*  109096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109099 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  109102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  109116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109134 */     GIR_RootConstrainSelectedInstOperands,
     /*  109135 */     // GIR_Coverage, 51264,
     /*  109135 */     GIR_EraseRootFromParent_Done,
     /*  109136 */   // Label 1723: @109136
     /*  109136 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(109181), // Rule ID 51265 //
     /*  109141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109144 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  109147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  109161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109179 */     GIR_RootConstrainSelectedInstOperands,
     /*  109180 */     // GIR_Coverage, 51265,
     /*  109180 */     GIR_EraseRootFromParent_Done,
     /*  109181 */   // Label 1724: @109181
     /*  109181 */   GIM_Reject,
     /*  109182 */ // Label 1722: @109182
     /*  109182 */ GIM_Reject,
     /*  109183 */ // Label 1672: @109183
     /*  109183 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(109297),
     /*  109188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  109191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  109194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109206 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(109251), // Rule ID 51280 //
     /*  109211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109214 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  109217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  109231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109249 */     GIR_RootConstrainSelectedInstOperands,
     /*  109250 */     // GIR_Coverage, 51280,
     /*  109250 */     GIR_EraseRootFromParent_Done,
     /*  109251 */   // Label 1726: @109251
     /*  109251 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(109296), // Rule ID 51281 //
     /*  109256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109259 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  109262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  109276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109294 */     GIR_RootConstrainSelectedInstOperands,
     /*  109295 */     // GIR_Coverage, 51281,
     /*  109295 */     GIR_EraseRootFromParent_Done,
     /*  109296 */   // Label 1727: @109296
     /*  109296 */   GIM_Reject,
     /*  109297 */ // Label 1725: @109297
     /*  109297 */ GIM_Reject,
     /*  109298 */ // Label 1673: @109298
     /*  109298 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(109412),
     /*  109303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  109306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  109309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109321 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(109366), // Rule ID 51296 //
     /*  109326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  109329 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  109329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  109332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  109346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109364 */     GIR_RootConstrainSelectedInstOperands,
     /*  109365 */     // GIR_Coverage, 51296,
     /*  109365 */     GIR_EraseRootFromParent_Done,
     /*  109366 */   // Label 1729: @109366
     /*  109366 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(109411), // Rule ID 51297 //
     /*  109371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  109374 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  109374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  109377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  109391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109409 */     GIR_RootConstrainSelectedInstOperands,
     /*  109410 */     // GIR_Coverage, 51297,
     /*  109410 */     GIR_EraseRootFromParent_Done,
     /*  109411 */   // Label 1730: @109411
     /*  109411 */   GIM_Reject,
     /*  109412 */ // Label 1728: @109412
     /*  109412 */ GIM_Reject,
     /*  109413 */ // Label 1674: @109413
     /*  109413 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(109527),
     /*  109418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  109421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  109424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109436 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(109481), // Rule ID 51252 //
     /*  109441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109444 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  109447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  109461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109479 */     GIR_RootConstrainSelectedInstOperands,
     /*  109480 */     // GIR_Coverage, 51252,
     /*  109480 */     GIR_EraseRootFromParent_Done,
     /*  109481 */   // Label 1732: @109481
     /*  109481 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(109526), // Rule ID 51253 //
     /*  109486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109489 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  109492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  109506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109524 */     GIR_RootConstrainSelectedInstOperands,
     /*  109525 */     // GIR_Coverage, 51253,
     /*  109525 */     GIR_EraseRootFromParent_Done,
     /*  109526 */   // Label 1733: @109526
     /*  109526 */   GIM_Reject,
     /*  109527 */ // Label 1731: @109527
     /*  109527 */ GIM_Reject,
     /*  109528 */ // Label 1675: @109528
     /*  109528 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(109642),
     /*  109533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  109536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  109539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109551 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(109596), // Rule ID 51268 //
     /*  109556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109559 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  109562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  109576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109594 */     GIR_RootConstrainSelectedInstOperands,
     /*  109595 */     // GIR_Coverage, 51268,
     /*  109595 */     GIR_EraseRootFromParent_Done,
     /*  109596 */   // Label 1735: @109596
     /*  109596 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(109641), // Rule ID 51269 //
     /*  109601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109604 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  109607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  109621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109639 */     GIR_RootConstrainSelectedInstOperands,
     /*  109640 */     // GIR_Coverage, 51269,
     /*  109640 */     GIR_EraseRootFromParent_Done,
     /*  109641 */   // Label 1736: @109641
     /*  109641 */   GIM_Reject,
     /*  109642 */ // Label 1734: @109642
     /*  109642 */ GIM_Reject,
     /*  109643 */ // Label 1676: @109643
     /*  109643 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(109757),
     /*  109648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  109651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  109654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109666 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(109711), // Rule ID 51284 //
     /*  109671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109674 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  109677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  109691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109709 */     GIR_RootConstrainSelectedInstOperands,
     /*  109710 */     // GIR_Coverage, 51284,
     /*  109710 */     GIR_EraseRootFromParent_Done,
     /*  109711 */   // Label 1738: @109711
     /*  109711 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(109756), // Rule ID 51285 //
     /*  109716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109719 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  109722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  109736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109754 */     GIR_RootConstrainSelectedInstOperands,
     /*  109755 */     // GIR_Coverage, 51285,
     /*  109755 */     GIR_EraseRootFromParent_Done,
     /*  109756 */   // Label 1739: @109756
     /*  109756 */   GIM_Reject,
     /*  109757 */ // Label 1737: @109757
     /*  109757 */ GIM_Reject,
     /*  109758 */ // Label 1677: @109758
     /*  109758 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(109872),
     /*  109763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  109766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  109769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109781 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(109826), // Rule ID 51256 //
     /*  109786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109789 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  109792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  109806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109824 */     GIR_RootConstrainSelectedInstOperands,
     /*  109825 */     // GIR_Coverage, 51256,
     /*  109825 */     GIR_EraseRootFromParent_Done,
     /*  109826 */   // Label 1741: @109826
     /*  109826 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(109871), // Rule ID 51257 //
     /*  109831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109834 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  109837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  109851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109869 */     GIR_RootConstrainSelectedInstOperands,
     /*  109870 */     // GIR_Coverage, 51257,
     /*  109870 */     GIR_EraseRootFromParent_Done,
     /*  109871 */   // Label 1742: @109871
     /*  109871 */   GIM_Reject,
     /*  109872 */ // Label 1740: @109872
     /*  109872 */ GIM_Reject,
     /*  109873 */ // Label 1678: @109873
     /*  109873 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(109987),
     /*  109878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  109881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  109884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109896 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(109941), // Rule ID 51272 //
     /*  109901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109904 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  109907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  109921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109939 */     GIR_RootConstrainSelectedInstOperands,
     /*  109940 */     // GIR_Coverage, 51272,
     /*  109940 */     GIR_EraseRootFromParent_Done,
     /*  109941 */   // Label 1744: @109941
     /*  109941 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(109986), // Rule ID 51273 //
     /*  109946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109949 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  109952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  109966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109984 */     GIR_RootConstrainSelectedInstOperands,
     /*  109985 */     // GIR_Coverage, 51273,
     /*  109985 */     GIR_EraseRootFromParent_Done,
     /*  109986 */   // Label 1745: @109986
     /*  109986 */   GIM_Reject,
     /*  109987 */ // Label 1743: @109987
     /*  109987 */ GIM_Reject,
     /*  109988 */ // Label 1679: @109988
     /*  109988 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(110102),
     /*  109993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  109996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  109999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110011 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(110056), // Rule ID 51260 //
     /*  110016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110019 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  110022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  110036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110054 */     GIR_RootConstrainSelectedInstOperands,
     /*  110055 */     // GIR_Coverage, 51260,
     /*  110055 */     GIR_EraseRootFromParent_Done,
     /*  110056 */   // Label 1747: @110056
     /*  110056 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(110101), // Rule ID 51261 //
     /*  110061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110064 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  110067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  110081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110099 */     GIR_RootConstrainSelectedInstOperands,
     /*  110100 */     // GIR_Coverage, 51261,
     /*  110100 */     GIR_EraseRootFromParent_Done,
     /*  110101 */   // Label 1748: @110101
     /*  110101 */   GIM_Reject,
     /*  110102 */ // Label 1746: @110102
     /*  110102 */ GIM_Reject,
     /*  110103 */ // Label 1680: @110103
     /*  110103 */ GIM_Reject,
     /*  110104 */ // Label 4: @110104
     /*  110104 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1773*/ GIMT_Encode4(112837),
     /*  110115 */ /*GILLT_s32*//*Label 1749*/ GIMT_Encode4(110239),
     /*  110119 */ /*GILLT_s64*//*Label 1750*/ GIMT_Encode4(110273), GIMT_Encode4(0),
     /*  110127 */ /*GILLT_nxv1s8*//*Label 1751*/ GIMT_Encode4(110307),
     /*  110131 */ /*GILLT_nxv1s16*//*Label 1752*/ GIMT_Encode4(110422),
     /*  110135 */ /*GILLT_nxv1s32*//*Label 1753*/ GIMT_Encode4(110537),
     /*  110139 */ /*GILLT_nxv1s64*//*Label 1754*/ GIMT_Encode4(110652), GIMT_Encode4(0),
     /*  110147 */ /*GILLT_nxv2s8*//*Label 1755*/ GIMT_Encode4(110767),
     /*  110151 */ /*GILLT_nxv2s16*//*Label 1756*/ GIMT_Encode4(110882),
     /*  110155 */ /*GILLT_nxv2s32*//*Label 1757*/ GIMT_Encode4(110997),
     /*  110159 */ /*GILLT_nxv2s64*//*Label 1758*/ GIMT_Encode4(111112), GIMT_Encode4(0),
     /*  110167 */ /*GILLT_nxv4s8*//*Label 1759*/ GIMT_Encode4(111227),
     /*  110171 */ /*GILLT_nxv4s16*//*Label 1760*/ GIMT_Encode4(111342),
     /*  110175 */ /*GILLT_nxv4s32*//*Label 1761*/ GIMT_Encode4(111457),
     /*  110179 */ /*GILLT_nxv4s64*//*Label 1762*/ GIMT_Encode4(111572), GIMT_Encode4(0),
     /*  110187 */ /*GILLT_nxv8s8*//*Label 1763*/ GIMT_Encode4(111687),
     /*  110191 */ /*GILLT_nxv8s16*//*Label 1764*/ GIMT_Encode4(111802),
     /*  110195 */ /*GILLT_nxv8s32*//*Label 1765*/ GIMT_Encode4(111917),
     /*  110199 */ /*GILLT_nxv8s64*//*Label 1766*/ GIMT_Encode4(112032), GIMT_Encode4(0),
     /*  110207 */ /*GILLT_nxv16s8*//*Label 1767*/ GIMT_Encode4(112147),
     /*  110211 */ /*GILLT_nxv16s16*//*Label 1768*/ GIMT_Encode4(112262),
     /*  110215 */ /*GILLT_nxv16s32*//*Label 1769*/ GIMT_Encode4(112377), GIMT_Encode4(0),
     /*  110223 */ /*GILLT_nxv32s8*//*Label 1770*/ GIMT_Encode4(112492),
     /*  110227 */ /*GILLT_nxv32s16*//*Label 1771*/ GIMT_Encode4(112607), GIMT_Encode4(0),
     /*  110235 */ /*GILLT_nxv64s8*//*Label 1772*/ GIMT_Encode4(112722),
     /*  110239 */ // Label 1749: @110239
     /*  110239 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(110272), // Rule ID 312 //
     /*  110244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  110247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  110250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  110253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110265 */   // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIVU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  110270 */   GIR_RootConstrainSelectedInstOperands,
     /*  110271 */   // GIR_Coverage, 312,
     /*  110271 */   GIR_Done,
     /*  110272 */ // Label 1774: @110272
     /*  110272 */ GIM_Reject,
     /*  110273 */ // Label 1750: @110273
     /*  110273 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(110306), // Rule ID 311 //
     /*  110278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  110281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  110284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  110287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110299 */   // (udiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  110299 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  110304 */   GIR_RootConstrainSelectedInstOperands,
     /*  110305 */   // GIR_Coverage, 311,
     /*  110305 */   GIR_Done,
     /*  110306 */ // Label 1775: @110306
     /*  110306 */ GIM_Reject,
     /*  110307 */ // Label 1751: @110307
     /*  110307 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(110421),
     /*  110312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  110315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  110318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110330 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(110375), // Rule ID 51124 //
     /*  110335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110338 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  110341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  110355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110373 */     GIR_RootConstrainSelectedInstOperands,
     /*  110374 */     // GIR_Coverage, 51124,
     /*  110374 */     GIR_EraseRootFromParent_Done,
     /*  110375 */   // Label 1777: @110375
     /*  110375 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(110420), // Rule ID 51125 //
     /*  110380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110383 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  110386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  110400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110418 */     GIR_RootConstrainSelectedInstOperands,
     /*  110419 */     // GIR_Coverage, 51125,
     /*  110419 */     GIR_EraseRootFromParent_Done,
     /*  110420 */   // Label 1778: @110420
     /*  110420 */   GIM_Reject,
     /*  110421 */ // Label 1776: @110421
     /*  110421 */ GIM_Reject,
     /*  110422 */ // Label 1752: @110422
     /*  110422 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(110536),
     /*  110427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  110430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  110433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110445 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(110490), // Rule ID 51136 //
     /*  110450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110453 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  110456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  110470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110488 */     GIR_RootConstrainSelectedInstOperands,
     /*  110489 */     // GIR_Coverage, 51136,
     /*  110489 */     GIR_EraseRootFromParent_Done,
     /*  110490 */   // Label 1780: @110490
     /*  110490 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(110535), // Rule ID 51137 //
     /*  110495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110498 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  110501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  110515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110533 */     GIR_RootConstrainSelectedInstOperands,
     /*  110534 */     // GIR_Coverage, 51137,
     /*  110534 */     GIR_EraseRootFromParent_Done,
     /*  110535 */   // Label 1781: @110535
     /*  110535 */   GIM_Reject,
     /*  110536 */ // Label 1779: @110536
     /*  110536 */ GIM_Reject,
     /*  110537 */ // Label 1753: @110537
     /*  110537 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(110651),
     /*  110542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  110545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  110548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110560 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(110605), // Rule ID 51144 //
     /*  110565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110568 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  110568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  110571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  110585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110603 */     GIR_RootConstrainSelectedInstOperands,
     /*  110604 */     // GIR_Coverage, 51144,
     /*  110604 */     GIR_EraseRootFromParent_Done,
     /*  110605 */   // Label 1783: @110605
     /*  110605 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(110650), // Rule ID 51145 //
     /*  110610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110613 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  110613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  110616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  110630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110648 */     GIR_RootConstrainSelectedInstOperands,
     /*  110649 */     // GIR_Coverage, 51145,
     /*  110649 */     GIR_EraseRootFromParent_Done,
     /*  110650 */   // Label 1784: @110650
     /*  110650 */   GIM_Reject,
     /*  110651 */ // Label 1782: @110651
     /*  110651 */ GIM_Reject,
     /*  110652 */ // Label 1754: @110652
     /*  110652 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(110766),
     /*  110657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  110660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  110663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110675 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(110720), // Rule ID 51160 //
     /*  110680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  110683 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  110683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  110686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  110700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  110715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110718 */     GIR_RootConstrainSelectedInstOperands,
     /*  110719 */     // GIR_Coverage, 51160,
     /*  110719 */     GIR_EraseRootFromParent_Done,
     /*  110720 */   // Label 1786: @110720
     /*  110720 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(110765), // Rule ID 51161 //
     /*  110725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  110728 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  110728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  110731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  110745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  110760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110763 */     GIR_RootConstrainSelectedInstOperands,
     /*  110764 */     // GIR_Coverage, 51161,
     /*  110764 */     GIR_EraseRootFromParent_Done,
     /*  110765 */   // Label 1787: @110765
     /*  110765 */   GIM_Reject,
     /*  110766 */ // Label 1785: @110766
     /*  110766 */ GIM_Reject,
     /*  110767 */ // Label 1755: @110767
     /*  110767 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(110881),
     /*  110772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  110775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  110778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110786 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110790 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(110835), // Rule ID 51128 //
     /*  110795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110798 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  110801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  110815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110833 */     GIR_RootConstrainSelectedInstOperands,
     /*  110834 */     // GIR_Coverage, 51128,
     /*  110834 */     GIR_EraseRootFromParent_Done,
     /*  110835 */   // Label 1789: @110835
     /*  110835 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(110880), // Rule ID 51129 //
     /*  110840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110843 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  110846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  110860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110878 */     GIR_RootConstrainSelectedInstOperands,
     /*  110879 */     // GIR_Coverage, 51129,
     /*  110879 */     GIR_EraseRootFromParent_Done,
     /*  110880 */   // Label 1790: @110880
     /*  110880 */   GIM_Reject,
     /*  110881 */ // Label 1788: @110881
     /*  110881 */ GIM_Reject,
     /*  110882 */ // Label 1756: @110882
     /*  110882 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(110996),
     /*  110887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  110890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  110893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110905 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(110950), // Rule ID 51140 //
     /*  110910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110913 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  110916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  110930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110948 */     GIR_RootConstrainSelectedInstOperands,
     /*  110949 */     // GIR_Coverage, 51140,
     /*  110949 */     GIR_EraseRootFromParent_Done,
     /*  110950 */   // Label 1792: @110950
     /*  110950 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(110995), // Rule ID 51141 //
     /*  110955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110958 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  110961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  110975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110993 */     GIR_RootConstrainSelectedInstOperands,
     /*  110994 */     // GIR_Coverage, 51141,
     /*  110994 */     GIR_EraseRootFromParent_Done,
     /*  110995 */   // Label 1793: @110995
     /*  110995 */   GIM_Reject,
     /*  110996 */ // Label 1791: @110996
     /*  110996 */ GIM_Reject,
     /*  110997 */ // Label 1757: @110997
     /*  110997 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(111111),
     /*  111002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  111005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  111008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111020 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(111065), // Rule ID 51156 //
     /*  111025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111028 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  111031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  111045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111063 */     GIR_RootConstrainSelectedInstOperands,
     /*  111064 */     // GIR_Coverage, 51156,
     /*  111064 */     GIR_EraseRootFromParent_Done,
     /*  111065 */   // Label 1795: @111065
     /*  111065 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(111110), // Rule ID 51157 //
     /*  111070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111073 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  111076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  111090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111108 */     GIR_RootConstrainSelectedInstOperands,
     /*  111109 */     // GIR_Coverage, 51157,
     /*  111109 */     GIR_EraseRootFromParent_Done,
     /*  111110 */   // Label 1796: @111110
     /*  111110 */   GIM_Reject,
     /*  111111 */ // Label 1794: @111111
     /*  111111 */ GIM_Reject,
     /*  111112 */ // Label 1758: @111112
     /*  111112 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(111226),
     /*  111117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  111120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  111123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111131 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111135 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(111180), // Rule ID 51200 //
     /*  111140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  111143 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  111143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  111146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  111160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111178 */     GIR_RootConstrainSelectedInstOperands,
     /*  111179 */     // GIR_Coverage, 51200,
     /*  111179 */     GIR_EraseRootFromParent_Done,
     /*  111180 */   // Label 1798: @111180
     /*  111180 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(111225), // Rule ID 51201 //
     /*  111185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  111188 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  111188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  111191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  111205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111223 */     GIR_RootConstrainSelectedInstOperands,
     /*  111224 */     // GIR_Coverage, 51201,
     /*  111224 */     GIR_EraseRootFromParent_Done,
     /*  111225 */   // Label 1799: @111225
     /*  111225 */   GIM_Reject,
     /*  111226 */ // Label 1797: @111226
     /*  111226 */ GIM_Reject,
     /*  111227 */ // Label 1759: @111227
     /*  111227 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(111341),
     /*  111232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  111235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  111238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111250 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(111295), // Rule ID 51132 //
     /*  111255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111258 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  111261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  111275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111293 */     GIR_RootConstrainSelectedInstOperands,
     /*  111294 */     // GIR_Coverage, 51132,
     /*  111294 */     GIR_EraseRootFromParent_Done,
     /*  111295 */   // Label 1801: @111295
     /*  111295 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(111340), // Rule ID 51133 //
     /*  111300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111303 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  111306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  111320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111338 */     GIR_RootConstrainSelectedInstOperands,
     /*  111339 */     // GIR_Coverage, 51133,
     /*  111339 */     GIR_EraseRootFromParent_Done,
     /*  111340 */   // Label 1802: @111340
     /*  111340 */   GIM_Reject,
     /*  111341 */ // Label 1800: @111341
     /*  111341 */ GIM_Reject,
     /*  111342 */ // Label 1760: @111342
     /*  111342 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(111456),
     /*  111347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  111350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  111353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111365 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(111410), // Rule ID 51152 //
     /*  111370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111373 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  111376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  111390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111408 */     GIR_RootConstrainSelectedInstOperands,
     /*  111409 */     // GIR_Coverage, 51152,
     /*  111409 */     GIR_EraseRootFromParent_Done,
     /*  111410 */   // Label 1804: @111410
     /*  111410 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(111455), // Rule ID 51153 //
     /*  111415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111418 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  111421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  111435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111453 */     GIR_RootConstrainSelectedInstOperands,
     /*  111454 */     // GIR_Coverage, 51153,
     /*  111454 */     GIR_EraseRootFromParent_Done,
     /*  111455 */   // Label 1805: @111455
     /*  111455 */   GIM_Reject,
     /*  111456 */ // Label 1803: @111456
     /*  111456 */ GIM_Reject,
     /*  111457 */ // Label 1761: @111457
     /*  111457 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(111571),
     /*  111462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  111465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  111468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111480 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(111525), // Rule ID 51188 //
     /*  111485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111488 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  111491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  111505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111523 */     GIR_RootConstrainSelectedInstOperands,
     /*  111524 */     // GIR_Coverage, 51188,
     /*  111524 */     GIR_EraseRootFromParent_Done,
     /*  111525 */   // Label 1807: @111525
     /*  111525 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(111570), // Rule ID 51189 //
     /*  111530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111533 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  111536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  111550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111568 */     GIR_RootConstrainSelectedInstOperands,
     /*  111569 */     // GIR_Coverage, 51189,
     /*  111569 */     GIR_EraseRootFromParent_Done,
     /*  111570 */   // Label 1808: @111570
     /*  111570 */   GIM_Reject,
     /*  111571 */ // Label 1806: @111571
     /*  111571 */ GIM_Reject,
     /*  111572 */ // Label 1762: @111572
     /*  111572 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(111686),
     /*  111577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  111580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  111583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111595 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(111640), // Rule ID 51204 //
     /*  111600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  111603 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  111603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  111606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  111620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111638 */     GIR_RootConstrainSelectedInstOperands,
     /*  111639 */     // GIR_Coverage, 51204,
     /*  111639 */     GIR_EraseRootFromParent_Done,
     /*  111640 */   // Label 1810: @111640
     /*  111640 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(111685), // Rule ID 51205 //
     /*  111645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  111648 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  111648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  111651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  111665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111683 */     GIR_RootConstrainSelectedInstOperands,
     /*  111684 */     // GIR_Coverage, 51205,
     /*  111684 */     GIR_EraseRootFromParent_Done,
     /*  111685 */   // Label 1811: @111685
     /*  111685 */   GIM_Reject,
     /*  111686 */ // Label 1809: @111686
     /*  111686 */ GIM_Reject,
     /*  111687 */ // Label 1763: @111687
     /*  111687 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(111801),
     /*  111692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  111695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  111698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111710 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(111755), // Rule ID 51148 //
     /*  111715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111718 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  111721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  111735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111753 */     GIR_RootConstrainSelectedInstOperands,
     /*  111754 */     // GIR_Coverage, 51148,
     /*  111754 */     GIR_EraseRootFromParent_Done,
     /*  111755 */   // Label 1813: @111755
     /*  111755 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(111800), // Rule ID 51149 //
     /*  111760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111763 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  111766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  111780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111798 */     GIR_RootConstrainSelectedInstOperands,
     /*  111799 */     // GIR_Coverage, 51149,
     /*  111799 */     GIR_EraseRootFromParent_Done,
     /*  111800 */   // Label 1814: @111800
     /*  111800 */   GIM_Reject,
     /*  111801 */ // Label 1812: @111801
     /*  111801 */ GIM_Reject,
     /*  111802 */ // Label 1764: @111802
     /*  111802 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(111916),
     /*  111807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  111810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  111813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111825 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(111870), // Rule ID 51176 //
     /*  111830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111833 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  111836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  111850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111868 */     GIR_RootConstrainSelectedInstOperands,
     /*  111869 */     // GIR_Coverage, 51176,
     /*  111869 */     GIR_EraseRootFromParent_Done,
     /*  111870 */   // Label 1816: @111870
     /*  111870 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(111915), // Rule ID 51177 //
     /*  111875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111878 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  111881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  111895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111913 */     GIR_RootConstrainSelectedInstOperands,
     /*  111914 */     // GIR_Coverage, 51177,
     /*  111914 */     GIR_EraseRootFromParent_Done,
     /*  111915 */   // Label 1817: @111915
     /*  111915 */   GIM_Reject,
     /*  111916 */ // Label 1815: @111916
     /*  111916 */ GIM_Reject,
     /*  111917 */ // Label 1765: @111917
     /*  111917 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(112031),
     /*  111922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  111925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  111928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111940 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(111985), // Rule ID 51192 //
     /*  111945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111948 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  111951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  111965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111983 */     GIR_RootConstrainSelectedInstOperands,
     /*  111984 */     // GIR_Coverage, 51192,
     /*  111984 */     GIR_EraseRootFromParent_Done,
     /*  111985 */   // Label 1819: @111985
     /*  111985 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(112030), // Rule ID 51193 //
     /*  111990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111993 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  111996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  112010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112028 */     GIR_RootConstrainSelectedInstOperands,
     /*  112029 */     // GIR_Coverage, 51193,
     /*  112029 */     GIR_EraseRootFromParent_Done,
     /*  112030 */   // Label 1820: @112030
     /*  112030 */   GIM_Reject,
     /*  112031 */ // Label 1818: @112031
     /*  112031 */ GIM_Reject,
     /*  112032 */ // Label 1766: @112032
     /*  112032 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(112146),
     /*  112037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  112040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  112043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112055 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(112100), // Rule ID 51208 //
     /*  112060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  112063 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  112063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  112066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  112080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112098 */     GIR_RootConstrainSelectedInstOperands,
     /*  112099 */     // GIR_Coverage, 51208,
     /*  112099 */     GIR_EraseRootFromParent_Done,
     /*  112100 */   // Label 1822: @112100
     /*  112100 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(112145), // Rule ID 51209 //
     /*  112105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  112108 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  112108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  112111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  112125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112143 */     GIR_RootConstrainSelectedInstOperands,
     /*  112144 */     // GIR_Coverage, 51209,
     /*  112144 */     GIR_EraseRootFromParent_Done,
     /*  112145 */   // Label 1823: @112145
     /*  112145 */   GIM_Reject,
     /*  112146 */ // Label 1821: @112146
     /*  112146 */ GIM_Reject,
     /*  112147 */ // Label 1767: @112147
     /*  112147 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(112261),
     /*  112152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  112155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  112158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112170 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(112215), // Rule ID 51164 //
     /*  112175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112178 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  112181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  112195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112213 */     GIR_RootConstrainSelectedInstOperands,
     /*  112214 */     // GIR_Coverage, 51164,
     /*  112214 */     GIR_EraseRootFromParent_Done,
     /*  112215 */   // Label 1825: @112215
     /*  112215 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(112260), // Rule ID 51165 //
     /*  112220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112223 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  112226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  112240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112258 */     GIR_RootConstrainSelectedInstOperands,
     /*  112259 */     // GIR_Coverage, 51165,
     /*  112259 */     GIR_EraseRootFromParent_Done,
     /*  112260 */   // Label 1826: @112260
     /*  112260 */   GIM_Reject,
     /*  112261 */ // Label 1824: @112261
     /*  112261 */ GIM_Reject,
     /*  112262 */ // Label 1768: @112262
     /*  112262 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(112376),
     /*  112267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  112270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  112273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112285 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(112330), // Rule ID 51180 //
     /*  112290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112293 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  112296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  112310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112328 */     GIR_RootConstrainSelectedInstOperands,
     /*  112329 */     // GIR_Coverage, 51180,
     /*  112329 */     GIR_EraseRootFromParent_Done,
     /*  112330 */   // Label 1828: @112330
     /*  112330 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(112375), // Rule ID 51181 //
     /*  112335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112338 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  112341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  112355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112373 */     GIR_RootConstrainSelectedInstOperands,
     /*  112374 */     // GIR_Coverage, 51181,
     /*  112374 */     GIR_EraseRootFromParent_Done,
     /*  112375 */   // Label 1829: @112375
     /*  112375 */   GIM_Reject,
     /*  112376 */ // Label 1827: @112376
     /*  112376 */ GIM_Reject,
     /*  112377 */ // Label 1769: @112377
     /*  112377 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(112491),
     /*  112382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  112385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  112388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112400 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(112445), // Rule ID 51196 //
     /*  112405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112408 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  112408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  112411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  112425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112443 */     GIR_RootConstrainSelectedInstOperands,
     /*  112444 */     // GIR_Coverage, 51196,
     /*  112444 */     GIR_EraseRootFromParent_Done,
     /*  112445 */   // Label 1831: @112445
     /*  112445 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(112490), // Rule ID 51197 //
     /*  112450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112453 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  112453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  112456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  112470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112488 */     GIR_RootConstrainSelectedInstOperands,
     /*  112489 */     // GIR_Coverage, 51197,
     /*  112489 */     GIR_EraseRootFromParent_Done,
     /*  112490 */   // Label 1832: @112490
     /*  112490 */   GIM_Reject,
     /*  112491 */ // Label 1830: @112491
     /*  112491 */ GIM_Reject,
     /*  112492 */ // Label 1770: @112492
     /*  112492 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(112606),
     /*  112497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  112500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  112503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112515 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(112560), // Rule ID 51168 //
     /*  112520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112523 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  112526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  112540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112558 */     GIR_RootConstrainSelectedInstOperands,
     /*  112559 */     // GIR_Coverage, 51168,
     /*  112559 */     GIR_EraseRootFromParent_Done,
     /*  112560 */   // Label 1834: @112560
     /*  112560 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(112605), // Rule ID 51169 //
     /*  112565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112568 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  112571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  112585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112603 */     GIR_RootConstrainSelectedInstOperands,
     /*  112604 */     // GIR_Coverage, 51169,
     /*  112604 */     GIR_EraseRootFromParent_Done,
     /*  112605 */   // Label 1835: @112605
     /*  112605 */   GIM_Reject,
     /*  112606 */ // Label 1833: @112606
     /*  112606 */ GIM_Reject,
     /*  112607 */ // Label 1771: @112607
     /*  112607 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(112721),
     /*  112612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  112615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  112618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112626 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112630 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(112675), // Rule ID 51184 //
     /*  112635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112638 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  112641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  112655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112673 */     GIR_RootConstrainSelectedInstOperands,
     /*  112674 */     // GIR_Coverage, 51184,
     /*  112674 */     GIR_EraseRootFromParent_Done,
     /*  112675 */   // Label 1837: @112675
     /*  112675 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(112720), // Rule ID 51185 //
     /*  112680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112683 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  112686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  112700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112718 */     GIR_RootConstrainSelectedInstOperands,
     /*  112719 */     // GIR_Coverage, 51185,
     /*  112719 */     GIR_EraseRootFromParent_Done,
     /*  112720 */   // Label 1838: @112720
     /*  112720 */   GIM_Reject,
     /*  112721 */ // Label 1836: @112721
     /*  112721 */ GIM_Reject,
     /*  112722 */ // Label 1772: @112722
     /*  112722 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(112836),
     /*  112727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  112730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  112733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112745 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(112790), // Rule ID 51172 //
     /*  112750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112753 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  112756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  112770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112788 */     GIR_RootConstrainSelectedInstOperands,
     /*  112789 */     // GIR_Coverage, 51172,
     /*  112789 */     GIR_EraseRootFromParent_Done,
     /*  112790 */   // Label 1840: @112790
     /*  112790 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(112835), // Rule ID 51173 //
     /*  112795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112798 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  112801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  112815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112833 */     GIR_RootConstrainSelectedInstOperands,
     /*  112834 */     // GIR_Coverage, 51173,
     /*  112834 */     GIR_EraseRootFromParent_Done,
     /*  112835 */   // Label 1841: @112835
     /*  112835 */   GIM_Reject,
     /*  112836 */ // Label 1839: @112836
     /*  112836 */ GIM_Reject,
     /*  112837 */ // Label 1773: @112837
     /*  112837 */ GIM_Reject,
     /*  112838 */ // Label 5: @112838
     /*  112838 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1866*/ GIMT_Encode4(115616),
     /*  112849 */ /*GILLT_s32*//*Label 1842*/ GIMT_Encode4(112973),
     /*  112853 */ /*GILLT_s64*//*Label 1843*/ GIMT_Encode4(113007), GIMT_Encode4(0),
     /*  112861 */ /*GILLT_nxv1s8*//*Label 1844*/ GIMT_Encode4(113086),
     /*  112865 */ /*GILLT_nxv1s16*//*Label 1845*/ GIMT_Encode4(113201),
     /*  112869 */ /*GILLT_nxv1s32*//*Label 1846*/ GIMT_Encode4(113316),
     /*  112873 */ /*GILLT_nxv1s64*//*Label 1847*/ GIMT_Encode4(113431), GIMT_Encode4(0),
     /*  112881 */ /*GILLT_nxv2s8*//*Label 1848*/ GIMT_Encode4(113546),
     /*  112885 */ /*GILLT_nxv2s16*//*Label 1849*/ GIMT_Encode4(113661),
     /*  112889 */ /*GILLT_nxv2s32*//*Label 1850*/ GIMT_Encode4(113776),
     /*  112893 */ /*GILLT_nxv2s64*//*Label 1851*/ GIMT_Encode4(113891), GIMT_Encode4(0),
     /*  112901 */ /*GILLT_nxv4s8*//*Label 1852*/ GIMT_Encode4(114006),
     /*  112905 */ /*GILLT_nxv4s16*//*Label 1853*/ GIMT_Encode4(114121),
     /*  112909 */ /*GILLT_nxv4s32*//*Label 1854*/ GIMT_Encode4(114236),
     /*  112913 */ /*GILLT_nxv4s64*//*Label 1855*/ GIMT_Encode4(114351), GIMT_Encode4(0),
     /*  112921 */ /*GILLT_nxv8s8*//*Label 1856*/ GIMT_Encode4(114466),
     /*  112925 */ /*GILLT_nxv8s16*//*Label 1857*/ GIMT_Encode4(114581),
     /*  112929 */ /*GILLT_nxv8s32*//*Label 1858*/ GIMT_Encode4(114696),
     /*  112933 */ /*GILLT_nxv8s64*//*Label 1859*/ GIMT_Encode4(114811), GIMT_Encode4(0),
     /*  112941 */ /*GILLT_nxv16s8*//*Label 1860*/ GIMT_Encode4(114926),
     /*  112945 */ /*GILLT_nxv16s16*//*Label 1861*/ GIMT_Encode4(115041),
     /*  112949 */ /*GILLT_nxv16s32*//*Label 1862*/ GIMT_Encode4(115156), GIMT_Encode4(0),
     /*  112957 */ /*GILLT_nxv32s8*//*Label 1863*/ GIMT_Encode4(115271),
     /*  112961 */ /*GILLT_nxv32s16*//*Label 1864*/ GIMT_Encode4(115386), GIMT_Encode4(0),
     /*  112969 */ /*GILLT_nxv64s8*//*Label 1865*/ GIMT_Encode4(115501),
     /*  112973 */ // Label 1842: @112973
     /*  112973 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(113006), // Rule ID 314 //
     /*  112978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  112981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  112984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  112987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112999 */   // (srem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REM:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  112999 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  113004 */   GIR_RootConstrainSelectedInstOperands,
     /*  113005 */   // GIR_Coverage, 314,
     /*  113005 */   GIR_Done,
     /*  113006 */ // Label 1867: @113006
     /*  113006 */ GIM_Reject,
     /*  113007 */ // Label 1843: @113007
     /*  113007 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(113085),
     /*  113012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  113015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113022 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(113061), // Rule ID 323 //
     /*  113027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /*  113030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /*  113037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_sexti32),
     /*  113044 */     // (srem:{ *:[i64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (REMW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::REMW),
     /*  113047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  113054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  113059 */     GIR_RootConstrainSelectedInstOperands,
     /*  113060 */     // GIR_Coverage, 323,
     /*  113060 */     GIR_EraseRootFromParent_Done,
     /*  113061 */   // Label 1869: @113061
     /*  113061 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(113084), // Rule ID 313 //
     /*  113066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  113069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113077 */     // (srem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  113082 */     GIR_RootConstrainSelectedInstOperands,
     /*  113083 */     // GIR_Coverage, 313,
     /*  113083 */     GIR_Done,
     /*  113084 */   // Label 1870: @113084
     /*  113084 */   GIM_Reject,
     /*  113085 */ // Label 1868: @113085
     /*  113085 */ GIM_Reject,
     /*  113086 */ // Label 1844: @113086
     /*  113086 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(113200),
     /*  113091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  113094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  113097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113109 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(113154), // Rule ID 51388 //
     /*  113114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113117 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  113120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  113134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113152 */     GIR_RootConstrainSelectedInstOperands,
     /*  113153 */     // GIR_Coverage, 51388,
     /*  113153 */     GIR_EraseRootFromParent_Done,
     /*  113154 */   // Label 1872: @113154
     /*  113154 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(113199), // Rule ID 51389 //
     /*  113159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113162 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  113165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  113179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113197 */     GIR_RootConstrainSelectedInstOperands,
     /*  113198 */     // GIR_Coverage, 51389,
     /*  113198 */     GIR_EraseRootFromParent_Done,
     /*  113199 */   // Label 1873: @113199
     /*  113199 */   GIM_Reject,
     /*  113200 */ // Label 1871: @113200
     /*  113200 */ GIM_Reject,
     /*  113201 */ // Label 1845: @113201
     /*  113201 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(113315),
     /*  113206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  113209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  113212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113224 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(113269), // Rule ID 51400 //
     /*  113229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113232 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  113235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  113249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113267 */     GIR_RootConstrainSelectedInstOperands,
     /*  113268 */     // GIR_Coverage, 51400,
     /*  113268 */     GIR_EraseRootFromParent_Done,
     /*  113269 */   // Label 1875: @113269
     /*  113269 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(113314), // Rule ID 51401 //
     /*  113274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113277 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  113280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  113294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113312 */     GIR_RootConstrainSelectedInstOperands,
     /*  113313 */     // GIR_Coverage, 51401,
     /*  113313 */     GIR_EraseRootFromParent_Done,
     /*  113314 */   // Label 1876: @113314
     /*  113314 */   GIM_Reject,
     /*  113315 */ // Label 1874: @113315
     /*  113315 */ GIM_Reject,
     /*  113316 */ // Label 1846: @113316
     /*  113316 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(113430),
     /*  113321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  113324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  113327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113339 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(113384), // Rule ID 51408 //
     /*  113344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113347 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  113347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  113350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  113364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113382 */     GIR_RootConstrainSelectedInstOperands,
     /*  113383 */     // GIR_Coverage, 51408,
     /*  113383 */     GIR_EraseRootFromParent_Done,
     /*  113384 */   // Label 1878: @113384
     /*  113384 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(113429), // Rule ID 51409 //
     /*  113389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113392 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  113392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  113395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  113409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113427 */     GIR_RootConstrainSelectedInstOperands,
     /*  113428 */     // GIR_Coverage, 51409,
     /*  113428 */     GIR_EraseRootFromParent_Done,
     /*  113429 */   // Label 1879: @113429
     /*  113429 */   GIM_Reject,
     /*  113430 */ // Label 1877: @113430
     /*  113430 */ GIM_Reject,
     /*  113431 */ // Label 1847: @113431
     /*  113431 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(113545),
     /*  113436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  113439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  113442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113454 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(113499), // Rule ID 51424 //
     /*  113459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  113462 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  113462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  113465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  113479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113497 */     GIR_RootConstrainSelectedInstOperands,
     /*  113498 */     // GIR_Coverage, 51424,
     /*  113498 */     GIR_EraseRootFromParent_Done,
     /*  113499 */   // Label 1881: @113499
     /*  113499 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(113544), // Rule ID 51425 //
     /*  113504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  113507 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  113507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  113510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  113524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113542 */     GIR_RootConstrainSelectedInstOperands,
     /*  113543 */     // GIR_Coverage, 51425,
     /*  113543 */     GIR_EraseRootFromParent_Done,
     /*  113544 */   // Label 1882: @113544
     /*  113544 */   GIM_Reject,
     /*  113545 */ // Label 1880: @113545
     /*  113545 */ GIM_Reject,
     /*  113546 */ // Label 1848: @113546
     /*  113546 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(113660),
     /*  113551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  113554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  113557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113569 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(113614), // Rule ID 51392 //
     /*  113574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113577 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  113580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  113594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113612 */     GIR_RootConstrainSelectedInstOperands,
     /*  113613 */     // GIR_Coverage, 51392,
     /*  113613 */     GIR_EraseRootFromParent_Done,
     /*  113614 */   // Label 1884: @113614
     /*  113614 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(113659), // Rule ID 51393 //
     /*  113619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113622 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  113625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  113639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113657 */     GIR_RootConstrainSelectedInstOperands,
     /*  113658 */     // GIR_Coverage, 51393,
     /*  113658 */     GIR_EraseRootFromParent_Done,
     /*  113659 */   // Label 1885: @113659
     /*  113659 */   GIM_Reject,
     /*  113660 */ // Label 1883: @113660
     /*  113660 */ GIM_Reject,
     /*  113661 */ // Label 1849: @113661
     /*  113661 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(113775),
     /*  113666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  113669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  113672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113684 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(113729), // Rule ID 51404 //
     /*  113689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113692 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  113695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  113709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113727 */     GIR_RootConstrainSelectedInstOperands,
     /*  113728 */     // GIR_Coverage, 51404,
     /*  113728 */     GIR_EraseRootFromParent_Done,
     /*  113729 */   // Label 1887: @113729
     /*  113729 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(113774), // Rule ID 51405 //
     /*  113734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113737 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  113740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  113754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113772 */     GIR_RootConstrainSelectedInstOperands,
     /*  113773 */     // GIR_Coverage, 51405,
     /*  113773 */     GIR_EraseRootFromParent_Done,
     /*  113774 */   // Label 1888: @113774
     /*  113774 */   GIM_Reject,
     /*  113775 */ // Label 1886: @113775
     /*  113775 */ GIM_Reject,
     /*  113776 */ // Label 1850: @113776
     /*  113776 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(113890),
     /*  113781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  113784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  113787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113795 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113799 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(113844), // Rule ID 51420 //
     /*  113804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113807 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  113807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  113810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  113824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113842 */     GIR_RootConstrainSelectedInstOperands,
     /*  113843 */     // GIR_Coverage, 51420,
     /*  113843 */     GIR_EraseRootFromParent_Done,
     /*  113844 */   // Label 1890: @113844
     /*  113844 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(113889), // Rule ID 51421 //
     /*  113849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113852 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  113852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  113855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  113869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113887 */     GIR_RootConstrainSelectedInstOperands,
     /*  113888 */     // GIR_Coverage, 51421,
     /*  113888 */     GIR_EraseRootFromParent_Done,
     /*  113889 */   // Label 1891: @113889
     /*  113889 */   GIM_Reject,
     /*  113890 */ // Label 1889: @113890
     /*  113890 */ GIM_Reject,
     /*  113891 */ // Label 1851: @113891
     /*  113891 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(114005),
     /*  113896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  113899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  113902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113914 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(113959), // Rule ID 51464 //
     /*  113919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  113922 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  113922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  113925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  113939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113957 */     GIR_RootConstrainSelectedInstOperands,
     /*  113958 */     // GIR_Coverage, 51464,
     /*  113958 */     GIR_EraseRootFromParent_Done,
     /*  113959 */   // Label 1893: @113959
     /*  113959 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(114004), // Rule ID 51465 //
     /*  113964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  113967 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  113967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  113970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  113984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114002 */     GIR_RootConstrainSelectedInstOperands,
     /*  114003 */     // GIR_Coverage, 51465,
     /*  114003 */     GIR_EraseRootFromParent_Done,
     /*  114004 */   // Label 1894: @114004
     /*  114004 */   GIM_Reject,
     /*  114005 */ // Label 1892: @114005
     /*  114005 */ GIM_Reject,
     /*  114006 */ // Label 1852: @114006
     /*  114006 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(114120),
     /*  114011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  114014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  114017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114025 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114029 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(114074), // Rule ID 51396 //
     /*  114034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114037 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  114040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  114054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114072 */     GIR_RootConstrainSelectedInstOperands,
     /*  114073 */     // GIR_Coverage, 51396,
     /*  114073 */     GIR_EraseRootFromParent_Done,
     /*  114074 */   // Label 1896: @114074
     /*  114074 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(114119), // Rule ID 51397 //
     /*  114079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114082 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  114085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  114099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114117 */     GIR_RootConstrainSelectedInstOperands,
     /*  114118 */     // GIR_Coverage, 51397,
     /*  114118 */     GIR_EraseRootFromParent_Done,
     /*  114119 */   // Label 1897: @114119
     /*  114119 */   GIM_Reject,
     /*  114120 */ // Label 1895: @114120
     /*  114120 */ GIM_Reject,
     /*  114121 */ // Label 1853: @114121
     /*  114121 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(114235),
     /*  114126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  114129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  114132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114144 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(114189), // Rule ID 51416 //
     /*  114149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114152 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  114152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  114155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  114169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114187 */     GIR_RootConstrainSelectedInstOperands,
     /*  114188 */     // GIR_Coverage, 51416,
     /*  114188 */     GIR_EraseRootFromParent_Done,
     /*  114189 */   // Label 1899: @114189
     /*  114189 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(114234), // Rule ID 51417 //
     /*  114194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114197 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  114197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  114200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  114214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114232 */     GIR_RootConstrainSelectedInstOperands,
     /*  114233 */     // GIR_Coverage, 51417,
     /*  114233 */     GIR_EraseRootFromParent_Done,
     /*  114234 */   // Label 1900: @114234
     /*  114234 */   GIM_Reject,
     /*  114235 */ // Label 1898: @114235
     /*  114235 */ GIM_Reject,
     /*  114236 */ // Label 1854: @114236
     /*  114236 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(114350),
     /*  114241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  114244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  114247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114259 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(114304), // Rule ID 51452 //
     /*  114264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114267 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  114267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  114270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  114284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114302 */     GIR_RootConstrainSelectedInstOperands,
     /*  114303 */     // GIR_Coverage, 51452,
     /*  114303 */     GIR_EraseRootFromParent_Done,
     /*  114304 */   // Label 1902: @114304
     /*  114304 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(114349), // Rule ID 51453 //
     /*  114309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114312 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  114312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  114315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  114329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114347 */     GIR_RootConstrainSelectedInstOperands,
     /*  114348 */     // GIR_Coverage, 51453,
     /*  114348 */     GIR_EraseRootFromParent_Done,
     /*  114349 */   // Label 1903: @114349
     /*  114349 */   GIM_Reject,
     /*  114350 */ // Label 1901: @114350
     /*  114350 */ GIM_Reject,
     /*  114351 */ // Label 1855: @114351
     /*  114351 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(114465),
     /*  114356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  114359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  114362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114370 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114374 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(114419), // Rule ID 51468 //
     /*  114379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  114382 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  114382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  114385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  114399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114417 */     GIR_RootConstrainSelectedInstOperands,
     /*  114418 */     // GIR_Coverage, 51468,
     /*  114418 */     GIR_EraseRootFromParent_Done,
     /*  114419 */   // Label 1905: @114419
     /*  114419 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(114464), // Rule ID 51469 //
     /*  114424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  114427 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  114427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  114430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  114444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114462 */     GIR_RootConstrainSelectedInstOperands,
     /*  114463 */     // GIR_Coverage, 51469,
     /*  114463 */     GIR_EraseRootFromParent_Done,
     /*  114464 */   // Label 1906: @114464
     /*  114464 */   GIM_Reject,
     /*  114465 */ // Label 1904: @114465
     /*  114465 */ GIM_Reject,
     /*  114466 */ // Label 1856: @114466
     /*  114466 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(114580),
     /*  114471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  114474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  114477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114489 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(114534), // Rule ID 51412 //
     /*  114494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114497 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  114500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  114514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114532 */     GIR_RootConstrainSelectedInstOperands,
     /*  114533 */     // GIR_Coverage, 51412,
     /*  114533 */     GIR_EraseRootFromParent_Done,
     /*  114534 */   // Label 1908: @114534
     /*  114534 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(114579), // Rule ID 51413 //
     /*  114539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114542 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  114545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  114559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114577 */     GIR_RootConstrainSelectedInstOperands,
     /*  114578 */     // GIR_Coverage, 51413,
     /*  114578 */     GIR_EraseRootFromParent_Done,
     /*  114579 */   // Label 1909: @114579
     /*  114579 */   GIM_Reject,
     /*  114580 */ // Label 1907: @114580
     /*  114580 */ GIM_Reject,
     /*  114581 */ // Label 1857: @114581
     /*  114581 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(114695),
     /*  114586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  114589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  114592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114604 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(114649), // Rule ID 51440 //
     /*  114609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114612 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  114612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  114615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  114629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114647 */     GIR_RootConstrainSelectedInstOperands,
     /*  114648 */     // GIR_Coverage, 51440,
     /*  114648 */     GIR_EraseRootFromParent_Done,
     /*  114649 */   // Label 1911: @114649
     /*  114649 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(114694), // Rule ID 51441 //
     /*  114654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114657 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  114657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  114660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  114674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114692 */     GIR_RootConstrainSelectedInstOperands,
     /*  114693 */     // GIR_Coverage, 51441,
     /*  114693 */     GIR_EraseRootFromParent_Done,
     /*  114694 */   // Label 1912: @114694
     /*  114694 */   GIM_Reject,
     /*  114695 */ // Label 1910: @114695
     /*  114695 */ GIM_Reject,
     /*  114696 */ // Label 1858: @114696
     /*  114696 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(114810),
     /*  114701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  114704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  114707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114719 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(114764), // Rule ID 51456 //
     /*  114724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114727 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  114727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  114730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  114744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114762 */     GIR_RootConstrainSelectedInstOperands,
     /*  114763 */     // GIR_Coverage, 51456,
     /*  114763 */     GIR_EraseRootFromParent_Done,
     /*  114764 */   // Label 1914: @114764
     /*  114764 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(114809), // Rule ID 51457 //
     /*  114769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114772 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  114772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  114775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  114789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114807 */     GIR_RootConstrainSelectedInstOperands,
     /*  114808 */     // GIR_Coverage, 51457,
     /*  114808 */     GIR_EraseRootFromParent_Done,
     /*  114809 */   // Label 1915: @114809
     /*  114809 */   GIM_Reject,
     /*  114810 */ // Label 1913: @114810
     /*  114810 */ GIM_Reject,
     /*  114811 */ // Label 1859: @114811
     /*  114811 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(114925),
     /*  114816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  114819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  114822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114834 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(114879), // Rule ID 51472 //
     /*  114839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  114842 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  114842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  114845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  114859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114877 */     GIR_RootConstrainSelectedInstOperands,
     /*  114878 */     // GIR_Coverage, 51472,
     /*  114878 */     GIR_EraseRootFromParent_Done,
     /*  114879 */   // Label 1917: @114879
     /*  114879 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(114924), // Rule ID 51473 //
     /*  114884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  114887 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  114887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  114890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  114904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114922 */     GIR_RootConstrainSelectedInstOperands,
     /*  114923 */     // GIR_Coverage, 51473,
     /*  114923 */     GIR_EraseRootFromParent_Done,
     /*  114924 */   // Label 1918: @114924
     /*  114924 */   GIM_Reject,
     /*  114925 */ // Label 1916: @114925
     /*  114925 */ GIM_Reject,
     /*  114926 */ // Label 1860: @114926
     /*  114926 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(115040),
     /*  114931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  114934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  114937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114949 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(114994), // Rule ID 51428 //
     /*  114954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114957 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  114960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  114974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114992 */     GIR_RootConstrainSelectedInstOperands,
     /*  114993 */     // GIR_Coverage, 51428,
     /*  114993 */     GIR_EraseRootFromParent_Done,
     /*  114994 */   // Label 1920: @114994
     /*  114994 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(115039), // Rule ID 51429 //
     /*  114999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115002 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  115005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  115019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115037 */     GIR_RootConstrainSelectedInstOperands,
     /*  115038 */     // GIR_Coverage, 51429,
     /*  115038 */     GIR_EraseRootFromParent_Done,
     /*  115039 */   // Label 1921: @115039
     /*  115039 */   GIM_Reject,
     /*  115040 */ // Label 1919: @115040
     /*  115040 */ GIM_Reject,
     /*  115041 */ // Label 1861: @115041
     /*  115041 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(115155),
     /*  115046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  115049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  115052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115064 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(115109), // Rule ID 51444 //
     /*  115069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115072 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  115075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  115089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115107 */     GIR_RootConstrainSelectedInstOperands,
     /*  115108 */     // GIR_Coverage, 51444,
     /*  115108 */     GIR_EraseRootFromParent_Done,
     /*  115109 */   // Label 1923: @115109
     /*  115109 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(115154), // Rule ID 51445 //
     /*  115114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115117 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  115120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  115134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115152 */     GIR_RootConstrainSelectedInstOperands,
     /*  115153 */     // GIR_Coverage, 51445,
     /*  115153 */     GIR_EraseRootFromParent_Done,
     /*  115154 */   // Label 1924: @115154
     /*  115154 */   GIM_Reject,
     /*  115155 */ // Label 1922: @115155
     /*  115155 */ GIM_Reject,
     /*  115156 */ // Label 1862: @115156
     /*  115156 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(115270),
     /*  115161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  115164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  115167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115179 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(115224), // Rule ID 51460 //
     /*  115184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115187 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  115187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  115190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  115204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115222 */     GIR_RootConstrainSelectedInstOperands,
     /*  115223 */     // GIR_Coverage, 51460,
     /*  115223 */     GIR_EraseRootFromParent_Done,
     /*  115224 */   // Label 1926: @115224
     /*  115224 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(115269), // Rule ID 51461 //
     /*  115229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115232 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  115232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  115235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  115249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115267 */     GIR_RootConstrainSelectedInstOperands,
     /*  115268 */     // GIR_Coverage, 51461,
     /*  115268 */     GIR_EraseRootFromParent_Done,
     /*  115269 */   // Label 1927: @115269
     /*  115269 */   GIM_Reject,
     /*  115270 */ // Label 1925: @115270
     /*  115270 */ GIM_Reject,
     /*  115271 */ // Label 1863: @115271
     /*  115271 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(115385),
     /*  115276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  115279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  115282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115294 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(115339), // Rule ID 51432 //
     /*  115299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115302 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  115305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  115319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115337 */     GIR_RootConstrainSelectedInstOperands,
     /*  115338 */     // GIR_Coverage, 51432,
     /*  115338 */     GIR_EraseRootFromParent_Done,
     /*  115339 */   // Label 1929: @115339
     /*  115339 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(115384), // Rule ID 51433 //
     /*  115344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115347 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  115350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  115364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115382 */     GIR_RootConstrainSelectedInstOperands,
     /*  115383 */     // GIR_Coverage, 51433,
     /*  115383 */     GIR_EraseRootFromParent_Done,
     /*  115384 */   // Label 1930: @115384
     /*  115384 */   GIM_Reject,
     /*  115385 */ // Label 1928: @115385
     /*  115385 */ GIM_Reject,
     /*  115386 */ // Label 1864: @115386
     /*  115386 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(115500),
     /*  115391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  115394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  115397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115409 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(115454), // Rule ID 51448 //
     /*  115414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115417 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  115420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  115434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115452 */     GIR_RootConstrainSelectedInstOperands,
     /*  115453 */     // GIR_Coverage, 51448,
     /*  115453 */     GIR_EraseRootFromParent_Done,
     /*  115454 */   // Label 1932: @115454
     /*  115454 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(115499), // Rule ID 51449 //
     /*  115459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115462 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  115465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  115479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115497 */     GIR_RootConstrainSelectedInstOperands,
     /*  115498 */     // GIR_Coverage, 51449,
     /*  115498 */     GIR_EraseRootFromParent_Done,
     /*  115499 */   // Label 1933: @115499
     /*  115499 */   GIM_Reject,
     /*  115500 */ // Label 1931: @115500
     /*  115500 */ GIM_Reject,
     /*  115501 */ // Label 1865: @115501
     /*  115501 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(115615),
     /*  115506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  115509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  115512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115524 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(115569), // Rule ID 51436 //
     /*  115529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115532 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  115535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  115549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115567 */     GIR_RootConstrainSelectedInstOperands,
     /*  115568 */     // GIR_Coverage, 51436,
     /*  115568 */     GIR_EraseRootFromParent_Done,
     /*  115569 */   // Label 1935: @115569
     /*  115569 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(115614), // Rule ID 51437 //
     /*  115574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115577 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  115580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  115594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115612 */     GIR_RootConstrainSelectedInstOperands,
     /*  115613 */     // GIR_Coverage, 51437,
     /*  115613 */     GIR_EraseRootFromParent_Done,
     /*  115614 */   // Label 1936: @115614
     /*  115614 */   GIM_Reject,
     /*  115615 */ // Label 1934: @115615
     /*  115615 */ GIM_Reject,
     /*  115616 */ // Label 1866: @115616
     /*  115616 */ GIM_Reject,
     /*  115617 */ // Label 6: @115617
     /*  115617 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1961*/ GIMT_Encode4(118350),
     /*  115628 */ /*GILLT_s32*//*Label 1937*/ GIMT_Encode4(115752),
     /*  115632 */ /*GILLT_s64*//*Label 1938*/ GIMT_Encode4(115786), GIMT_Encode4(0),
     /*  115640 */ /*GILLT_nxv1s8*//*Label 1939*/ GIMT_Encode4(115820),
     /*  115644 */ /*GILLT_nxv1s16*//*Label 1940*/ GIMT_Encode4(115935),
     /*  115648 */ /*GILLT_nxv1s32*//*Label 1941*/ GIMT_Encode4(116050),
     /*  115652 */ /*GILLT_nxv1s64*//*Label 1942*/ GIMT_Encode4(116165), GIMT_Encode4(0),
     /*  115660 */ /*GILLT_nxv2s8*//*Label 1943*/ GIMT_Encode4(116280),
     /*  115664 */ /*GILLT_nxv2s16*//*Label 1944*/ GIMT_Encode4(116395),
     /*  115668 */ /*GILLT_nxv2s32*//*Label 1945*/ GIMT_Encode4(116510),
     /*  115672 */ /*GILLT_nxv2s64*//*Label 1946*/ GIMT_Encode4(116625), GIMT_Encode4(0),
     /*  115680 */ /*GILLT_nxv4s8*//*Label 1947*/ GIMT_Encode4(116740),
     /*  115684 */ /*GILLT_nxv4s16*//*Label 1948*/ GIMT_Encode4(116855),
     /*  115688 */ /*GILLT_nxv4s32*//*Label 1949*/ GIMT_Encode4(116970),
     /*  115692 */ /*GILLT_nxv4s64*//*Label 1950*/ GIMT_Encode4(117085), GIMT_Encode4(0),
     /*  115700 */ /*GILLT_nxv8s8*//*Label 1951*/ GIMT_Encode4(117200),
     /*  115704 */ /*GILLT_nxv8s16*//*Label 1952*/ GIMT_Encode4(117315),
     /*  115708 */ /*GILLT_nxv8s32*//*Label 1953*/ GIMT_Encode4(117430),
     /*  115712 */ /*GILLT_nxv8s64*//*Label 1954*/ GIMT_Encode4(117545), GIMT_Encode4(0),
     /*  115720 */ /*GILLT_nxv16s8*//*Label 1955*/ GIMT_Encode4(117660),
     /*  115724 */ /*GILLT_nxv16s16*//*Label 1956*/ GIMT_Encode4(117775),
     /*  115728 */ /*GILLT_nxv16s32*//*Label 1957*/ GIMT_Encode4(117890), GIMT_Encode4(0),
     /*  115736 */ /*GILLT_nxv32s8*//*Label 1958*/ GIMT_Encode4(118005),
     /*  115740 */ /*GILLT_nxv32s16*//*Label 1959*/ GIMT_Encode4(118120), GIMT_Encode4(0),
     /*  115748 */ /*GILLT_nxv64s8*//*Label 1960*/ GIMT_Encode4(118235),
     /*  115752 */ // Label 1937: @115752
     /*  115752 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(115785), // Rule ID 316 //
     /*  115757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  115760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  115763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  115766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115778 */   // (urem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REMU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  115778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  115783 */   GIR_RootConstrainSelectedInstOperands,
     /*  115784 */   // GIR_Coverage, 316,
     /*  115784 */   GIR_Done,
     /*  115785 */ // Label 1962: @115785
     /*  115785 */ GIM_Reject,
     /*  115786 */ // Label 1938: @115786
     /*  115786 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(115819), // Rule ID 315 //
     /*  115791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  115794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  115797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  115800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115812 */   // (urem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  115812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  115817 */   GIR_RootConstrainSelectedInstOperands,
     /*  115818 */   // GIR_Coverage, 315,
     /*  115818 */   GIR_Done,
     /*  115819 */ // Label 1963: @115819
     /*  115819 */ GIM_Reject,
     /*  115820 */ // Label 1939: @115820
     /*  115820 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(115934),
     /*  115825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  115828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  115831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115843 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(115888), // Rule ID 51300 //
     /*  115848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115851 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  115854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  115868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115886 */     GIR_RootConstrainSelectedInstOperands,
     /*  115887 */     // GIR_Coverage, 51300,
     /*  115887 */     GIR_EraseRootFromParent_Done,
     /*  115888 */   // Label 1965: @115888
     /*  115888 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(115933), // Rule ID 51301 //
     /*  115893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115896 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  115899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  115913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115931 */     GIR_RootConstrainSelectedInstOperands,
     /*  115932 */     // GIR_Coverage, 51301,
     /*  115932 */     GIR_EraseRootFromParent_Done,
     /*  115933 */   // Label 1966: @115933
     /*  115933 */   GIM_Reject,
     /*  115934 */ // Label 1964: @115934
     /*  115934 */ GIM_Reject,
     /*  115935 */ // Label 1940: @115935
     /*  115935 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(116049),
     /*  115940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  115943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  115946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115958 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(116003), // Rule ID 51312 //
     /*  115963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115966 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  115969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  115983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116001 */     GIR_RootConstrainSelectedInstOperands,
     /*  116002 */     // GIR_Coverage, 51312,
     /*  116002 */     GIR_EraseRootFromParent_Done,
     /*  116003 */   // Label 1968: @116003
     /*  116003 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(116048), // Rule ID 51313 //
     /*  116008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116011 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  116011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  116014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  116028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116046 */     GIR_RootConstrainSelectedInstOperands,
     /*  116047 */     // GIR_Coverage, 51313,
     /*  116047 */     GIR_EraseRootFromParent_Done,
     /*  116048 */   // Label 1969: @116048
     /*  116048 */   GIM_Reject,
     /*  116049 */ // Label 1967: @116049
     /*  116049 */ GIM_Reject,
     /*  116050 */ // Label 1941: @116050
     /*  116050 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(116164),
     /*  116055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  116058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  116061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116073 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(116118), // Rule ID 51320 //
     /*  116078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116081 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  116084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  116098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116116 */     GIR_RootConstrainSelectedInstOperands,
     /*  116117 */     // GIR_Coverage, 51320,
     /*  116117 */     GIR_EraseRootFromParent_Done,
     /*  116118 */   // Label 1971: @116118
     /*  116118 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(116163), // Rule ID 51321 //
     /*  116123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116126 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  116126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  116129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  116143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116161 */     GIR_RootConstrainSelectedInstOperands,
     /*  116162 */     // GIR_Coverage, 51321,
     /*  116162 */     GIR_EraseRootFromParent_Done,
     /*  116163 */   // Label 1972: @116163
     /*  116163 */   GIM_Reject,
     /*  116164 */ // Label 1970: @116164
     /*  116164 */ GIM_Reject,
     /*  116165 */ // Label 1942: @116165
     /*  116165 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(116279),
     /*  116170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  116173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  116176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116188 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(116233), // Rule ID 51336 //
     /*  116193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  116196 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  116196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  116199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  116213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116231 */     GIR_RootConstrainSelectedInstOperands,
     /*  116232 */     // GIR_Coverage, 51336,
     /*  116232 */     GIR_EraseRootFromParent_Done,
     /*  116233 */   // Label 1974: @116233
     /*  116233 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(116278), // Rule ID 51337 //
     /*  116238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  116241 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  116241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  116244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  116258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116276 */     GIR_RootConstrainSelectedInstOperands,
     /*  116277 */     // GIR_Coverage, 51337,
     /*  116277 */     GIR_EraseRootFromParent_Done,
     /*  116278 */   // Label 1975: @116278
     /*  116278 */   GIM_Reject,
     /*  116279 */ // Label 1973: @116279
     /*  116279 */ GIM_Reject,
     /*  116280 */ // Label 1943: @116280
     /*  116280 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(116394),
     /*  116285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  116288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  116291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116303 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(116348), // Rule ID 51304 //
     /*  116308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116311 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  116311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  116314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  116328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116346 */     GIR_RootConstrainSelectedInstOperands,
     /*  116347 */     // GIR_Coverage, 51304,
     /*  116347 */     GIR_EraseRootFromParent_Done,
     /*  116348 */   // Label 1977: @116348
     /*  116348 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(116393), // Rule ID 51305 //
     /*  116353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116356 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  116359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  116373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116391 */     GIR_RootConstrainSelectedInstOperands,
     /*  116392 */     // GIR_Coverage, 51305,
     /*  116392 */     GIR_EraseRootFromParent_Done,
     /*  116393 */   // Label 1978: @116393
     /*  116393 */   GIM_Reject,
     /*  116394 */ // Label 1976: @116394
     /*  116394 */ GIM_Reject,
     /*  116395 */ // Label 1944: @116395
     /*  116395 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(116509),
     /*  116400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  116403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  116406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116418 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(116463), // Rule ID 51316 //
     /*  116423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116426 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  116426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  116429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  116443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116461 */     GIR_RootConstrainSelectedInstOperands,
     /*  116462 */     // GIR_Coverage, 51316,
     /*  116462 */     GIR_EraseRootFromParent_Done,
     /*  116463 */   // Label 1980: @116463
     /*  116463 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(116508), // Rule ID 51317 //
     /*  116468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116471 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  116471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  116474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  116488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116506 */     GIR_RootConstrainSelectedInstOperands,
     /*  116507 */     // GIR_Coverage, 51317,
     /*  116507 */     GIR_EraseRootFromParent_Done,
     /*  116508 */   // Label 1981: @116508
     /*  116508 */   GIM_Reject,
     /*  116509 */ // Label 1979: @116509
     /*  116509 */ GIM_Reject,
     /*  116510 */ // Label 1945: @116510
     /*  116510 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(116624),
     /*  116515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  116518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  116521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116533 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(116578), // Rule ID 51332 //
     /*  116538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116541 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  116544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  116558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116576 */     GIR_RootConstrainSelectedInstOperands,
     /*  116577 */     // GIR_Coverage, 51332,
     /*  116577 */     GIR_EraseRootFromParent_Done,
     /*  116578 */   // Label 1983: @116578
     /*  116578 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(116623), // Rule ID 51333 //
     /*  116583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116586 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  116586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  116589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  116603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116621 */     GIR_RootConstrainSelectedInstOperands,
     /*  116622 */     // GIR_Coverage, 51333,
     /*  116622 */     GIR_EraseRootFromParent_Done,
     /*  116623 */   // Label 1984: @116623
     /*  116623 */   GIM_Reject,
     /*  116624 */ // Label 1982: @116624
     /*  116624 */ GIM_Reject,
     /*  116625 */ // Label 1946: @116625
     /*  116625 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(116739),
     /*  116630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  116633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  116636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116648 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(116693), // Rule ID 51376 //
     /*  116653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  116656 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  116656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  116659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  116673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116691 */     GIR_RootConstrainSelectedInstOperands,
     /*  116692 */     // GIR_Coverage, 51376,
     /*  116692 */     GIR_EraseRootFromParent_Done,
     /*  116693 */   // Label 1986: @116693
     /*  116693 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(116738), // Rule ID 51377 //
     /*  116698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  116701 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  116701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  116704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  116718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116736 */     GIR_RootConstrainSelectedInstOperands,
     /*  116737 */     // GIR_Coverage, 51377,
     /*  116737 */     GIR_EraseRootFromParent_Done,
     /*  116738 */   // Label 1987: @116738
     /*  116738 */   GIM_Reject,
     /*  116739 */ // Label 1985: @116739
     /*  116739 */ GIM_Reject,
     /*  116740 */ // Label 1947: @116740
     /*  116740 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(116854),
     /*  116745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  116748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  116751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116763 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(116808), // Rule ID 51308 //
     /*  116768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116771 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  116771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  116774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  116788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116806 */     GIR_RootConstrainSelectedInstOperands,
     /*  116807 */     // GIR_Coverage, 51308,
     /*  116807 */     GIR_EraseRootFromParent_Done,
     /*  116808 */   // Label 1989: @116808
     /*  116808 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(116853), // Rule ID 51309 //
     /*  116813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116816 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  116819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  116833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116851 */     GIR_RootConstrainSelectedInstOperands,
     /*  116852 */     // GIR_Coverage, 51309,
     /*  116852 */     GIR_EraseRootFromParent_Done,
     /*  116853 */   // Label 1990: @116853
     /*  116853 */   GIM_Reject,
     /*  116854 */ // Label 1988: @116854
     /*  116854 */ GIM_Reject,
     /*  116855 */ // Label 1948: @116855
     /*  116855 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(116969),
     /*  116860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  116863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  116866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116878 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(116923), // Rule ID 51328 //
     /*  116883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116886 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  116886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  116889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  116903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116921 */     GIR_RootConstrainSelectedInstOperands,
     /*  116922 */     // GIR_Coverage, 51328,
     /*  116922 */     GIR_EraseRootFromParent_Done,
     /*  116923 */   // Label 1992: @116923
     /*  116923 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(116968), // Rule ID 51329 //
     /*  116928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116931 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  116931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  116934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  116948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116966 */     GIR_RootConstrainSelectedInstOperands,
     /*  116967 */     // GIR_Coverage, 51329,
     /*  116967 */     GIR_EraseRootFromParent_Done,
     /*  116968 */   // Label 1993: @116968
     /*  116968 */   GIM_Reject,
     /*  116969 */ // Label 1991: @116969
     /*  116969 */ GIM_Reject,
     /*  116970 */ // Label 1949: @116970
     /*  116970 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(117084),
     /*  116975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  116978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  116981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116993 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(117038), // Rule ID 51364 //
     /*  116998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117001 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  117004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  117018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117036 */     GIR_RootConstrainSelectedInstOperands,
     /*  117037 */     // GIR_Coverage, 51364,
     /*  117037 */     GIR_EraseRootFromParent_Done,
     /*  117038 */   // Label 1995: @117038
     /*  117038 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(117083), // Rule ID 51365 //
     /*  117043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117046 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  117049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  117063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117081 */     GIR_RootConstrainSelectedInstOperands,
     /*  117082 */     // GIR_Coverage, 51365,
     /*  117082 */     GIR_EraseRootFromParent_Done,
     /*  117083 */   // Label 1996: @117083
     /*  117083 */   GIM_Reject,
     /*  117084 */ // Label 1994: @117084
     /*  117084 */ GIM_Reject,
     /*  117085 */ // Label 1950: @117085
     /*  117085 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(117199),
     /*  117090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  117093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  117096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117108 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(117153), // Rule ID 51380 //
     /*  117113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  117116 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  117116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  117119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  117133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117151 */     GIR_RootConstrainSelectedInstOperands,
     /*  117152 */     // GIR_Coverage, 51380,
     /*  117152 */     GIR_EraseRootFromParent_Done,
     /*  117153 */   // Label 1998: @117153
     /*  117153 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(117198), // Rule ID 51381 //
     /*  117158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  117161 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  117161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  117164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  117178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117196 */     GIR_RootConstrainSelectedInstOperands,
     /*  117197 */     // GIR_Coverage, 51381,
     /*  117197 */     GIR_EraseRootFromParent_Done,
     /*  117198 */   // Label 1999: @117198
     /*  117198 */   GIM_Reject,
     /*  117199 */ // Label 1997: @117199
     /*  117199 */ GIM_Reject,
     /*  117200 */ // Label 1951: @117200
     /*  117200 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(117314),
     /*  117205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  117208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  117211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117223 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(117268), // Rule ID 51324 //
     /*  117228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117231 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  117231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  117234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  117248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117266 */     GIR_RootConstrainSelectedInstOperands,
     /*  117267 */     // GIR_Coverage, 51324,
     /*  117267 */     GIR_EraseRootFromParent_Done,
     /*  117268 */   // Label 2001: @117268
     /*  117268 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(117313), // Rule ID 51325 //
     /*  117273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117276 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  117276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  117279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  117293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117311 */     GIR_RootConstrainSelectedInstOperands,
     /*  117312 */     // GIR_Coverage, 51325,
     /*  117312 */     GIR_EraseRootFromParent_Done,
     /*  117313 */   // Label 2002: @117313
     /*  117313 */   GIM_Reject,
     /*  117314 */ // Label 2000: @117314
     /*  117314 */ GIM_Reject,
     /*  117315 */ // Label 1952: @117315
     /*  117315 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(117429),
     /*  117320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  117323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  117326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117338 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(117383), // Rule ID 51352 //
     /*  117343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117346 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  117346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  117349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  117363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117381 */     GIR_RootConstrainSelectedInstOperands,
     /*  117382 */     // GIR_Coverage, 51352,
     /*  117382 */     GIR_EraseRootFromParent_Done,
     /*  117383 */   // Label 2004: @117383
     /*  117383 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(117428), // Rule ID 51353 //
     /*  117388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117391 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  117391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  117394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  117408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117426 */     GIR_RootConstrainSelectedInstOperands,
     /*  117427 */     // GIR_Coverage, 51353,
     /*  117427 */     GIR_EraseRootFromParent_Done,
     /*  117428 */   // Label 2005: @117428
     /*  117428 */   GIM_Reject,
     /*  117429 */ // Label 2003: @117429
     /*  117429 */ GIM_Reject,
     /*  117430 */ // Label 1953: @117430
     /*  117430 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(117544),
     /*  117435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  117438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  117441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117453 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(117498), // Rule ID 51368 //
     /*  117458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117461 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  117464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  117478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117496 */     GIR_RootConstrainSelectedInstOperands,
     /*  117497 */     // GIR_Coverage, 51368,
     /*  117497 */     GIR_EraseRootFromParent_Done,
     /*  117498 */   // Label 2007: @117498
     /*  117498 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(117543), // Rule ID 51369 //
     /*  117503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117506 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  117509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  117523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117541 */     GIR_RootConstrainSelectedInstOperands,
     /*  117542 */     // GIR_Coverage, 51369,
     /*  117542 */     GIR_EraseRootFromParent_Done,
     /*  117543 */   // Label 2008: @117543
     /*  117543 */   GIM_Reject,
     /*  117544 */ // Label 2006: @117544
     /*  117544 */ GIM_Reject,
     /*  117545 */ // Label 1954: @117545
     /*  117545 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(117659),
     /*  117550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  117553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  117556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117568 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(117613), // Rule ID 51384 //
     /*  117573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  117576 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  117576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  117579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  117593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117611 */     GIR_RootConstrainSelectedInstOperands,
     /*  117612 */     // GIR_Coverage, 51384,
     /*  117612 */     GIR_EraseRootFromParent_Done,
     /*  117613 */   // Label 2010: @117613
     /*  117613 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(117658), // Rule ID 51385 //
     /*  117618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  117621 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  117621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  117624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  117638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117656 */     GIR_RootConstrainSelectedInstOperands,
     /*  117657 */     // GIR_Coverage, 51385,
     /*  117657 */     GIR_EraseRootFromParent_Done,
     /*  117658 */   // Label 2011: @117658
     /*  117658 */   GIM_Reject,
     /*  117659 */ // Label 2009: @117659
     /*  117659 */ GIM_Reject,
     /*  117660 */ // Label 1955: @117660
     /*  117660 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(117774),
     /*  117665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  117668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  117671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117683 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(117728), // Rule ID 51340 //
     /*  117688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117691 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  117691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  117694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  117708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117726 */     GIR_RootConstrainSelectedInstOperands,
     /*  117727 */     // GIR_Coverage, 51340,
     /*  117727 */     GIR_EraseRootFromParent_Done,
     /*  117728 */   // Label 2013: @117728
     /*  117728 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(117773), // Rule ID 51341 //
     /*  117733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117736 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  117736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  117739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  117753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117771 */     GIR_RootConstrainSelectedInstOperands,
     /*  117772 */     // GIR_Coverage, 51341,
     /*  117772 */     GIR_EraseRootFromParent_Done,
     /*  117773 */   // Label 2014: @117773
     /*  117773 */   GIM_Reject,
     /*  117774 */ // Label 2012: @117774
     /*  117774 */ GIM_Reject,
     /*  117775 */ // Label 1956: @117775
     /*  117775 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(117889),
     /*  117780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  117783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  117786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117798 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(117843), // Rule ID 51356 //
     /*  117803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117806 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  117806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  117809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  117823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117841 */     GIR_RootConstrainSelectedInstOperands,
     /*  117842 */     // GIR_Coverage, 51356,
     /*  117842 */     GIR_EraseRootFromParent_Done,
     /*  117843 */   // Label 2016: @117843
     /*  117843 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(117888), // Rule ID 51357 //
     /*  117848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117851 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  117851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  117854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  117868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117886 */     GIR_RootConstrainSelectedInstOperands,
     /*  117887 */     // GIR_Coverage, 51357,
     /*  117887 */     GIR_EraseRootFromParent_Done,
     /*  117888 */   // Label 2017: @117888
     /*  117888 */   GIM_Reject,
     /*  117889 */ // Label 2015: @117889
     /*  117889 */ GIM_Reject,
     /*  117890 */ // Label 1957: @117890
     /*  117890 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(118004),
     /*  117895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  117898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  117901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117913 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(117958), // Rule ID 51372 //
     /*  117918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117921 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  117924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  117938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117956 */     GIR_RootConstrainSelectedInstOperands,
     /*  117957 */     // GIR_Coverage, 51372,
     /*  117957 */     GIR_EraseRootFromParent_Done,
     /*  117958 */   // Label 2019: @117958
     /*  117958 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(118003), // Rule ID 51373 //
     /*  117963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117966 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  117969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  117983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118001 */     GIR_RootConstrainSelectedInstOperands,
     /*  118002 */     // GIR_Coverage, 51373,
     /*  118002 */     GIR_EraseRootFromParent_Done,
     /*  118003 */   // Label 2020: @118003
     /*  118003 */   GIM_Reject,
     /*  118004 */ // Label 2018: @118004
     /*  118004 */ GIM_Reject,
     /*  118005 */ // Label 1958: @118005
     /*  118005 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(118119),
     /*  118010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  118013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  118016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118028 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(118073), // Rule ID 51344 //
     /*  118033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118036 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  118039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  118053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118071 */     GIR_RootConstrainSelectedInstOperands,
     /*  118072 */     // GIR_Coverage, 51344,
     /*  118072 */     GIR_EraseRootFromParent_Done,
     /*  118073 */   // Label 2022: @118073
     /*  118073 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(118118), // Rule ID 51345 //
     /*  118078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118081 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  118084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  118098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118116 */     GIR_RootConstrainSelectedInstOperands,
     /*  118117 */     // GIR_Coverage, 51345,
     /*  118117 */     GIR_EraseRootFromParent_Done,
     /*  118118 */   // Label 2023: @118118
     /*  118118 */   GIM_Reject,
     /*  118119 */ // Label 2021: @118119
     /*  118119 */ GIM_Reject,
     /*  118120 */ // Label 1959: @118120
     /*  118120 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(118234),
     /*  118125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  118128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  118131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118143 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(118188), // Rule ID 51360 //
     /*  118148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118151 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  118151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  118154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  118168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118186 */     GIR_RootConstrainSelectedInstOperands,
     /*  118187 */     // GIR_Coverage, 51360,
     /*  118187 */     GIR_EraseRootFromParent_Done,
     /*  118188 */   // Label 2025: @118188
     /*  118188 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(118233), // Rule ID 51361 //
     /*  118193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118196 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  118196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  118199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  118213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118231 */     GIR_RootConstrainSelectedInstOperands,
     /*  118232 */     // GIR_Coverage, 51361,
     /*  118232 */     GIR_EraseRootFromParent_Done,
     /*  118233 */   // Label 2026: @118233
     /*  118233 */   GIM_Reject,
     /*  118234 */ // Label 2024: @118234
     /*  118234 */ GIM_Reject,
     /*  118235 */ // Label 1960: @118235
     /*  118235 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(118349),
     /*  118240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  118243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  118246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118258 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(118303), // Rule ID 51348 //
     /*  118263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118266 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  118269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  118283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118301 */     GIR_RootConstrainSelectedInstOperands,
     /*  118302 */     // GIR_Coverage, 51348,
     /*  118302 */     GIR_EraseRootFromParent_Done,
     /*  118303 */   // Label 2028: @118303
     /*  118303 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(118348), // Rule ID 51349 //
     /*  118308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118311 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  118314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  118328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118346 */     GIR_RootConstrainSelectedInstOperands,
     /*  118347 */     // GIR_Coverage, 51349,
     /*  118347 */     GIR_EraseRootFromParent_Done,
     /*  118348 */   // Label 2029: @118348
     /*  118348 */   GIM_Reject,
     /*  118349 */ // Label 2027: @118349
     /*  118349 */ GIM_Reject,
     /*  118350 */ // Label 1961: @118350
     /*  118350 */ GIM_Reject,
     /*  118351 */ // Label 7: @118351
     /*  118351 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2061*/ GIMT_Encode4(128308),
     /*  118362 */ /*GILLT_s32*//*Label 2030*/ GIMT_Encode4(118486),
     /*  118366 */ /*GILLT_s64*//*Label 2031*/ GIMT_Encode4(120180),
     /*  118370 */ /*GILLT_nxv1s1*//*Label 2032*/ GIMT_Encode4(121501),
     /*  118374 */ /*GILLT_nxv1s8*//*Label 2033*/ GIMT_Encode4(122112),
     /*  118378 */ /*GILLT_nxv1s16*//*Label 2034*/ GIMT_Encode4(122227),
     /*  118382 */ /*GILLT_nxv1s32*//*Label 2035*/ GIMT_Encode4(122342),
     /*  118386 */ /*GILLT_nxv1s64*//*Label 2036*/ GIMT_Encode4(122457),
     /*  118390 */ /*GILLT_nxv2s1*//*Label 2037*/ GIMT_Encode4(122572),
     /*  118394 */ /*GILLT_nxv2s8*//*Label 2038*/ GIMT_Encode4(123183),
     /*  118398 */ /*GILLT_nxv2s16*//*Label 2039*/ GIMT_Encode4(123298),
     /*  118402 */ /*GILLT_nxv2s32*//*Label 2040*/ GIMT_Encode4(123413),
     /*  118406 */ /*GILLT_nxv2s64*//*Label 2041*/ GIMT_Encode4(123528),
     /*  118410 */ /*GILLT_nxv4s1*//*Label 2042*/ GIMT_Encode4(123643),
     /*  118414 */ /*GILLT_nxv4s8*//*Label 2043*/ GIMT_Encode4(124254),
     /*  118418 */ /*GILLT_nxv4s16*//*Label 2044*/ GIMT_Encode4(124369),
     /*  118422 */ /*GILLT_nxv4s32*//*Label 2045*/ GIMT_Encode4(124484),
     /*  118426 */ /*GILLT_nxv4s64*//*Label 2046*/ GIMT_Encode4(124599),
     /*  118430 */ /*GILLT_nxv8s1*//*Label 2047*/ GIMT_Encode4(124714),
     /*  118434 */ /*GILLT_nxv8s8*//*Label 2048*/ GIMT_Encode4(125325),
     /*  118438 */ /*GILLT_nxv8s16*//*Label 2049*/ GIMT_Encode4(125440),
     /*  118442 */ /*GILLT_nxv8s32*//*Label 2050*/ GIMT_Encode4(125555),
     /*  118446 */ /*GILLT_nxv8s64*//*Label 2051*/ GIMT_Encode4(125670),
     /*  118450 */ /*GILLT_nxv16s1*//*Label 2052*/ GIMT_Encode4(125785),
     /*  118454 */ /*GILLT_nxv16s8*//*Label 2053*/ GIMT_Encode4(126396),
     /*  118458 */ /*GILLT_nxv16s16*//*Label 2054*/ GIMT_Encode4(126511),
     /*  118462 */ /*GILLT_nxv16s32*//*Label 2055*/ GIMT_Encode4(126626),
     /*  118466 */ /*GILLT_nxv32s1*//*Label 2056*/ GIMT_Encode4(126741),
     /*  118470 */ /*GILLT_nxv32s8*//*Label 2057*/ GIMT_Encode4(127352),
     /*  118474 */ /*GILLT_nxv32s16*//*Label 2058*/ GIMT_Encode4(127467),
     /*  118478 */ /*GILLT_nxv64s1*//*Label 2059*/ GIMT_Encode4(127582),
     /*  118482 */ /*GILLT_nxv64s8*//*Label 2060*/ GIMT_Encode4(128193),
     /*  118486 */ // Label 2030: @118486
     /*  118486 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(120179),
     /*  118491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  118494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  118497 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(118586), // Rule ID 65511 //
     /*  118502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  118505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  118517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118546 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  118550 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  118561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  118570 */     // (and:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] })), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  118573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  118580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  118584 */     GIR_RootConstrainSelectedInstOperands,
     /*  118585 */     // GIR_Coverage, 65511,
     /*  118585 */     GIR_EraseRootFromParent_Done,
     /*  118586 */   // Label 2063: @118586
     /*  118586 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(118675), // Rule ID 2546 //
     /*  118591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  118594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  118606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118635 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  118639 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  118650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  118659 */     // (and:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1)), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  118662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  118669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  118673 */     GIR_RootConstrainSelectedInstOperands,
     /*  118674 */     // GIR_Coverage, 2546,
     /*  118674 */     GIR_EraseRootFromParent_Done,
     /*  118675 */   // Label 2064: @118675
     /*  118675 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(118754), // Rule ID 2473 //
     /*  118680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118719 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  118723 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  118727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118733 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  118740 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  118743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  118747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  118752 */     GIR_RootConstrainSelectedInstOperands,
     /*  118753 */     // GIR_Coverage, 2473,
     /*  118753 */     GIR_EraseRootFromParent_Done,
     /*  118754 */   // Label 2065: @118754
     /*  118754 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(118833), // Rule ID 65499 //
     /*  118759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  118774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118802 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  118806 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  118810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  118819 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  118822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  118831 */     GIR_RootConstrainSelectedInstOperands,
     /*  118832 */     // GIR_Coverage, 65499,
     /*  118832 */     GIR_EraseRootFromParent_Done,
     /*  118833 */   // Label 2066: @118833
     /*  118833 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(118898), // Rule ID 2493 //
     /*  118838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  118853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  118874 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  118878 */     // MIs[2] Operand 1
     /*  118878 */     // No operand predicates
     /*  118878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  118882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118884 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (BEXTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  118884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  118887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  118893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  118896 */     GIR_RootConstrainSelectedInstOperands,
     /*  118897 */     // GIR_Coverage, 2493,
     /*  118897 */     GIR_EraseRootFromParent_Done,
     /*  118898 */   // Label 2067: @118898
     /*  118898 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(118963), // Rule ID 62577 //
     /*  118903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode1),
     /*  118906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  118918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  118939 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  118943 */     // MIs[2] Operand 1
     /*  118943 */     // No operand predicates
     /*  118943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  118947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118949 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (TH_TST:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  118949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  118952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  118958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  118961 */     GIR_RootConstrainSelectedInstOperands,
     /*  118962 */     // GIR_Coverage, 62577,
     /*  118962 */     GIR_EraseRootFromParent_Done,
     /*  118963 */   // Label 2068: @118963
     /*  118963 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(119025), // Rule ID 2481 //
     /*  118968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  118983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  119000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  119009 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), 1:{ *:[i32] })  =>  (BEXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  119012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  119018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  119023 */     GIR_RootConstrainSelectedInstOperands,
     /*  119024 */     // GIR_Coverage, 2481,
     /*  119024 */     GIR_EraseRootFromParent_Done,
     /*  119025 */   // Label 2069: @119025
     /*  119025 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(119081), // Rule ID 2475 //
     /*  119030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  119045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119053 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  119057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119068 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119079 */     GIR_RootConstrainSelectedInstOperands,
     /*  119080 */     // GIR_Coverage, 2475,
     /*  119080 */     GIR_EraseRootFromParent_Done,
     /*  119081 */   // Label 2070: @119081
     /*  119081 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(119137), // Rule ID 65485 //
     /*  119086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  119089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119114 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119124 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  119127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119135 */     GIR_RootConstrainSelectedInstOperands,
     /*  119136 */     // GIR_Coverage, 65485,
     /*  119136 */     GIR_EraseRootFromParent_Done,
     /*  119137 */   // Label 2071: @119137
     /*  119137 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(119193), // Rule ID 65501 //
     /*  119142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  119161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119169 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  119173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119180 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119191 */     GIR_RootConstrainSelectedInstOperands,
     /*  119192 */     // GIR_Coverage, 65501,
     /*  119192 */     GIR_EraseRootFromParent_Done,
     /*  119193 */   // Label 2072: @119193
     /*  119193 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(119249), // Rule ID 2447 //
     /*  119198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  119201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119230 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119236 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  119239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119247 */     GIR_RootConstrainSelectedInstOperands,
     /*  119248 */     // GIR_Coverage, 2447,
     /*  119248 */     GIR_EraseRootFromParent_Done,
     /*  119249 */   // Label 2073: @119249
     /*  119249 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(119285), // Rule ID 64478 //
     /*  119254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  119257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119265 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119276 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 65535:{ *:[i32] })  =>  (CV_EXTHZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  119276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  119279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119283 */     GIR_RootConstrainSelectedInstOperands,
     /*  119284 */     // GIR_Coverage, 64478,
     /*  119284 */     GIR_EraseRootFromParent_Done,
     /*  119285 */   // Label 2074: @119285
     /*  119285 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(119321), // Rule ID 64480 //
     /*  119290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  119293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119301 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  119312 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 255:{ *:[i32] })  =>  (CV_EXTBZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  119312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  119315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119319 */     GIR_RootConstrainSelectedInstOperands,
     /*  119320 */     // GIR_Coverage, 64480,
     /*  119320 */     GIR_EraseRootFromParent_Done,
     /*  119321 */   // Label 2075: @119321
     /*  119321 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(119357), // Rule ID 2557 //
     /*  119326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /*  119329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119337 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119348 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  119348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  119351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119355 */     GIR_RootConstrainSelectedInstOperands,
     /*  119356 */     // GIR_Coverage, 2557,
     /*  119356 */     GIR_EraseRootFromParent_Done,
     /*  119357 */   // Label 2076: @119357
     /*  119357 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(119393), // Rule ID 2558 //
     /*  119362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /*  119365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119373 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119384 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  119384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  119387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119391 */     GIR_RootConstrainSelectedInstOperands,
     /*  119392 */     // GIR_Coverage, 2558,
     /*  119392 */     GIR_EraseRootFromParent_Done,
     /*  119393 */   // Label 2077: @119393
     /*  119393 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(119435), // Rule ID 2560 //
     /*  119398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /*  119401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119409 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119420 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i64] })
     /*  119420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  119423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  119433 */     GIR_RootConstrainSelectedInstOperands,
     /*  119434 */     // GIR_Coverage, 2560,
     /*  119434 */     GIR_EraseRootFromParent_Done,
     /*  119435 */   // Label 2078: @119435
     /*  119435 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(119477), // Rule ID 2561 //
     /*  119440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /*  119443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119451 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119462 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i32] })
     /*  119462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  119465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  119475 */     GIR_RootConstrainSelectedInstOperands,
     /*  119476 */     // GIR_Coverage, 2561,
     /*  119476 */     GIR_EraseRootFromParent_Done,
     /*  119477 */   // Label 2079: @119477
     /*  119477 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(119512), // Rule ID 64628 //
     /*  119482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /*  119497 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 63:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  119497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  119507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119510 */     GIR_RootConstrainSelectedInstOperands,
     /*  119511 */     // GIR_Coverage, 64628,
     /*  119511 */     GIR_EraseRootFromParent_Done,
     /*  119512 */   // Label 2080: @119512
     /*  119512 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(119547), // Rule ID 64629 //
     /*  119517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /*  119532 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 63:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  119532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  119542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119545 */     GIR_RootConstrainSelectedInstOperands,
     /*  119546 */     // GIR_Coverage, 64629,
     /*  119546 */     GIR_EraseRootFromParent_Done,
     /*  119547 */   // Label 2081: @119547
     /*  119547 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(119582), // Rule ID 64630 //
     /*  119552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 127,
     /*  119567 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 127:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 7:{ *:[i64] }, 0:{ *:[i64] })
     /*  119567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  119577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119580 */     GIR_RootConstrainSelectedInstOperands,
     /*  119581 */     // GIR_Coverage, 64630,
     /*  119581 */     GIR_EraseRootFromParent_Done,
     /*  119582 */   // Label 2082: @119582
     /*  119582 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(119617), // Rule ID 64631 //
     /*  119587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 127,
     /*  119602 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 127:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 7:{ *:[i32] }, 0:{ *:[i32] })
     /*  119602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  119612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119615 */     GIR_RootConstrainSelectedInstOperands,
     /*  119616 */     // GIR_Coverage, 64631,
     /*  119616 */     GIR_EraseRootFromParent_Done,
     /*  119617 */   // Label 2083: @119617
     /*  119617 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(119659), // Rule ID 64632 //
     /*  119622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119633 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  119644 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 255:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 8:{ *:[i64] }, 0:{ *:[i64] })
     /*  119644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  119654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119657 */     GIR_RootConstrainSelectedInstOperands,
     /*  119658 */     // GIR_Coverage, 64632,
     /*  119658 */     GIR_EraseRootFromParent_Done,
     /*  119659 */   // Label 2084: @119659
     /*  119659 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(119701), // Rule ID 64633 //
     /*  119664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119675 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  119686 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 255:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 8:{ *:[i32] }, 0:{ *:[i32] })
     /*  119686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  119696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119699 */     GIR_RootConstrainSelectedInstOperands,
     /*  119700 */     // GIR_Coverage, 64633,
     /*  119700 */     GIR_EraseRootFromParent_Done,
     /*  119701 */   // Label 2085: @119701
     /*  119701 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(119743), // Rule ID 64634 //
     /*  119706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119717 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(511),
     /*  119728 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 511:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 9:{ *:[i64] }, 0:{ *:[i64] })
     /*  119728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*  119738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119741 */     GIR_RootConstrainSelectedInstOperands,
     /*  119742 */     // GIR_Coverage, 64634,
     /*  119742 */     GIR_EraseRootFromParent_Done,
     /*  119743 */   // Label 2086: @119743
     /*  119743 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(119785), // Rule ID 64635 //
     /*  119748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119759 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(511),
     /*  119770 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 511:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 9:{ *:[i32] }, 0:{ *:[i32] })
     /*  119770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*  119780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119783 */     GIR_RootConstrainSelectedInstOperands,
     /*  119784 */     // GIR_Coverage, 64635,
     /*  119784 */     GIR_EraseRootFromParent_Done,
     /*  119785 */   // Label 2087: @119785
     /*  119785 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(119827), // Rule ID 64636 //
     /*  119790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119801 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1023),
     /*  119812 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 1023:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 10:{ *:[i64] }, 0:{ *:[i64] })
     /*  119812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/10,
     /*  119822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119825 */     GIR_RootConstrainSelectedInstOperands,
     /*  119826 */     // GIR_Coverage, 64636,
     /*  119826 */     GIR_EraseRootFromParent_Done,
     /*  119827 */   // Label 2088: @119827
     /*  119827 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(119869), // Rule ID 64637 //
     /*  119832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119843 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1023),
     /*  119854 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 1023:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 10:{ *:[i32] }, 0:{ *:[i32] })
     /*  119854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/10,
     /*  119864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119867 */     GIR_RootConstrainSelectedInstOperands,
     /*  119868 */     // GIR_Coverage, 64637,
     /*  119868 */     GIR_EraseRootFromParent_Done,
     /*  119869 */   // Label 2089: @119869
     /*  119869 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(119911), // Rule ID 64638 //
     /*  119874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119885 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2047),
     /*  119896 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 2047:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 11:{ *:[i64] }, 0:{ *:[i64] })
     /*  119896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /*  119906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119909 */     GIR_RootConstrainSelectedInstOperands,
     /*  119910 */     // GIR_Coverage, 64638,
     /*  119910 */     GIR_EraseRootFromParent_Done,
     /*  119911 */   // Label 2090: @119911
     /*  119911 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(119953), // Rule ID 64639 //
     /*  119916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119927 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2047),
     /*  119938 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 2047:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 11:{ *:[i32] }, 0:{ *:[i32] })
     /*  119938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /*  119948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119951 */     GIR_RootConstrainSelectedInstOperands,
     /*  119952 */     // GIR_Coverage, 64639,
     /*  119952 */     GIR_EraseRootFromParent_Done,
     /*  119953 */   // Label 2091: @119953
     /*  119953 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(119995), // Rule ID 91 //
     /*  119958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  119961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  119981 */     // MIs[1] Operand 1
     /*  119981 */     // No operand predicates
     /*  119981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119983 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  119983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  119986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  119993 */     GIR_RootConstrainSelectedInstOperands,
     /*  119994 */     // GIR_Coverage, 91,
     /*  119994 */     GIR_EraseRootFromParent_Done,
     /*  119995 */   // Label 2092: @119995
     /*  119995 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(120067), // Rule ID 109 //
     /*  120000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  120003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120019 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  120023 */     // MIs[1] Operand 1
     /*  120023 */     // No operand predicates
     /*  120023 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9937),
     /*  120027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120029 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9937>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)), (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask))
     /*  120029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  120032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  120045 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  120050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  120055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120060 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  120065 */     GIR_RootConstrainSelectedInstOperands,
     /*  120066 */     // GIR_Coverage, 109,
     /*  120066 */     GIR_EraseRootFromParent_Done,
     /*  120067 */   // Label 2093: @120067
     /*  120067 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(120109), // Rule ID 64531 //
     /*  120072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  120075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  120095 */     // MIs[1] Operand 1
     /*  120095 */     // No operand predicates
     /*  120095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120097 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ANDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  120097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDAI),
     /*  120100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  120102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  120107 */     GIR_RootConstrainSelectedInstOperands,
     /*  120108 */     // GIR_Coverage, 64531,
     /*  120108 */     GIR_EraseRootFromParent_Done,
     /*  120109 */   // Label 2094: @120109
     /*  120109 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(120151), // Rule ID 64535 //
     /*  120114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  120117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  120137 */     // MIs[1] Operand 1
     /*  120137 */     // No operand predicates
     /*  120137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120139 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ANDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  120139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDI),
     /*  120142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  120149 */     GIR_RootConstrainSelectedInstOperands,
     /*  120150 */     // GIR_Coverage, 64535,
     /*  120150 */     GIR_EraseRootFromParent_Done,
     /*  120151 */   // Label 2095: @120151
     /*  120151 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(120178), // Rule ID 89 //
     /*  120156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  120159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120171 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (AND:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  120171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  120176 */     GIR_RootConstrainSelectedInstOperands,
     /*  120177 */     // GIR_Coverage, 89,
     /*  120177 */     GIR_Done,
     /*  120178 */   // Label 2096: @120178
     /*  120178 */   GIM_Reject,
     /*  120179 */ // Label 2062: @120179
     /*  120179 */ GIM_Reject,
     /*  120180 */ // Label 2031: @120180
     /*  120180 */ GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(121500),
     /*  120185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  120188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  120191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120195 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(120280), // Rule ID 65510 //
     /*  120200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  120203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  120211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120240 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  120244 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  120264 */     // (and:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] })), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  120267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  120274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  120278 */     GIR_RootConstrainSelectedInstOperands,
     /*  120279 */     // GIR_Coverage, 65510,
     /*  120279 */     GIR_EraseRootFromParent_Done,
     /*  120280 */   // Label 2098: @120280
     /*  120280 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(120365), // Rule ID 2545 //
     /*  120285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  120288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  120296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120316 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120325 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  120329 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  120349 */     // (and:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1)), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  120352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  120359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  120363 */     GIR_RootConstrainSelectedInstOperands,
     /*  120364 */     // GIR_Coverage, 2545,
     /*  120364 */     GIR_EraseRootFromParent_Done,
     /*  120365 */   // Label 2099: @120365
     /*  120365 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(120440), // Rule ID 2472 //
     /*  120370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120405 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  120409 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120426 */     // (and:{ *:[i64] } (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120438 */     GIR_RootConstrainSelectedInstOperands,
     /*  120439 */     // GIR_Coverage, 2472,
     /*  120439 */     GIR_EraseRootFromParent_Done,
     /*  120440 */   // Label 2100: @120440
     /*  120440 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(120515), // Rule ID 65498 //
     /*  120445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120484 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  120488 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120501 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120513 */     GIR_RootConstrainSelectedInstOperands,
     /*  120514 */     // GIR_Coverage, 65498,
     /*  120514 */     GIR_EraseRootFromParent_Done,
     /*  120515 */   // Label 2101: @120515
     /*  120515 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(120576), // Rule ID 2492 //
     /*  120520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120552 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  120556 */     // MIs[2] Operand 1
     /*  120556 */     // No operand predicates
     /*  120556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  120560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120562 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (BEXTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  120562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  120565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  120571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  120574 */     GIR_RootConstrainSelectedInstOperands,
     /*  120575 */     // GIR_Coverage, 2492,
     /*  120575 */     GIR_EraseRootFromParent_Done,
     /*  120576 */   // Label 2102: @120576
     /*  120576 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(120637), // Rule ID 62576 //
     /*  120581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode0),
     /*  120584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120613 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  120617 */     // MIs[2] Operand 1
     /*  120617 */     // No operand predicates
     /*  120617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  120621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120623 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (TH_TST:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  120623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  120626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  120632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  120635 */     GIR_RootConstrainSelectedInstOperands,
     /*  120636 */     // GIR_Coverage, 62576,
     /*  120636 */     GIR_EraseRootFromParent_Done,
     /*  120637 */   // Label 2103: @120637
     /*  120637 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(120695), // Rule ID 2480 //
     /*  120642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  120670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120672 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120679 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), 1:{ *:[i64] })  =>  (BEXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  120682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  120688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120693 */     GIR_RootConstrainSelectedInstOperands,
     /*  120694 */     // GIR_Coverage, 2480,
     /*  120694 */     GIR_EraseRootFromParent_Done,
     /*  120695 */   // Label 2104: @120695
     /*  120695 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(120747), // Rule ID 2474 //
     /*  120700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  120711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120719 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  120723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120734 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  120745 */     GIR_RootConstrainSelectedInstOperands,
     /*  120746 */     // GIR_Coverage, 2474,
     /*  120746 */     GIR_EraseRootFromParent_Done,
     /*  120747 */   // Label 2105: @120747
     /*  120747 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(120799), // Rule ID 65484 //
     /*  120752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  120755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120776 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120786 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  120789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  120797 */     GIR_RootConstrainSelectedInstOperands,
     /*  120798 */     // GIR_Coverage, 65484,
     /*  120798 */     GIR_EraseRootFromParent_Done,
     /*  120799 */   // Label 2106: @120799
     /*  120799 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(120851), // Rule ID 65500 //
     /*  120804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  120819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120827 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  120831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120838 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  120849 */     GIR_RootConstrainSelectedInstOperands,
     /*  120850 */     // GIR_Coverage, 65500,
     /*  120850 */     GIR_EraseRootFromParent_Done,
     /*  120851 */   // Label 2107: @120851
     /*  120851 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(120903), // Rule ID 2446 //
     /*  120856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  120859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120884 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120890 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  120893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  120901 */     GIR_RootConstrainSelectedInstOperands,
     /*  120902 */     // GIR_Coverage, 2446,
     /*  120902 */     GIR_EraseRootFromParent_Done,
     /*  120903 */   // Label 2108: @120903
     /*  120903 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(120935), // Rule ID 64477 //
     /*  120908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  120911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120915 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120926 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 65535:{ *:[i64] })  =>  (CV_EXTHZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  120926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  120929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120933 */     GIR_RootConstrainSelectedInstOperands,
     /*  120934 */     // GIR_Coverage, 64477,
     /*  120934 */     GIR_EraseRootFromParent_Done,
     /*  120935 */   // Label 2109: @120935
     /*  120935 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(120967), // Rule ID 64479 //
     /*  120940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  120943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120947 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  120958 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 255:{ *:[i64] })  =>  (CV_EXTBZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  120958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  120961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120965 */     GIR_RootConstrainSelectedInstOperands,
     /*  120966 */     // GIR_Coverage, 64479,
     /*  120966 */     GIR_EraseRootFromParent_Done,
     /*  120967 */   // Label 2110: @120967
     /*  120967 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(121024), // Rule ID 262 //
     /*  120972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /*  120975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120979 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  120990 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] })  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), 32:{ *:[i64] })
     /*  120990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  120993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121002 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  121006 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  121009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /*  121022 */     GIR_RootConstrainSelectedInstOperands,
     /*  121023 */     // GIR_Coverage, 262,
     /*  121023 */     GIR_EraseRootFromParent_Done,
     /*  121024 */   // Label 2111: @121024
     /*  121024 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(121056), // Rule ID 2559 //
     /*  121029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /*  121032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121036 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  121047 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs)
     /*  121047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /*  121050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121054 */     GIR_RootConstrainSelectedInstOperands,
     /*  121055 */     // GIR_Coverage, 2559,
     /*  121055 */     GIR_EraseRootFromParent_Done,
     /*  121056 */   // Label 2112: @121056
     /*  121056 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(121094), // Rule ID 2562 //
     /*  121061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /*  121064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121068 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  121079 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  121079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  121082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  121092 */     GIR_RootConstrainSelectedInstOperands,
     /*  121093 */     // GIR_Coverage, 2562,
     /*  121093 */     GIR_EraseRootFromParent_Done,
     /*  121094 */   // Label 2113: @121094
     /*  121094 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(121132), // Rule ID 2605 //
     /*  121099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  121102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121106 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  121117 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  121117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*  121120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  121130 */     GIR_RootConstrainSelectedInstOperands,
     /*  121131 */     // GIR_Coverage, 2605,
     /*  121131 */     GIR_EraseRootFromParent_Done,
     /*  121132 */   // Label 2114: @121132
     /*  121132 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(121170), // Rule ID 65095 //
     /*  121137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*  121140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121144 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  121155 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  121155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*  121158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  121168 */     GIR_RootConstrainSelectedInstOperands,
     /*  121169 */     // GIR_Coverage, 65095,
     /*  121169 */     GIR_EraseRootFromParent_Done,
     /*  121170 */   // Label 2115: @121170
     /*  121170 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(121208), // Rule ID 90 //
     /*  121175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  121194 */     // MIs[1] Operand 1
     /*  121194 */     // No operand predicates
     /*  121194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121196 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  121196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  121199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  121206 */     GIR_RootConstrainSelectedInstOperands,
     /*  121207 */     // GIR_Coverage, 90,
     /*  121207 */     GIR_EraseRootFromParent_Done,
     /*  121208 */   // Label 2116: @121208
     /*  121208 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(121276), // Rule ID 107 //
     /*  121213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesMask),
     /*  121232 */     // MIs[1] Operand 1
     /*  121232 */     // No operand predicates
     /*  121232 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9935),
     /*  121236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121238 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesMask>><<P:Predicate_anonymous_9935>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  121238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  121254 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121269 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121274 */     GIR_RootConstrainSelectedInstOperands,
     /*  121275 */     // GIR_Coverage, 107,
     /*  121275 */     GIR_EraseRootFromParent_Done,
     /*  121276 */   // Label 2117: @121276
     /*  121276 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(121344), // Rule ID 108 //
     /*  121281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121296 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  121300 */     // MIs[1] Operand 1
     /*  121300 */     // No operand predicates
     /*  121300 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9937),
     /*  121304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121306 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9937>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  121306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121318 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  121322 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  121327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121337 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  121342 */     GIR_RootConstrainSelectedInstOperands,
     /*  121343 */     // GIR_Coverage, 108,
     /*  121343 */     GIR_EraseRootFromParent_Done,
     /*  121344 */   // Label 2118: @121344
     /*  121344 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(121412), // Rule ID 264 //
     /*  121349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  121352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesWMask),
     /*  121368 */     // MIs[1] Operand 1
     /*  121368 */     // No operand predicates
     /*  121368 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10027),
     /*  121372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121374 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesWMask>><<P:Predicate_anonymous_10027>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLIW:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  121374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*  121381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  121390 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121405 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121410 */     GIR_RootConstrainSelectedInstOperands,
     /*  121411 */     // GIR_Coverage, 264,
     /*  121411 */     GIR_EraseRootFromParent_Done,
     /*  121412 */   // Label 2119: @121412
     /*  121412 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(121476), // Rule ID 2624 //
     /*  121417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  121420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121432 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_Shifted32OnesMask),
     /*  121436 */     // MIs[1] Operand 1
     /*  121436 */     // No operand predicates
     /*  121436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121438 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>><<X:TrailingZeros>>:$mask)  =>  (SLLI_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask))
     /*  121438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  121454 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /*  121464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121469 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121474 */     GIR_RootConstrainSelectedInstOperands,
     /*  121475 */     // GIR_Coverage, 2624,
     /*  121475 */     GIR_EraseRootFromParent_Done,
     /*  121476 */   // Label 2120: @121476
     /*  121476 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(121499), // Rule ID 88 //
     /*  121481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121492 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AND:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  121497 */     GIR_RootConstrainSelectedInstOperands,
     /*  121498 */     // GIR_Coverage, 88,
     /*  121498 */     GIR_Done,
     /*  121499 */   // Label 2121: @121499
     /*  121499 */   GIM_Reject,
     /*  121500 */ // Label 2097: @121500
     /*  121500 */ GIM_Reject,
     /*  121501 */ // Label 2032: @121501
     /*  121501 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(122111),
     /*  121506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121516 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(121582), // Rule ID 71710 //
     /*  121521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121563 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121580 */     GIR_RootConstrainSelectedInstOperands,
     /*  121581 */     // GIR_Coverage, 71710,
     /*  121581 */     GIR_EraseRootFromParent_Done,
     /*  121582 */   // Label 2123: @121582
     /*  121582 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(121648), // Rule ID 71711 //
     /*  121587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121629 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121646 */     GIR_RootConstrainSelectedInstOperands,
     /*  121647 */     // GIR_Coverage, 71711,
     /*  121647 */     GIR_EraseRootFromParent_Done,
     /*  121648 */   // Label 2124: @121648
     /*  121648 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(121714), // Rule ID 71708 //
     /*  121653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121695 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121712 */     GIR_RootConstrainSelectedInstOperands,
     /*  121713 */     // GIR_Coverage, 71708,
     /*  121713 */     GIR_EraseRootFromParent_Done,
     /*  121714 */   // Label 2125: @121714
     /*  121714 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(121780), // Rule ID 71709 //
     /*  121719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121761 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121778 */     GIR_RootConstrainSelectedInstOperands,
     /*  121779 */     // GIR_Coverage, 71709,
     /*  121779 */     GIR_EraseRootFromParent_Done,
     /*  121780 */   // Label 2126: @121780
     /*  121780 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(121846), // Rule ID 71706 //
     /*  121785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121827 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121844 */     GIR_RootConstrainSelectedInstOperands,
     /*  121845 */     // GIR_Coverage, 71706,
     /*  121845 */     GIR_EraseRootFromParent_Done,
     /*  121846 */   // Label 2127: @121846
     /*  121846 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(121912), // Rule ID 71707 //
     /*  121851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121893 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121910 */     GIR_RootConstrainSelectedInstOperands,
     /*  121911 */     // GIR_Coverage, 71707,
     /*  121911 */     GIR_EraseRootFromParent_Done,
     /*  121912 */   // Label 2128: @121912
     /*  121912 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(121978), // Rule ID 53176 //
     /*  121917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121959 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121976 */     GIR_RootConstrainSelectedInstOperands,
     /*  121977 */     // GIR_Coverage, 53176,
     /*  121977 */     GIR_EraseRootFromParent_Done,
     /*  121978 */   // Label 2129: @121978
     /*  121978 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(122044), // Rule ID 53177 //
     /*  121983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122025 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122042 */     GIR_RootConstrainSelectedInstOperands,
     /*  122043 */     // GIR_Coverage, 53177,
     /*  122043 */     GIR_EraseRootFromParent_Done,
     /*  122044 */   // Label 2130: @122044
     /*  122044 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(122077), // Rule ID 53164 //
     /*  122049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122060 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  122063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122075 */     GIR_RootConstrainSelectedInstOperands,
     /*  122076 */     // GIR_Coverage, 53164,
     /*  122076 */     GIR_EraseRootFromParent_Done,
     /*  122077 */   // Label 2131: @122077
     /*  122077 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(122110), // Rule ID 53165 //
     /*  122082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122093 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  122096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122108 */     GIR_RootConstrainSelectedInstOperands,
     /*  122109 */     // GIR_Coverage, 53165,
     /*  122109 */     GIR_EraseRootFromParent_Done,
     /*  122110 */   // Label 2132: @122110
     /*  122110 */   GIM_Reject,
     /*  122111 */ // Label 2122: @122111
     /*  122111 */ GIM_Reject,
     /*  122112 */ // Label 2033: @122112
     /*  122112 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(122226),
     /*  122117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  122120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  122123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122131 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122135 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(122180), // Rule ID 47656 //
     /*  122140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122143 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  122143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  122146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  122160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122178 */     GIR_RootConstrainSelectedInstOperands,
     /*  122179 */     // GIR_Coverage, 47656,
     /*  122179 */     GIR_EraseRootFromParent_Done,
     /*  122180 */   // Label 2134: @122180
     /*  122180 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(122225), // Rule ID 47657 //
     /*  122185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122188 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  122188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  122191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  122205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122223 */     GIR_RootConstrainSelectedInstOperands,
     /*  122224 */     // GIR_Coverage, 47657,
     /*  122224 */     GIR_EraseRootFromParent_Done,
     /*  122225 */   // Label 2135: @122225
     /*  122225 */   GIM_Reject,
     /*  122226 */ // Label 2133: @122226
     /*  122226 */ GIM_Reject,
     /*  122227 */ // Label 2034: @122227
     /*  122227 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(122341),
     /*  122232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  122235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  122238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122250 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(122295), // Rule ID 47668 //
     /*  122255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122258 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  122258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  122261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  122275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122293 */     GIR_RootConstrainSelectedInstOperands,
     /*  122294 */     // GIR_Coverage, 47668,
     /*  122294 */     GIR_EraseRootFromParent_Done,
     /*  122295 */   // Label 2137: @122295
     /*  122295 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(122340), // Rule ID 47669 //
     /*  122300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122303 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  122303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  122306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  122320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122338 */     GIR_RootConstrainSelectedInstOperands,
     /*  122339 */     // GIR_Coverage, 47669,
     /*  122339 */     GIR_EraseRootFromParent_Done,
     /*  122340 */   // Label 2138: @122340
     /*  122340 */   GIM_Reject,
     /*  122341 */ // Label 2136: @122341
     /*  122341 */ GIM_Reject,
     /*  122342 */ // Label 2035: @122342
     /*  122342 */ GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(122456),
     /*  122347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  122350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  122353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122365 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(122410), // Rule ID 47676 //
     /*  122370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122373 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  122373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  122376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  122390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122408 */     GIR_RootConstrainSelectedInstOperands,
     /*  122409 */     // GIR_Coverage, 47676,
     /*  122409 */     GIR_EraseRootFromParent_Done,
     /*  122410 */   // Label 2140: @122410
     /*  122410 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(122455), // Rule ID 47677 //
     /*  122415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122418 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  122418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  122421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  122435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122453 */     GIR_RootConstrainSelectedInstOperands,
     /*  122454 */     // GIR_Coverage, 47677,
     /*  122454 */     GIR_EraseRootFromParent_Done,
     /*  122455 */   // Label 2141: @122455
     /*  122455 */   GIM_Reject,
     /*  122456 */ // Label 2139: @122456
     /*  122456 */ GIM_Reject,
     /*  122457 */ // Label 2036: @122457
     /*  122457 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(122571),
     /*  122462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  122465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  122468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122480 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(122525), // Rule ID 47692 //
     /*  122485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  122488 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  122488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  122491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  122505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  122520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122523 */     GIR_RootConstrainSelectedInstOperands,
     /*  122524 */     // GIR_Coverage, 47692,
     /*  122524 */     GIR_EraseRootFromParent_Done,
     /*  122525 */   // Label 2143: @122525
     /*  122525 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(122570), // Rule ID 47693 //
     /*  122530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  122533 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  122533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  122536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  122550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  122565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122568 */     GIR_RootConstrainSelectedInstOperands,
     /*  122569 */     // GIR_Coverage, 47693,
     /*  122569 */     GIR_EraseRootFromParent_Done,
     /*  122570 */   // Label 2144: @122570
     /*  122570 */   GIM_Reject,
     /*  122571 */ // Label 2142: @122571
     /*  122571 */ GIM_Reject,
     /*  122572 */ // Label 2037: @122572
     /*  122572 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(123182),
     /*  122577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122587 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(122653), // Rule ID 71738 //
     /*  122592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122634 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122651 */     GIR_RootConstrainSelectedInstOperands,
     /*  122652 */     // GIR_Coverage, 71738,
     /*  122652 */     GIR_EraseRootFromParent_Done,
     /*  122653 */   // Label 2146: @122653
     /*  122653 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(122719), // Rule ID 71739 //
     /*  122658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122700 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122717 */     GIR_RootConstrainSelectedInstOperands,
     /*  122718 */     // GIR_Coverage, 71739,
     /*  122718 */     GIR_EraseRootFromParent_Done,
     /*  122719 */   // Label 2147: @122719
     /*  122719 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(122785), // Rule ID 71736 //
     /*  122724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122766 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122783 */     GIR_RootConstrainSelectedInstOperands,
     /*  122784 */     // GIR_Coverage, 71736,
     /*  122784 */     GIR_EraseRootFromParent_Done,
     /*  122785 */   // Label 2148: @122785
     /*  122785 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(122851), // Rule ID 71737 //
     /*  122790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122832 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122849 */     GIR_RootConstrainSelectedInstOperands,
     /*  122850 */     // GIR_Coverage, 71737,
     /*  122850 */     GIR_EraseRootFromParent_Done,
     /*  122851 */   // Label 2149: @122851
     /*  122851 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(122917), // Rule ID 71734 //
     /*  122856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122898 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122915 */     GIR_RootConstrainSelectedInstOperands,
     /*  122916 */     // GIR_Coverage, 71734,
     /*  122916 */     GIR_EraseRootFromParent_Done,
     /*  122917 */   // Label 2150: @122917
     /*  122917 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(122983), // Rule ID 71735 //
     /*  122922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122964 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122981 */     GIR_RootConstrainSelectedInstOperands,
     /*  122982 */     // GIR_Coverage, 71735,
     /*  122982 */     GIR_EraseRootFromParent_Done,
     /*  122983 */   // Label 2151: @122983
     /*  122983 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(123049), // Rule ID 53194 //
     /*  122988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123030 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123047 */     GIR_RootConstrainSelectedInstOperands,
     /*  123048 */     // GIR_Coverage, 53194,
     /*  123048 */     GIR_EraseRootFromParent_Done,
     /*  123049 */   // Label 2152: @123049
     /*  123049 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(123115), // Rule ID 53195 //
     /*  123054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123096 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123113 */     GIR_RootConstrainSelectedInstOperands,
     /*  123114 */     // GIR_Coverage, 53195,
     /*  123114 */     GIR_EraseRootFromParent_Done,
     /*  123115 */   // Label 2153: @123115
     /*  123115 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(123148), // Rule ID 53182 //
     /*  123120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123131 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  123134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123146 */     GIR_RootConstrainSelectedInstOperands,
     /*  123147 */     // GIR_Coverage, 53182,
     /*  123147 */     GIR_EraseRootFromParent_Done,
     /*  123148 */   // Label 2154: @123148
     /*  123148 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(123181), // Rule ID 53183 //
     /*  123153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123164 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  123167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123179 */     GIR_RootConstrainSelectedInstOperands,
     /*  123180 */     // GIR_Coverage, 53183,
     /*  123180 */     GIR_EraseRootFromParent_Done,
     /*  123181 */   // Label 2155: @123181
     /*  123181 */   GIM_Reject,
     /*  123182 */ // Label 2145: @123182
     /*  123182 */ GIM_Reject,
     /*  123183 */ // Label 2038: @123183
     /*  123183 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(123297),
     /*  123188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  123191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  123194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123206 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(123251), // Rule ID 47660 //
     /*  123211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123214 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  123214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  123217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  123231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123249 */     GIR_RootConstrainSelectedInstOperands,
     /*  123250 */     // GIR_Coverage, 47660,
     /*  123250 */     GIR_EraseRootFromParent_Done,
     /*  123251 */   // Label 2157: @123251
     /*  123251 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(123296), // Rule ID 47661 //
     /*  123256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123259 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  123259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  123262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  123276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123294 */     GIR_RootConstrainSelectedInstOperands,
     /*  123295 */     // GIR_Coverage, 47661,
     /*  123295 */     GIR_EraseRootFromParent_Done,
     /*  123296 */   // Label 2158: @123296
     /*  123296 */   GIM_Reject,
     /*  123297 */ // Label 2156: @123297
     /*  123297 */ GIM_Reject,
     /*  123298 */ // Label 2039: @123298
     /*  123298 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(123412),
     /*  123303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  123306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  123309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123321 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(123366), // Rule ID 47672 //
     /*  123326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123329 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  123329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  123332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  123346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123364 */     GIR_RootConstrainSelectedInstOperands,
     /*  123365 */     // GIR_Coverage, 47672,
     /*  123365 */     GIR_EraseRootFromParent_Done,
     /*  123366 */   // Label 2160: @123366
     /*  123366 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(123411), // Rule ID 47673 //
     /*  123371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123374 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  123374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  123377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  123391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123409 */     GIR_RootConstrainSelectedInstOperands,
     /*  123410 */     // GIR_Coverage, 47673,
     /*  123410 */     GIR_EraseRootFromParent_Done,
     /*  123411 */   // Label 2161: @123411
     /*  123411 */   GIM_Reject,
     /*  123412 */ // Label 2159: @123412
     /*  123412 */ GIM_Reject,
     /*  123413 */ // Label 2040: @123413
     /*  123413 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(123527),
     /*  123418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  123421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  123424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123436 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(123481), // Rule ID 47688 //
     /*  123441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123444 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  123444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  123447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  123476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123479 */     GIR_RootConstrainSelectedInstOperands,
     /*  123480 */     // GIR_Coverage, 47688,
     /*  123480 */     GIR_EraseRootFromParent_Done,
     /*  123481 */   // Label 2163: @123481
     /*  123481 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(123526), // Rule ID 47689 //
     /*  123486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123489 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  123489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  123492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  123521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123524 */     GIR_RootConstrainSelectedInstOperands,
     /*  123525 */     // GIR_Coverage, 47689,
     /*  123525 */     GIR_EraseRootFromParent_Done,
     /*  123526 */   // Label 2164: @123526
     /*  123526 */   GIM_Reject,
     /*  123527 */ // Label 2162: @123527
     /*  123527 */ GIM_Reject,
     /*  123528 */ // Label 2041: @123528
     /*  123528 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(123642),
     /*  123533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  123536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  123539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123551 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(123596), // Rule ID 47732 //
     /*  123556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  123559 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  123559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  123562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  123576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  123591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123594 */     GIR_RootConstrainSelectedInstOperands,
     /*  123595 */     // GIR_Coverage, 47732,
     /*  123595 */     GIR_EraseRootFromParent_Done,
     /*  123596 */   // Label 2166: @123596
     /*  123596 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(123641), // Rule ID 47733 //
     /*  123601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  123604 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  123604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  123607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  123621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  123636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123639 */     GIR_RootConstrainSelectedInstOperands,
     /*  123640 */     // GIR_Coverage, 47733,
     /*  123640 */     GIR_EraseRootFromParent_Done,
     /*  123641 */   // Label 2167: @123641
     /*  123641 */   GIM_Reject,
     /*  123642 */ // Label 2165: @123642
     /*  123642 */ GIM_Reject,
     /*  123643 */ // Label 2042: @123643
     /*  123643 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(124253),
     /*  123648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123658 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(123724), // Rule ID 71766 //
     /*  123663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123705 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123722 */     GIR_RootConstrainSelectedInstOperands,
     /*  123723 */     // GIR_Coverage, 71766,
     /*  123723 */     GIR_EraseRootFromParent_Done,
     /*  123724 */   // Label 2169: @123724
     /*  123724 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(123790), // Rule ID 71767 //
     /*  123729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123771 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123788 */     GIR_RootConstrainSelectedInstOperands,
     /*  123789 */     // GIR_Coverage, 71767,
     /*  123789 */     GIR_EraseRootFromParent_Done,
     /*  123790 */   // Label 2170: @123790
     /*  123790 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(123856), // Rule ID 71764 //
     /*  123795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123837 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123854 */     GIR_RootConstrainSelectedInstOperands,
     /*  123855 */     // GIR_Coverage, 71764,
     /*  123855 */     GIR_EraseRootFromParent_Done,
     /*  123856 */   // Label 2171: @123856
     /*  123856 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(123922), // Rule ID 71765 //
     /*  123861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123903 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123920 */     GIR_RootConstrainSelectedInstOperands,
     /*  123921 */     // GIR_Coverage, 71765,
     /*  123921 */     GIR_EraseRootFromParent_Done,
     /*  123922 */   // Label 2172: @123922
     /*  123922 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(123988), // Rule ID 71762 //
     /*  123927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123969 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123986 */     GIR_RootConstrainSelectedInstOperands,
     /*  123987 */     // GIR_Coverage, 71762,
     /*  123987 */     GIR_EraseRootFromParent_Done,
     /*  123988 */   // Label 2173: @123988
     /*  123988 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(124054), // Rule ID 71763 //
     /*  123993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124035 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124052 */     GIR_RootConstrainSelectedInstOperands,
     /*  124053 */     // GIR_Coverage, 71763,
     /*  124053 */     GIR_EraseRootFromParent_Done,
     /*  124054 */   // Label 2174: @124054
     /*  124054 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(124120), // Rule ID 53212 //
     /*  124059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124101 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124118 */     GIR_RootConstrainSelectedInstOperands,
     /*  124119 */     // GIR_Coverage, 53212,
     /*  124119 */     GIR_EraseRootFromParent_Done,
     /*  124120 */   // Label 2175: @124120
     /*  124120 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(124186), // Rule ID 53213 //
     /*  124125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124167 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124184 */     GIR_RootConstrainSelectedInstOperands,
     /*  124185 */     // GIR_Coverage, 53213,
     /*  124185 */     GIR_EraseRootFromParent_Done,
     /*  124186 */   // Label 2176: @124186
     /*  124186 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(124219), // Rule ID 53200 //
     /*  124191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124202 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  124205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124217 */     GIR_RootConstrainSelectedInstOperands,
     /*  124218 */     // GIR_Coverage, 53200,
     /*  124218 */     GIR_EraseRootFromParent_Done,
     /*  124219 */   // Label 2177: @124219
     /*  124219 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(124252), // Rule ID 53201 //
     /*  124224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124235 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  124238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124250 */     GIR_RootConstrainSelectedInstOperands,
     /*  124251 */     // GIR_Coverage, 53201,
     /*  124251 */     GIR_EraseRootFromParent_Done,
     /*  124252 */   // Label 2178: @124252
     /*  124252 */   GIM_Reject,
     /*  124253 */ // Label 2168: @124253
     /*  124253 */ GIM_Reject,
     /*  124254 */ // Label 2043: @124254
     /*  124254 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(124368),
     /*  124259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  124262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  124265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124277 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(124322), // Rule ID 47664 //
     /*  124282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124285 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  124285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  124288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  124302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124320 */     GIR_RootConstrainSelectedInstOperands,
     /*  124321 */     // GIR_Coverage, 47664,
     /*  124321 */     GIR_EraseRootFromParent_Done,
     /*  124322 */   // Label 2180: @124322
     /*  124322 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(124367), // Rule ID 47665 //
     /*  124327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124330 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  124330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  124333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  124347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124365 */     GIR_RootConstrainSelectedInstOperands,
     /*  124366 */     // GIR_Coverage, 47665,
     /*  124366 */     GIR_EraseRootFromParent_Done,
     /*  124367 */   // Label 2181: @124367
     /*  124367 */   GIM_Reject,
     /*  124368 */ // Label 2179: @124368
     /*  124368 */ GIM_Reject,
     /*  124369 */ // Label 2044: @124369
     /*  124369 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(124483),
     /*  124374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  124377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  124380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124392 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(124437), // Rule ID 47684 //
     /*  124397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124400 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  124400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  124403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  124417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124435 */     GIR_RootConstrainSelectedInstOperands,
     /*  124436 */     // GIR_Coverage, 47684,
     /*  124436 */     GIR_EraseRootFromParent_Done,
     /*  124437 */   // Label 2183: @124437
     /*  124437 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(124482), // Rule ID 47685 //
     /*  124442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124445 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  124445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  124448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  124462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124480 */     GIR_RootConstrainSelectedInstOperands,
     /*  124481 */     // GIR_Coverage, 47685,
     /*  124481 */     GIR_EraseRootFromParent_Done,
     /*  124482 */   // Label 2184: @124482
     /*  124482 */   GIM_Reject,
     /*  124483 */ // Label 2182: @124483
     /*  124483 */ GIM_Reject,
     /*  124484 */ // Label 2045: @124484
     /*  124484 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(124598),
     /*  124489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  124492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  124495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124507 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(124552), // Rule ID 47720 //
     /*  124512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124515 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  124515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  124518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124550 */     GIR_RootConstrainSelectedInstOperands,
     /*  124551 */     // GIR_Coverage, 47720,
     /*  124551 */     GIR_EraseRootFromParent_Done,
     /*  124552 */   // Label 2186: @124552
     /*  124552 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(124597), // Rule ID 47721 //
     /*  124557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124560 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  124560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  124563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124595 */     GIR_RootConstrainSelectedInstOperands,
     /*  124596 */     // GIR_Coverage, 47721,
     /*  124596 */     GIR_EraseRootFromParent_Done,
     /*  124597 */   // Label 2187: @124597
     /*  124597 */   GIM_Reject,
     /*  124598 */ // Label 2185: @124598
     /*  124598 */ GIM_Reject,
     /*  124599 */ // Label 2046: @124599
     /*  124599 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(124713),
     /*  124604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  124607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  124610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124618 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124622 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(124667), // Rule ID 47736 //
     /*  124627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  124630 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  124630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  124633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  124647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  124662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124665 */     GIR_RootConstrainSelectedInstOperands,
     /*  124666 */     // GIR_Coverage, 47736,
     /*  124666 */     GIR_EraseRootFromParent_Done,
     /*  124667 */   // Label 2189: @124667
     /*  124667 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(124712), // Rule ID 47737 //
     /*  124672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  124675 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  124675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  124678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  124692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  124707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124710 */     GIR_RootConstrainSelectedInstOperands,
     /*  124711 */     // GIR_Coverage, 47737,
     /*  124711 */     GIR_EraseRootFromParent_Done,
     /*  124712 */   // Label 2190: @124712
     /*  124712 */   GIM_Reject,
     /*  124713 */ // Label 2188: @124713
     /*  124713 */ GIM_Reject,
     /*  124714 */ // Label 2047: @124714
     /*  124714 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(125324),
     /*  124719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124729 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(124795), // Rule ID 71794 //
     /*  124734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124776 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124793 */     GIR_RootConstrainSelectedInstOperands,
     /*  124794 */     // GIR_Coverage, 71794,
     /*  124794 */     GIR_EraseRootFromParent_Done,
     /*  124795 */   // Label 2192: @124795
     /*  124795 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(124861), // Rule ID 71795 //
     /*  124800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124842 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124859 */     GIR_RootConstrainSelectedInstOperands,
     /*  124860 */     // GIR_Coverage, 71795,
     /*  124860 */     GIR_EraseRootFromParent_Done,
     /*  124861 */   // Label 2193: @124861
     /*  124861 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(124927), // Rule ID 71792 //
     /*  124866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124908 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124925 */     GIR_RootConstrainSelectedInstOperands,
     /*  124926 */     // GIR_Coverage, 71792,
     /*  124926 */     GIR_EraseRootFromParent_Done,
     /*  124927 */   // Label 2194: @124927
     /*  124927 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(124993), // Rule ID 71793 //
     /*  124932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124974 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124991 */     GIR_RootConstrainSelectedInstOperands,
     /*  124992 */     // GIR_Coverage, 71793,
     /*  124992 */     GIR_EraseRootFromParent_Done,
     /*  124993 */   // Label 2195: @124993
     /*  124993 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(125059), // Rule ID 71790 //
     /*  124998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125040 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125057 */     GIR_RootConstrainSelectedInstOperands,
     /*  125058 */     // GIR_Coverage, 71790,
     /*  125058 */     GIR_EraseRootFromParent_Done,
     /*  125059 */   // Label 2196: @125059
     /*  125059 */   GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(125125), // Rule ID 71791 //
     /*  125064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125106 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125123 */     GIR_RootConstrainSelectedInstOperands,
     /*  125124 */     // GIR_Coverage, 71791,
     /*  125124 */     GIR_EraseRootFromParent_Done,
     /*  125125 */   // Label 2197: @125125
     /*  125125 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(125191), // Rule ID 53230 //
     /*  125130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125172 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125189 */     GIR_RootConstrainSelectedInstOperands,
     /*  125190 */     // GIR_Coverage, 53230,
     /*  125190 */     GIR_EraseRootFromParent_Done,
     /*  125191 */   // Label 2198: @125191
     /*  125191 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(125257), // Rule ID 53231 //
     /*  125196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125238 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125255 */     GIR_RootConstrainSelectedInstOperands,
     /*  125256 */     // GIR_Coverage, 53231,
     /*  125256 */     GIR_EraseRootFromParent_Done,
     /*  125257 */   // Label 2199: @125257
     /*  125257 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(125290), // Rule ID 53218 //
     /*  125262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125273 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  125276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125288 */     GIR_RootConstrainSelectedInstOperands,
     /*  125289 */     // GIR_Coverage, 53218,
     /*  125289 */     GIR_EraseRootFromParent_Done,
     /*  125290 */   // Label 2200: @125290
     /*  125290 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(125323), // Rule ID 53219 //
     /*  125295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125306 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  125309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125321 */     GIR_RootConstrainSelectedInstOperands,
     /*  125322 */     // GIR_Coverage, 53219,
     /*  125322 */     GIR_EraseRootFromParent_Done,
     /*  125323 */   // Label 2201: @125323
     /*  125323 */   GIM_Reject,
     /*  125324 */ // Label 2191: @125324
     /*  125324 */ GIM_Reject,
     /*  125325 */ // Label 2048: @125325
     /*  125325 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(125439),
     /*  125330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  125333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  125336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125348 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(125393), // Rule ID 47680 //
     /*  125353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125356 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  125356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  125359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  125373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125391 */     GIR_RootConstrainSelectedInstOperands,
     /*  125392 */     // GIR_Coverage, 47680,
     /*  125392 */     GIR_EraseRootFromParent_Done,
     /*  125393 */   // Label 2203: @125393
     /*  125393 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(125438), // Rule ID 47681 //
     /*  125398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125401 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  125401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  125404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  125418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125436 */     GIR_RootConstrainSelectedInstOperands,
     /*  125437 */     // GIR_Coverage, 47681,
     /*  125437 */     GIR_EraseRootFromParent_Done,
     /*  125438 */   // Label 2204: @125438
     /*  125438 */   GIM_Reject,
     /*  125439 */ // Label 2202: @125439
     /*  125439 */ GIM_Reject,
     /*  125440 */ // Label 2049: @125440
     /*  125440 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(125554),
     /*  125445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  125448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  125451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125463 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(125508), // Rule ID 47708 //
     /*  125468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125471 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  125471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  125474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  125503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125506 */     GIR_RootConstrainSelectedInstOperands,
     /*  125507 */     // GIR_Coverage, 47708,
     /*  125507 */     GIR_EraseRootFromParent_Done,
     /*  125508 */   // Label 2206: @125508
     /*  125508 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(125553), // Rule ID 47709 //
     /*  125513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125516 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  125516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  125519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  125548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125551 */     GIR_RootConstrainSelectedInstOperands,
     /*  125552 */     // GIR_Coverage, 47709,
     /*  125552 */     GIR_EraseRootFromParent_Done,
     /*  125553 */   // Label 2207: @125553
     /*  125553 */   GIM_Reject,
     /*  125554 */ // Label 2205: @125554
     /*  125554 */ GIM_Reject,
     /*  125555 */ // Label 2050: @125555
     /*  125555 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(125669),
     /*  125560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  125563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  125566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125578 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(125623), // Rule ID 47724 //
     /*  125583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125586 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  125586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  125589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  125603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  125618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125621 */     GIR_RootConstrainSelectedInstOperands,
     /*  125622 */     // GIR_Coverage, 47724,
     /*  125622 */     GIR_EraseRootFromParent_Done,
     /*  125623 */   // Label 2209: @125623
     /*  125623 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(125668), // Rule ID 47725 //
     /*  125628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125631 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  125631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  125634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  125648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  125663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125666 */     GIR_RootConstrainSelectedInstOperands,
     /*  125667 */     // GIR_Coverage, 47725,
     /*  125667 */     GIR_EraseRootFromParent_Done,
     /*  125668 */   // Label 2210: @125668
     /*  125668 */   GIM_Reject,
     /*  125669 */ // Label 2208: @125669
     /*  125669 */ GIM_Reject,
     /*  125670 */ // Label 2051: @125670
     /*  125670 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(125784),
     /*  125675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  125678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  125681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125693 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(125738), // Rule ID 47740 //
     /*  125698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  125701 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  125701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  125704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  125718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125736 */     GIR_RootConstrainSelectedInstOperands,
     /*  125737 */     // GIR_Coverage, 47740,
     /*  125737 */     GIR_EraseRootFromParent_Done,
     /*  125738 */   // Label 2212: @125738
     /*  125738 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(125783), // Rule ID 47741 //
     /*  125743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  125746 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  125746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  125749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  125763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125781 */     GIR_RootConstrainSelectedInstOperands,
     /*  125782 */     // GIR_Coverage, 47741,
     /*  125782 */     GIR_EraseRootFromParent_Done,
     /*  125783 */   // Label 2213: @125783
     /*  125783 */   GIM_Reject,
     /*  125784 */ // Label 2211: @125784
     /*  125784 */ GIM_Reject,
     /*  125785 */ // Label 2052: @125785
     /*  125785 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(126395),
     /*  125790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125800 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(125866), // Rule ID 71822 //
     /*  125805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125847 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125864 */     GIR_RootConstrainSelectedInstOperands,
     /*  125865 */     // GIR_Coverage, 71822,
     /*  125865 */     GIR_EraseRootFromParent_Done,
     /*  125866 */   // Label 2215: @125866
     /*  125866 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(125932), // Rule ID 71823 //
     /*  125871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125913 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125930 */     GIR_RootConstrainSelectedInstOperands,
     /*  125931 */     // GIR_Coverage, 71823,
     /*  125931 */     GIR_EraseRootFromParent_Done,
     /*  125932 */   // Label 2216: @125932
     /*  125932 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(125998), // Rule ID 71820 //
     /*  125937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125979 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125996 */     GIR_RootConstrainSelectedInstOperands,
     /*  125997 */     // GIR_Coverage, 71820,
     /*  125997 */     GIR_EraseRootFromParent_Done,
     /*  125998 */   // Label 2217: @125998
     /*  125998 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(126064), // Rule ID 71821 //
     /*  126003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126045 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126062 */     GIR_RootConstrainSelectedInstOperands,
     /*  126063 */     // GIR_Coverage, 71821,
     /*  126063 */     GIR_EraseRootFromParent_Done,
     /*  126064 */   // Label 2218: @126064
     /*  126064 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(126130), // Rule ID 71818 //
     /*  126069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126111 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126128 */     GIR_RootConstrainSelectedInstOperands,
     /*  126129 */     // GIR_Coverage, 71818,
     /*  126129 */     GIR_EraseRootFromParent_Done,
     /*  126130 */   // Label 2219: @126130
     /*  126130 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(126196), // Rule ID 71819 //
     /*  126135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126177 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126194 */     GIR_RootConstrainSelectedInstOperands,
     /*  126195 */     // GIR_Coverage, 71819,
     /*  126195 */     GIR_EraseRootFromParent_Done,
     /*  126196 */   // Label 2220: @126196
     /*  126196 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(126262), // Rule ID 53248 //
     /*  126201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126243 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126260 */     GIR_RootConstrainSelectedInstOperands,
     /*  126261 */     // GIR_Coverage, 53248,
     /*  126261 */     GIR_EraseRootFromParent_Done,
     /*  126262 */   // Label 2221: @126262
     /*  126262 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(126328), // Rule ID 53249 //
     /*  126267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126309 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126326 */     GIR_RootConstrainSelectedInstOperands,
     /*  126327 */     // GIR_Coverage, 53249,
     /*  126327 */     GIR_EraseRootFromParent_Done,
     /*  126328 */   // Label 2222: @126328
     /*  126328 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(126361), // Rule ID 53236 //
     /*  126333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126344 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  126347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126359 */     GIR_RootConstrainSelectedInstOperands,
     /*  126360 */     // GIR_Coverage, 53236,
     /*  126360 */     GIR_EraseRootFromParent_Done,
     /*  126361 */   // Label 2223: @126361
     /*  126361 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(126394), // Rule ID 53237 //
     /*  126366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126377 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  126380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126392 */     GIR_RootConstrainSelectedInstOperands,
     /*  126393 */     // GIR_Coverage, 53237,
     /*  126393 */     GIR_EraseRootFromParent_Done,
     /*  126394 */   // Label 2224: @126394
     /*  126394 */   GIM_Reject,
     /*  126395 */ // Label 2214: @126395
     /*  126395 */ GIM_Reject,
     /*  126396 */ // Label 2053: @126396
     /*  126396 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(126510),
     /*  126401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  126404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  126407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126419 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(126464), // Rule ID 47696 //
     /*  126424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126427 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  126427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  126430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  126444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126462 */     GIR_RootConstrainSelectedInstOperands,
     /*  126463 */     // GIR_Coverage, 47696,
     /*  126463 */     GIR_EraseRootFromParent_Done,
     /*  126464 */   // Label 2226: @126464
     /*  126464 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(126509), // Rule ID 47697 //
     /*  126469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126472 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  126472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  126475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  126489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126507 */     GIR_RootConstrainSelectedInstOperands,
     /*  126508 */     // GIR_Coverage, 47697,
     /*  126508 */     GIR_EraseRootFromParent_Done,
     /*  126509 */   // Label 2227: @126509
     /*  126509 */   GIM_Reject,
     /*  126510 */ // Label 2225: @126510
     /*  126510 */ GIM_Reject,
     /*  126511 */ // Label 2054: @126511
     /*  126511 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(126625),
     /*  126516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  126519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  126522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126534 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(126579), // Rule ID 47712 //
     /*  126539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126542 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  126542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  126545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126577 */     GIR_RootConstrainSelectedInstOperands,
     /*  126578 */     // GIR_Coverage, 47712,
     /*  126578 */     GIR_EraseRootFromParent_Done,
     /*  126579 */   // Label 2229: @126579
     /*  126579 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(126624), // Rule ID 47713 //
     /*  126584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126587 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  126587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  126590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126622 */     GIR_RootConstrainSelectedInstOperands,
     /*  126623 */     // GIR_Coverage, 47713,
     /*  126623 */     GIR_EraseRootFromParent_Done,
     /*  126624 */   // Label 2230: @126624
     /*  126624 */   GIM_Reject,
     /*  126625 */ // Label 2228: @126625
     /*  126625 */ GIM_Reject,
     /*  126626 */ // Label 2055: @126626
     /*  126626 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(126740),
     /*  126631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  126634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  126637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126649 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(126694), // Rule ID 47728 //
     /*  126654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126657 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  126657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  126660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  126674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126692 */     GIR_RootConstrainSelectedInstOperands,
     /*  126693 */     // GIR_Coverage, 47728,
     /*  126693 */     GIR_EraseRootFromParent_Done,
     /*  126694 */   // Label 2232: @126694
     /*  126694 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(126739), // Rule ID 47729 //
     /*  126699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126702 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  126702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  126705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  126719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126737 */     GIR_RootConstrainSelectedInstOperands,
     /*  126738 */     // GIR_Coverage, 47729,
     /*  126738 */     GIR_EraseRootFromParent_Done,
     /*  126739 */   // Label 2233: @126739
     /*  126739 */   GIM_Reject,
     /*  126740 */ // Label 2231: @126740
     /*  126740 */ GIM_Reject,
     /*  126741 */ // Label 2056: @126741
     /*  126741 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(127351),
     /*  126746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126756 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(126822), // Rule ID 71850 //
     /*  126761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126801 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126803 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126820 */     GIR_RootConstrainSelectedInstOperands,
     /*  126821 */     // GIR_Coverage, 71850,
     /*  126821 */     GIR_EraseRootFromParent_Done,
     /*  126822 */   // Label 2235: @126822
     /*  126822 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(126888), // Rule ID 71851 //
     /*  126827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126869 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126886 */     GIR_RootConstrainSelectedInstOperands,
     /*  126887 */     // GIR_Coverage, 71851,
     /*  126887 */     GIR_EraseRootFromParent_Done,
     /*  126888 */   // Label 2236: @126888
     /*  126888 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(126954), // Rule ID 71848 //
     /*  126893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126935 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126952 */     GIR_RootConstrainSelectedInstOperands,
     /*  126953 */     // GIR_Coverage, 71848,
     /*  126953 */     GIR_EraseRootFromParent_Done,
     /*  126954 */   // Label 2237: @126954
     /*  126954 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(127020), // Rule ID 71849 //
     /*  126959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127001 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127018 */     GIR_RootConstrainSelectedInstOperands,
     /*  127019 */     // GIR_Coverage, 71849,
     /*  127019 */     GIR_EraseRootFromParent_Done,
     /*  127020 */   // Label 2238: @127020
     /*  127020 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(127086), // Rule ID 71846 //
     /*  127025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127067 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127084 */     GIR_RootConstrainSelectedInstOperands,
     /*  127085 */     // GIR_Coverage, 71846,
     /*  127085 */     GIR_EraseRootFromParent_Done,
     /*  127086 */   // Label 2239: @127086
     /*  127086 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(127152), // Rule ID 71847 //
     /*  127091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127133 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127150 */     GIR_RootConstrainSelectedInstOperands,
     /*  127151 */     // GIR_Coverage, 71847,
     /*  127151 */     GIR_EraseRootFromParent_Done,
     /*  127152 */   // Label 2240: @127152
     /*  127152 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(127218), // Rule ID 53266 //
     /*  127157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127199 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127216 */     GIR_RootConstrainSelectedInstOperands,
     /*  127217 */     // GIR_Coverage, 53266,
     /*  127217 */     GIR_EraseRootFromParent_Done,
     /*  127218 */   // Label 2241: @127218
     /*  127218 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(127284), // Rule ID 53267 //
     /*  127223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127265 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127282 */     GIR_RootConstrainSelectedInstOperands,
     /*  127283 */     // GIR_Coverage, 53267,
     /*  127283 */     GIR_EraseRootFromParent_Done,
     /*  127284 */   // Label 2242: @127284
     /*  127284 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(127317), // Rule ID 53254 //
     /*  127289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127300 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  127303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127315 */     GIR_RootConstrainSelectedInstOperands,
     /*  127316 */     // GIR_Coverage, 53254,
     /*  127316 */     GIR_EraseRootFromParent_Done,
     /*  127317 */   // Label 2243: @127317
     /*  127317 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(127350), // Rule ID 53255 //
     /*  127322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127333 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  127336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127348 */     GIR_RootConstrainSelectedInstOperands,
     /*  127349 */     // GIR_Coverage, 53255,
     /*  127349 */     GIR_EraseRootFromParent_Done,
     /*  127350 */   // Label 2244: @127350
     /*  127350 */   GIM_Reject,
     /*  127351 */ // Label 2234: @127351
     /*  127351 */ GIM_Reject,
     /*  127352 */ // Label 2057: @127352
     /*  127352 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(127466),
     /*  127357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  127360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  127363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127375 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(127420), // Rule ID 47700 //
     /*  127380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127383 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  127383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  127386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  127400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127418 */     GIR_RootConstrainSelectedInstOperands,
     /*  127419 */     // GIR_Coverage, 47700,
     /*  127419 */     GIR_EraseRootFromParent_Done,
     /*  127420 */   // Label 2246: @127420
     /*  127420 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(127465), // Rule ID 47701 //
     /*  127425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127428 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  127428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  127431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  127445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127463 */     GIR_RootConstrainSelectedInstOperands,
     /*  127464 */     // GIR_Coverage, 47701,
     /*  127464 */     GIR_EraseRootFromParent_Done,
     /*  127465 */   // Label 2247: @127465
     /*  127465 */   GIM_Reject,
     /*  127466 */ // Label 2245: @127466
     /*  127466 */ GIM_Reject,
     /*  127467 */ // Label 2058: @127467
     /*  127467 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(127581),
     /*  127472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  127475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  127478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127490 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(127535), // Rule ID 47716 //
     /*  127495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127498 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  127498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  127501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127533 */     GIR_RootConstrainSelectedInstOperands,
     /*  127534 */     // GIR_Coverage, 47716,
     /*  127534 */     GIR_EraseRootFromParent_Done,
     /*  127535 */   // Label 2249: @127535
     /*  127535 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(127580), // Rule ID 47717 //
     /*  127540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127543 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  127543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  127546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127578 */     GIR_RootConstrainSelectedInstOperands,
     /*  127579 */     // GIR_Coverage, 47717,
     /*  127579 */     GIR_EraseRootFromParent_Done,
     /*  127580 */   // Label 2250: @127580
     /*  127580 */   GIM_Reject,
     /*  127581 */ // Label 2248: @127581
     /*  127581 */ GIM_Reject,
     /*  127582 */ // Label 2059: @127582
     /*  127582 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(128192),
     /*  127587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127597 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(127663), // Rule ID 71878 //
     /*  127602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127644 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127661 */     GIR_RootConstrainSelectedInstOperands,
     /*  127662 */     // GIR_Coverage, 71878,
     /*  127662 */     GIR_EraseRootFromParent_Done,
     /*  127663 */   // Label 2252: @127663
     /*  127663 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(127729), // Rule ID 71879 //
     /*  127668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127710 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127727 */     GIR_RootConstrainSelectedInstOperands,
     /*  127728 */     // GIR_Coverage, 71879,
     /*  127728 */     GIR_EraseRootFromParent_Done,
     /*  127729 */   // Label 2253: @127729
     /*  127729 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(127795), // Rule ID 71876 //
     /*  127734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127776 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127793 */     GIR_RootConstrainSelectedInstOperands,
     /*  127794 */     // GIR_Coverage, 71876,
     /*  127794 */     GIR_EraseRootFromParent_Done,
     /*  127795 */   // Label 2254: @127795
     /*  127795 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(127861), // Rule ID 71877 //
     /*  127800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127842 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127859 */     GIR_RootConstrainSelectedInstOperands,
     /*  127860 */     // GIR_Coverage, 71877,
     /*  127860 */     GIR_EraseRootFromParent_Done,
     /*  127861 */   // Label 2255: @127861
     /*  127861 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(127927), // Rule ID 71874 //
     /*  127866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127908 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127925 */     GIR_RootConstrainSelectedInstOperands,
     /*  127926 */     // GIR_Coverage, 71874,
     /*  127926 */     GIR_EraseRootFromParent_Done,
     /*  127927 */   // Label 2256: @127927
     /*  127927 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(127993), // Rule ID 71875 //
     /*  127932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127974 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127991 */     GIR_RootConstrainSelectedInstOperands,
     /*  127992 */     // GIR_Coverage, 71875,
     /*  127992 */     GIR_EraseRootFromParent_Done,
     /*  127993 */   // Label 2257: @127993
     /*  127993 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(128059), // Rule ID 53284 //
     /*  127998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128040 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128057 */     GIR_RootConstrainSelectedInstOperands,
     /*  128058 */     // GIR_Coverage, 53284,
     /*  128058 */     GIR_EraseRootFromParent_Done,
     /*  128059 */   // Label 2258: @128059
     /*  128059 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(128125), // Rule ID 53285 //
     /*  128064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128106 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128123 */     GIR_RootConstrainSelectedInstOperands,
     /*  128124 */     // GIR_Coverage, 53285,
     /*  128124 */     GIR_EraseRootFromParent_Done,
     /*  128125 */   // Label 2259: @128125
     /*  128125 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(128158), // Rule ID 53272 //
     /*  128130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128141 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  128144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128156 */     GIR_RootConstrainSelectedInstOperands,
     /*  128157 */     // GIR_Coverage, 53272,
     /*  128157 */     GIR_EraseRootFromParent_Done,
     /*  128158 */   // Label 2260: @128158
     /*  128158 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(128191), // Rule ID 53273 //
     /*  128163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128174 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  128177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128189 */     GIR_RootConstrainSelectedInstOperands,
     /*  128190 */     // GIR_Coverage, 53273,
     /*  128190 */     GIR_EraseRootFromParent_Done,
     /*  128191 */   // Label 2261: @128191
     /*  128191 */   GIM_Reject,
     /*  128192 */ // Label 2251: @128192
     /*  128192 */ GIM_Reject,
     /*  128193 */ // Label 2060: @128193
     /*  128193 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(128307),
     /*  128198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  128201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  128204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128216 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(128261), // Rule ID 47704 //
     /*  128221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128224 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  128224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  128227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  128231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  128241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128259 */     GIR_RootConstrainSelectedInstOperands,
     /*  128260 */     // GIR_Coverage, 47704,
     /*  128260 */     GIR_EraseRootFromParent_Done,
     /*  128261 */   // Label 2263: @128261
     /*  128261 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(128306), // Rule ID 47705 //
     /*  128266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128269 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  128269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  128272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  128276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  128286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128304 */     GIR_RootConstrainSelectedInstOperands,
     /*  128305 */     // GIR_Coverage, 47705,
     /*  128305 */     GIR_EraseRootFromParent_Done,
     /*  128306 */   // Label 2264: @128306
     /*  128306 */   GIM_Reject,
     /*  128307 */ // Label 2262: @128307
     /*  128307 */ GIM_Reject,
     /*  128308 */ // Label 2061: @128308
     /*  128308 */ GIM_Reject,
     /*  128309 */ // Label 8: @128309
     /*  128309 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2296*/ GIMT_Encode4(140929),
     /*  128320 */ /*GILLT_s32*//*Label 2265*/ GIMT_Encode4(128444),
     /*  128324 */ /*GILLT_s64*//*Label 2266*/ GIMT_Encode4(131174),
     /*  128328 */ /*GILLT_nxv1s1*//*Label 2267*/ GIMT_Encode4(134122),
     /*  128332 */ /*GILLT_nxv1s8*//*Label 2268*/ GIMT_Encode4(134733),
     /*  128336 */ /*GILLT_nxv1s16*//*Label 2269*/ GIMT_Encode4(134848),
     /*  128340 */ /*GILLT_nxv1s32*//*Label 2270*/ GIMT_Encode4(134963),
     /*  128344 */ /*GILLT_nxv1s64*//*Label 2271*/ GIMT_Encode4(135078),
     /*  128348 */ /*GILLT_nxv2s1*//*Label 2272*/ GIMT_Encode4(135193),
     /*  128352 */ /*GILLT_nxv2s8*//*Label 2273*/ GIMT_Encode4(135804),
     /*  128356 */ /*GILLT_nxv2s16*//*Label 2274*/ GIMT_Encode4(135919),
     /*  128360 */ /*GILLT_nxv2s32*//*Label 2275*/ GIMT_Encode4(136034),
     /*  128364 */ /*GILLT_nxv2s64*//*Label 2276*/ GIMT_Encode4(136149),
     /*  128368 */ /*GILLT_nxv4s1*//*Label 2277*/ GIMT_Encode4(136264),
     /*  128372 */ /*GILLT_nxv4s8*//*Label 2278*/ GIMT_Encode4(136875),
     /*  128376 */ /*GILLT_nxv4s16*//*Label 2279*/ GIMT_Encode4(136990),
     /*  128380 */ /*GILLT_nxv4s32*//*Label 2280*/ GIMT_Encode4(137105),
     /*  128384 */ /*GILLT_nxv4s64*//*Label 2281*/ GIMT_Encode4(137220),
     /*  128388 */ /*GILLT_nxv8s1*//*Label 2282*/ GIMT_Encode4(137335),
     /*  128392 */ /*GILLT_nxv8s8*//*Label 2283*/ GIMT_Encode4(137946),
     /*  128396 */ /*GILLT_nxv8s16*//*Label 2284*/ GIMT_Encode4(138061),
     /*  128400 */ /*GILLT_nxv8s32*//*Label 2285*/ GIMT_Encode4(138176),
     /*  128404 */ /*GILLT_nxv8s64*//*Label 2286*/ GIMT_Encode4(138291),
     /*  128408 */ /*GILLT_nxv16s1*//*Label 2287*/ GIMT_Encode4(138406),
     /*  128412 */ /*GILLT_nxv16s8*//*Label 2288*/ GIMT_Encode4(139017),
     /*  128416 */ /*GILLT_nxv16s16*//*Label 2289*/ GIMT_Encode4(139132),
     /*  128420 */ /*GILLT_nxv16s32*//*Label 2290*/ GIMT_Encode4(139247),
     /*  128424 */ /*GILLT_nxv32s1*//*Label 2291*/ GIMT_Encode4(139362),
     /*  128428 */ /*GILLT_nxv32s8*//*Label 2292*/ GIMT_Encode4(139973),
     /*  128432 */ /*GILLT_nxv32s16*//*Label 2293*/ GIMT_Encode4(140088),
     /*  128436 */ /*GILLT_nxv64s1*//*Label 2294*/ GIMT_Encode4(140203),
     /*  128440 */ /*GILLT_nxv64s8*//*Label 2295*/ GIMT_Encode4(140814),
     /*  128444 */ // Label 2265: @128444
     /*  128444 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(131173),
     /*  128449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  128452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  128455 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(128650), // Rule ID 65528 //
     /*  128460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128499 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128511 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128515 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128519 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128523 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128527 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128531 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128535 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  128539 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128543 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128547 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128551 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128555 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  128559 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128575 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128582 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128589 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128589 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128592 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128596 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  128606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  128611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  128630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  128635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128648 */     GIR_RootConstrainSelectedInstOperands,
     /*  128649 */     // GIR_Coverage, 65528,
     /*  128649 */     GIR_EraseRootFromParent_Done,
     /*  128650 */   // Label 2298: @128650
     /*  128650 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(128845), // Rule ID 65530 //
     /*  128655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128694 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128706 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128710 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128714 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128718 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128722 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128726 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128730 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  128734 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128738 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128742 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128746 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128750 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  128754 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128763 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128770 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128777 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128784 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  128801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  128806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  128825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  128830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128843 */     GIR_RootConstrainSelectedInstOperands,
     /*  128844 */     // GIR_Coverage, 65530,
     /*  128844 */     GIR_EraseRootFromParent_Done,
     /*  128845 */   // Label 2299: @128845
     /*  128845 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(129040), // Rule ID 65524 //
     /*  128850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128889 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128901 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128905 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128909 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128913 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128917 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128921 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128925 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  128929 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128933 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128937 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128941 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128945 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  128949 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128965 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128972 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128979 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128979 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128982 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128986 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  128996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  129001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  129020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  129025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129038 */     GIR_RootConstrainSelectedInstOperands,
     /*  129039 */     // GIR_Coverage, 65524,
     /*  129039 */     GIR_EraseRootFromParent_Done,
     /*  129040 */   // Label 2300: @129040
     /*  129040 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(129235), // Rule ID 65526 //
     /*  129045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129084 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  129088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  129092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129096 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129100 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  129108 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129112 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129116 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129120 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  129124 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  129128 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129132 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129136 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129140 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  129144 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129153 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129160 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129167 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129174 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129174 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129177 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129181 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  129191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  129196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  129215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  129220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129233 */     GIR_RootConstrainSelectedInstOperands,
     /*  129234 */     // GIR_Coverage, 65526,
     /*  129234 */     GIR_EraseRootFromParent_Done,
     /*  129235 */   // Label 2301: @129235
     /*  129235 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(129430), // Rule ID 65518 //
     /*  129240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129279 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  129283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129291 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129295 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129299 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  129303 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129307 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129311 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129315 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129319 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  129323 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129327 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129331 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129335 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129339 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129348 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129355 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129362 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129369 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129369 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129372 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129376 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  129386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  129391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  129410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  129415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129428 */     GIR_RootConstrainSelectedInstOperands,
     /*  129429 */     // GIR_Coverage, 65518,
     /*  129429 */     GIR_EraseRootFromParent_Done,
     /*  129430 */   // Label 2302: @129430
     /*  129430 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(129625), // Rule ID 65522 //
     /*  129435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129474 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  129478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129490 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129494 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  129498 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129502 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129506 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129510 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129514 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  129518 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129522 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129526 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129530 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129534 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129543 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129550 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129557 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129564 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129564 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129567 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129571 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  129581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  129586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  129605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  129610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129623 */     GIR_RootConstrainSelectedInstOperands,
     /*  129624 */     // GIR_Coverage, 65522,
     /*  129624 */     GIR_EraseRootFromParent_Done,
     /*  129625 */   // Label 2303: @129625
     /*  129625 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(129820), // Rule ID 2553 //
     /*  129630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129669 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  129673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129677 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129681 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129685 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129689 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  129693 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129697 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129701 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129705 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129709 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  129713 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129717 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129721 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129725 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129729 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129738 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129745 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129752 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129759 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129759 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129762 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129766 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  129776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  129781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  129800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  129805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129818 */     GIR_RootConstrainSelectedInstOperands,
     /*  129819 */     // GIR_Coverage, 2553,
     /*  129819 */     GIR_EraseRootFromParent_Done,
     /*  129820 */   // Label 2304: @129820
     /*  129820 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(130015), // Rule ID 65520 //
     /*  129825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129864 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  129868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129876 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129880 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129884 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  129888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129892 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129896 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129900 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129904 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  129908 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129912 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129916 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129920 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129924 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129926 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129933 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129940 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129947 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129954 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129954 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129957 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129961 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  129971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  129976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  129995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  130000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  130013 */     GIR_RootConstrainSelectedInstOperands,
     /*  130014 */     // GIR_Coverage, 65520,
     /*  130014 */     GIR_EraseRootFromParent_Done,
     /*  130015 */   // Label 2305: @130015
     /*  130015 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(130120), // Rule ID 2548 //
     /*  130020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130043 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  130047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  130051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130063 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  130067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130076 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130083 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  130083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  130100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  130110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  130118 */     GIR_RootConstrainSelectedInstOperands,
     /*  130119 */     // GIR_Coverage, 2548,
     /*  130119 */     GIR_EraseRootFromParent_Done,
     /*  130120 */   // Label 2306: @130120
     /*  130120 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(130225), // Rule ID 65513 //
     /*  130125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130148 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  130152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  130156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130168 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  130172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130188 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  130188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  130210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  130215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  130223 */     GIR_RootConstrainSelectedInstOperands,
     /*  130224 */     // GIR_Coverage, 65513,
     /*  130224 */     GIR_EraseRootFromParent_Done,
     /*  130225 */   // Label 2307: @130225
     /*  130225 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(130314), // Rule ID 65507 //
     /*  130230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  130245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130274 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  130278 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  130289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130298 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  130312 */     GIR_RootConstrainSelectedInstOperands,
     /*  130313 */     // GIR_Coverage, 65507,
     /*  130313 */     GIR_EraseRootFromParent_Done,
     /*  130314 */   // Label 2308: @130314
     /*  130314 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(130403), // Rule ID 2542 //
     /*  130319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  130334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130363 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  130367 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  130378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130387 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  130401 */     GIR_RootConstrainSelectedInstOperands,
     /*  130402 */     // GIR_Coverage, 2542,
     /*  130402 */     GIR_EraseRootFromParent_Done,
     /*  130403 */   // Label 2309: @130403
     /*  130403 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(130468), // Rule ID 65509 //
     /*  130408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130431 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130451 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  130466 */     GIR_RootConstrainSelectedInstOperands,
     /*  130467 */     // GIR_Coverage, 65509,
     /*  130467 */     GIR_EraseRootFromParent_Done,
     /*  130468 */   // Label 2310: @130468
     /*  130468 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(130533), // Rule ID 2544 //
     /*  130473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130496 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130516 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  130526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130531 */     GIR_RootConstrainSelectedInstOperands,
     /*  130532 */     // GIR_Coverage, 2544,
     /*  130532 */     GIR_EraseRootFromParent_Done,
     /*  130533 */   // Label 2311: @130533
     /*  130533 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(130599), // Rule ID 65515 //
     /*  130538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130566 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130570 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11278),
     /*  130574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130583 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }))<<P:Predicate_anonymous_11278>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130597 */     GIR_RootConstrainSelectedInstOperands,
     /*  130598 */     // GIR_Coverage, 65515,
     /*  130598 */     GIR_EraseRootFromParent_Done,
     /*  130599 */   // Label 2312: @130599
     /*  130599 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(130665), // Rule ID 2550 //
     /*  130604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130632 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11278),
     /*  130640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130649 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))<<P:Predicate_anonymous_11278>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130663 */     GIR_RootConstrainSelectedInstOperands,
     /*  130664 */     // GIR_Coverage, 2550,
     /*  130664 */     GIR_EraseRootFromParent_Done,
     /*  130665 */   // Label 2313: @130665
     /*  130665 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(130727), // Rule ID 2551 //
     /*  130670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  130673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130698 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  130702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  130711 */     // (or:{ *:[i32] } (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130725 */     GIR_RootConstrainSelectedInstOperands,
     /*  130726 */     // GIR_Coverage, 2551,
     /*  130726 */     GIR_EraseRootFromParent_Done,
     /*  130727 */   // Label 2314: @130727
     /*  130727 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(130789), // Rule ID 65516 //
     /*  130732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  130735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130760 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  130764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  130773 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }), (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130787 */     GIR_RootConstrainSelectedInstOperands,
     /*  130788 */     // GIR_Coverage, 65516,
     /*  130788 */     GIR_EraseRootFromParent_Done,
     /*  130789 */   // Label 2315: @130789
     /*  130789 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(130848), // Rule ID 2477 //
     /*  130794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  130797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130817 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  130821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  130834 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  130837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130846 */     GIR_RootConstrainSelectedInstOperands,
     /*  130847 */     // GIR_Coverage, 2477,
     /*  130847 */     GIR_EraseRootFromParent_Done,
     /*  130848 */   // Label 2316: @130848
     /*  130848 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(130907), // Rule ID 65503 //
     /*  130853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  130856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130880 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  130884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  130893 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  130896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130905 */     GIR_RootConstrainSelectedInstOperands,
     /*  130906 */     // GIR_Coverage, 65503,
     /*  130906 */     GIR_EraseRootFromParent_Done,
     /*  130907 */   // Label 2317: @130907
     /*  130907 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(130963), // Rule ID 65487 //
     /*  130912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  130915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130940 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  130944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130950 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  130953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130961 */     GIR_RootConstrainSelectedInstOperands,
     /*  130962 */     // GIR_Coverage, 65487,
     /*  130962 */     GIR_EraseRootFromParent_Done,
     /*  130963 */   // Label 2318: @130963
     /*  130963 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(131019), // Rule ID 2449 //
     /*  130968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  130971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131000 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  131004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131006 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  131009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131017 */     GIR_RootConstrainSelectedInstOperands,
     /*  131018 */     // GIR_Coverage, 2449,
     /*  131018 */     GIR_EraseRootFromParent_Done,
     /*  131019 */   // Label 2319: @131019
     /*  131019 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(131061), // Rule ID 87 //
     /*  131024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  131027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  131047 */     // MIs[1] Operand 1
     /*  131047 */     // No operand predicates
     /*  131047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131049 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  131049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  131052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  131059 */     GIR_RootConstrainSelectedInstOperands,
     /*  131060 */     // GIR_Coverage, 87,
     /*  131060 */     GIR_EraseRootFromParent_Done,
     /*  131061 */   // Label 2320: @131061
     /*  131061 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(131103), // Rule ID 64532 //
     /*  131066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  131069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  131089 */     // MIs[1] Operand 1
     /*  131089 */     // No operand predicates
     /*  131089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131091 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  131091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORAI),
     /*  131094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  131096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  131101 */     GIR_RootConstrainSelectedInstOperands,
     /*  131102 */     // GIR_Coverage, 64532,
     /*  131102 */     GIR_EraseRootFromParent_Done,
     /*  131103 */   // Label 2321: @131103
     /*  131103 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(131145), // Rule ID 64536 //
     /*  131108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  131111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  131131 */     // MIs[1] Operand 1
     /*  131131 */     // No operand predicates
     /*  131131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131133 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  131133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORI),
     /*  131136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  131143 */     GIR_RootConstrainSelectedInstOperands,
     /*  131144 */     // GIR_Coverage, 64536,
     /*  131144 */     GIR_EraseRootFromParent_Done,
     /*  131145 */   // Label 2322: @131145
     /*  131145 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(131172), // Rule ID 85 //
     /*  131150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  131153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131165 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (OR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  131170 */     GIR_RootConstrainSelectedInstOperands,
     /*  131171 */     // GIR_Coverage, 85,
     /*  131171 */     GIR_Done,
     /*  131172 */   // Label 2323: @131172
     /*  131172 */   GIM_Reject,
     /*  131173 */ // Label 2297: @131173
     /*  131173 */ GIM_Reject,
     /*  131174 */ // Label 2266: @131174
     /*  131174 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(134121),
     /*  131179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  131182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  131185 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(131380), // Rule ID 65527 //
     /*  131190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  131217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131229 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131241 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131245 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131249 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131253 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131257 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131261 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131265 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  131269 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131273 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131277 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131281 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131285 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  131289 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131305 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131312 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131319 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131319 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131322 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131326 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  131336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  131341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  131360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  131365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131378 */     GIR_RootConstrainSelectedInstOperands,
     /*  131379 */     // GIR_Coverage, 65527,
     /*  131379 */     GIR_EraseRootFromParent_Done,
     /*  131380 */   // Label 2325: @131380
     /*  131380 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(131575), // Rule ID 65529 //
     /*  131385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  131412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131424 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131436 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131440 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131444 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131448 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131452 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131456 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131460 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  131464 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131468 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131472 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131476 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131480 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  131484 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131500 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131507 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131514 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131514 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131517 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131521 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  131531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  131536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  131555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  131560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131573 */     GIR_RootConstrainSelectedInstOperands,
     /*  131574 */     // GIR_Coverage, 65529,
     /*  131574 */     GIR_EraseRootFromParent_Done,
     /*  131575 */   // Label 2326: @131575
     /*  131575 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(131770), // Rule ID 65523 //
     /*  131580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131619 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131631 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131635 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131639 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131643 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131647 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131651 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131655 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  131659 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131663 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131667 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131671 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131675 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  131679 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131688 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131695 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131702 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131709 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131709 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131712 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131716 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  131726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  131731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  131750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  131755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131768 */     GIR_RootConstrainSelectedInstOperands,
     /*  131769 */     // GIR_Coverage, 65523,
     /*  131769 */     GIR_EraseRootFromParent_Done,
     /*  131770 */   // Label 2327: @131770
     /*  131770 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(131965), // Rule ID 65525 //
     /*  131775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131814 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131826 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131830 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131834 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131838 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131842 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131846 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131850 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  131854 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131858 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131862 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131866 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131870 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  131874 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131890 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131897 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131904 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131904 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131907 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131911 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  131921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  131926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  131945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  131950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131963 */     GIR_RootConstrainSelectedInstOperands,
     /*  131964 */     // GIR_Coverage, 65525,
     /*  131964 */     GIR_EraseRootFromParent_Done,
     /*  131965 */   // Label 2328: @131965
     /*  131965 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(132160), // Rule ID 65517 //
     /*  131970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132009 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  132013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132021 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132025 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132029 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  132033 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132037 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132041 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132045 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132049 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  132053 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132057 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132061 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132065 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132069 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132078 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132085 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132092 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132099 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  132116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  132121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  132140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  132145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132158 */     GIR_RootConstrainSelectedInstOperands,
     /*  132159 */     // GIR_Coverage, 65517,
     /*  132159 */     GIR_EraseRootFromParent_Done,
     /*  132160 */   // Label 2329: @132160
     /*  132160 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(132355), // Rule ID 65521 //
     /*  132165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132204 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132216 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132220 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132224 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  132228 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132232 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132236 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132240 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132244 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  132248 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132252 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132256 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132260 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132264 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132273 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132280 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132287 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132294 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132294 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132297 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132301 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  132311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  132316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  132335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  132340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132353 */     GIR_RootConstrainSelectedInstOperands,
     /*  132354 */     // GIR_Coverage, 65521,
     /*  132354 */     GIR_EraseRootFromParent_Done,
     /*  132355 */   // Label 2330: @132355
     /*  132355 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(132550), // Rule ID 2552 //
     /*  132360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132399 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  132403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132411 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132415 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132419 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  132423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132435 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132439 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  132443 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132447 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132451 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132455 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132459 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132461 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132468 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132475 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132482 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132489 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132489 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132492 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132496 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  132506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  132511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  132530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  132535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132548 */     GIR_RootConstrainSelectedInstOperands,
     /*  132549 */     // GIR_Coverage, 2552,
     /*  132549 */     GIR_EraseRootFromParent_Done,
     /*  132550 */   // Label 2331: @132550
     /*  132550 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(132745), // Rule ID 65519 //
     /*  132555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132594 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132606 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132610 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132614 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  132618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132622 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132626 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132630 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132634 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  132638 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132642 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132646 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132650 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132654 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132656 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132663 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132670 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132677 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132684 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132684 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132687 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132691 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  132701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  132706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  132725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  132730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132743 */     GIR_RootConstrainSelectedInstOperands,
     /*  132744 */     // GIR_Coverage, 65519,
     /*  132744 */     GIR_EraseRootFromParent_Done,
     /*  132745 */   // Label 2332: @132745
     /*  132745 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(132850), // Rule ID 2547 //
     /*  132750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132773 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  132777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  132781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132793 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132813 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  132813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  132830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  132835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  132840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  132848 */     GIR_RootConstrainSelectedInstOperands,
     /*  132849 */     // GIR_Coverage, 2547,
     /*  132849 */     GIR_EraseRootFromParent_Done,
     /*  132850 */   // Label 2333: @132850
     /*  132850 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(132955), // Rule ID 65512 //
     /*  132855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132878 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  132882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  132886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132898 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  132902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132918 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  132918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  132940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  132945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  132953 */     GIR_RootConstrainSelectedInstOperands,
     /*  132954 */     // GIR_Coverage, 65512,
     /*  132954 */     GIR_EraseRootFromParent_Done,
     /*  132955 */   // Label 2334: @132955
     /*  132955 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(133044), // Rule ID 65506 //
     /*  132960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  132971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  132975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132995 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133004 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  133008 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  133019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133028 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133042 */     GIR_RootConstrainSelectedInstOperands,
     /*  133043 */     // GIR_Coverage, 65506,
     /*  133043 */     GIR_EraseRootFromParent_Done,
     /*  133044 */   // Label 2335: @133044
     /*  133044 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(133133), // Rule ID 2541 //
     /*  133049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  133064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133093 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  133097 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  133108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133117 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133131 */     GIR_RootConstrainSelectedInstOperands,
     /*  133132 */     // GIR_Coverage, 2541,
     /*  133132 */     GIR_EraseRootFromParent_Done,
     /*  133133 */   // Label 2336: @133133
     /*  133133 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133198), // Rule ID 65508 //
     /*  133138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133161 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133181 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  133196 */     GIR_RootConstrainSelectedInstOperands,
     /*  133197 */     // GIR_Coverage, 65508,
     /*  133197 */     GIR_EraseRootFromParent_Done,
     /*  133198 */   // Label 2337: @133198
     /*  133198 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133263), // Rule ID 2543 //
     /*  133203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133226 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133246 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  133256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133261 */     GIR_RootConstrainSelectedInstOperands,
     /*  133262 */     // GIR_Coverage, 2543,
     /*  133262 */     GIR_EraseRootFromParent_Done,
     /*  133263 */   // Label 2338: @133263
     /*  133263 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133348), // Rule ID 65533 //
     /*  133268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  133283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133308 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  133312 */     // MIs[1] Operand 2
     /*  133312 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  133323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133332 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133346 */     GIR_RootConstrainSelectedInstOperands,
     /*  133347 */     // GIR_Coverage, 65533,
     /*  133347 */     GIR_EraseRootFromParent_Done,
     /*  133348 */   // Label 2339: @133348
     /*  133348 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133433), // Rule ID 2556 //
     /*  133353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  133368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133393 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  133397 */     // MIs[1] Operand 2
     /*  133397 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  133408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133417 */     // (or:{ *:[i64] } (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133431 */     GIR_RootConstrainSelectedInstOperands,
     /*  133432 */     // GIR_Coverage, 2556,
     /*  133432 */     GIR_EraseRootFromParent_Done,
     /*  133433 */   // Label 2340: @133433
     /*  133433 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(133499), // Rule ID 65514 //
     /*  133438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133466 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133470 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11278),
     /*  133474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133483 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }))<<P:Predicate_anonymous_11278>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133497 */     GIR_RootConstrainSelectedInstOperands,
     /*  133498 */     // GIR_Coverage, 65514,
     /*  133498 */     GIR_EraseRootFromParent_Done,
     /*  133499 */   // Label 2341: @133499
     /*  133499 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(133565), // Rule ID 65532 //
     /*  133504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133532 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  133536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10054),
     /*  133540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133549 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }))<<P:Predicate_anonymous_10054>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133563 */     GIR_RootConstrainSelectedInstOperands,
     /*  133564 */     // GIR_Coverage, 65532,
     /*  133564 */     GIR_EraseRootFromParent_Done,
     /*  133565 */   // Label 2342: @133565
     /*  133565 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(133631), // Rule ID 2549 //
     /*  133570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133598 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133602 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11278),
     /*  133606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133615 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_11278>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133629 */     GIR_RootConstrainSelectedInstOperands,
     /*  133630 */     // GIR_Coverage, 2549,
     /*  133630 */     GIR_EraseRootFromParent_Done,
     /*  133631 */   // Label 2343: @133631
     /*  133631 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(133697), // Rule ID 2555 //
     /*  133636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133664 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  133668 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10054),
     /*  133672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133681 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_10054>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133695 */     GIR_RootConstrainSelectedInstOperands,
     /*  133696 */     // GIR_Coverage, 2555,
     /*  133696 */     GIR_EraseRootFromParent_Done,
     /*  133697 */   // Label 2344: @133697
     /*  133697 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(133759), // Rule ID 2554 //
     /*  133702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133730 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  133734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  133743 */     // (or:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  133746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133757 */     GIR_RootConstrainSelectedInstOperands,
     /*  133758 */     // GIR_Coverage, 2554,
     /*  133758 */     GIR_EraseRootFromParent_Done,
     /*  133759 */   // Label 2345: @133759
     /*  133759 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(133821), // Rule ID 65531 //
     /*  133764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133792 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  133796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  133805 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }), (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  133808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133819 */     GIR_RootConstrainSelectedInstOperands,
     /*  133820 */     // GIR_Coverage, 65531,
     /*  133820 */     GIR_EraseRootFromParent_Done,
     /*  133821 */   // Label 2346: @133821
     /*  133821 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(133880), // Rule ID 2476 //
     /*  133826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  133829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133849 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  133853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  133866 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  133869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133878 */     GIR_RootConstrainSelectedInstOperands,
     /*  133879 */     // GIR_Coverage, 2476,
     /*  133879 */     GIR_EraseRootFromParent_Done,
     /*  133880 */   // Label 2347: @133880
     /*  133880 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(133939), // Rule ID 65502 //
     /*  133885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  133888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133912 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  133916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  133925 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  133928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133937 */     GIR_RootConstrainSelectedInstOperands,
     /*  133938 */     // GIR_Coverage, 65502,
     /*  133938 */     GIR_EraseRootFromParent_Done,
     /*  133939 */   // Label 2348: @133939
     /*  133939 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(133995), // Rule ID 65486 //
     /*  133944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  133947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133972 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  133976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133982 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  133985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133993 */     GIR_RootConstrainSelectedInstOperands,
     /*  133994 */     // GIR_Coverage, 65486,
     /*  133994 */     GIR_EraseRootFromParent_Done,
     /*  133995 */   // Label 2349: @133995
     /*  133995 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134051), // Rule ID 2448 //
     /*  134000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  134003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134032 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  134036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134038 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  134041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134049 */     GIR_RootConstrainSelectedInstOperands,
     /*  134050 */     // GIR_Coverage, 2448,
     /*  134050 */     GIR_EraseRootFromParent_Done,
     /*  134051 */   // Label 2350: @134051
     /*  134051 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134093), // Rule ID 86 //
     /*  134056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  134059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  134079 */     // MIs[1] Operand 1
     /*  134079 */     // No operand predicates
     /*  134079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134081 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  134081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  134084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  134091 */     GIR_RootConstrainSelectedInstOperands,
     /*  134092 */     // GIR_Coverage, 86,
     /*  134092 */     GIR_EraseRootFromParent_Done,
     /*  134093 */   // Label 2351: @134093
     /*  134093 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(134120), // Rule ID 84 //
     /*  134098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  134101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134113 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (OR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  134118 */     GIR_RootConstrainSelectedInstOperands,
     /*  134119 */     // GIR_Coverage, 84,
     /*  134119 */     GIR_Done,
     /*  134120 */   // Label 2352: @134120
     /*  134120 */   GIM_Reject,
     /*  134121 */ // Label 2324: @134121
     /*  134121 */ GIM_Reject,
     /*  134122 */ // Label 2267: @134122
     /*  134122 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(134732),
     /*  134127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134137 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(134203), // Rule ID 71716 //
     /*  134142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134184 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134201 */     GIR_RootConstrainSelectedInstOperands,
     /*  134202 */     // GIR_Coverage, 71716,
     /*  134202 */     GIR_EraseRootFromParent_Done,
     /*  134203 */   // Label 2354: @134203
     /*  134203 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(134269), // Rule ID 71717 //
     /*  134208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134250 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134267 */     GIR_RootConstrainSelectedInstOperands,
     /*  134268 */     // GIR_Coverage, 71717,
     /*  134268 */     GIR_EraseRootFromParent_Done,
     /*  134269 */   // Label 2355: @134269
     /*  134269 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(134335), // Rule ID 71714 //
     /*  134274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134316 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134333 */     GIR_RootConstrainSelectedInstOperands,
     /*  134334 */     // GIR_Coverage, 71714,
     /*  134334 */     GIR_EraseRootFromParent_Done,
     /*  134335 */   // Label 2356: @134335
     /*  134335 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(134401), // Rule ID 71715 //
     /*  134340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134382 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134399 */     GIR_RootConstrainSelectedInstOperands,
     /*  134400 */     // GIR_Coverage, 71715,
     /*  134400 */     GIR_EraseRootFromParent_Done,
     /*  134401 */   // Label 2357: @134401
     /*  134401 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(134467), // Rule ID 71712 //
     /*  134406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134448 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134465 */     GIR_RootConstrainSelectedInstOperands,
     /*  134466 */     // GIR_Coverage, 71712,
     /*  134466 */     GIR_EraseRootFromParent_Done,
     /*  134467 */   // Label 2358: @134467
     /*  134467 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(134533), // Rule ID 71713 //
     /*  134472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134514 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134531 */     GIR_RootConstrainSelectedInstOperands,
     /*  134532 */     // GIR_Coverage, 71713,
     /*  134532 */     GIR_EraseRootFromParent_Done,
     /*  134533 */   // Label 2359: @134533
     /*  134533 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(134599), // Rule ID 53178 //
     /*  134538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134580 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134597 */     GIR_RootConstrainSelectedInstOperands,
     /*  134598 */     // GIR_Coverage, 53178,
     /*  134598 */     GIR_EraseRootFromParent_Done,
     /*  134599 */   // Label 2360: @134599
     /*  134599 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(134665), // Rule ID 53179 //
     /*  134604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134646 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134663 */     GIR_RootConstrainSelectedInstOperands,
     /*  134664 */     // GIR_Coverage, 53179,
     /*  134664 */     GIR_EraseRootFromParent_Done,
     /*  134665 */   // Label 2361: @134665
     /*  134665 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(134698), // Rule ID 53166 //
     /*  134670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134681 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  134684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134696 */     GIR_RootConstrainSelectedInstOperands,
     /*  134697 */     // GIR_Coverage, 53166,
     /*  134697 */     GIR_EraseRootFromParent_Done,
     /*  134698 */   // Label 2362: @134698
     /*  134698 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(134731), // Rule ID 53167 //
     /*  134703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134714 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  134717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134729 */     GIR_RootConstrainSelectedInstOperands,
     /*  134730 */     // GIR_Coverage, 53167,
     /*  134730 */     GIR_EraseRootFromParent_Done,
     /*  134731 */   // Label 2363: @134731
     /*  134731 */   GIM_Reject,
     /*  134732 */ // Label 2353: @134732
     /*  134732 */ GIM_Reject,
     /*  134733 */ // Label 2268: @134733
     /*  134733 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(134847),
     /*  134738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  134741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  134744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134756 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(134801), // Rule ID 47788 //
     /*  134761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134764 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  134764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  134767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  134781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134799 */     GIR_RootConstrainSelectedInstOperands,
     /*  134800 */     // GIR_Coverage, 47788,
     /*  134800 */     GIR_EraseRootFromParent_Done,
     /*  134801 */   // Label 2365: @134801
     /*  134801 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(134846), // Rule ID 47789 //
     /*  134806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134809 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  134809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  134812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  134826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134844 */     GIR_RootConstrainSelectedInstOperands,
     /*  134845 */     // GIR_Coverage, 47789,
     /*  134845 */     GIR_EraseRootFromParent_Done,
     /*  134846 */   // Label 2366: @134846
     /*  134846 */   GIM_Reject,
     /*  134847 */ // Label 2364: @134847
     /*  134847 */ GIM_Reject,
     /*  134848 */ // Label 2269: @134848
     /*  134848 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(134962),
     /*  134853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  134856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  134859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134871 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(134916), // Rule ID 47800 //
     /*  134876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134879 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  134879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  134882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  134896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  134911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134914 */     GIR_RootConstrainSelectedInstOperands,
     /*  134915 */     // GIR_Coverage, 47800,
     /*  134915 */     GIR_EraseRootFromParent_Done,
     /*  134916 */   // Label 2368: @134916
     /*  134916 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(134961), // Rule ID 47801 //
     /*  134921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134924 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  134924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  134927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  134941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  134956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134959 */     GIR_RootConstrainSelectedInstOperands,
     /*  134960 */     // GIR_Coverage, 47801,
     /*  134960 */     GIR_EraseRootFromParent_Done,
     /*  134961 */   // Label 2369: @134961
     /*  134961 */   GIM_Reject,
     /*  134962 */ // Label 2367: @134962
     /*  134962 */ GIM_Reject,
     /*  134963 */ // Label 2270: @134963
     /*  134963 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(135077),
     /*  134968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  134971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  134974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134986 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(135031), // Rule ID 47808 //
     /*  134991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134994 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  134994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  134997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  135011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135029 */     GIR_RootConstrainSelectedInstOperands,
     /*  135030 */     // GIR_Coverage, 47808,
     /*  135030 */     GIR_EraseRootFromParent_Done,
     /*  135031 */   // Label 2371: @135031
     /*  135031 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(135076), // Rule ID 47809 //
     /*  135036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135039 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  135039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  135042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  135056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135074 */     GIR_RootConstrainSelectedInstOperands,
     /*  135075 */     // GIR_Coverage, 47809,
     /*  135075 */     GIR_EraseRootFromParent_Done,
     /*  135076 */   // Label 2372: @135076
     /*  135076 */   GIM_Reject,
     /*  135077 */ // Label 2370: @135077
     /*  135077 */ GIM_Reject,
     /*  135078 */ // Label 2271: @135078
     /*  135078 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(135192),
     /*  135083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  135086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  135089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135101 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(135146), // Rule ID 47824 //
     /*  135106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  135109 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  135109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  135112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  135126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135144 */     GIR_RootConstrainSelectedInstOperands,
     /*  135145 */     // GIR_Coverage, 47824,
     /*  135145 */     GIR_EraseRootFromParent_Done,
     /*  135146 */   // Label 2374: @135146
     /*  135146 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(135191), // Rule ID 47825 //
     /*  135151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  135154 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  135154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  135157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  135171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135189 */     GIR_RootConstrainSelectedInstOperands,
     /*  135190 */     // GIR_Coverage, 47825,
     /*  135190 */     GIR_EraseRootFromParent_Done,
     /*  135191 */   // Label 2375: @135191
     /*  135191 */   GIM_Reject,
     /*  135192 */ // Label 2373: @135192
     /*  135192 */ GIM_Reject,
     /*  135193 */ // Label 2272: @135193
     /*  135193 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(135803),
     /*  135198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135208 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(135274), // Rule ID 71744 //
     /*  135213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135255 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135272 */     GIR_RootConstrainSelectedInstOperands,
     /*  135273 */     // GIR_Coverage, 71744,
     /*  135273 */     GIR_EraseRootFromParent_Done,
     /*  135274 */   // Label 2377: @135274
     /*  135274 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(135340), // Rule ID 71745 //
     /*  135279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135321 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135338 */     GIR_RootConstrainSelectedInstOperands,
     /*  135339 */     // GIR_Coverage, 71745,
     /*  135339 */     GIR_EraseRootFromParent_Done,
     /*  135340 */   // Label 2378: @135340
     /*  135340 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(135406), // Rule ID 71742 //
     /*  135345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135387 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135404 */     GIR_RootConstrainSelectedInstOperands,
     /*  135405 */     // GIR_Coverage, 71742,
     /*  135405 */     GIR_EraseRootFromParent_Done,
     /*  135406 */   // Label 2379: @135406
     /*  135406 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(135472), // Rule ID 71743 //
     /*  135411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135453 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135470 */     GIR_RootConstrainSelectedInstOperands,
     /*  135471 */     // GIR_Coverage, 71743,
     /*  135471 */     GIR_EraseRootFromParent_Done,
     /*  135472 */   // Label 2380: @135472
     /*  135472 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(135538), // Rule ID 71740 //
     /*  135477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135519 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135536 */     GIR_RootConstrainSelectedInstOperands,
     /*  135537 */     // GIR_Coverage, 71740,
     /*  135537 */     GIR_EraseRootFromParent_Done,
     /*  135538 */   // Label 2381: @135538
     /*  135538 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(135604), // Rule ID 71741 //
     /*  135543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135585 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135602 */     GIR_RootConstrainSelectedInstOperands,
     /*  135603 */     // GIR_Coverage, 71741,
     /*  135603 */     GIR_EraseRootFromParent_Done,
     /*  135604 */   // Label 2382: @135604
     /*  135604 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(135670), // Rule ID 53196 //
     /*  135609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135651 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135668 */     GIR_RootConstrainSelectedInstOperands,
     /*  135669 */     // GIR_Coverage, 53196,
     /*  135669 */     GIR_EraseRootFromParent_Done,
     /*  135670 */   // Label 2383: @135670
     /*  135670 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(135736), // Rule ID 53197 //
     /*  135675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135717 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135734 */     GIR_RootConstrainSelectedInstOperands,
     /*  135735 */     // GIR_Coverage, 53197,
     /*  135735 */     GIR_EraseRootFromParent_Done,
     /*  135736 */   // Label 2384: @135736
     /*  135736 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(135769), // Rule ID 53184 //
     /*  135741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135752 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  135755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135767 */     GIR_RootConstrainSelectedInstOperands,
     /*  135768 */     // GIR_Coverage, 53184,
     /*  135768 */     GIR_EraseRootFromParent_Done,
     /*  135769 */   // Label 2385: @135769
     /*  135769 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(135802), // Rule ID 53185 //
     /*  135774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135785 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  135788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135800 */     GIR_RootConstrainSelectedInstOperands,
     /*  135801 */     // GIR_Coverage, 53185,
     /*  135801 */     GIR_EraseRootFromParent_Done,
     /*  135802 */   // Label 2386: @135802
     /*  135802 */   GIM_Reject,
     /*  135803 */ // Label 2376: @135803
     /*  135803 */ GIM_Reject,
     /*  135804 */ // Label 2273: @135804
     /*  135804 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(135918),
     /*  135809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  135812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  135815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135827 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(135872), // Rule ID 47792 //
     /*  135832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135835 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  135835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  135838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  135852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135870 */     GIR_RootConstrainSelectedInstOperands,
     /*  135871 */     // GIR_Coverage, 47792,
     /*  135871 */     GIR_EraseRootFromParent_Done,
     /*  135872 */   // Label 2388: @135872
     /*  135872 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(135917), // Rule ID 47793 //
     /*  135877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135880 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  135880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  135883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  135897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135915 */     GIR_RootConstrainSelectedInstOperands,
     /*  135916 */     // GIR_Coverage, 47793,
     /*  135916 */     GIR_EraseRootFromParent_Done,
     /*  135917 */   // Label 2389: @135917
     /*  135917 */   GIM_Reject,
     /*  135918 */ // Label 2387: @135918
     /*  135918 */ GIM_Reject,
     /*  135919 */ // Label 2274: @135919
     /*  135919 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(136033),
     /*  135924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  135927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  135930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135942 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(135987), // Rule ID 47804 //
     /*  135947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135950 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  135950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  135953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  135967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135985 */     GIR_RootConstrainSelectedInstOperands,
     /*  135986 */     // GIR_Coverage, 47804,
     /*  135986 */     GIR_EraseRootFromParent_Done,
     /*  135987 */   // Label 2391: @135987
     /*  135987 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(136032), // Rule ID 47805 //
     /*  135992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135995 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  135995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  135998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  136027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136030 */     GIR_RootConstrainSelectedInstOperands,
     /*  136031 */     // GIR_Coverage, 47805,
     /*  136031 */     GIR_EraseRootFromParent_Done,
     /*  136032 */   // Label 2392: @136032
     /*  136032 */   GIM_Reject,
     /*  136033 */ // Label 2390: @136033
     /*  136033 */ GIM_Reject,
     /*  136034 */ // Label 2275: @136034
     /*  136034 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(136148),
     /*  136039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  136042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  136045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136057 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(136102), // Rule ID 47820 //
     /*  136062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136065 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  136065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  136068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  136082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136100 */     GIR_RootConstrainSelectedInstOperands,
     /*  136101 */     // GIR_Coverage, 47820,
     /*  136101 */     GIR_EraseRootFromParent_Done,
     /*  136102 */   // Label 2394: @136102
     /*  136102 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(136147), // Rule ID 47821 //
     /*  136107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136110 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  136110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  136113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  136127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136145 */     GIR_RootConstrainSelectedInstOperands,
     /*  136146 */     // GIR_Coverage, 47821,
     /*  136146 */     GIR_EraseRootFromParent_Done,
     /*  136147 */   // Label 2395: @136147
     /*  136147 */   GIM_Reject,
     /*  136148 */ // Label 2393: @136148
     /*  136148 */ GIM_Reject,
     /*  136149 */ // Label 2276: @136149
     /*  136149 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(136263),
     /*  136154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  136157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  136160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136172 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(136217), // Rule ID 47864 //
     /*  136177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  136180 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  136180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  136183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  136197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136215 */     GIR_RootConstrainSelectedInstOperands,
     /*  136216 */     // GIR_Coverage, 47864,
     /*  136216 */     GIR_EraseRootFromParent_Done,
     /*  136217 */   // Label 2397: @136217
     /*  136217 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(136262), // Rule ID 47865 //
     /*  136222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  136225 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  136225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  136228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  136242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136260 */     GIR_RootConstrainSelectedInstOperands,
     /*  136261 */     // GIR_Coverage, 47865,
     /*  136261 */     GIR_EraseRootFromParent_Done,
     /*  136262 */   // Label 2398: @136262
     /*  136262 */   GIM_Reject,
     /*  136263 */ // Label 2396: @136263
     /*  136263 */ GIM_Reject,
     /*  136264 */ // Label 2277: @136264
     /*  136264 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(136874),
     /*  136269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136279 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(136345), // Rule ID 71772 //
     /*  136284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136326 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136343 */     GIR_RootConstrainSelectedInstOperands,
     /*  136344 */     // GIR_Coverage, 71772,
     /*  136344 */     GIR_EraseRootFromParent_Done,
     /*  136345 */   // Label 2400: @136345
     /*  136345 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(136411), // Rule ID 71773 //
     /*  136350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136392 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136409 */     GIR_RootConstrainSelectedInstOperands,
     /*  136410 */     // GIR_Coverage, 71773,
     /*  136410 */     GIR_EraseRootFromParent_Done,
     /*  136411 */   // Label 2401: @136411
     /*  136411 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(136477), // Rule ID 71770 //
     /*  136416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136458 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136475 */     GIR_RootConstrainSelectedInstOperands,
     /*  136476 */     // GIR_Coverage, 71770,
     /*  136476 */     GIR_EraseRootFromParent_Done,
     /*  136477 */   // Label 2402: @136477
     /*  136477 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(136543), // Rule ID 71771 //
     /*  136482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136524 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136541 */     GIR_RootConstrainSelectedInstOperands,
     /*  136542 */     // GIR_Coverage, 71771,
     /*  136542 */     GIR_EraseRootFromParent_Done,
     /*  136543 */   // Label 2403: @136543
     /*  136543 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(136609), // Rule ID 71768 //
     /*  136548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136590 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136607 */     GIR_RootConstrainSelectedInstOperands,
     /*  136608 */     // GIR_Coverage, 71768,
     /*  136608 */     GIR_EraseRootFromParent_Done,
     /*  136609 */   // Label 2404: @136609
     /*  136609 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(136675), // Rule ID 71769 //
     /*  136614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136656 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136673 */     GIR_RootConstrainSelectedInstOperands,
     /*  136674 */     // GIR_Coverage, 71769,
     /*  136674 */     GIR_EraseRootFromParent_Done,
     /*  136675 */   // Label 2405: @136675
     /*  136675 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(136741), // Rule ID 53214 //
     /*  136680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136722 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136739 */     GIR_RootConstrainSelectedInstOperands,
     /*  136740 */     // GIR_Coverage, 53214,
     /*  136740 */     GIR_EraseRootFromParent_Done,
     /*  136741 */   // Label 2406: @136741
     /*  136741 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(136807), // Rule ID 53215 //
     /*  136746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136788 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136805 */     GIR_RootConstrainSelectedInstOperands,
     /*  136806 */     // GIR_Coverage, 53215,
     /*  136806 */     GIR_EraseRootFromParent_Done,
     /*  136807 */   // Label 2407: @136807
     /*  136807 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(136840), // Rule ID 53202 //
     /*  136812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136823 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  136826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136838 */     GIR_RootConstrainSelectedInstOperands,
     /*  136839 */     // GIR_Coverage, 53202,
     /*  136839 */     GIR_EraseRootFromParent_Done,
     /*  136840 */   // Label 2408: @136840
     /*  136840 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(136873), // Rule ID 53203 //
     /*  136845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136856 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  136859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136871 */     GIR_RootConstrainSelectedInstOperands,
     /*  136872 */     // GIR_Coverage, 53203,
     /*  136872 */     GIR_EraseRootFromParent_Done,
     /*  136873 */   // Label 2409: @136873
     /*  136873 */   GIM_Reject,
     /*  136874 */ // Label 2399: @136874
     /*  136874 */ GIM_Reject,
     /*  136875 */ // Label 2278: @136875
     /*  136875 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(136989),
     /*  136880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  136883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  136886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136898 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(136943), // Rule ID 47796 //
     /*  136903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136906 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  136906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  136909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136941 */     GIR_RootConstrainSelectedInstOperands,
     /*  136942 */     // GIR_Coverage, 47796,
     /*  136942 */     GIR_EraseRootFromParent_Done,
     /*  136943 */   // Label 2411: @136943
     /*  136943 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(136988), // Rule ID 47797 //
     /*  136948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136951 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  136951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  136954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136986 */     GIR_RootConstrainSelectedInstOperands,
     /*  136987 */     // GIR_Coverage, 47797,
     /*  136987 */     GIR_EraseRootFromParent_Done,
     /*  136988 */   // Label 2412: @136988
     /*  136988 */   GIM_Reject,
     /*  136989 */ // Label 2410: @136989
     /*  136989 */ GIM_Reject,
     /*  136990 */ // Label 2279: @136990
     /*  136990 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(137104),
     /*  136995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  136998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  137001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137013 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(137058), // Rule ID 47816 //
     /*  137018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137021 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  137021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  137024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137056 */     GIR_RootConstrainSelectedInstOperands,
     /*  137057 */     // GIR_Coverage, 47816,
     /*  137057 */     GIR_EraseRootFromParent_Done,
     /*  137058 */   // Label 2414: @137058
     /*  137058 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(137103), // Rule ID 47817 //
     /*  137063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137066 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  137066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  137069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137101 */     GIR_RootConstrainSelectedInstOperands,
     /*  137102 */     // GIR_Coverage, 47817,
     /*  137102 */     GIR_EraseRootFromParent_Done,
     /*  137103 */   // Label 2415: @137103
     /*  137103 */   GIM_Reject,
     /*  137104 */ // Label 2413: @137104
     /*  137104 */ GIM_Reject,
     /*  137105 */ // Label 2280: @137105
     /*  137105 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(137219),
     /*  137110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  137113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  137116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137128 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(137173), // Rule ID 47852 //
     /*  137133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137136 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  137136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  137139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  137153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137171 */     GIR_RootConstrainSelectedInstOperands,
     /*  137172 */     // GIR_Coverage, 47852,
     /*  137172 */     GIR_EraseRootFromParent_Done,
     /*  137173 */   // Label 2417: @137173
     /*  137173 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(137218), // Rule ID 47853 //
     /*  137178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137181 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  137181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  137184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  137198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137216 */     GIR_RootConstrainSelectedInstOperands,
     /*  137217 */     // GIR_Coverage, 47853,
     /*  137217 */     GIR_EraseRootFromParent_Done,
     /*  137218 */   // Label 2418: @137218
     /*  137218 */   GIM_Reject,
     /*  137219 */ // Label 2416: @137219
     /*  137219 */ GIM_Reject,
     /*  137220 */ // Label 2281: @137220
     /*  137220 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(137334),
     /*  137225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  137228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  137231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137243 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(137288), // Rule ID 47868 //
     /*  137248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  137251 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  137251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  137254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  137268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  137283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137286 */     GIR_RootConstrainSelectedInstOperands,
     /*  137287 */     // GIR_Coverage, 47868,
     /*  137287 */     GIR_EraseRootFromParent_Done,
     /*  137288 */   // Label 2420: @137288
     /*  137288 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(137333), // Rule ID 47869 //
     /*  137293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  137296 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  137296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  137299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  137313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  137328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137331 */     GIR_RootConstrainSelectedInstOperands,
     /*  137332 */     // GIR_Coverage, 47869,
     /*  137332 */     GIR_EraseRootFromParent_Done,
     /*  137333 */   // Label 2421: @137333
     /*  137333 */   GIM_Reject,
     /*  137334 */ // Label 2419: @137334
     /*  137334 */ GIM_Reject,
     /*  137335 */ // Label 2282: @137335
     /*  137335 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(137945),
     /*  137340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137350 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(137416), // Rule ID 71800 //
     /*  137355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137397 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137414 */     GIR_RootConstrainSelectedInstOperands,
     /*  137415 */     // GIR_Coverage, 71800,
     /*  137415 */     GIR_EraseRootFromParent_Done,
     /*  137416 */   // Label 2423: @137416
     /*  137416 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(137482), // Rule ID 71801 //
     /*  137421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137463 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137480 */     GIR_RootConstrainSelectedInstOperands,
     /*  137481 */     // GIR_Coverage, 71801,
     /*  137481 */     GIR_EraseRootFromParent_Done,
     /*  137482 */   // Label 2424: @137482
     /*  137482 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(137548), // Rule ID 71798 //
     /*  137487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137529 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137546 */     GIR_RootConstrainSelectedInstOperands,
     /*  137547 */     // GIR_Coverage, 71798,
     /*  137547 */     GIR_EraseRootFromParent_Done,
     /*  137548 */   // Label 2425: @137548
     /*  137548 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(137614), // Rule ID 71799 //
     /*  137553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137595 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137612 */     GIR_RootConstrainSelectedInstOperands,
     /*  137613 */     // GIR_Coverage, 71799,
     /*  137613 */     GIR_EraseRootFromParent_Done,
     /*  137614 */   // Label 2426: @137614
     /*  137614 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(137680), // Rule ID 71796 //
     /*  137619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137661 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137678 */     GIR_RootConstrainSelectedInstOperands,
     /*  137679 */     // GIR_Coverage, 71796,
     /*  137679 */     GIR_EraseRootFromParent_Done,
     /*  137680 */   // Label 2427: @137680
     /*  137680 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(137746), // Rule ID 71797 //
     /*  137685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137727 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137744 */     GIR_RootConstrainSelectedInstOperands,
     /*  137745 */     // GIR_Coverage, 71797,
     /*  137745 */     GIR_EraseRootFromParent_Done,
     /*  137746 */   // Label 2428: @137746
     /*  137746 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(137812), // Rule ID 53232 //
     /*  137751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137793 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137810 */     GIR_RootConstrainSelectedInstOperands,
     /*  137811 */     // GIR_Coverage, 53232,
     /*  137811 */     GIR_EraseRootFromParent_Done,
     /*  137812 */   // Label 2429: @137812
     /*  137812 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(137878), // Rule ID 53233 //
     /*  137817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137859 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137876 */     GIR_RootConstrainSelectedInstOperands,
     /*  137877 */     // GIR_Coverage, 53233,
     /*  137877 */     GIR_EraseRootFromParent_Done,
     /*  137878 */   // Label 2430: @137878
     /*  137878 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(137911), // Rule ID 53220 //
     /*  137883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137894 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  137897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137909 */     GIR_RootConstrainSelectedInstOperands,
     /*  137910 */     // GIR_Coverage, 53220,
     /*  137910 */     GIR_EraseRootFromParent_Done,
     /*  137911 */   // Label 2431: @137911
     /*  137911 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(137944), // Rule ID 53221 //
     /*  137916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137927 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  137930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137942 */     GIR_RootConstrainSelectedInstOperands,
     /*  137943 */     // GIR_Coverage, 53221,
     /*  137943 */     GIR_EraseRootFromParent_Done,
     /*  137944 */   // Label 2432: @137944
     /*  137944 */   GIM_Reject,
     /*  137945 */ // Label 2422: @137945
     /*  137945 */ GIM_Reject,
     /*  137946 */ // Label 2283: @137946
     /*  137946 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(138060),
     /*  137951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  137954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  137957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137969 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(138014), // Rule ID 47812 //
     /*  137974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137977 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  137977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  137980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138012 */     GIR_RootConstrainSelectedInstOperands,
     /*  138013 */     // GIR_Coverage, 47812,
     /*  138013 */     GIR_EraseRootFromParent_Done,
     /*  138014 */   // Label 2434: @138014
     /*  138014 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(138059), // Rule ID 47813 //
     /*  138019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138022 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  138022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  138025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  138039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138057 */     GIR_RootConstrainSelectedInstOperands,
     /*  138058 */     // GIR_Coverage, 47813,
     /*  138058 */     GIR_EraseRootFromParent_Done,
     /*  138059 */   // Label 2435: @138059
     /*  138059 */   GIM_Reject,
     /*  138060 */ // Label 2433: @138060
     /*  138060 */ GIM_Reject,
     /*  138061 */ // Label 2284: @138061
     /*  138061 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(138175),
     /*  138066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  138069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  138072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138084 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(138129), // Rule ID 47840 //
     /*  138089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138092 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  138092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  138095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  138109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138127 */     GIR_RootConstrainSelectedInstOperands,
     /*  138128 */     // GIR_Coverage, 47840,
     /*  138128 */     GIR_EraseRootFromParent_Done,
     /*  138129 */   // Label 2437: @138129
     /*  138129 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(138174), // Rule ID 47841 //
     /*  138134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138137 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  138137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  138140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  138154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138172 */     GIR_RootConstrainSelectedInstOperands,
     /*  138173 */     // GIR_Coverage, 47841,
     /*  138173 */     GIR_EraseRootFromParent_Done,
     /*  138174 */   // Label 2438: @138174
     /*  138174 */   GIM_Reject,
     /*  138175 */ // Label 2436: @138175
     /*  138175 */ GIM_Reject,
     /*  138176 */ // Label 2285: @138176
     /*  138176 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(138290),
     /*  138181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  138184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  138187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138199 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(138244), // Rule ID 47856 //
     /*  138204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138207 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  138207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  138210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  138224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  138239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138242 */     GIR_RootConstrainSelectedInstOperands,
     /*  138243 */     // GIR_Coverage, 47856,
     /*  138243 */     GIR_EraseRootFromParent_Done,
     /*  138244 */   // Label 2440: @138244
     /*  138244 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(138289), // Rule ID 47857 //
     /*  138249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138252 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  138252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  138255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  138269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  138284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138287 */     GIR_RootConstrainSelectedInstOperands,
     /*  138288 */     // GIR_Coverage, 47857,
     /*  138288 */     GIR_EraseRootFromParent_Done,
     /*  138289 */   // Label 2441: @138289
     /*  138289 */   GIM_Reject,
     /*  138290 */ // Label 2439: @138290
     /*  138290 */ GIM_Reject,
     /*  138291 */ // Label 2286: @138291
     /*  138291 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(138405),
     /*  138296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  138299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  138302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138314 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(138359), // Rule ID 47872 //
     /*  138319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  138322 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  138322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  138325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  138339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  138354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138357 */     GIR_RootConstrainSelectedInstOperands,
     /*  138358 */     // GIR_Coverage, 47872,
     /*  138358 */     GIR_EraseRootFromParent_Done,
     /*  138359 */   // Label 2443: @138359
     /*  138359 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(138404), // Rule ID 47873 //
     /*  138364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  138367 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  138367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  138370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  138384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  138399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138402 */     GIR_RootConstrainSelectedInstOperands,
     /*  138403 */     // GIR_Coverage, 47873,
     /*  138403 */     GIR_EraseRootFromParent_Done,
     /*  138404 */   // Label 2444: @138404
     /*  138404 */   GIM_Reject,
     /*  138405 */ // Label 2442: @138405
     /*  138405 */ GIM_Reject,
     /*  138406 */ // Label 2287: @138406
     /*  138406 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(139016),
     /*  138411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138421 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(138487), // Rule ID 71828 //
     /*  138426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138468 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138485 */     GIR_RootConstrainSelectedInstOperands,
     /*  138486 */     // GIR_Coverage, 71828,
     /*  138486 */     GIR_EraseRootFromParent_Done,
     /*  138487 */   // Label 2446: @138487
     /*  138487 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(138553), // Rule ID 71829 //
     /*  138492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138534 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138551 */     GIR_RootConstrainSelectedInstOperands,
     /*  138552 */     // GIR_Coverage, 71829,
     /*  138552 */     GIR_EraseRootFromParent_Done,
     /*  138553 */   // Label 2447: @138553
     /*  138553 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(138619), // Rule ID 71826 //
     /*  138558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138600 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138617 */     GIR_RootConstrainSelectedInstOperands,
     /*  138618 */     // GIR_Coverage, 71826,
     /*  138618 */     GIR_EraseRootFromParent_Done,
     /*  138619 */   // Label 2448: @138619
     /*  138619 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(138685), // Rule ID 71827 //
     /*  138624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138666 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138683 */     GIR_RootConstrainSelectedInstOperands,
     /*  138684 */     // GIR_Coverage, 71827,
     /*  138684 */     GIR_EraseRootFromParent_Done,
     /*  138685 */   // Label 2449: @138685
     /*  138685 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(138751), // Rule ID 71824 //
     /*  138690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138732 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138749 */     GIR_RootConstrainSelectedInstOperands,
     /*  138750 */     // GIR_Coverage, 71824,
     /*  138750 */     GIR_EraseRootFromParent_Done,
     /*  138751 */   // Label 2450: @138751
     /*  138751 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(138817), // Rule ID 71825 //
     /*  138756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138798 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138815 */     GIR_RootConstrainSelectedInstOperands,
     /*  138816 */     // GIR_Coverage, 71825,
     /*  138816 */     GIR_EraseRootFromParent_Done,
     /*  138817 */   // Label 2451: @138817
     /*  138817 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(138883), // Rule ID 53250 //
     /*  138822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138864 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138881 */     GIR_RootConstrainSelectedInstOperands,
     /*  138882 */     // GIR_Coverage, 53250,
     /*  138882 */     GIR_EraseRootFromParent_Done,
     /*  138883 */   // Label 2452: @138883
     /*  138883 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(138949), // Rule ID 53251 //
     /*  138888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138930 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138947 */     GIR_RootConstrainSelectedInstOperands,
     /*  138948 */     // GIR_Coverage, 53251,
     /*  138948 */     GIR_EraseRootFromParent_Done,
     /*  138949 */   // Label 2453: @138949
     /*  138949 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(138982), // Rule ID 53238 //
     /*  138954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138965 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  138968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138980 */     GIR_RootConstrainSelectedInstOperands,
     /*  138981 */     // GIR_Coverage, 53238,
     /*  138981 */     GIR_EraseRootFromParent_Done,
     /*  138982 */   // Label 2454: @138982
     /*  138982 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(139015), // Rule ID 53239 //
     /*  138987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138998 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  139001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139013 */     GIR_RootConstrainSelectedInstOperands,
     /*  139014 */     // GIR_Coverage, 53239,
     /*  139014 */     GIR_EraseRootFromParent_Done,
     /*  139015 */   // Label 2455: @139015
     /*  139015 */   GIM_Reject,
     /*  139016 */ // Label 2445: @139016
     /*  139016 */ GIM_Reject,
     /*  139017 */ // Label 2288: @139017
     /*  139017 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(139131),
     /*  139022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  139025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  139028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139040 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(139085), // Rule ID 47828 //
     /*  139045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139048 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  139048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  139051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  139065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139083 */     GIR_RootConstrainSelectedInstOperands,
     /*  139084 */     // GIR_Coverage, 47828,
     /*  139084 */     GIR_EraseRootFromParent_Done,
     /*  139085 */   // Label 2457: @139085
     /*  139085 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(139130), // Rule ID 47829 //
     /*  139090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139093 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  139093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  139096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  139110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139128 */     GIR_RootConstrainSelectedInstOperands,
     /*  139129 */     // GIR_Coverage, 47829,
     /*  139129 */     GIR_EraseRootFromParent_Done,
     /*  139130 */   // Label 2458: @139130
     /*  139130 */   GIM_Reject,
     /*  139131 */ // Label 2456: @139131
     /*  139131 */ GIM_Reject,
     /*  139132 */ // Label 2289: @139132
     /*  139132 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(139246),
     /*  139137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  139140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  139143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139155 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(139200), // Rule ID 47844 //
     /*  139160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139163 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  139163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  139166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  139180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139198 */     GIR_RootConstrainSelectedInstOperands,
     /*  139199 */     // GIR_Coverage, 47844,
     /*  139199 */     GIR_EraseRootFromParent_Done,
     /*  139200 */   // Label 2460: @139200
     /*  139200 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(139245), // Rule ID 47845 //
     /*  139205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139208 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  139208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  139211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  139225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139243 */     GIR_RootConstrainSelectedInstOperands,
     /*  139244 */     // GIR_Coverage, 47845,
     /*  139244 */     GIR_EraseRootFromParent_Done,
     /*  139245 */   // Label 2461: @139245
     /*  139245 */   GIM_Reject,
     /*  139246 */ // Label 2459: @139246
     /*  139246 */ GIM_Reject,
     /*  139247 */ // Label 2290: @139247
     /*  139247 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(139361),
     /*  139252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  139255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  139258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139270 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(139315), // Rule ID 47860 //
     /*  139275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139278 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  139278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  139281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  139295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139313 */     GIR_RootConstrainSelectedInstOperands,
     /*  139314 */     // GIR_Coverage, 47860,
     /*  139314 */     GIR_EraseRootFromParent_Done,
     /*  139315 */   // Label 2463: @139315
     /*  139315 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(139360), // Rule ID 47861 //
     /*  139320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139323 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  139323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  139326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  139340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139358 */     GIR_RootConstrainSelectedInstOperands,
     /*  139359 */     // GIR_Coverage, 47861,
     /*  139359 */     GIR_EraseRootFromParent_Done,
     /*  139360 */   // Label 2464: @139360
     /*  139360 */   GIM_Reject,
     /*  139361 */ // Label 2462: @139361
     /*  139361 */ GIM_Reject,
     /*  139362 */ // Label 2291: @139362
     /*  139362 */ GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(139972),
     /*  139367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139377 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(139443), // Rule ID 71856 //
     /*  139382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139424 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139441 */     GIR_RootConstrainSelectedInstOperands,
     /*  139442 */     // GIR_Coverage, 71856,
     /*  139442 */     GIR_EraseRootFromParent_Done,
     /*  139443 */   // Label 2466: @139443
     /*  139443 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(139509), // Rule ID 71857 //
     /*  139448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139490 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139507 */     GIR_RootConstrainSelectedInstOperands,
     /*  139508 */     // GIR_Coverage, 71857,
     /*  139508 */     GIR_EraseRootFromParent_Done,
     /*  139509 */   // Label 2467: @139509
     /*  139509 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(139575), // Rule ID 71854 //
     /*  139514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139556 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139573 */     GIR_RootConstrainSelectedInstOperands,
     /*  139574 */     // GIR_Coverage, 71854,
     /*  139574 */     GIR_EraseRootFromParent_Done,
     /*  139575 */   // Label 2468: @139575
     /*  139575 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(139641), // Rule ID 71855 //
     /*  139580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139622 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139639 */     GIR_RootConstrainSelectedInstOperands,
     /*  139640 */     // GIR_Coverage, 71855,
     /*  139640 */     GIR_EraseRootFromParent_Done,
     /*  139641 */   // Label 2469: @139641
     /*  139641 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(139707), // Rule ID 71852 //
     /*  139646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139688 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139705 */     GIR_RootConstrainSelectedInstOperands,
     /*  139706 */     // GIR_Coverage, 71852,
     /*  139706 */     GIR_EraseRootFromParent_Done,
     /*  139707 */   // Label 2470: @139707
     /*  139707 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(139773), // Rule ID 71853 //
     /*  139712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139754 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139771 */     GIR_RootConstrainSelectedInstOperands,
     /*  139772 */     // GIR_Coverage, 71853,
     /*  139772 */     GIR_EraseRootFromParent_Done,
     /*  139773 */   // Label 2471: @139773
     /*  139773 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(139839), // Rule ID 53268 //
     /*  139778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139820 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139837 */     GIR_RootConstrainSelectedInstOperands,
     /*  139838 */     // GIR_Coverage, 53268,
     /*  139838 */     GIR_EraseRootFromParent_Done,
     /*  139839 */   // Label 2472: @139839
     /*  139839 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(139905), // Rule ID 53269 //
     /*  139844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139886 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139903 */     GIR_RootConstrainSelectedInstOperands,
     /*  139904 */     // GIR_Coverage, 53269,
     /*  139904 */     GIR_EraseRootFromParent_Done,
     /*  139905 */   // Label 2473: @139905
     /*  139905 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(139938), // Rule ID 53256 //
     /*  139910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139921 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  139924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139936 */     GIR_RootConstrainSelectedInstOperands,
     /*  139937 */     // GIR_Coverage, 53256,
     /*  139937 */     GIR_EraseRootFromParent_Done,
     /*  139938 */   // Label 2474: @139938
     /*  139938 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(139971), // Rule ID 53257 //
     /*  139943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139954 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  139957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139969 */     GIR_RootConstrainSelectedInstOperands,
     /*  139970 */     // GIR_Coverage, 53257,
     /*  139970 */     GIR_EraseRootFromParent_Done,
     /*  139971 */   // Label 2475: @139971
     /*  139971 */   GIM_Reject,
     /*  139972 */ // Label 2465: @139972
     /*  139972 */ GIM_Reject,
     /*  139973 */ // Label 2292: @139973
     /*  139973 */ GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(140087),
     /*  139978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  139981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  139984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139996 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(140041), // Rule ID 47832 //
     /*  140001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140004 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  140004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  140007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  140021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140039 */     GIR_RootConstrainSelectedInstOperands,
     /*  140040 */     // GIR_Coverage, 47832,
     /*  140040 */     GIR_EraseRootFromParent_Done,
     /*  140041 */   // Label 2477: @140041
     /*  140041 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(140086), // Rule ID 47833 //
     /*  140046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140049 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  140049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  140052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  140066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140084 */     GIR_RootConstrainSelectedInstOperands,
     /*  140085 */     // GIR_Coverage, 47833,
     /*  140085 */     GIR_EraseRootFromParent_Done,
     /*  140086 */   // Label 2478: @140086
     /*  140086 */   GIM_Reject,
     /*  140087 */ // Label 2476: @140087
     /*  140087 */ GIM_Reject,
     /*  140088 */ // Label 2293: @140088
     /*  140088 */ GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(140202),
     /*  140093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  140096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  140099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140111 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(140156), // Rule ID 47848 //
     /*  140116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140119 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  140119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  140122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140154 */     GIR_RootConstrainSelectedInstOperands,
     /*  140155 */     // GIR_Coverage, 47848,
     /*  140155 */     GIR_EraseRootFromParent_Done,
     /*  140156 */   // Label 2480: @140156
     /*  140156 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(140201), // Rule ID 47849 //
     /*  140161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140164 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  140164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  140167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140199 */     GIR_RootConstrainSelectedInstOperands,
     /*  140200 */     // GIR_Coverage, 47849,
     /*  140200 */     GIR_EraseRootFromParent_Done,
     /*  140201 */   // Label 2481: @140201
     /*  140201 */   GIM_Reject,
     /*  140202 */ // Label 2479: @140202
     /*  140202 */ GIM_Reject,
     /*  140203 */ // Label 2294: @140203
     /*  140203 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(140813),
     /*  140208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140218 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(140284), // Rule ID 71884 //
     /*  140223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140265 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140282 */     GIR_RootConstrainSelectedInstOperands,
     /*  140283 */     // GIR_Coverage, 71884,
     /*  140283 */     GIR_EraseRootFromParent_Done,
     /*  140284 */   // Label 2483: @140284
     /*  140284 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(140350), // Rule ID 71885 //
     /*  140289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140331 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140348 */     GIR_RootConstrainSelectedInstOperands,
     /*  140349 */     // GIR_Coverage, 71885,
     /*  140349 */     GIR_EraseRootFromParent_Done,
     /*  140350 */   // Label 2484: @140350
     /*  140350 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(140416), // Rule ID 71882 //
     /*  140355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140397 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140414 */     GIR_RootConstrainSelectedInstOperands,
     /*  140415 */     // GIR_Coverage, 71882,
     /*  140415 */     GIR_EraseRootFromParent_Done,
     /*  140416 */   // Label 2485: @140416
     /*  140416 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(140482), // Rule ID 71883 //
     /*  140421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140463 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140480 */     GIR_RootConstrainSelectedInstOperands,
     /*  140481 */     // GIR_Coverage, 71883,
     /*  140481 */     GIR_EraseRootFromParent_Done,
     /*  140482 */   // Label 2486: @140482
     /*  140482 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(140548), // Rule ID 71880 //
     /*  140487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140529 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140546 */     GIR_RootConstrainSelectedInstOperands,
     /*  140547 */     // GIR_Coverage, 71880,
     /*  140547 */     GIR_EraseRootFromParent_Done,
     /*  140548 */   // Label 2487: @140548
     /*  140548 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(140614), // Rule ID 71881 //
     /*  140553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140595 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140612 */     GIR_RootConstrainSelectedInstOperands,
     /*  140613 */     // GIR_Coverage, 71881,
     /*  140613 */     GIR_EraseRootFromParent_Done,
     /*  140614 */   // Label 2488: @140614
     /*  140614 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(140680), // Rule ID 53286 //
     /*  140619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140661 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140678 */     GIR_RootConstrainSelectedInstOperands,
     /*  140679 */     // GIR_Coverage, 53286,
     /*  140679 */     GIR_EraseRootFromParent_Done,
     /*  140680 */   // Label 2489: @140680
     /*  140680 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(140746), // Rule ID 53287 //
     /*  140685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140727 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140744 */     GIR_RootConstrainSelectedInstOperands,
     /*  140745 */     // GIR_Coverage, 53287,
     /*  140745 */     GIR_EraseRootFromParent_Done,
     /*  140746 */   // Label 2490: @140746
     /*  140746 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(140779), // Rule ID 53274 //
     /*  140751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140762 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  140765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140777 */     GIR_RootConstrainSelectedInstOperands,
     /*  140778 */     // GIR_Coverage, 53274,
     /*  140778 */     GIR_EraseRootFromParent_Done,
     /*  140779 */   // Label 2491: @140779
     /*  140779 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(140812), // Rule ID 53275 //
     /*  140784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140795 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  140798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140810 */     GIR_RootConstrainSelectedInstOperands,
     /*  140811 */     // GIR_Coverage, 53275,
     /*  140811 */     GIR_EraseRootFromParent_Done,
     /*  140812 */   // Label 2492: @140812
     /*  140812 */   GIM_Reject,
     /*  140813 */ // Label 2482: @140813
     /*  140813 */ GIM_Reject,
     /*  140814 */ // Label 2295: @140814
     /*  140814 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(140928),
     /*  140819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  140822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  140825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140837 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(140882), // Rule ID 47836 //
     /*  140842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140845 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  140845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  140848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140880 */     GIR_RootConstrainSelectedInstOperands,
     /*  140881 */     // GIR_Coverage, 47836,
     /*  140881 */     GIR_EraseRootFromParent_Done,
     /*  140882 */   // Label 2494: @140882
     /*  140882 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(140927), // Rule ID 47837 //
     /*  140887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140890 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  140890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  140893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140925 */     GIR_RootConstrainSelectedInstOperands,
     /*  140926 */     // GIR_Coverage, 47837,
     /*  140926 */     GIR_EraseRootFromParent_Done,
     /*  140927 */   // Label 2495: @140927
     /*  140927 */   GIM_Reject,
     /*  140928 */ // Label 2493: @140928
     /*  140928 */ GIM_Reject,
     /*  140929 */ // Label 2296: @140929
     /*  140929 */ GIM_Reject,
     /*  140930 */ // Label 9: @140930
     /*  140930 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2527*/ GIMT_Encode4(155836),
     /*  140941 */ /*GILLT_s32*//*Label 2496*/ GIMT_Encode4(141065),
     /*  140945 */ /*GILLT_s64*//*Label 2497*/ GIMT_Encode4(141603),
     /*  140949 */ /*GILLT_nxv1s1*//*Label 2498*/ GIMT_Encode4(142029),
     /*  140953 */ /*GILLT_nxv1s8*//*Label 2499*/ GIMT_Encode4(143640),
     /*  140957 */ /*GILLT_nxv1s16*//*Label 2500*/ GIMT_Encode4(143755),
     /*  140961 */ /*GILLT_nxv1s32*//*Label 2501*/ GIMT_Encode4(143870),
     /*  140965 */ /*GILLT_nxv1s64*//*Label 2502*/ GIMT_Encode4(143985),
     /*  140969 */ /*GILLT_nxv2s1*//*Label 2503*/ GIMT_Encode4(144100),
     /*  140973 */ /*GILLT_nxv2s8*//*Label 2504*/ GIMT_Encode4(145711),
     /*  140977 */ /*GILLT_nxv2s16*//*Label 2505*/ GIMT_Encode4(145826),
     /*  140981 */ /*GILLT_nxv2s32*//*Label 2506*/ GIMT_Encode4(145941),
     /*  140985 */ /*GILLT_nxv2s64*//*Label 2507*/ GIMT_Encode4(146056),
     /*  140989 */ /*GILLT_nxv4s1*//*Label 2508*/ GIMT_Encode4(146171),
     /*  140993 */ /*GILLT_nxv4s8*//*Label 2509*/ GIMT_Encode4(147782),
     /*  140997 */ /*GILLT_nxv4s16*//*Label 2510*/ GIMT_Encode4(147897),
     /*  141001 */ /*GILLT_nxv4s32*//*Label 2511*/ GIMT_Encode4(148012),
     /*  141005 */ /*GILLT_nxv4s64*//*Label 2512*/ GIMT_Encode4(148127),
     /*  141009 */ /*GILLT_nxv8s1*//*Label 2513*/ GIMT_Encode4(148242),
     /*  141013 */ /*GILLT_nxv8s8*//*Label 2514*/ GIMT_Encode4(149853),
     /*  141017 */ /*GILLT_nxv8s16*//*Label 2515*/ GIMT_Encode4(149968),
     /*  141021 */ /*GILLT_nxv8s32*//*Label 2516*/ GIMT_Encode4(150083),
     /*  141025 */ /*GILLT_nxv8s64*//*Label 2517*/ GIMT_Encode4(150198),
     /*  141029 */ /*GILLT_nxv16s1*//*Label 2518*/ GIMT_Encode4(150313),
     /*  141033 */ /*GILLT_nxv16s8*//*Label 2519*/ GIMT_Encode4(151924),
     /*  141037 */ /*GILLT_nxv16s16*//*Label 2520*/ GIMT_Encode4(152039),
     /*  141041 */ /*GILLT_nxv16s32*//*Label 2521*/ GIMT_Encode4(152154),
     /*  141045 */ /*GILLT_nxv32s1*//*Label 2522*/ GIMT_Encode4(152269),
     /*  141049 */ /*GILLT_nxv32s8*//*Label 2523*/ GIMT_Encode4(153880),
     /*  141053 */ /*GILLT_nxv32s16*//*Label 2524*/ GIMT_Encode4(153995),
     /*  141057 */ /*GILLT_nxv64s1*//*Label 2525*/ GIMT_Encode4(154110),
     /*  141061 */ /*GILLT_nxv64s8*//*Label 2526*/ GIMT_Encode4(155721),
     /*  141065 */ // Label 2496: @141065
     /*  141065 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(141602),
     /*  141070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  141073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  141076 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(141159), // Rule ID 2485 //
     /*  141081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  141084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141104 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  141108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141121 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] })  =>  (ADDI:{ *:[i32] } (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })
     /*  141121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  141124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  141128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141133 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  141139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  141149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141157 */     GIR_RootConstrainSelectedInstOperands,
     /*  141158 */     // GIR_Coverage, 2485,
     /*  141158 */     GIR_EraseRootFromParent_Done,
     /*  141159 */   // Label 2529: @141159
     /*  141159 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(141218), // Rule ID 2479 //
     /*  141164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  141167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141187 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141204 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141216 */     GIR_RootConstrainSelectedInstOperands,
     /*  141217 */     // GIR_Coverage, 2479,
     /*  141217 */     GIR_EraseRootFromParent_Done,
     /*  141218 */   // Label 2530: @141218
     /*  141218 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(141277), // Rule ID 65505 //
     /*  141223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  141226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141250 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141263 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141275 */     GIR_RootConstrainSelectedInstOperands,
     /*  141276 */     // GIR_Coverage, 65505,
     /*  141276 */     GIR_EraseRootFromParent_Done,
     /*  141277 */   // Label 2531: @141277
     /*  141277 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(141333), // Rule ID 65489 //
     /*  141282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  141285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141310 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141320 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs2)  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141331 */     GIR_RootConstrainSelectedInstOperands,
     /*  141332 */     // GIR_Coverage, 65489,
     /*  141332 */     GIR_EraseRootFromParent_Done,
     /*  141333 */   // Label 2532: @141333
     /*  141333 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(141392), // Rule ID 2453 //
     /*  141338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  141341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141377 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141390 */     GIR_RootConstrainSelectedInstOperands,
     /*  141391 */     // GIR_Coverage, 2453,
     /*  141391 */     GIR_EraseRootFromParent_Done,
     /*  141392 */   // Label 2533: @141392
     /*  141392 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(141448), // Rule ID 65491 //
     /*  141397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  141400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141429 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141435 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  141446 */     GIR_RootConstrainSelectedInstOperands,
     /*  141447 */     // GIR_Coverage, 65491,
     /*  141447 */     GIR_EraseRootFromParent_Done,
     /*  141448 */   // Label 2534: @141448
     /*  141448 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(141490), // Rule ID 95 //
     /*  141453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  141456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  141476 */     // MIs[1] Operand 1
     /*  141476 */     // No operand predicates
     /*  141476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141478 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  141478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  141481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141488 */     GIR_RootConstrainSelectedInstOperands,
     /*  141489 */     // GIR_Coverage, 95,
     /*  141489 */     GIR_EraseRootFromParent_Done,
     /*  141490 */   // Label 2535: @141490
     /*  141490 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(141532), // Rule ID 64533 //
     /*  141495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  141498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  141518 */     // MIs[1] Operand 1
     /*  141518 */     // No operand predicates
     /*  141518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141520 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_XORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  141520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORAI),
     /*  141523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  141525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141530 */     GIR_RootConstrainSelectedInstOperands,
     /*  141531 */     // GIR_Coverage, 64533,
     /*  141531 */     GIR_EraseRootFromParent_Done,
     /*  141532 */   // Label 2536: @141532
     /*  141532 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(141574), // Rule ID 64537 //
     /*  141537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  141540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  141560 */     // MIs[1] Operand 1
     /*  141560 */     // No operand predicates
     /*  141560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141562 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_XORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  141562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORI),
     /*  141565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141572 */     GIR_RootConstrainSelectedInstOperands,
     /*  141573 */     // GIR_Coverage, 64537,
     /*  141573 */     GIR_EraseRootFromParent_Done,
     /*  141574 */   // Label 2537: @141574
     /*  141574 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(141601), // Rule ID 93 //
     /*  141579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  141582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141594 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  141599 */     GIR_RootConstrainSelectedInstOperands,
     /*  141600 */     // GIR_Coverage, 93,
     /*  141600 */     GIR_Done,
     /*  141601 */   // Label 2538: @141601
     /*  141601 */   GIM_Reject,
     /*  141602 */ // Label 2528: @141602
     /*  141602 */ GIM_Reject,
     /*  141603 */ // Label 2497: @141603
     /*  141603 */ GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(142028),
     /*  141608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  141611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  141614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141618 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(141697), // Rule ID 2484 //
     /*  141623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  141626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141642 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  141646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141659 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } -1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] })  =>  (ADDI:{ *:[i64] } (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })
     /*  141659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  141662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  141666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141671 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  141677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  141687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141695 */     GIR_RootConstrainSelectedInstOperands,
     /*  141696 */     // GIR_Coverage, 2484,
     /*  141696 */     GIR_EraseRootFromParent_Done,
     /*  141697 */   // Label 2540: @141697
     /*  141697 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(141752), // Rule ID 2478 //
     /*  141702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  141705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141721 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141738 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141750 */     GIR_RootConstrainSelectedInstOperands,
     /*  141751 */     // GIR_Coverage, 2478,
     /*  141751 */     GIR_EraseRootFromParent_Done,
     /*  141752 */   // Label 2541: @141752
     /*  141752 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(141807), // Rule ID 65504 //
     /*  141757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  141760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141780 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141793 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141805 */     GIR_RootConstrainSelectedInstOperands,
     /*  141806 */     // GIR_Coverage, 65504,
     /*  141806 */     GIR_EraseRootFromParent_Done,
     /*  141807 */   // Label 2542: @141807
     /*  141807 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(141859), // Rule ID 65488 //
     /*  141812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  141815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141836 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141846 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141857 */     GIR_RootConstrainSelectedInstOperands,
     /*  141858 */     // GIR_Coverage, 65488,
     /*  141858 */     GIR_EraseRootFromParent_Done,
     /*  141859 */   // Label 2543: @141859
     /*  141859 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(141914), // Rule ID 2452 //
     /*  141864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  141867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141899 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141912 */     GIR_RootConstrainSelectedInstOperands,
     /*  141913 */     // GIR_Coverage, 2452,
     /*  141913 */     GIR_EraseRootFromParent_Done,
     /*  141914 */   // Label 2544: @141914
     /*  141914 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(141966), // Rule ID 65490 //
     /*  141919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  141922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141947 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141953 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }))  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  141964 */     GIR_RootConstrainSelectedInstOperands,
     /*  141965 */     // GIR_Coverage, 65490,
     /*  141965 */     GIR_EraseRootFromParent_Done,
     /*  141966 */   // Label 2545: @141966
     /*  141966 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(142004), // Rule ID 94 //
     /*  141971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  141974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  141990 */     // MIs[1] Operand 1
     /*  141990 */     // No operand predicates
     /*  141990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141992 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  141992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  141995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  142002 */     GIR_RootConstrainSelectedInstOperands,
     /*  142003 */     // GIR_Coverage, 94,
     /*  142003 */     GIR_EraseRootFromParent_Done,
     /*  142004 */   // Label 2546: @142004
     /*  142004 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(142027), // Rule ID 92 //
     /*  142009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  142012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142020 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  142025 */     GIR_RootConstrainSelectedInstOperands,
     /*  142026 */     // GIR_Coverage, 92,
     /*  142026 */     GIR_Done,
     /*  142027 */   // Label 2547: @142027
     /*  142027 */   GIM_Reject,
     /*  142028 */ // Label 2539: @142028
     /*  142028 */ GIM_Reject,
     /*  142029 */ // Label 2498: @142029
     /*  142029 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(143639),
     /*  142034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142044 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(142113), // Rule ID 53170 //
     /*  142049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142092 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142111 */     GIR_RootConstrainSelectedInstOperands,
     /*  142112 */     // GIR_Coverage, 53170,
     /*  142112 */     GIR_EraseRootFromParent_Done,
     /*  142113 */   // Label 2549: @142113
     /*  142113 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(142182), // Rule ID 53171 //
     /*  142118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142161 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142180 */     GIR_RootConstrainSelectedInstOperands,
     /*  142181 */     // GIR_Coverage, 53171,
     /*  142181 */     GIR_EraseRootFromParent_Done,
     /*  142182 */   // Label 2550: @142182
     /*  142182 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(142251), // Rule ID 53172 //
     /*  142187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142230 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142249 */     GIR_RootConstrainSelectedInstOperands,
     /*  142250 */     // GIR_Coverage, 53172,
     /*  142250 */     GIR_EraseRootFromParent_Done,
     /*  142251 */   // Label 2551: @142251
     /*  142251 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(142320), // Rule ID 53173 //
     /*  142256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142299 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142318 */     GIR_RootConstrainSelectedInstOperands,
     /*  142319 */     // GIR_Coverage, 53173,
     /*  142319 */     GIR_EraseRootFromParent_Done,
     /*  142320 */   // Label 2552: @142320
     /*  142320 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(142386), // Rule ID 71698 //
     /*  142325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142367 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142384 */     GIR_RootConstrainSelectedInstOperands,
     /*  142385 */     // GIR_Coverage, 71698,
     /*  142385 */     GIR_EraseRootFromParent_Done,
     /*  142386 */   // Label 2553: @142386
     /*  142386 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(142452), // Rule ID 71699 //
     /*  142391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142433 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142450 */     GIR_RootConstrainSelectedInstOperands,
     /*  142451 */     // GIR_Coverage, 71699,
     /*  142451 */     GIR_EraseRootFromParent_Done,
     /*  142452 */   // Label 2554: @142452
     /*  142452 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(142518), // Rule ID 71696 //
     /*  142457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142499 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142516 */     GIR_RootConstrainSelectedInstOperands,
     /*  142517 */     // GIR_Coverage, 71696,
     /*  142517 */     GIR_EraseRootFromParent_Done,
     /*  142518 */   // Label 2555: @142518
     /*  142518 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(142584), // Rule ID 71697 //
     /*  142523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142565 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142582 */     GIR_RootConstrainSelectedInstOperands,
     /*  142583 */     // GIR_Coverage, 71697,
     /*  142583 */     GIR_EraseRootFromParent_Done,
     /*  142584 */   // Label 2556: @142584
     /*  142584 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(142653), // Rule ID 53174 //
     /*  142589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142632 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142651 */     GIR_RootConstrainSelectedInstOperands,
     /*  142652 */     // GIR_Coverage, 53174,
     /*  142652 */     GIR_EraseRootFromParent_Done,
     /*  142653 */   // Label 2557: @142653
     /*  142653 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(142722), // Rule ID 53175 //
     /*  142658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142701 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142720 */     GIR_RootConstrainSelectedInstOperands,
     /*  142721 */     // GIR_Coverage, 53175,
     /*  142721 */     GIR_EraseRootFromParent_Done,
     /*  142722 */   // Label 2558: @142722
     /*  142722 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(142791), // Rule ID 71692 //
     /*  142727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142770 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142789 */     GIR_RootConstrainSelectedInstOperands,
     /*  142790 */     // GIR_Coverage, 71692,
     /*  142790 */     GIR_EraseRootFromParent_Done,
     /*  142791 */   // Label 2559: @142791
     /*  142791 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(142860), // Rule ID 71693 //
     /*  142796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142839 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142858 */     GIR_RootConstrainSelectedInstOperands,
     /*  142859 */     // GIR_Coverage, 71693,
     /*  142859 */     GIR_EraseRootFromParent_Done,
     /*  142860 */   // Label 2560: @142860
     /*  142860 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(142929), // Rule ID 71694 //
     /*  142865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142908 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142927 */     GIR_RootConstrainSelectedInstOperands,
     /*  142928 */     // GIR_Coverage, 71694,
     /*  142928 */     GIR_EraseRootFromParent_Done,
     /*  142929 */   // Label 2561: @142929
     /*  142929 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(142998), // Rule ID 71695 //
     /*  142934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142977 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142996 */     GIR_RootConstrainSelectedInstOperands,
     /*  142997 */     // GIR_Coverage, 71695,
     /*  142997 */     GIR_EraseRootFromParent_Done,
     /*  142998 */   // Label 2562: @142998
     /*  142998 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(143067), // Rule ID 71700 //
     /*  143003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143046 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143065 */     GIR_RootConstrainSelectedInstOperands,
     /*  143066 */     // GIR_Coverage, 71700,
     /*  143066 */     GIR_EraseRootFromParent_Done,
     /*  143067 */   // Label 2563: @143067
     /*  143067 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(143136), // Rule ID 71701 //
     /*  143072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143115 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143134 */     GIR_RootConstrainSelectedInstOperands,
     /*  143135 */     // GIR_Coverage, 71701,
     /*  143135 */     GIR_EraseRootFromParent_Done,
     /*  143136 */   // Label 2564: @143136
     /*  143136 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(143202), // Rule ID 71704 //
     /*  143141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143183 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  143192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143200 */     GIR_RootConstrainSelectedInstOperands,
     /*  143201 */     // GIR_Coverage, 71704,
     /*  143201 */     GIR_EraseRootFromParent_Done,
     /*  143202 */   // Label 2565: @143202
     /*  143202 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(143268), // Rule ID 71705 //
     /*  143207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143249 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  143258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143266 */     GIR_RootConstrainSelectedInstOperands,
     /*  143267 */     // GIR_Coverage, 71705,
     /*  143267 */     GIR_EraseRootFromParent_Done,
     /*  143268 */   // Label 2566: @143268
     /*  143268 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(143334), // Rule ID 71702 //
     /*  143273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  143305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143315 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143332 */     GIR_RootConstrainSelectedInstOperands,
     /*  143333 */     // GIR_Coverage, 71702,
     /*  143333 */     GIR_EraseRootFromParent_Done,
     /*  143334 */   // Label 2567: @143334
     /*  143334 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(143400), // Rule ID 71703 //
     /*  143339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  143371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143381 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143398 */     GIR_RootConstrainSelectedInstOperands,
     /*  143399 */     // GIR_Coverage, 71703,
     /*  143399 */     GIR_EraseRootFromParent_Done,
     /*  143400 */   // Label 2568: @143400
     /*  143400 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(143443), // Rule ID 71718 //
     /*  143405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143426 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143441 */     GIR_RootConstrainSelectedInstOperands,
     /*  143442 */     // GIR_Coverage, 71718,
     /*  143442 */     GIR_EraseRootFromParent_Done,
     /*  143443 */   // Label 2569: @143443
     /*  143443 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(143486), // Rule ID 71719 //
     /*  143448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143469 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143484 */     GIR_RootConstrainSelectedInstOperands,
     /*  143485 */     // GIR_Coverage, 71719,
     /*  143485 */     GIR_EraseRootFromParent_Done,
     /*  143486 */   // Label 2570: @143486
     /*  143486 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(143529), // Rule ID 53180 //
     /*  143491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143512 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143527 */     GIR_RootConstrainSelectedInstOperands,
     /*  143528 */     // GIR_Coverage, 53180,
     /*  143528 */     GIR_EraseRootFromParent_Done,
     /*  143529 */   // Label 2571: @143529
     /*  143529 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(143572), // Rule ID 53181 //
     /*  143534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143555 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143570 */     GIR_RootConstrainSelectedInstOperands,
     /*  143571 */     // GIR_Coverage, 53181,
     /*  143571 */     GIR_EraseRootFromParent_Done,
     /*  143572 */   // Label 2572: @143572
     /*  143572 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(143605), // Rule ID 53168 //
     /*  143577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143588 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  143591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143603 */     GIR_RootConstrainSelectedInstOperands,
     /*  143604 */     // GIR_Coverage, 53168,
     /*  143604 */     GIR_EraseRootFromParent_Done,
     /*  143605 */   // Label 2573: @143605
     /*  143605 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(143638), // Rule ID 53169 //
     /*  143610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143621 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  143624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143636 */     GIR_RootConstrainSelectedInstOperands,
     /*  143637 */     // GIR_Coverage, 53169,
     /*  143637 */     GIR_EraseRootFromParent_Done,
     /*  143638 */   // Label 2574: @143638
     /*  143638 */   GIM_Reject,
     /*  143639 */ // Label 2548: @143639
     /*  143639 */ GIM_Reject,
     /*  143640 */ // Label 2499: @143640
     /*  143640 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(143754),
     /*  143645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  143648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  143651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143663 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(143708), // Rule ID 47920 //
     /*  143668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143671 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  143671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  143674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  143688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143706 */     GIR_RootConstrainSelectedInstOperands,
     /*  143707 */     // GIR_Coverage, 47920,
     /*  143707 */     GIR_EraseRootFromParent_Done,
     /*  143708 */   // Label 2576: @143708
     /*  143708 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(143753), // Rule ID 47921 //
     /*  143713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143716 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  143716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  143719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  143733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143751 */     GIR_RootConstrainSelectedInstOperands,
     /*  143752 */     // GIR_Coverage, 47921,
     /*  143752 */     GIR_EraseRootFromParent_Done,
     /*  143753 */   // Label 2577: @143753
     /*  143753 */   GIM_Reject,
     /*  143754 */ // Label 2575: @143754
     /*  143754 */ GIM_Reject,
     /*  143755 */ // Label 2500: @143755
     /*  143755 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(143869),
     /*  143760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  143763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  143766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143778 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(143823), // Rule ID 47932 //
     /*  143783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143786 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  143786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  143789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  143803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143821 */     GIR_RootConstrainSelectedInstOperands,
     /*  143822 */     // GIR_Coverage, 47932,
     /*  143822 */     GIR_EraseRootFromParent_Done,
     /*  143823 */   // Label 2579: @143823
     /*  143823 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(143868), // Rule ID 47933 //
     /*  143828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143831 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  143831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  143834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  143848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143866 */     GIR_RootConstrainSelectedInstOperands,
     /*  143867 */     // GIR_Coverage, 47933,
     /*  143867 */     GIR_EraseRootFromParent_Done,
     /*  143868 */   // Label 2580: @143868
     /*  143868 */   GIM_Reject,
     /*  143869 */ // Label 2578: @143869
     /*  143869 */ GIM_Reject,
     /*  143870 */ // Label 2501: @143870
     /*  143870 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(143984),
     /*  143875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  143878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  143881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143893 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(143938), // Rule ID 47940 //
     /*  143898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143901 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  143901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  143904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  143918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  143933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143936 */     GIR_RootConstrainSelectedInstOperands,
     /*  143937 */     // GIR_Coverage, 47940,
     /*  143937 */     GIR_EraseRootFromParent_Done,
     /*  143938 */   // Label 2582: @143938
     /*  143938 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(143983), // Rule ID 47941 //
     /*  143943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143946 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  143946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  143949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  143963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  143978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143981 */     GIR_RootConstrainSelectedInstOperands,
     /*  143982 */     // GIR_Coverage, 47941,
     /*  143982 */     GIR_EraseRootFromParent_Done,
     /*  143983 */   // Label 2583: @143983
     /*  143983 */   GIM_Reject,
     /*  143984 */ // Label 2581: @143984
     /*  143984 */ GIM_Reject,
     /*  143985 */ // Label 2502: @143985
     /*  143985 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(144099),
     /*  143990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  143993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  143996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144008 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(144053), // Rule ID 47956 //
     /*  144013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  144016 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  144016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  144019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  144033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144051 */     GIR_RootConstrainSelectedInstOperands,
     /*  144052 */     // GIR_Coverage, 47956,
     /*  144052 */     GIR_EraseRootFromParent_Done,
     /*  144053 */   // Label 2585: @144053
     /*  144053 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(144098), // Rule ID 47957 //
     /*  144058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  144061 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  144061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  144064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  144078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144096 */     GIR_RootConstrainSelectedInstOperands,
     /*  144097 */     // GIR_Coverage, 47957,
     /*  144097 */     GIR_EraseRootFromParent_Done,
     /*  144098 */   // Label 2586: @144098
     /*  144098 */   GIM_Reject,
     /*  144099 */ // Label 2584: @144099
     /*  144099 */ GIM_Reject,
     /*  144100 */ // Label 2503: @144100
     /*  144100 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(145710),
     /*  144105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144115 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(144184), // Rule ID 53188 //
     /*  144120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144163 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144182 */     GIR_RootConstrainSelectedInstOperands,
     /*  144183 */     // GIR_Coverage, 53188,
     /*  144183 */     GIR_EraseRootFromParent_Done,
     /*  144184 */   // Label 2588: @144184
     /*  144184 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(144253), // Rule ID 53189 //
     /*  144189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144232 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144251 */     GIR_RootConstrainSelectedInstOperands,
     /*  144252 */     // GIR_Coverage, 53189,
     /*  144252 */     GIR_EraseRootFromParent_Done,
     /*  144253 */   // Label 2589: @144253
     /*  144253 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(144322), // Rule ID 53190 //
     /*  144258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144301 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144320 */     GIR_RootConstrainSelectedInstOperands,
     /*  144321 */     // GIR_Coverage, 53190,
     /*  144321 */     GIR_EraseRootFromParent_Done,
     /*  144322 */   // Label 2590: @144322
     /*  144322 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(144391), // Rule ID 53191 //
     /*  144327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144370 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144389 */     GIR_RootConstrainSelectedInstOperands,
     /*  144390 */     // GIR_Coverage, 53191,
     /*  144390 */     GIR_EraseRootFromParent_Done,
     /*  144391 */   // Label 2591: @144391
     /*  144391 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(144457), // Rule ID 71726 //
     /*  144396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144438 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144455 */     GIR_RootConstrainSelectedInstOperands,
     /*  144456 */     // GIR_Coverage, 71726,
     /*  144456 */     GIR_EraseRootFromParent_Done,
     /*  144457 */   // Label 2592: @144457
     /*  144457 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(144523), // Rule ID 71727 //
     /*  144462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144504 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144521 */     GIR_RootConstrainSelectedInstOperands,
     /*  144522 */     // GIR_Coverage, 71727,
     /*  144522 */     GIR_EraseRootFromParent_Done,
     /*  144523 */   // Label 2593: @144523
     /*  144523 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(144589), // Rule ID 71724 //
     /*  144528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144570 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144587 */     GIR_RootConstrainSelectedInstOperands,
     /*  144588 */     // GIR_Coverage, 71724,
     /*  144588 */     GIR_EraseRootFromParent_Done,
     /*  144589 */   // Label 2594: @144589
     /*  144589 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(144655), // Rule ID 71725 //
     /*  144594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144636 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144653 */     GIR_RootConstrainSelectedInstOperands,
     /*  144654 */     // GIR_Coverage, 71725,
     /*  144654 */     GIR_EraseRootFromParent_Done,
     /*  144655 */   // Label 2595: @144655
     /*  144655 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(144724), // Rule ID 53192 //
     /*  144660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144703 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144722 */     GIR_RootConstrainSelectedInstOperands,
     /*  144723 */     // GIR_Coverage, 53192,
     /*  144723 */     GIR_EraseRootFromParent_Done,
     /*  144724 */   // Label 2596: @144724
     /*  144724 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(144793), // Rule ID 53193 //
     /*  144729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144772 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144791 */     GIR_RootConstrainSelectedInstOperands,
     /*  144792 */     // GIR_Coverage, 53193,
     /*  144792 */     GIR_EraseRootFromParent_Done,
     /*  144793 */   // Label 2597: @144793
     /*  144793 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(144862), // Rule ID 71720 //
     /*  144798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144841 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144860 */     GIR_RootConstrainSelectedInstOperands,
     /*  144861 */     // GIR_Coverage, 71720,
     /*  144861 */     GIR_EraseRootFromParent_Done,
     /*  144862 */   // Label 2598: @144862
     /*  144862 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(144931), // Rule ID 71721 //
     /*  144867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  144882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144910 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144929 */     GIR_RootConstrainSelectedInstOperands,
     /*  144930 */     // GIR_Coverage, 71721,
     /*  144930 */     GIR_EraseRootFromParent_Done,
     /*  144931 */   // Label 2599: @144931
     /*  144931 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(145000), // Rule ID 71722 //
     /*  144936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144979 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144998 */     GIR_RootConstrainSelectedInstOperands,
     /*  144999 */     // GIR_Coverage, 71722,
     /*  144999 */     GIR_EraseRootFromParent_Done,
     /*  145000 */   // Label 2600: @145000
     /*  145000 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(145069), // Rule ID 71723 //
     /*  145005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  145028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145048 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  145051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145067 */     GIR_RootConstrainSelectedInstOperands,
     /*  145068 */     // GIR_Coverage, 71723,
     /*  145068 */     GIR_EraseRootFromParent_Done,
     /*  145069 */   // Label 2601: @145069
     /*  145069 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(145138), // Rule ID 71728 //
     /*  145074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145117 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145136 */     GIR_RootConstrainSelectedInstOperands,
     /*  145137 */     // GIR_Coverage, 71728,
     /*  145137 */     GIR_EraseRootFromParent_Done,
     /*  145138 */   // Label 2602: @145138
     /*  145138 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(145207), // Rule ID 71729 //
     /*  145143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145186 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145205 */     GIR_RootConstrainSelectedInstOperands,
     /*  145206 */     // GIR_Coverage, 71729,
     /*  145206 */     GIR_EraseRootFromParent_Done,
     /*  145207 */   // Label 2603: @145207
     /*  145207 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(145273), // Rule ID 71732 //
     /*  145212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  145239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145254 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  145263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145271 */     GIR_RootConstrainSelectedInstOperands,
     /*  145272 */     // GIR_Coverage, 71732,
     /*  145272 */     GIR_EraseRootFromParent_Done,
     /*  145273 */   // Label 2604: @145273
     /*  145273 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(145339), // Rule ID 71733 //
     /*  145278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  145305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145320 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  145329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145337 */     GIR_RootConstrainSelectedInstOperands,
     /*  145338 */     // GIR_Coverage, 71733,
     /*  145338 */     GIR_EraseRootFromParent_Done,
     /*  145339 */   // Label 2605: @145339
     /*  145339 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(145405), // Rule ID 71730 //
     /*  145344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  145376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145386 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145403 */     GIR_RootConstrainSelectedInstOperands,
     /*  145404 */     // GIR_Coverage, 71730,
     /*  145404 */     GIR_EraseRootFromParent_Done,
     /*  145405 */   // Label 2606: @145405
     /*  145405 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(145471), // Rule ID 71731 //
     /*  145410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  145442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145452 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145469 */     GIR_RootConstrainSelectedInstOperands,
     /*  145470 */     // GIR_Coverage, 71731,
     /*  145470 */     GIR_EraseRootFromParent_Done,
     /*  145471 */   // Label 2607: @145471
     /*  145471 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(145514), // Rule ID 71746 //
     /*  145476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145497 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145512 */     GIR_RootConstrainSelectedInstOperands,
     /*  145513 */     // GIR_Coverage, 71746,
     /*  145513 */     GIR_EraseRootFromParent_Done,
     /*  145514 */   // Label 2608: @145514
     /*  145514 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(145557), // Rule ID 71747 //
     /*  145519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145540 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145555 */     GIR_RootConstrainSelectedInstOperands,
     /*  145556 */     // GIR_Coverage, 71747,
     /*  145556 */     GIR_EraseRootFromParent_Done,
     /*  145557 */   // Label 2609: @145557
     /*  145557 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(145600), // Rule ID 53198 //
     /*  145562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145583 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145598 */     GIR_RootConstrainSelectedInstOperands,
     /*  145599 */     // GIR_Coverage, 53198,
     /*  145599 */     GIR_EraseRootFromParent_Done,
     /*  145600 */   // Label 2610: @145600
     /*  145600 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(145643), // Rule ID 53199 //
     /*  145605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145626 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145641 */     GIR_RootConstrainSelectedInstOperands,
     /*  145642 */     // GIR_Coverage, 53199,
     /*  145642 */     GIR_EraseRootFromParent_Done,
     /*  145643 */   // Label 2611: @145643
     /*  145643 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(145676), // Rule ID 53186 //
     /*  145648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145659 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  145662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145674 */     GIR_RootConstrainSelectedInstOperands,
     /*  145675 */     // GIR_Coverage, 53186,
     /*  145675 */     GIR_EraseRootFromParent_Done,
     /*  145676 */   // Label 2612: @145676
     /*  145676 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(145709), // Rule ID 53187 //
     /*  145681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145692 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  145695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145707 */     GIR_RootConstrainSelectedInstOperands,
     /*  145708 */     // GIR_Coverage, 53187,
     /*  145708 */     GIR_EraseRootFromParent_Done,
     /*  145709 */   // Label 2613: @145709
     /*  145709 */   GIM_Reject,
     /*  145710 */ // Label 2587: @145710
     /*  145710 */ GIM_Reject,
     /*  145711 */ // Label 2504: @145711
     /*  145711 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(145825),
     /*  145716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  145719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  145722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145734 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(145779), // Rule ID 47924 //
     /*  145739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145742 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  145742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  145745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  145759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145777 */     GIR_RootConstrainSelectedInstOperands,
     /*  145778 */     // GIR_Coverage, 47924,
     /*  145778 */     GIR_EraseRootFromParent_Done,
     /*  145779 */   // Label 2615: @145779
     /*  145779 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(145824), // Rule ID 47925 //
     /*  145784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145787 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  145787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  145790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  145804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145822 */     GIR_RootConstrainSelectedInstOperands,
     /*  145823 */     // GIR_Coverage, 47925,
     /*  145823 */     GIR_EraseRootFromParent_Done,
     /*  145824 */   // Label 2616: @145824
     /*  145824 */   GIM_Reject,
     /*  145825 */ // Label 2614: @145825
     /*  145825 */ GIM_Reject,
     /*  145826 */ // Label 2505: @145826
     /*  145826 */ GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(145940),
     /*  145831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  145834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  145837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145849 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(145894), // Rule ID 47936 //
     /*  145854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145857 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  145857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  145860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  145874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145892 */     GIR_RootConstrainSelectedInstOperands,
     /*  145893 */     // GIR_Coverage, 47936,
     /*  145893 */     GIR_EraseRootFromParent_Done,
     /*  145894 */   // Label 2618: @145894
     /*  145894 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(145939), // Rule ID 47937 //
     /*  145899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145902 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  145902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  145905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  145919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145937 */     GIR_RootConstrainSelectedInstOperands,
     /*  145938 */     // GIR_Coverage, 47937,
     /*  145938 */     GIR_EraseRootFromParent_Done,
     /*  145939 */   // Label 2619: @145939
     /*  145939 */   GIM_Reject,
     /*  145940 */ // Label 2617: @145940
     /*  145940 */ GIM_Reject,
     /*  145941 */ // Label 2506: @145941
     /*  145941 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(146055),
     /*  145946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  145949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  145952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145964 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(146009), // Rule ID 47952 //
     /*  145969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145972 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  145972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  145975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  145989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  146004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146007 */     GIR_RootConstrainSelectedInstOperands,
     /*  146008 */     // GIR_Coverage, 47952,
     /*  146008 */     GIR_EraseRootFromParent_Done,
     /*  146009 */   // Label 2621: @146009
     /*  146009 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(146054), // Rule ID 47953 //
     /*  146014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146017 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  146017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  146020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  146034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  146049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146052 */     GIR_RootConstrainSelectedInstOperands,
     /*  146053 */     // GIR_Coverage, 47953,
     /*  146053 */     GIR_EraseRootFromParent_Done,
     /*  146054 */   // Label 2622: @146054
     /*  146054 */   GIM_Reject,
     /*  146055 */ // Label 2620: @146055
     /*  146055 */ GIM_Reject,
     /*  146056 */ // Label 2507: @146056
     /*  146056 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(146170),
     /*  146061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  146064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  146067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146079 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(146124), // Rule ID 47996 //
     /*  146084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  146087 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  146087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  146090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  146104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  146119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146122 */     GIR_RootConstrainSelectedInstOperands,
     /*  146123 */     // GIR_Coverage, 47996,
     /*  146123 */     GIR_EraseRootFromParent_Done,
     /*  146124 */   // Label 2624: @146124
     /*  146124 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(146169), // Rule ID 47997 //
     /*  146129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  146132 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  146132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  146135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  146149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  146164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146167 */     GIR_RootConstrainSelectedInstOperands,
     /*  146168 */     // GIR_Coverage, 47997,
     /*  146168 */     GIR_EraseRootFromParent_Done,
     /*  146169 */   // Label 2625: @146169
     /*  146169 */   GIM_Reject,
     /*  146170 */ // Label 2623: @146170
     /*  146170 */ GIM_Reject,
     /*  146171 */ // Label 2508: @146171
     /*  146171 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(147781),
     /*  146176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146186 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(146255), // Rule ID 53206 //
     /*  146191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146234 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146253 */     GIR_RootConstrainSelectedInstOperands,
     /*  146254 */     // GIR_Coverage, 53206,
     /*  146254 */     GIR_EraseRootFromParent_Done,
     /*  146255 */   // Label 2627: @146255
     /*  146255 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(146324), // Rule ID 53207 //
     /*  146260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146303 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146322 */     GIR_RootConstrainSelectedInstOperands,
     /*  146323 */     // GIR_Coverage, 53207,
     /*  146323 */     GIR_EraseRootFromParent_Done,
     /*  146324 */   // Label 2628: @146324
     /*  146324 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(146393), // Rule ID 53208 //
     /*  146329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146372 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  146375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146391 */     GIR_RootConstrainSelectedInstOperands,
     /*  146392 */     // GIR_Coverage, 53208,
     /*  146392 */     GIR_EraseRootFromParent_Done,
     /*  146393 */   // Label 2629: @146393
     /*  146393 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(146462), // Rule ID 53209 //
     /*  146398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146441 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  146444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146460 */     GIR_RootConstrainSelectedInstOperands,
     /*  146461 */     // GIR_Coverage, 53209,
     /*  146461 */     GIR_EraseRootFromParent_Done,
     /*  146462 */   // Label 2630: @146462
     /*  146462 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(146528), // Rule ID 71754 //
     /*  146467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146509 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146526 */     GIR_RootConstrainSelectedInstOperands,
     /*  146527 */     // GIR_Coverage, 71754,
     /*  146527 */     GIR_EraseRootFromParent_Done,
     /*  146528 */   // Label 2631: @146528
     /*  146528 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(146594), // Rule ID 71755 //
     /*  146533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146575 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146592 */     GIR_RootConstrainSelectedInstOperands,
     /*  146593 */     // GIR_Coverage, 71755,
     /*  146593 */     GIR_EraseRootFromParent_Done,
     /*  146594 */   // Label 2632: @146594
     /*  146594 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(146660), // Rule ID 71752 //
     /*  146599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  146627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146641 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146658 */     GIR_RootConstrainSelectedInstOperands,
     /*  146659 */     // GIR_Coverage, 71752,
     /*  146659 */     GIR_EraseRootFromParent_Done,
     /*  146660 */   // Label 2633: @146660
     /*  146660 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(146726), // Rule ID 71753 //
     /*  146665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  146693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146707 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146724 */     GIR_RootConstrainSelectedInstOperands,
     /*  146725 */     // GIR_Coverage, 71753,
     /*  146725 */     GIR_EraseRootFromParent_Done,
     /*  146726 */   // Label 2634: @146726
     /*  146726 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(146795), // Rule ID 53210 //
     /*  146731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146774 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146793 */     GIR_RootConstrainSelectedInstOperands,
     /*  146794 */     // GIR_Coverage, 53210,
     /*  146794 */     GIR_EraseRootFromParent_Done,
     /*  146795 */   // Label 2635: @146795
     /*  146795 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(146864), // Rule ID 53211 //
     /*  146800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146843 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146862 */     GIR_RootConstrainSelectedInstOperands,
     /*  146863 */     // GIR_Coverage, 53211,
     /*  146863 */     GIR_EraseRootFromParent_Done,
     /*  146864 */   // Label 2636: @146864
     /*  146864 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(146933), // Rule ID 71748 //
     /*  146869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  146884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146912 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146931 */     GIR_RootConstrainSelectedInstOperands,
     /*  146932 */     // GIR_Coverage, 71748,
     /*  146932 */     GIR_EraseRootFromParent_Done,
     /*  146933 */   // Label 2637: @146933
     /*  146933 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(147002), // Rule ID 71749 //
     /*  146938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  146953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146981 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147000 */     GIR_RootConstrainSelectedInstOperands,
     /*  147001 */     // GIR_Coverage, 71749,
     /*  147001 */     GIR_EraseRootFromParent_Done,
     /*  147002 */   // Label 2638: @147002
     /*  147002 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(147071), // Rule ID 71750 //
     /*  147007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147050 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  147053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147069 */     GIR_RootConstrainSelectedInstOperands,
     /*  147070 */     // GIR_Coverage, 71750,
     /*  147070 */     GIR_EraseRootFromParent_Done,
     /*  147071 */   // Label 2639: @147071
     /*  147071 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(147140), // Rule ID 71751 //
     /*  147076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147119 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  147122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147138 */     GIR_RootConstrainSelectedInstOperands,
     /*  147139 */     // GIR_Coverage, 71751,
     /*  147139 */     GIR_EraseRootFromParent_Done,
     /*  147140 */   // Label 2640: @147140
     /*  147140 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(147209), // Rule ID 71756 //
     /*  147145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147188 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147207 */     GIR_RootConstrainSelectedInstOperands,
     /*  147208 */     // GIR_Coverage, 71756,
     /*  147208 */     GIR_EraseRootFromParent_Done,
     /*  147209 */   // Label 2641: @147209
     /*  147209 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(147278), // Rule ID 71757 //
     /*  147214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147257 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147276 */     GIR_RootConstrainSelectedInstOperands,
     /*  147277 */     // GIR_Coverage, 71757,
     /*  147277 */     GIR_EraseRootFromParent_Done,
     /*  147278 */   // Label 2642: @147278
     /*  147278 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(147344), // Rule ID 71760 //
     /*  147283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  147310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147325 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  147334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147342 */     GIR_RootConstrainSelectedInstOperands,
     /*  147343 */     // GIR_Coverage, 71760,
     /*  147343 */     GIR_EraseRootFromParent_Done,
     /*  147344 */   // Label 2643: @147344
     /*  147344 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(147410), // Rule ID 71761 //
     /*  147349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  147376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147391 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  147400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147408 */     GIR_RootConstrainSelectedInstOperands,
     /*  147409 */     // GIR_Coverage, 71761,
     /*  147409 */     GIR_EraseRootFromParent_Done,
     /*  147410 */   // Label 2644: @147410
     /*  147410 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(147476), // Rule ID 71758 //
     /*  147415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147457 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147474 */     GIR_RootConstrainSelectedInstOperands,
     /*  147475 */     // GIR_Coverage, 71758,
     /*  147475 */     GIR_EraseRootFromParent_Done,
     /*  147476 */   // Label 2645: @147476
     /*  147476 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(147542), // Rule ID 71759 //
     /*  147481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147523 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147540 */     GIR_RootConstrainSelectedInstOperands,
     /*  147541 */     // GIR_Coverage, 71759,
     /*  147541 */     GIR_EraseRootFromParent_Done,
     /*  147542 */   // Label 2646: @147542
     /*  147542 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(147585), // Rule ID 71774 //
     /*  147547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147568 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147583 */     GIR_RootConstrainSelectedInstOperands,
     /*  147584 */     // GIR_Coverage, 71774,
     /*  147584 */     GIR_EraseRootFromParent_Done,
     /*  147585 */   // Label 2647: @147585
     /*  147585 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(147628), // Rule ID 71775 //
     /*  147590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147611 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147626 */     GIR_RootConstrainSelectedInstOperands,
     /*  147627 */     // GIR_Coverage, 71775,
     /*  147627 */     GIR_EraseRootFromParent_Done,
     /*  147628 */   // Label 2648: @147628
     /*  147628 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(147671), // Rule ID 53216 //
     /*  147633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147654 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147669 */     GIR_RootConstrainSelectedInstOperands,
     /*  147670 */     // GIR_Coverage, 53216,
     /*  147670 */     GIR_EraseRootFromParent_Done,
     /*  147671 */   // Label 2649: @147671
     /*  147671 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(147714), // Rule ID 53217 //
     /*  147676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147697 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147712 */     GIR_RootConstrainSelectedInstOperands,
     /*  147713 */     // GIR_Coverage, 53217,
     /*  147713 */     GIR_EraseRootFromParent_Done,
     /*  147714 */   // Label 2650: @147714
     /*  147714 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(147747), // Rule ID 53204 //
     /*  147719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147730 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  147733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147745 */     GIR_RootConstrainSelectedInstOperands,
     /*  147746 */     // GIR_Coverage, 53204,
     /*  147746 */     GIR_EraseRootFromParent_Done,
     /*  147747 */   // Label 2651: @147747
     /*  147747 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(147780), // Rule ID 53205 //
     /*  147752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147763 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  147766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147778 */     GIR_RootConstrainSelectedInstOperands,
     /*  147779 */     // GIR_Coverage, 53205,
     /*  147779 */     GIR_EraseRootFromParent_Done,
     /*  147780 */   // Label 2652: @147780
     /*  147780 */   GIM_Reject,
     /*  147781 */ // Label 2626: @147781
     /*  147781 */ GIM_Reject,
     /*  147782 */ // Label 2509: @147782
     /*  147782 */ GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(147896),
     /*  147787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  147790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  147793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147805 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(147850), // Rule ID 47928 //
     /*  147810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147813 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  147813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  147816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  147830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147848 */     GIR_RootConstrainSelectedInstOperands,
     /*  147849 */     // GIR_Coverage, 47928,
     /*  147849 */     GIR_EraseRootFromParent_Done,
     /*  147850 */   // Label 2654: @147850
     /*  147850 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(147895), // Rule ID 47929 //
     /*  147855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147858 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  147858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  147861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  147875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147893 */     GIR_RootConstrainSelectedInstOperands,
     /*  147894 */     // GIR_Coverage, 47929,
     /*  147894 */     GIR_EraseRootFromParent_Done,
     /*  147895 */   // Label 2655: @147895
     /*  147895 */   GIM_Reject,
     /*  147896 */ // Label 2653: @147896
     /*  147896 */ GIM_Reject,
     /*  147897 */ // Label 2510: @147897
     /*  147897 */ GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(148011),
     /*  147902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  147905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  147908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147916 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147920 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(147965), // Rule ID 47948 //
     /*  147925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147928 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  147928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  147931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  147945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  147960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147963 */     GIR_RootConstrainSelectedInstOperands,
     /*  147964 */     // GIR_Coverage, 47948,
     /*  147964 */     GIR_EraseRootFromParent_Done,
     /*  147965 */   // Label 2657: @147965
     /*  147965 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(148010), // Rule ID 47949 //
     /*  147970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147973 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  147973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  147976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  147990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  148005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148008 */     GIR_RootConstrainSelectedInstOperands,
     /*  148009 */     // GIR_Coverage, 47949,
     /*  148009 */     GIR_EraseRootFromParent_Done,
     /*  148010 */   // Label 2658: @148010
     /*  148010 */   GIM_Reject,
     /*  148011 */ // Label 2656: @148011
     /*  148011 */ GIM_Reject,
     /*  148012 */ // Label 2511: @148012
     /*  148012 */ GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(148126),
     /*  148017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  148020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  148023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148035 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(148080), // Rule ID 47984 //
     /*  148040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148043 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  148043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  148046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  148060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148078 */     GIR_RootConstrainSelectedInstOperands,
     /*  148079 */     // GIR_Coverage, 47984,
     /*  148079 */     GIR_EraseRootFromParent_Done,
     /*  148080 */   // Label 2660: @148080
     /*  148080 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(148125), // Rule ID 47985 //
     /*  148085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148088 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  148088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  148091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  148105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148123 */     GIR_RootConstrainSelectedInstOperands,
     /*  148124 */     // GIR_Coverage, 47985,
     /*  148124 */     GIR_EraseRootFromParent_Done,
     /*  148125 */   // Label 2661: @148125
     /*  148125 */   GIM_Reject,
     /*  148126 */ // Label 2659: @148126
     /*  148126 */ GIM_Reject,
     /*  148127 */ // Label 2512: @148127
     /*  148127 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(148241),
     /*  148132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  148135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  148138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148146 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148150 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(148195), // Rule ID 48000 //
     /*  148155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  148158 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  148158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  148161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  148175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148193 */     GIR_RootConstrainSelectedInstOperands,
     /*  148194 */     // GIR_Coverage, 48000,
     /*  148194 */     GIR_EraseRootFromParent_Done,
     /*  148195 */   // Label 2663: @148195
     /*  148195 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(148240), // Rule ID 48001 //
     /*  148200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  148203 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  148203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  148206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  148220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148238 */     GIR_RootConstrainSelectedInstOperands,
     /*  148239 */     // GIR_Coverage, 48001,
     /*  148239 */     GIR_EraseRootFromParent_Done,
     /*  148240 */   // Label 2664: @148240
     /*  148240 */   GIM_Reject,
     /*  148241 */ // Label 2662: @148241
     /*  148241 */ GIM_Reject,
     /*  148242 */ // Label 2513: @148242
     /*  148242 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(149852),
     /*  148247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148257 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(148326), // Rule ID 53224 //
     /*  148262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148305 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148324 */     GIR_RootConstrainSelectedInstOperands,
     /*  148325 */     // GIR_Coverage, 53224,
     /*  148325 */     GIR_EraseRootFromParent_Done,
     /*  148326 */   // Label 2666: @148326
     /*  148326 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(148395), // Rule ID 53225 //
     /*  148331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148374 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148393 */     GIR_RootConstrainSelectedInstOperands,
     /*  148394 */     // GIR_Coverage, 53225,
     /*  148394 */     GIR_EraseRootFromParent_Done,
     /*  148395 */   // Label 2667: @148395
     /*  148395 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(148464), // Rule ID 53226 //
     /*  148400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148443 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148462 */     GIR_RootConstrainSelectedInstOperands,
     /*  148463 */     // GIR_Coverage, 53226,
     /*  148463 */     GIR_EraseRootFromParent_Done,
     /*  148464 */   // Label 2668: @148464
     /*  148464 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(148533), // Rule ID 53227 //
     /*  148469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148512 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148531 */     GIR_RootConstrainSelectedInstOperands,
     /*  148532 */     // GIR_Coverage, 53227,
     /*  148532 */     GIR_EraseRootFromParent_Done,
     /*  148533 */   // Label 2669: @148533
     /*  148533 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(148599), // Rule ID 71782 //
     /*  148538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148580 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148597 */     GIR_RootConstrainSelectedInstOperands,
     /*  148598 */     // GIR_Coverage, 71782,
     /*  148598 */     GIR_EraseRootFromParent_Done,
     /*  148599 */   // Label 2670: @148599
     /*  148599 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(148665), // Rule ID 71783 //
     /*  148604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148646 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148663 */     GIR_RootConstrainSelectedInstOperands,
     /*  148664 */     // GIR_Coverage, 71783,
     /*  148664 */     GIR_EraseRootFromParent_Done,
     /*  148665 */   // Label 2671: @148665
     /*  148665 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(148731), // Rule ID 71780 //
     /*  148670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  148698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148712 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148729 */     GIR_RootConstrainSelectedInstOperands,
     /*  148730 */     // GIR_Coverage, 71780,
     /*  148730 */     GIR_EraseRootFromParent_Done,
     /*  148731 */   // Label 2672: @148731
     /*  148731 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(148797), // Rule ID 71781 //
     /*  148736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  148764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148778 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148795 */     GIR_RootConstrainSelectedInstOperands,
     /*  148796 */     // GIR_Coverage, 71781,
     /*  148796 */     GIR_EraseRootFromParent_Done,
     /*  148797 */   // Label 2673: @148797
     /*  148797 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(148866), // Rule ID 53228 //
     /*  148802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148845 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148864 */     GIR_RootConstrainSelectedInstOperands,
     /*  148865 */     // GIR_Coverage, 53228,
     /*  148865 */     GIR_EraseRootFromParent_Done,
     /*  148866 */   // Label 2674: @148866
     /*  148866 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(148935), // Rule ID 53229 //
     /*  148871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148914 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148933 */     GIR_RootConstrainSelectedInstOperands,
     /*  148934 */     // GIR_Coverage, 53229,
     /*  148934 */     GIR_EraseRootFromParent_Done,
     /*  148935 */   // Label 2675: @148935
     /*  148935 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(149004), // Rule ID 71776 //
     /*  148940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148971 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148983 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149002 */     GIR_RootConstrainSelectedInstOperands,
     /*  149003 */     // GIR_Coverage, 71776,
     /*  149003 */     GIR_EraseRootFromParent_Done,
     /*  149004 */   // Label 2676: @149004
     /*  149004 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(149073), // Rule ID 71777 //
     /*  149009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  149032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149052 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149071 */     GIR_RootConstrainSelectedInstOperands,
     /*  149072 */     // GIR_Coverage, 71777,
     /*  149072 */     GIR_EraseRootFromParent_Done,
     /*  149073 */   // Label 2677: @149073
     /*  149073 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(149142), // Rule ID 71778 //
     /*  149078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  149101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149121 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  149124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149140 */     GIR_RootConstrainSelectedInstOperands,
     /*  149141 */     // GIR_Coverage, 71778,
     /*  149141 */     GIR_EraseRootFromParent_Done,
     /*  149142 */   // Label 2678: @149142
     /*  149142 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(149211), // Rule ID 71779 //
     /*  149147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  149170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149190 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  149193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149209 */     GIR_RootConstrainSelectedInstOperands,
     /*  149210 */     // GIR_Coverage, 71779,
     /*  149210 */     GIR_EraseRootFromParent_Done,
     /*  149211 */   // Label 2679: @149211
     /*  149211 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(149280), // Rule ID 71784 //
     /*  149216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149247 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149259 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149278 */     GIR_RootConstrainSelectedInstOperands,
     /*  149279 */     // GIR_Coverage, 71784,
     /*  149279 */     GIR_EraseRootFromParent_Done,
     /*  149280 */   // Label 2680: @149280
     /*  149280 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(149349), // Rule ID 71785 //
     /*  149285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149328 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149347 */     GIR_RootConstrainSelectedInstOperands,
     /*  149348 */     // GIR_Coverage, 71785,
     /*  149348 */     GIR_EraseRootFromParent_Done,
     /*  149349 */   // Label 2681: @149349
     /*  149349 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(149415), // Rule ID 71788 //
     /*  149354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149396 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149413 */     GIR_RootConstrainSelectedInstOperands,
     /*  149414 */     // GIR_Coverage, 71788,
     /*  149414 */     GIR_EraseRootFromParent_Done,
     /*  149415 */   // Label 2682: @149415
     /*  149415 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(149481), // Rule ID 71789 //
     /*  149420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149462 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149479 */     GIR_RootConstrainSelectedInstOperands,
     /*  149480 */     // GIR_Coverage, 71789,
     /*  149480 */     GIR_EraseRootFromParent_Done,
     /*  149481 */   // Label 2683: @149481
     /*  149481 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(149547), // Rule ID 71786 //
     /*  149486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149528 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149545 */     GIR_RootConstrainSelectedInstOperands,
     /*  149546 */     // GIR_Coverage, 71786,
     /*  149546 */     GIR_EraseRootFromParent_Done,
     /*  149547 */   // Label 2684: @149547
     /*  149547 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(149613), // Rule ID 71787 //
     /*  149552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149594 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149611 */     GIR_RootConstrainSelectedInstOperands,
     /*  149612 */     // GIR_Coverage, 71787,
     /*  149612 */     GIR_EraseRootFromParent_Done,
     /*  149613 */   // Label 2685: @149613
     /*  149613 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(149656), // Rule ID 71802 //
     /*  149618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149639 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149654 */     GIR_RootConstrainSelectedInstOperands,
     /*  149655 */     // GIR_Coverage, 71802,
     /*  149655 */     GIR_EraseRootFromParent_Done,
     /*  149656 */   // Label 2686: @149656
     /*  149656 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(149699), // Rule ID 71803 //
     /*  149661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149682 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149697 */     GIR_RootConstrainSelectedInstOperands,
     /*  149698 */     // GIR_Coverage, 71803,
     /*  149698 */     GIR_EraseRootFromParent_Done,
     /*  149699 */   // Label 2687: @149699
     /*  149699 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(149742), // Rule ID 53234 //
     /*  149704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149725 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149740 */     GIR_RootConstrainSelectedInstOperands,
     /*  149741 */     // GIR_Coverage, 53234,
     /*  149741 */     GIR_EraseRootFromParent_Done,
     /*  149742 */   // Label 2688: @149742
     /*  149742 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(149785), // Rule ID 53235 //
     /*  149747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149768 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149783 */     GIR_RootConstrainSelectedInstOperands,
     /*  149784 */     // GIR_Coverage, 53235,
     /*  149784 */     GIR_EraseRootFromParent_Done,
     /*  149785 */   // Label 2689: @149785
     /*  149785 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(149818), // Rule ID 53222 //
     /*  149790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149801 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  149804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149816 */     GIR_RootConstrainSelectedInstOperands,
     /*  149817 */     // GIR_Coverage, 53222,
     /*  149817 */     GIR_EraseRootFromParent_Done,
     /*  149818 */   // Label 2690: @149818
     /*  149818 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(149851), // Rule ID 53223 //
     /*  149823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149834 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  149837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149849 */     GIR_RootConstrainSelectedInstOperands,
     /*  149850 */     // GIR_Coverage, 53223,
     /*  149850 */     GIR_EraseRootFromParent_Done,
     /*  149851 */   // Label 2691: @149851
     /*  149851 */   GIM_Reject,
     /*  149852 */ // Label 2665: @149852
     /*  149852 */ GIM_Reject,
     /*  149853 */ // Label 2514: @149853
     /*  149853 */ GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(149967),
     /*  149858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  149861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  149864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149876 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(149921), // Rule ID 47944 //
     /*  149881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149884 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  149884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  149887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  149901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149919 */     GIR_RootConstrainSelectedInstOperands,
     /*  149920 */     // GIR_Coverage, 47944,
     /*  149920 */     GIR_EraseRootFromParent_Done,
     /*  149921 */   // Label 2693: @149921
     /*  149921 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(149966), // Rule ID 47945 //
     /*  149926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149929 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  149929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  149932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  149946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149964 */     GIR_RootConstrainSelectedInstOperands,
     /*  149965 */     // GIR_Coverage, 47945,
     /*  149965 */     GIR_EraseRootFromParent_Done,
     /*  149966 */   // Label 2694: @149966
     /*  149966 */   GIM_Reject,
     /*  149967 */ // Label 2692: @149967
     /*  149967 */ GIM_Reject,
     /*  149968 */ // Label 2515: @149968
     /*  149968 */ GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(150082),
     /*  149973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  149976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  149979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149991 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(150036), // Rule ID 47972 //
     /*  149996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149999 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  149999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  150002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  150016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150034 */     GIR_RootConstrainSelectedInstOperands,
     /*  150035 */     // GIR_Coverage, 47972,
     /*  150035 */     GIR_EraseRootFromParent_Done,
     /*  150036 */   // Label 2696: @150036
     /*  150036 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(150081), // Rule ID 47973 //
     /*  150041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150044 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  150044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  150047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  150061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150079 */     GIR_RootConstrainSelectedInstOperands,
     /*  150080 */     // GIR_Coverage, 47973,
     /*  150080 */     GIR_EraseRootFromParent_Done,
     /*  150081 */   // Label 2697: @150081
     /*  150081 */   GIM_Reject,
     /*  150082 */ // Label 2695: @150082
     /*  150082 */ GIM_Reject,
     /*  150083 */ // Label 2516: @150083
     /*  150083 */ GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(150197),
     /*  150088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  150091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  150094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150106 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(150151), // Rule ID 47988 //
     /*  150111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150114 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  150114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  150117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  150131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150149 */     GIR_RootConstrainSelectedInstOperands,
     /*  150150 */     // GIR_Coverage, 47988,
     /*  150150 */     GIR_EraseRootFromParent_Done,
     /*  150151 */   // Label 2699: @150151
     /*  150151 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(150196), // Rule ID 47989 //
     /*  150156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150159 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  150159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  150162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  150176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150194 */     GIR_RootConstrainSelectedInstOperands,
     /*  150195 */     // GIR_Coverage, 47989,
     /*  150195 */     GIR_EraseRootFromParent_Done,
     /*  150196 */   // Label 2700: @150196
     /*  150196 */   GIM_Reject,
     /*  150197 */ // Label 2698: @150197
     /*  150197 */ GIM_Reject,
     /*  150198 */ // Label 2517: @150198
     /*  150198 */ GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(150312),
     /*  150203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  150206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  150209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150221 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(150266), // Rule ID 48004 //
     /*  150226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  150229 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  150229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  150232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  150246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  150261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150264 */     GIR_RootConstrainSelectedInstOperands,
     /*  150265 */     // GIR_Coverage, 48004,
     /*  150265 */     GIR_EraseRootFromParent_Done,
     /*  150266 */   // Label 2702: @150266
     /*  150266 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(150311), // Rule ID 48005 //
     /*  150271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  150274 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  150274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  150277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  150291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  150306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150309 */     GIR_RootConstrainSelectedInstOperands,
     /*  150310 */     // GIR_Coverage, 48005,
     /*  150310 */     GIR_EraseRootFromParent_Done,
     /*  150311 */   // Label 2703: @150311
     /*  150311 */   GIM_Reject,
     /*  150312 */ // Label 2701: @150312
     /*  150312 */ GIM_Reject,
     /*  150313 */ // Label 2518: @150313
     /*  150313 */ GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(151923),
     /*  150318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150328 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(150397), // Rule ID 53242 //
     /*  150333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150376 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  150379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150395 */     GIR_RootConstrainSelectedInstOperands,
     /*  150396 */     // GIR_Coverage, 53242,
     /*  150396 */     GIR_EraseRootFromParent_Done,
     /*  150397 */   // Label 2705: @150397
     /*  150397 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(150466), // Rule ID 53243 //
     /*  150402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150445 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  150448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150464 */     GIR_RootConstrainSelectedInstOperands,
     /*  150465 */     // GIR_Coverage, 53243,
     /*  150465 */     GIR_EraseRootFromParent_Done,
     /*  150466 */   // Label 2706: @150466
     /*  150466 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(150535), // Rule ID 53244 //
     /*  150471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150514 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150533 */     GIR_RootConstrainSelectedInstOperands,
     /*  150534 */     // GIR_Coverage, 53244,
     /*  150534 */     GIR_EraseRootFromParent_Done,
     /*  150535 */   // Label 2707: @150535
     /*  150535 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(150604), // Rule ID 53245 //
     /*  150540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150583 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150602 */     GIR_RootConstrainSelectedInstOperands,
     /*  150603 */     // GIR_Coverage, 53245,
     /*  150603 */     GIR_EraseRootFromParent_Done,
     /*  150604 */   // Label 2708: @150604
     /*  150604 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(150670), // Rule ID 71810 //
     /*  150609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  150632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150651 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  150660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150668 */     GIR_RootConstrainSelectedInstOperands,
     /*  150669 */     // GIR_Coverage, 71810,
     /*  150669 */     GIR_EraseRootFromParent_Done,
     /*  150670 */   // Label 2709: @150670
     /*  150670 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(150736), // Rule ID 71811 //
     /*  150675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  150698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150717 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  150726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150734 */     GIR_RootConstrainSelectedInstOperands,
     /*  150735 */     // GIR_Coverage, 71811,
     /*  150735 */     GIR_EraseRootFromParent_Done,
     /*  150736 */   // Label 2710: @150736
     /*  150736 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(150802), // Rule ID 71808 //
     /*  150741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  150769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150783 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150800 */     GIR_RootConstrainSelectedInstOperands,
     /*  150801 */     // GIR_Coverage, 71808,
     /*  150801 */     GIR_EraseRootFromParent_Done,
     /*  150802 */   // Label 2711: @150802
     /*  150802 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(150868), // Rule ID 71809 //
     /*  150807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  150835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150849 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150866 */     GIR_RootConstrainSelectedInstOperands,
     /*  150867 */     // GIR_Coverage, 71809,
     /*  150867 */     GIR_EraseRootFromParent_Done,
     /*  150868 */   // Label 2712: @150868
     /*  150868 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(150937), // Rule ID 53246 //
     /*  150873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150916 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150935 */     GIR_RootConstrainSelectedInstOperands,
     /*  150936 */     // GIR_Coverage, 53246,
     /*  150936 */     GIR_EraseRootFromParent_Done,
     /*  150937 */   // Label 2713: @150937
     /*  150937 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(151006), // Rule ID 53247 //
     /*  150942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150985 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151004 */     GIR_RootConstrainSelectedInstOperands,
     /*  151005 */     // GIR_Coverage, 53247,
     /*  151005 */     GIR_EraseRootFromParent_Done,
     /*  151006 */   // Label 2714: @151006
     /*  151006 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(151075), // Rule ID 71804 //
     /*  151011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  151034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151054 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151073 */     GIR_RootConstrainSelectedInstOperands,
     /*  151074 */     // GIR_Coverage, 71804,
     /*  151074 */     GIR_EraseRootFromParent_Done,
     /*  151075 */   // Label 2715: @151075
     /*  151075 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(151144), // Rule ID 71805 //
     /*  151080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  151103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151123 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151142 */     GIR_RootConstrainSelectedInstOperands,
     /*  151143 */     // GIR_Coverage, 71805,
     /*  151143 */     GIR_EraseRootFromParent_Done,
     /*  151144 */   // Label 2716: @151144
     /*  151144 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(151213), // Rule ID 71806 //
     /*  151149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  151172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151192 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  151195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151211 */     GIR_RootConstrainSelectedInstOperands,
     /*  151212 */     // GIR_Coverage, 71806,
     /*  151212 */     GIR_EraseRootFromParent_Done,
     /*  151213 */   // Label 2717: @151213
     /*  151213 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(151282), // Rule ID 71807 //
     /*  151218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  151241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151249 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151261 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  151264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151280 */     GIR_RootConstrainSelectedInstOperands,
     /*  151281 */     // GIR_Coverage, 71807,
     /*  151281 */     GIR_EraseRootFromParent_Done,
     /*  151282 */   // Label 2718: @151282
     /*  151282 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(151351), // Rule ID 71812 //
     /*  151287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151330 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151349 */     GIR_RootConstrainSelectedInstOperands,
     /*  151350 */     // GIR_Coverage, 71812,
     /*  151350 */     GIR_EraseRootFromParent_Done,
     /*  151351 */   // Label 2719: @151351
     /*  151351 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(151420), // Rule ID 71813 //
     /*  151356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151399 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151418 */     GIR_RootConstrainSelectedInstOperands,
     /*  151419 */     // GIR_Coverage, 71813,
     /*  151419 */     GIR_EraseRootFromParent_Done,
     /*  151420 */   // Label 2720: @151420
     /*  151420 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(151486), // Rule ID 71816 //
     /*  151425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151467 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  151476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151484 */     GIR_RootConstrainSelectedInstOperands,
     /*  151485 */     // GIR_Coverage, 71816,
     /*  151485 */     GIR_EraseRootFromParent_Done,
     /*  151486 */   // Label 2721: @151486
     /*  151486 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(151552), // Rule ID 71817 //
     /*  151491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151533 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  151542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151550 */     GIR_RootConstrainSelectedInstOperands,
     /*  151551 */     // GIR_Coverage, 71817,
     /*  151551 */     GIR_EraseRootFromParent_Done,
     /*  151552 */   // Label 2722: @151552
     /*  151552 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(151618), // Rule ID 71814 //
     /*  151557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  151589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151599 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151616 */     GIR_RootConstrainSelectedInstOperands,
     /*  151617 */     // GIR_Coverage, 71814,
     /*  151617 */     GIR_EraseRootFromParent_Done,
     /*  151618 */   // Label 2723: @151618
     /*  151618 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(151684), // Rule ID 71815 //
     /*  151623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  151655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151665 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151682 */     GIR_RootConstrainSelectedInstOperands,
     /*  151683 */     // GIR_Coverage, 71815,
     /*  151683 */     GIR_EraseRootFromParent_Done,
     /*  151684 */   // Label 2724: @151684
     /*  151684 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(151727), // Rule ID 71830 //
     /*  151689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151710 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151725 */     GIR_RootConstrainSelectedInstOperands,
     /*  151726 */     // GIR_Coverage, 71830,
     /*  151726 */     GIR_EraseRootFromParent_Done,
     /*  151727 */   // Label 2725: @151727
     /*  151727 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(151770), // Rule ID 71831 //
     /*  151732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151753 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151768 */     GIR_RootConstrainSelectedInstOperands,
     /*  151769 */     // GIR_Coverage, 71831,
     /*  151769 */     GIR_EraseRootFromParent_Done,
     /*  151770 */   // Label 2726: @151770
     /*  151770 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(151813), // Rule ID 53252 //
     /*  151775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151796 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151811 */     GIR_RootConstrainSelectedInstOperands,
     /*  151812 */     // GIR_Coverage, 53252,
     /*  151812 */     GIR_EraseRootFromParent_Done,
     /*  151813 */   // Label 2727: @151813
     /*  151813 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(151856), // Rule ID 53253 //
     /*  151818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151839 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151854 */     GIR_RootConstrainSelectedInstOperands,
     /*  151855 */     // GIR_Coverage, 53253,
     /*  151855 */     GIR_EraseRootFromParent_Done,
     /*  151856 */   // Label 2728: @151856
     /*  151856 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(151889), // Rule ID 53240 //
     /*  151861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151872 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  151875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151887 */     GIR_RootConstrainSelectedInstOperands,
     /*  151888 */     // GIR_Coverage, 53240,
     /*  151888 */     GIR_EraseRootFromParent_Done,
     /*  151889 */   // Label 2729: @151889
     /*  151889 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(151922), // Rule ID 53241 //
     /*  151894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151905 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  151908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151920 */     GIR_RootConstrainSelectedInstOperands,
     /*  151921 */     // GIR_Coverage, 53241,
     /*  151921 */     GIR_EraseRootFromParent_Done,
     /*  151922 */   // Label 2730: @151922
     /*  151922 */   GIM_Reject,
     /*  151923 */ // Label 2704: @151923
     /*  151923 */ GIM_Reject,
     /*  151924 */ // Label 2519: @151924
     /*  151924 */ GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(152038),
     /*  151929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  151932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  151935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151947 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(151992), // Rule ID 47960 //
     /*  151952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151955 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  151955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  151958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  151972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151990 */     GIR_RootConstrainSelectedInstOperands,
     /*  151991 */     // GIR_Coverage, 47960,
     /*  151991 */     GIR_EraseRootFromParent_Done,
     /*  151992 */   // Label 2732: @151992
     /*  151992 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(152037), // Rule ID 47961 //
     /*  151997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152000 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  152000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  152003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  152017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152035 */     GIR_RootConstrainSelectedInstOperands,
     /*  152036 */     // GIR_Coverage, 47961,
     /*  152036 */     GIR_EraseRootFromParent_Done,
     /*  152037 */   // Label 2733: @152037
     /*  152037 */   GIM_Reject,
     /*  152038 */ // Label 2731: @152038
     /*  152038 */ GIM_Reject,
     /*  152039 */ // Label 2520: @152039
     /*  152039 */ GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(152153),
     /*  152044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  152047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  152050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152062 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(152107), // Rule ID 47976 //
     /*  152067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152070 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  152070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  152073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  152087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152105 */     GIR_RootConstrainSelectedInstOperands,
     /*  152106 */     // GIR_Coverage, 47976,
     /*  152106 */     GIR_EraseRootFromParent_Done,
     /*  152107 */   // Label 2735: @152107
     /*  152107 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(152152), // Rule ID 47977 //
     /*  152112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152115 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  152115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  152118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  152132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152150 */     GIR_RootConstrainSelectedInstOperands,
     /*  152151 */     // GIR_Coverage, 47977,
     /*  152151 */     GIR_EraseRootFromParent_Done,
     /*  152152 */   // Label 2736: @152152
     /*  152152 */   GIM_Reject,
     /*  152153 */ // Label 2734: @152153
     /*  152153 */ GIM_Reject,
     /*  152154 */ // Label 2521: @152154
     /*  152154 */ GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(152268),
     /*  152159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  152162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  152165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152177 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(152222), // Rule ID 47992 //
     /*  152182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152185 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  152185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  152188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  152202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  152217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152220 */     GIR_RootConstrainSelectedInstOperands,
     /*  152221 */     // GIR_Coverage, 47992,
     /*  152221 */     GIR_EraseRootFromParent_Done,
     /*  152222 */   // Label 2738: @152222
     /*  152222 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(152267), // Rule ID 47993 //
     /*  152227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152230 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  152230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  152233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  152247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  152262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152265 */     GIR_RootConstrainSelectedInstOperands,
     /*  152266 */     // GIR_Coverage, 47993,
     /*  152266 */     GIR_EraseRootFromParent_Done,
     /*  152267 */   // Label 2739: @152267
     /*  152267 */   GIM_Reject,
     /*  152268 */ // Label 2737: @152268
     /*  152268 */ GIM_Reject,
     /*  152269 */ // Label 2522: @152269
     /*  152269 */ GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(153879),
     /*  152274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152284 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(152353), // Rule ID 53260 //
     /*  152289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152332 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  152335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152351 */     GIR_RootConstrainSelectedInstOperands,
     /*  152352 */     // GIR_Coverage, 53260,
     /*  152352 */     GIR_EraseRootFromParent_Done,
     /*  152353 */   // Label 2741: @152353
     /*  152353 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(152422), // Rule ID 53261 //
     /*  152358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152399 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152401 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  152404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152420 */     GIR_RootConstrainSelectedInstOperands,
     /*  152421 */     // GIR_Coverage, 53261,
     /*  152421 */     GIR_EraseRootFromParent_Done,
     /*  152422 */   // Label 2742: @152422
     /*  152422 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(152491), // Rule ID 53262 //
     /*  152427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152470 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  152473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152489 */     GIR_RootConstrainSelectedInstOperands,
     /*  152490 */     // GIR_Coverage, 53262,
     /*  152490 */     GIR_EraseRootFromParent_Done,
     /*  152491 */   // Label 2743: @152491
     /*  152491 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(152560), // Rule ID 53263 //
     /*  152496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152539 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  152542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152558 */     GIR_RootConstrainSelectedInstOperands,
     /*  152559 */     // GIR_Coverage, 53263,
     /*  152559 */     GIR_EraseRootFromParent_Done,
     /*  152560 */   // Label 2744: @152560
     /*  152560 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(152626), // Rule ID 71838 //
     /*  152565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  152588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152607 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  152616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152624 */     GIR_RootConstrainSelectedInstOperands,
     /*  152625 */     // GIR_Coverage, 71838,
     /*  152625 */     GIR_EraseRootFromParent_Done,
     /*  152626 */   // Label 2745: @152626
     /*  152626 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(152692), // Rule ID 71839 //
     /*  152631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  152654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152673 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  152682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152690 */     GIR_RootConstrainSelectedInstOperands,
     /*  152691 */     // GIR_Coverage, 71839,
     /*  152691 */     GIR_EraseRootFromParent_Done,
     /*  152692 */   // Label 2746: @152692
     /*  152692 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(152758), // Rule ID 71836 //
     /*  152697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  152725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152739 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152756 */     GIR_RootConstrainSelectedInstOperands,
     /*  152757 */     // GIR_Coverage, 71836,
     /*  152757 */     GIR_EraseRootFromParent_Done,
     /*  152758 */   // Label 2747: @152758
     /*  152758 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(152824), // Rule ID 71837 //
     /*  152763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  152791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152805 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152822 */     GIR_RootConstrainSelectedInstOperands,
     /*  152823 */     // GIR_Coverage, 71837,
     /*  152823 */     GIR_EraseRootFromParent_Done,
     /*  152824 */   // Label 2748: @152824
     /*  152824 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(152893), // Rule ID 53264 //
     /*  152829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152872 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152891 */     GIR_RootConstrainSelectedInstOperands,
     /*  152892 */     // GIR_Coverage, 53264,
     /*  152892 */     GIR_EraseRootFromParent_Done,
     /*  152893 */   // Label 2749: @152893
     /*  152893 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(152962), // Rule ID 53265 //
     /*  152898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152941 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152960 */     GIR_RootConstrainSelectedInstOperands,
     /*  152961 */     // GIR_Coverage, 53265,
     /*  152961 */     GIR_EraseRootFromParent_Done,
     /*  152962 */   // Label 2750: @152962
     /*  152962 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(153031), // Rule ID 71832 //
     /*  152967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  152982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153010 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153029 */     GIR_RootConstrainSelectedInstOperands,
     /*  153030 */     // GIR_Coverage, 71832,
     /*  153030 */     GIR_EraseRootFromParent_Done,
     /*  153031 */   // Label 2751: @153031
     /*  153031 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(153100), // Rule ID 71833 //
     /*  153036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  153059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153079 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153098 */     GIR_RootConstrainSelectedInstOperands,
     /*  153099 */     // GIR_Coverage, 71833,
     /*  153099 */     GIR_EraseRootFromParent_Done,
     /*  153100 */   // Label 2752: @153100
     /*  153100 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(153169), // Rule ID 71834 //
     /*  153105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  153128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153148 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  153151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153167 */     GIR_RootConstrainSelectedInstOperands,
     /*  153168 */     // GIR_Coverage, 71834,
     /*  153168 */     GIR_EraseRootFromParent_Done,
     /*  153169 */   // Label 2753: @153169
     /*  153169 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(153238), // Rule ID 71835 //
     /*  153174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  153197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153205 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153217 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  153220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153236 */     GIR_RootConstrainSelectedInstOperands,
     /*  153237 */     // GIR_Coverage, 71835,
     /*  153237 */     GIR_EraseRootFromParent_Done,
     /*  153238 */   // Label 2754: @153238
     /*  153238 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(153307), // Rule ID 71840 //
     /*  153243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153286 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153305 */     GIR_RootConstrainSelectedInstOperands,
     /*  153306 */     // GIR_Coverage, 71840,
     /*  153306 */     GIR_EraseRootFromParent_Done,
     /*  153307 */   // Label 2755: @153307
     /*  153307 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(153376), // Rule ID 71841 //
     /*  153312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153355 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153374 */     GIR_RootConstrainSelectedInstOperands,
     /*  153375 */     // GIR_Coverage, 71841,
     /*  153375 */     GIR_EraseRootFromParent_Done,
     /*  153376 */   // Label 2756: @153376
     /*  153376 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(153442), // Rule ID 71844 //
     /*  153381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153423 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153440 */     GIR_RootConstrainSelectedInstOperands,
     /*  153441 */     // GIR_Coverage, 71844,
     /*  153441 */     GIR_EraseRootFromParent_Done,
     /*  153442 */   // Label 2757: @153442
     /*  153442 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(153508), // Rule ID 71845 //
     /*  153447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153489 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153506 */     GIR_RootConstrainSelectedInstOperands,
     /*  153507 */     // GIR_Coverage, 71845,
     /*  153507 */     GIR_EraseRootFromParent_Done,
     /*  153508 */   // Label 2758: @153508
     /*  153508 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(153574), // Rule ID 71842 //
     /*  153513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  153545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153555 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153572 */     GIR_RootConstrainSelectedInstOperands,
     /*  153573 */     // GIR_Coverage, 71842,
     /*  153573 */     GIR_EraseRootFromParent_Done,
     /*  153574 */   // Label 2759: @153574
     /*  153574 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(153640), // Rule ID 71843 //
     /*  153579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  153611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153621 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153638 */     GIR_RootConstrainSelectedInstOperands,
     /*  153639 */     // GIR_Coverage, 71843,
     /*  153639 */     GIR_EraseRootFromParent_Done,
     /*  153640 */   // Label 2760: @153640
     /*  153640 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(153683), // Rule ID 71858 //
     /*  153645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153666 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153681 */     GIR_RootConstrainSelectedInstOperands,
     /*  153682 */     // GIR_Coverage, 71858,
     /*  153682 */     GIR_EraseRootFromParent_Done,
     /*  153683 */   // Label 2761: @153683
     /*  153683 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(153726), // Rule ID 71859 //
     /*  153688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153709 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153724 */     GIR_RootConstrainSelectedInstOperands,
     /*  153725 */     // GIR_Coverage, 71859,
     /*  153725 */     GIR_EraseRootFromParent_Done,
     /*  153726 */   // Label 2762: @153726
     /*  153726 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(153769), // Rule ID 53270 //
     /*  153731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153752 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153767 */     GIR_RootConstrainSelectedInstOperands,
     /*  153768 */     // GIR_Coverage, 53270,
     /*  153768 */     GIR_EraseRootFromParent_Done,
     /*  153769 */   // Label 2763: @153769
     /*  153769 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(153812), // Rule ID 53271 //
     /*  153774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153795 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153810 */     GIR_RootConstrainSelectedInstOperands,
     /*  153811 */     // GIR_Coverage, 53271,
     /*  153811 */     GIR_EraseRootFromParent_Done,
     /*  153812 */   // Label 2764: @153812
     /*  153812 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(153845), // Rule ID 53258 //
     /*  153817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153828 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  153831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153843 */     GIR_RootConstrainSelectedInstOperands,
     /*  153844 */     // GIR_Coverage, 53258,
     /*  153844 */     GIR_EraseRootFromParent_Done,
     /*  153845 */   // Label 2765: @153845
     /*  153845 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(153878), // Rule ID 53259 //
     /*  153850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153861 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  153864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153876 */     GIR_RootConstrainSelectedInstOperands,
     /*  153877 */     // GIR_Coverage, 53259,
     /*  153877 */     GIR_EraseRootFromParent_Done,
     /*  153878 */   // Label 2766: @153878
     /*  153878 */   GIM_Reject,
     /*  153879 */ // Label 2740: @153879
     /*  153879 */ GIM_Reject,
     /*  153880 */ // Label 2523: @153880
     /*  153880 */ GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(153994),
     /*  153885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  153888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  153891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153903 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(153948), // Rule ID 47964 //
     /*  153908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153911 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  153911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  153914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  153918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  153923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  153925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  153928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  153933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153946 */     GIR_RootConstrainSelectedInstOperands,
     /*  153947 */     // GIR_Coverage, 47964,
     /*  153947 */     GIR_EraseRootFromParent_Done,
     /*  153948 */   // Label 2768: @153948
     /*  153948 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(153993), // Rule ID 47965 //
     /*  153953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153956 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  153956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  153959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  153963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  153968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  153970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  153973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  153978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153991 */     GIR_RootConstrainSelectedInstOperands,
     /*  153992 */     // GIR_Coverage, 47965,
     /*  153992 */     GIR_EraseRootFromParent_Done,
     /*  153993 */   // Label 2769: @153993
     /*  153993 */   GIM_Reject,
     /*  153994 */ // Label 2767: @153994
     /*  153994 */ GIM_Reject,
     /*  153995 */ // Label 2524: @153995
     /*  153995 */ GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(154109),
     /*  154000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  154003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  154006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154018 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(154063), // Rule ID 47980 //
     /*  154023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154026 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  154026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  154029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  154033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  154038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  154040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  154043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  154048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  154058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154061 */     GIR_RootConstrainSelectedInstOperands,
     /*  154062 */     // GIR_Coverage, 47980,
     /*  154062 */     GIR_EraseRootFromParent_Done,
     /*  154063 */   // Label 2771: @154063
     /*  154063 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(154108), // Rule ID 47981 //
     /*  154068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154071 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  154071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  154074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  154078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  154083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  154085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  154088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  154093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  154103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154106 */     GIR_RootConstrainSelectedInstOperands,
     /*  154107 */     // GIR_Coverage, 47981,
     /*  154107 */     GIR_EraseRootFromParent_Done,
     /*  154108 */   // Label 2772: @154108
     /*  154108 */   GIM_Reject,
     /*  154109 */ // Label 2770: @154109
     /*  154109 */ GIM_Reject,
     /*  154110 */ // Label 2525: @154110
     /*  154110 */ GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(155720),
     /*  154115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154125 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(154194), // Rule ID 53278 //
     /*  154130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154173 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154192 */     GIR_RootConstrainSelectedInstOperands,
     /*  154193 */     // GIR_Coverage, 53278,
     /*  154193 */     GIR_EraseRootFromParent_Done,
     /*  154194 */   // Label 2774: @154194
     /*  154194 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(154263), // Rule ID 53279 //
     /*  154199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154242 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154261 */     GIR_RootConstrainSelectedInstOperands,
     /*  154262 */     // GIR_Coverage, 53279,
     /*  154262 */     GIR_EraseRootFromParent_Done,
     /*  154263 */   // Label 2775: @154263
     /*  154263 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(154332), // Rule ID 53280 //
     /*  154268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154311 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154330 */     GIR_RootConstrainSelectedInstOperands,
     /*  154331 */     // GIR_Coverage, 53280,
     /*  154331 */     GIR_EraseRootFromParent_Done,
     /*  154332 */   // Label 2776: @154332
     /*  154332 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(154401), // Rule ID 53281 //
     /*  154337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154380 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154399 */     GIR_RootConstrainSelectedInstOperands,
     /*  154400 */     // GIR_Coverage, 53281,
     /*  154400 */     GIR_EraseRootFromParent_Done,
     /*  154401 */   // Label 2777: @154401
     /*  154401 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(154467), // Rule ID 71866 //
     /*  154406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154448 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154465 */     GIR_RootConstrainSelectedInstOperands,
     /*  154466 */     // GIR_Coverage, 71866,
     /*  154466 */     GIR_EraseRootFromParent_Done,
     /*  154467 */   // Label 2778: @154467
     /*  154467 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(154533), // Rule ID 71867 //
     /*  154472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154514 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154531 */     GIR_RootConstrainSelectedInstOperands,
     /*  154532 */     // GIR_Coverage, 71867,
     /*  154532 */     GIR_EraseRootFromParent_Done,
     /*  154533 */   // Label 2779: @154533
     /*  154533 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(154599), // Rule ID 71864 //
     /*  154538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154580 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154597 */     GIR_RootConstrainSelectedInstOperands,
     /*  154598 */     // GIR_Coverage, 71864,
     /*  154598 */     GIR_EraseRootFromParent_Done,
     /*  154599 */   // Label 2780: @154599
     /*  154599 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(154665), // Rule ID 71865 //
     /*  154604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154646 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154663 */     GIR_RootConstrainSelectedInstOperands,
     /*  154664 */     // GIR_Coverage, 71865,
     /*  154664 */     GIR_EraseRootFromParent_Done,
     /*  154665 */   // Label 2781: @154665
     /*  154665 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(154734), // Rule ID 53282 //
     /*  154670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154713 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154732 */     GIR_RootConstrainSelectedInstOperands,
     /*  154733 */     // GIR_Coverage, 53282,
     /*  154733 */     GIR_EraseRootFromParent_Done,
     /*  154734 */   // Label 2782: @154734
     /*  154734 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(154803), // Rule ID 53283 //
     /*  154739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154782 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154801 */     GIR_RootConstrainSelectedInstOperands,
     /*  154802 */     // GIR_Coverage, 53283,
     /*  154802 */     GIR_EraseRootFromParent_Done,
     /*  154803 */   // Label 2783: @154803
     /*  154803 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(154872), // Rule ID 71860 //
     /*  154808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154839 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154851 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154870 */     GIR_RootConstrainSelectedInstOperands,
     /*  154871 */     // GIR_Coverage, 71860,
     /*  154871 */     GIR_EraseRootFromParent_Done,
     /*  154872 */   // Label 2784: @154872
     /*  154872 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(154941), // Rule ID 71861 //
     /*  154877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154920 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154939 */     GIR_RootConstrainSelectedInstOperands,
     /*  154940 */     // GIR_Coverage, 71861,
     /*  154940 */     GIR_EraseRootFromParent_Done,
     /*  154941 */   // Label 2785: @154941
     /*  154941 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(155010), // Rule ID 71862 //
     /*  154946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154989 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155008 */     GIR_RootConstrainSelectedInstOperands,
     /*  155009 */     // GIR_Coverage, 71862,
     /*  155009 */     GIR_EraseRootFromParent_Done,
     /*  155010 */   // Label 2786: @155010
     /*  155010 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(155079), // Rule ID 71863 //
     /*  155015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  155038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155058 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  155061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155077 */     GIR_RootConstrainSelectedInstOperands,
     /*  155078 */     // GIR_Coverage, 71863,
     /*  155078 */     GIR_EraseRootFromParent_Done,
     /*  155079 */   // Label 2787: @155079
     /*  155079 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(155148), // Rule ID 71868 //
     /*  155084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155111 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155127 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155146 */     GIR_RootConstrainSelectedInstOperands,
     /*  155147 */     // GIR_Coverage, 71868,
     /*  155147 */     GIR_EraseRootFromParent_Done,
     /*  155148 */   // Label 2788: @155148
     /*  155148 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(155217), // Rule ID 71869 //
     /*  155153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155196 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155215 */     GIR_RootConstrainSelectedInstOperands,
     /*  155216 */     // GIR_Coverage, 71869,
     /*  155216 */     GIR_EraseRootFromParent_Done,
     /*  155217 */   // Label 2789: @155217
     /*  155217 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(155283), // Rule ID 71872 //
     /*  155222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  155249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  155257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155264 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  155273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155281 */     GIR_RootConstrainSelectedInstOperands,
     /*  155282 */     // GIR_Coverage, 71872,
     /*  155282 */     GIR_EraseRootFromParent_Done,
     /*  155283 */   // Label 2790: @155283
     /*  155283 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(155349), // Rule ID 71873 //
     /*  155288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  155315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155330 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  155339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155347 */     GIR_RootConstrainSelectedInstOperands,
     /*  155348 */     // GIR_Coverage, 71873,
     /*  155348 */     GIR_EraseRootFromParent_Done,
     /*  155349 */   // Label 2791: @155349
     /*  155349 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(155415), // Rule ID 71870 //
     /*  155354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  155394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155396 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155413 */     GIR_RootConstrainSelectedInstOperands,
     /*  155414 */     // GIR_Coverage, 71870,
     /*  155414 */     GIR_EraseRootFromParent_Done,
     /*  155415 */   // Label 2792: @155415
     /*  155415 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(155481), // Rule ID 71871 //
     /*  155420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155462 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155479 */     GIR_RootConstrainSelectedInstOperands,
     /*  155480 */     // GIR_Coverage, 71871,
     /*  155480 */     GIR_EraseRootFromParent_Done,
     /*  155481 */   // Label 2793: @155481
     /*  155481 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(155524), // Rule ID 71886 //
     /*  155486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155507 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155522 */     GIR_RootConstrainSelectedInstOperands,
     /*  155523 */     // GIR_Coverage, 71886,
     /*  155523 */     GIR_EraseRootFromParent_Done,
     /*  155524 */   // Label 2794: @155524
     /*  155524 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(155567), // Rule ID 71887 //
     /*  155529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155550 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155565 */     GIR_RootConstrainSelectedInstOperands,
     /*  155566 */     // GIR_Coverage, 71887,
     /*  155566 */     GIR_EraseRootFromParent_Done,
     /*  155567 */   // Label 2795: @155567
     /*  155567 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(155610), // Rule ID 53288 //
     /*  155572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155593 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155608 */     GIR_RootConstrainSelectedInstOperands,
     /*  155609 */     // GIR_Coverage, 53288,
     /*  155609 */     GIR_EraseRootFromParent_Done,
     /*  155610 */   // Label 2796: @155610
     /*  155610 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(155653), // Rule ID 53289 //
     /*  155615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155636 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155651 */     GIR_RootConstrainSelectedInstOperands,
     /*  155652 */     // GIR_Coverage, 53289,
     /*  155652 */     GIR_EraseRootFromParent_Done,
     /*  155653 */   // Label 2797: @155653
     /*  155653 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(155686), // Rule ID 53276 //
     /*  155658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155669 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  155672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155684 */     GIR_RootConstrainSelectedInstOperands,
     /*  155685 */     // GIR_Coverage, 53276,
     /*  155685 */     GIR_EraseRootFromParent_Done,
     /*  155686 */   // Label 2798: @155686
     /*  155686 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(155719), // Rule ID 53277 //
     /*  155691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155702 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  155705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155717 */     GIR_RootConstrainSelectedInstOperands,
     /*  155718 */     // GIR_Coverage, 53277,
     /*  155718 */     GIR_EraseRootFromParent_Done,
     /*  155719 */   // Label 2799: @155719
     /*  155719 */   GIM_Reject,
     /*  155720 */ // Label 2773: @155720
     /*  155720 */ GIM_Reject,
     /*  155721 */ // Label 2526: @155721
     /*  155721 */ GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(155835),
     /*  155726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  155729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  155732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155744 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(155789), // Rule ID 47968 //
     /*  155749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155752 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  155752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  155755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  155759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  155764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  155766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  155769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  155774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155787 */     GIR_RootConstrainSelectedInstOperands,
     /*  155788 */     // GIR_Coverage, 47968,
     /*  155788 */     GIR_EraseRootFromParent_Done,
     /*  155789 */   // Label 2801: @155789
     /*  155789 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(155834), // Rule ID 47969 //
     /*  155794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155797 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  155797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  155800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  155804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  155809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  155811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  155814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  155819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155832 */     GIR_RootConstrainSelectedInstOperands,
     /*  155833 */     // GIR_Coverage, 47969,
     /*  155833 */     GIR_EraseRootFromParent_Done,
     /*  155834 */   // Label 2802: @155834
     /*  155834 */   GIM_Reject,
     /*  155835 */ // Label 2800: @155835
     /*  155835 */ GIM_Reject,
     /*  155836 */ // Label 2527: @155836
     /*  155836 */ GIM_Reject,
     /*  155837 */ // Label 10: @155837
     /*  155837 */ GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(155897),
     /*  155842 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  155846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155850 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(155873), // Rule ID 116 //
     /*  155855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  155858 */     // MIs[0] Operand 1
     /*  155858 */     // No operand predicates
     /*  155858 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i64] })
     /*  155858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  155861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155863 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  155868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155871 */     GIR_RootConstrainSelectedInstOperands,
     /*  155872 */     // GIR_Coverage, 116,
     /*  155872 */     GIR_EraseRootFromParent_Done,
     /*  155873 */   // Label 2804: @155873
     /*  155873 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(155896), // Rule ID 117 //
     /*  155878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  155881 */     // MIs[0] Operand 1
     /*  155881 */     // No operand predicates
     /*  155881 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i32] })
     /*  155881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  155884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155886 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  155891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155894 */     GIR_RootConstrainSelectedInstOperands,
     /*  155895 */     // GIR_Coverage, 117,
     /*  155895 */     GIR_EraseRootFromParent_Done,
     /*  155896 */   // Label 2805: @155896
     /*  155896 */   GIM_Reject,
     /*  155897 */ // Label 2803: @155897
     /*  155897 */ GIM_Reject,
     /*  155898 */ // Label 11: @155898
     /*  155898 */ GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(155958),
     /*  155903 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  155906 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  155909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  155912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  155915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  155927 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(155942), // Rule ID 56 //
     /*  155932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  155935 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  155935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  155940 */     GIR_RootConstrainSelectedInstOperands,
     /*  155941 */     // GIR_Coverage, 56,
     /*  155941 */     GIR_Done,
     /*  155942 */   // Label 2807: @155942
     /*  155942 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(155957), // Rule ID 57 //
     /*  155947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  155950 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  155950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  155955 */     GIR_RootConstrainSelectedInstOperands,
     /*  155956 */     // GIR_Coverage, 57,
     /*  155956 */     GIR_Done,
     /*  155957 */   // Label 2808: @155957
     /*  155957 */   GIM_Reject,
     /*  155958 */ // Label 2806: @155958
     /*  155958 */ GIM_Reject,
     /*  155959 */ // Label 12: @155959
     /*  155959 */ GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(156049),
     /*  155964 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  155967 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  155970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  155973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  155976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  155980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155988 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(156003), // Rule ID 54 //
     /*  155993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  155996 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  155996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  156001 */     GIR_RootConstrainSelectedInstOperands,
     /*  156002 */     // GIR_Coverage, 54,
     /*  156002 */     GIR_Done,
     /*  156003 */   // Label 2810: @156003
     /*  156003 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(156018), // Rule ID 55 //
     /*  156008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  156011 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  156011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  156016 */     GIR_RootConstrainSelectedInstOperands,
     /*  156017 */     // GIR_Coverage, 55,
     /*  156017 */     GIR_Done,
     /*  156018 */   // Label 2811: @156018
     /*  156018 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(156033), // Rule ID 2404 //
     /*  156023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0),
     /*  156026 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  156026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  156031 */     GIR_RootConstrainSelectedInstOperands,
     /*  156032 */     // GIR_Coverage, 2404,
     /*  156032 */     GIR_Done,
     /*  156033 */   // Label 2812: @156033
     /*  156033 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(156048), // Rule ID 2405 //
     /*  156038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1),
     /*  156041 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  156041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  156046 */     GIR_RootConstrainSelectedInstOperands,
     /*  156047 */     // GIR_Coverage, 2405,
     /*  156047 */     GIR_Done,
     /*  156048 */   // Label 2813: @156048
     /*  156048 */   GIM_Reject,
     /*  156049 */ // Label 2809: @156049
     /*  156049 */ GIM_Reject,
     /*  156050 */ // Label 13: @156050
     /*  156050 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2816*/ GIMT_Encode4(156416),
     /*  156061 */ /*GILLT_s32*//*Label 2814*/ GIMT_Encode4(156069),
     /*  156065 */ /*GILLT_s64*//*Label 2815*/ GIMT_Encode4(156306),
     /*  156069 */ // Label 2814: @156069
     /*  156069 */ GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(156305),
     /*  156074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156077 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(156100), // Rule ID 1447 //
     /*  156082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  156085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156093 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  156093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  156098 */     GIR_RootConstrainSelectedInstOperands,
     /*  156099 */     // GIR_Coverage, 1447,
     /*  156099 */     GIR_Done,
     /*  156100 */   // Label 2818: @156100
     /*  156100 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(156123), // Rule ID 1448 //
     /*  156105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  156108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156116 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  156116 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  156121 */     GIR_RootConstrainSelectedInstOperands,
     /*  156122 */     // GIR_Coverage, 1448,
     /*  156122 */     GIR_Done,
     /*  156123 */   // Label 2819: @156123
     /*  156123 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(156146), // Rule ID 1449 //
     /*  156128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  156131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156139 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  156139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  156144 */     GIR_RootConstrainSelectedInstOperands,
     /*  156145 */     // GIR_Coverage, 1449,
     /*  156145 */     GIR_Done,
     /*  156146 */   // Label 2820: @156146
     /*  156146 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(156169), // Rule ID 1450 //
     /*  156151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  156154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156162 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  156162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  156167 */     GIR_RootConstrainSelectedInstOperands,
     /*  156168 */     // GIR_Coverage, 1450,
     /*  156168 */     GIR_Done,
     /*  156169 */   // Label 2821: @156169
     /*  156169 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(156207), // Rule ID 1451 //
     /*  156174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  156177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156185 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  156185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  156190 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  156196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156206 */     // GIR_Coverage, 1451,
     /*  156206 */     GIR_EraseRootFromParent_Done,
     /*  156207 */   // Label 2822: @156207
     /*  156207 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(156245), // Rule ID 1452 //
     /*  156212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  156215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156223 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  156223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  156228 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  156234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156244 */     // GIR_Coverage, 1452,
     /*  156244 */     GIR_EraseRootFromParent_Done,
     /*  156245 */   // Label 2823: @156245
     /*  156245 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(156304), // Rule ID 1453 //
     /*  156250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  156253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156261 */     // (bitconvert:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), FPR32INX:{ *:[f32] }:$rs1, sub_32:{ *:[i32] })
     /*  156261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  156264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  156268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  156273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  156275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  156278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  156280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  156283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  156288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156303 */     // GIR_Coverage, 1453,
     /*  156303 */     GIR_EraseRootFromParent_Done,
     /*  156304 */   // Label 2824: @156304
     /*  156304 */   GIM_Reject,
     /*  156305 */ // Label 2817: @156305
     /*  156305 */ GIM_Reject,
     /*  156306 */ // Label 2815: @156306
     /*  156306 */ GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(156415),
     /*  156311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156314 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(156337), // Rule ID 1900 //
     /*  156319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  156322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156330 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FMV_D_X:{ *:[f64] } GPR:{ *:[i64] }:$rs1)
     /*  156330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_D_X),
     /*  156335 */     GIR_RootConstrainSelectedInstOperands,
     /*  156336 */     // GIR_Coverage, 1900,
     /*  156336 */     GIR_Done,
     /*  156337 */   // Label 2826: @156337
     /*  156337 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(156360), // Rule ID 1901 //
     /*  156342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  156345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156353 */     // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMV_X_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)
     /*  156353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_D),
     /*  156358 */     GIR_RootConstrainSelectedInstOperands,
     /*  156359 */     // GIR_Coverage, 1901,
     /*  156359 */     GIR_Done,
     /*  156360 */   // Label 2827: @156360
     /*  156360 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(156387), // Rule ID 1928 //
     /*  156365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  156368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156376 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i32] })
     /*  156376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156386 */     // GIR_Coverage, 1928,
     /*  156386 */     GIR_Done,
     /*  156387 */   // Label 2828: @156387
     /*  156387 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(156414), // Rule ID 1929 //
     /*  156392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  156395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156403 */     // (bitconvert:{ *:[i64] } GPR:{ *:[f64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[i64] } GPR:{ *:[f64] }:$rs1, GPR:{ *:[i32] })
     /*  156403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156413 */     // GIR_Coverage, 1929,
     /*  156413 */     GIR_Done,
     /*  156414 */   // Label 2829: @156414
     /*  156414 */   GIM_Reject,
     /*  156415 */ // Label 2825: @156415
     /*  156415 */ GIM_Reject,
     /*  156416 */ // Label 2816: @156416
     /*  156416 */ GIM_Reject,
     /*  156417 */ // Label 14: @156417
     /*  156417 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2833*/ GIMT_Encode4(156614),
     /*  156428 */ /*GILLT_s16*//*Label 2830*/ GIMT_Encode4(156440),
     /*  156432 */ /*GILLT_s32*//*Label 2831*/ GIMT_Encode4(156498),
     /*  156436 */ /*GILLT_s64*//*Label 2832*/ GIMT_Encode4(156556),
     /*  156440 */ // Label 2830: @156440
     /*  156440 */ GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(156497),
     /*  156445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156456 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(156476), // Rule ID 2436 //
     /*  156461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  156464 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /*  156464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156474 */     GIR_RootConstrainSelectedInstOperands,
     /*  156475 */     // GIR_Coverage, 2436,
     /*  156475 */     GIR_EraseRootFromParent_Done,
     /*  156476 */   // Label 2835: @156476
     /*  156476 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(156496), // Rule ID 2437 //
     /*  156481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  156484 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /*  156484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156494 */     GIR_RootConstrainSelectedInstOperands,
     /*  156495 */     // GIR_Coverage, 2437,
     /*  156495 */     GIR_EraseRootFromParent_Done,
     /*  156496 */   // Label 2836: @156496
     /*  156496 */   GIM_Reject,
     /*  156497 */ // Label 2834: @156497
     /*  156497 */ GIM_Reject,
     /*  156498 */ // Label 2831: @156498
     /*  156498 */ GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(156555),
     /*  156503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156514 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(156534), // Rule ID 2354 //
     /*  156519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  156522 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /*  156522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156532 */     GIR_RootConstrainSelectedInstOperands,
     /*  156533 */     // GIR_Coverage, 2354,
     /*  156533 */     GIR_EraseRootFromParent_Done,
     /*  156534 */   // Label 2838: @156534
     /*  156534 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(156554), // Rule ID 2355 //
     /*  156539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  156542 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /*  156542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156552 */     GIR_RootConstrainSelectedInstOperands,
     /*  156553 */     // GIR_Coverage, 2355,
     /*  156553 */     GIR_EraseRootFromParent_Done,
     /*  156554 */   // Label 2839: @156554
     /*  156554 */   GIM_Reject,
     /*  156555 */ // Label 2837: @156555
     /*  156555 */ GIM_Reject,
     /*  156556 */ // Label 2832: @156556
     /*  156556 */ GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(156613),
     /*  156561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156572 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(156592), // Rule ID 2394 //
     /*  156577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  156580 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /*  156580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156590 */     GIR_RootConstrainSelectedInstOperands,
     /*  156591 */     // GIR_Coverage, 2394,
     /*  156591 */     GIR_EraseRootFromParent_Done,
     /*  156592 */   // Label 2841: @156592
     /*  156592 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(156612), // Rule ID 2395 //
     /*  156597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  156600 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /*  156600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156610 */     GIR_RootConstrainSelectedInstOperands,
     /*  156611 */     // GIR_Coverage, 2395,
     /*  156611 */     GIR_EraseRootFromParent_Done,
     /*  156612 */   // Label 2842: @156612
     /*  156612 */   GIM_Reject,
     /*  156613 */ // Label 2840: @156613
     /*  156613 */ GIM_Reject,
     /*  156614 */ // Label 2833: @156614
     /*  156614 */ GIM_Reject,
     /*  156615 */ // Label 15: @156615
     /*  156615 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2846*/ GIMT_Encode4(156812),
     /*  156626 */ /*GILLT_s16*//*Label 2843*/ GIMT_Encode4(156638),
     /*  156630 */ /*GILLT_s32*//*Label 2844*/ GIMT_Encode4(156696),
     /*  156634 */ /*GILLT_s64*//*Label 2845*/ GIMT_Encode4(156754),
     /*  156638 */ // Label 2843: @156638
     /*  156638 */ GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(156695),
     /*  156643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156654 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(156674), // Rule ID 2420 //
     /*  156659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  156662 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /*  156662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156672 */     GIR_RootConstrainSelectedInstOperands,
     /*  156673 */     // GIR_Coverage, 2420,
     /*  156673 */     GIR_EraseRootFromParent_Done,
     /*  156674 */   // Label 2848: @156674
     /*  156674 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(156694), // Rule ID 2421 //
     /*  156679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  156682 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /*  156682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156692 */     GIR_RootConstrainSelectedInstOperands,
     /*  156693 */     // GIR_Coverage, 2421,
     /*  156693 */     GIR_EraseRootFromParent_Done,
     /*  156694 */   // Label 2849: @156694
     /*  156694 */   GIM_Reject,
     /*  156695 */ // Label 2847: @156695
     /*  156695 */ GIM_Reject,
     /*  156696 */ // Label 2844: @156696
     /*  156696 */ GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(156753),
     /*  156701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156712 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(156732), // Rule ID 2338 //
     /*  156717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  156720 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /*  156720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156730 */     GIR_RootConstrainSelectedInstOperands,
     /*  156731 */     // GIR_Coverage, 2338,
     /*  156731 */     GIR_EraseRootFromParent_Done,
     /*  156732 */   // Label 2851: @156732
     /*  156732 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(156752), // Rule ID 2339 //
     /*  156737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  156740 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /*  156740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156750 */     GIR_RootConstrainSelectedInstOperands,
     /*  156751 */     // GIR_Coverage, 2339,
     /*  156751 */     GIR_EraseRootFromParent_Done,
     /*  156752 */   // Label 2852: @156752
     /*  156752 */   GIM_Reject,
     /*  156753 */ // Label 2850: @156753
     /*  156753 */ GIM_Reject,
     /*  156754 */ // Label 2845: @156754
     /*  156754 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(156811),
     /*  156759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156770 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(156790), // Rule ID 2378 //
     /*  156775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  156778 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /*  156778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156788 */     GIR_RootConstrainSelectedInstOperands,
     /*  156789 */     // GIR_Coverage, 2378,
     /*  156789 */     GIR_EraseRootFromParent_Done,
     /*  156790 */   // Label 2854: @156790
     /*  156790 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(156810), // Rule ID 2379 //
     /*  156795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  156798 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /*  156798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156808 */     GIR_RootConstrainSelectedInstOperands,
     /*  156809 */     // GIR_Coverage, 2379,
     /*  156809 */     GIR_EraseRootFromParent_Done,
     /*  156810 */   // Label 2855: @156810
     /*  156810 */   GIM_Reject,
     /*  156811 */ // Label 2853: @156811
     /*  156811 */ GIM_Reject,
     /*  156812 */ // Label 2846: @156812
     /*  156812 */ GIM_Reject,
     /*  156813 */ // Label 16: @156813
     /*  156813 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2858*/ GIMT_Encode4(157392),
     /*  156824 */ /*GILLT_s32*//*Label 2856*/ GIMT_Encode4(156832),
     /*  156828 */ /*GILLT_s64*//*Label 2857*/ GIMT_Encode4(157205),
     /*  156832 */ // Label 2856: @156832
     /*  156832 */ GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(156863), // Rule ID 1466 //
     /*  156837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  156840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156851 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  156851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  156854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156856 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156861 */   GIR_RootConstrainSelectedInstOperands,
     /*  156862 */   // GIR_Coverage, 1466,
     /*  156862 */   GIR_EraseRootFromParent_Done,
     /*  156863 */ // Label 2859: @156863
     /*  156863 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(156894), // Rule ID 1467 //
     /*  156868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  156871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156882 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  156882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  156885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156887 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156892 */   GIR_RootConstrainSelectedInstOperands,
     /*  156893 */   // GIR_Coverage, 1467,
     /*  156893 */   GIR_EraseRootFromParent_Done,
     /*  156894 */ // Label 2860: @156894
     /*  156894 */ GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(156925), // Rule ID 1492 //
     /*  156899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  156902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156913 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  156913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  156916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156918 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156923 */   GIR_RootConstrainSelectedInstOperands,
     /*  156924 */   // GIR_Coverage, 1492,
     /*  156924 */   GIR_EraseRootFromParent_Done,
     /*  156925 */ // Label 2861: @156925
     /*  156925 */ GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(156956), // Rule ID 1493 //
     /*  156930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  156933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156944 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  156944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  156947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156949 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156954 */   GIR_RootConstrainSelectedInstOperands,
     /*  156955 */   // GIR_Coverage, 1493,
     /*  156955 */   GIR_EraseRootFromParent_Done,
     /*  156956 */ // Label 2862: @156956
     /*  156956 */ GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(156987), // Rule ID 1860 //
     /*  156961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /*  156964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156975 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  156975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  156978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156980 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156985 */   GIR_RootConstrainSelectedInstOperands,
     /*  156986 */   // GIR_Coverage, 1860,
     /*  156986 */   GIR_EraseRootFromParent_Done,
     /*  156987 */ // Label 2863: @156987
     /*  156987 */ GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(157018), // Rule ID 1861 //
     /*  156992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /*  156995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157006 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  157006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  157009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157011 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157016 */   GIR_RootConstrainSelectedInstOperands,
     /*  157017 */   // GIR_Coverage, 1861,
     /*  157017 */   GIR_EraseRootFromParent_Done,
     /*  157018 */ // Label 2864: @157018
     /*  157018 */ GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(157049), // Rule ID 1886 //
     /*  157023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /*  157026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  157037 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  157040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157042 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157047 */   GIR_RootConstrainSelectedInstOperands,
     /*  157048 */   // GIR_Coverage, 1886,
     /*  157048 */   GIR_EraseRootFromParent_Done,
     /*  157049 */ // Label 2865: @157049
     /*  157049 */ GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(157080), // Rule ID 1887 //
     /*  157054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /*  157057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  157068 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  157068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  157071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157073 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157078 */   GIR_RootConstrainSelectedInstOperands,
     /*  157079 */   // GIR_Coverage, 1887,
     /*  157079 */   GIR_EraseRootFromParent_Done,
     /*  157080 */ // Label 2866: @157080
     /*  157080 */ GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(157111), // Rule ID 2202 //
     /*  157085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /*  157088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157099 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  157102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157104 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157109 */   GIR_RootConstrainSelectedInstOperands,
     /*  157110 */   // GIR_Coverage, 2202,
     /*  157110 */   GIR_EraseRootFromParent_Done,
     /*  157111 */ // Label 2867: @157111
     /*  157111 */ GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(157142), // Rule ID 2203 //
     /*  157116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /*  157119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157130 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  157130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  157133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157135 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157140 */   GIR_RootConstrainSelectedInstOperands,
     /*  157141 */   // GIR_Coverage, 2203,
     /*  157141 */   GIR_EraseRootFromParent_Done,
     /*  157142 */ // Label 2868: @157142
     /*  157142 */ GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(157173), // Rule ID 2228 //
     /*  157147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /*  157150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157161 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  157164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157166 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157171 */   GIR_RootConstrainSelectedInstOperands,
     /*  157172 */   // GIR_Coverage, 2228,
     /*  157172 */   GIR_EraseRootFromParent_Done,
     /*  157173 */ // Label 2869: @157173
     /*  157173 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(157204), // Rule ID 2229 //
     /*  157178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /*  157181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157192 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  157192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  157195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157197 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157202 */   GIR_RootConstrainSelectedInstOperands,
     /*  157203 */   // GIR_Coverage, 2229,
     /*  157203 */   GIR_EraseRootFromParent_Done,
     /*  157204 */ // Label 2870: @157204
     /*  157204 */ GIM_Reject,
     /*  157205 */ // Label 2857: @157205
     /*  157205 */ GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(157236), // Rule ID 1519 //
     /*  157210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  157213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157224 */   // (lrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  157227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157229 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157234 */   GIR_RootConstrainSelectedInstOperands,
     /*  157235 */   // GIR_Coverage, 1519,
     /*  157235 */   GIR_EraseRootFromParent_Done,
     /*  157236 */ // Label 2871: @157236
     /*  157236 */ GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(157267), // Rule ID 1547 //
     /*  157241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  157244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157255 */   // (lrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  157258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157260 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157265 */   GIR_RootConstrainSelectedInstOperands,
     /*  157266 */   // GIR_Coverage, 1547,
     /*  157266 */   GIR_EraseRootFromParent_Done,
     /*  157267 */ // Label 2872: @157267
     /*  157267 */ GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(157298), // Rule ID 1917 //
     /*  157272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  157275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157286 */   // (lrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  157289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157291 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157296 */   GIR_RootConstrainSelectedInstOperands,
     /*  157297 */   // GIR_Coverage, 1917,
     /*  157297 */   GIR_EraseRootFromParent_Done,
     /*  157298 */ // Label 2873: @157298
     /*  157298 */ GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(157329), // Rule ID 1945 //
     /*  157303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  157306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157317 */   // (lrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  157320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157322 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157327 */   GIR_RootConstrainSelectedInstOperands,
     /*  157328 */   // GIR_Coverage, 1945,
     /*  157328 */   GIR_EraseRootFromParent_Done,
     /*  157329 */ // Label 2874: @157329
     /*  157329 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(157360), // Rule ID 2253 //
     /*  157334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  157337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157348 */   // (lrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  157351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157353 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157358 */   GIR_RootConstrainSelectedInstOperands,
     /*  157359 */   // GIR_Coverage, 2253,
     /*  157359 */   GIR_EraseRootFromParent_Done,
     /*  157360 */ // Label 2875: @157360
     /*  157360 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(157391), // Rule ID 2279 //
     /*  157365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  157368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157379 */   // (lrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  157382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157384 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157389 */   GIR_RootConstrainSelectedInstOperands,
     /*  157390 */   // GIR_Coverage, 2279,
     /*  157390 */   GIR_EraseRootFromParent_Done,
     /*  157391 */ // Label 2876: @157391
     /*  157391 */ GIM_Reject,
     /*  157392 */ // Label 2858: @157392
     /*  157392 */ GIM_Reject,
     /*  157393 */ // Label 17: @157393
     /*  157393 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(157602),
     /*  157398 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  157401 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2881*/ GIMT_Encode4(157601),
     /*  157412 */   /*GILLT_s16*//*Label 2878*/ GIMT_Encode4(157424),
     /*  157416 */   /*GILLT_s32*//*Label 2879*/ GIMT_Encode4(157483),
     /*  157420 */   /*GILLT_s64*//*Label 2880*/ GIMT_Encode4(157542),
     /*  157424 */   // Label 2878: @157424
     /*  157424 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(157482),
     /*  157429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157433 */     GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(157457), // Rule ID 2255 //
     /*  157438 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  157441 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157445 */       // (llrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157445 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  157448 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157450 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157452 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157455 */       GIR_RootConstrainSelectedInstOperands,
     /*  157456 */       // GIR_Coverage, 2255,
     /*  157456 */       GIR_EraseRootFromParent_Done,
     /*  157457 */     // Label 2883: @157457
     /*  157457 */     GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(157481), // Rule ID 2281 //
     /*  157462 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  157465 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157469 */       // (llrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157469 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  157472 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157474 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157476 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157479 */       GIR_RootConstrainSelectedInstOperands,
     /*  157480 */       // GIR_Coverage, 2281,
     /*  157480 */       GIR_EraseRootFromParent_Done,
     /*  157481 */     // Label 2884: @157481
     /*  157481 */     GIM_Reject,
     /*  157482 */   // Label 2882: @157482
     /*  157482 */   GIM_Reject,
     /*  157483 */   // Label 2879: @157483
     /*  157483 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(157541),
     /*  157488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157492 */     GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(157516), // Rule ID 1521 //
     /*  157497 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  157500 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157504 */       // (llrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157504 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  157507 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157509 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157511 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157514 */       GIR_RootConstrainSelectedInstOperands,
     /*  157515 */       // GIR_Coverage, 1521,
     /*  157515 */       GIR_EraseRootFromParent_Done,
     /*  157516 */     // Label 2886: @157516
     /*  157516 */     GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(157540), // Rule ID 1549 //
     /*  157521 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  157524 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157528 */       // (llrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157528 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  157531 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157533 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157535 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157538 */       GIR_RootConstrainSelectedInstOperands,
     /*  157539 */       // GIR_Coverage, 1549,
     /*  157539 */       GIR_EraseRootFromParent_Done,
     /*  157540 */     // Label 2887: @157540
     /*  157540 */     GIM_Reject,
     /*  157541 */   // Label 2885: @157541
     /*  157541 */   GIM_Reject,
     /*  157542 */   // Label 2880: @157542
     /*  157542 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(157600),
     /*  157547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157551 */     GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(157575), // Rule ID 1919 //
     /*  157556 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  157559 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157563 */       // (llrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157563 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  157566 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157568 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157570 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157573 */       GIR_RootConstrainSelectedInstOperands,
     /*  157574 */       // GIR_Coverage, 1919,
     /*  157574 */       GIR_EraseRootFromParent_Done,
     /*  157575 */     // Label 2889: @157575
     /*  157575 */     GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(157599), // Rule ID 1947 //
     /*  157580 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  157583 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157587 */       // (llrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157587 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  157590 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157592 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157594 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157597 */       GIR_RootConstrainSelectedInstOperands,
     /*  157598 */       // GIR_Coverage, 1947,
     /*  157598 */       GIR_EraseRootFromParent_Done,
     /*  157599 */     // Label 2890: @157599
     /*  157599 */     GIM_Reject,
     /*  157600 */   // Label 2888: @157600
     /*  157600 */   GIM_Reject,
     /*  157601 */   // Label 2881: @157601
     /*  157601 */   GIM_Reject,
     /*  157602 */ // Label 2877: @157602
     /*  157602 */ GIM_Reject,
     /*  157603 */ // Label 18: @157603
     /*  157603 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2894*/ GIMT_Encode4(157800),
     /*  157614 */ /*GILLT_s16*//*Label 2891*/ GIMT_Encode4(157626),
     /*  157618 */ /*GILLT_s32*//*Label 2892*/ GIMT_Encode4(157684),
     /*  157622 */ /*GILLT_s64*//*Label 2893*/ GIMT_Encode4(157742),
     /*  157626 */ // Label 2891: @157626
     /*  157626 */ GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(157683),
     /*  157631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157642 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(157662), // Rule ID 2424 //
     /*  157647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  157650 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /*  157650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  157653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157660 */     GIR_RootConstrainSelectedInstOperands,
     /*  157661 */     // GIR_Coverage, 2424,
     /*  157661 */     GIR_EraseRootFromParent_Done,
     /*  157662 */   // Label 2896: @157662
     /*  157662 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(157682), // Rule ID 2425 //
     /*  157667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  157670 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /*  157670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  157673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157680 */     GIR_RootConstrainSelectedInstOperands,
     /*  157681 */     // GIR_Coverage, 2425,
     /*  157681 */     GIR_EraseRootFromParent_Done,
     /*  157682 */   // Label 2897: @157682
     /*  157682 */   GIM_Reject,
     /*  157683 */ // Label 2895: @157683
     /*  157683 */ GIM_Reject,
     /*  157684 */ // Label 2892: @157684
     /*  157684 */ GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(157741),
     /*  157689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157700 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(157720), // Rule ID 2342 //
     /*  157705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  157708 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /*  157708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  157711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157718 */     GIR_RootConstrainSelectedInstOperands,
     /*  157719 */     // GIR_Coverage, 2342,
     /*  157719 */     GIR_EraseRootFromParent_Done,
     /*  157720 */   // Label 2899: @157720
     /*  157720 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(157740), // Rule ID 2343 //
     /*  157725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  157728 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /*  157728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  157731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157738 */     GIR_RootConstrainSelectedInstOperands,
     /*  157739 */     // GIR_Coverage, 2343,
     /*  157739 */     GIR_EraseRootFromParent_Done,
     /*  157740 */   // Label 2900: @157740
     /*  157740 */   GIM_Reject,
     /*  157741 */ // Label 2898: @157741
     /*  157741 */ GIM_Reject,
     /*  157742 */ // Label 2893: @157742
     /*  157742 */ GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(157799),
     /*  157747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157758 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(157778), // Rule ID 2382 //
     /*  157763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  157766 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i64] })
     /*  157766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157776 */     GIR_RootConstrainSelectedInstOperands,
     /*  157777 */     // GIR_Coverage, 2382,
     /*  157777 */     GIR_EraseRootFromParent_Done,
     /*  157778 */   // Label 2902: @157778
     /*  157778 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(157798), // Rule ID 2383 //
     /*  157783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  157786 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i32] })
     /*  157786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157796 */     GIR_RootConstrainSelectedInstOperands,
     /*  157797 */     // GIR_Coverage, 2383,
     /*  157797 */     GIR_EraseRootFromParent_Done,
     /*  157798 */   // Label 2903: @157798
     /*  157798 */   GIM_Reject,
     /*  157799 */ // Label 2901: @157799
     /*  157799 */ GIM_Reject,
     /*  157800 */ // Label 2894: @157800
     /*  157800 */ GIM_Reject,
     /*  157801 */ // Label 19: @157801
     /*  157801 */ GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(157839), // Rule ID 291 //
     /*  157806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  157809 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  157812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157816 */   // (readcyclecounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3072:{ *:[i64] }, X0:{ *:[i64] })
     /*  157816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  157819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157821 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3072),
     /*  157831 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  157837 */   GIR_RootConstrainSelectedInstOperands,
     /*  157838 */   // GIR_Coverage, 291,
     /*  157838 */   GIR_EraseRootFromParent_Done,
     /*  157839 */ // Label 2904: @157839
     /*  157839 */ GIM_Reject,
     /*  157840 */ // Label 20: @157840
     /*  157840 */ GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(157878), // Rule ID 292 //
     /*  157845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  157848 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  157851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157855 */   // (readsteadycounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3073:{ *:[i64] }, X0:{ *:[i64] })
     /*  157855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  157858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157860 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3073),
     /*  157870 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  157876 */   GIR_RootConstrainSelectedInstOperands,
     /*  157877 */   // GIR_Coverage, 292,
     /*  157877 */   GIR_EraseRootFromParent_Done,
     /*  157878 */ // Label 2905: @157878
     /*  157878 */ GIM_Reject,
     /*  157879 */ // Label 21: @157879
     /*  157879 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 2940*/ GIMT_Encode4(166856),
     /*  157890 */ /*GILLT_p0s32*//*Label 2906*/ GIMT_Encode4(158026),
     /*  157894 */ /*GILLT_p0s64*//*Label 2907*/ GIMT_Encode4(158120),
     /*  157898 */ /*GILLT_s16*//*Label 2908*/ GIMT_Encode4(158214),
     /*  157902 */ /*GILLT_s32*//*Label 2909*/ GIMT_Encode4(158869),
     /*  157906 */ /*GILLT_s64*//*Label 2910*/ GIMT_Encode4(160324),
     /*  157910 */ /*GILLT_nxv1s1*//*Label 2911*/ GIMT_Encode4(161550),
     /*  157914 */ /*GILLT_nxv1s8*//*Label 2912*/ GIMT_Encode4(161670),
     /*  157918 */ /*GILLT_nxv1s16*//*Label 2913*/ GIMT_Encode4(161798),
     /*  157922 */ /*GILLT_nxv1s32*//*Label 2914*/ GIMT_Encode4(162036),
     /*  157926 */ /*GILLT_nxv1s64*//*Label 2915*/ GIMT_Encode4(162274),
     /*  157930 */ /*GILLT_nxv2s1*//*Label 2916*/ GIMT_Encode4(162512),
     /*  157934 */ /*GILLT_nxv2s8*//*Label 2917*/ GIMT_Encode4(162632),
     /*  157938 */ /*GILLT_nxv2s16*//*Label 2918*/ GIMT_Encode4(162760),
     /*  157942 */ /*GILLT_nxv2s32*//*Label 2919*/ GIMT_Encode4(162998),
     /*  157946 */ /*GILLT_nxv2s64*//*Label 2920*/ GIMT_Encode4(163236),
     /*  157950 */ /*GILLT_nxv4s1*//*Label 2921*/ GIMT_Encode4(163474),
     /*  157954 */ /*GILLT_nxv4s8*//*Label 2922*/ GIMT_Encode4(163594),
     /*  157958 */ /*GILLT_nxv4s16*//*Label 2923*/ GIMT_Encode4(163722),
     /*  157962 */ /*GILLT_nxv4s32*//*Label 2924*/ GIMT_Encode4(163960),
     /*  157966 */ /*GILLT_nxv4s64*//*Label 2925*/ GIMT_Encode4(164198),
     /*  157970 */ /*GILLT_nxv8s1*//*Label 2926*/ GIMT_Encode4(164436),
     /*  157974 */ /*GILLT_nxv8s8*//*Label 2927*/ GIMT_Encode4(164556),
     /*  157978 */ /*GILLT_nxv8s16*//*Label 2928*/ GIMT_Encode4(164684),
     /*  157982 */ /*GILLT_nxv8s32*//*Label 2929*/ GIMT_Encode4(164922),
     /*  157986 */ /*GILLT_nxv8s64*//*Label 2930*/ GIMT_Encode4(165160),
     /*  157990 */ /*GILLT_nxv16s1*//*Label 2931*/ GIMT_Encode4(165398),
     /*  157994 */ /*GILLT_nxv16s8*//*Label 2932*/ GIMT_Encode4(165518),
     /*  157998 */ /*GILLT_nxv16s16*//*Label 2933*/ GIMT_Encode4(165646),
     /*  158002 */ /*GILLT_nxv16s32*//*Label 2934*/ GIMT_Encode4(165884),
     /*  158006 */ /*GILLT_nxv32s1*//*Label 2935*/ GIMT_Encode4(166122),
     /*  158010 */ /*GILLT_nxv32s8*//*Label 2936*/ GIMT_Encode4(166242),
     /*  158014 */ /*GILLT_nxv32s16*//*Label 2937*/ GIMT_Encode4(166370),
     /*  158018 */ /*GILLT_nxv64s1*//*Label 2938*/ GIMT_Encode4(166608),
     /*  158022 */ /*GILLT_nxv64s8*//*Label 2939*/ GIMT_Encode4(166728),
     /*  158026 */ // Label 2906: @158026
     /*  158026 */ GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(158119),
     /*  158031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158034 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158046 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(158082), // Rule ID 65366 //
     /*  158051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  158054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158061 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  158064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158080 */     GIR_RootConstrainSelectedInstOperands,
     /*  158081 */     // GIR_Coverage, 65366,
     /*  158081 */     GIR_EraseRootFromParent_Done,
     /*  158082 */   // Label 2942: @158082
     /*  158082 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(158118), // Rule ID 65370 //
     /*  158087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  158090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158097 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  158100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158116 */     GIR_RootConstrainSelectedInstOperands,
     /*  158117 */     // GIR_Coverage, 65370,
     /*  158117 */     GIR_EraseRootFromParent_Done,
     /*  158118 */   // Label 2943: @158118
     /*  158118 */   GIM_Reject,
     /*  158119 */ // Label 2941: @158119
     /*  158119 */ GIM_Reject,
     /*  158120 */ // Label 2907: @158120
     /*  158120 */ GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(158213),
     /*  158125 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158128 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158136 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158140 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(158176), // Rule ID 65365 //
     /*  158145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  158148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158155 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  158158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158174 */     GIR_RootConstrainSelectedInstOperands,
     /*  158175 */     // GIR_Coverage, 65365,
     /*  158175 */     GIR_EraseRootFromParent_Done,
     /*  158176 */   // Label 2945: @158176
     /*  158176 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(158212), // Rule ID 65369 //
     /*  158181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  158184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158191 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  158194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158210 */     GIR_RootConstrainSelectedInstOperands,
     /*  158211 */     // GIR_Coverage, 65369,
     /*  158211 */     GIR_EraseRootFromParent_Done,
     /*  158212 */   // Label 2946: @158212
     /*  158212 */   GIM_Reject,
     /*  158213 */ // Label 2944: @158213
     /*  158213 */ GIM_Reject,
     /*  158214 */ // Label 2908: @158214
     /*  158214 */ GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(158265), // Rule ID 2150 //
     /*  158219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  158222 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158225 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  158233 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158237 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158244 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  158247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158259 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158263 */   GIR_RootConstrainSelectedInstOperands,
     /*  158264 */   // GIR_Coverage, 2150,
     /*  158264 */   GIR_EraseRootFromParent_Done,
     /*  158265 */ // Label 2947: @158265
     /*  158265 */ GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(158316), // Rule ID 2151 //
     /*  158270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  158273 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158276 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  158284 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158288 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158295 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  158298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158310 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158314 */   GIR_RootConstrainSelectedInstOperands,
     /*  158315 */   // GIR_Coverage, 2151,
     /*  158315 */   GIR_EraseRootFromParent_Done,
     /*  158316 */ // Label 2948: @158316
     /*  158316 */ GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(158367), // Rule ID 2156 //
     /*  158321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  158324 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158327 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  158335 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158339 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158346 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  158349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158356 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158361 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158365 */   GIR_RootConstrainSelectedInstOperands,
     /*  158366 */   // GIR_Coverage, 2156,
     /*  158366 */   GIR_EraseRootFromParent_Done,
     /*  158367 */ // Label 2949: @158367
     /*  158367 */ GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(158418), // Rule ID 2157 //
     /*  158372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  158375 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158378 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  158386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158390 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158397 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  158400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158412 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158416 */   GIR_RootConstrainSelectedInstOperands,
     /*  158417 */   // GIR_Coverage, 2157,
     /*  158417 */   GIR_EraseRootFromParent_Done,
     /*  158418 */ // Label 2950: @158418
     /*  158418 */ GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(158469), // Rule ID 65373 //
     /*  158423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  158426 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158429 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158448 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158463 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158467 */   GIR_RootConstrainSelectedInstOperands,
     /*  158468 */   // GIR_Coverage, 65373,
     /*  158468 */   GIR_EraseRootFromParent_Done,
     /*  158469 */ // Label 2951: @158469
     /*  158469 */ GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(158520), // Rule ID 65374 //
     /*  158474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  158477 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158480 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158488 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158492 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158499 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158514 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158518 */   GIR_RootConstrainSelectedInstOperands,
     /*  158519 */   // GIR_Coverage, 65374,
     /*  158519 */   GIR_EraseRootFromParent_Done,
     /*  158520 */ // Label 2952: @158520
     /*  158520 */ GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(158578), // Rule ID 65377 //
     /*  158525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  158528 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158531 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158535 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158550 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158557 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  158560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158576 */   GIR_RootConstrainSelectedInstOperands,
     /*  158577 */   // GIR_Coverage, 65377,
     /*  158577 */   GIR_EraseRootFromParent_Done,
     /*  158578 */ // Label 2953: @158578
     /*  158578 */ GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(158636), // Rule ID 65378 //
     /*  158583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  158586 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158589 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158593 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158604 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158608 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158615 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  158618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158634 */   GIR_RootConstrainSelectedInstOperands,
     /*  158635 */   // GIR_Coverage, 65378,
     /*  158635 */   GIR_EraseRootFromParent_Done,
     /*  158636 */ // Label 2954: @158636
     /*  158636 */ GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(158694), // Rule ID 65381 //
     /*  158641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  158644 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158647 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158651 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158662 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158666 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158673 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  158676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158683 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158688 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158692 */   GIR_RootConstrainSelectedInstOperands,
     /*  158693 */   // GIR_Coverage, 65381,
     /*  158693 */   GIR_EraseRootFromParent_Done,
     /*  158694 */ // Label 2955: @158694
     /*  158694 */ GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(158752), // Rule ID 65382 //
     /*  158699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  158702 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158705 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158709 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158720 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158724 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158731 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  158734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158741 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158746 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158750 */   GIR_RootConstrainSelectedInstOperands,
     /*  158751 */   // GIR_Coverage, 65382,
     /*  158751 */   GIR_EraseRootFromParent_Done,
     /*  158752 */ // Label 2956: @158752
     /*  158752 */ GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(158810), // Rule ID 65383 //
     /*  158757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  158760 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158763 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158767 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158778 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158782 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158789 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158804 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158808 */   GIR_RootConstrainSelectedInstOperands,
     /*  158809 */   // GIR_Coverage, 65383,
     /*  158809 */   GIR_EraseRootFromParent_Done,
     /*  158810 */ // Label 2957: @158810
     /*  158810 */ GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(158868), // Rule ID 65384 //
     /*  158815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  158818 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158821 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158825 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158836 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158840 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158847 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158862 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158866 */   GIR_RootConstrainSelectedInstOperands,
     /*  158867 */   // GIR_Coverage, 65384,
     /*  158867 */   GIR_EraseRootFromParent_Done,
     /*  158868 */ // Label 2958: @158868
     /*  158868 */ GIM_Reject,
     /*  158869 */ // Label 2909: @158869
     /*  158869 */ GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(158927), // Rule ID 237 //
     /*  158874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  158877 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158880 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158884 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158895 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158899 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158906 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  158909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158925 */   GIR_RootConstrainSelectedInstOperands,
     /*  158926 */   // GIR_Coverage, 237,
     /*  158926 */   GIR_EraseRootFromParent_Done,
     /*  158927 */ // Label 2959: @158927
     /*  158927 */ GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(158985), // Rule ID 241 //
     /*  158932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  158935 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158938 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158942 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158957 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158964 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158983 */   GIR_RootConstrainSelectedInstOperands,
     /*  158984 */   // GIR_Coverage, 241,
     /*  158984 */   GIR_EraseRootFromParent_Done,
     /*  158985 */ // Label 2960: @158985
     /*  158985 */ GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(159036), // Rule ID 242 //
     /*  158990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  158993 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158996 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159015 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159030 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159034 */   GIR_RootConstrainSelectedInstOperands,
     /*  159035 */   // GIR_Coverage, 242,
     /*  159035 */   GIR_EraseRootFromParent_Done,
     /*  159036 */ // Label 2961: @159036
     /*  159036 */ GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(159087), // Rule ID 243 //
     /*  159041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159044 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159047 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159055 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159059 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159066 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159076 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159081 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159085 */   GIR_RootConstrainSelectedInstOperands,
     /*  159086 */   // GIR_Coverage, 243,
     /*  159086 */   GIR_EraseRootFromParent_Done,
     /*  159087 */ // Label 2962: @159087
     /*  159087 */ GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(159148), // Rule ID 326 //
     /*  159092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159095 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159098 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159102 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159109 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159116 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159120 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159127 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10091>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  159130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159142 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159146 */   GIR_RootConstrainSelectedInstOperands,
     /*  159147 */   // GIR_Coverage, 326,
     /*  159147 */   GIR_EraseRootFromParent_Done,
     /*  159148 */ // Label 2963: @159148
     /*  159148 */ GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(159209), // Rule ID 330 //
     /*  159153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159156 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159159 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159163 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159170 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159177 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159181 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159188 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10093>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159207 */   GIR_RootConstrainSelectedInstOperands,
     /*  159208 */   // GIR_Coverage, 330,
     /*  159208 */   GIR_EraseRootFromParent_Done,
     /*  159209 */ // Label 2964: @159209
     /*  159209 */ GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(159270), // Rule ID 344 //
     /*  159214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode1),
     /*  159217 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159220 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159224 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  159231 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159238 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159242 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159249 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10105>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159264 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159268 */   GIR_RootConstrainSelectedInstOperands,
     /*  159269 */   // GIR_Coverage, 344,
     /*  159269 */   GIR_EraseRootFromParent_Done,
     /*  159270 */ // Label 2965: @159270
     /*  159270 */ GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(159331), // Rule ID 346 //
     /*  159275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  159278 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159281 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159285 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  159292 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159303 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159310 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10107>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159315 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159325 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159329 */   GIR_RootConstrainSelectedInstOperands,
     /*  159330 */   // GIR_Coverage, 346,
     /*  159330 */   GIR_EraseRootFromParent_Done,
     /*  159331 */ // Label 2966: @159331
     /*  159331 */ GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(159382), // Rule ID 1437 //
     /*  159336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  159339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159342 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  159350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159354 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159361 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  159364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159376 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159380 */   GIR_RootConstrainSelectedInstOperands,
     /*  159381 */   // GIR_Coverage, 1437,
     /*  159381 */   GIR_EraseRootFromParent_Done,
     /*  159382 */ // Label 2967: @159382
     /*  159382 */ GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(159433), // Rule ID 1438 //
     /*  159387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  159390 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159393 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  159401 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159405 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159412 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  159415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159427 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159431 */   GIR_RootConstrainSelectedInstOperands,
     /*  159432 */   // GIR_Coverage, 1438,
     /*  159432 */   GIR_EraseRootFromParent_Done,
     /*  159433 */ // Label 2968: @159433
     /*  159433 */ GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(159484), // Rule ID 1443 //
     /*  159438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  159441 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159444 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  159452 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159456 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159463 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  159466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159478 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159482 */   GIR_RootConstrainSelectedInstOperands,
     /*  159483 */   // GIR_Coverage, 1443,
     /*  159483 */   GIR_EraseRootFromParent_Done,
     /*  159484 */ // Label 2969: @159484
     /*  159484 */ GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(159535), // Rule ID 1444 //
     /*  159489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  159492 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159495 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  159503 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159507 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159514 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  159517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159529 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159533 */   GIR_RootConstrainSelectedInstOperands,
     /*  159534 */   // GIR_Coverage, 1444,
     /*  159534 */   GIR_EraseRootFromParent_Done,
     /*  159535 */ // Label 2970: @159535
     /*  159535 */ GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(159593), // Rule ID 65389 //
     /*  159540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  159543 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159546 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159550 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  159557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159561 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159565 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159572 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159582 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159587 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159591 */   GIR_RootConstrainSelectedInstOperands,
     /*  159592 */   // GIR_Coverage, 65389,
     /*  159592 */   GIR_EraseRootFromParent_Done,
     /*  159593 */ // Label 2971: @159593
     /*  159593 */ GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(159651), // Rule ID 65390 //
     /*  159598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  159601 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159604 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159608 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  159615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159619 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159623 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159630 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159645 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159649 */   GIR_RootConstrainSelectedInstOperands,
     /*  159650 */   // GIR_Coverage, 65390,
     /*  159650 */   GIR_EraseRootFromParent_Done,
     /*  159651 */ // Label 2972: @159651
     /*  159651 */ GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(159709), // Rule ID 65393 //
     /*  159656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  159659 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159662 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159666 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159681 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159688 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  159691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159703 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159707 */   GIR_RootConstrainSelectedInstOperands,
     /*  159708 */   // GIR_Coverage, 65393,
     /*  159708 */   GIR_EraseRootFromParent_Done,
     /*  159709 */ // Label 2973: @159709
     /*  159709 */ GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(159767), // Rule ID 65394 //
     /*  159714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  159717 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159720 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159724 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159746 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  159749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159761 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159765 */   GIR_RootConstrainSelectedInstOperands,
     /*  159766 */   // GIR_Coverage, 65394,
     /*  159766 */   GIR_EraseRootFromParent_Done,
     /*  159767 */ // Label 2974: @159767
     /*  159767 */ GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(159825), // Rule ID 65395 //
     /*  159772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  159775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159778 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159797 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159804 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159823 */   GIR_RootConstrainSelectedInstOperands,
     /*  159824 */   // GIR_Coverage, 65395,
     /*  159824 */   GIR_EraseRootFromParent_Done,
     /*  159825 */ // Label 2975: @159825
     /*  159825 */ GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(159883), // Rule ID 65396 //
     /*  159830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  159833 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159836 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159840 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159851 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159855 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159862 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159881 */   GIR_RootConstrainSelectedInstOperands,
     /*  159882 */   // GIR_Coverage, 65396,
     /*  159882 */   GIR_EraseRootFromParent_Done,
     /*  159883 */ // Label 2976: @159883
     /*  159883 */ GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(159927), // Rule ID 1102 //
     /*  159888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  159891 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159894 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159898 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159905 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159912 */   // MIs[0] rs1
     /*  159912 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159920 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10595>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  159920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  159925 */   GIR_RootConstrainSelectedInstOperands,
     /*  159926 */   // GIR_Coverage, 1102,
     /*  159926 */   GIR_Done,
     /*  159927 */ // Label 2977: @159927
     /*  159927 */ GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(159971), // Rule ID 1106 //
     /*  159932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  159935 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159938 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159942 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159949 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  159952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159956 */   // MIs[0] rs1
     /*  159956 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159964 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10597>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  159964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  159969 */   GIR_RootConstrainSelectedInstOperands,
     /*  159970 */   // GIR_Coverage, 1106,
     /*  159970 */   GIR_Done,
     /*  159971 */ // Label 2978: @159971
     /*  159971 */ GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(160015), // Rule ID 1110 //
     /*  159976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  159979 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159982 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159986 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159993 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160000 */   // MIs[0] rs1
     /*  160000 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160008 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10599>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  160013 */   GIR_RootConstrainSelectedInstOperands,
     /*  160014 */   // GIR_Coverage, 1110,
     /*  160014 */   GIR_Done,
     /*  160015 */ // Label 2979: @160015
     /*  160015 */ GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(160059), // Rule ID 1114 //
     /*  160020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160023 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160026 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160030 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160037 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160044 */   // MIs[0] rs1
     /*  160044 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160052 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10601>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160052 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  160057 */   GIR_RootConstrainSelectedInstOperands,
     /*  160058 */   // GIR_Coverage, 1114,
     /*  160058 */   GIR_Done,
     /*  160059 */ // Label 2980: @160059
     /*  160059 */ GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(160103), // Rule ID 1130 //
     /*  160064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  160067 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160070 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160074 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160081 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160088 */   // MIs[0] rs1
     /*  160088 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160096 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10615>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160101 */   GIR_RootConstrainSelectedInstOperands,
     /*  160102 */   // GIR_Coverage, 1130,
     /*  160102 */   GIR_Done,
     /*  160103 */ // Label 2981: @160103
     /*  160103 */ GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(160147), // Rule ID 1132 //
     /*  160108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  160111 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160114 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160118 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160125 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160132 */   // MIs[0] rs1
     /*  160132 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160140 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10617>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160145 */   GIR_RootConstrainSelectedInstOperands,
     /*  160146 */   // GIR_Coverage, 1132,
     /*  160146 */   GIR_Done,
     /*  160147 */ // Label 2982: @160147
     /*  160147 */ GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(160191), // Rule ID 1134 //
     /*  160152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160155 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160158 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160162 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160169 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160176 */   // MIs[0] rs1
     /*  160176 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160184 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10619>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160189 */   GIR_RootConstrainSelectedInstOperands,
     /*  160190 */   // GIR_Coverage, 1134,
     /*  160190 */   GIR_Done,
     /*  160191 */ // Label 2983: @160191
     /*  160191 */ GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(160235), // Rule ID 1138 //
     /*  160196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160199 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160202 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160206 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160213 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160220 */   // MIs[0] rs1
     /*  160220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160228 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10621>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160233 */   GIR_RootConstrainSelectedInstOperands,
     /*  160234 */   // GIR_Coverage, 1138,
     /*  160234 */   GIR_Done,
     /*  160235 */ // Label 2984: @160235
     /*  160235 */ GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(160279), // Rule ID 1142 //
     /*  160240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160243 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160246 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160250 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  160257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160264 */   // MIs[0] rs1
     /*  160264 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160272 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10623>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  160277 */   GIR_RootConstrainSelectedInstOperands,
     /*  160278 */   // GIR_Coverage, 1142,
     /*  160278 */   GIR_Done,
     /*  160279 */ // Label 2985: @160279
     /*  160279 */ GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(160323), // Rule ID 1144 //
     /*  160284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160287 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160290 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160294 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  160301 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160308 */   // MIs[0] rs1
     /*  160308 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160316 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10625>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  160321 */   GIR_RootConstrainSelectedInstOperands,
     /*  160322 */   // GIR_Coverage, 1144,
     /*  160322 */   GIR_Done,
     /*  160323 */ // Label 2986: @160323
     /*  160323 */ GIM_Reject,
     /*  160324 */ // Label 2910: @160324
     /*  160324 */ GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(160382), // Rule ID 236 //
     /*  160329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  160332 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160335 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160339 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160354 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160361 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  160364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160376 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160380 */   GIR_RootConstrainSelectedInstOperands,
     /*  160381 */   // GIR_Coverage, 236,
     /*  160381 */   GIR_EraseRootFromParent_Done,
     /*  160382 */ // Label 2987: @160382
     /*  160382 */ GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(160440), // Rule ID 240 //
     /*  160387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  160390 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160393 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160397 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160408 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160412 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160419 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160434 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160438 */   GIR_RootConstrainSelectedInstOperands,
     /*  160439 */   // GIR_Coverage, 240,
     /*  160439 */   GIR_EraseRootFromParent_Done,
     /*  160440 */ // Label 2988: @160440
     /*  160440 */ GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(160498), // Rule ID 286 //
     /*  160445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160448 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160451 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160466 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160470 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160477 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160496 */   GIR_RootConstrainSelectedInstOperands,
     /*  160497 */   // GIR_Coverage, 286,
     /*  160497 */   GIR_EraseRootFromParent_Done,
     /*  160498 */ // Label 2989: @160498
     /*  160498 */ GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(160549), // Rule ID 288 //
     /*  160503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160509 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160517 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160521 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160528 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  160531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160533 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160543 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160547 */   GIR_RootConstrainSelectedInstOperands,
     /*  160548 */   // GIR_Coverage, 288,
     /*  160548 */   GIR_EraseRootFromParent_Done,
     /*  160549 */ // Label 2990: @160549
     /*  160549 */ GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(160610), // Rule ID 325 //
     /*  160554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  160557 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160560 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160564 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160571 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160578 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160582 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160589 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10091>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  160592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160604 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160608 */   GIR_RootConstrainSelectedInstOperands,
     /*  160609 */   // GIR_Coverage, 325,
     /*  160609 */   GIR_EraseRootFromParent_Done,
     /*  160610 */ // Label 2991: @160610
     /*  160610 */ GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(160671), // Rule ID 329 //
     /*  160615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  160618 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160621 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160625 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160632 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160639 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160643 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160650 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10093>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160665 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160669 */   GIR_RootConstrainSelectedInstOperands,
     /*  160670 */   // GIR_Coverage, 329,
     /*  160670 */   GIR_EraseRootFromParent_Done,
     /*  160671 */ // Label 2992: @160671
     /*  160671 */ GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(160732), // Rule ID 343 //
     /*  160676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode0),
     /*  160679 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160682 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160686 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160693 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160700 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160704 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160711 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10105>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160726 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160730 */   GIR_RootConstrainSelectedInstOperands,
     /*  160731 */   // GIR_Coverage, 343,
     /*  160731 */   GIR_EraseRootFromParent_Done,
     /*  160732 */ // Label 2993: @160732
     /*  160732 */ GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(160793), // Rule ID 345 //
     /*  160737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  160740 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160743 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160747 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160754 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160761 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160765 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160772 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10107>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160787 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160791 */   GIR_RootConstrainSelectedInstOperands,
     /*  160792 */   // GIR_Coverage, 345,
     /*  160792 */   GIR_EraseRootFromParent_Done,
     /*  160793 */ // Label 2994: @160793
     /*  160793 */ GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(160854), // Rule ID 351 //
     /*  160798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  160801 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160804 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160808 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  160815 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160822 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160826 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160833 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10111>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  160836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160852 */   GIR_RootConstrainSelectedInstOperands,
     /*  160853 */   // GIR_Coverage, 351,
     /*  160853 */   GIR_EraseRootFromParent_Done,
     /*  160854 */ // Label 2995: @160854
     /*  160854 */ GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(160905), // Rule ID 1835 //
     /*  160859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  160862 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160865 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  160873 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160877 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160884 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  160887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160899 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160903 */   GIR_RootConstrainSelectedInstOperands,
     /*  160904 */   // GIR_Coverage, 1835,
     /*  160904 */   GIR_EraseRootFromParent_Done,
     /*  160905 */ // Label 2996: @160905
     /*  160905 */ GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(160956), // Rule ID 1836 //
     /*  160910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  160913 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160916 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  160924 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160928 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160935 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  160938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160950 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160954 */   GIR_RootConstrainSelectedInstOperands,
     /*  160955 */   // GIR_Coverage, 1836,
     /*  160955 */   GIR_EraseRootFromParent_Done,
     /*  160956 */ // Label 2997: @160956
     /*  160956 */ GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(161007), // Rule ID 1840 //
     /*  160961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  160964 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160967 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160975 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160979 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160986 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  160989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161001 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161005 */   GIR_RootConstrainSelectedInstOperands,
     /*  161006 */   // GIR_Coverage, 1840,
     /*  161006 */   GIR_EraseRootFromParent_Done,
     /*  161007 */ // Label 2998: @161007
     /*  161007 */ GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(161058), // Rule ID 1844 //
     /*  161012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0),
     /*  161015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  161026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161030 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161037 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_RV32:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD_RV32),
     /*  161040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161052 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161056 */   GIR_RootConstrainSelectedInstOperands,
     /*  161057 */   // GIR_Coverage, 1844,
     /*  161057 */   GIR_EraseRootFromParent_Done,
     /*  161058 */ // Label 2999: @161058
     /*  161058 */ GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(161109), // Rule ID 1845 //
     /*  161063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1),
     /*  161066 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161069 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  161077 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161081 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161088 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_RV32:{ *:[f64] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  161088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD_RV32),
     /*  161091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161107 */   GIR_RootConstrainSelectedInstOperands,
     /*  161108 */   // GIR_Coverage, 1845,
     /*  161108 */   GIR_EraseRootFromParent_Done,
     /*  161109 */ // Label 3000: @161109
     /*  161109 */ GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(161153), // Rule ID 1101 //
     /*  161114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161117 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161120 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161124 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161131 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161138 */   // MIs[0] rs1
     /*  161138 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161146 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10595>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  161151 */   GIR_RootConstrainSelectedInstOperands,
     /*  161152 */   // GIR_Coverage, 1101,
     /*  161152 */   GIR_Done,
     /*  161153 */ // Label 3001: @161153
     /*  161153 */ GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(161197), // Rule ID 1105 //
     /*  161158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161161 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161164 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161168 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161175 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161182 */   // MIs[0] rs1
     /*  161182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161190 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10597>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  161195 */   GIR_RootConstrainSelectedInstOperands,
     /*  161196 */   // GIR_Coverage, 1105,
     /*  161196 */   GIR_Done,
     /*  161197 */ // Label 3002: @161197
     /*  161197 */ GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(161241), // Rule ID 1109 //
     /*  161202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161205 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161208 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161212 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161226 */   // MIs[0] rs1
     /*  161226 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161234 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10599>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  161239 */   GIR_RootConstrainSelectedInstOperands,
     /*  161240 */   // GIR_Coverage, 1109,
     /*  161240 */   GIR_Done,
     /*  161241 */ // Label 3003: @161241
     /*  161241 */ GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(161285), // Rule ID 1113 //
     /*  161246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161249 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161252 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161256 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161263 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161270 */   // MIs[0] rs1
     /*  161270 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161278 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10601>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  161283 */   GIR_RootConstrainSelectedInstOperands,
     /*  161284 */   // GIR_Coverage, 1113,
     /*  161284 */   GIR_Done,
     /*  161285 */ // Label 3004: @161285
     /*  161285 */ GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(161329), // Rule ID 1129 //
     /*  161290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  161293 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161296 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161300 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161307 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161314 */   // MIs[0] rs1
     /*  161314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161322 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10615>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161327 */   GIR_RootConstrainSelectedInstOperands,
     /*  161328 */   // GIR_Coverage, 1129,
     /*  161328 */   GIR_Done,
     /*  161329 */ // Label 3005: @161329
     /*  161329 */ GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(161373), // Rule ID 1131 //
     /*  161334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  161337 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161340 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161344 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161351 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161358 */   // MIs[0] rs1
     /*  161358 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161366 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10617>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161371 */   GIR_RootConstrainSelectedInstOperands,
     /*  161372 */   // GIR_Coverage, 1131,
     /*  161372 */   GIR_Done,
     /*  161373 */ // Label 3006: @161373
     /*  161373 */ GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(161417), // Rule ID 1133 //
     /*  161378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161381 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161384 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161388 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161395 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161402 */   // MIs[0] rs1
     /*  161402 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161410 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10619>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161415 */   GIR_RootConstrainSelectedInstOperands,
     /*  161416 */   // GIR_Coverage, 1133,
     /*  161416 */   GIR_Done,
     /*  161417 */ // Label 3007: @161417
     /*  161417 */ GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(161461), // Rule ID 1137 //
     /*  161422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161425 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161428 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161432 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161439 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161446 */   // MIs[0] rs1
     /*  161446 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161454 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10621>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161459 */   GIR_RootConstrainSelectedInstOperands,
     /*  161460 */   // GIR_Coverage, 1137,
     /*  161460 */   GIR_Done,
     /*  161461 */ // Label 3008: @161461
     /*  161461 */ GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(161505), // Rule ID 1141 //
     /*  161466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161469 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161476 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161483 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161490 */   // MIs[0] rs1
     /*  161490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161498 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10623>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  161503 */   GIR_RootConstrainSelectedInstOperands,
     /*  161504 */   // GIR_Coverage, 1141,
     /*  161504 */   GIR_Done,
     /*  161505 */ // Label 3009: @161505
     /*  161505 */ GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(161549), // Rule ID 1143 //
     /*  161510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161513 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161516 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161520 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161527 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161534 */   // MIs[0] rs1
     /*  161534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161542 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10625>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  161547 */   GIR_RootConstrainSelectedInstOperands,
     /*  161548 */   // GIR_Coverage, 1143,
     /*  161548 */   GIR_Done,
     /*  161549 */ // Label 3010: @161549
     /*  161549 */ GIM_Reject,
     /*  161550 */ // Label 2911: @161550
     /*  161550 */ GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(161669),
     /*  161555 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161558 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161566 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161574 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(161621), // Rule ID 45746 //
     /*  161579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161582 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  161582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  161585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  161599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  161612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161619 */     GIR_RootConstrainSelectedInstOperands,
     /*  161620 */     // GIR_Coverage, 45746,
     /*  161620 */     GIR_EraseRootFromParent_Done,
     /*  161621 */   // Label 3012: @161621
     /*  161621 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(161668), // Rule ID 45747 //
     /*  161626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161629 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  161629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  161632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  161646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  161659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161666 */     GIR_RootConstrainSelectedInstOperands,
     /*  161667 */     // GIR_Coverage, 45747,
     /*  161667 */     GIR_EraseRootFromParent_Done,
     /*  161668 */   // Label 3013: @161668
     /*  161668 */   GIM_Reject,
     /*  161669 */ // Label 3011: @161669
     /*  161669 */ GIM_Reject,
     /*  161670 */ // Label 2912: @161670
     /*  161670 */ GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(161797),
     /*  161675 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161678 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161686 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(161741), // Rule ID 45742 //
     /*  161691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161694 */     // MIs[0] rs1
     /*  161694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161702 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  161702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  161705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  161719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161739 */     GIR_RootConstrainSelectedInstOperands,
     /*  161740 */     // GIR_Coverage, 45742,
     /*  161740 */     GIR_EraseRootFromParent_Done,
     /*  161741 */   // Label 3015: @161741
     /*  161741 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(161796), // Rule ID 45743 //
     /*  161746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161749 */     // MIs[0] rs1
     /*  161749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161757 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  161757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  161760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  161774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161794 */     GIR_RootConstrainSelectedInstOperands,
     /*  161795 */     // GIR_Coverage, 45743,
     /*  161795 */     GIR_EraseRootFromParent_Done,
     /*  161796 */   // Label 3016: @161796
     /*  161796 */   GIM_Reject,
     /*  161797 */ // Label 3014: @161797
     /*  161797 */ GIM_Reject,
     /*  161798 */ // Label 2913: @161798
     /*  161798 */ GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(162035),
     /*  161803 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161806 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161814 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(161869), // Rule ID 45938 //
     /*  161819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161822 */     // MIs[0] rs1
     /*  161822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161830 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  161830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  161833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  161847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  161860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161867 */     GIR_RootConstrainSelectedInstOperands,
     /*  161868 */     // GIR_Coverage, 45938,
     /*  161868 */     GIR_EraseRootFromParent_Done,
     /*  161869 */   // Label 3018: @161869
     /*  161869 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(161924), // Rule ID 45939 //
     /*  161874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161877 */     // MIs[0] rs1
     /*  161877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161885 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  161885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  161888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  161902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  161915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161922 */     GIR_RootConstrainSelectedInstOperands,
     /*  161923 */     // GIR_Coverage, 45939,
     /*  161923 */     GIR_EraseRootFromParent_Done,
     /*  161924 */   // Label 3019: @161924
     /*  161924 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(161979), // Rule ID 46014 //
     /*  161929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  161932 */     // MIs[0] rs1
     /*  161932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161940 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  161940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  161943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  161957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  161970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161977 */     GIR_RootConstrainSelectedInstOperands,
     /*  161978 */     // GIR_Coverage, 46014,
     /*  161978 */     GIR_EraseRootFromParent_Done,
     /*  161979 */   // Label 3020: @161979
     /*  161979 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(162034), // Rule ID 46015 //
     /*  161984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  161987 */     // MIs[0] rs1
     /*  161987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161995 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  161995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  161998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162032 */     GIR_RootConstrainSelectedInstOperands,
     /*  162033 */     // GIR_Coverage, 46015,
     /*  162033 */     GIR_EraseRootFromParent_Done,
     /*  162034 */   // Label 3021: @162034
     /*  162034 */   GIM_Reject,
     /*  162035 */ // Label 3017: @162035
     /*  162035 */ GIM_Reject,
     /*  162036 */ // Label 2914: @162036
     /*  162036 */ GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(162273),
     /*  162041 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162044 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162052 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(162107), // Rule ID 45946 //
     /*  162057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162060 */     // MIs[0] rs1
     /*  162060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162068 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162105 */     GIR_RootConstrainSelectedInstOperands,
     /*  162106 */     // GIR_Coverage, 45946,
     /*  162106 */     GIR_EraseRootFromParent_Done,
     /*  162107 */   // Label 3023: @162107
     /*  162107 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(162162), // Rule ID 45947 //
     /*  162112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162115 */     // MIs[0] rs1
     /*  162115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162123 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  162123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162160 */     GIR_RootConstrainSelectedInstOperands,
     /*  162161 */     // GIR_Coverage, 45947,
     /*  162161 */     GIR_EraseRootFromParent_Done,
     /*  162162 */   // Label 3024: @162162
     /*  162162 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(162217), // Rule ID 46022 //
     /*  162167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  162170 */     // MIs[0] rs1
     /*  162170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162178 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162215 */     GIR_RootConstrainSelectedInstOperands,
     /*  162216 */     // GIR_Coverage, 46022,
     /*  162216 */     GIR_EraseRootFromParent_Done,
     /*  162217 */   // Label 3025: @162217
     /*  162217 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(162272), // Rule ID 46023 //
     /*  162222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  162225 */     // MIs[0] rs1
     /*  162225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162233 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  162233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162270 */     GIR_RootConstrainSelectedInstOperands,
     /*  162271 */     // GIR_Coverage, 46023,
     /*  162271 */     GIR_EraseRootFromParent_Done,
     /*  162272 */   // Label 3026: @162272
     /*  162272 */   GIM_Reject,
     /*  162273 */ // Label 3022: @162273
     /*  162273 */ GIM_Reject,
     /*  162274 */ // Label 2915: @162274
     /*  162274 */ GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(162511),
     /*  162279 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162282 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162290 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(162345), // Rule ID 45962 //
     /*  162295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  162298 */     // MIs[0] rs1
     /*  162298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162306 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  162306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162343 */     GIR_RootConstrainSelectedInstOperands,
     /*  162344 */     // GIR_Coverage, 45962,
     /*  162344 */     GIR_EraseRootFromParent_Done,
     /*  162345 */   // Label 3028: @162345
     /*  162345 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(162400), // Rule ID 45963 //
     /*  162350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  162353 */     // MIs[0] rs1
     /*  162353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162361 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  162361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162398 */     GIR_RootConstrainSelectedInstOperands,
     /*  162399 */     // GIR_Coverage, 45963,
     /*  162399 */     GIR_EraseRootFromParent_Done,
     /*  162400 */   // Label 3029: @162400
     /*  162400 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(162455), // Rule ID 46034 //
     /*  162405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  162408 */     // MIs[0] rs1
     /*  162408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162416 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  162416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162453 */     GIR_RootConstrainSelectedInstOperands,
     /*  162454 */     // GIR_Coverage, 46034,
     /*  162454 */     GIR_EraseRootFromParent_Done,
     /*  162455 */   // Label 3030: @162455
     /*  162455 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(162510), // Rule ID 46035 //
     /*  162460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  162463 */     // MIs[0] rs1
     /*  162463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162471 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  162471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162508 */     GIR_RootConstrainSelectedInstOperands,
     /*  162509 */     // GIR_Coverage, 46035,
     /*  162509 */     GIR_EraseRootFromParent_Done,
     /*  162510 */   // Label 3031: @162510
     /*  162510 */   GIM_Reject,
     /*  162511 */ // Label 3027: @162511
     /*  162511 */ GIM_Reject,
     /*  162512 */ // Label 2916: @162512
     /*  162512 */ GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(162631),
     /*  162517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162520 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  162532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162536 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(162583), // Rule ID 46074 //
     /*  162541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162544 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  162544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  162547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  162561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162581 */     GIR_RootConstrainSelectedInstOperands,
     /*  162582 */     // GIR_Coverage, 46074,
     /*  162582 */     GIR_EraseRootFromParent_Done,
     /*  162583 */   // Label 3033: @162583
     /*  162583 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(162630), // Rule ID 46075 //
     /*  162588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162591 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  162591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  162594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  162608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162628 */     GIR_RootConstrainSelectedInstOperands,
     /*  162629 */     // GIR_Coverage, 46075,
     /*  162629 */     GIR_EraseRootFromParent_Done,
     /*  162630 */   // Label 3034: @162630
     /*  162630 */   GIM_Reject,
     /*  162631 */ // Label 3032: @162631
     /*  162631 */ GIM_Reject,
     /*  162632 */ // Label 2917: @162632
     /*  162632 */ GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(162759),
     /*  162637 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162648 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(162703), // Rule ID 45930 //
     /*  162653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162656 */     // MIs[0] rs1
     /*  162656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162664 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  162664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  162667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  162681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162701 */     GIR_RootConstrainSelectedInstOperands,
     /*  162702 */     // GIR_Coverage, 45930,
     /*  162702 */     GIR_EraseRootFromParent_Done,
     /*  162703 */   // Label 3036: @162703
     /*  162703 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(162758), // Rule ID 45931 //
     /*  162708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162711 */     // MIs[0] rs1
     /*  162711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162719 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  162719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  162722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  162736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162756 */     GIR_RootConstrainSelectedInstOperands,
     /*  162757 */     // GIR_Coverage, 45931,
     /*  162757 */     GIR_EraseRootFromParent_Done,
     /*  162758 */   // Label 3037: @162758
     /*  162758 */   GIM_Reject,
     /*  162759 */ // Label 3035: @162759
     /*  162759 */ GIM_Reject,
     /*  162760 */ // Label 2918: @162760
     /*  162760 */ GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(162997),
     /*  162765 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162768 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162776 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(162831), // Rule ID 45942 //
     /*  162781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162784 */     // MIs[0] rs1
     /*  162784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162792 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  162795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  162809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162829 */     GIR_RootConstrainSelectedInstOperands,
     /*  162830 */     // GIR_Coverage, 45942,
     /*  162830 */     GIR_EraseRootFromParent_Done,
     /*  162831 */   // Label 3039: @162831
     /*  162831 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(162886), // Rule ID 45943 //
     /*  162836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162839 */     // MIs[0] rs1
     /*  162839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162847 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  162850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  162864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162884 */     GIR_RootConstrainSelectedInstOperands,
     /*  162885 */     // GIR_Coverage, 45943,
     /*  162885 */     GIR_EraseRootFromParent_Done,
     /*  162886 */   // Label 3040: @162886
     /*  162886 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(162941), // Rule ID 46018 //
     /*  162891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  162894 */     // MIs[0] rs1
     /*  162894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162902 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  162905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  162919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162939 */     GIR_RootConstrainSelectedInstOperands,
     /*  162940 */     // GIR_Coverage, 46018,
     /*  162940 */     GIR_EraseRootFromParent_Done,
     /*  162941 */   // Label 3041: @162941
     /*  162941 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(162996), // Rule ID 46019 //
     /*  162946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  162949 */     // MIs[0] rs1
     /*  162949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162957 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  162960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  162974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162994 */     GIR_RootConstrainSelectedInstOperands,
     /*  162995 */     // GIR_Coverage, 46019,
     /*  162995 */     GIR_EraseRootFromParent_Done,
     /*  162996 */   // Label 3042: @162996
     /*  162996 */   GIM_Reject,
     /*  162997 */ // Label 3038: @162997
     /*  162997 */ GIM_Reject,
     /*  162998 */ // Label 2919: @162998
     /*  162998 */ GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(163235),
     /*  163003 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163006 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163014 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(163069), // Rule ID 45958 //
     /*  163019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163022 */     // MIs[0] rs1
     /*  163022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163030 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163067 */     GIR_RootConstrainSelectedInstOperands,
     /*  163068 */     // GIR_Coverage, 45958,
     /*  163068 */     GIR_EraseRootFromParent_Done,
     /*  163069 */   // Label 3044: @163069
     /*  163069 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(163124), // Rule ID 45959 //
     /*  163074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163077 */     // MIs[0] rs1
     /*  163077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163085 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  163085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163122 */     GIR_RootConstrainSelectedInstOperands,
     /*  163123 */     // GIR_Coverage, 45959,
     /*  163123 */     GIR_EraseRootFromParent_Done,
     /*  163124 */   // Label 3045: @163124
     /*  163124 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(163179), // Rule ID 46030 //
     /*  163129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  163132 */     // MIs[0] rs1
     /*  163132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163140 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163177 */     GIR_RootConstrainSelectedInstOperands,
     /*  163178 */     // GIR_Coverage, 46030,
     /*  163178 */     GIR_EraseRootFromParent_Done,
     /*  163179 */   // Label 3046: @163179
     /*  163179 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(163234), // Rule ID 46031 //
     /*  163184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  163187 */     // MIs[0] rs1
     /*  163187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163195 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  163195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163232 */     GIR_RootConstrainSelectedInstOperands,
     /*  163233 */     // GIR_Coverage, 46031,
     /*  163233 */     GIR_EraseRootFromParent_Done,
     /*  163234 */   // Label 3047: @163234
     /*  163234 */   GIM_Reject,
     /*  163235 */ // Label 3043: @163235
     /*  163235 */ GIM_Reject,
     /*  163236 */ // Label 2920: @163236
     /*  163236 */ GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(163473),
     /*  163241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163244 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  163252 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(163307), // Rule ID 46002 //
     /*  163257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  163260 */     // MIs[0] rs1
     /*  163260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163268 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  163268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163305 */     GIR_RootConstrainSelectedInstOperands,
     /*  163306 */     // GIR_Coverage, 46002,
     /*  163306 */     GIR_EraseRootFromParent_Done,
     /*  163307 */   // Label 3049: @163307
     /*  163307 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(163362), // Rule ID 46003 //
     /*  163312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  163315 */     // MIs[0] rs1
     /*  163315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163323 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  163323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163360 */     GIR_RootConstrainSelectedInstOperands,
     /*  163361 */     // GIR_Coverage, 46003,
     /*  163361 */     GIR_EraseRootFromParent_Done,
     /*  163362 */   // Label 3050: @163362
     /*  163362 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(163417), // Rule ID 46062 //
     /*  163367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  163370 */     // MIs[0] rs1
     /*  163370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163378 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  163378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163415 */     GIR_RootConstrainSelectedInstOperands,
     /*  163416 */     // GIR_Coverage, 46062,
     /*  163416 */     GIR_EraseRootFromParent_Done,
     /*  163417 */   // Label 3051: @163417
     /*  163417 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(163472), // Rule ID 46063 //
     /*  163422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  163425 */     // MIs[0] rs1
     /*  163425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163433 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  163433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163470 */     GIR_RootConstrainSelectedInstOperands,
     /*  163471 */     // GIR_Coverage, 46063,
     /*  163471 */     GIR_EraseRootFromParent_Done,
     /*  163472 */   // Label 3052: @163472
     /*  163472 */   GIM_Reject,
     /*  163473 */ // Label 3048: @163473
     /*  163473 */ GIM_Reject,
     /*  163474 */ // Label 2921: @163474
     /*  163474 */ GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(163593),
     /*  163479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163482 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  163494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163498 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(163545), // Rule ID 46078 //
     /*  163503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163506 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  163506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  163509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  163523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163543 */     GIR_RootConstrainSelectedInstOperands,
     /*  163544 */     // GIR_Coverage, 46078,
     /*  163544 */     GIR_EraseRootFromParent_Done,
     /*  163545 */   // Label 3054: @163545
     /*  163545 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(163592), // Rule ID 46079 //
     /*  163550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163553 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  163553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  163556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  163570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163590 */     GIR_RootConstrainSelectedInstOperands,
     /*  163591 */     // GIR_Coverage, 46079,
     /*  163591 */     GIR_EraseRootFromParent_Done,
     /*  163592 */   // Label 3055: @163592
     /*  163592 */   GIM_Reject,
     /*  163593 */ // Label 3053: @163593
     /*  163593 */ GIM_Reject,
     /*  163594 */ // Label 2922: @163594
     /*  163594 */ GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(163721),
     /*  163599 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163602 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163610 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(163665), // Rule ID 45934 //
     /*  163615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163618 */     // MIs[0] rs1
     /*  163618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163626 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  163626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  163629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  163643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163663 */     GIR_RootConstrainSelectedInstOperands,
     /*  163664 */     // GIR_Coverage, 45934,
     /*  163664 */     GIR_EraseRootFromParent_Done,
     /*  163665 */   // Label 3057: @163665
     /*  163665 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(163720), // Rule ID 45935 //
     /*  163670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163673 */     // MIs[0] rs1
     /*  163673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163681 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  163681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  163684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  163698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163718 */     GIR_RootConstrainSelectedInstOperands,
     /*  163719 */     // GIR_Coverage, 45935,
     /*  163719 */     GIR_EraseRootFromParent_Done,
     /*  163720 */   // Label 3058: @163720
     /*  163720 */   GIM_Reject,
     /*  163721 */ // Label 3056: @163721
     /*  163721 */ GIM_Reject,
     /*  163722 */ // Label 2923: @163722
     /*  163722 */ GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(163959),
     /*  163727 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163738 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(163793), // Rule ID 45954 //
     /*  163743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163746 */     // MIs[0] rs1
     /*  163746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163754 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  163754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  163757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  163771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163791 */     GIR_RootConstrainSelectedInstOperands,
     /*  163792 */     // GIR_Coverage, 45954,
     /*  163792 */     GIR_EraseRootFromParent_Done,
     /*  163793 */   // Label 3060: @163793
     /*  163793 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(163848), // Rule ID 45955 //
     /*  163798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163801 */     // MIs[0] rs1
     /*  163801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163809 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  163812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  163826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163846 */     GIR_RootConstrainSelectedInstOperands,
     /*  163847 */     // GIR_Coverage, 45955,
     /*  163847 */     GIR_EraseRootFromParent_Done,
     /*  163848 */   // Label 3061: @163848
     /*  163848 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(163903), // Rule ID 46026 //
     /*  163853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  163856 */     // MIs[0] rs1
     /*  163856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163864 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  163864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  163867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  163881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163901 */     GIR_RootConstrainSelectedInstOperands,
     /*  163902 */     // GIR_Coverage, 46026,
     /*  163902 */     GIR_EraseRootFromParent_Done,
     /*  163903 */   // Label 3062: @163903
     /*  163903 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(163958), // Rule ID 46027 //
     /*  163908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  163911 */     // MIs[0] rs1
     /*  163911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163919 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  163922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  163936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163956 */     GIR_RootConstrainSelectedInstOperands,
     /*  163957 */     // GIR_Coverage, 46027,
     /*  163957 */     GIR_EraseRootFromParent_Done,
     /*  163958 */   // Label 3063: @163958
     /*  163958 */   GIM_Reject,
     /*  163959 */ // Label 3059: @163959
     /*  163959 */ GIM_Reject,
     /*  163960 */ // Label 2924: @163960
     /*  163960 */ GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(164197),
     /*  163965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163968 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  163976 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(164031), // Rule ID 45990 //
     /*  163981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163984 */     // MIs[0] rs1
     /*  163984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163992 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  163995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164029 */     GIR_RootConstrainSelectedInstOperands,
     /*  164030 */     // GIR_Coverage, 45990,
     /*  164030 */     GIR_EraseRootFromParent_Done,
     /*  164031 */   // Label 3065: @164031
     /*  164031 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(164086), // Rule ID 45991 //
     /*  164036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164039 */     // MIs[0] rs1
     /*  164039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164047 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164084 */     GIR_RootConstrainSelectedInstOperands,
     /*  164085 */     // GIR_Coverage, 45991,
     /*  164085 */     GIR_EraseRootFromParent_Done,
     /*  164086 */   // Label 3066: @164086
     /*  164086 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(164141), // Rule ID 46050 //
     /*  164091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  164094 */     // MIs[0] rs1
     /*  164094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164102 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  164102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164139 */     GIR_RootConstrainSelectedInstOperands,
     /*  164140 */     // GIR_Coverage, 46050,
     /*  164140 */     GIR_EraseRootFromParent_Done,
     /*  164141 */   // Label 3067: @164141
     /*  164141 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(164196), // Rule ID 46051 //
     /*  164146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  164149 */     // MIs[0] rs1
     /*  164149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164157 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164194 */     GIR_RootConstrainSelectedInstOperands,
     /*  164195 */     // GIR_Coverage, 46051,
     /*  164195 */     GIR_EraseRootFromParent_Done,
     /*  164196 */   // Label 3068: @164196
     /*  164196 */   GIM_Reject,
     /*  164197 */ // Label 3064: @164197
     /*  164197 */ GIM_Reject,
     /*  164198 */ // Label 2925: @164198
     /*  164198 */ GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(164435),
     /*  164203 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164206 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  164214 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(164269), // Rule ID 46006 //
     /*  164219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  164222 */     // MIs[0] rs1
     /*  164222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164230 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  164230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164267 */     GIR_RootConstrainSelectedInstOperands,
     /*  164268 */     // GIR_Coverage, 46006,
     /*  164268 */     GIR_EraseRootFromParent_Done,
     /*  164269 */   // Label 3070: @164269
     /*  164269 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(164324), // Rule ID 46007 //
     /*  164274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  164277 */     // MIs[0] rs1
     /*  164277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164285 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  164285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164322 */     GIR_RootConstrainSelectedInstOperands,
     /*  164323 */     // GIR_Coverage, 46007,
     /*  164323 */     GIR_EraseRootFromParent_Done,
     /*  164324 */   // Label 3071: @164324
     /*  164324 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(164379), // Rule ID 46066 //
     /*  164329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  164332 */     // MIs[0] rs1
     /*  164332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164340 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  164340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164377 */     GIR_RootConstrainSelectedInstOperands,
     /*  164378 */     // GIR_Coverage, 46066,
     /*  164378 */     GIR_EraseRootFromParent_Done,
     /*  164379 */   // Label 3072: @164379
     /*  164379 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(164434), // Rule ID 46067 //
     /*  164384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  164387 */     // MIs[0] rs1
     /*  164387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164395 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  164395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164432 */     GIR_RootConstrainSelectedInstOperands,
     /*  164433 */     // GIR_Coverage, 46067,
     /*  164433 */     GIR_EraseRootFromParent_Done,
     /*  164434 */   // Label 3073: @164434
     /*  164434 */   GIM_Reject,
     /*  164435 */ // Label 3069: @164435
     /*  164435 */ GIM_Reject,
     /*  164436 */ // Label 2926: @164436
     /*  164436 */ GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(164555),
     /*  164441 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164444 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164452 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164460 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(164507), // Rule ID 46082 //
     /*  164465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164468 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  164468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  164471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  164485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  164498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164505 */     GIR_RootConstrainSelectedInstOperands,
     /*  164506 */     // GIR_Coverage, 46082,
     /*  164506 */     GIR_EraseRootFromParent_Done,
     /*  164507 */   // Label 3075: @164507
     /*  164507 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(164554), // Rule ID 46083 //
     /*  164512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164515 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  164515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  164518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  164532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  164545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164552 */     GIR_RootConstrainSelectedInstOperands,
     /*  164553 */     // GIR_Coverage, 46083,
     /*  164553 */     GIR_EraseRootFromParent_Done,
     /*  164554 */   // Label 3076: @164554
     /*  164554 */   GIM_Reject,
     /*  164555 */ // Label 3074: @164555
     /*  164555 */ GIM_Reject,
     /*  164556 */ // Label 2927: @164556
     /*  164556 */ GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(164683),
     /*  164561 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164564 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164572 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(164627), // Rule ID 45950 //
     /*  164577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164580 */     // MIs[0] rs1
     /*  164580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164588 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  164588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  164591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  164605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164625 */     GIR_RootConstrainSelectedInstOperands,
     /*  164626 */     // GIR_Coverage, 45950,
     /*  164626 */     GIR_EraseRootFromParent_Done,
     /*  164627 */   // Label 3078: @164627
     /*  164627 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(164682), // Rule ID 45951 //
     /*  164632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164635 */     // MIs[0] rs1
     /*  164635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164643 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  164643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  164646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  164660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164680 */     GIR_RootConstrainSelectedInstOperands,
     /*  164681 */     // GIR_Coverage, 45951,
     /*  164681 */     GIR_EraseRootFromParent_Done,
     /*  164682 */   // Label 3079: @164682
     /*  164682 */   GIM_Reject,
     /*  164683 */ // Label 3077: @164683
     /*  164683 */ GIM_Reject,
     /*  164684 */ // Label 2928: @164684
     /*  164684 */ GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(164921),
     /*  164689 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164692 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  164700 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(164755), // Rule ID 45978 //
     /*  164705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164708 */     // MIs[0] rs1
     /*  164708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164716 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  164716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  164719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  164733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164753 */     GIR_RootConstrainSelectedInstOperands,
     /*  164754 */     // GIR_Coverage, 45978,
     /*  164754 */     GIR_EraseRootFromParent_Done,
     /*  164755 */   // Label 3081: @164755
     /*  164755 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(164810), // Rule ID 45979 //
     /*  164760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164763 */     // MIs[0] rs1
     /*  164763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164771 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  164771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  164774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  164788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164808 */     GIR_RootConstrainSelectedInstOperands,
     /*  164809 */     // GIR_Coverage, 45979,
     /*  164809 */     GIR_EraseRootFromParent_Done,
     /*  164810 */   // Label 3082: @164810
     /*  164810 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(164865), // Rule ID 46038 //
     /*  164815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  164818 */     // MIs[0] rs1
     /*  164818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164826 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  164826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  164829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  164843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164863 */     GIR_RootConstrainSelectedInstOperands,
     /*  164864 */     // GIR_Coverage, 46038,
     /*  164864 */     GIR_EraseRootFromParent_Done,
     /*  164865 */   // Label 3083: @164865
     /*  164865 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(164920), // Rule ID 46039 //
     /*  164870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  164873 */     // MIs[0] rs1
     /*  164873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164881 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  164881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  164884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  164898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164918 */     GIR_RootConstrainSelectedInstOperands,
     /*  164919 */     // GIR_Coverage, 46039,
     /*  164919 */     GIR_EraseRootFromParent_Done,
     /*  164920 */   // Label 3084: @164920
     /*  164920 */   GIM_Reject,
     /*  164921 */ // Label 3080: @164921
     /*  164921 */ GIM_Reject,
     /*  164922 */ // Label 2929: @164922
     /*  164922 */ GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(165159),
     /*  164927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  164938 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(164993), // Rule ID 45994 //
     /*  164943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164946 */     // MIs[0] rs1
     /*  164946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164954 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  164954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  164957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  164971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164991 */     GIR_RootConstrainSelectedInstOperands,
     /*  164992 */     // GIR_Coverage, 45994,
     /*  164992 */     GIR_EraseRootFromParent_Done,
     /*  164993 */   // Label 3086: @164993
     /*  164993 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(165048), // Rule ID 45995 //
     /*  164998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165001 */     // MIs[0] rs1
     /*  165001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165009 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  165009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165046 */     GIR_RootConstrainSelectedInstOperands,
     /*  165047 */     // GIR_Coverage, 45995,
     /*  165047 */     GIR_EraseRootFromParent_Done,
     /*  165048 */   // Label 3087: @165048
     /*  165048 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(165103), // Rule ID 46054 //
     /*  165053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  165056 */     // MIs[0] rs1
     /*  165056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165064 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  165064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165101 */     GIR_RootConstrainSelectedInstOperands,
     /*  165102 */     // GIR_Coverage, 46054,
     /*  165102 */     GIR_EraseRootFromParent_Done,
     /*  165103 */   // Label 3088: @165103
     /*  165103 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(165158), // Rule ID 46055 //
     /*  165108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  165111 */     // MIs[0] rs1
     /*  165111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165119 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  165119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165156 */     GIR_RootConstrainSelectedInstOperands,
     /*  165157 */     // GIR_Coverage, 46055,
     /*  165157 */     GIR_EraseRootFromParent_Done,
     /*  165158 */   // Label 3089: @165158
     /*  165158 */   GIM_Reject,
     /*  165159 */ // Label 3085: @165159
     /*  165159 */ GIM_Reject,
     /*  165160 */ // Label 2930: @165160
     /*  165160 */ GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(165397),
     /*  165165 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165168 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  165176 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(165231), // Rule ID 46010 //
     /*  165181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  165184 */     // MIs[0] rs1
     /*  165184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165192 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  165192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165229 */     GIR_RootConstrainSelectedInstOperands,
     /*  165230 */     // GIR_Coverage, 46010,
     /*  165230 */     GIR_EraseRootFromParent_Done,
     /*  165231 */   // Label 3091: @165231
     /*  165231 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(165286), // Rule ID 46011 //
     /*  165236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  165239 */     // MIs[0] rs1
     /*  165239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165247 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  165247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165284 */     GIR_RootConstrainSelectedInstOperands,
     /*  165285 */     // GIR_Coverage, 46011,
     /*  165285 */     GIR_EraseRootFromParent_Done,
     /*  165286 */   // Label 3092: @165286
     /*  165286 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(165341), // Rule ID 46070 //
     /*  165291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  165294 */     // MIs[0] rs1
     /*  165294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165302 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  165302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165339 */     GIR_RootConstrainSelectedInstOperands,
     /*  165340 */     // GIR_Coverage, 46070,
     /*  165340 */     GIR_EraseRootFromParent_Done,
     /*  165341 */   // Label 3093: @165341
     /*  165341 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(165396), // Rule ID 46071 //
     /*  165346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  165349 */     // MIs[0] rs1
     /*  165349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165357 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  165357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165394 */     GIR_RootConstrainSelectedInstOperands,
     /*  165395 */     // GIR_Coverage, 46071,
     /*  165395 */     GIR_EraseRootFromParent_Done,
     /*  165396 */   // Label 3094: @165396
     /*  165396 */   GIM_Reject,
     /*  165397 */ // Label 3090: @165397
     /*  165397 */ GIM_Reject,
     /*  165398 */ // Label 2931: @165398
     /*  165398 */ GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(165517),
     /*  165403 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165406 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  165418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165422 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(165469), // Rule ID 46086 //
     /*  165427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165430 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  165430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  165433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  165447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  165460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165467 */     GIR_RootConstrainSelectedInstOperands,
     /*  165468 */     // GIR_Coverage, 46086,
     /*  165468 */     GIR_EraseRootFromParent_Done,
     /*  165469 */   // Label 3096: @165469
     /*  165469 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(165516), // Rule ID 46087 //
     /*  165474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165477 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  165477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  165480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  165494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  165507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165514 */     GIR_RootConstrainSelectedInstOperands,
     /*  165515 */     // GIR_Coverage, 46087,
     /*  165515 */     GIR_EraseRootFromParent_Done,
     /*  165516 */   // Label 3097: @165516
     /*  165516 */   GIM_Reject,
     /*  165517 */ // Label 3095: @165517
     /*  165517 */ GIM_Reject,
     /*  165518 */ // Label 2932: @165518
     /*  165518 */ GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(165645),
     /*  165523 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165526 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165534 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(165589), // Rule ID 45966 //
     /*  165539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165542 */     // MIs[0] rs1
     /*  165542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165550 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  165550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  165553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  165567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165587 */     GIR_RootConstrainSelectedInstOperands,
     /*  165588 */     // GIR_Coverage, 45966,
     /*  165588 */     GIR_EraseRootFromParent_Done,
     /*  165589 */   // Label 3099: @165589
     /*  165589 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(165644), // Rule ID 45967 //
     /*  165594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165597 */     // MIs[0] rs1
     /*  165597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165605 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  165605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  165608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  165622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165642 */     GIR_RootConstrainSelectedInstOperands,
     /*  165643 */     // GIR_Coverage, 45967,
     /*  165643 */     GIR_EraseRootFromParent_Done,
     /*  165644 */   // Label 3100: @165644
     /*  165644 */   GIM_Reject,
     /*  165645 */ // Label 3098: @165645
     /*  165645 */ GIM_Reject,
     /*  165646 */ // Label 2933: @165646
     /*  165646 */ GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(165883),
     /*  165651 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165654 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165662 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(165717), // Rule ID 45982 //
     /*  165667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165670 */     // MIs[0] rs1
     /*  165670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165678 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  165678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  165681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  165695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165715 */     GIR_RootConstrainSelectedInstOperands,
     /*  165716 */     // GIR_Coverage, 45982,
     /*  165716 */     GIR_EraseRootFromParent_Done,
     /*  165717 */   // Label 3102: @165717
     /*  165717 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(165772), // Rule ID 45983 //
     /*  165722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165725 */     // MIs[0] rs1
     /*  165725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165733 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  165733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  165736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  165750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165770 */     GIR_RootConstrainSelectedInstOperands,
     /*  165771 */     // GIR_Coverage, 45983,
     /*  165771 */     GIR_EraseRootFromParent_Done,
     /*  165772 */   // Label 3103: @165772
     /*  165772 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(165827), // Rule ID 46042 //
     /*  165777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  165780 */     // MIs[0] rs1
     /*  165780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165788 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  165788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  165791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  165805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165825 */     GIR_RootConstrainSelectedInstOperands,
     /*  165826 */     // GIR_Coverage, 46042,
     /*  165826 */     GIR_EraseRootFromParent_Done,
     /*  165827 */   // Label 3104: @165827
     /*  165827 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(165882), // Rule ID 46043 //
     /*  165832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  165835 */     // MIs[0] rs1
     /*  165835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165843 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  165843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  165846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  165860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165880 */     GIR_RootConstrainSelectedInstOperands,
     /*  165881 */     // GIR_Coverage, 46043,
     /*  165881 */     GIR_EraseRootFromParent_Done,
     /*  165882 */   // Label 3105: @165882
     /*  165882 */   GIM_Reject,
     /*  165883 */ // Label 3101: @165883
     /*  165883 */ GIM_Reject,
     /*  165884 */ // Label 2934: @165884
     /*  165884 */ GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(166121),
     /*  165889 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165892 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  165900 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(165955), // Rule ID 45998 //
     /*  165905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165908 */     // MIs[0] rs1
     /*  165908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165916 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  165916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  165919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  165933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165953 */     GIR_RootConstrainSelectedInstOperands,
     /*  165954 */     // GIR_Coverage, 45998,
     /*  165954 */     GIR_EraseRootFromParent_Done,
     /*  165955 */   // Label 3107: @165955
     /*  165955 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(166010), // Rule ID 45999 //
     /*  165960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165963 */     // MIs[0] rs1
     /*  165963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165971 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  165971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  165974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  165988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166008 */     GIR_RootConstrainSelectedInstOperands,
     /*  166009 */     // GIR_Coverage, 45999,
     /*  166009 */     GIR_EraseRootFromParent_Done,
     /*  166010 */   // Label 3108: @166010
     /*  166010 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(166065), // Rule ID 46058 //
     /*  166015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  166018 */     // MIs[0] rs1
     /*  166018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166026 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  166026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166063 */     GIR_RootConstrainSelectedInstOperands,
     /*  166064 */     // GIR_Coverage, 46058,
     /*  166064 */     GIR_EraseRootFromParent_Done,
     /*  166065 */   // Label 3109: @166065
     /*  166065 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(166120), // Rule ID 46059 //
     /*  166070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  166073 */     // MIs[0] rs1
     /*  166073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166081 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  166081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166118 */     GIR_RootConstrainSelectedInstOperands,
     /*  166119 */     // GIR_Coverage, 46059,
     /*  166119 */     GIR_EraseRootFromParent_Done,
     /*  166120 */   // Label 3110: @166120
     /*  166120 */   GIM_Reject,
     /*  166121 */ // Label 3106: @166121
     /*  166121 */ GIM_Reject,
     /*  166122 */ // Label 2935: @166122
     /*  166122 */ GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(166241),
     /*  166127 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166130 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166138 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166146 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(166193), // Rule ID 46090 //
     /*  166151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166154 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  166154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  166157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  166171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166191 */     GIR_RootConstrainSelectedInstOperands,
     /*  166192 */     // GIR_Coverage, 46090,
     /*  166192 */     GIR_EraseRootFromParent_Done,
     /*  166193 */   // Label 3112: @166193
     /*  166193 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(166240), // Rule ID 46091 //
     /*  166198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166201 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  166201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  166204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  166218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166238 */     GIR_RootConstrainSelectedInstOperands,
     /*  166239 */     // GIR_Coverage, 46091,
     /*  166239 */     GIR_EraseRootFromParent_Done,
     /*  166240 */   // Label 3113: @166240
     /*  166240 */   GIM_Reject,
     /*  166241 */ // Label 3111: @166241
     /*  166241 */ GIM_Reject,
     /*  166242 */ // Label 2936: @166242
     /*  166242 */ GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(166369),
     /*  166247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166258 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(166313), // Rule ID 45970 //
     /*  166263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166266 */     // MIs[0] rs1
     /*  166266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166274 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  166274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  166277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  166291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166311 */     GIR_RootConstrainSelectedInstOperands,
     /*  166312 */     // GIR_Coverage, 45970,
     /*  166312 */     GIR_EraseRootFromParent_Done,
     /*  166313 */   // Label 3115: @166313
     /*  166313 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(166368), // Rule ID 45971 //
     /*  166318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166321 */     // MIs[0] rs1
     /*  166321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166329 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  166329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  166332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  166346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166366 */     GIR_RootConstrainSelectedInstOperands,
     /*  166367 */     // GIR_Coverage, 45971,
     /*  166367 */     GIR_EraseRootFromParent_Done,
     /*  166368 */   // Label 3116: @166368
     /*  166368 */   GIM_Reject,
     /*  166369 */ // Label 3114: @166369
     /*  166369 */ GIM_Reject,
     /*  166370 */ // Label 2937: @166370
     /*  166370 */ GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(166607),
     /*  166375 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166378 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166386 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(166441), // Rule ID 45986 //
     /*  166391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166394 */     // MIs[0] rs1
     /*  166394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166402 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166439 */     GIR_RootConstrainSelectedInstOperands,
     /*  166440 */     // GIR_Coverage, 45986,
     /*  166440 */     GIR_EraseRootFromParent_Done,
     /*  166441 */   // Label 3118: @166441
     /*  166441 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(166496), // Rule ID 45987 //
     /*  166446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166449 */     // MIs[0] rs1
     /*  166449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166457 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166494 */     GIR_RootConstrainSelectedInstOperands,
     /*  166495 */     // GIR_Coverage, 45987,
     /*  166495 */     GIR_EraseRootFromParent_Done,
     /*  166496 */   // Label 3119: @166496
     /*  166496 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(166551), // Rule ID 46046 //
     /*  166501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  166504 */     // MIs[0] rs1
     /*  166504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166512 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166549 */     GIR_RootConstrainSelectedInstOperands,
     /*  166550 */     // GIR_Coverage, 46046,
     /*  166550 */     GIR_EraseRootFromParent_Done,
     /*  166551 */   // Label 3120: @166551
     /*  166551 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(166606), // Rule ID 46047 //
     /*  166556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  166559 */     // MIs[0] rs1
     /*  166559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166567 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166604 */     GIR_RootConstrainSelectedInstOperands,
     /*  166605 */     // GIR_Coverage, 46047,
     /*  166605 */     GIR_EraseRootFromParent_Done,
     /*  166606 */   // Label 3121: @166606
     /*  166606 */   GIM_Reject,
     /*  166607 */ // Label 3117: @166607
     /*  166607 */ GIM_Reject,
     /*  166608 */ // Label 2938: @166608
     /*  166608 */ GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(166727),
     /*  166613 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166616 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166632 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(166679), // Rule ID 46094 //
     /*  166637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166640 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  166640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  166643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  166657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166677 */     GIR_RootConstrainSelectedInstOperands,
     /*  166678 */     // GIR_Coverage, 46094,
     /*  166678 */     GIR_EraseRootFromParent_Done,
     /*  166679 */   // Label 3123: @166679
     /*  166679 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(166726), // Rule ID 46095 //
     /*  166684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166687 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  166687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  166690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  166704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166724 */     GIR_RootConstrainSelectedInstOperands,
     /*  166725 */     // GIR_Coverage, 46095,
     /*  166725 */     GIR_EraseRootFromParent_Done,
     /*  166726 */   // Label 3124: @166726
     /*  166726 */   GIM_Reject,
     /*  166727 */ // Label 3122: @166727
     /*  166727 */ GIM_Reject,
     /*  166728 */ // Label 2939: @166728
     /*  166728 */ GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(166855),
     /*  166733 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166736 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166744 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(166799), // Rule ID 45974 //
     /*  166749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166752 */     // MIs[0] rs1
     /*  166752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166760 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  166760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  166763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  166777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166797 */     GIR_RootConstrainSelectedInstOperands,
     /*  166798 */     // GIR_Coverage, 45974,
     /*  166798 */     GIR_EraseRootFromParent_Done,
     /*  166799 */   // Label 3126: @166799
     /*  166799 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(166854), // Rule ID 45975 //
     /*  166804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166807 */     // MIs[0] rs1
     /*  166807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166815 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  166815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  166818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  166832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166852 */     GIR_RootConstrainSelectedInstOperands,
     /*  166853 */     // GIR_Coverage, 45975,
     /*  166853 */     GIR_EraseRootFromParent_Done,
     /*  166854 */   // Label 3127: @166854
     /*  166854 */   GIM_Reject,
     /*  166855 */ // Label 3125: @166855
     /*  166855 */ GIM_Reject,
     /*  166856 */ // Label 2940: @166856
     /*  166856 */ GIM_Reject,
     /*  166857 */ // Label 22: @166857
     /*  166857 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3130*/ GIMT_Encode4(167970),
     /*  166868 */ /*GILLT_s32*//*Label 3128*/ GIMT_Encode4(166876),
     /*  166872 */ /*GILLT_s64*//*Label 3129*/ GIMT_Encode4(167396),
     /*  166876 */ // Label 3128: @166876
     /*  166876 */ GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(166930), // Rule ID 235 //
     /*  166881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  166884 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166887 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  166894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166898 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166902 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166909 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  166909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  166912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166924 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166928 */   GIR_RootConstrainSelectedInstOperands,
     /*  166929 */   // GIR_Coverage, 235,
     /*  166929 */   GIR_EraseRootFromParent_Done,
     /*  166930 */ // Label 3131: @166930
     /*  166930 */ GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(166984), // Rule ID 239 //
     /*  166935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  166938 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166941 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  166948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166952 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166956 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166963 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  166963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  166966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166978 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166982 */   GIR_RootConstrainSelectedInstOperands,
     /*  166983 */   // GIR_Coverage, 239,
     /*  166983 */   GIR_EraseRootFromParent_Done,
     /*  166984 */ // Label 3132: @166984
     /*  166984 */ GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(167041), // Rule ID 328 //
     /*  166989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  166992 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  166995 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167002 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167009 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167013 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167020 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10091>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  167023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167035 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167039 */   GIR_RootConstrainSelectedInstOperands,
     /*  167040 */   // GIR_Coverage, 328,
     /*  167040 */   GIR_EraseRootFromParent_Done,
     /*  167041 */ // Label 3133: @167041
     /*  167041 */ GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(167098), // Rule ID 332 //
     /*  167046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  167049 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167052 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167059 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167066 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167070 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167077 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10093>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  167080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167092 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167096 */   GIR_RootConstrainSelectedInstOperands,
     /*  167097 */   // GIR_Coverage, 332,
     /*  167097 */   GIR_EraseRootFromParent_Done,
     /*  167098 */ // Label 3134: @167098
     /*  167098 */ GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(167155), // Rule ID 348 //
     /*  167103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  167106 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167109 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167116 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167123 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167127 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167134 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10107>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  167137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167149 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167153 */   GIR_RootConstrainSelectedInstOperands,
     /*  167154 */   // GIR_Coverage, 348,
     /*  167154 */   GIR_EraseRootFromParent_Done,
     /*  167155 */ // Label 3135: @167155
     /*  167155 */ GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(167195), // Rule ID 1104 //
     /*  167160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167163 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167166 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167180 */   // MIs[0] rs1
     /*  167180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167188 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10595>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  167193 */   GIR_RootConstrainSelectedInstOperands,
     /*  167194 */   // GIR_Coverage, 1104,
     /*  167194 */   GIR_Done,
     /*  167195 */ // Label 3136: @167195
     /*  167195 */ GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(167235), // Rule ID 1108 //
     /*  167200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167203 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167206 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167213 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167220 */   // MIs[0] rs1
     /*  167220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167228 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10597>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  167233 */   GIR_RootConstrainSelectedInstOperands,
     /*  167234 */   // GIR_Coverage, 1108,
     /*  167234 */   GIR_Done,
     /*  167235 */ // Label 3137: @167235
     /*  167235 */ GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(167275), // Rule ID 1112 //
     /*  167240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167243 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167246 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167260 */   // MIs[0] rs1
     /*  167260 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167268 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10599>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  167273 */   GIR_RootConstrainSelectedInstOperands,
     /*  167274 */   // GIR_Coverage, 1112,
     /*  167274 */   GIR_Done,
     /*  167275 */ // Label 3138: @167275
     /*  167275 */ GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(167315), // Rule ID 1116 //
     /*  167280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167283 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167286 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167293 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167300 */   // MIs[0] rs1
     /*  167300 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167308 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10601>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  167313 */   GIR_RootConstrainSelectedInstOperands,
     /*  167314 */   // GIR_Coverage, 1116,
     /*  167314 */   GIR_Done,
     /*  167315 */ // Label 3139: @167315
     /*  167315 */ GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(167355), // Rule ID 1136 //
     /*  167320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  167323 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167326 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167333 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167340 */   // MIs[0] rs1
     /*  167340 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167348 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10619>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  167353 */   GIR_RootConstrainSelectedInstOperands,
     /*  167354 */   // GIR_Coverage, 1136,
     /*  167354 */   GIR_Done,
     /*  167355 */ // Label 3140: @167355
     /*  167355 */ GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(167395), // Rule ID 1140 //
     /*  167360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  167363 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167366 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167373 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167380 */   // MIs[0] rs1
     /*  167380 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167388 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10621>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  167393 */   GIR_RootConstrainSelectedInstOperands,
     /*  167394 */   // GIR_Coverage, 1140,
     /*  167394 */   GIR_Done,
     /*  167395 */ // Label 3141: @167395
     /*  167395 */ GIM_Reject,
     /*  167396 */ // Label 3129: @167396
     /*  167396 */ GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(167450), // Rule ID 234 //
     /*  167401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  167404 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167407 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167418 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167422 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167429 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  167432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167434 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167444 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167448 */   GIR_RootConstrainSelectedInstOperands,
     /*  167449 */   // GIR_Coverage, 234,
     /*  167449 */   GIR_EraseRootFromParent_Done,
     /*  167450 */ // Label 3142: @167450
     /*  167450 */ GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(167504), // Rule ID 238 //
     /*  167455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  167458 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167461 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167472 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167476 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167483 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  167486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167498 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167502 */   GIR_RootConstrainSelectedInstOperands,
     /*  167503 */   // GIR_Coverage, 238,
     /*  167503 */   GIR_EraseRootFromParent_Done,
     /*  167504 */ // Label 3143: @167504
     /*  167504 */ GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(167558), // Rule ID 285 //
     /*  167509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  167512 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167515 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167526 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167530 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167537 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  167540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167552 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167556 */   GIR_RootConstrainSelectedInstOperands,
     /*  167557 */   // GIR_Coverage, 285,
     /*  167557 */   GIR_EraseRootFromParent_Done,
     /*  167558 */ // Label 3144: @167558
     /*  167558 */ GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(167615), // Rule ID 327 //
     /*  167563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  167566 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167569 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167576 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167583 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167594 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10091>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  167597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167609 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167613 */   GIR_RootConstrainSelectedInstOperands,
     /*  167614 */   // GIR_Coverage, 327,
     /*  167614 */   GIR_EraseRootFromParent_Done,
     /*  167615 */ // Label 3145: @167615
     /*  167615 */ GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(167672), // Rule ID 331 //
     /*  167620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  167623 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167626 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167633 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167640 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167644 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167651 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10093>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  167654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167666 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167670 */   GIR_RootConstrainSelectedInstOperands,
     /*  167671 */   // GIR_Coverage, 331,
     /*  167671 */   GIR_EraseRootFromParent_Done,
     /*  167672 */ // Label 3146: @167672
     /*  167672 */ GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(167729), // Rule ID 347 //
     /*  167677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  167680 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167683 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167690 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167697 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167701 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167708 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10107>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  167711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167723 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167727 */   GIR_RootConstrainSelectedInstOperands,
     /*  167728 */   // GIR_Coverage, 347,
     /*  167728 */   GIR_EraseRootFromParent_Done,
     /*  167729 */ // Label 3147: @167729
     /*  167729 */ GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(167769), // Rule ID 1103 //
     /*  167734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  167737 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167740 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167747 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167754 */   // MIs[0] rs1
     /*  167754 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167762 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10595>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  167762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  167767 */   GIR_RootConstrainSelectedInstOperands,
     /*  167768 */   // GIR_Coverage, 1103,
     /*  167768 */   GIR_Done,
     /*  167769 */ // Label 3148: @167769
     /*  167769 */ GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(167809), // Rule ID 1107 //
     /*  167774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  167777 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167780 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167787 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167794 */   // MIs[0] rs1
     /*  167794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167802 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10597>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  167802 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  167807 */   GIR_RootConstrainSelectedInstOperands,
     /*  167808 */   // GIR_Coverage, 1107,
     /*  167808 */   GIR_Done,
     /*  167809 */ // Label 3149: @167809
     /*  167809 */ GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(167849), // Rule ID 1111 //
     /*  167814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  167817 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167820 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167827 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167834 */   // MIs[0] rs1
     /*  167834 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167842 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10599>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  167842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  167847 */   GIR_RootConstrainSelectedInstOperands,
     /*  167848 */   // GIR_Coverage, 1111,
     /*  167848 */   GIR_Done,
     /*  167849 */ // Label 3150: @167849
     /*  167849 */ GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(167889), // Rule ID 1115 //
     /*  167854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  167857 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167860 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167867 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167874 */   // MIs[0] rs1
     /*  167874 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167882 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10601>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  167882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  167887 */   GIR_RootConstrainSelectedInstOperands,
     /*  167888 */   // GIR_Coverage, 1115,
     /*  167888 */   GIR_Done,
     /*  167889 */ // Label 3151: @167889
     /*  167889 */ GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(167929), // Rule ID 1135 //
     /*  167894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  167897 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167900 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167907 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167914 */   // MIs[0] rs1
     /*  167914 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167922 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10619>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  167922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  167927 */   GIR_RootConstrainSelectedInstOperands,
     /*  167928 */   // GIR_Coverage, 1135,
     /*  167928 */   GIR_Done,
     /*  167929 */ // Label 3152: @167929
     /*  167929 */ GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(167969), // Rule ID 1139 //
     /*  167934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  167937 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167940 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167947 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167954 */   // MIs[0] rs1
     /*  167954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167962 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10621>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  167962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  167967 */   GIR_RootConstrainSelectedInstOperands,
     /*  167968 */   // GIR_Coverage, 1139,
     /*  167968 */   GIR_Done,
     /*  167969 */ // Label 3153: @167969
     /*  167969 */ GIM_Reject,
     /*  167970 */ // Label 3130: @167970
     /*  167970 */ GIM_Reject,
     /*  167971 */ // Label 23: @167971
     /*  167971 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3156*/ GIMT_Encode4(168604),
     /*  167982 */ /*GILLT_s32*//*Label 3154*/ GIMT_Encode4(167990),
     /*  167986 */ /*GILLT_s64*//*Label 3155*/ GIMT_Encode4(168270),
     /*  167990 */ // Label 3154: @167990
     /*  167990 */ GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(168044), // Rule ID 245 //
     /*  167995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  167998 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168001 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168016 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168023 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168038 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168042 */   GIR_RootConstrainSelectedInstOperands,
     /*  168043 */   // GIR_Coverage, 245,
     /*  168043 */   GIR_EraseRootFromParent_Done,
     /*  168044 */ // Label 3157: @168044
     /*  168044 */ GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(168098), // Rule ID 247 //
     /*  168049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  168052 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168055 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168066 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168070 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168077 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168092 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168096 */   GIR_RootConstrainSelectedInstOperands,
     /*  168097 */   // GIR_Coverage, 247,
     /*  168097 */   GIR_EraseRootFromParent_Done,
     /*  168098 */ // Label 3158: @168098
     /*  168098 */ GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(168155), // Rule ID 334 //
     /*  168103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  168106 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168109 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168116 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168123 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168127 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168134 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10095>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168149 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168153 */   GIR_RootConstrainSelectedInstOperands,
     /*  168154 */   // GIR_Coverage, 334,
     /*  168154 */   GIR_EraseRootFromParent_Done,
     /*  168155 */ // Label 3159: @168155
     /*  168155 */ GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(168212), // Rule ID 336 //
     /*  168160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  168163 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168166 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168173 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168184 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168191 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10097>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168206 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168210 */   GIR_RootConstrainSelectedInstOperands,
     /*  168211 */   // GIR_Coverage, 336,
     /*  168211 */   GIR_EraseRootFromParent_Done,
     /*  168212 */ // Label 3160: @168212
     /*  168212 */ GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(168269), // Rule ID 350 //
     /*  168217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  168220 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168223 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168230 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168248 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10109>>  =>  (LWU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  168251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168263 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168267 */   GIR_RootConstrainSelectedInstOperands,
     /*  168268 */   // GIR_Coverage, 350,
     /*  168268 */   GIR_EraseRootFromParent_Done,
     /*  168269 */ // Label 3161: @168269
     /*  168269 */ GIM_Reject,
     /*  168270 */ // Label 3155: @168270
     /*  168270 */ GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(168324), // Rule ID 244 //
     /*  168275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  168278 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168281 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168296 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168303 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168318 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168322 */   GIR_RootConstrainSelectedInstOperands,
     /*  168323 */   // GIR_Coverage, 244,
     /*  168323 */   GIR_EraseRootFromParent_Done,
     /*  168324 */ // Label 3162: @168324
     /*  168324 */ GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(168378), // Rule ID 246 //
     /*  168329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  168332 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168335 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168346 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168350 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168357 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168362 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168372 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168376 */   GIR_RootConstrainSelectedInstOperands,
     /*  168377 */   // GIR_Coverage, 246,
     /*  168377 */   GIR_EraseRootFromParent_Done,
     /*  168378 */ // Label 3163: @168378
     /*  168378 */ GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(168432), // Rule ID 287 //
     /*  168383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  168386 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168389 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168400 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168404 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168411 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  168414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168426 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168430 */   GIR_RootConstrainSelectedInstOperands,
     /*  168431 */   // GIR_Coverage, 287,
     /*  168431 */   GIR_EraseRootFromParent_Done,
     /*  168432 */ // Label 3164: @168432
     /*  168432 */ GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(168489), // Rule ID 333 //
     /*  168437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168440 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168443 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168450 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168457 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168461 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168468 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10095>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168487 */   GIR_RootConstrainSelectedInstOperands,
     /*  168488 */   // GIR_Coverage, 333,
     /*  168488 */   GIR_EraseRootFromParent_Done,
     /*  168489 */ // Label 3165: @168489
     /*  168489 */ GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(168546), // Rule ID 335 //
     /*  168494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168497 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168500 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168507 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168514 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168518 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168525 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10097>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168540 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168544 */   GIR_RootConstrainSelectedInstOperands,
     /*  168545 */   // GIR_Coverage, 335,
     /*  168545 */   GIR_EraseRootFromParent_Done,
     /*  168546 */ // Label 3166: @168546
     /*  168546 */ GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(168603), // Rule ID 349 //
     /*  168551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  168554 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168557 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168564 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168575 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168582 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10109>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  168585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168601 */   GIR_RootConstrainSelectedInstOperands,
     /*  168602 */   // GIR_Coverage, 349,
     /*  168602 */   GIR_EraseRootFromParent_Done,
     /*  168603 */ // Label 3167: @168603
     /*  168603 */ GIM_Reject,
     /*  168604 */ // Label 3156: @168604
     /*  168604 */ GIM_Reject,
     /*  168605 */ // Label 24: @168605
     /*  168605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 3202*/ GIMT_Encode4(175504),
     /*  168616 */ /*GILLT_p0s32*//*Label 3168*/ GIMT_Encode4(168752),
     /*  168620 */ /*GILLT_p0s64*//*Label 3169*/ GIMT_Encode4(168846),
     /*  168624 */ /*GILLT_s16*//*Label 3170*/ GIMT_Encode4(168940),
     /*  168628 */ /*GILLT_s32*//*Label 3171*/ GIMT_Encode4(169579),
     /*  168632 */ /*GILLT_s64*//*Label 3172*/ GIMT_Encode4(170881),
     /*  168636 */ /*GILLT_nxv1s1*//*Label 3173*/ GIMT_Encode4(171958),
     /*  168640 */ /*GILLT_nxv1s8*//*Label 3174*/ GIMT_Encode4(172038),
     /*  168644 */ /*GILLT_nxv1s16*//*Label 3175*/ GIMT_Encode4(172126),
     /*  168648 */ /*GILLT_nxv1s32*//*Label 3176*/ GIMT_Encode4(172284),
     /*  168652 */ /*GILLT_nxv1s64*//*Label 3177*/ GIMT_Encode4(172442),
     /*  168656 */ /*GILLT_nxv2s1*//*Label 3178*/ GIMT_Encode4(172600),
     /*  168660 */ /*GILLT_nxv2s8*//*Label 3179*/ GIMT_Encode4(172680),
     /*  168664 */ /*GILLT_nxv2s16*//*Label 3180*/ GIMT_Encode4(172768),
     /*  168668 */ /*GILLT_nxv2s32*//*Label 3181*/ GIMT_Encode4(172926),
     /*  168672 */ /*GILLT_nxv2s64*//*Label 3182*/ GIMT_Encode4(173084),
     /*  168676 */ /*GILLT_nxv4s1*//*Label 3183*/ GIMT_Encode4(173242),
     /*  168680 */ /*GILLT_nxv4s8*//*Label 3184*/ GIMT_Encode4(173322),
     /*  168684 */ /*GILLT_nxv4s16*//*Label 3185*/ GIMT_Encode4(173410),
     /*  168688 */ /*GILLT_nxv4s32*//*Label 3186*/ GIMT_Encode4(173568),
     /*  168692 */ /*GILLT_nxv4s64*//*Label 3187*/ GIMT_Encode4(173726),
     /*  168696 */ /*GILLT_nxv8s1*//*Label 3188*/ GIMT_Encode4(173884),
     /*  168700 */ /*GILLT_nxv8s8*//*Label 3189*/ GIMT_Encode4(173964),
     /*  168704 */ /*GILLT_nxv8s16*//*Label 3190*/ GIMT_Encode4(174052),
     /*  168708 */ /*GILLT_nxv8s32*//*Label 3191*/ GIMT_Encode4(174210),
     /*  168712 */ /*GILLT_nxv8s64*//*Label 3192*/ GIMT_Encode4(174368),
     /*  168716 */ /*GILLT_nxv16s1*//*Label 3193*/ GIMT_Encode4(174526),
     /*  168720 */ /*GILLT_nxv16s8*//*Label 3194*/ GIMT_Encode4(174606),
     /*  168724 */ /*GILLT_nxv16s16*//*Label 3195*/ GIMT_Encode4(174694),
     /*  168728 */ /*GILLT_nxv16s32*//*Label 3196*/ GIMT_Encode4(174852),
     /*  168732 */ /*GILLT_nxv32s1*//*Label 3197*/ GIMT_Encode4(175010),
     /*  168736 */ /*GILLT_nxv32s8*//*Label 3198*/ GIMT_Encode4(175090),
     /*  168740 */ /*GILLT_nxv32s16*//*Label 3199*/ GIMT_Encode4(175178),
     /*  168744 */ /*GILLT_nxv64s1*//*Label 3200*/ GIMT_Encode4(175336),
     /*  168748 */ /*GILLT_nxv64s8*//*Label 3201*/ GIMT_Encode4(175416),
     /*  168752 */ // Label 3168: @168752
     /*  168752 */ GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(168845),
     /*  168757 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168760 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  168764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168768 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168772 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(168808), // Rule ID 65368 //
     /*  168777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  168780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168787 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  168790 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  168792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168806 */     GIR_RootConstrainSelectedInstOperands,
     /*  168807 */     // GIR_Coverage, 65368,
     /*  168807 */     GIR_EraseRootFromParent_Done,
     /*  168808 */   // Label 3204: @168808
     /*  168808 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(168844), // Rule ID 65372 //
     /*  168813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  168816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168823 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  168826 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  168828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168842 */     GIR_RootConstrainSelectedInstOperands,
     /*  168843 */     // GIR_Coverage, 65372,
     /*  168843 */     GIR_EraseRootFromParent_Done,
     /*  168844 */   // Label 3205: @168844
     /*  168844 */   GIM_Reject,
     /*  168845 */ // Label 3203: @168845
     /*  168845 */ GIM_Reject,
     /*  168846 */ // Label 3169: @168846
     /*  168846 */ GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(168939),
     /*  168851 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168854 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  168858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168862 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168866 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(168902), // Rule ID 65367 //
     /*  168871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  168874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168881 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  168884 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  168886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168900 */     GIR_RootConstrainSelectedInstOperands,
     /*  168901 */     // GIR_Coverage, 65367,
     /*  168901 */     GIR_EraseRootFromParent_Done,
     /*  168902 */   // Label 3207: @168902
     /*  168902 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(168938), // Rule ID 65371 //
     /*  168907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  168910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168917 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  168920 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  168922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168936 */     GIR_RootConstrainSelectedInstOperands,
     /*  168937 */     // GIR_Coverage, 65371,
     /*  168937 */     GIR_EraseRootFromParent_Done,
     /*  168938 */   // Label 3208: @168938
     /*  168938 */   GIM_Reject,
     /*  168939 */ // Label 3206: @168939
     /*  168939 */ GIM_Reject,
     /*  168940 */ // Label 3170: @168940
     /*  168940 */ GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(168994), // Rule ID 65385 //
     /*  168945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168948 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168951 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168962 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168966 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168973 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  168976 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  168978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168988 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168992 */   GIR_RootConstrainSelectedInstOperands,
     /*  168993 */   // GIR_Coverage, 65385,
     /*  168993 */   GIR_EraseRootFromParent_Done,
     /*  168994 */ // Label 3209: @168994
     /*  168994 */ GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(169048), // Rule ID 65386 //
     /*  168999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169002 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169005 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169016 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169020 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169027 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169030 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169042 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169046 */   GIR_RootConstrainSelectedInstOperands,
     /*  169047 */   // GIR_Coverage, 65386,
     /*  169047 */   GIR_EraseRootFromParent_Done,
     /*  169048 */ // Label 3210: @169048
     /*  169048 */ GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(169102), // Rule ID 65387 //
     /*  169053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  169056 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169059 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169070 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169074 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169081 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169084 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169096 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169100 */   GIR_RootConstrainSelectedInstOperands,
     /*  169101 */   // GIR_Coverage, 65387,
     /*  169101 */   GIR_EraseRootFromParent_Done,
     /*  169102 */ // Label 3211: @169102
     /*  169102 */ GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(169156), // Rule ID 65388 //
     /*  169107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169110 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169113 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169128 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169135 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169138 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169154 */   GIR_RootConstrainSelectedInstOperands,
     /*  169155 */   // GIR_Coverage, 65388,
     /*  169155 */   GIR_EraseRootFromParent_Done,
     /*  169156 */ // Label 3212: @169156
     /*  169156 */ GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(169207), // Rule ID 2152 //
     /*  169161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  169164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169167 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  169175 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169179 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169186 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  169189 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169201 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169205 */   GIR_RootConstrainSelectedInstOperands,
     /*  169206 */   // GIR_Coverage, 2152,
     /*  169206 */   GIR_EraseRootFromParent_Done,
     /*  169207 */ // Label 3213: @169207
     /*  169207 */ GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(169258), // Rule ID 2153 //
     /*  169212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  169215 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169218 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  169226 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169230 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169237 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  169240 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169247 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169252 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169256 */   GIR_RootConstrainSelectedInstOperands,
     /*  169257 */   // GIR_Coverage, 2153,
     /*  169257 */   GIR_EraseRootFromParent_Done,
     /*  169258 */ // Label 3214: @169258
     /*  169258 */ GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(169309), // Rule ID 2158 //
     /*  169263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  169266 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169269 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  169277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169281 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169288 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  169291 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169303 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169307 */   GIR_RootConstrainSelectedInstOperands,
     /*  169308 */   // GIR_Coverage, 2158,
     /*  169308 */   GIR_EraseRootFromParent_Done,
     /*  169309 */ // Label 3215: @169309
     /*  169309 */ GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(169360), // Rule ID 2159 //
     /*  169314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  169317 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169320 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  169328 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169332 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169339 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  169342 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169358 */   GIR_RootConstrainSelectedInstOperands,
     /*  169359 */   // GIR_Coverage, 2159,
     /*  169359 */   GIR_EraseRootFromParent_Done,
     /*  169360 */ // Label 3216: @169360
     /*  169360 */ GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(169411), // Rule ID 65375 //
     /*  169365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169371 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169379 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169383 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169390 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169393 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169405 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169409 */   GIR_RootConstrainSelectedInstOperands,
     /*  169410 */   // GIR_Coverage, 65375,
     /*  169410 */   GIR_EraseRootFromParent_Done,
     /*  169411 */ // Label 3217: @169411
     /*  169411 */ GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(169462), // Rule ID 65376 //
     /*  169416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169422 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169430 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169434 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169441 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169444 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169451 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169456 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169460 */   GIR_RootConstrainSelectedInstOperands,
     /*  169461 */   // GIR_Coverage, 65376,
     /*  169461 */   GIR_EraseRootFromParent_Done,
     /*  169462 */ // Label 3218: @169462
     /*  169462 */ GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(169520), // Rule ID 65379 //
     /*  169467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169470 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169473 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169477 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169488 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169492 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169499 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169502 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169514 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169518 */   GIR_RootConstrainSelectedInstOperands,
     /*  169519 */   // GIR_Coverage, 65379,
     /*  169519 */   GIR_EraseRootFromParent_Done,
     /*  169520 */ // Label 3219: @169520
     /*  169520 */ GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(169578), // Rule ID 65380 //
     /*  169525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169528 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169531 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169535 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169550 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169557 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169560 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169576 */   GIR_RootConstrainSelectedInstOperands,
     /*  169577 */   // GIR_Coverage, 65380,
     /*  169577 */   GIR_EraseRootFromParent_Done,
     /*  169578 */ // Label 3220: @169578
     /*  169578 */ GIM_Reject,
     /*  169579 */ // Label 3171: @169579
     /*  169579 */ GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(169636), // Rule ID 338 //
     /*  169584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169587 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169590 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169597 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  169600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169604 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169608 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169615 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10099>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169618 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169634 */   GIR_RootConstrainSelectedInstOperands,
     /*  169635 */   // GIR_Coverage, 338,
     /*  169635 */   GIR_EraseRootFromParent_Done,
     /*  169636 */ // Label 3221: @169636
     /*  169636 */ GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(169693), // Rule ID 340 //
     /*  169641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169644 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169647 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169654 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  169657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169661 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169665 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169672 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10101>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169675 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169677 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169687 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169691 */   GIR_RootConstrainSelectedInstOperands,
     /*  169692 */   // GIR_Coverage, 340,
     /*  169692 */   GIR_EraseRootFromParent_Done,
     /*  169693 */ // Label 3222: @169693
     /*  169693 */ GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(169750), // Rule ID 342 //
     /*  169698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169701 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169704 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169711 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  169714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169718 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169722 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169729 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10103>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169732 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169744 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169748 */   GIR_RootConstrainSelectedInstOperands,
     /*  169749 */   // GIR_Coverage, 342,
     /*  169749 */   GIR_EraseRootFromParent_Done,
     /*  169750 */ // Label 3223: @169750
     /*  169750 */ GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(169804), // Rule ID 65391 //
     /*  169755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  169758 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169761 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169772 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169776 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169783 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169786 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169802 */   GIR_RootConstrainSelectedInstOperands,
     /*  169803 */   // GIR_Coverage, 65391,
     /*  169803 */   GIR_EraseRootFromParent_Done,
     /*  169804 */ // Label 3224: @169804
     /*  169804 */ GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(169858), // Rule ID 65392 //
     /*  169809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  169812 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169815 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169826 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169830 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169837 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169840 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169856 */   GIR_RootConstrainSelectedInstOperands,
     /*  169857 */   // GIR_Coverage, 65392,
     /*  169857 */   GIR_EraseRootFromParent_Done,
     /*  169858 */ // Label 3225: @169858
     /*  169858 */ GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(169916), // Rule ID 249 //
     /*  169863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169866 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169869 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169873 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169884 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169888 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169895 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169898 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169914 */   GIR_RootConstrainSelectedInstOperands,
     /*  169915 */   // GIR_Coverage, 249,
     /*  169915 */   GIR_EraseRootFromParent_Done,
     /*  169916 */ // Label 3226: @169916
     /*  169916 */ GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(169974), // Rule ID 251 //
     /*  169921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169924 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169927 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169931 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169946 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169953 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169956 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169968 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169972 */   GIR_RootConstrainSelectedInstOperands,
     /*  169973 */   // GIR_Coverage, 251,
     /*  169973 */   GIR_EraseRootFromParent_Done,
     /*  169974 */ // Label 3227: @169974
     /*  169974 */ GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(170025), // Rule ID 252 //
     /*  169979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169985 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169993 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169997 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170004 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170007 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170019 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170023 */   GIR_RootConstrainSelectedInstOperands,
     /*  170024 */   // GIR_Coverage, 252,
     /*  170024 */   GIR_EraseRootFromParent_Done,
     /*  170025 */ // Label 3228: @170025
     /*  170025 */ GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(170076), // Rule ID 253 //
     /*  170030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  170033 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170036 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170044 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170048 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170055 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170058 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170060 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170065 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170070 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170074 */   GIR_RootConstrainSelectedInstOperands,
     /*  170075 */   // GIR_Coverage, 253,
     /*  170075 */   GIR_EraseRootFromParent_Done,
     /*  170076 */ // Label 3229: @170076
     /*  170076 */ GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(170127), // Rule ID 1439 //
     /*  170081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  170084 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170087 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  170095 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170099 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170106 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  170109 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170121 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170125 */   GIR_RootConstrainSelectedInstOperands,
     /*  170126 */   // GIR_Coverage, 1439,
     /*  170126 */   GIR_EraseRootFromParent_Done,
     /*  170127 */ // Label 3230: @170127
     /*  170127 */ GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(170178), // Rule ID 1440 //
     /*  170132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  170135 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170138 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  170146 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170150 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170157 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  170160 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170172 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170176 */   GIR_RootConstrainSelectedInstOperands,
     /*  170177 */   // GIR_Coverage, 1440,
     /*  170177 */   GIR_EraseRootFromParent_Done,
     /*  170178 */ // Label 3231: @170178
     /*  170178 */ GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(170229), // Rule ID 1445 //
     /*  170183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  170186 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170189 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  170197 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170201 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170208 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  170211 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170223 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170227 */   GIR_RootConstrainSelectedInstOperands,
     /*  170228 */   // GIR_Coverage, 1445,
     /*  170228 */   GIR_EraseRootFromParent_Done,
     /*  170229 */ // Label 3232: @170229
     /*  170229 */ GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(170280), // Rule ID 1446 //
     /*  170234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  170237 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170240 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  170248 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170252 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170259 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  170262 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170269 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170274 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170278 */   GIR_RootConstrainSelectedInstOperands,
     /*  170279 */   // GIR_Coverage, 1446,
     /*  170279 */   GIR_EraseRootFromParent_Done,
     /*  170280 */ // Label 3233: @170280
     /*  170280 */ GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(170338), // Rule ID 65397 //
     /*  170285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  170288 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170291 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170295 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170306 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170310 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170317 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170320 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170336 */   GIR_RootConstrainSelectedInstOperands,
     /*  170337 */   // GIR_Coverage, 65397,
     /*  170337 */   GIR_EraseRootFromParent_Done,
     /*  170338 */ // Label 3234: @170338
     /*  170338 */ GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(170396), // Rule ID 65398 //
     /*  170343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  170346 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170349 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170353 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170368 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170375 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170378 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170390 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170394 */   GIR_RootConstrainSelectedInstOperands,
     /*  170395 */   // GIR_Coverage, 65398,
     /*  170395 */   GIR_EraseRootFromParent_Done,
     /*  170396 */ // Label 3235: @170396
     /*  170396 */ GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(170454), // Rule ID 65399 //
     /*  170401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  170404 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170407 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170411 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170422 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170426 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170433 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170436 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170448 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170452 */   GIR_RootConstrainSelectedInstOperands,
     /*  170453 */   // GIR_Coverage, 65399,
     /*  170453 */   GIR_EraseRootFromParent_Done,
     /*  170454 */ // Label 3236: @170454
     /*  170454 */ GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(170512), // Rule ID 65400 //
     /*  170459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  170462 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170465 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170469 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170480 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170491 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170494 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170506 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170510 */   GIR_RootConstrainSelectedInstOperands,
     /*  170511 */   // GIR_Coverage, 65400,
     /*  170511 */   GIR_EraseRootFromParent_Done,
     /*  170512 */ // Label 3237: @170512
     /*  170512 */ GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(170558), // Rule ID 1118 //
     /*  170517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170520 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170523 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170530 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170537 */   // MIs[0] rs1
     /*  170537 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170545 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10603>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  170548 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170550 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170552 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170556 */   GIR_RootConstrainSelectedInstOperands,
     /*  170557 */   // GIR_Coverage, 1118,
     /*  170557 */   GIR_EraseRootFromParent_Done,
     /*  170558 */ // Label 3238: @170558
     /*  170558 */ GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(170604), // Rule ID 1120 //
     /*  170563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170566 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170569 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170576 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  170579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170583 */   // MIs[0] rs1
     /*  170583 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170591 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10605>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  170594 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170596 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170598 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170602 */   GIR_RootConstrainSelectedInstOperands,
     /*  170603 */   // GIR_Coverage, 1120,
     /*  170603 */   GIR_EraseRootFromParent_Done,
     /*  170604 */ // Label 3239: @170604
     /*  170604 */ GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(170650), // Rule ID 1122 //
     /*  170609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170612 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170615 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170622 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170629 */   // MIs[0] rs1
     /*  170629 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170637 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10607>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  170640 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170642 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170644 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170648 */   GIR_RootConstrainSelectedInstOperands,
     /*  170649 */   // GIR_Coverage, 1122,
     /*  170649 */   GIR_EraseRootFromParent_Done,
     /*  170650 */ // Label 3240: @170650
     /*  170650 */ GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(170696), // Rule ID 1124 //
     /*  170655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170658 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170661 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170668 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  170671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170675 */   // MIs[0] rs1
     /*  170675 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170683 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10609>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  170686 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170688 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170690 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170694 */   GIR_RootConstrainSelectedInstOperands,
     /*  170695 */   // GIR_Coverage, 1124,
     /*  170695 */   GIR_EraseRootFromParent_Done,
     /*  170696 */ // Label 3241: @170696
     /*  170696 */ GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(170742), // Rule ID 1126 //
     /*  170701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170704 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170707 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170714 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170721 */   // MIs[0] rs1
     /*  170721 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170729 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10611>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  170732 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170734 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170736 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170740 */   GIR_RootConstrainSelectedInstOperands,
     /*  170741 */   // GIR_Coverage, 1126,
     /*  170741 */   GIR_EraseRootFromParent_Done,
     /*  170742 */ // Label 3242: @170742
     /*  170742 */ GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(170788), // Rule ID 1128 //
     /*  170747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170750 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170753 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170760 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  170763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170767 */   // MIs[0] rs1
     /*  170767 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170775 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10613>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  170778 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170780 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170782 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170786 */   GIR_RootConstrainSelectedInstOperands,
     /*  170787 */   // GIR_Coverage, 1128,
     /*  170787 */   GIR_EraseRootFromParent_Done,
     /*  170788 */ // Label 3243: @170788
     /*  170788 */ GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(170834), // Rule ID 1146 //
     /*  170793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  170796 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170799 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  170806 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170813 */   // MIs[0] rs1
     /*  170813 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170821 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10627>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  170824 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170826 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170828 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170832 */   GIR_RootConstrainSelectedInstOperands,
     /*  170833 */   // GIR_Coverage, 1146,
     /*  170833 */   GIR_EraseRootFromParent_Done,
     /*  170834 */ // Label 3244: @170834
     /*  170834 */ GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(170880), // Rule ID 1148 //
     /*  170839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  170842 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170845 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  170852 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  170855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170859 */   // MIs[0] rs1
     /*  170859 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170867 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10629>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  170870 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170872 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170878 */   GIR_RootConstrainSelectedInstOperands,
     /*  170879 */   // GIR_Coverage, 1148,
     /*  170879 */   GIR_EraseRootFromParent_Done,
     /*  170880 */ // Label 3245: @170880
     /*  170880 */ GIM_Reject,
     /*  170881 */ // Label 3172: @170881
     /*  170881 */ GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(170938), // Rule ID 337 //
     /*  170886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  170889 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170892 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170899 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170917 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10099>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170920 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170932 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170936 */   GIR_RootConstrainSelectedInstOperands,
     /*  170937 */   // GIR_Coverage, 337,
     /*  170937 */   GIR_EraseRootFromParent_Done,
     /*  170938 */ // Label 3246: @170938
     /*  170938 */ GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(170995), // Rule ID 339 //
     /*  170943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  170946 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170949 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170956 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170963 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170967 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170974 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10101>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170977 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170989 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170993 */   GIR_RootConstrainSelectedInstOperands,
     /*  170994 */   // GIR_Coverage, 339,
     /*  170994 */   GIR_EraseRootFromParent_Done,
     /*  170995 */ // Label 3247: @170995
     /*  170995 */ GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(171052), // Rule ID 341 //
     /*  171000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  171003 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171006 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171013 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171020 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171024 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171031 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10103>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  171034 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171046 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171050 */   GIR_RootConstrainSelectedInstOperands,
     /*  171051 */   // GIR_Coverage, 341,
     /*  171051 */   GIR_EraseRootFromParent_Done,
     /*  171052 */ // Label 3248: @171052
     /*  171052 */ GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(171109), // Rule ID 352 //
     /*  171057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  171060 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171063 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171070 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171077 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171081 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171088 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10113>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171091 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171107 */   GIR_RootConstrainSelectedInstOperands,
     /*  171108 */   // GIR_Coverage, 352,
     /*  171108 */   GIR_EraseRootFromParent_Done,
     /*  171109 */ // Label 3249: @171109
     /*  171109 */ GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(171167), // Rule ID 248 //
     /*  171114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  171117 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171120 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171124 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171135 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171139 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171146 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  171149 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171161 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171165 */   GIR_RootConstrainSelectedInstOperands,
     /*  171166 */   // GIR_Coverage, 248,
     /*  171166 */   GIR_EraseRootFromParent_Done,
     /*  171167 */ // Label 3250: @171167
     /*  171167 */ GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(171225), // Rule ID 250 //
     /*  171172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  171175 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171178 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171182 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171193 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171197 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171204 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171207 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171219 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171223 */   GIR_RootConstrainSelectedInstOperands,
     /*  171224 */   // GIR_Coverage, 250,
     /*  171224 */   GIR_EraseRootFromParent_Done,
     /*  171225 */ // Label 3251: @171225
     /*  171225 */ GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(171283), // Rule ID 289 //
     /*  171230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  171233 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171236 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171240 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171251 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171255 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171262 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  171265 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171277 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171281 */   GIR_RootConstrainSelectedInstOperands,
     /*  171282 */   // GIR_Coverage, 289,
     /*  171282 */   GIR_EraseRootFromParent_Done,
     /*  171283 */ // Label 3252: @171283
     /*  171283 */ GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(171334), // Rule ID 290 //
     /*  171288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  171291 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171294 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171302 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171306 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171313 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171316 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171332 */   GIR_RootConstrainSelectedInstOperands,
     /*  171333 */   // GIR_Coverage, 290,
     /*  171333 */   GIR_EraseRootFromParent_Done,
     /*  171334 */ // Label 3253: @171334
     /*  171334 */ GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(171385), // Rule ID 1837 //
     /*  171339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  171342 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171345 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  171353 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171357 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171364 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  171367 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171379 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171383 */   GIR_RootConstrainSelectedInstOperands,
     /*  171384 */   // GIR_Coverage, 1837,
     /*  171384 */   GIR_EraseRootFromParent_Done,
     /*  171385 */ // Label 3254: @171385
     /*  171385 */ GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(171436), // Rule ID 1838 //
     /*  171390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  171393 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171396 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  171404 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171408 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171415 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  171418 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171434 */   GIR_RootConstrainSelectedInstOperands,
     /*  171435 */   // GIR_Coverage, 1838,
     /*  171435 */   GIR_EraseRootFromParent_Done,
     /*  171436 */ // Label 3255: @171436
     /*  171436 */ GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(171487), // Rule ID 1841 //
     /*  171441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  171444 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171447 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171455 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171459 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171466 */   // (st GPR:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171469 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171481 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171485 */   GIR_RootConstrainSelectedInstOperands,
     /*  171486 */   // GIR_Coverage, 1841,
     /*  171486 */   GIR_EraseRootFromParent_Done,
     /*  171487 */ // Label 3256: @171487
     /*  171487 */ GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(171538), // Rule ID 1846 //
     /*  171492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0),
     /*  171495 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171498 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  171506 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171510 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171517 */   // (st GPRPair:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD_RV32 GPRPair:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RV32),
     /*  171520 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171532 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171536 */   GIR_RootConstrainSelectedInstOperands,
     /*  171537 */   // GIR_Coverage, 1846,
     /*  171537 */   GIR_EraseRootFromParent_Done,
     /*  171538 */ // Label 3257: @171538
     /*  171538 */ GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(171589), // Rule ID 1847 //
     /*  171543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1),
     /*  171546 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171549 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  171557 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171561 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171568 */   // (st GPRPair:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD_RV32 GPRPair:{ *:[f64] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RV32),
     /*  171571 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171583 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171587 */   GIR_RootConstrainSelectedInstOperands,
     /*  171588 */   // GIR_Coverage, 1847,
     /*  171588 */   GIR_EraseRootFromParent_Done,
     /*  171589 */ // Label 3258: @171589
     /*  171589 */ GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(171635), // Rule ID 1117 //
     /*  171594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171597 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171600 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171607 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171614 */   // MIs[0] rs1
     /*  171614 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171622 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10603>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  171625 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171627 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171629 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171633 */   GIR_RootConstrainSelectedInstOperands,
     /*  171634 */   // GIR_Coverage, 1117,
     /*  171634 */   GIR_EraseRootFromParent_Done,
     /*  171635 */ // Label 3259: @171635
     /*  171635 */ GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(171681), // Rule ID 1119 //
     /*  171640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171643 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171646 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171653 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171660 */   // MIs[0] rs1
     /*  171660 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171668 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10605>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  171671 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171673 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171675 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171679 */   GIR_RootConstrainSelectedInstOperands,
     /*  171680 */   // GIR_Coverage, 1119,
     /*  171680 */   GIR_EraseRootFromParent_Done,
     /*  171681 */ // Label 3260: @171681
     /*  171681 */ GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(171727), // Rule ID 1121 //
     /*  171686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171689 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171692 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171699 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171706 */   // MIs[0] rs1
     /*  171706 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171714 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10607>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  171717 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171719 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171725 */   GIR_RootConstrainSelectedInstOperands,
     /*  171726 */   // GIR_Coverage, 1121,
     /*  171726 */   GIR_EraseRootFromParent_Done,
     /*  171727 */ // Label 3261: @171727
     /*  171727 */ GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(171773), // Rule ID 1123 //
     /*  171732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171735 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171738 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171745 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171752 */   // MIs[0] rs1
     /*  171752 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171760 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10609>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  171763 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171765 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171771 */   GIR_RootConstrainSelectedInstOperands,
     /*  171772 */   // GIR_Coverage, 1123,
     /*  171772 */   GIR_EraseRootFromParent_Done,
     /*  171773 */ // Label 3262: @171773
     /*  171773 */ GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(171819), // Rule ID 1125 //
     /*  171778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171781 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171784 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171791 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171798 */   // MIs[0] rs1
     /*  171798 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171806 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10611>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  171809 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171811 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171813 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171817 */   GIR_RootConstrainSelectedInstOperands,
     /*  171818 */   // GIR_Coverage, 1125,
     /*  171818 */   GIR_EraseRootFromParent_Done,
     /*  171819 */ // Label 3263: @171819
     /*  171819 */ GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(171865), // Rule ID 1127 //
     /*  171824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171827 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171830 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171837 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171844 */   // MIs[0] rs1
     /*  171844 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171852 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10613>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  171855 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171857 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171863 */   GIR_RootConstrainSelectedInstOperands,
     /*  171864 */   // GIR_Coverage, 1127,
     /*  171864 */   GIR_EraseRootFromParent_Done,
     /*  171865 */ // Label 3264: @171865
     /*  171865 */ GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(171911), // Rule ID 1145 //
     /*  171870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  171873 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171876 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171890 */   // MIs[0] rs1
     /*  171890 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171898 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10627>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  171901 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171903 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171905 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171909 */   GIR_RootConstrainSelectedInstOperands,
     /*  171910 */   // GIR_Coverage, 1145,
     /*  171910 */   GIR_EraseRootFromParent_Done,
     /*  171911 */ // Label 3265: @171911
     /*  171911 */ GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(171957), // Rule ID 1147 //
     /*  171916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  171919 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171922 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171929 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171936 */   // MIs[0] rs1
     /*  171936 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171944 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10629>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  171947 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171949 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171951 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171955 */   GIR_RootConstrainSelectedInstOperands,
     /*  171956 */   // GIR_Coverage, 1147,
     /*  171956 */   GIR_EraseRootFromParent_Done,
     /*  171957 */ // Label 3266: @171957
     /*  171957 */ GIM_Reject,
     /*  171958 */ // Label 3173: @171958
     /*  171958 */ GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(172037),
     /*  171963 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171966 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171974 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171982 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(172009), // Rule ID 45748 //
     /*  171987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171990 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  171990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  171993 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172007 */     GIR_RootConstrainSelectedInstOperands,
     /*  172008 */     // GIR_Coverage, 45748,
     /*  172008 */     GIR_EraseRootFromParent_Done,
     /*  172009 */   // Label 3268: @172009
     /*  172009 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(172036), // Rule ID 45749 //
     /*  172014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172017 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  172017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  172020 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172034 */     GIR_RootConstrainSelectedInstOperands,
     /*  172035 */     // GIR_Coverage, 45749,
     /*  172035 */     GIR_EraseRootFromParent_Done,
     /*  172036 */   // Label 3269: @172036
     /*  172036 */   GIM_Reject,
     /*  172037 */ // Label 3267: @172037
     /*  172037 */ GIM_Reject,
     /*  172038 */ // Label 3174: @172038
     /*  172038 */ GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(172125),
     /*  172043 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172046 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172054 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(172089), // Rule ID 45744 //
     /*  172059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172062 */     // MIs[0] rs1
     /*  172062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172070 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  172070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  172073 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172087 */     GIR_RootConstrainSelectedInstOperands,
     /*  172088 */     // GIR_Coverage, 45744,
     /*  172088 */     GIR_EraseRootFromParent_Done,
     /*  172089 */   // Label 3271: @172089
     /*  172089 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(172124), // Rule ID 45745 //
     /*  172094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172097 */     // MIs[0] rs1
     /*  172097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172105 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  172105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  172108 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172122 */     GIR_RootConstrainSelectedInstOperands,
     /*  172123 */     // GIR_Coverage, 45745,
     /*  172123 */     GIR_EraseRootFromParent_Done,
     /*  172124 */   // Label 3272: @172124
     /*  172124 */   GIM_Reject,
     /*  172125 */ // Label 3270: @172125
     /*  172125 */ GIM_Reject,
     /*  172126 */ // Label 3175: @172126
     /*  172126 */ GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(172283),
     /*  172131 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172134 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172142 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(172177), // Rule ID 45940 //
     /*  172147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172150 */     // MIs[0] rs1
     /*  172150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172158 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172161 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172175 */     GIR_RootConstrainSelectedInstOperands,
     /*  172176 */     // GIR_Coverage, 45940,
     /*  172176 */     GIR_EraseRootFromParent_Done,
     /*  172177 */   // Label 3274: @172177
     /*  172177 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(172212), // Rule ID 45941 //
     /*  172182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172185 */     // MIs[0] rs1
     /*  172185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172193 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172196 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172210 */     GIR_RootConstrainSelectedInstOperands,
     /*  172211 */     // GIR_Coverage, 45941,
     /*  172211 */     GIR_EraseRootFromParent_Done,
     /*  172212 */   // Label 3275: @172212
     /*  172212 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(172247), // Rule ID 46016 //
     /*  172217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  172220 */     // MIs[0] rs1
     /*  172220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172228 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172231 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172245 */     GIR_RootConstrainSelectedInstOperands,
     /*  172246 */     // GIR_Coverage, 46016,
     /*  172246 */     GIR_EraseRootFromParent_Done,
     /*  172247 */   // Label 3276: @172247
     /*  172247 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(172282), // Rule ID 46017 //
     /*  172252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  172255 */     // MIs[0] rs1
     /*  172255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172263 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172266 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172280 */     GIR_RootConstrainSelectedInstOperands,
     /*  172281 */     // GIR_Coverage, 46017,
     /*  172281 */     GIR_EraseRootFromParent_Done,
     /*  172282 */   // Label 3277: @172282
     /*  172282 */   GIM_Reject,
     /*  172283 */ // Label 3273: @172283
     /*  172283 */ GIM_Reject,
     /*  172284 */ // Label 3176: @172284
     /*  172284 */ GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(172441),
     /*  172289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172292 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172300 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(172335), // Rule ID 45948 //
     /*  172305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172308 */     // MIs[0] rs1
     /*  172308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172316 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  172316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172319 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172333 */     GIR_RootConstrainSelectedInstOperands,
     /*  172334 */     // GIR_Coverage, 45948,
     /*  172334 */     GIR_EraseRootFromParent_Done,
     /*  172335 */   // Label 3279: @172335
     /*  172335 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(172370), // Rule ID 45949 //
     /*  172340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172343 */     // MIs[0] rs1
     /*  172343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172351 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  172351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172354 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172368 */     GIR_RootConstrainSelectedInstOperands,
     /*  172369 */     // GIR_Coverage, 45949,
     /*  172369 */     GIR_EraseRootFromParent_Done,
     /*  172370 */   // Label 3280: @172370
     /*  172370 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(172405), // Rule ID 46024 //
     /*  172375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  172378 */     // MIs[0] rs1
     /*  172378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172386 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  172386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172389 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172403 */     GIR_RootConstrainSelectedInstOperands,
     /*  172404 */     // GIR_Coverage, 46024,
     /*  172404 */     GIR_EraseRootFromParent_Done,
     /*  172405 */   // Label 3281: @172405
     /*  172405 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(172440), // Rule ID 46025 //
     /*  172410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  172413 */     // MIs[0] rs1
     /*  172413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172421 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  172421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172424 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172438 */     GIR_RootConstrainSelectedInstOperands,
     /*  172439 */     // GIR_Coverage, 46025,
     /*  172439 */     GIR_EraseRootFromParent_Done,
     /*  172440 */   // Label 3282: @172440
     /*  172440 */   GIM_Reject,
     /*  172441 */ // Label 3278: @172441
     /*  172441 */ GIM_Reject,
     /*  172442 */ // Label 3177: @172442
     /*  172442 */ GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(172599),
     /*  172447 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172450 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172458 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(172493), // Rule ID 45964 //
     /*  172463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  172466 */     // MIs[0] rs1
     /*  172466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172474 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  172474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172477 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172491 */     GIR_RootConstrainSelectedInstOperands,
     /*  172492 */     // GIR_Coverage, 45964,
     /*  172492 */     GIR_EraseRootFromParent_Done,
     /*  172493 */   // Label 3284: @172493
     /*  172493 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(172528), // Rule ID 45965 //
     /*  172498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  172501 */     // MIs[0] rs1
     /*  172501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172509 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  172509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172512 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172526 */     GIR_RootConstrainSelectedInstOperands,
     /*  172527 */     // GIR_Coverage, 45965,
     /*  172527 */     GIR_EraseRootFromParent_Done,
     /*  172528 */   // Label 3285: @172528
     /*  172528 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(172563), // Rule ID 46036 //
     /*  172533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  172536 */     // MIs[0] rs1
     /*  172536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172544 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  172544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172547 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172561 */     GIR_RootConstrainSelectedInstOperands,
     /*  172562 */     // GIR_Coverage, 46036,
     /*  172562 */     GIR_EraseRootFromParent_Done,
     /*  172563 */   // Label 3286: @172563
     /*  172563 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(172598), // Rule ID 46037 //
     /*  172568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  172571 */     // MIs[0] rs1
     /*  172571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172579 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  172579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172582 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172596 */     GIR_RootConstrainSelectedInstOperands,
     /*  172597 */     // GIR_Coverage, 46037,
     /*  172597 */     GIR_EraseRootFromParent_Done,
     /*  172598 */   // Label 3287: @172598
     /*  172598 */   GIM_Reject,
     /*  172599 */ // Label 3283: @172599
     /*  172599 */ GIM_Reject,
     /*  172600 */ // Label 3178: @172600
     /*  172600 */ GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(172679),
     /*  172605 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172608 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172616 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  172620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172624 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(172651), // Rule ID 46076 //
     /*  172629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172632 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  172632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  172635 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172649 */     GIR_RootConstrainSelectedInstOperands,
     /*  172650 */     // GIR_Coverage, 46076,
     /*  172650 */     GIR_EraseRootFromParent_Done,
     /*  172651 */   // Label 3289: @172651
     /*  172651 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(172678), // Rule ID 46077 //
     /*  172656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172659 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  172659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  172662 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172676 */     GIR_RootConstrainSelectedInstOperands,
     /*  172677 */     // GIR_Coverage, 46077,
     /*  172677 */     GIR_EraseRootFromParent_Done,
     /*  172678 */   // Label 3290: @172678
     /*  172678 */   GIM_Reject,
     /*  172679 */ // Label 3288: @172679
     /*  172679 */ GIM_Reject,
     /*  172680 */ // Label 3179: @172680
     /*  172680 */ GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(172767),
     /*  172685 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172688 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172696 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(172731), // Rule ID 45932 //
     /*  172701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172704 */     // MIs[0] rs1
     /*  172704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172712 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  172712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  172715 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172729 */     GIR_RootConstrainSelectedInstOperands,
     /*  172730 */     // GIR_Coverage, 45932,
     /*  172730 */     GIR_EraseRootFromParent_Done,
     /*  172731 */   // Label 3292: @172731
     /*  172731 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(172766), // Rule ID 45933 //
     /*  172736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172739 */     // MIs[0] rs1
     /*  172739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172747 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  172747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  172750 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172764 */     GIR_RootConstrainSelectedInstOperands,
     /*  172765 */     // GIR_Coverage, 45933,
     /*  172765 */     GIR_EraseRootFromParent_Done,
     /*  172766 */   // Label 3293: @172766
     /*  172766 */   GIM_Reject,
     /*  172767 */ // Label 3291: @172767
     /*  172767 */ GIM_Reject,
     /*  172768 */ // Label 3180: @172768
     /*  172768 */ GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(172925),
     /*  172773 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172776 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172784 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(172819), // Rule ID 45944 //
     /*  172789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172792 */     // MIs[0] rs1
     /*  172792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172800 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  172803 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172817 */     GIR_RootConstrainSelectedInstOperands,
     /*  172818 */     // GIR_Coverage, 45944,
     /*  172818 */     GIR_EraseRootFromParent_Done,
     /*  172819 */   // Label 3295: @172819
     /*  172819 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(172854), // Rule ID 45945 //
     /*  172824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172827 */     // MIs[0] rs1
     /*  172827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172835 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  172838 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172852 */     GIR_RootConstrainSelectedInstOperands,
     /*  172853 */     // GIR_Coverage, 45945,
     /*  172853 */     GIR_EraseRootFromParent_Done,
     /*  172854 */   // Label 3296: @172854
     /*  172854 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(172889), // Rule ID 46020 //
     /*  172859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  172862 */     // MIs[0] rs1
     /*  172862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172870 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  172873 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172887 */     GIR_RootConstrainSelectedInstOperands,
     /*  172888 */     // GIR_Coverage, 46020,
     /*  172888 */     GIR_EraseRootFromParent_Done,
     /*  172889 */   // Label 3297: @172889
     /*  172889 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(172924), // Rule ID 46021 //
     /*  172894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  172897 */     // MIs[0] rs1
     /*  172897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172905 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  172908 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172922 */     GIR_RootConstrainSelectedInstOperands,
     /*  172923 */     // GIR_Coverage, 46021,
     /*  172923 */     GIR_EraseRootFromParent_Done,
     /*  172924 */   // Label 3298: @172924
     /*  172924 */   GIM_Reject,
     /*  172925 */ // Label 3294: @172925
     /*  172925 */ GIM_Reject,
     /*  172926 */ // Label 3181: @172926
     /*  172926 */ GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(173083),
     /*  172931 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172934 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172942 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(172977), // Rule ID 45960 //
     /*  172947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172950 */     // MIs[0] rs1
     /*  172950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172958 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  172958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  172961 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172975 */     GIR_RootConstrainSelectedInstOperands,
     /*  172976 */     // GIR_Coverage, 45960,
     /*  172976 */     GIR_EraseRootFromParent_Done,
     /*  172977 */   // Label 3300: @172977
     /*  172977 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(173012), // Rule ID 45961 //
     /*  172982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172985 */     // MIs[0] rs1
     /*  172985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172993 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  172993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  172996 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173010 */     GIR_RootConstrainSelectedInstOperands,
     /*  173011 */     // GIR_Coverage, 45961,
     /*  173011 */     GIR_EraseRootFromParent_Done,
     /*  173012 */   // Label 3301: @173012
     /*  173012 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(173047), // Rule ID 46032 //
     /*  173017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  173020 */     // MIs[0] rs1
     /*  173020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173028 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  173031 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173045 */     GIR_RootConstrainSelectedInstOperands,
     /*  173046 */     // GIR_Coverage, 46032,
     /*  173046 */     GIR_EraseRootFromParent_Done,
     /*  173047 */   // Label 3302: @173047
     /*  173047 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(173082), // Rule ID 46033 //
     /*  173052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  173055 */     // MIs[0] rs1
     /*  173055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173063 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  173066 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173080 */     GIR_RootConstrainSelectedInstOperands,
     /*  173081 */     // GIR_Coverage, 46033,
     /*  173081 */     GIR_EraseRootFromParent_Done,
     /*  173082 */   // Label 3303: @173082
     /*  173082 */   GIM_Reject,
     /*  173083 */ // Label 3299: @173083
     /*  173083 */ GIM_Reject,
     /*  173084 */ // Label 3182: @173084
     /*  173084 */ GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(173241),
     /*  173089 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173092 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  173100 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(173135), // Rule ID 46004 //
     /*  173105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  173108 */     // MIs[0] rs1
     /*  173108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173116 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173119 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173133 */     GIR_RootConstrainSelectedInstOperands,
     /*  173134 */     // GIR_Coverage, 46004,
     /*  173134 */     GIR_EraseRootFromParent_Done,
     /*  173135 */   // Label 3305: @173135
     /*  173135 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(173170), // Rule ID 46005 //
     /*  173140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  173143 */     // MIs[0] rs1
     /*  173143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173151 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173154 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173168 */     GIR_RootConstrainSelectedInstOperands,
     /*  173169 */     // GIR_Coverage, 46005,
     /*  173169 */     GIR_EraseRootFromParent_Done,
     /*  173170 */   // Label 3306: @173170
     /*  173170 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(173205), // Rule ID 46064 //
     /*  173175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  173178 */     // MIs[0] rs1
     /*  173178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173186 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173189 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173203 */     GIR_RootConstrainSelectedInstOperands,
     /*  173204 */     // GIR_Coverage, 46064,
     /*  173204 */     GIR_EraseRootFromParent_Done,
     /*  173205 */   // Label 3307: @173205
     /*  173205 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(173240), // Rule ID 46065 //
     /*  173210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  173213 */     // MIs[0] rs1
     /*  173213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173221 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173224 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173238 */     GIR_RootConstrainSelectedInstOperands,
     /*  173239 */     // GIR_Coverage, 46065,
     /*  173239 */     GIR_EraseRootFromParent_Done,
     /*  173240 */   // Label 3308: @173240
     /*  173240 */   GIM_Reject,
     /*  173241 */ // Label 3304: @173241
     /*  173241 */ GIM_Reject,
     /*  173242 */ // Label 3183: @173242
     /*  173242 */ GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(173321),
     /*  173247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173266 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(173293), // Rule ID 46080 //
     /*  173271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173274 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  173274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  173277 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173291 */     GIR_RootConstrainSelectedInstOperands,
     /*  173292 */     // GIR_Coverage, 46080,
     /*  173292 */     GIR_EraseRootFromParent_Done,
     /*  173293 */   // Label 3310: @173293
     /*  173293 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(173320), // Rule ID 46081 //
     /*  173298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173301 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  173301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  173304 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173318 */     GIR_RootConstrainSelectedInstOperands,
     /*  173319 */     // GIR_Coverage, 46081,
     /*  173319 */     GIR_EraseRootFromParent_Done,
     /*  173320 */   // Label 3311: @173320
     /*  173320 */   GIM_Reject,
     /*  173321 */ // Label 3309: @173321
     /*  173321 */ GIM_Reject,
     /*  173322 */ // Label 3184: @173322
     /*  173322 */ GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(173409),
     /*  173327 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173330 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173338 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(173373), // Rule ID 45936 //
     /*  173343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173346 */     // MIs[0] rs1
     /*  173346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173354 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  173354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  173357 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173371 */     GIR_RootConstrainSelectedInstOperands,
     /*  173372 */     // GIR_Coverage, 45936,
     /*  173372 */     GIR_EraseRootFromParent_Done,
     /*  173373 */   // Label 3313: @173373
     /*  173373 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(173408), // Rule ID 45937 //
     /*  173378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173381 */     // MIs[0] rs1
     /*  173381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173389 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  173389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  173392 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173406 */     GIR_RootConstrainSelectedInstOperands,
     /*  173407 */     // GIR_Coverage, 45937,
     /*  173407 */     GIR_EraseRootFromParent_Done,
     /*  173408 */   // Label 3314: @173408
     /*  173408 */   GIM_Reject,
     /*  173409 */ // Label 3312: @173409
     /*  173409 */ GIM_Reject,
     /*  173410 */ // Label 3185: @173410
     /*  173410 */ GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(173567),
     /*  173415 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173418 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173426 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(173461), // Rule ID 45956 //
     /*  173431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173434 */     // MIs[0] rs1
     /*  173434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173442 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173445 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173459 */     GIR_RootConstrainSelectedInstOperands,
     /*  173460 */     // GIR_Coverage, 45956,
     /*  173460 */     GIR_EraseRootFromParent_Done,
     /*  173461 */   // Label 3316: @173461
     /*  173461 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(173496), // Rule ID 45957 //
     /*  173466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173469 */     // MIs[0] rs1
     /*  173469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173477 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  173477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173480 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173494 */     GIR_RootConstrainSelectedInstOperands,
     /*  173495 */     // GIR_Coverage, 45957,
     /*  173495 */     GIR_EraseRootFromParent_Done,
     /*  173496 */   // Label 3317: @173496
     /*  173496 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(173531), // Rule ID 46028 //
     /*  173501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  173504 */     // MIs[0] rs1
     /*  173504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173512 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173515 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173529 */     GIR_RootConstrainSelectedInstOperands,
     /*  173530 */     // GIR_Coverage, 46028,
     /*  173530 */     GIR_EraseRootFromParent_Done,
     /*  173531 */   // Label 3318: @173531
     /*  173531 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(173566), // Rule ID 46029 //
     /*  173536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  173539 */     // MIs[0] rs1
     /*  173539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173547 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  173547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173550 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173564 */     GIR_RootConstrainSelectedInstOperands,
     /*  173565 */     // GIR_Coverage, 46029,
     /*  173565 */     GIR_EraseRootFromParent_Done,
     /*  173566 */   // Label 3319: @173566
     /*  173566 */   GIM_Reject,
     /*  173567 */ // Label 3315: @173567
     /*  173567 */ GIM_Reject,
     /*  173568 */ // Label 3186: @173568
     /*  173568 */ GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(173725),
     /*  173573 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173576 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  173584 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(173619), // Rule ID 45992 //
     /*  173589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173592 */     // MIs[0] rs1
     /*  173592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173600 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  173603 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173617 */     GIR_RootConstrainSelectedInstOperands,
     /*  173618 */     // GIR_Coverage, 45992,
     /*  173618 */     GIR_EraseRootFromParent_Done,
     /*  173619 */   // Label 3321: @173619
     /*  173619 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(173654), // Rule ID 45993 //
     /*  173624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173627 */     // MIs[0] rs1
     /*  173627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173635 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  173638 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173652 */     GIR_RootConstrainSelectedInstOperands,
     /*  173653 */     // GIR_Coverage, 45993,
     /*  173653 */     GIR_EraseRootFromParent_Done,
     /*  173654 */   // Label 3322: @173654
     /*  173654 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(173689), // Rule ID 46052 //
     /*  173659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  173662 */     // MIs[0] rs1
     /*  173662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173670 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  173673 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173687 */     GIR_RootConstrainSelectedInstOperands,
     /*  173688 */     // GIR_Coverage, 46052,
     /*  173688 */     GIR_EraseRootFromParent_Done,
     /*  173689 */   // Label 3323: @173689
     /*  173689 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(173724), // Rule ID 46053 //
     /*  173694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  173697 */     // MIs[0] rs1
     /*  173697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173705 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  173708 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173722 */     GIR_RootConstrainSelectedInstOperands,
     /*  173723 */     // GIR_Coverage, 46053,
     /*  173723 */     GIR_EraseRootFromParent_Done,
     /*  173724 */   // Label 3324: @173724
     /*  173724 */   GIM_Reject,
     /*  173725 */ // Label 3320: @173725
     /*  173725 */ GIM_Reject,
     /*  173726 */ // Label 3187: @173726
     /*  173726 */ GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(173883),
     /*  173731 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173734 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  173742 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(173777), // Rule ID 46008 //
     /*  173747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  173750 */     // MIs[0] rs1
     /*  173750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173758 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  173761 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173775 */     GIR_RootConstrainSelectedInstOperands,
     /*  173776 */     // GIR_Coverage, 46008,
     /*  173776 */     GIR_EraseRootFromParent_Done,
     /*  173777 */   // Label 3326: @173777
     /*  173777 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(173812), // Rule ID 46009 //
     /*  173782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  173785 */     // MIs[0] rs1
     /*  173785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173793 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  173796 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173810 */     GIR_RootConstrainSelectedInstOperands,
     /*  173811 */     // GIR_Coverage, 46009,
     /*  173811 */     GIR_EraseRootFromParent_Done,
     /*  173812 */   // Label 3327: @173812
     /*  173812 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(173847), // Rule ID 46068 //
     /*  173817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  173820 */     // MIs[0] rs1
     /*  173820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173828 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  173831 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173845 */     GIR_RootConstrainSelectedInstOperands,
     /*  173846 */     // GIR_Coverage, 46068,
     /*  173846 */     GIR_EraseRootFromParent_Done,
     /*  173847 */   // Label 3328: @173847
     /*  173847 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(173882), // Rule ID 46069 //
     /*  173852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  173855 */     // MIs[0] rs1
     /*  173855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173863 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  173866 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173880 */     GIR_RootConstrainSelectedInstOperands,
     /*  173881 */     // GIR_Coverage, 46069,
     /*  173881 */     GIR_EraseRootFromParent_Done,
     /*  173882 */   // Label 3329: @173882
     /*  173882 */   GIM_Reject,
     /*  173883 */ // Label 3325: @173883
     /*  173883 */ GIM_Reject,
     /*  173884 */ // Label 3188: @173884
     /*  173884 */ GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(173963),
     /*  173889 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173892 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173900 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173908 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(173935), // Rule ID 46084 //
     /*  173913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173916 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  173916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  173919 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173933 */     GIR_RootConstrainSelectedInstOperands,
     /*  173934 */     // GIR_Coverage, 46084,
     /*  173934 */     GIR_EraseRootFromParent_Done,
     /*  173935 */   // Label 3331: @173935
     /*  173935 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(173962), // Rule ID 46085 //
     /*  173940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173943 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  173943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  173946 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173960 */     GIR_RootConstrainSelectedInstOperands,
     /*  173961 */     // GIR_Coverage, 46085,
     /*  173961 */     GIR_EraseRootFromParent_Done,
     /*  173962 */   // Label 3332: @173962
     /*  173962 */   GIM_Reject,
     /*  173963 */ // Label 3330: @173963
     /*  173963 */ GIM_Reject,
     /*  173964 */ // Label 3189: @173964
     /*  173964 */ GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(174051),
     /*  173969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173972 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173980 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(174015), // Rule ID 45952 //
     /*  173985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173988 */     // MIs[0] rs1
     /*  173988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173996 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  173996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  173999 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174013 */     GIR_RootConstrainSelectedInstOperands,
     /*  174014 */     // GIR_Coverage, 45952,
     /*  174014 */     GIR_EraseRootFromParent_Done,
     /*  174015 */   // Label 3334: @174015
     /*  174015 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(174050), // Rule ID 45953 //
     /*  174020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174023 */     // MIs[0] rs1
     /*  174023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174031 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  174031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  174034 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174048 */     GIR_RootConstrainSelectedInstOperands,
     /*  174049 */     // GIR_Coverage, 45953,
     /*  174049 */     GIR_EraseRootFromParent_Done,
     /*  174050 */   // Label 3335: @174050
     /*  174050 */   GIM_Reject,
     /*  174051 */ // Label 3333: @174051
     /*  174051 */ GIM_Reject,
     /*  174052 */ // Label 3190: @174052
     /*  174052 */ GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(174209),
     /*  174057 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174060 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174068 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(174103), // Rule ID 45980 //
     /*  174073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174076 */     // MIs[0] rs1
     /*  174076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174084 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174087 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174101 */     GIR_RootConstrainSelectedInstOperands,
     /*  174102 */     // GIR_Coverage, 45980,
     /*  174102 */     GIR_EraseRootFromParent_Done,
     /*  174103 */   // Label 3337: @174103
     /*  174103 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(174138), // Rule ID 45981 //
     /*  174108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174111 */     // MIs[0] rs1
     /*  174111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174119 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174122 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174136 */     GIR_RootConstrainSelectedInstOperands,
     /*  174137 */     // GIR_Coverage, 45981,
     /*  174137 */     GIR_EraseRootFromParent_Done,
     /*  174138 */   // Label 3338: @174138
     /*  174138 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(174173), // Rule ID 46040 //
     /*  174143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  174146 */     // MIs[0] rs1
     /*  174146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174154 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174157 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174171 */     GIR_RootConstrainSelectedInstOperands,
     /*  174172 */     // GIR_Coverage, 46040,
     /*  174172 */     GIR_EraseRootFromParent_Done,
     /*  174173 */   // Label 3339: @174173
     /*  174173 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(174208), // Rule ID 46041 //
     /*  174178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  174181 */     // MIs[0] rs1
     /*  174181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174189 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174192 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174206 */     GIR_RootConstrainSelectedInstOperands,
     /*  174207 */     // GIR_Coverage, 46041,
     /*  174207 */     GIR_EraseRootFromParent_Done,
     /*  174208 */   // Label 3340: @174208
     /*  174208 */   GIM_Reject,
     /*  174209 */ // Label 3336: @174209
     /*  174209 */ GIM_Reject,
     /*  174210 */ // Label 3191: @174210
     /*  174210 */ GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(174367),
     /*  174215 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174218 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174226 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(174261), // Rule ID 45996 //
     /*  174231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174234 */     // MIs[0] rs1
     /*  174234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174242 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174245 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174259 */     GIR_RootConstrainSelectedInstOperands,
     /*  174260 */     // GIR_Coverage, 45996,
     /*  174260 */     GIR_EraseRootFromParent_Done,
     /*  174261 */   // Label 3342: @174261
     /*  174261 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(174296), // Rule ID 45997 //
     /*  174266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174269 */     // MIs[0] rs1
     /*  174269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174277 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174280 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174294 */     GIR_RootConstrainSelectedInstOperands,
     /*  174295 */     // GIR_Coverage, 45997,
     /*  174295 */     GIR_EraseRootFromParent_Done,
     /*  174296 */   // Label 3343: @174296
     /*  174296 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(174331), // Rule ID 46056 //
     /*  174301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  174304 */     // MIs[0] rs1
     /*  174304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174312 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174315 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174329 */     GIR_RootConstrainSelectedInstOperands,
     /*  174330 */     // GIR_Coverage, 46056,
     /*  174330 */     GIR_EraseRootFromParent_Done,
     /*  174331 */   // Label 3344: @174331
     /*  174331 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(174366), // Rule ID 46057 //
     /*  174336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  174339 */     // MIs[0] rs1
     /*  174339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174347 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174350 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174364 */     GIR_RootConstrainSelectedInstOperands,
     /*  174365 */     // GIR_Coverage, 46057,
     /*  174365 */     GIR_EraseRootFromParent_Done,
     /*  174366 */   // Label 3345: @174366
     /*  174366 */   GIM_Reject,
     /*  174367 */ // Label 3341: @174367
     /*  174367 */ GIM_Reject,
     /*  174368 */ // Label 3192: @174368
     /*  174368 */ GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(174525),
     /*  174373 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174376 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174384 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(174419), // Rule ID 46012 //
     /*  174389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  174392 */     // MIs[0] rs1
     /*  174392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174400 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  174400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174403 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174417 */     GIR_RootConstrainSelectedInstOperands,
     /*  174418 */     // GIR_Coverage, 46012,
     /*  174418 */     GIR_EraseRootFromParent_Done,
     /*  174419 */   // Label 3347: @174419
     /*  174419 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(174454), // Rule ID 46013 //
     /*  174424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  174427 */     // MIs[0] rs1
     /*  174427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174435 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  174435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174438 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174452 */     GIR_RootConstrainSelectedInstOperands,
     /*  174453 */     // GIR_Coverage, 46013,
     /*  174453 */     GIR_EraseRootFromParent_Done,
     /*  174454 */   // Label 3348: @174454
     /*  174454 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(174489), // Rule ID 46072 //
     /*  174459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  174462 */     // MIs[0] rs1
     /*  174462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174470 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  174470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174473 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174487 */     GIR_RootConstrainSelectedInstOperands,
     /*  174488 */     // GIR_Coverage, 46072,
     /*  174488 */     GIR_EraseRootFromParent_Done,
     /*  174489 */   // Label 3349: @174489
     /*  174489 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(174524), // Rule ID 46073 //
     /*  174494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  174497 */     // MIs[0] rs1
     /*  174497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174505 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  174505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174508 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174522 */     GIR_RootConstrainSelectedInstOperands,
     /*  174523 */     // GIR_Coverage, 46073,
     /*  174523 */     GIR_EraseRootFromParent_Done,
     /*  174524 */   // Label 3350: @174524
     /*  174524 */   GIM_Reject,
     /*  174525 */ // Label 3346: @174525
     /*  174525 */ GIM_Reject,
     /*  174526 */ // Label 3193: @174526
     /*  174526 */ GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(174605),
     /*  174531 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174534 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174542 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174550 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(174577), // Rule ID 46088 //
     /*  174555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174558 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  174558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  174561 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174575 */     GIR_RootConstrainSelectedInstOperands,
     /*  174576 */     // GIR_Coverage, 46088,
     /*  174576 */     GIR_EraseRootFromParent_Done,
     /*  174577 */   // Label 3352: @174577
     /*  174577 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(174604), // Rule ID 46089 //
     /*  174582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174585 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  174585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  174588 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174602 */     GIR_RootConstrainSelectedInstOperands,
     /*  174603 */     // GIR_Coverage, 46089,
     /*  174603 */     GIR_EraseRootFromParent_Done,
     /*  174604 */   // Label 3353: @174604
     /*  174604 */   GIM_Reject,
     /*  174605 */ // Label 3351: @174605
     /*  174605 */ GIM_Reject,
     /*  174606 */ // Label 3194: @174606
     /*  174606 */ GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(174693),
     /*  174611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174614 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174622 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(174657), // Rule ID 45968 //
     /*  174627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174630 */     // MIs[0] rs1
     /*  174630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174638 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  174638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  174641 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174655 */     GIR_RootConstrainSelectedInstOperands,
     /*  174656 */     // GIR_Coverage, 45968,
     /*  174656 */     GIR_EraseRootFromParent_Done,
     /*  174657 */   // Label 3355: @174657
     /*  174657 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(174692), // Rule ID 45969 //
     /*  174662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174665 */     // MIs[0] rs1
     /*  174665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174673 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  174673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  174676 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174690 */     GIR_RootConstrainSelectedInstOperands,
     /*  174691 */     // GIR_Coverage, 45969,
     /*  174691 */     GIR_EraseRootFromParent_Done,
     /*  174692 */   // Label 3356: @174692
     /*  174692 */   GIM_Reject,
     /*  174693 */ // Label 3354: @174693
     /*  174693 */ GIM_Reject,
     /*  174694 */ // Label 3195: @174694
     /*  174694 */ GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(174851),
     /*  174699 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174702 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174710 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(174745), // Rule ID 45984 //
     /*  174715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174718 */     // MIs[0] rs1
     /*  174718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174726 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  174729 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174743 */     GIR_RootConstrainSelectedInstOperands,
     /*  174744 */     // GIR_Coverage, 45984,
     /*  174744 */     GIR_EraseRootFromParent_Done,
     /*  174745 */   // Label 3358: @174745
     /*  174745 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(174780), // Rule ID 45985 //
     /*  174750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174753 */     // MIs[0] rs1
     /*  174753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174761 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  174764 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174778 */     GIR_RootConstrainSelectedInstOperands,
     /*  174779 */     // GIR_Coverage, 45985,
     /*  174779 */     GIR_EraseRootFromParent_Done,
     /*  174780 */   // Label 3359: @174780
     /*  174780 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(174815), // Rule ID 46044 //
     /*  174785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  174788 */     // MIs[0] rs1
     /*  174788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174796 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  174799 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174813 */     GIR_RootConstrainSelectedInstOperands,
     /*  174814 */     // GIR_Coverage, 46044,
     /*  174814 */     GIR_EraseRootFromParent_Done,
     /*  174815 */   // Label 3360: @174815
     /*  174815 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(174850), // Rule ID 46045 //
     /*  174820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  174823 */     // MIs[0] rs1
     /*  174823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174831 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  174834 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174848 */     GIR_RootConstrainSelectedInstOperands,
     /*  174849 */     // GIR_Coverage, 46045,
     /*  174849 */     GIR_EraseRootFromParent_Done,
     /*  174850 */   // Label 3361: @174850
     /*  174850 */   GIM_Reject,
     /*  174851 */ // Label 3357: @174851
     /*  174851 */ GIM_Reject,
     /*  174852 */ // Label 3196: @174852
     /*  174852 */ GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(175009),
     /*  174857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174868 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(174903), // Rule ID 46000 //
     /*  174873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174876 */     // MIs[0] rs1
     /*  174876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174884 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  174887 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174901 */     GIR_RootConstrainSelectedInstOperands,
     /*  174902 */     // GIR_Coverage, 46000,
     /*  174902 */     GIR_EraseRootFromParent_Done,
     /*  174903 */   // Label 3363: @174903
     /*  174903 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(174938), // Rule ID 46001 //
     /*  174908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174911 */     // MIs[0] rs1
     /*  174911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174919 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  174922 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174936 */     GIR_RootConstrainSelectedInstOperands,
     /*  174937 */     // GIR_Coverage, 46001,
     /*  174937 */     GIR_EraseRootFromParent_Done,
     /*  174938 */   // Label 3364: @174938
     /*  174938 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(174973), // Rule ID 46060 //
     /*  174943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  174946 */     // MIs[0] rs1
     /*  174946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174954 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  174957 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174971 */     GIR_RootConstrainSelectedInstOperands,
     /*  174972 */     // GIR_Coverage, 46060,
     /*  174972 */     GIR_EraseRootFromParent_Done,
     /*  174973 */   // Label 3365: @174973
     /*  174973 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(175008), // Rule ID 46061 //
     /*  174978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  174981 */     // MIs[0] rs1
     /*  174981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174989 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  174992 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  175002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175006 */     GIR_RootConstrainSelectedInstOperands,
     /*  175007 */     // GIR_Coverage, 46061,
     /*  175007 */     GIR_EraseRootFromParent_Done,
     /*  175008 */   // Label 3366: @175008
     /*  175008 */   GIM_Reject,
     /*  175009 */ // Label 3362: @175009
     /*  175009 */ GIM_Reject,
     /*  175010 */ // Label 3197: @175010
     /*  175010 */ GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(175089),
     /*  175015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175034 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(175061), // Rule ID 46092 //
     /*  175039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175042 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  175042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  175045 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175059 */     GIR_RootConstrainSelectedInstOperands,
     /*  175060 */     // GIR_Coverage, 46092,
     /*  175060 */     GIR_EraseRootFromParent_Done,
     /*  175061 */   // Label 3368: @175061
     /*  175061 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(175088), // Rule ID 46093 //
     /*  175066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175069 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  175069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  175072 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175086 */     GIR_RootConstrainSelectedInstOperands,
     /*  175087 */     // GIR_Coverage, 46093,
     /*  175087 */     GIR_EraseRootFromParent_Done,
     /*  175088 */   // Label 3369: @175088
     /*  175088 */   GIM_Reject,
     /*  175089 */ // Label 3367: @175089
     /*  175089 */ GIM_Reject,
     /*  175090 */ // Label 3198: @175090
     /*  175090 */ GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(175177),
     /*  175095 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175098 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  175106 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(175141), // Rule ID 45972 //
     /*  175111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175114 */     // MIs[0] rs1
     /*  175114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175122 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  175122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  175125 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175139 */     GIR_RootConstrainSelectedInstOperands,
     /*  175140 */     // GIR_Coverage, 45972,
     /*  175140 */     GIR_EraseRootFromParent_Done,
     /*  175141 */   // Label 3371: @175141
     /*  175141 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(175176), // Rule ID 45973 //
     /*  175146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175149 */     // MIs[0] rs1
     /*  175149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175157 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  175157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  175160 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175174 */     GIR_RootConstrainSelectedInstOperands,
     /*  175175 */     // GIR_Coverage, 45973,
     /*  175175 */     GIR_EraseRootFromParent_Done,
     /*  175176 */   // Label 3372: @175176
     /*  175176 */   GIM_Reject,
     /*  175177 */ // Label 3370: @175177
     /*  175177 */ GIM_Reject,
     /*  175178 */ // Label 3199: @175178
     /*  175178 */ GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(175335),
     /*  175183 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175186 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  175194 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(175229), // Rule ID 45988 //
     /*  175199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175202 */     // MIs[0] rs1
     /*  175202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175210 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175213 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175227 */     GIR_RootConstrainSelectedInstOperands,
     /*  175228 */     // GIR_Coverage, 45988,
     /*  175228 */     GIR_EraseRootFromParent_Done,
     /*  175229 */   // Label 3374: @175229
     /*  175229 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(175264), // Rule ID 45989 //
     /*  175234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175237 */     // MIs[0] rs1
     /*  175237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175245 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  175245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175248 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175262 */     GIR_RootConstrainSelectedInstOperands,
     /*  175263 */     // GIR_Coverage, 45989,
     /*  175263 */     GIR_EraseRootFromParent_Done,
     /*  175264 */   // Label 3375: @175264
     /*  175264 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(175299), // Rule ID 46048 //
     /*  175269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  175272 */     // MIs[0] rs1
     /*  175272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175280 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175283 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175297 */     GIR_RootConstrainSelectedInstOperands,
     /*  175298 */     // GIR_Coverage, 46048,
     /*  175298 */     GIR_EraseRootFromParent_Done,
     /*  175299 */   // Label 3376: @175299
     /*  175299 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(175334), // Rule ID 46049 //
     /*  175304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  175307 */     // MIs[0] rs1
     /*  175307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175315 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  175315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175318 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175332 */     GIR_RootConstrainSelectedInstOperands,
     /*  175333 */     // GIR_Coverage, 46049,
     /*  175333 */     GIR_EraseRootFromParent_Done,
     /*  175334 */   // Label 3377: @175334
     /*  175334 */   GIM_Reject,
     /*  175335 */ // Label 3373: @175335
     /*  175335 */ GIM_Reject,
     /*  175336 */ // Label 3200: @175336
     /*  175336 */ GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(175415),
     /*  175341 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175344 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175352 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175360 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(175387), // Rule ID 46096 //
     /*  175365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175368 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  175368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  175371 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175385 */     GIR_RootConstrainSelectedInstOperands,
     /*  175386 */     // GIR_Coverage, 46096,
     /*  175386 */     GIR_EraseRootFromParent_Done,
     /*  175387 */   // Label 3379: @175387
     /*  175387 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(175414), // Rule ID 46097 //
     /*  175392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175395 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  175395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  175398 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175412 */     GIR_RootConstrainSelectedInstOperands,
     /*  175413 */     // GIR_Coverage, 46097,
     /*  175413 */     GIR_EraseRootFromParent_Done,
     /*  175414 */   // Label 3380: @175414
     /*  175414 */   GIM_Reject,
     /*  175415 */ // Label 3378: @175415
     /*  175415 */ GIM_Reject,
     /*  175416 */ // Label 3201: @175416
     /*  175416 */ GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(175503),
     /*  175421 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175424 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  175432 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(175467), // Rule ID 45976 //
     /*  175437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175440 */     // MIs[0] rs1
     /*  175440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175448 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  175448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  175451 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175465 */     GIR_RootConstrainSelectedInstOperands,
     /*  175466 */     // GIR_Coverage, 45976,
     /*  175466 */     GIR_EraseRootFromParent_Done,
     /*  175467 */   // Label 3382: @175467
     /*  175467 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(175502), // Rule ID 45977 //
     /*  175472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175475 */     // MIs[0] rs1
     /*  175475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175483 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  175483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  175486 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175500 */     GIR_RootConstrainSelectedInstOperands,
     /*  175501 */     // GIR_Coverage, 45977,
     /*  175501 */     GIR_EraseRootFromParent_Done,
     /*  175502 */   // Label 3383: @175502
     /*  175502 */   GIM_Reject,
     /*  175503 */ // Label 3381: @175503
     /*  175503 */ GIM_Reject,
     /*  175504 */ // Label 3202: @175504
     /*  175504 */ GIM_Reject,
     /*  175505 */ // Label 25: @175505
     /*  175505 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3386*/ GIMT_Encode4(180390),
     /*  175516 */ /*GILLT_s32*//*Label 3384*/ GIMT_Encode4(175524),
     /*  175520 */ /*GILLT_s64*//*Label 3385*/ GIMT_Encode4(177517),
     /*  175524 */ // Label 3384: @175524
     /*  175524 */ GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(177516),
     /*  175529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  175532 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  175535 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(175601), // Rule ID 655 //
     /*  175540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175543 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175550 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  175553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175557 */     // MIs[0] addr
     /*  175557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175573 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 2:{ *:[i32] })
     /*  175573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175581 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175586 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175588 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175590 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  175595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175599 */     GIR_RootConstrainSelectedInstOperands,
     /*  175600 */     // GIR_Coverage, 655,
     /*  175600 */     GIR_EraseRootFromParent_Done,
     /*  175601 */   // Label 3388: @175601
     /*  175601 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(175667), // Rule ID 657 //
     /*  175606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175609 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175616 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  175619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175623 */     // MIs[0] addr
     /*  175623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175639 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 4:{ *:[i32] })
     /*  175639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175647 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175652 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175654 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175656 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175665 */     GIR_RootConstrainSelectedInstOperands,
     /*  175666 */     // GIR_Coverage, 657,
     /*  175666 */     GIR_EraseRootFromParent_Done,
     /*  175667 */   // Label 3389: @175667
     /*  175667 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(175733), // Rule ID 659 //
     /*  175672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175675 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175682 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175689 */     // MIs[0] addr
     /*  175689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175705 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 5:{ *:[i32] })
     /*  175705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175713 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175718 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175720 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175722 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  175727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175731 */     GIR_RootConstrainSelectedInstOperands,
     /*  175732 */     // GIR_Coverage, 659,
     /*  175732 */     GIR_EraseRootFromParent_Done,
     /*  175733 */   // Label 3390: @175733
     /*  175733 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(175799), // Rule ID 661 //
     /*  175738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175741 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175748 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  175751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175755 */     // MIs[0] addr
     /*  175755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175771 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 6:{ *:[i32] })
     /*  175771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175779 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175784 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175786 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175788 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  175793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175797 */     GIR_RootConstrainSelectedInstOperands,
     /*  175798 */     // GIR_Coverage, 661,
     /*  175798 */     GIR_EraseRootFromParent_Done,
     /*  175799 */   // Label 3391: @175799
     /*  175799 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(175865), // Rule ID 663 //
     /*  175804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175807 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175814 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  175817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175821 */     // MIs[0] addr
     /*  175821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175837 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 7:{ *:[i32] })
     /*  175837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175845 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175850 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175852 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175854 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  175859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175863 */     GIR_RootConstrainSelectedInstOperands,
     /*  175864 */     // GIR_Coverage, 663,
     /*  175864 */     GIR_EraseRootFromParent_Done,
     /*  175865 */   // Label 3392: @175865
     /*  175865 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(175920), // Rule ID 672 //
     /*  175870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  175873 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175880 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  175883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175887 */     // MIs[0] addr
     /*  175887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175903 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  175906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175908 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175910 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175912 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175918 */     GIR_RootConstrainSelectedInstOperands,
     /*  175919 */     // GIR_Coverage, 672,
     /*  175919 */     GIR_EraseRootFromParent_Done,
     /*  175920 */   // Label 3393: @175920
     /*  175920 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(175975), // Rule ID 674 //
     /*  175925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  175928 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175935 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  175938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175942 */     // MIs[0] addr
     /*  175942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175958 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  175961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175963 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175965 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175967 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175973 */     GIR_RootConstrainSelectedInstOperands,
     /*  175974 */     // GIR_Coverage, 674,
     /*  175974 */     GIR_EraseRootFromParent_Done,
     /*  175975 */   // Label 3394: @175975
     /*  175975 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(176030), // Rule ID 676 //
     /*  175980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  175983 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175990 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175997 */     // MIs[0] addr
     /*  175997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176013 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  176016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176018 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176020 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176022 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176028 */     GIR_RootConstrainSelectedInstOperands,
     /*  176029 */     // GIR_Coverage, 676,
     /*  176029 */     GIR_EraseRootFromParent_Done,
     /*  176030 */   // Label 3395: @176030
     /*  176030 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(176085), // Rule ID 678 //
     /*  176035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176038 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176045 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176052 */     // MIs[0] addr
     /*  176052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176068 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  176071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176073 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176075 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176077 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176083 */     GIR_RootConstrainSelectedInstOperands,
     /*  176084 */     // GIR_Coverage, 678,
     /*  176084 */     GIR_EraseRootFromParent_Done,
     /*  176085 */   // Label 3396: @176085
     /*  176085 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(176140), // Rule ID 680 //
     /*  176090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176107 */     // MIs[0] addr
     /*  176107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176123 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  176126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176128 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176130 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176132 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176138 */     GIR_RootConstrainSelectedInstOperands,
     /*  176139 */     // GIR_Coverage, 680,
     /*  176139 */     GIR_EraseRootFromParent_Done,
     /*  176140 */   // Label 3397: @176140
     /*  176140 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(176195), // Rule ID 682 //
     /*  176145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176148 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176155 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176162 */     // MIs[0] addr
     /*  176162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176178 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176183 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176185 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176187 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176193 */     GIR_RootConstrainSelectedInstOperands,
     /*  176194 */     // GIR_Coverage, 682,
     /*  176194 */     GIR_EraseRootFromParent_Done,
     /*  176195 */   // Label 3398: @176195
     /*  176195 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(176250), // Rule ID 684 //
     /*  176200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176203 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176217 */     // MIs[0] addr
     /*  176217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176233 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176238 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176240 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176242 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176248 */     GIR_RootConstrainSelectedInstOperands,
     /*  176249 */     // GIR_Coverage, 684,
     /*  176249 */     GIR_EraseRootFromParent_Done,
     /*  176250 */   // Label 3399: @176250
     /*  176250 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(176305), // Rule ID 686 //
     /*  176255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176258 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176265 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176272 */     // MIs[0] addr
     /*  176272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176288 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176293 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176295 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176297 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176303 */     GIR_RootConstrainSelectedInstOperands,
     /*  176304 */     // GIR_Coverage, 686,
     /*  176304 */     GIR_EraseRootFromParent_Done,
     /*  176305 */   // Label 3400: @176305
     /*  176305 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(176360), // Rule ID 688 //
     /*  176310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176327 */     // MIs[0] addr
     /*  176327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176343 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176348 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176350 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176352 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176358 */     GIR_RootConstrainSelectedInstOperands,
     /*  176359 */     // GIR_Coverage, 688,
     /*  176359 */     GIR_EraseRootFromParent_Done,
     /*  176360 */   // Label 3401: @176360
     /*  176360 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(176415), // Rule ID 690 //
     /*  176365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176382 */     // MIs[0] addr
     /*  176382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176398 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176403 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176405 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176407 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176413 */     GIR_RootConstrainSelectedInstOperands,
     /*  176414 */     // GIR_Coverage, 690,
     /*  176414 */     GIR_EraseRootFromParent_Done,
     /*  176415 */   // Label 3402: @176415
     /*  176415 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(176470), // Rule ID 1062 //
     /*  176420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176423 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176437 */     // MIs[0] addr
     /*  176437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176453 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176458 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176460 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176462 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176468 */     GIR_RootConstrainSelectedInstOperands,
     /*  176469 */     // GIR_Coverage, 1062,
     /*  176469 */     GIR_EraseRootFromParent_Done,
     /*  176470 */   // Label 3403: @176470
     /*  176470 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(176525), // Rule ID 1064 //
     /*  176475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176478 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176485 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176492 */     // MIs[0] addr
     /*  176492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176508 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  176511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176513 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176515 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176517 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176523 */     GIR_RootConstrainSelectedInstOperands,
     /*  176524 */     // GIR_Coverage, 1064,
     /*  176524 */     GIR_EraseRootFromParent_Done,
     /*  176525 */   // Label 3404: @176525
     /*  176525 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(176580), // Rule ID 1066 //
     /*  176530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176533 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176540 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176547 */     // MIs[0] addr
     /*  176547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176563 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  176566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176568 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176570 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176572 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176578 */     GIR_RootConstrainSelectedInstOperands,
     /*  176579 */     // GIR_Coverage, 1066,
     /*  176579 */     GIR_EraseRootFromParent_Done,
     /*  176580 */   // Label 3405: @176580
     /*  176580 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(176635), // Rule ID 1068 //
     /*  176585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176595 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176602 */     // MIs[0] addr
     /*  176602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176618 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  176621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176623 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176625 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176627 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176633 */     GIR_RootConstrainSelectedInstOperands,
     /*  176634 */     // GIR_Coverage, 1068,
     /*  176634 */     GIR_EraseRootFromParent_Done,
     /*  176635 */   // Label 3406: @176635
     /*  176635 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(176690), // Rule ID 1070 //
     /*  176640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176643 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176650 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176657 */     // MIs[0] addr
     /*  176657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176673 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  176676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176678 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176680 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176682 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176688 */     GIR_RootConstrainSelectedInstOperands,
     /*  176689 */     // GIR_Coverage, 1070,
     /*  176689 */     GIR_EraseRootFromParent_Done,
     /*  176690 */   // Label 3407: @176690
     /*  176690 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(176745), // Rule ID 1072 //
     /*  176695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176698 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176705 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176712 */     // MIs[0] addr
     /*  176712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176728 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176733 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176735 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176737 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176743 */     GIR_RootConstrainSelectedInstOperands,
     /*  176744 */     // GIR_Coverage, 1072,
     /*  176744 */     GIR_EraseRootFromParent_Done,
     /*  176745 */   // Label 3408: @176745
     /*  176745 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(176800), // Rule ID 1074 //
     /*  176750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176767 */     // MIs[0] addr
     /*  176767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176783 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176788 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176790 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176792 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176798 */     GIR_RootConstrainSelectedInstOperands,
     /*  176799 */     // GIR_Coverage, 1074,
     /*  176799 */     GIR_EraseRootFromParent_Done,
     /*  176800 */   // Label 3409: @176800
     /*  176800 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(176855), // Rule ID 1076 //
     /*  176805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176808 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176815 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176822 */     // MIs[0] addr
     /*  176822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176838 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176843 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176845 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176847 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176853 */     GIR_RootConstrainSelectedInstOperands,
     /*  176854 */     // GIR_Coverage, 1076,
     /*  176854 */     GIR_EraseRootFromParent_Done,
     /*  176855 */   // Label 3410: @176855
     /*  176855 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(176910), // Rule ID 1078 //
     /*  176860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176863 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176877 */     // MIs[0] addr
     /*  176877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176893 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176898 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176900 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176902 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176908 */     GIR_RootConstrainSelectedInstOperands,
     /*  176909 */     // GIR_Coverage, 1078,
     /*  176909 */     GIR_EraseRootFromParent_Done,
     /*  176910 */   // Label 3411: @176910
     /*  176910 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(176965), // Rule ID 1080 //
     /*  176915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176932 */     // MIs[0] addr
     /*  176932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176948 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176953 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176955 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176957 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176963 */     GIR_RootConstrainSelectedInstOperands,
     /*  176964 */     // GIR_Coverage, 1080,
     /*  176964 */     GIR_EraseRootFromParent_Done,
     /*  176965 */   // Label 3412: @176965
     /*  176965 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(177020), // Rule ID 1082 //
     /*  176970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176973 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  176980 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176987 */     // MIs[0] addr
     /*  176987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177003 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177008 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177010 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177012 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177018 */     GIR_RootConstrainSelectedInstOperands,
     /*  177019 */     // GIR_Coverage, 1082,
     /*  177019 */     GIR_EraseRootFromParent_Done,
     /*  177020 */   // Label 3413: @177020
     /*  177020 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(177075), // Rule ID 1084 //
     /*  177025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177028 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177035 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177042 */     // MIs[0] addr
     /*  177042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177058 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  177061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177063 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177065 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177067 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177073 */     GIR_RootConstrainSelectedInstOperands,
     /*  177074 */     // GIR_Coverage, 1084,
     /*  177074 */     GIR_EraseRootFromParent_Done,
     /*  177075 */   // Label 3414: @177075
     /*  177075 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(177130), // Rule ID 1086 //
     /*  177080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177083 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177090 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177097 */     // MIs[0] addr
     /*  177097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177113 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  177116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177118 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177120 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177122 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177128 */     GIR_RootConstrainSelectedInstOperands,
     /*  177129 */     // GIR_Coverage, 1086,
     /*  177129 */     GIR_EraseRootFromParent_Done,
     /*  177130 */   // Label 3415: @177130
     /*  177130 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(177185), // Rule ID 1088 //
     /*  177135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177152 */     // MIs[0] addr
     /*  177152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177168 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  177171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177173 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177175 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177177 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177183 */     GIR_RootConstrainSelectedInstOperands,
     /*  177184 */     // GIR_Coverage, 1088,
     /*  177184 */     GIR_EraseRootFromParent_Done,
     /*  177185 */   // Label 3416: @177185
     /*  177185 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(177240), // Rule ID 1090 //
     /*  177190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177193 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177200 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177207 */     // MIs[0] addr
     /*  177207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177223 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  177226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177228 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177230 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177232 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177238 */     GIR_RootConstrainSelectedInstOperands,
     /*  177239 */     // GIR_Coverage, 1090,
     /*  177239 */     GIR_EraseRootFromParent_Done,
     /*  177240 */   // Label 3417: @177240
     /*  177240 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(177295), // Rule ID 1092 //
     /*  177245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177262 */     // MIs[0] addr
     /*  177262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177278 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177283 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177285 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177287 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177293 */     GIR_RootConstrainSelectedInstOperands,
     /*  177294 */     // GIR_Coverage, 1092,
     /*  177294 */     GIR_EraseRootFromParent_Done,
     /*  177295 */   // Label 3418: @177295
     /*  177295 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(177350), // Rule ID 1094 //
     /*  177300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177303 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177310 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177317 */     // MIs[0] addr
     /*  177317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177333 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177338 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177340 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177342 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177348 */     GIR_RootConstrainSelectedInstOperands,
     /*  177349 */     // GIR_Coverage, 1094,
     /*  177349 */     GIR_EraseRootFromParent_Done,
     /*  177350 */   // Label 3419: @177350
     /*  177350 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(177405), // Rule ID 1096 //
     /*  177355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177358 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177365 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177372 */     // MIs[0] addr
     /*  177372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177388 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177393 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177395 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177397 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177403 */     GIR_RootConstrainSelectedInstOperands,
     /*  177404 */     // GIR_Coverage, 1096,
     /*  177404 */     GIR_EraseRootFromParent_Done,
     /*  177405 */   // Label 3420: @177405
     /*  177405 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(177460), // Rule ID 1098 //
     /*  177410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177413 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177420 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177427 */     // MIs[0] addr
     /*  177427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177443 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177448 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177450 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177452 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177458 */     GIR_RootConstrainSelectedInstOperands,
     /*  177459 */     // GIR_Coverage, 1098,
     /*  177459 */     GIR_EraseRootFromParent_Done,
     /*  177460 */   // Label 3421: @177460
     /*  177460 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(177515), // Rule ID 1100 //
     /*  177465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177482 */     // MIs[0] addr
     /*  177482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177498 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177503 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177505 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177507 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177513 */     GIR_RootConstrainSelectedInstOperands,
     /*  177514 */     // GIR_Coverage, 1100,
     /*  177514 */     GIR_EraseRootFromParent_Done,
     /*  177515 */   // Label 3422: @177515
     /*  177515 */   GIM_Reject,
     /*  177516 */ // Label 3387: @177516
     /*  177516 */ GIM_Reject,
     /*  177517 */ // Label 3385: @177517
     /*  177517 */ GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(180389),
     /*  177522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  177525 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  177528 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(177594), // Rule ID 654 //
     /*  177533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177536 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177543 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177550 */     // MIs[0] addr
     /*  177550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177566 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  177566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177574 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177579 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177581 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177583 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  177588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177592 */     GIR_RootConstrainSelectedInstOperands,
     /*  177593 */     // GIR_Coverage, 654,
     /*  177593 */     GIR_EraseRootFromParent_Done,
     /*  177594 */   // Label 3424: @177594
     /*  177594 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(177660), // Rule ID 656 //
     /*  177599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177602 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177609 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177616 */     // MIs[0] addr
     /*  177616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177632 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  177632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177640 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177645 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177647 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177649 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177658 */     GIR_RootConstrainSelectedInstOperands,
     /*  177659 */     // GIR_Coverage, 656,
     /*  177659 */     GIR_EraseRootFromParent_Done,
     /*  177660 */   // Label 3425: @177660
     /*  177660 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(177726), // Rule ID 658 //
     /*  177665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177668 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177675 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177682 */     // MIs[0] addr
     /*  177682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177698 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  177698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177706 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177711 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177713 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177715 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177724 */     GIR_RootConstrainSelectedInstOperands,
     /*  177725 */     // GIR_Coverage, 658,
     /*  177725 */     GIR_EraseRootFromParent_Done,
     /*  177726 */   // Label 3426: @177726
     /*  177726 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(177792), // Rule ID 660 //
     /*  177731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177734 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177741 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177748 */     // MIs[0] addr
     /*  177748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177764 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  177764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177772 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177777 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177779 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177781 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177790 */     GIR_RootConstrainSelectedInstOperands,
     /*  177791 */     // GIR_Coverage, 660,
     /*  177791 */     GIR_EraseRootFromParent_Done,
     /*  177792 */   // Label 3427: @177792
     /*  177792 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(177858), // Rule ID 662 //
     /*  177797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177800 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177807 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177814 */     // MIs[0] addr
     /*  177814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177830 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  177830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177838 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177843 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177845 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177847 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  177852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177856 */     GIR_RootConstrainSelectedInstOperands,
     /*  177857 */     // GIR_Coverage, 662,
     /*  177857 */     GIR_EraseRootFromParent_Done,
     /*  177858 */   // Label 3428: @177858
     /*  177858 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(177924), // Rule ID 664 //
     /*  177863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  177866 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  177873 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177880 */     // MIs[0] addr
     /*  177880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177896 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  177896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  177902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177904 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177909 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177911 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177913 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  177918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177922 */     GIR_RootConstrainSelectedInstOperands,
     /*  177923 */     // GIR_Coverage, 664,
     /*  177923 */     GIR_EraseRootFromParent_Done,
     /*  177924 */   // Label 3429: @177924
     /*  177924 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(177990), // Rule ID 665 //
     /*  177929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  177932 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  177939 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177946 */     // MIs[0] addr
     /*  177946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177962 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  177962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  177968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177970 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177975 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177977 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177979 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177988 */     GIR_RootConstrainSelectedInstOperands,
     /*  177989 */     // GIR_Coverage, 665,
     /*  177989 */     GIR_EraseRootFromParent_Done,
     /*  177990 */   // Label 3430: @177990
     /*  177990 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(178056), // Rule ID 666 //
     /*  177995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  177998 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178005 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178012 */     // MIs[0] addr
     /*  178012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178028 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  178028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178036 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178041 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178043 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178045 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178054 */     GIR_RootConstrainSelectedInstOperands,
     /*  178055 */     // GIR_Coverage, 666,
     /*  178055 */     GIR_EraseRootFromParent_Done,
     /*  178056 */   // Label 3431: @178056
     /*  178056 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(178122), // Rule ID 667 //
     /*  178061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178078 */     // MIs[0] addr
     /*  178078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178094 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  178094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178102 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178107 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178109 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178111 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178120 */     GIR_RootConstrainSelectedInstOperands,
     /*  178121 */     // GIR_Coverage, 667,
     /*  178121 */     GIR_EraseRootFromParent_Done,
     /*  178122 */   // Label 3432: @178122
     /*  178122 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(178188), // Rule ID 668 //
     /*  178127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178130 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178144 */     // MIs[0] addr
     /*  178144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178160 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  178160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178168 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178173 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178175 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178177 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  178182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178186 */     GIR_RootConstrainSelectedInstOperands,
     /*  178187 */     // GIR_Coverage, 668,
     /*  178187 */     GIR_EraseRootFromParent_Done,
     /*  178188 */   // Label 3433: @178188
     /*  178188 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(178243), // Rule ID 671 //
     /*  178193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178196 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178203 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178210 */     // MIs[0] addr
     /*  178210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178226 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178231 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178233 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178235 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178241 */     GIR_RootConstrainSelectedInstOperands,
     /*  178242 */     // GIR_Coverage, 671,
     /*  178242 */     GIR_EraseRootFromParent_Done,
     /*  178243 */   // Label 3434: @178243
     /*  178243 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(178298), // Rule ID 673 //
     /*  178248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178251 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178258 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178265 */     // MIs[0] addr
     /*  178265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178281 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  178284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178286 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178288 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178290 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178296 */     GIR_RootConstrainSelectedInstOperands,
     /*  178297 */     // GIR_Coverage, 673,
     /*  178297 */     GIR_EraseRootFromParent_Done,
     /*  178298 */   // Label 3435: @178298
     /*  178298 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(178353), // Rule ID 675 //
     /*  178303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178306 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178313 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178320 */     // MIs[0] addr
     /*  178320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178336 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  178339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178341 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178343 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178345 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178351 */     GIR_RootConstrainSelectedInstOperands,
     /*  178352 */     // GIR_Coverage, 675,
     /*  178352 */     GIR_EraseRootFromParent_Done,
     /*  178353 */   // Label 3436: @178353
     /*  178353 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(178408), // Rule ID 677 //
     /*  178358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178361 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178368 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178375 */     // MIs[0] addr
     /*  178375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178391 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  178394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178396 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178398 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178400 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178406 */     GIR_RootConstrainSelectedInstOperands,
     /*  178407 */     // GIR_Coverage, 677,
     /*  178407 */     GIR_EraseRootFromParent_Done,
     /*  178408 */   // Label 3437: @178408
     /*  178408 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(178463), // Rule ID 679 //
     /*  178413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178416 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178423 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178430 */     // MIs[0] addr
     /*  178430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178446 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  178449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178451 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178453 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178455 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178461 */     GIR_RootConstrainSelectedInstOperands,
     /*  178462 */     // GIR_Coverage, 679,
     /*  178462 */     GIR_EraseRootFromParent_Done,
     /*  178463 */   // Label 3438: @178463
     /*  178463 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(178518), // Rule ID 681 //
     /*  178468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178471 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178478 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178485 */     // MIs[0] addr
     /*  178485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178501 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178506 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178508 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178510 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178516 */     GIR_RootConstrainSelectedInstOperands,
     /*  178517 */     // GIR_Coverage, 681,
     /*  178517 */     GIR_EraseRootFromParent_Done,
     /*  178518 */   // Label 3439: @178518
     /*  178518 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(178573), // Rule ID 683 //
     /*  178523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178526 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178540 */     // MIs[0] addr
     /*  178540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178556 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178561 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178563 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178565 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178571 */     GIR_RootConstrainSelectedInstOperands,
     /*  178572 */     // GIR_Coverage, 683,
     /*  178572 */     GIR_EraseRootFromParent_Done,
     /*  178573 */   // Label 3440: @178573
     /*  178573 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(178628), // Rule ID 685 //
     /*  178578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178595 */     // MIs[0] addr
     /*  178595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178611 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178616 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178618 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178620 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178626 */     GIR_RootConstrainSelectedInstOperands,
     /*  178627 */     // GIR_Coverage, 685,
     /*  178627 */     GIR_EraseRootFromParent_Done,
     /*  178628 */   // Label 3441: @178628
     /*  178628 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(178683), // Rule ID 687 //
     /*  178633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178636 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178643 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178650 */     // MIs[0] addr
     /*  178650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178666 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178671 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178673 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178675 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178681 */     GIR_RootConstrainSelectedInstOperands,
     /*  178682 */     // GIR_Coverage, 687,
     /*  178682 */     GIR_EraseRootFromParent_Done,
     /*  178683 */   // Label 3442: @178683
     /*  178683 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(178738), // Rule ID 689 //
     /*  178688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178691 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178698 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178705 */     // MIs[0] addr
     /*  178705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178721 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178726 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178728 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178730 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178736 */     GIR_RootConstrainSelectedInstOperands,
     /*  178737 */     // GIR_Coverage, 689,
     /*  178737 */     GIR_EraseRootFromParent_Done,
     /*  178738 */   // Label 3443: @178738
     /*  178738 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(178793), // Rule ID 691 //
     /*  178743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178753 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178760 */     // MIs[0] addr
     /*  178760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178776 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  178779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178781 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178783 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178785 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178791 */     GIR_RootConstrainSelectedInstOperands,
     /*  178792 */     // GIR_Coverage, 691,
     /*  178792 */     GIR_EraseRootFromParent_Done,
     /*  178793 */   // Label 3444: @178793
     /*  178793 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(178848), // Rule ID 692 //
     /*  178798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178808 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178815 */     // MIs[0] addr
     /*  178815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178831 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ),
     /*  178834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178836 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178838 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178840 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178846 */     GIR_RootConstrainSelectedInstOperands,
     /*  178847 */     // GIR_Coverage, 692,
     /*  178847 */     GIR_EraseRootFromParent_Done,
     /*  178848 */   // Label 3445: @178848
     /*  178848 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(178903), // Rule ID 693 //
     /*  178853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178856 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178863 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178870 */     // MIs[0] addr
     /*  178870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178886 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_RL),
     /*  178889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178891 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178893 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178895 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178901 */     GIR_RootConstrainSelectedInstOperands,
     /*  178902 */     // GIR_Coverage, 693,
     /*  178902 */     GIR_EraseRootFromParent_Done,
     /*  178903 */   // Label 3446: @178903
     /*  178903 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(178958), // Rule ID 694 //
     /*  178908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178911 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178918 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178925 */     // MIs[0] addr
     /*  178925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178941 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  178944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178946 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178948 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178950 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178956 */     GIR_RootConstrainSelectedInstOperands,
     /*  178957 */     // GIR_Coverage, 694,
     /*  178957 */     GIR_EraseRootFromParent_Done,
     /*  178958 */   // Label 3447: @178958
     /*  178958 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(179013), // Rule ID 695 //
     /*  178963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178980 */     // MIs[0] addr
     /*  178980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178996 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  178999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179001 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179003 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179005 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179011 */     GIR_RootConstrainSelectedInstOperands,
     /*  179012 */     // GIR_Coverage, 695,
     /*  179012 */     GIR_EraseRootFromParent_Done,
     /*  179013 */   // Label 3448: @179013
     /*  179013 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(179068), // Rule ID 696 //
     /*  179018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179021 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179028 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179035 */     // MIs[0] addr
     /*  179035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179051 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179056 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179058 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179060 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179066 */     GIR_RootConstrainSelectedInstOperands,
     /*  179067 */     // GIR_Coverage, 696,
     /*  179067 */     GIR_EraseRootFromParent_Done,
     /*  179068 */   // Label 3449: @179068
     /*  179068 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(179123), // Rule ID 697 //
     /*  179073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179083 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179090 */     // MIs[0] addr
     /*  179090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179106 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179111 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179113 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179115 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179121 */     GIR_RootConstrainSelectedInstOperands,
     /*  179122 */     // GIR_Coverage, 697,
     /*  179122 */     GIR_EraseRootFromParent_Done,
     /*  179123 */   // Label 3450: @179123
     /*  179123 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(179178), // Rule ID 698 //
     /*  179128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179131 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179138 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179145 */     // MIs[0] addr
     /*  179145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179161 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179166 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179168 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179170 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179176 */     GIR_RootConstrainSelectedInstOperands,
     /*  179177 */     // GIR_Coverage, 698,
     /*  179177 */     GIR_EraseRootFromParent_Done,
     /*  179178 */   // Label 3451: @179178
     /*  179178 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(179233), // Rule ID 699 //
     /*  179183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179186 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179193 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179200 */     // MIs[0] addr
     /*  179200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179216 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179221 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179223 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179225 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179231 */     GIR_RootConstrainSelectedInstOperands,
     /*  179232 */     // GIR_Coverage, 699,
     /*  179232 */     GIR_EraseRootFromParent_Done,
     /*  179233 */   // Label 3452: @179233
     /*  179233 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(179288), // Rule ID 700 //
     /*  179238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179241 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179248 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179255 */     // MIs[0] addr
     /*  179255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179271 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179276 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179278 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179280 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179286 */     GIR_RootConstrainSelectedInstOperands,
     /*  179287 */     // GIR_Coverage, 700,
     /*  179287 */     GIR_EraseRootFromParent_Done,
     /*  179288 */   // Label 3453: @179288
     /*  179288 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(179343), // Rule ID 1061 //
     /*  179293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179296 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179303 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179310 */     // MIs[0] addr
     /*  179310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179326 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179331 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179333 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179335 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179341 */     GIR_RootConstrainSelectedInstOperands,
     /*  179342 */     // GIR_Coverage, 1061,
     /*  179342 */     GIR_EraseRootFromParent_Done,
     /*  179343 */   // Label 3454: @179343
     /*  179343 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(179398), // Rule ID 1063 //
     /*  179348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179351 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179358 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179365 */     // MIs[0] addr
     /*  179365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179381 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  179384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179386 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179388 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179390 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179396 */     GIR_RootConstrainSelectedInstOperands,
     /*  179397 */     // GIR_Coverage, 1063,
     /*  179397 */     GIR_EraseRootFromParent_Done,
     /*  179398 */   // Label 3455: @179398
     /*  179398 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(179453), // Rule ID 1065 //
     /*  179403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179406 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179413 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179420 */     // MIs[0] addr
     /*  179420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179436 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  179439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179441 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179443 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179445 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179451 */     GIR_RootConstrainSelectedInstOperands,
     /*  179452 */     // GIR_Coverage, 1065,
     /*  179452 */     GIR_EraseRootFromParent_Done,
     /*  179453 */   // Label 3456: @179453
     /*  179453 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(179508), // Rule ID 1067 //
     /*  179458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179461 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179468 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179475 */     // MIs[0] addr
     /*  179475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179491 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  179494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179496 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179498 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179500 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179506 */     GIR_RootConstrainSelectedInstOperands,
     /*  179507 */     // GIR_Coverage, 1067,
     /*  179507 */     GIR_EraseRootFromParent_Done,
     /*  179508 */   // Label 3457: @179508
     /*  179508 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(179563), // Rule ID 1069 //
     /*  179513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179516 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179523 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179530 */     // MIs[0] addr
     /*  179530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179546 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  179549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179551 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179553 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179555 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179561 */     GIR_RootConstrainSelectedInstOperands,
     /*  179562 */     // GIR_Coverage, 1069,
     /*  179562 */     GIR_EraseRootFromParent_Done,
     /*  179563 */   // Label 3458: @179563
     /*  179563 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(179618), // Rule ID 1071 //
     /*  179568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179571 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179578 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179585 */     // MIs[0] addr
     /*  179585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179601 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179606 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179608 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179610 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179616 */     GIR_RootConstrainSelectedInstOperands,
     /*  179617 */     // GIR_Coverage, 1071,
     /*  179617 */     GIR_EraseRootFromParent_Done,
     /*  179618 */   // Label 3459: @179618
     /*  179618 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(179673), // Rule ID 1073 //
     /*  179623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179626 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179633 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179640 */     // MIs[0] addr
     /*  179640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179656 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179661 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179663 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179665 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179671 */     GIR_RootConstrainSelectedInstOperands,
     /*  179672 */     // GIR_Coverage, 1073,
     /*  179672 */     GIR_EraseRootFromParent_Done,
     /*  179673 */   // Label 3460: @179673
     /*  179673 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(179728), // Rule ID 1075 //
     /*  179678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179681 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179688 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179695 */     // MIs[0] addr
     /*  179695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179711 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179716 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179718 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179720 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179726 */     GIR_RootConstrainSelectedInstOperands,
     /*  179727 */     // GIR_Coverage, 1075,
     /*  179727 */     GIR_EraseRootFromParent_Done,
     /*  179728 */   // Label 3461: @179728
     /*  179728 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(179783), // Rule ID 1077 //
     /*  179733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179750 */     // MIs[0] addr
     /*  179750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179766 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179771 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179773 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179775 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179781 */     GIR_RootConstrainSelectedInstOperands,
     /*  179782 */     // GIR_Coverage, 1077,
     /*  179782 */     GIR_EraseRootFromParent_Done,
     /*  179783 */   // Label 3462: @179783
     /*  179783 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(179838), // Rule ID 1079 //
     /*  179788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179791 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179798 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179805 */     // MIs[0] addr
     /*  179805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179821 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179826 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179828 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179830 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179836 */     GIR_RootConstrainSelectedInstOperands,
     /*  179837 */     // GIR_Coverage, 1079,
     /*  179837 */     GIR_EraseRootFromParent_Done,
     /*  179838 */   // Label 3463: @179838
     /*  179838 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(179893), // Rule ID 1081 //
     /*  179843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179860 */     // MIs[0] addr
     /*  179860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179876 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  179879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179881 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179883 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179885 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179891 */     GIR_RootConstrainSelectedInstOperands,
     /*  179892 */     // GIR_Coverage, 1081,
     /*  179892 */     GIR_EraseRootFromParent_Done,
     /*  179893 */   // Label 3464: @179893
     /*  179893 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(179948), // Rule ID 1083 //
     /*  179898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179901 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179908 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179915 */     // MIs[0] addr
     /*  179915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179931 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  179934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179936 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179938 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179940 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179946 */     GIR_RootConstrainSelectedInstOperands,
     /*  179947 */     // GIR_Coverage, 1083,
     /*  179947 */     GIR_EraseRootFromParent_Done,
     /*  179948 */   // Label 3465: @179948
     /*  179948 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(180003), // Rule ID 1085 //
     /*  179953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179956 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179963 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179970 */     // MIs[0] addr
     /*  179970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179986 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  179989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179991 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179993 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179995 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180001 */     GIR_RootConstrainSelectedInstOperands,
     /*  180002 */     // GIR_Coverage, 1085,
     /*  180002 */     GIR_EraseRootFromParent_Done,
     /*  180003 */   // Label 3466: @180003
     /*  180003 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(180058), // Rule ID 1087 //
     /*  180008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  180011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180025 */     // MIs[0] addr
     /*  180025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180041 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  180044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180046 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180048 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180050 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180056 */     GIR_RootConstrainSelectedInstOperands,
     /*  180057 */     // GIR_Coverage, 1087,
     /*  180057 */     GIR_EraseRootFromParent_Done,
     /*  180058 */   // Label 3467: @180058
     /*  180058 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(180113), // Rule ID 1089 //
     /*  180063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  180066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180073 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180080 */     // MIs[0] addr
     /*  180080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180096 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  180099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180101 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180103 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180105 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180111 */     GIR_RootConstrainSelectedInstOperands,
     /*  180112 */     // GIR_Coverage, 1089,
     /*  180112 */     GIR_EraseRootFromParent_Done,
     /*  180113 */   // Label 3468: @180113
     /*  180113 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(180168), // Rule ID 1091 //
     /*  180118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180121 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180128 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180135 */     // MIs[0] addr
     /*  180135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180151 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180156 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180158 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180160 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180166 */     GIR_RootConstrainSelectedInstOperands,
     /*  180167 */     // GIR_Coverage, 1091,
     /*  180167 */     GIR_EraseRootFromParent_Done,
     /*  180168 */   // Label 3469: @180168
     /*  180168 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(180223), // Rule ID 1093 //
     /*  180173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180176 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180183 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180190 */     // MIs[0] addr
     /*  180190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180206 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180211 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180213 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180215 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180221 */     GIR_RootConstrainSelectedInstOperands,
     /*  180222 */     // GIR_Coverage, 1093,
     /*  180222 */     GIR_EraseRootFromParent_Done,
     /*  180223 */   // Label 3470: @180223
     /*  180223 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(180278), // Rule ID 1095 //
     /*  180228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180245 */     // MIs[0] addr
     /*  180245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180261 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180266 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180268 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180270 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180276 */     GIR_RootConstrainSelectedInstOperands,
     /*  180277 */     // GIR_Coverage, 1095,
     /*  180277 */     GIR_EraseRootFromParent_Done,
     /*  180278 */   // Label 3471: @180278
     /*  180278 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(180333), // Rule ID 1097 //
     /*  180283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180286 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180293 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180300 */     // MIs[0] addr
     /*  180300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180316 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180321 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180323 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180325 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180331 */     GIR_RootConstrainSelectedInstOperands,
     /*  180332 */     // GIR_Coverage, 1097,
     /*  180332 */     GIR_EraseRootFromParent_Done,
     /*  180333 */   // Label 3472: @180333
     /*  180333 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(180388), // Rule ID 1099 //
     /*  180338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180341 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180355 */     // MIs[0] addr
     /*  180355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180371 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180376 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180378 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180380 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180386 */     GIR_RootConstrainSelectedInstOperands,
     /*  180387 */     // GIR_Coverage, 1099,
     /*  180387 */     GIR_EraseRootFromParent_Done,
     /*  180388 */   // Label 3473: @180388
     /*  180388 */   GIM_Reject,
     /*  180389 */ // Label 3423: @180389
     /*  180389 */ GIM_Reject,
     /*  180390 */ // Label 3386: @180390
     /*  180390 */ GIM_Reject,
     /*  180391 */ // Label 26: @180391
     /*  180391 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3476*/ GIMT_Encode4(183300),
     /*  180402 */ /*GILLT_s32*//*Label 3474*/ GIMT_Encode4(180410),
     /*  180406 */ /*GILLT_s64*//*Label 3475*/ GIMT_Encode4(181650),
     /*  180410 */ // Label 3474: @180410
     /*  180410 */ GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(181649),
     /*  180415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  180418 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(180459), // Rule ID 354 //
     /*  180423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180426 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180440 */     // MIs[0] rs1
     /*  180440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180452 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180457 */     GIR_RootConstrainSelectedInstOperands,
     /*  180458 */     // GIR_Coverage, 354,
     /*  180458 */     GIR_Done,
     /*  180459 */   // Label 3478: @180459
     /*  180459 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(180500), // Rule ID 356 //
     /*  180464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180467 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180481 */     // MIs[0] rs1
     /*  180481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180493 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  180498 */     GIR_RootConstrainSelectedInstOperands,
     /*  180499 */     // GIR_Coverage, 356,
     /*  180499 */     GIR_Done,
     /*  180500 */   // Label 3479: @180500
     /*  180500 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(180541), // Rule ID 358 //
     /*  180505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180508 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180515 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180522 */     // MIs[0] rs1
     /*  180522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180534 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  180539 */     GIR_RootConstrainSelectedInstOperands,
     /*  180540 */     // GIR_Coverage, 358,
     /*  180540 */     GIR_Done,
     /*  180541 */   // Label 3480: @180541
     /*  180541 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(180582), // Rule ID 360 //
     /*  180546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180549 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180556 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180563 */     // MIs[0] rs1
     /*  180563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180575 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  180580 */     GIR_RootConstrainSelectedInstOperands,
     /*  180581 */     // GIR_Coverage, 360,
     /*  180581 */     GIR_Done,
     /*  180582 */   // Label 3481: @180582
     /*  180582 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(180623), // Rule ID 362 //
     /*  180587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180590 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180597 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180604 */     // MIs[0] rs1
     /*  180604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180616 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  180621 */     GIR_RootConstrainSelectedInstOperands,
     /*  180622 */     // GIR_Coverage, 362,
     /*  180622 */     GIR_Done,
     /*  180623 */   // Label 3482: @180623
     /*  180623 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(180664), // Rule ID 364 //
     /*  180628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180631 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180638 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180645 */     // MIs[0] rs1
     /*  180645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180657 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180662 */     GIR_RootConstrainSelectedInstOperands,
     /*  180663 */     // GIR_Coverage, 364,
     /*  180663 */     GIR_Done,
     /*  180664 */   // Label 3483: @180664
     /*  180664 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(180705), // Rule ID 366 //
     /*  180669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180672 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180679 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180686 */     // MIs[0] rs1
     /*  180686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180698 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180703 */     GIR_RootConstrainSelectedInstOperands,
     /*  180704 */     // GIR_Coverage, 366,
     /*  180704 */     GIR_Done,
     /*  180705 */   // Label 3484: @180705
     /*  180705 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(180746), // Rule ID 368 //
     /*  180710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180713 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180720 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180727 */     // MIs[0] rs1
     /*  180727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180739 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180744 */     GIR_RootConstrainSelectedInstOperands,
     /*  180745 */     // GIR_Coverage, 368,
     /*  180745 */     GIR_Done,
     /*  180746 */   // Label 3485: @180746
     /*  180746 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(180787), // Rule ID 370 //
     /*  180751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180754 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180761 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180768 */     // MIs[0] rs1
     /*  180768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180780 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180785 */     GIR_RootConstrainSelectedInstOperands,
     /*  180786 */     // GIR_Coverage, 370,
     /*  180786 */     GIR_Done,
     /*  180787 */   // Label 3486: @180787
     /*  180787 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(180828), // Rule ID 372 //
     /*  180792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180809 */     // MIs[0] rs1
     /*  180809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180821 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180826 */     GIR_RootConstrainSelectedInstOperands,
     /*  180827 */     // GIR_Coverage, 372,
     /*  180827 */     GIR_Done,
     /*  180828 */   // Label 3487: @180828
     /*  180828 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(180869), // Rule ID 702 //
     /*  180833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180836 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180850 */     // MIs[0] rs1
     /*  180850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180862 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180862 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  180867 */     GIR_RootConstrainSelectedInstOperands,
     /*  180868 */     // GIR_Coverage, 702,
     /*  180868 */     GIR_Done,
     /*  180869 */   // Label 3488: @180869
     /*  180869 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(180910), // Rule ID 704 //
     /*  180874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180884 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180891 */     // MIs[0] rs1
     /*  180891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180903 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  180908 */     GIR_RootConstrainSelectedInstOperands,
     /*  180909 */     // GIR_Coverage, 704,
     /*  180909 */     GIR_Done,
     /*  180910 */   // Label 3489: @180910
     /*  180910 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(180951), // Rule ID 706 //
     /*  180915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180932 */     // MIs[0] rs1
     /*  180932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180944 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180944 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  180949 */     GIR_RootConstrainSelectedInstOperands,
     /*  180950 */     // GIR_Coverage, 706,
     /*  180950 */     GIR_Done,
     /*  180951 */   // Label 3490: @180951
     /*  180951 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(180992), // Rule ID 708 //
     /*  180956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180959 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180966 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180973 */     // MIs[0] rs1
     /*  180973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180985 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  180990 */     GIR_RootConstrainSelectedInstOperands,
     /*  180991 */     // GIR_Coverage, 708,
     /*  180991 */     GIR_Done,
     /*  180992 */   // Label 3491: @180992
     /*  180992 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(181033), // Rule ID 710 //
     /*  180997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181000 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181007 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181014 */     // MIs[0] rs1
     /*  181014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181026 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  181031 */     GIR_RootConstrainSelectedInstOperands,
     /*  181032 */     // GIR_Coverage, 710,
     /*  181032 */     GIR_Done,
     /*  181033 */   // Label 3492: @181033
     /*  181033 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(181074), // Rule ID 712 //
     /*  181038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181041 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181048 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181055 */     // MIs[0] rs1
     /*  181055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181067 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181072 */     GIR_RootConstrainSelectedInstOperands,
     /*  181073 */     // GIR_Coverage, 712,
     /*  181073 */     GIR_Done,
     /*  181074 */   // Label 3493: @181074
     /*  181074 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(181115), // Rule ID 714 //
     /*  181079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181082 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181089 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181096 */     // MIs[0] rs1
     /*  181096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181108 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181108 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181113 */     GIR_RootConstrainSelectedInstOperands,
     /*  181114 */     // GIR_Coverage, 714,
     /*  181114 */     GIR_Done,
     /*  181115 */   // Label 3494: @181115
     /*  181115 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(181156), // Rule ID 716 //
     /*  181120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181123 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181137 */     // MIs[0] rs1
     /*  181137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181149 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181154 */     GIR_RootConstrainSelectedInstOperands,
     /*  181155 */     // GIR_Coverage, 716,
     /*  181155 */     GIR_Done,
     /*  181156 */   // Label 3495: @181156
     /*  181156 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(181197), // Rule ID 718 //
     /*  181161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181164 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181178 */     // MIs[0] rs1
     /*  181178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181190 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181195 */     GIR_RootConstrainSelectedInstOperands,
     /*  181196 */     // GIR_Coverage, 718,
     /*  181196 */     GIR_Done,
     /*  181197 */   // Label 3496: @181197
     /*  181197 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(181238), // Rule ID 720 //
     /*  181202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181219 */     // MIs[0] rs1
     /*  181219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181231 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181236 */     GIR_RootConstrainSelectedInstOperands,
     /*  181237 */     // GIR_Coverage, 720,
     /*  181237 */     GIR_Done,
     /*  181238 */   // Label 3497: @181238
     /*  181238 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(181279), // Rule ID 882 //
     /*  181243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181260 */     // MIs[0] rs1
     /*  181260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181272 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181277 */     GIR_RootConstrainSelectedInstOperands,
     /*  181278 */     // GIR_Coverage, 882,
     /*  181278 */     GIR_Done,
     /*  181279 */   // Label 3498: @181279
     /*  181279 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(181320), // Rule ID 884 //
     /*  181284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181287 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181301 */     // MIs[0] rs1
     /*  181301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181313 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  181318 */     GIR_RootConstrainSelectedInstOperands,
     /*  181319 */     // GIR_Coverage, 884,
     /*  181319 */     GIR_Done,
     /*  181320 */   // Label 3499: @181320
     /*  181320 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(181361), // Rule ID 886 //
     /*  181325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181335 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181342 */     // MIs[0] rs1
     /*  181342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181354 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  181359 */     GIR_RootConstrainSelectedInstOperands,
     /*  181360 */     // GIR_Coverage, 886,
     /*  181360 */     GIR_Done,
     /*  181361 */   // Label 3500: @181361
     /*  181361 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(181402), // Rule ID 888 //
     /*  181366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181369 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181376 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181383 */     // MIs[0] rs1
     /*  181383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181395 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  181400 */     GIR_RootConstrainSelectedInstOperands,
     /*  181401 */     // GIR_Coverage, 888,
     /*  181401 */     GIR_Done,
     /*  181402 */   // Label 3501: @181402
     /*  181402 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(181443), // Rule ID 890 //
     /*  181407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181410 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181417 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181424 */     // MIs[0] rs1
     /*  181424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181436 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  181441 */     GIR_RootConstrainSelectedInstOperands,
     /*  181442 */     // GIR_Coverage, 890,
     /*  181442 */     GIR_Done,
     /*  181443 */   // Label 3502: @181443
     /*  181443 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(181484), // Rule ID 892 //
     /*  181448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181451 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181458 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181465 */     // MIs[0] rs1
     /*  181465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181477 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181482 */     GIR_RootConstrainSelectedInstOperands,
     /*  181483 */     // GIR_Coverage, 892,
     /*  181483 */     GIR_Done,
     /*  181484 */   // Label 3503: @181484
     /*  181484 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(181525), // Rule ID 894 //
     /*  181489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181492 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181499 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181506 */     // MIs[0] rs1
     /*  181506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181518 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181523 */     GIR_RootConstrainSelectedInstOperands,
     /*  181524 */     // GIR_Coverage, 894,
     /*  181524 */     GIR_Done,
     /*  181525 */   // Label 3504: @181525
     /*  181525 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(181566), // Rule ID 896 //
     /*  181530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181533 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181540 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181547 */     // MIs[0] rs1
     /*  181547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181559 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181564 */     GIR_RootConstrainSelectedInstOperands,
     /*  181565 */     // GIR_Coverage, 896,
     /*  181565 */     GIR_Done,
     /*  181566 */   // Label 3505: @181566
     /*  181566 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(181607), // Rule ID 898 //
     /*  181571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181574 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181581 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181588 */     // MIs[0] rs1
     /*  181588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181600 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181605 */     GIR_RootConstrainSelectedInstOperands,
     /*  181606 */     // GIR_Coverage, 898,
     /*  181606 */     GIR_Done,
     /*  181607 */   // Label 3506: @181607
     /*  181607 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(181648), // Rule ID 900 //
     /*  181612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181615 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181622 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181629 */     // MIs[0] rs1
     /*  181629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181641 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181646 */     GIR_RootConstrainSelectedInstOperands,
     /*  181647 */     // GIR_Coverage, 900,
     /*  181647 */     GIR_Done,
     /*  181648 */   // Label 3507: @181648
     /*  181648 */   GIM_Reject,
     /*  181649 */ // Label 3477: @181649
     /*  181649 */ GIM_Reject,
     /*  181650 */ // Label 3475: @181650
     /*  181650 */ GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(183299),
     /*  181655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  181658 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(181699), // Rule ID 353 //
     /*  181663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181666 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181673 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181680 */     // MIs[0] rs1
     /*  181680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181692 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181697 */     GIR_RootConstrainSelectedInstOperands,
     /*  181698 */     // GIR_Coverage, 353,
     /*  181698 */     GIR_Done,
     /*  181699 */   // Label 3509: @181699
     /*  181699 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(181740), // Rule ID 355 //
     /*  181704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181707 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181714 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181721 */     // MIs[0] rs1
     /*  181721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181733 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  181738 */     GIR_RootConstrainSelectedInstOperands,
     /*  181739 */     // GIR_Coverage, 355,
     /*  181739 */     GIR_Done,
     /*  181740 */   // Label 3510: @181740
     /*  181740 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(181781), // Rule ID 357 //
     /*  181745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181748 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181755 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181762 */     // MIs[0] rs1
     /*  181762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181774 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  181779 */     GIR_RootConstrainSelectedInstOperands,
     /*  181780 */     // GIR_Coverage, 357,
     /*  181780 */     GIR_Done,
     /*  181781 */   // Label 3511: @181781
     /*  181781 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(181822), // Rule ID 359 //
     /*  181786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181789 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181796 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181803 */     // MIs[0] rs1
     /*  181803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181815 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  181820 */     GIR_RootConstrainSelectedInstOperands,
     /*  181821 */     // GIR_Coverage, 359,
     /*  181821 */     GIR_Done,
     /*  181822 */   // Label 3512: @181822
     /*  181822 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(181863), // Rule ID 361 //
     /*  181827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181844 */     // MIs[0] rs1
     /*  181844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181856 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  181861 */     GIR_RootConstrainSelectedInstOperands,
     /*  181862 */     // GIR_Coverage, 361,
     /*  181862 */     GIR_Done,
     /*  181863 */   // Label 3513: @181863
     /*  181863 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(181904), // Rule ID 363 //
     /*  181868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  181871 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181885 */     // MIs[0] rs1
     /*  181885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181897 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181902 */     GIR_RootConstrainSelectedInstOperands,
     /*  181903 */     // GIR_Coverage, 363,
     /*  181903 */     GIR_Done,
     /*  181904 */   // Label 3514: @181904
     /*  181904 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(181945), // Rule ID 365 //
     /*  181909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  181912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181926 */     // MIs[0] rs1
     /*  181926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181938 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181943 */     GIR_RootConstrainSelectedInstOperands,
     /*  181944 */     // GIR_Coverage, 365,
     /*  181944 */     GIR_Done,
     /*  181945 */   // Label 3515: @181945
     /*  181945 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(181986), // Rule ID 367 //
     /*  181950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  181953 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181960 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181967 */     // MIs[0] rs1
     /*  181967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181979 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181979 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181984 */     GIR_RootConstrainSelectedInstOperands,
     /*  181985 */     // GIR_Coverage, 367,
     /*  181985 */     GIR_Done,
     /*  181986 */   // Label 3516: @181986
     /*  181986 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(182027), // Rule ID 369 //
     /*  181991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  181994 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182001 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182008 */     // MIs[0] rs1
     /*  182008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182020 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182025 */     GIR_RootConstrainSelectedInstOperands,
     /*  182026 */     // GIR_Coverage, 369,
     /*  182026 */     GIR_Done,
     /*  182027 */   // Label 3517: @182027
     /*  182027 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(182068), // Rule ID 371 //
     /*  182032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  182035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182049 */     // MIs[0] rs1
     /*  182049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182061 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182066 */     GIR_RootConstrainSelectedInstOperands,
     /*  182067 */     // GIR_Coverage, 371,
     /*  182067 */     GIR_Done,
     /*  182068 */   // Label 3518: @182068
     /*  182068 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(182109), // Rule ID 533 //
     /*  182073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182083 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182090 */     // MIs[0] rs1
     /*  182090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182102 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182107 */     GIR_RootConstrainSelectedInstOperands,
     /*  182108 */     // GIR_Coverage, 533,
     /*  182108 */     GIR_Done,
     /*  182109 */   // Label 3519: @182109
     /*  182109 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(182150), // Rule ID 534 //
     /*  182114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182117 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182131 */     // MIs[0] rs1
     /*  182131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182143 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ),
     /*  182148 */     GIR_RootConstrainSelectedInstOperands,
     /*  182149 */     // GIR_Coverage, 534,
     /*  182149 */     GIR_Done,
     /*  182150 */   // Label 3520: @182150
     /*  182150 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(182191), // Rule ID 535 //
     /*  182155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182172 */     // MIs[0] rs1
     /*  182172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182184 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_RL),
     /*  182189 */     GIR_RootConstrainSelectedInstOperands,
     /*  182190 */     // GIR_Coverage, 535,
     /*  182190 */     GIR_Done,
     /*  182191 */   // Label 3521: @182191
     /*  182191 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(182232), // Rule ID 536 //
     /*  182196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182199 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182213 */     // MIs[0] rs1
     /*  182213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182225 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  182230 */     GIR_RootConstrainSelectedInstOperands,
     /*  182231 */     // GIR_Coverage, 536,
     /*  182231 */     GIR_Done,
     /*  182232 */   // Label 3522: @182232
     /*  182232 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(182273), // Rule ID 537 //
     /*  182237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182247 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182254 */     // MIs[0] rs1
     /*  182254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182266 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  182271 */     GIR_RootConstrainSelectedInstOperands,
     /*  182272 */     // GIR_Coverage, 537,
     /*  182272 */     GIR_Done,
     /*  182273 */   // Label 3523: @182273
     /*  182273 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(182314), // Rule ID 538 //
     /*  182278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182281 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182288 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182295 */     // MIs[0] rs1
     /*  182295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182307 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182312 */     GIR_RootConstrainSelectedInstOperands,
     /*  182313 */     // GIR_Coverage, 538,
     /*  182313 */     GIR_Done,
     /*  182314 */   // Label 3524: @182314
     /*  182314 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(182355), // Rule ID 539 //
     /*  182319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182322 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182329 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182336 */     // MIs[0] rs1
     /*  182336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182348 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182348 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182353 */     GIR_RootConstrainSelectedInstOperands,
     /*  182354 */     // GIR_Coverage, 539,
     /*  182354 */     GIR_Done,
     /*  182355 */   // Label 3525: @182355
     /*  182355 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(182396), // Rule ID 540 //
     /*  182360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182363 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182377 */     // MIs[0] rs1
     /*  182377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182389 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182394 */     GIR_RootConstrainSelectedInstOperands,
     /*  182395 */     // GIR_Coverage, 540,
     /*  182395 */     GIR_Done,
     /*  182396 */   // Label 3526: @182396
     /*  182396 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(182437), // Rule ID 541 //
     /*  182401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182404 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182411 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182418 */     // MIs[0] rs1
     /*  182418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182430 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182435 */     GIR_RootConstrainSelectedInstOperands,
     /*  182436 */     // GIR_Coverage, 541,
     /*  182436 */     GIR_Done,
     /*  182437 */   // Label 3527: @182437
     /*  182437 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(182478), // Rule ID 542 //
     /*  182442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182445 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182452 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182459 */     // MIs[0] rs1
     /*  182459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182471 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182476 */     GIR_RootConstrainSelectedInstOperands,
     /*  182477 */     // GIR_Coverage, 542,
     /*  182477 */     GIR_Done,
     /*  182478 */   // Label 3528: @182478
     /*  182478 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(182519), // Rule ID 701 //
     /*  182483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182486 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182493 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182500 */     // MIs[0] rs1
     /*  182500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182512 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182517 */     GIR_RootConstrainSelectedInstOperands,
     /*  182518 */     // GIR_Coverage, 701,
     /*  182518 */     GIR_Done,
     /*  182519 */   // Label 3529: @182519
     /*  182519 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(182560), // Rule ID 703 //
     /*  182524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182527 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182534 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182541 */     // MIs[0] rs1
     /*  182541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182553 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  182558 */     GIR_RootConstrainSelectedInstOperands,
     /*  182559 */     // GIR_Coverage, 703,
     /*  182559 */     GIR_Done,
     /*  182560 */   // Label 3530: @182560
     /*  182560 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(182601), // Rule ID 705 //
     /*  182565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182568 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182582 */     // MIs[0] rs1
     /*  182582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182594 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  182599 */     GIR_RootConstrainSelectedInstOperands,
     /*  182600 */     // GIR_Coverage, 705,
     /*  182600 */     GIR_Done,
     /*  182601 */   // Label 3531: @182601
     /*  182601 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(182642), // Rule ID 707 //
     /*  182606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182609 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182616 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182623 */     // MIs[0] rs1
     /*  182623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182635 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  182640 */     GIR_RootConstrainSelectedInstOperands,
     /*  182641 */     // GIR_Coverage, 707,
     /*  182641 */     GIR_Done,
     /*  182642 */   // Label 3532: @182642
     /*  182642 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(182683), // Rule ID 709 //
     /*  182647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182650 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182657 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182664 */     // MIs[0] rs1
     /*  182664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182676 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182676 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  182681 */     GIR_RootConstrainSelectedInstOperands,
     /*  182682 */     // GIR_Coverage, 709,
     /*  182682 */     GIR_Done,
     /*  182683 */   // Label 3533: @182683
     /*  182683 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(182724), // Rule ID 711 //
     /*  182688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182691 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182698 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182705 */     // MIs[0] rs1
     /*  182705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182717 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182722 */     GIR_RootConstrainSelectedInstOperands,
     /*  182723 */     // GIR_Coverage, 711,
     /*  182723 */     GIR_Done,
     /*  182724 */   // Label 3534: @182724
     /*  182724 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(182765), // Rule ID 713 //
     /*  182729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182732 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182739 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182746 */     // MIs[0] rs1
     /*  182746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182758 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182763 */     GIR_RootConstrainSelectedInstOperands,
     /*  182764 */     // GIR_Coverage, 713,
     /*  182764 */     GIR_Done,
     /*  182765 */   // Label 3535: @182765
     /*  182765 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(182806), // Rule ID 715 //
     /*  182770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182780 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182787 */     // MIs[0] rs1
     /*  182787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182799 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182804 */     GIR_RootConstrainSelectedInstOperands,
     /*  182805 */     // GIR_Coverage, 715,
     /*  182805 */     GIR_Done,
     /*  182806 */   // Label 3536: @182806
     /*  182806 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(182847), // Rule ID 717 //
     /*  182811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182814 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182821 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182828 */     // MIs[0] rs1
     /*  182828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182840 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182845 */     GIR_RootConstrainSelectedInstOperands,
     /*  182846 */     // GIR_Coverage, 717,
     /*  182846 */     GIR_Done,
     /*  182847 */   // Label 3537: @182847
     /*  182847 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(182888), // Rule ID 719 //
     /*  182852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182855 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182862 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182869 */     // MIs[0] rs1
     /*  182869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182881 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182881 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182886 */     GIR_RootConstrainSelectedInstOperands,
     /*  182887 */     // GIR_Coverage, 719,
     /*  182887 */     GIR_Done,
     /*  182888 */   // Label 3538: @182888
     /*  182888 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(182929), // Rule ID 881 //
     /*  182893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182896 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182903 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182910 */     // MIs[0] rs1
     /*  182910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182922 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182927 */     GIR_RootConstrainSelectedInstOperands,
     /*  182928 */     // GIR_Coverage, 881,
     /*  182928 */     GIR_Done,
     /*  182929 */   // Label 3539: @182929
     /*  182929 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(182970), // Rule ID 883 //
     /*  182934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182937 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182944 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182951 */     // MIs[0] rs1
     /*  182951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182963 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  182968 */     GIR_RootConstrainSelectedInstOperands,
     /*  182969 */     // GIR_Coverage, 883,
     /*  182969 */     GIR_Done,
     /*  182970 */   // Label 3540: @182970
     /*  182970 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(183011), // Rule ID 885 //
     /*  182975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182992 */     // MIs[0] rs1
     /*  182992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183004 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  183009 */     GIR_RootConstrainSelectedInstOperands,
     /*  183010 */     // GIR_Coverage, 885,
     /*  183010 */     GIR_Done,
     /*  183011 */   // Label 3541: @183011
     /*  183011 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(183052), // Rule ID 887 //
     /*  183016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183019 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183033 */     // MIs[0] rs1
     /*  183033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183045 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  183050 */     GIR_RootConstrainSelectedInstOperands,
     /*  183051 */     // GIR_Coverage, 887,
     /*  183051 */     GIR_Done,
     /*  183052 */   // Label 3542: @183052
     /*  183052 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(183093), // Rule ID 889 //
     /*  183057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183060 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183074 */     // MIs[0] rs1
     /*  183074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183086 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  183091 */     GIR_RootConstrainSelectedInstOperands,
     /*  183092 */     // GIR_Coverage, 889,
     /*  183092 */     GIR_Done,
     /*  183093 */   // Label 3543: @183093
     /*  183093 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(183134), // Rule ID 891 //
     /*  183098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183101 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183108 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183115 */     // MIs[0] rs1
     /*  183115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183127 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183132 */     GIR_RootConstrainSelectedInstOperands,
     /*  183133 */     // GIR_Coverage, 891,
     /*  183133 */     GIR_Done,
     /*  183134 */   // Label 3544: @183134
     /*  183134 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(183175), // Rule ID 893 //
     /*  183139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183142 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183149 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183156 */     // MIs[0] rs1
     /*  183156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183168 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183173 */     GIR_RootConstrainSelectedInstOperands,
     /*  183174 */     // GIR_Coverage, 893,
     /*  183174 */     GIR_Done,
     /*  183175 */   // Label 3545: @183175
     /*  183175 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(183216), // Rule ID 895 //
     /*  183180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183183 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183190 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183197 */     // MIs[0] rs1
     /*  183197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183209 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183209 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183214 */     GIR_RootConstrainSelectedInstOperands,
     /*  183215 */     // GIR_Coverage, 895,
     /*  183215 */     GIR_Done,
     /*  183216 */   // Label 3546: @183216
     /*  183216 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(183257), // Rule ID 897 //
     /*  183221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183224 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183231 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183238 */     // MIs[0] rs1
     /*  183238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183250 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183255 */     GIR_RootConstrainSelectedInstOperands,
     /*  183256 */     // GIR_Coverage, 897,
     /*  183256 */     GIR_Done,
     /*  183257 */   // Label 3547: @183257
     /*  183257 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(183298), // Rule ID 899 //
     /*  183262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183265 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183272 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183279 */     // MIs[0] rs1
     /*  183279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183291 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183296 */     GIR_RootConstrainSelectedInstOperands,
     /*  183297 */     // GIR_Coverage, 899,
     /*  183297 */     GIR_Done,
     /*  183298 */   // Label 3548: @183298
     /*  183298 */   GIM_Reject,
     /*  183299 */ // Label 3508: @183299
     /*  183299 */ GIM_Reject,
     /*  183300 */ // Label 3476: @183300
     /*  183300 */ GIM_Reject,
     /*  183301 */ // Label 27: @183301
     /*  183301 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3551*/ GIMT_Encode4(186210),
     /*  183312 */ /*GILLT_s32*//*Label 3549*/ GIMT_Encode4(183320),
     /*  183316 */ /*GILLT_s64*//*Label 3550*/ GIMT_Encode4(184560),
     /*  183320 */ // Label 3549: @183320
     /*  183320 */ GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(184559),
     /*  183325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  183328 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(183369), // Rule ID 374 //
     /*  183333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183350 */     // MIs[0] rs1
     /*  183350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183362 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183367 */     GIR_RootConstrainSelectedInstOperands,
     /*  183368 */     // GIR_Coverage, 374,
     /*  183368 */     GIR_Done,
     /*  183369 */   // Label 3553: @183369
     /*  183369 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(183410), // Rule ID 376 //
     /*  183374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183377 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183384 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183391 */     // MIs[0] rs1
     /*  183391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183403 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  183408 */     GIR_RootConstrainSelectedInstOperands,
     /*  183409 */     // GIR_Coverage, 376,
     /*  183409 */     GIR_Done,
     /*  183410 */   // Label 3554: @183410
     /*  183410 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(183451), // Rule ID 378 //
     /*  183415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183418 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183425 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183432 */     // MIs[0] rs1
     /*  183432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183444 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  183449 */     GIR_RootConstrainSelectedInstOperands,
     /*  183450 */     // GIR_Coverage, 378,
     /*  183450 */     GIR_Done,
     /*  183451 */   // Label 3555: @183451
     /*  183451 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(183492), // Rule ID 380 //
     /*  183456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183459 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183466 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183473 */     // MIs[0] rs1
     /*  183473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183485 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  183490 */     GIR_RootConstrainSelectedInstOperands,
     /*  183491 */     // GIR_Coverage, 380,
     /*  183491 */     GIR_Done,
     /*  183492 */   // Label 3556: @183492
     /*  183492 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(183533), // Rule ID 382 //
     /*  183497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183500 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183514 */     // MIs[0] rs1
     /*  183514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183526 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  183531 */     GIR_RootConstrainSelectedInstOperands,
     /*  183532 */     // GIR_Coverage, 382,
     /*  183532 */     GIR_Done,
     /*  183533 */   // Label 3557: @183533
     /*  183533 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(183574), // Rule ID 384 //
     /*  183538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183541 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183548 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183555 */     // MIs[0] rs1
     /*  183555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183567 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183572 */     GIR_RootConstrainSelectedInstOperands,
     /*  183573 */     // GIR_Coverage, 384,
     /*  183573 */     GIR_Done,
     /*  183574 */   // Label 3558: @183574
     /*  183574 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(183615), // Rule ID 386 //
     /*  183579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183582 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183596 */     // MIs[0] rs1
     /*  183596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183608 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183613 */     GIR_RootConstrainSelectedInstOperands,
     /*  183614 */     // GIR_Coverage, 386,
     /*  183614 */     GIR_Done,
     /*  183615 */   // Label 3559: @183615
     /*  183615 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(183656), // Rule ID 388 //
     /*  183620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183623 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183630 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183637 */     // MIs[0] rs1
     /*  183637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183649 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183654 */     GIR_RootConstrainSelectedInstOperands,
     /*  183655 */     // GIR_Coverage, 388,
     /*  183655 */     GIR_Done,
     /*  183656 */   // Label 3560: @183656
     /*  183656 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(183697), // Rule ID 390 //
     /*  183661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183664 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183671 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183678 */     // MIs[0] rs1
     /*  183678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183690 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183695 */     GIR_RootConstrainSelectedInstOperands,
     /*  183696 */     // GIR_Coverage, 390,
     /*  183696 */     GIR_Done,
     /*  183697 */   // Label 3561: @183697
     /*  183697 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(183738), // Rule ID 392 //
     /*  183702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183705 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183719 */     // MIs[0] rs1
     /*  183719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183731 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183736 */     GIR_RootConstrainSelectedInstOperands,
     /*  183737 */     // GIR_Coverage, 392,
     /*  183737 */     GIR_Done,
     /*  183738 */   // Label 3562: @183738
     /*  183738 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(183779), // Rule ID 722 //
     /*  183743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183753 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183760 */     // MIs[0] rs1
     /*  183760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183772 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  183777 */     GIR_RootConstrainSelectedInstOperands,
     /*  183778 */     // GIR_Coverage, 722,
     /*  183778 */     GIR_Done,
     /*  183779 */   // Label 3563: @183779
     /*  183779 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(183820), // Rule ID 724 //
     /*  183784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183787 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183801 */     // MIs[0] rs1
     /*  183801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183813 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  183818 */     GIR_RootConstrainSelectedInstOperands,
     /*  183819 */     // GIR_Coverage, 724,
     /*  183819 */     GIR_Done,
     /*  183820 */   // Label 3564: @183820
     /*  183820 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(183861), // Rule ID 726 //
     /*  183825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183842 */     // MIs[0] rs1
     /*  183842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183854 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  183859 */     GIR_RootConstrainSelectedInstOperands,
     /*  183860 */     // GIR_Coverage, 726,
     /*  183860 */     GIR_Done,
     /*  183861 */   // Label 3565: @183861
     /*  183861 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(183902), // Rule ID 728 //
     /*  183866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183869 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183876 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183883 */     // MIs[0] rs1
     /*  183883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183895 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  183900 */     GIR_RootConstrainSelectedInstOperands,
     /*  183901 */     // GIR_Coverage, 728,
     /*  183901 */     GIR_Done,
     /*  183902 */   // Label 3566: @183902
     /*  183902 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(183943), // Rule ID 730 //
     /*  183907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183924 */     // MIs[0] rs1
     /*  183924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183936 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  183941 */     GIR_RootConstrainSelectedInstOperands,
     /*  183942 */     // GIR_Coverage, 730,
     /*  183942 */     GIR_Done,
     /*  183943 */   // Label 3567: @183943
     /*  183943 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(183984), // Rule ID 732 //
     /*  183948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  183951 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183958 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183965 */     // MIs[0] rs1
     /*  183965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183977 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  183982 */     GIR_RootConstrainSelectedInstOperands,
     /*  183983 */     // GIR_Coverage, 732,
     /*  183983 */     GIR_Done,
     /*  183984 */   // Label 3568: @183984
     /*  183984 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(184025), // Rule ID 734 //
     /*  183989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  183992 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183999 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184006 */     // MIs[0] rs1
     /*  184006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184018 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184023 */     GIR_RootConstrainSelectedInstOperands,
     /*  184024 */     // GIR_Coverage, 734,
     /*  184024 */     GIR_Done,
     /*  184025 */   // Label 3569: @184025
     /*  184025 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(184066), // Rule ID 736 //
     /*  184030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184033 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184040 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184047 */     // MIs[0] rs1
     /*  184047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184059 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184064 */     GIR_RootConstrainSelectedInstOperands,
     /*  184065 */     // GIR_Coverage, 736,
     /*  184065 */     GIR_Done,
     /*  184066 */   // Label 3570: @184066
     /*  184066 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(184107), // Rule ID 738 //
     /*  184071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184074 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184081 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184088 */     // MIs[0] rs1
     /*  184088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184100 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184105 */     GIR_RootConstrainSelectedInstOperands,
     /*  184106 */     // GIR_Coverage, 738,
     /*  184106 */     GIR_Done,
     /*  184107 */   // Label 3571: @184107
     /*  184107 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(184148), // Rule ID 740 //
     /*  184112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184115 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184122 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184129 */     // MIs[0] rs1
     /*  184129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184141 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184146 */     GIR_RootConstrainSelectedInstOperands,
     /*  184147 */     // GIR_Coverage, 740,
     /*  184147 */     GIR_Done,
     /*  184148 */   // Label 3572: @184148
     /*  184148 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(184189), // Rule ID 902 //
     /*  184153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184156 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184170 */     // MIs[0] rs1
     /*  184170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184182 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184187 */     GIR_RootConstrainSelectedInstOperands,
     /*  184188 */     // GIR_Coverage, 902,
     /*  184188 */     GIR_Done,
     /*  184189 */   // Label 3573: @184189
     /*  184189 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(184230), // Rule ID 904 //
     /*  184194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184211 */     // MIs[0] rs1
     /*  184211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184223 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  184228 */     GIR_RootConstrainSelectedInstOperands,
     /*  184229 */     // GIR_Coverage, 904,
     /*  184229 */     GIR_Done,
     /*  184230 */   // Label 3574: @184230
     /*  184230 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(184271), // Rule ID 906 //
     /*  184235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184252 */     // MIs[0] rs1
     /*  184252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184264 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  184269 */     GIR_RootConstrainSelectedInstOperands,
     /*  184270 */     // GIR_Coverage, 906,
     /*  184270 */     GIR_Done,
     /*  184271 */   // Label 3575: @184271
     /*  184271 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(184312), // Rule ID 908 //
     /*  184276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184279 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184286 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184293 */     // MIs[0] rs1
     /*  184293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184305 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  184310 */     GIR_RootConstrainSelectedInstOperands,
     /*  184311 */     // GIR_Coverage, 908,
     /*  184311 */     GIR_Done,
     /*  184312 */   // Label 3576: @184312
     /*  184312 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(184353), // Rule ID 910 //
     /*  184317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184320 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184334 */     // MIs[0] rs1
     /*  184334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184346 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  184351 */     GIR_RootConstrainSelectedInstOperands,
     /*  184352 */     // GIR_Coverage, 910,
     /*  184352 */     GIR_Done,
     /*  184353 */   // Label 3577: @184353
     /*  184353 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(184394), // Rule ID 912 //
     /*  184358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184361 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184368 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184375 */     // MIs[0] rs1
     /*  184375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184387 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184392 */     GIR_RootConstrainSelectedInstOperands,
     /*  184393 */     // GIR_Coverage, 912,
     /*  184393 */     GIR_Done,
     /*  184394 */   // Label 3578: @184394
     /*  184394 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(184435), // Rule ID 914 //
     /*  184399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184402 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184409 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184416 */     // MIs[0] rs1
     /*  184416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184428 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184433 */     GIR_RootConstrainSelectedInstOperands,
     /*  184434 */     // GIR_Coverage, 914,
     /*  184434 */     GIR_Done,
     /*  184435 */   // Label 3579: @184435
     /*  184435 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(184476), // Rule ID 916 //
     /*  184440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184443 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184450 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184457 */     // MIs[0] rs1
     /*  184457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184469 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184474 */     GIR_RootConstrainSelectedInstOperands,
     /*  184475 */     // GIR_Coverage, 916,
     /*  184475 */     GIR_Done,
     /*  184476 */   // Label 3580: @184476
     /*  184476 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(184517), // Rule ID 918 //
     /*  184481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184484 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184491 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184498 */     // MIs[0] rs1
     /*  184498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184510 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184515 */     GIR_RootConstrainSelectedInstOperands,
     /*  184516 */     // GIR_Coverage, 918,
     /*  184516 */     GIR_Done,
     /*  184517 */   // Label 3581: @184517
     /*  184517 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(184558), // Rule ID 920 //
     /*  184522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184525 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184532 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184539 */     // MIs[0] rs1
     /*  184539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184551 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184556 */     GIR_RootConstrainSelectedInstOperands,
     /*  184557 */     // GIR_Coverage, 920,
     /*  184557 */     GIR_Done,
     /*  184558 */   // Label 3582: @184558
     /*  184558 */   GIM_Reject,
     /*  184559 */ // Label 3552: @184559
     /*  184559 */ GIM_Reject,
     /*  184560 */ // Label 3550: @184560
     /*  184560 */ GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(186209),
     /*  184565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  184568 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(184609), // Rule ID 373 //
     /*  184573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184576 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184583 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184590 */     // MIs[0] rs1
     /*  184590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184602 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184607 */     GIR_RootConstrainSelectedInstOperands,
     /*  184608 */     // GIR_Coverage, 373,
     /*  184608 */     GIR_Done,
     /*  184609 */   // Label 3584: @184609
     /*  184609 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(184650), // Rule ID 375 //
     /*  184614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184617 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184624 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184631 */     // MIs[0] rs1
     /*  184631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184643 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  184648 */     GIR_RootConstrainSelectedInstOperands,
     /*  184649 */     // GIR_Coverage, 375,
     /*  184649 */     GIR_Done,
     /*  184650 */   // Label 3585: @184650
     /*  184650 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(184691), // Rule ID 377 //
     /*  184655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184658 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184665 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184672 */     // MIs[0] rs1
     /*  184672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184684 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  184689 */     GIR_RootConstrainSelectedInstOperands,
     /*  184690 */     // GIR_Coverage, 377,
     /*  184690 */     GIR_Done,
     /*  184691 */   // Label 3586: @184691
     /*  184691 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(184732), // Rule ID 379 //
     /*  184696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184699 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184706 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184713 */     // MIs[0] rs1
     /*  184713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184725 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  184730 */     GIR_RootConstrainSelectedInstOperands,
     /*  184731 */     // GIR_Coverage, 379,
     /*  184731 */     GIR_Done,
     /*  184732 */   // Label 3587: @184732
     /*  184732 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(184773), // Rule ID 381 //
     /*  184737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184740 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184747 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184754 */     // MIs[0] rs1
     /*  184754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184766 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  184771 */     GIR_RootConstrainSelectedInstOperands,
     /*  184772 */     // GIR_Coverage, 381,
     /*  184772 */     GIR_Done,
     /*  184773 */   // Label 3588: @184773
     /*  184773 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(184814), // Rule ID 383 //
     /*  184778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184781 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184788 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184795 */     // MIs[0] rs1
     /*  184795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184807 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184812 */     GIR_RootConstrainSelectedInstOperands,
     /*  184813 */     // GIR_Coverage, 383,
     /*  184813 */     GIR_Done,
     /*  184814 */   // Label 3589: @184814
     /*  184814 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(184855), // Rule ID 385 //
     /*  184819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184822 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184829 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184836 */     // MIs[0] rs1
     /*  184836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184848 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184853 */     GIR_RootConstrainSelectedInstOperands,
     /*  184854 */     // GIR_Coverage, 385,
     /*  184854 */     GIR_Done,
     /*  184855 */   // Label 3590: @184855
     /*  184855 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(184896), // Rule ID 387 //
     /*  184860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184863 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184877 */     // MIs[0] rs1
     /*  184877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184889 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184894 */     GIR_RootConstrainSelectedInstOperands,
     /*  184895 */     // GIR_Coverage, 387,
     /*  184895 */     GIR_Done,
     /*  184896 */   // Label 3591: @184896
     /*  184896 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(184937), // Rule ID 389 //
     /*  184901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184904 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184911 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184918 */     // MIs[0] rs1
     /*  184918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184930 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184935 */     GIR_RootConstrainSelectedInstOperands,
     /*  184936 */     // GIR_Coverage, 389,
     /*  184936 */     GIR_Done,
     /*  184937 */   // Label 3592: @184937
     /*  184937 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(184978), // Rule ID 391 //
     /*  184942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184945 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184952 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184959 */     // MIs[0] rs1
     /*  184959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184971 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184976 */     GIR_RootConstrainSelectedInstOperands,
     /*  184977 */     // GIR_Coverage, 391,
     /*  184977 */     GIR_Done,
     /*  184978 */   // Label 3593: @184978
     /*  184978 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(185019), // Rule ID 543 //
     /*  184983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  184986 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  184993 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185000 */     // MIs[0] rs1
     /*  185000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185012 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185017 */     GIR_RootConstrainSelectedInstOperands,
     /*  185018 */     // GIR_Coverage, 543,
     /*  185018 */     GIR_Done,
     /*  185019 */   // Label 3594: @185019
     /*  185019 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(185060), // Rule ID 544 //
     /*  185024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185034 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185041 */     // MIs[0] rs1
     /*  185041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185053 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ),
     /*  185058 */     GIR_RootConstrainSelectedInstOperands,
     /*  185059 */     // GIR_Coverage, 544,
     /*  185059 */     GIR_Done,
     /*  185060 */   // Label 3595: @185060
     /*  185060 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(185101), // Rule ID 545 //
     /*  185065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185068 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185075 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185082 */     // MIs[0] rs1
     /*  185082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185094 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_RL),
     /*  185099 */     GIR_RootConstrainSelectedInstOperands,
     /*  185100 */     // GIR_Coverage, 545,
     /*  185100 */     GIR_Done,
     /*  185101 */   // Label 3596: @185101
     /*  185101 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(185142), // Rule ID 546 //
     /*  185106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185109 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185123 */     // MIs[0] rs1
     /*  185123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185135 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  185140 */     GIR_RootConstrainSelectedInstOperands,
     /*  185141 */     // GIR_Coverage, 546,
     /*  185141 */     GIR_Done,
     /*  185142 */   // Label 3597: @185142
     /*  185142 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(185183), // Rule ID 547 //
     /*  185147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185150 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185157 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185164 */     // MIs[0] rs1
     /*  185164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185176 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  185181 */     GIR_RootConstrainSelectedInstOperands,
     /*  185182 */     // GIR_Coverage, 547,
     /*  185182 */     GIR_Done,
     /*  185183 */   // Label 3598: @185183
     /*  185183 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(185224), // Rule ID 548 //
     /*  185188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185191 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185198 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185205 */     // MIs[0] rs1
     /*  185205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185217 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185222 */     GIR_RootConstrainSelectedInstOperands,
     /*  185223 */     // GIR_Coverage, 548,
     /*  185223 */     GIR_Done,
     /*  185224 */   // Label 3599: @185224
     /*  185224 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(185265), // Rule ID 549 //
     /*  185229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185232 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185239 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185246 */     // MIs[0] rs1
     /*  185246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185258 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185263 */     GIR_RootConstrainSelectedInstOperands,
     /*  185264 */     // GIR_Coverage, 549,
     /*  185264 */     GIR_Done,
     /*  185265 */   // Label 3600: @185265
     /*  185265 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(185306), // Rule ID 550 //
     /*  185270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185273 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185280 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185287 */     // MIs[0] rs1
     /*  185287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185299 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185304 */     GIR_RootConstrainSelectedInstOperands,
     /*  185305 */     // GIR_Coverage, 550,
     /*  185305 */     GIR_Done,
     /*  185306 */   // Label 3601: @185306
     /*  185306 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(185347), // Rule ID 551 //
     /*  185311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185314 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185321 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185328 */     // MIs[0] rs1
     /*  185328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185340 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185345 */     GIR_RootConstrainSelectedInstOperands,
     /*  185346 */     // GIR_Coverage, 551,
     /*  185346 */     GIR_Done,
     /*  185347 */   // Label 3602: @185347
     /*  185347 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(185388), // Rule ID 552 //
     /*  185352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185355 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185362 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185369 */     // MIs[0] rs1
     /*  185369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185381 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185386 */     GIR_RootConstrainSelectedInstOperands,
     /*  185387 */     // GIR_Coverage, 552,
     /*  185387 */     GIR_Done,
     /*  185388 */   // Label 3603: @185388
     /*  185388 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(185429), // Rule ID 721 //
     /*  185393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185403 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185410 */     // MIs[0] rs1
     /*  185410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185422 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185427 */     GIR_RootConstrainSelectedInstOperands,
     /*  185428 */     // GIR_Coverage, 721,
     /*  185428 */     GIR_Done,
     /*  185429 */   // Label 3604: @185429
     /*  185429 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(185470), // Rule ID 723 //
     /*  185434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185437 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185444 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185451 */     // MIs[0] rs1
     /*  185451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185463 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  185468 */     GIR_RootConstrainSelectedInstOperands,
     /*  185469 */     // GIR_Coverage, 723,
     /*  185469 */     GIR_Done,
     /*  185470 */   // Label 3605: @185470
     /*  185470 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(185511), // Rule ID 725 //
     /*  185475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185478 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185485 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185492 */     // MIs[0] rs1
     /*  185492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185504 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  185509 */     GIR_RootConstrainSelectedInstOperands,
     /*  185510 */     // GIR_Coverage, 725,
     /*  185510 */     GIR_Done,
     /*  185511 */   // Label 3606: @185511
     /*  185511 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(185552), // Rule ID 727 //
     /*  185516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185519 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185526 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185533 */     // MIs[0] rs1
     /*  185533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185545 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  185550 */     GIR_RootConstrainSelectedInstOperands,
     /*  185551 */     // GIR_Coverage, 727,
     /*  185551 */     GIR_Done,
     /*  185552 */   // Label 3607: @185552
     /*  185552 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(185593), // Rule ID 729 //
     /*  185557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185560 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185567 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185574 */     // MIs[0] rs1
     /*  185574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185586 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  185591 */     GIR_RootConstrainSelectedInstOperands,
     /*  185592 */     // GIR_Coverage, 729,
     /*  185592 */     GIR_Done,
     /*  185593 */   // Label 3608: @185593
     /*  185593 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(185634), // Rule ID 731 //
     /*  185598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185601 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185608 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185615 */     // MIs[0] rs1
     /*  185615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185627 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185632 */     GIR_RootConstrainSelectedInstOperands,
     /*  185633 */     // GIR_Coverage, 731,
     /*  185633 */     GIR_Done,
     /*  185634 */   // Label 3609: @185634
     /*  185634 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(185675), // Rule ID 733 //
     /*  185639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185642 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185649 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185656 */     // MIs[0] rs1
     /*  185656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185668 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185668 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185673 */     GIR_RootConstrainSelectedInstOperands,
     /*  185674 */     // GIR_Coverage, 733,
     /*  185674 */     GIR_Done,
     /*  185675 */   // Label 3610: @185675
     /*  185675 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(185716), // Rule ID 735 //
     /*  185680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185683 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185690 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185697 */     // MIs[0] rs1
     /*  185697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185709 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185714 */     GIR_RootConstrainSelectedInstOperands,
     /*  185715 */     // GIR_Coverage, 735,
     /*  185715 */     GIR_Done,
     /*  185716 */   // Label 3611: @185716
     /*  185716 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(185757), // Rule ID 737 //
     /*  185721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185724 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185731 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185738 */     // MIs[0] rs1
     /*  185738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185750 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185755 */     GIR_RootConstrainSelectedInstOperands,
     /*  185756 */     // GIR_Coverage, 737,
     /*  185756 */     GIR_Done,
     /*  185757 */   // Label 3612: @185757
     /*  185757 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(185798), // Rule ID 739 //
     /*  185762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185765 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185772 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185779 */     // MIs[0] rs1
     /*  185779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185791 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185796 */     GIR_RootConstrainSelectedInstOperands,
     /*  185797 */     // GIR_Coverage, 739,
     /*  185797 */     GIR_Done,
     /*  185798 */   // Label 3613: @185798
     /*  185798 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(185839), // Rule ID 901 //
     /*  185803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185806 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185813 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185820 */     // MIs[0] rs1
     /*  185820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185832 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  185837 */     GIR_RootConstrainSelectedInstOperands,
     /*  185838 */     // GIR_Coverage, 901,
     /*  185838 */     GIR_Done,
     /*  185839 */   // Label 3614: @185839
     /*  185839 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(185880), // Rule ID 903 //
     /*  185844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185847 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185854 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185861 */     // MIs[0] rs1
     /*  185861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185873 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  185878 */     GIR_RootConstrainSelectedInstOperands,
     /*  185879 */     // GIR_Coverage, 903,
     /*  185879 */     GIR_Done,
     /*  185880 */   // Label 3615: @185880
     /*  185880 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(185921), // Rule ID 905 //
     /*  185885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185888 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185895 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185902 */     // MIs[0] rs1
     /*  185902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185914 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  185919 */     GIR_RootConstrainSelectedInstOperands,
     /*  185920 */     // GIR_Coverage, 905,
     /*  185920 */     GIR_Done,
     /*  185921 */   // Label 3616: @185921
     /*  185921 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(185962), // Rule ID 907 //
     /*  185926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185943 */     // MIs[0] rs1
     /*  185943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185955 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  185960 */     GIR_RootConstrainSelectedInstOperands,
     /*  185961 */     // GIR_Coverage, 907,
     /*  185961 */     GIR_Done,
     /*  185962 */   // Label 3617: @185962
     /*  185962 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(186003), // Rule ID 909 //
     /*  185967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185984 */     // MIs[0] rs1
     /*  185984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185996 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  186001 */     GIR_RootConstrainSelectedInstOperands,
     /*  186002 */     // GIR_Coverage, 909,
     /*  186002 */     GIR_Done,
     /*  186003 */   // Label 3618: @186003
     /*  186003 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(186044), // Rule ID 911 //
     /*  186008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186025 */     // MIs[0] rs1
     /*  186025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186037 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186042 */     GIR_RootConstrainSelectedInstOperands,
     /*  186043 */     // GIR_Coverage, 911,
     /*  186043 */     GIR_Done,
     /*  186044 */   // Label 3619: @186044
     /*  186044 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(186085), // Rule ID 913 //
     /*  186049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186066 */     // MIs[0] rs1
     /*  186066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186078 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186078 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186083 */     GIR_RootConstrainSelectedInstOperands,
     /*  186084 */     // GIR_Coverage, 913,
     /*  186084 */     GIR_Done,
     /*  186085 */   // Label 3620: @186085
     /*  186085 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(186126), // Rule ID 915 //
     /*  186090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186107 */     // MIs[0] rs1
     /*  186107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186119 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186124 */     GIR_RootConstrainSelectedInstOperands,
     /*  186125 */     // GIR_Coverage, 915,
     /*  186125 */     GIR_Done,
     /*  186126 */   // Label 3621: @186126
     /*  186126 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(186167), // Rule ID 917 //
     /*  186131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186134 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186141 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186148 */     // MIs[0] rs1
     /*  186148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186160 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186165 */     GIR_RootConstrainSelectedInstOperands,
     /*  186166 */     // GIR_Coverage, 917,
     /*  186166 */     GIR_Done,
     /*  186167 */   // Label 3622: @186167
     /*  186167 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(186208), // Rule ID 919 //
     /*  186172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186175 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186182 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186189 */     // MIs[0] rs1
     /*  186189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186201 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186206 */     GIR_RootConstrainSelectedInstOperands,
     /*  186207 */     // GIR_Coverage, 919,
     /*  186207 */     GIR_Done,
     /*  186208 */   // Label 3623: @186208
     /*  186208 */   GIM_Reject,
     /*  186209 */ // Label 3583: @186209
     /*  186209 */ GIM_Reject,
     /*  186210 */ // Label 3551: @186210
     /*  186210 */ GIM_Reject,
     /*  186211 */ // Label 28: @186211
     /*  186211 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3626*/ GIMT_Encode4(189120),
     /*  186222 */ /*GILLT_s32*//*Label 3624*/ GIMT_Encode4(186230),
     /*  186226 */ /*GILLT_s64*//*Label 3625*/ GIMT_Encode4(187470),
     /*  186230 */ // Label 3624: @186230
     /*  186230 */ GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(187469),
     /*  186235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  186238 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(186279), // Rule ID 394 //
     /*  186243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186260 */     // MIs[0] rs1
     /*  186260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186272 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186277 */     GIR_RootConstrainSelectedInstOperands,
     /*  186278 */     // GIR_Coverage, 394,
     /*  186278 */     GIR_Done,
     /*  186279 */   // Label 3628: @186279
     /*  186279 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(186320), // Rule ID 396 //
     /*  186284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186287 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186301 */     // MIs[0] rs1
     /*  186301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186313 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  186318 */     GIR_RootConstrainSelectedInstOperands,
     /*  186319 */     // GIR_Coverage, 396,
     /*  186319 */     GIR_Done,
     /*  186320 */   // Label 3629: @186320
     /*  186320 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(186361), // Rule ID 398 //
     /*  186325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186335 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186342 */     // MIs[0] rs1
     /*  186342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186354 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  186359 */     GIR_RootConstrainSelectedInstOperands,
     /*  186360 */     // GIR_Coverage, 398,
     /*  186360 */     GIR_Done,
     /*  186361 */   // Label 3630: @186361
     /*  186361 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(186402), // Rule ID 400 //
     /*  186366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186369 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186376 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186383 */     // MIs[0] rs1
     /*  186383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186395 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  186400 */     GIR_RootConstrainSelectedInstOperands,
     /*  186401 */     // GIR_Coverage, 400,
     /*  186401 */     GIR_Done,
     /*  186402 */   // Label 3631: @186402
     /*  186402 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(186443), // Rule ID 402 //
     /*  186407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186410 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186417 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186424 */     // MIs[0] rs1
     /*  186424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186436 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  186441 */     GIR_RootConstrainSelectedInstOperands,
     /*  186442 */     // GIR_Coverage, 402,
     /*  186442 */     GIR_Done,
     /*  186443 */   // Label 3632: @186443
     /*  186443 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(186484), // Rule ID 404 //
     /*  186448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186451 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186458 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186465 */     // MIs[0] rs1
     /*  186465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186477 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186482 */     GIR_RootConstrainSelectedInstOperands,
     /*  186483 */     // GIR_Coverage, 404,
     /*  186483 */     GIR_Done,
     /*  186484 */   // Label 3633: @186484
     /*  186484 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(186525), // Rule ID 406 //
     /*  186489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186492 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186499 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186506 */     // MIs[0] rs1
     /*  186506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186518 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186523 */     GIR_RootConstrainSelectedInstOperands,
     /*  186524 */     // GIR_Coverage, 406,
     /*  186524 */     GIR_Done,
     /*  186525 */   // Label 3634: @186525
     /*  186525 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(186566), // Rule ID 408 //
     /*  186530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186533 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186540 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186547 */     // MIs[0] rs1
     /*  186547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186559 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186564 */     GIR_RootConstrainSelectedInstOperands,
     /*  186565 */     // GIR_Coverage, 408,
     /*  186565 */     GIR_Done,
     /*  186566 */   // Label 3635: @186566
     /*  186566 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(186607), // Rule ID 410 //
     /*  186571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186574 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186581 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186588 */     // MIs[0] rs1
     /*  186588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186600 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186605 */     GIR_RootConstrainSelectedInstOperands,
     /*  186606 */     // GIR_Coverage, 410,
     /*  186606 */     GIR_Done,
     /*  186607 */   // Label 3636: @186607
     /*  186607 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(186648), // Rule ID 412 //
     /*  186612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186615 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186622 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186629 */     // MIs[0] rs1
     /*  186629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186641 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186646 */     GIR_RootConstrainSelectedInstOperands,
     /*  186647 */     // GIR_Coverage, 412,
     /*  186647 */     GIR_Done,
     /*  186648 */   // Label 3637: @186648
     /*  186648 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(186689), // Rule ID 742 //
     /*  186653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186656 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186663 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186670 */     // MIs[0] rs1
     /*  186670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186682 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186687 */     GIR_RootConstrainSelectedInstOperands,
     /*  186688 */     // GIR_Coverage, 742,
     /*  186688 */     GIR_Done,
     /*  186689 */   // Label 3638: @186689
     /*  186689 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(186730), // Rule ID 744 //
     /*  186694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186697 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186704 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186711 */     // MIs[0] rs1
     /*  186711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186723 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  186728 */     GIR_RootConstrainSelectedInstOperands,
     /*  186729 */     // GIR_Coverage, 744,
     /*  186729 */     GIR_Done,
     /*  186730 */   // Label 3639: @186730
     /*  186730 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(186771), // Rule ID 746 //
     /*  186735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186738 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186745 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186752 */     // MIs[0] rs1
     /*  186752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186764 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  186769 */     GIR_RootConstrainSelectedInstOperands,
     /*  186770 */     // GIR_Coverage, 746,
     /*  186770 */     GIR_Done,
     /*  186771 */   // Label 3640: @186771
     /*  186771 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(186812), // Rule ID 748 //
     /*  186776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186779 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186793 */     // MIs[0] rs1
     /*  186793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186805 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  186810 */     GIR_RootConstrainSelectedInstOperands,
     /*  186811 */     // GIR_Coverage, 748,
     /*  186811 */     GIR_Done,
     /*  186812 */   // Label 3641: @186812
     /*  186812 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(186853), // Rule ID 750 //
     /*  186817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186820 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186827 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186834 */     // MIs[0] rs1
     /*  186834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186846 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  186851 */     GIR_RootConstrainSelectedInstOperands,
     /*  186852 */     // GIR_Coverage, 750,
     /*  186852 */     GIR_Done,
     /*  186853 */   // Label 3642: @186853
     /*  186853 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(186894), // Rule ID 752 //
     /*  186858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186861 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186875 */     // MIs[0] rs1
     /*  186875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186887 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186892 */     GIR_RootConstrainSelectedInstOperands,
     /*  186893 */     // GIR_Coverage, 752,
     /*  186893 */     GIR_Done,
     /*  186894 */   // Label 3643: @186894
     /*  186894 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(186935), // Rule ID 754 //
     /*  186899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186902 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186909 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186916 */     // MIs[0] rs1
     /*  186916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186928 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186933 */     GIR_RootConstrainSelectedInstOperands,
     /*  186934 */     // GIR_Coverage, 754,
     /*  186934 */     GIR_Done,
     /*  186935 */   // Label 3644: @186935
     /*  186935 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(186976), // Rule ID 756 //
     /*  186940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186943 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186950 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186957 */     // MIs[0] rs1
     /*  186957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186969 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186974 */     GIR_RootConstrainSelectedInstOperands,
     /*  186975 */     // GIR_Coverage, 756,
     /*  186975 */     GIR_Done,
     /*  186976 */   // Label 3645: @186976
     /*  186976 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(187017), // Rule ID 758 //
     /*  186981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186984 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186991 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186998 */     // MIs[0] rs1
     /*  186998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187010 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187015 */     GIR_RootConstrainSelectedInstOperands,
     /*  187016 */     // GIR_Coverage, 758,
     /*  187016 */     GIR_Done,
     /*  187017 */   // Label 3646: @187017
     /*  187017 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(187058), // Rule ID 760 //
     /*  187022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187025 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187032 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187039 */     // MIs[0] rs1
     /*  187039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187051 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187056 */     GIR_RootConstrainSelectedInstOperands,
     /*  187057 */     // GIR_Coverage, 760,
     /*  187057 */     GIR_Done,
     /*  187058 */   // Label 3647: @187058
     /*  187058 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(187099), // Rule ID 922 //
     /*  187063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187073 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187080 */     // MIs[0] rs1
     /*  187080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187092 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187097 */     GIR_RootConstrainSelectedInstOperands,
     /*  187098 */     // GIR_Coverage, 922,
     /*  187098 */     GIR_Done,
     /*  187099 */   // Label 3648: @187099
     /*  187099 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(187140), // Rule ID 924 //
     /*  187104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187107 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187114 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187121 */     // MIs[0] rs1
     /*  187121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187133 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  187138 */     GIR_RootConstrainSelectedInstOperands,
     /*  187139 */     // GIR_Coverage, 924,
     /*  187139 */     GIR_Done,
     /*  187140 */   // Label 3649: @187140
     /*  187140 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(187181), // Rule ID 926 //
     /*  187145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187148 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187155 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187162 */     // MIs[0] rs1
     /*  187162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187174 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  187179 */     GIR_RootConstrainSelectedInstOperands,
     /*  187180 */     // GIR_Coverage, 926,
     /*  187180 */     GIR_Done,
     /*  187181 */   // Label 3650: @187181
     /*  187181 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(187222), // Rule ID 928 //
     /*  187186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187189 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187203 */     // MIs[0] rs1
     /*  187203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187215 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  187220 */     GIR_RootConstrainSelectedInstOperands,
     /*  187221 */     // GIR_Coverage, 928,
     /*  187221 */     GIR_Done,
     /*  187222 */   // Label 3651: @187222
     /*  187222 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(187263), // Rule ID 930 //
     /*  187227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187230 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187237 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187244 */     // MIs[0] rs1
     /*  187244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187256 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  187261 */     GIR_RootConstrainSelectedInstOperands,
     /*  187262 */     // GIR_Coverage, 930,
     /*  187262 */     GIR_Done,
     /*  187263 */   // Label 3652: @187263
     /*  187263 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(187304), // Rule ID 932 //
     /*  187268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187271 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187285 */     // MIs[0] rs1
     /*  187285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187297 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187297 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187302 */     GIR_RootConstrainSelectedInstOperands,
     /*  187303 */     // GIR_Coverage, 932,
     /*  187303 */     GIR_Done,
     /*  187304 */   // Label 3653: @187304
     /*  187304 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(187345), // Rule ID 934 //
     /*  187309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187312 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187326 */     // MIs[0] rs1
     /*  187326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187338 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187343 */     GIR_RootConstrainSelectedInstOperands,
     /*  187344 */     // GIR_Coverage, 934,
     /*  187344 */     GIR_Done,
     /*  187345 */   // Label 3654: @187345
     /*  187345 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(187386), // Rule ID 936 //
     /*  187350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187353 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187360 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187367 */     // MIs[0] rs1
     /*  187367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187379 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187384 */     GIR_RootConstrainSelectedInstOperands,
     /*  187385 */     // GIR_Coverage, 936,
     /*  187385 */     GIR_Done,
     /*  187386 */   // Label 3655: @187386
     /*  187386 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(187427), // Rule ID 938 //
     /*  187391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187394 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187401 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187408 */     // MIs[0] rs1
     /*  187408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187420 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187425 */     GIR_RootConstrainSelectedInstOperands,
     /*  187426 */     // GIR_Coverage, 938,
     /*  187426 */     GIR_Done,
     /*  187427 */   // Label 3656: @187427
     /*  187427 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(187468), // Rule ID 940 //
     /*  187432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187435 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187442 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187449 */     // MIs[0] rs1
     /*  187449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187461 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187466 */     GIR_RootConstrainSelectedInstOperands,
     /*  187467 */     // GIR_Coverage, 940,
     /*  187467 */     GIR_Done,
     /*  187468 */   // Label 3657: @187468
     /*  187468 */   GIM_Reject,
     /*  187469 */ // Label 3627: @187469
     /*  187469 */ GIM_Reject,
     /*  187470 */ // Label 3625: @187470
     /*  187470 */ GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(189119),
     /*  187475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  187478 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(187519), // Rule ID 393 //
     /*  187483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187486 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187493 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187500 */     // MIs[0] rs1
     /*  187500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187512 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187517 */     GIR_RootConstrainSelectedInstOperands,
     /*  187518 */     // GIR_Coverage, 393,
     /*  187518 */     GIR_Done,
     /*  187519 */   // Label 3659: @187519
     /*  187519 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(187560), // Rule ID 395 //
     /*  187524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187527 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187534 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187541 */     // MIs[0] rs1
     /*  187541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187553 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  187558 */     GIR_RootConstrainSelectedInstOperands,
     /*  187559 */     // GIR_Coverage, 395,
     /*  187559 */     GIR_Done,
     /*  187560 */   // Label 3660: @187560
     /*  187560 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(187601), // Rule ID 397 //
     /*  187565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187568 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187582 */     // MIs[0] rs1
     /*  187582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187594 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  187599 */     GIR_RootConstrainSelectedInstOperands,
     /*  187600 */     // GIR_Coverage, 397,
     /*  187600 */     GIR_Done,
     /*  187601 */   // Label 3661: @187601
     /*  187601 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(187642), // Rule ID 399 //
     /*  187606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187609 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187616 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187623 */     // MIs[0] rs1
     /*  187623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187635 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  187640 */     GIR_RootConstrainSelectedInstOperands,
     /*  187641 */     // GIR_Coverage, 399,
     /*  187641 */     GIR_Done,
     /*  187642 */   // Label 3662: @187642
     /*  187642 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(187683), // Rule ID 401 //
     /*  187647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187650 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187657 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187664 */     // MIs[0] rs1
     /*  187664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187676 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187676 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  187681 */     GIR_RootConstrainSelectedInstOperands,
     /*  187682 */     // GIR_Coverage, 401,
     /*  187682 */     GIR_Done,
     /*  187683 */   // Label 3663: @187683
     /*  187683 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(187724), // Rule ID 403 //
     /*  187688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187691 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187698 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187705 */     // MIs[0] rs1
     /*  187705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187717 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187722 */     GIR_RootConstrainSelectedInstOperands,
     /*  187723 */     // GIR_Coverage, 403,
     /*  187723 */     GIR_Done,
     /*  187724 */   // Label 3664: @187724
     /*  187724 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(187765), // Rule ID 405 //
     /*  187729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187732 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187739 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187746 */     // MIs[0] rs1
     /*  187746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187758 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187763 */     GIR_RootConstrainSelectedInstOperands,
     /*  187764 */     // GIR_Coverage, 405,
     /*  187764 */     GIR_Done,
     /*  187765 */   // Label 3665: @187765
     /*  187765 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(187806), // Rule ID 407 //
     /*  187770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187780 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187787 */     // MIs[0] rs1
     /*  187787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187799 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187804 */     GIR_RootConstrainSelectedInstOperands,
     /*  187805 */     // GIR_Coverage, 407,
     /*  187805 */     GIR_Done,
     /*  187806 */   // Label 3666: @187806
     /*  187806 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(187847), // Rule ID 409 //
     /*  187811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187814 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187821 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187828 */     // MIs[0] rs1
     /*  187828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187840 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187845 */     GIR_RootConstrainSelectedInstOperands,
     /*  187846 */     // GIR_Coverage, 409,
     /*  187846 */     GIR_Done,
     /*  187847 */   // Label 3667: @187847
     /*  187847 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(187888), // Rule ID 411 //
     /*  187852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187855 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187862 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187869 */     // MIs[0] rs1
     /*  187869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187881 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187881 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187886 */     GIR_RootConstrainSelectedInstOperands,
     /*  187887 */     // GIR_Coverage, 411,
     /*  187887 */     GIR_Done,
     /*  187888 */   // Label 3668: @187888
     /*  187888 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(187929), // Rule ID 553 //
     /*  187893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  187896 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187903 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187910 */     // MIs[0] rs1
     /*  187910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187922 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  187927 */     GIR_RootConstrainSelectedInstOperands,
     /*  187928 */     // GIR_Coverage, 553,
     /*  187928 */     GIR_Done,
     /*  187929 */   // Label 3669: @187929
     /*  187929 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(187970), // Rule ID 554 //
     /*  187934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  187937 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187944 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187951 */     // MIs[0] rs1
     /*  187951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187963 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ),
     /*  187968 */     GIR_RootConstrainSelectedInstOperands,
     /*  187969 */     // GIR_Coverage, 554,
     /*  187969 */     GIR_Done,
     /*  187970 */   // Label 3670: @187970
     /*  187970 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(188011), // Rule ID 555 //
     /*  187975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  187978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187992 */     // MIs[0] rs1
     /*  187992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188004 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_RL),
     /*  188009 */     GIR_RootConstrainSelectedInstOperands,
     /*  188010 */     // GIR_Coverage, 555,
     /*  188010 */     GIR_Done,
     /*  188011 */   // Label 3671: @188011
     /*  188011 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(188052), // Rule ID 556 //
     /*  188016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188019 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188033 */     // MIs[0] rs1
     /*  188033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188045 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  188050 */     GIR_RootConstrainSelectedInstOperands,
     /*  188051 */     // GIR_Coverage, 556,
     /*  188051 */     GIR_Done,
     /*  188052 */   // Label 3672: @188052
     /*  188052 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(188093), // Rule ID 557 //
     /*  188057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188060 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188074 */     // MIs[0] rs1
     /*  188074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188086 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  188091 */     GIR_RootConstrainSelectedInstOperands,
     /*  188092 */     // GIR_Coverage, 557,
     /*  188092 */     GIR_Done,
     /*  188093 */   // Label 3673: @188093
     /*  188093 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(188134), // Rule ID 558 //
     /*  188098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188101 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188108 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188115 */     // MIs[0] rs1
     /*  188115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188127 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188132 */     GIR_RootConstrainSelectedInstOperands,
     /*  188133 */     // GIR_Coverage, 558,
     /*  188133 */     GIR_Done,
     /*  188134 */   // Label 3674: @188134
     /*  188134 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(188175), // Rule ID 559 //
     /*  188139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188142 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188149 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188156 */     // MIs[0] rs1
     /*  188156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188168 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188173 */     GIR_RootConstrainSelectedInstOperands,
     /*  188174 */     // GIR_Coverage, 559,
     /*  188174 */     GIR_Done,
     /*  188175 */   // Label 3675: @188175
     /*  188175 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(188216), // Rule ID 560 //
     /*  188180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188183 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188190 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188197 */     // MIs[0] rs1
     /*  188197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188209 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188209 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188214 */     GIR_RootConstrainSelectedInstOperands,
     /*  188215 */     // GIR_Coverage, 560,
     /*  188215 */     GIR_Done,
     /*  188216 */   // Label 3676: @188216
     /*  188216 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(188257), // Rule ID 561 //
     /*  188221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188224 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188231 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188238 */     // MIs[0] rs1
     /*  188238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188250 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188255 */     GIR_RootConstrainSelectedInstOperands,
     /*  188256 */     // GIR_Coverage, 561,
     /*  188256 */     GIR_Done,
     /*  188257 */   // Label 3677: @188257
     /*  188257 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(188298), // Rule ID 562 //
     /*  188262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188265 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188272 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188279 */     // MIs[0] rs1
     /*  188279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188291 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188296 */     GIR_RootConstrainSelectedInstOperands,
     /*  188297 */     // GIR_Coverage, 562,
     /*  188297 */     GIR_Done,
     /*  188298 */   // Label 3678: @188298
     /*  188298 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(188339), // Rule ID 741 //
     /*  188303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188306 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188313 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188320 */     // MIs[0] rs1
     /*  188320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188332 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188337 */     GIR_RootConstrainSelectedInstOperands,
     /*  188338 */     // GIR_Coverage, 741,
     /*  188338 */     GIR_Done,
     /*  188339 */   // Label 3679: @188339
     /*  188339 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(188380), // Rule ID 743 //
     /*  188344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188347 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188354 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188361 */     // MIs[0] rs1
     /*  188361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188373 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  188378 */     GIR_RootConstrainSelectedInstOperands,
     /*  188379 */     // GIR_Coverage, 743,
     /*  188379 */     GIR_Done,
     /*  188380 */   // Label 3680: @188380
     /*  188380 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(188421), // Rule ID 745 //
     /*  188385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188388 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188402 */     // MIs[0] rs1
     /*  188402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188414 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  188419 */     GIR_RootConstrainSelectedInstOperands,
     /*  188420 */     // GIR_Coverage, 745,
     /*  188420 */     GIR_Done,
     /*  188421 */   // Label 3681: @188421
     /*  188421 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(188462), // Rule ID 747 //
     /*  188426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188429 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188436 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188443 */     // MIs[0] rs1
     /*  188443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188455 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  188460 */     GIR_RootConstrainSelectedInstOperands,
     /*  188461 */     // GIR_Coverage, 747,
     /*  188461 */     GIR_Done,
     /*  188462 */   // Label 3682: @188462
     /*  188462 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(188503), // Rule ID 749 //
     /*  188467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188470 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188477 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188484 */     // MIs[0] rs1
     /*  188484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188496 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  188501 */     GIR_RootConstrainSelectedInstOperands,
     /*  188502 */     // GIR_Coverage, 749,
     /*  188502 */     GIR_Done,
     /*  188503 */   // Label 3683: @188503
     /*  188503 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(188544), // Rule ID 751 //
     /*  188508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188511 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188518 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188525 */     // MIs[0] rs1
     /*  188525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188537 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188542 */     GIR_RootConstrainSelectedInstOperands,
     /*  188543 */     // GIR_Coverage, 751,
     /*  188543 */     GIR_Done,
     /*  188544 */   // Label 3684: @188544
     /*  188544 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(188585), // Rule ID 753 //
     /*  188549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188552 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188559 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188566 */     // MIs[0] rs1
     /*  188566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188578 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188583 */     GIR_RootConstrainSelectedInstOperands,
     /*  188584 */     // GIR_Coverage, 753,
     /*  188584 */     GIR_Done,
     /*  188585 */   // Label 3685: @188585
     /*  188585 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(188626), // Rule ID 755 //
     /*  188590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188593 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188600 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188607 */     // MIs[0] rs1
     /*  188607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188619 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188624 */     GIR_RootConstrainSelectedInstOperands,
     /*  188625 */     // GIR_Coverage, 755,
     /*  188625 */     GIR_Done,
     /*  188626 */   // Label 3686: @188626
     /*  188626 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(188667), // Rule ID 757 //
     /*  188631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188634 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188641 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188648 */     // MIs[0] rs1
     /*  188648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188660 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188660 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188665 */     GIR_RootConstrainSelectedInstOperands,
     /*  188666 */     // GIR_Coverage, 757,
     /*  188666 */     GIR_Done,
     /*  188667 */   // Label 3687: @188667
     /*  188667 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(188708), // Rule ID 759 //
     /*  188672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188675 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188682 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188689 */     // MIs[0] rs1
     /*  188689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188701 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188706 */     GIR_RootConstrainSelectedInstOperands,
     /*  188707 */     // GIR_Coverage, 759,
     /*  188707 */     GIR_Done,
     /*  188708 */   // Label 3688: @188708
     /*  188708 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(188749), // Rule ID 921 //
     /*  188713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188716 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188723 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188730 */     // MIs[0] rs1
     /*  188730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188742 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  188747 */     GIR_RootConstrainSelectedInstOperands,
     /*  188748 */     // GIR_Coverage, 921,
     /*  188748 */     GIR_Done,
     /*  188749 */   // Label 3689: @188749
     /*  188749 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(188790), // Rule ID 923 //
     /*  188754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188757 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188764 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188771 */     // MIs[0] rs1
     /*  188771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188783 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  188788 */     GIR_RootConstrainSelectedInstOperands,
     /*  188789 */     // GIR_Coverage, 923,
     /*  188789 */     GIR_Done,
     /*  188790 */   // Label 3690: @188790
     /*  188790 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(188831), // Rule ID 925 //
     /*  188795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188798 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188812 */     // MIs[0] rs1
     /*  188812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188824 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  188829 */     GIR_RootConstrainSelectedInstOperands,
     /*  188830 */     // GIR_Coverage, 925,
     /*  188830 */     GIR_Done,
     /*  188831 */   // Label 3691: @188831
     /*  188831 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(188872), // Rule ID 927 //
     /*  188836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188839 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188846 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188853 */     // MIs[0] rs1
     /*  188853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188865 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  188870 */     GIR_RootConstrainSelectedInstOperands,
     /*  188871 */     // GIR_Coverage, 927,
     /*  188871 */     GIR_Done,
     /*  188872 */   // Label 3692: @188872
     /*  188872 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(188913), // Rule ID 929 //
     /*  188877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188880 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188894 */     // MIs[0] rs1
     /*  188894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188906 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  188911 */     GIR_RootConstrainSelectedInstOperands,
     /*  188912 */     // GIR_Coverage, 929,
     /*  188912 */     GIR_Done,
     /*  188913 */   // Label 3693: @188913
     /*  188913 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(188954), // Rule ID 931 //
     /*  188918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188921 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188935 */     // MIs[0] rs1
     /*  188935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188947 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  188952 */     GIR_RootConstrainSelectedInstOperands,
     /*  188953 */     // GIR_Coverage, 931,
     /*  188953 */     GIR_Done,
     /*  188954 */   // Label 3694: @188954
     /*  188954 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(188995), // Rule ID 933 //
     /*  188959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188976 */     // MIs[0] rs1
     /*  188976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188988 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  188993 */     GIR_RootConstrainSelectedInstOperands,
     /*  188994 */     // GIR_Coverage, 933,
     /*  188994 */     GIR_Done,
     /*  188995 */   // Label 3695: @188995
     /*  188995 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(189036), // Rule ID 935 //
     /*  189000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189017 */     // MIs[0] rs1
     /*  189017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189029 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189034 */     GIR_RootConstrainSelectedInstOperands,
     /*  189035 */     // GIR_Coverage, 935,
     /*  189035 */     GIR_Done,
     /*  189036 */   // Label 3696: @189036
     /*  189036 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(189077), // Rule ID 937 //
     /*  189041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189044 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189058 */     // MIs[0] rs1
     /*  189058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189070 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189075 */     GIR_RootConstrainSelectedInstOperands,
     /*  189076 */     // GIR_Coverage, 937,
     /*  189076 */     GIR_Done,
     /*  189077 */   // Label 3697: @189077
     /*  189077 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(189118), // Rule ID 939 //
     /*  189082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189085 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189092 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189099 */     // MIs[0] rs1
     /*  189099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189111 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189116 */     GIR_RootConstrainSelectedInstOperands,
     /*  189117 */     // GIR_Coverage, 939,
     /*  189117 */     GIR_Done,
     /*  189118 */   // Label 3698: @189118
     /*  189118 */   GIM_Reject,
     /*  189119 */ // Label 3658: @189119
     /*  189119 */ GIM_Reject,
     /*  189120 */ // Label 3626: @189120
     /*  189120 */ GIM_Reject,
     /*  189121 */ // Label 29: @189121
     /*  189121 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3701*/ GIMT_Encode4(190032),
     /*  189132 */ /*GILLT_s32*//*Label 3699*/ GIMT_Encode4(189140),
     /*  189136 */ /*GILLT_s64*//*Label 3700*/ GIMT_Encode4(189422),
     /*  189140 */ // Label 3699: @189140
     /*  189140 */ GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(189421),
     /*  189145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  189148 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189155 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(189208), // Rule ID 624 //
     /*  189160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189170 */     // MIs[0] addr
     /*  189170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189182 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 2:{ *:[i32] })
     /*  189182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189190 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189195 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189197 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  189202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189206 */     GIR_RootConstrainSelectedInstOperands,
     /*  189207 */     // GIR_Coverage, 624,
     /*  189207 */     GIR_EraseRootFromParent_Done,
     /*  189208 */   // Label 3703: @189208
     /*  189208 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(189261), // Rule ID 626 //
     /*  189213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189216 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189223 */     // MIs[0] addr
     /*  189223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189235 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 4:{ *:[i32] })
     /*  189235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189243 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189248 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189250 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189259 */     GIR_RootConstrainSelectedInstOperands,
     /*  189260 */     // GIR_Coverage, 626,
     /*  189260 */     GIR_EraseRootFromParent_Done,
     /*  189261 */   // Label 3704: @189261
     /*  189261 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(189314), // Rule ID 628 //
     /*  189266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189276 */     // MIs[0] addr
     /*  189276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189288 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 5:{ *:[i32] })
     /*  189288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189296 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189301 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189303 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  189308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189312 */     GIR_RootConstrainSelectedInstOperands,
     /*  189313 */     // GIR_Coverage, 628,
     /*  189313 */     GIR_EraseRootFromParent_Done,
     /*  189314 */   // Label 3705: @189314
     /*  189314 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(189367), // Rule ID 630 //
     /*  189319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189322 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189329 */     // MIs[0] addr
     /*  189329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189341 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 6:{ *:[i32] })
     /*  189341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189349 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189354 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189356 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  189361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189365 */     GIR_RootConstrainSelectedInstOperands,
     /*  189366 */     // GIR_Coverage, 630,
     /*  189366 */     GIR_EraseRootFromParent_Done,
     /*  189367 */   // Label 3706: @189367
     /*  189367 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(189420), // Rule ID 632 //
     /*  189372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189382 */     // MIs[0] addr
     /*  189382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189394 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 7:{ *:[i32] })
     /*  189394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189402 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189407 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189409 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  189414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189418 */     GIR_RootConstrainSelectedInstOperands,
     /*  189419 */     // GIR_Coverage, 632,
     /*  189419 */     GIR_EraseRootFromParent_Done,
     /*  189420 */   // Label 3707: @189420
     /*  189420 */   GIM_Reject,
     /*  189421 */ // Label 3702: @189421
     /*  189421 */ GIM_Reject,
     /*  189422 */ // Label 3700: @189422
     /*  189422 */ GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(190031),
     /*  189427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  189430 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(189490), // Rule ID 623 //
     /*  189435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189438 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189445 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189452 */     // MIs[0] addr
     /*  189452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189464 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  189464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189472 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189477 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189479 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  189484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189488 */     GIR_RootConstrainSelectedInstOperands,
     /*  189489 */     // GIR_Coverage, 623,
     /*  189489 */     GIR_EraseRootFromParent_Done,
     /*  189490 */   // Label 3709: @189490
     /*  189490 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(189550), // Rule ID 625 //
     /*  189495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189512 */     // MIs[0] addr
     /*  189512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189524 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  189524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189532 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189537 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189539 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189548 */     GIR_RootConstrainSelectedInstOperands,
     /*  189549 */     // GIR_Coverage, 625,
     /*  189549 */     GIR_EraseRootFromParent_Done,
     /*  189550 */   // Label 3710: @189550
     /*  189550 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(189610), // Rule ID 627 //
     /*  189555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189558 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189565 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189572 */     // MIs[0] addr
     /*  189572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189584 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  189584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189592 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189597 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189599 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  189604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189608 */     GIR_RootConstrainSelectedInstOperands,
     /*  189609 */     // GIR_Coverage, 627,
     /*  189609 */     GIR_EraseRootFromParent_Done,
     /*  189610 */   // Label 3711: @189610
     /*  189610 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(189670), // Rule ID 629 //
     /*  189615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189632 */     // MIs[0] addr
     /*  189632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189644 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  189644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189652 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189657 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189659 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  189664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189668 */     GIR_RootConstrainSelectedInstOperands,
     /*  189669 */     // GIR_Coverage, 629,
     /*  189669 */     GIR_EraseRootFromParent_Done,
     /*  189670 */   // Label 3712: @189670
     /*  189670 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(189730), // Rule ID 631 //
     /*  189675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189678 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189692 */     // MIs[0] addr
     /*  189692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189704 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  189704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189712 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189717 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189719 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  189724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189728 */     GIR_RootConstrainSelectedInstOperands,
     /*  189729 */     // GIR_Coverage, 631,
     /*  189729 */     GIR_EraseRootFromParent_Done,
     /*  189730 */   // Label 3713: @189730
     /*  189730 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(189790), // Rule ID 641 //
     /*  189735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189738 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189745 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189752 */     // MIs[0] addr
     /*  189752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189764 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_monotonic>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  189764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189772 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189777 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189779 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  189784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189788 */     GIR_RootConstrainSelectedInstOperands,
     /*  189789 */     // GIR_Coverage, 641,
     /*  189789 */     GIR_EraseRootFromParent_Done,
     /*  189790 */   // Label 3714: @189790
     /*  189790 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(189850), // Rule ID 642 //
     /*  189795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189798 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189812 */     // MIs[0] addr
     /*  189812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189824 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acquire>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  189824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189832 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189837 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189839 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189848 */     GIR_RootConstrainSelectedInstOperands,
     /*  189849 */     // GIR_Coverage, 642,
     /*  189849 */     GIR_EraseRootFromParent_Done,
     /*  189850 */   // Label 3715: @189850
     /*  189850 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(189910), // Rule ID 643 //
     /*  189855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189858 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189865 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189872 */     // MIs[0] addr
     /*  189872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189884 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_release>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  189884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189892 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189897 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189899 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  189904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189908 */     GIR_RootConstrainSelectedInstOperands,
     /*  189909 */     // GIR_Coverage, 643,
     /*  189909 */     GIR_EraseRootFromParent_Done,
     /*  189910 */   // Label 3716: @189910
     /*  189910 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(189970), // Rule ID 644 //
     /*  189915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189932 */     // MIs[0] addr
     /*  189932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189944 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acq_rel>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  189944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189952 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189957 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189959 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  189964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189968 */     GIR_RootConstrainSelectedInstOperands,
     /*  189969 */     // GIR_Coverage, 644,
     /*  189969 */     GIR_EraseRootFromParent_Done,
     /*  189970 */   // Label 3717: @189970
     /*  189970 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(190030), // Rule ID 645 //
     /*  189975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189992 */     // MIs[0] addr
     /*  189992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190004 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_seq_cst>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  190004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  190010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190012 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190017 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190019 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  190024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190028 */     GIR_RootConstrainSelectedInstOperands,
     /*  190029 */     // GIR_Coverage, 645,
     /*  190029 */     GIR_EraseRootFromParent_Done,
     /*  190030 */   // Label 3718: @190030
     /*  190030 */   GIM_Reject,
     /*  190031 */ // Label 3708: @190031
     /*  190031 */ GIM_Reject,
     /*  190032 */ // Label 3701: @190032
     /*  190032 */ GIM_Reject,
     /*  190033 */ // Label 30: @190033
     /*  190033 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3721*/ GIMT_Encode4(192942),
     /*  190044 */ /*GILLT_s32*//*Label 3719*/ GIMT_Encode4(190052),
     /*  190048 */ /*GILLT_s64*//*Label 3720*/ GIMT_Encode4(191292),
     /*  190052 */ // Label 3719: @190052
     /*  190052 */ GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(191291),
     /*  190057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  190060 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(190101), // Rule ID 414 //
     /*  190065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190068 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190075 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190082 */     // MIs[0] rs1
     /*  190082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190094 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190099 */     GIR_RootConstrainSelectedInstOperands,
     /*  190100 */     // GIR_Coverage, 414,
     /*  190100 */     GIR_Done,
     /*  190101 */   // Label 3723: @190101
     /*  190101 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(190142), // Rule ID 416 //
     /*  190106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190109 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190123 */     // MIs[0] rs1
     /*  190123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190135 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  190140 */     GIR_RootConstrainSelectedInstOperands,
     /*  190141 */     // GIR_Coverage, 416,
     /*  190141 */     GIR_Done,
     /*  190142 */   // Label 3724: @190142
     /*  190142 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(190183), // Rule ID 418 //
     /*  190147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190150 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190157 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190164 */     // MIs[0] rs1
     /*  190164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190176 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  190181 */     GIR_RootConstrainSelectedInstOperands,
     /*  190182 */     // GIR_Coverage, 418,
     /*  190182 */     GIR_Done,
     /*  190183 */   // Label 3725: @190183
     /*  190183 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(190224), // Rule ID 420 //
     /*  190188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190191 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190198 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190205 */     // MIs[0] rs1
     /*  190205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190217 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  190222 */     GIR_RootConstrainSelectedInstOperands,
     /*  190223 */     // GIR_Coverage, 420,
     /*  190223 */     GIR_Done,
     /*  190224 */   // Label 3726: @190224
     /*  190224 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(190265), // Rule ID 422 //
     /*  190229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190232 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190239 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190246 */     // MIs[0] rs1
     /*  190246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190258 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  190263 */     GIR_RootConstrainSelectedInstOperands,
     /*  190264 */     // GIR_Coverage, 422,
     /*  190264 */     GIR_Done,
     /*  190265 */   // Label 3727: @190265
     /*  190265 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(190306), // Rule ID 424 //
     /*  190270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190273 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190280 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190287 */     // MIs[0] rs1
     /*  190287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190299 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190304 */     GIR_RootConstrainSelectedInstOperands,
     /*  190305 */     // GIR_Coverage, 424,
     /*  190305 */     GIR_Done,
     /*  190306 */   // Label 3728: @190306
     /*  190306 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(190347), // Rule ID 426 //
     /*  190311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190314 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190321 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190328 */     // MIs[0] rs1
     /*  190328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190340 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190345 */     GIR_RootConstrainSelectedInstOperands,
     /*  190346 */     // GIR_Coverage, 426,
     /*  190346 */     GIR_Done,
     /*  190347 */   // Label 3729: @190347
     /*  190347 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(190388), // Rule ID 428 //
     /*  190352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190355 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190362 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190369 */     // MIs[0] rs1
     /*  190369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190381 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190386 */     GIR_RootConstrainSelectedInstOperands,
     /*  190387 */     // GIR_Coverage, 428,
     /*  190387 */     GIR_Done,
     /*  190388 */   // Label 3730: @190388
     /*  190388 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(190429), // Rule ID 430 //
     /*  190393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190403 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190410 */     // MIs[0] rs1
     /*  190410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190422 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190427 */     GIR_RootConstrainSelectedInstOperands,
     /*  190428 */     // GIR_Coverage, 430,
     /*  190428 */     GIR_Done,
     /*  190429 */   // Label 3731: @190429
     /*  190429 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(190470), // Rule ID 432 //
     /*  190434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190437 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190444 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190451 */     // MIs[0] rs1
     /*  190451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190463 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190468 */     GIR_RootConstrainSelectedInstOperands,
     /*  190469 */     // GIR_Coverage, 432,
     /*  190469 */     GIR_Done,
     /*  190470 */   // Label 3732: @190470
     /*  190470 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(190511), // Rule ID 762 //
     /*  190475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190478 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190485 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190492 */     // MIs[0] rs1
     /*  190492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190504 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190509 */     GIR_RootConstrainSelectedInstOperands,
     /*  190510 */     // GIR_Coverage, 762,
     /*  190510 */     GIR_Done,
     /*  190511 */   // Label 3733: @190511
     /*  190511 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(190552), // Rule ID 764 //
     /*  190516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190519 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190526 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190533 */     // MIs[0] rs1
     /*  190533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190545 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  190550 */     GIR_RootConstrainSelectedInstOperands,
     /*  190551 */     // GIR_Coverage, 764,
     /*  190551 */     GIR_Done,
     /*  190552 */   // Label 3734: @190552
     /*  190552 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(190593), // Rule ID 766 //
     /*  190557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190560 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190567 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190574 */     // MIs[0] rs1
     /*  190574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190586 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  190591 */     GIR_RootConstrainSelectedInstOperands,
     /*  190592 */     // GIR_Coverage, 766,
     /*  190592 */     GIR_Done,
     /*  190593 */   // Label 3735: @190593
     /*  190593 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(190634), // Rule ID 768 //
     /*  190598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190601 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190608 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190615 */     // MIs[0] rs1
     /*  190615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190627 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  190632 */     GIR_RootConstrainSelectedInstOperands,
     /*  190633 */     // GIR_Coverage, 768,
     /*  190633 */     GIR_Done,
     /*  190634 */   // Label 3736: @190634
     /*  190634 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(190675), // Rule ID 770 //
     /*  190639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190642 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190649 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190656 */     // MIs[0] rs1
     /*  190656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190668 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190668 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  190673 */     GIR_RootConstrainSelectedInstOperands,
     /*  190674 */     // GIR_Coverage, 770,
     /*  190674 */     GIR_Done,
     /*  190675 */   // Label 3737: @190675
     /*  190675 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(190716), // Rule ID 772 //
     /*  190680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190683 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190690 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190697 */     // MIs[0] rs1
     /*  190697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190709 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190714 */     GIR_RootConstrainSelectedInstOperands,
     /*  190715 */     // GIR_Coverage, 772,
     /*  190715 */     GIR_Done,
     /*  190716 */   // Label 3738: @190716
     /*  190716 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(190757), // Rule ID 774 //
     /*  190721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190724 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190731 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190738 */     // MIs[0] rs1
     /*  190738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190750 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190755 */     GIR_RootConstrainSelectedInstOperands,
     /*  190756 */     // GIR_Coverage, 774,
     /*  190756 */     GIR_Done,
     /*  190757 */   // Label 3739: @190757
     /*  190757 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(190798), // Rule ID 776 //
     /*  190762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190765 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190772 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190779 */     // MIs[0] rs1
     /*  190779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190791 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190796 */     GIR_RootConstrainSelectedInstOperands,
     /*  190797 */     // GIR_Coverage, 776,
     /*  190797 */     GIR_Done,
     /*  190798 */   // Label 3740: @190798
     /*  190798 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(190839), // Rule ID 778 //
     /*  190803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190806 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190813 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190820 */     // MIs[0] rs1
     /*  190820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190832 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190837 */     GIR_RootConstrainSelectedInstOperands,
     /*  190838 */     // GIR_Coverage, 778,
     /*  190838 */     GIR_Done,
     /*  190839 */   // Label 3741: @190839
     /*  190839 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(190880), // Rule ID 780 //
     /*  190844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190847 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190854 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190861 */     // MIs[0] rs1
     /*  190861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190873 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190878 */     GIR_RootConstrainSelectedInstOperands,
     /*  190879 */     // GIR_Coverage, 780,
     /*  190879 */     GIR_Done,
     /*  190880 */   // Label 3742: @190880
     /*  190880 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(190921), // Rule ID 942 //
     /*  190885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190888 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190895 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190902 */     // MIs[0] rs1
     /*  190902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190914 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  190919 */     GIR_RootConstrainSelectedInstOperands,
     /*  190920 */     // GIR_Coverage, 942,
     /*  190920 */     GIR_Done,
     /*  190921 */   // Label 3743: @190921
     /*  190921 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(190962), // Rule ID 944 //
     /*  190926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190943 */     // MIs[0] rs1
     /*  190943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190955 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  190960 */     GIR_RootConstrainSelectedInstOperands,
     /*  190961 */     // GIR_Coverage, 944,
     /*  190961 */     GIR_Done,
     /*  190962 */   // Label 3744: @190962
     /*  190962 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(191003), // Rule ID 946 //
     /*  190967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190984 */     // MIs[0] rs1
     /*  190984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190996 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  191001 */     GIR_RootConstrainSelectedInstOperands,
     /*  191002 */     // GIR_Coverage, 946,
     /*  191002 */     GIR_Done,
     /*  191003 */   // Label 3745: @191003
     /*  191003 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(191044), // Rule ID 948 //
     /*  191008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191025 */     // MIs[0] rs1
     /*  191025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191037 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  191042 */     GIR_RootConstrainSelectedInstOperands,
     /*  191043 */     // GIR_Coverage, 948,
     /*  191043 */     GIR_Done,
     /*  191044 */   // Label 3746: @191044
     /*  191044 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(191085), // Rule ID 950 //
     /*  191049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191066 */     // MIs[0] rs1
     /*  191066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191078 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191078 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  191083 */     GIR_RootConstrainSelectedInstOperands,
     /*  191084 */     // GIR_Coverage, 950,
     /*  191084 */     GIR_Done,
     /*  191085 */   // Label 3747: @191085
     /*  191085 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(191126), // Rule ID 952 //
     /*  191090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191107 */     // MIs[0] rs1
     /*  191107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191119 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191124 */     GIR_RootConstrainSelectedInstOperands,
     /*  191125 */     // GIR_Coverage, 952,
     /*  191125 */     GIR_Done,
     /*  191126 */   // Label 3748: @191126
     /*  191126 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(191167), // Rule ID 954 //
     /*  191131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191134 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191141 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191148 */     // MIs[0] rs1
     /*  191148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191160 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191165 */     GIR_RootConstrainSelectedInstOperands,
     /*  191166 */     // GIR_Coverage, 954,
     /*  191166 */     GIR_Done,
     /*  191167 */   // Label 3749: @191167
     /*  191167 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(191208), // Rule ID 956 //
     /*  191172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191175 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191182 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191189 */     // MIs[0] rs1
     /*  191189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191201 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191206 */     GIR_RootConstrainSelectedInstOperands,
     /*  191207 */     // GIR_Coverage, 956,
     /*  191207 */     GIR_Done,
     /*  191208 */   // Label 3750: @191208
     /*  191208 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(191249), // Rule ID 958 //
     /*  191213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191216 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191223 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191230 */     // MIs[0] rs1
     /*  191230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191242 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191247 */     GIR_RootConstrainSelectedInstOperands,
     /*  191248 */     // GIR_Coverage, 958,
     /*  191248 */     GIR_Done,
     /*  191249 */   // Label 3751: @191249
     /*  191249 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(191290), // Rule ID 960 //
     /*  191254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191257 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191264 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191271 */     // MIs[0] rs1
     /*  191271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191283 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191288 */     GIR_RootConstrainSelectedInstOperands,
     /*  191289 */     // GIR_Coverage, 960,
     /*  191289 */     GIR_Done,
     /*  191290 */   // Label 3752: @191290
     /*  191290 */   GIM_Reject,
     /*  191291 */ // Label 3722: @191291
     /*  191291 */ GIM_Reject,
     /*  191292 */ // Label 3720: @191292
     /*  191292 */ GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(192941),
     /*  191297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  191300 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(191341), // Rule ID 413 //
     /*  191305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191308 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191315 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191322 */     // MIs[0] rs1
     /*  191322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191334 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191339 */     GIR_RootConstrainSelectedInstOperands,
     /*  191340 */     // GIR_Coverage, 413,
     /*  191340 */     GIR_Done,
     /*  191341 */   // Label 3754: @191341
     /*  191341 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(191382), // Rule ID 415 //
     /*  191346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191349 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191356 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191363 */     // MIs[0] rs1
     /*  191363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191375 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  191380 */     GIR_RootConstrainSelectedInstOperands,
     /*  191381 */     // GIR_Coverage, 415,
     /*  191381 */     GIR_Done,
     /*  191382 */   // Label 3755: @191382
     /*  191382 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(191423), // Rule ID 417 //
     /*  191387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191390 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191397 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191404 */     // MIs[0] rs1
     /*  191404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191416 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  191421 */     GIR_RootConstrainSelectedInstOperands,
     /*  191422 */     // GIR_Coverage, 417,
     /*  191422 */     GIR_Done,
     /*  191423 */   // Label 3756: @191423
     /*  191423 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(191464), // Rule ID 419 //
     /*  191428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191431 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191438 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191445 */     // MIs[0] rs1
     /*  191445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191457 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  191462 */     GIR_RootConstrainSelectedInstOperands,
     /*  191463 */     // GIR_Coverage, 419,
     /*  191463 */     GIR_Done,
     /*  191464 */   // Label 3757: @191464
     /*  191464 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(191505), // Rule ID 421 //
     /*  191469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191472 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191486 */     // MIs[0] rs1
     /*  191486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191498 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  191503 */     GIR_RootConstrainSelectedInstOperands,
     /*  191504 */     // GIR_Coverage, 421,
     /*  191504 */     GIR_Done,
     /*  191505 */   // Label 3758: @191505
     /*  191505 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(191546), // Rule ID 423 //
     /*  191510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191513 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191520 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191527 */     // MIs[0] rs1
     /*  191527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191539 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191544 */     GIR_RootConstrainSelectedInstOperands,
     /*  191545 */     // GIR_Coverage, 423,
     /*  191545 */     GIR_Done,
     /*  191546 */   // Label 3759: @191546
     /*  191546 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(191587), // Rule ID 425 //
     /*  191551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191554 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191561 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191568 */     // MIs[0] rs1
     /*  191568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191580 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191585 */     GIR_RootConstrainSelectedInstOperands,
     /*  191586 */     // GIR_Coverage, 425,
     /*  191586 */     GIR_Done,
     /*  191587 */   // Label 3760: @191587
     /*  191587 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(191628), // Rule ID 427 //
     /*  191592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191595 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191602 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191609 */     // MIs[0] rs1
     /*  191609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191621 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191626 */     GIR_RootConstrainSelectedInstOperands,
     /*  191627 */     // GIR_Coverage, 427,
     /*  191627 */     GIR_Done,
     /*  191628 */   // Label 3761: @191628
     /*  191628 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(191669), // Rule ID 429 //
     /*  191633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191636 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191643 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191650 */     // MIs[0] rs1
     /*  191650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191662 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191662 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191667 */     GIR_RootConstrainSelectedInstOperands,
     /*  191668 */     // GIR_Coverage, 429,
     /*  191668 */     GIR_Done,
     /*  191669 */   // Label 3762: @191669
     /*  191669 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(191710), // Rule ID 431 //
     /*  191674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191677 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191684 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191691 */     // MIs[0] rs1
     /*  191691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191703 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191708 */     GIR_RootConstrainSelectedInstOperands,
     /*  191709 */     // GIR_Coverage, 431,
     /*  191709 */     GIR_Done,
     /*  191710 */   // Label 3763: @191710
     /*  191710 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(191751), // Rule ID 563 //
     /*  191715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191718 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191725 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191732 */     // MIs[0] rs1
     /*  191732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191744 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  191749 */     GIR_RootConstrainSelectedInstOperands,
     /*  191750 */     // GIR_Coverage, 563,
     /*  191750 */     GIR_Done,
     /*  191751 */   // Label 3764: @191751
     /*  191751 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(191792), // Rule ID 564 //
     /*  191756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191759 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191766 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191773 */     // MIs[0] rs1
     /*  191773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191785 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ),
     /*  191790 */     GIR_RootConstrainSelectedInstOperands,
     /*  191791 */     // GIR_Coverage, 564,
     /*  191791 */     GIR_Done,
     /*  191792 */   // Label 3765: @191792
     /*  191792 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(191833), // Rule ID 565 //
     /*  191797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191800 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191807 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191814 */     // MIs[0] rs1
     /*  191814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191826 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_RL),
     /*  191831 */     GIR_RootConstrainSelectedInstOperands,
     /*  191832 */     // GIR_Coverage, 565,
     /*  191832 */     GIR_Done,
     /*  191833 */   // Label 3766: @191833
     /*  191833 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(191874), // Rule ID 566 //
     /*  191838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191841 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191848 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191855 */     // MIs[0] rs1
     /*  191855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191867 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191867 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  191872 */     GIR_RootConstrainSelectedInstOperands,
     /*  191873 */     // GIR_Coverage, 566,
     /*  191873 */     GIR_Done,
     /*  191874 */   // Label 3767: @191874
     /*  191874 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(191915), // Rule ID 567 //
     /*  191879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191882 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191889 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191896 */     // MIs[0] rs1
     /*  191896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191908 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191908 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  191913 */     GIR_RootConstrainSelectedInstOperands,
     /*  191914 */     // GIR_Coverage, 567,
     /*  191914 */     GIR_Done,
     /*  191915 */   // Label 3768: @191915
     /*  191915 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(191956), // Rule ID 568 //
     /*  191920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191923 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191930 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191937 */     // MIs[0] rs1
     /*  191937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191949 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  191954 */     GIR_RootConstrainSelectedInstOperands,
     /*  191955 */     // GIR_Coverage, 568,
     /*  191955 */     GIR_Done,
     /*  191956 */   // Label 3769: @191956
     /*  191956 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(191997), // Rule ID 569 //
     /*  191961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191964 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191971 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191978 */     // MIs[0] rs1
     /*  191978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191990 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  191995 */     GIR_RootConstrainSelectedInstOperands,
     /*  191996 */     // GIR_Coverage, 569,
     /*  191996 */     GIR_Done,
     /*  191997 */   // Label 3770: @191997
     /*  191997 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(192038), // Rule ID 570 //
     /*  192002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192005 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192012 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192019 */     // MIs[0] rs1
     /*  192019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192031 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192036 */     GIR_RootConstrainSelectedInstOperands,
     /*  192037 */     // GIR_Coverage, 570,
     /*  192037 */     GIR_Done,
     /*  192038 */   // Label 3771: @192038
     /*  192038 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(192079), // Rule ID 571 //
     /*  192043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192046 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192060 */     // MIs[0] rs1
     /*  192060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192072 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192077 */     GIR_RootConstrainSelectedInstOperands,
     /*  192078 */     // GIR_Coverage, 571,
     /*  192078 */     GIR_Done,
     /*  192079 */   // Label 3772: @192079
     /*  192079 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(192120), // Rule ID 572 //
     /*  192084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192087 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192094 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192101 */     // MIs[0] rs1
     /*  192101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192113 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192118 */     GIR_RootConstrainSelectedInstOperands,
     /*  192119 */     // GIR_Coverage, 572,
     /*  192119 */     GIR_Done,
     /*  192120 */   // Label 3773: @192120
     /*  192120 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(192161), // Rule ID 761 //
     /*  192125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192142 */     // MIs[0] rs1
     /*  192142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192154 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192159 */     GIR_RootConstrainSelectedInstOperands,
     /*  192160 */     // GIR_Coverage, 761,
     /*  192160 */     GIR_Done,
     /*  192161 */   // Label 3774: @192161
     /*  192161 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(192202), // Rule ID 763 //
     /*  192166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192169 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192176 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192183 */     // MIs[0] rs1
     /*  192183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192195 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  192200 */     GIR_RootConstrainSelectedInstOperands,
     /*  192201 */     // GIR_Coverage, 763,
     /*  192201 */     GIR_Done,
     /*  192202 */   // Label 3775: @192202
     /*  192202 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(192243), // Rule ID 765 //
     /*  192207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192210 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192217 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192224 */     // MIs[0] rs1
     /*  192224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192236 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  192241 */     GIR_RootConstrainSelectedInstOperands,
     /*  192242 */     // GIR_Coverage, 765,
     /*  192242 */     GIR_Done,
     /*  192243 */   // Label 3776: @192243
     /*  192243 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(192284), // Rule ID 767 //
     /*  192248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192251 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192258 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192265 */     // MIs[0] rs1
     /*  192265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192277 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  192282 */     GIR_RootConstrainSelectedInstOperands,
     /*  192283 */     // GIR_Coverage, 767,
     /*  192283 */     GIR_Done,
     /*  192284 */   // Label 3777: @192284
     /*  192284 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(192325), // Rule ID 769 //
     /*  192289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192292 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192299 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192306 */     // MIs[0] rs1
     /*  192306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192318 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  192323 */     GIR_RootConstrainSelectedInstOperands,
     /*  192324 */     // GIR_Coverage, 769,
     /*  192324 */     GIR_Done,
     /*  192325 */   // Label 3778: @192325
     /*  192325 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(192366), // Rule ID 771 //
     /*  192330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192333 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192347 */     // MIs[0] rs1
     /*  192347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192359 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192364 */     GIR_RootConstrainSelectedInstOperands,
     /*  192365 */     // GIR_Coverage, 771,
     /*  192365 */     GIR_Done,
     /*  192366 */   // Label 3779: @192366
     /*  192366 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(192407), // Rule ID 773 //
     /*  192371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192374 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192381 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192388 */     // MIs[0] rs1
     /*  192388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192400 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192405 */     GIR_RootConstrainSelectedInstOperands,
     /*  192406 */     // GIR_Coverage, 773,
     /*  192406 */     GIR_Done,
     /*  192407 */   // Label 3780: @192407
     /*  192407 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(192448), // Rule ID 775 //
     /*  192412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192415 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192422 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192429 */     // MIs[0] rs1
     /*  192429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192441 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192446 */     GIR_RootConstrainSelectedInstOperands,
     /*  192447 */     // GIR_Coverage, 775,
     /*  192447 */     GIR_Done,
     /*  192448 */   // Label 3781: @192448
     /*  192448 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(192489), // Rule ID 777 //
     /*  192453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192456 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192470 */     // MIs[0] rs1
     /*  192470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192482 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192487 */     GIR_RootConstrainSelectedInstOperands,
     /*  192488 */     // GIR_Coverage, 777,
     /*  192488 */     GIR_Done,
     /*  192489 */   // Label 3782: @192489
     /*  192489 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(192530), // Rule ID 779 //
     /*  192494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192497 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192504 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192511 */     // MIs[0] rs1
     /*  192511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192523 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192528 */     GIR_RootConstrainSelectedInstOperands,
     /*  192529 */     // GIR_Coverage, 779,
     /*  192529 */     GIR_Done,
     /*  192530 */   // Label 3783: @192530
     /*  192530 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(192571), // Rule ID 941 //
     /*  192535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192538 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192545 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192552 */     // MIs[0] rs1
     /*  192552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192564 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192569 */     GIR_RootConstrainSelectedInstOperands,
     /*  192570 */     // GIR_Coverage, 941,
     /*  192570 */     GIR_Done,
     /*  192571 */   // Label 3784: @192571
     /*  192571 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(192612), // Rule ID 943 //
     /*  192576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192579 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192586 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192593 */     // MIs[0] rs1
     /*  192593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192605 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  192610 */     GIR_RootConstrainSelectedInstOperands,
     /*  192611 */     // GIR_Coverage, 943,
     /*  192611 */     GIR_Done,
     /*  192612 */   // Label 3785: @192612
     /*  192612 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(192653), // Rule ID 945 //
     /*  192617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192620 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192627 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192634 */     // MIs[0] rs1
     /*  192634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192646 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  192651 */     GIR_RootConstrainSelectedInstOperands,
     /*  192652 */     // GIR_Coverage, 945,
     /*  192652 */     GIR_Done,
     /*  192653 */   // Label 3786: @192653
     /*  192653 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(192694), // Rule ID 947 //
     /*  192658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192661 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192668 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192675 */     // MIs[0] rs1
     /*  192675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192687 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  192692 */     GIR_RootConstrainSelectedInstOperands,
     /*  192693 */     // GIR_Coverage, 947,
     /*  192693 */     GIR_Done,
     /*  192694 */   // Label 3787: @192694
     /*  192694 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(192735), // Rule ID 949 //
     /*  192699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192702 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192709 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192716 */     // MIs[0] rs1
     /*  192716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192728 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  192733 */     GIR_RootConstrainSelectedInstOperands,
     /*  192734 */     // GIR_Coverage, 949,
     /*  192734 */     GIR_Done,
     /*  192735 */   // Label 3788: @192735
     /*  192735 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(192776), // Rule ID 951 //
     /*  192740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192757 */     // MIs[0] rs1
     /*  192757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192769 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192774 */     GIR_RootConstrainSelectedInstOperands,
     /*  192775 */     // GIR_Coverage, 951,
     /*  192775 */     GIR_Done,
     /*  192776 */   // Label 3789: @192776
     /*  192776 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(192817), // Rule ID 953 //
     /*  192781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192784 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192798 */     // MIs[0] rs1
     /*  192798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192810 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192815 */     GIR_RootConstrainSelectedInstOperands,
     /*  192816 */     // GIR_Coverage, 953,
     /*  192816 */     GIR_Done,
     /*  192817 */   // Label 3790: @192817
     /*  192817 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(192858), // Rule ID 955 //
     /*  192822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192825 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192832 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192839 */     // MIs[0] rs1
     /*  192839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192851 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192851 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192856 */     GIR_RootConstrainSelectedInstOperands,
     /*  192857 */     // GIR_Coverage, 955,
     /*  192857 */     GIR_Done,
     /*  192858 */   // Label 3791: @192858
     /*  192858 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(192899), // Rule ID 957 //
     /*  192863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192866 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192873 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192880 */     // MIs[0] rs1
     /*  192880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192892 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192897 */     GIR_RootConstrainSelectedInstOperands,
     /*  192898 */     // GIR_Coverage, 957,
     /*  192898 */     GIR_Done,
     /*  192899 */   // Label 3792: @192899
     /*  192899 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(192940), // Rule ID 959 //
     /*  192904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192907 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192914 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192921 */     // MIs[0] rs1
     /*  192921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192933 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192938 */     GIR_RootConstrainSelectedInstOperands,
     /*  192939 */     // GIR_Coverage, 959,
     /*  192939 */     GIR_Done,
     /*  192940 */   // Label 3793: @192940
     /*  192940 */   GIM_Reject,
     /*  192941 */ // Label 3753: @192941
     /*  192941 */ GIM_Reject,
     /*  192942 */ // Label 3721: @192942
     /*  192942 */ GIM_Reject,
     /*  192943 */ // Label 31: @192943
     /*  192943 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3796*/ GIMT_Encode4(195852),
     /*  192954 */ /*GILLT_s32*//*Label 3794*/ GIMT_Encode4(192962),
     /*  192958 */ /*GILLT_s64*//*Label 3795*/ GIMT_Encode4(194202),
     /*  192962 */ // Label 3794: @192962
     /*  192962 */ GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(194201),
     /*  192967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  192970 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(193011), // Rule ID 434 //
     /*  192975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  192978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192992 */     // MIs[0] rs1
     /*  192992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193004 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193009 */     GIR_RootConstrainSelectedInstOperands,
     /*  193010 */     // GIR_Coverage, 434,
     /*  193010 */     GIR_Done,
     /*  193011 */   // Label 3798: @193011
     /*  193011 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(193052), // Rule ID 436 //
     /*  193016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193019 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193033 */     // MIs[0] rs1
     /*  193033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193045 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  193050 */     GIR_RootConstrainSelectedInstOperands,
     /*  193051 */     // GIR_Coverage, 436,
     /*  193051 */     GIR_Done,
     /*  193052 */   // Label 3799: @193052
     /*  193052 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(193093), // Rule ID 438 //
     /*  193057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193060 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193074 */     // MIs[0] rs1
     /*  193074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193086 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  193091 */     GIR_RootConstrainSelectedInstOperands,
     /*  193092 */     // GIR_Coverage, 438,
     /*  193092 */     GIR_Done,
     /*  193093 */   // Label 3800: @193093
     /*  193093 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(193134), // Rule ID 440 //
     /*  193098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193101 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193108 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193115 */     // MIs[0] rs1
     /*  193115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193127 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  193132 */     GIR_RootConstrainSelectedInstOperands,
     /*  193133 */     // GIR_Coverage, 440,
     /*  193133 */     GIR_Done,
     /*  193134 */   // Label 3801: @193134
     /*  193134 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(193175), // Rule ID 442 //
     /*  193139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193142 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193149 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193156 */     // MIs[0] rs1
     /*  193156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193168 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  193173 */     GIR_RootConstrainSelectedInstOperands,
     /*  193174 */     // GIR_Coverage, 442,
     /*  193174 */     GIR_Done,
     /*  193175 */   // Label 3802: @193175
     /*  193175 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(193216), // Rule ID 444 //
     /*  193180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193183 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193190 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193197 */     // MIs[0] rs1
     /*  193197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193209 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193209 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193214 */     GIR_RootConstrainSelectedInstOperands,
     /*  193215 */     // GIR_Coverage, 444,
     /*  193215 */     GIR_Done,
     /*  193216 */   // Label 3803: @193216
     /*  193216 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(193257), // Rule ID 446 //
     /*  193221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193224 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193231 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193238 */     // MIs[0] rs1
     /*  193238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193250 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193255 */     GIR_RootConstrainSelectedInstOperands,
     /*  193256 */     // GIR_Coverage, 446,
     /*  193256 */     GIR_Done,
     /*  193257 */   // Label 3804: @193257
     /*  193257 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(193298), // Rule ID 448 //
     /*  193262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193265 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193272 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193279 */     // MIs[0] rs1
     /*  193279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193291 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193296 */     GIR_RootConstrainSelectedInstOperands,
     /*  193297 */     // GIR_Coverage, 448,
     /*  193297 */     GIR_Done,
     /*  193298 */   // Label 3805: @193298
     /*  193298 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(193339), // Rule ID 450 //
     /*  193303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193306 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193313 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193320 */     // MIs[0] rs1
     /*  193320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193332 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193337 */     GIR_RootConstrainSelectedInstOperands,
     /*  193338 */     // GIR_Coverage, 450,
     /*  193338 */     GIR_Done,
     /*  193339 */   // Label 3806: @193339
     /*  193339 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(193380), // Rule ID 452 //
     /*  193344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193347 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193354 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193361 */     // MIs[0] rs1
     /*  193361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193373 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193378 */     GIR_RootConstrainSelectedInstOperands,
     /*  193379 */     // GIR_Coverage, 452,
     /*  193379 */     GIR_Done,
     /*  193380 */   // Label 3807: @193380
     /*  193380 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(193421), // Rule ID 782 //
     /*  193385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193388 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193402 */     // MIs[0] rs1
     /*  193402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193414 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193419 */     GIR_RootConstrainSelectedInstOperands,
     /*  193420 */     // GIR_Coverage, 782,
     /*  193420 */     GIR_Done,
     /*  193421 */   // Label 3808: @193421
     /*  193421 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(193462), // Rule ID 784 //
     /*  193426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193429 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193436 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193443 */     // MIs[0] rs1
     /*  193443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193455 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  193460 */     GIR_RootConstrainSelectedInstOperands,
     /*  193461 */     // GIR_Coverage, 784,
     /*  193461 */     GIR_Done,
     /*  193462 */   // Label 3809: @193462
     /*  193462 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(193503), // Rule ID 786 //
     /*  193467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193470 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193477 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193484 */     // MIs[0] rs1
     /*  193484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193496 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  193501 */     GIR_RootConstrainSelectedInstOperands,
     /*  193502 */     // GIR_Coverage, 786,
     /*  193502 */     GIR_Done,
     /*  193503 */   // Label 3810: @193503
     /*  193503 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(193544), // Rule ID 788 //
     /*  193508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193511 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193518 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193525 */     // MIs[0] rs1
     /*  193525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193537 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  193542 */     GIR_RootConstrainSelectedInstOperands,
     /*  193543 */     // GIR_Coverage, 788,
     /*  193543 */     GIR_Done,
     /*  193544 */   // Label 3811: @193544
     /*  193544 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(193585), // Rule ID 790 //
     /*  193549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193552 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193559 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193566 */     // MIs[0] rs1
     /*  193566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193578 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  193583 */     GIR_RootConstrainSelectedInstOperands,
     /*  193584 */     // GIR_Coverage, 790,
     /*  193584 */     GIR_Done,
     /*  193585 */   // Label 3812: @193585
     /*  193585 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(193626), // Rule ID 792 //
     /*  193590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193593 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193600 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193607 */     // MIs[0] rs1
     /*  193607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193619 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193624 */     GIR_RootConstrainSelectedInstOperands,
     /*  193625 */     // GIR_Coverage, 792,
     /*  193625 */     GIR_Done,
     /*  193626 */   // Label 3813: @193626
     /*  193626 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(193667), // Rule ID 794 //
     /*  193631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193634 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193641 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193648 */     // MIs[0] rs1
     /*  193648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193660 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193660 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193665 */     GIR_RootConstrainSelectedInstOperands,
     /*  193666 */     // GIR_Coverage, 794,
     /*  193666 */     GIR_Done,
     /*  193667 */   // Label 3814: @193667
     /*  193667 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(193708), // Rule ID 796 //
     /*  193672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193675 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193682 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193689 */     // MIs[0] rs1
     /*  193689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193701 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193706 */     GIR_RootConstrainSelectedInstOperands,
     /*  193707 */     // GIR_Coverage, 796,
     /*  193707 */     GIR_Done,
     /*  193708 */   // Label 3815: @193708
     /*  193708 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(193749), // Rule ID 798 //
     /*  193713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193716 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193723 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193730 */     // MIs[0] rs1
     /*  193730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193742 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193747 */     GIR_RootConstrainSelectedInstOperands,
     /*  193748 */     // GIR_Coverage, 798,
     /*  193748 */     GIR_Done,
     /*  193749 */   // Label 3816: @193749
     /*  193749 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(193790), // Rule ID 800 //
     /*  193754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193757 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193764 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193771 */     // MIs[0] rs1
     /*  193771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193783 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193788 */     GIR_RootConstrainSelectedInstOperands,
     /*  193789 */     // GIR_Coverage, 800,
     /*  193789 */     GIR_Done,
     /*  193790 */   // Label 3817: @193790
     /*  193790 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(193831), // Rule ID 962 //
     /*  193795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193798 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193812 */     // MIs[0] rs1
     /*  193812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193824 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  193829 */     GIR_RootConstrainSelectedInstOperands,
     /*  193830 */     // GIR_Coverage, 962,
     /*  193830 */     GIR_Done,
     /*  193831 */   // Label 3818: @193831
     /*  193831 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(193872), // Rule ID 964 //
     /*  193836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193839 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193846 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193853 */     // MIs[0] rs1
     /*  193853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193865 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  193870 */     GIR_RootConstrainSelectedInstOperands,
     /*  193871 */     // GIR_Coverage, 964,
     /*  193871 */     GIR_Done,
     /*  193872 */   // Label 3819: @193872
     /*  193872 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(193913), // Rule ID 966 //
     /*  193877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193880 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193894 */     // MIs[0] rs1
     /*  193894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193906 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  193911 */     GIR_RootConstrainSelectedInstOperands,
     /*  193912 */     // GIR_Coverage, 966,
     /*  193912 */     GIR_Done,
     /*  193913 */   // Label 3820: @193913
     /*  193913 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(193954), // Rule ID 968 //
     /*  193918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193921 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193935 */     // MIs[0] rs1
     /*  193935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193947 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  193952 */     GIR_RootConstrainSelectedInstOperands,
     /*  193953 */     // GIR_Coverage, 968,
     /*  193953 */     GIR_Done,
     /*  193954 */   // Label 3821: @193954
     /*  193954 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(193995), // Rule ID 970 //
     /*  193959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193976 */     // MIs[0] rs1
     /*  193976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193988 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  193993 */     GIR_RootConstrainSelectedInstOperands,
     /*  193994 */     // GIR_Coverage, 970,
     /*  193994 */     GIR_Done,
     /*  193995 */   // Label 3822: @193995
     /*  193995 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(194036), // Rule ID 972 //
     /*  194000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194017 */     // MIs[0] rs1
     /*  194017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194029 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194034 */     GIR_RootConstrainSelectedInstOperands,
     /*  194035 */     // GIR_Coverage, 972,
     /*  194035 */     GIR_Done,
     /*  194036 */   // Label 3823: @194036
     /*  194036 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(194077), // Rule ID 974 //
     /*  194041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194044 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194058 */     // MIs[0] rs1
     /*  194058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194070 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194075 */     GIR_RootConstrainSelectedInstOperands,
     /*  194076 */     // GIR_Coverage, 974,
     /*  194076 */     GIR_Done,
     /*  194077 */   // Label 3824: @194077
     /*  194077 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(194118), // Rule ID 976 //
     /*  194082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194085 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194092 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194099 */     // MIs[0] rs1
     /*  194099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194111 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194116 */     GIR_RootConstrainSelectedInstOperands,
     /*  194117 */     // GIR_Coverage, 976,
     /*  194117 */     GIR_Done,
     /*  194118 */   // Label 3825: @194118
     /*  194118 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(194159), // Rule ID 978 //
     /*  194123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194126 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194133 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194140 */     // MIs[0] rs1
     /*  194140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194152 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194157 */     GIR_RootConstrainSelectedInstOperands,
     /*  194158 */     // GIR_Coverage, 978,
     /*  194158 */     GIR_Done,
     /*  194159 */   // Label 3826: @194159
     /*  194159 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(194200), // Rule ID 980 //
     /*  194164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194167 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194174 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194181 */     // MIs[0] rs1
     /*  194181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194193 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194198 */     GIR_RootConstrainSelectedInstOperands,
     /*  194199 */     // GIR_Coverage, 980,
     /*  194199 */     GIR_Done,
     /*  194200 */   // Label 3827: @194200
     /*  194200 */   GIM_Reject,
     /*  194201 */ // Label 3797: @194201
     /*  194201 */ GIM_Reject,
     /*  194202 */ // Label 3795: @194202
     /*  194202 */ GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(195851),
     /*  194207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  194210 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(194251), // Rule ID 433 //
     /*  194215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194218 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194225 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194232 */     // MIs[0] rs1
     /*  194232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194244 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194249 */     GIR_RootConstrainSelectedInstOperands,
     /*  194250 */     // GIR_Coverage, 433,
     /*  194250 */     GIR_Done,
     /*  194251 */   // Label 3829: @194251
     /*  194251 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(194292), // Rule ID 435 //
     /*  194256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194259 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194266 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194273 */     // MIs[0] rs1
     /*  194273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194285 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  194290 */     GIR_RootConstrainSelectedInstOperands,
     /*  194291 */     // GIR_Coverage, 435,
     /*  194291 */     GIR_Done,
     /*  194292 */   // Label 3830: @194292
     /*  194292 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(194333), // Rule ID 437 //
     /*  194297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194300 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194307 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194314 */     // MIs[0] rs1
     /*  194314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194326 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  194331 */     GIR_RootConstrainSelectedInstOperands,
     /*  194332 */     // GIR_Coverage, 437,
     /*  194332 */     GIR_Done,
     /*  194333 */   // Label 3831: @194333
     /*  194333 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(194374), // Rule ID 439 //
     /*  194338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194341 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194355 */     // MIs[0] rs1
     /*  194355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194367 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  194372 */     GIR_RootConstrainSelectedInstOperands,
     /*  194373 */     // GIR_Coverage, 439,
     /*  194373 */     GIR_Done,
     /*  194374 */   // Label 3832: @194374
     /*  194374 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(194415), // Rule ID 441 //
     /*  194379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194382 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194389 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194396 */     // MIs[0] rs1
     /*  194396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194408 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  194413 */     GIR_RootConstrainSelectedInstOperands,
     /*  194414 */     // GIR_Coverage, 441,
     /*  194414 */     GIR_Done,
     /*  194415 */   // Label 3833: @194415
     /*  194415 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(194456), // Rule ID 443 //
     /*  194420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194423 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194437 */     // MIs[0] rs1
     /*  194437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194449 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194449 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194454 */     GIR_RootConstrainSelectedInstOperands,
     /*  194455 */     // GIR_Coverage, 443,
     /*  194455 */     GIR_Done,
     /*  194456 */   // Label 3834: @194456
     /*  194456 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(194497), // Rule ID 445 //
     /*  194461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194464 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194471 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194478 */     // MIs[0] rs1
     /*  194478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194490 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194495 */     GIR_RootConstrainSelectedInstOperands,
     /*  194496 */     // GIR_Coverage, 445,
     /*  194496 */     GIR_Done,
     /*  194497 */   // Label 3835: @194497
     /*  194497 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(194538), // Rule ID 447 //
     /*  194502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194505 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194512 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194519 */     // MIs[0] rs1
     /*  194519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194531 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194536 */     GIR_RootConstrainSelectedInstOperands,
     /*  194537 */     // GIR_Coverage, 447,
     /*  194537 */     GIR_Done,
     /*  194538 */   // Label 3836: @194538
     /*  194538 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(194579), // Rule ID 449 //
     /*  194543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194546 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194553 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194560 */     // MIs[0] rs1
     /*  194560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194572 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194577 */     GIR_RootConstrainSelectedInstOperands,
     /*  194578 */     // GIR_Coverage, 449,
     /*  194578 */     GIR_Done,
     /*  194579 */   // Label 3837: @194579
     /*  194579 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(194620), // Rule ID 451 //
     /*  194584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194587 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194594 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194601 */     // MIs[0] rs1
     /*  194601 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194613 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194618 */     GIR_RootConstrainSelectedInstOperands,
     /*  194619 */     // GIR_Coverage, 451,
     /*  194619 */     GIR_Done,
     /*  194620 */   // Label 3838: @194620
     /*  194620 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(194661), // Rule ID 573 //
     /*  194625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194628 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194635 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194642 */     // MIs[0] rs1
     /*  194642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194654 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194659 */     GIR_RootConstrainSelectedInstOperands,
     /*  194660 */     // GIR_Coverage, 573,
     /*  194660 */     GIR_Done,
     /*  194661 */   // Label 3839: @194661
     /*  194661 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(194702), // Rule ID 574 //
     /*  194666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194669 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194676 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194683 */     // MIs[0] rs1
     /*  194683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194695 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ),
     /*  194700 */     GIR_RootConstrainSelectedInstOperands,
     /*  194701 */     // GIR_Coverage, 574,
     /*  194701 */     GIR_Done,
     /*  194702 */   // Label 3840: @194702
     /*  194702 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(194743), // Rule ID 575 //
     /*  194707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194710 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194717 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194724 */     // MIs[0] rs1
     /*  194724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194736 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_RL),
     /*  194741 */     GIR_RootConstrainSelectedInstOperands,
     /*  194742 */     // GIR_Coverage, 575,
     /*  194742 */     GIR_Done,
     /*  194743 */   // Label 3841: @194743
     /*  194743 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(194784), // Rule ID 576 //
     /*  194748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194751 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194758 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194765 */     // MIs[0] rs1
     /*  194765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194777 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  194782 */     GIR_RootConstrainSelectedInstOperands,
     /*  194783 */     // GIR_Coverage, 576,
     /*  194783 */     GIR_Done,
     /*  194784 */   // Label 3842: @194784
     /*  194784 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(194825), // Rule ID 577 //
     /*  194789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194792 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194799 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194806 */     // MIs[0] rs1
     /*  194806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194818 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  194823 */     GIR_RootConstrainSelectedInstOperands,
     /*  194824 */     // GIR_Coverage, 577,
     /*  194824 */     GIR_Done,
     /*  194825 */   // Label 3843: @194825
     /*  194825 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(194866), // Rule ID 578 //
     /*  194830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194833 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194840 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194847 */     // MIs[0] rs1
     /*  194847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194859 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194864 */     GIR_RootConstrainSelectedInstOperands,
     /*  194865 */     // GIR_Coverage, 578,
     /*  194865 */     GIR_Done,
     /*  194866 */   // Label 3844: @194866
     /*  194866 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(194907), // Rule ID 579 //
     /*  194871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194874 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194881 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194888 */     // MIs[0] rs1
     /*  194888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194900 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194905 */     GIR_RootConstrainSelectedInstOperands,
     /*  194906 */     // GIR_Coverage, 579,
     /*  194906 */     GIR_Done,
     /*  194907 */   // Label 3845: @194907
     /*  194907 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(194948), // Rule ID 580 //
     /*  194912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194915 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194922 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194929 */     // MIs[0] rs1
     /*  194929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194941 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194946 */     GIR_RootConstrainSelectedInstOperands,
     /*  194947 */     // GIR_Coverage, 580,
     /*  194947 */     GIR_Done,
     /*  194948 */   // Label 3846: @194948
     /*  194948 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(194989), // Rule ID 581 //
     /*  194953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194956 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194963 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194970 */     // MIs[0] rs1
     /*  194970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194982 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194982 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194987 */     GIR_RootConstrainSelectedInstOperands,
     /*  194988 */     // GIR_Coverage, 581,
     /*  194988 */     GIR_Done,
     /*  194989 */   // Label 3847: @194989
     /*  194989 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(195030), // Rule ID 582 //
     /*  194994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194997 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195004 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195011 */     // MIs[0] rs1
     /*  195011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195023 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195028 */     GIR_RootConstrainSelectedInstOperands,
     /*  195029 */     // GIR_Coverage, 582,
     /*  195029 */     GIR_Done,
     /*  195030 */   // Label 3848: @195030
     /*  195030 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(195071), // Rule ID 781 //
     /*  195035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195038 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195045 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195052 */     // MIs[0] rs1
     /*  195052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195064 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195069 */     GIR_RootConstrainSelectedInstOperands,
     /*  195070 */     // GIR_Coverage, 781,
     /*  195070 */     GIR_Done,
     /*  195071 */   // Label 3849: @195071
     /*  195071 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(195112), // Rule ID 783 //
     /*  195076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195079 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195086 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195093 */     // MIs[0] rs1
     /*  195093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195105 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  195110 */     GIR_RootConstrainSelectedInstOperands,
     /*  195111 */     // GIR_Coverage, 783,
     /*  195111 */     GIR_Done,
     /*  195112 */   // Label 3850: @195112
     /*  195112 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(195153), // Rule ID 785 //
     /*  195117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195120 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195127 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195134 */     // MIs[0] rs1
     /*  195134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195146 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  195151 */     GIR_RootConstrainSelectedInstOperands,
     /*  195152 */     // GIR_Coverage, 785,
     /*  195152 */     GIR_Done,
     /*  195153 */   // Label 3851: @195153
     /*  195153 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(195194), // Rule ID 787 //
     /*  195158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195175 */     // MIs[0] rs1
     /*  195175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195187 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  195192 */     GIR_RootConstrainSelectedInstOperands,
     /*  195193 */     // GIR_Coverage, 787,
     /*  195193 */     GIR_Done,
     /*  195194 */   // Label 3852: @195194
     /*  195194 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(195235), // Rule ID 789 //
     /*  195199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195202 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195209 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195216 */     // MIs[0] rs1
     /*  195216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195228 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  195233 */     GIR_RootConstrainSelectedInstOperands,
     /*  195234 */     // GIR_Coverage, 789,
     /*  195234 */     GIR_Done,
     /*  195235 */   // Label 3853: @195235
     /*  195235 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(195276), // Rule ID 791 //
     /*  195240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195243 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195250 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195257 */     // MIs[0] rs1
     /*  195257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195269 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195274 */     GIR_RootConstrainSelectedInstOperands,
     /*  195275 */     // GIR_Coverage, 791,
     /*  195275 */     GIR_Done,
     /*  195276 */   // Label 3854: @195276
     /*  195276 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(195317), // Rule ID 793 //
     /*  195281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195284 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195291 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195298 */     // MIs[0] rs1
     /*  195298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195310 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195315 */     GIR_RootConstrainSelectedInstOperands,
     /*  195316 */     // GIR_Coverage, 793,
     /*  195316 */     GIR_Done,
     /*  195317 */   // Label 3855: @195317
     /*  195317 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(195358), // Rule ID 795 //
     /*  195322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195325 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195332 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195339 */     // MIs[0] rs1
     /*  195339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195351 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195356 */     GIR_RootConstrainSelectedInstOperands,
     /*  195357 */     // GIR_Coverage, 795,
     /*  195357 */     GIR_Done,
     /*  195358 */   // Label 3856: @195358
     /*  195358 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(195399), // Rule ID 797 //
     /*  195363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195366 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195373 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195380 */     // MIs[0] rs1
     /*  195380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195392 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195397 */     GIR_RootConstrainSelectedInstOperands,
     /*  195398 */     // GIR_Coverage, 797,
     /*  195398 */     GIR_Done,
     /*  195399 */   // Label 3857: @195399
     /*  195399 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(195440), // Rule ID 799 //
     /*  195404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195407 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195414 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195421 */     // MIs[0] rs1
     /*  195421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195433 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195438 */     GIR_RootConstrainSelectedInstOperands,
     /*  195439 */     // GIR_Coverage, 799,
     /*  195439 */     GIR_Done,
     /*  195440 */   // Label 3858: @195440
     /*  195440 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(195481), // Rule ID 961 //
     /*  195445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195448 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195455 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195462 */     // MIs[0] rs1
     /*  195462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195474 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195479 */     GIR_RootConstrainSelectedInstOperands,
     /*  195480 */     // GIR_Coverage, 961,
     /*  195480 */     GIR_Done,
     /*  195481 */   // Label 3859: @195481
     /*  195481 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(195522), // Rule ID 963 //
     /*  195486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195489 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195496 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195503 */     // MIs[0] rs1
     /*  195503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195515 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  195520 */     GIR_RootConstrainSelectedInstOperands,
     /*  195521 */     // GIR_Coverage, 963,
     /*  195521 */     GIR_Done,
     /*  195522 */   // Label 3860: @195522
     /*  195522 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(195563), // Rule ID 965 //
     /*  195527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195530 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195537 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195544 */     // MIs[0] rs1
     /*  195544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195556 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  195561 */     GIR_RootConstrainSelectedInstOperands,
     /*  195562 */     // GIR_Coverage, 965,
     /*  195562 */     GIR_Done,
     /*  195563 */   // Label 3861: @195563
     /*  195563 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(195604), // Rule ID 967 //
     /*  195568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195571 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195578 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195585 */     // MIs[0] rs1
     /*  195585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195597 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  195602 */     GIR_RootConstrainSelectedInstOperands,
     /*  195603 */     // GIR_Coverage, 967,
     /*  195603 */     GIR_Done,
     /*  195604 */   // Label 3862: @195604
     /*  195604 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(195645), // Rule ID 969 //
     /*  195609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195612 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195619 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195626 */     // MIs[0] rs1
     /*  195626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195638 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  195643 */     GIR_RootConstrainSelectedInstOperands,
     /*  195644 */     // GIR_Coverage, 969,
     /*  195644 */     GIR_Done,
     /*  195645 */   // Label 3863: @195645
     /*  195645 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(195686), // Rule ID 971 //
     /*  195650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195653 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195660 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195667 */     // MIs[0] rs1
     /*  195667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195679 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195684 */     GIR_RootConstrainSelectedInstOperands,
     /*  195685 */     // GIR_Coverage, 971,
     /*  195685 */     GIR_Done,
     /*  195686 */   // Label 3864: @195686
     /*  195686 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(195727), // Rule ID 973 //
     /*  195691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195708 */     // MIs[0] rs1
     /*  195708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195720 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195725 */     GIR_RootConstrainSelectedInstOperands,
     /*  195726 */     // GIR_Coverage, 973,
     /*  195726 */     GIR_Done,
     /*  195727 */   // Label 3865: @195727
     /*  195727 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(195768), // Rule ID 975 //
     /*  195732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195735 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195749 */     // MIs[0] rs1
     /*  195749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195761 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195766 */     GIR_RootConstrainSelectedInstOperands,
     /*  195767 */     // GIR_Coverage, 975,
     /*  195767 */     GIR_Done,
     /*  195768 */   // Label 3866: @195768
     /*  195768 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(195809), // Rule ID 977 //
     /*  195773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195776 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195790 */     // MIs[0] rs1
     /*  195790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195802 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195807 */     GIR_RootConstrainSelectedInstOperands,
     /*  195808 */     // GIR_Coverage, 977,
     /*  195808 */     GIR_Done,
     /*  195809 */   // Label 3867: @195809
     /*  195809 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(195850), // Rule ID 979 //
     /*  195814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195817 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195824 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195831 */     // MIs[0] rs1
     /*  195831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195843 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195848 */     GIR_RootConstrainSelectedInstOperands,
     /*  195849 */     // GIR_Coverage, 979,
     /*  195849 */     GIR_Done,
     /*  195850 */   // Label 3868: @195850
     /*  195850 */   GIM_Reject,
     /*  195851 */ // Label 3828: @195851
     /*  195851 */ GIM_Reject,
     /*  195852 */ // Label 3796: @195852
     /*  195852 */ GIM_Reject,
     /*  195853 */ // Label 32: @195853
     /*  195853 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3871*/ GIMT_Encode4(198762),
     /*  195864 */ /*GILLT_s32*//*Label 3869*/ GIMT_Encode4(195872),
     /*  195868 */ /*GILLT_s64*//*Label 3870*/ GIMT_Encode4(197112),
     /*  195872 */ // Label 3869: @195872
     /*  195872 */ GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(197111),
     /*  195877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  195880 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(195921), // Rule ID 454 //
     /*  195885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  195888 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195895 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195902 */     // MIs[0] rs1
     /*  195902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195914 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  195919 */     GIR_RootConstrainSelectedInstOperands,
     /*  195920 */     // GIR_Coverage, 454,
     /*  195920 */     GIR_Done,
     /*  195921 */   // Label 3873: @195921
     /*  195921 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(195962), // Rule ID 456 //
     /*  195926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  195929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195943 */     // MIs[0] rs1
     /*  195943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195955 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  195960 */     GIR_RootConstrainSelectedInstOperands,
     /*  195961 */     // GIR_Coverage, 456,
     /*  195961 */     GIR_Done,
     /*  195962 */   // Label 3874: @195962
     /*  195962 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(196003), // Rule ID 458 //
     /*  195967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  195970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195984 */     // MIs[0] rs1
     /*  195984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195996 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  196001 */     GIR_RootConstrainSelectedInstOperands,
     /*  196002 */     // GIR_Coverage, 458,
     /*  196002 */     GIR_Done,
     /*  196003 */   // Label 3875: @196003
     /*  196003 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(196044), // Rule ID 460 //
     /*  196008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196025 */     // MIs[0] rs1
     /*  196025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196037 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  196042 */     GIR_RootConstrainSelectedInstOperands,
     /*  196043 */     // GIR_Coverage, 460,
     /*  196043 */     GIR_Done,
     /*  196044 */   // Label 3876: @196044
     /*  196044 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(196085), // Rule ID 462 //
     /*  196049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196066 */     // MIs[0] rs1
     /*  196066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196078 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196078 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  196083 */     GIR_RootConstrainSelectedInstOperands,
     /*  196084 */     // GIR_Coverage, 462,
     /*  196084 */     GIR_Done,
     /*  196085 */   // Label 3877: @196085
     /*  196085 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(196126), // Rule ID 464 //
     /*  196090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196107 */     // MIs[0] rs1
     /*  196107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196119 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196124 */     GIR_RootConstrainSelectedInstOperands,
     /*  196125 */     // GIR_Coverage, 464,
     /*  196125 */     GIR_Done,
     /*  196126 */   // Label 3878: @196126
     /*  196126 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(196167), // Rule ID 466 //
     /*  196131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196134 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196141 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196148 */     // MIs[0] rs1
     /*  196148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196160 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196165 */     GIR_RootConstrainSelectedInstOperands,
     /*  196166 */     // GIR_Coverage, 466,
     /*  196166 */     GIR_Done,
     /*  196167 */   // Label 3879: @196167
     /*  196167 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(196208), // Rule ID 468 //
     /*  196172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196175 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196182 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196189 */     // MIs[0] rs1
     /*  196189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196201 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196206 */     GIR_RootConstrainSelectedInstOperands,
     /*  196207 */     // GIR_Coverage, 468,
     /*  196207 */     GIR_Done,
     /*  196208 */   // Label 3880: @196208
     /*  196208 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(196249), // Rule ID 470 //
     /*  196213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196216 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196223 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196230 */     // MIs[0] rs1
     /*  196230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196242 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196247 */     GIR_RootConstrainSelectedInstOperands,
     /*  196248 */     // GIR_Coverage, 470,
     /*  196248 */     GIR_Done,
     /*  196249 */   // Label 3881: @196249
     /*  196249 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(196290), // Rule ID 472 //
     /*  196254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196257 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196264 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196271 */     // MIs[0] rs1
     /*  196271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196283 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196288 */     GIR_RootConstrainSelectedInstOperands,
     /*  196289 */     // GIR_Coverage, 472,
     /*  196289 */     GIR_Done,
     /*  196290 */   // Label 3882: @196290
     /*  196290 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(196331), // Rule ID 802 //
     /*  196295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196298 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196305 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196312 */     // MIs[0] rs1
     /*  196312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196324 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196324 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196329 */     GIR_RootConstrainSelectedInstOperands,
     /*  196330 */     // GIR_Coverage, 802,
     /*  196330 */     GIR_Done,
     /*  196331 */   // Label 3883: @196331
     /*  196331 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(196372), // Rule ID 804 //
     /*  196336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196339 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196346 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196353 */     // MIs[0] rs1
     /*  196353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196365 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  196370 */     GIR_RootConstrainSelectedInstOperands,
     /*  196371 */     // GIR_Coverage, 804,
     /*  196371 */     GIR_Done,
     /*  196372 */   // Label 3884: @196372
     /*  196372 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(196413), // Rule ID 806 //
     /*  196377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196380 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196387 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196394 */     // MIs[0] rs1
     /*  196394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196406 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  196411 */     GIR_RootConstrainSelectedInstOperands,
     /*  196412 */     // GIR_Coverage, 806,
     /*  196412 */     GIR_Done,
     /*  196413 */   // Label 3885: @196413
     /*  196413 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(196454), // Rule ID 808 //
     /*  196418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196421 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196428 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196435 */     // MIs[0] rs1
     /*  196435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196447 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  196452 */     GIR_RootConstrainSelectedInstOperands,
     /*  196453 */     // GIR_Coverage, 808,
     /*  196453 */     GIR_Done,
     /*  196454 */   // Label 3886: @196454
     /*  196454 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(196495), // Rule ID 810 //
     /*  196459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196462 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196469 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196476 */     // MIs[0] rs1
     /*  196476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196488 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  196493 */     GIR_RootConstrainSelectedInstOperands,
     /*  196494 */     // GIR_Coverage, 810,
     /*  196494 */     GIR_Done,
     /*  196495 */   // Label 3887: @196495
     /*  196495 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(196536), // Rule ID 812 //
     /*  196500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196503 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196510 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196517 */     // MIs[0] rs1
     /*  196517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196529 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196534 */     GIR_RootConstrainSelectedInstOperands,
     /*  196535 */     // GIR_Coverage, 812,
     /*  196535 */     GIR_Done,
     /*  196536 */   // Label 3888: @196536
     /*  196536 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(196577), // Rule ID 814 //
     /*  196541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196544 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196551 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196558 */     // MIs[0] rs1
     /*  196558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196570 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196575 */     GIR_RootConstrainSelectedInstOperands,
     /*  196576 */     // GIR_Coverage, 814,
     /*  196576 */     GIR_Done,
     /*  196577 */   // Label 3889: @196577
     /*  196577 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(196618), // Rule ID 816 //
     /*  196582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196585 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196592 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196599 */     // MIs[0] rs1
     /*  196599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196611 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196616 */     GIR_RootConstrainSelectedInstOperands,
     /*  196617 */     // GIR_Coverage, 816,
     /*  196617 */     GIR_Done,
     /*  196618 */   // Label 3890: @196618
     /*  196618 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(196659), // Rule ID 818 //
     /*  196623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196626 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196633 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196640 */     // MIs[0] rs1
     /*  196640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196652 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196652 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196657 */     GIR_RootConstrainSelectedInstOperands,
     /*  196658 */     // GIR_Coverage, 818,
     /*  196658 */     GIR_Done,
     /*  196659 */   // Label 3891: @196659
     /*  196659 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(196700), // Rule ID 820 //
     /*  196664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196667 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196674 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196681 */     // MIs[0] rs1
     /*  196681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196693 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196698 */     GIR_RootConstrainSelectedInstOperands,
     /*  196699 */     // GIR_Coverage, 820,
     /*  196699 */     GIR_Done,
     /*  196700 */   // Label 3892: @196700
     /*  196700 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(196741), // Rule ID 982 //
     /*  196705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196708 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196715 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196722 */     // MIs[0] rs1
     /*  196722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196734 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  196739 */     GIR_RootConstrainSelectedInstOperands,
     /*  196740 */     // GIR_Coverage, 982,
     /*  196740 */     GIR_Done,
     /*  196741 */   // Label 3893: @196741
     /*  196741 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(196782), // Rule ID 984 //
     /*  196746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196749 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196756 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196763 */     // MIs[0] rs1
     /*  196763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196775 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  196780 */     GIR_RootConstrainSelectedInstOperands,
     /*  196781 */     // GIR_Coverage, 984,
     /*  196781 */     GIR_Done,
     /*  196782 */   // Label 3894: @196782
     /*  196782 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(196823), // Rule ID 986 //
     /*  196787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196790 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196797 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196804 */     // MIs[0] rs1
     /*  196804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196816 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  196821 */     GIR_RootConstrainSelectedInstOperands,
     /*  196822 */     // GIR_Coverage, 986,
     /*  196822 */     GIR_Done,
     /*  196823 */   // Label 3895: @196823
     /*  196823 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(196864), // Rule ID 988 //
     /*  196828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196838 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196845 */     // MIs[0] rs1
     /*  196845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196857 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  196862 */     GIR_RootConstrainSelectedInstOperands,
     /*  196863 */     // GIR_Coverage, 988,
     /*  196863 */     GIR_Done,
     /*  196864 */   // Label 3896: @196864
     /*  196864 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(196905), // Rule ID 990 //
     /*  196869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196872 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196886 */     // MIs[0] rs1
     /*  196886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196898 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  196903 */     GIR_RootConstrainSelectedInstOperands,
     /*  196904 */     // GIR_Coverage, 990,
     /*  196904 */     GIR_Done,
     /*  196905 */   // Label 3897: @196905
     /*  196905 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(196946), // Rule ID 992 //
     /*  196910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196913 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196927 */     // MIs[0] rs1
     /*  196927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196939 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  196944 */     GIR_RootConstrainSelectedInstOperands,
     /*  196945 */     // GIR_Coverage, 992,
     /*  196945 */     GIR_Done,
     /*  196946 */   // Label 3898: @196946
     /*  196946 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(196987), // Rule ID 994 //
     /*  196951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196954 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196968 */     // MIs[0] rs1
     /*  196968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196980 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  196985 */     GIR_RootConstrainSelectedInstOperands,
     /*  196986 */     // GIR_Coverage, 994,
     /*  196986 */     GIR_Done,
     /*  196987 */   // Label 3899: @196987
     /*  196987 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(197028), // Rule ID 996 //
     /*  196992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196995 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197002 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197009 */     // MIs[0] rs1
     /*  197009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197021 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197026 */     GIR_RootConstrainSelectedInstOperands,
     /*  197027 */     // GIR_Coverage, 996,
     /*  197027 */     GIR_Done,
     /*  197028 */   // Label 3900: @197028
     /*  197028 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(197069), // Rule ID 998 //
     /*  197033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197036 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197043 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197050 */     // MIs[0] rs1
     /*  197050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197062 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197067 */     GIR_RootConstrainSelectedInstOperands,
     /*  197068 */     // GIR_Coverage, 998,
     /*  197068 */     GIR_Done,
     /*  197069 */   // Label 3901: @197069
     /*  197069 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(197110), // Rule ID 1000 //
     /*  197074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197077 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197091 */     // MIs[0] rs1
     /*  197091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197103 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197108 */     GIR_RootConstrainSelectedInstOperands,
     /*  197109 */     // GIR_Coverage, 1000,
     /*  197109 */     GIR_Done,
     /*  197110 */   // Label 3902: @197110
     /*  197110 */   GIM_Reject,
     /*  197111 */ // Label 3872: @197111
     /*  197111 */ GIM_Reject,
     /*  197112 */ // Label 3870: @197112
     /*  197112 */ GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(198761),
     /*  197117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  197120 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(197161), // Rule ID 453 //
     /*  197125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197142 */     // MIs[0] rs1
     /*  197142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197154 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197159 */     GIR_RootConstrainSelectedInstOperands,
     /*  197160 */     // GIR_Coverage, 453,
     /*  197160 */     GIR_Done,
     /*  197161 */   // Label 3904: @197161
     /*  197161 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(197202), // Rule ID 455 //
     /*  197166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197169 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197176 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197183 */     // MIs[0] rs1
     /*  197183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197195 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  197200 */     GIR_RootConstrainSelectedInstOperands,
     /*  197201 */     // GIR_Coverage, 455,
     /*  197201 */     GIR_Done,
     /*  197202 */   // Label 3905: @197202
     /*  197202 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(197243), // Rule ID 457 //
     /*  197207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197210 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197217 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197224 */     // MIs[0] rs1
     /*  197224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197236 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  197241 */     GIR_RootConstrainSelectedInstOperands,
     /*  197242 */     // GIR_Coverage, 457,
     /*  197242 */     GIR_Done,
     /*  197243 */   // Label 3906: @197243
     /*  197243 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(197284), // Rule ID 459 //
     /*  197248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197251 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197258 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197265 */     // MIs[0] rs1
     /*  197265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197277 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  197282 */     GIR_RootConstrainSelectedInstOperands,
     /*  197283 */     // GIR_Coverage, 459,
     /*  197283 */     GIR_Done,
     /*  197284 */   // Label 3907: @197284
     /*  197284 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(197325), // Rule ID 461 //
     /*  197289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197292 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197299 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197306 */     // MIs[0] rs1
     /*  197306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197318 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  197323 */     GIR_RootConstrainSelectedInstOperands,
     /*  197324 */     // GIR_Coverage, 461,
     /*  197324 */     GIR_Done,
     /*  197325 */   // Label 3908: @197325
     /*  197325 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(197366), // Rule ID 463 //
     /*  197330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197333 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197347 */     // MIs[0] rs1
     /*  197347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197359 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197364 */     GIR_RootConstrainSelectedInstOperands,
     /*  197365 */     // GIR_Coverage, 463,
     /*  197365 */     GIR_Done,
     /*  197366 */   // Label 3909: @197366
     /*  197366 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(197407), // Rule ID 465 //
     /*  197371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197374 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197381 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197388 */     // MIs[0] rs1
     /*  197388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197400 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197405 */     GIR_RootConstrainSelectedInstOperands,
     /*  197406 */     // GIR_Coverage, 465,
     /*  197406 */     GIR_Done,
     /*  197407 */   // Label 3910: @197407
     /*  197407 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(197448), // Rule ID 467 //
     /*  197412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197415 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197422 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197429 */     // MIs[0] rs1
     /*  197429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197441 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197446 */     GIR_RootConstrainSelectedInstOperands,
     /*  197447 */     // GIR_Coverage, 467,
     /*  197447 */     GIR_Done,
     /*  197448 */   // Label 3911: @197448
     /*  197448 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(197489), // Rule ID 469 //
     /*  197453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197456 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197470 */     // MIs[0] rs1
     /*  197470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197482 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197487 */     GIR_RootConstrainSelectedInstOperands,
     /*  197488 */     // GIR_Coverage, 469,
     /*  197488 */     GIR_Done,
     /*  197489 */   // Label 3912: @197489
     /*  197489 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(197530), // Rule ID 471 //
     /*  197494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197497 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197504 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197511 */     // MIs[0] rs1
     /*  197511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197523 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197528 */     GIR_RootConstrainSelectedInstOperands,
     /*  197529 */     // GIR_Coverage, 471,
     /*  197529 */     GIR_Done,
     /*  197530 */   // Label 3913: @197530
     /*  197530 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(197571), // Rule ID 583 //
     /*  197535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197538 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197545 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197552 */     // MIs[0] rs1
     /*  197552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197564 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197569 */     GIR_RootConstrainSelectedInstOperands,
     /*  197570 */     // GIR_Coverage, 583,
     /*  197570 */     GIR_Done,
     /*  197571 */   // Label 3914: @197571
     /*  197571 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(197612), // Rule ID 584 //
     /*  197576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197579 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197586 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197593 */     // MIs[0] rs1
     /*  197593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197605 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ),
     /*  197610 */     GIR_RootConstrainSelectedInstOperands,
     /*  197611 */     // GIR_Coverage, 584,
     /*  197611 */     GIR_Done,
     /*  197612 */   // Label 3915: @197612
     /*  197612 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(197653), // Rule ID 585 //
     /*  197617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197620 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197627 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197634 */     // MIs[0] rs1
     /*  197634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197646 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_RL),
     /*  197651 */     GIR_RootConstrainSelectedInstOperands,
     /*  197652 */     // GIR_Coverage, 585,
     /*  197652 */     GIR_Done,
     /*  197653 */   // Label 3916: @197653
     /*  197653 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(197694), // Rule ID 586 //
     /*  197658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197661 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197668 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197675 */     // MIs[0] rs1
     /*  197675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197687 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  197692 */     GIR_RootConstrainSelectedInstOperands,
     /*  197693 */     // GIR_Coverage, 586,
     /*  197693 */     GIR_Done,
     /*  197694 */   // Label 3917: @197694
     /*  197694 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(197735), // Rule ID 587 //
     /*  197699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197702 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197709 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197716 */     // MIs[0] rs1
     /*  197716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197728 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  197733 */     GIR_RootConstrainSelectedInstOperands,
     /*  197734 */     // GIR_Coverage, 587,
     /*  197734 */     GIR_Done,
     /*  197735 */   // Label 3918: @197735
     /*  197735 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(197776), // Rule ID 588 //
     /*  197740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197757 */     // MIs[0] rs1
     /*  197757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197769 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197774 */     GIR_RootConstrainSelectedInstOperands,
     /*  197775 */     // GIR_Coverage, 588,
     /*  197775 */     GIR_Done,
     /*  197776 */   // Label 3919: @197776
     /*  197776 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(197817), // Rule ID 589 //
     /*  197781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197784 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197798 */     // MIs[0] rs1
     /*  197798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197810 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197815 */     GIR_RootConstrainSelectedInstOperands,
     /*  197816 */     // GIR_Coverage, 589,
     /*  197816 */     GIR_Done,
     /*  197817 */   // Label 3920: @197817
     /*  197817 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(197858), // Rule ID 590 //
     /*  197822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197825 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197832 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197839 */     // MIs[0] rs1
     /*  197839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197851 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197851 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197856 */     GIR_RootConstrainSelectedInstOperands,
     /*  197857 */     // GIR_Coverage, 590,
     /*  197857 */     GIR_Done,
     /*  197858 */   // Label 3921: @197858
     /*  197858 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(197899), // Rule ID 591 //
     /*  197863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197866 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197873 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197880 */     // MIs[0] rs1
     /*  197880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197892 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197897 */     GIR_RootConstrainSelectedInstOperands,
     /*  197898 */     // GIR_Coverage, 591,
     /*  197898 */     GIR_Done,
     /*  197899 */   // Label 3922: @197899
     /*  197899 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(197940), // Rule ID 592 //
     /*  197904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197907 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197914 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197921 */     // MIs[0] rs1
     /*  197921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197933 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197938 */     GIR_RootConstrainSelectedInstOperands,
     /*  197939 */     // GIR_Coverage, 592,
     /*  197939 */     GIR_Done,
     /*  197940 */   // Label 3923: @197940
     /*  197940 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(197981), // Rule ID 801 //
     /*  197945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  197948 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197955 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197962 */     // MIs[0] rs1
     /*  197962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197974 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197979 */     GIR_RootConstrainSelectedInstOperands,
     /*  197980 */     // GIR_Coverage, 801,
     /*  197980 */     GIR_Done,
     /*  197981 */   // Label 3924: @197981
     /*  197981 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(198022), // Rule ID 803 //
     /*  197986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  197989 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197996 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198003 */     // MIs[0] rs1
     /*  198003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198015 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  198020 */     GIR_RootConstrainSelectedInstOperands,
     /*  198021 */     // GIR_Coverage, 803,
     /*  198021 */     GIR_Done,
     /*  198022 */   // Label 3925: @198022
     /*  198022 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(198063), // Rule ID 805 //
     /*  198027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198030 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198037 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198044 */     // MIs[0] rs1
     /*  198044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198056 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  198061 */     GIR_RootConstrainSelectedInstOperands,
     /*  198062 */     // GIR_Coverage, 805,
     /*  198062 */     GIR_Done,
     /*  198063 */   // Label 3926: @198063
     /*  198063 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(198104), // Rule ID 807 //
     /*  198068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198071 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198078 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198085 */     // MIs[0] rs1
     /*  198085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198097 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  198102 */     GIR_RootConstrainSelectedInstOperands,
     /*  198103 */     // GIR_Coverage, 807,
     /*  198103 */     GIR_Done,
     /*  198104 */   // Label 3927: @198104
     /*  198104 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(198145), // Rule ID 809 //
     /*  198109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198112 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198119 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198126 */     // MIs[0] rs1
     /*  198126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198138 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198138 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  198143 */     GIR_RootConstrainSelectedInstOperands,
     /*  198144 */     // GIR_Coverage, 809,
     /*  198144 */     GIR_Done,
     /*  198145 */   // Label 3928: @198145
     /*  198145 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(198186), // Rule ID 811 //
     /*  198150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198153 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198160 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198167 */     // MIs[0] rs1
     /*  198167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198179 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198179 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198184 */     GIR_RootConstrainSelectedInstOperands,
     /*  198185 */     // GIR_Coverage, 811,
     /*  198185 */     GIR_Done,
     /*  198186 */   // Label 3929: @198186
     /*  198186 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(198227), // Rule ID 813 //
     /*  198191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198194 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198201 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198208 */     // MIs[0] rs1
     /*  198208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198220 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198225 */     GIR_RootConstrainSelectedInstOperands,
     /*  198226 */     // GIR_Coverage, 813,
     /*  198226 */     GIR_Done,
     /*  198227 */   // Label 3930: @198227
     /*  198227 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(198268), // Rule ID 815 //
     /*  198232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198235 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198242 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198249 */     // MIs[0] rs1
     /*  198249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198261 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198266 */     GIR_RootConstrainSelectedInstOperands,
     /*  198267 */     // GIR_Coverage, 815,
     /*  198267 */     GIR_Done,
     /*  198268 */   // Label 3931: @198268
     /*  198268 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(198309), // Rule ID 817 //
     /*  198273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198276 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198290 */     // MIs[0] rs1
     /*  198290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198302 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198307 */     GIR_RootConstrainSelectedInstOperands,
     /*  198308 */     // GIR_Coverage, 817,
     /*  198308 */     GIR_Done,
     /*  198309 */   // Label 3932: @198309
     /*  198309 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(198350), // Rule ID 819 //
     /*  198314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198317 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198324 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198331 */     // MIs[0] rs1
     /*  198331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198343 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198348 */     GIR_RootConstrainSelectedInstOperands,
     /*  198349 */     // GIR_Coverage, 819,
     /*  198349 */     GIR_Done,
     /*  198350 */   // Label 3933: @198350
     /*  198350 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(198391), // Rule ID 981 //
     /*  198355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198358 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198365 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198372 */     // MIs[0] rs1
     /*  198372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198384 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198389 */     GIR_RootConstrainSelectedInstOperands,
     /*  198390 */     // GIR_Coverage, 981,
     /*  198390 */     GIR_Done,
     /*  198391 */   // Label 3934: @198391
     /*  198391 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(198432), // Rule ID 983 //
     /*  198396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198399 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198406 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198413 */     // MIs[0] rs1
     /*  198413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198425 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  198430 */     GIR_RootConstrainSelectedInstOperands,
     /*  198431 */     // GIR_Coverage, 983,
     /*  198431 */     GIR_Done,
     /*  198432 */   // Label 3935: @198432
     /*  198432 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(198473), // Rule ID 985 //
     /*  198437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198440 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198454 */     // MIs[0] rs1
     /*  198454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198466 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  198471 */     GIR_RootConstrainSelectedInstOperands,
     /*  198472 */     // GIR_Coverage, 985,
     /*  198472 */     GIR_Done,
     /*  198473 */   // Label 3936: @198473
     /*  198473 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(198514), // Rule ID 987 //
     /*  198478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198481 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198488 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198495 */     // MIs[0] rs1
     /*  198495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198507 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  198512 */     GIR_RootConstrainSelectedInstOperands,
     /*  198513 */     // GIR_Coverage, 987,
     /*  198513 */     GIR_Done,
     /*  198514 */   // Label 3937: @198514
     /*  198514 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(198555), // Rule ID 989 //
     /*  198519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198522 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198529 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198536 */     // MIs[0] rs1
     /*  198536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198548 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  198553 */     GIR_RootConstrainSelectedInstOperands,
     /*  198554 */     // GIR_Coverage, 989,
     /*  198554 */     GIR_Done,
     /*  198555 */   // Label 3938: @198555
     /*  198555 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(198596), // Rule ID 991 //
     /*  198560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198563 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198570 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198577 */     // MIs[0] rs1
     /*  198577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198589 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198594 */     GIR_RootConstrainSelectedInstOperands,
     /*  198595 */     // GIR_Coverage, 991,
     /*  198595 */     GIR_Done,
     /*  198596 */   // Label 3939: @198596
     /*  198596 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(198637), // Rule ID 993 //
     /*  198601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198604 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198611 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198618 */     // MIs[0] rs1
     /*  198618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198630 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198635 */     GIR_RootConstrainSelectedInstOperands,
     /*  198636 */     // GIR_Coverage, 993,
     /*  198636 */     GIR_Done,
     /*  198637 */   // Label 3940: @198637
     /*  198637 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(198678), // Rule ID 995 //
     /*  198642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198659 */     // MIs[0] rs1
     /*  198659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198671 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198676 */     GIR_RootConstrainSelectedInstOperands,
     /*  198677 */     // GIR_Coverage, 995,
     /*  198677 */     GIR_Done,
     /*  198678 */   // Label 3941: @198678
     /*  198678 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(198719), // Rule ID 997 //
     /*  198683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198700 */     // MIs[0] rs1
     /*  198700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198712 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198717 */     GIR_RootConstrainSelectedInstOperands,
     /*  198718 */     // GIR_Coverage, 997,
     /*  198718 */     GIR_Done,
     /*  198719 */   // Label 3942: @198719
     /*  198719 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(198760), // Rule ID 999 //
     /*  198724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198727 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198734 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198741 */     // MIs[0] rs1
     /*  198741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198753 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198758 */     GIR_RootConstrainSelectedInstOperands,
     /*  198759 */     // GIR_Coverage, 999,
     /*  198759 */     GIR_Done,
     /*  198760 */   // Label 3943: @198760
     /*  198760 */   GIM_Reject,
     /*  198761 */ // Label 3903: @198761
     /*  198761 */ GIM_Reject,
     /*  198762 */ // Label 3871: @198762
     /*  198762 */ GIM_Reject,
     /*  198763 */ // Label 33: @198763
     /*  198763 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3946*/ GIMT_Encode4(201672),
     /*  198774 */ /*GILLT_s32*//*Label 3944*/ GIMT_Encode4(198782),
     /*  198778 */ /*GILLT_s64*//*Label 3945*/ GIMT_Encode4(200022),
     /*  198782 */ // Label 3944: @198782
     /*  198782 */ GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(200021),
     /*  198787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  198790 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(198831), // Rule ID 474 //
     /*  198795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198798 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198812 */     // MIs[0] rs1
     /*  198812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198824 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  198829 */     GIR_RootConstrainSelectedInstOperands,
     /*  198830 */     // GIR_Coverage, 474,
     /*  198830 */     GIR_Done,
     /*  198831 */   // Label 3948: @198831
     /*  198831 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(198872), // Rule ID 476 //
     /*  198836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198839 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198846 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198853 */     // MIs[0] rs1
     /*  198853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198865 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  198870 */     GIR_RootConstrainSelectedInstOperands,
     /*  198871 */     // GIR_Coverage, 476,
     /*  198871 */     GIR_Done,
     /*  198872 */   // Label 3949: @198872
     /*  198872 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(198913), // Rule ID 478 //
     /*  198877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198880 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198894 */     // MIs[0] rs1
     /*  198894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198906 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  198911 */     GIR_RootConstrainSelectedInstOperands,
     /*  198912 */     // GIR_Coverage, 478,
     /*  198912 */     GIR_Done,
     /*  198913 */   // Label 3950: @198913
     /*  198913 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(198954), // Rule ID 480 //
     /*  198918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198921 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198935 */     // MIs[0] rs1
     /*  198935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198947 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  198952 */     GIR_RootConstrainSelectedInstOperands,
     /*  198953 */     // GIR_Coverage, 480,
     /*  198953 */     GIR_Done,
     /*  198954 */   // Label 3951: @198954
     /*  198954 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(198995), // Rule ID 482 //
     /*  198959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198976 */     // MIs[0] rs1
     /*  198976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198988 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  198993 */     GIR_RootConstrainSelectedInstOperands,
     /*  198994 */     // GIR_Coverage, 482,
     /*  198994 */     GIR_Done,
     /*  198995 */   // Label 3952: @198995
     /*  198995 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(199036), // Rule ID 484 //
     /*  199000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199017 */     // MIs[0] rs1
     /*  199017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199029 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199034 */     GIR_RootConstrainSelectedInstOperands,
     /*  199035 */     // GIR_Coverage, 484,
     /*  199035 */     GIR_Done,
     /*  199036 */   // Label 3953: @199036
     /*  199036 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(199077), // Rule ID 486 //
     /*  199041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199044 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199058 */     // MIs[0] rs1
     /*  199058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199070 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199075 */     GIR_RootConstrainSelectedInstOperands,
     /*  199076 */     // GIR_Coverage, 486,
     /*  199076 */     GIR_Done,
     /*  199077 */   // Label 3954: @199077
     /*  199077 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(199118), // Rule ID 488 //
     /*  199082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199085 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199092 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199099 */     // MIs[0] rs1
     /*  199099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199111 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199116 */     GIR_RootConstrainSelectedInstOperands,
     /*  199117 */     // GIR_Coverage, 488,
     /*  199117 */     GIR_Done,
     /*  199118 */   // Label 3955: @199118
     /*  199118 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(199159), // Rule ID 490 //
     /*  199123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199126 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199133 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199140 */     // MIs[0] rs1
     /*  199140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199152 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199157 */     GIR_RootConstrainSelectedInstOperands,
     /*  199158 */     // GIR_Coverage, 490,
     /*  199158 */     GIR_Done,
     /*  199159 */   // Label 3956: @199159
     /*  199159 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(199200), // Rule ID 492 //
     /*  199164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199167 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199174 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199181 */     // MIs[0] rs1
     /*  199181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199193 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199198 */     GIR_RootConstrainSelectedInstOperands,
     /*  199199 */     // GIR_Coverage, 492,
     /*  199199 */     GIR_Done,
     /*  199200 */   // Label 3957: @199200
     /*  199200 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(199241), // Rule ID 822 //
     /*  199205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199208 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199215 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199222 */     // MIs[0] rs1
     /*  199222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199234 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199239 */     GIR_RootConstrainSelectedInstOperands,
     /*  199240 */     // GIR_Coverage, 822,
     /*  199240 */     GIR_Done,
     /*  199241 */   // Label 3958: @199241
     /*  199241 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(199282), // Rule ID 824 //
     /*  199246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199249 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199256 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199263 */     // MIs[0] rs1
     /*  199263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199275 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  199280 */     GIR_RootConstrainSelectedInstOperands,
     /*  199281 */     // GIR_Coverage, 824,
     /*  199281 */     GIR_Done,
     /*  199282 */   // Label 3959: @199282
     /*  199282 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(199323), // Rule ID 826 //
     /*  199287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199290 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199297 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199304 */     // MIs[0] rs1
     /*  199304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199316 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  199321 */     GIR_RootConstrainSelectedInstOperands,
     /*  199322 */     // GIR_Coverage, 826,
     /*  199322 */     GIR_Done,
     /*  199323 */   // Label 3960: @199323
     /*  199323 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(199364), // Rule ID 828 //
     /*  199328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199331 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199338 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199345 */     // MIs[0] rs1
     /*  199345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199357 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  199362 */     GIR_RootConstrainSelectedInstOperands,
     /*  199363 */     // GIR_Coverage, 828,
     /*  199363 */     GIR_Done,
     /*  199364 */   // Label 3961: @199364
     /*  199364 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(199405), // Rule ID 830 //
     /*  199369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199372 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199379 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199386 */     // MIs[0] rs1
     /*  199386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199398 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  199403 */     GIR_RootConstrainSelectedInstOperands,
     /*  199404 */     // GIR_Coverage, 830,
     /*  199404 */     GIR_Done,
     /*  199405 */   // Label 3962: @199405
     /*  199405 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(199446), // Rule ID 832 //
     /*  199410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199413 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199420 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199427 */     // MIs[0] rs1
     /*  199427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199439 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199444 */     GIR_RootConstrainSelectedInstOperands,
     /*  199445 */     // GIR_Coverage, 832,
     /*  199445 */     GIR_Done,
     /*  199446 */   // Label 3963: @199446
     /*  199446 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(199487), // Rule ID 834 //
     /*  199451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199454 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199461 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199468 */     // MIs[0] rs1
     /*  199468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199480 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199485 */     GIR_RootConstrainSelectedInstOperands,
     /*  199486 */     // GIR_Coverage, 834,
     /*  199486 */     GIR_Done,
     /*  199487 */   // Label 3964: @199487
     /*  199487 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(199528), // Rule ID 836 //
     /*  199492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199495 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199502 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199509 */     // MIs[0] rs1
     /*  199509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199521 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199526 */     GIR_RootConstrainSelectedInstOperands,
     /*  199527 */     // GIR_Coverage, 836,
     /*  199527 */     GIR_Done,
     /*  199528 */   // Label 3965: @199528
     /*  199528 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(199569), // Rule ID 838 //
     /*  199533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199536 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199543 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199550 */     // MIs[0] rs1
     /*  199550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199562 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199567 */     GIR_RootConstrainSelectedInstOperands,
     /*  199568 */     // GIR_Coverage, 838,
     /*  199568 */     GIR_Done,
     /*  199569 */   // Label 3966: @199569
     /*  199569 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(199610), // Rule ID 840 //
     /*  199574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199577 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199584 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199591 */     // MIs[0] rs1
     /*  199591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199603 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199608 */     GIR_RootConstrainSelectedInstOperands,
     /*  199609 */     // GIR_Coverage, 840,
     /*  199609 */     GIR_Done,
     /*  199610 */   // Label 3967: @199610
     /*  199610 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(199651), // Rule ID 1002 //
     /*  199615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199632 */     // MIs[0] rs1
     /*  199632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199644 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199649 */     GIR_RootConstrainSelectedInstOperands,
     /*  199650 */     // GIR_Coverage, 1002,
     /*  199650 */     GIR_Done,
     /*  199651 */   // Label 3968: @199651
     /*  199651 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(199692), // Rule ID 1004 //
     /*  199656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199659 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199666 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199673 */     // MIs[0] rs1
     /*  199673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199685 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  199690 */     GIR_RootConstrainSelectedInstOperands,
     /*  199691 */     // GIR_Coverage, 1004,
     /*  199691 */     GIR_Done,
     /*  199692 */   // Label 3969: @199692
     /*  199692 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(199733), // Rule ID 1006 //
     /*  199697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199707 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199714 */     // MIs[0] rs1
     /*  199714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199726 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  199731 */     GIR_RootConstrainSelectedInstOperands,
     /*  199732 */     // GIR_Coverage, 1006,
     /*  199732 */     GIR_Done,
     /*  199733 */   // Label 3970: @199733
     /*  199733 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(199774), // Rule ID 1008 //
     /*  199738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199741 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199748 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199755 */     // MIs[0] rs1
     /*  199755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199767 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  199772 */     GIR_RootConstrainSelectedInstOperands,
     /*  199773 */     // GIR_Coverage, 1008,
     /*  199773 */     GIR_Done,
     /*  199774 */   // Label 3971: @199774
     /*  199774 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(199815), // Rule ID 1010 //
     /*  199779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199782 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199789 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199796 */     // MIs[0] rs1
     /*  199796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199808 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  199813 */     GIR_RootConstrainSelectedInstOperands,
     /*  199814 */     // GIR_Coverage, 1010,
     /*  199814 */     GIR_Done,
     /*  199815 */   // Label 3972: @199815
     /*  199815 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(199856), // Rule ID 1012 //
     /*  199820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199823 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199830 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199837 */     // MIs[0] rs1
     /*  199837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199849 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199854 */     GIR_RootConstrainSelectedInstOperands,
     /*  199855 */     // GIR_Coverage, 1012,
     /*  199855 */     GIR_Done,
     /*  199856 */   // Label 3973: @199856
     /*  199856 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(199897), // Rule ID 1014 //
     /*  199861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199864 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199878 */     // MIs[0] rs1
     /*  199878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199890 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199895 */     GIR_RootConstrainSelectedInstOperands,
     /*  199896 */     // GIR_Coverage, 1014,
     /*  199896 */     GIR_Done,
     /*  199897 */   // Label 3974: @199897
     /*  199897 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(199938), // Rule ID 1016 //
     /*  199902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199919 */     // MIs[0] rs1
     /*  199919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199931 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199936 */     GIR_RootConstrainSelectedInstOperands,
     /*  199937 */     // GIR_Coverage, 1016,
     /*  199937 */     GIR_Done,
     /*  199938 */   // Label 3975: @199938
     /*  199938 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(199979), // Rule ID 1018 //
     /*  199943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199946 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199960 */     // MIs[0] rs1
     /*  199960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199972 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199977 */     GIR_RootConstrainSelectedInstOperands,
     /*  199978 */     // GIR_Coverage, 1018,
     /*  199978 */     GIR_Done,
     /*  199979 */   // Label 3976: @199979
     /*  199979 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(200020), // Rule ID 1020 //
     /*  199984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199987 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199994 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200001 */     // MIs[0] rs1
     /*  200001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200013 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200018 */     GIR_RootConstrainSelectedInstOperands,
     /*  200019 */     // GIR_Coverage, 1020,
     /*  200019 */     GIR_Done,
     /*  200020 */   // Label 3977: @200020
     /*  200020 */   GIM_Reject,
     /*  200021 */ // Label 3947: @200021
     /*  200021 */ GIM_Reject,
     /*  200022 */ // Label 3945: @200022
     /*  200022 */ GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(201671),
     /*  200027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  200030 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(200071), // Rule ID 473 //
     /*  200035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200038 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200045 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200052 */     // MIs[0] rs1
     /*  200052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200064 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200069 */     GIR_RootConstrainSelectedInstOperands,
     /*  200070 */     // GIR_Coverage, 473,
     /*  200070 */     GIR_Done,
     /*  200071 */   // Label 3979: @200071
     /*  200071 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(200112), // Rule ID 475 //
     /*  200076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200079 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200086 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200093 */     // MIs[0] rs1
     /*  200093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200105 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  200110 */     GIR_RootConstrainSelectedInstOperands,
     /*  200111 */     // GIR_Coverage, 475,
     /*  200111 */     GIR_Done,
     /*  200112 */   // Label 3980: @200112
     /*  200112 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(200153), // Rule ID 477 //
     /*  200117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200120 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200127 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200134 */     // MIs[0] rs1
     /*  200134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200146 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  200151 */     GIR_RootConstrainSelectedInstOperands,
     /*  200152 */     // GIR_Coverage, 477,
     /*  200152 */     GIR_Done,
     /*  200153 */   // Label 3981: @200153
     /*  200153 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(200194), // Rule ID 479 //
     /*  200158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200175 */     // MIs[0] rs1
     /*  200175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200187 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  200192 */     GIR_RootConstrainSelectedInstOperands,
     /*  200193 */     // GIR_Coverage, 479,
     /*  200193 */     GIR_Done,
     /*  200194 */   // Label 3982: @200194
     /*  200194 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(200235), // Rule ID 481 //
     /*  200199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200202 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200209 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200216 */     // MIs[0] rs1
     /*  200216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200228 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  200233 */     GIR_RootConstrainSelectedInstOperands,
     /*  200234 */     // GIR_Coverage, 481,
     /*  200234 */     GIR_Done,
     /*  200235 */   // Label 3983: @200235
     /*  200235 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(200276), // Rule ID 483 //
     /*  200240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200243 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200250 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200257 */     // MIs[0] rs1
     /*  200257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200269 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200274 */     GIR_RootConstrainSelectedInstOperands,
     /*  200275 */     // GIR_Coverage, 483,
     /*  200275 */     GIR_Done,
     /*  200276 */   // Label 3984: @200276
     /*  200276 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(200317), // Rule ID 485 //
     /*  200281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200284 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200291 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200298 */     // MIs[0] rs1
     /*  200298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200310 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200315 */     GIR_RootConstrainSelectedInstOperands,
     /*  200316 */     // GIR_Coverage, 485,
     /*  200316 */     GIR_Done,
     /*  200317 */   // Label 3985: @200317
     /*  200317 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(200358), // Rule ID 487 //
     /*  200322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200325 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200332 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200339 */     // MIs[0] rs1
     /*  200339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200351 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200356 */     GIR_RootConstrainSelectedInstOperands,
     /*  200357 */     // GIR_Coverage, 487,
     /*  200357 */     GIR_Done,
     /*  200358 */   // Label 3986: @200358
     /*  200358 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(200399), // Rule ID 489 //
     /*  200363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200366 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200373 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200380 */     // MIs[0] rs1
     /*  200380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200392 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200397 */     GIR_RootConstrainSelectedInstOperands,
     /*  200398 */     // GIR_Coverage, 489,
     /*  200398 */     GIR_Done,
     /*  200399 */   // Label 3987: @200399
     /*  200399 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(200440), // Rule ID 491 //
     /*  200404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200407 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200414 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200421 */     // MIs[0] rs1
     /*  200421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200433 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200438 */     GIR_RootConstrainSelectedInstOperands,
     /*  200439 */     // GIR_Coverage, 491,
     /*  200439 */     GIR_Done,
     /*  200440 */   // Label 3988: @200440
     /*  200440 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(200481), // Rule ID 593 //
     /*  200445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200448 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200455 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200462 */     // MIs[0] rs1
     /*  200462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200474 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200479 */     GIR_RootConstrainSelectedInstOperands,
     /*  200480 */     // GIR_Coverage, 593,
     /*  200480 */     GIR_Done,
     /*  200481 */   // Label 3989: @200481
     /*  200481 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(200522), // Rule ID 594 //
     /*  200486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200489 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200496 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200503 */     // MIs[0] rs1
     /*  200503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200515 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ),
     /*  200520 */     GIR_RootConstrainSelectedInstOperands,
     /*  200521 */     // GIR_Coverage, 594,
     /*  200521 */     GIR_Done,
     /*  200522 */   // Label 3990: @200522
     /*  200522 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(200563), // Rule ID 595 //
     /*  200527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200530 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200537 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200544 */     // MIs[0] rs1
     /*  200544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200556 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_RL),
     /*  200561 */     GIR_RootConstrainSelectedInstOperands,
     /*  200562 */     // GIR_Coverage, 595,
     /*  200562 */     GIR_Done,
     /*  200563 */   // Label 3991: @200563
     /*  200563 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(200604), // Rule ID 596 //
     /*  200568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200571 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200578 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200585 */     // MIs[0] rs1
     /*  200585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200597 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  200602 */     GIR_RootConstrainSelectedInstOperands,
     /*  200603 */     // GIR_Coverage, 596,
     /*  200603 */     GIR_Done,
     /*  200604 */   // Label 3992: @200604
     /*  200604 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(200645), // Rule ID 597 //
     /*  200609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200612 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200619 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200626 */     // MIs[0] rs1
     /*  200626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200638 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  200643 */     GIR_RootConstrainSelectedInstOperands,
     /*  200644 */     // GIR_Coverage, 597,
     /*  200644 */     GIR_Done,
     /*  200645 */   // Label 3993: @200645
     /*  200645 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(200686), // Rule ID 598 //
     /*  200650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200653 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200660 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200667 */     // MIs[0] rs1
     /*  200667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200679 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200684 */     GIR_RootConstrainSelectedInstOperands,
     /*  200685 */     // GIR_Coverage, 598,
     /*  200685 */     GIR_Done,
     /*  200686 */   // Label 3994: @200686
     /*  200686 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(200727), // Rule ID 599 //
     /*  200691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200708 */     // MIs[0] rs1
     /*  200708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200720 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200725 */     GIR_RootConstrainSelectedInstOperands,
     /*  200726 */     // GIR_Coverage, 599,
     /*  200726 */     GIR_Done,
     /*  200727 */   // Label 3995: @200727
     /*  200727 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(200768), // Rule ID 600 //
     /*  200732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200735 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200749 */     // MIs[0] rs1
     /*  200749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200761 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200766 */     GIR_RootConstrainSelectedInstOperands,
     /*  200767 */     // GIR_Coverage, 600,
     /*  200767 */     GIR_Done,
     /*  200768 */   // Label 3996: @200768
     /*  200768 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(200809), // Rule ID 601 //
     /*  200773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200776 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200790 */     // MIs[0] rs1
     /*  200790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200802 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200807 */     GIR_RootConstrainSelectedInstOperands,
     /*  200808 */     // GIR_Coverage, 601,
     /*  200808 */     GIR_Done,
     /*  200809 */   // Label 3997: @200809
     /*  200809 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(200850), // Rule ID 602 //
     /*  200814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200817 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200824 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200831 */     // MIs[0] rs1
     /*  200831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200843 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200848 */     GIR_RootConstrainSelectedInstOperands,
     /*  200849 */     // GIR_Coverage, 602,
     /*  200849 */     GIR_Done,
     /*  200850 */   // Label 3998: @200850
     /*  200850 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(200891), // Rule ID 821 //
     /*  200855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200858 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200865 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200872 */     // MIs[0] rs1
     /*  200872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200884 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  200889 */     GIR_RootConstrainSelectedInstOperands,
     /*  200890 */     // GIR_Coverage, 821,
     /*  200890 */     GIR_Done,
     /*  200891 */   // Label 3999: @200891
     /*  200891 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(200932), // Rule ID 823 //
     /*  200896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200899 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200906 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200913 */     // MIs[0] rs1
     /*  200913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200925 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  200930 */     GIR_RootConstrainSelectedInstOperands,
     /*  200931 */     // GIR_Coverage, 823,
     /*  200931 */     GIR_Done,
     /*  200932 */   // Label 4000: @200932
     /*  200932 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(200973), // Rule ID 825 //
     /*  200937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200940 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200947 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200954 */     // MIs[0] rs1
     /*  200954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200966 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  200971 */     GIR_RootConstrainSelectedInstOperands,
     /*  200972 */     // GIR_Coverage, 825,
     /*  200972 */     GIR_Done,
     /*  200973 */   // Label 4001: @200973
     /*  200973 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(201014), // Rule ID 827 //
     /*  200978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200981 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200988 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200995 */     // MIs[0] rs1
     /*  200995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201007 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  201012 */     GIR_RootConstrainSelectedInstOperands,
     /*  201013 */     // GIR_Coverage, 827,
     /*  201013 */     GIR_Done,
     /*  201014 */   // Label 4002: @201014
     /*  201014 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(201055), // Rule ID 829 //
     /*  201019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201022 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201036 */     // MIs[0] rs1
     /*  201036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201048 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  201053 */     GIR_RootConstrainSelectedInstOperands,
     /*  201054 */     // GIR_Coverage, 829,
     /*  201054 */     GIR_Done,
     /*  201055 */   // Label 4003: @201055
     /*  201055 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(201096), // Rule ID 831 //
     /*  201060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201063 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201077 */     // MIs[0] rs1
     /*  201077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201089 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201094 */     GIR_RootConstrainSelectedInstOperands,
     /*  201095 */     // GIR_Coverage, 831,
     /*  201095 */     GIR_Done,
     /*  201096 */   // Label 4004: @201096
     /*  201096 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(201137), // Rule ID 833 //
     /*  201101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201104 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201111 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201118 */     // MIs[0] rs1
     /*  201118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201130 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201135 */     GIR_RootConstrainSelectedInstOperands,
     /*  201136 */     // GIR_Coverage, 833,
     /*  201136 */     GIR_Done,
     /*  201137 */   // Label 4005: @201137
     /*  201137 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(201178), // Rule ID 835 //
     /*  201142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201145 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201159 */     // MIs[0] rs1
     /*  201159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201171 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201176 */     GIR_RootConstrainSelectedInstOperands,
     /*  201177 */     // GIR_Coverage, 835,
     /*  201177 */     GIR_Done,
     /*  201178 */   // Label 4006: @201178
     /*  201178 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(201219), // Rule ID 837 //
     /*  201183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201186 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201193 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201200 */     // MIs[0] rs1
     /*  201200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201212 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201217 */     GIR_RootConstrainSelectedInstOperands,
     /*  201218 */     // GIR_Coverage, 837,
     /*  201218 */     GIR_Done,
     /*  201219 */   // Label 4007: @201219
     /*  201219 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(201260), // Rule ID 839 //
     /*  201224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201227 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201234 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201241 */     // MIs[0] rs1
     /*  201241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201253 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201258 */     GIR_RootConstrainSelectedInstOperands,
     /*  201259 */     // GIR_Coverage, 839,
     /*  201259 */     GIR_Done,
     /*  201260 */   // Label 4008: @201260
     /*  201260 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(201301), // Rule ID 1001 //
     /*  201265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201268 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201275 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201282 */     // MIs[0] rs1
     /*  201282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201294 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201299 */     GIR_RootConstrainSelectedInstOperands,
     /*  201300 */     // GIR_Coverage, 1001,
     /*  201300 */     GIR_Done,
     /*  201301 */   // Label 4009: @201301
     /*  201301 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(201342), // Rule ID 1003 //
     /*  201306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201309 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201316 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201323 */     // MIs[0] rs1
     /*  201323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201335 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  201340 */     GIR_RootConstrainSelectedInstOperands,
     /*  201341 */     // GIR_Coverage, 1003,
     /*  201341 */     GIR_Done,
     /*  201342 */   // Label 4010: @201342
     /*  201342 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(201383), // Rule ID 1005 //
     /*  201347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201350 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201357 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201364 */     // MIs[0] rs1
     /*  201364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201376 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  201381 */     GIR_RootConstrainSelectedInstOperands,
     /*  201382 */     // GIR_Coverage, 1005,
     /*  201382 */     GIR_Done,
     /*  201383 */   // Label 4011: @201383
     /*  201383 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(201424), // Rule ID 1007 //
     /*  201388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201391 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201398 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201405 */     // MIs[0] rs1
     /*  201405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201417 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  201422 */     GIR_RootConstrainSelectedInstOperands,
     /*  201423 */     // GIR_Coverage, 1007,
     /*  201423 */     GIR_Done,
     /*  201424 */   // Label 4012: @201424
     /*  201424 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(201465), // Rule ID 1009 //
     /*  201429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201432 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201446 */     // MIs[0] rs1
     /*  201446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201458 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  201463 */     GIR_RootConstrainSelectedInstOperands,
     /*  201464 */     // GIR_Coverage, 1009,
     /*  201464 */     GIR_Done,
     /*  201465 */   // Label 4013: @201465
     /*  201465 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(201506), // Rule ID 1011 //
     /*  201470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201480 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201487 */     // MIs[0] rs1
     /*  201487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201499 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201504 */     GIR_RootConstrainSelectedInstOperands,
     /*  201505 */     // GIR_Coverage, 1011,
     /*  201505 */     GIR_Done,
     /*  201506 */   // Label 4014: @201506
     /*  201506 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(201547), // Rule ID 1013 //
     /*  201511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201514 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201521 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201528 */     // MIs[0] rs1
     /*  201528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201540 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201545 */     GIR_RootConstrainSelectedInstOperands,
     /*  201546 */     // GIR_Coverage, 1013,
     /*  201546 */     GIR_Done,
     /*  201547 */   // Label 4015: @201547
     /*  201547 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(201588), // Rule ID 1015 //
     /*  201552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201562 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201569 */     // MIs[0] rs1
     /*  201569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201581 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201586 */     GIR_RootConstrainSelectedInstOperands,
     /*  201587 */     // GIR_Coverage, 1015,
     /*  201587 */     GIR_Done,
     /*  201588 */   // Label 4016: @201588
     /*  201588 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(201629), // Rule ID 1017 //
     /*  201593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201610 */     // MIs[0] rs1
     /*  201610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201622 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201627 */     GIR_RootConstrainSelectedInstOperands,
     /*  201628 */     // GIR_Coverage, 1017,
     /*  201628 */     GIR_Done,
     /*  201629 */   // Label 4017: @201629
     /*  201629 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(201670), // Rule ID 1019 //
     /*  201634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201651 */     // MIs[0] rs1
     /*  201651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201663 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201668 */     GIR_RootConstrainSelectedInstOperands,
     /*  201669 */     // GIR_Coverage, 1019,
     /*  201669 */     GIR_Done,
     /*  201670 */   // Label 4018: @201670
     /*  201670 */   GIM_Reject,
     /*  201671 */ // Label 3978: @201671
     /*  201671 */ GIM_Reject,
     /*  201672 */ // Label 3946: @201672
     /*  201672 */ GIM_Reject,
     /*  201673 */ // Label 34: @201673
     /*  201673 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4021*/ GIMT_Encode4(204582),
     /*  201684 */ /*GILLT_s32*//*Label 4019*/ GIMT_Encode4(201692),
     /*  201688 */ /*GILLT_s64*//*Label 4020*/ GIMT_Encode4(202932),
     /*  201692 */ // Label 4019: @201692
     /*  201692 */ GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(202931),
     /*  201697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  201700 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(201741), // Rule ID 494 //
     /*  201705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201708 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201715 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201722 */     // MIs[0] rs1
     /*  201722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201734 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  201739 */     GIR_RootConstrainSelectedInstOperands,
     /*  201740 */     // GIR_Coverage, 494,
     /*  201740 */     GIR_Done,
     /*  201741 */   // Label 4023: @201741
     /*  201741 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(201782), // Rule ID 496 //
     /*  201746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201749 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201756 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201763 */     // MIs[0] rs1
     /*  201763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201775 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  201780 */     GIR_RootConstrainSelectedInstOperands,
     /*  201781 */     // GIR_Coverage, 496,
     /*  201781 */     GIR_Done,
     /*  201782 */   // Label 4024: @201782
     /*  201782 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(201823), // Rule ID 498 //
     /*  201787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201790 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201797 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201804 */     // MIs[0] rs1
     /*  201804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201816 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  201821 */     GIR_RootConstrainSelectedInstOperands,
     /*  201822 */     // GIR_Coverage, 498,
     /*  201822 */     GIR_Done,
     /*  201823 */   // Label 4025: @201823
     /*  201823 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(201864), // Rule ID 500 //
     /*  201828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201838 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201845 */     // MIs[0] rs1
     /*  201845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201857 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  201862 */     GIR_RootConstrainSelectedInstOperands,
     /*  201863 */     // GIR_Coverage, 500,
     /*  201863 */     GIR_Done,
     /*  201864 */   // Label 4026: @201864
     /*  201864 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(201905), // Rule ID 502 //
     /*  201869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201872 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201886 */     // MIs[0] rs1
     /*  201886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201898 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  201903 */     GIR_RootConstrainSelectedInstOperands,
     /*  201904 */     // GIR_Coverage, 502,
     /*  201904 */     GIR_Done,
     /*  201905 */   // Label 4027: @201905
     /*  201905 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(201946), // Rule ID 504 //
     /*  201910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  201913 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201927 */     // MIs[0] rs1
     /*  201927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201939 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  201944 */     GIR_RootConstrainSelectedInstOperands,
     /*  201945 */     // GIR_Coverage, 504,
     /*  201945 */     GIR_Done,
     /*  201946 */   // Label 4028: @201946
     /*  201946 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(201987), // Rule ID 506 //
     /*  201951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  201954 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201968 */     // MIs[0] rs1
     /*  201968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201980 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  201985 */     GIR_RootConstrainSelectedInstOperands,
     /*  201986 */     // GIR_Coverage, 506,
     /*  201986 */     GIR_Done,
     /*  201987 */   // Label 4029: @201987
     /*  201987 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(202028), // Rule ID 508 //
     /*  201992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  201995 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202002 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202009 */     // MIs[0] rs1
     /*  202009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202021 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202026 */     GIR_RootConstrainSelectedInstOperands,
     /*  202027 */     // GIR_Coverage, 508,
     /*  202027 */     GIR_Done,
     /*  202028 */   // Label 4030: @202028
     /*  202028 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(202069), // Rule ID 510 //
     /*  202033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202036 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202043 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202050 */     // MIs[0] rs1
     /*  202050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202062 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202067 */     GIR_RootConstrainSelectedInstOperands,
     /*  202068 */     // GIR_Coverage, 510,
     /*  202068 */     GIR_Done,
     /*  202069 */   // Label 4031: @202069
     /*  202069 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(202110), // Rule ID 512 //
     /*  202074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202077 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202091 */     // MIs[0] rs1
     /*  202091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202103 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202108 */     GIR_RootConstrainSelectedInstOperands,
     /*  202109 */     // GIR_Coverage, 512,
     /*  202109 */     GIR_Done,
     /*  202110 */   // Label 4032: @202110
     /*  202110 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(202151), // Rule ID 842 //
     /*  202115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202118 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202125 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202132 */     // MIs[0] rs1
     /*  202132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202144 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202144 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202149 */     GIR_RootConstrainSelectedInstOperands,
     /*  202150 */     // GIR_Coverage, 842,
     /*  202150 */     GIR_Done,
     /*  202151 */   // Label 4033: @202151
     /*  202151 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(202192), // Rule ID 844 //
     /*  202156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202159 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202166 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202173 */     // MIs[0] rs1
     /*  202173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202185 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202185 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  202190 */     GIR_RootConstrainSelectedInstOperands,
     /*  202191 */     // GIR_Coverage, 844,
     /*  202191 */     GIR_Done,
     /*  202192 */   // Label 4034: @202192
     /*  202192 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(202233), // Rule ID 846 //
     /*  202197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202200 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202207 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202214 */     // MIs[0] rs1
     /*  202214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202226 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  202231 */     GIR_RootConstrainSelectedInstOperands,
     /*  202232 */     // GIR_Coverage, 846,
     /*  202232 */     GIR_Done,
     /*  202233 */   // Label 4035: @202233
     /*  202233 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(202274), // Rule ID 848 //
     /*  202238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202241 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202248 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202255 */     // MIs[0] rs1
     /*  202255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202267 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  202272 */     GIR_RootConstrainSelectedInstOperands,
     /*  202273 */     // GIR_Coverage, 848,
     /*  202273 */     GIR_Done,
     /*  202274 */   // Label 4036: @202274
     /*  202274 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(202315), // Rule ID 850 //
     /*  202279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202282 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202289 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202296 */     // MIs[0] rs1
     /*  202296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202308 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202308 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  202313 */     GIR_RootConstrainSelectedInstOperands,
     /*  202314 */     // GIR_Coverage, 850,
     /*  202314 */     GIR_Done,
     /*  202315 */   // Label 4037: @202315
     /*  202315 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(202356), // Rule ID 852 //
     /*  202320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202323 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202330 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202337 */     // MIs[0] rs1
     /*  202337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202349 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202354 */     GIR_RootConstrainSelectedInstOperands,
     /*  202355 */     // GIR_Coverage, 852,
     /*  202355 */     GIR_Done,
     /*  202356 */   // Label 4038: @202356
     /*  202356 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(202397), // Rule ID 854 //
     /*  202361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202364 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202371 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202378 */     // MIs[0] rs1
     /*  202378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202390 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202395 */     GIR_RootConstrainSelectedInstOperands,
     /*  202396 */     // GIR_Coverage, 854,
     /*  202396 */     GIR_Done,
     /*  202397 */   // Label 4039: @202397
     /*  202397 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(202438), // Rule ID 856 //
     /*  202402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202405 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202412 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202419 */     // MIs[0] rs1
     /*  202419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202431 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202436 */     GIR_RootConstrainSelectedInstOperands,
     /*  202437 */     // GIR_Coverage, 856,
     /*  202437 */     GIR_Done,
     /*  202438 */   // Label 4040: @202438
     /*  202438 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(202479), // Rule ID 858 //
     /*  202443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202446 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202453 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202460 */     // MIs[0] rs1
     /*  202460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202472 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202477 */     GIR_RootConstrainSelectedInstOperands,
     /*  202478 */     // GIR_Coverage, 858,
     /*  202478 */     GIR_Done,
     /*  202479 */   // Label 4041: @202479
     /*  202479 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(202520), // Rule ID 860 //
     /*  202484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202487 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202494 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202501 */     // MIs[0] rs1
     /*  202501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202513 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202518 */     GIR_RootConstrainSelectedInstOperands,
     /*  202519 */     // GIR_Coverage, 860,
     /*  202519 */     GIR_Done,
     /*  202520 */   // Label 4042: @202520
     /*  202520 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(202561), // Rule ID 1022 //
     /*  202525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202528 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202535 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202542 */     // MIs[0] rs1
     /*  202542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202554 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202559 */     GIR_RootConstrainSelectedInstOperands,
     /*  202560 */     // GIR_Coverage, 1022,
     /*  202560 */     GIR_Done,
     /*  202561 */   // Label 4043: @202561
     /*  202561 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(202602), // Rule ID 1024 //
     /*  202566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202569 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202576 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202583 */     // MIs[0] rs1
     /*  202583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202595 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  202600 */     GIR_RootConstrainSelectedInstOperands,
     /*  202601 */     // GIR_Coverage, 1024,
     /*  202601 */     GIR_Done,
     /*  202602 */   // Label 4044: @202602
     /*  202602 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(202643), // Rule ID 1026 //
     /*  202607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202610 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202624 */     // MIs[0] rs1
     /*  202624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202636 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202636 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  202641 */     GIR_RootConstrainSelectedInstOperands,
     /*  202642 */     // GIR_Coverage, 1026,
     /*  202642 */     GIR_Done,
     /*  202643 */   // Label 4045: @202643
     /*  202643 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(202684), // Rule ID 1028 //
     /*  202648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202651 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202658 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202665 */     // MIs[0] rs1
     /*  202665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202677 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  202682 */     GIR_RootConstrainSelectedInstOperands,
     /*  202683 */     // GIR_Coverage, 1028,
     /*  202683 */     GIR_Done,
     /*  202684 */   // Label 4046: @202684
     /*  202684 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(202725), // Rule ID 1030 //
     /*  202689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202692 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202699 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202706 */     // MIs[0] rs1
     /*  202706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202718 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  202723 */     GIR_RootConstrainSelectedInstOperands,
     /*  202724 */     // GIR_Coverage, 1030,
     /*  202724 */     GIR_Done,
     /*  202725 */   // Label 4047: @202725
     /*  202725 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(202766), // Rule ID 1032 //
     /*  202730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202733 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202740 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202747 */     // MIs[0] rs1
     /*  202747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202759 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202764 */     GIR_RootConstrainSelectedInstOperands,
     /*  202765 */     // GIR_Coverage, 1032,
     /*  202765 */     GIR_Done,
     /*  202766 */   // Label 4048: @202766
     /*  202766 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(202807), // Rule ID 1034 //
     /*  202771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202774 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202781 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202788 */     // MIs[0] rs1
     /*  202788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202800 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202805 */     GIR_RootConstrainSelectedInstOperands,
     /*  202806 */     // GIR_Coverage, 1034,
     /*  202806 */     GIR_Done,
     /*  202807 */   // Label 4049: @202807
     /*  202807 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(202848), // Rule ID 1036 //
     /*  202812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202815 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202829 */     // MIs[0] rs1
     /*  202829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202841 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202841 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202846 */     GIR_RootConstrainSelectedInstOperands,
     /*  202847 */     // GIR_Coverage, 1036,
     /*  202847 */     GIR_Done,
     /*  202848 */   // Label 4050: @202848
     /*  202848 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(202889), // Rule ID 1038 //
     /*  202853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202856 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202863 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202870 */     // MIs[0] rs1
     /*  202870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202882 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202887 */     GIR_RootConstrainSelectedInstOperands,
     /*  202888 */     // GIR_Coverage, 1038,
     /*  202888 */     GIR_Done,
     /*  202889 */   // Label 4051: @202889
     /*  202889 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(202930), // Rule ID 1040 //
     /*  202894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202897 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202904 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202911 */     // MIs[0] rs1
     /*  202911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202923 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202928 */     GIR_RootConstrainSelectedInstOperands,
     /*  202929 */     // GIR_Coverage, 1040,
     /*  202929 */     GIR_Done,
     /*  202930 */   // Label 4052: @202930
     /*  202930 */   GIM_Reject,
     /*  202931 */ // Label 4022: @202931
     /*  202931 */ GIM_Reject,
     /*  202932 */ // Label 4020: @202932
     /*  202932 */ GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(204581),
     /*  202937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  202940 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(202981), // Rule ID 493 //
     /*  202945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  202948 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202955 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202962 */     // MIs[0] rs1
     /*  202962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202974 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202979 */     GIR_RootConstrainSelectedInstOperands,
     /*  202980 */     // GIR_Coverage, 493,
     /*  202980 */     GIR_Done,
     /*  202981 */   // Label 4054: @202981
     /*  202981 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(203022), // Rule ID 495 //
     /*  202986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  202989 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202996 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203003 */     // MIs[0] rs1
     /*  203003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203015 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  203020 */     GIR_RootConstrainSelectedInstOperands,
     /*  203021 */     // GIR_Coverage, 495,
     /*  203021 */     GIR_Done,
     /*  203022 */   // Label 4055: @203022
     /*  203022 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(203063), // Rule ID 497 //
     /*  203027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203030 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203037 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203044 */     // MIs[0] rs1
     /*  203044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203056 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  203061 */     GIR_RootConstrainSelectedInstOperands,
     /*  203062 */     // GIR_Coverage, 497,
     /*  203062 */     GIR_Done,
     /*  203063 */   // Label 4056: @203063
     /*  203063 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(203104), // Rule ID 499 //
     /*  203068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203071 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203078 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203085 */     // MIs[0] rs1
     /*  203085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203097 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  203102 */     GIR_RootConstrainSelectedInstOperands,
     /*  203103 */     // GIR_Coverage, 499,
     /*  203103 */     GIR_Done,
     /*  203104 */   // Label 4057: @203104
     /*  203104 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(203145), // Rule ID 501 //
     /*  203109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203112 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203119 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203126 */     // MIs[0] rs1
     /*  203126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203138 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203138 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  203143 */     GIR_RootConstrainSelectedInstOperands,
     /*  203144 */     // GIR_Coverage, 501,
     /*  203144 */     GIR_Done,
     /*  203145 */   // Label 4058: @203145
     /*  203145 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(203186), // Rule ID 503 //
     /*  203150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203153 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203160 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203167 */     // MIs[0] rs1
     /*  203167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203179 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203179 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203184 */     GIR_RootConstrainSelectedInstOperands,
     /*  203185 */     // GIR_Coverage, 503,
     /*  203185 */     GIR_Done,
     /*  203186 */   // Label 4059: @203186
     /*  203186 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(203227), // Rule ID 505 //
     /*  203191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203194 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203201 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203208 */     // MIs[0] rs1
     /*  203208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203220 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203225 */     GIR_RootConstrainSelectedInstOperands,
     /*  203226 */     // GIR_Coverage, 505,
     /*  203226 */     GIR_Done,
     /*  203227 */   // Label 4060: @203227
     /*  203227 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(203268), // Rule ID 507 //
     /*  203232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203235 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203242 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203249 */     // MIs[0] rs1
     /*  203249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203261 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203266 */     GIR_RootConstrainSelectedInstOperands,
     /*  203267 */     // GIR_Coverage, 507,
     /*  203267 */     GIR_Done,
     /*  203268 */   // Label 4061: @203268
     /*  203268 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(203309), // Rule ID 509 //
     /*  203273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203276 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203290 */     // MIs[0] rs1
     /*  203290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203302 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203307 */     GIR_RootConstrainSelectedInstOperands,
     /*  203308 */     // GIR_Coverage, 509,
     /*  203308 */     GIR_Done,
     /*  203309 */   // Label 4062: @203309
     /*  203309 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(203350), // Rule ID 511 //
     /*  203314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203317 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203324 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203331 */     // MIs[0] rs1
     /*  203331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203343 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203348 */     GIR_RootConstrainSelectedInstOperands,
     /*  203349 */     // GIR_Coverage, 511,
     /*  203349 */     GIR_Done,
     /*  203350 */   // Label 4063: @203350
     /*  203350 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(203391), // Rule ID 603 //
     /*  203355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203358 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203365 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203372 */     // MIs[0] rs1
     /*  203372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203384 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203389 */     GIR_RootConstrainSelectedInstOperands,
     /*  203390 */     // GIR_Coverage, 603,
     /*  203390 */     GIR_Done,
     /*  203391 */   // Label 4064: @203391
     /*  203391 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(203432), // Rule ID 604 //
     /*  203396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203399 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203406 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203413 */     // MIs[0] rs1
     /*  203413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203425 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ),
     /*  203430 */     GIR_RootConstrainSelectedInstOperands,
     /*  203431 */     // GIR_Coverage, 604,
     /*  203431 */     GIR_Done,
     /*  203432 */   // Label 4065: @203432
     /*  203432 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(203473), // Rule ID 605 //
     /*  203437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203440 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203454 */     // MIs[0] rs1
     /*  203454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203466 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_RL),
     /*  203471 */     GIR_RootConstrainSelectedInstOperands,
     /*  203472 */     // GIR_Coverage, 605,
     /*  203472 */     GIR_Done,
     /*  203473 */   // Label 4066: @203473
     /*  203473 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(203514), // Rule ID 606 //
     /*  203478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203481 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203488 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203495 */     // MIs[0] rs1
     /*  203495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203507 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  203512 */     GIR_RootConstrainSelectedInstOperands,
     /*  203513 */     // GIR_Coverage, 606,
     /*  203513 */     GIR_Done,
     /*  203514 */   // Label 4067: @203514
     /*  203514 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(203555), // Rule ID 607 //
     /*  203519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203522 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203529 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203536 */     // MIs[0] rs1
     /*  203536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203548 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  203553 */     GIR_RootConstrainSelectedInstOperands,
     /*  203554 */     // GIR_Coverage, 607,
     /*  203554 */     GIR_Done,
     /*  203555 */   // Label 4068: @203555
     /*  203555 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(203596), // Rule ID 608 //
     /*  203560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203563 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203570 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203577 */     // MIs[0] rs1
     /*  203577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203589 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203594 */     GIR_RootConstrainSelectedInstOperands,
     /*  203595 */     // GIR_Coverage, 608,
     /*  203595 */     GIR_Done,
     /*  203596 */   // Label 4069: @203596
     /*  203596 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(203637), // Rule ID 609 //
     /*  203601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203604 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203611 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203618 */     // MIs[0] rs1
     /*  203618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203630 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203635 */     GIR_RootConstrainSelectedInstOperands,
     /*  203636 */     // GIR_Coverage, 609,
     /*  203636 */     GIR_Done,
     /*  203637 */   // Label 4070: @203637
     /*  203637 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(203678), // Rule ID 610 //
     /*  203642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203659 */     // MIs[0] rs1
     /*  203659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203671 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203676 */     GIR_RootConstrainSelectedInstOperands,
     /*  203677 */     // GIR_Coverage, 610,
     /*  203677 */     GIR_Done,
     /*  203678 */   // Label 4071: @203678
     /*  203678 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(203719), // Rule ID 611 //
     /*  203683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203700 */     // MIs[0] rs1
     /*  203700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203712 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203717 */     GIR_RootConstrainSelectedInstOperands,
     /*  203718 */     // GIR_Coverage, 611,
     /*  203718 */     GIR_Done,
     /*  203719 */   // Label 4072: @203719
     /*  203719 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(203760), // Rule ID 612 //
     /*  203724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203727 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203734 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203741 */     // MIs[0] rs1
     /*  203741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203753 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203758 */     GIR_RootConstrainSelectedInstOperands,
     /*  203759 */     // GIR_Coverage, 612,
     /*  203759 */     GIR_Done,
     /*  203760 */   // Label 4073: @203760
     /*  203760 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(203801), // Rule ID 841 //
     /*  203765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203768 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203775 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203782 */     // MIs[0] rs1
     /*  203782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203794 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  203799 */     GIR_RootConstrainSelectedInstOperands,
     /*  203800 */     // GIR_Coverage, 841,
     /*  203800 */     GIR_Done,
     /*  203801 */   // Label 4074: @203801
     /*  203801 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(203842), // Rule ID 843 //
     /*  203806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203809 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203816 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203823 */     // MIs[0] rs1
     /*  203823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203835 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  203840 */     GIR_RootConstrainSelectedInstOperands,
     /*  203841 */     // GIR_Coverage, 843,
     /*  203841 */     GIR_Done,
     /*  203842 */   // Label 4075: @203842
     /*  203842 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(203883), // Rule ID 845 //
     /*  203847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203850 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203857 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203864 */     // MIs[0] rs1
     /*  203864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203876 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  203881 */     GIR_RootConstrainSelectedInstOperands,
     /*  203882 */     // GIR_Coverage, 845,
     /*  203882 */     GIR_Done,
     /*  203883 */   // Label 4076: @203883
     /*  203883 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(203924), // Rule ID 847 //
     /*  203888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203898 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203905 */     // MIs[0] rs1
     /*  203905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203917 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  203922 */     GIR_RootConstrainSelectedInstOperands,
     /*  203923 */     // GIR_Coverage, 847,
     /*  203923 */     GIR_Done,
     /*  203924 */   // Label 4077: @203924
     /*  203924 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(203965), // Rule ID 849 //
     /*  203929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203932 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203939 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203946 */     // MIs[0] rs1
     /*  203946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203958 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  203963 */     GIR_RootConstrainSelectedInstOperands,
     /*  203964 */     // GIR_Coverage, 849,
     /*  203964 */     GIR_Done,
     /*  203965 */   // Label 4078: @203965
     /*  203965 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(204006), // Rule ID 851 //
     /*  203970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  203973 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203980 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203987 */     // MIs[0] rs1
     /*  203987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203999 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204004 */     GIR_RootConstrainSelectedInstOperands,
     /*  204005 */     // GIR_Coverage, 851,
     /*  204005 */     GIR_Done,
     /*  204006 */   // Label 4079: @204006
     /*  204006 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(204047), // Rule ID 853 //
     /*  204011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204014 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204021 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204028 */     // MIs[0] rs1
     /*  204028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204040 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204045 */     GIR_RootConstrainSelectedInstOperands,
     /*  204046 */     // GIR_Coverage, 853,
     /*  204046 */     GIR_Done,
     /*  204047 */   // Label 4080: @204047
     /*  204047 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(204088), // Rule ID 855 //
     /*  204052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204055 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204062 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204069 */     // MIs[0] rs1
     /*  204069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204081 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204086 */     GIR_RootConstrainSelectedInstOperands,
     /*  204087 */     // GIR_Coverage, 855,
     /*  204087 */     GIR_Done,
     /*  204088 */   // Label 4081: @204088
     /*  204088 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(204129), // Rule ID 857 //
     /*  204093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204096 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204103 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204110 */     // MIs[0] rs1
     /*  204110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204122 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204127 */     GIR_RootConstrainSelectedInstOperands,
     /*  204128 */     // GIR_Coverage, 857,
     /*  204128 */     GIR_Done,
     /*  204129 */   // Label 4082: @204129
     /*  204129 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(204170), // Rule ID 859 //
     /*  204134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204137 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204144 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204151 */     // MIs[0] rs1
     /*  204151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204163 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204168 */     GIR_RootConstrainSelectedInstOperands,
     /*  204169 */     // GIR_Coverage, 859,
     /*  204169 */     GIR_Done,
     /*  204170 */   // Label 4083: @204170
     /*  204170 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(204211), // Rule ID 1021 //
     /*  204175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204178 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204185 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204192 */     // MIs[0] rs1
     /*  204192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204204 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204209 */     GIR_RootConstrainSelectedInstOperands,
     /*  204210 */     // GIR_Coverage, 1021,
     /*  204210 */     GIR_Done,
     /*  204211 */   // Label 4084: @204211
     /*  204211 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(204252), // Rule ID 1023 //
     /*  204216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204219 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204226 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204233 */     // MIs[0] rs1
     /*  204233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204245 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  204250 */     GIR_RootConstrainSelectedInstOperands,
     /*  204251 */     // GIR_Coverage, 1023,
     /*  204251 */     GIR_Done,
     /*  204252 */   // Label 4085: @204252
     /*  204252 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(204293), // Rule ID 1025 //
     /*  204257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204260 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204267 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204274 */     // MIs[0] rs1
     /*  204274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204286 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  204291 */     GIR_RootConstrainSelectedInstOperands,
     /*  204292 */     // GIR_Coverage, 1025,
     /*  204292 */     GIR_Done,
     /*  204293 */   // Label 4086: @204293
     /*  204293 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(204334), // Rule ID 1027 //
     /*  204298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204301 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204308 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204315 */     // MIs[0] rs1
     /*  204315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204327 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  204332 */     GIR_RootConstrainSelectedInstOperands,
     /*  204333 */     // GIR_Coverage, 1027,
     /*  204333 */     GIR_Done,
     /*  204334 */   // Label 4087: @204334
     /*  204334 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(204375), // Rule ID 1029 //
     /*  204339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204342 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204349 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204356 */     // MIs[0] rs1
     /*  204356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204368 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  204373 */     GIR_RootConstrainSelectedInstOperands,
     /*  204374 */     // GIR_Coverage, 1029,
     /*  204374 */     GIR_Done,
     /*  204375 */   // Label 4088: @204375
     /*  204375 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(204416), // Rule ID 1031 //
     /*  204380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204383 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204397 */     // MIs[0] rs1
     /*  204397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204409 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204414 */     GIR_RootConstrainSelectedInstOperands,
     /*  204415 */     // GIR_Coverage, 1031,
     /*  204415 */     GIR_Done,
     /*  204416 */   // Label 4089: @204416
     /*  204416 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(204457), // Rule ID 1033 //
     /*  204421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204424 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204431 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204438 */     // MIs[0] rs1
     /*  204438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204450 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204455 */     GIR_RootConstrainSelectedInstOperands,
     /*  204456 */     // GIR_Coverage, 1033,
     /*  204456 */     GIR_Done,
     /*  204457 */   // Label 4090: @204457
     /*  204457 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(204498), // Rule ID 1035 //
     /*  204462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204465 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204472 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204479 */     // MIs[0] rs1
     /*  204479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204491 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204496 */     GIR_RootConstrainSelectedInstOperands,
     /*  204497 */     // GIR_Coverage, 1035,
     /*  204497 */     GIR_Done,
     /*  204498 */   // Label 4091: @204498
     /*  204498 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(204539), // Rule ID 1037 //
     /*  204503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204506 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204513 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204520 */     // MIs[0] rs1
     /*  204520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204532 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204537 */     GIR_RootConstrainSelectedInstOperands,
     /*  204538 */     // GIR_Coverage, 1037,
     /*  204538 */     GIR_Done,
     /*  204539 */   // Label 4092: @204539
     /*  204539 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(204580), // Rule ID 1039 //
     /*  204544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204561 */     // MIs[0] rs1
     /*  204561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204573 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204578 */     GIR_RootConstrainSelectedInstOperands,
     /*  204579 */     // GIR_Coverage, 1039,
     /*  204579 */     GIR_Done,
     /*  204580 */   // Label 4093: @204580
     /*  204580 */   GIM_Reject,
     /*  204581 */ // Label 4053: @204581
     /*  204581 */ GIM_Reject,
     /*  204582 */ // Label 4021: @204582
     /*  204582 */ GIM_Reject,
     /*  204583 */ // Label 35: @204583
     /*  204583 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4096*/ GIMT_Encode4(207492),
     /*  204594 */ /*GILLT_s32*//*Label 4094*/ GIMT_Encode4(204602),
     /*  204598 */ /*GILLT_s64*//*Label 4095*/ GIMT_Encode4(205842),
     /*  204602 */ // Label 4094: @204602
     /*  204602 */ GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(205841),
     /*  204607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  204610 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(204651), // Rule ID 514 //
     /*  204615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204632 */     // MIs[0] rs1
     /*  204632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204644 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204649 */     GIR_RootConstrainSelectedInstOperands,
     /*  204650 */     // GIR_Coverage, 514,
     /*  204650 */     GIR_Done,
     /*  204651 */   // Label 4098: @204651
     /*  204651 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(204692), // Rule ID 516 //
     /*  204656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204659 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204666 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204673 */     // MIs[0] rs1
     /*  204673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204685 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  204690 */     GIR_RootConstrainSelectedInstOperands,
     /*  204691 */     // GIR_Coverage, 516,
     /*  204691 */     GIR_Done,
     /*  204692 */   // Label 4099: @204692
     /*  204692 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(204733), // Rule ID 518 //
     /*  204697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204707 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204714 */     // MIs[0] rs1
     /*  204714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204726 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  204731 */     GIR_RootConstrainSelectedInstOperands,
     /*  204732 */     // GIR_Coverage, 518,
     /*  204732 */     GIR_Done,
     /*  204733 */   // Label 4100: @204733
     /*  204733 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(204774), // Rule ID 520 //
     /*  204738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204741 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204748 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204755 */     // MIs[0] rs1
     /*  204755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204767 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  204772 */     GIR_RootConstrainSelectedInstOperands,
     /*  204773 */     // GIR_Coverage, 520,
     /*  204773 */     GIR_Done,
     /*  204774 */   // Label 4101: @204774
     /*  204774 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(204815), // Rule ID 522 //
     /*  204779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204782 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204789 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204796 */     // MIs[0] rs1
     /*  204796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204808 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  204813 */     GIR_RootConstrainSelectedInstOperands,
     /*  204814 */     // GIR_Coverage, 522,
     /*  204814 */     GIR_Done,
     /*  204815 */   // Label 4102: @204815
     /*  204815 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(204856), // Rule ID 524 //
     /*  204820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204823 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204830 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204837 */     // MIs[0] rs1
     /*  204837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204849 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204854 */     GIR_RootConstrainSelectedInstOperands,
     /*  204855 */     // GIR_Coverage, 524,
     /*  204855 */     GIR_Done,
     /*  204856 */   // Label 4103: @204856
     /*  204856 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(204897), // Rule ID 526 //
     /*  204861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204864 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204878 */     // MIs[0] rs1
     /*  204878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204890 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204895 */     GIR_RootConstrainSelectedInstOperands,
     /*  204896 */     // GIR_Coverage, 526,
     /*  204896 */     GIR_Done,
     /*  204897 */   // Label 4104: @204897
     /*  204897 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(204938), // Rule ID 528 //
     /*  204902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204919 */     // MIs[0] rs1
     /*  204919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204931 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204936 */     GIR_RootConstrainSelectedInstOperands,
     /*  204937 */     // GIR_Coverage, 528,
     /*  204937 */     GIR_Done,
     /*  204938 */   // Label 4105: @204938
     /*  204938 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(204979), // Rule ID 530 //
     /*  204943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204946 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204960 */     // MIs[0] rs1
     /*  204960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204972 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204977 */     GIR_RootConstrainSelectedInstOperands,
     /*  204978 */     // GIR_Coverage, 530,
     /*  204978 */     GIR_Done,
     /*  204979 */   // Label 4106: @204979
     /*  204979 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(205020), // Rule ID 532 //
     /*  204984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204987 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204994 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205001 */     // MIs[0] rs1
     /*  205001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205013 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205018 */     GIR_RootConstrainSelectedInstOperands,
     /*  205019 */     // GIR_Coverage, 532,
     /*  205019 */     GIR_Done,
     /*  205020 */   // Label 4107: @205020
     /*  205020 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(205061), // Rule ID 862 //
     /*  205025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205028 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205035 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205042 */     // MIs[0] rs1
     /*  205042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205054 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205059 */     GIR_RootConstrainSelectedInstOperands,
     /*  205060 */     // GIR_Coverage, 862,
     /*  205060 */     GIR_Done,
     /*  205061 */   // Label 4108: @205061
     /*  205061 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(205102), // Rule ID 864 //
     /*  205066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205069 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205076 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205083 */     // MIs[0] rs1
     /*  205083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205095 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  205100 */     GIR_RootConstrainSelectedInstOperands,
     /*  205101 */     // GIR_Coverage, 864,
     /*  205101 */     GIR_Done,
     /*  205102 */   // Label 4109: @205102
     /*  205102 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(205143), // Rule ID 866 //
     /*  205107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205110 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205117 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205124 */     // MIs[0] rs1
     /*  205124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205136 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205136 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  205141 */     GIR_RootConstrainSelectedInstOperands,
     /*  205142 */     // GIR_Coverage, 866,
     /*  205142 */     GIR_Done,
     /*  205143 */   // Label 4110: @205143
     /*  205143 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(205184), // Rule ID 868 //
     /*  205148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205151 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205158 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205165 */     // MIs[0] rs1
     /*  205165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205177 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  205182 */     GIR_RootConstrainSelectedInstOperands,
     /*  205183 */     // GIR_Coverage, 868,
     /*  205183 */     GIR_Done,
     /*  205184 */   // Label 4111: @205184
     /*  205184 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(205225), // Rule ID 870 //
     /*  205189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205192 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205199 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205206 */     // MIs[0] rs1
     /*  205206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205218 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  205223 */     GIR_RootConstrainSelectedInstOperands,
     /*  205224 */     // GIR_Coverage, 870,
     /*  205224 */     GIR_Done,
     /*  205225 */   // Label 4112: @205225
     /*  205225 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(205266), // Rule ID 872 //
     /*  205230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205233 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205240 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205247 */     // MIs[0] rs1
     /*  205247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205259 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205264 */     GIR_RootConstrainSelectedInstOperands,
     /*  205265 */     // GIR_Coverage, 872,
     /*  205265 */     GIR_Done,
     /*  205266 */   // Label 4113: @205266
     /*  205266 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(205307), // Rule ID 874 //
     /*  205271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205274 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205281 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205288 */     // MIs[0] rs1
     /*  205288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205300 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205300 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205305 */     GIR_RootConstrainSelectedInstOperands,
     /*  205306 */     // GIR_Coverage, 874,
     /*  205306 */     GIR_Done,
     /*  205307 */   // Label 4114: @205307
     /*  205307 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(205348), // Rule ID 876 //
     /*  205312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205315 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205322 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205329 */     // MIs[0] rs1
     /*  205329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205341 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205346 */     GIR_RootConstrainSelectedInstOperands,
     /*  205347 */     // GIR_Coverage, 876,
     /*  205347 */     GIR_Done,
     /*  205348 */   // Label 4115: @205348
     /*  205348 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(205389), // Rule ID 878 //
     /*  205353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205356 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205363 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205370 */     // MIs[0] rs1
     /*  205370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205382 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205387 */     GIR_RootConstrainSelectedInstOperands,
     /*  205388 */     // GIR_Coverage, 878,
     /*  205388 */     GIR_Done,
     /*  205389 */   // Label 4116: @205389
     /*  205389 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(205430), // Rule ID 880 //
     /*  205394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205397 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205404 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205411 */     // MIs[0] rs1
     /*  205411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205423 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205423 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205428 */     GIR_RootConstrainSelectedInstOperands,
     /*  205429 */     // GIR_Coverage, 880,
     /*  205429 */     GIR_Done,
     /*  205430 */   // Label 4117: @205430
     /*  205430 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(205471), // Rule ID 1042 //
     /*  205435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205438 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205445 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205452 */     // MIs[0] rs1
     /*  205452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205464 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205469 */     GIR_RootConstrainSelectedInstOperands,
     /*  205470 */     // GIR_Coverage, 1042,
     /*  205470 */     GIR_Done,
     /*  205471 */   // Label 4118: @205471
     /*  205471 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(205512), // Rule ID 1044 //
     /*  205476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205479 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205486 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205493 */     // MIs[0] rs1
     /*  205493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205505 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  205510 */     GIR_RootConstrainSelectedInstOperands,
     /*  205511 */     // GIR_Coverage, 1044,
     /*  205511 */     GIR_Done,
     /*  205512 */   // Label 4119: @205512
     /*  205512 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(205553), // Rule ID 1046 //
     /*  205517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205520 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205527 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205534 */     // MIs[0] rs1
     /*  205534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205546 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  205551 */     GIR_RootConstrainSelectedInstOperands,
     /*  205552 */     // GIR_Coverage, 1046,
     /*  205552 */     GIR_Done,
     /*  205553 */   // Label 4120: @205553
     /*  205553 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(205594), // Rule ID 1048 //
     /*  205558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205561 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205568 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205575 */     // MIs[0] rs1
     /*  205575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205587 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  205592 */     GIR_RootConstrainSelectedInstOperands,
     /*  205593 */     // GIR_Coverage, 1048,
     /*  205593 */     GIR_Done,
     /*  205594 */   // Label 4121: @205594
     /*  205594 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(205635), // Rule ID 1050 //
     /*  205599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205602 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205609 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205616 */     // MIs[0] rs1
     /*  205616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205628 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  205633 */     GIR_RootConstrainSelectedInstOperands,
     /*  205634 */     // GIR_Coverage, 1050,
     /*  205634 */     GIR_Done,
     /*  205635 */   // Label 4122: @205635
     /*  205635 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(205676), // Rule ID 1052 //
     /*  205640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205643 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205650 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205657 */     // MIs[0] rs1
     /*  205657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205669 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205674 */     GIR_RootConstrainSelectedInstOperands,
     /*  205675 */     // GIR_Coverage, 1052,
     /*  205675 */     GIR_Done,
     /*  205676 */   // Label 4123: @205676
     /*  205676 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(205717), // Rule ID 1054 //
     /*  205681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205684 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205691 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205698 */     // MIs[0] rs1
     /*  205698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205710 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205715 */     GIR_RootConstrainSelectedInstOperands,
     /*  205716 */     // GIR_Coverage, 1054,
     /*  205716 */     GIR_Done,
     /*  205717 */   // Label 4124: @205717
     /*  205717 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(205758), // Rule ID 1056 //
     /*  205722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205725 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205732 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205739 */     // MIs[0] rs1
     /*  205739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205751 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205756 */     GIR_RootConstrainSelectedInstOperands,
     /*  205757 */     // GIR_Coverage, 1056,
     /*  205757 */     GIR_Done,
     /*  205758 */   // Label 4125: @205758
     /*  205758 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(205799), // Rule ID 1058 //
     /*  205763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205766 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205773 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205780 */     // MIs[0] rs1
     /*  205780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205792 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205797 */     GIR_RootConstrainSelectedInstOperands,
     /*  205798 */     // GIR_Coverage, 1058,
     /*  205798 */     GIR_Done,
     /*  205799 */   // Label 4126: @205799
     /*  205799 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(205840), // Rule ID 1060 //
     /*  205804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205807 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205814 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205821 */     // MIs[0] rs1
     /*  205821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205833 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205838 */     GIR_RootConstrainSelectedInstOperands,
     /*  205839 */     // GIR_Coverage, 1060,
     /*  205839 */     GIR_Done,
     /*  205840 */   // Label 4127: @205840
     /*  205840 */   GIM_Reject,
     /*  205841 */ // Label 4097: @205841
     /*  205841 */ GIM_Reject,
     /*  205842 */ // Label 4095: @205842
     /*  205842 */ GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(207491),
     /*  205847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  205850 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(205891), // Rule ID 513 //
     /*  205855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  205858 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205865 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205872 */     // MIs[0] rs1
     /*  205872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205884 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205889 */     GIR_RootConstrainSelectedInstOperands,
     /*  205890 */     // GIR_Coverage, 513,
     /*  205890 */     GIR_Done,
     /*  205891 */   // Label 4129: @205891
     /*  205891 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(205932), // Rule ID 515 //
     /*  205896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  205899 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205906 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205913 */     // MIs[0] rs1
     /*  205913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205925 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  205930 */     GIR_RootConstrainSelectedInstOperands,
     /*  205931 */     // GIR_Coverage, 515,
     /*  205931 */     GIR_Done,
     /*  205932 */   // Label 4130: @205932
     /*  205932 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(205973), // Rule ID 517 //
     /*  205937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  205940 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205947 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205954 */     // MIs[0] rs1
     /*  205954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205966 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  205971 */     GIR_RootConstrainSelectedInstOperands,
     /*  205972 */     // GIR_Coverage, 517,
     /*  205972 */     GIR_Done,
     /*  205973 */   // Label 4131: @205973
     /*  205973 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(206014), // Rule ID 519 //
     /*  205978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  205981 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205988 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205995 */     // MIs[0] rs1
     /*  205995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206007 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  206012 */     GIR_RootConstrainSelectedInstOperands,
     /*  206013 */     // GIR_Coverage, 519,
     /*  206013 */     GIR_Done,
     /*  206014 */   // Label 4132: @206014
     /*  206014 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(206055), // Rule ID 521 //
     /*  206019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206022 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206036 */     // MIs[0] rs1
     /*  206036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206048 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  206053 */     GIR_RootConstrainSelectedInstOperands,
     /*  206054 */     // GIR_Coverage, 521,
     /*  206054 */     GIR_Done,
     /*  206055 */   // Label 4133: @206055
     /*  206055 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(206096), // Rule ID 523 //
     /*  206060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206063 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206077 */     // MIs[0] rs1
     /*  206077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206089 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206094 */     GIR_RootConstrainSelectedInstOperands,
     /*  206095 */     // GIR_Coverage, 523,
     /*  206095 */     GIR_Done,
     /*  206096 */   // Label 4134: @206096
     /*  206096 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(206137), // Rule ID 525 //
     /*  206101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206104 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206111 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206118 */     // MIs[0] rs1
     /*  206118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206130 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206135 */     GIR_RootConstrainSelectedInstOperands,
     /*  206136 */     // GIR_Coverage, 525,
     /*  206136 */     GIR_Done,
     /*  206137 */   // Label 4135: @206137
     /*  206137 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(206178), // Rule ID 527 //
     /*  206142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206145 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206159 */     // MIs[0] rs1
     /*  206159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206171 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206176 */     GIR_RootConstrainSelectedInstOperands,
     /*  206177 */     // GIR_Coverage, 527,
     /*  206177 */     GIR_Done,
     /*  206178 */   // Label 4136: @206178
     /*  206178 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(206219), // Rule ID 529 //
     /*  206183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206186 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206193 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206200 */     // MIs[0] rs1
     /*  206200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206212 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206217 */     GIR_RootConstrainSelectedInstOperands,
     /*  206218 */     // GIR_Coverage, 529,
     /*  206218 */     GIR_Done,
     /*  206219 */   // Label 4137: @206219
     /*  206219 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(206260), // Rule ID 531 //
     /*  206224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206227 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206234 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206241 */     // MIs[0] rs1
     /*  206241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206253 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206258 */     GIR_RootConstrainSelectedInstOperands,
     /*  206259 */     // GIR_Coverage, 531,
     /*  206259 */     GIR_Done,
     /*  206260 */   // Label 4138: @206260
     /*  206260 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(206301), // Rule ID 613 //
     /*  206265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206268 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206275 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206282 */     // MIs[0] rs1
     /*  206282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206294 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206299 */     GIR_RootConstrainSelectedInstOperands,
     /*  206300 */     // GIR_Coverage, 613,
     /*  206300 */     GIR_Done,
     /*  206301 */   // Label 4139: @206301
     /*  206301 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(206342), // Rule ID 614 //
     /*  206306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206309 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206316 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206323 */     // MIs[0] rs1
     /*  206323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206335 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ),
     /*  206340 */     GIR_RootConstrainSelectedInstOperands,
     /*  206341 */     // GIR_Coverage, 614,
     /*  206341 */     GIR_Done,
     /*  206342 */   // Label 4140: @206342
     /*  206342 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(206383), // Rule ID 615 //
     /*  206347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206350 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206357 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206364 */     // MIs[0] rs1
     /*  206364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206376 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_RL),
     /*  206381 */     GIR_RootConstrainSelectedInstOperands,
     /*  206382 */     // GIR_Coverage, 615,
     /*  206382 */     GIR_Done,
     /*  206383 */   // Label 4141: @206383
     /*  206383 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(206424), // Rule ID 616 //
     /*  206388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206391 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206398 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206405 */     // MIs[0] rs1
     /*  206405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206417 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  206422 */     GIR_RootConstrainSelectedInstOperands,
     /*  206423 */     // GIR_Coverage, 616,
     /*  206423 */     GIR_Done,
     /*  206424 */   // Label 4142: @206424
     /*  206424 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(206465), // Rule ID 617 //
     /*  206429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206432 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206446 */     // MIs[0] rs1
     /*  206446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206458 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  206463 */     GIR_RootConstrainSelectedInstOperands,
     /*  206464 */     // GIR_Coverage, 617,
     /*  206464 */     GIR_Done,
     /*  206465 */   // Label 4143: @206465
     /*  206465 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(206506), // Rule ID 618 //
     /*  206470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206480 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206487 */     // MIs[0] rs1
     /*  206487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206499 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206504 */     GIR_RootConstrainSelectedInstOperands,
     /*  206505 */     // GIR_Coverage, 618,
     /*  206505 */     GIR_Done,
     /*  206506 */   // Label 4144: @206506
     /*  206506 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(206547), // Rule ID 619 //
     /*  206511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206514 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206521 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206528 */     // MIs[0] rs1
     /*  206528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206540 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206545 */     GIR_RootConstrainSelectedInstOperands,
     /*  206546 */     // GIR_Coverage, 619,
     /*  206546 */     GIR_Done,
     /*  206547 */   // Label 4145: @206547
     /*  206547 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(206588), // Rule ID 620 //
     /*  206552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206562 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206569 */     // MIs[0] rs1
     /*  206569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206581 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206586 */     GIR_RootConstrainSelectedInstOperands,
     /*  206587 */     // GIR_Coverage, 620,
     /*  206587 */     GIR_Done,
     /*  206588 */   // Label 4146: @206588
     /*  206588 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(206629), // Rule ID 621 //
     /*  206593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206610 */     // MIs[0] rs1
     /*  206610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206622 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206627 */     GIR_RootConstrainSelectedInstOperands,
     /*  206628 */     // GIR_Coverage, 621,
     /*  206628 */     GIR_Done,
     /*  206629 */   // Label 4147: @206629
     /*  206629 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(206670), // Rule ID 622 //
     /*  206634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206651 */     // MIs[0] rs1
     /*  206651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206663 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206668 */     GIR_RootConstrainSelectedInstOperands,
     /*  206669 */     // GIR_Coverage, 622,
     /*  206669 */     GIR_Done,
     /*  206670 */   // Label 4148: @206670
     /*  206670 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(206711), // Rule ID 861 //
     /*  206675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206678 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206692 */     // MIs[0] rs1
     /*  206692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206704 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206709 */     GIR_RootConstrainSelectedInstOperands,
     /*  206710 */     // GIR_Coverage, 861,
     /*  206710 */     GIR_Done,
     /*  206711 */   // Label 4149: @206711
     /*  206711 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(206752), // Rule ID 863 //
     /*  206716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206719 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206726 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206733 */     // MIs[0] rs1
     /*  206733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206745 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  206750 */     GIR_RootConstrainSelectedInstOperands,
     /*  206751 */     // GIR_Coverage, 863,
     /*  206751 */     GIR_Done,
     /*  206752 */   // Label 4150: @206752
     /*  206752 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(206793), // Rule ID 865 //
     /*  206757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206760 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206774 */     // MIs[0] rs1
     /*  206774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206786 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206786 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  206791 */     GIR_RootConstrainSelectedInstOperands,
     /*  206792 */     // GIR_Coverage, 865,
     /*  206792 */     GIR_Done,
     /*  206793 */   // Label 4151: @206793
     /*  206793 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(206834), // Rule ID 867 //
     /*  206798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206808 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206815 */     // MIs[0] rs1
     /*  206815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206827 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  206832 */     GIR_RootConstrainSelectedInstOperands,
     /*  206833 */     // GIR_Coverage, 867,
     /*  206833 */     GIR_Done,
     /*  206834 */   // Label 4152: @206834
     /*  206834 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(206875), // Rule ID 869 //
     /*  206839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206842 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206856 */     // MIs[0] rs1
     /*  206856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206868 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  206873 */     GIR_RootConstrainSelectedInstOperands,
     /*  206874 */     // GIR_Coverage, 869,
     /*  206874 */     GIR_Done,
     /*  206875 */   // Label 4153: @206875
     /*  206875 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(206916), // Rule ID 871 //
     /*  206880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206883 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206890 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206897 */     // MIs[0] rs1
     /*  206897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206909 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206914 */     GIR_RootConstrainSelectedInstOperands,
     /*  206915 */     // GIR_Coverage, 871,
     /*  206915 */     GIR_Done,
     /*  206916 */   // Label 4154: @206916
     /*  206916 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(206957), // Rule ID 873 //
     /*  206921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206924 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206931 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206938 */     // MIs[0] rs1
     /*  206938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206950 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206955 */     GIR_RootConstrainSelectedInstOperands,
     /*  206956 */     // GIR_Coverage, 873,
     /*  206956 */     GIR_Done,
     /*  206957 */   // Label 4155: @206957
     /*  206957 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(206998), // Rule ID 875 //
     /*  206962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206965 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206972 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206979 */     // MIs[0] rs1
     /*  206979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206991 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206996 */     GIR_RootConstrainSelectedInstOperands,
     /*  206997 */     // GIR_Coverage, 875,
     /*  206997 */     GIR_Done,
     /*  206998 */   // Label 4156: @206998
     /*  206998 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(207039), // Rule ID 877 //
     /*  207003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207006 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207013 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207020 */     // MIs[0] rs1
     /*  207020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207032 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207037 */     GIR_RootConstrainSelectedInstOperands,
     /*  207038 */     // GIR_Coverage, 877,
     /*  207038 */     GIR_Done,
     /*  207039 */   // Label 4157: @207039
     /*  207039 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(207080), // Rule ID 879 //
     /*  207044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207047 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207054 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207061 */     // MIs[0] rs1
     /*  207061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207073 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207078 */     GIR_RootConstrainSelectedInstOperands,
     /*  207079 */     // GIR_Coverage, 879,
     /*  207079 */     GIR_Done,
     /*  207080 */   // Label 4158: @207080
     /*  207080 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(207121), // Rule ID 1041 //
     /*  207085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207088 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207102 */     // MIs[0] rs1
     /*  207102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207114 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207119 */     GIR_RootConstrainSelectedInstOperands,
     /*  207120 */     // GIR_Coverage, 1041,
     /*  207120 */     GIR_Done,
     /*  207121 */   // Label 4159: @207121
     /*  207121 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(207162), // Rule ID 1043 //
     /*  207126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207129 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207136 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207143 */     // MIs[0] rs1
     /*  207143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207155 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  207160 */     GIR_RootConstrainSelectedInstOperands,
     /*  207161 */     // GIR_Coverage, 1043,
     /*  207161 */     GIR_Done,
     /*  207162 */   // Label 4160: @207162
     /*  207162 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(207203), // Rule ID 1045 //
     /*  207167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207170 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207177 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207184 */     // MIs[0] rs1
     /*  207184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207196 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  207201 */     GIR_RootConstrainSelectedInstOperands,
     /*  207202 */     // GIR_Coverage, 1045,
     /*  207202 */     GIR_Done,
     /*  207203 */   // Label 4161: @207203
     /*  207203 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(207244), // Rule ID 1047 //
     /*  207208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207211 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207218 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207225 */     // MIs[0] rs1
     /*  207225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207237 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  207242 */     GIR_RootConstrainSelectedInstOperands,
     /*  207243 */     // GIR_Coverage, 1047,
     /*  207243 */     GIR_Done,
     /*  207244 */   // Label 4162: @207244
     /*  207244 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(207285), // Rule ID 1049 //
     /*  207249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207252 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207259 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207266 */     // MIs[0] rs1
     /*  207266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207278 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  207283 */     GIR_RootConstrainSelectedInstOperands,
     /*  207284 */     // GIR_Coverage, 1049,
     /*  207284 */     GIR_Done,
     /*  207285 */   // Label 4163: @207285
     /*  207285 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(207326), // Rule ID 1051 //
     /*  207290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207293 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207300 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207307 */     // MIs[0] rs1
     /*  207307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207319 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207324 */     GIR_RootConstrainSelectedInstOperands,
     /*  207325 */     // GIR_Coverage, 1051,
     /*  207325 */     GIR_Done,
     /*  207326 */   // Label 4164: @207326
     /*  207326 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(207367), // Rule ID 1053 //
     /*  207331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207334 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207341 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207348 */     // MIs[0] rs1
     /*  207348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207360 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207365 */     GIR_RootConstrainSelectedInstOperands,
     /*  207366 */     // GIR_Coverage, 1053,
     /*  207366 */     GIR_Done,
     /*  207367 */   // Label 4165: @207367
     /*  207367 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(207408), // Rule ID 1055 //
     /*  207372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207375 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207382 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207389 */     // MIs[0] rs1
     /*  207389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207401 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207406 */     GIR_RootConstrainSelectedInstOperands,
     /*  207407 */     // GIR_Coverage, 1055,
     /*  207407 */     GIR_Done,
     /*  207408 */   // Label 4166: @207408
     /*  207408 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(207449), // Rule ID 1057 //
     /*  207413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207416 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207423 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207430 */     // MIs[0] rs1
     /*  207430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207442 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207447 */     GIR_RootConstrainSelectedInstOperands,
     /*  207448 */     // GIR_Coverage, 1057,
     /*  207448 */     GIR_Done,
     /*  207449 */   // Label 4167: @207449
     /*  207449 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(207490), // Rule ID 1059 //
     /*  207454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207457 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207464 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207471 */     // MIs[0] rs1
     /*  207471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207483 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207483 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207488 */     GIR_RootConstrainSelectedInstOperands,
     /*  207489 */     // GIR_Coverage, 1059,
     /*  207489 */     GIR_Done,
     /*  207490 */   // Label 4168: @207490
     /*  207490 */   GIM_Reject,
     /*  207491 */ // Label 4128: @207491
     /*  207491 */ GIM_Reject,
     /*  207492 */ // Label 4096: @207492
     /*  207492 */ GIM_Reject,
     /*  207493 */ // Label 36: @207493
     /*  207493 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4171*/ GIMT_Encode4(207710),
     /*  207504 */ /*GILLT_s32*//*Label 4169*/ GIMT_Encode4(207512),
     /*  207508 */ /*GILLT_s64*//*Label 4170*/ GIMT_Encode4(207611),
     /*  207512 */ // Label 4169: @207512
     /*  207512 */ GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(207538), // Rule ID 255 //
     /*  207517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207520 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  207524 */   // MIs[0] Operand 1
     /*  207524 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207527 */   // (atomic_fence 4:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 2:{ *:[i32] }, 3:{ *:[i32] })
     /*  207527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  207533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207536 */   GIR_RootConstrainSelectedInstOperands,
     /*  207537 */   // GIR_Coverage, 255,
     /*  207537 */   GIR_EraseRootFromParent_Done,
     /*  207538 */ // Label 4172: @207538
     /*  207538 */ GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(207564), // Rule ID 257 //
     /*  207543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207546 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  207550 */   // MIs[0] Operand 1
     /*  207550 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207553 */   // (atomic_fence 5:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  207553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  207562 */   GIR_RootConstrainSelectedInstOperands,
     /*  207563 */   // GIR_Coverage, 257,
     /*  207563 */   GIR_EraseRootFromParent_Done,
     /*  207564 */ // Label 4173: @207564
     /*  207564 */ GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(207584), // Rule ID 259 //
     /*  207569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207572 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  207576 */   // MIs[0] Operand 1
     /*  207576 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207579 */   // (atomic_fence 6:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE_TSO)
     /*  207579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  207582 */   GIR_RootConstrainSelectedInstOperands,
     /*  207583 */   // GIR_Coverage, 259,
     /*  207583 */   GIR_EraseRootFromParent_Done,
     /*  207584 */ // Label 4174: @207584
     /*  207584 */ GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(207610), // Rule ID 261 //
     /*  207589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207592 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  207596 */   // MIs[0] Operand 1
     /*  207596 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207599 */   // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  207599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207608 */   GIR_RootConstrainSelectedInstOperands,
     /*  207609 */   // GIR_Coverage, 261,
     /*  207609 */   GIR_EraseRootFromParent_Done,
     /*  207610 */ // Label 4175: @207610
     /*  207610 */ GIM_Reject,
     /*  207611 */ // Label 4170: @207611
     /*  207611 */ GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(207637), // Rule ID 254 //
     /*  207616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207619 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  207623 */   // MIs[0] Operand 1
     /*  207623 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207626 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 2:{ *:[i64] }, 3:{ *:[i64] })
     /*  207626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  207632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207635 */   GIR_RootConstrainSelectedInstOperands,
     /*  207636 */   // GIR_Coverage, 254,
     /*  207636 */   GIR_EraseRootFromParent_Done,
     /*  207637 */ // Label 4176: @207637
     /*  207637 */ GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(207663), // Rule ID 256 //
     /*  207642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207645 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  207649 */   // MIs[0] Operand 1
     /*  207649 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207652 */   // (atomic_fence 5:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  207652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  207661 */   GIR_RootConstrainSelectedInstOperands,
     /*  207662 */   // GIR_Coverage, 256,
     /*  207662 */   GIR_EraseRootFromParent_Done,
     /*  207663 */ // Label 4177: @207663
     /*  207663 */ GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(207683), // Rule ID 258 //
     /*  207668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207671 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  207675 */   // MIs[0] Operand 1
     /*  207675 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207678 */   // (atomic_fence 6:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE_TSO)
     /*  207678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  207681 */   GIR_RootConstrainSelectedInstOperands,
     /*  207682 */   // GIR_Coverage, 258,
     /*  207682 */   GIR_EraseRootFromParent_Done,
     /*  207683 */ // Label 4178: @207683
     /*  207683 */ GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(207709), // Rule ID 260 //
     /*  207688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207691 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  207695 */   // MIs[0] Operand 1
     /*  207695 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207698 */   // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  207698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207707 */   GIR_RootConstrainSelectedInstOperands,
     /*  207708 */   // GIR_Coverage, 260,
     /*  207708 */   GIR_EraseRootFromParent_Done,
     /*  207709 */ // Label 4179: @207709
     /*  207709 */ GIM_Reject,
     /*  207710 */ // Label 4171: @207710
     /*  207710 */ GIM_Reject,
     /*  207711 */ // Label 37: @207711
     /*  207711 */ GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(209196),
     /*  207716 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  207719 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(207764), // Rule ID 2718 //
     /*  207724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  207735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207749 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  207752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207762 */     GIR_RootConstrainSelectedInstOperands,
     /*  207763 */     // GIR_Coverage, 2718,
     /*  207763 */     GIR_EraseRootFromParent_Done,
     /*  207764 */   // Label 4181: @207764
     /*  207764 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(207809), // Rule ID 2719 //
     /*  207769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  207780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207794 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  207797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207807 */     GIR_RootConstrainSelectedInstOperands,
     /*  207808 */     // GIR_Coverage, 2719,
     /*  207808 */     GIR_EraseRootFromParent_Done,
     /*  207809 */   // Label 4182: @207809
     /*  207809 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(207854), // Rule ID 23268 //
     /*  207814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  207825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207839 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  207842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207852 */     GIR_RootConstrainSelectedInstOperands,
     /*  207853 */     // GIR_Coverage, 23268,
     /*  207853 */     GIR_EraseRootFromParent_Done,
     /*  207854 */   // Label 4183: @207854
     /*  207854 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(207899), // Rule ID 23269 //
     /*  207859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  207870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207884 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  207887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207897 */     GIR_RootConstrainSelectedInstOperands,
     /*  207898 */     // GIR_Coverage, 23269,
     /*  207898 */     GIR_EraseRootFromParent_Done,
     /*  207899 */   // Label 4184: @207899
     /*  207899 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(207944), // Rule ID 23270 //
     /*  207904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  207915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207929 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  207932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207942 */     GIR_RootConstrainSelectedInstOperands,
     /*  207943 */     // GIR_Coverage, 23270,
     /*  207943 */     GIR_EraseRootFromParent_Done,
     /*  207944 */   // Label 4185: @207944
     /*  207944 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(207989), // Rule ID 23271 //
     /*  207949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  207960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207974 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  207977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207987 */     GIR_RootConstrainSelectedInstOperands,
     /*  207988 */     // GIR_Coverage, 23271,
     /*  207988 */     GIR_EraseRootFromParent_Done,
     /*  207989 */   // Label 4186: @207989
     /*  207989 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(208034), // Rule ID 23272 //
     /*  207994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208019 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  208022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208032 */     GIR_RootConstrainSelectedInstOperands,
     /*  208033 */     // GIR_Coverage, 23272,
     /*  208033 */     GIR_EraseRootFromParent_Done,
     /*  208034 */   // Label 4187: @208034
     /*  208034 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(208079), // Rule ID 23273 //
     /*  208039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208064 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  208067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208077 */     GIR_RootConstrainSelectedInstOperands,
     /*  208078 */     // GIR_Coverage, 23273,
     /*  208078 */     GIR_EraseRootFromParent_Done,
     /*  208079 */   // Label 4188: @208079
     /*  208079 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(208124), // Rule ID 23274 //
     /*  208084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208109 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  208112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208122 */     GIR_RootConstrainSelectedInstOperands,
     /*  208123 */     // GIR_Coverage, 23274,
     /*  208123 */     GIR_EraseRootFromParent_Done,
     /*  208124 */   // Label 4189: @208124
     /*  208124 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(208169), // Rule ID 23275 //
     /*  208129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208154 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  208157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208167 */     GIR_RootConstrainSelectedInstOperands,
     /*  208168 */     // GIR_Coverage, 23275,
     /*  208168 */     GIR_EraseRootFromParent_Done,
     /*  208169 */   // Label 4190: @208169
     /*  208169 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(208214), // Rule ID 23276 //
     /*  208174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208199 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  208202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208212 */     GIR_RootConstrainSelectedInstOperands,
     /*  208213 */     // GIR_Coverage, 23276,
     /*  208213 */     GIR_EraseRootFromParent_Done,
     /*  208214 */   // Label 4191: @208214
     /*  208214 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(208259), // Rule ID 23277 //
     /*  208219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208244 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  208247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208257 */     GIR_RootConstrainSelectedInstOperands,
     /*  208258 */     // GIR_Coverage, 23277,
     /*  208258 */     GIR_EraseRootFromParent_Done,
     /*  208259 */   // Label 4192: @208259
     /*  208259 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(208304), // Rule ID 23278 //
     /*  208264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208289 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  208292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208302 */     GIR_RootConstrainSelectedInstOperands,
     /*  208303 */     // GIR_Coverage, 23278,
     /*  208303 */     GIR_EraseRootFromParent_Done,
     /*  208304 */   // Label 4193: @208304
     /*  208304 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(208349), // Rule ID 23279 //
     /*  208309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208334 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11432:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  208337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208347 */     GIR_RootConstrainSelectedInstOperands,
     /*  208348 */     // GIR_Coverage, 23279,
     /*  208348 */     GIR_EraseRootFromParent_Done,
     /*  208349 */   // Label 4194: @208349
     /*  208349 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(208394), // Rule ID 23280 //
     /*  208354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208379 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  208382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208392 */     GIR_RootConstrainSelectedInstOperands,
     /*  208393 */     // GIR_Coverage, 23280,
     /*  208393 */     GIR_EraseRootFromParent_Done,
     /*  208394 */   // Label 4195: @208394
     /*  208394 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(208439), // Rule ID 23281 //
     /*  208399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208424 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  208427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208437 */     GIR_RootConstrainSelectedInstOperands,
     /*  208438 */     // GIR_Coverage, 23281,
     /*  208438 */     GIR_EraseRootFromParent_Done,
     /*  208439 */   // Label 4196: @208439
     /*  208439 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(208484), // Rule ID 23282 //
     /*  208444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208469 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  208472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208482 */     GIR_RootConstrainSelectedInstOperands,
     /*  208483 */     // GIR_Coverage, 23282,
     /*  208483 */     GIR_EraseRootFromParent_Done,
     /*  208484 */   // Label 4197: @208484
     /*  208484 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(208529), // Rule ID 23283 //
     /*  208489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208514 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  208517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208527 */     GIR_RootConstrainSelectedInstOperands,
     /*  208528 */     // GIR_Coverage, 23283,
     /*  208528 */     GIR_EraseRootFromParent_Done,
     /*  208529 */   // Label 4198: @208529
     /*  208529 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(208574), // Rule ID 23284 //
     /*  208534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208559 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  208562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208572 */     GIR_RootConstrainSelectedInstOperands,
     /*  208573 */     // GIR_Coverage, 23284,
     /*  208573 */     GIR_EraseRootFromParent_Done,
     /*  208574 */   // Label 4199: @208574
     /*  208574 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(208619), // Rule ID 23285 //
     /*  208579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208604 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  208607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208617 */     GIR_RootConstrainSelectedInstOperands,
     /*  208618 */     // GIR_Coverage, 23285,
     /*  208618 */     GIR_EraseRootFromParent_Done,
     /*  208619 */   // Label 4200: @208619
     /*  208619 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(208664), // Rule ID 23286 //
     /*  208624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208649 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  208652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208662 */     GIR_RootConstrainSelectedInstOperands,
     /*  208663 */     // GIR_Coverage, 23286,
     /*  208663 */     GIR_EraseRootFromParent_Done,
     /*  208664 */   // Label 4201: @208664
     /*  208664 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(208709), // Rule ID 23287 //
     /*  208669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208694 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  208697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208707 */     GIR_RootConstrainSelectedInstOperands,
     /*  208708 */     // GIR_Coverage, 23287,
     /*  208708 */     GIR_EraseRootFromParent_Done,
     /*  208709 */   // Label 4202: @208709
     /*  208709 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(208754), // Rule ID 23288 //
     /*  208714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208739 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  208742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208752 */     GIR_RootConstrainSelectedInstOperands,
     /*  208753 */     // GIR_Coverage, 23288,
     /*  208753 */     GIR_EraseRootFromParent_Done,
     /*  208754 */   // Label 4203: @208754
     /*  208754 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(208799), // Rule ID 23289 //
     /*  208759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208784 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  208787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208797 */     GIR_RootConstrainSelectedInstOperands,
     /*  208798 */     // GIR_Coverage, 23289,
     /*  208798 */     GIR_EraseRootFromParent_Done,
     /*  208799 */   // Label 4204: @208799
     /*  208799 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(208844), // Rule ID 23290 //
     /*  208804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208829 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  208832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208842 */     GIR_RootConstrainSelectedInstOperands,
     /*  208843 */     // GIR_Coverage, 23290,
     /*  208843 */     GIR_EraseRootFromParent_Done,
     /*  208844 */   // Label 4205: @208844
     /*  208844 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(208889), // Rule ID 23291 //
     /*  208849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208874 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  208877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208887 */     GIR_RootConstrainSelectedInstOperands,
     /*  208888 */     // GIR_Coverage, 23291,
     /*  208888 */     GIR_EraseRootFromParent_Done,
     /*  208889 */   // Label 4206: @208889
     /*  208889 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(208934), // Rule ID 23292 //
     /*  208894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208919 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  208922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208932 */     GIR_RootConstrainSelectedInstOperands,
     /*  208933 */     // GIR_Coverage, 23292,
     /*  208933 */     GIR_EraseRootFromParent_Done,
     /*  208934 */   // Label 4207: @208934
     /*  208934 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(208979), // Rule ID 23293 //
     /*  208939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208964 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11460:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  208967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208977 */     GIR_RootConstrainSelectedInstOperands,
     /*  208978 */     // GIR_Coverage, 23293,
     /*  208978 */     GIR_EraseRootFromParent_Done,
     /*  208979 */   // Label 4208: @208979
     /*  208979 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(209015), // Rule ID 2655 //
     /*  208984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  208987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64im),
     /*  208992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  208995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209006 */     // (intrinsic_wo_chain:{ *:[i64] } 10974:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (AES64IM:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64IM),
     /*  209009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209013 */     GIR_RootConstrainSelectedInstOperands,
     /*  209014 */     // GIR_Coverage, 2655,
     /*  209014 */     GIR_EraseRootFromParent_Done,
     /*  209015 */   // Label 4209: @209015
     /*  209015 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(209051), // Rule ID 2676 //
     /*  209020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0),
     /*  209028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209042 */     // (intrinsic_wo_chain:{ *:[i64] } 11127:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0),
     /*  209045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209049 */     GIR_RootConstrainSelectedInstOperands,
     /*  209050 */     // GIR_Coverage, 2676,
     /*  209050 */     GIR_EraseRootFromParent_Done,
     /*  209051 */   // Label 4210: @209051
     /*  209051 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(209087), // Rule ID 2677 //
     /*  209056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1),
     /*  209064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209078 */     // (intrinsic_wo_chain:{ *:[i64] } 11130:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1),
     /*  209081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209085 */     GIR_RootConstrainSelectedInstOperands,
     /*  209086 */     // GIR_Coverage, 2677,
     /*  209086 */     GIR_EraseRootFromParent_Done,
     /*  209087 */   // Label 4211: @209087
     /*  209087 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(209123), // Rule ID 2678 //
     /*  209092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0),
     /*  209100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209114 */     // (intrinsic_wo_chain:{ *:[i64] } 11133:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0),
     /*  209117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209121 */     GIR_RootConstrainSelectedInstOperands,
     /*  209122 */     // GIR_Coverage, 2678,
     /*  209122 */     GIR_EraseRootFromParent_Done,
     /*  209123 */   // Label 4212: @209123
     /*  209123 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(209159), // Rule ID 2679 //
     /*  209128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1),
     /*  209136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209150 */     // (intrinsic_wo_chain:{ *:[i64] } 11135:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1),
     /*  209153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209157 */     GIR_RootConstrainSelectedInstOperands,
     /*  209158 */     // GIR_Coverage, 2679,
     /*  209158 */     GIR_EraseRootFromParent_Done,
     /*  209159 */   // Label 4213: @209159
     /*  209159 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(209195), // Rule ID 64446 //
     /*  209164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  209167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_clb),
     /*  209172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209186 */     // (intrinsic_wo_chain:{ *:[i32] } 10994:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1)  =>  (CV_CLB:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  209186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLB),
     /*  209189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209193 */     GIR_RootConstrainSelectedInstOperands,
     /*  209194 */     // GIR_Coverage, 64446,
     /*  209194 */     GIR_EraseRootFromParent_Done,
     /*  209195 */   // Label 4214: @209195
     /*  209195 */   GIM_Reject,
     /*  209196 */ // Label 4180: @209196
     /*  209196 */ GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(216484),
     /*  209201 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  209204 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(209258), // Rule ID 2688 //
     /*  209209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209241 */     // (intrinsic_wo_chain:{ *:[i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  209244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209256 */     GIR_RootConstrainSelectedInstOperands,
     /*  209257 */     // GIR_Coverage, 2688,
     /*  209257 */     GIR_EraseRootFromParent_Done,
     /*  209258 */   // Label 4216: @209258
     /*  209258 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(209312), // Rule ID 2689 //
     /*  209263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209295 */     // (intrinsic_wo_chain:{ *:[i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  209298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209310 */     GIR_RootConstrainSelectedInstOperands,
     /*  209311 */     // GIR_Coverage, 2689,
     /*  209311 */     GIR_EraseRootFromParent_Done,
     /*  209312 */   // Label 4217: @209312
     /*  209312 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(209366), // Rule ID 2694 //
     /*  209317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  209325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  209328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209349 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  209352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209364 */     GIR_RootConstrainSelectedInstOperands,
     /*  209365 */     // GIR_Coverage, 2694,
     /*  209365 */     GIR_EraseRootFromParent_Done,
     /*  209366 */   // Label 4218: @209366
     /*  209366 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(209420), // Rule ID 2695 //
     /*  209371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  209379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  209382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209403 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  209406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209418 */     GIR_RootConstrainSelectedInstOperands,
     /*  209419 */     // GIR_Coverage, 2695,
     /*  209419 */     GIR_EraseRootFromParent_Done,
     /*  209420 */   // Label 4219: @209420
     /*  209420 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(209477), // Rule ID 2714 //
     /*  209425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  209428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  209433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  209436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  209439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209457 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  209457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  209460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  209464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209475 */     GIR_RootConstrainSelectedInstOperands,
     /*  209476 */     // GIR_Coverage, 2714,
     /*  209476 */     GIR_EraseRootFromParent_Done,
     /*  209477 */   // Label 4220: @209477
     /*  209477 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(209534), // Rule ID 2715 //
     /*  209482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  209485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  209490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  209493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  209496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209514 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  209514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  209517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  209521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209532 */     GIR_RootConstrainSelectedInstOperands,
     /*  209533 */     // GIR_Coverage, 2715,
     /*  209533 */     GIR_EraseRootFromParent_Done,
     /*  209534 */   // Label 4221: @209534
     /*  209534 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(209588), // Rule ID 23294 //
     /*  209539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  209553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209571 */     // (intrinsic_wo_chain:{ *:[i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  209574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209586 */     GIR_RootConstrainSelectedInstOperands,
     /*  209587 */     // GIR_Coverage, 23294,
     /*  209587 */     GIR_EraseRootFromParent_Done,
     /*  209588 */   // Label 4222: @209588
     /*  209588 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(209642), // Rule ID 23295 //
     /*  209593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  209607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209625 */     // (intrinsic_wo_chain:{ *:[i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  209628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209640 */     GIR_RootConstrainSelectedInstOperands,
     /*  209641 */     // GIR_Coverage, 23295,
     /*  209641 */     GIR_EraseRootFromParent_Done,
     /*  209642 */   // Label 4223: @209642
     /*  209642 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(209696), // Rule ID 23298 //
     /*  209647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  209661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209679 */     // (intrinsic_wo_chain:{ *:[i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  209682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209694 */     GIR_RootConstrainSelectedInstOperands,
     /*  209695 */     // GIR_Coverage, 23298,
     /*  209695 */     GIR_EraseRootFromParent_Done,
     /*  209696 */   // Label 4224: @209696
     /*  209696 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(209750), // Rule ID 23299 //
     /*  209701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  209715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209733 */     // (intrinsic_wo_chain:{ *:[i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  209736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209748 */     GIR_RootConstrainSelectedInstOperands,
     /*  209749 */     // GIR_Coverage, 23299,
     /*  209749 */     GIR_EraseRootFromParent_Done,
     /*  209750 */   // Label 4225: @209750
     /*  209750 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(209804), // Rule ID 23302 //
     /*  209755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  209769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209787 */     // (intrinsic_wo_chain:{ *:[i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  209790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209802 */     GIR_RootConstrainSelectedInstOperands,
     /*  209803 */     // GIR_Coverage, 23302,
     /*  209803 */     GIR_EraseRootFromParent_Done,
     /*  209804 */   // Label 4226: @209804
     /*  209804 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(209858), // Rule ID 23303 //
     /*  209809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  209823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209841 */     // (intrinsic_wo_chain:{ *:[i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  209844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209856 */     GIR_RootConstrainSelectedInstOperands,
     /*  209857 */     // GIR_Coverage, 23303,
     /*  209857 */     GIR_EraseRootFromParent_Done,
     /*  209858 */   // Label 4227: @209858
     /*  209858 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(209912), // Rule ID 23306 //
     /*  209863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  209877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209895 */     // (intrinsic_wo_chain:{ *:[i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  209898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209910 */     GIR_RootConstrainSelectedInstOperands,
     /*  209911 */     // GIR_Coverage, 23306,
     /*  209911 */     GIR_EraseRootFromParent_Done,
     /*  209912 */   // Label 4228: @209912
     /*  209912 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(209966), // Rule ID 23307 //
     /*  209917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  209931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209949 */     // (intrinsic_wo_chain:{ *:[i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  209952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209964 */     GIR_RootConstrainSelectedInstOperands,
     /*  209965 */     // GIR_Coverage, 23307,
     /*  209965 */     GIR_EraseRootFromParent_Done,
     /*  209966 */   // Label 4229: @209966
     /*  209966 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(210020), // Rule ID 23310 //
     /*  209971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  209985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210003 */     // (intrinsic_wo_chain:{ *:[i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  210006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210018 */     GIR_RootConstrainSelectedInstOperands,
     /*  210019 */     // GIR_Coverage, 23310,
     /*  210019 */     GIR_EraseRootFromParent_Done,
     /*  210020 */   // Label 4230: @210020
     /*  210020 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(210074), // Rule ID 23311 //
     /*  210025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210057 */     // (intrinsic_wo_chain:{ *:[i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  210060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210072 */     GIR_RootConstrainSelectedInstOperands,
     /*  210073 */     // GIR_Coverage, 23311,
     /*  210073 */     GIR_EraseRootFromParent_Done,
     /*  210074 */   // Label 4231: @210074
     /*  210074 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(210128), // Rule ID 23314 //
     /*  210079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210111 */     // (intrinsic_wo_chain:{ *:[i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  210114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210126 */     GIR_RootConstrainSelectedInstOperands,
     /*  210127 */     // GIR_Coverage, 23314,
     /*  210127 */     GIR_EraseRootFromParent_Done,
     /*  210128 */   // Label 4232: @210128
     /*  210128 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(210182), // Rule ID 23315 //
     /*  210133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210165 */     // (intrinsic_wo_chain:{ *:[i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  210168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210180 */     GIR_RootConstrainSelectedInstOperands,
     /*  210181 */     // GIR_Coverage, 23315,
     /*  210181 */     GIR_EraseRootFromParent_Done,
     /*  210182 */   // Label 4233: @210182
     /*  210182 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(210236), // Rule ID 23318 //
     /*  210187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  210201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210219 */     // (intrinsic_wo_chain:{ *:[i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  210222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210234 */     GIR_RootConstrainSelectedInstOperands,
     /*  210235 */     // GIR_Coverage, 23318,
     /*  210235 */     GIR_EraseRootFromParent_Done,
     /*  210236 */   // Label 4234: @210236
     /*  210236 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(210290), // Rule ID 23319 //
     /*  210241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  210255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210273 */     // (intrinsic_wo_chain:{ *:[i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  210276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210288 */     GIR_RootConstrainSelectedInstOperands,
     /*  210289 */     // GIR_Coverage, 23319,
     /*  210289 */     GIR_EraseRootFromParent_Done,
     /*  210290 */   // Label 4235: @210290
     /*  210290 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(210344), // Rule ID 23322 //
     /*  210295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210327 */     // (intrinsic_wo_chain:{ *:[i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  210330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210342 */     GIR_RootConstrainSelectedInstOperands,
     /*  210343 */     // GIR_Coverage, 23322,
     /*  210343 */     GIR_EraseRootFromParent_Done,
     /*  210344 */   // Label 4236: @210344
     /*  210344 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(210398), // Rule ID 23323 //
     /*  210349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210381 */     // (intrinsic_wo_chain:{ *:[i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  210384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210396 */     GIR_RootConstrainSelectedInstOperands,
     /*  210397 */     // GIR_Coverage, 23323,
     /*  210397 */     GIR_EraseRootFromParent_Done,
     /*  210398 */   // Label 4237: @210398
     /*  210398 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(210452), // Rule ID 23326 //
     /*  210403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210435 */     // (intrinsic_wo_chain:{ *:[i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  210438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210450 */     GIR_RootConstrainSelectedInstOperands,
     /*  210451 */     // GIR_Coverage, 23326,
     /*  210451 */     GIR_EraseRootFromParent_Done,
     /*  210452 */   // Label 4238: @210452
     /*  210452 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(210506), // Rule ID 23327 //
     /*  210457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210489 */     // (intrinsic_wo_chain:{ *:[i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  210492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210504 */     GIR_RootConstrainSelectedInstOperands,
     /*  210505 */     // GIR_Coverage, 23327,
     /*  210505 */     GIR_EraseRootFromParent_Done,
     /*  210506 */   // Label 4239: @210506
     /*  210506 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(210560), // Rule ID 23330 //
     /*  210511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210543 */     // (intrinsic_wo_chain:{ *:[i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  210546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210558 */     GIR_RootConstrainSelectedInstOperands,
     /*  210559 */     // GIR_Coverage, 23330,
     /*  210559 */     GIR_EraseRootFromParent_Done,
     /*  210560 */   // Label 4240: @210560
     /*  210560 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(210614), // Rule ID 23331 //
     /*  210565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210597 */     // (intrinsic_wo_chain:{ *:[i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  210600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210612 */     GIR_RootConstrainSelectedInstOperands,
     /*  210613 */     // GIR_Coverage, 23331,
     /*  210613 */     GIR_EraseRootFromParent_Done,
     /*  210614 */   // Label 4241: @210614
     /*  210614 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(210668), // Rule ID 23334 //
     /*  210619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  210633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210651 */     // (intrinsic_wo_chain:{ *:[i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  210654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210666 */     GIR_RootConstrainSelectedInstOperands,
     /*  210667 */     // GIR_Coverage, 23334,
     /*  210667 */     GIR_EraseRootFromParent_Done,
     /*  210668 */   // Label 4242: @210668
     /*  210668 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(210722), // Rule ID 23335 //
     /*  210673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  210687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210705 */     // (intrinsic_wo_chain:{ *:[i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  210708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210720 */     GIR_RootConstrainSelectedInstOperands,
     /*  210721 */     // GIR_Coverage, 23335,
     /*  210721 */     GIR_EraseRootFromParent_Done,
     /*  210722 */   // Label 4243: @210722
     /*  210722 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(210776), // Rule ID 23338 //
     /*  210727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210759 */     // (intrinsic_wo_chain:{ *:[i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  210762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210774 */     GIR_RootConstrainSelectedInstOperands,
     /*  210775 */     // GIR_Coverage, 23338,
     /*  210775 */     GIR_EraseRootFromParent_Done,
     /*  210776 */   // Label 4244: @210776
     /*  210776 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(210830), // Rule ID 23339 //
     /*  210781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210813 */     // (intrinsic_wo_chain:{ *:[i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  210816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210828 */     GIR_RootConstrainSelectedInstOperands,
     /*  210829 */     // GIR_Coverage, 23339,
     /*  210829 */     GIR_EraseRootFromParent_Done,
     /*  210830 */   // Label 4245: @210830
     /*  210830 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(210884), // Rule ID 23342 //
     /*  210835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210867 */     // (intrinsic_wo_chain:{ *:[i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  210870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210882 */     GIR_RootConstrainSelectedInstOperands,
     /*  210883 */     // GIR_Coverage, 23342,
     /*  210883 */     GIR_EraseRootFromParent_Done,
     /*  210884 */   // Label 4246: @210884
     /*  210884 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(210938), // Rule ID 23343 //
     /*  210889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210921 */     // (intrinsic_wo_chain:{ *:[i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  210924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210936 */     GIR_RootConstrainSelectedInstOperands,
     /*  210937 */     // GIR_Coverage, 23343,
     /*  210937 */     GIR_EraseRootFromParent_Done,
     /*  210938 */   // Label 4247: @210938
     /*  210938 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(210992), // Rule ID 23346 //
     /*  210943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  210954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210975 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  210978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210990 */     GIR_RootConstrainSelectedInstOperands,
     /*  210991 */     // GIR_Coverage, 23346,
     /*  210991 */     GIR_EraseRootFromParent_Done,
     /*  210992 */   // Label 4248: @210992
     /*  210992 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(211046), // Rule ID 23347 //
     /*  210997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  211011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211029 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  211032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211044 */     GIR_RootConstrainSelectedInstOperands,
     /*  211045 */     // GIR_Coverage, 23347,
     /*  211045 */     GIR_EraseRootFromParent_Done,
     /*  211046 */   // Label 4249: @211046
     /*  211046 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(211100), // Rule ID 23350 //
     /*  211051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211083 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  211086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211098 */     GIR_RootConstrainSelectedInstOperands,
     /*  211099 */     // GIR_Coverage, 23350,
     /*  211099 */     GIR_EraseRootFromParent_Done,
     /*  211100 */   // Label 4250: @211100
     /*  211100 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(211154), // Rule ID 23351 //
     /*  211105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211137 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  211140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211152 */     GIR_RootConstrainSelectedInstOperands,
     /*  211153 */     // GIR_Coverage, 23351,
     /*  211153 */     GIR_EraseRootFromParent_Done,
     /*  211154 */   // Label 4251: @211154
     /*  211154 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(211208), // Rule ID 23354 //
     /*  211159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211191 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  211194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211206 */     GIR_RootConstrainSelectedInstOperands,
     /*  211207 */     // GIR_Coverage, 23354,
     /*  211207 */     GIR_EraseRootFromParent_Done,
     /*  211208 */   // Label 4252: @211208
     /*  211208 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(211262), // Rule ID 23355 //
     /*  211213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211245 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  211248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211260 */     GIR_RootConstrainSelectedInstOperands,
     /*  211261 */     // GIR_Coverage, 23355,
     /*  211261 */     GIR_EraseRootFromParent_Done,
     /*  211262 */   // Label 4253: @211262
     /*  211262 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(211316), // Rule ID 23358 //
     /*  211267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211299 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  211302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211314 */     GIR_RootConstrainSelectedInstOperands,
     /*  211315 */     // GIR_Coverage, 23358,
     /*  211315 */     GIR_EraseRootFromParent_Done,
     /*  211316 */   // Label 4254: @211316
     /*  211316 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(211370), // Rule ID 23359 //
     /*  211321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211353 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  211356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211368 */     GIR_RootConstrainSelectedInstOperands,
     /*  211369 */     // GIR_Coverage, 23359,
     /*  211369 */     GIR_EraseRootFromParent_Done,
     /*  211370 */   // Label 4255: @211370
     /*  211370 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(211424), // Rule ID 23362 //
     /*  211375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  211386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211407 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  211410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211422 */     GIR_RootConstrainSelectedInstOperands,
     /*  211423 */     // GIR_Coverage, 23362,
     /*  211423 */     GIR_EraseRootFromParent_Done,
     /*  211424 */   // Label 4256: @211424
     /*  211424 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(211478), // Rule ID 23363 //
     /*  211429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  211440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211461 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  211464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211476 */     GIR_RootConstrainSelectedInstOperands,
     /*  211477 */     // GIR_Coverage, 23363,
     /*  211477 */     GIR_EraseRootFromParent_Done,
     /*  211478 */   // Label 4257: @211478
     /*  211478 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(211532), // Rule ID 23366 //
     /*  211483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  211494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  211497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211515 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  211518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211530 */     GIR_RootConstrainSelectedInstOperands,
     /*  211531 */     // GIR_Coverage, 23366,
     /*  211531 */     GIR_EraseRootFromParent_Done,
     /*  211532 */   // Label 4258: @211532
     /*  211532 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(211586), // Rule ID 23367 //
     /*  211537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  211548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  211551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211569 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  211572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211584 */     GIR_RootConstrainSelectedInstOperands,
     /*  211585 */     // GIR_Coverage, 23367,
     /*  211585 */     GIR_EraseRootFromParent_Done,
     /*  211586 */   // Label 4259: @211586
     /*  211586 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(211640), // Rule ID 23370 //
     /*  211591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  211605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211623 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  211626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211638 */     GIR_RootConstrainSelectedInstOperands,
     /*  211639 */     // GIR_Coverage, 23370,
     /*  211639 */     GIR_EraseRootFromParent_Done,
     /*  211640 */   // Label 4260: @211640
     /*  211640 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(211694), // Rule ID 23371 //
     /*  211645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  211659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211677 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  211680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211692 */     GIR_RootConstrainSelectedInstOperands,
     /*  211693 */     // GIR_Coverage, 23371,
     /*  211693 */     GIR_EraseRootFromParent_Done,
     /*  211694 */   // Label 4261: @211694
     /*  211694 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(211748), // Rule ID 23374 //
     /*  211699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  211713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211731 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  211734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211746 */     GIR_RootConstrainSelectedInstOperands,
     /*  211747 */     // GIR_Coverage, 23374,
     /*  211747 */     GIR_EraseRootFromParent_Done,
     /*  211748 */   // Label 4262: @211748
     /*  211748 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(211802), // Rule ID 23375 //
     /*  211753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  211767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211785 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  211788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211800 */     GIR_RootConstrainSelectedInstOperands,
     /*  211801 */     // GIR_Coverage, 23375,
     /*  211801 */     GIR_EraseRootFromParent_Done,
     /*  211802 */   // Label 4263: @211802
     /*  211802 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(211856), // Rule ID 23378 //
     /*  211807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211839 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  211842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211854 */     GIR_RootConstrainSelectedInstOperands,
     /*  211855 */     // GIR_Coverage, 23378,
     /*  211855 */     GIR_EraseRootFromParent_Done,
     /*  211856 */   // Label 4264: @211856
     /*  211856 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(211910), // Rule ID 23379 //
     /*  211861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211893 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  211896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211908 */     GIR_RootConstrainSelectedInstOperands,
     /*  211909 */     // GIR_Coverage, 23379,
     /*  211909 */     GIR_EraseRootFromParent_Done,
     /*  211910 */   // Label 4265: @211910
     /*  211910 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(211964), // Rule ID 23382 //
     /*  211915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211947 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  211950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211962 */     GIR_RootConstrainSelectedInstOperands,
     /*  211963 */     // GIR_Coverage, 23382,
     /*  211963 */     GIR_EraseRootFromParent_Done,
     /*  211964 */   // Label 4266: @211964
     /*  211964 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(212018), // Rule ID 23383 //
     /*  211969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212001 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  212004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212016 */     GIR_RootConstrainSelectedInstOperands,
     /*  212017 */     // GIR_Coverage, 23383,
     /*  212017 */     GIR_EraseRootFromParent_Done,
     /*  212018 */   // Label 4267: @212018
     /*  212018 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(212072), // Rule ID 23386 //
     /*  212023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212055 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  212058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212070 */     GIR_RootConstrainSelectedInstOperands,
     /*  212071 */     // GIR_Coverage, 23386,
     /*  212071 */     GIR_EraseRootFromParent_Done,
     /*  212072 */   // Label 4268: @212072
     /*  212072 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(212126), // Rule ID 23387 //
     /*  212077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212109 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  212112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212124 */     GIR_RootConstrainSelectedInstOperands,
     /*  212125 */     // GIR_Coverage, 23387,
     /*  212125 */     GIR_EraseRootFromParent_Done,
     /*  212126 */   // Label 4269: @212126
     /*  212126 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(212180), // Rule ID 23390 //
     /*  212131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212163 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  212166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212178 */     GIR_RootConstrainSelectedInstOperands,
     /*  212179 */     // GIR_Coverage, 23390,
     /*  212179 */     GIR_EraseRootFromParent_Done,
     /*  212180 */   // Label 4270: @212180
     /*  212180 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(212234), // Rule ID 23391 //
     /*  212185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212217 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  212220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212232 */     GIR_RootConstrainSelectedInstOperands,
     /*  212233 */     // GIR_Coverage, 23391,
     /*  212233 */     GIR_EraseRootFromParent_Done,
     /*  212234 */   // Label 4271: @212234
     /*  212234 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(212288), // Rule ID 23394 //
     /*  212239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  212253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212271 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  212274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212286 */     GIR_RootConstrainSelectedInstOperands,
     /*  212287 */     // GIR_Coverage, 23394,
     /*  212287 */     GIR_EraseRootFromParent_Done,
     /*  212288 */   // Label 4272: @212288
     /*  212288 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(212342), // Rule ID 23395 //
     /*  212293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  212307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212325 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  212328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212340 */     GIR_RootConstrainSelectedInstOperands,
     /*  212341 */     // GIR_Coverage, 23395,
     /*  212341 */     GIR_EraseRootFromParent_Done,
     /*  212342 */   // Label 4273: @212342
     /*  212342 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(212396), // Rule ID 23398 //
     /*  212347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  212361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212379 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  212382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212394 */     GIR_RootConstrainSelectedInstOperands,
     /*  212395 */     // GIR_Coverage, 23398,
     /*  212395 */     GIR_EraseRootFromParent_Done,
     /*  212396 */   // Label 4274: @212396
     /*  212396 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(212450), // Rule ID 23399 //
     /*  212401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  212415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212433 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  212436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212448 */     GIR_RootConstrainSelectedInstOperands,
     /*  212449 */     // GIR_Coverage, 23399,
     /*  212449 */     GIR_EraseRootFromParent_Done,
     /*  212450 */   // Label 4275: @212450
     /*  212450 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(212504), // Rule ID 23402 //
     /*  212455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  212469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212487 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  212490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212502 */     GIR_RootConstrainSelectedInstOperands,
     /*  212503 */     // GIR_Coverage, 23402,
     /*  212503 */     GIR_EraseRootFromParent_Done,
     /*  212504 */   // Label 4276: @212504
     /*  212504 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(212558), // Rule ID 23403 //
     /*  212509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  212523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212541 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  212544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212556 */     GIR_RootConstrainSelectedInstOperands,
     /*  212557 */     // GIR_Coverage, 23403,
     /*  212557 */     GIR_EraseRootFromParent_Done,
     /*  212558 */   // Label 4277: @212558
     /*  212558 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(212612), // Rule ID 23406 //
     /*  212563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  212577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212595 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  212598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212610 */     GIR_RootConstrainSelectedInstOperands,
     /*  212611 */     // GIR_Coverage, 23406,
     /*  212611 */     GIR_EraseRootFromParent_Done,
     /*  212612 */   // Label 4278: @212612
     /*  212612 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(212666), // Rule ID 23407 //
     /*  212617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  212631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212649 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  212652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212664 */     GIR_RootConstrainSelectedInstOperands,
     /*  212665 */     // GIR_Coverage, 23407,
     /*  212665 */     GIR_EraseRootFromParent_Done,
     /*  212666 */   // Label 4279: @212666
     /*  212666 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(212720), // Rule ID 23410 //
     /*  212671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  212685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212703 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  212706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212718 */     GIR_RootConstrainSelectedInstOperands,
     /*  212719 */     // GIR_Coverage, 23410,
     /*  212719 */     GIR_EraseRootFromParent_Done,
     /*  212720 */   // Label 4280: @212720
     /*  212720 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(212774), // Rule ID 23411 //
     /*  212725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  212739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212757 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  212760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212772 */     GIR_RootConstrainSelectedInstOperands,
     /*  212773 */     // GIR_Coverage, 23411,
     /*  212773 */     GIR_EraseRootFromParent_Done,
     /*  212774 */   // Label 4281: @212774
     /*  212774 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(212828), // Rule ID 23414 //
     /*  212779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212811 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  212814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212826 */     GIR_RootConstrainSelectedInstOperands,
     /*  212827 */     // GIR_Coverage, 23414,
     /*  212827 */     GIR_EraseRootFromParent_Done,
     /*  212828 */   // Label 4282: @212828
     /*  212828 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(212882), // Rule ID 23415 //
     /*  212833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212865 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  212868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212880 */     GIR_RootConstrainSelectedInstOperands,
     /*  212881 */     // GIR_Coverage, 23415,
     /*  212881 */     GIR_EraseRootFromParent_Done,
     /*  212882 */   // Label 4283: @212882
     /*  212882 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(212936), // Rule ID 23418 //
     /*  212887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212919 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  212922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212934 */     GIR_RootConstrainSelectedInstOperands,
     /*  212935 */     // GIR_Coverage, 23418,
     /*  212935 */     GIR_EraseRootFromParent_Done,
     /*  212936 */   // Label 4284: @212936
     /*  212936 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(212990), // Rule ID 23419 //
     /*  212941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212973 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  212976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212988 */     GIR_RootConstrainSelectedInstOperands,
     /*  212989 */     // GIR_Coverage, 23419,
     /*  212989 */     GIR_EraseRootFromParent_Done,
     /*  212990 */   // Label 4285: @212990
     /*  212990 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(213044), // Rule ID 23422 //
     /*  212995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  213006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  213009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213027 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  213030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213042 */     GIR_RootConstrainSelectedInstOperands,
     /*  213043 */     // GIR_Coverage, 23422,
     /*  213043 */     GIR_EraseRootFromParent_Done,
     /*  213044 */   // Label 4286: @213044
     /*  213044 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(213098), // Rule ID 23423 //
     /*  213049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  213060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  213063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213081 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  213084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213096 */     GIR_RootConstrainSelectedInstOperands,
     /*  213097 */     // GIR_Coverage, 23423,
     /*  213097 */     GIR_EraseRootFromParent_Done,
     /*  213098 */   // Label 4287: @213098
     /*  213098 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(213155), // Rule ID 23510 //
     /*  213103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  213114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  213117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213135 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213153 */     GIR_RootConstrainSelectedInstOperands,
     /*  213154 */     // GIR_Coverage, 23510,
     /*  213154 */     GIR_EraseRootFromParent_Done,
     /*  213155 */   // Label 4288: @213155
     /*  213155 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(213212), // Rule ID 23511 //
     /*  213160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  213171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  213174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213192 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213210 */     GIR_RootConstrainSelectedInstOperands,
     /*  213211 */     // GIR_Coverage, 23511,
     /*  213211 */     GIR_EraseRootFromParent_Done,
     /*  213212 */   // Label 4289: @213212
     /*  213212 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(213269), // Rule ID 23514 //
     /*  213217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  213228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  213231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213249 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11335:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213267 */     GIR_RootConstrainSelectedInstOperands,
     /*  213268 */     // GIR_Coverage, 23514,
     /*  213268 */     GIR_EraseRootFromParent_Done,
     /*  213269 */   // Label 4290: @213269
     /*  213269 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(213326), // Rule ID 23515 //
     /*  213274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  213285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  213288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213306 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11335:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213324 */     GIR_RootConstrainSelectedInstOperands,
     /*  213325 */     // GIR_Coverage, 23515,
     /*  213325 */     GIR_EraseRootFromParent_Done,
     /*  213326 */   // Label 4291: @213326
     /*  213326 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(213383), // Rule ID 23518 //
     /*  213331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  213342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  213345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213363 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  213363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213381 */     GIR_RootConstrainSelectedInstOperands,
     /*  213382 */     // GIR_Coverage, 23518,
     /*  213382 */     GIR_EraseRootFromParent_Done,
     /*  213383 */   // Label 4292: @213383
     /*  213383 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(213440), // Rule ID 23519 //
     /*  213388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  213399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  213402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213420 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  213420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213438 */     GIR_RootConstrainSelectedInstOperands,
     /*  213439 */     // GIR_Coverage, 23519,
     /*  213439 */     GIR_EraseRootFromParent_Done,
     /*  213440 */   // Label 4293: @213440
     /*  213440 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(213497), // Rule ID 23522 //
     /*  213445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  213456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  213459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213477 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  213477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213495 */     GIR_RootConstrainSelectedInstOperands,
     /*  213496 */     // GIR_Coverage, 23522,
     /*  213496 */     GIR_EraseRootFromParent_Done,
     /*  213497 */   // Label 4294: @213497
     /*  213497 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(213554), // Rule ID 23523 //
     /*  213502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  213513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  213516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213534 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  213534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213552 */     GIR_RootConstrainSelectedInstOperands,
     /*  213553 */     // GIR_Coverage, 23523,
     /*  213553 */     GIR_EraseRootFromParent_Done,
     /*  213554 */   // Label 4295: @213554
     /*  213554 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(213611), // Rule ID 23526 //
     /*  213559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  213570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  213573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213591 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  213591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213609 */     GIR_RootConstrainSelectedInstOperands,
     /*  213610 */     // GIR_Coverage, 23526,
     /*  213610 */     GIR_EraseRootFromParent_Done,
     /*  213611 */   // Label 4296: @213611
     /*  213611 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(213668), // Rule ID 23527 //
     /*  213616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  213627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  213630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213648 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  213648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213666 */     GIR_RootConstrainSelectedInstOperands,
     /*  213667 */     // GIR_Coverage, 23527,
     /*  213667 */     GIR_EraseRootFromParent_Done,
     /*  213668 */   // Label 4297: @213668
     /*  213668 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(213725), // Rule ID 23530 //
     /*  213673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  213684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  213687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213705 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11335:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213723 */     GIR_RootConstrainSelectedInstOperands,
     /*  213724 */     // GIR_Coverage, 23530,
     /*  213724 */     GIR_EraseRootFromParent_Done,
     /*  213725 */   // Label 4298: @213725
     /*  213725 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(213782), // Rule ID 23531 //
     /*  213730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  213741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  213744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213762 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11335:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213780 */     GIR_RootConstrainSelectedInstOperands,
     /*  213781 */     // GIR_Coverage, 23531,
     /*  213781 */     GIR_EraseRootFromParent_Done,
     /*  213782 */   // Label 4299: @213782
     /*  213782 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(213839), // Rule ID 23534 //
     /*  213787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  213798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  213801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213819 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  213819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213837 */     GIR_RootConstrainSelectedInstOperands,
     /*  213838 */     // GIR_Coverage, 23534,
     /*  213838 */     GIR_EraseRootFromParent_Done,
     /*  213839 */   // Label 4300: @213839
     /*  213839 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(213896), // Rule ID 23535 //
     /*  213844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  213855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  213858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  213876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213894 */     GIR_RootConstrainSelectedInstOperands,
     /*  213895 */     // GIR_Coverage, 23535,
     /*  213895 */     GIR_EraseRootFromParent_Done,
     /*  213896 */   // Label 4301: @213896
     /*  213896 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(213953), // Rule ID 23538 //
     /*  213901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  213912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  213915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213933 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  213933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213951 */     GIR_RootConstrainSelectedInstOperands,
     /*  213952 */     // GIR_Coverage, 23538,
     /*  213952 */     GIR_EraseRootFromParent_Done,
     /*  213953 */   // Label 4302: @213953
     /*  213953 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(214010), // Rule ID 23539 //
     /*  213958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  213969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  213972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  213990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214008 */     GIR_RootConstrainSelectedInstOperands,
     /*  214009 */     // GIR_Coverage, 23539,
     /*  214009 */     GIR_EraseRootFromParent_Done,
     /*  214010 */   // Label 4303: @214010
     /*  214010 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(214067), // Rule ID 23542 //
     /*  214015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  214018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  214026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  214029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214047 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  214047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214065 */     GIR_RootConstrainSelectedInstOperands,
     /*  214066 */     // GIR_Coverage, 23542,
     /*  214066 */     GIR_EraseRootFromParent_Done,
     /*  214067 */   // Label 4304: @214067
     /*  214067 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(214124), // Rule ID 23543 //
     /*  214072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  214075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  214083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  214086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214104 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  214104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214122 */     GIR_RootConstrainSelectedInstOperands,
     /*  214123 */     // GIR_Coverage, 23543,
     /*  214123 */     GIR_EraseRootFromParent_Done,
     /*  214124 */   // Label 4305: @214124
     /*  214124 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(214181), // Rule ID 23546 //
     /*  214129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  214140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  214143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214161 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214179 */     GIR_RootConstrainSelectedInstOperands,
     /*  214180 */     // GIR_Coverage, 23546,
     /*  214180 */     GIR_EraseRootFromParent_Done,
     /*  214181 */   // Label 4306: @214181
     /*  214181 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(214238), // Rule ID 23547 //
     /*  214186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  214197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  214200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214218 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214236 */     GIR_RootConstrainSelectedInstOperands,
     /*  214237 */     // GIR_Coverage, 23547,
     /*  214237 */     GIR_EraseRootFromParent_Done,
     /*  214238 */   // Label 4307: @214238
     /*  214238 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(214295), // Rule ID 23550 //
     /*  214243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  214254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  214257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214275 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214293 */     GIR_RootConstrainSelectedInstOperands,
     /*  214294 */     // GIR_Coverage, 23550,
     /*  214294 */     GIR_EraseRootFromParent_Done,
     /*  214295 */   // Label 4308: @214295
     /*  214295 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(214352), // Rule ID 23551 //
     /*  214300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  214311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  214314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214332 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214350 */     GIR_RootConstrainSelectedInstOperands,
     /*  214351 */     // GIR_Coverage, 23551,
     /*  214351 */     GIR_EraseRootFromParent_Done,
     /*  214352 */   // Label 4309: @214352
     /*  214352 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(214409), // Rule ID 23554 //
     /*  214357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  214368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  214371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214389 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214407 */     GIR_RootConstrainSelectedInstOperands,
     /*  214408 */     // GIR_Coverage, 23554,
     /*  214408 */     GIR_EraseRootFromParent_Done,
     /*  214409 */   // Label 4310: @214409
     /*  214409 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(214466), // Rule ID 23555 //
     /*  214414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  214425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  214428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214446 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214464 */     GIR_RootConstrainSelectedInstOperands,
     /*  214465 */     // GIR_Coverage, 23555,
     /*  214465 */     GIR_EraseRootFromParent_Done,
     /*  214466 */   // Label 4311: @214466
     /*  214466 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(214523), // Rule ID 23558 //
     /*  214471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  214482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  214485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214503 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214521 */     GIR_RootConstrainSelectedInstOperands,
     /*  214522 */     // GIR_Coverage, 23558,
     /*  214522 */     GIR_EraseRootFromParent_Done,
     /*  214523 */   // Label 4312: @214523
     /*  214523 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(214580), // Rule ID 23559 //
     /*  214528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  214539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  214542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214560 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214578 */     GIR_RootConstrainSelectedInstOperands,
     /*  214579 */     // GIR_Coverage, 23559,
     /*  214579 */     GIR_EraseRootFromParent_Done,
     /*  214580 */   // Label 4313: @214580
     /*  214580 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(214637), // Rule ID 23562 //
     /*  214585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  214596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  214599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214617 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214635 */     GIR_RootConstrainSelectedInstOperands,
     /*  214636 */     // GIR_Coverage, 23562,
     /*  214636 */     GIR_EraseRootFromParent_Done,
     /*  214637 */   // Label 4314: @214637
     /*  214637 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(214694), // Rule ID 23563 //
     /*  214642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  214653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  214656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214674 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214692 */     GIR_RootConstrainSelectedInstOperands,
     /*  214693 */     // GIR_Coverage, 23563,
     /*  214693 */     GIR_EraseRootFromParent_Done,
     /*  214694 */   // Label 4315: @214694
     /*  214694 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(214751), // Rule ID 23566 //
     /*  214699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  214710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  214713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214731 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214749 */     GIR_RootConstrainSelectedInstOperands,
     /*  214750 */     // GIR_Coverage, 23566,
     /*  214750 */     GIR_EraseRootFromParent_Done,
     /*  214751 */   // Label 4316: @214751
     /*  214751 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(214808), // Rule ID 23567 //
     /*  214756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  214767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  214770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214788 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214806 */     GIR_RootConstrainSelectedInstOperands,
     /*  214807 */     // GIR_Coverage, 23567,
     /*  214807 */     GIR_EraseRootFromParent_Done,
     /*  214808 */   // Label 4317: @214808
     /*  214808 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(214865), // Rule ID 23570 //
     /*  214813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  214824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  214827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214845 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  214845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214863 */     GIR_RootConstrainSelectedInstOperands,
     /*  214864 */     // GIR_Coverage, 23570,
     /*  214864 */     GIR_EraseRootFromParent_Done,
     /*  214865 */   // Label 4318: @214865
     /*  214865 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(214922), // Rule ID 23571 //
     /*  214870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  214881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  214884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  214902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214920 */     GIR_RootConstrainSelectedInstOperands,
     /*  214921 */     // GIR_Coverage, 23571,
     /*  214921 */     GIR_EraseRootFromParent_Done,
     /*  214922 */   // Label 4319: @214922
     /*  214922 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(214979), // Rule ID 23574 //
     /*  214927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  214938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  214941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214959 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  214959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214977 */     GIR_RootConstrainSelectedInstOperands,
     /*  214978 */     // GIR_Coverage, 23574,
     /*  214978 */     GIR_EraseRootFromParent_Done,
     /*  214979 */   // Label 4320: @214979
     /*  214979 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(215036), // Rule ID 23575 //
     /*  214984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  214995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  214998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215016 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  215016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215034 */     GIR_RootConstrainSelectedInstOperands,
     /*  215035 */     // GIR_Coverage, 23575,
     /*  215035 */     GIR_EraseRootFromParent_Done,
     /*  215036 */   // Label 4321: @215036
     /*  215036 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(215093), // Rule ID 23578 //
     /*  215041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  215052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  215055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215073 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  215073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215091 */     GIR_RootConstrainSelectedInstOperands,
     /*  215092 */     // GIR_Coverage, 23578,
     /*  215092 */     GIR_EraseRootFromParent_Done,
     /*  215093 */   // Label 4322: @215093
     /*  215093 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(215150), // Rule ID 23579 //
     /*  215098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  215109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  215112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215130 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  215130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215148 */     GIR_RootConstrainSelectedInstOperands,
     /*  215149 */     // GIR_Coverage, 23579,
     /*  215149 */     GIR_EraseRootFromParent_Done,
     /*  215150 */   // Label 4323: @215150
     /*  215150 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(215207), // Rule ID 23582 //
     /*  215155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  215158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  215166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  215169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215187 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  215187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215205 */     GIR_RootConstrainSelectedInstOperands,
     /*  215206 */     // GIR_Coverage, 23582,
     /*  215206 */     GIR_EraseRootFromParent_Done,
     /*  215207 */   // Label 4324: @215207
     /*  215207 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(215264), // Rule ID 23583 //
     /*  215212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  215215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  215223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  215226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  215244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215262 */     GIR_RootConstrainSelectedInstOperands,
     /*  215263 */     // GIR_Coverage, 23583,
     /*  215263 */     GIR_EraseRootFromParent_Done,
     /*  215264 */   // Label 4325: @215264
     /*  215264 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(215321), // Rule ID 23586 //
     /*  215269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  215272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  215280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  215283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215301 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  215301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215319 */     GIR_RootConstrainSelectedInstOperands,
     /*  215320 */     // GIR_Coverage, 23586,
     /*  215320 */     GIR_EraseRootFromParent_Done,
     /*  215321 */   // Label 4326: @215321
     /*  215321 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(215378), // Rule ID 23587 //
     /*  215326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  215329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  215337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  215340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215358 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  215358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215376 */     GIR_RootConstrainSelectedInstOperands,
     /*  215377 */     // GIR_Coverage, 23587,
     /*  215377 */     GIR_EraseRootFromParent_Done,
     /*  215378 */   // Label 4327: @215378
     /*  215378 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(215435), // Rule ID 23590 //
     /*  215383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  215386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  215394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  215397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215415 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  215415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215433 */     GIR_RootConstrainSelectedInstOperands,
     /*  215434 */     // GIR_Coverage, 23590,
     /*  215434 */     GIR_EraseRootFromParent_Done,
     /*  215435 */   // Label 4328: @215435
     /*  215435 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(215492), // Rule ID 23591 //
     /*  215440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  215443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  215451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  215454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215472 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  215472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215490 */     GIR_RootConstrainSelectedInstOperands,
     /*  215491 */     // GIR_Coverage, 23591,
     /*  215491 */     GIR_EraseRootFromParent_Done,
     /*  215492 */   // Label 4329: @215492
     /*  215492 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(215538), // Rule ID 2657 //
     /*  215497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  215500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks1i),
     /*  215505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215519 */     // MIs[0] rnum
     /*  215519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  215522 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_rnum),
     /*  215527 */     // (intrinsic_wo_chain:{ *:[i64] } 10975:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)  =>  (AES64KS1I:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)
     /*  215527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS1I),
     /*  215530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rnum
     /*  215536 */     GIR_RootConstrainSelectedInstOperands,
     /*  215537 */     // GIR_Coverage, 2657,
     /*  215537 */     GIR_EraseRootFromParent_Done,
     /*  215538 */   // Label 4330: @215538
     /*  215538 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(215583), // Rule ID 64454 //
     /*  215543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  215546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clip),
     /*  215551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215572 */     // (intrinsic_wo_chain:{ *:[i32] } 10985:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPR),
     /*  215575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215581 */     GIR_RootConstrainSelectedInstOperands,
     /*  215582 */     // GIR_Coverage, 64454,
     /*  215582 */     GIR_EraseRootFromParent_Done,
     /*  215583 */   // Label 4331: @215583
     /*  215583 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(215628), // Rule ID 64481 //
     /*  215588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  215591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clipu),
     /*  215596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215617 */     // (intrinsic_wo_chain:{ *:[i32] } 10986:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPUR),
     /*  215620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215626 */     GIR_RootConstrainSelectedInstOperands,
     /*  215627 */     // GIR_Coverage, 64481,
     /*  215627 */     GIR_EraseRootFromParent_Done,
     /*  215628 */   // Label 4332: @215628
     /*  215628 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(215673), // Rule ID 2647 //
     /*  215633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  215636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  215641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215662 */     // (intrinsic_wo_chain:{ *:[i64] } 11693:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM4:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  215665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215671 */     GIR_RootConstrainSelectedInstOperands,
     /*  215672 */     // GIR_Coverage, 2647,
     /*  215672 */     GIR_EraseRootFromParent_Done,
     /*  215673 */   // Label 4333: @215673
     /*  215673 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(215718), // Rule ID 2648 //
     /*  215678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  215681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  215686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215707 */     // (intrinsic_wo_chain:{ *:[i32] } 11693:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM4:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  215710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215716 */     GIR_RootConstrainSelectedInstOperands,
     /*  215717 */     // GIR_Coverage, 2648,
     /*  215717 */     GIR_EraseRootFromParent_Done,
     /*  215718 */   // Label 4334: @215718
     /*  215718 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(215763), // Rule ID 2649 //
     /*  215723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  215726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  215731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215752 */     // (intrinsic_wo_chain:{ *:[i64] } 11694:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM8:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  215755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215761 */     GIR_RootConstrainSelectedInstOperands,
     /*  215762 */     // GIR_Coverage, 2649,
     /*  215762 */     GIR_EraseRootFromParent_Done,
     /*  215763 */   // Label 4335: @215763
     /*  215763 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(215808), // Rule ID 2650 //
     /*  215768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  215771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  215776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215797 */     // (intrinsic_wo_chain:{ *:[i32] } 11694:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM8:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  215800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215806 */     GIR_RootConstrainSelectedInstOperands,
     /*  215807 */     // GIR_Coverage, 2650,
     /*  215807 */     GIR_EraseRootFromParent_Done,
     /*  215808 */   // Label 4336: @215808
     /*  215808 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(215853), // Rule ID 2653 //
     /*  215813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  215816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ds),
     /*  215821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215842 */     // (intrinsic_wo_chain:{ *:[i64] } 10970:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DS),
     /*  215845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215851 */     GIR_RootConstrainSelectedInstOperands,
     /*  215852 */     // GIR_Coverage, 2653,
     /*  215852 */     GIR_EraseRootFromParent_Done,
     /*  215853 */   // Label 4337: @215853
     /*  215853 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(215898), // Rule ID 2654 //
     /*  215858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  215861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64dsm),
     /*  215866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215887 */     // (intrinsic_wo_chain:{ *:[i64] } 10971:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DSM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DSM),
     /*  215890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215896 */     GIR_RootConstrainSelectedInstOperands,
     /*  215897 */     // GIR_Coverage, 2654,
     /*  215897 */     GIR_EraseRootFromParent_Done,
     /*  215898 */   // Label 4338: @215898
     /*  215898 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(215943), // Rule ID 2656 //
     /*  215903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  215906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks2),
     /*  215911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215932 */     // (intrinsic_wo_chain:{ *:[i64] } 10976:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64KS2:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS2),
     /*  215935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215941 */     GIR_RootConstrainSelectedInstOperands,
     /*  215942 */     // GIR_Coverage, 2656,
     /*  215942 */     GIR_EraseRootFromParent_Done,
     /*  215943 */   // Label 4339: @215943
     /*  215943 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(215988), // Rule ID 2660 //
     /*  215948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  215951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64es),
     /*  215956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215977 */     // (intrinsic_wo_chain:{ *:[i64] } 10972:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ES:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ES),
     /*  215980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215986 */     GIR_RootConstrainSelectedInstOperands,
     /*  215987 */     // GIR_Coverage, 2660,
     /*  215987 */     GIR_EraseRootFromParent_Done,
     /*  215988 */   // Label 4340: @215988
     /*  215988 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(216033), // Rule ID 2661 //
     /*  215993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  215996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64esm),
     /*  216001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216022 */     // (intrinsic_wo_chain:{ *:[i64] } 10973:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ESM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ESM),
     /*  216025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216031 */     GIR_RootConstrainSelectedInstOperands,
     /*  216032 */     // GIR_Coverage, 2661,
     /*  216032 */     GIR_EraseRootFromParent_Done,
     /*  216033 */   // Label 4341: @216033
     /*  216033 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(216078), // Rule ID 2670 //
     /*  216038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0l),
     /*  216046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216067 */     // (intrinsic_wo_chain:{ *:[i32] } 11129:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0L),
     /*  216070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216076 */     GIR_RootConstrainSelectedInstOperands,
     /*  216077 */     // GIR_Coverage, 2670,
     /*  216077 */     GIR_EraseRootFromParent_Done,
     /*  216078 */   // Label 4342: @216078
     /*  216078 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(216123), // Rule ID 2671 //
     /*  216083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0h),
     /*  216091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216112 */     // (intrinsic_wo_chain:{ *:[i32] } 11128:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0H),
     /*  216115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216121 */     GIR_RootConstrainSelectedInstOperands,
     /*  216122 */     // GIR_Coverage, 2671,
     /*  216122 */     GIR_EraseRootFromParent_Done,
     /*  216123 */   // Label 4343: @216123
     /*  216123 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(216168), // Rule ID 2672 //
     /*  216128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1l),
     /*  216136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216157 */     // (intrinsic_wo_chain:{ *:[i32] } 11132:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1L),
     /*  216160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216166 */     GIR_RootConstrainSelectedInstOperands,
     /*  216167 */     // GIR_Coverage, 2672,
     /*  216167 */     GIR_EraseRootFromParent_Done,
     /*  216168 */   // Label 4344: @216168
     /*  216168 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(216213), // Rule ID 2673 //
     /*  216173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1h),
     /*  216181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216202 */     // (intrinsic_wo_chain:{ *:[i32] } 11131:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1H),
     /*  216205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216211 */     GIR_RootConstrainSelectedInstOperands,
     /*  216212 */     // GIR_Coverage, 2673,
     /*  216212 */     GIR_EraseRootFromParent_Done,
     /*  216213 */   // Label 4345: @216213
     /*  216213 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(216258), // Rule ID 2674 //
     /*  216218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0r),
     /*  216226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216247 */     // (intrinsic_wo_chain:{ *:[i32] } 11134:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM0R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0R),
     /*  216250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216256 */     GIR_RootConstrainSelectedInstOperands,
     /*  216257 */     // GIR_Coverage, 2674,
     /*  216257 */     GIR_EraseRootFromParent_Done,
     /*  216258 */   // Label 4346: @216258
     /*  216258 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(216303), // Rule ID 2675 //
     /*  216263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1r),
     /*  216271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216292 */     // (intrinsic_wo_chain:{ *:[i32] } 11136:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM1R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1R),
     /*  216295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216301 */     GIR_RootConstrainSelectedInstOperands,
     /*  216302 */     // GIR_Coverage, 2675,
     /*  216302 */     GIR_EraseRootFromParent_Done,
     /*  216303 */   // Label 4347: @216303
     /*  216303 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(216348), // Rule ID 64431 //
     /*  216308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extract),
     /*  216316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216337 */     // (intrinsic_wo_chain:{ *:[i32] } 10995:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTR),
     /*  216340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216346 */     GIR_RootConstrainSelectedInstOperands,
     /*  216347 */     // GIR_Coverage, 64431,
     /*  216347 */     GIR_EraseRootFromParent_Done,
     /*  216348 */   // Label 4348: @216348
     /*  216348 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(216393), // Rule ID 64433 //
     /*  216353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extractu),
     /*  216361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216382 */     // (intrinsic_wo_chain:{ *:[i32] } 10996:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTUR),
     /*  216385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216391 */     GIR_RootConstrainSelectedInstOperands,
     /*  216392 */     // GIR_Coverage, 64433,
     /*  216392 */     GIR_EraseRootFromParent_Done,
     /*  216393 */   // Label 4349: @216393
     /*  216393 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(216438), // Rule ID 64435 //
     /*  216398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bclr),
     /*  216406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216427 */     // (intrinsic_wo_chain:{ *:[i32] } 10991:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BCLRR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BCLRR),
     /*  216430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216436 */     GIR_RootConstrainSelectedInstOperands,
     /*  216437 */     // GIR_Coverage, 64435,
     /*  216437 */     GIR_EraseRootFromParent_Done,
     /*  216438 */   // Label 4350: @216438
     /*  216438 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(216483), // Rule ID 64437 //
     /*  216443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bset),
     /*  216451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216472 */     // (intrinsic_wo_chain:{ *:[i32] } 10993:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BSETR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BSETR),
     /*  216475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216481 */     GIR_RootConstrainSelectedInstOperands,
     /*  216482 */     // GIR_Coverage, 64437,
     /*  216482 */     GIR_EraseRootFromParent_Done,
     /*  216483 */   // Label 4351: @216483
     /*  216483 */   GIM_Reject,
     /*  216484 */ // Label 4215: @216484
     /*  216484 */ GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(387389),
     /*  216489 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  216492 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(216566), // Rule ID 5468 //
     /*  216497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  216511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216537 */     // MIs[1] Operand 1
     /*  216537 */     // No operand predicates
     /*  216537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216546 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  216546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  216549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216564 */     GIR_RootConstrainSelectedInstOperands,
     /*  216565 */     // GIR_Coverage, 5468,
     /*  216565 */     GIR_EraseRootFromParent_Done,
     /*  216566 */   // Label 4353: @216566
     /*  216566 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(216640), // Rule ID 5469 //
     /*  216571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  216585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216611 */     // MIs[1] Operand 1
     /*  216611 */     // No operand predicates
     /*  216611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  216620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  216623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216638 */     GIR_RootConstrainSelectedInstOperands,
     /*  216639 */     // GIR_Coverage, 5469,
     /*  216639 */     GIR_EraseRootFromParent_Done,
     /*  216640 */   // Label 4354: @216640
     /*  216640 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(216714), // Rule ID 5470 //
     /*  216645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  216656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  216659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216685 */     // MIs[1] Operand 1
     /*  216685 */     // No operand predicates
     /*  216685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216694 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  216694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  216697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216712 */     GIR_RootConstrainSelectedInstOperands,
     /*  216713 */     // GIR_Coverage, 5470,
     /*  216713 */     GIR_EraseRootFromParent_Done,
     /*  216714 */   // Label 4355: @216714
     /*  216714 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(216788), // Rule ID 5471 //
     /*  216719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  216730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  216733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216759 */     // MIs[1] Operand 1
     /*  216759 */     // No operand predicates
     /*  216759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216768 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  216768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  216771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216786 */     GIR_RootConstrainSelectedInstOperands,
     /*  216787 */     // GIR_Coverage, 5471,
     /*  216787 */     GIR_EraseRootFromParent_Done,
     /*  216788 */   // Label 4356: @216788
     /*  216788 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(216862), // Rule ID 5472 //
     /*  216793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  216804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  216807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216833 */     // MIs[1] Operand 1
     /*  216833 */     // No operand predicates
     /*  216833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216842 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  216842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  216845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216860 */     GIR_RootConstrainSelectedInstOperands,
     /*  216861 */     // GIR_Coverage, 5472,
     /*  216861 */     GIR_EraseRootFromParent_Done,
     /*  216862 */   // Label 4357: @216862
     /*  216862 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(216936), // Rule ID 5473 //
     /*  216867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  216878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  216881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216907 */     // MIs[1] Operand 1
     /*  216907 */     // No operand predicates
     /*  216907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216916 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  216916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  216919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216934 */     GIR_RootConstrainSelectedInstOperands,
     /*  216935 */     // GIR_Coverage, 5473,
     /*  216935 */     GIR_EraseRootFromParent_Done,
     /*  216936 */   // Label 4358: @216936
     /*  216936 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(217010), // Rule ID 5474 //
     /*  216941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  216955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216981 */     // MIs[1] Operand 1
     /*  216981 */     // No operand predicates
     /*  216981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216990 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  216990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  216993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217008 */     GIR_RootConstrainSelectedInstOperands,
     /*  217009 */     // GIR_Coverage, 5474,
     /*  217009 */     GIR_EraseRootFromParent_Done,
     /*  217010 */   // Label 4359: @217010
     /*  217010 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(217084), // Rule ID 5475 //
     /*  217015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  217029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217055 */     // MIs[1] Operand 1
     /*  217055 */     // No operand predicates
     /*  217055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217064 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  217064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  217067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217082 */     GIR_RootConstrainSelectedInstOperands,
     /*  217083 */     // GIR_Coverage, 5475,
     /*  217083 */     GIR_EraseRootFromParent_Done,
     /*  217084 */   // Label 4360: @217084
     /*  217084 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(217158), // Rule ID 5476 //
     /*  217089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217129 */     // MIs[1] Operand 1
     /*  217129 */     // No operand predicates
     /*  217129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217138 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  217138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217156 */     GIR_RootConstrainSelectedInstOperands,
     /*  217157 */     // GIR_Coverage, 5476,
     /*  217157 */     GIR_EraseRootFromParent_Done,
     /*  217158 */   // Label 4361: @217158
     /*  217158 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(217232), // Rule ID 5477 //
     /*  217163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217203 */     // MIs[1] Operand 1
     /*  217203 */     // No operand predicates
     /*  217203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217212 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  217212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217230 */     GIR_RootConstrainSelectedInstOperands,
     /*  217231 */     // GIR_Coverage, 5477,
     /*  217231 */     GIR_EraseRootFromParent_Done,
     /*  217232 */   // Label 4362: @217232
     /*  217232 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(217306), // Rule ID 5478 //
     /*  217237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217277 */     // MIs[1] Operand 1
     /*  217277 */     // No operand predicates
     /*  217277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217286 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  217286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217304 */     GIR_RootConstrainSelectedInstOperands,
     /*  217305 */     // GIR_Coverage, 5478,
     /*  217305 */     GIR_EraseRootFromParent_Done,
     /*  217306 */   // Label 4363: @217306
     /*  217306 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(217380), // Rule ID 5479 //
     /*  217311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217351 */     // MIs[1] Operand 1
     /*  217351 */     // No operand predicates
     /*  217351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217360 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  217360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217378 */     GIR_RootConstrainSelectedInstOperands,
     /*  217379 */     // GIR_Coverage, 5479,
     /*  217379 */     GIR_EraseRootFromParent_Done,
     /*  217380 */   // Label 4364: @217380
     /*  217380 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(217454), // Rule ID 5480 //
     /*  217385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  217396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  217399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217425 */     // MIs[1] Operand 1
     /*  217425 */     // No operand predicates
     /*  217425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217434 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  217434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217452 */     GIR_RootConstrainSelectedInstOperands,
     /*  217453 */     // GIR_Coverage, 5480,
     /*  217453 */     GIR_EraseRootFromParent_Done,
     /*  217454 */   // Label 4365: @217454
     /*  217454 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(217528), // Rule ID 5481 //
     /*  217459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  217470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  217473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217499 */     // MIs[1] Operand 1
     /*  217499 */     // No operand predicates
     /*  217499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217508 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  217508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217526 */     GIR_RootConstrainSelectedInstOperands,
     /*  217527 */     // GIR_Coverage, 5481,
     /*  217527 */     GIR_EraseRootFromParent_Done,
     /*  217528 */   // Label 4366: @217528
     /*  217528 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(217602), // Rule ID 5482 //
     /*  217533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  217544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  217547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217573 */     // MIs[1] Operand 1
     /*  217573 */     // No operand predicates
     /*  217573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217582 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  217582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217600 */     GIR_RootConstrainSelectedInstOperands,
     /*  217601 */     // GIR_Coverage, 5482,
     /*  217601 */     GIR_EraseRootFromParent_Done,
     /*  217602 */   // Label 4367: @217602
     /*  217602 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(217676), // Rule ID 5483 //
     /*  217607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  217618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  217621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217647 */     // MIs[1] Operand 1
     /*  217647 */     // No operand predicates
     /*  217647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217656 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  217656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217674 */     GIR_RootConstrainSelectedInstOperands,
     /*  217675 */     // GIR_Coverage, 5483,
     /*  217675 */     GIR_EraseRootFromParent_Done,
     /*  217676 */   // Label 4368: @217676
     /*  217676 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(217750), // Rule ID 5484 //
     /*  217681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  217695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217721 */     // MIs[1] Operand 1
     /*  217721 */     // No operand predicates
     /*  217721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217730 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  217730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217748 */     GIR_RootConstrainSelectedInstOperands,
     /*  217749 */     // GIR_Coverage, 5484,
     /*  217749 */     GIR_EraseRootFromParent_Done,
     /*  217750 */   // Label 4369: @217750
     /*  217750 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(217824), // Rule ID 5485 //
     /*  217755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  217769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217795 */     // MIs[1] Operand 1
     /*  217795 */     // No operand predicates
     /*  217795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217804 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  217804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217822 */     GIR_RootConstrainSelectedInstOperands,
     /*  217823 */     // GIR_Coverage, 5485,
     /*  217823 */     GIR_EraseRootFromParent_Done,
     /*  217824 */   // Label 4370: @217824
     /*  217824 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(217898), // Rule ID 5486 //
     /*  217829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  217832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  217843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217869 */     // MIs[1] Operand 1
     /*  217869 */     // No operand predicates
     /*  217869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217878 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  217878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  217896 */     GIR_RootConstrainSelectedInstOperands,
     /*  217897 */     // GIR_Coverage, 5486,
     /*  217897 */     GIR_EraseRootFromParent_Done,
     /*  217898 */   // Label 4371: @217898
     /*  217898 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(217972), // Rule ID 5487 //
     /*  217903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  217906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  217917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217943 */     // MIs[1] Operand 1
     /*  217943 */     // No operand predicates
     /*  217943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217952 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  217952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  217970 */     GIR_RootConstrainSelectedInstOperands,
     /*  217971 */     // GIR_Coverage, 5487,
     /*  217971 */     GIR_EraseRootFromParent_Done,
     /*  217972 */   // Label 4372: @217972
     /*  217972 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(218046), // Rule ID 5488 //
     /*  217977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  217988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  217991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218017 */     // MIs[1] Operand 1
     /*  218017 */     // No operand predicates
     /*  218017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218026 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  218026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218044 */     GIR_RootConstrainSelectedInstOperands,
     /*  218045 */     // GIR_Coverage, 5488,
     /*  218045 */     GIR_EraseRootFromParent_Done,
     /*  218046 */   // Label 4373: @218046
     /*  218046 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(218120), // Rule ID 5489 //
     /*  218051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  218065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218091 */     // MIs[1] Operand 1
     /*  218091 */     // No operand predicates
     /*  218091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218100 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  218100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218118 */     GIR_RootConstrainSelectedInstOperands,
     /*  218119 */     // GIR_Coverage, 5489,
     /*  218119 */     GIR_EraseRootFromParent_Done,
     /*  218120 */   // Label 4374: @218120
     /*  218120 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(218194), // Rule ID 5490 //
     /*  218125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  218139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218165 */     // MIs[1] Operand 1
     /*  218165 */     // No operand predicates
     /*  218165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218174 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  218174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218192 */     GIR_RootConstrainSelectedInstOperands,
     /*  218193 */     // GIR_Coverage, 5490,
     /*  218193 */     GIR_EraseRootFromParent_Done,
     /*  218194 */   // Label 4375: @218194
     /*  218194 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(218268), // Rule ID 5491 //
     /*  218199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  218213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218239 */     // MIs[1] Operand 1
     /*  218239 */     // No operand predicates
     /*  218239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218248 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  218248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218266 */     GIR_RootConstrainSelectedInstOperands,
     /*  218267 */     // GIR_Coverage, 5491,
     /*  218267 */     GIR_EraseRootFromParent_Done,
     /*  218268 */   // Label 4376: @218268
     /*  218268 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(218342), // Rule ID 5492 //
     /*  218273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  218284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  218287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218313 */     // MIs[1] Operand 1
     /*  218313 */     // No operand predicates
     /*  218313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218322 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  218322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218340 */     GIR_RootConstrainSelectedInstOperands,
     /*  218341 */     // GIR_Coverage, 5492,
     /*  218341 */     GIR_EraseRootFromParent_Done,
     /*  218342 */   // Label 4377: @218342
     /*  218342 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(218416), // Rule ID 5493 //
     /*  218347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  218358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  218361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218387 */     // MIs[1] Operand 1
     /*  218387 */     // No operand predicates
     /*  218387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218396 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  218396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218414 */     GIR_RootConstrainSelectedInstOperands,
     /*  218415 */     // GIR_Coverage, 5493,
     /*  218415 */     GIR_EraseRootFromParent_Done,
     /*  218416 */   // Label 4378: @218416
     /*  218416 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(218490), // Rule ID 5494 //
     /*  218421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  218432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  218435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218461 */     // MIs[1] Operand 1
     /*  218461 */     // No operand predicates
     /*  218461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218470 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  218470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218488 */     GIR_RootConstrainSelectedInstOperands,
     /*  218489 */     // GIR_Coverage, 5494,
     /*  218489 */     GIR_EraseRootFromParent_Done,
     /*  218490 */   // Label 4379: @218490
     /*  218490 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(218564), // Rule ID 5495 //
     /*  218495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  218506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  218509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218535 */     // MIs[1] Operand 1
     /*  218535 */     // No operand predicates
     /*  218535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218544 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  218544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218562 */     GIR_RootConstrainSelectedInstOperands,
     /*  218563 */     // GIR_Coverage, 5495,
     /*  218563 */     GIR_EraseRootFromParent_Done,
     /*  218564 */   // Label 4380: @218564
     /*  218564 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(218638), // Rule ID 5496 //
     /*  218569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  218583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218609 */     // MIs[1] Operand 1
     /*  218609 */     // No operand predicates
     /*  218609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218618 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  218618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218636 */     GIR_RootConstrainSelectedInstOperands,
     /*  218637 */     // GIR_Coverage, 5496,
     /*  218637 */     GIR_EraseRootFromParent_Done,
     /*  218638 */   // Label 4381: @218638
     /*  218638 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(218712), // Rule ID 5497 //
     /*  218643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  218657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218683 */     // MIs[1] Operand 1
     /*  218683 */     // No operand predicates
     /*  218683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218692 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  218692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218710 */     GIR_RootConstrainSelectedInstOperands,
     /*  218711 */     // GIR_Coverage, 5497,
     /*  218711 */     GIR_EraseRootFromParent_Done,
     /*  218712 */   // Label 4382: @218712
     /*  218712 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(218786), // Rule ID 5498 //
     /*  218717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  218731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218757 */     // MIs[1] Operand 1
     /*  218757 */     // No operand predicates
     /*  218757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218766 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  218766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218784 */     GIR_RootConstrainSelectedInstOperands,
     /*  218785 */     // GIR_Coverage, 5498,
     /*  218785 */     GIR_EraseRootFromParent_Done,
     /*  218786 */   // Label 4383: @218786
     /*  218786 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(218860), // Rule ID 5499 //
     /*  218791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  218805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218831 */     // MIs[1] Operand 1
     /*  218831 */     // No operand predicates
     /*  218831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218840 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  218840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218858 */     GIR_RootConstrainSelectedInstOperands,
     /*  218859 */     // GIR_Coverage, 5499,
     /*  218859 */     GIR_EraseRootFromParent_Done,
     /*  218860 */   // Label 4384: @218860
     /*  218860 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(218934), // Rule ID 5500 //
     /*  218865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  218876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  218879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218905 */     // MIs[1] Operand 1
     /*  218905 */     // No operand predicates
     /*  218905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218914 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  218914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218932 */     GIR_RootConstrainSelectedInstOperands,
     /*  218933 */     // GIR_Coverage, 5500,
     /*  218933 */     GIR_EraseRootFromParent_Done,
     /*  218934 */   // Label 4385: @218934
     /*  218934 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(219008), // Rule ID 5501 //
     /*  218939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  218950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  218953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218979 */     // MIs[1] Operand 1
     /*  218979 */     // No operand predicates
     /*  218979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218988 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  218988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219006 */     GIR_RootConstrainSelectedInstOperands,
     /*  219007 */     // GIR_Coverage, 5501,
     /*  219007 */     GIR_EraseRootFromParent_Done,
     /*  219008 */   // Label 4386: @219008
     /*  219008 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(219082), // Rule ID 5502 //
     /*  219013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  219027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219053 */     // MIs[1] Operand 1
     /*  219053 */     // No operand predicates
     /*  219053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219062 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  219062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219080 */     GIR_RootConstrainSelectedInstOperands,
     /*  219081 */     // GIR_Coverage, 5502,
     /*  219081 */     GIR_EraseRootFromParent_Done,
     /*  219082 */   // Label 4387: @219082
     /*  219082 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(219156), // Rule ID 5503 //
     /*  219087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  219101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219127 */     // MIs[1] Operand 1
     /*  219127 */     // No operand predicates
     /*  219127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219136 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  219136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219154 */     GIR_RootConstrainSelectedInstOperands,
     /*  219155 */     // GIR_Coverage, 5503,
     /*  219155 */     GIR_EraseRootFromParent_Done,
     /*  219156 */   // Label 4388: @219156
     /*  219156 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(219230), // Rule ID 5504 //
     /*  219161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  219172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  219175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219201 */     // MIs[1] Operand 1
     /*  219201 */     // No operand predicates
     /*  219201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219210 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  219210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219228 */     GIR_RootConstrainSelectedInstOperands,
     /*  219229 */     // GIR_Coverage, 5504,
     /*  219229 */     GIR_EraseRootFromParent_Done,
     /*  219230 */   // Label 4389: @219230
     /*  219230 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(219304), // Rule ID 5505 //
     /*  219235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  219246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  219249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219275 */     // MIs[1] Operand 1
     /*  219275 */     // No operand predicates
     /*  219275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219284 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  219284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219302 */     GIR_RootConstrainSelectedInstOperands,
     /*  219303 */     // GIR_Coverage, 5505,
     /*  219303 */     GIR_EraseRootFromParent_Done,
     /*  219304 */   // Label 4390: @219304
     /*  219304 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(219378), // Rule ID 5506 //
     /*  219309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  219323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219349 */     // MIs[1] Operand 1
     /*  219349 */     // No operand predicates
     /*  219349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219358 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  219358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219376 */     GIR_RootConstrainSelectedInstOperands,
     /*  219377 */     // GIR_Coverage, 5506,
     /*  219377 */     GIR_EraseRootFromParent_Done,
     /*  219378 */   // Label 4391: @219378
     /*  219378 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(219452), // Rule ID 5507 //
     /*  219383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  219397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219423 */     // MIs[1] Operand 1
     /*  219423 */     // No operand predicates
     /*  219423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219432 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  219432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219450 */     GIR_RootConstrainSelectedInstOperands,
     /*  219451 */     // GIR_Coverage, 5507,
     /*  219451 */     GIR_EraseRootFromParent_Done,
     /*  219452 */   // Label 4392: @219452
     /*  219452 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(219526), // Rule ID 5508 //
     /*  219457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  219471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219497 */     // MIs[1] Operand 1
     /*  219497 */     // No operand predicates
     /*  219497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219506 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  219506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219524 */     GIR_RootConstrainSelectedInstOperands,
     /*  219525 */     // GIR_Coverage, 5508,
     /*  219525 */     GIR_EraseRootFromParent_Done,
     /*  219526 */   // Label 4393: @219526
     /*  219526 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(219600), // Rule ID 5509 //
     /*  219531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  219545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219571 */     // MIs[1] Operand 1
     /*  219571 */     // No operand predicates
     /*  219571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219580 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  219580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219598 */     GIR_RootConstrainSelectedInstOperands,
     /*  219599 */     // GIR_Coverage, 5509,
     /*  219599 */     GIR_EraseRootFromParent_Done,
     /*  219600 */   // Label 4394: @219600
     /*  219600 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(219674), // Rule ID 5510 //
     /*  219605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  219619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219645 */     // MIs[1] Operand 1
     /*  219645 */     // No operand predicates
     /*  219645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219654 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  219654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219672 */     GIR_RootConstrainSelectedInstOperands,
     /*  219673 */     // GIR_Coverage, 5510,
     /*  219673 */     GIR_EraseRootFromParent_Done,
     /*  219674 */   // Label 4395: @219674
     /*  219674 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(219748), // Rule ID 5511 //
     /*  219679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  219693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219719 */     // MIs[1] Operand 1
     /*  219719 */     // No operand predicates
     /*  219719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  219728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219746 */     GIR_RootConstrainSelectedInstOperands,
     /*  219747 */     // GIR_Coverage, 5511,
     /*  219747 */     GIR_EraseRootFromParent_Done,
     /*  219748 */   // Label 4396: @219748
     /*  219748 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(219822), // Rule ID 7980 //
     /*  219753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  219764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  219767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219793 */     // MIs[1] Operand 1
     /*  219793 */     // No operand predicates
     /*  219793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219802 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  219802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  219805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  219820 */     GIR_RootConstrainSelectedInstOperands,
     /*  219821 */     // GIR_Coverage, 7980,
     /*  219821 */     GIR_EraseRootFromParent_Done,
     /*  219822 */   // Label 4397: @219822
     /*  219822 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(219896), // Rule ID 7981 //
     /*  219827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  219838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  219841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219867 */     // MIs[1] Operand 1
     /*  219867 */     // No operand predicates
     /*  219867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219876 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  219876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  219879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  219894 */     GIR_RootConstrainSelectedInstOperands,
     /*  219895 */     // GIR_Coverage, 7981,
     /*  219895 */     GIR_EraseRootFromParent_Done,
     /*  219896 */   // Label 4398: @219896
     /*  219896 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(219970), // Rule ID 7984 //
     /*  219901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  219915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219941 */     // MIs[1] Operand 1
     /*  219941 */     // No operand predicates
     /*  219941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219950 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  219950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  219953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  219968 */     GIR_RootConstrainSelectedInstOperands,
     /*  219969 */     // GIR_Coverage, 7984,
     /*  219969 */     GIR_EraseRootFromParent_Done,
     /*  219970 */   // Label 4399: @219970
     /*  219970 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(220044), // Rule ID 7985 //
     /*  219975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  219989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220015 */     // MIs[1] Operand 1
     /*  220015 */     // No operand predicates
     /*  220015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220024 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220042 */     GIR_RootConstrainSelectedInstOperands,
     /*  220043 */     // GIR_Coverage, 7985,
     /*  220043 */     GIR_EraseRootFromParent_Done,
     /*  220044 */   // Label 4400: @220044
     /*  220044 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(220118), // Rule ID 7988 //
     /*  220049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  220063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220089 */     // MIs[1] Operand 1
     /*  220089 */     // No operand predicates
     /*  220089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220098 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220116 */     GIR_RootConstrainSelectedInstOperands,
     /*  220117 */     // GIR_Coverage, 7988,
     /*  220117 */     GIR_EraseRootFromParent_Done,
     /*  220118 */   // Label 4401: @220118
     /*  220118 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(220192), // Rule ID 7989 //
     /*  220123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  220137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220163 */     // MIs[1] Operand 1
     /*  220163 */     // No operand predicates
     /*  220163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220172 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220190 */     GIR_RootConstrainSelectedInstOperands,
     /*  220191 */     // GIR_Coverage, 7989,
     /*  220191 */     GIR_EraseRootFromParent_Done,
     /*  220192 */   // Label 4402: @220192
     /*  220192 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(220266), // Rule ID 7992 //
     /*  220197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220237 */     // MIs[1] Operand 1
     /*  220237 */     // No operand predicates
     /*  220237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220246 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220264 */     GIR_RootConstrainSelectedInstOperands,
     /*  220265 */     // GIR_Coverage, 7992,
     /*  220265 */     GIR_EraseRootFromParent_Done,
     /*  220266 */   // Label 4403: @220266
     /*  220266 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(220340), // Rule ID 7993 //
     /*  220271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220311 */     // MIs[1] Operand 1
     /*  220311 */     // No operand predicates
     /*  220311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220320 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220338 */     GIR_RootConstrainSelectedInstOperands,
     /*  220339 */     // GIR_Coverage, 7993,
     /*  220339 */     GIR_EraseRootFromParent_Done,
     /*  220340 */   // Label 4404: @220340
     /*  220340 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(220414), // Rule ID 7996 //
     /*  220345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  220359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220385 */     // MIs[1] Operand 1
     /*  220385 */     // No operand predicates
     /*  220385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220394 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220412 */     GIR_RootConstrainSelectedInstOperands,
     /*  220413 */     // GIR_Coverage, 7996,
     /*  220413 */     GIR_EraseRootFromParent_Done,
     /*  220414 */   // Label 4405: @220414
     /*  220414 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(220488), // Rule ID 7997 //
     /*  220419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  220433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220459 */     // MIs[1] Operand 1
     /*  220459 */     // No operand predicates
     /*  220459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220468 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220486 */     GIR_RootConstrainSelectedInstOperands,
     /*  220487 */     // GIR_Coverage, 7997,
     /*  220487 */     GIR_EraseRootFromParent_Done,
     /*  220488 */   // Label 4406: @220488
     /*  220488 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(220562), // Rule ID 8000 //
     /*  220493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  220507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220533 */     // MIs[1] Operand 1
     /*  220533 */     // No operand predicates
     /*  220533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220542 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  220542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220560 */     GIR_RootConstrainSelectedInstOperands,
     /*  220561 */     // GIR_Coverage, 8000,
     /*  220561 */     GIR_EraseRootFromParent_Done,
     /*  220562 */   // Label 4407: @220562
     /*  220562 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(220636), // Rule ID 8001 //
     /*  220567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  220581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220607 */     // MIs[1] Operand 1
     /*  220607 */     // No operand predicates
     /*  220607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220616 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  220616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220634 */     GIR_RootConstrainSelectedInstOperands,
     /*  220635 */     // GIR_Coverage, 8001,
     /*  220635 */     GIR_EraseRootFromParent_Done,
     /*  220636 */   // Label 4408: @220636
     /*  220636 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(220710), // Rule ID 8004 //
     /*  220641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  220652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  220655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220681 */     // MIs[1] Operand 1
     /*  220681 */     // No operand predicates
     /*  220681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220690 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220708 */     GIR_RootConstrainSelectedInstOperands,
     /*  220709 */     // GIR_Coverage, 8004,
     /*  220709 */     GIR_EraseRootFromParent_Done,
     /*  220710 */   // Label 4409: @220710
     /*  220710 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(220784), // Rule ID 8005 //
     /*  220715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  220726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  220729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220755 */     // MIs[1] Operand 1
     /*  220755 */     // No operand predicates
     /*  220755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220764 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220782 */     GIR_RootConstrainSelectedInstOperands,
     /*  220783 */     // GIR_Coverage, 8005,
     /*  220783 */     GIR_EraseRootFromParent_Done,
     /*  220784 */   // Label 4410: @220784
     /*  220784 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(220858), // Rule ID 8008 //
     /*  220789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  220803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220829 */     // MIs[1] Operand 1
     /*  220829 */     // No operand predicates
     /*  220829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220838 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220856 */     GIR_RootConstrainSelectedInstOperands,
     /*  220857 */     // GIR_Coverage, 8008,
     /*  220857 */     GIR_EraseRootFromParent_Done,
     /*  220858 */   // Label 4411: @220858
     /*  220858 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(220932), // Rule ID 8009 //
     /*  220863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  220877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220903 */     // MIs[1] Operand 1
     /*  220903 */     // No operand predicates
     /*  220903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220912 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220930 */     GIR_RootConstrainSelectedInstOperands,
     /*  220931 */     // GIR_Coverage, 8009,
     /*  220931 */     GIR_EraseRootFromParent_Done,
     /*  220932 */   // Label 4412: @220932
     /*  220932 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(221006), // Rule ID 8012 //
     /*  220937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  220951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220977 */     // MIs[1] Operand 1
     /*  220977 */     // No operand predicates
     /*  220977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220986 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  220986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221004 */     GIR_RootConstrainSelectedInstOperands,
     /*  221005 */     // GIR_Coverage, 8012,
     /*  221005 */     GIR_EraseRootFromParent_Done,
     /*  221006 */   // Label 4413: @221006
     /*  221006 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(221080), // Rule ID 8013 //
     /*  221011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  221025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221051 */     // MIs[1] Operand 1
     /*  221051 */     // No operand predicates
     /*  221051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221060 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221078 */     GIR_RootConstrainSelectedInstOperands,
     /*  221079 */     // GIR_Coverage, 8013,
     /*  221079 */     GIR_EraseRootFromParent_Done,
     /*  221080 */   // Label 4414: @221080
     /*  221080 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(221154), // Rule ID 8016 //
     /*  221085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  221088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221125 */     // MIs[1] Operand 1
     /*  221125 */     // No operand predicates
     /*  221125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221134 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  221134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221152 */     GIR_RootConstrainSelectedInstOperands,
     /*  221153 */     // GIR_Coverage, 8016,
     /*  221153 */     GIR_EraseRootFromParent_Done,
     /*  221154 */   // Label 4415: @221154
     /*  221154 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(221228), // Rule ID 8017 //
     /*  221159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  221162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221199 */     // MIs[1] Operand 1
     /*  221199 */     // No operand predicates
     /*  221199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221208 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  221208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221226 */     GIR_RootConstrainSelectedInstOperands,
     /*  221227 */     // GIR_Coverage, 8017,
     /*  221227 */     GIR_EraseRootFromParent_Done,
     /*  221228 */   // Label 4416: @221228
     /*  221228 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(221302), // Rule ID 8020 //
     /*  221233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  221247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221273 */     // MIs[1] Operand 1
     /*  221273 */     // No operand predicates
     /*  221273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221282 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221300 */     GIR_RootConstrainSelectedInstOperands,
     /*  221301 */     // GIR_Coverage, 8020,
     /*  221301 */     GIR_EraseRootFromParent_Done,
     /*  221302 */   // Label 4417: @221302
     /*  221302 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(221376), // Rule ID 8021 //
     /*  221307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  221321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221347 */     // MIs[1] Operand 1
     /*  221347 */     // No operand predicates
     /*  221347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221356 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221374 */     GIR_RootConstrainSelectedInstOperands,
     /*  221375 */     // GIR_Coverage, 8021,
     /*  221375 */     GIR_EraseRootFromParent_Done,
     /*  221376 */   // Label 4418: @221376
     /*  221376 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(221450), // Rule ID 8024 //
     /*  221381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  221395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221421 */     // MIs[1] Operand 1
     /*  221421 */     // No operand predicates
     /*  221421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221430 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221448 */     GIR_RootConstrainSelectedInstOperands,
     /*  221449 */     // GIR_Coverage, 8024,
     /*  221449 */     GIR_EraseRootFromParent_Done,
     /*  221450 */   // Label 4419: @221450
     /*  221450 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(221524), // Rule ID 8025 //
     /*  221455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  221469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221495 */     // MIs[1] Operand 1
     /*  221495 */     // No operand predicates
     /*  221495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221504 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221522 */     GIR_RootConstrainSelectedInstOperands,
     /*  221523 */     // GIR_Coverage, 8025,
     /*  221523 */     GIR_EraseRootFromParent_Done,
     /*  221524 */   // Label 4420: @221524
     /*  221524 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(221598), // Rule ID 8028 //
     /*  221529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  221540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  221543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221569 */     // MIs[1] Operand 1
     /*  221569 */     // No operand predicates
     /*  221569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221578 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  221581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221596 */     GIR_RootConstrainSelectedInstOperands,
     /*  221597 */     // GIR_Coverage, 8028,
     /*  221597 */     GIR_EraseRootFromParent_Done,
     /*  221598 */   // Label 4421: @221598
     /*  221598 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(221672), // Rule ID 8029 //
     /*  221603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  221614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  221617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221643 */     // MIs[1] Operand 1
     /*  221643 */     // No operand predicates
     /*  221643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221652 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  221655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221670 */     GIR_RootConstrainSelectedInstOperands,
     /*  221671 */     // GIR_Coverage, 8029,
     /*  221671 */     GIR_EraseRootFromParent_Done,
     /*  221672 */   // Label 4422: @221672
     /*  221672 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(221746), // Rule ID 8032 //
     /*  221677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  221691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221717 */     // MIs[1] Operand 1
     /*  221717 */     // No operand predicates
     /*  221717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221726 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221744 */     GIR_RootConstrainSelectedInstOperands,
     /*  221745 */     // GIR_Coverage, 8032,
     /*  221745 */     GIR_EraseRootFromParent_Done,
     /*  221746 */   // Label 4423: @221746
     /*  221746 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(221820), // Rule ID 8033 //
     /*  221751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  221765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221791 */     // MIs[1] Operand 1
     /*  221791 */     // No operand predicates
     /*  221791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221800 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221818 */     GIR_RootConstrainSelectedInstOperands,
     /*  221819 */     // GIR_Coverage, 8033,
     /*  221819 */     GIR_EraseRootFromParent_Done,
     /*  221820 */   // Label 4424: @221820
     /*  221820 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(221894), // Rule ID 8036 //
     /*  221825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  221839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221865 */     // MIs[1] Operand 1
     /*  221865 */     // No operand predicates
     /*  221865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221874 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221892 */     GIR_RootConstrainSelectedInstOperands,
     /*  221893 */     // GIR_Coverage, 8036,
     /*  221893 */     GIR_EraseRootFromParent_Done,
     /*  221894 */   // Label 4425: @221894
     /*  221894 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(221968), // Rule ID 8037 //
     /*  221899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  221913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221939 */     // MIs[1] Operand 1
     /*  221939 */     // No operand predicates
     /*  221939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221948 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221966 */     GIR_RootConstrainSelectedInstOperands,
     /*  221967 */     // GIR_Coverage, 8037,
     /*  221967 */     GIR_EraseRootFromParent_Done,
     /*  221968 */   // Label 4426: @221968
     /*  221968 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(222042), // Rule ID 8040 //
     /*  221973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  221987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222013 */     // MIs[1] Operand 1
     /*  222013 */     // No operand predicates
     /*  222013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222022 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222040 */     GIR_RootConstrainSelectedInstOperands,
     /*  222041 */     // GIR_Coverage, 8040,
     /*  222041 */     GIR_EraseRootFromParent_Done,
     /*  222042 */   // Label 4427: @222042
     /*  222042 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(222116), // Rule ID 8041 //
     /*  222047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  222058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  222061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222087 */     // MIs[1] Operand 1
     /*  222087 */     // No operand predicates
     /*  222087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222096 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222114 */     GIR_RootConstrainSelectedInstOperands,
     /*  222115 */     // GIR_Coverage, 8041,
     /*  222115 */     GIR_EraseRootFromParent_Done,
     /*  222116 */   // Label 4428: @222116
     /*  222116 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(222190), // Rule ID 8044 //
     /*  222121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  222135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222161 */     // MIs[1] Operand 1
     /*  222161 */     // No operand predicates
     /*  222161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222170 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222188 */     GIR_RootConstrainSelectedInstOperands,
     /*  222189 */     // GIR_Coverage, 8044,
     /*  222189 */     GIR_EraseRootFromParent_Done,
     /*  222190 */   // Label 4429: @222190
     /*  222190 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(222264), // Rule ID 8045 //
     /*  222195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  222209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222235 */     // MIs[1] Operand 1
     /*  222235 */     // No operand predicates
     /*  222235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222262 */     GIR_RootConstrainSelectedInstOperands,
     /*  222263 */     // GIR_Coverage, 8045,
     /*  222263 */     GIR_EraseRootFromParent_Done,
     /*  222264 */   // Label 4430: @222264
     /*  222264 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(222338), // Rule ID 8048 //
     /*  222269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  222283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222309 */     // MIs[1] Operand 1
     /*  222309 */     // No operand predicates
     /*  222309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222318 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222336 */     GIR_RootConstrainSelectedInstOperands,
     /*  222337 */     // GIR_Coverage, 8048,
     /*  222337 */     GIR_EraseRootFromParent_Done,
     /*  222338 */   // Label 4431: @222338
     /*  222338 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(222412), // Rule ID 8049 //
     /*  222343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  222357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222383 */     // MIs[1] Operand 1
     /*  222383 */     // No operand predicates
     /*  222383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222392 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222410 */     GIR_RootConstrainSelectedInstOperands,
     /*  222411 */     // GIR_Coverage, 8049,
     /*  222411 */     GIR_EraseRootFromParent_Done,
     /*  222412 */   // Label 4432: @222412
     /*  222412 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(222486), // Rule ID 8052 //
     /*  222417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  222431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222457 */     // MIs[1] Operand 1
     /*  222457 */     // No operand predicates
     /*  222457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222466 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222484 */     GIR_RootConstrainSelectedInstOperands,
     /*  222485 */     // GIR_Coverage, 8052,
     /*  222485 */     GIR_EraseRootFromParent_Done,
     /*  222486 */   // Label 4433: @222486
     /*  222486 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(222560), // Rule ID 8053 //
     /*  222491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  222505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222531 */     // MIs[1] Operand 1
     /*  222531 */     // No operand predicates
     /*  222531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222540 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222558 */     GIR_RootConstrainSelectedInstOperands,
     /*  222559 */     // GIR_Coverage, 8053,
     /*  222559 */     GIR_EraseRootFromParent_Done,
     /*  222560 */   // Label 4434: @222560
     /*  222560 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(222634), // Rule ID 8056 //
     /*  222565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  222568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  222576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  222579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222605 */     // MIs[1] Operand 1
     /*  222605 */     // No operand predicates
     /*  222605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222614 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  222614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222632 */     GIR_RootConstrainSelectedInstOperands,
     /*  222633 */     // GIR_Coverage, 8056,
     /*  222633 */     GIR_EraseRootFromParent_Done,
     /*  222634 */   // Label 4435: @222634
     /*  222634 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(222708), // Rule ID 8057 //
     /*  222639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  222642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  222650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  222653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222679 */     // MIs[1] Operand 1
     /*  222679 */     // No operand predicates
     /*  222679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222688 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  222688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222706 */     GIR_RootConstrainSelectedInstOperands,
     /*  222707 */     // GIR_Coverage, 8057,
     /*  222707 */     GIR_EraseRootFromParent_Done,
     /*  222708 */   // Label 4436: @222708
     /*  222708 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(222782), // Rule ID 8060 //
     /*  222713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  222716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  222727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222753 */     // MIs[1] Operand 1
     /*  222753 */     // No operand predicates
     /*  222753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222762 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  222762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222780 */     GIR_RootConstrainSelectedInstOperands,
     /*  222781 */     // GIR_Coverage, 8060,
     /*  222781 */     GIR_EraseRootFromParent_Done,
     /*  222782 */   // Label 4437: @222782
     /*  222782 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(222856), // Rule ID 8061 //
     /*  222787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  222790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  222801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222827 */     // MIs[1] Operand 1
     /*  222827 */     // No operand predicates
     /*  222827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222836 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  222836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222854 */     GIR_RootConstrainSelectedInstOperands,
     /*  222855 */     // GIR_Coverage, 8061,
     /*  222855 */     GIR_EraseRootFromParent_Done,
     /*  222856 */   // Label 4438: @222856
     /*  222856 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(222930), // Rule ID 8064 //
     /*  222861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  222864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  222875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222901 */     // MIs[1] Operand 1
     /*  222901 */     // No operand predicates
     /*  222901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222910 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  222910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222928 */     GIR_RootConstrainSelectedInstOperands,
     /*  222929 */     // GIR_Coverage, 8064,
     /*  222929 */     GIR_EraseRootFromParent_Done,
     /*  222930 */   // Label 4439: @222930
     /*  222930 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(223004), // Rule ID 8065 //
     /*  222935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  222938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  222949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222975 */     // MIs[1] Operand 1
     /*  222975 */     // No operand predicates
     /*  222975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222984 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  222984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223002 */     GIR_RootConstrainSelectedInstOperands,
     /*  223003 */     // GIR_Coverage, 8065,
     /*  223003 */     GIR_EraseRootFromParent_Done,
     /*  223004 */   // Label 4440: @223004
     /*  223004 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(223078), // Rule ID 8244 //
     /*  223009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  223023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223049 */     // MIs[1] Operand 1
     /*  223049 */     // No operand predicates
     /*  223049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223058 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  223061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223076 */     GIR_RootConstrainSelectedInstOperands,
     /*  223077 */     // GIR_Coverage, 8244,
     /*  223077 */     GIR_EraseRootFromParent_Done,
     /*  223078 */   // Label 4441: @223078
     /*  223078 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(223152), // Rule ID 8245 //
     /*  223083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  223097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223123 */     // MIs[1] Operand 1
     /*  223123 */     // No operand predicates
     /*  223123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223132 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  223135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223150 */     GIR_RootConstrainSelectedInstOperands,
     /*  223151 */     // GIR_Coverage, 8245,
     /*  223151 */     GIR_EraseRootFromParent_Done,
     /*  223152 */   // Label 4442: @223152
     /*  223152 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(223226), // Rule ID 8248 //
     /*  223157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  223171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223197 */     // MIs[1] Operand 1
     /*  223197 */     // No operand predicates
     /*  223197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223206 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223224 */     GIR_RootConstrainSelectedInstOperands,
     /*  223225 */     // GIR_Coverage, 8248,
     /*  223225 */     GIR_EraseRootFromParent_Done,
     /*  223226 */   // Label 4443: @223226
     /*  223226 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(223300), // Rule ID 8249 //
     /*  223231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  223245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223271 */     // MIs[1] Operand 1
     /*  223271 */     // No operand predicates
     /*  223271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223280 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223298 */     GIR_RootConstrainSelectedInstOperands,
     /*  223299 */     // GIR_Coverage, 8249,
     /*  223299 */     GIR_EraseRootFromParent_Done,
     /*  223300 */   // Label 4444: @223300
     /*  223300 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(223374), // Rule ID 8252 //
     /*  223305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  223319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223345 */     // MIs[1] Operand 1
     /*  223345 */     // No operand predicates
     /*  223345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223354 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223372 */     GIR_RootConstrainSelectedInstOperands,
     /*  223373 */     // GIR_Coverage, 8252,
     /*  223373 */     GIR_EraseRootFromParent_Done,
     /*  223374 */   // Label 4445: @223374
     /*  223374 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(223448), // Rule ID 8253 //
     /*  223379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  223393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223419 */     // MIs[1] Operand 1
     /*  223419 */     // No operand predicates
     /*  223419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223428 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223446 */     GIR_RootConstrainSelectedInstOperands,
     /*  223447 */     // GIR_Coverage, 8253,
     /*  223447 */     GIR_EraseRootFromParent_Done,
     /*  223448 */   // Label 4446: @223448
     /*  223448 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(223522), // Rule ID 8256 //
     /*  223453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  223467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223493 */     // MIs[1] Operand 1
     /*  223493 */     // No operand predicates
     /*  223493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223502 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  223502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223520 */     GIR_RootConstrainSelectedInstOperands,
     /*  223521 */     // GIR_Coverage, 8256,
     /*  223521 */     GIR_EraseRootFromParent_Done,
     /*  223522 */   // Label 4447: @223522
     /*  223522 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(223596), // Rule ID 8257 //
     /*  223527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  223541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223567 */     // MIs[1] Operand 1
     /*  223567 */     // No operand predicates
     /*  223567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223576 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  223576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223594 */     GIR_RootConstrainSelectedInstOperands,
     /*  223595 */     // GIR_Coverage, 8257,
     /*  223595 */     GIR_EraseRootFromParent_Done,
     /*  223596 */   // Label 4448: @223596
     /*  223596 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(223670), // Rule ID 8260 //
     /*  223601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  223615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223641 */     // MIs[1] Operand 1
     /*  223641 */     // No operand predicates
     /*  223641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223650 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  223650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223668 */     GIR_RootConstrainSelectedInstOperands,
     /*  223669 */     // GIR_Coverage, 8260,
     /*  223669 */     GIR_EraseRootFromParent_Done,
     /*  223670 */   // Label 4449: @223670
     /*  223670 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(223744), // Rule ID 8261 //
     /*  223675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  223689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223715 */     // MIs[1] Operand 1
     /*  223715 */     // No operand predicates
     /*  223715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223724 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  223724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223742 */     GIR_RootConstrainSelectedInstOperands,
     /*  223743 */     // GIR_Coverage, 8261,
     /*  223743 */     GIR_EraseRootFromParent_Done,
     /*  223744 */   // Label 4450: @223744
     /*  223744 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(223818), // Rule ID 8264 //
     /*  223749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  223763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223789 */     // MIs[1] Operand 1
     /*  223789 */     // No operand predicates
     /*  223789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223798 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  223798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223816 */     GIR_RootConstrainSelectedInstOperands,
     /*  223817 */     // GIR_Coverage, 8264,
     /*  223817 */     GIR_EraseRootFromParent_Done,
     /*  223818 */   // Label 4451: @223818
     /*  223818 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(223892), // Rule ID 8265 //
     /*  223823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  223837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223863 */     // MIs[1] Operand 1
     /*  223863 */     // No operand predicates
     /*  223863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223872 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  223872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223890 */     GIR_RootConstrainSelectedInstOperands,
     /*  223891 */     // GIR_Coverage, 8265,
     /*  223891 */     GIR_EraseRootFromParent_Done,
     /*  223892 */   // Label 4452: @223892
     /*  223892 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(223966), // Rule ID 8268 //
     /*  223897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  223911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223937 */     // MIs[1] Operand 1
     /*  223937 */     // No operand predicates
     /*  223937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223946 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  223949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223964 */     GIR_RootConstrainSelectedInstOperands,
     /*  223965 */     // GIR_Coverage, 8268,
     /*  223965 */     GIR_EraseRootFromParent_Done,
     /*  223966 */   // Label 4453: @223966
     /*  223966 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(224040), // Rule ID 8269 //
     /*  223971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  223985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224011 */     // MIs[1] Operand 1
     /*  224011 */     // No operand predicates
     /*  224011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224020 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224038 */     GIR_RootConstrainSelectedInstOperands,
     /*  224039 */     // GIR_Coverage, 8269,
     /*  224039 */     GIR_EraseRootFromParent_Done,
     /*  224040 */   // Label 4454: @224040
     /*  224040 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(224114), // Rule ID 8272 //
     /*  224045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224085 */     // MIs[1] Operand 1
     /*  224085 */     // No operand predicates
     /*  224085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224094 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224112 */     GIR_RootConstrainSelectedInstOperands,
     /*  224113 */     // GIR_Coverage, 8272,
     /*  224113 */     GIR_EraseRootFromParent_Done,
     /*  224114 */   // Label 4455: @224114
     /*  224114 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(224188), // Rule ID 8273 //
     /*  224119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224159 */     // MIs[1] Operand 1
     /*  224159 */     // No operand predicates
     /*  224159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224168 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224186 */     GIR_RootConstrainSelectedInstOperands,
     /*  224187 */     // GIR_Coverage, 8273,
     /*  224187 */     GIR_EraseRootFromParent_Done,
     /*  224188 */   // Label 4456: @224188
     /*  224188 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(224262), // Rule ID 8276 //
     /*  224193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  224207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224233 */     // MIs[1] Operand 1
     /*  224233 */     // No operand predicates
     /*  224233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224242 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  224242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224260 */     GIR_RootConstrainSelectedInstOperands,
     /*  224261 */     // GIR_Coverage, 8276,
     /*  224261 */     GIR_EraseRootFromParent_Done,
     /*  224262 */   // Label 4457: @224262
     /*  224262 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(224336), // Rule ID 8277 //
     /*  224267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  224281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224307 */     // MIs[1] Operand 1
     /*  224307 */     // No operand predicates
     /*  224307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224316 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  224316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224334 */     GIR_RootConstrainSelectedInstOperands,
     /*  224335 */     // GIR_Coverage, 8277,
     /*  224335 */     GIR_EraseRootFromParent_Done,
     /*  224336 */   // Label 4458: @224336
     /*  224336 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(224410), // Rule ID 8280 //
     /*  224341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  224344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  224355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224381 */     // MIs[1] Operand 1
     /*  224381 */     // No operand predicates
     /*  224381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224390 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  224390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224408 */     GIR_RootConstrainSelectedInstOperands,
     /*  224409 */     // GIR_Coverage, 8280,
     /*  224409 */     GIR_EraseRootFromParent_Done,
     /*  224410 */   // Label 4459: @224410
     /*  224410 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(224484), // Rule ID 8281 //
     /*  224415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  224418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  224429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224455 */     // MIs[1] Operand 1
     /*  224455 */     // No operand predicates
     /*  224455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224464 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  224464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224482 */     GIR_RootConstrainSelectedInstOperands,
     /*  224483 */     // GIR_Coverage, 8281,
     /*  224483 */     GIR_EraseRootFromParent_Done,
     /*  224484 */   // Label 4460: @224484
     /*  224484 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(224558), // Rule ID 8284 //
     /*  224489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  224500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  224503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224529 */     // MIs[1] Operand 1
     /*  224529 */     // No operand predicates
     /*  224529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224538 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  224541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224556 */     GIR_RootConstrainSelectedInstOperands,
     /*  224557 */     // GIR_Coverage, 8284,
     /*  224557 */     GIR_EraseRootFromParent_Done,
     /*  224558 */   // Label 4461: @224558
     /*  224558 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(224632), // Rule ID 8285 //
     /*  224563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  224574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  224577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224603 */     // MIs[1] Operand 1
     /*  224603 */     // No operand predicates
     /*  224603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224612 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  224615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224630 */     GIR_RootConstrainSelectedInstOperands,
     /*  224631 */     // GIR_Coverage, 8285,
     /*  224631 */     GIR_EraseRootFromParent_Done,
     /*  224632 */   // Label 4462: @224632
     /*  224632 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(224706), // Rule ID 8288 //
     /*  224637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  224648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  224651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  224665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224677 */     // MIs[1] Operand 1
     /*  224677 */     // No operand predicates
     /*  224677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224686 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  224689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224704 */     GIR_RootConstrainSelectedInstOperands,
     /*  224705 */     // GIR_Coverage, 8288,
     /*  224705 */     GIR_EraseRootFromParent_Done,
     /*  224706 */   // Label 4463: @224706
     /*  224706 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(224780), // Rule ID 8289 //
     /*  224711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  224722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  224725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  224739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224751 */     // MIs[1] Operand 1
     /*  224751 */     // No operand predicates
     /*  224751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224760 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  224763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224778 */     GIR_RootConstrainSelectedInstOperands,
     /*  224779 */     // GIR_Coverage, 8289,
     /*  224779 */     GIR_EraseRootFromParent_Done,
     /*  224780 */   // Label 4464: @224780
     /*  224780 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(224854), // Rule ID 8292 //
     /*  224785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  224796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  224799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  224813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224825 */     // MIs[1] Operand 1
     /*  224825 */     // No operand predicates
     /*  224825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224834 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  224837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224852 */     GIR_RootConstrainSelectedInstOperands,
     /*  224853 */     // GIR_Coverage, 8292,
     /*  224853 */     GIR_EraseRootFromParent_Done,
     /*  224854 */   // Label 4465: @224854
     /*  224854 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(224928), // Rule ID 8293 //
     /*  224859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  224870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  224873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  224887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224899 */     // MIs[1] Operand 1
     /*  224899 */     // No operand predicates
     /*  224899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224908 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  224911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224926 */     GIR_RootConstrainSelectedInstOperands,
     /*  224927 */     // GIR_Coverage, 8293,
     /*  224927 */     GIR_EraseRootFromParent_Done,
     /*  224928 */   // Label 4466: @224928
     /*  224928 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(225002), // Rule ID 8296 //
     /*  224933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  224947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224973 */     // MIs[1] Operand 1
     /*  224973 */     // No operand predicates
     /*  224973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224982 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  224985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225000 */     GIR_RootConstrainSelectedInstOperands,
     /*  225001 */     // GIR_Coverage, 8296,
     /*  225001 */     GIR_EraseRootFromParent_Done,
     /*  225002 */   // Label 4467: @225002
     /*  225002 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(225076), // Rule ID 8297 //
     /*  225007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  225021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225047 */     // MIs[1] Operand 1
     /*  225047 */     // No operand predicates
     /*  225047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225056 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225074 */     GIR_RootConstrainSelectedInstOperands,
     /*  225075 */     // GIR_Coverage, 8297,
     /*  225075 */     GIR_EraseRootFromParent_Done,
     /*  225076 */   // Label 4468: @225076
     /*  225076 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(225150), // Rule ID 8300 //
     /*  225081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225121 */     // MIs[1] Operand 1
     /*  225121 */     // No operand predicates
     /*  225121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225130 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225148 */     GIR_RootConstrainSelectedInstOperands,
     /*  225149 */     // GIR_Coverage, 8300,
     /*  225149 */     GIR_EraseRootFromParent_Done,
     /*  225150 */   // Label 4469: @225150
     /*  225150 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(225224), // Rule ID 8301 //
     /*  225155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225195 */     // MIs[1] Operand 1
     /*  225195 */     // No operand predicates
     /*  225195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225204 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225222 */     GIR_RootConstrainSelectedInstOperands,
     /*  225223 */     // GIR_Coverage, 8301,
     /*  225223 */     GIR_EraseRootFromParent_Done,
     /*  225224 */   // Label 4470: @225224
     /*  225224 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(225298), // Rule ID 8304 //
     /*  225229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225269 */     // MIs[1] Operand 1
     /*  225269 */     // No operand predicates
     /*  225269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225278 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225296 */     GIR_RootConstrainSelectedInstOperands,
     /*  225297 */     // GIR_Coverage, 8304,
     /*  225297 */     GIR_EraseRootFromParent_Done,
     /*  225298 */   // Label 4471: @225298
     /*  225298 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(225372), // Rule ID 8305 //
     /*  225303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225343 */     // MIs[1] Operand 1
     /*  225343 */     // No operand predicates
     /*  225343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225352 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225370 */     GIR_RootConstrainSelectedInstOperands,
     /*  225371 */     // GIR_Coverage, 8305,
     /*  225371 */     GIR_EraseRootFromParent_Done,
     /*  225372 */   // Label 4472: @225372
     /*  225372 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(225446), // Rule ID 8308 //
     /*  225377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  225391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225417 */     // MIs[1] Operand 1
     /*  225417 */     // No operand predicates
     /*  225417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225426 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225444 */     GIR_RootConstrainSelectedInstOperands,
     /*  225445 */     // GIR_Coverage, 8308,
     /*  225445 */     GIR_EraseRootFromParent_Done,
     /*  225446 */   // Label 4473: @225446
     /*  225446 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(225520), // Rule ID 8309 //
     /*  225451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  225465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225491 */     // MIs[1] Operand 1
     /*  225491 */     // No operand predicates
     /*  225491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225500 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225518 */     GIR_RootConstrainSelectedInstOperands,
     /*  225519 */     // GIR_Coverage, 8309,
     /*  225519 */     GIR_EraseRootFromParent_Done,
     /*  225520 */   // Label 4474: @225520
     /*  225520 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(225594), // Rule ID 8312 //
     /*  225525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  225539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225565 */     // MIs[1] Operand 1
     /*  225565 */     // No operand predicates
     /*  225565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225574 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225592 */     GIR_RootConstrainSelectedInstOperands,
     /*  225593 */     // GIR_Coverage, 8312,
     /*  225593 */     GIR_EraseRootFromParent_Done,
     /*  225594 */   // Label 4475: @225594
     /*  225594 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(225668), // Rule ID 8313 //
     /*  225599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  225613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225639 */     // MIs[1] Operand 1
     /*  225639 */     // No operand predicates
     /*  225639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225648 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225666 */     GIR_RootConstrainSelectedInstOperands,
     /*  225667 */     // GIR_Coverage, 8313,
     /*  225667 */     GIR_EraseRootFromParent_Done,
     /*  225668 */   // Label 4476: @225668
     /*  225668 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(225742), // Rule ID 8316 //
     /*  225673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  225687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225713 */     // MIs[1] Operand 1
     /*  225713 */     // No operand predicates
     /*  225713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225722 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225740 */     GIR_RootConstrainSelectedInstOperands,
     /*  225741 */     // GIR_Coverage, 8316,
     /*  225741 */     GIR_EraseRootFromParent_Done,
     /*  225742 */   // Label 4477: @225742
     /*  225742 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(225816), // Rule ID 8317 //
     /*  225747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  225761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225787 */     // MIs[1] Operand 1
     /*  225787 */     // No operand predicates
     /*  225787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225796 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225814 */     GIR_RootConstrainSelectedInstOperands,
     /*  225815 */     // GIR_Coverage, 8317,
     /*  225815 */     GIR_EraseRootFromParent_Done,
     /*  225816 */   // Label 4478: @225816
     /*  225816 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(225890), // Rule ID 8320 //
     /*  225821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  225824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  225832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  225835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225861 */     // MIs[1] Operand 1
     /*  225861 */     // No operand predicates
     /*  225861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225870 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  225870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225888 */     GIR_RootConstrainSelectedInstOperands,
     /*  225889 */     // GIR_Coverage, 8320,
     /*  225889 */     GIR_EraseRootFromParent_Done,
     /*  225890 */   // Label 4479: @225890
     /*  225890 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(225964), // Rule ID 8321 //
     /*  225895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  225898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  225906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  225909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225935 */     // MIs[1] Operand 1
     /*  225935 */     // No operand predicates
     /*  225935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225944 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  225944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225962 */     GIR_RootConstrainSelectedInstOperands,
     /*  225963 */     // GIR_Coverage, 8321,
     /*  225963 */     GIR_EraseRootFromParent_Done,
     /*  225964 */   // Label 4480: @225964
     /*  225964 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(226038), // Rule ID 8324 //
     /*  225969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  225972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  225983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226009 */     // MIs[1] Operand 1
     /*  226009 */     // No operand predicates
     /*  226009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226018 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  226021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226036 */     GIR_RootConstrainSelectedInstOperands,
     /*  226037 */     // GIR_Coverage, 8324,
     /*  226037 */     GIR_EraseRootFromParent_Done,
     /*  226038 */   // Label 4481: @226038
     /*  226038 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(226112), // Rule ID 8325 //
     /*  226043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  226057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226083 */     // MIs[1] Operand 1
     /*  226083 */     // No operand predicates
     /*  226083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226092 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  226095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226110 */     GIR_RootConstrainSelectedInstOperands,
     /*  226111 */     // GIR_Coverage, 8325,
     /*  226111 */     GIR_EraseRootFromParent_Done,
     /*  226112 */   // Label 4482: @226112
     /*  226112 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(226186), // Rule ID 8328 //
     /*  226117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226157 */     // MIs[1] Operand 1
     /*  226157 */     // No operand predicates
     /*  226157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226166 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  226169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226184 */     GIR_RootConstrainSelectedInstOperands,
     /*  226185 */     // GIR_Coverage, 8328,
     /*  226185 */     GIR_EraseRootFromParent_Done,
     /*  226186 */   // Label 4483: @226186
     /*  226186 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(226260), // Rule ID 8329 //
     /*  226191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226231 */     // MIs[1] Operand 1
     /*  226231 */     // No operand predicates
     /*  226231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226240 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  226243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226258 */     GIR_RootConstrainSelectedInstOperands,
     /*  226259 */     // GIR_Coverage, 8329,
     /*  226259 */     GIR_EraseRootFromParent_Done,
     /*  226260 */   // Label 4484: @226260
     /*  226260 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(226334), // Rule ID 8860 //
     /*  226265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  226279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226305 */     // MIs[1] Operand 1
     /*  226305 */     // No operand predicates
     /*  226305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226314 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  226317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226332 */     GIR_RootConstrainSelectedInstOperands,
     /*  226333 */     // GIR_Coverage, 8860,
     /*  226333 */     GIR_EraseRootFromParent_Done,
     /*  226334 */   // Label 4485: @226334
     /*  226334 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(226408), // Rule ID 8861 //
     /*  226339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  226353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226379 */     // MIs[1] Operand 1
     /*  226379 */     // No operand predicates
     /*  226379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226388 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  226391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226406 */     GIR_RootConstrainSelectedInstOperands,
     /*  226407 */     // GIR_Coverage, 8861,
     /*  226407 */     GIR_EraseRootFromParent_Done,
     /*  226408 */   // Label 4486: @226408
     /*  226408 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(226482), // Rule ID 8864 //
     /*  226413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  226427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226453 */     // MIs[1] Operand 1
     /*  226453 */     // No operand predicates
     /*  226453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226462 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226480 */     GIR_RootConstrainSelectedInstOperands,
     /*  226481 */     // GIR_Coverage, 8864,
     /*  226481 */     GIR_EraseRootFromParent_Done,
     /*  226482 */   // Label 4487: @226482
     /*  226482 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(226556), // Rule ID 8865 //
     /*  226487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  226501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226527 */     // MIs[1] Operand 1
     /*  226527 */     // No operand predicates
     /*  226527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226536 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226554 */     GIR_RootConstrainSelectedInstOperands,
     /*  226555 */     // GIR_Coverage, 8865,
     /*  226555 */     GIR_EraseRootFromParent_Done,
     /*  226556 */   // Label 4488: @226556
     /*  226556 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(226630), // Rule ID 8868 //
     /*  226561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  226575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226601 */     // MIs[1] Operand 1
     /*  226601 */     // No operand predicates
     /*  226601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226628 */     GIR_RootConstrainSelectedInstOperands,
     /*  226629 */     // GIR_Coverage, 8868,
     /*  226629 */     GIR_EraseRootFromParent_Done,
     /*  226630 */   // Label 4489: @226630
     /*  226630 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(226704), // Rule ID 8869 //
     /*  226635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  226649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226675 */     // MIs[1] Operand 1
     /*  226675 */     // No operand predicates
     /*  226675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226684 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226702 */     GIR_RootConstrainSelectedInstOperands,
     /*  226703 */     // GIR_Coverage, 8869,
     /*  226703 */     GIR_EraseRootFromParent_Done,
     /*  226704 */   // Label 4490: @226704
     /*  226704 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(226778), // Rule ID 8872 //
     /*  226709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  226723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226749 */     // MIs[1] Operand 1
     /*  226749 */     // No operand predicates
     /*  226749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226758 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  226758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226776 */     GIR_RootConstrainSelectedInstOperands,
     /*  226777 */     // GIR_Coverage, 8872,
     /*  226777 */     GIR_EraseRootFromParent_Done,
     /*  226778 */   // Label 4491: @226778
     /*  226778 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(226852), // Rule ID 8873 //
     /*  226783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  226797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226823 */     // MIs[1] Operand 1
     /*  226823 */     // No operand predicates
     /*  226823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226832 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  226832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226850 */     GIR_RootConstrainSelectedInstOperands,
     /*  226851 */     // GIR_Coverage, 8873,
     /*  226851 */     GIR_EraseRootFromParent_Done,
     /*  226852 */   // Label 4492: @226852
     /*  226852 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(226926), // Rule ID 8876 //
     /*  226857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  226871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226897 */     // MIs[1] Operand 1
     /*  226897 */     // No operand predicates
     /*  226897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226906 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  226906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226924 */     GIR_RootConstrainSelectedInstOperands,
     /*  226925 */     // GIR_Coverage, 8876,
     /*  226925 */     GIR_EraseRootFromParent_Done,
     /*  226926 */   // Label 4493: @226926
     /*  226926 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(227000), // Rule ID 8877 //
     /*  226931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  226945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226971 */     // MIs[1] Operand 1
     /*  226971 */     // No operand predicates
     /*  226971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226980 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  226980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226998 */     GIR_RootConstrainSelectedInstOperands,
     /*  226999 */     // GIR_Coverage, 8877,
     /*  226999 */     GIR_EraseRootFromParent_Done,
     /*  227000 */   // Label 4494: @227000
     /*  227000 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(227074), // Rule ID 8880 //
     /*  227005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  227019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227045 */     // MIs[1] Operand 1
     /*  227045 */     // No operand predicates
     /*  227045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227054 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  227054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227072 */     GIR_RootConstrainSelectedInstOperands,
     /*  227073 */     // GIR_Coverage, 8880,
     /*  227073 */     GIR_EraseRootFromParent_Done,
     /*  227074 */   // Label 4495: @227074
     /*  227074 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(227148), // Rule ID 8881 //
     /*  227079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  227093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227119 */     // MIs[1] Operand 1
     /*  227119 */     // No operand predicates
     /*  227119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227128 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  227128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227146 */     GIR_RootConstrainSelectedInstOperands,
     /*  227147 */     // GIR_Coverage, 8881,
     /*  227147 */     GIR_EraseRootFromParent_Done,
     /*  227148 */   // Label 4496: @227148
     /*  227148 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(227222), // Rule ID 8884 //
     /*  227153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  227167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227193 */     // MIs[1] Operand 1
     /*  227193 */     // No operand predicates
     /*  227193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227202 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227220 */     GIR_RootConstrainSelectedInstOperands,
     /*  227221 */     // GIR_Coverage, 8884,
     /*  227221 */     GIR_EraseRootFromParent_Done,
     /*  227222 */   // Label 4497: @227222
     /*  227222 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(227296), // Rule ID 8885 //
     /*  227227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  227241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227267 */     // MIs[1] Operand 1
     /*  227267 */     // No operand predicates
     /*  227267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227276 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227294 */     GIR_RootConstrainSelectedInstOperands,
     /*  227295 */     // GIR_Coverage, 8885,
     /*  227295 */     GIR_EraseRootFromParent_Done,
     /*  227296 */   // Label 4498: @227296
     /*  227296 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(227370), // Rule ID 8888 //
     /*  227301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  227315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227341 */     // MIs[1] Operand 1
     /*  227341 */     // No operand predicates
     /*  227341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227350 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227368 */     GIR_RootConstrainSelectedInstOperands,
     /*  227369 */     // GIR_Coverage, 8888,
     /*  227369 */     GIR_EraseRootFromParent_Done,
     /*  227370 */   // Label 4499: @227370
     /*  227370 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(227444), // Rule ID 8889 //
     /*  227375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  227389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227415 */     // MIs[1] Operand 1
     /*  227415 */     // No operand predicates
     /*  227415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227424 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227442 */     GIR_RootConstrainSelectedInstOperands,
     /*  227443 */     // GIR_Coverage, 8889,
     /*  227443 */     GIR_EraseRootFromParent_Done,
     /*  227444 */   // Label 4500: @227444
     /*  227444 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(227518), // Rule ID 8892 //
     /*  227449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  227463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227489 */     // MIs[1] Operand 1
     /*  227489 */     // No operand predicates
     /*  227489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227498 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  227498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227516 */     GIR_RootConstrainSelectedInstOperands,
     /*  227517 */     // GIR_Coverage, 8892,
     /*  227517 */     GIR_EraseRootFromParent_Done,
     /*  227518 */   // Label 4501: @227518
     /*  227518 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(227592), // Rule ID 8893 //
     /*  227523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  227537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227563 */     // MIs[1] Operand 1
     /*  227563 */     // No operand predicates
     /*  227563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227572 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  227572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227590 */     GIR_RootConstrainSelectedInstOperands,
     /*  227591 */     // GIR_Coverage, 8893,
     /*  227591 */     GIR_EraseRootFromParent_Done,
     /*  227592 */   // Label 4502: @227592
     /*  227592 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(227666), // Rule ID 8896 //
     /*  227597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  227600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  227611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227637 */     // MIs[1] Operand 1
     /*  227637 */     // No operand predicates
     /*  227637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227646 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  227646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  227664 */     GIR_RootConstrainSelectedInstOperands,
     /*  227665 */     // GIR_Coverage, 8896,
     /*  227665 */     GIR_EraseRootFromParent_Done,
     /*  227666 */   // Label 4503: @227666
     /*  227666 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(227740), // Rule ID 8897 //
     /*  227671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  227674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  227685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227711 */     // MIs[1] Operand 1
     /*  227711 */     // No operand predicates
     /*  227711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227720 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  227720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  227738 */     GIR_RootConstrainSelectedInstOperands,
     /*  227739 */     // GIR_Coverage, 8897,
     /*  227739 */     GIR_EraseRootFromParent_Done,
     /*  227740 */   // Label 4504: @227740
     /*  227740 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(227814), // Rule ID 8900 //
     /*  227745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  227756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  227759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227785 */     // MIs[1] Operand 1
     /*  227785 */     // No operand predicates
     /*  227785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227794 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  227797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227812 */     GIR_RootConstrainSelectedInstOperands,
     /*  227813 */     // GIR_Coverage, 8900,
     /*  227813 */     GIR_EraseRootFromParent_Done,
     /*  227814 */   // Label 4505: @227814
     /*  227814 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(227888), // Rule ID 8901 //
     /*  227819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  227830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  227833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227859 */     // MIs[1] Operand 1
     /*  227859 */     // No operand predicates
     /*  227859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227868 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  227871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227886 */     GIR_RootConstrainSelectedInstOperands,
     /*  227887 */     // GIR_Coverage, 8901,
     /*  227887 */     GIR_EraseRootFromParent_Done,
     /*  227888 */   // Label 4506: @227888
     /*  227888 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(227962), // Rule ID 8904 //
     /*  227893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  227904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  227907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  227921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227933 */     // MIs[1] Operand 1
     /*  227933 */     // No operand predicates
     /*  227933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227942 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  227945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227960 */     GIR_RootConstrainSelectedInstOperands,
     /*  227961 */     // GIR_Coverage, 8904,
     /*  227961 */     GIR_EraseRootFromParent_Done,
     /*  227962 */   // Label 4507: @227962
     /*  227962 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(228036), // Rule ID 8905 //
     /*  227967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  227978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  227981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  227995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228007 */     // MIs[1] Operand 1
     /*  228007 */     // No operand predicates
     /*  228007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228016 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228034 */     GIR_RootConstrainSelectedInstOperands,
     /*  228035 */     // GIR_Coverage, 8905,
     /*  228035 */     GIR_EraseRootFromParent_Done,
     /*  228036 */   // Label 4508: @228036
     /*  228036 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(228110), // Rule ID 8908 //
     /*  228041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  228052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  228055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228081 */     // MIs[1] Operand 1
     /*  228081 */     // No operand predicates
     /*  228081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228090 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228108 */     GIR_RootConstrainSelectedInstOperands,
     /*  228109 */     // GIR_Coverage, 8908,
     /*  228109 */     GIR_EraseRootFromParent_Done,
     /*  228110 */   // Label 4509: @228110
     /*  228110 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(228184), // Rule ID 8909 //
     /*  228115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  228126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  228129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228155 */     // MIs[1] Operand 1
     /*  228155 */     // No operand predicates
     /*  228155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228164 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228182 */     GIR_RootConstrainSelectedInstOperands,
     /*  228183 */     // GIR_Coverage, 8909,
     /*  228183 */     GIR_EraseRootFromParent_Done,
     /*  228184 */   // Label 4510: @228184
     /*  228184 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(228258), // Rule ID 8912 //
     /*  228189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  228203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228229 */     // MIs[1] Operand 1
     /*  228229 */     // No operand predicates
     /*  228229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228238 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228256 */     GIR_RootConstrainSelectedInstOperands,
     /*  228257 */     // GIR_Coverage, 8912,
     /*  228257 */     GIR_EraseRootFromParent_Done,
     /*  228258 */   // Label 4511: @228258
     /*  228258 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(228332), // Rule ID 8913 //
     /*  228263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  228277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228303 */     // MIs[1] Operand 1
     /*  228303 */     // No operand predicates
     /*  228303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228312 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228330 */     GIR_RootConstrainSelectedInstOperands,
     /*  228331 */     // GIR_Coverage, 8913,
     /*  228331 */     GIR_EraseRootFromParent_Done,
     /*  228332 */   // Label 4512: @228332
     /*  228332 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(228406), // Rule ID 8916 //
     /*  228337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  228351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228377 */     // MIs[1] Operand 1
     /*  228377 */     // No operand predicates
     /*  228377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228386 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228404 */     GIR_RootConstrainSelectedInstOperands,
     /*  228405 */     // GIR_Coverage, 8916,
     /*  228405 */     GIR_EraseRootFromParent_Done,
     /*  228406 */   // Label 4513: @228406
     /*  228406 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(228480), // Rule ID 8917 //
     /*  228411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  228425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228451 */     // MIs[1] Operand 1
     /*  228451 */     // No operand predicates
     /*  228451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228460 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228478 */     GIR_RootConstrainSelectedInstOperands,
     /*  228479 */     // GIR_Coverage, 8917,
     /*  228479 */     GIR_EraseRootFromParent_Done,
     /*  228480 */   // Label 4514: @228480
     /*  228480 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(228554), // Rule ID 8920 //
     /*  228485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  228499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228525 */     // MIs[1] Operand 1
     /*  228525 */     // No operand predicates
     /*  228525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228534 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228552 */     GIR_RootConstrainSelectedInstOperands,
     /*  228553 */     // GIR_Coverage, 8920,
     /*  228553 */     GIR_EraseRootFromParent_Done,
     /*  228554 */   // Label 4515: @228554
     /*  228554 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(228628), // Rule ID 8921 //
     /*  228559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  228573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228599 */     // MIs[1] Operand 1
     /*  228599 */     // No operand predicates
     /*  228599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228608 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228626 */     GIR_RootConstrainSelectedInstOperands,
     /*  228627 */     // GIR_Coverage, 8921,
     /*  228627 */     GIR_EraseRootFromParent_Done,
     /*  228628 */   // Label 4516: @228628
     /*  228628 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(228702), // Rule ID 8924 //
     /*  228633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  228644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  228647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228673 */     // MIs[1] Operand 1
     /*  228673 */     // No operand predicates
     /*  228673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228682 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  228682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228700 */     GIR_RootConstrainSelectedInstOperands,
     /*  228701 */     // GIR_Coverage, 8924,
     /*  228701 */     GIR_EraseRootFromParent_Done,
     /*  228702 */   // Label 4517: @228702
     /*  228702 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(228776), // Rule ID 8925 //
     /*  228707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  228718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  228721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228747 */     // MIs[1] Operand 1
     /*  228747 */     // No operand predicates
     /*  228747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228756 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  228756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228774 */     GIR_RootConstrainSelectedInstOperands,
     /*  228775 */     // GIR_Coverage, 8925,
     /*  228775 */     GIR_EraseRootFromParent_Done,
     /*  228776 */   // Label 4518: @228776
     /*  228776 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(228850), // Rule ID 8928 //
     /*  228781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  228795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228821 */     // MIs[1] Operand 1
     /*  228821 */     // No operand predicates
     /*  228821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228830 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  228830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228848 */     GIR_RootConstrainSelectedInstOperands,
     /*  228849 */     // GIR_Coverage, 8928,
     /*  228849 */     GIR_EraseRootFromParent_Done,
     /*  228850 */   // Label 4519: @228850
     /*  228850 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(228924), // Rule ID 8929 //
     /*  228855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  228869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228895 */     // MIs[1] Operand 1
     /*  228895 */     // No operand predicates
     /*  228895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228904 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  228904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228922 */     GIR_RootConstrainSelectedInstOperands,
     /*  228923 */     // GIR_Coverage, 8929,
     /*  228923 */     GIR_EraseRootFromParent_Done,
     /*  228924 */   // Label 4520: @228924
     /*  228924 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(228998), // Rule ID 8932 //
     /*  228929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  228943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228969 */     // MIs[1] Operand 1
     /*  228969 */     // No operand predicates
     /*  228969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228978 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  228978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228996 */     GIR_RootConstrainSelectedInstOperands,
     /*  228997 */     // GIR_Coverage, 8932,
     /*  228997 */     GIR_EraseRootFromParent_Done,
     /*  228998 */   // Label 4521: @228998
     /*  228998 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(229072), // Rule ID 8933 //
     /*  229003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  229017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229043 */     // MIs[1] Operand 1
     /*  229043 */     // No operand predicates
     /*  229043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229052 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229070 */     GIR_RootConstrainSelectedInstOperands,
     /*  229071 */     // GIR_Coverage, 8933,
     /*  229071 */     GIR_EraseRootFromParent_Done,
     /*  229072 */   // Label 4522: @229072
     /*  229072 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(229146), // Rule ID 8936 //
     /*  229077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229117 */     // MIs[1] Operand 1
     /*  229117 */     // No operand predicates
     /*  229117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229126 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  229129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229144 */     GIR_RootConstrainSelectedInstOperands,
     /*  229145 */     // GIR_Coverage, 8936,
     /*  229145 */     GIR_EraseRootFromParent_Done,
     /*  229146 */   // Label 4523: @229146
     /*  229146 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(229220), // Rule ID 8937 //
     /*  229151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229191 */     // MIs[1] Operand 1
     /*  229191 */     // No operand predicates
     /*  229191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229200 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  229203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229218 */     GIR_RootConstrainSelectedInstOperands,
     /*  229219 */     // GIR_Coverage, 8937,
     /*  229219 */     GIR_EraseRootFromParent_Done,
     /*  229220 */   // Label 4524: @229220
     /*  229220 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(229294), // Rule ID 8940 //
     /*  229225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229265 */     // MIs[1] Operand 1
     /*  229265 */     // No operand predicates
     /*  229265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229274 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  229277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229292 */     GIR_RootConstrainSelectedInstOperands,
     /*  229293 */     // GIR_Coverage, 8940,
     /*  229293 */     GIR_EraseRootFromParent_Done,
     /*  229294 */   // Label 4525: @229294
     /*  229294 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(229368), // Rule ID 8941 //
     /*  229299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229339 */     // MIs[1] Operand 1
     /*  229339 */     // No operand predicates
     /*  229339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229348 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  229351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229366 */     GIR_RootConstrainSelectedInstOperands,
     /*  229367 */     // GIR_Coverage, 8941,
     /*  229367 */     GIR_EraseRootFromParent_Done,
     /*  229368 */   // Label 4526: @229368
     /*  229368 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(229442), // Rule ID 8944 //
     /*  229373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  229387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229413 */     // MIs[1] Operand 1
     /*  229413 */     // No operand predicates
     /*  229413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229422 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229440 */     GIR_RootConstrainSelectedInstOperands,
     /*  229441 */     // GIR_Coverage, 8944,
     /*  229441 */     GIR_EraseRootFromParent_Done,
     /*  229442 */   // Label 4527: @229442
     /*  229442 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(229516), // Rule ID 8945 //
     /*  229447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  229461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229487 */     // MIs[1] Operand 1
     /*  229487 */     // No operand predicates
     /*  229487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229496 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229514 */     GIR_RootConstrainSelectedInstOperands,
     /*  229515 */     // GIR_Coverage, 8945,
     /*  229515 */     GIR_EraseRootFromParent_Done,
     /*  229516 */   // Label 4528: @229516
     /*  229516 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(229590), // Rule ID 9124 //
     /*  229521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  229535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229561 */     // MIs[1] Operand 1
     /*  229561 */     // No operand predicates
     /*  229561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229570 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  229570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  229573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229588 */     GIR_RootConstrainSelectedInstOperands,
     /*  229589 */     // GIR_Coverage, 9124,
     /*  229589 */     GIR_EraseRootFromParent_Done,
     /*  229590 */   // Label 4529: @229590
     /*  229590 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(229664), // Rule ID 9125 //
     /*  229595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  229609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229635 */     // MIs[1] Operand 1
     /*  229635 */     // No operand predicates
     /*  229635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229644 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  229644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  229647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229662 */     GIR_RootConstrainSelectedInstOperands,
     /*  229663 */     // GIR_Coverage, 9125,
     /*  229663 */     GIR_EraseRootFromParent_Done,
     /*  229664 */   // Label 4530: @229664
     /*  229664 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(229738), // Rule ID 9128 //
     /*  229669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  229683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229709 */     // MIs[1] Operand 1
     /*  229709 */     // No operand predicates
     /*  229709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229718 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  229718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  229721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229736 */     GIR_RootConstrainSelectedInstOperands,
     /*  229737 */     // GIR_Coverage, 9128,
     /*  229737 */     GIR_EraseRootFromParent_Done,
     /*  229738 */   // Label 4531: @229738
     /*  229738 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(229812), // Rule ID 9129 //
     /*  229743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  229757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229783 */     // MIs[1] Operand 1
     /*  229783 */     // No operand predicates
     /*  229783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229792 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  229792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  229795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229810 */     GIR_RootConstrainSelectedInstOperands,
     /*  229811 */     // GIR_Coverage, 9129,
     /*  229811 */     GIR_EraseRootFromParent_Done,
     /*  229812 */   // Label 4532: @229812
     /*  229812 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(229886), // Rule ID 9132 //
     /*  229817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  229831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229857 */     // MIs[1] Operand 1
     /*  229857 */     // No operand predicates
     /*  229857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229866 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  229866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  229869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229884 */     GIR_RootConstrainSelectedInstOperands,
     /*  229885 */     // GIR_Coverage, 9132,
     /*  229885 */     GIR_EraseRootFromParent_Done,
     /*  229886 */   // Label 4533: @229886
     /*  229886 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(229960), // Rule ID 9133 //
     /*  229891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  229905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229931 */     // MIs[1] Operand 1
     /*  229931 */     // No operand predicates
     /*  229931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229940 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  229940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  229943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229958 */     GIR_RootConstrainSelectedInstOperands,
     /*  229959 */     // GIR_Coverage, 9133,
     /*  229959 */     GIR_EraseRootFromParent_Done,
     /*  229960 */   // Label 4534: @229960
     /*  229960 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(230034), // Rule ID 9136 //
     /*  229965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  229979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230005 */     // MIs[1] Operand 1
     /*  230005 */     // No operand predicates
     /*  230005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  230017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230032 */     GIR_RootConstrainSelectedInstOperands,
     /*  230033 */     // GIR_Coverage, 9136,
     /*  230033 */     GIR_EraseRootFromParent_Done,
     /*  230034 */   // Label 4535: @230034
     /*  230034 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(230108), // Rule ID 9137 //
     /*  230039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  230053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230079 */     // MIs[1] Operand 1
     /*  230079 */     // No operand predicates
     /*  230079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230088 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  230091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230106 */     GIR_RootConstrainSelectedInstOperands,
     /*  230107 */     // GIR_Coverage, 9137,
     /*  230107 */     GIR_EraseRootFromParent_Done,
     /*  230108 */   // Label 4536: @230108
     /*  230108 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(230182), // Rule ID 9140 //
     /*  230113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230153 */     // MIs[1] Operand 1
     /*  230153 */     // No operand predicates
     /*  230153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230162 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230180 */     GIR_RootConstrainSelectedInstOperands,
     /*  230181 */     // GIR_Coverage, 9140,
     /*  230181 */     GIR_EraseRootFromParent_Done,
     /*  230182 */   // Label 4537: @230182
     /*  230182 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(230256), // Rule ID 9141 //
     /*  230187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230227 */     // MIs[1] Operand 1
     /*  230227 */     // No operand predicates
     /*  230227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230236 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230254 */     GIR_RootConstrainSelectedInstOperands,
     /*  230255 */     // GIR_Coverage, 9141,
     /*  230255 */     GIR_EraseRootFromParent_Done,
     /*  230256 */   // Label 4538: @230256
     /*  230256 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(230330), // Rule ID 9144 //
     /*  230261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230301 */     // MIs[1] Operand 1
     /*  230301 */     // No operand predicates
     /*  230301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230310 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  230310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230328 */     GIR_RootConstrainSelectedInstOperands,
     /*  230329 */     // GIR_Coverage, 9144,
     /*  230329 */     GIR_EraseRootFromParent_Done,
     /*  230330 */   // Label 4539: @230330
     /*  230330 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(230404), // Rule ID 9145 //
     /*  230335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230375 */     // MIs[1] Operand 1
     /*  230375 */     // No operand predicates
     /*  230375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230384 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  230384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230402 */     GIR_RootConstrainSelectedInstOperands,
     /*  230403 */     // GIR_Coverage, 9145,
     /*  230403 */     GIR_EraseRootFromParent_Done,
     /*  230404 */   // Label 4540: @230404
     /*  230404 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(230478), // Rule ID 9148 //
     /*  230409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  230423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230449 */     // MIs[1] Operand 1
     /*  230449 */     // No operand predicates
     /*  230449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230458 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230476 */     GIR_RootConstrainSelectedInstOperands,
     /*  230477 */     // GIR_Coverage, 9148,
     /*  230477 */     GIR_EraseRootFromParent_Done,
     /*  230478 */   // Label 4541: @230478
     /*  230478 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(230552), // Rule ID 9149 //
     /*  230483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  230497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230523 */     // MIs[1] Operand 1
     /*  230523 */     // No operand predicates
     /*  230523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230532 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230550 */     GIR_RootConstrainSelectedInstOperands,
     /*  230551 */     // GIR_Coverage, 9149,
     /*  230551 */     GIR_EraseRootFromParent_Done,
     /*  230552 */   // Label 4542: @230552
     /*  230552 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(230626), // Rule ID 9152 //
     /*  230557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  230571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230597 */     // MIs[1] Operand 1
     /*  230597 */     // No operand predicates
     /*  230597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230606 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230624 */     GIR_RootConstrainSelectedInstOperands,
     /*  230625 */     // GIR_Coverage, 9152,
     /*  230625 */     GIR_EraseRootFromParent_Done,
     /*  230626 */   // Label 4543: @230626
     /*  230626 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(230700), // Rule ID 9153 //
     /*  230631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  230645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230671 */     // MIs[1] Operand 1
     /*  230671 */     // No operand predicates
     /*  230671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230698 */     GIR_RootConstrainSelectedInstOperands,
     /*  230699 */     // GIR_Coverage, 9153,
     /*  230699 */     GIR_EraseRootFromParent_Done,
     /*  230700 */   // Label 4544: @230700
     /*  230700 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(230774), // Rule ID 9156 //
     /*  230705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  230719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230745 */     // MIs[1] Operand 1
     /*  230745 */     // No operand predicates
     /*  230745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230754 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  230754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230772 */     GIR_RootConstrainSelectedInstOperands,
     /*  230773 */     // GIR_Coverage, 9156,
     /*  230773 */     GIR_EraseRootFromParent_Done,
     /*  230774 */   // Label 4545: @230774
     /*  230774 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(230848), // Rule ID 9157 //
     /*  230779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  230793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230819 */     // MIs[1] Operand 1
     /*  230819 */     // No operand predicates
     /*  230819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230828 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  230828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230846 */     GIR_RootConstrainSelectedInstOperands,
     /*  230847 */     // GIR_Coverage, 9157,
     /*  230847 */     GIR_EraseRootFromParent_Done,
     /*  230848 */   // Label 4546: @230848
     /*  230848 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(230922), // Rule ID 9160 //
     /*  230853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  230856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  230867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230893 */     // MIs[1] Operand 1
     /*  230893 */     // No operand predicates
     /*  230893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230902 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  230902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230920 */     GIR_RootConstrainSelectedInstOperands,
     /*  230921 */     // GIR_Coverage, 9160,
     /*  230921 */     GIR_EraseRootFromParent_Done,
     /*  230922 */   // Label 4547: @230922
     /*  230922 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(230996), // Rule ID 9161 //
     /*  230927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  230930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  230941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230967 */     // MIs[1] Operand 1
     /*  230967 */     // No operand predicates
     /*  230967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230976 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  230976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230994 */     GIR_RootConstrainSelectedInstOperands,
     /*  230995 */     // GIR_Coverage, 9161,
     /*  230995 */     GIR_EraseRootFromParent_Done,
     /*  230996 */   // Label 4548: @230996
     /*  230996 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(231070), // Rule ID 9164 //
     /*  231001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  231015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231041 */     // MIs[1] Operand 1
     /*  231041 */     // No operand predicates
     /*  231041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231050 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231068 */     GIR_RootConstrainSelectedInstOperands,
     /*  231069 */     // GIR_Coverage, 9164,
     /*  231069 */     GIR_EraseRootFromParent_Done,
     /*  231070 */   // Label 4549: @231070
     /*  231070 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(231144), // Rule ID 9165 //
     /*  231075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  231089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231115 */     // MIs[1] Operand 1
     /*  231115 */     // No operand predicates
     /*  231115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231124 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231142 */     GIR_RootConstrainSelectedInstOperands,
     /*  231143 */     // GIR_Coverage, 9165,
     /*  231143 */     GIR_EraseRootFromParent_Done,
     /*  231144 */   // Label 4550: @231144
     /*  231144 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(231218), // Rule ID 9168 //
     /*  231149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  231163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231189 */     // MIs[1] Operand 1
     /*  231189 */     // No operand predicates
     /*  231189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231198 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231216 */     GIR_RootConstrainSelectedInstOperands,
     /*  231217 */     // GIR_Coverage, 9168,
     /*  231217 */     GIR_EraseRootFromParent_Done,
     /*  231218 */   // Label 4551: @231218
     /*  231218 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(231292), // Rule ID 9169 //
     /*  231223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  231237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231263 */     // MIs[1] Operand 1
     /*  231263 */     // No operand predicates
     /*  231263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231272 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231290 */     GIR_RootConstrainSelectedInstOperands,
     /*  231291 */     // GIR_Coverage, 9169,
     /*  231291 */     GIR_EraseRootFromParent_Done,
     /*  231292 */   // Label 4552: @231292
     /*  231292 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(231366), // Rule ID 9172 //
     /*  231297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  231308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  231311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231337 */     // MIs[1] Operand 1
     /*  231337 */     // No operand predicates
     /*  231337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231346 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231364 */     GIR_RootConstrainSelectedInstOperands,
     /*  231365 */     // GIR_Coverage, 9172,
     /*  231365 */     GIR_EraseRootFromParent_Done,
     /*  231366 */   // Label 4553: @231366
     /*  231366 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(231440), // Rule ID 9173 //
     /*  231371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  231382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  231385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231411 */     // MIs[1] Operand 1
     /*  231411 */     // No operand predicates
     /*  231411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231420 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231438 */     GIR_RootConstrainSelectedInstOperands,
     /*  231439 */     // GIR_Coverage, 9173,
     /*  231439 */     GIR_EraseRootFromParent_Done,
     /*  231440 */   // Label 4554: @231440
     /*  231440 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(231514), // Rule ID 9176 //
     /*  231445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  231459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231485 */     // MIs[1] Operand 1
     /*  231485 */     // No operand predicates
     /*  231485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231494 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231512 */     GIR_RootConstrainSelectedInstOperands,
     /*  231513 */     // GIR_Coverage, 9176,
     /*  231513 */     GIR_EraseRootFromParent_Done,
     /*  231514 */   // Label 4555: @231514
     /*  231514 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(231588), // Rule ID 9177 //
     /*  231519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  231533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231559 */     // MIs[1] Operand 1
     /*  231559 */     // No operand predicates
     /*  231559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231568 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231586 */     GIR_RootConstrainSelectedInstOperands,
     /*  231587 */     // GIR_Coverage, 9177,
     /*  231587 */     GIR_EraseRootFromParent_Done,
     /*  231588 */   // Label 4556: @231588
     /*  231588 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(231662), // Rule ID 9180 //
     /*  231593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  231607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231633 */     // MIs[1] Operand 1
     /*  231633 */     // No operand predicates
     /*  231633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231642 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231660 */     GIR_RootConstrainSelectedInstOperands,
     /*  231661 */     // GIR_Coverage, 9180,
     /*  231661 */     GIR_EraseRootFromParent_Done,
     /*  231662 */   // Label 4557: @231662
     /*  231662 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(231736), // Rule ID 9181 //
     /*  231667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  231681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231707 */     // MIs[1] Operand 1
     /*  231707 */     // No operand predicates
     /*  231707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231716 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231734 */     GIR_RootConstrainSelectedInstOperands,
     /*  231735 */     // GIR_Coverage, 9181,
     /*  231735 */     GIR_EraseRootFromParent_Done,
     /*  231736 */   // Label 4558: @231736
     /*  231736 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(231810), // Rule ID 9184 //
     /*  231741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  231755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231781 */     // MIs[1] Operand 1
     /*  231781 */     // No operand predicates
     /*  231781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231790 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231808 */     GIR_RootConstrainSelectedInstOperands,
     /*  231809 */     // GIR_Coverage, 9184,
     /*  231809 */     GIR_EraseRootFromParent_Done,
     /*  231810 */   // Label 4559: @231810
     /*  231810 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(231884), // Rule ID 9185 //
     /*  231815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  231829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231855 */     // MIs[1] Operand 1
     /*  231855 */     // No operand predicates
     /*  231855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231864 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231882 */     GIR_RootConstrainSelectedInstOperands,
     /*  231883 */     // GIR_Coverage, 9185,
     /*  231883 */     GIR_EraseRootFromParent_Done,
     /*  231884 */   // Label 4560: @231884
     /*  231884 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(231958), // Rule ID 9188 //
     /*  231889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  231903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231929 */     // MIs[1] Operand 1
     /*  231929 */     // No operand predicates
     /*  231929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231938 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  231938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231956 */     GIR_RootConstrainSelectedInstOperands,
     /*  231957 */     // GIR_Coverage, 9188,
     /*  231957 */     GIR_EraseRootFromParent_Done,
     /*  231958 */   // Label 4561: @231958
     /*  231958 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(232032), // Rule ID 9189 //
     /*  231963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  231977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232003 */     // MIs[1] Operand 1
     /*  232003 */     // No operand predicates
     /*  232003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232012 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232030 */     GIR_RootConstrainSelectedInstOperands,
     /*  232031 */     // GIR_Coverage, 9189,
     /*  232031 */     GIR_EraseRootFromParent_Done,
     /*  232032 */   // Label 4562: @232032
     /*  232032 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(232106), // Rule ID 9192 //
     /*  232037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  232051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232077 */     // MIs[1] Operand 1
     /*  232077 */     // No operand predicates
     /*  232077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232086 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232104 */     GIR_RootConstrainSelectedInstOperands,
     /*  232105 */     // GIR_Coverage, 9192,
     /*  232105 */     GIR_EraseRootFromParent_Done,
     /*  232106 */   // Label 4563: @232106
     /*  232106 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(232180), // Rule ID 9193 //
     /*  232111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  232125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232151 */     // MIs[1] Operand 1
     /*  232151 */     // No operand predicates
     /*  232151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232160 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232178 */     GIR_RootConstrainSelectedInstOperands,
     /*  232179 */     // GIR_Coverage, 9193,
     /*  232179 */     GIR_EraseRootFromParent_Done,
     /*  232180 */   // Label 4564: @232180
     /*  232180 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(232254), // Rule ID 9196 //
     /*  232185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  232199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232225 */     // MIs[1] Operand 1
     /*  232225 */     // No operand predicates
     /*  232225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232234 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232252 */     GIR_RootConstrainSelectedInstOperands,
     /*  232253 */     // GIR_Coverage, 9196,
     /*  232253 */     GIR_EraseRootFromParent_Done,
     /*  232254 */   // Label 4565: @232254
     /*  232254 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(232328), // Rule ID 9197 //
     /*  232259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  232273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232299 */     // MIs[1] Operand 1
     /*  232299 */     // No operand predicates
     /*  232299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232308 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232326 */     GIR_RootConstrainSelectedInstOperands,
     /*  232327 */     // GIR_Coverage, 9197,
     /*  232327 */     GIR_EraseRootFromParent_Done,
     /*  232328 */   // Label 4566: @232328
     /*  232328 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(232402), // Rule ID 9200 //
     /*  232333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  232336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  232347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232373 */     // MIs[1] Operand 1
     /*  232373 */     // No operand predicates
     /*  232373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232382 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232400 */     GIR_RootConstrainSelectedInstOperands,
     /*  232401 */     // GIR_Coverage, 9200,
     /*  232401 */     GIR_EraseRootFromParent_Done,
     /*  232402 */   // Label 4567: @232402
     /*  232402 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(232476), // Rule ID 9201 //
     /*  232407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  232410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  232421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232447 */     // MIs[1] Operand 1
     /*  232447 */     // No operand predicates
     /*  232447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232456 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  232456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232474 */     GIR_RootConstrainSelectedInstOperands,
     /*  232475 */     // GIR_Coverage, 9201,
     /*  232475 */     GIR_EraseRootFromParent_Done,
     /*  232476 */   // Label 4568: @232476
     /*  232476 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(232550), // Rule ID 9204 //
     /*  232481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  232484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  232495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232521 */     // MIs[1] Operand 1
     /*  232521 */     // No operand predicates
     /*  232521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232530 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232548 */     GIR_RootConstrainSelectedInstOperands,
     /*  232549 */     // GIR_Coverage, 9204,
     /*  232549 */     GIR_EraseRootFromParent_Done,
     /*  232550 */   // Label 4569: @232550
     /*  232550 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(232624), // Rule ID 9205 //
     /*  232555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  232558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  232569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232595 */     // MIs[1] Operand 1
     /*  232595 */     // No operand predicates
     /*  232595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232604 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  232604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232622 */     GIR_RootConstrainSelectedInstOperands,
     /*  232623 */     // GIR_Coverage, 9205,
     /*  232623 */     GIR_EraseRootFromParent_Done,
     /*  232624 */   // Label 4570: @232624
     /*  232624 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(232698), // Rule ID 9208 //
     /*  232629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  232632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  232643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232669 */     // MIs[1] Operand 1
     /*  232669 */     // No operand predicates
     /*  232669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232678 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232696 */     GIR_RootConstrainSelectedInstOperands,
     /*  232697 */     // GIR_Coverage, 9208,
     /*  232697 */     GIR_EraseRootFromParent_Done,
     /*  232698 */   // Label 4571: @232698
     /*  232698 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(232772), // Rule ID 9209 //
     /*  232703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  232706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  232717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232743 */     // MIs[1] Operand 1
     /*  232743 */     // No operand predicates
     /*  232743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232752 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  232752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232770 */     GIR_RootConstrainSelectedInstOperands,
     /*  232771 */     // GIR_Coverage, 9209,
     /*  232771 */     GIR_EraseRootFromParent_Done,
     /*  232772 */   // Label 4572: @232772
     /*  232772 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(232846), // Rule ID 9300 //
     /*  232777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  232791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232817 */     // MIs[1] Operand 1
     /*  232817 */     // No operand predicates
     /*  232817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232826 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  232826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  232829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232844 */     GIR_RootConstrainSelectedInstOperands,
     /*  232845 */     // GIR_Coverage, 9300,
     /*  232845 */     GIR_EraseRootFromParent_Done,
     /*  232846 */   // Label 4573: @232846
     /*  232846 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(232920), // Rule ID 9301 //
     /*  232851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  232865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232891 */     // MIs[1] Operand 1
     /*  232891 */     // No operand predicates
     /*  232891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232900 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  232900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  232903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232918 */     GIR_RootConstrainSelectedInstOperands,
     /*  232919 */     // GIR_Coverage, 9301,
     /*  232919 */     GIR_EraseRootFromParent_Done,
     /*  232920 */   // Label 4574: @232920
     /*  232920 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(232994), // Rule ID 9304 //
     /*  232925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  232939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232965 */     // MIs[1] Operand 1
     /*  232965 */     // No operand predicates
     /*  232965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232974 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  232974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  232977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232992 */     GIR_RootConstrainSelectedInstOperands,
     /*  232993 */     // GIR_Coverage, 9304,
     /*  232993 */     GIR_EraseRootFromParent_Done,
     /*  232994 */   // Label 4575: @232994
     /*  232994 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(233068), // Rule ID 9305 //
     /*  232999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  233013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233039 */     // MIs[1] Operand 1
     /*  233039 */     // No operand predicates
     /*  233039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233048 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233066 */     GIR_RootConstrainSelectedInstOperands,
     /*  233067 */     // GIR_Coverage, 9305,
     /*  233067 */     GIR_EraseRootFromParent_Done,
     /*  233068 */   // Label 4576: @233068
     /*  233068 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(233142), // Rule ID 9308 //
     /*  233073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  233087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233113 */     // MIs[1] Operand 1
     /*  233113 */     // No operand predicates
     /*  233113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233122 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233140 */     GIR_RootConstrainSelectedInstOperands,
     /*  233141 */     // GIR_Coverage, 9308,
     /*  233141 */     GIR_EraseRootFromParent_Done,
     /*  233142 */   // Label 4577: @233142
     /*  233142 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(233216), // Rule ID 9309 //
     /*  233147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  233161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233187 */     // MIs[1] Operand 1
     /*  233187 */     // No operand predicates
     /*  233187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233196 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233214 */     GIR_RootConstrainSelectedInstOperands,
     /*  233215 */     // GIR_Coverage, 9309,
     /*  233215 */     GIR_EraseRootFromParent_Done,
     /*  233216 */   // Label 4578: @233216
     /*  233216 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(233290), // Rule ID 9312 //
     /*  233221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  233235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233261 */     // MIs[1] Operand 1
     /*  233261 */     // No operand predicates
     /*  233261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233270 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233288 */     GIR_RootConstrainSelectedInstOperands,
     /*  233289 */     // GIR_Coverage, 9312,
     /*  233289 */     GIR_EraseRootFromParent_Done,
     /*  233290 */   // Label 4579: @233290
     /*  233290 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(233364), // Rule ID 9313 //
     /*  233295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  233309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233335 */     // MIs[1] Operand 1
     /*  233335 */     // No operand predicates
     /*  233335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233344 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233362 */     GIR_RootConstrainSelectedInstOperands,
     /*  233363 */     // GIR_Coverage, 9313,
     /*  233363 */     GIR_EraseRootFromParent_Done,
     /*  233364 */   // Label 4580: @233364
     /*  233364 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(233438), // Rule ID 9316 //
     /*  233369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  233383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233409 */     // MIs[1] Operand 1
     /*  233409 */     // No operand predicates
     /*  233409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233418 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233436 */     GIR_RootConstrainSelectedInstOperands,
     /*  233437 */     // GIR_Coverage, 9316,
     /*  233437 */     GIR_EraseRootFromParent_Done,
     /*  233438 */   // Label 4581: @233438
     /*  233438 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(233512), // Rule ID 9317 //
     /*  233443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  233457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233483 */     // MIs[1] Operand 1
     /*  233483 */     // No operand predicates
     /*  233483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233492 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233510 */     GIR_RootConstrainSelectedInstOperands,
     /*  233511 */     // GIR_Coverage, 9317,
     /*  233511 */     GIR_EraseRootFromParent_Done,
     /*  233512 */   // Label 4582: @233512
     /*  233512 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(233586), // Rule ID 9320 //
     /*  233517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  233531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233557 */     // MIs[1] Operand 1
     /*  233557 */     // No operand predicates
     /*  233557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233566 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  233566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233584 */     GIR_RootConstrainSelectedInstOperands,
     /*  233585 */     // GIR_Coverage, 9320,
     /*  233585 */     GIR_EraseRootFromParent_Done,
     /*  233586 */   // Label 4583: @233586
     /*  233586 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(233660), // Rule ID 9321 //
     /*  233591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  233605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233631 */     // MIs[1] Operand 1
     /*  233631 */     // No operand predicates
     /*  233631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233640 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  233640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233658 */     GIR_RootConstrainSelectedInstOperands,
     /*  233659 */     // GIR_Coverage, 9321,
     /*  233659 */     GIR_EraseRootFromParent_Done,
     /*  233660 */   // Label 4584: @233660
     /*  233660 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(233734), // Rule ID 9324 //
     /*  233665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  233679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233705 */     // MIs[1] Operand 1
     /*  233705 */     // No operand predicates
     /*  233705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233714 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233732 */     GIR_RootConstrainSelectedInstOperands,
     /*  233733 */     // GIR_Coverage, 9324,
     /*  233733 */     GIR_EraseRootFromParent_Done,
     /*  233734 */   // Label 4585: @233734
     /*  233734 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(233808), // Rule ID 9325 //
     /*  233739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  233753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233779 */     // MIs[1] Operand 1
     /*  233779 */     // No operand predicates
     /*  233779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233788 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233806 */     GIR_RootConstrainSelectedInstOperands,
     /*  233807 */     // GIR_Coverage, 9325,
     /*  233807 */     GIR_EraseRootFromParent_Done,
     /*  233808 */   // Label 4586: @233808
     /*  233808 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(233882), // Rule ID 9328 //
     /*  233813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  233827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233853 */     // MIs[1] Operand 1
     /*  233853 */     // No operand predicates
     /*  233853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233862 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233880 */     GIR_RootConstrainSelectedInstOperands,
     /*  233881 */     // GIR_Coverage, 9328,
     /*  233881 */     GIR_EraseRootFromParent_Done,
     /*  233882 */   // Label 4587: @233882
     /*  233882 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(233956), // Rule ID 9329 //
     /*  233887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  233901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233927 */     // MIs[1] Operand 1
     /*  233927 */     // No operand predicates
     /*  233927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233936 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233954 */     GIR_RootConstrainSelectedInstOperands,
     /*  233955 */     // GIR_Coverage, 9329,
     /*  233955 */     GIR_EraseRootFromParent_Done,
     /*  233956 */   // Label 4588: @233956
     /*  233956 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(234030), // Rule ID 9332 //
     /*  233961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  233975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234001 */     // MIs[1] Operand 1
     /*  234001 */     // No operand predicates
     /*  234001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234010 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234028 */     GIR_RootConstrainSelectedInstOperands,
     /*  234029 */     // GIR_Coverage, 9332,
     /*  234029 */     GIR_EraseRootFromParent_Done,
     /*  234030 */   // Label 4589: @234030
     /*  234030 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(234104), // Rule ID 9333 //
     /*  234035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  234049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234075 */     // MIs[1] Operand 1
     /*  234075 */     // No operand predicates
     /*  234075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234084 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234102 */     GIR_RootConstrainSelectedInstOperands,
     /*  234103 */     // GIR_Coverage, 9333,
     /*  234103 */     GIR_EraseRootFromParent_Done,
     /*  234104 */   // Label 4590: @234104
     /*  234104 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(234178), // Rule ID 9336 //
     /*  234109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  234112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234149 */     // MIs[1] Operand 1
     /*  234149 */     // No operand predicates
     /*  234149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234158 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  234158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234176 */     GIR_RootConstrainSelectedInstOperands,
     /*  234177 */     // GIR_Coverage, 9336,
     /*  234177 */     GIR_EraseRootFromParent_Done,
     /*  234178 */   // Label 4591: @234178
     /*  234178 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(234252), // Rule ID 9337 //
     /*  234183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  234186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234223 */     // MIs[1] Operand 1
     /*  234223 */     // No operand predicates
     /*  234223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234232 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  234232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234250 */     GIR_RootConstrainSelectedInstOperands,
     /*  234251 */     // GIR_Coverage, 9337,
     /*  234251 */     GIR_EraseRootFromParent_Done,
     /*  234252 */   // Label 4592: @234252
     /*  234252 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(234326), // Rule ID 9340 //
     /*  234257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  234271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234297 */     // MIs[1] Operand 1
     /*  234297 */     // No operand predicates
     /*  234297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234306 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234324 */     GIR_RootConstrainSelectedInstOperands,
     /*  234325 */     // GIR_Coverage, 9340,
     /*  234325 */     GIR_EraseRootFromParent_Done,
     /*  234326 */   // Label 4593: @234326
     /*  234326 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(234400), // Rule ID 9341 //
     /*  234331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  234345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234371 */     // MIs[1] Operand 1
     /*  234371 */     // No operand predicates
     /*  234371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234380 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234398 */     GIR_RootConstrainSelectedInstOperands,
     /*  234399 */     // GIR_Coverage, 9341,
     /*  234399 */     GIR_EraseRootFromParent_Done,
     /*  234400 */   // Label 4594: @234400
     /*  234400 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(234474), // Rule ID 9344 //
     /*  234405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  234419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234445 */     // MIs[1] Operand 1
     /*  234445 */     // No operand predicates
     /*  234445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234454 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234472 */     GIR_RootConstrainSelectedInstOperands,
     /*  234473 */     // GIR_Coverage, 9344,
     /*  234473 */     GIR_EraseRootFromParent_Done,
     /*  234474 */   // Label 4595: @234474
     /*  234474 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(234548), // Rule ID 9345 //
     /*  234479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  234493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234519 */     // MIs[1] Operand 1
     /*  234519 */     // No operand predicates
     /*  234519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234528 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234546 */     GIR_RootConstrainSelectedInstOperands,
     /*  234547 */     // GIR_Coverage, 9345,
     /*  234547 */     GIR_EraseRootFromParent_Done,
     /*  234548 */   // Label 4596: @234548
     /*  234548 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(234622), // Rule ID 9348 //
     /*  234553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  234564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  234567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  234581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234593 */     // MIs[1] Operand 1
     /*  234593 */     // No operand predicates
     /*  234593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234602 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  234605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234620 */     GIR_RootConstrainSelectedInstOperands,
     /*  234621 */     // GIR_Coverage, 9348,
     /*  234621 */     GIR_EraseRootFromParent_Done,
     /*  234622 */   // Label 4597: @234622
     /*  234622 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(234696), // Rule ID 9349 //
     /*  234627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  234638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  234641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  234655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234667 */     // MIs[1] Operand 1
     /*  234667 */     // No operand predicates
     /*  234667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234676 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  234679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234694 */     GIR_RootConstrainSelectedInstOperands,
     /*  234695 */     // GIR_Coverage, 9349,
     /*  234695 */     GIR_EraseRootFromParent_Done,
     /*  234696 */   // Label 4598: @234696
     /*  234696 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(234770), // Rule ID 9352 //
     /*  234701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  234715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234741 */     // MIs[1] Operand 1
     /*  234741 */     // No operand predicates
     /*  234741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234750 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234768 */     GIR_RootConstrainSelectedInstOperands,
     /*  234769 */     // GIR_Coverage, 9352,
     /*  234769 */     GIR_EraseRootFromParent_Done,
     /*  234770 */   // Label 4599: @234770
     /*  234770 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(234844), // Rule ID 9353 //
     /*  234775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  234789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234815 */     // MIs[1] Operand 1
     /*  234815 */     // No operand predicates
     /*  234815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234824 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234842 */     GIR_RootConstrainSelectedInstOperands,
     /*  234843 */     // GIR_Coverage, 9353,
     /*  234843 */     GIR_EraseRootFromParent_Done,
     /*  234844 */   // Label 4600: @234844
     /*  234844 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(234918), // Rule ID 9356 //
     /*  234849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  234863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234889 */     // MIs[1] Operand 1
     /*  234889 */     // No operand predicates
     /*  234889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234898 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234916 */     GIR_RootConstrainSelectedInstOperands,
     /*  234917 */     // GIR_Coverage, 9356,
     /*  234917 */     GIR_EraseRootFromParent_Done,
     /*  234918 */   // Label 4601: @234918
     /*  234918 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(234992), // Rule ID 9357 //
     /*  234923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  234937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234963 */     // MIs[1] Operand 1
     /*  234963 */     // No operand predicates
     /*  234963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234972 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234990 */     GIR_RootConstrainSelectedInstOperands,
     /*  234991 */     // GIR_Coverage, 9357,
     /*  234991 */     GIR_EraseRootFromParent_Done,
     /*  234992 */   // Label 4602: @234992
     /*  234992 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(235066), // Rule ID 9360 //
     /*  234997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  235011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235037 */     // MIs[1] Operand 1
     /*  235037 */     // No operand predicates
     /*  235037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235046 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235064 */     GIR_RootConstrainSelectedInstOperands,
     /*  235065 */     // GIR_Coverage, 9360,
     /*  235065 */     GIR_EraseRootFromParent_Done,
     /*  235066 */   // Label 4603: @235066
     /*  235066 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(235140), // Rule ID 9361 //
     /*  235071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  235085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235111 */     // MIs[1] Operand 1
     /*  235111 */     // No operand predicates
     /*  235111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235120 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235138 */     GIR_RootConstrainSelectedInstOperands,
     /*  235139 */     // GIR_Coverage, 9361,
     /*  235139 */     GIR_EraseRootFromParent_Done,
     /*  235140 */   // Label 4604: @235140
     /*  235140 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(235214), // Rule ID 9364 //
     /*  235145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235185 */     // MIs[1] Operand 1
     /*  235185 */     // No operand predicates
     /*  235185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235194 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235212 */     GIR_RootConstrainSelectedInstOperands,
     /*  235213 */     // GIR_Coverage, 9364,
     /*  235213 */     GIR_EraseRootFromParent_Done,
     /*  235214 */   // Label 4605: @235214
     /*  235214 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(235288), // Rule ID 9365 //
     /*  235219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235259 */     // MIs[1] Operand 1
     /*  235259 */     // No operand predicates
     /*  235259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235268 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235286 */     GIR_RootConstrainSelectedInstOperands,
     /*  235287 */     // GIR_Coverage, 9365,
     /*  235287 */     GIR_EraseRootFromParent_Done,
     /*  235288 */   // Label 4606: @235288
     /*  235288 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(235362), // Rule ID 9368 //
     /*  235293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235333 */     // MIs[1] Operand 1
     /*  235333 */     // No operand predicates
     /*  235333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235342 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235360 */     GIR_RootConstrainSelectedInstOperands,
     /*  235361 */     // GIR_Coverage, 9368,
     /*  235361 */     GIR_EraseRootFromParent_Done,
     /*  235362 */   // Label 4607: @235362
     /*  235362 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(235436), // Rule ID 9369 //
     /*  235367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235407 */     // MIs[1] Operand 1
     /*  235407 */     // No operand predicates
     /*  235407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235416 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235434 */     GIR_RootConstrainSelectedInstOperands,
     /*  235435 */     // GIR_Coverage, 9369,
     /*  235435 */     GIR_EraseRootFromParent_Done,
     /*  235436 */   // Label 4608: @235436
     /*  235436 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(235510), // Rule ID 9372 //
     /*  235441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  235455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235481 */     // MIs[1] Operand 1
     /*  235481 */     // No operand predicates
     /*  235481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235490 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235508 */     GIR_RootConstrainSelectedInstOperands,
     /*  235509 */     // GIR_Coverage, 9372,
     /*  235509 */     GIR_EraseRootFromParent_Done,
     /*  235510 */   // Label 4609: @235510
     /*  235510 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(235584), // Rule ID 9373 //
     /*  235515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  235529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235555 */     // MIs[1] Operand 1
     /*  235555 */     // No operand predicates
     /*  235555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235564 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235582 */     GIR_RootConstrainSelectedInstOperands,
     /*  235583 */     // GIR_Coverage, 9373,
     /*  235583 */     GIR_EraseRootFromParent_Done,
     /*  235584 */   // Label 4610: @235584
     /*  235584 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(235658), // Rule ID 9376 //
     /*  235589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  235592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  235600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  235603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235629 */     // MIs[1] Operand 1
     /*  235629 */     // No operand predicates
     /*  235629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235638 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  235638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235656 */     GIR_RootConstrainSelectedInstOperands,
     /*  235657 */     // GIR_Coverage, 9376,
     /*  235657 */     GIR_EraseRootFromParent_Done,
     /*  235658 */   // Label 4611: @235658
     /*  235658 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(235732), // Rule ID 9377 //
     /*  235663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  235666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  235674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  235677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235703 */     // MIs[1] Operand 1
     /*  235703 */     // No operand predicates
     /*  235703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235712 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  235712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235730 */     GIR_RootConstrainSelectedInstOperands,
     /*  235731 */     // GIR_Coverage, 9377,
     /*  235731 */     GIR_EraseRootFromParent_Done,
     /*  235732 */   // Label 4612: @235732
     /*  235732 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(235806), // Rule ID 9380 //
     /*  235737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  235740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  235751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235777 */     // MIs[1] Operand 1
     /*  235777 */     // No operand predicates
     /*  235777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235786 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  235786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235804 */     GIR_RootConstrainSelectedInstOperands,
     /*  235805 */     // GIR_Coverage, 9380,
     /*  235805 */     GIR_EraseRootFromParent_Done,
     /*  235806 */   // Label 4613: @235806
     /*  235806 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(235880), // Rule ID 9381 //
     /*  235811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  235814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  235825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235851 */     // MIs[1] Operand 1
     /*  235851 */     // No operand predicates
     /*  235851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235860 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  235860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235878 */     GIR_RootConstrainSelectedInstOperands,
     /*  235879 */     // GIR_Coverage, 9381,
     /*  235879 */     GIR_EraseRootFromParent_Done,
     /*  235880 */   // Label 4614: @235880
     /*  235880 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(235954), // Rule ID 9384 //
     /*  235885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  235888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  235899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235925 */     // MIs[1] Operand 1
     /*  235925 */     // No operand predicates
     /*  235925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235934 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  235934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235952 */     GIR_RootConstrainSelectedInstOperands,
     /*  235953 */     // GIR_Coverage, 9384,
     /*  235953 */     GIR_EraseRootFromParent_Done,
     /*  235954 */   // Label 4615: @235954
     /*  235954 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(236028), // Rule ID 9385 //
     /*  235959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  235962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  235973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235999 */     // MIs[1] Operand 1
     /*  235999 */     // No operand predicates
     /*  235999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236008 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  236011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236026 */     GIR_RootConstrainSelectedInstOperands,
     /*  236027 */     // GIR_Coverage, 9385,
     /*  236027 */     GIR_EraseRootFromParent_Done,
     /*  236028 */   // Label 4616: @236028
     /*  236028 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(236102), // Rule ID 9476 //
     /*  236033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  236047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236073 */     // MIs[1] Operand 1
     /*  236073 */     // No operand predicates
     /*  236073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236082 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  236085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236100 */     GIR_RootConstrainSelectedInstOperands,
     /*  236101 */     // GIR_Coverage, 9476,
     /*  236101 */     GIR_EraseRootFromParent_Done,
     /*  236102 */   // Label 4617: @236102
     /*  236102 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(236176), // Rule ID 9477 //
     /*  236107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  236121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236147 */     // MIs[1] Operand 1
     /*  236147 */     // No operand predicates
     /*  236147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236156 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  236159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236174 */     GIR_RootConstrainSelectedInstOperands,
     /*  236175 */     // GIR_Coverage, 9477,
     /*  236175 */     GIR_EraseRootFromParent_Done,
     /*  236176 */   // Label 4618: @236176
     /*  236176 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(236250), // Rule ID 9480 //
     /*  236181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  236195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236221 */     // MIs[1] Operand 1
     /*  236221 */     // No operand predicates
     /*  236221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236230 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236248 */     GIR_RootConstrainSelectedInstOperands,
     /*  236249 */     // GIR_Coverage, 9480,
     /*  236249 */     GIR_EraseRootFromParent_Done,
     /*  236250 */   // Label 4619: @236250
     /*  236250 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(236324), // Rule ID 9481 //
     /*  236255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  236269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236295 */     // MIs[1] Operand 1
     /*  236295 */     // No operand predicates
     /*  236295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236304 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236322 */     GIR_RootConstrainSelectedInstOperands,
     /*  236323 */     // GIR_Coverage, 9481,
     /*  236323 */     GIR_EraseRootFromParent_Done,
     /*  236324 */   // Label 4620: @236324
     /*  236324 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(236398), // Rule ID 9484 //
     /*  236329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  236343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236369 */     // MIs[1] Operand 1
     /*  236369 */     // No operand predicates
     /*  236369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236378 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236396 */     GIR_RootConstrainSelectedInstOperands,
     /*  236397 */     // GIR_Coverage, 9484,
     /*  236397 */     GIR_EraseRootFromParent_Done,
     /*  236398 */   // Label 4621: @236398
     /*  236398 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(236472), // Rule ID 9485 //
     /*  236403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  236417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236443 */     // MIs[1] Operand 1
     /*  236443 */     // No operand predicates
     /*  236443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236452 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236470 */     GIR_RootConstrainSelectedInstOperands,
     /*  236471 */     // GIR_Coverage, 9485,
     /*  236471 */     GIR_EraseRootFromParent_Done,
     /*  236472 */   // Label 4622: @236472
     /*  236472 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(236546), // Rule ID 9488 //
     /*  236477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  236491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236517 */     // MIs[1] Operand 1
     /*  236517 */     // No operand predicates
     /*  236517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236526 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  236526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236544 */     GIR_RootConstrainSelectedInstOperands,
     /*  236545 */     // GIR_Coverage, 9488,
     /*  236545 */     GIR_EraseRootFromParent_Done,
     /*  236546 */   // Label 4623: @236546
     /*  236546 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(236620), // Rule ID 9489 //
     /*  236551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  236565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236591 */     // MIs[1] Operand 1
     /*  236591 */     // No operand predicates
     /*  236591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236600 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  236600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236618 */     GIR_RootConstrainSelectedInstOperands,
     /*  236619 */     // GIR_Coverage, 9489,
     /*  236619 */     GIR_EraseRootFromParent_Done,
     /*  236620 */   // Label 4624: @236620
     /*  236620 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(236694), // Rule ID 9492 //
     /*  236625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  236639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236665 */     // MIs[1] Operand 1
     /*  236665 */     // No operand predicates
     /*  236665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236674 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  236674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236692 */     GIR_RootConstrainSelectedInstOperands,
     /*  236693 */     // GIR_Coverage, 9492,
     /*  236693 */     GIR_EraseRootFromParent_Done,
     /*  236694 */   // Label 4625: @236694
     /*  236694 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(236768), // Rule ID 9493 //
     /*  236699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  236713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236739 */     // MIs[1] Operand 1
     /*  236739 */     // No operand predicates
     /*  236739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236748 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  236748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236766 */     GIR_RootConstrainSelectedInstOperands,
     /*  236767 */     // GIR_Coverage, 9493,
     /*  236767 */     GIR_EraseRootFromParent_Done,
     /*  236768 */   // Label 4626: @236768
     /*  236768 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(236842), // Rule ID 9496 //
     /*  236773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  236787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236813 */     // MIs[1] Operand 1
     /*  236813 */     // No operand predicates
     /*  236813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236822 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  236822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236840 */     GIR_RootConstrainSelectedInstOperands,
     /*  236841 */     // GIR_Coverage, 9496,
     /*  236841 */     GIR_EraseRootFromParent_Done,
     /*  236842 */   // Label 4627: @236842
     /*  236842 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(236916), // Rule ID 9497 //
     /*  236847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  236861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236887 */     // MIs[1] Operand 1
     /*  236887 */     // No operand predicates
     /*  236887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236896 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  236896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236914 */     GIR_RootConstrainSelectedInstOperands,
     /*  236915 */     // GIR_Coverage, 9497,
     /*  236915 */     GIR_EraseRootFromParent_Done,
     /*  236916 */   // Label 4628: @236916
     /*  236916 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(236990), // Rule ID 9500 //
     /*  236921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  236935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236961 */     // MIs[1] Operand 1
     /*  236961 */     // No operand predicates
     /*  236961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236970 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  236973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236988 */     GIR_RootConstrainSelectedInstOperands,
     /*  236989 */     // GIR_Coverage, 9500,
     /*  236989 */     GIR_EraseRootFromParent_Done,
     /*  236990 */   // Label 4629: @236990
     /*  236990 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(237064), // Rule ID 9501 //
     /*  236995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  237009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237035 */     // MIs[1] Operand 1
     /*  237035 */     // No operand predicates
     /*  237035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237044 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237062 */     GIR_RootConstrainSelectedInstOperands,
     /*  237063 */     // GIR_Coverage, 9501,
     /*  237063 */     GIR_EraseRootFromParent_Done,
     /*  237064 */   // Label 4630: @237064
     /*  237064 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(237138), // Rule ID 9504 //
     /*  237069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  237083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237109 */     // MIs[1] Operand 1
     /*  237109 */     // No operand predicates
     /*  237109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237118 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237136 */     GIR_RootConstrainSelectedInstOperands,
     /*  237137 */     // GIR_Coverage, 9504,
     /*  237137 */     GIR_EraseRootFromParent_Done,
     /*  237138 */   // Label 4631: @237138
     /*  237138 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(237212), // Rule ID 9505 //
     /*  237143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  237157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237183 */     // MIs[1] Operand 1
     /*  237183 */     // No operand predicates
     /*  237183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237192 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237210 */     GIR_RootConstrainSelectedInstOperands,
     /*  237211 */     // GIR_Coverage, 9505,
     /*  237211 */     GIR_EraseRootFromParent_Done,
     /*  237212 */   // Label 4632: @237212
     /*  237212 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(237286), // Rule ID 9508 //
     /*  237217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  237231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237257 */     // MIs[1] Operand 1
     /*  237257 */     // No operand predicates
     /*  237257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237266 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237284 */     GIR_RootConstrainSelectedInstOperands,
     /*  237285 */     // GIR_Coverage, 9508,
     /*  237285 */     GIR_EraseRootFromParent_Done,
     /*  237286 */   // Label 4633: @237286
     /*  237286 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(237360), // Rule ID 9509 //
     /*  237291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  237305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237331 */     // MIs[1] Operand 1
     /*  237331 */     // No operand predicates
     /*  237331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237340 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  237340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237358 */     GIR_RootConstrainSelectedInstOperands,
     /*  237359 */     // GIR_Coverage, 9509,
     /*  237359 */     GIR_EraseRootFromParent_Done,
     /*  237360 */   // Label 4634: @237360
     /*  237360 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(237434), // Rule ID 9512 //
     /*  237365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  237368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  237379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237405 */     // MIs[1] Operand 1
     /*  237405 */     // No operand predicates
     /*  237405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237414 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  237414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237432 */     GIR_RootConstrainSelectedInstOperands,
     /*  237433 */     // GIR_Coverage, 9512,
     /*  237433 */     GIR_EraseRootFromParent_Done,
     /*  237434 */   // Label 4635: @237434
     /*  237434 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(237508), // Rule ID 9513 //
     /*  237439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  237442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  237453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237479 */     // MIs[1] Operand 1
     /*  237479 */     // No operand predicates
     /*  237479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237488 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  237488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237506 */     GIR_RootConstrainSelectedInstOperands,
     /*  237507 */     // GIR_Coverage, 9513,
     /*  237507 */     GIR_EraseRootFromParent_Done,
     /*  237508 */   // Label 4636: @237508
     /*  237508 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(237582), // Rule ID 9516 //
     /*  237513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  237524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  237527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237553 */     // MIs[1] Operand 1
     /*  237553 */     // No operand predicates
     /*  237553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237562 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  237562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  237565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237580 */     GIR_RootConstrainSelectedInstOperands,
     /*  237581 */     // GIR_Coverage, 9516,
     /*  237581 */     GIR_EraseRootFromParent_Done,
     /*  237582 */   // Label 4637: @237582
     /*  237582 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(237656), // Rule ID 9517 //
     /*  237587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  237598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  237601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237627 */     // MIs[1] Operand 1
     /*  237627 */     // No operand predicates
     /*  237627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237636 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  237639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237654 */     GIR_RootConstrainSelectedInstOperands,
     /*  237655 */     // GIR_Coverage, 9517,
     /*  237655 */     GIR_EraseRootFromParent_Done,
     /*  237656 */   // Label 4638: @237656
     /*  237656 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(237730), // Rule ID 9520 //
     /*  237661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  237672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  237675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  237689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237701 */     // MIs[1] Operand 1
     /*  237701 */     // No operand predicates
     /*  237701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237710 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  237710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  237713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237728 */     GIR_RootConstrainSelectedInstOperands,
     /*  237729 */     // GIR_Coverage, 9520,
     /*  237729 */     GIR_EraseRootFromParent_Done,
     /*  237730 */   // Label 4639: @237730
     /*  237730 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(237804), // Rule ID 9521 //
     /*  237735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  237746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  237749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  237763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237775 */     // MIs[1] Operand 1
     /*  237775 */     // No operand predicates
     /*  237775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237784 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  237787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237802 */     GIR_RootConstrainSelectedInstOperands,
     /*  237803 */     // GIR_Coverage, 9521,
     /*  237803 */     GIR_EraseRootFromParent_Done,
     /*  237804 */   // Label 4640: @237804
     /*  237804 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(237878), // Rule ID 9524 //
     /*  237809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  237820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  237823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  237837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237849 */     // MIs[1] Operand 1
     /*  237849 */     // No operand predicates
     /*  237849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237858 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  237858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  237861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237876 */     GIR_RootConstrainSelectedInstOperands,
     /*  237877 */     // GIR_Coverage, 9524,
     /*  237877 */     GIR_EraseRootFromParent_Done,
     /*  237878 */   // Label 4641: @237878
     /*  237878 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(237952), // Rule ID 9525 //
     /*  237883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  237894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  237897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  237911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237923 */     // MIs[1] Operand 1
     /*  237923 */     // No operand predicates
     /*  237923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237932 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  237935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237950 */     GIR_RootConstrainSelectedInstOperands,
     /*  237951 */     // GIR_Coverage, 9525,
     /*  237951 */     GIR_EraseRootFromParent_Done,
     /*  237952 */   // Label 4642: @237952
     /*  237952 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(238026), // Rule ID 9528 //
     /*  237957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  237971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237997 */     // MIs[1] Operand 1
     /*  237997 */     // No operand predicates
     /*  237997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238006 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238024 */     GIR_RootConstrainSelectedInstOperands,
     /*  238025 */     // GIR_Coverage, 9528,
     /*  238025 */     GIR_EraseRootFromParent_Done,
     /*  238026 */   // Label 4643: @238026
     /*  238026 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(238100), // Rule ID 9529 //
     /*  238031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  238045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238071 */     // MIs[1] Operand 1
     /*  238071 */     // No operand predicates
     /*  238071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238080 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238098 */     GIR_RootConstrainSelectedInstOperands,
     /*  238099 */     // GIR_Coverage, 9529,
     /*  238099 */     GIR_EraseRootFromParent_Done,
     /*  238100 */   // Label 4644: @238100
     /*  238100 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(238174), // Rule ID 9532 //
     /*  238105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238145 */     // MIs[1] Operand 1
     /*  238145 */     // No operand predicates
     /*  238145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238154 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238172 */     GIR_RootConstrainSelectedInstOperands,
     /*  238173 */     // GIR_Coverage, 9532,
     /*  238173 */     GIR_EraseRootFromParent_Done,
     /*  238174 */   // Label 4645: @238174
     /*  238174 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(238248), // Rule ID 9533 //
     /*  238179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238219 */     // MIs[1] Operand 1
     /*  238219 */     // No operand predicates
     /*  238219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238228 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238246 */     GIR_RootConstrainSelectedInstOperands,
     /*  238247 */     // GIR_Coverage, 9533,
     /*  238247 */     GIR_EraseRootFromParent_Done,
     /*  238248 */   // Label 4646: @238248
     /*  238248 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(238322), // Rule ID 9536 //
     /*  238253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238293 */     // MIs[1] Operand 1
     /*  238293 */     // No operand predicates
     /*  238293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238302 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238320 */     GIR_RootConstrainSelectedInstOperands,
     /*  238321 */     // GIR_Coverage, 9536,
     /*  238321 */     GIR_EraseRootFromParent_Done,
     /*  238322 */   // Label 4647: @238322
     /*  238322 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(238396), // Rule ID 9537 //
     /*  238327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238367 */     // MIs[1] Operand 1
     /*  238367 */     // No operand predicates
     /*  238367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238376 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238394 */     GIR_RootConstrainSelectedInstOperands,
     /*  238395 */     // GIR_Coverage, 9537,
     /*  238395 */     GIR_EraseRootFromParent_Done,
     /*  238396 */   // Label 4648: @238396
     /*  238396 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(238470), // Rule ID 9540 //
     /*  238401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  238415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238441 */     // MIs[1] Operand 1
     /*  238441 */     // No operand predicates
     /*  238441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238450 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  238450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238468 */     GIR_RootConstrainSelectedInstOperands,
     /*  238469 */     // GIR_Coverage, 9540,
     /*  238469 */     GIR_EraseRootFromParent_Done,
     /*  238470 */   // Label 4649: @238470
     /*  238470 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(238544), // Rule ID 9541 //
     /*  238475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  238489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238515 */     // MIs[1] Operand 1
     /*  238515 */     // No operand predicates
     /*  238515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238524 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238542 */     GIR_RootConstrainSelectedInstOperands,
     /*  238543 */     // GIR_Coverage, 9541,
     /*  238543 */     GIR_EraseRootFromParent_Done,
     /*  238544 */   // Label 4650: @238544
     /*  238544 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(238618), // Rule ID 9544 //
     /*  238549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  238563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238589 */     // MIs[1] Operand 1
     /*  238589 */     // No operand predicates
     /*  238589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238598 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  238598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238616 */     GIR_RootConstrainSelectedInstOperands,
     /*  238617 */     // GIR_Coverage, 9544,
     /*  238617 */     GIR_EraseRootFromParent_Done,
     /*  238618 */   // Label 4651: @238618
     /*  238618 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(238692), // Rule ID 9545 //
     /*  238623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  238637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238663 */     // MIs[1] Operand 1
     /*  238663 */     // No operand predicates
     /*  238663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238690 */     GIR_RootConstrainSelectedInstOperands,
     /*  238691 */     // GIR_Coverage, 9545,
     /*  238691 */     GIR_EraseRootFromParent_Done,
     /*  238692 */   // Label 4652: @238692
     /*  238692 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(238766), // Rule ID 9548 //
     /*  238697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  238711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238737 */     // MIs[1] Operand 1
     /*  238737 */     // No operand predicates
     /*  238737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238746 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  238746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238764 */     GIR_RootConstrainSelectedInstOperands,
     /*  238765 */     // GIR_Coverage, 9548,
     /*  238765 */     GIR_EraseRootFromParent_Done,
     /*  238766 */   // Label 4653: @238766
     /*  238766 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(238840), // Rule ID 9549 //
     /*  238771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  238785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238811 */     // MIs[1] Operand 1
     /*  238811 */     // No operand predicates
     /*  238811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238820 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238838 */     GIR_RootConstrainSelectedInstOperands,
     /*  238839 */     // GIR_Coverage, 9549,
     /*  238839 */     GIR_EraseRootFromParent_Done,
     /*  238840 */   // Label 4654: @238840
     /*  238840 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(238914), // Rule ID 9552 //
     /*  238845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  238848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  238856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  238859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238885 */     // MIs[1] Operand 1
     /*  238885 */     // No operand predicates
     /*  238885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238894 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  238894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238912 */     GIR_RootConstrainSelectedInstOperands,
     /*  238913 */     // GIR_Coverage, 9552,
     /*  238913 */     GIR_EraseRootFromParent_Done,
     /*  238914 */   // Label 4655: @238914
     /*  238914 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(238988), // Rule ID 9553 //
     /*  238919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  238922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  238930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  238933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238959 */     // MIs[1] Operand 1
     /*  238959 */     // No operand predicates
     /*  238959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238968 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  238968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238986 */     GIR_RootConstrainSelectedInstOperands,
     /*  238987 */     // GIR_Coverage, 9553,
     /*  238987 */     GIR_EraseRootFromParent_Done,
     /*  238988 */   // Label 4656: @238988
     /*  238988 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(239062), // Rule ID 9556 //
     /*  238993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  238996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  239007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239033 */     // MIs[1] Operand 1
     /*  239033 */     // No operand predicates
     /*  239033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239042 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  239045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239060 */     GIR_RootConstrainSelectedInstOperands,
     /*  239061 */     // GIR_Coverage, 9556,
     /*  239061 */     GIR_EraseRootFromParent_Done,
     /*  239062 */   // Label 4657: @239062
     /*  239062 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(239136), // Rule ID 9557 //
     /*  239067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  239081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239107 */     // MIs[1] Operand 1
     /*  239107 */     // No operand predicates
     /*  239107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239116 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  239119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239134 */     GIR_RootConstrainSelectedInstOperands,
     /*  239135 */     // GIR_Coverage, 9557,
     /*  239135 */     GIR_EraseRootFromParent_Done,
     /*  239136 */   // Label 4658: @239136
     /*  239136 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(239210), // Rule ID 9560 //
     /*  239141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239181 */     // MIs[1] Operand 1
     /*  239181 */     // No operand predicates
     /*  239181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239190 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  239193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239208 */     GIR_RootConstrainSelectedInstOperands,
     /*  239209 */     // GIR_Coverage, 9560,
     /*  239209 */     GIR_EraseRootFromParent_Done,
     /*  239210 */   // Label 4659: @239210
     /*  239210 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(239284), // Rule ID 9561 //
     /*  239215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239255 */     // MIs[1] Operand 1
     /*  239255 */     // No operand predicates
     /*  239255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  239267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239282 */     GIR_RootConstrainSelectedInstOperands,
     /*  239283 */     // GIR_Coverage, 9561,
     /*  239283 */     GIR_EraseRootFromParent_Done,
     /*  239284 */   // Label 4660: @239284
     /*  239284 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(239340), // Rule ID 64451 //
     /*  239289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  239292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bitrev),
     /*  239297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  239300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  239303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239311 */     // MIs[0] pts
     /*  239311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  239314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  239319 */     // MIs[0] radix
     /*  239319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  239322 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm2),
     /*  239327 */     // (intrinsic_wo_chain:{ *:[i32] } 10992:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts)
     /*  239327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /*  239330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239334 */     GIR_RootToRootCopy, /*OpIdx*/4, // radix
     /*  239336 */     GIR_RootToRootCopy, /*OpIdx*/3, // pts
     /*  239338 */     GIR_RootConstrainSelectedInstOperands,
     /*  239339 */     // GIR_Coverage, 64451,
     /*  239339 */     GIR_EraseRootFromParent_Done,
     /*  239340 */   // Label 4661: @239340
     /*  239340 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(239403), // Rule ID 2690 //
     /*  239345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  239348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  239353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  239356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  239359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  239377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239384 */     // (intrinsic_wo_chain:{ *:[i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  239384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  239387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239391 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  239393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239401 */     GIR_RootConstrainSelectedInstOperands,
     /*  239402 */     // GIR_Coverage, 2690,
     /*  239402 */     GIR_EraseRootFromParent_Done,
     /*  239403 */   // Label 4662: @239403
     /*  239403 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(239466), // Rule ID 2691 //
     /*  239408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  239411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  239416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  239419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  239422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  239440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239447 */     // (intrinsic_wo_chain:{ *:[i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  239447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  239450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239454 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  239456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239464 */     GIR_RootConstrainSelectedInstOperands,
     /*  239465 */     // GIR_Coverage, 2691,
     /*  239465 */     GIR_EraseRootFromParent_Done,
     /*  239466 */   // Label 4663: @239466
     /*  239466 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(239532), // Rule ID 2698 //
     /*  239471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  239479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  239482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239510 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  239510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  239513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239530 */     GIR_RootConstrainSelectedInstOperands,
     /*  239531 */     // GIR_Coverage, 2698,
     /*  239531 */     GIR_EraseRootFromParent_Done,
     /*  239532 */   // Label 4664: @239532
     /*  239532 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(239598), // Rule ID 2699 //
     /*  239537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  239545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  239548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239576 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  239576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  239579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239596 */     GIR_RootConstrainSelectedInstOperands,
     /*  239597 */     // GIR_Coverage, 2699,
     /*  239597 */     GIR_EraseRootFromParent_Done,
     /*  239598 */   // Label 4665: @239598
     /*  239598 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(239664), // Rule ID 2702 //
     /*  239603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  239611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239642 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11691:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  239642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  239645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239662 */     GIR_RootConstrainSelectedInstOperands,
     /*  239663 */     // GIR_Coverage, 2702,
     /*  239663 */     GIR_EraseRootFromParent_Done,
     /*  239664 */   // Label 4666: @239664
     /*  239664 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(239730), // Rule ID 2703 //
     /*  239669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  239677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239708 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11691:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  239708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  239711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239728 */     GIR_RootConstrainSelectedInstOperands,
     /*  239729 */     // GIR_Coverage, 2703,
     /*  239729 */     GIR_EraseRootFromParent_Done,
     /*  239730 */   // Label 4667: @239730
     /*  239730 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(239796), // Rule ID 2706 //
     /*  239735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  239738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  239743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  239752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239774 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  239774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  239777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239794 */     GIR_RootConstrainSelectedInstOperands,
     /*  239795 */     // GIR_Coverage, 2706,
     /*  239795 */     GIR_EraseRootFromParent_Done,
     /*  239796 */   // Label 4668: @239796
     /*  239796 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(239862), // Rule ID 2707 //
     /*  239801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  239804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  239809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  239818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239840 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  239840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  239843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239860 */     GIR_RootConstrainSelectedInstOperands,
     /*  239861 */     // GIR_Coverage, 2707,
     /*  239861 */     GIR_EraseRootFromParent_Done,
     /*  239862 */   // Label 4669: @239862
     /*  239862 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(239925), // Rule ID 2720 //
     /*  239867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  239875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239906 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  239906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  239909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239923 */     GIR_RootConstrainSelectedInstOperands,
     /*  239924 */     // GIR_Coverage, 2720,
     /*  239924 */     GIR_EraseRootFromParent_Done,
     /*  239925 */   // Label 4670: @239925
     /*  239925 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(239988), // Rule ID 2721 //
     /*  239930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  239938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239969 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  239969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  239972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239986 */     GIR_RootConstrainSelectedInstOperands,
     /*  239987 */     // GIR_Coverage, 2721,
     /*  239987 */     GIR_EraseRootFromParent_Done,
     /*  239988 */   // Label 4671: @239988
     /*  239988 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(240051), // Rule ID 2732 //
     /*  239993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  240001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240032 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  240035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240049 */     GIR_RootConstrainSelectedInstOperands,
     /*  240050 */     // GIR_Coverage, 2732,
     /*  240050 */     GIR_EraseRootFromParent_Done,
     /*  240051 */   // Label 4672: @240051
     /*  240051 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(240114), // Rule ID 2733 //
     /*  240056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  240064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240095 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  240098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240112 */     GIR_RootConstrainSelectedInstOperands,
     /*  240113 */     // GIR_Coverage, 2733,
     /*  240113 */     GIR_EraseRootFromParent_Done,
     /*  240114 */   // Label 4673: @240114
     /*  240114 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(240177), // Rule ID 2740 //
     /*  240119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  240127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240158 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  240161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240175 */     GIR_RootConstrainSelectedInstOperands,
     /*  240176 */     // GIR_Coverage, 2740,
     /*  240176 */     GIR_EraseRootFromParent_Done,
     /*  240177 */   // Label 4674: @240177
     /*  240177 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(240240), // Rule ID 2741 //
     /*  240182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  240190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240221 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  240224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240238 */     GIR_RootConstrainSelectedInstOperands,
     /*  240239 */     // GIR_Coverage, 2741,
     /*  240239 */     GIR_EraseRootFromParent_Done,
     /*  240240 */   // Label 4675: @240240
     /*  240240 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(240306), // Rule ID 2742 //
     /*  240245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  240248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  240253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240284 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  240287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240304 */     GIR_RootConstrainSelectedInstOperands,
     /*  240305 */     // GIR_Coverage, 2742,
     /*  240305 */     GIR_EraseRootFromParent_Done,
     /*  240306 */   // Label 4676: @240306
     /*  240306 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(240372), // Rule ID 2743 //
     /*  240311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  240314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  240319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240350 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  240353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240370 */     GIR_RootConstrainSelectedInstOperands,
     /*  240371 */     // GIR_Coverage, 2743,
     /*  240371 */     GIR_EraseRootFromParent_Done,
     /*  240372 */   // Label 4677: @240372
     /*  240372 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(240435), // Rule ID 2754 //
     /*  240377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  240385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  240391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  240394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240416 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  240416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  240419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240433 */     GIR_RootConstrainSelectedInstOperands,
     /*  240434 */     // GIR_Coverage, 2754,
     /*  240434 */     GIR_EraseRootFromParent_Done,
     /*  240435 */   // Label 4678: @240435
     /*  240435 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(240498), // Rule ID 2755 //
     /*  240440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  240448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  240454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  240457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240479 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  240479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  240482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240496 */     GIR_RootConstrainSelectedInstOperands,
     /*  240497 */     // GIR_Coverage, 2755,
     /*  240497 */     GIR_EraseRootFromParent_Done,
     /*  240498 */   // Label 4679: @240498
     /*  240498 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(240564), // Rule ID 4902 //
     /*  240503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  240514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  240517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  240520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240542 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11691:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  240545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240562 */     GIR_RootConstrainSelectedInstOperands,
     /*  240563 */     // GIR_Coverage, 4902,
     /*  240563 */     GIR_EraseRootFromParent_Done,
     /*  240564 */   // Label 4680: @240564
     /*  240564 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(240630), // Rule ID 4903 //
     /*  240569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  240580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  240583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  240586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240608 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11691:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  240611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240628 */     GIR_RootConstrainSelectedInstOperands,
     /*  240629 */     // GIR_Coverage, 4903,
     /*  240629 */     GIR_EraseRootFromParent_Done,
     /*  240630 */   // Label 4681: @240630
     /*  240630 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(240696), // Rule ID 4906 //
     /*  240635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  240646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  240649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  240652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11691:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  240677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240694 */     GIR_RootConstrainSelectedInstOperands,
     /*  240695 */     // GIR_Coverage, 4906,
     /*  240695 */     GIR_EraseRootFromParent_Done,
     /*  240696 */   // Label 4682: @240696
     /*  240696 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(240762), // Rule ID 4907 //
     /*  240701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  240712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  240715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  240718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240740 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11691:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  240743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240760 */     GIR_RootConstrainSelectedInstOperands,
     /*  240761 */     // GIR_Coverage, 4907,
     /*  240761 */     GIR_EraseRootFromParent_Done,
     /*  240762 */   // Label 4683: @240762
     /*  240762 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(240828), // Rule ID 4910 //
     /*  240767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  240778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  240781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  240784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240806 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11691:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  240809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240826 */     GIR_RootConstrainSelectedInstOperands,
     /*  240827 */     // GIR_Coverage, 4910,
     /*  240827 */     GIR_EraseRootFromParent_Done,
     /*  240828 */   // Label 4684: @240828
     /*  240828 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(240894), // Rule ID 4911 //
     /*  240833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  240844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  240847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  240850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240872 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11691:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  240875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240892 */     GIR_RootConstrainSelectedInstOperands,
     /*  240893 */     // GIR_Coverage, 4911,
     /*  240893 */     GIR_EraseRootFromParent_Done,
     /*  240894 */   // Label 4685: @240894
     /*  240894 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(240960), // Rule ID 4914 //
     /*  240899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  240910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  240913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  240916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240938 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11691:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  240941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240958 */     GIR_RootConstrainSelectedInstOperands,
     /*  240959 */     // GIR_Coverage, 4914,
     /*  240959 */     GIR_EraseRootFromParent_Done,
     /*  240960 */   // Label 4686: @240960
     /*  240960 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(241026), // Rule ID 4915 //
     /*  240965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  240976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  240979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  240982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241004 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11691:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  241004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  241007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241024 */     GIR_RootConstrainSelectedInstOperands,
     /*  241025 */     // GIR_Coverage, 4915,
     /*  241025 */     GIR_EraseRootFromParent_Done,
     /*  241026 */   // Label 4687: @241026
     /*  241026 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(241092), // Rule ID 4918 //
     /*  241031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  241042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  241045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  241048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241070 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11691:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  241070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241090 */     GIR_RootConstrainSelectedInstOperands,
     /*  241091 */     // GIR_Coverage, 4918,
     /*  241091 */     GIR_EraseRootFromParent_Done,
     /*  241092 */   // Label 4688: @241092
     /*  241092 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(241158), // Rule ID 4919 //
     /*  241097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  241108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  241111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  241114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241136 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11691:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  241136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241156 */     GIR_RootConstrainSelectedInstOperands,
     /*  241157 */     // GIR_Coverage, 4919,
     /*  241157 */     GIR_EraseRootFromParent_Done,
     /*  241158 */   // Label 4689: @241158
     /*  241158 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(241224), // Rule ID 4922 //
     /*  241163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  241174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  241177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  241180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241202 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11691:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  241205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241222 */     GIR_RootConstrainSelectedInstOperands,
     /*  241223 */     // GIR_Coverage, 4922,
     /*  241223 */     GIR_EraseRootFromParent_Done,
     /*  241224 */   // Label 4690: @241224
     /*  241224 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(241290), // Rule ID 4923 //
     /*  241229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  241240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  241243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  241246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11691:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  241271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241288 */     GIR_RootConstrainSelectedInstOperands,
     /*  241289 */     // GIR_Coverage, 4923,
     /*  241289 */     GIR_EraseRootFromParent_Done,
     /*  241290 */   // Label 4691: @241290
     /*  241290 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(241356), // Rule ID 4926 //
     /*  241295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  241306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  241309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  241312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11691:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241354 */     GIR_RootConstrainSelectedInstOperands,
     /*  241355 */     // GIR_Coverage, 4926,
     /*  241355 */     GIR_EraseRootFromParent_Done,
     /*  241356 */   // Label 4692: @241356
     /*  241356 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(241422), // Rule ID 4927 //
     /*  241361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  241372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  241375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  241378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11691:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241420 */     GIR_RootConstrainSelectedInstOperands,
     /*  241421 */     // GIR_Coverage, 4927,
     /*  241421 */     GIR_EraseRootFromParent_Done,
     /*  241422 */   // Label 4693: @241422
     /*  241422 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(241488), // Rule ID 4930 //
     /*  241427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  241438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  241441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  241444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241466 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11691:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241486 */     GIR_RootConstrainSelectedInstOperands,
     /*  241487 */     // GIR_Coverage, 4930,
     /*  241487 */     GIR_EraseRootFromParent_Done,
     /*  241488 */   // Label 4694: @241488
     /*  241488 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(241554), // Rule ID 4931 //
     /*  241493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  241504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  241507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  241510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241532 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11691:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241552 */     GIR_RootConstrainSelectedInstOperands,
     /*  241553 */     // GIR_Coverage, 4931,
     /*  241553 */     GIR_EraseRootFromParent_Done,
     /*  241554 */   // Label 4695: @241554
     /*  241554 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(241620), // Rule ID 4934 //
     /*  241559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  241570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  241573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  241576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11691:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  241601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241618 */     GIR_RootConstrainSelectedInstOperands,
     /*  241619 */     // GIR_Coverage, 4934,
     /*  241619 */     GIR_EraseRootFromParent_Done,
     /*  241620 */   // Label 4696: @241620
     /*  241620 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(241686), // Rule ID 4935 //
     /*  241625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  241636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  241639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  241642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241664 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11691:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  241667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241684 */     GIR_RootConstrainSelectedInstOperands,
     /*  241685 */     // GIR_Coverage, 4935,
     /*  241685 */     GIR_EraseRootFromParent_Done,
     /*  241686 */   // Label 4697: @241686
     /*  241686 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(241752), // Rule ID 4938 //
     /*  241691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  241702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  241705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  241708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241730 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11691:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241750 */     GIR_RootConstrainSelectedInstOperands,
     /*  241751 */     // GIR_Coverage, 4938,
     /*  241751 */     GIR_EraseRootFromParent_Done,
     /*  241752 */   // Label 4698: @241752
     /*  241752 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(241818), // Rule ID 4939 //
     /*  241757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  241768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  241771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  241774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11691:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241816 */     GIR_RootConstrainSelectedInstOperands,
     /*  241817 */     // GIR_Coverage, 4939,
     /*  241817 */     GIR_EraseRootFromParent_Done,
     /*  241818 */   // Label 4699: @241818
     /*  241818 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(241884), // Rule ID 4942 //
     /*  241823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  241826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  241834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  241837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  241840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241862 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11691:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  241862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241882 */     GIR_RootConstrainSelectedInstOperands,
     /*  241883 */     // GIR_Coverage, 4942,
     /*  241883 */     GIR_EraseRootFromParent_Done,
     /*  241884 */   // Label 4700: @241884
     /*  241884 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(241950), // Rule ID 4943 //
     /*  241889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  241892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  241900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  241903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  241906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11691:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  241928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241948 */     GIR_RootConstrainSelectedInstOperands,
     /*  241949 */     // GIR_Coverage, 4943,
     /*  241949 */     GIR_EraseRootFromParent_Done,
     /*  241950 */   // Label 4701: @241950
     /*  241950 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(242016), // Rule ID 4946 //
     /*  241955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  241958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  241966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  241969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  241972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241994 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11691:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  241994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242014 */     GIR_RootConstrainSelectedInstOperands,
     /*  242015 */     // GIR_Coverage, 4946,
     /*  242015 */     GIR_EraseRootFromParent_Done,
     /*  242016 */   // Label 4702: @242016
     /*  242016 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(242082), // Rule ID 4947 //
     /*  242021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  242032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  242035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  242038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242060 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11691:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  242063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242080 */     GIR_RootConstrainSelectedInstOperands,
     /*  242081 */     // GIR_Coverage, 4947,
     /*  242081 */     GIR_EraseRootFromParent_Done,
     /*  242082 */   // Label 4703: @242082
     /*  242082 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(242148), // Rule ID 4950 //
     /*  242087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  242098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  242104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242126 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11691:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  242129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242146 */     GIR_RootConstrainSelectedInstOperands,
     /*  242147 */     // GIR_Coverage, 4950,
     /*  242147 */     GIR_EraseRootFromParent_Done,
     /*  242148 */   // Label 4704: @242148
     /*  242148 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(242214), // Rule ID 4951 //
     /*  242153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  242164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  242170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242192 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11691:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  242195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242212 */     GIR_RootConstrainSelectedInstOperands,
     /*  242213 */     // GIR_Coverage, 4951,
     /*  242213 */     GIR_EraseRootFromParent_Done,
     /*  242214 */   // Label 4705: @242214
     /*  242214 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(242280), // Rule ID 4954 //
     /*  242219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  242230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  242233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  242236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242258 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11691:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  242261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242278 */     GIR_RootConstrainSelectedInstOperands,
     /*  242279 */     // GIR_Coverage, 4954,
     /*  242279 */     GIR_EraseRootFromParent_Done,
     /*  242280 */   // Label 4706: @242280
     /*  242280 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(242346), // Rule ID 4955 //
     /*  242285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  242296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  242299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  242302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242324 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11691:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  242327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242344 */     GIR_RootConstrainSelectedInstOperands,
     /*  242345 */     // GIR_Coverage, 4955,
     /*  242345 */     GIR_EraseRootFromParent_Done,
     /*  242346 */   // Label 4707: @242346
     /*  242346 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(242412), // Rule ID 4958 //
     /*  242351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  242362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  242365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  242368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242390 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11691:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  242393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242410 */     GIR_RootConstrainSelectedInstOperands,
     /*  242411 */     // GIR_Coverage, 4958,
     /*  242411 */     GIR_EraseRootFromParent_Done,
     /*  242412 */   // Label 4708: @242412
     /*  242412 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(242478), // Rule ID 4959 //
     /*  242417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  242428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  242431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  242434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242456 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11691:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  242459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242476 */     GIR_RootConstrainSelectedInstOperands,
     /*  242477 */     // GIR_Coverage, 4959,
     /*  242477 */     GIR_EraseRootFromParent_Done,
     /*  242478 */   // Label 4709: @242478
     /*  242478 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(242544), // Rule ID 4962 //
     /*  242483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  242494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  242497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  242500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242522 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11691:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  242525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242542 */     GIR_RootConstrainSelectedInstOperands,
     /*  242543 */     // GIR_Coverage, 4962,
     /*  242543 */     GIR_EraseRootFromParent_Done,
     /*  242544 */   // Label 4710: @242544
     /*  242544 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(242610), // Rule ID 4963 //
     /*  242549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  242560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  242563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  242566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11691:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  242591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242608 */     GIR_RootConstrainSelectedInstOperands,
     /*  242609 */     // GIR_Coverage, 4963,
     /*  242609 */     GIR_EraseRootFromParent_Done,
     /*  242610 */   // Label 4711: @242610
     /*  242610 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(242676), // Rule ID 4966 //
     /*  242615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  242626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  242629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  242632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11691:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  242657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242674 */     GIR_RootConstrainSelectedInstOperands,
     /*  242675 */     // GIR_Coverage, 4966,
     /*  242675 */     GIR_EraseRootFromParent_Done,
     /*  242676 */   // Label 4712: @242676
     /*  242676 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(242742), // Rule ID 4967 //
     /*  242681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  242692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  242695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  242698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242720 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11691:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  242723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242740 */     GIR_RootConstrainSelectedInstOperands,
     /*  242741 */     // GIR_Coverage, 4967,
     /*  242741 */     GIR_EraseRootFromParent_Done,
     /*  242742 */   // Label 4713: @242742
     /*  242742 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(242808), // Rule ID 4970 //
     /*  242747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  242758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  242764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242786 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11691:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  242789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242806 */     GIR_RootConstrainSelectedInstOperands,
     /*  242807 */     // GIR_Coverage, 4970,
     /*  242807 */     GIR_EraseRootFromParent_Done,
     /*  242808 */   // Label 4714: @242808
     /*  242808 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(242874), // Rule ID 4971 //
     /*  242813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  242824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  242830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11691:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  242855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242872 */     GIR_RootConstrainSelectedInstOperands,
     /*  242873 */     // GIR_Coverage, 4971,
     /*  242873 */     GIR_EraseRootFromParent_Done,
     /*  242874 */   // Label 4715: @242874
     /*  242874 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(242940), // Rule ID 4974 //
     /*  242879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  242890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  242896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11691:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  242921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242938 */     GIR_RootConstrainSelectedInstOperands,
     /*  242939 */     // GIR_Coverage, 4974,
     /*  242939 */     GIR_EraseRootFromParent_Done,
     /*  242940 */   // Label 4716: @242940
     /*  242940 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(243006), // Rule ID 4975 //
     /*  242945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  242956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  242962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242984 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11691:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  242987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243004 */     GIR_RootConstrainSelectedInstOperands,
     /*  243005 */     // GIR_Coverage, 4975,
     /*  243005 */     GIR_EraseRootFromParent_Done,
     /*  243006 */   // Label 4717: @243006
     /*  243006 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(243072), // Rule ID 4978 //
     /*  243011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  243028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243050 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11691:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  243053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243070 */     GIR_RootConstrainSelectedInstOperands,
     /*  243071 */     // GIR_Coverage, 4978,
     /*  243071 */     GIR_EraseRootFromParent_Done,
     /*  243072 */   // Label 4718: @243072
     /*  243072 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(243138), // Rule ID 4979 //
     /*  243077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  243094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243116 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11691:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  243119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243136 */     GIR_RootConstrainSelectedInstOperands,
     /*  243137 */     // GIR_Coverage, 4979,
     /*  243137 */     GIR_EraseRootFromParent_Done,
     /*  243138 */   // Label 4719: @243138
     /*  243138 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(243204), // Rule ID 4982 //
     /*  243143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  243160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11691:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  243185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243202 */     GIR_RootConstrainSelectedInstOperands,
     /*  243203 */     // GIR_Coverage, 4982,
     /*  243203 */     GIR_EraseRootFromParent_Done,
     /*  243204 */   // Label 4720: @243204
     /*  243204 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(243270), // Rule ID 4983 //
     /*  243209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  243226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243248 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11691:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  243251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243268 */     GIR_RootConstrainSelectedInstOperands,
     /*  243269 */     // GIR_Coverage, 4983,
     /*  243269 */     GIR_EraseRootFromParent_Done,
     /*  243270 */   // Label 4721: @243270
     /*  243270 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(243336), // Rule ID 4986 //
     /*  243275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  243292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243314 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11691:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  243317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243334 */     GIR_RootConstrainSelectedInstOperands,
     /*  243335 */     // GIR_Coverage, 4986,
     /*  243335 */     GIR_EraseRootFromParent_Done,
     /*  243336 */   // Label 4722: @243336
     /*  243336 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(243402), // Rule ID 4987 //
     /*  243341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  243358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243380 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11691:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  243383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243400 */     GIR_RootConstrainSelectedInstOperands,
     /*  243401 */     // GIR_Coverage, 4987,
     /*  243401 */     GIR_EraseRootFromParent_Done,
     /*  243402 */   // Label 4723: @243402
     /*  243402 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(243468), // Rule ID 4990 //
     /*  243407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  243418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  243424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243446 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11691:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  243449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243466 */     GIR_RootConstrainSelectedInstOperands,
     /*  243467 */     // GIR_Coverage, 4990,
     /*  243467 */     GIR_EraseRootFromParent_Done,
     /*  243468 */   // Label 4724: @243468
     /*  243468 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(243534), // Rule ID 4991 //
     /*  243473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  243484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  243490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243512 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11691:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  243515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243532 */     GIR_RootConstrainSelectedInstOperands,
     /*  243533 */     // GIR_Coverage, 4991,
     /*  243533 */     GIR_EraseRootFromParent_Done,
     /*  243534 */   // Label 4725: @243534
     /*  243534 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(243600), // Rule ID 4994 //
     /*  243539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243578 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11691:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  243581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243598 */     GIR_RootConstrainSelectedInstOperands,
     /*  243599 */     // GIR_Coverage, 4994,
     /*  243599 */     GIR_EraseRootFromParent_Done,
     /*  243600 */   // Label 4726: @243600
     /*  243600 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(243666), // Rule ID 4995 //
     /*  243605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11691:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  243647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243664 */     GIR_RootConstrainSelectedInstOperands,
     /*  243665 */     // GIR_Coverage, 4995,
     /*  243665 */     GIR_EraseRootFromParent_Done,
     /*  243666 */   // Label 4727: @243666
     /*  243666 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(243732), // Rule ID 4998 //
     /*  243671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  243688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11691:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  243713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243730 */     GIR_RootConstrainSelectedInstOperands,
     /*  243731 */     // GIR_Coverage, 4998,
     /*  243731 */     GIR_EraseRootFromParent_Done,
     /*  243732 */   // Label 4728: @243732
     /*  243732 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(243798), // Rule ID 4999 //
     /*  243737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  243754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11691:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  243779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243796 */     GIR_RootConstrainSelectedInstOperands,
     /*  243797 */     // GIR_Coverage, 4999,
     /*  243797 */     GIR_EraseRootFromParent_Done,
     /*  243798 */   // Label 4729: @243798
     /*  243798 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(243864), // Rule ID 5002 //
     /*  243803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  243820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243842 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11691:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  243845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243862 */     GIR_RootConstrainSelectedInstOperands,
     /*  243863 */     // GIR_Coverage, 5002,
     /*  243863 */     GIR_EraseRootFromParent_Done,
     /*  243864 */   // Label 4730: @243864
     /*  243864 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(243930), // Rule ID 5003 //
     /*  243869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  243886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243908 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11691:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  243911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243928 */     GIR_RootConstrainSelectedInstOperands,
     /*  243929 */     // GIR_Coverage, 5003,
     /*  243929 */     GIR_EraseRootFromParent_Done,
     /*  243930 */   // Label 4731: @243930
     /*  243930 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(243996), // Rule ID 5006 //
     /*  243935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  243946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  243952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243974 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11691:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  243977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243994 */     GIR_RootConstrainSelectedInstOperands,
     /*  243995 */     // GIR_Coverage, 5006,
     /*  243995 */     GIR_EraseRootFromParent_Done,
     /*  243996 */   // Label 4732: @243996
     /*  243996 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(244062), // Rule ID 5007 //
     /*  244001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  244004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  244012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  244015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244040 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11691:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  244040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  244043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244060 */     GIR_RootConstrainSelectedInstOperands,
     /*  244061 */     // GIR_Coverage, 5007,
     /*  244061 */     GIR_EraseRootFromParent_Done,
     /*  244062 */   // Label 4733: @244062
     /*  244062 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(244128), // Rule ID 5010 //
     /*  244067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  244078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  244081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244106 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  244109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244126 */     GIR_RootConstrainSelectedInstOperands,
     /*  244127 */     // GIR_Coverage, 5010,
     /*  244127 */     GIR_EraseRootFromParent_Done,
     /*  244128 */   // Label 4734: @244128
     /*  244128 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(244194), // Rule ID 5011 //
     /*  244133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  244144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  244147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244172 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  244175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244192 */     GIR_RootConstrainSelectedInstOperands,
     /*  244193 */     // GIR_Coverage, 5011,
     /*  244193 */     GIR_EraseRootFromParent_Done,
     /*  244194 */   // Label 4735: @244194
     /*  244194 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(244260), // Rule ID 5014 //
     /*  244199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  244210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  244213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244238 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244258 */     GIR_RootConstrainSelectedInstOperands,
     /*  244259 */     // GIR_Coverage, 5014,
     /*  244259 */     GIR_EraseRootFromParent_Done,
     /*  244260 */   // Label 4736: @244260
     /*  244260 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(244326), // Rule ID 5015 //
     /*  244265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  244276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  244279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244304 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244324 */     GIR_RootConstrainSelectedInstOperands,
     /*  244325 */     // GIR_Coverage, 5015,
     /*  244325 */     GIR_EraseRootFromParent_Done,
     /*  244326 */   // Label 4737: @244326
     /*  244326 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(244392), // Rule ID 5018 //
     /*  244331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  244342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  244345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244370 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  244373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244390 */     GIR_RootConstrainSelectedInstOperands,
     /*  244391 */     // GIR_Coverage, 5018,
     /*  244391 */     GIR_EraseRootFromParent_Done,
     /*  244392 */   // Label 4738: @244392
     /*  244392 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(244458), // Rule ID 5019 //
     /*  244397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  244408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  244411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244436 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  244439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244456 */     GIR_RootConstrainSelectedInstOperands,
     /*  244457 */     // GIR_Coverage, 5019,
     /*  244457 */     GIR_EraseRootFromParent_Done,
     /*  244458 */   // Label 4739: @244458
     /*  244458 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(244524), // Rule ID 5022 //
     /*  244463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  244505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244522 */     GIR_RootConstrainSelectedInstOperands,
     /*  244523 */     // GIR_Coverage, 5022,
     /*  244523 */     GIR_EraseRootFromParent_Done,
     /*  244524 */   // Label 4740: @244524
     /*  244524 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(244590), // Rule ID 5023 //
     /*  244529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  244571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244588 */     GIR_RootConstrainSelectedInstOperands,
     /*  244589 */     // GIR_Coverage, 5023,
     /*  244589 */     GIR_EraseRootFromParent_Done,
     /*  244590 */   // Label 4741: @244590
     /*  244590 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(244656), // Rule ID 5026 //
     /*  244595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  244606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  244609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  244612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244634 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  244637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244654 */     GIR_RootConstrainSelectedInstOperands,
     /*  244655 */     // GIR_Coverage, 5026,
     /*  244655 */     GIR_EraseRootFromParent_Done,
     /*  244656 */   // Label 4742: @244656
     /*  244656 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(244722), // Rule ID 5027 //
     /*  244661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  244672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  244675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  244678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244700 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  244703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244720 */     GIR_RootConstrainSelectedInstOperands,
     /*  244721 */     // GIR_Coverage, 5027,
     /*  244721 */     GIR_EraseRootFromParent_Done,
     /*  244722 */   // Label 4743: @244722
     /*  244722 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(244788), // Rule ID 5030 //
     /*  244727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  244738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  244741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  244744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244766 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  244769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244786 */     GIR_RootConstrainSelectedInstOperands,
     /*  244787 */     // GIR_Coverage, 5030,
     /*  244787 */     GIR_EraseRootFromParent_Done,
     /*  244788 */   // Label 4744: @244788
     /*  244788 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(244854), // Rule ID 5031 //
     /*  244793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  244804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  244807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  244810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244832 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  244835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244852 */     GIR_RootConstrainSelectedInstOperands,
     /*  244853 */     // GIR_Coverage, 5031,
     /*  244853 */     GIR_EraseRootFromParent_Done,
     /*  244854 */   // Label 4745: @244854
     /*  244854 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(244920), // Rule ID 5034 //
     /*  244859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  244870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  244873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  244876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244898 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  244898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244918 */     GIR_RootConstrainSelectedInstOperands,
     /*  244919 */     // GIR_Coverage, 5034,
     /*  244919 */     GIR_EraseRootFromParent_Done,
     /*  244920 */   // Label 4746: @244920
     /*  244920 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(244986), // Rule ID 5035 //
     /*  244925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  244936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  244939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  244942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244964 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  244964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244984 */     GIR_RootConstrainSelectedInstOperands,
     /*  244985 */     // GIR_Coverage, 5035,
     /*  244985 */     GIR_EraseRootFromParent_Done,
     /*  244986 */   // Label 4747: @244986
     /*  244986 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(245052), // Rule ID 5038 //
     /*  244991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  245008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245050 */     GIR_RootConstrainSelectedInstOperands,
     /*  245051 */     // GIR_Coverage, 5038,
     /*  245051 */     GIR_EraseRootFromParent_Done,
     /*  245052 */   // Label 4748: @245052
     /*  245052 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(245118), // Rule ID 5039 //
     /*  245057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  245074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245116 */     GIR_RootConstrainSelectedInstOperands,
     /*  245117 */     // GIR_Coverage, 5039,
     /*  245117 */     GIR_EraseRootFromParent_Done,
     /*  245118 */   // Label 4749: @245118
     /*  245118 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(245184), // Rule ID 5042 //
     /*  245123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245182 */     GIR_RootConstrainSelectedInstOperands,
     /*  245183 */     // GIR_Coverage, 5042,
     /*  245183 */     GIR_EraseRootFromParent_Done,
     /*  245184 */   // Label 4750: @245184
     /*  245184 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(245250), // Rule ID 5043 //
     /*  245189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245248 */     GIR_RootConstrainSelectedInstOperands,
     /*  245249 */     // GIR_Coverage, 5043,
     /*  245249 */     GIR_EraseRootFromParent_Done,
     /*  245250 */   // Label 4751: @245250
     /*  245250 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(245316), // Rule ID 5046 //
     /*  245255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  245266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  245269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  245272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245294 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245314 */     GIR_RootConstrainSelectedInstOperands,
     /*  245315 */     // GIR_Coverage, 5046,
     /*  245315 */     GIR_EraseRootFromParent_Done,
     /*  245316 */   // Label 4752: @245316
     /*  245316 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(245382), // Rule ID 5047 //
     /*  245321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  245332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  245335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  245338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245360 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245380 */     GIR_RootConstrainSelectedInstOperands,
     /*  245381 */     // GIR_Coverage, 5047,
     /*  245381 */     GIR_EraseRootFromParent_Done,
     /*  245382 */   // Label 4753: @245382
     /*  245382 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(245448), // Rule ID 5050 //
     /*  245387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  245398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  245401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  245404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245426 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245446 */     GIR_RootConstrainSelectedInstOperands,
     /*  245447 */     // GIR_Coverage, 5050,
     /*  245447 */     GIR_EraseRootFromParent_Done,
     /*  245448 */   // Label 4754: @245448
     /*  245448 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(245514), // Rule ID 5051 //
     /*  245453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  245464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  245467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  245470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245492 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245512 */     GIR_RootConstrainSelectedInstOperands,
     /*  245513 */     // GIR_Coverage, 5051,
     /*  245513 */     GIR_EraseRootFromParent_Done,
     /*  245514 */   // Label 4755: @245514
     /*  245514 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(245580), // Rule ID 5054 //
     /*  245519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245558 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245578 */     GIR_RootConstrainSelectedInstOperands,
     /*  245579 */     // GIR_Coverage, 5054,
     /*  245579 */     GIR_EraseRootFromParent_Done,
     /*  245580 */   // Label 4756: @245580
     /*  245580 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(245646), // Rule ID 5055 //
     /*  245585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245624 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245644 */     GIR_RootConstrainSelectedInstOperands,
     /*  245645 */     // GIR_Coverage, 5055,
     /*  245645 */     GIR_EraseRootFromParent_Done,
     /*  245646 */   // Label 4757: @245646
     /*  245646 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(245712), // Rule ID 5058 //
     /*  245651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  245662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  245665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  245668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245710 */     GIR_RootConstrainSelectedInstOperands,
     /*  245711 */     // GIR_Coverage, 5058,
     /*  245711 */     GIR_EraseRootFromParent_Done,
     /*  245712 */   // Label 4758: @245712
     /*  245712 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(245778), // Rule ID 5059 //
     /*  245717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  245728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  245731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  245734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245756 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245776 */     GIR_RootConstrainSelectedInstOperands,
     /*  245777 */     // GIR_Coverage, 5059,
     /*  245777 */     GIR_EraseRootFromParent_Done,
     /*  245778 */   // Label 4759: @245778
     /*  245778 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(245844), // Rule ID 5062 //
     /*  245783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  245794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  245797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  245800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245822 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245842 */     GIR_RootConstrainSelectedInstOperands,
     /*  245843 */     // GIR_Coverage, 5062,
     /*  245843 */     GIR_EraseRootFromParent_Done,
     /*  245844 */   // Label 4760: @245844
     /*  245844 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(245910), // Rule ID 5063 //
     /*  245849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  245860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  245863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  245866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245888 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245908 */     GIR_RootConstrainSelectedInstOperands,
     /*  245909 */     // GIR_Coverage, 5063,
     /*  245909 */     GIR_EraseRootFromParent_Done,
     /*  245910 */   // Label 4761: @245910
     /*  245910 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(245976), // Rule ID 5066 //
     /*  245915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  245926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  245929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  245932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245954 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245974 */     GIR_RootConstrainSelectedInstOperands,
     /*  245975 */     // GIR_Coverage, 5066,
     /*  245975 */     GIR_EraseRootFromParent_Done,
     /*  245976 */   // Label 4762: @245976
     /*  245976 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(246042), // Rule ID 5067 //
     /*  245981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  245992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  245995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  245998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246020 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  246023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246040 */     GIR_RootConstrainSelectedInstOperands,
     /*  246041 */     // GIR_Coverage, 5067,
     /*  246041 */     GIR_EraseRootFromParent_Done,
     /*  246042 */   // Label 4763: @246042
     /*  246042 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(246108), // Rule ID 5070 //
     /*  246047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  246058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  246061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  246089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246106 */     GIR_RootConstrainSelectedInstOperands,
     /*  246107 */     // GIR_Coverage, 5070,
     /*  246107 */     GIR_EraseRootFromParent_Done,
     /*  246108 */   // Label 4764: @246108
     /*  246108 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(246174), // Rule ID 5071 //
     /*  246113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  246124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  246127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246152 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  246155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246172 */     GIR_RootConstrainSelectedInstOperands,
     /*  246173 */     // GIR_Coverage, 5071,
     /*  246173 */     GIR_EraseRootFromParent_Done,
     /*  246174 */   // Label 4765: @246174
     /*  246174 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(246240), // Rule ID 5074 //
     /*  246179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  246190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  246193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246238 */     GIR_RootConstrainSelectedInstOperands,
     /*  246239 */     // GIR_Coverage, 5074,
     /*  246239 */     GIR_EraseRootFromParent_Done,
     /*  246240 */   // Label 4766: @246240
     /*  246240 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(246306), // Rule ID 5075 //
     /*  246245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  246256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  246259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246284 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246304 */     GIR_RootConstrainSelectedInstOperands,
     /*  246305 */     // GIR_Coverage, 5075,
     /*  246305 */     GIR_EraseRootFromParent_Done,
     /*  246306 */   // Label 4767: @246306
     /*  246306 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(246372), // Rule ID 5078 //
     /*  246311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  246328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246350 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246370 */     GIR_RootConstrainSelectedInstOperands,
     /*  246371 */     // GIR_Coverage, 5078,
     /*  246371 */     GIR_EraseRootFromParent_Done,
     /*  246372 */   // Label 4768: @246372
     /*  246372 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(246438), // Rule ID 5079 //
     /*  246377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  246394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246416 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246436 */     GIR_RootConstrainSelectedInstOperands,
     /*  246437 */     // GIR_Coverage, 5079,
     /*  246437 */     GIR_EraseRootFromParent_Done,
     /*  246438 */   // Label 4769: @246438
     /*  246438 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(246504), // Rule ID 5082 //
     /*  246443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  246460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  246485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246502 */     GIR_RootConstrainSelectedInstOperands,
     /*  246503 */     // GIR_Coverage, 5082,
     /*  246503 */     GIR_EraseRootFromParent_Done,
     /*  246504 */   // Label 4770: @246504
     /*  246504 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(246570), // Rule ID 5083 //
     /*  246509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  246526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246548 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  246551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246568 */     GIR_RootConstrainSelectedInstOperands,
     /*  246569 */     // GIR_Coverage, 5083,
     /*  246569 */     GIR_EraseRootFromParent_Done,
     /*  246570 */   // Label 4771: @246570
     /*  246570 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(246636), // Rule ID 5086 //
     /*  246575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  246586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  246589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  246592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  246617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246634 */     GIR_RootConstrainSelectedInstOperands,
     /*  246635 */     // GIR_Coverage, 5086,
     /*  246635 */     GIR_EraseRootFromParent_Done,
     /*  246636 */   // Label 4772: @246636
     /*  246636 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(246702), // Rule ID 5087 //
     /*  246641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  246652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  246655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  246658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246680 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  246683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246700 */     GIR_RootConstrainSelectedInstOperands,
     /*  246701 */     // GIR_Coverage, 5087,
     /*  246701 */     GIR_EraseRootFromParent_Done,
     /*  246702 */   // Label 4773: @246702
     /*  246702 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(246768), // Rule ID 5090 //
     /*  246707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  246724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246746 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246766 */     GIR_RootConstrainSelectedInstOperands,
     /*  246767 */     // GIR_Coverage, 5090,
     /*  246767 */     GIR_EraseRootFromParent_Done,
     /*  246768 */   // Label 4774: @246768
     /*  246768 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(246834), // Rule ID 5091 //
     /*  246773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  246790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246812 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246832 */     GIR_RootConstrainSelectedInstOperands,
     /*  246833 */     // GIR_Coverage, 5091,
     /*  246833 */     GIR_EraseRootFromParent_Done,
     /*  246834 */   // Label 4775: @246834
     /*  246834 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(246900), // Rule ID 5094 //
     /*  246839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  246856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246878 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246898 */     GIR_RootConstrainSelectedInstOperands,
     /*  246899 */     // GIR_Coverage, 5094,
     /*  246899 */     GIR_EraseRootFromParent_Done,
     /*  246900 */   // Label 4776: @246900
     /*  246900 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(246966), // Rule ID 5095 //
     /*  246905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  246922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246944 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246964 */     GIR_RootConstrainSelectedInstOperands,
     /*  246965 */     // GIR_Coverage, 5095,
     /*  246965 */     GIR_EraseRootFromParent_Done,
     /*  246966 */   // Label 4777: @246966
     /*  246966 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(247032), // Rule ID 5098 //
     /*  246971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  246982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  246985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  246988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247010 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  247013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247030 */     GIR_RootConstrainSelectedInstOperands,
     /*  247031 */     // GIR_Coverage, 5098,
     /*  247031 */     GIR_EraseRootFromParent_Done,
     /*  247032 */   // Label 4778: @247032
     /*  247032 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(247098), // Rule ID 5099 //
     /*  247037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  247054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247076 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  247079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247096 */     GIR_RootConstrainSelectedInstOperands,
     /*  247097 */     // GIR_Coverage, 5099,
     /*  247097 */     GIR_EraseRootFromParent_Done,
     /*  247098 */   // Label 4779: @247098
     /*  247098 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(247164), // Rule ID 5102 //
     /*  247103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  247120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247142 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  247145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247162 */     GIR_RootConstrainSelectedInstOperands,
     /*  247163 */     // GIR_Coverage, 5102,
     /*  247163 */     GIR_EraseRootFromParent_Done,
     /*  247164 */   // Label 4780: @247164
     /*  247164 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(247230), // Rule ID 5103 //
     /*  247169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  247186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  247211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247228 */     GIR_RootConstrainSelectedInstOperands,
     /*  247229 */     // GIR_Coverage, 5103,
     /*  247229 */     GIR_EraseRootFromParent_Done,
     /*  247230 */   // Label 4781: @247230
     /*  247230 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(247296), // Rule ID 5106 //
     /*  247235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  247277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247294 */     GIR_RootConstrainSelectedInstOperands,
     /*  247295 */     // GIR_Coverage, 5106,
     /*  247295 */     GIR_EraseRootFromParent_Done,
     /*  247296 */   // Label 4782: @247296
     /*  247296 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(247362), // Rule ID 5107 //
     /*  247301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247340 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  247343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247360 */     GIR_RootConstrainSelectedInstOperands,
     /*  247361 */     // GIR_Coverage, 5107,
     /*  247361 */     GIR_EraseRootFromParent_Done,
     /*  247362 */   // Label 4783: @247362
     /*  247362 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(247428), // Rule ID 5110 //
     /*  247367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247406 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  247409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247426 */     GIR_RootConstrainSelectedInstOperands,
     /*  247427 */     // GIR_Coverage, 5110,
     /*  247427 */     GIR_EraseRootFromParent_Done,
     /*  247428 */   // Label 4784: @247428
     /*  247428 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(247494), // Rule ID 5111 //
     /*  247433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247472 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  247475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247492 */     GIR_RootConstrainSelectedInstOperands,
     /*  247493 */     // GIR_Coverage, 5111,
     /*  247493 */     GIR_EraseRootFromParent_Done,
     /*  247494 */   // Label 4785: @247494
     /*  247494 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(247560), // Rule ID 5114 //
     /*  247499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247538 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  247541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247558 */     GIR_RootConstrainSelectedInstOperands,
     /*  247559 */     // GIR_Coverage, 5114,
     /*  247559 */     GIR_EraseRootFromParent_Done,
     /*  247560 */   // Label 4786: @247560
     /*  247560 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(247626), // Rule ID 5115 //
     /*  247565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  247607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247624 */     GIR_RootConstrainSelectedInstOperands,
     /*  247625 */     // GIR_Coverage, 5115,
     /*  247625 */     GIR_EraseRootFromParent_Done,
     /*  247626 */   // Label 4787: @247626
     /*  247626 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(247692), // Rule ID 5118 //
     /*  247631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  247648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247670 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  247673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247690 */     GIR_RootConstrainSelectedInstOperands,
     /*  247691 */     // GIR_Coverage, 5118,
     /*  247691 */     GIR_EraseRootFromParent_Done,
     /*  247692 */   // Label 4788: @247692
     /*  247692 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(247758), // Rule ID 5119 //
     /*  247697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  247714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247736 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  247739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247756 */     GIR_RootConstrainSelectedInstOperands,
     /*  247757 */     // GIR_Coverage, 5119,
     /*  247757 */     GIR_EraseRootFromParent_Done,
     /*  247758 */   // Label 4789: @247758
     /*  247758 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(247821), // Rule ID 5382 //
     /*  247763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  247774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  247777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247802 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  247802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  247805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  247819 */     GIR_RootConstrainSelectedInstOperands,
     /*  247820 */     // GIR_Coverage, 5382,
     /*  247820 */     GIR_EraseRootFromParent_Done,
     /*  247821 */   // Label 4790: @247821
     /*  247821 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(247884), // Rule ID 5383 //
     /*  247826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  247837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  247840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247865 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  247865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  247868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  247882 */     GIR_RootConstrainSelectedInstOperands,
     /*  247883 */     // GIR_Coverage, 5383,
     /*  247883 */     GIR_EraseRootFromParent_Done,
     /*  247884 */   // Label 4791: @247884
     /*  247884 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(247947), // Rule ID 5384 //
     /*  247889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  247900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  247903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247928 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  247928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  247931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  247945 */     GIR_RootConstrainSelectedInstOperands,
     /*  247946 */     // GIR_Coverage, 5384,
     /*  247946 */     GIR_EraseRootFromParent_Done,
     /*  247947 */   // Label 4792: @247947
     /*  247947 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(248010), // Rule ID 5385 //
     /*  247952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  247963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  247966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247991 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  247991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  247994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248008 */     GIR_RootConstrainSelectedInstOperands,
     /*  248009 */     // GIR_Coverage, 5385,
     /*  248009 */     GIR_EraseRootFromParent_Done,
     /*  248010 */   // Label 4793: @248010
     /*  248010 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(248073), // Rule ID 5386 //
     /*  248015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  248029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  248032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248054 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  248054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  248057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248071 */     GIR_RootConstrainSelectedInstOperands,
     /*  248072 */     // GIR_Coverage, 5386,
     /*  248072 */     GIR_EraseRootFromParent_Done,
     /*  248073 */   // Label 4794: @248073
     /*  248073 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(248136), // Rule ID 5387 //
     /*  248078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  248092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  248095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248117 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  248117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  248120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248134 */     GIR_RootConstrainSelectedInstOperands,
     /*  248135 */     // GIR_Coverage, 5387,
     /*  248135 */     GIR_EraseRootFromParent_Done,
     /*  248136 */   // Label 4795: @248136
     /*  248136 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(248199), // Rule ID 5388 //
     /*  248141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  248155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  248158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248180 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  248180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248197 */     GIR_RootConstrainSelectedInstOperands,
     /*  248198 */     // GIR_Coverage, 5388,
     /*  248198 */     GIR_EraseRootFromParent_Done,
     /*  248199 */   // Label 4796: @248199
     /*  248199 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(248262), // Rule ID 5389 //
     /*  248204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  248218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  248221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248243 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  248243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248260 */     GIR_RootConstrainSelectedInstOperands,
     /*  248261 */     // GIR_Coverage, 5389,
     /*  248261 */     GIR_EraseRootFromParent_Done,
     /*  248262 */   // Label 4797: @248262
     /*  248262 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(248325), // Rule ID 5390 //
     /*  248267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  248281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  248284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248306 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  248306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248323 */     GIR_RootConstrainSelectedInstOperands,
     /*  248324 */     // GIR_Coverage, 5390,
     /*  248324 */     GIR_EraseRootFromParent_Done,
     /*  248325 */   // Label 4798: @248325
     /*  248325 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(248388), // Rule ID 5391 //
     /*  248330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  248344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  248347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248369 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  248369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248386 */     GIR_RootConstrainSelectedInstOperands,
     /*  248387 */     // GIR_Coverage, 5391,
     /*  248387 */     GIR_EraseRootFromParent_Done,
     /*  248388 */   // Label 4799: @248388
     /*  248388 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(248451), // Rule ID 5392 //
     /*  248393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  248404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  248407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  248432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248449 */     GIR_RootConstrainSelectedInstOperands,
     /*  248450 */     // GIR_Coverage, 5392,
     /*  248450 */     GIR_EraseRootFromParent_Done,
     /*  248451 */   // Label 4800: @248451
     /*  248451 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(248514), // Rule ID 5393 //
     /*  248456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  248467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  248470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248495 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  248495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248512 */     GIR_RootConstrainSelectedInstOperands,
     /*  248513 */     // GIR_Coverage, 5393,
     /*  248513 */     GIR_EraseRootFromParent_Done,
     /*  248514 */   // Label 4801: @248514
     /*  248514 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(248577), // Rule ID 5394 //
     /*  248519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  248530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  248533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  248536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248558 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  248558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248575 */     GIR_RootConstrainSelectedInstOperands,
     /*  248576 */     // GIR_Coverage, 5394,
     /*  248576 */     GIR_EraseRootFromParent_Done,
     /*  248577 */   // Label 4802: @248577
     /*  248577 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(248640), // Rule ID 5395 //
     /*  248582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  248593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  248596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  248599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248621 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  248621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248638 */     GIR_RootConstrainSelectedInstOperands,
     /*  248639 */     // GIR_Coverage, 5395,
     /*  248639 */     GIR_EraseRootFromParent_Done,
     /*  248640 */   // Label 4803: @248640
     /*  248640 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(248703), // Rule ID 5396 //
     /*  248645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  248659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  248662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248684 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  248684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248701 */     GIR_RootConstrainSelectedInstOperands,
     /*  248702 */     // GIR_Coverage, 5396,
     /*  248702 */     GIR_EraseRootFromParent_Done,
     /*  248703 */   // Label 4804: @248703
     /*  248703 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(248766), // Rule ID 5397 //
     /*  248708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  248722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  248725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248747 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  248747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248764 */     GIR_RootConstrainSelectedInstOperands,
     /*  248765 */     // GIR_Coverage, 5397,
     /*  248765 */     GIR_EraseRootFromParent_Done,
     /*  248766 */   // Label 4805: @248766
     /*  248766 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(248829), // Rule ID 5398 //
     /*  248771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  248774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  248785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  248788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248810 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  248810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248827 */     GIR_RootConstrainSelectedInstOperands,
     /*  248828 */     // GIR_Coverage, 5398,
     /*  248828 */     GIR_EraseRootFromParent_Done,
     /*  248829 */   // Label 4806: @248829
     /*  248829 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(248892), // Rule ID 5399 //
     /*  248834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  248837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  248848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  248851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248873 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  248873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248890 */     GIR_RootConstrainSelectedInstOperands,
     /*  248891 */     // GIR_Coverage, 5399,
     /*  248891 */     GIR_EraseRootFromParent_Done,
     /*  248892 */   // Label 4807: @248892
     /*  248892 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(248955), // Rule ID 5400 //
     /*  248897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  248908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  248911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  248914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248936 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  248936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  248939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248953 */     GIR_RootConstrainSelectedInstOperands,
     /*  248954 */     // GIR_Coverage, 5400,
     /*  248954 */     GIR_EraseRootFromParent_Done,
     /*  248955 */   // Label 4808: @248955
     /*  248955 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(249018), // Rule ID 5401 //
     /*  248960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  248971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  248974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  248977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248999 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  248999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249016 */     GIR_RootConstrainSelectedInstOperands,
     /*  249017 */     // GIR_Coverage, 5401,
     /*  249017 */     GIR_EraseRootFromParent_Done,
     /*  249018 */   // Label 4809: @249018
     /*  249018 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(249081), // Rule ID 5402 //
     /*  249023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  249037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  249040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249062 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  249062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249079 */     GIR_RootConstrainSelectedInstOperands,
     /*  249080 */     // GIR_Coverage, 5402,
     /*  249080 */     GIR_EraseRootFromParent_Done,
     /*  249081 */   // Label 4810: @249081
     /*  249081 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(249144), // Rule ID 5403 //
     /*  249086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  249100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  249103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249125 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  249125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249142 */     GIR_RootConstrainSelectedInstOperands,
     /*  249143 */     // GIR_Coverage, 5403,
     /*  249143 */     GIR_EraseRootFromParent_Done,
     /*  249144 */   // Label 4811: @249144
     /*  249144 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(249207), // Rule ID 5404 //
     /*  249149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  249160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  249163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  249166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249188 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  249188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249205 */     GIR_RootConstrainSelectedInstOperands,
     /*  249206 */     // GIR_Coverage, 5404,
     /*  249206 */     GIR_EraseRootFromParent_Done,
     /*  249207 */   // Label 4812: @249207
     /*  249207 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(249270), // Rule ID 5405 //
     /*  249212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  249223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  249226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  249229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249251 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  249251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249268 */     GIR_RootConstrainSelectedInstOperands,
     /*  249269 */     // GIR_Coverage, 5405,
     /*  249269 */     GIR_EraseRootFromParent_Done,
     /*  249270 */   // Label 4813: @249270
     /*  249270 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(249333), // Rule ID 5406 //
     /*  249275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  249289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249314 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  249314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249331 */     GIR_RootConstrainSelectedInstOperands,
     /*  249332 */     // GIR_Coverage, 5406,
     /*  249332 */     GIR_EraseRootFromParent_Done,
     /*  249333 */   // Label 4814: @249333
     /*  249333 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(249396), // Rule ID 5407 //
     /*  249338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  249352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249377 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  249377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249394 */     GIR_RootConstrainSelectedInstOperands,
     /*  249395 */     // GIR_Coverage, 5407,
     /*  249395 */     GIR_EraseRootFromParent_Done,
     /*  249396 */   // Label 4815: @249396
     /*  249396 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(249459), // Rule ID 5408 //
     /*  249401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  249415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249440 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  249440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249457 */     GIR_RootConstrainSelectedInstOperands,
     /*  249458 */     // GIR_Coverage, 5408,
     /*  249458 */     GIR_EraseRootFromParent_Done,
     /*  249459 */   // Label 4816: @249459
     /*  249459 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(249522), // Rule ID 5409 //
     /*  249464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  249478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249503 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  249503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249520 */     GIR_RootConstrainSelectedInstOperands,
     /*  249521 */     // GIR_Coverage, 5409,
     /*  249521 */     GIR_EraseRootFromParent_Done,
     /*  249522 */   // Label 4817: @249522
     /*  249522 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(249585), // Rule ID 5410 //
     /*  249527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  249541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  249544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249566 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  249566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249583 */     GIR_RootConstrainSelectedInstOperands,
     /*  249584 */     // GIR_Coverage, 5410,
     /*  249584 */     GIR_EraseRootFromParent_Done,
     /*  249585 */   // Label 4818: @249585
     /*  249585 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(249648), // Rule ID 5411 //
     /*  249590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  249604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  249607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249629 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  249629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249646 */     GIR_RootConstrainSelectedInstOperands,
     /*  249647 */     // GIR_Coverage, 5411,
     /*  249647 */     GIR_EraseRootFromParent_Done,
     /*  249648 */   // Label 4819: @249648
     /*  249648 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(249711), // Rule ID 5412 //
     /*  249653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  249664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  249667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  249670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249692 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  249692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249709 */     GIR_RootConstrainSelectedInstOperands,
     /*  249710 */     // GIR_Coverage, 5412,
     /*  249710 */     GIR_EraseRootFromParent_Done,
     /*  249711 */   // Label 4820: @249711
     /*  249711 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(249774), // Rule ID 5413 //
     /*  249716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  249727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  249730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  249733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249755 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  249755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249772 */     GIR_RootConstrainSelectedInstOperands,
     /*  249773 */     // GIR_Coverage, 5413,
     /*  249773 */     GIR_EraseRootFromParent_Done,
     /*  249774 */   // Label 4821: @249774
     /*  249774 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(249837), // Rule ID 5414 //
     /*  249779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  249793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  249796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249818 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  249818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249835 */     GIR_RootConstrainSelectedInstOperands,
     /*  249836 */     // GIR_Coverage, 5414,
     /*  249836 */     GIR_EraseRootFromParent_Done,
     /*  249837 */   // Label 4822: @249837
     /*  249837 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(249900), // Rule ID 5415 //
     /*  249842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  249856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  249859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249881 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  249881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249898 */     GIR_RootConstrainSelectedInstOperands,
     /*  249899 */     // GIR_Coverage, 5415,
     /*  249899 */     GIR_EraseRootFromParent_Done,
     /*  249900 */   // Label 4823: @249900
     /*  249900 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(249963), // Rule ID 5416 //
     /*  249905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  249919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  249922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249944 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  249944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249961 */     GIR_RootConstrainSelectedInstOperands,
     /*  249962 */     // GIR_Coverage, 5416,
     /*  249962 */     GIR_EraseRootFromParent_Done,
     /*  249963 */   // Label 4824: @249963
     /*  249963 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(250026), // Rule ID 5417 //
     /*  249968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  249982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  249985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250007 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  250007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250024 */     GIR_RootConstrainSelectedInstOperands,
     /*  250025 */     // GIR_Coverage, 5417,
     /*  250025 */     GIR_EraseRootFromParent_Done,
     /*  250026 */   // Label 4825: @250026
     /*  250026 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(250089), // Rule ID 5418 //
     /*  250031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  250034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  250045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  250048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250070 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  250070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  250073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250087 */     GIR_RootConstrainSelectedInstOperands,
     /*  250088 */     // GIR_Coverage, 5418,
     /*  250088 */     GIR_EraseRootFromParent_Done,
     /*  250089 */   // Label 4826: @250089
     /*  250089 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(250152), // Rule ID 5419 //
     /*  250094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  250097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  250108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  250111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250133 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  250133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  250136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250150 */     GIR_RootConstrainSelectedInstOperands,
     /*  250151 */     // GIR_Coverage, 5419,
     /*  250151 */     GIR_EraseRootFromParent_Done,
     /*  250152 */   // Label 4827: @250152
     /*  250152 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(250215), // Rule ID 5420 //
     /*  250157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  250160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  250174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250196 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  250196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  250199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250213 */     GIR_RootConstrainSelectedInstOperands,
     /*  250214 */     // GIR_Coverage, 5420,
     /*  250214 */     GIR_EraseRootFromParent_Done,
     /*  250215 */   // Label 4828: @250215
     /*  250215 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(250278), // Rule ID 5421 //
     /*  250220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  250223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  250237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250259 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  250259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  250262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250276 */     GIR_RootConstrainSelectedInstOperands,
     /*  250277 */     // GIR_Coverage, 5421,
     /*  250277 */     GIR_EraseRootFromParent_Done,
     /*  250278 */   // Label 4829: @250278
     /*  250278 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(250341), // Rule ID 5422 //
     /*  250283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  250286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  250297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  250300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250322 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  250322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250339 */     GIR_RootConstrainSelectedInstOperands,
     /*  250340 */     // GIR_Coverage, 5422,
     /*  250340 */     GIR_EraseRootFromParent_Done,
     /*  250341 */   // Label 4830: @250341
     /*  250341 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(250404), // Rule ID 5423 //
     /*  250346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  250349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  250360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  250363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250385 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  250385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250402 */     GIR_RootConstrainSelectedInstOperands,
     /*  250403 */     // GIR_Coverage, 5423,
     /*  250403 */     GIR_EraseRootFromParent_Done,
     /*  250404 */   // Label 4831: @250404
     /*  250404 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(250467), // Rule ID 5424 //
     /*  250409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  250423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250448 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  250448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  250451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250465 */     GIR_RootConstrainSelectedInstOperands,
     /*  250466 */     // GIR_Coverage, 5424,
     /*  250466 */     GIR_EraseRootFromParent_Done,
     /*  250467 */   // Label 4832: @250467
     /*  250467 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(250530), // Rule ID 5425 //
     /*  250472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  250486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250511 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  250511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  250514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250528 */     GIR_RootConstrainSelectedInstOperands,
     /*  250529 */     // GIR_Coverage, 5425,
     /*  250529 */     GIR_EraseRootFromParent_Done,
     /*  250530 */   // Label 4833: @250530
     /*  250530 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(250593), // Rule ID 5426 //
     /*  250535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  250549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250574 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  250574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  250577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250591 */     GIR_RootConstrainSelectedInstOperands,
     /*  250592 */     // GIR_Coverage, 5426,
     /*  250592 */     GIR_EraseRootFromParent_Done,
     /*  250593 */   // Label 4834: @250593
     /*  250593 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(250656), // Rule ID 5427 //
     /*  250598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  250612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250637 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  250637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  250640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250654 */     GIR_RootConstrainSelectedInstOperands,
     /*  250655 */     // GIR_Coverage, 5427,
     /*  250655 */     GIR_EraseRootFromParent_Done,
     /*  250656 */   // Label 4835: @250656
     /*  250656 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(250719), // Rule ID 5428 //
     /*  250661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  250675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250700 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  250700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  250703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250717 */     GIR_RootConstrainSelectedInstOperands,
     /*  250718 */     // GIR_Coverage, 5428,
     /*  250718 */     GIR_EraseRootFromParent_Done,
     /*  250719 */   // Label 4836: @250719
     /*  250719 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(250782), // Rule ID 5429 //
     /*  250724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  250738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250763 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  250763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  250766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250780 */     GIR_RootConstrainSelectedInstOperands,
     /*  250781 */     // GIR_Coverage, 5429,
     /*  250781 */     GIR_EraseRootFromParent_Done,
     /*  250782 */   // Label 4837: @250782
     /*  250782 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(250845), // Rule ID 5430 //
     /*  250787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  250801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250826 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  250826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  250829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250843 */     GIR_RootConstrainSelectedInstOperands,
     /*  250844 */     // GIR_Coverage, 5430,
     /*  250844 */     GIR_EraseRootFromParent_Done,
     /*  250845 */   // Label 4838: @250845
     /*  250845 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(250908), // Rule ID 5431 //
     /*  250850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  250864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250889 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  250889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  250892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250906 */     GIR_RootConstrainSelectedInstOperands,
     /*  250907 */     // GIR_Coverage, 5431,
     /*  250907 */     GIR_EraseRootFromParent_Done,
     /*  250908 */   // Label 4839: @250908
     /*  250908 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(250971), // Rule ID 5432 //
     /*  250913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  250927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250952 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  250952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  250955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250969 */     GIR_RootConstrainSelectedInstOperands,
     /*  250970 */     // GIR_Coverage, 5432,
     /*  250970 */     GIR_EraseRootFromParent_Done,
     /*  250971 */   // Label 4840: @250971
     /*  250971 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(251034), // Rule ID 5433 //
     /*  250976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  250990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251015 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251032 */     GIR_RootConstrainSelectedInstOperands,
     /*  251033 */     // GIR_Coverage, 5433,
     /*  251033 */     GIR_EraseRootFromParent_Done,
     /*  251034 */   // Label 4841: @251034
     /*  251034 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(251097), // Rule ID 5434 //
     /*  251039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  251053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251078 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  251078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251095 */     GIR_RootConstrainSelectedInstOperands,
     /*  251096 */     // GIR_Coverage, 5434,
     /*  251096 */     GIR_EraseRootFromParent_Done,
     /*  251097 */   // Label 4842: @251097
     /*  251097 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(251160), // Rule ID 5435 //
     /*  251102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  251116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251141 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  251141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251158 */     GIR_RootConstrainSelectedInstOperands,
     /*  251159 */     // GIR_Coverage, 5435,
     /*  251159 */     GIR_EraseRootFromParent_Done,
     /*  251160 */   // Label 4843: @251160
     /*  251160 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(251223), // Rule ID 5436 //
     /*  251165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  251176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  251179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251204 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251221 */     GIR_RootConstrainSelectedInstOperands,
     /*  251222 */     // GIR_Coverage, 5436,
     /*  251222 */     GIR_EraseRootFromParent_Done,
     /*  251223 */   // Label 4844: @251223
     /*  251223 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(251286), // Rule ID 5437 //
     /*  251228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  251239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  251242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251267 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251284 */     GIR_RootConstrainSelectedInstOperands,
     /*  251285 */     // GIR_Coverage, 5437,
     /*  251285 */     GIR_EraseRootFromParent_Done,
     /*  251286 */   // Label 4845: @251286
     /*  251286 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(251349), // Rule ID 5438 //
     /*  251291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  251305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251330 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  251330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251347 */     GIR_RootConstrainSelectedInstOperands,
     /*  251348 */     // GIR_Coverage, 5438,
     /*  251348 */     GIR_EraseRootFromParent_Done,
     /*  251349 */   // Label 4846: @251349
     /*  251349 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(251412), // Rule ID 5439 //
     /*  251354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  251368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251393 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251410 */     GIR_RootConstrainSelectedInstOperands,
     /*  251411 */     // GIR_Coverage, 5439,
     /*  251411 */     GIR_EraseRootFromParent_Done,
     /*  251412 */   // Label 4847: @251412
     /*  251412 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(251475), // Rule ID 5440 //
     /*  251417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  251431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251456 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  251456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251473 */     GIR_RootConstrainSelectedInstOperands,
     /*  251474 */     // GIR_Coverage, 5440,
     /*  251474 */     GIR_EraseRootFromParent_Done,
     /*  251475 */   // Label 4848: @251475
     /*  251475 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(251538), // Rule ID 5441 //
     /*  251480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  251494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251519 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  251519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251536 */     GIR_RootConstrainSelectedInstOperands,
     /*  251537 */     // GIR_Coverage, 5441,
     /*  251537 */     GIR_EraseRootFromParent_Done,
     /*  251538 */   // Label 4849: @251538
     /*  251538 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(251601), // Rule ID 5442 //
     /*  251543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  251546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  251557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251582 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  251582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251599 */     GIR_RootConstrainSelectedInstOperands,
     /*  251600 */     // GIR_Coverage, 5442,
     /*  251600 */     GIR_EraseRootFromParent_Done,
     /*  251601 */   // Label 4850: @251601
     /*  251601 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(251664), // Rule ID 5443 //
     /*  251606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  251609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  251620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251645 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  251645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251662 */     GIR_RootConstrainSelectedInstOperands,
     /*  251663 */     // GIR_Coverage, 5443,
     /*  251663 */     GIR_EraseRootFromParent_Done,
     /*  251664 */   // Label 4851: @251664
     /*  251664 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(251727), // Rule ID 5444 //
     /*  251669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  251680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  251683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251708 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  251711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251725 */     GIR_RootConstrainSelectedInstOperands,
     /*  251726 */     // GIR_Coverage, 5444,
     /*  251726 */     GIR_EraseRootFromParent_Done,
     /*  251727 */   // Label 4852: @251727
     /*  251727 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(251790), // Rule ID 5445 //
     /*  251732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  251743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  251746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251771 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  251774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251788 */     GIR_RootConstrainSelectedInstOperands,
     /*  251789 */     // GIR_Coverage, 5445,
     /*  251789 */     GIR_EraseRootFromParent_Done,
     /*  251790 */   // Label 4853: @251790
     /*  251790 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(251853), // Rule ID 5446 //
     /*  251795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  251806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  251809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251834 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  251837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251851 */     GIR_RootConstrainSelectedInstOperands,
     /*  251852 */     // GIR_Coverage, 5446,
     /*  251852 */     GIR_EraseRootFromParent_Done,
     /*  251853 */   // Label 4854: @251853
     /*  251853 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(251916), // Rule ID 5447 //
     /*  251858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  251869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  251872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251897 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  251900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251914 */     GIR_RootConstrainSelectedInstOperands,
     /*  251915 */     // GIR_Coverage, 5447,
     /*  251915 */     GIR_EraseRootFromParent_Done,
     /*  251916 */   // Label 4855: @251916
     /*  251916 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(251979), // Rule ID 5448 //
     /*  251921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  251932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  251935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251960 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  251963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251977 */     GIR_RootConstrainSelectedInstOperands,
     /*  251978 */     // GIR_Coverage, 5448,
     /*  251978 */     GIR_EraseRootFromParent_Done,
     /*  251979 */   // Label 4856: @251979
     /*  251979 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(252042), // Rule ID 5449 //
     /*  251984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  251995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  251998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252023 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252040 */     GIR_RootConstrainSelectedInstOperands,
     /*  252041 */     // GIR_Coverage, 5449,
     /*  252041 */     GIR_EraseRootFromParent_Done,
     /*  252042 */   // Label 4857: @252042
     /*  252042 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(252105), // Rule ID 5450 //
     /*  252047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  252061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252086 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252103 */     GIR_RootConstrainSelectedInstOperands,
     /*  252104 */     // GIR_Coverage, 5450,
     /*  252104 */     GIR_EraseRootFromParent_Done,
     /*  252105 */   // Label 4858: @252105
     /*  252105 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(252168), // Rule ID 5451 //
     /*  252110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  252124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252149 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252166 */     GIR_RootConstrainSelectedInstOperands,
     /*  252167 */     // GIR_Coverage, 5451,
     /*  252167 */     GIR_EraseRootFromParent_Done,
     /*  252168 */   // Label 4859: @252168
     /*  252168 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(252231), // Rule ID 5452 //
     /*  252173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  252187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252212 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252229 */     GIR_RootConstrainSelectedInstOperands,
     /*  252230 */     // GIR_Coverage, 5452,
     /*  252230 */     GIR_EraseRootFromParent_Done,
     /*  252231 */   // Label 4860: @252231
     /*  252231 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(252294), // Rule ID 5453 //
     /*  252236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  252250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252275 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252292 */     GIR_RootConstrainSelectedInstOperands,
     /*  252293 */     // GIR_Coverage, 5453,
     /*  252293 */     GIR_EraseRootFromParent_Done,
     /*  252294 */   // Label 4861: @252294
     /*  252294 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(252357), // Rule ID 5454 //
     /*  252299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  252313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252338 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252355 */     GIR_RootConstrainSelectedInstOperands,
     /*  252356 */     // GIR_Coverage, 5454,
     /*  252356 */     GIR_EraseRootFromParent_Done,
     /*  252357 */   // Label 4862: @252357
     /*  252357 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(252420), // Rule ID 5455 //
     /*  252362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  252376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252401 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252418 */     GIR_RootConstrainSelectedInstOperands,
     /*  252419 */     // GIR_Coverage, 5455,
     /*  252419 */     GIR_EraseRootFromParent_Done,
     /*  252420 */   // Label 4863: @252420
     /*  252420 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(252483), // Rule ID 5456 //
     /*  252425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  252439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252464 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252481 */     GIR_RootConstrainSelectedInstOperands,
     /*  252482 */     // GIR_Coverage, 5456,
     /*  252482 */     GIR_EraseRootFromParent_Done,
     /*  252483 */   // Label 4864: @252483
     /*  252483 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(252546), // Rule ID 5457 //
     /*  252488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  252502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252527 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252544 */     GIR_RootConstrainSelectedInstOperands,
     /*  252545 */     // GIR_Coverage, 5457,
     /*  252545 */     GIR_EraseRootFromParent_Done,
     /*  252546 */   // Label 4865: @252546
     /*  252546 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(252609), // Rule ID 5458 //
     /*  252551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  252565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252590 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252607 */     GIR_RootConstrainSelectedInstOperands,
     /*  252608 */     // GIR_Coverage, 5458,
     /*  252608 */     GIR_EraseRootFromParent_Done,
     /*  252609 */   // Label 4866: @252609
     /*  252609 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(252672), // Rule ID 5459 //
     /*  252614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  252628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252653 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252670 */     GIR_RootConstrainSelectedInstOperands,
     /*  252671 */     // GIR_Coverage, 5459,
     /*  252671 */     GIR_EraseRootFromParent_Done,
     /*  252672 */   // Label 4867: @252672
     /*  252672 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(252735), // Rule ID 5460 //
     /*  252677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  252691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252716 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252733 */     GIR_RootConstrainSelectedInstOperands,
     /*  252734 */     // GIR_Coverage, 5460,
     /*  252734 */     GIR_EraseRootFromParent_Done,
     /*  252735 */   // Label 4868: @252735
     /*  252735 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(252798), // Rule ID 5461 //
     /*  252740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  252754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252779 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252796 */     GIR_RootConstrainSelectedInstOperands,
     /*  252797 */     // GIR_Coverage, 5461,
     /*  252797 */     GIR_EraseRootFromParent_Done,
     /*  252798 */   // Label 4869: @252798
     /*  252798 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(252861), // Rule ID 5462 //
     /*  252803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  252806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  252817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252842 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  252842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252859 */     GIR_RootConstrainSelectedInstOperands,
     /*  252860 */     // GIR_Coverage, 5462,
     /*  252860 */     GIR_EraseRootFromParent_Done,
     /*  252861 */   // Label 4870: @252861
     /*  252861 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(252924), // Rule ID 5463 //
     /*  252866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  252869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  252880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252905 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  252905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252922 */     GIR_RootConstrainSelectedInstOperands,
     /*  252923 */     // GIR_Coverage, 5463,
     /*  252923 */     GIR_EraseRootFromParent_Done,
     /*  252924 */   // Label 4871: @252924
     /*  252924 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(252987), // Rule ID 5464 //
     /*  252929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  252932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  252943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252968 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  252968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252985 */     GIR_RootConstrainSelectedInstOperands,
     /*  252986 */     // GIR_Coverage, 5464,
     /*  252986 */     GIR_EraseRootFromParent_Done,
     /*  252987 */   // Label 4872: @252987
     /*  252987 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(253050), // Rule ID 5465 //
     /*  252992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  252995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  253006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  253009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253031 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  253031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  253034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253048 */     GIR_RootConstrainSelectedInstOperands,
     /*  253049 */     // GIR_Coverage, 5465,
     /*  253049 */     GIR_EraseRootFromParent_Done,
     /*  253050 */   // Label 4873: @253050
     /*  253050 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(253113), // Rule ID 5466 //
     /*  253055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  253058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  253069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  253072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253094 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  253094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  253097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253111 */     GIR_RootConstrainSelectedInstOperands,
     /*  253112 */     // GIR_Coverage, 5466,
     /*  253112 */     GIR_EraseRootFromParent_Done,
     /*  253113 */   // Label 4874: @253113
     /*  253113 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(253176), // Rule ID 5467 //
     /*  253118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  253121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  253132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  253135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253157 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  253157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  253160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253174 */     GIR_RootConstrainSelectedInstOperands,
     /*  253175 */     // GIR_Coverage, 5467,
     /*  253175 */     GIR_EraseRootFromParent_Done,
     /*  253176 */   // Label 4875: @253176
     /*  253176 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(253239), // Rule ID 5688 //
     /*  253181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  253195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  253198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253220 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  253223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253237 */     GIR_RootConstrainSelectedInstOperands,
     /*  253238 */     // GIR_Coverage, 5688,
     /*  253238 */     GIR_EraseRootFromParent_Done,
     /*  253239 */   // Label 4876: @253239
     /*  253239 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(253302), // Rule ID 5689 //
     /*  253244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  253258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  253261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253283 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  253286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253300 */     GIR_RootConstrainSelectedInstOperands,
     /*  253301 */     // GIR_Coverage, 5689,
     /*  253301 */     GIR_EraseRootFromParent_Done,
     /*  253302 */   // Label 4877: @253302
     /*  253302 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(253365), // Rule ID 5690 //
     /*  253307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  253321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  253324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253346 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253363 */     GIR_RootConstrainSelectedInstOperands,
     /*  253364 */     // GIR_Coverage, 5690,
     /*  253364 */     GIR_EraseRootFromParent_Done,
     /*  253365 */   // Label 4878: @253365
     /*  253365 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(253428), // Rule ID 5691 //
     /*  253370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  253384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  253387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253409 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253426 */     GIR_RootConstrainSelectedInstOperands,
     /*  253427 */     // GIR_Coverage, 5691,
     /*  253427 */     GIR_EraseRootFromParent_Done,
     /*  253428 */   // Label 4879: @253428
     /*  253428 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(253491), // Rule ID 5692 //
     /*  253433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  253447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  253450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253472 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253489 */     GIR_RootConstrainSelectedInstOperands,
     /*  253490 */     // GIR_Coverage, 5692,
     /*  253490 */     GIR_EraseRootFromParent_Done,
     /*  253491 */   // Label 4880: @253491
     /*  253491 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(253554), // Rule ID 5693 //
     /*  253496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  253510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  253513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253535 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253552 */     GIR_RootConstrainSelectedInstOperands,
     /*  253553 */     // GIR_Coverage, 5693,
     /*  253553 */     GIR_EraseRootFromParent_Done,
     /*  253554 */   // Label 4881: @253554
     /*  253554 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(253617), // Rule ID 5694 //
     /*  253559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  253573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  253576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253598 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  253598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253615 */     GIR_RootConstrainSelectedInstOperands,
     /*  253616 */     // GIR_Coverage, 5694,
     /*  253616 */     GIR_EraseRootFromParent_Done,
     /*  253617 */   // Label 4882: @253617
     /*  253617 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(253680), // Rule ID 5695 //
     /*  253622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  253636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  253639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253661 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  253661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253678 */     GIR_RootConstrainSelectedInstOperands,
     /*  253679 */     // GIR_Coverage, 5695,
     /*  253679 */     GIR_EraseRootFromParent_Done,
     /*  253680 */   // Label 4883: @253680
     /*  253680 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(253743), // Rule ID 5696 //
     /*  253685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  253699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  253702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253724 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  253724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253741 */     GIR_RootConstrainSelectedInstOperands,
     /*  253742 */     // GIR_Coverage, 5696,
     /*  253742 */     GIR_EraseRootFromParent_Done,
     /*  253743 */   // Label 4884: @253743
     /*  253743 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(253806), // Rule ID 5697 //
     /*  253748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  253762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  253765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253787 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  253787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253804 */     GIR_RootConstrainSelectedInstOperands,
     /*  253805 */     // GIR_Coverage, 5697,
     /*  253805 */     GIR_EraseRootFromParent_Done,
     /*  253806 */   // Label 4885: @253806
     /*  253806 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(253869), // Rule ID 5698 //
     /*  253811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  253825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  253828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253850 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253867 */     GIR_RootConstrainSelectedInstOperands,
     /*  253868 */     // GIR_Coverage, 5698,
     /*  253868 */     GIR_EraseRootFromParent_Done,
     /*  253869 */   // Label 4886: @253869
     /*  253869 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(253932), // Rule ID 5699 //
     /*  253874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  253888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  253891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253913 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253930 */     GIR_RootConstrainSelectedInstOperands,
     /*  253931 */     // GIR_Coverage, 5699,
     /*  253931 */     GIR_EraseRootFromParent_Done,
     /*  253932 */   // Label 4887: @253932
     /*  253932 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(253995), // Rule ID 5700 //
     /*  253937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  253951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  253954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253976 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  253979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253993 */     GIR_RootConstrainSelectedInstOperands,
     /*  253994 */     // GIR_Coverage, 5700,
     /*  253994 */     GIR_EraseRootFromParent_Done,
     /*  253995 */   // Label 4888: @253995
     /*  253995 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(254058), // Rule ID 5701 //
     /*  254000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  254014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  254017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254039 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254056 */     GIR_RootConstrainSelectedInstOperands,
     /*  254057 */     // GIR_Coverage, 5701,
     /*  254057 */     GIR_EraseRootFromParent_Done,
     /*  254058 */   // Label 4889: @254058
     /*  254058 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(254121), // Rule ID 5702 //
     /*  254063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  254077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  254080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254102 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254119 */     GIR_RootConstrainSelectedInstOperands,
     /*  254120 */     // GIR_Coverage, 5702,
     /*  254120 */     GIR_EraseRootFromParent_Done,
     /*  254121 */   // Label 4890: @254121
     /*  254121 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(254184), // Rule ID 5703 //
     /*  254126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  254140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  254143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254165 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254182 */     GIR_RootConstrainSelectedInstOperands,
     /*  254183 */     // GIR_Coverage, 5703,
     /*  254183 */     GIR_EraseRootFromParent_Done,
     /*  254184 */   // Label 4891: @254184
     /*  254184 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(254247), // Rule ID 5704 //
     /*  254189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  254203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  254206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254228 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  254228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254245 */     GIR_RootConstrainSelectedInstOperands,
     /*  254246 */     // GIR_Coverage, 5704,
     /*  254246 */     GIR_EraseRootFromParent_Done,
     /*  254247 */   // Label 4892: @254247
     /*  254247 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(254310), // Rule ID 5705 //
     /*  254252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  254266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  254269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254291 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  254291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254308 */     GIR_RootConstrainSelectedInstOperands,
     /*  254309 */     // GIR_Coverage, 5705,
     /*  254309 */     GIR_EraseRootFromParent_Done,
     /*  254310 */   // Label 4893: @254310
     /*  254310 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(254373), // Rule ID 5706 //
     /*  254315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  254318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  254329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  254332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254354 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  254354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254371 */     GIR_RootConstrainSelectedInstOperands,
     /*  254372 */     // GIR_Coverage, 5706,
     /*  254372 */     GIR_EraseRootFromParent_Done,
     /*  254373 */   // Label 4894: @254373
     /*  254373 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(254436), // Rule ID 5707 //
     /*  254378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  254381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  254392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  254395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254417 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  254417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254434 */     GIR_RootConstrainSelectedInstOperands,
     /*  254435 */     // GIR_Coverage, 5707,
     /*  254435 */     GIR_EraseRootFromParent_Done,
     /*  254436 */   // Label 4895: @254436
     /*  254436 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(254499), // Rule ID 5708 //
     /*  254441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  254452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  254455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  254458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254480 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254497 */     GIR_RootConstrainSelectedInstOperands,
     /*  254498 */     // GIR_Coverage, 5708,
     /*  254498 */     GIR_EraseRootFromParent_Done,
     /*  254499 */   // Label 4896: @254499
     /*  254499 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(254562), // Rule ID 5709 //
     /*  254504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  254515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  254518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  254521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254543 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254560 */     GIR_RootConstrainSelectedInstOperands,
     /*  254561 */     // GIR_Coverage, 5709,
     /*  254561 */     GIR_EraseRootFromParent_Done,
     /*  254562 */   // Label 4897: @254562
     /*  254562 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(254625), // Rule ID 5710 //
     /*  254567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  254578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  254581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  254584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254606 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  254609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254623 */     GIR_RootConstrainSelectedInstOperands,
     /*  254624 */     // GIR_Coverage, 5710,
     /*  254624 */     GIR_EraseRootFromParent_Done,
     /*  254625 */   // Label 4898: @254625
     /*  254625 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(254688), // Rule ID 5711 //
     /*  254630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  254641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  254644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  254647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254669 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  254672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254686 */     GIR_RootConstrainSelectedInstOperands,
     /*  254687 */     // GIR_Coverage, 5711,
     /*  254687 */     GIR_EraseRootFromParent_Done,
     /*  254688 */   // Label 4899: @254688
     /*  254688 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(254751), // Rule ID 5712 //
     /*  254693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  254704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  254707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  254710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254732 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  254735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254749 */     GIR_RootConstrainSelectedInstOperands,
     /*  254750 */     // GIR_Coverage, 5712,
     /*  254750 */     GIR_EraseRootFromParent_Done,
     /*  254751 */   // Label 4900: @254751
     /*  254751 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(254814), // Rule ID 5713 //
     /*  254756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  254767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  254770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  254773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254795 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  254798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254812 */     GIR_RootConstrainSelectedInstOperands,
     /*  254813 */     // GIR_Coverage, 5713,
     /*  254813 */     GIR_EraseRootFromParent_Done,
     /*  254814 */   // Label 4901: @254814
     /*  254814 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(254877), // Rule ID 5714 //
     /*  254819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  254833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  254836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254858 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254875 */     GIR_RootConstrainSelectedInstOperands,
     /*  254876 */     // GIR_Coverage, 5714,
     /*  254876 */     GIR_EraseRootFromParent_Done,
     /*  254877 */   // Label 4902: @254877
     /*  254877 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(254940), // Rule ID 5715 //
     /*  254882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  254896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  254899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254921 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254938 */     GIR_RootConstrainSelectedInstOperands,
     /*  254939 */     // GIR_Coverage, 5715,
     /*  254939 */     GIR_EraseRootFromParent_Done,
     /*  254940 */   // Label 4903: @254940
     /*  254940 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(255003), // Rule ID 5716 //
     /*  254945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  254956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  254959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  254962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254984 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  254987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255001 */     GIR_RootConstrainSelectedInstOperands,
     /*  255002 */     // GIR_Coverage, 5716,
     /*  255002 */     GIR_EraseRootFromParent_Done,
     /*  255003 */   // Label 4904: @255003
     /*  255003 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(255066), // Rule ID 5717 //
     /*  255008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  255022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  255025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255047 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255064 */     GIR_RootConstrainSelectedInstOperands,
     /*  255065 */     // GIR_Coverage, 5717,
     /*  255065 */     GIR_EraseRootFromParent_Done,
     /*  255066 */   // Label 4905: @255066
     /*  255066 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(255129), // Rule ID 5718 //
     /*  255071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  255085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  255088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255110 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255127 */     GIR_RootConstrainSelectedInstOperands,
     /*  255128 */     // GIR_Coverage, 5718,
     /*  255128 */     GIR_EraseRootFromParent_Done,
     /*  255129 */   // Label 4906: @255129
     /*  255129 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(255192), // Rule ID 5719 //
     /*  255134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  255148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  255151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255173 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255190 */     GIR_RootConstrainSelectedInstOperands,
     /*  255191 */     // GIR_Coverage, 5719,
     /*  255191 */     GIR_EraseRootFromParent_Done,
     /*  255192 */   // Label 4907: @255192
     /*  255192 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(255255), // Rule ID 5720 //
     /*  255197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  255211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  255214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255236 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255253 */     GIR_RootConstrainSelectedInstOperands,
     /*  255254 */     // GIR_Coverage, 5720,
     /*  255254 */     GIR_EraseRootFromParent_Done,
     /*  255255 */   // Label 4908: @255255
     /*  255255 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(255318), // Rule ID 5721 //
     /*  255260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  255274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  255277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255299 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  255299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255316 */     GIR_RootConstrainSelectedInstOperands,
     /*  255317 */     // GIR_Coverage, 5721,
     /*  255317 */     GIR_EraseRootFromParent_Done,
     /*  255318 */   // Label 4909: @255318
     /*  255318 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(255381), // Rule ID 5722 //
     /*  255323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  255337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  255340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255362 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255379 */     GIR_RootConstrainSelectedInstOperands,
     /*  255380 */     // GIR_Coverage, 5722,
     /*  255380 */     GIR_EraseRootFromParent_Done,
     /*  255381 */   // Label 4910: @255381
     /*  255381 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(255444), // Rule ID 5723 //
     /*  255386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  255400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  255403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255425 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  255425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255442 */     GIR_RootConstrainSelectedInstOperands,
     /*  255443 */     // GIR_Coverage, 5723,
     /*  255443 */     GIR_EraseRootFromParent_Done,
     /*  255444 */   // Label 4911: @255444
     /*  255444 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(255507), // Rule ID 5724 //
     /*  255449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  255463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  255466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255488 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255505 */     GIR_RootConstrainSelectedInstOperands,
     /*  255506 */     // GIR_Coverage, 5724,
     /*  255506 */     GIR_EraseRootFromParent_Done,
     /*  255507 */   // Label 4912: @255507
     /*  255507 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(255570), // Rule ID 5725 //
     /*  255512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  255526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  255529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255551 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  255551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255568 */     GIR_RootConstrainSelectedInstOperands,
     /*  255569 */     // GIR_Coverage, 5725,
     /*  255569 */     GIR_EraseRootFromParent_Done,
     /*  255570 */   // Label 4913: @255570
     /*  255570 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(255633), // Rule ID 5726 //
     /*  255575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  255578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  255586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  255589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  255592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255614 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  255614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255631 */     GIR_RootConstrainSelectedInstOperands,
     /*  255632 */     // GIR_Coverage, 5726,
     /*  255632 */     GIR_EraseRootFromParent_Done,
     /*  255633 */   // Label 4914: @255633
     /*  255633 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(255696), // Rule ID 5727 //
     /*  255638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  255641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  255649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  255652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  255655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255677 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  255677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255694 */     GIR_RootConstrainSelectedInstOperands,
     /*  255695 */     // GIR_Coverage, 5727,
     /*  255695 */     GIR_EraseRootFromParent_Done,
     /*  255696 */   // Label 4915: @255696
     /*  255696 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(255759), // Rule ID 5728 //
     /*  255701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  255704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  255715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  255718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255740 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  255740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255757 */     GIR_RootConstrainSelectedInstOperands,
     /*  255758 */     // GIR_Coverage, 5728,
     /*  255758 */     GIR_EraseRootFromParent_Done,
     /*  255759 */   // Label 4916: @255759
     /*  255759 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(255822), // Rule ID 5729 //
     /*  255764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  255767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  255778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  255781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255803 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  255803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255820 */     GIR_RootConstrainSelectedInstOperands,
     /*  255821 */     // GIR_Coverage, 5729,
     /*  255821 */     GIR_EraseRootFromParent_Done,
     /*  255822 */   // Label 4917: @255822
     /*  255822 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(255885), // Rule ID 5730 //
     /*  255827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  255830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  255841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  255844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255866 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  255866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255883 */     GIR_RootConstrainSelectedInstOperands,
     /*  255884 */     // GIR_Coverage, 5730,
     /*  255884 */     GIR_EraseRootFromParent_Done,
     /*  255885 */   // Label 4918: @255885
     /*  255885 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(255948), // Rule ID 5731 //
     /*  255890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  255893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  255904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  255907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255929 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  255929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255946 */     GIR_RootConstrainSelectedInstOperands,
     /*  255947 */     // GIR_Coverage, 5731,
     /*  255947 */     GIR_EraseRootFromParent_Done,
     /*  255948 */   // Label 4919: @255948
     /*  255948 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(256011), // Rule ID 5732 //
     /*  255953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  255964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  255967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255992 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  255995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256009 */     GIR_RootConstrainSelectedInstOperands,
     /*  256010 */     // GIR_Coverage, 5732,
     /*  256010 */     GIR_EraseRootFromParent_Done,
     /*  256011 */   // Label 4920: @256011
     /*  256011 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(256074), // Rule ID 5733 //
     /*  256016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  256030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256055 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  256058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256072 */     GIR_RootConstrainSelectedInstOperands,
     /*  256073 */     // GIR_Coverage, 5733,
     /*  256073 */     GIR_EraseRootFromParent_Done,
     /*  256074 */   // Label 4921: @256074
     /*  256074 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(256137), // Rule ID 5734 //
     /*  256079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  256093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256118 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256135 */     GIR_RootConstrainSelectedInstOperands,
     /*  256136 */     // GIR_Coverage, 5734,
     /*  256136 */     GIR_EraseRootFromParent_Done,
     /*  256137 */   // Label 4922: @256137
     /*  256137 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(256200), // Rule ID 5735 //
     /*  256142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  256156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256181 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256198 */     GIR_RootConstrainSelectedInstOperands,
     /*  256199 */     // GIR_Coverage, 5735,
     /*  256199 */     GIR_EraseRootFromParent_Done,
     /*  256200 */   // Label 4923: @256200
     /*  256200 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(256263), // Rule ID 5736 //
     /*  256205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  256219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256261 */     GIR_RootConstrainSelectedInstOperands,
     /*  256262 */     // GIR_Coverage, 5736,
     /*  256262 */     GIR_EraseRootFromParent_Done,
     /*  256263 */   // Label 4924: @256263
     /*  256263 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(256326), // Rule ID 5737 //
     /*  256268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  256282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256307 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256324 */     GIR_RootConstrainSelectedInstOperands,
     /*  256325 */     // GIR_Coverage, 5737,
     /*  256325 */     GIR_EraseRootFromParent_Done,
     /*  256326 */   // Label 4925: @256326
     /*  256326 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(256389), // Rule ID 5738 //
     /*  256331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  256345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256370 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256387 */     GIR_RootConstrainSelectedInstOperands,
     /*  256388 */     // GIR_Coverage, 5738,
     /*  256388 */     GIR_EraseRootFromParent_Done,
     /*  256389 */   // Label 4926: @256389
     /*  256389 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(256452), // Rule ID 5739 //
     /*  256394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  256408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256433 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256450 */     GIR_RootConstrainSelectedInstOperands,
     /*  256451 */     // GIR_Coverage, 5739,
     /*  256451 */     GIR_EraseRootFromParent_Done,
     /*  256452 */   // Label 4927: @256452
     /*  256452 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(256515), // Rule ID 5740 //
     /*  256457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  256471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256496 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256513 */     GIR_RootConstrainSelectedInstOperands,
     /*  256514 */     // GIR_Coverage, 5740,
     /*  256514 */     GIR_EraseRootFromParent_Done,
     /*  256515 */   // Label 4928: @256515
     /*  256515 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(256578), // Rule ID 5741 //
     /*  256520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  256534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256559 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256576 */     GIR_RootConstrainSelectedInstOperands,
     /*  256577 */     // GIR_Coverage, 5741,
     /*  256577 */     GIR_EraseRootFromParent_Done,
     /*  256578 */   // Label 4929: @256578
     /*  256578 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(256641), // Rule ID 5742 //
     /*  256583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  256597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256622 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  256622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256639 */     GIR_RootConstrainSelectedInstOperands,
     /*  256640 */     // GIR_Coverage, 5742,
     /*  256640 */     GIR_EraseRootFromParent_Done,
     /*  256641 */   // Label 4930: @256641
     /*  256641 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(256704), // Rule ID 5743 //
     /*  256646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  256660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256685 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  256685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256702 */     GIR_RootConstrainSelectedInstOperands,
     /*  256703 */     // GIR_Coverage, 5743,
     /*  256703 */     GIR_EraseRootFromParent_Done,
     /*  256704 */   // Label 4931: @256704
     /*  256704 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(256767), // Rule ID 5744 //
     /*  256709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  256723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256748 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256765 */     GIR_RootConstrainSelectedInstOperands,
     /*  256766 */     // GIR_Coverage, 5744,
     /*  256766 */     GIR_EraseRootFromParent_Done,
     /*  256767 */   // Label 4932: @256767
     /*  256767 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(256830), // Rule ID 5745 //
     /*  256772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  256786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256811 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256828 */     GIR_RootConstrainSelectedInstOperands,
     /*  256829 */     // GIR_Coverage, 5745,
     /*  256829 */     GIR_EraseRootFromParent_Done,
     /*  256830 */   // Label 4933: @256830
     /*  256830 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(256893), // Rule ID 5746 //
     /*  256835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  256849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256874 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256891 */     GIR_RootConstrainSelectedInstOperands,
     /*  256892 */     // GIR_Coverage, 5746,
     /*  256892 */     GIR_EraseRootFromParent_Done,
     /*  256893 */   // Label 4934: @256893
     /*  256893 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(256956), // Rule ID 5747 //
     /*  256898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  256912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256937 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256954 */     GIR_RootConstrainSelectedInstOperands,
     /*  256955 */     // GIR_Coverage, 5747,
     /*  256955 */     GIR_EraseRootFromParent_Done,
     /*  256956 */   // Label 4935: @256956
     /*  256956 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(257019), // Rule ID 5748 //
     /*  256961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  256975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257000 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  257000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257017 */     GIR_RootConstrainSelectedInstOperands,
     /*  257018 */     // GIR_Coverage, 5748,
     /*  257018 */     GIR_EraseRootFromParent_Done,
     /*  257019 */   // Label 4936: @257019
     /*  257019 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(257082), // Rule ID 5749 //
     /*  257024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  257038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257063 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  257063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257080 */     GIR_RootConstrainSelectedInstOperands,
     /*  257081 */     // GIR_Coverage, 5749,
     /*  257081 */     GIR_EraseRootFromParent_Done,
     /*  257082 */   // Label 4937: @257082
     /*  257082 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(257145), // Rule ID 5750 //
     /*  257087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  257090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  257101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257126 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  257126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  257143 */     GIR_RootConstrainSelectedInstOperands,
     /*  257144 */     // GIR_Coverage, 5750,
     /*  257144 */     GIR_EraseRootFromParent_Done,
     /*  257145 */   // Label 4938: @257145
     /*  257145 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(257208), // Rule ID 5751 //
     /*  257150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  257153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  257164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257189 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  257189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  257206 */     GIR_RootConstrainSelectedInstOperands,
     /*  257207 */     // GIR_Coverage, 5751,
     /*  257207 */     GIR_EraseRootFromParent_Done,
     /*  257208 */   // Label 4939: @257208
     /*  257208 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(257271), // Rule ID 5752 //
     /*  257213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  257227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257252 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257269 */     GIR_RootConstrainSelectedInstOperands,
     /*  257270 */     // GIR_Coverage, 5752,
     /*  257270 */     GIR_EraseRootFromParent_Done,
     /*  257271 */   // Label 4940: @257271
     /*  257271 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(257334), // Rule ID 5753 //
     /*  257276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  257290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257315 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257332 */     GIR_RootConstrainSelectedInstOperands,
     /*  257333 */     // GIR_Coverage, 5753,
     /*  257333 */     GIR_EraseRootFromParent_Done,
     /*  257334 */   // Label 4941: @257334
     /*  257334 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(257397), // Rule ID 5754 //
     /*  257339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  257353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257378 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257395 */     GIR_RootConstrainSelectedInstOperands,
     /*  257396 */     // GIR_Coverage, 5754,
     /*  257396 */     GIR_EraseRootFromParent_Done,
     /*  257397 */   // Label 4942: @257397
     /*  257397 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(257460), // Rule ID 5755 //
     /*  257402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  257416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257441 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257458 */     GIR_RootConstrainSelectedInstOperands,
     /*  257459 */     // GIR_Coverage, 5755,
     /*  257459 */     GIR_EraseRootFromParent_Done,
     /*  257460 */   // Label 4943: @257460
     /*  257460 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(257523), // Rule ID 5756 //
     /*  257465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  257476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  257479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257504 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257521 */     GIR_RootConstrainSelectedInstOperands,
     /*  257522 */     // GIR_Coverage, 5756,
     /*  257522 */     GIR_EraseRootFromParent_Done,
     /*  257523 */   // Label 4944: @257523
     /*  257523 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(257586), // Rule ID 5757 //
     /*  257528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  257539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  257542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257567 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257584 */     GIR_RootConstrainSelectedInstOperands,
     /*  257585 */     // GIR_Coverage, 5757,
     /*  257585 */     GIR_EraseRootFromParent_Done,
     /*  257586 */   // Label 4945: @257586
     /*  257586 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(257649), // Rule ID 5758 //
     /*  257591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  257605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257630 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257647 */     GIR_RootConstrainSelectedInstOperands,
     /*  257648 */     // GIR_Coverage, 5758,
     /*  257648 */     GIR_EraseRootFromParent_Done,
     /*  257649 */   // Label 4946: @257649
     /*  257649 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(257712), // Rule ID 5759 //
     /*  257654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  257668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257693 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257710 */     GIR_RootConstrainSelectedInstOperands,
     /*  257711 */     // GIR_Coverage, 5759,
     /*  257711 */     GIR_EraseRootFromParent_Done,
     /*  257712 */   // Label 4947: @257712
     /*  257712 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(257775), // Rule ID 5760 //
     /*  257717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  257731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257756 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257773 */     GIR_RootConstrainSelectedInstOperands,
     /*  257774 */     // GIR_Coverage, 5760,
     /*  257774 */     GIR_EraseRootFromParent_Done,
     /*  257775 */   // Label 4948: @257775
     /*  257775 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(257838), // Rule ID 5761 //
     /*  257780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  257794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257819 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257836 */     GIR_RootConstrainSelectedInstOperands,
     /*  257837 */     // GIR_Coverage, 5761,
     /*  257837 */     GIR_EraseRootFromParent_Done,
     /*  257838 */   // Label 4949: @257838
     /*  257838 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(257901), // Rule ID 5762 //
     /*  257843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  257857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257882 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257899 */     GIR_RootConstrainSelectedInstOperands,
     /*  257900 */     // GIR_Coverage, 5762,
     /*  257900 */     GIR_EraseRootFromParent_Done,
     /*  257901 */   // Label 4950: @257901
     /*  257901 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(257964), // Rule ID 5763 //
     /*  257906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  257920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257945 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257962 */     GIR_RootConstrainSelectedInstOperands,
     /*  257963 */     // GIR_Coverage, 5763,
     /*  257963 */     GIR_EraseRootFromParent_Done,
     /*  257964 */   // Label 4951: @257964
     /*  257964 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(258027), // Rule ID 5764 //
     /*  257969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  257983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258008 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258025 */     GIR_RootConstrainSelectedInstOperands,
     /*  258026 */     // GIR_Coverage, 5764,
     /*  258026 */     GIR_EraseRootFromParent_Done,
     /*  258027 */   // Label 4952: @258027
     /*  258027 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(258090), // Rule ID 5765 //
     /*  258032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  258046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258071 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258088 */     GIR_RootConstrainSelectedInstOperands,
     /*  258089 */     // GIR_Coverage, 5765,
     /*  258089 */     GIR_EraseRootFromParent_Done,
     /*  258090 */   // Label 4953: @258090
     /*  258090 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(258153), // Rule ID 5766 //
     /*  258095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  258109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258134 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258151 */     GIR_RootConstrainSelectedInstOperands,
     /*  258152 */     // GIR_Coverage, 5766,
     /*  258152 */     GIR_EraseRootFromParent_Done,
     /*  258153 */   // Label 4954: @258153
     /*  258153 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(258216), // Rule ID 5767 //
     /*  258158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  258172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258197 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258214 */     GIR_RootConstrainSelectedInstOperands,
     /*  258215 */     // GIR_Coverage, 5767,
     /*  258215 */     GIR_EraseRootFromParent_Done,
     /*  258216 */   // Label 4955: @258216
     /*  258216 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(258279), // Rule ID 5768 //
     /*  258221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  258235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258260 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258277 */     GIR_RootConstrainSelectedInstOperands,
     /*  258278 */     // GIR_Coverage, 5768,
     /*  258278 */     GIR_EraseRootFromParent_Done,
     /*  258279 */   // Label 4956: @258279
     /*  258279 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(258342), // Rule ID 5769 //
     /*  258284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  258298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258323 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258340 */     GIR_RootConstrainSelectedInstOperands,
     /*  258341 */     // GIR_Coverage, 5769,
     /*  258341 */     GIR_EraseRootFromParent_Done,
     /*  258342 */   // Label 4957: @258342
     /*  258342 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(258405), // Rule ID 5770 //
     /*  258347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  258350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  258361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258386 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  258386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258403 */     GIR_RootConstrainSelectedInstOperands,
     /*  258404 */     // GIR_Coverage, 5770,
     /*  258404 */     GIR_EraseRootFromParent_Done,
     /*  258405 */   // Label 4958: @258405
     /*  258405 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(258468), // Rule ID 5771 //
     /*  258410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  258413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  258424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258449 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  258449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258466 */     GIR_RootConstrainSelectedInstOperands,
     /*  258467 */     // GIR_Coverage, 5771,
     /*  258467 */     GIR_EraseRootFromParent_Done,
     /*  258468 */   // Label 4959: @258468
     /*  258468 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(258531), // Rule ID 5772 //
     /*  258473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  258476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  258487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  258512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258529 */     GIR_RootConstrainSelectedInstOperands,
     /*  258530 */     // GIR_Coverage, 5772,
     /*  258530 */     GIR_EraseRootFromParent_Done,
     /*  258531 */   // Label 4960: @258531
     /*  258531 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(258594), // Rule ID 5773 //
     /*  258536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  258539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  258550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258575 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  258575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258592 */     GIR_RootConstrainSelectedInstOperands,
     /*  258593 */     // GIR_Coverage, 5773,
     /*  258593 */     GIR_EraseRootFromParent_Done,
     /*  258594 */   // Label 4961: @258594
     /*  258594 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(258657), // Rule ID 5774 //
     /*  258599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  258602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  258613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258638 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  258638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258655 */     GIR_RootConstrainSelectedInstOperands,
     /*  258656 */     // GIR_Coverage, 5774,
     /*  258656 */     GIR_EraseRootFromParent_Done,
     /*  258657 */   // Label 4962: @258657
     /*  258657 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(258720), // Rule ID 5775 //
     /*  258662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  258665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  258676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258701 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  258701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258718 */     GIR_RootConstrainSelectedInstOperands,
     /*  258719 */     // GIR_Coverage, 5775,
     /*  258719 */     GIR_EraseRootFromParent_Done,
     /*  258720 */   // Label 4963: @258720
     /*  258720 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(258783), // Rule ID 7808 //
     /*  258725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  258739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  258742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258764 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  258764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  258767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258781 */     GIR_RootConstrainSelectedInstOperands,
     /*  258782 */     // GIR_Coverage, 7808,
     /*  258782 */     GIR_EraseRootFromParent_Done,
     /*  258783 */   // Label 4964: @258783
     /*  258783 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(258846), // Rule ID 7809 //
     /*  258788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  258802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  258805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258827 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  258830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258844 */     GIR_RootConstrainSelectedInstOperands,
     /*  258845 */     // GIR_Coverage, 7809,
     /*  258845 */     GIR_EraseRootFromParent_Done,
     /*  258846 */   // Label 4965: @258846
     /*  258846 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(258909), // Rule ID 7812 //
     /*  258851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  258865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  258868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258890 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  258890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  258893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258907 */     GIR_RootConstrainSelectedInstOperands,
     /*  258908 */     // GIR_Coverage, 7812,
     /*  258908 */     GIR_EraseRootFromParent_Done,
     /*  258909 */   // Label 4966: @258909
     /*  258909 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(258972), // Rule ID 7813 //
     /*  258914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  258928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  258931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258953 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  258956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258970 */     GIR_RootConstrainSelectedInstOperands,
     /*  258971 */     // GIR_Coverage, 7813,
     /*  258971 */     GIR_EraseRootFromParent_Done,
     /*  258972 */   // Label 4967: @258972
     /*  258972 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(259035), // Rule ID 7816 //
     /*  258977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  258988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  258991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  258994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259016 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  259019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259033 */     GIR_RootConstrainSelectedInstOperands,
     /*  259034 */     // GIR_Coverage, 7816,
     /*  259034 */     GIR_EraseRootFromParent_Done,
     /*  259035 */   // Label 4968: @259035
     /*  259035 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(259098), // Rule ID 7817 //
     /*  259040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  259054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  259057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259079 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  259082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259096 */     GIR_RootConstrainSelectedInstOperands,
     /*  259097 */     // GIR_Coverage, 7817,
     /*  259097 */     GIR_EraseRootFromParent_Done,
     /*  259098 */   // Label 4969: @259098
     /*  259098 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(259161), // Rule ID 7820 //
     /*  259103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  259117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  259120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259142 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259159 */     GIR_RootConstrainSelectedInstOperands,
     /*  259160 */     // GIR_Coverage, 7820,
     /*  259160 */     GIR_EraseRootFromParent_Done,
     /*  259161 */   // Label 4970: @259161
     /*  259161 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(259224), // Rule ID 7821 //
     /*  259166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  259180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  259183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259205 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259222 */     GIR_RootConstrainSelectedInstOperands,
     /*  259223 */     // GIR_Coverage, 7821,
     /*  259223 */     GIR_EraseRootFromParent_Done,
     /*  259224 */   // Label 4971: @259224
     /*  259224 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(259287), // Rule ID 7824 //
     /*  259229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  259243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  259246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259268 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  259268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259285 */     GIR_RootConstrainSelectedInstOperands,
     /*  259286 */     // GIR_Coverage, 7824,
     /*  259286 */     GIR_EraseRootFromParent_Done,
     /*  259287 */   // Label 4972: @259287
     /*  259287 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(259350), // Rule ID 7825 //
     /*  259292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  259306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  259309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259331 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  259331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259348 */     GIR_RootConstrainSelectedInstOperands,
     /*  259349 */     // GIR_Coverage, 7825,
     /*  259349 */     GIR_EraseRootFromParent_Done,
     /*  259350 */   // Label 4973: @259350
     /*  259350 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(259413), // Rule ID 7828 //
     /*  259355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  259369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  259372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259394 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259411 */     GIR_RootConstrainSelectedInstOperands,
     /*  259412 */     // GIR_Coverage, 7828,
     /*  259412 */     GIR_EraseRootFromParent_Done,
     /*  259413 */   // Label 4974: @259413
     /*  259413 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(259476), // Rule ID 7829 //
     /*  259418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  259432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  259435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259457 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259474 */     GIR_RootConstrainSelectedInstOperands,
     /*  259475 */     // GIR_Coverage, 7829,
     /*  259475 */     GIR_EraseRootFromParent_Done,
     /*  259476 */   // Label 4975: @259476
     /*  259476 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(259539), // Rule ID 7832 //
     /*  259481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  259495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  259498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259520 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259537 */     GIR_RootConstrainSelectedInstOperands,
     /*  259538 */     // GIR_Coverage, 7832,
     /*  259538 */     GIR_EraseRootFromParent_Done,
     /*  259539 */   // Label 4976: @259539
     /*  259539 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(259602), // Rule ID 7833 //
     /*  259544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  259558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  259561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259583 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259600 */     GIR_RootConstrainSelectedInstOperands,
     /*  259601 */     // GIR_Coverage, 7833,
     /*  259601 */     GIR_EraseRootFromParent_Done,
     /*  259602 */   // Label 4977: @259602
     /*  259602 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(259665), // Rule ID 7836 //
     /*  259607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  259621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  259624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259646 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  259646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259663 */     GIR_RootConstrainSelectedInstOperands,
     /*  259664 */     // GIR_Coverage, 7836,
     /*  259664 */     GIR_EraseRootFromParent_Done,
     /*  259665 */   // Label 4978: @259665
     /*  259665 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(259728), // Rule ID 7837 //
     /*  259670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  259684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  259687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259709 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  259709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259726 */     GIR_RootConstrainSelectedInstOperands,
     /*  259727 */     // GIR_Coverage, 7837,
     /*  259727 */     GIR_EraseRootFromParent_Done,
     /*  259728 */   // Label 4979: @259728
     /*  259728 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(259791), // Rule ID 7840 //
     /*  259733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  259736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  259747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  259750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259772 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  259772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259789 */     GIR_RootConstrainSelectedInstOperands,
     /*  259790 */     // GIR_Coverage, 7840,
     /*  259790 */     GIR_EraseRootFromParent_Done,
     /*  259791 */   // Label 4980: @259791
     /*  259791 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(259854), // Rule ID 7841 //
     /*  259796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  259799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  259810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  259813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259835 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  259835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259852 */     GIR_RootConstrainSelectedInstOperands,
     /*  259853 */     // GIR_Coverage, 7841,
     /*  259853 */     GIR_EraseRootFromParent_Done,
     /*  259854 */   // Label 4981: @259854
     /*  259854 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(259917), // Rule ID 7844 //
     /*  259859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  259870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  259873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  259876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259898 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  259901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259915 */     GIR_RootConstrainSelectedInstOperands,
     /*  259916 */     // GIR_Coverage, 7844,
     /*  259916 */     GIR_EraseRootFromParent_Done,
     /*  259917 */   // Label 4982: @259917
     /*  259917 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(259980), // Rule ID 7845 //
     /*  259922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  259933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  259936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  259939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259961 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  259964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259978 */     GIR_RootConstrainSelectedInstOperands,
     /*  259979 */     // GIR_Coverage, 7845,
     /*  259979 */     GIR_EraseRootFromParent_Done,
     /*  259980 */   // Label 4983: @259980
     /*  259980 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(260043), // Rule ID 7848 //
     /*  259985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  259996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  259999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  260002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260024 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260041 */     GIR_RootConstrainSelectedInstOperands,
     /*  260042 */     // GIR_Coverage, 7848,
     /*  260042 */     GIR_EraseRootFromParent_Done,
     /*  260043 */   // Label 4984: @260043
     /*  260043 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(260106), // Rule ID 7849 //
     /*  260048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  260059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  260062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  260065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260087 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260104 */     GIR_RootConstrainSelectedInstOperands,
     /*  260105 */     // GIR_Coverage, 7849,
     /*  260105 */     GIR_EraseRootFromParent_Done,
     /*  260106 */   // Label 4985: @260106
     /*  260106 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(260169), // Rule ID 7852 //
     /*  260111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  260122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  260125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  260128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260150 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260167 */     GIR_RootConstrainSelectedInstOperands,
     /*  260168 */     // GIR_Coverage, 7852,
     /*  260168 */     GIR_EraseRootFromParent_Done,
     /*  260169 */   // Label 4986: @260169
     /*  260169 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(260232), // Rule ID 7853 //
     /*  260174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  260185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  260188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  260191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260213 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260230 */     GIR_RootConstrainSelectedInstOperands,
     /*  260231 */     // GIR_Coverage, 7853,
     /*  260231 */     GIR_EraseRootFromParent_Done,
     /*  260232 */   // Label 4987: @260232
     /*  260232 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(260295), // Rule ID 7856 //
     /*  260237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  260251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  260254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260276 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260293 */     GIR_RootConstrainSelectedInstOperands,
     /*  260294 */     // GIR_Coverage, 7856,
     /*  260294 */     GIR_EraseRootFromParent_Done,
     /*  260295 */   // Label 4988: @260295
     /*  260295 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(260358), // Rule ID 7857 //
     /*  260300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  260314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  260317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260339 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260356 */     GIR_RootConstrainSelectedInstOperands,
     /*  260357 */     // GIR_Coverage, 7857,
     /*  260357 */     GIR_EraseRootFromParent_Done,
     /*  260358 */   // Label 4989: @260358
     /*  260358 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(260421), // Rule ID 7860 //
     /*  260363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  260377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  260380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260402 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260419 */     GIR_RootConstrainSelectedInstOperands,
     /*  260420 */     // GIR_Coverage, 7860,
     /*  260420 */     GIR_EraseRootFromParent_Done,
     /*  260421 */   // Label 4990: @260421
     /*  260421 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(260484), // Rule ID 7861 //
     /*  260426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  260440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  260443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260465 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260482 */     GIR_RootConstrainSelectedInstOperands,
     /*  260483 */     // GIR_Coverage, 7861,
     /*  260483 */     GIR_EraseRootFromParent_Done,
     /*  260484 */   // Label 4991: @260484
     /*  260484 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(260547), // Rule ID 7864 //
     /*  260489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  260500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  260503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  260506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260528 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260545 */     GIR_RootConstrainSelectedInstOperands,
     /*  260546 */     // GIR_Coverage, 7864,
     /*  260546 */     GIR_EraseRootFromParent_Done,
     /*  260547 */   // Label 4992: @260547
     /*  260547 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(260610), // Rule ID 7865 //
     /*  260552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  260563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  260566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  260569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260591 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260608 */     GIR_RootConstrainSelectedInstOperands,
     /*  260609 */     // GIR_Coverage, 7865,
     /*  260609 */     GIR_EraseRootFromParent_Done,
     /*  260610 */   // Label 4993: @260610
     /*  260610 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(260673), // Rule ID 7868 //
     /*  260615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  260629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  260632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260654 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260671 */     GIR_RootConstrainSelectedInstOperands,
     /*  260672 */     // GIR_Coverage, 7868,
     /*  260672 */     GIR_EraseRootFromParent_Done,
     /*  260673 */   // Label 4994: @260673
     /*  260673 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(260736), // Rule ID 7869 //
     /*  260678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  260692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  260695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260717 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260734 */     GIR_RootConstrainSelectedInstOperands,
     /*  260735 */     // GIR_Coverage, 7869,
     /*  260735 */     GIR_EraseRootFromParent_Done,
     /*  260736 */   // Label 4995: @260736
     /*  260736 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(260799), // Rule ID 7872 //
     /*  260741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  260755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  260758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260780 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260797 */     GIR_RootConstrainSelectedInstOperands,
     /*  260798 */     // GIR_Coverage, 7872,
     /*  260798 */     GIR_EraseRootFromParent_Done,
     /*  260799 */   // Label 4996: @260799
     /*  260799 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(260862), // Rule ID 7873 //
     /*  260804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  260818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  260821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260843 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260860 */     GIR_RootConstrainSelectedInstOperands,
     /*  260861 */     // GIR_Coverage, 7873,
     /*  260861 */     GIR_EraseRootFromParent_Done,
     /*  260862 */   // Label 4997: @260862
     /*  260862 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(260925), // Rule ID 7876 //
     /*  260867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  260881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  260884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260906 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260923 */     GIR_RootConstrainSelectedInstOperands,
     /*  260924 */     // GIR_Coverage, 7876,
     /*  260924 */     GIR_EraseRootFromParent_Done,
     /*  260925 */   // Label 4998: @260925
     /*  260925 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(260988), // Rule ID 7877 //
     /*  260930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  260944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  260947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260969 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260986 */     GIR_RootConstrainSelectedInstOperands,
     /*  260987 */     // GIR_Coverage, 7877,
     /*  260987 */     GIR_EraseRootFromParent_Done,
     /*  260988 */   // Label 4999: @260988
     /*  260988 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(261051), // Rule ID 7880 //
     /*  260993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  260996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  261007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  261010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261032 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  261032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  261035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261049 */     GIR_RootConstrainSelectedInstOperands,
     /*  261050 */     // GIR_Coverage, 7880,
     /*  261050 */     GIR_EraseRootFromParent_Done,
     /*  261051 */   // Label 5000: @261051
     /*  261051 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(261114), // Rule ID 7881 //
     /*  261056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  261059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  261070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  261073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261095 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  261098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261112 */     GIR_RootConstrainSelectedInstOperands,
     /*  261113 */     // GIR_Coverage, 7881,
     /*  261113 */     GIR_EraseRootFromParent_Done,
     /*  261114 */   // Label 5001: @261114
     /*  261114 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(261177), // Rule ID 7884 //
     /*  261119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  261122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  261133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  261136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261158 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  261158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  261161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261175 */     GIR_RootConstrainSelectedInstOperands,
     /*  261176 */     // GIR_Coverage, 7884,
     /*  261176 */     GIR_EraseRootFromParent_Done,
     /*  261177 */   // Label 5002: @261177
     /*  261177 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(261240), // Rule ID 7885 //
     /*  261182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  261185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  261196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  261199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261221 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  261224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261238 */     GIR_RootConstrainSelectedInstOperands,
     /*  261239 */     // GIR_Coverage, 7885,
     /*  261239 */     GIR_EraseRootFromParent_Done,
     /*  261240 */   // Label 5003: @261240
     /*  261240 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(261303), // Rule ID 7888 //
     /*  261245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  261248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  261259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  261262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261284 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  261284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261301 */     GIR_RootConstrainSelectedInstOperands,
     /*  261302 */     // GIR_Coverage, 7888,
     /*  261302 */     GIR_EraseRootFromParent_Done,
     /*  261303 */   // Label 5004: @261303
     /*  261303 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(261366), // Rule ID 7889 //
     /*  261308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  261311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  261322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  261325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261347 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261364 */     GIR_RootConstrainSelectedInstOperands,
     /*  261365 */     // GIR_Coverage, 7889,
     /*  261365 */     GIR_EraseRootFromParent_Done,
     /*  261366 */   // Label 5005: @261366
     /*  261366 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(261429), // Rule ID 7892 //
     /*  261371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  261385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261410 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  261413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261427 */     GIR_RootConstrainSelectedInstOperands,
     /*  261428 */     // GIR_Coverage, 7892,
     /*  261428 */     GIR_EraseRootFromParent_Done,
     /*  261429 */   // Label 5006: @261429
     /*  261429 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(261492), // Rule ID 7893 //
     /*  261434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  261448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261473 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  261476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261490 */     GIR_RootConstrainSelectedInstOperands,
     /*  261491 */     // GIR_Coverage, 7893,
     /*  261491 */     GIR_EraseRootFromParent_Done,
     /*  261492 */   // Label 5007: @261492
     /*  261492 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(261555), // Rule ID 7896 //
     /*  261497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  261511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261536 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  261539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261553 */     GIR_RootConstrainSelectedInstOperands,
     /*  261554 */     // GIR_Coverage, 7896,
     /*  261554 */     GIR_EraseRootFromParent_Done,
     /*  261555 */   // Label 5008: @261555
     /*  261555 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(261618), // Rule ID 7897 //
     /*  261560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  261574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261599 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  261602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261616 */     GIR_RootConstrainSelectedInstOperands,
     /*  261617 */     // GIR_Coverage, 7897,
     /*  261617 */     GIR_EraseRootFromParent_Done,
     /*  261618 */   // Label 5009: @261618
     /*  261618 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(261681), // Rule ID 7900 //
     /*  261623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  261637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261662 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261679 */     GIR_RootConstrainSelectedInstOperands,
     /*  261680 */     // GIR_Coverage, 7900,
     /*  261680 */     GIR_EraseRootFromParent_Done,
     /*  261681 */   // Label 5010: @261681
     /*  261681 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(261744), // Rule ID 7901 //
     /*  261686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  261700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261725 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261742 */     GIR_RootConstrainSelectedInstOperands,
     /*  261743 */     // GIR_Coverage, 7901,
     /*  261743 */     GIR_EraseRootFromParent_Done,
     /*  261744 */   // Label 5011: @261744
     /*  261744 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(261807), // Rule ID 7904 //
     /*  261749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  261763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261788 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  261788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  261791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261805 */     GIR_RootConstrainSelectedInstOperands,
     /*  261806 */     // GIR_Coverage, 7904,
     /*  261806 */     GIR_EraseRootFromParent_Done,
     /*  261807 */   // Label 5012: @261807
     /*  261807 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(261870), // Rule ID 7905 //
     /*  261812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  261826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261851 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  261854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261868 */     GIR_RootConstrainSelectedInstOperands,
     /*  261869 */     // GIR_Coverage, 7905,
     /*  261869 */     GIR_EraseRootFromParent_Done,
     /*  261870 */   // Label 5013: @261870
     /*  261870 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(261933), // Rule ID 7908 //
     /*  261875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  261889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261914 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  261914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261931 */     GIR_RootConstrainSelectedInstOperands,
     /*  261932 */     // GIR_Coverage, 7908,
     /*  261932 */     GIR_EraseRootFromParent_Done,
     /*  261933 */   // Label 5014: @261933
     /*  261933 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(261996), // Rule ID 7909 //
     /*  261938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  261952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261977 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261994 */     GIR_RootConstrainSelectedInstOperands,
     /*  261995 */     // GIR_Coverage, 7909,
     /*  261995 */     GIR_EraseRootFromParent_Done,
     /*  261996 */   // Label 5015: @261996
     /*  261996 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(262059), // Rule ID 7912 //
     /*  262001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  262015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  262040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262057 */     GIR_RootConstrainSelectedInstOperands,
     /*  262058 */     // GIR_Coverage, 7912,
     /*  262058 */     GIR_EraseRootFromParent_Done,
     /*  262059 */   // Label 5016: @262059
     /*  262059 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(262122), // Rule ID 7913 //
     /*  262064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  262078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262103 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  262103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262120 */     GIR_RootConstrainSelectedInstOperands,
     /*  262121 */     // GIR_Coverage, 7913,
     /*  262121 */     GIR_EraseRootFromParent_Done,
     /*  262122 */   // Label 5017: @262122
     /*  262122 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(262185), // Rule ID 7916 //
     /*  262127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  262141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262166 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262183 */     GIR_RootConstrainSelectedInstOperands,
     /*  262184 */     // GIR_Coverage, 7916,
     /*  262184 */     GIR_EraseRootFromParent_Done,
     /*  262185 */   // Label 5018: @262185
     /*  262185 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(262248), // Rule ID 7917 //
     /*  262190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  262204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262229 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262246 */     GIR_RootConstrainSelectedInstOperands,
     /*  262247 */     // GIR_Coverage, 7917,
     /*  262247 */     GIR_EraseRootFromParent_Done,
     /*  262248 */   // Label 5019: @262248
     /*  262248 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(262311), // Rule ID 7920 //
     /*  262253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  262267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262292 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262309 */     GIR_RootConstrainSelectedInstOperands,
     /*  262310 */     // GIR_Coverage, 7920,
     /*  262310 */     GIR_EraseRootFromParent_Done,
     /*  262311 */   // Label 5020: @262311
     /*  262311 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(262374), // Rule ID 7921 //
     /*  262316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  262330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262355 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  262355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262372 */     GIR_RootConstrainSelectedInstOperands,
     /*  262373 */     // GIR_Coverage, 7921,
     /*  262373 */     GIR_EraseRootFromParent_Done,
     /*  262374 */   // Label 5021: @262374
     /*  262374 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(262437), // Rule ID 7924 //
     /*  262379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  262393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262418 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  262418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262435 */     GIR_RootConstrainSelectedInstOperands,
     /*  262436 */     // GIR_Coverage, 7924,
     /*  262436 */     GIR_EraseRootFromParent_Done,
     /*  262437 */   // Label 5022: @262437
     /*  262437 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(262500), // Rule ID 7925 //
     /*  262442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  262456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262481 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  262481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262498 */     GIR_RootConstrainSelectedInstOperands,
     /*  262499 */     // GIR_Coverage, 7925,
     /*  262499 */     GIR_EraseRootFromParent_Done,
     /*  262500 */   // Label 5023: @262500
     /*  262500 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(262563), // Rule ID 7928 //
     /*  262505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  262508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  262519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262544 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  262544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262561 */     GIR_RootConstrainSelectedInstOperands,
     /*  262562 */     // GIR_Coverage, 7928,
     /*  262562 */     GIR_EraseRootFromParent_Done,
     /*  262563 */   // Label 5024: @262563
     /*  262563 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(262626), // Rule ID 7929 //
     /*  262568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  262571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  262582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262607 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  262607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262624 */     GIR_RootConstrainSelectedInstOperands,
     /*  262625 */     // GIR_Coverage, 7929,
     /*  262625 */     GIR_EraseRootFromParent_Done,
     /*  262626 */   // Label 5025: @262626
     /*  262626 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(262689), // Rule ID 7932 //
     /*  262631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  262645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262670 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  262673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262687 */     GIR_RootConstrainSelectedInstOperands,
     /*  262688 */     // GIR_Coverage, 7932,
     /*  262688 */     GIR_EraseRootFromParent_Done,
     /*  262689 */   // Label 5026: @262689
     /*  262689 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(262752), // Rule ID 7933 //
     /*  262694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  262708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262733 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  262736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262750 */     GIR_RootConstrainSelectedInstOperands,
     /*  262751 */     // GIR_Coverage, 7933,
     /*  262751 */     GIR_EraseRootFromParent_Done,
     /*  262752 */   // Label 5027: @262752
     /*  262752 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(262815), // Rule ID 7936 //
     /*  262757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  262768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  262771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262796 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  262799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262813 */     GIR_RootConstrainSelectedInstOperands,
     /*  262814 */     // GIR_Coverage, 7936,
     /*  262814 */     GIR_EraseRootFromParent_Done,
     /*  262815 */   // Label 5028: @262815
     /*  262815 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(262878), // Rule ID 7937 //
     /*  262820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  262831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  262834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262859 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  262862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262876 */     GIR_RootConstrainSelectedInstOperands,
     /*  262877 */     // GIR_Coverage, 7937,
     /*  262877 */     GIR_EraseRootFromParent_Done,
     /*  262878 */   // Label 5029: @262878
     /*  262878 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(262941), // Rule ID 7940 //
     /*  262883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  262894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  262897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262922 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  262925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262939 */     GIR_RootConstrainSelectedInstOperands,
     /*  262940 */     // GIR_Coverage, 7940,
     /*  262940 */     GIR_EraseRootFromParent_Done,
     /*  262941 */   // Label 5030: @262941
     /*  262941 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(263004), // Rule ID 7941 //
     /*  262946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  262957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  262960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262985 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  262988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263002 */     GIR_RootConstrainSelectedInstOperands,
     /*  263003 */     // GIR_Coverage, 7941,
     /*  263003 */     GIR_EraseRootFromParent_Done,
     /*  263004 */   // Label 5031: @263004
     /*  263004 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(263067), // Rule ID 7944 //
     /*  263009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  263023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263048 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263065 */     GIR_RootConstrainSelectedInstOperands,
     /*  263066 */     // GIR_Coverage, 7944,
     /*  263066 */     GIR_EraseRootFromParent_Done,
     /*  263067 */   // Label 5032: @263067
     /*  263067 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(263130), // Rule ID 7945 //
     /*  263072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  263086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263111 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263128 */     GIR_RootConstrainSelectedInstOperands,
     /*  263129 */     // GIR_Coverage, 7945,
     /*  263129 */     GIR_EraseRootFromParent_Done,
     /*  263130 */   // Label 5033: @263130
     /*  263130 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(263193), // Rule ID 7948 //
     /*  263135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  263149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263174 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263191 */     GIR_RootConstrainSelectedInstOperands,
     /*  263192 */     // GIR_Coverage, 7948,
     /*  263192 */     GIR_EraseRootFromParent_Done,
     /*  263193 */   // Label 5034: @263193
     /*  263193 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(263256), // Rule ID 7949 //
     /*  263198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  263212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263237 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263254 */     GIR_RootConstrainSelectedInstOperands,
     /*  263255 */     // GIR_Coverage, 7949,
     /*  263255 */     GIR_EraseRootFromParent_Done,
     /*  263256 */   // Label 5035: @263256
     /*  263256 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(263319), // Rule ID 7952 //
     /*  263261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  263275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263300 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263317 */     GIR_RootConstrainSelectedInstOperands,
     /*  263318 */     // GIR_Coverage, 7952,
     /*  263318 */     GIR_EraseRootFromParent_Done,
     /*  263319 */   // Label 5036: @263319
     /*  263319 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(263382), // Rule ID 7953 //
     /*  263324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  263338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263363 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263380 */     GIR_RootConstrainSelectedInstOperands,
     /*  263381 */     // GIR_Coverage, 7953,
     /*  263381 */     GIR_EraseRootFromParent_Done,
     /*  263382 */   // Label 5037: @263382
     /*  263382 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(263445), // Rule ID 7956 //
     /*  263387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  263401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263426 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263443 */     GIR_RootConstrainSelectedInstOperands,
     /*  263444 */     // GIR_Coverage, 7956,
     /*  263444 */     GIR_EraseRootFromParent_Done,
     /*  263445 */   // Label 5038: @263445
     /*  263445 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(263508), // Rule ID 7957 //
     /*  263450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  263464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263489 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263506 */     GIR_RootConstrainSelectedInstOperands,
     /*  263507 */     // GIR_Coverage, 7957,
     /*  263507 */     GIR_EraseRootFromParent_Done,
     /*  263508 */   // Label 5039: @263508
     /*  263508 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(263571), // Rule ID 7960 //
     /*  263513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  263527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263552 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263569 */     GIR_RootConstrainSelectedInstOperands,
     /*  263570 */     // GIR_Coverage, 7960,
     /*  263570 */     GIR_EraseRootFromParent_Done,
     /*  263571 */   // Label 5040: @263571
     /*  263571 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(263634), // Rule ID 7961 //
     /*  263576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  263590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263615 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263632 */     GIR_RootConstrainSelectedInstOperands,
     /*  263633 */     // GIR_Coverage, 7961,
     /*  263633 */     GIR_EraseRootFromParent_Done,
     /*  263634 */   // Label 5041: @263634
     /*  263634 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(263697), // Rule ID 7964 //
     /*  263639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  263653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263678 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263695 */     GIR_RootConstrainSelectedInstOperands,
     /*  263696 */     // GIR_Coverage, 7964,
     /*  263696 */     GIR_EraseRootFromParent_Done,
     /*  263697 */   // Label 5042: @263697
     /*  263697 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(263760), // Rule ID 7965 //
     /*  263702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  263716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263741 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263758 */     GIR_RootConstrainSelectedInstOperands,
     /*  263759 */     // GIR_Coverage, 7965,
     /*  263759 */     GIR_EraseRootFromParent_Done,
     /*  263760 */   // Label 5043: @263760
     /*  263760 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(263823), // Rule ID 7968 //
     /*  263765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  263768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  263779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263804 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  263804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263821 */     GIR_RootConstrainSelectedInstOperands,
     /*  263822 */     // GIR_Coverage, 7968,
     /*  263822 */     GIR_EraseRootFromParent_Done,
     /*  263823 */   // Label 5044: @263823
     /*  263823 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(263886), // Rule ID 7969 //
     /*  263828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  263831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  263842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263867 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  263867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263884 */     GIR_RootConstrainSelectedInstOperands,
     /*  263885 */     // GIR_Coverage, 7969,
     /*  263885 */     GIR_EraseRootFromParent_Done,
     /*  263886 */   // Label 5045: @263886
     /*  263886 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(263949), // Rule ID 7972 //
     /*  263891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  263894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  263905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263930 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  263930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263947 */     GIR_RootConstrainSelectedInstOperands,
     /*  263948 */     // GIR_Coverage, 7972,
     /*  263948 */     GIR_EraseRootFromParent_Done,
     /*  263949 */   // Label 5046: @263949
     /*  263949 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(264012), // Rule ID 7973 //
     /*  263954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  263957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  263968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263993 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  263993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264010 */     GIR_RootConstrainSelectedInstOperands,
     /*  264011 */     // GIR_Coverage, 7973,
     /*  264011 */     GIR_EraseRootFromParent_Done,
     /*  264012 */   // Label 5047: @264012
     /*  264012 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(264075), // Rule ID 7976 //
     /*  264017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  264020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  264031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  264034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264056 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  264056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  264059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264073 */     GIR_RootConstrainSelectedInstOperands,
     /*  264074 */     // GIR_Coverage, 7976,
     /*  264074 */     GIR_EraseRootFromParent_Done,
     /*  264075 */   // Label 5048: @264075
     /*  264075 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(264138), // Rule ID 7977 //
     /*  264080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  264083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  264094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  264097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264119 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  264119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  264122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264136 */     GIR_RootConstrainSelectedInstOperands,
     /*  264137 */     // GIR_Coverage, 7977,
     /*  264137 */     GIR_EraseRootFromParent_Done,
     /*  264138 */   // Label 5049: @264138
     /*  264138 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(264201), // Rule ID 8068 //
     /*  264143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  264157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  264160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264182 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  264185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264199 */     GIR_RootConstrainSelectedInstOperands,
     /*  264200 */     // GIR_Coverage, 8068,
     /*  264200 */     GIR_EraseRootFromParent_Done,
     /*  264201 */   // Label 5050: @264201
     /*  264201 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(264264), // Rule ID 8069 //
     /*  264206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  264220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  264223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264245 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  264248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264262 */     GIR_RootConstrainSelectedInstOperands,
     /*  264263 */     // GIR_Coverage, 8069,
     /*  264263 */     GIR_EraseRootFromParent_Done,
     /*  264264 */   // Label 5051: @264264
     /*  264264 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(264327), // Rule ID 8072 //
     /*  264269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  264283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  264286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264308 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264325 */     GIR_RootConstrainSelectedInstOperands,
     /*  264326 */     // GIR_Coverage, 8072,
     /*  264326 */     GIR_EraseRootFromParent_Done,
     /*  264327 */   // Label 5052: @264327
     /*  264327 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(264390), // Rule ID 8073 //
     /*  264332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  264346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  264349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264371 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264388 */     GIR_RootConstrainSelectedInstOperands,
     /*  264389 */     // GIR_Coverage, 8073,
     /*  264389 */     GIR_EraseRootFromParent_Done,
     /*  264390 */   // Label 5053: @264390
     /*  264390 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(264453), // Rule ID 8076 //
     /*  264395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  264409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  264412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264434 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264451 */     GIR_RootConstrainSelectedInstOperands,
     /*  264452 */     // GIR_Coverage, 8076,
     /*  264452 */     GIR_EraseRootFromParent_Done,
     /*  264453 */   // Label 5054: @264453
     /*  264453 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(264516), // Rule ID 8077 //
     /*  264458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  264472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  264475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264497 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264514 */     GIR_RootConstrainSelectedInstOperands,
     /*  264515 */     // GIR_Coverage, 8077,
     /*  264515 */     GIR_EraseRootFromParent_Done,
     /*  264516 */   // Label 5055: @264516
     /*  264516 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(264579), // Rule ID 8080 //
     /*  264521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  264535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  264538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264560 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  264560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264577 */     GIR_RootConstrainSelectedInstOperands,
     /*  264578 */     // GIR_Coverage, 8080,
     /*  264578 */     GIR_EraseRootFromParent_Done,
     /*  264579 */   // Label 5056: @264579
     /*  264579 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(264642), // Rule ID 8081 //
     /*  264584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  264598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  264601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264623 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  264623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264640 */     GIR_RootConstrainSelectedInstOperands,
     /*  264641 */     // GIR_Coverage, 8081,
     /*  264641 */     GIR_EraseRootFromParent_Done,
     /*  264642 */   // Label 5057: @264642
     /*  264642 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(264705), // Rule ID 8084 //
     /*  264647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  264661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  264664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264686 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  264686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264703 */     GIR_RootConstrainSelectedInstOperands,
     /*  264704 */     // GIR_Coverage, 8084,
     /*  264704 */     GIR_EraseRootFromParent_Done,
     /*  264705 */   // Label 5058: @264705
     /*  264705 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(264768), // Rule ID 8085 //
     /*  264710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  264724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  264727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264749 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  264749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264766 */     GIR_RootConstrainSelectedInstOperands,
     /*  264767 */     // GIR_Coverage, 8085,
     /*  264767 */     GIR_EraseRootFromParent_Done,
     /*  264768 */   // Label 5059: @264768
     /*  264768 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(264831), // Rule ID 8088 //
     /*  264773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  264787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  264790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264812 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264829 */     GIR_RootConstrainSelectedInstOperands,
     /*  264830 */     // GIR_Coverage, 8088,
     /*  264830 */     GIR_EraseRootFromParent_Done,
     /*  264831 */   // Label 5060: @264831
     /*  264831 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(264894), // Rule ID 8089 //
     /*  264836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  264850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  264853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264875 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264892 */     GIR_RootConstrainSelectedInstOperands,
     /*  264893 */     // GIR_Coverage, 8089,
     /*  264893 */     GIR_EraseRootFromParent_Done,
     /*  264894 */   // Label 5061: @264894
     /*  264894 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(264957), // Rule ID 8092 //
     /*  264899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  264913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  264916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264938 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  264941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264955 */     GIR_RootConstrainSelectedInstOperands,
     /*  264956 */     // GIR_Coverage, 8092,
     /*  264956 */     GIR_EraseRootFromParent_Done,
     /*  264957 */   // Label 5062: @264957
     /*  264957 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(265020), // Rule ID 8093 //
     /*  264962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  264976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  264979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265001 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265018 */     GIR_RootConstrainSelectedInstOperands,
     /*  265019 */     // GIR_Coverage, 8093,
     /*  265019 */     GIR_EraseRootFromParent_Done,
     /*  265020 */   // Label 5063: @265020
     /*  265020 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(265083), // Rule ID 8096 //
     /*  265025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  265039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  265042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265064 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265081 */     GIR_RootConstrainSelectedInstOperands,
     /*  265082 */     // GIR_Coverage, 8096,
     /*  265082 */     GIR_EraseRootFromParent_Done,
     /*  265083 */   // Label 5064: @265083
     /*  265083 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(265146), // Rule ID 8097 //
     /*  265088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  265102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  265105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265127 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265144 */     GIR_RootConstrainSelectedInstOperands,
     /*  265145 */     // GIR_Coverage, 8097,
     /*  265145 */     GIR_EraseRootFromParent_Done,
     /*  265146 */   // Label 5065: @265146
     /*  265146 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(265209), // Rule ID 8100 //
     /*  265151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  265165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  265168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265190 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  265190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265207 */     GIR_RootConstrainSelectedInstOperands,
     /*  265208 */     // GIR_Coverage, 8100,
     /*  265208 */     GIR_EraseRootFromParent_Done,
     /*  265209 */   // Label 5066: @265209
     /*  265209 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(265272), // Rule ID 8101 //
     /*  265214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  265228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  265231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265253 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  265253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265270 */     GIR_RootConstrainSelectedInstOperands,
     /*  265271 */     // GIR_Coverage, 8101,
     /*  265271 */     GIR_EraseRootFromParent_Done,
     /*  265272 */   // Label 5067: @265272
     /*  265272 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(265335), // Rule ID 8104 //
     /*  265277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  265280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  265291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  265294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265316 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  265316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265333 */     GIR_RootConstrainSelectedInstOperands,
     /*  265334 */     // GIR_Coverage, 8104,
     /*  265334 */     GIR_EraseRootFromParent_Done,
     /*  265335 */   // Label 5068: @265335
     /*  265335 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(265398), // Rule ID 8105 //
     /*  265340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  265343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  265354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  265357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265379 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  265379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265396 */     GIR_RootConstrainSelectedInstOperands,
     /*  265397 */     // GIR_Coverage, 8105,
     /*  265397 */     GIR_EraseRootFromParent_Done,
     /*  265398 */   // Label 5069: @265398
     /*  265398 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(265461), // Rule ID 8108 //
     /*  265403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  265417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  265420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265442 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265459 */     GIR_RootConstrainSelectedInstOperands,
     /*  265460 */     // GIR_Coverage, 8108,
     /*  265460 */     GIR_EraseRootFromParent_Done,
     /*  265461 */   // Label 5070: @265461
     /*  265461 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(265524), // Rule ID 8109 //
     /*  265466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  265480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  265483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265505 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265522 */     GIR_RootConstrainSelectedInstOperands,
     /*  265523 */     // GIR_Coverage, 8109,
     /*  265523 */     GIR_EraseRootFromParent_Done,
     /*  265524 */   // Label 5071: @265524
     /*  265524 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(265587), // Rule ID 8112 //
     /*  265529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  265540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  265543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  265546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265568 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  265571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265585 */     GIR_RootConstrainSelectedInstOperands,
     /*  265586 */     // GIR_Coverage, 8112,
     /*  265586 */     GIR_EraseRootFromParent_Done,
     /*  265587 */   // Label 5072: @265587
     /*  265587 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(265650), // Rule ID 8113 //
     /*  265592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  265603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  265606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  265609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265631 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  265634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265648 */     GIR_RootConstrainSelectedInstOperands,
     /*  265649 */     // GIR_Coverage, 8113,
     /*  265649 */     GIR_EraseRootFromParent_Done,
     /*  265650 */   // Label 5073: @265650
     /*  265650 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(265713), // Rule ID 8116 //
     /*  265655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  265666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  265669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  265672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265694 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  265697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265711 */     GIR_RootConstrainSelectedInstOperands,
     /*  265712 */     // GIR_Coverage, 8116,
     /*  265712 */     GIR_EraseRootFromParent_Done,
     /*  265713 */   // Label 5074: @265713
     /*  265713 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(265776), // Rule ID 8117 //
     /*  265718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  265729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  265732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  265735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265757 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  265760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265774 */     GIR_RootConstrainSelectedInstOperands,
     /*  265775 */     // GIR_Coverage, 8117,
     /*  265775 */     GIR_EraseRootFromParent_Done,
     /*  265776 */   // Label 5075: @265776
     /*  265776 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(265839), // Rule ID 8120 //
     /*  265781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  265795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  265798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265820 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265837 */     GIR_RootConstrainSelectedInstOperands,
     /*  265838 */     // GIR_Coverage, 8120,
     /*  265838 */     GIR_EraseRootFromParent_Done,
     /*  265839 */   // Label 5076: @265839
     /*  265839 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(265902), // Rule ID 8121 //
     /*  265844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  265858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  265861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265883 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265900 */     GIR_RootConstrainSelectedInstOperands,
     /*  265901 */     // GIR_Coverage, 8121,
     /*  265901 */     GIR_EraseRootFromParent_Done,
     /*  265902 */   // Label 5077: @265902
     /*  265902 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(265965), // Rule ID 8124 //
     /*  265907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  265921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  265924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265946 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  265949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265963 */     GIR_RootConstrainSelectedInstOperands,
     /*  265964 */     // GIR_Coverage, 8124,
     /*  265964 */     GIR_EraseRootFromParent_Done,
     /*  265965 */   // Label 5078: @265965
     /*  265965 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(266028), // Rule ID 8125 //
     /*  265970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  265984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  265987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266009 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266026 */     GIR_RootConstrainSelectedInstOperands,
     /*  266027 */     // GIR_Coverage, 8125,
     /*  266027 */     GIR_EraseRootFromParent_Done,
     /*  266028 */   // Label 5079: @266028
     /*  266028 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(266091), // Rule ID 8128 //
     /*  266033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  266047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  266050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266072 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266089 */     GIR_RootConstrainSelectedInstOperands,
     /*  266090 */     // GIR_Coverage, 8128,
     /*  266090 */     GIR_EraseRootFromParent_Done,
     /*  266091 */   // Label 5080: @266091
     /*  266091 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(266154), // Rule ID 8129 //
     /*  266096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  266110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  266113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266135 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266152 */     GIR_RootConstrainSelectedInstOperands,
     /*  266153 */     // GIR_Coverage, 8129,
     /*  266153 */     GIR_EraseRootFromParent_Done,
     /*  266154 */   // Label 5081: @266154
     /*  266154 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(266217), // Rule ID 8132 //
     /*  266159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  266173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  266176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266198 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266215 */     GIR_RootConstrainSelectedInstOperands,
     /*  266216 */     // GIR_Coverage, 8132,
     /*  266216 */     GIR_EraseRootFromParent_Done,
     /*  266217 */   // Label 5082: @266217
     /*  266217 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(266280), // Rule ID 8133 //
     /*  266222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  266236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  266239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266261 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266278 */     GIR_RootConstrainSelectedInstOperands,
     /*  266279 */     // GIR_Coverage, 8133,
     /*  266279 */     GIR_EraseRootFromParent_Done,
     /*  266280 */   // Label 5083: @266280
     /*  266280 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(266343), // Rule ID 8136 //
     /*  266285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  266299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  266302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266324 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266341 */     GIR_RootConstrainSelectedInstOperands,
     /*  266342 */     // GIR_Coverage, 8136,
     /*  266342 */     GIR_EraseRootFromParent_Done,
     /*  266343 */   // Label 5084: @266343
     /*  266343 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(266406), // Rule ID 8137 //
     /*  266348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  266362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  266365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266387 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266404 */     GIR_RootConstrainSelectedInstOperands,
     /*  266405 */     // GIR_Coverage, 8137,
     /*  266405 */     GIR_EraseRootFromParent_Done,
     /*  266406 */   // Label 5085: @266406
     /*  266406 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(266469), // Rule ID 8140 //
     /*  266411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  266425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  266428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266450 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266467 */     GIR_RootConstrainSelectedInstOperands,
     /*  266468 */     // GIR_Coverage, 8140,
     /*  266468 */     GIR_EraseRootFromParent_Done,
     /*  266469 */   // Label 5086: @266469
     /*  266469 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(266532), // Rule ID 8141 //
     /*  266474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  266488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  266491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266513 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266530 */     GIR_RootConstrainSelectedInstOperands,
     /*  266531 */     // GIR_Coverage, 8141,
     /*  266531 */     GIR_EraseRootFromParent_Done,
     /*  266532 */   // Label 5087: @266532
     /*  266532 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(266595), // Rule ID 8144 //
     /*  266537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  266540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  266551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  266554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266576 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  266576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266593 */     GIR_RootConstrainSelectedInstOperands,
     /*  266594 */     // GIR_Coverage, 8144,
     /*  266594 */     GIR_EraseRootFromParent_Done,
     /*  266595 */   // Label 5088: @266595
     /*  266595 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(266658), // Rule ID 8145 //
     /*  266600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  266603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  266614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  266617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266639 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  266639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266656 */     GIR_RootConstrainSelectedInstOperands,
     /*  266657 */     // GIR_Coverage, 8145,
     /*  266657 */     GIR_EraseRootFromParent_Done,
     /*  266658 */   // Label 5089: @266658
     /*  266658 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(266721), // Rule ID 8148 //
     /*  266663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  266666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  266677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  266680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266702 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  266702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266719 */     GIR_RootConstrainSelectedInstOperands,
     /*  266720 */     // GIR_Coverage, 8148,
     /*  266720 */     GIR_EraseRootFromParent_Done,
     /*  266721 */   // Label 5090: @266721
     /*  266721 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(266784), // Rule ID 8149 //
     /*  266726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  266729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  266740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  266743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266765 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  266765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266782 */     GIR_RootConstrainSelectedInstOperands,
     /*  266783 */     // GIR_Coverage, 8149,
     /*  266783 */     GIR_EraseRootFromParent_Done,
     /*  266784 */   // Label 5091: @266784
     /*  266784 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(266847), // Rule ID 8152 //
     /*  266789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  266792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  266803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  266806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266828 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  266828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266845 */     GIR_RootConstrainSelectedInstOperands,
     /*  266846 */     // GIR_Coverage, 8152,
     /*  266846 */     GIR_EraseRootFromParent_Done,
     /*  266847 */   // Label 5092: @266847
     /*  266847 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(266910), // Rule ID 8153 //
     /*  266852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  266855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  266866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  266869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266891 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  266891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266908 */     GIR_RootConstrainSelectedInstOperands,
     /*  266909 */     // GIR_Coverage, 8153,
     /*  266909 */     GIR_EraseRootFromParent_Done,
     /*  266910 */   // Label 5093: @266910
     /*  266910 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(266973), // Rule ID 8156 //
     /*  266915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  266929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266954 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  266957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266971 */     GIR_RootConstrainSelectedInstOperands,
     /*  266972 */     // GIR_Coverage, 8156,
     /*  266972 */     GIR_EraseRootFromParent_Done,
     /*  266973 */   // Label 5094: @266973
     /*  266973 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(267036), // Rule ID 8157 //
     /*  266978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  266992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267017 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  267020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267034 */     GIR_RootConstrainSelectedInstOperands,
     /*  267035 */     // GIR_Coverage, 8157,
     /*  267035 */     GIR_EraseRootFromParent_Done,
     /*  267036 */   // Label 5095: @267036
     /*  267036 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(267099), // Rule ID 8160 //
     /*  267041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  267055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267080 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267097 */     GIR_RootConstrainSelectedInstOperands,
     /*  267098 */     // GIR_Coverage, 8160,
     /*  267098 */     GIR_EraseRootFromParent_Done,
     /*  267099 */   // Label 5096: @267099
     /*  267099 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(267162), // Rule ID 8161 //
     /*  267104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  267118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267143 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267160 */     GIR_RootConstrainSelectedInstOperands,
     /*  267161 */     // GIR_Coverage, 8161,
     /*  267161 */     GIR_EraseRootFromParent_Done,
     /*  267162 */   // Label 5097: @267162
     /*  267162 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(267225), // Rule ID 8164 //
     /*  267167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  267181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267206 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267223 */     GIR_RootConstrainSelectedInstOperands,
     /*  267224 */     // GIR_Coverage, 8164,
     /*  267224 */     GIR_EraseRootFromParent_Done,
     /*  267225 */   // Label 5098: @267225
     /*  267225 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(267288), // Rule ID 8165 //
     /*  267230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  267244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267269 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267286 */     GIR_RootConstrainSelectedInstOperands,
     /*  267287 */     // GIR_Coverage, 8165,
     /*  267287 */     GIR_EraseRootFromParent_Done,
     /*  267288 */   // Label 5099: @267288
     /*  267288 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(267351), // Rule ID 8168 //
     /*  267293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  267307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267332 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267349 */     GIR_RootConstrainSelectedInstOperands,
     /*  267350 */     // GIR_Coverage, 8168,
     /*  267350 */     GIR_EraseRootFromParent_Done,
     /*  267351 */   // Label 5100: @267351
     /*  267351 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(267414), // Rule ID 8169 //
     /*  267356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  267370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267395 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267412 */     GIR_RootConstrainSelectedInstOperands,
     /*  267413 */     // GIR_Coverage, 8169,
     /*  267413 */     GIR_EraseRootFromParent_Done,
     /*  267414 */   // Label 5101: @267414
     /*  267414 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(267477), // Rule ID 8172 //
     /*  267419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  267433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267458 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267475 */     GIR_RootConstrainSelectedInstOperands,
     /*  267476 */     // GIR_Coverage, 8172,
     /*  267476 */     GIR_EraseRootFromParent_Done,
     /*  267477 */   // Label 5102: @267477
     /*  267477 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(267540), // Rule ID 8173 //
     /*  267482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  267496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267521 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267538 */     GIR_RootConstrainSelectedInstOperands,
     /*  267539 */     // GIR_Coverage, 8173,
     /*  267539 */     GIR_EraseRootFromParent_Done,
     /*  267540 */   // Label 5103: @267540
     /*  267540 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(267603), // Rule ID 8176 //
     /*  267545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  267559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267584 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  267584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267601 */     GIR_RootConstrainSelectedInstOperands,
     /*  267602 */     // GIR_Coverage, 8176,
     /*  267602 */     GIR_EraseRootFromParent_Done,
     /*  267603 */   // Label 5104: @267603
     /*  267603 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(267666), // Rule ID 8177 //
     /*  267608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  267622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267647 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  267647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267664 */     GIR_RootConstrainSelectedInstOperands,
     /*  267665 */     // GIR_Coverage, 8177,
     /*  267665 */     GIR_EraseRootFromParent_Done,
     /*  267666 */   // Label 5105: @267666
     /*  267666 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(267729), // Rule ID 8180 //
     /*  267671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  267685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267710 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267727 */     GIR_RootConstrainSelectedInstOperands,
     /*  267728 */     // GIR_Coverage, 8180,
     /*  267728 */     GIR_EraseRootFromParent_Done,
     /*  267729 */   // Label 5106: @267729
     /*  267729 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(267792), // Rule ID 8181 //
     /*  267734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  267748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267773 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267790 */     GIR_RootConstrainSelectedInstOperands,
     /*  267791 */     // GIR_Coverage, 8181,
     /*  267791 */     GIR_EraseRootFromParent_Done,
     /*  267792 */   // Label 5107: @267792
     /*  267792 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(267855), // Rule ID 8184 //
     /*  267797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  267811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267836 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267853 */     GIR_RootConstrainSelectedInstOperands,
     /*  267854 */     // GIR_Coverage, 8184,
     /*  267854 */     GIR_EraseRootFromParent_Done,
     /*  267855 */   // Label 5108: @267855
     /*  267855 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(267918), // Rule ID 8185 //
     /*  267860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  267874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267899 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267916 */     GIR_RootConstrainSelectedInstOperands,
     /*  267917 */     // GIR_Coverage, 8185,
     /*  267917 */     GIR_EraseRootFromParent_Done,
     /*  267918 */   // Label 5109: @267918
     /*  267918 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(267981), // Rule ID 8188 //
     /*  267923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  267937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267962 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  267962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267979 */     GIR_RootConstrainSelectedInstOperands,
     /*  267980 */     // GIR_Coverage, 8188,
     /*  267980 */     GIR_EraseRootFromParent_Done,
     /*  267981 */   // Label 5110: @267981
     /*  267981 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(268044), // Rule ID 8189 //
     /*  267986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  268000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268025 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  268025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268042 */     GIR_RootConstrainSelectedInstOperands,
     /*  268043 */     // GIR_Coverage, 8189,
     /*  268043 */     GIR_EraseRootFromParent_Done,
     /*  268044 */   // Label 5111: @268044
     /*  268044 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(268107), // Rule ID 8192 //
     /*  268049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  268052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  268063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268088 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  268088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  268105 */     GIR_RootConstrainSelectedInstOperands,
     /*  268106 */     // GIR_Coverage, 8192,
     /*  268106 */     GIR_EraseRootFromParent_Done,
     /*  268107 */   // Label 5112: @268107
     /*  268107 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(268170), // Rule ID 8193 //
     /*  268112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  268115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  268126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268151 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  268151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  268168 */     GIR_RootConstrainSelectedInstOperands,
     /*  268169 */     // GIR_Coverage, 8193,
     /*  268169 */     GIR_EraseRootFromParent_Done,
     /*  268170 */   // Label 5113: @268170
     /*  268170 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(268233), // Rule ID 8196 //
     /*  268175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  268189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268214 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268231 */     GIR_RootConstrainSelectedInstOperands,
     /*  268232 */     // GIR_Coverage, 8196,
     /*  268232 */     GIR_EraseRootFromParent_Done,
     /*  268233 */   // Label 5114: @268233
     /*  268233 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(268296), // Rule ID 8197 //
     /*  268238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  268252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268277 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268294 */     GIR_RootConstrainSelectedInstOperands,
     /*  268295 */     // GIR_Coverage, 8197,
     /*  268295 */     GIR_EraseRootFromParent_Done,
     /*  268296 */   // Label 5115: @268296
     /*  268296 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(268359), // Rule ID 8200 //
     /*  268301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  268315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268340 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268357 */     GIR_RootConstrainSelectedInstOperands,
     /*  268358 */     // GIR_Coverage, 8200,
     /*  268358 */     GIR_EraseRootFromParent_Done,
     /*  268359 */   // Label 5116: @268359
     /*  268359 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(268422), // Rule ID 8201 //
     /*  268364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  268378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268403 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268420 */     GIR_RootConstrainSelectedInstOperands,
     /*  268421 */     // GIR_Coverage, 8201,
     /*  268421 */     GIR_EraseRootFromParent_Done,
     /*  268422 */   // Label 5117: @268422
     /*  268422 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(268485), // Rule ID 8204 //
     /*  268427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  268438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  268441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268466 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268483 */     GIR_RootConstrainSelectedInstOperands,
     /*  268484 */     // GIR_Coverage, 8204,
     /*  268484 */     GIR_EraseRootFromParent_Done,
     /*  268485 */   // Label 5118: @268485
     /*  268485 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(268548), // Rule ID 8205 //
     /*  268490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  268501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  268504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268529 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268546 */     GIR_RootConstrainSelectedInstOperands,
     /*  268547 */     // GIR_Coverage, 8205,
     /*  268547 */     GIR_EraseRootFromParent_Done,
     /*  268548 */   // Label 5119: @268548
     /*  268548 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(268611), // Rule ID 8208 //
     /*  268553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  268567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268592 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268609 */     GIR_RootConstrainSelectedInstOperands,
     /*  268610 */     // GIR_Coverage, 8208,
     /*  268610 */     GIR_EraseRootFromParent_Done,
     /*  268611 */   // Label 5120: @268611
     /*  268611 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(268674), // Rule ID 8209 //
     /*  268616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  268630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268655 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268672 */     GIR_RootConstrainSelectedInstOperands,
     /*  268673 */     // GIR_Coverage, 8209,
     /*  268673 */     GIR_EraseRootFromParent_Done,
     /*  268674 */   // Label 5121: @268674
     /*  268674 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(268737), // Rule ID 8212 //
     /*  268679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  268693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268718 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268735 */     GIR_RootConstrainSelectedInstOperands,
     /*  268736 */     // GIR_Coverage, 8212,
     /*  268736 */     GIR_EraseRootFromParent_Done,
     /*  268737 */   // Label 5122: @268737
     /*  268737 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(268800), // Rule ID 8213 //
     /*  268742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  268756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268781 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268798 */     GIR_RootConstrainSelectedInstOperands,
     /*  268799 */     // GIR_Coverage, 8213,
     /*  268799 */     GIR_EraseRootFromParent_Done,
     /*  268800 */   // Label 5123: @268800
     /*  268800 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(268863), // Rule ID 8216 //
     /*  268805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  268819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268844 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268861 */     GIR_RootConstrainSelectedInstOperands,
     /*  268862 */     // GIR_Coverage, 8216,
     /*  268862 */     GIR_EraseRootFromParent_Done,
     /*  268863 */   // Label 5124: @268863
     /*  268863 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(268926), // Rule ID 8217 //
     /*  268868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  268882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268907 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268924 */     GIR_RootConstrainSelectedInstOperands,
     /*  268925 */     // GIR_Coverage, 8217,
     /*  268925 */     GIR_EraseRootFromParent_Done,
     /*  268926 */   // Label 5125: @268926
     /*  268926 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(268989), // Rule ID 8220 //
     /*  268931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  268945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268970 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  268970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268987 */     GIR_RootConstrainSelectedInstOperands,
     /*  268988 */     // GIR_Coverage, 8220,
     /*  268988 */     GIR_EraseRootFromParent_Done,
     /*  268989 */   // Label 5126: @268989
     /*  268989 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(269052), // Rule ID 8221 //
     /*  268994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  269008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269033 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269050 */     GIR_RootConstrainSelectedInstOperands,
     /*  269051 */     // GIR_Coverage, 8221,
     /*  269051 */     GIR_EraseRootFromParent_Done,
     /*  269052 */   // Label 5127: @269052
     /*  269052 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(269115), // Rule ID 8224 //
     /*  269057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  269071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269096 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  269096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269113 */     GIR_RootConstrainSelectedInstOperands,
     /*  269114 */     // GIR_Coverage, 8224,
     /*  269114 */     GIR_EraseRootFromParent_Done,
     /*  269115 */   // Label 5128: @269115
     /*  269115 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(269178), // Rule ID 8225 //
     /*  269120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  269134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269159 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269176 */     GIR_RootConstrainSelectedInstOperands,
     /*  269177 */     // GIR_Coverage, 8225,
     /*  269177 */     GIR_EraseRootFromParent_Done,
     /*  269178 */   // Label 5129: @269178
     /*  269178 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(269241), // Rule ID 8228 //
     /*  269183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  269197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269222 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  269222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269239 */     GIR_RootConstrainSelectedInstOperands,
     /*  269240 */     // GIR_Coverage, 8228,
     /*  269240 */     GIR_EraseRootFromParent_Done,
     /*  269241 */   // Label 5130: @269241
     /*  269241 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(269304), // Rule ID 8229 //
     /*  269246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  269260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269285 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269302 */     GIR_RootConstrainSelectedInstOperands,
     /*  269303 */     // GIR_Coverage, 8229,
     /*  269303 */     GIR_EraseRootFromParent_Done,
     /*  269304 */   // Label 5131: @269304
     /*  269304 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(269367), // Rule ID 8232 //
     /*  269309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  269312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  269323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269348 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  269348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269365 */     GIR_RootConstrainSelectedInstOperands,
     /*  269366 */     // GIR_Coverage, 8232,
     /*  269366 */     GIR_EraseRootFromParent_Done,
     /*  269367 */   // Label 5132: @269367
     /*  269367 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(269430), // Rule ID 8233 //
     /*  269372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  269375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  269386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269411 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269428 */     GIR_RootConstrainSelectedInstOperands,
     /*  269429 */     // GIR_Coverage, 8233,
     /*  269429 */     GIR_EraseRootFromParent_Done,
     /*  269430 */   // Label 5133: @269430
     /*  269430 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(269493), // Rule ID 8236 //
     /*  269435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  269438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  269449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269474 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  269474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269491 */     GIR_RootConstrainSelectedInstOperands,
     /*  269492 */     // GIR_Coverage, 8236,
     /*  269492 */     GIR_EraseRootFromParent_Done,
     /*  269493 */   // Label 5134: @269493
     /*  269493 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(269556), // Rule ID 8237 //
     /*  269498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  269501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  269512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269537 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269554 */     GIR_RootConstrainSelectedInstOperands,
     /*  269555 */     // GIR_Coverage, 8237,
     /*  269555 */     GIR_EraseRootFromParent_Done,
     /*  269556 */   // Label 5135: @269556
     /*  269556 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(269619), // Rule ID 8240 //
     /*  269561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  269564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  269575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269600 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  269600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269617 */     GIR_RootConstrainSelectedInstOperands,
     /*  269618 */     // GIR_Coverage, 8240,
     /*  269618 */     GIR_EraseRootFromParent_Done,
     /*  269619 */   // Label 5136: @269619
     /*  269619 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(269682), // Rule ID 8241 //
     /*  269624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  269627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  269638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269663 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269680 */     GIR_RootConstrainSelectedInstOperands,
     /*  269681 */     // GIR_Coverage, 8241,
     /*  269681 */     GIR_EraseRootFromParent_Done,
     /*  269682 */   // Label 5137: @269682
     /*  269682 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(269745), // Rule ID 8332 //
     /*  269687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  269701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  269704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269726 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  269729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269743 */     GIR_RootConstrainSelectedInstOperands,
     /*  269744 */     // GIR_Coverage, 8332,
     /*  269744 */     GIR_EraseRootFromParent_Done,
     /*  269745 */   // Label 5138: @269745
     /*  269745 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(269808), // Rule ID 8333 //
     /*  269750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  269764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  269767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269789 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  269789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  269792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269806 */     GIR_RootConstrainSelectedInstOperands,
     /*  269807 */     // GIR_Coverage, 8333,
     /*  269807 */     GIR_EraseRootFromParent_Done,
     /*  269808 */   // Label 5139: @269808
     /*  269808 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(269871), // Rule ID 8336 //
     /*  269813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  269827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  269830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269852 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  269855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269869 */     GIR_RootConstrainSelectedInstOperands,
     /*  269870 */     // GIR_Coverage, 8336,
     /*  269870 */     GIR_EraseRootFromParent_Done,
     /*  269871 */   // Label 5140: @269871
     /*  269871 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(269934), // Rule ID 8337 //
     /*  269876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  269890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  269893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269915 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  269915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  269918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269932 */     GIR_RootConstrainSelectedInstOperands,
     /*  269933 */     // GIR_Coverage, 8337,
     /*  269933 */     GIR_EraseRootFromParent_Done,
     /*  269934 */   // Label 5141: @269934
     /*  269934 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(269997), // Rule ID 8340 //
     /*  269939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  269953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  269956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269978 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  269981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269995 */     GIR_RootConstrainSelectedInstOperands,
     /*  269996 */     // GIR_Coverage, 8340,
     /*  269996 */     GIR_EraseRootFromParent_Done,
     /*  269997 */   // Label 5142: @269997
     /*  269997 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(270060), // Rule ID 8341 //
     /*  270002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  270016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  270019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270041 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270058 */     GIR_RootConstrainSelectedInstOperands,
     /*  270059 */     // GIR_Coverage, 8341,
     /*  270059 */     GIR_EraseRootFromParent_Done,
     /*  270060 */   // Label 5143: @270060
     /*  270060 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(270123), // Rule ID 8344 //
     /*  270065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  270079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  270082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270104 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  270104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  270107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270121 */     GIR_RootConstrainSelectedInstOperands,
     /*  270122 */     // GIR_Coverage, 8344,
     /*  270122 */     GIR_EraseRootFromParent_Done,
     /*  270123 */   // Label 5144: @270123
     /*  270123 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(270186), // Rule ID 8345 //
     /*  270128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  270142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  270145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270167 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  270167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  270170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270184 */     GIR_RootConstrainSelectedInstOperands,
     /*  270185 */     // GIR_Coverage, 8345,
     /*  270185 */     GIR_EraseRootFromParent_Done,
     /*  270186 */   // Label 5145: @270186
     /*  270186 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(270249), // Rule ID 8348 //
     /*  270191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  270205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  270208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270230 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  270230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270247 */     GIR_RootConstrainSelectedInstOperands,
     /*  270248 */     // GIR_Coverage, 8348,
     /*  270248 */     GIR_EraseRootFromParent_Done,
     /*  270249 */   // Label 5146: @270249
     /*  270249 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(270312), // Rule ID 8349 //
     /*  270254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  270268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  270271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270293 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  270293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270310 */     GIR_RootConstrainSelectedInstOperands,
     /*  270311 */     // GIR_Coverage, 8349,
     /*  270311 */     GIR_EraseRootFromParent_Done,
     /*  270312 */   // Label 5147: @270312
     /*  270312 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(270375), // Rule ID 8352 //
     /*  270317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  270331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  270334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270356 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  270356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270373 */     GIR_RootConstrainSelectedInstOperands,
     /*  270374 */     // GIR_Coverage, 8352,
     /*  270374 */     GIR_EraseRootFromParent_Done,
     /*  270375 */   // Label 5148: @270375
     /*  270375 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(270438), // Rule ID 8353 //
     /*  270380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  270394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  270397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270419 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  270419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270436 */     GIR_RootConstrainSelectedInstOperands,
     /*  270437 */     // GIR_Coverage, 8353,
     /*  270437 */     GIR_EraseRootFromParent_Done,
     /*  270438 */   // Label 5149: @270438
     /*  270438 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(270501), // Rule ID 8356 //
     /*  270443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  270457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  270460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270482 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270499 */     GIR_RootConstrainSelectedInstOperands,
     /*  270500 */     // GIR_Coverage, 8356,
     /*  270500 */     GIR_EraseRootFromParent_Done,
     /*  270501 */   // Label 5150: @270501
     /*  270501 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(270564), // Rule ID 8357 //
     /*  270506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  270520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  270523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270545 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270562 */     GIR_RootConstrainSelectedInstOperands,
     /*  270563 */     // GIR_Coverage, 8357,
     /*  270563 */     GIR_EraseRootFromParent_Done,
     /*  270564 */   // Label 5151: @270564
     /*  270564 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(270627), // Rule ID 8360 //
     /*  270569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  270583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  270586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  270608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270625 */     GIR_RootConstrainSelectedInstOperands,
     /*  270626 */     // GIR_Coverage, 8360,
     /*  270626 */     GIR_EraseRootFromParent_Done,
     /*  270627 */   // Label 5152: @270627
     /*  270627 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(270690), // Rule ID 8361 //
     /*  270632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  270646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  270649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270671 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  270671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270688 */     GIR_RootConstrainSelectedInstOperands,
     /*  270689 */     // GIR_Coverage, 8361,
     /*  270689 */     GIR_EraseRootFromParent_Done,
     /*  270690 */   // Label 5153: @270690
     /*  270690 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(270753), // Rule ID 8364 //
     /*  270695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  270709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  270712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270734 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  270734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270751 */     GIR_RootConstrainSelectedInstOperands,
     /*  270752 */     // GIR_Coverage, 8364,
     /*  270752 */     GIR_EraseRootFromParent_Done,
     /*  270753 */   // Label 5154: @270753
     /*  270753 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(270816), // Rule ID 8365 //
     /*  270758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  270772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  270775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270797 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  270797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270814 */     GIR_RootConstrainSelectedInstOperands,
     /*  270815 */     // GIR_Coverage, 8365,
     /*  270815 */     GIR_EraseRootFromParent_Done,
     /*  270816 */   // Label 5155: @270816
     /*  270816 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(270879), // Rule ID 8368 //
     /*  270821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  270824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  270835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  270838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270860 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  270860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270877 */     GIR_RootConstrainSelectedInstOperands,
     /*  270878 */     // GIR_Coverage, 8368,
     /*  270878 */     GIR_EraseRootFromParent_Done,
     /*  270879 */   // Label 5156: @270879
     /*  270879 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(270942), // Rule ID 8369 //
     /*  270884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  270887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  270898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  270901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270923 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  270923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270940 */     GIR_RootConstrainSelectedInstOperands,
     /*  270941 */     // GIR_Coverage, 8369,
     /*  270941 */     GIR_EraseRootFromParent_Done,
     /*  270942 */   // Label 5157: @270942
     /*  270942 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(271005), // Rule ID 8372 //
     /*  270947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  270958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  270961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  270964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270986 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  270989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271003 */     GIR_RootConstrainSelectedInstOperands,
     /*  271004 */     // GIR_Coverage, 8372,
     /*  271004 */     GIR_EraseRootFromParent_Done,
     /*  271005 */   // Label 5158: @271005
     /*  271005 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(271068), // Rule ID 8373 //
     /*  271010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  271024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  271027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271049 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271066 */     GIR_RootConstrainSelectedInstOperands,
     /*  271067 */     // GIR_Coverage, 8373,
     /*  271067 */     GIR_EraseRootFromParent_Done,
     /*  271068 */   // Label 5159: @271068
     /*  271068 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(271131), // Rule ID 8376 //
     /*  271073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  271087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  271090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271112 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271129 */     GIR_RootConstrainSelectedInstOperands,
     /*  271130 */     // GIR_Coverage, 8376,
     /*  271130 */     GIR_EraseRootFromParent_Done,
     /*  271131 */   // Label 5160: @271131
     /*  271131 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(271194), // Rule ID 8377 //
     /*  271136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  271150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  271153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271175 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271192 */     GIR_RootConstrainSelectedInstOperands,
     /*  271193 */     // GIR_Coverage, 8377,
     /*  271193 */     GIR_EraseRootFromParent_Done,
     /*  271194 */   // Label 5161: @271194
     /*  271194 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(271257), // Rule ID 8380 //
     /*  271199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  271210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  271213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  271216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271238 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271255 */     GIR_RootConstrainSelectedInstOperands,
     /*  271256 */     // GIR_Coverage, 8380,
     /*  271256 */     GIR_EraseRootFromParent_Done,
     /*  271257 */   // Label 5162: @271257
     /*  271257 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(271320), // Rule ID 8381 //
     /*  271262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  271273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  271276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  271279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271301 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271318 */     GIR_RootConstrainSelectedInstOperands,
     /*  271319 */     // GIR_Coverage, 8381,
     /*  271319 */     GIR_EraseRootFromParent_Done,
     /*  271320 */   // Label 5163: @271320
     /*  271320 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(271383), // Rule ID 8384 //
     /*  271325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  271339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  271342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271364 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271381 */     GIR_RootConstrainSelectedInstOperands,
     /*  271382 */     // GIR_Coverage, 8384,
     /*  271382 */     GIR_EraseRootFromParent_Done,
     /*  271383 */   // Label 5164: @271383
     /*  271383 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(271446), // Rule ID 8385 //
     /*  271388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  271402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  271405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271427 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271444 */     GIR_RootConstrainSelectedInstOperands,
     /*  271445 */     // GIR_Coverage, 8385,
     /*  271445 */     GIR_EraseRootFromParent_Done,
     /*  271446 */   // Label 5165: @271446
     /*  271446 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(271509), // Rule ID 8388 //
     /*  271451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  271465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  271468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271490 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271507 */     GIR_RootConstrainSelectedInstOperands,
     /*  271508 */     // GIR_Coverage, 8388,
     /*  271508 */     GIR_EraseRootFromParent_Done,
     /*  271509 */   // Label 5166: @271509
     /*  271509 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(271572), // Rule ID 8389 //
     /*  271514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  271528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  271531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271553 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271570 */     GIR_RootConstrainSelectedInstOperands,
     /*  271571 */     // GIR_Coverage, 8389,
     /*  271571 */     GIR_EraseRootFromParent_Done,
     /*  271572 */   // Label 5167: @271572
     /*  271572 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(271635), // Rule ID 8392 //
     /*  271577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  271591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  271594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271616 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271633 */     GIR_RootConstrainSelectedInstOperands,
     /*  271634 */     // GIR_Coverage, 8392,
     /*  271634 */     GIR_EraseRootFromParent_Done,
     /*  271635 */   // Label 5168: @271635
     /*  271635 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(271698), // Rule ID 8393 //
     /*  271640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  271654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  271657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271679 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271696 */     GIR_RootConstrainSelectedInstOperands,
     /*  271697 */     // GIR_Coverage, 8393,
     /*  271697 */     GIR_EraseRootFromParent_Done,
     /*  271698 */   // Label 5169: @271698
     /*  271698 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(271761), // Rule ID 8396 //
     /*  271703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  271717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  271720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271742 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271759 */     GIR_RootConstrainSelectedInstOperands,
     /*  271760 */     // GIR_Coverage, 8396,
     /*  271760 */     GIR_EraseRootFromParent_Done,
     /*  271761 */   // Label 5170: @271761
     /*  271761 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(271824), // Rule ID 8397 //
     /*  271766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  271780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  271783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271805 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  271805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271822 */     GIR_RootConstrainSelectedInstOperands,
     /*  271823 */     // GIR_Coverage, 8397,
     /*  271823 */     GIR_EraseRootFromParent_Done,
     /*  271824 */   // Label 5171: @271824
     /*  271824 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(271887), // Rule ID 8400 //
     /*  271829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  271843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  271846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271868 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271885 */     GIR_RootConstrainSelectedInstOperands,
     /*  271886 */     // GIR_Coverage, 8400,
     /*  271886 */     GIR_EraseRootFromParent_Done,
     /*  271887 */   // Label 5172: @271887
     /*  271887 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(271950), // Rule ID 8401 //
     /*  271892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  271906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  271909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271931 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  271931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271948 */     GIR_RootConstrainSelectedInstOperands,
     /*  271949 */     // GIR_Coverage, 8401,
     /*  271949 */     GIR_EraseRootFromParent_Done,
     /*  271950 */   // Label 5173: @271950
     /*  271950 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(272013), // Rule ID 8404 //
     /*  271955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  271969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  271972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271994 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272011 */     GIR_RootConstrainSelectedInstOperands,
     /*  272012 */     // GIR_Coverage, 8404,
     /*  272012 */     GIR_EraseRootFromParent_Done,
     /*  272013 */   // Label 5174: @272013
     /*  272013 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(272076), // Rule ID 8405 //
     /*  272018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  272032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  272035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272057 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  272057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272074 */     GIR_RootConstrainSelectedInstOperands,
     /*  272075 */     // GIR_Coverage, 8405,
     /*  272075 */     GIR_EraseRootFromParent_Done,
     /*  272076 */   // Label 5175: @272076
     /*  272076 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(272139), // Rule ID 8408 //
     /*  272081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  272095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  272098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272120 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  272120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  272123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272137 */     GIR_RootConstrainSelectedInstOperands,
     /*  272138 */     // GIR_Coverage, 8408,
     /*  272138 */     GIR_EraseRootFromParent_Done,
     /*  272139 */   // Label 5176: @272139
     /*  272139 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(272202), // Rule ID 8409 //
     /*  272144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  272147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  272158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  272161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272183 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  272183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  272186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272200 */     GIR_RootConstrainSelectedInstOperands,
     /*  272201 */     // GIR_Coverage, 8409,
     /*  272201 */     GIR_EraseRootFromParent_Done,
     /*  272202 */   // Label 5177: @272202
     /*  272202 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(272265), // Rule ID 8412 //
     /*  272207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  272221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  272224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272246 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  272246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272263 */     GIR_RootConstrainSelectedInstOperands,
     /*  272264 */     // GIR_Coverage, 8412,
     /*  272264 */     GIR_EraseRootFromParent_Done,
     /*  272265 */   // Label 5178: @272265
     /*  272265 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(272328), // Rule ID 8413 //
     /*  272270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  272273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  272284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  272287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272309 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  272309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272326 */     GIR_RootConstrainSelectedInstOperands,
     /*  272327 */     // GIR_Coverage, 8413,
     /*  272327 */     GIR_EraseRootFromParent_Done,
     /*  272328 */   // Label 5179: @272328
     /*  272328 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(272391), // Rule ID 8416 //
     /*  272333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  272347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  272350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272372 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  272372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272389 */     GIR_RootConstrainSelectedInstOperands,
     /*  272390 */     // GIR_Coverage, 8416,
     /*  272390 */     GIR_EraseRootFromParent_Done,
     /*  272391 */   // Label 5180: @272391
     /*  272391 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(272454), // Rule ID 8417 //
     /*  272396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  272399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  272410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  272413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272435 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  272435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272452 */     GIR_RootConstrainSelectedInstOperands,
     /*  272453 */     // GIR_Coverage, 8417,
     /*  272453 */     GIR_EraseRootFromParent_Done,
     /*  272454 */   // Label 5181: @272454
     /*  272454 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(272517), // Rule ID 8420 //
     /*  272459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  272473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272498 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  272501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272515 */     GIR_RootConstrainSelectedInstOperands,
     /*  272516 */     // GIR_Coverage, 8420,
     /*  272516 */     GIR_EraseRootFromParent_Done,
     /*  272517 */   // Label 5182: @272517
     /*  272517 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(272580), // Rule ID 8421 //
     /*  272522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  272536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272561 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  272564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272578 */     GIR_RootConstrainSelectedInstOperands,
     /*  272579 */     // GIR_Coverage, 8421,
     /*  272579 */     GIR_EraseRootFromParent_Done,
     /*  272580 */   // Label 5183: @272580
     /*  272580 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(272643), // Rule ID 8424 //
     /*  272585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  272599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272624 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  272627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272641 */     GIR_RootConstrainSelectedInstOperands,
     /*  272642 */     // GIR_Coverage, 8424,
     /*  272642 */     GIR_EraseRootFromParent_Done,
     /*  272643 */   // Label 5184: @272643
     /*  272643 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(272706), // Rule ID 8425 //
     /*  272648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  272662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272687 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  272690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272704 */     GIR_RootConstrainSelectedInstOperands,
     /*  272705 */     // GIR_Coverage, 8425,
     /*  272705 */     GIR_EraseRootFromParent_Done,
     /*  272706 */   // Label 5185: @272706
     /*  272706 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(272769), // Rule ID 8428 //
     /*  272711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  272725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272750 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  272753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272767 */     GIR_RootConstrainSelectedInstOperands,
     /*  272768 */     // GIR_Coverage, 8428,
     /*  272768 */     GIR_EraseRootFromParent_Done,
     /*  272769 */   // Label 5186: @272769
     /*  272769 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(272832), // Rule ID 8429 //
     /*  272774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  272788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272813 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  272816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272830 */     GIR_RootConstrainSelectedInstOperands,
     /*  272831 */     // GIR_Coverage, 8429,
     /*  272831 */     GIR_EraseRootFromParent_Done,
     /*  272832 */   // Label 5187: @272832
     /*  272832 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(272895), // Rule ID 8432 //
     /*  272837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  272851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272876 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  272879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272893 */     GIR_RootConstrainSelectedInstOperands,
     /*  272894 */     // GIR_Coverage, 8432,
     /*  272894 */     GIR_EraseRootFromParent_Done,
     /*  272895 */   // Label 5188: @272895
     /*  272895 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(272958), // Rule ID 8433 //
     /*  272900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  272914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272939 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  272942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272956 */     GIR_RootConstrainSelectedInstOperands,
     /*  272957 */     // GIR_Coverage, 8433,
     /*  272957 */     GIR_EraseRootFromParent_Done,
     /*  272958 */   // Label 5189: @272958
     /*  272958 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(273021), // Rule ID 8436 //
     /*  272963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  272977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273002 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273019 */     GIR_RootConstrainSelectedInstOperands,
     /*  273020 */     // GIR_Coverage, 8436,
     /*  273020 */     GIR_EraseRootFromParent_Done,
     /*  273021 */   // Label 5190: @273021
     /*  273021 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(273084), // Rule ID 8437 //
     /*  273026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  273040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273065 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273082 */     GIR_RootConstrainSelectedInstOperands,
     /*  273083 */     // GIR_Coverage, 8437,
     /*  273083 */     GIR_EraseRootFromParent_Done,
     /*  273084 */   // Label 5191: @273084
     /*  273084 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(273147), // Rule ID 8440 //
     /*  273089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  273103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273128 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  273128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273145 */     GIR_RootConstrainSelectedInstOperands,
     /*  273146 */     // GIR_Coverage, 8440,
     /*  273146 */     GIR_EraseRootFromParent_Done,
     /*  273147 */   // Label 5192: @273147
     /*  273147 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(273210), // Rule ID 8441 //
     /*  273152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  273166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273191 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  273191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273208 */     GIR_RootConstrainSelectedInstOperands,
     /*  273209 */     // GIR_Coverage, 8441,
     /*  273209 */     GIR_EraseRootFromParent_Done,
     /*  273210 */   // Label 5193: @273210
     /*  273210 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(273273), // Rule ID 8444 //
     /*  273215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  273229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273254 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273271 */     GIR_RootConstrainSelectedInstOperands,
     /*  273272 */     // GIR_Coverage, 8444,
     /*  273272 */     GIR_EraseRootFromParent_Done,
     /*  273273 */   // Label 5194: @273273
     /*  273273 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(273336), // Rule ID 8445 //
     /*  273278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  273292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273317 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273334 */     GIR_RootConstrainSelectedInstOperands,
     /*  273335 */     // GIR_Coverage, 8445,
     /*  273335 */     GIR_EraseRootFromParent_Done,
     /*  273336 */   // Label 5195: @273336
     /*  273336 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(273399), // Rule ID 8448 //
     /*  273341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  273355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273380 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273397 */     GIR_RootConstrainSelectedInstOperands,
     /*  273398 */     // GIR_Coverage, 8448,
     /*  273398 */     GIR_EraseRootFromParent_Done,
     /*  273399 */   // Label 5196: @273399
     /*  273399 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(273462), // Rule ID 8449 //
     /*  273404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  273418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273443 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273460 */     GIR_RootConstrainSelectedInstOperands,
     /*  273461 */     // GIR_Coverage, 8449,
     /*  273461 */     GIR_EraseRootFromParent_Done,
     /*  273462 */   // Label 5197: @273462
     /*  273462 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(273525), // Rule ID 8452 //
     /*  273467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  273481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273506 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  273506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273523 */     GIR_RootConstrainSelectedInstOperands,
     /*  273524 */     // GIR_Coverage, 8452,
     /*  273524 */     GIR_EraseRootFromParent_Done,
     /*  273525 */   // Label 5198: @273525
     /*  273525 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(273588), // Rule ID 8453 //
     /*  273530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  273544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273569 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  273569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273586 */     GIR_RootConstrainSelectedInstOperands,
     /*  273587 */     // GIR_Coverage, 8453,
     /*  273587 */     GIR_EraseRootFromParent_Done,
     /*  273588 */   // Label 5199: @273588
     /*  273588 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(273651), // Rule ID 8456 //
     /*  273593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  273596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  273607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273632 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  273632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273649 */     GIR_RootConstrainSelectedInstOperands,
     /*  273650 */     // GIR_Coverage, 8456,
     /*  273650 */     GIR_EraseRootFromParent_Done,
     /*  273651 */   // Label 5200: @273651
     /*  273651 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(273714), // Rule ID 8457 //
     /*  273656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  273659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  273670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273695 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  273695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273712 */     GIR_RootConstrainSelectedInstOperands,
     /*  273713 */     // GIR_Coverage, 8457,
     /*  273713 */     GIR_EraseRootFromParent_Done,
     /*  273714 */   // Label 5201: @273714
     /*  273714 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(273777), // Rule ID 8460 //
     /*  273719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  273730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  273733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  273747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273758 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  273761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273775 */     GIR_RootConstrainSelectedInstOperands,
     /*  273776 */     // GIR_Coverage, 8460,
     /*  273776 */     GIR_EraseRootFromParent_Done,
     /*  273777 */   // Label 5202: @273777
     /*  273777 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(273840), // Rule ID 8461 //
     /*  273782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  273793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  273796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  273810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273821 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  273824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273838 */     GIR_RootConstrainSelectedInstOperands,
     /*  273839 */     // GIR_Coverage, 8461,
     /*  273839 */     GIR_EraseRootFromParent_Done,
     /*  273840 */   // Label 5203: @273840
     /*  273840 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(273903), // Rule ID 8464 //
     /*  273845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  273856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  273859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273884 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  273887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273901 */     GIR_RootConstrainSelectedInstOperands,
     /*  273902 */     // GIR_Coverage, 8464,
     /*  273902 */     GIR_EraseRootFromParent_Done,
     /*  273903 */   // Label 5204: @273903
     /*  273903 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(273966), // Rule ID 8465 //
     /*  273908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  273919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  273922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273947 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  273950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273964 */     GIR_RootConstrainSelectedInstOperands,
     /*  273965 */     // GIR_Coverage, 8465,
     /*  273965 */     GIR_EraseRootFromParent_Done,
     /*  273966 */   // Label 5205: @273966
     /*  273966 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(274029), // Rule ID 8468 //
     /*  273971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  273982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  273985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274010 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274027 */     GIR_RootConstrainSelectedInstOperands,
     /*  274028 */     // GIR_Coverage, 8468,
     /*  274028 */     GIR_EraseRootFromParent_Done,
     /*  274029 */   // Label 5206: @274029
     /*  274029 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(274092), // Rule ID 8469 //
     /*  274034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  274045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  274048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274073 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274090 */     GIR_RootConstrainSelectedInstOperands,
     /*  274091 */     // GIR_Coverage, 8469,
     /*  274091 */     GIR_EraseRootFromParent_Done,
     /*  274092 */   // Label 5207: @274092
     /*  274092 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(274155), // Rule ID 8472 //
     /*  274097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  274111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274136 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274153 */     GIR_RootConstrainSelectedInstOperands,
     /*  274154 */     // GIR_Coverage, 8472,
     /*  274154 */     GIR_EraseRootFromParent_Done,
     /*  274155 */   // Label 5208: @274155
     /*  274155 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(274218), // Rule ID 8473 //
     /*  274160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  274174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274199 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274216 */     GIR_RootConstrainSelectedInstOperands,
     /*  274217 */     // GIR_Coverage, 8473,
     /*  274217 */     GIR_EraseRootFromParent_Done,
     /*  274218 */   // Label 5209: @274218
     /*  274218 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(274281), // Rule ID 8476 //
     /*  274223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  274237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274262 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274279 */     GIR_RootConstrainSelectedInstOperands,
     /*  274280 */     // GIR_Coverage, 8476,
     /*  274280 */     GIR_EraseRootFromParent_Done,
     /*  274281 */   // Label 5210: @274281
     /*  274281 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(274344), // Rule ID 8477 //
     /*  274286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  274300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274325 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274342 */     GIR_RootConstrainSelectedInstOperands,
     /*  274343 */     // GIR_Coverage, 8477,
     /*  274343 */     GIR_EraseRootFromParent_Done,
     /*  274344 */   // Label 5211: @274344
     /*  274344 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(274407), // Rule ID 8480 //
     /*  274349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  274363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274388 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274405 */     GIR_RootConstrainSelectedInstOperands,
     /*  274406 */     // GIR_Coverage, 8480,
     /*  274406 */     GIR_EraseRootFromParent_Done,
     /*  274407 */   // Label 5212: @274407
     /*  274407 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(274470), // Rule ID 8481 //
     /*  274412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  274426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274451 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274468 */     GIR_RootConstrainSelectedInstOperands,
     /*  274469 */     // GIR_Coverage, 8481,
     /*  274469 */     GIR_EraseRootFromParent_Done,
     /*  274470 */   // Label 5213: @274470
     /*  274470 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(274533), // Rule ID 8484 //
     /*  274475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  274489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274514 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274531 */     GIR_RootConstrainSelectedInstOperands,
     /*  274532 */     // GIR_Coverage, 8484,
     /*  274532 */     GIR_EraseRootFromParent_Done,
     /*  274533 */   // Label 5214: @274533
     /*  274533 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(274596), // Rule ID 8485 //
     /*  274538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  274552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274577 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274594 */     GIR_RootConstrainSelectedInstOperands,
     /*  274595 */     // GIR_Coverage, 8485,
     /*  274595 */     GIR_EraseRootFromParent_Done,
     /*  274596 */   // Label 5215: @274596
     /*  274596 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(274659), // Rule ID 8488 //
     /*  274601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  274615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274640 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274657 */     GIR_RootConstrainSelectedInstOperands,
     /*  274658 */     // GIR_Coverage, 8488,
     /*  274658 */     GIR_EraseRootFromParent_Done,
     /*  274659 */   // Label 5216: @274659
     /*  274659 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(274722), // Rule ID 8489 //
     /*  274664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  274678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274703 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274720 */     GIR_RootConstrainSelectedInstOperands,
     /*  274721 */     // GIR_Coverage, 8489,
     /*  274721 */     GIR_EraseRootFromParent_Done,
     /*  274722 */   // Label 5217: @274722
     /*  274722 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(274785), // Rule ID 8492 //
     /*  274727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  274741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274766 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274783 */     GIR_RootConstrainSelectedInstOperands,
     /*  274784 */     // GIR_Coverage, 8492,
     /*  274784 */     GIR_EraseRootFromParent_Done,
     /*  274785 */   // Label 5218: @274785
     /*  274785 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(274848), // Rule ID 8493 //
     /*  274790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  274804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274829 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274846 */     GIR_RootConstrainSelectedInstOperands,
     /*  274847 */     // GIR_Coverage, 8493,
     /*  274847 */     GIR_EraseRootFromParent_Done,
     /*  274848 */   // Label 5219: @274848
     /*  274848 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(274911), // Rule ID 8496 //
     /*  274853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  274856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  274867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274892 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  274892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274909 */     GIR_RootConstrainSelectedInstOperands,
     /*  274910 */     // GIR_Coverage, 8496,
     /*  274910 */     GIR_EraseRootFromParent_Done,
     /*  274911 */   // Label 5220: @274911
     /*  274911 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(274974), // Rule ID 8497 //
     /*  274916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  274919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  274930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274955 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  274955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274972 */     GIR_RootConstrainSelectedInstOperands,
     /*  274973 */     // GIR_Coverage, 8497,
     /*  274973 */     GIR_EraseRootFromParent_Done,
     /*  274974 */   // Label 5221: @274974
     /*  274974 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(275037), // Rule ID 8500 //
     /*  274979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  274982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  274993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275018 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  275018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  275021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275035 */     GIR_RootConstrainSelectedInstOperands,
     /*  275036 */     // GIR_Coverage, 8500,
     /*  275036 */     GIR_EraseRootFromParent_Done,
     /*  275037 */   // Label 5222: @275037
     /*  275037 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(275100), // Rule ID 8501 //
     /*  275042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  275045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  275056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275081 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  275081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  275084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275098 */     GIR_RootConstrainSelectedInstOperands,
     /*  275099 */     // GIR_Coverage, 8501,
     /*  275099 */     GIR_EraseRootFromParent_Done,
     /*  275100 */   // Label 5223: @275100
     /*  275100 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(275163), // Rule ID 8504 //
     /*  275105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  275108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  275119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  275122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275144 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  275144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  275147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275161 */     GIR_RootConstrainSelectedInstOperands,
     /*  275162 */     // GIR_Coverage, 8504,
     /*  275162 */     GIR_EraseRootFromParent_Done,
     /*  275163 */   // Label 5224: @275163
     /*  275163 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(275226), // Rule ID 8505 //
     /*  275168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  275171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  275182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275207 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  275207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  275210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275224 */     GIR_RootConstrainSelectedInstOperands,
     /*  275225 */     // GIR_Coverage, 8505,
     /*  275225 */     GIR_EraseRootFromParent_Done,
     /*  275226 */   // Label 5225: @275226
     /*  275226 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(275289), // Rule ID 8508 //
     /*  275231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  275245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  275248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275270 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  275273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275287 */     GIR_RootConstrainSelectedInstOperands,
     /*  275288 */     // GIR_Coverage, 8508,
     /*  275288 */     GIR_EraseRootFromParent_Done,
     /*  275289 */   // Label 5226: @275289
     /*  275289 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(275352), // Rule ID 8509 //
     /*  275294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  275308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  275311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275333 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  275336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275350 */     GIR_RootConstrainSelectedInstOperands,
     /*  275351 */     // GIR_Coverage, 8509,
     /*  275351 */     GIR_EraseRootFromParent_Done,
     /*  275352 */   // Label 5227: @275352
     /*  275352 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(275415), // Rule ID 8512 //
     /*  275357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  275371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  275374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275396 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275413 */     GIR_RootConstrainSelectedInstOperands,
     /*  275414 */     // GIR_Coverage, 8512,
     /*  275414 */     GIR_EraseRootFromParent_Done,
     /*  275415 */   // Label 5228: @275415
     /*  275415 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(275478), // Rule ID 8513 //
     /*  275420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  275434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  275437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275459 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275476 */     GIR_RootConstrainSelectedInstOperands,
     /*  275477 */     // GIR_Coverage, 8513,
     /*  275477 */     GIR_EraseRootFromParent_Done,
     /*  275478 */   // Label 5229: @275478
     /*  275478 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(275541), // Rule ID 8516 //
     /*  275483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  275497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  275500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275522 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275539 */     GIR_RootConstrainSelectedInstOperands,
     /*  275540 */     // GIR_Coverage, 8516,
     /*  275540 */     GIR_EraseRootFromParent_Done,
     /*  275541 */   // Label 5230: @275541
     /*  275541 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(275604), // Rule ID 8517 //
     /*  275546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  275560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  275563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275585 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275602 */     GIR_RootConstrainSelectedInstOperands,
     /*  275603 */     // GIR_Coverage, 8517,
     /*  275603 */     GIR_EraseRootFromParent_Done,
     /*  275604 */   // Label 5231: @275604
     /*  275604 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(275667), // Rule ID 8520 //
     /*  275609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  275623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  275626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275648 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  275648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275665 */     GIR_RootConstrainSelectedInstOperands,
     /*  275666 */     // GIR_Coverage, 8520,
     /*  275666 */     GIR_EraseRootFromParent_Done,
     /*  275667 */   // Label 5232: @275667
     /*  275667 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(275730), // Rule ID 8521 //
     /*  275672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  275686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  275689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275711 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  275711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275728 */     GIR_RootConstrainSelectedInstOperands,
     /*  275729 */     // GIR_Coverage, 8521,
     /*  275729 */     GIR_EraseRootFromParent_Done,
     /*  275730 */   // Label 5233: @275730
     /*  275730 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(275793), // Rule ID 8524 //
     /*  275735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  275749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  275752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275774 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  275774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275791 */     GIR_RootConstrainSelectedInstOperands,
     /*  275792 */     // GIR_Coverage, 8524,
     /*  275792 */     GIR_EraseRootFromParent_Done,
     /*  275793 */   // Label 5234: @275793
     /*  275793 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(275856), // Rule ID 8525 //
     /*  275798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  275812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  275815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275837 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  275837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275854 */     GIR_RootConstrainSelectedInstOperands,
     /*  275855 */     // GIR_Coverage, 8525,
     /*  275855 */     GIR_EraseRootFromParent_Done,
     /*  275856 */   // Label 5235: @275856
     /*  275856 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(275919), // Rule ID 8528 //
     /*  275861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  275875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  275878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275900 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275917 */     GIR_RootConstrainSelectedInstOperands,
     /*  275918 */     // GIR_Coverage, 8528,
     /*  275918 */     GIR_EraseRootFromParent_Done,
     /*  275919 */   // Label 5236: @275919
     /*  275919 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(275982), // Rule ID 8529 //
     /*  275924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  275938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  275941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275963 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275980 */     GIR_RootConstrainSelectedInstOperands,
     /*  275981 */     // GIR_Coverage, 8529,
     /*  275981 */     GIR_EraseRootFromParent_Done,
     /*  275982 */   // Label 5237: @275982
     /*  275982 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(276045), // Rule ID 8532 //
     /*  275987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  276001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  276004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276026 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276043 */     GIR_RootConstrainSelectedInstOperands,
     /*  276044 */     // GIR_Coverage, 8532,
     /*  276044 */     GIR_EraseRootFromParent_Done,
     /*  276045 */   // Label 5238: @276045
     /*  276045 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(276108), // Rule ID 8533 //
     /*  276050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  276064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  276067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276089 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276106 */     GIR_RootConstrainSelectedInstOperands,
     /*  276107 */     // GIR_Coverage, 8533,
     /*  276107 */     GIR_EraseRootFromParent_Done,
     /*  276108 */   // Label 5239: @276108
     /*  276108 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(276171), // Rule ID 8536 //
     /*  276113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  276127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  276130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276152 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276169 */     GIR_RootConstrainSelectedInstOperands,
     /*  276170 */     // GIR_Coverage, 8536,
     /*  276170 */     GIR_EraseRootFromParent_Done,
     /*  276171 */   // Label 5240: @276171
     /*  276171 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(276234), // Rule ID 8537 //
     /*  276176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  276190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  276193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276215 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276232 */     GIR_RootConstrainSelectedInstOperands,
     /*  276233 */     // GIR_Coverage, 8537,
     /*  276233 */     GIR_EraseRootFromParent_Done,
     /*  276234 */   // Label 5241: @276234
     /*  276234 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(276297), // Rule ID 8540 //
     /*  276239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  276253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  276256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276278 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  276278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276295 */     GIR_RootConstrainSelectedInstOperands,
     /*  276296 */     // GIR_Coverage, 8540,
     /*  276296 */     GIR_EraseRootFromParent_Done,
     /*  276297 */   // Label 5242: @276297
     /*  276297 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(276360), // Rule ID 8541 //
     /*  276302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  276316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  276319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276341 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  276341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276358 */     GIR_RootConstrainSelectedInstOperands,
     /*  276359 */     // GIR_Coverage, 8541,
     /*  276359 */     GIR_EraseRootFromParent_Done,
     /*  276360 */   // Label 5243: @276360
     /*  276360 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(276423), // Rule ID 8544 //
     /*  276365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  276368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  276379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  276382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276404 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  276404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276421 */     GIR_RootConstrainSelectedInstOperands,
     /*  276422 */     // GIR_Coverage, 8544,
     /*  276422 */     GIR_EraseRootFromParent_Done,
     /*  276423 */   // Label 5244: @276423
     /*  276423 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(276486), // Rule ID 8545 //
     /*  276428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  276431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  276442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  276445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276467 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  276467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276484 */     GIR_RootConstrainSelectedInstOperands,
     /*  276485 */     // GIR_Coverage, 8545,
     /*  276485 */     GIR_EraseRootFromParent_Done,
     /*  276486 */   // Label 5245: @276486
     /*  276486 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(276549), // Rule ID 8548 //
     /*  276491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  276502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  276505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  276508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276530 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276547 */     GIR_RootConstrainSelectedInstOperands,
     /*  276548 */     // GIR_Coverage, 8548,
     /*  276548 */     GIR_EraseRootFromParent_Done,
     /*  276549 */   // Label 5246: @276549
     /*  276549 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(276612), // Rule ID 8549 //
     /*  276554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  276565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  276568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  276571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276593 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276610 */     GIR_RootConstrainSelectedInstOperands,
     /*  276611 */     // GIR_Coverage, 8549,
     /*  276611 */     GIR_EraseRootFromParent_Done,
     /*  276612 */   // Label 5247: @276612
     /*  276612 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(276675), // Rule ID 8552 //
     /*  276617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  276628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  276631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  276634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276656 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  276659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276673 */     GIR_RootConstrainSelectedInstOperands,
     /*  276674 */     // GIR_Coverage, 8552,
     /*  276674 */     GIR_EraseRootFromParent_Done,
     /*  276675 */   // Label 5248: @276675
     /*  276675 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(276738), // Rule ID 8553 //
     /*  276680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  276691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  276694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  276697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276719 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  276722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276736 */     GIR_RootConstrainSelectedInstOperands,
     /*  276737 */     // GIR_Coverage, 8553,
     /*  276737 */     GIR_EraseRootFromParent_Done,
     /*  276738 */   // Label 5249: @276738
     /*  276738 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(276801), // Rule ID 8556 //
     /*  276743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  276754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  276757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  276760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276782 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  276785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276799 */     GIR_RootConstrainSelectedInstOperands,
     /*  276800 */     // GIR_Coverage, 8556,
     /*  276800 */     GIR_EraseRootFromParent_Done,
     /*  276801 */   // Label 5250: @276801
     /*  276801 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(276864), // Rule ID 8557 //
     /*  276806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  276817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  276820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  276823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276845 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  276848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276862 */     GIR_RootConstrainSelectedInstOperands,
     /*  276863 */     // GIR_Coverage, 8557,
     /*  276863 */     GIR_EraseRootFromParent_Done,
     /*  276864 */   // Label 5251: @276864
     /*  276864 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(276927), // Rule ID 8560 //
     /*  276869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  276883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  276886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276908 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276925 */     GIR_RootConstrainSelectedInstOperands,
     /*  276926 */     // GIR_Coverage, 8560,
     /*  276926 */     GIR_EraseRootFromParent_Done,
     /*  276927 */   // Label 5252: @276927
     /*  276927 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(276990), // Rule ID 8561 //
     /*  276932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  276946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  276949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276971 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276988 */     GIR_RootConstrainSelectedInstOperands,
     /*  276989 */     // GIR_Coverage, 8561,
     /*  276989 */     GIR_EraseRootFromParent_Done,
     /*  276990 */   // Label 5253: @276990
     /*  276990 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(277053), // Rule ID 8564 //
     /*  276995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  277009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  277012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277034 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277051 */     GIR_RootConstrainSelectedInstOperands,
     /*  277052 */     // GIR_Coverage, 8564,
     /*  277052 */     GIR_EraseRootFromParent_Done,
     /*  277053 */   // Label 5254: @277053
     /*  277053 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(277116), // Rule ID 8565 //
     /*  277058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  277072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  277075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277097 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  277097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277114 */     GIR_RootConstrainSelectedInstOperands,
     /*  277115 */     // GIR_Coverage, 8565,
     /*  277115 */     GIR_EraseRootFromParent_Done,
     /*  277116 */   // Label 5255: @277116
     /*  277116 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(277179), // Rule ID 8568 //
     /*  277121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  277135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  277138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277160 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277177 */     GIR_RootConstrainSelectedInstOperands,
     /*  277178 */     // GIR_Coverage, 8568,
     /*  277178 */     GIR_EraseRootFromParent_Done,
     /*  277179 */   // Label 5256: @277179
     /*  277179 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(277242), // Rule ID 8569 //
     /*  277184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  277198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  277201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277223 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  277223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277240 */     GIR_RootConstrainSelectedInstOperands,
     /*  277241 */     // GIR_Coverage, 8569,
     /*  277241 */     GIR_EraseRootFromParent_Done,
     /*  277242 */   // Label 5257: @277242
     /*  277242 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(277305), // Rule ID 8572 //
     /*  277247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  277261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  277264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277286 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277303 */     GIR_RootConstrainSelectedInstOperands,
     /*  277304 */     // GIR_Coverage, 8572,
     /*  277304 */     GIR_EraseRootFromParent_Done,
     /*  277305 */   // Label 5258: @277305
     /*  277305 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(277368), // Rule ID 8573 //
     /*  277310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  277324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  277327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277349 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277366 */     GIR_RootConstrainSelectedInstOperands,
     /*  277367 */     // GIR_Coverage, 8573,
     /*  277367 */     GIR_EraseRootFromParent_Done,
     /*  277368 */   // Label 5259: @277368
     /*  277368 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(277431), // Rule ID 8576 //
     /*  277373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  277387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  277390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277412 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277429 */     GIR_RootConstrainSelectedInstOperands,
     /*  277430 */     // GIR_Coverage, 8576,
     /*  277430 */     GIR_EraseRootFromParent_Done,
     /*  277431 */   // Label 5260: @277431
     /*  277431 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(277494), // Rule ID 8577 //
     /*  277436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  277450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  277453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277475 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277492 */     GIR_RootConstrainSelectedInstOperands,
     /*  277493 */     // GIR_Coverage, 8577,
     /*  277493 */     GIR_EraseRootFromParent_Done,
     /*  277494 */   // Label 5261: @277494
     /*  277494 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(277557), // Rule ID 8580 //
     /*  277499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  277513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  277516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277538 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277555 */     GIR_RootConstrainSelectedInstOperands,
     /*  277556 */     // GIR_Coverage, 8580,
     /*  277556 */     GIR_EraseRootFromParent_Done,
     /*  277557 */   // Label 5262: @277557
     /*  277557 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(277620), // Rule ID 8581 //
     /*  277562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  277576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  277579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277601 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277618 */     GIR_RootConstrainSelectedInstOperands,
     /*  277619 */     // GIR_Coverage, 8581,
     /*  277619 */     GIR_EraseRootFromParent_Done,
     /*  277620 */   // Label 5263: @277620
     /*  277620 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(277683), // Rule ID 8584 //
     /*  277625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  277628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  277636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  277639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  277642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277664 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  277664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277681 */     GIR_RootConstrainSelectedInstOperands,
     /*  277682 */     // GIR_Coverage, 8584,
     /*  277682 */     GIR_EraseRootFromParent_Done,
     /*  277683 */   // Label 5264: @277683
     /*  277683 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(277746), // Rule ID 8585 //
     /*  277688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  277691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  277699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  277702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  277705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277727 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  277727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277744 */     GIR_RootConstrainSelectedInstOperands,
     /*  277745 */     // GIR_Coverage, 8585,
     /*  277745 */     GIR_EraseRootFromParent_Done,
     /*  277746 */   // Label 5265: @277746
     /*  277746 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(277809), // Rule ID 8588 //
     /*  277751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  277754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  277765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  277768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277790 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  277790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277807 */     GIR_RootConstrainSelectedInstOperands,
     /*  277808 */     // GIR_Coverage, 8588,
     /*  277808 */     GIR_EraseRootFromParent_Done,
     /*  277809 */   // Label 5266: @277809
     /*  277809 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(277872), // Rule ID 8589 //
     /*  277814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  277817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  277828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  277831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277853 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  277853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277870 */     GIR_RootConstrainSelectedInstOperands,
     /*  277871 */     // GIR_Coverage, 8589,
     /*  277871 */     GIR_EraseRootFromParent_Done,
     /*  277872 */   // Label 5267: @277872
     /*  277872 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(277935), // Rule ID 8592 //
     /*  277877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  277880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  277891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  277894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277916 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  277916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277933 */     GIR_RootConstrainSelectedInstOperands,
     /*  277934 */     // GIR_Coverage, 8592,
     /*  277934 */     GIR_EraseRootFromParent_Done,
     /*  277935 */   // Label 5268: @277935
     /*  277935 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(277998), // Rule ID 8593 //
     /*  277940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  277943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  277954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  277957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277979 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  277979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277996 */     GIR_RootConstrainSelectedInstOperands,
     /*  277997 */     // GIR_Coverage, 8593,
     /*  277997 */     GIR_EraseRootFromParent_Done,
     /*  277998 */   // Label 5269: @277998
     /*  277998 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(278061), // Rule ID 8596 //
     /*  278003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  278017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278042 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  278045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278059 */     GIR_RootConstrainSelectedInstOperands,
     /*  278060 */     // GIR_Coverage, 8596,
     /*  278060 */     GIR_EraseRootFromParent_Done,
     /*  278061 */   // Label 5270: @278061
     /*  278061 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(278124), // Rule ID 8597 //
     /*  278066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  278080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278105 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  278108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278122 */     GIR_RootConstrainSelectedInstOperands,
     /*  278123 */     // GIR_Coverage, 8597,
     /*  278123 */     GIR_EraseRootFromParent_Done,
     /*  278124 */   // Label 5271: @278124
     /*  278124 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(278187), // Rule ID 8600 //
     /*  278129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  278143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278168 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278185 */     GIR_RootConstrainSelectedInstOperands,
     /*  278186 */     // GIR_Coverage, 8600,
     /*  278186 */     GIR_EraseRootFromParent_Done,
     /*  278187 */   // Label 5272: @278187
     /*  278187 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(278250), // Rule ID 8601 //
     /*  278192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  278206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278231 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278248 */     GIR_RootConstrainSelectedInstOperands,
     /*  278249 */     // GIR_Coverage, 8601,
     /*  278249 */     GIR_EraseRootFromParent_Done,
     /*  278250 */   // Label 5273: @278250
     /*  278250 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(278313), // Rule ID 8604 //
     /*  278255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  278269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278294 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278311 */     GIR_RootConstrainSelectedInstOperands,
     /*  278312 */     // GIR_Coverage, 8604,
     /*  278312 */     GIR_EraseRootFromParent_Done,
     /*  278313 */   // Label 5274: @278313
     /*  278313 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(278376), // Rule ID 8605 //
     /*  278318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  278332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278357 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278374 */     GIR_RootConstrainSelectedInstOperands,
     /*  278375 */     // GIR_Coverage, 8605,
     /*  278375 */     GIR_EraseRootFromParent_Done,
     /*  278376 */   // Label 5275: @278376
     /*  278376 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(278439), // Rule ID 8608 //
     /*  278381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  278395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278420 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278437 */     GIR_RootConstrainSelectedInstOperands,
     /*  278438 */     // GIR_Coverage, 8608,
     /*  278438 */     GIR_EraseRootFromParent_Done,
     /*  278439 */   // Label 5276: @278439
     /*  278439 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(278502), // Rule ID 8609 //
     /*  278444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  278458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278483 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278500 */     GIR_RootConstrainSelectedInstOperands,
     /*  278501 */     // GIR_Coverage, 8609,
     /*  278501 */     GIR_EraseRootFromParent_Done,
     /*  278502 */   // Label 5277: @278502
     /*  278502 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(278565), // Rule ID 8612 //
     /*  278507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  278521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278546 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278563 */     GIR_RootConstrainSelectedInstOperands,
     /*  278564 */     // GIR_Coverage, 8612,
     /*  278564 */     GIR_EraseRootFromParent_Done,
     /*  278565 */   // Label 5278: @278565
     /*  278565 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(278628), // Rule ID 8613 //
     /*  278570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  278584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278609 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278626 */     GIR_RootConstrainSelectedInstOperands,
     /*  278627 */     // GIR_Coverage, 8613,
     /*  278627 */     GIR_EraseRootFromParent_Done,
     /*  278628 */   // Label 5279: @278628
     /*  278628 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(278691), // Rule ID 8616 //
     /*  278633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  278647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278672 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  278672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278689 */     GIR_RootConstrainSelectedInstOperands,
     /*  278690 */     // GIR_Coverage, 8616,
     /*  278690 */     GIR_EraseRootFromParent_Done,
     /*  278691 */   // Label 5280: @278691
     /*  278691 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(278754), // Rule ID 8617 //
     /*  278696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  278710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278735 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  278735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278752 */     GIR_RootConstrainSelectedInstOperands,
     /*  278753 */     // GIR_Coverage, 8617,
     /*  278753 */     GIR_EraseRootFromParent_Done,
     /*  278754 */   // Label 5281: @278754
     /*  278754 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(278817), // Rule ID 8620 //
     /*  278759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  278773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278798 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278815 */     GIR_RootConstrainSelectedInstOperands,
     /*  278816 */     // GIR_Coverage, 8620,
     /*  278816 */     GIR_EraseRootFromParent_Done,
     /*  278817 */   // Label 5282: @278817
     /*  278817 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(278880), // Rule ID 8621 //
     /*  278822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  278836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278861 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278878 */     GIR_RootConstrainSelectedInstOperands,
     /*  278879 */     // GIR_Coverage, 8621,
     /*  278879 */     GIR_EraseRootFromParent_Done,
     /*  278880 */   // Label 5283: @278880
     /*  278880 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(278943), // Rule ID 8624 //
     /*  278885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  278899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278924 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278941 */     GIR_RootConstrainSelectedInstOperands,
     /*  278942 */     // GIR_Coverage, 8624,
     /*  278942 */     GIR_EraseRootFromParent_Done,
     /*  278943 */   // Label 5284: @278943
     /*  278943 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(279006), // Rule ID 8625 //
     /*  278948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  278962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278987 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279004 */     GIR_RootConstrainSelectedInstOperands,
     /*  279005 */     // GIR_Coverage, 8625,
     /*  279005 */     GIR_EraseRootFromParent_Done,
     /*  279006 */   // Label 5285: @279006
     /*  279006 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(279069), // Rule ID 8628 //
     /*  279011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  279025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279050 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  279050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279067 */     GIR_RootConstrainSelectedInstOperands,
     /*  279068 */     // GIR_Coverage, 8628,
     /*  279068 */     GIR_EraseRootFromParent_Done,
     /*  279069 */   // Label 5286: @279069
     /*  279069 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(279132), // Rule ID 8629 //
     /*  279074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  279088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279113 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  279113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279130 */     GIR_RootConstrainSelectedInstOperands,
     /*  279131 */     // GIR_Coverage, 8629,
     /*  279131 */     GIR_EraseRootFromParent_Done,
     /*  279132 */   // Label 5287: @279132
     /*  279132 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(279195), // Rule ID 8632 //
     /*  279137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  279140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  279151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279176 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  279176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  279193 */     GIR_RootConstrainSelectedInstOperands,
     /*  279194 */     // GIR_Coverage, 8632,
     /*  279194 */     GIR_EraseRootFromParent_Done,
     /*  279195 */   // Label 5288: @279195
     /*  279195 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(279258), // Rule ID 8633 //
     /*  279200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  279203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  279214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279239 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  279239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  279256 */     GIR_RootConstrainSelectedInstOperands,
     /*  279257 */     // GIR_Coverage, 8633,
     /*  279257 */     GIR_EraseRootFromParent_Done,
     /*  279258 */   // Label 5289: @279258
     /*  279258 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(279321), // Rule ID 8636 //
     /*  279263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  279277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279302 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279319 */     GIR_RootConstrainSelectedInstOperands,
     /*  279320 */     // GIR_Coverage, 8636,
     /*  279320 */     GIR_EraseRootFromParent_Done,
     /*  279321 */   // Label 5290: @279321
     /*  279321 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(279384), // Rule ID 8637 //
     /*  279326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  279340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279365 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279382 */     GIR_RootConstrainSelectedInstOperands,
     /*  279383 */     // GIR_Coverage, 8637,
     /*  279383 */     GIR_EraseRootFromParent_Done,
     /*  279384 */   // Label 5291: @279384
     /*  279384 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(279447), // Rule ID 8640 //
     /*  279389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  279403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279428 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279445 */     GIR_RootConstrainSelectedInstOperands,
     /*  279446 */     // GIR_Coverage, 8640,
     /*  279446 */     GIR_EraseRootFromParent_Done,
     /*  279447 */   // Label 5292: @279447
     /*  279447 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(279510), // Rule ID 8641 //
     /*  279452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  279466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279491 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279508 */     GIR_RootConstrainSelectedInstOperands,
     /*  279509 */     // GIR_Coverage, 8641,
     /*  279509 */     GIR_EraseRootFromParent_Done,
     /*  279510 */   // Label 5293: @279510
     /*  279510 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(279573), // Rule ID 8644 //
     /*  279515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  279526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  279529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279554 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279571 */     GIR_RootConstrainSelectedInstOperands,
     /*  279572 */     // GIR_Coverage, 8644,
     /*  279572 */     GIR_EraseRootFromParent_Done,
     /*  279573 */   // Label 5294: @279573
     /*  279573 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(279636), // Rule ID 8645 //
     /*  279578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  279589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  279592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279617 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279634 */     GIR_RootConstrainSelectedInstOperands,
     /*  279635 */     // GIR_Coverage, 8645,
     /*  279635 */     GIR_EraseRootFromParent_Done,
     /*  279636 */   // Label 5295: @279636
     /*  279636 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(279699), // Rule ID 8648 //
     /*  279641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  279655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279680 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279697 */     GIR_RootConstrainSelectedInstOperands,
     /*  279698 */     // GIR_Coverage, 8648,
     /*  279698 */     GIR_EraseRootFromParent_Done,
     /*  279699 */   // Label 5296: @279699
     /*  279699 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(279762), // Rule ID 8649 //
     /*  279704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  279718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279743 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279760 */     GIR_RootConstrainSelectedInstOperands,
     /*  279761 */     // GIR_Coverage, 8649,
     /*  279761 */     GIR_EraseRootFromParent_Done,
     /*  279762 */   // Label 5297: @279762
     /*  279762 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(279825), // Rule ID 8652 //
     /*  279767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  279781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279806 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279823 */     GIR_RootConstrainSelectedInstOperands,
     /*  279824 */     // GIR_Coverage, 8652,
     /*  279824 */     GIR_EraseRootFromParent_Done,
     /*  279825 */   // Label 5298: @279825
     /*  279825 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(279888), // Rule ID 8653 //
     /*  279830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  279844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279869 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279886 */     GIR_RootConstrainSelectedInstOperands,
     /*  279887 */     // GIR_Coverage, 8653,
     /*  279887 */     GIR_EraseRootFromParent_Done,
     /*  279888 */   // Label 5299: @279888
     /*  279888 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(279951), // Rule ID 8656 //
     /*  279893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  279907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279932 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279949 */     GIR_RootConstrainSelectedInstOperands,
     /*  279950 */     // GIR_Coverage, 8656,
     /*  279950 */     GIR_EraseRootFromParent_Done,
     /*  279951 */   // Label 5300: @279951
     /*  279951 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(280014), // Rule ID 8657 //
     /*  279956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  279970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279995 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280012 */     GIR_RootConstrainSelectedInstOperands,
     /*  280013 */     // GIR_Coverage, 8657,
     /*  280013 */     GIR_EraseRootFromParent_Done,
     /*  280014 */   // Label 5301: @280014
     /*  280014 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(280077), // Rule ID 8660 //
     /*  280019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  280033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280058 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280075 */     GIR_RootConstrainSelectedInstOperands,
     /*  280076 */     // GIR_Coverage, 8660,
     /*  280076 */     GIR_EraseRootFromParent_Done,
     /*  280077 */   // Label 5302: @280077
     /*  280077 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(280140), // Rule ID 8661 //
     /*  280082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  280096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280121 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280138 */     GIR_RootConstrainSelectedInstOperands,
     /*  280139 */     // GIR_Coverage, 8661,
     /*  280139 */     GIR_EraseRootFromParent_Done,
     /*  280140 */   // Label 5303: @280140
     /*  280140 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(280203), // Rule ID 8664 //
     /*  280145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  280159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280184 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280201 */     GIR_RootConstrainSelectedInstOperands,
     /*  280202 */     // GIR_Coverage, 8664,
     /*  280202 */     GIR_EraseRootFromParent_Done,
     /*  280203 */   // Label 5304: @280203
     /*  280203 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(280266), // Rule ID 8665 //
     /*  280208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  280222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280247 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280264 */     GIR_RootConstrainSelectedInstOperands,
     /*  280265 */     // GIR_Coverage, 8665,
     /*  280265 */     GIR_EraseRootFromParent_Done,
     /*  280266 */   // Label 5305: @280266
     /*  280266 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(280329), // Rule ID 8668 //
     /*  280271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  280285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280310 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280327 */     GIR_RootConstrainSelectedInstOperands,
     /*  280328 */     // GIR_Coverage, 8668,
     /*  280328 */     GIR_EraseRootFromParent_Done,
     /*  280329 */   // Label 5306: @280329
     /*  280329 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(280392), // Rule ID 8669 //
     /*  280334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  280348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280373 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280390 */     GIR_RootConstrainSelectedInstOperands,
     /*  280391 */     // GIR_Coverage, 8669,
     /*  280391 */     GIR_EraseRootFromParent_Done,
     /*  280392 */   // Label 5307: @280392
     /*  280392 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(280455), // Rule ID 8672 //
     /*  280397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  280411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280436 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  280436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280453 */     GIR_RootConstrainSelectedInstOperands,
     /*  280454 */     // GIR_Coverage, 8672,
     /*  280454 */     GIR_EraseRootFromParent_Done,
     /*  280455 */   // Label 5308: @280455
     /*  280455 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(280518), // Rule ID 8673 //
     /*  280460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  280463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  280474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280499 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  280499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280516 */     GIR_RootConstrainSelectedInstOperands,
     /*  280517 */     // GIR_Coverage, 8673,
     /*  280517 */     GIR_EraseRootFromParent_Done,
     /*  280518 */   // Label 5309: @280518
     /*  280518 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(280581), // Rule ID 8676 //
     /*  280523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  280537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280562 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  280562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280579 */     GIR_RootConstrainSelectedInstOperands,
     /*  280580 */     // GIR_Coverage, 8676,
     /*  280580 */     GIR_EraseRootFromParent_Done,
     /*  280581 */   // Label 5310: @280581
     /*  280581 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(280644), // Rule ID 8677 //
     /*  280586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  280589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  280600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280625 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  280625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280642 */     GIR_RootConstrainSelectedInstOperands,
     /*  280643 */     // GIR_Coverage, 8677,
     /*  280643 */     GIR_EraseRootFromParent_Done,
     /*  280644 */   // Label 5311: @280644
     /*  280644 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(280707), // Rule ID 8680 //
     /*  280649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  280663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280688 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  280688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280705 */     GIR_RootConstrainSelectedInstOperands,
     /*  280706 */     // GIR_Coverage, 8680,
     /*  280706 */     GIR_EraseRootFromParent_Done,
     /*  280707 */   // Label 5312: @280707
     /*  280707 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(280770), // Rule ID 8681 //
     /*  280712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  280715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  280726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280751 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  280751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280768 */     GIR_RootConstrainSelectedInstOperands,
     /*  280769 */     // GIR_Coverage, 8681,
     /*  280769 */     GIR_EraseRootFromParent_Done,
     /*  280770 */   // Label 5313: @280770
     /*  280770 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(280833), // Rule ID 8684 //
     /*  280775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  280789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  280792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280814 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  280817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280831 */     GIR_RootConstrainSelectedInstOperands,
     /*  280832 */     // GIR_Coverage, 8684,
     /*  280832 */     GIR_EraseRootFromParent_Done,
     /*  280833 */   // Label 5314: @280833
     /*  280833 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(280896), // Rule ID 8685 //
     /*  280838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  280852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  280855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280877 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  280880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280894 */     GIR_RootConstrainSelectedInstOperands,
     /*  280895 */     // GIR_Coverage, 8685,
     /*  280895 */     GIR_EraseRootFromParent_Done,
     /*  280896 */   // Label 5315: @280896
     /*  280896 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(280959), // Rule ID 8688 //
     /*  280901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  280915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  280918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280940 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  280943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280957 */     GIR_RootConstrainSelectedInstOperands,
     /*  280958 */     // GIR_Coverage, 8688,
     /*  280958 */     GIR_EraseRootFromParent_Done,
     /*  280959 */   // Label 5316: @280959
     /*  280959 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(281022), // Rule ID 8689 //
     /*  280964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  280978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  280981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281003 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  281006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281020 */     GIR_RootConstrainSelectedInstOperands,
     /*  281021 */     // GIR_Coverage, 8689,
     /*  281021 */     GIR_EraseRootFromParent_Done,
     /*  281022 */   // Label 5317: @281022
     /*  281022 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(281085), // Rule ID 8692 //
     /*  281027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  281041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  281044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281066 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281083 */     GIR_RootConstrainSelectedInstOperands,
     /*  281084 */     // GIR_Coverage, 8692,
     /*  281084 */     GIR_EraseRootFromParent_Done,
     /*  281085 */   // Label 5318: @281085
     /*  281085 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(281148), // Rule ID 8693 //
     /*  281090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  281104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  281107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281129 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281146 */     GIR_RootConstrainSelectedInstOperands,
     /*  281147 */     // GIR_Coverage, 8693,
     /*  281147 */     GIR_EraseRootFromParent_Done,
     /*  281148 */   // Label 5319: @281148
     /*  281148 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(281211), // Rule ID 8696 //
     /*  281153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  281167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  281170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281192 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  281192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  281195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281209 */     GIR_RootConstrainSelectedInstOperands,
     /*  281210 */     // GIR_Coverage, 8696,
     /*  281210 */     GIR_EraseRootFromParent_Done,
     /*  281211 */   // Label 5320: @281211
     /*  281211 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(281274), // Rule ID 8697 //
     /*  281216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  281230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  281233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281255 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  281258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281272 */     GIR_RootConstrainSelectedInstOperands,
     /*  281273 */     // GIR_Coverage, 8697,
     /*  281273 */     GIR_EraseRootFromParent_Done,
     /*  281274 */   // Label 5321: @281274
     /*  281274 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(281337), // Rule ID 8700 //
     /*  281279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  281293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  281296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281318 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  281318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281335 */     GIR_RootConstrainSelectedInstOperands,
     /*  281336 */     // GIR_Coverage, 8700,
     /*  281336 */     GIR_EraseRootFromParent_Done,
     /*  281337 */   // Label 5322: @281337
     /*  281337 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(281400), // Rule ID 8701 //
     /*  281342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  281356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  281359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281381 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281398 */     GIR_RootConstrainSelectedInstOperands,
     /*  281399 */     // GIR_Coverage, 8701,
     /*  281399 */     GIR_EraseRootFromParent_Done,
     /*  281400 */   // Label 5323: @281400
     /*  281400 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(281463), // Rule ID 8704 //
     /*  281405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  281419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  281422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281444 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  281444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281461 */     GIR_RootConstrainSelectedInstOperands,
     /*  281462 */     // GIR_Coverage, 8704,
     /*  281462 */     GIR_EraseRootFromParent_Done,
     /*  281463 */   // Label 5324: @281463
     /*  281463 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(281526), // Rule ID 8705 //
     /*  281468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  281482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  281485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281507 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  281507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281524 */     GIR_RootConstrainSelectedInstOperands,
     /*  281525 */     // GIR_Coverage, 8705,
     /*  281525 */     GIR_EraseRootFromParent_Done,
     /*  281526 */   // Label 5325: @281526
     /*  281526 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(281589), // Rule ID 8708 //
     /*  281531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  281545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  281548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281570 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281587 */     GIR_RootConstrainSelectedInstOperands,
     /*  281588 */     // GIR_Coverage, 8708,
     /*  281588 */     GIR_EraseRootFromParent_Done,
     /*  281589 */   // Label 5326: @281589
     /*  281589 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(281652), // Rule ID 8709 //
     /*  281594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  281608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  281611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281633 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281650 */     GIR_RootConstrainSelectedInstOperands,
     /*  281651 */     // GIR_Coverage, 8709,
     /*  281651 */     GIR_EraseRootFromParent_Done,
     /*  281652 */   // Label 5327: @281652
     /*  281652 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(281715), // Rule ID 8712 //
     /*  281657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  281671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  281674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281696 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  281696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281713 */     GIR_RootConstrainSelectedInstOperands,
     /*  281714 */     // GIR_Coverage, 8712,
     /*  281714 */     GIR_EraseRootFromParent_Done,
     /*  281715 */   // Label 5328: @281715
     /*  281715 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(281778), // Rule ID 8713 //
     /*  281720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  281734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  281737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281759 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281776 */     GIR_RootConstrainSelectedInstOperands,
     /*  281777 */     // GIR_Coverage, 8713,
     /*  281777 */     GIR_EraseRootFromParent_Done,
     /*  281778 */   // Label 5329: @281778
     /*  281778 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(281841), // Rule ID 8716 //
     /*  281783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  281797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  281800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281822 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  281822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281839 */     GIR_RootConstrainSelectedInstOperands,
     /*  281840 */     // GIR_Coverage, 8716,
     /*  281840 */     GIR_EraseRootFromParent_Done,
     /*  281841 */   // Label 5330: @281841
     /*  281841 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(281904), // Rule ID 8717 //
     /*  281846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  281860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  281863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281885 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  281885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281902 */     GIR_RootConstrainSelectedInstOperands,
     /*  281903 */     // GIR_Coverage, 8717,
     /*  281903 */     GIR_EraseRootFromParent_Done,
     /*  281904 */   // Label 5331: @281904
     /*  281904 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(281967), // Rule ID 8720 //
     /*  281909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  281912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  281923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  281926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281948 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  281948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281965 */     GIR_RootConstrainSelectedInstOperands,
     /*  281966 */     // GIR_Coverage, 8720,
     /*  281966 */     GIR_EraseRootFromParent_Done,
     /*  281967 */   // Label 5332: @281967
     /*  281967 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(282030), // Rule ID 8721 //
     /*  281972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  281975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  281986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  281989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282011 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  282011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  282028 */     GIR_RootConstrainSelectedInstOperands,
     /*  282029 */     // GIR_Coverage, 8721,
     /*  282029 */     GIR_EraseRootFromParent_Done,
     /*  282030 */   // Label 5333: @282030
     /*  282030 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(282093), // Rule ID 8724 //
     /*  282035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  282049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  282052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282074 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282091 */     GIR_RootConstrainSelectedInstOperands,
     /*  282092 */     // GIR_Coverage, 8724,
     /*  282092 */     GIR_EraseRootFromParent_Done,
     /*  282093 */   // Label 5334: @282093
     /*  282093 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(282156), // Rule ID 8725 //
     /*  282098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  282112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  282115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282137 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282154 */     GIR_RootConstrainSelectedInstOperands,
     /*  282155 */     // GIR_Coverage, 8725,
     /*  282155 */     GIR_EraseRootFromParent_Done,
     /*  282156 */   // Label 5335: @282156
     /*  282156 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(282219), // Rule ID 8728 //
     /*  282161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  282175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  282178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282200 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282217 */     GIR_RootConstrainSelectedInstOperands,
     /*  282218 */     // GIR_Coverage, 8728,
     /*  282218 */     GIR_EraseRootFromParent_Done,
     /*  282219 */   // Label 5336: @282219
     /*  282219 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(282282), // Rule ID 8729 //
     /*  282224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  282238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  282241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282263 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282280 */     GIR_RootConstrainSelectedInstOperands,
     /*  282281 */     // GIR_Coverage, 8729,
     /*  282281 */     GIR_EraseRootFromParent_Done,
     /*  282282 */   // Label 5337: @282282
     /*  282282 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(282345), // Rule ID 8732 //
     /*  282287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  282298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  282301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  282304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282326 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282343 */     GIR_RootConstrainSelectedInstOperands,
     /*  282344 */     // GIR_Coverage, 8732,
     /*  282344 */     GIR_EraseRootFromParent_Done,
     /*  282345 */   // Label 5338: @282345
     /*  282345 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(282408), // Rule ID 8733 //
     /*  282350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  282361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  282364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  282367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282389 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282406 */     GIR_RootConstrainSelectedInstOperands,
     /*  282407 */     // GIR_Coverage, 8733,
     /*  282407 */     GIR_EraseRootFromParent_Done,
     /*  282408 */   // Label 5339: @282408
     /*  282408 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(282471), // Rule ID 8736 //
     /*  282413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  282427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  282430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282469 */     GIR_RootConstrainSelectedInstOperands,
     /*  282470 */     // GIR_Coverage, 8736,
     /*  282470 */     GIR_EraseRootFromParent_Done,
     /*  282471 */   // Label 5340: @282471
     /*  282471 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(282534), // Rule ID 8737 //
     /*  282476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  282490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  282493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282515 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282532 */     GIR_RootConstrainSelectedInstOperands,
     /*  282533 */     // GIR_Coverage, 8737,
     /*  282533 */     GIR_EraseRootFromParent_Done,
     /*  282534 */   // Label 5341: @282534
     /*  282534 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(282597), // Rule ID 8740 //
     /*  282539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  282553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  282556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282578 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282595 */     GIR_RootConstrainSelectedInstOperands,
     /*  282596 */     // GIR_Coverage, 8740,
     /*  282596 */     GIR_EraseRootFromParent_Done,
     /*  282597 */   // Label 5342: @282597
     /*  282597 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(282660), // Rule ID 8741 //
     /*  282602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  282616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  282619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282641 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282658 */     GIR_RootConstrainSelectedInstOperands,
     /*  282659 */     // GIR_Coverage, 8741,
     /*  282659 */     GIR_EraseRootFromParent_Done,
     /*  282660 */   // Label 5343: @282660
     /*  282660 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(282723), // Rule ID 8744 //
     /*  282665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  282679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  282682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282704 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282721 */     GIR_RootConstrainSelectedInstOperands,
     /*  282722 */     // GIR_Coverage, 8744,
     /*  282722 */     GIR_EraseRootFromParent_Done,
     /*  282723 */   // Label 5344: @282723
     /*  282723 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(282786), // Rule ID 8745 //
     /*  282728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  282742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  282745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282767 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282784 */     GIR_RootConstrainSelectedInstOperands,
     /*  282785 */     // GIR_Coverage, 8745,
     /*  282785 */     GIR_EraseRootFromParent_Done,
     /*  282786 */   // Label 5345: @282786
     /*  282786 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(282849), // Rule ID 8748 //
     /*  282791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  282805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  282808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282830 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  282830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282847 */     GIR_RootConstrainSelectedInstOperands,
     /*  282848 */     // GIR_Coverage, 8748,
     /*  282848 */     GIR_EraseRootFromParent_Done,
     /*  282849 */   // Label 5346: @282849
     /*  282849 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(282912), // Rule ID 8749 //
     /*  282854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  282868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  282871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282893 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  282893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282910 */     GIR_RootConstrainSelectedInstOperands,
     /*  282911 */     // GIR_Coverage, 8749,
     /*  282911 */     GIR_EraseRootFromParent_Done,
     /*  282912 */   // Label 5347: @282912
     /*  282912 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(282975), // Rule ID 8752 //
     /*  282917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  282931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  282934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282956 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  282956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282973 */     GIR_RootConstrainSelectedInstOperands,
     /*  282974 */     // GIR_Coverage, 8752,
     /*  282974 */     GIR_EraseRootFromParent_Done,
     /*  282975 */   // Label 5348: @282975
     /*  282975 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(283038), // Rule ID 8753 //
     /*  282980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  282994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  282997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283019 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  283019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283036 */     GIR_RootConstrainSelectedInstOperands,
     /*  283037 */     // GIR_Coverage, 8753,
     /*  283037 */     GIR_EraseRootFromParent_Done,
     /*  283038 */   // Label 5349: @283038
     /*  283038 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(283101), // Rule ID 8756 //
     /*  283043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  283057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  283060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283082 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  283082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283099 */     GIR_RootConstrainSelectedInstOperands,
     /*  283100 */     // GIR_Coverage, 8756,
     /*  283100 */     GIR_EraseRootFromParent_Done,
     /*  283101 */   // Label 5350: @283101
     /*  283101 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(283164), // Rule ID 8757 //
     /*  283106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  283120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  283123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283145 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  283145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283162 */     GIR_RootConstrainSelectedInstOperands,
     /*  283163 */     // GIR_Coverage, 8757,
     /*  283163 */     GIR_EraseRootFromParent_Done,
     /*  283164 */   // Label 5351: @283164
     /*  283164 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(283227), // Rule ID 8760 //
     /*  283169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  283172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  283183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  283186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283208 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  283211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283225 */     GIR_RootConstrainSelectedInstOperands,
     /*  283226 */     // GIR_Coverage, 8760,
     /*  283226 */     GIR_EraseRootFromParent_Done,
     /*  283227 */   // Label 5352: @283227
     /*  283227 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(283290), // Rule ID 8761 //
     /*  283232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  283246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  283249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283271 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  283274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283288 */     GIR_RootConstrainSelectedInstOperands,
     /*  283289 */     // GIR_Coverage, 8761,
     /*  283289 */     GIR_EraseRootFromParent_Done,
     /*  283290 */   // Label 5353: @283290
     /*  283290 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(283353), // Rule ID 8764 //
     /*  283295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  283298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  283309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  283312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283334 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283351 */     GIR_RootConstrainSelectedInstOperands,
     /*  283352 */     // GIR_Coverage, 8764,
     /*  283352 */     GIR_EraseRootFromParent_Done,
     /*  283353 */   // Label 5354: @283353
     /*  283353 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(283416), // Rule ID 8765 //
     /*  283358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  283372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  283375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283397 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283414 */     GIR_RootConstrainSelectedInstOperands,
     /*  283415 */     // GIR_Coverage, 8765,
     /*  283415 */     GIR_EraseRootFromParent_Done,
     /*  283416 */   // Label 5355: @283416
     /*  283416 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(283479), // Rule ID 8768 //
     /*  283421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  283424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  283435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  283438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283460 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283477 */     GIR_RootConstrainSelectedInstOperands,
     /*  283478 */     // GIR_Coverage, 8768,
     /*  283478 */     GIR_EraseRootFromParent_Done,
     /*  283479 */   // Label 5356: @283479
     /*  283479 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(283542), // Rule ID 8769 //
     /*  283484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  283498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  283501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283523 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283540 */     GIR_RootConstrainSelectedInstOperands,
     /*  283541 */     // GIR_Coverage, 8769,
     /*  283541 */     GIR_EraseRootFromParent_Done,
     /*  283542 */   // Label 5357: @283542
     /*  283542 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(283605), // Rule ID 8772 //
     /*  283547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  283561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283586 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  283589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283603 */     GIR_RootConstrainSelectedInstOperands,
     /*  283604 */     // GIR_Coverage, 8772,
     /*  283604 */     GIR_EraseRootFromParent_Done,
     /*  283605 */   // Label 5358: @283605
     /*  283605 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(283668), // Rule ID 8773 //
     /*  283610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  283624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283649 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  283652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283666 */     GIR_RootConstrainSelectedInstOperands,
     /*  283667 */     // GIR_Coverage, 8773,
     /*  283667 */     GIR_EraseRootFromParent_Done,
     /*  283668 */   // Label 5359: @283668
     /*  283668 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(283731), // Rule ID 8776 //
     /*  283673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  283687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283712 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  283715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283729 */     GIR_RootConstrainSelectedInstOperands,
     /*  283730 */     // GIR_Coverage, 8776,
     /*  283730 */     GIR_EraseRootFromParent_Done,
     /*  283731 */   // Label 5360: @283731
     /*  283731 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(283794), // Rule ID 8777 //
     /*  283736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  283750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283775 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  283778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283792 */     GIR_RootConstrainSelectedInstOperands,
     /*  283793 */     // GIR_Coverage, 8777,
     /*  283793 */     GIR_EraseRootFromParent_Done,
     /*  283794 */   // Label 5361: @283794
     /*  283794 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(283857), // Rule ID 8780 //
     /*  283799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  283813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283838 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  283841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283855 */     GIR_RootConstrainSelectedInstOperands,
     /*  283856 */     // GIR_Coverage, 8780,
     /*  283856 */     GIR_EraseRootFromParent_Done,
     /*  283857 */   // Label 5362: @283857
     /*  283857 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(283920), // Rule ID 8781 //
     /*  283862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  283876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283901 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  283904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283918 */     GIR_RootConstrainSelectedInstOperands,
     /*  283919 */     // GIR_Coverage, 8781,
     /*  283919 */     GIR_EraseRootFromParent_Done,
     /*  283920 */   // Label 5363: @283920
     /*  283920 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(283983), // Rule ID 8784 //
     /*  283925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  283939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283964 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  283967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283981 */     GIR_RootConstrainSelectedInstOperands,
     /*  283982 */     // GIR_Coverage, 8784,
     /*  283982 */     GIR_EraseRootFromParent_Done,
     /*  283983 */   // Label 5364: @283983
     /*  283983 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(284046), // Rule ID 8785 //
     /*  283988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  284002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284027 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  284030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284044 */     GIR_RootConstrainSelectedInstOperands,
     /*  284045 */     // GIR_Coverage, 8785,
     /*  284045 */     GIR_EraseRootFromParent_Done,
     /*  284046 */   // Label 5365: @284046
     /*  284046 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(284109), // Rule ID 8788 //
     /*  284051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  284065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284090 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  284090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284107 */     GIR_RootConstrainSelectedInstOperands,
     /*  284108 */     // GIR_Coverage, 8788,
     /*  284108 */     GIR_EraseRootFromParent_Done,
     /*  284109 */   // Label 5366: @284109
     /*  284109 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(284172), // Rule ID 8789 //
     /*  284114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  284128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284153 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284170 */     GIR_RootConstrainSelectedInstOperands,
     /*  284171 */     // GIR_Coverage, 8789,
     /*  284171 */     GIR_EraseRootFromParent_Done,
     /*  284172 */   // Label 5367: @284172
     /*  284172 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(284235), // Rule ID 8792 //
     /*  284177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  284191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284216 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  284216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284233 */     GIR_RootConstrainSelectedInstOperands,
     /*  284234 */     // GIR_Coverage, 8792,
     /*  284234 */     GIR_EraseRootFromParent_Done,
     /*  284235 */   // Label 5368: @284235
     /*  284235 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(284298), // Rule ID 8793 //
     /*  284240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  284254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284279 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  284279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284296 */     GIR_RootConstrainSelectedInstOperands,
     /*  284297 */     // GIR_Coverage, 8793,
     /*  284297 */     GIR_EraseRootFromParent_Done,
     /*  284298 */   // Label 5369: @284298
     /*  284298 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(284361), // Rule ID 8796 //
     /*  284303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  284317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284342 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284359 */     GIR_RootConstrainSelectedInstOperands,
     /*  284360 */     // GIR_Coverage, 8796,
     /*  284360 */     GIR_EraseRootFromParent_Done,
     /*  284361 */   // Label 5370: @284361
     /*  284361 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(284424), // Rule ID 8797 //
     /*  284366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  284380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284405 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284422 */     GIR_RootConstrainSelectedInstOperands,
     /*  284423 */     // GIR_Coverage, 8797,
     /*  284423 */     GIR_EraseRootFromParent_Done,
     /*  284424 */   // Label 5371: @284424
     /*  284424 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(284487), // Rule ID 8800 //
     /*  284429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  284443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284468 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  284468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284485 */     GIR_RootConstrainSelectedInstOperands,
     /*  284486 */     // GIR_Coverage, 8800,
     /*  284486 */     GIR_EraseRootFromParent_Done,
     /*  284487 */   // Label 5372: @284487
     /*  284487 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(284550), // Rule ID 8801 //
     /*  284492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  284506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284531 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284548 */     GIR_RootConstrainSelectedInstOperands,
     /*  284549 */     // GIR_Coverage, 8801,
     /*  284549 */     GIR_EraseRootFromParent_Done,
     /*  284550 */   // Label 5373: @284550
     /*  284550 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(284613), // Rule ID 8804 //
     /*  284555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  284569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284594 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  284594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284611 */     GIR_RootConstrainSelectedInstOperands,
     /*  284612 */     // GIR_Coverage, 8804,
     /*  284612 */     GIR_EraseRootFromParent_Done,
     /*  284613 */   // Label 5374: @284613
     /*  284613 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(284676), // Rule ID 8805 //
     /*  284618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  284632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284657 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  284657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284674 */     GIR_RootConstrainSelectedInstOperands,
     /*  284675 */     // GIR_Coverage, 8805,
     /*  284675 */     GIR_EraseRootFromParent_Done,
     /*  284676 */   // Label 5375: @284676
     /*  284676 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(284739), // Rule ID 8808 //
     /*  284681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  284684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  284695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284720 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  284720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284737 */     GIR_RootConstrainSelectedInstOperands,
     /*  284738 */     // GIR_Coverage, 8808,
     /*  284738 */     GIR_EraseRootFromParent_Done,
     /*  284739 */   // Label 5376: @284739
     /*  284739 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(284802), // Rule ID 8809 //
     /*  284744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  284747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  284758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284783 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  284783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284800 */     GIR_RootConstrainSelectedInstOperands,
     /*  284801 */     // GIR_Coverage, 8809,
     /*  284801 */     GIR_EraseRootFromParent_Done,
     /*  284802 */   // Label 5377: @284802
     /*  284802 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(284865), // Rule ID 8812 //
     /*  284807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  284818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  284821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284846 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  284849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284863 */     GIR_RootConstrainSelectedInstOperands,
     /*  284864 */     // GIR_Coverage, 8812,
     /*  284864 */     GIR_EraseRootFromParent_Done,
     /*  284865 */   // Label 5378: @284865
     /*  284865 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(284928), // Rule ID 8813 //
     /*  284870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  284881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  284884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284909 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  284912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284926 */     GIR_RootConstrainSelectedInstOperands,
     /*  284927 */     // GIR_Coverage, 8813,
     /*  284927 */     GIR_EraseRootFromParent_Done,
     /*  284928 */   // Label 5379: @284928
     /*  284928 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(284991), // Rule ID 8816 //
     /*  284933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  284944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  284947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284972 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  284975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284989 */     GIR_RootConstrainSelectedInstOperands,
     /*  284990 */     // GIR_Coverage, 8816,
     /*  284990 */     GIR_EraseRootFromParent_Done,
     /*  284991 */   // Label 5380: @284991
     /*  284991 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(285054), // Rule ID 8817 //
     /*  284996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  285007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  285010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285035 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285052 */     GIR_RootConstrainSelectedInstOperands,
     /*  285053 */     // GIR_Coverage, 8817,
     /*  285053 */     GIR_EraseRootFromParent_Done,
     /*  285054 */   // Label 5381: @285054
     /*  285054 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(285117), // Rule ID 8820 //
     /*  285059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  285070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  285073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285098 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285115 */     GIR_RootConstrainSelectedInstOperands,
     /*  285116 */     // GIR_Coverage, 8820,
     /*  285116 */     GIR_EraseRootFromParent_Done,
     /*  285117 */   // Label 5382: @285117
     /*  285117 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(285180), // Rule ID 8821 //
     /*  285122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  285133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  285136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285161 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285178 */     GIR_RootConstrainSelectedInstOperands,
     /*  285179 */     // GIR_Coverage, 8821,
     /*  285179 */     GIR_EraseRootFromParent_Done,
     /*  285180 */   // Label 5383: @285180
     /*  285180 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(285243), // Rule ID 8824 //
     /*  285185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  285199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285224 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285241 */     GIR_RootConstrainSelectedInstOperands,
     /*  285242 */     // GIR_Coverage, 8824,
     /*  285242 */     GIR_EraseRootFromParent_Done,
     /*  285243 */   // Label 5384: @285243
     /*  285243 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(285306), // Rule ID 8825 //
     /*  285248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  285262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285287 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285304 */     GIR_RootConstrainSelectedInstOperands,
     /*  285305 */     // GIR_Coverage, 8825,
     /*  285305 */     GIR_EraseRootFromParent_Done,
     /*  285306 */   // Label 5385: @285306
     /*  285306 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(285369), // Rule ID 8828 //
     /*  285311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  285325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285350 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285367 */     GIR_RootConstrainSelectedInstOperands,
     /*  285368 */     // GIR_Coverage, 8828,
     /*  285368 */     GIR_EraseRootFromParent_Done,
     /*  285369 */   // Label 5386: @285369
     /*  285369 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(285432), // Rule ID 8829 //
     /*  285374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  285388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285413 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285430 */     GIR_RootConstrainSelectedInstOperands,
     /*  285431 */     // GIR_Coverage, 8829,
     /*  285431 */     GIR_EraseRootFromParent_Done,
     /*  285432 */   // Label 5387: @285432
     /*  285432 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(285495), // Rule ID 8832 //
     /*  285437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  285448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  285451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285476 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285493 */     GIR_RootConstrainSelectedInstOperands,
     /*  285494 */     // GIR_Coverage, 8832,
     /*  285494 */     GIR_EraseRootFromParent_Done,
     /*  285495 */   // Label 5388: @285495
     /*  285495 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(285558), // Rule ID 8833 //
     /*  285500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  285511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  285514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285539 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285556 */     GIR_RootConstrainSelectedInstOperands,
     /*  285557 */     // GIR_Coverage, 8833,
     /*  285557 */     GIR_EraseRootFromParent_Done,
     /*  285558 */   // Label 5389: @285558
     /*  285558 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(285621), // Rule ID 8836 //
     /*  285563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  285574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  285577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285602 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285619 */     GIR_RootConstrainSelectedInstOperands,
     /*  285620 */     // GIR_Coverage, 8836,
     /*  285620 */     GIR_EraseRootFromParent_Done,
     /*  285621 */   // Label 5390: @285621
     /*  285621 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(285684), // Rule ID 8837 //
     /*  285626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  285637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  285640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285665 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285682 */     GIR_RootConstrainSelectedInstOperands,
     /*  285683 */     // GIR_Coverage, 8837,
     /*  285683 */     GIR_EraseRootFromParent_Done,
     /*  285684 */   // Label 5391: @285684
     /*  285684 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(285747), // Rule ID 8840 //
     /*  285689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  285703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285745 */     GIR_RootConstrainSelectedInstOperands,
     /*  285746 */     // GIR_Coverage, 8840,
     /*  285746 */     GIR_EraseRootFromParent_Done,
     /*  285747 */   // Label 5392: @285747
     /*  285747 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(285810), // Rule ID 8841 //
     /*  285752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  285766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285791 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285808 */     GIR_RootConstrainSelectedInstOperands,
     /*  285809 */     // GIR_Coverage, 8841,
     /*  285809 */     GIR_EraseRootFromParent_Done,
     /*  285810 */   // Label 5393: @285810
     /*  285810 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(285873), // Rule ID 8844 //
     /*  285815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  285829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285854 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285871 */     GIR_RootConstrainSelectedInstOperands,
     /*  285872 */     // GIR_Coverage, 8844,
     /*  285872 */     GIR_EraseRootFromParent_Done,
     /*  285873 */   // Label 5394: @285873
     /*  285873 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(285936), // Rule ID 8845 //
     /*  285878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  285892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285917 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285934 */     GIR_RootConstrainSelectedInstOperands,
     /*  285935 */     // GIR_Coverage, 8845,
     /*  285935 */     GIR_EraseRootFromParent_Done,
     /*  285936 */   // Label 5395: @285936
     /*  285936 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(285999), // Rule ID 8848 //
     /*  285941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  285944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  285955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285980 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  285980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285997 */     GIR_RootConstrainSelectedInstOperands,
     /*  285998 */     // GIR_Coverage, 8848,
     /*  285998 */     GIR_EraseRootFromParent_Done,
     /*  285999 */   // Label 5396: @285999
     /*  285999 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(286062), // Rule ID 8849 //
     /*  286004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  286007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  286018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286043 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  286043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  286046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286060 */     GIR_RootConstrainSelectedInstOperands,
     /*  286061 */     // GIR_Coverage, 8849,
     /*  286061 */     GIR_EraseRootFromParent_Done,
     /*  286062 */   // Label 5397: @286062
     /*  286062 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(286125), // Rule ID 8852 //
     /*  286067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  286070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  286081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286106 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  286106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  286109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286123 */     GIR_RootConstrainSelectedInstOperands,
     /*  286124 */     // GIR_Coverage, 8852,
     /*  286124 */     GIR_EraseRootFromParent_Done,
     /*  286125 */   // Label 5398: @286125
     /*  286125 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(286188), // Rule ID 8853 //
     /*  286130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  286133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  286144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286169 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  286169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  286172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286186 */     GIR_RootConstrainSelectedInstOperands,
     /*  286187 */     // GIR_Coverage, 8853,
     /*  286187 */     GIR_EraseRootFromParent_Done,
     /*  286188 */   // Label 5399: @286188
     /*  286188 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(286251), // Rule ID 8856 //
     /*  286193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  286196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  286207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286232 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  286232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  286235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286249 */     GIR_RootConstrainSelectedInstOperands,
     /*  286250 */     // GIR_Coverage, 8856,
     /*  286250 */     GIR_EraseRootFromParent_Done,
     /*  286251 */   // Label 5400: @286251
     /*  286251 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(286314), // Rule ID 8857 //
     /*  286256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  286259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  286270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286295 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  286295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  286298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286312 */     GIR_RootConstrainSelectedInstOperands,
     /*  286313 */     // GIR_Coverage, 8857,
     /*  286313 */     GIR_EraseRootFromParent_Done,
     /*  286314 */   // Label 5401: @286314
     /*  286314 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(286377), // Rule ID 8948 //
     /*  286319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  286333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  286336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286358 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  286361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286375 */     GIR_RootConstrainSelectedInstOperands,
     /*  286376 */     // GIR_Coverage, 8948,
     /*  286376 */     GIR_EraseRootFromParent_Done,
     /*  286377 */   // Label 5402: @286377
     /*  286377 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(286440), // Rule ID 8949 //
     /*  286382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  286396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  286399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286421 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  286424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286438 */     GIR_RootConstrainSelectedInstOperands,
     /*  286439 */     // GIR_Coverage, 8949,
     /*  286439 */     GIR_EraseRootFromParent_Done,
     /*  286440 */   // Label 5403: @286440
     /*  286440 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(286503), // Rule ID 8952 //
     /*  286445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  286459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  286462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286484 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  286487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286501 */     GIR_RootConstrainSelectedInstOperands,
     /*  286502 */     // GIR_Coverage, 8952,
     /*  286502 */     GIR_EraseRootFromParent_Done,
     /*  286503 */   // Label 5404: @286503
     /*  286503 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(286566), // Rule ID 8953 //
     /*  286508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  286522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  286525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286547 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  286550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286564 */     GIR_RootConstrainSelectedInstOperands,
     /*  286565 */     // GIR_Coverage, 8953,
     /*  286565 */     GIR_EraseRootFromParent_Done,
     /*  286566 */   // Label 5405: @286566
     /*  286566 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(286629), // Rule ID 8956 //
     /*  286571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  286585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  286588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286627 */     GIR_RootConstrainSelectedInstOperands,
     /*  286628 */     // GIR_Coverage, 8956,
     /*  286628 */     GIR_EraseRootFromParent_Done,
     /*  286629 */   // Label 5406: @286629
     /*  286629 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(286692), // Rule ID 8957 //
     /*  286634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  286648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  286651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286673 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286690 */     GIR_RootConstrainSelectedInstOperands,
     /*  286691 */     // GIR_Coverage, 8957,
     /*  286691 */     GIR_EraseRootFromParent_Done,
     /*  286692 */   // Label 5407: @286692
     /*  286692 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(286755), // Rule ID 8960 //
     /*  286697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  286711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  286714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286736 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  286736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  286739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286753 */     GIR_RootConstrainSelectedInstOperands,
     /*  286754 */     // GIR_Coverage, 8960,
     /*  286754 */     GIR_EraseRootFromParent_Done,
     /*  286755 */   // Label 5408: @286755
     /*  286755 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(286818), // Rule ID 8961 //
     /*  286760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  286774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  286777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286799 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  286802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286816 */     GIR_RootConstrainSelectedInstOperands,
     /*  286817 */     // GIR_Coverage, 8961,
     /*  286817 */     GIR_EraseRootFromParent_Done,
     /*  286818 */   // Label 5409: @286818
     /*  286818 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(286881), // Rule ID 8964 //
     /*  286823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  286837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  286840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286862 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  286862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286879 */     GIR_RootConstrainSelectedInstOperands,
     /*  286880 */     // GIR_Coverage, 8964,
     /*  286880 */     GIR_EraseRootFromParent_Done,
     /*  286881 */   // Label 5410: @286881
     /*  286881 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(286944), // Rule ID 8965 //
     /*  286886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  286900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  286903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286925 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286942 */     GIR_RootConstrainSelectedInstOperands,
     /*  286943 */     // GIR_Coverage, 8965,
     /*  286943 */     GIR_EraseRootFromParent_Done,
     /*  286944 */   // Label 5411: @286944
     /*  286944 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(287007), // Rule ID 8968 //
     /*  286949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  286963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  286966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286988 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287005 */     GIR_RootConstrainSelectedInstOperands,
     /*  287006 */     // GIR_Coverage, 8968,
     /*  287006 */     GIR_EraseRootFromParent_Done,
     /*  287007 */   // Label 5412: @287007
     /*  287007 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(287070), // Rule ID 8969 //
     /*  287012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  287026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  287029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287051 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  287051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287068 */     GIR_RootConstrainSelectedInstOperands,
     /*  287069 */     // GIR_Coverage, 8969,
     /*  287069 */     GIR_EraseRootFromParent_Done,
     /*  287070 */   // Label 5413: @287070
     /*  287070 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(287133), // Rule ID 8972 //
     /*  287075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  287089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  287092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287114 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287131 */     GIR_RootConstrainSelectedInstOperands,
     /*  287132 */     // GIR_Coverage, 8972,
     /*  287132 */     GIR_EraseRootFromParent_Done,
     /*  287133 */   // Label 5414: @287133
     /*  287133 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(287196), // Rule ID 8973 //
     /*  287138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  287152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  287155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287177 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287194 */     GIR_RootConstrainSelectedInstOperands,
     /*  287195 */     // GIR_Coverage, 8973,
     /*  287195 */     GIR_EraseRootFromParent_Done,
     /*  287196 */   // Label 5415: @287196
     /*  287196 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(287259), // Rule ID 8976 //
     /*  287201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  287215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  287218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287240 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287257 */     GIR_RootConstrainSelectedInstOperands,
     /*  287258 */     // GIR_Coverage, 8976,
     /*  287258 */     GIR_EraseRootFromParent_Done,
     /*  287259 */   // Label 5416: @287259
     /*  287259 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(287322), // Rule ID 8977 //
     /*  287264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  287278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  287281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287303 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287320 */     GIR_RootConstrainSelectedInstOperands,
     /*  287321 */     // GIR_Coverage, 8977,
     /*  287321 */     GIR_EraseRootFromParent_Done,
     /*  287322 */   // Label 5417: @287322
     /*  287322 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(287385), // Rule ID 8980 //
     /*  287327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  287341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  287344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287366 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  287366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287383 */     GIR_RootConstrainSelectedInstOperands,
     /*  287384 */     // GIR_Coverage, 8980,
     /*  287384 */     GIR_EraseRootFromParent_Done,
     /*  287385 */   // Label 5418: @287385
     /*  287385 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(287448), // Rule ID 8981 //
     /*  287390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  287404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  287407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287429 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  287429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287446 */     GIR_RootConstrainSelectedInstOperands,
     /*  287447 */     // GIR_Coverage, 8981,
     /*  287447 */     GIR_EraseRootFromParent_Done,
     /*  287448 */   // Label 5419: @287448
     /*  287448 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(287511), // Rule ID 8984 //
     /*  287453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  287456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  287467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  287470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287492 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  287492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287509 */     GIR_RootConstrainSelectedInstOperands,
     /*  287510 */     // GIR_Coverage, 8984,
     /*  287510 */     GIR_EraseRootFromParent_Done,
     /*  287511 */   // Label 5420: @287511
     /*  287511 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(287574), // Rule ID 8985 //
     /*  287516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  287519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  287530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  287533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287555 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  287555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287572 */     GIR_RootConstrainSelectedInstOperands,
     /*  287573 */     // GIR_Coverage, 8985,
     /*  287573 */     GIR_EraseRootFromParent_Done,
     /*  287574 */   // Label 5421: @287574
     /*  287574 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(287637), // Rule ID 8988 //
     /*  287579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  287590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  287593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  287596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287618 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  287621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287635 */     GIR_RootConstrainSelectedInstOperands,
     /*  287636 */     // GIR_Coverage, 8988,
     /*  287636 */     GIR_EraseRootFromParent_Done,
     /*  287637 */   // Label 5422: @287637
     /*  287637 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(287700), // Rule ID 8989 //
     /*  287642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  287653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  287656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  287659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287681 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  287684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287698 */     GIR_RootConstrainSelectedInstOperands,
     /*  287699 */     // GIR_Coverage, 8989,
     /*  287699 */     GIR_EraseRootFromParent_Done,
     /*  287700 */   // Label 5423: @287700
     /*  287700 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(287763), // Rule ID 8992 //
     /*  287705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  287716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  287719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  287722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287744 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  287747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287761 */     GIR_RootConstrainSelectedInstOperands,
     /*  287762 */     // GIR_Coverage, 8992,
     /*  287762 */     GIR_EraseRootFromParent_Done,
     /*  287763 */   // Label 5424: @287763
     /*  287763 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(287826), // Rule ID 8993 //
     /*  287768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  287779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  287782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  287785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287807 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  287810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287824 */     GIR_RootConstrainSelectedInstOperands,
     /*  287825 */     // GIR_Coverage, 8993,
     /*  287825 */     GIR_EraseRootFromParent_Done,
     /*  287826 */   // Label 5425: @287826
     /*  287826 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(287889), // Rule ID 8996 //
     /*  287831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  287842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  287845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  287848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287870 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  287873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287887 */     GIR_RootConstrainSelectedInstOperands,
     /*  287888 */     // GIR_Coverage, 8996,
     /*  287888 */     GIR_EraseRootFromParent_Done,
     /*  287889 */   // Label 5426: @287889
     /*  287889 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(287952), // Rule ID 8997 //
     /*  287894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  287905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  287908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  287911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287933 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  287936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287950 */     GIR_RootConstrainSelectedInstOperands,
     /*  287951 */     // GIR_Coverage, 8997,
     /*  287951 */     GIR_EraseRootFromParent_Done,
     /*  287952 */   // Label 5427: @287952
     /*  287952 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(288015), // Rule ID 9000 //
     /*  287957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  287971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  287974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287996 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  287999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288013 */     GIR_RootConstrainSelectedInstOperands,
     /*  288014 */     // GIR_Coverage, 9000,
     /*  288014 */     GIR_EraseRootFromParent_Done,
     /*  288015 */   // Label 5428: @288015
     /*  288015 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(288078), // Rule ID 9001 //
     /*  288020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  288034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  288037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288059 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288076 */     GIR_RootConstrainSelectedInstOperands,
     /*  288077 */     // GIR_Coverage, 9001,
     /*  288077 */     GIR_EraseRootFromParent_Done,
     /*  288078 */   // Label 5429: @288078
     /*  288078 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(288141), // Rule ID 9004 //
     /*  288083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  288097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  288100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288122 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  288122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288139 */     GIR_RootConstrainSelectedInstOperands,
     /*  288140 */     // GIR_Coverage, 9004,
     /*  288140 */     GIR_EraseRootFromParent_Done,
     /*  288141 */   // Label 5430: @288141
     /*  288141 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(288204), // Rule ID 9005 //
     /*  288146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  288160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  288163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288185 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288202 */     GIR_RootConstrainSelectedInstOperands,
     /*  288203 */     // GIR_Coverage, 9005,
     /*  288203 */     GIR_EraseRootFromParent_Done,
     /*  288204 */   // Label 5431: @288204
     /*  288204 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(288267), // Rule ID 9008 //
     /*  288209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  288223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  288226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288248 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  288248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288265 */     GIR_RootConstrainSelectedInstOperands,
     /*  288266 */     // GIR_Coverage, 9008,
     /*  288266 */     GIR_EraseRootFromParent_Done,
     /*  288267 */   // Label 5432: @288267
     /*  288267 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(288330), // Rule ID 9009 //
     /*  288272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  288286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  288289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288311 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288328 */     GIR_RootConstrainSelectedInstOperands,
     /*  288329 */     // GIR_Coverage, 9009,
     /*  288329 */     GIR_EraseRootFromParent_Done,
     /*  288330 */   // Label 5433: @288330
     /*  288330 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(288393), // Rule ID 9012 //
     /*  288335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  288349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  288352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288374 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288391 */     GIR_RootConstrainSelectedInstOperands,
     /*  288392 */     // GIR_Coverage, 9012,
     /*  288392 */     GIR_EraseRootFromParent_Done,
     /*  288393 */   // Label 5434: @288393
     /*  288393 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(288456), // Rule ID 9013 //
     /*  288398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  288412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  288415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288437 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288454 */     GIR_RootConstrainSelectedInstOperands,
     /*  288455 */     // GIR_Coverage, 9013,
     /*  288455 */     GIR_EraseRootFromParent_Done,
     /*  288456 */   // Label 5435: @288456
     /*  288456 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(288519), // Rule ID 9016 //
     /*  288461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  288475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  288478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288500 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288517 */     GIR_RootConstrainSelectedInstOperands,
     /*  288518 */     // GIR_Coverage, 9016,
     /*  288518 */     GIR_EraseRootFromParent_Done,
     /*  288519 */   // Label 5436: @288519
     /*  288519 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(288582), // Rule ID 9017 //
     /*  288524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  288538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  288541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288563 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288580 */     GIR_RootConstrainSelectedInstOperands,
     /*  288581 */     // GIR_Coverage, 9017,
     /*  288581 */     GIR_EraseRootFromParent_Done,
     /*  288582 */   // Label 5437: @288582
     /*  288582 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(288645), // Rule ID 9020 //
     /*  288587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  288601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  288604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288626 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288643 */     GIR_RootConstrainSelectedInstOperands,
     /*  288644 */     // GIR_Coverage, 9020,
     /*  288644 */     GIR_EraseRootFromParent_Done,
     /*  288645 */   // Label 5438: @288645
     /*  288645 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(288708), // Rule ID 9021 //
     /*  288650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  288664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  288667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288689 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288706 */     GIR_RootConstrainSelectedInstOperands,
     /*  288707 */     // GIR_Coverage, 9021,
     /*  288707 */     GIR_EraseRootFromParent_Done,
     /*  288708 */   // Label 5439: @288708
     /*  288708 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(288771), // Rule ID 9024 //
     /*  288713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  288716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  288724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  288727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  288730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288752 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  288752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288769 */     GIR_RootConstrainSelectedInstOperands,
     /*  288770 */     // GIR_Coverage, 9024,
     /*  288770 */     GIR_EraseRootFromParent_Done,
     /*  288771 */   // Label 5440: @288771
     /*  288771 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(288834), // Rule ID 9025 //
     /*  288776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  288779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  288787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  288790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  288793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288815 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  288815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288832 */     GIR_RootConstrainSelectedInstOperands,
     /*  288833 */     // GIR_Coverage, 9025,
     /*  288833 */     GIR_EraseRootFromParent_Done,
     /*  288834 */   // Label 5441: @288834
     /*  288834 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(288897), // Rule ID 9028 //
     /*  288839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  288842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  288853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  288856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288878 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  288878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288895 */     GIR_RootConstrainSelectedInstOperands,
     /*  288896 */     // GIR_Coverage, 9028,
     /*  288896 */     GIR_EraseRootFromParent_Done,
     /*  288897 */   // Label 5442: @288897
     /*  288897 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(288960), // Rule ID 9029 //
     /*  288902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  288905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  288916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  288919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288941 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  288941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288958 */     GIR_RootConstrainSelectedInstOperands,
     /*  288959 */     // GIR_Coverage, 9029,
     /*  288959 */     GIR_EraseRootFromParent_Done,
     /*  288960 */   // Label 5443: @288960
     /*  288960 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(289023), // Rule ID 9032 //
     /*  288965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  288968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  288979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  288982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289004 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  289004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  289007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289021 */     GIR_RootConstrainSelectedInstOperands,
     /*  289022 */     // GIR_Coverage, 9032,
     /*  289022 */     GIR_EraseRootFromParent_Done,
     /*  289023 */   // Label 5444: @289023
     /*  289023 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(289086), // Rule ID 9033 //
     /*  289028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  289031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  289042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  289045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289067 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  289067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  289070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289084 */     GIR_RootConstrainSelectedInstOperands,
     /*  289085 */     // GIR_Coverage, 9033,
     /*  289085 */     GIR_EraseRootFromParent_Done,
     /*  289086 */   // Label 5445: @289086
     /*  289086 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(289149), // Rule ID 9036 //
     /*  289091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  289105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289130 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  289133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289147 */     GIR_RootConstrainSelectedInstOperands,
     /*  289148 */     // GIR_Coverage, 9036,
     /*  289148 */     GIR_EraseRootFromParent_Done,
     /*  289149 */   // Label 5446: @289149
     /*  289149 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(289212), // Rule ID 9037 //
     /*  289154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  289168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289193 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  289196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289210 */     GIR_RootConstrainSelectedInstOperands,
     /*  289211 */     // GIR_Coverage, 9037,
     /*  289211 */     GIR_EraseRootFromParent_Done,
     /*  289212 */   // Label 5447: @289212
     /*  289212 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(289275), // Rule ID 9040 //
     /*  289217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  289231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289256 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289273 */     GIR_RootConstrainSelectedInstOperands,
     /*  289274 */     // GIR_Coverage, 9040,
     /*  289274 */     GIR_EraseRootFromParent_Done,
     /*  289275 */   // Label 5448: @289275
     /*  289275 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(289338), // Rule ID 9041 //
     /*  289280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  289294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289319 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289336 */     GIR_RootConstrainSelectedInstOperands,
     /*  289337 */     // GIR_Coverage, 9041,
     /*  289337 */     GIR_EraseRootFromParent_Done,
     /*  289338 */   // Label 5449: @289338
     /*  289338 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(289401), // Rule ID 9044 //
     /*  289343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  289357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289382 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289399 */     GIR_RootConstrainSelectedInstOperands,
     /*  289400 */     // GIR_Coverage, 9044,
     /*  289400 */     GIR_EraseRootFromParent_Done,
     /*  289401 */   // Label 5450: @289401
     /*  289401 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(289464), // Rule ID 9045 //
     /*  289406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  289420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289445 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289462 */     GIR_RootConstrainSelectedInstOperands,
     /*  289463 */     // GIR_Coverage, 9045,
     /*  289463 */     GIR_EraseRootFromParent_Done,
     /*  289464 */   // Label 5451: @289464
     /*  289464 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(289527), // Rule ID 9048 //
     /*  289469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  289483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289508 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289525 */     GIR_RootConstrainSelectedInstOperands,
     /*  289526 */     // GIR_Coverage, 9048,
     /*  289526 */     GIR_EraseRootFromParent_Done,
     /*  289527 */   // Label 5452: @289527
     /*  289527 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(289590), // Rule ID 9049 //
     /*  289532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  289546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289571 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  289571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289588 */     GIR_RootConstrainSelectedInstOperands,
     /*  289589 */     // GIR_Coverage, 9049,
     /*  289589 */     GIR_EraseRootFromParent_Done,
     /*  289590 */   // Label 5453: @289590
     /*  289590 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(289653), // Rule ID 9052 //
     /*  289595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  289609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289634 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289651 */     GIR_RootConstrainSelectedInstOperands,
     /*  289652 */     // GIR_Coverage, 9052,
     /*  289652 */     GIR_EraseRootFromParent_Done,
     /*  289653 */   // Label 5454: @289653
     /*  289653 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(289716), // Rule ID 9053 //
     /*  289658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  289672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289697 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  289697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289714 */     GIR_RootConstrainSelectedInstOperands,
     /*  289715 */     // GIR_Coverage, 9053,
     /*  289715 */     GIR_EraseRootFromParent_Done,
     /*  289716 */   // Label 5455: @289716
     /*  289716 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(289779), // Rule ID 9056 //
     /*  289721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  289735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289760 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  289760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289777 */     GIR_RootConstrainSelectedInstOperands,
     /*  289778 */     // GIR_Coverage, 9056,
     /*  289778 */     GIR_EraseRootFromParent_Done,
     /*  289779 */   // Label 5456: @289779
     /*  289779 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(289842), // Rule ID 9057 //
     /*  289784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  289798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289823 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289840 */     GIR_RootConstrainSelectedInstOperands,
     /*  289841 */     // GIR_Coverage, 9057,
     /*  289841 */     GIR_EraseRootFromParent_Done,
     /*  289842 */   // Label 5457: @289842
     /*  289842 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(289905), // Rule ID 9060 //
     /*  289847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  289861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289886 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  289889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289903 */     GIR_RootConstrainSelectedInstOperands,
     /*  289904 */     // GIR_Coverage, 9060,
     /*  289904 */     GIR_EraseRootFromParent_Done,
     /*  289905 */   // Label 5458: @289905
     /*  289905 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(289968), // Rule ID 9061 //
     /*  289910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  289924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289949 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  289952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289966 */     GIR_RootConstrainSelectedInstOperands,
     /*  289967 */     // GIR_Coverage, 9061,
     /*  289967 */     GIR_EraseRootFromParent_Done,
     /*  289968 */   // Label 5459: @289968
     /*  289968 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(290031), // Rule ID 9064 //
     /*  289973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  289987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290012 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290029 */     GIR_RootConstrainSelectedInstOperands,
     /*  290030 */     // GIR_Coverage, 9064,
     /*  290030 */     GIR_EraseRootFromParent_Done,
     /*  290031 */   // Label 5460: @290031
     /*  290031 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(290094), // Rule ID 9065 //
     /*  290036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  290047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  290050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290075 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290092 */     GIR_RootConstrainSelectedInstOperands,
     /*  290093 */     // GIR_Coverage, 9065,
     /*  290093 */     GIR_EraseRootFromParent_Done,
     /*  290094 */   // Label 5461: @290094
     /*  290094 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(290157), // Rule ID 9068 //
     /*  290099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  290113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290138 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  290138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290155 */     GIR_RootConstrainSelectedInstOperands,
     /*  290156 */     // GIR_Coverage, 9068,
     /*  290156 */     GIR_EraseRootFromParent_Done,
     /*  290157 */   // Label 5462: @290157
     /*  290157 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(290220), // Rule ID 9069 //
     /*  290162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  290176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290201 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  290201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290218 */     GIR_RootConstrainSelectedInstOperands,
     /*  290219 */     // GIR_Coverage, 9069,
     /*  290219 */     GIR_EraseRootFromParent_Done,
     /*  290220 */   // Label 5463: @290220
     /*  290220 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(290283), // Rule ID 9072 //
     /*  290225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  290228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  290239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290264 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  290264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290281 */     GIR_RootConstrainSelectedInstOperands,
     /*  290282 */     // GIR_Coverage, 9072,
     /*  290282 */     GIR_EraseRootFromParent_Done,
     /*  290283 */   // Label 5464: @290283
     /*  290283 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(290346), // Rule ID 9073 //
     /*  290288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  290291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  290302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290327 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  290327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290344 */     GIR_RootConstrainSelectedInstOperands,
     /*  290345 */     // GIR_Coverage, 9073,
     /*  290345 */     GIR_EraseRootFromParent_Done,
     /*  290346 */   // Label 5465: @290346
     /*  290346 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(290409), // Rule ID 9076 //
     /*  290351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  290365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290390 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290407 */     GIR_RootConstrainSelectedInstOperands,
     /*  290408 */     // GIR_Coverage, 9076,
     /*  290408 */     GIR_EraseRootFromParent_Done,
     /*  290409 */   // Label 5466: @290409
     /*  290409 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(290472), // Rule ID 9077 //
     /*  290414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  290428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290453 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290470 */     GIR_RootConstrainSelectedInstOperands,
     /*  290471 */     // GIR_Coverage, 9077,
     /*  290471 */     GIR_EraseRootFromParent_Done,
     /*  290472 */   // Label 5467: @290472
     /*  290472 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(290535), // Rule ID 9080 //
     /*  290477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  290488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  290491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290516 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290533 */     GIR_RootConstrainSelectedInstOperands,
     /*  290534 */     // GIR_Coverage, 9080,
     /*  290534 */     GIR_EraseRootFromParent_Done,
     /*  290535 */   // Label 5468: @290535
     /*  290535 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(290598), // Rule ID 9081 //
     /*  290540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  290551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  290554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290579 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290596 */     GIR_RootConstrainSelectedInstOperands,
     /*  290597 */     // GIR_Coverage, 9081,
     /*  290597 */     GIR_EraseRootFromParent_Done,
     /*  290598 */   // Label 5469: @290598
     /*  290598 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(290661), // Rule ID 9084 //
     /*  290603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  290614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  290617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290642 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  290645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290659 */     GIR_RootConstrainSelectedInstOperands,
     /*  290660 */     // GIR_Coverage, 9084,
     /*  290660 */     GIR_EraseRootFromParent_Done,
     /*  290661 */   // Label 5470: @290661
     /*  290661 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(290724), // Rule ID 9085 //
     /*  290666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  290677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  290680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290705 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  290708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290722 */     GIR_RootConstrainSelectedInstOperands,
     /*  290723 */     // GIR_Coverage, 9085,
     /*  290723 */     GIR_EraseRootFromParent_Done,
     /*  290724 */   // Label 5471: @290724
     /*  290724 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(290787), // Rule ID 9088 //
     /*  290729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  290743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290768 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290785 */     GIR_RootConstrainSelectedInstOperands,
     /*  290786 */     // GIR_Coverage, 9088,
     /*  290786 */     GIR_EraseRootFromParent_Done,
     /*  290787 */   // Label 5472: @290787
     /*  290787 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(290850), // Rule ID 9089 //
     /*  290792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  290806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290831 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290848 */     GIR_RootConstrainSelectedInstOperands,
     /*  290849 */     // GIR_Coverage, 9089,
     /*  290849 */     GIR_EraseRootFromParent_Done,
     /*  290850 */   // Label 5473: @290850
     /*  290850 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(290913), // Rule ID 9092 //
     /*  290855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  290869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290894 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290911 */     GIR_RootConstrainSelectedInstOperands,
     /*  290912 */     // GIR_Coverage, 9092,
     /*  290912 */     GIR_EraseRootFromParent_Done,
     /*  290913 */   // Label 5474: @290913
     /*  290913 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(290976), // Rule ID 9093 //
     /*  290918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  290932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290957 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290974 */     GIR_RootConstrainSelectedInstOperands,
     /*  290975 */     // GIR_Coverage, 9093,
     /*  290975 */     GIR_EraseRootFromParent_Done,
     /*  290976 */   // Label 5475: @290976
     /*  290976 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(291039), // Rule ID 9096 //
     /*  290981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  290992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  290995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291020 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291037 */     GIR_RootConstrainSelectedInstOperands,
     /*  291038 */     // GIR_Coverage, 9096,
     /*  291038 */     GIR_EraseRootFromParent_Done,
     /*  291039 */   // Label 5476: @291039
     /*  291039 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(291102), // Rule ID 9097 //
     /*  291044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  291055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  291058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291083 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291100 */     GIR_RootConstrainSelectedInstOperands,
     /*  291101 */     // GIR_Coverage, 9097,
     /*  291101 */     GIR_EraseRootFromParent_Done,
     /*  291102 */   // Label 5477: @291102
     /*  291102 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(291165), // Rule ID 9100 //
     /*  291107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  291121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291146 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291163 */     GIR_RootConstrainSelectedInstOperands,
     /*  291164 */     // GIR_Coverage, 9100,
     /*  291164 */     GIR_EraseRootFromParent_Done,
     /*  291165 */   // Label 5478: @291165
     /*  291165 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(291228), // Rule ID 9101 //
     /*  291170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  291184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291209 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291226 */     GIR_RootConstrainSelectedInstOperands,
     /*  291227 */     // GIR_Coverage, 9101,
     /*  291227 */     GIR_EraseRootFromParent_Done,
     /*  291228 */   // Label 5479: @291228
     /*  291228 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(291291), // Rule ID 9104 //
     /*  291233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  291247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291272 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291289 */     GIR_RootConstrainSelectedInstOperands,
     /*  291290 */     // GIR_Coverage, 9104,
     /*  291290 */     GIR_EraseRootFromParent_Done,
     /*  291291 */   // Label 5480: @291291
     /*  291291 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(291354), // Rule ID 9105 //
     /*  291296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  291310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291335 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291352 */     GIR_RootConstrainSelectedInstOperands,
     /*  291353 */     // GIR_Coverage, 9105,
     /*  291353 */     GIR_EraseRootFromParent_Done,
     /*  291354 */   // Label 5481: @291354
     /*  291354 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(291417), // Rule ID 9108 //
     /*  291359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  291373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291398 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291415 */     GIR_RootConstrainSelectedInstOperands,
     /*  291416 */     // GIR_Coverage, 9108,
     /*  291416 */     GIR_EraseRootFromParent_Done,
     /*  291417 */   // Label 5482: @291417
     /*  291417 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(291480), // Rule ID 9109 //
     /*  291422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  291436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291461 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291478 */     GIR_RootConstrainSelectedInstOperands,
     /*  291479 */     // GIR_Coverage, 9109,
     /*  291479 */     GIR_EraseRootFromParent_Done,
     /*  291480 */   // Label 5483: @291480
     /*  291480 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(291543), // Rule ID 9112 //
     /*  291485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  291488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  291499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291524 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  291524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291541 */     GIR_RootConstrainSelectedInstOperands,
     /*  291542 */     // GIR_Coverage, 9112,
     /*  291542 */     GIR_EraseRootFromParent_Done,
     /*  291543 */   // Label 5484: @291543
     /*  291543 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(291606), // Rule ID 9113 //
     /*  291548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  291551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  291562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291587 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  291587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291604 */     GIR_RootConstrainSelectedInstOperands,
     /*  291605 */     // GIR_Coverage, 9113,
     /*  291605 */     GIR_EraseRootFromParent_Done,
     /*  291606 */   // Label 5485: @291606
     /*  291606 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(291669), // Rule ID 9116 //
     /*  291611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  291614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  291625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291650 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  291650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291667 */     GIR_RootConstrainSelectedInstOperands,
     /*  291668 */     // GIR_Coverage, 9116,
     /*  291668 */     GIR_EraseRootFromParent_Done,
     /*  291669 */   // Label 5486: @291669
     /*  291669 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(291732), // Rule ID 9117 //
     /*  291674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  291677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  291688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291713 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  291713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291730 */     GIR_RootConstrainSelectedInstOperands,
     /*  291731 */     // GIR_Coverage, 9117,
     /*  291731 */     GIR_EraseRootFromParent_Done,
     /*  291732 */   // Label 5487: @291732
     /*  291732 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(291795), // Rule ID 9120 //
     /*  291737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  291740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  291751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291776 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  291776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291793 */     GIR_RootConstrainSelectedInstOperands,
     /*  291794 */     // GIR_Coverage, 9120,
     /*  291794 */     GIR_EraseRootFromParent_Done,
     /*  291795 */   // Label 5488: @291795
     /*  291795 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(291858), // Rule ID 9121 //
     /*  291800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  291803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  291814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291839 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  291839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291856 */     GIR_RootConstrainSelectedInstOperands,
     /*  291857 */     // GIR_Coverage, 9121,
     /*  291857 */     GIR_EraseRootFromParent_Done,
     /*  291858 */   // Label 5489: @291858
     /*  291858 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(291921), // Rule ID 9212 //
     /*  291863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  291874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  291877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291902 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  291902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  291905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291919 */     GIR_RootConstrainSelectedInstOperands,
     /*  291920 */     // GIR_Coverage, 9212,
     /*  291920 */     GIR_EraseRootFromParent_Done,
     /*  291921 */   // Label 5490: @291921
     /*  291921 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(291984), // Rule ID 9213 //
     /*  291926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  291937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  291940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291965 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  291968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291982 */     GIR_RootConstrainSelectedInstOperands,
     /*  291983 */     // GIR_Coverage, 9213,
     /*  291983 */     GIR_EraseRootFromParent_Done,
     /*  291984 */   // Label 5491: @291984
     /*  291984 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(292047), // Rule ID 9216 //
     /*  291989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  292003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292028 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292045 */     GIR_RootConstrainSelectedInstOperands,
     /*  292046 */     // GIR_Coverage, 9216,
     /*  292046 */     GIR_EraseRootFromParent_Done,
     /*  292047 */   // Label 5492: @292047
     /*  292047 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(292110), // Rule ID 9217 //
     /*  292052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  292066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292091 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292108 */     GIR_RootConstrainSelectedInstOperands,
     /*  292109 */     // GIR_Coverage, 9217,
     /*  292109 */     GIR_EraseRootFromParent_Done,
     /*  292110 */   // Label 5493: @292110
     /*  292110 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(292173), // Rule ID 9220 //
     /*  292115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  292129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292154 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292171 */     GIR_RootConstrainSelectedInstOperands,
     /*  292172 */     // GIR_Coverage, 9220,
     /*  292172 */     GIR_EraseRootFromParent_Done,
     /*  292173 */   // Label 5494: @292173
     /*  292173 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(292236), // Rule ID 9221 //
     /*  292178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  292192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292217 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292234 */     GIR_RootConstrainSelectedInstOperands,
     /*  292235 */     // GIR_Coverage, 9221,
     /*  292235 */     GIR_EraseRootFromParent_Done,
     /*  292236 */   // Label 5495: @292236
     /*  292236 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(292299), // Rule ID 9224 //
     /*  292241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  292255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  292280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292297 */     GIR_RootConstrainSelectedInstOperands,
     /*  292298 */     // GIR_Coverage, 9224,
     /*  292298 */     GIR_EraseRootFromParent_Done,
     /*  292299 */   // Label 5496: @292299
     /*  292299 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(292362), // Rule ID 9225 //
     /*  292304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  292318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292343 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292360 */     GIR_RootConstrainSelectedInstOperands,
     /*  292361 */     // GIR_Coverage, 9225,
     /*  292361 */     GIR_EraseRootFromParent_Done,
     /*  292362 */   // Label 5497: @292362
     /*  292362 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(292425), // Rule ID 9228 //
     /*  292367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  292381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292406 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  292406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292423 */     GIR_RootConstrainSelectedInstOperands,
     /*  292424 */     // GIR_Coverage, 9228,
     /*  292424 */     GIR_EraseRootFromParent_Done,
     /*  292425 */   // Label 5498: @292425
     /*  292425 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(292488), // Rule ID 9229 //
     /*  292430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  292444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292469 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292486 */     GIR_RootConstrainSelectedInstOperands,
     /*  292487 */     // GIR_Coverage, 9229,
     /*  292487 */     GIR_EraseRootFromParent_Done,
     /*  292488 */   // Label 5499: @292488
     /*  292488 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(292551), // Rule ID 9232 //
     /*  292493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  292507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292532 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292549 */     GIR_RootConstrainSelectedInstOperands,
     /*  292550 */     // GIR_Coverage, 9232,
     /*  292550 */     GIR_EraseRootFromParent_Done,
     /*  292551 */   // Label 5500: @292551
     /*  292551 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(292614), // Rule ID 9233 //
     /*  292556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  292570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292595 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  292595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292612 */     GIR_RootConstrainSelectedInstOperands,
     /*  292613 */     // GIR_Coverage, 9233,
     /*  292613 */     GIR_EraseRootFromParent_Done,
     /*  292614 */   // Label 5501: @292614
     /*  292614 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(292677), // Rule ID 9236 //
     /*  292619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  292633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292658 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292675 */     GIR_RootConstrainSelectedInstOperands,
     /*  292676 */     // GIR_Coverage, 9236,
     /*  292676 */     GIR_EraseRootFromParent_Done,
     /*  292677 */   // Label 5502: @292677
     /*  292677 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(292740), // Rule ID 9237 //
     /*  292682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  292696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292721 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292738 */     GIR_RootConstrainSelectedInstOperands,
     /*  292739 */     // GIR_Coverage, 9237,
     /*  292739 */     GIR_EraseRootFromParent_Done,
     /*  292740 */   // Label 5503: @292740
     /*  292740 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(292803), // Rule ID 9240 //
     /*  292745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  292759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292784 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  292784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292801 */     GIR_RootConstrainSelectedInstOperands,
     /*  292802 */     // GIR_Coverage, 9240,
     /*  292802 */     GIR_EraseRootFromParent_Done,
     /*  292803 */   // Label 5504: @292803
     /*  292803 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(292866), // Rule ID 9241 //
     /*  292808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  292822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292847 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292864 */     GIR_RootConstrainSelectedInstOperands,
     /*  292865 */     // GIR_Coverage, 9241,
     /*  292865 */     GIR_EraseRootFromParent_Done,
     /*  292866 */   // Label 5505: @292866
     /*  292866 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(292929), // Rule ID 9244 //
     /*  292871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  292885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292910 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292927 */     GIR_RootConstrainSelectedInstOperands,
     /*  292928 */     // GIR_Coverage, 9244,
     /*  292928 */     GIR_EraseRootFromParent_Done,
     /*  292929 */   // Label 5506: @292929
     /*  292929 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(292992), // Rule ID 9245 //
     /*  292934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  292948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292973 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  292973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292990 */     GIR_RootConstrainSelectedInstOperands,
     /*  292991 */     // GIR_Coverage, 9245,
     /*  292991 */     GIR_EraseRootFromParent_Done,
     /*  292992 */   // Label 5507: @292992
     /*  292992 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(293055), // Rule ID 9248 //
     /*  292997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  293000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  293011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293036 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  293036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  293053 */     GIR_RootConstrainSelectedInstOperands,
     /*  293054 */     // GIR_Coverage, 9248,
     /*  293054 */     GIR_EraseRootFromParent_Done,
     /*  293055 */   // Label 5508: @293055
     /*  293055 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(293118), // Rule ID 9249 //
     /*  293060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  293063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  293074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293099 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  293099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  293116 */     GIR_RootConstrainSelectedInstOperands,
     /*  293117 */     // GIR_Coverage, 9249,
     /*  293117 */     GIR_EraseRootFromParent_Done,
     /*  293118 */   // Label 5509: @293118
     /*  293118 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(293181), // Rule ID 9252 //
     /*  293123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  293137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293162 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293179 */     GIR_RootConstrainSelectedInstOperands,
     /*  293180 */     // GIR_Coverage, 9252,
     /*  293180 */     GIR_EraseRootFromParent_Done,
     /*  293181 */   // Label 5510: @293181
     /*  293181 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(293244), // Rule ID 9253 //
     /*  293186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  293200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293225 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293242 */     GIR_RootConstrainSelectedInstOperands,
     /*  293243 */     // GIR_Coverage, 9253,
     /*  293243 */     GIR_EraseRootFromParent_Done,
     /*  293244 */   // Label 5511: @293244
     /*  293244 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(293307), // Rule ID 9256 //
     /*  293249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  293263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293288 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293305 */     GIR_RootConstrainSelectedInstOperands,
     /*  293306 */     // GIR_Coverage, 9256,
     /*  293306 */     GIR_EraseRootFromParent_Done,
     /*  293307 */   // Label 5512: @293307
     /*  293307 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(293370), // Rule ID 9257 //
     /*  293312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  293326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293351 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293368 */     GIR_RootConstrainSelectedInstOperands,
     /*  293369 */     // GIR_Coverage, 9257,
     /*  293369 */     GIR_EraseRootFromParent_Done,
     /*  293370 */   // Label 5513: @293370
     /*  293370 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(293433), // Rule ID 9260 //
     /*  293375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  293386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  293389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293414 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293431 */     GIR_RootConstrainSelectedInstOperands,
     /*  293432 */     // GIR_Coverage, 9260,
     /*  293432 */     GIR_EraseRootFromParent_Done,
     /*  293433 */   // Label 5514: @293433
     /*  293433 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(293496), // Rule ID 9261 //
     /*  293438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  293449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  293452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293477 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293494 */     GIR_RootConstrainSelectedInstOperands,
     /*  293495 */     // GIR_Coverage, 9261,
     /*  293495 */     GIR_EraseRootFromParent_Done,
     /*  293496 */   // Label 5515: @293496
     /*  293496 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(293559), // Rule ID 9264 //
     /*  293501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  293515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293540 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293557 */     GIR_RootConstrainSelectedInstOperands,
     /*  293558 */     // GIR_Coverage, 9264,
     /*  293558 */     GIR_EraseRootFromParent_Done,
     /*  293559 */   // Label 5516: @293559
     /*  293559 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(293622), // Rule ID 9265 //
     /*  293564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  293578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293603 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293620 */     GIR_RootConstrainSelectedInstOperands,
     /*  293621 */     // GIR_Coverage, 9265,
     /*  293621 */     GIR_EraseRootFromParent_Done,
     /*  293622 */   // Label 5517: @293622
     /*  293622 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(293685), // Rule ID 9268 //
     /*  293627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  293641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293666 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293683 */     GIR_RootConstrainSelectedInstOperands,
     /*  293684 */     // GIR_Coverage, 9268,
     /*  293684 */     GIR_EraseRootFromParent_Done,
     /*  293685 */   // Label 5518: @293685
     /*  293685 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(293748), // Rule ID 9269 //
     /*  293690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  293704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293729 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293746 */     GIR_RootConstrainSelectedInstOperands,
     /*  293747 */     // GIR_Coverage, 9269,
     /*  293747 */     GIR_EraseRootFromParent_Done,
     /*  293748 */   // Label 5519: @293748
     /*  293748 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(293811), // Rule ID 9272 //
     /*  293753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  293767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293792 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293809 */     GIR_RootConstrainSelectedInstOperands,
     /*  293810 */     // GIR_Coverage, 9272,
     /*  293810 */     GIR_EraseRootFromParent_Done,
     /*  293811 */   // Label 5520: @293811
     /*  293811 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(293874), // Rule ID 9273 //
     /*  293816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  293830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293855 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293872 */     GIR_RootConstrainSelectedInstOperands,
     /*  293873 */     // GIR_Coverage, 9273,
     /*  293873 */     GIR_EraseRootFromParent_Done,
     /*  293874 */   // Label 5521: @293874
     /*  293874 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(293937), // Rule ID 9276 //
     /*  293879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  293893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293918 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  293918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293935 */     GIR_RootConstrainSelectedInstOperands,
     /*  293936 */     // GIR_Coverage, 9276,
     /*  293936 */     GIR_EraseRootFromParent_Done,
     /*  293937 */   // Label 5522: @293937
     /*  293937 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(294000), // Rule ID 9277 //
     /*  293942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  293956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293981 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  293981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293998 */     GIR_RootConstrainSelectedInstOperands,
     /*  293999 */     // GIR_Coverage, 9277,
     /*  293999 */     GIR_EraseRootFromParent_Done,
     /*  294000 */   // Label 5523: @294000
     /*  294000 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(294063), // Rule ID 9280 //
     /*  294005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  294019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294044 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294061 */     GIR_RootConstrainSelectedInstOperands,
     /*  294062 */     // GIR_Coverage, 9280,
     /*  294062 */     GIR_EraseRootFromParent_Done,
     /*  294063 */   // Label 5524: @294063
     /*  294063 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(294126), // Rule ID 9281 //
     /*  294068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  294082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294107 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294124 */     GIR_RootConstrainSelectedInstOperands,
     /*  294125 */     // GIR_Coverage, 9281,
     /*  294125 */     GIR_EraseRootFromParent_Done,
     /*  294126 */   // Label 5525: @294126
     /*  294126 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(294189), // Rule ID 9284 //
     /*  294131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  294145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294170 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294187 */     GIR_RootConstrainSelectedInstOperands,
     /*  294188 */     // GIR_Coverage, 9284,
     /*  294188 */     GIR_EraseRootFromParent_Done,
     /*  294189 */   // Label 5526: @294189
     /*  294189 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(294252), // Rule ID 9285 //
     /*  294194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  294208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294233 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294250 */     GIR_RootConstrainSelectedInstOperands,
     /*  294251 */     // GIR_Coverage, 9285,
     /*  294251 */     GIR_EraseRootFromParent_Done,
     /*  294252 */   // Label 5527: @294252
     /*  294252 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(294315), // Rule ID 9288 //
     /*  294257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  294271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294296 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294313 */     GIR_RootConstrainSelectedInstOperands,
     /*  294314 */     // GIR_Coverage, 9288,
     /*  294314 */     GIR_EraseRootFromParent_Done,
     /*  294315 */   // Label 5528: @294315
     /*  294315 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(294378), // Rule ID 9289 //
     /*  294320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  294323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  294334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294359 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294376 */     GIR_RootConstrainSelectedInstOperands,
     /*  294377 */     // GIR_Coverage, 9289,
     /*  294377 */     GIR_EraseRootFromParent_Done,
     /*  294378 */   // Label 5529: @294378
     /*  294378 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(294441), // Rule ID 9292 //
     /*  294383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  294397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294422 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294439 */     GIR_RootConstrainSelectedInstOperands,
     /*  294440 */     // GIR_Coverage, 9292,
     /*  294440 */     GIR_EraseRootFromParent_Done,
     /*  294441 */   // Label 5530: @294441
     /*  294441 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(294504), // Rule ID 9293 //
     /*  294446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  294449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  294460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294485 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294502 */     GIR_RootConstrainSelectedInstOperands,
     /*  294503 */     // GIR_Coverage, 9293,
     /*  294503 */     GIR_EraseRootFromParent_Done,
     /*  294504 */   // Label 5531: @294504
     /*  294504 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(294567), // Rule ID 9296 //
     /*  294509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  294523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294548 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294565 */     GIR_RootConstrainSelectedInstOperands,
     /*  294566 */     // GIR_Coverage, 9296,
     /*  294566 */     GIR_EraseRootFromParent_Done,
     /*  294567 */   // Label 5532: @294567
     /*  294567 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(294630), // Rule ID 9297 //
     /*  294572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  294575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  294586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294611 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294628 */     GIR_RootConstrainSelectedInstOperands,
     /*  294629 */     // GIR_Coverage, 9297,
     /*  294629 */     GIR_EraseRootFromParent_Done,
     /*  294630 */   // Label 5533: @294630
     /*  294630 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(294693), // Rule ID 9388 //
     /*  294635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  294649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294674 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  294677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294691 */     GIR_RootConstrainSelectedInstOperands,
     /*  294692 */     // GIR_Coverage, 9388,
     /*  294692 */     GIR_EraseRootFromParent_Done,
     /*  294693 */   // Label 5534: @294693
     /*  294693 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(294756), // Rule ID 9389 //
     /*  294698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  294712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294737 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  294740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294754 */     GIR_RootConstrainSelectedInstOperands,
     /*  294755 */     // GIR_Coverage, 9389,
     /*  294755 */     GIR_EraseRootFromParent_Done,
     /*  294756 */   // Label 5535: @294756
     /*  294756 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(294819), // Rule ID 9392 //
     /*  294761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  294775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294800 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  294803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294817 */     GIR_RootConstrainSelectedInstOperands,
     /*  294818 */     // GIR_Coverage, 9392,
     /*  294818 */     GIR_EraseRootFromParent_Done,
     /*  294819 */   // Label 5536: @294819
     /*  294819 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(294882), // Rule ID 9393 //
     /*  294824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  294838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294863 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  294866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294880 */     GIR_RootConstrainSelectedInstOperands,
     /*  294881 */     // GIR_Coverage, 9393,
     /*  294881 */     GIR_EraseRootFromParent_Done,
     /*  294882 */   // Label 5537: @294882
     /*  294882 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(294945), // Rule ID 9396 //
     /*  294887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  294901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294926 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  294929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294943 */     GIR_RootConstrainSelectedInstOperands,
     /*  294944 */     // GIR_Coverage, 9396,
     /*  294944 */     GIR_EraseRootFromParent_Done,
     /*  294945 */   // Label 5538: @294945
     /*  294945 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(295008), // Rule ID 9397 //
     /*  294950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  294964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294989 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  294992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295006 */     GIR_RootConstrainSelectedInstOperands,
     /*  295007 */     // GIR_Coverage, 9397,
     /*  295007 */     GIR_EraseRootFromParent_Done,
     /*  295008 */   // Label 5539: @295008
     /*  295008 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(295071), // Rule ID 9400 //
     /*  295013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  295027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295052 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  295055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295069 */     GIR_RootConstrainSelectedInstOperands,
     /*  295070 */     // GIR_Coverage, 9400,
     /*  295070 */     GIR_EraseRootFromParent_Done,
     /*  295071 */   // Label 5540: @295071
     /*  295071 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(295134), // Rule ID 9401 //
     /*  295076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  295090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295115 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  295118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295132 */     GIR_RootConstrainSelectedInstOperands,
     /*  295133 */     // GIR_Coverage, 9401,
     /*  295133 */     GIR_EraseRootFromParent_Done,
     /*  295134 */   // Label 5541: @295134
     /*  295134 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(295197), // Rule ID 9404 //
     /*  295139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  295153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295178 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295195 */     GIR_RootConstrainSelectedInstOperands,
     /*  295196 */     // GIR_Coverage, 9404,
     /*  295196 */     GIR_EraseRootFromParent_Done,
     /*  295197 */   // Label 5542: @295197
     /*  295197 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(295260), // Rule ID 9405 //
     /*  295202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  295216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295241 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295258 */     GIR_RootConstrainSelectedInstOperands,
     /*  295259 */     // GIR_Coverage, 9405,
     /*  295259 */     GIR_EraseRootFromParent_Done,
     /*  295260 */   // Label 5543: @295260
     /*  295260 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(295323), // Rule ID 9408 //
     /*  295265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  295279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295304 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295321 */     GIR_RootConstrainSelectedInstOperands,
     /*  295322 */     // GIR_Coverage, 9408,
     /*  295322 */     GIR_EraseRootFromParent_Done,
     /*  295323 */   // Label 5544: @295323
     /*  295323 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(295386), // Rule ID 9409 //
     /*  295328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  295342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295367 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295384 */     GIR_RootConstrainSelectedInstOperands,
     /*  295385 */     // GIR_Coverage, 9409,
     /*  295385 */     GIR_EraseRootFromParent_Done,
     /*  295386 */   // Label 5545: @295386
     /*  295386 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(295449), // Rule ID 9412 //
     /*  295391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  295405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295430 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295447 */     GIR_RootConstrainSelectedInstOperands,
     /*  295448 */     // GIR_Coverage, 9412,
     /*  295448 */     GIR_EraseRootFromParent_Done,
     /*  295449 */   // Label 5546: @295449
     /*  295449 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(295512), // Rule ID 9413 //
     /*  295454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  295468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295493 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295510 */     GIR_RootConstrainSelectedInstOperands,
     /*  295511 */     // GIR_Coverage, 9413,
     /*  295511 */     GIR_EraseRootFromParent_Done,
     /*  295512 */   // Label 5547: @295512
     /*  295512 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(295575), // Rule ID 9416 //
     /*  295517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  295531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295556 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295573 */     GIR_RootConstrainSelectedInstOperands,
     /*  295574 */     // GIR_Coverage, 9416,
     /*  295574 */     GIR_EraseRootFromParent_Done,
     /*  295575 */   // Label 5548: @295575
     /*  295575 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(295638), // Rule ID 9417 //
     /*  295580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  295594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295619 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295636 */     GIR_RootConstrainSelectedInstOperands,
     /*  295637 */     // GIR_Coverage, 9417,
     /*  295637 */     GIR_EraseRootFromParent_Done,
     /*  295638 */   // Label 5549: @295638
     /*  295638 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(295701), // Rule ID 9420 //
     /*  295643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  295657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295682 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295699 */     GIR_RootConstrainSelectedInstOperands,
     /*  295700 */     // GIR_Coverage, 9420,
     /*  295700 */     GIR_EraseRootFromParent_Done,
     /*  295701 */   // Label 5550: @295701
     /*  295701 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(295764), // Rule ID 9421 //
     /*  295706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  295720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295745 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295762 */     GIR_RootConstrainSelectedInstOperands,
     /*  295763 */     // GIR_Coverage, 9421,
     /*  295763 */     GIR_EraseRootFromParent_Done,
     /*  295764 */   // Label 5551: @295764
     /*  295764 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(295827), // Rule ID 9424 //
     /*  295769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  295772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  295783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295808 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  295808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295825 */     GIR_RootConstrainSelectedInstOperands,
     /*  295826 */     // GIR_Coverage, 9424,
     /*  295826 */     GIR_EraseRootFromParent_Done,
     /*  295827 */   // Label 5552: @295827
     /*  295827 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(295890), // Rule ID 9425 //
     /*  295832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  295835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  295846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295871 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  295871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295888 */     GIR_RootConstrainSelectedInstOperands,
     /*  295889 */     // GIR_Coverage, 9425,
     /*  295889 */     GIR_EraseRootFromParent_Done,
     /*  295890 */   // Label 5553: @295890
     /*  295890 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(295953), // Rule ID 9428 //
     /*  295895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  295906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  295909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295934 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  295937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295951 */     GIR_RootConstrainSelectedInstOperands,
     /*  295952 */     // GIR_Coverage, 9428,
     /*  295952 */     GIR_EraseRootFromParent_Done,
     /*  295953 */   // Label 5554: @295953
     /*  295953 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(296016), // Rule ID 9429 //
     /*  295958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  295969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  295972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295997 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296014 */     GIR_RootConstrainSelectedInstOperands,
     /*  296015 */     // GIR_Coverage, 9429,
     /*  296015 */     GIR_EraseRootFromParent_Done,
     /*  296016 */   // Label 5555: @296016
     /*  296016 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(296079), // Rule ID 9432 //
     /*  296021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  296035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296060 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296077 */     GIR_RootConstrainSelectedInstOperands,
     /*  296078 */     // GIR_Coverage, 9432,
     /*  296078 */     GIR_EraseRootFromParent_Done,
     /*  296079 */   // Label 5556: @296079
     /*  296079 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(296142), // Rule ID 9433 //
     /*  296084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  296098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296123 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296140 */     GIR_RootConstrainSelectedInstOperands,
     /*  296141 */     // GIR_Coverage, 9433,
     /*  296141 */     GIR_EraseRootFromParent_Done,
     /*  296142 */   // Label 5557: @296142
     /*  296142 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(296205), // Rule ID 9436 //
     /*  296147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  296158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  296161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296186 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296203 */     GIR_RootConstrainSelectedInstOperands,
     /*  296204 */     // GIR_Coverage, 9436,
     /*  296204 */     GIR_EraseRootFromParent_Done,
     /*  296205 */   // Label 5558: @296205
     /*  296205 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(296268), // Rule ID 9437 //
     /*  296210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  296221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  296224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296249 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296266 */     GIR_RootConstrainSelectedInstOperands,
     /*  296267 */     // GIR_Coverage, 9437,
     /*  296267 */     GIR_EraseRootFromParent_Done,
     /*  296268 */   // Label 5559: @296268
     /*  296268 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(296331), // Rule ID 9440 //
     /*  296273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  296287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296312 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296329 */     GIR_RootConstrainSelectedInstOperands,
     /*  296330 */     // GIR_Coverage, 9440,
     /*  296330 */     GIR_EraseRootFromParent_Done,
     /*  296331 */   // Label 5560: @296331
     /*  296331 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(296394), // Rule ID 9441 //
     /*  296336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  296350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296375 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296392 */     GIR_RootConstrainSelectedInstOperands,
     /*  296393 */     // GIR_Coverage, 9441,
     /*  296393 */     GIR_EraseRootFromParent_Done,
     /*  296394 */   // Label 5561: @296394
     /*  296394 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(296457), // Rule ID 9444 //
     /*  296399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  296413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296438 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296455 */     GIR_RootConstrainSelectedInstOperands,
     /*  296456 */     // GIR_Coverage, 9444,
     /*  296456 */     GIR_EraseRootFromParent_Done,
     /*  296457 */   // Label 5562: @296457
     /*  296457 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(296520), // Rule ID 9445 //
     /*  296462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  296476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296501 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296518 */     GIR_RootConstrainSelectedInstOperands,
     /*  296519 */     // GIR_Coverage, 9445,
     /*  296519 */     GIR_EraseRootFromParent_Done,
     /*  296520 */   // Label 5563: @296520
     /*  296520 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(296583), // Rule ID 9448 //
     /*  296525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  296539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296564 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296581 */     GIR_RootConstrainSelectedInstOperands,
     /*  296582 */     // GIR_Coverage, 9448,
     /*  296582 */     GIR_EraseRootFromParent_Done,
     /*  296583 */   // Label 5564: @296583
     /*  296583 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(296646), // Rule ID 9449 //
     /*  296588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  296602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296627 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296644 */     GIR_RootConstrainSelectedInstOperands,
     /*  296645 */     // GIR_Coverage, 9449,
     /*  296645 */     GIR_EraseRootFromParent_Done,
     /*  296646 */   // Label 5565: @296646
     /*  296646 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(296709), // Rule ID 9452 //
     /*  296651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  296665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296690 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296707 */     GIR_RootConstrainSelectedInstOperands,
     /*  296708 */     // GIR_Coverage, 9452,
     /*  296708 */     GIR_EraseRootFromParent_Done,
     /*  296709 */   // Label 5566: @296709
     /*  296709 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(296772), // Rule ID 9453 //
     /*  296714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  296728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296753 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296770 */     GIR_RootConstrainSelectedInstOperands,
     /*  296771 */     // GIR_Coverage, 9453,
     /*  296771 */     GIR_EraseRootFromParent_Done,
     /*  296772 */   // Label 5567: @296772
     /*  296772 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(296835), // Rule ID 9456 //
     /*  296777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  296791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296816 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296833 */     GIR_RootConstrainSelectedInstOperands,
     /*  296834 */     // GIR_Coverage, 9456,
     /*  296834 */     GIR_EraseRootFromParent_Done,
     /*  296835 */   // Label 5568: @296835
     /*  296835 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(296898), // Rule ID 9457 //
     /*  296840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  296854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296879 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296896 */     GIR_RootConstrainSelectedInstOperands,
     /*  296897 */     // GIR_Coverage, 9457,
     /*  296897 */     GIR_EraseRootFromParent_Done,
     /*  296898 */   // Label 5569: @296898
     /*  296898 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(296961), // Rule ID 9460 //
     /*  296903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  296917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296942 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296959 */     GIR_RootConstrainSelectedInstOperands,
     /*  296960 */     // GIR_Coverage, 9460,
     /*  296960 */     GIR_EraseRootFromParent_Done,
     /*  296961 */   // Label 5570: @296961
     /*  296961 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(297024), // Rule ID 9461 //
     /*  296966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  296980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297005 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297022 */     GIR_RootConstrainSelectedInstOperands,
     /*  297023 */     // GIR_Coverage, 9461,
     /*  297023 */     GIR_EraseRootFromParent_Done,
     /*  297024 */   // Label 5571: @297024
     /*  297024 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(297087), // Rule ID 9464 //
     /*  297029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  297032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  297043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297068 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  297071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297085 */     GIR_RootConstrainSelectedInstOperands,
     /*  297086 */     // GIR_Coverage, 9464,
     /*  297086 */     GIR_EraseRootFromParent_Done,
     /*  297087 */   // Label 5572: @297087
     /*  297087 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(297150), // Rule ID 9465 //
     /*  297092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  297095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  297106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297131 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  297134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297148 */     GIR_RootConstrainSelectedInstOperands,
     /*  297149 */     // GIR_Coverage, 9465,
     /*  297149 */     GIR_EraseRootFromParent_Done,
     /*  297150 */   // Label 5573: @297150
     /*  297150 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(297213), // Rule ID 9468 //
     /*  297155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  297158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  297169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297194 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  297197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297211 */     GIR_RootConstrainSelectedInstOperands,
     /*  297212 */     // GIR_Coverage, 9468,
     /*  297212 */     GIR_EraseRootFromParent_Done,
     /*  297213 */   // Label 5574: @297213
     /*  297213 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(297276), // Rule ID 9469 //
     /*  297218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  297221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  297232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297257 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  297260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297274 */     GIR_RootConstrainSelectedInstOperands,
     /*  297275 */     // GIR_Coverage, 9469,
     /*  297275 */     GIR_EraseRootFromParent_Done,
     /*  297276 */   // Label 5575: @297276
     /*  297276 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(297339), // Rule ID 9472 //
     /*  297281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  297284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  297295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297320 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297337 */     GIR_RootConstrainSelectedInstOperands,
     /*  297338 */     // GIR_Coverage, 9472,
     /*  297338 */     GIR_EraseRootFromParent_Done,
     /*  297339 */   // Label 5576: @297339
     /*  297339 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(297402), // Rule ID 9473 //
     /*  297344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  297347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  297358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297383 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297400 */     GIR_RootConstrainSelectedInstOperands,
     /*  297401 */     // GIR_Coverage, 9473,
     /*  297401 */     GIR_EraseRootFromParent_Done,
     /*  297402 */   // Label 5577: @297402
     /*  297402 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(297465), // Rule ID 9564 //
     /*  297407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  297421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  297424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297463 */     GIR_RootConstrainSelectedInstOperands,
     /*  297464 */     // GIR_Coverage, 9564,
     /*  297464 */     GIR_EraseRootFromParent_Done,
     /*  297465 */   // Label 5578: @297465
     /*  297465 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(297528), // Rule ID 9565 //
     /*  297470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  297484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  297487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297509 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297526 */     GIR_RootConstrainSelectedInstOperands,
     /*  297527 */     // GIR_Coverage, 9565,
     /*  297527 */     GIR_EraseRootFromParent_Done,
     /*  297528 */   // Label 5579: @297528
     /*  297528 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(297591), // Rule ID 9568 //
     /*  297533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  297547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  297550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297589 */     GIR_RootConstrainSelectedInstOperands,
     /*  297590 */     // GIR_Coverage, 9568,
     /*  297590 */     GIR_EraseRootFromParent_Done,
     /*  297591 */   // Label 5580: @297591
     /*  297591 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(297654), // Rule ID 9569 //
     /*  297596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  297610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  297613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297635 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297652 */     GIR_RootConstrainSelectedInstOperands,
     /*  297653 */     // GIR_Coverage, 9569,
     /*  297653 */     GIR_EraseRootFromParent_Done,
     /*  297654 */   // Label 5581: @297654
     /*  297654 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(297717), // Rule ID 9572 //
     /*  297659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  297673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  297676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297698 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297715 */     GIR_RootConstrainSelectedInstOperands,
     /*  297716 */     // GIR_Coverage, 9572,
     /*  297716 */     GIR_EraseRootFromParent_Done,
     /*  297717 */   // Label 5582: @297717
     /*  297717 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(297780), // Rule ID 9573 //
     /*  297722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  297736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  297739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297761 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297778 */     GIR_RootConstrainSelectedInstOperands,
     /*  297779 */     // GIR_Coverage, 9573,
     /*  297779 */     GIR_EraseRootFromParent_Done,
     /*  297780 */   // Label 5583: @297780
     /*  297780 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(297843), // Rule ID 9576 //
     /*  297785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  297799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  297802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297824 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297841 */     GIR_RootConstrainSelectedInstOperands,
     /*  297842 */     // GIR_Coverage, 9576,
     /*  297842 */     GIR_EraseRootFromParent_Done,
     /*  297843 */   // Label 5584: @297843
     /*  297843 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(297906), // Rule ID 9577 //
     /*  297848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  297862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  297865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297887 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297904 */     GIR_RootConstrainSelectedInstOperands,
     /*  297905 */     // GIR_Coverage, 9577,
     /*  297905 */     GIR_EraseRootFromParent_Done,
     /*  297906 */   // Label 5585: @297906
     /*  297906 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(297969), // Rule ID 9580 //
     /*  297911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  297925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  297928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297950 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297967 */     GIR_RootConstrainSelectedInstOperands,
     /*  297968 */     // GIR_Coverage, 9580,
     /*  297968 */     GIR_EraseRootFromParent_Done,
     /*  297969 */   // Label 5586: @297969
     /*  297969 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(298032), // Rule ID 9581 //
     /*  297974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  297988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  297991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298013 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  298013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298030 */     GIR_RootConstrainSelectedInstOperands,
     /*  298031 */     // GIR_Coverage, 9581,
     /*  298031 */     GIR_EraseRootFromParent_Done,
     /*  298032 */   // Label 5587: @298032
     /*  298032 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(298095), // Rule ID 9584 //
     /*  298037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  298051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  298054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298076 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298093 */     GIR_RootConstrainSelectedInstOperands,
     /*  298094 */     // GIR_Coverage, 9584,
     /*  298094 */     GIR_EraseRootFromParent_Done,
     /*  298095 */   // Label 5588: @298095
     /*  298095 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(298158), // Rule ID 9585 //
     /*  298100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  298114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  298117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298139 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298156 */     GIR_RootConstrainSelectedInstOperands,
     /*  298157 */     // GIR_Coverage, 9585,
     /*  298157 */     GIR_EraseRootFromParent_Done,
     /*  298158 */   // Label 5589: @298158
     /*  298158 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(298221), // Rule ID 9588 //
     /*  298163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  298177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  298180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298202 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298219 */     GIR_RootConstrainSelectedInstOperands,
     /*  298220 */     // GIR_Coverage, 9588,
     /*  298220 */     GIR_EraseRootFromParent_Done,
     /*  298221 */   // Label 5590: @298221
     /*  298221 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(298284), // Rule ID 9589 //
     /*  298226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  298240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  298243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298265 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298282 */     GIR_RootConstrainSelectedInstOperands,
     /*  298283 */     // GIR_Coverage, 9589,
     /*  298283 */     GIR_EraseRootFromParent_Done,
     /*  298284 */   // Label 5591: @298284
     /*  298284 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(298347), // Rule ID 9592 //
     /*  298289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  298303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  298306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298328 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  298328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298345 */     GIR_RootConstrainSelectedInstOperands,
     /*  298346 */     // GIR_Coverage, 9592,
     /*  298346 */     GIR_EraseRootFromParent_Done,
     /*  298347 */   // Label 5592: @298347
     /*  298347 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(298410), // Rule ID 9593 //
     /*  298352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  298366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  298369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298391 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  298391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298408 */     GIR_RootConstrainSelectedInstOperands,
     /*  298409 */     // GIR_Coverage, 9593,
     /*  298409 */     GIR_EraseRootFromParent_Done,
     /*  298410 */   // Label 5593: @298410
     /*  298410 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(298473), // Rule ID 9596 //
     /*  298415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  298418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  298429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  298432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298454 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  298454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298471 */     GIR_RootConstrainSelectedInstOperands,
     /*  298472 */     // GIR_Coverage, 9596,
     /*  298472 */     GIR_EraseRootFromParent_Done,
     /*  298473 */   // Label 5594: @298473
     /*  298473 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(298536), // Rule ID 9597 //
     /*  298478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  298481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  298492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  298495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298517 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  298517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298534 */     GIR_RootConstrainSelectedInstOperands,
     /*  298535 */     // GIR_Coverage, 9597,
     /*  298535 */     GIR_EraseRootFromParent_Done,
     /*  298536 */   // Label 5595: @298536
     /*  298536 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(298599), // Rule ID 9600 //
     /*  298541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  298552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  298555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  298558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298580 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  298583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298597 */     GIR_RootConstrainSelectedInstOperands,
     /*  298598 */     // GIR_Coverage, 9600,
     /*  298598 */     GIR_EraseRootFromParent_Done,
     /*  298599 */   // Label 5596: @298599
     /*  298599 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(298662), // Rule ID 9601 //
     /*  298604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  298615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  298618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  298621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298643 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  298646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298660 */     GIR_RootConstrainSelectedInstOperands,
     /*  298661 */     // GIR_Coverage, 9601,
     /*  298661 */     GIR_EraseRootFromParent_Done,
     /*  298662 */   // Label 5597: @298662
     /*  298662 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(298725), // Rule ID 9604 //
     /*  298667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  298678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  298681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  298684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298706 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  298709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298723 */     GIR_RootConstrainSelectedInstOperands,
     /*  298724 */     // GIR_Coverage, 9604,
     /*  298724 */     GIR_EraseRootFromParent_Done,
     /*  298725 */   // Label 5598: @298725
     /*  298725 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(298788), // Rule ID 9605 //
     /*  298730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  298741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  298744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  298747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298769 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  298772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298786 */     GIR_RootConstrainSelectedInstOperands,
     /*  298787 */     // GIR_Coverage, 9605,
     /*  298787 */     GIR_EraseRootFromParent_Done,
     /*  298788 */   // Label 5599: @298788
     /*  298788 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(298851), // Rule ID 9608 //
     /*  298793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  298804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  298807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  298810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298832 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  298835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298849 */     GIR_RootConstrainSelectedInstOperands,
     /*  298850 */     // GIR_Coverage, 9608,
     /*  298850 */     GIR_EraseRootFromParent_Done,
     /*  298851 */   // Label 5600: @298851
     /*  298851 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(298914), // Rule ID 9609 //
     /*  298856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  298867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  298870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  298873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298895 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  298898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298912 */     GIR_RootConstrainSelectedInstOperands,
     /*  298913 */     // GIR_Coverage, 9609,
     /*  298913 */     GIR_EraseRootFromParent_Done,
     /*  298914 */   // Label 5601: @298914
     /*  298914 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(298977), // Rule ID 9612 //
     /*  298919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  298933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  298936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298958 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  298961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298975 */     GIR_RootConstrainSelectedInstOperands,
     /*  298976 */     // GIR_Coverage, 9612,
     /*  298976 */     GIR_EraseRootFromParent_Done,
     /*  298977 */   // Label 5602: @298977
     /*  298977 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(299040), // Rule ID 9613 //
     /*  298982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  298996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  298999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299021 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299038 */     GIR_RootConstrainSelectedInstOperands,
     /*  299039 */     // GIR_Coverage, 9613,
     /*  299039 */     GIR_EraseRootFromParent_Done,
     /*  299040 */   // Label 5603: @299040
     /*  299040 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(299103), // Rule ID 9616 //
     /*  299045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  299059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  299062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299084 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299101 */     GIR_RootConstrainSelectedInstOperands,
     /*  299102 */     // GIR_Coverage, 9616,
     /*  299102 */     GIR_EraseRootFromParent_Done,
     /*  299103 */   // Label 5604: @299103
     /*  299103 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(299166), // Rule ID 9617 //
     /*  299108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  299122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  299125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299147 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299164 */     GIR_RootConstrainSelectedInstOperands,
     /*  299165 */     // GIR_Coverage, 9617,
     /*  299165 */     GIR_EraseRootFromParent_Done,
     /*  299166 */   // Label 5605: @299166
     /*  299166 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(299229), // Rule ID 9620 //
     /*  299171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  299185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  299188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299210 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299227 */     GIR_RootConstrainSelectedInstOperands,
     /*  299228 */     // GIR_Coverage, 9620,
     /*  299228 */     GIR_EraseRootFromParent_Done,
     /*  299229 */   // Label 5606: @299229
     /*  299229 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(299292), // Rule ID 9621 //
     /*  299234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  299248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  299251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299273 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299290 */     GIR_RootConstrainSelectedInstOperands,
     /*  299291 */     // GIR_Coverage, 9621,
     /*  299291 */     GIR_EraseRootFromParent_Done,
     /*  299292 */   // Label 5607: @299292
     /*  299292 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(299355), // Rule ID 9624 //
     /*  299297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  299311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  299314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299336 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299353 */     GIR_RootConstrainSelectedInstOperands,
     /*  299354 */     // GIR_Coverage, 9624,
     /*  299354 */     GIR_EraseRootFromParent_Done,
     /*  299355 */   // Label 5608: @299355
     /*  299355 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(299418), // Rule ID 9625 //
     /*  299360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  299374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  299377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299399 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299416 */     GIR_RootConstrainSelectedInstOperands,
     /*  299417 */     // GIR_Coverage, 9625,
     /*  299417 */     GIR_EraseRootFromParent_Done,
     /*  299418 */   // Label 5609: @299418
     /*  299418 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(299481), // Rule ID 9628 //
     /*  299423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  299437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  299440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299462 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299479 */     GIR_RootConstrainSelectedInstOperands,
     /*  299480 */     // GIR_Coverage, 9628,
     /*  299480 */     GIR_EraseRootFromParent_Done,
     /*  299481 */   // Label 5610: @299481
     /*  299481 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(299544), // Rule ID 9629 //
     /*  299486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  299500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  299503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299525 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299542 */     GIR_RootConstrainSelectedInstOperands,
     /*  299543 */     // GIR_Coverage, 9629,
     /*  299543 */     GIR_EraseRootFromParent_Done,
     /*  299544 */   // Label 5611: @299544
     /*  299544 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(299607), // Rule ID 9632 //
     /*  299549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  299563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  299566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299588 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299605 */     GIR_RootConstrainSelectedInstOperands,
     /*  299606 */     // GIR_Coverage, 9632,
     /*  299606 */     GIR_EraseRootFromParent_Done,
     /*  299607 */   // Label 5612: @299607
     /*  299607 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(299670), // Rule ID 9633 //
     /*  299612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  299626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  299629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299651 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299668 */     GIR_RootConstrainSelectedInstOperands,
     /*  299669 */     // GIR_Coverage, 9633,
     /*  299669 */     GIR_EraseRootFromParent_Done,
     /*  299670 */   // Label 5613: @299670
     /*  299670 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(299733), // Rule ID 9636 //
     /*  299675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  299678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  299689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  299692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299714 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299731 */     GIR_RootConstrainSelectedInstOperands,
     /*  299732 */     // GIR_Coverage, 9636,
     /*  299732 */     GIR_EraseRootFromParent_Done,
     /*  299733 */   // Label 5614: @299733
     /*  299733 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(299796), // Rule ID 9637 //
     /*  299738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  299741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  299752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  299755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299777 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  299777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299794 */     GIR_RootConstrainSelectedInstOperands,
     /*  299795 */     // GIR_Coverage, 9637,
     /*  299795 */     GIR_EraseRootFromParent_Done,
     /*  299796 */   // Label 5615: @299796
     /*  299796 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(299859), // Rule ID 9640 //
     /*  299801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  299804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  299815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  299818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299840 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299857 */     GIR_RootConstrainSelectedInstOperands,
     /*  299858 */     // GIR_Coverage, 9640,
     /*  299858 */     GIR_EraseRootFromParent_Done,
     /*  299859 */   // Label 5616: @299859
     /*  299859 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(299922), // Rule ID 9641 //
     /*  299864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  299867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  299878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  299881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299903 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  299903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299920 */     GIR_RootConstrainSelectedInstOperands,
     /*  299921 */     // GIR_Coverage, 9641,
     /*  299921 */     GIR_EraseRootFromParent_Done,
     /*  299922 */   // Label 5617: @299922
     /*  299922 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(299985), // Rule ID 9644 //
     /*  299927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  299930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  299941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  299944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299966 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299983 */     GIR_RootConstrainSelectedInstOperands,
     /*  299984 */     // GIR_Coverage, 9644,
     /*  299984 */     GIR_EraseRootFromParent_Done,
     /*  299985 */   // Label 5618: @299985
     /*  299985 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(300048), // Rule ID 9645 //
     /*  299990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  299993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  300004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  300007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300029 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  300029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  300032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300046 */     GIR_RootConstrainSelectedInstOperands,
     /*  300047 */     // GIR_Coverage, 9645,
     /*  300047 */     GIR_EraseRootFromParent_Done,
     /*  300048 */   // Label 5619: @300048
     /*  300048 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(300111), // Rule ID 9648 //
     /*  300053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  300067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  300070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300092 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  300095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300109 */     GIR_RootConstrainSelectedInstOperands,
     /*  300110 */     // GIR_Coverage, 9648,
     /*  300110 */     GIR_EraseRootFromParent_Done,
     /*  300111 */   // Label 5620: @300111
     /*  300111 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(300174), // Rule ID 9649 //
     /*  300116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  300130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  300133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300155 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  300158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300172 */     GIR_RootConstrainSelectedInstOperands,
     /*  300173 */     // GIR_Coverage, 9649,
     /*  300173 */     GIR_EraseRootFromParent_Done,
     /*  300174 */   // Label 5621: @300174
     /*  300174 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(300237), // Rule ID 9652 //
     /*  300179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  300193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  300196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300218 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300235 */     GIR_RootConstrainSelectedInstOperands,
     /*  300236 */     // GIR_Coverage, 9652,
     /*  300236 */     GIR_EraseRootFromParent_Done,
     /*  300237 */   // Label 5622: @300237
     /*  300237 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(300300), // Rule ID 9653 //
     /*  300242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  300256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  300259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300281 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300298 */     GIR_RootConstrainSelectedInstOperands,
     /*  300299 */     // GIR_Coverage, 9653,
     /*  300299 */     GIR_EraseRootFromParent_Done,
     /*  300300 */   // Label 5623: @300300
     /*  300300 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(300363), // Rule ID 9656 //
     /*  300305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  300319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  300322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300344 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300361 */     GIR_RootConstrainSelectedInstOperands,
     /*  300362 */     // GIR_Coverage, 9656,
     /*  300362 */     GIR_EraseRootFromParent_Done,
     /*  300363 */   // Label 5624: @300363
     /*  300363 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(300426), // Rule ID 9657 //
     /*  300368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  300382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  300385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300407 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300424 */     GIR_RootConstrainSelectedInstOperands,
     /*  300425 */     // GIR_Coverage, 9657,
     /*  300425 */     GIR_EraseRootFromParent_Done,
     /*  300426 */   // Label 5625: @300426
     /*  300426 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(300489), // Rule ID 9660 //
     /*  300431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  300445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  300448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300470 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300487 */     GIR_RootConstrainSelectedInstOperands,
     /*  300488 */     // GIR_Coverage, 9660,
     /*  300488 */     GIR_EraseRootFromParent_Done,
     /*  300489 */   // Label 5626: @300489
     /*  300489 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(300552), // Rule ID 9661 //
     /*  300494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  300508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  300511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300533 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300550 */     GIR_RootConstrainSelectedInstOperands,
     /*  300551 */     // GIR_Coverage, 9661,
     /*  300551 */     GIR_EraseRootFromParent_Done,
     /*  300552 */   // Label 5627: @300552
     /*  300552 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(300615), // Rule ID 9664 //
     /*  300557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  300571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  300574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300596 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300613 */     GIR_RootConstrainSelectedInstOperands,
     /*  300614 */     // GIR_Coverage, 9664,
     /*  300614 */     GIR_EraseRootFromParent_Done,
     /*  300615 */   // Label 5628: @300615
     /*  300615 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(300678), // Rule ID 9665 //
     /*  300620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  300634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  300637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300659 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300676 */     GIR_RootConstrainSelectedInstOperands,
     /*  300677 */     // GIR_Coverage, 9665,
     /*  300677 */     GIR_EraseRootFromParent_Done,
     /*  300678 */   // Label 5629: @300678
     /*  300678 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(300741), // Rule ID 9668 //
     /*  300683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  300697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  300700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300722 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300739 */     GIR_RootConstrainSelectedInstOperands,
     /*  300740 */     // GIR_Coverage, 9668,
     /*  300740 */     GIR_EraseRootFromParent_Done,
     /*  300741 */   // Label 5630: @300741
     /*  300741 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(300804), // Rule ID 9669 //
     /*  300746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  300760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  300763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300785 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300802 */     GIR_RootConstrainSelectedInstOperands,
     /*  300803 */     // GIR_Coverage, 9669,
     /*  300803 */     GIR_EraseRootFromParent_Done,
     /*  300804 */   // Label 5631: @300804
     /*  300804 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(300867), // Rule ID 9672 //
     /*  300809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  300823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  300826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300848 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300865 */     GIR_RootConstrainSelectedInstOperands,
     /*  300866 */     // GIR_Coverage, 9672,
     /*  300866 */     GIR_EraseRootFromParent_Done,
     /*  300867 */   // Label 5632: @300867
     /*  300867 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(300930), // Rule ID 9673 //
     /*  300872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  300886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  300889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300911 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300928 */     GIR_RootConstrainSelectedInstOperands,
     /*  300929 */     // GIR_Coverage, 9673,
     /*  300929 */     GIR_EraseRootFromParent_Done,
     /*  300930 */   // Label 5633: @300930
     /*  300930 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(300993), // Rule ID 9676 //
     /*  300935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  300949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  300952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300974 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300991 */     GIR_RootConstrainSelectedInstOperands,
     /*  300992 */     // GIR_Coverage, 9676,
     /*  300992 */     GIR_EraseRootFromParent_Done,
     /*  300993 */   // Label 5634: @300993
     /*  300993 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(301056), // Rule ID 9677 //
     /*  300998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  301009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  301012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  301015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301037 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301054 */     GIR_RootConstrainSelectedInstOperands,
     /*  301055 */     // GIR_Coverage, 9677,
     /*  301055 */     GIR_EraseRootFromParent_Done,
     /*  301056 */   // Label 5635: @301056
     /*  301056 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(301119), // Rule ID 9680 //
     /*  301061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  301075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  301078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301100 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  301100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301117 */     GIR_RootConstrainSelectedInstOperands,
     /*  301118 */     // GIR_Coverage, 9680,
     /*  301118 */     GIR_EraseRootFromParent_Done,
     /*  301119 */   // Label 5636: @301119
     /*  301119 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(301182), // Rule ID 9681 //
     /*  301124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  301138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  301141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301163 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  301163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301180 */     GIR_RootConstrainSelectedInstOperands,
     /*  301181 */     // GIR_Coverage, 9681,
     /*  301181 */     GIR_EraseRootFromParent_Done,
     /*  301182 */   // Label 5637: @301182
     /*  301182 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(301245), // Rule ID 9684 //
     /*  301187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  301190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  301201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  301204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301226 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  301226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301243 */     GIR_RootConstrainSelectedInstOperands,
     /*  301244 */     // GIR_Coverage, 9684,
     /*  301244 */     GIR_EraseRootFromParent_Done,
     /*  301245 */   // Label 5638: @301245
     /*  301245 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(301308), // Rule ID 9685 //
     /*  301250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  301253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  301264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  301267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301289 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  301289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301306 */     GIR_RootConstrainSelectedInstOperands,
     /*  301307 */     // GIR_Coverage, 9685,
     /*  301307 */     GIR_EraseRootFromParent_Done,
     /*  301308 */   // Label 5639: @301308
     /*  301308 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(301371), // Rule ID 9688 //
     /*  301313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  301327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  301330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301352 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301369 */     GIR_RootConstrainSelectedInstOperands,
     /*  301370 */     // GIR_Coverage, 9688,
     /*  301370 */     GIR_EraseRootFromParent_Done,
     /*  301371 */   // Label 5640: @301371
     /*  301371 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(301434), // Rule ID 9689 //
     /*  301376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  301390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  301393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301415 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301432 */     GIR_RootConstrainSelectedInstOperands,
     /*  301433 */     // GIR_Coverage, 9689,
     /*  301433 */     GIR_EraseRootFromParent_Done,
     /*  301434 */   // Label 5641: @301434
     /*  301434 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(301497), // Rule ID 9692 //
     /*  301439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  301450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  301453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  301456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301478 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301495 */     GIR_RootConstrainSelectedInstOperands,
     /*  301496 */     // GIR_Coverage, 9692,
     /*  301496 */     GIR_EraseRootFromParent_Done,
     /*  301497 */   // Label 5642: @301497
     /*  301497 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(301560), // Rule ID 9693 //
     /*  301502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  301513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  301516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  301519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301541 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301558 */     GIR_RootConstrainSelectedInstOperands,
     /*  301559 */     // GIR_Coverage, 9693,
     /*  301559 */     GIR_EraseRootFromParent_Done,
     /*  301560 */   // Label 5643: @301560
     /*  301560 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(301623), // Rule ID 9696 //
     /*  301565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  301576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  301579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  301582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301604 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  301607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301621 */     GIR_RootConstrainSelectedInstOperands,
     /*  301622 */     // GIR_Coverage, 9696,
     /*  301622 */     GIR_EraseRootFromParent_Done,
     /*  301623 */   // Label 5644: @301623
     /*  301623 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(301686), // Rule ID 9697 //
     /*  301628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  301639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  301642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  301645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301667 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  301670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301684 */     GIR_RootConstrainSelectedInstOperands,
     /*  301685 */     // GIR_Coverage, 9697,
     /*  301685 */     GIR_EraseRootFromParent_Done,
     /*  301686 */   // Label 5645: @301686
     /*  301686 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(301749), // Rule ID 9700 //
     /*  301691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  301705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  301708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301730 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301747 */     GIR_RootConstrainSelectedInstOperands,
     /*  301748 */     // GIR_Coverage, 9700,
     /*  301748 */     GIR_EraseRootFromParent_Done,
     /*  301749 */   // Label 5646: @301749
     /*  301749 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(301812), // Rule ID 9701 //
     /*  301754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  301768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  301771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301793 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301810 */     GIR_RootConstrainSelectedInstOperands,
     /*  301811 */     // GIR_Coverage, 9701,
     /*  301811 */     GIR_EraseRootFromParent_Done,
     /*  301812 */   // Label 5647: @301812
     /*  301812 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(301875), // Rule ID 9704 //
     /*  301817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  301831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  301834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301856 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301873 */     GIR_RootConstrainSelectedInstOperands,
     /*  301874 */     // GIR_Coverage, 9704,
     /*  301874 */     GIR_EraseRootFromParent_Done,
     /*  301875 */   // Label 5648: @301875
     /*  301875 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(301938), // Rule ID 9705 //
     /*  301880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  301894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  301897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301919 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301936 */     GIR_RootConstrainSelectedInstOperands,
     /*  301937 */     // GIR_Coverage, 9705,
     /*  301937 */     GIR_EraseRootFromParent_Done,
     /*  301938 */   // Label 5649: @301938
     /*  301938 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(302001), // Rule ID 9708 //
     /*  301943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  301954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  301957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  301960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301982 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  301985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301999 */     GIR_RootConstrainSelectedInstOperands,
     /*  302000 */     // GIR_Coverage, 9708,
     /*  302000 */     GIR_EraseRootFromParent_Done,
     /*  302001 */   // Label 5650: @302001
     /*  302001 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(302064), // Rule ID 9709 //
     /*  302006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  302017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  302020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  302023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302045 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302062 */     GIR_RootConstrainSelectedInstOperands,
     /*  302063 */     // GIR_Coverage, 9709,
     /*  302063 */     GIR_EraseRootFromParent_Done,
     /*  302064 */   // Label 5651: @302064
     /*  302064 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(302127), // Rule ID 9712 //
     /*  302069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  302083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  302086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302108 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302125 */     GIR_RootConstrainSelectedInstOperands,
     /*  302126 */     // GIR_Coverage, 9712,
     /*  302126 */     GIR_EraseRootFromParent_Done,
     /*  302127 */   // Label 5652: @302127
     /*  302127 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(302190), // Rule ID 9713 //
     /*  302132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  302146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  302149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302171 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302188 */     GIR_RootConstrainSelectedInstOperands,
     /*  302189 */     // GIR_Coverage, 9713,
     /*  302189 */     GIR_EraseRootFromParent_Done,
     /*  302190 */   // Label 5653: @302190
     /*  302190 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(302253), // Rule ID 9716 //
     /*  302195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  302209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  302212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302234 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302251 */     GIR_RootConstrainSelectedInstOperands,
     /*  302252 */     // GIR_Coverage, 9716,
     /*  302252 */     GIR_EraseRootFromParent_Done,
     /*  302253 */   // Label 5654: @302253
     /*  302253 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(302316), // Rule ID 9717 //
     /*  302258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  302272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  302275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302297 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302314 */     GIR_RootConstrainSelectedInstOperands,
     /*  302315 */     // GIR_Coverage, 9717,
     /*  302315 */     GIR_EraseRootFromParent_Done,
     /*  302316 */   // Label 5655: @302316
     /*  302316 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(302379), // Rule ID 9720 //
     /*  302321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  302335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  302338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302360 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302377 */     GIR_RootConstrainSelectedInstOperands,
     /*  302378 */     // GIR_Coverage, 9720,
     /*  302378 */     GIR_EraseRootFromParent_Done,
     /*  302379 */   // Label 5656: @302379
     /*  302379 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(302442), // Rule ID 9721 //
     /*  302384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  302398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  302401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302423 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302440 */     GIR_RootConstrainSelectedInstOperands,
     /*  302441 */     // GIR_Coverage, 9721,
     /*  302441 */     GIR_EraseRootFromParent_Done,
     /*  302442 */   // Label 5657: @302442
     /*  302442 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(302505), // Rule ID 9724 //
     /*  302447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  302450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  302461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  302464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302486 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302503 */     GIR_RootConstrainSelectedInstOperands,
     /*  302504 */     // GIR_Coverage, 9724,
     /*  302504 */     GIR_EraseRootFromParent_Done,
     /*  302505 */   // Label 5658: @302505
     /*  302505 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(302568), // Rule ID 9725 //
     /*  302510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  302513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  302524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  302527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302549 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302566 */     GIR_RootConstrainSelectedInstOperands,
     /*  302567 */     // GIR_Coverage, 9725,
     /*  302567 */     GIR_EraseRootFromParent_Done,
     /*  302568 */   // Label 5659: @302568
     /*  302568 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(302631), // Rule ID 9728 //
     /*  302573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  302576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  302587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  302590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302612 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302629 */     GIR_RootConstrainSelectedInstOperands,
     /*  302630 */     // GIR_Coverage, 9728,
     /*  302630 */     GIR_EraseRootFromParent_Done,
     /*  302631 */   // Label 5660: @302631
     /*  302631 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(302694), // Rule ID 9729 //
     /*  302636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  302639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  302650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  302653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302675 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302692 */     GIR_RootConstrainSelectedInstOperands,
     /*  302693 */     // GIR_Coverage, 9729,
     /*  302693 */     GIR_EraseRootFromParent_Done,
     /*  302694 */   // Label 5661: @302694
     /*  302694 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(302757), // Rule ID 9732 //
     /*  302699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  302702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  302713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  302716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302755 */     GIR_RootConstrainSelectedInstOperands,
     /*  302756 */     // GIR_Coverage, 9732,
     /*  302756 */     GIR_EraseRootFromParent_Done,
     /*  302757 */   // Label 5662: @302757
     /*  302757 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(302820), // Rule ID 9733 //
     /*  302762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  302765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  302776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  302779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302801 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302818 */     GIR_RootConstrainSelectedInstOperands,
     /*  302819 */     // GIR_Coverage, 9733,
     /*  302819 */     GIR_EraseRootFromParent_Done,
     /*  302820 */   // Label 5663: @302820
     /*  302820 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(302883), // Rule ID 9736 //
     /*  302825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  302836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  302839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  302842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302864 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  302867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302881 */     GIR_RootConstrainSelectedInstOperands,
     /*  302882 */     // GIR_Coverage, 9736,
     /*  302882 */     GIR_EraseRootFromParent_Done,
     /*  302883 */   // Label 5664: @302883
     /*  302883 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(302946), // Rule ID 9737 //
     /*  302888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  302899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  302902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  302905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302927 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  302930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302944 */     GIR_RootConstrainSelectedInstOperands,
     /*  302945 */     // GIR_Coverage, 9737,
     /*  302945 */     GIR_EraseRootFromParent_Done,
     /*  302946 */   // Label 5665: @302946
     /*  302946 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(303009), // Rule ID 9740 //
     /*  302951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  302965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  302968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302990 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  302993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303007 */     GIR_RootConstrainSelectedInstOperands,
     /*  303008 */     // GIR_Coverage, 9740,
     /*  303008 */     GIR_EraseRootFromParent_Done,
     /*  303009 */   // Label 5666: @303009
     /*  303009 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(303072), // Rule ID 9741 //
     /*  303014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  303028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  303031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303053 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303070 */     GIR_RootConstrainSelectedInstOperands,
     /*  303071 */     // GIR_Coverage, 9741,
     /*  303071 */     GIR_EraseRootFromParent_Done,
     /*  303072 */   // Label 5667: @303072
     /*  303072 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(303135), // Rule ID 9744 //
     /*  303077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  303091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  303094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303116 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303133 */     GIR_RootConstrainSelectedInstOperands,
     /*  303134 */     // GIR_Coverage, 9744,
     /*  303134 */     GIR_EraseRootFromParent_Done,
     /*  303135 */   // Label 5668: @303135
     /*  303135 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(303198), // Rule ID 9745 //
     /*  303140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  303154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  303157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303179 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303196 */     GIR_RootConstrainSelectedInstOperands,
     /*  303197 */     // GIR_Coverage, 9745,
     /*  303197 */     GIR_EraseRootFromParent_Done,
     /*  303198 */   // Label 5669: @303198
     /*  303198 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(303261), // Rule ID 9748 //
     /*  303203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  303217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  303220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303242 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303259 */     GIR_RootConstrainSelectedInstOperands,
     /*  303260 */     // GIR_Coverage, 9748,
     /*  303260 */     GIR_EraseRootFromParent_Done,
     /*  303261 */   // Label 5670: @303261
     /*  303261 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(303324), // Rule ID 9749 //
     /*  303266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  303280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  303283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303305 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  303305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303322 */     GIR_RootConstrainSelectedInstOperands,
     /*  303323 */     // GIR_Coverage, 9749,
     /*  303323 */     GIR_EraseRootFromParent_Done,
     /*  303324 */   // Label 5671: @303324
     /*  303324 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(303387), // Rule ID 9752 //
     /*  303329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  303343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  303346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303385 */     GIR_RootConstrainSelectedInstOperands,
     /*  303386 */     // GIR_Coverage, 9752,
     /*  303386 */     GIR_EraseRootFromParent_Done,
     /*  303387 */   // Label 5672: @303387
     /*  303387 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(303450), // Rule ID 9753 //
     /*  303392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  303406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  303409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303431 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  303431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303448 */     GIR_RootConstrainSelectedInstOperands,
     /*  303449 */     // GIR_Coverage, 9753,
     /*  303449 */     GIR_EraseRootFromParent_Done,
     /*  303450 */   // Label 5673: @303450
     /*  303450 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(303513), // Rule ID 9756 //
     /*  303455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  303469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  303472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303494 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  303494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303511 */     GIR_RootConstrainSelectedInstOperands,
     /*  303512 */     // GIR_Coverage, 9756,
     /*  303512 */     GIR_EraseRootFromParent_Done,
     /*  303513 */   // Label 5674: @303513
     /*  303513 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(303576), // Rule ID 9757 //
     /*  303518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  303532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  303535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303557 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  303557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303574 */     GIR_RootConstrainSelectedInstOperands,
     /*  303575 */     // GIR_Coverage, 9757,
     /*  303575 */     GIR_EraseRootFromParent_Done,
     /*  303576 */   // Label 5675: @303576
     /*  303576 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(303639), // Rule ID 9760 //
     /*  303581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  303595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  303598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303637 */     GIR_RootConstrainSelectedInstOperands,
     /*  303638 */     // GIR_Coverage, 9760,
     /*  303638 */     GIR_EraseRootFromParent_Done,
     /*  303639 */   // Label 5676: @303639
     /*  303639 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(303702), // Rule ID 9761 //
     /*  303644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  303658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  303661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303683 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303700 */     GIR_RootConstrainSelectedInstOperands,
     /*  303701 */     // GIR_Coverage, 9761,
     /*  303701 */     GIR_EraseRootFromParent_Done,
     /*  303702 */   // Label 5677: @303702
     /*  303702 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(303765), // Rule ID 9764 //
     /*  303707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  303721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  303724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303746 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303763 */     GIR_RootConstrainSelectedInstOperands,
     /*  303764 */     // GIR_Coverage, 9764,
     /*  303764 */     GIR_EraseRootFromParent_Done,
     /*  303765 */   // Label 5678: @303765
     /*  303765 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(303828), // Rule ID 9765 //
     /*  303770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  303784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  303787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303809 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  303809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303826 */     GIR_RootConstrainSelectedInstOperands,
     /*  303827 */     // GIR_Coverage, 9765,
     /*  303827 */     GIR_EraseRootFromParent_Done,
     /*  303828 */   // Label 5679: @303828
     /*  303828 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(303891), // Rule ID 9768 //
     /*  303833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  303847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  303850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  303872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303889 */     GIR_RootConstrainSelectedInstOperands,
     /*  303890 */     // GIR_Coverage, 9768,
     /*  303890 */     GIR_EraseRootFromParent_Done,
     /*  303891 */   // Label 5680: @303891
     /*  303891 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(303954), // Rule ID 9769 //
     /*  303896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  303910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  303913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303935 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  303935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303952 */     GIR_RootConstrainSelectedInstOperands,
     /*  303953 */     // GIR_Coverage, 9769,
     /*  303953 */     GIR_EraseRootFromParent_Done,
     /*  303954 */   // Label 5681: @303954
     /*  303954 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(304017), // Rule ID 9772 //
     /*  303959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  303962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  303973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  303976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303998 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  303998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304015 */     GIR_RootConstrainSelectedInstOperands,
     /*  304016 */     // GIR_Coverage, 9772,
     /*  304016 */     GIR_EraseRootFromParent_Done,
     /*  304017 */   // Label 5682: @304017
     /*  304017 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(304080), // Rule ID 9773 //
     /*  304022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  304025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  304036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  304039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304061 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  304061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304078 */     GIR_RootConstrainSelectedInstOperands,
     /*  304079 */     // GIR_Coverage, 9773,
     /*  304079 */     GIR_EraseRootFromParent_Done,
     /*  304080 */   // Label 5683: @304080
     /*  304080 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(304143), // Rule ID 9776 //
     /*  304085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  304099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  304102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304124 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304141 */     GIR_RootConstrainSelectedInstOperands,
     /*  304142 */     // GIR_Coverage, 9776,
     /*  304142 */     GIR_EraseRootFromParent_Done,
     /*  304143 */   // Label 5684: @304143
     /*  304143 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(304206), // Rule ID 9777 //
     /*  304148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  304162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  304165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304187 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304204 */     GIR_RootConstrainSelectedInstOperands,
     /*  304205 */     // GIR_Coverage, 9777,
     /*  304205 */     GIR_EraseRootFromParent_Done,
     /*  304206 */   // Label 5685: @304206
     /*  304206 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(304269), // Rule ID 9780 //
     /*  304211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  304225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  304228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304250 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304267 */     GIR_RootConstrainSelectedInstOperands,
     /*  304268 */     // GIR_Coverage, 9780,
     /*  304268 */     GIR_EraseRootFromParent_Done,
     /*  304269 */   // Label 5686: @304269
     /*  304269 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(304332), // Rule ID 9781 //
     /*  304274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  304288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  304291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304313 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304330 */     GIR_RootConstrainSelectedInstOperands,
     /*  304331 */     // GIR_Coverage, 9781,
     /*  304331 */     GIR_EraseRootFromParent_Done,
     /*  304332 */   // Label 5687: @304332
     /*  304332 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(304395), // Rule ID 9784 //
     /*  304337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  304348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  304351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  304354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304376 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304393 */     GIR_RootConstrainSelectedInstOperands,
     /*  304394 */     // GIR_Coverage, 9784,
     /*  304394 */     GIR_EraseRootFromParent_Done,
     /*  304395 */   // Label 5688: @304395
     /*  304395 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(304458), // Rule ID 9785 //
     /*  304400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  304411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  304414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  304417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304439 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304456 */     GIR_RootConstrainSelectedInstOperands,
     /*  304457 */     // GIR_Coverage, 9785,
     /*  304457 */     GIR_EraseRootFromParent_Done,
     /*  304458 */   // Label 5689: @304458
     /*  304458 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(304521), // Rule ID 9788 //
     /*  304463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  304477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  304480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304502 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304519 */     GIR_RootConstrainSelectedInstOperands,
     /*  304520 */     // GIR_Coverage, 9788,
     /*  304520 */     GIR_EraseRootFromParent_Done,
     /*  304521 */   // Label 5690: @304521
     /*  304521 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(304584), // Rule ID 9789 //
     /*  304526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  304540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  304543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304565 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304582 */     GIR_RootConstrainSelectedInstOperands,
     /*  304583 */     // GIR_Coverage, 9789,
     /*  304583 */     GIR_EraseRootFromParent_Done,
     /*  304584 */   // Label 5691: @304584
     /*  304584 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(304647), // Rule ID 9792 //
     /*  304589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  304603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  304606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304628 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304645 */     GIR_RootConstrainSelectedInstOperands,
     /*  304646 */     // GIR_Coverage, 9792,
     /*  304646 */     GIR_EraseRootFromParent_Done,
     /*  304647 */   // Label 5692: @304647
     /*  304647 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(304710), // Rule ID 9793 //
     /*  304652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  304666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  304669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304691 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304708 */     GIR_RootConstrainSelectedInstOperands,
     /*  304709 */     // GIR_Coverage, 9793,
     /*  304709 */     GIR_EraseRootFromParent_Done,
     /*  304710 */   // Label 5693: @304710
     /*  304710 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(304773), // Rule ID 9796 //
     /*  304715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  304729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  304732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304754 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304771 */     GIR_RootConstrainSelectedInstOperands,
     /*  304772 */     // GIR_Coverage, 9796,
     /*  304772 */     GIR_EraseRootFromParent_Done,
     /*  304773 */   // Label 5694: @304773
     /*  304773 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(304836), // Rule ID 9797 //
     /*  304778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  304792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  304795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304817 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304834 */     GIR_RootConstrainSelectedInstOperands,
     /*  304835 */     // GIR_Coverage, 9797,
     /*  304835 */     GIR_EraseRootFromParent_Done,
     /*  304836 */   // Label 5695: @304836
     /*  304836 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(304899), // Rule ID 9800 //
     /*  304841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  304855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  304858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304880 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  304880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304897 */     GIR_RootConstrainSelectedInstOperands,
     /*  304898 */     // GIR_Coverage, 9800,
     /*  304898 */     GIR_EraseRootFromParent_Done,
     /*  304899 */   // Label 5696: @304899
     /*  304899 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(304962), // Rule ID 9801 //
     /*  304904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  304918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  304921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304943 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  304943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304960 */     GIR_RootConstrainSelectedInstOperands,
     /*  304961 */     // GIR_Coverage, 9801,
     /*  304961 */     GIR_EraseRootFromParent_Done,
     /*  304962 */   // Label 5697: @304962
     /*  304962 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(305025), // Rule ID 9804 //
     /*  304967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  304981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  304984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305006 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  305006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305023 */     GIR_RootConstrainSelectedInstOperands,
     /*  305024 */     // GIR_Coverage, 9804,
     /*  305024 */     GIR_EraseRootFromParent_Done,
     /*  305025 */   // Label 5698: @305025
     /*  305025 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(305088), // Rule ID 9805 //
     /*  305030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  305044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  305047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305069 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  305069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305086 */     GIR_RootConstrainSelectedInstOperands,
     /*  305087 */     // GIR_Coverage, 9805,
     /*  305087 */     GIR_EraseRootFromParent_Done,
     /*  305088 */   // Label 5699: @305088
     /*  305088 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(305151), // Rule ID 9808 //
     /*  305093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  305107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  305110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305132 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  305132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305149 */     GIR_RootConstrainSelectedInstOperands,
     /*  305150 */     // GIR_Coverage, 9808,
     /*  305150 */     GIR_EraseRootFromParent_Done,
     /*  305151 */   // Label 5700: @305151
     /*  305151 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(305214), // Rule ID 9809 //
     /*  305156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  305170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  305173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305195 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  305195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305212 */     GIR_RootConstrainSelectedInstOperands,
     /*  305213 */     // GIR_Coverage, 9809,
     /*  305213 */     GIR_EraseRootFromParent_Done,
     /*  305214 */   // Label 5701: @305214
     /*  305214 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(305277), // Rule ID 9812 //
     /*  305219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  305233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  305236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305258 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305275 */     GIR_RootConstrainSelectedInstOperands,
     /*  305276 */     // GIR_Coverage, 9812,
     /*  305276 */     GIR_EraseRootFromParent_Done,
     /*  305277 */   // Label 5702: @305277
     /*  305277 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(305340), // Rule ID 9813 //
     /*  305282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  305296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  305299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305321 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  305321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305338 */     GIR_RootConstrainSelectedInstOperands,
     /*  305339 */     // GIR_Coverage, 9813,
     /*  305339 */     GIR_EraseRootFromParent_Done,
     /*  305340 */   // Label 5703: @305340
     /*  305340 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(305403), // Rule ID 9816 //
     /*  305345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  305359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  305362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305384 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305401 */     GIR_RootConstrainSelectedInstOperands,
     /*  305402 */     // GIR_Coverage, 9816,
     /*  305402 */     GIR_EraseRootFromParent_Done,
     /*  305403 */   // Label 5704: @305403
     /*  305403 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(305466), // Rule ID 9817 //
     /*  305408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  305422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  305425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305447 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  305447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305464 */     GIR_RootConstrainSelectedInstOperands,
     /*  305465 */     // GIR_Coverage, 9817,
     /*  305465 */     GIR_EraseRootFromParent_Done,
     /*  305466 */   // Label 5705: @305466
     /*  305466 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(305529), // Rule ID 9820 //
     /*  305471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  305485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  305488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305510 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305527 */     GIR_RootConstrainSelectedInstOperands,
     /*  305528 */     // GIR_Coverage, 9820,
     /*  305528 */     GIR_EraseRootFromParent_Done,
     /*  305529 */   // Label 5706: @305529
     /*  305529 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(305592), // Rule ID 9821 //
     /*  305534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  305548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  305551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305573 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  305573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305590 */     GIR_RootConstrainSelectedInstOperands,
     /*  305591 */     // GIR_Coverage, 9821,
     /*  305591 */     GIR_EraseRootFromParent_Done,
     /*  305592 */   // Label 5707: @305592
     /*  305592 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(305655), // Rule ID 9824 //
     /*  305597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  305611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  305614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305636 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  305639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305653 */     GIR_RootConstrainSelectedInstOperands,
     /*  305654 */     // GIR_Coverage, 9824,
     /*  305654 */     GIR_EraseRootFromParent_Done,
     /*  305655 */   // Label 5708: @305655
     /*  305655 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(305718), // Rule ID 9825 //
     /*  305660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  305674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  305677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305699 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  305702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305716 */     GIR_RootConstrainSelectedInstOperands,
     /*  305717 */     // GIR_Coverage, 9825,
     /*  305717 */     GIR_EraseRootFromParent_Done,
     /*  305718 */   // Label 5709: @305718
     /*  305718 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(305781), // Rule ID 9828 //
     /*  305723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  305737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  305740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305762 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  305765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305779 */     GIR_RootConstrainSelectedInstOperands,
     /*  305780 */     // GIR_Coverage, 9828,
     /*  305780 */     GIR_EraseRootFromParent_Done,
     /*  305781 */   // Label 5710: @305781
     /*  305781 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(305844), // Rule ID 9829 //
     /*  305786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  305800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  305803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305825 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  305828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305842 */     GIR_RootConstrainSelectedInstOperands,
     /*  305843 */     // GIR_Coverage, 9829,
     /*  305843 */     GIR_EraseRootFromParent_Done,
     /*  305844 */   // Label 5711: @305844
     /*  305844 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(305907), // Rule ID 9832 //
     /*  305849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  305863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  305866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305888 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  305891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305905 */     GIR_RootConstrainSelectedInstOperands,
     /*  305906 */     // GIR_Coverage, 9832,
     /*  305906 */     GIR_EraseRootFromParent_Done,
     /*  305907 */   // Label 5712: @305907
     /*  305907 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(305970), // Rule ID 9833 //
     /*  305912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  305926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  305929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305951 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  305954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305968 */     GIR_RootConstrainSelectedInstOperands,
     /*  305969 */     // GIR_Coverage, 9833,
     /*  305969 */     GIR_EraseRootFromParent_Done,
     /*  305970 */   // Label 5713: @305970
     /*  305970 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(306033), // Rule ID 9836 //
     /*  305975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  305989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  305992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  306017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306031 */     GIR_RootConstrainSelectedInstOperands,
     /*  306032 */     // GIR_Coverage, 9836,
     /*  306032 */     GIR_EraseRootFromParent_Done,
     /*  306033 */   // Label 5714: @306033
     /*  306033 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(306096), // Rule ID 9837 //
     /*  306038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  306052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  306055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306077 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  306077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  306080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306094 */     GIR_RootConstrainSelectedInstOperands,
     /*  306095 */     // GIR_Coverage, 9837,
     /*  306095 */     GIR_EraseRootFromParent_Done,
     /*  306096 */   // Label 5715: @306096
     /*  306096 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(306159), // Rule ID 9840 //
     /*  306101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  306115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  306118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306140 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306157 */     GIR_RootConstrainSelectedInstOperands,
     /*  306158 */     // GIR_Coverage, 9840,
     /*  306158 */     GIR_EraseRootFromParent_Done,
     /*  306159 */   // Label 5716: @306159
     /*  306159 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(306222), // Rule ID 9841 //
     /*  306164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  306178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  306181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306203 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  306203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306220 */     GIR_RootConstrainSelectedInstOperands,
     /*  306221 */     // GIR_Coverage, 9841,
     /*  306221 */     GIR_EraseRootFromParent_Done,
     /*  306222 */   // Label 5717: @306222
     /*  306222 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(306285), // Rule ID 9844 //
     /*  306227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  306241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  306244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306266 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  306266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306283 */     GIR_RootConstrainSelectedInstOperands,
     /*  306284 */     // GIR_Coverage, 9844,
     /*  306284 */     GIR_EraseRootFromParent_Done,
     /*  306285 */   // Label 5718: @306285
     /*  306285 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(306348), // Rule ID 9845 //
     /*  306290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  306304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  306307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306329 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  306329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306346 */     GIR_RootConstrainSelectedInstOperands,
     /*  306347 */     // GIR_Coverage, 9845,
     /*  306347 */     GIR_EraseRootFromParent_Done,
     /*  306348 */   // Label 5719: @306348
     /*  306348 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(306411), // Rule ID 9848 //
     /*  306353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  306367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  306370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306392 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306409 */     GIR_RootConstrainSelectedInstOperands,
     /*  306410 */     // GIR_Coverage, 9848,
     /*  306410 */     GIR_EraseRootFromParent_Done,
     /*  306411 */   // Label 5720: @306411
     /*  306411 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(306474), // Rule ID 9849 //
     /*  306416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  306430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  306433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306455 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306472 */     GIR_RootConstrainSelectedInstOperands,
     /*  306473 */     // GIR_Coverage, 9849,
     /*  306473 */     GIR_EraseRootFromParent_Done,
     /*  306474 */   // Label 5721: @306474
     /*  306474 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(306537), // Rule ID 9852 //
     /*  306479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  306493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  306496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306518 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306535 */     GIR_RootConstrainSelectedInstOperands,
     /*  306536 */     // GIR_Coverage, 9852,
     /*  306536 */     GIR_EraseRootFromParent_Done,
     /*  306537 */   // Label 5722: @306537
     /*  306537 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(306600), // Rule ID 9853 //
     /*  306542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  306556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  306559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306581 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  306581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306598 */     GIR_RootConstrainSelectedInstOperands,
     /*  306599 */     // GIR_Coverage, 9853,
     /*  306599 */     GIR_EraseRootFromParent_Done,
     /*  306600 */   // Label 5723: @306600
     /*  306600 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(306663), // Rule ID 9856 //
     /*  306605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  306619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  306622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306644 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  306644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306661 */     GIR_RootConstrainSelectedInstOperands,
     /*  306662 */     // GIR_Coverage, 9856,
     /*  306662 */     GIR_EraseRootFromParent_Done,
     /*  306663 */   // Label 5724: @306663
     /*  306663 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(306726), // Rule ID 9857 //
     /*  306668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  306682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  306685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306707 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  306707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306724 */     GIR_RootConstrainSelectedInstOperands,
     /*  306725 */     // GIR_Coverage, 9857,
     /*  306725 */     GIR_EraseRootFromParent_Done,
     /*  306726 */   // Label 5725: @306726
     /*  306726 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(306789), // Rule ID 9860 //
     /*  306731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  306734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  306745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  306748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306770 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  306770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306787 */     GIR_RootConstrainSelectedInstOperands,
     /*  306788 */     // GIR_Coverage, 9860,
     /*  306788 */     GIR_EraseRootFromParent_Done,
     /*  306789 */   // Label 5726: @306789
     /*  306789 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(306852), // Rule ID 9861 //
     /*  306794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  306797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  306808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  306811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306833 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  306833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306850 */     GIR_RootConstrainSelectedInstOperands,
     /*  306851 */     // GIR_Coverage, 9861,
     /*  306851 */     GIR_EraseRootFromParent_Done,
     /*  306852 */   // Label 5727: @306852
     /*  306852 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(306915), // Rule ID 9864 //
     /*  306857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  306868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  306871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  306874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306896 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  306899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306913 */     GIR_RootConstrainSelectedInstOperands,
     /*  306914 */     // GIR_Coverage, 9864,
     /*  306914 */     GIR_EraseRootFromParent_Done,
     /*  306915 */   // Label 5728: @306915
     /*  306915 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(306978), // Rule ID 9865 //
     /*  306920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  306931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  306934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  306937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306959 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  306962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306976 */     GIR_RootConstrainSelectedInstOperands,
     /*  306977 */     // GIR_Coverage, 9865,
     /*  306977 */     GIR_EraseRootFromParent_Done,
     /*  306978 */   // Label 5729: @306978
     /*  306978 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(307041), // Rule ID 9868 //
     /*  306983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  306994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  306997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  307000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307022 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307039 */     GIR_RootConstrainSelectedInstOperands,
     /*  307040 */     // GIR_Coverage, 9868,
     /*  307040 */     GIR_EraseRootFromParent_Done,
     /*  307041 */   // Label 5730: @307041
     /*  307041 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(307104), // Rule ID 9869 //
     /*  307046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  307057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  307060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  307063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307085 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307102 */     GIR_RootConstrainSelectedInstOperands,
     /*  307103 */     // GIR_Coverage, 9869,
     /*  307103 */     GIR_EraseRootFromParent_Done,
     /*  307104 */   // Label 5731: @307104
     /*  307104 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(307167), // Rule ID 9872 //
     /*  307109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  307120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  307123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  307126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307148 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307165 */     GIR_RootConstrainSelectedInstOperands,
     /*  307166 */     // GIR_Coverage, 9872,
     /*  307166 */     GIR_EraseRootFromParent_Done,
     /*  307167 */   // Label 5732: @307167
     /*  307167 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(307230), // Rule ID 9873 //
     /*  307172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  307183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  307186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  307189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307211 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307228 */     GIR_RootConstrainSelectedInstOperands,
     /*  307229 */     // GIR_Coverage, 9873,
     /*  307229 */     GIR_EraseRootFromParent_Done,
     /*  307230 */   // Label 5733: @307230
     /*  307230 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(307293), // Rule ID 9876 //
     /*  307235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  307249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  307252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307274 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307291 */     GIR_RootConstrainSelectedInstOperands,
     /*  307292 */     // GIR_Coverage, 9876,
     /*  307292 */     GIR_EraseRootFromParent_Done,
     /*  307293 */   // Label 5734: @307293
     /*  307293 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(307356), // Rule ID 9877 //
     /*  307298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  307312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  307315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307337 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307354 */     GIR_RootConstrainSelectedInstOperands,
     /*  307355 */     // GIR_Coverage, 9877,
     /*  307355 */     GIR_EraseRootFromParent_Done,
     /*  307356 */   // Label 5735: @307356
     /*  307356 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(307419), // Rule ID 9880 //
     /*  307361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  307375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  307378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307400 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307417 */     GIR_RootConstrainSelectedInstOperands,
     /*  307418 */     // GIR_Coverage, 9880,
     /*  307418 */     GIR_EraseRootFromParent_Done,
     /*  307419 */   // Label 5736: @307419
     /*  307419 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(307482), // Rule ID 9881 //
     /*  307424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  307438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  307441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307463 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307480 */     GIR_RootConstrainSelectedInstOperands,
     /*  307481 */     // GIR_Coverage, 9881,
     /*  307481 */     GIR_EraseRootFromParent_Done,
     /*  307482 */   // Label 5737: @307482
     /*  307482 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(307545), // Rule ID 9884 //
     /*  307487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  307498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  307501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  307504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307526 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307543 */     GIR_RootConstrainSelectedInstOperands,
     /*  307544 */     // GIR_Coverage, 9884,
     /*  307544 */     GIR_EraseRootFromParent_Done,
     /*  307545 */   // Label 5738: @307545
     /*  307545 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(307608), // Rule ID 9885 //
     /*  307550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  307561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  307564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  307567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307589 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307606 */     GIR_RootConstrainSelectedInstOperands,
     /*  307607 */     // GIR_Coverage, 9885,
     /*  307607 */     GIR_EraseRootFromParent_Done,
     /*  307608 */   // Label 5739: @307608
     /*  307608 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(307671), // Rule ID 9888 //
     /*  307613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  307627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  307630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307652 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307669 */     GIR_RootConstrainSelectedInstOperands,
     /*  307670 */     // GIR_Coverage, 9888,
     /*  307670 */     GIR_EraseRootFromParent_Done,
     /*  307671 */   // Label 5740: @307671
     /*  307671 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(307734), // Rule ID 9889 //
     /*  307676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  307690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  307693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307715 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307732 */     GIR_RootConstrainSelectedInstOperands,
     /*  307733 */     // GIR_Coverage, 9889,
     /*  307733 */     GIR_EraseRootFromParent_Done,
     /*  307734 */   // Label 5741: @307734
     /*  307734 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(307797), // Rule ID 9892 //
     /*  307739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  307753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  307756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307778 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307795 */     GIR_RootConstrainSelectedInstOperands,
     /*  307796 */     // GIR_Coverage, 9892,
     /*  307796 */     GIR_EraseRootFromParent_Done,
     /*  307797 */   // Label 5742: @307797
     /*  307797 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(307860), // Rule ID 9893 //
     /*  307802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  307816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  307819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307841 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307858 */     GIR_RootConstrainSelectedInstOperands,
     /*  307859 */     // GIR_Coverage, 9893,
     /*  307859 */     GIR_EraseRootFromParent_Done,
     /*  307860 */   // Label 5743: @307860
     /*  307860 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(307923), // Rule ID 9896 //
     /*  307865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  307879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  307882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307904 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307921 */     GIR_RootConstrainSelectedInstOperands,
     /*  307922 */     // GIR_Coverage, 9896,
     /*  307922 */     GIR_EraseRootFromParent_Done,
     /*  307923 */   // Label 5744: @307923
     /*  307923 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(307986), // Rule ID 9897 //
     /*  307928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  307942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  307945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307967 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307984 */     GIR_RootConstrainSelectedInstOperands,
     /*  307985 */     // GIR_Coverage, 9897,
     /*  307985 */     GIR_EraseRootFromParent_Done,
     /*  307986 */   // Label 5745: @307986
     /*  307986 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(308049), // Rule ID 9900 //
     /*  307991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  307994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  308002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  308005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  308008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308030 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  308030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  308033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308047 */     GIR_RootConstrainSelectedInstOperands,
     /*  308048 */     // GIR_Coverage, 9900,
     /*  308048 */     GIR_EraseRootFromParent_Done,
     /*  308049 */   // Label 5746: @308049
     /*  308049 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(308112), // Rule ID 9901 //
     /*  308054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  308057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  308065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  308068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  308071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308093 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  308093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  308096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308110 */     GIR_RootConstrainSelectedInstOperands,
     /*  308111 */     // GIR_Coverage, 9901,
     /*  308111 */     GIR_EraseRootFromParent_Done,
     /*  308112 */   // Label 5747: @308112
     /*  308112 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(308175), // Rule ID 9904 //
     /*  308117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  308120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  308131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  308134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308156 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  308156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  308159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308173 */     GIR_RootConstrainSelectedInstOperands,
     /*  308174 */     // GIR_Coverage, 9904,
     /*  308174 */     GIR_EraseRootFromParent_Done,
     /*  308175 */   // Label 5748: @308175
     /*  308175 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(308238), // Rule ID 9905 //
     /*  308180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  308183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  308194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  308197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308219 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  308219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  308222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308236 */     GIR_RootConstrainSelectedInstOperands,
     /*  308237 */     // GIR_Coverage, 9905,
     /*  308237 */     GIR_EraseRootFromParent_Done,
     /*  308238 */   // Label 5749: @308238
     /*  308238 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(308301), // Rule ID 9908 //
     /*  308243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  308246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  308257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  308260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308282 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  308282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308299 */     GIR_RootConstrainSelectedInstOperands,
     /*  308300 */     // GIR_Coverage, 9908,
     /*  308300 */     GIR_EraseRootFromParent_Done,
     /*  308301 */   // Label 5750: @308301
     /*  308301 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(308364), // Rule ID 9909 //
     /*  308306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  308309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  308320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  308323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308345 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  308345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308362 */     GIR_RootConstrainSelectedInstOperands,
     /*  308363 */     // GIR_Coverage, 9909,
     /*  308363 */     GIR_EraseRootFromParent_Done,
     /*  308364 */   // Label 5751: @308364
     /*  308364 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(308430), // Rule ID 13984 //
     /*  308369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  308380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  308383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  308386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308408 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  308408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  308411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308428 */     GIR_RootConstrainSelectedInstOperands,
     /*  308429 */     // GIR_Coverage, 13984,
     /*  308429 */     GIR_EraseRootFromParent_Done,
     /*  308430 */   // Label 5752: @308430
     /*  308430 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(308496), // Rule ID 13985 //
     /*  308435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  308446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  308449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  308452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308474 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  308474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  308477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308494 */     GIR_RootConstrainSelectedInstOperands,
     /*  308495 */     // GIR_Coverage, 13985,
     /*  308495 */     GIR_EraseRootFromParent_Done,
     /*  308496 */   // Label 5753: @308496
     /*  308496 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(308562), // Rule ID 13986 //
     /*  308501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  308512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  308515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  308518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308540 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  308540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  308543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308560 */     GIR_RootConstrainSelectedInstOperands,
     /*  308561 */     // GIR_Coverage, 13986,
     /*  308561 */     GIR_EraseRootFromParent_Done,
     /*  308562 */   // Label 5754: @308562
     /*  308562 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(308628), // Rule ID 13987 //
     /*  308567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  308578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  308581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  308584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308606 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  308606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  308609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308626 */     GIR_RootConstrainSelectedInstOperands,
     /*  308627 */     // GIR_Coverage, 13987,
     /*  308627 */     GIR_EraseRootFromParent_Done,
     /*  308628 */   // Label 5755: @308628
     /*  308628 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(308694), // Rule ID 13988 //
     /*  308633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  308644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  308647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  308650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308672 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  308672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  308675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308692 */     GIR_RootConstrainSelectedInstOperands,
     /*  308693 */     // GIR_Coverage, 13988,
     /*  308693 */     GIR_EraseRootFromParent_Done,
     /*  308694 */   // Label 5756: @308694
     /*  308694 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(308760), // Rule ID 13989 //
     /*  308699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  308710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  308713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  308716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308738 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  308738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  308741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308758 */     GIR_RootConstrainSelectedInstOperands,
     /*  308759 */     // GIR_Coverage, 13989,
     /*  308759 */     GIR_EraseRootFromParent_Done,
     /*  308760 */   // Label 5757: @308760
     /*  308760 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(308826), // Rule ID 13990 //
     /*  308765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  308776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  308779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  308782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308804 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  308804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  308807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308824 */     GIR_RootConstrainSelectedInstOperands,
     /*  308825 */     // GIR_Coverage, 13990,
     /*  308825 */     GIR_EraseRootFromParent_Done,
     /*  308826 */   // Label 5758: @308826
     /*  308826 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(308892), // Rule ID 13991 //
     /*  308831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  308842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  308845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  308848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308870 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  308870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  308873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308890 */     GIR_RootConstrainSelectedInstOperands,
     /*  308891 */     // GIR_Coverage, 13991,
     /*  308891 */     GIR_EraseRootFromParent_Done,
     /*  308892 */   // Label 5759: @308892
     /*  308892 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(308958), // Rule ID 13992 //
     /*  308897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  308908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  308911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  308914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308936 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  308936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  308939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308956 */     GIR_RootConstrainSelectedInstOperands,
     /*  308957 */     // GIR_Coverage, 13992,
     /*  308957 */     GIR_EraseRootFromParent_Done,
     /*  308958 */   // Label 5760: @308958
     /*  308958 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(309024), // Rule ID 13993 //
     /*  308963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  308974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  308977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  308980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309002 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309022 */     GIR_RootConstrainSelectedInstOperands,
     /*  309023 */     // GIR_Coverage, 13993,
     /*  309023 */     GIR_EraseRootFromParent_Done,
     /*  309024 */   // Label 5761: @309024
     /*  309024 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(309090), // Rule ID 13994 //
     /*  309029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  309040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  309043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  309046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309068 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  309068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309088 */     GIR_RootConstrainSelectedInstOperands,
     /*  309089 */     // GIR_Coverage, 13994,
     /*  309089 */     GIR_EraseRootFromParent_Done,
     /*  309090 */   // Label 5762: @309090
     /*  309090 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(309156), // Rule ID 13995 //
     /*  309095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  309106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  309109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  309112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309134 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  309134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309154 */     GIR_RootConstrainSelectedInstOperands,
     /*  309155 */     // GIR_Coverage, 13995,
     /*  309155 */     GIR_EraseRootFromParent_Done,
     /*  309156 */   // Label 5763: @309156
     /*  309156 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(309222), // Rule ID 13996 //
     /*  309161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  309172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  309175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  309178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309200 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309220 */     GIR_RootConstrainSelectedInstOperands,
     /*  309221 */     // GIR_Coverage, 13996,
     /*  309221 */     GIR_EraseRootFromParent_Done,
     /*  309222 */   // Label 5764: @309222
     /*  309222 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(309288), // Rule ID 13997 //
     /*  309227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  309238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  309241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  309244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309266 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309286 */     GIR_RootConstrainSelectedInstOperands,
     /*  309287 */     // GIR_Coverage, 13997,
     /*  309287 */     GIR_EraseRootFromParent_Done,
     /*  309288 */   // Label 5765: @309288
     /*  309288 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(309354), // Rule ID 13998 //
     /*  309293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  309304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  309307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  309310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309332 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309352 */     GIR_RootConstrainSelectedInstOperands,
     /*  309353 */     // GIR_Coverage, 13998,
     /*  309353 */     GIR_EraseRootFromParent_Done,
     /*  309354 */   // Label 5766: @309354
     /*  309354 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(309420), // Rule ID 13999 //
     /*  309359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  309370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  309373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  309376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309418 */     GIR_RootConstrainSelectedInstOperands,
     /*  309419 */     // GIR_Coverage, 13999,
     /*  309419 */     GIR_EraseRootFromParent_Done,
     /*  309420 */   // Label 5767: @309420
     /*  309420 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(309486), // Rule ID 14000 //
     /*  309425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  309436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  309439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  309442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  309464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309484 */     GIR_RootConstrainSelectedInstOperands,
     /*  309485 */     // GIR_Coverage, 14000,
     /*  309485 */     GIR_EraseRootFromParent_Done,
     /*  309486 */   // Label 5768: @309486
     /*  309486 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(309552), // Rule ID 14001 //
     /*  309491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  309502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  309505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  309508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309530 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  309530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309550 */     GIR_RootConstrainSelectedInstOperands,
     /*  309551 */     // GIR_Coverage, 14001,
     /*  309551 */     GIR_EraseRootFromParent_Done,
     /*  309552 */   // Label 5769: @309552
     /*  309552 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(309618), // Rule ID 14002 //
     /*  309557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  309560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  309568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  309571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  309574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309596 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  309596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309616 */     GIR_RootConstrainSelectedInstOperands,
     /*  309617 */     // GIR_Coverage, 14002,
     /*  309617 */     GIR_EraseRootFromParent_Done,
     /*  309618 */   // Label 5770: @309618
     /*  309618 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(309684), // Rule ID 14003 //
     /*  309623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  309626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  309634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  309637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  309640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309662 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  309662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309682 */     GIR_RootConstrainSelectedInstOperands,
     /*  309683 */     // GIR_Coverage, 14003,
     /*  309683 */     GIR_EraseRootFromParent_Done,
     /*  309684 */   // Label 5771: @309684
     /*  309684 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(309750), // Rule ID 14004 //
     /*  309689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  309700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  309703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  309706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309728 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  309731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309748 */     GIR_RootConstrainSelectedInstOperands,
     /*  309749 */     // GIR_Coverage, 14004,
     /*  309749 */     GIR_EraseRootFromParent_Done,
     /*  309750 */   // Label 5772: @309750
     /*  309750 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(309816), // Rule ID 14005 //
     /*  309755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  309766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  309769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  309772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309794 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  309797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309814 */     GIR_RootConstrainSelectedInstOperands,
     /*  309815 */     // GIR_Coverage, 14005,
     /*  309815 */     GIR_EraseRootFromParent_Done,
     /*  309816 */   // Label 5773: @309816
     /*  309816 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(309882), // Rule ID 14006 //
     /*  309821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  309832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  309835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  309838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309860 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  309863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309880 */     GIR_RootConstrainSelectedInstOperands,
     /*  309881 */     // GIR_Coverage, 14006,
     /*  309881 */     GIR_EraseRootFromParent_Done,
     /*  309882 */   // Label 5774: @309882
     /*  309882 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(309948), // Rule ID 14007 //
     /*  309887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  309898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  309901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  309904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309926 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  309929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309946 */     GIR_RootConstrainSelectedInstOperands,
     /*  309947 */     // GIR_Coverage, 14007,
     /*  309947 */     GIR_EraseRootFromParent_Done,
     /*  309948 */   // Label 5775: @309948
     /*  309948 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(310014), // Rule ID 14008 //
     /*  309953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  309964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  309967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  309970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309992 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  309995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310012 */     GIR_RootConstrainSelectedInstOperands,
     /*  310013 */     // GIR_Coverage, 14008,
     /*  310013 */     GIR_EraseRootFromParent_Done,
     /*  310014 */   // Label 5776: @310014
     /*  310014 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(310080), // Rule ID 14009 //
     /*  310019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  310030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  310033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  310036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310058 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  310058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310078 */     GIR_RootConstrainSelectedInstOperands,
     /*  310079 */     // GIR_Coverage, 14009,
     /*  310079 */     GIR_EraseRootFromParent_Done,
     /*  310080 */   // Label 5777: @310080
     /*  310080 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(310146), // Rule ID 14010 //
     /*  310085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  310096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  310099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  310102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310144 */     GIR_RootConstrainSelectedInstOperands,
     /*  310145 */     // GIR_Coverage, 14010,
     /*  310145 */     GIR_EraseRootFromParent_Done,
     /*  310146 */   // Label 5778: @310146
     /*  310146 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(310212), // Rule ID 14011 //
     /*  310151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  310162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  310165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  310168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310210 */     GIR_RootConstrainSelectedInstOperands,
     /*  310211 */     // GIR_Coverage, 14011,
     /*  310211 */     GIR_EraseRootFromParent_Done,
     /*  310212 */   // Label 5779: @310212
     /*  310212 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(310278), // Rule ID 14012 //
     /*  310217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  310228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  310231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  310234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310256 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310276 */     GIR_RootConstrainSelectedInstOperands,
     /*  310277 */     // GIR_Coverage, 14012,
     /*  310277 */     GIR_EraseRootFromParent_Done,
     /*  310278 */   // Label 5780: @310278
     /*  310278 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(310344), // Rule ID 14013 //
     /*  310283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  310294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  310297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  310300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310322 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310342 */     GIR_RootConstrainSelectedInstOperands,
     /*  310343 */     // GIR_Coverage, 14013,
     /*  310343 */     GIR_EraseRootFromParent_Done,
     /*  310344 */   // Label 5781: @310344
     /*  310344 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(310410), // Rule ID 14014 //
     /*  310349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  310360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  310363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  310366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310388 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310408 */     GIR_RootConstrainSelectedInstOperands,
     /*  310409 */     // GIR_Coverage, 14014,
     /*  310409 */     GIR_EraseRootFromParent_Done,
     /*  310410 */   // Label 5782: @310410
     /*  310410 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(310476), // Rule ID 14015 //
     /*  310415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  310426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  310429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  310432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310454 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310474 */     GIR_RootConstrainSelectedInstOperands,
     /*  310475 */     // GIR_Coverage, 14015,
     /*  310475 */     GIR_EraseRootFromParent_Done,
     /*  310476 */   // Label 5783: @310476
     /*  310476 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(310542), // Rule ID 14016 //
     /*  310481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  310492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  310495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  310498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310520 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  310520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310540 */     GIR_RootConstrainSelectedInstOperands,
     /*  310541 */     // GIR_Coverage, 14016,
     /*  310541 */     GIR_EraseRootFromParent_Done,
     /*  310542 */   // Label 5784: @310542
     /*  310542 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(310608), // Rule ID 14017 //
     /*  310547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  310558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  310561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  310564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  310586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310606 */     GIR_RootConstrainSelectedInstOperands,
     /*  310607 */     // GIR_Coverage, 14017,
     /*  310607 */     GIR_EraseRootFromParent_Done,
     /*  310608 */   // Label 5785: @310608
     /*  310608 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(310674), // Rule ID 14018 //
     /*  310613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  310624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  310627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  310630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310652 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  310652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310672 */     GIR_RootConstrainSelectedInstOperands,
     /*  310673 */     // GIR_Coverage, 14018,
     /*  310673 */     GIR_EraseRootFromParent_Done,
     /*  310674 */   // Label 5786: @310674
     /*  310674 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(310740), // Rule ID 14019 //
     /*  310679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  310690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  310693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  310696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310718 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  310718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310738 */     GIR_RootConstrainSelectedInstOperands,
     /*  310739 */     // GIR_Coverage, 14019,
     /*  310739 */     GIR_EraseRootFromParent_Done,
     /*  310740 */   // Label 5787: @310740
     /*  310740 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(310806), // Rule ID 14020 //
     /*  310745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  310756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  310759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  310762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310784 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  310784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310804 */     GIR_RootConstrainSelectedInstOperands,
     /*  310805 */     // GIR_Coverage, 14020,
     /*  310805 */     GIR_EraseRootFromParent_Done,
     /*  310806 */   // Label 5788: @310806
     /*  310806 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(310872), // Rule ID 14021 //
     /*  310811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  310822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  310825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  310828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310850 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  310850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310870 */     GIR_RootConstrainSelectedInstOperands,
     /*  310871 */     // GIR_Coverage, 14021,
     /*  310871 */     GIR_EraseRootFromParent_Done,
     /*  310872 */   // Label 5789: @310872
     /*  310872 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(310938), // Rule ID 14022 //
     /*  310877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  310880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  310888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  310891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  310894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310916 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  310916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310936 */     GIR_RootConstrainSelectedInstOperands,
     /*  310937 */     // GIR_Coverage, 14022,
     /*  310937 */     GIR_EraseRootFromParent_Done,
     /*  310938 */   // Label 5790: @310938
     /*  310938 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(311004), // Rule ID 14023 //
     /*  310943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  310946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  310954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  310957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  310960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310982 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  310982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311002 */     GIR_RootConstrainSelectedInstOperands,
     /*  311003 */     // GIR_Coverage, 14023,
     /*  311003 */     GIR_EraseRootFromParent_Done,
     /*  311004 */   // Label 5791: @311004
     /*  311004 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(311070), // Rule ID 14024 //
     /*  311009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  311020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  311023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  311026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311048 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  311048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311068 */     GIR_RootConstrainSelectedInstOperands,
     /*  311069 */     // GIR_Coverage, 14024,
     /*  311069 */     GIR_EraseRootFromParent_Done,
     /*  311070 */   // Label 5792: @311070
     /*  311070 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(311136), // Rule ID 14025 //
     /*  311075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  311078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  311086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  311089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  311092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311114 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  311114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311134 */     GIR_RootConstrainSelectedInstOperands,
     /*  311135 */     // GIR_Coverage, 14025,
     /*  311135 */     GIR_EraseRootFromParent_Done,
     /*  311136 */   // Label 5793: @311136
     /*  311136 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(311202), // Rule ID 14026 //
     /*  311141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  311152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  311155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  311158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311180 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  311180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311200 */     GIR_RootConstrainSelectedInstOperands,
     /*  311201 */     // GIR_Coverage, 14026,
     /*  311201 */     GIR_EraseRootFromParent_Done,
     /*  311202 */   // Label 5794: @311202
     /*  311202 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(311268), // Rule ID 14027 //
     /*  311207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  311210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  311218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  311221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  311224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311246 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  311246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311266 */     GIR_RootConstrainSelectedInstOperands,
     /*  311267 */     // GIR_Coverage, 14027,
     /*  311267 */     GIR_EraseRootFromParent_Done,
     /*  311268 */   // Label 5795: @311268
     /*  311268 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(311334), // Rule ID 14028 //
     /*  311273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  311284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  311287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  311290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311312 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  311315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311332 */     GIR_RootConstrainSelectedInstOperands,
     /*  311333 */     // GIR_Coverage, 14028,
     /*  311333 */     GIR_EraseRootFromParent_Done,
     /*  311334 */   // Label 5796: @311334
     /*  311334 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(311400), // Rule ID 14029 //
     /*  311339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  311350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  311353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  311356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311378 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  311381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311398 */     GIR_RootConstrainSelectedInstOperands,
     /*  311399 */     // GIR_Coverage, 14029,
     /*  311399 */     GIR_EraseRootFromParent_Done,
     /*  311400 */   // Label 5797: @311400
     /*  311400 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(311466), // Rule ID 14030 //
     /*  311405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  311416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  311419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  311422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311444 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311464 */     GIR_RootConstrainSelectedInstOperands,
     /*  311465 */     // GIR_Coverage, 14030,
     /*  311465 */     GIR_EraseRootFromParent_Done,
     /*  311466 */   // Label 5798: @311466
     /*  311466 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(311532), // Rule ID 14031 //
     /*  311471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  311482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  311485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  311488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311510 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311530 */     GIR_RootConstrainSelectedInstOperands,
     /*  311531 */     // GIR_Coverage, 14031,
     /*  311531 */     GIR_EraseRootFromParent_Done,
     /*  311532 */   // Label 5799: @311532
     /*  311532 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(311598), // Rule ID 14032 //
     /*  311537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  311540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  311548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  311551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  311554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311576 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311596 */     GIR_RootConstrainSelectedInstOperands,
     /*  311597 */     // GIR_Coverage, 14032,
     /*  311597 */     GIR_EraseRootFromParent_Done,
     /*  311598 */   // Label 5800: @311598
     /*  311598 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(311664), // Rule ID 14033 //
     /*  311603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  311606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  311614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  311617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  311620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311642 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311662 */     GIR_RootConstrainSelectedInstOperands,
     /*  311663 */     // GIR_Coverage, 14033,
     /*  311663 */     GIR_EraseRootFromParent_Done,
     /*  311664 */   // Label 5801: @311664
     /*  311664 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(311730), // Rule ID 14034 //
     /*  311669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  311680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  311683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  311686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311708 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311728 */     GIR_RootConstrainSelectedInstOperands,
     /*  311729 */     // GIR_Coverage, 14034,
     /*  311729 */     GIR_EraseRootFromParent_Done,
     /*  311730 */   // Label 5802: @311730
     /*  311730 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(311796), // Rule ID 14035 //
     /*  311735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  311746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  311749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  311752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311774 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311794 */     GIR_RootConstrainSelectedInstOperands,
     /*  311795 */     // GIR_Coverage, 14035,
     /*  311795 */     GIR_EraseRootFromParent_Done,
     /*  311796 */   // Label 5803: @311796
     /*  311796 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(311862), // Rule ID 14036 //
     /*  311801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  311804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  311812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  311815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  311818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311840 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311860 */     GIR_RootConstrainSelectedInstOperands,
     /*  311861 */     // GIR_Coverage, 14036,
     /*  311861 */     GIR_EraseRootFromParent_Done,
     /*  311862 */   // Label 5804: @311862
     /*  311862 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(311928), // Rule ID 14037 //
     /*  311867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  311870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  311878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  311881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  311884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311906 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311926 */     GIR_RootConstrainSelectedInstOperands,
     /*  311927 */     // GIR_Coverage, 14037,
     /*  311927 */     GIR_EraseRootFromParent_Done,
     /*  311928 */   // Label 5805: @311928
     /*  311928 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(311994), // Rule ID 14038 //
     /*  311933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  311936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  311944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  311947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  311950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311972 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  311972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311992 */     GIR_RootConstrainSelectedInstOperands,
     /*  311993 */     // GIR_Coverage, 14038,
     /*  311993 */     GIR_EraseRootFromParent_Done,
     /*  311994 */   // Label 5806: @311994
     /*  311994 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(312060), // Rule ID 14039 //
     /*  311999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  312002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  312010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  312013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  312016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312038 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  312038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312058 */     GIR_RootConstrainSelectedInstOperands,
     /*  312059 */     // GIR_Coverage, 14039,
     /*  312059 */     GIR_EraseRootFromParent_Done,
     /*  312060 */   // Label 5807: @312060
     /*  312060 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(312126), // Rule ID 14040 //
     /*  312065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  312076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  312079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  312082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312104 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312124 */     GIR_RootConstrainSelectedInstOperands,
     /*  312125 */     // GIR_Coverage, 14040,
     /*  312125 */     GIR_EraseRootFromParent_Done,
     /*  312126 */   // Label 5808: @312126
     /*  312126 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(312192), // Rule ID 14041 //
     /*  312131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  312142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  312145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  312148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312170 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312190 */     GIR_RootConstrainSelectedInstOperands,
     /*  312191 */     // GIR_Coverage, 14041,
     /*  312191 */     GIR_EraseRootFromParent_Done,
     /*  312192 */   // Label 5809: @312192
     /*  312192 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(312258), // Rule ID 14042 //
     /*  312197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  312208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  312211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  312214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312236 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312256 */     GIR_RootConstrainSelectedInstOperands,
     /*  312257 */     // GIR_Coverage, 14042,
     /*  312257 */     GIR_EraseRootFromParent_Done,
     /*  312258 */   // Label 5810: @312258
     /*  312258 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(312324), // Rule ID 14043 //
     /*  312263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  312274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  312277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  312280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312302 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312322 */     GIR_RootConstrainSelectedInstOperands,
     /*  312323 */     // GIR_Coverage, 14043,
     /*  312323 */     GIR_EraseRootFromParent_Done,
     /*  312324 */   // Label 5811: @312324
     /*  312324 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(312390), // Rule ID 14044 //
     /*  312329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  312340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  312343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  312346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312368 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312388 */     GIR_RootConstrainSelectedInstOperands,
     /*  312389 */     // GIR_Coverage, 14044,
     /*  312389 */     GIR_EraseRootFromParent_Done,
     /*  312390 */   // Label 5812: @312390
     /*  312390 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(312456), // Rule ID 14045 //
     /*  312395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  312406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  312409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  312412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312434 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312454 */     GIR_RootConstrainSelectedInstOperands,
     /*  312455 */     // GIR_Coverage, 14045,
     /*  312455 */     GIR_EraseRootFromParent_Done,
     /*  312456 */   // Label 5813: @312456
     /*  312456 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(312522), // Rule ID 14046 //
     /*  312461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  312472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  312475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  312478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312500 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312520 */     GIR_RootConstrainSelectedInstOperands,
     /*  312521 */     // GIR_Coverage, 14046,
     /*  312521 */     GIR_EraseRootFromParent_Done,
     /*  312522 */   // Label 5814: @312522
     /*  312522 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(312588), // Rule ID 14047 //
     /*  312527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  312538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  312541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  312544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312566 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312586 */     GIR_RootConstrainSelectedInstOperands,
     /*  312587 */     // GIR_Coverage, 14047,
     /*  312587 */     GIR_EraseRootFromParent_Done,
     /*  312588 */   // Label 5815: @312588
     /*  312588 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(312654), // Rule ID 14048 //
     /*  312593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  312604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  312607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  312610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312632 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312652 */     GIR_RootConstrainSelectedInstOperands,
     /*  312653 */     // GIR_Coverage, 14048,
     /*  312653 */     GIR_EraseRootFromParent_Done,
     /*  312654 */   // Label 5816: @312654
     /*  312654 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(312720), // Rule ID 14049 //
     /*  312659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  312670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  312673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  312676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312698 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312718 */     GIR_RootConstrainSelectedInstOperands,
     /*  312719 */     // GIR_Coverage, 14049,
     /*  312719 */     GIR_EraseRootFromParent_Done,
     /*  312720 */   // Label 5817: @312720
     /*  312720 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(312786), // Rule ID 14050 //
     /*  312725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  312736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  312739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  312742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312764 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312784 */     GIR_RootConstrainSelectedInstOperands,
     /*  312785 */     // GIR_Coverage, 14050,
     /*  312785 */     GIR_EraseRootFromParent_Done,
     /*  312786 */   // Label 5818: @312786
     /*  312786 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(312852), // Rule ID 14051 //
     /*  312791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  312802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  312805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  312808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312830 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312850 */     GIR_RootConstrainSelectedInstOperands,
     /*  312851 */     // GIR_Coverage, 14051,
     /*  312851 */     GIR_EraseRootFromParent_Done,
     /*  312852 */   // Label 5819: @312852
     /*  312852 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(312918), // Rule ID 14052 //
     /*  312857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  312860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  312868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  312871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  312874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312896 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  312896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312916 */     GIR_RootConstrainSelectedInstOperands,
     /*  312917 */     // GIR_Coverage, 14052,
     /*  312917 */     GIR_EraseRootFromParent_Done,
     /*  312918 */   // Label 5820: @312918
     /*  312918 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(312984), // Rule ID 14053 //
     /*  312923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  312926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  312934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  312937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  312940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312962 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  312962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312982 */     GIR_RootConstrainSelectedInstOperands,
     /*  312983 */     // GIR_Coverage, 14053,
     /*  312983 */     GIR_EraseRootFromParent_Done,
     /*  312984 */   // Label 5821: @312984
     /*  312984 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(313050), // Rule ID 14054 //
     /*  312989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  312992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  313000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  313003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  313006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313028 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313048 */     GIR_RootConstrainSelectedInstOperands,
     /*  313049 */     // GIR_Coverage, 14054,
     /*  313049 */     GIR_EraseRootFromParent_Done,
     /*  313050 */   // Label 5822: @313050
     /*  313050 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(313116), // Rule ID 14055 //
     /*  313055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  313058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  313066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  313069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  313072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313094 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313114 */     GIR_RootConstrainSelectedInstOperands,
     /*  313115 */     // GIR_Coverage, 14055,
     /*  313115 */     GIR_EraseRootFromParent_Done,
     /*  313116 */   // Label 5823: @313116
     /*  313116 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(313182), // Rule ID 14056 //
     /*  313121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  313124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  313132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  313135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  313138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313160 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313180 */     GIR_RootConstrainSelectedInstOperands,
     /*  313181 */     // GIR_Coverage, 14056,
     /*  313181 */     GIR_EraseRootFromParent_Done,
     /*  313182 */   // Label 5824: @313182
     /*  313182 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(313248), // Rule ID 14057 //
     /*  313187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  313190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  313198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  313201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  313204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313226 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313246 */     GIR_RootConstrainSelectedInstOperands,
     /*  313247 */     // GIR_Coverage, 14057,
     /*  313247 */     GIR_EraseRootFromParent_Done,
     /*  313248 */   // Label 5825: @313248
     /*  313248 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(313314), // Rule ID 19060 //
     /*  313253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  313264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  313267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  313270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313292 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  313295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313312 */     GIR_RootConstrainSelectedInstOperands,
     /*  313313 */     // GIR_Coverage, 19060,
     /*  313313 */     GIR_EraseRootFromParent_Done,
     /*  313314 */   // Label 5826: @313314
     /*  313314 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(313380), // Rule ID 19061 //
     /*  313319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  313322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  313330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  313333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  313336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313358 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  313358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  313361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313378 */     GIR_RootConstrainSelectedInstOperands,
     /*  313379 */     // GIR_Coverage, 19061,
     /*  313379 */     GIR_EraseRootFromParent_Done,
     /*  313380 */   // Label 5827: @313380
     /*  313380 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(313446), // Rule ID 19064 //
     /*  313385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  313388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  313396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  313399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  313402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313424 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  313427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313444 */     GIR_RootConstrainSelectedInstOperands,
     /*  313445 */     // GIR_Coverage, 19064,
     /*  313445 */     GIR_EraseRootFromParent_Done,
     /*  313446 */   // Label 5828: @313446
     /*  313446 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(313512), // Rule ID 19065 //
     /*  313451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  313454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  313462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  313465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  313468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313490 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  313493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313510 */     GIR_RootConstrainSelectedInstOperands,
     /*  313511 */     // GIR_Coverage, 19065,
     /*  313511 */     GIR_EraseRootFromParent_Done,
     /*  313512 */   // Label 5829: @313512
     /*  313512 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(313578), // Rule ID 19068 //
     /*  313517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  313528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  313531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313556 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  313559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313576 */     GIR_RootConstrainSelectedInstOperands,
     /*  313577 */     // GIR_Coverage, 19068,
     /*  313577 */     GIR_EraseRootFromParent_Done,
     /*  313578 */   // Label 5830: @313578
     /*  313578 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(313644), // Rule ID 19069 //
     /*  313583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  313586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  313594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  313597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313622 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  313622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  313625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313642 */     GIR_RootConstrainSelectedInstOperands,
     /*  313643 */     // GIR_Coverage, 19069,
     /*  313643 */     GIR_EraseRootFromParent_Done,
     /*  313644 */   // Label 5831: @313644
     /*  313644 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(313710), // Rule ID 19072 //
     /*  313649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  313652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  313660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  313663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  313666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313688 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  313691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313708 */     GIR_RootConstrainSelectedInstOperands,
     /*  313709 */     // GIR_Coverage, 19072,
     /*  313709 */     GIR_EraseRootFromParent_Done,
     /*  313710 */   // Label 5832: @313710
     /*  313710 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(313776), // Rule ID 19073 //
     /*  313715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  313718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  313726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  313729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  313732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313754 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  313757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313774 */     GIR_RootConstrainSelectedInstOperands,
     /*  313775 */     // GIR_Coverage, 19073,
     /*  313775 */     GIR_EraseRootFromParent_Done,
     /*  313776 */   // Label 5833: @313776
     /*  313776 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(313842), // Rule ID 19076 //
     /*  313781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  313784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  313792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  313795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  313798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313820 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  313823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313840 */     GIR_RootConstrainSelectedInstOperands,
     /*  313841 */     // GIR_Coverage, 19076,
     /*  313841 */     GIR_EraseRootFromParent_Done,
     /*  313842 */   // Label 5834: @313842
     /*  313842 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(313908), // Rule ID 19077 //
     /*  313847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  313850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  313858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  313861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  313864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313886 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  313889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313906 */     GIR_RootConstrainSelectedInstOperands,
     /*  313907 */     // GIR_Coverage, 19077,
     /*  313907 */     GIR_EraseRootFromParent_Done,
     /*  313908 */   // Label 5835: @313908
     /*  313908 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(313974), // Rule ID 19080 //
     /*  313913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  313924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  313927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  313930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313952 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  313955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313972 */     GIR_RootConstrainSelectedInstOperands,
     /*  313973 */     // GIR_Coverage, 19080,
     /*  313973 */     GIR_EraseRootFromParent_Done,
     /*  313974 */   // Label 5836: @313974
     /*  313974 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(314040), // Rule ID 19081 //
     /*  313979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  313982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  313990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  313993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  313996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314018 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  314021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314038 */     GIR_RootConstrainSelectedInstOperands,
     /*  314039 */     // GIR_Coverage, 19081,
     /*  314039 */     GIR_EraseRootFromParent_Done,
     /*  314040 */   // Label 5837: @314040
     /*  314040 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(314106), // Rule ID 19084 //
     /*  314045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  314048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  314056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  314059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314084 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  314087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314104 */     GIR_RootConstrainSelectedInstOperands,
     /*  314105 */     // GIR_Coverage, 19084,
     /*  314105 */     GIR_EraseRootFromParent_Done,
     /*  314106 */   // Label 5838: @314106
     /*  314106 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(314172), // Rule ID 19085 //
     /*  314111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  314122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  314125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314150 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  314153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314170 */     GIR_RootConstrainSelectedInstOperands,
     /*  314171 */     // GIR_Coverage, 19085,
     /*  314171 */     GIR_EraseRootFromParent_Done,
     /*  314172 */   // Label 5839: @314172
     /*  314172 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(314238), // Rule ID 19088 //
     /*  314177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  314180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  314188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  314191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314216 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  314219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314236 */     GIR_RootConstrainSelectedInstOperands,
     /*  314237 */     // GIR_Coverage, 19088,
     /*  314237 */     GIR_EraseRootFromParent_Done,
     /*  314238 */   // Label 5840: @314238
     /*  314238 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(314304), // Rule ID 19089 //
     /*  314243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  314254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  314257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314282 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  314285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314302 */     GIR_RootConstrainSelectedInstOperands,
     /*  314303 */     // GIR_Coverage, 19089,
     /*  314303 */     GIR_EraseRootFromParent_Done,
     /*  314304 */   // Label 5841: @314304
     /*  314304 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(314370), // Rule ID 19092 //
     /*  314309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  314320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  314323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314348 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  314351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314368 */     GIR_RootConstrainSelectedInstOperands,
     /*  314369 */     // GIR_Coverage, 19092,
     /*  314369 */     GIR_EraseRootFromParent_Done,
     /*  314370 */   // Label 5842: @314370
     /*  314370 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(314436), // Rule ID 19093 //
     /*  314375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  314386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  314389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314414 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  314417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314434 */     GIR_RootConstrainSelectedInstOperands,
     /*  314435 */     // GIR_Coverage, 19093,
     /*  314435 */     GIR_EraseRootFromParent_Done,
     /*  314436 */   // Label 5843: @314436
     /*  314436 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(314502), // Rule ID 19096 //
     /*  314441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  314452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  314455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314480 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  314483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314500 */     GIR_RootConstrainSelectedInstOperands,
     /*  314501 */     // GIR_Coverage, 19096,
     /*  314501 */     GIR_EraseRootFromParent_Done,
     /*  314502 */   // Label 5844: @314502
     /*  314502 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(314568), // Rule ID 19097 //
     /*  314507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  314518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  314521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314546 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  314549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314566 */     GIR_RootConstrainSelectedInstOperands,
     /*  314567 */     // GIR_Coverage, 19097,
     /*  314567 */     GIR_EraseRootFromParent_Done,
     /*  314568 */   // Label 5845: @314568
     /*  314568 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(314634), // Rule ID 19100 //
     /*  314573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  314584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  314587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  314590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314612 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  314615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314632 */     GIR_RootConstrainSelectedInstOperands,
     /*  314633 */     // GIR_Coverage, 19100,
     /*  314633 */     GIR_EraseRootFromParent_Done,
     /*  314634 */   // Label 5846: @314634
     /*  314634 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(314700), // Rule ID 19101 //
     /*  314639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  314650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  314653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  314656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314678 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  314681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314698 */     GIR_RootConstrainSelectedInstOperands,
     /*  314699 */     // GIR_Coverage, 19101,
     /*  314699 */     GIR_EraseRootFromParent_Done,
     /*  314700 */   // Label 5847: @314700
     /*  314700 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(314766), // Rule ID 19104 //
     /*  314705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  314708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  314716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  314719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  314722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314744 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  314747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314764 */     GIR_RootConstrainSelectedInstOperands,
     /*  314765 */     // GIR_Coverage, 19104,
     /*  314765 */     GIR_EraseRootFromParent_Done,
     /*  314766 */   // Label 5848: @314766
     /*  314766 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(314832), // Rule ID 19105 //
     /*  314771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  314774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  314782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  314785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  314788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314810 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  314810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  314813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314830 */     GIR_RootConstrainSelectedInstOperands,
     /*  314831 */     // GIR_Coverage, 19105,
     /*  314831 */     GIR_EraseRootFromParent_Done,
     /*  314832 */   // Label 5849: @314832
     /*  314832 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(314898), // Rule ID 19108 //
     /*  314837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  314840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  314848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  314851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  314854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314876 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  314879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314896 */     GIR_RootConstrainSelectedInstOperands,
     /*  314897 */     // GIR_Coverage, 19108,
     /*  314897 */     GIR_EraseRootFromParent_Done,
     /*  314898 */   // Label 5850: @314898
     /*  314898 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(314964), // Rule ID 19109 //
     /*  314903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  314906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  314914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  314917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  314920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314942 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  314942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  314945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314962 */     GIR_RootConstrainSelectedInstOperands,
     /*  314963 */     // GIR_Coverage, 19109,
     /*  314963 */     GIR_EraseRootFromParent_Done,
     /*  314964 */   // Label 5851: @314964
     /*  314964 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(315030), // Rule ID 19112 //
     /*  314969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  314972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  314980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  314983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  314986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315008 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  315008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  315011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315028 */     GIR_RootConstrainSelectedInstOperands,
     /*  315029 */     // GIR_Coverage, 19112,
     /*  315029 */     GIR_EraseRootFromParent_Done,
     /*  315030 */   // Label 5852: @315030
     /*  315030 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(315096), // Rule ID 19113 //
     /*  315035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  315038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  315046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  315049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  315052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315074 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  315074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  315077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315094 */     GIR_RootConstrainSelectedInstOperands,
     /*  315095 */     // GIR_Coverage, 19113,
     /*  315095 */     GIR_EraseRootFromParent_Done,
     /*  315096 */   // Label 5853: @315096
     /*  315096 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(315159), // Rule ID 19776 //
     /*  315101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  315115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315140 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  315143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315157 */     GIR_RootConstrainSelectedInstOperands,
     /*  315158 */     // GIR_Coverage, 19776,
     /*  315158 */     GIR_EraseRootFromParent_Done,
     /*  315159 */   // Label 5854: @315159
     /*  315159 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(315222), // Rule ID 19777 //
     /*  315164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  315178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315203 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  315206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315220 */     GIR_RootConstrainSelectedInstOperands,
     /*  315221 */     // GIR_Coverage, 19777,
     /*  315221 */     GIR_EraseRootFromParent_Done,
     /*  315222 */   // Label 5855: @315222
     /*  315222 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(315285), // Rule ID 19780 //
     /*  315227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  315241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  315244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315266 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315283 */     GIR_RootConstrainSelectedInstOperands,
     /*  315284 */     // GIR_Coverage, 19780,
     /*  315284 */     GIR_EraseRootFromParent_Done,
     /*  315285 */   // Label 5856: @315285
     /*  315285 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(315348), // Rule ID 19781 //
     /*  315290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  315304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  315307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315329 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315346 */     GIR_RootConstrainSelectedInstOperands,
     /*  315347 */     // GIR_Coverage, 19781,
     /*  315347 */     GIR_EraseRootFromParent_Done,
     /*  315348 */   // Label 5857: @315348
     /*  315348 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(315411), // Rule ID 19784 //
     /*  315353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  315370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  315392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315409 */     GIR_RootConstrainSelectedInstOperands,
     /*  315410 */     // GIR_Coverage, 19784,
     /*  315410 */     GIR_EraseRootFromParent_Done,
     /*  315411 */   // Label 5858: @315411
     /*  315411 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(315474), // Rule ID 19785 //
     /*  315416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  315433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315455 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  315455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315472 */     GIR_RootConstrainSelectedInstOperands,
     /*  315473 */     // GIR_Coverage, 19785,
     /*  315473 */     GIR_EraseRootFromParent_Done,
     /*  315474 */   // Label 5859: @315474
     /*  315474 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(315537), // Rule ID 19788 //
     /*  315479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  315490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  315493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  315496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315518 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315535 */     GIR_RootConstrainSelectedInstOperands,
     /*  315536 */     // GIR_Coverage, 19788,
     /*  315536 */     GIR_EraseRootFromParent_Done,
     /*  315537 */   // Label 5860: @315537
     /*  315537 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(315600), // Rule ID 19789 //
     /*  315542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  315553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  315556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  315559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315581 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315598 */     GIR_RootConstrainSelectedInstOperands,
     /*  315599 */     // GIR_Coverage, 19789,
     /*  315599 */     GIR_EraseRootFromParent_Done,
     /*  315600 */   // Label 5861: @315600
     /*  315600 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(315663), // Rule ID 19792 //
     /*  315605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  315619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  315622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315644 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  315644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315661 */     GIR_RootConstrainSelectedInstOperands,
     /*  315662 */     // GIR_Coverage, 19792,
     /*  315662 */     GIR_EraseRootFromParent_Done,
     /*  315663 */   // Label 5862: @315663
     /*  315663 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(315726), // Rule ID 19793 //
     /*  315668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  315682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  315685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315707 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  315707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315724 */     GIR_RootConstrainSelectedInstOperands,
     /*  315725 */     // GIR_Coverage, 19793,
     /*  315725 */     GIR_EraseRootFromParent_Done,
     /*  315726 */   // Label 5863: @315726
     /*  315726 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(315789), // Rule ID 19796 //
     /*  315731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  315734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  315745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  315748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315770 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  315770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315787 */     GIR_RootConstrainSelectedInstOperands,
     /*  315788 */     // GIR_Coverage, 19796,
     /*  315788 */     GIR_EraseRootFromParent_Done,
     /*  315789 */   // Label 5864: @315789
     /*  315789 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(315852), // Rule ID 19797 //
     /*  315794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  315797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  315808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  315811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315833 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  315833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315850 */     GIR_RootConstrainSelectedInstOperands,
     /*  315851 */     // GIR_Coverage, 19797,
     /*  315851 */     GIR_EraseRootFromParent_Done,
     /*  315852 */   // Label 5865: @315852
     /*  315852 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(315915), // Rule ID 19800 //
     /*  315857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  315868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  315871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  315874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  315899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315913 */     GIR_RootConstrainSelectedInstOperands,
     /*  315914 */     // GIR_Coverage, 19800,
     /*  315914 */     GIR_EraseRootFromParent_Done,
     /*  315915 */   // Label 5866: @315915
     /*  315915 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(315978), // Rule ID 19801 //
     /*  315920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  315931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  315934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  315937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315959 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  315962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315976 */     GIR_RootConstrainSelectedInstOperands,
     /*  315977 */     // GIR_Coverage, 19801,
     /*  315977 */     GIR_EraseRootFromParent_Done,
     /*  315978 */   // Label 5867: @315978
     /*  315978 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(316041), // Rule ID 19804 //
     /*  315983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  315994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  315997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  316000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316022 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  316022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316039 */     GIR_RootConstrainSelectedInstOperands,
     /*  316040 */     // GIR_Coverage, 19804,
     /*  316040 */     GIR_EraseRootFromParent_Done,
     /*  316041 */   // Label 5868: @316041
     /*  316041 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(316104), // Rule ID 19805 //
     /*  316046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  316057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  316060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  316063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316085 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316102 */     GIR_RootConstrainSelectedInstOperands,
     /*  316103 */     // GIR_Coverage, 19805,
     /*  316103 */     GIR_EraseRootFromParent_Done,
     /*  316104 */   // Label 5869: @316104
     /*  316104 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(316167), // Rule ID 19808 //
     /*  316109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  316112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  316120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  316123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316148 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  316148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316165 */     GIR_RootConstrainSelectedInstOperands,
     /*  316166 */     // GIR_Coverage, 19808,
     /*  316166 */     GIR_EraseRootFromParent_Done,
     /*  316167 */   // Label 5870: @316167
     /*  316167 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(316230), // Rule ID 19809 //
     /*  316172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  316183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  316186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316211 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316228 */     GIR_RootConstrainSelectedInstOperands,
     /*  316229 */     // GIR_Coverage, 19809,
     /*  316229 */     GIR_EraseRootFromParent_Done,
     /*  316230 */   // Label 5871: @316230
     /*  316230 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(316293), // Rule ID 19812 //
     /*  316235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  316249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  316252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316274 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316291 */     GIR_RootConstrainSelectedInstOperands,
     /*  316292 */     // GIR_Coverage, 19812,
     /*  316292 */     GIR_EraseRootFromParent_Done,
     /*  316293 */   // Label 5872: @316293
     /*  316293 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(316356), // Rule ID 19813 //
     /*  316298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  316312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  316315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316337 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316354 */     GIR_RootConstrainSelectedInstOperands,
     /*  316355 */     // GIR_Coverage, 19813,
     /*  316355 */     GIR_EraseRootFromParent_Done,
     /*  316356 */   // Label 5873: @316356
     /*  316356 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(316419), // Rule ID 19816 //
     /*  316361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  316375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  316378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316400 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316417 */     GIR_RootConstrainSelectedInstOperands,
     /*  316418 */     // GIR_Coverage, 19816,
     /*  316418 */     GIR_EraseRootFromParent_Done,
     /*  316419 */   // Label 5874: @316419
     /*  316419 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(316482), // Rule ID 19817 //
     /*  316424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  316438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  316441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316463 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316480 */     GIR_RootConstrainSelectedInstOperands,
     /*  316481 */     // GIR_Coverage, 19817,
     /*  316481 */     GIR_EraseRootFromParent_Done,
     /*  316482 */   // Label 5875: @316482
     /*  316482 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(316545), // Rule ID 19820 //
     /*  316487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  316498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  316501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  316504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316526 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316543 */     GIR_RootConstrainSelectedInstOperands,
     /*  316544 */     // GIR_Coverage, 19820,
     /*  316544 */     GIR_EraseRootFromParent_Done,
     /*  316545 */   // Label 5876: @316545
     /*  316545 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(316608), // Rule ID 19821 //
     /*  316550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  316561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  316564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  316567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316589 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316606 */     GIR_RootConstrainSelectedInstOperands,
     /*  316607 */     // GIR_Coverage, 19821,
     /*  316607 */     GIR_EraseRootFromParent_Done,
     /*  316608 */   // Label 5877: @316608
     /*  316608 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(316671), // Rule ID 19824 //
     /*  316613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  316624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  316627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  316630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316652 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  316652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316669 */     GIR_RootConstrainSelectedInstOperands,
     /*  316670 */     // GIR_Coverage, 19824,
     /*  316670 */     GIR_EraseRootFromParent_Done,
     /*  316671 */   // Label 5878: @316671
     /*  316671 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(316734), // Rule ID 19825 //
     /*  316676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  316687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  316690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  316693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316715 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  316715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316732 */     GIR_RootConstrainSelectedInstOperands,
     /*  316733 */     // GIR_Coverage, 19825,
     /*  316733 */     GIR_EraseRootFromParent_Done,
     /*  316734 */   // Label 5879: @316734
     /*  316734 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(316797), // Rule ID 19828 //
     /*  316739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  316753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  316756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316778 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  316778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316795 */     GIR_RootConstrainSelectedInstOperands,
     /*  316796 */     // GIR_Coverage, 19828,
     /*  316796 */     GIR_EraseRootFromParent_Done,
     /*  316797 */   // Label 5880: @316797
     /*  316797 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(316860), // Rule ID 19829 //
     /*  316802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  316816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  316819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316841 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  316841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316858 */     GIR_RootConstrainSelectedInstOperands,
     /*  316859 */     // GIR_Coverage, 19829,
     /*  316859 */     GIR_EraseRootFromParent_Done,
     /*  316860 */   // Label 5881: @316860
     /*  316860 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(316923), // Rule ID 19832 //
     /*  316865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  316879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  316882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316904 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  316904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316921 */     GIR_RootConstrainSelectedInstOperands,
     /*  316922 */     // GIR_Coverage, 19832,
     /*  316922 */     GIR_EraseRootFromParent_Done,
     /*  316923 */   // Label 5882: @316923
     /*  316923 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(316986), // Rule ID 19833 //
     /*  316928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  316942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  316945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316967 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  316967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316984 */     GIR_RootConstrainSelectedInstOperands,
     /*  316985 */     // GIR_Coverage, 19833,
     /*  316985 */     GIR_EraseRootFromParent_Done,
     /*  316986 */   // Label 5883: @316986
     /*  316986 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(317049), // Rule ID 19836 //
     /*  316991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  316994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  317005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317030 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  317033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317047 */     GIR_RootConstrainSelectedInstOperands,
     /*  317048 */     // GIR_Coverage, 19836,
     /*  317048 */     GIR_EraseRootFromParent_Done,
     /*  317049 */   // Label 5884: @317049
     /*  317049 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(317112), // Rule ID 19837 //
     /*  317054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  317068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317093 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  317096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317110 */     GIR_RootConstrainSelectedInstOperands,
     /*  317111 */     // GIR_Coverage, 19837,
     /*  317111 */     GIR_EraseRootFromParent_Done,
     /*  317112 */   // Label 5885: @317112
     /*  317112 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(317175), // Rule ID 19840 //
     /*  317117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  317131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317156 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  317159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317173 */     GIR_RootConstrainSelectedInstOperands,
     /*  317174 */     // GIR_Coverage, 19840,
     /*  317174 */     GIR_EraseRootFromParent_Done,
     /*  317175 */   // Label 5886: @317175
     /*  317175 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(317238), // Rule ID 19841 //
     /*  317180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  317194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317219 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  317222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317236 */     GIR_RootConstrainSelectedInstOperands,
     /*  317237 */     // GIR_Coverage, 19841,
     /*  317237 */     GIR_EraseRootFromParent_Done,
     /*  317238 */   // Label 5887: @317238
     /*  317238 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(317301), // Rule ID 19844 //
     /*  317243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317282 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  317282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  317285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317299 */     GIR_RootConstrainSelectedInstOperands,
     /*  317300 */     // GIR_Coverage, 19844,
     /*  317300 */     GIR_EraseRootFromParent_Done,
     /*  317301 */   // Label 5888: @317301
     /*  317301 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(317364), // Rule ID 19845 //
     /*  317306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317345 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  317345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  317348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317362 */     GIR_RootConstrainSelectedInstOperands,
     /*  317363 */     // GIR_Coverage, 19845,
     /*  317363 */     GIR_EraseRootFromParent_Done,
     /*  317364 */   // Label 5889: @317364
     /*  317364 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(317427), // Rule ID 19848 //
     /*  317369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317408 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  317411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317425 */     GIR_RootConstrainSelectedInstOperands,
     /*  317426 */     // GIR_Coverage, 19848,
     /*  317426 */     GIR_EraseRootFromParent_Done,
     /*  317427 */   // Label 5890: @317427
     /*  317427 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(317490), // Rule ID 19849 //
     /*  317432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317471 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  317474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317488 */     GIR_RootConstrainSelectedInstOperands,
     /*  317489 */     // GIR_Coverage, 19849,
     /*  317489 */     GIR_EraseRootFromParent_Done,
     /*  317490 */   // Label 5891: @317490
     /*  317490 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(317553), // Rule ID 19852 //
     /*  317495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  317509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317534 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  317534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  317537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317551 */     GIR_RootConstrainSelectedInstOperands,
     /*  317552 */     // GIR_Coverage, 19852,
     /*  317552 */     GIR_EraseRootFromParent_Done,
     /*  317553 */   // Label 5892: @317553
     /*  317553 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(317616), // Rule ID 19853 //
     /*  317558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  317572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317597 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  317597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  317600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317614 */     GIR_RootConstrainSelectedInstOperands,
     /*  317615 */     // GIR_Coverage, 19853,
     /*  317615 */     GIR_EraseRootFromParent_Done,
     /*  317616 */   // Label 5893: @317616
     /*  317616 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(317679), // Rule ID 19856 //
     /*  317621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  317624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  317635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  317638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  317653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317660 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  317660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  317663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317677 */     GIR_RootConstrainSelectedInstOperands,
     /*  317678 */     // GIR_Coverage, 19856,
     /*  317678 */     GIR_EraseRootFromParent_Done,
     /*  317679 */   // Label 5894: @317679
     /*  317679 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(317742), // Rule ID 19857 //
     /*  317684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  317687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  317698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  317701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  317716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317723 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  317723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  317726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317740 */     GIR_RootConstrainSelectedInstOperands,
     /*  317741 */     // GIR_Coverage, 19857,
     /*  317741 */     GIR_EraseRootFromParent_Done,
     /*  317742 */   // Label 5895: @317742
     /*  317742 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(317805), // Rule ID 19860 //
     /*  317747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  317758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  317761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317786 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  317789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317803 */     GIR_RootConstrainSelectedInstOperands,
     /*  317804 */     // GIR_Coverage, 19860,
     /*  317804 */     GIR_EraseRootFromParent_Done,
     /*  317805 */   // Label 5896: @317805
     /*  317805 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(317868), // Rule ID 19861 //
     /*  317810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  317821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  317824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317849 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  317852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317866 */     GIR_RootConstrainSelectedInstOperands,
     /*  317867 */     // GIR_Coverage, 19861,
     /*  317867 */     GIR_EraseRootFromParent_Done,
     /*  317868 */   // Label 5897: @317868
     /*  317868 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(317931), // Rule ID 19864 //
     /*  317873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  317884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  317887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317912 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  317915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317929 */     GIR_RootConstrainSelectedInstOperands,
     /*  317930 */     // GIR_Coverage, 19864,
     /*  317930 */     GIR_EraseRootFromParent_Done,
     /*  317931 */   // Label 5898: @317931
     /*  317931 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(317994), // Rule ID 19865 //
     /*  317936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  317947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  317950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317975 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  317978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317992 */     GIR_RootConstrainSelectedInstOperands,
     /*  317993 */     // GIR_Coverage, 19865,
     /*  317993 */     GIR_EraseRootFromParent_Done,
     /*  317994 */   // Label 5899: @317994
     /*  317994 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(318057), // Rule ID 19868 //
     /*  317999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  318010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  318013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318038 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  318041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318055 */     GIR_RootConstrainSelectedInstOperands,
     /*  318056 */     // GIR_Coverage, 19868,
     /*  318056 */     GIR_EraseRootFromParent_Done,
     /*  318057 */   // Label 5900: @318057
     /*  318057 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(318120), // Rule ID 19869 //
     /*  318062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  318073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  318076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318101 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  318101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  318104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318118 */     GIR_RootConstrainSelectedInstOperands,
     /*  318119 */     // GIR_Coverage, 19869,
     /*  318119 */     GIR_EraseRootFromParent_Done,
     /*  318120 */   // Label 5901: @318120
     /*  318120 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(318183), // Rule ID 19872 //
     /*  318125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  318139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318164 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  318167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318181 */     GIR_RootConstrainSelectedInstOperands,
     /*  318182 */     // GIR_Coverage, 19872,
     /*  318182 */     GIR_EraseRootFromParent_Done,
     /*  318183 */   // Label 5902: @318183
     /*  318183 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(318246), // Rule ID 19873 //
     /*  318188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  318202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318227 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  318230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318244 */     GIR_RootConstrainSelectedInstOperands,
     /*  318245 */     // GIR_Coverage, 19873,
     /*  318245 */     GIR_EraseRootFromParent_Done,
     /*  318246 */   // Label 5903: @318246
     /*  318246 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(318309), // Rule ID 19876 //
     /*  318251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  318265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318290 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  318293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318307 */     GIR_RootConstrainSelectedInstOperands,
     /*  318308 */     // GIR_Coverage, 19876,
     /*  318308 */     GIR_EraseRootFromParent_Done,
     /*  318309 */   // Label 5904: @318309
     /*  318309 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(318372), // Rule ID 19877 //
     /*  318314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  318328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318353 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  318356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318370 */     GIR_RootConstrainSelectedInstOperands,
     /*  318371 */     // GIR_Coverage, 19877,
     /*  318371 */     GIR_EraseRootFromParent_Done,
     /*  318372 */   // Label 5905: @318372
     /*  318372 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(318435), // Rule ID 19880 //
     /*  318377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  318388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  318391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318416 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  318419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318433 */     GIR_RootConstrainSelectedInstOperands,
     /*  318434 */     // GIR_Coverage, 19880,
     /*  318434 */     GIR_EraseRootFromParent_Done,
     /*  318435 */   // Label 5906: @318435
     /*  318435 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(318498), // Rule ID 19881 //
     /*  318440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  318451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  318454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318479 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  318482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318496 */     GIR_RootConstrainSelectedInstOperands,
     /*  318497 */     // GIR_Coverage, 19881,
     /*  318497 */     GIR_EraseRootFromParent_Done,
     /*  318498 */   // Label 5907: @318498
     /*  318498 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(318561), // Rule ID 19884 //
     /*  318503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  318514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  318517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318542 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  318542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  318545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318559 */     GIR_RootConstrainSelectedInstOperands,
     /*  318560 */     // GIR_Coverage, 19884,
     /*  318560 */     GIR_EraseRootFromParent_Done,
     /*  318561 */   // Label 5908: @318561
     /*  318561 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(318624), // Rule ID 19885 //
     /*  318566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  318577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  318580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318605 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  318605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  318608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318622 */     GIR_RootConstrainSelectedInstOperands,
     /*  318623 */     // GIR_Coverage, 19885,
     /*  318623 */     GIR_EraseRootFromParent_Done,
     /*  318624 */   // Label 5909: @318624
     /*  318624 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(318687), // Rule ID 19888 //
     /*  318629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  318643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  318668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  318671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318685 */     GIR_RootConstrainSelectedInstOperands,
     /*  318686 */     // GIR_Coverage, 19888,
     /*  318686 */     GIR_EraseRootFromParent_Done,
     /*  318687 */   // Label 5910: @318687
     /*  318687 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(318750), // Rule ID 19889 //
     /*  318692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  318706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318731 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  318731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  318734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318748 */     GIR_RootConstrainSelectedInstOperands,
     /*  318749 */     // GIR_Coverage, 19889,
     /*  318749 */     GIR_EraseRootFromParent_Done,
     /*  318750 */   // Label 5911: @318750
     /*  318750 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(318813), // Rule ID 19892 //
     /*  318755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  318769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318794 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  318794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  318797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318811 */     GIR_RootConstrainSelectedInstOperands,
     /*  318812 */     // GIR_Coverage, 19892,
     /*  318812 */     GIR_EraseRootFromParent_Done,
     /*  318813 */   // Label 5912: @318813
     /*  318813 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(318876), // Rule ID 19893 //
     /*  318818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  318832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318857 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  318857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  318860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318874 */     GIR_RootConstrainSelectedInstOperands,
     /*  318875 */     // GIR_Coverage, 19893,
     /*  318875 */     GIR_EraseRootFromParent_Done,
     /*  318876 */   // Label 5913: @318876
     /*  318876 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(318939), // Rule ID 19896 //
     /*  318881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  318895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  318898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318920 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  318923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318937 */     GIR_RootConstrainSelectedInstOperands,
     /*  318938 */     // GIR_Coverage, 19896,
     /*  318938 */     GIR_EraseRootFromParent_Done,
     /*  318939 */   // Label 5914: @318939
     /*  318939 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(319002), // Rule ID 19897 //
     /*  318944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  318958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  318961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318983 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  318983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  318986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319000 */     GIR_RootConstrainSelectedInstOperands,
     /*  319001 */     // GIR_Coverage, 19897,
     /*  319001 */     GIR_EraseRootFromParent_Done,
     /*  319002 */   // Label 5915: @319002
     /*  319002 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(319065), // Rule ID 19900 //
     /*  319007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  319021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319046 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319063 */     GIR_RootConstrainSelectedInstOperands,
     /*  319064 */     // GIR_Coverage, 19900,
     /*  319064 */     GIR_EraseRootFromParent_Done,
     /*  319065 */   // Label 5916: @319065
     /*  319065 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(319128), // Rule ID 19901 //
     /*  319070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  319084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319109 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319126 */     GIR_RootConstrainSelectedInstOperands,
     /*  319127 */     // GIR_Coverage, 19901,
     /*  319127 */     GIR_EraseRootFromParent_Done,
     /*  319128 */   // Label 5917: @319128
     /*  319128 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(319191), // Rule ID 19904 //
     /*  319133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  319147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319172 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319189 */     GIR_RootConstrainSelectedInstOperands,
     /*  319190 */     // GIR_Coverage, 19904,
     /*  319190 */     GIR_EraseRootFromParent_Done,
     /*  319191 */   // Label 5918: @319191
     /*  319191 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(319254), // Rule ID 19905 //
     /*  319196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  319210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319235 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319252 */     GIR_RootConstrainSelectedInstOperands,
     /*  319253 */     // GIR_Coverage, 19905,
     /*  319253 */     GIR_EraseRootFromParent_Done,
     /*  319254 */   // Label 5919: @319254
     /*  319254 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(319317), // Rule ID 19908 //
     /*  319259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  319273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  319276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319298 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319315 */     GIR_RootConstrainSelectedInstOperands,
     /*  319316 */     // GIR_Coverage, 19908,
     /*  319316 */     GIR_EraseRootFromParent_Done,
     /*  319317 */   // Label 5920: @319317
     /*  319317 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(319380), // Rule ID 19909 //
     /*  319322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  319336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  319339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319361 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319378 */     GIR_RootConstrainSelectedInstOperands,
     /*  319379 */     // GIR_Coverage, 19909,
     /*  319379 */     GIR_EraseRootFromParent_Done,
     /*  319380 */   // Label 5921: @319380
     /*  319380 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(319443), // Rule ID 19912 //
     /*  319385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  319399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  319402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319424 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319441 */     GIR_RootConstrainSelectedInstOperands,
     /*  319442 */     // GIR_Coverage, 19912,
     /*  319442 */     GIR_EraseRootFromParent_Done,
     /*  319443 */   // Label 5922: @319443
     /*  319443 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(319506), // Rule ID 19913 //
     /*  319448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  319462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  319465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319487 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319504 */     GIR_RootConstrainSelectedInstOperands,
     /*  319505 */     // GIR_Coverage, 19913,
     /*  319505 */     GIR_EraseRootFromParent_Done,
     /*  319506 */   // Label 5923: @319506
     /*  319506 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(319569), // Rule ID 19916 //
     /*  319511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  319514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  319525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  319528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319550 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  319550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319567 */     GIR_RootConstrainSelectedInstOperands,
     /*  319568 */     // GIR_Coverage, 19916,
     /*  319568 */     GIR_EraseRootFromParent_Done,
     /*  319569 */   // Label 5924: @319569
     /*  319569 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(319632), // Rule ID 19917 //
     /*  319574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  319577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  319588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  319591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319613 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  319613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319630 */     GIR_RootConstrainSelectedInstOperands,
     /*  319631 */     // GIR_Coverage, 19917,
     /*  319631 */     GIR_EraseRootFromParent_Done,
     /*  319632 */   // Label 5925: @319632
     /*  319632 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(319695), // Rule ID 19920 //
     /*  319637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  319651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  319654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319676 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  319679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319693 */     GIR_RootConstrainSelectedInstOperands,
     /*  319694 */     // GIR_Coverage, 19920,
     /*  319694 */     GIR_EraseRootFromParent_Done,
     /*  319695 */   // Label 5926: @319695
     /*  319695 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(319758), // Rule ID 19921 //
     /*  319700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  319714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  319717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319739 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  319742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319756 */     GIR_RootConstrainSelectedInstOperands,
     /*  319757 */     // GIR_Coverage, 19921,
     /*  319757 */     GIR_EraseRootFromParent_Done,
     /*  319758 */   // Label 5927: @319758
     /*  319758 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(319821), // Rule ID 19924 //
     /*  319763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  319774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  319777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  319780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319802 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  319805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319819 */     GIR_RootConstrainSelectedInstOperands,
     /*  319820 */     // GIR_Coverage, 19924,
     /*  319820 */     GIR_EraseRootFromParent_Done,
     /*  319821 */   // Label 5928: @319821
     /*  319821 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(319884), // Rule ID 19925 //
     /*  319826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  319837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  319840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  319843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319865 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  319868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319882 */     GIR_RootConstrainSelectedInstOperands,
     /*  319883 */     // GIR_Coverage, 19925,
     /*  319883 */     GIR_EraseRootFromParent_Done,
     /*  319884 */   // Label 5929: @319884
     /*  319884 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(319947), // Rule ID 19928 //
     /*  319889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  319900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  319903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  319906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319928 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  319931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319945 */     GIR_RootConstrainSelectedInstOperands,
     /*  319946 */     // GIR_Coverage, 19928,
     /*  319946 */     GIR_EraseRootFromParent_Done,
     /*  319947 */   // Label 5930: @319947
     /*  319947 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(320010), // Rule ID 19929 //
     /*  319952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  319963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  319966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  319969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319991 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  319994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320008 */     GIR_RootConstrainSelectedInstOperands,
     /*  320009 */     // GIR_Coverage, 19929,
     /*  320009 */     GIR_EraseRootFromParent_Done,
     /*  320010 */   // Label 5931: @320010
     /*  320010 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(320073), // Rule ID 19932 //
     /*  320015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  320029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  320032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320054 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320071 */     GIR_RootConstrainSelectedInstOperands,
     /*  320072 */     // GIR_Coverage, 19932,
     /*  320072 */     GIR_EraseRootFromParent_Done,
     /*  320073 */   // Label 5932: @320073
     /*  320073 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(320136), // Rule ID 19933 //
     /*  320078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  320092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  320095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320117 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320134 */     GIR_RootConstrainSelectedInstOperands,
     /*  320135 */     // GIR_Coverage, 19933,
     /*  320135 */     GIR_EraseRootFromParent_Done,
     /*  320136 */   // Label 5933: @320136
     /*  320136 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(320199), // Rule ID 19936 //
     /*  320141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  320155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  320158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320180 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320197 */     GIR_RootConstrainSelectedInstOperands,
     /*  320198 */     // GIR_Coverage, 19936,
     /*  320198 */     GIR_EraseRootFromParent_Done,
     /*  320199 */   // Label 5934: @320199
     /*  320199 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(320262), // Rule ID 19937 //
     /*  320204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  320218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  320221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320243 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320260 */     GIR_RootConstrainSelectedInstOperands,
     /*  320261 */     // GIR_Coverage, 19937,
     /*  320261 */     GIR_EraseRootFromParent_Done,
     /*  320262 */   // Label 5935: @320262
     /*  320262 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(320325), // Rule ID 19940 //
     /*  320267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  320281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  320284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320306 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320323 */     GIR_RootConstrainSelectedInstOperands,
     /*  320324 */     // GIR_Coverage, 19940,
     /*  320324 */     GIR_EraseRootFromParent_Done,
     /*  320325 */   // Label 5936: @320325
     /*  320325 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(320388), // Rule ID 19941 //
     /*  320330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  320344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  320347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320369 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320386 */     GIR_RootConstrainSelectedInstOperands,
     /*  320387 */     // GIR_Coverage, 19941,
     /*  320387 */     GIR_EraseRootFromParent_Done,
     /*  320388 */   // Label 5937: @320388
     /*  320388 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(320451), // Rule ID 19944 //
     /*  320393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  320407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  320410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320432 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320449 */     GIR_RootConstrainSelectedInstOperands,
     /*  320450 */     // GIR_Coverage, 19944,
     /*  320450 */     GIR_EraseRootFromParent_Done,
     /*  320451 */   // Label 5938: @320451
     /*  320451 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(320514), // Rule ID 19945 //
     /*  320456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  320470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  320473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320495 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320512 */     GIR_RootConstrainSelectedInstOperands,
     /*  320513 */     // GIR_Coverage, 19945,
     /*  320513 */     GIR_EraseRootFromParent_Done,
     /*  320514 */   // Label 5939: @320514
     /*  320514 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(320577), // Rule ID 19948 //
     /*  320519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  320533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  320536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320558 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320575 */     GIR_RootConstrainSelectedInstOperands,
     /*  320576 */     // GIR_Coverage, 19948,
     /*  320576 */     GIR_EraseRootFromParent_Done,
     /*  320577 */   // Label 5940: @320577
     /*  320577 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(320640), // Rule ID 19949 //
     /*  320582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  320596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  320599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320621 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320638 */     GIR_RootConstrainSelectedInstOperands,
     /*  320639 */     // GIR_Coverage, 19949,
     /*  320639 */     GIR_EraseRootFromParent_Done,
     /*  320640 */   // Label 5941: @320640
     /*  320640 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(320703), // Rule ID 19952 //
     /*  320645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  320659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  320662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320684 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320701 */     GIR_RootConstrainSelectedInstOperands,
     /*  320702 */     // GIR_Coverage, 19952,
     /*  320702 */     GIR_EraseRootFromParent_Done,
     /*  320703 */   // Label 5942: @320703
     /*  320703 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(320766), // Rule ID 19953 //
     /*  320708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  320722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  320725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320747 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320764 */     GIR_RootConstrainSelectedInstOperands,
     /*  320765 */     // GIR_Coverage, 19953,
     /*  320765 */     GIR_EraseRootFromParent_Done,
     /*  320766 */   // Label 5943: @320766
     /*  320766 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(320829), // Rule ID 19956 //
     /*  320771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  320785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320810 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  320813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320827 */     GIR_RootConstrainSelectedInstOperands,
     /*  320828 */     // GIR_Coverage, 19956,
     /*  320828 */     GIR_EraseRootFromParent_Done,
     /*  320829 */   // Label 5944: @320829
     /*  320829 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(320892), // Rule ID 19957 //
     /*  320834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  320848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320873 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  320876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320890 */     GIR_RootConstrainSelectedInstOperands,
     /*  320891 */     // GIR_Coverage, 19957,
     /*  320891 */     GIR_EraseRootFromParent_Done,
     /*  320892 */   // Label 5945: @320892
     /*  320892 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(320955), // Rule ID 19960 //
     /*  320897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  320911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320936 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  320939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320953 */     GIR_RootConstrainSelectedInstOperands,
     /*  320954 */     // GIR_Coverage, 19960,
     /*  320954 */     GIR_EraseRootFromParent_Done,
     /*  320955 */   // Label 5946: @320955
     /*  320955 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(321018), // Rule ID 19961 //
     /*  320960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  320974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320999 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  321002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321016 */     GIR_RootConstrainSelectedInstOperands,
     /*  321017 */     // GIR_Coverage, 19961,
     /*  321017 */     GIR_EraseRootFromParent_Done,
     /*  321018 */   // Label 5947: @321018
     /*  321018 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(321081), // Rule ID 19964 //
     /*  321023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  321037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321062 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  321065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321079 */     GIR_RootConstrainSelectedInstOperands,
     /*  321080 */     // GIR_Coverage, 19964,
     /*  321080 */     GIR_EraseRootFromParent_Done,
     /*  321081 */   // Label 5948: @321081
     /*  321081 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(321144), // Rule ID 19965 //
     /*  321086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  321100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321125 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  321128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321142 */     GIR_RootConstrainSelectedInstOperands,
     /*  321143 */     // GIR_Coverage, 19965,
     /*  321143 */     GIR_EraseRootFromParent_Done,
     /*  321144 */   // Label 5949: @321144
     /*  321144 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(321207), // Rule ID 19968 //
     /*  321149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  321163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321188 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  321191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321205 */     GIR_RootConstrainSelectedInstOperands,
     /*  321206 */     // GIR_Coverage, 19968,
     /*  321206 */     GIR_EraseRootFromParent_Done,
     /*  321207 */   // Label 5950: @321207
     /*  321207 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(321270), // Rule ID 19969 //
     /*  321212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  321226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321251 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  321254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321268 */     GIR_RootConstrainSelectedInstOperands,
     /*  321269 */     // GIR_Coverage, 19969,
     /*  321269 */     GIR_EraseRootFromParent_Done,
     /*  321270 */   // Label 5951: @321270
     /*  321270 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(321333), // Rule ID 19972 //
     /*  321275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  321289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321314 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  321317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321331 */     GIR_RootConstrainSelectedInstOperands,
     /*  321332 */     // GIR_Coverage, 19972,
     /*  321332 */     GIR_EraseRootFromParent_Done,
     /*  321333 */   // Label 5952: @321333
     /*  321333 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(321396), // Rule ID 19973 //
     /*  321338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  321352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321377 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  321380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321394 */     GIR_RootConstrainSelectedInstOperands,
     /*  321395 */     // GIR_Coverage, 19973,
     /*  321395 */     GIR_EraseRootFromParent_Done,
     /*  321396 */   // Label 5953: @321396
     /*  321396 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(321459), // Rule ID 19976 //
     /*  321401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  321404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  321415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321440 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  321443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321457 */     GIR_RootConstrainSelectedInstOperands,
     /*  321458 */     // GIR_Coverage, 19976,
     /*  321458 */     GIR_EraseRootFromParent_Done,
     /*  321459 */   // Label 5954: @321459
     /*  321459 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(321522), // Rule ID 19977 //
     /*  321464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  321467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  321478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321503 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  321506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321520 */     GIR_RootConstrainSelectedInstOperands,
     /*  321521 */     // GIR_Coverage, 19977,
     /*  321521 */     GIR_EraseRootFromParent_Done,
     /*  321522 */   // Label 5955: @321522
     /*  321522 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(321585), // Rule ID 19980 //
     /*  321527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  321541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321566 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  321569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321583 */     GIR_RootConstrainSelectedInstOperands,
     /*  321584 */     // GIR_Coverage, 19980,
     /*  321584 */     GIR_EraseRootFromParent_Done,
     /*  321585 */   // Label 5956: @321585
     /*  321585 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(321648), // Rule ID 19981 //
     /*  321590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  321604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321629 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  321632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321646 */     GIR_RootConstrainSelectedInstOperands,
     /*  321647 */     // GIR_Coverage, 19981,
     /*  321647 */     GIR_EraseRootFromParent_Done,
     /*  321648 */   // Label 5957: @321648
     /*  321648 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(321711), // Rule ID 19984 //
     /*  321653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  321664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  321667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321692 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  321695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321709 */     GIR_RootConstrainSelectedInstOperands,
     /*  321710 */     // GIR_Coverage, 19984,
     /*  321710 */     GIR_EraseRootFromParent_Done,
     /*  321711 */   // Label 5958: @321711
     /*  321711 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(321774), // Rule ID 19985 //
     /*  321716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  321727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  321730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321755 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  321758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321772 */     GIR_RootConstrainSelectedInstOperands,
     /*  321773 */     // GIR_Coverage, 19985,
     /*  321773 */     GIR_EraseRootFromParent_Done,
     /*  321774 */   // Label 5959: @321774
     /*  321774 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(321837), // Rule ID 19988 //
     /*  321779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  321790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  321793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321818 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  321821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321835 */     GIR_RootConstrainSelectedInstOperands,
     /*  321836 */     // GIR_Coverage, 19988,
     /*  321836 */     GIR_EraseRootFromParent_Done,
     /*  321837 */   // Label 5960: @321837
     /*  321837 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(321900), // Rule ID 19989 //
     /*  321842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  321853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  321856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321881 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  321884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321898 */     GIR_RootConstrainSelectedInstOperands,
     /*  321899 */     // GIR_Coverage, 19989,
     /*  321899 */     GIR_EraseRootFromParent_Done,
     /*  321900 */   // Label 5961: @321900
     /*  321900 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(321963), // Rule ID 19992 //
     /*  321905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  321919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321944 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  321947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321961 */     GIR_RootConstrainSelectedInstOperands,
     /*  321962 */     // GIR_Coverage, 19992,
     /*  321962 */     GIR_EraseRootFromParent_Done,
     /*  321963 */   // Label 5962: @321963
     /*  321963 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(322026), // Rule ID 19993 //
     /*  321968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  321982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322007 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  322010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322024 */     GIR_RootConstrainSelectedInstOperands,
     /*  322025 */     // GIR_Coverage, 19993,
     /*  322025 */     GIR_EraseRootFromParent_Done,
     /*  322026 */   // Label 5963: @322026
     /*  322026 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(322089), // Rule ID 19996 //
     /*  322031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  322045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322070 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  322073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322087 */     GIR_RootConstrainSelectedInstOperands,
     /*  322088 */     // GIR_Coverage, 19996,
     /*  322088 */     GIR_EraseRootFromParent_Done,
     /*  322089 */   // Label 5964: @322089
     /*  322089 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(322152), // Rule ID 19997 //
     /*  322094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  322108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322133 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  322136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322150 */     GIR_RootConstrainSelectedInstOperands,
     /*  322151 */     // GIR_Coverage, 19997,
     /*  322151 */     GIR_EraseRootFromParent_Done,
     /*  322152 */   // Label 5965: @322152
     /*  322152 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(322215), // Rule ID 20000 //
     /*  322157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  322171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322196 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  322199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322213 */     GIR_RootConstrainSelectedInstOperands,
     /*  322214 */     // GIR_Coverage, 20000,
     /*  322214 */     GIR_EraseRootFromParent_Done,
     /*  322215 */   // Label 5966: @322215
     /*  322215 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(322278), // Rule ID 20001 //
     /*  322220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  322234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322259 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  322262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322276 */     GIR_RootConstrainSelectedInstOperands,
     /*  322277 */     // GIR_Coverage, 20001,
     /*  322277 */     GIR_EraseRootFromParent_Done,
     /*  322278 */   // Label 5967: @322278
     /*  322278 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(322341), // Rule ID 20004 //
     /*  322283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  322297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322322 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  322325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322339 */     GIR_RootConstrainSelectedInstOperands,
     /*  322340 */     // GIR_Coverage, 20004,
     /*  322340 */     GIR_EraseRootFromParent_Done,
     /*  322341 */   // Label 5968: @322341
     /*  322341 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(322404), // Rule ID 20005 //
     /*  322346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  322360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322385 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  322388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322402 */     GIR_RootConstrainSelectedInstOperands,
     /*  322403 */     // GIR_Coverage, 20005,
     /*  322403 */     GIR_EraseRootFromParent_Done,
     /*  322404 */   // Label 5969: @322404
     /*  322404 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(322467), // Rule ID 20008 //
     /*  322409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  322423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322448 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  322451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322465 */     GIR_RootConstrainSelectedInstOperands,
     /*  322466 */     // GIR_Coverage, 20008,
     /*  322466 */     GIR_EraseRootFromParent_Done,
     /*  322467 */   // Label 5970: @322467
     /*  322467 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(322530), // Rule ID 20009 //
     /*  322472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  322486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322511 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  322514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322528 */     GIR_RootConstrainSelectedInstOperands,
     /*  322529 */     // GIR_Coverage, 20009,
     /*  322529 */     GIR_EraseRootFromParent_Done,
     /*  322530 */   // Label 5971: @322530
     /*  322530 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(322593), // Rule ID 20012 //
     /*  322535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  322549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322574 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  322577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322591 */     GIR_RootConstrainSelectedInstOperands,
     /*  322592 */     // GIR_Coverage, 20012,
     /*  322592 */     GIR_EraseRootFromParent_Done,
     /*  322593 */   // Label 5972: @322593
     /*  322593 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(322656), // Rule ID 20013 //
     /*  322598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  322612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322637 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  322640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322654 */     GIR_RootConstrainSelectedInstOperands,
     /*  322655 */     // GIR_Coverage, 20013,
     /*  322655 */     GIR_EraseRootFromParent_Done,
     /*  322656 */   // Label 5973: @322656
     /*  322656 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(322719), // Rule ID 20016 //
     /*  322661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  322675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  322678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322700 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  322703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322717 */     GIR_RootConstrainSelectedInstOperands,
     /*  322718 */     // GIR_Coverage, 20016,
     /*  322718 */     GIR_EraseRootFromParent_Done,
     /*  322719 */   // Label 5974: @322719
     /*  322719 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(322782), // Rule ID 20017 //
     /*  322724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  322738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  322741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322763 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  322766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322780 */     GIR_RootConstrainSelectedInstOperands,
     /*  322781 */     // GIR_Coverage, 20017,
     /*  322781 */     GIR_EraseRootFromParent_Done,
     /*  322782 */   // Label 5975: @322782
     /*  322782 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(322845), // Rule ID 20020 //
     /*  322787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  322801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  322804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322826 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  322829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322843 */     GIR_RootConstrainSelectedInstOperands,
     /*  322844 */     // GIR_Coverage, 20020,
     /*  322844 */     GIR_EraseRootFromParent_Done,
     /*  322845 */   // Label 5976: @322845
     /*  322845 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(322908), // Rule ID 20021 //
     /*  322850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  322864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  322867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322889 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  322892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322906 */     GIR_RootConstrainSelectedInstOperands,
     /*  322907 */     // GIR_Coverage, 20021,
     /*  322907 */     GIR_EraseRootFromParent_Done,
     /*  322908 */   // Label 5977: @322908
     /*  322908 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(322971), // Rule ID 20024 //
     /*  322913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  322927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  322930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322952 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  322955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322969 */     GIR_RootConstrainSelectedInstOperands,
     /*  322970 */     // GIR_Coverage, 20024,
     /*  322970 */     GIR_EraseRootFromParent_Done,
     /*  322971 */   // Label 5978: @322971
     /*  322971 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(323034), // Rule ID 20025 //
     /*  322976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  322990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  322993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323015 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  323018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323032 */     GIR_RootConstrainSelectedInstOperands,
     /*  323033 */     // GIR_Coverage, 20025,
     /*  323033 */     GIR_EraseRootFromParent_Done,
     /*  323034 */   // Label 5979: @323034
     /*  323034 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(323097), // Rule ID 20028 //
     /*  323039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  323053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  323056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323078 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323095 */     GIR_RootConstrainSelectedInstOperands,
     /*  323096 */     // GIR_Coverage, 20028,
     /*  323096 */     GIR_EraseRootFromParent_Done,
     /*  323097 */   // Label 5980: @323097
     /*  323097 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(323160), // Rule ID 20029 //
     /*  323102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  323116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  323119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323141 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323158 */     GIR_RootConstrainSelectedInstOperands,
     /*  323159 */     // GIR_Coverage, 20029,
     /*  323159 */     GIR_EraseRootFromParent_Done,
     /*  323160 */   // Label 5981: @323160
     /*  323160 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(323223), // Rule ID 20032 //
     /*  323165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  323179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  323182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323204 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323221 */     GIR_RootConstrainSelectedInstOperands,
     /*  323222 */     // GIR_Coverage, 20032,
     /*  323222 */     GIR_EraseRootFromParent_Done,
     /*  323223 */   // Label 5982: @323223
     /*  323223 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(323286), // Rule ID 20033 //
     /*  323228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  323242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  323245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323267 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323284 */     GIR_RootConstrainSelectedInstOperands,
     /*  323285 */     // GIR_Coverage, 20033,
     /*  323285 */     GIR_EraseRootFromParent_Done,
     /*  323286 */   // Label 5983: @323286
     /*  323286 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(323349), // Rule ID 20036 //
     /*  323291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  323294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  323305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  323308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323330 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  323330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323347 */     GIR_RootConstrainSelectedInstOperands,
     /*  323348 */     // GIR_Coverage, 20036,
     /*  323348 */     GIR_EraseRootFromParent_Done,
     /*  323349 */   // Label 5984: @323349
     /*  323349 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(323412), // Rule ID 20037 //
     /*  323354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  323357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  323368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  323371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323393 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  323393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323410 */     GIR_RootConstrainSelectedInstOperands,
     /*  323411 */     // GIR_Coverage, 20037,
     /*  323411 */     GIR_EraseRootFromParent_Done,
     /*  323412 */   // Label 5985: @323412
     /*  323412 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(323475), // Rule ID 20040 //
     /*  323417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  323431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323456 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323473 */     GIR_RootConstrainSelectedInstOperands,
     /*  323474 */     // GIR_Coverage, 20040,
     /*  323474 */     GIR_EraseRootFromParent_Done,
     /*  323475 */   // Label 5986: @323475
     /*  323475 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(323538), // Rule ID 20041 //
     /*  323480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  323494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323519 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323536 */     GIR_RootConstrainSelectedInstOperands,
     /*  323537 */     // GIR_Coverage, 20041,
     /*  323537 */     GIR_EraseRootFromParent_Done,
     /*  323538 */   // Label 5987: @323538
     /*  323538 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(323601), // Rule ID 20044 //
     /*  323543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  323554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  323557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323582 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  323585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323599 */     GIR_RootConstrainSelectedInstOperands,
     /*  323600 */     // GIR_Coverage, 20044,
     /*  323600 */     GIR_EraseRootFromParent_Done,
     /*  323601 */   // Label 5988: @323601
     /*  323601 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(323664), // Rule ID 20045 //
     /*  323606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  323617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  323620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323645 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  323648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323662 */     GIR_RootConstrainSelectedInstOperands,
     /*  323663 */     // GIR_Coverage, 20045,
     /*  323663 */     GIR_EraseRootFromParent_Done,
     /*  323664 */   // Label 5989: @323664
     /*  323664 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(323727), // Rule ID 20048 //
     /*  323669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  323680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  323683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323708 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  323711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323725 */     GIR_RootConstrainSelectedInstOperands,
     /*  323726 */     // GIR_Coverage, 20048,
     /*  323726 */     GIR_EraseRootFromParent_Done,
     /*  323727 */   // Label 5990: @323727
     /*  323727 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(323790), // Rule ID 20049 //
     /*  323732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  323743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  323746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323771 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  323774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323788 */     GIR_RootConstrainSelectedInstOperands,
     /*  323789 */     // GIR_Coverage, 20049,
     /*  323789 */     GIR_EraseRootFromParent_Done,
     /*  323790 */   // Label 5991: @323790
     /*  323790 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(323853), // Rule ID 20052 //
     /*  323795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  323809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  323812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323834 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323851 */     GIR_RootConstrainSelectedInstOperands,
     /*  323852 */     // GIR_Coverage, 20052,
     /*  323852 */     GIR_EraseRootFromParent_Done,
     /*  323853 */   // Label 5992: @323853
     /*  323853 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(323916), // Rule ID 20053 //
     /*  323858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  323872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  323875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323897 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323914 */     GIR_RootConstrainSelectedInstOperands,
     /*  323915 */     // GIR_Coverage, 20053,
     /*  323915 */     GIR_EraseRootFromParent_Done,
     /*  323916 */   // Label 5993: @323916
     /*  323916 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(323979), // Rule ID 20056 //
     /*  323921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  323935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  323938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323960 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  323963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323977 */     GIR_RootConstrainSelectedInstOperands,
     /*  323978 */     // GIR_Coverage, 20056,
     /*  323978 */     GIR_EraseRootFromParent_Done,
     /*  323979 */   // Label 5994: @323979
     /*  323979 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(324042), // Rule ID 20057 //
     /*  323984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  323998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  324001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324023 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324040 */     GIR_RootConstrainSelectedInstOperands,
     /*  324041 */     // GIR_Coverage, 20057,
     /*  324041 */     GIR_EraseRootFromParent_Done,
     /*  324042 */   // Label 5995: @324042
     /*  324042 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(324105), // Rule ID 20060 //
     /*  324047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  324061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  324064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324086 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324103 */     GIR_RootConstrainSelectedInstOperands,
     /*  324104 */     // GIR_Coverage, 20060,
     /*  324104 */     GIR_EraseRootFromParent_Done,
     /*  324105 */   // Label 5996: @324105
     /*  324105 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(324168), // Rule ID 20061 //
     /*  324110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  324124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  324127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324149 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324166 */     GIR_RootConstrainSelectedInstOperands,
     /*  324167 */     // GIR_Coverage, 20061,
     /*  324167 */     GIR_EraseRootFromParent_Done,
     /*  324168 */   // Label 5997: @324168
     /*  324168 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(324231), // Rule ID 20064 //
     /*  324173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  324187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  324190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324212 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  324215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324229 */     GIR_RootConstrainSelectedInstOperands,
     /*  324230 */     // GIR_Coverage, 20064,
     /*  324230 */     GIR_EraseRootFromParent_Done,
     /*  324231 */   // Label 5998: @324231
     /*  324231 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(324294), // Rule ID 20065 //
     /*  324236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  324250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  324253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324275 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  324278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324292 */     GIR_RootConstrainSelectedInstOperands,
     /*  324293 */     // GIR_Coverage, 20065,
     /*  324293 */     GIR_EraseRootFromParent_Done,
     /*  324294 */   // Label 5999: @324294
     /*  324294 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(324357), // Rule ID 20068 //
     /*  324299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  324313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  324316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324338 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324355 */     GIR_RootConstrainSelectedInstOperands,
     /*  324356 */     // GIR_Coverage, 20068,
     /*  324356 */     GIR_EraseRootFromParent_Done,
     /*  324357 */   // Label 6000: @324357
     /*  324357 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(324420), // Rule ID 20069 //
     /*  324362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  324376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  324379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324401 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324418 */     GIR_RootConstrainSelectedInstOperands,
     /*  324419 */     // GIR_Coverage, 20069,
     /*  324419 */     GIR_EraseRootFromParent_Done,
     /*  324420 */   // Label 6001: @324420
     /*  324420 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(324483), // Rule ID 20072 //
     /*  324425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  324439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  324442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324464 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324481 */     GIR_RootConstrainSelectedInstOperands,
     /*  324482 */     // GIR_Coverage, 20072,
     /*  324482 */     GIR_EraseRootFromParent_Done,
     /*  324483 */   // Label 6002: @324483
     /*  324483 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(324546), // Rule ID 20073 //
     /*  324488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  324502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  324505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324527 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324544 */     GIR_RootConstrainSelectedInstOperands,
     /*  324545 */     // GIR_Coverage, 20073,
     /*  324545 */     GIR_EraseRootFromParent_Done,
     /*  324546 */   // Label 6003: @324546
     /*  324546 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(324609), // Rule ID 20076 //
     /*  324551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  324565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324590 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  324593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324607 */     GIR_RootConstrainSelectedInstOperands,
     /*  324608 */     // GIR_Coverage, 20076,
     /*  324608 */     GIR_EraseRootFromParent_Done,
     /*  324609 */   // Label 6004: @324609
     /*  324609 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(324672), // Rule ID 20077 //
     /*  324614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  324628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324653 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  324656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324670 */     GIR_RootConstrainSelectedInstOperands,
     /*  324671 */     // GIR_Coverage, 20077,
     /*  324671 */     GIR_EraseRootFromParent_Done,
     /*  324672 */   // Label 6005: @324672
     /*  324672 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(324735), // Rule ID 20080 //
     /*  324677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  324691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324716 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  324719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324733 */     GIR_RootConstrainSelectedInstOperands,
     /*  324734 */     // GIR_Coverage, 20080,
     /*  324734 */     GIR_EraseRootFromParent_Done,
     /*  324735 */   // Label 6006: @324735
     /*  324735 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(324798), // Rule ID 20081 //
     /*  324740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  324754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324779 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  324782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324796 */     GIR_RootConstrainSelectedInstOperands,
     /*  324797 */     // GIR_Coverage, 20081,
     /*  324797 */     GIR_EraseRootFromParent_Done,
     /*  324798 */   // Label 6007: @324798
     /*  324798 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(324861), // Rule ID 20084 //
     /*  324803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  324817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  324820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324842 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  324845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324859 */     GIR_RootConstrainSelectedInstOperands,
     /*  324860 */     // GIR_Coverage, 20084,
     /*  324860 */     GIR_EraseRootFromParent_Done,
     /*  324861 */   // Label 6008: @324861
     /*  324861 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(324924), // Rule ID 20085 //
     /*  324866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  324880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  324883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324905 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  324908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324922 */     GIR_RootConstrainSelectedInstOperands,
     /*  324923 */     // GIR_Coverage, 20085,
     /*  324923 */     GIR_EraseRootFromParent_Done,
     /*  324924 */   // Label 6009: @324924
     /*  324924 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(324987), // Rule ID 20088 //
     /*  324929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  324943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324968 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  324971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324985 */     GIR_RootConstrainSelectedInstOperands,
     /*  324986 */     // GIR_Coverage, 20088,
     /*  324986 */     GIR_EraseRootFromParent_Done,
     /*  324987 */   // Label 6010: @324987
     /*  324987 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(325050), // Rule ID 20089 //
     /*  324992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  325006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325031 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  325034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325048 */     GIR_RootConstrainSelectedInstOperands,
     /*  325049 */     // GIR_Coverage, 20089,
     /*  325049 */     GIR_EraseRootFromParent_Done,
     /*  325050 */   // Label 6011: @325050
     /*  325050 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(325113), // Rule ID 20092 //
     /*  325055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  325069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325094 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  325097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325111 */     GIR_RootConstrainSelectedInstOperands,
     /*  325112 */     // GIR_Coverage, 20092,
     /*  325112 */     GIR_EraseRootFromParent_Done,
     /*  325113 */   // Label 6012: @325113
     /*  325113 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(325176), // Rule ID 20093 //
     /*  325118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  325132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325157 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  325160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325174 */     GIR_RootConstrainSelectedInstOperands,
     /*  325175 */     // GIR_Coverage, 20093,
     /*  325175 */     GIR_EraseRootFromParent_Done,
     /*  325176 */   // Label 6013: @325176
     /*  325176 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(325239), // Rule ID 20096 //
     /*  325181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  325184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  325195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325220 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  325220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  325223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325237 */     GIR_RootConstrainSelectedInstOperands,
     /*  325238 */     // GIR_Coverage, 20096,
     /*  325238 */     GIR_EraseRootFromParent_Done,
     /*  325239 */   // Label 6014: @325239
     /*  325239 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(325302), // Rule ID 20097 //
     /*  325244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  325247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  325258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325283 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  325283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  325286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325300 */     GIR_RootConstrainSelectedInstOperands,
     /*  325301 */     // GIR_Coverage, 20097,
     /*  325301 */     GIR_EraseRootFromParent_Done,
     /*  325302 */   // Label 6015: @325302
     /*  325302 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(325365), // Rule ID 20100 //
     /*  325307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  325321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325346 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  325349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325363 */     GIR_RootConstrainSelectedInstOperands,
     /*  325364 */     // GIR_Coverage, 20100,
     /*  325364 */     GIR_EraseRootFromParent_Done,
     /*  325365 */   // Label 6016: @325365
     /*  325365 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(325428), // Rule ID 20101 //
     /*  325370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  325384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325409 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  325412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325426 */     GIR_RootConstrainSelectedInstOperands,
     /*  325427 */     // GIR_Coverage, 20101,
     /*  325427 */     GIR_EraseRootFromParent_Done,
     /*  325428 */   // Label 6017: @325428
     /*  325428 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(325491), // Rule ID 20104 //
     /*  325433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  325447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325472 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  325475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325489 */     GIR_RootConstrainSelectedInstOperands,
     /*  325490 */     // GIR_Coverage, 20104,
     /*  325490 */     GIR_EraseRootFromParent_Done,
     /*  325491 */   // Label 6018: @325491
     /*  325491 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(325554), // Rule ID 20105 //
     /*  325496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  325510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325535 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  325538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325552 */     GIR_RootConstrainSelectedInstOperands,
     /*  325553 */     // GIR_Coverage, 20105,
     /*  325553 */     GIR_EraseRootFromParent_Done,
     /*  325554 */   // Label 6019: @325554
     /*  325554 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(325617), // Rule ID 20108 //
     /*  325559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  325570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  325573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325598 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  325601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325615 */     GIR_RootConstrainSelectedInstOperands,
     /*  325616 */     // GIR_Coverage, 20108,
     /*  325616 */     GIR_EraseRootFromParent_Done,
     /*  325617 */   // Label 6020: @325617
     /*  325617 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(325680), // Rule ID 20109 //
     /*  325622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  325633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  325636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325661 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  325664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325678 */     GIR_RootConstrainSelectedInstOperands,
     /*  325679 */     // GIR_Coverage, 20109,
     /*  325679 */     GIR_EraseRootFromParent_Done,
     /*  325680 */   // Label 6021: @325680
     /*  325680 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(325743), // Rule ID 20112 //
     /*  325685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  325699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325724 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  325727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325741 */     GIR_RootConstrainSelectedInstOperands,
     /*  325742 */     // GIR_Coverage, 20112,
     /*  325742 */     GIR_EraseRootFromParent_Done,
     /*  325743 */   // Label 6022: @325743
     /*  325743 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(325806), // Rule ID 20113 //
     /*  325748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  325762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325787 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  325790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325804 */     GIR_RootConstrainSelectedInstOperands,
     /*  325805 */     // GIR_Coverage, 20113,
     /*  325805 */     GIR_EraseRootFromParent_Done,
     /*  325806 */   // Label 6023: @325806
     /*  325806 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(325869), // Rule ID 20116 //
     /*  325811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  325825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325850 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  325853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325867 */     GIR_RootConstrainSelectedInstOperands,
     /*  325868 */     // GIR_Coverage, 20116,
     /*  325868 */     GIR_EraseRootFromParent_Done,
     /*  325869 */   // Label 6024: @325869
     /*  325869 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(325932), // Rule ID 20117 //
     /*  325874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  325888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325913 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  325916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325930 */     GIR_RootConstrainSelectedInstOperands,
     /*  325931 */     // GIR_Coverage, 20117,
     /*  325931 */     GIR_EraseRootFromParent_Done,
     /*  325932 */   // Label 6025: @325932
     /*  325932 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(325995), // Rule ID 20120 //
     /*  325937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  325951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325976 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  325979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325993 */     GIR_RootConstrainSelectedInstOperands,
     /*  325994 */     // GIR_Coverage, 20120,
     /*  325994 */     GIR_EraseRootFromParent_Done,
     /*  325995 */   // Label 6026: @325995
     /*  325995 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(326058), // Rule ID 20121 //
     /*  326000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  326011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  326014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326039 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  326042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326056 */     GIR_RootConstrainSelectedInstOperands,
     /*  326057 */     // GIR_Coverage, 20121,
     /*  326057 */     GIR_EraseRootFromParent_Done,
     /*  326058 */   // Label 6027: @326058
     /*  326058 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(326121), // Rule ID 20124 //
     /*  326063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  326077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326102 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  326105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326119 */     GIR_RootConstrainSelectedInstOperands,
     /*  326120 */     // GIR_Coverage, 20124,
     /*  326120 */     GIR_EraseRootFromParent_Done,
     /*  326121 */   // Label 6028: @326121
     /*  326121 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(326184), // Rule ID 20125 //
     /*  326126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  326140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326165 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  326168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326182 */     GIR_RootConstrainSelectedInstOperands,
     /*  326183 */     // GIR_Coverage, 20125,
     /*  326183 */     GIR_EraseRootFromParent_Done,
     /*  326184 */   // Label 6029: @326184
     /*  326184 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(326247), // Rule ID 20128 //
     /*  326189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  326203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326228 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  326231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326245 */     GIR_RootConstrainSelectedInstOperands,
     /*  326246 */     // GIR_Coverage, 20128,
     /*  326246 */     GIR_EraseRootFromParent_Done,
     /*  326247 */   // Label 6030: @326247
     /*  326247 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(326310), // Rule ID 20129 //
     /*  326252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  326266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326291 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  326294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326308 */     GIR_RootConstrainSelectedInstOperands,
     /*  326309 */     // GIR_Coverage, 20129,
     /*  326309 */     GIR_EraseRootFromParent_Done,
     /*  326310 */   // Label 6031: @326310
     /*  326310 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(326373), // Rule ID 20132 //
     /*  326315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  326329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326354 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  326357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326371 */     GIR_RootConstrainSelectedInstOperands,
     /*  326372 */     // GIR_Coverage, 20132,
     /*  326372 */     GIR_EraseRootFromParent_Done,
     /*  326373 */   // Label 6032: @326373
     /*  326373 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(326436), // Rule ID 20133 //
     /*  326378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  326392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326417 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  326420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326434 */     GIR_RootConstrainSelectedInstOperands,
     /*  326435 */     // GIR_Coverage, 20133,
     /*  326435 */     GIR_EraseRootFromParent_Done,
     /*  326436 */   // Label 6033: @326436
     /*  326436 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(326499), // Rule ID 20136 //
     /*  326441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  326455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  326458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326480 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  326483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326497 */     GIR_RootConstrainSelectedInstOperands,
     /*  326498 */     // GIR_Coverage, 20136,
     /*  326498 */     GIR_EraseRootFromParent_Done,
     /*  326499 */   // Label 6034: @326499
     /*  326499 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(326562), // Rule ID 20137 //
     /*  326504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  326518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  326521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326543 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  326546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326560 */     GIR_RootConstrainSelectedInstOperands,
     /*  326561 */     // GIR_Coverage, 20137,
     /*  326561 */     GIR_EraseRootFromParent_Done,
     /*  326562 */   // Label 6035: @326562
     /*  326562 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(326625), // Rule ID 20140 //
     /*  326567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  326581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  326584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326606 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  326609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326623 */     GIR_RootConstrainSelectedInstOperands,
     /*  326624 */     // GIR_Coverage, 20140,
     /*  326624 */     GIR_EraseRootFromParent_Done,
     /*  326625 */   // Label 6036: @326625
     /*  326625 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(326688), // Rule ID 20141 //
     /*  326630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  326644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  326647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326669 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  326672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326686 */     GIR_RootConstrainSelectedInstOperands,
     /*  326687 */     // GIR_Coverage, 20141,
     /*  326687 */     GIR_EraseRootFromParent_Done,
     /*  326688 */   // Label 6037: @326688
     /*  326688 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(326751), // Rule ID 20144 //
     /*  326693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  326707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  326710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326732 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  326735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326749 */     GIR_RootConstrainSelectedInstOperands,
     /*  326750 */     // GIR_Coverage, 20144,
     /*  326750 */     GIR_EraseRootFromParent_Done,
     /*  326751 */   // Label 6038: @326751
     /*  326751 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(326814), // Rule ID 20145 //
     /*  326756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  326770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  326773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326795 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  326798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326812 */     GIR_RootConstrainSelectedInstOperands,
     /*  326813 */     // GIR_Coverage, 20145,
     /*  326813 */     GIR_EraseRootFromParent_Done,
     /*  326814 */   // Label 6039: @326814
     /*  326814 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(326877), // Rule ID 20148 //
     /*  326819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  326833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  326836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326858 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  326861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326875 */     GIR_RootConstrainSelectedInstOperands,
     /*  326876 */     // GIR_Coverage, 20148,
     /*  326876 */     GIR_EraseRootFromParent_Done,
     /*  326877 */   // Label 6040: @326877
     /*  326877 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(326940), // Rule ID 20149 //
     /*  326882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  326896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  326899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326921 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  326924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326938 */     GIR_RootConstrainSelectedInstOperands,
     /*  326939 */     // GIR_Coverage, 20149,
     /*  326939 */     GIR_EraseRootFromParent_Done,
     /*  326940 */   // Label 6041: @326940
     /*  326940 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(327003), // Rule ID 20152 //
     /*  326945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  326959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  326962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326984 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  326987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327001 */     GIR_RootConstrainSelectedInstOperands,
     /*  327002 */     // GIR_Coverage, 20152,
     /*  327002 */     GIR_EraseRootFromParent_Done,
     /*  327003 */   // Label 6042: @327003
     /*  327003 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(327066), // Rule ID 20153 //
     /*  327008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  327022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  327025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327047 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327064 */     GIR_RootConstrainSelectedInstOperands,
     /*  327065 */     // GIR_Coverage, 20153,
     /*  327065 */     GIR_EraseRootFromParent_Done,
     /*  327066 */   // Label 6043: @327066
     /*  327066 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(327129), // Rule ID 20156 //
     /*  327071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  327074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  327085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  327088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327110 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  327110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327127 */     GIR_RootConstrainSelectedInstOperands,
     /*  327128 */     // GIR_Coverage, 20156,
     /*  327128 */     GIR_EraseRootFromParent_Done,
     /*  327129 */   // Label 6044: @327129
     /*  327129 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(327192), // Rule ID 20157 //
     /*  327134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  327137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  327148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  327151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327173 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  327173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327190 */     GIR_RootConstrainSelectedInstOperands,
     /*  327191 */     // GIR_Coverage, 20157,
     /*  327191 */     GIR_EraseRootFromParent_Done,
     /*  327192 */   // Label 6045: @327192
     /*  327192 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(327255), // Rule ID 20160 //
     /*  327197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  327211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  327214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327236 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327253 */     GIR_RootConstrainSelectedInstOperands,
     /*  327254 */     // GIR_Coverage, 20160,
     /*  327254 */     GIR_EraseRootFromParent_Done,
     /*  327255 */   // Label 6046: @327255
     /*  327255 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(327318), // Rule ID 20161 //
     /*  327260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  327274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  327277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327299 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327316 */     GIR_RootConstrainSelectedInstOperands,
     /*  327317 */     // GIR_Coverage, 20161,
     /*  327317 */     GIR_EraseRootFromParent_Done,
     /*  327318 */   // Label 6047: @327318
     /*  327318 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(327381), // Rule ID 20164 //
     /*  327323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  327337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  327340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327362 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327379 */     GIR_RootConstrainSelectedInstOperands,
     /*  327380 */     // GIR_Coverage, 20164,
     /*  327380 */     GIR_EraseRootFromParent_Done,
     /*  327381 */   // Label 6048: @327381
     /*  327381 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(327444), // Rule ID 20165 //
     /*  327386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  327400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  327403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327425 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327442 */     GIR_RootConstrainSelectedInstOperands,
     /*  327443 */     // GIR_Coverage, 20165,
     /*  327443 */     GIR_EraseRootFromParent_Done,
     /*  327444 */   // Label 6049: @327444
     /*  327444 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(327507), // Rule ID 20168 //
     /*  327449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  327460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  327463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  327466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327488 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327505 */     GIR_RootConstrainSelectedInstOperands,
     /*  327506 */     // GIR_Coverage, 20168,
     /*  327506 */     GIR_EraseRootFromParent_Done,
     /*  327507 */   // Label 6050: @327507
     /*  327507 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(327570), // Rule ID 20169 //
     /*  327512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  327523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  327526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  327529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327551 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327568 */     GIR_RootConstrainSelectedInstOperands,
     /*  327569 */     // GIR_Coverage, 20169,
     /*  327569 */     GIR_EraseRootFromParent_Done,
     /*  327570 */   // Label 6051: @327570
     /*  327570 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(327633), // Rule ID 20172 //
     /*  327575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  327589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  327592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327614 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327631 */     GIR_RootConstrainSelectedInstOperands,
     /*  327632 */     // GIR_Coverage, 20172,
     /*  327632 */     GIR_EraseRootFromParent_Done,
     /*  327633 */   // Label 6052: @327633
     /*  327633 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(327696), // Rule ID 20173 //
     /*  327638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  327652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  327655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327677 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327694 */     GIR_RootConstrainSelectedInstOperands,
     /*  327695 */     // GIR_Coverage, 20173,
     /*  327695 */     GIR_EraseRootFromParent_Done,
     /*  327696 */   // Label 6053: @327696
     /*  327696 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(327759), // Rule ID 20176 //
     /*  327701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  327715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  327718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327757 */     GIR_RootConstrainSelectedInstOperands,
     /*  327758 */     // GIR_Coverage, 20176,
     /*  327758 */     GIR_EraseRootFromParent_Done,
     /*  327759 */   // Label 6054: @327759
     /*  327759 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(327822), // Rule ID 20177 //
     /*  327764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  327778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  327781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327803 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327820 */     GIR_RootConstrainSelectedInstOperands,
     /*  327821 */     // GIR_Coverage, 20177,
     /*  327821 */     GIR_EraseRootFromParent_Done,
     /*  327822 */   // Label 6055: @327822
     /*  327822 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(327885), // Rule ID 20180 //
     /*  327827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  327841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  327844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327866 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327883 */     GIR_RootConstrainSelectedInstOperands,
     /*  327884 */     // GIR_Coverage, 20180,
     /*  327884 */     GIR_EraseRootFromParent_Done,
     /*  327885 */   // Label 6056: @327885
     /*  327885 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(327948), // Rule ID 20181 //
     /*  327890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  327904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  327907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327929 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327946 */     GIR_RootConstrainSelectedInstOperands,
     /*  327947 */     // GIR_Coverage, 20181,
     /*  327947 */     GIR_EraseRootFromParent_Done,
     /*  327948 */   // Label 6057: @327948
     /*  327948 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(328011), // Rule ID 20184 //
     /*  327953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  327956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  327967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  327970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327992 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  327992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328009 */     GIR_RootConstrainSelectedInstOperands,
     /*  328010 */     // GIR_Coverage, 20184,
     /*  328010 */     GIR_EraseRootFromParent_Done,
     /*  328011 */   // Label 6058: @328011
     /*  328011 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(328074), // Rule ID 20185 //
     /*  328016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  328030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  328033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328055 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  328058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328072 */     GIR_RootConstrainSelectedInstOperands,
     /*  328073 */     // GIR_Coverage, 20185,
     /*  328073 */     GIR_EraseRootFromParent_Done,
     /*  328074 */   // Label 6059: @328074
     /*  328074 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(328137), // Rule ID 20188 //
     /*  328079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  328093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  328096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328118 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  328121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328135 */     GIR_RootConstrainSelectedInstOperands,
     /*  328136 */     // GIR_Coverage, 20188,
     /*  328136 */     GIR_EraseRootFromParent_Done,
     /*  328137 */   // Label 6060: @328137
     /*  328137 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(328200), // Rule ID 20189 //
     /*  328142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  328156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  328159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328181 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  328184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328198 */     GIR_RootConstrainSelectedInstOperands,
     /*  328199 */     // GIR_Coverage, 20189,
     /*  328199 */     GIR_EraseRootFromParent_Done,
     /*  328200 */   // Label 6061: @328200
     /*  328200 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(328263), // Rule ID 20192 //
     /*  328205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  328219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  328222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328244 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328261 */     GIR_RootConstrainSelectedInstOperands,
     /*  328262 */     // GIR_Coverage, 20192,
     /*  328262 */     GIR_EraseRootFromParent_Done,
     /*  328263 */   // Label 6062: @328263
     /*  328263 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(328326), // Rule ID 20193 //
     /*  328268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  328282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  328285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328307 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328324 */     GIR_RootConstrainSelectedInstOperands,
     /*  328325 */     // GIR_Coverage, 20193,
     /*  328325 */     GIR_EraseRootFromParent_Done,
     /*  328326 */   // Label 6063: @328326
     /*  328326 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(328389), // Rule ID 20196 //
     /*  328331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  328345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328370 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  328373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328387 */     GIR_RootConstrainSelectedInstOperands,
     /*  328388 */     // GIR_Coverage, 20196,
     /*  328388 */     GIR_EraseRootFromParent_Done,
     /*  328389 */   // Label 6064: @328389
     /*  328389 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(328452), // Rule ID 20197 //
     /*  328394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  328408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328433 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  328436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328450 */     GIR_RootConstrainSelectedInstOperands,
     /*  328451 */     // GIR_Coverage, 20197,
     /*  328451 */     GIR_EraseRootFromParent_Done,
     /*  328452 */   // Label 6065: @328452
     /*  328452 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(328515), // Rule ID 20200 //
     /*  328457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  328471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328496 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  328499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328513 */     GIR_RootConstrainSelectedInstOperands,
     /*  328514 */     // GIR_Coverage, 20200,
     /*  328514 */     GIR_EraseRootFromParent_Done,
     /*  328515 */   // Label 6066: @328515
     /*  328515 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(328578), // Rule ID 20201 //
     /*  328520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  328534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328559 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  328562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328576 */     GIR_RootConstrainSelectedInstOperands,
     /*  328577 */     // GIR_Coverage, 20201,
     /*  328577 */     GIR_EraseRootFromParent_Done,
     /*  328578 */   // Label 6067: @328578
     /*  328578 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(328641), // Rule ID 20204 //
     /*  328583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  328597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328622 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  328625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328639 */     GIR_RootConstrainSelectedInstOperands,
     /*  328640 */     // GIR_Coverage, 20204,
     /*  328640 */     GIR_EraseRootFromParent_Done,
     /*  328641 */   // Label 6068: @328641
     /*  328641 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(328704), // Rule ID 20205 //
     /*  328646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  328660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328685 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  328688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328702 */     GIR_RootConstrainSelectedInstOperands,
     /*  328703 */     // GIR_Coverage, 20205,
     /*  328703 */     GIR_EraseRootFromParent_Done,
     /*  328704 */   // Label 6069: @328704
     /*  328704 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(328767), // Rule ID 20208 //
     /*  328709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  328723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328748 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  328751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328765 */     GIR_RootConstrainSelectedInstOperands,
     /*  328766 */     // GIR_Coverage, 20208,
     /*  328766 */     GIR_EraseRootFromParent_Done,
     /*  328767 */   // Label 6070: @328767
     /*  328767 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(328830), // Rule ID 20209 //
     /*  328772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  328786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328811 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  328814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328828 */     GIR_RootConstrainSelectedInstOperands,
     /*  328829 */     // GIR_Coverage, 20209,
     /*  328829 */     GIR_EraseRootFromParent_Done,
     /*  328830 */   // Label 6071: @328830
     /*  328830 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(328893), // Rule ID 20212 //
     /*  328835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  328849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328874 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  328877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328891 */     GIR_RootConstrainSelectedInstOperands,
     /*  328892 */     // GIR_Coverage, 20212,
     /*  328892 */     GIR_EraseRootFromParent_Done,
     /*  328893 */   // Label 6072: @328893
     /*  328893 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(328956), // Rule ID 20213 //
     /*  328898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  328912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328937 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  328940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328954 */     GIR_RootConstrainSelectedInstOperands,
     /*  328955 */     // GIR_Coverage, 20213,
     /*  328955 */     GIR_EraseRootFromParent_Done,
     /*  328956 */   // Label 6073: @328956
     /*  328956 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(329019), // Rule ID 20216 //
     /*  328961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  328975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  328978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  328993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329000 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  329003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329017 */     GIR_RootConstrainSelectedInstOperands,
     /*  329018 */     // GIR_Coverage, 20216,
     /*  329018 */     GIR_EraseRootFromParent_Done,
     /*  329019 */   // Label 6074: @329019
     /*  329019 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(329082), // Rule ID 20217 //
     /*  329024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  329027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  329038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329063 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  329063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  329066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329080 */     GIR_RootConstrainSelectedInstOperands,
     /*  329081 */     // GIR_Coverage, 20217,
     /*  329081 */     GIR_EraseRootFromParent_Done,
     /*  329082 */   // Label 6075: @329082
     /*  329082 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(329145), // Rule ID 20220 //
     /*  329087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  329101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329126 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  329129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329143 */     GIR_RootConstrainSelectedInstOperands,
     /*  329144 */     // GIR_Coverage, 20220,
     /*  329144 */     GIR_EraseRootFromParent_Done,
     /*  329145 */   // Label 6076: @329145
     /*  329145 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(329208), // Rule ID 20221 //
     /*  329150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  329164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329189 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  329192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329206 */     GIR_RootConstrainSelectedInstOperands,
     /*  329207 */     // GIR_Coverage, 20221,
     /*  329207 */     GIR_EraseRootFromParent_Done,
     /*  329208 */   // Label 6077: @329208
     /*  329208 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(329271), // Rule ID 20224 //
     /*  329213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329252 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  329255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329269 */     GIR_RootConstrainSelectedInstOperands,
     /*  329270 */     // GIR_Coverage, 20224,
     /*  329270 */     GIR_EraseRootFromParent_Done,
     /*  329271 */   // Label 6078: @329271
     /*  329271 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(329334), // Rule ID 20225 //
     /*  329276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329315 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  329318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329332 */     GIR_RootConstrainSelectedInstOperands,
     /*  329333 */     // GIR_Coverage, 20225,
     /*  329333 */     GIR_EraseRootFromParent_Done,
     /*  329334 */   // Label 6079: @329334
     /*  329334 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(329397), // Rule ID 20228 //
     /*  329339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329378 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  329381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329395 */     GIR_RootConstrainSelectedInstOperands,
     /*  329396 */     // GIR_Coverage, 20228,
     /*  329396 */     GIR_EraseRootFromParent_Done,
     /*  329397 */   // Label 6080: @329397
     /*  329397 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(329460), // Rule ID 20229 //
     /*  329402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329441 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  329444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329458 */     GIR_RootConstrainSelectedInstOperands,
     /*  329459 */     // GIR_Coverage, 20229,
     /*  329459 */     GIR_EraseRootFromParent_Done,
     /*  329460 */   // Label 6081: @329460
     /*  329460 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(329523), // Rule ID 20232 //
     /*  329465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329504 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  329507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329521 */     GIR_RootConstrainSelectedInstOperands,
     /*  329522 */     // GIR_Coverage, 20232,
     /*  329522 */     GIR_EraseRootFromParent_Done,
     /*  329523 */   // Label 6082: @329523
     /*  329523 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(329586), // Rule ID 20233 //
     /*  329528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329567 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  329570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329584 */     GIR_RootConstrainSelectedInstOperands,
     /*  329585 */     // GIR_Coverage, 20233,
     /*  329585 */     GIR_EraseRootFromParent_Done,
     /*  329586 */   // Label 6083: @329586
     /*  329586 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(329649), // Rule ID 20236 //
     /*  329591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  329605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329630 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  329633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329647 */     GIR_RootConstrainSelectedInstOperands,
     /*  329648 */     // GIR_Coverage, 20236,
     /*  329648 */     GIR_EraseRootFromParent_Done,
     /*  329649 */   // Label 6084: @329649
     /*  329649 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(329712), // Rule ID 20237 //
     /*  329654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  329668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329693 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  329696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329710 */     GIR_RootConstrainSelectedInstOperands,
     /*  329711 */     // GIR_Coverage, 20237,
     /*  329711 */     GIR_EraseRootFromParent_Done,
     /*  329712 */   // Label 6085: @329712
     /*  329712 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(329775), // Rule ID 20240 //
     /*  329717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  329731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329756 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  329759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329773 */     GIR_RootConstrainSelectedInstOperands,
     /*  329774 */     // GIR_Coverage, 20240,
     /*  329774 */     GIR_EraseRootFromParent_Done,
     /*  329775 */   // Label 6086: @329775
     /*  329775 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(329838), // Rule ID 20241 //
     /*  329780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  329794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329819 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  329822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329836 */     GIR_RootConstrainSelectedInstOperands,
     /*  329837 */     // GIR_Coverage, 20241,
     /*  329837 */     GIR_EraseRootFromParent_Done,
     /*  329838 */   // Label 6087: @329838
     /*  329838 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(329901), // Rule ID 20244 //
     /*  329843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  329846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  329857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329882 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  329885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329899 */     GIR_RootConstrainSelectedInstOperands,
     /*  329900 */     // GIR_Coverage, 20244,
     /*  329900 */     GIR_EraseRootFromParent_Done,
     /*  329901 */   // Label 6088: @329901
     /*  329901 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(329964), // Rule ID 20245 //
     /*  329906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  329909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  329920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329945 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  329945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  329948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329962 */     GIR_RootConstrainSelectedInstOperands,
     /*  329963 */     // GIR_Coverage, 20245,
     /*  329963 */     GIR_EraseRootFromParent_Done,
     /*  329964 */   // Label 6089: @329964
     /*  329964 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(330027), // Rule ID 20248 //
     /*  329969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  329972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  329983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330008 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  330011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330025 */     GIR_RootConstrainSelectedInstOperands,
     /*  330026 */     // GIR_Coverage, 20248,
     /*  330026 */     GIR_EraseRootFromParent_Done,
     /*  330027 */   // Label 6090: @330027
     /*  330027 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(330090), // Rule ID 20249 //
     /*  330032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  330046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330071 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  330074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330088 */     GIR_RootConstrainSelectedInstOperands,
     /*  330089 */     // GIR_Coverage, 20249,
     /*  330089 */     GIR_EraseRootFromParent_Done,
     /*  330090 */   // Label 6091: @330090
     /*  330090 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(330153), // Rule ID 20252 //
     /*  330095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330134 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  330137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330151 */     GIR_RootConstrainSelectedInstOperands,
     /*  330152 */     // GIR_Coverage, 20252,
     /*  330152 */     GIR_EraseRootFromParent_Done,
     /*  330153 */   // Label 6092: @330153
     /*  330153 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(330216), // Rule ID 20253 //
     /*  330158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330197 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  330200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330214 */     GIR_RootConstrainSelectedInstOperands,
     /*  330215 */     // GIR_Coverage, 20253,
     /*  330215 */     GIR_EraseRootFromParent_Done,
     /*  330216 */   // Label 6093: @330216
     /*  330216 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(330279), // Rule ID 20256 //
     /*  330221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  330235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330260 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  330263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330277 */     GIR_RootConstrainSelectedInstOperands,
     /*  330278 */     // GIR_Coverage, 20256,
     /*  330278 */     GIR_EraseRootFromParent_Done,
     /*  330279 */   // Label 6094: @330279
     /*  330279 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(330342), // Rule ID 20257 //
     /*  330284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  330298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330323 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  330326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330340 */     GIR_RootConstrainSelectedInstOperands,
     /*  330341 */     // GIR_Coverage, 20257,
     /*  330341 */     GIR_EraseRootFromParent_Done,
     /*  330342 */   // Label 6095: @330342
     /*  330342 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(330405), // Rule ID 20260 //
     /*  330347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  330361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330386 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  330389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330403 */     GIR_RootConstrainSelectedInstOperands,
     /*  330404 */     // GIR_Coverage, 20260,
     /*  330404 */     GIR_EraseRootFromParent_Done,
     /*  330405 */   // Label 6096: @330405
     /*  330405 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(330468), // Rule ID 20261 //
     /*  330410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  330424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330449 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  330452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330466 */     GIR_RootConstrainSelectedInstOperands,
     /*  330467 */     // GIR_Coverage, 20261,
     /*  330467 */     GIR_EraseRootFromParent_Done,
     /*  330468 */   // Label 6097: @330468
     /*  330468 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(330531), // Rule ID 20264 //
     /*  330473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  330487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330512 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  330515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330529 */     GIR_RootConstrainSelectedInstOperands,
     /*  330530 */     // GIR_Coverage, 20264,
     /*  330530 */     GIR_EraseRootFromParent_Done,
     /*  330531 */   // Label 6098: @330531
     /*  330531 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(330594), // Rule ID 20265 //
     /*  330536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  330550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330575 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  330578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330592 */     GIR_RootConstrainSelectedInstOperands,
     /*  330593 */     // GIR_Coverage, 20265,
     /*  330593 */     GIR_EraseRootFromParent_Done,
     /*  330594 */   // Label 6099: @330594
     /*  330594 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(330657), // Rule ID 20268 //
     /*  330599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  330613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330638 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  330641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330655 */     GIR_RootConstrainSelectedInstOperands,
     /*  330656 */     // GIR_Coverage, 20268,
     /*  330656 */     GIR_EraseRootFromParent_Done,
     /*  330657 */   // Label 6100: @330657
     /*  330657 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(330720), // Rule ID 20269 //
     /*  330662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  330676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330701 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  330704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330718 */     GIR_RootConstrainSelectedInstOperands,
     /*  330719 */     // GIR_Coverage, 20269,
     /*  330719 */     GIR_EraseRootFromParent_Done,
     /*  330720 */   // Label 6101: @330720
     /*  330720 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(330783), // Rule ID 20272 //
     /*  330725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  330739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330764 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  330767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330781 */     GIR_RootConstrainSelectedInstOperands,
     /*  330782 */     // GIR_Coverage, 20272,
     /*  330782 */     GIR_EraseRootFromParent_Done,
     /*  330783 */   // Label 6102: @330783
     /*  330783 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(330846), // Rule ID 20273 //
     /*  330788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  330802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330827 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  330830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330844 */     GIR_RootConstrainSelectedInstOperands,
     /*  330845 */     // GIR_Coverage, 20273,
     /*  330845 */     GIR_EraseRootFromParent_Done,
     /*  330846 */   // Label 6103: @330846
     /*  330846 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(330909), // Rule ID 20276 //
     /*  330851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  330865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330890 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  330893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330907 */     GIR_RootConstrainSelectedInstOperands,
     /*  330908 */     // GIR_Coverage, 20276,
     /*  330908 */     GIR_EraseRootFromParent_Done,
     /*  330909 */   // Label 6104: @330909
     /*  330909 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(330972), // Rule ID 20277 //
     /*  330914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  330928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330953 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  330956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330970 */     GIR_RootConstrainSelectedInstOperands,
     /*  330971 */     // GIR_Coverage, 20277,
     /*  330971 */     GIR_EraseRootFromParent_Done,
     /*  330972 */   // Label 6105: @330972
     /*  330972 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(331035), // Rule ID 20280 //
     /*  330977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  330991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331016 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  331019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331033 */     GIR_RootConstrainSelectedInstOperands,
     /*  331034 */     // GIR_Coverage, 20280,
     /*  331034 */     GIR_EraseRootFromParent_Done,
     /*  331035 */   // Label 6106: @331035
     /*  331035 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(331098), // Rule ID 20281 //
     /*  331040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  331054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331079 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  331082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331096 */     GIR_RootConstrainSelectedInstOperands,
     /*  331097 */     // GIR_Coverage, 20281,
     /*  331097 */     GIR_EraseRootFromParent_Done,
     /*  331098 */   // Label 6107: @331098
     /*  331098 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(331161), // Rule ID 20284 //
     /*  331103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  331117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331142 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  331145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331159 */     GIR_RootConstrainSelectedInstOperands,
     /*  331160 */     // GIR_Coverage, 20284,
     /*  331160 */     GIR_EraseRootFromParent_Done,
     /*  331161 */   // Label 6108: @331161
     /*  331161 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(331224), // Rule ID 20285 //
     /*  331166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  331180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331205 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  331208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331222 */     GIR_RootConstrainSelectedInstOperands,
     /*  331223 */     // GIR_Coverage, 20285,
     /*  331223 */     GIR_EraseRootFromParent_Done,
     /*  331224 */   // Label 6109: @331224
     /*  331224 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(331287), // Rule ID 20288 //
     /*  331229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  331240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  331243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331268 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  331271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331285 */     GIR_RootConstrainSelectedInstOperands,
     /*  331286 */     // GIR_Coverage, 20288,
     /*  331286 */     GIR_EraseRootFromParent_Done,
     /*  331287 */   // Label 6110: @331287
     /*  331287 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(331350), // Rule ID 20289 //
     /*  331292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  331303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  331306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331331 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  331334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331348 */     GIR_RootConstrainSelectedInstOperands,
     /*  331349 */     // GIR_Coverage, 20289,
     /*  331349 */     GIR_EraseRootFromParent_Done,
     /*  331350 */   // Label 6111: @331350
     /*  331350 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(331413), // Rule ID 20292 //
     /*  331355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331394 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  331397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331411 */     GIR_RootConstrainSelectedInstOperands,
     /*  331412 */     // GIR_Coverage, 20292,
     /*  331412 */     GIR_EraseRootFromParent_Done,
     /*  331413 */   // Label 6112: @331413
     /*  331413 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(331476), // Rule ID 20293 //
     /*  331418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331457 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  331460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331474 */     GIR_RootConstrainSelectedInstOperands,
     /*  331475 */     // GIR_Coverage, 20293,
     /*  331475 */     GIR_EraseRootFromParent_Done,
     /*  331476 */   // Label 6113: @331476
     /*  331476 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(331539), // Rule ID 20296 //
     /*  331481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  331495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331520 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  331523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331537 */     GIR_RootConstrainSelectedInstOperands,
     /*  331538 */     // GIR_Coverage, 20296,
     /*  331538 */     GIR_EraseRootFromParent_Done,
     /*  331539 */   // Label 6114: @331539
     /*  331539 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(331602), // Rule ID 20297 //
     /*  331544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  331558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331583 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  331586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331600 */     GIR_RootConstrainSelectedInstOperands,
     /*  331601 */     // GIR_Coverage, 20297,
     /*  331601 */     GIR_EraseRootFromParent_Done,
     /*  331602 */   // Label 6115: @331602
     /*  331602 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(331665), // Rule ID 20300 //
     /*  331607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331646 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  331649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331663 */     GIR_RootConstrainSelectedInstOperands,
     /*  331664 */     // GIR_Coverage, 20300,
     /*  331664 */     GIR_EraseRootFromParent_Done,
     /*  331665 */   // Label 6116: @331665
     /*  331665 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(331728), // Rule ID 20301 //
     /*  331670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331709 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  331712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331726 */     GIR_RootConstrainSelectedInstOperands,
     /*  331727 */     // GIR_Coverage, 20301,
     /*  331727 */     GIR_EraseRootFromParent_Done,
     /*  331728 */   // Label 6117: @331728
     /*  331728 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(331791), // Rule ID 20304 //
     /*  331733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  331747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331772 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  331772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  331775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331789 */     GIR_RootConstrainSelectedInstOperands,
     /*  331790 */     // GIR_Coverage, 20304,
     /*  331790 */     GIR_EraseRootFromParent_Done,
     /*  331791 */   // Label 6118: @331791
     /*  331791 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(331854), // Rule ID 20305 //
     /*  331796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  331799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  331810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331835 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  331835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  331838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331852 */     GIR_RootConstrainSelectedInstOperands,
     /*  331853 */     // GIR_Coverage, 20305,
     /*  331853 */     GIR_EraseRootFromParent_Done,
     /*  331854 */   // Label 6119: @331854
     /*  331854 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(331917), // Rule ID 20308 //
     /*  331859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  331873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331898 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  331898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  331901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331915 */     GIR_RootConstrainSelectedInstOperands,
     /*  331916 */     // GIR_Coverage, 20308,
     /*  331916 */     GIR_EraseRootFromParent_Done,
     /*  331917 */   // Label 6120: @331917
     /*  331917 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(331980), // Rule ID 20309 //
     /*  331922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  331925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  331936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331961 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  331961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  331964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331978 */     GIR_RootConstrainSelectedInstOperands,
     /*  331979 */     // GIR_Coverage, 20309,
     /*  331979 */     GIR_EraseRootFromParent_Done,
     /*  331980 */   // Label 6121: @331980
     /*  331980 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(332043), // Rule ID 20312 //
     /*  331985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  331999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332024 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  332027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332041 */     GIR_RootConstrainSelectedInstOperands,
     /*  332042 */     // GIR_Coverage, 20312,
     /*  332042 */     GIR_EraseRootFromParent_Done,
     /*  332043 */   // Label 6122: @332043
     /*  332043 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(332106), // Rule ID 20313 //
     /*  332048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  332062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332087 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  332090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332104 */     GIR_RootConstrainSelectedInstOperands,
     /*  332105 */     // GIR_Coverage, 20313,
     /*  332105 */     GIR_EraseRootFromParent_Done,
     /*  332106 */   // Label 6123: @332106
     /*  332106 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(332169), // Rule ID 20316 //
     /*  332111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332150 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  332153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332167 */     GIR_RootConstrainSelectedInstOperands,
     /*  332168 */     // GIR_Coverage, 20316,
     /*  332168 */     GIR_EraseRootFromParent_Done,
     /*  332169 */   // Label 6124: @332169
     /*  332169 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(332232), // Rule ID 20317 //
     /*  332174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332213 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  332216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332230 */     GIR_RootConstrainSelectedInstOperands,
     /*  332231 */     // GIR_Coverage, 20317,
     /*  332231 */     GIR_EraseRootFromParent_Done,
     /*  332232 */   // Label 6125: @332232
     /*  332232 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(332295), // Rule ID 20320 //
     /*  332237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332276 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  332279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332293 */     GIR_RootConstrainSelectedInstOperands,
     /*  332294 */     // GIR_Coverage, 20320,
     /*  332294 */     GIR_EraseRootFromParent_Done,
     /*  332295 */   // Label 6126: @332295
     /*  332295 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(332358), // Rule ID 20321 //
     /*  332300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332339 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  332342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332356 */     GIR_RootConstrainSelectedInstOperands,
     /*  332357 */     // GIR_Coverage, 20321,
     /*  332357 */     GIR_EraseRootFromParent_Done,
     /*  332358 */   // Label 6127: @332358
     /*  332358 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(332421), // Rule ID 20324 //
     /*  332363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332402 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  332405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332419 */     GIR_RootConstrainSelectedInstOperands,
     /*  332420 */     // GIR_Coverage, 20324,
     /*  332420 */     GIR_EraseRootFromParent_Done,
     /*  332421 */   // Label 6128: @332421
     /*  332421 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(332484), // Rule ID 20325 //
     /*  332426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332465 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  332468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332482 */     GIR_RootConstrainSelectedInstOperands,
     /*  332483 */     // GIR_Coverage, 20325,
     /*  332483 */     GIR_EraseRootFromParent_Done,
     /*  332484 */   // Label 6129: @332484
     /*  332484 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(332547), // Rule ID 20328 //
     /*  332489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  332503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332528 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  332531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332545 */     GIR_RootConstrainSelectedInstOperands,
     /*  332546 */     // GIR_Coverage, 20328,
     /*  332546 */     GIR_EraseRootFromParent_Done,
     /*  332547 */   // Label 6130: @332547
     /*  332547 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(332610), // Rule ID 20329 //
     /*  332552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  332566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332591 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  332594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332608 */     GIR_RootConstrainSelectedInstOperands,
     /*  332609 */     // GIR_Coverage, 20329,
     /*  332609 */     GIR_EraseRootFromParent_Done,
     /*  332610 */   // Label 6131: @332610
     /*  332610 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(332673), // Rule ID 20332 //
     /*  332615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  332629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332654 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  332657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332671 */     GIR_RootConstrainSelectedInstOperands,
     /*  332672 */     // GIR_Coverage, 20332,
     /*  332672 */     GIR_EraseRootFromParent_Done,
     /*  332673 */   // Label 6132: @332673
     /*  332673 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(332736), // Rule ID 20333 //
     /*  332678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  332692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332717 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  332720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332734 */     GIR_RootConstrainSelectedInstOperands,
     /*  332735 */     // GIR_Coverage, 20333,
     /*  332735 */     GIR_EraseRootFromParent_Done,
     /*  332736 */   // Label 6133: @332736
     /*  332736 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(332799), // Rule ID 20336 //
     /*  332741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  332744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  332755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332780 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  332783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332797 */     GIR_RootConstrainSelectedInstOperands,
     /*  332798 */     // GIR_Coverage, 20336,
     /*  332798 */     GIR_EraseRootFromParent_Done,
     /*  332799 */   // Label 6134: @332799
     /*  332799 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(332862), // Rule ID 20337 //
     /*  332804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  332818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332843 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  332846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332860 */     GIR_RootConstrainSelectedInstOperands,
     /*  332861 */     // GIR_Coverage, 20337,
     /*  332861 */     GIR_EraseRootFromParent_Done,
     /*  332862 */   // Label 6135: @332862
     /*  332862 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(332925), // Rule ID 20340 //
     /*  332867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  332881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332906 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  332909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332923 */     GIR_RootConstrainSelectedInstOperands,
     /*  332924 */     // GIR_Coverage, 20340,
     /*  332924 */     GIR_EraseRootFromParent_Done,
     /*  332925 */   // Label 6136: @332925
     /*  332925 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(332988), // Rule ID 20341 //
     /*  332930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  332944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332969 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  332972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332986 */     GIR_RootConstrainSelectedInstOperands,
     /*  332987 */     // GIR_Coverage, 20341,
     /*  332987 */     GIR_EraseRootFromParent_Done,
     /*  332988 */   // Label 6137: @332988
     /*  332988 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(333051), // Rule ID 20344 //
     /*  332993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  333007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333032 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  333035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333049 */     GIR_RootConstrainSelectedInstOperands,
     /*  333050 */     // GIR_Coverage, 20344,
     /*  333050 */     GIR_EraseRootFromParent_Done,
     /*  333051 */   // Label 6138: @333051
     /*  333051 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(333114), // Rule ID 20345 //
     /*  333056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  333070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333095 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  333098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333112 */     GIR_RootConstrainSelectedInstOperands,
     /*  333113 */     // GIR_Coverage, 20345,
     /*  333113 */     GIR_EraseRootFromParent_Done,
     /*  333114 */   // Label 6139: @333114
     /*  333114 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(333177), // Rule ID 20348 //
     /*  333119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  333130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  333133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333158 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  333161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333175 */     GIR_RootConstrainSelectedInstOperands,
     /*  333176 */     // GIR_Coverage, 20348,
     /*  333176 */     GIR_EraseRootFromParent_Done,
     /*  333177 */   // Label 6140: @333177
     /*  333177 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(333240), // Rule ID 20349 //
     /*  333182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  333193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  333196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333221 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  333224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333238 */     GIR_RootConstrainSelectedInstOperands,
     /*  333239 */     // GIR_Coverage, 20349,
     /*  333239 */     GIR_EraseRootFromParent_Done,
     /*  333240 */   // Label 6141: @333240
     /*  333240 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(333303), // Rule ID 20352 //
     /*  333245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  333259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333284 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  333287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333301 */     GIR_RootConstrainSelectedInstOperands,
     /*  333302 */     // GIR_Coverage, 20352,
     /*  333302 */     GIR_EraseRootFromParent_Done,
     /*  333303 */   // Label 6142: @333303
     /*  333303 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(333366), // Rule ID 20353 //
     /*  333308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  333322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333347 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  333350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333364 */     GIR_RootConstrainSelectedInstOperands,
     /*  333365 */     // GIR_Coverage, 20353,
     /*  333365 */     GIR_EraseRootFromParent_Done,
     /*  333366 */   // Label 6143: @333366
     /*  333366 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(333429), // Rule ID 20356 //
     /*  333371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  333385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333410 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  333413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333427 */     GIR_RootConstrainSelectedInstOperands,
     /*  333428 */     // GIR_Coverage, 20356,
     /*  333428 */     GIR_EraseRootFromParent_Done,
     /*  333429 */   // Label 6144: @333429
     /*  333429 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(333492), // Rule ID 20357 //
     /*  333434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  333448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333473 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  333476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333490 */     GIR_RootConstrainSelectedInstOperands,
     /*  333491 */     // GIR_Coverage, 20357,
     /*  333491 */     GIR_EraseRootFromParent_Done,
     /*  333492 */   // Label 6145: @333492
     /*  333492 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(333555), // Rule ID 20360 //
     /*  333497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  333511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333536 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  333539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333553 */     GIR_RootConstrainSelectedInstOperands,
     /*  333554 */     // GIR_Coverage, 20360,
     /*  333554 */     GIR_EraseRootFromParent_Done,
     /*  333555 */   // Label 6146: @333555
     /*  333555 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(333618), // Rule ID 20361 //
     /*  333560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  333574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333599 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  333602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333616 */     GIR_RootConstrainSelectedInstOperands,
     /*  333617 */     // GIR_Coverage, 20361,
     /*  333617 */     GIR_EraseRootFromParent_Done,
     /*  333618 */   // Label 6147: @333618
     /*  333618 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(333681), // Rule ID 20364 //
     /*  333623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  333637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333662 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  333665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333679 */     GIR_RootConstrainSelectedInstOperands,
     /*  333680 */     // GIR_Coverage, 20364,
     /*  333680 */     GIR_EraseRootFromParent_Done,
     /*  333681 */   // Label 6148: @333681
     /*  333681 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(333744), // Rule ID 20365 //
     /*  333686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  333700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333725 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  333728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333742 */     GIR_RootConstrainSelectedInstOperands,
     /*  333743 */     // GIR_Coverage, 20365,
     /*  333743 */     GIR_EraseRootFromParent_Done,
     /*  333744 */   // Label 6149: @333744
     /*  333744 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(333807), // Rule ID 20368 //
     /*  333749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  333763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333788 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  333791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333805 */     GIR_RootConstrainSelectedInstOperands,
     /*  333806 */     // GIR_Coverage, 20368,
     /*  333806 */     GIR_EraseRootFromParent_Done,
     /*  333807 */   // Label 6150: @333807
     /*  333807 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(333870), // Rule ID 20369 //
     /*  333812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  333826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333851 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  333854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333868 */     GIR_RootConstrainSelectedInstOperands,
     /*  333869 */     // GIR_Coverage, 20369,
     /*  333869 */     GIR_EraseRootFromParent_Done,
     /*  333870 */   // Label 6151: @333870
     /*  333870 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(333933), // Rule ID 20372 //
     /*  333875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  333889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333914 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  333917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333931 */     GIR_RootConstrainSelectedInstOperands,
     /*  333932 */     // GIR_Coverage, 20372,
     /*  333932 */     GIR_EraseRootFromParent_Done,
     /*  333933 */   // Label 6152: @333933
     /*  333933 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(333996), // Rule ID 20373 //
     /*  333938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  333952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333977 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  333980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333994 */     GIR_RootConstrainSelectedInstOperands,
     /*  333995 */     // GIR_Coverage, 20373,
     /*  333995 */     GIR_EraseRootFromParent_Done,
     /*  333996 */   // Label 6153: @333996
     /*  333996 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(334059), // Rule ID 20376 //
     /*  334001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  334015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  334018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  334043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334057 */     GIR_RootConstrainSelectedInstOperands,
     /*  334058 */     // GIR_Coverage, 20376,
     /*  334058 */     GIR_EraseRootFromParent_Done,
     /*  334059 */   // Label 6154: @334059
     /*  334059 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(334122), // Rule ID 20377 //
     /*  334064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  334078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  334081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334103 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  334106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334120 */     GIR_RootConstrainSelectedInstOperands,
     /*  334121 */     // GIR_Coverage, 20377,
     /*  334121 */     GIR_EraseRootFromParent_Done,
     /*  334122 */   // Label 6155: @334122
     /*  334122 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(334185), // Rule ID 20380 //
     /*  334127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  334141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  334144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334166 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334183 */     GIR_RootConstrainSelectedInstOperands,
     /*  334184 */     // GIR_Coverage, 20380,
     /*  334184 */     GIR_EraseRootFromParent_Done,
     /*  334185 */   // Label 6156: @334185
     /*  334185 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(334248), // Rule ID 20381 //
     /*  334190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  334204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  334207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334229 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334246 */     GIR_RootConstrainSelectedInstOperands,
     /*  334247 */     // GIR_Coverage, 20381,
     /*  334247 */     GIR_EraseRootFromParent_Done,
     /*  334248 */   // Label 6157: @334248
     /*  334248 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(334311), // Rule ID 20384 //
     /*  334253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  334267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  334270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334292 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334309 */     GIR_RootConstrainSelectedInstOperands,
     /*  334310 */     // GIR_Coverage, 20384,
     /*  334310 */     GIR_EraseRootFromParent_Done,
     /*  334311 */   // Label 6158: @334311
     /*  334311 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(334374), // Rule ID 20385 //
     /*  334316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  334330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  334333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334355 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334372 */     GIR_RootConstrainSelectedInstOperands,
     /*  334373 */     // GIR_Coverage, 20385,
     /*  334373 */     GIR_EraseRootFromParent_Done,
     /*  334374 */   // Label 6159: @334374
     /*  334374 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(334437), // Rule ID 20388 //
     /*  334379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  334393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  334396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334418 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334435 */     GIR_RootConstrainSelectedInstOperands,
     /*  334436 */     // GIR_Coverage, 20388,
     /*  334436 */     GIR_EraseRootFromParent_Done,
     /*  334437 */   // Label 6160: @334437
     /*  334437 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(334500), // Rule ID 20389 //
     /*  334442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  334456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  334459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334481 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334498 */     GIR_RootConstrainSelectedInstOperands,
     /*  334499 */     // GIR_Coverage, 20389,
     /*  334499 */     GIR_EraseRootFromParent_Done,
     /*  334500 */   // Label 6161: @334500
     /*  334500 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(334563), // Rule ID 20392 //
     /*  334505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  334519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  334522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334561 */     GIR_RootConstrainSelectedInstOperands,
     /*  334562 */     // GIR_Coverage, 20392,
     /*  334562 */     GIR_EraseRootFromParent_Done,
     /*  334563 */   // Label 6162: @334563
     /*  334563 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(334626), // Rule ID 20393 //
     /*  334568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  334582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  334585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334607 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334624 */     GIR_RootConstrainSelectedInstOperands,
     /*  334625 */     // GIR_Coverage, 20393,
     /*  334625 */     GIR_EraseRootFromParent_Done,
     /*  334626 */   // Label 6163: @334626
     /*  334626 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(334689), // Rule ID 20396 //
     /*  334631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  334634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  334645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  334648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334670 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  334670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334687 */     GIR_RootConstrainSelectedInstOperands,
     /*  334688 */     // GIR_Coverage, 20396,
     /*  334688 */     GIR_EraseRootFromParent_Done,
     /*  334689 */   // Label 6164: @334689
     /*  334689 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(334752), // Rule ID 20397 //
     /*  334694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  334697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  334708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  334711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334733 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  334733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334750 */     GIR_RootConstrainSelectedInstOperands,
     /*  334751 */     // GIR_Coverage, 20397,
     /*  334751 */     GIR_EraseRootFromParent_Done,
     /*  334752 */   // Label 6165: @334752
     /*  334752 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(334815), // Rule ID 20400 //
     /*  334757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  334771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  334774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334796 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  334799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334813 */     GIR_RootConstrainSelectedInstOperands,
     /*  334814 */     // GIR_Coverage, 20400,
     /*  334814 */     GIR_EraseRootFromParent_Done,
     /*  334815 */   // Label 6166: @334815
     /*  334815 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(334878), // Rule ID 20401 //
     /*  334820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  334834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  334837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334859 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  334862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334876 */     GIR_RootConstrainSelectedInstOperands,
     /*  334877 */     // GIR_Coverage, 20401,
     /*  334877 */     GIR_EraseRootFromParent_Done,
     /*  334878 */   // Label 6167: @334878
     /*  334878 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(334941), // Rule ID 20404 //
     /*  334883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  334894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  334897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  334900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334922 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  334925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334939 */     GIR_RootConstrainSelectedInstOperands,
     /*  334940 */     // GIR_Coverage, 20404,
     /*  334940 */     GIR_EraseRootFromParent_Done,
     /*  334941 */   // Label 6168: @334941
     /*  334941 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(335004), // Rule ID 20405 //
     /*  334946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  334957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  334960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  334963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334985 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  334988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335002 */     GIR_RootConstrainSelectedInstOperands,
     /*  335003 */     // GIR_Coverage, 20405,
     /*  335003 */     GIR_EraseRootFromParent_Done,
     /*  335004 */   // Label 6169: @335004
     /*  335004 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(335067), // Rule ID 20408 //
     /*  335009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  335020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  335023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  335026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335048 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335065 */     GIR_RootConstrainSelectedInstOperands,
     /*  335066 */     // GIR_Coverage, 20408,
     /*  335066 */     GIR_EraseRootFromParent_Done,
     /*  335067 */   // Label 6170: @335067
     /*  335067 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(335130), // Rule ID 20409 //
     /*  335072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  335083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  335086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  335089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335111 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335128 */     GIR_RootConstrainSelectedInstOperands,
     /*  335129 */     // GIR_Coverage, 20409,
     /*  335129 */     GIR_EraseRootFromParent_Done,
     /*  335130 */   // Label 6171: @335130
     /*  335130 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(335193), // Rule ID 20412 //
     /*  335135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  335149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  335152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335174 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335191 */     GIR_RootConstrainSelectedInstOperands,
     /*  335192 */     // GIR_Coverage, 20412,
     /*  335192 */     GIR_EraseRootFromParent_Done,
     /*  335193 */   // Label 6172: @335193
     /*  335193 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(335256), // Rule ID 20413 //
     /*  335198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  335212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  335215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335237 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335254 */     GIR_RootConstrainSelectedInstOperands,
     /*  335255 */     // GIR_Coverage, 20413,
     /*  335255 */     GIR_EraseRootFromParent_Done,
     /*  335256 */   // Label 6173: @335256
     /*  335256 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(335319), // Rule ID 20416 //
     /*  335261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  335275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  335278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335300 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335317 */     GIR_RootConstrainSelectedInstOperands,
     /*  335318 */     // GIR_Coverage, 20416,
     /*  335318 */     GIR_EraseRootFromParent_Done,
     /*  335319 */   // Label 6174: @335319
     /*  335319 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(335382), // Rule ID 20417 //
     /*  335324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  335338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  335341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335363 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335380 */     GIR_RootConstrainSelectedInstOperands,
     /*  335381 */     // GIR_Coverage, 20417,
     /*  335381 */     GIR_EraseRootFromParent_Done,
     /*  335382 */   // Label 6175: @335382
     /*  335382 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(335445), // Rule ID 20420 //
     /*  335387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  335404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335426 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335443 */     GIR_RootConstrainSelectedInstOperands,
     /*  335444 */     // GIR_Coverage, 20420,
     /*  335444 */     GIR_EraseRootFromParent_Done,
     /*  335445 */   // Label 6176: @335445
     /*  335445 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(335508), // Rule ID 20421 //
     /*  335450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  335467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335489 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335506 */     GIR_RootConstrainSelectedInstOperands,
     /*  335507 */     // GIR_Coverage, 20421,
     /*  335507 */     GIR_EraseRootFromParent_Done,
     /*  335508 */   // Label 6177: @335508
     /*  335508 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(335571), // Rule ID 20424 //
     /*  335513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  335530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335552 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335569 */     GIR_RootConstrainSelectedInstOperands,
     /*  335570 */     // GIR_Coverage, 20424,
     /*  335570 */     GIR_EraseRootFromParent_Done,
     /*  335571 */   // Label 6178: @335571
     /*  335571 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(335634), // Rule ID 20425 //
     /*  335576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  335593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335615 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335632 */     GIR_RootConstrainSelectedInstOperands,
     /*  335633 */     // GIR_Coverage, 20425,
     /*  335633 */     GIR_EraseRootFromParent_Done,
     /*  335634 */   // Label 6179: @335634
     /*  335634 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(335697), // Rule ID 20428 //
     /*  335639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  335653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  335656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335678 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335695 */     GIR_RootConstrainSelectedInstOperands,
     /*  335696 */     // GIR_Coverage, 20428,
     /*  335696 */     GIR_EraseRootFromParent_Done,
     /*  335697 */   // Label 6180: @335697
     /*  335697 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(335760), // Rule ID 20429 //
     /*  335702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  335716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  335719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335741 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335758 */     GIR_RootConstrainSelectedInstOperands,
     /*  335759 */     // GIR_Coverage, 20429,
     /*  335759 */     GIR_EraseRootFromParent_Done,
     /*  335760 */   // Label 6181: @335760
     /*  335760 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(335823), // Rule ID 20432 //
     /*  335765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  335779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  335782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335804 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335821 */     GIR_RootConstrainSelectedInstOperands,
     /*  335822 */     // GIR_Coverage, 20432,
     /*  335822 */     GIR_EraseRootFromParent_Done,
     /*  335823 */   // Label 6182: @335823
     /*  335823 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(335886), // Rule ID 20433 //
     /*  335828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  335842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  335845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335867 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335884 */     GIR_RootConstrainSelectedInstOperands,
     /*  335885 */     // GIR_Coverage, 20433,
     /*  335885 */     GIR_EraseRootFromParent_Done,
     /*  335886 */   // Label 6183: @335886
     /*  335886 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(335949), // Rule ID 20436 //
     /*  335891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  335905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  335908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335930 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  335933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335947 */     GIR_RootConstrainSelectedInstOperands,
     /*  335948 */     // GIR_Coverage, 20436,
     /*  335948 */     GIR_EraseRootFromParent_Done,
     /*  335949 */   // Label 6184: @335949
     /*  335949 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(336012), // Rule ID 20437 //
     /*  335954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  335968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  335971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335993 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  335996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336010 */     GIR_RootConstrainSelectedInstOperands,
     /*  336011 */     // GIR_Coverage, 20437,
     /*  336011 */     GIR_EraseRootFromParent_Done,
     /*  336012 */   // Label 6185: @336012
     /*  336012 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(336075), // Rule ID 20440 //
     /*  336017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  336034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336056 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336073 */     GIR_RootConstrainSelectedInstOperands,
     /*  336074 */     // GIR_Coverage, 20440,
     /*  336074 */     GIR_EraseRootFromParent_Done,
     /*  336075 */   // Label 6186: @336075
     /*  336075 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(336138), // Rule ID 20441 //
     /*  336080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  336097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336119 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336136 */     GIR_RootConstrainSelectedInstOperands,
     /*  336137 */     // GIR_Coverage, 20441,
     /*  336137 */     GIR_EraseRootFromParent_Done,
     /*  336138 */   // Label 6187: @336138
     /*  336138 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(336201), // Rule ID 20444 //
     /*  336143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  336160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336182 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336199 */     GIR_RootConstrainSelectedInstOperands,
     /*  336200 */     // GIR_Coverage, 20444,
     /*  336200 */     GIR_EraseRootFromParent_Done,
     /*  336201 */   // Label 6188: @336201
     /*  336201 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(336264), // Rule ID 20445 //
     /*  336206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  336223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336245 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336262 */     GIR_RootConstrainSelectedInstOperands,
     /*  336263 */     // GIR_Coverage, 20445,
     /*  336263 */     GIR_EraseRootFromParent_Done,
     /*  336264 */   // Label 6189: @336264
     /*  336264 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(336327), // Rule ID 20448 //
     /*  336269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  336283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  336286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336308 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336325 */     GIR_RootConstrainSelectedInstOperands,
     /*  336326 */     // GIR_Coverage, 20448,
     /*  336326 */     GIR_EraseRootFromParent_Done,
     /*  336327 */   // Label 6190: @336327
     /*  336327 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(336390), // Rule ID 20449 //
     /*  336332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  336346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  336349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336371 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336388 */     GIR_RootConstrainSelectedInstOperands,
     /*  336389 */     // GIR_Coverage, 20449,
     /*  336389 */     GIR_EraseRootFromParent_Done,
     /*  336390 */   // Label 6191: @336390
     /*  336390 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(336453), // Rule ID 20452 //
     /*  336395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  336409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  336412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336434 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336451 */     GIR_RootConstrainSelectedInstOperands,
     /*  336452 */     // GIR_Coverage, 20452,
     /*  336452 */     GIR_EraseRootFromParent_Done,
     /*  336453 */   // Label 6192: @336453
     /*  336453 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(336516), // Rule ID 20453 //
     /*  336458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  336472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  336475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336497 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336514 */     GIR_RootConstrainSelectedInstOperands,
     /*  336515 */     // GIR_Coverage, 20453,
     /*  336515 */     GIR_EraseRootFromParent_Done,
     /*  336516 */   // Label 6193: @336516
     /*  336516 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(336579), // Rule ID 20456 //
     /*  336521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  336524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  336535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  336538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336560 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  336560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336577 */     GIR_RootConstrainSelectedInstOperands,
     /*  336578 */     // GIR_Coverage, 20456,
     /*  336578 */     GIR_EraseRootFromParent_Done,
     /*  336579 */   // Label 6194: @336579
     /*  336579 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(336642), // Rule ID 20457 //
     /*  336584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  336587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  336598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  336601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336623 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  336623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336640 */     GIR_RootConstrainSelectedInstOperands,
     /*  336641 */     // GIR_Coverage, 20457,
     /*  336641 */     GIR_EraseRootFromParent_Done,
     /*  336642 */   // Label 6195: @336642
     /*  336642 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(336705), // Rule ID 20460 //
     /*  336647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  336661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  336664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336686 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  336689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336703 */     GIR_RootConstrainSelectedInstOperands,
     /*  336704 */     // GIR_Coverage, 20460,
     /*  336704 */     GIR_EraseRootFromParent_Done,
     /*  336705 */   // Label 6196: @336705
     /*  336705 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(336768), // Rule ID 20461 //
     /*  336710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  336724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  336727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336749 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  336752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336766 */     GIR_RootConstrainSelectedInstOperands,
     /*  336767 */     // GIR_Coverage, 20461,
     /*  336767 */     GIR_EraseRootFromParent_Done,
     /*  336768 */   // Label 6197: @336768
     /*  336768 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(336831), // Rule ID 20464 //
     /*  336773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  336784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  336787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  336790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336812 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  336815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336829 */     GIR_RootConstrainSelectedInstOperands,
     /*  336830 */     // GIR_Coverage, 20464,
     /*  336830 */     GIR_EraseRootFromParent_Done,
     /*  336831 */   // Label 6198: @336831
     /*  336831 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(336894), // Rule ID 20465 //
     /*  336836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  336847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  336850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  336853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336875 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  336878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336892 */     GIR_RootConstrainSelectedInstOperands,
     /*  336893 */     // GIR_Coverage, 20465,
     /*  336893 */     GIR_EraseRootFromParent_Done,
     /*  336894 */   // Label 6199: @336894
     /*  336894 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(336957), // Rule ID 20468 //
     /*  336899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  336910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  336913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  336916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336938 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  336941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336955 */     GIR_RootConstrainSelectedInstOperands,
     /*  336956 */     // GIR_Coverage, 20468,
     /*  336956 */     GIR_EraseRootFromParent_Done,
     /*  336957 */   // Label 6200: @336957
     /*  336957 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(337020), // Rule ID 20469 //
     /*  336962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  336973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  336976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  336979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337001 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  337001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337018 */     GIR_RootConstrainSelectedInstOperands,
     /*  337019 */     // GIR_Coverage, 20469,
     /*  337019 */     GIR_EraseRootFromParent_Done,
     /*  337020 */   // Label 6201: @337020
     /*  337020 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(337083), // Rule ID 20472 //
     /*  337025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  337039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  337042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337064 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337081 */     GIR_RootConstrainSelectedInstOperands,
     /*  337082 */     // GIR_Coverage, 20472,
     /*  337082 */     GIR_EraseRootFromParent_Done,
     /*  337083 */   // Label 6202: @337083
     /*  337083 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(337146), // Rule ID 20473 //
     /*  337088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  337102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  337105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337127 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337144 */     GIR_RootConstrainSelectedInstOperands,
     /*  337145 */     // GIR_Coverage, 20473,
     /*  337145 */     GIR_EraseRootFromParent_Done,
     /*  337146 */   // Label 6203: @337146
     /*  337146 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(337209), // Rule ID 20476 //
     /*  337151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  337165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  337168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337190 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337207 */     GIR_RootConstrainSelectedInstOperands,
     /*  337208 */     // GIR_Coverage, 20476,
     /*  337208 */     GIR_EraseRootFromParent_Done,
     /*  337209 */   // Label 6204: @337209
     /*  337209 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(337272), // Rule ID 20477 //
     /*  337214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  337228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  337231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337253 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337270 */     GIR_RootConstrainSelectedInstOperands,
     /*  337271 */     // GIR_Coverage, 20477,
     /*  337271 */     GIR_EraseRootFromParent_Done,
     /*  337272 */   // Label 6205: @337272
     /*  337272 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(337335), // Rule ID 20480 //
     /*  337277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  337291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  337294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337316 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337333 */     GIR_RootConstrainSelectedInstOperands,
     /*  337334 */     // GIR_Coverage, 20480,
     /*  337334 */     GIR_EraseRootFromParent_Done,
     /*  337335 */   // Label 6206: @337335
     /*  337335 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(337398), // Rule ID 20481 //
     /*  337340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  337354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  337357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337379 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337396 */     GIR_RootConstrainSelectedInstOperands,
     /*  337397 */     // GIR_Coverage, 20481,
     /*  337397 */     GIR_EraseRootFromParent_Done,
     /*  337398 */   // Label 6207: @337398
     /*  337398 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(337461), // Rule ID 20484 //
     /*  337403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  337417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  337420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337442 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337459 */     GIR_RootConstrainSelectedInstOperands,
     /*  337460 */     // GIR_Coverage, 20484,
     /*  337460 */     GIR_EraseRootFromParent_Done,
     /*  337461 */   // Label 6208: @337461
     /*  337461 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(337524), // Rule ID 20485 //
     /*  337466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  337480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  337483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337505 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337522 */     GIR_RootConstrainSelectedInstOperands,
     /*  337523 */     // GIR_Coverage, 20485,
     /*  337523 */     GIR_EraseRootFromParent_Done,
     /*  337524 */   // Label 6209: @337524
     /*  337524 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(337587), // Rule ID 20488 //
     /*  337529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  337543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  337546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337568 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337585 */     GIR_RootConstrainSelectedInstOperands,
     /*  337586 */     // GIR_Coverage, 20488,
     /*  337586 */     GIR_EraseRootFromParent_Done,
     /*  337587 */   // Label 6210: @337587
     /*  337587 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(337650), // Rule ID 20489 //
     /*  337592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  337606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  337609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337631 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337648 */     GIR_RootConstrainSelectedInstOperands,
     /*  337649 */     // GIR_Coverage, 20489,
     /*  337649 */     GIR_EraseRootFromParent_Done,
     /*  337650 */   // Label 6211: @337650
     /*  337650 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(337713), // Rule ID 20492 //
     /*  337655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  337669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  337672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337694 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337711 */     GIR_RootConstrainSelectedInstOperands,
     /*  337712 */     // GIR_Coverage, 20492,
     /*  337712 */     GIR_EraseRootFromParent_Done,
     /*  337713 */   // Label 6212: @337713
     /*  337713 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(337776), // Rule ID 20493 //
     /*  337718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  337732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  337735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337757 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337774 */     GIR_RootConstrainSelectedInstOperands,
     /*  337775 */     // GIR_Coverage, 20493,
     /*  337775 */     GIR_EraseRootFromParent_Done,
     /*  337776 */   // Label 6213: @337776
     /*  337776 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(337842), // Rule ID 20496 //
     /*  337781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  337784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  337792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  337795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  337798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337820 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  337820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  337823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337840 */     GIR_RootConstrainSelectedInstOperands,
     /*  337841 */     // GIR_Coverage, 20496,
     /*  337841 */     GIR_EraseRootFromParent_Done,
     /*  337842 */   // Label 6214: @337842
     /*  337842 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(337908), // Rule ID 20497 //
     /*  337847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  337850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  337858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  337861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  337864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337886 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  337886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  337889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337906 */     GIR_RootConstrainSelectedInstOperands,
     /*  337907 */     // GIR_Coverage, 20497,
     /*  337907 */     GIR_EraseRootFromParent_Done,
     /*  337908 */   // Label 6215: @337908
     /*  337908 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(337974), // Rule ID 20500 //
     /*  337913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  337916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  337924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  337927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  337930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337952 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  337952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  337955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337972 */     GIR_RootConstrainSelectedInstOperands,
     /*  337973 */     // GIR_Coverage, 20500,
     /*  337973 */     GIR_EraseRootFromParent_Done,
     /*  337974 */   // Label 6216: @337974
     /*  337974 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(338040), // Rule ID 20501 //
     /*  337979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  337982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  337990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  337993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  337996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  338021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338038 */     GIR_RootConstrainSelectedInstOperands,
     /*  338039 */     // GIR_Coverage, 20501,
     /*  338039 */     GIR_EraseRootFromParent_Done,
     /*  338040 */   // Label 6217: @338040
     /*  338040 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(338106), // Rule ID 20504 //
     /*  338045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  338056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  338059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  338062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338104 */     GIR_RootConstrainSelectedInstOperands,
     /*  338105 */     // GIR_Coverage, 20504,
     /*  338105 */     GIR_EraseRootFromParent_Done,
     /*  338106 */   // Label 6218: @338106
     /*  338106 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(338172), // Rule ID 20505 //
     /*  338111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  338122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  338125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  338128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338150 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338170 */     GIR_RootConstrainSelectedInstOperands,
     /*  338171 */     // GIR_Coverage, 20505,
     /*  338171 */     GIR_EraseRootFromParent_Done,
     /*  338172 */   // Label 6219: @338172
     /*  338172 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(338238), // Rule ID 20508 //
     /*  338177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  338180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  338188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  338191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  338194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338236 */     GIR_RootConstrainSelectedInstOperands,
     /*  338237 */     // GIR_Coverage, 20508,
     /*  338237 */     GIR_EraseRootFromParent_Done,
     /*  338238 */   // Label 6220: @338238
     /*  338238 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(338304), // Rule ID 20509 //
     /*  338243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  338246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  338254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  338257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  338260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338282 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338302 */     GIR_RootConstrainSelectedInstOperands,
     /*  338303 */     // GIR_Coverage, 20509,
     /*  338303 */     GIR_EraseRootFromParent_Done,
     /*  338304 */   // Label 6221: @338304
     /*  338304 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(338370), // Rule ID 20512 //
     /*  338309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  338312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  338320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  338323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  338326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338348 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  338348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338368 */     GIR_RootConstrainSelectedInstOperands,
     /*  338369 */     // GIR_Coverage, 20512,
     /*  338369 */     GIR_EraseRootFromParent_Done,
     /*  338370 */   // Label 6222: @338370
     /*  338370 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(338436), // Rule ID 20513 //
     /*  338375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  338378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  338386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  338389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  338392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  338414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338434 */     GIR_RootConstrainSelectedInstOperands,
     /*  338435 */     // GIR_Coverage, 20513,
     /*  338435 */     GIR_EraseRootFromParent_Done,
     /*  338436 */   // Label 6223: @338436
     /*  338436 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(338502), // Rule ID 20516 //
     /*  338441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  338452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338480 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338500 */     GIR_RootConstrainSelectedInstOperands,
     /*  338501 */     // GIR_Coverage, 20516,
     /*  338501 */     GIR_EraseRootFromParent_Done,
     /*  338502 */   // Label 6224: @338502
     /*  338502 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(338568), // Rule ID 20517 //
     /*  338507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  338518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338546 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338566 */     GIR_RootConstrainSelectedInstOperands,
     /*  338567 */     // GIR_Coverage, 20517,
     /*  338567 */     GIR_EraseRootFromParent_Done,
     /*  338568 */   // Label 6225: @338568
     /*  338568 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(338634), // Rule ID 20520 //
     /*  338573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  338584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  338587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  338590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338612 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  338615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338632 */     GIR_RootConstrainSelectedInstOperands,
     /*  338633 */     // GIR_Coverage, 20520,
     /*  338633 */     GIR_EraseRootFromParent_Done,
     /*  338634 */   // Label 6226: @338634
     /*  338634 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(338700), // Rule ID 20521 //
     /*  338639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  338650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  338653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  338656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338678 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  338681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338698 */     GIR_RootConstrainSelectedInstOperands,
     /*  338699 */     // GIR_Coverage, 20521,
     /*  338699 */     GIR_EraseRootFromParent_Done,
     /*  338700 */   // Label 6227: @338700
     /*  338700 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(338766), // Rule ID 20524 //
     /*  338705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  338716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  338719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  338722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338744 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  338747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338764 */     GIR_RootConstrainSelectedInstOperands,
     /*  338765 */     // GIR_Coverage, 20524,
     /*  338765 */     GIR_EraseRootFromParent_Done,
     /*  338766 */   // Label 6228: @338766
     /*  338766 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(338832), // Rule ID 20525 //
     /*  338771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  338782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  338785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  338788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338810 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  338813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338830 */     GIR_RootConstrainSelectedInstOperands,
     /*  338831 */     // GIR_Coverage, 20525,
     /*  338831 */     GIR_EraseRootFromParent_Done,
     /*  338832 */   // Label 6229: @338832
     /*  338832 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(338898), // Rule ID 20528 //
     /*  338837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  338840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  338848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  338851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  338854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338896 */     GIR_RootConstrainSelectedInstOperands,
     /*  338897 */     // GIR_Coverage, 20528,
     /*  338897 */     GIR_EraseRootFromParent_Done,
     /*  338898 */   // Label 6230: @338898
     /*  338898 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(338964), // Rule ID 20529 //
     /*  338903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  338906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  338914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  338917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  338920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338942 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338962 */     GIR_RootConstrainSelectedInstOperands,
     /*  338963 */     // GIR_Coverage, 20529,
     /*  338963 */     GIR_EraseRootFromParent_Done,
     /*  338964 */   // Label 6231: @338964
     /*  338964 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(339030), // Rule ID 20532 //
     /*  338969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  338972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  338980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  338983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  338986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339008 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  339008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339028 */     GIR_RootConstrainSelectedInstOperands,
     /*  339029 */     // GIR_Coverage, 20532,
     /*  339029 */     GIR_EraseRootFromParent_Done,
     /*  339030 */   // Label 6232: @339030
     /*  339030 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(339096), // Rule ID 20533 //
     /*  339035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  339046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  339049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  339052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339074 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339094 */     GIR_RootConstrainSelectedInstOperands,
     /*  339095 */     // GIR_Coverage, 20533,
     /*  339095 */     GIR_EraseRootFromParent_Done,
     /*  339096 */   // Label 6233: @339096
     /*  339096 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(339162), // Rule ID 20536 //
     /*  339101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  339104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  339112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  339115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  339118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339140 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  339140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339160 */     GIR_RootConstrainSelectedInstOperands,
     /*  339161 */     // GIR_Coverage, 20536,
     /*  339161 */     GIR_EraseRootFromParent_Done,
     /*  339162 */   // Label 6234: @339162
     /*  339162 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(339228), // Rule ID 20537 //
     /*  339167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  339178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  339181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  339184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339206 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339226 */     GIR_RootConstrainSelectedInstOperands,
     /*  339227 */     // GIR_Coverage, 20537,
     /*  339227 */     GIR_EraseRootFromParent_Done,
     /*  339228 */   // Label 6235: @339228
     /*  339228 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(339294), // Rule ID 20540 //
     /*  339233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  339236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  339244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339272 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339292 */     GIR_RootConstrainSelectedInstOperands,
     /*  339293 */     // GIR_Coverage, 20540,
     /*  339293 */     GIR_EraseRootFromParent_Done,
     /*  339294 */   // Label 6236: @339294
     /*  339294 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(339360), // Rule ID 20541 //
     /*  339299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  339302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  339310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339338 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339358 */     GIR_RootConstrainSelectedInstOperands,
     /*  339359 */     // GIR_Coverage, 20541,
     /*  339359 */     GIR_EraseRootFromParent_Done,
     /*  339360 */   // Label 6237: @339360
     /*  339360 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(339426), // Rule ID 20544 //
     /*  339365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  339368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  339376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339404 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339424 */     GIR_RootConstrainSelectedInstOperands,
     /*  339425 */     // GIR_Coverage, 20544,
     /*  339425 */     GIR_EraseRootFromParent_Done,
     /*  339426 */   // Label 6238: @339426
     /*  339426 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(339492), // Rule ID 20545 //
     /*  339431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  339434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  339442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339470 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339490 */     GIR_RootConstrainSelectedInstOperands,
     /*  339491 */     // GIR_Coverage, 20545,
     /*  339491 */     GIR_EraseRootFromParent_Done,
     /*  339492 */   // Label 6239: @339492
     /*  339492 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(339558), // Rule ID 20548 //
     /*  339497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  339500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  339508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  339511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  339514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339556 */     GIR_RootConstrainSelectedInstOperands,
     /*  339557 */     // GIR_Coverage, 20548,
     /*  339557 */     GIR_EraseRootFromParent_Done,
     /*  339558 */   // Label 6240: @339558
     /*  339558 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(339624), // Rule ID 20549 //
     /*  339563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  339566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  339574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  339577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  339580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339622 */     GIR_RootConstrainSelectedInstOperands,
     /*  339623 */     // GIR_Coverage, 20549,
     /*  339623 */     GIR_EraseRootFromParent_Done,
     /*  339624 */   // Label 6241: @339624
     /*  339624 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(339690), // Rule ID 20874 //
     /*  339629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  339632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  339640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  339643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  339646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  339668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  339671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339688 */     GIR_RootConstrainSelectedInstOperands,
     /*  339689 */     // GIR_Coverage, 20874,
     /*  339689 */     GIR_EraseRootFromParent_Done,
     /*  339690 */   // Label 6242: @339690
     /*  339690 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(339756), // Rule ID 20875 //
     /*  339695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  339698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  339706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  339709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  339712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339734 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  339734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  339737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339754 */     GIR_RootConstrainSelectedInstOperands,
     /*  339755 */     // GIR_Coverage, 20875,
     /*  339755 */     GIR_EraseRootFromParent_Done,
     /*  339756 */   // Label 6243: @339756
     /*  339756 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(339822), // Rule ID 20878 //
     /*  339761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  339764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  339772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  339775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  339778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339800 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  339800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  339803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339820 */     GIR_RootConstrainSelectedInstOperands,
     /*  339821 */     // GIR_Coverage, 20878,
     /*  339821 */     GIR_EraseRootFromParent_Done,
     /*  339822 */   // Label 6244: @339822
     /*  339822 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(339888), // Rule ID 20879 //
     /*  339827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  339830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  339838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  339841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  339844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339866 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  339866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  339869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339886 */     GIR_RootConstrainSelectedInstOperands,
     /*  339887 */     // GIR_Coverage, 20879,
     /*  339887 */     GIR_EraseRootFromParent_Done,
     /*  339888 */   // Label 6245: @339888
     /*  339888 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(339954), // Rule ID 20882 //
     /*  339893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  339896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  339904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  339907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  339910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339932 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  339932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  339935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339952 */     GIR_RootConstrainSelectedInstOperands,
     /*  339953 */     // GIR_Coverage, 20882,
     /*  339953 */     GIR_EraseRootFromParent_Done,
     /*  339954 */   // Label 6246: @339954
     /*  339954 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(340020), // Rule ID 20883 //
     /*  339959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  339970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  339973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  339976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  340001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340018 */     GIR_RootConstrainSelectedInstOperands,
     /*  340019 */     // GIR_Coverage, 20883,
     /*  340019 */     GIR_EraseRootFromParent_Done,
     /*  340020 */   // Label 6247: @340020
     /*  340020 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(340086), // Rule ID 20886 //
     /*  340025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  340036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340064 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340084 */     GIR_RootConstrainSelectedInstOperands,
     /*  340085 */     // GIR_Coverage, 20886,
     /*  340085 */     GIR_EraseRootFromParent_Done,
     /*  340086 */   // Label 6248: @340086
     /*  340086 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(340152), // Rule ID 20887 //
     /*  340091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  340102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340130 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340150 */     GIR_RootConstrainSelectedInstOperands,
     /*  340151 */     // GIR_Coverage, 20887,
     /*  340151 */     GIR_EraseRootFromParent_Done,
     /*  340152 */   // Label 6249: @340152
     /*  340152 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(340218), // Rule ID 20890 //
     /*  340157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  340160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  340168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  340171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  340174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340216 */     GIR_RootConstrainSelectedInstOperands,
     /*  340217 */     // GIR_Coverage, 20890,
     /*  340217 */     GIR_EraseRootFromParent_Done,
     /*  340218 */   // Label 6250: @340218
     /*  340218 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(340284), // Rule ID 20891 //
     /*  340223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  340226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  340234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  340237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  340240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340262 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  340262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340282 */     GIR_RootConstrainSelectedInstOperands,
     /*  340283 */     // GIR_Coverage, 20891,
     /*  340283 */     GIR_EraseRootFromParent_Done,
     /*  340284 */   // Label 6251: @340284
     /*  340284 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(340350), // Rule ID 20894 //
     /*  340289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  340292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  340300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  340303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  340306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  340328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340348 */     GIR_RootConstrainSelectedInstOperands,
     /*  340349 */     // GIR_Coverage, 20894,
     /*  340349 */     GIR_EraseRootFromParent_Done,
     /*  340350 */   // Label 6252: @340350
     /*  340350 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(340416), // Rule ID 20895 //
     /*  340355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  340358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  340366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  340369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  340372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340394 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  340394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340414 */     GIR_RootConstrainSelectedInstOperands,
     /*  340415 */     // GIR_Coverage, 20895,
     /*  340415 */     GIR_EraseRootFromParent_Done,
     /*  340416 */   // Label 6253: @340416
     /*  340416 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(340482), // Rule ID 20898 //
     /*  340421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  340432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  340435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  340438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340480 */     GIR_RootConstrainSelectedInstOperands,
     /*  340481 */     // GIR_Coverage, 20898,
     /*  340481 */     GIR_EraseRootFromParent_Done,
     /*  340482 */   // Label 6254: @340482
     /*  340482 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(340548), // Rule ID 20899 //
     /*  340487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  340498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  340501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  340504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340526 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340546 */     GIR_RootConstrainSelectedInstOperands,
     /*  340547 */     // GIR_Coverage, 20899,
     /*  340547 */     GIR_EraseRootFromParent_Done,
     /*  340548 */   // Label 6255: @340548
     /*  340548 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(340614), // Rule ID 20902 //
     /*  340553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  340564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  340567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  340570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340592 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  340595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340612 */     GIR_RootConstrainSelectedInstOperands,
     /*  340613 */     // GIR_Coverage, 20902,
     /*  340613 */     GIR_EraseRootFromParent_Done,
     /*  340614 */   // Label 6256: @340614
     /*  340614 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(340680), // Rule ID 20903 //
     /*  340619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  340630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  340633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  340636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340658 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  340661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340678 */     GIR_RootConstrainSelectedInstOperands,
     /*  340679 */     // GIR_Coverage, 20903,
     /*  340679 */     GIR_EraseRootFromParent_Done,
     /*  340680 */   // Label 6257: @340680
     /*  340680 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(340746), // Rule ID 20906 //
     /*  340685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  340696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  340699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  340702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340724 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  340727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340744 */     GIR_RootConstrainSelectedInstOperands,
     /*  340745 */     // GIR_Coverage, 20906,
     /*  340745 */     GIR_EraseRootFromParent_Done,
     /*  340746 */   // Label 6258: @340746
     /*  340746 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(340812), // Rule ID 20907 //
     /*  340751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  340762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  340765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  340768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340790 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  340793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340810 */     GIR_RootConstrainSelectedInstOperands,
     /*  340811 */     // GIR_Coverage, 20907,
     /*  340811 */     GIR_EraseRootFromParent_Done,
     /*  340812 */   // Label 6259: @340812
     /*  340812 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(340878), // Rule ID 20910 //
     /*  340817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  340820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  340828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  340831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  340834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340876 */     GIR_RootConstrainSelectedInstOperands,
     /*  340877 */     // GIR_Coverage, 20910,
     /*  340877 */     GIR_EraseRootFromParent_Done,
     /*  340878 */   // Label 6260: @340878
     /*  340878 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(340944), // Rule ID 20911 //
     /*  340883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  340886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  340894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  340897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  340900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340922 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  340922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340942 */     GIR_RootConstrainSelectedInstOperands,
     /*  340943 */     // GIR_Coverage, 20911,
     /*  340943 */     GIR_EraseRootFromParent_Done,
     /*  340944 */   // Label 6261: @340944
     /*  340944 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(341010), // Rule ID 20914 //
     /*  340949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  340952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  340960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  340963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  340966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340988 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  340991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341008 */     GIR_RootConstrainSelectedInstOperands,
     /*  341009 */     // GIR_Coverage, 20914,
     /*  341009 */     GIR_EraseRootFromParent_Done,
     /*  341010 */   // Label 6262: @341010
     /*  341010 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(341076), // Rule ID 20915 //
     /*  341015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  341026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  341029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  341032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341054 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341074 */     GIR_RootConstrainSelectedInstOperands,
     /*  341075 */     // GIR_Coverage, 20915,
     /*  341075 */     GIR_EraseRootFromParent_Done,
     /*  341076 */   // Label 6263: @341076
     /*  341076 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(341142), // Rule ID 20918 //
     /*  341081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  341092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  341095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  341098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341120 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341140 */     GIR_RootConstrainSelectedInstOperands,
     /*  341141 */     // GIR_Coverage, 20918,
     /*  341141 */     GIR_EraseRootFromParent_Done,
     /*  341142 */   // Label 6264: @341142
     /*  341142 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(341208), // Rule ID 20919 //
     /*  341147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  341158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  341161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  341164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341206 */     GIR_RootConstrainSelectedInstOperands,
     /*  341207 */     // GIR_Coverage, 20919,
     /*  341207 */     GIR_EraseRootFromParent_Done,
     /*  341208 */   // Label 6265: @341208
     /*  341208 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(341274), // Rule ID 20922 //
     /*  341213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  341216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  341224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  341227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  341230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  341255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341272 */     GIR_RootConstrainSelectedInstOperands,
     /*  341273 */     // GIR_Coverage, 20922,
     /*  341273 */     GIR_EraseRootFromParent_Done,
     /*  341274 */   // Label 6266: @341274
     /*  341274 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(341340), // Rule ID 20923 //
     /*  341279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  341282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  341290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  341293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  341296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  341318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  341321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341338 */     GIR_RootConstrainSelectedInstOperands,
     /*  341339 */     // GIR_Coverage, 20923,
     /*  341339 */     GIR_EraseRootFromParent_Done,
     /*  341340 */   // Label 6267: @341340
     /*  341340 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(341406), // Rule ID 20926 //
     /*  341345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  341348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  341356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  341359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  341362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341384 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341404 */     GIR_RootConstrainSelectedInstOperands,
     /*  341405 */     // GIR_Coverage, 20926,
     /*  341405 */     GIR_EraseRootFromParent_Done,
     /*  341406 */   // Label 6268: @341406
     /*  341406 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(341472), // Rule ID 20927 //
     /*  341411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  341414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  341422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  341425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  341428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341450 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  341450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341470 */     GIR_RootConstrainSelectedInstOperands,
     /*  341471 */     // GIR_Coverage, 20927,
     /*  341471 */     GIR_EraseRootFromParent_Done,
     /*  341472 */   // Label 6269: @341472
     /*  341472 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(341538), // Rule ID 20930 //
     /*  341477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  341480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  341488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  341491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  341494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341516 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341536 */     GIR_RootConstrainSelectedInstOperands,
     /*  341537 */     // GIR_Coverage, 20930,
     /*  341537 */     GIR_EraseRootFromParent_Done,
     /*  341538 */   // Label 6270: @341538
     /*  341538 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(341604), // Rule ID 20931 //
     /*  341543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  341546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  341554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  341557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  341560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341582 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  341582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341602 */     GIR_RootConstrainSelectedInstOperands,
     /*  341603 */     // GIR_Coverage, 20931,
     /*  341603 */     GIR_EraseRootFromParent_Done,
     /*  341604 */   // Label 6271: @341604
     /*  341604 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(341670), // Rule ID 20934 //
     /*  341609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  341620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  341623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  341626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  341651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341668 */     GIR_RootConstrainSelectedInstOperands,
     /*  341669 */     // GIR_Coverage, 20934,
     /*  341669 */     GIR_EraseRootFromParent_Done,
     /*  341670 */   // Label 6272: @341670
     /*  341670 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(341736), // Rule ID 20935 //
     /*  341675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  341686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  341689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  341692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341714 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  341717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341734 */     GIR_RootConstrainSelectedInstOperands,
     /*  341735 */     // GIR_Coverage, 20935,
     /*  341735 */     GIR_EraseRootFromParent_Done,
     /*  341736 */   // Label 6273: @341736
     /*  341736 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(341802), // Rule ID 20938 //
     /*  341741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  341752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  341755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  341758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341780 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  341783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341800 */     GIR_RootConstrainSelectedInstOperands,
     /*  341801 */     // GIR_Coverage, 20938,
     /*  341801 */     GIR_EraseRootFromParent_Done,
     /*  341802 */   // Label 6274: @341802
     /*  341802 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(341868), // Rule ID 20939 //
     /*  341807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  341818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  341821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  341824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341846 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  341849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341866 */     GIR_RootConstrainSelectedInstOperands,
     /*  341867 */     // GIR_Coverage, 20939,
     /*  341867 */     GIR_EraseRootFromParent_Done,
     /*  341868 */   // Label 6275: @341868
     /*  341868 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(341934), // Rule ID 20942 //
     /*  341873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  341884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  341887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  341890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341912 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  341915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341932 */     GIR_RootConstrainSelectedInstOperands,
     /*  341933 */     // GIR_Coverage, 20942,
     /*  341933 */     GIR_EraseRootFromParent_Done,
     /*  341934 */   // Label 6276: @341934
     /*  341934 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(342000), // Rule ID 20943 //
     /*  341939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  341950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  341953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  341956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341978 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  341981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341998 */     GIR_RootConstrainSelectedInstOperands,
     /*  341999 */     // GIR_Coverage, 20943,
     /*  341999 */     GIR_EraseRootFromParent_Done,
     /*  342000 */   // Label 6277: @342000
     /*  342000 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(342066), // Rule ID 20946 //
     /*  342005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  342016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  342019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  342022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342044 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342064 */     GIR_RootConstrainSelectedInstOperands,
     /*  342065 */     // GIR_Coverage, 20946,
     /*  342065 */     GIR_EraseRootFromParent_Done,
     /*  342066 */   // Label 6278: @342066
     /*  342066 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(342132), // Rule ID 20947 //
     /*  342071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  342082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  342085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  342088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342110 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342130 */     GIR_RootConstrainSelectedInstOperands,
     /*  342131 */     // GIR_Coverage, 20947,
     /*  342131 */     GIR_EraseRootFromParent_Done,
     /*  342132 */   // Label 6279: @342132
     /*  342132 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(342198), // Rule ID 20950 //
     /*  342137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  342148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  342151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  342154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342176 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342196 */     GIR_RootConstrainSelectedInstOperands,
     /*  342197 */     // GIR_Coverage, 20950,
     /*  342197 */     GIR_EraseRootFromParent_Done,
     /*  342198 */   // Label 6280: @342198
     /*  342198 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(342264), // Rule ID 20951 //
     /*  342203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  342214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  342217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  342220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342242 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342262 */     GIR_RootConstrainSelectedInstOperands,
     /*  342263 */     // GIR_Coverage, 20951,
     /*  342263 */     GIR_EraseRootFromParent_Done,
     /*  342264 */   // Label 6281: @342264
     /*  342264 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(342330), // Rule ID 20954 //
     /*  342269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  342272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  342280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  342283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  342286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  342308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342328 */     GIR_RootConstrainSelectedInstOperands,
     /*  342329 */     // GIR_Coverage, 20954,
     /*  342329 */     GIR_EraseRootFromParent_Done,
     /*  342330 */   // Label 6282: @342330
     /*  342330 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(342396), // Rule ID 20955 //
     /*  342335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  342338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  342346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  342349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  342352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  342374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342394 */     GIR_RootConstrainSelectedInstOperands,
     /*  342395 */     // GIR_Coverage, 20955,
     /*  342395 */     GIR_EraseRootFromParent_Done,
     /*  342396 */   // Label 6283: @342396
     /*  342396 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(342462), // Rule ID 20958 //
     /*  342401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  342412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  342415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  342418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342440 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342460 */     GIR_RootConstrainSelectedInstOperands,
     /*  342461 */     // GIR_Coverage, 20958,
     /*  342461 */     GIR_EraseRootFromParent_Done,
     /*  342462 */   // Label 6284: @342462
     /*  342462 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(342528), // Rule ID 20959 //
     /*  342467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  342478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  342481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  342484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342506 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342526 */     GIR_RootConstrainSelectedInstOperands,
     /*  342527 */     // GIR_Coverage, 20959,
     /*  342527 */     GIR_EraseRootFromParent_Done,
     /*  342528 */   // Label 6285: @342528
     /*  342528 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(342594), // Rule ID 20962 //
     /*  342533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  342544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  342547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  342550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342572 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  342575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342592 */     GIR_RootConstrainSelectedInstOperands,
     /*  342593 */     // GIR_Coverage, 20962,
     /*  342593 */     GIR_EraseRootFromParent_Done,
     /*  342594 */   // Label 6286: @342594
     /*  342594 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(342660), // Rule ID 20963 //
     /*  342599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  342610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  342613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  342616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342638 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  342641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342658 */     GIR_RootConstrainSelectedInstOperands,
     /*  342659 */     // GIR_Coverage, 20963,
     /*  342659 */     GIR_EraseRootFromParent_Done,
     /*  342660 */   // Label 6287: @342660
     /*  342660 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(342726), // Rule ID 20966 //
     /*  342665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  342676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  342679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  342682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342704 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  342707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342724 */     GIR_RootConstrainSelectedInstOperands,
     /*  342725 */     // GIR_Coverage, 20966,
     /*  342725 */     GIR_EraseRootFromParent_Done,
     /*  342726 */   // Label 6288: @342726
     /*  342726 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(342792), // Rule ID 20967 //
     /*  342731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  342742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  342745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  342748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342770 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  342773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342790 */     GIR_RootConstrainSelectedInstOperands,
     /*  342791 */     // GIR_Coverage, 20967,
     /*  342791 */     GIR_EraseRootFromParent_Done,
     /*  342792 */   // Label 6289: @342792
     /*  342792 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(342858), // Rule ID 20970 //
     /*  342797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  342808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  342811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  342814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342856 */     GIR_RootConstrainSelectedInstOperands,
     /*  342857 */     // GIR_Coverage, 20970,
     /*  342857 */     GIR_EraseRootFromParent_Done,
     /*  342858 */   // Label 6290: @342858
     /*  342858 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(342924), // Rule ID 20971 //
     /*  342863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  342874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  342877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  342880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342922 */     GIR_RootConstrainSelectedInstOperands,
     /*  342923 */     // GIR_Coverage, 20971,
     /*  342923 */     GIR_EraseRootFromParent_Done,
     /*  342924 */   // Label 6291: @342924
     /*  342924 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(342990), // Rule ID 20974 //
     /*  342929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  342940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  342943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  342946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  342971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342988 */     GIR_RootConstrainSelectedInstOperands,
     /*  342989 */     // GIR_Coverage, 20974,
     /*  342989 */     GIR_EraseRootFromParent_Done,
     /*  342990 */   // Label 6292: @342990
     /*  342990 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(343056), // Rule ID 20975 //
     /*  342995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  343006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  343009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  343012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343034 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343054 */     GIR_RootConstrainSelectedInstOperands,
     /*  343055 */     // GIR_Coverage, 20975,
     /*  343055 */     GIR_EraseRootFromParent_Done,
     /*  343056 */   // Label 6293: @343056
     /*  343056 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(343122), // Rule ID 20978 //
     /*  343061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  343064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  343072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  343075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  343078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  343100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343120 */     GIR_RootConstrainSelectedInstOperands,
     /*  343121 */     // GIR_Coverage, 20978,
     /*  343121 */     GIR_EraseRootFromParent_Done,
     /*  343122 */   // Label 6294: @343122
     /*  343122 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(343188), // Rule ID 20979 //
     /*  343127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  343130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  343138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  343141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  343144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343186 */     GIR_RootConstrainSelectedInstOperands,
     /*  343187 */     // GIR_Coverage, 20979,
     /*  343187 */     GIR_EraseRootFromParent_Done,
     /*  343188 */   // Label 6295: @343188
     /*  343188 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(343254), // Rule ID 20982 //
     /*  343193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  343210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343232 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  343235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343252 */     GIR_RootConstrainSelectedInstOperands,
     /*  343253 */     // GIR_Coverage, 20982,
     /*  343253 */     GIR_EraseRootFromParent_Done,
     /*  343254 */   // Label 6296: @343254
     /*  343254 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(343320), // Rule ID 20983 //
     /*  343259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  343276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  343301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343318 */     GIR_RootConstrainSelectedInstOperands,
     /*  343319 */     // GIR_Coverage, 20983,
     /*  343319 */     GIR_EraseRootFromParent_Done,
     /*  343320 */   // Label 6297: @343320
     /*  343320 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(343386), // Rule ID 20986 //
     /*  343325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343384 */     GIR_RootConstrainSelectedInstOperands,
     /*  343385 */     // GIR_Coverage, 20986,
     /*  343385 */     GIR_EraseRootFromParent_Done,
     /*  343386 */   // Label 6298: @343386
     /*  343386 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(343452), // Rule ID 20987 //
     /*  343391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343430 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343450 */     GIR_RootConstrainSelectedInstOperands,
     /*  343451 */     // GIR_Coverage, 20987,
     /*  343451 */     GIR_EraseRootFromParent_Done,
     /*  343452 */   // Label 6299: @343452
     /*  343452 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(343518), // Rule ID 20990 //
     /*  343457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343496 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343516 */     GIR_RootConstrainSelectedInstOperands,
     /*  343517 */     // GIR_Coverage, 20990,
     /*  343517 */     GIR_EraseRootFromParent_Done,
     /*  343518 */   // Label 6300: @343518
     /*  343518 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(343584), // Rule ID 20991 //
     /*  343523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343562 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343582 */     GIR_RootConstrainSelectedInstOperands,
     /*  343583 */     // GIR_Coverage, 20991,
     /*  343583 */     GIR_EraseRootFromParent_Done,
     /*  343584 */   // Label 6301: @343584
     /*  343584 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(343650), // Rule ID 21258 //
     /*  343589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  343600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  343603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  343606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343628 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  343631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343648 */     GIR_RootConstrainSelectedInstOperands,
     /*  343649 */     // GIR_Coverage, 21258,
     /*  343649 */     GIR_EraseRootFromParent_Done,
     /*  343650 */   // Label 6302: @343650
     /*  343650 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(343716), // Rule ID 21259 //
     /*  343655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  343666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  343669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  343672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343694 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  343697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343714 */     GIR_RootConstrainSelectedInstOperands,
     /*  343715 */     // GIR_Coverage, 21259,
     /*  343715 */     GIR_EraseRootFromParent_Done,
     /*  343716 */   // Label 6303: @343716
     /*  343716 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(343782), // Rule ID 21262 //
     /*  343721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  343732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  343735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  343738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343760 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  343763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343780 */     GIR_RootConstrainSelectedInstOperands,
     /*  343781 */     // GIR_Coverage, 21262,
     /*  343781 */     GIR_EraseRootFromParent_Done,
     /*  343782 */   // Label 6304: @343782
     /*  343782 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(343848), // Rule ID 21263 //
     /*  343787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  343798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  343801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  343804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  343829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343846 */     GIR_RootConstrainSelectedInstOperands,
     /*  343847 */     // GIR_Coverage, 21263,
     /*  343847 */     GIR_EraseRootFromParent_Done,
     /*  343848 */   // Label 6305: @343848
     /*  343848 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(343914), // Rule ID 21266 //
     /*  343853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  343864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  343867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  343870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  343895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343912 */     GIR_RootConstrainSelectedInstOperands,
     /*  343913 */     // GIR_Coverage, 21266,
     /*  343913 */     GIR_EraseRootFromParent_Done,
     /*  343914 */   // Label 6306: @343914
     /*  343914 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(343980), // Rule ID 21267 //
     /*  343919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  343930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  343933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  343936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  343961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343978 */     GIR_RootConstrainSelectedInstOperands,
     /*  343979 */     // GIR_Coverage, 21267,
     /*  343979 */     GIR_EraseRootFromParent_Done,
     /*  343980 */   // Label 6307: @343980
     /*  343980 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(344046), // Rule ID 21270 //
     /*  343985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  343996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  343999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  344002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344024 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344044 */     GIR_RootConstrainSelectedInstOperands,
     /*  344045 */     // GIR_Coverage, 21270,
     /*  344045 */     GIR_EraseRootFromParent_Done,
     /*  344046 */   // Label 6308: @344046
     /*  344046 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(344112), // Rule ID 21271 //
     /*  344051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  344062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  344065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  344068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344090 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344110 */     GIR_RootConstrainSelectedInstOperands,
     /*  344111 */     // GIR_Coverage, 21271,
     /*  344111 */     GIR_EraseRootFromParent_Done,
     /*  344112 */   // Label 6309: @344112
     /*  344112 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(344178), // Rule ID 21274 //
     /*  344117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344156 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344176 */     GIR_RootConstrainSelectedInstOperands,
     /*  344177 */     // GIR_Coverage, 21274,
     /*  344177 */     GIR_EraseRootFromParent_Done,
     /*  344178 */   // Label 6310: @344178
     /*  344178 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(344244), // Rule ID 21275 //
     /*  344183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344222 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344242 */     GIR_RootConstrainSelectedInstOperands,
     /*  344243 */     // GIR_Coverage, 21275,
     /*  344243 */     GIR_EraseRootFromParent_Done,
     /*  344244 */   // Label 6311: @344244
     /*  344244 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(344310), // Rule ID 21278 //
     /*  344249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  344266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344288 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  344291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344308 */     GIR_RootConstrainSelectedInstOperands,
     /*  344309 */     // GIR_Coverage, 21278,
     /*  344309 */     GIR_EraseRootFromParent_Done,
     /*  344310 */   // Label 6312: @344310
     /*  344310 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(344376), // Rule ID 21279 //
     /*  344315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  344332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344354 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  344357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344374 */     GIR_RootConstrainSelectedInstOperands,
     /*  344375 */     // GIR_Coverage, 21279,
     /*  344375 */     GIR_EraseRootFromParent_Done,
     /*  344376 */   // Label 6313: @344376
     /*  344376 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(344442), // Rule ID 21282 //
     /*  344381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  344392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  344395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344420 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  344423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344440 */     GIR_RootConstrainSelectedInstOperands,
     /*  344441 */     // GIR_Coverage, 21282,
     /*  344441 */     GIR_EraseRootFromParent_Done,
     /*  344442 */   // Label 6314: @344442
     /*  344442 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(344508), // Rule ID 21283 //
     /*  344447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  344458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  344461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  344489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344506 */     GIR_RootConstrainSelectedInstOperands,
     /*  344507 */     // GIR_Coverage, 21283,
     /*  344507 */     GIR_EraseRootFromParent_Done,
     /*  344508 */   // Label 6315: @344508
     /*  344508 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(344574), // Rule ID 21286 //
     /*  344513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  344524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  344527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  344530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344552 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344572 */     GIR_RootConstrainSelectedInstOperands,
     /*  344573 */     // GIR_Coverage, 21286,
     /*  344573 */     GIR_EraseRootFromParent_Done,
     /*  344574 */   // Label 6316: @344574
     /*  344574 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(344640), // Rule ID 21287 //
     /*  344579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  344590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  344593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  344596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344618 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344638 */     GIR_RootConstrainSelectedInstOperands,
     /*  344639 */     // GIR_Coverage, 21287,
     /*  344639 */     GIR_EraseRootFromParent_Done,
     /*  344640 */   // Label 6317: @344640
     /*  344640 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(344706), // Rule ID 21290 //
     /*  344645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  344656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  344659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  344662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344684 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344704 */     GIR_RootConstrainSelectedInstOperands,
     /*  344705 */     // GIR_Coverage, 21290,
     /*  344705 */     GIR_EraseRootFromParent_Done,
     /*  344706 */   // Label 6318: @344706
     /*  344706 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(344772), // Rule ID 21291 //
     /*  344711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  344722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  344725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  344728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344750 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344770 */     GIR_RootConstrainSelectedInstOperands,
     /*  344771 */     // GIR_Coverage, 21291,
     /*  344771 */     GIR_EraseRootFromParent_Done,
     /*  344772 */   // Label 6319: @344772
     /*  344772 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(344838), // Rule ID 21294 //
     /*  344777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  344788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  344791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  344794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344816 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  344819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344836 */     GIR_RootConstrainSelectedInstOperands,
     /*  344837 */     // GIR_Coverage, 21294,
     /*  344837 */     GIR_EraseRootFromParent_Done,
     /*  344838 */   // Label 6320: @344838
     /*  344838 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(344904), // Rule ID 21295 //
     /*  344843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  344854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  344857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  344860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344882 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  344885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344902 */     GIR_RootConstrainSelectedInstOperands,
     /*  344903 */     // GIR_Coverage, 21295,
     /*  344903 */     GIR_EraseRootFromParent_Done,
     /*  344904 */   // Label 6321: @344904
     /*  344904 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(344970), // Rule ID 21298 //
     /*  344909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  344926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344948 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  344951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344968 */     GIR_RootConstrainSelectedInstOperands,
     /*  344969 */     // GIR_Coverage, 21298,
     /*  344969 */     GIR_EraseRootFromParent_Done,
     /*  344970 */   // Label 6322: @344970
     /*  344970 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(345036), // Rule ID 21299 //
     /*  344975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  344992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345014 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345034 */     GIR_RootConstrainSelectedInstOperands,
     /*  345035 */     // GIR_Coverage, 21299,
     /*  345035 */     GIR_EraseRootFromParent_Done,
     /*  345036 */   // Label 6323: @345036
     /*  345036 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(345102), // Rule ID 21302 //
     /*  345041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  345052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  345055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  345058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345080 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345100 */     GIR_RootConstrainSelectedInstOperands,
     /*  345101 */     // GIR_Coverage, 21302,
     /*  345101 */     GIR_EraseRootFromParent_Done,
     /*  345102 */   // Label 6324: @345102
     /*  345102 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(345168), // Rule ID 21303 //
     /*  345107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  345118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  345121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  345124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345166 */     GIR_RootConstrainSelectedInstOperands,
     /*  345167 */     // GIR_Coverage, 21303,
     /*  345167 */     GIR_EraseRootFromParent_Done,
     /*  345168 */   // Label 6325: @345168
     /*  345168 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(345234), // Rule ID 21306 //
     /*  345173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  345184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  345187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  345190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345212 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345232 */     GIR_RootConstrainSelectedInstOperands,
     /*  345233 */     // GIR_Coverage, 21306,
     /*  345233 */     GIR_EraseRootFromParent_Done,
     /*  345234 */   // Label 6326: @345234
     /*  345234 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(345300), // Rule ID 21307 //
     /*  345239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  345250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  345253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  345256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345278 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345298 */     GIR_RootConstrainSelectedInstOperands,
     /*  345299 */     // GIR_Coverage, 21307,
     /*  345299 */     GIR_EraseRootFromParent_Done,
     /*  345300 */   // Label 6327: @345300
     /*  345300 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(345366), // Rule ID 21310 //
     /*  345305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  345316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  345319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  345322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345344 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345364 */     GIR_RootConstrainSelectedInstOperands,
     /*  345365 */     // GIR_Coverage, 21310,
     /*  345365 */     GIR_EraseRootFromParent_Done,
     /*  345366 */   // Label 6328: @345366
     /*  345366 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(345432), // Rule ID 21311 //
     /*  345371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  345382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  345385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  345388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345410 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345430 */     GIR_RootConstrainSelectedInstOperands,
     /*  345431 */     // GIR_Coverage, 21311,
     /*  345431 */     GIR_EraseRootFromParent_Done,
     /*  345432 */   // Label 6329: @345432
     /*  345432 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(345498), // Rule ID 21314 //
     /*  345437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  345448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  345451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  345454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345496 */     GIR_RootConstrainSelectedInstOperands,
     /*  345497 */     // GIR_Coverage, 21314,
     /*  345497 */     GIR_EraseRootFromParent_Done,
     /*  345498 */   // Label 6330: @345498
     /*  345498 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(345564), // Rule ID 21315 //
     /*  345503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  345514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  345517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  345520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345542 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345562 */     GIR_RootConstrainSelectedInstOperands,
     /*  345563 */     // GIR_Coverage, 21315,
     /*  345563 */     GIR_EraseRootFromParent_Done,
     /*  345564 */   // Label 6331: @345564
     /*  345564 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(345630), // Rule ID 21318 //
     /*  345569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  345580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  345583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  345586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345628 */     GIR_RootConstrainSelectedInstOperands,
     /*  345629 */     // GIR_Coverage, 21318,
     /*  345629 */     GIR_EraseRootFromParent_Done,
     /*  345630 */   // Label 6332: @345630
     /*  345630 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(345696), // Rule ID 21319 //
     /*  345635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  345646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  345649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  345652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345674 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345694 */     GIR_RootConstrainSelectedInstOperands,
     /*  345695 */     // GIR_Coverage, 21319,
     /*  345695 */     GIR_EraseRootFromParent_Done,
     /*  345696 */   // Label 6333: @345696
     /*  345696 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(345762), // Rule ID 21322 //
     /*  345701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  345712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  345715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  345718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345740 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345760 */     GIR_RootConstrainSelectedInstOperands,
     /*  345761 */     // GIR_Coverage, 21322,
     /*  345761 */     GIR_EraseRootFromParent_Done,
     /*  345762 */   // Label 6334: @345762
     /*  345762 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(345828), // Rule ID 21323 //
     /*  345767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  345778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  345781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  345784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345806 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345826 */     GIR_RootConstrainSelectedInstOperands,
     /*  345827 */     // GIR_Coverage, 21323,
     /*  345827 */     GIR_EraseRootFromParent_Done,
     /*  345828 */   // Label 6335: @345828
     /*  345828 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(345894), // Rule ID 21326 //
     /*  345833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  345850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345872 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345892 */     GIR_RootConstrainSelectedInstOperands,
     /*  345893 */     // GIR_Coverage, 21326,
     /*  345893 */     GIR_EraseRootFromParent_Done,
     /*  345894 */   // Label 6336: @345894
     /*  345894 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(345960), // Rule ID 21327 //
     /*  345899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  345916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345938 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345958 */     GIR_RootConstrainSelectedInstOperands,
     /*  345959 */     // GIR_Coverage, 21327,
     /*  345959 */     GIR_EraseRootFromParent_Done,
     /*  345960 */   // Label 6337: @345960
     /*  345960 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(346026), // Rule ID 21330 //
     /*  345965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  345973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  345976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  345979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  345982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346004 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  346007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346024 */     GIR_RootConstrainSelectedInstOperands,
     /*  346025 */     // GIR_Coverage, 21330,
     /*  346025 */     GIR_EraseRootFromParent_Done,
     /*  346026 */   // Label 6338: @346026
     /*  346026 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(346092), // Rule ID 21331 //
     /*  346031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  346042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  346045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  346048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346070 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  346073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346090 */     GIR_RootConstrainSelectedInstOperands,
     /*  346091 */     // GIR_Coverage, 21331,
     /*  346091 */     GIR_EraseRootFromParent_Done,
     /*  346092 */   // Label 6339: @346092
     /*  346092 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(346158), // Rule ID 21334 //
     /*  346097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  346108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  346111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  346114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346136 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  346139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346156 */     GIR_RootConstrainSelectedInstOperands,
     /*  346157 */     // GIR_Coverage, 21334,
     /*  346157 */     GIR_EraseRootFromParent_Done,
     /*  346158 */   // Label 6340: @346158
     /*  346158 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(346224), // Rule ID 21335 //
     /*  346163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  346174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  346177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  346180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346202 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  346205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346222 */     GIR_RootConstrainSelectedInstOperands,
     /*  346223 */     // GIR_Coverage, 21335,
     /*  346223 */     GIR_EraseRootFromParent_Done,
     /*  346224 */   // Label 6341: @346224
     /*  346224 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(346290), // Rule ID 21338 //
     /*  346229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  346240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  346243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  346246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346268 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  346271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346288 */     GIR_RootConstrainSelectedInstOperands,
     /*  346289 */     // GIR_Coverage, 21338,
     /*  346289 */     GIR_EraseRootFromParent_Done,
     /*  346290 */   // Label 6342: @346290
     /*  346290 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(346356), // Rule ID 21339 //
     /*  346295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  346306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  346309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  346312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346334 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  346337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346354 */     GIR_RootConstrainSelectedInstOperands,
     /*  346355 */     // GIR_Coverage, 21339,
     /*  346355 */     GIR_EraseRootFromParent_Done,
     /*  346356 */   // Label 6343: @346356
     /*  346356 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(346422), // Rule ID 21342 //
     /*  346361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  346372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  346375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  346378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346400 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  346403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346420 */     GIR_RootConstrainSelectedInstOperands,
     /*  346421 */     // GIR_Coverage, 21342,
     /*  346421 */     GIR_EraseRootFromParent_Done,
     /*  346422 */   // Label 6344: @346422
     /*  346422 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(346488), // Rule ID 21343 //
     /*  346427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  346438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  346441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  346444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346466 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  346469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346486 */     GIR_RootConstrainSelectedInstOperands,
     /*  346487 */     // GIR_Coverage, 21343,
     /*  346487 */     GIR_EraseRootFromParent_Done,
     /*  346488 */   // Label 6345: @346488
     /*  346488 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(346554), // Rule ID 21346 //
     /*  346493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  346504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  346507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  346510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346532 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  346535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346552 */     GIR_RootConstrainSelectedInstOperands,
     /*  346553 */     // GIR_Coverage, 21346,
     /*  346553 */     GIR_EraseRootFromParent_Done,
     /*  346554 */   // Label 6346: @346554
     /*  346554 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(346620), // Rule ID 21347 //
     /*  346559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  346570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  346573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  346576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346598 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  346601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346618 */     GIR_RootConstrainSelectedInstOperands,
     /*  346619 */     // GIR_Coverage, 21347,
     /*  346619 */     GIR_EraseRootFromParent_Done,
     /*  346620 */   // Label 6347: @346620
     /*  346620 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(346686), // Rule ID 21350 //
     /*  346625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  346636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  346639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  346642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346664 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  346667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346684 */     GIR_RootConstrainSelectedInstOperands,
     /*  346685 */     // GIR_Coverage, 21350,
     /*  346685 */     GIR_EraseRootFromParent_Done,
     /*  346686 */   // Label 6348: @346686
     /*  346686 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(346752), // Rule ID 21351 //
     /*  346691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  346702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  346705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  346708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346730 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  346733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346750 */     GIR_RootConstrainSelectedInstOperands,
     /*  346751 */     // GIR_Coverage, 21351,
     /*  346751 */     GIR_EraseRootFromParent_Done,
     /*  346752 */   // Label 6349: @346752
     /*  346752 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(346818), // Rule ID 21354 //
     /*  346757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  346768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  346771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  346774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346796 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  346799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346816 */     GIR_RootConstrainSelectedInstOperands,
     /*  346817 */     // GIR_Coverage, 21354,
     /*  346817 */     GIR_EraseRootFromParent_Done,
     /*  346818 */   // Label 6350: @346818
     /*  346818 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(346884), // Rule ID 21355 //
     /*  346823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  346834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  346837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  346840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346862 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  346865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346882 */     GIR_RootConstrainSelectedInstOperands,
     /*  346883 */     // GIR_Coverage, 21355,
     /*  346883 */     GIR_EraseRootFromParent_Done,
     /*  346884 */   // Label 6351: @346884
     /*  346884 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(346950), // Rule ID 21358 //
     /*  346889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  346900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  346903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  346906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346928 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  346931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346948 */     GIR_RootConstrainSelectedInstOperands,
     /*  346949 */     // GIR_Coverage, 21358,
     /*  346949 */     GIR_EraseRootFromParent_Done,
     /*  346950 */   // Label 6352: @346950
     /*  346950 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(347016), // Rule ID 21359 //
     /*  346955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  346966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  346969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  346972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346994 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  346997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347014 */     GIR_RootConstrainSelectedInstOperands,
     /*  347015 */     // GIR_Coverage, 21359,
     /*  347015 */     GIR_EraseRootFromParent_Done,
     /*  347016 */   // Label 6353: @347016
     /*  347016 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(347082), // Rule ID 21362 //
     /*  347021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  347032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  347035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  347038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347060 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  347063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347080 */     GIR_RootConstrainSelectedInstOperands,
     /*  347081 */     // GIR_Coverage, 21362,
     /*  347081 */     GIR_EraseRootFromParent_Done,
     /*  347082 */   // Label 6354: @347082
     /*  347082 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(347148), // Rule ID 21363 //
     /*  347087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  347098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  347101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  347104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347126 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  347129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347146 */     GIR_RootConstrainSelectedInstOperands,
     /*  347147 */     // GIR_Coverage, 21363,
     /*  347147 */     GIR_EraseRootFromParent_Done,
     /*  347148 */   // Label 6355: @347148
     /*  347148 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(347214), // Rule ID 21366 //
     /*  347153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  347164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  347167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  347170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347192 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  347195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347212 */     GIR_RootConstrainSelectedInstOperands,
     /*  347213 */     // GIR_Coverage, 21366,
     /*  347213 */     GIR_EraseRootFromParent_Done,
     /*  347214 */   // Label 6356: @347214
     /*  347214 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(347280), // Rule ID 21367 //
     /*  347219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  347230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  347233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  347236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347258 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  347261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347278 */     GIR_RootConstrainSelectedInstOperands,
     /*  347279 */     // GIR_Coverage, 21367,
     /*  347279 */     GIR_EraseRootFromParent_Done,
     /*  347280 */   // Label 6357: @347280
     /*  347280 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(347346), // Rule ID 21370 //
     /*  347285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  347296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  347299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  347302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347324 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  347327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347344 */     GIR_RootConstrainSelectedInstOperands,
     /*  347345 */     // GIR_Coverage, 21370,
     /*  347345 */     GIR_EraseRootFromParent_Done,
     /*  347346 */   // Label 6358: @347346
     /*  347346 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(347412), // Rule ID 21371 //
     /*  347351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  347362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  347365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  347368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347390 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  347393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347410 */     GIR_RootConstrainSelectedInstOperands,
     /*  347411 */     // GIR_Coverage, 21371,
     /*  347411 */     GIR_EraseRootFromParent_Done,
     /*  347412 */   // Label 6359: @347412
     /*  347412 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(347478), // Rule ID 21374 //
     /*  347417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  347420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  347428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  347431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  347434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347456 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  347456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  347459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347476 */     GIR_RootConstrainSelectedInstOperands,
     /*  347477 */     // GIR_Coverage, 21374,
     /*  347477 */     GIR_EraseRootFromParent_Done,
     /*  347478 */   // Label 6360: @347478
     /*  347478 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(347544), // Rule ID 21375 //
     /*  347483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  347486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  347494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  347497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  347500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347522 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  347525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347542 */     GIR_RootConstrainSelectedInstOperands,
     /*  347543 */     // GIR_Coverage, 21375,
     /*  347543 */     GIR_EraseRootFromParent_Done,
     /*  347544 */   // Label 6361: @347544
     /*  347544 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(347610), // Rule ID 21378 //
     /*  347549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  347552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  347560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  347563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  347566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347588 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  347588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  347591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347608 */     GIR_RootConstrainSelectedInstOperands,
     /*  347609 */     // GIR_Coverage, 21378,
     /*  347609 */     GIR_EraseRootFromParent_Done,
     /*  347610 */   // Label 6362: @347610
     /*  347610 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(347676), // Rule ID 21379 //
     /*  347615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  347618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  347626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  347629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  347632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347654 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  347657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347674 */     GIR_RootConstrainSelectedInstOperands,
     /*  347675 */     // GIR_Coverage, 21379,
     /*  347675 */     GIR_EraseRootFromParent_Done,
     /*  347676 */   // Label 6363: @347676
     /*  347676 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(347742), // Rule ID 21382 //
     /*  347681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  347684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  347692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  347695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  347698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347720 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  347720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  347723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347740 */     GIR_RootConstrainSelectedInstOperands,
     /*  347741 */     // GIR_Coverage, 21382,
     /*  347741 */     GIR_EraseRootFromParent_Done,
     /*  347742 */   // Label 6364: @347742
     /*  347742 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(347808), // Rule ID 21383 //
     /*  347747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  347750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  347758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  347761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  347764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347786 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  347789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347806 */     GIR_RootConstrainSelectedInstOperands,
     /*  347807 */     // GIR_Coverage, 21383,
     /*  347807 */     GIR_EraseRootFromParent_Done,
     /*  347808 */   // Label 6365: @347808
     /*  347808 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(347874), // Rule ID 21386 //
     /*  347813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  347816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  347824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  347827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  347830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347852 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  347852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  347855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347872 */     GIR_RootConstrainSelectedInstOperands,
     /*  347873 */     // GIR_Coverage, 21386,
     /*  347873 */     GIR_EraseRootFromParent_Done,
     /*  347874 */   // Label 6366: @347874
     /*  347874 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(347940), // Rule ID 21387 //
     /*  347879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  347882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  347890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  347893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  347896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347918 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  347921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347938 */     GIR_RootConstrainSelectedInstOperands,
     /*  347939 */     // GIR_Coverage, 21387,
     /*  347939 */     GIR_EraseRootFromParent_Done,
     /*  347940 */   // Label 6367: @347940
     /*  347940 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(348006), // Rule ID 21390 //
     /*  347945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  347953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  347956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  347959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  347962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347984 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  347984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  347987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348004 */     GIR_RootConstrainSelectedInstOperands,
     /*  348005 */     // GIR_Coverage, 21390,
     /*  348005 */     GIR_EraseRootFromParent_Done,
     /*  348006 */   // Label 6368: @348006
     /*  348006 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(348072), // Rule ID 21391 //
     /*  348011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  348022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  348025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  348028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348050 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  348053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348070 */     GIR_RootConstrainSelectedInstOperands,
     /*  348071 */     // GIR_Coverage, 21391,
     /*  348071 */     GIR_EraseRootFromParent_Done,
     /*  348072 */   // Label 6369: @348072
     /*  348072 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(348138), // Rule ID 21394 //
     /*  348077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  348088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  348091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  348094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348116 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  348119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348136 */     GIR_RootConstrainSelectedInstOperands,
     /*  348137 */     // GIR_Coverage, 21394,
     /*  348137 */     GIR_EraseRootFromParent_Done,
     /*  348138 */   // Label 6370: @348138
     /*  348138 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(348204), // Rule ID 21395 //
     /*  348143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  348154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  348157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  348160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348182 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  348185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348202 */     GIR_RootConstrainSelectedInstOperands,
     /*  348203 */     // GIR_Coverage, 21395,
     /*  348203 */     GIR_EraseRootFromParent_Done,
     /*  348204 */   // Label 6371: @348204
     /*  348204 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(348270), // Rule ID 21398 //
     /*  348209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  348220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  348223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  348226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348248 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  348251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348268 */     GIR_RootConstrainSelectedInstOperands,
     /*  348269 */     // GIR_Coverage, 21398,
     /*  348269 */     GIR_EraseRootFromParent_Done,
     /*  348270 */   // Label 6372: @348270
     /*  348270 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(348336), // Rule ID 21399 //
     /*  348275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  348286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  348289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  348292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348314 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  348317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348334 */     GIR_RootConstrainSelectedInstOperands,
     /*  348335 */     // GIR_Coverage, 21399,
     /*  348335 */     GIR_EraseRootFromParent_Done,
     /*  348336 */   // Label 6373: @348336
     /*  348336 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(348402), // Rule ID 21402 //
     /*  348341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  348352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  348355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  348358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348380 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  348383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348400 */     GIR_RootConstrainSelectedInstOperands,
     /*  348401 */     // GIR_Coverage, 21402,
     /*  348401 */     GIR_EraseRootFromParent_Done,
     /*  348402 */   // Label 6374: @348402
     /*  348402 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(348468), // Rule ID 21403 //
     /*  348407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  348418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  348421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  348424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348446 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  348449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348466 */     GIR_RootConstrainSelectedInstOperands,
     /*  348467 */     // GIR_Coverage, 21403,
     /*  348467 */     GIR_EraseRootFromParent_Done,
     /*  348468 */   // Label 6375: @348468
     /*  348468 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(348534), // Rule ID 21406 //
     /*  348473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  348484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  348487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  348490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348512 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  348515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348532 */     GIR_RootConstrainSelectedInstOperands,
     /*  348533 */     // GIR_Coverage, 21406,
     /*  348533 */     GIR_EraseRootFromParent_Done,
     /*  348534 */   // Label 6376: @348534
     /*  348534 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(348600), // Rule ID 21407 //
     /*  348539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  348550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  348553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  348556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348578 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  348581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348598 */     GIR_RootConstrainSelectedInstOperands,
     /*  348599 */     // GIR_Coverage, 21407,
     /*  348599 */     GIR_EraseRootFromParent_Done,
     /*  348600 */   // Label 6377: @348600
     /*  348600 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(348666), // Rule ID 21410 //
     /*  348605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  348616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  348619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  348622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348644 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  348647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348664 */     GIR_RootConstrainSelectedInstOperands,
     /*  348665 */     // GIR_Coverage, 21410,
     /*  348665 */     GIR_EraseRootFromParent_Done,
     /*  348666 */   // Label 6378: @348666
     /*  348666 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(348732), // Rule ID 21411 //
     /*  348671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  348682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  348685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  348688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348710 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  348713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348730 */     GIR_RootConstrainSelectedInstOperands,
     /*  348731 */     // GIR_Coverage, 21411,
     /*  348731 */     GIR_EraseRootFromParent_Done,
     /*  348732 */   // Label 6379: @348732
     /*  348732 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(348798), // Rule ID 21414 //
     /*  348737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  348740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  348748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  348751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  348754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348776 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  348779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348796 */     GIR_RootConstrainSelectedInstOperands,
     /*  348797 */     // GIR_Coverage, 21414,
     /*  348797 */     GIR_EraseRootFromParent_Done,
     /*  348798 */   // Label 6380: @348798
     /*  348798 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(348864), // Rule ID 21415 //
     /*  348803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  348806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  348814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  348817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  348820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348842 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  348845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348862 */     GIR_RootConstrainSelectedInstOperands,
     /*  348863 */     // GIR_Coverage, 21415,
     /*  348863 */     GIR_EraseRootFromParent_Done,
     /*  348864 */   // Label 6381: @348864
     /*  348864 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(348930), // Rule ID 21418 //
     /*  348869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  348872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  348880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  348883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  348886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348908 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  348911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348928 */     GIR_RootConstrainSelectedInstOperands,
     /*  348929 */     // GIR_Coverage, 21418,
     /*  348929 */     GIR_EraseRootFromParent_Done,
     /*  348930 */   // Label 6382: @348930
     /*  348930 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(348996), // Rule ID 21419 //
     /*  348935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  348938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  348946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  348949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  348952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348974 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  348977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348994 */     GIR_RootConstrainSelectedInstOperands,
     /*  348995 */     // GIR_Coverage, 21419,
     /*  348995 */     GIR_EraseRootFromParent_Done,
     /*  348996 */   // Label 6383: @348996
     /*  348996 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(349062), // Rule ID 21422 //
     /*  349001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  349012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  349015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  349018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349040 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  349043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349060 */     GIR_RootConstrainSelectedInstOperands,
     /*  349061 */     // GIR_Coverage, 21422,
     /*  349061 */     GIR_EraseRootFromParent_Done,
     /*  349062 */   // Label 6384: @349062
     /*  349062 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(349128), // Rule ID 21423 //
     /*  349067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  349078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  349081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  349084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349106 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  349109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349126 */     GIR_RootConstrainSelectedInstOperands,
     /*  349127 */     // GIR_Coverage, 21423,
     /*  349127 */     GIR_EraseRootFromParent_Done,
     /*  349128 */   // Label 6385: @349128
     /*  349128 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(349194), // Rule ID 21426 //
     /*  349133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349172 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  349175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349192 */     GIR_RootConstrainSelectedInstOperands,
     /*  349193 */     // GIR_Coverage, 21426,
     /*  349193 */     GIR_EraseRootFromParent_Done,
     /*  349194 */   // Label 6386: @349194
     /*  349194 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(349260), // Rule ID 21427 //
     /*  349199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349238 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  349241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349258 */     GIR_RootConstrainSelectedInstOperands,
     /*  349259 */     // GIR_Coverage, 21427,
     /*  349259 */     GIR_EraseRootFromParent_Done,
     /*  349260 */   // Label 6387: @349260
     /*  349260 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(349326), // Rule ID 21430 //
     /*  349265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  349276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  349279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349304 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  349307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349324 */     GIR_RootConstrainSelectedInstOperands,
     /*  349325 */     // GIR_Coverage, 21430,
     /*  349325 */     GIR_EraseRootFromParent_Done,
     /*  349326 */   // Label 6388: @349326
     /*  349326 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(349392), // Rule ID 21431 //
     /*  349331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  349342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  349345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349370 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  349373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349390 */     GIR_RootConstrainSelectedInstOperands,
     /*  349391 */     // GIR_Coverage, 21431,
     /*  349391 */     GIR_EraseRootFromParent_Done,
     /*  349392 */   // Label 6389: @349392
     /*  349392 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(349458), // Rule ID 21434 //
     /*  349397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  349408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  349411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  349414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349436 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  349439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349456 */     GIR_RootConstrainSelectedInstOperands,
     /*  349457 */     // GIR_Coverage, 21434,
     /*  349457 */     GIR_EraseRootFromParent_Done,
     /*  349458 */   // Label 6390: @349458
     /*  349458 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(349524), // Rule ID 21435 //
     /*  349463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  349466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  349474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  349477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  349480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349502 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  349505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349522 */     GIR_RootConstrainSelectedInstOperands,
     /*  349523 */     // GIR_Coverage, 21435,
     /*  349523 */     GIR_EraseRootFromParent_Done,
     /*  349524 */   // Label 6391: @349524
     /*  349524 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(349590), // Rule ID 21438 //
     /*  349529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  349540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  349543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  349546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349568 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  349571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349588 */     GIR_RootConstrainSelectedInstOperands,
     /*  349589 */     // GIR_Coverage, 21438,
     /*  349589 */     GIR_EraseRootFromParent_Done,
     /*  349590 */   // Label 6392: @349590
     /*  349590 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(349656), // Rule ID 21439 //
     /*  349595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  349598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  349606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  349609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  349612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349634 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  349637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349654 */     GIR_RootConstrainSelectedInstOperands,
     /*  349655 */     // GIR_Coverage, 21439,
     /*  349655 */     GIR_EraseRootFromParent_Done,
     /*  349656 */   // Label 6393: @349656
     /*  349656 */   GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(349722), // Rule ID 21442 //
     /*  349661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  349672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  349675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  349678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349700 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  349703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349720 */     GIR_RootConstrainSelectedInstOperands,
     /*  349721 */     // GIR_Coverage, 21442,
     /*  349721 */     GIR_EraseRootFromParent_Done,
     /*  349722 */   // Label 6394: @349722
     /*  349722 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(349788), // Rule ID 21443 //
     /*  349727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  349730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  349738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  349741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  349744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349766 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  349769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349786 */     GIR_RootConstrainSelectedInstOperands,
     /*  349787 */     // GIR_Coverage, 21443,
     /*  349787 */     GIR_EraseRootFromParent_Done,
     /*  349788 */   // Label 6395: @349788
     /*  349788 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(349854), // Rule ID 21446 //
     /*  349793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  349804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  349807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  349810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349832 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  349835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349852 */     GIR_RootConstrainSelectedInstOperands,
     /*  349853 */     // GIR_Coverage, 21446,
     /*  349853 */     GIR_EraseRootFromParent_Done,
     /*  349854 */   // Label 6396: @349854
     /*  349854 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(349920), // Rule ID 21447 //
     /*  349859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  349862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  349870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  349873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  349876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349898 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  349901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349918 */     GIR_RootConstrainSelectedInstOperands,
     /*  349919 */     // GIR_Coverage, 21447,
     /*  349919 */     GIR_EraseRootFromParent_Done,
     /*  349920 */   // Label 6397: @349920
     /*  349920 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(349986), // Rule ID 21450 //
     /*  349925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  349928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  349933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  349936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  349939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  349942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349964 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  349967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349984 */     GIR_RootConstrainSelectedInstOperands,
     /*  349985 */     // GIR_Coverage, 21450,
     /*  349985 */     GIR_EraseRootFromParent_Done,
     /*  349986 */   // Label 6398: @349986
     /*  349986 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(350052), // Rule ID 21451 //
     /*  349991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  349994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  349999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  350002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  350005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  350008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350030 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  350033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350050 */     GIR_RootConstrainSelectedInstOperands,
     /*  350051 */     // GIR_Coverage, 21451,
     /*  350051 */     GIR_EraseRootFromParent_Done,
     /*  350052 */   // Label 6399: @350052
     /*  350052 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(350118), // Rule ID 21454 //
     /*  350057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  350068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  350071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350096 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  350099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350116 */     GIR_RootConstrainSelectedInstOperands,
     /*  350117 */     // GIR_Coverage, 21454,
     /*  350117 */     GIR_EraseRootFromParent_Done,
     /*  350118 */   // Label 6400: @350118
     /*  350118 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(350184), // Rule ID 21455 //
     /*  350123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  350134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  350137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350162 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  350165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350182 */     GIR_RootConstrainSelectedInstOperands,
     /*  350183 */     // GIR_Coverage, 21455,
     /*  350183 */     GIR_EraseRootFromParent_Done,
     /*  350184 */   // Label 6401: @350184
     /*  350184 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(350250), // Rule ID 21458 //
     /*  350189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  350200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  350203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350228 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  350231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350248 */     GIR_RootConstrainSelectedInstOperands,
     /*  350249 */     // GIR_Coverage, 21458,
     /*  350249 */     GIR_EraseRootFromParent_Done,
     /*  350250 */   // Label 6402: @350250
     /*  350250 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(350316), // Rule ID 21459 //
     /*  350255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  350266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  350269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350294 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  350297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350314 */     GIR_RootConstrainSelectedInstOperands,
     /*  350315 */     // GIR_Coverage, 21459,
     /*  350315 */     GIR_EraseRootFromParent_Done,
     /*  350316 */   // Label 6403: @350316
     /*  350316 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(350382), // Rule ID 21462 //
     /*  350321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  350332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  350335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  350338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350360 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  350363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350380 */     GIR_RootConstrainSelectedInstOperands,
     /*  350381 */     // GIR_Coverage, 21462,
     /*  350381 */     GIR_EraseRootFromParent_Done,
     /*  350382 */   // Label 6404: @350382
     /*  350382 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(350448), // Rule ID 21463 //
     /*  350387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  350398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  350401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  350404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350426 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  350429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350446 */     GIR_RootConstrainSelectedInstOperands,
     /*  350447 */     // GIR_Coverage, 21463,
     /*  350447 */     GIR_EraseRootFromParent_Done,
     /*  350448 */   // Label 6405: @350448
     /*  350448 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(350514), // Rule ID 21466 //
     /*  350453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  350464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  350467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  350470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350492 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  350495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350512 */     GIR_RootConstrainSelectedInstOperands,
     /*  350513 */     // GIR_Coverage, 21466,
     /*  350513 */     GIR_EraseRootFromParent_Done,
     /*  350514 */   // Label 6406: @350514
     /*  350514 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(350580), // Rule ID 21467 //
     /*  350519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  350530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  350533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  350536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350558 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  350561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350578 */     GIR_RootConstrainSelectedInstOperands,
     /*  350579 */     // GIR_Coverage, 21467,
     /*  350579 */     GIR_EraseRootFromParent_Done,
     /*  350580 */   // Label 6407: @350580
     /*  350580 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(350646), // Rule ID 21470 //
     /*  350585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  350588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  350596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  350599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  350602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350624 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  350627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350644 */     GIR_RootConstrainSelectedInstOperands,
     /*  350645 */     // GIR_Coverage, 21470,
     /*  350645 */     GIR_EraseRootFromParent_Done,
     /*  350646 */   // Label 6408: @350646
     /*  350646 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(350712), // Rule ID 21471 //
     /*  350651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  350654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  350662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  350665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  350668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350690 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  350693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350710 */     GIR_RootConstrainSelectedInstOperands,
     /*  350711 */     // GIR_Coverage, 21471,
     /*  350711 */     GIR_EraseRootFromParent_Done,
     /*  350712 */   // Label 6409: @350712
     /*  350712 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(350778), // Rule ID 21474 //
     /*  350717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  350720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  350728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  350731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  350734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350756 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  350759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350776 */     GIR_RootConstrainSelectedInstOperands,
     /*  350777 */     // GIR_Coverage, 21474,
     /*  350777 */     GIR_EraseRootFromParent_Done,
     /*  350778 */   // Label 6410: @350778
     /*  350778 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(350844), // Rule ID 21475 //
     /*  350783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  350786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  350794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  350797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  350800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350822 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  350825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350842 */     GIR_RootConstrainSelectedInstOperands,
     /*  350843 */     // GIR_Coverage, 21475,
     /*  350843 */     GIR_EraseRootFromParent_Done,
     /*  350844 */   // Label 6411: @350844
     /*  350844 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(350910), // Rule ID 21478 //
     /*  350849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  350852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  350860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  350863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  350866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350888 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  350891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350908 */     GIR_RootConstrainSelectedInstOperands,
     /*  350909 */     // GIR_Coverage, 21478,
     /*  350909 */     GIR_EraseRootFromParent_Done,
     /*  350910 */   // Label 6412: @350910
     /*  350910 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(350976), // Rule ID 21479 //
     /*  350915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  350918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  350926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  350929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  350932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350954 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  350957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350974 */     GIR_RootConstrainSelectedInstOperands,
     /*  350975 */     // GIR_Coverage, 21479,
     /*  350975 */     GIR_EraseRootFromParent_Done,
     /*  350976 */   // Label 6413: @350976
     /*  350976 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(351042), // Rule ID 21482 //
     /*  350981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  350984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  350992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  350995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  350998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351020 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  351023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351040 */     GIR_RootConstrainSelectedInstOperands,
     /*  351041 */     // GIR_Coverage, 21482,
     /*  351041 */     GIR_EraseRootFromParent_Done,
     /*  351042 */   // Label 6414: @351042
     /*  351042 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(351108), // Rule ID 21483 //
     /*  351047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  351050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  351058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  351061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  351064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351086 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  351089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351106 */     GIR_RootConstrainSelectedInstOperands,
     /*  351107 */     // GIR_Coverage, 21483,
     /*  351107 */     GIR_EraseRootFromParent_Done,
     /*  351108 */   // Label 6415: @351108
     /*  351108 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(351174), // Rule ID 21726 //
     /*  351113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  351124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  351127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  351130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351152 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  351155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351172 */     GIR_RootConstrainSelectedInstOperands,
     /*  351173 */     // GIR_Coverage, 21726,
     /*  351173 */     GIR_EraseRootFromParent_Done,
     /*  351174 */   // Label 6416: @351174
     /*  351174 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(351240), // Rule ID 21727 //
     /*  351179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  351190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  351193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  351196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351218 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  351221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351238 */     GIR_RootConstrainSelectedInstOperands,
     /*  351239 */     // GIR_Coverage, 21727,
     /*  351239 */     GIR_EraseRootFromParent_Done,
     /*  351240 */   // Label 6417: @351240
     /*  351240 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(351306), // Rule ID 21730 //
     /*  351245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  351256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  351259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  351262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351284 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  351287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351304 */     GIR_RootConstrainSelectedInstOperands,
     /*  351305 */     // GIR_Coverage, 21730,
     /*  351305 */     GIR_EraseRootFromParent_Done,
     /*  351306 */   // Label 6418: @351306
     /*  351306 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(351372), // Rule ID 21731 //
     /*  351311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  351322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  351325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  351328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351350 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  351353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351370 */     GIR_RootConstrainSelectedInstOperands,
     /*  351371 */     // GIR_Coverage, 21731,
     /*  351371 */     GIR_EraseRootFromParent_Done,
     /*  351372 */   // Label 6419: @351372
     /*  351372 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(351438), // Rule ID 21734 //
     /*  351377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  351388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  351391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  351394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351416 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  351419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351436 */     GIR_RootConstrainSelectedInstOperands,
     /*  351437 */     // GIR_Coverage, 21734,
     /*  351437 */     GIR_EraseRootFromParent_Done,
     /*  351438 */   // Label 6420: @351438
     /*  351438 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(351504), // Rule ID 21735 //
     /*  351443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  351454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  351457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  351460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351482 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  351485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351502 */     GIR_RootConstrainSelectedInstOperands,
     /*  351503 */     // GIR_Coverage, 21735,
     /*  351503 */     GIR_EraseRootFromParent_Done,
     /*  351504 */   // Label 6421: @351504
     /*  351504 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(351570), // Rule ID 21738 //
     /*  351509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  351520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  351523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  351526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351548 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11247:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  351551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351568 */     GIR_RootConstrainSelectedInstOperands,
     /*  351569 */     // GIR_Coverage, 21738,
     /*  351569 */     GIR_EraseRootFromParent_Done,
     /*  351570 */   // Label 6422: @351570
     /*  351570 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(351636), // Rule ID 21739 //
     /*  351575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  351586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  351589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  351592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351614 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11247:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  351617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351634 */     GIR_RootConstrainSelectedInstOperands,
     /*  351635 */     // GIR_Coverage, 21739,
     /*  351635 */     GIR_EraseRootFromParent_Done,
     /*  351636 */   // Label 6423: @351636
     /*  351636 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(351702), // Rule ID 21742 //
     /*  351641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  351652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  351655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  351658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351680 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  351683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351700 */     GIR_RootConstrainSelectedInstOperands,
     /*  351701 */     // GIR_Coverage, 21742,
     /*  351701 */     GIR_EraseRootFromParent_Done,
     /*  351702 */   // Label 6424: @351702
     /*  351702 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(351768), // Rule ID 21743 //
     /*  351707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  351718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  351721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  351724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351746 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  351749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351766 */     GIR_RootConstrainSelectedInstOperands,
     /*  351767 */     // GIR_Coverage, 21743,
     /*  351767 */     GIR_EraseRootFromParent_Done,
     /*  351768 */   // Label 6425: @351768
     /*  351768 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(351834), // Rule ID 21746 //
     /*  351773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  351784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  351787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  351790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351812 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  351815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351832 */     GIR_RootConstrainSelectedInstOperands,
     /*  351833 */     // GIR_Coverage, 21746,
     /*  351833 */     GIR_EraseRootFromParent_Done,
     /*  351834 */   // Label 6426: @351834
     /*  351834 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(351900), // Rule ID 21747 //
     /*  351839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  351850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  351853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  351856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351878 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  351881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351898 */     GIR_RootConstrainSelectedInstOperands,
     /*  351899 */     // GIR_Coverage, 21747,
     /*  351899 */     GIR_EraseRootFromParent_Done,
     /*  351900 */   // Label 6427: @351900
     /*  351900 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(351966), // Rule ID 21750 //
     /*  351905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  351908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  351916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  351919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351944 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  351944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  351947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351964 */     GIR_RootConstrainSelectedInstOperands,
     /*  351965 */     // GIR_Coverage, 21750,
     /*  351965 */     GIR_EraseRootFromParent_Done,
     /*  351966 */   // Label 6428: @351966
     /*  351966 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(352032), // Rule ID 21751 //
     /*  351971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  351974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  351982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  351985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352010 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  352013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352030 */     GIR_RootConstrainSelectedInstOperands,
     /*  352031 */     // GIR_Coverage, 21751,
     /*  352031 */     GIR_EraseRootFromParent_Done,
     /*  352032 */   // Label 6429: @352032
     /*  352032 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(352098), // Rule ID 21754 //
     /*  352037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  352048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  352051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  352054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352076 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352096 */     GIR_RootConstrainSelectedInstOperands,
     /*  352097 */     // GIR_Coverage, 21754,
     /*  352097 */     GIR_EraseRootFromParent_Done,
     /*  352098 */   // Label 6430: @352098
     /*  352098 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(352164), // Rule ID 21755 //
     /*  352103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  352114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  352117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  352120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352142 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352162 */     GIR_RootConstrainSelectedInstOperands,
     /*  352163 */     // GIR_Coverage, 21755,
     /*  352163 */     GIR_EraseRootFromParent_Done,
     /*  352164 */   // Label 6431: @352164
     /*  352164 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(352230), // Rule ID 21758 //
     /*  352169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  352186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352208 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352228 */     GIR_RootConstrainSelectedInstOperands,
     /*  352229 */     // GIR_Coverage, 21758,
     /*  352229 */     GIR_EraseRootFromParent_Done,
     /*  352230 */   // Label 6432: @352230
     /*  352230 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(352296), // Rule ID 21759 //
     /*  352235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  352252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352274 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352294 */     GIR_RootConstrainSelectedInstOperands,
     /*  352295 */     // GIR_Coverage, 21759,
     /*  352295 */     GIR_EraseRootFromParent_Done,
     /*  352296 */   // Label 6433: @352296
     /*  352296 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(352362), // Rule ID 21762 //
     /*  352301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  352312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  352315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  352318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352360 */     GIR_RootConstrainSelectedInstOperands,
     /*  352361 */     // GIR_Coverage, 21762,
     /*  352361 */     GIR_EraseRootFromParent_Done,
     /*  352362 */   // Label 6434: @352362
     /*  352362 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(352428), // Rule ID 21763 //
     /*  352367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  352378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  352381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  352384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352406 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352426 */     GIR_RootConstrainSelectedInstOperands,
     /*  352427 */     // GIR_Coverage, 21763,
     /*  352427 */     GIR_EraseRootFromParent_Done,
     /*  352428 */   // Label 6435: @352428
     /*  352428 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(352494), // Rule ID 21766 //
     /*  352433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  352444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  352447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  352450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352472 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352492 */     GIR_RootConstrainSelectedInstOperands,
     /*  352493 */     // GIR_Coverage, 21766,
     /*  352493 */     GIR_EraseRootFromParent_Done,
     /*  352494 */   // Label 6436: @352494
     /*  352494 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(352560), // Rule ID 21767 //
     /*  352499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  352510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  352513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  352516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352538 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352558 */     GIR_RootConstrainSelectedInstOperands,
     /*  352559 */     // GIR_Coverage, 21767,
     /*  352559 */     GIR_EraseRootFromParent_Done,
     /*  352560 */   // Label 6437: @352560
     /*  352560 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(352626), // Rule ID 21770 //
     /*  352565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  352568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  352576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  352579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  352582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352604 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  352604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352624 */     GIR_RootConstrainSelectedInstOperands,
     /*  352625 */     // GIR_Coverage, 21770,
     /*  352625 */     GIR_EraseRootFromParent_Done,
     /*  352626 */   // Label 6438: @352626
     /*  352626 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(352692), // Rule ID 21771 //
     /*  352631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  352634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  352642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  352645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  352648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352670 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  352670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352690 */     GIR_RootConstrainSelectedInstOperands,
     /*  352691 */     // GIR_Coverage, 21771,
     /*  352691 */     GIR_EraseRootFromParent_Done,
     /*  352692 */   // Label 6439: @352692
     /*  352692 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(352758), // Rule ID 21774 //
     /*  352697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  352700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  352708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  352711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  352714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  352736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352756 */     GIR_RootConstrainSelectedInstOperands,
     /*  352757 */     // GIR_Coverage, 21774,
     /*  352757 */     GIR_EraseRootFromParent_Done,
     /*  352758 */   // Label 6440: @352758
     /*  352758 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(352824), // Rule ID 21775 //
     /*  352763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  352766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  352774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  352777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  352780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  352802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352822 */     GIR_RootConstrainSelectedInstOperands,
     /*  352823 */     // GIR_Coverage, 21775,
     /*  352823 */     GIR_EraseRootFromParent_Done,
     /*  352824 */   // Label 6441: @352824
     /*  352824 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(352890), // Rule ID 21778 //
     /*  352829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  352832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  352840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  352843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  352846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  352868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352888 */     GIR_RootConstrainSelectedInstOperands,
     /*  352889 */     // GIR_Coverage, 21778,
     /*  352889 */     GIR_EraseRootFromParent_Done,
     /*  352890 */   // Label 6442: @352890
     /*  352890 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(352956), // Rule ID 21779 //
     /*  352895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  352898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  352906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  352909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  352912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  352934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352954 */     GIR_RootConstrainSelectedInstOperands,
     /*  352955 */     // GIR_Coverage, 21779,
     /*  352955 */     GIR_EraseRootFromParent_Done,
     /*  352956 */   // Label 6443: @352956
     /*  352956 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(353022), // Rule ID 21782 //
     /*  352961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  352964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  352972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  352975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  352978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353000 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  353003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353020 */     GIR_RootConstrainSelectedInstOperands,
     /*  353021 */     // GIR_Coverage, 21782,
     /*  353021 */     GIR_EraseRootFromParent_Done,
     /*  353022 */   // Label 6444: @353022
     /*  353022 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(353088), // Rule ID 21783 //
     /*  353027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  353038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  353041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  353044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353066 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  353069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353086 */     GIR_RootConstrainSelectedInstOperands,
     /*  353087 */     // GIR_Coverage, 21783,
     /*  353087 */     GIR_EraseRootFromParent_Done,
     /*  353088 */   // Label 6445: @353088
     /*  353088 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(353154), // Rule ID 21786 //
     /*  353093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  353104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  353107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  353110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353132 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  353135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353152 */     GIR_RootConstrainSelectedInstOperands,
     /*  353153 */     // GIR_Coverage, 21786,
     /*  353153 */     GIR_EraseRootFromParent_Done,
     /*  353154 */   // Label 6446: @353154
     /*  353154 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(353220), // Rule ID 21787 //
     /*  353159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  353170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  353173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  353176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353198 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  353201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353218 */     GIR_RootConstrainSelectedInstOperands,
     /*  353219 */     // GIR_Coverage, 21787,
     /*  353219 */     GIR_EraseRootFromParent_Done,
     /*  353220 */   // Label 6447: @353220
     /*  353220 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(353286), // Rule ID 21790 //
     /*  353225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  353236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  353239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  353242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353264 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353284 */     GIR_RootConstrainSelectedInstOperands,
     /*  353285 */     // GIR_Coverage, 21790,
     /*  353285 */     GIR_EraseRootFromParent_Done,
     /*  353286 */   // Label 6448: @353286
     /*  353286 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(353352), // Rule ID 21791 //
     /*  353291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  353302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  353305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  353308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353330 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353350 */     GIR_RootConstrainSelectedInstOperands,
     /*  353351 */     // GIR_Coverage, 21791,
     /*  353351 */     GIR_EraseRootFromParent_Done,
     /*  353352 */   // Label 6449: @353352
     /*  353352 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(353418), // Rule ID 21794 //
     /*  353357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  353368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  353371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  353374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  353399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353416 */     GIR_RootConstrainSelectedInstOperands,
     /*  353417 */     // GIR_Coverage, 21794,
     /*  353417 */     GIR_EraseRootFromParent_Done,
     /*  353418 */   // Label 6450: @353418
     /*  353418 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(353484), // Rule ID 21795 //
     /*  353423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  353434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  353437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  353440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353462 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  353465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353482 */     GIR_RootConstrainSelectedInstOperands,
     /*  353483 */     // GIR_Coverage, 21795,
     /*  353483 */     GIR_EraseRootFromParent_Done,
     /*  353484 */   // Label 6451: @353484
     /*  353484 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(353550), // Rule ID 21798 //
     /*  353489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  353500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  353503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  353506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353528 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  353531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353548 */     GIR_RootConstrainSelectedInstOperands,
     /*  353549 */     // GIR_Coverage, 21798,
     /*  353549 */     GIR_EraseRootFromParent_Done,
     /*  353550 */   // Label 6452: @353550
     /*  353550 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(353616), // Rule ID 21799 //
     /*  353555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  353566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  353569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  353572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353594 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  353597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353614 */     GIR_RootConstrainSelectedInstOperands,
     /*  353615 */     // GIR_Coverage, 21799,
     /*  353615 */     GIR_EraseRootFromParent_Done,
     /*  353616 */   // Label 6453: @353616
     /*  353616 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(353682), // Rule ID 21802 //
     /*  353621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  353632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  353635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  353638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353660 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  353663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353680 */     GIR_RootConstrainSelectedInstOperands,
     /*  353681 */     // GIR_Coverage, 21802,
     /*  353681 */     GIR_EraseRootFromParent_Done,
     /*  353682 */   // Label 6454: @353682
     /*  353682 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(353748), // Rule ID 21803 //
     /*  353687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  353698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  353701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  353704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353726 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  353729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353746 */     GIR_RootConstrainSelectedInstOperands,
     /*  353747 */     // GIR_Coverage, 21803,
     /*  353747 */     GIR_EraseRootFromParent_Done,
     /*  353748 */   // Label 6455: @353748
     /*  353748 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(353814), // Rule ID 21806 //
     /*  353753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  353764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  353767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  353770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353792 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  353795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353812 */     GIR_RootConstrainSelectedInstOperands,
     /*  353813 */     // GIR_Coverage, 21806,
     /*  353813 */     GIR_EraseRootFromParent_Done,
     /*  353814 */   // Label 6456: @353814
     /*  353814 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(353880), // Rule ID 21807 //
     /*  353819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  353830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  353833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  353836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353858 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  353861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353878 */     GIR_RootConstrainSelectedInstOperands,
     /*  353879 */     // GIR_Coverage, 21807,
     /*  353879 */     GIR_EraseRootFromParent_Done,
     /*  353880 */   // Label 6457: @353880
     /*  353880 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(353946), // Rule ID 21810 //
     /*  353885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  353888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  353896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  353899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  353902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353924 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353944 */     GIR_RootConstrainSelectedInstOperands,
     /*  353945 */     // GIR_Coverage, 21810,
     /*  353945 */     GIR_EraseRootFromParent_Done,
     /*  353946 */   // Label 6458: @353946
     /*  353946 */   GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(354012), // Rule ID 21811 //
     /*  353951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  353954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  353962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  353965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  353968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353990 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354010 */     GIR_RootConstrainSelectedInstOperands,
     /*  354011 */     // GIR_Coverage, 21811,
     /*  354011 */     GIR_EraseRootFromParent_Done,
     /*  354012 */   // Label 6459: @354012
     /*  354012 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(354078), // Rule ID 21814 //
     /*  354017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  354028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  354031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354056 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354076 */     GIR_RootConstrainSelectedInstOperands,
     /*  354077 */     // GIR_Coverage, 21814,
     /*  354077 */     GIR_EraseRootFromParent_Done,
     /*  354078 */   // Label 6460: @354078
     /*  354078 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(354144), // Rule ID 21815 //
     /*  354083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  354094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  354097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354122 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354142 */     GIR_RootConstrainSelectedInstOperands,
     /*  354143 */     // GIR_Coverage, 21815,
     /*  354143 */     GIR_EraseRootFromParent_Done,
     /*  354144 */   // Label 6461: @354144
     /*  354144 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(354210), // Rule ID 21818 //
     /*  354149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  354160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  354163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354188 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354208 */     GIR_RootConstrainSelectedInstOperands,
     /*  354209 */     // GIR_Coverage, 21818,
     /*  354209 */     GIR_EraseRootFromParent_Done,
     /*  354210 */   // Label 6462: @354210
     /*  354210 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(354276), // Rule ID 21819 //
     /*  354215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  354226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  354229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354254 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354274 */     GIR_RootConstrainSelectedInstOperands,
     /*  354275 */     // GIR_Coverage, 21819,
     /*  354275 */     GIR_EraseRootFromParent_Done,
     /*  354276 */   // Label 6463: @354276
     /*  354276 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(354342), // Rule ID 21822 //
     /*  354281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  354292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  354295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  354298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354320 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354340 */     GIR_RootConstrainSelectedInstOperands,
     /*  354341 */     // GIR_Coverage, 21822,
     /*  354341 */     GIR_EraseRootFromParent_Done,
     /*  354342 */   // Label 6464: @354342
     /*  354342 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(354408), // Rule ID 21823 //
     /*  354347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  354358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  354361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  354364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354386 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354406 */     GIR_RootConstrainSelectedInstOperands,
     /*  354407 */     // GIR_Coverage, 21823,
     /*  354407 */     GIR_EraseRootFromParent_Done,
     /*  354408 */   // Label 6465: @354408
     /*  354408 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(354474), // Rule ID 21826 //
     /*  354413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  354424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  354427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  354430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354452 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354472 */     GIR_RootConstrainSelectedInstOperands,
     /*  354473 */     // GIR_Coverage, 21826,
     /*  354473 */     GIR_EraseRootFromParent_Done,
     /*  354474 */   // Label 6466: @354474
     /*  354474 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(354540), // Rule ID 21827 //
     /*  354479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  354490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  354493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  354496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354518 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354538 */     GIR_RootConstrainSelectedInstOperands,
     /*  354539 */     // GIR_Coverage, 21827,
     /*  354539 */     GIR_EraseRootFromParent_Done,
     /*  354540 */   // Label 6467: @354540
     /*  354540 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(354606), // Rule ID 21830 //
     /*  354545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  354548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  354556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  354559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  354562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354584 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354604 */     GIR_RootConstrainSelectedInstOperands,
     /*  354605 */     // GIR_Coverage, 21830,
     /*  354605 */     GIR_EraseRootFromParent_Done,
     /*  354606 */   // Label 6468: @354606
     /*  354606 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(354672), // Rule ID 21831 //
     /*  354611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  354614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  354622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  354625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  354628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354650 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354670 */     GIR_RootConstrainSelectedInstOperands,
     /*  354671 */     // GIR_Coverage, 21831,
     /*  354671 */     GIR_EraseRootFromParent_Done,
     /*  354672 */   // Label 6469: @354672
     /*  354672 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(354738), // Rule ID 21834 //
     /*  354677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  354680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  354688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  354691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  354694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354716 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354736 */     GIR_RootConstrainSelectedInstOperands,
     /*  354737 */     // GIR_Coverage, 21834,
     /*  354737 */     GIR_EraseRootFromParent_Done,
     /*  354738 */   // Label 6470: @354738
     /*  354738 */   GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(354804), // Rule ID 21835 //
     /*  354743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  354746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  354754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  354757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  354760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354782 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354802 */     GIR_RootConstrainSelectedInstOperands,
     /*  354803 */     // GIR_Coverage, 21835,
     /*  354803 */     GIR_EraseRootFromParent_Done,
     /*  354804 */   // Label 6471: @354804
     /*  354804 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(354870), // Rule ID 21838 //
     /*  354809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  354812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  354820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  354823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  354826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354868 */     GIR_RootConstrainSelectedInstOperands,
     /*  354869 */     // GIR_Coverage, 21838,
     /*  354869 */     GIR_EraseRootFromParent_Done,
     /*  354870 */   // Label 6472: @354870
     /*  354870 */   GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(354936), // Rule ID 21839 //
     /*  354875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  354878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  354886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  354889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  354892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354914 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354934 */     GIR_RootConstrainSelectedInstOperands,
     /*  354935 */     // GIR_Coverage, 21839,
     /*  354935 */     GIR_EraseRootFromParent_Done,
     /*  354936 */   // Label 6473: @354936
     /*  354936 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(355002), // Rule ID 21842 //
     /*  354941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  354944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  354952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  354955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  354958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355000 */     GIR_RootConstrainSelectedInstOperands,
     /*  355001 */     // GIR_Coverage, 21842,
     /*  355001 */     GIR_EraseRootFromParent_Done,
     /*  355002 */   // Label 6474: @355002
     /*  355002 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(355068), // Rule ID 21843 //
     /*  355007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  355010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  355018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  355021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  355024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  355049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355066 */     GIR_RootConstrainSelectedInstOperands,
     /*  355067 */     // GIR_Coverage, 21843,
     /*  355067 */     GIR_EraseRootFromParent_Done,
     /*  355068 */   // Label 6475: @355068
     /*  355068 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(355134), // Rule ID 21954 //
     /*  355073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355112 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  355115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355132 */     GIR_RootConstrainSelectedInstOperands,
     /*  355133 */     // GIR_Coverage, 21954,
     /*  355133 */     GIR_EraseRootFromParent_Done,
     /*  355134 */   // Label 6476: @355134
     /*  355134 */   GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(355200), // Rule ID 21955 //
     /*  355139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355178 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  355181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355198 */     GIR_RootConstrainSelectedInstOperands,
     /*  355199 */     // GIR_Coverage, 21955,
     /*  355199 */     GIR_EraseRootFromParent_Done,
     /*  355200 */   // Label 6477: @355200
     /*  355200 */   GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(355266), // Rule ID 21958 //
     /*  355205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  355222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355244 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  355247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355264 */     GIR_RootConstrainSelectedInstOperands,
     /*  355265 */     // GIR_Coverage, 21958,
     /*  355265 */     GIR_EraseRootFromParent_Done,
     /*  355266 */   // Label 6478: @355266
     /*  355266 */   GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(355332), // Rule ID 21959 //
     /*  355271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  355288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355310 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  355313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355330 */     GIR_RootConstrainSelectedInstOperands,
     /*  355331 */     // GIR_Coverage, 21959,
     /*  355331 */     GIR_EraseRootFromParent_Done,
     /*  355332 */   // Label 6479: @355332
     /*  355332 */   GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(355398), // Rule ID 21962 //
     /*  355337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  355348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  355351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  355354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355376 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  355379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355396 */     GIR_RootConstrainSelectedInstOperands,
     /*  355397 */     // GIR_Coverage, 21962,
     /*  355397 */     GIR_EraseRootFromParent_Done,
     /*  355398 */   // Label 6480: @355398
     /*  355398 */   GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(355464), // Rule ID 21963 //
     /*  355403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  355414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  355417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  355420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355442 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  355445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355462 */     GIR_RootConstrainSelectedInstOperands,
     /*  355463 */     // GIR_Coverage, 21963,
     /*  355463 */     GIR_EraseRootFromParent_Done,
     /*  355464 */   // Label 6481: @355464
     /*  355464 */   GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(355530), // Rule ID 21966 //
     /*  355469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  355480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  355483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  355486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355508 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  355511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355528 */     GIR_RootConstrainSelectedInstOperands,
     /*  355529 */     // GIR_Coverage, 21966,
     /*  355529 */     GIR_EraseRootFromParent_Done,
     /*  355530 */   // Label 6482: @355530
     /*  355530 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(355596), // Rule ID 21967 //
     /*  355535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  355546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  355549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  355552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355574 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  355577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355594 */     GIR_RootConstrainSelectedInstOperands,
     /*  355595 */     // GIR_Coverage, 21967,
     /*  355595 */     GIR_EraseRootFromParent_Done,
     /*  355596 */   // Label 6483: @355596
     /*  355596 */   GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(355662), // Rule ID 21970 //
     /*  355601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  355612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  355615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  355618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355640 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  355643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355660 */     GIR_RootConstrainSelectedInstOperands,
     /*  355661 */     // GIR_Coverage, 21970,
     /*  355661 */     GIR_EraseRootFromParent_Done,
     /*  355662 */   // Label 6484: @355662
     /*  355662 */   GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(355728), // Rule ID 21971 //
     /*  355667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  355678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  355681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  355684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355706 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  355709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355726 */     GIR_RootConstrainSelectedInstOperands,
     /*  355727 */     // GIR_Coverage, 21971,
     /*  355727 */     GIR_EraseRootFromParent_Done,
     /*  355728 */   // Label 6485: @355728
     /*  355728 */   GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(355794), // Rule ID 21974 //
     /*  355733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  355736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  355744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  355747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  355750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355772 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  355775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355792 */     GIR_RootConstrainSelectedInstOperands,
     /*  355793 */     // GIR_Coverage, 21974,
     /*  355793 */     GIR_EraseRootFromParent_Done,
     /*  355794 */   // Label 6486: @355794
     /*  355794 */   GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(355860), // Rule ID 21975 //
     /*  355799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  355802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  355810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  355813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  355816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355838 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  355841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355858 */     GIR_RootConstrainSelectedInstOperands,
     /*  355859 */     // GIR_Coverage, 21975,
     /*  355859 */     GIR_EraseRootFromParent_Done,
     /*  355860 */   // Label 6487: @355860
     /*  355860 */   GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(355926), // Rule ID 21978 //
     /*  355865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  355868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  355876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  355879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  355882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355904 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  355907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355924 */     GIR_RootConstrainSelectedInstOperands,
     /*  355925 */     // GIR_Coverage, 21978,
     /*  355925 */     GIR_EraseRootFromParent_Done,
     /*  355926 */   // Label 6488: @355926
     /*  355926 */   GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(355992), // Rule ID 21979 //
     /*  355931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  355934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  355942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  355945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  355948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355970 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  355973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355990 */     GIR_RootConstrainSelectedInstOperands,
     /*  355991 */     // GIR_Coverage, 21979,
     /*  355991 */     GIR_EraseRootFromParent_Done,
     /*  355992 */   // Label 6489: @355992
     /*  355992 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(356058), // Rule ID 21982 //
     /*  355997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  356000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  356008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  356011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  356014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356036 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  356039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356056 */     GIR_RootConstrainSelectedInstOperands,
     /*  356057 */     // GIR_Coverage, 21982,
     /*  356057 */     GIR_EraseRootFromParent_Done,
     /*  356058 */   // Label 6490: @356058
     /*  356058 */   GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(356124), // Rule ID 21983 //
     /*  356063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  356066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  356074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  356077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  356080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356102 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  356105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356122 */     GIR_RootConstrainSelectedInstOperands,
     /*  356123 */     // GIR_Coverage, 21983,
     /*  356123 */     GIR_EraseRootFromParent_Done,
     /*  356124 */   // Label 6491: @356124
     /*  356124 */   GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(356190), // Rule ID 21986 //
     /*  356129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  356132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  356140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  356143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  356146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356168 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  356171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356188 */     GIR_RootConstrainSelectedInstOperands,
     /*  356189 */     // GIR_Coverage, 21986,
     /*  356189 */     GIR_EraseRootFromParent_Done,
     /*  356190 */   // Label 6492: @356190
     /*  356190 */   GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(356256), // Rule ID 21987 //
     /*  356195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  356198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  356206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  356209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  356212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356234 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  356237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356254 */     GIR_RootConstrainSelectedInstOperands,
     /*  356255 */     // GIR_Coverage, 21987,
     /*  356255 */     GIR_EraseRootFromParent_Done,
     /*  356256 */   // Label 6493: @356256
     /*  356256 */   GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(356319), // Rule ID 23158 //
     /*  356261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  356272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  356275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  356278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356300 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  356303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356317 */     GIR_RootConstrainSelectedInstOperands,
     /*  356318 */     // GIR_Coverage, 23158,
     /*  356318 */     GIR_EraseRootFromParent_Done,
     /*  356319 */   // Label 6494: @356319
     /*  356319 */   GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(356382), // Rule ID 23159 //
     /*  356324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  356335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  356338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  356341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356363 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  356366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356380 */     GIR_RootConstrainSelectedInstOperands,
     /*  356381 */     // GIR_Coverage, 23159,
     /*  356381 */     GIR_EraseRootFromParent_Done,
     /*  356382 */   // Label 6495: @356382
     /*  356382 */   GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(356445), // Rule ID 23160 //
     /*  356387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  356398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  356401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  356404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356426 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  356429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356443 */     GIR_RootConstrainSelectedInstOperands,
     /*  356444 */     // GIR_Coverage, 23160,
     /*  356444 */     GIR_EraseRootFromParent_Done,
     /*  356445 */   // Label 6496: @356445
     /*  356445 */   GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(356508), // Rule ID 23161 //
     /*  356450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  356461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  356464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  356467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356489 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  356492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356506 */     GIR_RootConstrainSelectedInstOperands,
     /*  356507 */     // GIR_Coverage, 23161,
     /*  356507 */     GIR_EraseRootFromParent_Done,
     /*  356508 */   // Label 6497: @356508
     /*  356508 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(356571), // Rule ID 23162 //
     /*  356513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  356524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  356527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  356530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356552 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  356555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356569 */     GIR_RootConstrainSelectedInstOperands,
     /*  356570 */     // GIR_Coverage, 23162,
     /*  356570 */     GIR_EraseRootFromParent_Done,
     /*  356571 */   // Label 6498: @356571
     /*  356571 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(356634), // Rule ID 23163 //
     /*  356576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  356587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  356590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  356593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356615 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  356618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356632 */     GIR_RootConstrainSelectedInstOperands,
     /*  356633 */     // GIR_Coverage, 23163,
     /*  356633 */     GIR_EraseRootFromParent_Done,
     /*  356634 */   // Label 6499: @356634
     /*  356634 */   GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(356697), // Rule ID 23164 //
     /*  356639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  356650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  356653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  356656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356678 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  356681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356695 */     GIR_RootConstrainSelectedInstOperands,
     /*  356696 */     // GIR_Coverage, 23164,
     /*  356696 */     GIR_EraseRootFromParent_Done,
     /*  356697 */   // Label 6500: @356697
     /*  356697 */   GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(356760), // Rule ID 23165 //
     /*  356702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  356713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  356716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  356719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356741 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  356744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356758 */     GIR_RootConstrainSelectedInstOperands,
     /*  356759 */     // GIR_Coverage, 23165,
     /*  356759 */     GIR_EraseRootFromParent_Done,
     /*  356760 */   // Label 6501: @356760
     /*  356760 */   GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(356823), // Rule ID 23166 //
     /*  356765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  356776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  356779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  356782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356804 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  356807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356821 */     GIR_RootConstrainSelectedInstOperands,
     /*  356822 */     // GIR_Coverage, 23166,
     /*  356822 */     GIR_EraseRootFromParent_Done,
     /*  356823 */   // Label 6502: @356823
     /*  356823 */   GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(356886), // Rule ID 23167 //
     /*  356828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  356839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  356842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  356845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356867 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  356870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356884 */     GIR_RootConstrainSelectedInstOperands,
     /*  356885 */     // GIR_Coverage, 23167,
     /*  356885 */     GIR_EraseRootFromParent_Done,
     /*  356886 */   // Label 6503: @356886
     /*  356886 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(356949), // Rule ID 23168 //
     /*  356891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  356902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  356905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  356908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356930 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  356933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356947 */     GIR_RootConstrainSelectedInstOperands,
     /*  356948 */     // GIR_Coverage, 23168,
     /*  356948 */     GIR_EraseRootFromParent_Done,
     /*  356949 */   // Label 6504: @356949
     /*  356949 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(357012), // Rule ID 23169 //
     /*  356954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  356965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  356968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  356971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356993 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  356996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357010 */     GIR_RootConstrainSelectedInstOperands,
     /*  357011 */     // GIR_Coverage, 23169,
     /*  357011 */     GIR_EraseRootFromParent_Done,
     /*  357012 */   // Label 6505: @357012
     /*  357012 */   GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(357075), // Rule ID 23170 //
     /*  357017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357056 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  357059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357073 */     GIR_RootConstrainSelectedInstOperands,
     /*  357074 */     // GIR_Coverage, 23170,
     /*  357074 */     GIR_EraseRootFromParent_Done,
     /*  357075 */   // Label 6506: @357075
     /*  357075 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(357138), // Rule ID 23171 //
     /*  357080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357119 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  357122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357136 */     GIR_RootConstrainSelectedInstOperands,
     /*  357137 */     // GIR_Coverage, 23171,
     /*  357137 */     GIR_EraseRootFromParent_Done,
     /*  357138 */   // Label 6507: @357138
     /*  357138 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(357201), // Rule ID 23172 //
     /*  357143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  357154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  357157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  357160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357182 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  357185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357199 */     GIR_RootConstrainSelectedInstOperands,
     /*  357200 */     // GIR_Coverage, 23172,
     /*  357200 */     GIR_EraseRootFromParent_Done,
     /*  357201 */   // Label 6508: @357201
     /*  357201 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(357264), // Rule ID 23173 //
     /*  357206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  357217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  357220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  357223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357245 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  357248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357262 */     GIR_RootConstrainSelectedInstOperands,
     /*  357263 */     // GIR_Coverage, 23173,
     /*  357263 */     GIR_EraseRootFromParent_Done,
     /*  357264 */   // Label 6509: @357264
     /*  357264 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(357327), // Rule ID 23174 //
     /*  357269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  357280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  357283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  357286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357308 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  357311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357325 */     GIR_RootConstrainSelectedInstOperands,
     /*  357326 */     // GIR_Coverage, 23174,
     /*  357326 */     GIR_EraseRootFromParent_Done,
     /*  357327 */   // Label 6510: @357327
     /*  357327 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(357390), // Rule ID 23175 //
     /*  357332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  357343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  357346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  357349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357371 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  357374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357388 */     GIR_RootConstrainSelectedInstOperands,
     /*  357389 */     // GIR_Coverage, 23175,
     /*  357389 */     GIR_EraseRootFromParent_Done,
     /*  357390 */   // Label 6511: @357390
     /*  357390 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(357453), // Rule ID 23176 //
     /*  357395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  357406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  357409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  357412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357434 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  357437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357451 */     GIR_RootConstrainSelectedInstOperands,
     /*  357452 */     // GIR_Coverage, 23176,
     /*  357452 */     GIR_EraseRootFromParent_Done,
     /*  357453 */   // Label 6512: @357453
     /*  357453 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(357516), // Rule ID 23177 //
     /*  357458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  357469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  357472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  357475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357497 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  357500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357514 */     GIR_RootConstrainSelectedInstOperands,
     /*  357515 */     // GIR_Coverage, 23177,
     /*  357515 */     GIR_EraseRootFromParent_Done,
     /*  357516 */   // Label 6513: @357516
     /*  357516 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(357579), // Rule ID 23178 //
     /*  357521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  357538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357560 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  357563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357577 */     GIR_RootConstrainSelectedInstOperands,
     /*  357578 */     // GIR_Coverage, 23178,
     /*  357578 */     GIR_EraseRootFromParent_Done,
     /*  357579 */   // Label 6514: @357579
     /*  357579 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(357642), // Rule ID 23179 //
     /*  357584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  357601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357623 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  357626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357640 */     GIR_RootConstrainSelectedInstOperands,
     /*  357641 */     // GIR_Coverage, 23179,
     /*  357641 */     GIR_EraseRootFromParent_Done,
     /*  357642 */   // Label 6515: @357642
     /*  357642 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(357705), // Rule ID 23180 //
     /*  357647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  357658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  357661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  357664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357686 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  357689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357703 */     GIR_RootConstrainSelectedInstOperands,
     /*  357704 */     // GIR_Coverage, 23180,
     /*  357704 */     GIR_EraseRootFromParent_Done,
     /*  357705 */   // Label 6516: @357705
     /*  357705 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(357768), // Rule ID 23181 //
     /*  357710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  357721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  357724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  357727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357749 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  357752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357766 */     GIR_RootConstrainSelectedInstOperands,
     /*  357767 */     // GIR_Coverage, 23181,
     /*  357767 */     GIR_EraseRootFromParent_Done,
     /*  357768 */   // Label 6517: @357768
     /*  357768 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(357831), // Rule ID 23182 //
     /*  357773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  357784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  357787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  357790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357812 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  357815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357829 */     GIR_RootConstrainSelectedInstOperands,
     /*  357830 */     // GIR_Coverage, 23182,
     /*  357830 */     GIR_EraseRootFromParent_Done,
     /*  357831 */   // Label 6518: @357831
     /*  357831 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(357894), // Rule ID 23183 //
     /*  357836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  357847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  357850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  357853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357875 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  357878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357892 */     GIR_RootConstrainSelectedInstOperands,
     /*  357893 */     // GIR_Coverage, 23183,
     /*  357893 */     GIR_EraseRootFromParent_Done,
     /*  357894 */   // Label 6519: @357894
     /*  357894 */   GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(357957), // Rule ID 23184 //
     /*  357899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357938 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  357941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357955 */     GIR_RootConstrainSelectedInstOperands,
     /*  357956 */     // GIR_Coverage, 23184,
     /*  357956 */     GIR_EraseRootFromParent_Done,
     /*  357957 */   // Label 6520: @357957
     /*  357957 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(358020), // Rule ID 23185 //
     /*  357962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358001 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  358004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358018 */     GIR_RootConstrainSelectedInstOperands,
     /*  358019 */     // GIR_Coverage, 23185,
     /*  358019 */     GIR_EraseRootFromParent_Done,
     /*  358020 */   // Label 6521: @358020
     /*  358020 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(358083), // Rule ID 23186 //
     /*  358025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358064 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  358067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358081 */     GIR_RootConstrainSelectedInstOperands,
     /*  358082 */     // GIR_Coverage, 23186,
     /*  358082 */     GIR_EraseRootFromParent_Done,
     /*  358083 */   // Label 6522: @358083
     /*  358083 */   GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(358146), // Rule ID 23187 //
     /*  358088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358127 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  358130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358144 */     GIR_RootConstrainSelectedInstOperands,
     /*  358145 */     // GIR_Coverage, 23187,
     /*  358145 */     GIR_EraseRootFromParent_Done,
     /*  358146 */   // Label 6523: @358146
     /*  358146 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(358209), // Rule ID 23188 //
     /*  358151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  358162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  358165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  358168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358190 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  358193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358207 */     GIR_RootConstrainSelectedInstOperands,
     /*  358208 */     // GIR_Coverage, 23188,
     /*  358208 */     GIR_EraseRootFromParent_Done,
     /*  358209 */   // Label 6524: @358209
     /*  358209 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(358272), // Rule ID 23189 //
     /*  358214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  358225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  358228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  358231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358253 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  358256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358270 */     GIR_RootConstrainSelectedInstOperands,
     /*  358271 */     // GIR_Coverage, 23189,
     /*  358271 */     GIR_EraseRootFromParent_Done,
     /*  358272 */   // Label 6525: @358272
     /*  358272 */   GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(358335), // Rule ID 23190 //
     /*  358277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  358288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  358291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  358294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358316 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  358319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358333 */     GIR_RootConstrainSelectedInstOperands,
     /*  358334 */     // GIR_Coverage, 23190,
     /*  358334 */     GIR_EraseRootFromParent_Done,
     /*  358335 */   // Label 6526: @358335
     /*  358335 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(358398), // Rule ID 23191 //
     /*  358340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  358351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  358354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  358357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358379 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  358382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358396 */     GIR_RootConstrainSelectedInstOperands,
     /*  358397 */     // GIR_Coverage, 23191,
     /*  358397 */     GIR_EraseRootFromParent_Done,
     /*  358398 */   // Label 6527: @358398
     /*  358398 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(358461), // Rule ID 23192 //
     /*  358403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  358414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  358417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  358420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358442 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  358445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358459 */     GIR_RootConstrainSelectedInstOperands,
     /*  358460 */     // GIR_Coverage, 23192,
     /*  358460 */     GIR_EraseRootFromParent_Done,
     /*  358461 */   // Label 6528: @358461
     /*  358461 */   GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(358524), // Rule ID 23193 //
     /*  358466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  358477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  358480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  358483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358505 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  358508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358522 */     GIR_RootConstrainSelectedInstOperands,
     /*  358523 */     // GIR_Coverage, 23193,
     /*  358523 */     GIR_EraseRootFromParent_Done,
     /*  358524 */   // Label 6529: @358524
     /*  358524 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(358587), // Rule ID 23194 //
     /*  358529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  358540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  358543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  358546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358568 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  358571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358585 */     GIR_RootConstrainSelectedInstOperands,
     /*  358586 */     // GIR_Coverage, 23194,
     /*  358586 */     GIR_EraseRootFromParent_Done,
     /*  358587 */   // Label 6530: @358587
     /*  358587 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(358650), // Rule ID 23195 //
     /*  358592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  358603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  358606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  358609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358631 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  358634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358648 */     GIR_RootConstrainSelectedInstOperands,
     /*  358649 */     // GIR_Coverage, 23195,
     /*  358649 */     GIR_EraseRootFromParent_Done,
     /*  358650 */   // Label 6531: @358650
     /*  358650 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(358713), // Rule ID 23196 //
     /*  358655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  358666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  358669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  358672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358694 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  358697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358711 */     GIR_RootConstrainSelectedInstOperands,
     /*  358712 */     // GIR_Coverage, 23196,
     /*  358712 */     GIR_EraseRootFromParent_Done,
     /*  358713 */   // Label 6532: @358713
     /*  358713 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(358776), // Rule ID 23197 //
     /*  358718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  358729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  358732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  358735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358757 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  358760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358774 */     GIR_RootConstrainSelectedInstOperands,
     /*  358775 */     // GIR_Coverage, 23197,
     /*  358775 */     GIR_EraseRootFromParent_Done,
     /*  358776 */   // Label 6533: @358776
     /*  358776 */   GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(358839), // Rule ID 23198 //
     /*  358781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  358792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  358795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  358798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358820 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  358823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358837 */     GIR_RootConstrainSelectedInstOperands,
     /*  358838 */     // GIR_Coverage, 23198,
     /*  358838 */     GIR_EraseRootFromParent_Done,
     /*  358839 */   // Label 6534: @358839
     /*  358839 */   GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(358902), // Rule ID 23199 //
     /*  358844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  358855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  358858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  358861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358883 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  358886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358900 */     GIR_RootConstrainSelectedInstOperands,
     /*  358901 */     // GIR_Coverage, 23199,
     /*  358901 */     GIR_EraseRootFromParent_Done,
     /*  358902 */   // Label 6535: @358902
     /*  358902 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(358965), // Rule ID 23200 //
     /*  358907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358946 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  358949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358963 */     GIR_RootConstrainSelectedInstOperands,
     /*  358964 */     // GIR_Coverage, 23200,
     /*  358964 */     GIR_EraseRootFromParent_Done,
     /*  358965 */   // Label 6536: @358965
     /*  358965 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(359028), // Rule ID 23201 //
     /*  358970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359009 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  359012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359026 */     GIR_RootConstrainSelectedInstOperands,
     /*  359027 */     // GIR_Coverage, 23201,
     /*  359027 */     GIR_EraseRootFromParent_Done,
     /*  359028 */   // Label 6537: @359028
     /*  359028 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(359091), // Rule ID 23202 //
     /*  359033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359072 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  359075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359089 */     GIR_RootConstrainSelectedInstOperands,
     /*  359090 */     // GIR_Coverage, 23202,
     /*  359090 */     GIR_EraseRootFromParent_Done,
     /*  359091 */   // Label 6538: @359091
     /*  359091 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(359154), // Rule ID 23203 //
     /*  359096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359135 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  359138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359152 */     GIR_RootConstrainSelectedInstOperands,
     /*  359153 */     // GIR_Coverage, 23203,
     /*  359153 */     GIR_EraseRootFromParent_Done,
     /*  359154 */   // Label 6539: @359154
     /*  359154 */   GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(359217), // Rule ID 23204 //
     /*  359159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  359170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  359173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  359176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359198 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  359201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359215 */     GIR_RootConstrainSelectedInstOperands,
     /*  359216 */     // GIR_Coverage, 23204,
     /*  359216 */     GIR_EraseRootFromParent_Done,
     /*  359217 */   // Label 6540: @359217
     /*  359217 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(359280), // Rule ID 23205 //
     /*  359222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  359233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  359236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  359239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359261 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  359264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359278 */     GIR_RootConstrainSelectedInstOperands,
     /*  359279 */     // GIR_Coverage, 23205,
     /*  359279 */     GIR_EraseRootFromParent_Done,
     /*  359280 */   // Label 6541: @359280
     /*  359280 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(359343), // Rule ID 23206 //
     /*  359285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  359296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  359299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  359302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359324 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  359327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359341 */     GIR_RootConstrainSelectedInstOperands,
     /*  359342 */     // GIR_Coverage, 23206,
     /*  359342 */     GIR_EraseRootFromParent_Done,
     /*  359343 */   // Label 6542: @359343
     /*  359343 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(359406), // Rule ID 23207 //
     /*  359348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  359359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  359362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  359365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359387 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  359390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359404 */     GIR_RootConstrainSelectedInstOperands,
     /*  359405 */     // GIR_Coverage, 23207,
     /*  359405 */     GIR_EraseRootFromParent_Done,
     /*  359406 */   // Label 6543: @359406
     /*  359406 */   GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(359469), // Rule ID 23208 //
     /*  359411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  359422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  359425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359450 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  359453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359467 */     GIR_RootConstrainSelectedInstOperands,
     /*  359468 */     // GIR_Coverage, 23208,
     /*  359468 */     GIR_EraseRootFromParent_Done,
     /*  359469 */   // Label 6544: @359469
     /*  359469 */   GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(359532), // Rule ID 23209 //
     /*  359474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  359485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  359488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359513 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  359516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359530 */     GIR_RootConstrainSelectedInstOperands,
     /*  359531 */     // GIR_Coverage, 23209,
     /*  359531 */     GIR_EraseRootFromParent_Done,
     /*  359532 */   // Label 6545: @359532
     /*  359532 */   GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(359595), // Rule ID 23210 //
     /*  359537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  359548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  359551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  359554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359576 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  359579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359593 */     GIR_RootConstrainSelectedInstOperands,
     /*  359594 */     // GIR_Coverage, 23210,
     /*  359594 */     GIR_EraseRootFromParent_Done,
     /*  359595 */   // Label 6546: @359595
     /*  359595 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(359658), // Rule ID 23211 //
     /*  359600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  359611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  359614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  359617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359639 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  359642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359656 */     GIR_RootConstrainSelectedInstOperands,
     /*  359657 */     // GIR_Coverage, 23211,
     /*  359657 */     GIR_EraseRootFromParent_Done,
     /*  359658 */   // Label 6547: @359658
     /*  359658 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(359721), // Rule ID 23212 //
     /*  359663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  359674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  359677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  359680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359702 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  359705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359719 */     GIR_RootConstrainSelectedInstOperands,
     /*  359720 */     // GIR_Coverage, 23212,
     /*  359720 */     GIR_EraseRootFromParent_Done,
     /*  359721 */   // Label 6548: @359721
     /*  359721 */   GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(359784), // Rule ID 23213 //
     /*  359726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  359737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  359740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  359743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359765 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  359768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359782 */     GIR_RootConstrainSelectedInstOperands,
     /*  359783 */     // GIR_Coverage, 23213,
     /*  359783 */     GIR_EraseRootFromParent_Done,
     /*  359784 */   // Label 6549: @359784
     /*  359784 */   GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(359847), // Rule ID 23214 //
     /*  359789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  359800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  359803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  359806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359828 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  359831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359845 */     GIR_RootConstrainSelectedInstOperands,
     /*  359846 */     // GIR_Coverage, 23214,
     /*  359846 */     GIR_EraseRootFromParent_Done,
     /*  359847 */   // Label 6550: @359847
     /*  359847 */   GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(359910), // Rule ID 23215 //
     /*  359852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  359863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  359866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  359869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359891 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  359894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359908 */     GIR_RootConstrainSelectedInstOperands,
     /*  359909 */     // GIR_Coverage, 23215,
     /*  359909 */     GIR_EraseRootFromParent_Done,
     /*  359910 */   // Label 6551: @359910
     /*  359910 */   GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(359973), // Rule ID 23216 //
     /*  359915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359954 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  359957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359971 */     GIR_RootConstrainSelectedInstOperands,
     /*  359972 */     // GIR_Coverage, 23216,
     /*  359972 */     GIR_EraseRootFromParent_Done,
     /*  359973 */   // Label 6552: @359973
     /*  359973 */   GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(360036), // Rule ID 23217 //
     /*  359978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360017 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  360020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360034 */     GIR_RootConstrainSelectedInstOperands,
     /*  360035 */     // GIR_Coverage, 23217,
     /*  360035 */     GIR_EraseRootFromParent_Done,
     /*  360036 */   // Label 6553: @360036
     /*  360036 */   GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(360099), // Rule ID 23218 //
     /*  360041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360080 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  360083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360097 */     GIR_RootConstrainSelectedInstOperands,
     /*  360098 */     // GIR_Coverage, 23218,
     /*  360098 */     GIR_EraseRootFromParent_Done,
     /*  360099 */   // Label 6554: @360099
     /*  360099 */   GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(360162), // Rule ID 23219 //
     /*  360104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360143 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  360146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360160 */     GIR_RootConstrainSelectedInstOperands,
     /*  360161 */     // GIR_Coverage, 23219,
     /*  360161 */     GIR_EraseRootFromParent_Done,
     /*  360162 */   // Label 6555: @360162
     /*  360162 */   GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(360225), // Rule ID 23220 //
     /*  360167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360206 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  360209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360223 */     GIR_RootConstrainSelectedInstOperands,
     /*  360224 */     // GIR_Coverage, 23220,
     /*  360224 */     GIR_EraseRootFromParent_Done,
     /*  360225 */   // Label 6556: @360225
     /*  360225 */   GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(360288), // Rule ID 23221 //
     /*  360230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360269 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  360272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360286 */     GIR_RootConstrainSelectedInstOperands,
     /*  360287 */     // GIR_Coverage, 23221,
     /*  360287 */     GIR_EraseRootFromParent_Done,
     /*  360288 */   // Label 6557: @360288
     /*  360288 */   GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(360351), // Rule ID 23222 //
     /*  360293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360332 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  360335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360349 */     GIR_RootConstrainSelectedInstOperands,
     /*  360350 */     // GIR_Coverage, 23222,
     /*  360350 */     GIR_EraseRootFromParent_Done,
     /*  360351 */   // Label 6558: @360351
     /*  360351 */   GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(360414), // Rule ID 23223 //
     /*  360356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360395 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  360398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360412 */     GIR_RootConstrainSelectedInstOperands,
     /*  360413 */     // GIR_Coverage, 23223,
     /*  360413 */     GIR_EraseRootFromParent_Done,
     /*  360414 */   // Label 6559: @360414
     /*  360414 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(360477), // Rule ID 23224 //
     /*  360419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360458 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  360461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360475 */     GIR_RootConstrainSelectedInstOperands,
     /*  360476 */     // GIR_Coverage, 23224,
     /*  360476 */     GIR_EraseRootFromParent_Done,
     /*  360477 */   // Label 6560: @360477
     /*  360477 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(360540), // Rule ID 23225 //
     /*  360482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360521 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  360524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360538 */     GIR_RootConstrainSelectedInstOperands,
     /*  360539 */     // GIR_Coverage, 23225,
     /*  360539 */     GIR_EraseRootFromParent_Done,
     /*  360540 */   // Label 6561: @360540
     /*  360540 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(360603), // Rule ID 23226 //
     /*  360545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360584 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  360587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360601 */     GIR_RootConstrainSelectedInstOperands,
     /*  360602 */     // GIR_Coverage, 23226,
     /*  360602 */     GIR_EraseRootFromParent_Done,
     /*  360603 */   // Label 6562: @360603
     /*  360603 */   GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(360666), // Rule ID 23227 //
     /*  360608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360647 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  360650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360664 */     GIR_RootConstrainSelectedInstOperands,
     /*  360665 */     // GIR_Coverage, 23227,
     /*  360665 */     GIR_EraseRootFromParent_Done,
     /*  360666 */   // Label 6563: @360666
     /*  360666 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(360729), // Rule ID 23228 //
     /*  360671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360710 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  360713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360727 */     GIR_RootConstrainSelectedInstOperands,
     /*  360728 */     // GIR_Coverage, 23228,
     /*  360728 */     GIR_EraseRootFromParent_Done,
     /*  360729 */   // Label 6564: @360729
     /*  360729 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(360792), // Rule ID 23229 //
     /*  360734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360773 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  360776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360790 */     GIR_RootConstrainSelectedInstOperands,
     /*  360791 */     // GIR_Coverage, 23229,
     /*  360791 */     GIR_EraseRootFromParent_Done,
     /*  360792 */   // Label 6565: @360792
     /*  360792 */   GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(360855), // Rule ID 23230 //
     /*  360797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360836 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  360839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360853 */     GIR_RootConstrainSelectedInstOperands,
     /*  360854 */     // GIR_Coverage, 23230,
     /*  360854 */     GIR_EraseRootFromParent_Done,
     /*  360855 */   // Label 6566: @360855
     /*  360855 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(360918), // Rule ID 23231 //
     /*  360860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360899 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  360902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360916 */     GIR_RootConstrainSelectedInstOperands,
     /*  360917 */     // GIR_Coverage, 23231,
     /*  360917 */     GIR_EraseRootFromParent_Done,
     /*  360918 */   // Label 6567: @360918
     /*  360918 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(360981), // Rule ID 23232 //
     /*  360923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360962 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  360965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360979 */     GIR_RootConstrainSelectedInstOperands,
     /*  360980 */     // GIR_Coverage, 23232,
     /*  360980 */     GIR_EraseRootFromParent_Done,
     /*  360981 */   // Label 6568: @360981
     /*  360981 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(361044), // Rule ID 23233 //
     /*  360986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361025 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  361028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361042 */     GIR_RootConstrainSelectedInstOperands,
     /*  361043 */     // GIR_Coverage, 23233,
     /*  361043 */     GIR_EraseRootFromParent_Done,
     /*  361044 */   // Label 6569: @361044
     /*  361044 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(361107), // Rule ID 23234 //
     /*  361049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361088 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  361091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361105 */     GIR_RootConstrainSelectedInstOperands,
     /*  361106 */     // GIR_Coverage, 23234,
     /*  361106 */     GIR_EraseRootFromParent_Done,
     /*  361107 */   // Label 6570: @361107
     /*  361107 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(361170), // Rule ID 23235 //
     /*  361112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361151 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  361154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361168 */     GIR_RootConstrainSelectedInstOperands,
     /*  361169 */     // GIR_Coverage, 23235,
     /*  361169 */     GIR_EraseRootFromParent_Done,
     /*  361170 */   // Label 6571: @361170
     /*  361170 */   GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(361233), // Rule ID 23236 //
     /*  361175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361214 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  361217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361231 */     GIR_RootConstrainSelectedInstOperands,
     /*  361232 */     // GIR_Coverage, 23236,
     /*  361232 */     GIR_EraseRootFromParent_Done,
     /*  361233 */   // Label 6572: @361233
     /*  361233 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(361296), // Rule ID 23237 //
     /*  361238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361277 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  361280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361294 */     GIR_RootConstrainSelectedInstOperands,
     /*  361295 */     // GIR_Coverage, 23237,
     /*  361295 */     GIR_EraseRootFromParent_Done,
     /*  361296 */   // Label 6573: @361296
     /*  361296 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(361359), // Rule ID 23238 //
     /*  361301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361340 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  361343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361357 */     GIR_RootConstrainSelectedInstOperands,
     /*  361358 */     // GIR_Coverage, 23238,
     /*  361358 */     GIR_EraseRootFromParent_Done,
     /*  361359 */   // Label 6574: @361359
     /*  361359 */   GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(361422), // Rule ID 23239 //
     /*  361364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361403 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  361406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361420 */     GIR_RootConstrainSelectedInstOperands,
     /*  361421 */     // GIR_Coverage, 23239,
     /*  361421 */     GIR_EraseRootFromParent_Done,
     /*  361422 */   // Label 6575: @361422
     /*  361422 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(361485), // Rule ID 23240 //
     /*  361427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361466 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  361469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361483 */     GIR_RootConstrainSelectedInstOperands,
     /*  361484 */     // GIR_Coverage, 23240,
     /*  361484 */     GIR_EraseRootFromParent_Done,
     /*  361485 */   // Label 6576: @361485
     /*  361485 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(361548), // Rule ID 23241 //
     /*  361490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361529 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  361532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361546 */     GIR_RootConstrainSelectedInstOperands,
     /*  361547 */     // GIR_Coverage, 23241,
     /*  361547 */     GIR_EraseRootFromParent_Done,
     /*  361548 */   // Label 6577: @361548
     /*  361548 */   GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(361611), // Rule ID 23242 //
     /*  361553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361592 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  361595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361609 */     GIR_RootConstrainSelectedInstOperands,
     /*  361610 */     // GIR_Coverage, 23242,
     /*  361610 */     GIR_EraseRootFromParent_Done,
     /*  361611 */   // Label 6578: @361611
     /*  361611 */   GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(361674), // Rule ID 23243 //
     /*  361616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361655 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  361658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361672 */     GIR_RootConstrainSelectedInstOperands,
     /*  361673 */     // GIR_Coverage, 23243,
     /*  361673 */     GIR_EraseRootFromParent_Done,
     /*  361674 */   // Label 6579: @361674
     /*  361674 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(361737), // Rule ID 23244 //
     /*  361679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361718 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  361721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361735 */     GIR_RootConstrainSelectedInstOperands,
     /*  361736 */     // GIR_Coverage, 23244,
     /*  361736 */     GIR_EraseRootFromParent_Done,
     /*  361737 */   // Label 6580: @361737
     /*  361737 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(361800), // Rule ID 23245 //
     /*  361742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361781 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  361784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361798 */     GIR_RootConstrainSelectedInstOperands,
     /*  361799 */     // GIR_Coverage, 23245,
     /*  361799 */     GIR_EraseRootFromParent_Done,
     /*  361800 */   // Label 6581: @361800
     /*  361800 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(361863), // Rule ID 23246 //
     /*  361805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361844 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  361847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361861 */     GIR_RootConstrainSelectedInstOperands,
     /*  361862 */     // GIR_Coverage, 23246,
     /*  361862 */     GIR_EraseRootFromParent_Done,
     /*  361863 */   // Label 6582: @361863
     /*  361863 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(361926), // Rule ID 23247 //
     /*  361868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361907 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  361910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361924 */     GIR_RootConstrainSelectedInstOperands,
     /*  361925 */     // GIR_Coverage, 23247,
     /*  361925 */     GIR_EraseRootFromParent_Done,
     /*  361926 */   // Label 6583: @361926
     /*  361926 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(361989), // Rule ID 23248 //
     /*  361931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361970 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  361973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361987 */     GIR_RootConstrainSelectedInstOperands,
     /*  361988 */     // GIR_Coverage, 23248,
     /*  361988 */     GIR_EraseRootFromParent_Done,
     /*  361989 */   // Label 6584: @361989
     /*  361989 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(362052), // Rule ID 23249 //
     /*  361994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362033 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  362036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362050 */     GIR_RootConstrainSelectedInstOperands,
     /*  362051 */     // GIR_Coverage, 23249,
     /*  362051 */     GIR_EraseRootFromParent_Done,
     /*  362052 */   // Label 6585: @362052
     /*  362052 */   GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(362115), // Rule ID 23250 //
     /*  362057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362096 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  362099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362113 */     GIR_RootConstrainSelectedInstOperands,
     /*  362114 */     // GIR_Coverage, 23250,
     /*  362114 */     GIR_EraseRootFromParent_Done,
     /*  362115 */   // Label 6586: @362115
     /*  362115 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(362178), // Rule ID 23251 //
     /*  362120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362159 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  362162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362176 */     GIR_RootConstrainSelectedInstOperands,
     /*  362177 */     // GIR_Coverage, 23251,
     /*  362177 */     GIR_EraseRootFromParent_Done,
     /*  362178 */   // Label 6587: @362178
     /*  362178 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(362241), // Rule ID 23252 //
     /*  362183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362222 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  362225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362239 */     GIR_RootConstrainSelectedInstOperands,
     /*  362240 */     // GIR_Coverage, 23252,
     /*  362240 */     GIR_EraseRootFromParent_Done,
     /*  362241 */   // Label 6588: @362241
     /*  362241 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(362304), // Rule ID 23253 //
     /*  362246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362285 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  362288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362302 */     GIR_RootConstrainSelectedInstOperands,
     /*  362303 */     // GIR_Coverage, 23253,
     /*  362303 */     GIR_EraseRootFromParent_Done,
     /*  362304 */   // Label 6589: @362304
     /*  362304 */   GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(362367), // Rule ID 23254 //
     /*  362309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  362320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  362323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  362326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362348 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  362351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362365 */     GIR_RootConstrainSelectedInstOperands,
     /*  362366 */     // GIR_Coverage, 23254,
     /*  362366 */     GIR_EraseRootFromParent_Done,
     /*  362367 */   // Label 6590: @362367
     /*  362367 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(362430), // Rule ID 23255 //
     /*  362372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  362383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  362386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  362389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362411 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  362414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362428 */     GIR_RootConstrainSelectedInstOperands,
     /*  362429 */     // GIR_Coverage, 23255,
     /*  362429 */     GIR_EraseRootFromParent_Done,
     /*  362430 */   // Label 6591: @362430
     /*  362430 */   GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(362493), // Rule ID 23256 //
     /*  362435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362474 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  362477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362491 */     GIR_RootConstrainSelectedInstOperands,
     /*  362492 */     // GIR_Coverage, 23256,
     /*  362492 */     GIR_EraseRootFromParent_Done,
     /*  362493 */   // Label 6592: @362493
     /*  362493 */   GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(362556), // Rule ID 23257 //
     /*  362498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362537 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  362540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362554 */     GIR_RootConstrainSelectedInstOperands,
     /*  362555 */     // GIR_Coverage, 23257,
     /*  362555 */     GIR_EraseRootFromParent_Done,
     /*  362556 */   // Label 6593: @362556
     /*  362556 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(362619), // Rule ID 23258 //
     /*  362561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362600 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  362603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362617 */     GIR_RootConstrainSelectedInstOperands,
     /*  362618 */     // GIR_Coverage, 23258,
     /*  362618 */     GIR_EraseRootFromParent_Done,
     /*  362619 */   // Label 6594: @362619
     /*  362619 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(362682), // Rule ID 23259 //
     /*  362624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362663 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  362666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362680 */     GIR_RootConstrainSelectedInstOperands,
     /*  362681 */     // GIR_Coverage, 23259,
     /*  362681 */     GIR_EraseRootFromParent_Done,
     /*  362682 */   // Label 6595: @362682
     /*  362682 */   GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(362745), // Rule ID 23260 //
     /*  362687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362726 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  362729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362743 */     GIR_RootConstrainSelectedInstOperands,
     /*  362744 */     // GIR_Coverage, 23260,
     /*  362744 */     GIR_EraseRootFromParent_Done,
     /*  362745 */   // Label 6596: @362745
     /*  362745 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(362808), // Rule ID 23261 //
     /*  362750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362789 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  362792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362806 */     GIR_RootConstrainSelectedInstOperands,
     /*  362807 */     // GIR_Coverage, 23261,
     /*  362807 */     GIR_EraseRootFromParent_Done,
     /*  362808 */   // Label 6597: @362808
     /*  362808 */   GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(362871), // Rule ID 23262 //
     /*  362813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362852 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  362855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362869 */     GIR_RootConstrainSelectedInstOperands,
     /*  362870 */     // GIR_Coverage, 23262,
     /*  362870 */     GIR_EraseRootFromParent_Done,
     /*  362871 */   // Label 6598: @362871
     /*  362871 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(362934), // Rule ID 23263 //
     /*  362876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362915 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  362918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362932 */     GIR_RootConstrainSelectedInstOperands,
     /*  362933 */     // GIR_Coverage, 23263,
     /*  362933 */     GIR_EraseRootFromParent_Done,
     /*  362934 */   // Label 6599: @362934
     /*  362934 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(362997), // Rule ID 23264 //
     /*  362939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362978 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  362981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362995 */     GIR_RootConstrainSelectedInstOperands,
     /*  362996 */     // GIR_Coverage, 23264,
     /*  362996 */     GIR_EraseRootFromParent_Done,
     /*  362997 */   // Label 6600: @362997
     /*  362997 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(363060), // Rule ID 23265 //
     /*  363002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  363013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363041 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  363044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363058 */     GIR_RootConstrainSelectedInstOperands,
     /*  363059 */     // GIR_Coverage, 23265,
     /*  363059 */     GIR_EraseRootFromParent_Done,
     /*  363060 */   // Label 6601: @363060
     /*  363060 */   GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(363123), // Rule ID 23266 //
     /*  363065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  363076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363104 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  363107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363121 */     GIR_RootConstrainSelectedInstOperands,
     /*  363122 */     // GIR_Coverage, 23266,
     /*  363122 */     GIR_EraseRootFromParent_Done,
     /*  363123 */   // Label 6602: @363123
     /*  363123 */   GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(363186), // Rule ID 23267 //
     /*  363128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  363139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363167 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  363170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363184 */     GIR_RootConstrainSelectedInstOperands,
     /*  363185 */     // GIR_Coverage, 23267,
     /*  363185 */     GIR_EraseRootFromParent_Done,
     /*  363186 */   // Label 6603: @363186
     /*  363186 */   GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(363249), // Rule ID 23296 //
     /*  363191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363230 */     // (intrinsic_wo_chain:{ *:[i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  363233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363237 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363247 */     GIR_RootConstrainSelectedInstOperands,
     /*  363248 */     // GIR_Coverage, 23296,
     /*  363248 */     GIR_EraseRootFromParent_Done,
     /*  363249 */   // Label 6604: @363249
     /*  363249 */   GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(363312), // Rule ID 23297 //
     /*  363254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363293 */     // (intrinsic_wo_chain:{ *:[i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  363296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363300 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363310 */     GIR_RootConstrainSelectedInstOperands,
     /*  363311 */     // GIR_Coverage, 23297,
     /*  363311 */     GIR_EraseRootFromParent_Done,
     /*  363312 */   // Label 6605: @363312
     /*  363312 */   GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(363375), // Rule ID 23300 //
     /*  363317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363356 */     // (intrinsic_wo_chain:{ *:[i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  363359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363363 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363373 */     GIR_RootConstrainSelectedInstOperands,
     /*  363374 */     // GIR_Coverage, 23300,
     /*  363374 */     GIR_EraseRootFromParent_Done,
     /*  363375 */   // Label 6606: @363375
     /*  363375 */   GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(363438), // Rule ID 23301 //
     /*  363380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363419 */     // (intrinsic_wo_chain:{ *:[i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  363422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363426 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363436 */     GIR_RootConstrainSelectedInstOperands,
     /*  363437 */     // GIR_Coverage, 23301,
     /*  363437 */     GIR_EraseRootFromParent_Done,
     /*  363438 */   // Label 6607: @363438
     /*  363438 */   GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(363501), // Rule ID 23304 //
     /*  363443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363482 */     // (intrinsic_wo_chain:{ *:[i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  363485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363489 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363499 */     GIR_RootConstrainSelectedInstOperands,
     /*  363500 */     // GIR_Coverage, 23304,
     /*  363500 */     GIR_EraseRootFromParent_Done,
     /*  363501 */   // Label 6608: @363501
     /*  363501 */   GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(363564), // Rule ID 23305 //
     /*  363506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363545 */     // (intrinsic_wo_chain:{ *:[i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  363548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363552 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363562 */     GIR_RootConstrainSelectedInstOperands,
     /*  363563 */     // GIR_Coverage, 23305,
     /*  363563 */     GIR_EraseRootFromParent_Done,
     /*  363564 */   // Label 6609: @363564
     /*  363564 */   GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(363627), // Rule ID 23308 //
     /*  363569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363608 */     // (intrinsic_wo_chain:{ *:[i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  363611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363615 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363625 */     GIR_RootConstrainSelectedInstOperands,
     /*  363626 */     // GIR_Coverage, 23308,
     /*  363626 */     GIR_EraseRootFromParent_Done,
     /*  363627 */   // Label 6610: @363627
     /*  363627 */   GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(363690), // Rule ID 23309 //
     /*  363632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363671 */     // (intrinsic_wo_chain:{ *:[i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  363674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363678 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363688 */     GIR_RootConstrainSelectedInstOperands,
     /*  363689 */     // GIR_Coverage, 23309,
     /*  363689 */     GIR_EraseRootFromParent_Done,
     /*  363690 */   // Label 6611: @363690
     /*  363690 */   GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(363753), // Rule ID 23312 //
     /*  363695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363734 */     // (intrinsic_wo_chain:{ *:[i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  363737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363741 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363751 */     GIR_RootConstrainSelectedInstOperands,
     /*  363752 */     // GIR_Coverage, 23312,
     /*  363752 */     GIR_EraseRootFromParent_Done,
     /*  363753 */   // Label 6612: @363753
     /*  363753 */   GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(363816), // Rule ID 23313 //
     /*  363758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363797 */     // (intrinsic_wo_chain:{ *:[i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  363800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363804 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363814 */     GIR_RootConstrainSelectedInstOperands,
     /*  363815 */     // GIR_Coverage, 23313,
     /*  363815 */     GIR_EraseRootFromParent_Done,
     /*  363816 */   // Label 6613: @363816
     /*  363816 */   GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(363879), // Rule ID 23316 //
     /*  363821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363860 */     // (intrinsic_wo_chain:{ *:[i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  363863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363867 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363877 */     GIR_RootConstrainSelectedInstOperands,
     /*  363878 */     // GIR_Coverage, 23316,
     /*  363878 */     GIR_EraseRootFromParent_Done,
     /*  363879 */   // Label 6614: @363879
     /*  363879 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(363942), // Rule ID 23317 //
     /*  363884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363923 */     // (intrinsic_wo_chain:{ *:[i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  363926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363930 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363940 */     GIR_RootConstrainSelectedInstOperands,
     /*  363941 */     // GIR_Coverage, 23317,
     /*  363941 */     GIR_EraseRootFromParent_Done,
     /*  363942 */   // Label 6615: @363942
     /*  363942 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(364005), // Rule ID 23320 //
     /*  363947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  363955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  363961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  363964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363986 */     // (intrinsic_wo_chain:{ *:[i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  363989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363993 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364003 */     GIR_RootConstrainSelectedInstOperands,
     /*  364004 */     // GIR_Coverage, 23320,
     /*  364004 */     GIR_EraseRootFromParent_Done,
     /*  364005 */   // Label 6616: @364005
     /*  364005 */   GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(364068), // Rule ID 23321 //
     /*  364010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  364024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364049 */     // (intrinsic_wo_chain:{ *:[i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  364052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364056 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364066 */     GIR_RootConstrainSelectedInstOperands,
     /*  364067 */     // GIR_Coverage, 23321,
     /*  364067 */     GIR_EraseRootFromParent_Done,
     /*  364068 */   // Label 6617: @364068
     /*  364068 */   GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(364131), // Rule ID 23324 //
     /*  364073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  364087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364112 */     // (intrinsic_wo_chain:{ *:[i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  364115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364119 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364129 */     GIR_RootConstrainSelectedInstOperands,
     /*  364130 */     // GIR_Coverage, 23324,
     /*  364130 */     GIR_EraseRootFromParent_Done,
     /*  364131 */   // Label 6618: @364131
     /*  364131 */   GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(364194), // Rule ID 23325 //
     /*  364136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  364150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364175 */     // (intrinsic_wo_chain:{ *:[i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  364178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364182 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364192 */     GIR_RootConstrainSelectedInstOperands,
     /*  364193 */     // GIR_Coverage, 23325,
     /*  364193 */     GIR_EraseRootFromParent_Done,
     /*  364194 */   // Label 6619: @364194
     /*  364194 */   GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(364257), // Rule ID 23328 //
     /*  364199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  364213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364238 */     // (intrinsic_wo_chain:{ *:[i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  364241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364245 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364255 */     GIR_RootConstrainSelectedInstOperands,
     /*  364256 */     // GIR_Coverage, 23328,
     /*  364256 */     GIR_EraseRootFromParent_Done,
     /*  364257 */   // Label 6620: @364257
     /*  364257 */   GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(364320), // Rule ID 23329 //
     /*  364262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  364276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364301 */     // (intrinsic_wo_chain:{ *:[i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  364304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364308 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364318 */     GIR_RootConstrainSelectedInstOperands,
     /*  364319 */     // GIR_Coverage, 23329,
     /*  364319 */     GIR_EraseRootFromParent_Done,
     /*  364320 */   // Label 6621: @364320
     /*  364320 */   GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(364383), // Rule ID 23332 //
     /*  364325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  364339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  364342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364364 */     // (intrinsic_wo_chain:{ *:[i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  364367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364371 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364381 */     GIR_RootConstrainSelectedInstOperands,
     /*  364382 */     // GIR_Coverage, 23332,
     /*  364382 */     GIR_EraseRootFromParent_Done,
     /*  364383 */   // Label 6622: @364383
     /*  364383 */   GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(364446), // Rule ID 23333 //
     /*  364388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  364402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  364405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364427 */     // (intrinsic_wo_chain:{ *:[i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  364430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364434 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364444 */     GIR_RootConstrainSelectedInstOperands,
     /*  364445 */     // GIR_Coverage, 23333,
     /*  364445 */     GIR_EraseRootFromParent_Done,
     /*  364446 */   // Label 6623: @364446
     /*  364446 */   GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(364509), // Rule ID 23336 //
     /*  364451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364490 */     // (intrinsic_wo_chain:{ *:[i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  364493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364497 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364507 */     GIR_RootConstrainSelectedInstOperands,
     /*  364508 */     // GIR_Coverage, 23336,
     /*  364508 */     GIR_EraseRootFromParent_Done,
     /*  364509 */   // Label 6624: @364509
     /*  364509 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(364572), // Rule ID 23337 //
     /*  364514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364553 */     // (intrinsic_wo_chain:{ *:[i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  364556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364560 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364570 */     GIR_RootConstrainSelectedInstOperands,
     /*  364571 */     // GIR_Coverage, 23337,
     /*  364571 */     GIR_EraseRootFromParent_Done,
     /*  364572 */   // Label 6625: @364572
     /*  364572 */   GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(364635), // Rule ID 23340 //
     /*  364577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364616 */     // (intrinsic_wo_chain:{ *:[i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  364619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364623 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364633 */     GIR_RootConstrainSelectedInstOperands,
     /*  364634 */     // GIR_Coverage, 23340,
     /*  364634 */     GIR_EraseRootFromParent_Done,
     /*  364635 */   // Label 6626: @364635
     /*  364635 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(364698), // Rule ID 23341 //
     /*  364640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364679 */     // (intrinsic_wo_chain:{ *:[i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  364682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364686 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364696 */     GIR_RootConstrainSelectedInstOperands,
     /*  364697 */     // GIR_Coverage, 23341,
     /*  364697 */     GIR_EraseRootFromParent_Done,
     /*  364698 */   // Label 6627: @364698
     /*  364698 */   GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(364761), // Rule ID 23344 //
     /*  364703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364742 */     // (intrinsic_wo_chain:{ *:[i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  364745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364749 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364759 */     GIR_RootConstrainSelectedInstOperands,
     /*  364760 */     // GIR_Coverage, 23344,
     /*  364760 */     GIR_EraseRootFromParent_Done,
     /*  364761 */   // Label 6628: @364761
     /*  364761 */   GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(364824), // Rule ID 23345 //
     /*  364766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364805 */     // (intrinsic_wo_chain:{ *:[i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  364808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364812 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364822 */     GIR_RootConstrainSelectedInstOperands,
     /*  364823 */     // GIR_Coverage, 23345,
     /*  364823 */     GIR_EraseRootFromParent_Done,
     /*  364824 */   // Label 6629: @364824
     /*  364824 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(364890), // Rule ID 23426 //
     /*  364829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  364840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  364843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364868 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  364868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  364871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364888 */     GIR_RootConstrainSelectedInstOperands,
     /*  364889 */     // GIR_Coverage, 23426,
     /*  364889 */     GIR_EraseRootFromParent_Done,
     /*  364890 */   // Label 6630: @364890
     /*  364890 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(364956), // Rule ID 23427 //
     /*  364895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  364906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  364909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364934 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  364934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  364937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364954 */     GIR_RootConstrainSelectedInstOperands,
     /*  364955 */     // GIR_Coverage, 23427,
     /*  364955 */     GIR_EraseRootFromParent_Done,
     /*  364956 */   // Label 6631: @364956
     /*  364956 */   GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(365022), // Rule ID 23430 //
     /*  364961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  364972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  364975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365000 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  365000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365020 */     GIR_RootConstrainSelectedInstOperands,
     /*  365021 */     // GIR_Coverage, 23430,
     /*  365021 */     GIR_EraseRootFromParent_Done,
     /*  365022 */   // Label 6632: @365022
     /*  365022 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(365088), // Rule ID 23431 //
     /*  365027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  365038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  365041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365066 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  365066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365086 */     GIR_RootConstrainSelectedInstOperands,
     /*  365087 */     // GIR_Coverage, 23431,
     /*  365087 */     GIR_EraseRootFromParent_Done,
     /*  365088 */   // Label 6633: @365088
     /*  365088 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(365154), // Rule ID 23434 //
     /*  365093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  365104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  365107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365132 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  365132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  365135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365152 */     GIR_RootConstrainSelectedInstOperands,
     /*  365153 */     // GIR_Coverage, 23434,
     /*  365153 */     GIR_EraseRootFromParent_Done,
     /*  365154 */   // Label 6634: @365154
     /*  365154 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(365220), // Rule ID 23435 //
     /*  365159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  365170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  365173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365198 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  365198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  365201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365218 */     GIR_RootConstrainSelectedInstOperands,
     /*  365219 */     // GIR_Coverage, 23435,
     /*  365219 */     GIR_EraseRootFromParent_Done,
     /*  365220 */   // Label 6635: @365220
     /*  365220 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(365286), // Rule ID 23438 //
     /*  365225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  365236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  365239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  365264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365284 */     GIR_RootConstrainSelectedInstOperands,
     /*  365285 */     // GIR_Coverage, 23438,
     /*  365285 */     GIR_EraseRootFromParent_Done,
     /*  365286 */   // Label 6636: @365286
     /*  365286 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(365352), // Rule ID 23439 //
     /*  365291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  365302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  365305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365330 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  365330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365350 */     GIR_RootConstrainSelectedInstOperands,
     /*  365351 */     // GIR_Coverage, 23439,
     /*  365351 */     GIR_EraseRootFromParent_Done,
     /*  365352 */   // Label 6637: @365352
     /*  365352 */   GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(365418), // Rule ID 23442 //
     /*  365357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  365368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  365371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  365396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365416 */     GIR_RootConstrainSelectedInstOperands,
     /*  365417 */     // GIR_Coverage, 23442,
     /*  365417 */     GIR_EraseRootFromParent_Done,
     /*  365418 */   // Label 6638: @365418
     /*  365418 */   GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(365484), // Rule ID 23443 //
     /*  365423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  365434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  365437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365462 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  365462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365482 */     GIR_RootConstrainSelectedInstOperands,
     /*  365483 */     // GIR_Coverage, 23443,
     /*  365483 */     GIR_EraseRootFromParent_Done,
     /*  365484 */   // Label 6639: @365484
     /*  365484 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(365550), // Rule ID 23446 //
     /*  365489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  365500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  365503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  365506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365528 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  365528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365548 */     GIR_RootConstrainSelectedInstOperands,
     /*  365549 */     // GIR_Coverage, 23446,
     /*  365549 */     GIR_EraseRootFromParent_Done,
     /*  365550 */   // Label 6640: @365550
     /*  365550 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(365616), // Rule ID 23447 //
     /*  365555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  365566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  365569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  365572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365594 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  365594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365614 */     GIR_RootConstrainSelectedInstOperands,
     /*  365615 */     // GIR_Coverage, 23447,
     /*  365615 */     GIR_EraseRootFromParent_Done,
     /*  365616 */   // Label 6641: @365616
     /*  365616 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(365682), // Rule ID 23450 //
     /*  365621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  365632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  365635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365660 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  365660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365680 */     GIR_RootConstrainSelectedInstOperands,
     /*  365681 */     // GIR_Coverage, 23450,
     /*  365681 */     GIR_EraseRootFromParent_Done,
     /*  365682 */   // Label 6642: @365682
     /*  365682 */   GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(365748), // Rule ID 23451 //
     /*  365687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  365698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  365701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365726 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  365726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365746 */     GIR_RootConstrainSelectedInstOperands,
     /*  365747 */     // GIR_Coverage, 23451,
     /*  365747 */     GIR_EraseRootFromParent_Done,
     /*  365748 */   // Label 6643: @365748
     /*  365748 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(365814), // Rule ID 23454 //
     /*  365753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  365764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  365767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  365792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365812 */     GIR_RootConstrainSelectedInstOperands,
     /*  365813 */     // GIR_Coverage, 23454,
     /*  365813 */     GIR_EraseRootFromParent_Done,
     /*  365814 */   // Label 6644: @365814
     /*  365814 */   GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(365880), // Rule ID 23455 //
     /*  365819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  365830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  365833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365858 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  365858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365878 */     GIR_RootConstrainSelectedInstOperands,
     /*  365879 */     // GIR_Coverage, 23455,
     /*  365879 */     GIR_EraseRootFromParent_Done,
     /*  365880 */   // Label 6645: @365880
     /*  365880 */   GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(365946), // Rule ID 23458 //
     /*  365885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  365888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  365896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  365899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365924 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  365924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  365941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365944 */     GIR_RootConstrainSelectedInstOperands,
     /*  365945 */     // GIR_Coverage, 23458,
     /*  365945 */     GIR_EraseRootFromParent_Done,
     /*  365946 */   // Label 6646: @365946
     /*  365946 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(366012), // Rule ID 23459 //
     /*  365951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  365954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  365962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  365965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365990 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  365990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  366007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366010 */     GIR_RootConstrainSelectedInstOperands,
     /*  366011 */     // GIR_Coverage, 23459,
     /*  366011 */     GIR_EraseRootFromParent_Done,
     /*  366012 */   // Label 6647: @366012
     /*  366012 */   GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(366078), // Rule ID 23462 //
     /*  366017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  366028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  366031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366056 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366076 */     GIR_RootConstrainSelectedInstOperands,
     /*  366077 */     // GIR_Coverage, 23462,
     /*  366077 */     GIR_EraseRootFromParent_Done,
     /*  366078 */   // Label 6648: @366078
     /*  366078 */   GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(366144), // Rule ID 23463 //
     /*  366083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  366094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  366097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366122 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366142 */     GIR_RootConstrainSelectedInstOperands,
     /*  366143 */     // GIR_Coverage, 23463,
     /*  366143 */     GIR_EraseRootFromParent_Done,
     /*  366144 */   // Label 6649: @366144
     /*  366144 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(366210), // Rule ID 23466 //
     /*  366149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  366160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  366163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366188 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366208 */     GIR_RootConstrainSelectedInstOperands,
     /*  366209 */     // GIR_Coverage, 23466,
     /*  366209 */     GIR_EraseRootFromParent_Done,
     /*  366210 */   // Label 6650: @366210
     /*  366210 */   GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(366276), // Rule ID 23467 //
     /*  366215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  366226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  366229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366254 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366274 */     GIR_RootConstrainSelectedInstOperands,
     /*  366275 */     // GIR_Coverage, 23467,
     /*  366275 */     GIR_EraseRootFromParent_Done,
     /*  366276 */   // Label 6651: @366276
     /*  366276 */   GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(366342), // Rule ID 23470 //
     /*  366281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  366292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  366295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366320 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366340 */     GIR_RootConstrainSelectedInstOperands,
     /*  366341 */     // GIR_Coverage, 23470,
     /*  366341 */     GIR_EraseRootFromParent_Done,
     /*  366342 */   // Label 6652: @366342
     /*  366342 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(366408), // Rule ID 23471 //
     /*  366347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  366358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  366361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366386 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366406 */     GIR_RootConstrainSelectedInstOperands,
     /*  366407 */     // GIR_Coverage, 23471,
     /*  366407 */     GIR_EraseRootFromParent_Done,
     /*  366408 */   // Label 6653: @366408
     /*  366408 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(366474), // Rule ID 23474 //
     /*  366413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  366424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  366427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  366452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366472 */     GIR_RootConstrainSelectedInstOperands,
     /*  366473 */     // GIR_Coverage, 23474,
     /*  366473 */     GIR_EraseRootFromParent_Done,
     /*  366474 */   // Label 6654: @366474
     /*  366474 */   GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(366540), // Rule ID 23475 //
     /*  366479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  366490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  366493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366518 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  366518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366538 */     GIR_RootConstrainSelectedInstOperands,
     /*  366539 */     // GIR_Coverage, 23475,
     /*  366539 */     GIR_EraseRootFromParent_Done,
     /*  366540 */   // Label 6655: @366540
     /*  366540 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(366606), // Rule ID 23478 //
     /*  366545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  366556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  366559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366584 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  366584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366604 */     GIR_RootConstrainSelectedInstOperands,
     /*  366605 */     // GIR_Coverage, 23478,
     /*  366605 */     GIR_EraseRootFromParent_Done,
     /*  366606 */   // Label 6656: @366606
     /*  366606 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(366672), // Rule ID 23479 //
     /*  366611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  366622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  366625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366650 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  366650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366670 */     GIR_RootConstrainSelectedInstOperands,
     /*  366671 */     // GIR_Coverage, 23479,
     /*  366671 */     GIR_EraseRootFromParent_Done,
     /*  366672 */   // Label 6657: @366672
     /*  366672 */   GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(366738), // Rule ID 23482 //
     /*  366677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  366688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  366691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366716 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  366716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366736 */     GIR_RootConstrainSelectedInstOperands,
     /*  366737 */     // GIR_Coverage, 23482,
     /*  366737 */     GIR_EraseRootFromParent_Done,
     /*  366738 */   // Label 6658: @366738
     /*  366738 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(366804), // Rule ID 23483 //
     /*  366743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  366754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  366757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366782 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  366782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366802 */     GIR_RootConstrainSelectedInstOperands,
     /*  366803 */     // GIR_Coverage, 23483,
     /*  366803 */     GIR_EraseRootFromParent_Done,
     /*  366804 */   // Label 6659: @366804
     /*  366804 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(366870), // Rule ID 23486 //
     /*  366809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  366820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  366823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  366848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366868 */     GIR_RootConstrainSelectedInstOperands,
     /*  366869 */     // GIR_Coverage, 23486,
     /*  366869 */     GIR_EraseRootFromParent_Done,
     /*  366870 */   // Label 6660: @366870
     /*  366870 */   GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(366936), // Rule ID 23487 //
     /*  366875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  366886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  366889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366914 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  366914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366934 */     GIR_RootConstrainSelectedInstOperands,
     /*  366935 */     // GIR_Coverage, 23487,
     /*  366935 */     GIR_EraseRootFromParent_Done,
     /*  366936 */   // Label 6661: @366936
     /*  366936 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(367002), // Rule ID 23490 //
     /*  366941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  366952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  366955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  366980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367000 */     GIR_RootConstrainSelectedInstOperands,
     /*  367001 */     // GIR_Coverage, 23490,
     /*  367001 */     GIR_EraseRootFromParent_Done,
     /*  367002 */   // Label 6662: @367002
     /*  367002 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(367068), // Rule ID 23491 //
     /*  367007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  367018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  367021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  367046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367066 */     GIR_RootConstrainSelectedInstOperands,
     /*  367067 */     // GIR_Coverage, 23491,
     /*  367067 */     GIR_EraseRootFromParent_Done,
     /*  367068 */   // Label 6663: @367068
     /*  367068 */   GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(367134), // Rule ID 23494 //
     /*  367073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  367084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  367087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367112 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  367112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367132 */     GIR_RootConstrainSelectedInstOperands,
     /*  367133 */     // GIR_Coverage, 23494,
     /*  367133 */     GIR_EraseRootFromParent_Done,
     /*  367134 */   // Label 6664: @367134
     /*  367134 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(367200), // Rule ID 23495 //
     /*  367139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  367150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  367153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367178 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  367178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367198 */     GIR_RootConstrainSelectedInstOperands,
     /*  367199 */     // GIR_Coverage, 23495,
     /*  367199 */     GIR_EraseRootFromParent_Done,
     /*  367200 */   // Label 6665: @367200
     /*  367200 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(367266), // Rule ID 23498 //
     /*  367205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  367208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  367216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  367219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  367244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  367247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367264 */     GIR_RootConstrainSelectedInstOperands,
     /*  367265 */     // GIR_Coverage, 23498,
     /*  367265 */     GIR_EraseRootFromParent_Done,
     /*  367266 */   // Label 6666: @367266
     /*  367266 */   GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(367332), // Rule ID 23499 //
     /*  367271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  367274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  367282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  367285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367310 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  367310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  367313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367330 */     GIR_RootConstrainSelectedInstOperands,
     /*  367331 */     // GIR_Coverage, 23499,
     /*  367331 */     GIR_EraseRootFromParent_Done,
     /*  367332 */   // Label 6667: @367332
     /*  367332 */   GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(367398), // Rule ID 23502 //
     /*  367337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  367340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  367348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  367351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367376 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  367376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367396 */     GIR_RootConstrainSelectedInstOperands,
     /*  367397 */     // GIR_Coverage, 23502,
     /*  367397 */     GIR_EraseRootFromParent_Done,
     /*  367398 */   // Label 6668: @367398
     /*  367398 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(367464), // Rule ID 23503 //
     /*  367403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  367406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  367414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  367417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367442 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  367442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367462 */     GIR_RootConstrainSelectedInstOperands,
     /*  367463 */     // GIR_Coverage, 23503,
     /*  367463 */     GIR_EraseRootFromParent_Done,
     /*  367464 */   // Label 6669: @367464
     /*  367464 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(367530), // Rule ID 23506 //
     /*  367469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  367472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  367480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  367483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367508 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  367508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367528 */     GIR_RootConstrainSelectedInstOperands,
     /*  367529 */     // GIR_Coverage, 23506,
     /*  367529 */     GIR_EraseRootFromParent_Done,
     /*  367530 */   // Label 6670: @367530
     /*  367530 */   GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(367596), // Rule ID 23507 //
     /*  367535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  367538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  367546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  367549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367574 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  367574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367594 */     GIR_RootConstrainSelectedInstOperands,
     /*  367595 */     // GIR_Coverage, 23507,
     /*  367595 */     GIR_EraseRootFromParent_Done,
     /*  367596 */   // Label 6671: @367596
     /*  367596 */   GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(367662), // Rule ID 60622 //
     /*  367601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  367612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  367615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  367618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367640 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  367640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  367643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367660 */     GIR_RootConstrainSelectedInstOperands,
     /*  367661 */     // GIR_Coverage, 60622,
     /*  367661 */     GIR_EraseRootFromParent_Done,
     /*  367662 */   // Label 6672: @367662
     /*  367662 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(367728), // Rule ID 60623 //
     /*  367667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  367670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  367678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  367681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  367684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367706 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  367706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  367709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367726 */     GIR_RootConstrainSelectedInstOperands,
     /*  367727 */     // GIR_Coverage, 60623,
     /*  367727 */     GIR_EraseRootFromParent_Done,
     /*  367728 */   // Label 6673: @367728
     /*  367728 */   GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(367794), // Rule ID 60626 //
     /*  367733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  367744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  367747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  367750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367772 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  367772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  367775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367792 */     GIR_RootConstrainSelectedInstOperands,
     /*  367793 */     // GIR_Coverage, 60626,
     /*  367793 */     GIR_EraseRootFromParent_Done,
     /*  367794 */   // Label 6674: @367794
     /*  367794 */   GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(367860), // Rule ID 60627 //
     /*  367799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  367802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  367810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  367813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  367816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367838 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  367838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  367841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367858 */     GIR_RootConstrainSelectedInstOperands,
     /*  367859 */     // GIR_Coverage, 60627,
     /*  367859 */     GIR_EraseRootFromParent_Done,
     /*  367860 */   // Label 6675: @367860
     /*  367860 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(367926), // Rule ID 60630 //
     /*  367865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  367876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  367879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  367882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367904 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  367904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  367907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367924 */     GIR_RootConstrainSelectedInstOperands,
     /*  367925 */     // GIR_Coverage, 60630,
     /*  367925 */     GIR_EraseRootFromParent_Done,
     /*  367926 */   // Label 6676: @367926
     /*  367926 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(367992), // Rule ID 60631 //
     /*  367931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  367934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  367942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  367945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  367948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367970 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  367970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  367973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367990 */     GIR_RootConstrainSelectedInstOperands,
     /*  367991 */     // GIR_Coverage, 60631,
     /*  367991 */     GIR_EraseRootFromParent_Done,
     /*  367992 */   // Label 6677: @367992
     /*  367992 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(368058), // Rule ID 60634 //
     /*  367997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  368008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  368011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  368014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368036 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  368039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368056 */     GIR_RootConstrainSelectedInstOperands,
     /*  368057 */     // GIR_Coverage, 60634,
     /*  368057 */     GIR_EraseRootFromParent_Done,
     /*  368058 */   // Label 6678: @368058
     /*  368058 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(368124), // Rule ID 60635 //
     /*  368063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  368074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  368077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  368080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368102 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  368102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  368105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368122 */     GIR_RootConstrainSelectedInstOperands,
     /*  368123 */     // GIR_Coverage, 60635,
     /*  368123 */     GIR_EraseRootFromParent_Done,
     /*  368124 */   // Label 6679: @368124
     /*  368124 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(368190), // Rule ID 60638 //
     /*  368129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  368140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  368143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  368146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368168 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368188 */     GIR_RootConstrainSelectedInstOperands,
     /*  368189 */     // GIR_Coverage, 60638,
     /*  368189 */     GIR_EraseRootFromParent_Done,
     /*  368190 */   // Label 6680: @368190
     /*  368190 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(368256), // Rule ID 60639 //
     /*  368195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  368206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  368209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  368212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368234 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  368234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368254 */     GIR_RootConstrainSelectedInstOperands,
     /*  368255 */     // GIR_Coverage, 60639,
     /*  368255 */     GIR_EraseRootFromParent_Done,
     /*  368256 */   // Label 6681: @368256
     /*  368256 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(368322), // Rule ID 60642 //
     /*  368261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  368272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  368275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  368278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368300 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  368300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368320 */     GIR_RootConstrainSelectedInstOperands,
     /*  368321 */     // GIR_Coverage, 60642,
     /*  368321 */     GIR_EraseRootFromParent_Done,
     /*  368322 */   // Label 6682: @368322
     /*  368322 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(368388), // Rule ID 60643 //
     /*  368327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  368338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  368341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  368344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368366 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  368366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368386 */     GIR_RootConstrainSelectedInstOperands,
     /*  368387 */     // GIR_Coverage, 60643,
     /*  368387 */     GIR_EraseRootFromParent_Done,
     /*  368388 */   // Label 6683: @368388
     /*  368388 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(368454), // Rule ID 60646 //
     /*  368393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  368404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  368407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  368410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368452 */     GIR_RootConstrainSelectedInstOperands,
     /*  368453 */     // GIR_Coverage, 60646,
     /*  368453 */     GIR_EraseRootFromParent_Done,
     /*  368454 */   // Label 6684: @368454
     /*  368454 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(368520), // Rule ID 60647 //
     /*  368459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  368470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  368473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  368476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368498 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368518 */     GIR_RootConstrainSelectedInstOperands,
     /*  368519 */     // GIR_Coverage, 60647,
     /*  368519 */     GIR_EraseRootFromParent_Done,
     /*  368520 */   // Label 6685: @368520
     /*  368520 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(368586), // Rule ID 60650 //
     /*  368525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  368536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  368539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  368542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368564 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368584 */     GIR_RootConstrainSelectedInstOperands,
     /*  368585 */     // GIR_Coverage, 60650,
     /*  368585 */     GIR_EraseRootFromParent_Done,
     /*  368586 */   // Label 6686: @368586
     /*  368586 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(368652), // Rule ID 60651 //
     /*  368591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  368602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  368605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  368608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368630 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  368630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368650 */     GIR_RootConstrainSelectedInstOperands,
     /*  368651 */     // GIR_Coverage, 60651,
     /*  368651 */     GIR_EraseRootFromParent_Done,
     /*  368652 */   // Label 6687: @368652
     /*  368652 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(368718), // Rule ID 60654 //
     /*  368657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  368668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  368671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  368674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  368696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368716 */     GIR_RootConstrainSelectedInstOperands,
     /*  368717 */     // GIR_Coverage, 60654,
     /*  368717 */     GIR_EraseRootFromParent_Done,
     /*  368718 */   // Label 6688: @368718
     /*  368718 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(368784), // Rule ID 60655 //
     /*  368723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  368734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  368737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  368740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368762 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  368762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368782 */     GIR_RootConstrainSelectedInstOperands,
     /*  368783 */     // GIR_Coverage, 60655,
     /*  368783 */     GIR_EraseRootFromParent_Done,
     /*  368784 */   // Label 6689: @368784
     /*  368784 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(368850), // Rule ID 60658 //
     /*  368789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  368800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  368803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  368806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368828 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  368828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  368845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368848 */     GIR_RootConstrainSelectedInstOperands,
     /*  368849 */     // GIR_Coverage, 60658,
     /*  368849 */     GIR_EraseRootFromParent_Done,
     /*  368850 */   // Label 6690: @368850
     /*  368850 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(368916), // Rule ID 60659 //
     /*  368855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  368866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  368869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  368872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368894 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  368894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  368911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368914 */     GIR_RootConstrainSelectedInstOperands,
     /*  368915 */     // GIR_Coverage, 60659,
     /*  368915 */     GIR_EraseRootFromParent_Done,
     /*  368916 */   // Label 6691: @368916
     /*  368916 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(368982), // Rule ID 60662 //
     /*  368921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  368932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  368935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  368938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  368963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368980 */     GIR_RootConstrainSelectedInstOperands,
     /*  368981 */     // GIR_Coverage, 60662,
     /*  368981 */     GIR_EraseRootFromParent_Done,
     /*  368982 */   // Label 6692: @368982
     /*  368982 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(369048), // Rule ID 60663 //
     /*  368987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  368998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  369001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  369004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369046 */     GIR_RootConstrainSelectedInstOperands,
     /*  369047 */     // GIR_Coverage, 60663,
     /*  369047 */     GIR_EraseRootFromParent_Done,
     /*  369048 */   // Label 6693: @369048
     /*  369048 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(369114), // Rule ID 60666 //
     /*  369053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  369064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  369067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  369070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369092 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369112 */     GIR_RootConstrainSelectedInstOperands,
     /*  369113 */     // GIR_Coverage, 60666,
     /*  369113 */     GIR_EraseRootFromParent_Done,
     /*  369114 */   // Label 6694: @369114
     /*  369114 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(369180), // Rule ID 60667 //
     /*  369119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  369130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  369133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  369136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369158 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369178 */     GIR_RootConstrainSelectedInstOperands,
     /*  369179 */     // GIR_Coverage, 60667,
     /*  369179 */     GIR_EraseRootFromParent_Done,
     /*  369180 */   // Label 6695: @369180
     /*  369180 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(369246), // Rule ID 60670 //
     /*  369185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  369196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  369199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  369202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369224 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369244 */     GIR_RootConstrainSelectedInstOperands,
     /*  369245 */     // GIR_Coverage, 60670,
     /*  369245 */     GIR_EraseRootFromParent_Done,
     /*  369246 */   // Label 6696: @369246
     /*  369246 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(369312), // Rule ID 60671 //
     /*  369251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  369262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  369265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  369268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369290 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369310 */     GIR_RootConstrainSelectedInstOperands,
     /*  369311 */     // GIR_Coverage, 60671,
     /*  369311 */     GIR_EraseRootFromParent_Done,
     /*  369312 */   // Label 6697: @369312
     /*  369312 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(369378), // Rule ID 60674 //
     /*  369317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  369328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  369331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  369334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369356 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369376 */     GIR_RootConstrainSelectedInstOperands,
     /*  369377 */     // GIR_Coverage, 60674,
     /*  369377 */     GIR_EraseRootFromParent_Done,
     /*  369378 */   // Label 6698: @369378
     /*  369378 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(369444), // Rule ID 60675 //
     /*  369383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  369394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  369397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  369400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369422 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369442 */     GIR_RootConstrainSelectedInstOperands,
     /*  369443 */     // GIR_Coverage, 60675,
     /*  369443 */     GIR_EraseRootFromParent_Done,
     /*  369444 */   // Label 6699: @369444
     /*  369444 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(369510), // Rule ID 60678 //
     /*  369449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  369460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  369463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  369466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369488 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369508 */     GIR_RootConstrainSelectedInstOperands,
     /*  369509 */     // GIR_Coverage, 60678,
     /*  369509 */     GIR_EraseRootFromParent_Done,
     /*  369510 */   // Label 6700: @369510
     /*  369510 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(369576), // Rule ID 60679 //
     /*  369515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  369526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  369529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  369532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369554 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369574 */     GIR_RootConstrainSelectedInstOperands,
     /*  369575 */     // GIR_Coverage, 60679,
     /*  369575 */     GIR_EraseRootFromParent_Done,
     /*  369576 */   // Label 6701: @369576
     /*  369576 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(369642), // Rule ID 60682 //
     /*  369581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  369592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  369595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  369598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369620 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369640 */     GIR_RootConstrainSelectedInstOperands,
     /*  369641 */     // GIR_Coverage, 60682,
     /*  369641 */     GIR_EraseRootFromParent_Done,
     /*  369642 */   // Label 6702: @369642
     /*  369642 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(369708), // Rule ID 60683 //
     /*  369647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  369658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  369661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  369664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369686 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369706 */     GIR_RootConstrainSelectedInstOperands,
     /*  369707 */     // GIR_Coverage, 60683,
     /*  369707 */     GIR_EraseRootFromParent_Done,
     /*  369708 */   // Label 6703: @369708
     /*  369708 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(369774), // Rule ID 60686 //
     /*  369713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  369724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  369727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  369730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  369752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369772 */     GIR_RootConstrainSelectedInstOperands,
     /*  369773 */     // GIR_Coverage, 60686,
     /*  369773 */     GIR_EraseRootFromParent_Done,
     /*  369774 */   // Label 6704: @369774
     /*  369774 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(369840), // Rule ID 60687 //
     /*  369779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  369790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  369793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  369796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  369818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369838 */     GIR_RootConstrainSelectedInstOperands,
     /*  369839 */     // GIR_Coverage, 60687,
     /*  369839 */     GIR_EraseRootFromParent_Done,
     /*  369840 */   // Label 6705: @369840
     /*  369840 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(369906), // Rule ID 60690 //
     /*  369845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  369856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  369859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  369862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  369884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369904 */     GIR_RootConstrainSelectedInstOperands,
     /*  369905 */     // GIR_Coverage, 60690,
     /*  369905 */     GIR_EraseRootFromParent_Done,
     /*  369906 */   // Label 6706: @369906
     /*  369906 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(369972), // Rule ID 60691 //
     /*  369911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  369922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  369925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  369928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369950 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  369950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369970 */     GIR_RootConstrainSelectedInstOperands,
     /*  369971 */     // GIR_Coverage, 60691,
     /*  369971 */     GIR_EraseRootFromParent_Done,
     /*  369972 */   // Label 6707: @369972
     /*  369972 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(370038), // Rule ID 60694 //
     /*  369977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  369988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  369991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  369994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370036 */     GIR_RootConstrainSelectedInstOperands,
     /*  370037 */     // GIR_Coverage, 60694,
     /*  370037 */     GIR_EraseRootFromParent_Done,
     /*  370038 */   // Label 6708: @370038
     /*  370038 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(370104), // Rule ID 60695 //
     /*  370043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  370054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  370057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  370060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370082 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370102 */     GIR_RootConstrainSelectedInstOperands,
     /*  370103 */     // GIR_Coverage, 60695,
     /*  370103 */     GIR_EraseRootFromParent_Done,
     /*  370104 */   // Label 6709: @370104
     /*  370104 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(370170), // Rule ID 60698 //
     /*  370109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  370120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  370123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  370126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370148 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  370148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  370151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370168 */     GIR_RootConstrainSelectedInstOperands,
     /*  370169 */     // GIR_Coverage, 60698,
     /*  370169 */     GIR_EraseRootFromParent_Done,
     /*  370170 */   // Label 6710: @370170
     /*  370170 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(370236), // Rule ID 60699 //
     /*  370175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  370186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  370189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  370192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  370214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  370217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370234 */     GIR_RootConstrainSelectedInstOperands,
     /*  370235 */     // GIR_Coverage, 60699,
     /*  370235 */     GIR_EraseRootFromParent_Done,
     /*  370236 */   // Label 6711: @370236
     /*  370236 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(370302), // Rule ID 60702 //
     /*  370241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  370252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  370255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  370258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370280 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  370280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370300 */     GIR_RootConstrainSelectedInstOperands,
     /*  370301 */     // GIR_Coverage, 60702,
     /*  370301 */     GIR_EraseRootFromParent_Done,
     /*  370302 */   // Label 6712: @370302
     /*  370302 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(370368), // Rule ID 60703 //
     /*  370307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  370318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  370321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  370324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370346 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  370346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370366 */     GIR_RootConstrainSelectedInstOperands,
     /*  370367 */     // GIR_Coverage, 60703,
     /*  370367 */     GIR_EraseRootFromParent_Done,
     /*  370368 */   // Label 6713: @370368
     /*  370368 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(370434), // Rule ID 60706 //
     /*  370373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  370384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  370387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  370390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370412 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  370412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370432 */     GIR_RootConstrainSelectedInstOperands,
     /*  370433 */     // GIR_Coverage, 60706,
     /*  370433 */     GIR_EraseRootFromParent_Done,
     /*  370434 */   // Label 6714: @370434
     /*  370434 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(370500), // Rule ID 60707 //
     /*  370439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  370450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  370453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  370456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370478 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  370478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370498 */     GIR_RootConstrainSelectedInstOperands,
     /*  370499 */     // GIR_Coverage, 60707,
     /*  370499 */     GIR_EraseRootFromParent_Done,
     /*  370500 */   // Label 6715: @370500
     /*  370500 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(370566), // Rule ID 60710 //
     /*  370505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  370516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  370519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  370522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  370547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370564 */     GIR_RootConstrainSelectedInstOperands,
     /*  370565 */     // GIR_Coverage, 60710,
     /*  370565 */     GIR_EraseRootFromParent_Done,
     /*  370566 */   // Label 6716: @370566
     /*  370566 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(370632), // Rule ID 60711 //
     /*  370571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  370582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  370585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  370588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370610 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  370613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370630 */     GIR_RootConstrainSelectedInstOperands,
     /*  370631 */     // GIR_Coverage, 60711,
     /*  370631 */     GIR_EraseRootFromParent_Done,
     /*  370632 */   // Label 6717: @370632
     /*  370632 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(370698), // Rule ID 60714 //
     /*  370637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  370648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  370651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  370654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370676 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  370679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370696 */     GIR_RootConstrainSelectedInstOperands,
     /*  370697 */     // GIR_Coverage, 60714,
     /*  370697 */     GIR_EraseRootFromParent_Done,
     /*  370698 */   // Label 6718: @370698
     /*  370698 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(370764), // Rule ID 60715 //
     /*  370703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  370714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  370717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  370720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370742 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  370745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370762 */     GIR_RootConstrainSelectedInstOperands,
     /*  370763 */     // GIR_Coverage, 60715,
     /*  370763 */     GIR_EraseRootFromParent_Done,
     /*  370764 */   // Label 6719: @370764
     /*  370764 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(370830), // Rule ID 60718 //
     /*  370769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  370780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  370783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  370786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370808 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  370811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370828 */     GIR_RootConstrainSelectedInstOperands,
     /*  370829 */     // GIR_Coverage, 60718,
     /*  370829 */     GIR_EraseRootFromParent_Done,
     /*  370830 */   // Label 6720: @370830
     /*  370830 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(370896), // Rule ID 60719 //
     /*  370835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  370846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  370849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  370852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370874 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  370877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370894 */     GIR_RootConstrainSelectedInstOperands,
     /*  370895 */     // GIR_Coverage, 60719,
     /*  370895 */     GIR_EraseRootFromParent_Done,
     /*  370896 */   // Label 6721: @370896
     /*  370896 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(370962), // Rule ID 60722 //
     /*  370901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  370912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  370915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  370918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370940 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  370943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370960 */     GIR_RootConstrainSelectedInstOperands,
     /*  370961 */     // GIR_Coverage, 60722,
     /*  370961 */     GIR_EraseRootFromParent_Done,
     /*  370962 */   // Label 6722: @370962
     /*  370962 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(371028), // Rule ID 60723 //
     /*  370967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  370978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  370981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  370984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371006 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  371009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371026 */     GIR_RootConstrainSelectedInstOperands,
     /*  371027 */     // GIR_Coverage, 60723,
     /*  371027 */     GIR_EraseRootFromParent_Done,
     /*  371028 */   // Label 6723: @371028
     /*  371028 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(371094), // Rule ID 60726 //
     /*  371033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  371044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  371047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  371050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371072 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371092 */     GIR_RootConstrainSelectedInstOperands,
     /*  371093 */     // GIR_Coverage, 60726,
     /*  371093 */     GIR_EraseRootFromParent_Done,
     /*  371094 */   // Label 6724: @371094
     /*  371094 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(371160), // Rule ID 60727 //
     /*  371099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  371110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  371113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  371116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371138 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371158 */     GIR_RootConstrainSelectedInstOperands,
     /*  371159 */     // GIR_Coverage, 60727,
     /*  371159 */     GIR_EraseRootFromParent_Done,
     /*  371160 */   // Label 6725: @371160
     /*  371160 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(371226), // Rule ID 60730 //
     /*  371165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  371176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  371179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  371182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371204 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  371204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371224 */     GIR_RootConstrainSelectedInstOperands,
     /*  371225 */     // GIR_Coverage, 60730,
     /*  371225 */     GIR_EraseRootFromParent_Done,
     /*  371226 */   // Label 6726: @371226
     /*  371226 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(371292), // Rule ID 60731 //
     /*  371231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  371242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  371245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  371248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371270 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  371270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371290 */     GIR_RootConstrainSelectedInstOperands,
     /*  371291 */     // GIR_Coverage, 60731,
     /*  371291 */     GIR_EraseRootFromParent_Done,
     /*  371292 */   // Label 6727: @371292
     /*  371292 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(371358), // Rule ID 60734 //
     /*  371297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  371308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  371311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  371314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371336 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371356 */     GIR_RootConstrainSelectedInstOperands,
     /*  371357 */     // GIR_Coverage, 60734,
     /*  371357 */     GIR_EraseRootFromParent_Done,
     /*  371358 */   // Label 6728: @371358
     /*  371358 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(371424), // Rule ID 60735 //
     /*  371363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  371374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  371377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  371380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371402 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371422 */     GIR_RootConstrainSelectedInstOperands,
     /*  371423 */     // GIR_Coverage, 60735,
     /*  371423 */     GIR_EraseRootFromParent_Done,
     /*  371424 */   // Label 6729: @371424
     /*  371424 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(371490), // Rule ID 60738 //
     /*  371429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  371440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  371443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  371446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371468 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371488 */     GIR_RootConstrainSelectedInstOperands,
     /*  371489 */     // GIR_Coverage, 60738,
     /*  371489 */     GIR_EraseRootFromParent_Done,
     /*  371490 */   // Label 6730: @371490
     /*  371490 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(371556), // Rule ID 60739 //
     /*  371495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  371506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  371509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  371512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371534 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371554 */     GIR_RootConstrainSelectedInstOperands,
     /*  371555 */     // GIR_Coverage, 60739,
     /*  371555 */     GIR_EraseRootFromParent_Done,
     /*  371556 */   // Label 6731: @371556
     /*  371556 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(371622), // Rule ID 60742 //
     /*  371561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  371572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  371575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  371578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  371600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371620 */     GIR_RootConstrainSelectedInstOperands,
     /*  371621 */     // GIR_Coverage, 60742,
     /*  371621 */     GIR_EraseRootFromParent_Done,
     /*  371622 */   // Label 6732: @371622
     /*  371622 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(371688), // Rule ID 60743 //
     /*  371627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  371638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  371641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  371644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371666 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  371666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371686 */     GIR_RootConstrainSelectedInstOperands,
     /*  371687 */     // GIR_Coverage, 60743,
     /*  371687 */     GIR_EraseRootFromParent_Done,
     /*  371688 */   // Label 6733: @371688
     /*  371688 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(371754), // Rule ID 60746 //
     /*  371693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  371704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  371707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  371710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371732 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  371732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371752 */     GIR_RootConstrainSelectedInstOperands,
     /*  371753 */     // GIR_Coverage, 60746,
     /*  371753 */     GIR_EraseRootFromParent_Done,
     /*  371754 */   // Label 6734: @371754
     /*  371754 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(371820), // Rule ID 60747 //
     /*  371759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  371770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  371773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  371776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371798 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  371798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371818 */     GIR_RootConstrainSelectedInstOperands,
     /*  371819 */     // GIR_Coverage, 60747,
     /*  371819 */     GIR_EraseRootFromParent_Done,
     /*  371820 */   // Label 6735: @371820
     /*  371820 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(371886), // Rule ID 60750 //
     /*  371825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  371836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  371839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  371842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  371867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371884 */     GIR_RootConstrainSelectedInstOperands,
     /*  371885 */     // GIR_Coverage, 60750,
     /*  371885 */     GIR_EraseRootFromParent_Done,
     /*  371886 */   // Label 6736: @371886
     /*  371886 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(371952), // Rule ID 60751 //
     /*  371891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  371902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  371905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  371908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371930 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  371933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371950 */     GIR_RootConstrainSelectedInstOperands,
     /*  371951 */     // GIR_Coverage, 60751,
     /*  371951 */     GIR_EraseRootFromParent_Done,
     /*  371952 */   // Label 6737: @371952
     /*  371952 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(372018), // Rule ID 60754 //
     /*  371957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  371968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  371971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  371974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371996 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  371999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372016 */     GIR_RootConstrainSelectedInstOperands,
     /*  372017 */     // GIR_Coverage, 60754,
     /*  372017 */     GIR_EraseRootFromParent_Done,
     /*  372018 */   // Label 6738: @372018
     /*  372018 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(372084), // Rule ID 60755 //
     /*  372023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  372034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  372037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  372040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372062 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372082 */     GIR_RootConstrainSelectedInstOperands,
     /*  372083 */     // GIR_Coverage, 60755,
     /*  372083 */     GIR_EraseRootFromParent_Done,
     /*  372084 */   // Label 6739: @372084
     /*  372084 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(372150), // Rule ID 60758 //
     /*  372089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  372100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  372103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  372106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372128 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372148 */     GIR_RootConstrainSelectedInstOperands,
     /*  372149 */     // GIR_Coverage, 60758,
     /*  372149 */     GIR_EraseRootFromParent_Done,
     /*  372150 */   // Label 6740: @372150
     /*  372150 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(372216), // Rule ID 60759 //
     /*  372155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  372166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  372169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  372172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372194 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372214 */     GIR_RootConstrainSelectedInstOperands,
     /*  372215 */     // GIR_Coverage, 60759,
     /*  372215 */     GIR_EraseRootFromParent_Done,
     /*  372216 */   // Label 6741: @372216
     /*  372216 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(372282), // Rule ID 60762 //
     /*  372221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  372232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  372235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  372238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372260 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372280 */     GIR_RootConstrainSelectedInstOperands,
     /*  372281 */     // GIR_Coverage, 60762,
     /*  372281 */     GIR_EraseRootFromParent_Done,
     /*  372282 */   // Label 6742: @372282
     /*  372282 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(372348), // Rule ID 60763 //
     /*  372287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  372298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  372301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  372304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372346 */     GIR_RootConstrainSelectedInstOperands,
     /*  372347 */     // GIR_Coverage, 60763,
     /*  372347 */     GIR_EraseRootFromParent_Done,
     /*  372348 */   // Label 6743: @372348
     /*  372348 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(372414), // Rule ID 60766 //
     /*  372353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  372364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  372367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  372370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372392 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372412 */     GIR_RootConstrainSelectedInstOperands,
     /*  372413 */     // GIR_Coverage, 60766,
     /*  372413 */     GIR_EraseRootFromParent_Done,
     /*  372414 */   // Label 6744: @372414
     /*  372414 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(372480), // Rule ID 60767 //
     /*  372419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  372430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  372433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  372436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372458 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372478 */     GIR_RootConstrainSelectedInstOperands,
     /*  372479 */     // GIR_Coverage, 60767,
     /*  372479 */     GIR_EraseRootFromParent_Done,
     /*  372480 */   // Label 6745: @372480
     /*  372480 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(372546), // Rule ID 60770 //
     /*  372485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  372496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  372499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  372502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372524 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372544 */     GIR_RootConstrainSelectedInstOperands,
     /*  372545 */     // GIR_Coverage, 60770,
     /*  372545 */     GIR_EraseRootFromParent_Done,
     /*  372546 */   // Label 6746: @372546
     /*  372546 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(372612), // Rule ID 60771 //
     /*  372551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  372562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  372565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  372568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372590 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372610 */     GIR_RootConstrainSelectedInstOperands,
     /*  372611 */     // GIR_Coverage, 60771,
     /*  372611 */     GIR_EraseRootFromParent_Done,
     /*  372612 */   // Label 6747: @372612
     /*  372612 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(372678), // Rule ID 60774 //
     /*  372617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  372628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  372631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  372634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372676 */     GIR_RootConstrainSelectedInstOperands,
     /*  372677 */     // GIR_Coverage, 60774,
     /*  372677 */     GIR_EraseRootFromParent_Done,
     /*  372678 */   // Label 6748: @372678
     /*  372678 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(372744), // Rule ID 60775 //
     /*  372683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  372694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  372697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  372700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372742 */     GIR_RootConstrainSelectedInstOperands,
     /*  372743 */     // GIR_Coverage, 60775,
     /*  372743 */     GIR_EraseRootFromParent_Done,
     /*  372744 */   // Label 6749: @372744
     /*  372744 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(372810), // Rule ID 60778 //
     /*  372749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  372760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  372763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  372766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372788 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372808 */     GIR_RootConstrainSelectedInstOperands,
     /*  372809 */     // GIR_Coverage, 60778,
     /*  372809 */     GIR_EraseRootFromParent_Done,
     /*  372810 */   // Label 6750: @372810
     /*  372810 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(372876), // Rule ID 60779 //
     /*  372815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  372826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  372829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  372832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372854 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372874 */     GIR_RootConstrainSelectedInstOperands,
     /*  372875 */     // GIR_Coverage, 60779,
     /*  372875 */     GIR_EraseRootFromParent_Done,
     /*  372876 */   // Label 6751: @372876
     /*  372876 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(372942), // Rule ID 60782 //
     /*  372881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  372892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  372895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  372898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372920 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372940 */     GIR_RootConstrainSelectedInstOperands,
     /*  372941 */     // GIR_Coverage, 60782,
     /*  372941 */     GIR_EraseRootFromParent_Done,
     /*  372942 */   // Label 6752: @372942
     /*  372942 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(373008), // Rule ID 60783 //
     /*  372947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  372958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  372961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  372964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372986 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373006 */     GIR_RootConstrainSelectedInstOperands,
     /*  373007 */     // GIR_Coverage, 60783,
     /*  373007 */     GIR_EraseRootFromParent_Done,
     /*  373008 */   // Label 6753: @373008
     /*  373008 */   GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(373074), // Rule ID 60786 //
     /*  373013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  373024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  373027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  373030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373052 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  373055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373072 */     GIR_RootConstrainSelectedInstOperands,
     /*  373073 */     // GIR_Coverage, 60786,
     /*  373073 */     GIR_EraseRootFromParent_Done,
     /*  373074 */   // Label 6754: @373074
     /*  373074 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(373140), // Rule ID 60787 //
     /*  373079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  373090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  373093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  373096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373118 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  373118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  373121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373138 */     GIR_RootConstrainSelectedInstOperands,
     /*  373139 */     // GIR_Coverage, 60787,
     /*  373139 */     GIR_EraseRootFromParent_Done,
     /*  373140 */   // Label 6755: @373140
     /*  373140 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(373206), // Rule ID 60790 //
     /*  373145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  373156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  373159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  373162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373184 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  373187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373204 */     GIR_RootConstrainSelectedInstOperands,
     /*  373205 */     // GIR_Coverage, 60790,
     /*  373205 */     GIR_EraseRootFromParent_Done,
     /*  373206 */   // Label 6756: @373206
     /*  373206 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(373272), // Rule ID 60791 //
     /*  373211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  373222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  373225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  373228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373250 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  373250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  373253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373270 */     GIR_RootConstrainSelectedInstOperands,
     /*  373271 */     // GIR_Coverage, 60791,
     /*  373271 */     GIR_EraseRootFromParent_Done,
     /*  373272 */   // Label 6757: @373272
     /*  373272 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(373338), // Rule ID 60794 //
     /*  373277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  373288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  373291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  373294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373316 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373336 */     GIR_RootConstrainSelectedInstOperands,
     /*  373337 */     // GIR_Coverage, 60794,
     /*  373337 */     GIR_EraseRootFromParent_Done,
     /*  373338 */   // Label 6758: @373338
     /*  373338 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(373404), // Rule ID 60795 //
     /*  373343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  373354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  373357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  373360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373382 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  373382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373402 */     GIR_RootConstrainSelectedInstOperands,
     /*  373403 */     // GIR_Coverage, 60795,
     /*  373403 */     GIR_EraseRootFromParent_Done,
     /*  373404 */   // Label 6759: @373404
     /*  373404 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(373470), // Rule ID 60798 //
     /*  373409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  373420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  373423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  373426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373448 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  373451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373468 */     GIR_RootConstrainSelectedInstOperands,
     /*  373469 */     // GIR_Coverage, 60798,
     /*  373469 */     GIR_EraseRootFromParent_Done,
     /*  373470 */   // Label 6760: @373470
     /*  373470 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(373536), // Rule ID 60799 //
     /*  373475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  373486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  373489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  373492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373514 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  373517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373534 */     GIR_RootConstrainSelectedInstOperands,
     /*  373535 */     // GIR_Coverage, 60799,
     /*  373535 */     GIR_EraseRootFromParent_Done,
     /*  373536 */   // Label 6761: @373536
     /*  373536 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(373602), // Rule ID 60802 //
     /*  373541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  373552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  373555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  373558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373580 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  373583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373600 */     GIR_RootConstrainSelectedInstOperands,
     /*  373601 */     // GIR_Coverage, 60802,
     /*  373601 */     GIR_EraseRootFromParent_Done,
     /*  373602 */   // Label 6762: @373602
     /*  373602 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(373668), // Rule ID 60803 //
     /*  373607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  373618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  373621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  373624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373646 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  373649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373666 */     GIR_RootConstrainSelectedInstOperands,
     /*  373667 */     // GIR_Coverage, 60803,
     /*  373667 */     GIR_EraseRootFromParent_Done,
     /*  373668 */   // Label 6763: @373668
     /*  373668 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(373734), // Rule ID 60806 //
     /*  373673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  373684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  373687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  373690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373712 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  373715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373732 */     GIR_RootConstrainSelectedInstOperands,
     /*  373733 */     // GIR_Coverage, 60806,
     /*  373733 */     GIR_EraseRootFromParent_Done,
     /*  373734 */   // Label 6764: @373734
     /*  373734 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(373800), // Rule ID 60807 //
     /*  373739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  373750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  373753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  373756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373778 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  373781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373798 */     GIR_RootConstrainSelectedInstOperands,
     /*  373799 */     // GIR_Coverage, 60807,
     /*  373799 */     GIR_EraseRootFromParent_Done,
     /*  373800 */   // Label 6765: @373800
     /*  373800 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(373866), // Rule ID 60810 //
     /*  373805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  373816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  373819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  373822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373844 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  373847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373864 */     GIR_RootConstrainSelectedInstOperands,
     /*  373865 */     // GIR_Coverage, 60810,
     /*  373865 */     GIR_EraseRootFromParent_Done,
     /*  373866 */   // Label 6766: @373866
     /*  373866 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(373932), // Rule ID 60811 //
     /*  373871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  373882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  373885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  373888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373910 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  373913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373930 */     GIR_RootConstrainSelectedInstOperands,
     /*  373931 */     // GIR_Coverage, 60811,
     /*  373931 */     GIR_EraseRootFromParent_Done,
     /*  373932 */   // Label 6767: @373932
     /*  373932 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(373998), // Rule ID 60814 //
     /*  373937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  373948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  373951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  373954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373976 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  373979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373996 */     GIR_RootConstrainSelectedInstOperands,
     /*  373997 */     // GIR_Coverage, 60814,
     /*  373997 */     GIR_EraseRootFromParent_Done,
     /*  373998 */   // Label 6768: @373998
     /*  373998 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(374064), // Rule ID 60815 //
     /*  374003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  374014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  374017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  374020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374042 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374062 */     GIR_RootConstrainSelectedInstOperands,
     /*  374063 */     // GIR_Coverage, 60815,
     /*  374063 */     GIR_EraseRootFromParent_Done,
     /*  374064 */   // Label 6769: @374064
     /*  374064 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(374130), // Rule ID 60818 //
     /*  374069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  374080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  374083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  374086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  374108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374128 */     GIR_RootConstrainSelectedInstOperands,
     /*  374129 */     // GIR_Coverage, 60818,
     /*  374129 */     GIR_EraseRootFromParent_Done,
     /*  374130 */   // Label 6770: @374130
     /*  374130 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(374196), // Rule ID 60819 //
     /*  374135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  374146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  374149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  374152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374174 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  374174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374194 */     GIR_RootConstrainSelectedInstOperands,
     /*  374195 */     // GIR_Coverage, 60819,
     /*  374195 */     GIR_EraseRootFromParent_Done,
     /*  374196 */   // Label 6771: @374196
     /*  374196 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(374262), // Rule ID 60822 //
     /*  374201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  374212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  374215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  374218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374240 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374260 */     GIR_RootConstrainSelectedInstOperands,
     /*  374261 */     // GIR_Coverage, 60822,
     /*  374261 */     GIR_EraseRootFromParent_Done,
     /*  374262 */   // Label 6772: @374262
     /*  374262 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(374328), // Rule ID 60823 //
     /*  374267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  374278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  374281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  374284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374306 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374326 */     GIR_RootConstrainSelectedInstOperands,
     /*  374327 */     // GIR_Coverage, 60823,
     /*  374327 */     GIR_EraseRootFromParent_Done,
     /*  374328 */   // Label 6773: @374328
     /*  374328 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(374394), // Rule ID 60826 //
     /*  374333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  374344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  374347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  374350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374372 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374392 */     GIR_RootConstrainSelectedInstOperands,
     /*  374393 */     // GIR_Coverage, 60826,
     /*  374393 */     GIR_EraseRootFromParent_Done,
     /*  374394 */   // Label 6774: @374394
     /*  374394 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(374460), // Rule ID 60827 //
     /*  374399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  374410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  374413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  374416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374438 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374458 */     GIR_RootConstrainSelectedInstOperands,
     /*  374459 */     // GIR_Coverage, 60827,
     /*  374459 */     GIR_EraseRootFromParent_Done,
     /*  374460 */   // Label 6775: @374460
     /*  374460 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(374526), // Rule ID 60830 //
     /*  374465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  374476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  374479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  374482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374504 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  374504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374524 */     GIR_RootConstrainSelectedInstOperands,
     /*  374525 */     // GIR_Coverage, 60830,
     /*  374525 */     GIR_EraseRootFromParent_Done,
     /*  374526 */   // Label 6776: @374526
     /*  374526 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(374592), // Rule ID 60831 //
     /*  374531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  374542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  374545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  374548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  374570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374590 */     GIR_RootConstrainSelectedInstOperands,
     /*  374591 */     // GIR_Coverage, 60831,
     /*  374591 */     GIR_EraseRootFromParent_Done,
     /*  374592 */   // Label 6777: @374592
     /*  374592 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(374658), // Rule ID 60834 //
     /*  374597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  374608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  374611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  374614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  374636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374656 */     GIR_RootConstrainSelectedInstOperands,
     /*  374657 */     // GIR_Coverage, 60834,
     /*  374657 */     GIR_EraseRootFromParent_Done,
     /*  374658 */   // Label 6778: @374658
     /*  374658 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(374724), // Rule ID 60835 //
     /*  374663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  374674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  374677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  374680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  374702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374722 */     GIR_RootConstrainSelectedInstOperands,
     /*  374723 */     // GIR_Coverage, 60835,
     /*  374723 */     GIR_EraseRootFromParent_Done,
     /*  374724 */   // Label 6779: @374724
     /*  374724 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(374790), // Rule ID 60838 //
     /*  374729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  374740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  374743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  374746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374768 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  374771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374788 */     GIR_RootConstrainSelectedInstOperands,
     /*  374789 */     // GIR_Coverage, 60838,
     /*  374789 */     GIR_EraseRootFromParent_Done,
     /*  374790 */   // Label 6780: @374790
     /*  374790 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(374856), // Rule ID 60839 //
     /*  374795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  374806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  374809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  374812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374834 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  374837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374854 */     GIR_RootConstrainSelectedInstOperands,
     /*  374855 */     // GIR_Coverage, 60839,
     /*  374855 */     GIR_EraseRootFromParent_Done,
     /*  374856 */   // Label 6781: @374856
     /*  374856 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(374922), // Rule ID 60842 //
     /*  374861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  374872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  374875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  374878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374900 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  374903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374920 */     GIR_RootConstrainSelectedInstOperands,
     /*  374921 */     // GIR_Coverage, 60842,
     /*  374921 */     GIR_EraseRootFromParent_Done,
     /*  374922 */   // Label 6782: @374922
     /*  374922 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(374988), // Rule ID 60843 //
     /*  374927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  374938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  374941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  374944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374966 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  374969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374986 */     GIR_RootConstrainSelectedInstOperands,
     /*  374987 */     // GIR_Coverage, 60843,
     /*  374987 */     GIR_EraseRootFromParent_Done,
     /*  374988 */   // Label 6783: @374988
     /*  374988 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(375054), // Rule ID 60846 //
     /*  374993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  375004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  375007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  375010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375032 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375052 */     GIR_RootConstrainSelectedInstOperands,
     /*  375053 */     // GIR_Coverage, 60846,
     /*  375053 */     GIR_EraseRootFromParent_Done,
     /*  375054 */   // Label 6784: @375054
     /*  375054 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(375120), // Rule ID 60847 //
     /*  375059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  375070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  375073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  375076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375098 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375118 */     GIR_RootConstrainSelectedInstOperands,
     /*  375119 */     // GIR_Coverage, 60847,
     /*  375119 */     GIR_EraseRootFromParent_Done,
     /*  375120 */   // Label 6785: @375120
     /*  375120 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(375186), // Rule ID 60850 //
     /*  375125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  375136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  375139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  375142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375164 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375184 */     GIR_RootConstrainSelectedInstOperands,
     /*  375185 */     // GIR_Coverage, 60850,
     /*  375185 */     GIR_EraseRootFromParent_Done,
     /*  375186 */   // Label 6786: @375186
     /*  375186 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(375252), // Rule ID 60851 //
     /*  375191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  375202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  375205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  375208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375230 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375250 */     GIR_RootConstrainSelectedInstOperands,
     /*  375251 */     // GIR_Coverage, 60851,
     /*  375251 */     GIR_EraseRootFromParent_Done,
     /*  375252 */   // Label 6787: @375252
     /*  375252 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(375318), // Rule ID 60854 //
     /*  375257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  375268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  375271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  375274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375316 */     GIR_RootConstrainSelectedInstOperands,
     /*  375317 */     // GIR_Coverage, 60854,
     /*  375317 */     GIR_EraseRootFromParent_Done,
     /*  375318 */   // Label 6788: @375318
     /*  375318 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(375384), // Rule ID 60855 //
     /*  375323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  375334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  375337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  375340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375362 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375382 */     GIR_RootConstrainSelectedInstOperands,
     /*  375383 */     // GIR_Coverage, 60855,
     /*  375383 */     GIR_EraseRootFromParent_Done,
     /*  375384 */   // Label 6789: @375384
     /*  375384 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(375450), // Rule ID 60858 //
     /*  375389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  375400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  375403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  375406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375428 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375448 */     GIR_RootConstrainSelectedInstOperands,
     /*  375449 */     // GIR_Coverage, 60858,
     /*  375449 */     GIR_EraseRootFromParent_Done,
     /*  375450 */   // Label 6790: @375450
     /*  375450 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(375516), // Rule ID 60859 //
     /*  375455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  375466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  375469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  375472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375494 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375514 */     GIR_RootConstrainSelectedInstOperands,
     /*  375515 */     // GIR_Coverage, 60859,
     /*  375515 */     GIR_EraseRootFromParent_Done,
     /*  375516 */   // Label 6791: @375516
     /*  375516 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(375582), // Rule ID 60862 //
     /*  375521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  375532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  375535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  375538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  375560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375580 */     GIR_RootConstrainSelectedInstOperands,
     /*  375581 */     // GIR_Coverage, 60862,
     /*  375581 */     GIR_EraseRootFromParent_Done,
     /*  375582 */   // Label 6792: @375582
     /*  375582 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(375648), // Rule ID 60863 //
     /*  375587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  375598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  375601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  375604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375646 */     GIR_RootConstrainSelectedInstOperands,
     /*  375647 */     // GIR_Coverage, 60863,
     /*  375647 */     GIR_EraseRootFromParent_Done,
     /*  375648 */   // Label 6793: @375648
     /*  375648 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(375714), // Rule ID 60866 //
     /*  375653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  375664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  375667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  375670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375692 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  375692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375712 */     GIR_RootConstrainSelectedInstOperands,
     /*  375713 */     // GIR_Coverage, 60866,
     /*  375713 */     GIR_EraseRootFromParent_Done,
     /*  375714 */   // Label 6794: @375714
     /*  375714 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(375780), // Rule ID 60867 //
     /*  375719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  375730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  375733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  375736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375758 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375778 */     GIR_RootConstrainSelectedInstOperands,
     /*  375779 */     // GIR_Coverage, 60867,
     /*  375779 */     GIR_EraseRootFromParent_Done,
     /*  375780 */   // Label 6795: @375780
     /*  375780 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(375846), // Rule ID 60870 //
     /*  375785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  375796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  375799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  375802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375824 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  375824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375844 */     GIR_RootConstrainSelectedInstOperands,
     /*  375845 */     // GIR_Coverage, 60870,
     /*  375845 */     GIR_EraseRootFromParent_Done,
     /*  375846 */   // Label 6796: @375846
     /*  375846 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(375912), // Rule ID 60871 //
     /*  375851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  375862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  375865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  375868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375910 */     GIR_RootConstrainSelectedInstOperands,
     /*  375911 */     // GIR_Coverage, 60871,
     /*  375911 */     GIR_EraseRootFromParent_Done,
     /*  375912 */   // Label 6797: @375912
     /*  375912 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(375978), // Rule ID 60874 //
     /*  375917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  375928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  375931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  375934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375956 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  375956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375976 */     GIR_RootConstrainSelectedInstOperands,
     /*  375977 */     // GIR_Coverage, 60874,
     /*  375977 */     GIR_EraseRootFromParent_Done,
     /*  375978 */   // Label 6798: @375978
     /*  375978 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(376044), // Rule ID 60875 //
     /*  375983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  375994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  375997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  376000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376022 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  376025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376042 */     GIR_RootConstrainSelectedInstOperands,
     /*  376043 */     // GIR_Coverage, 60875,
     /*  376043 */     GIR_EraseRootFromParent_Done,
     /*  376044 */   // Label 6799: @376044
     /*  376044 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(376110), // Rule ID 60878 //
     /*  376049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  376060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  376063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  376066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376088 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  376088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  376091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376108 */     GIR_RootConstrainSelectedInstOperands,
     /*  376109 */     // GIR_Coverage, 60878,
     /*  376109 */     GIR_EraseRootFromParent_Done,
     /*  376110 */   // Label 6800: @376110
     /*  376110 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(376176), // Rule ID 60879 //
     /*  376115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  376126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  376129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  376132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376154 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  376157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376174 */     GIR_RootConstrainSelectedInstOperands,
     /*  376175 */     // GIR_Coverage, 60879,
     /*  376175 */     GIR_EraseRootFromParent_Done,
     /*  376176 */   // Label 6801: @376176
     /*  376176 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(376242), // Rule ID 60882 //
     /*  376181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  376192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  376195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  376198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  376220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  376223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376240 */     GIR_RootConstrainSelectedInstOperands,
     /*  376241 */     // GIR_Coverage, 60882,
     /*  376241 */     GIR_EraseRootFromParent_Done,
     /*  376242 */   // Label 6802: @376242
     /*  376242 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(376308), // Rule ID 60883 //
     /*  376247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  376258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  376261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  376264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376286 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  376289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376306 */     GIR_RootConstrainSelectedInstOperands,
     /*  376307 */     // GIR_Coverage, 60883,
     /*  376307 */     GIR_EraseRootFromParent_Done,
     /*  376308 */   // Label 6803: @376308
     /*  376308 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(376374), // Rule ID 60886 //
     /*  376313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  376324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  376327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  376330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376352 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  376355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376372 */     GIR_RootConstrainSelectedInstOperands,
     /*  376373 */     // GIR_Coverage, 60886,
     /*  376373 */     GIR_EraseRootFromParent_Done,
     /*  376374 */   // Label 6804: @376374
     /*  376374 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(376440), // Rule ID 60887 //
     /*  376379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  376390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  376393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  376396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376418 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  376421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376438 */     GIR_RootConstrainSelectedInstOperands,
     /*  376439 */     // GIR_Coverage, 60887,
     /*  376439 */     GIR_EraseRootFromParent_Done,
     /*  376440 */   // Label 6805: @376440
     /*  376440 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(376506), // Rule ID 60890 //
     /*  376445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  376456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  376459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  376462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376484 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  376487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376504 */     GIR_RootConstrainSelectedInstOperands,
     /*  376505 */     // GIR_Coverage, 60890,
     /*  376505 */     GIR_EraseRootFromParent_Done,
     /*  376506 */   // Label 6806: @376506
     /*  376506 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(376572), // Rule ID 60891 //
     /*  376511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  376522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  376525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  376528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376550 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  376553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376570 */     GIR_RootConstrainSelectedInstOperands,
     /*  376571 */     // GIR_Coverage, 60891,
     /*  376571 */     GIR_EraseRootFromParent_Done,
     /*  376572 */   // Label 6807: @376572
     /*  376572 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(376638), // Rule ID 60894 //
     /*  376577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  376588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  376591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  376594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376616 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376636 */     GIR_RootConstrainSelectedInstOperands,
     /*  376637 */     // GIR_Coverage, 60894,
     /*  376637 */     GIR_EraseRootFromParent_Done,
     /*  376638 */   // Label 6808: @376638
     /*  376638 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(376704), // Rule ID 60895 //
     /*  376643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  376654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  376657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  376660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376682 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376702 */     GIR_RootConstrainSelectedInstOperands,
     /*  376703 */     // GIR_Coverage, 60895,
     /*  376703 */     GIR_EraseRootFromParent_Done,
     /*  376704 */   // Label 6809: @376704
     /*  376704 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(376770), // Rule ID 60898 //
     /*  376709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  376720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  376723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  376726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376748 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  376751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376768 */     GIR_RootConstrainSelectedInstOperands,
     /*  376769 */     // GIR_Coverage, 60898,
     /*  376769 */     GIR_EraseRootFromParent_Done,
     /*  376770 */   // Label 6810: @376770
     /*  376770 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(376836), // Rule ID 60899 //
     /*  376775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  376786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  376789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  376792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376814 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  376817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376834 */     GIR_RootConstrainSelectedInstOperands,
     /*  376835 */     // GIR_Coverage, 60899,
     /*  376835 */     GIR_EraseRootFromParent_Done,
     /*  376836 */   // Label 6811: @376836
     /*  376836 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(376902), // Rule ID 60902 //
     /*  376841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  376852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  376855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  376858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376880 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376900 */     GIR_RootConstrainSelectedInstOperands,
     /*  376901 */     // GIR_Coverage, 60902,
     /*  376901 */     GIR_EraseRootFromParent_Done,
     /*  376902 */   // Label 6812: @376902
     /*  376902 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(376968), // Rule ID 60903 //
     /*  376907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  376918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  376921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  376924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376946 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376966 */     GIR_RootConstrainSelectedInstOperands,
     /*  376967 */     // GIR_Coverage, 60903,
     /*  376967 */     GIR_EraseRootFromParent_Done,
     /*  376968 */   // Label 6813: @376968
     /*  376968 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(377034), // Rule ID 60906 //
     /*  376973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  376984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  376987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  376990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377012 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  377012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377032 */     GIR_RootConstrainSelectedInstOperands,
     /*  377033 */     // GIR_Coverage, 60906,
     /*  377033 */     GIR_EraseRootFromParent_Done,
     /*  377034 */   // Label 6814: @377034
     /*  377034 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(377100), // Rule ID 60907 //
     /*  377039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  377050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  377053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  377056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377078 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  377078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377098 */     GIR_RootConstrainSelectedInstOperands,
     /*  377099 */     // GIR_Coverage, 60907,
     /*  377099 */     GIR_EraseRootFromParent_Done,
     /*  377100 */   // Label 6815: @377100
     /*  377100 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(377166), // Rule ID 60910 //
     /*  377105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  377116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  377119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  377122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377144 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377164 */     GIR_RootConstrainSelectedInstOperands,
     /*  377165 */     // GIR_Coverage, 60910,
     /*  377165 */     GIR_EraseRootFromParent_Done,
     /*  377166 */   // Label 6816: @377166
     /*  377166 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(377232), // Rule ID 60911 //
     /*  377171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  377182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  377185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  377188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377210 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377230 */     GIR_RootConstrainSelectedInstOperands,
     /*  377231 */     // GIR_Coverage, 60911,
     /*  377231 */     GIR_EraseRootFromParent_Done,
     /*  377232 */   // Label 6817: @377232
     /*  377232 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(377298), // Rule ID 60914 //
     /*  377237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  377248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  377251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  377254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377296 */     GIR_RootConstrainSelectedInstOperands,
     /*  377297 */     // GIR_Coverage, 60914,
     /*  377297 */     GIR_EraseRootFromParent_Done,
     /*  377298 */   // Label 6818: @377298
     /*  377298 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(377364), // Rule ID 60915 //
     /*  377303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  377314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  377317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  377320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377362 */     GIR_RootConstrainSelectedInstOperands,
     /*  377363 */     // GIR_Coverage, 60915,
     /*  377363 */     GIR_EraseRootFromParent_Done,
     /*  377364 */   // Label 6819: @377364
     /*  377364 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(377430), // Rule ID 60918 //
     /*  377369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  377380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  377383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  377386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  377408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377428 */     GIR_RootConstrainSelectedInstOperands,
     /*  377429 */     // GIR_Coverage, 60918,
     /*  377429 */     GIR_EraseRootFromParent_Done,
     /*  377430 */   // Label 6820: @377430
     /*  377430 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(377496), // Rule ID 60919 //
     /*  377435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  377446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  377449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  377452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  377474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377494 */     GIR_RootConstrainSelectedInstOperands,
     /*  377495 */     // GIR_Coverage, 60919,
     /*  377495 */     GIR_EraseRootFromParent_Done,
     /*  377496 */   // Label 6821: @377496
     /*  377496 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(377562), // Rule ID 60922 //
     /*  377501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  377512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  377515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  377518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377540 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  377540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377560 */     GIR_RootConstrainSelectedInstOperands,
     /*  377561 */     // GIR_Coverage, 60922,
     /*  377561 */     GIR_EraseRootFromParent_Done,
     /*  377562 */   // Label 6822: @377562
     /*  377562 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(377628), // Rule ID 60923 //
     /*  377567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  377578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  377581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  377584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377606 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  377606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377626 */     GIR_RootConstrainSelectedInstOperands,
     /*  377627 */     // GIR_Coverage, 60923,
     /*  377627 */     GIR_EraseRootFromParent_Done,
     /*  377628 */   // Label 6823: @377628
     /*  377628 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(377694), // Rule ID 60926 //
     /*  377633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  377644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  377647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  377650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377672 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  377675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377692 */     GIR_RootConstrainSelectedInstOperands,
     /*  377693 */     // GIR_Coverage, 60926,
     /*  377693 */     GIR_EraseRootFromParent_Done,
     /*  377694 */   // Label 6824: @377694
     /*  377694 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(377760), // Rule ID 60927 //
     /*  377699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  377710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  377713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  377716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377738 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  377741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377758 */     GIR_RootConstrainSelectedInstOperands,
     /*  377759 */     // GIR_Coverage, 60927,
     /*  377759 */     GIR_EraseRootFromParent_Done,
     /*  377760 */   // Label 6825: @377760
     /*  377760 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(377826), // Rule ID 60930 //
     /*  377765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  377776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  377779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  377782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377804 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  377807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377824 */     GIR_RootConstrainSelectedInstOperands,
     /*  377825 */     // GIR_Coverage, 60930,
     /*  377825 */     GIR_EraseRootFromParent_Done,
     /*  377826 */   // Label 6826: @377826
     /*  377826 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(377892), // Rule ID 60931 //
     /*  377831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  377842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  377845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  377848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  377873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377890 */     GIR_RootConstrainSelectedInstOperands,
     /*  377891 */     // GIR_Coverage, 60931,
     /*  377891 */     GIR_EraseRootFromParent_Done,
     /*  377892 */   // Label 6827: @377892
     /*  377892 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(377958), // Rule ID 60934 //
     /*  377897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  377908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  377911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  377914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377936 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  377939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377956 */     GIR_RootConstrainSelectedInstOperands,
     /*  377957 */     // GIR_Coverage, 60934,
     /*  377957 */     GIR_EraseRootFromParent_Done,
     /*  377958 */   // Label 6828: @377958
     /*  377958 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(378024), // Rule ID 60935 //
     /*  377963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  377974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  377977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  377980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378002 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378022 */     GIR_RootConstrainSelectedInstOperands,
     /*  378023 */     // GIR_Coverage, 60935,
     /*  378023 */     GIR_EraseRootFromParent_Done,
     /*  378024 */   // Label 6829: @378024
     /*  378024 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(378090), // Rule ID 60938 //
     /*  378029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  378040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  378043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  378046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378088 */     GIR_RootConstrainSelectedInstOperands,
     /*  378089 */     // GIR_Coverage, 60938,
     /*  378089 */     GIR_EraseRootFromParent_Done,
     /*  378090 */   // Label 6830: @378090
     /*  378090 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(378156), // Rule ID 60939 //
     /*  378095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  378106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  378109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  378112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378134 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378154 */     GIR_RootConstrainSelectedInstOperands,
     /*  378155 */     // GIR_Coverage, 60939,
     /*  378155 */     GIR_EraseRootFromParent_Done,
     /*  378156 */   // Label 6831: @378156
     /*  378156 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(378222), // Rule ID 60942 //
     /*  378161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  378172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  378175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  378178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378200 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378220 */     GIR_RootConstrainSelectedInstOperands,
     /*  378221 */     // GIR_Coverage, 60942,
     /*  378221 */     GIR_EraseRootFromParent_Done,
     /*  378222 */   // Label 6832: @378222
     /*  378222 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(378288), // Rule ID 60943 //
     /*  378227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  378238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  378241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  378244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378266 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378286 */     GIR_RootConstrainSelectedInstOperands,
     /*  378287 */     // GIR_Coverage, 60943,
     /*  378287 */     GIR_EraseRootFromParent_Done,
     /*  378288 */   // Label 6833: @378288
     /*  378288 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(378354), // Rule ID 60946 //
     /*  378293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  378304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  378307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  378310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378332 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378352 */     GIR_RootConstrainSelectedInstOperands,
     /*  378353 */     // GIR_Coverage, 60946,
     /*  378353 */     GIR_EraseRootFromParent_Done,
     /*  378354 */   // Label 6834: @378354
     /*  378354 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(378420), // Rule ID 60947 //
     /*  378359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  378370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  378373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  378376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378398 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378418 */     GIR_RootConstrainSelectedInstOperands,
     /*  378419 */     // GIR_Coverage, 60947,
     /*  378419 */     GIR_EraseRootFromParent_Done,
     /*  378420 */   // Label 6835: @378420
     /*  378420 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(378486), // Rule ID 60950 //
     /*  378425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  378436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  378439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  378442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378484 */     GIR_RootConstrainSelectedInstOperands,
     /*  378485 */     // GIR_Coverage, 60950,
     /*  378485 */     GIR_EraseRootFromParent_Done,
     /*  378486 */   // Label 6836: @378486
     /*  378486 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(378552), // Rule ID 60951 //
     /*  378491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  378502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  378505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  378508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378530 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378550 */     GIR_RootConstrainSelectedInstOperands,
     /*  378551 */     // GIR_Coverage, 60951,
     /*  378551 */     GIR_EraseRootFromParent_Done,
     /*  378552 */   // Label 6837: @378552
     /*  378552 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(378618), // Rule ID 60954 //
     /*  378557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  378568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  378571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  378574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378616 */     GIR_RootConstrainSelectedInstOperands,
     /*  378617 */     // GIR_Coverage, 60954,
     /*  378617 */     GIR_EraseRootFromParent_Done,
     /*  378618 */   // Label 6838: @378618
     /*  378618 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(378684), // Rule ID 60955 //
     /*  378623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  378634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  378637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  378640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378662 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378682 */     GIR_RootConstrainSelectedInstOperands,
     /*  378683 */     // GIR_Coverage, 60955,
     /*  378683 */     GIR_EraseRootFromParent_Done,
     /*  378684 */   // Label 6839: @378684
     /*  378684 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(378750), // Rule ID 60958 //
     /*  378689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  378700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  378703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  378706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378728 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378748 */     GIR_RootConstrainSelectedInstOperands,
     /*  378749 */     // GIR_Coverage, 60958,
     /*  378749 */     GIR_EraseRootFromParent_Done,
     /*  378750 */   // Label 6840: @378750
     /*  378750 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(378816), // Rule ID 60959 //
     /*  378755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  378766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  378769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  378772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378794 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378814 */     GIR_RootConstrainSelectedInstOperands,
     /*  378815 */     // GIR_Coverage, 60959,
     /*  378815 */     GIR_EraseRootFromParent_Done,
     /*  378816 */   // Label 6841: @378816
     /*  378816 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(378882), // Rule ID 60962 //
     /*  378821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  378832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  378835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  378838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  378860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378880 */     GIR_RootConstrainSelectedInstOperands,
     /*  378881 */     // GIR_Coverage, 60962,
     /*  378881 */     GIR_EraseRootFromParent_Done,
     /*  378882 */   // Label 6842: @378882
     /*  378882 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(378948), // Rule ID 60963 //
     /*  378887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  378898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  378901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  378904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378926 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  378926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378946 */     GIR_RootConstrainSelectedInstOperands,
     /*  378947 */     // GIR_Coverage, 60963,
     /*  378947 */     GIR_EraseRootFromParent_Done,
     /*  378948 */   // Label 6843: @378948
     /*  378948 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(379014), // Rule ID 60966 //
     /*  378953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  378964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  378967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  378970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378992 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  378992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379012 */     GIR_RootConstrainSelectedInstOperands,
     /*  379013 */     // GIR_Coverage, 60966,
     /*  379013 */     GIR_EraseRootFromParent_Done,
     /*  379014 */   // Label 6844: @379014
     /*  379014 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(379080), // Rule ID 60967 //
     /*  379019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  379030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  379033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  379036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379058 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  379061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379078 */     GIR_RootConstrainSelectedInstOperands,
     /*  379079 */     // GIR_Coverage, 60967,
     /*  379079 */     GIR_EraseRootFromParent_Done,
     /*  379080 */   // Label 6845: @379080
     /*  379080 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(379146), // Rule ID 60970 //
     /*  379085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  379096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  379099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  379102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379124 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  379124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  379127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379144 */     GIR_RootConstrainSelectedInstOperands,
     /*  379145 */     // GIR_Coverage, 60970,
     /*  379145 */     GIR_EraseRootFromParent_Done,
     /*  379146 */   // Label 6846: @379146
     /*  379146 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(379212), // Rule ID 60971 //
     /*  379151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  379162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  379165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  379168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379190 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  379193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379210 */     GIR_RootConstrainSelectedInstOperands,
     /*  379211 */     // GIR_Coverage, 60971,
     /*  379211 */     GIR_EraseRootFromParent_Done,
     /*  379212 */   // Label 6847: @379212
     /*  379212 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(379278), // Rule ID 61394 //
     /*  379217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  379228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  379231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  379234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379256 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  379259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379276 */     GIR_RootConstrainSelectedInstOperands,
     /*  379277 */     // GIR_Coverage, 61394,
     /*  379277 */     GIR_EraseRootFromParent_Done,
     /*  379278 */   // Label 6848: @379278
     /*  379278 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(379344), // Rule ID 61395 //
     /*  379283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  379294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  379297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  379300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379322 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  379325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379342 */     GIR_RootConstrainSelectedInstOperands,
     /*  379343 */     // GIR_Coverage, 61395,
     /*  379343 */     GIR_EraseRootFromParent_Done,
     /*  379344 */   // Label 6849: @379344
     /*  379344 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(379410), // Rule ID 61398 //
     /*  379349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  379360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  379363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  379366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379388 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379408 */     GIR_RootConstrainSelectedInstOperands,
     /*  379409 */     // GIR_Coverage, 61398,
     /*  379409 */     GIR_EraseRootFromParent_Done,
     /*  379410 */   // Label 6850: @379410
     /*  379410 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(379476), // Rule ID 61399 //
     /*  379415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  379426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  379429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  379432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379454 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379474 */     GIR_RootConstrainSelectedInstOperands,
     /*  379475 */     // GIR_Coverage, 61399,
     /*  379475 */     GIR_EraseRootFromParent_Done,
     /*  379476 */   // Label 6851: @379476
     /*  379476 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(379542), // Rule ID 61402 //
     /*  379481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  379492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  379495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  379498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379520 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379540 */     GIR_RootConstrainSelectedInstOperands,
     /*  379541 */     // GIR_Coverage, 61402,
     /*  379541 */     GIR_EraseRootFromParent_Done,
     /*  379542 */   // Label 6852: @379542
     /*  379542 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(379608), // Rule ID 61403 //
     /*  379547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  379558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  379561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  379564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379586 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379606 */     GIR_RootConstrainSelectedInstOperands,
     /*  379607 */     // GIR_Coverage, 61403,
     /*  379607 */     GIR_EraseRootFromParent_Done,
     /*  379608 */   // Label 6853: @379608
     /*  379608 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(379674), // Rule ID 61406 //
     /*  379613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  379624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  379627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  379630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379652 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  379652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379672 */     GIR_RootConstrainSelectedInstOperands,
     /*  379673 */     // GIR_Coverage, 61406,
     /*  379673 */     GIR_EraseRootFromParent_Done,
     /*  379674 */   // Label 6854: @379674
     /*  379674 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(379740), // Rule ID 61407 //
     /*  379679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  379690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  379693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  379696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379718 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379738 */     GIR_RootConstrainSelectedInstOperands,
     /*  379739 */     // GIR_Coverage, 61407,
     /*  379739 */     GIR_EraseRootFromParent_Done,
     /*  379740 */   // Label 6855: @379740
     /*  379740 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(379806), // Rule ID 61410 //
     /*  379745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  379756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  379759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  379762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379784 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  379784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379804 */     GIR_RootConstrainSelectedInstOperands,
     /*  379805 */     // GIR_Coverage, 61410,
     /*  379805 */     GIR_EraseRootFromParent_Done,
     /*  379806 */   // Label 6856: @379806
     /*  379806 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(379872), // Rule ID 61411 //
     /*  379811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  379822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  379825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  379828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379850 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379870 */     GIR_RootConstrainSelectedInstOperands,
     /*  379871 */     // GIR_Coverage, 61411,
     /*  379871 */     GIR_EraseRootFromParent_Done,
     /*  379872 */   // Label 6857: @379872
     /*  379872 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(379938), // Rule ID 61414 //
     /*  379877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  379888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  379891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  379894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379916 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379936 */     GIR_RootConstrainSelectedInstOperands,
     /*  379937 */     // GIR_Coverage, 61414,
     /*  379937 */     GIR_EraseRootFromParent_Done,
     /*  379938 */   // Label 6858: @379938
     /*  379938 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(380004), // Rule ID 61415 //
     /*  379943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  379954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  379957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  379960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379982 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380002 */     GIR_RootConstrainSelectedInstOperands,
     /*  380003 */     // GIR_Coverage, 61415,
     /*  380003 */     GIR_EraseRootFromParent_Done,
     /*  380004 */   // Label 6859: @380004
     /*  380004 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(380070), // Rule ID 61418 //
     /*  380009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  380020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  380023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  380026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380048 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380068 */     GIR_RootConstrainSelectedInstOperands,
     /*  380069 */     // GIR_Coverage, 61418,
     /*  380069 */     GIR_EraseRootFromParent_Done,
     /*  380070 */   // Label 6860: @380070
     /*  380070 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(380136), // Rule ID 61419 //
     /*  380075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  380086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  380089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  380092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380114 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380134 */     GIR_RootConstrainSelectedInstOperands,
     /*  380135 */     // GIR_Coverage, 61419,
     /*  380135 */     GIR_EraseRootFromParent_Done,
     /*  380136 */   // Label 6861: @380136
     /*  380136 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(380202), // Rule ID 61422 //
     /*  380141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  380152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  380155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  380158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380200 */     GIR_RootConstrainSelectedInstOperands,
     /*  380201 */     // GIR_Coverage, 61422,
     /*  380201 */     GIR_EraseRootFromParent_Done,
     /*  380202 */   // Label 6862: @380202
     /*  380202 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(380268), // Rule ID 61423 //
     /*  380207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  380218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  380221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  380224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380266 */     GIR_RootConstrainSelectedInstOperands,
     /*  380267 */     // GIR_Coverage, 61423,
     /*  380267 */     GIR_EraseRootFromParent_Done,
     /*  380268 */   // Label 6863: @380268
     /*  380268 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(380334), // Rule ID 61426 //
     /*  380273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  380284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  380287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  380290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380312 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  380312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380332 */     GIR_RootConstrainSelectedInstOperands,
     /*  380333 */     // GIR_Coverage, 61426,
     /*  380333 */     GIR_EraseRootFromParent_Done,
     /*  380334 */   // Label 6864: @380334
     /*  380334 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(380400), // Rule ID 61427 //
     /*  380339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  380350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  380353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  380356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380378 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  380378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380398 */     GIR_RootConstrainSelectedInstOperands,
     /*  380399 */     // GIR_Coverage, 61427,
     /*  380399 */     GIR_EraseRootFromParent_Done,
     /*  380400 */   // Label 6865: @380400
     /*  380400 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(380466), // Rule ID 61430 //
     /*  380405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  380416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  380419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  380422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380444 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  380444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380464 */     GIR_RootConstrainSelectedInstOperands,
     /*  380465 */     // GIR_Coverage, 61430,
     /*  380465 */     GIR_EraseRootFromParent_Done,
     /*  380466 */   // Label 6866: @380466
     /*  380466 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(380532), // Rule ID 61431 //
     /*  380471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  380482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  380485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  380488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380510 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  380510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380530 */     GIR_RootConstrainSelectedInstOperands,
     /*  380531 */     // GIR_Coverage, 61431,
     /*  380531 */     GIR_EraseRootFromParent_Done,
     /*  380532 */   // Label 6867: @380532
     /*  380532 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(380598), // Rule ID 61434 //
     /*  380537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  380548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  380551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  380554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  380579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380596 */     GIR_RootConstrainSelectedInstOperands,
     /*  380597 */     // GIR_Coverage, 61434,
     /*  380597 */     GIR_EraseRootFromParent_Done,
     /*  380598 */   // Label 6868: @380598
     /*  380598 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(380664), // Rule ID 61435 //
     /*  380603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  380614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  380617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  380620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380642 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  380645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380662 */     GIR_RootConstrainSelectedInstOperands,
     /*  380663 */     // GIR_Coverage, 61435,
     /*  380663 */     GIR_EraseRootFromParent_Done,
     /*  380664 */   // Label 6869: @380664
     /*  380664 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(380730), // Rule ID 61438 //
     /*  380669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  380680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  380683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  380686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380708 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  380711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380728 */     GIR_RootConstrainSelectedInstOperands,
     /*  380729 */     // GIR_Coverage, 61438,
     /*  380729 */     GIR_EraseRootFromParent_Done,
     /*  380730 */   // Label 6870: @380730
     /*  380730 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(380796), // Rule ID 61439 //
     /*  380735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  380746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  380749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  380752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380774 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  380777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380794 */     GIR_RootConstrainSelectedInstOperands,
     /*  380795 */     // GIR_Coverage, 61439,
     /*  380795 */     GIR_EraseRootFromParent_Done,
     /*  380796 */   // Label 6871: @380796
     /*  380796 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(380862), // Rule ID 61442 //
     /*  380801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  380812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  380815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  380818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380840 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  380843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380860 */     GIR_RootConstrainSelectedInstOperands,
     /*  380861 */     // GIR_Coverage, 61442,
     /*  380861 */     GIR_EraseRootFromParent_Done,
     /*  380862 */   // Label 6872: @380862
     /*  380862 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(380928), // Rule ID 61443 //
     /*  380867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  380878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  380881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  380884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380906 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  380909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380926 */     GIR_RootConstrainSelectedInstOperands,
     /*  380927 */     // GIR_Coverage, 61443,
     /*  380927 */     GIR_EraseRootFromParent_Done,
     /*  380928 */   // Label 6873: @380928
     /*  380928 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(380994), // Rule ID 61446 //
     /*  380933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  380944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  380947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  380950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380972 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  380975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380992 */     GIR_RootConstrainSelectedInstOperands,
     /*  380993 */     // GIR_Coverage, 61446,
     /*  380993 */     GIR_EraseRootFromParent_Done,
     /*  380994 */   // Label 6874: @380994
     /*  380994 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(381060), // Rule ID 61447 //
     /*  380999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  381010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  381013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  381016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381038 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381058 */     GIR_RootConstrainSelectedInstOperands,
     /*  381059 */     // GIR_Coverage, 61447,
     /*  381059 */     GIR_EraseRootFromParent_Done,
     /*  381060 */   // Label 6875: @381060
     /*  381060 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(381126), // Rule ID 61450 //
     /*  381065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  381076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  381079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  381082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381104 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381124 */     GIR_RootConstrainSelectedInstOperands,
     /*  381125 */     // GIR_Coverage, 61450,
     /*  381125 */     GIR_EraseRootFromParent_Done,
     /*  381126 */   // Label 6876: @381126
     /*  381126 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(381192), // Rule ID 61451 //
     /*  381131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  381142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  381145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  381148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381170 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381190 */     GIR_RootConstrainSelectedInstOperands,
     /*  381191 */     // GIR_Coverage, 61451,
     /*  381191 */     GIR_EraseRootFromParent_Done,
     /*  381192 */   // Label 6877: @381192
     /*  381192 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(381258), // Rule ID 61454 //
     /*  381197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  381208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  381211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  381214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381236 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381256 */     GIR_RootConstrainSelectedInstOperands,
     /*  381257 */     // GIR_Coverage, 61454,
     /*  381257 */     GIR_EraseRootFromParent_Done,
     /*  381258 */   // Label 6878: @381258
     /*  381258 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(381324), // Rule ID 61455 //
     /*  381263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  381274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  381277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  381280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381302 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381322 */     GIR_RootConstrainSelectedInstOperands,
     /*  381323 */     // GIR_Coverage, 61455,
     /*  381323 */     GIR_EraseRootFromParent_Done,
     /*  381324 */   // Label 6879: @381324
     /*  381324 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(381390), // Rule ID 61458 //
     /*  381329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  381340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  381343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  381346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381388 */     GIR_RootConstrainSelectedInstOperands,
     /*  381389 */     // GIR_Coverage, 61458,
     /*  381389 */     GIR_EraseRootFromParent_Done,
     /*  381390 */   // Label 6880: @381390
     /*  381390 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(381456), // Rule ID 61459 //
     /*  381395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  381406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  381409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  381412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  381434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381454 */     GIR_RootConstrainSelectedInstOperands,
     /*  381455 */     // GIR_Coverage, 61459,
     /*  381455 */     GIR_EraseRootFromParent_Done,
     /*  381456 */   // Label 6881: @381456
     /*  381456 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(381522), // Rule ID 61462 //
     /*  381461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  381472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  381475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  381478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381520 */     GIR_RootConstrainSelectedInstOperands,
     /*  381521 */     // GIR_Coverage, 61462,
     /*  381521 */     GIR_EraseRootFromParent_Done,
     /*  381522 */   // Label 6882: @381522
     /*  381522 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(381588), // Rule ID 61463 //
     /*  381527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  381538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  381541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  381544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381566 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  381566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381586 */     GIR_RootConstrainSelectedInstOperands,
     /*  381587 */     // GIR_Coverage, 61463,
     /*  381587 */     GIR_EraseRootFromParent_Done,
     /*  381588 */   // Label 6883: @381588
     /*  381588 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(381654), // Rule ID 61466 //
     /*  381593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  381604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  381607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  381610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381652 */     GIR_RootConstrainSelectedInstOperands,
     /*  381653 */     // GIR_Coverage, 61466,
     /*  381653 */     GIR_EraseRootFromParent_Done,
     /*  381654 */   // Label 6884: @381654
     /*  381654 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(381720), // Rule ID 61467 //
     /*  381659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  381670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  381673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  381676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381698 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  381698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381718 */     GIR_RootConstrainSelectedInstOperands,
     /*  381719 */     // GIR_Coverage, 61467,
     /*  381719 */     GIR_EraseRootFromParent_Done,
     /*  381720 */   // Label 6885: @381720
     /*  381720 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(381786), // Rule ID 61470 //
     /*  381725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  381736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  381739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  381742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  381764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381784 */     GIR_RootConstrainSelectedInstOperands,
     /*  381785 */     // GIR_Coverage, 61470,
     /*  381785 */     GIR_EraseRootFromParent_Done,
     /*  381786 */   // Label 6886: @381786
     /*  381786 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(381852), // Rule ID 61471 //
     /*  381791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  381802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  381805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  381808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381830 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  381830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381850 */     GIR_RootConstrainSelectedInstOperands,
     /*  381851 */     // GIR_Coverage, 61471,
     /*  381851 */     GIR_EraseRootFromParent_Done,
     /*  381852 */   // Label 6887: @381852
     /*  381852 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(381918), // Rule ID 61474 //
     /*  381857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  381868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  381871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  381874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  381896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381916 */     GIR_RootConstrainSelectedInstOperands,
     /*  381917 */     // GIR_Coverage, 61474,
     /*  381917 */     GIR_EraseRootFromParent_Done,
     /*  381918 */   // Label 6888: @381918
     /*  381918 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(381984), // Rule ID 61475 //
     /*  381923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  381934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  381937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  381940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381962 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  381962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381982 */     GIR_RootConstrainSelectedInstOperands,
     /*  381983 */     // GIR_Coverage, 61475,
     /*  381983 */     GIR_EraseRootFromParent_Done,
     /*  381984 */   // Label 6889: @381984
     /*  381984 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(382050), // Rule ID 61478 //
     /*  381989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  382000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  382003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  382006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382028 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  382031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382048 */     GIR_RootConstrainSelectedInstOperands,
     /*  382049 */     // GIR_Coverage, 61478,
     /*  382049 */     GIR_EraseRootFromParent_Done,
     /*  382050 */   // Label 6890: @382050
     /*  382050 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(382116), // Rule ID 61479 //
     /*  382055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  382066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  382069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  382072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382094 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  382097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382114 */     GIR_RootConstrainSelectedInstOperands,
     /*  382115 */     // GIR_Coverage, 61479,
     /*  382115 */     GIR_EraseRootFromParent_Done,
     /*  382116 */   // Label 6891: @382116
     /*  382116 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(382182), // Rule ID 61482 //
     /*  382121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  382132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  382135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  382138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382160 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  382163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382180 */     GIR_RootConstrainSelectedInstOperands,
     /*  382181 */     // GIR_Coverage, 61482,
     /*  382181 */     GIR_EraseRootFromParent_Done,
     /*  382182 */   // Label 6892: @382182
     /*  382182 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(382248), // Rule ID 61483 //
     /*  382187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  382198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  382201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  382204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382226 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  382226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  382229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382246 */     GIR_RootConstrainSelectedInstOperands,
     /*  382247 */     // GIR_Coverage, 61483,
     /*  382247 */     GIR_EraseRootFromParent_Done,
     /*  382248 */   // Label 6893: @382248
     /*  382248 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(382314), // Rule ID 61486 //
     /*  382253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  382264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  382267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  382270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382292 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382312 */     GIR_RootConstrainSelectedInstOperands,
     /*  382313 */     // GIR_Coverage, 61486,
     /*  382313 */     GIR_EraseRootFromParent_Done,
     /*  382314 */   // Label 6894: @382314
     /*  382314 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(382380), // Rule ID 61487 //
     /*  382319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  382330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  382333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  382336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382358 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  382358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382378 */     GIR_RootConstrainSelectedInstOperands,
     /*  382379 */     // GIR_Coverage, 61487,
     /*  382379 */     GIR_EraseRootFromParent_Done,
     /*  382380 */   // Label 6895: @382380
     /*  382380 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(382446), // Rule ID 61490 //
     /*  382385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  382396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  382399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  382402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382424 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382444 */     GIR_RootConstrainSelectedInstOperands,
     /*  382445 */     // GIR_Coverage, 61490,
     /*  382445 */     GIR_EraseRootFromParent_Done,
     /*  382446 */   // Label 6896: @382446
     /*  382446 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(382512), // Rule ID 61491 //
     /*  382451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  382462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  382465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  382468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382490 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  382490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382510 */     GIR_RootConstrainSelectedInstOperands,
     /*  382511 */     // GIR_Coverage, 61491,
     /*  382511 */     GIR_EraseRootFromParent_Done,
     /*  382512 */   // Label 6897: @382512
     /*  382512 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(382578), // Rule ID 61494 //
     /*  382517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  382528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  382531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  382534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382556 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  382556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382576 */     GIR_RootConstrainSelectedInstOperands,
     /*  382577 */     // GIR_Coverage, 61494,
     /*  382577 */     GIR_EraseRootFromParent_Done,
     /*  382578 */   // Label 6898: @382578
     /*  382578 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(382644), // Rule ID 61495 //
     /*  382583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  382594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  382597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  382600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382622 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  382622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382642 */     GIR_RootConstrainSelectedInstOperands,
     /*  382643 */     // GIR_Coverage, 61495,
     /*  382643 */     GIR_EraseRootFromParent_Done,
     /*  382644 */   // Label 6899: @382644
     /*  382644 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(382710), // Rule ID 61498 //
     /*  382649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  382660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  382663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  382666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382688 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  382688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382708 */     GIR_RootConstrainSelectedInstOperands,
     /*  382709 */     // GIR_Coverage, 61498,
     /*  382709 */     GIR_EraseRootFromParent_Done,
     /*  382710 */   // Label 6900: @382710
     /*  382710 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(382776), // Rule ID 61499 //
     /*  382715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  382726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  382729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  382732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382754 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  382754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382774 */     GIR_RootConstrainSelectedInstOperands,
     /*  382775 */     // GIR_Coverage, 61499,
     /*  382775 */     GIR_EraseRootFromParent_Done,
     /*  382776 */   // Label 6901: @382776
     /*  382776 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(382842), // Rule ID 61502 //
     /*  382781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  382792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  382795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  382798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382820 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382840 */     GIR_RootConstrainSelectedInstOperands,
     /*  382841 */     // GIR_Coverage, 61502,
     /*  382841 */     GIR_EraseRootFromParent_Done,
     /*  382842 */   // Label 6902: @382842
     /*  382842 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(382908), // Rule ID 61503 //
     /*  382847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  382858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  382861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  382864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382886 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382906 */     GIR_RootConstrainSelectedInstOperands,
     /*  382907 */     // GIR_Coverage, 61503,
     /*  382907 */     GIR_EraseRootFromParent_Done,
     /*  382908 */   // Label 6903: @382908
     /*  382908 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(382974), // Rule ID 61506 //
     /*  382913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  382924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  382927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  382930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  382955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382972 */     GIR_RootConstrainSelectedInstOperands,
     /*  382973 */     // GIR_Coverage, 61506,
     /*  382973 */     GIR_EraseRootFromParent_Done,
     /*  382974 */   // Label 6904: @382974
     /*  382974 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(383040), // Rule ID 61507 //
     /*  382979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  382990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  382993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  382996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383018 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383038 */     GIR_RootConstrainSelectedInstOperands,
     /*  383039 */     // GIR_Coverage, 61507,
     /*  383039 */     GIR_EraseRootFromParent_Done,
     /*  383040 */   // Label 6905: @383040
     /*  383040 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(383106), // Rule ID 61510 //
     /*  383045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  383056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  383059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  383062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383104 */     GIR_RootConstrainSelectedInstOperands,
     /*  383105 */     // GIR_Coverage, 61510,
     /*  383105 */     GIR_EraseRootFromParent_Done,
     /*  383106 */   // Label 6906: @383106
     /*  383106 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(383172), // Rule ID 61511 //
     /*  383111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  383122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  383125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  383128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383150 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383170 */     GIR_RootConstrainSelectedInstOperands,
     /*  383171 */     // GIR_Coverage, 61511,
     /*  383171 */     GIR_EraseRootFromParent_Done,
     /*  383172 */   // Label 6907: @383172
     /*  383172 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(383238), // Rule ID 61514 //
     /*  383177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  383188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  383191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  383194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383236 */     GIR_RootConstrainSelectedInstOperands,
     /*  383237 */     // GIR_Coverage, 61514,
     /*  383237 */     GIR_EraseRootFromParent_Done,
     /*  383238 */   // Label 6908: @383238
     /*  383238 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(383304), // Rule ID 61515 //
     /*  383243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  383254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  383257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  383260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383282 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383302 */     GIR_RootConstrainSelectedInstOperands,
     /*  383303 */     // GIR_Coverage, 61515,
     /*  383303 */     GIR_EraseRootFromParent_Done,
     /*  383304 */   // Label 6909: @383304
     /*  383304 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(383370), // Rule ID 61518 //
     /*  383309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  383320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  383323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  383326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383348 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  383348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  383365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383368 */     GIR_RootConstrainSelectedInstOperands,
     /*  383369 */     // GIR_Coverage, 61518,
     /*  383369 */     GIR_EraseRootFromParent_Done,
     /*  383370 */   // Label 6910: @383370
     /*  383370 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(383436), // Rule ID 61519 //
     /*  383375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  383386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  383389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  383392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  383414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  383431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383434 */     GIR_RootConstrainSelectedInstOperands,
     /*  383435 */     // GIR_Coverage, 61519,
     /*  383435 */     GIR_EraseRootFromParent_Done,
     /*  383436 */   // Label 6911: @383436
     /*  383436 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(383502), // Rule ID 61522 //
     /*  383441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  383452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  383455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  383458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383480 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383500 */     GIR_RootConstrainSelectedInstOperands,
     /*  383501 */     // GIR_Coverage, 61522,
     /*  383501 */     GIR_EraseRootFromParent_Done,
     /*  383502 */   // Label 6912: @383502
     /*  383502 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(383568), // Rule ID 61523 //
     /*  383507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  383518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  383521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  383524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383546 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383566 */     GIR_RootConstrainSelectedInstOperands,
     /*  383567 */     // GIR_Coverage, 61523,
     /*  383567 */     GIR_EraseRootFromParent_Done,
     /*  383568 */   // Label 6913: @383568
     /*  383568 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(383634), // Rule ID 61526 //
     /*  383573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  383584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  383587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  383590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383612 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  383615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383632 */     GIR_RootConstrainSelectedInstOperands,
     /*  383633 */     // GIR_Coverage, 61526,
     /*  383633 */     GIR_EraseRootFromParent_Done,
     /*  383634 */   // Label 6914: @383634
     /*  383634 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(383700), // Rule ID 61527 //
     /*  383639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  383650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  383653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  383656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383678 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  383681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383698 */     GIR_RootConstrainSelectedInstOperands,
     /*  383699 */     // GIR_Coverage, 61527,
     /*  383699 */     GIR_EraseRootFromParent_Done,
     /*  383700 */   // Label 6915: @383700
     /*  383700 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(383766), // Rule ID 61530 //
     /*  383705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  383716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  383719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  383722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383744 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  383747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383764 */     GIR_RootConstrainSelectedInstOperands,
     /*  383765 */     // GIR_Coverage, 61530,
     /*  383765 */     GIR_EraseRootFromParent_Done,
     /*  383766 */   // Label 6916: @383766
     /*  383766 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(383832), // Rule ID 61531 //
     /*  383771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  383782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  383785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  383788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383810 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  383813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383830 */     GIR_RootConstrainSelectedInstOperands,
     /*  383831 */     // GIR_Coverage, 61531,
     /*  383831 */     GIR_EraseRootFromParent_Done,
     /*  383832 */   // Label 6917: @383832
     /*  383832 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(383898), // Rule ID 61534 //
     /*  383837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  383848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  383851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  383854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383896 */     GIR_RootConstrainSelectedInstOperands,
     /*  383897 */     // GIR_Coverage, 61534,
     /*  383897 */     GIR_EraseRootFromParent_Done,
     /*  383898 */   // Label 6918: @383898
     /*  383898 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(383964), // Rule ID 61535 //
     /*  383903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  383914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  383917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  383920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383942 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383962 */     GIR_RootConstrainSelectedInstOperands,
     /*  383963 */     // GIR_Coverage, 61535,
     /*  383963 */     GIR_EraseRootFromParent_Done,
     /*  383964 */   // Label 6919: @383964
     /*  383964 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(384030), // Rule ID 61538 //
     /*  383969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  383980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  383983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  383986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384008 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384028 */     GIR_RootConstrainSelectedInstOperands,
     /*  384029 */     // GIR_Coverage, 61538,
     /*  384029 */     GIR_EraseRootFromParent_Done,
     /*  384030 */   // Label 6920: @384030
     /*  384030 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(384096), // Rule ID 61539 //
     /*  384035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  384046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  384049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  384052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384074 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384094 */     GIR_RootConstrainSelectedInstOperands,
     /*  384095 */     // GIR_Coverage, 61539,
     /*  384095 */     GIR_EraseRootFromParent_Done,
     /*  384096 */   // Label 6921: @384096
     /*  384096 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(384162), // Rule ID 61542 //
     /*  384101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  384112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  384115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  384118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384140 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384160 */     GIR_RootConstrainSelectedInstOperands,
     /*  384161 */     // GIR_Coverage, 61542,
     /*  384161 */     GIR_EraseRootFromParent_Done,
     /*  384162 */   // Label 6922: @384162
     /*  384162 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(384228), // Rule ID 61543 //
     /*  384167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  384178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  384181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  384184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384226 */     GIR_RootConstrainSelectedInstOperands,
     /*  384227 */     // GIR_Coverage, 61543,
     /*  384227 */     GIR_EraseRootFromParent_Done,
     /*  384228 */   // Label 6923: @384228
     /*  384228 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(384294), // Rule ID 61546 //
     /*  384233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  384244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  384247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  384250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384272 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384292 */     GIR_RootConstrainSelectedInstOperands,
     /*  384293 */     // GIR_Coverage, 61546,
     /*  384293 */     GIR_EraseRootFromParent_Done,
     /*  384294 */   // Label 6924: @384294
     /*  384294 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(384360), // Rule ID 61547 //
     /*  384299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  384310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  384313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  384316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384338 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  384338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384358 */     GIR_RootConstrainSelectedInstOperands,
     /*  384359 */     // GIR_Coverage, 61547,
     /*  384359 */     GIR_EraseRootFromParent_Done,
     /*  384360 */   // Label 6925: @384360
     /*  384360 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(384426), // Rule ID 61550 //
     /*  384365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  384376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  384379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  384382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384404 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384424 */     GIR_RootConstrainSelectedInstOperands,
     /*  384425 */     // GIR_Coverage, 61550,
     /*  384425 */     GIR_EraseRootFromParent_Done,
     /*  384426 */   // Label 6926: @384426
     /*  384426 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(384492), // Rule ID 61551 //
     /*  384431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  384442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  384445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  384448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384470 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  384470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384490 */     GIR_RootConstrainSelectedInstOperands,
     /*  384491 */     // GIR_Coverage, 61551,
     /*  384491 */     GIR_EraseRootFromParent_Done,
     /*  384492 */   // Label 6927: @384492
     /*  384492 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(384558), // Rule ID 61554 //
     /*  384497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  384508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  384511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  384514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384556 */     GIR_RootConstrainSelectedInstOperands,
     /*  384557 */     // GIR_Coverage, 61554,
     /*  384557 */     GIR_EraseRootFromParent_Done,
     /*  384558 */   // Label 6928: @384558
     /*  384558 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(384624), // Rule ID 61555 //
     /*  384563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  384574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  384577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  384580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384602 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  384602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384622 */     GIR_RootConstrainSelectedInstOperands,
     /*  384623 */     // GIR_Coverage, 61555,
     /*  384623 */     GIR_EraseRootFromParent_Done,
     /*  384624 */   // Label 6929: @384624
     /*  384624 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(384690), // Rule ID 61558 //
     /*  384629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  384640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  384643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  384646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  384668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384688 */     GIR_RootConstrainSelectedInstOperands,
     /*  384689 */     // GIR_Coverage, 61558,
     /*  384689 */     GIR_EraseRootFromParent_Done,
     /*  384690 */   // Label 6930: @384690
     /*  384690 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(384756), // Rule ID 61559 //
     /*  384695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  384706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  384709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  384712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384734 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384754 */     GIR_RootConstrainSelectedInstOperands,
     /*  384755 */     // GIR_Coverage, 61559,
     /*  384755 */     GIR_EraseRootFromParent_Done,
     /*  384756 */   // Label 6931: @384756
     /*  384756 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(384822), // Rule ID 61562 //
     /*  384761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  384772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  384775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  384778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384800 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  384800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384820 */     GIR_RootConstrainSelectedInstOperands,
     /*  384821 */     // GIR_Coverage, 61562,
     /*  384821 */     GIR_EraseRootFromParent_Done,
     /*  384822 */   // Label 6932: @384822
     /*  384822 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(384888), // Rule ID 61563 //
     /*  384827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  384838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  384841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  384844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384866 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384886 */     GIR_RootConstrainSelectedInstOperands,
     /*  384887 */     // GIR_Coverage, 61563,
     /*  384887 */     GIR_EraseRootFromParent_Done,
     /*  384888 */   // Label 6933: @384888
     /*  384888 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(384954), // Rule ID 61566 //
     /*  384893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  384904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  384907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  384910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384932 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  384932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384952 */     GIR_RootConstrainSelectedInstOperands,
     /*  384953 */     // GIR_Coverage, 61566,
     /*  384953 */     GIR_EraseRootFromParent_Done,
     /*  384954 */   // Label 6934: @384954
     /*  384954 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(385020), // Rule ID 61567 //
     /*  384959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  384970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  384973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  384976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384998 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  385001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385018 */     GIR_RootConstrainSelectedInstOperands,
     /*  385019 */     // GIR_Coverage, 61567,
     /*  385019 */     GIR_EraseRootFromParent_Done,
     /*  385020 */   // Label 6935: @385020
     /*  385020 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(385085), // Rule ID 64458 //
     /*  385025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  385033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385069 */     // MIs[1] Operand 1
     /*  385069 */     // No operand predicates
     /*  385069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385071 */     // (intrinsic_wo_chain:{ *:[i32] } 10981:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDN),
     /*  385074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385083 */     GIR_RootConstrainSelectedInstOperands,
     /*  385084 */     // GIR_Coverage, 64458,
     /*  385084 */     GIR_EraseRootFromParent_Done,
     /*  385085 */   // Label 6936: @385085
     /*  385085 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(385150), // Rule ID 64485 //
     /*  385090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  385098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385134 */     // MIs[1] Operand 1
     /*  385134 */     // No operand predicates
     /*  385134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385136 */     // (intrinsic_wo_chain:{ *:[i32] } 10983:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUN),
     /*  385139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385148 */     GIR_RootConstrainSelectedInstOperands,
     /*  385149 */     // GIR_Coverage, 64485,
     /*  385149 */     GIR_EraseRootFromParent_Done,
     /*  385150 */   // Label 6937: @385150
     /*  385150 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(385215), // Rule ID 64488 //
     /*  385155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  385163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385199 */     // MIs[1] Operand 1
     /*  385199 */     // No operand predicates
     /*  385199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385201 */     // (intrinsic_wo_chain:{ *:[i32] } 10982:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRN),
     /*  385204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385213 */     GIR_RootConstrainSelectedInstOperands,
     /*  385214 */     // GIR_Coverage, 64488,
     /*  385214 */     GIR_EraseRootFromParent_Done,
     /*  385215 */   // Label 6938: @385215
     /*  385215 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(385280), // Rule ID 64491 //
     /*  385220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  385228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385264 */     // MIs[1] Operand 1
     /*  385264 */     // No operand predicates
     /*  385264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385266 */     // (intrinsic_wo_chain:{ *:[i32] } 10984:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURN),
     /*  385269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385278 */     GIR_RootConstrainSelectedInstOperands,
     /*  385279 */     // GIR_Coverage, 64491,
     /*  385279 */     GIR_EraseRootFromParent_Done,
     /*  385280 */   // Label 6939: @385280
     /*  385280 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(385345), // Rule ID 64494 //
     /*  385285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  385293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385329 */     // MIs[1] Operand 1
     /*  385329 */     // No operand predicates
     /*  385329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385331 */     // (intrinsic_wo_chain:{ *:[i32] } 10987:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBN),
     /*  385334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385343 */     GIR_RootConstrainSelectedInstOperands,
     /*  385344 */     // GIR_Coverage, 64494,
     /*  385344 */     GIR_EraseRootFromParent_Done,
     /*  385345 */   // Label 6940: @385345
     /*  385345 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(385410), // Rule ID 64497 //
     /*  385350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  385358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385394 */     // MIs[1] Operand 1
     /*  385394 */     // No operand predicates
     /*  385394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385396 */     // (intrinsic_wo_chain:{ *:[i32] } 10989:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUN),
     /*  385399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385408 */     GIR_RootConstrainSelectedInstOperands,
     /*  385409 */     // GIR_Coverage, 64497,
     /*  385409 */     GIR_EraseRootFromParent_Done,
     /*  385410 */   // Label 6941: @385410
     /*  385410 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(385475), // Rule ID 64500 //
     /*  385415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  385423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385459 */     // MIs[1] Operand 1
     /*  385459 */     // No operand predicates
     /*  385459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385461 */     // (intrinsic_wo_chain:{ *:[i32] } 10988:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRN),
     /*  385464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385473 */     GIR_RootConstrainSelectedInstOperands,
     /*  385474 */     // GIR_Coverage, 64500,
     /*  385474 */     GIR_EraseRootFromParent_Done,
     /*  385475 */   // Label 6942: @385475
     /*  385475 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(385540), // Rule ID 64503 //
     /*  385480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  385488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385524 */     // MIs[1] Operand 1
     /*  385524 */     // No operand predicates
     /*  385524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385526 */     // (intrinsic_wo_chain:{ *:[i32] } 10990:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURN),
     /*  385529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385538 */     GIR_RootConstrainSelectedInstOperands,
     /*  385539 */     // GIR_Coverage, 64503,
     /*  385539 */     GIR_EraseRootFromParent_Done,
     /*  385540 */   // Label 6943: @385540
     /*  385540 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(385595), // Rule ID 2651 //
     /*  385545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  385548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsi),
     /*  385553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385574 */     // MIs[0] imm
     /*  385574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  385582 */     // (intrinsic_wo_chain:{ *:[i32] } 10966:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  385582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSI),
     /*  385585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385591 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  385593 */     GIR_RootConstrainSelectedInstOperands,
     /*  385594 */     // GIR_Coverage, 2651,
     /*  385594 */     GIR_EraseRootFromParent_Done,
     /*  385595 */   // Label 6944: @385595
     /*  385595 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(385650), // Rule ID 2652 //
     /*  385600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  385603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsmi),
     /*  385608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385629 */     // MIs[0] imm
     /*  385629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  385637 */     // (intrinsic_wo_chain:{ *:[i32] } 10967:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  385637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSMI),
     /*  385640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385646 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  385648 */     GIR_RootConstrainSelectedInstOperands,
     /*  385649 */     // GIR_Coverage, 2652,
     /*  385649 */     GIR_EraseRootFromParent_Done,
     /*  385650 */   // Label 6945: @385650
     /*  385650 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(385705), // Rule ID 2658 //
     /*  385655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  385658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esi),
     /*  385663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385684 */     // MIs[0] imm
     /*  385684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  385692 */     // (intrinsic_wo_chain:{ *:[i32] } 10968:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  385692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESI),
     /*  385695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385701 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  385703 */     GIR_RootConstrainSelectedInstOperands,
     /*  385704 */     // GIR_Coverage, 2658,
     /*  385704 */     GIR_EraseRootFromParent_Done,
     /*  385705 */   // Label 6946: @385705
     /*  385705 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(385760), // Rule ID 2659 //
     /*  385710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  385713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esmi),
     /*  385718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385739 */     // MIs[0] imm
     /*  385739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  385747 */     // (intrinsic_wo_chain:{ *:[i32] } 10969:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  385747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESMI),
     /*  385750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385756 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  385758 */     GIR_RootConstrainSelectedInstOperands,
     /*  385759 */     // GIR_Coverage, 2659,
     /*  385759 */     GIR_EraseRootFromParent_Done,
     /*  385760 */   // Label 6947: @385760
     /*  385760 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(385815), // Rule ID 64514 //
     /*  385765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluN),
     /*  385773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385794 */     // MIs[0] imm5
     /*  385794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385802 */     // (intrinsic_wo_chain:{ *:[i32] } 11014:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULUN),
     /*  385805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385811 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385813 */     GIR_RootConstrainSelectedInstOperands,
     /*  385814 */     // GIR_Coverage, 64514,
     /*  385814 */     GIR_EraseRootFromParent_Done,
     /*  385815 */   // Label 6948: @385815
     /*  385815 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(385870), // Rule ID 64515 //
     /*  385820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuN),
     /*  385828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385849 */     // MIs[0] imm5
     /*  385849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385857 */     // (intrinsic_wo_chain:{ *:[i32] } 11010:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHUN),
     /*  385860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385866 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385868 */     GIR_RootConstrainSelectedInstOperands,
     /*  385869 */     // GIR_Coverage, 64515,
     /*  385869 */     GIR_EraseRootFromParent_Done,
     /*  385870 */   // Label 6949: @385870
     /*  385870 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(385925), // Rule ID 64516 //
     /*  385875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsN),
     /*  385883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385904 */     // MIs[0] imm5
     /*  385904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385907 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385912 */     // (intrinsic_wo_chain:{ *:[i32] } 11012:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSN),
     /*  385915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385921 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385923 */     GIR_RootConstrainSelectedInstOperands,
     /*  385924 */     // GIR_Coverage, 64516,
     /*  385924 */     GIR_EraseRootFromParent_Done,
     /*  385925 */   // Label 6950: @385925
     /*  385925 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(385980), // Rule ID 64517 //
     /*  385930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsN),
     /*  385938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385959 */     // MIs[0] imm5
     /*  385959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385967 */     // (intrinsic_wo_chain:{ *:[i32] } 11008:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSN),
     /*  385970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385976 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385978 */     GIR_RootConstrainSelectedInstOperands,
     /*  385979 */     // GIR_Coverage, 64517,
     /*  385979 */     GIR_EraseRootFromParent_Done,
     /*  385980 */   // Label 6951: @385980
     /*  385980 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(386035), // Rule ID 64518 //
     /*  385985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluRN),
     /*  385993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386014 */     // MIs[0] imm5
     /*  386014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386022 */     // (intrinsic_wo_chain:{ *:[i32] } 11015:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULURN),
     /*  386025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386031 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386033 */     GIR_RootConstrainSelectedInstOperands,
     /*  386034 */     // GIR_Coverage, 64518,
     /*  386034 */     GIR_EraseRootFromParent_Done,
     /*  386035 */   // Label 6952: @386035
     /*  386035 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(386090), // Rule ID 64519 //
     /*  386040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuRN),
     /*  386048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386069 */     // MIs[0] imm5
     /*  386069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386077 */     // (intrinsic_wo_chain:{ *:[i32] } 11011:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHURN),
     /*  386080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386086 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386088 */     GIR_RootConstrainSelectedInstOperands,
     /*  386089 */     // GIR_Coverage, 64519,
     /*  386089 */     GIR_EraseRootFromParent_Done,
     /*  386090 */   // Label 6953: @386090
     /*  386090 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(386145), // Rule ID 64520 //
     /*  386095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsRN),
     /*  386103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386124 */     // MIs[0] imm5
     /*  386124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386127 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386132 */     // (intrinsic_wo_chain:{ *:[i32] } 11013:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSRN),
     /*  386135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386141 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386143 */     GIR_RootConstrainSelectedInstOperands,
     /*  386144 */     // GIR_Coverage, 64520,
     /*  386144 */     GIR_EraseRootFromParent_Done,
     /*  386145 */   // Label 6954: @386145
     /*  386145 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(386200), // Rule ID 64521 //
     /*  386150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsRN),
     /*  386158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386179 */     // MIs[0] imm5
     /*  386179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386187 */     // (intrinsic_wo_chain:{ *:[i32] } 11009:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSRN),
     /*  386190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386196 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386198 */     GIR_RootConstrainSelectedInstOperands,
     /*  386199 */     // GIR_Coverage, 64521,
     /*  386199 */     GIR_EraseRootFromParent_Done,
     /*  386200 */   // Label 6955: @386200
     /*  386200 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(386254), // Rule ID 64456 //
     /*  386205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  386213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386241 */     // (intrinsic_wo_chain:{ *:[i32] } 10981:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  386244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386252 */     GIR_RootConstrainSelectedInstOperands,
     /*  386253 */     // GIR_Coverage, 64456,
     /*  386253 */     GIR_EraseRootFromParent_Done,
     /*  386254 */   // Label 6956: @386254
     /*  386254 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(386308), // Rule ID 64457 //
     /*  386259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  386267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386295 */     // (intrinsic_wo_chain:{ *:[i32] } 10981:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  386298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386306 */     GIR_RootConstrainSelectedInstOperands,
     /*  386307 */     // GIR_Coverage, 64457,
     /*  386307 */     GIR_EraseRootFromParent_Done,
     /*  386308 */   // Label 6957: @386308
     /*  386308 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(386362), // Rule ID 64483 //
     /*  386313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  386321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386349 */     // (intrinsic_wo_chain:{ *:[i32] } 10983:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  386352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386360 */     GIR_RootConstrainSelectedInstOperands,
     /*  386361 */     // GIR_Coverage, 64483,
     /*  386361 */     GIR_EraseRootFromParent_Done,
     /*  386362 */   // Label 6958: @386362
     /*  386362 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(386416), // Rule ID 64484 //
     /*  386367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  386375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386403 */     // (intrinsic_wo_chain:{ *:[i32] } 10983:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  386406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386414 */     GIR_RootConstrainSelectedInstOperands,
     /*  386415 */     // GIR_Coverage, 64484,
     /*  386415 */     GIR_EraseRootFromParent_Done,
     /*  386416 */   // Label 6959: @386416
     /*  386416 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(386470), // Rule ID 64486 //
     /*  386421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  386429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386457 */     // (intrinsic_wo_chain:{ *:[i32] } 10982:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  386460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386468 */     GIR_RootConstrainSelectedInstOperands,
     /*  386469 */     // GIR_Coverage, 64486,
     /*  386469 */     GIR_EraseRootFromParent_Done,
     /*  386470 */   // Label 6960: @386470
     /*  386470 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(386524), // Rule ID 64487 //
     /*  386475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  386483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386511 */     // (intrinsic_wo_chain:{ *:[i32] } 10982:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  386514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386522 */     GIR_RootConstrainSelectedInstOperands,
     /*  386523 */     // GIR_Coverage, 64487,
     /*  386523 */     GIR_EraseRootFromParent_Done,
     /*  386524 */   // Label 6961: @386524
     /*  386524 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(386578), // Rule ID 64489 //
     /*  386529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  386537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386565 */     // (intrinsic_wo_chain:{ *:[i32] } 10984:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  386568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386576 */     GIR_RootConstrainSelectedInstOperands,
     /*  386577 */     // GIR_Coverage, 64489,
     /*  386577 */     GIR_EraseRootFromParent_Done,
     /*  386578 */   // Label 6962: @386578
     /*  386578 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(386632), // Rule ID 64490 //
     /*  386583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  386591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386619 */     // (intrinsic_wo_chain:{ *:[i32] } 10984:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  386622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386630 */     GIR_RootConstrainSelectedInstOperands,
     /*  386631 */     // GIR_Coverage, 64490,
     /*  386631 */     GIR_EraseRootFromParent_Done,
     /*  386632 */   // Label 6963: @386632
     /*  386632 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(386686), // Rule ID 64492 //
     /*  386637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  386645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386673 */     // (intrinsic_wo_chain:{ *:[i32] } 10987:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  386676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386684 */     GIR_RootConstrainSelectedInstOperands,
     /*  386685 */     // GIR_Coverage, 64492,
     /*  386685 */     GIR_EraseRootFromParent_Done,
     /*  386686 */   // Label 6964: @386686
     /*  386686 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(386740), // Rule ID 64493 //
     /*  386691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  386699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386727 */     // (intrinsic_wo_chain:{ *:[i32] } 10987:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  386730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386738 */     GIR_RootConstrainSelectedInstOperands,
     /*  386739 */     // GIR_Coverage, 64493,
     /*  386739 */     GIR_EraseRootFromParent_Done,
     /*  386740 */   // Label 6965: @386740
     /*  386740 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(386794), // Rule ID 64495 //
     /*  386745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  386753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386781 */     // (intrinsic_wo_chain:{ *:[i32] } 10989:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  386784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386792 */     GIR_RootConstrainSelectedInstOperands,
     /*  386793 */     // GIR_Coverage, 64495,
     /*  386793 */     GIR_EraseRootFromParent_Done,
     /*  386794 */   // Label 6966: @386794
     /*  386794 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(386848), // Rule ID 64496 //
     /*  386799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  386807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386835 */     // (intrinsic_wo_chain:{ *:[i32] } 10989:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  386838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386846 */     GIR_RootConstrainSelectedInstOperands,
     /*  386847 */     // GIR_Coverage, 64496,
     /*  386847 */     GIR_EraseRootFromParent_Done,
     /*  386848 */   // Label 6967: @386848
     /*  386848 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(386902), // Rule ID 64498 //
     /*  386853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  386861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386889 */     // (intrinsic_wo_chain:{ *:[i32] } 10988:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  386892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386900 */     GIR_RootConstrainSelectedInstOperands,
     /*  386901 */     // GIR_Coverage, 64498,
     /*  386901 */     GIR_EraseRootFromParent_Done,
     /*  386902 */   // Label 6968: @386902
     /*  386902 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(386956), // Rule ID 64499 //
     /*  386907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  386915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386943 */     // (intrinsic_wo_chain:{ *:[i32] } 10988:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  386946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386954 */     GIR_RootConstrainSelectedInstOperands,
     /*  386955 */     // GIR_Coverage, 64499,
     /*  386955 */     GIR_EraseRootFromParent_Done,
     /*  386956 */   // Label 6969: @386956
     /*  386956 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(387010), // Rule ID 64501 //
     /*  386961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  386969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386997 */     // (intrinsic_wo_chain:{ *:[i32] } 10990:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  387000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387008 */     GIR_RootConstrainSelectedInstOperands,
     /*  387009 */     // GIR_Coverage, 64501,
     /*  387009 */     GIR_EraseRootFromParent_Done,
     /*  387010 */   // Label 6970: @387010
     /*  387010 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(387064), // Rule ID 64502 //
     /*  387015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  387018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  387023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387051 */     // (intrinsic_wo_chain:{ *:[i32] } 10990:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  387054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387062 */     GIR_RootConstrainSelectedInstOperands,
     /*  387063 */     // GIR_Coverage, 64502,
     /*  387063 */     GIR_EraseRootFromParent_Done,
     /*  387064 */   // Label 6971: @387064
     /*  387064 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(387118), // Rule ID 64439 //
     /*  387069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /*  387072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  387077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387105 */     // (intrinsic_wo_chain:{ *:[i32] } 10997:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  387108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387116 */     GIR_RootConstrainSelectedInstOperands,
     /*  387117 */     // GIR_Coverage, 64439,
     /*  387117 */     GIR_EraseRootFromParent_Done,
     /*  387118 */   // Label 6972: @387118
     /*  387118 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(387172), // Rule ID 64440 //
     /*  387123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  387126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  387131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387159 */     // (intrinsic_wo_chain:{ *:[i32] } 10997:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  387162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387170 */     GIR_RootConstrainSelectedInstOperands,
     /*  387171 */     // GIR_Coverage, 64440,
     /*  387171 */     GIR_EraseRootFromParent_Done,
     /*  387172 */   // Label 6973: @387172
     /*  387172 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(387226), // Rule ID 64510 //
     /*  387177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  387180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  387185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387213 */     // (intrinsic_wo_chain:{ *:[i32] } 10998:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  387216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387224 */     GIR_RootConstrainSelectedInstOperands,
     /*  387225 */     // GIR_Coverage, 64510,
     /*  387225 */     GIR_EraseRootFromParent_Done,
     /*  387226 */   // Label 6974: @387226
     /*  387226 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(387280), // Rule ID 64511 //
     /*  387231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  387234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  387239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387267 */     // (intrinsic_wo_chain:{ *:[i32] } 10998:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  387270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387278 */     GIR_RootConstrainSelectedInstOperands,
     /*  387279 */     // GIR_Coverage, 64511,
     /*  387279 */     GIR_EraseRootFromParent_Done,
     /*  387280 */   // Label 6975: @387280
     /*  387280 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(387334), // Rule ID 64512 //
     /*  387285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  387288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  387293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387321 */     // (intrinsic_wo_chain:{ *:[i32] } 11007:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  387324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387332 */     GIR_RootConstrainSelectedInstOperands,
     /*  387333 */     // GIR_Coverage, 64512,
     /*  387333 */     GIR_EraseRootFromParent_Done,
     /*  387334 */   // Label 6976: @387334
     /*  387334 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(387388), // Rule ID 64513 //
     /*  387339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  387342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  387347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387375 */     // (intrinsic_wo_chain:{ *:[i32] } 11007:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  387378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387386 */     GIR_RootConstrainSelectedInstOperands,
     /*  387387 */     // GIR_Coverage, 64513,
     /*  387387 */     GIR_EraseRootFromParent_Done,
     /*  387388 */   // Label 6977: @387388
     /*  387388 */   GIM_Reject,
     /*  387389 */ // Label 4352: @387389
     /*  387389 */ GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(906166),
     /*  387394 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  387397 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(387472), // Rule ID 62843 //
     /*  387402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  387413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387420 */     // MIs[0] op1
     /*  387420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387428 */     // MIs[0] op2
     /*  387428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387431 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387436 */     // MIs[0] op3
     /*  387436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387451 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  387451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF8),
     /*  387454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387456 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387458 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387460 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387470 */     GIR_RootConstrainSelectedInstOperands,
     /*  387471 */     // GIR_Coverage, 62843,
     /*  387471 */     GIR_EraseRootFromParent_Done,
     /*  387472 */   // Label 6979: @387472
     /*  387472 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(387547), // Rule ID 62844 //
     /*  387477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  387488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387495 */     // MIs[0] op1
     /*  387495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387503 */     // MIs[0] op2
     /*  387503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387511 */     // MIs[0] op3
     /*  387511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387526 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  387526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF8),
     /*  387529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387531 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387533 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387535 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387545 */     GIR_RootConstrainSelectedInstOperands,
     /*  387546 */     // GIR_Coverage, 62844,
     /*  387546 */     GIR_EraseRootFromParent_Done,
     /*  387547 */   // Label 6980: @387547
     /*  387547 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(387622), // Rule ID 62875 //
     /*  387552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  387563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387570 */     // MIs[0] op1
     /*  387570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387573 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387578 */     // MIs[0] op2
     /*  387578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387586 */     // MIs[0] op3
     /*  387586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387601 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  387601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF4),
     /*  387604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387606 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387608 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387610 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387620 */     GIR_RootConstrainSelectedInstOperands,
     /*  387621 */     // GIR_Coverage, 62875,
     /*  387621 */     GIR_EraseRootFromParent_Done,
     /*  387622 */   // Label 6981: @387622
     /*  387622 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(387697), // Rule ID 62876 //
     /*  387627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  387638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387645 */     // MIs[0] op1
     /*  387645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387653 */     // MIs[0] op2
     /*  387653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387661 */     // MIs[0] op3
     /*  387661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387664 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387676 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  387676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF4),
     /*  387679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387681 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387683 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387685 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387695 */     GIR_RootConstrainSelectedInstOperands,
     /*  387696 */     // GIR_Coverage, 62876,
     /*  387696 */     GIR_EraseRootFromParent_Done,
     /*  387697 */   // Label 6982: @387697
     /*  387697 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(387772), // Rule ID 62919 //
     /*  387702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  387713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387720 */     // MIs[0] op1
     /*  387720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387728 */     // MIs[0] op2
     /*  387728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387736 */     // MIs[0] op3
     /*  387736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387751 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  387751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  387754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387756 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387758 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387760 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387770 */     GIR_RootConstrainSelectedInstOperands,
     /*  387771 */     // GIR_Coverage, 62919,
     /*  387771 */     GIR_EraseRootFromParent_Done,
     /*  387772 */   // Label 6983: @387772
     /*  387772 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(387847), // Rule ID 62920 //
     /*  387777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  387788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387795 */     // MIs[0] op1
     /*  387795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387803 */     // MIs[0] op2
     /*  387803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387811 */     // MIs[0] op3
     /*  387811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387814 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387826 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  387826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  387829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387831 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387833 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387835 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387845 */     GIR_RootConstrainSelectedInstOperands,
     /*  387846 */     // GIR_Coverage, 62920,
     /*  387846 */     GIR_EraseRootFromParent_Done,
     /*  387847 */   // Label 6984: @387847
     /*  387847 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(387922), // Rule ID 62963 //
     /*  387852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  387863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387870 */     // MIs[0] op1
     /*  387870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387873 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387878 */     // MIs[0] op2
     /*  387878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387886 */     // MIs[0] op3
     /*  387886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387901 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  387901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF4),
     /*  387904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387906 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387908 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387910 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387920 */     GIR_RootConstrainSelectedInstOperands,
     /*  387921 */     // GIR_Coverage, 62963,
     /*  387921 */     GIR_EraseRootFromParent_Done,
     /*  387922 */   // Label 6985: @387922
     /*  387922 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(387997), // Rule ID 62964 //
     /*  387927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  387938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387945 */     // MIs[0] op1
     /*  387945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387948 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387953 */     // MIs[0] op2
     /*  387953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387961 */     // MIs[0] op3
     /*  387961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  387976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF4),
     /*  387979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387981 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387983 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387985 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387995 */     GIR_RootConstrainSelectedInstOperands,
     /*  387996 */     // GIR_Coverage, 62964,
     /*  387996 */     GIR_EraseRootFromParent_Done,
     /*  387997 */   // Label 6986: @387997
     /*  387997 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(388072), // Rule ID 63019 //
     /*  388002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  388013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388020 */     // MIs[0] op1
     /*  388020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388028 */     // MIs[0] op2
     /*  388028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388036 */     // MIs[0] op3
     /*  388036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388051 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  388051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388056 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388058 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388060 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388070 */     GIR_RootConstrainSelectedInstOperands,
     /*  388071 */     // GIR_Coverage, 63019,
     /*  388071 */     GIR_EraseRootFromParent_Done,
     /*  388072 */   // Label 6987: @388072
     /*  388072 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(388147), // Rule ID 63020 //
     /*  388077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  388088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388095 */     // MIs[0] op1
     /*  388095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388098 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388103 */     // MIs[0] op2
     /*  388103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388106 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388111 */     // MIs[0] op3
     /*  388111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  388126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388131 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388133 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388135 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388145 */     GIR_RootConstrainSelectedInstOperands,
     /*  388146 */     // GIR_Coverage, 63020,
     /*  388146 */     GIR_EraseRootFromParent_Done,
     /*  388147 */   // Label 6988: @388147
     /*  388147 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(388222), // Rule ID 63075 //
     /*  388152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  388163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388170 */     // MIs[0] op1
     /*  388170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388173 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388178 */     // MIs[0] op2
     /*  388178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388186 */     // MIs[0] op3
     /*  388186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388201 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  388201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388206 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388208 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388210 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388220 */     GIR_RootConstrainSelectedInstOperands,
     /*  388221 */     // GIR_Coverage, 63075,
     /*  388221 */     GIR_EraseRootFromParent_Done,
     /*  388222 */   // Label 6989: @388222
     /*  388222 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(388297), // Rule ID 63076 //
     /*  388227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  388238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388245 */     // MIs[0] op1
     /*  388245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388248 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388253 */     // MIs[0] op2
     /*  388253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388261 */     // MIs[0] op3
     /*  388261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  388276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388281 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388283 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388285 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388295 */     GIR_RootConstrainSelectedInstOperands,
     /*  388296 */     // GIR_Coverage, 63076,
     /*  388296 */     GIR_EraseRootFromParent_Done,
     /*  388297 */   // Label 6990: @388297
     /*  388297 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(388372), // Rule ID 63131 //
     /*  388302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  388313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388320 */     // MIs[0] op1
     /*  388320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388323 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388328 */     // MIs[0] op2
     /*  388328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388331 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388336 */     // MIs[0] op3
     /*  388336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388339 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388351 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  388351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388356 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388358 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388360 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388370 */     GIR_RootConstrainSelectedInstOperands,
     /*  388371 */     // GIR_Coverage, 63131,
     /*  388371 */     GIR_EraseRootFromParent_Done,
     /*  388372 */   // Label 6991: @388372
     /*  388372 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(388447), // Rule ID 63132 //
     /*  388377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  388388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388395 */     // MIs[0] op1
     /*  388395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388403 */     // MIs[0] op2
     /*  388403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388411 */     // MIs[0] op3
     /*  388411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388414 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  388426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388431 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388433 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388435 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388445 */     GIR_RootConstrainSelectedInstOperands,
     /*  388446 */     // GIR_Coverage, 63132,
     /*  388446 */     GIR_EraseRootFromParent_Done,
     /*  388447 */   // Label 6992: @388447
     /*  388447 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(388522), // Rule ID 63175 //
     /*  388452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  388463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388470 */     // MIs[0] op1
     /*  388470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388478 */     // MIs[0] op2
     /*  388478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388486 */     // MIs[0] op3
     /*  388486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388489 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388501 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  388501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388506 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388508 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388510 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388520 */     GIR_RootConstrainSelectedInstOperands,
     /*  388521 */     // GIR_Coverage, 63175,
     /*  388521 */     GIR_EraseRootFromParent_Done,
     /*  388522 */   // Label 6993: @388522
     /*  388522 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(388597), // Rule ID 63176 //
     /*  388527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  388538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388545 */     // MIs[0] op1
     /*  388545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388553 */     // MIs[0] op2
     /*  388553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388561 */     // MIs[0] op3
     /*  388561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  388576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388581 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388583 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388585 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388595 */     GIR_RootConstrainSelectedInstOperands,
     /*  388596 */     // GIR_Coverage, 63176,
     /*  388596 */     GIR_EraseRootFromParent_Done,
     /*  388597 */   // Label 6994: @388597
     /*  388597 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(388672), // Rule ID 63231 //
     /*  388602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  388613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388620 */     // MIs[0] op1
     /*  388620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388628 */     // MIs[0] op2
     /*  388628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388631 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388636 */     // MIs[0] op3
     /*  388636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388639 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388651 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  388651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388656 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388658 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388660 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388670 */     GIR_RootConstrainSelectedInstOperands,
     /*  388671 */     // GIR_Coverage, 63231,
     /*  388671 */     GIR_EraseRootFromParent_Done,
     /*  388672 */   // Label 6995: @388672
     /*  388672 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(388747), // Rule ID 63232 //
     /*  388677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  388688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388695 */     // MIs[0] op1
     /*  388695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388703 */     // MIs[0] op2
     /*  388703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388711 */     // MIs[0] op3
     /*  388711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  388726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388731 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388733 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388735 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388745 */     GIR_RootConstrainSelectedInstOperands,
     /*  388746 */     // GIR_Coverage, 63232,
     /*  388746 */     GIR_EraseRootFromParent_Done,
     /*  388747 */   // Label 6996: @388747
     /*  388747 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(388822), // Rule ID 63287 //
     /*  388752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  388763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388770 */     // MIs[0] op1
     /*  388770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388778 */     // MIs[0] op2
     /*  388778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388786 */     // MIs[0] op3
     /*  388786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388801 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  388801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388806 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388808 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388810 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388820 */     GIR_RootConstrainSelectedInstOperands,
     /*  388821 */     // GIR_Coverage, 63287,
     /*  388821 */     GIR_EraseRootFromParent_Done,
     /*  388822 */   // Label 6997: @388822
     /*  388822 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(388897), // Rule ID 63288 //
     /*  388827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  388838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388845 */     // MIs[0] op1
     /*  388845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388853 */     // MIs[0] op2
     /*  388853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388861 */     // MIs[0] op3
     /*  388861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  388876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388881 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388883 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388885 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388895 */     GIR_RootConstrainSelectedInstOperands,
     /*  388896 */     // GIR_Coverage, 63288,
     /*  388896 */     GIR_EraseRootFromParent_Done,
     /*  388897 */   // Label 6998: @388897
     /*  388897 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(388972), // Rule ID 63343 //
     /*  388902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  388913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388920 */     // MIs[0] op1
     /*  388920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388923 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388928 */     // MIs[0] op2
     /*  388928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388931 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388936 */     // MIs[0] op3
     /*  388936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388951 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  388951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  388954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388956 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388958 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388960 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388970 */     GIR_RootConstrainSelectedInstOperands,
     /*  388971 */     // GIR_Coverage, 63343,
     /*  388971 */     GIR_EraseRootFromParent_Done,
     /*  388972 */   // Label 6999: @388972
     /*  388972 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(389047), // Rule ID 63344 //
     /*  388977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  388988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388995 */     // MIs[0] op1
     /*  388995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389003 */     // MIs[0] op2
     /*  389003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389011 */     // MIs[0] op3
     /*  389011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  389026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  389029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389031 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389033 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389035 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389045 */     GIR_RootConstrainSelectedInstOperands,
     /*  389046 */     // GIR_Coverage, 63344,
     /*  389046 */     GIR_EraseRootFromParent_Done,
     /*  389047 */   // Label 7000: @389047
     /*  389047 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(389122), // Rule ID 63387 //
     /*  389052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  389063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389070 */     // MIs[0] op1
     /*  389070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389073 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389078 */     // MIs[0] op2
     /*  389078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389081 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389086 */     // MIs[0] op3
     /*  389086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389101 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  389101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  389104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389106 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389108 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389110 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389120 */     GIR_RootConstrainSelectedInstOperands,
     /*  389121 */     // GIR_Coverage, 63387,
     /*  389121 */     GIR_EraseRootFromParent_Done,
     /*  389122 */   // Label 7001: @389122
     /*  389122 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(389197), // Rule ID 63388 //
     /*  389127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  389138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389145 */     // MIs[0] op1
     /*  389145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389153 */     // MIs[0] op2
     /*  389153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389156 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389161 */     // MIs[0] op3
     /*  389161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389176 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  389176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  389179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389181 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389183 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389185 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389195 */     GIR_RootConstrainSelectedInstOperands,
     /*  389196 */     // GIR_Coverage, 63388,
     /*  389196 */     GIR_EraseRootFromParent_Done,
     /*  389197 */   // Label 7002: @389197
     /*  389197 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(389272), // Rule ID 63431 //
     /*  389202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  389213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389220 */     // MIs[0] op1
     /*  389220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389223 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389228 */     // MIs[0] op2
     /*  389228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389236 */     // MIs[0] op3
     /*  389236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389251 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  389251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  389254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389256 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389258 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389260 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389270 */     GIR_RootConstrainSelectedInstOperands,
     /*  389271 */     // GIR_Coverage, 63431,
     /*  389271 */     GIR_EraseRootFromParent_Done,
     /*  389272 */   // Label 7003: @389272
     /*  389272 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(389347), // Rule ID 63432 //
     /*  389277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  389288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389295 */     // MIs[0] op1
     /*  389295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389303 */     // MIs[0] op2
     /*  389303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389311 */     // MIs[0] op3
     /*  389311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389326 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  389326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  389329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389331 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389333 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389335 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389345 */     GIR_RootConstrainSelectedInstOperands,
     /*  389346 */     // GIR_Coverage, 63432,
     /*  389346 */     GIR_EraseRootFromParent_Done,
     /*  389347 */   // Label 7004: @389347
     /*  389347 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(389422), // Rule ID 63475 //
     /*  389352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  389363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389370 */     // MIs[0] op1
     /*  389370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389373 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389378 */     // MIs[0] op2
     /*  389378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389381 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389386 */     // MIs[0] op3
     /*  389386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389389 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389401 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  389401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  389404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389406 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389408 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389410 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389420 */     GIR_RootConstrainSelectedInstOperands,
     /*  389421 */     // GIR_Coverage, 63475,
     /*  389421 */     GIR_EraseRootFromParent_Done,
     /*  389422 */   // Label 7005: @389422
     /*  389422 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(389497), // Rule ID 63476 //
     /*  389427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  389438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389445 */     // MIs[0] op1
     /*  389445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389448 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389453 */     // MIs[0] op2
     /*  389453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389456 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389461 */     // MIs[0] op3
     /*  389461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389464 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  389476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  389479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389481 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389483 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389485 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389495 */     GIR_RootConstrainSelectedInstOperands,
     /*  389496 */     // GIR_Coverage, 63476,
     /*  389496 */     GIR_EraseRootFromParent_Done,
     /*  389497 */   // Label 7006: @389497
     /*  389497 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(389572), // Rule ID 63531 //
     /*  389502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  389513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389520 */     // MIs[0] op1
     /*  389520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389523 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389528 */     // MIs[0] op2
     /*  389528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389536 */     // MIs[0] op3
     /*  389536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389551 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  389551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  389554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389556 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389558 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389560 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389570 */     GIR_RootConstrainSelectedInstOperands,
     /*  389571 */     // GIR_Coverage, 63531,
     /*  389571 */     GIR_EraseRootFromParent_Done,
     /*  389572 */   // Label 7007: @389572
     /*  389572 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(389647), // Rule ID 63532 //
     /*  389577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  389588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389595 */     // MIs[0] op1
     /*  389595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389598 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389603 */     // MIs[0] op2
     /*  389603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389606 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389611 */     // MIs[0] op3
     /*  389611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389614 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  389626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  389629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389631 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389633 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389635 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389645 */     GIR_RootConstrainSelectedInstOperands,
     /*  389646 */     // GIR_Coverage, 63532,
     /*  389646 */     GIR_EraseRootFromParent_Done,
     /*  389647 */   // Label 7008: @389647
     /*  389647 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(389722), // Rule ID 63587 //
     /*  389652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  389663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389670 */     // MIs[0] op1
     /*  389670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389678 */     // MIs[0] op2
     /*  389678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389686 */     // MIs[0] op3
     /*  389686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389701 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  389701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  389704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389706 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389708 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389710 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389720 */     GIR_RootConstrainSelectedInstOperands,
     /*  389721 */     // GIR_Coverage, 63587,
     /*  389721 */     GIR_EraseRootFromParent_Done,
     /*  389722 */   // Label 7009: @389722
     /*  389722 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(389797), // Rule ID 63588 //
     /*  389727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  389738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389745 */     // MIs[0] op1
     /*  389745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389748 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389753 */     // MIs[0] op2
     /*  389753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389756 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389761 */     // MIs[0] op3
     /*  389761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389764 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  389776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  389779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389781 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389783 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389785 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389795 */     GIR_RootConstrainSelectedInstOperands,
     /*  389796 */     // GIR_Coverage, 63588,
     /*  389796 */     GIR_EraseRootFromParent_Done,
     /*  389797 */   // Label 7010: @389797
     /*  389797 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(389872), // Rule ID 63643 //
     /*  389802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  389813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389820 */     // MIs[0] op1
     /*  389820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389823 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389828 */     // MIs[0] op2
     /*  389828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389831 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389836 */     // MIs[0] op3
     /*  389836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389839 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  389851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  389854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389856 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389858 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389860 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389870 */     GIR_RootConstrainSelectedInstOperands,
     /*  389871 */     // GIR_Coverage, 63643,
     /*  389871 */     GIR_EraseRootFromParent_Done,
     /*  389872 */   // Label 7011: @389872
     /*  389872 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(389947), // Rule ID 63644 //
     /*  389877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  389888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389895 */     // MIs[0] op1
     /*  389895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389903 */     // MIs[0] op2
     /*  389903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389911 */     // MIs[0] op3
     /*  389911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389914 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  389926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  389929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389931 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389933 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389935 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389945 */     GIR_RootConstrainSelectedInstOperands,
     /*  389946 */     // GIR_Coverage, 63644,
     /*  389946 */     GIR_EraseRootFromParent_Done,
     /*  389947 */   // Label 7012: @389947
     /*  389947 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(390022), // Rule ID 63699 //
     /*  389952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  389963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389970 */     // MIs[0] op1
     /*  389970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389973 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389978 */     // MIs[0] op2
     /*  389978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389981 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389986 */     // MIs[0] op3
     /*  389986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389989 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390001 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  390001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390006 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390008 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390010 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390020 */     GIR_RootConstrainSelectedInstOperands,
     /*  390021 */     // GIR_Coverage, 63699,
     /*  390021 */     GIR_EraseRootFromParent_Done,
     /*  390022 */   // Label 7013: @390022
     /*  390022 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(390097), // Rule ID 63700 //
     /*  390027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  390038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390045 */     // MIs[0] op1
     /*  390045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390048 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390053 */     // MIs[0] op2
     /*  390053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390061 */     // MIs[0] op3
     /*  390061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390064 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  390076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390081 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390083 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390085 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390095 */     GIR_RootConstrainSelectedInstOperands,
     /*  390096 */     // GIR_Coverage, 63700,
     /*  390096 */     GIR_EraseRootFromParent_Done,
     /*  390097 */   // Label 7014: @390097
     /*  390097 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(390172), // Rule ID 63755 //
     /*  390102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  390113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390120 */     // MIs[0] op1
     /*  390120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390128 */     // MIs[0] op2
     /*  390128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390136 */     // MIs[0] op3
     /*  390136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390139 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390151 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  390151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  390154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390156 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390158 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390160 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390170 */     GIR_RootConstrainSelectedInstOperands,
     /*  390171 */     // GIR_Coverage, 63755,
     /*  390171 */     GIR_EraseRootFromParent_Done,
     /*  390172 */   // Label 7015: @390172
     /*  390172 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(390247), // Rule ID 63756 //
     /*  390177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  390188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390195 */     // MIs[0] op1
     /*  390195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390203 */     // MIs[0] op2
     /*  390203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390211 */     // MIs[0] op3
     /*  390211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390226 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  390226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  390229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390231 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390233 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390235 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390245 */     GIR_RootConstrainSelectedInstOperands,
     /*  390246 */     // GIR_Coverage, 63756,
     /*  390246 */     GIR_EraseRootFromParent_Done,
     /*  390247 */   // Label 7016: @390247
     /*  390247 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(390322), // Rule ID 63811 //
     /*  390252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  390263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390270 */     // MIs[0] op1
     /*  390270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390273 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390278 */     // MIs[0] op2
     /*  390278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390286 */     // MIs[0] op3
     /*  390286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390301 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  390301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  390304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390306 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390308 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390310 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390320 */     GIR_RootConstrainSelectedInstOperands,
     /*  390321 */     // GIR_Coverage, 63811,
     /*  390321 */     GIR_EraseRootFromParent_Done,
     /*  390322 */   // Label 7017: @390322
     /*  390322 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(390397), // Rule ID 63812 //
     /*  390327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  390338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390345 */     // MIs[0] op1
     /*  390345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390353 */     // MIs[0] op2
     /*  390353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390361 */     // MIs[0] op3
     /*  390361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  390376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  390379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390381 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390383 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390385 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390395 */     GIR_RootConstrainSelectedInstOperands,
     /*  390396 */     // GIR_Coverage, 63812,
     /*  390396 */     GIR_EraseRootFromParent_Done,
     /*  390397 */   // Label 7018: @390397
     /*  390397 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(390472), // Rule ID 63867 //
     /*  390402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  390413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390420 */     // MIs[0] op1
     /*  390420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390428 */     // MIs[0] op2
     /*  390428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390431 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390436 */     // MIs[0] op3
     /*  390436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390451 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  390451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390456 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390458 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390460 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390470 */     GIR_RootConstrainSelectedInstOperands,
     /*  390471 */     // GIR_Coverage, 63867,
     /*  390471 */     GIR_EraseRootFromParent_Done,
     /*  390472 */   // Label 7019: @390472
     /*  390472 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(390547), // Rule ID 63868 //
     /*  390477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  390488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390495 */     // MIs[0] op1
     /*  390495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390503 */     // MIs[0] op2
     /*  390503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390511 */     // MIs[0] op3
     /*  390511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390526 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  390526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390531 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390533 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390535 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390545 */     GIR_RootConstrainSelectedInstOperands,
     /*  390546 */     // GIR_Coverage, 63868,
     /*  390546 */     GIR_EraseRootFromParent_Done,
     /*  390547 */   // Label 7020: @390547
     /*  390547 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(390622), // Rule ID 63923 //
     /*  390552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  390563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390570 */     // MIs[0] op1
     /*  390570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390573 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390578 */     // MIs[0] op2
     /*  390578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390586 */     // MIs[0] op3
     /*  390586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390601 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  390601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  390604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390606 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390608 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390610 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390620 */     GIR_RootConstrainSelectedInstOperands,
     /*  390621 */     // GIR_Coverage, 63923,
     /*  390621 */     GIR_EraseRootFromParent_Done,
     /*  390622 */   // Label 7021: @390622
     /*  390622 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(390697), // Rule ID 63924 //
     /*  390627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  390638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390645 */     // MIs[0] op1
     /*  390645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390653 */     // MIs[0] op2
     /*  390653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390661 */     // MIs[0] op3
     /*  390661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390664 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  390676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  390679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390681 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390683 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390685 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390695 */     GIR_RootConstrainSelectedInstOperands,
     /*  390696 */     // GIR_Coverage, 63924,
     /*  390696 */     GIR_EraseRootFromParent_Done,
     /*  390697 */   // Label 7022: @390697
     /*  390697 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(390771), // Rule ID 62825 //
     /*  390702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  390713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390723 */     // MIs[0] op1
     /*  390723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390731 */     // MIs[0] op2
     /*  390731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390750 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  390750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF8),
     /*  390753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390755 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390757 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390759 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390769 */     GIR_RootConstrainSelectedInstOperands,
     /*  390770 */     // GIR_Coverage, 62825,
     /*  390770 */     GIR_EraseRootFromParent_Done,
     /*  390771 */   // Label 7023: @390771
     /*  390771 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(390845), // Rule ID 62826 //
     /*  390776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  390787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390797 */     // MIs[0] op1
     /*  390797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390800 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390805 */     // MIs[0] op2
     /*  390805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390808 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390824 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  390824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF8),
     /*  390827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390829 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390831 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390833 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390843 */     GIR_RootConstrainSelectedInstOperands,
     /*  390844 */     // GIR_Coverage, 62826,
     /*  390844 */     GIR_EraseRootFromParent_Done,
     /*  390845 */   // Label 7024: @390845
     /*  390845 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(390919), // Rule ID 62871 //
     /*  390850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  390861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390871 */     // MIs[0] op1
     /*  390871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390874 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390879 */     // MIs[0] op2
     /*  390879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390898 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  390898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF4),
     /*  390901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390903 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390905 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390907 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390917 */     GIR_RootConstrainSelectedInstOperands,
     /*  390918 */     // GIR_Coverage, 62871,
     /*  390918 */     GIR_EraseRootFromParent_Done,
     /*  390919 */   // Label 7025: @390919
     /*  390919 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(390993), // Rule ID 62872 //
     /*  390924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  390935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390945 */     // MIs[0] op1
     /*  390945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390948 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390953 */     // MIs[0] op2
     /*  390953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390972 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  390972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF4),
     /*  390975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390977 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390979 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390981 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390991 */     GIR_RootConstrainSelectedInstOperands,
     /*  390992 */     // GIR_Coverage, 62872,
     /*  390992 */     GIR_EraseRootFromParent_Done,
     /*  390993 */   // Label 7026: @390993
     /*  390993 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(391067), // Rule ID 62915 //
     /*  390998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  391009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391019 */     // MIs[0] op1
     /*  391019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391027 */     // MIs[0] op2
     /*  391027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391046 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391051 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391053 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391055 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391065 */     GIR_RootConstrainSelectedInstOperands,
     /*  391066 */     // GIR_Coverage, 62915,
     /*  391066 */     GIR_EraseRootFromParent_Done,
     /*  391067 */   // Label 7027: @391067
     /*  391067 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(391141), // Rule ID 62916 //
     /*  391072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  391083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391093 */     // MIs[0] op1
     /*  391093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391101 */     // MIs[0] op2
     /*  391101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391120 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391125 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391127 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391129 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391139 */     GIR_RootConstrainSelectedInstOperands,
     /*  391140 */     // GIR_Coverage, 62916,
     /*  391140 */     GIR_EraseRootFromParent_Done,
     /*  391141 */   // Label 7028: @391141
     /*  391141 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(391215), // Rule ID 62959 //
     /*  391146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391167 */     // MIs[0] op1
     /*  391167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391175 */     // MIs[0] op2
     /*  391175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391178 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF4),
     /*  391197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391199 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391201 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391203 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391213 */     GIR_RootConstrainSelectedInstOperands,
     /*  391214 */     // GIR_Coverage, 62959,
     /*  391214 */     GIR_EraseRootFromParent_Done,
     /*  391215 */   // Label 7029: @391215
     /*  391215 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(391289), // Rule ID 62960 //
     /*  391220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391241 */     // MIs[0] op1
     /*  391241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391249 */     // MIs[0] op2
     /*  391249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF4),
     /*  391271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391273 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391275 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391277 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391287 */     GIR_RootConstrainSelectedInstOperands,
     /*  391288 */     // GIR_Coverage, 62960,
     /*  391288 */     GIR_EraseRootFromParent_Done,
     /*  391289 */   // Label 7030: @391289
     /*  391289 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(391363), // Rule ID 63015 //
     /*  391294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  391305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391315 */     // MIs[0] op1
     /*  391315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391323 */     // MIs[0] op2
     /*  391323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391342 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391347 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391349 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391351 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391361 */     GIR_RootConstrainSelectedInstOperands,
     /*  391362 */     // GIR_Coverage, 63015,
     /*  391362 */     GIR_EraseRootFromParent_Done,
     /*  391363 */   // Label 7031: @391363
     /*  391363 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(391437), // Rule ID 63016 //
     /*  391368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  391379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391389 */     // MIs[0] op1
     /*  391389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391392 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391397 */     // MIs[0] op2
     /*  391397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391400 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391416 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391421 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391423 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391425 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391435 */     GIR_RootConstrainSelectedInstOperands,
     /*  391436 */     // GIR_Coverage, 63016,
     /*  391436 */     GIR_EraseRootFromParent_Done,
     /*  391437 */   // Label 7032: @391437
     /*  391437 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(391511), // Rule ID 63071 //
     /*  391442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  391453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391463 */     // MIs[0] op1
     /*  391463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391466 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391471 */     // MIs[0] op2
     /*  391471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391490 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  391490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391495 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391497 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391499 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391509 */     GIR_RootConstrainSelectedInstOperands,
     /*  391510 */     // GIR_Coverage, 63071,
     /*  391510 */     GIR_EraseRootFromParent_Done,
     /*  391511 */   // Label 7033: @391511
     /*  391511 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(391585), // Rule ID 63072 //
     /*  391516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  391527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391537 */     // MIs[0] op1
     /*  391537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391540 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391545 */     // MIs[0] op2
     /*  391545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391564 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  391564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391569 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391571 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391573 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391583 */     GIR_RootConstrainSelectedInstOperands,
     /*  391584 */     // GIR_Coverage, 63072,
     /*  391584 */     GIR_EraseRootFromParent_Done,
     /*  391585 */   // Label 7034: @391585
     /*  391585 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(391659), // Rule ID 63127 //
     /*  391590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  391601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391611 */     // MIs[0] op1
     /*  391611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391614 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391619 */     // MIs[0] op2
     /*  391619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391622 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391638 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  391641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391643 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391645 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391647 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391657 */     GIR_RootConstrainSelectedInstOperands,
     /*  391658 */     // GIR_Coverage, 63127,
     /*  391658 */     GIR_EraseRootFromParent_Done,
     /*  391659 */   // Label 7035: @391659
     /*  391659 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(391733), // Rule ID 63128 //
     /*  391664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  391675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391685 */     // MIs[0] op1
     /*  391685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391688 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391693 */     // MIs[0] op2
     /*  391693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391712 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  391715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391717 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391719 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391721 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391731 */     GIR_RootConstrainSelectedInstOperands,
     /*  391732 */     // GIR_Coverage, 63128,
     /*  391732 */     GIR_EraseRootFromParent_Done,
     /*  391733 */   // Label 7036: @391733
     /*  391733 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(391807), // Rule ID 63171 //
     /*  391738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  391749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391759 */     // MIs[0] op1
     /*  391759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391762 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391767 */     // MIs[0] op2
     /*  391767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391786 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  391789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391791 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391793 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391795 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391805 */     GIR_RootConstrainSelectedInstOperands,
     /*  391806 */     // GIR_Coverage, 63171,
     /*  391806 */     GIR_EraseRootFromParent_Done,
     /*  391807 */   // Label 7037: @391807
     /*  391807 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(391881), // Rule ID 63172 //
     /*  391812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  391823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391833 */     // MIs[0] op1
     /*  391833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391836 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391841 */     // MIs[0] op2
     /*  391841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  391863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391865 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391867 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391869 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391879 */     GIR_RootConstrainSelectedInstOperands,
     /*  391880 */     // GIR_Coverage, 63172,
     /*  391880 */     GIR_EraseRootFromParent_Done,
     /*  391881 */   // Label 7038: @391881
     /*  391881 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(391955), // Rule ID 63227 //
     /*  391886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  391897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391907 */     // MIs[0] op1
     /*  391907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391915 */     // MIs[0] op2
     /*  391915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  391934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  391937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391939 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391941 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391943 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391953 */     GIR_RootConstrainSelectedInstOperands,
     /*  391954 */     // GIR_Coverage, 63227,
     /*  391954 */     GIR_EraseRootFromParent_Done,
     /*  391955 */   // Label 7039: @391955
     /*  391955 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(392029), // Rule ID 63228 //
     /*  391960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  391971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391981 */     // MIs[0] op1
     /*  391981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391989 */     // MIs[0] op2
     /*  391989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  392008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392013 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392015 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392017 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392027 */     GIR_RootConstrainSelectedInstOperands,
     /*  392028 */     // GIR_Coverage, 63228,
     /*  392028 */     GIR_EraseRootFromParent_Done,
     /*  392029 */   // Label 7040: @392029
     /*  392029 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(392103), // Rule ID 63283 //
     /*  392034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  392045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392055 */     // MIs[0] op1
     /*  392055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392063 */     // MIs[0] op2
     /*  392063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  392082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392087 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392089 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392091 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  392101 */     GIR_RootConstrainSelectedInstOperands,
     /*  392102 */     // GIR_Coverage, 63283,
     /*  392102 */     GIR_EraseRootFromParent_Done,
     /*  392103 */   // Label 7041: @392103
     /*  392103 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(392177), // Rule ID 63284 //
     /*  392108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  392119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392129 */     // MIs[0] op1
     /*  392129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392137 */     // MIs[0] op2
     /*  392137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392140 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392156 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  392156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392161 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392163 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392165 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  392175 */     GIR_RootConstrainSelectedInstOperands,
     /*  392176 */     // GIR_Coverage, 63284,
     /*  392176 */     GIR_EraseRootFromParent_Done,
     /*  392177 */   // Label 7042: @392177
     /*  392177 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(392251), // Rule ID 63339 //
     /*  392182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  392193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392203 */     // MIs[0] op1
     /*  392203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392211 */     // MIs[0] op2
     /*  392211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  392233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392235 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392237 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392239 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392249 */     GIR_RootConstrainSelectedInstOperands,
     /*  392250 */     // GIR_Coverage, 63339,
     /*  392250 */     GIR_EraseRootFromParent_Done,
     /*  392251 */   // Label 7043: @392251
     /*  392251 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(392325), // Rule ID 63340 //
     /*  392256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  392267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392277 */     // MIs[0] op1
     /*  392277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392285 */     // MIs[0] op2
     /*  392285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392304 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  392307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392309 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392311 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392313 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392323 */     GIR_RootConstrainSelectedInstOperands,
     /*  392324 */     // GIR_Coverage, 63340,
     /*  392324 */     GIR_EraseRootFromParent_Done,
     /*  392325 */   // Label 7044: @392325
     /*  392325 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(392399), // Rule ID 63383 //
     /*  392330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  392341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392351 */     // MIs[0] op1
     /*  392351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392354 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392359 */     // MIs[0] op2
     /*  392359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392378 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  392381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392383 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392385 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392387 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392397 */     GIR_RootConstrainSelectedInstOperands,
     /*  392398 */     // GIR_Coverage, 63383,
     /*  392398 */     GIR_EraseRootFromParent_Done,
     /*  392399 */   // Label 7045: @392399
     /*  392399 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(392473), // Rule ID 63384 //
     /*  392404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  392415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392425 */     // MIs[0] op1
     /*  392425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392428 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392433 */     // MIs[0] op2
     /*  392433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392452 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  392455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392457 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392459 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392461 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392471 */     GIR_RootConstrainSelectedInstOperands,
     /*  392472 */     // GIR_Coverage, 63384,
     /*  392472 */     GIR_EraseRootFromParent_Done,
     /*  392473 */   // Label 7046: @392473
     /*  392473 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(392547), // Rule ID 63427 //
     /*  392478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  392489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392499 */     // MIs[0] op1
     /*  392499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392507 */     // MIs[0] op2
     /*  392507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392526 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  392529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392531 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392533 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392535 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392545 */     GIR_RootConstrainSelectedInstOperands,
     /*  392546 */     // GIR_Coverage, 63427,
     /*  392546 */     GIR_EraseRootFromParent_Done,
     /*  392547 */   // Label 7047: @392547
     /*  392547 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(392621), // Rule ID 63428 //
     /*  392552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  392563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392573 */     // MIs[0] op1
     /*  392573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392576 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392581 */     // MIs[0] op2
     /*  392581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392600 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  392603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392605 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392607 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392609 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392619 */     GIR_RootConstrainSelectedInstOperands,
     /*  392620 */     // GIR_Coverage, 63428,
     /*  392620 */     GIR_EraseRootFromParent_Done,
     /*  392621 */   // Label 7048: @392621
     /*  392621 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(392695), // Rule ID 63471 //
     /*  392626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  392637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392647 */     // MIs[0] op1
     /*  392647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392650 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392655 */     // MIs[0] op2
     /*  392655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392674 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  392674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  392677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392679 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392681 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392683 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392693 */     GIR_RootConstrainSelectedInstOperands,
     /*  392694 */     // GIR_Coverage, 63471,
     /*  392694 */     GIR_EraseRootFromParent_Done,
     /*  392695 */   // Label 7049: @392695
     /*  392695 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(392769), // Rule ID 63472 //
     /*  392700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  392711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392721 */     // MIs[0] op1
     /*  392721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392724 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392729 */     // MIs[0] op2
     /*  392729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392748 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  392748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  392751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392753 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392755 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392757 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392767 */     GIR_RootConstrainSelectedInstOperands,
     /*  392768 */     // GIR_Coverage, 63472,
     /*  392768 */     GIR_EraseRootFromParent_Done,
     /*  392769 */   // Label 7050: @392769
     /*  392769 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(392843), // Rule ID 63527 //
     /*  392774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  392785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392795 */     // MIs[0] op1
     /*  392795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392803 */     // MIs[0] op2
     /*  392803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392822 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  392822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  392825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392827 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392829 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392831 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392841 */     GIR_RootConstrainSelectedInstOperands,
     /*  392842 */     // GIR_Coverage, 63527,
     /*  392842 */     GIR_EraseRootFromParent_Done,
     /*  392843 */   // Label 7051: @392843
     /*  392843 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(392917), // Rule ID 63528 //
     /*  392848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  392859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392869 */     // MIs[0] op1
     /*  392869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392872 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392877 */     // MIs[0] op2
     /*  392877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392896 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  392896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  392899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392901 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392903 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392905 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392915 */     GIR_RootConstrainSelectedInstOperands,
     /*  392916 */     // GIR_Coverage, 63528,
     /*  392916 */     GIR_EraseRootFromParent_Done,
     /*  392917 */   // Label 7052: @392917
     /*  392917 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(392991), // Rule ID 63583 //
     /*  392922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  392933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392943 */     // MIs[0] op1
     /*  392943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392951 */     // MIs[0] op2
     /*  392951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392970 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  392970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  392973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392975 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392977 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392979 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392989 */     GIR_RootConstrainSelectedInstOperands,
     /*  392990 */     // GIR_Coverage, 63583,
     /*  392990 */     GIR_EraseRootFromParent_Done,
     /*  392991 */   // Label 7053: @392991
     /*  392991 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(393065), // Rule ID 63584 //
     /*  392996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  393007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393017 */     // MIs[0] op1
     /*  393017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393025 */     // MIs[0] op2
     /*  393025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393044 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393049 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393051 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393053 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393063 */     GIR_RootConstrainSelectedInstOperands,
     /*  393064 */     // GIR_Coverage, 63584,
     /*  393064 */     GIR_EraseRootFromParent_Done,
     /*  393065 */   // Label 7054: @393065
     /*  393065 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(393139), // Rule ID 63639 //
     /*  393070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393091 */     // MIs[0] op1
     /*  393091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393094 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393099 */     // MIs[0] op2
     /*  393099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  393121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393123 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393125 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393127 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393137 */     GIR_RootConstrainSelectedInstOperands,
     /*  393138 */     // GIR_Coverage, 63639,
     /*  393138 */     GIR_EraseRootFromParent_Done,
     /*  393139 */   // Label 7055: @393139
     /*  393139 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(393213), // Rule ID 63640 //
     /*  393144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393165 */     // MIs[0] op1
     /*  393165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393168 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393173 */     // MIs[0] op2
     /*  393173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  393195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393197 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393199 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393201 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393211 */     GIR_RootConstrainSelectedInstOperands,
     /*  393212 */     // GIR_Coverage, 63640,
     /*  393212 */     GIR_EraseRootFromParent_Done,
     /*  393213 */   // Label 7056: @393213
     /*  393213 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(393287), // Rule ID 63695 //
     /*  393218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393239 */     // MIs[0] op1
     /*  393239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393242 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393247 */     // MIs[0] op2
     /*  393247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393250 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393266 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  393269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393271 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393273 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393275 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393285 */     GIR_RootConstrainSelectedInstOperands,
     /*  393286 */     // GIR_Coverage, 63695,
     /*  393286 */     GIR_EraseRootFromParent_Done,
     /*  393287 */   // Label 7057: @393287
     /*  393287 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(393361), // Rule ID 63696 //
     /*  393292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393313 */     // MIs[0] op1
     /*  393313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393316 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393321 */     // MIs[0] op2
     /*  393321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393340 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  393343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393345 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393347 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393349 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393359 */     GIR_RootConstrainSelectedInstOperands,
     /*  393360 */     // GIR_Coverage, 63696,
     /*  393360 */     GIR_EraseRootFromParent_Done,
     /*  393361 */   // Label 7058: @393361
     /*  393361 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(393435), // Rule ID 63751 //
     /*  393366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  393377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393387 */     // MIs[0] op1
     /*  393387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393395 */     // MIs[0] op2
     /*  393395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393414 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393419 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393421 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393423 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393433 */     GIR_RootConstrainSelectedInstOperands,
     /*  393434 */     // GIR_Coverage, 63751,
     /*  393434 */     GIR_EraseRootFromParent_Done,
     /*  393435 */   // Label 7059: @393435
     /*  393435 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(393509), // Rule ID 63752 //
     /*  393440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  393451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393461 */     // MIs[0] op1
     /*  393461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393464 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393469 */     // MIs[0] op2
     /*  393469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393472 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393488 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393493 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393495 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393497 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393507 */     GIR_RootConstrainSelectedInstOperands,
     /*  393508 */     // GIR_Coverage, 63752,
     /*  393508 */     GIR_EraseRootFromParent_Done,
     /*  393509 */   // Label 7060: @393509
     /*  393509 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(393583), // Rule ID 63807 //
     /*  393514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  393525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393535 */     // MIs[0] op1
     /*  393535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393543 */     // MIs[0] op2
     /*  393543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393562 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  393562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  393565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393567 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393569 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393571 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393581 */     GIR_RootConstrainSelectedInstOperands,
     /*  393582 */     // GIR_Coverage, 63807,
     /*  393582 */     GIR_EraseRootFromParent_Done,
     /*  393583 */   // Label 7061: @393583
     /*  393583 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(393657), // Rule ID 63808 //
     /*  393588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  393599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393609 */     // MIs[0] op1
     /*  393609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393617 */     // MIs[0] op2
     /*  393617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  393636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  393639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393641 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393643 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393645 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393655 */     GIR_RootConstrainSelectedInstOperands,
     /*  393656 */     // GIR_Coverage, 63808,
     /*  393656 */     GIR_EraseRootFromParent_Done,
     /*  393657 */   // Label 7062: @393657
     /*  393657 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(393731), // Rule ID 63863 //
     /*  393662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  393673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393683 */     // MIs[0] op1
     /*  393683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393691 */     // MIs[0] op2
     /*  393691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393710 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  393710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  393713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393715 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393717 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393719 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393729 */     GIR_RootConstrainSelectedInstOperands,
     /*  393730 */     // GIR_Coverage, 63863,
     /*  393730 */     GIR_EraseRootFromParent_Done,
     /*  393731 */   // Label 7063: @393731
     /*  393731 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(393805), // Rule ID 63864 //
     /*  393736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  393747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393757 */     // MIs[0] op1
     /*  393757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393765 */     // MIs[0] op2
     /*  393765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393784 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  393784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  393787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393789 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393791 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393793 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393803 */     GIR_RootConstrainSelectedInstOperands,
     /*  393804 */     // GIR_Coverage, 63864,
     /*  393804 */     GIR_EraseRootFromParent_Done,
     /*  393805 */   // Label 7064: @393805
     /*  393805 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(393879), // Rule ID 63919 //
     /*  393810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  393821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393831 */     // MIs[0] op1
     /*  393831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393839 */     // MIs[0] op2
     /*  393839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393858 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  393858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393863 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393865 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393867 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393877 */     GIR_RootConstrainSelectedInstOperands,
     /*  393878 */     // GIR_Coverage, 63919,
     /*  393878 */     GIR_EraseRootFromParent_Done,
     /*  393879 */   // Label 7065: @393879
     /*  393879 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(393953), // Rule ID 63920 //
     /*  393884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  393895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393905 */     // MIs[0] op1
     /*  393905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393908 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393913 */     // MIs[0] op2
     /*  393913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393932 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  393932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393937 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393939 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393941 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393951 */     GIR_RootConstrainSelectedInstOperands,
     /*  393952 */     // GIR_Coverage, 63920,
     /*  393952 */     GIR_EraseRootFromParent_Done,
     /*  393953 */   // Label 7066: @393953
     /*  393953 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(394027), // Rule ID 62849 //
     /*  393958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  393966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  393969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  393972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393979 */     // MIs[0] op1
     /*  393979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393982 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393991 */     // MIs[0] op3
     /*  393991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394006 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF8),
     /*  394009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394011 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394013 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394015 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394025 */     GIR_RootConstrainSelectedInstOperands,
     /*  394026 */     // GIR_Coverage, 62849,
     /*  394026 */     GIR_EraseRootFromParent_Done,
     /*  394027 */   // Label 7067: @394027
     /*  394027 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(394101), // Rule ID 62850 //
     /*  394032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  394043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  394046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394053 */     // MIs[0] op1
     /*  394053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394065 */     // MIs[0] op3
     /*  394065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394080 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF8),
     /*  394083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394085 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394087 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394089 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394099 */     GIR_RootConstrainSelectedInstOperands,
     /*  394100 */     // GIR_Coverage, 62850,
     /*  394100 */     GIR_EraseRootFromParent_Done,
     /*  394101 */   // Label 7068: @394101
     /*  394101 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(394175), // Rule ID 62887 //
     /*  394106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  394117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  394120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394127 */     // MIs[0] op1
     /*  394127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394139 */     // MIs[0] op3
     /*  394139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394154 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF4),
     /*  394157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394159 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394161 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394163 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394173 */     GIR_RootConstrainSelectedInstOperands,
     /*  394174 */     // GIR_Coverage, 62887,
     /*  394174 */     GIR_EraseRootFromParent_Done,
     /*  394175 */   // Label 7069: @394175
     /*  394175 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(394249), // Rule ID 62888 //
     /*  394180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  394191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  394194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394201 */     // MIs[0] op1
     /*  394201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394213 */     // MIs[0] op3
     /*  394213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394216 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394228 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF4),
     /*  394231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394233 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394235 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394237 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394247 */     GIR_RootConstrainSelectedInstOperands,
     /*  394248 */     // GIR_Coverage, 62888,
     /*  394248 */     GIR_EraseRootFromParent_Done,
     /*  394249 */   // Label 7070: @394249
     /*  394249 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(394323), // Rule ID 62931 //
     /*  394254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  394265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  394268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394275 */     // MIs[0] op1
     /*  394275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394278 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394287 */     // MIs[0] op3
     /*  394287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394290 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394302 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  394305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394307 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394309 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394311 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394321 */     GIR_RootConstrainSelectedInstOperands,
     /*  394322 */     // GIR_Coverage, 62931,
     /*  394322 */     GIR_EraseRootFromParent_Done,
     /*  394323 */   // Label 7071: @394323
     /*  394323 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(394397), // Rule ID 62932 //
     /*  394328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  394339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  394342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394349 */     // MIs[0] op1
     /*  394349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394361 */     // MIs[0] op3
     /*  394361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394376 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  394379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394381 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394383 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394385 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394395 */     GIR_RootConstrainSelectedInstOperands,
     /*  394396 */     // GIR_Coverage, 62932,
     /*  394396 */     GIR_EraseRootFromParent_Done,
     /*  394397 */   // Label 7072: @394397
     /*  394397 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(394471), // Rule ID 62975 //
     /*  394402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  394413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  394416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394423 */     // MIs[0] op1
     /*  394423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394435 */     // MIs[0] op3
     /*  394435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394438 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394450 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  394450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF4),
     /*  394453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394455 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394457 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394459 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394469 */     GIR_RootConstrainSelectedInstOperands,
     /*  394470 */     // GIR_Coverage, 62975,
     /*  394470 */     GIR_EraseRootFromParent_Done,
     /*  394471 */   // Label 7073: @394471
     /*  394471 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(394545), // Rule ID 62976 //
     /*  394476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  394487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  394490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394497 */     // MIs[0] op1
     /*  394497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394509 */     // MIs[0] op3
     /*  394509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394512 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394524 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  394524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF4),
     /*  394527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394529 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394531 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394533 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394543 */     GIR_RootConstrainSelectedInstOperands,
     /*  394544 */     // GIR_Coverage, 62976,
     /*  394544 */     GIR_EraseRootFromParent_Done,
     /*  394545 */   // Label 7074: @394545
     /*  394545 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(394619), // Rule ID 63031 //
     /*  394550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  394561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  394564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394571 */     // MIs[0] op1
     /*  394571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394583 */     // MIs[0] op3
     /*  394583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394598 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  394598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  394601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394603 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394605 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394607 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394617 */     GIR_RootConstrainSelectedInstOperands,
     /*  394618 */     // GIR_Coverage, 63031,
     /*  394618 */     GIR_EraseRootFromParent_Done,
     /*  394619 */   // Label 7075: @394619
     /*  394619 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(394693), // Rule ID 63032 //
     /*  394624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  394635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  394638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394645 */     // MIs[0] op1
     /*  394645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394657 */     // MIs[0] op3
     /*  394657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394672 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  394672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  394675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394677 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394679 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394681 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394691 */     GIR_RootConstrainSelectedInstOperands,
     /*  394692 */     // GIR_Coverage, 63032,
     /*  394692 */     GIR_EraseRootFromParent_Done,
     /*  394693 */   // Label 7076: @394693
     /*  394693 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(394767), // Rule ID 63087 //
     /*  394698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  394709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  394712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394719 */     // MIs[0] op1
     /*  394719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394731 */     // MIs[0] op3
     /*  394731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  394746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  394749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394751 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394753 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394755 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394765 */     GIR_RootConstrainSelectedInstOperands,
     /*  394766 */     // GIR_Coverage, 63087,
     /*  394766 */     GIR_EraseRootFromParent_Done,
     /*  394767 */   // Label 7077: @394767
     /*  394767 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(394841), // Rule ID 63088 //
     /*  394772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  394783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  394786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394793 */     // MIs[0] op1
     /*  394793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394805 */     // MIs[0] op3
     /*  394805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394808 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394820 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  394820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  394823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394825 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394827 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394829 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394839 */     GIR_RootConstrainSelectedInstOperands,
     /*  394840 */     // GIR_Coverage, 63088,
     /*  394840 */     GIR_EraseRootFromParent_Done,
     /*  394841 */   // Label 7078: @394841
     /*  394841 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(394915), // Rule ID 63143 //
     /*  394846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  394857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  394860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394867 */     // MIs[0] op1
     /*  394867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394879 */     // MIs[0] op3
     /*  394879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394894 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  394897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394899 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394901 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394903 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394913 */     GIR_RootConstrainSelectedInstOperands,
     /*  394914 */     // GIR_Coverage, 63143,
     /*  394914 */     GIR_EraseRootFromParent_Done,
     /*  394915 */   // Label 7079: @394915
     /*  394915 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(394989), // Rule ID 63144 //
     /*  394920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  394931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  394934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394941 */     // MIs[0] op1
     /*  394941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394944 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394953 */     // MIs[0] op3
     /*  394953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394968 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  394971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394973 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394975 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394977 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394987 */     GIR_RootConstrainSelectedInstOperands,
     /*  394988 */     // GIR_Coverage, 63144,
     /*  394988 */     GIR_EraseRootFromParent_Done,
     /*  394989 */   // Label 7080: @394989
     /*  394989 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(395063), // Rule ID 63187 //
     /*  394994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  395005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  395008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395015 */     // MIs[0] op1
     /*  395015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395027 */     // MIs[0] op3
     /*  395027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395042 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395047 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395049 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395051 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395061 */     GIR_RootConstrainSelectedInstOperands,
     /*  395062 */     // GIR_Coverage, 63187,
     /*  395062 */     GIR_EraseRootFromParent_Done,
     /*  395063 */   // Label 7081: @395063
     /*  395063 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(395137), // Rule ID 63188 //
     /*  395068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  395079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  395082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395089 */     // MIs[0] op1
     /*  395089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395092 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395101 */     // MIs[0] op3
     /*  395101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395116 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395121 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395123 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395125 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395135 */     GIR_RootConstrainSelectedInstOperands,
     /*  395136 */     // GIR_Coverage, 63188,
     /*  395136 */     GIR_EraseRootFromParent_Done,
     /*  395137 */   // Label 7082: @395137
     /*  395137 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(395211), // Rule ID 63243 //
     /*  395142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  395156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395163 */     // MIs[0] op1
     /*  395163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395166 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395175 */     // MIs[0] op3
     /*  395175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395178 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  395190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395195 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395197 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395199 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395209 */     GIR_RootConstrainSelectedInstOperands,
     /*  395210 */     // GIR_Coverage, 63243,
     /*  395210 */     GIR_EraseRootFromParent_Done,
     /*  395211 */   // Label 7083: @395211
     /*  395211 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(395285), // Rule ID 63244 //
     /*  395216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  395230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395237 */     // MIs[0] op1
     /*  395237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395249 */     // MIs[0] op3
     /*  395249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  395264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395269 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395271 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395273 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395283 */     GIR_RootConstrainSelectedInstOperands,
     /*  395284 */     // GIR_Coverage, 63244,
     /*  395284 */     GIR_EraseRootFromParent_Done,
     /*  395285 */   // Label 7084: @395285
     /*  395285 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(395359), // Rule ID 63299 //
     /*  395290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  395304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395311 */     // MIs[0] op1
     /*  395311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395323 */     // MIs[0] op3
     /*  395323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395338 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  395338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395343 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395345 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395347 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  395357 */     GIR_RootConstrainSelectedInstOperands,
     /*  395358 */     // GIR_Coverage, 63299,
     /*  395358 */     GIR_EraseRootFromParent_Done,
     /*  395359 */   // Label 7085: @395359
     /*  395359 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(395433), // Rule ID 63300 //
     /*  395364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  395378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395385 */     // MIs[0] op1
     /*  395385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395397 */     // MIs[0] op3
     /*  395397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395400 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395412 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  395412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395417 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395419 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395421 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  395431 */     GIR_RootConstrainSelectedInstOperands,
     /*  395432 */     // GIR_Coverage, 63300,
     /*  395432 */     GIR_EraseRootFromParent_Done,
     /*  395433 */   // Label 7086: @395433
     /*  395433 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(395507), // Rule ID 63355 //
     /*  395438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  395449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  395452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395459 */     // MIs[0] op1
     /*  395459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395471 */     // MIs[0] op3
     /*  395471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395486 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  395489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395491 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395493 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395495 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395505 */     GIR_RootConstrainSelectedInstOperands,
     /*  395506 */     // GIR_Coverage, 63355,
     /*  395506 */     GIR_EraseRootFromParent_Done,
     /*  395507 */   // Label 7087: @395507
     /*  395507 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(395581), // Rule ID 63356 //
     /*  395512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  395523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  395526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395533 */     // MIs[0] op1
     /*  395533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395545 */     // MIs[0] op3
     /*  395545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395560 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  395560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  395563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395565 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395567 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395569 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395579 */     GIR_RootConstrainSelectedInstOperands,
     /*  395580 */     // GIR_Coverage, 63356,
     /*  395580 */     GIR_EraseRootFromParent_Done,
     /*  395581 */   // Label 7088: @395581
     /*  395581 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(395655), // Rule ID 63399 //
     /*  395586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  395597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  395600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395607 */     // MIs[0] op1
     /*  395607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395619 */     // MIs[0] op3
     /*  395619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395622 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395634 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  395637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395639 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395641 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395643 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395653 */     GIR_RootConstrainSelectedInstOperands,
     /*  395654 */     // GIR_Coverage, 63399,
     /*  395654 */     GIR_EraseRootFromParent_Done,
     /*  395655 */   // Label 7089: @395655
     /*  395655 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(395729), // Rule ID 63400 //
     /*  395660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  395671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  395674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395681 */     // MIs[0] op1
     /*  395681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395693 */     // MIs[0] op3
     /*  395693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395708 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  395708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  395711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395713 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395715 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395717 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395727 */     GIR_RootConstrainSelectedInstOperands,
     /*  395728 */     // GIR_Coverage, 63400,
     /*  395728 */     GIR_EraseRootFromParent_Done,
     /*  395729 */   // Label 7090: @395729
     /*  395729 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(395803), // Rule ID 63443 //
     /*  395734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  395745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  395748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395755 */     // MIs[0] op1
     /*  395755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395758 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395767 */     // MIs[0] op3
     /*  395767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395782 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  395785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395787 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395789 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395791 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395801 */     GIR_RootConstrainSelectedInstOperands,
     /*  395802 */     // GIR_Coverage, 63443,
     /*  395802 */     GIR_EraseRootFromParent_Done,
     /*  395803 */   // Label 7091: @395803
     /*  395803 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(395877), // Rule ID 63444 //
     /*  395808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  395819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  395822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395829 */     // MIs[0] op1
     /*  395829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395832 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395841 */     // MIs[0] op3
     /*  395841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395856 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  395856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  395859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395861 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395863 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395865 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395875 */     GIR_RootConstrainSelectedInstOperands,
     /*  395876 */     // GIR_Coverage, 63444,
     /*  395876 */     GIR_EraseRootFromParent_Done,
     /*  395877 */   // Label 7092: @395877
     /*  395877 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(395951), // Rule ID 63487 //
     /*  395882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  395893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  395896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395903 */     // MIs[0] op1
     /*  395903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395915 */     // MIs[0] op3
     /*  395915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395930 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  395933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395935 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395937 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395939 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395949 */     GIR_RootConstrainSelectedInstOperands,
     /*  395950 */     // GIR_Coverage, 63487,
     /*  395950 */     GIR_EraseRootFromParent_Done,
     /*  395951 */   // Label 7093: @395951
     /*  395951 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(396025), // Rule ID 63488 //
     /*  395956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  395967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  395970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395977 */     // MIs[0] op1
     /*  395977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395989 */     // MIs[0] op3
     /*  395989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396004 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396009 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396011 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396013 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396023 */     GIR_RootConstrainSelectedInstOperands,
     /*  396024 */     // GIR_Coverage, 63488,
     /*  396024 */     GIR_EraseRootFromParent_Done,
     /*  396025 */   // Label 7094: @396025
     /*  396025 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(396099), // Rule ID 63543 //
     /*  396030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  396041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  396044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396051 */     // MIs[0] op1
     /*  396051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396063 */     // MIs[0] op3
     /*  396063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396078 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396083 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396085 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396087 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396097 */     GIR_RootConstrainSelectedInstOperands,
     /*  396098 */     // GIR_Coverage, 63543,
     /*  396098 */     GIR_EraseRootFromParent_Done,
     /*  396099 */   // Label 7095: @396099
     /*  396099 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(396173), // Rule ID 63544 //
     /*  396104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  396115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  396118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396125 */     // MIs[0] op1
     /*  396125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396128 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396137 */     // MIs[0] op3
     /*  396137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396140 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396152 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396157 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396159 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396161 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396171 */     GIR_RootConstrainSelectedInstOperands,
     /*  396172 */     // GIR_Coverage, 63544,
     /*  396172 */     GIR_EraseRootFromParent_Done,
     /*  396173 */   // Label 7096: @396173
     /*  396173 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(396247), // Rule ID 63599 //
     /*  396178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  396189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  396192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396199 */     // MIs[0] op1
     /*  396199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396211 */     // MIs[0] op3
     /*  396211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396226 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  396229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396231 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396233 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396235 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396245 */     GIR_RootConstrainSelectedInstOperands,
     /*  396246 */     // GIR_Coverage, 63599,
     /*  396246 */     GIR_EraseRootFromParent_Done,
     /*  396247 */   // Label 7097: @396247
     /*  396247 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(396321), // Rule ID 63600 //
     /*  396252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  396263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  396266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396273 */     // MIs[0] op1
     /*  396273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396285 */     // MIs[0] op3
     /*  396285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396300 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  396303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396305 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396307 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396309 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396319 */     GIR_RootConstrainSelectedInstOperands,
     /*  396320 */     // GIR_Coverage, 63600,
     /*  396320 */     GIR_EraseRootFromParent_Done,
     /*  396321 */   // Label 7098: @396321
     /*  396321 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(396395), // Rule ID 63655 //
     /*  396326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  396337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  396340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396347 */     // MIs[0] op1
     /*  396347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396359 */     // MIs[0] op3
     /*  396359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396379 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396381 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396383 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396393 */     GIR_RootConstrainSelectedInstOperands,
     /*  396394 */     // GIR_Coverage, 63655,
     /*  396394 */     GIR_EraseRootFromParent_Done,
     /*  396395 */   // Label 7099: @396395
     /*  396395 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(396469), // Rule ID 63656 //
     /*  396400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  396411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  396414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396421 */     // MIs[0] op1
     /*  396421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396433 */     // MIs[0] op3
     /*  396433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396448 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  396448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396453 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396455 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396457 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396467 */     GIR_RootConstrainSelectedInstOperands,
     /*  396468 */     // GIR_Coverage, 63656,
     /*  396468 */     GIR_EraseRootFromParent_Done,
     /*  396469 */   // Label 7100: @396469
     /*  396469 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(396543), // Rule ID 63711 //
     /*  396474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  396485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  396488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396495 */     // MIs[0] op1
     /*  396495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396507 */     // MIs[0] op3
     /*  396507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396522 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396527 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396529 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396531 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396541 */     GIR_RootConstrainSelectedInstOperands,
     /*  396542 */     // GIR_Coverage, 63711,
     /*  396542 */     GIR_EraseRootFromParent_Done,
     /*  396543 */   // Label 7101: @396543
     /*  396543 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(396617), // Rule ID 63712 //
     /*  396548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  396559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  396562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396569 */     // MIs[0] op1
     /*  396569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396572 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396581 */     // MIs[0] op3
     /*  396581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  396596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396601 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396603 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396605 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396615 */     GIR_RootConstrainSelectedInstOperands,
     /*  396616 */     // GIR_Coverage, 63712,
     /*  396616 */     GIR_EraseRootFromParent_Done,
     /*  396617 */   // Label 7102: @396617
     /*  396617 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(396691), // Rule ID 63767 //
     /*  396622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  396633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  396636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396643 */     // MIs[0] op1
     /*  396643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396655 */     // MIs[0] op3
     /*  396655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396670 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  396673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396675 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396677 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396679 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396689 */     GIR_RootConstrainSelectedInstOperands,
     /*  396690 */     // GIR_Coverage, 63767,
     /*  396690 */     GIR_EraseRootFromParent_Done,
     /*  396691 */   // Label 7103: @396691
     /*  396691 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(396765), // Rule ID 63768 //
     /*  396696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  396707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  396710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396717 */     // MIs[0] op1
     /*  396717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396720 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396729 */     // MIs[0] op3
     /*  396729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396744 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  396744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  396747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396749 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396751 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396753 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396763 */     GIR_RootConstrainSelectedInstOperands,
     /*  396764 */     // GIR_Coverage, 63768,
     /*  396764 */     GIR_EraseRootFromParent_Done,
     /*  396765 */   // Label 7104: @396765
     /*  396765 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(396839), // Rule ID 63823 //
     /*  396770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  396781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  396784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396791 */     // MIs[0] op1
     /*  396791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396803 */     // MIs[0] op3
     /*  396803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396818 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  396818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396823 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396825 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396827 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396837 */     GIR_RootConstrainSelectedInstOperands,
     /*  396838 */     // GIR_Coverage, 63823,
     /*  396838 */     GIR_EraseRootFromParent_Done,
     /*  396839 */   // Label 7105: @396839
     /*  396839 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(396913), // Rule ID 63824 //
     /*  396844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  396855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  396858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396865 */     // MIs[0] op1
     /*  396865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396877 */     // MIs[0] op3
     /*  396877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  396892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396897 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396899 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396901 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396911 */     GIR_RootConstrainSelectedInstOperands,
     /*  396912 */     // GIR_Coverage, 63824,
     /*  396912 */     GIR_EraseRootFromParent_Done,
     /*  396913 */   // Label 7106: @396913
     /*  396913 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(396987), // Rule ID 63879 //
     /*  396918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  396929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  396932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396939 */     // MIs[0] op1
     /*  396939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396942 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396951 */     // MIs[0] op3
     /*  396951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  396966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396971 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396973 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396975 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396985 */     GIR_RootConstrainSelectedInstOperands,
     /*  396986 */     // GIR_Coverage, 63879,
     /*  396986 */     GIR_EraseRootFromParent_Done,
     /*  396987 */   // Label 7107: @396987
     /*  396987 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(397061), // Rule ID 63880 //
     /*  396992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  397003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  397006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397013 */     // MIs[0] op1
     /*  397013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397016 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397025 */     // MIs[0] op3
     /*  397025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397040 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  397043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397045 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397047 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397049 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397059 */     GIR_RootConstrainSelectedInstOperands,
     /*  397060 */     // GIR_Coverage, 63880,
     /*  397060 */     GIR_EraseRootFromParent_Done,
     /*  397061 */   // Label 7108: @397061
     /*  397061 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(397135), // Rule ID 63935 //
     /*  397066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  397077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  397080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397087 */     // MIs[0] op1
     /*  397087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397090 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397099 */     // MIs[0] op3
     /*  397099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  397117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397119 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397121 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397123 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397133 */     GIR_RootConstrainSelectedInstOperands,
     /*  397134 */     // GIR_Coverage, 63935,
     /*  397134 */     GIR_EraseRootFromParent_Done,
     /*  397135 */   // Label 7109: @397135
     /*  397135 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(397209), // Rule ID 63936 //
     /*  397140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  397151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  397154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397161 */     // MIs[0] op1
     /*  397161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397173 */     // MIs[0] op3
     /*  397173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397188 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  397191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397193 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397195 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397197 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397207 */     GIR_RootConstrainSelectedInstOperands,
     /*  397208 */     // GIR_Coverage, 63936,
     /*  397208 */     GIR_EraseRootFromParent_Done,
     /*  397209 */   // Label 7110: @397209
     /*  397209 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(397284), // Rule ID 7360 //
     /*  397214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  397225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  397228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  397231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397260 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  397260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  397263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397282 */     GIR_RootConstrainSelectedInstOperands,
     /*  397283 */     // GIR_Coverage, 7360,
     /*  397283 */     GIR_EraseRootFromParent_Done,
     /*  397284 */   // Label 7111: @397284
     /*  397284 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(397359), // Rule ID 7361 //
     /*  397289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  397300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  397303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  397306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397335 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  397335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  397338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397357 */     GIR_RootConstrainSelectedInstOperands,
     /*  397358 */     // GIR_Coverage, 7361,
     /*  397358 */     GIR_EraseRootFromParent_Done,
     /*  397359 */   // Label 7112: @397359
     /*  397359 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(397434), // Rule ID 7364 //
     /*  397364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  397375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  397378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  397381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397410 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  397410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397432 */     GIR_RootConstrainSelectedInstOperands,
     /*  397433 */     // GIR_Coverage, 7364,
     /*  397433 */     GIR_EraseRootFromParent_Done,
     /*  397434 */   // Label 7113: @397434
     /*  397434 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(397509), // Rule ID 7365 //
     /*  397439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  397450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  397453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  397456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397485 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  397485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397507 */     GIR_RootConstrainSelectedInstOperands,
     /*  397508 */     // GIR_Coverage, 7365,
     /*  397508 */     GIR_EraseRootFromParent_Done,
     /*  397509 */   // Label 7114: @397509
     /*  397509 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(397584), // Rule ID 7368 //
     /*  397514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  397525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  397528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  397531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397560 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  397560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397582 */     GIR_RootConstrainSelectedInstOperands,
     /*  397583 */     // GIR_Coverage, 7368,
     /*  397583 */     GIR_EraseRootFromParent_Done,
     /*  397584 */   // Label 7115: @397584
     /*  397584 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(397659), // Rule ID 7369 //
     /*  397589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  397600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  397603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  397606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397635 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  397635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397657 */     GIR_RootConstrainSelectedInstOperands,
     /*  397658 */     // GIR_Coverage, 7369,
     /*  397658 */     GIR_EraseRootFromParent_Done,
     /*  397659 */   // Label 7116: @397659
     /*  397659 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(397734), // Rule ID 7372 //
     /*  397664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  397675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  397678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  397681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397710 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  397710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397732 */     GIR_RootConstrainSelectedInstOperands,
     /*  397733 */     // GIR_Coverage, 7372,
     /*  397733 */     GIR_EraseRootFromParent_Done,
     /*  397734 */   // Label 7117: @397734
     /*  397734 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(397809), // Rule ID 7373 //
     /*  397739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  397750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  397753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  397756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397774 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397785 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  397785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397807 */     GIR_RootConstrainSelectedInstOperands,
     /*  397808 */     // GIR_Coverage, 7373,
     /*  397808 */     GIR_EraseRootFromParent_Done,
     /*  397809 */   // Label 7118: @397809
     /*  397809 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(397884), // Rule ID 7376 //
     /*  397814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  397825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  397828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  397831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  397860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397882 */     GIR_RootConstrainSelectedInstOperands,
     /*  397883 */     // GIR_Coverage, 7376,
     /*  397883 */     GIR_EraseRootFromParent_Done,
     /*  397884 */   // Label 7119: @397884
     /*  397884 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(397959), // Rule ID 7377 //
     /*  397889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  397900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  397903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  397906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397935 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  397935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397957 */     GIR_RootConstrainSelectedInstOperands,
     /*  397958 */     // GIR_Coverage, 7377,
     /*  397958 */     GIR_EraseRootFromParent_Done,
     /*  397959 */   // Label 7120: @397959
     /*  397959 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(398034), // Rule ID 7380 //
     /*  397964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  397975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  397978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  397981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398010 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  398010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398032 */     GIR_RootConstrainSelectedInstOperands,
     /*  398033 */     // GIR_Coverage, 7380,
     /*  398033 */     GIR_EraseRootFromParent_Done,
     /*  398034 */   // Label 7121: @398034
     /*  398034 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(398109), // Rule ID 7381 //
     /*  398039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  398050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  398053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  398056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398085 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  398085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398107 */     GIR_RootConstrainSelectedInstOperands,
     /*  398108 */     // GIR_Coverage, 7381,
     /*  398108 */     GIR_EraseRootFromParent_Done,
     /*  398109 */   // Label 7122: @398109
     /*  398109 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(398184), // Rule ID 7384 //
     /*  398114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  398125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  398128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  398131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398160 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  398160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398182 */     GIR_RootConstrainSelectedInstOperands,
     /*  398183 */     // GIR_Coverage, 7384,
     /*  398183 */     GIR_EraseRootFromParent_Done,
     /*  398184 */   // Label 7123: @398184
     /*  398184 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(398259), // Rule ID 7385 //
     /*  398189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  398200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  398203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  398206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398235 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  398235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398257 */     GIR_RootConstrainSelectedInstOperands,
     /*  398258 */     // GIR_Coverage, 7385,
     /*  398258 */     GIR_EraseRootFromParent_Done,
     /*  398259 */   // Label 7124: @398259
     /*  398259 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(398334), // Rule ID 7388 //
     /*  398264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  398275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  398278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  398281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398310 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  398310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398332 */     GIR_RootConstrainSelectedInstOperands,
     /*  398333 */     // GIR_Coverage, 7388,
     /*  398333 */     GIR_EraseRootFromParent_Done,
     /*  398334 */   // Label 7125: @398334
     /*  398334 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(398409), // Rule ID 7389 //
     /*  398339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  398350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  398353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  398356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398385 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  398385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398407 */     GIR_RootConstrainSelectedInstOperands,
     /*  398408 */     // GIR_Coverage, 7389,
     /*  398408 */     GIR_EraseRootFromParent_Done,
     /*  398409 */   // Label 7126: @398409
     /*  398409 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(398484), // Rule ID 7392 //
     /*  398414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  398425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  398428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  398431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398460 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  398460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398482 */     GIR_RootConstrainSelectedInstOperands,
     /*  398483 */     // GIR_Coverage, 7392,
     /*  398483 */     GIR_EraseRootFromParent_Done,
     /*  398484 */   // Label 7127: @398484
     /*  398484 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(398559), // Rule ID 7393 //
     /*  398489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  398500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  398503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  398506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398535 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  398535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398557 */     GIR_RootConstrainSelectedInstOperands,
     /*  398558 */     // GIR_Coverage, 7393,
     /*  398558 */     GIR_EraseRootFromParent_Done,
     /*  398559 */   // Label 7128: @398559
     /*  398559 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(398634), // Rule ID 7396 //
     /*  398564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  398567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  398575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  398578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  398581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398610 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  398610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  398629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398632 */     GIR_RootConstrainSelectedInstOperands,
     /*  398633 */     // GIR_Coverage, 7396,
     /*  398633 */     GIR_EraseRootFromParent_Done,
     /*  398634 */   // Label 7129: @398634
     /*  398634 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(398709), // Rule ID 7397 //
     /*  398639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  398642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  398650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  398653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  398656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398685 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  398685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  398704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398707 */     GIR_RootConstrainSelectedInstOperands,
     /*  398708 */     // GIR_Coverage, 7397,
     /*  398708 */     GIR_EraseRootFromParent_Done,
     /*  398709 */   // Label 7130: @398709
     /*  398709 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(398784), // Rule ID 7400 //
     /*  398714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  398725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  398728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  398731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398749 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398760 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  398760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  398763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398782 */     GIR_RootConstrainSelectedInstOperands,
     /*  398783 */     // GIR_Coverage, 7400,
     /*  398783 */     GIR_EraseRootFromParent_Done,
     /*  398784 */   // Label 7131: @398784
     /*  398784 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(398859), // Rule ID 7401 //
     /*  398789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  398800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  398803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  398806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398835 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  398835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  398838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398857 */     GIR_RootConstrainSelectedInstOperands,
     /*  398858 */     // GIR_Coverage, 7401,
     /*  398858 */     GIR_EraseRootFromParent_Done,
     /*  398859 */   // Label 7132: @398859
     /*  398859 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(398934), // Rule ID 7404 //
     /*  398864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  398875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  398878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  398881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398910 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  398910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  398913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398932 */     GIR_RootConstrainSelectedInstOperands,
     /*  398933 */     // GIR_Coverage, 7404,
     /*  398933 */     GIR_EraseRootFromParent_Done,
     /*  398934 */   // Label 7133: @398934
     /*  398934 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(399009), // Rule ID 7405 //
     /*  398939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  398950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  398953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  398956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398985 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  398985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  398988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399007 */     GIR_RootConstrainSelectedInstOperands,
     /*  399008 */     // GIR_Coverage, 7405,
     /*  399008 */     GIR_EraseRootFromParent_Done,
     /*  399009 */   // Label 7134: @399009
     /*  399009 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(399084), // Rule ID 7408 //
     /*  399014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  399025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  399028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  399031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399060 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  399060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399082 */     GIR_RootConstrainSelectedInstOperands,
     /*  399083 */     // GIR_Coverage, 7408,
     /*  399083 */     GIR_EraseRootFromParent_Done,
     /*  399084 */   // Label 7135: @399084
     /*  399084 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(399159), // Rule ID 7409 //
     /*  399089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  399100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  399103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  399106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399135 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  399135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399157 */     GIR_RootConstrainSelectedInstOperands,
     /*  399158 */     // GIR_Coverage, 7409,
     /*  399158 */     GIR_EraseRootFromParent_Done,
     /*  399159 */   // Label 7136: @399159
     /*  399159 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(399234), // Rule ID 7412 //
     /*  399164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  399178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399210 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  399210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399232 */     GIR_RootConstrainSelectedInstOperands,
     /*  399233 */     // GIR_Coverage, 7412,
     /*  399233 */     GIR_EraseRootFromParent_Done,
     /*  399234 */   // Label 7137: @399234
     /*  399234 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(399309), // Rule ID 7413 //
     /*  399239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  399253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399285 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  399285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399307 */     GIR_RootConstrainSelectedInstOperands,
     /*  399308 */     // GIR_Coverage, 7413,
     /*  399308 */     GIR_EraseRootFromParent_Done,
     /*  399309 */   // Label 7138: @399309
     /*  399309 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(399384), // Rule ID 7416 //
     /*  399314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  399328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399360 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  399360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399382 */     GIR_RootConstrainSelectedInstOperands,
     /*  399383 */     // GIR_Coverage, 7416,
     /*  399383 */     GIR_EraseRootFromParent_Done,
     /*  399384 */   // Label 7139: @399384
     /*  399384 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(399459), // Rule ID 7417 //
     /*  399389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  399403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399435 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  399435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399457 */     GIR_RootConstrainSelectedInstOperands,
     /*  399458 */     // GIR_Coverage, 7417,
     /*  399458 */     GIR_EraseRootFromParent_Done,
     /*  399459 */   // Label 7140: @399459
     /*  399459 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(399534), // Rule ID 7420 //
     /*  399464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  399475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  399478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  399481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399510 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  399510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399532 */     GIR_RootConstrainSelectedInstOperands,
     /*  399533 */     // GIR_Coverage, 7420,
     /*  399533 */     GIR_EraseRootFromParent_Done,
     /*  399534 */   // Label 7141: @399534
     /*  399534 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(399609), // Rule ID 7421 //
     /*  399539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  399550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  399553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  399556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399585 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  399585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399607 */     GIR_RootConstrainSelectedInstOperands,
     /*  399608 */     // GIR_Coverage, 7421,
     /*  399608 */     GIR_EraseRootFromParent_Done,
     /*  399609 */   // Label 7142: @399609
     /*  399609 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(399684), // Rule ID 7424 //
     /*  399614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  399625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  399628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  399631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399660 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  399660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399682 */     GIR_RootConstrainSelectedInstOperands,
     /*  399683 */     // GIR_Coverage, 7424,
     /*  399683 */     GIR_EraseRootFromParent_Done,
     /*  399684 */   // Label 7143: @399684
     /*  399684 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(399759), // Rule ID 7425 //
     /*  399689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  399700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  399703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  399706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399735 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  399735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399757 */     GIR_RootConstrainSelectedInstOperands,
     /*  399758 */     // GIR_Coverage, 7425,
     /*  399758 */     GIR_EraseRootFromParent_Done,
     /*  399759 */   // Label 7144: @399759
     /*  399759 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(399834), // Rule ID 7428 //
     /*  399764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  399775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  399778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  399781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399810 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  399810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399832 */     GIR_RootConstrainSelectedInstOperands,
     /*  399833 */     // GIR_Coverage, 7428,
     /*  399833 */     GIR_EraseRootFromParent_Done,
     /*  399834 */   // Label 7145: @399834
     /*  399834 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(399909), // Rule ID 7429 //
     /*  399839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  399850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  399853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  399856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399885 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  399885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399907 */     GIR_RootConstrainSelectedInstOperands,
     /*  399908 */     // GIR_Coverage, 7429,
     /*  399908 */     GIR_EraseRootFromParent_Done,
     /*  399909 */   // Label 7146: @399909
     /*  399909 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(399984), // Rule ID 7432 //
     /*  399914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  399925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  399928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  399931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  399960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399982 */     GIR_RootConstrainSelectedInstOperands,
     /*  399983 */     // GIR_Coverage, 7432,
     /*  399983 */     GIR_EraseRootFromParent_Done,
     /*  399984 */   // Label 7147: @399984
     /*  399984 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(400059), // Rule ID 7433 //
     /*  399989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  400000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  400003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  400006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400035 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  400035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400057 */     GIR_RootConstrainSelectedInstOperands,
     /*  400058 */     // GIR_Coverage, 7433,
     /*  400058 */     GIR_EraseRootFromParent_Done,
     /*  400059 */   // Label 7148: @400059
     /*  400059 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(400134), // Rule ID 7436 //
     /*  400064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  400067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  400078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  400110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  400113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400132 */     GIR_RootConstrainSelectedInstOperands,
     /*  400133 */     // GIR_Coverage, 7436,
     /*  400133 */     GIR_EraseRootFromParent_Done,
     /*  400134 */   // Label 7149: @400134
     /*  400134 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(400209), // Rule ID 7437 //
     /*  400139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  400142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  400153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400185 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  400185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  400188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400207 */     GIR_RootConstrainSelectedInstOperands,
     /*  400208 */     // GIR_Coverage, 7437,
     /*  400208 */     GIR_EraseRootFromParent_Done,
     /*  400209 */   // Label 7150: @400209
     /*  400209 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(400284), // Rule ID 7440 //
     /*  400214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  400217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  400225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  400228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  400231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400260 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  400260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  400263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400282 */     GIR_RootConstrainSelectedInstOperands,
     /*  400283 */     // GIR_Coverage, 7440,
     /*  400283 */     GIR_EraseRootFromParent_Done,
     /*  400284 */   // Label 7151: @400284
     /*  400284 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(400359), // Rule ID 7441 //
     /*  400289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  400292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  400300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  400303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  400306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400335 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  400335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  400338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400357 */     GIR_RootConstrainSelectedInstOperands,
     /*  400358 */     // GIR_Coverage, 7441,
     /*  400358 */     GIR_EraseRootFromParent_Done,
     /*  400359 */   // Label 7152: @400359
     /*  400359 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(400434), // Rule ID 7444 //
     /*  400364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  400367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  400375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  400378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  400381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400410 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  400410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400432 */     GIR_RootConstrainSelectedInstOperands,
     /*  400433 */     // GIR_Coverage, 7444,
     /*  400433 */     GIR_EraseRootFromParent_Done,
     /*  400434 */   // Label 7153: @400434
     /*  400434 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(400509), // Rule ID 7445 //
     /*  400439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  400442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  400450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  400453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  400456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400485 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  400485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400507 */     GIR_RootConstrainSelectedInstOperands,
     /*  400508 */     // GIR_Coverage, 7445,
     /*  400508 */     GIR_EraseRootFromParent_Done,
     /*  400509 */   // Label 7154: @400509
     /*  400509 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(400586), // Rule ID 2750 //
     /*  400514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  400517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  400525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  400528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  400531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400546 */     // MIs[0] Operand 4
     /*  400546 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400564 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  400564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  400567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400584 */     GIR_RootConstrainSelectedInstOperands,
     /*  400585 */     // GIR_Coverage, 2750,
     /*  400585 */     GIR_EraseRootFromParent_Done,
     /*  400586 */   // Label 7155: @400586
     /*  400586 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(400663), // Rule ID 2751 //
     /*  400591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  400594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  400602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  400605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  400608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400623 */     // MIs[0] Operand 4
     /*  400623 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400641 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  400641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  400644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400661 */     GIR_RootConstrainSelectedInstOperands,
     /*  400662 */     // GIR_Coverage, 2751,
     /*  400662 */     GIR_EraseRootFromParent_Done,
     /*  400663 */   // Label 7156: @400663
     /*  400663 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(400740), // Rule ID 20642 //
     /*  400668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  400671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  400679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  400682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  400685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400700 */     // MIs[0] Operand 4
     /*  400700 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  400718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  400721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400738 */     GIR_RootConstrainSelectedInstOperands,
     /*  400739 */     // GIR_Coverage, 20642,
     /*  400739 */     GIR_EraseRootFromParent_Done,
     /*  400740 */   // Label 7157: @400740
     /*  400740 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(400817), // Rule ID 20643 //
     /*  400745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  400748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  400756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  400759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  400762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400777 */     // MIs[0] Operand 4
     /*  400777 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400795 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  400795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  400798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400815 */     GIR_RootConstrainSelectedInstOperands,
     /*  400816 */     // GIR_Coverage, 20643,
     /*  400816 */     GIR_EraseRootFromParent_Done,
     /*  400817 */   // Label 7158: @400817
     /*  400817 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(400894), // Rule ID 20646 //
     /*  400822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  400825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  400833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  400836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  400839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400854 */     // MIs[0] Operand 4
     /*  400854 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400872 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  400872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  400875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400892 */     GIR_RootConstrainSelectedInstOperands,
     /*  400893 */     // GIR_Coverage, 20646,
     /*  400893 */     GIR_EraseRootFromParent_Done,
     /*  400894 */   // Label 7159: @400894
     /*  400894 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(400971), // Rule ID 20647 //
     /*  400899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  400902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  400910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  400913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  400916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400931 */     // MIs[0] Operand 4
     /*  400931 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400949 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  400949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  400952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400969 */     GIR_RootConstrainSelectedInstOperands,
     /*  400970 */     // GIR_Coverage, 20647,
     /*  400970 */     GIR_EraseRootFromParent_Done,
     /*  400971 */   // Label 7160: @400971
     /*  400971 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(401048), // Rule ID 20650 //
     /*  400976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  400979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  400987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  400990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  400993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401008 */     // MIs[0] Operand 4
     /*  401008 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401026 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401046 */     GIR_RootConstrainSelectedInstOperands,
     /*  401047 */     // GIR_Coverage, 20650,
     /*  401047 */     GIR_EraseRootFromParent_Done,
     /*  401048 */   // Label 7161: @401048
     /*  401048 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(401125), // Rule ID 20651 //
     /*  401053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  401064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  401067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  401070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401085 */     // MIs[0] Operand 4
     /*  401085 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401103 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401123 */     GIR_RootConstrainSelectedInstOperands,
     /*  401124 */     // GIR_Coverage, 20651,
     /*  401124 */     GIR_EraseRootFromParent_Done,
     /*  401125 */   // Label 7162: @401125
     /*  401125 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(401202), // Rule ID 20654 //
     /*  401130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  401133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  401141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  401144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  401147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401162 */     // MIs[0] Operand 4
     /*  401162 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401180 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  401180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401200 */     GIR_RootConstrainSelectedInstOperands,
     /*  401201 */     // GIR_Coverage, 20654,
     /*  401201 */     GIR_EraseRootFromParent_Done,
     /*  401202 */   // Label 7163: @401202
     /*  401202 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(401279), // Rule ID 20655 //
     /*  401207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  401210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  401218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  401221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  401224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401239 */     // MIs[0] Operand 4
     /*  401239 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401257 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  401257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401277 */     GIR_RootConstrainSelectedInstOperands,
     /*  401278 */     // GIR_Coverage, 20655,
     /*  401278 */     GIR_EraseRootFromParent_Done,
     /*  401279 */   // Label 7164: @401279
     /*  401279 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(401356), // Rule ID 20658 //
     /*  401284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  401287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  401295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  401298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  401301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401316 */     // MIs[0] Operand 4
     /*  401316 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401334 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  401334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  401351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401354 */     GIR_RootConstrainSelectedInstOperands,
     /*  401355 */     // GIR_Coverage, 20658,
     /*  401355 */     GIR_EraseRootFromParent_Done,
     /*  401356 */   // Label 7165: @401356
     /*  401356 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(401433), // Rule ID 20659 //
     /*  401361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  401364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  401372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  401375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  401378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401393 */     // MIs[0] Operand 4
     /*  401393 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401411 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  401411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  401428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401431 */     GIR_RootConstrainSelectedInstOperands,
     /*  401432 */     // GIR_Coverage, 20659,
     /*  401432 */     GIR_EraseRootFromParent_Done,
     /*  401433 */   // Label 7166: @401433
     /*  401433 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(401510), // Rule ID 20662 //
     /*  401438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  401449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  401452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  401455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401470 */     // MIs[0] Operand 4
     /*  401470 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401488 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  401491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401508 */     GIR_RootConstrainSelectedInstOperands,
     /*  401509 */     // GIR_Coverage, 20662,
     /*  401509 */     GIR_EraseRootFromParent_Done,
     /*  401510 */   // Label 7167: @401510
     /*  401510 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(401587), // Rule ID 20663 //
     /*  401515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  401526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  401529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  401532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401547 */     // MIs[0] Operand 4
     /*  401547 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401565 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  401568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401585 */     GIR_RootConstrainSelectedInstOperands,
     /*  401586 */     // GIR_Coverage, 20663,
     /*  401586 */     GIR_EraseRootFromParent_Done,
     /*  401587 */   // Label 7168: @401587
     /*  401587 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(401664), // Rule ID 20666 //
     /*  401592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  401603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  401606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  401609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401624 */     // MIs[0] Operand 4
     /*  401624 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401642 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  401645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401662 */     GIR_RootConstrainSelectedInstOperands,
     /*  401663 */     // GIR_Coverage, 20666,
     /*  401663 */     GIR_EraseRootFromParent_Done,
     /*  401664 */   // Label 7169: @401664
     /*  401664 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(401741), // Rule ID 20667 //
     /*  401669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  401680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  401683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  401686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401701 */     // MIs[0] Operand 4
     /*  401701 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401719 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  401722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401739 */     GIR_RootConstrainSelectedInstOperands,
     /*  401740 */     // GIR_Coverage, 20667,
     /*  401740 */     GIR_EraseRootFromParent_Done,
     /*  401741 */   // Label 7170: @401741
     /*  401741 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(401818), // Rule ID 20670 //
     /*  401746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  401757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  401760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  401763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401778 */     // MIs[0] Operand 4
     /*  401778 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401796 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  401799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401816 */     GIR_RootConstrainSelectedInstOperands,
     /*  401817 */     // GIR_Coverage, 20670,
     /*  401817 */     GIR_EraseRootFromParent_Done,
     /*  401818 */   // Label 7171: @401818
     /*  401818 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(401895), // Rule ID 20671 //
     /*  401823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  401834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  401837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  401840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401855 */     // MIs[0] Operand 4
     /*  401855 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401873 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  401876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401893 */     GIR_RootConstrainSelectedInstOperands,
     /*  401894 */     // GIR_Coverage, 20671,
     /*  401894 */     GIR_EraseRootFromParent_Done,
     /*  401895 */   // Label 7172: @401895
     /*  401895 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(401972), // Rule ID 20674 //
     /*  401900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  401903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  401911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  401914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  401917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401932 */     // MIs[0] Operand 4
     /*  401932 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  401950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  401953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401970 */     GIR_RootConstrainSelectedInstOperands,
     /*  401971 */     // GIR_Coverage, 20674,
     /*  401971 */     GIR_EraseRootFromParent_Done,
     /*  401972 */   // Label 7173: @401972
     /*  401972 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(402049), // Rule ID 20675 //
     /*  401977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  401980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  401988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  401991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  401994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402009 */     // MIs[0] Operand 4
     /*  402009 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402027 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402047 */     GIR_RootConstrainSelectedInstOperands,
     /*  402048 */     // GIR_Coverage, 20675,
     /*  402048 */     GIR_EraseRootFromParent_Done,
     /*  402049 */   // Label 7174: @402049
     /*  402049 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(402126), // Rule ID 20678 //
     /*  402054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  402057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  402065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  402068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  402071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402086 */     // MIs[0] Operand 4
     /*  402086 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402104 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402124 */     GIR_RootConstrainSelectedInstOperands,
     /*  402125 */     // GIR_Coverage, 20678,
     /*  402125 */     GIR_EraseRootFromParent_Done,
     /*  402126 */   // Label 7175: @402126
     /*  402126 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(402203), // Rule ID 20679 //
     /*  402131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  402134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  402142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  402145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  402148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402163 */     // MIs[0] Operand 4
     /*  402163 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402181 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402201 */     GIR_RootConstrainSelectedInstOperands,
     /*  402202 */     // GIR_Coverage, 20679,
     /*  402202 */     GIR_EraseRootFromParent_Done,
     /*  402203 */   // Label 7176: @402203
     /*  402203 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(402280), // Rule ID 20682 //
     /*  402208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  402211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  402219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  402222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  402225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402240 */     // MIs[0] Operand 4
     /*  402240 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402258 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402278 */     GIR_RootConstrainSelectedInstOperands,
     /*  402279 */     // GIR_Coverage, 20682,
     /*  402279 */     GIR_EraseRootFromParent_Done,
     /*  402280 */   // Label 7177: @402280
     /*  402280 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(402357), // Rule ID 20683 //
     /*  402285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  402288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  402296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  402299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  402302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402317 */     // MIs[0] Operand 4
     /*  402317 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402335 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402355 */     GIR_RootConstrainSelectedInstOperands,
     /*  402356 */     // GIR_Coverage, 20683,
     /*  402356 */     GIR_EraseRootFromParent_Done,
     /*  402357 */   // Label 7178: @402357
     /*  402357 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(402434), // Rule ID 20686 //
     /*  402362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  402365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  402373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  402376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  402379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402394 */     // MIs[0] Operand 4
     /*  402394 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402412 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  402412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402432 */     GIR_RootConstrainSelectedInstOperands,
     /*  402433 */     // GIR_Coverage, 20686,
     /*  402433 */     GIR_EraseRootFromParent_Done,
     /*  402434 */   // Label 7179: @402434
     /*  402434 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(402511), // Rule ID 20687 //
     /*  402439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  402442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  402450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  402453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  402456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402471 */     // MIs[0] Operand 4
     /*  402471 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402489 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  402489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402509 */     GIR_RootConstrainSelectedInstOperands,
     /*  402510 */     // GIR_Coverage, 20687,
     /*  402510 */     GIR_EraseRootFromParent_Done,
     /*  402511 */   // Label 7180: @402511
     /*  402511 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(402588), // Rule ID 20690 //
     /*  402516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  402519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  402527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  402530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  402533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402548 */     // MIs[0] Operand 4
     /*  402548 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402566 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  402566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402586 */     GIR_RootConstrainSelectedInstOperands,
     /*  402587 */     // GIR_Coverage, 20690,
     /*  402587 */     GIR_EraseRootFromParent_Done,
     /*  402588 */   // Label 7181: @402588
     /*  402588 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(402665), // Rule ID 20691 //
     /*  402593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  402596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  402604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  402607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  402610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402625 */     // MIs[0] Operand 4
     /*  402625 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402643 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  402643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402663 */     GIR_RootConstrainSelectedInstOperands,
     /*  402664 */     // GIR_Coverage, 20691,
     /*  402664 */     GIR_EraseRootFromParent_Done,
     /*  402665 */   // Label 7182: @402665
     /*  402665 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(402742), // Rule ID 20694 //
     /*  402670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  402673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  402681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  402684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  402687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402702 */     // MIs[0] Operand 4
     /*  402702 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402720 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  402720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402740 */     GIR_RootConstrainSelectedInstOperands,
     /*  402741 */     // GIR_Coverage, 20694,
     /*  402741 */     GIR_EraseRootFromParent_Done,
     /*  402742 */   // Label 7183: @402742
     /*  402742 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(402819), // Rule ID 20695 //
     /*  402747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  402750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  402758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  402761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  402764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402779 */     // MIs[0] Operand 4
     /*  402779 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402797 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  402797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402817 */     GIR_RootConstrainSelectedInstOperands,
     /*  402818 */     // GIR_Coverage, 20695,
     /*  402818 */     GIR_EraseRootFromParent_Done,
     /*  402819 */   // Label 7184: @402819
     /*  402819 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(402896), // Rule ID 20698 //
     /*  402824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  402827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  402835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  402838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  402841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402856 */     // MIs[0] Operand 4
     /*  402856 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402874 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  402874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  402877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402894 */     GIR_RootConstrainSelectedInstOperands,
     /*  402895 */     // GIR_Coverage, 20698,
     /*  402895 */     GIR_EraseRootFromParent_Done,
     /*  402896 */   // Label 7185: @402896
     /*  402896 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(402973), // Rule ID 20699 //
     /*  402901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  402904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  402912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  402915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  402918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402933 */     // MIs[0] Operand 4
     /*  402933 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402951 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  402951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  402954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402971 */     GIR_RootConstrainSelectedInstOperands,
     /*  402972 */     // GIR_Coverage, 20699,
     /*  402972 */     GIR_EraseRootFromParent_Done,
     /*  402973 */   // Label 7186: @402973
     /*  402973 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(403050), // Rule ID 20702 //
     /*  402978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  402981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  402989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  402992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  402995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403010 */     // MIs[0] Operand 4
     /*  403010 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403028 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403048 */     GIR_RootConstrainSelectedInstOperands,
     /*  403049 */     // GIR_Coverage, 20702,
     /*  403049 */     GIR_EraseRootFromParent_Done,
     /*  403050 */   // Label 7187: @403050
     /*  403050 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(403127), // Rule ID 20703 //
     /*  403055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  403066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  403069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  403072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403087 */     // MIs[0] Operand 4
     /*  403087 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403105 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403125 */     GIR_RootConstrainSelectedInstOperands,
     /*  403126 */     // GIR_Coverage, 20703,
     /*  403126 */     GIR_EraseRootFromParent_Done,
     /*  403127 */   // Label 7188: @403127
     /*  403127 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(403204), // Rule ID 20706 //
     /*  403132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  403135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  403143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  403146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  403149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403164 */     // MIs[0] Operand 4
     /*  403164 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403182 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403202 */     GIR_RootConstrainSelectedInstOperands,
     /*  403203 */     // GIR_Coverage, 20706,
     /*  403203 */     GIR_EraseRootFromParent_Done,
     /*  403204 */   // Label 7189: @403204
     /*  403204 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(403281), // Rule ID 20707 //
     /*  403209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  403212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  403220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  403223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  403226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403241 */     // MIs[0] Operand 4
     /*  403241 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403259 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403279 */     GIR_RootConstrainSelectedInstOperands,
     /*  403280 */     // GIR_Coverage, 20707,
     /*  403280 */     GIR_EraseRootFromParent_Done,
     /*  403281 */   // Label 7190: @403281
     /*  403281 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(403358), // Rule ID 20710 //
     /*  403286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  403297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  403300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  403303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403318 */     // MIs[0] Operand 4
     /*  403318 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403336 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403356 */     GIR_RootConstrainSelectedInstOperands,
     /*  403357 */     // GIR_Coverage, 20710,
     /*  403357 */     GIR_EraseRootFromParent_Done,
     /*  403358 */   // Label 7191: @403358
     /*  403358 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(403435), // Rule ID 20711 //
     /*  403363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  403374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  403377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  403380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403395 */     // MIs[0] Operand 4
     /*  403395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403413 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403433 */     GIR_RootConstrainSelectedInstOperands,
     /*  403434 */     // GIR_Coverage, 20711,
     /*  403434 */     GIR_EraseRootFromParent_Done,
     /*  403435 */   // Label 7192: @403435
     /*  403435 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(403512), // Rule ID 20714 //
     /*  403440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  403443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  403451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  403454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  403457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403472 */     // MIs[0] Operand 4
     /*  403472 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403510 */     GIR_RootConstrainSelectedInstOperands,
     /*  403511 */     // GIR_Coverage, 20714,
     /*  403511 */     GIR_EraseRootFromParent_Done,
     /*  403512 */   // Label 7193: @403512
     /*  403512 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(403589), // Rule ID 20715 //
     /*  403517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  403520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  403528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  403531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  403534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403549 */     // MIs[0] Operand 4
     /*  403549 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403567 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403587 */     GIR_RootConstrainSelectedInstOperands,
     /*  403588 */     // GIR_Coverage, 20715,
     /*  403588 */     GIR_EraseRootFromParent_Done,
     /*  403589 */   // Label 7194: @403589
     /*  403589 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(403666), // Rule ID 20718 //
     /*  403594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  403597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  403605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  403608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  403611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403626 */     // MIs[0] Operand 4
     /*  403626 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  403644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403664 */     GIR_RootConstrainSelectedInstOperands,
     /*  403665 */     // GIR_Coverage, 20718,
     /*  403665 */     GIR_EraseRootFromParent_Done,
     /*  403666 */   // Label 7195: @403666
     /*  403666 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(403743), // Rule ID 20719 //
     /*  403671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  403674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  403682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  403685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  403688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403703 */     // MIs[0] Operand 4
     /*  403703 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403721 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  403721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403741 */     GIR_RootConstrainSelectedInstOperands,
     /*  403742 */     // GIR_Coverage, 20719,
     /*  403742 */     GIR_EraseRootFromParent_Done,
     /*  403743 */   // Label 7196: @403743
     /*  403743 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(403820), // Rule ID 20722 //
     /*  403748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  403759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  403762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  403765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403780 */     // MIs[0] Operand 4
     /*  403780 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  403801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403818 */     GIR_RootConstrainSelectedInstOperands,
     /*  403819 */     // GIR_Coverage, 20722,
     /*  403819 */     GIR_EraseRootFromParent_Done,
     /*  403820 */   // Label 7197: @403820
     /*  403820 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(403897), // Rule ID 20723 //
     /*  403825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  403836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  403839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  403842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403857 */     // MIs[0] Operand 4
     /*  403857 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403875 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  403878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403895 */     GIR_RootConstrainSelectedInstOperands,
     /*  403896 */     // GIR_Coverage, 20723,
     /*  403896 */     GIR_EraseRootFromParent_Done,
     /*  403897 */   // Label 7198: @403897
     /*  403897 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(403974), // Rule ID 20726 //
     /*  403902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  403913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  403916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  403919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403934 */     // MIs[0] Operand 4
     /*  403934 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403952 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  403955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403972 */     GIR_RootConstrainSelectedInstOperands,
     /*  403973 */     // GIR_Coverage, 20726,
     /*  403973 */     GIR_EraseRootFromParent_Done,
     /*  403974 */   // Label 7199: @403974
     /*  403974 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(404051), // Rule ID 20727 //
     /*  403979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  403990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  403993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  403996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404011 */     // MIs[0] Operand 4
     /*  404011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404029 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404049 */     GIR_RootConstrainSelectedInstOperands,
     /*  404050 */     // GIR_Coverage, 20727,
     /*  404050 */     GIR_EraseRootFromParent_Done,
     /*  404051 */   // Label 7200: @404051
     /*  404051 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(404128), // Rule ID 20730 //
     /*  404056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  404067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  404070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  404073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404088 */     // MIs[0] Operand 4
     /*  404088 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404106 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404126 */     GIR_RootConstrainSelectedInstOperands,
     /*  404127 */     // GIR_Coverage, 20730,
     /*  404127 */     GIR_EraseRootFromParent_Done,
     /*  404128 */   // Label 7201: @404128
     /*  404128 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(404205), // Rule ID 20731 //
     /*  404133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  404144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  404147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  404150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404165 */     // MIs[0] Operand 4
     /*  404165 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404183 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404203 */     GIR_RootConstrainSelectedInstOperands,
     /*  404204 */     // GIR_Coverage, 20731,
     /*  404204 */     GIR_EraseRootFromParent_Done,
     /*  404205 */   // Label 7202: @404205
     /*  404205 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(404282), // Rule ID 20734 //
     /*  404210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  404221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  404224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  404227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404242 */     // MIs[0] Operand 4
     /*  404242 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  404260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404280 */     GIR_RootConstrainSelectedInstOperands,
     /*  404281 */     // GIR_Coverage, 20734,
     /*  404281 */     GIR_EraseRootFromParent_Done,
     /*  404282 */   // Label 7203: @404282
     /*  404282 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(404359), // Rule ID 20735 //
     /*  404287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  404290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  404298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  404301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  404304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404319 */     // MIs[0] Operand 4
     /*  404319 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404337 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404357 */     GIR_RootConstrainSelectedInstOperands,
     /*  404358 */     // GIR_Coverage, 20735,
     /*  404358 */     GIR_EraseRootFromParent_Done,
     /*  404359 */   // Label 7204: @404359
     /*  404359 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(404436), // Rule ID 20738 //
     /*  404364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  404375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  404378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  404381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404396 */     // MIs[0] Operand 4
     /*  404396 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404414 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  404414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404434 */     GIR_RootConstrainSelectedInstOperands,
     /*  404435 */     // GIR_Coverage, 20738,
     /*  404435 */     GIR_EraseRootFromParent_Done,
     /*  404436 */   // Label 7205: @404436
     /*  404436 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(404513), // Rule ID 20739 //
     /*  404441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  404444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  404452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  404455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  404458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404473 */     // MIs[0] Operand 4
     /*  404473 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404491 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404511 */     GIR_RootConstrainSelectedInstOperands,
     /*  404512 */     // GIR_Coverage, 20739,
     /*  404512 */     GIR_EraseRootFromParent_Done,
     /*  404513 */   // Label 7206: @404513
     /*  404513 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(404590), // Rule ID 20742 //
     /*  404518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  404529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  404532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  404535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404550 */     // MIs[0] Operand 4
     /*  404550 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404568 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  404568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404588 */     GIR_RootConstrainSelectedInstOperands,
     /*  404589 */     // GIR_Coverage, 20742,
     /*  404589 */     GIR_EraseRootFromParent_Done,
     /*  404590 */   // Label 7207: @404590
     /*  404590 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(404667), // Rule ID 20743 //
     /*  404595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  404598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  404606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  404609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  404612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404627 */     // MIs[0] Operand 4
     /*  404627 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404645 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404665 */     GIR_RootConstrainSelectedInstOperands,
     /*  404666 */     // GIR_Coverage, 20743,
     /*  404666 */     GIR_EraseRootFromParent_Done,
     /*  404667 */   // Label 7208: @404667
     /*  404667 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(404744), // Rule ID 20746 //
     /*  404672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  404675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  404683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  404686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  404689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404704 */     // MIs[0] Operand 4
     /*  404704 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404722 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  404722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404742 */     GIR_RootConstrainSelectedInstOperands,
     /*  404743 */     // GIR_Coverage, 20746,
     /*  404743 */     GIR_EraseRootFromParent_Done,
     /*  404744 */   // Label 7209: @404744
     /*  404744 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(404821), // Rule ID 20747 //
     /*  404749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  404752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  404760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  404763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  404766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404781 */     // MIs[0] Operand 4
     /*  404781 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404819 */     GIR_RootConstrainSelectedInstOperands,
     /*  404820 */     // GIR_Coverage, 20747,
     /*  404820 */     GIR_EraseRootFromParent_Done,
     /*  404821 */   // Label 7210: @404821
     /*  404821 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(404898), // Rule ID 20750 //
     /*  404826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  404829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  404837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  404840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  404843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404858 */     // MIs[0] Operand 4
     /*  404858 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404876 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  404876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404896 */     GIR_RootConstrainSelectedInstOperands,
     /*  404897 */     // GIR_Coverage, 20750,
     /*  404897 */     GIR_EraseRootFromParent_Done,
     /*  404898 */   // Label 7211: @404898
     /*  404898 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(404975), // Rule ID 20751 //
     /*  404903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  404906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  404914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  404917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  404920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404935 */     // MIs[0] Operand 4
     /*  404935 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404953 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404973 */     GIR_RootConstrainSelectedInstOperands,
     /*  404974 */     // GIR_Coverage, 20751,
     /*  404974 */     GIR_EraseRootFromParent_Done,
     /*  404975 */   // Label 7212: @404975
     /*  404975 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(405052), // Rule ID 20754 //
     /*  404980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  404983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  404991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  404994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  404997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405012 */     // MIs[0] Operand 4
     /*  405012 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405030 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  405030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  405033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405050 */     GIR_RootConstrainSelectedInstOperands,
     /*  405051 */     // GIR_Coverage, 20754,
     /*  405051 */     GIR_EraseRootFromParent_Done,
     /*  405052 */   // Label 7213: @405052
     /*  405052 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(405129), // Rule ID 20755 //
     /*  405057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  405060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  405068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  405071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  405074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405089 */     // MIs[0] Operand 4
     /*  405089 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405107 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  405107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  405110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405127 */     GIR_RootConstrainSelectedInstOperands,
     /*  405128 */     // GIR_Coverage, 20755,
     /*  405128 */     GIR_EraseRootFromParent_Done,
     /*  405129 */   // Label 7214: @405129
     /*  405129 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(405206), // Rule ID 21114 //
     /*  405134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  405145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  405148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  405151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405166 */     // MIs[0] Operand 4
     /*  405166 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405184 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  405187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405204 */     GIR_RootConstrainSelectedInstOperands,
     /*  405205 */     // GIR_Coverage, 21114,
     /*  405205 */     GIR_EraseRootFromParent_Done,
     /*  405206 */   // Label 7215: @405206
     /*  405206 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(405283), // Rule ID 21115 //
     /*  405211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  405222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  405225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  405228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405243 */     // MIs[0] Operand 4
     /*  405243 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405261 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  405264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405281 */     GIR_RootConstrainSelectedInstOperands,
     /*  405282 */     // GIR_Coverage, 21115,
     /*  405282 */     GIR_EraseRootFromParent_Done,
     /*  405283 */   // Label 7216: @405283
     /*  405283 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(405360), // Rule ID 21118 //
     /*  405288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  405305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405320 */     // MIs[0] Operand 4
     /*  405320 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405338 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  405341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405358 */     GIR_RootConstrainSelectedInstOperands,
     /*  405359 */     // GIR_Coverage, 21118,
     /*  405359 */     GIR_EraseRootFromParent_Done,
     /*  405360 */   // Label 7217: @405360
     /*  405360 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(405437), // Rule ID 21119 //
     /*  405365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  405382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405397 */     // MIs[0] Operand 4
     /*  405397 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405415 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  405418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405435 */     GIR_RootConstrainSelectedInstOperands,
     /*  405436 */     // GIR_Coverage, 21119,
     /*  405436 */     GIR_EraseRootFromParent_Done,
     /*  405437 */   // Label 7218: @405437
     /*  405437 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(405514), // Rule ID 21122 //
     /*  405442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  405459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405474 */     // MIs[0] Operand 4
     /*  405474 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  405495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405512 */     GIR_RootConstrainSelectedInstOperands,
     /*  405513 */     // GIR_Coverage, 21122,
     /*  405513 */     GIR_EraseRootFromParent_Done,
     /*  405514 */   // Label 7219: @405514
     /*  405514 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(405591), // Rule ID 21123 //
     /*  405519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  405536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405551 */     // MIs[0] Operand 4
     /*  405551 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405569 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  405572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405589 */     GIR_RootConstrainSelectedInstOperands,
     /*  405590 */     // GIR_Coverage, 21123,
     /*  405590 */     GIR_EraseRootFromParent_Done,
     /*  405591 */   // Label 7220: @405591
     /*  405591 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(405668), // Rule ID 21126 //
     /*  405596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  405607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  405610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  405613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405628 */     // MIs[0] Operand 4
     /*  405628 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405646 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  405649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405666 */     GIR_RootConstrainSelectedInstOperands,
     /*  405667 */     // GIR_Coverage, 21126,
     /*  405667 */     GIR_EraseRootFromParent_Done,
     /*  405668 */   // Label 7221: @405668
     /*  405668 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(405745), // Rule ID 21127 //
     /*  405673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  405684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  405687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  405690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405705 */     // MIs[0] Operand 4
     /*  405705 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405723 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  405726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405743 */     GIR_RootConstrainSelectedInstOperands,
     /*  405744 */     // GIR_Coverage, 21127,
     /*  405744 */     GIR_EraseRootFromParent_Done,
     /*  405745 */   // Label 7222: @405745
     /*  405745 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(405822), // Rule ID 21130 //
     /*  405750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  405761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  405764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  405767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405782 */     // MIs[0] Operand 4
     /*  405782 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405800 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  405803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405820 */     GIR_RootConstrainSelectedInstOperands,
     /*  405821 */     // GIR_Coverage, 21130,
     /*  405821 */     GIR_EraseRootFromParent_Done,
     /*  405822 */   // Label 7223: @405822
     /*  405822 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(405899), // Rule ID 21131 //
     /*  405827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  405838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  405841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  405844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405859 */     // MIs[0] Operand 4
     /*  405859 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405877 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  405880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405897 */     GIR_RootConstrainSelectedInstOperands,
     /*  405898 */     // GIR_Coverage, 21131,
     /*  405898 */     GIR_EraseRootFromParent_Done,
     /*  405899 */   // Label 7224: @405899
     /*  405899 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(405976), // Rule ID 21134 //
     /*  405904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  405907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  405915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  405918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  405921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405936 */     // MIs[0] Operand 4
     /*  405936 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405954 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  405957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405974 */     GIR_RootConstrainSelectedInstOperands,
     /*  405975 */     // GIR_Coverage, 21134,
     /*  405975 */     GIR_EraseRootFromParent_Done,
     /*  405976 */   // Label 7225: @405976
     /*  405976 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(406053), // Rule ID 21135 //
     /*  405981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  405984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  405992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  405995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  405998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406013 */     // MIs[0] Operand 4
     /*  406013 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406031 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  406034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406051 */     GIR_RootConstrainSelectedInstOperands,
     /*  406052 */     // GIR_Coverage, 21135,
     /*  406052 */     GIR_EraseRootFromParent_Done,
     /*  406053 */   // Label 7226: @406053
     /*  406053 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(406130), // Rule ID 21138 //
     /*  406058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  406069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  406072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  406075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406090 */     // MIs[0] Operand 4
     /*  406090 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406108 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  406111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406128 */     GIR_RootConstrainSelectedInstOperands,
     /*  406129 */     // GIR_Coverage, 21138,
     /*  406129 */     GIR_EraseRootFromParent_Done,
     /*  406130 */   // Label 7227: @406130
     /*  406130 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(406207), // Rule ID 21139 //
     /*  406135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  406146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  406149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  406152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406167 */     // MIs[0] Operand 4
     /*  406167 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406185 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  406188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406205 */     GIR_RootConstrainSelectedInstOperands,
     /*  406206 */     // GIR_Coverage, 21139,
     /*  406206 */     GIR_EraseRootFromParent_Done,
     /*  406207 */   // Label 7228: @406207
     /*  406207 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(406284), // Rule ID 21142 //
     /*  406212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  406223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  406226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  406229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406244 */     // MIs[0] Operand 4
     /*  406244 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406262 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  406265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406282 */     GIR_RootConstrainSelectedInstOperands,
     /*  406283 */     // GIR_Coverage, 21142,
     /*  406283 */     GIR_EraseRootFromParent_Done,
     /*  406284 */   // Label 7229: @406284
     /*  406284 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(406361), // Rule ID 21143 //
     /*  406289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  406300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  406303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  406306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406321 */     // MIs[0] Operand 4
     /*  406321 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406339 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  406342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406359 */     GIR_RootConstrainSelectedInstOperands,
     /*  406360 */     // GIR_Coverage, 21143,
     /*  406360 */     GIR_EraseRootFromParent_Done,
     /*  406361 */   // Label 7230: @406361
     /*  406361 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(406438), // Rule ID 21146 //
     /*  406366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  406377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  406380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  406383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406398 */     // MIs[0] Operand 4
     /*  406398 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406416 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  406419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406436 */     GIR_RootConstrainSelectedInstOperands,
     /*  406437 */     // GIR_Coverage, 21146,
     /*  406437 */     GIR_EraseRootFromParent_Done,
     /*  406438 */   // Label 7231: @406438
     /*  406438 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(406515), // Rule ID 21147 //
     /*  406443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  406454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  406457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  406460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406475 */     // MIs[0] Operand 4
     /*  406475 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406493 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  406496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406513 */     GIR_RootConstrainSelectedInstOperands,
     /*  406514 */     // GIR_Coverage, 21147,
     /*  406514 */     GIR_EraseRootFromParent_Done,
     /*  406515 */   // Label 7232: @406515
     /*  406515 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(406592), // Rule ID 21150 //
     /*  406520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  406531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  406534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  406537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406552 */     // MIs[0] Operand 4
     /*  406552 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406570 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  406573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406590 */     GIR_RootConstrainSelectedInstOperands,
     /*  406591 */     // GIR_Coverage, 21150,
     /*  406591 */     GIR_EraseRootFromParent_Done,
     /*  406592 */   // Label 7233: @406592
     /*  406592 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(406669), // Rule ID 21151 //
     /*  406597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  406608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  406611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  406614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406629 */     // MIs[0] Operand 4
     /*  406629 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406647 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  406650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406667 */     GIR_RootConstrainSelectedInstOperands,
     /*  406668 */     // GIR_Coverage, 21151,
     /*  406668 */     GIR_EraseRootFromParent_Done,
     /*  406669 */   // Label 7234: @406669
     /*  406669 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(406746), // Rule ID 21154 //
     /*  406674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  406685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  406688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  406691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406706 */     // MIs[0] Operand 4
     /*  406706 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  406727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406744 */     GIR_RootConstrainSelectedInstOperands,
     /*  406745 */     // GIR_Coverage, 21154,
     /*  406745 */     GIR_EraseRootFromParent_Done,
     /*  406746 */   // Label 7235: @406746
     /*  406746 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(406823), // Rule ID 21155 //
     /*  406751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  406762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  406765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  406768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406783 */     // MIs[0] Operand 4
     /*  406783 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406801 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  406804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406821 */     GIR_RootConstrainSelectedInstOperands,
     /*  406822 */     // GIR_Coverage, 21155,
     /*  406822 */     GIR_EraseRootFromParent_Done,
     /*  406823 */   // Label 7236: @406823
     /*  406823 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(406900), // Rule ID 21158 //
     /*  406828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  406839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  406842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  406845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406860 */     // MIs[0] Operand 4
     /*  406860 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  406881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406898 */     GIR_RootConstrainSelectedInstOperands,
     /*  406899 */     // GIR_Coverage, 21158,
     /*  406899 */     GIR_EraseRootFromParent_Done,
     /*  406900 */   // Label 7237: @406900
     /*  406900 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(406977), // Rule ID 21159 //
     /*  406905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  406916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  406919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  406922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406937 */     // MIs[0] Operand 4
     /*  406937 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406955 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  406958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406975 */     GIR_RootConstrainSelectedInstOperands,
     /*  406976 */     // GIR_Coverage, 21159,
     /*  406976 */     GIR_EraseRootFromParent_Done,
     /*  406977 */   // Label 7238: @406977
     /*  406977 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(407054), // Rule ID 21162 //
     /*  406982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  406999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407014 */     // MIs[0] Operand 4
     /*  407014 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407032 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407052 */     GIR_RootConstrainSelectedInstOperands,
     /*  407053 */     // GIR_Coverage, 21162,
     /*  407053 */     GIR_EraseRootFromParent_Done,
     /*  407054 */   // Label 7239: @407054
     /*  407054 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(407131), // Rule ID 21163 //
     /*  407059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  407070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  407073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  407076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407091 */     // MIs[0] Operand 4
     /*  407091 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407109 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407129 */     GIR_RootConstrainSelectedInstOperands,
     /*  407130 */     // GIR_Coverage, 21163,
     /*  407130 */     GIR_EraseRootFromParent_Done,
     /*  407131 */   // Label 7240: @407131
     /*  407131 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(407208), // Rule ID 21166 //
     /*  407136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  407153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407168 */     // MIs[0] Operand 4
     /*  407168 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407206 */     GIR_RootConstrainSelectedInstOperands,
     /*  407207 */     // GIR_Coverage, 21166,
     /*  407207 */     GIR_EraseRootFromParent_Done,
     /*  407208 */   // Label 7241: @407208
     /*  407208 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(407285), // Rule ID 21167 //
     /*  407213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  407230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407245 */     // MIs[0] Operand 4
     /*  407245 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407263 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407283 */     GIR_RootConstrainSelectedInstOperands,
     /*  407284 */     // GIR_Coverage, 21167,
     /*  407284 */     GIR_EraseRootFromParent_Done,
     /*  407285 */   // Label 7242: @407285
     /*  407285 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(407362), // Rule ID 21170 //
     /*  407290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  407301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  407304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  407307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407322 */     // MIs[0] Operand 4
     /*  407322 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407340 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  407343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407360 */     GIR_RootConstrainSelectedInstOperands,
     /*  407361 */     // GIR_Coverage, 21170,
     /*  407361 */     GIR_EraseRootFromParent_Done,
     /*  407362 */   // Label 7243: @407362
     /*  407362 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(407439), // Rule ID 21171 //
     /*  407367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  407378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  407381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  407384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407399 */     // MIs[0] Operand 4
     /*  407399 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407417 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  407420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407437 */     GIR_RootConstrainSelectedInstOperands,
     /*  407438 */     // GIR_Coverage, 21171,
     /*  407438 */     GIR_EraseRootFromParent_Done,
     /*  407439 */   // Label 7244: @407439
     /*  407439 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(407516), // Rule ID 21174 //
     /*  407444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  407455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  407458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407476 */     // MIs[0] Operand 4
     /*  407476 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  407497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407514 */     GIR_RootConstrainSelectedInstOperands,
     /*  407515 */     // GIR_Coverage, 21174,
     /*  407515 */     GIR_EraseRootFromParent_Done,
     /*  407516 */   // Label 7245: @407516
     /*  407516 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(407593), // Rule ID 21175 //
     /*  407521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  407532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  407535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407553 */     // MIs[0] Operand 4
     /*  407553 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407571 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  407574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407591 */     GIR_RootConstrainSelectedInstOperands,
     /*  407592 */     // GIR_Coverage, 21175,
     /*  407592 */     GIR_EraseRootFromParent_Done,
     /*  407593 */   // Label 7246: @407593
     /*  407593 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(407670), // Rule ID 21178 //
     /*  407598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  407609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  407612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  407615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407630 */     // MIs[0] Operand 4
     /*  407630 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407648 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407668 */     GIR_RootConstrainSelectedInstOperands,
     /*  407669 */     // GIR_Coverage, 21178,
     /*  407669 */     GIR_EraseRootFromParent_Done,
     /*  407670 */   // Label 7247: @407670
     /*  407670 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(407747), // Rule ID 21179 //
     /*  407675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  407686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  407689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  407692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407707 */     // MIs[0] Operand 4
     /*  407707 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407725 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407745 */     GIR_RootConstrainSelectedInstOperands,
     /*  407746 */     // GIR_Coverage, 21179,
     /*  407746 */     GIR_EraseRootFromParent_Done,
     /*  407747 */   // Label 7248: @407747
     /*  407747 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(407824), // Rule ID 21182 //
     /*  407752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  407763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  407766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  407769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407784 */     // MIs[0] Operand 4
     /*  407784 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407802 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407822 */     GIR_RootConstrainSelectedInstOperands,
     /*  407823 */     // GIR_Coverage, 21182,
     /*  407823 */     GIR_EraseRootFromParent_Done,
     /*  407824 */   // Label 7249: @407824
     /*  407824 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(407901), // Rule ID 21183 //
     /*  407829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  407840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  407843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  407846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407861 */     // MIs[0] Operand 4
     /*  407861 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407879 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407899 */     GIR_RootConstrainSelectedInstOperands,
     /*  407900 */     // GIR_Coverage, 21183,
     /*  407900 */     GIR_EraseRootFromParent_Done,
     /*  407901 */   // Label 7250: @407901
     /*  407901 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(407978), // Rule ID 21486 //
     /*  407906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  407914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  407917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  407920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  407923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407938 */     // MIs[0] Operand 4
     /*  407938 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407956 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  407956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  407959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  407973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407976 */     GIR_RootConstrainSelectedInstOperands,
     /*  407977 */     // GIR_Coverage, 21486,
     /*  407977 */     GIR_EraseRootFromParent_Done,
     /*  407978 */   // Label 7251: @407978
     /*  407978 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(408055), // Rule ID 21487 //
     /*  407983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  407991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  407994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  407997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  408000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408015 */     // MIs[0] Operand 4
     /*  408015 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408033 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  408036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408053 */     GIR_RootConstrainSelectedInstOperands,
     /*  408054 */     // GIR_Coverage, 21487,
     /*  408054 */     GIR_EraseRootFromParent_Done,
     /*  408055 */   // Label 7252: @408055
     /*  408055 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(408132), // Rule ID 21490 //
     /*  408060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  408071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  408074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  408077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408092 */     // MIs[0] Operand 4
     /*  408092 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408110 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408130 */     GIR_RootConstrainSelectedInstOperands,
     /*  408131 */     // GIR_Coverage, 21490,
     /*  408131 */     GIR_EraseRootFromParent_Done,
     /*  408132 */   // Label 7253: @408132
     /*  408132 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(408209), // Rule ID 21491 //
     /*  408137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  408148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  408151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  408154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408169 */     // MIs[0] Operand 4
     /*  408169 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408187 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408207 */     GIR_RootConstrainSelectedInstOperands,
     /*  408208 */     // GIR_Coverage, 21491,
     /*  408208 */     GIR_EraseRootFromParent_Done,
     /*  408209 */   // Label 7254: @408209
     /*  408209 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(408286), // Rule ID 21494 //
     /*  408214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  408225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  408228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  408231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408246 */     // MIs[0] Operand 4
     /*  408246 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408264 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  408267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408284 */     GIR_RootConstrainSelectedInstOperands,
     /*  408285 */     // GIR_Coverage, 21494,
     /*  408285 */     GIR_EraseRootFromParent_Done,
     /*  408286 */   // Label 7255: @408286
     /*  408286 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(408363), // Rule ID 21495 //
     /*  408291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  408302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  408305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  408308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408323 */     // MIs[0] Operand 4
     /*  408323 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408341 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  408344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408361 */     GIR_RootConstrainSelectedInstOperands,
     /*  408362 */     // GIR_Coverage, 21495,
     /*  408362 */     GIR_EraseRootFromParent_Done,
     /*  408363 */   // Label 7256: @408363
     /*  408363 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(408440), // Rule ID 21498 //
     /*  408368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  408379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  408382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  408385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408400 */     // MIs[0] Operand 4
     /*  408400 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408418 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  408421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408438 */     GIR_RootConstrainSelectedInstOperands,
     /*  408439 */     // GIR_Coverage, 21498,
     /*  408439 */     GIR_EraseRootFromParent_Done,
     /*  408440 */   // Label 7257: @408440
     /*  408440 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(408517), // Rule ID 21499 //
     /*  408445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  408456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  408459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  408462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408477 */     // MIs[0] Operand 4
     /*  408477 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408495 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  408498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408515 */     GIR_RootConstrainSelectedInstOperands,
     /*  408516 */     // GIR_Coverage, 21499,
     /*  408516 */     GIR_EraseRootFromParent_Done,
     /*  408517 */   // Label 7258: @408517
     /*  408517 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(408594), // Rule ID 21502 //
     /*  408522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  408533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  408536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  408539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408554 */     // MIs[0] Operand 4
     /*  408554 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408572 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  408575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408592 */     GIR_RootConstrainSelectedInstOperands,
     /*  408593 */     // GIR_Coverage, 21502,
     /*  408593 */     GIR_EraseRootFromParent_Done,
     /*  408594 */   // Label 7259: @408594
     /*  408594 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(408671), // Rule ID 21503 //
     /*  408599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  408610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  408613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  408616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408631 */     // MIs[0] Operand 4
     /*  408631 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408649 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  408652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408669 */     GIR_RootConstrainSelectedInstOperands,
     /*  408670 */     // GIR_Coverage, 21503,
     /*  408670 */     GIR_EraseRootFromParent_Done,
     /*  408671 */   // Label 7260: @408671
     /*  408671 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(408748), // Rule ID 21506 //
     /*  408676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  408687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  408690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  408693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408708 */     // MIs[0] Operand 4
     /*  408708 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408726 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  408729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408746 */     GIR_RootConstrainSelectedInstOperands,
     /*  408747 */     // GIR_Coverage, 21506,
     /*  408747 */     GIR_EraseRootFromParent_Done,
     /*  408748 */   // Label 7261: @408748
     /*  408748 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(408825), // Rule ID 21507 //
     /*  408753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  408764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  408767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  408770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408785 */     // MIs[0] Operand 4
     /*  408785 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408803 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  408806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408823 */     GIR_RootConstrainSelectedInstOperands,
     /*  408824 */     // GIR_Coverage, 21507,
     /*  408824 */     GIR_EraseRootFromParent_Done,
     /*  408825 */   // Label 7262: @408825
     /*  408825 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(408902), // Rule ID 21510 //
     /*  408830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  408841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  408844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  408847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408862 */     // MIs[0] Operand 4
     /*  408862 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408880 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  408880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408900 */     GIR_RootConstrainSelectedInstOperands,
     /*  408901 */     // GIR_Coverage, 21510,
     /*  408901 */     GIR_EraseRootFromParent_Done,
     /*  408902 */   // Label 7263: @408902
     /*  408902 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(408979), // Rule ID 21511 //
     /*  408907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  408910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  408918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  408921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  408924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408939 */     // MIs[0] Operand 4
     /*  408939 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408957 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  408957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408977 */     GIR_RootConstrainSelectedInstOperands,
     /*  408978 */     // GIR_Coverage, 21511,
     /*  408978 */     GIR_EraseRootFromParent_Done,
     /*  408979 */   // Label 7264: @408979
     /*  408979 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(409056), // Rule ID 21514 //
     /*  408984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  408995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  408998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409016 */     // MIs[0] Operand 4
     /*  409016 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409034 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409054 */     GIR_RootConstrainSelectedInstOperands,
     /*  409055 */     // GIR_Coverage, 21514,
     /*  409055 */     GIR_EraseRootFromParent_Done,
     /*  409056 */   // Label 7265: @409056
     /*  409056 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(409133), // Rule ID 21515 //
     /*  409061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  409072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  409075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409093 */     // MIs[0] Operand 4
     /*  409093 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409111 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409131 */     GIR_RootConstrainSelectedInstOperands,
     /*  409132 */     // GIR_Coverage, 21515,
     /*  409132 */     GIR_EraseRootFromParent_Done,
     /*  409133 */   // Label 7266: @409133
     /*  409133 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(409210), // Rule ID 21518 //
     /*  409138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  409149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  409152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  409155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409170 */     // MIs[0] Operand 4
     /*  409170 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409188 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409208 */     GIR_RootConstrainSelectedInstOperands,
     /*  409209 */     // GIR_Coverage, 21518,
     /*  409209 */     GIR_EraseRootFromParent_Done,
     /*  409210 */   // Label 7267: @409210
     /*  409210 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(409287), // Rule ID 21519 //
     /*  409215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  409226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  409229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  409232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409247 */     // MIs[0] Operand 4
     /*  409247 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409265 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409285 */     GIR_RootConstrainSelectedInstOperands,
     /*  409286 */     // GIR_Coverage, 21519,
     /*  409286 */     GIR_EraseRootFromParent_Done,
     /*  409287 */   // Label 7268: @409287
     /*  409287 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(409364), // Rule ID 21522 //
     /*  409292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  409303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  409306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  409309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409324 */     // MIs[0] Operand 4
     /*  409324 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409342 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409362 */     GIR_RootConstrainSelectedInstOperands,
     /*  409363 */     // GIR_Coverage, 21522,
     /*  409363 */     GIR_EraseRootFromParent_Done,
     /*  409364 */   // Label 7269: @409364
     /*  409364 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(409441), // Rule ID 21523 //
     /*  409369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  409380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  409383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  409386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409401 */     // MIs[0] Operand 4
     /*  409401 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409419 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409439 */     GIR_RootConstrainSelectedInstOperands,
     /*  409440 */     // GIR_Coverage, 21523,
     /*  409440 */     GIR_EraseRootFromParent_Done,
     /*  409441 */   // Label 7270: @409441
     /*  409441 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(409518), // Rule ID 21526 //
     /*  409446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  409457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  409460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  409463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409478 */     // MIs[0] Operand 4
     /*  409478 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  409499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409516 */     GIR_RootConstrainSelectedInstOperands,
     /*  409517 */     // GIR_Coverage, 21526,
     /*  409517 */     GIR_EraseRootFromParent_Done,
     /*  409518 */   // Label 7271: @409518
     /*  409518 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(409595), // Rule ID 21527 //
     /*  409523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  409534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  409537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  409540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409555 */     // MIs[0] Operand 4
     /*  409555 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409573 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  409576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409593 */     GIR_RootConstrainSelectedInstOperands,
     /*  409594 */     // GIR_Coverage, 21527,
     /*  409594 */     GIR_EraseRootFromParent_Done,
     /*  409595 */   // Label 7272: @409595
     /*  409595 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(409672), // Rule ID 21530 //
     /*  409600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  409603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  409611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  409614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  409617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409632 */     // MIs[0] Operand 4
     /*  409632 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409650 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409670 */     GIR_RootConstrainSelectedInstOperands,
     /*  409671 */     // GIR_Coverage, 21530,
     /*  409671 */     GIR_EraseRootFromParent_Done,
     /*  409672 */   // Label 7273: @409672
     /*  409672 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(409749), // Rule ID 21531 //
     /*  409677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  409680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  409688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  409691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  409694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409709 */     // MIs[0] Operand 4
     /*  409709 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409727 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  409727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409747 */     GIR_RootConstrainSelectedInstOperands,
     /*  409748 */     // GIR_Coverage, 21531,
     /*  409748 */     GIR_EraseRootFromParent_Done,
     /*  409749 */   // Label 7274: @409749
     /*  409749 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(409826), // Rule ID 21534 //
     /*  409754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  409757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  409765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  409768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  409771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409786 */     // MIs[0] Operand 4
     /*  409786 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409804 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409824 */     GIR_RootConstrainSelectedInstOperands,
     /*  409825 */     // GIR_Coverage, 21534,
     /*  409825 */     GIR_EraseRootFromParent_Done,
     /*  409826 */   // Label 7275: @409826
     /*  409826 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(409903), // Rule ID 21535 //
     /*  409831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  409834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  409842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  409845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  409848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409863 */     // MIs[0] Operand 4
     /*  409863 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409881 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  409881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409901 */     GIR_RootConstrainSelectedInstOperands,
     /*  409902 */     // GIR_Coverage, 21535,
     /*  409902 */     GIR_EraseRootFromParent_Done,
     /*  409903 */   // Label 7276: @409903
     /*  409903 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(409980), // Rule ID 21538 //
     /*  409908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  409911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  409919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  409922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  409925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409940 */     // MIs[0] Operand 4
     /*  409940 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409978 */     GIR_RootConstrainSelectedInstOperands,
     /*  409979 */     // GIR_Coverage, 21538,
     /*  409979 */     GIR_EraseRootFromParent_Done,
     /*  409980 */   // Label 7277: @409980
     /*  409980 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(410057), // Rule ID 21539 //
     /*  409985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  409988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  409996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  409999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  410002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410017 */     // MIs[0] Operand 4
     /*  410017 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410035 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  410038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410055 */     GIR_RootConstrainSelectedInstOperands,
     /*  410056 */     // GIR_Coverage, 21539,
     /*  410056 */     GIR_EraseRootFromParent_Done,
     /*  410057 */   // Label 7278: @410057
     /*  410057 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(410134), // Rule ID 21542 //
     /*  410062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  410065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  410079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410094 */     // MIs[0] Operand 4
     /*  410094 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  410115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410132 */     GIR_RootConstrainSelectedInstOperands,
     /*  410133 */     // GIR_Coverage, 21542,
     /*  410133 */     GIR_EraseRootFromParent_Done,
     /*  410134 */   // Label 7279: @410134
     /*  410134 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(410211), // Rule ID 21543 //
     /*  410139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  410142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  410156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410171 */     // MIs[0] Operand 4
     /*  410171 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410189 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  410192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410209 */     GIR_RootConstrainSelectedInstOperands,
     /*  410210 */     // GIR_Coverage, 21543,
     /*  410210 */     GIR_EraseRootFromParent_Done,
     /*  410211 */   // Label 7280: @410211
     /*  410211 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(410288), // Rule ID 21546 //
     /*  410216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  410227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  410230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  410233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410248 */     // MIs[0] Operand 4
     /*  410248 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410266 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  410269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410286 */     GIR_RootConstrainSelectedInstOperands,
     /*  410287 */     // GIR_Coverage, 21546,
     /*  410287 */     GIR_EraseRootFromParent_Done,
     /*  410288 */   // Label 7281: @410288
     /*  410288 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(410365), // Rule ID 21547 //
     /*  410293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  410304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  410307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  410310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410325 */     // MIs[0] Operand 4
     /*  410325 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410343 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  410346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410363 */     GIR_RootConstrainSelectedInstOperands,
     /*  410364 */     // GIR_Coverage, 21547,
     /*  410364 */     GIR_EraseRootFromParent_Done,
     /*  410365 */   // Label 7282: @410365
     /*  410365 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(410442), // Rule ID 21550 //
     /*  410370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  410381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  410384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  410387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410402 */     // MIs[0] Operand 4
     /*  410402 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410420 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  410423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410440 */     GIR_RootConstrainSelectedInstOperands,
     /*  410441 */     // GIR_Coverage, 21550,
     /*  410441 */     GIR_EraseRootFromParent_Done,
     /*  410442 */   // Label 7283: @410442
     /*  410442 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(410519), // Rule ID 21551 //
     /*  410447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  410458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  410461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  410464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410479 */     // MIs[0] Operand 4
     /*  410479 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410497 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  410500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410517 */     GIR_RootConstrainSelectedInstOperands,
     /*  410518 */     // GIR_Coverage, 21551,
     /*  410518 */     GIR_EraseRootFromParent_Done,
     /*  410519 */   // Label 7284: @410519
     /*  410519 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(410596), // Rule ID 21554 //
     /*  410524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  410535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  410538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  410541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410556 */     // MIs[0] Operand 4
     /*  410556 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410574 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  410577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410594 */     GIR_RootConstrainSelectedInstOperands,
     /*  410595 */     // GIR_Coverage, 21554,
     /*  410595 */     GIR_EraseRootFromParent_Done,
     /*  410596 */   // Label 7285: @410596
     /*  410596 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(410673), // Rule ID 21555 //
     /*  410601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  410612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  410615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  410618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410633 */     // MIs[0] Operand 4
     /*  410633 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410651 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  410654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410671 */     GIR_RootConstrainSelectedInstOperands,
     /*  410672 */     // GIR_Coverage, 21555,
     /*  410672 */     GIR_EraseRootFromParent_Done,
     /*  410673 */   // Label 7286: @410673
     /*  410673 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(410750), // Rule ID 21558 //
     /*  410678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  410689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  410692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  410695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410710 */     // MIs[0] Operand 4
     /*  410710 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410728 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  410731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410748 */     GIR_RootConstrainSelectedInstOperands,
     /*  410749 */     // GIR_Coverage, 21558,
     /*  410749 */     GIR_EraseRootFromParent_Done,
     /*  410750 */   // Label 7287: @410750
     /*  410750 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(410827), // Rule ID 21559 //
     /*  410755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  410766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  410769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  410772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410787 */     // MIs[0] Operand 4
     /*  410787 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410805 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  410808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410825 */     GIR_RootConstrainSelectedInstOperands,
     /*  410826 */     // GIR_Coverage, 21559,
     /*  410826 */     GIR_EraseRootFromParent_Done,
     /*  410827 */   // Label 7288: @410827
     /*  410827 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(410904), // Rule ID 21562 //
     /*  410832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  410843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  410846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  410849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410864 */     // MIs[0] Operand 4
     /*  410864 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410882 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  410885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410902 */     GIR_RootConstrainSelectedInstOperands,
     /*  410903 */     // GIR_Coverage, 21562,
     /*  410903 */     GIR_EraseRootFromParent_Done,
     /*  410904 */   // Label 7289: @410904
     /*  410904 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(410981), // Rule ID 21563 //
     /*  410909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  410920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  410923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  410926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410941 */     // MIs[0] Operand 4
     /*  410941 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410959 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  410962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410979 */     GIR_RootConstrainSelectedInstOperands,
     /*  410980 */     // GIR_Coverage, 21563,
     /*  410980 */     GIR_EraseRootFromParent_Done,
     /*  410981 */   // Label 7290: @410981
     /*  410981 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(411058), // Rule ID 21566 //
     /*  410986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  410997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  411000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  411003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411018 */     // MIs[0] Operand 4
     /*  411018 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411036 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411056 */     GIR_RootConstrainSelectedInstOperands,
     /*  411057 */     // GIR_Coverage, 21566,
     /*  411057 */     GIR_EraseRootFromParent_Done,
     /*  411058 */   // Label 7291: @411058
     /*  411058 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(411135), // Rule ID 21567 //
     /*  411063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  411074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  411077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  411080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411095 */     // MIs[0] Operand 4
     /*  411095 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411113 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  411113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411133 */     GIR_RootConstrainSelectedInstOperands,
     /*  411134 */     // GIR_Coverage, 21567,
     /*  411134 */     GIR_EraseRootFromParent_Done,
     /*  411135 */   // Label 7292: @411135
     /*  411135 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(411212), // Rule ID 21570 //
     /*  411140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  411151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  411154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411172 */     // MIs[0] Operand 4
     /*  411172 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  411193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411210 */     GIR_RootConstrainSelectedInstOperands,
     /*  411211 */     // GIR_Coverage, 21570,
     /*  411211 */     GIR_EraseRootFromParent_Done,
     /*  411212 */   // Label 7293: @411212
     /*  411212 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(411289), // Rule ID 21571 //
     /*  411217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  411228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  411231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411249 */     // MIs[0] Operand 4
     /*  411249 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411267 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  411270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411287 */     GIR_RootConstrainSelectedInstOperands,
     /*  411288 */     // GIR_Coverage, 21571,
     /*  411288 */     GIR_EraseRootFromParent_Done,
     /*  411289 */   // Label 7294: @411289
     /*  411289 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(411366), // Rule ID 21574 //
     /*  411294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  411305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  411308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411326 */     // MIs[0] Operand 4
     /*  411326 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411344 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411364 */     GIR_RootConstrainSelectedInstOperands,
     /*  411365 */     // GIR_Coverage, 21574,
     /*  411365 */     GIR_EraseRootFromParent_Done,
     /*  411366 */   // Label 7295: @411366
     /*  411366 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(411443), // Rule ID 21575 //
     /*  411371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  411382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  411385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411403 */     // MIs[0] Operand 4
     /*  411403 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411421 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411441 */     GIR_RootConstrainSelectedInstOperands,
     /*  411442 */     // GIR_Coverage, 21575,
     /*  411442 */     GIR_EraseRootFromParent_Done,
     /*  411443 */   // Label 7296: @411443
     /*  411443 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(411520), // Rule ID 21578 //
     /*  411448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  411459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  411462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411480 */     // MIs[0] Operand 4
     /*  411480 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  411501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411518 */     GIR_RootConstrainSelectedInstOperands,
     /*  411519 */     // GIR_Coverage, 21578,
     /*  411519 */     GIR_EraseRootFromParent_Done,
     /*  411520 */   // Label 7297: @411520
     /*  411520 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(411597), // Rule ID 21579 //
     /*  411525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  411536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  411539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411557 */     // MIs[0] Operand 4
     /*  411557 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411575 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  411578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411595 */     GIR_RootConstrainSelectedInstOperands,
     /*  411596 */     // GIR_Coverage, 21579,
     /*  411596 */     GIR_EraseRootFromParent_Done,
     /*  411597 */   // Label 7298: @411597
     /*  411597 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(411674), // Rule ID 21582 //
     /*  411602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  411613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  411616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  411619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411634 */     // MIs[0] Operand 4
     /*  411634 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  411655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411672 */     GIR_RootConstrainSelectedInstOperands,
     /*  411673 */     // GIR_Coverage, 21582,
     /*  411673 */     GIR_EraseRootFromParent_Done,
     /*  411674 */   // Label 7299: @411674
     /*  411674 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(411751), // Rule ID 21583 //
     /*  411679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  411690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  411693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  411696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411711 */     // MIs[0] Operand 4
     /*  411711 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411729 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  411732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411749 */     GIR_RootConstrainSelectedInstOperands,
     /*  411750 */     // GIR_Coverage, 21583,
     /*  411750 */     GIR_EraseRootFromParent_Done,
     /*  411751 */   // Label 7300: @411751
     /*  411751 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(411828), // Rule ID 21586 //
     /*  411756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  411767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  411770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  411773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411788 */     // MIs[0] Operand 4
     /*  411788 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411806 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411826 */     GIR_RootConstrainSelectedInstOperands,
     /*  411827 */     // GIR_Coverage, 21586,
     /*  411827 */     GIR_EraseRootFromParent_Done,
     /*  411828 */   // Label 7301: @411828
     /*  411828 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(411905), // Rule ID 21587 //
     /*  411833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  411844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  411847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  411850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411865 */     // MIs[0] Operand 4
     /*  411865 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411883 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411903 */     GIR_RootConstrainSelectedInstOperands,
     /*  411904 */     // GIR_Coverage, 21587,
     /*  411904 */     GIR_EraseRootFromParent_Done,
     /*  411905 */   // Label 7302: @411905
     /*  411905 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(411982), // Rule ID 21590 //
     /*  411910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  411913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  411921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  411924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  411927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411942 */     // MIs[0] Operand 4
     /*  411942 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411960 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411980 */     GIR_RootConstrainSelectedInstOperands,
     /*  411981 */     // GIR_Coverage, 21590,
     /*  411981 */     GIR_EraseRootFromParent_Done,
     /*  411982 */   // Label 7303: @411982
     /*  411982 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(412059), // Rule ID 21591 //
     /*  411987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  411990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  411998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  412001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  412004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412019 */     // MIs[0] Operand 4
     /*  412019 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412037 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  412040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412057 */     GIR_RootConstrainSelectedInstOperands,
     /*  412058 */     // GIR_Coverage, 21591,
     /*  412058 */     GIR_EraseRootFromParent_Done,
     /*  412059 */   // Label 7304: @412059
     /*  412059 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(412136), // Rule ID 21594 //
     /*  412064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  412075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  412078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  412081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412096 */     // MIs[0] Operand 4
     /*  412096 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  412117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412134 */     GIR_RootConstrainSelectedInstOperands,
     /*  412135 */     // GIR_Coverage, 21594,
     /*  412135 */     GIR_EraseRootFromParent_Done,
     /*  412136 */   // Label 7305: @412136
     /*  412136 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(412213), // Rule ID 21595 //
     /*  412141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  412152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  412155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  412158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412173 */     // MIs[0] Operand 4
     /*  412173 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412191 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  412194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412211 */     GIR_RootConstrainSelectedInstOperands,
     /*  412212 */     // GIR_Coverage, 21595,
     /*  412212 */     GIR_EraseRootFromParent_Done,
     /*  412213 */   // Label 7306: @412213
     /*  412213 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(412290), // Rule ID 21598 //
     /*  412218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  412229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  412232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  412235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412250 */     // MIs[0] Operand 4
     /*  412250 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  412271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412288 */     GIR_RootConstrainSelectedInstOperands,
     /*  412289 */     // GIR_Coverage, 21598,
     /*  412289 */     GIR_EraseRootFromParent_Done,
     /*  412290 */   // Label 7307: @412290
     /*  412290 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(412367), // Rule ID 21599 //
     /*  412295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  412306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  412309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  412312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412327 */     // MIs[0] Operand 4
     /*  412327 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412345 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  412348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412365 */     GIR_RootConstrainSelectedInstOperands,
     /*  412366 */     // GIR_Coverage, 21599,
     /*  412366 */     GIR_EraseRootFromParent_Done,
     /*  412367 */   // Label 7308: @412367
     /*  412367 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(412444), // Rule ID 21602 //
     /*  412372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  412383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  412386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  412389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412404 */     // MIs[0] Operand 4
     /*  412404 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  412425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412442 */     GIR_RootConstrainSelectedInstOperands,
     /*  412443 */     // GIR_Coverage, 21602,
     /*  412443 */     GIR_EraseRootFromParent_Done,
     /*  412444 */   // Label 7309: @412444
     /*  412444 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(412521), // Rule ID 21603 //
     /*  412449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  412460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  412463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  412466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412481 */     // MIs[0] Operand 4
     /*  412481 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412499 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  412502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412519 */     GIR_RootConstrainSelectedInstOperands,
     /*  412520 */     // GIR_Coverage, 21603,
     /*  412520 */     GIR_EraseRootFromParent_Done,
     /*  412521 */   // Label 7310: @412521
     /*  412521 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(412594), // Rule ID 62831 //
     /*  412526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  412540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412550 */     // MIs[0] op1
     /*  412550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412553 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412573 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  412573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF8),
     /*  412576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412578 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412580 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412582 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412592 */     GIR_RootConstrainSelectedInstOperands,
     /*  412593 */     // GIR_Coverage, 62831,
     /*  412593 */     GIR_EraseRootFromParent_Done,
     /*  412594 */   // Label 7311: @412594
     /*  412594 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(412667), // Rule ID 62832 //
     /*  412599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  412602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  412613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412623 */     // MIs[0] op1
     /*  412623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412646 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  412646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF8),
     /*  412649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412651 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412653 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412655 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412665 */     GIR_RootConstrainSelectedInstOperands,
     /*  412666 */     // GIR_Coverage, 62832,
     /*  412666 */     GIR_EraseRootFromParent_Done,
     /*  412667 */   // Label 7312: @412667
     /*  412667 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(412740), // Rule ID 62855 //
     /*  412672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  412680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  412686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  412689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412696 */     // MIs[0] op1
     /*  412696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412699 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412719 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  412719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF8),
     /*  412722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412724 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412726 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412728 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412738 */     GIR_RootConstrainSelectedInstOperands,
     /*  412739 */     // GIR_Coverage, 62855,
     /*  412739 */     GIR_EraseRootFromParent_Done,
     /*  412740 */   // Label 7313: @412740
     /*  412740 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(412813), // Rule ID 62856 //
     /*  412745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  412748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  412753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  412759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  412762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412769 */     // MIs[0] op1
     /*  412769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412792 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  412792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF8),
     /*  412795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412797 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412799 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412801 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412811 */     GIR_RootConstrainSelectedInstOperands,
     /*  412812 */     // GIR_Coverage, 62856,
     /*  412812 */     GIR_EraseRootFromParent_Done,
     /*  412813 */   // Label 7314: @412813
     /*  412813 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(412886), // Rule ID 62881 //
     /*  412818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  412829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  412832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412842 */     // MIs[0] op1
     /*  412842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412845 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412865 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  412865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF4),
     /*  412868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412870 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412872 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412874 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412884 */     GIR_RootConstrainSelectedInstOperands,
     /*  412885 */     // GIR_Coverage, 62881,
     /*  412885 */     GIR_EraseRootFromParent_Done,
     /*  412886 */   // Label 7315: @412886
     /*  412886 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(412959), // Rule ID 62882 //
     /*  412891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  412894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  412902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  412905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412915 */     // MIs[0] op1
     /*  412915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412938 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  412938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF4),
     /*  412941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412943 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412945 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412947 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412957 */     GIR_RootConstrainSelectedInstOperands,
     /*  412958 */     // GIR_Coverage, 62882,
     /*  412958 */     GIR_EraseRootFromParent_Done,
     /*  412959 */   // Label 7316: @412959
     /*  412959 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(413032), // Rule ID 62893 //
     /*  412964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  412972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  412975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  412978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  412981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412988 */     // MIs[0] op1
     /*  412988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412991 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413011 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF4),
     /*  413014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413016 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413018 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413020 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413030 */     GIR_RootConstrainSelectedInstOperands,
     /*  413031 */     // GIR_Coverage, 62893,
     /*  413031 */     GIR_EraseRootFromParent_Done,
     /*  413032 */   // Label 7317: @413032
     /*  413032 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(413105), // Rule ID 62894 //
     /*  413037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  413048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  413051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  413054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413061 */     // MIs[0] op1
     /*  413061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413064 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413084 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF4),
     /*  413087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413089 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413091 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413093 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413103 */     GIR_RootConstrainSelectedInstOperands,
     /*  413104 */     // GIR_Coverage, 62894,
     /*  413104 */     GIR_EraseRootFromParent_Done,
     /*  413105 */   // Label 7318: @413105
     /*  413105 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(413178), // Rule ID 62925 //
     /*  413110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413134 */     // MIs[0] op1
     /*  413134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413157 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  413160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413162 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413164 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413166 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413176 */     GIR_RootConstrainSelectedInstOperands,
     /*  413177 */     // GIR_Coverage, 62925,
     /*  413177 */     GIR_EraseRootFromParent_Done,
     /*  413178 */   // Label 7319: @413178
     /*  413178 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(413251), // Rule ID 62926 //
     /*  413183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413207 */     // MIs[0] op1
     /*  413207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413230 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  413233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413235 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413237 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413239 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413249 */     GIR_RootConstrainSelectedInstOperands,
     /*  413250 */     // GIR_Coverage, 62926,
     /*  413250 */     GIR_EraseRootFromParent_Done,
     /*  413251 */   // Label 7320: @413251
     /*  413251 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(413324), // Rule ID 62937 //
     /*  413256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  413273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413280 */     // MIs[0] op1
     /*  413280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413303 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  413306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413308 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413310 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413312 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413322 */     GIR_RootConstrainSelectedInstOperands,
     /*  413323 */     // GIR_Coverage, 62937,
     /*  413323 */     GIR_EraseRootFromParent_Done,
     /*  413324 */   // Label 7321: @413324
     /*  413324 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(413397), // Rule ID 62938 //
     /*  413329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  413346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413353 */     // MIs[0] op1
     /*  413353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413376 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  413379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413381 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413383 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413385 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413395 */     GIR_RootConstrainSelectedInstOperands,
     /*  413396 */     // GIR_Coverage, 62938,
     /*  413396 */     GIR_EraseRootFromParent_Done,
     /*  413397 */   // Label 7322: @413397
     /*  413397 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(413470), // Rule ID 62969 //
     /*  413402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413426 */     // MIs[0] op1
     /*  413426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413449 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF4),
     /*  413452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413454 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413456 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413458 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413468 */     GIR_RootConstrainSelectedInstOperands,
     /*  413469 */     // GIR_Coverage, 62969,
     /*  413469 */     GIR_EraseRootFromParent_Done,
     /*  413470 */   // Label 7323: @413470
     /*  413470 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(413543), // Rule ID 62970 //
     /*  413475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413499 */     // MIs[0] op1
     /*  413499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413522 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF4),
     /*  413525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413527 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413529 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413531 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413541 */     GIR_RootConstrainSelectedInstOperands,
     /*  413542 */     // GIR_Coverage, 62970,
     /*  413542 */     GIR_EraseRootFromParent_Done,
     /*  413543 */   // Label 7324: @413543
     /*  413543 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(413616), // Rule ID 62981 //
     /*  413548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  413565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413572 */     // MIs[0] op1
     /*  413572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413595 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF4),
     /*  413598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413600 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413602 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413604 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413614 */     GIR_RootConstrainSelectedInstOperands,
     /*  413615 */     // GIR_Coverage, 62981,
     /*  413615 */     GIR_EraseRootFromParent_Done,
     /*  413616 */   // Label 7325: @413616
     /*  413616 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(413689), // Rule ID 62982 //
     /*  413621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  413638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413645 */     // MIs[0] op1
     /*  413645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF4),
     /*  413671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413673 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413675 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413677 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413687 */     GIR_RootConstrainSelectedInstOperands,
     /*  413688 */     // GIR_Coverage, 62982,
     /*  413688 */     GIR_EraseRootFromParent_Done,
     /*  413689 */   // Label 7326: @413689
     /*  413689 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(413762), // Rule ID 63005 //
     /*  413694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  413702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  413711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413718 */     // MIs[0] op1
     /*  413718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  413726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  413734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413741 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_MF4),
     /*  413744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413746 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413748 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413750 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413760 */     GIR_RootConstrainSelectedInstOperands,
     /*  413761 */     // GIR_Coverage, 63005,
     /*  413761 */     GIR_EraseRootFromParent_Done,
     /*  413762 */   // Label 7327: @413762
     /*  413762 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(413835), // Rule ID 63006 //
     /*  413767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  413775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  413784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413791 */     // MIs[0] op1
     /*  413791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  413799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  413807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413814 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_MF4),
     /*  413817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413819 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413821 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413823 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413833 */     GIR_RootConstrainSelectedInstOperands,
     /*  413834 */     // GIR_Coverage, 63006,
     /*  413834 */     GIR_EraseRootFromParent_Done,
     /*  413835 */   // Label 7328: @413835
     /*  413835 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(413908), // Rule ID 63025 //
     /*  413840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  413851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  413854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413864 */     // MIs[0] op1
     /*  413864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413867 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413887 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  413890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413892 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413894 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413896 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413906 */     GIR_RootConstrainSelectedInstOperands,
     /*  413907 */     // GIR_Coverage, 63025,
     /*  413907 */     GIR_EraseRootFromParent_Done,
     /*  413908 */   // Label 7329: @413908
     /*  413908 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(413981), // Rule ID 63026 //
     /*  413913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  413924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  413927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413937 */     // MIs[0] op1
     /*  413937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413940 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413960 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  413963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413965 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413967 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413969 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413979 */     GIR_RootConstrainSelectedInstOperands,
     /*  413980 */     // GIR_Coverage, 63026,
     /*  413980 */     GIR_EraseRootFromParent_Done,
     /*  413981 */   // Label 7330: @413981
     /*  413981 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(414054), // Rule ID 63037 //
     /*  413986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  413997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  414003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414010 */     // MIs[0] op1
     /*  414010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414013 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414033 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  414036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414038 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414040 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414042 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414052 */     GIR_RootConstrainSelectedInstOperands,
     /*  414053 */     // GIR_Coverage, 63037,
     /*  414053 */     GIR_EraseRootFromParent_Done,
     /*  414054 */   // Label 7331: @414054
     /*  414054 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(414127), // Rule ID 63038 //
     /*  414059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  414076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414083 */     // MIs[0] op1
     /*  414083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414106 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  414109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414111 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414113 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414115 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414125 */     GIR_RootConstrainSelectedInstOperands,
     /*  414126 */     // GIR_Coverage, 63038,
     /*  414126 */     GIR_EraseRootFromParent_Done,
     /*  414127 */   // Label 7332: @414127
     /*  414127 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(414200), // Rule ID 63061 //
     /*  414132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414156 */     // MIs[0] op1
     /*  414156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414179 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_MF2),
     /*  414182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414184 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414186 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414188 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414198 */     GIR_RootConstrainSelectedInstOperands,
     /*  414199 */     // GIR_Coverage, 63061,
     /*  414199 */     GIR_EraseRootFromParent_Done,
     /*  414200 */   // Label 7333: @414200
     /*  414200 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(414273), // Rule ID 63062 //
     /*  414205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414229 */     // MIs[0] op1
     /*  414229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_MF2),
     /*  414255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414257 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414259 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414261 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414271 */     GIR_RootConstrainSelectedInstOperands,
     /*  414272 */     // GIR_Coverage, 63062,
     /*  414272 */     GIR_EraseRootFromParent_Done,
     /*  414273 */   // Label 7334: @414273
     /*  414273 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(414346), // Rule ID 63081 //
     /*  414278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414302 */     // MIs[0] op1
     /*  414302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414325 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  414325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  414328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414330 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414332 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414334 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414344 */     GIR_RootConstrainSelectedInstOperands,
     /*  414345 */     // GIR_Coverage, 63081,
     /*  414345 */     GIR_EraseRootFromParent_Done,
     /*  414346 */   // Label 7335: @414346
     /*  414346 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(414419), // Rule ID 63082 //
     /*  414351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414375 */     // MIs[0] op1
     /*  414375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414398 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  414398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  414401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414403 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414405 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414407 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414417 */     GIR_RootConstrainSelectedInstOperands,
     /*  414418 */     // GIR_Coverage, 63082,
     /*  414418 */     GIR_EraseRootFromParent_Done,
     /*  414419 */   // Label 7336: @414419
     /*  414419 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(414492), // Rule ID 63093 //
     /*  414424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  414441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414448 */     // MIs[0] op1
     /*  414448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414471 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  414471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  414474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414476 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414478 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414480 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414490 */     GIR_RootConstrainSelectedInstOperands,
     /*  414491 */     // GIR_Coverage, 63093,
     /*  414491 */     GIR_EraseRootFromParent_Done,
     /*  414492 */   // Label 7337: @414492
     /*  414492 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(414565), // Rule ID 63094 //
     /*  414497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  414514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414521 */     // MIs[0] op1
     /*  414521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414544 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  414544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  414547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414549 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414551 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414553 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414563 */     GIR_RootConstrainSelectedInstOperands,
     /*  414564 */     // GIR_Coverage, 63094,
     /*  414564 */     GIR_EraseRootFromParent_Done,
     /*  414565 */   // Label 7338: @414565
     /*  414565 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(414638), // Rule ID 63117 //
     /*  414570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414594 */     // MIs[0] op1
     /*  414594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414597 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  414610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414617 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  414617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_MF2),
     /*  414620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414622 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414624 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414626 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414636 */     GIR_RootConstrainSelectedInstOperands,
     /*  414637 */     // GIR_Coverage, 63117,
     /*  414637 */     GIR_EraseRootFromParent_Done,
     /*  414638 */   // Label 7339: @414638
     /*  414638 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(414711), // Rule ID 63118 //
     /*  414643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414667 */     // MIs[0] op1
     /*  414667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  414683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414690 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  414690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_MF2),
     /*  414693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414695 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414697 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414699 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414709 */     GIR_RootConstrainSelectedInstOperands,
     /*  414710 */     // GIR_Coverage, 63118,
     /*  414710 */     GIR_EraseRootFromParent_Done,
     /*  414711 */   // Label 7340: @414711
     /*  414711 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(414784), // Rule ID 63137 //
     /*  414716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  414730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414740 */     // MIs[0] op1
     /*  414740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414763 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  414763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  414766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414768 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414770 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414772 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414782 */     GIR_RootConstrainSelectedInstOperands,
     /*  414783 */     // GIR_Coverage, 63137,
     /*  414783 */     GIR_EraseRootFromParent_Done,
     /*  414784 */   // Label 7341: @414784
     /*  414784 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(414857), // Rule ID 63138 //
     /*  414789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  414803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414813 */     // MIs[0] op1
     /*  414813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414836 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  414836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  414839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414841 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414843 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414845 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414855 */     GIR_RootConstrainSelectedInstOperands,
     /*  414856 */     // GIR_Coverage, 63138,
     /*  414856 */     GIR_EraseRootFromParent_Done,
     /*  414857 */   // Label 7342: @414857
     /*  414857 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(414930), // Rule ID 63149 //
     /*  414862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  414876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  414879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414886 */     // MIs[0] op1
     /*  414886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414909 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  414909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  414912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414914 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414916 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414918 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414928 */     GIR_RootConstrainSelectedInstOperands,
     /*  414929 */     // GIR_Coverage, 63149,
     /*  414929 */     GIR_EraseRootFromParent_Done,
     /*  414930 */   // Label 7343: @414930
     /*  414930 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(415003), // Rule ID 63150 //
     /*  414935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  414949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  414952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414959 */     // MIs[0] op1
     /*  414959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  414982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  414985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414987 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414989 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414991 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  415001 */     GIR_RootConstrainSelectedInstOperands,
     /*  415002 */     // GIR_Coverage, 63150,
     /*  415002 */     GIR_EraseRootFromParent_Done,
     /*  415003 */   // Label 7344: @415003
     /*  415003 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(415076), // Rule ID 63181 //
     /*  415008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415032 */     // MIs[0] op1
     /*  415032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415055 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  415055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415060 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415062 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415064 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415074 */     GIR_RootConstrainSelectedInstOperands,
     /*  415075 */     // GIR_Coverage, 63181,
     /*  415075 */     GIR_EraseRootFromParent_Done,
     /*  415076 */   // Label 7345: @415076
     /*  415076 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(415149), // Rule ID 63182 //
     /*  415081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415105 */     // MIs[0] op1
     /*  415105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415108 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415128 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  415128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415133 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415135 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415137 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415147 */     GIR_RootConstrainSelectedInstOperands,
     /*  415148 */     // GIR_Coverage, 63182,
     /*  415148 */     GIR_EraseRootFromParent_Done,
     /*  415149 */   // Label 7346: @415149
     /*  415149 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(415222), // Rule ID 63193 //
     /*  415154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  415171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415178 */     // MIs[0] op1
     /*  415178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415201 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  415201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  415204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415206 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415208 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415210 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415220 */     GIR_RootConstrainSelectedInstOperands,
     /*  415221 */     // GIR_Coverage, 63193,
     /*  415221 */     GIR_EraseRootFromParent_Done,
     /*  415222 */   // Label 7347: @415222
     /*  415222 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(415295), // Rule ID 63194 //
     /*  415227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  415244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415251 */     // MIs[0] op1
     /*  415251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415254 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415274 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  415274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  415277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415279 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415281 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415283 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415293 */     GIR_RootConstrainSelectedInstOperands,
     /*  415294 */     // GIR_Coverage, 63194,
     /*  415294 */     GIR_EraseRootFromParent_Done,
     /*  415295 */   // Label 7348: @415295
     /*  415295 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(415368), // Rule ID 63217 //
     /*  415300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  415317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415324 */     // MIs[0] op1
     /*  415324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  415340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415347 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  415347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M1),
     /*  415350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415352 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415354 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415356 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415366 */     GIR_RootConstrainSelectedInstOperands,
     /*  415367 */     // GIR_Coverage, 63217,
     /*  415367 */     GIR_EraseRootFromParent_Done,
     /*  415368 */   // Label 7349: @415368
     /*  415368 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(415441), // Rule ID 63218 //
     /*  415373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  415390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415397 */     // MIs[0] op1
     /*  415397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415400 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  415413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415420 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  415420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M1),
     /*  415423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415425 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415427 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415429 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415439 */     GIR_RootConstrainSelectedInstOperands,
     /*  415440 */     // GIR_Coverage, 63218,
     /*  415440 */     GIR_EraseRootFromParent_Done,
     /*  415441 */   // Label 7350: @415441
     /*  415441 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(415514), // Rule ID 63237 //
     /*  415446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415470 */     // MIs[0] op1
     /*  415470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  415493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415498 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415500 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415502 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415512 */     GIR_RootConstrainSelectedInstOperands,
     /*  415513 */     // GIR_Coverage, 63237,
     /*  415513 */     GIR_EraseRootFromParent_Done,
     /*  415514 */   // Label 7351: @415514
     /*  415514 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(415587), // Rule ID 63238 //
     /*  415519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415543 */     // MIs[0] op1
     /*  415543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415566 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  415566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415571 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415573 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415575 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415585 */     GIR_RootConstrainSelectedInstOperands,
     /*  415586 */     // GIR_Coverage, 63238,
     /*  415586 */     GIR_EraseRootFromParent_Done,
     /*  415587 */   // Label 7352: @415587
     /*  415587 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(415660), // Rule ID 63249 //
     /*  415592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  415609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415616 */     // MIs[0] op1
     /*  415616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415639 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  415639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  415642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415644 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415646 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415648 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415658 */     GIR_RootConstrainSelectedInstOperands,
     /*  415659 */     // GIR_Coverage, 63249,
     /*  415659 */     GIR_EraseRootFromParent_Done,
     /*  415660 */   // Label 7353: @415660
     /*  415660 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(415733), // Rule ID 63250 //
     /*  415665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  415682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415689 */     // MIs[0] op1
     /*  415689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415712 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  415712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  415715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415717 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415719 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415721 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415731 */     GIR_RootConstrainSelectedInstOperands,
     /*  415732 */     // GIR_Coverage, 63250,
     /*  415732 */     GIR_EraseRootFromParent_Done,
     /*  415733 */   // Label 7354: @415733
     /*  415733 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(415806), // Rule ID 63273 //
     /*  415738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415762 */     // MIs[0] op1
     /*  415762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415765 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  415778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415785 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  415785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M1),
     /*  415788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415790 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415792 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415794 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415804 */     GIR_RootConstrainSelectedInstOperands,
     /*  415805 */     // GIR_Coverage, 63273,
     /*  415805 */     GIR_EraseRootFromParent_Done,
     /*  415806 */   // Label 7355: @415806
     /*  415806 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(415879), // Rule ID 63274 //
     /*  415811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415835 */     // MIs[0] op1
     /*  415835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  415851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415858 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  415858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M1),
     /*  415861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415863 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415865 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415867 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415877 */     GIR_RootConstrainSelectedInstOperands,
     /*  415878 */     // GIR_Coverage, 63274,
     /*  415878 */     GIR_EraseRootFromParent_Done,
     /*  415879 */   // Label 7356: @415879
     /*  415879 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(415952), // Rule ID 63293 //
     /*  415884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  415895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415908 */     // MIs[0] op1
     /*  415908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415931 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  415931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415936 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415938 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415940 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  415950 */     GIR_RootConstrainSelectedInstOperands,
     /*  415951 */     // GIR_Coverage, 63293,
     /*  415951 */     GIR_EraseRootFromParent_Done,
     /*  415952 */   // Label 7357: @415952
     /*  415952 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(416025), // Rule ID 63294 //
     /*  415957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  415968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415981 */     // MIs[0] op1
     /*  415981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416004 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  416004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  416007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416009 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416011 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416013 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416023 */     GIR_RootConstrainSelectedInstOperands,
     /*  416024 */     // GIR_Coverage, 63294,
     /*  416024 */     GIR_EraseRootFromParent_Done,
     /*  416025 */   // Label 7358: @416025
     /*  416025 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(416098), // Rule ID 63305 //
     /*  416030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  416047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416054 */     // MIs[0] op1
     /*  416054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416077 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  416077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  416080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416082 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416084 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416086 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416096 */     GIR_RootConstrainSelectedInstOperands,
     /*  416097 */     // GIR_Coverage, 63305,
     /*  416097 */     GIR_EraseRootFromParent_Done,
     /*  416098 */   // Label 7359: @416098
     /*  416098 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(416171), // Rule ID 63306 //
     /*  416103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  416120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416127 */     // MIs[0] op1
     /*  416127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416150 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  416150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  416153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416155 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416157 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416159 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416169 */     GIR_RootConstrainSelectedInstOperands,
     /*  416170 */     // GIR_Coverage, 63306,
     /*  416170 */     GIR_EraseRootFromParent_Done,
     /*  416171 */   // Label 7360: @416171
     /*  416171 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(416244), // Rule ID 63329 //
     /*  416176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  416184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416200 */     // MIs[0] op1
     /*  416200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  416208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  416216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416223 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  416223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M1),
     /*  416226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416228 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416230 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416232 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416242 */     GIR_RootConstrainSelectedInstOperands,
     /*  416243 */     // GIR_Coverage, 63329,
     /*  416243 */     GIR_EraseRootFromParent_Done,
     /*  416244 */   // Label 7361: @416244
     /*  416244 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(416317), // Rule ID 63330 //
     /*  416249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  416257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416273 */     // MIs[0] op1
     /*  416273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  416281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  416289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416296 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  416296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M1),
     /*  416299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416301 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416303 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416305 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416315 */     GIR_RootConstrainSelectedInstOperands,
     /*  416316 */     // GIR_Coverage, 63330,
     /*  416316 */     GIR_EraseRootFromParent_Done,
     /*  416317 */   // Label 7362: @416317
     /*  416317 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(416390), // Rule ID 63349 //
     /*  416322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416346 */     // MIs[0] op1
     /*  416346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416349 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416369 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  416372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416374 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416376 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416378 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416388 */     GIR_RootConstrainSelectedInstOperands,
     /*  416389 */     // GIR_Coverage, 63349,
     /*  416389 */     GIR_EraseRootFromParent_Done,
     /*  416390 */   // Label 7363: @416390
     /*  416390 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(416463), // Rule ID 63350 //
     /*  416395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416419 */     // MIs[0] op1
     /*  416419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416422 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416442 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  416445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416447 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416449 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416451 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416461 */     GIR_RootConstrainSelectedInstOperands,
     /*  416462 */     // GIR_Coverage, 63350,
     /*  416462 */     GIR_EraseRootFromParent_Done,
     /*  416463 */   // Label 7364: @416463
     /*  416463 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(416536), // Rule ID 63361 //
     /*  416468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  416485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416492 */     // MIs[0] op1
     /*  416492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416495 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416515 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  416518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416520 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416522 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416524 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416534 */     GIR_RootConstrainSelectedInstOperands,
     /*  416535 */     // GIR_Coverage, 63361,
     /*  416535 */     GIR_EraseRootFromParent_Done,
     /*  416536 */   // Label 7365: @416536
     /*  416536 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(416609), // Rule ID 63362 //
     /*  416541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  416558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416565 */     // MIs[0] op1
     /*  416565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416568 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416588 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  416591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416593 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416595 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416597 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416607 */     GIR_RootConstrainSelectedInstOperands,
     /*  416608 */     // GIR_Coverage, 63362,
     /*  416608 */     GIR_EraseRootFromParent_Done,
     /*  416609 */   // Label 7366: @416609
     /*  416609 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(416682), // Rule ID 63393 //
     /*  416614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  416625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  416628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416638 */     // MIs[0] op1
     /*  416638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416641 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416661 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  416664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416666 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416668 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416670 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416680 */     GIR_RootConstrainSelectedInstOperands,
     /*  416681 */     // GIR_Coverage, 63393,
     /*  416681 */     GIR_EraseRootFromParent_Done,
     /*  416682 */   // Label 7367: @416682
     /*  416682 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(416755), // Rule ID 63394 //
     /*  416687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  416698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  416701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416711 */     // MIs[0] op1
     /*  416711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416734 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  416737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416739 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416741 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416743 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416753 */     GIR_RootConstrainSelectedInstOperands,
     /*  416754 */     // GIR_Coverage, 63394,
     /*  416754 */     GIR_EraseRootFromParent_Done,
     /*  416755 */   // Label 7368: @416755
     /*  416755 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(416828), // Rule ID 63405 //
     /*  416760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  416771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  416774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  416777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416784 */     // MIs[0] op1
     /*  416784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416807 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  416810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416812 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416814 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416816 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416826 */     GIR_RootConstrainSelectedInstOperands,
     /*  416827 */     // GIR_Coverage, 63405,
     /*  416827 */     GIR_EraseRootFromParent_Done,
     /*  416828 */   // Label 7369: @416828
     /*  416828 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(416901), // Rule ID 63406 //
     /*  416833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  416844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  416847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  416850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416857 */     // MIs[0] op1
     /*  416857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416880 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  416883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416885 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416887 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416889 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416899 */     GIR_RootConstrainSelectedInstOperands,
     /*  416900 */     // GIR_Coverage, 63406,
     /*  416900 */     GIR_EraseRootFromParent_Done,
     /*  416901 */   // Label 7370: @416901
     /*  416901 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(416974), // Rule ID 63437 //
     /*  416906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  416917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  416920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416930 */     // MIs[0] op1
     /*  416930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416953 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  416956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416958 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416960 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416962 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416972 */     GIR_RootConstrainSelectedInstOperands,
     /*  416973 */     // GIR_Coverage, 63437,
     /*  416973 */     GIR_EraseRootFromParent_Done,
     /*  416974 */   // Label 7371: @416974
     /*  416974 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(417047), // Rule ID 63438 //
     /*  416979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  416990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  416993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417003 */     // MIs[0] op1
     /*  417003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417026 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  417029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417031 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417033 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417035 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417045 */     GIR_RootConstrainSelectedInstOperands,
     /*  417046 */     // GIR_Coverage, 63438,
     /*  417046 */     GIR_EraseRootFromParent_Done,
     /*  417047 */   // Label 7372: @417047
     /*  417047 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(417120), // Rule ID 63449 //
     /*  417052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  417063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  417066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  417069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417076 */     // MIs[0] op1
     /*  417076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417079 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417099 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  417099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  417102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417104 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417106 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417108 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417118 */     GIR_RootConstrainSelectedInstOperands,
     /*  417119 */     // GIR_Coverage, 63449,
     /*  417119 */     GIR_EraseRootFromParent_Done,
     /*  417120 */   // Label 7373: @417120
     /*  417120 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(417193), // Rule ID 63450 //
     /*  417125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  417136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  417139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  417142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417149 */     // MIs[0] op1
     /*  417149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417152 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417172 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  417175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417177 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417179 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417181 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417191 */     GIR_RootConstrainSelectedInstOperands,
     /*  417192 */     // GIR_Coverage, 63450,
     /*  417192 */     GIR_EraseRootFromParent_Done,
     /*  417193 */   // Label 7374: @417193
     /*  417193 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(417266), // Rule ID 63481 //
     /*  417198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417222 */     // MIs[0] op1
     /*  417222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  417248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417250 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417252 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417254 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417264 */     GIR_RootConstrainSelectedInstOperands,
     /*  417265 */     // GIR_Coverage, 63481,
     /*  417265 */     GIR_EraseRootFromParent_Done,
     /*  417266 */   // Label 7375: @417266
     /*  417266 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(417339), // Rule ID 63482 //
     /*  417271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417295 */     // MIs[0] op1
     /*  417295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  417321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417323 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417325 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417327 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417337 */     GIR_RootConstrainSelectedInstOperands,
     /*  417338 */     // GIR_Coverage, 63482,
     /*  417338 */     GIR_EraseRootFromParent_Done,
     /*  417339 */   // Label 7376: @417339
     /*  417339 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(417412), // Rule ID 63493 //
     /*  417344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  417361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417368 */     // MIs[0] op1
     /*  417368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417371 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417391 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  417394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417396 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417398 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417400 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417410 */     GIR_RootConstrainSelectedInstOperands,
     /*  417411 */     // GIR_Coverage, 63493,
     /*  417411 */     GIR_EraseRootFromParent_Done,
     /*  417412 */   // Label 7377: @417412
     /*  417412 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(417485), // Rule ID 63494 //
     /*  417417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  417434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417441 */     // MIs[0] op1
     /*  417441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  417467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417469 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417471 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417473 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417483 */     GIR_RootConstrainSelectedInstOperands,
     /*  417484 */     // GIR_Coverage, 63494,
     /*  417484 */     GIR_EraseRootFromParent_Done,
     /*  417485 */   // Label 7378: @417485
     /*  417485 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(417558), // Rule ID 63517 //
     /*  417490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417514 */     // MIs[0] op1
     /*  417514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417537 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M2),
     /*  417540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417542 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417544 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417546 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417556 */     GIR_RootConstrainSelectedInstOperands,
     /*  417557 */     // GIR_Coverage, 63517,
     /*  417557 */     GIR_EraseRootFromParent_Done,
     /*  417558 */   // Label 7379: @417558
     /*  417558 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(417631), // Rule ID 63518 //
     /*  417563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417587 */     // MIs[0] op1
     /*  417587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417590 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417610 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M2),
     /*  417613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417615 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417617 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417619 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417629 */     GIR_RootConstrainSelectedInstOperands,
     /*  417630 */     // GIR_Coverage, 63518,
     /*  417630 */     GIR_EraseRootFromParent_Done,
     /*  417631 */   // Label 7380: @417631
     /*  417631 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(417704), // Rule ID 63537 //
     /*  417636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417660 */     // MIs[0] op1
     /*  417660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417683 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  417686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417688 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417690 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417692 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417702 */     GIR_RootConstrainSelectedInstOperands,
     /*  417703 */     // GIR_Coverage, 63537,
     /*  417703 */     GIR_EraseRootFromParent_Done,
     /*  417704 */   // Label 7381: @417704
     /*  417704 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(417777), // Rule ID 63538 //
     /*  417709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417733 */     // MIs[0] op1
     /*  417733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417756 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  417759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417761 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417763 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417765 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417775 */     GIR_RootConstrainSelectedInstOperands,
     /*  417776 */     // GIR_Coverage, 63538,
     /*  417776 */     GIR_EraseRootFromParent_Done,
     /*  417777 */   // Label 7382: @417777
     /*  417777 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(417850), // Rule ID 63549 //
     /*  417782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  417799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417806 */     // MIs[0] op1
     /*  417806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417829 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  417832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417834 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417836 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417838 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417848 */     GIR_RootConstrainSelectedInstOperands,
     /*  417849 */     // GIR_Coverage, 63549,
     /*  417849 */     GIR_EraseRootFromParent_Done,
     /*  417850 */   // Label 7383: @417850
     /*  417850 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(417923), // Rule ID 63550 //
     /*  417855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  417872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417879 */     // MIs[0] op1
     /*  417879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417902 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  417905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417907 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417909 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417911 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417921 */     GIR_RootConstrainSelectedInstOperands,
     /*  417922 */     // GIR_Coverage, 63550,
     /*  417922 */     GIR_EraseRootFromParent_Done,
     /*  417923 */   // Label 7384: @417923
     /*  417923 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(417996), // Rule ID 63573 //
     /*  417928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417952 */     // MIs[0] op1
     /*  417952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417975 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M4),
     /*  417978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417980 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417982 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417984 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417994 */     GIR_RootConstrainSelectedInstOperands,
     /*  417995 */     // GIR_Coverage, 63573,
     /*  417995 */     GIR_EraseRootFromParent_Done,
     /*  417996 */   // Label 7385: @417996
     /*  417996 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(418069), // Rule ID 63574 //
     /*  418001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418025 */     // MIs[0] op1
     /*  418025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418048 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M4),
     /*  418051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418053 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418055 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418057 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418067 */     GIR_RootConstrainSelectedInstOperands,
     /*  418068 */     // GIR_Coverage, 63574,
     /*  418068 */     GIR_EraseRootFromParent_Done,
     /*  418069 */   // Label 7386: @418069
     /*  418069 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(418142), // Rule ID 63593 //
     /*  418074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418098 */     // MIs[0] op1
     /*  418098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418121 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  418124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418126 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418128 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418130 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418140 */     GIR_RootConstrainSelectedInstOperands,
     /*  418141 */     // GIR_Coverage, 63593,
     /*  418141 */     GIR_EraseRootFromParent_Done,
     /*  418142 */   // Label 7387: @418142
     /*  418142 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(418215), // Rule ID 63594 //
     /*  418147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418171 */     // MIs[0] op1
     /*  418171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418194 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  418197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418199 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418201 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418203 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418213 */     GIR_RootConstrainSelectedInstOperands,
     /*  418214 */     // GIR_Coverage, 63594,
     /*  418214 */     GIR_EraseRootFromParent_Done,
     /*  418215 */   // Label 7388: @418215
     /*  418215 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(418288), // Rule ID 63605 //
     /*  418220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  418237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418244 */     // MIs[0] op1
     /*  418244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418247 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418267 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  418270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418272 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418274 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418276 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418286 */     GIR_RootConstrainSelectedInstOperands,
     /*  418287 */     // GIR_Coverage, 63605,
     /*  418287 */     GIR_EraseRootFromParent_Done,
     /*  418288 */   // Label 7389: @418288
     /*  418288 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(418361), // Rule ID 63606 //
     /*  418293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  418310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418317 */     // MIs[0] op1
     /*  418317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418320 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418340 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  418343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418345 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418347 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418349 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418359 */     GIR_RootConstrainSelectedInstOperands,
     /*  418360 */     // GIR_Coverage, 63606,
     /*  418360 */     GIR_EraseRootFromParent_Done,
     /*  418361 */   // Label 7390: @418361
     /*  418361 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(418434), // Rule ID 63629 //
     /*  418366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418390 */     // MIs[0] op1
     /*  418390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418413 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M8),
     /*  418416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418418 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418420 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418422 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418432 */     GIR_RootConstrainSelectedInstOperands,
     /*  418433 */     // GIR_Coverage, 63629,
     /*  418433 */     GIR_EraseRootFromParent_Done,
     /*  418434 */   // Label 7391: @418434
     /*  418434 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(418507), // Rule ID 63630 //
     /*  418439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418463 */     // MIs[0] op1
     /*  418463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418466 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418486 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M8),
     /*  418489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418491 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418493 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418495 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418505 */     GIR_RootConstrainSelectedInstOperands,
     /*  418506 */     // GIR_Coverage, 63630,
     /*  418506 */     GIR_EraseRootFromParent_Done,
     /*  418507 */   // Label 7392: @418507
     /*  418507 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(418580), // Rule ID 63649 //
     /*  418512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418536 */     // MIs[0] op1
     /*  418536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418559 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  418562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418564 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418566 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418568 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418578 */     GIR_RootConstrainSelectedInstOperands,
     /*  418579 */     // GIR_Coverage, 63649,
     /*  418579 */     GIR_EraseRootFromParent_Done,
     /*  418580 */   // Label 7393: @418580
     /*  418580 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(418653), // Rule ID 63650 //
     /*  418585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418609 */     // MIs[0] op1
     /*  418609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418632 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  418635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418637 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418639 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418641 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418651 */     GIR_RootConstrainSelectedInstOperands,
     /*  418652 */     // GIR_Coverage, 63650,
     /*  418652 */     GIR_EraseRootFromParent_Done,
     /*  418653 */   // Label 7394: @418653
     /*  418653 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(418726), // Rule ID 63661 //
     /*  418658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  418675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418682 */     // MIs[0] op1
     /*  418682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418705 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  418708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418710 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418712 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418714 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418724 */     GIR_RootConstrainSelectedInstOperands,
     /*  418725 */     // GIR_Coverage, 63661,
     /*  418725 */     GIR_EraseRootFromParent_Done,
     /*  418726 */   // Label 7395: @418726
     /*  418726 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(418799), // Rule ID 63662 //
     /*  418731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  418748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418755 */     // MIs[0] op1
     /*  418755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418758 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  418781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418783 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418785 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418787 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418797 */     GIR_RootConstrainSelectedInstOperands,
     /*  418798 */     // GIR_Coverage, 63662,
     /*  418798 */     GIR_EraseRootFromParent_Done,
     /*  418799 */   // Label 7396: @418799
     /*  418799 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(418872), // Rule ID 63685 //
     /*  418804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418828 */     // MIs[0] op1
     /*  418828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418831 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  418844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M2),
     /*  418854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418856 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418858 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418860 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418870 */     GIR_RootConstrainSelectedInstOperands,
     /*  418871 */     // GIR_Coverage, 63685,
     /*  418871 */     GIR_EraseRootFromParent_Done,
     /*  418872 */   // Label 7397: @418872
     /*  418872 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(418945), // Rule ID 63686 //
     /*  418877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418901 */     // MIs[0] op1
     /*  418901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  418917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418924 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M2),
     /*  418927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418929 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418931 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418933 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418943 */     GIR_RootConstrainSelectedInstOperands,
     /*  418944 */     // GIR_Coverage, 63686,
     /*  418944 */     GIR_EraseRootFromParent_Done,
     /*  418945 */   // Label 7398: @418945
     /*  418945 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(419018), // Rule ID 63705 //
     /*  418950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  418961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  418964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418974 */     // MIs[0] op1
     /*  418974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418997 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  419000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419002 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419004 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419006 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419016 */     GIR_RootConstrainSelectedInstOperands,
     /*  419017 */     // GIR_Coverage, 63705,
     /*  419017 */     GIR_EraseRootFromParent_Done,
     /*  419018 */   // Label 7399: @419018
     /*  419018 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(419091), // Rule ID 63706 //
     /*  419023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419047 */     // MIs[0] op1
     /*  419047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419070 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  419073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419075 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419077 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419079 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419089 */     GIR_RootConstrainSelectedInstOperands,
     /*  419090 */     // GIR_Coverage, 63706,
     /*  419090 */     GIR_EraseRootFromParent_Done,
     /*  419091 */   // Label 7400: @419091
     /*  419091 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(419164), // Rule ID 63717 //
     /*  419096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  419113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419120 */     // MIs[0] op1
     /*  419120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419143 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  419146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419148 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419150 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419152 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419162 */     GIR_RootConstrainSelectedInstOperands,
     /*  419163 */     // GIR_Coverage, 63717,
     /*  419163 */     GIR_EraseRootFromParent_Done,
     /*  419164 */   // Label 7401: @419164
     /*  419164 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(419237), // Rule ID 63718 //
     /*  419169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  419186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419193 */     // MIs[0] op1
     /*  419193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419216 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  419219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419221 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419223 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419225 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419235 */     GIR_RootConstrainSelectedInstOperands,
     /*  419236 */     // GIR_Coverage, 63718,
     /*  419236 */     GIR_EraseRootFromParent_Done,
     /*  419237 */   // Label 7402: @419237
     /*  419237 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(419310), // Rule ID 63741 //
     /*  419242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419266 */     // MIs[0] op1
     /*  419266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419289 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M4),
     /*  419292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419294 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419296 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419298 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419308 */     GIR_RootConstrainSelectedInstOperands,
     /*  419309 */     // GIR_Coverage, 63741,
     /*  419309 */     GIR_EraseRootFromParent_Done,
     /*  419310 */   // Label 7403: @419310
     /*  419310 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(419383), // Rule ID 63742 //
     /*  419315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419339 */     // MIs[0] op1
     /*  419339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419362 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M4),
     /*  419365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419367 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419369 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419371 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419381 */     GIR_RootConstrainSelectedInstOperands,
     /*  419382 */     // GIR_Coverage, 63742,
     /*  419382 */     GIR_EraseRootFromParent_Done,
     /*  419383 */   // Label 7404: @419383
     /*  419383 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(419456), // Rule ID 63761 //
     /*  419388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419412 */     // MIs[0] op1
     /*  419412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419435 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  419438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419440 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419442 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419444 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419454 */     GIR_RootConstrainSelectedInstOperands,
     /*  419455 */     // GIR_Coverage, 63761,
     /*  419455 */     GIR_EraseRootFromParent_Done,
     /*  419456 */   // Label 7405: @419456
     /*  419456 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(419529), // Rule ID 63762 //
     /*  419461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419485 */     // MIs[0] op1
     /*  419485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419508 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  419511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419513 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419515 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419517 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419527 */     GIR_RootConstrainSelectedInstOperands,
     /*  419528 */     // GIR_Coverage, 63762,
     /*  419528 */     GIR_EraseRootFromParent_Done,
     /*  419529 */   // Label 7406: @419529
     /*  419529 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(419602), // Rule ID 63773 //
     /*  419534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  419551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419558 */     // MIs[0] op1
     /*  419558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419581 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  419584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419586 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419588 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419590 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419600 */     GIR_RootConstrainSelectedInstOperands,
     /*  419601 */     // GIR_Coverage, 63773,
     /*  419601 */     GIR_EraseRootFromParent_Done,
     /*  419602 */   // Label 7407: @419602
     /*  419602 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(419675), // Rule ID 63774 //
     /*  419607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  419624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419631 */     // MIs[0] op1
     /*  419631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419654 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  419657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419659 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419661 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419663 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419673 */     GIR_RootConstrainSelectedInstOperands,
     /*  419674 */     // GIR_Coverage, 63774,
     /*  419674 */     GIR_EraseRootFromParent_Done,
     /*  419675 */   // Label 7408: @419675
     /*  419675 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(419748), // Rule ID 63797 //
     /*  419680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419704 */     // MIs[0] op1
     /*  419704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419727 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M8),
     /*  419730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419732 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419734 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419736 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419746 */     GIR_RootConstrainSelectedInstOperands,
     /*  419747 */     // GIR_Coverage, 63797,
     /*  419747 */     GIR_EraseRootFromParent_Done,
     /*  419748 */   // Label 7409: @419748
     /*  419748 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(419821), // Rule ID 63798 //
     /*  419753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419777 */     // MIs[0] op1
     /*  419777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419800 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M8),
     /*  419803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419805 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419807 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419809 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419819 */     GIR_RootConstrainSelectedInstOperands,
     /*  419820 */     // GIR_Coverage, 63798,
     /*  419820 */     GIR_EraseRootFromParent_Done,
     /*  419821 */   // Label 7410: @419821
     /*  419821 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(419894), // Rule ID 63817 //
     /*  419826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  419837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  419840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419850 */     // MIs[0] op1
     /*  419850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419853 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419873 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  419873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  419876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419878 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419880 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419882 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419892 */     GIR_RootConstrainSelectedInstOperands,
     /*  419893 */     // GIR_Coverage, 63817,
     /*  419893 */     GIR_EraseRootFromParent_Done,
     /*  419894 */   // Label 7411: @419894
     /*  419894 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(419967), // Rule ID 63818 //
     /*  419899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  419910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  419913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419923 */     // MIs[0] op1
     /*  419923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  419946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  419949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419951 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419953 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419955 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419965 */     GIR_RootConstrainSelectedInstOperands,
     /*  419966 */     // GIR_Coverage, 63818,
     /*  419966 */     GIR_EraseRootFromParent_Done,
     /*  419967 */   // Label 7412: @419967
     /*  419967 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(420040), // Rule ID 63829 //
     /*  419972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  419983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  419986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  419989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419996 */     // MIs[0] op1
     /*  419996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419999 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420019 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  420022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420024 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420026 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420028 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420038 */     GIR_RootConstrainSelectedInstOperands,
     /*  420039 */     // GIR_Coverage, 63829,
     /*  420039 */     GIR_EraseRootFromParent_Done,
     /*  420040 */   // Label 7413: @420040
     /*  420040 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(420113), // Rule ID 63830 //
     /*  420045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  420062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420069 */     // MIs[0] op1
     /*  420069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420092 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  420095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420097 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420099 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420101 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420111 */     GIR_RootConstrainSelectedInstOperands,
     /*  420112 */     // GIR_Coverage, 63830,
     /*  420112 */     GIR_EraseRootFromParent_Done,
     /*  420113 */   // Label 7414: @420113
     /*  420113 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(420186), // Rule ID 63853 //
     /*  420118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420142 */     // MIs[0] op1
     /*  420142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420145 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420165 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M2),
     /*  420168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420170 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420172 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420174 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420184 */     GIR_RootConstrainSelectedInstOperands,
     /*  420185 */     // GIR_Coverage, 63853,
     /*  420185 */     GIR_EraseRootFromParent_Done,
     /*  420186 */   // Label 7415: @420186
     /*  420186 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(420259), // Rule ID 63854 //
     /*  420191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420215 */     // MIs[0] op1
     /*  420215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420218 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M2),
     /*  420241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420243 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420245 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420247 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420257 */     GIR_RootConstrainSelectedInstOperands,
     /*  420258 */     // GIR_Coverage, 63854,
     /*  420258 */     GIR_EraseRootFromParent_Done,
     /*  420259 */   // Label 7416: @420259
     /*  420259 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(420332), // Rule ID 63873 //
     /*  420264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420288 */     // MIs[0] op1
     /*  420288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420311 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  420314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420316 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420318 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420320 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420330 */     GIR_RootConstrainSelectedInstOperands,
     /*  420331 */     // GIR_Coverage, 63873,
     /*  420331 */     GIR_EraseRootFromParent_Done,
     /*  420332 */   // Label 7417: @420332
     /*  420332 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(420405), // Rule ID 63874 //
     /*  420337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420361 */     // MIs[0] op1
     /*  420361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420384 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  420387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420389 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420391 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420393 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420403 */     GIR_RootConstrainSelectedInstOperands,
     /*  420404 */     // GIR_Coverage, 63874,
     /*  420404 */     GIR_EraseRootFromParent_Done,
     /*  420405 */   // Label 7418: @420405
     /*  420405 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(420478), // Rule ID 63885 //
     /*  420410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  420427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420434 */     // MIs[0] op1
     /*  420434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420437 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420457 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  420460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420462 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420464 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420466 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420476 */     GIR_RootConstrainSelectedInstOperands,
     /*  420477 */     // GIR_Coverage, 63885,
     /*  420477 */     GIR_EraseRootFromParent_Done,
     /*  420478 */   // Label 7419: @420478
     /*  420478 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(420551), // Rule ID 63886 //
     /*  420483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  420500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420507 */     // MIs[0] op1
     /*  420507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420530 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  420533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420535 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420537 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420539 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420549 */     GIR_RootConstrainSelectedInstOperands,
     /*  420550 */     // GIR_Coverage, 63886,
     /*  420550 */     GIR_EraseRootFromParent_Done,
     /*  420551 */   // Label 7420: @420551
     /*  420551 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(420624), // Rule ID 63909 //
     /*  420556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420580 */     // MIs[0] op1
     /*  420580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420583 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420603 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M4),
     /*  420606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420608 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420610 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420612 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420622 */     GIR_RootConstrainSelectedInstOperands,
     /*  420623 */     // GIR_Coverage, 63909,
     /*  420623 */     GIR_EraseRootFromParent_Done,
     /*  420624 */   // Label 7421: @420624
     /*  420624 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(420697), // Rule ID 63910 //
     /*  420629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420653 */     // MIs[0] op1
     /*  420653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420676 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M4),
     /*  420679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420681 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420683 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420685 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420695 */     GIR_RootConstrainSelectedInstOperands,
     /*  420696 */     // GIR_Coverage, 63910,
     /*  420696 */     GIR_EraseRootFromParent_Done,
     /*  420697 */   // Label 7422: @420697
     /*  420697 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(420770), // Rule ID 63929 //
     /*  420702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420726 */     // MIs[0] op1
     /*  420726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420749 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  420752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420754 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420756 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420758 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420768 */     GIR_RootConstrainSelectedInstOperands,
     /*  420769 */     // GIR_Coverage, 63929,
     /*  420769 */     GIR_EraseRootFromParent_Done,
     /*  420770 */   // Label 7423: @420770
     /*  420770 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(420843), // Rule ID 63930 //
     /*  420775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420799 */     // MIs[0] op1
     /*  420799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420822 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  420825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420827 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420829 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420831 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420841 */     GIR_RootConstrainSelectedInstOperands,
     /*  420842 */     // GIR_Coverage, 63930,
     /*  420842 */     GIR_EraseRootFromParent_Done,
     /*  420843 */   // Label 7424: @420843
     /*  420843 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(420916), // Rule ID 63941 //
     /*  420848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  420865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420872 */     // MIs[0] op1
     /*  420872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420895 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11089:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  420898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420900 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420902 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420904 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420914 */     GIR_RootConstrainSelectedInstOperands,
     /*  420915 */     // GIR_Coverage, 63941,
     /*  420915 */     GIR_EraseRootFromParent_Done,
     /*  420916 */   // Label 7425: @420916
     /*  420916 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(420989), // Rule ID 63942 //
     /*  420921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  420938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420945 */     // MIs[0] op1
     /*  420945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420948 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  420971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420973 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420975 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420977 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420987 */     GIR_RootConstrainSelectedInstOperands,
     /*  420988 */     // GIR_Coverage, 63942,
     /*  420988 */     GIR_EraseRootFromParent_Done,
     /*  420989 */   // Label 7426: @420989
     /*  420989 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(421062), // Rule ID 63965 //
     /*  420994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421018 */     // MIs[0] op1
     /*  421018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  421034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421041 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  421041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M8),
     /*  421044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421046 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421048 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421050 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421060 */     GIR_RootConstrainSelectedInstOperands,
     /*  421061 */     // GIR_Coverage, 63965,
     /*  421061 */     GIR_EraseRootFromParent_Done,
     /*  421062 */   // Label 7427: @421062
     /*  421062 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(421135), // Rule ID 63966 //
     /*  421067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421091 */     // MIs[0] op1
     /*  421091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421094 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  421107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  421114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M8),
     /*  421117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421119 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421121 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421123 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421133 */     GIR_RootConstrainSelectedInstOperands,
     /*  421134 */     // GIR_Coverage, 63966,
     /*  421134 */     GIR_EraseRootFromParent_Done,
     /*  421135 */   // Label 7428: @421135
     /*  421135 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(421218), // Rule ID 5338 //
     /*  421140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  421154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421183 */     // MIs[1] Operand 1
     /*  421183 */     // No operand predicates
     /*  421183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421196 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  421199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421206 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421216 */     GIR_RootConstrainSelectedInstOperands,
     /*  421217 */     // GIR_Coverage, 5338,
     /*  421217 */     GIR_EraseRootFromParent_Done,
     /*  421218 */   // Label 7429: @421218
     /*  421218 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(421301), // Rule ID 5339 //
     /*  421223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  421237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421266 */     // MIs[1] Operand 1
     /*  421266 */     // No operand predicates
     /*  421266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421279 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  421282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421299 */     GIR_RootConstrainSelectedInstOperands,
     /*  421300 */     // GIR_Coverage, 5339,
     /*  421300 */     GIR_EraseRootFromParent_Done,
     /*  421301 */   // Label 7430: @421301
     /*  421301 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(421384), // Rule ID 5340 //
     /*  421306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  421320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421349 */     // MIs[1] Operand 1
     /*  421349 */     // No operand predicates
     /*  421349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421362 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421372 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421382 */     GIR_RootConstrainSelectedInstOperands,
     /*  421383 */     // GIR_Coverage, 5340,
     /*  421383 */     GIR_EraseRootFromParent_Done,
     /*  421384 */   // Label 7431: @421384
     /*  421384 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(421467), // Rule ID 5341 //
     /*  421389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  421403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421432 */     // MIs[1] Operand 1
     /*  421432 */     // No operand predicates
     /*  421432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421445 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421465 */     GIR_RootConstrainSelectedInstOperands,
     /*  421466 */     // GIR_Coverage, 5341,
     /*  421466 */     GIR_EraseRootFromParent_Done,
     /*  421467 */   // Label 7432: @421467
     /*  421467 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(421550), // Rule ID 5342 //
     /*  421472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  421483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  421486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  421492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421515 */     // MIs[1] Operand 1
     /*  421515 */     // No operand predicates
     /*  421515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421528 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421538 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421548 */     GIR_RootConstrainSelectedInstOperands,
     /*  421549 */     // GIR_Coverage, 5342,
     /*  421549 */     GIR_EraseRootFromParent_Done,
     /*  421550 */   // Label 7433: @421550
     /*  421550 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(421633), // Rule ID 5343 //
     /*  421555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  421566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  421569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  421575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421598 */     // MIs[1] Operand 1
     /*  421598 */     // No operand predicates
     /*  421598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421611 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421631 */     GIR_RootConstrainSelectedInstOperands,
     /*  421632 */     // GIR_Coverage, 5343,
     /*  421632 */     GIR_EraseRootFromParent_Done,
     /*  421633 */   // Label 7434: @421633
     /*  421633 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(421716), // Rule ID 5344 //
     /*  421638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  421652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421681 */     // MIs[1] Operand 1
     /*  421681 */     // No operand predicates
     /*  421681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421694 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421714 */     GIR_RootConstrainSelectedInstOperands,
     /*  421715 */     // GIR_Coverage, 5344,
     /*  421715 */     GIR_EraseRootFromParent_Done,
     /*  421716 */   // Label 7435: @421716
     /*  421716 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(421799), // Rule ID 5345 //
     /*  421721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  421735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421764 */     // MIs[1] Operand 1
     /*  421764 */     // No operand predicates
     /*  421764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421777 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421787 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421797 */     GIR_RootConstrainSelectedInstOperands,
     /*  421798 */     // GIR_Coverage, 5345,
     /*  421798 */     GIR_EraseRootFromParent_Done,
     /*  421799 */   // Label 7436: @421799
     /*  421799 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(421882), // Rule ID 5346 //
     /*  421804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  421818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421847 */     // MIs[1] Operand 1
     /*  421847 */     // No operand predicates
     /*  421847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421870 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421880 */     GIR_RootConstrainSelectedInstOperands,
     /*  421881 */     // GIR_Coverage, 5346,
     /*  421881 */     GIR_EraseRootFromParent_Done,
     /*  421882 */   // Label 7437: @421882
     /*  421882 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(421965), // Rule ID 5347 //
     /*  421887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  421901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421930 */     // MIs[1] Operand 1
     /*  421930 */     // No operand predicates
     /*  421930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421943 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421963 */     GIR_RootConstrainSelectedInstOperands,
     /*  421964 */     // GIR_Coverage, 5347,
     /*  421964 */     GIR_EraseRootFromParent_Done,
     /*  421965 */   // Label 7438: @421965
     /*  421965 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(422048), // Rule ID 5348 //
     /*  421970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  421984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422013 */     // MIs[1] Operand 1
     /*  422013 */     // No operand predicates
     /*  422013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422026 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422036 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422046 */     GIR_RootConstrainSelectedInstOperands,
     /*  422047 */     // GIR_Coverage, 5348,
     /*  422047 */     GIR_EraseRootFromParent_Done,
     /*  422048 */   // Label 7439: @422048
     /*  422048 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(422131), // Rule ID 5349 //
     /*  422053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  422067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422096 */     // MIs[1] Operand 1
     /*  422096 */     // No operand predicates
     /*  422096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422109 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422129 */     GIR_RootConstrainSelectedInstOperands,
     /*  422130 */     // GIR_Coverage, 5349,
     /*  422130 */     GIR_EraseRootFromParent_Done,
     /*  422131 */   // Label 7440: @422131
     /*  422131 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(422214), // Rule ID 5350 //
     /*  422136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  422147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  422150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  422156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422179 */     // MIs[1] Operand 1
     /*  422179 */     // No operand predicates
     /*  422179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422192 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  422192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422202 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422212 */     GIR_RootConstrainSelectedInstOperands,
     /*  422213 */     // GIR_Coverage, 5350,
     /*  422213 */     GIR_EraseRootFromParent_Done,
     /*  422214 */   // Label 7441: @422214
     /*  422214 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(422297), // Rule ID 5351 //
     /*  422219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  422230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  422233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  422239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422262 */     // MIs[1] Operand 1
     /*  422262 */     // No operand predicates
     /*  422262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422275 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  422275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422295 */     GIR_RootConstrainSelectedInstOperands,
     /*  422296 */     // GIR_Coverage, 5351,
     /*  422296 */     GIR_EraseRootFromParent_Done,
     /*  422297 */   // Label 7442: @422297
     /*  422297 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(422380), // Rule ID 5352 //
     /*  422302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  422313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  422316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  422322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422345 */     // MIs[1] Operand 1
     /*  422345 */     // No operand predicates
     /*  422345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422358 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  422358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422368 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422378 */     GIR_RootConstrainSelectedInstOperands,
     /*  422379 */     // GIR_Coverage, 5352,
     /*  422379 */     GIR_EraseRootFromParent_Done,
     /*  422380 */   // Label 7443: @422380
     /*  422380 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(422463), // Rule ID 5353 //
     /*  422385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  422396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  422399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  422405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422424 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422428 */     // MIs[1] Operand 1
     /*  422428 */     // No operand predicates
     /*  422428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422441 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422461 */     GIR_RootConstrainSelectedInstOperands,
     /*  422462 */     // GIR_Coverage, 5353,
     /*  422462 */     GIR_EraseRootFromParent_Done,
     /*  422463 */   // Label 7444: @422463
     /*  422463 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(422546), // Rule ID 5354 //
     /*  422468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  422479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  422482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  422488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422511 */     // MIs[1] Operand 1
     /*  422511 */     // No operand predicates
     /*  422511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422524 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422534 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422544 */     GIR_RootConstrainSelectedInstOperands,
     /*  422545 */     // GIR_Coverage, 5354,
     /*  422545 */     GIR_EraseRootFromParent_Done,
     /*  422546 */   // Label 7445: @422546
     /*  422546 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(422629), // Rule ID 5355 //
     /*  422551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  422562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  422565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  422571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422594 */     // MIs[1] Operand 1
     /*  422594 */     // No operand predicates
     /*  422594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422607 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422627 */     GIR_RootConstrainSelectedInstOperands,
     /*  422628 */     // GIR_Coverage, 5355,
     /*  422628 */     GIR_EraseRootFromParent_Done,
     /*  422629 */   // Label 7446: @422629
     /*  422629 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(422712), // Rule ID 5356 //
     /*  422634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  422637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  422648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422677 */     // MIs[1] Operand 1
     /*  422677 */     // No operand predicates
     /*  422677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422690 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  422690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422700 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  422710 */     GIR_RootConstrainSelectedInstOperands,
     /*  422711 */     // GIR_Coverage, 5356,
     /*  422711 */     GIR_EraseRootFromParent_Done,
     /*  422712 */   // Label 7447: @422712
     /*  422712 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(422795), // Rule ID 5357 //
     /*  422717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  422720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  422731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422760 */     // MIs[1] Operand 1
     /*  422760 */     // No operand predicates
     /*  422760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422773 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  422773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  422793 */     GIR_RootConstrainSelectedInstOperands,
     /*  422794 */     // GIR_Coverage, 5357,
     /*  422794 */     GIR_EraseRootFromParent_Done,
     /*  422795 */   // Label 7448: @422795
     /*  422795 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(422878), // Rule ID 5358 //
     /*  422800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  422811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  422814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  422820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422843 */     // MIs[1] Operand 1
     /*  422843 */     // No operand predicates
     /*  422843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422856 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  422856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  422859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422866 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422876 */     GIR_RootConstrainSelectedInstOperands,
     /*  422877 */     // GIR_Coverage, 5358,
     /*  422877 */     GIR_EraseRootFromParent_Done,
     /*  422878 */   // Label 7449: @422878
     /*  422878 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(422961), // Rule ID 5359 //
     /*  422883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  422894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  422897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  422903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422926 */     // MIs[1] Operand 1
     /*  422926 */     // No operand predicates
     /*  422926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422939 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  422939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  422942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422959 */     GIR_RootConstrainSelectedInstOperands,
     /*  422960 */     // GIR_Coverage, 5359,
     /*  422960 */     GIR_EraseRootFromParent_Done,
     /*  422961 */   // Label 7450: @422961
     /*  422961 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(423044), // Rule ID 5360 //
     /*  422966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  422977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  422980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  422986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423009 */     // MIs[1] Operand 1
     /*  423009 */     // No operand predicates
     /*  423009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423022 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  423022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423032 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423042 */     GIR_RootConstrainSelectedInstOperands,
     /*  423043 */     // GIR_Coverage, 5360,
     /*  423043 */     GIR_EraseRootFromParent_Done,
     /*  423044 */   // Label 7451: @423044
     /*  423044 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(423127), // Rule ID 5361 //
     /*  423049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  423060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  423063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  423069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423092 */     // MIs[1] Operand 1
     /*  423092 */     // No operand predicates
     /*  423092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423105 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  423105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423115 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423125 */     GIR_RootConstrainSelectedInstOperands,
     /*  423126 */     // GIR_Coverage, 5361,
     /*  423126 */     GIR_EraseRootFromParent_Done,
     /*  423127 */   // Label 7452: @423127
     /*  423127 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(423210), // Rule ID 5362 //
     /*  423132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  423143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  423146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  423152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423175 */     // MIs[1] Operand 1
     /*  423175 */     // No operand predicates
     /*  423175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423188 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  423188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423198 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423208 */     GIR_RootConstrainSelectedInstOperands,
     /*  423209 */     // GIR_Coverage, 5362,
     /*  423209 */     GIR_EraseRootFromParent_Done,
     /*  423210 */   // Label 7453: @423210
     /*  423210 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(423293), // Rule ID 5363 //
     /*  423215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  423226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  423229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  423235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423258 */     // MIs[1] Operand 1
     /*  423258 */     // No operand predicates
     /*  423258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423271 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  423271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423291 */     GIR_RootConstrainSelectedInstOperands,
     /*  423292 */     // GIR_Coverage, 5363,
     /*  423292 */     GIR_EraseRootFromParent_Done,
     /*  423293 */   // Label 7454: @423293
     /*  423293 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(423376), // Rule ID 5364 //
     /*  423298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  423309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  423312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  423318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423341 */     // MIs[1] Operand 1
     /*  423341 */     // No operand predicates
     /*  423341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423354 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  423354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423374 */     GIR_RootConstrainSelectedInstOperands,
     /*  423375 */     // GIR_Coverage, 5364,
     /*  423375 */     GIR_EraseRootFromParent_Done,
     /*  423376 */   // Label 7455: @423376
     /*  423376 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(423459), // Rule ID 5365 //
     /*  423381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  423392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  423395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  423401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423424 */     // MIs[1] Operand 1
     /*  423424 */     // No operand predicates
     /*  423424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423437 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  423437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423457 */     GIR_RootConstrainSelectedInstOperands,
     /*  423458 */     // GIR_Coverage, 5365,
     /*  423458 */     GIR_EraseRootFromParent_Done,
     /*  423459 */   // Label 7456: @423459
     /*  423459 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(423542), // Rule ID 5366 //
     /*  423464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  423475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  423478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  423484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423507 */     // MIs[1] Operand 1
     /*  423507 */     // No operand predicates
     /*  423507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423520 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  423520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423540 */     GIR_RootConstrainSelectedInstOperands,
     /*  423541 */     // GIR_Coverage, 5366,
     /*  423541 */     GIR_EraseRootFromParent_Done,
     /*  423542 */   // Label 7457: @423542
     /*  423542 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(423625), // Rule ID 5367 //
     /*  423547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  423558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  423561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  423567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423590 */     // MIs[1] Operand 1
     /*  423590 */     // No operand predicates
     /*  423590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423603 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  423603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423623 */     GIR_RootConstrainSelectedInstOperands,
     /*  423624 */     // GIR_Coverage, 5367,
     /*  423624 */     GIR_EraseRootFromParent_Done,
     /*  423625 */   // Label 7458: @423625
     /*  423625 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(423708), // Rule ID 5368 //
     /*  423630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  423641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  423644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  423650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423673 */     // MIs[1] Operand 1
     /*  423673 */     // No operand predicates
     /*  423673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423686 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  423686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423696 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423706 */     GIR_RootConstrainSelectedInstOperands,
     /*  423707 */     // GIR_Coverage, 5368,
     /*  423707 */     GIR_EraseRootFromParent_Done,
     /*  423708 */   // Label 7459: @423708
     /*  423708 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(423791), // Rule ID 5369 //
     /*  423713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  423724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  423727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  423733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423756 */     // MIs[1] Operand 1
     /*  423756 */     // No operand predicates
     /*  423756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423769 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  423769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423789 */     GIR_RootConstrainSelectedInstOperands,
     /*  423790 */     // GIR_Coverage, 5369,
     /*  423790 */     GIR_EraseRootFromParent_Done,
     /*  423791 */   // Label 7460: @423791
     /*  423791 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(423874), // Rule ID 5370 //
     /*  423796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  423807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  423810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  423816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423839 */     // MIs[1] Operand 1
     /*  423839 */     // No operand predicates
     /*  423839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423852 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  423852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423862 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423872 */     GIR_RootConstrainSelectedInstOperands,
     /*  423873 */     // GIR_Coverage, 5370,
     /*  423873 */     GIR_EraseRootFromParent_Done,
     /*  423874 */   // Label 7461: @423874
     /*  423874 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(423957), // Rule ID 5371 //
     /*  423879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  423890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  423893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  423899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423922 */     // MIs[1] Operand 1
     /*  423922 */     // No operand predicates
     /*  423922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423935 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423955 */     GIR_RootConstrainSelectedInstOperands,
     /*  423956 */     // GIR_Coverage, 5371,
     /*  423956 */     GIR_EraseRootFromParent_Done,
     /*  423957 */   // Label 7462: @423957
     /*  423957 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(424040), // Rule ID 5372 //
     /*  423962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  423973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  423976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  423982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424005 */     // MIs[1] Operand 1
     /*  424005 */     // No operand predicates
     /*  424005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424018 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  424018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424028 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424038 */     GIR_RootConstrainSelectedInstOperands,
     /*  424039 */     // GIR_Coverage, 5372,
     /*  424039 */     GIR_EraseRootFromParent_Done,
     /*  424040 */   // Label 7463: @424040
     /*  424040 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(424123), // Rule ID 5373 //
     /*  424045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  424056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  424059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  424065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424088 */     // MIs[1] Operand 1
     /*  424088 */     // No operand predicates
     /*  424088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424101 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  424101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424121 */     GIR_RootConstrainSelectedInstOperands,
     /*  424122 */     // GIR_Coverage, 5373,
     /*  424122 */     GIR_EraseRootFromParent_Done,
     /*  424123 */   // Label 7464: @424123
     /*  424123 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(424206), // Rule ID 5374 //
     /*  424128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  424131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  424139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  424142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  424148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424171 */     // MIs[1] Operand 1
     /*  424171 */     // No operand predicates
     /*  424171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424184 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  424184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424194 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424204 */     GIR_RootConstrainSelectedInstOperands,
     /*  424205 */     // GIR_Coverage, 5374,
     /*  424205 */     GIR_EraseRootFromParent_Done,
     /*  424206 */   // Label 7465: @424206
     /*  424206 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(424289), // Rule ID 5375 //
     /*  424211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  424222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  424225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  424231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424254 */     // MIs[1] Operand 1
     /*  424254 */     // No operand predicates
     /*  424254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424267 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  424267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424287 */     GIR_RootConstrainSelectedInstOperands,
     /*  424288 */     // GIR_Coverage, 5375,
     /*  424288 */     GIR_EraseRootFromParent_Done,
     /*  424289 */   // Label 7466: @424289
     /*  424289 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(424372), // Rule ID 5376 //
     /*  424294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  424297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  424305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  424308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  424314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424337 */     // MIs[1] Operand 1
     /*  424337 */     // No operand predicates
     /*  424337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424350 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  424353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424360 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424370 */     GIR_RootConstrainSelectedInstOperands,
     /*  424371 */     // GIR_Coverage, 5376,
     /*  424371 */     GIR_EraseRootFromParent_Done,
     /*  424372 */   // Label 7467: @424372
     /*  424372 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(424455), // Rule ID 5377 //
     /*  424377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  424380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  424388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  424391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  424397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424420 */     // MIs[1] Operand 1
     /*  424420 */     // No operand predicates
     /*  424420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424433 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  424436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424453 */     GIR_RootConstrainSelectedInstOperands,
     /*  424454 */     // GIR_Coverage, 5377,
     /*  424454 */     GIR_EraseRootFromParent_Done,
     /*  424455 */   // Label 7468: @424455
     /*  424455 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(424538), // Rule ID 5378 //
     /*  424460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  424463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  424471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  424474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  424480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424503 */     // MIs[1] Operand 1
     /*  424503 */     // No operand predicates
     /*  424503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424516 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424526 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424536 */     GIR_RootConstrainSelectedInstOperands,
     /*  424537 */     // GIR_Coverage, 5378,
     /*  424537 */     GIR_EraseRootFromParent_Done,
     /*  424538 */   // Label 7469: @424538
     /*  424538 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(424621), // Rule ID 5379 //
     /*  424543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  424546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  424554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  424557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  424563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424586 */     // MIs[1] Operand 1
     /*  424586 */     // No operand predicates
     /*  424586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424599 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424619 */     GIR_RootConstrainSelectedInstOperands,
     /*  424620 */     // GIR_Coverage, 5379,
     /*  424620 */     GIR_EraseRootFromParent_Done,
     /*  424621 */   // Label 7470: @424621
     /*  424621 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(424704), // Rule ID 5380 //
     /*  424626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  424629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  424637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  424640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  424646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424669 */     // MIs[1] Operand 1
     /*  424669 */     // No operand predicates
     /*  424669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424682 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424692 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424702 */     GIR_RootConstrainSelectedInstOperands,
     /*  424703 */     // GIR_Coverage, 5380,
     /*  424703 */     GIR_EraseRootFromParent_Done,
     /*  424704 */   // Label 7471: @424704
     /*  424704 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(424787), // Rule ID 5381 //
     /*  424709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  424712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  424720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  424723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  424729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424752 */     // MIs[1] Operand 1
     /*  424752 */     // No operand predicates
     /*  424752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424765 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424785 */     GIR_RootConstrainSelectedInstOperands,
     /*  424786 */     // GIR_Coverage, 5381,
     /*  424786 */     GIR_EraseRootFromParent_Done,
     /*  424787 */   // Label 7472: @424787
     /*  424787 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(424863), // Rule ID 60614 //
     /*  424792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  424795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  424803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  424806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  424809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424824 */     // MIs[0] rs2
     /*  424824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424827 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424839 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  424839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  424842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424861 */     GIR_RootConstrainSelectedInstOperands,
     /*  424862 */     // GIR_Coverage, 60614,
     /*  424862 */     GIR_EraseRootFromParent_Done,
     /*  424863 */   // Label 7473: @424863
     /*  424863 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(424939), // Rule ID 60615 //
     /*  424868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  424871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  424879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  424882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  424885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424900 */     // MIs[0] rs2
     /*  424900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424915 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  424915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  424918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424937 */     GIR_RootConstrainSelectedInstOperands,
     /*  424938 */     // GIR_Coverage, 60615,
     /*  424938 */     GIR_EraseRootFromParent_Done,
     /*  424939 */   // Label 7474: @424939
     /*  424939 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(425015), // Rule ID 62260 //
     /*  424944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  424947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  424955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  424958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  424961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424976 */     // MIs[0] rs2
     /*  424976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424991 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  424991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  424994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425013 */     GIR_RootConstrainSelectedInstOperands,
     /*  425014 */     // GIR_Coverage, 62260,
     /*  425014 */     GIR_EraseRootFromParent_Done,
     /*  425015 */   // Label 7475: @425015
     /*  425015 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(425091), // Rule ID 62261 //
     /*  425020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  425031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  425034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  425037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425052 */     // MIs[0] rs2
     /*  425052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425067 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  425070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425089 */     GIR_RootConstrainSelectedInstOperands,
     /*  425090 */     // GIR_Coverage, 62261,
     /*  425090 */     GIR_EraseRootFromParent_Done,
     /*  425091 */   // Label 7476: @425091
     /*  425091 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(425167), // Rule ID 62262 //
     /*  425096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425128 */     // MIs[0] rs2
     /*  425128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  425146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425165 */     GIR_RootConstrainSelectedInstOperands,
     /*  425166 */     // GIR_Coverage, 62262,
     /*  425166 */     GIR_EraseRootFromParent_Done,
     /*  425167 */   // Label 7477: @425167
     /*  425167 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(425243), // Rule ID 62263 //
     /*  425172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425204 */     // MIs[0] rs2
     /*  425204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425207 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425219 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  425222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425241 */     GIR_RootConstrainSelectedInstOperands,
     /*  425242 */     // GIR_Coverage, 62263,
     /*  425242 */     GIR_EraseRootFromParent_Done,
     /*  425243 */   // Label 7478: @425243
     /*  425243 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(425319), // Rule ID 62264 //
     /*  425248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  425259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  425262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  425265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425280 */     // MIs[0] rs2
     /*  425280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425295 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  425298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425317 */     GIR_RootConstrainSelectedInstOperands,
     /*  425318 */     // GIR_Coverage, 62264,
     /*  425318 */     GIR_EraseRootFromParent_Done,
     /*  425319 */   // Label 7479: @425319
     /*  425319 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(425395), // Rule ID 62265 //
     /*  425324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  425335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  425338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  425341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425356 */     // MIs[0] rs2
     /*  425356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425359 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425371 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  425374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425393 */     GIR_RootConstrainSelectedInstOperands,
     /*  425394 */     // GIR_Coverage, 62265,
     /*  425394 */     GIR_EraseRootFromParent_Done,
     /*  425395 */   // Label 7480: @425395
     /*  425395 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(425471), // Rule ID 62266 //
     /*  425400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  425411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  425414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  425417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425432 */     // MIs[0] rs2
     /*  425432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425447 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  425450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425469 */     GIR_RootConstrainSelectedInstOperands,
     /*  425470 */     // GIR_Coverage, 62266,
     /*  425470 */     GIR_EraseRootFromParent_Done,
     /*  425471 */   // Label 7481: @425471
     /*  425471 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(425547), // Rule ID 62267 //
     /*  425476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  425487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  425490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  425493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425508 */     // MIs[0] rs2
     /*  425508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425523 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  425526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425545 */     GIR_RootConstrainSelectedInstOperands,
     /*  425546 */     // GIR_Coverage, 62267,
     /*  425546 */     GIR_EraseRootFromParent_Done,
     /*  425547 */   // Label 7482: @425547
     /*  425547 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(425623), // Rule ID 62388 //
     /*  425552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  425555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  425563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  425569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425584 */     // MIs[0] rs2
     /*  425584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425599 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  425602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425621 */     GIR_RootConstrainSelectedInstOperands,
     /*  425622 */     // GIR_Coverage, 62388,
     /*  425622 */     GIR_EraseRootFromParent_Done,
     /*  425623 */   // Label 7483: @425623
     /*  425623 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(425699), // Rule ID 62389 //
     /*  425628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  425631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  425639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  425645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425660 */     // MIs[0] rs2
     /*  425660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425675 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  425678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425697 */     GIR_RootConstrainSelectedInstOperands,
     /*  425698 */     // GIR_Coverage, 62389,
     /*  425698 */     GIR_EraseRootFromParent_Done,
     /*  425699 */   // Label 7484: @425699
     /*  425699 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(425775), // Rule ID 62390 //
     /*  425704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  425707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  425715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  425718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  425721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425736 */     // MIs[0] rs2
     /*  425736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425751 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  425754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425773 */     GIR_RootConstrainSelectedInstOperands,
     /*  425774 */     // GIR_Coverage, 62390,
     /*  425774 */     GIR_EraseRootFromParent_Done,
     /*  425775 */   // Label 7485: @425775
     /*  425775 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(425851), // Rule ID 62391 //
     /*  425780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  425783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  425791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  425794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  425797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425812 */     // MIs[0] rs2
     /*  425812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425815 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425827 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  425830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425849 */     GIR_RootConstrainSelectedInstOperands,
     /*  425850 */     // GIR_Coverage, 62391,
     /*  425850 */     GIR_EraseRootFromParent_Done,
     /*  425851 */   // Label 7486: @425851
     /*  425851 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(425927), // Rule ID 62392 //
     /*  425856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  425859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425888 */     // MIs[0] rs2
     /*  425888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425891 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425903 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  425906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425925 */     GIR_RootConstrainSelectedInstOperands,
     /*  425926 */     // GIR_Coverage, 62392,
     /*  425926 */     GIR_EraseRootFromParent_Done,
     /*  425927 */   // Label 7487: @425927
     /*  425927 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(426003), // Rule ID 62393 //
     /*  425932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  425935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425964 */     // MIs[0] rs2
     /*  425964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425979 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  425982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426001 */     GIR_RootConstrainSelectedInstOperands,
     /*  426002 */     // GIR_Coverage, 62393,
     /*  426002 */     GIR_EraseRootFromParent_Done,
     /*  426003 */   // Label 7488: @426003
     /*  426003 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(426079), // Rule ID 62394 //
     /*  426008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  426011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  426019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  426022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  426025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426040 */     // MIs[0] rs2
     /*  426040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426055 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  426058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426077 */     GIR_RootConstrainSelectedInstOperands,
     /*  426078 */     // GIR_Coverage, 62394,
     /*  426078 */     GIR_EraseRootFromParent_Done,
     /*  426079 */   // Label 7489: @426079
     /*  426079 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(426155), // Rule ID 62395 //
     /*  426084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  426095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  426098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  426101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426116 */     // MIs[0] rs2
     /*  426116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426119 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426131 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  426134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426153 */     GIR_RootConstrainSelectedInstOperands,
     /*  426154 */     // GIR_Coverage, 62395,
     /*  426154 */     GIR_EraseRootFromParent_Done,
     /*  426155 */   // Label 7490: @426155
     /*  426155 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(426231), // Rule ID 62396 //
     /*  426160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  426163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  426171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  426174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  426177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426192 */     // MIs[0] rs2
     /*  426192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426195 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426207 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  426210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426229 */     GIR_RootConstrainSelectedInstOperands,
     /*  426230 */     // GIR_Coverage, 62396,
     /*  426230 */     GIR_EraseRootFromParent_Done,
     /*  426231 */   // Label 7491: @426231
     /*  426231 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(426307), // Rule ID 62397 //
     /*  426236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  426247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  426250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  426253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426268 */     // MIs[0] rs2
     /*  426268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426283 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  426286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426305 */     GIR_RootConstrainSelectedInstOperands,
     /*  426306 */     // GIR_Coverage, 62397,
     /*  426306 */     GIR_EraseRootFromParent_Done,
     /*  426307 */   // Label 7492: @426307
     /*  426307 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(426395), // Rule ID 2800 //
     /*  426312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  426323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  426326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  426329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426359 */     // MIs[1] Operand 1
     /*  426359 */     // No operand predicates
     /*  426359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426368 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  426368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  426371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426377 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426393 */     GIR_RootConstrainSelectedInstOperands,
     /*  426394 */     // GIR_Coverage, 2800,
     /*  426394 */     GIR_EraseRootFromParent_Done,
     /*  426395 */   // Label 7493: @426395
     /*  426395 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(426483), // Rule ID 2801 //
     /*  426400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  426411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  426414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  426417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426447 */     // MIs[1] Operand 1
     /*  426447 */     // No operand predicates
     /*  426447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426456 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  426456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  426459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426465 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426481 */     GIR_RootConstrainSelectedInstOperands,
     /*  426482 */     // GIR_Coverage, 2801,
     /*  426482 */     GIR_EraseRootFromParent_Done,
     /*  426483 */   // Label 7494: @426483
     /*  426483 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(426571), // Rule ID 2808 //
     /*  426488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  426499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  426502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  426505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426535 */     // MIs[1] Operand 1
     /*  426535 */     // No operand predicates
     /*  426535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426544 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  426544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  426547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426553 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426569 */     GIR_RootConstrainSelectedInstOperands,
     /*  426570 */     // GIR_Coverage, 2808,
     /*  426570 */     GIR_EraseRootFromParent_Done,
     /*  426571 */   // Label 7495: @426571
     /*  426571 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(426659), // Rule ID 2809 //
     /*  426576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  426587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  426590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  426593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426623 */     // MIs[1] Operand 1
     /*  426623 */     // No operand predicates
     /*  426623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426632 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  426632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  426635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426641 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426657 */     GIR_RootConstrainSelectedInstOperands,
     /*  426658 */     // GIR_Coverage, 2809,
     /*  426658 */     GIR_EraseRootFromParent_Done,
     /*  426659 */   // Label 7496: @426659
     /*  426659 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(426747), // Rule ID 2816 //
     /*  426664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  426675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  426678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  426681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426711 */     // MIs[1] Operand 1
     /*  426711 */     // No operand predicates
     /*  426711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426720 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  426720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  426723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426729 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426745 */     GIR_RootConstrainSelectedInstOperands,
     /*  426746 */     // GIR_Coverage, 2816,
     /*  426746 */     GIR_EraseRootFromParent_Done,
     /*  426747 */   // Label 7497: @426747
     /*  426747 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(426835), // Rule ID 2817 //
     /*  426752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  426763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  426766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  426769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426799 */     // MIs[1] Operand 1
     /*  426799 */     // No operand predicates
     /*  426799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426808 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  426808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  426811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426817 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426833 */     GIR_RootConstrainSelectedInstOperands,
     /*  426834 */     // GIR_Coverage, 2817,
     /*  426834 */     GIR_EraseRootFromParent_Done,
     /*  426835 */   // Label 7498: @426835
     /*  426835 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(426923), // Rule ID 2824 //
     /*  426840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  426851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  426854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  426857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426887 */     // MIs[1] Operand 1
     /*  426887 */     // No operand predicates
     /*  426887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426896 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  426896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  426899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426905 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426921 */     GIR_RootConstrainSelectedInstOperands,
     /*  426922 */     // GIR_Coverage, 2824,
     /*  426922 */     GIR_EraseRootFromParent_Done,
     /*  426923 */   // Label 7499: @426923
     /*  426923 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(427011), // Rule ID 2825 //
     /*  426928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  426939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  426942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  426945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426975 */     // MIs[1] Operand 1
     /*  426975 */     // No operand predicates
     /*  426975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426984 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  426984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  426987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426993 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427009 */     GIR_RootConstrainSelectedInstOperands,
     /*  427010 */     // GIR_Coverage, 2825,
     /*  427010 */     GIR_EraseRootFromParent_Done,
     /*  427011 */   // Label 7500: @427011
     /*  427011 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(427099), // Rule ID 2832 //
     /*  427016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  427027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  427030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  427033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427063 */     // MIs[1] Operand 1
     /*  427063 */     // No operand predicates
     /*  427063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427072 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  427072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427081 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427097 */     GIR_RootConstrainSelectedInstOperands,
     /*  427098 */     // GIR_Coverage, 2832,
     /*  427098 */     GIR_EraseRootFromParent_Done,
     /*  427099 */   // Label 7501: @427099
     /*  427099 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(427187), // Rule ID 2833 //
     /*  427104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  427115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  427118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  427121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427151 */     // MIs[1] Operand 1
     /*  427151 */     // No operand predicates
     /*  427151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427160 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  427160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427169 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427185 */     GIR_RootConstrainSelectedInstOperands,
     /*  427186 */     // GIR_Coverage, 2833,
     /*  427186 */     GIR_EraseRootFromParent_Done,
     /*  427187 */   // Label 7502: @427187
     /*  427187 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(427275), // Rule ID 2840 //
     /*  427192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  427203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  427206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  427209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427239 */     // MIs[1] Operand 1
     /*  427239 */     // No operand predicates
     /*  427239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427248 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  427248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427257 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427273 */     GIR_RootConstrainSelectedInstOperands,
     /*  427274 */     // GIR_Coverage, 2840,
     /*  427274 */     GIR_EraseRootFromParent_Done,
     /*  427275 */   // Label 7503: @427275
     /*  427275 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(427363), // Rule ID 2841 //
     /*  427280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  427291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  427294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  427297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427327 */     // MIs[1] Operand 1
     /*  427327 */     // No operand predicates
     /*  427327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427336 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  427336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427345 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427361 */     GIR_RootConstrainSelectedInstOperands,
     /*  427362 */     // GIR_Coverage, 2841,
     /*  427362 */     GIR_EraseRootFromParent_Done,
     /*  427363 */   // Label 7504: @427363
     /*  427363 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(427451), // Rule ID 2848 //
     /*  427368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  427379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  427382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  427385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427415 */     // MIs[1] Operand 1
     /*  427415 */     // No operand predicates
     /*  427415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  427424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427433 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427449 */     GIR_RootConstrainSelectedInstOperands,
     /*  427450 */     // GIR_Coverage, 2848,
     /*  427450 */     GIR_EraseRootFromParent_Done,
     /*  427451 */   // Label 7505: @427451
     /*  427451 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(427539), // Rule ID 2849 //
     /*  427456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  427467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  427470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  427473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427503 */     // MIs[1] Operand 1
     /*  427503 */     // No operand predicates
     /*  427503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427512 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  427512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427521 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427537 */     GIR_RootConstrainSelectedInstOperands,
     /*  427538 */     // GIR_Coverage, 2849,
     /*  427538 */     GIR_EraseRootFromParent_Done,
     /*  427539 */   // Label 7506: @427539
     /*  427539 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(427627), // Rule ID 2856 //
     /*  427544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  427555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  427558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  427561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427591 */     // MIs[1] Operand 1
     /*  427591 */     // No operand predicates
     /*  427591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427600 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  427600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427609 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427625 */     GIR_RootConstrainSelectedInstOperands,
     /*  427626 */     // GIR_Coverage, 2856,
     /*  427626 */     GIR_EraseRootFromParent_Done,
     /*  427627 */   // Label 7507: @427627
     /*  427627 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(427715), // Rule ID 2857 //
     /*  427632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  427643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  427646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  427649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427679 */     // MIs[1] Operand 1
     /*  427679 */     // No operand predicates
     /*  427679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427688 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  427688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427697 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427713 */     GIR_RootConstrainSelectedInstOperands,
     /*  427714 */     // GIR_Coverage, 2857,
     /*  427714 */     GIR_EraseRootFromParent_Done,
     /*  427715 */   // Label 7508: @427715
     /*  427715 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(427803), // Rule ID 2864 //
     /*  427720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  427731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  427734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  427737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427767 */     // MIs[1] Operand 1
     /*  427767 */     // No operand predicates
     /*  427767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427776 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  427776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427785 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427801 */     GIR_RootConstrainSelectedInstOperands,
     /*  427802 */     // GIR_Coverage, 2864,
     /*  427802 */     GIR_EraseRootFromParent_Done,
     /*  427803 */   // Label 7509: @427803
     /*  427803 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(427891), // Rule ID 2865 //
     /*  427808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  427819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  427822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  427825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427855 */     // MIs[1] Operand 1
     /*  427855 */     // No operand predicates
     /*  427855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427864 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  427864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427873 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427889 */     GIR_RootConstrainSelectedInstOperands,
     /*  427890 */     // GIR_Coverage, 2865,
     /*  427890 */     GIR_EraseRootFromParent_Done,
     /*  427891 */   // Label 7510: @427891
     /*  427891 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(427979), // Rule ID 2872 //
     /*  427896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  427899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  427907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  427910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  427913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427943 */     // MIs[1] Operand 1
     /*  427943 */     // No operand predicates
     /*  427943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  427952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427961 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  427974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427977 */     GIR_RootConstrainSelectedInstOperands,
     /*  427978 */     // GIR_Coverage, 2872,
     /*  427978 */     GIR_EraseRootFromParent_Done,
     /*  427979 */   // Label 7511: @427979
     /*  427979 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(428067), // Rule ID 2873 //
     /*  427984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  427987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  427995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  427998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  428001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428031 */     // MIs[1] Operand 1
     /*  428031 */     // No operand predicates
     /*  428031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  428040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428049 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428065 */     GIR_RootConstrainSelectedInstOperands,
     /*  428066 */     // GIR_Coverage, 2873,
     /*  428066 */     GIR_EraseRootFromParent_Done,
     /*  428067 */   // Label 7512: @428067
     /*  428067 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(428155), // Rule ID 2880 //
     /*  428072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  428083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  428086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  428089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428119 */     // MIs[1] Operand 1
     /*  428119 */     // No operand predicates
     /*  428119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428128 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  428128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428137 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428153 */     GIR_RootConstrainSelectedInstOperands,
     /*  428154 */     // GIR_Coverage, 2880,
     /*  428154 */     GIR_EraseRootFromParent_Done,
     /*  428155 */   // Label 7513: @428155
     /*  428155 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(428243), // Rule ID 2881 //
     /*  428160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  428171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  428174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  428177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428207 */     // MIs[1] Operand 1
     /*  428207 */     // No operand predicates
     /*  428207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428216 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  428216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428225 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428241 */     GIR_RootConstrainSelectedInstOperands,
     /*  428242 */     // GIR_Coverage, 2881,
     /*  428242 */     GIR_EraseRootFromParent_Done,
     /*  428243 */   // Label 7514: @428243
     /*  428243 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(428331), // Rule ID 2888 //
     /*  428248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  428259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  428262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  428265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428295 */     // MIs[1] Operand 1
     /*  428295 */     // No operand predicates
     /*  428295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428304 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  428304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428313 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428329 */     GIR_RootConstrainSelectedInstOperands,
     /*  428330 */     // GIR_Coverage, 2888,
     /*  428330 */     GIR_EraseRootFromParent_Done,
     /*  428331 */   // Label 7515: @428331
     /*  428331 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(428419), // Rule ID 2889 //
     /*  428336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  428347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  428350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  428353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428383 */     // MIs[1] Operand 1
     /*  428383 */     // No operand predicates
     /*  428383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428392 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  428392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428401 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428417 */     GIR_RootConstrainSelectedInstOperands,
     /*  428418 */     // GIR_Coverage, 2889,
     /*  428418 */     GIR_EraseRootFromParent_Done,
     /*  428419 */   // Label 7516: @428419
     /*  428419 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(428507), // Rule ID 2896 //
     /*  428424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  428435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  428438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  428441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428471 */     // MIs[1] Operand 1
     /*  428471 */     // No operand predicates
     /*  428471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428480 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  428480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  428483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428489 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428505 */     GIR_RootConstrainSelectedInstOperands,
     /*  428506 */     // GIR_Coverage, 2896,
     /*  428506 */     GIR_EraseRootFromParent_Done,
     /*  428507 */   // Label 7517: @428507
     /*  428507 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(428595), // Rule ID 2897 //
     /*  428512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  428523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  428526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  428529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428559 */     // MIs[1] Operand 1
     /*  428559 */     // No operand predicates
     /*  428559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428568 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  428568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  428571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428577 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428593 */     GIR_RootConstrainSelectedInstOperands,
     /*  428594 */     // GIR_Coverage, 2897,
     /*  428594 */     GIR_EraseRootFromParent_Done,
     /*  428595 */   // Label 7518: @428595
     /*  428595 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(428683), // Rule ID 2904 //
     /*  428600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  428611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  428614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  428617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428647 */     // MIs[1] Operand 1
     /*  428647 */     // No operand predicates
     /*  428647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428656 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  428656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428665 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428681 */     GIR_RootConstrainSelectedInstOperands,
     /*  428682 */     // GIR_Coverage, 2904,
     /*  428682 */     GIR_EraseRootFromParent_Done,
     /*  428683 */   // Label 7519: @428683
     /*  428683 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(428771), // Rule ID 2905 //
     /*  428688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  428699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  428702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  428705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428735 */     // MIs[1] Operand 1
     /*  428735 */     // No operand predicates
     /*  428735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428744 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  428744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428753 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428769 */     GIR_RootConstrainSelectedInstOperands,
     /*  428770 */     // GIR_Coverage, 2905,
     /*  428770 */     GIR_EraseRootFromParent_Done,
     /*  428771 */   // Label 7520: @428771
     /*  428771 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(428859), // Rule ID 2912 //
     /*  428776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  428787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  428790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  428793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428823 */     // MIs[1] Operand 1
     /*  428823 */     // No operand predicates
     /*  428823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428832 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  428832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428841 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428857 */     GIR_RootConstrainSelectedInstOperands,
     /*  428858 */     // GIR_Coverage, 2912,
     /*  428858 */     GIR_EraseRootFromParent_Done,
     /*  428859 */   // Label 7521: @428859
     /*  428859 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(428947), // Rule ID 2913 //
     /*  428864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  428875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  428878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  428881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428911 */     // MIs[1] Operand 1
     /*  428911 */     // No operand predicates
     /*  428911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428920 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  428920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428929 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428945 */     GIR_RootConstrainSelectedInstOperands,
     /*  428946 */     // GIR_Coverage, 2913,
     /*  428946 */     GIR_EraseRootFromParent_Done,
     /*  428947 */   // Label 7522: @428947
     /*  428947 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(429035), // Rule ID 2920 //
     /*  428952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  428963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  428966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  428969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428999 */     // MIs[1] Operand 1
     /*  428999 */     // No operand predicates
     /*  428999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429008 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  429008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429017 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429033 */     GIR_RootConstrainSelectedInstOperands,
     /*  429034 */     // GIR_Coverage, 2920,
     /*  429034 */     GIR_EraseRootFromParent_Done,
     /*  429035 */   // Label 7523: @429035
     /*  429035 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(429123), // Rule ID 2921 //
     /*  429040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  429051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  429054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  429057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429087 */     // MIs[1] Operand 1
     /*  429087 */     // No operand predicates
     /*  429087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429096 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  429096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429105 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429121 */     GIR_RootConstrainSelectedInstOperands,
     /*  429122 */     // GIR_Coverage, 2921,
     /*  429122 */     GIR_EraseRootFromParent_Done,
     /*  429123 */   // Label 7524: @429123
     /*  429123 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(429211), // Rule ID 2928 //
     /*  429128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429175 */     // MIs[1] Operand 1
     /*  429175 */     // No operand predicates
     /*  429175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429193 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429209 */     GIR_RootConstrainSelectedInstOperands,
     /*  429210 */     // GIR_Coverage, 2928,
     /*  429210 */     GIR_EraseRootFromParent_Done,
     /*  429211 */   // Label 7525: @429211
     /*  429211 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(429299), // Rule ID 2929 //
     /*  429216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429263 */     // MIs[1] Operand 1
     /*  429263 */     // No operand predicates
     /*  429263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429272 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429281 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429297 */     GIR_RootConstrainSelectedInstOperands,
     /*  429298 */     // GIR_Coverage, 2929,
     /*  429298 */     GIR_EraseRootFromParent_Done,
     /*  429299 */   // Label 7526: @429299
     /*  429299 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(429387), // Rule ID 2936 //
     /*  429304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429351 */     // MIs[1] Operand 1
     /*  429351 */     // No operand predicates
     /*  429351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429360 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429369 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429385 */     GIR_RootConstrainSelectedInstOperands,
     /*  429386 */     // GIR_Coverage, 2936,
     /*  429386 */     GIR_EraseRootFromParent_Done,
     /*  429387 */   // Label 7527: @429387
     /*  429387 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(429475), // Rule ID 2937 //
     /*  429392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429439 */     // MIs[1] Operand 1
     /*  429439 */     // No operand predicates
     /*  429439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429448 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429457 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429473 */     GIR_RootConstrainSelectedInstOperands,
     /*  429474 */     // GIR_Coverage, 2937,
     /*  429474 */     GIR_EraseRootFromParent_Done,
     /*  429475 */   // Label 7528: @429475
     /*  429475 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(429563), // Rule ID 2944 //
     /*  429480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  429491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  429494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  429497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429527 */     // MIs[1] Operand 1
     /*  429527 */     // No operand predicates
     /*  429527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429545 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429561 */     GIR_RootConstrainSelectedInstOperands,
     /*  429562 */     // GIR_Coverage, 2944,
     /*  429562 */     GIR_EraseRootFromParent_Done,
     /*  429563 */   // Label 7529: @429563
     /*  429563 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(429651), // Rule ID 2945 //
     /*  429568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  429579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  429582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  429585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429615 */     // MIs[1] Operand 1
     /*  429615 */     // No operand predicates
     /*  429615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429624 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429633 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429649 */     GIR_RootConstrainSelectedInstOperands,
     /*  429650 */     // GIR_Coverage, 2945,
     /*  429650 */     GIR_EraseRootFromParent_Done,
     /*  429651 */   // Label 7530: @429651
     /*  429651 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(429739), // Rule ID 2952 //
     /*  429656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  429659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  429667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  429670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  429673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429703 */     // MIs[1] Operand 1
     /*  429703 */     // No operand predicates
     /*  429703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429712 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  429712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429721 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429737 */     GIR_RootConstrainSelectedInstOperands,
     /*  429738 */     // GIR_Coverage, 2952,
     /*  429738 */     GIR_EraseRootFromParent_Done,
     /*  429739 */   // Label 7531: @429739
     /*  429739 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(429827), // Rule ID 2953 //
     /*  429744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  429747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  429755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  429758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  429761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429791 */     // MIs[1] Operand 1
     /*  429791 */     // No operand predicates
     /*  429791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429800 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  429800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429809 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429825 */     GIR_RootConstrainSelectedInstOperands,
     /*  429826 */     // GIR_Coverage, 2953,
     /*  429826 */     GIR_EraseRootFromParent_Done,
     /*  429827 */   // Label 7532: @429827
     /*  429827 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(429915), // Rule ID 2960 //
     /*  429832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  429835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  429843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  429846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  429849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429879 */     // MIs[1] Operand 1
     /*  429879 */     // No operand predicates
     /*  429879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429888 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  429888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429897 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429913 */     GIR_RootConstrainSelectedInstOperands,
     /*  429914 */     // GIR_Coverage, 2960,
     /*  429914 */     GIR_EraseRootFromParent_Done,
     /*  429915 */   // Label 7533: @429915
     /*  429915 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(430003), // Rule ID 2961 //
     /*  429920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  429923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  429931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  429934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  429937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429967 */     // MIs[1] Operand 1
     /*  429967 */     // No operand predicates
     /*  429967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429976 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  429976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429985 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430001 */     GIR_RootConstrainSelectedInstOperands,
     /*  430002 */     // GIR_Coverage, 2961,
     /*  430002 */     GIR_EraseRootFromParent_Done,
     /*  430003 */   // Label 7534: @430003
     /*  430003 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(430091), // Rule ID 2968 //
     /*  430008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  430011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  430019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  430022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  430025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430055 */     // MIs[1] Operand 1
     /*  430055 */     // No operand predicates
     /*  430055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430064 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  430064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  430067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430073 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430089 */     GIR_RootConstrainSelectedInstOperands,
     /*  430090 */     // GIR_Coverage, 2968,
     /*  430090 */     GIR_EraseRootFromParent_Done,
     /*  430091 */   // Label 7535: @430091
     /*  430091 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(430179), // Rule ID 2969 //
     /*  430096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  430099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  430107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  430110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  430113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430143 */     // MIs[1] Operand 1
     /*  430143 */     // No operand predicates
     /*  430143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430152 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  430152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  430155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430161 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430177 */     GIR_RootConstrainSelectedInstOperands,
     /*  430178 */     // GIR_Coverage, 2969,
     /*  430178 */     GIR_EraseRootFromParent_Done,
     /*  430179 */   // Label 7536: @430179
     /*  430179 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(430265), // Rule ID 3152 //
     /*  430184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  430195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  430198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  430201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430231 */     // MIs[1] Operand 1
     /*  430231 */     // No operand predicates
     /*  430231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430240 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  430243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430263 */     GIR_RootConstrainSelectedInstOperands,
     /*  430264 */     // GIR_Coverage, 3152,
     /*  430264 */     GIR_EraseRootFromParent_Done,
     /*  430265 */   // Label 7537: @430265
     /*  430265 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(430351), // Rule ID 3153 //
     /*  430270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  430281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  430284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  430287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430317 */     // MIs[1] Operand 1
     /*  430317 */     // No operand predicates
     /*  430317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430326 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  430329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430349 */     GIR_RootConstrainSelectedInstOperands,
     /*  430350 */     // GIR_Coverage, 3153,
     /*  430350 */     GIR_EraseRootFromParent_Done,
     /*  430351 */   // Label 7538: @430351
     /*  430351 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(430437), // Rule ID 3156 //
     /*  430356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  430367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  430370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  430373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430403 */     // MIs[1] Operand 1
     /*  430403 */     // No operand predicates
     /*  430403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430412 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430435 */     GIR_RootConstrainSelectedInstOperands,
     /*  430436 */     // GIR_Coverage, 3156,
     /*  430436 */     GIR_EraseRootFromParent_Done,
     /*  430437 */   // Label 7539: @430437
     /*  430437 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(430523), // Rule ID 3157 //
     /*  430442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  430453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  430456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  430459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430489 */     // MIs[1] Operand 1
     /*  430489 */     // No operand predicates
     /*  430489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430498 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430521 */     GIR_RootConstrainSelectedInstOperands,
     /*  430522 */     // GIR_Coverage, 3157,
     /*  430522 */     GIR_EraseRootFromParent_Done,
     /*  430523 */   // Label 7540: @430523
     /*  430523 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(430609), // Rule ID 3160 //
     /*  430528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  430539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  430542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  430545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430575 */     // MIs[1] Operand 1
     /*  430575 */     // No operand predicates
     /*  430575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430584 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430607 */     GIR_RootConstrainSelectedInstOperands,
     /*  430608 */     // GIR_Coverage, 3160,
     /*  430608 */     GIR_EraseRootFromParent_Done,
     /*  430609 */   // Label 7541: @430609
     /*  430609 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(430695), // Rule ID 3161 //
     /*  430614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  430625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  430628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  430631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430661 */     // MIs[1] Operand 1
     /*  430661 */     // No operand predicates
     /*  430661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430670 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430693 */     GIR_RootConstrainSelectedInstOperands,
     /*  430694 */     // GIR_Coverage, 3161,
     /*  430694 */     GIR_EraseRootFromParent_Done,
     /*  430695 */   // Label 7542: @430695
     /*  430695 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(430781), // Rule ID 3164 //
     /*  430700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  430711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  430714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  430717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430747 */     // MIs[1] Operand 1
     /*  430747 */     // No operand predicates
     /*  430747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430756 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430779 */     GIR_RootConstrainSelectedInstOperands,
     /*  430780 */     // GIR_Coverage, 3164,
     /*  430780 */     GIR_EraseRootFromParent_Done,
     /*  430781 */   // Label 7543: @430781
     /*  430781 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(430867), // Rule ID 3165 //
     /*  430786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  430797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  430800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  430803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430833 */     // MIs[1] Operand 1
     /*  430833 */     // No operand predicates
     /*  430833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430842 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  430842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430865 */     GIR_RootConstrainSelectedInstOperands,
     /*  430866 */     // GIR_Coverage, 3165,
     /*  430866 */     GIR_EraseRootFromParent_Done,
     /*  430867 */   // Label 7544: @430867
     /*  430867 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(430953), // Rule ID 3168 //
     /*  430872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  430883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  430886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  430889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430919 */     // MIs[1] Operand 1
     /*  430919 */     // No operand predicates
     /*  430919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430928 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430951 */     GIR_RootConstrainSelectedInstOperands,
     /*  430952 */     // GIR_Coverage, 3168,
     /*  430952 */     GIR_EraseRootFromParent_Done,
     /*  430953 */   // Label 7545: @430953
     /*  430953 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(431039), // Rule ID 3169 //
     /*  430958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  430969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  430972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  430975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431005 */     // MIs[1] Operand 1
     /*  431005 */     // No operand predicates
     /*  431005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431014 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431037 */     GIR_RootConstrainSelectedInstOperands,
     /*  431038 */     // GIR_Coverage, 3169,
     /*  431038 */     GIR_EraseRootFromParent_Done,
     /*  431039 */   // Label 7546: @431039
     /*  431039 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(431125), // Rule ID 3172 //
     /*  431044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  431055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  431058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  431061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431091 */     // MIs[1] Operand 1
     /*  431091 */     // No operand predicates
     /*  431091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431100 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431123 */     GIR_RootConstrainSelectedInstOperands,
     /*  431124 */     // GIR_Coverage, 3172,
     /*  431124 */     GIR_EraseRootFromParent_Done,
     /*  431125 */   // Label 7547: @431125
     /*  431125 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(431211), // Rule ID 3173 //
     /*  431130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  431141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  431144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  431147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431177 */     // MIs[1] Operand 1
     /*  431177 */     // No operand predicates
     /*  431177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431209 */     GIR_RootConstrainSelectedInstOperands,
     /*  431210 */     // GIR_Coverage, 3173,
     /*  431210 */     GIR_EraseRootFromParent_Done,
     /*  431211 */   // Label 7548: @431211
     /*  431211 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(431297), // Rule ID 3176 //
     /*  431216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  431227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  431230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  431233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431263 */     // MIs[1] Operand 1
     /*  431263 */     // No operand predicates
     /*  431263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431272 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431295 */     GIR_RootConstrainSelectedInstOperands,
     /*  431296 */     // GIR_Coverage, 3176,
     /*  431296 */     GIR_EraseRootFromParent_Done,
     /*  431297 */   // Label 7549: @431297
     /*  431297 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(431383), // Rule ID 3177 //
     /*  431302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  431313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  431316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  431319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431349 */     // MIs[1] Operand 1
     /*  431349 */     // No operand predicates
     /*  431349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  431358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431381 */     GIR_RootConstrainSelectedInstOperands,
     /*  431382 */     // GIR_Coverage, 3177,
     /*  431382 */     GIR_EraseRootFromParent_Done,
     /*  431383 */   // Label 7550: @431383
     /*  431383 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(431469), // Rule ID 3180 //
     /*  431388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  431399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  431402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  431405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431435 */     // MIs[1] Operand 1
     /*  431435 */     // No operand predicates
     /*  431435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431444 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431467 */     GIR_RootConstrainSelectedInstOperands,
     /*  431468 */     // GIR_Coverage, 3180,
     /*  431468 */     GIR_EraseRootFromParent_Done,
     /*  431469 */   // Label 7551: @431469
     /*  431469 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(431555), // Rule ID 3181 //
     /*  431474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  431485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  431488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  431491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431521 */     // MIs[1] Operand 1
     /*  431521 */     // No operand predicates
     /*  431521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431530 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431553 */     GIR_RootConstrainSelectedInstOperands,
     /*  431554 */     // GIR_Coverage, 3181,
     /*  431554 */     GIR_EraseRootFromParent_Done,
     /*  431555 */   // Label 7552: @431555
     /*  431555 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(431641), // Rule ID 3184 //
     /*  431560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  431571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  431574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  431577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431607 */     // MIs[1] Operand 1
     /*  431607 */     // No operand predicates
     /*  431607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431616 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431639 */     GIR_RootConstrainSelectedInstOperands,
     /*  431640 */     // GIR_Coverage, 3184,
     /*  431640 */     GIR_EraseRootFromParent_Done,
     /*  431641 */   // Label 7553: @431641
     /*  431641 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(431727), // Rule ID 3185 //
     /*  431646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  431657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  431660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  431663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431693 */     // MIs[1] Operand 1
     /*  431693 */     // No operand predicates
     /*  431693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431725 */     GIR_RootConstrainSelectedInstOperands,
     /*  431726 */     // GIR_Coverage, 3185,
     /*  431726 */     GIR_EraseRootFromParent_Done,
     /*  431727 */   // Label 7554: @431727
     /*  431727 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(431813), // Rule ID 3188 //
     /*  431732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  431735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  431743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  431746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  431749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431779 */     // MIs[1] Operand 1
     /*  431779 */     // No operand predicates
     /*  431779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431788 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  431788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  431808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431811 */     GIR_RootConstrainSelectedInstOperands,
     /*  431812 */     // GIR_Coverage, 3188,
     /*  431812 */     GIR_EraseRootFromParent_Done,
     /*  431813 */   // Label 7555: @431813
     /*  431813 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(431899), // Rule ID 3189 //
     /*  431818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  431821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  431829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  431832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  431835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431865 */     // MIs[1] Operand 1
     /*  431865 */     // No operand predicates
     /*  431865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431874 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  431874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  431894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431897 */     GIR_RootConstrainSelectedInstOperands,
     /*  431898 */     // GIR_Coverage, 3189,
     /*  431898 */     GIR_EraseRootFromParent_Done,
     /*  431899 */   // Label 7556: @431899
     /*  431899 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(431985), // Rule ID 3192 //
     /*  431904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  431915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  431918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  431921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431951 */     // MIs[1] Operand 1
     /*  431951 */     // No operand predicates
     /*  431951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  431963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431983 */     GIR_RootConstrainSelectedInstOperands,
     /*  431984 */     // GIR_Coverage, 3192,
     /*  431984 */     GIR_EraseRootFromParent_Done,
     /*  431985 */   // Label 7557: @431985
     /*  431985 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(432071), // Rule ID 3193 //
     /*  431990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  432001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  432004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  432007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432037 */     // MIs[1] Operand 1
     /*  432037 */     // No operand predicates
     /*  432037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432046 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432069 */     GIR_RootConstrainSelectedInstOperands,
     /*  432070 */     // GIR_Coverage, 3193,
     /*  432070 */     GIR_EraseRootFromParent_Done,
     /*  432071 */   // Label 7558: @432071
     /*  432071 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(432157), // Rule ID 3196 //
     /*  432076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  432087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  432090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  432093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432123 */     // MIs[1] Operand 1
     /*  432123 */     // No operand predicates
     /*  432123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432132 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432155 */     GIR_RootConstrainSelectedInstOperands,
     /*  432156 */     // GIR_Coverage, 3196,
     /*  432156 */     GIR_EraseRootFromParent_Done,
     /*  432157 */   // Label 7559: @432157
     /*  432157 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(432243), // Rule ID 3197 //
     /*  432162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  432173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  432176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  432179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432209 */     // MIs[1] Operand 1
     /*  432209 */     // No operand predicates
     /*  432209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432218 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432241 */     GIR_RootConstrainSelectedInstOperands,
     /*  432242 */     // GIR_Coverage, 3197,
     /*  432242 */     GIR_EraseRootFromParent_Done,
     /*  432243 */   // Label 7560: @432243
     /*  432243 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(432329), // Rule ID 3200 //
     /*  432248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  432259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  432262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  432265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432295 */     // MIs[1] Operand 1
     /*  432295 */     // No operand predicates
     /*  432295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432304 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432327 */     GIR_RootConstrainSelectedInstOperands,
     /*  432328 */     // GIR_Coverage, 3200,
     /*  432328 */     GIR_EraseRootFromParent_Done,
     /*  432329 */   // Label 7561: @432329
     /*  432329 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(432415), // Rule ID 3201 //
     /*  432334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  432345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  432348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  432351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432381 */     // MIs[1] Operand 1
     /*  432381 */     // No operand predicates
     /*  432381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432390 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432413 */     GIR_RootConstrainSelectedInstOperands,
     /*  432414 */     // GIR_Coverage, 3201,
     /*  432414 */     GIR_EraseRootFromParent_Done,
     /*  432415 */   // Label 7562: @432415
     /*  432415 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(432501), // Rule ID 3204 //
     /*  432420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  432431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  432434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432467 */     // MIs[1] Operand 1
     /*  432467 */     // No operand predicates
     /*  432467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432499 */     GIR_RootConstrainSelectedInstOperands,
     /*  432500 */     // GIR_Coverage, 3204,
     /*  432500 */     GIR_EraseRootFromParent_Done,
     /*  432501 */   // Label 7563: @432501
     /*  432501 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(432587), // Rule ID 3205 //
     /*  432506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  432517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  432520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432553 */     // MIs[1] Operand 1
     /*  432553 */     // No operand predicates
     /*  432553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432562 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432585 */     GIR_RootConstrainSelectedInstOperands,
     /*  432586 */     // GIR_Coverage, 3205,
     /*  432586 */     GIR_EraseRootFromParent_Done,
     /*  432587 */   // Label 7564: @432587
     /*  432587 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(432673), // Rule ID 3208 //
     /*  432592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  432603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  432606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  432609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432639 */     // MIs[1] Operand 1
     /*  432639 */     // No operand predicates
     /*  432639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432648 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432671 */     GIR_RootConstrainSelectedInstOperands,
     /*  432672 */     // GIR_Coverage, 3208,
     /*  432672 */     GIR_EraseRootFromParent_Done,
     /*  432673 */   // Label 7565: @432673
     /*  432673 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(432759), // Rule ID 3209 //
     /*  432678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  432689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  432692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  432695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432725 */     // MIs[1] Operand 1
     /*  432725 */     // No operand predicates
     /*  432725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432734 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432757 */     GIR_RootConstrainSelectedInstOperands,
     /*  432758 */     // GIR_Coverage, 3209,
     /*  432758 */     GIR_EraseRootFromParent_Done,
     /*  432759 */   // Label 7566: @432759
     /*  432759 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(432845), // Rule ID 3212 //
     /*  432764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  432775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  432778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  432781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432811 */     // MIs[1] Operand 1
     /*  432811 */     // No operand predicates
     /*  432811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432820 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432843 */     GIR_RootConstrainSelectedInstOperands,
     /*  432844 */     // GIR_Coverage, 3212,
     /*  432844 */     GIR_EraseRootFromParent_Done,
     /*  432845 */   // Label 7567: @432845
     /*  432845 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(432931), // Rule ID 3213 //
     /*  432850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  432861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  432864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  432867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432897 */     // MIs[1] Operand 1
     /*  432897 */     // No operand predicates
     /*  432897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432906 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432929 */     GIR_RootConstrainSelectedInstOperands,
     /*  432930 */     // GIR_Coverage, 3213,
     /*  432930 */     GIR_EraseRootFromParent_Done,
     /*  432931 */   // Label 7568: @432931
     /*  432931 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(433017), // Rule ID 3216 //
     /*  432936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  432947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  432950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  432953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432983 */     // MIs[1] Operand 1
     /*  432983 */     // No operand predicates
     /*  432983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  432992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433015 */     GIR_RootConstrainSelectedInstOperands,
     /*  433016 */     // GIR_Coverage, 3216,
     /*  433016 */     GIR_EraseRootFromParent_Done,
     /*  433017 */   // Label 7569: @433017
     /*  433017 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(433103), // Rule ID 3217 //
     /*  433022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  433033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  433036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  433039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433069 */     // MIs[1] Operand 1
     /*  433069 */     // No operand predicates
     /*  433069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433078 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433101 */     GIR_RootConstrainSelectedInstOperands,
     /*  433102 */     // GIR_Coverage, 3217,
     /*  433102 */     GIR_EraseRootFromParent_Done,
     /*  433103 */   // Label 7570: @433103
     /*  433103 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(433189), // Rule ID 3220 //
     /*  433108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  433119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  433122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433155 */     // MIs[1] Operand 1
     /*  433155 */     // No operand predicates
     /*  433155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433164 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433187 */     GIR_RootConstrainSelectedInstOperands,
     /*  433188 */     // GIR_Coverage, 3220,
     /*  433188 */     GIR_EraseRootFromParent_Done,
     /*  433189 */   // Label 7571: @433189
     /*  433189 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(433275), // Rule ID 3221 //
     /*  433194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  433205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  433208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433241 */     // MIs[1] Operand 1
     /*  433241 */     // No operand predicates
     /*  433241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433250 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433273 */     GIR_RootConstrainSelectedInstOperands,
     /*  433274 */     // GIR_Coverage, 3221,
     /*  433274 */     GIR_EraseRootFromParent_Done,
     /*  433275 */   // Label 7572: @433275
     /*  433275 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(433361), // Rule ID 3224 //
     /*  433280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  433297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433327 */     // MIs[1] Operand 1
     /*  433327 */     // No operand predicates
     /*  433327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433336 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433359 */     GIR_RootConstrainSelectedInstOperands,
     /*  433360 */     // GIR_Coverage, 3224,
     /*  433360 */     GIR_EraseRootFromParent_Done,
     /*  433361 */   // Label 7573: @433361
     /*  433361 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(433447), // Rule ID 3225 //
     /*  433366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  433383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433413 */     // MIs[1] Operand 1
     /*  433413 */     // No operand predicates
     /*  433413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433422 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433445 */     GIR_RootConstrainSelectedInstOperands,
     /*  433446 */     // GIR_Coverage, 3225,
     /*  433446 */     GIR_EraseRootFromParent_Done,
     /*  433447 */   // Label 7574: @433447
     /*  433447 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(433533), // Rule ID 3228 //
     /*  433452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  433463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  433466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  433469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433499 */     // MIs[1] Operand 1
     /*  433499 */     // No operand predicates
     /*  433499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433531 */     GIR_RootConstrainSelectedInstOperands,
     /*  433532 */     // GIR_Coverage, 3228,
     /*  433532 */     GIR_EraseRootFromParent_Done,
     /*  433533 */   // Label 7575: @433533
     /*  433533 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(433619), // Rule ID 3229 //
     /*  433538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  433549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  433552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  433555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433585 */     // MIs[1] Operand 1
     /*  433585 */     // No operand predicates
     /*  433585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433617 */     GIR_RootConstrainSelectedInstOperands,
     /*  433618 */     // GIR_Coverage, 3229,
     /*  433618 */     GIR_EraseRootFromParent_Done,
     /*  433619 */   // Label 7576: @433619
     /*  433619 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(433705), // Rule ID 3232 //
     /*  433624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  433635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  433638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  433641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433671 */     // MIs[1] Operand 1
     /*  433671 */     // No operand predicates
     /*  433671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433680 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433703 */     GIR_RootConstrainSelectedInstOperands,
     /*  433704 */     // GIR_Coverage, 3232,
     /*  433704 */     GIR_EraseRootFromParent_Done,
     /*  433705 */   // Label 7577: @433705
     /*  433705 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(433791), // Rule ID 3233 //
     /*  433710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  433721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  433724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  433727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433757 */     // MIs[1] Operand 1
     /*  433757 */     // No operand predicates
     /*  433757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433766 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433789 */     GIR_RootConstrainSelectedInstOperands,
     /*  433790 */     // GIR_Coverage, 3233,
     /*  433790 */     GIR_EraseRootFromParent_Done,
     /*  433791 */   // Label 7578: @433791
     /*  433791 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(433877), // Rule ID 3236 //
     /*  433796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  433807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  433810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  433813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433843 */     // MIs[1] Operand 1
     /*  433843 */     // No operand predicates
     /*  433843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433852 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433875 */     GIR_RootConstrainSelectedInstOperands,
     /*  433876 */     // GIR_Coverage, 3236,
     /*  433876 */     GIR_EraseRootFromParent_Done,
     /*  433877 */   // Label 7579: @433877
     /*  433877 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(433963), // Rule ID 3237 //
     /*  433882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  433893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  433896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  433899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433929 */     // MIs[1] Operand 1
     /*  433929 */     // No operand predicates
     /*  433929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433938 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433961 */     GIR_RootConstrainSelectedInstOperands,
     /*  433962 */     // GIR_Coverage, 3237,
     /*  433962 */     GIR_EraseRootFromParent_Done,
     /*  433963 */   // Label 7580: @433963
     /*  433963 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(434049), // Rule ID 3504 //
     /*  433968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  433976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  433979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  433982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  433985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434015 */     // MIs[1] Operand 1
     /*  434015 */     // No operand predicates
     /*  434015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434024 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  434027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434047 */     GIR_RootConstrainSelectedInstOperands,
     /*  434048 */     // GIR_Coverage, 3504,
     /*  434048 */     GIR_EraseRootFromParent_Done,
     /*  434049 */   // Label 7581: @434049
     /*  434049 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(434135), // Rule ID 3505 //
     /*  434054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  434065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  434068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  434071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434101 */     // MIs[1] Operand 1
     /*  434101 */     // No operand predicates
     /*  434101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434110 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  434113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434133 */     GIR_RootConstrainSelectedInstOperands,
     /*  434134 */     // GIR_Coverage, 3505,
     /*  434134 */     GIR_EraseRootFromParent_Done,
     /*  434135 */   // Label 7582: @434135
     /*  434135 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(434221), // Rule ID 3508 //
     /*  434140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  434151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  434154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  434157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434187 */     // MIs[1] Operand 1
     /*  434187 */     // No operand predicates
     /*  434187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434196 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434219 */     GIR_RootConstrainSelectedInstOperands,
     /*  434220 */     // GIR_Coverage, 3508,
     /*  434220 */     GIR_EraseRootFromParent_Done,
     /*  434221 */   // Label 7583: @434221
     /*  434221 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(434307), // Rule ID 3509 //
     /*  434226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  434237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  434240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  434243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434273 */     // MIs[1] Operand 1
     /*  434273 */     // No operand predicates
     /*  434273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434282 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434305 */     GIR_RootConstrainSelectedInstOperands,
     /*  434306 */     // GIR_Coverage, 3509,
     /*  434306 */     GIR_EraseRootFromParent_Done,
     /*  434307 */   // Label 7584: @434307
     /*  434307 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(434393), // Rule ID 3512 //
     /*  434312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  434323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  434326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  434329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434359 */     // MIs[1] Operand 1
     /*  434359 */     // No operand predicates
     /*  434359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434368 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434391 */     GIR_RootConstrainSelectedInstOperands,
     /*  434392 */     // GIR_Coverage, 3512,
     /*  434392 */     GIR_EraseRootFromParent_Done,
     /*  434393 */   // Label 7585: @434393
     /*  434393 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(434479), // Rule ID 3513 //
     /*  434398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  434409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  434412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  434415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434445 */     // MIs[1] Operand 1
     /*  434445 */     // No operand predicates
     /*  434445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434454 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434477 */     GIR_RootConstrainSelectedInstOperands,
     /*  434478 */     // GIR_Coverage, 3513,
     /*  434478 */     GIR_EraseRootFromParent_Done,
     /*  434479 */   // Label 7586: @434479
     /*  434479 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(434565), // Rule ID 3516 //
     /*  434484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  434495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  434498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  434501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434531 */     // MIs[1] Operand 1
     /*  434531 */     // No operand predicates
     /*  434531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434540 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434563 */     GIR_RootConstrainSelectedInstOperands,
     /*  434564 */     // GIR_Coverage, 3516,
     /*  434564 */     GIR_EraseRootFromParent_Done,
     /*  434565 */   // Label 7587: @434565
     /*  434565 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(434651), // Rule ID 3517 //
     /*  434570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  434581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  434584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  434587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434617 */     // MIs[1] Operand 1
     /*  434617 */     // No operand predicates
     /*  434617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434626 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434649 */     GIR_RootConstrainSelectedInstOperands,
     /*  434650 */     // GIR_Coverage, 3517,
     /*  434650 */     GIR_EraseRootFromParent_Done,
     /*  434651 */   // Label 7588: @434651
     /*  434651 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(434737), // Rule ID 3520 //
     /*  434656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  434667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  434670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  434673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434703 */     // MIs[1] Operand 1
     /*  434703 */     // No operand predicates
     /*  434703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434712 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434735 */     GIR_RootConstrainSelectedInstOperands,
     /*  434736 */     // GIR_Coverage, 3520,
     /*  434736 */     GIR_EraseRootFromParent_Done,
     /*  434737 */   // Label 7589: @434737
     /*  434737 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(434823), // Rule ID 3521 //
     /*  434742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  434753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  434756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  434759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434789 */     // MIs[1] Operand 1
     /*  434789 */     // No operand predicates
     /*  434789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434798 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434821 */     GIR_RootConstrainSelectedInstOperands,
     /*  434822 */     // GIR_Coverage, 3521,
     /*  434822 */     GIR_EraseRootFromParent_Done,
     /*  434823 */   // Label 7590: @434823
     /*  434823 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(434909), // Rule ID 3524 //
     /*  434828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  434839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  434842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  434845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434875 */     // MIs[1] Operand 1
     /*  434875 */     // No operand predicates
     /*  434875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434884 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  434884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434907 */     GIR_RootConstrainSelectedInstOperands,
     /*  434908 */     // GIR_Coverage, 3524,
     /*  434908 */     GIR_EraseRootFromParent_Done,
     /*  434909 */   // Label 7591: @434909
     /*  434909 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(434995), // Rule ID 3525 //
     /*  434914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  434925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  434928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  434931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434961 */     // MIs[1] Operand 1
     /*  434961 */     // No operand predicates
     /*  434961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434970 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  434970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434993 */     GIR_RootConstrainSelectedInstOperands,
     /*  434994 */     // GIR_Coverage, 3525,
     /*  434994 */     GIR_EraseRootFromParent_Done,
     /*  434995 */   // Label 7592: @434995
     /*  434995 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(435081), // Rule ID 3528 //
     /*  435000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  435011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  435017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435047 */     // MIs[1] Operand 1
     /*  435047 */     // No operand predicates
     /*  435047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435056 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435079 */     GIR_RootConstrainSelectedInstOperands,
     /*  435080 */     // GIR_Coverage, 3528,
     /*  435080 */     GIR_EraseRootFromParent_Done,
     /*  435081 */   // Label 7593: @435081
     /*  435081 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(435167), // Rule ID 3529 //
     /*  435086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  435097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  435103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435133 */     // MIs[1] Operand 1
     /*  435133 */     // No operand predicates
     /*  435133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435142 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435165 */     GIR_RootConstrainSelectedInstOperands,
     /*  435166 */     // GIR_Coverage, 3529,
     /*  435166 */     GIR_EraseRootFromParent_Done,
     /*  435167 */   // Label 7594: @435167
     /*  435167 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(435253), // Rule ID 3532 //
     /*  435172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  435183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  435186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435219 */     // MIs[1] Operand 1
     /*  435219 */     // No operand predicates
     /*  435219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435228 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  435228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435251 */     GIR_RootConstrainSelectedInstOperands,
     /*  435252 */     // GIR_Coverage, 3532,
     /*  435252 */     GIR_EraseRootFromParent_Done,
     /*  435253 */   // Label 7595: @435253
     /*  435253 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(435339), // Rule ID 3533 //
     /*  435258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  435269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  435272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435305 */     // MIs[1] Operand 1
     /*  435305 */     // No operand predicates
     /*  435305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435314 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  435314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435337 */     GIR_RootConstrainSelectedInstOperands,
     /*  435338 */     // GIR_Coverage, 3533,
     /*  435338 */     GIR_EraseRootFromParent_Done,
     /*  435339 */   // Label 7596: @435339
     /*  435339 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(435425), // Rule ID 3536 //
     /*  435344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  435355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  435358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  435361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435391 */     // MIs[1] Operand 1
     /*  435391 */     // No operand predicates
     /*  435391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  435400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435423 */     GIR_RootConstrainSelectedInstOperands,
     /*  435424 */     // GIR_Coverage, 3536,
     /*  435424 */     GIR_EraseRootFromParent_Done,
     /*  435425 */   // Label 7597: @435425
     /*  435425 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(435511), // Rule ID 3537 //
     /*  435430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  435441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  435444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  435447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435477 */     // MIs[1] Operand 1
     /*  435477 */     // No operand predicates
     /*  435477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435486 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  435486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435509 */     GIR_RootConstrainSelectedInstOperands,
     /*  435510 */     // GIR_Coverage, 3537,
     /*  435510 */     GIR_EraseRootFromParent_Done,
     /*  435511 */   // Label 7598: @435511
     /*  435511 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(435597), // Rule ID 3540 //
     /*  435516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  435519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  435527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  435530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  435533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435563 */     // MIs[1] Operand 1
     /*  435563 */     // No operand predicates
     /*  435563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435572 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  435572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  435592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435595 */     GIR_RootConstrainSelectedInstOperands,
     /*  435596 */     // GIR_Coverage, 3540,
     /*  435596 */     GIR_EraseRootFromParent_Done,
     /*  435597 */   // Label 7599: @435597
     /*  435597 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(435683), // Rule ID 3541 //
     /*  435602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  435605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  435613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  435616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  435619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435649 */     // MIs[1] Operand 1
     /*  435649 */     // No operand predicates
     /*  435649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435658 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  435658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  435678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435681 */     GIR_RootConstrainSelectedInstOperands,
     /*  435682 */     // GIR_Coverage, 3541,
     /*  435682 */     GIR_EraseRootFromParent_Done,
     /*  435683 */   // Label 7600: @435683
     /*  435683 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(435769), // Rule ID 3544 //
     /*  435688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  435699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  435702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  435705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435735 */     // MIs[1] Operand 1
     /*  435735 */     // No operand predicates
     /*  435735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435744 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  435747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435767 */     GIR_RootConstrainSelectedInstOperands,
     /*  435768 */     // GIR_Coverage, 3544,
     /*  435768 */     GIR_EraseRootFromParent_Done,
     /*  435769 */   // Label 7601: @435769
     /*  435769 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(435855), // Rule ID 3545 //
     /*  435774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  435785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  435788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  435791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435821 */     // MIs[1] Operand 1
     /*  435821 */     // No operand predicates
     /*  435821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435830 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  435833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435853 */     GIR_RootConstrainSelectedInstOperands,
     /*  435854 */     // GIR_Coverage, 3545,
     /*  435854 */     GIR_EraseRootFromParent_Done,
     /*  435855 */   // Label 7602: @435855
     /*  435855 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(435941), // Rule ID 3548 //
     /*  435860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  435871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  435874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  435877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435907 */     // MIs[1] Operand 1
     /*  435907 */     // No operand predicates
     /*  435907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435916 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  435919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435939 */     GIR_RootConstrainSelectedInstOperands,
     /*  435940 */     // GIR_Coverage, 3548,
     /*  435940 */     GIR_EraseRootFromParent_Done,
     /*  435941 */   // Label 7603: @435941
     /*  435941 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(436027), // Rule ID 3549 //
     /*  435946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  435957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  435960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  435963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435993 */     // MIs[1] Operand 1
     /*  435993 */     // No operand predicates
     /*  435993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436002 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  436002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436025 */     GIR_RootConstrainSelectedInstOperands,
     /*  436026 */     // GIR_Coverage, 3549,
     /*  436026 */     GIR_EraseRootFromParent_Done,
     /*  436027 */   // Label 7604: @436027
     /*  436027 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(436113), // Rule ID 3552 //
     /*  436032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  436043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  436046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  436049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436079 */     // MIs[1] Operand 1
     /*  436079 */     // No operand predicates
     /*  436079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436088 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  436088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436111 */     GIR_RootConstrainSelectedInstOperands,
     /*  436112 */     // GIR_Coverage, 3552,
     /*  436112 */     GIR_EraseRootFromParent_Done,
     /*  436113 */   // Label 7605: @436113
     /*  436113 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(436199), // Rule ID 3553 //
     /*  436118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  436129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  436132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  436135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436165 */     // MIs[1] Operand 1
     /*  436165 */     // No operand predicates
     /*  436165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436174 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  436174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436197 */     GIR_RootConstrainSelectedInstOperands,
     /*  436198 */     // GIR_Coverage, 3553,
     /*  436198 */     GIR_EraseRootFromParent_Done,
     /*  436199 */   // Label 7606: @436199
     /*  436199 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(436285), // Rule ID 3556 //
     /*  436204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  436221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436251 */     // MIs[1] Operand 1
     /*  436251 */     // No operand predicates
     /*  436251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436260 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436283 */     GIR_RootConstrainSelectedInstOperands,
     /*  436284 */     // GIR_Coverage, 3556,
     /*  436284 */     GIR_EraseRootFromParent_Done,
     /*  436285 */   // Label 7607: @436285
     /*  436285 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(436371), // Rule ID 3557 //
     /*  436290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  436307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436337 */     // MIs[1] Operand 1
     /*  436337 */     // No operand predicates
     /*  436337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436369 */     GIR_RootConstrainSelectedInstOperands,
     /*  436370 */     // GIR_Coverage, 3557,
     /*  436370 */     GIR_EraseRootFromParent_Done,
     /*  436371 */   // Label 7608: @436371
     /*  436371 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(436457), // Rule ID 3560 //
     /*  436376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  436393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436423 */     // MIs[1] Operand 1
     /*  436423 */     // No operand predicates
     /*  436423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436432 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436455 */     GIR_RootConstrainSelectedInstOperands,
     /*  436456 */     // GIR_Coverage, 3560,
     /*  436456 */     GIR_EraseRootFromParent_Done,
     /*  436457 */   // Label 7609: @436457
     /*  436457 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(436543), // Rule ID 3561 //
     /*  436462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  436479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436509 */     // MIs[1] Operand 1
     /*  436509 */     // No operand predicates
     /*  436509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436518 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436541 */     GIR_RootConstrainSelectedInstOperands,
     /*  436542 */     // GIR_Coverage, 3561,
     /*  436542 */     GIR_EraseRootFromParent_Done,
     /*  436543 */   // Label 7610: @436543
     /*  436543 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(436629), // Rule ID 3564 //
     /*  436548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  436559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  436562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  436565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436595 */     // MIs[1] Operand 1
     /*  436595 */     // No operand predicates
     /*  436595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436604 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436627 */     GIR_RootConstrainSelectedInstOperands,
     /*  436628 */     // GIR_Coverage, 3564,
     /*  436628 */     GIR_EraseRootFromParent_Done,
     /*  436629 */   // Label 7611: @436629
     /*  436629 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(436715), // Rule ID 3565 //
     /*  436634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  436645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  436648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  436651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436681 */     // MIs[1] Operand 1
     /*  436681 */     // No operand predicates
     /*  436681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436690 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436713 */     GIR_RootConstrainSelectedInstOperands,
     /*  436714 */     // GIR_Coverage, 3565,
     /*  436714 */     GIR_EraseRootFromParent_Done,
     /*  436715 */   // Label 7612: @436715
     /*  436715 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(436801), // Rule ID 3568 //
     /*  436720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  436731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  436734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  436737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436767 */     // MIs[1] Operand 1
     /*  436767 */     // No operand predicates
     /*  436767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436799 */     GIR_RootConstrainSelectedInstOperands,
     /*  436800 */     // GIR_Coverage, 3568,
     /*  436800 */     GIR_EraseRootFromParent_Done,
     /*  436801 */   // Label 7613: @436801
     /*  436801 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(436887), // Rule ID 3569 //
     /*  436806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  436817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  436820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  436823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436853 */     // MIs[1] Operand 1
     /*  436853 */     // No operand predicates
     /*  436853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  436862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436885 */     GIR_RootConstrainSelectedInstOperands,
     /*  436886 */     // GIR_Coverage, 3569,
     /*  436886 */     GIR_EraseRootFromParent_Done,
     /*  436887 */   // Label 7614: @436887
     /*  436887 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(436973), // Rule ID 3572 //
     /*  436892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  436903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  436906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  436909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436939 */     // MIs[1] Operand 1
     /*  436939 */     // No operand predicates
     /*  436939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436948 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436971 */     GIR_RootConstrainSelectedInstOperands,
     /*  436972 */     // GIR_Coverage, 3572,
     /*  436972 */     GIR_EraseRootFromParent_Done,
     /*  436973 */   // Label 7615: @436973
     /*  436973 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(437059), // Rule ID 3573 //
     /*  436978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  436989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  436992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  436995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437025 */     // MIs[1] Operand 1
     /*  437025 */     // No operand predicates
     /*  437025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437034 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  437037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437057 */     GIR_RootConstrainSelectedInstOperands,
     /*  437058 */     // GIR_Coverage, 3573,
     /*  437058 */     GIR_EraseRootFromParent_Done,
     /*  437059 */   // Label 7616: @437059
     /*  437059 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(437145), // Rule ID 3576 //
     /*  437064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  437075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  437078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  437081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437111 */     // MIs[1] Operand 1
     /*  437111 */     // No operand predicates
     /*  437111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437120 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  437120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437143 */     GIR_RootConstrainSelectedInstOperands,
     /*  437144 */     // GIR_Coverage, 3576,
     /*  437144 */     GIR_EraseRootFromParent_Done,
     /*  437145 */   // Label 7617: @437145
     /*  437145 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(437231), // Rule ID 3577 //
     /*  437150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  437161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  437164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  437167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437197 */     // MIs[1] Operand 1
     /*  437197 */     // No operand predicates
     /*  437197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437206 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437229 */     GIR_RootConstrainSelectedInstOperands,
     /*  437230 */     // GIR_Coverage, 3577,
     /*  437230 */     GIR_EraseRootFromParent_Done,
     /*  437231 */   // Label 7618: @437231
     /*  437231 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(437317), // Rule ID 3580 //
     /*  437236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  437247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  437250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  437253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437283 */     // MIs[1] Operand 1
     /*  437283 */     // No operand predicates
     /*  437283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  437295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437315 */     GIR_RootConstrainSelectedInstOperands,
     /*  437316 */     // GIR_Coverage, 3580,
     /*  437316 */     GIR_EraseRootFromParent_Done,
     /*  437317 */   // Label 7619: @437317
     /*  437317 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(437403), // Rule ID 3581 //
     /*  437322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  437333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  437336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  437339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437369 */     // MIs[1] Operand 1
     /*  437369 */     // No operand predicates
     /*  437369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437378 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  437381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437401 */     GIR_RootConstrainSelectedInstOperands,
     /*  437402 */     // GIR_Coverage, 3581,
     /*  437402 */     GIR_EraseRootFromParent_Done,
     /*  437403 */   // Label 7620: @437403
     /*  437403 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(437489), // Rule ID 3584 //
     /*  437408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  437419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  437422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  437425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437455 */     // MIs[1] Operand 1
     /*  437455 */     // No operand predicates
     /*  437455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437464 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  437467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437487 */     GIR_RootConstrainSelectedInstOperands,
     /*  437488 */     // GIR_Coverage, 3584,
     /*  437488 */     GIR_EraseRootFromParent_Done,
     /*  437489 */   // Label 7621: @437489
     /*  437489 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(437575), // Rule ID 3585 //
     /*  437494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  437505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  437508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  437511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437541 */     // MIs[1] Operand 1
     /*  437541 */     // No operand predicates
     /*  437541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437550 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  437553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437573 */     GIR_RootConstrainSelectedInstOperands,
     /*  437574 */     // GIR_Coverage, 3585,
     /*  437574 */     GIR_EraseRootFromParent_Done,
     /*  437575 */   // Label 7622: @437575
     /*  437575 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(437661), // Rule ID 3588 //
     /*  437580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  437591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  437594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  437597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437627 */     // MIs[1] Operand 1
     /*  437627 */     // No operand predicates
     /*  437627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437636 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437659 */     GIR_RootConstrainSelectedInstOperands,
     /*  437660 */     // GIR_Coverage, 3588,
     /*  437660 */     GIR_EraseRootFromParent_Done,
     /*  437661 */   // Label 7623: @437661
     /*  437661 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(437747), // Rule ID 3589 //
     /*  437666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  437677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  437680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  437683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437713 */     // MIs[1] Operand 1
     /*  437713 */     // No operand predicates
     /*  437713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437722 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437745 */     GIR_RootConstrainSelectedInstOperands,
     /*  437746 */     // GIR_Coverage, 3589,
     /*  437746 */     GIR_EraseRootFromParent_Done,
     /*  437747 */   // Label 7624: @437747
     /*  437747 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(437833), // Rule ID 5952 //
     /*  437752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  437763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  437766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  437769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437799 */     // MIs[1] Operand 1
     /*  437799 */     // No operand predicates
     /*  437799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437808 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  437811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437831 */     GIR_RootConstrainSelectedInstOperands,
     /*  437832 */     // GIR_Coverage, 5952,
     /*  437832 */     GIR_EraseRootFromParent_Done,
     /*  437833 */   // Label 7625: @437833
     /*  437833 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(437919), // Rule ID 5953 //
     /*  437838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  437849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  437852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  437855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437885 */     // MIs[1] Operand 1
     /*  437885 */     // No operand predicates
     /*  437885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437894 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  437894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  437897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437917 */     GIR_RootConstrainSelectedInstOperands,
     /*  437918 */     // GIR_Coverage, 5953,
     /*  437918 */     GIR_EraseRootFromParent_Done,
     /*  437919 */   // Label 7626: @437919
     /*  437919 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(438005), // Rule ID 5956 //
     /*  437924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  437935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  437938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  437941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437971 */     // MIs[1] Operand 1
     /*  437971 */     // No operand predicates
     /*  437971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437980 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  437983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438003 */     GIR_RootConstrainSelectedInstOperands,
     /*  438004 */     // GIR_Coverage, 5956,
     /*  438004 */     GIR_EraseRootFromParent_Done,
     /*  438005 */   // Label 7627: @438005
     /*  438005 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(438091), // Rule ID 5957 //
     /*  438010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  438021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  438024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  438027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438057 */     // MIs[1] Operand 1
     /*  438057 */     // No operand predicates
     /*  438057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438066 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438089 */     GIR_RootConstrainSelectedInstOperands,
     /*  438090 */     // GIR_Coverage, 5957,
     /*  438090 */     GIR_EraseRootFromParent_Done,
     /*  438091 */   // Label 7628: @438091
     /*  438091 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(438177), // Rule ID 5960 //
     /*  438096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  438107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  438110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  438113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438143 */     // MIs[1] Operand 1
     /*  438143 */     // No operand predicates
     /*  438143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438152 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438175 */     GIR_RootConstrainSelectedInstOperands,
     /*  438176 */     // GIR_Coverage, 5960,
     /*  438176 */     GIR_EraseRootFromParent_Done,
     /*  438177 */   // Label 7629: @438177
     /*  438177 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(438263), // Rule ID 5961 //
     /*  438182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  438193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  438196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  438199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438229 */     // MIs[1] Operand 1
     /*  438229 */     // No operand predicates
     /*  438229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438238 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438261 */     GIR_RootConstrainSelectedInstOperands,
     /*  438262 */     // GIR_Coverage, 5961,
     /*  438262 */     GIR_EraseRootFromParent_Done,
     /*  438263 */   // Label 7630: @438263
     /*  438263 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(438349), // Rule ID 5964 //
     /*  438268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  438285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438315 */     // MIs[1] Operand 1
     /*  438315 */     // No operand predicates
     /*  438315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438324 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438347 */     GIR_RootConstrainSelectedInstOperands,
     /*  438348 */     // GIR_Coverage, 5964,
     /*  438348 */     GIR_EraseRootFromParent_Done,
     /*  438349 */   // Label 7631: @438349
     /*  438349 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(438435), // Rule ID 5965 //
     /*  438354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  438371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438401 */     // MIs[1] Operand 1
     /*  438401 */     // No operand predicates
     /*  438401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438410 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438433 */     GIR_RootConstrainSelectedInstOperands,
     /*  438434 */     // GIR_Coverage, 5965,
     /*  438434 */     GIR_EraseRootFromParent_Done,
     /*  438435 */   // Label 7632: @438435
     /*  438435 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(438521), // Rule ID 5968 //
     /*  438440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  438457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438487 */     // MIs[1] Operand 1
     /*  438487 */     // No operand predicates
     /*  438487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438519 */     GIR_RootConstrainSelectedInstOperands,
     /*  438520 */     // GIR_Coverage, 5968,
     /*  438520 */     GIR_EraseRootFromParent_Done,
     /*  438521 */   // Label 7633: @438521
     /*  438521 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(438607), // Rule ID 5969 //
     /*  438526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  438543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438573 */     // MIs[1] Operand 1
     /*  438573 */     // No operand predicates
     /*  438573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438582 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438605 */     GIR_RootConstrainSelectedInstOperands,
     /*  438606 */     // GIR_Coverage, 5969,
     /*  438606 */     GIR_EraseRootFromParent_Done,
     /*  438607 */   // Label 7634: @438607
     /*  438607 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(438693), // Rule ID 5972 //
     /*  438612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  438623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  438626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  438629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438659 */     // MIs[1] Operand 1
     /*  438659 */     // No operand predicates
     /*  438659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  438668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438691 */     GIR_RootConstrainSelectedInstOperands,
     /*  438692 */     // GIR_Coverage, 5972,
     /*  438692 */     GIR_EraseRootFromParent_Done,
     /*  438693 */   // Label 7635: @438693
     /*  438693 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(438779), // Rule ID 5973 //
     /*  438698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  438709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  438712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  438715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438745 */     // MIs[1] Operand 1
     /*  438745 */     // No operand predicates
     /*  438745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438754 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  438754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438777 */     GIR_RootConstrainSelectedInstOperands,
     /*  438778 */     // GIR_Coverage, 5973,
     /*  438778 */     GIR_EraseRootFromParent_Done,
     /*  438779 */   // Label 7636: @438779
     /*  438779 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(438865), // Rule ID 5976 //
     /*  438784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  438795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  438798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  438801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438831 */     // MIs[1] Operand 1
     /*  438831 */     // No operand predicates
     /*  438831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  438843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438863 */     GIR_RootConstrainSelectedInstOperands,
     /*  438864 */     // GIR_Coverage, 5976,
     /*  438864 */     GIR_EraseRootFromParent_Done,
     /*  438865 */   // Label 7637: @438865
     /*  438865 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(438951), // Rule ID 5977 //
     /*  438870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  438881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  438884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  438887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438917 */     // MIs[1] Operand 1
     /*  438917 */     // No operand predicates
     /*  438917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438926 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  438929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438949 */     GIR_RootConstrainSelectedInstOperands,
     /*  438950 */     // GIR_Coverage, 5977,
     /*  438950 */     GIR_EraseRootFromParent_Done,
     /*  438951 */   // Label 7638: @438951
     /*  438951 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(439037), // Rule ID 5980 //
     /*  438956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  438967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  438970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  438973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439003 */     // MIs[1] Operand 1
     /*  439003 */     // No operand predicates
     /*  439003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439012 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439035 */     GIR_RootConstrainSelectedInstOperands,
     /*  439036 */     // GIR_Coverage, 5980,
     /*  439036 */     GIR_EraseRootFromParent_Done,
     /*  439037 */   // Label 7639: @439037
     /*  439037 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(439123), // Rule ID 5981 //
     /*  439042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  439053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  439056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  439059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439089 */     // MIs[1] Operand 1
     /*  439089 */     // No operand predicates
     /*  439089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439098 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439121 */     GIR_RootConstrainSelectedInstOperands,
     /*  439122 */     // GIR_Coverage, 5981,
     /*  439122 */     GIR_EraseRootFromParent_Done,
     /*  439123 */   // Label 7640: @439123
     /*  439123 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(439209), // Rule ID 5984 //
     /*  439128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  439139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  439142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439175 */     // MIs[1] Operand 1
     /*  439175 */     // No operand predicates
     /*  439175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439184 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  439184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439207 */     GIR_RootConstrainSelectedInstOperands,
     /*  439208 */     // GIR_Coverage, 5984,
     /*  439208 */     GIR_EraseRootFromParent_Done,
     /*  439209 */   // Label 7641: @439209
     /*  439209 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(439295), // Rule ID 5985 //
     /*  439214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  439225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  439228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439261 */     // MIs[1] Operand 1
     /*  439261 */     // No operand predicates
     /*  439261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  439270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439293 */     GIR_RootConstrainSelectedInstOperands,
     /*  439294 */     // GIR_Coverage, 5985,
     /*  439294 */     GIR_EraseRootFromParent_Done,
     /*  439295 */   // Label 7642: @439295
     /*  439295 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(439381), // Rule ID 5988 //
     /*  439300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  439303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  439311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  439314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  439317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439347 */     // MIs[1] Operand 1
     /*  439347 */     // No operand predicates
     /*  439347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  439356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  439376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439379 */     GIR_RootConstrainSelectedInstOperands,
     /*  439380 */     // GIR_Coverage, 5988,
     /*  439380 */     GIR_EraseRootFromParent_Done,
     /*  439381 */   // Label 7643: @439381
     /*  439381 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(439467), // Rule ID 5989 //
     /*  439386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  439389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  439397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  439400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  439403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439433 */     // MIs[1] Operand 1
     /*  439433 */     // No operand predicates
     /*  439433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439442 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  439442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  439462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439465 */     GIR_RootConstrainSelectedInstOperands,
     /*  439466 */     // GIR_Coverage, 5989,
     /*  439466 */     GIR_EraseRootFromParent_Done,
     /*  439467 */   // Label 7644: @439467
     /*  439467 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(439553), // Rule ID 5992 //
     /*  439472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  439483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  439486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  439489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439519 */     // MIs[1] Operand 1
     /*  439519 */     // No operand predicates
     /*  439519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439528 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  439531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439551 */     GIR_RootConstrainSelectedInstOperands,
     /*  439552 */     // GIR_Coverage, 5992,
     /*  439552 */     GIR_EraseRootFromParent_Done,
     /*  439553 */   // Label 7645: @439553
     /*  439553 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(439639), // Rule ID 5993 //
     /*  439558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  439569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  439572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  439575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439605 */     // MIs[1] Operand 1
     /*  439605 */     // No operand predicates
     /*  439605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439614 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  439617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439637 */     GIR_RootConstrainSelectedInstOperands,
     /*  439638 */     // GIR_Coverage, 5993,
     /*  439638 */     GIR_EraseRootFromParent_Done,
     /*  439639 */   // Label 7646: @439639
     /*  439639 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(439725), // Rule ID 5996 //
     /*  439644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  439655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  439658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  439661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439691 */     // MIs[1] Operand 1
     /*  439691 */     // No operand predicates
     /*  439691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439700 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  439703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439723 */     GIR_RootConstrainSelectedInstOperands,
     /*  439724 */     // GIR_Coverage, 5996,
     /*  439724 */     GIR_EraseRootFromParent_Done,
     /*  439725 */   // Label 7647: @439725
     /*  439725 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(439811), // Rule ID 5997 //
     /*  439730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  439741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  439744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  439747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439777 */     // MIs[1] Operand 1
     /*  439777 */     // No operand predicates
     /*  439777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439786 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  439789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439809 */     GIR_RootConstrainSelectedInstOperands,
     /*  439810 */     // GIR_Coverage, 5997,
     /*  439810 */     GIR_EraseRootFromParent_Done,
     /*  439811 */   // Label 7648: @439811
     /*  439811 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(439897), // Rule ID 6000 //
     /*  439816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  439827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  439830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  439833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439863 */     // MIs[1] Operand 1
     /*  439863 */     // No operand predicates
     /*  439863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439872 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  439875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439895 */     GIR_RootConstrainSelectedInstOperands,
     /*  439896 */     // GIR_Coverage, 6000,
     /*  439896 */     GIR_EraseRootFromParent_Done,
     /*  439897 */   // Label 7649: @439897
     /*  439897 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(439983), // Rule ID 6001 //
     /*  439902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  439913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  439916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  439919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439949 */     // MIs[1] Operand 1
     /*  439949 */     // No operand predicates
     /*  439949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439958 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  439961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439981 */     GIR_RootConstrainSelectedInstOperands,
     /*  439982 */     // GIR_Coverage, 6001,
     /*  439982 */     GIR_EraseRootFromParent_Done,
     /*  439983 */   // Label 7650: @439983
     /*  439983 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(440069), // Rule ID 6004 //
     /*  439988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  439999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  440002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  440005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440035 */     // MIs[1] Operand 1
     /*  440035 */     // No operand predicates
     /*  440035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440044 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440067 */     GIR_RootConstrainSelectedInstOperands,
     /*  440068 */     // GIR_Coverage, 6004,
     /*  440068 */     GIR_EraseRootFromParent_Done,
     /*  440069 */   // Label 7651: @440069
     /*  440069 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(440155), // Rule ID 6005 //
     /*  440074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  440085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  440088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  440091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440121 */     // MIs[1] Operand 1
     /*  440121 */     // No operand predicates
     /*  440121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440153 */     GIR_RootConstrainSelectedInstOperands,
     /*  440154 */     // GIR_Coverage, 6005,
     /*  440154 */     GIR_EraseRootFromParent_Done,
     /*  440155 */   // Label 7652: @440155
     /*  440155 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(440241), // Rule ID 6008 //
     /*  440160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  440171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  440174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  440177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440207 */     // MIs[1] Operand 1
     /*  440207 */     // No operand predicates
     /*  440207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440216 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440239 */     GIR_RootConstrainSelectedInstOperands,
     /*  440240 */     // GIR_Coverage, 6008,
     /*  440240 */     GIR_EraseRootFromParent_Done,
     /*  440241 */   // Label 7653: @440241
     /*  440241 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(440327), // Rule ID 6009 //
     /*  440246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  440257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  440260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  440263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440293 */     // MIs[1] Operand 1
     /*  440293 */     // No operand predicates
     /*  440293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440302 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440325 */     GIR_RootConstrainSelectedInstOperands,
     /*  440326 */     // GIR_Coverage, 6009,
     /*  440326 */     GIR_EraseRootFromParent_Done,
     /*  440327 */   // Label 7654: @440327
     /*  440327 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(440413), // Rule ID 6012 //
     /*  440332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  440343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  440346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  440349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440379 */     // MIs[1] Operand 1
     /*  440379 */     // No operand predicates
     /*  440379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440388 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440411 */     GIR_RootConstrainSelectedInstOperands,
     /*  440412 */     // GIR_Coverage, 6012,
     /*  440412 */     GIR_EraseRootFromParent_Done,
     /*  440413 */   // Label 7655: @440413
     /*  440413 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(440499), // Rule ID 6013 //
     /*  440418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  440429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  440432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  440435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440465 */     // MIs[1] Operand 1
     /*  440465 */     // No operand predicates
     /*  440465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440474 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440497 */     GIR_RootConstrainSelectedInstOperands,
     /*  440498 */     // GIR_Coverage, 6013,
     /*  440498 */     GIR_EraseRootFromParent_Done,
     /*  440499 */   // Label 7656: @440499
     /*  440499 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(440585), // Rule ID 6016 //
     /*  440504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  440515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  440518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440551 */     // MIs[1] Operand 1
     /*  440551 */     // No operand predicates
     /*  440551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440583 */     GIR_RootConstrainSelectedInstOperands,
     /*  440584 */     // GIR_Coverage, 6016,
     /*  440584 */     GIR_EraseRootFromParent_Done,
     /*  440585 */   // Label 7657: @440585
     /*  440585 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(440671), // Rule ID 6017 //
     /*  440590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  440601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  440604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440637 */     // MIs[1] Operand 1
     /*  440637 */     // No operand predicates
     /*  440637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440669 */     GIR_RootConstrainSelectedInstOperands,
     /*  440670 */     // GIR_Coverage, 6017,
     /*  440670 */     GIR_EraseRootFromParent_Done,
     /*  440671 */   // Label 7658: @440671
     /*  440671 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(440757), // Rule ID 6020 //
     /*  440676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  440687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  440690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  440693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440723 */     // MIs[1] Operand 1
     /*  440723 */     // No operand predicates
     /*  440723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440732 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440755 */     GIR_RootConstrainSelectedInstOperands,
     /*  440756 */     // GIR_Coverage, 6020,
     /*  440756 */     GIR_EraseRootFromParent_Done,
     /*  440757 */   // Label 7659: @440757
     /*  440757 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(440843), // Rule ID 6021 //
     /*  440762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  440773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  440776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  440779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440809 */     // MIs[1] Operand 1
     /*  440809 */     // No operand predicates
     /*  440809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440818 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440841 */     GIR_RootConstrainSelectedInstOperands,
     /*  440842 */     // GIR_Coverage, 6021,
     /*  440842 */     GIR_EraseRootFromParent_Done,
     /*  440843 */   // Label 7660: @440843
     /*  440843 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(440929), // Rule ID 6024 //
     /*  440848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  440859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  440862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  440865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440895 */     // MIs[1] Operand 1
     /*  440895 */     // No operand predicates
     /*  440895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440904 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440927 */     GIR_RootConstrainSelectedInstOperands,
     /*  440928 */     // GIR_Coverage, 6024,
     /*  440928 */     GIR_EraseRootFromParent_Done,
     /*  440929 */   // Label 7661: @440929
     /*  440929 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(441015), // Rule ID 6025 //
     /*  440934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  440945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  440948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  440951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440981 */     // MIs[1] Operand 1
     /*  440981 */     // No operand predicates
     /*  440981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440990 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441013 */     GIR_RootConstrainSelectedInstOperands,
     /*  441014 */     // GIR_Coverage, 6025,
     /*  441014 */     GIR_EraseRootFromParent_Done,
     /*  441015 */   // Label 7662: @441015
     /*  441015 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(441101), // Rule ID 6028 //
     /*  441020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  441031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  441034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441067 */     // MIs[1] Operand 1
     /*  441067 */     // No operand predicates
     /*  441067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  441079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441099 */     GIR_RootConstrainSelectedInstOperands,
     /*  441100 */     // GIR_Coverage, 6028,
     /*  441100 */     GIR_EraseRootFromParent_Done,
     /*  441101 */   // Label 7663: @441101
     /*  441101 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(441187), // Rule ID 6029 //
     /*  441106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  441117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  441120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441153 */     // MIs[1] Operand 1
     /*  441153 */     // No operand predicates
     /*  441153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441162 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  441165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441185 */     GIR_RootConstrainSelectedInstOperands,
     /*  441186 */     // GIR_Coverage, 6029,
     /*  441186 */     GIR_EraseRootFromParent_Done,
     /*  441187 */   // Label 7664: @441187
     /*  441187 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(441273), // Rule ID 6032 //
     /*  441192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  441203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  441206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441239 */     // MIs[1] Operand 1
     /*  441239 */     // No operand predicates
     /*  441239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441248 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  441251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441271 */     GIR_RootConstrainSelectedInstOperands,
     /*  441272 */     // GIR_Coverage, 6032,
     /*  441272 */     GIR_EraseRootFromParent_Done,
     /*  441273 */   // Label 7665: @441273
     /*  441273 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(441359), // Rule ID 6033 //
     /*  441278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  441289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  441292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441325 */     // MIs[1] Operand 1
     /*  441325 */     // No operand predicates
     /*  441325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441334 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  441337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441357 */     GIR_RootConstrainSelectedInstOperands,
     /*  441358 */     // GIR_Coverage, 6033,
     /*  441358 */     GIR_EraseRootFromParent_Done,
     /*  441359 */   // Label 7666: @441359
     /*  441359 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(441445), // Rule ID 6036 //
     /*  441364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  441375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  441378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441411 */     // MIs[1] Operand 1
     /*  441411 */     // No operand predicates
     /*  441411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441420 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  441423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441443 */     GIR_RootConstrainSelectedInstOperands,
     /*  441444 */     // GIR_Coverage, 6036,
     /*  441444 */     GIR_EraseRootFromParent_Done,
     /*  441445 */   // Label 7667: @441445
     /*  441445 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(441531), // Rule ID 6037 //
     /*  441450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  441461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  441464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441497 */     // MIs[1] Operand 1
     /*  441497 */     // No operand predicates
     /*  441497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441506 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  441509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441529 */     GIR_RootConstrainSelectedInstOperands,
     /*  441530 */     // GIR_Coverage, 6037,
     /*  441530 */     GIR_EraseRootFromParent_Done,
     /*  441531 */   // Label 7668: @441531
     /*  441531 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(441617), // Rule ID 6216 //
     /*  441536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  441547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  441550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  441553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441583 */     // MIs[1] Operand 1
     /*  441583 */     // No operand predicates
     /*  441583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441592 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  441595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441615 */     GIR_RootConstrainSelectedInstOperands,
     /*  441616 */     // GIR_Coverage, 6216,
     /*  441616 */     GIR_EraseRootFromParent_Done,
     /*  441617 */   // Label 7669: @441617
     /*  441617 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(441703), // Rule ID 6217 //
     /*  441622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  441633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  441636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  441639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441669 */     // MIs[1] Operand 1
     /*  441669 */     // No operand predicates
     /*  441669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441678 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  441678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  441681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441701 */     GIR_RootConstrainSelectedInstOperands,
     /*  441702 */     // GIR_Coverage, 6217,
     /*  441702 */     GIR_EraseRootFromParent_Done,
     /*  441703 */   // Label 7670: @441703
     /*  441703 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(441789), // Rule ID 6220 //
     /*  441708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  441719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  441722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  441725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441755 */     // MIs[1] Operand 1
     /*  441755 */     // No operand predicates
     /*  441755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441764 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  441767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441787 */     GIR_RootConstrainSelectedInstOperands,
     /*  441788 */     // GIR_Coverage, 6220,
     /*  441788 */     GIR_EraseRootFromParent_Done,
     /*  441789 */   // Label 7671: @441789
     /*  441789 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(441875), // Rule ID 6221 //
     /*  441794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  441805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  441808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  441811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441841 */     // MIs[1] Operand 1
     /*  441841 */     // No operand predicates
     /*  441841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441850 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  441850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  441853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441873 */     GIR_RootConstrainSelectedInstOperands,
     /*  441874 */     // GIR_Coverage, 6221,
     /*  441874 */     GIR_EraseRootFromParent_Done,
     /*  441875 */   // Label 7672: @441875
     /*  441875 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(441961), // Rule ID 6224 //
     /*  441880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  441891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  441894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  441897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441927 */     // MIs[1] Operand 1
     /*  441927 */     // No operand predicates
     /*  441927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441936 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  441939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441959 */     GIR_RootConstrainSelectedInstOperands,
     /*  441960 */     // GIR_Coverage, 6224,
     /*  441960 */     GIR_EraseRootFromParent_Done,
     /*  441961 */   // Label 7673: @441961
     /*  441961 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(442047), // Rule ID 6225 //
     /*  441966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  441977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  441980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  441983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442013 */     // MIs[1] Operand 1
     /*  442013 */     // No operand predicates
     /*  442013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442022 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442045 */     GIR_RootConstrainSelectedInstOperands,
     /*  442046 */     // GIR_Coverage, 6225,
     /*  442046 */     GIR_EraseRootFromParent_Done,
     /*  442047 */   // Label 7674: @442047
     /*  442047 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(442133), // Rule ID 6228 //
     /*  442052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  442069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442099 */     // MIs[1] Operand 1
     /*  442099 */     // No operand predicates
     /*  442099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442108 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  442111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442131 */     GIR_RootConstrainSelectedInstOperands,
     /*  442132 */     // GIR_Coverage, 6228,
     /*  442132 */     GIR_EraseRootFromParent_Done,
     /*  442133 */   // Label 7675: @442133
     /*  442133 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(442219), // Rule ID 6229 //
     /*  442138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  442155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442185 */     // MIs[1] Operand 1
     /*  442185 */     // No operand predicates
     /*  442185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  442197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442217 */     GIR_RootConstrainSelectedInstOperands,
     /*  442218 */     // GIR_Coverage, 6229,
     /*  442218 */     GIR_EraseRootFromParent_Done,
     /*  442219 */   // Label 7676: @442219
     /*  442219 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(442305), // Rule ID 6232 //
     /*  442224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  442241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442271 */     // MIs[1] Operand 1
     /*  442271 */     // No operand predicates
     /*  442271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442280 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442303 */     GIR_RootConstrainSelectedInstOperands,
     /*  442304 */     // GIR_Coverage, 6232,
     /*  442304 */     GIR_EraseRootFromParent_Done,
     /*  442305 */   // Label 7677: @442305
     /*  442305 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(442391), // Rule ID 6233 //
     /*  442310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  442327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442357 */     // MIs[1] Operand 1
     /*  442357 */     // No operand predicates
     /*  442357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442389 */     GIR_RootConstrainSelectedInstOperands,
     /*  442390 */     // GIR_Coverage, 6233,
     /*  442390 */     GIR_EraseRootFromParent_Done,
     /*  442391 */   // Label 7678: @442391
     /*  442391 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(442477), // Rule ID 6236 //
     /*  442396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  442407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  442410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442443 */     // MIs[1] Operand 1
     /*  442443 */     // No operand predicates
     /*  442443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442452 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  442452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442475 */     GIR_RootConstrainSelectedInstOperands,
     /*  442476 */     // GIR_Coverage, 6236,
     /*  442476 */     GIR_EraseRootFromParent_Done,
     /*  442477 */   // Label 7679: @442477
     /*  442477 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(442563), // Rule ID 6237 //
     /*  442482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  442493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  442496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442529 */     // MIs[1] Operand 1
     /*  442529 */     // No operand predicates
     /*  442529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  442538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442561 */     GIR_RootConstrainSelectedInstOperands,
     /*  442562 */     // GIR_Coverage, 6237,
     /*  442562 */     GIR_EraseRootFromParent_Done,
     /*  442563 */   // Label 7680: @442563
     /*  442563 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(442649), // Rule ID 6240 //
     /*  442568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  442579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  442582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  442585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442615 */     // MIs[1] Operand 1
     /*  442615 */     // No operand predicates
     /*  442615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442624 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  442624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442647 */     GIR_RootConstrainSelectedInstOperands,
     /*  442648 */     // GIR_Coverage, 6240,
     /*  442648 */     GIR_EraseRootFromParent_Done,
     /*  442649 */   // Label 7681: @442649
     /*  442649 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(442735), // Rule ID 6241 //
     /*  442654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  442665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  442668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  442671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442701 */     // MIs[1] Operand 1
     /*  442701 */     // No operand predicates
     /*  442701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442710 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442733 */     GIR_RootConstrainSelectedInstOperands,
     /*  442734 */     // GIR_Coverage, 6241,
     /*  442734 */     GIR_EraseRootFromParent_Done,
     /*  442735 */   // Label 7682: @442735
     /*  442735 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(442821), // Rule ID 6244 //
     /*  442740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  442751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  442754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  442757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442787 */     // MIs[1] Operand 1
     /*  442787 */     // No operand predicates
     /*  442787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442796 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442819 */     GIR_RootConstrainSelectedInstOperands,
     /*  442820 */     // GIR_Coverage, 6244,
     /*  442820 */     GIR_EraseRootFromParent_Done,
     /*  442821 */   // Label 7683: @442821
     /*  442821 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(442907), // Rule ID 6245 //
     /*  442826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  442837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  442840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  442843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442873 */     // MIs[1] Operand 1
     /*  442873 */     // No operand predicates
     /*  442873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442905 */     GIR_RootConstrainSelectedInstOperands,
     /*  442906 */     // GIR_Coverage, 6245,
     /*  442906 */     GIR_EraseRootFromParent_Done,
     /*  442907 */   // Label 7684: @442907
     /*  442907 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(442993), // Rule ID 6248 //
     /*  442912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  442923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  442926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  442929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442959 */     // MIs[1] Operand 1
     /*  442959 */     // No operand predicates
     /*  442959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442968 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  442968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442991 */     GIR_RootConstrainSelectedInstOperands,
     /*  442992 */     // GIR_Coverage, 6248,
     /*  442992 */     GIR_EraseRootFromParent_Done,
     /*  442993 */   // Label 7685: @442993
     /*  442993 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(443079), // Rule ID 6249 //
     /*  442998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  443009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  443012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  443015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443045 */     // MIs[1] Operand 1
     /*  443045 */     // No operand predicates
     /*  443045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443054 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  443054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443077 */     GIR_RootConstrainSelectedInstOperands,
     /*  443078 */     // GIR_Coverage, 6249,
     /*  443078 */     GIR_EraseRootFromParent_Done,
     /*  443079 */   // Label 7686: @443079
     /*  443079 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(443165), // Rule ID 6252 //
     /*  443084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  443087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  443095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  443098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  443101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443131 */     // MIs[1] Operand 1
     /*  443131 */     // No operand predicates
     /*  443131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  443140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  443160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443163 */     GIR_RootConstrainSelectedInstOperands,
     /*  443164 */     // GIR_Coverage, 6252,
     /*  443164 */     GIR_EraseRootFromParent_Done,
     /*  443165 */   // Label 7687: @443165
     /*  443165 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(443251), // Rule ID 6253 //
     /*  443170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  443173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  443181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  443184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  443187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443217 */     // MIs[1] Operand 1
     /*  443217 */     // No operand predicates
     /*  443217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443226 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  443226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  443246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443249 */     GIR_RootConstrainSelectedInstOperands,
     /*  443250 */     // GIR_Coverage, 6253,
     /*  443250 */     GIR_EraseRootFromParent_Done,
     /*  443251 */   // Label 7688: @443251
     /*  443251 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(443337), // Rule ID 6256 //
     /*  443256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  443267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  443270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  443273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443303 */     // MIs[1] Operand 1
     /*  443303 */     // No operand predicates
     /*  443303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443312 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443335 */     GIR_RootConstrainSelectedInstOperands,
     /*  443336 */     // GIR_Coverage, 6256,
     /*  443336 */     GIR_EraseRootFromParent_Done,
     /*  443337 */   // Label 7689: @443337
     /*  443337 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(443423), // Rule ID 6257 //
     /*  443342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  443353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  443356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  443359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443389 */     // MIs[1] Operand 1
     /*  443389 */     // No operand predicates
     /*  443389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443421 */     GIR_RootConstrainSelectedInstOperands,
     /*  443422 */     // GIR_Coverage, 6257,
     /*  443422 */     GIR_EraseRootFromParent_Done,
     /*  443423 */   // Label 7690: @443423
     /*  443423 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(443509), // Rule ID 6260 //
     /*  443428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  443439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  443442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  443445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443475 */     // MIs[1] Operand 1
     /*  443475 */     // No operand predicates
     /*  443475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443484 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  443487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443507 */     GIR_RootConstrainSelectedInstOperands,
     /*  443508 */     // GIR_Coverage, 6260,
     /*  443508 */     GIR_EraseRootFromParent_Done,
     /*  443509 */   // Label 7691: @443509
     /*  443509 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(443595), // Rule ID 6261 //
     /*  443514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  443525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  443528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  443531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443561 */     // MIs[1] Operand 1
     /*  443561 */     // No operand predicates
     /*  443561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443570 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  443573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443593 */     GIR_RootConstrainSelectedInstOperands,
     /*  443594 */     // GIR_Coverage, 6261,
     /*  443594 */     GIR_EraseRootFromParent_Done,
     /*  443595 */   // Label 7692: @443595
     /*  443595 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(443681), // Rule ID 6264 //
     /*  443600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  443611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  443614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  443617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443647 */     // MIs[1] Operand 1
     /*  443647 */     // No operand predicates
     /*  443647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443656 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  443659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443679 */     GIR_RootConstrainSelectedInstOperands,
     /*  443680 */     // GIR_Coverage, 6264,
     /*  443680 */     GIR_EraseRootFromParent_Done,
     /*  443681 */   // Label 7693: @443681
     /*  443681 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(443767), // Rule ID 6265 //
     /*  443686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  443697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  443700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  443703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443733 */     // MIs[1] Operand 1
     /*  443733 */     // No operand predicates
     /*  443733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443742 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  443745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443765 */     GIR_RootConstrainSelectedInstOperands,
     /*  443766 */     // GIR_Coverage, 6265,
     /*  443766 */     GIR_EraseRootFromParent_Done,
     /*  443767 */   // Label 7694: @443767
     /*  443767 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(443853), // Rule ID 6268 //
     /*  443772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  443783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  443786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  443789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443819 */     // MIs[1] Operand 1
     /*  443819 */     // No operand predicates
     /*  443819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443828 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  443828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443851 */     GIR_RootConstrainSelectedInstOperands,
     /*  443852 */     // GIR_Coverage, 6268,
     /*  443852 */     GIR_EraseRootFromParent_Done,
     /*  443853 */   // Label 7695: @443853
     /*  443853 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(443939), // Rule ID 6269 //
     /*  443858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  443869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  443872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  443875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443905 */     // MIs[1] Operand 1
     /*  443905 */     // No operand predicates
     /*  443905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  443914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443937 */     GIR_RootConstrainSelectedInstOperands,
     /*  443938 */     // GIR_Coverage, 6269,
     /*  443938 */     GIR_EraseRootFromParent_Done,
     /*  443939 */   // Label 7696: @443939
     /*  443939 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(444025), // Rule ID 6272 //
     /*  443944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  443955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  443958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  443961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443991 */     // MIs[1] Operand 1
     /*  443991 */     // No operand predicates
     /*  443991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444000 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444023 */     GIR_RootConstrainSelectedInstOperands,
     /*  444024 */     // GIR_Coverage, 6272,
     /*  444024 */     GIR_EraseRootFromParent_Done,
     /*  444025 */   // Label 7697: @444025
     /*  444025 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(444111), // Rule ID 6273 //
     /*  444030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  444041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  444044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  444047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444077 */     // MIs[1] Operand 1
     /*  444077 */     // No operand predicates
     /*  444077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444086 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444109 */     GIR_RootConstrainSelectedInstOperands,
     /*  444110 */     // GIR_Coverage, 6273,
     /*  444110 */     GIR_EraseRootFromParent_Done,
     /*  444111 */   // Label 7698: @444111
     /*  444111 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(444197), // Rule ID 6276 //
     /*  444116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  444127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  444130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  444133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444163 */     // MIs[1] Operand 1
     /*  444163 */     // No operand predicates
     /*  444163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444172 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444195 */     GIR_RootConstrainSelectedInstOperands,
     /*  444196 */     // GIR_Coverage, 6276,
     /*  444196 */     GIR_EraseRootFromParent_Done,
     /*  444197 */   // Label 7699: @444197
     /*  444197 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(444283), // Rule ID 6277 //
     /*  444202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  444213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  444216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  444219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444249 */     // MIs[1] Operand 1
     /*  444249 */     // No operand predicates
     /*  444249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444258 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444281 */     GIR_RootConstrainSelectedInstOperands,
     /*  444282 */     // GIR_Coverage, 6277,
     /*  444282 */     GIR_EraseRootFromParent_Done,
     /*  444283 */   // Label 7700: @444283
     /*  444283 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(444369), // Rule ID 6280 //
     /*  444288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  444305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444335 */     // MIs[1] Operand 1
     /*  444335 */     // No operand predicates
     /*  444335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444367 */     GIR_RootConstrainSelectedInstOperands,
     /*  444368 */     // GIR_Coverage, 6280,
     /*  444368 */     GIR_EraseRootFromParent_Done,
     /*  444369 */   // Label 7701: @444369
     /*  444369 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(444455), // Rule ID 6281 //
     /*  444374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  444391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444421 */     // MIs[1] Operand 1
     /*  444421 */     // No operand predicates
     /*  444421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444453 */     GIR_RootConstrainSelectedInstOperands,
     /*  444454 */     // GIR_Coverage, 6281,
     /*  444454 */     GIR_EraseRootFromParent_Done,
     /*  444455 */   // Label 7702: @444455
     /*  444455 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(444541), // Rule ID 6284 //
     /*  444460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  444471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  444474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  444477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444507 */     // MIs[1] Operand 1
     /*  444507 */     // No operand predicates
     /*  444507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444539 */     GIR_RootConstrainSelectedInstOperands,
     /*  444540 */     // GIR_Coverage, 6284,
     /*  444540 */     GIR_EraseRootFromParent_Done,
     /*  444541 */   // Label 7703: @444541
     /*  444541 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(444627), // Rule ID 6285 //
     /*  444546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  444557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  444560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  444563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444593 */     // MIs[1] Operand 1
     /*  444593 */     // No operand predicates
     /*  444593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444602 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444625 */     GIR_RootConstrainSelectedInstOperands,
     /*  444626 */     // GIR_Coverage, 6285,
     /*  444626 */     GIR_EraseRootFromParent_Done,
     /*  444627 */   // Label 7704: @444627
     /*  444627 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(444713), // Rule ID 6288 //
     /*  444632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  444643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  444646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  444649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444679 */     // MIs[1] Operand 1
     /*  444679 */     // No operand predicates
     /*  444679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444688 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444711 */     GIR_RootConstrainSelectedInstOperands,
     /*  444712 */     // GIR_Coverage, 6288,
     /*  444712 */     GIR_EraseRootFromParent_Done,
     /*  444713 */   // Label 7705: @444713
     /*  444713 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(444799), // Rule ID 6289 //
     /*  444718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  444729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  444732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  444735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444765 */     // MIs[1] Operand 1
     /*  444765 */     // No operand predicates
     /*  444765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444774 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444797 */     GIR_RootConstrainSelectedInstOperands,
     /*  444798 */     // GIR_Coverage, 6289,
     /*  444798 */     GIR_EraseRootFromParent_Done,
     /*  444799 */   // Label 7706: @444799
     /*  444799 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(444885), // Rule ID 6292 //
     /*  444804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  444807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  444815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  444818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  444821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444851 */     // MIs[1] Operand 1
     /*  444851 */     // No operand predicates
     /*  444851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  444860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  444880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444883 */     GIR_RootConstrainSelectedInstOperands,
     /*  444884 */     // GIR_Coverage, 6292,
     /*  444884 */     GIR_EraseRootFromParent_Done,
     /*  444885 */   // Label 7707: @444885
     /*  444885 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(444971), // Rule ID 6293 //
     /*  444890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  444893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  444901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  444904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  444907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444937 */     // MIs[1] Operand 1
     /*  444937 */     // No operand predicates
     /*  444937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  444946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  444966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444969 */     GIR_RootConstrainSelectedInstOperands,
     /*  444970 */     // GIR_Coverage, 6293,
     /*  444970 */     GIR_EraseRootFromParent_Done,
     /*  444971 */   // Label 7708: @444971
     /*  444971 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(445057), // Rule ID 6296 //
     /*  444976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  444979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  444987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  444990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  444993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445023 */     // MIs[1] Operand 1
     /*  445023 */     // No operand predicates
     /*  445023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445032 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  445035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445055 */     GIR_RootConstrainSelectedInstOperands,
     /*  445056 */     // GIR_Coverage, 6296,
     /*  445056 */     GIR_EraseRootFromParent_Done,
     /*  445057 */   // Label 7709: @445057
     /*  445057 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(445143), // Rule ID 6297 //
     /*  445062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  445073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  445076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  445079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445109 */     // MIs[1] Operand 1
     /*  445109 */     // No operand predicates
     /*  445109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445118 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  445121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445141 */     GIR_RootConstrainSelectedInstOperands,
     /*  445142 */     // GIR_Coverage, 6297,
     /*  445142 */     GIR_EraseRootFromParent_Done,
     /*  445143 */   // Label 7710: @445143
     /*  445143 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(445229), // Rule ID 6300 //
     /*  445148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  445151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  445165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445195 */     // MIs[1] Operand 1
     /*  445195 */     // No operand predicates
     /*  445195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445204 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  445207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445227 */     GIR_RootConstrainSelectedInstOperands,
     /*  445228 */     // GIR_Coverage, 6300,
     /*  445228 */     GIR_EraseRootFromParent_Done,
     /*  445229 */   // Label 7711: @445229
     /*  445229 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(445315), // Rule ID 6301 //
     /*  445234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  445251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445281 */     // MIs[1] Operand 1
     /*  445281 */     // No operand predicates
     /*  445281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445290 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  445293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445313 */     GIR_RootConstrainSelectedInstOperands,
     /*  445314 */     // GIR_Coverage, 6301,
     /*  445314 */     GIR_EraseRootFromParent_Done,
     /*  445315 */   // Label 7712: @445315
     /*  445315 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(445401), // Rule ID 6480 //
     /*  445320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  445331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  445334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  445337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445367 */     // MIs[1] Operand 1
     /*  445367 */     // No operand predicates
     /*  445367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445376 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  445379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445399 */     GIR_RootConstrainSelectedInstOperands,
     /*  445400 */     // GIR_Coverage, 6480,
     /*  445400 */     GIR_EraseRootFromParent_Done,
     /*  445401 */   // Label 7713: @445401
     /*  445401 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(445487), // Rule ID 6481 //
     /*  445406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  445417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  445420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  445423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445453 */     // MIs[1] Operand 1
     /*  445453 */     // No operand predicates
     /*  445453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445462 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  445465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445485 */     GIR_RootConstrainSelectedInstOperands,
     /*  445486 */     // GIR_Coverage, 6481,
     /*  445486 */     GIR_EraseRootFromParent_Done,
     /*  445487 */   // Label 7714: @445487
     /*  445487 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(445573), // Rule ID 6484 //
     /*  445492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  445503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  445506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  445509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445539 */     // MIs[1] Operand 1
     /*  445539 */     // No operand predicates
     /*  445539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445548 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  445551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445571 */     GIR_RootConstrainSelectedInstOperands,
     /*  445572 */     // GIR_Coverage, 6484,
     /*  445572 */     GIR_EraseRootFromParent_Done,
     /*  445573 */   // Label 7715: @445573
     /*  445573 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(445659), // Rule ID 6485 //
     /*  445578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  445589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  445592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  445595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445625 */     // MIs[1] Operand 1
     /*  445625 */     // No operand predicates
     /*  445625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445634 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  445637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445657 */     GIR_RootConstrainSelectedInstOperands,
     /*  445658 */     // GIR_Coverage, 6485,
     /*  445658 */     GIR_EraseRootFromParent_Done,
     /*  445659 */   // Label 7716: @445659
     /*  445659 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(445745), // Rule ID 6488 //
     /*  445664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  445675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  445678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  445681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445711 */     // MIs[1] Operand 1
     /*  445711 */     // No operand predicates
     /*  445711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445720 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  445723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445743 */     GIR_RootConstrainSelectedInstOperands,
     /*  445744 */     // GIR_Coverage, 6488,
     /*  445744 */     GIR_EraseRootFromParent_Done,
     /*  445745 */   // Label 7717: @445745
     /*  445745 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(445831), // Rule ID 6489 //
     /*  445750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  445761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  445764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  445767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445797 */     // MIs[1] Operand 1
     /*  445797 */     // No operand predicates
     /*  445797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445806 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  445809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445829 */     GIR_RootConstrainSelectedInstOperands,
     /*  445830 */     // GIR_Coverage, 6489,
     /*  445830 */     GIR_EraseRootFromParent_Done,
     /*  445831 */   // Label 7718: @445831
     /*  445831 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(445917), // Rule ID 6492 //
     /*  445836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  445847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  445850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  445853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445883 */     // MIs[1] Operand 1
     /*  445883 */     // No operand predicates
     /*  445883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445892 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  445892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  445895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  445912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445915 */     GIR_RootConstrainSelectedInstOperands,
     /*  445916 */     // GIR_Coverage, 6492,
     /*  445916 */     GIR_EraseRootFromParent_Done,
     /*  445917 */   // Label 7719: @445917
     /*  445917 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(446003), // Rule ID 6493 //
     /*  445922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  445933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  445936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  445939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445969 */     // MIs[1] Operand 1
     /*  445969 */     // No operand predicates
     /*  445969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445978 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  445978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  445981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  445998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446001 */     GIR_RootConstrainSelectedInstOperands,
     /*  446002 */     // GIR_Coverage, 6493,
     /*  446002 */     GIR_EraseRootFromParent_Done,
     /*  446003 */   // Label 7720: @446003
     /*  446003 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(446089), // Rule ID 6496 //
     /*  446008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  446019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  446022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  446025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446055 */     // MIs[1] Operand 1
     /*  446055 */     // No operand predicates
     /*  446055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446064 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446087 */     GIR_RootConstrainSelectedInstOperands,
     /*  446088 */     // GIR_Coverage, 6496,
     /*  446088 */     GIR_EraseRootFromParent_Done,
     /*  446089 */   // Label 7721: @446089
     /*  446089 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(446175), // Rule ID 6497 //
     /*  446094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  446105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  446108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  446111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446141 */     // MIs[1] Operand 1
     /*  446141 */     // No operand predicates
     /*  446141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446150 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446173 */     GIR_RootConstrainSelectedInstOperands,
     /*  446174 */     // GIR_Coverage, 6497,
     /*  446174 */     GIR_EraseRootFromParent_Done,
     /*  446175 */   // Label 7722: @446175
     /*  446175 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(446261), // Rule ID 6500 //
     /*  446180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  446197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446227 */     // MIs[1] Operand 1
     /*  446227 */     // No operand predicates
     /*  446227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446236 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  446236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446259 */     GIR_RootConstrainSelectedInstOperands,
     /*  446260 */     // GIR_Coverage, 6500,
     /*  446260 */     GIR_EraseRootFromParent_Done,
     /*  446261 */   // Label 7723: @446261
     /*  446261 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(446347), // Rule ID 6501 //
     /*  446266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  446283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446313 */     // MIs[1] Operand 1
     /*  446313 */     // No operand predicates
     /*  446313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  446322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446345 */     GIR_RootConstrainSelectedInstOperands,
     /*  446346 */     // GIR_Coverage, 6501,
     /*  446346 */     GIR_EraseRootFromParent_Done,
     /*  446347 */   // Label 7724: @446347
     /*  446347 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(446433), // Rule ID 6504 //
     /*  446352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  446363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  446366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  446369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446399 */     // MIs[1] Operand 1
     /*  446399 */     // No operand predicates
     /*  446399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446408 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446431 */     GIR_RootConstrainSelectedInstOperands,
     /*  446432 */     // GIR_Coverage, 6504,
     /*  446432 */     GIR_EraseRootFromParent_Done,
     /*  446433 */   // Label 7725: @446433
     /*  446433 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(446519), // Rule ID 6505 //
     /*  446438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  446449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  446452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  446455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446485 */     // MIs[1] Operand 1
     /*  446485 */     // No operand predicates
     /*  446485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446494 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  446494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446517 */     GIR_RootConstrainSelectedInstOperands,
     /*  446518 */     // GIR_Coverage, 6505,
     /*  446518 */     GIR_EraseRootFromParent_Done,
     /*  446519 */   // Label 7726: @446519
     /*  446519 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(446605), // Rule ID 6508 //
     /*  446524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  446535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  446538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  446541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446571 */     // MIs[1] Operand 1
     /*  446571 */     // No operand predicates
     /*  446571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446580 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446603 */     GIR_RootConstrainSelectedInstOperands,
     /*  446604 */     // GIR_Coverage, 6508,
     /*  446604 */     GIR_EraseRootFromParent_Done,
     /*  446605 */   // Label 7727: @446605
     /*  446605 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(446691), // Rule ID 6509 //
     /*  446610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  446621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  446624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  446627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446657 */     // MIs[1] Operand 1
     /*  446657 */     // No operand predicates
     /*  446657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446666 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446689 */     GIR_RootConstrainSelectedInstOperands,
     /*  446690 */     // GIR_Coverage, 6509,
     /*  446690 */     GIR_EraseRootFromParent_Done,
     /*  446691 */   // Label 7728: @446691
     /*  446691 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(446777), // Rule ID 6512 //
     /*  446696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  446707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  446710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  446713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446743 */     // MIs[1] Operand 1
     /*  446743 */     // No operand predicates
     /*  446743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  446752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446775 */     GIR_RootConstrainSelectedInstOperands,
     /*  446776 */     // GIR_Coverage, 6512,
     /*  446776 */     GIR_EraseRootFromParent_Done,
     /*  446777 */   // Label 7729: @446777
     /*  446777 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(446863), // Rule ID 6513 //
     /*  446782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  446793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  446796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  446799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446829 */     // MIs[1] Operand 1
     /*  446829 */     // No operand predicates
     /*  446829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  446838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446861 */     GIR_RootConstrainSelectedInstOperands,
     /*  446862 */     // GIR_Coverage, 6513,
     /*  446862 */     GIR_EraseRootFromParent_Done,
     /*  446863 */   // Label 7730: @446863
     /*  446863 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(446949), // Rule ID 6516 //
     /*  446868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  446871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  446879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  446882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  446885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446915 */     // MIs[1] Operand 1
     /*  446915 */     // No operand predicates
     /*  446915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446924 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  446924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  446944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446947 */     GIR_RootConstrainSelectedInstOperands,
     /*  446948 */     // GIR_Coverage, 6516,
     /*  446948 */     GIR_EraseRootFromParent_Done,
     /*  446949 */   // Label 7731: @446949
     /*  446949 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(447035), // Rule ID 6517 //
     /*  446954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  446957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  446965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  446968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  446971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447001 */     // MIs[1] Operand 1
     /*  447001 */     // No operand predicates
     /*  447001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447010 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  447010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  447030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447033 */     GIR_RootConstrainSelectedInstOperands,
     /*  447034 */     // GIR_Coverage, 6517,
     /*  447034 */     GIR_EraseRootFromParent_Done,
     /*  447035 */   // Label 7732: @447035
     /*  447035 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(447121), // Rule ID 6520 //
     /*  447040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  447051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  447054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  447057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447087 */     // MIs[1] Operand 1
     /*  447087 */     // No operand predicates
     /*  447087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447096 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447119 */     GIR_RootConstrainSelectedInstOperands,
     /*  447120 */     // GIR_Coverage, 6520,
     /*  447120 */     GIR_EraseRootFromParent_Done,
     /*  447121 */   // Label 7733: @447121
     /*  447121 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(447207), // Rule ID 6521 //
     /*  447126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  447137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  447140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  447143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447173 */     // MIs[1] Operand 1
     /*  447173 */     // No operand predicates
     /*  447173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447182 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447205 */     GIR_RootConstrainSelectedInstOperands,
     /*  447206 */     // GIR_Coverage, 6521,
     /*  447206 */     GIR_EraseRootFromParent_Done,
     /*  447207 */   // Label 7734: @447207
     /*  447207 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(447293), // Rule ID 6524 //
     /*  447212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  447223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  447226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  447229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447259 */     // MIs[1] Operand 1
     /*  447259 */     // No operand predicates
     /*  447259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447268 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447291 */     GIR_RootConstrainSelectedInstOperands,
     /*  447292 */     // GIR_Coverage, 6524,
     /*  447292 */     GIR_EraseRootFromParent_Done,
     /*  447293 */   // Label 7735: @447293
     /*  447293 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(447379), // Rule ID 6525 //
     /*  447298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  447309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  447312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  447315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447345 */     // MIs[1] Operand 1
     /*  447345 */     // No operand predicates
     /*  447345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447354 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447377 */     GIR_RootConstrainSelectedInstOperands,
     /*  447378 */     // GIR_Coverage, 6525,
     /*  447378 */     GIR_EraseRootFromParent_Done,
     /*  447379 */   // Label 7736: @447379
     /*  447379 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(447465), // Rule ID 6528 //
     /*  447384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  447395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  447398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  447401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447431 */     // MIs[1] Operand 1
     /*  447431 */     // No operand predicates
     /*  447431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447440 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447463 */     GIR_RootConstrainSelectedInstOperands,
     /*  447464 */     // GIR_Coverage, 6528,
     /*  447464 */     GIR_EraseRootFromParent_Done,
     /*  447465 */   // Label 7737: @447465
     /*  447465 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(447551), // Rule ID 6529 //
     /*  447470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  447481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  447484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  447487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447517 */     // MIs[1] Operand 1
     /*  447517 */     // No operand predicates
     /*  447517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447526 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447549 */     GIR_RootConstrainSelectedInstOperands,
     /*  447550 */     // GIR_Coverage, 6529,
     /*  447550 */     GIR_EraseRootFromParent_Done,
     /*  447551 */   // Label 7738: @447551
     /*  447551 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(447637), // Rule ID 6532 //
     /*  447556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  447567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  447570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  447573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447603 */     // MIs[1] Operand 1
     /*  447603 */     // No operand predicates
     /*  447603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447612 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447635 */     GIR_RootConstrainSelectedInstOperands,
     /*  447636 */     // GIR_Coverage, 6532,
     /*  447636 */     GIR_EraseRootFromParent_Done,
     /*  447637 */   // Label 7739: @447637
     /*  447637 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(447723), // Rule ID 6533 //
     /*  447642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  447653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  447656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  447659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447689 */     // MIs[1] Operand 1
     /*  447689 */     // No operand predicates
     /*  447689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447698 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  447698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447721 */     GIR_RootConstrainSelectedInstOperands,
     /*  447722 */     // GIR_Coverage, 6533,
     /*  447722 */     GIR_EraseRootFromParent_Done,
     /*  447723 */   // Label 7740: @447723
     /*  447723 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(447809), // Rule ID 6536 //
     /*  447728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  447739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  447742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  447745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447775 */     // MIs[1] Operand 1
     /*  447775 */     // No operand predicates
     /*  447775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447784 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447807 */     GIR_RootConstrainSelectedInstOperands,
     /*  447808 */     // GIR_Coverage, 6536,
     /*  447808 */     GIR_EraseRootFromParent_Done,
     /*  447809 */   // Label 7741: @447809
     /*  447809 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(447895), // Rule ID 6537 //
     /*  447814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  447825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  447828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  447831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447861 */     // MIs[1] Operand 1
     /*  447861 */     // No operand predicates
     /*  447861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447870 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  447870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447893 */     GIR_RootConstrainSelectedInstOperands,
     /*  447894 */     // GIR_Coverage, 6537,
     /*  447894 */     GIR_EraseRootFromParent_Done,
     /*  447895 */   // Label 7742: @447895
     /*  447895 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(447981), // Rule ID 6540 //
     /*  447900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  447911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  447914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  447917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447947 */     // MIs[1] Operand 1
     /*  447947 */     // No operand predicates
     /*  447947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447956 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447979 */     GIR_RootConstrainSelectedInstOperands,
     /*  447980 */     // GIR_Coverage, 6540,
     /*  447980 */     GIR_EraseRootFromParent_Done,
     /*  447981 */   // Label 7743: @447981
     /*  447981 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(448067), // Rule ID 6541 //
     /*  447986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  447997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  448000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  448003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448033 */     // MIs[1] Operand 1
     /*  448033 */     // No operand predicates
     /*  448033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448042 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448065 */     GIR_RootConstrainSelectedInstOperands,
     /*  448066 */     // GIR_Coverage, 6541,
     /*  448066 */     GIR_EraseRootFromParent_Done,
     /*  448067 */   // Label 7744: @448067
     /*  448067 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(448153), // Rule ID 6544 //
     /*  448072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  448089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448119 */     // MIs[1] Operand 1
     /*  448119 */     // No operand predicates
     /*  448119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448128 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448151 */     GIR_RootConstrainSelectedInstOperands,
     /*  448152 */     // GIR_Coverage, 6544,
     /*  448152 */     GIR_EraseRootFromParent_Done,
     /*  448153 */   // Label 7745: @448153
     /*  448153 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(448239), // Rule ID 6545 //
     /*  448158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  448175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448205 */     // MIs[1] Operand 1
     /*  448205 */     // No operand predicates
     /*  448205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448237 */     GIR_RootConstrainSelectedInstOperands,
     /*  448238 */     // GIR_Coverage, 6545,
     /*  448238 */     GIR_EraseRootFromParent_Done,
     /*  448239 */   // Label 7746: @448239
     /*  448239 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(448325), // Rule ID 6548 //
     /*  448244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  448261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448291 */     // MIs[1] Operand 1
     /*  448291 */     // No operand predicates
     /*  448291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448300 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448323 */     GIR_RootConstrainSelectedInstOperands,
     /*  448324 */     // GIR_Coverage, 6548,
     /*  448324 */     GIR_EraseRootFromParent_Done,
     /*  448325 */   // Label 7747: @448325
     /*  448325 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(448411), // Rule ID 6549 //
     /*  448330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  448347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448377 */     // MIs[1] Operand 1
     /*  448377 */     // No operand predicates
     /*  448377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448386 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448409 */     GIR_RootConstrainSelectedInstOperands,
     /*  448410 */     // GIR_Coverage, 6549,
     /*  448410 */     GIR_EraseRootFromParent_Done,
     /*  448411 */   // Label 7748: @448411
     /*  448411 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(448497), // Rule ID 6552 //
     /*  448416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  448433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448463 */     // MIs[1] Operand 1
     /*  448463 */     // No operand predicates
     /*  448463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448472 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448495 */     GIR_RootConstrainSelectedInstOperands,
     /*  448496 */     // GIR_Coverage, 6552,
     /*  448496 */     GIR_EraseRootFromParent_Done,
     /*  448497 */   // Label 7749: @448497
     /*  448497 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(448583), // Rule ID 6553 //
     /*  448502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  448519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448549 */     // MIs[1] Operand 1
     /*  448549 */     // No operand predicates
     /*  448549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448558 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448581 */     GIR_RootConstrainSelectedInstOperands,
     /*  448582 */     // GIR_Coverage, 6553,
     /*  448582 */     GIR_EraseRootFromParent_Done,
     /*  448583 */   // Label 7750: @448583
     /*  448583 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(448669), // Rule ID 6556 //
     /*  448588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  448599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  448602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  448605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448635 */     // MIs[1] Operand 1
     /*  448635 */     // No operand predicates
     /*  448635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448644 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  448644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448667 */     GIR_RootConstrainSelectedInstOperands,
     /*  448668 */     // GIR_Coverage, 6556,
     /*  448668 */     GIR_EraseRootFromParent_Done,
     /*  448669 */   // Label 7751: @448669
     /*  448669 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(448755), // Rule ID 6557 //
     /*  448674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  448677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  448685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  448688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  448691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448721 */     // MIs[1] Operand 1
     /*  448721 */     // No operand predicates
     /*  448721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448730 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  448730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448753 */     GIR_RootConstrainSelectedInstOperands,
     /*  448754 */     // GIR_Coverage, 6557,
     /*  448754 */     GIR_EraseRootFromParent_Done,
     /*  448755 */   // Label 7752: @448755
     /*  448755 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(448841), // Rule ID 6560 //
     /*  448760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  448771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  448774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  448777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448807 */     // MIs[1] Operand 1
     /*  448807 */     // No operand predicates
     /*  448807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448816 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  448816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448839 */     GIR_RootConstrainSelectedInstOperands,
     /*  448840 */     // GIR_Coverage, 6560,
     /*  448840 */     GIR_EraseRootFromParent_Done,
     /*  448841 */   // Label 7753: @448841
     /*  448841 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(448927), // Rule ID 6561 //
     /*  448846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  448849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  448857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  448860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  448863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448893 */     // MIs[1] Operand 1
     /*  448893 */     // No operand predicates
     /*  448893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448902 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  448902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448925 */     GIR_RootConstrainSelectedInstOperands,
     /*  448926 */     // GIR_Coverage, 6561,
     /*  448926 */     GIR_EraseRootFromParent_Done,
     /*  448927 */   // Label 7754: @448927
     /*  448927 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(449013), // Rule ID 6564 //
     /*  448932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  448943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  448946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  448949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448979 */     // MIs[1] Operand 1
     /*  448979 */     // No operand predicates
     /*  448979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448988 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  448988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449011 */     GIR_RootConstrainSelectedInstOperands,
     /*  449012 */     // GIR_Coverage, 6564,
     /*  449012 */     GIR_EraseRootFromParent_Done,
     /*  449013 */   // Label 7755: @449013
     /*  449013 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(449099), // Rule ID 6565 //
     /*  449018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  449021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  449029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  449032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  449035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449065 */     // MIs[1] Operand 1
     /*  449065 */     // No operand predicates
     /*  449065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449074 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  449074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  449077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449097 */     GIR_RootConstrainSelectedInstOperands,
     /*  449098 */     // GIR_Coverage, 6565,
     /*  449098 */     GIR_EraseRootFromParent_Done,
     /*  449099 */   // Label 7756: @449099
     /*  449099 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(449185), // Rule ID 6744 //
     /*  449104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  449115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  449118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  449121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449151 */     // MIs[1] Operand 1
     /*  449151 */     // No operand predicates
     /*  449151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449160 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  449163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449183 */     GIR_RootConstrainSelectedInstOperands,
     /*  449184 */     // GIR_Coverage, 6744,
     /*  449184 */     GIR_EraseRootFromParent_Done,
     /*  449185 */   // Label 7757: @449185
     /*  449185 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(449271), // Rule ID 6745 //
     /*  449190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  449201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  449204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  449207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449237 */     // MIs[1] Operand 1
     /*  449237 */     // No operand predicates
     /*  449237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449246 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  449249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449269 */     GIR_RootConstrainSelectedInstOperands,
     /*  449270 */     // GIR_Coverage, 6745,
     /*  449270 */     GIR_EraseRootFromParent_Done,
     /*  449271 */   // Label 7758: @449271
     /*  449271 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(449357), // Rule ID 6748 //
     /*  449276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  449287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  449290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  449293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449323 */     // MIs[1] Operand 1
     /*  449323 */     // No operand predicates
     /*  449323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449332 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449355 */     GIR_RootConstrainSelectedInstOperands,
     /*  449356 */     // GIR_Coverage, 6748,
     /*  449356 */     GIR_EraseRootFromParent_Done,
     /*  449357 */   // Label 7759: @449357
     /*  449357 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(449443), // Rule ID 6749 //
     /*  449362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  449373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  449376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  449379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449409 */     // MIs[1] Operand 1
     /*  449409 */     // No operand predicates
     /*  449409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449418 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449441 */     GIR_RootConstrainSelectedInstOperands,
     /*  449442 */     // GIR_Coverage, 6749,
     /*  449442 */     GIR_EraseRootFromParent_Done,
     /*  449443 */   // Label 7760: @449443
     /*  449443 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(449529), // Rule ID 6752 //
     /*  449448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  449459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  449462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  449465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449495 */     // MIs[1] Operand 1
     /*  449495 */     // No operand predicates
     /*  449495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449504 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449527 */     GIR_RootConstrainSelectedInstOperands,
     /*  449528 */     // GIR_Coverage, 6752,
     /*  449528 */     GIR_EraseRootFromParent_Done,
     /*  449529 */   // Label 7761: @449529
     /*  449529 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(449615), // Rule ID 6753 //
     /*  449534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  449545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  449548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  449551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449581 */     // MIs[1] Operand 1
     /*  449581 */     // No operand predicates
     /*  449581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449590 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449613 */     GIR_RootConstrainSelectedInstOperands,
     /*  449614 */     // GIR_Coverage, 6753,
     /*  449614 */     GIR_EraseRootFromParent_Done,
     /*  449615 */   // Label 7762: @449615
     /*  449615 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(449701), // Rule ID 6756 //
     /*  449620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  449631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  449634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  449637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449667 */     // MIs[1] Operand 1
     /*  449667 */     // No operand predicates
     /*  449667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449676 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  449676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449699 */     GIR_RootConstrainSelectedInstOperands,
     /*  449700 */     // GIR_Coverage, 6756,
     /*  449700 */     GIR_EraseRootFromParent_Done,
     /*  449701 */   // Label 7763: @449701
     /*  449701 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(449787), // Rule ID 6757 //
     /*  449706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  449717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  449720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  449723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449753 */     // MIs[1] Operand 1
     /*  449753 */     // No operand predicates
     /*  449753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449762 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  449762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449785 */     GIR_RootConstrainSelectedInstOperands,
     /*  449786 */     // GIR_Coverage, 6757,
     /*  449786 */     GIR_EraseRootFromParent_Done,
     /*  449787 */   // Label 7764: @449787
     /*  449787 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(449873), // Rule ID 6760 //
     /*  449792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  449803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  449806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  449809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449839 */     // MIs[1] Operand 1
     /*  449839 */     // No operand predicates
     /*  449839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449848 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  449848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449871 */     GIR_RootConstrainSelectedInstOperands,
     /*  449872 */     // GIR_Coverage, 6760,
     /*  449872 */     GIR_EraseRootFromParent_Done,
     /*  449873 */   // Label 7765: @449873
     /*  449873 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(449959), // Rule ID 6761 //
     /*  449878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  449889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  449892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  449895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449925 */     // MIs[1] Operand 1
     /*  449925 */     // No operand predicates
     /*  449925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449934 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  449934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449957 */     GIR_RootConstrainSelectedInstOperands,
     /*  449958 */     // GIR_Coverage, 6761,
     /*  449958 */     GIR_EraseRootFromParent_Done,
     /*  449959 */   // Label 7766: @449959
     /*  449959 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(450045), // Rule ID 6764 //
     /*  449964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  449975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  449978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  449981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450011 */     // MIs[1] Operand 1
     /*  450011 */     // No operand predicates
     /*  450011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450020 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  450020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450043 */     GIR_RootConstrainSelectedInstOperands,
     /*  450044 */     // GIR_Coverage, 6764,
     /*  450044 */     GIR_EraseRootFromParent_Done,
     /*  450045 */   // Label 7767: @450045
     /*  450045 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(450131), // Rule ID 6765 //
     /*  450050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  450061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  450064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  450067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450097 */     // MIs[1] Operand 1
     /*  450097 */     // No operand predicates
     /*  450097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450106 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  450106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450129 */     GIR_RootConstrainSelectedInstOperands,
     /*  450130 */     // GIR_Coverage, 6765,
     /*  450130 */     GIR_EraseRootFromParent_Done,
     /*  450131 */   // Label 7768: @450131
     /*  450131 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(450217), // Rule ID 6768 //
     /*  450136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  450147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  450150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  450153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450183 */     // MIs[1] Operand 1
     /*  450183 */     // No operand predicates
     /*  450183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450192 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450215 */     GIR_RootConstrainSelectedInstOperands,
     /*  450216 */     // GIR_Coverage, 6768,
     /*  450216 */     GIR_EraseRootFromParent_Done,
     /*  450217 */   // Label 7769: @450217
     /*  450217 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(450303), // Rule ID 6769 //
     /*  450222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  450233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  450236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  450239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450269 */     // MIs[1] Operand 1
     /*  450269 */     // No operand predicates
     /*  450269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450278 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450301 */     GIR_RootConstrainSelectedInstOperands,
     /*  450302 */     // GIR_Coverage, 6769,
     /*  450302 */     GIR_EraseRootFromParent_Done,
     /*  450303 */   // Label 7770: @450303
     /*  450303 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(450389), // Rule ID 6772 //
     /*  450308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  450319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  450322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  450325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450355 */     // MIs[1] Operand 1
     /*  450355 */     // No operand predicates
     /*  450355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450364 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450387 */     GIR_RootConstrainSelectedInstOperands,
     /*  450388 */     // GIR_Coverage, 6772,
     /*  450388 */     GIR_EraseRootFromParent_Done,
     /*  450389 */   // Label 7771: @450389
     /*  450389 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(450475), // Rule ID 6773 //
     /*  450394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  450405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  450408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  450411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450441 */     // MIs[1] Operand 1
     /*  450441 */     // No operand predicates
     /*  450441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450450 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450473 */     GIR_RootConstrainSelectedInstOperands,
     /*  450474 */     // GIR_Coverage, 6773,
     /*  450474 */     GIR_EraseRootFromParent_Done,
     /*  450475 */   // Label 7772: @450475
     /*  450475 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(450561), // Rule ID 6776 //
     /*  450480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  450491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  450494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  450497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450527 */     // MIs[1] Operand 1
     /*  450527 */     // No operand predicates
     /*  450527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  450536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450559 */     GIR_RootConstrainSelectedInstOperands,
     /*  450560 */     // GIR_Coverage, 6776,
     /*  450560 */     GIR_EraseRootFromParent_Done,
     /*  450561 */   // Label 7773: @450561
     /*  450561 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(450647), // Rule ID 6777 //
     /*  450566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  450577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  450580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  450583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450613 */     // MIs[1] Operand 1
     /*  450613 */     // No operand predicates
     /*  450613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450622 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  450622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450645 */     GIR_RootConstrainSelectedInstOperands,
     /*  450646 */     // GIR_Coverage, 6777,
     /*  450646 */     GIR_EraseRootFromParent_Done,
     /*  450647 */   // Label 7774: @450647
     /*  450647 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(450733), // Rule ID 6780 //
     /*  450652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  450655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  450663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  450666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  450669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450699 */     // MIs[1] Operand 1
     /*  450699 */     // No operand predicates
     /*  450699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450708 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  450708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  450728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450731 */     GIR_RootConstrainSelectedInstOperands,
     /*  450732 */     // GIR_Coverage, 6780,
     /*  450732 */     GIR_EraseRootFromParent_Done,
     /*  450733 */   // Label 7775: @450733
     /*  450733 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(450819), // Rule ID 6781 //
     /*  450738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  450741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  450749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  450752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  450755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450785 */     // MIs[1] Operand 1
     /*  450785 */     // No operand predicates
     /*  450785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450794 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  450794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  450814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450817 */     GIR_RootConstrainSelectedInstOperands,
     /*  450818 */     // GIR_Coverage, 6781,
     /*  450818 */     GIR_EraseRootFromParent_Done,
     /*  450819 */   // Label 7776: @450819
     /*  450819 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(450905), // Rule ID 6784 //
     /*  450824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  450835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  450838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  450841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450871 */     // MIs[1] Operand 1
     /*  450871 */     // No operand predicates
     /*  450871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450880 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  450883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450903 */     GIR_RootConstrainSelectedInstOperands,
     /*  450904 */     // GIR_Coverage, 6784,
     /*  450904 */     GIR_EraseRootFromParent_Done,
     /*  450905 */   // Label 7777: @450905
     /*  450905 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(450991), // Rule ID 6785 //
     /*  450910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  450921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  450924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  450927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450957 */     // MIs[1] Operand 1
     /*  450957 */     // No operand predicates
     /*  450957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450966 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  450969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450989 */     GIR_RootConstrainSelectedInstOperands,
     /*  450990 */     // GIR_Coverage, 6785,
     /*  450990 */     GIR_EraseRootFromParent_Done,
     /*  450991 */   // Label 7778: @450991
     /*  450991 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(451077), // Rule ID 6788 //
     /*  450996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  451007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  451010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  451013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451043 */     // MIs[1] Operand 1
     /*  451043 */     // No operand predicates
     /*  451043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451052 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451075 */     GIR_RootConstrainSelectedInstOperands,
     /*  451076 */     // GIR_Coverage, 6788,
     /*  451076 */     GIR_EraseRootFromParent_Done,
     /*  451077 */   // Label 7779: @451077
     /*  451077 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(451163), // Rule ID 6789 //
     /*  451082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  451093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  451096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  451099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451129 */     // MIs[1] Operand 1
     /*  451129 */     // No operand predicates
     /*  451129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451138 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451161 */     GIR_RootConstrainSelectedInstOperands,
     /*  451162 */     // GIR_Coverage, 6789,
     /*  451162 */     GIR_EraseRootFromParent_Done,
     /*  451163 */   // Label 7780: @451163
     /*  451163 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(451249), // Rule ID 6792 //
     /*  451168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  451179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  451182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  451185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451215 */     // MIs[1] Operand 1
     /*  451215 */     // No operand predicates
     /*  451215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451224 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451247 */     GIR_RootConstrainSelectedInstOperands,
     /*  451248 */     // GIR_Coverage, 6792,
     /*  451248 */     GIR_EraseRootFromParent_Done,
     /*  451249 */   // Label 7781: @451249
     /*  451249 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(451335), // Rule ID 6793 //
     /*  451254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  451265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  451268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  451271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451301 */     // MIs[1] Operand 1
     /*  451301 */     // No operand predicates
     /*  451301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451310 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451333 */     GIR_RootConstrainSelectedInstOperands,
     /*  451334 */     // GIR_Coverage, 6793,
     /*  451334 */     GIR_EraseRootFromParent_Done,
     /*  451335 */   // Label 7782: @451335
     /*  451335 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(451421), // Rule ID 6796 //
     /*  451340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  451351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  451354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  451357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451387 */     // MIs[1] Operand 1
     /*  451387 */     // No operand predicates
     /*  451387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451419 */     GIR_RootConstrainSelectedInstOperands,
     /*  451420 */     // GIR_Coverage, 6796,
     /*  451420 */     GIR_EraseRootFromParent_Done,
     /*  451421 */   // Label 7783: @451421
     /*  451421 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(451507), // Rule ID 6797 //
     /*  451426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  451437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  451440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  451443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451473 */     // MIs[1] Operand 1
     /*  451473 */     // No operand predicates
     /*  451473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451505 */     GIR_RootConstrainSelectedInstOperands,
     /*  451506 */     // GIR_Coverage, 6797,
     /*  451506 */     GIR_EraseRootFromParent_Done,
     /*  451507 */   // Label 7784: @451507
     /*  451507 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(451593), // Rule ID 6800 //
     /*  451512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  451523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  451526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  451529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451559 */     // MIs[1] Operand 1
     /*  451559 */     // No operand predicates
     /*  451559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451568 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451591 */     GIR_RootConstrainSelectedInstOperands,
     /*  451592 */     // GIR_Coverage, 6800,
     /*  451592 */     GIR_EraseRootFromParent_Done,
     /*  451593 */   // Label 7785: @451593
     /*  451593 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(451679), // Rule ID 6801 //
     /*  451598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  451609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  451612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  451615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451645 */     // MIs[1] Operand 1
     /*  451645 */     // No operand predicates
     /*  451645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451654 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451677 */     GIR_RootConstrainSelectedInstOperands,
     /*  451678 */     // GIR_Coverage, 6801,
     /*  451678 */     GIR_EraseRootFromParent_Done,
     /*  451679 */   // Label 7786: @451679
     /*  451679 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(451765), // Rule ID 6804 //
     /*  451684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  451695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  451698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  451701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451731 */     // MIs[1] Operand 1
     /*  451731 */     // No operand predicates
     /*  451731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451740 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451763 */     GIR_RootConstrainSelectedInstOperands,
     /*  451764 */     // GIR_Coverage, 6804,
     /*  451764 */     GIR_EraseRootFromParent_Done,
     /*  451765 */   // Label 7787: @451765
     /*  451765 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(451851), // Rule ID 6805 //
     /*  451770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  451781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  451784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  451787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451817 */     // MIs[1] Operand 1
     /*  451817 */     // No operand predicates
     /*  451817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451826 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451849 */     GIR_RootConstrainSelectedInstOperands,
     /*  451850 */     // GIR_Coverage, 6805,
     /*  451850 */     GIR_EraseRootFromParent_Done,
     /*  451851 */   // Label 7788: @451851
     /*  451851 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(451937), // Rule ID 6808 //
     /*  451856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  451867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  451870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  451873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451903 */     // MIs[1] Operand 1
     /*  451903 */     // No operand predicates
     /*  451903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  451912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451935 */     GIR_RootConstrainSelectedInstOperands,
     /*  451936 */     // GIR_Coverage, 6808,
     /*  451936 */     GIR_EraseRootFromParent_Done,
     /*  451937 */   // Label 7789: @451937
     /*  451937 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(452023), // Rule ID 6809 //
     /*  451942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  451953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  451956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  451959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451989 */     // MIs[1] Operand 1
     /*  451989 */     // No operand predicates
     /*  451989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  451998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  452001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452021 */     GIR_RootConstrainSelectedInstOperands,
     /*  452022 */     // GIR_Coverage, 6809,
     /*  452022 */     GIR_EraseRootFromParent_Done,
     /*  452023 */   // Label 7790: @452023
     /*  452023 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(452109), // Rule ID 6812 //
     /*  452028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  452039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  452042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  452045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452075 */     // MIs[1] Operand 1
     /*  452075 */     // No operand predicates
     /*  452075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452084 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452107 */     GIR_RootConstrainSelectedInstOperands,
     /*  452108 */     // GIR_Coverage, 6812,
     /*  452108 */     GIR_EraseRootFromParent_Done,
     /*  452109 */   // Label 7791: @452109
     /*  452109 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(452195), // Rule ID 6813 //
     /*  452114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  452125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  452128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  452131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452161 */     // MIs[1] Operand 1
     /*  452161 */     // No operand predicates
     /*  452161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452170 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452193 */     GIR_RootConstrainSelectedInstOperands,
     /*  452194 */     // GIR_Coverage, 6813,
     /*  452194 */     GIR_EraseRootFromParent_Done,
     /*  452195 */   // Label 7792: @452195
     /*  452195 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(452281), // Rule ID 6816 //
     /*  452200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  452211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  452214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  452217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452247 */     // MIs[1] Operand 1
     /*  452247 */     // No operand predicates
     /*  452247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452256 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452279 */     GIR_RootConstrainSelectedInstOperands,
     /*  452280 */     // GIR_Coverage, 6816,
     /*  452280 */     GIR_EraseRootFromParent_Done,
     /*  452281 */   // Label 7793: @452281
     /*  452281 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(452367), // Rule ID 6817 //
     /*  452286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  452297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  452300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  452303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452333 */     // MIs[1] Operand 1
     /*  452333 */     // No operand predicates
     /*  452333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452342 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452365 */     GIR_RootConstrainSelectedInstOperands,
     /*  452366 */     // GIR_Coverage, 6817,
     /*  452366 */     GIR_EraseRootFromParent_Done,
     /*  452367 */   // Label 7794: @452367
     /*  452367 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(452453), // Rule ID 6820 //
     /*  452372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  452383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  452386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  452389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452419 */     // MIs[1] Operand 1
     /*  452419 */     // No operand predicates
     /*  452419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452428 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  452431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452451 */     GIR_RootConstrainSelectedInstOperands,
     /*  452452 */     // GIR_Coverage, 6820,
     /*  452452 */     GIR_EraseRootFromParent_Done,
     /*  452453 */   // Label 7795: @452453
     /*  452453 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(452539), // Rule ID 6821 //
     /*  452458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  452469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  452472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  452475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452505 */     // MIs[1] Operand 1
     /*  452505 */     // No operand predicates
     /*  452505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452514 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  452517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452537 */     GIR_RootConstrainSelectedInstOperands,
     /*  452538 */     // GIR_Coverage, 6821,
     /*  452538 */     GIR_EraseRootFromParent_Done,
     /*  452539 */   // Label 7796: @452539
     /*  452539 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(452625), // Rule ID 6824 //
     /*  452544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  452555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  452558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  452561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452591 */     // MIs[1] Operand 1
     /*  452591 */     // No operand predicates
     /*  452591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452600 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452623 */     GIR_RootConstrainSelectedInstOperands,
     /*  452624 */     // GIR_Coverage, 6824,
     /*  452624 */     GIR_EraseRootFromParent_Done,
     /*  452625 */   // Label 7797: @452625
     /*  452625 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(452711), // Rule ID 6825 //
     /*  452630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  452641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  452644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  452647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452677 */     // MIs[1] Operand 1
     /*  452677 */     // No operand predicates
     /*  452677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452686 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452709 */     GIR_RootConstrainSelectedInstOperands,
     /*  452710 */     // GIR_Coverage, 6825,
     /*  452710 */     GIR_EraseRootFromParent_Done,
     /*  452711 */   // Label 7798: @452711
     /*  452711 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(452797), // Rule ID 6828 //
     /*  452716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  452727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  452730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  452733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452763 */     // MIs[1] Operand 1
     /*  452763 */     // No operand predicates
     /*  452763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452772 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452795 */     GIR_RootConstrainSelectedInstOperands,
     /*  452796 */     // GIR_Coverage, 6828,
     /*  452796 */     GIR_EraseRootFromParent_Done,
     /*  452797 */   // Label 7799: @452797
     /*  452797 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(452883), // Rule ID 6829 //
     /*  452802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  452813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  452816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  452819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452849 */     // MIs[1] Operand 1
     /*  452849 */     // No operand predicates
     /*  452849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452858 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452881 */     GIR_RootConstrainSelectedInstOperands,
     /*  452882 */     // GIR_Coverage, 6829,
     /*  452882 */     GIR_EraseRootFromParent_Done,
     /*  452883 */   // Label 7800: @452883
     /*  452883 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(452969), // Rule ID 7008 //
     /*  452888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  452896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  452899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452935 */     // MIs[1] Operand 1
     /*  452935 */     // No operand predicates
     /*  452935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452944 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  452944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  452947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452967 */     GIR_RootConstrainSelectedInstOperands,
     /*  452968 */     // GIR_Coverage, 7008,
     /*  452968 */     GIR_EraseRootFromParent_Done,
     /*  452969 */   // Label 7801: @452969
     /*  452969 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(453055), // Rule ID 7009 //
     /*  452974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  452982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  452985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453021 */     // MIs[1] Operand 1
     /*  453021 */     // No operand predicates
     /*  453021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453030 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  453033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453053 */     GIR_RootConstrainSelectedInstOperands,
     /*  453054 */     // GIR_Coverage, 7009,
     /*  453054 */     GIR_EraseRootFromParent_Done,
     /*  453055 */   // Label 7802: @453055
     /*  453055 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(453141), // Rule ID 7012 //
     /*  453060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  453071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  453074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  453077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453107 */     // MIs[1] Operand 1
     /*  453107 */     // No operand predicates
     /*  453107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453116 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453139 */     GIR_RootConstrainSelectedInstOperands,
     /*  453140 */     // GIR_Coverage, 7012,
     /*  453140 */     GIR_EraseRootFromParent_Done,
     /*  453141 */   // Label 7803: @453141
     /*  453141 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(453227), // Rule ID 7013 //
     /*  453146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  453157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  453160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  453163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453193 */     // MIs[1] Operand 1
     /*  453193 */     // No operand predicates
     /*  453193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453202 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453225 */     GIR_RootConstrainSelectedInstOperands,
     /*  453226 */     // GIR_Coverage, 7013,
     /*  453226 */     GIR_EraseRootFromParent_Done,
     /*  453227 */   // Label 7804: @453227
     /*  453227 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(453313), // Rule ID 7016 //
     /*  453232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  453243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  453246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  453249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453279 */     // MIs[1] Operand 1
     /*  453279 */     // No operand predicates
     /*  453279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453288 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453311 */     GIR_RootConstrainSelectedInstOperands,
     /*  453312 */     // GIR_Coverage, 7016,
     /*  453312 */     GIR_EraseRootFromParent_Done,
     /*  453313 */   // Label 7805: @453313
     /*  453313 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(453399), // Rule ID 7017 //
     /*  453318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  453329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  453332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  453335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453365 */     // MIs[1] Operand 1
     /*  453365 */     // No operand predicates
     /*  453365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453374 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453397 */     GIR_RootConstrainSelectedInstOperands,
     /*  453398 */     // GIR_Coverage, 7017,
     /*  453398 */     GIR_EraseRootFromParent_Done,
     /*  453399 */   // Label 7806: @453399
     /*  453399 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(453485), // Rule ID 7020 //
     /*  453404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453451 */     // MIs[1] Operand 1
     /*  453451 */     // No operand predicates
     /*  453451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453460 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453483 */     GIR_RootConstrainSelectedInstOperands,
     /*  453484 */     // GIR_Coverage, 7020,
     /*  453484 */     GIR_EraseRootFromParent_Done,
     /*  453485 */   // Label 7807: @453485
     /*  453485 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(453571), // Rule ID 7021 //
     /*  453490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453537 */     // MIs[1] Operand 1
     /*  453537 */     // No operand predicates
     /*  453537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453569 */     GIR_RootConstrainSelectedInstOperands,
     /*  453570 */     // GIR_Coverage, 7021,
     /*  453570 */     GIR_EraseRootFromParent_Done,
     /*  453571 */   // Label 7808: @453571
     /*  453571 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(453657), // Rule ID 7024 //
     /*  453576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  453587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  453590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  453593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453623 */     // MIs[1] Operand 1
     /*  453623 */     // No operand predicates
     /*  453623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453632 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453655 */     GIR_RootConstrainSelectedInstOperands,
     /*  453656 */     // GIR_Coverage, 7024,
     /*  453656 */     GIR_EraseRootFromParent_Done,
     /*  453657 */   // Label 7809: @453657
     /*  453657 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(453743), // Rule ID 7025 //
     /*  453662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  453673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  453676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  453679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453709 */     // MIs[1] Operand 1
     /*  453709 */     // No operand predicates
     /*  453709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453741 */     GIR_RootConstrainSelectedInstOperands,
     /*  453742 */     // GIR_Coverage, 7025,
     /*  453742 */     GIR_EraseRootFromParent_Done,
     /*  453743 */   // Label 7810: @453743
     /*  453743 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(453829), // Rule ID 7028 //
     /*  453748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  453759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  453762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  453765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453795 */     // MIs[1] Operand 1
     /*  453795 */     // No operand predicates
     /*  453795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453804 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  453804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453827 */     GIR_RootConstrainSelectedInstOperands,
     /*  453828 */     // GIR_Coverage, 7028,
     /*  453828 */     GIR_EraseRootFromParent_Done,
     /*  453829 */   // Label 7811: @453829
     /*  453829 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(453915), // Rule ID 7029 //
     /*  453834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  453845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  453848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  453851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453881 */     // MIs[1] Operand 1
     /*  453881 */     // No operand predicates
     /*  453881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453890 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  453890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453913 */     GIR_RootConstrainSelectedInstOperands,
     /*  453914 */     // GIR_Coverage, 7029,
     /*  453914 */     GIR_EraseRootFromParent_Done,
     /*  453915 */   // Label 7812: @453915
     /*  453915 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(454001), // Rule ID 7032 //
     /*  453920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  453931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  453934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  453937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453967 */     // MIs[1] Operand 1
     /*  453967 */     // No operand predicates
     /*  453967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453976 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  453979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453999 */     GIR_RootConstrainSelectedInstOperands,
     /*  454000 */     // GIR_Coverage, 7032,
     /*  454000 */     GIR_EraseRootFromParent_Done,
     /*  454001 */   // Label 7813: @454001
     /*  454001 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(454087), // Rule ID 7033 //
     /*  454006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  454017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  454020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  454023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454053 */     // MIs[1] Operand 1
     /*  454053 */     // No operand predicates
     /*  454053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454062 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454085 */     GIR_RootConstrainSelectedInstOperands,
     /*  454086 */     // GIR_Coverage, 7033,
     /*  454086 */     GIR_EraseRootFromParent_Done,
     /*  454087 */   // Label 7814: @454087
     /*  454087 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(454173), // Rule ID 7036 //
     /*  454092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  454103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  454106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  454109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454139 */     // MIs[1] Operand 1
     /*  454139 */     // No operand predicates
     /*  454139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454148 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  454148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454171 */     GIR_RootConstrainSelectedInstOperands,
     /*  454172 */     // GIR_Coverage, 7036,
     /*  454172 */     GIR_EraseRootFromParent_Done,
     /*  454173 */   // Label 7815: @454173
     /*  454173 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(454259), // Rule ID 7037 //
     /*  454178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  454189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  454192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  454195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454225 */     // MIs[1] Operand 1
     /*  454225 */     // No operand predicates
     /*  454225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454234 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454257 */     GIR_RootConstrainSelectedInstOperands,
     /*  454258 */     // GIR_Coverage, 7037,
     /*  454258 */     GIR_EraseRootFromParent_Done,
     /*  454259 */   // Label 7816: @454259
     /*  454259 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(454345), // Rule ID 7040 //
     /*  454264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  454275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  454278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  454281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454311 */     // MIs[1] Operand 1
     /*  454311 */     // No operand predicates
     /*  454311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  454320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454343 */     GIR_RootConstrainSelectedInstOperands,
     /*  454344 */     // GIR_Coverage, 7040,
     /*  454344 */     GIR_EraseRootFromParent_Done,
     /*  454345 */   // Label 7817: @454345
     /*  454345 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(454431), // Rule ID 7041 //
     /*  454350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  454361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  454364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  454367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454397 */     // MIs[1] Operand 1
     /*  454397 */     // No operand predicates
     /*  454397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454406 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  454406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454429 */     GIR_RootConstrainSelectedInstOperands,
     /*  454430 */     // GIR_Coverage, 7041,
     /*  454430 */     GIR_EraseRootFromParent_Done,
     /*  454431 */   // Label 7818: @454431
     /*  454431 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(454517), // Rule ID 7044 //
     /*  454436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  454439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  454453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454483 */     // MIs[1] Operand 1
     /*  454483 */     // No operand predicates
     /*  454483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454492 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  454492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  454512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454515 */     GIR_RootConstrainSelectedInstOperands,
     /*  454516 */     // GIR_Coverage, 7044,
     /*  454516 */     GIR_EraseRootFromParent_Done,
     /*  454517 */   // Label 7819: @454517
     /*  454517 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(454603), // Rule ID 7045 //
     /*  454522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  454525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  454539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454569 */     // MIs[1] Operand 1
     /*  454569 */     // No operand predicates
     /*  454569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454578 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  454578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  454598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454601 */     GIR_RootConstrainSelectedInstOperands,
     /*  454602 */     // GIR_Coverage, 7045,
     /*  454602 */     GIR_EraseRootFromParent_Done,
     /*  454603 */   // Label 7820: @454603
     /*  454603 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(454689), // Rule ID 7048 //
     /*  454608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  454619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  454622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  454625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454655 */     // MIs[1] Operand 1
     /*  454655 */     // No operand predicates
     /*  454655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454664 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  454667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454687 */     GIR_RootConstrainSelectedInstOperands,
     /*  454688 */     // GIR_Coverage, 7048,
     /*  454688 */     GIR_EraseRootFromParent_Done,
     /*  454689 */   // Label 7821: @454689
     /*  454689 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(454775), // Rule ID 7049 //
     /*  454694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  454705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  454708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  454711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454741 */     // MIs[1] Operand 1
     /*  454741 */     // No operand predicates
     /*  454741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454750 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  454753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454773 */     GIR_RootConstrainSelectedInstOperands,
     /*  454774 */     // GIR_Coverage, 7049,
     /*  454774 */     GIR_EraseRootFromParent_Done,
     /*  454775 */   // Label 7822: @454775
     /*  454775 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(454861), // Rule ID 7052 //
     /*  454780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  454791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  454794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  454797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454827 */     // MIs[1] Operand 1
     /*  454827 */     // No operand predicates
     /*  454827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454836 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  454839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454859 */     GIR_RootConstrainSelectedInstOperands,
     /*  454860 */     // GIR_Coverage, 7052,
     /*  454860 */     GIR_EraseRootFromParent_Done,
     /*  454861 */   // Label 7823: @454861
     /*  454861 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(454947), // Rule ID 7053 //
     /*  454866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  454877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  454880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  454883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454913 */     // MIs[1] Operand 1
     /*  454913 */     // No operand predicates
     /*  454913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454922 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  454925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454945 */     GIR_RootConstrainSelectedInstOperands,
     /*  454946 */     // GIR_Coverage, 7053,
     /*  454946 */     GIR_EraseRootFromParent_Done,
     /*  454947 */   // Label 7824: @454947
     /*  454947 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(455033), // Rule ID 7056 //
     /*  454952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  454963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  454966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  454969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454999 */     // MIs[1] Operand 1
     /*  454999 */     // No operand predicates
     /*  454999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455008 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  455008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455031 */     GIR_RootConstrainSelectedInstOperands,
     /*  455032 */     // GIR_Coverage, 7056,
     /*  455032 */     GIR_EraseRootFromParent_Done,
     /*  455033 */   // Label 7825: @455033
     /*  455033 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(455119), // Rule ID 7057 //
     /*  455038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  455049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  455052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  455055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455085 */     // MIs[1] Operand 1
     /*  455085 */     // No operand predicates
     /*  455085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455094 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  455094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455117 */     GIR_RootConstrainSelectedInstOperands,
     /*  455118 */     // GIR_Coverage, 7057,
     /*  455118 */     GIR_EraseRootFromParent_Done,
     /*  455119 */   // Label 7826: @455119
     /*  455119 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(455205), // Rule ID 7060 //
     /*  455124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  455135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  455138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  455141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455171 */     // MIs[1] Operand 1
     /*  455171 */     // No operand predicates
     /*  455171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455180 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455203 */     GIR_RootConstrainSelectedInstOperands,
     /*  455204 */     // GIR_Coverage, 7060,
     /*  455204 */     GIR_EraseRootFromParent_Done,
     /*  455205 */   // Label 7827: @455205
     /*  455205 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(455291), // Rule ID 7061 //
     /*  455210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  455221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  455224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  455227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455257 */     // MIs[1] Operand 1
     /*  455257 */     // No operand predicates
     /*  455257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455266 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455289 */     GIR_RootConstrainSelectedInstOperands,
     /*  455290 */     // GIR_Coverage, 7061,
     /*  455290 */     GIR_EraseRootFromParent_Done,
     /*  455291 */   // Label 7828: @455291
     /*  455291 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(455377), // Rule ID 7064 //
     /*  455296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  455307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  455310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  455313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455343 */     // MIs[1] Operand 1
     /*  455343 */     // No operand predicates
     /*  455343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455352 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455375 */     GIR_RootConstrainSelectedInstOperands,
     /*  455376 */     // GIR_Coverage, 7064,
     /*  455376 */     GIR_EraseRootFromParent_Done,
     /*  455377 */   // Label 7829: @455377
     /*  455377 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(455463), // Rule ID 7065 //
     /*  455382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  455393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  455396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  455399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455429 */     // MIs[1] Operand 1
     /*  455429 */     // No operand predicates
     /*  455429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455438 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455461 */     GIR_RootConstrainSelectedInstOperands,
     /*  455462 */     // GIR_Coverage, 7065,
     /*  455462 */     GIR_EraseRootFromParent_Done,
     /*  455463 */   // Label 7830: @455463
     /*  455463 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(455549), // Rule ID 7068 //
     /*  455468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  455479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  455482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  455485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455515 */     // MIs[1] Operand 1
     /*  455515 */     // No operand predicates
     /*  455515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455524 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455547 */     GIR_RootConstrainSelectedInstOperands,
     /*  455548 */     // GIR_Coverage, 7068,
     /*  455548 */     GIR_EraseRootFromParent_Done,
     /*  455549 */   // Label 7831: @455549
     /*  455549 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(455635), // Rule ID 7069 //
     /*  455554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  455565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  455568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  455571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455601 */     // MIs[1] Operand 1
     /*  455601 */     // No operand predicates
     /*  455601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455610 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455633 */     GIR_RootConstrainSelectedInstOperands,
     /*  455634 */     // GIR_Coverage, 7069,
     /*  455634 */     GIR_EraseRootFromParent_Done,
     /*  455635 */   // Label 7832: @455635
     /*  455635 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(455721), // Rule ID 7072 //
     /*  455640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  455651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  455654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  455657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455687 */     // MIs[1] Operand 1
     /*  455687 */     // No operand predicates
     /*  455687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455719 */     GIR_RootConstrainSelectedInstOperands,
     /*  455720 */     // GIR_Coverage, 7072,
     /*  455720 */     GIR_EraseRootFromParent_Done,
     /*  455721 */   // Label 7833: @455721
     /*  455721 */   GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(455807), // Rule ID 7073 //
     /*  455726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  455737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  455740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  455743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455773 */     // MIs[1] Operand 1
     /*  455773 */     // No operand predicates
     /*  455773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  455782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455805 */     GIR_RootConstrainSelectedInstOperands,
     /*  455806 */     // GIR_Coverage, 7073,
     /*  455806 */     GIR_EraseRootFromParent_Done,
     /*  455807 */   // Label 7834: @455807
     /*  455807 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(455893), // Rule ID 7076 //
     /*  455812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  455823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  455826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  455829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455859 */     // MIs[1] Operand 1
     /*  455859 */     // No operand predicates
     /*  455859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455891 */     GIR_RootConstrainSelectedInstOperands,
     /*  455892 */     // GIR_Coverage, 7076,
     /*  455892 */     GIR_EraseRootFromParent_Done,
     /*  455893 */   // Label 7835: @455893
     /*  455893 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(455979), // Rule ID 7077 //
     /*  455898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  455909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  455912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  455915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455945 */     // MIs[1] Operand 1
     /*  455945 */     // No operand predicates
     /*  455945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455954 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  455954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455977 */     GIR_RootConstrainSelectedInstOperands,
     /*  455978 */     // GIR_Coverage, 7077,
     /*  455978 */     GIR_EraseRootFromParent_Done,
     /*  455979 */   // Label 7836: @455979
     /*  455979 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(456065), // Rule ID 7080 //
     /*  455984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  455995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  455998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  456001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456031 */     // MIs[1] Operand 1
     /*  456031 */     // No operand predicates
     /*  456031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456040 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  456040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456063 */     GIR_RootConstrainSelectedInstOperands,
     /*  456064 */     // GIR_Coverage, 7080,
     /*  456064 */     GIR_EraseRootFromParent_Done,
     /*  456065 */   // Label 7837: @456065
     /*  456065 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(456151), // Rule ID 7081 //
     /*  456070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  456081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  456084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  456087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456117 */     // MIs[1] Operand 1
     /*  456117 */     // No operand predicates
     /*  456117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456126 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  456126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456149 */     GIR_RootConstrainSelectedInstOperands,
     /*  456150 */     // GIR_Coverage, 7081,
     /*  456150 */     GIR_EraseRootFromParent_Done,
     /*  456151 */   // Label 7838: @456151
     /*  456151 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(456237), // Rule ID 7084 //
     /*  456156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  456167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  456170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  456173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456203 */     // MIs[1] Operand 1
     /*  456203 */     // No operand predicates
     /*  456203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456212 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  456215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456235 */     GIR_RootConstrainSelectedInstOperands,
     /*  456236 */     // GIR_Coverage, 7084,
     /*  456236 */     GIR_EraseRootFromParent_Done,
     /*  456237 */   // Label 7839: @456237
     /*  456237 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(456323), // Rule ID 7085 //
     /*  456242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  456253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  456256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  456259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456289 */     // MIs[1] Operand 1
     /*  456289 */     // No operand predicates
     /*  456289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  456301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456321 */     GIR_RootConstrainSelectedInstOperands,
     /*  456322 */     // GIR_Coverage, 7085,
     /*  456322 */     GIR_EraseRootFromParent_Done,
     /*  456323 */   // Label 7840: @456323
     /*  456323 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(456409), // Rule ID 7088 //
     /*  456328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  456339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  456342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  456345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456375 */     // MIs[1] Operand 1
     /*  456375 */     // No operand predicates
     /*  456375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456384 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  456387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456407 */     GIR_RootConstrainSelectedInstOperands,
     /*  456408 */     // GIR_Coverage, 7088,
     /*  456408 */     GIR_EraseRootFromParent_Done,
     /*  456409 */   // Label 7841: @456409
     /*  456409 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(456495), // Rule ID 7089 //
     /*  456414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  456425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  456428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  456431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456461 */     // MIs[1] Operand 1
     /*  456461 */     // No operand predicates
     /*  456461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456470 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  456473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456493 */     GIR_RootConstrainSelectedInstOperands,
     /*  456494 */     // GIR_Coverage, 7089,
     /*  456494 */     GIR_EraseRootFromParent_Done,
     /*  456495 */   // Label 7842: @456495
     /*  456495 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(456581), // Rule ID 7092 //
     /*  456500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  456511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  456514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  456517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456547 */     // MIs[1] Operand 1
     /*  456547 */     // No operand predicates
     /*  456547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456556 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456579 */     GIR_RootConstrainSelectedInstOperands,
     /*  456580 */     // GIR_Coverage, 7092,
     /*  456580 */     GIR_EraseRootFromParent_Done,
     /*  456581 */   // Label 7843: @456581
     /*  456581 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(456667), // Rule ID 7093 //
     /*  456586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  456597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  456600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  456603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456633 */     // MIs[1] Operand 1
     /*  456633 */     // No operand predicates
     /*  456633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456665 */     GIR_RootConstrainSelectedInstOperands,
     /*  456666 */     // GIR_Coverage, 7093,
     /*  456666 */     GIR_EraseRootFromParent_Done,
     /*  456667 */   // Label 7844: @456667
     /*  456667 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(456753), // Rule ID 7272 //
     /*  456672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  456683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  456686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  456689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456719 */     // MIs[1] Operand 1
     /*  456719 */     // No operand predicates
     /*  456719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456728 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  456728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  456731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456751 */     GIR_RootConstrainSelectedInstOperands,
     /*  456752 */     // GIR_Coverage, 7272,
     /*  456752 */     GIR_EraseRootFromParent_Done,
     /*  456753 */   // Label 7845: @456753
     /*  456753 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(456839), // Rule ID 7273 //
     /*  456758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  456769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  456772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  456775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456805 */     // MIs[1] Operand 1
     /*  456805 */     // No operand predicates
     /*  456805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456814 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  456814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  456817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456837 */     GIR_RootConstrainSelectedInstOperands,
     /*  456838 */     // GIR_Coverage, 7273,
     /*  456838 */     GIR_EraseRootFromParent_Done,
     /*  456839 */   // Label 7846: @456839
     /*  456839 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(456925), // Rule ID 7276 //
     /*  456844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  456855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  456858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  456861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456891 */     // MIs[1] Operand 1
     /*  456891 */     // No operand predicates
     /*  456891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456900 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  456900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  456903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456923 */     GIR_RootConstrainSelectedInstOperands,
     /*  456924 */     // GIR_Coverage, 7276,
     /*  456924 */     GIR_EraseRootFromParent_Done,
     /*  456925 */   // Label 7847: @456925
     /*  456925 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(457011), // Rule ID 7277 //
     /*  456930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  456941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  456944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  456947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456977 */     // MIs[1] Operand 1
     /*  456977 */     // No operand predicates
     /*  456977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456986 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  456986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  456989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457009 */     GIR_RootConstrainSelectedInstOperands,
     /*  457010 */     // GIR_Coverage, 7277,
     /*  457010 */     GIR_EraseRootFromParent_Done,
     /*  457011 */   // Label 7848: @457011
     /*  457011 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(457097), // Rule ID 7280 //
     /*  457016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  457027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  457030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  457033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457063 */     // MIs[1] Operand 1
     /*  457063 */     // No operand predicates
     /*  457063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457072 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457095 */     GIR_RootConstrainSelectedInstOperands,
     /*  457096 */     // GIR_Coverage, 7280,
     /*  457096 */     GIR_EraseRootFromParent_Done,
     /*  457097 */   // Label 7849: @457097
     /*  457097 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(457183), // Rule ID 7281 //
     /*  457102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  457113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  457116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  457119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457149 */     // MIs[1] Operand 1
     /*  457149 */     // No operand predicates
     /*  457149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457158 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457181 */     GIR_RootConstrainSelectedInstOperands,
     /*  457182 */     // GIR_Coverage, 7281,
     /*  457182 */     GIR_EraseRootFromParent_Done,
     /*  457183 */   // Label 7850: @457183
     /*  457183 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(457269), // Rule ID 7284 //
     /*  457188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  457199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  457202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  457205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457235 */     // MIs[1] Operand 1
     /*  457235 */     // No operand predicates
     /*  457235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457244 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  457247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457267 */     GIR_RootConstrainSelectedInstOperands,
     /*  457268 */     // GIR_Coverage, 7284,
     /*  457268 */     GIR_EraseRootFromParent_Done,
     /*  457269 */   // Label 7851: @457269
     /*  457269 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(457355), // Rule ID 7285 //
     /*  457274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  457285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  457288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  457291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457321 */     // MIs[1] Operand 1
     /*  457321 */     // No operand predicates
     /*  457321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457330 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  457333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457353 */     GIR_RootConstrainSelectedInstOperands,
     /*  457354 */     // GIR_Coverage, 7285,
     /*  457354 */     GIR_EraseRootFromParent_Done,
     /*  457355 */   // Label 7852: @457355
     /*  457355 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(457441), // Rule ID 7288 //
     /*  457360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  457371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  457374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  457377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457407 */     // MIs[1] Operand 1
     /*  457407 */     // No operand predicates
     /*  457407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457416 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457439 */     GIR_RootConstrainSelectedInstOperands,
     /*  457440 */     // GIR_Coverage, 7288,
     /*  457440 */     GIR_EraseRootFromParent_Done,
     /*  457441 */   // Label 7853: @457441
     /*  457441 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(457527), // Rule ID 7289 //
     /*  457446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  457457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  457460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  457463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457493 */     // MIs[1] Operand 1
     /*  457493 */     // No operand predicates
     /*  457493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457502 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457525 */     GIR_RootConstrainSelectedInstOperands,
     /*  457526 */     // GIR_Coverage, 7289,
     /*  457526 */     GIR_EraseRootFromParent_Done,
     /*  457527 */   // Label 7854: @457527
     /*  457527 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(457613), // Rule ID 7292 //
     /*  457532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  457543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  457546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  457549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457579 */     // MIs[1] Operand 1
     /*  457579 */     // No operand predicates
     /*  457579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457588 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  457588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457611 */     GIR_RootConstrainSelectedInstOperands,
     /*  457612 */     // GIR_Coverage, 7292,
     /*  457612 */     GIR_EraseRootFromParent_Done,
     /*  457613 */   // Label 7855: @457613
     /*  457613 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(457699), // Rule ID 7293 //
     /*  457618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  457629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  457632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  457635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457665 */     // MIs[1] Operand 1
     /*  457665 */     // No operand predicates
     /*  457665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457674 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  457674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457697 */     GIR_RootConstrainSelectedInstOperands,
     /*  457698 */     // GIR_Coverage, 7293,
     /*  457698 */     GIR_EraseRootFromParent_Done,
     /*  457699 */   // Label 7856: @457699
     /*  457699 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(457785), // Rule ID 7296 //
     /*  457704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  457715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  457718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  457721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457751 */     // MIs[1] Operand 1
     /*  457751 */     // No operand predicates
     /*  457751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457760 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457783 */     GIR_RootConstrainSelectedInstOperands,
     /*  457784 */     // GIR_Coverage, 7296,
     /*  457784 */     GIR_EraseRootFromParent_Done,
     /*  457785 */   // Label 7857: @457785
     /*  457785 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(457871), // Rule ID 7297 //
     /*  457790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  457801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  457804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  457807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457837 */     // MIs[1] Operand 1
     /*  457837 */     // No operand predicates
     /*  457837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457846 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457869 */     GIR_RootConstrainSelectedInstOperands,
     /*  457870 */     // GIR_Coverage, 7297,
     /*  457870 */     GIR_EraseRootFromParent_Done,
     /*  457871 */   // Label 7858: @457871
     /*  457871 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(457957), // Rule ID 7300 //
     /*  457876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  457887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  457890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  457893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457923 */     // MIs[1] Operand 1
     /*  457923 */     // No operand predicates
     /*  457923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457932 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457955 */     GIR_RootConstrainSelectedInstOperands,
     /*  457956 */     // GIR_Coverage, 7300,
     /*  457956 */     GIR_EraseRootFromParent_Done,
     /*  457957 */   // Label 7859: @457957
     /*  457957 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(458043), // Rule ID 7301 //
     /*  457962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  457973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  457976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  457979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458009 */     // MIs[1] Operand 1
     /*  458009 */     // No operand predicates
     /*  458009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458018 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  458018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458041 */     GIR_RootConstrainSelectedInstOperands,
     /*  458042 */     // GIR_Coverage, 7301,
     /*  458042 */     GIR_EraseRootFromParent_Done,
     /*  458043 */   // Label 7860: @458043
     /*  458043 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(458129), // Rule ID 7304 //
     /*  458048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  458059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  458062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  458065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458095 */     // MIs[1] Operand 1
     /*  458095 */     // No operand predicates
     /*  458095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  458104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458127 */     GIR_RootConstrainSelectedInstOperands,
     /*  458128 */     // GIR_Coverage, 7304,
     /*  458128 */     GIR_EraseRootFromParent_Done,
     /*  458129 */   // Label 7861: @458129
     /*  458129 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(458215), // Rule ID 7305 //
     /*  458134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  458145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  458148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  458151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458181 */     // MIs[1] Operand 1
     /*  458181 */     // No operand predicates
     /*  458181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  458190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458213 */     GIR_RootConstrainSelectedInstOperands,
     /*  458214 */     // GIR_Coverage, 7305,
     /*  458214 */     GIR_EraseRootFromParent_Done,
     /*  458215 */   // Label 7862: @458215
     /*  458215 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(458301), // Rule ID 7308 //
     /*  458220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  458223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  458231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  458234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  458237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458267 */     // MIs[1] Operand 1
     /*  458267 */     // No operand predicates
     /*  458267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  458276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458299 */     GIR_RootConstrainSelectedInstOperands,
     /*  458300 */     // GIR_Coverage, 7308,
     /*  458300 */     GIR_EraseRootFromParent_Done,
     /*  458301 */   // Label 7863: @458301
     /*  458301 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(458387), // Rule ID 7309 //
     /*  458306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  458309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  458317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  458320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  458323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458353 */     // MIs[1] Operand 1
     /*  458353 */     // No operand predicates
     /*  458353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458362 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  458362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458385 */     GIR_RootConstrainSelectedInstOperands,
     /*  458386 */     // GIR_Coverage, 7309,
     /*  458386 */     GIR_EraseRootFromParent_Done,
     /*  458387 */   // Label 7864: @458387
     /*  458387 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(458473), // Rule ID 7312 //
     /*  458392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  458403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  458406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  458409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458439 */     // MIs[1] Operand 1
     /*  458439 */     // No operand predicates
     /*  458439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458448 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458471 */     GIR_RootConstrainSelectedInstOperands,
     /*  458472 */     // GIR_Coverage, 7312,
     /*  458472 */     GIR_EraseRootFromParent_Done,
     /*  458473 */   // Label 7865: @458473
     /*  458473 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(458559), // Rule ID 7313 //
     /*  458478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  458489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  458492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  458495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458525 */     // MIs[1] Operand 1
     /*  458525 */     // No operand predicates
     /*  458525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458534 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458557 */     GIR_RootConstrainSelectedInstOperands,
     /*  458558 */     // GIR_Coverage, 7313,
     /*  458558 */     GIR_EraseRootFromParent_Done,
     /*  458559 */   // Label 7866: @458559
     /*  458559 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(458645), // Rule ID 7316 //
     /*  458564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  458575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  458578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  458581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458611 */     // MIs[1] Operand 1
     /*  458611 */     // No operand predicates
     /*  458611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458620 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  458623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458643 */     GIR_RootConstrainSelectedInstOperands,
     /*  458644 */     // GIR_Coverage, 7316,
     /*  458644 */     GIR_EraseRootFromParent_Done,
     /*  458645 */   // Label 7867: @458645
     /*  458645 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(458731), // Rule ID 7317 //
     /*  458650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  458661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  458664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  458667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458697 */     // MIs[1] Operand 1
     /*  458697 */     // No operand predicates
     /*  458697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458706 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  458709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458729 */     GIR_RootConstrainSelectedInstOperands,
     /*  458730 */     // GIR_Coverage, 7317,
     /*  458730 */     GIR_EraseRootFromParent_Done,
     /*  458731 */   // Label 7868: @458731
     /*  458731 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(458817), // Rule ID 7320 //
     /*  458736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  458747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  458750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  458753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458783 */     // MIs[1] Operand 1
     /*  458783 */     // No operand predicates
     /*  458783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458792 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  458795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458815 */     GIR_RootConstrainSelectedInstOperands,
     /*  458816 */     // GIR_Coverage, 7320,
     /*  458816 */     GIR_EraseRootFromParent_Done,
     /*  458817 */   // Label 7869: @458817
     /*  458817 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(458903), // Rule ID 7321 //
     /*  458822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  458833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  458836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  458839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458869 */     // MIs[1] Operand 1
     /*  458869 */     // No operand predicates
     /*  458869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458878 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  458881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458901 */     GIR_RootConstrainSelectedInstOperands,
     /*  458902 */     // GIR_Coverage, 7321,
     /*  458902 */     GIR_EraseRootFromParent_Done,
     /*  458903 */   // Label 7870: @458903
     /*  458903 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(458989), // Rule ID 7324 //
     /*  458908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  458919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  458922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  458925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458955 */     // MIs[1] Operand 1
     /*  458955 */     // No operand predicates
     /*  458955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  458964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458987 */     GIR_RootConstrainSelectedInstOperands,
     /*  458988 */     // GIR_Coverage, 7324,
     /*  458988 */     GIR_EraseRootFromParent_Done,
     /*  458989 */   // Label 7871: @458989
     /*  458989 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(459075), // Rule ID 7325 //
     /*  458994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  459005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  459008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  459011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459041 */     // MIs[1] Operand 1
     /*  459041 */     // No operand predicates
     /*  459041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459050 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459073 */     GIR_RootConstrainSelectedInstOperands,
     /*  459074 */     // GIR_Coverage, 7325,
     /*  459074 */     GIR_EraseRootFromParent_Done,
     /*  459075 */   // Label 7872: @459075
     /*  459075 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(459161), // Rule ID 7328 //
     /*  459080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  459091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  459094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  459097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459127 */     // MIs[1] Operand 1
     /*  459127 */     // No operand predicates
     /*  459127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459159 */     GIR_RootConstrainSelectedInstOperands,
     /*  459160 */     // GIR_Coverage, 7328,
     /*  459160 */     GIR_EraseRootFromParent_Done,
     /*  459161 */   // Label 7873: @459161
     /*  459161 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(459247), // Rule ID 7329 //
     /*  459166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  459177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  459180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  459183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459213 */     // MIs[1] Operand 1
     /*  459213 */     // No operand predicates
     /*  459213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459222 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459245 */     GIR_RootConstrainSelectedInstOperands,
     /*  459246 */     // GIR_Coverage, 7329,
     /*  459246 */     GIR_EraseRootFromParent_Done,
     /*  459247 */   // Label 7874: @459247
     /*  459247 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(459333), // Rule ID 7332 //
     /*  459252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  459263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  459266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  459269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459299 */     // MIs[1] Operand 1
     /*  459299 */     // No operand predicates
     /*  459299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459308 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459331 */     GIR_RootConstrainSelectedInstOperands,
     /*  459332 */     // GIR_Coverage, 7332,
     /*  459332 */     GIR_EraseRootFromParent_Done,
     /*  459333 */   // Label 7875: @459333
     /*  459333 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(459419), // Rule ID 7333 //
     /*  459338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  459349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  459352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  459355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459385 */     // MIs[1] Operand 1
     /*  459385 */     // No operand predicates
     /*  459385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459394 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459417 */     GIR_RootConstrainSelectedInstOperands,
     /*  459418 */     // GIR_Coverage, 7333,
     /*  459418 */     GIR_EraseRootFromParent_Done,
     /*  459419 */   // Label 7876: @459419
     /*  459419 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(459505), // Rule ID 7336 //
     /*  459424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  459435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  459438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  459441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459471 */     // MIs[1] Operand 1
     /*  459471 */     // No operand predicates
     /*  459471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459480 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459503 */     GIR_RootConstrainSelectedInstOperands,
     /*  459504 */     // GIR_Coverage, 7336,
     /*  459504 */     GIR_EraseRootFromParent_Done,
     /*  459505 */   // Label 7877: @459505
     /*  459505 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(459591), // Rule ID 7337 //
     /*  459510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  459521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  459524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  459527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459557 */     // MIs[1] Operand 1
     /*  459557 */     // No operand predicates
     /*  459557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459566 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459589 */     GIR_RootConstrainSelectedInstOperands,
     /*  459590 */     // GIR_Coverage, 7337,
     /*  459590 */     GIR_EraseRootFromParent_Done,
     /*  459591 */   // Label 7878: @459591
     /*  459591 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(459677), // Rule ID 7340 //
     /*  459596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  459607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  459610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  459613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459643 */     // MIs[1] Operand 1
     /*  459643 */     // No operand predicates
     /*  459643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459652 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459675 */     GIR_RootConstrainSelectedInstOperands,
     /*  459676 */     // GIR_Coverage, 7340,
     /*  459676 */     GIR_EraseRootFromParent_Done,
     /*  459677 */   // Label 7879: @459677
     /*  459677 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(459763), // Rule ID 7341 //
     /*  459682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  459693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  459696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  459699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459729 */     // MIs[1] Operand 1
     /*  459729 */     // No operand predicates
     /*  459729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459738 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459761 */     GIR_RootConstrainSelectedInstOperands,
     /*  459762 */     // GIR_Coverage, 7341,
     /*  459762 */     GIR_EraseRootFromParent_Done,
     /*  459763 */   // Label 7880: @459763
     /*  459763 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(459849), // Rule ID 7344 //
     /*  459768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  459779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  459782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  459785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459815 */     // MIs[1] Operand 1
     /*  459815 */     // No operand predicates
     /*  459815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459824 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459847 */     GIR_RootConstrainSelectedInstOperands,
     /*  459848 */     // GIR_Coverage, 7344,
     /*  459848 */     GIR_EraseRootFromParent_Done,
     /*  459849 */   // Label 7881: @459849
     /*  459849 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(459935), // Rule ID 7345 //
     /*  459854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  459865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  459868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  459871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459901 */     // MIs[1] Operand 1
     /*  459901 */     // No operand predicates
     /*  459901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459910 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459933 */     GIR_RootConstrainSelectedInstOperands,
     /*  459934 */     // GIR_Coverage, 7345,
     /*  459934 */     GIR_EraseRootFromParent_Done,
     /*  459935 */   // Label 7882: @459935
     /*  459935 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(460021), // Rule ID 7348 //
     /*  459940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  459943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  459951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  459954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  459957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459987 */     // MIs[1] Operand 1
     /*  459987 */     // No operand predicates
     /*  459987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459996 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  459996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460019 */     GIR_RootConstrainSelectedInstOperands,
     /*  460020 */     // GIR_Coverage, 7348,
     /*  460020 */     GIR_EraseRootFromParent_Done,
     /*  460021 */   // Label 7883: @460021
     /*  460021 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(460107), // Rule ID 7349 //
     /*  460026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  460037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  460040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  460043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460073 */     // MIs[1] Operand 1
     /*  460073 */     // No operand predicates
     /*  460073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460082 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  460085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460105 */     GIR_RootConstrainSelectedInstOperands,
     /*  460106 */     // GIR_Coverage, 7349,
     /*  460106 */     GIR_EraseRootFromParent_Done,
     /*  460107 */   // Label 7884: @460107
     /*  460107 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(460193), // Rule ID 7352 //
     /*  460112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  460123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  460126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  460129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460159 */     // MIs[1] Operand 1
     /*  460159 */     // No operand predicates
     /*  460159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460168 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  460171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460191 */     GIR_RootConstrainSelectedInstOperands,
     /*  460192 */     // GIR_Coverage, 7352,
     /*  460192 */     GIR_EraseRootFromParent_Done,
     /*  460193 */   // Label 7885: @460193
     /*  460193 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(460279), // Rule ID 7353 //
     /*  460198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  460209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  460212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  460215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460245 */     // MIs[1] Operand 1
     /*  460245 */     // No operand predicates
     /*  460245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460254 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  460257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460277 */     GIR_RootConstrainSelectedInstOperands,
     /*  460278 */     // GIR_Coverage, 7353,
     /*  460278 */     GIR_EraseRootFromParent_Done,
     /*  460279 */   // Label 7886: @460279
     /*  460279 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(460365), // Rule ID 7356 //
     /*  460284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  460295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  460298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  460301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460331 */     // MIs[1] Operand 1
     /*  460331 */     // No operand predicates
     /*  460331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460340 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  460343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460363 */     GIR_RootConstrainSelectedInstOperands,
     /*  460364 */     // GIR_Coverage, 7356,
     /*  460364 */     GIR_EraseRootFromParent_Done,
     /*  460365 */   // Label 7887: @460365
     /*  460365 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(460451), // Rule ID 7357 //
     /*  460370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  460381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  460384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  460387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460417 */     // MIs[1] Operand 1
     /*  460417 */     // No operand predicates
     /*  460417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460426 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  460429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460449 */     GIR_RootConstrainSelectedInstOperands,
     /*  460450 */     // GIR_Coverage, 7357,
     /*  460450 */     GIR_EraseRootFromParent_Done,
     /*  460451 */   // Label 7888: @460451
     /*  460451 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(460537), // Rule ID 7568 //
     /*  460456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  460467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  460470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  460473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460503 */     // MIs[1] Operand 1
     /*  460503 */     // No operand predicates
     /*  460503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460512 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  460515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460535 */     GIR_RootConstrainSelectedInstOperands,
     /*  460536 */     // GIR_Coverage, 7568,
     /*  460536 */     GIR_EraseRootFromParent_Done,
     /*  460537 */   // Label 7889: @460537
     /*  460537 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(460623), // Rule ID 7569 //
     /*  460542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  460553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  460556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  460559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460589 */     // MIs[1] Operand 1
     /*  460589 */     // No operand predicates
     /*  460589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460598 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  460601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460621 */     GIR_RootConstrainSelectedInstOperands,
     /*  460622 */     // GIR_Coverage, 7569,
     /*  460622 */     GIR_EraseRootFromParent_Done,
     /*  460623 */   // Label 7890: @460623
     /*  460623 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(460709), // Rule ID 7572 //
     /*  460628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  460639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  460642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  460645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460675 */     // MIs[1] Operand 1
     /*  460675 */     // No operand predicates
     /*  460675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460684 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  460687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460707 */     GIR_RootConstrainSelectedInstOperands,
     /*  460708 */     // GIR_Coverage, 7572,
     /*  460708 */     GIR_EraseRootFromParent_Done,
     /*  460709 */   // Label 7891: @460709
     /*  460709 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(460795), // Rule ID 7573 //
     /*  460714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  460725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  460728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  460731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460761 */     // MIs[1] Operand 1
     /*  460761 */     // No operand predicates
     /*  460761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460770 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  460773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460793 */     GIR_RootConstrainSelectedInstOperands,
     /*  460794 */     // GIR_Coverage, 7573,
     /*  460794 */     GIR_EraseRootFromParent_Done,
     /*  460795 */   // Label 7892: @460795
     /*  460795 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(460881), // Rule ID 7576 //
     /*  460800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  460811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  460814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  460817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460847 */     // MIs[1] Operand 1
     /*  460847 */     // No operand predicates
     /*  460847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460856 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  460859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460879 */     GIR_RootConstrainSelectedInstOperands,
     /*  460880 */     // GIR_Coverage, 7576,
     /*  460880 */     GIR_EraseRootFromParent_Done,
     /*  460881 */   // Label 7893: @460881
     /*  460881 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(460967), // Rule ID 7577 //
     /*  460886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  460897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  460900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  460903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460933 */     // MIs[1] Operand 1
     /*  460933 */     // No operand predicates
     /*  460933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460942 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  460945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460965 */     GIR_RootConstrainSelectedInstOperands,
     /*  460966 */     // GIR_Coverage, 7577,
     /*  460966 */     GIR_EraseRootFromParent_Done,
     /*  460967 */   // Label 7894: @460967
     /*  460967 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(461053), // Rule ID 7580 //
     /*  460972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  460983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  460986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  460989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461019 */     // MIs[1] Operand 1
     /*  461019 */     // No operand predicates
     /*  461019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461028 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461051 */     GIR_RootConstrainSelectedInstOperands,
     /*  461052 */     // GIR_Coverage, 7580,
     /*  461052 */     GIR_EraseRootFromParent_Done,
     /*  461053 */   // Label 7895: @461053
     /*  461053 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(461139), // Rule ID 7581 //
     /*  461058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  461069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  461072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  461075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461105 */     // MIs[1] Operand 1
     /*  461105 */     // No operand predicates
     /*  461105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461114 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461137 */     GIR_RootConstrainSelectedInstOperands,
     /*  461138 */     // GIR_Coverage, 7581,
     /*  461138 */     GIR_EraseRootFromParent_Done,
     /*  461139 */   // Label 7896: @461139
     /*  461139 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(461225), // Rule ID 7584 //
     /*  461144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  461155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  461158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  461161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461191 */     // MIs[1] Operand 1
     /*  461191 */     // No operand predicates
     /*  461191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  461203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461223 */     GIR_RootConstrainSelectedInstOperands,
     /*  461224 */     // GIR_Coverage, 7584,
     /*  461224 */     GIR_EraseRootFromParent_Done,
     /*  461225 */   // Label 7897: @461225
     /*  461225 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(461311), // Rule ID 7585 //
     /*  461230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  461241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  461244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  461247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461277 */     // MIs[1] Operand 1
     /*  461277 */     // No operand predicates
     /*  461277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461286 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  461289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461309 */     GIR_RootConstrainSelectedInstOperands,
     /*  461310 */     // GIR_Coverage, 7585,
     /*  461310 */     GIR_EraseRootFromParent_Done,
     /*  461311 */   // Label 7898: @461311
     /*  461311 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(461397), // Rule ID 7588 //
     /*  461316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  461327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  461330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  461333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461363 */     // MIs[1] Operand 1
     /*  461363 */     // No operand predicates
     /*  461363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461372 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  461375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461395 */     GIR_RootConstrainSelectedInstOperands,
     /*  461396 */     // GIR_Coverage, 7588,
     /*  461396 */     GIR_EraseRootFromParent_Done,
     /*  461397 */   // Label 7899: @461397
     /*  461397 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(461483), // Rule ID 7589 //
     /*  461402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  461413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  461416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  461419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461449 */     // MIs[1] Operand 1
     /*  461449 */     // No operand predicates
     /*  461449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461458 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  461461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461481 */     GIR_RootConstrainSelectedInstOperands,
     /*  461482 */     // GIR_Coverage, 7589,
     /*  461482 */     GIR_EraseRootFromParent_Done,
     /*  461483 */   // Label 7900: @461483
     /*  461483 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(461569), // Rule ID 7592 //
     /*  461488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  461499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  461502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  461505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461535 */     // MIs[1] Operand 1
     /*  461535 */     // No operand predicates
     /*  461535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461544 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  461547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461567 */     GIR_RootConstrainSelectedInstOperands,
     /*  461568 */     // GIR_Coverage, 7592,
     /*  461568 */     GIR_EraseRootFromParent_Done,
     /*  461569 */   // Label 7901: @461569
     /*  461569 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(461655), // Rule ID 7593 //
     /*  461574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  461585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  461588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  461591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461621 */     // MIs[1] Operand 1
     /*  461621 */     // No operand predicates
     /*  461621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  461633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461653 */     GIR_RootConstrainSelectedInstOperands,
     /*  461654 */     // GIR_Coverage, 7593,
     /*  461654 */     GIR_EraseRootFromParent_Done,
     /*  461655 */   // Label 7902: @461655
     /*  461655 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(461741), // Rule ID 7596 //
     /*  461660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  461671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  461674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  461677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461707 */     // MIs[1] Operand 1
     /*  461707 */     // No operand predicates
     /*  461707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461716 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  461719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461739 */     GIR_RootConstrainSelectedInstOperands,
     /*  461740 */     // GIR_Coverage, 7596,
     /*  461740 */     GIR_EraseRootFromParent_Done,
     /*  461741 */   // Label 7903: @461741
     /*  461741 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(461827), // Rule ID 7597 //
     /*  461746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  461757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  461760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  461763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461793 */     // MIs[1] Operand 1
     /*  461793 */     // No operand predicates
     /*  461793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461802 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  461805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461825 */     GIR_RootConstrainSelectedInstOperands,
     /*  461826 */     // GIR_Coverage, 7597,
     /*  461826 */     GIR_EraseRootFromParent_Done,
     /*  461827 */   // Label 7904: @461827
     /*  461827 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(461913), // Rule ID 7600 //
     /*  461832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  461843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  461846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  461849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461879 */     // MIs[1] Operand 1
     /*  461879 */     // No operand predicates
     /*  461879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461888 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461911 */     GIR_RootConstrainSelectedInstOperands,
     /*  461912 */     // GIR_Coverage, 7600,
     /*  461912 */     GIR_EraseRootFromParent_Done,
     /*  461913 */   // Label 7905: @461913
     /*  461913 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(461999), // Rule ID 7601 //
     /*  461918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  461929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  461932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  461935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461965 */     // MIs[1] Operand 1
     /*  461965 */     // No operand predicates
     /*  461965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461974 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461997 */     GIR_RootConstrainSelectedInstOperands,
     /*  461998 */     // GIR_Coverage, 7601,
     /*  461998 */     GIR_EraseRootFromParent_Done,
     /*  461999 */   // Label 7906: @461999
     /*  461999 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(462085), // Rule ID 7604 //
     /*  462004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  462015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  462018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  462021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462051 */     // MIs[1] Operand 1
     /*  462051 */     // No operand predicates
     /*  462051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462083 */     GIR_RootConstrainSelectedInstOperands,
     /*  462084 */     // GIR_Coverage, 7604,
     /*  462084 */     GIR_EraseRootFromParent_Done,
     /*  462085 */   // Label 7907: @462085
     /*  462085 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(462171), // Rule ID 7605 //
     /*  462090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  462101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  462104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  462107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462137 */     // MIs[1] Operand 1
     /*  462137 */     // No operand predicates
     /*  462137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462169 */     GIR_RootConstrainSelectedInstOperands,
     /*  462170 */     // GIR_Coverage, 7605,
     /*  462170 */     GIR_EraseRootFromParent_Done,
     /*  462171 */   // Label 7908: @462171
     /*  462171 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(462257), // Rule ID 7608 //
     /*  462176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  462187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  462190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  462193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462223 */     // MIs[1] Operand 1
     /*  462223 */     // No operand predicates
     /*  462223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462232 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  462235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462255 */     GIR_RootConstrainSelectedInstOperands,
     /*  462256 */     // GIR_Coverage, 7608,
     /*  462256 */     GIR_EraseRootFromParent_Done,
     /*  462257 */   // Label 7909: @462257
     /*  462257 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(462343), // Rule ID 7609 //
     /*  462262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  462273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  462276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  462279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462309 */     // MIs[1] Operand 1
     /*  462309 */     // No operand predicates
     /*  462309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462318 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  462321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462341 */     GIR_RootConstrainSelectedInstOperands,
     /*  462342 */     // GIR_Coverage, 7609,
     /*  462342 */     GIR_EraseRootFromParent_Done,
     /*  462343 */   // Label 7910: @462343
     /*  462343 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(462429), // Rule ID 7612 //
     /*  462348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  462359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  462362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  462365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462395 */     // MIs[1] Operand 1
     /*  462395 */     // No operand predicates
     /*  462395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  462404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  462407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462427 */     GIR_RootConstrainSelectedInstOperands,
     /*  462428 */     // GIR_Coverage, 7612,
     /*  462428 */     GIR_EraseRootFromParent_Done,
     /*  462429 */   // Label 7911: @462429
     /*  462429 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(462515), // Rule ID 7613 //
     /*  462434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  462437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  462445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  462448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  462451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462481 */     // MIs[1] Operand 1
     /*  462481 */     // No operand predicates
     /*  462481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462490 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  462493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462513 */     GIR_RootConstrainSelectedInstOperands,
     /*  462514 */     // GIR_Coverage, 7613,
     /*  462514 */     GIR_EraseRootFromParent_Done,
     /*  462515 */   // Label 7912: @462515
     /*  462515 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(462601), // Rule ID 7616 //
     /*  462520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  462531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  462534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  462537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462567 */     // MIs[1] Operand 1
     /*  462567 */     // No operand predicates
     /*  462567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  462576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  462579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462599 */     GIR_RootConstrainSelectedInstOperands,
     /*  462600 */     // GIR_Coverage, 7616,
     /*  462600 */     GIR_EraseRootFromParent_Done,
     /*  462601 */   // Label 7913: @462601
     /*  462601 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(462687), // Rule ID 7617 //
     /*  462606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  462609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  462617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  462620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  462623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462653 */     // MIs[1] Operand 1
     /*  462653 */     // No operand predicates
     /*  462653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462662 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  462665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462685 */     GIR_RootConstrainSelectedInstOperands,
     /*  462686 */     // GIR_Coverage, 7617,
     /*  462686 */     GIR_EraseRootFromParent_Done,
     /*  462687 */   // Label 7914: @462687
     /*  462687 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(462773), // Rule ID 7620 //
     /*  462692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  462703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  462706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  462709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462739 */     // MIs[1] Operand 1
     /*  462739 */     // No operand predicates
     /*  462739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  462748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462771 */     GIR_RootConstrainSelectedInstOperands,
     /*  462772 */     // GIR_Coverage, 7620,
     /*  462772 */     GIR_EraseRootFromParent_Done,
     /*  462773 */   // Label 7915: @462773
     /*  462773 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(462859), // Rule ID 7621 //
     /*  462778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  462781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  462789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  462792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  462795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462825 */     // MIs[1] Operand 1
     /*  462825 */     // No operand predicates
     /*  462825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462857 */     GIR_RootConstrainSelectedInstOperands,
     /*  462858 */     // GIR_Coverage, 7621,
     /*  462858 */     GIR_EraseRootFromParent_Done,
     /*  462859 */   // Label 7916: @462859
     /*  462859 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(462945), // Rule ID 7624 //
     /*  462864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  462875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  462878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  462881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462911 */     // MIs[1] Operand 1
     /*  462911 */     // No operand predicates
     /*  462911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462920 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  462920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  462923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462943 */     GIR_RootConstrainSelectedInstOperands,
     /*  462944 */     // GIR_Coverage, 7624,
     /*  462944 */     GIR_EraseRootFromParent_Done,
     /*  462945 */   // Label 7917: @462945
     /*  462945 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(463031), // Rule ID 7625 //
     /*  462950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  462953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  462961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  462964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  462967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462997 */     // MIs[1] Operand 1
     /*  462997 */     // No operand predicates
     /*  462997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463006 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  463009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463029 */     GIR_RootConstrainSelectedInstOperands,
     /*  463030 */     // GIR_Coverage, 7625,
     /*  463030 */     GIR_EraseRootFromParent_Done,
     /*  463031 */   // Label 7918: @463031
     /*  463031 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(463117), // Rule ID 7748 //
     /*  463036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  463047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  463050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  463053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463083 */     // MIs[1] Operand 1
     /*  463083 */     // No operand predicates
     /*  463083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463092 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  463095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463115 */     GIR_RootConstrainSelectedInstOperands,
     /*  463116 */     // GIR_Coverage, 7748,
     /*  463116 */     GIR_EraseRootFromParent_Done,
     /*  463117 */   // Label 7919: @463117
     /*  463117 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(463203), // Rule ID 7749 //
     /*  463122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  463133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  463136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  463139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463169 */     // MIs[1] Operand 1
     /*  463169 */     // No operand predicates
     /*  463169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463178 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  463181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463201 */     GIR_RootConstrainSelectedInstOperands,
     /*  463202 */     // GIR_Coverage, 7749,
     /*  463202 */     GIR_EraseRootFromParent_Done,
     /*  463203 */   // Label 7920: @463203
     /*  463203 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(463289), // Rule ID 7752 //
     /*  463208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  463219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  463222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  463225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463255 */     // MIs[1] Operand 1
     /*  463255 */     // No operand predicates
     /*  463255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463264 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  463267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463287 */     GIR_RootConstrainSelectedInstOperands,
     /*  463288 */     // GIR_Coverage, 7752,
     /*  463288 */     GIR_EraseRootFromParent_Done,
     /*  463289 */   // Label 7921: @463289
     /*  463289 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(463375), // Rule ID 7753 //
     /*  463294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  463305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  463308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  463311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463341 */     // MIs[1] Operand 1
     /*  463341 */     // No operand predicates
     /*  463341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463350 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  463353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463373 */     GIR_RootConstrainSelectedInstOperands,
     /*  463374 */     // GIR_Coverage, 7753,
     /*  463374 */     GIR_EraseRootFromParent_Done,
     /*  463375 */   // Label 7922: @463375
     /*  463375 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(463461), // Rule ID 7756 //
     /*  463380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  463391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  463394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  463397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463427 */     // MIs[1] Operand 1
     /*  463427 */     // No operand predicates
     /*  463427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463436 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  463439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463459 */     GIR_RootConstrainSelectedInstOperands,
     /*  463460 */     // GIR_Coverage, 7756,
     /*  463460 */     GIR_EraseRootFromParent_Done,
     /*  463461 */   // Label 7923: @463461
     /*  463461 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(463547), // Rule ID 7757 //
     /*  463466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  463477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  463480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  463483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463513 */     // MIs[1] Operand 1
     /*  463513 */     // No operand predicates
     /*  463513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463522 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  463525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463545 */     GIR_RootConstrainSelectedInstOperands,
     /*  463546 */     // GIR_Coverage, 7757,
     /*  463546 */     GIR_EraseRootFromParent_Done,
     /*  463547 */   // Label 7924: @463547
     /*  463547 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(463633), // Rule ID 7760 //
     /*  463552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  463563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  463566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  463569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463599 */     // MIs[1] Operand 1
     /*  463599 */     // No operand predicates
     /*  463599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463608 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  463611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463631 */     GIR_RootConstrainSelectedInstOperands,
     /*  463632 */     // GIR_Coverage, 7760,
     /*  463632 */     GIR_EraseRootFromParent_Done,
     /*  463633 */   // Label 7925: @463633
     /*  463633 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(463719), // Rule ID 7761 //
     /*  463638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  463649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  463652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  463655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463685 */     // MIs[1] Operand 1
     /*  463685 */     // No operand predicates
     /*  463685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463694 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  463697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463717 */     GIR_RootConstrainSelectedInstOperands,
     /*  463718 */     // GIR_Coverage, 7761,
     /*  463718 */     GIR_EraseRootFromParent_Done,
     /*  463719 */   // Label 7926: @463719
     /*  463719 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(463805), // Rule ID 7764 //
     /*  463724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  463735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  463738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  463741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463771 */     // MIs[1] Operand 1
     /*  463771 */     // No operand predicates
     /*  463771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463780 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  463783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463803 */     GIR_RootConstrainSelectedInstOperands,
     /*  463804 */     // GIR_Coverage, 7764,
     /*  463804 */     GIR_EraseRootFromParent_Done,
     /*  463805 */   // Label 7927: @463805
     /*  463805 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(463891), // Rule ID 7765 //
     /*  463810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  463821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  463824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  463827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463857 */     // MIs[1] Operand 1
     /*  463857 */     // No operand predicates
     /*  463857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463866 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  463869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463889 */     GIR_RootConstrainSelectedInstOperands,
     /*  463890 */     // GIR_Coverage, 7765,
     /*  463890 */     GIR_EraseRootFromParent_Done,
     /*  463891 */   // Label 7928: @463891
     /*  463891 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(463977), // Rule ID 7768 //
     /*  463896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  463907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  463910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  463913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463943 */     // MIs[1] Operand 1
     /*  463943 */     // No operand predicates
     /*  463943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463952 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  463955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463975 */     GIR_RootConstrainSelectedInstOperands,
     /*  463976 */     // GIR_Coverage, 7768,
     /*  463976 */     GIR_EraseRootFromParent_Done,
     /*  463977 */   // Label 7929: @463977
     /*  463977 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(464063), // Rule ID 7769 //
     /*  463982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  463993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  463996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  463999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464029 */     // MIs[1] Operand 1
     /*  464029 */     // No operand predicates
     /*  464029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464038 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  464041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464061 */     GIR_RootConstrainSelectedInstOperands,
     /*  464062 */     // GIR_Coverage, 7769,
     /*  464062 */     GIR_EraseRootFromParent_Done,
     /*  464063 */   // Label 7930: @464063
     /*  464063 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(464149), // Rule ID 7772 //
     /*  464068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  464079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  464082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  464085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464115 */     // MIs[1] Operand 1
     /*  464115 */     // No operand predicates
     /*  464115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464124 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  464127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464147 */     GIR_RootConstrainSelectedInstOperands,
     /*  464148 */     // GIR_Coverage, 7772,
     /*  464148 */     GIR_EraseRootFromParent_Done,
     /*  464149 */   // Label 7931: @464149
     /*  464149 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(464235), // Rule ID 7773 //
     /*  464154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  464165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  464168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  464171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464201 */     // MIs[1] Operand 1
     /*  464201 */     // No operand predicates
     /*  464201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  464213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464233 */     GIR_RootConstrainSelectedInstOperands,
     /*  464234 */     // GIR_Coverage, 7773,
     /*  464234 */     GIR_EraseRootFromParent_Done,
     /*  464235 */   // Label 7932: @464235
     /*  464235 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(464321), // Rule ID 7776 //
     /*  464240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  464251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  464254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  464257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464287 */     // MIs[1] Operand 1
     /*  464287 */     // No operand predicates
     /*  464287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464296 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  464299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464319 */     GIR_RootConstrainSelectedInstOperands,
     /*  464320 */     // GIR_Coverage, 7776,
     /*  464320 */     GIR_EraseRootFromParent_Done,
     /*  464321 */   // Label 7933: @464321
     /*  464321 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(464407), // Rule ID 7777 //
     /*  464326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  464337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  464340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  464343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464373 */     // MIs[1] Operand 1
     /*  464373 */     // No operand predicates
     /*  464373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  464385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464405 */     GIR_RootConstrainSelectedInstOperands,
     /*  464406 */     // GIR_Coverage, 7777,
     /*  464406 */     GIR_EraseRootFromParent_Done,
     /*  464407 */   // Label 7934: @464407
     /*  464407 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(464493), // Rule ID 7780 //
     /*  464412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  464423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  464426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  464429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464459 */     // MIs[1] Operand 1
     /*  464459 */     // No operand predicates
     /*  464459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464468 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  464471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464491 */     GIR_RootConstrainSelectedInstOperands,
     /*  464492 */     // GIR_Coverage, 7780,
     /*  464492 */     GIR_EraseRootFromParent_Done,
     /*  464493 */   // Label 7935: @464493
     /*  464493 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(464579), // Rule ID 7781 //
     /*  464498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  464509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  464512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  464515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464545 */     // MIs[1] Operand 1
     /*  464545 */     // No operand predicates
     /*  464545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464554 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  464557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464577 */     GIR_RootConstrainSelectedInstOperands,
     /*  464578 */     // GIR_Coverage, 7781,
     /*  464578 */     GIR_EraseRootFromParent_Done,
     /*  464579 */   // Label 7936: @464579
     /*  464579 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(464665), // Rule ID 7784 //
     /*  464584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  464595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  464598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  464601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464631 */     // MIs[1] Operand 1
     /*  464631 */     // No operand predicates
     /*  464631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  464643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464663 */     GIR_RootConstrainSelectedInstOperands,
     /*  464664 */     // GIR_Coverage, 7784,
     /*  464664 */     GIR_EraseRootFromParent_Done,
     /*  464665 */   // Label 7937: @464665
     /*  464665 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(464751), // Rule ID 7785 //
     /*  464670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  464681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  464684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  464687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464717 */     // MIs[1] Operand 1
     /*  464717 */     // No operand predicates
     /*  464717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  464729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464749 */     GIR_RootConstrainSelectedInstOperands,
     /*  464750 */     // GIR_Coverage, 7785,
     /*  464750 */     GIR_EraseRootFromParent_Done,
     /*  464751 */   // Label 7938: @464751
     /*  464751 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(464837), // Rule ID 7788 //
     /*  464756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  464767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  464770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  464773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464803 */     // MIs[1] Operand 1
     /*  464803 */     // No operand predicates
     /*  464803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464812 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  464815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464835 */     GIR_RootConstrainSelectedInstOperands,
     /*  464836 */     // GIR_Coverage, 7788,
     /*  464836 */     GIR_EraseRootFromParent_Done,
     /*  464837 */   // Label 7939: @464837
     /*  464837 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(464923), // Rule ID 7789 //
     /*  464842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  464853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  464856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  464859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464889 */     // MIs[1] Operand 1
     /*  464889 */     // No operand predicates
     /*  464889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464898 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  464901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464921 */     GIR_RootConstrainSelectedInstOperands,
     /*  464922 */     // GIR_Coverage, 7789,
     /*  464922 */     GIR_EraseRootFromParent_Done,
     /*  464923 */   // Label 7940: @464923
     /*  464923 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(465009), // Rule ID 7792 //
     /*  464928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  464931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  464939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  464942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  464945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464975 */     // MIs[1] Operand 1
     /*  464975 */     // No operand predicates
     /*  464975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464984 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  464984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  464987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465007 */     GIR_RootConstrainSelectedInstOperands,
     /*  465008 */     // GIR_Coverage, 7792,
     /*  465008 */     GIR_EraseRootFromParent_Done,
     /*  465009 */   // Label 7941: @465009
     /*  465009 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(465095), // Rule ID 7793 //
     /*  465014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  465025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  465028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  465031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465061 */     // MIs[1] Operand 1
     /*  465061 */     // No operand predicates
     /*  465061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465070 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  465073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465093 */     GIR_RootConstrainSelectedInstOperands,
     /*  465094 */     // GIR_Coverage, 7793,
     /*  465094 */     GIR_EraseRootFromParent_Done,
     /*  465095 */   // Label 7942: @465095
     /*  465095 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(465181), // Rule ID 7796 //
     /*  465100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  465111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  465114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  465117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465147 */     // MIs[1] Operand 1
     /*  465147 */     // No operand predicates
     /*  465147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  465159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465179 */     GIR_RootConstrainSelectedInstOperands,
     /*  465180 */     // GIR_Coverage, 7796,
     /*  465180 */     GIR_EraseRootFromParent_Done,
     /*  465181 */   // Label 7943: @465181
     /*  465181 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(465267), // Rule ID 7797 //
     /*  465186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  465197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  465200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  465203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465233 */     // MIs[1] Operand 1
     /*  465233 */     // No operand predicates
     /*  465233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465242 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  465245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465265 */     GIR_RootConstrainSelectedInstOperands,
     /*  465266 */     // GIR_Coverage, 7797,
     /*  465266 */     GIR_EraseRootFromParent_Done,
     /*  465267 */   // Label 7944: @465267
     /*  465267 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(465353), // Rule ID 7800 //
     /*  465272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  465283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  465286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  465289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465319 */     // MIs[1] Operand 1
     /*  465319 */     // No operand predicates
     /*  465319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  465331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465351 */     GIR_RootConstrainSelectedInstOperands,
     /*  465352 */     // GIR_Coverage, 7800,
     /*  465352 */     GIR_EraseRootFromParent_Done,
     /*  465353 */   // Label 7945: @465353
     /*  465353 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(465439), // Rule ID 7801 //
     /*  465358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  465369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  465372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  465375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465405 */     // MIs[1] Operand 1
     /*  465405 */     // No operand predicates
     /*  465405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  465417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465437 */     GIR_RootConstrainSelectedInstOperands,
     /*  465438 */     // GIR_Coverage, 7801,
     /*  465438 */     GIR_EraseRootFromParent_Done,
     /*  465439 */   // Label 7946: @465439
     /*  465439 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(465525), // Rule ID 7804 //
     /*  465444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  465455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  465458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  465461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465491 */     // MIs[1] Operand 1
     /*  465491 */     // No operand predicates
     /*  465491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  465503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465523 */     GIR_RootConstrainSelectedInstOperands,
     /*  465524 */     // GIR_Coverage, 7804,
     /*  465524 */     GIR_EraseRootFromParent_Done,
     /*  465525 */   // Label 7947: @465525
     /*  465525 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(465611), // Rule ID 7805 //
     /*  465530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  465541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  465544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  465547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465577 */     // MIs[1] Operand 1
     /*  465577 */     // No operand predicates
     /*  465577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  465589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465609 */     GIR_RootConstrainSelectedInstOperands,
     /*  465610 */     // GIR_Coverage, 7805,
     /*  465610 */     GIR_EraseRootFromParent_Done,
     /*  465611 */   // Label 7948: @465611
     /*  465611 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(465700), // Rule ID 14234 //
     /*  465616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  465627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  465630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  465633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465663 */     // MIs[1] Operand 1
     /*  465663 */     // No operand predicates
     /*  465663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465672 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  465675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465698 */     GIR_RootConstrainSelectedInstOperands,
     /*  465699 */     // GIR_Coverage, 14234,
     /*  465699 */     GIR_EraseRootFromParent_Done,
     /*  465700 */   // Label 7949: @465700
     /*  465700 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(465789), // Rule ID 14235 //
     /*  465705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  465716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  465719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  465722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465752 */     // MIs[1] Operand 1
     /*  465752 */     // No operand predicates
     /*  465752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465761 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  465761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  465764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465787 */     GIR_RootConstrainSelectedInstOperands,
     /*  465788 */     // GIR_Coverage, 14235,
     /*  465788 */     GIR_EraseRootFromParent_Done,
     /*  465789 */   // Label 7950: @465789
     /*  465789 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(465878), // Rule ID 14238 //
     /*  465794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  465805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  465808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  465811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465841 */     // MIs[1] Operand 1
     /*  465841 */     // No operand predicates
     /*  465841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465850 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  465853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465876 */     GIR_RootConstrainSelectedInstOperands,
     /*  465877 */     // GIR_Coverage, 14238,
     /*  465877 */     GIR_EraseRootFromParent_Done,
     /*  465878 */   // Label 7951: @465878
     /*  465878 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(465967), // Rule ID 14239 //
     /*  465883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  465894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  465897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  465900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465930 */     // MIs[1] Operand 1
     /*  465930 */     // No operand predicates
     /*  465930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465939 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  465939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  465942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465965 */     GIR_RootConstrainSelectedInstOperands,
     /*  465966 */     // GIR_Coverage, 14239,
     /*  465966 */     GIR_EraseRootFromParent_Done,
     /*  465967 */   // Label 7952: @465967
     /*  465967 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(466056), // Rule ID 14242 //
     /*  465972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  465983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  465986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  465989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466019 */     // MIs[1] Operand 1
     /*  466019 */     // No operand predicates
     /*  466019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466028 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466054 */     GIR_RootConstrainSelectedInstOperands,
     /*  466055 */     // GIR_Coverage, 14242,
     /*  466055 */     GIR_EraseRootFromParent_Done,
     /*  466056 */   // Label 7953: @466056
     /*  466056 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(466145), // Rule ID 14243 //
     /*  466061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  466072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  466075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  466078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466108 */     // MIs[1] Operand 1
     /*  466108 */     // No operand predicates
     /*  466108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466117 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  466117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466143 */     GIR_RootConstrainSelectedInstOperands,
     /*  466144 */     // GIR_Coverage, 14243,
     /*  466144 */     GIR_EraseRootFromParent_Done,
     /*  466145 */   // Label 7954: @466145
     /*  466145 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(466234), // Rule ID 14246 //
     /*  466150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  466161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  466164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466197 */     // MIs[1] Operand 1
     /*  466197 */     // No operand predicates
     /*  466197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466206 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  466209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466232 */     GIR_RootConstrainSelectedInstOperands,
     /*  466233 */     // GIR_Coverage, 14246,
     /*  466233 */     GIR_EraseRootFromParent_Done,
     /*  466234 */   // Label 7955: @466234
     /*  466234 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(466323), // Rule ID 14247 //
     /*  466239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  466250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  466253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466286 */     // MIs[1] Operand 1
     /*  466286 */     // No operand predicates
     /*  466286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466295 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  466298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466321 */     GIR_RootConstrainSelectedInstOperands,
     /*  466322 */     // GIR_Coverage, 14247,
     /*  466322 */     GIR_EraseRootFromParent_Done,
     /*  466323 */   // Label 7956: @466323
     /*  466323 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(466412), // Rule ID 14250 //
     /*  466328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  466339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  466342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  466345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466375 */     // MIs[1] Operand 1
     /*  466375 */     // No operand predicates
     /*  466375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466384 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466410 */     GIR_RootConstrainSelectedInstOperands,
     /*  466411 */     // GIR_Coverage, 14250,
     /*  466411 */     GIR_EraseRootFromParent_Done,
     /*  466412 */   // Label 7957: @466412
     /*  466412 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(466501), // Rule ID 14251 //
     /*  466417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  466428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  466431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  466434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466464 */     // MIs[1] Operand 1
     /*  466464 */     // No operand predicates
     /*  466464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466473 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466499 */     GIR_RootConstrainSelectedInstOperands,
     /*  466500 */     // GIR_Coverage, 14251,
     /*  466500 */     GIR_EraseRootFromParent_Done,
     /*  466501 */   // Label 7958: @466501
     /*  466501 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(466590), // Rule ID 14254 //
     /*  466506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  466517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  466523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466553 */     // MIs[1] Operand 1
     /*  466553 */     // No operand predicates
     /*  466553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466562 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466588 */     GIR_RootConstrainSelectedInstOperands,
     /*  466589 */     // GIR_Coverage, 14254,
     /*  466589 */     GIR_EraseRootFromParent_Done,
     /*  466590 */   // Label 7959: @466590
     /*  466590 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(466679), // Rule ID 14255 //
     /*  466595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  466606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  466612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466642 */     // MIs[1] Operand 1
     /*  466642 */     // No operand predicates
     /*  466642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466651 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466677 */     GIR_RootConstrainSelectedInstOperands,
     /*  466678 */     // GIR_Coverage, 14255,
     /*  466678 */     GIR_EraseRootFromParent_Done,
     /*  466679 */   // Label 7960: @466679
     /*  466679 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(466768), // Rule ID 14258 //
     /*  466684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  466695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  466698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  466701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466731 */     // MIs[1] Operand 1
     /*  466731 */     // No operand predicates
     /*  466731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466766 */     GIR_RootConstrainSelectedInstOperands,
     /*  466767 */     // GIR_Coverage, 14258,
     /*  466767 */     GIR_EraseRootFromParent_Done,
     /*  466768 */   // Label 7961: @466768
     /*  466768 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(466857), // Rule ID 14259 //
     /*  466773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  466784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  466787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  466790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466820 */     // MIs[1] Operand 1
     /*  466820 */     // No operand predicates
     /*  466820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466829 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  466829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466855 */     GIR_RootConstrainSelectedInstOperands,
     /*  466856 */     // GIR_Coverage, 14259,
     /*  466856 */     GIR_EraseRootFromParent_Done,
     /*  466857 */   // Label 7962: @466857
     /*  466857 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(466946), // Rule ID 14262 //
     /*  466862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  466873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  466876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  466879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466909 */     // MIs[1] Operand 1
     /*  466909 */     // No operand predicates
     /*  466909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466944 */     GIR_RootConstrainSelectedInstOperands,
     /*  466945 */     // GIR_Coverage, 14262,
     /*  466945 */     GIR_EraseRootFromParent_Done,
     /*  466946 */   // Label 7963: @466946
     /*  466946 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(467035), // Rule ID 14263 //
     /*  466951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  466962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  466965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  466968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466998 */     // MIs[1] Operand 1
     /*  466998 */     // No operand predicates
     /*  466998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467007 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  467007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467033 */     GIR_RootConstrainSelectedInstOperands,
     /*  467034 */     // GIR_Coverage, 14263,
     /*  467034 */     GIR_EraseRootFromParent_Done,
     /*  467035 */   // Label 7964: @467035
     /*  467035 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(467124), // Rule ID 14266 //
     /*  467040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  467051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  467054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  467057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467087 */     // MIs[1] Operand 1
     /*  467087 */     // No operand predicates
     /*  467087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  467096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  467116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467122 */     GIR_RootConstrainSelectedInstOperands,
     /*  467123 */     // GIR_Coverage, 14266,
     /*  467123 */     GIR_EraseRootFromParent_Done,
     /*  467124 */   // Label 7965: @467124
     /*  467124 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(467213), // Rule ID 14267 //
     /*  467129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  467140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  467143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  467146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467176 */     // MIs[1] Operand 1
     /*  467176 */     // No operand predicates
     /*  467176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467185 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  467185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  467205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467211 */     GIR_RootConstrainSelectedInstOperands,
     /*  467212 */     // GIR_Coverage, 14267,
     /*  467212 */     GIR_EraseRootFromParent_Done,
     /*  467213 */   // Label 7966: @467213
     /*  467213 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(467302), // Rule ID 14270 //
     /*  467218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  467221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  467229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  467232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  467235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467265 */     // MIs[1] Operand 1
     /*  467265 */     // No operand predicates
     /*  467265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  467274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  467294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467300 */     GIR_RootConstrainSelectedInstOperands,
     /*  467301 */     // GIR_Coverage, 14270,
     /*  467301 */     GIR_EraseRootFromParent_Done,
     /*  467302 */   // Label 7967: @467302
     /*  467302 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(467391), // Rule ID 14271 //
     /*  467307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  467310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  467318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  467321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  467324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467354 */     // MIs[1] Operand 1
     /*  467354 */     // No operand predicates
     /*  467354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467363 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  467363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  467383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467389 */     GIR_RootConstrainSelectedInstOperands,
     /*  467390 */     // GIR_Coverage, 14271,
     /*  467390 */     GIR_EraseRootFromParent_Done,
     /*  467391 */   // Label 7968: @467391
     /*  467391 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(467480), // Rule ID 14274 //
     /*  467396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  467413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467443 */     // MIs[1] Operand 1
     /*  467443 */     // No operand predicates
     /*  467443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467452 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  467455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467478 */     GIR_RootConstrainSelectedInstOperands,
     /*  467479 */     // GIR_Coverage, 14274,
     /*  467479 */     GIR_EraseRootFromParent_Done,
     /*  467480 */   // Label 7969: @467480
     /*  467480 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(467569), // Rule ID 14275 //
     /*  467485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  467502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467532 */     // MIs[1] Operand 1
     /*  467532 */     // No operand predicates
     /*  467532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467541 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  467544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467567 */     GIR_RootConstrainSelectedInstOperands,
     /*  467568 */     // GIR_Coverage, 14275,
     /*  467568 */     GIR_EraseRootFromParent_Done,
     /*  467569 */   // Label 7970: @467569
     /*  467569 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(467658), // Rule ID 14278 //
     /*  467574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  467585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  467588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  467591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467621 */     // MIs[1] Operand 1
     /*  467621 */     // No operand predicates
     /*  467621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467630 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  467633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467656 */     GIR_RootConstrainSelectedInstOperands,
     /*  467657 */     // GIR_Coverage, 14278,
     /*  467657 */     GIR_EraseRootFromParent_Done,
     /*  467658 */   // Label 7971: @467658
     /*  467658 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(467747), // Rule ID 14279 //
     /*  467663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  467674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  467677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  467680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467710 */     // MIs[1] Operand 1
     /*  467710 */     // No operand predicates
     /*  467710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467719 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  467722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467745 */     GIR_RootConstrainSelectedInstOperands,
     /*  467746 */     // GIR_Coverage, 14279,
     /*  467746 */     GIR_EraseRootFromParent_Done,
     /*  467747 */   // Label 7972: @467747
     /*  467747 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(467836), // Rule ID 14282 //
     /*  467752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  467763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  467766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  467769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467799 */     // MIs[1] Operand 1
     /*  467799 */     // No operand predicates
     /*  467799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467808 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  467811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467834 */     GIR_RootConstrainSelectedInstOperands,
     /*  467835 */     // GIR_Coverage, 14282,
     /*  467835 */     GIR_EraseRootFromParent_Done,
     /*  467836 */   // Label 7973: @467836
     /*  467836 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(467925), // Rule ID 14283 //
     /*  467841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  467852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  467855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  467858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467888 */     // MIs[1] Operand 1
     /*  467888 */     // No operand predicates
     /*  467888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467897 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  467900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467923 */     GIR_RootConstrainSelectedInstOperands,
     /*  467924 */     // GIR_Coverage, 14283,
     /*  467924 */     GIR_EraseRootFromParent_Done,
     /*  467925 */   // Label 7974: @467925
     /*  467925 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(468014), // Rule ID 14286 //
     /*  467930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  467941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  467944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  467947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467977 */     // MIs[1] Operand 1
     /*  467977 */     // No operand predicates
     /*  467977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  467986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  467989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468012 */     GIR_RootConstrainSelectedInstOperands,
     /*  468013 */     // GIR_Coverage, 14286,
     /*  468013 */     GIR_EraseRootFromParent_Done,
     /*  468014 */   // Label 7975: @468014
     /*  468014 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(468103), // Rule ID 14287 //
     /*  468019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  468030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  468033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  468036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468066 */     // MIs[1] Operand 1
     /*  468066 */     // No operand predicates
     /*  468066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468075 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468101 */     GIR_RootConstrainSelectedInstOperands,
     /*  468102 */     // GIR_Coverage, 14287,
     /*  468102 */     GIR_EraseRootFromParent_Done,
     /*  468103 */   // Label 7976: @468103
     /*  468103 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(468192), // Rule ID 14290 //
     /*  468108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  468119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  468122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  468125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468155 */     // MIs[1] Operand 1
     /*  468155 */     // No operand predicates
     /*  468155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468164 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468190 */     GIR_RootConstrainSelectedInstOperands,
     /*  468191 */     // GIR_Coverage, 14290,
     /*  468191 */     GIR_EraseRootFromParent_Done,
     /*  468192 */   // Label 7977: @468192
     /*  468192 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(468281), // Rule ID 14291 //
     /*  468197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  468208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  468211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  468214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468244 */     // MIs[1] Operand 1
     /*  468244 */     // No operand predicates
     /*  468244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468253 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468279 */     GIR_RootConstrainSelectedInstOperands,
     /*  468280 */     // GIR_Coverage, 14291,
     /*  468280 */     GIR_EraseRootFromParent_Done,
     /*  468281 */   // Label 7978: @468281
     /*  468281 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(468370), // Rule ID 14294 //
     /*  468286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  468297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  468300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  468303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468333 */     // MIs[1] Operand 1
     /*  468333 */     // No operand predicates
     /*  468333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468342 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468368 */     GIR_RootConstrainSelectedInstOperands,
     /*  468369 */     // GIR_Coverage, 14294,
     /*  468369 */     GIR_EraseRootFromParent_Done,
     /*  468370 */   // Label 7979: @468370
     /*  468370 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(468459), // Rule ID 14295 //
     /*  468375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  468386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  468389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  468392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468422 */     // MIs[1] Operand 1
     /*  468422 */     // No operand predicates
     /*  468422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468431 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468457 */     GIR_RootConstrainSelectedInstOperands,
     /*  468458 */     // GIR_Coverage, 14295,
     /*  468458 */     GIR_EraseRootFromParent_Done,
     /*  468459 */   // Label 7980: @468459
     /*  468459 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(468548), // Rule ID 14298 //
     /*  468464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  468475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  468478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  468481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468511 */     // MIs[1] Operand 1
     /*  468511 */     // No operand predicates
     /*  468511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468520 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468546 */     GIR_RootConstrainSelectedInstOperands,
     /*  468547 */     // GIR_Coverage, 14298,
     /*  468547 */     GIR_EraseRootFromParent_Done,
     /*  468548 */   // Label 7981: @468548
     /*  468548 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(468637), // Rule ID 14299 //
     /*  468553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  468564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  468567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  468570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468600 */     // MIs[1] Operand 1
     /*  468600 */     // No operand predicates
     /*  468600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468609 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468635 */     GIR_RootConstrainSelectedInstOperands,
     /*  468636 */     // GIR_Coverage, 14299,
     /*  468636 */     GIR_EraseRootFromParent_Done,
     /*  468637 */   // Label 7982: @468637
     /*  468637 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(468726), // Rule ID 14302 //
     /*  468642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  468653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  468656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  468659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468689 */     // MIs[1] Operand 1
     /*  468689 */     // No operand predicates
     /*  468689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468698 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468724 */     GIR_RootConstrainSelectedInstOperands,
     /*  468725 */     // GIR_Coverage, 14302,
     /*  468725 */     GIR_EraseRootFromParent_Done,
     /*  468726 */   // Label 7983: @468726
     /*  468726 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(468815), // Rule ID 14303 //
     /*  468731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  468742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  468745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  468748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468778 */     // MIs[1] Operand 1
     /*  468778 */     // No operand predicates
     /*  468778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468787 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468813 */     GIR_RootConstrainSelectedInstOperands,
     /*  468814 */     // GIR_Coverage, 14303,
     /*  468814 */     GIR_EraseRootFromParent_Done,
     /*  468815 */   // Label 7984: @468815
     /*  468815 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(468904), // Rule ID 14306 //
     /*  468820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  468831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  468834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  468837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468867 */     // MIs[1] Operand 1
     /*  468867 */     // No operand predicates
     /*  468867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468876 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468902 */     GIR_RootConstrainSelectedInstOperands,
     /*  468903 */     // GIR_Coverage, 14306,
     /*  468903 */     GIR_EraseRootFromParent_Done,
     /*  468904 */   // Label 7985: @468904
     /*  468904 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(468993), // Rule ID 14307 //
     /*  468909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  468920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  468923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  468926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468956 */     // MIs[1] Operand 1
     /*  468956 */     // No operand predicates
     /*  468956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468965 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468991 */     GIR_RootConstrainSelectedInstOperands,
     /*  468992 */     // GIR_Coverage, 14307,
     /*  468992 */     GIR_EraseRootFromParent_Done,
     /*  468993 */   // Label 7986: @468993
     /*  468993 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(469082), // Rule ID 14310 //
     /*  468998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  469001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  469009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  469012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  469015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469045 */     // MIs[1] Operand 1
     /*  469045 */     // No operand predicates
     /*  469045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469054 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  469054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  469057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469080 */     GIR_RootConstrainSelectedInstOperands,
     /*  469081 */     // GIR_Coverage, 14310,
     /*  469081 */     GIR_EraseRootFromParent_Done,
     /*  469082 */   // Label 7987: @469082
     /*  469082 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(469171), // Rule ID 14311 //
     /*  469087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  469090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  469098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  469101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  469104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469134 */     // MIs[1] Operand 1
     /*  469134 */     // No operand predicates
     /*  469134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  469143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  469146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469169 */     GIR_RootConstrainSelectedInstOperands,
     /*  469170 */     // GIR_Coverage, 14311,
     /*  469170 */     GIR_EraseRootFromParent_Done,
     /*  469171 */   // Label 7988: @469171
     /*  469171 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(469260), // Rule ID 14314 //
     /*  469176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  469179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  469187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  469190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  469193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469223 */     // MIs[1] Operand 1
     /*  469223 */     // No operand predicates
     /*  469223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469232 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  469232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  469235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469258 */     GIR_RootConstrainSelectedInstOperands,
     /*  469259 */     // GIR_Coverage, 14314,
     /*  469259 */     GIR_EraseRootFromParent_Done,
     /*  469260 */   // Label 7989: @469260
     /*  469260 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(469349), // Rule ID 14315 //
     /*  469265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  469268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  469276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  469279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  469282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469312 */     // MIs[1] Operand 1
     /*  469312 */     // No operand predicates
     /*  469312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469321 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  469321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  469324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469347 */     GIR_RootConstrainSelectedInstOperands,
     /*  469348 */     // GIR_Coverage, 14315,
     /*  469348 */     GIR_EraseRootFromParent_Done,
     /*  469349 */   // Label 7990: @469349
     /*  469349 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(469438), // Rule ID 14318 //
     /*  469354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  469357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  469365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  469368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  469371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469401 */     // MIs[1] Operand 1
     /*  469401 */     // No operand predicates
     /*  469401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469410 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  469410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  469413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469436 */     GIR_RootConstrainSelectedInstOperands,
     /*  469437 */     // GIR_Coverage, 14318,
     /*  469437 */     GIR_EraseRootFromParent_Done,
     /*  469438 */   // Label 7991: @469438
     /*  469438 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(469527), // Rule ID 14319 //
     /*  469443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  469446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  469454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  469457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  469460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469490 */     // MIs[1] Operand 1
     /*  469490 */     // No operand predicates
     /*  469490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469499 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  469499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  469502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469525 */     GIR_RootConstrainSelectedInstOperands,
     /*  469526 */     // GIR_Coverage, 14319,
     /*  469526 */     GIR_EraseRootFromParent_Done,
     /*  469527 */   // Label 7992: @469527
     /*  469527 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(469616), // Rule ID 14498 //
     /*  469532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  469543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  469546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  469549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469579 */     // MIs[1] Operand 1
     /*  469579 */     // No operand predicates
     /*  469579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469588 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  469591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469614 */     GIR_RootConstrainSelectedInstOperands,
     /*  469615 */     // GIR_Coverage, 14498,
     /*  469615 */     GIR_EraseRootFromParent_Done,
     /*  469616 */   // Label 7993: @469616
     /*  469616 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(469705), // Rule ID 14499 //
     /*  469621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  469632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  469635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  469638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469668 */     // MIs[1] Operand 1
     /*  469668 */     // No operand predicates
     /*  469668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469677 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  469680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469703 */     GIR_RootConstrainSelectedInstOperands,
     /*  469704 */     // GIR_Coverage, 14499,
     /*  469704 */     GIR_EraseRootFromParent_Done,
     /*  469705 */   // Label 7994: @469705
     /*  469705 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(469794), // Rule ID 14502 //
     /*  469710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  469721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  469724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  469727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469757 */     // MIs[1] Operand 1
     /*  469757 */     // No operand predicates
     /*  469757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469766 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  469769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469792 */     GIR_RootConstrainSelectedInstOperands,
     /*  469793 */     // GIR_Coverage, 14502,
     /*  469793 */     GIR_EraseRootFromParent_Done,
     /*  469794 */   // Label 7995: @469794
     /*  469794 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(469883), // Rule ID 14503 //
     /*  469799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  469810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  469813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  469816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469846 */     // MIs[1] Operand 1
     /*  469846 */     // No operand predicates
     /*  469846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469855 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  469858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469881 */     GIR_RootConstrainSelectedInstOperands,
     /*  469882 */     // GIR_Coverage, 14503,
     /*  469882 */     GIR_EraseRootFromParent_Done,
     /*  469883 */   // Label 7996: @469883
     /*  469883 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(469972), // Rule ID 14506 //
     /*  469888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  469899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  469902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  469905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469935 */     // MIs[1] Operand 1
     /*  469935 */     // No operand predicates
     /*  469935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469944 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  469947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469970 */     GIR_RootConstrainSelectedInstOperands,
     /*  469971 */     // GIR_Coverage, 14506,
     /*  469971 */     GIR_EraseRootFromParent_Done,
     /*  469972 */   // Label 7997: @469972
     /*  469972 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(470061), // Rule ID 14507 //
     /*  469977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  469988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  469991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  469994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470024 */     // MIs[1] Operand 1
     /*  470024 */     // No operand predicates
     /*  470024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470033 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470059 */     GIR_RootConstrainSelectedInstOperands,
     /*  470060 */     // GIR_Coverage, 14507,
     /*  470060 */     GIR_EraseRootFromParent_Done,
     /*  470061 */   // Label 7998: @470061
     /*  470061 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(470150), // Rule ID 14510 //
     /*  470066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  470077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  470080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  470083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470113 */     // MIs[1] Operand 1
     /*  470113 */     // No operand predicates
     /*  470113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470122 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  470125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470148 */     GIR_RootConstrainSelectedInstOperands,
     /*  470149 */     // GIR_Coverage, 14510,
     /*  470149 */     GIR_EraseRootFromParent_Done,
     /*  470150 */   // Label 7999: @470150
     /*  470150 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(470239), // Rule ID 14511 //
     /*  470155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  470166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  470169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  470172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470202 */     // MIs[1] Operand 1
     /*  470202 */     // No operand predicates
     /*  470202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470211 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  470214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470237 */     GIR_RootConstrainSelectedInstOperands,
     /*  470238 */     // GIR_Coverage, 14511,
     /*  470238 */     GIR_EraseRootFromParent_Done,
     /*  470239 */   // Label 8000: @470239
     /*  470239 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(470328), // Rule ID 14514 //
     /*  470244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  470255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  470258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  470261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470291 */     // MIs[1] Operand 1
     /*  470291 */     // No operand predicates
     /*  470291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470300 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470326 */     GIR_RootConstrainSelectedInstOperands,
     /*  470327 */     // GIR_Coverage, 14514,
     /*  470327 */     GIR_EraseRootFromParent_Done,
     /*  470328 */   // Label 8001: @470328
     /*  470328 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(470417), // Rule ID 14515 //
     /*  470333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  470344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  470347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  470350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470380 */     // MIs[1] Operand 1
     /*  470380 */     // No operand predicates
     /*  470380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470389 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470415 */     GIR_RootConstrainSelectedInstOperands,
     /*  470416 */     // GIR_Coverage, 14515,
     /*  470416 */     GIR_EraseRootFromParent_Done,
     /*  470417 */   // Label 8002: @470417
     /*  470417 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(470506), // Rule ID 14518 //
     /*  470422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  470433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  470436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  470439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470469 */     // MIs[1] Operand 1
     /*  470469 */     // No operand predicates
     /*  470469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  470478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470504 */     GIR_RootConstrainSelectedInstOperands,
     /*  470505 */     // GIR_Coverage, 14518,
     /*  470505 */     GIR_EraseRootFromParent_Done,
     /*  470506 */   // Label 8003: @470506
     /*  470506 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(470595), // Rule ID 14519 //
     /*  470511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  470522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  470525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  470528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470558 */     // MIs[1] Operand 1
     /*  470558 */     // No operand predicates
     /*  470558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470567 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  470567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470593 */     GIR_RootConstrainSelectedInstOperands,
     /*  470594 */     // GIR_Coverage, 14519,
     /*  470594 */     GIR_EraseRootFromParent_Done,
     /*  470595 */   // Label 8004: @470595
     /*  470595 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(470684), // Rule ID 14522 //
     /*  470600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  470611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  470614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  470617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470647 */     // MIs[1] Operand 1
     /*  470647 */     // No operand predicates
     /*  470647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470656 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470682 */     GIR_RootConstrainSelectedInstOperands,
     /*  470683 */     // GIR_Coverage, 14522,
     /*  470683 */     GIR_EraseRootFromParent_Done,
     /*  470684 */   // Label 8005: @470684
     /*  470684 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(470773), // Rule ID 14523 //
     /*  470689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  470700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  470703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  470706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470736 */     // MIs[1] Operand 1
     /*  470736 */     // No operand predicates
     /*  470736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470745 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470771 */     GIR_RootConstrainSelectedInstOperands,
     /*  470772 */     // GIR_Coverage, 14523,
     /*  470772 */     GIR_EraseRootFromParent_Done,
     /*  470773 */   // Label 8006: @470773
     /*  470773 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(470862), // Rule ID 14526 //
     /*  470778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  470789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  470792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  470795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470825 */     // MIs[1] Operand 1
     /*  470825 */     // No operand predicates
     /*  470825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470834 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470860 */     GIR_RootConstrainSelectedInstOperands,
     /*  470861 */     // GIR_Coverage, 14526,
     /*  470861 */     GIR_EraseRootFromParent_Done,
     /*  470862 */   // Label 8007: @470862
     /*  470862 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(470951), // Rule ID 14527 //
     /*  470867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  470878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  470881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  470884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470914 */     // MIs[1] Operand 1
     /*  470914 */     // No operand predicates
     /*  470914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470923 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470949 */     GIR_RootConstrainSelectedInstOperands,
     /*  470950 */     // GIR_Coverage, 14527,
     /*  470950 */     GIR_EraseRootFromParent_Done,
     /*  470951 */   // Label 8008: @470951
     /*  470951 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(471040), // Rule ID 14530 //
     /*  470956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  470967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  470970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  470973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471003 */     // MIs[1] Operand 1
     /*  471003 */     // No operand predicates
     /*  471003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471012 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  471012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471038 */     GIR_RootConstrainSelectedInstOperands,
     /*  471039 */     // GIR_Coverage, 14530,
     /*  471039 */     GIR_EraseRootFromParent_Done,
     /*  471040 */   // Label 8009: @471040
     /*  471040 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(471129), // Rule ID 14531 //
     /*  471045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  471056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  471059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  471062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471092 */     // MIs[1] Operand 1
     /*  471092 */     // No operand predicates
     /*  471092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471101 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  471101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471127 */     GIR_RootConstrainSelectedInstOperands,
     /*  471128 */     // GIR_Coverage, 14531,
     /*  471128 */     GIR_EraseRootFromParent_Done,
     /*  471129 */   // Label 8010: @471129
     /*  471129 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(471218), // Rule ID 14534 //
     /*  471134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  471137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  471145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  471148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  471151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471181 */     // MIs[1] Operand 1
     /*  471181 */     // No operand predicates
     /*  471181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471190 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  471190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471216 */     GIR_RootConstrainSelectedInstOperands,
     /*  471217 */     // GIR_Coverage, 14534,
     /*  471217 */     GIR_EraseRootFromParent_Done,
     /*  471218 */   // Label 8011: @471218
     /*  471218 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(471307), // Rule ID 14535 //
     /*  471223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  471226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  471234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  471237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  471240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471270 */     // MIs[1] Operand 1
     /*  471270 */     // No operand predicates
     /*  471270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471279 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  471279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471305 */     GIR_RootConstrainSelectedInstOperands,
     /*  471306 */     // GIR_Coverage, 14535,
     /*  471306 */     GIR_EraseRootFromParent_Done,
     /*  471307 */   // Label 8012: @471307
     /*  471307 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(471396), // Rule ID 14538 //
     /*  471312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  471323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  471326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  471329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471359 */     // MIs[1] Operand 1
     /*  471359 */     // No operand predicates
     /*  471359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471368 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471394 */     GIR_RootConstrainSelectedInstOperands,
     /*  471395 */     // GIR_Coverage, 14538,
     /*  471395 */     GIR_EraseRootFromParent_Done,
     /*  471396 */   // Label 8013: @471396
     /*  471396 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(471485), // Rule ID 14539 //
     /*  471401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  471412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  471415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  471418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471448 */     // MIs[1] Operand 1
     /*  471448 */     // No operand predicates
     /*  471448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471457 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471483 */     GIR_RootConstrainSelectedInstOperands,
     /*  471484 */     // GIR_Coverage, 14539,
     /*  471484 */     GIR_EraseRootFromParent_Done,
     /*  471485 */   // Label 8014: @471485
     /*  471485 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(471574), // Rule ID 14542 //
     /*  471490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  471501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  471504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  471507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471537 */     // MIs[1] Operand 1
     /*  471537 */     // No operand predicates
     /*  471537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  471549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471572 */     GIR_RootConstrainSelectedInstOperands,
     /*  471573 */     // GIR_Coverage, 14542,
     /*  471573 */     GIR_EraseRootFromParent_Done,
     /*  471574 */   // Label 8015: @471574
     /*  471574 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(471663), // Rule ID 14543 //
     /*  471579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  471590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  471593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  471596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471622 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471626 */     // MIs[1] Operand 1
     /*  471626 */     // No operand predicates
     /*  471626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471635 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  471638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471658 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471661 */     GIR_RootConstrainSelectedInstOperands,
     /*  471662 */     // GIR_Coverage, 14543,
     /*  471662 */     GIR_EraseRootFromParent_Done,
     /*  471663 */   // Label 8016: @471663
     /*  471663 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(471752), // Rule ID 14546 //
     /*  471668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  471679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  471682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  471685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471715 */     // MIs[1] Operand 1
     /*  471715 */     // No operand predicates
     /*  471715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471724 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  471727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471750 */     GIR_RootConstrainSelectedInstOperands,
     /*  471751 */     // GIR_Coverage, 14546,
     /*  471751 */     GIR_EraseRootFromParent_Done,
     /*  471752 */   // Label 8017: @471752
     /*  471752 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(471841), // Rule ID 14547 //
     /*  471757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  471768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  471771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  471774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471804 */     // MIs[1] Operand 1
     /*  471804 */     // No operand predicates
     /*  471804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471813 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  471816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471839 */     GIR_RootConstrainSelectedInstOperands,
     /*  471840 */     // GIR_Coverage, 14547,
     /*  471840 */     GIR_EraseRootFromParent_Done,
     /*  471841 */   // Label 8018: @471841
     /*  471841 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(471930), // Rule ID 14550 //
     /*  471846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  471857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  471860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  471863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471893 */     // MIs[1] Operand 1
     /*  471893 */     // No operand predicates
     /*  471893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  471902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471928 */     GIR_RootConstrainSelectedInstOperands,
     /*  471929 */     // GIR_Coverage, 14550,
     /*  471929 */     GIR_EraseRootFromParent_Done,
     /*  471930 */   // Label 8019: @471930
     /*  471930 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(472019), // Rule ID 14551 //
     /*  471935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  471946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  471949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  471952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471982 */     // MIs[1] Operand 1
     /*  471982 */     // No operand predicates
     /*  471982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471991 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  471991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472017 */     GIR_RootConstrainSelectedInstOperands,
     /*  472018 */     // GIR_Coverage, 14551,
     /*  472018 */     GIR_EraseRootFromParent_Done,
     /*  472019 */   // Label 8020: @472019
     /*  472019 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(472108), // Rule ID 14554 //
     /*  472024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  472035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  472038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  472041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472071 */     // MIs[1] Operand 1
     /*  472071 */     // No operand predicates
     /*  472071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472080 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  472080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472106 */     GIR_RootConstrainSelectedInstOperands,
     /*  472107 */     // GIR_Coverage, 14554,
     /*  472107 */     GIR_EraseRootFromParent_Done,
     /*  472108 */   // Label 8021: @472108
     /*  472108 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(472197), // Rule ID 14555 //
     /*  472113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  472124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  472127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  472130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472160 */     // MIs[1] Operand 1
     /*  472160 */     // No operand predicates
     /*  472160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472169 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472195 */     GIR_RootConstrainSelectedInstOperands,
     /*  472196 */     // GIR_Coverage, 14555,
     /*  472196 */     GIR_EraseRootFromParent_Done,
     /*  472197 */   // Label 8022: @472197
     /*  472197 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(472286), // Rule ID 14558 //
     /*  472202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  472213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  472216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  472219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472249 */     // MIs[1] Operand 1
     /*  472249 */     // No operand predicates
     /*  472249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472258 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  472258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472284 */     GIR_RootConstrainSelectedInstOperands,
     /*  472285 */     // GIR_Coverage, 14558,
     /*  472285 */     GIR_EraseRootFromParent_Done,
     /*  472286 */   // Label 8023: @472286
     /*  472286 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(472375), // Rule ID 14559 //
     /*  472291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  472302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  472305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  472308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472338 */     // MIs[1] Operand 1
     /*  472338 */     // No operand predicates
     /*  472338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472347 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472373 */     GIR_RootConstrainSelectedInstOperands,
     /*  472374 */     // GIR_Coverage, 14559,
     /*  472374 */     GIR_EraseRootFromParent_Done,
     /*  472375 */   // Label 8024: @472375
     /*  472375 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(472464), // Rule ID 14562 //
     /*  472380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  472391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  472394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  472397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472427 */     // MIs[1] Operand 1
     /*  472427 */     // No operand predicates
     /*  472427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472462 */     GIR_RootConstrainSelectedInstOperands,
     /*  472463 */     // GIR_Coverage, 14562,
     /*  472463 */     GIR_EraseRootFromParent_Done,
     /*  472464 */   // Label 8025: @472464
     /*  472464 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(472553), // Rule ID 14563 //
     /*  472469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  472480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  472483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  472486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472516 */     // MIs[1] Operand 1
     /*  472516 */     // No operand predicates
     /*  472516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472525 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472551 */     GIR_RootConstrainSelectedInstOperands,
     /*  472552 */     // GIR_Coverage, 14563,
     /*  472552 */     GIR_EraseRootFromParent_Done,
     /*  472553 */   // Label 8026: @472553
     /*  472553 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(472642), // Rule ID 14566 //
     /*  472558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  472569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  472572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  472575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472605 */     // MIs[1] Operand 1
     /*  472605 */     // No operand predicates
     /*  472605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472614 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472640 */     GIR_RootConstrainSelectedInstOperands,
     /*  472641 */     // GIR_Coverage, 14566,
     /*  472641 */     GIR_EraseRootFromParent_Done,
     /*  472642 */   // Label 8027: @472642
     /*  472642 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(472731), // Rule ID 14567 //
     /*  472647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  472658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  472661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  472664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472694 */     // MIs[1] Operand 1
     /*  472694 */     // No operand predicates
     /*  472694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472703 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472729 */     GIR_RootConstrainSelectedInstOperands,
     /*  472730 */     // GIR_Coverage, 14567,
     /*  472730 */     GIR_EraseRootFromParent_Done,
     /*  472731 */   // Label 8028: @472731
     /*  472731 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(472820), // Rule ID 14570 //
     /*  472736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  472747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  472750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  472753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472783 */     // MIs[1] Operand 1
     /*  472783 */     // No operand predicates
     /*  472783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472792 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472818 */     GIR_RootConstrainSelectedInstOperands,
     /*  472819 */     // GIR_Coverage, 14570,
     /*  472819 */     GIR_EraseRootFromParent_Done,
     /*  472820 */   // Label 8029: @472820
     /*  472820 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(472909), // Rule ID 14571 //
     /*  472825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  472836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  472839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  472842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472872 */     // MIs[1] Operand 1
     /*  472872 */     // No operand predicates
     /*  472872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472881 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472907 */     GIR_RootConstrainSelectedInstOperands,
     /*  472908 */     // GIR_Coverage, 14571,
     /*  472908 */     GIR_EraseRootFromParent_Done,
     /*  472909 */   // Label 8030: @472909
     /*  472909 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(472998), // Rule ID 14574 //
     /*  472914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  472917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  472925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  472928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  472931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472961 */     // MIs[1] Operand 1
     /*  472961 */     // No operand predicates
     /*  472961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472970 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  472970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472996 */     GIR_RootConstrainSelectedInstOperands,
     /*  472997 */     // GIR_Coverage, 14574,
     /*  472997 */     GIR_EraseRootFromParent_Done,
     /*  472998 */   // Label 8031: @472998
     /*  472998 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(473087), // Rule ID 14575 //
     /*  473003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  473014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  473017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  473020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473050 */     // MIs[1] Operand 1
     /*  473050 */     // No operand predicates
     /*  473050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  473062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473085 */     GIR_RootConstrainSelectedInstOperands,
     /*  473086 */     // GIR_Coverage, 14575,
     /*  473086 */     GIR_EraseRootFromParent_Done,
     /*  473087 */   // Label 8032: @473087
     /*  473087 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(473176), // Rule ID 14578 //
     /*  473092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  473103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  473106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  473109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473139 */     // MIs[1] Operand 1
     /*  473139 */     // No operand predicates
     /*  473139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473148 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  473151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473174 */     GIR_RootConstrainSelectedInstOperands,
     /*  473175 */     // GIR_Coverage, 14578,
     /*  473175 */     GIR_EraseRootFromParent_Done,
     /*  473176 */   // Label 8033: @473176
     /*  473176 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(473265), // Rule ID 14579 //
     /*  473181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  473192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  473195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  473198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473228 */     // MIs[1] Operand 1
     /*  473228 */     // No operand predicates
     /*  473228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473237 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  473240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473263 */     GIR_RootConstrainSelectedInstOperands,
     /*  473264 */     // GIR_Coverage, 14579,
     /*  473264 */     GIR_EraseRootFromParent_Done,
     /*  473265 */   // Label 8034: @473265
     /*  473265 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(473354), // Rule ID 14582 //
     /*  473270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  473281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  473284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  473287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473317 */     // MIs[1] Operand 1
     /*  473317 */     // No operand predicates
     /*  473317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473326 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  473329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473352 */     GIR_RootConstrainSelectedInstOperands,
     /*  473353 */     // GIR_Coverage, 14582,
     /*  473353 */     GIR_EraseRootFromParent_Done,
     /*  473354 */   // Label 8035: @473354
     /*  473354 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(473443), // Rule ID 14583 //
     /*  473359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  473370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  473373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  473376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473406 */     // MIs[1] Operand 1
     /*  473406 */     // No operand predicates
     /*  473406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473415 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  473418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473441 */     GIR_RootConstrainSelectedInstOperands,
     /*  473442 */     // GIR_Coverage, 14583,
     /*  473442 */     GIR_EraseRootFromParent_Done,
     /*  473443 */   // Label 8036: @473443
     /*  473443 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(473529), // Rule ID 24678 //
     /*  473448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  473459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  473462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  473465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473495 */     // MIs[1] Operand 1
     /*  473495 */     // No operand predicates
     /*  473495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473504 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  473507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473527 */     GIR_RootConstrainSelectedInstOperands,
     /*  473528 */     // GIR_Coverage, 24678,
     /*  473528 */     GIR_EraseRootFromParent_Done,
     /*  473529 */   // Label 8037: @473529
     /*  473529 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(473615), // Rule ID 24679 //
     /*  473534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  473545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  473548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  473551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473581 */     // MIs[1] Operand 1
     /*  473581 */     // No operand predicates
     /*  473581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473590 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  473593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473613 */     GIR_RootConstrainSelectedInstOperands,
     /*  473614 */     // GIR_Coverage, 24679,
     /*  473614 */     GIR_EraseRootFromParent_Done,
     /*  473615 */   // Label 8038: @473615
     /*  473615 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(473701), // Rule ID 24682 //
     /*  473620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  473631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  473634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  473637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473667 */     // MIs[1] Operand 1
     /*  473667 */     // No operand predicates
     /*  473667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473676 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  473679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473699 */     GIR_RootConstrainSelectedInstOperands,
     /*  473700 */     // GIR_Coverage, 24682,
     /*  473700 */     GIR_EraseRootFromParent_Done,
     /*  473701 */   // Label 8039: @473701
     /*  473701 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(473787), // Rule ID 24683 //
     /*  473706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  473717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  473720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  473723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473753 */     // MIs[1] Operand 1
     /*  473753 */     // No operand predicates
     /*  473753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473762 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  473765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473785 */     GIR_RootConstrainSelectedInstOperands,
     /*  473786 */     // GIR_Coverage, 24683,
     /*  473786 */     GIR_EraseRootFromParent_Done,
     /*  473787 */   // Label 8040: @473787
     /*  473787 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(473873), // Rule ID 24686 //
     /*  473792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  473803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  473806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  473809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473839 */     // MIs[1] Operand 1
     /*  473839 */     // No operand predicates
     /*  473839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473848 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  473851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473871 */     GIR_RootConstrainSelectedInstOperands,
     /*  473872 */     // GIR_Coverage, 24686,
     /*  473872 */     GIR_EraseRootFromParent_Done,
     /*  473873 */   // Label 8041: @473873
     /*  473873 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(473959), // Rule ID 24687 //
     /*  473878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  473889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  473892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  473895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473925 */     // MIs[1] Operand 1
     /*  473925 */     // No operand predicates
     /*  473925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473934 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  473937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473957 */     GIR_RootConstrainSelectedInstOperands,
     /*  473958 */     // GIR_Coverage, 24687,
     /*  473958 */     GIR_EraseRootFromParent_Done,
     /*  473959 */   // Label 8042: @473959
     /*  473959 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(474045), // Rule ID 24690 //
     /*  473964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  473975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  473978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  473981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474011 */     // MIs[1] Operand 1
     /*  474011 */     // No operand predicates
     /*  474011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474020 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  474023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474043 */     GIR_RootConstrainSelectedInstOperands,
     /*  474044 */     // GIR_Coverage, 24690,
     /*  474044 */     GIR_EraseRootFromParent_Done,
     /*  474045 */   // Label 8043: @474045
     /*  474045 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(474131), // Rule ID 24691 //
     /*  474050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  474061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  474064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  474067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474097 */     // MIs[1] Operand 1
     /*  474097 */     // No operand predicates
     /*  474097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474106 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  474109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474129 */     GIR_RootConstrainSelectedInstOperands,
     /*  474130 */     // GIR_Coverage, 24691,
     /*  474130 */     GIR_EraseRootFromParent_Done,
     /*  474131 */   // Label 8044: @474131
     /*  474131 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(474217), // Rule ID 24694 //
     /*  474136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  474153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474183 */     // MIs[1] Operand 1
     /*  474183 */     // No operand predicates
     /*  474183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474192 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474215 */     GIR_RootConstrainSelectedInstOperands,
     /*  474216 */     // GIR_Coverage, 24694,
     /*  474216 */     GIR_EraseRootFromParent_Done,
     /*  474217 */   // Label 8045: @474217
     /*  474217 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(474303), // Rule ID 24695 //
     /*  474222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  474239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474269 */     // MIs[1] Operand 1
     /*  474269 */     // No operand predicates
     /*  474269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474278 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474301 */     GIR_RootConstrainSelectedInstOperands,
     /*  474302 */     // GIR_Coverage, 24695,
     /*  474302 */     GIR_EraseRootFromParent_Done,
     /*  474303 */   // Label 8046: @474303
     /*  474303 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(474389), // Rule ID 24698 //
     /*  474308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  474319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  474322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  474325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474355 */     // MIs[1] Operand 1
     /*  474355 */     // No operand predicates
     /*  474355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474364 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474387 */     GIR_RootConstrainSelectedInstOperands,
     /*  474388 */     // GIR_Coverage, 24698,
     /*  474388 */     GIR_EraseRootFromParent_Done,
     /*  474389 */   // Label 8047: @474389
     /*  474389 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(474475), // Rule ID 24699 //
     /*  474394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  474405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  474408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  474411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474441 */     // MIs[1] Operand 1
     /*  474441 */     // No operand predicates
     /*  474441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474450 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474473 */     GIR_RootConstrainSelectedInstOperands,
     /*  474474 */     // GIR_Coverage, 24699,
     /*  474474 */     GIR_EraseRootFromParent_Done,
     /*  474475 */   // Label 8048: @474475
     /*  474475 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(474561), // Rule ID 24702 //
     /*  474480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  474491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  474494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  474497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474527 */     // MIs[1] Operand 1
     /*  474527 */     // No operand predicates
     /*  474527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474536 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474559 */     GIR_RootConstrainSelectedInstOperands,
     /*  474560 */     // GIR_Coverage, 24702,
     /*  474560 */     GIR_EraseRootFromParent_Done,
     /*  474561 */   // Label 8049: @474561
     /*  474561 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(474647), // Rule ID 24703 //
     /*  474566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  474577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  474580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  474583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474613 */     // MIs[1] Operand 1
     /*  474613 */     // No operand predicates
     /*  474613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474622 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474645 */     GIR_RootConstrainSelectedInstOperands,
     /*  474646 */     // GIR_Coverage, 24703,
     /*  474646 */     GIR_EraseRootFromParent_Done,
     /*  474647 */   // Label 8050: @474647
     /*  474647 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(474733), // Rule ID 24706 //
     /*  474652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  474663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  474666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  474669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474699 */     // MIs[1] Operand 1
     /*  474699 */     // No operand predicates
     /*  474699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474731 */     GIR_RootConstrainSelectedInstOperands,
     /*  474732 */     // GIR_Coverage, 24706,
     /*  474732 */     GIR_EraseRootFromParent_Done,
     /*  474733 */   // Label 8051: @474733
     /*  474733 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(474819), // Rule ID 24707 //
     /*  474738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  474749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  474752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  474755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474785 */     // MIs[1] Operand 1
     /*  474785 */     // No operand predicates
     /*  474785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474794 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474817 */     GIR_RootConstrainSelectedInstOperands,
     /*  474818 */     // GIR_Coverage, 24707,
     /*  474818 */     GIR_EraseRootFromParent_Done,
     /*  474819 */   // Label 8052: @474819
     /*  474819 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(474905), // Rule ID 24710 //
     /*  474824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  474835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  474838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  474841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474871 */     // MIs[1] Operand 1
     /*  474871 */     // No operand predicates
     /*  474871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474903 */     GIR_RootConstrainSelectedInstOperands,
     /*  474904 */     // GIR_Coverage, 24710,
     /*  474904 */     GIR_EraseRootFromParent_Done,
     /*  474905 */   // Label 8053: @474905
     /*  474905 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(474991), // Rule ID 24711 //
     /*  474910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  474921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  474924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  474927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474957 */     // MIs[1] Operand 1
     /*  474957 */     // No operand predicates
     /*  474957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474989 */     GIR_RootConstrainSelectedInstOperands,
     /*  474990 */     // GIR_Coverage, 24711,
     /*  474990 */     GIR_EraseRootFromParent_Done,
     /*  474991 */   // Label 8054: @474991
     /*  474991 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(475077), // Rule ID 24714 //
     /*  474996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  474999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  475007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  475010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  475013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475043 */     // MIs[1] Operand 1
     /*  475043 */     // No operand predicates
     /*  475043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  475052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  475072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475075 */     GIR_RootConstrainSelectedInstOperands,
     /*  475076 */     // GIR_Coverage, 24714,
     /*  475076 */     GIR_EraseRootFromParent_Done,
     /*  475077 */   // Label 8055: @475077
     /*  475077 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(475163), // Rule ID 24715 //
     /*  475082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  475085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  475093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  475096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  475099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475129 */     // MIs[1] Operand 1
     /*  475129 */     // No operand predicates
     /*  475129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475138 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  475138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  475158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475161 */     GIR_RootConstrainSelectedInstOperands,
     /*  475162 */     // GIR_Coverage, 24715,
     /*  475162 */     GIR_EraseRootFromParent_Done,
     /*  475163 */   // Label 8056: @475163
     /*  475163 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(475249), // Rule ID 24718 //
     /*  475168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  475179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  475182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475215 */     // MIs[1] Operand 1
     /*  475215 */     // No operand predicates
     /*  475215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475224 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475247 */     GIR_RootConstrainSelectedInstOperands,
     /*  475248 */     // GIR_Coverage, 24718,
     /*  475248 */     GIR_EraseRootFromParent_Done,
     /*  475249 */   // Label 8057: @475249
     /*  475249 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(475335), // Rule ID 24719 //
     /*  475254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  475265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  475268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475301 */     // MIs[1] Operand 1
     /*  475301 */     // No operand predicates
     /*  475301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475310 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475333 */     GIR_RootConstrainSelectedInstOperands,
     /*  475334 */     // GIR_Coverage, 24719,
     /*  475334 */     GIR_EraseRootFromParent_Done,
     /*  475335 */   // Label 8058: @475335
     /*  475335 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(475421), // Rule ID 24722 //
     /*  475340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  475351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  475354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475387 */     // MIs[1] Operand 1
     /*  475387 */     // No operand predicates
     /*  475387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475396 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475419 */     GIR_RootConstrainSelectedInstOperands,
     /*  475420 */     // GIR_Coverage, 24722,
     /*  475420 */     GIR_EraseRootFromParent_Done,
     /*  475421 */   // Label 8059: @475421
     /*  475421 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(475507), // Rule ID 24723 //
     /*  475426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  475437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  475440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475473 */     // MIs[1] Operand 1
     /*  475473 */     // No operand predicates
     /*  475473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475482 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475505 */     GIR_RootConstrainSelectedInstOperands,
     /*  475506 */     // GIR_Coverage, 24723,
     /*  475506 */     GIR_EraseRootFromParent_Done,
     /*  475507 */   // Label 8060: @475507
     /*  475507 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(475593), // Rule ID 24726 //
     /*  475512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  475523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  475526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  475529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475559 */     // MIs[1] Operand 1
     /*  475559 */     // No operand predicates
     /*  475559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475568 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  475571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475591 */     GIR_RootConstrainSelectedInstOperands,
     /*  475592 */     // GIR_Coverage, 24726,
     /*  475592 */     GIR_EraseRootFromParent_Done,
     /*  475593 */   // Label 8061: @475593
     /*  475593 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(475679), // Rule ID 24727 //
     /*  475598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  475609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  475612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  475615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475645 */     // MIs[1] Operand 1
     /*  475645 */     // No operand predicates
     /*  475645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475654 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  475657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475677 */     GIR_RootConstrainSelectedInstOperands,
     /*  475678 */     // GIR_Coverage, 24727,
     /*  475678 */     GIR_EraseRootFromParent_Done,
     /*  475679 */   // Label 8062: @475679
     /*  475679 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(475765), // Rule ID 24730 //
     /*  475684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  475695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  475698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  475701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475731 */     // MIs[1] Operand 1
     /*  475731 */     // No operand predicates
     /*  475731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475740 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475763 */     GIR_RootConstrainSelectedInstOperands,
     /*  475764 */     // GIR_Coverage, 24730,
     /*  475764 */     GIR_EraseRootFromParent_Done,
     /*  475765 */   // Label 8063: @475765
     /*  475765 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(475851), // Rule ID 24731 //
     /*  475770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  475781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  475784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  475787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475817 */     // MIs[1] Operand 1
     /*  475817 */     // No operand predicates
     /*  475817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475826 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475849 */     GIR_RootConstrainSelectedInstOperands,
     /*  475850 */     // GIR_Coverage, 24731,
     /*  475850 */     GIR_EraseRootFromParent_Done,
     /*  475851 */   // Label 8064: @475851
     /*  475851 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(475937), // Rule ID 24734 //
     /*  475856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  475867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  475870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  475873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475903 */     // MIs[1] Operand 1
     /*  475903 */     // No operand predicates
     /*  475903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475912 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475935 */     GIR_RootConstrainSelectedInstOperands,
     /*  475936 */     // GIR_Coverage, 24734,
     /*  475936 */     GIR_EraseRootFromParent_Done,
     /*  475937 */   // Label 8065: @475937
     /*  475937 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(476023), // Rule ID 24735 //
     /*  475942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  475953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  475956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  475959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475989 */     // MIs[1] Operand 1
     /*  475989 */     // No operand predicates
     /*  475989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475998 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476021 */     GIR_RootConstrainSelectedInstOperands,
     /*  476022 */     // GIR_Coverage, 24735,
     /*  476022 */     GIR_EraseRootFromParent_Done,
     /*  476023 */   // Label 8066: @476023
     /*  476023 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(476109), // Rule ID 24738 //
     /*  476028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  476039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  476042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  476045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476075 */     // MIs[1] Operand 1
     /*  476075 */     // No operand predicates
     /*  476075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476084 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  476084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476107 */     GIR_RootConstrainSelectedInstOperands,
     /*  476108 */     // GIR_Coverage, 24738,
     /*  476108 */     GIR_EraseRootFromParent_Done,
     /*  476109 */   // Label 8067: @476109
     /*  476109 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(476195), // Rule ID 24739 //
     /*  476114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  476125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  476128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  476131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476161 */     // MIs[1] Operand 1
     /*  476161 */     // No operand predicates
     /*  476161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476170 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  476170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476193 */     GIR_RootConstrainSelectedInstOperands,
     /*  476194 */     // GIR_Coverage, 24739,
     /*  476194 */     GIR_EraseRootFromParent_Done,
     /*  476195 */   // Label 8068: @476195
     /*  476195 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(476281), // Rule ID 24742 //
     /*  476200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  476211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  476214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476247 */     // MIs[1] Operand 1
     /*  476247 */     // No operand predicates
     /*  476247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476256 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476279 */     GIR_RootConstrainSelectedInstOperands,
     /*  476280 */     // GIR_Coverage, 24742,
     /*  476280 */     GIR_EraseRootFromParent_Done,
     /*  476281 */   // Label 8069: @476281
     /*  476281 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(476367), // Rule ID 24743 //
     /*  476286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  476297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  476300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476333 */     // MIs[1] Operand 1
     /*  476333 */     // No operand predicates
     /*  476333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476365 */     GIR_RootConstrainSelectedInstOperands,
     /*  476366 */     // GIR_Coverage, 24743,
     /*  476366 */     GIR_EraseRootFromParent_Done,
     /*  476367 */   // Label 8070: @476367
     /*  476367 */   GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(476453), // Rule ID 24746 //
     /*  476372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  476383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  476386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476419 */     // MIs[1] Operand 1
     /*  476419 */     // No operand predicates
     /*  476419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476451 */     GIR_RootConstrainSelectedInstOperands,
     /*  476452 */     // GIR_Coverage, 24746,
     /*  476452 */     GIR_EraseRootFromParent_Done,
     /*  476453 */   // Label 8071: @476453
     /*  476453 */   GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(476539), // Rule ID 24747 //
     /*  476458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  476469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  476472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476505 */     // MIs[1] Operand 1
     /*  476505 */     // No operand predicates
     /*  476505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476537 */     GIR_RootConstrainSelectedInstOperands,
     /*  476538 */     // GIR_Coverage, 24747,
     /*  476538 */     GIR_EraseRootFromParent_Done,
     /*  476539 */   // Label 8072: @476539
     /*  476539 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(476625), // Rule ID 24750 //
     /*  476544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  476555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  476558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  476561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476591 */     // MIs[1] Operand 1
     /*  476591 */     // No operand predicates
     /*  476591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476600 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476623 */     GIR_RootConstrainSelectedInstOperands,
     /*  476624 */     // GIR_Coverage, 24750,
     /*  476624 */     GIR_EraseRootFromParent_Done,
     /*  476625 */   // Label 8073: @476625
     /*  476625 */   GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(476711), // Rule ID 24751 //
     /*  476630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  476641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  476644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  476647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476677 */     // MIs[1] Operand 1
     /*  476677 */     // No operand predicates
     /*  476677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476686 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476709 */     GIR_RootConstrainSelectedInstOperands,
     /*  476710 */     // GIR_Coverage, 24751,
     /*  476710 */     GIR_EraseRootFromParent_Done,
     /*  476711 */   // Label 8074: @476711
     /*  476711 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(476797), // Rule ID 24754 //
     /*  476716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  476719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  476727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  476730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  476733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476763 */     // MIs[1] Operand 1
     /*  476763 */     // No operand predicates
     /*  476763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476772 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  476772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476795 */     GIR_RootConstrainSelectedInstOperands,
     /*  476796 */     // GIR_Coverage, 24754,
     /*  476796 */     GIR_EraseRootFromParent_Done,
     /*  476797 */   // Label 8075: @476797
     /*  476797 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(476883), // Rule ID 24755 //
     /*  476802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  476805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  476813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  476816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  476819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476849 */     // MIs[1] Operand 1
     /*  476849 */     // No operand predicates
     /*  476849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476858 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  476858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476881 */     GIR_RootConstrainSelectedInstOperands,
     /*  476882 */     // GIR_Coverage, 24755,
     /*  476882 */     GIR_EraseRootFromParent_Done,
     /*  476883 */   // Label 8076: @476883
     /*  476883 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(476969), // Rule ID 24758 //
     /*  476888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  476891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  476899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  476902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  476905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476935 */     // MIs[1] Operand 1
     /*  476935 */     // No operand predicates
     /*  476935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476944 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  476944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476967 */     GIR_RootConstrainSelectedInstOperands,
     /*  476968 */     // GIR_Coverage, 24758,
     /*  476968 */     GIR_EraseRootFromParent_Done,
     /*  476969 */   // Label 8077: @476969
     /*  476969 */   GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(477055), // Rule ID 24759 //
     /*  476974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  476977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  476985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  476988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  476991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477021 */     // MIs[1] Operand 1
     /*  477021 */     // No operand predicates
     /*  477021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477030 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  477033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477053 */     GIR_RootConstrainSelectedInstOperands,
     /*  477054 */     // GIR_Coverage, 24759,
     /*  477054 */     GIR_EraseRootFromParent_Done,
     /*  477055 */   // Label 8078: @477055
     /*  477055 */   GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(477141), // Rule ID 24762 //
     /*  477060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  477063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  477071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  477074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  477077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477107 */     // MIs[1] Operand 1
     /*  477107 */     // No operand predicates
     /*  477107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477116 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  477116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477139 */     GIR_RootConstrainSelectedInstOperands,
     /*  477140 */     // GIR_Coverage, 24762,
     /*  477140 */     GIR_EraseRootFromParent_Done,
     /*  477141 */   // Label 8079: @477141
     /*  477141 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(477227), // Rule ID 24763 //
     /*  477146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  477149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  477157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  477160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  477163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477193 */     // MIs[1] Operand 1
     /*  477193 */     // No operand predicates
     /*  477193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477202 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477225 */     GIR_RootConstrainSelectedInstOperands,
     /*  477226 */     // GIR_Coverage, 24763,
     /*  477226 */     GIR_EraseRootFromParent_Done,
     /*  477227 */   // Label 8080: @477227
     /*  477227 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(477313), // Rule ID 24970 //
     /*  477232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  477243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  477246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477279 */     // MIs[1] Operand 1
     /*  477279 */     // No operand predicates
     /*  477279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477288 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477311 */     GIR_RootConstrainSelectedInstOperands,
     /*  477312 */     // GIR_Coverage, 24970,
     /*  477312 */     GIR_EraseRootFromParent_Done,
     /*  477313 */   // Label 8081: @477313
     /*  477313 */   GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(477399), // Rule ID 24971 //
     /*  477318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  477329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  477332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477365 */     // MIs[1] Operand 1
     /*  477365 */     // No operand predicates
     /*  477365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477374 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  477374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477397 */     GIR_RootConstrainSelectedInstOperands,
     /*  477398 */     // GIR_Coverage, 24971,
     /*  477398 */     GIR_EraseRootFromParent_Done,
     /*  477399 */   // Label 8082: @477399
     /*  477399 */   GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(477485), // Rule ID 24974 //
     /*  477404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  477415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  477418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  477421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477451 */     // MIs[1] Operand 1
     /*  477451 */     // No operand predicates
     /*  477451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477460 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477483 */     GIR_RootConstrainSelectedInstOperands,
     /*  477484 */     // GIR_Coverage, 24974,
     /*  477484 */     GIR_EraseRootFromParent_Done,
     /*  477485 */   // Label 8083: @477485
     /*  477485 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(477571), // Rule ID 24975 //
     /*  477490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  477501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  477504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  477507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477537 */     // MIs[1] Operand 1
     /*  477537 */     // No operand predicates
     /*  477537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477546 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  477546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477569 */     GIR_RootConstrainSelectedInstOperands,
     /*  477570 */     // GIR_Coverage, 24975,
     /*  477570 */     GIR_EraseRootFromParent_Done,
     /*  477571 */   // Label 8084: @477571
     /*  477571 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(477657), // Rule ID 24978 //
     /*  477576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  477587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  477590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  477593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477623 */     // MIs[1] Operand 1
     /*  477623 */     // No operand predicates
     /*  477623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477632 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  477632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477655 */     GIR_RootConstrainSelectedInstOperands,
     /*  477656 */     // GIR_Coverage, 24978,
     /*  477656 */     GIR_EraseRootFromParent_Done,
     /*  477657 */   // Label 8085: @477657
     /*  477657 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(477743), // Rule ID 24979 //
     /*  477662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  477673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  477676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  477679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477709 */     // MIs[1] Operand 1
     /*  477709 */     // No operand predicates
     /*  477709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477718 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  477718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477741 */     GIR_RootConstrainSelectedInstOperands,
     /*  477742 */     // GIR_Coverage, 24979,
     /*  477742 */     GIR_EraseRootFromParent_Done,
     /*  477743 */   // Label 8086: @477743
     /*  477743 */   GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(477829), // Rule ID 24982 //
     /*  477748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  477759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  477762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  477765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477795 */     // MIs[1] Operand 1
     /*  477795 */     // No operand predicates
     /*  477795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477804 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  477807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477827 */     GIR_RootConstrainSelectedInstOperands,
     /*  477828 */     // GIR_Coverage, 24982,
     /*  477828 */     GIR_EraseRootFromParent_Done,
     /*  477829 */   // Label 8087: @477829
     /*  477829 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(477915), // Rule ID 24983 //
     /*  477834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  477845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  477848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  477851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477881 */     // MIs[1] Operand 1
     /*  477881 */     // No operand predicates
     /*  477881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477890 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  477890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  477893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477913 */     GIR_RootConstrainSelectedInstOperands,
     /*  477914 */     // GIR_Coverage, 24983,
     /*  477914 */     GIR_EraseRootFromParent_Done,
     /*  477915 */   // Label 8088: @477915
     /*  477915 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(478001), // Rule ID 24986 //
     /*  477920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  477931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  477934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  477937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477967 */     // MIs[1] Operand 1
     /*  477967 */     // No operand predicates
     /*  477967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477976 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  477976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  477979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477999 */     GIR_RootConstrainSelectedInstOperands,
     /*  478000 */     // GIR_Coverage, 24986,
     /*  478000 */     GIR_EraseRootFromParent_Done,
     /*  478001 */   // Label 8089: @478001
     /*  478001 */   GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(478087), // Rule ID 24987 //
     /*  478006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  478017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  478020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  478023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478053 */     // MIs[1] Operand 1
     /*  478053 */     // No operand predicates
     /*  478053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478062 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478085 */     GIR_RootConstrainSelectedInstOperands,
     /*  478086 */     // GIR_Coverage, 24987,
     /*  478086 */     GIR_EraseRootFromParent_Done,
     /*  478087 */   // Label 8090: @478087
     /*  478087 */   GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(478173), // Rule ID 24990 //
     /*  478092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  478095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  478109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478139 */     // MIs[1] Operand 1
     /*  478139 */     // No operand predicates
     /*  478139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478148 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  478148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478171 */     GIR_RootConstrainSelectedInstOperands,
     /*  478172 */     // GIR_Coverage, 24990,
     /*  478172 */     GIR_EraseRootFromParent_Done,
     /*  478173 */   // Label 8091: @478173
     /*  478173 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(478259), // Rule ID 24991 //
     /*  478178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  478181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  478195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478225 */     // MIs[1] Operand 1
     /*  478225 */     // No operand predicates
     /*  478225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478234 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  478234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478257 */     GIR_RootConstrainSelectedInstOperands,
     /*  478258 */     // GIR_Coverage, 24991,
     /*  478258 */     GIR_EraseRootFromParent_Done,
     /*  478259 */   // Label 8092: @478259
     /*  478259 */   GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(478345), // Rule ID 24994 //
     /*  478264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  478275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  478278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  478281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478311 */     // MIs[1] Operand 1
     /*  478311 */     // No operand predicates
     /*  478311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478320 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478343 */     GIR_RootConstrainSelectedInstOperands,
     /*  478344 */     // GIR_Coverage, 24994,
     /*  478344 */     GIR_EraseRootFromParent_Done,
     /*  478345 */   // Label 8093: @478345
     /*  478345 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(478431), // Rule ID 24995 //
     /*  478350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  478361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  478364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  478367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478397 */     // MIs[1] Operand 1
     /*  478397 */     // No operand predicates
     /*  478397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478406 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478429 */     GIR_RootConstrainSelectedInstOperands,
     /*  478430 */     // GIR_Coverage, 24995,
     /*  478430 */     GIR_EraseRootFromParent_Done,
     /*  478431 */   // Label 8094: @478431
     /*  478431 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(478517), // Rule ID 24998 //
     /*  478436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  478447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  478450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  478453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478483 */     // MIs[1] Operand 1
     /*  478483 */     // No operand predicates
     /*  478483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478492 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  478495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478515 */     GIR_RootConstrainSelectedInstOperands,
     /*  478516 */     // GIR_Coverage, 24998,
     /*  478516 */     GIR_EraseRootFromParent_Done,
     /*  478517 */   // Label 8095: @478517
     /*  478517 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(478603), // Rule ID 24999 //
     /*  478522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  478533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  478536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  478539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478569 */     // MIs[1] Operand 1
     /*  478569 */     // No operand predicates
     /*  478569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478578 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  478581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478601 */     GIR_RootConstrainSelectedInstOperands,
     /*  478602 */     // GIR_Coverage, 24999,
     /*  478602 */     GIR_EraseRootFromParent_Done,
     /*  478603 */   // Label 8096: @478603
     /*  478603 */   GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(478689), // Rule ID 25002 //
     /*  478608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  478619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  478622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  478625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478655 */     // MIs[1] Operand 1
     /*  478655 */     // No operand predicates
     /*  478655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478664 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  478667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478687 */     GIR_RootConstrainSelectedInstOperands,
     /*  478688 */     // GIR_Coverage, 25002,
     /*  478688 */     GIR_EraseRootFromParent_Done,
     /*  478689 */   // Label 8097: @478689
     /*  478689 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(478775), // Rule ID 25003 //
     /*  478694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  478705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  478708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  478711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478741 */     // MIs[1] Operand 1
     /*  478741 */     // No operand predicates
     /*  478741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478750 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  478753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478773 */     GIR_RootConstrainSelectedInstOperands,
     /*  478774 */     // GIR_Coverage, 25003,
     /*  478774 */     GIR_EraseRootFromParent_Done,
     /*  478775 */   // Label 8098: @478775
     /*  478775 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(478861), // Rule ID 25006 //
     /*  478780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  478791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  478794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  478797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478827 */     // MIs[1] Operand 1
     /*  478827 */     // No operand predicates
     /*  478827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478836 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478859 */     GIR_RootConstrainSelectedInstOperands,
     /*  478860 */     // GIR_Coverage, 25006,
     /*  478860 */     GIR_EraseRootFromParent_Done,
     /*  478861 */   // Label 8099: @478861
     /*  478861 */   GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(478947), // Rule ID 25007 //
     /*  478866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  478877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  478880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  478883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478913 */     // MIs[1] Operand 1
     /*  478913 */     // No operand predicates
     /*  478913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478922 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478945 */     GIR_RootConstrainSelectedInstOperands,
     /*  478946 */     // GIR_Coverage, 25007,
     /*  478946 */     GIR_EraseRootFromParent_Done,
     /*  478947 */   // Label 8100: @478947
     /*  478947 */   GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(479033), // Rule ID 25010 //
     /*  478952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  478963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  478966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  478969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478999 */     // MIs[1] Operand 1
     /*  478999 */     // No operand predicates
     /*  478999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479008 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  479008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479031 */     GIR_RootConstrainSelectedInstOperands,
     /*  479032 */     // GIR_Coverage, 25010,
     /*  479032 */     GIR_EraseRootFromParent_Done,
     /*  479033 */   // Label 8101: @479033
     /*  479033 */   GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(479119), // Rule ID 25011 //
     /*  479038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  479049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  479052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  479055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479085 */     // MIs[1] Operand 1
     /*  479085 */     // No operand predicates
     /*  479085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479094 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  479094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479117 */     GIR_RootConstrainSelectedInstOperands,
     /*  479118 */     // GIR_Coverage, 25011,
     /*  479118 */     GIR_EraseRootFromParent_Done,
     /*  479119 */   // Label 8102: @479119
     /*  479119 */   GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(479205), // Rule ID 25014 //
     /*  479124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  479135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  479138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  479141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479171 */     // MIs[1] Operand 1
     /*  479171 */     // No operand predicates
     /*  479171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479180 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  479180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479203 */     GIR_RootConstrainSelectedInstOperands,
     /*  479204 */     // GIR_Coverage, 25014,
     /*  479204 */     GIR_EraseRootFromParent_Done,
     /*  479205 */   // Label 8103: @479205
     /*  479205 */   GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(479291), // Rule ID 25015 //
     /*  479210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  479221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  479224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  479227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479257 */     // MIs[1] Operand 1
     /*  479257 */     // No operand predicates
     /*  479257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479266 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  479266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479289 */     GIR_RootConstrainSelectedInstOperands,
     /*  479290 */     // GIR_Coverage, 25015,
     /*  479290 */     GIR_EraseRootFromParent_Done,
     /*  479291 */   // Label 8104: @479291
     /*  479291 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(479377), // Rule ID 25018 //
     /*  479296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  479299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  479307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  479310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  479313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479343 */     // MIs[1] Operand 1
     /*  479343 */     // No operand predicates
     /*  479343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479352 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  479352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479375 */     GIR_RootConstrainSelectedInstOperands,
     /*  479376 */     // GIR_Coverage, 25018,
     /*  479376 */     GIR_EraseRootFromParent_Done,
     /*  479377 */   // Label 8105: @479377
     /*  479377 */   GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(479463), // Rule ID 25019 //
     /*  479382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  479385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  479393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  479396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  479399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479429 */     // MIs[1] Operand 1
     /*  479429 */     // No operand predicates
     /*  479429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479438 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  479438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479461 */     GIR_RootConstrainSelectedInstOperands,
     /*  479462 */     // GIR_Coverage, 25019,
     /*  479462 */     GIR_EraseRootFromParent_Done,
     /*  479463 */   // Label 8106: @479463
     /*  479463 */   GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(479549), // Rule ID 25022 //
     /*  479468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  479471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  479479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  479482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  479485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479515 */     // MIs[1] Operand 1
     /*  479515 */     // No operand predicates
     /*  479515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479524 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  479524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479547 */     GIR_RootConstrainSelectedInstOperands,
     /*  479548 */     // GIR_Coverage, 25022,
     /*  479548 */     GIR_EraseRootFromParent_Done,
     /*  479549 */   // Label 8107: @479549
     /*  479549 */   GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(479635), // Rule ID 25023 //
     /*  479554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  479557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  479565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  479568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  479571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479601 */     // MIs[1] Operand 1
     /*  479601 */     // No operand predicates
     /*  479601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479610 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  479610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479633 */     GIR_RootConstrainSelectedInstOperands,
     /*  479634 */     // GIR_Coverage, 25023,
     /*  479634 */     GIR_EraseRootFromParent_Done,
     /*  479635 */   // Label 8108: @479635
     /*  479635 */   GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(479721), // Rule ID 25026 //
     /*  479640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  479643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  479651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  479654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  479657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479687 */     // MIs[1] Operand 1
     /*  479687 */     // No operand predicates
     /*  479687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479696 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  479696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479719 */     GIR_RootConstrainSelectedInstOperands,
     /*  479720 */     // GIR_Coverage, 25026,
     /*  479720 */     GIR_EraseRootFromParent_Done,
     /*  479721 */   // Label 8109: @479721
     /*  479721 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(479807), // Rule ID 25027 //
     /*  479726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  479729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  479737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  479740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  479743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479773 */     // MIs[1] Operand 1
     /*  479773 */     // No operand predicates
     /*  479773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479782 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  479782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479805 */     GIR_RootConstrainSelectedInstOperands,
     /*  479806 */     // GIR_Coverage, 25027,
     /*  479806 */     GIR_EraseRootFromParent_Done,
     /*  479807 */   // Label 8110: @479807
     /*  479807 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(479893), // Rule ID 61038 //
     /*  479812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  479815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  479823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  479826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  479829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479859 */     // MIs[1] Operand 1
     /*  479859 */     // No operand predicates
     /*  479859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  479871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479891 */     GIR_RootConstrainSelectedInstOperands,
     /*  479892 */     // GIR_Coverage, 61038,
     /*  479892 */     GIR_EraseRootFromParent_Done,
     /*  479893 */   // Label 8111: @479893
     /*  479893 */   GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(479979), // Rule ID 61039 //
     /*  479898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  479901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  479909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  479912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  479915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479945 */     // MIs[1] Operand 1
     /*  479945 */     // No operand predicates
     /*  479945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479954 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  479957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479977 */     GIR_RootConstrainSelectedInstOperands,
     /*  479978 */     // GIR_Coverage, 61039,
     /*  479978 */     GIR_EraseRootFromParent_Done,
     /*  479979 */   // Label 8112: @479979
     /*  479979 */   GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(480065), // Rule ID 61046 //
     /*  479984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  479987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  479995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  479998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  480001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480031 */     // MIs[1] Operand 1
     /*  480031 */     // No operand predicates
     /*  480031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480040 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480063 */     GIR_RootConstrainSelectedInstOperands,
     /*  480064 */     // GIR_Coverage, 61046,
     /*  480064 */     GIR_EraseRootFromParent_Done,
     /*  480065 */   // Label 8113: @480065
     /*  480065 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(480151), // Rule ID 61047 //
     /*  480070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  480081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  480084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  480087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480117 */     // MIs[1] Operand 1
     /*  480117 */     // No operand predicates
     /*  480117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480149 */     GIR_RootConstrainSelectedInstOperands,
     /*  480150 */     // GIR_Coverage, 61047,
     /*  480150 */     GIR_EraseRootFromParent_Done,
     /*  480151 */   // Label 8114: @480151
     /*  480151 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(480237), // Rule ID 61054 //
     /*  480156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  480167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  480170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  480173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480203 */     // MIs[1] Operand 1
     /*  480203 */     // No operand predicates
     /*  480203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480212 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  480215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480235 */     GIR_RootConstrainSelectedInstOperands,
     /*  480236 */     // GIR_Coverage, 61054,
     /*  480236 */     GIR_EraseRootFromParent_Done,
     /*  480237 */   // Label 8115: @480237
     /*  480237 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(480323), // Rule ID 61055 //
     /*  480242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  480253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  480256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  480259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480289 */     // MIs[1] Operand 1
     /*  480289 */     // No operand predicates
     /*  480289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480298 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  480301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480321 */     GIR_RootConstrainSelectedInstOperands,
     /*  480322 */     // GIR_Coverage, 61055,
     /*  480322 */     GIR_EraseRootFromParent_Done,
     /*  480323 */   // Label 8116: @480323
     /*  480323 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(480409), // Rule ID 61062 //
     /*  480328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  480339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  480342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  480345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480375 */     // MIs[1] Operand 1
     /*  480375 */     // No operand predicates
     /*  480375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  480387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480407 */     GIR_RootConstrainSelectedInstOperands,
     /*  480408 */     // GIR_Coverage, 61062,
     /*  480408 */     GIR_EraseRootFromParent_Done,
     /*  480409 */   // Label 8117: @480409
     /*  480409 */   GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(480495), // Rule ID 61063 //
     /*  480414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  480425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  480428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  480431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480461 */     // MIs[1] Operand 1
     /*  480461 */     // No operand predicates
     /*  480461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  480473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480493 */     GIR_RootConstrainSelectedInstOperands,
     /*  480494 */     // GIR_Coverage, 61063,
     /*  480494 */     GIR_EraseRootFromParent_Done,
     /*  480495 */   // Label 8118: @480495
     /*  480495 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(480581), // Rule ID 61070 //
     /*  480500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  480511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  480514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  480517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480547 */     // MIs[1] Operand 1
     /*  480547 */     // No operand predicates
     /*  480547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480556 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  480559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480579 */     GIR_RootConstrainSelectedInstOperands,
     /*  480580 */     // GIR_Coverage, 61070,
     /*  480580 */     GIR_EraseRootFromParent_Done,
     /*  480581 */   // Label 8119: @480581
     /*  480581 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(480667), // Rule ID 61071 //
     /*  480586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  480597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  480600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  480603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480633 */     // MIs[1] Operand 1
     /*  480633 */     // No operand predicates
     /*  480633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480642 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  480645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480665 */     GIR_RootConstrainSelectedInstOperands,
     /*  480666 */     // GIR_Coverage, 61071,
     /*  480666 */     GIR_EraseRootFromParent_Done,
     /*  480667 */   // Label 8120: @480667
     /*  480667 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(480753), // Rule ID 61078 //
     /*  480672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  480683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  480686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  480689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480719 */     // MIs[1] Operand 1
     /*  480719 */     // No operand predicates
     /*  480719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480728 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  480731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480751 */     GIR_RootConstrainSelectedInstOperands,
     /*  480752 */     // GIR_Coverage, 61078,
     /*  480752 */     GIR_EraseRootFromParent_Done,
     /*  480753 */   // Label 8121: @480753
     /*  480753 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(480839), // Rule ID 61079 //
     /*  480758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  480769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  480772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  480775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480805 */     // MIs[1] Operand 1
     /*  480805 */     // No operand predicates
     /*  480805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480814 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  480817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480837 */     GIR_RootConstrainSelectedInstOperands,
     /*  480838 */     // GIR_Coverage, 61079,
     /*  480838 */     GIR_EraseRootFromParent_Done,
     /*  480839 */   // Label 8122: @480839
     /*  480839 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(480925), // Rule ID 61086 //
     /*  480844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  480855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  480858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  480861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480891 */     // MIs[1] Operand 1
     /*  480891 */     // No operand predicates
     /*  480891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480900 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  480900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480923 */     GIR_RootConstrainSelectedInstOperands,
     /*  480924 */     // GIR_Coverage, 61086,
     /*  480924 */     GIR_EraseRootFromParent_Done,
     /*  480925 */   // Label 8123: @480925
     /*  480925 */   GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(481011), // Rule ID 61087 //
     /*  480930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  480941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  480944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  480947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480977 */     // MIs[1] Operand 1
     /*  480977 */     // No operand predicates
     /*  480977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480986 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  480986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481009 */     GIR_RootConstrainSelectedInstOperands,
     /*  481010 */     // GIR_Coverage, 61087,
     /*  481010 */     GIR_EraseRootFromParent_Done,
     /*  481011 */   // Label 8124: @481011
     /*  481011 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(481097), // Rule ID 61094 //
     /*  481016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  481027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  481030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  481033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481063 */     // MIs[1] Operand 1
     /*  481063 */     // No operand predicates
     /*  481063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481072 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11679:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481095 */     GIR_RootConstrainSelectedInstOperands,
     /*  481096 */     // GIR_Coverage, 61094,
     /*  481096 */     GIR_EraseRootFromParent_Done,
     /*  481097 */   // Label 8125: @481097
     /*  481097 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(481183), // Rule ID 61095 //
     /*  481102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  481113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  481116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  481119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481149 */     // MIs[1] Operand 1
     /*  481149 */     // No operand predicates
     /*  481149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11679:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481181 */     GIR_RootConstrainSelectedInstOperands,
     /*  481182 */     // GIR_Coverage, 61095,
     /*  481182 */     GIR_EraseRootFromParent_Done,
     /*  481183 */   // Label 8126: @481183
     /*  481183 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(481269), // Rule ID 61102 //
     /*  481188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  481199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  481202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  481205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481235 */     // MIs[1] Operand 1
     /*  481235 */     // No operand predicates
     /*  481235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  481247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481267 */     GIR_RootConstrainSelectedInstOperands,
     /*  481268 */     // GIR_Coverage, 61102,
     /*  481268 */     GIR_EraseRootFromParent_Done,
     /*  481269 */   // Label 8127: @481269
     /*  481269 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(481355), // Rule ID 61103 //
     /*  481274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  481285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  481288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  481291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481321 */     // MIs[1] Operand 1
     /*  481321 */     // No operand predicates
     /*  481321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  481333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481353 */     GIR_RootConstrainSelectedInstOperands,
     /*  481354 */     // GIR_Coverage, 61103,
     /*  481354 */     GIR_EraseRootFromParent_Done,
     /*  481355 */   // Label 8128: @481355
     /*  481355 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(481441), // Rule ID 61110 //
     /*  481360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  481371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  481374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  481377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481407 */     // MIs[1] Operand 1
     /*  481407 */     // No operand predicates
     /*  481407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481439 */     GIR_RootConstrainSelectedInstOperands,
     /*  481440 */     // GIR_Coverage, 61110,
     /*  481440 */     GIR_EraseRootFromParent_Done,
     /*  481441 */   // Label 8129: @481441
     /*  481441 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(481527), // Rule ID 61111 //
     /*  481446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  481457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  481460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  481463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481493 */     // MIs[1] Operand 1
     /*  481493 */     // No operand predicates
     /*  481493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481525 */     GIR_RootConstrainSelectedInstOperands,
     /*  481526 */     // GIR_Coverage, 61111,
     /*  481526 */     GIR_EraseRootFromParent_Done,
     /*  481527 */   // Label 8130: @481527
     /*  481527 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(481613), // Rule ID 61118 //
     /*  481532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  481543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  481546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  481549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481579 */     // MIs[1] Operand 1
     /*  481579 */     // No operand predicates
     /*  481579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481588 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  481591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481611 */     GIR_RootConstrainSelectedInstOperands,
     /*  481612 */     // GIR_Coverage, 61118,
     /*  481612 */     GIR_EraseRootFromParent_Done,
     /*  481613 */   // Label 8131: @481613
     /*  481613 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(481699), // Rule ID 61119 //
     /*  481618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  481629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  481632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  481635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481665 */     // MIs[1] Operand 1
     /*  481665 */     // No operand predicates
     /*  481665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481674 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  481677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481697 */     GIR_RootConstrainSelectedInstOperands,
     /*  481698 */     // GIR_Coverage, 61119,
     /*  481698 */     GIR_EraseRootFromParent_Done,
     /*  481699 */   // Label 8132: @481699
     /*  481699 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(481785), // Rule ID 61126 //
     /*  481704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  481715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  481718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  481721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481751 */     // MIs[1] Operand 1
     /*  481751 */     // No operand predicates
     /*  481751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481783 */     GIR_RootConstrainSelectedInstOperands,
     /*  481784 */     // GIR_Coverage, 61126,
     /*  481784 */     GIR_EraseRootFromParent_Done,
     /*  481785 */   // Label 8133: @481785
     /*  481785 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(481871), // Rule ID 61127 //
     /*  481790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  481801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  481804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  481807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481837 */     // MIs[1] Operand 1
     /*  481837 */     // No operand predicates
     /*  481837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481846 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481869 */     GIR_RootConstrainSelectedInstOperands,
     /*  481870 */     // GIR_Coverage, 61127,
     /*  481870 */     GIR_EraseRootFromParent_Done,
     /*  481871 */   // Label 8134: @481871
     /*  481871 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(481957), // Rule ID 61134 //
     /*  481876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  481887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  481890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  481893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481923 */     // MIs[1] Operand 1
     /*  481923 */     // No operand predicates
     /*  481923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481932 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  481935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481955 */     GIR_RootConstrainSelectedInstOperands,
     /*  481956 */     // GIR_Coverage, 61134,
     /*  481956 */     GIR_EraseRootFromParent_Done,
     /*  481957 */   // Label 8135: @481957
     /*  481957 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(482043), // Rule ID 61135 //
     /*  481962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  481973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  481976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  481979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482009 */     // MIs[1] Operand 1
     /*  482009 */     // No operand predicates
     /*  482009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482018 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  482021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482041 */     GIR_RootConstrainSelectedInstOperands,
     /*  482042 */     // GIR_Coverage, 61135,
     /*  482042 */     GIR_EraseRootFromParent_Done,
     /*  482043 */   // Label 8136: @482043
     /*  482043 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(482129), // Rule ID 61142 //
     /*  482048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  482051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  482059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  482062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  482065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482095 */     // MIs[1] Operand 1
     /*  482095 */     // No operand predicates
     /*  482095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482104 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  482107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482127 */     GIR_RootConstrainSelectedInstOperands,
     /*  482128 */     // GIR_Coverage, 61142,
     /*  482128 */     GIR_EraseRootFromParent_Done,
     /*  482129 */   // Label 8137: @482129
     /*  482129 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(482215), // Rule ID 61143 //
     /*  482134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  482145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  482148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  482151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482181 */     // MIs[1] Operand 1
     /*  482181 */     // No operand predicates
     /*  482181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482190 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  482193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482213 */     GIR_RootConstrainSelectedInstOperands,
     /*  482214 */     // GIR_Coverage, 61143,
     /*  482214 */     GIR_EraseRootFromParent_Done,
     /*  482215 */   // Label 8138: @482215
     /*  482215 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(482301), // Rule ID 61150 //
     /*  482220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  482223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  482231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  482234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  482237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482267 */     // MIs[1] Operand 1
     /*  482267 */     // No operand predicates
     /*  482267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482276 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  482279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482299 */     GIR_RootConstrainSelectedInstOperands,
     /*  482300 */     // GIR_Coverage, 61150,
     /*  482300 */     GIR_EraseRootFromParent_Done,
     /*  482301 */   // Label 8139: @482301
     /*  482301 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(482387), // Rule ID 61151 //
     /*  482306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  482317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  482320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  482323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482353 */     // MIs[1] Operand 1
     /*  482353 */     // No operand predicates
     /*  482353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482362 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  482365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482385 */     GIR_RootConstrainSelectedInstOperands,
     /*  482386 */     // GIR_Coverage, 61151,
     /*  482386 */     GIR_EraseRootFromParent_Done,
     /*  482387 */   // Label 8140: @482387
     /*  482387 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(482473), // Rule ID 62006 //
     /*  482392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  482403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  482406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  482409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482439 */     // MIs[1] Operand 1
     /*  482439 */     // No operand predicates
     /*  482439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482448 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  482448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  482451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482471 */     GIR_RootConstrainSelectedInstOperands,
     /*  482472 */     // GIR_Coverage, 62006,
     /*  482472 */     GIR_EraseRootFromParent_Done,
     /*  482473 */   // Label 8141: @482473
     /*  482473 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(482559), // Rule ID 62007 //
     /*  482478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  482489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  482492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  482495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482525 */     // MIs[1] Operand 1
     /*  482525 */     // No operand predicates
     /*  482525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482534 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  482534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  482537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482557 */     GIR_RootConstrainSelectedInstOperands,
     /*  482558 */     // GIR_Coverage, 62007,
     /*  482558 */     GIR_EraseRootFromParent_Done,
     /*  482559 */   // Label 8142: @482559
     /*  482559 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(482645), // Rule ID 62010 //
     /*  482564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  482575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  482578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  482581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482611 */     // MIs[1] Operand 1
     /*  482611 */     // No operand predicates
     /*  482611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482620 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  482620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  482623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482643 */     GIR_RootConstrainSelectedInstOperands,
     /*  482644 */     // GIR_Coverage, 62010,
     /*  482644 */     GIR_EraseRootFromParent_Done,
     /*  482645 */   // Label 8143: @482645
     /*  482645 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(482731), // Rule ID 62011 //
     /*  482650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  482661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  482664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  482667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482697 */     // MIs[1] Operand 1
     /*  482697 */     // No operand predicates
     /*  482697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482706 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  482706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  482709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482729 */     GIR_RootConstrainSelectedInstOperands,
     /*  482730 */     // GIR_Coverage, 62011,
     /*  482730 */     GIR_EraseRootFromParent_Done,
     /*  482731 */   // Label 8144: @482731
     /*  482731 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(482817), // Rule ID 62014 //
     /*  482736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  482747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  482750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  482753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482783 */     // MIs[1] Operand 1
     /*  482783 */     // No operand predicates
     /*  482783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482792 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  482792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  482795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482815 */     GIR_RootConstrainSelectedInstOperands,
     /*  482816 */     // GIR_Coverage, 62014,
     /*  482816 */     GIR_EraseRootFromParent_Done,
     /*  482817 */   // Label 8145: @482817
     /*  482817 */   GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(482903), // Rule ID 62015 //
     /*  482822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  482833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  482836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  482839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482869 */     // MIs[1] Operand 1
     /*  482869 */     // No operand predicates
     /*  482869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482878 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  482878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  482881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482901 */     GIR_RootConstrainSelectedInstOperands,
     /*  482902 */     // GIR_Coverage, 62015,
     /*  482902 */     GIR_EraseRootFromParent_Done,
     /*  482903 */   // Label 8146: @482903
     /*  482903 */   GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(482989), // Rule ID 62018 //
     /*  482908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  482919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  482922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  482925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482955 */     // MIs[1] Operand 1
     /*  482955 */     // No operand predicates
     /*  482955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482964 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  482967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482987 */     GIR_RootConstrainSelectedInstOperands,
     /*  482988 */     // GIR_Coverage, 62018,
     /*  482988 */     GIR_EraseRootFromParent_Done,
     /*  482989 */   // Label 8147: @482989
     /*  482989 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(483075), // Rule ID 62019 //
     /*  482994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  483005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  483008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  483011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483041 */     // MIs[1] Operand 1
     /*  483041 */     // No operand predicates
     /*  483041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483050 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  483053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483073 */     GIR_RootConstrainSelectedInstOperands,
     /*  483074 */     // GIR_Coverage, 62019,
     /*  483074 */     GIR_EraseRootFromParent_Done,
     /*  483075 */   // Label 8148: @483075
     /*  483075 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(483161), // Rule ID 62022 //
     /*  483080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  483097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483127 */     // MIs[1] Operand 1
     /*  483127 */     // No operand predicates
     /*  483127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483136 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483159 */     GIR_RootConstrainSelectedInstOperands,
     /*  483160 */     // GIR_Coverage, 62022,
     /*  483160 */     GIR_EraseRootFromParent_Done,
     /*  483161 */   // Label 8149: @483161
     /*  483161 */   GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(483247), // Rule ID 62023 //
     /*  483166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  483183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483213 */     // MIs[1] Operand 1
     /*  483213 */     // No operand predicates
     /*  483213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483222 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483245 */     GIR_RootConstrainSelectedInstOperands,
     /*  483246 */     // GIR_Coverage, 62023,
     /*  483246 */     GIR_EraseRootFromParent_Done,
     /*  483247 */   // Label 8150: @483247
     /*  483247 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(483333), // Rule ID 62026 //
     /*  483252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  483263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  483266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  483269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483299 */     // MIs[1] Operand 1
     /*  483299 */     // No operand predicates
     /*  483299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483308 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  483308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483331 */     GIR_RootConstrainSelectedInstOperands,
     /*  483332 */     // GIR_Coverage, 62026,
     /*  483332 */     GIR_EraseRootFromParent_Done,
     /*  483333 */   // Label 8151: @483333
     /*  483333 */   GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(483419), // Rule ID 62027 //
     /*  483338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  483349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  483352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  483355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483385 */     // MIs[1] Operand 1
     /*  483385 */     // No operand predicates
     /*  483385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483394 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  483394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483417 */     GIR_RootConstrainSelectedInstOperands,
     /*  483418 */     // GIR_Coverage, 62027,
     /*  483418 */     GIR_EraseRootFromParent_Done,
     /*  483419 */   // Label 8152: @483419
     /*  483419 */   GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(483505), // Rule ID 62030 //
     /*  483424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  483435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  483438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  483441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483471 */     // MIs[1] Operand 1
     /*  483471 */     // No operand predicates
     /*  483471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483480 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483503 */     GIR_RootConstrainSelectedInstOperands,
     /*  483504 */     // GIR_Coverage, 62030,
     /*  483504 */     GIR_EraseRootFromParent_Done,
     /*  483505 */   // Label 8153: @483505
     /*  483505 */   GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(483591), // Rule ID 62031 //
     /*  483510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  483521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  483524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  483527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483557 */     // MIs[1] Operand 1
     /*  483557 */     // No operand predicates
     /*  483557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483566 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483589 */     GIR_RootConstrainSelectedInstOperands,
     /*  483590 */     // GIR_Coverage, 62031,
     /*  483590 */     GIR_EraseRootFromParent_Done,
     /*  483591 */   // Label 8154: @483591
     /*  483591 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(483677), // Rule ID 62034 //
     /*  483596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  483607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  483610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  483613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483643 */     // MIs[1] Operand 1
     /*  483643 */     // No operand predicates
     /*  483643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483675 */     GIR_RootConstrainSelectedInstOperands,
     /*  483676 */     // GIR_Coverage, 62034,
     /*  483676 */     GIR_EraseRootFromParent_Done,
     /*  483677 */   // Label 8155: @483677
     /*  483677 */   GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(483763), // Rule ID 62035 //
     /*  483682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  483693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  483696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  483699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483729 */     // MIs[1] Operand 1
     /*  483729 */     // No operand predicates
     /*  483729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483738 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483761 */     GIR_RootConstrainSelectedInstOperands,
     /*  483762 */     // GIR_Coverage, 62035,
     /*  483762 */     GIR_EraseRootFromParent_Done,
     /*  483763 */   // Label 8156: @483763
     /*  483763 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(483849), // Rule ID 62038 //
     /*  483768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  483779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  483782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  483785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483815 */     // MIs[1] Operand 1
     /*  483815 */     // No operand predicates
     /*  483815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  483824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483847 */     GIR_RootConstrainSelectedInstOperands,
     /*  483848 */     // GIR_Coverage, 62038,
     /*  483848 */     GIR_EraseRootFromParent_Done,
     /*  483849 */   // Label 8157: @483849
     /*  483849 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(483935), // Rule ID 62039 //
     /*  483854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  483865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  483868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  483871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483901 */     // MIs[1] Operand 1
     /*  483901 */     // No operand predicates
     /*  483901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483910 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  483910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483933 */     GIR_RootConstrainSelectedInstOperands,
     /*  483934 */     // GIR_Coverage, 62039,
     /*  483934 */     GIR_EraseRootFromParent_Done,
     /*  483935 */   // Label 8158: @483935
     /*  483935 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(484021), // Rule ID 62042 //
     /*  483940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  483951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  483954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  483957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483987 */     // MIs[1] Operand 1
     /*  483987 */     // No operand predicates
     /*  483987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483996 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  483996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  484016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484019 */     GIR_RootConstrainSelectedInstOperands,
     /*  484020 */     // GIR_Coverage, 62042,
     /*  484020 */     GIR_EraseRootFromParent_Done,
     /*  484021 */   // Label 8159: @484021
     /*  484021 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(484107), // Rule ID 62043 //
     /*  484026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  484037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  484040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  484043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484073 */     // MIs[1] Operand 1
     /*  484073 */     // No operand predicates
     /*  484073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  484082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  484102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484105 */     GIR_RootConstrainSelectedInstOperands,
     /*  484106 */     // GIR_Coverage, 62043,
     /*  484106 */     GIR_EraseRootFromParent_Done,
     /*  484107 */   // Label 8160: @484107
     /*  484107 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(484193), // Rule ID 62046 //
     /*  484112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  484123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  484126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484159 */     // MIs[1] Operand 1
     /*  484159 */     // No operand predicates
     /*  484159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484168 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484191 */     GIR_RootConstrainSelectedInstOperands,
     /*  484192 */     // GIR_Coverage, 62046,
     /*  484192 */     GIR_EraseRootFromParent_Done,
     /*  484193 */   // Label 8161: @484193
     /*  484193 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(484279), // Rule ID 62047 //
     /*  484198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  484209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  484212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484245 */     // MIs[1] Operand 1
     /*  484245 */     // No operand predicates
     /*  484245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484254 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484277 */     GIR_RootConstrainSelectedInstOperands,
     /*  484278 */     // GIR_Coverage, 62047,
     /*  484278 */     GIR_EraseRootFromParent_Done,
     /*  484279 */   // Label 8162: @484279
     /*  484279 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(484365), // Rule ID 62050 //
     /*  484284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  484295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  484298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484331 */     // MIs[1] Operand 1
     /*  484331 */     // No operand predicates
     /*  484331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484340 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484363 */     GIR_RootConstrainSelectedInstOperands,
     /*  484364 */     // GIR_Coverage, 62050,
     /*  484364 */     GIR_EraseRootFromParent_Done,
     /*  484365 */   // Label 8163: @484365
     /*  484365 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(484451), // Rule ID 62051 //
     /*  484370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  484381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  484384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484417 */     // MIs[1] Operand 1
     /*  484417 */     // No operand predicates
     /*  484417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484426 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484449 */     GIR_RootConstrainSelectedInstOperands,
     /*  484450 */     // GIR_Coverage, 62051,
     /*  484450 */     GIR_EraseRootFromParent_Done,
     /*  484451 */   // Label 8164: @484451
     /*  484451 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(484537), // Rule ID 62054 //
     /*  484456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  484467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  484470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  484473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484503 */     // MIs[1] Operand 1
     /*  484503 */     // No operand predicates
     /*  484503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484512 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  484515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484535 */     GIR_RootConstrainSelectedInstOperands,
     /*  484536 */     // GIR_Coverage, 62054,
     /*  484536 */     GIR_EraseRootFromParent_Done,
     /*  484537 */   // Label 8165: @484537
     /*  484537 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(484623), // Rule ID 62055 //
     /*  484542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  484553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  484556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  484559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484589 */     // MIs[1] Operand 1
     /*  484589 */     // No operand predicates
     /*  484589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484598 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  484601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484621 */     GIR_RootConstrainSelectedInstOperands,
     /*  484622 */     // GIR_Coverage, 62055,
     /*  484622 */     GIR_EraseRootFromParent_Done,
     /*  484623 */   // Label 8166: @484623
     /*  484623 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(484709), // Rule ID 62058 //
     /*  484628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  484639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  484642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  484645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484675 */     // MIs[1] Operand 1
     /*  484675 */     // No operand predicates
     /*  484675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484707 */     GIR_RootConstrainSelectedInstOperands,
     /*  484708 */     // GIR_Coverage, 62058,
     /*  484708 */     GIR_EraseRootFromParent_Done,
     /*  484709 */   // Label 8167: @484709
     /*  484709 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(484795), // Rule ID 62059 //
     /*  484714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  484725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  484728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  484731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484761 */     // MIs[1] Operand 1
     /*  484761 */     // No operand predicates
     /*  484761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484770 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484793 */     GIR_RootConstrainSelectedInstOperands,
     /*  484794 */     // GIR_Coverage, 62059,
     /*  484794 */     GIR_EraseRootFromParent_Done,
     /*  484795 */   // Label 8168: @484795
     /*  484795 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(484881), // Rule ID 62062 //
     /*  484800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  484811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  484814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  484817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484847 */     // MIs[1] Operand 1
     /*  484847 */     // No operand predicates
     /*  484847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484856 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484879 */     GIR_RootConstrainSelectedInstOperands,
     /*  484880 */     // GIR_Coverage, 62062,
     /*  484880 */     GIR_EraseRootFromParent_Done,
     /*  484881 */   // Label 8169: @484881
     /*  484881 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(484967), // Rule ID 62063 //
     /*  484886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  484897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  484900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  484903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484933 */     // MIs[1] Operand 1
     /*  484933 */     // No operand predicates
     /*  484933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484942 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484965 */     GIR_RootConstrainSelectedInstOperands,
     /*  484966 */     // GIR_Coverage, 62063,
     /*  484966 */     GIR_EraseRootFromParent_Done,
     /*  484967 */   // Label 8170: @484967
     /*  484967 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(485053), // Rule ID 62066 //
     /*  484972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  484983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  484986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  484989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485019 */     // MIs[1] Operand 1
     /*  485019 */     // No operand predicates
     /*  485019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485028 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485051 */     GIR_RootConstrainSelectedInstOperands,
     /*  485052 */     // GIR_Coverage, 62066,
     /*  485052 */     GIR_EraseRootFromParent_Done,
     /*  485053 */   // Label 8171: @485053
     /*  485053 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(485139), // Rule ID 62067 //
     /*  485058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  485069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  485072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  485075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485105 */     // MIs[1] Operand 1
     /*  485105 */     // No operand predicates
     /*  485105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485114 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485137 */     GIR_RootConstrainSelectedInstOperands,
     /*  485138 */     // GIR_Coverage, 62067,
     /*  485138 */     GIR_EraseRootFromParent_Done,
     /*  485139 */   // Label 8172: @485139
     /*  485139 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(485225), // Rule ID 62070 //
     /*  485144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  485155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  485158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485191 */     // MIs[1] Operand 1
     /*  485191 */     // No operand predicates
     /*  485191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485223 */     GIR_RootConstrainSelectedInstOperands,
     /*  485224 */     // GIR_Coverage, 62070,
     /*  485224 */     GIR_EraseRootFromParent_Done,
     /*  485225 */   // Label 8173: @485225
     /*  485225 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(485311), // Rule ID 62071 //
     /*  485230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  485241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  485244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485277 */     // MIs[1] Operand 1
     /*  485277 */     // No operand predicates
     /*  485277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485309 */     GIR_RootConstrainSelectedInstOperands,
     /*  485310 */     // GIR_Coverage, 62071,
     /*  485310 */     GIR_EraseRootFromParent_Done,
     /*  485311 */   // Label 8174: @485311
     /*  485311 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(485397), // Rule ID 62074 //
     /*  485316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  485327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  485330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  485333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485363 */     // MIs[1] Operand 1
     /*  485363 */     // No operand predicates
     /*  485363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485372 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485395 */     GIR_RootConstrainSelectedInstOperands,
     /*  485396 */     // GIR_Coverage, 62074,
     /*  485396 */     GIR_EraseRootFromParent_Done,
     /*  485397 */   // Label 8175: @485397
     /*  485397 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(485483), // Rule ID 62075 //
     /*  485402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  485413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  485416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  485419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485449 */     // MIs[1] Operand 1
     /*  485449 */     // No operand predicates
     /*  485449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485458 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485481 */     GIR_RootConstrainSelectedInstOperands,
     /*  485482 */     // GIR_Coverage, 62075,
     /*  485482 */     GIR_EraseRootFromParent_Done,
     /*  485483 */   // Label 8176: @485483
     /*  485483 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(485569), // Rule ID 62078 //
     /*  485488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  485499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  485502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  485505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485535 */     // MIs[1] Operand 1
     /*  485535 */     // No operand predicates
     /*  485535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485544 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485567 */     GIR_RootConstrainSelectedInstOperands,
     /*  485568 */     // GIR_Coverage, 62078,
     /*  485568 */     GIR_EraseRootFromParent_Done,
     /*  485569 */   // Label 8177: @485569
     /*  485569 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(485655), // Rule ID 62079 //
     /*  485574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  485585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  485588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  485591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485621 */     // MIs[1] Operand 1
     /*  485621 */     // No operand predicates
     /*  485621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485630 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485653 */     GIR_RootConstrainSelectedInstOperands,
     /*  485654 */     // GIR_Coverage, 62079,
     /*  485654 */     GIR_EraseRootFromParent_Done,
     /*  485655 */   // Label 8178: @485655
     /*  485655 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(485741), // Rule ID 62082 //
     /*  485660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  485671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  485674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  485677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485707 */     // MIs[1] Operand 1
     /*  485707 */     // No operand predicates
     /*  485707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485716 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  485716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485739 */     GIR_RootConstrainSelectedInstOperands,
     /*  485740 */     // GIR_Coverage, 62082,
     /*  485740 */     GIR_EraseRootFromParent_Done,
     /*  485741 */   // Label 8179: @485741
     /*  485741 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(485827), // Rule ID 62083 //
     /*  485746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  485757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  485760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  485763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485793 */     // MIs[1] Operand 1
     /*  485793 */     // No operand predicates
     /*  485793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  485802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485825 */     GIR_RootConstrainSelectedInstOperands,
     /*  485826 */     // GIR_Coverage, 62083,
     /*  485826 */     GIR_EraseRootFromParent_Done,
     /*  485827 */   // Label 8180: @485827
     /*  485827 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(485913), // Rule ID 62086 //
     /*  485832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  485843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  485846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  485849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485879 */     // MIs[1] Operand 1
     /*  485879 */     // No operand predicates
     /*  485879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485888 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  485888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485911 */     GIR_RootConstrainSelectedInstOperands,
     /*  485912 */     // GIR_Coverage, 62086,
     /*  485912 */     GIR_EraseRootFromParent_Done,
     /*  485913 */   // Label 8181: @485913
     /*  485913 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(485999), // Rule ID 62087 //
     /*  485918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  485929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  485932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  485935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485965 */     // MIs[1] Operand 1
     /*  485965 */     // No operand predicates
     /*  485965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485974 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  485974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485997 */     GIR_RootConstrainSelectedInstOperands,
     /*  485998 */     // GIR_Coverage, 62087,
     /*  485998 */     GIR_EraseRootFromParent_Done,
     /*  485999 */   // Label 8182: @485999
     /*  485999 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(486085), // Rule ID 62090 //
     /*  486004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  486015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  486018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  486021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486051 */     // MIs[1] Operand 1
     /*  486051 */     // No operand predicates
     /*  486051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486060 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  486060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  486063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486083 */     GIR_RootConstrainSelectedInstOperands,
     /*  486084 */     // GIR_Coverage, 62090,
     /*  486084 */     GIR_EraseRootFromParent_Done,
     /*  486085 */   // Label 8183: @486085
     /*  486085 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(486171), // Rule ID 62091 //
     /*  486090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  486101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  486104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  486107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486137 */     // MIs[1] Operand 1
     /*  486137 */     // No operand predicates
     /*  486137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  486146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  486149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486169 */     GIR_RootConstrainSelectedInstOperands,
     /*  486170 */     // GIR_Coverage, 62091,
     /*  486170 */     GIR_EraseRootFromParent_Done,
     /*  486171 */   // Label 8184: @486171
     /*  486171 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(486250), // Rule ID 2756 //
     /*  486176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  486187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  486190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  486196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486228 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  486231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486248 */     GIR_RootConstrainSelectedInstOperands,
     /*  486249 */     // GIR_Coverage, 2756,
     /*  486249 */     GIR_EraseRootFromParent_Done,
     /*  486250 */   // Label 8185: @486250
     /*  486250 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(486329), // Rule ID 2757 //
     /*  486255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  486266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  486269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  486275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486307 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  486310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486327 */     GIR_RootConstrainSelectedInstOperands,
     /*  486328 */     // GIR_Coverage, 2757,
     /*  486328 */     GIR_EraseRootFromParent_Done,
     /*  486329 */   // Label 8186: @486329
     /*  486329 */   GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(486408), // Rule ID 4072 //
     /*  486334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  486345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  486348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  486351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  486354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486386 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  486389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486406 */     GIR_RootConstrainSelectedInstOperands,
     /*  486407 */     // GIR_Coverage, 4072,
     /*  486407 */     GIR_EraseRootFromParent_Done,
     /*  486408 */   // Label 8187: @486408
     /*  486408 */   GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(486487), // Rule ID 4073 //
     /*  486413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  486424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  486427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  486430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  486433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486465 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  486468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486485 */     GIR_RootConstrainSelectedInstOperands,
     /*  486486 */     // GIR_Coverage, 4073,
     /*  486486 */     GIR_EraseRootFromParent_Done,
     /*  486487 */   // Label 8188: @486487
     /*  486487 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(486566), // Rule ID 4082 //
     /*  486492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  486503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  486506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  486509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  486512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486544 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  486547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486564 */     GIR_RootConstrainSelectedInstOperands,
     /*  486565 */     // GIR_Coverage, 4082,
     /*  486565 */     GIR_EraseRootFromParent_Done,
     /*  486566 */   // Label 8189: @486566
     /*  486566 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(486645), // Rule ID 4083 //
     /*  486571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  486582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  486585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  486588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  486591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486623 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  486626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486643 */     GIR_RootConstrainSelectedInstOperands,
     /*  486644 */     // GIR_Coverage, 4083,
     /*  486644 */     GIR_EraseRootFromParent_Done,
     /*  486645 */   // Label 8190: @486645
     /*  486645 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(486724), // Rule ID 4092 //
     /*  486650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  486661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  486664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  486667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  486670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  486705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486722 */     GIR_RootConstrainSelectedInstOperands,
     /*  486723 */     // GIR_Coverage, 4092,
     /*  486723 */     GIR_EraseRootFromParent_Done,
     /*  486724 */   // Label 8191: @486724
     /*  486724 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(486803), // Rule ID 4093 //
     /*  486729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  486740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  486743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  486746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  486749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486781 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  486784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486801 */     GIR_RootConstrainSelectedInstOperands,
     /*  486802 */     // GIR_Coverage, 4093,
     /*  486802 */     GIR_EraseRootFromParent_Done,
     /*  486803 */   // Label 8192: @486803
     /*  486803 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(486882), // Rule ID 4102 //
     /*  486808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  486819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  486822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  486825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  486828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486860 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  486863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486880 */     GIR_RootConstrainSelectedInstOperands,
     /*  486881 */     // GIR_Coverage, 4102,
     /*  486881 */     GIR_EraseRootFromParent_Done,
     /*  486882 */   // Label 8193: @486882
     /*  486882 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(486961), // Rule ID 4103 //
     /*  486887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  486898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  486901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  486904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  486907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486939 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  486942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486959 */     GIR_RootConstrainSelectedInstOperands,
     /*  486960 */     // GIR_Coverage, 4103,
     /*  486960 */     GIR_EraseRootFromParent_Done,
     /*  486961 */   // Label 8194: @486961
     /*  486961 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(487040), // Rule ID 4112 //
     /*  486966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  486977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  486980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  486983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  486986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487018 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  487018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487038 */     GIR_RootConstrainSelectedInstOperands,
     /*  487039 */     // GIR_Coverage, 4112,
     /*  487039 */     GIR_EraseRootFromParent_Done,
     /*  487040 */   // Label 8195: @487040
     /*  487040 */   GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(487119), // Rule ID 4113 //
     /*  487045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  487056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  487059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  487062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  487065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487097 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  487097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487117 */     GIR_RootConstrainSelectedInstOperands,
     /*  487118 */     // GIR_Coverage, 4113,
     /*  487118 */     GIR_EraseRootFromParent_Done,
     /*  487119 */   // Label 8196: @487119
     /*  487119 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(487198), // Rule ID 4122 //
     /*  487124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  487135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  487138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  487144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  487179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487196 */     GIR_RootConstrainSelectedInstOperands,
     /*  487197 */     // GIR_Coverage, 4122,
     /*  487197 */     GIR_EraseRootFromParent_Done,
     /*  487198 */   // Label 8197: @487198
     /*  487198 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(487277), // Rule ID 4123 //
     /*  487203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  487214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  487217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  487223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487255 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  487258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487275 */     GIR_RootConstrainSelectedInstOperands,
     /*  487276 */     // GIR_Coverage, 4123,
     /*  487276 */     GIR_EraseRootFromParent_Done,
     /*  487277 */   // Label 8198: @487277
     /*  487277 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(487356), // Rule ID 4132 //
     /*  487282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  487293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  487296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  487302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487354 */     GIR_RootConstrainSelectedInstOperands,
     /*  487355 */     // GIR_Coverage, 4132,
     /*  487355 */     GIR_EraseRootFromParent_Done,
     /*  487356 */   // Label 8199: @487356
     /*  487356 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(487435), // Rule ID 4133 //
     /*  487361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  487372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  487375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  487381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487413 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487433 */     GIR_RootConstrainSelectedInstOperands,
     /*  487434 */     // GIR_Coverage, 4133,
     /*  487434 */     GIR_EraseRootFromParent_Done,
     /*  487435 */   // Label 8200: @487435
     /*  487435 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(487514), // Rule ID 4142 //
     /*  487440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  487451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  487454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  487457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  487460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  487495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487512 */     GIR_RootConstrainSelectedInstOperands,
     /*  487513 */     // GIR_Coverage, 4142,
     /*  487513 */     GIR_EraseRootFromParent_Done,
     /*  487514 */   // Label 8201: @487514
     /*  487514 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(487593), // Rule ID 4143 //
     /*  487519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  487530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  487533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  487536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  487539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  487574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487591 */     GIR_RootConstrainSelectedInstOperands,
     /*  487592 */     // GIR_Coverage, 4143,
     /*  487592 */     GIR_EraseRootFromParent_Done,
     /*  487593 */   // Label 8202: @487593
     /*  487593 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(487672), // Rule ID 4152 //
     /*  487598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  487609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  487612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  487615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  487618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487650 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  487653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487670 */     GIR_RootConstrainSelectedInstOperands,
     /*  487671 */     // GIR_Coverage, 4152,
     /*  487671 */     GIR_EraseRootFromParent_Done,
     /*  487672 */   // Label 8203: @487672
     /*  487672 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(487751), // Rule ID 4153 //
     /*  487677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  487688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  487691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  487694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  487697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487729 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  487732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487749 */     GIR_RootConstrainSelectedInstOperands,
     /*  487750 */     // GIR_Coverage, 4153,
     /*  487750 */     GIR_EraseRootFromParent_Done,
     /*  487751 */   // Label 8204: @487751
     /*  487751 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(487830), // Rule ID 4162 //
     /*  487756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  487767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  487770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  487773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  487776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487808 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487828 */     GIR_RootConstrainSelectedInstOperands,
     /*  487829 */     // GIR_Coverage, 4162,
     /*  487829 */     GIR_EraseRootFromParent_Done,
     /*  487830 */   // Label 8205: @487830
     /*  487830 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(487909), // Rule ID 4163 //
     /*  487835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  487846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  487849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  487852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  487855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487887 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487907 */     GIR_RootConstrainSelectedInstOperands,
     /*  487908 */     // GIR_Coverage, 4163,
     /*  487908 */     GIR_EraseRootFromParent_Done,
     /*  487909 */   // Label 8206: @487909
     /*  487909 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(487988), // Rule ID 4172 //
     /*  487914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  487917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  487925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  487928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  487931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  487934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487966 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  487966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487986 */     GIR_RootConstrainSelectedInstOperands,
     /*  487987 */     // GIR_Coverage, 4172,
     /*  487987 */     GIR_EraseRootFromParent_Done,
     /*  487988 */   // Label 8207: @487988
     /*  487988 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(488067), // Rule ID 4173 //
     /*  487993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  487996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  488004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  488007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  488010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  488013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488045 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  488048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488065 */     GIR_RootConstrainSelectedInstOperands,
     /*  488066 */     // GIR_Coverage, 4173,
     /*  488066 */     GIR_EraseRootFromParent_Done,
     /*  488067 */   // Label 8208: @488067
     /*  488067 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(488146), // Rule ID 4182 //
     /*  488072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  488083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  488086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  488089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  488092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  488127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488144 */     GIR_RootConstrainSelectedInstOperands,
     /*  488145 */     // GIR_Coverage, 4182,
     /*  488145 */     GIR_EraseRootFromParent_Done,
     /*  488146 */   // Label 8209: @488146
     /*  488146 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(488225), // Rule ID 4183 //
     /*  488151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  488162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  488165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  488168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  488171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488203 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  488206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488223 */     GIR_RootConstrainSelectedInstOperands,
     /*  488224 */     // GIR_Coverage, 4183,
     /*  488224 */     GIR_EraseRootFromParent_Done,
     /*  488225 */   // Label 8210: @488225
     /*  488225 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(488304), // Rule ID 4192 //
     /*  488230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  488241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  488244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  488247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  488250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488282 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  488285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488302 */     GIR_RootConstrainSelectedInstOperands,
     /*  488303 */     // GIR_Coverage, 4192,
     /*  488303 */     GIR_EraseRootFromParent_Done,
     /*  488304 */   // Label 8211: @488304
     /*  488304 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(488383), // Rule ID 4193 //
     /*  488309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  488320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  488323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  488326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  488329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488361 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  488364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488381 */     GIR_RootConstrainSelectedInstOperands,
     /*  488382 */     // GIR_Coverage, 4193,
     /*  488382 */     GIR_EraseRootFromParent_Done,
     /*  488383 */   // Label 8212: @488383
     /*  488383 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(488462), // Rule ID 4202 //
     /*  488388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  488399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  488402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  488405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  488408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488440 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  488443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488460 */     GIR_RootConstrainSelectedInstOperands,
     /*  488461 */     // GIR_Coverage, 4202,
     /*  488461 */     GIR_EraseRootFromParent_Done,
     /*  488462 */   // Label 8213: @488462
     /*  488462 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(488541), // Rule ID 4203 //
     /*  488467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  488478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  488481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  488484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  488487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488519 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11659:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  488522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488539 */     GIR_RootConstrainSelectedInstOperands,
     /*  488540 */     // GIR_Coverage, 4203,
     /*  488540 */     GIR_EraseRootFromParent_Done,
     /*  488541 */   // Label 8214: @488541
     /*  488541 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(488620), // Rule ID 4272 //
     /*  488546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  488557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  488560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  488563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  488566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488598 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  488598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  488601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488618 */     GIR_RootConstrainSelectedInstOperands,
     /*  488619 */     // GIR_Coverage, 4272,
     /*  488619 */     GIR_EraseRootFromParent_Done,
     /*  488620 */   // Label 8215: @488620
     /*  488620 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(488699), // Rule ID 4273 //
     /*  488625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  488636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  488639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  488642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  488645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488677 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  488677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  488680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488697 */     GIR_RootConstrainSelectedInstOperands,
     /*  488698 */     // GIR_Coverage, 4273,
     /*  488698 */     GIR_EraseRootFromParent_Done,
     /*  488699 */   // Label 8216: @488699
     /*  488699 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(488778), // Rule ID 4282 //
     /*  488704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  488715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  488718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  488721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  488724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488756 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  488756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  488759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488776 */     GIR_RootConstrainSelectedInstOperands,
     /*  488777 */     // GIR_Coverage, 4282,
     /*  488777 */     GIR_EraseRootFromParent_Done,
     /*  488778 */   // Label 8217: @488778
     /*  488778 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(488857), // Rule ID 4283 //
     /*  488783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  488794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  488797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  488800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  488803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488835 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  488835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  488838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488855 */     GIR_RootConstrainSelectedInstOperands,
     /*  488856 */     // GIR_Coverage, 4283,
     /*  488856 */     GIR_EraseRootFromParent_Done,
     /*  488857 */   // Label 8218: @488857
     /*  488857 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(488936), // Rule ID 4292 //
     /*  488862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  488873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  488876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  488879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  488882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488914 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  488914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  488917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488934 */     GIR_RootConstrainSelectedInstOperands,
     /*  488935 */     // GIR_Coverage, 4292,
     /*  488935 */     GIR_EraseRootFromParent_Done,
     /*  488936 */   // Label 8219: @488936
     /*  488936 */   GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(489015), // Rule ID 4293 //
     /*  488941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  488952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  488955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  488958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  488961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488993 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  488993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  488996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489013 */     GIR_RootConstrainSelectedInstOperands,
     /*  489014 */     // GIR_Coverage, 4293,
     /*  489014 */     GIR_EraseRootFromParent_Done,
     /*  489015 */   // Label 8220: @489015
     /*  489015 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(489094), // Rule ID 4302 //
     /*  489020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  489031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  489034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  489037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  489040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489072 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489092 */     GIR_RootConstrainSelectedInstOperands,
     /*  489093 */     // GIR_Coverage, 4302,
     /*  489093 */     GIR_EraseRootFromParent_Done,
     /*  489094 */   // Label 8221: @489094
     /*  489094 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(489173), // Rule ID 4303 //
     /*  489099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  489110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  489113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  489116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  489119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489151 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489171 */     GIR_RootConstrainSelectedInstOperands,
     /*  489172 */     // GIR_Coverage, 4303,
     /*  489172 */     GIR_EraseRootFromParent_Done,
     /*  489173 */   // Label 8222: @489173
     /*  489173 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(489252), // Rule ID 4312 //
     /*  489178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  489189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  489192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  489195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  489198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489230 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  489233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489250 */     GIR_RootConstrainSelectedInstOperands,
     /*  489251 */     // GIR_Coverage, 4312,
     /*  489251 */     GIR_EraseRootFromParent_Done,
     /*  489252 */   // Label 8223: @489252
     /*  489252 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(489331), // Rule ID 4313 //
     /*  489257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  489268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  489271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  489274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  489277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489309 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  489312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489329 */     GIR_RootConstrainSelectedInstOperands,
     /*  489330 */     // GIR_Coverage, 4313,
     /*  489330 */     GIR_EraseRootFromParent_Done,
     /*  489331 */   // Label 8224: @489331
     /*  489331 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(489410), // Rule ID 4322 //
     /*  489336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  489347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  489350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  489353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  489356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489388 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  489391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489408 */     GIR_RootConstrainSelectedInstOperands,
     /*  489409 */     // GIR_Coverage, 4322,
     /*  489409 */     GIR_EraseRootFromParent_Done,
     /*  489410 */   // Label 8225: @489410
     /*  489410 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(489489), // Rule ID 4323 //
     /*  489415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  489426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  489429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  489432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  489435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489467 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  489470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489487 */     GIR_RootConstrainSelectedInstOperands,
     /*  489488 */     // GIR_Coverage, 4323,
     /*  489488 */     GIR_EraseRootFromParent_Done,
     /*  489489 */   // Label 8226: @489489
     /*  489489 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(489568), // Rule ID 4332 //
     /*  489494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  489505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  489508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  489511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  489514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  489546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  489549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489566 */     GIR_RootConstrainSelectedInstOperands,
     /*  489567 */     // GIR_Coverage, 4332,
     /*  489567 */     GIR_EraseRootFromParent_Done,
     /*  489568 */   // Label 8227: @489568
     /*  489568 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(489647), // Rule ID 4333 //
     /*  489573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  489584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  489587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  489590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  489593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489625 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  489625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  489628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489645 */     GIR_RootConstrainSelectedInstOperands,
     /*  489646 */     // GIR_Coverage, 4333,
     /*  489646 */     GIR_EraseRootFromParent_Done,
     /*  489647 */   // Label 8228: @489647
     /*  489647 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(489726), // Rule ID 4342 //
     /*  489652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  489663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  489666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  489669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  489672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489704 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  489704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  489707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489724 */     GIR_RootConstrainSelectedInstOperands,
     /*  489725 */     // GIR_Coverage, 4342,
     /*  489725 */     GIR_EraseRootFromParent_Done,
     /*  489726 */   // Label 8229: @489726
     /*  489726 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(489805), // Rule ID 4343 //
     /*  489731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  489742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  489745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  489748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  489751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489783 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  489783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  489786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489803 */     GIR_RootConstrainSelectedInstOperands,
     /*  489804 */     // GIR_Coverage, 4343,
     /*  489804 */     GIR_EraseRootFromParent_Done,
     /*  489805 */   // Label 8230: @489805
     /*  489805 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(489884), // Rule ID 4352 //
     /*  489810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  489821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  489824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  489827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  489830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  489862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489882 */     GIR_RootConstrainSelectedInstOperands,
     /*  489883 */     // GIR_Coverage, 4352,
     /*  489883 */     GIR_EraseRootFromParent_Done,
     /*  489884 */   // Label 8231: @489884
     /*  489884 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(489963), // Rule ID 4353 //
     /*  489889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  489900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  489903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  489906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  489909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489941 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  489941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489961 */     GIR_RootConstrainSelectedInstOperands,
     /*  489962 */     // GIR_Coverage, 4353,
     /*  489962 */     GIR_EraseRootFromParent_Done,
     /*  489963 */   // Label 8232: @489963
     /*  489963 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(490042), // Rule ID 4362 //
     /*  489968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  489979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  489982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  489985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  489988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490020 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490040 */     GIR_RootConstrainSelectedInstOperands,
     /*  490041 */     // GIR_Coverage, 4362,
     /*  490041 */     GIR_EraseRootFromParent_Done,
     /*  490042 */   // Label 8233: @490042
     /*  490042 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(490121), // Rule ID 4363 //
     /*  490047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  490058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  490061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  490064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  490067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490099 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490119 */     GIR_RootConstrainSelectedInstOperands,
     /*  490120 */     // GIR_Coverage, 4363,
     /*  490120 */     GIR_EraseRootFromParent_Done,
     /*  490121 */   // Label 8234: @490121
     /*  490121 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(490200), // Rule ID 4372 //
     /*  490126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  490137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  490140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  490143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  490146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490178 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490198 */     GIR_RootConstrainSelectedInstOperands,
     /*  490199 */     // GIR_Coverage, 4372,
     /*  490199 */     GIR_EraseRootFromParent_Done,
     /*  490200 */   // Label 8235: @490200
     /*  490200 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(490279), // Rule ID 4373 //
     /*  490205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  490216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  490219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  490222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  490225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490257 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490277 */     GIR_RootConstrainSelectedInstOperands,
     /*  490278 */     // GIR_Coverage, 4373,
     /*  490278 */     GIR_EraseRootFromParent_Done,
     /*  490279 */   // Label 8236: @490279
     /*  490279 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(490358), // Rule ID 4382 //
     /*  490284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  490295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  490298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  490301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  490304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  490339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490356 */     GIR_RootConstrainSelectedInstOperands,
     /*  490357 */     // GIR_Coverage, 4382,
     /*  490357 */     GIR_EraseRootFromParent_Done,
     /*  490358 */   // Label 8237: @490358
     /*  490358 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(490437), // Rule ID 4383 //
     /*  490363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  490374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  490377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  490380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  490383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490415 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  490415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  490418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490435 */     GIR_RootConstrainSelectedInstOperands,
     /*  490436 */     // GIR_Coverage, 4383,
     /*  490436 */     GIR_EraseRootFromParent_Done,
     /*  490437 */   // Label 8238: @490437
     /*  490437 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(490516), // Rule ID 4392 //
     /*  490442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  490453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  490456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  490459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  490462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  490497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490514 */     GIR_RootConstrainSelectedInstOperands,
     /*  490515 */     // GIR_Coverage, 4392,
     /*  490515 */     GIR_EraseRootFromParent_Done,
     /*  490516 */   // Label 8239: @490516
     /*  490516 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(490595), // Rule ID 4393 //
     /*  490521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  490532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  490535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  490538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  490541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490573 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  490573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  490576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490593 */     GIR_RootConstrainSelectedInstOperands,
     /*  490594 */     // GIR_Coverage, 4393,
     /*  490594 */     GIR_EraseRootFromParent_Done,
     /*  490595 */   // Label 8240: @490595
     /*  490595 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(490674), // Rule ID 4402 //
     /*  490600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  490611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  490614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  490617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  490620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490652 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490672 */     GIR_RootConstrainSelectedInstOperands,
     /*  490673 */     // GIR_Coverage, 4402,
     /*  490673 */     GIR_EraseRootFromParent_Done,
     /*  490674 */   // Label 8241: @490674
     /*  490674 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(490753), // Rule ID 4403 //
     /*  490679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  490690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  490693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  490696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  490699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490731 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  490731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490751 */     GIR_RootConstrainSelectedInstOperands,
     /*  490752 */     // GIR_Coverage, 4403,
     /*  490752 */     GIR_EraseRootFromParent_Done,
     /*  490753 */   // Label 8242: @490753
     /*  490753 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(490832), // Rule ID 4412 //
     /*  490758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  490769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  490772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  490775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  490778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490810 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490830 */     GIR_RootConstrainSelectedInstOperands,
     /*  490831 */     // GIR_Coverage, 4412,
     /*  490831 */     GIR_EraseRootFromParent_Done,
     /*  490832 */   // Label 8243: @490832
     /*  490832 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(490911), // Rule ID 4413 //
     /*  490837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  490848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  490851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  490854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  490857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490889 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11687:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  490889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490909 */     GIR_RootConstrainSelectedInstOperands,
     /*  490910 */     // GIR_Coverage, 4413,
     /*  490910 */     GIR_EraseRootFromParent_Done,
     /*  490911 */   // Label 8244: @490911
     /*  490911 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(490990), // Rule ID 4482 //
     /*  490916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  490924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  490927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  490930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  490933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  490936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490968 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  490971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490988 */     GIR_RootConstrainSelectedInstOperands,
     /*  490989 */     // GIR_Coverage, 4482,
     /*  490989 */     GIR_EraseRootFromParent_Done,
     /*  490990 */   // Label 8245: @490990
     /*  490990 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(491069), // Rule ID 4483 //
     /*  490995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  491006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  491009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  491012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  491015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491047 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  491050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491067 */     GIR_RootConstrainSelectedInstOperands,
     /*  491068 */     // GIR_Coverage, 4483,
     /*  491068 */     GIR_EraseRootFromParent_Done,
     /*  491069 */   // Label 8246: @491069
     /*  491069 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(491148), // Rule ID 4492 //
     /*  491074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  491085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  491088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  491091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  491094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491146 */     GIR_RootConstrainSelectedInstOperands,
     /*  491147 */     // GIR_Coverage, 4492,
     /*  491147 */     GIR_EraseRootFromParent_Done,
     /*  491148 */   // Label 8247: @491148
     /*  491148 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(491227), // Rule ID 4493 //
     /*  491153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  491164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  491167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  491170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  491173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491205 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491225 */     GIR_RootConstrainSelectedInstOperands,
     /*  491226 */     // GIR_Coverage, 4493,
     /*  491226 */     GIR_EraseRootFromParent_Done,
     /*  491227 */   // Label 8248: @491227
     /*  491227 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(491306), // Rule ID 4502 //
     /*  491232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  491243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  491246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  491249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  491252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  491287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491304 */     GIR_RootConstrainSelectedInstOperands,
     /*  491305 */     // GIR_Coverage, 4502,
     /*  491305 */     GIR_EraseRootFromParent_Done,
     /*  491306 */   // Label 8249: @491306
     /*  491306 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(491385), // Rule ID 4503 //
     /*  491311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  491322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  491325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  491328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  491331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491363 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  491366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491383 */     GIR_RootConstrainSelectedInstOperands,
     /*  491384 */     // GIR_Coverage, 4503,
     /*  491384 */     GIR_EraseRootFromParent_Done,
     /*  491385 */   // Label 8250: @491385
     /*  491385 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(491464), // Rule ID 4512 //
     /*  491390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  491401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  491404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  491407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  491410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  491445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491462 */     GIR_RootConstrainSelectedInstOperands,
     /*  491463 */     // GIR_Coverage, 4512,
     /*  491463 */     GIR_EraseRootFromParent_Done,
     /*  491464 */   // Label 8251: @491464
     /*  491464 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(491543), // Rule ID 4513 //
     /*  491469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  491480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  491483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  491486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  491489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  491524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491541 */     GIR_RootConstrainSelectedInstOperands,
     /*  491542 */     // GIR_Coverage, 4513,
     /*  491542 */     GIR_EraseRootFromParent_Done,
     /*  491543 */   // Label 8252: @491543
     /*  491543 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(491622), // Rule ID 4522 //
     /*  491548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  491559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  491562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  491565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  491568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491600 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  491603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491620 */     GIR_RootConstrainSelectedInstOperands,
     /*  491621 */     // GIR_Coverage, 4522,
     /*  491621 */     GIR_EraseRootFromParent_Done,
     /*  491622 */   // Label 8253: @491622
     /*  491622 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(491701), // Rule ID 4523 //
     /*  491627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  491638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  491641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  491644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  491647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491679 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  491682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491699 */     GIR_RootConstrainSelectedInstOperands,
     /*  491700 */     // GIR_Coverage, 4523,
     /*  491700 */     GIR_EraseRootFromParent_Done,
     /*  491701 */   // Label 8254: @491701
     /*  491701 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(491780), // Rule ID 4532 //
     /*  491706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  491717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  491720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  491723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  491726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491758 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  491761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491778 */     GIR_RootConstrainSelectedInstOperands,
     /*  491779 */     // GIR_Coverage, 4532,
     /*  491779 */     GIR_EraseRootFromParent_Done,
     /*  491780 */   // Label 8255: @491780
     /*  491780 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(491859), // Rule ID 4533 //
     /*  491785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  491796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  491799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  491802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  491805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491837 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  491840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491857 */     GIR_RootConstrainSelectedInstOperands,
     /*  491858 */     // GIR_Coverage, 4533,
     /*  491858 */     GIR_EraseRootFromParent_Done,
     /*  491859 */   // Label 8256: @491859
     /*  491859 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(491938), // Rule ID 4542 //
     /*  491864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  491875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  491878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  491881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  491884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491916 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491936 */     GIR_RootConstrainSelectedInstOperands,
     /*  491937 */     // GIR_Coverage, 4542,
     /*  491937 */     GIR_EraseRootFromParent_Done,
     /*  491938 */   // Label 8257: @491938
     /*  491938 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(492017), // Rule ID 4543 //
     /*  491943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  491954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  491957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  491960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  491963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491995 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492015 */     GIR_RootConstrainSelectedInstOperands,
     /*  492016 */     // GIR_Coverage, 4543,
     /*  492016 */     GIR_EraseRootFromParent_Done,
     /*  492017 */   // Label 8258: @492017
     /*  492017 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(492096), // Rule ID 4552 //
     /*  492022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  492033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  492036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  492039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  492042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492094 */     GIR_RootConstrainSelectedInstOperands,
     /*  492095 */     // GIR_Coverage, 4552,
     /*  492095 */     GIR_EraseRootFromParent_Done,
     /*  492096 */   // Label 8259: @492096
     /*  492096 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(492175), // Rule ID 4553 //
     /*  492101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  492112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  492115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  492118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  492121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492153 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492173 */     GIR_RootConstrainSelectedInstOperands,
     /*  492174 */     // GIR_Coverage, 4553,
     /*  492174 */     GIR_EraseRootFromParent_Done,
     /*  492175 */   // Label 8260: @492175
     /*  492175 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(492254), // Rule ID 4562 //
     /*  492180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  492191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  492194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  492197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  492200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492252 */     GIR_RootConstrainSelectedInstOperands,
     /*  492253 */     // GIR_Coverage, 4562,
     /*  492253 */     GIR_EraseRootFromParent_Done,
     /*  492254 */   // Label 8261: @492254
     /*  492254 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(492333), // Rule ID 4563 //
     /*  492259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  492270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  492273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  492276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  492279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492311 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492331 */     GIR_RootConstrainSelectedInstOperands,
     /*  492332 */     // GIR_Coverage, 4563,
     /*  492332 */     GIR_EraseRootFromParent_Done,
     /*  492333 */   // Label 8262: @492333
     /*  492333 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(492412), // Rule ID 4572 //
     /*  492338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  492349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  492352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  492355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  492358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492390 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492410 */     GIR_RootConstrainSelectedInstOperands,
     /*  492411 */     // GIR_Coverage, 4572,
     /*  492411 */     GIR_EraseRootFromParent_Done,
     /*  492412 */   // Label 8263: @492412
     /*  492412 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(492491), // Rule ID 4573 //
     /*  492417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  492428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  492431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  492434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  492437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492469 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492489 */     GIR_RootConstrainSelectedInstOperands,
     /*  492490 */     // GIR_Coverage, 4573,
     /*  492490 */     GIR_EraseRootFromParent_Done,
     /*  492491 */   // Label 8264: @492491
     /*  492491 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(492570), // Rule ID 4582 //
     /*  492496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  492507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  492510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  492513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  492516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492548 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  492551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492568 */     GIR_RootConstrainSelectedInstOperands,
     /*  492569 */     // GIR_Coverage, 4582,
     /*  492569 */     GIR_EraseRootFromParent_Done,
     /*  492570 */   // Label 8265: @492570
     /*  492570 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(492649), // Rule ID 4583 //
     /*  492575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  492586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  492589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  492592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  492595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492627 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  492630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492647 */     GIR_RootConstrainSelectedInstOperands,
     /*  492648 */     // GIR_Coverage, 4583,
     /*  492648 */     GIR_EraseRootFromParent_Done,
     /*  492649 */   // Label 8266: @492649
     /*  492649 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(492728), // Rule ID 4592 //
     /*  492654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  492665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  492668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  492671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  492674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  492706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492726 */     GIR_RootConstrainSelectedInstOperands,
     /*  492727 */     // GIR_Coverage, 4592,
     /*  492727 */     GIR_EraseRootFromParent_Done,
     /*  492728 */   // Label 8267: @492728
     /*  492728 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(492807), // Rule ID 4593 //
     /*  492733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  492744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  492747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  492750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  492753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492785 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492805 */     GIR_RootConstrainSelectedInstOperands,
     /*  492806 */     // GIR_Coverage, 4593,
     /*  492806 */     GIR_EraseRootFromParent_Done,
     /*  492807 */   // Label 8268: @492807
     /*  492807 */   GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(492886), // Rule ID 4602 //
     /*  492812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  492823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  492826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  492829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  492832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  492864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492884 */     GIR_RootConstrainSelectedInstOperands,
     /*  492885 */     // GIR_Coverage, 4602,
     /*  492885 */     GIR_EraseRootFromParent_Done,
     /*  492886 */   // Label 8269: @492886
     /*  492886 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(492965), // Rule ID 4603 //
     /*  492891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  492902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  492905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  492908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  492911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492963 */     GIR_RootConstrainSelectedInstOperands,
     /*  492964 */     // GIR_Coverage, 4603,
     /*  492964 */     GIR_EraseRootFromParent_Done,
     /*  492965 */   // Label 8270: @492965
     /*  492965 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(493044), // Rule ID 4612 //
     /*  492970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  492981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  492984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  492987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  492990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493022 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  493022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  493025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493042 */     GIR_RootConstrainSelectedInstOperands,
     /*  493043 */     // GIR_Coverage, 4612,
     /*  493043 */     GIR_EraseRootFromParent_Done,
     /*  493044 */   // Label 8271: @493044
     /*  493044 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(493123), // Rule ID 4613 //
     /*  493049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  493052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  493060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  493063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  493066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  493069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493101 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  493101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  493104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493121 */     GIR_RootConstrainSelectedInstOperands,
     /*  493122 */     // GIR_Coverage, 4613,
     /*  493122 */     GIR_EraseRootFromParent_Done,
     /*  493123 */   // Label 8272: @493123
     /*  493123 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(493202), // Rule ID 4622 //
     /*  493128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  493131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  493139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  493142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  493145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  493148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493180 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  493180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  493183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493200 */     GIR_RootConstrainSelectedInstOperands,
     /*  493201 */     // GIR_Coverage, 4622,
     /*  493201 */     GIR_EraseRootFromParent_Done,
     /*  493202 */   // Label 8273: @493202
     /*  493202 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(493281), // Rule ID 4623 //
     /*  493207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  493210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  493218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  493221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  493224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  493227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493259 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  493259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  493262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493279 */     GIR_RootConstrainSelectedInstOperands,
     /*  493280 */     // GIR_Coverage, 4623,
     /*  493280 */     GIR_EraseRootFromParent_Done,
     /*  493281 */   // Label 8274: @493281
     /*  493281 */   GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(493360), // Rule ID 4692 //
     /*  493286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  493297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  493300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  493303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  493306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493338 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  493341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493358 */     GIR_RootConstrainSelectedInstOperands,
     /*  493359 */     // GIR_Coverage, 4692,
     /*  493359 */     GIR_EraseRootFromParent_Done,
     /*  493360 */   // Label 8275: @493360
     /*  493360 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(493439), // Rule ID 4693 //
     /*  493365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  493376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  493379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  493382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  493385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493417 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  493420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493437 */     GIR_RootConstrainSelectedInstOperands,
     /*  493438 */     // GIR_Coverage, 4693,
     /*  493438 */     GIR_EraseRootFromParent_Done,
     /*  493439 */   // Label 8276: @493439
     /*  493439 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(493518), // Rule ID 4702 //
     /*  493444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  493455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  493458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  493461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  493464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  493499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493516 */     GIR_RootConstrainSelectedInstOperands,
     /*  493517 */     // GIR_Coverage, 4702,
     /*  493517 */     GIR_EraseRootFromParent_Done,
     /*  493518 */   // Label 8277: @493518
     /*  493518 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(493597), // Rule ID 4703 //
     /*  493523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  493534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  493537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  493540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  493543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493575 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  493578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493595 */     GIR_RootConstrainSelectedInstOperands,
     /*  493596 */     // GIR_Coverage, 4703,
     /*  493596 */     GIR_EraseRootFromParent_Done,
     /*  493597 */   // Label 8278: @493597
     /*  493597 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(493676), // Rule ID 4712 //
     /*  493602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  493613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  493616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  493619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  493622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493654 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  493657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493674 */     GIR_RootConstrainSelectedInstOperands,
     /*  493675 */     // GIR_Coverage, 4712,
     /*  493675 */     GIR_EraseRootFromParent_Done,
     /*  493676 */   // Label 8279: @493676
     /*  493676 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(493755), // Rule ID 4713 //
     /*  493681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  493692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  493695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  493698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  493701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493733 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  493736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493753 */     GIR_RootConstrainSelectedInstOperands,
     /*  493754 */     // GIR_Coverage, 4713,
     /*  493754 */     GIR_EraseRootFromParent_Done,
     /*  493755 */   // Label 8280: @493755
     /*  493755 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(493834), // Rule ID 4722 //
     /*  493760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  493771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  493774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  493777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  493780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493812 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  493815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493832 */     GIR_RootConstrainSelectedInstOperands,
     /*  493833 */     // GIR_Coverage, 4722,
     /*  493833 */     GIR_EraseRootFromParent_Done,
     /*  493834 */   // Label 8281: @493834
     /*  493834 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(493913), // Rule ID 4723 //
     /*  493839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  493850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  493853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  493856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  493859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493891 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  493894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493911 */     GIR_RootConstrainSelectedInstOperands,
     /*  493912 */     // GIR_Coverage, 4723,
     /*  493912 */     GIR_EraseRootFromParent_Done,
     /*  493913 */   // Label 8282: @493913
     /*  493913 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(493992), // Rule ID 4732 //
     /*  493918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  493929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  493932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  493935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  493938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493970 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  493973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493990 */     GIR_RootConstrainSelectedInstOperands,
     /*  493991 */     // GIR_Coverage, 4732,
     /*  493991 */     GIR_EraseRootFromParent_Done,
     /*  493992 */   // Label 8283: @493992
     /*  493992 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(494071), // Rule ID 4733 //
     /*  493997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  494008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  494011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  494014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  494017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494049 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494069 */     GIR_RootConstrainSelectedInstOperands,
     /*  494070 */     // GIR_Coverage, 4733,
     /*  494070 */     GIR_EraseRootFromParent_Done,
     /*  494071 */   // Label 8284: @494071
     /*  494071 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(494150), // Rule ID 4742 //
     /*  494076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  494087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  494090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  494093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  494096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494128 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  494131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494148 */     GIR_RootConstrainSelectedInstOperands,
     /*  494149 */     // GIR_Coverage, 4742,
     /*  494149 */     GIR_EraseRootFromParent_Done,
     /*  494150 */   // Label 8285: @494150
     /*  494150 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(494229), // Rule ID 4743 //
     /*  494155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  494166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  494169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  494172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  494175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494207 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  494210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494227 */     GIR_RootConstrainSelectedInstOperands,
     /*  494228 */     // GIR_Coverage, 4743,
     /*  494228 */     GIR_EraseRootFromParent_Done,
     /*  494229 */   // Label 8286: @494229
     /*  494229 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(494308), // Rule ID 4752 //
     /*  494234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  494245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  494248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  494251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  494254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494286 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  494289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494306 */     GIR_RootConstrainSelectedInstOperands,
     /*  494307 */     // GIR_Coverage, 4752,
     /*  494307 */     GIR_EraseRootFromParent_Done,
     /*  494308 */   // Label 8287: @494308
     /*  494308 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(494387), // Rule ID 4753 //
     /*  494313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  494324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  494327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  494330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  494333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494365 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  494368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494385 */     GIR_RootConstrainSelectedInstOperands,
     /*  494386 */     // GIR_Coverage, 4753,
     /*  494386 */     GIR_EraseRootFromParent_Done,
     /*  494387 */   // Label 8288: @494387
     /*  494387 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(494466), // Rule ID 4762 //
     /*  494392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  494403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  494406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  494409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  494412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494464 */     GIR_RootConstrainSelectedInstOperands,
     /*  494465 */     // GIR_Coverage, 4762,
     /*  494465 */     GIR_EraseRootFromParent_Done,
     /*  494466 */   // Label 8289: @494466
     /*  494466 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(494545), // Rule ID 4763 //
     /*  494471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  494482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  494485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  494488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  494491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494523 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494543 */     GIR_RootConstrainSelectedInstOperands,
     /*  494544 */     // GIR_Coverage, 4763,
     /*  494544 */     GIR_EraseRootFromParent_Done,
     /*  494545 */   // Label 8290: @494545
     /*  494545 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(494624), // Rule ID 4772 //
     /*  494550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  494561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  494564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  494567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  494570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494602 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  494605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494622 */     GIR_RootConstrainSelectedInstOperands,
     /*  494623 */     // GIR_Coverage, 4772,
     /*  494623 */     GIR_EraseRootFromParent_Done,
     /*  494624 */   // Label 8291: @494624
     /*  494624 */   GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(494703), // Rule ID 4773 //
     /*  494629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  494640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  494643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  494646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  494649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  494684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494701 */     GIR_RootConstrainSelectedInstOperands,
     /*  494702 */     // GIR_Coverage, 4773,
     /*  494702 */     GIR_EraseRootFromParent_Done,
     /*  494703 */   // Label 8292: @494703
     /*  494703 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(494782), // Rule ID 4782 //
     /*  494708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  494719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  494722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  494725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  494728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494760 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494780 */     GIR_RootConstrainSelectedInstOperands,
     /*  494781 */     // GIR_Coverage, 4782,
     /*  494781 */     GIR_EraseRootFromParent_Done,
     /*  494782 */   // Label 8293: @494782
     /*  494782 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(494861), // Rule ID 4783 //
     /*  494787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  494798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  494801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  494804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  494807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494839 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494859 */     GIR_RootConstrainSelectedInstOperands,
     /*  494860 */     // GIR_Coverage, 4783,
     /*  494860 */     GIR_EraseRootFromParent_Done,
     /*  494861 */   // Label 8294: @494861
     /*  494861 */   GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(494940), // Rule ID 4792 //
     /*  494866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  494877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  494880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  494883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  494886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  494921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494938 */     GIR_RootConstrainSelectedInstOperands,
     /*  494939 */     // GIR_Coverage, 4792,
     /*  494939 */     GIR_EraseRootFromParent_Done,
     /*  494940 */   // Label 8295: @494940
     /*  494940 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(495019), // Rule ID 4793 //
     /*  494945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  494956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  494959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  494962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  494965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494997 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  495000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495017 */     GIR_RootConstrainSelectedInstOperands,
     /*  495018 */     // GIR_Coverage, 4793,
     /*  495018 */     GIR_EraseRootFromParent_Done,
     /*  495019 */   // Label 8296: @495019
     /*  495019 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(495098), // Rule ID 4802 //
     /*  495024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  495035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  495038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  495041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  495044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495076 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  495079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495096 */     GIR_RootConstrainSelectedInstOperands,
     /*  495097 */     // GIR_Coverage, 4802,
     /*  495097 */     GIR_EraseRootFromParent_Done,
     /*  495098 */   // Label 8297: @495098
     /*  495098 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(495177), // Rule ID 4803 //
     /*  495103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  495114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  495117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  495120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  495123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495155 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  495158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495175 */     GIR_RootConstrainSelectedInstOperands,
     /*  495176 */     // GIR_Coverage, 4803,
     /*  495176 */     GIR_EraseRootFromParent_Done,
     /*  495177 */   // Label 8298: @495177
     /*  495177 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(495256), // Rule ID 4812 //
     /*  495182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  495193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  495196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  495199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  495202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  495237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495254 */     GIR_RootConstrainSelectedInstOperands,
     /*  495255 */     // GIR_Coverage, 4812,
     /*  495255 */     GIR_EraseRootFromParent_Done,
     /*  495256 */   // Label 8299: @495256
     /*  495256 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(495335), // Rule ID 4813 //
     /*  495261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  495272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  495275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  495278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  495281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495313 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  495316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495333 */     GIR_RootConstrainSelectedInstOperands,
     /*  495334 */     // GIR_Coverage, 4813,
     /*  495334 */     GIR_EraseRootFromParent_Done,
     /*  495335 */   // Label 8300: @495335
     /*  495335 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(495414), // Rule ID 4822 //
     /*  495340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  495351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  495354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  495357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  495360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495392 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  495395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495412 */     GIR_RootConstrainSelectedInstOperands,
     /*  495413 */     // GIR_Coverage, 4822,
     /*  495413 */     GIR_EraseRootFromParent_Done,
     /*  495414 */   // Label 8301: @495414
     /*  495414 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(495493), // Rule ID 4823 //
     /*  495419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  495430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  495433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  495436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  495439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495471 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  495474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495491 */     GIR_RootConstrainSelectedInstOperands,
     /*  495492 */     // GIR_Coverage, 4823,
     /*  495492 */     GIR_EraseRootFromParent_Done,
     /*  495493 */   // Label 8302: @495493
     /*  495493 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(495572), // Rule ID 4832 //
     /*  495498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  495509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  495512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  495515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  495518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495550 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  495553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495570 */     GIR_RootConstrainSelectedInstOperands,
     /*  495571 */     // GIR_Coverage, 4832,
     /*  495571 */     GIR_EraseRootFromParent_Done,
     /*  495572 */   // Label 8303: @495572
     /*  495572 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(495651), // Rule ID 4833 //
     /*  495577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  495588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  495591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  495594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  495597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495629 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11683:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  495632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495649 */     GIR_RootConstrainSelectedInstOperands,
     /*  495650 */     // GIR_Coverage, 4833,
     /*  495650 */     GIR_EraseRootFromParent_Done,
     /*  495651 */   // Label 8304: @495651
     /*  495651 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(495719), // Rule ID 2716 //
     /*  495656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  495667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  495670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  495673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  495676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495688 */     // MIs[0] policy
     /*  495688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495698 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  495698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  495701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495705 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495715 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495717 */     GIR_RootConstrainSelectedInstOperands,
     /*  495718 */     // GIR_Coverage, 2716,
     /*  495718 */     GIR_EraseRootFromParent_Done,
     /*  495719 */   // Label 8305: @495719
     /*  495719 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(495787), // Rule ID 2717 //
     /*  495724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  495735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  495738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  495741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  495744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495756 */     // MIs[0] policy
     /*  495756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495766 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  495766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  495769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495773 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495783 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495785 */     GIR_RootConstrainSelectedInstOperands,
     /*  495786 */     // GIR_Coverage, 2717,
     /*  495786 */     GIR_EraseRootFromParent_Done,
     /*  495787 */   // Label 8306: @495787
     /*  495787 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(495855), // Rule ID 23512 //
     /*  495792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  495803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  495806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  495809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  495812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495824 */     // MIs[0] policy
     /*  495824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495834 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  495834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  495837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495841 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495851 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495853 */     GIR_RootConstrainSelectedInstOperands,
     /*  495854 */     // GIR_Coverage, 23512,
     /*  495854 */     GIR_EraseRootFromParent_Done,
     /*  495855 */   // Label 8307: @495855
     /*  495855 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(495923), // Rule ID 23513 //
     /*  495860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  495871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  495874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  495877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  495880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495892 */     // MIs[0] policy
     /*  495892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495902 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  495902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  495905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495909 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495919 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495921 */     GIR_RootConstrainSelectedInstOperands,
     /*  495922 */     // GIR_Coverage, 23513,
     /*  495922 */     GIR_EraseRootFromParent_Done,
     /*  495923 */   // Label 8308: @495923
     /*  495923 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(495991), // Rule ID 23516 //
     /*  495928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  495939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  495942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  495945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  495948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495960 */     // MIs[0] policy
     /*  495960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495970 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11336:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  495970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  495973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495977 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495987 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495989 */     GIR_RootConstrainSelectedInstOperands,
     /*  495990 */     // GIR_Coverage, 23516,
     /*  495990 */     GIR_EraseRootFromParent_Done,
     /*  495991 */   // Label 8309: @495991
     /*  495991 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(496059), // Rule ID 23517 //
     /*  495996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  496007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  496010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  496013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496028 */     // MIs[0] policy
     /*  496028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496038 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11336:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496045 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496055 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496057 */     GIR_RootConstrainSelectedInstOperands,
     /*  496058 */     // GIR_Coverage, 23517,
     /*  496058 */     GIR_EraseRootFromParent_Done,
     /*  496059 */   // Label 8310: @496059
     /*  496059 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(496127), // Rule ID 23520 //
     /*  496064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  496075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  496078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496096 */     // MIs[0] policy
     /*  496096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496106 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  496109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496113 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496123 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496125 */     GIR_RootConstrainSelectedInstOperands,
     /*  496126 */     // GIR_Coverage, 23520,
     /*  496126 */     GIR_EraseRootFromParent_Done,
     /*  496127 */   // Label 8311: @496127
     /*  496127 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(496195), // Rule ID 23521 //
     /*  496132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  496143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  496146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496164 */     // MIs[0] policy
     /*  496164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496174 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  496177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496181 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496191 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496193 */     GIR_RootConstrainSelectedInstOperands,
     /*  496194 */     // GIR_Coverage, 23521,
     /*  496194 */     GIR_EraseRootFromParent_Done,
     /*  496195 */   // Label 8312: @496195
     /*  496195 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(496263), // Rule ID 23524 //
     /*  496200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  496211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  496214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496232 */     // MIs[0] policy
     /*  496232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496242 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496249 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496259 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496261 */     GIR_RootConstrainSelectedInstOperands,
     /*  496262 */     // GIR_Coverage, 23524,
     /*  496262 */     GIR_EraseRootFromParent_Done,
     /*  496263 */   // Label 8313: @496263
     /*  496263 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(496331), // Rule ID 23525 //
     /*  496268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  496279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  496282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496300 */     // MIs[0] policy
     /*  496300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496310 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496317 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496327 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496329 */     GIR_RootConstrainSelectedInstOperands,
     /*  496330 */     // GIR_Coverage, 23525,
     /*  496330 */     GIR_EraseRootFromParent_Done,
     /*  496331 */   // Label 8314: @496331
     /*  496331 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(496399), // Rule ID 23528 //
     /*  496336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  496347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  496350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496368 */     // MIs[0] policy
     /*  496368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496385 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496395 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496397 */     GIR_RootConstrainSelectedInstOperands,
     /*  496398 */     // GIR_Coverage, 23528,
     /*  496398 */     GIR_EraseRootFromParent_Done,
     /*  496399 */   // Label 8315: @496399
     /*  496399 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(496467), // Rule ID 23529 //
     /*  496404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  496415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  496418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496436 */     // MIs[0] policy
     /*  496436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496446 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496453 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496463 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496465 */     GIR_RootConstrainSelectedInstOperands,
     /*  496466 */     // GIR_Coverage, 23529,
     /*  496466 */     GIR_EraseRootFromParent_Done,
     /*  496467 */   // Label 8316: @496467
     /*  496467 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(496535), // Rule ID 23532 //
     /*  496472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  496483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  496486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  496489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496504 */     // MIs[0] policy
     /*  496504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496514 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11336:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496521 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496531 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496533 */     GIR_RootConstrainSelectedInstOperands,
     /*  496534 */     // GIR_Coverage, 23532,
     /*  496534 */     GIR_EraseRootFromParent_Done,
     /*  496535 */   // Label 8317: @496535
     /*  496535 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(496603), // Rule ID 23533 //
     /*  496540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  496551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  496554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  496557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496572 */     // MIs[0] policy
     /*  496572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11336:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496589 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496599 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496601 */     GIR_RootConstrainSelectedInstOperands,
     /*  496602 */     // GIR_Coverage, 23533,
     /*  496602 */     GIR_EraseRootFromParent_Done,
     /*  496603 */   // Label 8318: @496603
     /*  496603 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(496671), // Rule ID 23536 //
     /*  496608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  496619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  496622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  496625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496640 */     // MIs[0] policy
     /*  496640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496650 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496657 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496667 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496669 */     GIR_RootConstrainSelectedInstOperands,
     /*  496670 */     // GIR_Coverage, 23536,
     /*  496670 */     GIR_EraseRootFromParent_Done,
     /*  496671 */   // Label 8319: @496671
     /*  496671 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(496739), // Rule ID 23537 //
     /*  496676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  496687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  496690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  496693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496708 */     // MIs[0] policy
     /*  496708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496718 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496725 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496735 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496737 */     GIR_RootConstrainSelectedInstOperands,
     /*  496738 */     // GIR_Coverage, 23537,
     /*  496738 */     GIR_EraseRootFromParent_Done,
     /*  496739 */   // Label 8320: @496739
     /*  496739 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(496807), // Rule ID 23540 //
     /*  496744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  496755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  496758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496776 */     // MIs[0] policy
     /*  496776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496786 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496793 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496803 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496805 */     GIR_RootConstrainSelectedInstOperands,
     /*  496806 */     // GIR_Coverage, 23540,
     /*  496806 */     GIR_EraseRootFromParent_Done,
     /*  496807 */   // Label 8321: @496807
     /*  496807 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(496875), // Rule ID 23541 //
     /*  496812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  496823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  496826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496844 */     // MIs[0] policy
     /*  496844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496854 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496861 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496871 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496873 */     GIR_RootConstrainSelectedInstOperands,
     /*  496874 */     // GIR_Coverage, 23541,
     /*  496874 */     GIR_EraseRootFromParent_Done,
     /*  496875 */   // Label 8322: @496875
     /*  496875 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(496943), // Rule ID 23544 //
     /*  496880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  496883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  496891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  496894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496912 */     // MIs[0] policy
     /*  496912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496922 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496929 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  496939 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496941 */     GIR_RootConstrainSelectedInstOperands,
     /*  496942 */     // GIR_Coverage, 23544,
     /*  496942 */     GIR_EraseRootFromParent_Done,
     /*  496943 */   // Label 8323: @496943
     /*  496943 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(497011), // Rule ID 23545 //
     /*  496948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  496951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  496959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  496962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496980 */     // MIs[0] policy
     /*  496980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496990 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496997 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  497007 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497009 */     GIR_RootConstrainSelectedInstOperands,
     /*  497010 */     // GIR_Coverage, 23545,
     /*  497010 */     GIR_EraseRootFromParent_Done,
     /*  497011 */   // Label 8324: @497011
     /*  497011 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(497079), // Rule ID 23548 //
     /*  497016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  497027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  497030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497048 */     // MIs[0] policy
     /*  497048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497058 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497065 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497075 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497077 */     GIR_RootConstrainSelectedInstOperands,
     /*  497078 */     // GIR_Coverage, 23548,
     /*  497078 */     GIR_EraseRootFromParent_Done,
     /*  497079 */   // Label 8325: @497079
     /*  497079 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(497147), // Rule ID 23549 //
     /*  497084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  497095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  497098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497116 */     // MIs[0] policy
     /*  497116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497126 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497133 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497143 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497145 */     GIR_RootConstrainSelectedInstOperands,
     /*  497146 */     // GIR_Coverage, 23549,
     /*  497146 */     GIR_EraseRootFromParent_Done,
     /*  497147 */   // Label 8326: @497147
     /*  497147 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(497215), // Rule ID 23552 //
     /*  497152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  497163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  497166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497184 */     // MIs[0] policy
     /*  497184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497194 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497201 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497211 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497213 */     GIR_RootConstrainSelectedInstOperands,
     /*  497214 */     // GIR_Coverage, 23552,
     /*  497214 */     GIR_EraseRootFromParent_Done,
     /*  497215 */   // Label 8327: @497215
     /*  497215 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(497283), // Rule ID 23553 //
     /*  497220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  497231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  497234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497252 */     // MIs[0] policy
     /*  497252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497262 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497269 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497279 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497281 */     GIR_RootConstrainSelectedInstOperands,
     /*  497282 */     // GIR_Coverage, 23553,
     /*  497282 */     GIR_EraseRootFromParent_Done,
     /*  497283 */   // Label 8328: @497283
     /*  497283 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(497351), // Rule ID 23556 //
     /*  497288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  497299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  497302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  497305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497320 */     // MIs[0] policy
     /*  497320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497330 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497337 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497347 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497349 */     GIR_RootConstrainSelectedInstOperands,
     /*  497350 */     // GIR_Coverage, 23556,
     /*  497350 */     GIR_EraseRootFromParent_Done,
     /*  497351 */   // Label 8329: @497351
     /*  497351 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(497419), // Rule ID 23557 //
     /*  497356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  497367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  497370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  497373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497388 */     // MIs[0] policy
     /*  497388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497398 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497405 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497415 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497417 */     GIR_RootConstrainSelectedInstOperands,
     /*  497418 */     // GIR_Coverage, 23557,
     /*  497418 */     GIR_EraseRootFromParent_Done,
     /*  497419 */   // Label 8330: @497419
     /*  497419 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(497487), // Rule ID 23560 //
     /*  497424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497456 */     // MIs[0] policy
     /*  497456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497473 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497483 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497485 */     GIR_RootConstrainSelectedInstOperands,
     /*  497486 */     // GIR_Coverage, 23560,
     /*  497486 */     GIR_EraseRootFromParent_Done,
     /*  497487 */   // Label 8331: @497487
     /*  497487 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(497555), // Rule ID 23561 //
     /*  497492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497524 */     // MIs[0] policy
     /*  497524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497534 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497541 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497551 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497553 */     GIR_RootConstrainSelectedInstOperands,
     /*  497554 */     // GIR_Coverage, 23561,
     /*  497554 */     GIR_EraseRootFromParent_Done,
     /*  497555 */   // Label 8332: @497555
     /*  497555 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(497623), // Rule ID 23564 //
     /*  497560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  497571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  497574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497592 */     // MIs[0] policy
     /*  497592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497602 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497609 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497619 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497621 */     GIR_RootConstrainSelectedInstOperands,
     /*  497622 */     // GIR_Coverage, 23564,
     /*  497622 */     GIR_EraseRootFromParent_Done,
     /*  497623 */   // Label 8333: @497623
     /*  497623 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(497691), // Rule ID 23565 //
     /*  497628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  497639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  497642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497660 */     // MIs[0] policy
     /*  497660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497670 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497677 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497687 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497689 */     GIR_RootConstrainSelectedInstOperands,
     /*  497690 */     // GIR_Coverage, 23565,
     /*  497690 */     GIR_EraseRootFromParent_Done,
     /*  497691 */   // Label 8334: @497691
     /*  497691 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(497759), // Rule ID 23568 //
     /*  497696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  497707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  497710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497728 */     // MIs[0] policy
     /*  497728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497738 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497745 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497755 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497757 */     GIR_RootConstrainSelectedInstOperands,
     /*  497758 */     // GIR_Coverage, 23568,
     /*  497758 */     GIR_EraseRootFromParent_Done,
     /*  497759 */   // Label 8335: @497759
     /*  497759 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(497827), // Rule ID 23569 //
     /*  497764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  497775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  497778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497796 */     // MIs[0] policy
     /*  497796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497806 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497813 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497823 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497825 */     GIR_RootConstrainSelectedInstOperands,
     /*  497826 */     // GIR_Coverage, 23569,
     /*  497826 */     GIR_EraseRootFromParent_Done,
     /*  497827 */   // Label 8336: @497827
     /*  497827 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(497895), // Rule ID 23572 //
     /*  497832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  497843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  497846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  497849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497864 */     // MIs[0] policy
     /*  497864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497881 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497891 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497893 */     GIR_RootConstrainSelectedInstOperands,
     /*  497894 */     // GIR_Coverage, 23572,
     /*  497894 */     GIR_EraseRootFromParent_Done,
     /*  497895 */   // Label 8337: @497895
     /*  497895 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(497963), // Rule ID 23573 //
     /*  497900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  497911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  497914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  497917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497932 */     // MIs[0] policy
     /*  497932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497942 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497949 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497959 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497961 */     GIR_RootConstrainSelectedInstOperands,
     /*  497962 */     // GIR_Coverage, 23573,
     /*  497962 */     GIR_EraseRootFromParent_Done,
     /*  497963 */   // Label 8338: @497963
     /*  497963 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(498031), // Rule ID 23576 //
     /*  497968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  497979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  497982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498000 */     // MIs[0] policy
     /*  498000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498010 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498017 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498027 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498029 */     GIR_RootConstrainSelectedInstOperands,
     /*  498030 */     // GIR_Coverage, 23576,
     /*  498030 */     GIR_EraseRootFromParent_Done,
     /*  498031 */   // Label 8339: @498031
     /*  498031 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(498099), // Rule ID 23577 //
     /*  498036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498068 */     // MIs[0] policy
     /*  498068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498078 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498085 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498095 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498097 */     GIR_RootConstrainSelectedInstOperands,
     /*  498098 */     // GIR_Coverage, 23577,
     /*  498098 */     GIR_EraseRootFromParent_Done,
     /*  498099 */   // Label 8340: @498099
     /*  498099 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(498167), // Rule ID 23580 //
     /*  498104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  498121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498136 */     // MIs[0] policy
     /*  498136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498146 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498153 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498163 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498165 */     GIR_RootConstrainSelectedInstOperands,
     /*  498166 */     // GIR_Coverage, 23580,
     /*  498166 */     GIR_EraseRootFromParent_Done,
     /*  498167 */   // Label 8341: @498167
     /*  498167 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(498235), // Rule ID 23581 //
     /*  498172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  498189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498204 */     // MIs[0] policy
     /*  498204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498214 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498221 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498231 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498233 */     GIR_RootConstrainSelectedInstOperands,
     /*  498234 */     // GIR_Coverage, 23581,
     /*  498234 */     GIR_EraseRootFromParent_Done,
     /*  498235 */   // Label 8342: @498235
     /*  498235 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(498303), // Rule ID 23584 //
     /*  498240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  498243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  498251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  498254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  498257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  498264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498272 */     // MIs[0] policy
     /*  498272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498282 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  498285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498289 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498299 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498301 */     GIR_RootConstrainSelectedInstOperands,
     /*  498302 */     // GIR_Coverage, 23584,
     /*  498302 */     GIR_EraseRootFromParent_Done,
     /*  498303 */   // Label 8343: @498303
     /*  498303 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(498371), // Rule ID 23585 //
     /*  498308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  498311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  498319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  498322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  498325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  498332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498340 */     // MIs[0] policy
     /*  498340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498350 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  498353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498357 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498367 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498369 */     GIR_RootConstrainSelectedInstOperands,
     /*  498370 */     // GIR_Coverage, 23585,
     /*  498370 */     GIR_EraseRootFromParent_Done,
     /*  498371 */   // Label 8344: @498371
     /*  498371 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(498439), // Rule ID 23588 //
     /*  498376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  498379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  498387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  498390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  498393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498408 */     // MIs[0] policy
     /*  498408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498425 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498435 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498437 */     GIR_RootConstrainSelectedInstOperands,
     /*  498438 */     // GIR_Coverage, 23588,
     /*  498438 */     GIR_EraseRootFromParent_Done,
     /*  498439 */   // Label 8345: @498439
     /*  498439 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(498507), // Rule ID 23589 //
     /*  498444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  498447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  498455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  498458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  498461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498476 */     // MIs[0] policy
     /*  498476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498486 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498493 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498503 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498505 */     GIR_RootConstrainSelectedInstOperands,
     /*  498506 */     // GIR_Coverage, 23589,
     /*  498506 */     GIR_EraseRootFromParent_Done,
     /*  498507 */   // Label 8346: @498507
     /*  498507 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(498575), // Rule ID 23592 //
     /*  498512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  498515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  498523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  498526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498544 */     // MIs[0] policy
     /*  498544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498554 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498561 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498571 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498573 */     GIR_RootConstrainSelectedInstOperands,
     /*  498574 */     // GIR_Coverage, 23592,
     /*  498574 */     GIR_EraseRootFromParent_Done,
     /*  498575 */   // Label 8347: @498575
     /*  498575 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(498643), // Rule ID 23593 //
     /*  498580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  498583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  498591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  498594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498612 */     // MIs[0] policy
     /*  498612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498622 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498629 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498639 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498641 */     GIR_RootConstrainSelectedInstOperands,
     /*  498642 */     // GIR_Coverage, 23593,
     /*  498642 */     GIR_EraseRootFromParent_Done,
     /*  498643 */   // Label 8348: @498643
     /*  498643 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(498711), // Rule ID 60606 //
     /*  498648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  498651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498680 */     // MIs[0] policy
     /*  498680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498690 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  498693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498707 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498709 */     GIR_RootConstrainSelectedInstOperands,
     /*  498710 */     // GIR_Coverage, 60606,
     /*  498710 */     GIR_EraseRootFromParent_Done,
     /*  498711 */   // Label 8349: @498711
     /*  498711 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(498779), // Rule ID 60607 //
     /*  498716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  498719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498748 */     // MIs[0] policy
     /*  498748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498758 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  498761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498775 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498777 */     GIR_RootConstrainSelectedInstOperands,
     /*  498778 */     // GIR_Coverage, 60607,
     /*  498778 */     GIR_EraseRootFromParent_Done,
     /*  498779 */   // Label 8350: @498779
     /*  498779 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(498847), // Rule ID 60608 //
     /*  498784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  498787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  498792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498816 */     // MIs[0] policy
     /*  498816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498826 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  498829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498843 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498845 */     GIR_RootConstrainSelectedInstOperands,
     /*  498846 */     // GIR_Coverage, 60608,
     /*  498846 */     GIR_EraseRootFromParent_Done,
     /*  498847 */   // Label 8351: @498847
     /*  498847 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(498915), // Rule ID 60609 //
     /*  498852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  498855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  498860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498884 */     // MIs[0] policy
     /*  498884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498894 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  498897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498911 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498913 */     GIR_RootConstrainSelectedInstOperands,
     /*  498914 */     // GIR_Coverage, 60609,
     /*  498914 */     GIR_EraseRootFromParent_Done,
     /*  498915 */   // Label 8352: @498915
     /*  498915 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(498983), // Rule ID 62102 //
     /*  498920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  498923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  498931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  498934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  498937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498952 */     // MIs[0] policy
     /*  498952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498962 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  498965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498979 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498981 */     GIR_RootConstrainSelectedInstOperands,
     /*  498982 */     // GIR_Coverage, 62102,
     /*  498982 */     GIR_EraseRootFromParent_Done,
     /*  498983 */   // Label 8353: @498983
     /*  498983 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(499051), // Rule ID 62103 //
     /*  498988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  498991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  498999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  499005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499020 */     // MIs[0] policy
     /*  499020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  499033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499047 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499049 */     GIR_RootConstrainSelectedInstOperands,
     /*  499050 */     // GIR_Coverage, 62103,
     /*  499050 */     GIR_EraseRootFromParent_Done,
     /*  499051 */   // Label 8354: @499051
     /*  499051 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(499119), // Rule ID 62104 //
     /*  499056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499088 */     // MIs[0] policy
     /*  499088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499098 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  499101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499115 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499117 */     GIR_RootConstrainSelectedInstOperands,
     /*  499118 */     // GIR_Coverage, 62104,
     /*  499118 */     GIR_EraseRootFromParent_Done,
     /*  499119 */   // Label 8355: @499119
     /*  499119 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(499187), // Rule ID 62105 //
     /*  499124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499156 */     // MIs[0] policy
     /*  499156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  499169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499183 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499185 */     GIR_RootConstrainSelectedInstOperands,
     /*  499186 */     // GIR_Coverage, 62105,
     /*  499186 */     GIR_EraseRootFromParent_Done,
     /*  499187 */   // Label 8356: @499187
     /*  499187 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(499255), // Rule ID 62106 //
     /*  499192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499224 */     // MIs[0] policy
     /*  499224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499234 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  499237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499251 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499253 */     GIR_RootConstrainSelectedInstOperands,
     /*  499254 */     // GIR_Coverage, 62106,
     /*  499254 */     GIR_EraseRootFromParent_Done,
     /*  499255 */   // Label 8357: @499255
     /*  499255 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(499323), // Rule ID 62107 //
     /*  499260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499292 */     // MIs[0] policy
     /*  499292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  499305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499319 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499321 */     GIR_RootConstrainSelectedInstOperands,
     /*  499322 */     // GIR_Coverage, 62107,
     /*  499322 */     GIR_EraseRootFromParent_Done,
     /*  499323 */   // Label 8358: @499323
     /*  499323 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(499391), // Rule ID 62108 //
     /*  499328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  499339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  499342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  499345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499360 */     // MIs[0] policy
     /*  499360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499370 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  499373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499387 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499389 */     GIR_RootConstrainSelectedInstOperands,
     /*  499390 */     // GIR_Coverage, 62108,
     /*  499390 */     GIR_EraseRootFromParent_Done,
     /*  499391 */   // Label 8359: @499391
     /*  499391 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(499459), // Rule ID 62109 //
     /*  499396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  499407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  499410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  499413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499428 */     // MIs[0] policy
     /*  499428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499438 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  499441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499455 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499457 */     GIR_RootConstrainSelectedInstOperands,
     /*  499458 */     // GIR_Coverage, 62109,
     /*  499458 */     GIR_EraseRootFromParent_Done,
     /*  499459 */   // Label 8360: @499459
     /*  499459 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(499527), // Rule ID 62110 //
     /*  499464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499496 */     // MIs[0] policy
     /*  499496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499506 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  499509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499523 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499525 */     GIR_RootConstrainSelectedInstOperands,
     /*  499526 */     // GIR_Coverage, 62110,
     /*  499526 */     GIR_EraseRootFromParent_Done,
     /*  499527 */   // Label 8361: @499527
     /*  499527 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(499595), // Rule ID 62111 //
     /*  499532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499564 */     // MIs[0] policy
     /*  499564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499574 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  499577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499591 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499593 */     GIR_RootConstrainSelectedInstOperands,
     /*  499594 */     // GIR_Coverage, 62111,
     /*  499594 */     GIR_EraseRootFromParent_Done,
     /*  499595 */   // Label 8362: @499595
     /*  499595 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(499663), // Rule ID 62112 //
     /*  499600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  499617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499632 */     // MIs[0] policy
     /*  499632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499642 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  499645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499659 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499661 */     GIR_RootConstrainSelectedInstOperands,
     /*  499662 */     // GIR_Coverage, 62112,
     /*  499662 */     GIR_EraseRootFromParent_Done,
     /*  499663 */   // Label 8363: @499663
     /*  499663 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(499731), // Rule ID 62113 //
     /*  499668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  499685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499700 */     // MIs[0] policy
     /*  499700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499710 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  499713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499727 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499729 */     GIR_RootConstrainSelectedInstOperands,
     /*  499730 */     // GIR_Coverage, 62113,
     /*  499730 */     GIR_EraseRootFromParent_Done,
     /*  499731 */   // Label 8364: @499731
     /*  499731 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(499799), // Rule ID 62114 //
     /*  499736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499768 */     // MIs[0] policy
     /*  499768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  499781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499795 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499797 */     GIR_RootConstrainSelectedInstOperands,
     /*  499798 */     // GIR_Coverage, 62114,
     /*  499798 */     GIR_EraseRootFromParent_Done,
     /*  499799 */   // Label 8365: @499799
     /*  499799 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(499867), // Rule ID 62115 //
     /*  499804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499836 */     // MIs[0] policy
     /*  499836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499846 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  499849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499863 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499865 */     GIR_RootConstrainSelectedInstOperands,
     /*  499866 */     // GIR_Coverage, 62115,
     /*  499866 */     GIR_EraseRootFromParent_Done,
     /*  499867 */   // Label 8366: @499867
     /*  499867 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(499935), // Rule ID 62116 //
     /*  499872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499904 */     // MIs[0] policy
     /*  499904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  499917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499931 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499933 */     GIR_RootConstrainSelectedInstOperands,
     /*  499934 */     // GIR_Coverage, 62116,
     /*  499934 */     GIR_EraseRootFromParent_Done,
     /*  499935 */   // Label 8367: @499935
     /*  499935 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(500003), // Rule ID 62117 //
     /*  499940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499972 */     // MIs[0] policy
     /*  499972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499982 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  499985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499999 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500001 */     GIR_RootConstrainSelectedInstOperands,
     /*  500002 */     // GIR_Coverage, 62117,
     /*  500002 */     GIR_EraseRootFromParent_Done,
     /*  500003 */   // Label 8368: @500003
     /*  500003 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(500071), // Rule ID 62118 //
     /*  500008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  500019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  500022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  500025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500040 */     // MIs[0] policy
     /*  500040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500050 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  500053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500067 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500069 */     GIR_RootConstrainSelectedInstOperands,
     /*  500070 */     // GIR_Coverage, 62118,
     /*  500070 */     GIR_EraseRootFromParent_Done,
     /*  500071 */   // Label 8369: @500071
     /*  500071 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(500139), // Rule ID 62119 //
     /*  500076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  500087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  500090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  500093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500108 */     // MIs[0] policy
     /*  500108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  500121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500135 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500137 */     GIR_RootConstrainSelectedInstOperands,
     /*  500138 */     // GIR_Coverage, 62119,
     /*  500138 */     GIR_EraseRootFromParent_Done,
     /*  500139 */   // Label 8370: @500139
     /*  500139 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(500207), // Rule ID 62120 //
     /*  500144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500176 */     // MIs[0] policy
     /*  500176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500186 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  500189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500203 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500205 */     GIR_RootConstrainSelectedInstOperands,
     /*  500206 */     // GIR_Coverage, 62120,
     /*  500206 */     GIR_EraseRootFromParent_Done,
     /*  500207 */   // Label 8371: @500207
     /*  500207 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(500275), // Rule ID 62121 //
     /*  500212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500244 */     // MIs[0] policy
     /*  500244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500254 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  500257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500271 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500273 */     GIR_RootConstrainSelectedInstOperands,
     /*  500274 */     // GIR_Coverage, 62121,
     /*  500274 */     GIR_EraseRootFromParent_Done,
     /*  500275 */   // Label 8372: @500275
     /*  500275 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(500343), // Rule ID 62122 //
     /*  500280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500312 */     // MIs[0] policy
     /*  500312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  500325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500339 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500341 */     GIR_RootConstrainSelectedInstOperands,
     /*  500342 */     // GIR_Coverage, 62122,
     /*  500342 */     GIR_EraseRootFromParent_Done,
     /*  500343 */   // Label 8373: @500343
     /*  500343 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(500411), // Rule ID 62123 //
     /*  500348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500380 */     // MIs[0] policy
     /*  500380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  500393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500407 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500409 */     GIR_RootConstrainSelectedInstOperands,
     /*  500410 */     // GIR_Coverage, 62123,
     /*  500410 */     GIR_EraseRootFromParent_Done,
     /*  500411 */   // Label 8374: @500411
     /*  500411 */   GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(500479), // Rule ID 62124 //
     /*  500416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500448 */     // MIs[0] policy
     /*  500448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  500461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500475 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500477 */     GIR_RootConstrainSelectedInstOperands,
     /*  500478 */     // GIR_Coverage, 62124,
     /*  500478 */     GIR_EraseRootFromParent_Done,
     /*  500479 */   // Label 8375: @500479
     /*  500479 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(500547), // Rule ID 62125 //
     /*  500484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500516 */     // MIs[0] policy
     /*  500516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  500529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500543 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500545 */     GIR_RootConstrainSelectedInstOperands,
     /*  500546 */     // GIR_Coverage, 62125,
     /*  500546 */     GIR_EraseRootFromParent_Done,
     /*  500547 */   // Label 8376: @500547
     /*  500547 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(500615), // Rule ID 62126 //
     /*  500552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500584 */     // MIs[0] policy
     /*  500584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  500597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500611 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500613 */     GIR_RootConstrainSelectedInstOperands,
     /*  500614 */     // GIR_Coverage, 62126,
     /*  500614 */     GIR_EraseRootFromParent_Done,
     /*  500615 */   // Label 8377: @500615
     /*  500615 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(500683), // Rule ID 62127 //
     /*  500620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500652 */     // MIs[0] policy
     /*  500652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  500665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500679 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500681 */     GIR_RootConstrainSelectedInstOperands,
     /*  500682 */     // GIR_Coverage, 62127,
     /*  500682 */     GIR_EraseRootFromParent_Done,
     /*  500683 */   // Label 8378: @500683
     /*  500683 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(500751), // Rule ID 62128 //
     /*  500688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500720 */     // MIs[0] policy
     /*  500720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  500733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500747 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500749 */     GIR_RootConstrainSelectedInstOperands,
     /*  500750 */     // GIR_Coverage, 62128,
     /*  500750 */     GIR_EraseRootFromParent_Done,
     /*  500751 */   // Label 8379: @500751
     /*  500751 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(500819), // Rule ID 62129 //
     /*  500756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500788 */     // MIs[0] policy
     /*  500788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  500801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500815 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500817 */     GIR_RootConstrainSelectedInstOperands,
     /*  500818 */     // GIR_Coverage, 62129,
     /*  500818 */     GIR_EraseRootFromParent_Done,
     /*  500819 */   // Label 8380: @500819
     /*  500819 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(500887), // Rule ID 62130 //
     /*  500824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500856 */     // MIs[0] policy
     /*  500856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  500869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500883 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500885 */     GIR_RootConstrainSelectedInstOperands,
     /*  500886 */     // GIR_Coverage, 62130,
     /*  500886 */     GIR_EraseRootFromParent_Done,
     /*  500887 */   // Label 8381: @500887
     /*  500887 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(500955), // Rule ID 62131 //
     /*  500892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500924 */     // MIs[0] policy
     /*  500924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500934 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  500937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500951 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500953 */     GIR_RootConstrainSelectedInstOperands,
     /*  500954 */     // GIR_Coverage, 62131,
     /*  500954 */     GIR_EraseRootFromParent_Done,
     /*  500955 */   // Label 8382: @500955
     /*  500955 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(501023), // Rule ID 62132 //
     /*  500960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500992 */     // MIs[0] policy
     /*  500992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  501005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501019 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501021 */     GIR_RootConstrainSelectedInstOperands,
     /*  501022 */     // GIR_Coverage, 62132,
     /*  501022 */     GIR_EraseRootFromParent_Done,
     /*  501023 */   // Label 8383: @501023
     /*  501023 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(501091), // Rule ID 62133 //
     /*  501028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501060 */     // MIs[0] policy
     /*  501060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501070 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  501073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501087 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501089 */     GIR_RootConstrainSelectedInstOperands,
     /*  501090 */     // GIR_Coverage, 62133,
     /*  501090 */     GIR_EraseRootFromParent_Done,
     /*  501091 */   // Label 8384: @501091
     /*  501091 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(501159), // Rule ID 62134 //
     /*  501096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501128 */     // MIs[0] policy
     /*  501128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501138 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  501141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501155 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501157 */     GIR_RootConstrainSelectedInstOperands,
     /*  501158 */     // GIR_Coverage, 62134,
     /*  501158 */     GIR_EraseRootFromParent_Done,
     /*  501159 */   // Label 8385: @501159
     /*  501159 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(501227), // Rule ID 62135 //
     /*  501164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501196 */     // MIs[0] policy
     /*  501196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  501209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501223 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501225 */     GIR_RootConstrainSelectedInstOperands,
     /*  501226 */     // GIR_Coverage, 62135,
     /*  501226 */     GIR_EraseRootFromParent_Done,
     /*  501227 */   // Label 8386: @501227
     /*  501227 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(501295), // Rule ID 62136 //
     /*  501232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501264 */     // MIs[0] policy
     /*  501264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501274 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  501277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501291 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501293 */     GIR_RootConstrainSelectedInstOperands,
     /*  501294 */     // GIR_Coverage, 62136,
     /*  501294 */     GIR_EraseRootFromParent_Done,
     /*  501295 */   // Label 8387: @501295
     /*  501295 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(501363), // Rule ID 62137 //
     /*  501300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501332 */     // MIs[0] policy
     /*  501332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501342 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  501345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501359 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501361 */     GIR_RootConstrainSelectedInstOperands,
     /*  501362 */     // GIR_Coverage, 62137,
     /*  501362 */     GIR_EraseRootFromParent_Done,
     /*  501363 */   // Label 8388: @501363
     /*  501363 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(501431), // Rule ID 62138 //
     /*  501368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501400 */     // MIs[0] policy
     /*  501400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501410 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  501413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501427 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501429 */     GIR_RootConstrainSelectedInstOperands,
     /*  501430 */     // GIR_Coverage, 62138,
     /*  501430 */     GIR_EraseRootFromParent_Done,
     /*  501431 */   // Label 8389: @501431
     /*  501431 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(501499), // Rule ID 62139 //
     /*  501436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501468 */     // MIs[0] policy
     /*  501468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  501481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501495 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501497 */     GIR_RootConstrainSelectedInstOperands,
     /*  501498 */     // GIR_Coverage, 62139,
     /*  501498 */     GIR_EraseRootFromParent_Done,
     /*  501499 */   // Label 8390: @501499
     /*  501499 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(501567), // Rule ID 62140 //
     /*  501504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501536 */     // MIs[0] policy
     /*  501536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  501549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501563 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501565 */     GIR_RootConstrainSelectedInstOperands,
     /*  501566 */     // GIR_Coverage, 62140,
     /*  501566 */     GIR_EraseRootFromParent_Done,
     /*  501567 */   // Label 8391: @501567
     /*  501567 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(501635), // Rule ID 62141 //
     /*  501572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501604 */     // MIs[0] policy
     /*  501604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  501617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501631 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501633 */     GIR_RootConstrainSelectedInstOperands,
     /*  501634 */     // GIR_Coverage, 62141,
     /*  501634 */     GIR_EraseRootFromParent_Done,
     /*  501635 */   // Label 8392: @501635
     /*  501635 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(501703), // Rule ID 62142 //
     /*  501640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501672 */     // MIs[0] policy
     /*  501672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501682 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  501685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501699 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501701 */     GIR_RootConstrainSelectedInstOperands,
     /*  501702 */     // GIR_Coverage, 62142,
     /*  501702 */     GIR_EraseRootFromParent_Done,
     /*  501703 */   // Label 8393: @501703
     /*  501703 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(501771), // Rule ID 62143 //
     /*  501708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501740 */     // MIs[0] policy
     /*  501740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  501753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501767 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501769 */     GIR_RootConstrainSelectedInstOperands,
     /*  501770 */     // GIR_Coverage, 62143,
     /*  501770 */     GIR_EraseRootFromParent_Done,
     /*  501771 */   // Label 8394: @501771
     /*  501771 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(501839), // Rule ID 62144 //
     /*  501776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501808 */     // MIs[0] policy
     /*  501808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501818 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  501821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501835 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501837 */     GIR_RootConstrainSelectedInstOperands,
     /*  501838 */     // GIR_Coverage, 62144,
     /*  501838 */     GIR_EraseRootFromParent_Done,
     /*  501839 */   // Label 8395: @501839
     /*  501839 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(501907), // Rule ID 62145 //
     /*  501844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501876 */     // MIs[0] policy
     /*  501876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501886 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  501889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501903 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501905 */     GIR_RootConstrainSelectedInstOperands,
     /*  501906 */     // GIR_Coverage, 62145,
     /*  501906 */     GIR_EraseRootFromParent_Done,
     /*  501907 */   // Label 8396: @501907
     /*  501907 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(501975), // Rule ID 62146 //
     /*  501912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  501920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  501923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  501926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501944 */     // MIs[0] policy
     /*  501944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501954 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  501957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501971 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501973 */     GIR_RootConstrainSelectedInstOperands,
     /*  501974 */     // GIR_Coverage, 62146,
     /*  501974 */     GIR_EraseRootFromParent_Done,
     /*  501975 */   // Label 8397: @501975
     /*  501975 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(502043), // Rule ID 62147 //
     /*  501980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  501988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  501991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  501994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502012 */     // MIs[0] policy
     /*  502012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502022 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  502025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502039 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502041 */     GIR_RootConstrainSelectedInstOperands,
     /*  502042 */     // GIR_Coverage, 62147,
     /*  502042 */     GIR_EraseRootFromParent_Done,
     /*  502043 */   // Label 8398: @502043
     /*  502043 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(502111), // Rule ID 62148 //
     /*  502048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502080 */     // MIs[0] policy
     /*  502080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502090 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  502093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502107 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502109 */     GIR_RootConstrainSelectedInstOperands,
     /*  502110 */     // GIR_Coverage, 62148,
     /*  502110 */     GIR_EraseRootFromParent_Done,
     /*  502111 */   // Label 8399: @502111
     /*  502111 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(502179), // Rule ID 62149 //
     /*  502116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502148 */     // MIs[0] policy
     /*  502148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  502161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502175 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502177 */     GIR_RootConstrainSelectedInstOperands,
     /*  502178 */     // GIR_Coverage, 62149,
     /*  502178 */     GIR_EraseRootFromParent_Done,
     /*  502179 */   // Label 8400: @502179
     /*  502179 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(502247), // Rule ID 62150 //
     /*  502184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502216 */     // MIs[0] policy
     /*  502216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  502229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502243 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502245 */     GIR_RootConstrainSelectedInstOperands,
     /*  502246 */     // GIR_Coverage, 62150,
     /*  502246 */     GIR_EraseRootFromParent_Done,
     /*  502247 */   // Label 8401: @502247
     /*  502247 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(502315), // Rule ID 62151 //
     /*  502252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502284 */     // MIs[0] policy
     /*  502284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502294 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  502297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502311 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502313 */     GIR_RootConstrainSelectedInstOperands,
     /*  502314 */     // GIR_Coverage, 62151,
     /*  502314 */     GIR_EraseRootFromParent_Done,
     /*  502315 */   // Label 8402: @502315
     /*  502315 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(502383), // Rule ID 62152 //
     /*  502320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  502331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  502334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502352 */     // MIs[0] policy
     /*  502352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502362 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  502365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502379 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502381 */     GIR_RootConstrainSelectedInstOperands,
     /*  502382 */     // GIR_Coverage, 62152,
     /*  502382 */     GIR_EraseRootFromParent_Done,
     /*  502383 */   // Label 8403: @502383
     /*  502383 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(502451), // Rule ID 62153 //
     /*  502388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  502399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  502402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502420 */     // MIs[0] policy
     /*  502420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  502433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502447 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502449 */     GIR_RootConstrainSelectedInstOperands,
     /*  502450 */     // GIR_Coverage, 62153,
     /*  502450 */     GIR_EraseRootFromParent_Done,
     /*  502451 */   // Label 8404: @502451
     /*  502451 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(502519), // Rule ID 62154 //
     /*  502456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  502473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502488 */     // MIs[0] policy
     /*  502488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502498 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  502501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502515 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502517 */     GIR_RootConstrainSelectedInstOperands,
     /*  502518 */     // GIR_Coverage, 62154,
     /*  502518 */     GIR_EraseRootFromParent_Done,
     /*  502519 */   // Label 8405: @502519
     /*  502519 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(502587), // Rule ID 62155 //
     /*  502524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  502541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502556 */     // MIs[0] policy
     /*  502556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502566 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  502569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502583 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502585 */     GIR_RootConstrainSelectedInstOperands,
     /*  502586 */     // GIR_Coverage, 62155,
     /*  502586 */     GIR_EraseRootFromParent_Done,
     /*  502587 */   // Label 8406: @502587
     /*  502587 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(502655), // Rule ID 62156 //
     /*  502592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502624 */     // MIs[0] policy
     /*  502624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502634 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  502637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502651 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502653 */     GIR_RootConstrainSelectedInstOperands,
     /*  502654 */     // GIR_Coverage, 62156,
     /*  502654 */     GIR_EraseRootFromParent_Done,
     /*  502655 */   // Label 8407: @502655
     /*  502655 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(502723), // Rule ID 62157 //
     /*  502660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502692 */     // MIs[0] policy
     /*  502692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  502705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502719 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502721 */     GIR_RootConstrainSelectedInstOperands,
     /*  502722 */     // GIR_Coverage, 62157,
     /*  502722 */     GIR_EraseRootFromParent_Done,
     /*  502723 */   // Label 8408: @502723
     /*  502723 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(502791), // Rule ID 62158 //
     /*  502728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502760 */     // MIs[0] policy
     /*  502760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  502773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502787 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502789 */     GIR_RootConstrainSelectedInstOperands,
     /*  502790 */     // GIR_Coverage, 62158,
     /*  502790 */     GIR_EraseRootFromParent_Done,
     /*  502791 */   // Label 8409: @502791
     /*  502791 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(502859), // Rule ID 62159 //
     /*  502796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502828 */     // MIs[0] policy
     /*  502828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  502841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502855 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502857 */     GIR_RootConstrainSelectedInstOperands,
     /*  502858 */     // GIR_Coverage, 62159,
     /*  502858 */     GIR_EraseRootFromParent_Done,
     /*  502859 */   // Label 8410: @502859
     /*  502859 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(502927), // Rule ID 62160 //
     /*  502864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502896 */     // MIs[0] policy
     /*  502896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  502909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502923 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502925 */     GIR_RootConstrainSelectedInstOperands,
     /*  502926 */     // GIR_Coverage, 62160,
     /*  502926 */     GIR_EraseRootFromParent_Done,
     /*  502927 */   // Label 8411: @502927
     /*  502927 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(502995), // Rule ID 62161 //
     /*  502932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502964 */     // MIs[0] policy
     /*  502964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  502977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502991 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502993 */     GIR_RootConstrainSelectedInstOperands,
     /*  502994 */     // GIR_Coverage, 62161,
     /*  502994 */     GIR_EraseRootFromParent_Done,
     /*  502995 */   // Label 8412: @502995
     /*  502995 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(503063), // Rule ID 62162 //
     /*  503000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503032 */     // MIs[0] policy
     /*  503032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  503045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503059 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503061 */     GIR_RootConstrainSelectedInstOperands,
     /*  503062 */     // GIR_Coverage, 62162,
     /*  503062 */     GIR_EraseRootFromParent_Done,
     /*  503063 */   // Label 8413: @503063
     /*  503063 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(503131), // Rule ID 62163 //
     /*  503068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503100 */     // MIs[0] policy
     /*  503100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  503113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503127 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503129 */     GIR_RootConstrainSelectedInstOperands,
     /*  503130 */     // GIR_Coverage, 62163,
     /*  503130 */     GIR_EraseRootFromParent_Done,
     /*  503131 */   // Label 8414: @503131
     /*  503131 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(503199), // Rule ID 62164 //
     /*  503136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503168 */     // MIs[0] policy
     /*  503168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503178 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  503181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503195 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503197 */     GIR_RootConstrainSelectedInstOperands,
     /*  503198 */     // GIR_Coverage, 62164,
     /*  503198 */     GIR_EraseRootFromParent_Done,
     /*  503199 */   // Label 8415: @503199
     /*  503199 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(503267), // Rule ID 62165 //
     /*  503204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503236 */     // MIs[0] policy
     /*  503236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  503249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503263 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503265 */     GIR_RootConstrainSelectedInstOperands,
     /*  503266 */     // GIR_Coverage, 62165,
     /*  503266 */     GIR_EraseRootFromParent_Done,
     /*  503267 */   // Label 8416: @503267
     /*  503267 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(503335), // Rule ID 62166 //
     /*  503272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503304 */     // MIs[0] policy
     /*  503304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503314 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  503317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503331 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503333 */     GIR_RootConstrainSelectedInstOperands,
     /*  503334 */     // GIR_Coverage, 62166,
     /*  503334 */     GIR_EraseRootFromParent_Done,
     /*  503335 */   // Label 8417: @503335
     /*  503335 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(503403), // Rule ID 62167 //
     /*  503340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503372 */     // MIs[0] policy
     /*  503372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  503385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503399 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503401 */     GIR_RootConstrainSelectedInstOperands,
     /*  503402 */     // GIR_Coverage, 62167,
     /*  503402 */     GIR_EraseRootFromParent_Done,
     /*  503403 */   // Label 8418: @503403
     /*  503403 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(503471), // Rule ID 62168 //
     /*  503408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503440 */     // MIs[0] policy
     /*  503440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503450 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  503453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503467 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503469 */     GIR_RootConstrainSelectedInstOperands,
     /*  503470 */     // GIR_Coverage, 62168,
     /*  503470 */     GIR_EraseRootFromParent_Done,
     /*  503471 */   // Label 8419: @503471
     /*  503471 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(503539), // Rule ID 62169 //
     /*  503476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503508 */     // MIs[0] policy
     /*  503508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  503521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503535 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503537 */     GIR_RootConstrainSelectedInstOperands,
     /*  503538 */     // GIR_Coverage, 62169,
     /*  503538 */     GIR_EraseRootFromParent_Done,
     /*  503539 */   // Label 8420: @503539
     /*  503539 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(503607), // Rule ID 62170 //
     /*  503544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503576 */     // MIs[0] policy
     /*  503576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  503589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503603 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503605 */     GIR_RootConstrainSelectedInstOperands,
     /*  503606 */     // GIR_Coverage, 62170,
     /*  503606 */     GIR_EraseRootFromParent_Done,
     /*  503607 */   // Label 8421: @503607
     /*  503607 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(503675), // Rule ID 62171 //
     /*  503612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503644 */     // MIs[0] policy
     /*  503644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503654 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  503657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503671 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503673 */     GIR_RootConstrainSelectedInstOperands,
     /*  503674 */     // GIR_Coverage, 62171,
     /*  503674 */     GIR_EraseRootFromParent_Done,
     /*  503675 */   // Label 8422: @503675
     /*  503675 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(503743), // Rule ID 62172 //
     /*  503680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503712 */     // MIs[0] policy
     /*  503712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503722 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  503725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503739 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503741 */     GIR_RootConstrainSelectedInstOperands,
     /*  503742 */     // GIR_Coverage, 62172,
     /*  503742 */     GIR_EraseRootFromParent_Done,
     /*  503743 */   // Label 8423: @503743
     /*  503743 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(503811), // Rule ID 62173 //
     /*  503748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503780 */     // MIs[0] policy
     /*  503780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503790 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  503793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503807 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503809 */     GIR_RootConstrainSelectedInstOperands,
     /*  503810 */     // GIR_Coverage, 62173,
     /*  503810 */     GIR_EraseRootFromParent_Done,
     /*  503811 */   // Label 8424: @503811
     /*  503811 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(503879), // Rule ID 62174 //
     /*  503816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503848 */     // MIs[0] policy
     /*  503848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503858 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  503861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503875 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503877 */     GIR_RootConstrainSelectedInstOperands,
     /*  503878 */     // GIR_Coverage, 62174,
     /*  503878 */     GIR_EraseRootFromParent_Done,
     /*  503879 */   // Label 8425: @503879
     /*  503879 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(503947), // Rule ID 62175 //
     /*  503884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503916 */     // MIs[0] policy
     /*  503916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  503929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503943 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503945 */     GIR_RootConstrainSelectedInstOperands,
     /*  503946 */     // GIR_Coverage, 62175,
     /*  503946 */     GIR_EraseRootFromParent_Done,
     /*  503947 */   // Label 8426: @503947
     /*  503947 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(504015), // Rule ID 62176 //
     /*  503952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503984 */     // MIs[0] policy
     /*  503984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503994 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  503997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504011 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504013 */     GIR_RootConstrainSelectedInstOperands,
     /*  504014 */     // GIR_Coverage, 62176,
     /*  504014 */     GIR_EraseRootFromParent_Done,
     /*  504015 */   // Label 8427: @504015
     /*  504015 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(504083), // Rule ID 62177 //
     /*  504020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504052 */     // MIs[0] policy
     /*  504052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504062 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  504065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504079 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504081 */     GIR_RootConstrainSelectedInstOperands,
     /*  504082 */     // GIR_Coverage, 62177,
     /*  504082 */     GIR_EraseRootFromParent_Done,
     /*  504083 */   // Label 8428: @504083
     /*  504083 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(504151), // Rule ID 62178 //
     /*  504088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504120 */     // MIs[0] policy
     /*  504120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504130 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  504133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504147 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504149 */     GIR_RootConstrainSelectedInstOperands,
     /*  504150 */     // GIR_Coverage, 62178,
     /*  504150 */     GIR_EraseRootFromParent_Done,
     /*  504151 */   // Label 8429: @504151
     /*  504151 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(504219), // Rule ID 62179 //
     /*  504156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504188 */     // MIs[0] policy
     /*  504188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  504201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504215 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504217 */     GIR_RootConstrainSelectedInstOperands,
     /*  504218 */     // GIR_Coverage, 62179,
     /*  504218 */     GIR_EraseRootFromParent_Done,
     /*  504219 */   // Label 8430: @504219
     /*  504219 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(504287), // Rule ID 62180 //
     /*  504224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504256 */     // MIs[0] policy
     /*  504256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504266 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  504269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504283 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504285 */     GIR_RootConstrainSelectedInstOperands,
     /*  504286 */     // GIR_Coverage, 62180,
     /*  504286 */     GIR_EraseRootFromParent_Done,
     /*  504287 */   // Label 8431: @504287
     /*  504287 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(504355), // Rule ID 62181 //
     /*  504292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504324 */     // MIs[0] policy
     /*  504324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  504337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504351 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504353 */     GIR_RootConstrainSelectedInstOperands,
     /*  504354 */     // GIR_Coverage, 62181,
     /*  504354 */     GIR_EraseRootFromParent_Done,
     /*  504355 */   // Label 8432: @504355
     /*  504355 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(504423), // Rule ID 62182 //
     /*  504360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504392 */     // MIs[0] policy
     /*  504392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504402 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  504405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504419 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504421 */     GIR_RootConstrainSelectedInstOperands,
     /*  504422 */     // GIR_Coverage, 62182,
     /*  504422 */     GIR_EraseRootFromParent_Done,
     /*  504423 */   // Label 8433: @504423
     /*  504423 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(504491), // Rule ID 62183 //
     /*  504428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504460 */     // MIs[0] policy
     /*  504460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504470 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  504473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504487 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504489 */     GIR_RootConstrainSelectedInstOperands,
     /*  504490 */     // GIR_Coverage, 62183,
     /*  504490 */     GIR_EraseRootFromParent_Done,
     /*  504491 */   // Label 8434: @504491
     /*  504491 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(504559), // Rule ID 62184 //
     /*  504496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  504507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  504510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504528 */     // MIs[0] policy
     /*  504528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  504541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504555 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504557 */     GIR_RootConstrainSelectedInstOperands,
     /*  504558 */     // GIR_Coverage, 62184,
     /*  504558 */     GIR_EraseRootFromParent_Done,
     /*  504559 */   // Label 8435: @504559
     /*  504559 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(504627), // Rule ID 62185 //
     /*  504564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  504575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  504578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504596 */     // MIs[0] policy
     /*  504596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504606 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  504609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504623 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504625 */     GIR_RootConstrainSelectedInstOperands,
     /*  504626 */     // GIR_Coverage, 62185,
     /*  504626 */     GIR_EraseRootFromParent_Done,
     /*  504627 */   // Label 8436: @504627
     /*  504627 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(504695), // Rule ID 62186 //
     /*  504632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504664 */     // MIs[0] policy
     /*  504664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  504677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504691 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504693 */     GIR_RootConstrainSelectedInstOperands,
     /*  504694 */     // GIR_Coverage, 62186,
     /*  504694 */     GIR_EraseRootFromParent_Done,
     /*  504695 */   // Label 8437: @504695
     /*  504695 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(504763), // Rule ID 62187 //
     /*  504700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504732 */     // MIs[0] policy
     /*  504732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504742 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  504745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504759 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504761 */     GIR_RootConstrainSelectedInstOperands,
     /*  504762 */     // GIR_Coverage, 62187,
     /*  504762 */     GIR_EraseRootFromParent_Done,
     /*  504763 */   // Label 8438: @504763
     /*  504763 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(504831), // Rule ID 62188 //
     /*  504768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504800 */     // MIs[0] policy
     /*  504800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504810 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  504813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504827 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504829 */     GIR_RootConstrainSelectedInstOperands,
     /*  504830 */     // GIR_Coverage, 62188,
     /*  504830 */     GIR_EraseRootFromParent_Done,
     /*  504831 */   // Label 8439: @504831
     /*  504831 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(504899), // Rule ID 62189 //
     /*  504836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504868 */     // MIs[0] policy
     /*  504868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  504881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504895 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504897 */     GIR_RootConstrainSelectedInstOperands,
     /*  504898 */     // GIR_Coverage, 62189,
     /*  504898 */     GIR_EraseRootFromParent_Done,
     /*  504899 */   // Label 8440: @504899
     /*  504899 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(504967), // Rule ID 62190 //
     /*  504904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504936 */     // MIs[0] policy
     /*  504936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  504949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504963 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504965 */     GIR_RootConstrainSelectedInstOperands,
     /*  504966 */     // GIR_Coverage, 62190,
     /*  504966 */     GIR_EraseRootFromParent_Done,
     /*  504967 */   // Label 8441: @504967
     /*  504967 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(505035), // Rule ID 62191 //
     /*  504972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505004 */     // MIs[0] policy
     /*  505004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505014 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  505017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505031 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505033 */     GIR_RootConstrainSelectedInstOperands,
     /*  505034 */     // GIR_Coverage, 62191,
     /*  505034 */     GIR_EraseRootFromParent_Done,
     /*  505035 */   // Label 8442: @505035
     /*  505035 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(505103), // Rule ID 62192 //
     /*  505040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  505057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505072 */     // MIs[0] policy
     /*  505072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505082 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  505085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505099 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505101 */     GIR_RootConstrainSelectedInstOperands,
     /*  505102 */     // GIR_Coverage, 62192,
     /*  505102 */     GIR_EraseRootFromParent_Done,
     /*  505103 */   // Label 8443: @505103
     /*  505103 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(505171), // Rule ID 62193 //
     /*  505108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  505125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505140 */     // MIs[0] policy
     /*  505140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505150 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  505153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505167 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505169 */     GIR_RootConstrainSelectedInstOperands,
     /*  505170 */     // GIR_Coverage, 62193,
     /*  505170 */     GIR_EraseRootFromParent_Done,
     /*  505171 */   // Label 8444: @505171
     /*  505171 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(505239), // Rule ID 62194 //
     /*  505176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505208 */     // MIs[0] policy
     /*  505208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505218 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  505221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505235 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505237 */     GIR_RootConstrainSelectedInstOperands,
     /*  505238 */     // GIR_Coverage, 62194,
     /*  505238 */     GIR_EraseRootFromParent_Done,
     /*  505239 */   // Label 8445: @505239
     /*  505239 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(505307), // Rule ID 62195 //
     /*  505244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505276 */     // MIs[0] policy
     /*  505276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505286 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  505289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505303 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505305 */     GIR_RootConstrainSelectedInstOperands,
     /*  505306 */     // GIR_Coverage, 62195,
     /*  505306 */     GIR_EraseRootFromParent_Done,
     /*  505307 */   // Label 8446: @505307
     /*  505307 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(505375), // Rule ID 62196 //
     /*  505312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505344 */     // MIs[0] policy
     /*  505344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  505357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505371 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505373 */     GIR_RootConstrainSelectedInstOperands,
     /*  505374 */     // GIR_Coverage, 62196,
     /*  505374 */     GIR_EraseRootFromParent_Done,
     /*  505375 */   // Label 8447: @505375
     /*  505375 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(505443), // Rule ID 62197 //
     /*  505380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505412 */     // MIs[0] policy
     /*  505412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  505425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505439 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505441 */     GIR_RootConstrainSelectedInstOperands,
     /*  505442 */     // GIR_Coverage, 62197,
     /*  505442 */     GIR_EraseRootFromParent_Done,
     /*  505443 */   // Label 8448: @505443
     /*  505443 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(505511), // Rule ID 62198 //
     /*  505448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505480 */     // MIs[0] policy
     /*  505480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  505493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505507 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505509 */     GIR_RootConstrainSelectedInstOperands,
     /*  505510 */     // GIR_Coverage, 62198,
     /*  505510 */     GIR_EraseRootFromParent_Done,
     /*  505511 */   // Label 8449: @505511
     /*  505511 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(505579), // Rule ID 62199 //
     /*  505516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505548 */     // MIs[0] policy
     /*  505548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  505561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505575 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505577 */     GIR_RootConstrainSelectedInstOperands,
     /*  505578 */     // GIR_Coverage, 62199,
     /*  505578 */     GIR_EraseRootFromParent_Done,
     /*  505579 */   // Label 8450: @505579
     /*  505579 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(505647), // Rule ID 62200 //
     /*  505584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505616 */     // MIs[0] policy
     /*  505616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  505629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505643 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505645 */     GIR_RootConstrainSelectedInstOperands,
     /*  505646 */     // GIR_Coverage, 62200,
     /*  505646 */     GIR_EraseRootFromParent_Done,
     /*  505647 */   // Label 8451: @505647
     /*  505647 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(505715), // Rule ID 62201 //
     /*  505652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505684 */     // MIs[0] policy
     /*  505684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  505697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505711 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505713 */     GIR_RootConstrainSelectedInstOperands,
     /*  505714 */     // GIR_Coverage, 62201,
     /*  505714 */     GIR_EraseRootFromParent_Done,
     /*  505715 */   // Label 8452: @505715
     /*  505715 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(505783), // Rule ID 62202 //
     /*  505720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505752 */     // MIs[0] policy
     /*  505752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  505765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505779 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505781 */     GIR_RootConstrainSelectedInstOperands,
     /*  505782 */     // GIR_Coverage, 62202,
     /*  505782 */     GIR_EraseRootFromParent_Done,
     /*  505783 */   // Label 8453: @505783
     /*  505783 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(505851), // Rule ID 62203 //
     /*  505788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505820 */     // MIs[0] policy
     /*  505820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  505833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505847 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505849 */     GIR_RootConstrainSelectedInstOperands,
     /*  505850 */     // GIR_Coverage, 62203,
     /*  505850 */     GIR_EraseRootFromParent_Done,
     /*  505851 */   // Label 8454: @505851
     /*  505851 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(505919), // Rule ID 62204 //
     /*  505856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505888 */     // MIs[0] policy
     /*  505888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505898 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  505901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505915 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505917 */     GIR_RootConstrainSelectedInstOperands,
     /*  505918 */     // GIR_Coverage, 62204,
     /*  505918 */     GIR_EraseRootFromParent_Done,
     /*  505919 */   // Label 8455: @505919
     /*  505919 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(505987), // Rule ID 62205 //
     /*  505924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505956 */     // MIs[0] policy
     /*  505956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  505969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505983 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505985 */     GIR_RootConstrainSelectedInstOperands,
     /*  505986 */     // GIR_Coverage, 62205,
     /*  505986 */     GIR_EraseRootFromParent_Done,
     /*  505987 */   // Label 8456: @505987
     /*  505987 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(506055), // Rule ID 62206 //
     /*  505992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506024 */     // MIs[0] policy
     /*  506024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506034 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  506037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506051 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506053 */     GIR_RootConstrainSelectedInstOperands,
     /*  506054 */     // GIR_Coverage, 62206,
     /*  506054 */     GIR_EraseRootFromParent_Done,
     /*  506055 */   // Label 8457: @506055
     /*  506055 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(506123), // Rule ID 62207 //
     /*  506060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506092 */     // MIs[0] policy
     /*  506092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506102 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  506105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506119 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506121 */     GIR_RootConstrainSelectedInstOperands,
     /*  506122 */     // GIR_Coverage, 62207,
     /*  506122 */     GIR_EraseRootFromParent_Done,
     /*  506123 */   // Label 8458: @506123
     /*  506123 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(506191), // Rule ID 62208 //
     /*  506128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506160 */     // MIs[0] policy
     /*  506160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506170 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  506173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506187 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506189 */     GIR_RootConstrainSelectedInstOperands,
     /*  506190 */     // GIR_Coverage, 62208,
     /*  506190 */     GIR_EraseRootFromParent_Done,
     /*  506191 */   // Label 8459: @506191
     /*  506191 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(506259), // Rule ID 62209 //
     /*  506196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506228 */     // MIs[0] policy
     /*  506228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506238 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  506241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506255 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506257 */     GIR_RootConstrainSelectedInstOperands,
     /*  506258 */     // GIR_Coverage, 62209,
     /*  506258 */     GIR_EraseRootFromParent_Done,
     /*  506259 */   // Label 8460: @506259
     /*  506259 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(506327), // Rule ID 62210 //
     /*  506264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506296 */     // MIs[0] policy
     /*  506296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506306 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  506309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506323 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506325 */     GIR_RootConstrainSelectedInstOperands,
     /*  506326 */     // GIR_Coverage, 62210,
     /*  506326 */     GIR_EraseRootFromParent_Done,
     /*  506327 */   // Label 8461: @506327
     /*  506327 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(506395), // Rule ID 62211 //
     /*  506332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506364 */     // MIs[0] policy
     /*  506364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506374 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  506377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506391 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506393 */     GIR_RootConstrainSelectedInstOperands,
     /*  506394 */     // GIR_Coverage, 62211,
     /*  506394 */     GIR_EraseRootFromParent_Done,
     /*  506395 */   // Label 8462: @506395
     /*  506395 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(506463), // Rule ID 62212 //
     /*  506400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506432 */     // MIs[0] policy
     /*  506432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506442 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  506445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506459 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506461 */     GIR_RootConstrainSelectedInstOperands,
     /*  506462 */     // GIR_Coverage, 62212,
     /*  506462 */     GIR_EraseRootFromParent_Done,
     /*  506463 */   // Label 8463: @506463
     /*  506463 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(506531), // Rule ID 62213 //
     /*  506468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506500 */     // MIs[0] policy
     /*  506500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506510 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  506513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506527 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506529 */     GIR_RootConstrainSelectedInstOperands,
     /*  506530 */     // GIR_Coverage, 62213,
     /*  506530 */     GIR_EraseRootFromParent_Done,
     /*  506531 */   // Label 8464: @506531
     /*  506531 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(506599), // Rule ID 62214 //
     /*  506536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506568 */     // MIs[0] policy
     /*  506568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506578 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  506581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506595 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506597 */     GIR_RootConstrainSelectedInstOperands,
     /*  506598 */     // GIR_Coverage, 62214,
     /*  506598 */     GIR_EraseRootFromParent_Done,
     /*  506599 */   // Label 8465: @506599
     /*  506599 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(506667), // Rule ID 62215 //
     /*  506604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506636 */     // MIs[0] policy
     /*  506636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506646 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  506649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506663 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506665 */     GIR_RootConstrainSelectedInstOperands,
     /*  506666 */     // GIR_Coverage, 62215,
     /*  506666 */     GIR_EraseRootFromParent_Done,
     /*  506667 */   // Label 8466: @506667
     /*  506667 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(506735), // Rule ID 62216 //
     /*  506672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506704 */     // MIs[0] policy
     /*  506704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506714 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  506717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506731 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506733 */     GIR_RootConstrainSelectedInstOperands,
     /*  506734 */     // GIR_Coverage, 62216,
     /*  506734 */     GIR_EraseRootFromParent_Done,
     /*  506735 */   // Label 8467: @506735
     /*  506735 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(506803), // Rule ID 62217 //
     /*  506740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506772 */     // MIs[0] policy
     /*  506772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506782 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  506785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506799 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506801 */     GIR_RootConstrainSelectedInstOperands,
     /*  506802 */     // GIR_Coverage, 62217,
     /*  506802 */     GIR_EraseRootFromParent_Done,
     /*  506803 */   // Label 8468: @506803
     /*  506803 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(506871), // Rule ID 62218 //
     /*  506808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506840 */     // MIs[0] policy
     /*  506840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506850 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  506853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506867 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506869 */     GIR_RootConstrainSelectedInstOperands,
     /*  506870 */     // GIR_Coverage, 62218,
     /*  506870 */     GIR_EraseRootFromParent_Done,
     /*  506871 */   // Label 8469: @506871
     /*  506871 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(506939), // Rule ID 62219 //
     /*  506876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506908 */     // MIs[0] policy
     /*  506908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  506921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506935 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506937 */     GIR_RootConstrainSelectedInstOperands,
     /*  506938 */     // GIR_Coverage, 62219,
     /*  506938 */     GIR_EraseRootFromParent_Done,
     /*  506939 */   // Label 8470: @506939
     /*  506939 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(507007), // Rule ID 62220 //
     /*  506944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506976 */     // MIs[0] policy
     /*  506976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506986 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  506989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507003 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507005 */     GIR_RootConstrainSelectedInstOperands,
     /*  507006 */     // GIR_Coverage, 62220,
     /*  507006 */     GIR_EraseRootFromParent_Done,
     /*  507007 */   // Label 8471: @507007
     /*  507007 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(507075), // Rule ID 62221 //
     /*  507012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507044 */     // MIs[0] policy
     /*  507044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  507057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507071 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507073 */     GIR_RootConstrainSelectedInstOperands,
     /*  507074 */     // GIR_Coverage, 62221,
     /*  507074 */     GIR_EraseRootFromParent_Done,
     /*  507075 */   // Label 8472: @507075
     /*  507075 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(507143), // Rule ID 62222 //
     /*  507080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507112 */     // MIs[0] policy
     /*  507112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507122 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  507125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507139 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507141 */     GIR_RootConstrainSelectedInstOperands,
     /*  507142 */     // GIR_Coverage, 62222,
     /*  507142 */     GIR_EraseRootFromParent_Done,
     /*  507143 */   // Label 8473: @507143
     /*  507143 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(507211), // Rule ID 62223 //
     /*  507148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507180 */     // MIs[0] policy
     /*  507180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507190 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  507193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507207 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507209 */     GIR_RootConstrainSelectedInstOperands,
     /*  507210 */     // GIR_Coverage, 62223,
     /*  507210 */     GIR_EraseRootFromParent_Done,
     /*  507211 */   // Label 8474: @507211
     /*  507211 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(507279), // Rule ID 62224 //
     /*  507216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507248 */     // MIs[0] policy
     /*  507248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507258 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  507261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507275 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507277 */     GIR_RootConstrainSelectedInstOperands,
     /*  507278 */     // GIR_Coverage, 62224,
     /*  507278 */     GIR_EraseRootFromParent_Done,
     /*  507279 */   // Label 8475: @507279
     /*  507279 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(507347), // Rule ID 62225 //
     /*  507284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507316 */     // MIs[0] policy
     /*  507316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  507329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507343 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507345 */     GIR_RootConstrainSelectedInstOperands,
     /*  507346 */     // GIR_Coverage, 62225,
     /*  507346 */     GIR_EraseRootFromParent_Done,
     /*  507347 */   // Label 8476: @507347
     /*  507347 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(507415), // Rule ID 62226 //
     /*  507352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507384 */     // MIs[0] policy
     /*  507384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507394 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  507397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507411 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507413 */     GIR_RootConstrainSelectedInstOperands,
     /*  507414 */     // GIR_Coverage, 62226,
     /*  507414 */     GIR_EraseRootFromParent_Done,
     /*  507415 */   // Label 8477: @507415
     /*  507415 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(507483), // Rule ID 62227 //
     /*  507420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507452 */     // MIs[0] policy
     /*  507452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507462 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  507465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507479 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507481 */     GIR_RootConstrainSelectedInstOperands,
     /*  507482 */     // GIR_Coverage, 62227,
     /*  507482 */     GIR_EraseRootFromParent_Done,
     /*  507483 */   // Label 8478: @507483
     /*  507483 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(507551), // Rule ID 62228 //
     /*  507488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507520 */     // MIs[0] policy
     /*  507520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507530 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  507533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507547 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507549 */     GIR_RootConstrainSelectedInstOperands,
     /*  507550 */     // GIR_Coverage, 62228,
     /*  507550 */     GIR_EraseRootFromParent_Done,
     /*  507551 */   // Label 8479: @507551
     /*  507551 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(507619), // Rule ID 62229 //
     /*  507556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507588 */     // MIs[0] policy
     /*  507588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  507601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507615 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507617 */     GIR_RootConstrainSelectedInstOperands,
     /*  507618 */     // GIR_Coverage, 62229,
     /*  507618 */     GIR_EraseRootFromParent_Done,
     /*  507619 */   // Label 8480: @507619
     /*  507619 */   GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(507687), // Rule ID 62230 //
     /*  507624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  507641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507656 */     // MIs[0] policy
     /*  507656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  507669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507683 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507685 */     GIR_RootConstrainSelectedInstOperands,
     /*  507686 */     // GIR_Coverage, 62230,
     /*  507686 */     GIR_EraseRootFromParent_Done,
     /*  507687 */   // Label 8481: @507687
     /*  507687 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(507755), // Rule ID 62231 //
     /*  507692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  507709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507724 */     // MIs[0] policy
     /*  507724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507734 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  507737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507751 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507753 */     GIR_RootConstrainSelectedInstOperands,
     /*  507754 */     // GIR_Coverage, 62231,
     /*  507754 */     GIR_EraseRootFromParent_Done,
     /*  507755 */   // Label 8482: @507755
     /*  507755 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(507823), // Rule ID 62232 //
     /*  507760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507792 */     // MIs[0] policy
     /*  507792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  507805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507819 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507821 */     GIR_RootConstrainSelectedInstOperands,
     /*  507822 */     // GIR_Coverage, 62232,
     /*  507822 */     GIR_EraseRootFromParent_Done,
     /*  507823 */   // Label 8483: @507823
     /*  507823 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(507891), // Rule ID 62233 //
     /*  507828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507860 */     // MIs[0] policy
     /*  507860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507870 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  507873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507887 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507889 */     GIR_RootConstrainSelectedInstOperands,
     /*  507890 */     // GIR_Coverage, 62233,
     /*  507890 */     GIR_EraseRootFromParent_Done,
     /*  507891 */   // Label 8484: @507891
     /*  507891 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(507959), // Rule ID 62234 //
     /*  507896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507928 */     // MIs[0] policy
     /*  507928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507938 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  507941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507955 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507957 */     GIR_RootConstrainSelectedInstOperands,
     /*  507958 */     // GIR_Coverage, 62234,
     /*  507958 */     GIR_EraseRootFromParent_Done,
     /*  507959 */   // Label 8485: @507959
     /*  507959 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(508027), // Rule ID 62235 //
     /*  507964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507996 */     // MIs[0] policy
     /*  507996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508006 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  508009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508023 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508025 */     GIR_RootConstrainSelectedInstOperands,
     /*  508026 */     // GIR_Coverage, 62235,
     /*  508026 */     GIR_EraseRootFromParent_Done,
     /*  508027 */   // Label 8486: @508027
     /*  508027 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(508095), // Rule ID 62236 //
     /*  508032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508064 */     // MIs[0] policy
     /*  508064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  508077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508091 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508093 */     GIR_RootConstrainSelectedInstOperands,
     /*  508094 */     // GIR_Coverage, 62236,
     /*  508094 */     GIR_EraseRootFromParent_Done,
     /*  508095 */   // Label 8487: @508095
     /*  508095 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(508163), // Rule ID 62237 //
     /*  508100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508132 */     // MIs[0] policy
     /*  508132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508142 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  508145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508159 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508161 */     GIR_RootConstrainSelectedInstOperands,
     /*  508162 */     // GIR_Coverage, 62237,
     /*  508162 */     GIR_EraseRootFromParent_Done,
     /*  508163 */   // Label 8488: @508163
     /*  508163 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(508231), // Rule ID 62238 //
     /*  508168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508200 */     // MIs[0] policy
     /*  508200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  508213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508227 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508229 */     GIR_RootConstrainSelectedInstOperands,
     /*  508230 */     // GIR_Coverage, 62238,
     /*  508230 */     GIR_EraseRootFromParent_Done,
     /*  508231 */   // Label 8489: @508231
     /*  508231 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(508299), // Rule ID 62239 //
     /*  508236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508268 */     // MIs[0] policy
     /*  508268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  508281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508295 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508297 */     GIR_RootConstrainSelectedInstOperands,
     /*  508298 */     // GIR_Coverage, 62239,
     /*  508298 */     GIR_EraseRootFromParent_Done,
     /*  508299 */   // Label 8490: @508299
     /*  508299 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(508367), // Rule ID 62240 //
     /*  508304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508336 */     // MIs[0] policy
     /*  508336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  508349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508363 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508365 */     GIR_RootConstrainSelectedInstOperands,
     /*  508366 */     // GIR_Coverage, 62240,
     /*  508366 */     GIR_EraseRootFromParent_Done,
     /*  508367 */   // Label 8491: @508367
     /*  508367 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(508435), // Rule ID 62241 //
     /*  508372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508404 */     // MIs[0] policy
     /*  508404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  508417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508431 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508433 */     GIR_RootConstrainSelectedInstOperands,
     /*  508434 */     // GIR_Coverage, 62241,
     /*  508434 */     GIR_EraseRootFromParent_Done,
     /*  508435 */   // Label 8492: @508435
     /*  508435 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(508503), // Rule ID 62242 //
     /*  508440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508472 */     // MIs[0] policy
     /*  508472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508482 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  508485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508499 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508501 */     GIR_RootConstrainSelectedInstOperands,
     /*  508502 */     // GIR_Coverage, 62242,
     /*  508502 */     GIR_EraseRootFromParent_Done,
     /*  508503 */   // Label 8493: @508503
     /*  508503 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(508571), // Rule ID 62243 //
     /*  508508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508540 */     // MIs[0] policy
     /*  508540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508550 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  508553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508567 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508569 */     GIR_RootConstrainSelectedInstOperands,
     /*  508570 */     // GIR_Coverage, 62243,
     /*  508570 */     GIR_EraseRootFromParent_Done,
     /*  508571 */   // Label 8494: @508571
     /*  508571 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(508639), // Rule ID 62244 //
     /*  508576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508608 */     // MIs[0] policy
     /*  508608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  508621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508635 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508637 */     GIR_RootConstrainSelectedInstOperands,
     /*  508638 */     // GIR_Coverage, 62244,
     /*  508638 */     GIR_EraseRootFromParent_Done,
     /*  508639 */   // Label 8495: @508639
     /*  508639 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(508707), // Rule ID 62245 //
     /*  508644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508676 */     // MIs[0] policy
     /*  508676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  508689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508703 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508705 */     GIR_RootConstrainSelectedInstOperands,
     /*  508706 */     // GIR_Coverage, 62245,
     /*  508706 */     GIR_EraseRootFromParent_Done,
     /*  508707 */   // Label 8496: @508707
     /*  508707 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(508775), // Rule ID 62246 //
     /*  508712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508744 */     // MIs[0] policy
     /*  508744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508754 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  508757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508771 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508773 */     GIR_RootConstrainSelectedInstOperands,
     /*  508774 */     // GIR_Coverage, 62246,
     /*  508774 */     GIR_EraseRootFromParent_Done,
     /*  508775 */   // Label 8497: @508775
     /*  508775 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(508843), // Rule ID 62247 //
     /*  508780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508812 */     // MIs[0] policy
     /*  508812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  508825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508839 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508841 */     GIR_RootConstrainSelectedInstOperands,
     /*  508842 */     // GIR_Coverage, 62247,
     /*  508842 */     GIR_EraseRootFromParent_Done,
     /*  508843 */   // Label 8498: @508843
     /*  508843 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(508911), // Rule ID 62248 //
     /*  508848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508880 */     // MIs[0] policy
     /*  508880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508890 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  508893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508907 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508909 */     GIR_RootConstrainSelectedInstOperands,
     /*  508910 */     // GIR_Coverage, 62248,
     /*  508910 */     GIR_EraseRootFromParent_Done,
     /*  508911 */   // Label 8499: @508911
     /*  508911 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(508979), // Rule ID 62249 //
     /*  508916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508948 */     // MIs[0] policy
     /*  508948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508958 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  508961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508975 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508977 */     GIR_RootConstrainSelectedInstOperands,
     /*  508978 */     // GIR_Coverage, 62249,
     /*  508978 */     GIR_EraseRootFromParent_Done,
     /*  508979 */   // Label 8500: @508979
     /*  508979 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(509047), // Rule ID 62250 //
     /*  508984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509016 */     // MIs[0] policy
     /*  509016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509026 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  509029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509043 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509045 */     GIR_RootConstrainSelectedInstOperands,
     /*  509046 */     // GIR_Coverage, 62250,
     /*  509046 */     GIR_EraseRootFromParent_Done,
     /*  509047 */   // Label 8501: @509047
     /*  509047 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(509115), // Rule ID 62251 //
     /*  509052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509084 */     // MIs[0] policy
     /*  509084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  509097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509111 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509113 */     GIR_RootConstrainSelectedInstOperands,
     /*  509114 */     // GIR_Coverage, 62251,
     /*  509114 */     GIR_EraseRootFromParent_Done,
     /*  509115 */   // Label 8502: @509115
     /*  509115 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(509183), // Rule ID 62252 //
     /*  509120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509152 */     // MIs[0] policy
     /*  509152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509162 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  509165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509179 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509181 */     GIR_RootConstrainSelectedInstOperands,
     /*  509182 */     // GIR_Coverage, 62252,
     /*  509182 */     GIR_EraseRootFromParent_Done,
     /*  509183 */   // Label 8503: @509183
     /*  509183 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(509251), // Rule ID 62253 //
     /*  509188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509220 */     // MIs[0] policy
     /*  509220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509230 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  509233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509247 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509249 */     GIR_RootConstrainSelectedInstOperands,
     /*  509250 */     // GIR_Coverage, 62253,
     /*  509250 */     GIR_EraseRootFromParent_Done,
     /*  509251 */   // Label 8504: @509251
     /*  509251 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(509319), // Rule ID 62254 //
     /*  509256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509288 */     // MIs[0] policy
     /*  509288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509298 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  509301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509315 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509317 */     GIR_RootConstrainSelectedInstOperands,
     /*  509318 */     // GIR_Coverage, 62254,
     /*  509318 */     GIR_EraseRootFromParent_Done,
     /*  509319 */   // Label 8505: @509319
     /*  509319 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(509387), // Rule ID 62255 //
     /*  509324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509356 */     // MIs[0] policy
     /*  509356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509366 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  509369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509383 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509385 */     GIR_RootConstrainSelectedInstOperands,
     /*  509386 */     // GIR_Coverage, 62255,
     /*  509386 */     GIR_EraseRootFromParent_Done,
     /*  509387 */   // Label 8506: @509387
     /*  509387 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(509455), // Rule ID 62256 //
     /*  509392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509424 */     // MIs[0] policy
     /*  509424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509434 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  509437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509451 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509453 */     GIR_RootConstrainSelectedInstOperands,
     /*  509454 */     // GIR_Coverage, 62256,
     /*  509454 */     GIR_EraseRootFromParent_Done,
     /*  509455 */   // Label 8507: @509455
     /*  509455 */   GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(509523), // Rule ID 62257 //
     /*  509460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509492 */     // MIs[0] policy
     /*  509492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509502 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  509505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509519 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509521 */     GIR_RootConstrainSelectedInstOperands,
     /*  509522 */     // GIR_Coverage, 62257,
     /*  509522 */     GIR_EraseRootFromParent_Done,
     /*  509523 */   // Label 8508: @509523
     /*  509523 */   GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(509591), // Rule ID 62258 //
     /*  509528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509560 */     // MIs[0] policy
     /*  509560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509570 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  509573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509587 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509589 */     GIR_RootConstrainSelectedInstOperands,
     /*  509590 */     // GIR_Coverage, 62258,
     /*  509590 */     GIR_EraseRootFromParent_Done,
     /*  509591 */   // Label 8509: @509591
     /*  509591 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(509659), // Rule ID 62259 //
     /*  509596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509628 */     // MIs[0] policy
     /*  509628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509638 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  509641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509655 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509657 */     GIR_RootConstrainSelectedInstOperands,
     /*  509658 */     // GIR_Coverage, 62259,
     /*  509658 */     GIR_EraseRootFromParent_Done,
     /*  509659 */   // Label 8510: @509659
     /*  509659 */   GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(509727), // Rule ID 62276 //
     /*  509664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  509675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  509678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509696 */     // MIs[0] policy
     /*  509696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509706 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  509709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509723 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509725 */     GIR_RootConstrainSelectedInstOperands,
     /*  509726 */     // GIR_Coverage, 62276,
     /*  509726 */     GIR_EraseRootFromParent_Done,
     /*  509727 */   // Label 8511: @509727
     /*  509727 */   GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(509795), // Rule ID 62277 //
     /*  509732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  509743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  509746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509764 */     // MIs[0] policy
     /*  509764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509774 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  509777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509791 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509793 */     GIR_RootConstrainSelectedInstOperands,
     /*  509794 */     // GIR_Coverage, 62277,
     /*  509794 */     GIR_EraseRootFromParent_Done,
     /*  509795 */   // Label 8512: @509795
     /*  509795 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(509863), // Rule ID 62278 //
     /*  509800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509832 */     // MIs[0] policy
     /*  509832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  509845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509859 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509861 */     GIR_RootConstrainSelectedInstOperands,
     /*  509862 */     // GIR_Coverage, 62278,
     /*  509862 */     GIR_EraseRootFromParent_Done,
     /*  509863 */   // Label 8513: @509863
     /*  509863 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(509931), // Rule ID 62279 //
     /*  509868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509900 */     // MIs[0] policy
     /*  509900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509910 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  509913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509927 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509929 */     GIR_RootConstrainSelectedInstOperands,
     /*  509930 */     // GIR_Coverage, 62279,
     /*  509930 */     GIR_EraseRootFromParent_Done,
     /*  509931 */   // Label 8514: @509931
     /*  509931 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(509999), // Rule ID 62280 //
     /*  509936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509968 */     // MIs[0] policy
     /*  509968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509978 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  509981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509995 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509997 */     GIR_RootConstrainSelectedInstOperands,
     /*  509998 */     // GIR_Coverage, 62280,
     /*  509998 */     GIR_EraseRootFromParent_Done,
     /*  509999 */   // Label 8515: @509999
     /*  509999 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(510067), // Rule ID 62281 //
     /*  510004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  510015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  510018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510036 */     // MIs[0] policy
     /*  510036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510046 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  510049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510063 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510065 */     GIR_RootConstrainSelectedInstOperands,
     /*  510066 */     // GIR_Coverage, 62281,
     /*  510066 */     GIR_EraseRootFromParent_Done,
     /*  510067 */   // Label 8516: @510067
     /*  510067 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(510135), // Rule ID 62282 //
     /*  510072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510104 */     // MIs[0] policy
     /*  510104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510114 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  510117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510131 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510133 */     GIR_RootConstrainSelectedInstOperands,
     /*  510134 */     // GIR_Coverage, 62282,
     /*  510134 */     GIR_EraseRootFromParent_Done,
     /*  510135 */   // Label 8517: @510135
     /*  510135 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(510203), // Rule ID 62283 //
     /*  510140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510172 */     // MIs[0] policy
     /*  510172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510182 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  510185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510199 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510201 */     GIR_RootConstrainSelectedInstOperands,
     /*  510202 */     // GIR_Coverage, 62283,
     /*  510202 */     GIR_EraseRootFromParent_Done,
     /*  510203 */   // Label 8518: @510203
     /*  510203 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(510271), // Rule ID 62284 //
     /*  510208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510240 */     // MIs[0] policy
     /*  510240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  510253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510267 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510269 */     GIR_RootConstrainSelectedInstOperands,
     /*  510270 */     // GIR_Coverage, 62284,
     /*  510270 */     GIR_EraseRootFromParent_Done,
     /*  510271 */   // Label 8519: @510271
     /*  510271 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(510339), // Rule ID 62285 //
     /*  510276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510308 */     // MIs[0] policy
     /*  510308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  510321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510335 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510337 */     GIR_RootConstrainSelectedInstOperands,
     /*  510338 */     // GIR_Coverage, 62285,
     /*  510338 */     GIR_EraseRootFromParent_Done,
     /*  510339 */   // Label 8520: @510339
     /*  510339 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(510407), // Rule ID 62286 //
     /*  510344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510376 */     // MIs[0] policy
     /*  510376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510386 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  510389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510403 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510405 */     GIR_RootConstrainSelectedInstOperands,
     /*  510406 */     // GIR_Coverage, 62286,
     /*  510406 */     GIR_EraseRootFromParent_Done,
     /*  510407 */   // Label 8521: @510407
     /*  510407 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(510475), // Rule ID 62287 //
     /*  510412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510444 */     // MIs[0] policy
     /*  510444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510454 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  510457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510471 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510473 */     GIR_RootConstrainSelectedInstOperands,
     /*  510474 */     // GIR_Coverage, 62287,
     /*  510474 */     GIR_EraseRootFromParent_Done,
     /*  510475 */   // Label 8522: @510475
     /*  510475 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(510543), // Rule ID 62288 //
     /*  510480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510512 */     // MIs[0] policy
     /*  510512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510522 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  510525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510539 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510541 */     GIR_RootConstrainSelectedInstOperands,
     /*  510542 */     // GIR_Coverage, 62288,
     /*  510542 */     GIR_EraseRootFromParent_Done,
     /*  510543 */   // Label 8523: @510543
     /*  510543 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(510611), // Rule ID 62289 //
     /*  510548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510580 */     // MIs[0] policy
     /*  510580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510590 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  510593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510607 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510609 */     GIR_RootConstrainSelectedInstOperands,
     /*  510610 */     // GIR_Coverage, 62289,
     /*  510610 */     GIR_EraseRootFromParent_Done,
     /*  510611 */   // Label 8524: @510611
     /*  510611 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(510679), // Rule ID 62290 //
     /*  510616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510648 */     // MIs[0] policy
     /*  510648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510658 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  510661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510675 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510677 */     GIR_RootConstrainSelectedInstOperands,
     /*  510678 */     // GIR_Coverage, 62290,
     /*  510678 */     GIR_EraseRootFromParent_Done,
     /*  510679 */   // Label 8525: @510679
     /*  510679 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(510747), // Rule ID 62291 //
     /*  510684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510716 */     // MIs[0] policy
     /*  510716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510726 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  510729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510743 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510745 */     GIR_RootConstrainSelectedInstOperands,
     /*  510746 */     // GIR_Coverage, 62291,
     /*  510746 */     GIR_EraseRootFromParent_Done,
     /*  510747 */   // Label 8526: @510747
     /*  510747 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(510815), // Rule ID 62292 //
     /*  510752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510784 */     // MIs[0] policy
     /*  510784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510794 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  510797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510811 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510813 */     GIR_RootConstrainSelectedInstOperands,
     /*  510814 */     // GIR_Coverage, 62292,
     /*  510814 */     GIR_EraseRootFromParent_Done,
     /*  510815 */   // Label 8527: @510815
     /*  510815 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(510883), // Rule ID 62293 //
     /*  510820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510852 */     // MIs[0] policy
     /*  510852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510862 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  510865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510879 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510881 */     GIR_RootConstrainSelectedInstOperands,
     /*  510882 */     // GIR_Coverage, 62293,
     /*  510882 */     GIR_EraseRootFromParent_Done,
     /*  510883 */   // Label 8528: @510883
     /*  510883 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(510951), // Rule ID 62294 //
     /*  510888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510920 */     // MIs[0] policy
     /*  510920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510930 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  510933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510947 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510949 */     GIR_RootConstrainSelectedInstOperands,
     /*  510950 */     // GIR_Coverage, 62294,
     /*  510950 */     GIR_EraseRootFromParent_Done,
     /*  510951 */   // Label 8529: @510951
     /*  510951 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(511019), // Rule ID 62295 //
     /*  510956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510988 */     // MIs[0] policy
     /*  510988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510998 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  511001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511015 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511017 */     GIR_RootConstrainSelectedInstOperands,
     /*  511018 */     // GIR_Coverage, 62295,
     /*  511018 */     GIR_EraseRootFromParent_Done,
     /*  511019 */   // Label 8530: @511019
     /*  511019 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(511087), // Rule ID 62296 //
     /*  511024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511056 */     // MIs[0] policy
     /*  511056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511066 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  511069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511083 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511085 */     GIR_RootConstrainSelectedInstOperands,
     /*  511086 */     // GIR_Coverage, 62296,
     /*  511086 */     GIR_EraseRootFromParent_Done,
     /*  511087 */   // Label 8531: @511087
     /*  511087 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(511155), // Rule ID 62297 //
     /*  511092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511124 */     // MIs[0] policy
     /*  511124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511134 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  511137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511151 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511153 */     GIR_RootConstrainSelectedInstOperands,
     /*  511154 */     // GIR_Coverage, 62297,
     /*  511154 */     GIR_EraseRootFromParent_Done,
     /*  511155 */   // Label 8532: @511155
     /*  511155 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(511223), // Rule ID 62298 //
     /*  511160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511192 */     // MIs[0] policy
     /*  511192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511202 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  511205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511219 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511221 */     GIR_RootConstrainSelectedInstOperands,
     /*  511222 */     // GIR_Coverage, 62298,
     /*  511222 */     GIR_EraseRootFromParent_Done,
     /*  511223 */   // Label 8533: @511223
     /*  511223 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(511291), // Rule ID 62299 //
     /*  511228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511260 */     // MIs[0] policy
     /*  511260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511270 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  511273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511287 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511289 */     GIR_RootConstrainSelectedInstOperands,
     /*  511290 */     // GIR_Coverage, 62299,
     /*  511290 */     GIR_EraseRootFromParent_Done,
     /*  511291 */   // Label 8534: @511291
     /*  511291 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(511359), // Rule ID 62300 //
     /*  511296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511328 */     // MIs[0] policy
     /*  511328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511338 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  511341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511355 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511357 */     GIR_RootConstrainSelectedInstOperands,
     /*  511358 */     // GIR_Coverage, 62300,
     /*  511358 */     GIR_EraseRootFromParent_Done,
     /*  511359 */   // Label 8535: @511359
     /*  511359 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(511427), // Rule ID 62301 //
     /*  511364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511396 */     // MIs[0] policy
     /*  511396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511406 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  511409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511423 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511425 */     GIR_RootConstrainSelectedInstOperands,
     /*  511426 */     // GIR_Coverage, 62301,
     /*  511426 */     GIR_EraseRootFromParent_Done,
     /*  511427 */   // Label 8536: @511427
     /*  511427 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(511495), // Rule ID 62302 //
     /*  511432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511464 */     // MIs[0] policy
     /*  511464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511474 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  511477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511491 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511493 */     GIR_RootConstrainSelectedInstOperands,
     /*  511494 */     // GIR_Coverage, 62302,
     /*  511494 */     GIR_EraseRootFromParent_Done,
     /*  511495 */   // Label 8537: @511495
     /*  511495 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(511563), // Rule ID 62303 //
     /*  511500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511532 */     // MIs[0] policy
     /*  511532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511542 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  511545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511559 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511561 */     GIR_RootConstrainSelectedInstOperands,
     /*  511562 */     // GIR_Coverage, 62303,
     /*  511562 */     GIR_EraseRootFromParent_Done,
     /*  511563 */   // Label 8538: @511563
     /*  511563 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(511631), // Rule ID 62398 //
     /*  511568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  511579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511600 */     // MIs[0] policy
     /*  511600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511610 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  511613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511627 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511629 */     GIR_RootConstrainSelectedInstOperands,
     /*  511630 */     // GIR_Coverage, 62398,
     /*  511630 */     GIR_EraseRootFromParent_Done,
     /*  511631 */   // Label 8539: @511631
     /*  511631 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(511699), // Rule ID 62399 //
     /*  511636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  511639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  511647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511668 */     // MIs[0] policy
     /*  511668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511678 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  511681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511695 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511697 */     GIR_RootConstrainSelectedInstOperands,
     /*  511698 */     // GIR_Coverage, 62399,
     /*  511698 */     GIR_EraseRootFromParent_Done,
     /*  511699 */   // Label 8540: @511699
     /*  511699 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(511767), // Rule ID 62400 //
     /*  511704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511736 */     // MIs[0] policy
     /*  511736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511746 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  511749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511763 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511765 */     GIR_RootConstrainSelectedInstOperands,
     /*  511766 */     // GIR_Coverage, 62400,
     /*  511766 */     GIR_EraseRootFromParent_Done,
     /*  511767 */   // Label 8541: @511767
     /*  511767 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(511835), // Rule ID 62401 //
     /*  511772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  511775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511804 */     // MIs[0] policy
     /*  511804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511814 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  511817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511831 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511833 */     GIR_RootConstrainSelectedInstOperands,
     /*  511834 */     // GIR_Coverage, 62401,
     /*  511834 */     GIR_EraseRootFromParent_Done,
     /*  511835 */   // Label 8542: @511835
     /*  511835 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(511903), // Rule ID 62402 //
     /*  511840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  511851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  511854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511872 */     // MIs[0] policy
     /*  511872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511882 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  511885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511899 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511901 */     GIR_RootConstrainSelectedInstOperands,
     /*  511902 */     // GIR_Coverage, 62402,
     /*  511902 */     GIR_EraseRootFromParent_Done,
     /*  511903 */   // Label 8543: @511903
     /*  511903 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(511971), // Rule ID 62403 //
     /*  511908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  511911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  511919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  511922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511940 */     // MIs[0] policy
     /*  511940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  511953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511967 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511969 */     GIR_RootConstrainSelectedInstOperands,
     /*  511970 */     // GIR_Coverage, 62403,
     /*  511970 */     GIR_EraseRootFromParent_Done,
     /*  511971 */   // Label 8544: @511971
     /*  511971 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(512039), // Rule ID 62404 //
     /*  511976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512008 */     // MIs[0] policy
     /*  512008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512018 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  512021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512035 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512037 */     GIR_RootConstrainSelectedInstOperands,
     /*  512038 */     // GIR_Coverage, 62404,
     /*  512038 */     GIR_EraseRootFromParent_Done,
     /*  512039 */   // Label 8545: @512039
     /*  512039 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(512107), // Rule ID 62405 //
     /*  512044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  512061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512076 */     // MIs[0] policy
     /*  512076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512086 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  512089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512103 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512105 */     GIR_RootConstrainSelectedInstOperands,
     /*  512106 */     // GIR_Coverage, 62405,
     /*  512106 */     GIR_EraseRootFromParent_Done,
     /*  512107 */   // Label 8546: @512107
     /*  512107 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(512175), // Rule ID 62406 //
     /*  512112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  512123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  512126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  512129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512144 */     // MIs[0] policy
     /*  512144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512154 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  512157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512171 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512173 */     GIR_RootConstrainSelectedInstOperands,
     /*  512174 */     // GIR_Coverage, 62406,
     /*  512174 */     GIR_EraseRootFromParent_Done,
     /*  512175 */   // Label 8547: @512175
     /*  512175 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(512243), // Rule ID 62407 //
     /*  512180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  512191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  512194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  512197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512212 */     // MIs[0] policy
     /*  512212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512222 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  512225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512239 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512241 */     GIR_RootConstrainSelectedInstOperands,
     /*  512242 */     // GIR_Coverage, 62407,
     /*  512242 */     GIR_EraseRootFromParent_Done,
     /*  512243 */   // Label 8548: @512243
     /*  512243 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(512311), // Rule ID 62408 //
     /*  512248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  512259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  512262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512280 */     // MIs[0] policy
     /*  512280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512290 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  512293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512307 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512309 */     GIR_RootConstrainSelectedInstOperands,
     /*  512310 */     // GIR_Coverage, 62408,
     /*  512310 */     GIR_EraseRootFromParent_Done,
     /*  512311 */   // Label 8549: @512311
     /*  512311 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(512379), // Rule ID 62409 //
     /*  512316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  512327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  512330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512348 */     // MIs[0] policy
     /*  512348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512358 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  512361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512375 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512377 */     GIR_RootConstrainSelectedInstOperands,
     /*  512378 */     // GIR_Coverage, 62409,
     /*  512378 */     GIR_EraseRootFromParent_Done,
     /*  512379 */   // Label 8550: @512379
     /*  512379 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(512447), // Rule ID 62410 //
     /*  512384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512416 */     // MIs[0] policy
     /*  512416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512426 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  512429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512443 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512445 */     GIR_RootConstrainSelectedInstOperands,
     /*  512446 */     // GIR_Coverage, 62410,
     /*  512446 */     GIR_EraseRootFromParent_Done,
     /*  512447 */   // Label 8551: @512447
     /*  512447 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(512515), // Rule ID 62411 //
     /*  512452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512484 */     // MIs[0] policy
     /*  512484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512494 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  512497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512511 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512513 */     GIR_RootConstrainSelectedInstOperands,
     /*  512514 */     // GIR_Coverage, 62411,
     /*  512514 */     GIR_EraseRootFromParent_Done,
     /*  512515 */   // Label 8552: @512515
     /*  512515 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(512583), // Rule ID 62412 //
     /*  512520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512552 */     // MIs[0] policy
     /*  512552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512562 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  512565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512579 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512581 */     GIR_RootConstrainSelectedInstOperands,
     /*  512582 */     // GIR_Coverage, 62412,
     /*  512582 */     GIR_EraseRootFromParent_Done,
     /*  512583 */   // Label 8553: @512583
     /*  512583 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(512651), // Rule ID 62413 //
     /*  512588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512620 */     // MIs[0] policy
     /*  512620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512630 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  512633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512647 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512649 */     GIR_RootConstrainSelectedInstOperands,
     /*  512650 */     // GIR_Coverage, 62413,
     /*  512650 */     GIR_EraseRootFromParent_Done,
     /*  512651 */   // Label 8554: @512651
     /*  512651 */   GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(512719), // Rule ID 62414 //
     /*  512656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512688 */     // MIs[0] policy
     /*  512688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  512701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512715 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512717 */     GIR_RootConstrainSelectedInstOperands,
     /*  512718 */     // GIR_Coverage, 62414,
     /*  512718 */     GIR_EraseRootFromParent_Done,
     /*  512719 */   // Label 8555: @512719
     /*  512719 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(512787), // Rule ID 62415 //
     /*  512724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512756 */     // MIs[0] policy
     /*  512756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  512769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512783 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512785 */     GIR_RootConstrainSelectedInstOperands,
     /*  512786 */     // GIR_Coverage, 62415,
     /*  512786 */     GIR_EraseRootFromParent_Done,
     /*  512787 */   // Label 8556: @512787
     /*  512787 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(512855), // Rule ID 62416 //
     /*  512792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512824 */     // MIs[0] policy
     /*  512824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  512837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512851 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512853 */     GIR_RootConstrainSelectedInstOperands,
     /*  512854 */     // GIR_Coverage, 62416,
     /*  512854 */     GIR_EraseRootFromParent_Done,
     /*  512855 */   // Label 8557: @512855
     /*  512855 */   GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(512923), // Rule ID 62417 //
     /*  512860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512892 */     // MIs[0] policy
     /*  512892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  512905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512919 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512921 */     GIR_RootConstrainSelectedInstOperands,
     /*  512922 */     // GIR_Coverage, 62417,
     /*  512922 */     GIR_EraseRootFromParent_Done,
     /*  512923 */   // Label 8558: @512923
     /*  512923 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(512991), // Rule ID 62418 //
     /*  512928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512960 */     // MIs[0] policy
     /*  512960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512970 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  512973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512987 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512989 */     GIR_RootConstrainSelectedInstOperands,
     /*  512990 */     // GIR_Coverage, 62418,
     /*  512990 */     GIR_EraseRootFromParent_Done,
     /*  512991 */   // Label 8559: @512991
     /*  512991 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(513059), // Rule ID 62419 //
     /*  512996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513028 */     // MIs[0] policy
     /*  513028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513038 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  513041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513055 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513057 */     GIR_RootConstrainSelectedInstOperands,
     /*  513058 */     // GIR_Coverage, 62419,
     /*  513058 */     GIR_EraseRootFromParent_Done,
     /*  513059 */   // Label 8560: @513059
     /*  513059 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(513127), // Rule ID 62420 //
     /*  513064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513096 */     // MIs[0] policy
     /*  513096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513106 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  513109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513123 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513125 */     GIR_RootConstrainSelectedInstOperands,
     /*  513126 */     // GIR_Coverage, 62420,
     /*  513126 */     GIR_EraseRootFromParent_Done,
     /*  513127 */   // Label 8561: @513127
     /*  513127 */   GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(513195), // Rule ID 62421 //
     /*  513132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513164 */     // MIs[0] policy
     /*  513164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513174 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  513177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513191 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513193 */     GIR_RootConstrainSelectedInstOperands,
     /*  513194 */     // GIR_Coverage, 62421,
     /*  513194 */     GIR_EraseRootFromParent_Done,
     /*  513195 */   // Label 8562: @513195
     /*  513195 */   GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(513263), // Rule ID 62422 //
     /*  513200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513232 */     // MIs[0] policy
     /*  513232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513242 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  513245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513259 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513261 */     GIR_RootConstrainSelectedInstOperands,
     /*  513262 */     // GIR_Coverage, 62422,
     /*  513262 */     GIR_EraseRootFromParent_Done,
     /*  513263 */   // Label 8563: @513263
     /*  513263 */   GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(513331), // Rule ID 62423 //
     /*  513268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513300 */     // MIs[0] policy
     /*  513300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513310 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  513313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513327 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513329 */     GIR_RootConstrainSelectedInstOperands,
     /*  513330 */     // GIR_Coverage, 62423,
     /*  513330 */     GIR_EraseRootFromParent_Done,
     /*  513331 */   // Label 8564: @513331
     /*  513331 */   GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(513399), // Rule ID 62424 //
     /*  513336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513368 */     // MIs[0] policy
     /*  513368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513378 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  513381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513395 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513397 */     GIR_RootConstrainSelectedInstOperands,
     /*  513398 */     // GIR_Coverage, 62424,
     /*  513398 */     GIR_EraseRootFromParent_Done,
     /*  513399 */   // Label 8565: @513399
     /*  513399 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(513467), // Rule ID 62425 //
     /*  513404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513436 */     // MIs[0] policy
     /*  513436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  513449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513463 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513465 */     GIR_RootConstrainSelectedInstOperands,
     /*  513466 */     // GIR_Coverage, 62425,
     /*  513466 */     GIR_EraseRootFromParent_Done,
     /*  513467 */   // Label 8566: @513467
     /*  513467 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(513535), // Rule ID 62426 //
     /*  513472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  513489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513504 */     // MIs[0] policy
     /*  513504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  513517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513531 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513533 */     GIR_RootConstrainSelectedInstOperands,
     /*  513534 */     // GIR_Coverage, 62426,
     /*  513534 */     GIR_EraseRootFromParent_Done,
     /*  513535 */   // Label 8567: @513535
     /*  513535 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(513603), // Rule ID 62427 //
     /*  513540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  513557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513572 */     // MIs[0] policy
     /*  513572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513582 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  513585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513599 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513601 */     GIR_RootConstrainSelectedInstOperands,
     /*  513602 */     // GIR_Coverage, 62427,
     /*  513602 */     GIR_EraseRootFromParent_Done,
     /*  513603 */   // Label 8568: @513603
     /*  513603 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(513671), // Rule ID 62428 //
     /*  513608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513640 */     // MIs[0] policy
     /*  513640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513650 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  513653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513667 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513669 */     GIR_RootConstrainSelectedInstOperands,
     /*  513670 */     // GIR_Coverage, 62428,
     /*  513670 */     GIR_EraseRootFromParent_Done,
     /*  513671 */   // Label 8569: @513671
     /*  513671 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(513739), // Rule ID 62429 //
     /*  513676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513708 */     // MIs[0] policy
     /*  513708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  513721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513735 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513737 */     GIR_RootConstrainSelectedInstOperands,
     /*  513738 */     // GIR_Coverage, 62429,
     /*  513738 */     GIR_EraseRootFromParent_Done,
     /*  513739 */   // Label 8570: @513739
     /*  513739 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(513807), // Rule ID 62430 //
     /*  513744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513776 */     // MIs[0] policy
     /*  513776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513786 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  513789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513803 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513805 */     GIR_RootConstrainSelectedInstOperands,
     /*  513806 */     // GIR_Coverage, 62430,
     /*  513806 */     GIR_EraseRootFromParent_Done,
     /*  513807 */   // Label 8571: @513807
     /*  513807 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(513875), // Rule ID 62431 //
     /*  513812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513844 */     // MIs[0] policy
     /*  513844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513854 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  513857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513871 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513873 */     GIR_RootConstrainSelectedInstOperands,
     /*  513874 */     // GIR_Coverage, 62431,
     /*  513874 */     GIR_EraseRootFromParent_Done,
     /*  513875 */   // Label 8572: @513875
     /*  513875 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(513943), // Rule ID 62432 //
     /*  513880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513912 */     // MIs[0] policy
     /*  513912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513922 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  513925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513939 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513941 */     GIR_RootConstrainSelectedInstOperands,
     /*  513942 */     // GIR_Coverage, 62432,
     /*  513942 */     GIR_EraseRootFromParent_Done,
     /*  513943 */   // Label 8573: @513943
     /*  513943 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(514011), // Rule ID 62433 //
     /*  513948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513980 */     // MIs[0] policy
     /*  513980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513990 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  513993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514007 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514009 */     GIR_RootConstrainSelectedInstOperands,
     /*  514010 */     // GIR_Coverage, 62433,
     /*  514010 */     GIR_EraseRootFromParent_Done,
     /*  514011 */   // Label 8574: @514011
     /*  514011 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(514079), // Rule ID 62434 //
     /*  514016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  514019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514048 */     // MIs[0] policy
     /*  514048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514058 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  514061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514075 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514077 */     GIR_RootConstrainSelectedInstOperands,
     /*  514078 */     // GIR_Coverage, 62434,
     /*  514078 */     GIR_EraseRootFromParent_Done,
     /*  514079 */   // Label 8575: @514079
     /*  514079 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(514147), // Rule ID 62435 //
     /*  514084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  514087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514116 */     // MIs[0] policy
     /*  514116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514126 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  514129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514143 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514145 */     GIR_RootConstrainSelectedInstOperands,
     /*  514146 */     // GIR_Coverage, 62435,
     /*  514146 */     GIR_EraseRootFromParent_Done,
     /*  514147 */   // Label 8576: @514147
     /*  514147 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(514218), // Rule ID 2710 //
     /*  514152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514184 */     // MIs[0] round
     /*  514184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514194 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  514197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514203 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514216 */     GIR_RootConstrainSelectedInstOperands,
     /*  514217 */     // GIR_Coverage, 2710,
     /*  514217 */     GIR_EraseRootFromParent_Done,
     /*  514218 */   // Label 8577: @514218
     /*  514218 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(514289), // Rule ID 2711 //
     /*  514223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514255 */     // MIs[0] round
     /*  514255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514265 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  514268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514274 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514287 */     GIR_RootConstrainSelectedInstOperands,
     /*  514288 */     // GIR_Coverage, 2711,
     /*  514288 */     GIR_EraseRootFromParent_Done,
     /*  514289 */   // Label 8578: @514289
     /*  514289 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(514360), // Rule ID 2746 //
     /*  514294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  514297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  514302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514326 */     // MIs[0] round
     /*  514326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514336 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  514339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514345 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514358 */     GIR_RootConstrainSelectedInstOperands,
     /*  514359 */     // GIR_Coverage, 2746,
     /*  514359 */     GIR_EraseRootFromParent_Done,
     /*  514360 */   // Label 8579: @514360
     /*  514360 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(514431), // Rule ID 2747 //
     /*  514365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  514368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  514373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514397 */     // MIs[0] round
     /*  514397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514407 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  514410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514416 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514429 */     GIR_RootConstrainSelectedInstOperands,
     /*  514430 */     // GIR_Coverage, 2747,
     /*  514430 */     GIR_EraseRootFromParent_Done,
     /*  514431 */   // Label 8580: @514431
     /*  514431 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(514502), // Rule ID 19004 //
     /*  514436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  514447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  514450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  514453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514468 */     // MIs[0] round
     /*  514468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514478 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  514481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514487 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514500 */     GIR_RootConstrainSelectedInstOperands,
     /*  514501 */     // GIR_Coverage, 19004,
     /*  514501 */     GIR_EraseRootFromParent_Done,
     /*  514502 */   // Label 8581: @514502
     /*  514502 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(514573), // Rule ID 19005 //
     /*  514507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  514518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  514521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  514524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514539 */     // MIs[0] round
     /*  514539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514549 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  514552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514558 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514571 */     GIR_RootConstrainSelectedInstOperands,
     /*  514572 */     // GIR_Coverage, 19005,
     /*  514572 */     GIR_EraseRootFromParent_Done,
     /*  514573 */   // Label 8582: @514573
     /*  514573 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(514644), // Rule ID 19008 //
     /*  514578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  514581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  514589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  514592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514610 */     // MIs[0] round
     /*  514610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514620 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  514620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  514623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514629 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514642 */     GIR_RootConstrainSelectedInstOperands,
     /*  514643 */     // GIR_Coverage, 19008,
     /*  514643 */     GIR_EraseRootFromParent_Done,
     /*  514644 */   // Label 8583: @514644
     /*  514644 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(514715), // Rule ID 19009 //
     /*  514649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  514652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  514660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  514663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514681 */     // MIs[0] round
     /*  514681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514691 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  514691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  514694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514700 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514713 */     GIR_RootConstrainSelectedInstOperands,
     /*  514714 */     // GIR_Coverage, 19009,
     /*  514714 */     GIR_EraseRootFromParent_Done,
     /*  514715 */   // Label 8584: @514715
     /*  514715 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(514786), // Rule ID 19012 //
     /*  514720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  514731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  514734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  514737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514752 */     // MIs[0] round
     /*  514752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514762 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  514765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514771 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514784 */     GIR_RootConstrainSelectedInstOperands,
     /*  514785 */     // GIR_Coverage, 19012,
     /*  514785 */     GIR_EraseRootFromParent_Done,
     /*  514786 */   // Label 8585: @514786
     /*  514786 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(514857), // Rule ID 19013 //
     /*  514791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  514802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  514805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  514808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514823 */     // MIs[0] round
     /*  514823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514833 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  514836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514842 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514855 */     GIR_RootConstrainSelectedInstOperands,
     /*  514856 */     // GIR_Coverage, 19013,
     /*  514856 */     GIR_EraseRootFromParent_Done,
     /*  514857 */   // Label 8586: @514857
     /*  514857 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(514928), // Rule ID 19016 //
     /*  514862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  514865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  514873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  514876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514894 */     // MIs[0] round
     /*  514894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514904 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  514904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  514907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514913 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514926 */     GIR_RootConstrainSelectedInstOperands,
     /*  514927 */     // GIR_Coverage, 19016,
     /*  514927 */     GIR_EraseRootFromParent_Done,
     /*  514928 */   // Label 8587: @514928
     /*  514928 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(514999), // Rule ID 19017 //
     /*  514933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  514936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  514944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  514947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514965 */     // MIs[0] round
     /*  514965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514975 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  514975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  514978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514984 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514997 */     GIR_RootConstrainSelectedInstOperands,
     /*  514998 */     // GIR_Coverage, 19017,
     /*  514998 */     GIR_EraseRootFromParent_Done,
     /*  514999 */   // Label 8588: @514999
     /*  514999 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(515070), // Rule ID 19020 //
     /*  515004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  515007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  515015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  515018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  515021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515036 */     // MIs[0] round
     /*  515036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515046 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  515046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  515049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515055 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515068 */     GIR_RootConstrainSelectedInstOperands,
     /*  515069 */     // GIR_Coverage, 19020,
     /*  515069 */     GIR_EraseRootFromParent_Done,
     /*  515070 */   // Label 8589: @515070
     /*  515070 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(515141), // Rule ID 19021 //
     /*  515075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  515078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  515086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  515089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  515092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515107 */     // MIs[0] round
     /*  515107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515117 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  515117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  515120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515126 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515139 */     GIR_RootConstrainSelectedInstOperands,
     /*  515140 */     // GIR_Coverage, 19021,
     /*  515140 */     GIR_EraseRootFromParent_Done,
     /*  515141 */   // Label 8590: @515141
     /*  515141 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(515212), // Rule ID 19024 //
     /*  515146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  515157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  515160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  515163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515178 */     // MIs[0] round
     /*  515178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515188 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  515191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515197 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515210 */     GIR_RootConstrainSelectedInstOperands,
     /*  515211 */     // GIR_Coverage, 19024,
     /*  515211 */     GIR_EraseRootFromParent_Done,
     /*  515212 */   // Label 8591: @515212
     /*  515212 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(515283), // Rule ID 19025 //
     /*  515217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  515228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  515231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  515234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515249 */     // MIs[0] round
     /*  515249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515259 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  515262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515268 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515281 */     GIR_RootConstrainSelectedInstOperands,
     /*  515282 */     // GIR_Coverage, 19025,
     /*  515282 */     GIR_EraseRootFromParent_Done,
     /*  515283 */   // Label 8592: @515283
     /*  515283 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(515354), // Rule ID 19028 //
     /*  515288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  515299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  515302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  515305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515320 */     // MIs[0] round
     /*  515320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515330 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  515333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515339 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515352 */     GIR_RootConstrainSelectedInstOperands,
     /*  515353 */     // GIR_Coverage, 19028,
     /*  515353 */     GIR_EraseRootFromParent_Done,
     /*  515354 */   // Label 8593: @515354
     /*  515354 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(515425), // Rule ID 19029 //
     /*  515359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  515370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  515373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  515376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515391 */     // MIs[0] round
     /*  515391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515401 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  515404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515410 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515423 */     GIR_RootConstrainSelectedInstOperands,
     /*  515424 */     // GIR_Coverage, 19029,
     /*  515424 */     GIR_EraseRootFromParent_Done,
     /*  515425 */   // Label 8594: @515425
     /*  515425 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(515496), // Rule ID 19032 //
     /*  515430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  515441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  515444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  515447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515462 */     // MIs[0] round
     /*  515462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515472 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11289:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  515475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515481 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515494 */     GIR_RootConstrainSelectedInstOperands,
     /*  515495 */     // GIR_Coverage, 19032,
     /*  515495 */     GIR_EraseRootFromParent_Done,
     /*  515496 */   // Label 8595: @515496
     /*  515496 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(515567), // Rule ID 19033 //
     /*  515501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  515512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  515515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  515518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515533 */     // MIs[0] round
     /*  515533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515543 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11289:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  515546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515552 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515565 */     GIR_RootConstrainSelectedInstOperands,
     /*  515566 */     // GIR_Coverage, 19033,
     /*  515566 */     GIR_EraseRootFromParent_Done,
     /*  515567 */   // Label 8596: @515567
     /*  515567 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(515638), // Rule ID 19036 //
     /*  515572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  515575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  515583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  515586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515604 */     // MIs[0] round
     /*  515604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515614 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  515614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  515617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515623 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515636 */     GIR_RootConstrainSelectedInstOperands,
     /*  515637 */     // GIR_Coverage, 19036,
     /*  515637 */     GIR_EraseRootFromParent_Done,
     /*  515638 */   // Label 8597: @515638
     /*  515638 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(515709), // Rule ID 19037 //
     /*  515643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  515646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  515654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  515657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515675 */     // MIs[0] round
     /*  515675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515685 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  515685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  515688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515694 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515707 */     GIR_RootConstrainSelectedInstOperands,
     /*  515708 */     // GIR_Coverage, 19037,
     /*  515708 */     GIR_EraseRootFromParent_Done,
     /*  515709 */   // Label 8598: @515709
     /*  515709 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(515780), // Rule ID 19040 //
     /*  515714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  515717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  515725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  515728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515746 */     // MIs[0] round
     /*  515746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515756 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  515756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  515759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515765 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515778 */     GIR_RootConstrainSelectedInstOperands,
     /*  515779 */     // GIR_Coverage, 19040,
     /*  515779 */     GIR_EraseRootFromParent_Done,
     /*  515780 */   // Label 8599: @515780
     /*  515780 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(515851), // Rule ID 19041 //
     /*  515785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  515788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  515796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  515799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515817 */     // MIs[0] round
     /*  515817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515827 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  515827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  515830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515836 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515849 */     GIR_RootConstrainSelectedInstOperands,
     /*  515850 */     // GIR_Coverage, 19041,
     /*  515850 */     GIR_EraseRootFromParent_Done,
     /*  515851 */   // Label 8600: @515851
     /*  515851 */   GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(515922), // Rule ID 19044 //
     /*  515856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  515859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  515873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515888 */     // MIs[0] round
     /*  515888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515898 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11289:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  515898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  515901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515907 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515920 */     GIR_RootConstrainSelectedInstOperands,
     /*  515921 */     // GIR_Coverage, 19044,
     /*  515921 */     GIR_EraseRootFromParent_Done,
     /*  515922 */   // Label 8601: @515922
     /*  515922 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(515993), // Rule ID 19045 //
     /*  515927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  515930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  515944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515959 */     // MIs[0] round
     /*  515959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515969 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11289:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  515969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  515972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515978 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515991 */     GIR_RootConstrainSelectedInstOperands,
     /*  515992 */     // GIR_Coverage, 19045,
     /*  515992 */     GIR_EraseRootFromParent_Done,
     /*  515993 */   // Label 8602: @515993
     /*  515993 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(516064), // Rule ID 19048 //
     /*  515998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  516001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  516009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  516012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  516015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516030 */     // MIs[0] round
     /*  516030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516040 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  516040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  516043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516049 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516062 */     GIR_RootConstrainSelectedInstOperands,
     /*  516063 */     // GIR_Coverage, 19048,
     /*  516063 */     GIR_EraseRootFromParent_Done,
     /*  516064 */   // Label 8603: @516064
     /*  516064 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(516135), // Rule ID 19049 //
     /*  516069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  516072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  516080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  516083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  516086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516101 */     // MIs[0] round
     /*  516101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516111 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  516111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  516114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516120 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516133 */     GIR_RootConstrainSelectedInstOperands,
     /*  516134 */     // GIR_Coverage, 19049,
     /*  516134 */     GIR_EraseRootFromParent_Done,
     /*  516135 */   // Label 8604: @516135
     /*  516135 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(516206), // Rule ID 19052 //
     /*  516140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  516143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  516151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  516154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  516157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516172 */     // MIs[0] round
     /*  516172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516182 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  516182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  516185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516191 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516204 */     GIR_RootConstrainSelectedInstOperands,
     /*  516205 */     // GIR_Coverage, 19052,
     /*  516205 */     GIR_EraseRootFromParent_Done,
     /*  516206 */   // Label 8605: @516206
     /*  516206 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(516277), // Rule ID 19053 //
     /*  516211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  516214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  516222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  516225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  516228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516243 */     // MIs[0] round
     /*  516243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516253 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  516253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  516256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516262 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516275 */     GIR_RootConstrainSelectedInstOperands,
     /*  516276 */     // GIR_Coverage, 19053,
     /*  516276 */     GIR_EraseRootFromParent_Done,
     /*  516277 */   // Label 8606: @516277
     /*  516277 */   GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(516348), // Rule ID 19056 //
     /*  516282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  516285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  516293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  516296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  516299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516314 */     // MIs[0] round
     /*  516314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516324 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11289:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  516324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  516327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516333 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516346 */     GIR_RootConstrainSelectedInstOperands,
     /*  516347 */     // GIR_Coverage, 19056,
     /*  516347 */     GIR_EraseRootFromParent_Done,
     /*  516348 */   // Label 8607: @516348
     /*  516348 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(516419), // Rule ID 19057 //
     /*  516353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  516356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  516364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  516367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  516370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516385 */     // MIs[0] round
     /*  516385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516395 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11289:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  516395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  516398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516404 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516417 */     GIR_RootConstrainSelectedInstOperands,
     /*  516418 */     // GIR_Coverage, 19057,
     /*  516418 */     GIR_EraseRootFromParent_Done,
     /*  516419 */   // Label 8608: @516419
     /*  516419 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(516490), // Rule ID 19116 //
     /*  516424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  516427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  516435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  516438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  516441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516456 */     // MIs[0] round
     /*  516456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516466 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  516466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  516469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516475 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516488 */     GIR_RootConstrainSelectedInstOperands,
     /*  516489 */     // GIR_Coverage, 19116,
     /*  516489 */     GIR_EraseRootFromParent_Done,
     /*  516490 */   // Label 8609: @516490
     /*  516490 */   GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(516561), // Rule ID 19117 //
     /*  516495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  516498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  516506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  516509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  516512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516527 */     // MIs[0] round
     /*  516527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516537 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  516537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  516540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516546 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516559 */     GIR_RootConstrainSelectedInstOperands,
     /*  516560 */     // GIR_Coverage, 19117,
     /*  516560 */     GIR_EraseRootFromParent_Done,
     /*  516561 */   // Label 8610: @516561
     /*  516561 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(516632), // Rule ID 19120 //
     /*  516566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  516569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  516577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  516580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  516583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516598 */     // MIs[0] round
     /*  516598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516608 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  516608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  516611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516617 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516630 */     GIR_RootConstrainSelectedInstOperands,
     /*  516631 */     // GIR_Coverage, 19120,
     /*  516631 */     GIR_EraseRootFromParent_Done,
     /*  516632 */   // Label 8611: @516632
     /*  516632 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(516703), // Rule ID 19121 //
     /*  516637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  516640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  516648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  516651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  516654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516669 */     // MIs[0] round
     /*  516669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516679 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  516679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  516682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516688 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516701 */     GIR_RootConstrainSelectedInstOperands,
     /*  516702 */     // GIR_Coverage, 19121,
     /*  516702 */     GIR_EraseRootFromParent_Done,
     /*  516703 */   // Label 8612: @516703
     /*  516703 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(516774), // Rule ID 19124 //
     /*  516708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  516711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  516719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  516722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516740 */     // MIs[0] round
     /*  516740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516750 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  516750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  516753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516759 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516772 */     GIR_RootConstrainSelectedInstOperands,
     /*  516773 */     // GIR_Coverage, 19124,
     /*  516773 */     GIR_EraseRootFromParent_Done,
     /*  516774 */   // Label 8613: @516774
     /*  516774 */   GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(516845), // Rule ID 19125 //
     /*  516779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  516782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  516790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  516793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516811 */     // MIs[0] round
     /*  516811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516821 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  516821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  516824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516830 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516843 */     GIR_RootConstrainSelectedInstOperands,
     /*  516844 */     // GIR_Coverage, 19125,
     /*  516844 */     GIR_EraseRootFromParent_Done,
     /*  516845 */   // Label 8614: @516845
     /*  516845 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(516916), // Rule ID 19128 //
     /*  516850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  516853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  516861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  516864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  516867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516882 */     // MIs[0] round
     /*  516882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516892 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  516892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  516895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516901 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516914 */     GIR_RootConstrainSelectedInstOperands,
     /*  516915 */     // GIR_Coverage, 19128,
     /*  516915 */     GIR_EraseRootFromParent_Done,
     /*  516916 */   // Label 8615: @516916
     /*  516916 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(516987), // Rule ID 19129 //
     /*  516921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  516924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  516932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  516935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  516938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516953 */     // MIs[0] round
     /*  516953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516963 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  516963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  516966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516972 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516985 */     GIR_RootConstrainSelectedInstOperands,
     /*  516986 */     // GIR_Coverage, 19129,
     /*  516986 */     GIR_EraseRootFromParent_Done,
     /*  516987 */   // Label 8616: @516987
     /*  516987 */   GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(517058), // Rule ID 19132 //
     /*  516992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  516995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  517003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  517006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517024 */     // MIs[0] round
     /*  517024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517034 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  517034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  517037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517043 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517056 */     GIR_RootConstrainSelectedInstOperands,
     /*  517057 */     // GIR_Coverage, 19132,
     /*  517057 */     GIR_EraseRootFromParent_Done,
     /*  517058 */   // Label 8617: @517058
     /*  517058 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(517129), // Rule ID 19133 //
     /*  517063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  517066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  517074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  517077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517095 */     // MIs[0] round
     /*  517095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517105 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  517105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  517108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517114 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517127 */     GIR_RootConstrainSelectedInstOperands,
     /*  517128 */     // GIR_Coverage, 19133,
     /*  517128 */     GIR_EraseRootFromParent_Done,
     /*  517129 */   // Label 8618: @517129
     /*  517129 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(517200), // Rule ID 19136 //
     /*  517134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  517137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  517145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  517148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  517151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517166 */     // MIs[0] round
     /*  517166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517176 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  517176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  517179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517185 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517198 */     GIR_RootConstrainSelectedInstOperands,
     /*  517199 */     // GIR_Coverage, 19136,
     /*  517199 */     GIR_EraseRootFromParent_Done,
     /*  517200 */   // Label 8619: @517200
     /*  517200 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(517271), // Rule ID 19137 //
     /*  517205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  517208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  517216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  517219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  517222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517237 */     // MIs[0] round
     /*  517237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517247 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  517247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  517250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517256 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517269 */     GIR_RootConstrainSelectedInstOperands,
     /*  517270 */     // GIR_Coverage, 19137,
     /*  517270 */     GIR_EraseRootFromParent_Done,
     /*  517271 */   // Label 8620: @517271
     /*  517271 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(517342), // Rule ID 19140 //
     /*  517276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  517287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  517290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  517293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517308 */     // MIs[0] round
     /*  517308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517318 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  517321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517327 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517340 */     GIR_RootConstrainSelectedInstOperands,
     /*  517341 */     // GIR_Coverage, 19140,
     /*  517341 */     GIR_EraseRootFromParent_Done,
     /*  517342 */   // Label 8621: @517342
     /*  517342 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(517413), // Rule ID 19141 //
     /*  517347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  517358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  517361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  517364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517379 */     // MIs[0] round
     /*  517379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517389 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  517392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517398 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517411 */     GIR_RootConstrainSelectedInstOperands,
     /*  517412 */     // GIR_Coverage, 19141,
     /*  517412 */     GIR_EraseRootFromParent_Done,
     /*  517413 */   // Label 8622: @517413
     /*  517413 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(517484), // Rule ID 19144 //
     /*  517418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  517429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  517432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  517435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517450 */     // MIs[0] round
     /*  517450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517460 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  517463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517469 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517482 */     GIR_RootConstrainSelectedInstOperands,
     /*  517483 */     // GIR_Coverage, 19144,
     /*  517483 */     GIR_EraseRootFromParent_Done,
     /*  517484 */   // Label 8623: @517484
     /*  517484 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(517555), // Rule ID 19145 //
     /*  517489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  517500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  517503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  517506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517521 */     // MIs[0] round
     /*  517521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517531 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  517534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517540 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517553 */     GIR_RootConstrainSelectedInstOperands,
     /*  517554 */     // GIR_Coverage, 19145,
     /*  517554 */     GIR_EraseRootFromParent_Done,
     /*  517555 */   // Label 8624: @517555
     /*  517555 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(517626), // Rule ID 19148 //
     /*  517560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  517571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  517574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  517577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517592 */     // MIs[0] round
     /*  517592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517602 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  517605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517611 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517624 */     GIR_RootConstrainSelectedInstOperands,
     /*  517625 */     // GIR_Coverage, 19148,
     /*  517625 */     GIR_EraseRootFromParent_Done,
     /*  517626 */   // Label 8625: @517626
     /*  517626 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(517697), // Rule ID 19149 //
     /*  517631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  517642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  517645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  517648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517663 */     // MIs[0] round
     /*  517663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517673 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  517676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517682 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517695 */     GIR_RootConstrainSelectedInstOperands,
     /*  517696 */     // GIR_Coverage, 19149,
     /*  517696 */     GIR_EraseRootFromParent_Done,
     /*  517697 */   // Label 8626: @517697
     /*  517697 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(517768), // Rule ID 19152 //
     /*  517702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  517705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  517713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  517716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517734 */     // MIs[0] round
     /*  517734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517744 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  517744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  517747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517753 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517766 */     GIR_RootConstrainSelectedInstOperands,
     /*  517767 */     // GIR_Coverage, 19152,
     /*  517767 */     GIR_EraseRootFromParent_Done,
     /*  517768 */   // Label 8627: @517768
     /*  517768 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(517839), // Rule ID 19153 //
     /*  517773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  517776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  517784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  517787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517805 */     // MIs[0] round
     /*  517805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517815 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  517815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  517818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517824 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517837 */     GIR_RootConstrainSelectedInstOperands,
     /*  517838 */     // GIR_Coverage, 19153,
     /*  517838 */     GIR_EraseRootFromParent_Done,
     /*  517839 */   // Label 8628: @517839
     /*  517839 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(517910), // Rule ID 19156 //
     /*  517844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  517847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517876 */     // MIs[0] round
     /*  517876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517886 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  517886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  517889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517895 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517908 */     GIR_RootConstrainSelectedInstOperands,
     /*  517909 */     // GIR_Coverage, 19156,
     /*  517909 */     GIR_EraseRootFromParent_Done,
     /*  517910 */   // Label 8629: @517910
     /*  517910 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(517981), // Rule ID 19157 //
     /*  517915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  517918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517947 */     // MIs[0] round
     /*  517947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517957 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  517957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  517960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517966 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517979 */     GIR_RootConstrainSelectedInstOperands,
     /*  517980 */     // GIR_Coverage, 19157,
     /*  517980 */     GIR_EraseRootFromParent_Done,
     /*  517981 */   // Label 8630: @517981
     /*  517981 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(518052), // Rule ID 19160 //
     /*  517986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  517989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  518000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  518003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518018 */     // MIs[0] round
     /*  518018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518028 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  518031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518037 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518050 */     GIR_RootConstrainSelectedInstOperands,
     /*  518051 */     // GIR_Coverage, 19160,
     /*  518051 */     GIR_EraseRootFromParent_Done,
     /*  518052 */   // Label 8631: @518052
     /*  518052 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(518123), // Rule ID 19161 //
     /*  518057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  518060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  518068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  518071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  518074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518089 */     // MIs[0] round
     /*  518089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518099 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  518102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518108 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518121 */     GIR_RootConstrainSelectedInstOperands,
     /*  518122 */     // GIR_Coverage, 19161,
     /*  518122 */     GIR_EraseRootFromParent_Done,
     /*  518123 */   // Label 8632: @518123
     /*  518123 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(518194), // Rule ID 19164 //
     /*  518128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  518139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  518142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  518145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518160 */     // MIs[0] round
     /*  518160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518170 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  518173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518179 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518192 */     GIR_RootConstrainSelectedInstOperands,
     /*  518193 */     // GIR_Coverage, 19164,
     /*  518193 */     GIR_EraseRootFromParent_Done,
     /*  518194 */   // Label 8633: @518194
     /*  518194 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(518265), // Rule ID 19165 //
     /*  518199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  518210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  518213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  518216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518231 */     // MIs[0] round
     /*  518231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518241 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  518244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518250 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518263 */     GIR_RootConstrainSelectedInstOperands,
     /*  518264 */     // GIR_Coverage, 19165,
     /*  518264 */     GIR_EraseRootFromParent_Done,
     /*  518265 */   // Label 8634: @518265
     /*  518265 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(518336), // Rule ID 19168 //
     /*  518270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  518281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  518284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  518287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518302 */     // MIs[0] round
     /*  518302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518312 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  518315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518321 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518334 */     GIR_RootConstrainSelectedInstOperands,
     /*  518335 */     // GIR_Coverage, 19168,
     /*  518335 */     GIR_EraseRootFromParent_Done,
     /*  518336 */   // Label 8635: @518336
     /*  518336 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(518407), // Rule ID 19169 //
     /*  518341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  518352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  518355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  518358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518373 */     // MIs[0] round
     /*  518373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518383 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  518386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518392 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518405 */     GIR_RootConstrainSelectedInstOperands,
     /*  518406 */     // GIR_Coverage, 19169,
     /*  518406 */     GIR_EraseRootFromParent_Done,
     /*  518407 */   // Label 8636: @518407
     /*  518407 */   GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(518478), // Rule ID 19172 //
     /*  518412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  518423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  518426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  518429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518444 */     // MIs[0] round
     /*  518444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518454 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  518457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518463 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518476 */     GIR_RootConstrainSelectedInstOperands,
     /*  518477 */     // GIR_Coverage, 19172,
     /*  518477 */     GIR_EraseRootFromParent_Done,
     /*  518478 */   // Label 8637: @518478
     /*  518478 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(518549), // Rule ID 19173 //
     /*  518483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  518494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  518497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  518500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518515 */     // MIs[0] round
     /*  518515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518525 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  518528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518534 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518547 */     GIR_RootConstrainSelectedInstOperands,
     /*  518548 */     // GIR_Coverage, 19173,
     /*  518548 */     GIR_EraseRootFromParent_Done,
     /*  518549 */   // Label 8638: @518549
     /*  518549 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(518620), // Rule ID 20758 //
     /*  518554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  518557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  518565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  518568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  518571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518586 */     // MIs[0] round
     /*  518586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518596 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  518599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518605 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518618 */     GIR_RootConstrainSelectedInstOperands,
     /*  518619 */     // GIR_Coverage, 20758,
     /*  518619 */     GIR_EraseRootFromParent_Done,
     /*  518620 */   // Label 8639: @518620
     /*  518620 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(518691), // Rule ID 20759 //
     /*  518625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  518628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  518636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  518639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  518642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518657 */     // MIs[0] round
     /*  518657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518667 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  518670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518676 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518689 */     GIR_RootConstrainSelectedInstOperands,
     /*  518690 */     // GIR_Coverage, 20759,
     /*  518690 */     GIR_EraseRootFromParent_Done,
     /*  518691 */   // Label 8640: @518691
     /*  518691 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(518762), // Rule ID 20762 //
     /*  518696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  518699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  518707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  518710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  518713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518728 */     // MIs[0] round
     /*  518728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518738 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  518741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518747 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518760 */     GIR_RootConstrainSelectedInstOperands,
     /*  518761 */     // GIR_Coverage, 20762,
     /*  518761 */     GIR_EraseRootFromParent_Done,
     /*  518762 */   // Label 8641: @518762
     /*  518762 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(518833), // Rule ID 20763 //
     /*  518767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  518770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  518778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  518781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  518784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518799 */     // MIs[0] round
     /*  518799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518809 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  518812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518818 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518831 */     GIR_RootConstrainSelectedInstOperands,
     /*  518832 */     // GIR_Coverage, 20763,
     /*  518832 */     GIR_EraseRootFromParent_Done,
     /*  518833 */   // Label 8642: @518833
     /*  518833 */   GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(518904), // Rule ID 20766 //
     /*  518838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  518841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  518849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  518852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  518855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518870 */     // MIs[0] round
     /*  518870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518880 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  518883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518889 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518902 */     GIR_RootConstrainSelectedInstOperands,
     /*  518903 */     // GIR_Coverage, 20766,
     /*  518903 */     GIR_EraseRootFromParent_Done,
     /*  518904 */   // Label 8643: @518904
     /*  518904 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(518975), // Rule ID 20767 //
     /*  518909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  518912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  518920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  518923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  518926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518941 */     // MIs[0] round
     /*  518941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518951 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  518954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518960 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518973 */     GIR_RootConstrainSelectedInstOperands,
     /*  518974 */     // GIR_Coverage, 20767,
     /*  518974 */     GIR_EraseRootFromParent_Done,
     /*  518975 */   // Label 8644: @518975
     /*  518975 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(519046), // Rule ID 20770 //
     /*  518980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  518983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  518991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  518994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  518997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519012 */     // MIs[0] round
     /*  519012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519022 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519031 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519044 */     GIR_RootConstrainSelectedInstOperands,
     /*  519045 */     // GIR_Coverage, 20770,
     /*  519045 */     GIR_EraseRootFromParent_Done,
     /*  519046 */   // Label 8645: @519046
     /*  519046 */   GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(519117), // Rule ID 20771 //
     /*  519051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  519054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  519062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  519065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  519068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519083 */     // MIs[0] round
     /*  519083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519093 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519102 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519115 */     GIR_RootConstrainSelectedInstOperands,
     /*  519116 */     // GIR_Coverage, 20771,
     /*  519116 */     GIR_EraseRootFromParent_Done,
     /*  519117 */   // Label 8646: @519117
     /*  519117 */   GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(519188), // Rule ID 20774 //
     /*  519122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  519125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  519133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  519136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  519139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519154 */     // MIs[0] round
     /*  519154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519164 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  519164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519173 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519186 */     GIR_RootConstrainSelectedInstOperands,
     /*  519187 */     // GIR_Coverage, 20774,
     /*  519187 */     GIR_EraseRootFromParent_Done,
     /*  519188 */   // Label 8647: @519188
     /*  519188 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(519259), // Rule ID 20775 //
     /*  519193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  519196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  519204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  519207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  519210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519225 */     // MIs[0] round
     /*  519225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519235 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  519235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519244 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519257 */     GIR_RootConstrainSelectedInstOperands,
     /*  519258 */     // GIR_Coverage, 20775,
     /*  519258 */     GIR_EraseRootFromParent_Done,
     /*  519259 */   // Label 8648: @519259
     /*  519259 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(519330), // Rule ID 20778 //
     /*  519264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  519275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  519278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  519281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519296 */     // MIs[0] round
     /*  519296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519315 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519328 */     GIR_RootConstrainSelectedInstOperands,
     /*  519329 */     // GIR_Coverage, 20778,
     /*  519329 */     GIR_EraseRootFromParent_Done,
     /*  519330 */   // Label 8649: @519330
     /*  519330 */   GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(519401), // Rule ID 20779 //
     /*  519335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  519346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  519349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  519352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519367 */     // MIs[0] round
     /*  519367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519377 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519386 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519399 */     GIR_RootConstrainSelectedInstOperands,
     /*  519400 */     // GIR_Coverage, 20779,
     /*  519400 */     GIR_EraseRootFromParent_Done,
     /*  519401 */   // Label 8650: @519401
     /*  519401 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(519472), // Rule ID 20782 //
     /*  519406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  519417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  519423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519438 */     // MIs[0] round
     /*  519438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519448 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519457 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519470 */     GIR_RootConstrainSelectedInstOperands,
     /*  519471 */     // GIR_Coverage, 20782,
     /*  519471 */     GIR_EraseRootFromParent_Done,
     /*  519472 */   // Label 8651: @519472
     /*  519472 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(519543), // Rule ID 20783 //
     /*  519477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  519488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  519494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519509 */     // MIs[0] round
     /*  519509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519519 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519528 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519541 */     GIR_RootConstrainSelectedInstOperands,
     /*  519542 */     // GIR_Coverage, 20783,
     /*  519542 */     GIR_EraseRootFromParent_Done,
     /*  519543 */   // Label 8652: @519543
     /*  519543 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(519614), // Rule ID 20786 //
     /*  519548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  519559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  519562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  519565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519580 */     // MIs[0] round
     /*  519580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519590 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  519593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519599 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519612 */     GIR_RootConstrainSelectedInstOperands,
     /*  519613 */     // GIR_Coverage, 20786,
     /*  519613 */     GIR_EraseRootFromParent_Done,
     /*  519614 */   // Label 8653: @519614
     /*  519614 */   GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(519685), // Rule ID 20787 //
     /*  519619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  519630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  519633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  519636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519651 */     // MIs[0] round
     /*  519651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519661 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  519664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519670 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519683 */     GIR_RootConstrainSelectedInstOperands,
     /*  519684 */     // GIR_Coverage, 20787,
     /*  519684 */     GIR_EraseRootFromParent_Done,
     /*  519685 */   // Label 8654: @519685
     /*  519685 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(519756), // Rule ID 20790 //
     /*  519690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  519693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  519701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  519704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  519707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519722 */     // MIs[0] round
     /*  519722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519741 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519754 */     GIR_RootConstrainSelectedInstOperands,
     /*  519755 */     // GIR_Coverage, 20790,
     /*  519755 */     GIR_EraseRootFromParent_Done,
     /*  519756 */   // Label 8655: @519756
     /*  519756 */   GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(519827), // Rule ID 20791 //
     /*  519761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  519764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  519772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  519775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  519778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519793 */     // MIs[0] round
     /*  519793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519812 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519825 */     GIR_RootConstrainSelectedInstOperands,
     /*  519826 */     // GIR_Coverage, 20791,
     /*  519826 */     GIR_EraseRootFromParent_Done,
     /*  519827 */   // Label 8656: @519827
     /*  519827 */   GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(519898), // Rule ID 20794 //
     /*  519832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  519835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  519843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  519846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  519849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519864 */     // MIs[0] round
     /*  519864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519874 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519883 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519896 */     GIR_RootConstrainSelectedInstOperands,
     /*  519897 */     // GIR_Coverage, 20794,
     /*  519897 */     GIR_EraseRootFromParent_Done,
     /*  519898 */   // Label 8657: @519898
     /*  519898 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(519969), // Rule ID 20795 //
     /*  519903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  519906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  519914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  519917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  519920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519935 */     // MIs[0] round
     /*  519935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519945 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519954 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519967 */     GIR_RootConstrainSelectedInstOperands,
     /*  519968 */     // GIR_Coverage, 20795,
     /*  519968 */     GIR_EraseRootFromParent_Done,
     /*  519969 */   // Label 8658: @519969
     /*  519969 */   GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(520040), // Rule ID 20798 //
     /*  519974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  519977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  519985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  519988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  519991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520006 */     // MIs[0] round
     /*  520006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520025 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520038 */     GIR_RootConstrainSelectedInstOperands,
     /*  520039 */     // GIR_Coverage, 20798,
     /*  520039 */     GIR_EraseRootFromParent_Done,
     /*  520040 */   // Label 8659: @520040
     /*  520040 */   GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(520111), // Rule ID 20799 //
     /*  520045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  520048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  520056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  520059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  520062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520077 */     // MIs[0] round
     /*  520077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520087 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520096 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520109 */     GIR_RootConstrainSelectedInstOperands,
     /*  520110 */     // GIR_Coverage, 20799,
     /*  520110 */     GIR_EraseRootFromParent_Done,
     /*  520111 */   // Label 8660: @520111
     /*  520111 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(520182), // Rule ID 20802 //
     /*  520116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  520119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  520127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  520130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  520133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520148 */     // MIs[0] round
     /*  520148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520158 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  520161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520167 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520180 */     GIR_RootConstrainSelectedInstOperands,
     /*  520181 */     // GIR_Coverage, 20802,
     /*  520181 */     GIR_EraseRootFromParent_Done,
     /*  520182 */   // Label 8661: @520182
     /*  520182 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(520253), // Rule ID 20803 //
     /*  520187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  520190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  520198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  520201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  520204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520219 */     // MIs[0] round
     /*  520219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520229 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  520232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520238 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520251 */     GIR_RootConstrainSelectedInstOperands,
     /*  520252 */     // GIR_Coverage, 20803,
     /*  520252 */     GIR_EraseRootFromParent_Done,
     /*  520253 */   // Label 8662: @520253
     /*  520253 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(520324), // Rule ID 20806 //
     /*  520258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  520261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  520269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  520272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  520275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520290 */     // MIs[0] round
     /*  520290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520300 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  520303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520309 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520322 */     GIR_RootConstrainSelectedInstOperands,
     /*  520323 */     // GIR_Coverage, 20806,
     /*  520323 */     GIR_EraseRootFromParent_Done,
     /*  520324 */   // Label 8663: @520324
     /*  520324 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(520395), // Rule ID 20807 //
     /*  520329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  520332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  520340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  520343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  520346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520361 */     // MIs[0] round
     /*  520361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520371 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  520374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520380 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520393 */     GIR_RootConstrainSelectedInstOperands,
     /*  520394 */     // GIR_Coverage, 20807,
     /*  520394 */     GIR_EraseRootFromParent_Done,
     /*  520395 */   // Label 8664: @520395
     /*  520395 */   GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(520466), // Rule ID 20810 //
     /*  520400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  520403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  520411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  520417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520432 */     // MIs[0] round
     /*  520432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520442 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520451 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520464 */     GIR_RootConstrainSelectedInstOperands,
     /*  520465 */     // GIR_Coverage, 20810,
     /*  520465 */     GIR_EraseRootFromParent_Done,
     /*  520466 */   // Label 8665: @520466
     /*  520466 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(520537), // Rule ID 20811 //
     /*  520471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  520474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  520482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  520488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520503 */     // MIs[0] round
     /*  520503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520513 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520522 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520535 */     GIR_RootConstrainSelectedInstOperands,
     /*  520536 */     // GIR_Coverage, 20811,
     /*  520536 */     GIR_EraseRootFromParent_Done,
     /*  520537 */   // Label 8666: @520537
     /*  520537 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(520608), // Rule ID 20814 //
     /*  520542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  520545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  520553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  520556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  520559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520574 */     // MIs[0] round
     /*  520574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520584 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  520587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520593 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520606 */     GIR_RootConstrainSelectedInstOperands,
     /*  520607 */     // GIR_Coverage, 20814,
     /*  520607 */     GIR_EraseRootFromParent_Done,
     /*  520608 */   // Label 8667: @520608
     /*  520608 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(520679), // Rule ID 20815 //
     /*  520613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  520616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  520624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  520627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  520630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520645 */     // MIs[0] round
     /*  520645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520655 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  520658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520664 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520677 */     GIR_RootConstrainSelectedInstOperands,
     /*  520678 */     // GIR_Coverage, 20815,
     /*  520678 */     GIR_EraseRootFromParent_Done,
     /*  520679 */   // Label 8668: @520679
     /*  520679 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(520750), // Rule ID 20818 //
     /*  520684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  520687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  520695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  520698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  520701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520716 */     // MIs[0] round
     /*  520716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  520729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520735 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520748 */     GIR_RootConstrainSelectedInstOperands,
     /*  520749 */     // GIR_Coverage, 20818,
     /*  520749 */     GIR_EraseRootFromParent_Done,
     /*  520750 */   // Label 8669: @520750
     /*  520750 */   GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(520821), // Rule ID 20819 //
     /*  520755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  520758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  520766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  520769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  520772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520787 */     // MIs[0] round
     /*  520787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520797 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  520800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520806 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520819 */     GIR_RootConstrainSelectedInstOperands,
     /*  520820 */     // GIR_Coverage, 20819,
     /*  520820 */     GIR_EraseRootFromParent_Done,
     /*  520821 */   // Label 8670: @520821
     /*  520821 */   GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(520892), // Rule ID 20822 //
     /*  520826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  520829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  520837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  520840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  520843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520858 */     // MIs[0] round
     /*  520858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  520871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520877 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520890 */     GIR_RootConstrainSelectedInstOperands,
     /*  520891 */     // GIR_Coverage, 20822,
     /*  520891 */     GIR_EraseRootFromParent_Done,
     /*  520892 */   // Label 8671: @520892
     /*  520892 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(520963), // Rule ID 20823 //
     /*  520897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  520900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  520908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  520911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  520914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520929 */     // MIs[0] round
     /*  520929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520939 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  520942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520948 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520961 */     GIR_RootConstrainSelectedInstOperands,
     /*  520962 */     // GIR_Coverage, 20823,
     /*  520962 */     GIR_EraseRootFromParent_Done,
     /*  520963 */   // Label 8672: @520963
     /*  520963 */   GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(521034), // Rule ID 20826 //
     /*  520968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  520971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  520979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  520982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  520985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521000 */     // MIs[0] round
     /*  521000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521010 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521019 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521032 */     GIR_RootConstrainSelectedInstOperands,
     /*  521033 */     // GIR_Coverage, 20826,
     /*  521033 */     GIR_EraseRootFromParent_Done,
     /*  521034 */   // Label 8673: @521034
     /*  521034 */   GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(521105), // Rule ID 20827 //
     /*  521039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  521050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  521053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  521056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521071 */     // MIs[0] round
     /*  521071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521081 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521090 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521103 */     GIR_RootConstrainSelectedInstOperands,
     /*  521104 */     // GIR_Coverage, 20827,
     /*  521104 */     GIR_EraseRootFromParent_Done,
     /*  521105 */   // Label 8674: @521105
     /*  521105 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(521176), // Rule ID 20830 //
     /*  521110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  521113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  521121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  521124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  521127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521142 */     // MIs[0] round
     /*  521142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521161 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521174 */     GIR_RootConstrainSelectedInstOperands,
     /*  521175 */     // GIR_Coverage, 20830,
     /*  521175 */     GIR_EraseRootFromParent_Done,
     /*  521176 */   // Label 8675: @521176
     /*  521176 */   GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(521247), // Rule ID 20831 //
     /*  521181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  521184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  521192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  521195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  521198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521213 */     // MIs[0] round
     /*  521213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521223 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521232 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521245 */     GIR_RootConstrainSelectedInstOperands,
     /*  521246 */     // GIR_Coverage, 20831,
     /*  521246 */     GIR_EraseRootFromParent_Done,
     /*  521247 */   // Label 8676: @521247
     /*  521247 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(521318), // Rule ID 20834 //
     /*  521252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  521255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  521263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  521266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  521269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521284 */     // MIs[0] round
     /*  521284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521294 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  521294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521303 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521316 */     GIR_RootConstrainSelectedInstOperands,
     /*  521317 */     // GIR_Coverage, 20834,
     /*  521317 */     GIR_EraseRootFromParent_Done,
     /*  521318 */   // Label 8677: @521318
     /*  521318 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(521389), // Rule ID 20835 //
     /*  521323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  521326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  521334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  521337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  521340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521355 */     // MIs[0] round
     /*  521355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521365 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  521365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521374 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521387 */     GIR_RootConstrainSelectedInstOperands,
     /*  521388 */     // GIR_Coverage, 20835,
     /*  521388 */     GIR_EraseRootFromParent_Done,
     /*  521389 */   // Label 8678: @521389
     /*  521389 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(521460), // Rule ID 20838 //
     /*  521394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  521405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  521408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  521411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521426 */     // MIs[0] round
     /*  521426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521436 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521445 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521458 */     GIR_RootConstrainSelectedInstOperands,
     /*  521459 */     // GIR_Coverage, 20838,
     /*  521459 */     GIR_EraseRootFromParent_Done,
     /*  521460 */   // Label 8679: @521460
     /*  521460 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(521531), // Rule ID 20839 //
     /*  521465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  521476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  521479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  521482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521497 */     // MIs[0] round
     /*  521497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521507 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521516 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521529 */     GIR_RootConstrainSelectedInstOperands,
     /*  521530 */     // GIR_Coverage, 20839,
     /*  521530 */     GIR_EraseRootFromParent_Done,
     /*  521531 */   // Label 8680: @521531
     /*  521531 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(521602), // Rule ID 20842 //
     /*  521536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  521547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  521550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  521553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521568 */     // MIs[0] round
     /*  521568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521578 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  521581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521587 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521600 */     GIR_RootConstrainSelectedInstOperands,
     /*  521601 */     // GIR_Coverage, 20842,
     /*  521601 */     GIR_EraseRootFromParent_Done,
     /*  521602 */   // Label 8681: @521602
     /*  521602 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(521673), // Rule ID 20843 //
     /*  521607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  521618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  521621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  521624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521639 */     // MIs[0] round
     /*  521639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521649 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  521652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521658 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521671 */     GIR_RootConstrainSelectedInstOperands,
     /*  521672 */     // GIR_Coverage, 20843,
     /*  521672 */     GIR_EraseRootFromParent_Done,
     /*  521673 */   // Label 8682: @521673
     /*  521673 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(521744), // Rule ID 20846 //
     /*  521678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  521689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  521692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  521695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521710 */     // MIs[0] round
     /*  521710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521720 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  521723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521729 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521742 */     GIR_RootConstrainSelectedInstOperands,
     /*  521743 */     // GIR_Coverage, 20846,
     /*  521743 */     GIR_EraseRootFromParent_Done,
     /*  521744 */   // Label 8683: @521744
     /*  521744 */   GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(521815), // Rule ID 20847 //
     /*  521749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  521760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  521763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  521766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521781 */     // MIs[0] round
     /*  521781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521791 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  521794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521800 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521813 */     GIR_RootConstrainSelectedInstOperands,
     /*  521814 */     // GIR_Coverage, 20847,
     /*  521814 */     GIR_EraseRootFromParent_Done,
     /*  521815 */   // Label 8684: @521815
     /*  521815 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(521886), // Rule ID 20850 //
     /*  521820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  521823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  521831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  521834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  521837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521852 */     // MIs[0] round
     /*  521852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521871 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521884 */     GIR_RootConstrainSelectedInstOperands,
     /*  521885 */     // GIR_Coverage, 20850,
     /*  521885 */     GIR_EraseRootFromParent_Done,
     /*  521886 */   // Label 8685: @521886
     /*  521886 */   GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(521957), // Rule ID 20851 //
     /*  521891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  521894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  521902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  521905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  521908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521923 */     // MIs[0] round
     /*  521923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521933 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521942 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521955 */     GIR_RootConstrainSelectedInstOperands,
     /*  521956 */     // GIR_Coverage, 20851,
     /*  521956 */     GIR_EraseRootFromParent_Done,
     /*  521957 */   // Label 8686: @521957
     /*  521957 */   GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(522028), // Rule ID 20854 //
     /*  521962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  521965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  521973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  521976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  521979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521994 */     // MIs[0] round
     /*  521994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522004 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522013 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522026 */     GIR_RootConstrainSelectedInstOperands,
     /*  522027 */     // GIR_Coverage, 20854,
     /*  522027 */     GIR_EraseRootFromParent_Done,
     /*  522028 */   // Label 8687: @522028
     /*  522028 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(522099), // Rule ID 20855 //
     /*  522033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  522044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  522047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  522050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522065 */     // MIs[0] round
     /*  522065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522075 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522084 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522097 */     GIR_RootConstrainSelectedInstOperands,
     /*  522098 */     // GIR_Coverage, 20855,
     /*  522098 */     GIR_EraseRootFromParent_Done,
     /*  522099 */   // Label 8688: @522099
     /*  522099 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(522170), // Rule ID 20858 //
     /*  522104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  522115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  522118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  522121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522136 */     // MIs[0] round
     /*  522136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522146 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522155 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522168 */     GIR_RootConstrainSelectedInstOperands,
     /*  522169 */     // GIR_Coverage, 20858,
     /*  522169 */     GIR_EraseRootFromParent_Done,
     /*  522170 */   // Label 8689: @522170
     /*  522170 */   GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(522241), // Rule ID 20859 //
     /*  522175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  522186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  522189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  522192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522207 */     // MIs[0] round
     /*  522207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522217 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522226 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522239 */     GIR_RootConstrainSelectedInstOperands,
     /*  522240 */     // GIR_Coverage, 20859,
     /*  522240 */     GIR_EraseRootFromParent_Done,
     /*  522241 */   // Label 8690: @522241
     /*  522241 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(522312), // Rule ID 20862 //
     /*  522246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  522257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  522260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  522263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522278 */     // MIs[0] round
     /*  522278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522288 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  522291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522297 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522310 */     GIR_RootConstrainSelectedInstOperands,
     /*  522311 */     // GIR_Coverage, 20862,
     /*  522311 */     GIR_EraseRootFromParent_Done,
     /*  522312 */   // Label 8691: @522312
     /*  522312 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(522383), // Rule ID 20863 //
     /*  522317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  522320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  522328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  522331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  522334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522349 */     // MIs[0] round
     /*  522349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522359 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  522362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522368 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522381 */     GIR_RootConstrainSelectedInstOperands,
     /*  522382 */     // GIR_Coverage, 20863,
     /*  522382 */     GIR_EraseRootFromParent_Done,
     /*  522383 */   // Label 8692: @522383
     /*  522383 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(522454), // Rule ID 20866 //
     /*  522388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  522399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  522402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  522405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522420 */     // MIs[0] round
     /*  522420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522430 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522439 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522452 */     GIR_RootConstrainSelectedInstOperands,
     /*  522453 */     // GIR_Coverage, 20866,
     /*  522453 */     GIR_EraseRootFromParent_Done,
     /*  522454 */   // Label 8693: @522454
     /*  522454 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(522525), // Rule ID 20867 //
     /*  522459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  522462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  522470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  522473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  522476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522491 */     // MIs[0] round
     /*  522491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522501 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522510 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522523 */     GIR_RootConstrainSelectedInstOperands,
     /*  522524 */     // GIR_Coverage, 20867,
     /*  522524 */     GIR_EraseRootFromParent_Done,
     /*  522525 */   // Label 8694: @522525
     /*  522525 */   GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(522596), // Rule ID 20870 //
     /*  522530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  522541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  522544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  522547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522562 */     // MIs[0] round
     /*  522562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522572 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522581 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522594 */     GIR_RootConstrainSelectedInstOperands,
     /*  522595 */     // GIR_Coverage, 20870,
     /*  522595 */     GIR_EraseRootFromParent_Done,
     /*  522596 */   // Label 8695: @522596
     /*  522596 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(522667), // Rule ID 20871 //
     /*  522601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  522604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  522612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  522615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  522618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522633 */     // MIs[0] round
     /*  522633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522643 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522652 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522665 */     GIR_RootConstrainSelectedInstOperands,
     /*  522666 */     // GIR_Coverage, 20871,
     /*  522666 */     GIR_EraseRootFromParent_Done,
     /*  522667 */   // Label 8696: @522667
     /*  522667 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(522738), // Rule ID 20994 //
     /*  522672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  522683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  522686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  522689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522704 */     // MIs[0] round
     /*  522704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522714 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  522717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522723 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522736 */     GIR_RootConstrainSelectedInstOperands,
     /*  522737 */     // GIR_Coverage, 20994,
     /*  522737 */     GIR_EraseRootFromParent_Done,
     /*  522738 */   // Label 8697: @522738
     /*  522738 */   GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(522809), // Rule ID 20995 //
     /*  522743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  522754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  522757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  522760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522775 */     // MIs[0] round
     /*  522775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522785 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  522788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522794 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522807 */     GIR_RootConstrainSelectedInstOperands,
     /*  522808 */     // GIR_Coverage, 20995,
     /*  522808 */     GIR_EraseRootFromParent_Done,
     /*  522809 */   // Label 8698: @522809
     /*  522809 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(522880), // Rule ID 20998 //
     /*  522814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  522825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  522828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  522831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522846 */     // MIs[0] round
     /*  522846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522856 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  522859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522865 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522878 */     GIR_RootConstrainSelectedInstOperands,
     /*  522879 */     // GIR_Coverage, 20998,
     /*  522879 */     GIR_EraseRootFromParent_Done,
     /*  522880 */   // Label 8699: @522880
     /*  522880 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(522951), // Rule ID 20999 //
     /*  522885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  522896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  522899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  522902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522917 */     // MIs[0] round
     /*  522917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522927 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  522930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522936 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522949 */     GIR_RootConstrainSelectedInstOperands,
     /*  522950 */     // GIR_Coverage, 20999,
     /*  522950 */     GIR_EraseRootFromParent_Done,
     /*  522951 */   // Label 8700: @522951
     /*  522951 */   GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(523022), // Rule ID 21002 //
     /*  522956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  522967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  522970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  522973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522988 */     // MIs[0] round
     /*  522988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522998 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  523001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523007 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523020 */     GIR_RootConstrainSelectedInstOperands,
     /*  523021 */     // GIR_Coverage, 21002,
     /*  523021 */     GIR_EraseRootFromParent_Done,
     /*  523022 */   // Label 8701: @523022
     /*  523022 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(523093), // Rule ID 21003 //
     /*  523027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  523038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  523041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  523044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523059 */     // MIs[0] round
     /*  523059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523069 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  523072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523078 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523091 */     GIR_RootConstrainSelectedInstOperands,
     /*  523092 */     // GIR_Coverage, 21003,
     /*  523092 */     GIR_EraseRootFromParent_Done,
     /*  523093 */   // Label 8702: @523093
     /*  523093 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(523164), // Rule ID 21006 //
     /*  523098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  523109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  523112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  523115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523130 */     // MIs[0] round
     /*  523130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523140 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  523143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523149 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523162 */     GIR_RootConstrainSelectedInstOperands,
     /*  523163 */     // GIR_Coverage, 21006,
     /*  523163 */     GIR_EraseRootFromParent_Done,
     /*  523164 */   // Label 8703: @523164
     /*  523164 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(523235), // Rule ID 21007 //
     /*  523169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  523180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  523183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  523186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523201 */     // MIs[0] round
     /*  523201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523211 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  523214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523220 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523233 */     GIR_RootConstrainSelectedInstOperands,
     /*  523234 */     // GIR_Coverage, 21007,
     /*  523234 */     GIR_EraseRootFromParent_Done,
     /*  523235 */   // Label 8704: @523235
     /*  523235 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(523306), // Rule ID 21010 //
     /*  523240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  523251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  523254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  523257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523272 */     // MIs[0] round
     /*  523272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523282 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  523285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523291 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523304 */     GIR_RootConstrainSelectedInstOperands,
     /*  523305 */     // GIR_Coverage, 21010,
     /*  523305 */     GIR_EraseRootFromParent_Done,
     /*  523306 */   // Label 8705: @523306
     /*  523306 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(523377), // Rule ID 21011 //
     /*  523311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  523322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  523325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  523328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523343 */     // MIs[0] round
     /*  523343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523353 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  523356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523362 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523375 */     GIR_RootConstrainSelectedInstOperands,
     /*  523376 */     // GIR_Coverage, 21011,
     /*  523376 */     GIR_EraseRootFromParent_Done,
     /*  523377 */   // Label 8706: @523377
     /*  523377 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(523448), // Rule ID 21014 //
     /*  523382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  523385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  523393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  523396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  523399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523414 */     // MIs[0] round
     /*  523414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523424 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  523424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  523427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523433 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523446 */     GIR_RootConstrainSelectedInstOperands,
     /*  523447 */     // GIR_Coverage, 21014,
     /*  523447 */     GIR_EraseRootFromParent_Done,
     /*  523448 */   // Label 8707: @523448
     /*  523448 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(523519), // Rule ID 21015 //
     /*  523453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  523456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  523464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  523467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  523470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523485 */     // MIs[0] round
     /*  523485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523495 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  523495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  523498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523504 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523517 */     GIR_RootConstrainSelectedInstOperands,
     /*  523518 */     // GIR_Coverage, 21015,
     /*  523518 */     GIR_EraseRootFromParent_Done,
     /*  523519 */   // Label 8708: @523519
     /*  523519 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(523590), // Rule ID 21018 //
     /*  523524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  523535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  523538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  523541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523556 */     // MIs[0] round
     /*  523556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523566 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  523569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523575 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523588 */     GIR_RootConstrainSelectedInstOperands,
     /*  523589 */     // GIR_Coverage, 21018,
     /*  523589 */     GIR_EraseRootFromParent_Done,
     /*  523590 */   // Label 8709: @523590
     /*  523590 */   GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(523661), // Rule ID 21019 //
     /*  523595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  523606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  523609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  523612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523627 */     // MIs[0] round
     /*  523627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523637 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  523640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523646 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523659 */     GIR_RootConstrainSelectedInstOperands,
     /*  523660 */     // GIR_Coverage, 21019,
     /*  523660 */     GIR_EraseRootFromParent_Done,
     /*  523661 */   // Label 8710: @523661
     /*  523661 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(523732), // Rule ID 21022 //
     /*  523666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  523677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  523680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  523683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523698 */     // MIs[0] round
     /*  523698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523708 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  523711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523717 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523730 */     GIR_RootConstrainSelectedInstOperands,
     /*  523731 */     // GIR_Coverage, 21022,
     /*  523731 */     GIR_EraseRootFromParent_Done,
     /*  523732 */   // Label 8711: @523732
     /*  523732 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(523803), // Rule ID 21023 //
     /*  523737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  523748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  523751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  523754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523769 */     // MIs[0] round
     /*  523769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523779 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  523782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523788 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523801 */     GIR_RootConstrainSelectedInstOperands,
     /*  523802 */     // GIR_Coverage, 21023,
     /*  523802 */     GIR_EraseRootFromParent_Done,
     /*  523803 */   // Label 8712: @523803
     /*  523803 */   GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(523874), // Rule ID 21026 //
     /*  523808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  523819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  523822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  523825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523840 */     // MIs[0] round
     /*  523840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523850 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  523853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523859 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523872 */     GIR_RootConstrainSelectedInstOperands,
     /*  523873 */     // GIR_Coverage, 21026,
     /*  523873 */     GIR_EraseRootFromParent_Done,
     /*  523874 */   // Label 8713: @523874
     /*  523874 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(523945), // Rule ID 21027 //
     /*  523879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  523890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  523893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  523896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523911 */     // MIs[0] round
     /*  523911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523921 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  523924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523930 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523943 */     GIR_RootConstrainSelectedInstOperands,
     /*  523944 */     // GIR_Coverage, 21027,
     /*  523944 */     GIR_EraseRootFromParent_Done,
     /*  523945 */   // Label 8714: @523945
     /*  523945 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(524016), // Rule ID 21030 //
     /*  523950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  523961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  523964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  523967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523982 */     // MIs[0] round
     /*  523982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523992 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  523995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524001 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524014 */     GIR_RootConstrainSelectedInstOperands,
     /*  524015 */     // GIR_Coverage, 21030,
     /*  524015 */     GIR_EraseRootFromParent_Done,
     /*  524016 */   // Label 8715: @524016
     /*  524016 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(524087), // Rule ID 21031 //
     /*  524021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  524032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  524035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  524038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524053 */     // MIs[0] round
     /*  524053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524063 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  524066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524072 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524085 */     GIR_RootConstrainSelectedInstOperands,
     /*  524086 */     // GIR_Coverage, 21031,
     /*  524086 */     GIR_EraseRootFromParent_Done,
     /*  524087 */   // Label 8716: @524087
     /*  524087 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(524158), // Rule ID 21034 //
     /*  524092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  524103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  524106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  524109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524124 */     // MIs[0] round
     /*  524124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524134 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  524137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524143 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524156 */     GIR_RootConstrainSelectedInstOperands,
     /*  524157 */     // GIR_Coverage, 21034,
     /*  524157 */     GIR_EraseRootFromParent_Done,
     /*  524158 */   // Label 8717: @524158
     /*  524158 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(524229), // Rule ID 21035 //
     /*  524163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  524174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  524177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  524180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524195 */     // MIs[0] round
     /*  524195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524205 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  524208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524214 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524227 */     GIR_RootConstrainSelectedInstOperands,
     /*  524228 */     // GIR_Coverage, 21035,
     /*  524228 */     GIR_EraseRootFromParent_Done,
     /*  524229 */   // Label 8718: @524229
     /*  524229 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(524300), // Rule ID 21038 //
     /*  524234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  524245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  524248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  524251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524266 */     // MIs[0] round
     /*  524266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524276 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  524279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524285 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524298 */     GIR_RootConstrainSelectedInstOperands,
     /*  524299 */     // GIR_Coverage, 21038,
     /*  524299 */     GIR_EraseRootFromParent_Done,
     /*  524300 */   // Label 8719: @524300
     /*  524300 */   GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(524371), // Rule ID 21039 //
     /*  524305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  524316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  524319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  524322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524337 */     // MIs[0] round
     /*  524337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524347 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  524350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524356 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524369 */     GIR_RootConstrainSelectedInstOperands,
     /*  524370 */     // GIR_Coverage, 21039,
     /*  524370 */     GIR_EraseRootFromParent_Done,
     /*  524371 */   // Label 8720: @524371
     /*  524371 */   GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(524442), // Rule ID 21042 //
     /*  524376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  524387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  524390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  524393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524408 */     // MIs[0] round
     /*  524408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524418 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  524421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524427 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524440 */     GIR_RootConstrainSelectedInstOperands,
     /*  524441 */     // GIR_Coverage, 21042,
     /*  524441 */     GIR_EraseRootFromParent_Done,
     /*  524442 */   // Label 8721: @524442
     /*  524442 */   GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(524513), // Rule ID 21043 //
     /*  524447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  524458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  524461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  524464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524479 */     // MIs[0] round
     /*  524479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524489 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  524492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524498 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524511 */     GIR_RootConstrainSelectedInstOperands,
     /*  524512 */     // GIR_Coverage, 21043,
     /*  524512 */     GIR_EraseRootFromParent_Done,
     /*  524513 */   // Label 8722: @524513
     /*  524513 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(524584), // Rule ID 21046 //
     /*  524518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  524529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  524532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  524535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524550 */     // MIs[0] round
     /*  524550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524560 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  524563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524569 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524582 */     GIR_RootConstrainSelectedInstOperands,
     /*  524583 */     // GIR_Coverage, 21046,
     /*  524583 */     GIR_EraseRootFromParent_Done,
     /*  524584 */   // Label 8723: @524584
     /*  524584 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(524655), // Rule ID 21047 //
     /*  524589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  524600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  524603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  524606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524621 */     // MIs[0] round
     /*  524621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524631 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  524634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524640 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524653 */     GIR_RootConstrainSelectedInstOperands,
     /*  524654 */     // GIR_Coverage, 21047,
     /*  524654 */     GIR_EraseRootFromParent_Done,
     /*  524655 */   // Label 8724: @524655
     /*  524655 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(524726), // Rule ID 21050 //
     /*  524660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  524671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  524674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  524677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524692 */     // MIs[0] round
     /*  524692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524702 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  524705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524711 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524724 */     GIR_RootConstrainSelectedInstOperands,
     /*  524725 */     // GIR_Coverage, 21050,
     /*  524725 */     GIR_EraseRootFromParent_Done,
     /*  524726 */   // Label 8725: @524726
     /*  524726 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(524797), // Rule ID 21051 //
     /*  524731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  524742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  524745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  524748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524763 */     // MIs[0] round
     /*  524763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524773 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  524776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524782 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524795 */     GIR_RootConstrainSelectedInstOperands,
     /*  524796 */     // GIR_Coverage, 21051,
     /*  524796 */     GIR_EraseRootFromParent_Done,
     /*  524797 */   // Label 8726: @524797
     /*  524797 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(524868), // Rule ID 21054 //
     /*  524802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  524813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  524816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  524819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524834 */     // MIs[0] round
     /*  524834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524844 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  524847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524853 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524866 */     GIR_RootConstrainSelectedInstOperands,
     /*  524867 */     // GIR_Coverage, 21054,
     /*  524867 */     GIR_EraseRootFromParent_Done,
     /*  524868 */   // Label 8727: @524868
     /*  524868 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(524939), // Rule ID 21055 //
     /*  524873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  524884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  524887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  524890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524905 */     // MIs[0] round
     /*  524905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524915 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  524918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524924 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524937 */     GIR_RootConstrainSelectedInstOperands,
     /*  524938 */     // GIR_Coverage, 21055,
     /*  524938 */     GIR_EraseRootFromParent_Done,
     /*  524939 */   // Label 8728: @524939
     /*  524939 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(525010), // Rule ID 21058 //
     /*  524944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  524955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  524958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  524961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524976 */     // MIs[0] round
     /*  524976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524986 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  524989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524995 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525008 */     GIR_RootConstrainSelectedInstOperands,
     /*  525009 */     // GIR_Coverage, 21058,
     /*  525009 */     GIR_EraseRootFromParent_Done,
     /*  525010 */   // Label 8729: @525010
     /*  525010 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(525081), // Rule ID 21059 //
     /*  525015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  525026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  525029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  525032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525047 */     // MIs[0] round
     /*  525047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525057 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  525060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525066 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525079 */     GIR_RootConstrainSelectedInstOperands,
     /*  525080 */     // GIR_Coverage, 21059,
     /*  525080 */     GIR_EraseRootFromParent_Done,
     /*  525081 */   // Label 8730: @525081
     /*  525081 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(525152), // Rule ID 21062 //
     /*  525086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  525097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  525100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  525103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525118 */     // MIs[0] round
     /*  525118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525128 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  525131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525137 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525150 */     GIR_RootConstrainSelectedInstOperands,
     /*  525151 */     // GIR_Coverage, 21062,
     /*  525151 */     GIR_EraseRootFromParent_Done,
     /*  525152 */   // Label 8731: @525152
     /*  525152 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(525223), // Rule ID 21063 //
     /*  525157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  525168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  525171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  525174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525189 */     // MIs[0] round
     /*  525189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525199 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  525202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525208 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525221 */     GIR_RootConstrainSelectedInstOperands,
     /*  525222 */     // GIR_Coverage, 21063,
     /*  525222 */     GIR_EraseRootFromParent_Done,
     /*  525223 */   // Label 8732: @525223
     /*  525223 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(525294), // Rule ID 21066 //
     /*  525228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  525239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  525242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  525245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525260 */     // MIs[0] round
     /*  525260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525270 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  525273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525279 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525292 */     GIR_RootConstrainSelectedInstOperands,
     /*  525293 */     // GIR_Coverage, 21066,
     /*  525293 */     GIR_EraseRootFromParent_Done,
     /*  525294 */   // Label 8733: @525294
     /*  525294 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(525365), // Rule ID 21067 //
     /*  525299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  525310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  525313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  525316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525331 */     // MIs[0] round
     /*  525331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525341 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  525344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525350 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525363 */     GIR_RootConstrainSelectedInstOperands,
     /*  525364 */     // GIR_Coverage, 21067,
     /*  525364 */     GIR_EraseRootFromParent_Done,
     /*  525365 */   // Label 8734: @525365
     /*  525365 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(525436), // Rule ID 21070 //
     /*  525370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  525381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  525384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  525387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525402 */     // MIs[0] round
     /*  525402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525412 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  525415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525421 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525434 */     GIR_RootConstrainSelectedInstOperands,
     /*  525435 */     // GIR_Coverage, 21070,
     /*  525435 */     GIR_EraseRootFromParent_Done,
     /*  525436 */   // Label 8735: @525436
     /*  525436 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(525507), // Rule ID 21071 //
     /*  525441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  525452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  525455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  525458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525473 */     // MIs[0] round
     /*  525473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525483 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  525486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525492 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525505 */     GIR_RootConstrainSelectedInstOperands,
     /*  525506 */     // GIR_Coverage, 21071,
     /*  525506 */     GIR_EraseRootFromParent_Done,
     /*  525507 */   // Label 8736: @525507
     /*  525507 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(525578), // Rule ID 21074 //
     /*  525512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  525515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525544 */     // MIs[0] round
     /*  525544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525554 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  525554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  525557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525563 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525576 */     GIR_RootConstrainSelectedInstOperands,
     /*  525577 */     // GIR_Coverage, 21074,
     /*  525577 */     GIR_EraseRootFromParent_Done,
     /*  525578 */   // Label 8737: @525578
     /*  525578 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(525649), // Rule ID 21075 //
     /*  525583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  525586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525615 */     // MIs[0] round
     /*  525615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525625 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  525625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  525628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525634 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525647 */     GIR_RootConstrainSelectedInstOperands,
     /*  525648 */     // GIR_Coverage, 21075,
     /*  525648 */     GIR_EraseRootFromParent_Done,
     /*  525649 */   // Label 8738: @525649
     /*  525649 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(525720), // Rule ID 21078 //
     /*  525654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  525665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  525668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  525671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525686 */     // MIs[0] round
     /*  525686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525696 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  525699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525705 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525718 */     GIR_RootConstrainSelectedInstOperands,
     /*  525719 */     // GIR_Coverage, 21078,
     /*  525719 */     GIR_EraseRootFromParent_Done,
     /*  525720 */   // Label 8739: @525720
     /*  525720 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(525791), // Rule ID 21079 //
     /*  525725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  525736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  525739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  525742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525757 */     // MIs[0] round
     /*  525757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525767 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  525770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525776 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525789 */     GIR_RootConstrainSelectedInstOperands,
     /*  525790 */     // GIR_Coverage, 21079,
     /*  525790 */     GIR_EraseRootFromParent_Done,
     /*  525791 */   // Label 8740: @525791
     /*  525791 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(525862), // Rule ID 21082 //
     /*  525796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  525807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  525810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  525813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525828 */     // MIs[0] round
     /*  525828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525838 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  525841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525847 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525860 */     GIR_RootConstrainSelectedInstOperands,
     /*  525861 */     // GIR_Coverage, 21082,
     /*  525861 */     GIR_EraseRootFromParent_Done,
     /*  525862 */   // Label 8741: @525862
     /*  525862 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(525933), // Rule ID 21083 //
     /*  525867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  525878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  525881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  525884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525899 */     // MIs[0] round
     /*  525899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525909 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  525912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525918 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525931 */     GIR_RootConstrainSelectedInstOperands,
     /*  525932 */     // GIR_Coverage, 21083,
     /*  525932 */     GIR_EraseRootFromParent_Done,
     /*  525933 */   // Label 8742: @525933
     /*  525933 */   GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(526004), // Rule ID 21086 //
     /*  525938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  525949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  525952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  525955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525970 */     // MIs[0] round
     /*  525970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525980 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  525983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525989 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526002 */     GIR_RootConstrainSelectedInstOperands,
     /*  526003 */     // GIR_Coverage, 21086,
     /*  526003 */     GIR_EraseRootFromParent_Done,
     /*  526004 */   // Label 8743: @526004
     /*  526004 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(526075), // Rule ID 21087 //
     /*  526009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  526020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  526023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  526026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526041 */     // MIs[0] round
     /*  526041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526051 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  526054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526060 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526073 */     GIR_RootConstrainSelectedInstOperands,
     /*  526074 */     // GIR_Coverage, 21087,
     /*  526074 */     GIR_EraseRootFromParent_Done,
     /*  526075 */   // Label 8744: @526075
     /*  526075 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(526146), // Rule ID 21090 //
     /*  526080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  526091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  526094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  526097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526112 */     // MIs[0] round
     /*  526112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526122 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  526125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526131 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526144 */     GIR_RootConstrainSelectedInstOperands,
     /*  526145 */     // GIR_Coverage, 21090,
     /*  526145 */     GIR_EraseRootFromParent_Done,
     /*  526146 */   // Label 8745: @526146
     /*  526146 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(526217), // Rule ID 21091 //
     /*  526151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  526162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  526165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  526168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526183 */     // MIs[0] round
     /*  526183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526193 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  526196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526202 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526215 */     GIR_RootConstrainSelectedInstOperands,
     /*  526216 */     // GIR_Coverage, 21091,
     /*  526216 */     GIR_EraseRootFromParent_Done,
     /*  526217 */   // Label 8746: @526217
     /*  526217 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(526288), // Rule ID 21094 //
     /*  526222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  526233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  526236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  526239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526254 */     // MIs[0] round
     /*  526254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526264 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  526267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526273 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526286 */     GIR_RootConstrainSelectedInstOperands,
     /*  526287 */     // GIR_Coverage, 21094,
     /*  526287 */     GIR_EraseRootFromParent_Done,
     /*  526288 */   // Label 8747: @526288
     /*  526288 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(526359), // Rule ID 21095 //
     /*  526293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  526304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  526307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  526310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526325 */     // MIs[0] round
     /*  526325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526335 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  526338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526344 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526357 */     GIR_RootConstrainSelectedInstOperands,
     /*  526358 */     // GIR_Coverage, 21095,
     /*  526358 */     GIR_EraseRootFromParent_Done,
     /*  526359 */   // Label 8748: @526359
     /*  526359 */   GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(526430), // Rule ID 21098 //
     /*  526364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  526375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  526378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  526381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526396 */     // MIs[0] round
     /*  526396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526406 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  526409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526415 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526428 */     GIR_RootConstrainSelectedInstOperands,
     /*  526429 */     // GIR_Coverage, 21098,
     /*  526429 */     GIR_EraseRootFromParent_Done,
     /*  526430 */   // Label 8749: @526430
     /*  526430 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(526501), // Rule ID 21099 //
     /*  526435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  526446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  526449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  526452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526467 */     // MIs[0] round
     /*  526467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526477 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  526480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526486 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526499 */     GIR_RootConstrainSelectedInstOperands,
     /*  526500 */     // GIR_Coverage, 21099,
     /*  526500 */     GIR_EraseRootFromParent_Done,
     /*  526501 */   // Label 8750: @526501
     /*  526501 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(526572), // Rule ID 21102 //
     /*  526506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  526517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526538 */     // MIs[0] round
     /*  526538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526548 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  526551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526557 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526570 */     GIR_RootConstrainSelectedInstOperands,
     /*  526571 */     // GIR_Coverage, 21102,
     /*  526571 */     GIR_EraseRootFromParent_Done,
     /*  526572 */   // Label 8751: @526572
     /*  526572 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(526643), // Rule ID 21103 //
     /*  526577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  526588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526609 */     // MIs[0] round
     /*  526609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526619 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  526622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526628 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526641 */     GIR_RootConstrainSelectedInstOperands,
     /*  526642 */     // GIR_Coverage, 21103,
     /*  526642 */     GIR_EraseRootFromParent_Done,
     /*  526643 */   // Label 8752: @526643
     /*  526643 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(526714), // Rule ID 21106 //
     /*  526648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  526659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  526662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  526665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526680 */     // MIs[0] round
     /*  526680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526690 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  526693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526699 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526712 */     GIR_RootConstrainSelectedInstOperands,
     /*  526713 */     // GIR_Coverage, 21106,
     /*  526713 */     GIR_EraseRootFromParent_Done,
     /*  526714 */   // Label 8753: @526714
     /*  526714 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(526785), // Rule ID 21107 //
     /*  526719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  526730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  526733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  526736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526751 */     // MIs[0] round
     /*  526751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526761 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  526764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526770 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526783 */     GIR_RootConstrainSelectedInstOperands,
     /*  526784 */     // GIR_Coverage, 21107,
     /*  526784 */     GIR_EraseRootFromParent_Done,
     /*  526785 */   // Label 8754: @526785
     /*  526785 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(526856), // Rule ID 21110 //
     /*  526790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  526801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  526804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  526807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526822 */     // MIs[0] round
     /*  526822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526832 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  526835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526841 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526854 */     GIR_RootConstrainSelectedInstOperands,
     /*  526855 */     // GIR_Coverage, 21110,
     /*  526855 */     GIR_EraseRootFromParent_Done,
     /*  526856 */   // Label 8755: @526856
     /*  526856 */   GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(526927), // Rule ID 21111 //
     /*  526861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  526872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  526875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  526878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526893 */     // MIs[0] round
     /*  526893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526903 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  526906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526912 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526925 */     GIR_RootConstrainSelectedInstOperands,
     /*  526926 */     // GIR_Coverage, 21111,
     /*  526926 */     GIR_EraseRootFromParent_Done,
     /*  526927 */   // Label 8756: @526927
     /*  526927 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(526998), // Rule ID 21186 //
     /*  526932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  526940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  526943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  526946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  526949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526964 */     // MIs[0] round
     /*  526964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526974 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  526977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526983 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526996 */     GIR_RootConstrainSelectedInstOperands,
     /*  526997 */     // GIR_Coverage, 21186,
     /*  526997 */     GIR_EraseRootFromParent_Done,
     /*  526998 */   // Label 8757: @526998
     /*  526998 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(527069), // Rule ID 21187 //
     /*  527003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  527014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  527017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  527020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527035 */     // MIs[0] round
     /*  527035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527045 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  527048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527054 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527067 */     GIR_RootConstrainSelectedInstOperands,
     /*  527068 */     // GIR_Coverage, 21187,
     /*  527068 */     GIR_EraseRootFromParent_Done,
     /*  527069 */   // Label 8758: @527069
     /*  527069 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(527140), // Rule ID 21190 //
     /*  527074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  527091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527106 */     // MIs[0] round
     /*  527106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527116 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527125 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527138 */     GIR_RootConstrainSelectedInstOperands,
     /*  527139 */     // GIR_Coverage, 21190,
     /*  527139 */     GIR_EraseRootFromParent_Done,
     /*  527140 */   // Label 8759: @527140
     /*  527140 */   GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(527211), // Rule ID 21191 //
     /*  527145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  527162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527177 */     // MIs[0] round
     /*  527177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527187 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527196 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527209 */     GIR_RootConstrainSelectedInstOperands,
     /*  527210 */     // GIR_Coverage, 21191,
     /*  527210 */     GIR_EraseRootFromParent_Done,
     /*  527211 */   // Label 8760: @527211
     /*  527211 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(527282), // Rule ID 21194 //
     /*  527216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  527227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  527230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  527233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527248 */     // MIs[0] round
     /*  527248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527267 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527280 */     GIR_RootConstrainSelectedInstOperands,
     /*  527281 */     // GIR_Coverage, 21194,
     /*  527281 */     GIR_EraseRootFromParent_Done,
     /*  527282 */   // Label 8761: @527282
     /*  527282 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(527353), // Rule ID 21195 //
     /*  527287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  527298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  527301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  527304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527319 */     // MIs[0] round
     /*  527319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527329 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527338 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527351 */     GIR_RootConstrainSelectedInstOperands,
     /*  527352 */     // GIR_Coverage, 21195,
     /*  527352 */     GIR_EraseRootFromParent_Done,
     /*  527353 */   // Label 8762: @527353
     /*  527353 */   GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(527424), // Rule ID 21198 //
     /*  527358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  527369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  527372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  527375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527390 */     // MIs[0] round
     /*  527390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527400 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  527403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527409 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527422 */     GIR_RootConstrainSelectedInstOperands,
     /*  527423 */     // GIR_Coverage, 21198,
     /*  527423 */     GIR_EraseRootFromParent_Done,
     /*  527424 */   // Label 8763: @527424
     /*  527424 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(527495), // Rule ID 21199 //
     /*  527429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  527440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  527443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  527446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527461 */     // MIs[0] round
     /*  527461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527471 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  527474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527480 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527493 */     GIR_RootConstrainSelectedInstOperands,
     /*  527494 */     // GIR_Coverage, 21199,
     /*  527494 */     GIR_EraseRootFromParent_Done,
     /*  527495 */   // Label 8764: @527495
     /*  527495 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(527566), // Rule ID 21202 //
     /*  527500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  527511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  527514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  527517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527532 */     // MIs[0] round
     /*  527532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527542 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  527545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527551 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527564 */     GIR_RootConstrainSelectedInstOperands,
     /*  527565 */     // GIR_Coverage, 21202,
     /*  527565 */     GIR_EraseRootFromParent_Done,
     /*  527566 */   // Label 8765: @527566
     /*  527566 */   GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(527637), // Rule ID 21203 //
     /*  527571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  527582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  527585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  527588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527603 */     // MIs[0] round
     /*  527603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527613 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  527616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527622 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527635 */     GIR_RootConstrainSelectedInstOperands,
     /*  527636 */     // GIR_Coverage, 21203,
     /*  527636 */     GIR_EraseRootFromParent_Done,
     /*  527637 */   // Label 8766: @527637
     /*  527637 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(527708), // Rule ID 21206 //
     /*  527642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  527645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  527653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  527656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  527659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527674 */     // MIs[0] round
     /*  527674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527684 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527693 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527706 */     GIR_RootConstrainSelectedInstOperands,
     /*  527707 */     // GIR_Coverage, 21206,
     /*  527707 */     GIR_EraseRootFromParent_Done,
     /*  527708 */   // Label 8767: @527708
     /*  527708 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(527779), // Rule ID 21207 //
     /*  527713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  527716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  527724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  527727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  527730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527745 */     // MIs[0] round
     /*  527745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527755 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  527755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527764 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527777 */     GIR_RootConstrainSelectedInstOperands,
     /*  527778 */     // GIR_Coverage, 21207,
     /*  527778 */     GIR_EraseRootFromParent_Done,
     /*  527779 */   // Label 8768: @527779
     /*  527779 */   GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(527850), // Rule ID 21210 //
     /*  527784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  527787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  527795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  527798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  527801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527816 */     // MIs[0] round
     /*  527816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527826 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527835 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527848 */     GIR_RootConstrainSelectedInstOperands,
     /*  527849 */     // GIR_Coverage, 21210,
     /*  527849 */     GIR_EraseRootFromParent_Done,
     /*  527850 */   // Label 8769: @527850
     /*  527850 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(527921), // Rule ID 21211 //
     /*  527855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  527858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  527866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  527869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  527872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527887 */     // MIs[0] round
     /*  527887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527897 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  527897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527906 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527919 */     GIR_RootConstrainSelectedInstOperands,
     /*  527920 */     // GIR_Coverage, 21211,
     /*  527920 */     GIR_EraseRootFromParent_Done,
     /*  527921 */   // Label 8770: @527921
     /*  527921 */   GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(527992), // Rule ID 21214 //
     /*  527926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  527929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  527937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  527940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  527943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527958 */     // MIs[0] round
     /*  527958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527968 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  527971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527977 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527990 */     GIR_RootConstrainSelectedInstOperands,
     /*  527991 */     // GIR_Coverage, 21214,
     /*  527991 */     GIR_EraseRootFromParent_Done,
     /*  527992 */   // Label 8771: @527992
     /*  527992 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(528063), // Rule ID 21215 //
     /*  527997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  528008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  528011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  528014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528029 */     // MIs[0] round
     /*  528029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528039 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  528042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528048 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528061 */     GIR_RootConstrainSelectedInstOperands,
     /*  528062 */     // GIR_Coverage, 21215,
     /*  528062 */     GIR_EraseRootFromParent_Done,
     /*  528063 */   // Label 8772: @528063
     /*  528063 */   GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(528134), // Rule ID 21218 //
     /*  528068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  528085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528100 */     // MIs[0] round
     /*  528100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528110 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  528113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528119 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528132 */     GIR_RootConstrainSelectedInstOperands,
     /*  528133 */     // GIR_Coverage, 21218,
     /*  528133 */     GIR_EraseRootFromParent_Done,
     /*  528134 */   // Label 8773: @528134
     /*  528134 */   GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(528205), // Rule ID 21219 //
     /*  528139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  528156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528171 */     // MIs[0] round
     /*  528171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528181 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  528184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528190 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528203 */     GIR_RootConstrainSelectedInstOperands,
     /*  528204 */     // GIR_Coverage, 21219,
     /*  528204 */     GIR_EraseRootFromParent_Done,
     /*  528205 */   // Label 8774: @528205
     /*  528205 */   GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(528276), // Rule ID 21222 //
     /*  528210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  528221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  528224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  528227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528242 */     // MIs[0] round
     /*  528242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528252 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  528255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528261 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528274 */     GIR_RootConstrainSelectedInstOperands,
     /*  528275 */     // GIR_Coverage, 21222,
     /*  528275 */     GIR_EraseRootFromParent_Done,
     /*  528276 */   // Label 8775: @528276
     /*  528276 */   GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(528347), // Rule ID 21223 //
     /*  528281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  528292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  528295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  528298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528313 */     // MIs[0] round
     /*  528313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528323 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  528326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528332 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528345 */     GIR_RootConstrainSelectedInstOperands,
     /*  528346 */     // GIR_Coverage, 21223,
     /*  528346 */     GIR_EraseRootFromParent_Done,
     /*  528347 */   // Label 8776: @528347
     /*  528347 */   GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(528418), // Rule ID 21226 //
     /*  528352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  528363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  528366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  528369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528384 */     // MIs[0] round
     /*  528384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528394 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  528397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528403 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528416 */     GIR_RootConstrainSelectedInstOperands,
     /*  528417 */     // GIR_Coverage, 21226,
     /*  528417 */     GIR_EraseRootFromParent_Done,
     /*  528418 */   // Label 8777: @528418
     /*  528418 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(528489), // Rule ID 21227 //
     /*  528423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  528434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  528437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  528440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528455 */     // MIs[0] round
     /*  528455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528465 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  528468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528474 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528487 */     GIR_RootConstrainSelectedInstOperands,
     /*  528488 */     // GIR_Coverage, 21227,
     /*  528488 */     GIR_EraseRootFromParent_Done,
     /*  528489 */   // Label 8778: @528489
     /*  528489 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(528560), // Rule ID 21230 //
     /*  528494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  528505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  528508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  528511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528526 */     // MIs[0] round
     /*  528526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  528539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528545 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528558 */     GIR_RootConstrainSelectedInstOperands,
     /*  528559 */     // GIR_Coverage, 21230,
     /*  528559 */     GIR_EraseRootFromParent_Done,
     /*  528560 */   // Label 8779: @528560
     /*  528560 */   GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(528631), // Rule ID 21231 //
     /*  528565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  528576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  528579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  528582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528597 */     // MIs[0] round
     /*  528597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528607 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  528610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528616 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528629 */     GIR_RootConstrainSelectedInstOperands,
     /*  528630 */     // GIR_Coverage, 21231,
     /*  528630 */     GIR_EraseRootFromParent_Done,
     /*  528631 */   // Label 8780: @528631
     /*  528631 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(528702), // Rule ID 21234 //
     /*  528636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  528647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  528650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  528653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528668 */     // MIs[0] round
     /*  528668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528678 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  528681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528687 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528700 */     GIR_RootConstrainSelectedInstOperands,
     /*  528701 */     // GIR_Coverage, 21234,
     /*  528701 */     GIR_EraseRootFromParent_Done,
     /*  528702 */   // Label 8781: @528702
     /*  528702 */   GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(528773), // Rule ID 21235 //
     /*  528707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  528718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  528721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  528724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528739 */     // MIs[0] round
     /*  528739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528749 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  528752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528758 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528771 */     GIR_RootConstrainSelectedInstOperands,
     /*  528772 */     // GIR_Coverage, 21235,
     /*  528772 */     GIR_EraseRootFromParent_Done,
     /*  528773 */   // Label 8782: @528773
     /*  528773 */   GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(528844), // Rule ID 21238 //
     /*  528778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  528789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  528792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  528795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528810 */     // MIs[0] round
     /*  528810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528820 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  528823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528829 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528842 */     GIR_RootConstrainSelectedInstOperands,
     /*  528843 */     // GIR_Coverage, 21238,
     /*  528843 */     GIR_EraseRootFromParent_Done,
     /*  528844 */   // Label 8783: @528844
     /*  528844 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(528915), // Rule ID 21239 //
     /*  528849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  528860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  528863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  528866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528881 */     // MIs[0] round
     /*  528881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528891 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  528894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528900 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528913 */     GIR_RootConstrainSelectedInstOperands,
     /*  528914 */     // GIR_Coverage, 21239,
     /*  528914 */     GIR_EraseRootFromParent_Done,
     /*  528915 */   // Label 8784: @528915
     /*  528915 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(528986), // Rule ID 21242 //
     /*  528920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  528931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  528934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  528937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528952 */     // MIs[0] round
     /*  528952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528962 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  528965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528971 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528984 */     GIR_RootConstrainSelectedInstOperands,
     /*  528985 */     // GIR_Coverage, 21242,
     /*  528985 */     GIR_EraseRootFromParent_Done,
     /*  528986 */   // Label 8785: @528986
     /*  528986 */   GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(529057), // Rule ID 21243 //
     /*  528991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  529002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  529005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  529008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529023 */     // MIs[0] round
     /*  529023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529033 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  529036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529042 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529055 */     GIR_RootConstrainSelectedInstOperands,
     /*  529056 */     // GIR_Coverage, 21243,
     /*  529056 */     GIR_EraseRootFromParent_Done,
     /*  529057 */   // Label 8786: @529057
     /*  529057 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(529128), // Rule ID 21246 //
     /*  529062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  529073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  529076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  529079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529094 */     // MIs[0] round
     /*  529094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  529107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529113 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529126 */     GIR_RootConstrainSelectedInstOperands,
     /*  529127 */     // GIR_Coverage, 21246,
     /*  529127 */     GIR_EraseRootFromParent_Done,
     /*  529128 */   // Label 8787: @529128
     /*  529128 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(529199), // Rule ID 21247 //
     /*  529133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  529144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  529147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  529150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529165 */     // MIs[0] round
     /*  529165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529175 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  529178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529184 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529197 */     GIR_RootConstrainSelectedInstOperands,
     /*  529198 */     // GIR_Coverage, 21247,
     /*  529198 */     GIR_EraseRootFromParent_Done,
     /*  529199 */   // Label 8788: @529199
     /*  529199 */   GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(529270), // Rule ID 21250 //
     /*  529204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  529215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  529218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  529221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529236 */     // MIs[0] round
     /*  529236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529246 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  529249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529255 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529268 */     GIR_RootConstrainSelectedInstOperands,
     /*  529269 */     // GIR_Coverage, 21250,
     /*  529269 */     GIR_EraseRootFromParent_Done,
     /*  529270 */   // Label 8789: @529270
     /*  529270 */   GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(529341), // Rule ID 21251 //
     /*  529275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  529286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  529289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  529292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529307 */     // MIs[0] round
     /*  529307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529317 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  529320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529326 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529339 */     GIR_RootConstrainSelectedInstOperands,
     /*  529340 */     // GIR_Coverage, 21251,
     /*  529340 */     GIR_EraseRootFromParent_Done,
     /*  529341 */   // Label 8790: @529341
     /*  529341 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(529412), // Rule ID 21254 //
     /*  529346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  529357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  529360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  529363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529378 */     // MIs[0] round
     /*  529378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529388 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  529391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529397 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529410 */     GIR_RootConstrainSelectedInstOperands,
     /*  529411 */     // GIR_Coverage, 21254,
     /*  529411 */     GIR_EraseRootFromParent_Done,
     /*  529412 */   // Label 8791: @529412
     /*  529412 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(529483), // Rule ID 21255 //
     /*  529417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  529428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  529431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  529434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529449 */     // MIs[0] round
     /*  529449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529459 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  529462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529468 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529481 */     GIR_RootConstrainSelectedInstOperands,
     /*  529482 */     // GIR_Coverage, 21255,
     /*  529482 */     GIR_EraseRootFromParent_Done,
     /*  529483 */   // Label 8792: @529483
     /*  529483 */   GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(529554), // Rule ID 21606 //
     /*  529488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  529499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  529502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  529505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529520 */     // MIs[0] round
     /*  529520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529530 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  529533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529539 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529552 */     GIR_RootConstrainSelectedInstOperands,
     /*  529553 */     // GIR_Coverage, 21606,
     /*  529553 */     GIR_EraseRootFromParent_Done,
     /*  529554 */   // Label 8793: @529554
     /*  529554 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(529625), // Rule ID 21607 //
     /*  529559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  529570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  529573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  529576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529591 */     // MIs[0] round
     /*  529591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529601 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  529601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  529604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529610 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529623 */     GIR_RootConstrainSelectedInstOperands,
     /*  529624 */     // GIR_Coverage, 21607,
     /*  529624 */     GIR_EraseRootFromParent_Done,
     /*  529625 */   // Label 8794: @529625
     /*  529625 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(529696), // Rule ID 21610 //
     /*  529630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  529641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  529644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  529647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529662 */     // MIs[0] round
     /*  529662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529672 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  529675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529681 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529694 */     GIR_RootConstrainSelectedInstOperands,
     /*  529695 */     // GIR_Coverage, 21610,
     /*  529695 */     GIR_EraseRootFromParent_Done,
     /*  529696 */   // Label 8795: @529696
     /*  529696 */   GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(529767), // Rule ID 21611 //
     /*  529701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  529712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  529715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  529718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529733 */     // MIs[0] round
     /*  529733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529743 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  529743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  529746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529752 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529765 */     GIR_RootConstrainSelectedInstOperands,
     /*  529766 */     // GIR_Coverage, 21611,
     /*  529766 */     GIR_EraseRootFromParent_Done,
     /*  529767 */   // Label 8796: @529767
     /*  529767 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(529838), // Rule ID 21614 //
     /*  529772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  529783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  529786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  529789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529804 */     // MIs[0] round
     /*  529804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529814 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  529817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529823 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529836 */     GIR_RootConstrainSelectedInstOperands,
     /*  529837 */     // GIR_Coverage, 21614,
     /*  529837 */     GIR_EraseRootFromParent_Done,
     /*  529838 */   // Label 8797: @529838
     /*  529838 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(529909), // Rule ID 21615 //
     /*  529843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  529854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  529857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  529860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529875 */     // MIs[0] round
     /*  529875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529885 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  529885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  529888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529894 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529907 */     GIR_RootConstrainSelectedInstOperands,
     /*  529908 */     // GIR_Coverage, 21615,
     /*  529908 */     GIR_EraseRootFromParent_Done,
     /*  529909 */   // Label 8798: @529909
     /*  529909 */   GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(529980), // Rule ID 21618 //
     /*  529914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  529925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  529928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529946 */     // MIs[0] round
     /*  529946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529956 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  529959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529965 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529978 */     GIR_RootConstrainSelectedInstOperands,
     /*  529979 */     // GIR_Coverage, 21618,
     /*  529979 */     GIR_EraseRootFromParent_Done,
     /*  529980 */   // Label 8799: @529980
     /*  529980 */   GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(530051), // Rule ID 21619 //
     /*  529985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  529996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  529999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  530002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530017 */     // MIs[0] round
     /*  530017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11251:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530036 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530049 */     GIR_RootConstrainSelectedInstOperands,
     /*  530050 */     // GIR_Coverage, 21619,
     /*  530050 */     GIR_EraseRootFromParent_Done,
     /*  530051 */   // Label 8800: @530051
     /*  530051 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(530122), // Rule ID 21622 //
     /*  530056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  530067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  530070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  530073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530088 */     // MIs[0] round
     /*  530088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530098 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530107 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530120 */     GIR_RootConstrainSelectedInstOperands,
     /*  530121 */     // GIR_Coverage, 21622,
     /*  530121 */     GIR_EraseRootFromParent_Done,
     /*  530122 */   // Label 8801: @530122
     /*  530122 */   GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(530193), // Rule ID 21623 //
     /*  530127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  530138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  530141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  530144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530159 */     // MIs[0] round
     /*  530159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530169 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530178 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530191 */     GIR_RootConstrainSelectedInstOperands,
     /*  530192 */     // GIR_Coverage, 21623,
     /*  530192 */     GIR_EraseRootFromParent_Done,
     /*  530193 */   // Label 8802: @530193
     /*  530193 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(530264), // Rule ID 21626 //
     /*  530198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  530209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  530212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  530215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530230 */     // MIs[0] round
     /*  530230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530240 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  530243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530249 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530262 */     GIR_RootConstrainSelectedInstOperands,
     /*  530263 */     // GIR_Coverage, 21626,
     /*  530263 */     GIR_EraseRootFromParent_Done,
     /*  530264 */   // Label 8803: @530264
     /*  530264 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(530335), // Rule ID 21627 //
     /*  530269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  530280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  530283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  530286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530301 */     // MIs[0] round
     /*  530301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530311 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  530314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530320 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530333 */     GIR_RootConstrainSelectedInstOperands,
     /*  530334 */     // GIR_Coverage, 21627,
     /*  530334 */     GIR_EraseRootFromParent_Done,
     /*  530335 */   // Label 8804: @530335
     /*  530335 */   GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(530406), // Rule ID 21630 //
     /*  530340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  530351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  530354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  530357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530372 */     // MIs[0] round
     /*  530372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530382 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  530385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530391 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530404 */     GIR_RootConstrainSelectedInstOperands,
     /*  530405 */     // GIR_Coverage, 21630,
     /*  530405 */     GIR_EraseRootFromParent_Done,
     /*  530406 */   // Label 8805: @530406
     /*  530406 */   GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(530477), // Rule ID 21631 //
     /*  530411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  530422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  530425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  530428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530443 */     // MIs[0] round
     /*  530443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530453 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  530456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530462 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530475 */     GIR_RootConstrainSelectedInstOperands,
     /*  530476 */     // GIR_Coverage, 21631,
     /*  530476 */     GIR_EraseRootFromParent_Done,
     /*  530477 */   // Label 8806: @530477
     /*  530477 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(530548), // Rule ID 21634 //
     /*  530482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  530493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  530496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  530499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530514 */     // MIs[0] round
     /*  530514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530524 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530533 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530546 */     GIR_RootConstrainSelectedInstOperands,
     /*  530547 */     // GIR_Coverage, 21634,
     /*  530547 */     GIR_EraseRootFromParent_Done,
     /*  530548 */   // Label 8807: @530548
     /*  530548 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(530619), // Rule ID 21635 //
     /*  530553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  530564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  530567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  530570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530585 */     // MIs[0] round
     /*  530585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530595 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530604 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530617 */     GIR_RootConstrainSelectedInstOperands,
     /*  530618 */     // GIR_Coverage, 21635,
     /*  530618 */     GIR_EraseRootFromParent_Done,
     /*  530619 */   // Label 8808: @530619
     /*  530619 */   GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(530690), // Rule ID 21638 //
     /*  530624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  530635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  530638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  530641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530656 */     // MIs[0] round
     /*  530656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530666 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530675 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530688 */     GIR_RootConstrainSelectedInstOperands,
     /*  530689 */     // GIR_Coverage, 21638,
     /*  530689 */     GIR_EraseRootFromParent_Done,
     /*  530690 */   // Label 8809: @530690
     /*  530690 */   GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(530761), // Rule ID 21639 //
     /*  530695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  530706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  530709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  530712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530727 */     // MIs[0] round
     /*  530727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530737 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530746 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530759 */     GIR_RootConstrainSelectedInstOperands,
     /*  530760 */     // GIR_Coverage, 21639,
     /*  530760 */     GIR_EraseRootFromParent_Done,
     /*  530761 */   // Label 8810: @530761
     /*  530761 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(530832), // Rule ID 21642 //
     /*  530766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  530777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  530780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  530783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530798 */     // MIs[0] round
     /*  530798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530808 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530817 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530830 */     GIR_RootConstrainSelectedInstOperands,
     /*  530831 */     // GIR_Coverage, 21642,
     /*  530831 */     GIR_EraseRootFromParent_Done,
     /*  530832 */   // Label 8811: @530832
     /*  530832 */   GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(530903), // Rule ID 21643 //
     /*  530837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  530848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  530851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  530854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530869 */     // MIs[0] round
     /*  530869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530879 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530888 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530901 */     GIR_RootConstrainSelectedInstOperands,
     /*  530902 */     // GIR_Coverage, 21643,
     /*  530902 */     GIR_EraseRootFromParent_Done,
     /*  530903 */   // Label 8812: @530903
     /*  530903 */   GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(530974), // Rule ID 21646 //
     /*  530908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  530919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  530922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  530925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530940 */     // MIs[0] round
     /*  530940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530950 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  530953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530959 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530972 */     GIR_RootConstrainSelectedInstOperands,
     /*  530973 */     // GIR_Coverage, 21646,
     /*  530973 */     GIR_EraseRootFromParent_Done,
     /*  530974 */   // Label 8813: @530974
     /*  530974 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(531045), // Rule ID 21647 //
     /*  530979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  530990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  530993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  530996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531011 */     // MIs[0] round
     /*  531011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531021 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531030 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531043 */     GIR_RootConstrainSelectedInstOperands,
     /*  531044 */     // GIR_Coverage, 21647,
     /*  531044 */     GIR_EraseRootFromParent_Done,
     /*  531045 */   // Label 8814: @531045
     /*  531045 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(531116), // Rule ID 21650 //
     /*  531050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  531061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  531064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  531067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531082 */     // MIs[0] round
     /*  531082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531092 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  531095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531101 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531114 */     GIR_RootConstrainSelectedInstOperands,
     /*  531115 */     // GIR_Coverage, 21650,
     /*  531115 */     GIR_EraseRootFromParent_Done,
     /*  531116 */   // Label 8815: @531116
     /*  531116 */   GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(531187), // Rule ID 21651 //
     /*  531121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  531132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  531135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  531138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531153 */     // MIs[0] round
     /*  531153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531163 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  531166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531172 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531185 */     GIR_RootConstrainSelectedInstOperands,
     /*  531186 */     // GIR_Coverage, 21651,
     /*  531186 */     GIR_EraseRootFromParent_Done,
     /*  531187 */   // Label 8816: @531187
     /*  531187 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(531258), // Rule ID 21654 //
     /*  531192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  531203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  531206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  531209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531224 */     // MIs[0] round
     /*  531224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  531237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531243 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531256 */     GIR_RootConstrainSelectedInstOperands,
     /*  531257 */     // GIR_Coverage, 21654,
     /*  531257 */     GIR_EraseRootFromParent_Done,
     /*  531258 */   // Label 8817: @531258
     /*  531258 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(531329), // Rule ID 21655 //
     /*  531263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  531274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  531277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  531280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531295 */     // MIs[0] round
     /*  531295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531305 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  531308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531314 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531327 */     GIR_RootConstrainSelectedInstOperands,
     /*  531328 */     // GIR_Coverage, 21655,
     /*  531328 */     GIR_EraseRootFromParent_Done,
     /*  531329 */   // Label 8818: @531329
     /*  531329 */   GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(531400), // Rule ID 21658 //
     /*  531334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  531345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  531348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  531351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531366 */     // MIs[0] round
     /*  531366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  531379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531385 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531398 */     GIR_RootConstrainSelectedInstOperands,
     /*  531399 */     // GIR_Coverage, 21658,
     /*  531399 */     GIR_EraseRootFromParent_Done,
     /*  531400 */   // Label 8819: @531400
     /*  531400 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(531471), // Rule ID 21659 //
     /*  531405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  531416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  531419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  531422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531437 */     // MIs[0] round
     /*  531437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531447 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  531450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531456 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531469 */     GIR_RootConstrainSelectedInstOperands,
     /*  531470 */     // GIR_Coverage, 21659,
     /*  531470 */     GIR_EraseRootFromParent_Done,
     /*  531471 */   // Label 8820: @531471
     /*  531471 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(531542), // Rule ID 21662 //
     /*  531476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  531487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  531490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  531493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531508 */     // MIs[0] round
     /*  531508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531527 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531540 */     GIR_RootConstrainSelectedInstOperands,
     /*  531541 */     // GIR_Coverage, 21662,
     /*  531541 */     GIR_EraseRootFromParent_Done,
     /*  531542 */   // Label 8821: @531542
     /*  531542 */   GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(531613), // Rule ID 21663 //
     /*  531547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  531558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  531561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  531564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531579 */     // MIs[0] round
     /*  531579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531589 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531598 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531611 */     GIR_RootConstrainSelectedInstOperands,
     /*  531612 */     // GIR_Coverage, 21663,
     /*  531612 */     GIR_EraseRootFromParent_Done,
     /*  531613 */   // Label 8822: @531613
     /*  531613 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(531684), // Rule ID 21666 //
     /*  531618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  531629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  531632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  531635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531650 */     // MIs[0] round
     /*  531650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531660 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  531660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  531663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531669 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531682 */     GIR_RootConstrainSelectedInstOperands,
     /*  531683 */     // GIR_Coverage, 21666,
     /*  531683 */     GIR_EraseRootFromParent_Done,
     /*  531684 */   // Label 8823: @531684
     /*  531684 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(531755), // Rule ID 21667 //
     /*  531689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  531700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  531703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  531706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531721 */     // MIs[0] round
     /*  531721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531731 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  531731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  531734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531740 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531753 */     GIR_RootConstrainSelectedInstOperands,
     /*  531754 */     // GIR_Coverage, 21667,
     /*  531754 */     GIR_EraseRootFromParent_Done,
     /*  531755 */   // Label 8824: @531755
     /*  531755 */   GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(531826), // Rule ID 21670 //
     /*  531760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  531771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  531774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  531777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531792 */     // MIs[0] round
     /*  531792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531802 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  531802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  531805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531811 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531824 */     GIR_RootConstrainSelectedInstOperands,
     /*  531825 */     // GIR_Coverage, 21670,
     /*  531825 */     GIR_EraseRootFromParent_Done,
     /*  531826 */   // Label 8825: @531826
     /*  531826 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(531897), // Rule ID 21671 //
     /*  531831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  531842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  531845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  531848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531863 */     // MIs[0] round
     /*  531863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531873 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  531873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  531876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531882 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531895 */     GIR_RootConstrainSelectedInstOperands,
     /*  531896 */     // GIR_Coverage, 21671,
     /*  531896 */     GIR_EraseRootFromParent_Done,
     /*  531897 */   // Label 8826: @531897
     /*  531897 */   GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(531968), // Rule ID 21674 //
     /*  531902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  531913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  531916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  531919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531934 */     // MIs[0] round
     /*  531934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531944 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  531944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  531947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531953 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531966 */     GIR_RootConstrainSelectedInstOperands,
     /*  531967 */     // GIR_Coverage, 21674,
     /*  531967 */     GIR_EraseRootFromParent_Done,
     /*  531968 */   // Label 8827: @531968
     /*  531968 */   GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(532039), // Rule ID 21675 //
     /*  531973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  531984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  531987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  531990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532005 */     // MIs[0] round
     /*  532005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532015 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532024 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532037 */     GIR_RootConstrainSelectedInstOperands,
     /*  532038 */     // GIR_Coverage, 21675,
     /*  532038 */     GIR_EraseRootFromParent_Done,
     /*  532039 */   // Label 8828: @532039
     /*  532039 */   GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(532110), // Rule ID 21678 //
     /*  532044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  532055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  532058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532076 */     // MIs[0] round
     /*  532076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532086 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532095 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532108 */     GIR_RootConstrainSelectedInstOperands,
     /*  532109 */     // GIR_Coverage, 21678,
     /*  532109 */     GIR_EraseRootFromParent_Done,
     /*  532110 */   // Label 8829: @532110
     /*  532110 */   GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(532181), // Rule ID 21679 //
     /*  532115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  532126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  532129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532147 */     // MIs[0] round
     /*  532147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532157 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11249:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532166 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532179 */     GIR_RootConstrainSelectedInstOperands,
     /*  532180 */     // GIR_Coverage, 21679,
     /*  532180 */     GIR_EraseRootFromParent_Done,
     /*  532181 */   // Label 8830: @532181
     /*  532181 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(532252), // Rule ID 21682 //
     /*  532186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  532197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  532200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532218 */     // MIs[0] round
     /*  532218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532228 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  532231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532237 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532250 */     GIR_RootConstrainSelectedInstOperands,
     /*  532251 */     // GIR_Coverage, 21682,
     /*  532251 */     GIR_EraseRootFromParent_Done,
     /*  532252 */   // Label 8831: @532252
     /*  532252 */   GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(532323), // Rule ID 21683 //
     /*  532257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  532268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  532271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532289 */     // MIs[0] round
     /*  532289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532299 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  532302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532308 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532321 */     GIR_RootConstrainSelectedInstOperands,
     /*  532322 */     // GIR_Coverage, 21683,
     /*  532322 */     GIR_EraseRootFromParent_Done,
     /*  532323 */   // Label 8832: @532323
     /*  532323 */   GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(532394), // Rule ID 21686 //
     /*  532328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  532339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  532342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  532345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532360 */     // MIs[0] round
     /*  532360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532370 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  532373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532379 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532392 */     GIR_RootConstrainSelectedInstOperands,
     /*  532393 */     // GIR_Coverage, 21686,
     /*  532393 */     GIR_EraseRootFromParent_Done,
     /*  532394 */   // Label 8833: @532394
     /*  532394 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(532465), // Rule ID 21687 //
     /*  532399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  532410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  532413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  532416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532431 */     // MIs[0] round
     /*  532431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532441 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  532444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532450 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532463 */     GIR_RootConstrainSelectedInstOperands,
     /*  532464 */     // GIR_Coverage, 21687,
     /*  532464 */     GIR_EraseRootFromParent_Done,
     /*  532465 */   // Label 8834: @532465
     /*  532465 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(532536), // Rule ID 21690 //
     /*  532470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  532481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  532484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  532487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532502 */     // MIs[0] round
     /*  532502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532512 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  532515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532521 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532534 */     GIR_RootConstrainSelectedInstOperands,
     /*  532535 */     // GIR_Coverage, 21690,
     /*  532535 */     GIR_EraseRootFromParent_Done,
     /*  532536 */   // Label 8835: @532536
     /*  532536 */   GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(532607), // Rule ID 21691 //
     /*  532541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  532552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  532555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  532558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532573 */     // MIs[0] round
     /*  532573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532583 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  532586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532592 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532605 */     GIR_RootConstrainSelectedInstOperands,
     /*  532606 */     // GIR_Coverage, 21691,
     /*  532606 */     GIR_EraseRootFromParent_Done,
     /*  532607 */   // Label 8836: @532607
     /*  532607 */   GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(532678), // Rule ID 21694 //
     /*  532612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  532623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  532626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  532629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532644 */     // MIs[0] round
     /*  532644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532654 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532663 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532676 */     GIR_RootConstrainSelectedInstOperands,
     /*  532677 */     // GIR_Coverage, 21694,
     /*  532677 */     GIR_EraseRootFromParent_Done,
     /*  532678 */   // Label 8837: @532678
     /*  532678 */   GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(532749), // Rule ID 21695 //
     /*  532683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  532694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  532697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  532700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532715 */     // MIs[0] round
     /*  532715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532725 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532734 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532747 */     GIR_RootConstrainSelectedInstOperands,
     /*  532748 */     // GIR_Coverage, 21695,
     /*  532748 */     GIR_EraseRootFromParent_Done,
     /*  532749 */   // Label 8838: @532749
     /*  532749 */   GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(532820), // Rule ID 21698 //
     /*  532754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  532765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  532768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  532771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532786 */     // MIs[0] round
     /*  532786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532796 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532805 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532818 */     GIR_RootConstrainSelectedInstOperands,
     /*  532819 */     // GIR_Coverage, 21698,
     /*  532819 */     GIR_EraseRootFromParent_Done,
     /*  532820 */   // Label 8839: @532820
     /*  532820 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(532891), // Rule ID 21699 //
     /*  532825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  532836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  532839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  532842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532857 */     // MIs[0] round
     /*  532857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532867 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532876 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532889 */     GIR_RootConstrainSelectedInstOperands,
     /*  532890 */     // GIR_Coverage, 21699,
     /*  532890 */     GIR_EraseRootFromParent_Done,
     /*  532891 */   // Label 8840: @532891
     /*  532891 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(532962), // Rule ID 21702 //
     /*  532896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  532907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  532910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  532913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532928 */     // MIs[0] round
     /*  532928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532938 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  532941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532947 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532960 */     GIR_RootConstrainSelectedInstOperands,
     /*  532961 */     // GIR_Coverage, 21702,
     /*  532961 */     GIR_EraseRootFromParent_Done,
     /*  532962 */   // Label 8841: @532962
     /*  532962 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(533033), // Rule ID 21703 //
     /*  532967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  532978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  532981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  532984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532999 */     // MIs[0] round
     /*  532999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533009 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  533012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533018 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533031 */     GIR_RootConstrainSelectedInstOperands,
     /*  533032 */     // GIR_Coverage, 21703,
     /*  533032 */     GIR_EraseRootFromParent_Done,
     /*  533033 */   // Label 8842: @533033
     /*  533033 */   GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(533104), // Rule ID 21706 //
     /*  533038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  533041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  533049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  533052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  533055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533070 */     // MIs[0] round
     /*  533070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533080 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533089 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533102 */     GIR_RootConstrainSelectedInstOperands,
     /*  533103 */     // GIR_Coverage, 21706,
     /*  533103 */     GIR_EraseRootFromParent_Done,
     /*  533104 */   // Label 8843: @533104
     /*  533104 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(533175), // Rule ID 21707 //
     /*  533109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  533112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  533120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  533123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  533126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533141 */     // MIs[0] round
     /*  533141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533151 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533160 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533173 */     GIR_RootConstrainSelectedInstOperands,
     /*  533174 */     // GIR_Coverage, 21707,
     /*  533174 */     GIR_EraseRootFromParent_Done,
     /*  533175 */   // Label 8844: @533175
     /*  533175 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(533246), // Rule ID 21710 //
     /*  533180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  533191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  533194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  533197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533212 */     // MIs[0] round
     /*  533212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533222 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  533225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533231 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533244 */     GIR_RootConstrainSelectedInstOperands,
     /*  533245 */     // GIR_Coverage, 21710,
     /*  533245 */     GIR_EraseRootFromParent_Done,
     /*  533246 */   // Label 8845: @533246
     /*  533246 */   GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(533317), // Rule ID 21711 //
     /*  533251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  533262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  533265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  533268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533283 */     // MIs[0] round
     /*  533283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533293 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  533296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533302 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533315 */     GIR_RootConstrainSelectedInstOperands,
     /*  533316 */     // GIR_Coverage, 21711,
     /*  533316 */     GIR_EraseRootFromParent_Done,
     /*  533317 */   // Label 8846: @533317
     /*  533317 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(533388), // Rule ID 21714 //
     /*  533322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  533333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  533336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  533339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533354 */     // MIs[0] round
     /*  533354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533364 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  533367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533373 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533386 */     GIR_RootConstrainSelectedInstOperands,
     /*  533387 */     // GIR_Coverage, 21714,
     /*  533387 */     GIR_EraseRootFromParent_Done,
     /*  533388 */   // Label 8847: @533388
     /*  533388 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(533459), // Rule ID 21715 //
     /*  533393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  533404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  533407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  533410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533425 */     // MIs[0] round
     /*  533425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533435 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  533438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533444 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533457 */     GIR_RootConstrainSelectedInstOperands,
     /*  533458 */     // GIR_Coverage, 21715,
     /*  533458 */     GIR_EraseRootFromParent_Done,
     /*  533459 */   // Label 8848: @533459
     /*  533459 */   GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(533530), // Rule ID 21718 //
     /*  533464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  533475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  533478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  533481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533496 */     // MIs[0] round
     /*  533496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533506 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  533509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533515 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533528 */     GIR_RootConstrainSelectedInstOperands,
     /*  533529 */     // GIR_Coverage, 21718,
     /*  533529 */     GIR_EraseRootFromParent_Done,
     /*  533530 */   // Label 8849: @533530
     /*  533530 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(533601), // Rule ID 21719 //
     /*  533535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  533546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  533549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  533552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533567 */     // MIs[0] round
     /*  533567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533577 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  533580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533586 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533599 */     GIR_RootConstrainSelectedInstOperands,
     /*  533600 */     // GIR_Coverage, 21719,
     /*  533600 */     GIR_EraseRootFromParent_Done,
     /*  533601 */   // Label 8850: @533601
     /*  533601 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(533672), // Rule ID 21722 //
     /*  533606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  533617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  533620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  533623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533638 */     // MIs[0] round
     /*  533638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533648 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533657 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533670 */     GIR_RootConstrainSelectedInstOperands,
     /*  533671 */     // GIR_Coverage, 21722,
     /*  533671 */     GIR_EraseRootFromParent_Done,
     /*  533672 */   // Label 8851: @533672
     /*  533672 */   GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(533743), // Rule ID 21723 //
     /*  533677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  533688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  533691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  533694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533709 */     // MIs[0] round
     /*  533709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533719 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533728 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533741 */     GIR_RootConstrainSelectedInstOperands,
     /*  533742 */     // GIR_Coverage, 21723,
     /*  533742 */     GIR_EraseRootFromParent_Done,
     /*  533743 */   // Label 8852: @533743
     /*  533743 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(533814), // Rule ID 21846 //
     /*  533748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  533759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  533762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  533765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533780 */     // MIs[0] round
     /*  533780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533790 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  533793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533799 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533812 */     GIR_RootConstrainSelectedInstOperands,
     /*  533813 */     // GIR_Coverage, 21846,
     /*  533813 */     GIR_EraseRootFromParent_Done,
     /*  533814 */   // Label 8853: @533814
     /*  533814 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(533885), // Rule ID 21847 //
     /*  533819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  533830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  533833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  533836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533851 */     // MIs[0] round
     /*  533851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533861 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  533864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533870 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533883 */     GIR_RootConstrainSelectedInstOperands,
     /*  533884 */     // GIR_Coverage, 21847,
     /*  533884 */     GIR_EraseRootFromParent_Done,
     /*  533885 */   // Label 8854: @533885
     /*  533885 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(533956), // Rule ID 21850 //
     /*  533890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  533901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  533904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  533907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533922 */     // MIs[0] round
     /*  533922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533932 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  533935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533941 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533954 */     GIR_RootConstrainSelectedInstOperands,
     /*  533955 */     // GIR_Coverage, 21850,
     /*  533955 */     GIR_EraseRootFromParent_Done,
     /*  533956 */   // Label 8855: @533956
     /*  533956 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(534027), // Rule ID 21851 //
     /*  533961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  533972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  533975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  533978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533993 */     // MIs[0] round
     /*  533993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534003 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  534006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534012 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534025 */     GIR_RootConstrainSelectedInstOperands,
     /*  534026 */     // GIR_Coverage, 21851,
     /*  534026 */     GIR_EraseRootFromParent_Done,
     /*  534027 */   // Label 8856: @534027
     /*  534027 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(534098), // Rule ID 21854 //
     /*  534032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534064 */     // MIs[0] round
     /*  534064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534074 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  534077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534083 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534096 */     GIR_RootConstrainSelectedInstOperands,
     /*  534097 */     // GIR_Coverage, 21854,
     /*  534097 */     GIR_EraseRootFromParent_Done,
     /*  534098 */   // Label 8857: @534098
     /*  534098 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(534169), // Rule ID 21855 //
     /*  534103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534135 */     // MIs[0] round
     /*  534135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534145 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  534148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534154 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534167 */     GIR_RootConstrainSelectedInstOperands,
     /*  534168 */     // GIR_Coverage, 21855,
     /*  534168 */     GIR_EraseRootFromParent_Done,
     /*  534169 */   // Label 8858: @534169
     /*  534169 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(534240), // Rule ID 21858 //
     /*  534174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  534185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  534188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  534191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534206 */     // MIs[0] round
     /*  534206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534216 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  534219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534225 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534238 */     GIR_RootConstrainSelectedInstOperands,
     /*  534239 */     // GIR_Coverage, 21858,
     /*  534239 */     GIR_EraseRootFromParent_Done,
     /*  534240 */   // Label 8859: @534240
     /*  534240 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(534311), // Rule ID 21859 //
     /*  534245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  534256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  534259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  534262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534277 */     // MIs[0] round
     /*  534277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534287 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  534290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534296 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534309 */     GIR_RootConstrainSelectedInstOperands,
     /*  534310 */     // GIR_Coverage, 21859,
     /*  534310 */     GIR_EraseRootFromParent_Done,
     /*  534311 */   // Label 8860: @534311
     /*  534311 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(534382), // Rule ID 21862 //
     /*  534316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  534327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  534330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  534333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534348 */     // MIs[0] round
     /*  534348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534358 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  534361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534367 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534380 */     GIR_RootConstrainSelectedInstOperands,
     /*  534381 */     // GIR_Coverage, 21862,
     /*  534381 */     GIR_EraseRootFromParent_Done,
     /*  534382 */   // Label 8861: @534382
     /*  534382 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(534453), // Rule ID 21863 //
     /*  534387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  534398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  534401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  534404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534419 */     // MIs[0] round
     /*  534419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534429 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  534432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534438 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534451 */     GIR_RootConstrainSelectedInstOperands,
     /*  534452 */     // GIR_Coverage, 21863,
     /*  534452 */     GIR_EraseRootFromParent_Done,
     /*  534453 */   // Label 8862: @534453
     /*  534453 */   GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(534524), // Rule ID 21866 //
     /*  534458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  534461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  534475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534490 */     // MIs[0] round
     /*  534490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534500 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  534503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534509 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534522 */     GIR_RootConstrainSelectedInstOperands,
     /*  534523 */     // GIR_Coverage, 21866,
     /*  534523 */     GIR_EraseRootFromParent_Done,
     /*  534524 */   // Label 8863: @534524
     /*  534524 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(534595), // Rule ID 21867 //
     /*  534529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  534546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534561 */     // MIs[0] round
     /*  534561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534571 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  534574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534580 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534593 */     GIR_RootConstrainSelectedInstOperands,
     /*  534594 */     // GIR_Coverage, 21867,
     /*  534594 */     GIR_EraseRootFromParent_Done,
     /*  534595 */   // Label 8864: @534595
     /*  534595 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(534666), // Rule ID 21870 //
     /*  534600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  534603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  534611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  534614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  534617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534632 */     // MIs[0] round
     /*  534632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534642 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  534645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534651 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534664 */     GIR_RootConstrainSelectedInstOperands,
     /*  534665 */     // GIR_Coverage, 21870,
     /*  534665 */     GIR_EraseRootFromParent_Done,
     /*  534666 */   // Label 8865: @534666
     /*  534666 */   GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(534737), // Rule ID 21871 //
     /*  534671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  534682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  534685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  534688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534703 */     // MIs[0] round
     /*  534703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534713 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  534716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534722 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534735 */     GIR_RootConstrainSelectedInstOperands,
     /*  534736 */     // GIR_Coverage, 21871,
     /*  534736 */     GIR_EraseRootFromParent_Done,
     /*  534737 */   // Label 8866: @534737
     /*  534737 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(534808), // Rule ID 21874 //
     /*  534742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  534745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  534753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  534756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  534759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534774 */     // MIs[0] round
     /*  534774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534784 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  534787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534793 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534806 */     GIR_RootConstrainSelectedInstOperands,
     /*  534807 */     // GIR_Coverage, 21874,
     /*  534807 */     GIR_EraseRootFromParent_Done,
     /*  534808 */   // Label 8867: @534808
     /*  534808 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(534879), // Rule ID 21875 //
     /*  534813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  534824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  534827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  534830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534845 */     // MIs[0] round
     /*  534845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534855 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  534858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534864 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534877 */     GIR_RootConstrainSelectedInstOperands,
     /*  534878 */     // GIR_Coverage, 21875,
     /*  534878 */     GIR_EraseRootFromParent_Done,
     /*  534879 */   // Label 8868: @534879
     /*  534879 */   GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(534950), // Rule ID 21878 //
     /*  534884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  534887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  534895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  534898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  534901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534916 */     // MIs[0] round
     /*  534916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534926 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  534929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534935 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534948 */     GIR_RootConstrainSelectedInstOperands,
     /*  534949 */     // GIR_Coverage, 21878,
     /*  534949 */     GIR_EraseRootFromParent_Done,
     /*  534950 */   // Label 8869: @534950
     /*  534950 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(535021), // Rule ID 21879 //
     /*  534955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  534966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  534969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  534972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534987 */     // MIs[0] round
     /*  534987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534997 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  535000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535006 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535019 */     GIR_RootConstrainSelectedInstOperands,
     /*  535020 */     // GIR_Coverage, 21879,
     /*  535020 */     GIR_EraseRootFromParent_Done,
     /*  535021 */   // Label 8870: @535021
     /*  535021 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(535092), // Rule ID 21882 //
     /*  535026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  535037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  535040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  535043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535058 */     // MIs[0] round
     /*  535058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535068 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  535071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535077 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535090 */     GIR_RootConstrainSelectedInstOperands,
     /*  535091 */     // GIR_Coverage, 21882,
     /*  535091 */     GIR_EraseRootFromParent_Done,
     /*  535092 */   // Label 8871: @535092
     /*  535092 */   GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(535163), // Rule ID 21883 //
     /*  535097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  535108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  535111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  535114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535129 */     // MIs[0] round
     /*  535129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535139 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  535142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535148 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535161 */     GIR_RootConstrainSelectedInstOperands,
     /*  535162 */     // GIR_Coverage, 21883,
     /*  535162 */     GIR_EraseRootFromParent_Done,
     /*  535163 */   // Label 8872: @535163
     /*  535163 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(535234), // Rule ID 21886 //
     /*  535168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  535179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  535182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  535185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535200 */     // MIs[0] round
     /*  535200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535210 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  535213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535219 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535232 */     GIR_RootConstrainSelectedInstOperands,
     /*  535233 */     // GIR_Coverage, 21886,
     /*  535233 */     GIR_EraseRootFromParent_Done,
     /*  535234 */   // Label 8873: @535234
     /*  535234 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(535305), // Rule ID 21887 //
     /*  535239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  535250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  535253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  535256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535271 */     // MIs[0] round
     /*  535271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535281 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  535284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535290 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535303 */     GIR_RootConstrainSelectedInstOperands,
     /*  535304 */     // GIR_Coverage, 21887,
     /*  535304 */     GIR_EraseRootFromParent_Done,
     /*  535305 */   // Label 8874: @535305
     /*  535305 */   GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(535376), // Rule ID 21890 //
     /*  535310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  535321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  535324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  535327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535342 */     // MIs[0] round
     /*  535342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  535355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535361 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535374 */     GIR_RootConstrainSelectedInstOperands,
     /*  535375 */     // GIR_Coverage, 21890,
     /*  535375 */     GIR_EraseRootFromParent_Done,
     /*  535376 */   // Label 8875: @535376
     /*  535376 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(535447), // Rule ID 21891 //
     /*  535381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  535392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  535395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  535398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535413 */     // MIs[0] round
     /*  535413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535423 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  535426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535432 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535445 */     GIR_RootConstrainSelectedInstOperands,
     /*  535446 */     // GIR_Coverage, 21891,
     /*  535446 */     GIR_EraseRootFromParent_Done,
     /*  535447 */   // Label 8876: @535447
     /*  535447 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(535518), // Rule ID 21894 //
     /*  535452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  535463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  535466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  535469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535484 */     // MIs[0] round
     /*  535484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535494 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  535497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535503 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535516 */     GIR_RootConstrainSelectedInstOperands,
     /*  535517 */     // GIR_Coverage, 21894,
     /*  535517 */     GIR_EraseRootFromParent_Done,
     /*  535518 */   // Label 8877: @535518
     /*  535518 */   GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(535589), // Rule ID 21895 //
     /*  535523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  535534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  535537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  535540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535555 */     // MIs[0] round
     /*  535555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535565 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  535568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535574 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535587 */     GIR_RootConstrainSelectedInstOperands,
     /*  535588 */     // GIR_Coverage, 21895,
     /*  535588 */     GIR_EraseRootFromParent_Done,
     /*  535589 */   // Label 8878: @535589
     /*  535589 */   GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(535660), // Rule ID 21898 //
     /*  535594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  535605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  535608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  535611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535626 */     // MIs[0] round
     /*  535626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535636 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  535639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535645 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535658 */     GIR_RootConstrainSelectedInstOperands,
     /*  535659 */     // GIR_Coverage, 21898,
     /*  535659 */     GIR_EraseRootFromParent_Done,
     /*  535660 */   // Label 8879: @535660
     /*  535660 */   GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(535731), // Rule ID 21899 //
     /*  535665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  535676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  535679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  535682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535697 */     // MIs[0] round
     /*  535697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535707 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  535710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535716 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535729 */     GIR_RootConstrainSelectedInstOperands,
     /*  535730 */     // GIR_Coverage, 21899,
     /*  535730 */     GIR_EraseRootFromParent_Done,
     /*  535731 */   // Label 8880: @535731
     /*  535731 */   GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(535802), // Rule ID 21902 //
     /*  535736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  535747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  535750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  535753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535768 */     // MIs[0] round
     /*  535768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535778 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  535781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535787 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535800 */     GIR_RootConstrainSelectedInstOperands,
     /*  535801 */     // GIR_Coverage, 21902,
     /*  535801 */     GIR_EraseRootFromParent_Done,
     /*  535802 */   // Label 8881: @535802
     /*  535802 */   GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(535873), // Rule ID 21903 //
     /*  535807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  535818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  535821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  535824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535839 */     // MIs[0] round
     /*  535839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535849 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  535852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535858 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535871 */     GIR_RootConstrainSelectedInstOperands,
     /*  535872 */     // GIR_Coverage, 21903,
     /*  535872 */     GIR_EraseRootFromParent_Done,
     /*  535873 */   // Label 8882: @535873
     /*  535873 */   GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(535944), // Rule ID 21906 //
     /*  535878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535910 */     // MIs[0] round
     /*  535910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535920 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  535923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535929 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535942 */     GIR_RootConstrainSelectedInstOperands,
     /*  535943 */     // GIR_Coverage, 21906,
     /*  535943 */     GIR_EraseRootFromParent_Done,
     /*  535944 */   // Label 8883: @535944
     /*  535944 */   GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(536015), // Rule ID 21907 //
     /*  535949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535981 */     // MIs[0] round
     /*  535981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535991 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  535994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536000 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536013 */     GIR_RootConstrainSelectedInstOperands,
     /*  536014 */     // GIR_Coverage, 21907,
     /*  536014 */     GIR_EraseRootFromParent_Done,
     /*  536015 */   // Label 8884: @536015
     /*  536015 */   GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(536086), // Rule ID 21910 //
     /*  536020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  536023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  536031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  536034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  536037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536052 */     // MIs[0] round
     /*  536052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536062 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  536065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536071 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536084 */     GIR_RootConstrainSelectedInstOperands,
     /*  536085 */     // GIR_Coverage, 21910,
     /*  536085 */     GIR_EraseRootFromParent_Done,
     /*  536086 */   // Label 8885: @536086
     /*  536086 */   GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(536157), // Rule ID 21911 //
     /*  536091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  536094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  536102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  536105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  536108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536123 */     // MIs[0] round
     /*  536123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536133 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  536136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536142 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536155 */     GIR_RootConstrainSelectedInstOperands,
     /*  536156 */     // GIR_Coverage, 21911,
     /*  536156 */     GIR_EraseRootFromParent_Done,
     /*  536157 */   // Label 8886: @536157
     /*  536157 */   GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(536228), // Rule ID 21914 //
     /*  536162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  536165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  536173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  536176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  536179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536194 */     // MIs[0] round
     /*  536194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536204 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  536207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536213 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536226 */     GIR_RootConstrainSelectedInstOperands,
     /*  536227 */     // GIR_Coverage, 21914,
     /*  536227 */     GIR_EraseRootFromParent_Done,
     /*  536228 */   // Label 8887: @536228
     /*  536228 */   GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(536299), // Rule ID 21915 //
     /*  536233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  536236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  536244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  536247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  536250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536265 */     // MIs[0] round
     /*  536265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536275 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  536278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536284 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536297 */     GIR_RootConstrainSelectedInstOperands,
     /*  536298 */     // GIR_Coverage, 21915,
     /*  536298 */     GIR_EraseRootFromParent_Done,
     /*  536299 */   // Label 8888: @536299
     /*  536299 */   GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(536370), // Rule ID 21918 //
     /*  536304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536336 */     // MIs[0] round
     /*  536336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536346 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  536349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536355 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536368 */     GIR_RootConstrainSelectedInstOperands,
     /*  536369 */     // GIR_Coverage, 21918,
     /*  536369 */     GIR_EraseRootFromParent_Done,
     /*  536370 */   // Label 8889: @536370
     /*  536370 */   GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(536441), // Rule ID 21919 //
     /*  536375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536407 */     // MIs[0] round
     /*  536407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536417 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  536420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536426 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536439 */     GIR_RootConstrainSelectedInstOperands,
     /*  536440 */     // GIR_Coverage, 21919,
     /*  536440 */     GIR_EraseRootFromParent_Done,
     /*  536441 */   // Label 8890: @536441
     /*  536441 */   GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(536512), // Rule ID 21922 //
     /*  536446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536478 */     // MIs[0] round
     /*  536478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536488 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  536491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536497 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536510 */     GIR_RootConstrainSelectedInstOperands,
     /*  536511 */     // GIR_Coverage, 21922,
     /*  536511 */     GIR_EraseRootFromParent_Done,
     /*  536512 */   // Label 8891: @536512
     /*  536512 */   GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(536583), // Rule ID 21923 //
     /*  536517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536549 */     // MIs[0] round
     /*  536549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536559 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  536562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536568 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536581 */     GIR_RootConstrainSelectedInstOperands,
     /*  536582 */     // GIR_Coverage, 21923,
     /*  536582 */     GIR_EraseRootFromParent_Done,
     /*  536583 */   // Label 8892: @536583
     /*  536583 */   GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(536654), // Rule ID 21926 //
     /*  536588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  536599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  536602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  536605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536620 */     // MIs[0] round
     /*  536620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536630 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  536633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536639 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536652 */     GIR_RootConstrainSelectedInstOperands,
     /*  536653 */     // GIR_Coverage, 21926,
     /*  536653 */     GIR_EraseRootFromParent_Done,
     /*  536654 */   // Label 8893: @536654
     /*  536654 */   GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(536725), // Rule ID 21927 //
     /*  536659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  536670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  536673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  536676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536691 */     // MIs[0] round
     /*  536691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536701 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  536704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536710 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536723 */     GIR_RootConstrainSelectedInstOperands,
     /*  536724 */     // GIR_Coverage, 21927,
     /*  536724 */     GIR_EraseRootFromParent_Done,
     /*  536725 */   // Label 8894: @536725
     /*  536725 */   GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(536796), // Rule ID 21930 //
     /*  536730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  536741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  536744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  536747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536762 */     // MIs[0] round
     /*  536762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536772 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  536775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536781 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536794 */     GIR_RootConstrainSelectedInstOperands,
     /*  536795 */     // GIR_Coverage, 21930,
     /*  536795 */     GIR_EraseRootFromParent_Done,
     /*  536796 */   // Label 8895: @536796
     /*  536796 */   GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(536867), // Rule ID 21931 //
     /*  536801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  536812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  536815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  536818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536833 */     // MIs[0] round
     /*  536833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536843 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  536846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536852 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536865 */     GIR_RootConstrainSelectedInstOperands,
     /*  536866 */     // GIR_Coverage, 21931,
     /*  536866 */     GIR_EraseRootFromParent_Done,
     /*  536867 */   // Label 8896: @536867
     /*  536867 */   GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(536938), // Rule ID 21934 //
     /*  536872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  536883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536904 */     // MIs[0] round
     /*  536904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536914 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  536917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536923 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536936 */     GIR_RootConstrainSelectedInstOperands,
     /*  536937 */     // GIR_Coverage, 21934,
     /*  536937 */     GIR_EraseRootFromParent_Done,
     /*  536938 */   // Label 8897: @536938
     /*  536938 */   GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(537009), // Rule ID 21935 //
     /*  536943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  536954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536975 */     // MIs[0] round
     /*  536975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536985 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  536988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536994 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537007 */     GIR_RootConstrainSelectedInstOperands,
     /*  537008 */     // GIR_Coverage, 21935,
     /*  537008 */     GIR_EraseRootFromParent_Done,
     /*  537009 */   // Label 8898: @537009
     /*  537009 */   GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(537080), // Rule ID 21938 //
     /*  537014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  537031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537046 */     // MIs[0] round
     /*  537046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537056 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  537059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537065 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537078 */     GIR_RootConstrainSelectedInstOperands,
     /*  537079 */     // GIR_Coverage, 21938,
     /*  537079 */     GIR_EraseRootFromParent_Done,
     /*  537080 */   // Label 8899: @537080
     /*  537080 */   GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(537151), // Rule ID 21939 //
     /*  537085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  537102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537117 */     // MIs[0] round
     /*  537117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537127 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  537130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537136 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537149 */     GIR_RootConstrainSelectedInstOperands,
     /*  537150 */     // GIR_Coverage, 21939,
     /*  537150 */     GIR_EraseRootFromParent_Done,
     /*  537151 */   // Label 8900: @537151
     /*  537151 */   GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(537222), // Rule ID 21942 //
     /*  537156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  537167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  537170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  537173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537188 */     // MIs[0] round
     /*  537188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537198 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  537201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537207 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537220 */     GIR_RootConstrainSelectedInstOperands,
     /*  537221 */     // GIR_Coverage, 21942,
     /*  537221 */     GIR_EraseRootFromParent_Done,
     /*  537222 */   // Label 8901: @537222
     /*  537222 */   GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(537293), // Rule ID 21943 //
     /*  537227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  537238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  537241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  537244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537259 */     // MIs[0] round
     /*  537259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537269 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  537272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537278 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537291 */     GIR_RootConstrainSelectedInstOperands,
     /*  537292 */     // GIR_Coverage, 21943,
     /*  537292 */     GIR_EraseRootFromParent_Done,
     /*  537293 */   // Label 8902: @537293
     /*  537293 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(537364), // Rule ID 21946 //
     /*  537298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  537309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  537312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  537315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537330 */     // MIs[0] round
     /*  537330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537340 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  537343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537349 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537362 */     GIR_RootConstrainSelectedInstOperands,
     /*  537363 */     // GIR_Coverage, 21946,
     /*  537363 */     GIR_EraseRootFromParent_Done,
     /*  537364 */   // Label 8903: @537364
     /*  537364 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(537435), // Rule ID 21947 //
     /*  537369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  537380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  537383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  537386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537401 */     // MIs[0] round
     /*  537401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537411 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  537414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537420 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537433 */     GIR_RootConstrainSelectedInstOperands,
     /*  537434 */     // GIR_Coverage, 21947,
     /*  537434 */     GIR_EraseRootFromParent_Done,
     /*  537435 */   // Label 8904: @537435
     /*  537435 */   GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(537506), // Rule ID 21950 //
     /*  537440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  537451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  537454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  537457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537472 */     // MIs[0] round
     /*  537472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537482 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  537485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537491 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537504 */     GIR_RootConstrainSelectedInstOperands,
     /*  537505 */     // GIR_Coverage, 21950,
     /*  537505 */     GIR_EraseRootFromParent_Done,
     /*  537506 */   // Label 8905: @537506
     /*  537506 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(537577), // Rule ID 21951 //
     /*  537511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  537522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  537525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  537528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537543 */     // MIs[0] round
     /*  537543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537553 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  537556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537562 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537575 */     GIR_RootConstrainSelectedInstOperands,
     /*  537576 */     // GIR_Coverage, 21951,
     /*  537576 */     GIR_EraseRootFromParent_Done,
     /*  537577 */   // Label 8906: @537577
     /*  537577 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(537648), // Rule ID 2760 //
     /*  537582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  537593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  537596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  537599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537610 */     // MIs[0] passthru
     /*  537610 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537626 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  537629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537646 */     GIR_RootConstrainSelectedInstOperands,
     /*  537647 */     // GIR_Coverage, 2760,
     /*  537647 */     GIR_EraseRootFromParent_Done,
     /*  537648 */   // Label 8907: @537648
     /*  537648 */   GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(537719), // Rule ID 2761 //
     /*  537653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  537664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  537667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  537670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537681 */     // MIs[0] passthru
     /*  537681 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537697 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  537700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537717 */     GIR_RootConstrainSelectedInstOperands,
     /*  537718 */     // GIR_Coverage, 2761,
     /*  537718 */     GIR_EraseRootFromParent_Done,
     /*  537719 */   // Label 8908: @537719
     /*  537719 */   GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(537790), // Rule ID 4076 //
     /*  537724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  537735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  537738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  537741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537752 */     // MIs[0] passthru
     /*  537752 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  537771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537788 */     GIR_RootConstrainSelectedInstOperands,
     /*  537789 */     // GIR_Coverage, 4076,
     /*  537789 */     GIR_EraseRootFromParent_Done,
     /*  537790 */   // Label 8909: @537790
     /*  537790 */   GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(537861), // Rule ID 4077 //
     /*  537795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  537806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  537809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  537812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537823 */     // MIs[0] passthru
     /*  537823 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537839 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  537842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537859 */     GIR_RootConstrainSelectedInstOperands,
     /*  537860 */     // GIR_Coverage, 4077,
     /*  537860 */     GIR_EraseRootFromParent_Done,
     /*  537861 */   // Label 8910: @537861
     /*  537861 */   GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(537932), // Rule ID 4086 //
     /*  537866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  537883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537894 */     // MIs[0] passthru
     /*  537894 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537910 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  537913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537930 */     GIR_RootConstrainSelectedInstOperands,
     /*  537931 */     // GIR_Coverage, 4086,
     /*  537931 */     GIR_EraseRootFromParent_Done,
     /*  537932 */   // Label 8911: @537932
     /*  537932 */   GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(538003), // Rule ID 4087 //
     /*  537937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  537954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537965 */     // MIs[0] passthru
     /*  537965 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537981 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  537984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538001 */     GIR_RootConstrainSelectedInstOperands,
     /*  538002 */     // GIR_Coverage, 4087,
     /*  538002 */     GIR_EraseRootFromParent_Done,
     /*  538003 */   // Label 8912: @538003
     /*  538003 */   GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(538074), // Rule ID 4096 //
     /*  538008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  538019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  538022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  538025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538036 */     // MIs[0] passthru
     /*  538036 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538052 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538072 */     GIR_RootConstrainSelectedInstOperands,
     /*  538073 */     // GIR_Coverage, 4096,
     /*  538073 */     GIR_EraseRootFromParent_Done,
     /*  538074 */   // Label 8913: @538074
     /*  538074 */   GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(538145), // Rule ID 4097 //
     /*  538079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  538090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  538093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  538096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538107 */     // MIs[0] passthru
     /*  538107 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538123 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538143 */     GIR_RootConstrainSelectedInstOperands,
     /*  538144 */     // GIR_Coverage, 4097,
     /*  538144 */     GIR_EraseRootFromParent_Done,
     /*  538145 */   // Label 8914: @538145
     /*  538145 */   GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(538216), // Rule ID 4106 //
     /*  538150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  538161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  538164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  538167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538178 */     // MIs[0] passthru
     /*  538178 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538194 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538214 */     GIR_RootConstrainSelectedInstOperands,
     /*  538215 */     // GIR_Coverage, 4106,
     /*  538215 */     GIR_EraseRootFromParent_Done,
     /*  538216 */   // Label 8915: @538216
     /*  538216 */   GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(538287), // Rule ID 4107 //
     /*  538221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  538232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  538235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  538238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538249 */     // MIs[0] passthru
     /*  538249 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538265 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538285 */     GIR_RootConstrainSelectedInstOperands,
     /*  538286 */     // GIR_Coverage, 4107,
     /*  538286 */     GIR_EraseRootFromParent_Done,
     /*  538287 */   // Label 8916: @538287
     /*  538287 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(538358), // Rule ID 4116 //
     /*  538292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  538303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  538306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  538309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538320 */     // MIs[0] passthru
     /*  538320 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538336 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  538339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538356 */     GIR_RootConstrainSelectedInstOperands,
     /*  538357 */     // GIR_Coverage, 4116,
     /*  538357 */     GIR_EraseRootFromParent_Done,
     /*  538358 */   // Label 8917: @538358
     /*  538358 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(538429), // Rule ID 4117 //
     /*  538363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  538374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  538377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  538380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538391 */     // MIs[0] passthru
     /*  538391 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538407 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  538410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538427 */     GIR_RootConstrainSelectedInstOperands,
     /*  538428 */     // GIR_Coverage, 4117,
     /*  538428 */     GIR_EraseRootFromParent_Done,
     /*  538429 */   // Label 8918: @538429
     /*  538429 */   GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(538500), // Rule ID 4126 //
     /*  538434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  538445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  538448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  538451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538462 */     // MIs[0] passthru
     /*  538462 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  538481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538498 */     GIR_RootConstrainSelectedInstOperands,
     /*  538499 */     // GIR_Coverage, 4126,
     /*  538499 */     GIR_EraseRootFromParent_Done,
     /*  538500 */   // Label 8919: @538500
     /*  538500 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(538571), // Rule ID 4127 //
     /*  538505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  538516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  538519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  538522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538533 */     // MIs[0] passthru
     /*  538533 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538549 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  538552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538569 */     GIR_RootConstrainSelectedInstOperands,
     /*  538570 */     // GIR_Coverage, 4127,
     /*  538570 */     GIR_EraseRootFromParent_Done,
     /*  538571 */   // Label 8920: @538571
     /*  538571 */   GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(538642), // Rule ID 4136 //
     /*  538576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  538587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  538590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  538593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538604 */     // MIs[0] passthru
     /*  538604 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538620 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  538623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538640 */     GIR_RootConstrainSelectedInstOperands,
     /*  538641 */     // GIR_Coverage, 4136,
     /*  538641 */     GIR_EraseRootFromParent_Done,
     /*  538642 */   // Label 8921: @538642
     /*  538642 */   GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(538713), // Rule ID 4137 //
     /*  538647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  538658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  538661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  538664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538675 */     // MIs[0] passthru
     /*  538675 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538691 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  538694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538711 */     GIR_RootConstrainSelectedInstOperands,
     /*  538712 */     // GIR_Coverage, 4137,
     /*  538712 */     GIR_EraseRootFromParent_Done,
     /*  538713 */   // Label 8922: @538713
     /*  538713 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(538784), // Rule ID 4146 //
     /*  538718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  538729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  538732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  538735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538746 */     // MIs[0] passthru
     /*  538746 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538782 */     GIR_RootConstrainSelectedInstOperands,
     /*  538783 */     // GIR_Coverage, 4146,
     /*  538783 */     GIR_EraseRootFromParent_Done,
     /*  538784 */   // Label 8923: @538784
     /*  538784 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(538855), // Rule ID 4147 //
     /*  538789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  538800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  538803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  538806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538817 */     // MIs[0] passthru
     /*  538817 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538833 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538853 */     GIR_RootConstrainSelectedInstOperands,
     /*  538854 */     // GIR_Coverage, 4147,
     /*  538854 */     GIR_EraseRootFromParent_Done,
     /*  538855 */   // Label 8924: @538855
     /*  538855 */   GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(538926), // Rule ID 4156 //
     /*  538860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  538871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  538874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  538877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538888 */     // MIs[0] passthru
     /*  538888 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538904 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538924 */     GIR_RootConstrainSelectedInstOperands,
     /*  538925 */     // GIR_Coverage, 4156,
     /*  538925 */     GIR_EraseRootFromParent_Done,
     /*  538926 */   // Label 8925: @538926
     /*  538926 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(538997), // Rule ID 4157 //
     /*  538931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  538942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  538945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  538948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538959 */     // MIs[0] passthru
     /*  538959 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538975 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538995 */     GIR_RootConstrainSelectedInstOperands,
     /*  538996 */     // GIR_Coverage, 4157,
     /*  538996 */     GIR_EraseRootFromParent_Done,
     /*  538997 */   // Label 8926: @538997
     /*  538997 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(539068), // Rule ID 4166 //
     /*  539002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  539013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  539016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  539019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539030 */     // MIs[0] passthru
     /*  539030 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539066 */     GIR_RootConstrainSelectedInstOperands,
     /*  539067 */     // GIR_Coverage, 4166,
     /*  539067 */     GIR_EraseRootFromParent_Done,
     /*  539068 */   // Label 8927: @539068
     /*  539068 */   GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(539139), // Rule ID 4167 //
     /*  539073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  539084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  539087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  539090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539101 */     // MIs[0] passthru
     /*  539101 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539117 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539137 */     GIR_RootConstrainSelectedInstOperands,
     /*  539138 */     // GIR_Coverage, 4167,
     /*  539138 */     GIR_EraseRootFromParent_Done,
     /*  539139 */   // Label 8928: @539139
     /*  539139 */   GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(539210), // Rule ID 4176 //
     /*  539144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  539155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  539158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  539161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539172 */     // MIs[0] passthru
     /*  539172 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539188 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  539191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539208 */     GIR_RootConstrainSelectedInstOperands,
     /*  539209 */     // GIR_Coverage, 4176,
     /*  539209 */     GIR_EraseRootFromParent_Done,
     /*  539210 */   // Label 8929: @539210
     /*  539210 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(539281), // Rule ID 4177 //
     /*  539215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  539226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  539229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  539232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539243 */     // MIs[0] passthru
     /*  539243 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539259 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  539262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539279 */     GIR_RootConstrainSelectedInstOperands,
     /*  539280 */     // GIR_Coverage, 4177,
     /*  539280 */     GIR_EraseRootFromParent_Done,
     /*  539281 */   // Label 8930: @539281
     /*  539281 */   GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(539352), // Rule ID 4186 //
     /*  539286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  539297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  539300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  539303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539314 */     // MIs[0] passthru
     /*  539314 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539330 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  539333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539350 */     GIR_RootConstrainSelectedInstOperands,
     /*  539351 */     // GIR_Coverage, 4186,
     /*  539351 */     GIR_EraseRootFromParent_Done,
     /*  539352 */   // Label 8931: @539352
     /*  539352 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(539423), // Rule ID 4187 //
     /*  539357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  539368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  539371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  539374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539385 */     // MIs[0] passthru
     /*  539385 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539401 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  539404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539421 */     GIR_RootConstrainSelectedInstOperands,
     /*  539422 */     // GIR_Coverage, 4187,
     /*  539422 */     GIR_EraseRootFromParent_Done,
     /*  539423 */   // Label 8932: @539423
     /*  539423 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(539494), // Rule ID 4196 //
     /*  539428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  539439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  539442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  539445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539456 */     // MIs[0] passthru
     /*  539456 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539472 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  539475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539492 */     GIR_RootConstrainSelectedInstOperands,
     /*  539493 */     // GIR_Coverage, 4196,
     /*  539493 */     GIR_EraseRootFromParent_Done,
     /*  539494 */   // Label 8933: @539494
     /*  539494 */   GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(539565), // Rule ID 4197 //
     /*  539499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  539510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  539513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  539516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539527 */     // MIs[0] passthru
     /*  539527 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539543 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  539546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539563 */     GIR_RootConstrainSelectedInstOperands,
     /*  539564 */     // GIR_Coverage, 4197,
     /*  539564 */     GIR_EraseRootFromParent_Done,
     /*  539565 */   // Label 8934: @539565
     /*  539565 */   GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(539636), // Rule ID 4206 //
     /*  539570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  539581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  539584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  539587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539598 */     // MIs[0] passthru
     /*  539598 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539614 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539634 */     GIR_RootConstrainSelectedInstOperands,
     /*  539635 */     // GIR_Coverage, 4206,
     /*  539635 */     GIR_EraseRootFromParent_Done,
     /*  539636 */   // Label 8935: @539636
     /*  539636 */   GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(539707), // Rule ID 4207 //
     /*  539641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  539652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  539655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  539658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539669 */     // MIs[0] passthru
     /*  539669 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539685 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539705 */     GIR_RootConstrainSelectedInstOperands,
     /*  539706 */     // GIR_Coverage, 4207,
     /*  539706 */     GIR_EraseRootFromParent_Done,
     /*  539707 */   // Label 8936: @539707
     /*  539707 */   GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(539778), // Rule ID 4276 //
     /*  539712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  539723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  539726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  539729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539740 */     // MIs[0] passthru
     /*  539740 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539756 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  539756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  539759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539776 */     GIR_RootConstrainSelectedInstOperands,
     /*  539777 */     // GIR_Coverage, 4276,
     /*  539777 */     GIR_EraseRootFromParent_Done,
     /*  539778 */   // Label 8937: @539778
     /*  539778 */   GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(539849), // Rule ID 4277 //
     /*  539783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  539794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  539797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  539800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539811 */     // MIs[0] passthru
     /*  539811 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539827 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  539827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  539830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539847 */     GIR_RootConstrainSelectedInstOperands,
     /*  539848 */     // GIR_Coverage, 4277,
     /*  539848 */     GIR_EraseRootFromParent_Done,
     /*  539849 */   // Label 8938: @539849
     /*  539849 */   GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(539920), // Rule ID 4286 //
     /*  539854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  539865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  539868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  539871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539882 */     // MIs[0] passthru
     /*  539882 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539898 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  539898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  539901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539918 */     GIR_RootConstrainSelectedInstOperands,
     /*  539919 */     // GIR_Coverage, 4286,
     /*  539919 */     GIR_EraseRootFromParent_Done,
     /*  539920 */   // Label 8939: @539920
     /*  539920 */   GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(539991), // Rule ID 4287 //
     /*  539925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  539936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  539939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  539942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539953 */     // MIs[0] passthru
     /*  539953 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539969 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  539969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  539972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539989 */     GIR_RootConstrainSelectedInstOperands,
     /*  539990 */     // GIR_Coverage, 4287,
     /*  539990 */     GIR_EraseRootFromParent_Done,
     /*  539991 */   // Label 8940: @539991
     /*  539991 */   GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(540062), // Rule ID 4296 //
     /*  539996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  540007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  540010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  540013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540024 */     // MIs[0] passthru
     /*  540024 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540060 */     GIR_RootConstrainSelectedInstOperands,
     /*  540061 */     // GIR_Coverage, 4296,
     /*  540061 */     GIR_EraseRootFromParent_Done,
     /*  540062 */   // Label 8941: @540062
     /*  540062 */   GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(540133), // Rule ID 4297 //
     /*  540067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  540078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  540081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  540084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540095 */     // MIs[0] passthru
     /*  540095 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540111 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540131 */     GIR_RootConstrainSelectedInstOperands,
     /*  540132 */     // GIR_Coverage, 4297,
     /*  540132 */     GIR_EraseRootFromParent_Done,
     /*  540133 */   // Label 8942: @540133
     /*  540133 */   GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(540204), // Rule ID 4306 //
     /*  540138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  540149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  540152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  540155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540166 */     // MIs[0] passthru
     /*  540166 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540182 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540202 */     GIR_RootConstrainSelectedInstOperands,
     /*  540203 */     // GIR_Coverage, 4306,
     /*  540203 */     GIR_EraseRootFromParent_Done,
     /*  540204 */   // Label 8943: @540204
     /*  540204 */   GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(540275), // Rule ID 4307 //
     /*  540209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  540220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  540223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  540226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540237 */     // MIs[0] passthru
     /*  540237 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540253 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540273 */     GIR_RootConstrainSelectedInstOperands,
     /*  540274 */     // GIR_Coverage, 4307,
     /*  540274 */     GIR_EraseRootFromParent_Done,
     /*  540275 */   // Label 8944: @540275
     /*  540275 */   GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(540346), // Rule ID 4316 //
     /*  540280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  540291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  540294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  540297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540308 */     // MIs[0] passthru
     /*  540308 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540324 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  540327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540344 */     GIR_RootConstrainSelectedInstOperands,
     /*  540345 */     // GIR_Coverage, 4316,
     /*  540345 */     GIR_EraseRootFromParent_Done,
     /*  540346 */   // Label 8945: @540346
     /*  540346 */   GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(540417), // Rule ID 4317 //
     /*  540351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  540362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  540365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  540368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540379 */     // MIs[0] passthru
     /*  540379 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540395 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  540398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540415 */     GIR_RootConstrainSelectedInstOperands,
     /*  540416 */     // GIR_Coverage, 4317,
     /*  540416 */     GIR_EraseRootFromParent_Done,
     /*  540417 */   // Label 8946: @540417
     /*  540417 */   GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(540488), // Rule ID 4326 //
     /*  540422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  540433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  540436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  540439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540450 */     // MIs[0] passthru
     /*  540450 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540466 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  540469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540486 */     GIR_RootConstrainSelectedInstOperands,
     /*  540487 */     // GIR_Coverage, 4326,
     /*  540487 */     GIR_EraseRootFromParent_Done,
     /*  540488 */   // Label 8947: @540488
     /*  540488 */   GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(540559), // Rule ID 4327 //
     /*  540493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  540504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  540507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  540510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540521 */     // MIs[0] passthru
     /*  540521 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540537 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  540540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540557 */     GIR_RootConstrainSelectedInstOperands,
     /*  540558 */     // GIR_Coverage, 4327,
     /*  540558 */     GIR_EraseRootFromParent_Done,
     /*  540559 */   // Label 8948: @540559
     /*  540559 */   GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(540630), // Rule ID 4336 //
     /*  540564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  540575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  540578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  540581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540592 */     // MIs[0] passthru
     /*  540592 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540608 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  540611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540628 */     GIR_RootConstrainSelectedInstOperands,
     /*  540629 */     // GIR_Coverage, 4336,
     /*  540629 */     GIR_EraseRootFromParent_Done,
     /*  540630 */   // Label 8949: @540630
     /*  540630 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(540701), // Rule ID 4337 //
     /*  540635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  540646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  540649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  540652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540663 */     // MIs[0] passthru
     /*  540663 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540679 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  540682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540699 */     GIR_RootConstrainSelectedInstOperands,
     /*  540700 */     // GIR_Coverage, 4337,
     /*  540700 */     GIR_EraseRootFromParent_Done,
     /*  540701 */   // Label 8950: @540701
     /*  540701 */   GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(540772), // Rule ID 4346 //
     /*  540706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  540717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  540720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  540723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540734 */     // MIs[0] passthru
     /*  540734 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540750 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11687:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540770 */     GIR_RootConstrainSelectedInstOperands,
     /*  540771 */     // GIR_Coverage, 4346,
     /*  540771 */     GIR_EraseRootFromParent_Done,
     /*  540772 */   // Label 8951: @540772
     /*  540772 */   GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(540843), // Rule ID 4347 //
     /*  540777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  540788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  540791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  540794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540805 */     // MIs[0] passthru
     /*  540805 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540821 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11687:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540841 */     GIR_RootConstrainSelectedInstOperands,
     /*  540842 */     // GIR_Coverage, 4347,
     /*  540842 */     GIR_EraseRootFromParent_Done,
     /*  540843 */   // Label 8952: @540843
     /*  540843 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(540914), // Rule ID 4356 //
     /*  540848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  540859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  540862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  540865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540876 */     // MIs[0] passthru
     /*  540876 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540912 */     GIR_RootConstrainSelectedInstOperands,
     /*  540913 */     // GIR_Coverage, 4356,
     /*  540913 */     GIR_EraseRootFromParent_Done,
     /*  540914 */   // Label 8953: @540914
     /*  540914 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(540985), // Rule ID 4357 //
     /*  540919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  540930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  540933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  540936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540947 */     // MIs[0] passthru
     /*  540947 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540963 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540983 */     GIR_RootConstrainSelectedInstOperands,
     /*  540984 */     // GIR_Coverage, 4357,
     /*  540984 */     GIR_EraseRootFromParent_Done,
     /*  540985 */   // Label 8954: @540985
     /*  540985 */   GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(541056), // Rule ID 4366 //
     /*  540990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  541001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  541004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  541007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541018 */     // MIs[0] passthru
     /*  541018 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541034 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541054 */     GIR_RootConstrainSelectedInstOperands,
     /*  541055 */     // GIR_Coverage, 4366,
     /*  541055 */     GIR_EraseRootFromParent_Done,
     /*  541056 */   // Label 8955: @541056
     /*  541056 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(541127), // Rule ID 4367 //
     /*  541061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  541072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  541075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  541078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541089 */     // MIs[0] passthru
     /*  541089 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541105 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541125 */     GIR_RootConstrainSelectedInstOperands,
     /*  541126 */     // GIR_Coverage, 4367,
     /*  541126 */     GIR_EraseRootFromParent_Done,
     /*  541127 */   // Label 8956: @541127
     /*  541127 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(541198), // Rule ID 4376 //
     /*  541132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  541143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  541146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  541149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541160 */     // MIs[0] passthru
     /*  541160 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541176 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541196 */     GIR_RootConstrainSelectedInstOperands,
     /*  541197 */     // GIR_Coverage, 4376,
     /*  541197 */     GIR_EraseRootFromParent_Done,
     /*  541198 */   // Label 8957: @541198
     /*  541198 */   GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(541269), // Rule ID 4377 //
     /*  541203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  541214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  541217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  541220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541231 */     // MIs[0] passthru
     /*  541231 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541247 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541267 */     GIR_RootConstrainSelectedInstOperands,
     /*  541268 */     // GIR_Coverage, 4377,
     /*  541268 */     GIR_EraseRootFromParent_Done,
     /*  541269 */   // Label 8958: @541269
     /*  541269 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(541340), // Rule ID 4386 //
     /*  541274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  541285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  541288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  541291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541302 */     // MIs[0] passthru
     /*  541302 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541318 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  541321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541338 */     GIR_RootConstrainSelectedInstOperands,
     /*  541339 */     // GIR_Coverage, 4386,
     /*  541339 */     GIR_EraseRootFromParent_Done,
     /*  541340 */   // Label 8959: @541340
     /*  541340 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(541411), // Rule ID 4387 //
     /*  541345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  541356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  541359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  541362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541373 */     // MIs[0] passthru
     /*  541373 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541389 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  541392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541409 */     GIR_RootConstrainSelectedInstOperands,
     /*  541410 */     // GIR_Coverage, 4387,
     /*  541410 */     GIR_EraseRootFromParent_Done,
     /*  541411 */   // Label 8960: @541411
     /*  541411 */   GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(541482), // Rule ID 4396 //
     /*  541416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  541427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  541430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  541433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541444 */     // MIs[0] passthru
     /*  541444 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541460 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  541463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541480 */     GIR_RootConstrainSelectedInstOperands,
     /*  541481 */     // GIR_Coverage, 4396,
     /*  541481 */     GIR_EraseRootFromParent_Done,
     /*  541482 */   // Label 8961: @541482
     /*  541482 */   GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(541553), // Rule ID 4397 //
     /*  541487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  541498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  541501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  541504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541515 */     // MIs[0] passthru
     /*  541515 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  541534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541551 */     GIR_RootConstrainSelectedInstOperands,
     /*  541552 */     // GIR_Coverage, 4397,
     /*  541552 */     GIR_EraseRootFromParent_Done,
     /*  541553 */   // Label 8962: @541553
     /*  541553 */   GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(541624), // Rule ID 4406 //
     /*  541558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  541569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  541572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  541575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541586 */     // MIs[0] passthru
     /*  541586 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541602 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541622 */     GIR_RootConstrainSelectedInstOperands,
     /*  541623 */     // GIR_Coverage, 4406,
     /*  541623 */     GIR_EraseRootFromParent_Done,
     /*  541624 */   // Label 8963: @541624
     /*  541624 */   GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(541695), // Rule ID 4407 //
     /*  541629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  541640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  541643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  541646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541657 */     // MIs[0] passthru
     /*  541657 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541673 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541693 */     GIR_RootConstrainSelectedInstOperands,
     /*  541694 */     // GIR_Coverage, 4407,
     /*  541694 */     GIR_EraseRootFromParent_Done,
     /*  541695 */   // Label 8964: @541695
     /*  541695 */   GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(541766), // Rule ID 4416 //
     /*  541700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  541711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  541714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  541717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541728 */     // MIs[0] passthru
     /*  541728 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541744 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541764 */     GIR_RootConstrainSelectedInstOperands,
     /*  541765 */     // GIR_Coverage, 4416,
     /*  541765 */     GIR_EraseRootFromParent_Done,
     /*  541766 */   // Label 8965: @541766
     /*  541766 */   GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(541837), // Rule ID 4417 //
     /*  541771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  541782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  541785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  541788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541799 */     // MIs[0] passthru
     /*  541799 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541815 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541835 */     GIR_RootConstrainSelectedInstOperands,
     /*  541836 */     // GIR_Coverage, 4417,
     /*  541836 */     GIR_EraseRootFromParent_Done,
     /*  541837 */   // Label 8966: @541837
     /*  541837 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(541908), // Rule ID 4486 //
     /*  541842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  541853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  541856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  541859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541870 */     // MIs[0] passthru
     /*  541870 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541886 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  541889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541906 */     GIR_RootConstrainSelectedInstOperands,
     /*  541907 */     // GIR_Coverage, 4486,
     /*  541907 */     GIR_EraseRootFromParent_Done,
     /*  541908 */   // Label 8967: @541908
     /*  541908 */   GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(541979), // Rule ID 4487 //
     /*  541913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  541924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  541927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  541930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541941 */     // MIs[0] passthru
     /*  541941 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541957 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  541960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541977 */     GIR_RootConstrainSelectedInstOperands,
     /*  541978 */     // GIR_Coverage, 4487,
     /*  541978 */     GIR_EraseRootFromParent_Done,
     /*  541979 */   // Label 8968: @541979
     /*  541979 */   GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(542050), // Rule ID 4496 //
     /*  541984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  541995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  541998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  542001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542012 */     // MIs[0] passthru
     /*  542012 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542028 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542048 */     GIR_RootConstrainSelectedInstOperands,
     /*  542049 */     // GIR_Coverage, 4496,
     /*  542049 */     GIR_EraseRootFromParent_Done,
     /*  542050 */   // Label 8969: @542050
     /*  542050 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(542121), // Rule ID 4497 //
     /*  542055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  542066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  542069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  542072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542083 */     // MIs[0] passthru
     /*  542083 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542099 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542119 */     GIR_RootConstrainSelectedInstOperands,
     /*  542120 */     // GIR_Coverage, 4497,
     /*  542120 */     GIR_EraseRootFromParent_Done,
     /*  542121 */   // Label 8970: @542121
     /*  542121 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(542192), // Rule ID 4506 //
     /*  542126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  542137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  542140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  542143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542154 */     // MIs[0] passthru
     /*  542154 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542170 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542190 */     GIR_RootConstrainSelectedInstOperands,
     /*  542191 */     // GIR_Coverage, 4506,
     /*  542191 */     GIR_EraseRootFromParent_Done,
     /*  542192 */   // Label 8971: @542192
     /*  542192 */   GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(542263), // Rule ID 4507 //
     /*  542197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  542208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  542211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  542214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542225 */     // MIs[0] passthru
     /*  542225 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542241 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542261 */     GIR_RootConstrainSelectedInstOperands,
     /*  542262 */     // GIR_Coverage, 4507,
     /*  542262 */     GIR_EraseRootFromParent_Done,
     /*  542263 */   // Label 8972: @542263
     /*  542263 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(542334), // Rule ID 4516 //
     /*  542268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  542279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  542282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  542285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542296 */     // MIs[0] passthru
     /*  542296 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542312 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  542315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542332 */     GIR_RootConstrainSelectedInstOperands,
     /*  542333 */     // GIR_Coverage, 4516,
     /*  542333 */     GIR_EraseRootFromParent_Done,
     /*  542334 */   // Label 8973: @542334
     /*  542334 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(542405), // Rule ID 4517 //
     /*  542339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  542350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  542353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  542356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542367 */     // MIs[0] passthru
     /*  542367 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542383 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  542386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542403 */     GIR_RootConstrainSelectedInstOperands,
     /*  542404 */     // GIR_Coverage, 4517,
     /*  542404 */     GIR_EraseRootFromParent_Done,
     /*  542405 */   // Label 8974: @542405
     /*  542405 */   GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(542476), // Rule ID 4526 //
     /*  542410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  542421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  542424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  542427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542438 */     // MIs[0] passthru
     /*  542438 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542454 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  542457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542474 */     GIR_RootConstrainSelectedInstOperands,
     /*  542475 */     // GIR_Coverage, 4526,
     /*  542475 */     GIR_EraseRootFromParent_Done,
     /*  542476 */   // Label 8975: @542476
     /*  542476 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(542547), // Rule ID 4527 //
     /*  542481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  542492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  542495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  542498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542509 */     // MIs[0] passthru
     /*  542509 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542525 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  542528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542545 */     GIR_RootConstrainSelectedInstOperands,
     /*  542546 */     // GIR_Coverage, 4527,
     /*  542546 */     GIR_EraseRootFromParent_Done,
     /*  542547 */   // Label 8976: @542547
     /*  542547 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(542618), // Rule ID 4536 //
     /*  542552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  542563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  542566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  542569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542580 */     // MIs[0] passthru
     /*  542580 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542596 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  542599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542616 */     GIR_RootConstrainSelectedInstOperands,
     /*  542617 */     // GIR_Coverage, 4536,
     /*  542617 */     GIR_EraseRootFromParent_Done,
     /*  542618 */   // Label 8977: @542618
     /*  542618 */   GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(542689), // Rule ID 4537 //
     /*  542623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  542634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  542637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  542640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542651 */     // MIs[0] passthru
     /*  542651 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542667 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  542670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542687 */     GIR_RootConstrainSelectedInstOperands,
     /*  542688 */     // GIR_Coverage, 4537,
     /*  542688 */     GIR_EraseRootFromParent_Done,
     /*  542689 */   // Label 8978: @542689
     /*  542689 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(542760), // Rule ID 4546 //
     /*  542694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  542705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  542708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  542711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542722 */     // MIs[0] passthru
     /*  542722 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542738 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542758 */     GIR_RootConstrainSelectedInstOperands,
     /*  542759 */     // GIR_Coverage, 4546,
     /*  542759 */     GIR_EraseRootFromParent_Done,
     /*  542760 */   // Label 8979: @542760
     /*  542760 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(542831), // Rule ID 4547 //
     /*  542765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  542776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  542779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  542782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542793 */     // MIs[0] passthru
     /*  542793 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542809 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542829 */     GIR_RootConstrainSelectedInstOperands,
     /*  542830 */     // GIR_Coverage, 4547,
     /*  542830 */     GIR_EraseRootFromParent_Done,
     /*  542831 */   // Label 8980: @542831
     /*  542831 */   GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(542902), // Rule ID 4556 //
     /*  542836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  542847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  542850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  542853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542864 */     // MIs[0] passthru
     /*  542864 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542900 */     GIR_RootConstrainSelectedInstOperands,
     /*  542901 */     // GIR_Coverage, 4556,
     /*  542901 */     GIR_EraseRootFromParent_Done,
     /*  542902 */   // Label 8981: @542902
     /*  542902 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(542973), // Rule ID 4557 //
     /*  542907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  542918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  542921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  542924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542935 */     // MIs[0] passthru
     /*  542935 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542951 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542971 */     GIR_RootConstrainSelectedInstOperands,
     /*  542972 */     // GIR_Coverage, 4557,
     /*  542972 */     GIR_EraseRootFromParent_Done,
     /*  542973 */   // Label 8982: @542973
     /*  542973 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(543044), // Rule ID 4566 //
     /*  542978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  542989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  542992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  542995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543006 */     // MIs[0] passthru
     /*  543006 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543022 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543042 */     GIR_RootConstrainSelectedInstOperands,
     /*  543043 */     // GIR_Coverage, 4566,
     /*  543043 */     GIR_EraseRootFromParent_Done,
     /*  543044 */   // Label 8983: @543044
     /*  543044 */   GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(543115), // Rule ID 4567 //
     /*  543049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  543060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  543063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  543066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543077 */     // MIs[0] passthru
     /*  543077 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543093 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543113 */     GIR_RootConstrainSelectedInstOperands,
     /*  543114 */     // GIR_Coverage, 4567,
     /*  543114 */     GIR_EraseRootFromParent_Done,
     /*  543115 */   // Label 8984: @543115
     /*  543115 */   GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(543186), // Rule ID 4576 //
     /*  543120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  543131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  543134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  543137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543148 */     // MIs[0] passthru
     /*  543148 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543164 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543184 */     GIR_RootConstrainSelectedInstOperands,
     /*  543185 */     // GIR_Coverage, 4576,
     /*  543185 */     GIR_EraseRootFromParent_Done,
     /*  543186 */   // Label 8985: @543186
     /*  543186 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(543257), // Rule ID 4577 //
     /*  543191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  543202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  543205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  543208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543219 */     // MIs[0] passthru
     /*  543219 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543235 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543255 */     GIR_RootConstrainSelectedInstOperands,
     /*  543256 */     // GIR_Coverage, 4577,
     /*  543256 */     GIR_EraseRootFromParent_Done,
     /*  543257 */   // Label 8986: @543257
     /*  543257 */   GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(543328), // Rule ID 4586 //
     /*  543262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  543273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  543276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  543279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543290 */     // MIs[0] passthru
     /*  543290 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543306 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543326 */     GIR_RootConstrainSelectedInstOperands,
     /*  543327 */     // GIR_Coverage, 4586,
     /*  543327 */     GIR_EraseRootFromParent_Done,
     /*  543328 */   // Label 8987: @543328
     /*  543328 */   GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(543399), // Rule ID 4587 //
     /*  543333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  543344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  543347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  543350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543361 */     // MIs[0] passthru
     /*  543361 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543377 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543397 */     GIR_RootConstrainSelectedInstOperands,
     /*  543398 */     // GIR_Coverage, 4587,
     /*  543398 */     GIR_EraseRootFromParent_Done,
     /*  543399 */   // Label 8988: @543399
     /*  543399 */   GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(543470), // Rule ID 4596 //
     /*  543404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  543415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  543418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  543421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543432 */     // MIs[0] passthru
     /*  543432 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543448 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  543451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543468 */     GIR_RootConstrainSelectedInstOperands,
     /*  543469 */     // GIR_Coverage, 4596,
     /*  543469 */     GIR_EraseRootFromParent_Done,
     /*  543470 */   // Label 8989: @543470
     /*  543470 */   GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(543541), // Rule ID 4597 //
     /*  543475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  543486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  543489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  543492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543503 */     // MIs[0] passthru
     /*  543503 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543519 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  543522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543539 */     GIR_RootConstrainSelectedInstOperands,
     /*  543540 */     // GIR_Coverage, 4597,
     /*  543540 */     GIR_EraseRootFromParent_Done,
     /*  543541 */   // Label 8990: @543541
     /*  543541 */   GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(543612), // Rule ID 4606 //
     /*  543546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  543557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  543560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  543563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543574 */     // MIs[0] passthru
     /*  543574 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543610 */     GIR_RootConstrainSelectedInstOperands,
     /*  543611 */     // GIR_Coverage, 4606,
     /*  543611 */     GIR_EraseRootFromParent_Done,
     /*  543612 */   // Label 8991: @543612
     /*  543612 */   GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(543683), // Rule ID 4607 //
     /*  543617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  543628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  543631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  543634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543645 */     // MIs[0] passthru
     /*  543645 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543661 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543681 */     GIR_RootConstrainSelectedInstOperands,
     /*  543682 */     // GIR_Coverage, 4607,
     /*  543682 */     GIR_EraseRootFromParent_Done,
     /*  543683 */   // Label 8992: @543683
     /*  543683 */   GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(543754), // Rule ID 4616 //
     /*  543688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  543699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  543702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  543705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543716 */     // MIs[0] passthru
     /*  543716 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543732 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543752 */     GIR_RootConstrainSelectedInstOperands,
     /*  543753 */     // GIR_Coverage, 4616,
     /*  543753 */     GIR_EraseRootFromParent_Done,
     /*  543754 */   // Label 8993: @543754
     /*  543754 */   GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(543825), // Rule ID 4617 //
     /*  543759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  543770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  543773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  543776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543787 */     // MIs[0] passthru
     /*  543787 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543803 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543823 */     GIR_RootConstrainSelectedInstOperands,
     /*  543824 */     // GIR_Coverage, 4617,
     /*  543824 */     GIR_EraseRootFromParent_Done,
     /*  543825 */   // Label 8994: @543825
     /*  543825 */   GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(543896), // Rule ID 4626 //
     /*  543830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  543841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  543844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  543847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543858 */     // MIs[0] passthru
     /*  543858 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543874 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543894 */     GIR_RootConstrainSelectedInstOperands,
     /*  543895 */     // GIR_Coverage, 4626,
     /*  543895 */     GIR_EraseRootFromParent_Done,
     /*  543896 */   // Label 8995: @543896
     /*  543896 */   GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(543967), // Rule ID 4627 //
     /*  543901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  543912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  543915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  543918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543929 */     // MIs[0] passthru
     /*  543929 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543945 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543965 */     GIR_RootConstrainSelectedInstOperands,
     /*  543966 */     // GIR_Coverage, 4627,
     /*  543966 */     GIR_EraseRootFromParent_Done,
     /*  543967 */   // Label 8996: @543967
     /*  543967 */   GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(544038), // Rule ID 4696 //
     /*  543972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  543980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  543983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  543986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  543989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544000 */     // MIs[0] passthru
     /*  544000 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544016 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  544019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544036 */     GIR_RootConstrainSelectedInstOperands,
     /*  544037 */     // GIR_Coverage, 4696,
     /*  544037 */     GIR_EraseRootFromParent_Done,
     /*  544038 */   // Label 8997: @544038
     /*  544038 */   GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(544109), // Rule ID 4697 //
     /*  544043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  544054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  544057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  544060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544071 */     // MIs[0] passthru
     /*  544071 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544087 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  544090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544107 */     GIR_RootConstrainSelectedInstOperands,
     /*  544108 */     // GIR_Coverage, 4697,
     /*  544108 */     GIR_EraseRootFromParent_Done,
     /*  544109 */   // Label 8998: @544109
     /*  544109 */   GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(544180), // Rule ID 4706 //
     /*  544114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  544125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  544128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  544131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544142 */     // MIs[0] passthru
     /*  544142 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544158 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544178 */     GIR_RootConstrainSelectedInstOperands,
     /*  544179 */     // GIR_Coverage, 4706,
     /*  544179 */     GIR_EraseRootFromParent_Done,
     /*  544180 */   // Label 8999: @544180
     /*  544180 */   GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(544251), // Rule ID 4707 //
     /*  544185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  544196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  544199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  544202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544213 */     // MIs[0] passthru
     /*  544213 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544229 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544249 */     GIR_RootConstrainSelectedInstOperands,
     /*  544250 */     // GIR_Coverage, 4707,
     /*  544250 */     GIR_EraseRootFromParent_Done,
     /*  544251 */   // Label 9000: @544251
     /*  544251 */   GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(544322), // Rule ID 4716 //
     /*  544256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  544267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  544270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  544273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544284 */     // MIs[0] passthru
     /*  544284 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  544303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544320 */     GIR_RootConstrainSelectedInstOperands,
     /*  544321 */     // GIR_Coverage, 4716,
     /*  544321 */     GIR_EraseRootFromParent_Done,
     /*  544322 */   // Label 9001: @544322
     /*  544322 */   GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(544393), // Rule ID 4717 //
     /*  544327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  544338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  544341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  544344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544355 */     // MIs[0] passthru
     /*  544355 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544371 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  544374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544391 */     GIR_RootConstrainSelectedInstOperands,
     /*  544392 */     // GIR_Coverage, 4717,
     /*  544392 */     GIR_EraseRootFromParent_Done,
     /*  544393 */   // Label 9002: @544393
     /*  544393 */   GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(544464), // Rule ID 4726 //
     /*  544398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  544409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  544412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  544415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544426 */     // MIs[0] passthru
     /*  544426 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  544445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544462 */     GIR_RootConstrainSelectedInstOperands,
     /*  544463 */     // GIR_Coverage, 4726,
     /*  544463 */     GIR_EraseRootFromParent_Done,
     /*  544464 */   // Label 9003: @544464
     /*  544464 */   GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(544535), // Rule ID 4727 //
     /*  544469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  544480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  544483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  544486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544497 */     // MIs[0] passthru
     /*  544497 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544513 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  544516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544533 */     GIR_RootConstrainSelectedInstOperands,
     /*  544534 */     // GIR_Coverage, 4727,
     /*  544534 */     GIR_EraseRootFromParent_Done,
     /*  544535 */   // Label 9004: @544535
     /*  544535 */   GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(544606), // Rule ID 4736 //
     /*  544540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  544551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  544554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  544557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544568 */     // MIs[0] passthru
     /*  544568 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544584 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  544587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544604 */     GIR_RootConstrainSelectedInstOperands,
     /*  544605 */     // GIR_Coverage, 4736,
     /*  544605 */     GIR_EraseRootFromParent_Done,
     /*  544606 */   // Label 9005: @544606
     /*  544606 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(544677), // Rule ID 4737 //
     /*  544611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  544622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  544625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  544628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544639 */     // MIs[0] passthru
     /*  544639 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544655 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  544658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544675 */     GIR_RootConstrainSelectedInstOperands,
     /*  544676 */     // GIR_Coverage, 4737,
     /*  544676 */     GIR_EraseRootFromParent_Done,
     /*  544677 */   // Label 9006: @544677
     /*  544677 */   GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(544748), // Rule ID 4746 //
     /*  544682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  544693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  544696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  544699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544710 */     // MIs[0] passthru
     /*  544710 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544726 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  544729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544746 */     GIR_RootConstrainSelectedInstOperands,
     /*  544747 */     // GIR_Coverage, 4746,
     /*  544747 */     GIR_EraseRootFromParent_Done,
     /*  544748 */   // Label 9007: @544748
     /*  544748 */   GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(544819), // Rule ID 4747 //
     /*  544753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  544764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  544767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  544770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544781 */     // MIs[0] passthru
     /*  544781 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544797 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  544800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544817 */     GIR_RootConstrainSelectedInstOperands,
     /*  544818 */     // GIR_Coverage, 4747,
     /*  544818 */     GIR_EraseRootFromParent_Done,
     /*  544819 */   // Label 9008: @544819
     /*  544819 */   GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(544890), // Rule ID 4756 //
     /*  544824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  544835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  544838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  544841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544852 */     // MIs[0] passthru
     /*  544852 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544888 */     GIR_RootConstrainSelectedInstOperands,
     /*  544889 */     // GIR_Coverage, 4756,
     /*  544889 */     GIR_EraseRootFromParent_Done,
     /*  544890 */   // Label 9009: @544890
     /*  544890 */   GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(544961), // Rule ID 4757 //
     /*  544895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  544906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  544909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  544912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544923 */     // MIs[0] passthru
     /*  544923 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544939 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544959 */     GIR_RootConstrainSelectedInstOperands,
     /*  544960 */     // GIR_Coverage, 4757,
     /*  544960 */     GIR_EraseRootFromParent_Done,
     /*  544961 */   // Label 9010: @544961
     /*  544961 */   GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(545032), // Rule ID 4766 //
     /*  544966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  544977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  544980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  544983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544994 */     // MIs[0] passthru
     /*  544994 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545010 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11683:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545030 */     GIR_RootConstrainSelectedInstOperands,
     /*  545031 */     // GIR_Coverage, 4766,
     /*  545031 */     GIR_EraseRootFromParent_Done,
     /*  545032 */   // Label 9011: @545032
     /*  545032 */   GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(545103), // Rule ID 4767 //
     /*  545037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  545048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  545051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  545054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545065 */     // MIs[0] passthru
     /*  545065 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545081 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11683:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545101 */     GIR_RootConstrainSelectedInstOperands,
     /*  545102 */     // GIR_Coverage, 4767,
     /*  545102 */     GIR_EraseRootFromParent_Done,
     /*  545103 */   // Label 9012: @545103
     /*  545103 */   GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(545174), // Rule ID 4776 //
     /*  545108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  545119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  545122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  545125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545136 */     // MIs[0] passthru
     /*  545136 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545172 */     GIR_RootConstrainSelectedInstOperands,
     /*  545173 */     // GIR_Coverage, 4776,
     /*  545173 */     GIR_EraseRootFromParent_Done,
     /*  545174 */   // Label 9013: @545174
     /*  545174 */   GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(545245), // Rule ID 4777 //
     /*  545179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  545190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  545193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  545196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545207 */     // MIs[0] passthru
     /*  545207 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545223 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545243 */     GIR_RootConstrainSelectedInstOperands,
     /*  545244 */     // GIR_Coverage, 4777,
     /*  545244 */     GIR_EraseRootFromParent_Done,
     /*  545245 */   // Label 9014: @545245
     /*  545245 */   GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(545316), // Rule ID 4786 //
     /*  545250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  545261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  545264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  545267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545278 */     // MIs[0] passthru
     /*  545278 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545294 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545314 */     GIR_RootConstrainSelectedInstOperands,
     /*  545315 */     // GIR_Coverage, 4786,
     /*  545315 */     GIR_EraseRootFromParent_Done,
     /*  545316 */   // Label 9015: @545316
     /*  545316 */   GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(545387), // Rule ID 4787 //
     /*  545321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  545332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  545335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  545338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545349 */     // MIs[0] passthru
     /*  545349 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545365 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545385 */     GIR_RootConstrainSelectedInstOperands,
     /*  545386 */     // GIR_Coverage, 4787,
     /*  545386 */     GIR_EraseRootFromParent_Done,
     /*  545387 */   // Label 9016: @545387
     /*  545387 */   GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(545458), // Rule ID 4796 //
     /*  545392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  545403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  545406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  545409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545420 */     // MIs[0] passthru
     /*  545420 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545436 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545456 */     GIR_RootConstrainSelectedInstOperands,
     /*  545457 */     // GIR_Coverage, 4796,
     /*  545457 */     GIR_EraseRootFromParent_Done,
     /*  545458 */   // Label 9017: @545458
     /*  545458 */   GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(545529), // Rule ID 4797 //
     /*  545463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  545474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  545477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  545480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545491 */     // MIs[0] passthru
     /*  545491 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545507 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545527 */     GIR_RootConstrainSelectedInstOperands,
     /*  545528 */     // GIR_Coverage, 4797,
     /*  545528 */     GIR_EraseRootFromParent_Done,
     /*  545529 */   // Label 9018: @545529
     /*  545529 */   GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(545600), // Rule ID 4806 //
     /*  545534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  545545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  545548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  545551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545562 */     // MIs[0] passthru
     /*  545562 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545578 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545598 */     GIR_RootConstrainSelectedInstOperands,
     /*  545599 */     // GIR_Coverage, 4806,
     /*  545599 */     GIR_EraseRootFromParent_Done,
     /*  545600 */   // Label 9019: @545600
     /*  545600 */   GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(545671), // Rule ID 4807 //
     /*  545605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  545616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  545619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  545622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545633 */     // MIs[0] passthru
     /*  545633 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545649 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545669 */     GIR_RootConstrainSelectedInstOperands,
     /*  545670 */     // GIR_Coverage, 4807,
     /*  545670 */     GIR_EraseRootFromParent_Done,
     /*  545671 */   // Label 9020: @545671
     /*  545671 */   GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(545742), // Rule ID 4816 //
     /*  545676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  545687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  545690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  545693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545704 */     // MIs[0] passthru
     /*  545704 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545720 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545740 */     GIR_RootConstrainSelectedInstOperands,
     /*  545741 */     // GIR_Coverage, 4816,
     /*  545741 */     GIR_EraseRootFromParent_Done,
     /*  545742 */   // Label 9021: @545742
     /*  545742 */   GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(545813), // Rule ID 4817 //
     /*  545747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  545758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  545761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  545764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545775 */     // MIs[0] passthru
     /*  545775 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545791 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545811 */     GIR_RootConstrainSelectedInstOperands,
     /*  545812 */     // GIR_Coverage, 4817,
     /*  545812 */     GIR_EraseRootFromParent_Done,
     /*  545813 */   // Label 9022: @545813
     /*  545813 */   GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(545884), // Rule ID 4826 //
     /*  545818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  545829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  545832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  545835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545846 */     // MIs[0] passthru
     /*  545846 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545862 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545882 */     GIR_RootConstrainSelectedInstOperands,
     /*  545883 */     // GIR_Coverage, 4826,
     /*  545883 */     GIR_EraseRootFromParent_Done,
     /*  545884 */   // Label 9023: @545884
     /*  545884 */   GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(545955), // Rule ID 4827 //
     /*  545889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  545900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  545903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  545906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545917 */     // MIs[0] passthru
     /*  545917 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545933 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545953 */     GIR_RootConstrainSelectedInstOperands,
     /*  545954 */     // GIR_Coverage, 4827,
     /*  545954 */     GIR_EraseRootFromParent_Done,
     /*  545955 */   // Label 9024: @545955
     /*  545955 */   GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(546026), // Rule ID 4836 //
     /*  545960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  545971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  545974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  545977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545988 */     // MIs[0] passthru
     /*  545988 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546004 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  546004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  546007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546024 */     GIR_RootConstrainSelectedInstOperands,
     /*  546025 */     // GIR_Coverage, 4836,
     /*  546025 */     GIR_EraseRootFromParent_Done,
     /*  546026 */   // Label 9025: @546026
     /*  546026 */   GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(546097), // Rule ID 4837 //
     /*  546031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  546034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  546042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  546045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  546048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546059 */     // MIs[0] passthru
     /*  546059 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546075 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  546075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  546078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546095 */     GIR_RootConstrainSelectedInstOperands,
     /*  546096 */     // GIR_Coverage, 4837,
     /*  546096 */     GIR_EraseRootFromParent_Done,
     /*  546097 */   // Label 9026: @546097
     /*  546097 */   GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(546169), // Rule ID 2692 //
     /*  546102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  546110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546148 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  546148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  546151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546167 */     GIR_RootConstrainSelectedInstOperands,
     /*  546168 */     // GIR_Coverage, 2692,
     /*  546168 */     GIR_EraseRootFromParent_Done,
     /*  546169 */   // Label 9027: @546169
     /*  546169 */   GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(546241), // Rule ID 2693 //
     /*  546174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  546182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546220 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  546220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  546223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546239 */     GIR_RootConstrainSelectedInstOperands,
     /*  546240 */     // GIR_Coverage, 2693,
     /*  546240 */     GIR_EraseRootFromParent_Done,
     /*  546241 */   // Label 9028: @546241
     /*  546241 */   GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(546316), // Rule ID 2696 //
     /*  546246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  546249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  546254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  546260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  546263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  546273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546292 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  546292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  546295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  546314 */     GIR_RootConstrainSelectedInstOperands,
     /*  546315 */     // GIR_Coverage, 2696,
     /*  546315 */     GIR_EraseRootFromParent_Done,
     /*  546316 */   // Label 9029: @546316
     /*  546316 */   GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(546391), // Rule ID 2697 //
     /*  546321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  546324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  546329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  546335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  546338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  546348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546367 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  546367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  546370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546376 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  546389 */     GIR_RootConstrainSelectedInstOperands,
     /*  546390 */     // GIR_Coverage, 2697,
     /*  546390 */     GIR_EraseRootFromParent_Done,
     /*  546391 */   // Label 9030: @546391
     /*  546391 */   GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(546466), // Rule ID 2724 //
     /*  546396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  546404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546442 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  546445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546464 */     GIR_RootConstrainSelectedInstOperands,
     /*  546465 */     // GIR_Coverage, 2724,
     /*  546465 */     GIR_EraseRootFromParent_Done,
     /*  546466 */   // Label 9031: @546466
     /*  546466 */   GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(546541), // Rule ID 2725 //
     /*  546471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  546479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546517 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  546520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546539 */     GIR_RootConstrainSelectedInstOperands,
     /*  546540 */     // GIR_Coverage, 2725,
     /*  546540 */     GIR_EraseRootFromParent_Done,
     /*  546541 */   // Label 9032: @546541
     /*  546541 */   GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(546613), // Rule ID 2738 //
     /*  546546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  546554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546592 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  546592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  546595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  546599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546611 */     GIR_RootConstrainSelectedInstOperands,
     /*  546612 */     // GIR_Coverage, 2738,
     /*  546612 */     GIR_EraseRootFromParent_Done,
     /*  546613 */   // Label 9033: @546613
     /*  546613 */   GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(546685), // Rule ID 2739 //
     /*  546618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  546626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546664 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  546664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  546667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  546671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546683 */     GIR_RootConstrainSelectedInstOperands,
     /*  546684 */     // GIR_Coverage, 2739,
     /*  546684 */     GIR_EraseRootFromParent_Done,
     /*  546685 */   // Label 9034: @546685
     /*  546685 */   GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(546760), // Rule ID 2758 //
     /*  546690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  546698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  546701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  546704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  546707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546736 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  546739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546758 */     GIR_RootConstrainSelectedInstOperands,
     /*  546759 */     // GIR_Coverage, 2758,
     /*  546759 */     GIR_EraseRootFromParent_Done,
     /*  546760 */   // Label 9035: @546760
     /*  546760 */   GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(546835), // Rule ID 2759 //
     /*  546765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  546773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  546776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  546779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  546782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546811 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  546814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546833 */     GIR_RootConstrainSelectedInstOperands,
     /*  546834 */     // GIR_Coverage, 2759,
     /*  546834 */     GIR_EraseRootFromParent_Done,
     /*  546835 */   // Label 9036: @546835
     /*  546835 */   GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(546910), // Rule ID 2784 //
     /*  546840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  546848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  546851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  546854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  546860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546886 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  546889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  546893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546908 */     GIR_RootConstrainSelectedInstOperands,
     /*  546909 */     // GIR_Coverage, 2784,
     /*  546909 */     GIR_EraseRootFromParent_Done,
     /*  546910 */   // Label 9037: @546910
     /*  546910 */   GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(546985), // Rule ID 2785 //
     /*  546915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  546923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  546926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  546929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  546935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546961 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  546964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  546968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546983 */     GIR_RootConstrainSelectedInstOperands,
     /*  546984 */     // GIR_Coverage, 2785,
     /*  546984 */     GIR_EraseRootFromParent_Done,
     /*  546985 */   // Label 9038: @546985
     /*  546985 */   GIM_Try, /*On fail goto*//*Label 9039*/ GIMT_Encode4(547060), // Rule ID 2796 //
     /*  546990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  546998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  547001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  547004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547036 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  547039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547058 */     GIR_RootConstrainSelectedInstOperands,
     /*  547059 */     // GIR_Coverage, 2796,
     /*  547059 */     GIR_EraseRootFromParent_Done,
     /*  547060 */   // Label 9039: @547060
     /*  547060 */   GIM_Try, /*On fail goto*//*Label 9040*/ GIMT_Encode4(547135), // Rule ID 2797 //
     /*  547065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  547076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  547079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547111 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  547114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547133 */     GIR_RootConstrainSelectedInstOperands,
     /*  547134 */     // GIR_Coverage, 2797,
     /*  547134 */     GIR_EraseRootFromParent_Done,
     /*  547135 */   // Label 9040: @547135
     /*  547135 */   GIM_Try, /*On fail goto*//*Label 9041*/ GIMT_Encode4(547210), // Rule ID 2804 //
     /*  547140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  547151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  547154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  547157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  547160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547186 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547208 */     GIR_RootConstrainSelectedInstOperands,
     /*  547209 */     // GIR_Coverage, 2804,
     /*  547209 */     GIR_EraseRootFromParent_Done,
     /*  547210 */   // Label 9041: @547210
     /*  547210 */   GIM_Try, /*On fail goto*//*Label 9042*/ GIMT_Encode4(547285), // Rule ID 2805 //
     /*  547215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  547226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  547229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  547232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  547235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547261 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547283 */     GIR_RootConstrainSelectedInstOperands,
     /*  547284 */     // GIR_Coverage, 2805,
     /*  547284 */     GIR_EraseRootFromParent_Done,
     /*  547285 */   // Label 9042: @547285
     /*  547285 */   GIM_Try, /*On fail goto*//*Label 9043*/ GIMT_Encode4(547360), // Rule ID 2812 //
     /*  547290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  547301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  547304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  547307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  547310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547336 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547358 */     GIR_RootConstrainSelectedInstOperands,
     /*  547359 */     // GIR_Coverage, 2812,
     /*  547359 */     GIR_EraseRootFromParent_Done,
     /*  547360 */   // Label 9043: @547360
     /*  547360 */   GIM_Try, /*On fail goto*//*Label 9044*/ GIMT_Encode4(547435), // Rule ID 2813 //
     /*  547365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  547376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  547379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  547382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  547385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547411 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547433 */     GIR_RootConstrainSelectedInstOperands,
     /*  547434 */     // GIR_Coverage, 2813,
     /*  547434 */     GIR_EraseRootFromParent_Done,
     /*  547435 */   // Label 9044: @547435
     /*  547435 */   GIM_Try, /*On fail goto*//*Label 9045*/ GIMT_Encode4(547510), // Rule ID 2820 //
     /*  547440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  547460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547486 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  547486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547508 */     GIR_RootConstrainSelectedInstOperands,
     /*  547509 */     // GIR_Coverage, 2820,
     /*  547509 */     GIR_EraseRootFromParent_Done,
     /*  547510 */   // Label 9045: @547510
     /*  547510 */   GIM_Try, /*On fail goto*//*Label 9046*/ GIMT_Encode4(547585), // Rule ID 2821 //
     /*  547515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  547535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547561 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  547561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547583 */     GIR_RootConstrainSelectedInstOperands,
     /*  547584 */     // GIR_Coverage, 2821,
     /*  547584 */     GIR_EraseRootFromParent_Done,
     /*  547585 */   // Label 9046: @547585
     /*  547585 */   GIM_Try, /*On fail goto*//*Label 9047*/ GIMT_Encode4(547660), // Rule ID 2828 //
     /*  547590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  547601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  547604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  547607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  547610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547636 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  547636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547658 */     GIR_RootConstrainSelectedInstOperands,
     /*  547659 */     // GIR_Coverage, 2828,
     /*  547659 */     GIR_EraseRootFromParent_Done,
     /*  547660 */   // Label 9047: @547660
     /*  547660 */   GIM_Try, /*On fail goto*//*Label 9048*/ GIMT_Encode4(547735), // Rule ID 2829 //
     /*  547665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  547676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  547679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  547682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  547685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547711 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  547711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547733 */     GIR_RootConstrainSelectedInstOperands,
     /*  547734 */     // GIR_Coverage, 2829,
     /*  547734 */     GIR_EraseRootFromParent_Done,
     /*  547735 */   // Label 9048: @547735
     /*  547735 */   GIM_Try, /*On fail goto*//*Label 9049*/ GIMT_Encode4(547810), // Rule ID 2836 //
     /*  547740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  547751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  547754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  547757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  547760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547786 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  547786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547808 */     GIR_RootConstrainSelectedInstOperands,
     /*  547809 */     // GIR_Coverage, 2836,
     /*  547809 */     GIR_EraseRootFromParent_Done,
     /*  547810 */   // Label 9049: @547810
     /*  547810 */   GIM_Try, /*On fail goto*//*Label 9050*/ GIMT_Encode4(547885), // Rule ID 2837 //
     /*  547815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  547826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  547829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  547832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  547835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547861 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  547861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547883 */     GIR_RootConstrainSelectedInstOperands,
     /*  547884 */     // GIR_Coverage, 2837,
     /*  547884 */     GIR_EraseRootFromParent_Done,
     /*  547885 */   // Label 9050: @547885
     /*  547885 */   GIM_Try, /*On fail goto*//*Label 9051*/ GIMT_Encode4(547960), // Rule ID 2844 //
     /*  547890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  547901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  547904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  547907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  547910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547936 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  547939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547958 */     GIR_RootConstrainSelectedInstOperands,
     /*  547959 */     // GIR_Coverage, 2844,
     /*  547959 */     GIR_EraseRootFromParent_Done,
     /*  547960 */   // Label 9051: @547960
     /*  547960 */   GIM_Try, /*On fail goto*//*Label 9052*/ GIMT_Encode4(548035), // Rule ID 2845 //
     /*  547965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  547976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  547979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  547982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  547985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548011 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548033 */     GIR_RootConstrainSelectedInstOperands,
     /*  548034 */     // GIR_Coverage, 2845,
     /*  548034 */     GIR_EraseRootFromParent_Done,
     /*  548035 */   // Label 9052: @548035
     /*  548035 */   GIM_Try, /*On fail goto*//*Label 9053*/ GIMT_Encode4(548110), // Rule ID 2852 //
     /*  548040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  548057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  548060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548108 */     GIR_RootConstrainSelectedInstOperands,
     /*  548109 */     // GIR_Coverage, 2852,
     /*  548109 */     GIR_EraseRootFromParent_Done,
     /*  548110 */   // Label 9053: @548110
     /*  548110 */   GIM_Try, /*On fail goto*//*Label 9054*/ GIMT_Encode4(548185), // Rule ID 2853 //
     /*  548115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  548132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  548135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548161 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548183 */     GIR_RootConstrainSelectedInstOperands,
     /*  548184 */     // GIR_Coverage, 2853,
     /*  548184 */     GIR_EraseRootFromParent_Done,
     /*  548185 */   // Label 9054: @548185
     /*  548185 */   GIM_Try, /*On fail goto*//*Label 9055*/ GIMT_Encode4(548260), // Rule ID 2860 //
     /*  548190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  548207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  548210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  548236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548258 */     GIR_RootConstrainSelectedInstOperands,
     /*  548259 */     // GIR_Coverage, 2860,
     /*  548259 */     GIR_EraseRootFromParent_Done,
     /*  548260 */   // Label 9055: @548260
     /*  548260 */   GIM_Try, /*On fail goto*//*Label 9056*/ GIMT_Encode4(548335), // Rule ID 2861 //
     /*  548265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  548282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  548285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548311 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  548311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548333 */     GIR_RootConstrainSelectedInstOperands,
     /*  548334 */     // GIR_Coverage, 2861,
     /*  548334 */     GIR_EraseRootFromParent_Done,
     /*  548335 */   // Label 9056: @548335
     /*  548335 */   GIM_Try, /*On fail goto*//*Label 9057*/ GIMT_Encode4(548410), // Rule ID 2868 //
     /*  548340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  548343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  548351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  548354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  548357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  548360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548386 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  548386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  548405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548408 */     GIR_RootConstrainSelectedInstOperands,
     /*  548409 */     // GIR_Coverage, 2868,
     /*  548409 */     GIR_EraseRootFromParent_Done,
     /*  548410 */   // Label 9057: @548410
     /*  548410 */   GIM_Try, /*On fail goto*//*Label 9058*/ GIMT_Encode4(548485), // Rule ID 2869 //
     /*  548415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  548418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  548426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  548429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  548432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  548435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548461 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  548461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  548480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548483 */     GIR_RootConstrainSelectedInstOperands,
     /*  548484 */     // GIR_Coverage, 2869,
     /*  548484 */     GIR_EraseRootFromParent_Done,
     /*  548485 */   // Label 9058: @548485
     /*  548485 */   GIM_Try, /*On fail goto*//*Label 9059*/ GIMT_Encode4(548560), // Rule ID 2876 //
     /*  548490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  548501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  548504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  548507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  548510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  548539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548558 */     GIR_RootConstrainSelectedInstOperands,
     /*  548559 */     // GIR_Coverage, 2876,
     /*  548559 */     GIR_EraseRootFromParent_Done,
     /*  548560 */   // Label 9059: @548560
     /*  548560 */   GIM_Try, /*On fail goto*//*Label 9060*/ GIMT_Encode4(548635), // Rule ID 2877 //
     /*  548565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  548576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  548579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  548582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  548585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548611 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  548614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548633 */     GIR_RootConstrainSelectedInstOperands,
     /*  548634 */     // GIR_Coverage, 2877,
     /*  548634 */     GIR_EraseRootFromParent_Done,
     /*  548635 */   // Label 9060: @548635
     /*  548635 */   GIM_Try, /*On fail goto*//*Label 9061*/ GIMT_Encode4(548710), // Rule ID 2884 //
     /*  548640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  548651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  548654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  548657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  548660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548686 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  548689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548708 */     GIR_RootConstrainSelectedInstOperands,
     /*  548709 */     // GIR_Coverage, 2884,
     /*  548709 */     GIR_EraseRootFromParent_Done,
     /*  548710 */   // Label 9061: @548710
     /*  548710 */   GIM_Try, /*On fail goto*//*Label 9062*/ GIMT_Encode4(548785), // Rule ID 2885 //
     /*  548715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  548726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  548729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  548732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  548735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548761 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  548764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548783 */     GIR_RootConstrainSelectedInstOperands,
     /*  548784 */     // GIR_Coverage, 2885,
     /*  548784 */     GIR_EraseRootFromParent_Done,
     /*  548785 */   // Label 9062: @548785
     /*  548785 */   GIM_Try, /*On fail goto*//*Label 9063*/ GIMT_Encode4(548860), // Rule ID 2892 //
     /*  548790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  548801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  548804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  548807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  548810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548836 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  548839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548858 */     GIR_RootConstrainSelectedInstOperands,
     /*  548859 */     // GIR_Coverage, 2892,
     /*  548859 */     GIR_EraseRootFromParent_Done,
     /*  548860 */   // Label 9063: @548860
     /*  548860 */   GIM_Try, /*On fail goto*//*Label 9064*/ GIMT_Encode4(548935), // Rule ID 2893 //
     /*  548865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  548876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  548879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  548882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  548885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548911 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  548914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548933 */     GIR_RootConstrainSelectedInstOperands,
     /*  548934 */     // GIR_Coverage, 2893,
     /*  548934 */     GIR_EraseRootFromParent_Done,
     /*  548935 */   // Label 9064: @548935
     /*  548935 */   GIM_Try, /*On fail goto*//*Label 9065*/ GIMT_Encode4(549010), // Rule ID 2900 //
     /*  548940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  548951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  548954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  548957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  548960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  548989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549008 */     GIR_RootConstrainSelectedInstOperands,
     /*  549009 */     // GIR_Coverage, 2900,
     /*  549009 */     GIR_EraseRootFromParent_Done,
     /*  549010 */   // Label 9065: @549010
     /*  549010 */   GIM_Try, /*On fail goto*//*Label 9066*/ GIMT_Encode4(549085), // Rule ID 2901 //
     /*  549015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  549026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  549029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  549032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  549035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549061 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549083 */     GIR_RootConstrainSelectedInstOperands,
     /*  549084 */     // GIR_Coverage, 2901,
     /*  549084 */     GIR_EraseRootFromParent_Done,
     /*  549085 */   // Label 9066: @549085
     /*  549085 */   GIM_Try, /*On fail goto*//*Label 9067*/ GIMT_Encode4(549160), // Rule ID 2908 //
     /*  549090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  549101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  549104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  549107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549158 */     GIR_RootConstrainSelectedInstOperands,
     /*  549159 */     // GIR_Coverage, 2908,
     /*  549159 */     GIR_EraseRootFromParent_Done,
     /*  549160 */   // Label 9067: @549160
     /*  549160 */   GIM_Try, /*On fail goto*//*Label 9068*/ GIMT_Encode4(549235), // Rule ID 2909 //
     /*  549165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  549176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  549179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  549182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549211 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549233 */     GIR_RootConstrainSelectedInstOperands,
     /*  549234 */     // GIR_Coverage, 2909,
     /*  549234 */     GIR_EraseRootFromParent_Done,
     /*  549235 */   // Label 9068: @549235
     /*  549235 */   GIM_Try, /*On fail goto*//*Label 9069*/ GIMT_Encode4(549310), // Rule ID 2916 //
     /*  549240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  549251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  549254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  549257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  549260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549308 */     GIR_RootConstrainSelectedInstOperands,
     /*  549309 */     // GIR_Coverage, 2916,
     /*  549309 */     GIR_EraseRootFromParent_Done,
     /*  549310 */   // Label 9069: @549310
     /*  549310 */   GIM_Try, /*On fail goto*//*Label 9070*/ GIMT_Encode4(549385), // Rule ID 2917 //
     /*  549315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  549326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  549329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  549332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  549335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549361 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549383 */     GIR_RootConstrainSelectedInstOperands,
     /*  549384 */     // GIR_Coverage, 2917,
     /*  549384 */     GIR_EraseRootFromParent_Done,
     /*  549385 */   // Label 9070: @549385
     /*  549385 */   GIM_Try, /*On fail goto*//*Label 9071*/ GIMT_Encode4(549460), // Rule ID 2924 //
     /*  549390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  549401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  549404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  549407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549458 */     GIR_RootConstrainSelectedInstOperands,
     /*  549459 */     // GIR_Coverage, 2924,
     /*  549459 */     GIR_EraseRootFromParent_Done,
     /*  549460 */   // Label 9071: @549460
     /*  549460 */   GIM_Try, /*On fail goto*//*Label 9072*/ GIMT_Encode4(549535), // Rule ID 2925 //
     /*  549465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  549476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  549479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  549482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549511 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549533 */     GIR_RootConstrainSelectedInstOperands,
     /*  549534 */     // GIR_Coverage, 2925,
     /*  549534 */     GIR_EraseRootFromParent_Done,
     /*  549535 */   // Label 9072: @549535
     /*  549535 */   GIM_Try, /*On fail goto*//*Label 9073*/ GIMT_Encode4(549610), // Rule ID 2932 //
     /*  549540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  549551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  549554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  549557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  549560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549608 */     GIR_RootConstrainSelectedInstOperands,
     /*  549609 */     // GIR_Coverage, 2932,
     /*  549609 */     GIR_EraseRootFromParent_Done,
     /*  549610 */   // Label 9073: @549610
     /*  549610 */   GIM_Try, /*On fail goto*//*Label 9074*/ GIMT_Encode4(549685), // Rule ID 2933 //
     /*  549615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  549626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  549629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  549632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  549635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549661 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549683 */     GIR_RootConstrainSelectedInstOperands,
     /*  549684 */     // GIR_Coverage, 2933,
     /*  549684 */     GIR_EraseRootFromParent_Done,
     /*  549685 */   // Label 9074: @549685
     /*  549685 */   GIM_Try, /*On fail goto*//*Label 9075*/ GIMT_Encode4(549760), // Rule ID 2940 //
     /*  549690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  549701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  549704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  549707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  549710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549736 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549758 */     GIR_RootConstrainSelectedInstOperands,
     /*  549759 */     // GIR_Coverage, 2940,
     /*  549759 */     GIR_EraseRootFromParent_Done,
     /*  549760 */   // Label 9075: @549760
     /*  549760 */   GIM_Try, /*On fail goto*//*Label 9076*/ GIMT_Encode4(549835), // Rule ID 2941 //
     /*  549765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  549776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  549779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  549782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  549785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549811 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549833 */     GIR_RootConstrainSelectedInstOperands,
     /*  549834 */     // GIR_Coverage, 2941,
     /*  549834 */     GIR_EraseRootFromParent_Done,
     /*  549835 */   // Label 9076: @549835
     /*  549835 */   GIM_Try, /*On fail goto*//*Label 9077*/ GIMT_Encode4(549910), // Rule ID 2948 //
     /*  549840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  549843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  549851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  549854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  549857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  549860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  549886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  549905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549908 */     GIR_RootConstrainSelectedInstOperands,
     /*  549909 */     // GIR_Coverage, 2948,
     /*  549909 */     GIR_EraseRootFromParent_Done,
     /*  549910 */   // Label 9077: @549910
     /*  549910 */   GIM_Try, /*On fail goto*//*Label 9078*/ GIMT_Encode4(549985), // Rule ID 2949 //
     /*  549915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  549918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  549926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  549929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  549932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  549935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  549961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  549980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549983 */     GIR_RootConstrainSelectedInstOperands,
     /*  549984 */     // GIR_Coverage, 2949,
     /*  549984 */     GIR_EraseRootFromParent_Done,
     /*  549985 */   // Label 9078: @549985
     /*  549985 */   GIM_Try, /*On fail goto*//*Label 9079*/ GIMT_Encode4(550060), // Rule ID 2956 //
     /*  549990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  549993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  550001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  550004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  550007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  550010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  550036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  550039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550058 */     GIR_RootConstrainSelectedInstOperands,
     /*  550059 */     // GIR_Coverage, 2956,
     /*  550059 */     GIR_EraseRootFromParent_Done,
     /*  550060 */   // Label 9079: @550060
     /*  550060 */   GIM_Try, /*On fail goto*//*Label 9080*/ GIMT_Encode4(550135), // Rule ID 2957 //
     /*  550065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  550068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  550076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  550079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  550082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  550085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550111 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  550111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  550114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550133 */     GIR_RootConstrainSelectedInstOperands,
     /*  550134 */     // GIR_Coverage, 2957,
     /*  550134 */     GIR_EraseRootFromParent_Done,
     /*  550135 */   // Label 9080: @550135
     /*  550135 */   GIM_Try, /*On fail goto*//*Label 9081*/ GIMT_Encode4(550210), // Rule ID 2964 //
     /*  550140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  550143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  550151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  550154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  550157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  550160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550186 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  550186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  550189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550208 */     GIR_RootConstrainSelectedInstOperands,
     /*  550209 */     // GIR_Coverage, 2964,
     /*  550209 */     GIR_EraseRootFromParent_Done,
     /*  550210 */   // Label 9081: @550210
     /*  550210 */   GIM_Try, /*On fail goto*//*Label 9082*/ GIMT_Encode4(550285), // Rule ID 2965 //
     /*  550215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  550218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  550226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  550229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  550232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  550235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550261 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  550261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  550264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550283 */     GIR_RootConstrainSelectedInstOperands,
     /*  550284 */     // GIR_Coverage, 2965,
     /*  550284 */     GIR_EraseRootFromParent_Done,
     /*  550285 */   // Label 9082: @550285
     /*  550285 */   GIM_Try, /*On fail goto*//*Label 9083*/ GIMT_Encode4(550360), // Rule ID 2980 //
     /*  550290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  550301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  550304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  550307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  550310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550336 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550358 */     GIR_RootConstrainSelectedInstOperands,
     /*  550359 */     // GIR_Coverage, 2980,
     /*  550359 */     GIR_EraseRootFromParent_Done,
     /*  550360 */   // Label 9083: @550360
     /*  550360 */   GIM_Try, /*On fail goto*//*Label 9084*/ GIMT_Encode4(550435), // Rule ID 2981 //
     /*  550365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  550376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  550379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  550382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  550385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550411 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550433 */     GIR_RootConstrainSelectedInstOperands,
     /*  550434 */     // GIR_Coverage, 2981,
     /*  550434 */     GIR_EraseRootFromParent_Done,
     /*  550435 */   // Label 9084: @550435
     /*  550435 */   GIM_Try, /*On fail goto*//*Label 9085*/ GIMT_Encode4(550510), // Rule ID 2984 //
     /*  550440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  550451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  550454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  550457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  550460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550486 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550508 */     GIR_RootConstrainSelectedInstOperands,
     /*  550509 */     // GIR_Coverage, 2984,
     /*  550509 */     GIR_EraseRootFromParent_Done,
     /*  550510 */   // Label 9085: @550510
     /*  550510 */   GIM_Try, /*On fail goto*//*Label 9086*/ GIMT_Encode4(550585), // Rule ID 2985 //
     /*  550515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  550526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  550529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  550532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  550535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550561 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550583 */     GIR_RootConstrainSelectedInstOperands,
     /*  550584 */     // GIR_Coverage, 2985,
     /*  550584 */     GIR_EraseRootFromParent_Done,
     /*  550585 */   // Label 9086: @550585
     /*  550585 */   GIM_Try, /*On fail goto*//*Label 9087*/ GIMT_Encode4(550660), // Rule ID 2988 //
     /*  550590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  550601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  550604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  550607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  550610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550636 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  550636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550658 */     GIR_RootConstrainSelectedInstOperands,
     /*  550659 */     // GIR_Coverage, 2988,
     /*  550659 */     GIR_EraseRootFromParent_Done,
     /*  550660 */   // Label 9087: @550660
     /*  550660 */   GIM_Try, /*On fail goto*//*Label 9088*/ GIMT_Encode4(550735), // Rule ID 2989 //
     /*  550665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  550676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  550679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  550682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  550685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550711 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  550711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550733 */     GIR_RootConstrainSelectedInstOperands,
     /*  550734 */     // GIR_Coverage, 2989,
     /*  550734 */     GIR_EraseRootFromParent_Done,
     /*  550735 */   // Label 9088: @550735
     /*  550735 */   GIM_Try, /*On fail goto*//*Label 9089*/ GIMT_Encode4(550810), // Rule ID 2992 //
     /*  550740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  550751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  550754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  550757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  550760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550786 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  550786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550808 */     GIR_RootConstrainSelectedInstOperands,
     /*  550809 */     // GIR_Coverage, 2992,
     /*  550809 */     GIR_EraseRootFromParent_Done,
     /*  550810 */   // Label 9089: @550810
     /*  550810 */   GIM_Try, /*On fail goto*//*Label 9090*/ GIMT_Encode4(550885), // Rule ID 2993 //
     /*  550815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  550826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  550829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  550832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  550835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550861 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  550861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550883 */     GIR_RootConstrainSelectedInstOperands,
     /*  550884 */     // GIR_Coverage, 2993,
     /*  550884 */     GIR_EraseRootFromParent_Done,
     /*  550885 */   // Label 9090: @550885
     /*  550885 */   GIM_Try, /*On fail goto*//*Label 9091*/ GIMT_Encode4(550960), // Rule ID 2996 //
     /*  550890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  550901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  550904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  550907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  550910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550936 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  550936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550958 */     GIR_RootConstrainSelectedInstOperands,
     /*  550959 */     // GIR_Coverage, 2996,
     /*  550959 */     GIR_EraseRootFromParent_Done,
     /*  550960 */   // Label 9091: @550960
     /*  550960 */   GIM_Try, /*On fail goto*//*Label 9092*/ GIMT_Encode4(551035), // Rule ID 2997 //
     /*  550965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  550976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  550979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  550982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  550985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551011 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  551011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  551014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551033 */     GIR_RootConstrainSelectedInstOperands,
     /*  551034 */     // GIR_Coverage, 2997,
     /*  551034 */     GIR_EraseRootFromParent_Done,
     /*  551035 */   // Label 9092: @551035
     /*  551035 */   GIM_Try, /*On fail goto*//*Label 9093*/ GIMT_Encode4(551110), // Rule ID 3000 //
     /*  551040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  551060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551086 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551108 */     GIR_RootConstrainSelectedInstOperands,
     /*  551109 */     // GIR_Coverage, 3000,
     /*  551109 */     GIR_EraseRootFromParent_Done,
     /*  551110 */   // Label 9093: @551110
     /*  551110 */   GIM_Try, /*On fail goto*//*Label 9094*/ GIMT_Encode4(551185), // Rule ID 3001 //
     /*  551115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  551135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551161 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551183 */     GIR_RootConstrainSelectedInstOperands,
     /*  551184 */     // GIR_Coverage, 3001,
     /*  551184 */     GIR_EraseRootFromParent_Done,
     /*  551185 */   // Label 9094: @551185
     /*  551185 */   GIM_Try, /*On fail goto*//*Label 9095*/ GIMT_Encode4(551260), // Rule ID 3004 //
     /*  551190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  551210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551236 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551258 */     GIR_RootConstrainSelectedInstOperands,
     /*  551259 */     // GIR_Coverage, 3004,
     /*  551259 */     GIR_EraseRootFromParent_Done,
     /*  551260 */   // Label 9095: @551260
     /*  551260 */   GIM_Try, /*On fail goto*//*Label 9096*/ GIMT_Encode4(551335), // Rule ID 3005 //
     /*  551265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  551285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551311 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551333 */     GIR_RootConstrainSelectedInstOperands,
     /*  551334 */     // GIR_Coverage, 3005,
     /*  551334 */     GIR_EraseRootFromParent_Done,
     /*  551335 */   // Label 9096: @551335
     /*  551335 */   GIM_Try, /*On fail goto*//*Label 9097*/ GIMT_Encode4(551410), // Rule ID 3008 //
     /*  551340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  551351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  551354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  551357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  551360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551386 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  551386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551408 */     GIR_RootConstrainSelectedInstOperands,
     /*  551409 */     // GIR_Coverage, 3008,
     /*  551409 */     GIR_EraseRootFromParent_Done,
     /*  551410 */   // Label 9097: @551410
     /*  551410 */   GIM_Try, /*On fail goto*//*Label 9098*/ GIMT_Encode4(551485), // Rule ID 3009 //
     /*  551415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  551426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  551429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  551432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  551435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551461 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  551461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551483 */     GIR_RootConstrainSelectedInstOperands,
     /*  551484 */     // GIR_Coverage, 3009,
     /*  551484 */     GIR_EraseRootFromParent_Done,
     /*  551485 */   // Label 9098: @551485
     /*  551485 */   GIM_Try, /*On fail goto*//*Label 9099*/ GIMT_Encode4(551560), // Rule ID 3012 //
     /*  551490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  551493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  551501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  551504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  551507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  551510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551536 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  551536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  551555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551558 */     GIR_RootConstrainSelectedInstOperands,
     /*  551559 */     // GIR_Coverage, 3012,
     /*  551559 */     GIR_EraseRootFromParent_Done,
     /*  551560 */   // Label 9099: @551560
     /*  551560 */   GIM_Try, /*On fail goto*//*Label 9100*/ GIMT_Encode4(551635), // Rule ID 3013 //
     /*  551565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  551568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  551576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  551579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  551582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  551585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551611 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  551611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  551630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551633 */     GIR_RootConstrainSelectedInstOperands,
     /*  551634 */     // GIR_Coverage, 3013,
     /*  551634 */     GIR_EraseRootFromParent_Done,
     /*  551635 */   // Label 9100: @551635
     /*  551635 */   GIM_Try, /*On fail goto*//*Label 9101*/ GIMT_Encode4(551710), // Rule ID 3016 //
     /*  551640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  551651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  551654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  551657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  551660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551686 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  551689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551708 */     GIR_RootConstrainSelectedInstOperands,
     /*  551709 */     // GIR_Coverage, 3016,
     /*  551709 */     GIR_EraseRootFromParent_Done,
     /*  551710 */   // Label 9101: @551710
     /*  551710 */   GIM_Try, /*On fail goto*//*Label 9102*/ GIMT_Encode4(551785), // Rule ID 3017 //
     /*  551715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  551726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  551729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  551732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  551735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551761 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  551764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551783 */     GIR_RootConstrainSelectedInstOperands,
     /*  551784 */     // GIR_Coverage, 3017,
     /*  551784 */     GIR_EraseRootFromParent_Done,
     /*  551785 */   // Label 9102: @551785
     /*  551785 */   GIM_Try, /*On fail goto*//*Label 9103*/ GIMT_Encode4(551860), // Rule ID 3020 //
     /*  551790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  551801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  551804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  551807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  551810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551836 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  551839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551858 */     GIR_RootConstrainSelectedInstOperands,
     /*  551859 */     // GIR_Coverage, 3020,
     /*  551859 */     GIR_EraseRootFromParent_Done,
     /*  551860 */   // Label 9103: @551860
     /*  551860 */   GIM_Try, /*On fail goto*//*Label 9104*/ GIMT_Encode4(551935), // Rule ID 3021 //
     /*  551865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  551876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  551879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  551882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  551885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551911 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  551914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551933 */     GIR_RootConstrainSelectedInstOperands,
     /*  551934 */     // GIR_Coverage, 3021,
     /*  551934 */     GIR_EraseRootFromParent_Done,
     /*  551935 */   // Label 9104: @551935
     /*  551935 */   GIM_Try, /*On fail goto*//*Label 9105*/ GIMT_Encode4(552010), // Rule ID 3024 //
     /*  551940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  551951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  551954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  551957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  551960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551986 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  551989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552008 */     GIR_RootConstrainSelectedInstOperands,
     /*  552009 */     // GIR_Coverage, 3024,
     /*  552009 */     GIR_EraseRootFromParent_Done,
     /*  552010 */   // Label 9105: @552010
     /*  552010 */   GIM_Try, /*On fail goto*//*Label 9106*/ GIMT_Encode4(552085), // Rule ID 3025 //
     /*  552015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  552026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  552029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  552032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  552035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552061 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552083 */     GIR_RootConstrainSelectedInstOperands,
     /*  552084 */     // GIR_Coverage, 3025,
     /*  552084 */     GIR_EraseRootFromParent_Done,
     /*  552085 */   // Label 9106: @552085
     /*  552085 */   GIM_Try, /*On fail goto*//*Label 9107*/ GIMT_Encode4(552160), // Rule ID 3028 //
     /*  552090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  552110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552136 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552158 */     GIR_RootConstrainSelectedInstOperands,
     /*  552159 */     // GIR_Coverage, 3028,
     /*  552159 */     GIR_EraseRootFromParent_Done,
     /*  552160 */   // Label 9107: @552160
     /*  552160 */   GIM_Try, /*On fail goto*//*Label 9108*/ GIMT_Encode4(552235), // Rule ID 3029 //
     /*  552165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  552185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552211 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552233 */     GIR_RootConstrainSelectedInstOperands,
     /*  552234 */     // GIR_Coverage, 3029,
     /*  552234 */     GIR_EraseRootFromParent_Done,
     /*  552235 */   // Label 9108: @552235
     /*  552235 */   GIM_Try, /*On fail goto*//*Label 9109*/ GIMT_Encode4(552310), // Rule ID 3032 //
     /*  552240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  552251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  552254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  552257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  552260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552286 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552308 */     GIR_RootConstrainSelectedInstOperands,
     /*  552309 */     // GIR_Coverage, 3032,
     /*  552309 */     GIR_EraseRootFromParent_Done,
     /*  552310 */   // Label 9109: @552310
     /*  552310 */   GIM_Try, /*On fail goto*//*Label 9110*/ GIMT_Encode4(552385), // Rule ID 3033 //
     /*  552315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  552326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  552329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  552332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  552335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552361 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552383 */     GIR_RootConstrainSelectedInstOperands,
     /*  552384 */     // GIR_Coverage, 3033,
     /*  552384 */     GIR_EraseRootFromParent_Done,
     /*  552385 */   // Label 9110: @552385
     /*  552385 */   GIM_Try, /*On fail goto*//*Label 9111*/ GIMT_Encode4(552460), // Rule ID 3036 //
     /*  552390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  552401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  552404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  552407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  552410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552436 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552458 */     GIR_RootConstrainSelectedInstOperands,
     /*  552459 */     // GIR_Coverage, 3036,
     /*  552459 */     GIR_EraseRootFromParent_Done,
     /*  552460 */   // Label 9111: @552460
     /*  552460 */   GIM_Try, /*On fail goto*//*Label 9112*/ GIMT_Encode4(552535), // Rule ID 3037 //
     /*  552465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  552476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  552479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  552482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  552485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552511 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552533 */     GIR_RootConstrainSelectedInstOperands,
     /*  552534 */     // GIR_Coverage, 3037,
     /*  552534 */     GIR_EraseRootFromParent_Done,
     /*  552535 */   // Label 9112: @552535
     /*  552535 */   GIM_Try, /*On fail goto*//*Label 9113*/ GIMT_Encode4(552610), // Rule ID 3040 //
     /*  552540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  552551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  552554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  552557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  552560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  552586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552608 */     GIR_RootConstrainSelectedInstOperands,
     /*  552609 */     // GIR_Coverage, 3040,
     /*  552609 */     GIR_EraseRootFromParent_Done,
     /*  552610 */   // Label 9113: @552610
     /*  552610 */   GIM_Try, /*On fail goto*//*Label 9114*/ GIMT_Encode4(552685), // Rule ID 3041 //
     /*  552615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  552626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  552629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  552632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  552635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552661 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  552661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552683 */     GIR_RootConstrainSelectedInstOperands,
     /*  552684 */     // GIR_Coverage, 3041,
     /*  552684 */     GIR_EraseRootFromParent_Done,
     /*  552685 */   // Label 9114: @552685
     /*  552685 */   GIM_Try, /*On fail goto*//*Label 9115*/ GIMT_Encode4(552760), // Rule ID 3044 //
     /*  552690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  552701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  552704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  552707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  552710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  552736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552758 */     GIR_RootConstrainSelectedInstOperands,
     /*  552759 */     // GIR_Coverage, 3044,
     /*  552759 */     GIR_EraseRootFromParent_Done,
     /*  552760 */   // Label 9115: @552760
     /*  552760 */   GIM_Try, /*On fail goto*//*Label 9116*/ GIMT_Encode4(552835), // Rule ID 3045 //
     /*  552765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  552776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  552779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  552782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  552785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552811 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  552811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552833 */     GIR_RootConstrainSelectedInstOperands,
     /*  552834 */     // GIR_Coverage, 3045,
     /*  552834 */     GIR_EraseRootFromParent_Done,
     /*  552835 */   // Label 9116: @552835
     /*  552835 */   GIM_Try, /*On fail goto*//*Label 9117*/ GIMT_Encode4(552910), // Rule ID 3048 //
     /*  552840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  552851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  552854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  552857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  552860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552886 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  552886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552908 */     GIR_RootConstrainSelectedInstOperands,
     /*  552909 */     // GIR_Coverage, 3048,
     /*  552909 */     GIR_EraseRootFromParent_Done,
     /*  552910 */   // Label 9117: @552910
     /*  552910 */   GIM_Try, /*On fail goto*//*Label 9118*/ GIMT_Encode4(552985), // Rule ID 3049 //
     /*  552915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  552926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  552929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  552932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  552935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552961 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  552961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552983 */     GIR_RootConstrainSelectedInstOperands,
     /*  552984 */     // GIR_Coverage, 3049,
     /*  552984 */     GIR_EraseRootFromParent_Done,
     /*  552985 */   // Label 9118: @552985
     /*  552985 */   GIM_Try, /*On fail goto*//*Label 9119*/ GIMT_Encode4(553060), // Rule ID 3052 //
     /*  552990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  552993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  553001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  553004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  553007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  553010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  553039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553058 */     GIR_RootConstrainSelectedInstOperands,
     /*  553059 */     // GIR_Coverage, 3052,
     /*  553059 */     GIR_EraseRootFromParent_Done,
     /*  553060 */   // Label 9119: @553060
     /*  553060 */   GIM_Try, /*On fail goto*//*Label 9120*/ GIMT_Encode4(553135), // Rule ID 3053 //
     /*  553065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  553076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  553079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  553082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  553085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553111 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  553114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553133 */     GIR_RootConstrainSelectedInstOperands,
     /*  553134 */     // GIR_Coverage, 3053,
     /*  553134 */     GIR_EraseRootFromParent_Done,
     /*  553135 */   // Label 9120: @553135
     /*  553135 */   GIM_Try, /*On fail goto*//*Label 9121*/ GIMT_Encode4(553210), // Rule ID 3056 //
     /*  553140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  553160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553186 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  553189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553208 */     GIR_RootConstrainSelectedInstOperands,
     /*  553209 */     // GIR_Coverage, 3056,
     /*  553209 */     GIR_EraseRootFromParent_Done,
     /*  553210 */   // Label 9121: @553210
     /*  553210 */   GIM_Try, /*On fail goto*//*Label 9122*/ GIMT_Encode4(553285), // Rule ID 3057 //
     /*  553215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  553235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553261 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  553264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553283 */     GIR_RootConstrainSelectedInstOperands,
     /*  553284 */     // GIR_Coverage, 3057,
     /*  553284 */     GIR_EraseRootFromParent_Done,
     /*  553285 */   // Label 9122: @553285
     /*  553285 */   GIM_Try, /*On fail goto*//*Label 9123*/ GIMT_Encode4(553360), // Rule ID 3060 //
     /*  553290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  553301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  553304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  553307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  553310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553336 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  553339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553358 */     GIR_RootConstrainSelectedInstOperands,
     /*  553359 */     // GIR_Coverage, 3060,
     /*  553359 */     GIR_EraseRootFromParent_Done,
     /*  553360 */   // Label 9123: @553360
     /*  553360 */   GIM_Try, /*On fail goto*//*Label 9124*/ GIMT_Encode4(553435), // Rule ID 3061 //
     /*  553365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  553376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  553379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  553382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  553385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553411 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  553414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553433 */     GIR_RootConstrainSelectedInstOperands,
     /*  553434 */     // GIR_Coverage, 3061,
     /*  553434 */     GIR_EraseRootFromParent_Done,
     /*  553435 */   // Label 9124: @553435
     /*  553435 */   GIM_Try, /*On fail goto*//*Label 9125*/ GIMT_Encode4(553510), // Rule ID 3064 //
     /*  553440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  553451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  553454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  553457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553486 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  553489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553508 */     GIR_RootConstrainSelectedInstOperands,
     /*  553509 */     // GIR_Coverage, 3064,
     /*  553509 */     GIR_EraseRootFromParent_Done,
     /*  553510 */   // Label 9125: @553510
     /*  553510 */   GIM_Try, /*On fail goto*//*Label 9126*/ GIMT_Encode4(553585), // Rule ID 3065 //
     /*  553515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  553526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  553529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  553532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553561 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  553561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  553564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553583 */     GIR_RootConstrainSelectedInstOperands,
     /*  553584 */     // GIR_Coverage, 3065,
     /*  553584 */     GIR_EraseRootFromParent_Done,
     /*  553585 */   // Label 9126: @553585
     /*  553585 */   GIM_Try, /*On fail goto*//*Label 9127*/ GIMT_Encode4(553660), // Rule ID 3068 //
     /*  553590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  553601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  553604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  553607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553636 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  553639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553658 */     GIR_RootConstrainSelectedInstOperands,
     /*  553659 */     // GIR_Coverage, 3068,
     /*  553659 */     GIR_EraseRootFromParent_Done,
     /*  553660 */   // Label 9127: @553660
     /*  553660 */   GIM_Try, /*On fail goto*//*Label 9128*/ GIMT_Encode4(553735), // Rule ID 3069 //
     /*  553665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  553676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  553679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  553682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553711 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  553711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  553714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553733 */     GIR_RootConstrainSelectedInstOperands,
     /*  553734 */     // GIR_Coverage, 3069,
     /*  553734 */     GIR_EraseRootFromParent_Done,
     /*  553735 */   // Label 9128: @553735
     /*  553735 */   GIM_Try, /*On fail goto*//*Label 9129*/ GIMT_Encode4(553810), // Rule ID 3072 //
     /*  553740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  553751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  553754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  553757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553786 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  553789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553808 */     GIR_RootConstrainSelectedInstOperands,
     /*  553809 */     // GIR_Coverage, 3072,
     /*  553809 */     GIR_EraseRootFromParent_Done,
     /*  553810 */   // Label 9129: @553810
     /*  553810 */   GIM_Try, /*On fail goto*//*Label 9130*/ GIMT_Encode4(553885), // Rule ID 3073 //
     /*  553815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  553826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  553829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  553832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553861 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  553861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  553864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553883 */     GIR_RootConstrainSelectedInstOperands,
     /*  553884 */     // GIR_Coverage, 3073,
     /*  553884 */     GIR_EraseRootFromParent_Done,
     /*  553885 */   // Label 9130: @553885
     /*  553885 */   GIM_Try, /*On fail goto*//*Label 9131*/ GIMT_Encode4(553960), // Rule ID 3076 //
     /*  553890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  553901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  553904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  553907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553936 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  553936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  553939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  553955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553958 */     GIR_RootConstrainSelectedInstOperands,
     /*  553959 */     // GIR_Coverage, 3076,
     /*  553959 */     GIR_EraseRootFromParent_Done,
     /*  553960 */   // Label 9131: @553960
     /*  553960 */   GIM_Try, /*On fail goto*//*Label 9132*/ GIMT_Encode4(554035), // Rule ID 3077 //
     /*  553965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  553976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  553979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  553982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554011 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  554014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554033 */     GIR_RootConstrainSelectedInstOperands,
     /*  554034 */     // GIR_Coverage, 3077,
     /*  554034 */     GIR_EraseRootFromParent_Done,
     /*  554035 */   // Label 9132: @554035
     /*  554035 */   GIM_Try, /*On fail goto*//*Label 9133*/ GIMT_Encode4(554110), // Rule ID 3080 //
     /*  554040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554108 */     GIR_RootConstrainSelectedInstOperands,
     /*  554109 */     // GIR_Coverage, 3080,
     /*  554109 */     GIR_EraseRootFromParent_Done,
     /*  554110 */   // Label 9133: @554110
     /*  554110 */   GIM_Try, /*On fail goto*//*Label 9134*/ GIMT_Encode4(554185), // Rule ID 3081 //
     /*  554115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554161 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554183 */     GIR_RootConstrainSelectedInstOperands,
     /*  554184 */     // GIR_Coverage, 3081,
     /*  554184 */     GIR_EraseRootFromParent_Done,
     /*  554185 */   // Label 9134: @554185
     /*  554185 */   GIM_Try, /*On fail goto*//*Label 9135*/ GIMT_Encode4(554260), // Rule ID 3084 //
     /*  554190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554236 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  554236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554258 */     GIR_RootConstrainSelectedInstOperands,
     /*  554259 */     // GIR_Coverage, 3084,
     /*  554259 */     GIR_EraseRootFromParent_Done,
     /*  554260 */   // Label 9135: @554260
     /*  554260 */   GIM_Try, /*On fail goto*//*Label 9136*/ GIMT_Encode4(554335), // Rule ID 3085 //
     /*  554265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554311 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  554311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554333 */     GIR_RootConstrainSelectedInstOperands,
     /*  554334 */     // GIR_Coverage, 3085,
     /*  554334 */     GIR_EraseRootFromParent_Done,
     /*  554335 */   // Label 9136: @554335
     /*  554335 */   GIM_Try, /*On fail goto*//*Label 9137*/ GIMT_Encode4(554410), // Rule ID 3088 //
     /*  554340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554386 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554408 */     GIR_RootConstrainSelectedInstOperands,
     /*  554409 */     // GIR_Coverage, 3088,
     /*  554409 */     GIR_EraseRootFromParent_Done,
     /*  554410 */   // Label 9137: @554410
     /*  554410 */   GIM_Try, /*On fail goto*//*Label 9138*/ GIMT_Encode4(554485), // Rule ID 3089 //
     /*  554415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554461 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554483 */     GIR_RootConstrainSelectedInstOperands,
     /*  554484 */     // GIR_Coverage, 3089,
     /*  554484 */     GIR_EraseRootFromParent_Done,
     /*  554485 */   // Label 9138: @554485
     /*  554485 */   GIM_Try, /*On fail goto*//*Label 9139*/ GIMT_Encode4(554560), // Rule ID 3092 //
     /*  554490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  554501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  554504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  554507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554536 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554558 */     GIR_RootConstrainSelectedInstOperands,
     /*  554559 */     // GIR_Coverage, 3092,
     /*  554559 */     GIR_EraseRootFromParent_Done,
     /*  554560 */   // Label 9139: @554560
     /*  554560 */   GIM_Try, /*On fail goto*//*Label 9140*/ GIMT_Encode4(554635), // Rule ID 3093 //
     /*  554565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  554576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  554579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  554582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554611 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554633 */     GIR_RootConstrainSelectedInstOperands,
     /*  554634 */     // GIR_Coverage, 3093,
     /*  554634 */     GIR_EraseRootFromParent_Done,
     /*  554635 */   // Label 9140: @554635
     /*  554635 */   GIM_Try, /*On fail goto*//*Label 9141*/ GIMT_Encode4(554710), // Rule ID 3096 //
     /*  554640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  554651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  554654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  554657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554686 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  554686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554708 */     GIR_RootConstrainSelectedInstOperands,
     /*  554709 */     // GIR_Coverage, 3096,
     /*  554709 */     GIR_EraseRootFromParent_Done,
     /*  554710 */   // Label 9141: @554710
     /*  554710 */   GIM_Try, /*On fail goto*//*Label 9142*/ GIMT_Encode4(554785), // Rule ID 3097 //
     /*  554715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  554726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  554729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  554732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554761 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  554761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554783 */     GIR_RootConstrainSelectedInstOperands,
     /*  554784 */     // GIR_Coverage, 3097,
     /*  554784 */     GIR_EraseRootFromParent_Done,
     /*  554785 */   // Label 9142: @554785
     /*  554785 */   GIM_Try, /*On fail goto*//*Label 9143*/ GIMT_Encode4(554860), // Rule ID 3100 //
     /*  554790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  554793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  554801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  554804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  554807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554836 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  554836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  554855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554858 */     GIR_RootConstrainSelectedInstOperands,
     /*  554859 */     // GIR_Coverage, 3100,
     /*  554859 */     GIR_EraseRootFromParent_Done,
     /*  554860 */   // Label 9143: @554860
     /*  554860 */   GIM_Try, /*On fail goto*//*Label 9144*/ GIMT_Encode4(554935), // Rule ID 3101 //
     /*  554865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  554868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  554876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  554879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  554882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554911 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  554911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  554930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554933 */     GIR_RootConstrainSelectedInstOperands,
     /*  554934 */     // GIR_Coverage, 3101,
     /*  554934 */     GIR_EraseRootFromParent_Done,
     /*  554935 */   // Label 9144: @554935
     /*  554935 */   GIM_Try, /*On fail goto*//*Label 9145*/ GIMT_Encode4(555010), // Rule ID 3104 //
     /*  554940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  554951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  554954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  554957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554986 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  554989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555008 */     GIR_RootConstrainSelectedInstOperands,
     /*  555009 */     // GIR_Coverage, 3104,
     /*  555009 */     GIR_EraseRootFromParent_Done,
     /*  555010 */   // Label 9145: @555010
     /*  555010 */   GIM_Try, /*On fail goto*//*Label 9146*/ GIMT_Encode4(555085), // Rule ID 3105 //
     /*  555015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  555026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  555029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  555032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555061 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555083 */     GIR_RootConstrainSelectedInstOperands,
     /*  555084 */     // GIR_Coverage, 3105,
     /*  555084 */     GIR_EraseRootFromParent_Done,
     /*  555085 */   // Label 9146: @555085
     /*  555085 */   GIM_Try, /*On fail goto*//*Label 9147*/ GIMT_Encode4(555160), // Rule ID 3108 //
     /*  555090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555136 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555158 */     GIR_RootConstrainSelectedInstOperands,
     /*  555159 */     // GIR_Coverage, 3108,
     /*  555159 */     GIR_EraseRootFromParent_Done,
     /*  555160 */   // Label 9147: @555160
     /*  555160 */   GIM_Try, /*On fail goto*//*Label 9148*/ GIMT_Encode4(555235), // Rule ID 3109 //
     /*  555165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555211 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555233 */     GIR_RootConstrainSelectedInstOperands,
     /*  555234 */     // GIR_Coverage, 3109,
     /*  555234 */     GIR_EraseRootFromParent_Done,
     /*  555235 */   // Label 9148: @555235
     /*  555235 */   GIM_Try, /*On fail goto*//*Label 9149*/ GIMT_Encode4(555310), // Rule ID 3112 //
     /*  555240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555286 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555308 */     GIR_RootConstrainSelectedInstOperands,
     /*  555309 */     // GIR_Coverage, 3112,
     /*  555309 */     GIR_EraseRootFromParent_Done,
     /*  555310 */   // Label 9149: @555310
     /*  555310 */   GIM_Try, /*On fail goto*//*Label 9150*/ GIMT_Encode4(555385), // Rule ID 3113 //
     /*  555315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555361 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555383 */     GIR_RootConstrainSelectedInstOperands,
     /*  555384 */     // GIR_Coverage, 3113,
     /*  555384 */     GIR_EraseRootFromParent_Done,
     /*  555385 */   // Label 9150: @555385
     /*  555385 */   GIM_Try, /*On fail goto*//*Label 9151*/ GIMT_Encode4(555460), // Rule ID 3116 //
     /*  555390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  555401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  555404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  555407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555436 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555458 */     GIR_RootConstrainSelectedInstOperands,
     /*  555459 */     // GIR_Coverage, 3116,
     /*  555459 */     GIR_EraseRootFromParent_Done,
     /*  555460 */   // Label 9151: @555460
     /*  555460 */   GIM_Try, /*On fail goto*//*Label 9152*/ GIMT_Encode4(555535), // Rule ID 3117 //
     /*  555465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  555476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  555479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  555482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555511 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555533 */     GIR_RootConstrainSelectedInstOperands,
     /*  555534 */     // GIR_Coverage, 3117,
     /*  555534 */     GIR_EraseRootFromParent_Done,
     /*  555535 */   // Label 9152: @555535
     /*  555535 */   GIM_Try, /*On fail goto*//*Label 9153*/ GIMT_Encode4(555610), // Rule ID 3120 //
     /*  555540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  555551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  555554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  555557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555586 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555608 */     GIR_RootConstrainSelectedInstOperands,
     /*  555609 */     // GIR_Coverage, 3120,
     /*  555609 */     GIR_EraseRootFromParent_Done,
     /*  555610 */   // Label 9153: @555610
     /*  555610 */   GIM_Try, /*On fail goto*//*Label 9154*/ GIMT_Encode4(555685), // Rule ID 3121 //
     /*  555615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  555626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  555629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  555632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555661 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555683 */     GIR_RootConstrainSelectedInstOperands,
     /*  555684 */     // GIR_Coverage, 3121,
     /*  555684 */     GIR_EraseRootFromParent_Done,
     /*  555685 */   // Label 9154: @555685
     /*  555685 */   GIM_Try, /*On fail goto*//*Label 9155*/ GIMT_Encode4(555760), // Rule ID 3124 //
     /*  555690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  555701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  555704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  555707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555736 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555758 */     GIR_RootConstrainSelectedInstOperands,
     /*  555759 */     // GIR_Coverage, 3124,
     /*  555759 */     GIR_EraseRootFromParent_Done,
     /*  555760 */   // Label 9155: @555760
     /*  555760 */   GIM_Try, /*On fail goto*//*Label 9156*/ GIMT_Encode4(555835), // Rule ID 3125 //
     /*  555765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  555776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  555779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  555782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555811 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555833 */     GIR_RootConstrainSelectedInstOperands,
     /*  555834 */     // GIR_Coverage, 3125,
     /*  555834 */     GIR_EraseRootFromParent_Done,
     /*  555835 */   // Label 9156: @555835
     /*  555835 */   GIM_Try, /*On fail goto*//*Label 9157*/ GIMT_Encode4(555910), // Rule ID 3128 //
     /*  555840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  555851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  555854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  555857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555886 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  555886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555908 */     GIR_RootConstrainSelectedInstOperands,
     /*  555909 */     // GIR_Coverage, 3128,
     /*  555909 */     GIR_EraseRootFromParent_Done,
     /*  555910 */   // Label 9157: @555910
     /*  555910 */   GIM_Try, /*On fail goto*//*Label 9158*/ GIMT_Encode4(555985), // Rule ID 3129 //
     /*  555915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  555926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  555929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  555932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555961 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  555961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555983 */     GIR_RootConstrainSelectedInstOperands,
     /*  555984 */     // GIR_Coverage, 3129,
     /*  555984 */     GIR_EraseRootFromParent_Done,
     /*  555985 */   // Label 9158: @555985
     /*  555985 */   GIM_Try, /*On fail goto*//*Label 9159*/ GIMT_Encode4(556060), // Rule ID 3132 //
     /*  555990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  556001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  556004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  556007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556058 */     GIR_RootConstrainSelectedInstOperands,
     /*  556059 */     // GIR_Coverage, 3132,
     /*  556059 */     GIR_EraseRootFromParent_Done,
     /*  556060 */   // Label 9159: @556060
     /*  556060 */   GIM_Try, /*On fail goto*//*Label 9160*/ GIMT_Encode4(556135), // Rule ID 3133 //
     /*  556065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  556076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  556079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  556082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556111 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556133 */     GIR_RootConstrainSelectedInstOperands,
     /*  556134 */     // GIR_Coverage, 3133,
     /*  556134 */     GIR_EraseRootFromParent_Done,
     /*  556135 */   // Label 9160: @556135
     /*  556135 */   GIM_Try, /*On fail goto*//*Label 9161*/ GIMT_Encode4(556210), // Rule ID 3136 //
     /*  556140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556208 */     GIR_RootConstrainSelectedInstOperands,
     /*  556209 */     // GIR_Coverage, 3136,
     /*  556209 */     GIR_EraseRootFromParent_Done,
     /*  556210 */   // Label 9161: @556210
     /*  556210 */   GIM_Try, /*On fail goto*//*Label 9162*/ GIMT_Encode4(556285), // Rule ID 3137 //
     /*  556215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556261 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556283 */     GIR_RootConstrainSelectedInstOperands,
     /*  556284 */     // GIR_Coverage, 3137,
     /*  556284 */     GIR_EraseRootFromParent_Done,
     /*  556285 */   // Label 9162: @556285
     /*  556285 */   GIM_Try, /*On fail goto*//*Label 9163*/ GIMT_Encode4(556360), // Rule ID 3140 //
     /*  556290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556336 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  556339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556358 */     GIR_RootConstrainSelectedInstOperands,
     /*  556359 */     // GIR_Coverage, 3140,
     /*  556359 */     GIR_EraseRootFromParent_Done,
     /*  556360 */   // Label 9163: @556360
     /*  556360 */   GIM_Try, /*On fail goto*//*Label 9164*/ GIMT_Encode4(556435), // Rule ID 3141 //
     /*  556365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556411 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  556414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556433 */     GIR_RootConstrainSelectedInstOperands,
     /*  556434 */     // GIR_Coverage, 3141,
     /*  556434 */     GIR_EraseRootFromParent_Done,
     /*  556435 */   // Label 9164: @556435
     /*  556435 */   GIM_Try, /*On fail goto*//*Label 9165*/ GIMT_Encode4(556510), // Rule ID 3144 //
     /*  556440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  556451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  556454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  556457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556486 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556508 */     GIR_RootConstrainSelectedInstOperands,
     /*  556509 */     // GIR_Coverage, 3144,
     /*  556509 */     GIR_EraseRootFromParent_Done,
     /*  556510 */   // Label 9165: @556510
     /*  556510 */   GIM_Try, /*On fail goto*//*Label 9166*/ GIMT_Encode4(556585), // Rule ID 3145 //
     /*  556515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  556526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  556529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  556532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556561 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556583 */     GIR_RootConstrainSelectedInstOperands,
     /*  556584 */     // GIR_Coverage, 3145,
     /*  556584 */     GIR_EraseRootFromParent_Done,
     /*  556585 */   // Label 9166: @556585
     /*  556585 */   GIM_Try, /*On fail goto*//*Label 9167*/ GIMT_Encode4(556660), // Rule ID 3148 //
     /*  556590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  556601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  556604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  556607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556636 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556658 */     GIR_RootConstrainSelectedInstOperands,
     /*  556659 */     // GIR_Coverage, 3148,
     /*  556659 */     GIR_EraseRootFromParent_Done,
     /*  556660 */   // Label 9167: @556660
     /*  556660 */   GIM_Try, /*On fail goto*//*Label 9168*/ GIMT_Encode4(556735), // Rule ID 3149 //
     /*  556665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  556676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  556679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  556682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556711 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556733 */     GIR_RootConstrainSelectedInstOperands,
     /*  556734 */     // GIR_Coverage, 3149,
     /*  556734 */     GIR_EraseRootFromParent_Done,
     /*  556735 */   // Label 9168: @556735
     /*  556735 */   GIM_Try, /*On fail goto*//*Label 9169*/ GIMT_Encode4(556810), // Rule ID 3240 //
     /*  556740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  556751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  556754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  556757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  556760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556786 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  556786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  556789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  556805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556808 */     GIR_RootConstrainSelectedInstOperands,
     /*  556809 */     // GIR_Coverage, 3240,
     /*  556809 */     GIR_EraseRootFromParent_Done,
     /*  556810 */   // Label 9169: @556810
     /*  556810 */   GIM_Try, /*On fail goto*//*Label 9170*/ GIMT_Encode4(556885), // Rule ID 3241 //
     /*  556815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  556826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  556829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  556832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  556835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556861 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  556861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  556864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  556880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556883 */     GIR_RootConstrainSelectedInstOperands,
     /*  556884 */     // GIR_Coverage, 3241,
     /*  556884 */     GIR_EraseRootFromParent_Done,
     /*  556885 */   // Label 9170: @556885
     /*  556885 */   GIM_Try, /*On fail goto*//*Label 9171*/ GIMT_Encode4(556960), // Rule ID 3244 //
     /*  556890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  556901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  556904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  556907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  556910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556936 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  556936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  556939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  556955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556958 */     GIR_RootConstrainSelectedInstOperands,
     /*  556959 */     // GIR_Coverage, 3244,
     /*  556959 */     GIR_EraseRootFromParent_Done,
     /*  556960 */   // Label 9171: @556960
     /*  556960 */   GIM_Try, /*On fail goto*//*Label 9172*/ GIMT_Encode4(557035), // Rule ID 3245 //
     /*  556965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  556976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  556979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  556982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  556985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557011 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557033 */     GIR_RootConstrainSelectedInstOperands,
     /*  557034 */     // GIR_Coverage, 3245,
     /*  557034 */     GIR_EraseRootFromParent_Done,
     /*  557035 */   // Label 9172: @557035
     /*  557035 */   GIM_Try, /*On fail goto*//*Label 9173*/ GIMT_Encode4(557110), // Rule ID 3248 //
     /*  557040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  557060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557086 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557108 */     GIR_RootConstrainSelectedInstOperands,
     /*  557109 */     // GIR_Coverage, 3248,
     /*  557109 */     GIR_EraseRootFromParent_Done,
     /*  557110 */   // Label 9173: @557110
     /*  557110 */   GIM_Try, /*On fail goto*//*Label 9174*/ GIMT_Encode4(557185), // Rule ID 3249 //
     /*  557115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  557135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557161 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557183 */     GIR_RootConstrainSelectedInstOperands,
     /*  557184 */     // GIR_Coverage, 3249,
     /*  557184 */     GIR_EraseRootFromParent_Done,
     /*  557185 */   // Label 9174: @557185
     /*  557185 */   GIM_Try, /*On fail goto*//*Label 9175*/ GIMT_Encode4(557260), // Rule ID 3252 //
     /*  557190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  557210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557236 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557258 */     GIR_RootConstrainSelectedInstOperands,
     /*  557259 */     // GIR_Coverage, 3252,
     /*  557259 */     GIR_EraseRootFromParent_Done,
     /*  557260 */   // Label 9175: @557260
     /*  557260 */   GIM_Try, /*On fail goto*//*Label 9176*/ GIMT_Encode4(557335), // Rule ID 3253 //
     /*  557265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  557285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557311 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557333 */     GIR_RootConstrainSelectedInstOperands,
     /*  557334 */     // GIR_Coverage, 3253,
     /*  557334 */     GIR_EraseRootFromParent_Done,
     /*  557335 */   // Label 9176: @557335
     /*  557335 */   GIM_Try, /*On fail goto*//*Label 9177*/ GIMT_Encode4(557410), // Rule ID 3256 //
     /*  557340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  557360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557386 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557408 */     GIR_RootConstrainSelectedInstOperands,
     /*  557409 */     // GIR_Coverage, 3256,
     /*  557409 */     GIR_EraseRootFromParent_Done,
     /*  557410 */   // Label 9177: @557410
     /*  557410 */   GIM_Try, /*On fail goto*//*Label 9178*/ GIMT_Encode4(557485), // Rule ID 3257 //
     /*  557415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  557435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557461 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557483 */     GIR_RootConstrainSelectedInstOperands,
     /*  557484 */     // GIR_Coverage, 3257,
     /*  557484 */     GIR_EraseRootFromParent_Done,
     /*  557485 */   // Label 9178: @557485
     /*  557485 */   GIM_Try, /*On fail goto*//*Label 9179*/ GIMT_Encode4(557560), // Rule ID 3260 //
     /*  557490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  557501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  557504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  557507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  557510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557536 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  557536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  557555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557558 */     GIR_RootConstrainSelectedInstOperands,
     /*  557559 */     // GIR_Coverage, 3260,
     /*  557559 */     GIR_EraseRootFromParent_Done,
     /*  557560 */   // Label 9179: @557560
     /*  557560 */   GIM_Try, /*On fail goto*//*Label 9180*/ GIMT_Encode4(557635), // Rule ID 3261 //
     /*  557565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  557576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  557579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  557582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  557585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557611 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  557611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  557630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557633 */     GIR_RootConstrainSelectedInstOperands,
     /*  557634 */     // GIR_Coverage, 3261,
     /*  557634 */     GIR_EraseRootFromParent_Done,
     /*  557635 */   // Label 9180: @557635
     /*  557635 */   GIM_Try, /*On fail goto*//*Label 9181*/ GIMT_Encode4(557710), // Rule ID 3264 //
     /*  557640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  557651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  557654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  557657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  557660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557686 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557708 */     GIR_RootConstrainSelectedInstOperands,
     /*  557709 */     // GIR_Coverage, 3264,
     /*  557709 */     GIR_EraseRootFromParent_Done,
     /*  557710 */   // Label 9181: @557710
     /*  557710 */   GIM_Try, /*On fail goto*//*Label 9182*/ GIMT_Encode4(557785), // Rule ID 3265 //
     /*  557715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  557726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  557729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  557732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  557735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557761 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557783 */     GIR_RootConstrainSelectedInstOperands,
     /*  557784 */     // GIR_Coverage, 3265,
     /*  557784 */     GIR_EraseRootFromParent_Done,
     /*  557785 */   // Label 9182: @557785
     /*  557785 */   GIM_Try, /*On fail goto*//*Label 9183*/ GIMT_Encode4(557860), // Rule ID 3268 //
     /*  557790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  557801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  557804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  557807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  557810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557836 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557858 */     GIR_RootConstrainSelectedInstOperands,
     /*  557859 */     // GIR_Coverage, 3268,
     /*  557859 */     GIR_EraseRootFromParent_Done,
     /*  557860 */   // Label 9183: @557860
     /*  557860 */   GIM_Try, /*On fail goto*//*Label 9184*/ GIMT_Encode4(557935), // Rule ID 3269 //
     /*  557865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  557876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  557879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  557882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  557885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557911 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557933 */     GIR_RootConstrainSelectedInstOperands,
     /*  557934 */     // GIR_Coverage, 3269,
     /*  557934 */     GIR_EraseRootFromParent_Done,
     /*  557935 */   // Label 9184: @557935
     /*  557935 */   GIM_Try, /*On fail goto*//*Label 9185*/ GIMT_Encode4(558010), // Rule ID 3272 //
     /*  557940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  557951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  557954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  557957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  557960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557986 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  557986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558008 */     GIR_RootConstrainSelectedInstOperands,
     /*  558009 */     // GIR_Coverage, 3272,
     /*  558009 */     GIR_EraseRootFromParent_Done,
     /*  558010 */   // Label 9185: @558010
     /*  558010 */   GIM_Try, /*On fail goto*//*Label 9186*/ GIMT_Encode4(558085), // Rule ID 3273 //
     /*  558015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  558026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  558029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  558032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  558035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558061 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  558061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558083 */     GIR_RootConstrainSelectedInstOperands,
     /*  558084 */     // GIR_Coverage, 3273,
     /*  558084 */     GIR_EraseRootFromParent_Done,
     /*  558085 */   // Label 9186: @558085
     /*  558085 */   GIM_Try, /*On fail goto*//*Label 9187*/ GIMT_Encode4(558160), // Rule ID 3276 //
     /*  558090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  558093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  558110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558136 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  558136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558158 */     GIR_RootConstrainSelectedInstOperands,
     /*  558159 */     // GIR_Coverage, 3276,
     /*  558159 */     GIR_EraseRootFromParent_Done,
     /*  558160 */   // Label 9187: @558160
     /*  558160 */   GIM_Try, /*On fail goto*//*Label 9188*/ GIMT_Encode4(558235), // Rule ID 3277 //
     /*  558165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  558168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  558185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558211 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  558211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558233 */     GIR_RootConstrainSelectedInstOperands,
     /*  558234 */     // GIR_Coverage, 3277,
     /*  558234 */     GIR_EraseRootFromParent_Done,
     /*  558235 */   // Label 9188: @558235
     /*  558235 */   GIM_Try, /*On fail goto*//*Label 9189*/ GIMT_Encode4(558310), // Rule ID 3280 //
     /*  558240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  558260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558286 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558308 */     GIR_RootConstrainSelectedInstOperands,
     /*  558309 */     // GIR_Coverage, 3280,
     /*  558309 */     GIR_EraseRootFromParent_Done,
     /*  558310 */   // Label 9189: @558310
     /*  558310 */   GIM_Try, /*On fail goto*//*Label 9190*/ GIMT_Encode4(558385), // Rule ID 3281 //
     /*  558315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  558335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558361 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558383 */     GIR_RootConstrainSelectedInstOperands,
     /*  558384 */     // GIR_Coverage, 3281,
     /*  558384 */     GIR_EraseRootFromParent_Done,
     /*  558385 */   // Label 9190: @558385
     /*  558385 */   GIM_Try, /*On fail goto*//*Label 9191*/ GIMT_Encode4(558460), // Rule ID 3284 //
     /*  558390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  558401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  558404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  558407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  558410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558436 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558458 */     GIR_RootConstrainSelectedInstOperands,
     /*  558459 */     // GIR_Coverage, 3284,
     /*  558459 */     GIR_EraseRootFromParent_Done,
     /*  558460 */   // Label 9191: @558460
     /*  558460 */   GIM_Try, /*On fail goto*//*Label 9192*/ GIMT_Encode4(558535), // Rule ID 3285 //
     /*  558465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  558476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  558479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  558482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  558485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558511 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558533 */     GIR_RootConstrainSelectedInstOperands,
     /*  558534 */     // GIR_Coverage, 3285,
     /*  558534 */     GIR_EraseRootFromParent_Done,
     /*  558535 */   // Label 9192: @558535
     /*  558535 */   GIM_Try, /*On fail goto*//*Label 9193*/ GIMT_Encode4(558610), // Rule ID 3288 //
     /*  558540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  558551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  558554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  558557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  558560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558586 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  558589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558608 */     GIR_RootConstrainSelectedInstOperands,
     /*  558609 */     // GIR_Coverage, 3288,
     /*  558609 */     GIR_EraseRootFromParent_Done,
     /*  558610 */   // Label 9193: @558610
     /*  558610 */   GIM_Try, /*On fail goto*//*Label 9194*/ GIMT_Encode4(558685), // Rule ID 3289 //
     /*  558615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  558626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  558629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  558632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  558635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558661 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  558664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558683 */     GIR_RootConstrainSelectedInstOperands,
     /*  558684 */     // GIR_Coverage, 3289,
     /*  558684 */     GIR_EraseRootFromParent_Done,
     /*  558685 */   // Label 9194: @558685
     /*  558685 */   GIM_Try, /*On fail goto*//*Label 9195*/ GIMT_Encode4(558760), // Rule ID 3292 //
     /*  558690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  558701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  558704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  558707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  558710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  558736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558758 */     GIR_RootConstrainSelectedInstOperands,
     /*  558759 */     // GIR_Coverage, 3292,
     /*  558759 */     GIR_EraseRootFromParent_Done,
     /*  558760 */   // Label 9195: @558760
     /*  558760 */   GIM_Try, /*On fail goto*//*Label 9196*/ GIMT_Encode4(558835), // Rule ID 3293 //
     /*  558765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  558776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  558779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  558782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  558785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558811 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  558811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558833 */     GIR_RootConstrainSelectedInstOperands,
     /*  558834 */     // GIR_Coverage, 3293,
     /*  558834 */     GIR_EraseRootFromParent_Done,
     /*  558835 */   // Label 9196: @558835
     /*  558835 */   GIM_Try, /*On fail goto*//*Label 9197*/ GIMT_Encode4(558910), // Rule ID 3296 //
     /*  558840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  558851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  558854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  558857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  558860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558886 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  558886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558908 */     GIR_RootConstrainSelectedInstOperands,
     /*  558909 */     // GIR_Coverage, 3296,
     /*  558909 */     GIR_EraseRootFromParent_Done,
     /*  558910 */   // Label 9197: @558910
     /*  558910 */   GIM_Try, /*On fail goto*//*Label 9198*/ GIMT_Encode4(558985), // Rule ID 3297 //
     /*  558915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  558926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  558929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  558932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  558935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558961 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  558961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558983 */     GIR_RootConstrainSelectedInstOperands,
     /*  558984 */     // GIR_Coverage, 3297,
     /*  558984 */     GIR_EraseRootFromParent_Done,
     /*  558985 */   // Label 9198: @558985
     /*  558985 */   GIM_Try, /*On fail goto*//*Label 9199*/ GIMT_Encode4(559060), // Rule ID 3300 //
     /*  558990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  559001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  559004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  559007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  559010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559036 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559058 */     GIR_RootConstrainSelectedInstOperands,
     /*  559059 */     // GIR_Coverage, 3300,
     /*  559059 */     GIR_EraseRootFromParent_Done,
     /*  559060 */   // Label 9199: @559060
     /*  559060 */   GIM_Try, /*On fail goto*//*Label 9200*/ GIMT_Encode4(559135), // Rule ID 3301 //
     /*  559065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  559076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  559079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  559082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  559085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559111 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559133 */     GIR_RootConstrainSelectedInstOperands,
     /*  559134 */     // GIR_Coverage, 3301,
     /*  559134 */     GIR_EraseRootFromParent_Done,
     /*  559135 */   // Label 9200: @559135
     /*  559135 */   GIM_Try, /*On fail goto*//*Label 9201*/ GIMT_Encode4(559210), // Rule ID 3304 //
     /*  559140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  559160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559186 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559208 */     GIR_RootConstrainSelectedInstOperands,
     /*  559209 */     // GIR_Coverage, 3304,
     /*  559209 */     GIR_EraseRootFromParent_Done,
     /*  559210 */   // Label 9201: @559210
     /*  559210 */   GIM_Try, /*On fail goto*//*Label 9202*/ GIMT_Encode4(559285), // Rule ID 3305 //
     /*  559215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  559235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559261 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559283 */     GIR_RootConstrainSelectedInstOperands,
     /*  559284 */     // GIR_Coverage, 3305,
     /*  559284 */     GIR_EraseRootFromParent_Done,
     /*  559285 */   // Label 9202: @559285
     /*  559285 */   GIM_Try, /*On fail goto*//*Label 9203*/ GIMT_Encode4(559360), // Rule ID 3308 //
     /*  559290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  559310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559336 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559358 */     GIR_RootConstrainSelectedInstOperands,
     /*  559359 */     // GIR_Coverage, 3308,
     /*  559359 */     GIR_EraseRootFromParent_Done,
     /*  559360 */   // Label 9203: @559360
     /*  559360 */   GIM_Try, /*On fail goto*//*Label 9204*/ GIMT_Encode4(559435), // Rule ID 3309 //
     /*  559365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  559385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559411 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559433 */     GIR_RootConstrainSelectedInstOperands,
     /*  559434 */     // GIR_Coverage, 3309,
     /*  559434 */     GIR_EraseRootFromParent_Done,
     /*  559435 */   // Label 9204: @559435
     /*  559435 */   GIM_Try, /*On fail goto*//*Label 9205*/ GIMT_Encode4(559510), // Rule ID 3312 //
     /*  559440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  559451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  559454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  559457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  559460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559508 */     GIR_RootConstrainSelectedInstOperands,
     /*  559509 */     // GIR_Coverage, 3312,
     /*  559509 */     GIR_EraseRootFromParent_Done,
     /*  559510 */   // Label 9205: @559510
     /*  559510 */   GIM_Try, /*On fail goto*//*Label 9206*/ GIMT_Encode4(559585), // Rule ID 3313 //
     /*  559515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  559526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  559529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  559532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  559535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559561 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559583 */     GIR_RootConstrainSelectedInstOperands,
     /*  559584 */     // GIR_Coverage, 3313,
     /*  559584 */     GIR_EraseRootFromParent_Done,
     /*  559585 */   // Label 9206: @559585
     /*  559585 */   GIM_Try, /*On fail goto*//*Label 9207*/ GIMT_Encode4(559660), // Rule ID 3316 //
     /*  559590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  559593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  559601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  559604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  559607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  559610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  559636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559658 */     GIR_RootConstrainSelectedInstOperands,
     /*  559659 */     // GIR_Coverage, 3316,
     /*  559659 */     GIR_EraseRootFromParent_Done,
     /*  559660 */   // Label 9207: @559660
     /*  559660 */   GIM_Try, /*On fail goto*//*Label 9208*/ GIMT_Encode4(559735), // Rule ID 3317 //
     /*  559665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  559668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  559676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  559679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  559682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  559685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559711 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  559711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559733 */     GIR_RootConstrainSelectedInstOperands,
     /*  559734 */     // GIR_Coverage, 3317,
     /*  559734 */     GIR_EraseRootFromParent_Done,
     /*  559735 */   // Label 9208: @559735
     /*  559735 */   GIM_Try, /*On fail goto*//*Label 9209*/ GIMT_Encode4(559810), // Rule ID 3320 //
     /*  559740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  559743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  559751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  559754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  559757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  559760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559786 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  559786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559808 */     GIR_RootConstrainSelectedInstOperands,
     /*  559809 */     // GIR_Coverage, 3320,
     /*  559809 */     GIR_EraseRootFromParent_Done,
     /*  559810 */   // Label 9209: @559810
     /*  559810 */   GIM_Try, /*On fail goto*//*Label 9210*/ GIMT_Encode4(559885), // Rule ID 3321 //
     /*  559815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  559818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  559826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  559829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  559832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  559835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559861 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  559861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559883 */     GIR_RootConstrainSelectedInstOperands,
     /*  559884 */     // GIR_Coverage, 3321,
     /*  559884 */     GIR_EraseRootFromParent_Done,
     /*  559885 */   // Label 9210: @559885
     /*  559885 */   GIM_Try, /*On fail goto*//*Label 9211*/ GIMT_Encode4(559960), // Rule ID 3324 //
     /*  559890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  559893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  559901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  559904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  559907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  559910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559936 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  559936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559958 */     GIR_RootConstrainSelectedInstOperands,
     /*  559959 */     // GIR_Coverage, 3324,
     /*  559959 */     GIR_EraseRootFromParent_Done,
     /*  559960 */   // Label 9211: @559960
     /*  559960 */   GIM_Try, /*On fail goto*//*Label 9212*/ GIMT_Encode4(560035), // Rule ID 3325 //
     /*  559965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  559968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  559976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  559979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  559982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  559985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560011 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  560014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560033 */     GIR_RootConstrainSelectedInstOperands,
     /*  560034 */     // GIR_Coverage, 3325,
     /*  560034 */     GIR_EraseRootFromParent_Done,
     /*  560035 */   // Label 9212: @560035
     /*  560035 */   GIM_Try, /*On fail goto*//*Label 9213*/ GIMT_Encode4(560110), // Rule ID 3328 //
     /*  560040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  560057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560086 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  560089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560108 */     GIR_RootConstrainSelectedInstOperands,
     /*  560109 */     // GIR_Coverage, 3328,
     /*  560109 */     GIR_EraseRootFromParent_Done,
     /*  560110 */   // Label 9213: @560110
     /*  560110 */   GIM_Try, /*On fail goto*//*Label 9214*/ GIMT_Encode4(560185), // Rule ID 3329 //
     /*  560115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  560132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560161 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  560164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560183 */     GIR_RootConstrainSelectedInstOperands,
     /*  560184 */     // GIR_Coverage, 3329,
     /*  560184 */     GIR_EraseRootFromParent_Done,
     /*  560185 */   // Label 9214: @560185
     /*  560185 */   GIM_Try, /*On fail goto*//*Label 9215*/ GIMT_Encode4(560260), // Rule ID 3332 //
     /*  560190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  560207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560236 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560258 */     GIR_RootConstrainSelectedInstOperands,
     /*  560259 */     // GIR_Coverage, 3332,
     /*  560259 */     GIR_EraseRootFromParent_Done,
     /*  560260 */   // Label 9215: @560260
     /*  560260 */   GIM_Try, /*On fail goto*//*Label 9216*/ GIMT_Encode4(560335), // Rule ID 3333 //
     /*  560265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  560282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560311 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560333 */     GIR_RootConstrainSelectedInstOperands,
     /*  560334 */     // GIR_Coverage, 3333,
     /*  560334 */     GIR_EraseRootFromParent_Done,
     /*  560335 */   // Label 9216: @560335
     /*  560335 */   GIM_Try, /*On fail goto*//*Label 9217*/ GIMT_Encode4(560410), // Rule ID 3336 //
     /*  560340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  560357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560386 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560408 */     GIR_RootConstrainSelectedInstOperands,
     /*  560409 */     // GIR_Coverage, 3336,
     /*  560409 */     GIR_EraseRootFromParent_Done,
     /*  560410 */   // Label 9217: @560410
     /*  560410 */   GIM_Try, /*On fail goto*//*Label 9218*/ GIMT_Encode4(560485), // Rule ID 3337 //
     /*  560415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  560432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560461 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560483 */     GIR_RootConstrainSelectedInstOperands,
     /*  560484 */     // GIR_Coverage, 3337,
     /*  560484 */     GIR_EraseRootFromParent_Done,
     /*  560485 */   // Label 9218: @560485
     /*  560485 */   GIM_Try, /*On fail goto*//*Label 9219*/ GIMT_Encode4(560560), // Rule ID 3340 //
     /*  560490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  560501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  560504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  560507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560536 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  560536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560558 */     GIR_RootConstrainSelectedInstOperands,
     /*  560559 */     // GIR_Coverage, 3340,
     /*  560559 */     GIR_EraseRootFromParent_Done,
     /*  560560 */   // Label 9219: @560560
     /*  560560 */   GIM_Try, /*On fail goto*//*Label 9220*/ GIMT_Encode4(560635), // Rule ID 3341 //
     /*  560565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  560576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  560579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  560582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560611 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  560611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560633 */     GIR_RootConstrainSelectedInstOperands,
     /*  560634 */     // GIR_Coverage, 3341,
     /*  560634 */     GIR_EraseRootFromParent_Done,
     /*  560635 */   // Label 9220: @560635
     /*  560635 */   GIM_Try, /*On fail goto*//*Label 9221*/ GIMT_Encode4(560710), // Rule ID 3344 //
     /*  560640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  560651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  560654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  560657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560686 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  560686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560708 */     GIR_RootConstrainSelectedInstOperands,
     /*  560709 */     // GIR_Coverage, 3344,
     /*  560709 */     GIR_EraseRootFromParent_Done,
     /*  560710 */   // Label 9221: @560710
     /*  560710 */   GIM_Try, /*On fail goto*//*Label 9222*/ GIMT_Encode4(560785), // Rule ID 3345 //
     /*  560715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  560726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  560729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  560732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560761 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  560761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560783 */     GIR_RootConstrainSelectedInstOperands,
     /*  560784 */     // GIR_Coverage, 3345,
     /*  560784 */     GIR_EraseRootFromParent_Done,
     /*  560785 */   // Label 9222: @560785
     /*  560785 */   GIM_Try, /*On fail goto*//*Label 9223*/ GIMT_Encode4(560860), // Rule ID 3348 //
     /*  560790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  560801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  560804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  560807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560836 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  560836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560858 */     GIR_RootConstrainSelectedInstOperands,
     /*  560859 */     // GIR_Coverage, 3348,
     /*  560859 */     GIR_EraseRootFromParent_Done,
     /*  560860 */   // Label 9223: @560860
     /*  560860 */   GIM_Try, /*On fail goto*//*Label 9224*/ GIMT_Encode4(560935), // Rule ID 3349 //
     /*  560865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  560876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  560879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  560882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560911 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  560911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560933 */     GIR_RootConstrainSelectedInstOperands,
     /*  560934 */     // GIR_Coverage, 3349,
     /*  560934 */     GIR_EraseRootFromParent_Done,
     /*  560935 */   // Label 9224: @560935
     /*  560935 */   GIM_Try, /*On fail goto*//*Label 9225*/ GIMT_Encode4(561010), // Rule ID 3352 //
     /*  560940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  560951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  560954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  560957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560986 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  560989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561008 */     GIR_RootConstrainSelectedInstOperands,
     /*  561009 */     // GIR_Coverage, 3352,
     /*  561009 */     GIR_EraseRootFromParent_Done,
     /*  561010 */   // Label 9225: @561010
     /*  561010 */   GIM_Try, /*On fail goto*//*Label 9226*/ GIMT_Encode4(561085), // Rule ID 3353 //
     /*  561015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  561026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  561029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  561032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561061 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561083 */     GIR_RootConstrainSelectedInstOperands,
     /*  561084 */     // GIR_Coverage, 3353,
     /*  561084 */     GIR_EraseRootFromParent_Done,
     /*  561085 */   // Label 9226: @561085
     /*  561085 */   GIM_Try, /*On fail goto*//*Label 9227*/ GIMT_Encode4(561160), // Rule ID 3356 //
     /*  561090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  561107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561136 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561158 */     GIR_RootConstrainSelectedInstOperands,
     /*  561159 */     // GIR_Coverage, 3356,
     /*  561159 */     GIR_EraseRootFromParent_Done,
     /*  561160 */   // Label 9227: @561160
     /*  561160 */   GIM_Try, /*On fail goto*//*Label 9228*/ GIMT_Encode4(561235), // Rule ID 3357 //
     /*  561165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  561182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561211 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561233 */     GIR_RootConstrainSelectedInstOperands,
     /*  561234 */     // GIR_Coverage, 3357,
     /*  561234 */     GIR_EraseRootFromParent_Done,
     /*  561235 */   // Label 9228: @561235
     /*  561235 */   GIM_Try, /*On fail goto*//*Label 9229*/ GIMT_Encode4(561310), // Rule ID 3360 //
     /*  561240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  561251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  561254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  561286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561308 */     GIR_RootConstrainSelectedInstOperands,
     /*  561309 */     // GIR_Coverage, 3360,
     /*  561309 */     GIR_EraseRootFromParent_Done,
     /*  561310 */   // Label 9229: @561310
     /*  561310 */   GIM_Try, /*On fail goto*//*Label 9230*/ GIMT_Encode4(561385), // Rule ID 3361 //
     /*  561315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  561326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  561329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561361 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  561361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561383 */     GIR_RootConstrainSelectedInstOperands,
     /*  561384 */     // GIR_Coverage, 3361,
     /*  561384 */     GIR_EraseRootFromParent_Done,
     /*  561385 */   // Label 9230: @561385
     /*  561385 */   GIM_Try, /*On fail goto*//*Label 9231*/ GIMT_Encode4(561460), // Rule ID 3364 //
     /*  561390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  561393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  561401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  561404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  561407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561436 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  561436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  561455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561458 */     GIR_RootConstrainSelectedInstOperands,
     /*  561459 */     // GIR_Coverage, 3364,
     /*  561459 */     GIR_EraseRootFromParent_Done,
     /*  561460 */   // Label 9231: @561460
     /*  561460 */   GIM_Try, /*On fail goto*//*Label 9232*/ GIMT_Encode4(561535), // Rule ID 3365 //
     /*  561465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  561468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  561476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  561479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  561482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561511 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  561511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  561530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561533 */     GIR_RootConstrainSelectedInstOperands,
     /*  561534 */     // GIR_Coverage, 3365,
     /*  561534 */     GIR_EraseRootFromParent_Done,
     /*  561535 */   // Label 9232: @561535
     /*  561535 */   GIM_Try, /*On fail goto*//*Label 9233*/ GIMT_Encode4(561610), // Rule ID 3368 //
     /*  561540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  561551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  561554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  561557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561586 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  561589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561608 */     GIR_RootConstrainSelectedInstOperands,
     /*  561609 */     // GIR_Coverage, 3368,
     /*  561609 */     GIR_EraseRootFromParent_Done,
     /*  561610 */   // Label 9233: @561610
     /*  561610 */   GIM_Try, /*On fail goto*//*Label 9234*/ GIMT_Encode4(561685), // Rule ID 3369 //
     /*  561615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  561626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  561629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  561632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561661 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  561664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561683 */     GIR_RootConstrainSelectedInstOperands,
     /*  561684 */     // GIR_Coverage, 3369,
     /*  561684 */     GIR_EraseRootFromParent_Done,
     /*  561685 */   // Label 9234: @561685
     /*  561685 */   GIM_Try, /*On fail goto*//*Label 9235*/ GIMT_Encode4(561760), // Rule ID 3372 //
     /*  561690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  561701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  561704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  561707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561736 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  561739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561758 */     GIR_RootConstrainSelectedInstOperands,
     /*  561759 */     // GIR_Coverage, 3372,
     /*  561759 */     GIR_EraseRootFromParent_Done,
     /*  561760 */   // Label 9235: @561760
     /*  561760 */   GIM_Try, /*On fail goto*//*Label 9236*/ GIMT_Encode4(561835), // Rule ID 3373 //
     /*  561765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  561776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  561779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  561782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561811 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  561814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561833 */     GIR_RootConstrainSelectedInstOperands,
     /*  561834 */     // GIR_Coverage, 3373,
     /*  561834 */     GIR_EraseRootFromParent_Done,
     /*  561835 */   // Label 9236: @561835
     /*  561835 */   GIM_Try, /*On fail goto*//*Label 9237*/ GIMT_Encode4(561910), // Rule ID 3376 //
     /*  561840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  561851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  561854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  561857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561886 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  561889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561908 */     GIR_RootConstrainSelectedInstOperands,
     /*  561909 */     // GIR_Coverage, 3376,
     /*  561909 */     GIR_EraseRootFromParent_Done,
     /*  561910 */   // Label 9237: @561910
     /*  561910 */   GIM_Try, /*On fail goto*//*Label 9238*/ GIMT_Encode4(561985), // Rule ID 3377 //
     /*  561915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  561926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  561929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  561932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561961 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  561964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561983 */     GIR_RootConstrainSelectedInstOperands,
     /*  561984 */     // GIR_Coverage, 3377,
     /*  561984 */     GIR_EraseRootFromParent_Done,
     /*  561985 */   // Label 9238: @561985
     /*  561985 */   GIM_Try, /*On fail goto*//*Label 9239*/ GIMT_Encode4(562060), // Rule ID 3380 //
     /*  561990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  562001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  562004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  562007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562036 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562058 */     GIR_RootConstrainSelectedInstOperands,
     /*  562059 */     // GIR_Coverage, 3380,
     /*  562059 */     GIR_EraseRootFromParent_Done,
     /*  562060 */   // Label 9239: @562060
     /*  562060 */   GIM_Try, /*On fail goto*//*Label 9240*/ GIMT_Encode4(562135), // Rule ID 3381 //
     /*  562065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  562076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  562079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  562082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562111 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562133 */     GIR_RootConstrainSelectedInstOperands,
     /*  562134 */     // GIR_Coverage, 3381,
     /*  562134 */     GIR_EraseRootFromParent_Done,
     /*  562135 */   // Label 9240: @562135
     /*  562135 */   GIM_Try, /*On fail goto*//*Label 9241*/ GIMT_Encode4(562210), // Rule ID 3384 //
     /*  562140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  562151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  562154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  562157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562186 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562208 */     GIR_RootConstrainSelectedInstOperands,
     /*  562209 */     // GIR_Coverage, 3384,
     /*  562209 */     GIR_EraseRootFromParent_Done,
     /*  562210 */   // Label 9241: @562210
     /*  562210 */   GIM_Try, /*On fail goto*//*Label 9242*/ GIMT_Encode4(562285), // Rule ID 3385 //
     /*  562215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  562226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  562229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  562232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562261 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562283 */     GIR_RootConstrainSelectedInstOperands,
     /*  562284 */     // GIR_Coverage, 3385,
     /*  562284 */     GIR_EraseRootFromParent_Done,
     /*  562285 */   // Label 9242: @562285
     /*  562285 */   GIM_Try, /*On fail goto*//*Label 9243*/ GIMT_Encode4(562360), // Rule ID 3388 //
     /*  562290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  562301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  562304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  562307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562336 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562358 */     GIR_RootConstrainSelectedInstOperands,
     /*  562359 */     // GIR_Coverage, 3388,
     /*  562359 */     GIR_EraseRootFromParent_Done,
     /*  562360 */   // Label 9243: @562360
     /*  562360 */   GIM_Try, /*On fail goto*//*Label 9244*/ GIMT_Encode4(562435), // Rule ID 3389 //
     /*  562365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  562376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  562379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  562382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562411 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562433 */     GIR_RootConstrainSelectedInstOperands,
     /*  562434 */     // GIR_Coverage, 3389,
     /*  562434 */     GIR_EraseRootFromParent_Done,
     /*  562435 */   // Label 9244: @562435
     /*  562435 */   GIM_Try, /*On fail goto*//*Label 9245*/ GIMT_Encode4(562510), // Rule ID 3392 //
     /*  562440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  562451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  562454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  562457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  562486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562508 */     GIR_RootConstrainSelectedInstOperands,
     /*  562509 */     // GIR_Coverage, 3392,
     /*  562509 */     GIR_EraseRootFromParent_Done,
     /*  562510 */   // Label 9245: @562510
     /*  562510 */   GIM_Try, /*On fail goto*//*Label 9246*/ GIMT_Encode4(562585), // Rule ID 3393 //
     /*  562515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  562526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  562529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  562532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562561 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  562561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562583 */     GIR_RootConstrainSelectedInstOperands,
     /*  562584 */     // GIR_Coverage, 3393,
     /*  562584 */     GIR_EraseRootFromParent_Done,
     /*  562585 */   // Label 9246: @562585
     /*  562585 */   GIM_Try, /*On fail goto*//*Label 9247*/ GIMT_Encode4(562660), // Rule ID 3396 //
     /*  562590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  562601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  562604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  562607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562636 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  562636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562658 */     GIR_RootConstrainSelectedInstOperands,
     /*  562659 */     // GIR_Coverage, 3396,
     /*  562659 */     GIR_EraseRootFromParent_Done,
     /*  562660 */   // Label 9247: @562660
     /*  562660 */   GIM_Try, /*On fail goto*//*Label 9248*/ GIMT_Encode4(562735), // Rule ID 3397 //
     /*  562665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  562676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  562679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  562682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562711 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  562711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562733 */     GIR_RootConstrainSelectedInstOperands,
     /*  562734 */     // GIR_Coverage, 3397,
     /*  562734 */     GIR_EraseRootFromParent_Done,
     /*  562735 */   // Label 9248: @562735
     /*  562735 */   GIM_Try, /*On fail goto*//*Label 9249*/ GIMT_Encode4(562810), // Rule ID 3400 //
     /*  562740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  562751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  562754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  562757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562786 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  562786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562808 */     GIR_RootConstrainSelectedInstOperands,
     /*  562809 */     // GIR_Coverage, 3400,
     /*  562809 */     GIR_EraseRootFromParent_Done,
     /*  562810 */   // Label 9249: @562810
     /*  562810 */   GIM_Try, /*On fail goto*//*Label 9250*/ GIMT_Encode4(562885), // Rule ID 3401 //
     /*  562815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  562826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  562829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  562832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562861 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  562861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562883 */     GIR_RootConstrainSelectedInstOperands,
     /*  562884 */     // GIR_Coverage, 3401,
     /*  562884 */     GIR_EraseRootFromParent_Done,
     /*  562885 */   // Label 9250: @562885
     /*  562885 */   GIM_Try, /*On fail goto*//*Label 9251*/ GIMT_Encode4(562960), // Rule ID 3404 //
     /*  562890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  562893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  562901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  562904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  562907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562936 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  562936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  562955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562958 */     GIR_RootConstrainSelectedInstOperands,
     /*  562959 */     // GIR_Coverage, 3404,
     /*  562959 */     GIR_EraseRootFromParent_Done,
     /*  562960 */   // Label 9251: @562960
     /*  562960 */   GIM_Try, /*On fail goto*//*Label 9252*/ GIMT_Encode4(563035), // Rule ID 3405 //
     /*  562965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  562968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  562976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  562979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  562982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563011 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  563014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563033 */     GIR_RootConstrainSelectedInstOperands,
     /*  563034 */     // GIR_Coverage, 3405,
     /*  563034 */     GIR_EraseRootFromParent_Done,
     /*  563035 */   // Label 9252: @563035
     /*  563035 */   GIM_Try, /*On fail goto*//*Label 9253*/ GIMT_Encode4(563110), // Rule ID 3408 //
     /*  563040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  563051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  563054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  563057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563086 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  563089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563108 */     GIR_RootConstrainSelectedInstOperands,
     /*  563109 */     // GIR_Coverage, 3408,
     /*  563109 */     GIR_EraseRootFromParent_Done,
     /*  563110 */   // Label 9253: @563110
     /*  563110 */   GIM_Try, /*On fail goto*//*Label 9254*/ GIMT_Encode4(563185), // Rule ID 3409 //
     /*  563115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  563126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  563129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  563132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563161 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  563164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563183 */     GIR_RootConstrainSelectedInstOperands,
     /*  563184 */     // GIR_Coverage, 3409,
     /*  563184 */     GIR_EraseRootFromParent_Done,
     /*  563185 */   // Label 9254: @563185
     /*  563185 */   GIM_Try, /*On fail goto*//*Label 9255*/ GIMT_Encode4(563260), // Rule ID 3412 //
     /*  563190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  563201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  563204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  563207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563236 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  563239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563258 */     GIR_RootConstrainSelectedInstOperands,
     /*  563259 */     // GIR_Coverage, 3412,
     /*  563259 */     GIR_EraseRootFromParent_Done,
     /*  563260 */   // Label 9255: @563260
     /*  563260 */   GIM_Try, /*On fail goto*//*Label 9256*/ GIMT_Encode4(563335), // Rule ID 3413 //
     /*  563265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  563276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  563279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  563282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563311 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  563314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563333 */     GIR_RootConstrainSelectedInstOperands,
     /*  563334 */     // GIR_Coverage, 3413,
     /*  563334 */     GIR_EraseRootFromParent_Done,
     /*  563335 */   // Label 9256: @563335
     /*  563335 */   GIM_Try, /*On fail goto*//*Label 9257*/ GIMT_Encode4(563410), // Rule ID 3416 //
     /*  563340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  563351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  563354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  563357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563386 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  563389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563408 */     GIR_RootConstrainSelectedInstOperands,
     /*  563409 */     // GIR_Coverage, 3416,
     /*  563409 */     GIR_EraseRootFromParent_Done,
     /*  563410 */   // Label 9257: @563410
     /*  563410 */   GIM_Try, /*On fail goto*//*Label 9258*/ GIMT_Encode4(563485), // Rule ID 3417 //
     /*  563415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  563426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  563429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  563432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563461 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  563464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563483 */     GIR_RootConstrainSelectedInstOperands,
     /*  563484 */     // GIR_Coverage, 3417,
     /*  563484 */     GIR_EraseRootFromParent_Done,
     /*  563485 */   // Label 9258: @563485
     /*  563485 */   GIM_Try, /*On fail goto*//*Label 9259*/ GIMT_Encode4(563560), // Rule ID 3420 //
     /*  563490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  563501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  563504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  563507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563536 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  563539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563558 */     GIR_RootConstrainSelectedInstOperands,
     /*  563559 */     // GIR_Coverage, 3420,
     /*  563559 */     GIR_EraseRootFromParent_Done,
     /*  563560 */   // Label 9259: @563560
     /*  563560 */   GIM_Try, /*On fail goto*//*Label 9260*/ GIMT_Encode4(563635), // Rule ID 3421 //
     /*  563565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  563576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  563579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  563582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563611 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  563614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563633 */     GIR_RootConstrainSelectedInstOperands,
     /*  563634 */     // GIR_Coverage, 3421,
     /*  563634 */     GIR_EraseRootFromParent_Done,
     /*  563635 */   // Label 9260: @563635
     /*  563635 */   GIM_Try, /*On fail goto*//*Label 9261*/ GIMT_Encode4(563710), // Rule ID 3424 //
     /*  563640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  563651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  563654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  563657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563686 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  563689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563708 */     GIR_RootConstrainSelectedInstOperands,
     /*  563709 */     // GIR_Coverage, 3424,
     /*  563709 */     GIR_EraseRootFromParent_Done,
     /*  563710 */   // Label 9261: @563710
     /*  563710 */   GIM_Try, /*On fail goto*//*Label 9262*/ GIMT_Encode4(563785), // Rule ID 3425 //
     /*  563715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  563726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  563729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  563732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563761 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  563764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563783 */     GIR_RootConstrainSelectedInstOperands,
     /*  563784 */     // GIR_Coverage, 3425,
     /*  563784 */     GIR_EraseRootFromParent_Done,
     /*  563785 */   // Label 9262: @563785
     /*  563785 */   GIM_Try, /*On fail goto*//*Label 9263*/ GIMT_Encode4(563860), // Rule ID 3428 //
     /*  563790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  563801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  563804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  563807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563836 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  563836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  563839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563858 */     GIR_RootConstrainSelectedInstOperands,
     /*  563859 */     // GIR_Coverage, 3428,
     /*  563859 */     GIR_EraseRootFromParent_Done,
     /*  563860 */   // Label 9263: @563860
     /*  563860 */   GIM_Try, /*On fail goto*//*Label 9264*/ GIMT_Encode4(563935), // Rule ID 3429 //
     /*  563865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  563876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  563879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  563882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563911 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  563911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  563914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563933 */     GIR_RootConstrainSelectedInstOperands,
     /*  563934 */     // GIR_Coverage, 3429,
     /*  563934 */     GIR_EraseRootFromParent_Done,
     /*  563935 */   // Label 9264: @563935
     /*  563935 */   GIM_Try, /*On fail goto*//*Label 9265*/ GIMT_Encode4(564010), // Rule ID 3432 //
     /*  563940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  563951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  563954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  563957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563986 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  563986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  563989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564008 */     GIR_RootConstrainSelectedInstOperands,
     /*  564009 */     // GIR_Coverage, 3432,
     /*  564009 */     GIR_EraseRootFromParent_Done,
     /*  564010 */   // Label 9265: @564010
     /*  564010 */   GIM_Try, /*On fail goto*//*Label 9266*/ GIMT_Encode4(564085), // Rule ID 3433 //
     /*  564015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  564026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  564029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  564032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564061 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564083 */     GIR_RootConstrainSelectedInstOperands,
     /*  564084 */     // GIR_Coverage, 3433,
     /*  564084 */     GIR_EraseRootFromParent_Done,
     /*  564085 */   // Label 9266: @564085
     /*  564085 */   GIM_Try, /*On fail goto*//*Label 9267*/ GIMT_Encode4(564160), // Rule ID 3436 //
     /*  564090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  564107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564136 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  564136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564158 */     GIR_RootConstrainSelectedInstOperands,
     /*  564159 */     // GIR_Coverage, 3436,
     /*  564159 */     GIR_EraseRootFromParent_Done,
     /*  564160 */   // Label 9267: @564160
     /*  564160 */   GIM_Try, /*On fail goto*//*Label 9268*/ GIMT_Encode4(564235), // Rule ID 3437 //
     /*  564165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  564182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564211 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  564211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564233 */     GIR_RootConstrainSelectedInstOperands,
     /*  564234 */     // GIR_Coverage, 3437,
     /*  564234 */     GIR_EraseRootFromParent_Done,
     /*  564235 */   // Label 9268: @564235
     /*  564235 */   GIM_Try, /*On fail goto*//*Label 9269*/ GIMT_Encode4(564310), // Rule ID 3440 //
     /*  564240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  564251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  564254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  564257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564286 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564308 */     GIR_RootConstrainSelectedInstOperands,
     /*  564309 */     // GIR_Coverage, 3440,
     /*  564309 */     GIR_EraseRootFromParent_Done,
     /*  564310 */   // Label 9269: @564310
     /*  564310 */   GIM_Try, /*On fail goto*//*Label 9270*/ GIMT_Encode4(564385), // Rule ID 3441 //
     /*  564315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  564326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  564329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  564332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564361 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564383 */     GIR_RootConstrainSelectedInstOperands,
     /*  564384 */     // GIR_Coverage, 3441,
     /*  564384 */     GIR_EraseRootFromParent_Done,
     /*  564385 */   // Label 9270: @564385
     /*  564385 */   GIM_Try, /*On fail goto*//*Label 9271*/ GIMT_Encode4(564460), // Rule ID 3444 //
     /*  564390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  564401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  564404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  564407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564436 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564458 */     GIR_RootConstrainSelectedInstOperands,
     /*  564459 */     // GIR_Coverage, 3444,
     /*  564459 */     GIR_EraseRootFromParent_Done,
     /*  564460 */   // Label 9271: @564460
     /*  564460 */   GIM_Try, /*On fail goto*//*Label 9272*/ GIMT_Encode4(564535), // Rule ID 3445 //
     /*  564465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  564476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  564479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  564482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564511 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564533 */     GIR_RootConstrainSelectedInstOperands,
     /*  564534 */     // GIR_Coverage, 3445,
     /*  564534 */     GIR_EraseRootFromParent_Done,
     /*  564535 */   // Label 9272: @564535
     /*  564535 */   GIM_Try, /*On fail goto*//*Label 9273*/ GIMT_Encode4(564610), // Rule ID 3448 //
     /*  564540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  564551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  564554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  564557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564586 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  564586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564608 */     GIR_RootConstrainSelectedInstOperands,
     /*  564609 */     // GIR_Coverage, 3448,
     /*  564609 */     GIR_EraseRootFromParent_Done,
     /*  564610 */   // Label 9273: @564610
     /*  564610 */   GIM_Try, /*On fail goto*//*Label 9274*/ GIMT_Encode4(564685), // Rule ID 3449 //
     /*  564615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  564626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  564629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  564632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564661 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  564661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564683 */     GIR_RootConstrainSelectedInstOperands,
     /*  564684 */     // GIR_Coverage, 3449,
     /*  564684 */     GIR_EraseRootFromParent_Done,
     /*  564685 */   // Label 9274: @564685
     /*  564685 */   GIM_Try, /*On fail goto*//*Label 9275*/ GIMT_Encode4(564760), // Rule ID 3452 //
     /*  564690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  564693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  564701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  564704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  564707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564736 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  564736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  564755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564758 */     GIR_RootConstrainSelectedInstOperands,
     /*  564759 */     // GIR_Coverage, 3452,
     /*  564759 */     GIR_EraseRootFromParent_Done,
     /*  564760 */   // Label 9275: @564760
     /*  564760 */   GIM_Try, /*On fail goto*//*Label 9276*/ GIMT_Encode4(564835), // Rule ID 3453 //
     /*  564765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  564768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  564776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  564779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  564782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564811 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  564811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  564830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564833 */     GIR_RootConstrainSelectedInstOperands,
     /*  564834 */     // GIR_Coverage, 3453,
     /*  564834 */     GIR_EraseRootFromParent_Done,
     /*  564835 */   // Label 9276: @564835
     /*  564835 */   GIM_Try, /*On fail goto*//*Label 9277*/ GIMT_Encode4(564910), // Rule ID 3456 //
     /*  564840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  564851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  564854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  564857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564886 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  564889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564908 */     GIR_RootConstrainSelectedInstOperands,
     /*  564909 */     // GIR_Coverage, 3456,
     /*  564909 */     GIR_EraseRootFromParent_Done,
     /*  564910 */   // Label 9277: @564910
     /*  564910 */   GIM_Try, /*On fail goto*//*Label 9278*/ GIMT_Encode4(564985), // Rule ID 3457 //
     /*  564915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  564926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  564929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  564932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564961 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  564964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564983 */     GIR_RootConstrainSelectedInstOperands,
     /*  564984 */     // GIR_Coverage, 3457,
     /*  564984 */     GIR_EraseRootFromParent_Done,
     /*  564985 */   // Label 9278: @564985
     /*  564985 */   GIM_Try, /*On fail goto*//*Label 9279*/ GIMT_Encode4(565060), // Rule ID 3460 //
     /*  564990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  565001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  565004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  565007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565036 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565058 */     GIR_RootConstrainSelectedInstOperands,
     /*  565059 */     // GIR_Coverage, 3460,
     /*  565059 */     GIR_EraseRootFromParent_Done,
     /*  565060 */   // Label 9279: @565060
     /*  565060 */   GIM_Try, /*On fail goto*//*Label 9280*/ GIMT_Encode4(565135), // Rule ID 3461 //
     /*  565065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  565076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  565079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  565082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565111 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565133 */     GIR_RootConstrainSelectedInstOperands,
     /*  565134 */     // GIR_Coverage, 3461,
     /*  565134 */     GIR_EraseRootFromParent_Done,
     /*  565135 */   // Label 9280: @565135
     /*  565135 */   GIM_Try, /*On fail goto*//*Label 9281*/ GIMT_Encode4(565210), // Rule ID 3464 //
     /*  565140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  565151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  565154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  565157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565186 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565208 */     GIR_RootConstrainSelectedInstOperands,
     /*  565209 */     // GIR_Coverage, 3464,
     /*  565209 */     GIR_EraseRootFromParent_Done,
     /*  565210 */   // Label 9281: @565210
     /*  565210 */   GIM_Try, /*On fail goto*//*Label 9282*/ GIMT_Encode4(565285), // Rule ID 3465 //
     /*  565215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  565226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  565229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  565232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565261 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565283 */     GIR_RootConstrainSelectedInstOperands,
     /*  565284 */     // GIR_Coverage, 3465,
     /*  565284 */     GIR_EraseRootFromParent_Done,
     /*  565285 */   // Label 9282: @565285
     /*  565285 */   GIM_Try, /*On fail goto*//*Label 9283*/ GIMT_Encode4(565360), // Rule ID 3468 //
     /*  565290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  565301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  565304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565336 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565358 */     GIR_RootConstrainSelectedInstOperands,
     /*  565359 */     // GIR_Coverage, 3468,
     /*  565359 */     GIR_EraseRootFromParent_Done,
     /*  565360 */   // Label 9283: @565360
     /*  565360 */   GIM_Try, /*On fail goto*//*Label 9284*/ GIMT_Encode4(565435), // Rule ID 3469 //
     /*  565365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  565376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  565379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565411 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565433 */     GIR_RootConstrainSelectedInstOperands,
     /*  565434 */     // GIR_Coverage, 3469,
     /*  565434 */     GIR_EraseRootFromParent_Done,
     /*  565435 */   // Label 9284: @565435
     /*  565435 */   GIM_Try, /*On fail goto*//*Label 9285*/ GIMT_Encode4(565510), // Rule ID 3472 //
     /*  565440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  565451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  565454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  565457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565486 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565508 */     GIR_RootConstrainSelectedInstOperands,
     /*  565509 */     // GIR_Coverage, 3472,
     /*  565509 */     GIR_EraseRootFromParent_Done,
     /*  565510 */   // Label 9285: @565510
     /*  565510 */   GIM_Try, /*On fail goto*//*Label 9286*/ GIMT_Encode4(565585), // Rule ID 3473 //
     /*  565515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  565526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  565529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  565532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565561 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565583 */     GIR_RootConstrainSelectedInstOperands,
     /*  565584 */     // GIR_Coverage, 3473,
     /*  565584 */     GIR_EraseRootFromParent_Done,
     /*  565585 */   // Label 9286: @565585
     /*  565585 */   GIM_Try, /*On fail goto*//*Label 9287*/ GIMT_Encode4(565660), // Rule ID 3476 //
     /*  565590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  565601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  565604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  565607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565636 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565658 */     GIR_RootConstrainSelectedInstOperands,
     /*  565659 */     // GIR_Coverage, 3476,
     /*  565659 */     GIR_EraseRootFromParent_Done,
     /*  565660 */   // Label 9287: @565660
     /*  565660 */   GIM_Try, /*On fail goto*//*Label 9288*/ GIMT_Encode4(565735), // Rule ID 3477 //
     /*  565665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  565676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  565679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  565682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565711 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565733 */     GIR_RootConstrainSelectedInstOperands,
     /*  565734 */     // GIR_Coverage, 3477,
     /*  565734 */     GIR_EraseRootFromParent_Done,
     /*  565735 */   // Label 9288: @565735
     /*  565735 */   GIM_Try, /*On fail goto*//*Label 9289*/ GIMT_Encode4(565810), // Rule ID 3480 //
     /*  565740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  565751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  565754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  565757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565786 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  565786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565808 */     GIR_RootConstrainSelectedInstOperands,
     /*  565809 */     // GIR_Coverage, 3480,
     /*  565809 */     GIR_EraseRootFromParent_Done,
     /*  565810 */   // Label 9289: @565810
     /*  565810 */   GIM_Try, /*On fail goto*//*Label 9290*/ GIMT_Encode4(565885), // Rule ID 3481 //
     /*  565815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  565826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  565829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  565832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565861 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  565861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565883 */     GIR_RootConstrainSelectedInstOperands,
     /*  565884 */     // GIR_Coverage, 3481,
     /*  565884 */     GIR_EraseRootFromParent_Done,
     /*  565885 */   // Label 9290: @565885
     /*  565885 */   GIM_Try, /*On fail goto*//*Label 9291*/ GIMT_Encode4(565960), // Rule ID 3484 //
     /*  565890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  565901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  565904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  565907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565936 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  565936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565958 */     GIR_RootConstrainSelectedInstOperands,
     /*  565959 */     // GIR_Coverage, 3484,
     /*  565959 */     GIR_EraseRootFromParent_Done,
     /*  565960 */   // Label 9291: @565960
     /*  565960 */   GIM_Try, /*On fail goto*//*Label 9292*/ GIMT_Encode4(566035), // Rule ID 3485 //
     /*  565965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  565976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  565979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  565982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566011 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566033 */     GIR_RootConstrainSelectedInstOperands,
     /*  566034 */     // GIR_Coverage, 3485,
     /*  566034 */     GIR_EraseRootFromParent_Done,
     /*  566035 */   // Label 9292: @566035
     /*  566035 */   GIM_Try, /*On fail goto*//*Label 9293*/ GIMT_Encode4(566110), // Rule ID 3488 //
     /*  566040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  566051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  566054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566086 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566108 */     GIR_RootConstrainSelectedInstOperands,
     /*  566109 */     // GIR_Coverage, 3488,
     /*  566109 */     GIR_EraseRootFromParent_Done,
     /*  566110 */   // Label 9293: @566110
     /*  566110 */   GIM_Try, /*On fail goto*//*Label 9294*/ GIMT_Encode4(566185), // Rule ID 3489 //
     /*  566115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  566126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  566129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566161 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566183 */     GIR_RootConstrainSelectedInstOperands,
     /*  566184 */     // GIR_Coverage, 3489,
     /*  566184 */     GIR_EraseRootFromParent_Done,
     /*  566185 */   // Label 9294: @566185
     /*  566185 */   GIM_Try, /*On fail goto*//*Label 9295*/ GIMT_Encode4(566260), // Rule ID 3492 //
     /*  566190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  566201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  566204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566236 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  566239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566258 */     GIR_RootConstrainSelectedInstOperands,
     /*  566259 */     // GIR_Coverage, 3492,
     /*  566259 */     GIR_EraseRootFromParent_Done,
     /*  566260 */   // Label 9295: @566260
     /*  566260 */   GIM_Try, /*On fail goto*//*Label 9296*/ GIMT_Encode4(566335), // Rule ID 3493 //
     /*  566265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  566276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  566279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  566314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566333 */     GIR_RootConstrainSelectedInstOperands,
     /*  566334 */     // GIR_Coverage, 3493,
     /*  566334 */     GIR_EraseRootFromParent_Done,
     /*  566335 */   // Label 9296: @566335
     /*  566335 */   GIM_Try, /*On fail goto*//*Label 9297*/ GIMT_Encode4(566410), // Rule ID 3496 //
     /*  566340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  566351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  566354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566386 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566408 */     GIR_RootConstrainSelectedInstOperands,
     /*  566409 */     // GIR_Coverage, 3496,
     /*  566409 */     GIR_EraseRootFromParent_Done,
     /*  566410 */   // Label 9297: @566410
     /*  566410 */   GIM_Try, /*On fail goto*//*Label 9298*/ GIMT_Encode4(566485), // Rule ID 3497 //
     /*  566415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  566426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  566429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566461 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566483 */     GIR_RootConstrainSelectedInstOperands,
     /*  566484 */     // GIR_Coverage, 3497,
     /*  566484 */     GIR_EraseRootFromParent_Done,
     /*  566485 */   // Label 9298: @566485
     /*  566485 */   GIM_Try, /*On fail goto*//*Label 9299*/ GIMT_Encode4(566560), // Rule ID 3500 //
     /*  566490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  566501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  566504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  566507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566558 */     GIR_RootConstrainSelectedInstOperands,
     /*  566559 */     // GIR_Coverage, 3500,
     /*  566559 */     GIR_EraseRootFromParent_Done,
     /*  566560 */   // Label 9299: @566560
     /*  566560 */   GIM_Try, /*On fail goto*//*Label 9300*/ GIMT_Encode4(566635), // Rule ID 3501 //
     /*  566565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  566576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  566579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  566582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566611 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566633 */     GIR_RootConstrainSelectedInstOperands,
     /*  566634 */     // GIR_Coverage, 3501,
     /*  566634 */     GIR_EraseRootFromParent_Done,
     /*  566635 */   // Label 9300: @566635
     /*  566635 */   GIM_Try, /*On fail goto*//*Label 9301*/ GIMT_Encode4(566710), // Rule ID 3592 //
     /*  566640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  566651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  566654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  566657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  566660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566686 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  566686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  566689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566708 */     GIR_RootConstrainSelectedInstOperands,
     /*  566709 */     // GIR_Coverage, 3592,
     /*  566709 */     GIR_EraseRootFromParent_Done,
     /*  566710 */   // Label 9301: @566710
     /*  566710 */   GIM_Try, /*On fail goto*//*Label 9302*/ GIMT_Encode4(566785), // Rule ID 3593 //
     /*  566715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  566726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  566729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  566732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  566735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566761 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  566761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  566764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566783 */     GIR_RootConstrainSelectedInstOperands,
     /*  566784 */     // GIR_Coverage, 3593,
     /*  566784 */     GIR_EraseRootFromParent_Done,
     /*  566785 */   // Label 9302: @566785
     /*  566785 */   GIM_Try, /*On fail goto*//*Label 9303*/ GIMT_Encode4(566860), // Rule ID 3596 //
     /*  566790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  566801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  566804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  566807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  566810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566836 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  566836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  566839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566858 */     GIR_RootConstrainSelectedInstOperands,
     /*  566859 */     // GIR_Coverage, 3596,
     /*  566859 */     GIR_EraseRootFromParent_Done,
     /*  566860 */   // Label 9303: @566860
     /*  566860 */   GIM_Try, /*On fail goto*//*Label 9304*/ GIMT_Encode4(566935), // Rule ID 3597 //
     /*  566865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  566876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  566879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  566882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  566885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566911 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  566911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  566914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566933 */     GIR_RootConstrainSelectedInstOperands,
     /*  566934 */     // GIR_Coverage, 3597,
     /*  566934 */     GIR_EraseRootFromParent_Done,
     /*  566935 */   // Label 9304: @566935
     /*  566935 */   GIM_Try, /*On fail goto*//*Label 9305*/ GIMT_Encode4(567010), // Rule ID 3600 //
     /*  566940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  566951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  566954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  566957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  566960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566986 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  566986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  566989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567008 */     GIR_RootConstrainSelectedInstOperands,
     /*  567009 */     // GIR_Coverage, 3600,
     /*  567009 */     GIR_EraseRootFromParent_Done,
     /*  567010 */   // Label 9305: @567010
     /*  567010 */   GIM_Try, /*On fail goto*//*Label 9306*/ GIMT_Encode4(567085), // Rule ID 3601 //
     /*  567015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  567026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  567029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  567032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  567035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567061 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567083 */     GIR_RootConstrainSelectedInstOperands,
     /*  567084 */     // GIR_Coverage, 3601,
     /*  567084 */     GIR_EraseRootFromParent_Done,
     /*  567085 */   // Label 9306: @567085
     /*  567085 */   GIM_Try, /*On fail goto*//*Label 9307*/ GIMT_Encode4(567160), // Rule ID 3604 //
     /*  567090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  567101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  567104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  567107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  567110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567136 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567158 */     GIR_RootConstrainSelectedInstOperands,
     /*  567159 */     // GIR_Coverage, 3604,
     /*  567159 */     GIR_EraseRootFromParent_Done,
     /*  567160 */   // Label 9307: @567160
     /*  567160 */   GIM_Try, /*On fail goto*//*Label 9308*/ GIMT_Encode4(567235), // Rule ID 3605 //
     /*  567165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  567176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  567179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  567182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  567185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567211 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567233 */     GIR_RootConstrainSelectedInstOperands,
     /*  567234 */     // GIR_Coverage, 3605,
     /*  567234 */     GIR_EraseRootFromParent_Done,
     /*  567235 */   // Label 9308: @567235
     /*  567235 */   GIM_Try, /*On fail goto*//*Label 9309*/ GIMT_Encode4(567310), // Rule ID 3608 //
     /*  567240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  567251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  567254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  567257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  567260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567286 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  567289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567308 */     GIR_RootConstrainSelectedInstOperands,
     /*  567309 */     // GIR_Coverage, 3608,
     /*  567309 */     GIR_EraseRootFromParent_Done,
     /*  567310 */   // Label 9309: @567310
     /*  567310 */   GIM_Try, /*On fail goto*//*Label 9310*/ GIMT_Encode4(567385), // Rule ID 3609 //
     /*  567315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  567326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  567329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  567332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  567335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567361 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  567364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567383 */     GIR_RootConstrainSelectedInstOperands,
     /*  567384 */     // GIR_Coverage, 3609,
     /*  567384 */     GIR_EraseRootFromParent_Done,
     /*  567385 */   // Label 9310: @567385
     /*  567385 */   GIM_Try, /*On fail goto*//*Label 9311*/ GIMT_Encode4(567460), // Rule ID 3612 //
     /*  567390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  567401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  567404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  567407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  567410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567436 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  567439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567458 */     GIR_RootConstrainSelectedInstOperands,
     /*  567459 */     // GIR_Coverage, 3612,
     /*  567459 */     GIR_EraseRootFromParent_Done,
     /*  567460 */   // Label 9311: @567460
     /*  567460 */   GIM_Try, /*On fail goto*//*Label 9312*/ GIMT_Encode4(567535), // Rule ID 3613 //
     /*  567465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  567476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  567479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  567482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  567485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567511 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  567514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567533 */     GIR_RootConstrainSelectedInstOperands,
     /*  567534 */     // GIR_Coverage, 3613,
     /*  567534 */     GIR_EraseRootFromParent_Done,
     /*  567535 */   // Label 9312: @567535
     /*  567535 */   GIM_Try, /*On fail goto*//*Label 9313*/ GIMT_Encode4(567610), // Rule ID 3616 //
     /*  567540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  567551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  567554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  567557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  567560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  567589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567608 */     GIR_RootConstrainSelectedInstOperands,
     /*  567609 */     // GIR_Coverage, 3616,
     /*  567609 */     GIR_EraseRootFromParent_Done,
     /*  567610 */   // Label 9313: @567610
     /*  567610 */   GIM_Try, /*On fail goto*//*Label 9314*/ GIMT_Encode4(567685), // Rule ID 3617 //
     /*  567615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  567626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  567629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  567632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  567635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567661 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  567664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567683 */     GIR_RootConstrainSelectedInstOperands,
     /*  567684 */     // GIR_Coverage, 3617,
     /*  567684 */     GIR_EraseRootFromParent_Done,
     /*  567685 */   // Label 9314: @567685
     /*  567685 */   GIM_Try, /*On fail goto*//*Label 9315*/ GIMT_Encode4(567760), // Rule ID 3620 //
     /*  567690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  567701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  567704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  567707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  567710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567758 */     GIR_RootConstrainSelectedInstOperands,
     /*  567759 */     // GIR_Coverage, 3620,
     /*  567759 */     GIR_EraseRootFromParent_Done,
     /*  567760 */   // Label 9315: @567760
     /*  567760 */   GIM_Try, /*On fail goto*//*Label 9316*/ GIMT_Encode4(567835), // Rule ID 3621 //
     /*  567765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  567776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  567779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  567782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  567785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567811 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567833 */     GIR_RootConstrainSelectedInstOperands,
     /*  567834 */     // GIR_Coverage, 3621,
     /*  567834 */     GIR_EraseRootFromParent_Done,
     /*  567835 */   // Label 9316: @567835
     /*  567835 */   GIM_Try, /*On fail goto*//*Label 9317*/ GIMT_Encode4(567910), // Rule ID 3624 //
     /*  567840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  567851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  567854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  567857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  567860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567886 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567908 */     GIR_RootConstrainSelectedInstOperands,
     /*  567909 */     // GIR_Coverage, 3624,
     /*  567909 */     GIR_EraseRootFromParent_Done,
     /*  567910 */   // Label 9317: @567910
     /*  567910 */   GIM_Try, /*On fail goto*//*Label 9318*/ GIMT_Encode4(567985), // Rule ID 3625 //
     /*  567915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  567926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  567929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  567932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  567935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567961 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567983 */     GIR_RootConstrainSelectedInstOperands,
     /*  567984 */     // GIR_Coverage, 3625,
     /*  567984 */     GIR_EraseRootFromParent_Done,
     /*  567985 */   // Label 9318: @567985
     /*  567985 */   GIM_Try, /*On fail goto*//*Label 9319*/ GIMT_Encode4(568060), // Rule ID 3628 //
     /*  567990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  568001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  568004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  568007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  568010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568058 */     GIR_RootConstrainSelectedInstOperands,
     /*  568059 */     // GIR_Coverage, 3628,
     /*  568059 */     GIR_EraseRootFromParent_Done,
     /*  568060 */   // Label 9319: @568060
     /*  568060 */   GIM_Try, /*On fail goto*//*Label 9320*/ GIMT_Encode4(568135), // Rule ID 3629 //
     /*  568065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  568076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  568079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  568082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  568085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568111 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568133 */     GIR_RootConstrainSelectedInstOperands,
     /*  568134 */     // GIR_Coverage, 3629,
     /*  568134 */     GIR_EraseRootFromParent_Done,
     /*  568135 */   // Label 9320: @568135
     /*  568135 */   GIM_Try, /*On fail goto*//*Label 9321*/ GIMT_Encode4(568210), // Rule ID 3632 //
     /*  568140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  568151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  568154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  568157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  568160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568208 */     GIR_RootConstrainSelectedInstOperands,
     /*  568209 */     // GIR_Coverage, 3632,
     /*  568209 */     GIR_EraseRootFromParent_Done,
     /*  568210 */   // Label 9321: @568210
     /*  568210 */   GIM_Try, /*On fail goto*//*Label 9322*/ GIMT_Encode4(568285), // Rule ID 3633 //
     /*  568215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  568226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  568229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  568232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  568235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568261 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568283 */     GIR_RootConstrainSelectedInstOperands,
     /*  568284 */     // GIR_Coverage, 3633,
     /*  568284 */     GIR_EraseRootFromParent_Done,
     /*  568285 */   // Label 9322: @568285
     /*  568285 */   GIM_Try, /*On fail goto*//*Label 9323*/ GIMT_Encode4(568360), // Rule ID 3636 //
     /*  568290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  568301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  568304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  568307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  568310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  568339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568358 */     GIR_RootConstrainSelectedInstOperands,
     /*  568359 */     // GIR_Coverage, 3636,
     /*  568359 */     GIR_EraseRootFromParent_Done,
     /*  568360 */   // Label 9323: @568360
     /*  568360 */   GIM_Try, /*On fail goto*//*Label 9324*/ GIMT_Encode4(568435), // Rule ID 3637 //
     /*  568365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  568376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  568379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  568382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  568385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568411 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  568414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568433 */     GIR_RootConstrainSelectedInstOperands,
     /*  568434 */     // GIR_Coverage, 3637,
     /*  568434 */     GIR_EraseRootFromParent_Done,
     /*  568435 */   // Label 9324: @568435
     /*  568435 */   GIM_Try, /*On fail goto*//*Label 9325*/ GIMT_Encode4(568510), // Rule ID 3640 //
     /*  568440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  568451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  568454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  568460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  568489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568508 */     GIR_RootConstrainSelectedInstOperands,
     /*  568509 */     // GIR_Coverage, 3640,
     /*  568509 */     GIR_EraseRootFromParent_Done,
     /*  568510 */   // Label 9325: @568510
     /*  568510 */   GIM_Try, /*On fail goto*//*Label 9326*/ GIMT_Encode4(568585), // Rule ID 3641 //
     /*  568515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  568526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  568529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  568535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568561 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  568564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568583 */     GIR_RootConstrainSelectedInstOperands,
     /*  568584 */     // GIR_Coverage, 3641,
     /*  568584 */     GIR_EraseRootFromParent_Done,
     /*  568585 */   // Label 9326: @568585
     /*  568585 */   GIM_Try, /*On fail goto*//*Label 9327*/ GIMT_Encode4(568660), // Rule ID 3644 //
     /*  568590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  568601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  568604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  568607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  568610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568636 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568658 */     GIR_RootConstrainSelectedInstOperands,
     /*  568659 */     // GIR_Coverage, 3644,
     /*  568659 */     GIR_EraseRootFromParent_Done,
     /*  568660 */   // Label 9327: @568660
     /*  568660 */   GIM_Try, /*On fail goto*//*Label 9328*/ GIMT_Encode4(568735), // Rule ID 3645 //
     /*  568665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  568676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  568679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  568682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  568685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568711 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568733 */     GIR_RootConstrainSelectedInstOperands,
     /*  568734 */     // GIR_Coverage, 3645,
     /*  568734 */     GIR_EraseRootFromParent_Done,
     /*  568735 */   // Label 9328: @568735
     /*  568735 */   GIM_Try, /*On fail goto*//*Label 9329*/ GIMT_Encode4(568810), // Rule ID 3648 //
     /*  568740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  568751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  568754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  568757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  568760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568808 */     GIR_RootConstrainSelectedInstOperands,
     /*  568809 */     // GIR_Coverage, 3648,
     /*  568809 */     GIR_EraseRootFromParent_Done,
     /*  568810 */   // Label 9329: @568810
     /*  568810 */   GIM_Try, /*On fail goto*//*Label 9330*/ GIMT_Encode4(568885), // Rule ID 3649 //
     /*  568815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  568826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  568829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  568832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  568835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568861 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568883 */     GIR_RootConstrainSelectedInstOperands,
     /*  568884 */     // GIR_Coverage, 3649,
     /*  568884 */     GIR_EraseRootFromParent_Done,
     /*  568885 */   // Label 9330: @568885
     /*  568885 */   GIM_Try, /*On fail goto*//*Label 9331*/ GIMT_Encode4(568960), // Rule ID 3652 //
     /*  568890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  568901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  568904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  568907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568936 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  568936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  568939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568958 */     GIR_RootConstrainSelectedInstOperands,
     /*  568959 */     // GIR_Coverage, 3652,
     /*  568959 */     GIR_EraseRootFromParent_Done,
     /*  568960 */   // Label 9331: @568960
     /*  568960 */   GIM_Try, /*On fail goto*//*Label 9332*/ GIMT_Encode4(569035), // Rule ID 3653 //
     /*  568965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  568976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  568979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  568982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569011 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  569014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569033 */     GIR_RootConstrainSelectedInstOperands,
     /*  569034 */     // GIR_Coverage, 3653,
     /*  569034 */     GIR_EraseRootFromParent_Done,
     /*  569035 */   // Label 9332: @569035
     /*  569035 */   GIM_Try, /*On fail goto*//*Label 9333*/ GIMT_Encode4(569110), // Rule ID 3656 //
     /*  569040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  569051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  569054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  569057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569108 */     GIR_RootConstrainSelectedInstOperands,
     /*  569109 */     // GIR_Coverage, 3656,
     /*  569109 */     GIR_EraseRootFromParent_Done,
     /*  569110 */   // Label 9333: @569110
     /*  569110 */   GIM_Try, /*On fail goto*//*Label 9334*/ GIMT_Encode4(569185), // Rule ID 3657 //
     /*  569115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  569126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  569129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  569132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569161 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569183 */     GIR_RootConstrainSelectedInstOperands,
     /*  569184 */     // GIR_Coverage, 3657,
     /*  569184 */     GIR_EraseRootFromParent_Done,
     /*  569185 */   // Label 9334: @569185
     /*  569185 */   GIM_Try, /*On fail goto*//*Label 9335*/ GIMT_Encode4(569260), // Rule ID 3660 //
     /*  569190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  569201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  569204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  569207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569236 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  569239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569258 */     GIR_RootConstrainSelectedInstOperands,
     /*  569259 */     // GIR_Coverage, 3660,
     /*  569259 */     GIR_EraseRootFromParent_Done,
     /*  569260 */   // Label 9335: @569260
     /*  569260 */   GIM_Try, /*On fail goto*//*Label 9336*/ GIMT_Encode4(569335), // Rule ID 3661 //
     /*  569265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  569276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  569279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  569282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569311 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  569314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569333 */     GIR_RootConstrainSelectedInstOperands,
     /*  569334 */     // GIR_Coverage, 3661,
     /*  569334 */     GIR_EraseRootFromParent_Done,
     /*  569335 */   // Label 9336: @569335
     /*  569335 */   GIM_Try, /*On fail goto*//*Label 9337*/ GIMT_Encode4(569410), // Rule ID 3664 //
     /*  569340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  569351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  569354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  569357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569386 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  569389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569408 */     GIR_RootConstrainSelectedInstOperands,
     /*  569409 */     // GIR_Coverage, 3664,
     /*  569409 */     GIR_EraseRootFromParent_Done,
     /*  569410 */   // Label 9337: @569410
     /*  569410 */   GIM_Try, /*On fail goto*//*Label 9338*/ GIMT_Encode4(569485), // Rule ID 3665 //
     /*  569415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  569426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  569429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  569432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569461 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  569464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569483 */     GIR_RootConstrainSelectedInstOperands,
     /*  569484 */     // GIR_Coverage, 3665,
     /*  569484 */     GIR_EraseRootFromParent_Done,
     /*  569485 */   // Label 9338: @569485
     /*  569485 */   GIM_Try, /*On fail goto*//*Label 9339*/ GIMT_Encode4(569560), // Rule ID 3668 //
     /*  569490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  569501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  569504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  569507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569536 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  569539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569558 */     GIR_RootConstrainSelectedInstOperands,
     /*  569559 */     // GIR_Coverage, 3668,
     /*  569559 */     GIR_EraseRootFromParent_Done,
     /*  569560 */   // Label 9339: @569560
     /*  569560 */   GIM_Try, /*On fail goto*//*Label 9340*/ GIMT_Encode4(569635), // Rule ID 3669 //
     /*  569565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  569576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  569579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  569582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569611 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  569614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569633 */     GIR_RootConstrainSelectedInstOperands,
     /*  569634 */     // GIR_Coverage, 3669,
     /*  569634 */     GIR_EraseRootFromParent_Done,
     /*  569635 */   // Label 9340: @569635
     /*  569635 */   GIM_Try, /*On fail goto*//*Label 9341*/ GIMT_Encode4(569710), // Rule ID 3672 //
     /*  569640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  569651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  569654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  569657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569686 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  569689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569708 */     GIR_RootConstrainSelectedInstOperands,
     /*  569709 */     // GIR_Coverage, 3672,
     /*  569709 */     GIR_EraseRootFromParent_Done,
     /*  569710 */   // Label 9341: @569710
     /*  569710 */   GIM_Try, /*On fail goto*//*Label 9342*/ GIMT_Encode4(569785), // Rule ID 3673 //
     /*  569715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  569726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  569729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  569732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569761 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  569764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569783 */     GIR_RootConstrainSelectedInstOperands,
     /*  569784 */     // GIR_Coverage, 3673,
     /*  569784 */     GIR_EraseRootFromParent_Done,
     /*  569785 */   // Label 9342: @569785
     /*  569785 */   GIM_Try, /*On fail goto*//*Label 9343*/ GIMT_Encode4(569860), // Rule ID 3676 //
     /*  569790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  569801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  569804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  569807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569836 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569858 */     GIR_RootConstrainSelectedInstOperands,
     /*  569859 */     // GIR_Coverage, 3676,
     /*  569859 */     GIR_EraseRootFromParent_Done,
     /*  569860 */   // Label 9343: @569860
     /*  569860 */   GIM_Try, /*On fail goto*//*Label 9344*/ GIMT_Encode4(569935), // Rule ID 3677 //
     /*  569865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  569876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  569879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  569882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569911 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569933 */     GIR_RootConstrainSelectedInstOperands,
     /*  569934 */     // GIR_Coverage, 3677,
     /*  569934 */     GIR_EraseRootFromParent_Done,
     /*  569935 */   // Label 9344: @569935
     /*  569935 */   GIM_Try, /*On fail goto*//*Label 9345*/ GIMT_Encode4(570010), // Rule ID 3680 //
     /*  569940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  569951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  569954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  569957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569986 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  569989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570008 */     GIR_RootConstrainSelectedInstOperands,
     /*  570009 */     // GIR_Coverage, 3680,
     /*  570009 */     GIR_EraseRootFromParent_Done,
     /*  570010 */   // Label 9345: @570010
     /*  570010 */   GIM_Try, /*On fail goto*//*Label 9346*/ GIMT_Encode4(570085), // Rule ID 3681 //
     /*  570015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  570026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  570029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  570032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570061 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  570064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570083 */     GIR_RootConstrainSelectedInstOperands,
     /*  570084 */     // GIR_Coverage, 3681,
     /*  570084 */     GIR_EraseRootFromParent_Done,
     /*  570085 */   // Label 9346: @570085
     /*  570085 */   GIM_Try, /*On fail goto*//*Label 9347*/ GIMT_Encode4(570160), // Rule ID 3684 //
     /*  570090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  570101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  570104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  570107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570158 */     GIR_RootConstrainSelectedInstOperands,
     /*  570159 */     // GIR_Coverage, 3684,
     /*  570159 */     GIR_EraseRootFromParent_Done,
     /*  570160 */   // Label 9347: @570160
     /*  570160 */   GIM_Try, /*On fail goto*//*Label 9348*/ GIMT_Encode4(570235), // Rule ID 3685 //
     /*  570165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  570176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  570179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  570182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570233 */     GIR_RootConstrainSelectedInstOperands,
     /*  570234 */     // GIR_Coverage, 3685,
     /*  570234 */     GIR_EraseRootFromParent_Done,
     /*  570235 */   // Label 9348: @570235
     /*  570235 */   GIM_Try, /*On fail goto*//*Label 9349*/ GIMT_Encode4(570310), // Rule ID 3688 //
     /*  570240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  570251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  570254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  570257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570286 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570308 */     GIR_RootConstrainSelectedInstOperands,
     /*  570309 */     // GIR_Coverage, 3688,
     /*  570309 */     GIR_EraseRootFromParent_Done,
     /*  570310 */   // Label 9349: @570310
     /*  570310 */   GIM_Try, /*On fail goto*//*Label 9350*/ GIMT_Encode4(570385), // Rule ID 3689 //
     /*  570315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  570326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  570329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  570332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570361 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570383 */     GIR_RootConstrainSelectedInstOperands,
     /*  570384 */     // GIR_Coverage, 3689,
     /*  570384 */     GIR_EraseRootFromParent_Done,
     /*  570385 */   // Label 9350: @570385
     /*  570385 */   GIM_Try, /*On fail goto*//*Label 9351*/ GIMT_Encode4(570460), // Rule ID 3692 //
     /*  570390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  570401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  570404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  570407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570436 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570458 */     GIR_RootConstrainSelectedInstOperands,
     /*  570459 */     // GIR_Coverage, 3692,
     /*  570459 */     GIR_EraseRootFromParent_Done,
     /*  570460 */   // Label 9351: @570460
     /*  570460 */   GIM_Try, /*On fail goto*//*Label 9352*/ GIMT_Encode4(570535), // Rule ID 3693 //
     /*  570465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  570476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  570479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  570482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570511 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570533 */     GIR_RootConstrainSelectedInstOperands,
     /*  570534 */     // GIR_Coverage, 3693,
     /*  570534 */     GIR_EraseRootFromParent_Done,
     /*  570535 */   // Label 9352: @570535
     /*  570535 */   GIM_Try, /*On fail goto*//*Label 9353*/ GIMT_Encode4(570610), // Rule ID 3696 //
     /*  570540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  570543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  570551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  570554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  570557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570586 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  570586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  570589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570608 */     GIR_RootConstrainSelectedInstOperands,
     /*  570609 */     // GIR_Coverage, 3696,
     /*  570609 */     GIR_EraseRootFromParent_Done,
     /*  570610 */   // Label 9353: @570610
     /*  570610 */   GIM_Try, /*On fail goto*//*Label 9354*/ GIMT_Encode4(570685), // Rule ID 3697 //
     /*  570615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  570618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  570626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  570629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  570632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570661 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  570661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  570664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570683 */     GIR_RootConstrainSelectedInstOperands,
     /*  570684 */     // GIR_Coverage, 3697,
     /*  570684 */     GIR_EraseRootFromParent_Done,
     /*  570685 */   // Label 9354: @570685
     /*  570685 */   GIM_Try, /*On fail goto*//*Label 9355*/ GIMT_Encode4(570760), // Rule ID 3700 //
     /*  570690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  570693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  570701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  570704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  570707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570736 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  570736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570758 */     GIR_RootConstrainSelectedInstOperands,
     /*  570759 */     // GIR_Coverage, 3700,
     /*  570759 */     GIR_EraseRootFromParent_Done,
     /*  570760 */   // Label 9355: @570760
     /*  570760 */   GIM_Try, /*On fail goto*//*Label 9356*/ GIMT_Encode4(570835), // Rule ID 3701 //
     /*  570765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  570768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  570776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  570779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  570782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570811 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  570811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570833 */     GIR_RootConstrainSelectedInstOperands,
     /*  570834 */     // GIR_Coverage, 3701,
     /*  570834 */     GIR_EraseRootFromParent_Done,
     /*  570835 */   // Label 9356: @570835
     /*  570835 */   GIM_Try, /*On fail goto*//*Label 9357*/ GIMT_Encode4(570910), // Rule ID 3704 //
     /*  570840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  570843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  570851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  570854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  570857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570886 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  570886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570908 */     GIR_RootConstrainSelectedInstOperands,
     /*  570909 */     // GIR_Coverage, 3704,
     /*  570909 */     GIR_EraseRootFromParent_Done,
     /*  570910 */   // Label 9357: @570910
     /*  570910 */   GIM_Try, /*On fail goto*//*Label 9358*/ GIMT_Encode4(570985), // Rule ID 3705 //
     /*  570915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  570918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  570926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  570929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  570932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570961 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  570961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570983 */     GIR_RootConstrainSelectedInstOperands,
     /*  570984 */     // GIR_Coverage, 3705,
     /*  570984 */     GIR_EraseRootFromParent_Done,
     /*  570985 */   // Label 9358: @570985
     /*  570985 */   GIM_Try, /*On fail goto*//*Label 9359*/ GIMT_Encode4(571060), // Rule ID 3708 //
     /*  570990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  570993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  571001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  571004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  571007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  571010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571036 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  571036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  571039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571058 */     GIR_RootConstrainSelectedInstOperands,
     /*  571059 */     // GIR_Coverage, 3708,
     /*  571059 */     GIR_EraseRootFromParent_Done,
     /*  571060 */   // Label 9359: @571060
     /*  571060 */   GIM_Try, /*On fail goto*//*Label 9360*/ GIMT_Encode4(571135), // Rule ID 3709 //
     /*  571065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  571068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  571076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  571079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  571082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  571085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571111 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  571111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  571114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571133 */     GIR_RootConstrainSelectedInstOperands,
     /*  571134 */     // GIR_Coverage, 3709,
     /*  571134 */     GIR_EraseRootFromParent_Done,
     /*  571135 */   // Label 9360: @571135
     /*  571135 */   GIM_Try, /*On fail goto*//*Label 9361*/ GIMT_Encode4(571210), // Rule ID 3712 //
     /*  571140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  571151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  571154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  571157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  571160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571186 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11685:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  571189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571208 */     GIR_RootConstrainSelectedInstOperands,
     /*  571209 */     // GIR_Coverage, 3712,
     /*  571209 */     GIR_EraseRootFromParent_Done,
     /*  571210 */   // Label 9361: @571210
     /*  571210 */   GIM_Try, /*On fail goto*//*Label 9362*/ GIMT_Encode4(571285), // Rule ID 3713 //
     /*  571215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  571226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  571229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  571232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  571235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571261 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11685:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  571264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571283 */     GIR_RootConstrainSelectedInstOperands,
     /*  571284 */     // GIR_Coverage, 3713,
     /*  571284 */     GIR_EraseRootFromParent_Done,
     /*  571285 */   // Label 9362: @571285
     /*  571285 */   GIM_Try, /*On fail goto*//*Label 9363*/ GIMT_Encode4(571360), // Rule ID 3716 //
     /*  571290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  571301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  571304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  571307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  571310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571336 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11685:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  571339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571358 */     GIR_RootConstrainSelectedInstOperands,
     /*  571359 */     // GIR_Coverage, 3716,
     /*  571359 */     GIR_EraseRootFromParent_Done,
     /*  571360 */   // Label 9363: @571360
     /*  571360 */   GIM_Try, /*On fail goto*//*Label 9364*/ GIMT_Encode4(571435), // Rule ID 3717 //
     /*  571365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  571376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  571379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  571382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  571385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571411 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11685:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  571414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571433 */     GIR_RootConstrainSelectedInstOperands,
     /*  571434 */     // GIR_Coverage, 3717,
     /*  571434 */     GIR_EraseRootFromParent_Done,
     /*  571435 */   // Label 9364: @571435
     /*  571435 */   GIM_Try, /*On fail goto*//*Label 9365*/ GIMT_Encode4(571510), // Rule ID 3720 //
     /*  571440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  571451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  571454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  571457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  571460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571486 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11685:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  571489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571508 */     GIR_RootConstrainSelectedInstOperands,
     /*  571509 */     // GIR_Coverage, 3720,
     /*  571509 */     GIR_EraseRootFromParent_Done,
     /*  571510 */   // Label 9365: @571510
     /*  571510 */   GIM_Try, /*On fail goto*//*Label 9366*/ GIMT_Encode4(571585), // Rule ID 3721 //
     /*  571515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  571526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  571529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  571532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  571535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571561 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11685:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  571564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571583 */     GIR_RootConstrainSelectedInstOperands,
     /*  571584 */     // GIR_Coverage, 3721,
     /*  571584 */     GIR_EraseRootFromParent_Done,
     /*  571585 */   // Label 9366: @571585
     /*  571585 */   GIM_Try, /*On fail goto*//*Label 9367*/ GIMT_Encode4(571660), // Rule ID 3724 //
     /*  571590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  571601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  571604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  571607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  571610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571636 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11685:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  571639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571658 */     GIR_RootConstrainSelectedInstOperands,
     /*  571659 */     // GIR_Coverage, 3724,
     /*  571659 */     GIR_EraseRootFromParent_Done,
     /*  571660 */   // Label 9367: @571660
     /*  571660 */   GIM_Try, /*On fail goto*//*Label 9368*/ GIMT_Encode4(571735), // Rule ID 3725 //
     /*  571665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  571676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  571679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  571682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  571685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571711 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11685:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  571714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571733 */     GIR_RootConstrainSelectedInstOperands,
     /*  571734 */     // GIR_Coverage, 3725,
     /*  571734 */     GIR_EraseRootFromParent_Done,
     /*  571735 */   // Label 9368: @571735
     /*  571735 */   GIM_Try, /*On fail goto*//*Label 9369*/ GIMT_Encode4(571810), // Rule ID 3728 //
     /*  571740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  571751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  571754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  571757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  571760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571786 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11685:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  571789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571808 */     GIR_RootConstrainSelectedInstOperands,
     /*  571809 */     // GIR_Coverage, 3728,
     /*  571809 */     GIR_EraseRootFromParent_Done,
     /*  571810 */   // Label 9369: @571810
     /*  571810 */   GIM_Try, /*On fail goto*//*Label 9370*/ GIMT_Encode4(571885), // Rule ID 3729 //
     /*  571815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  571826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  571829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  571832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  571835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571861 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11685:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  571864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571883 */     GIR_RootConstrainSelectedInstOperands,
     /*  571884 */     // GIR_Coverage, 3729,
     /*  571884 */     GIR_EraseRootFromParent_Done,
     /*  571885 */   // Label 9370: @571885
     /*  571885 */   GIM_Try, /*On fail goto*//*Label 9371*/ GIMT_Encode4(571960), // Rule ID 3732 //
     /*  571890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  571901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  571904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  571907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  571910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571936 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11685:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  571939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571958 */     GIR_RootConstrainSelectedInstOperands,
     /*  571959 */     // GIR_Coverage, 3732,
     /*  571959 */     GIR_EraseRootFromParent_Done,
     /*  571960 */   // Label 9371: @571960
     /*  571960 */   GIM_Try, /*On fail goto*//*Label 9372*/ GIMT_Encode4(572035), // Rule ID 3733 //
     /*  571965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  571976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  571979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  571982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  571985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572011 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11685:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572033 */     GIR_RootConstrainSelectedInstOperands,
     /*  572034 */     // GIR_Coverage, 3733,
     /*  572034 */     GIR_EraseRootFromParent_Done,
     /*  572035 */   // Label 9372: @572035
     /*  572035 */   GIM_Try, /*On fail goto*//*Label 9373*/ GIMT_Encode4(572110), // Rule ID 3736 //
     /*  572040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  572051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  572054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  572057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  572060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11685:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  572089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572108 */     GIR_RootConstrainSelectedInstOperands,
     /*  572109 */     // GIR_Coverage, 3736,
     /*  572109 */     GIR_EraseRootFromParent_Done,
     /*  572110 */   // Label 9373: @572110
     /*  572110 */   GIM_Try, /*On fail goto*//*Label 9374*/ GIMT_Encode4(572185), // Rule ID 3737 //
     /*  572115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  572126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  572129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  572132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  572135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572161 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11685:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  572164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572183 */     GIR_RootConstrainSelectedInstOperands,
     /*  572184 */     // GIR_Coverage, 3737,
     /*  572184 */     GIR_EraseRootFromParent_Done,
     /*  572185 */   // Label 9374: @572185
     /*  572185 */   GIM_Try, /*On fail goto*//*Label 9375*/ GIMT_Encode4(572260), // Rule ID 3740 //
     /*  572190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  572201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  572204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  572207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  572210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11685:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572258 */     GIR_RootConstrainSelectedInstOperands,
     /*  572259 */     // GIR_Coverage, 3740,
     /*  572259 */     GIR_EraseRootFromParent_Done,
     /*  572260 */   // Label 9375: @572260
     /*  572260 */   GIM_Try, /*On fail goto*//*Label 9376*/ GIMT_Encode4(572335), // Rule ID 3741 //
     /*  572265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  572276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  572279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  572282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  572285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572311 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11685:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572333 */     GIR_RootConstrainSelectedInstOperands,
     /*  572334 */     // GIR_Coverage, 3741,
     /*  572334 */     GIR_EraseRootFromParent_Done,
     /*  572335 */   // Label 9376: @572335
     /*  572335 */   GIM_Try, /*On fail goto*//*Label 9377*/ GIMT_Encode4(572410), // Rule ID 3744 //
     /*  572340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  572351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  572354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  572357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  572360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572386 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11685:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572408 */     GIR_RootConstrainSelectedInstOperands,
     /*  572409 */     // GIR_Coverage, 3744,
     /*  572409 */     GIR_EraseRootFromParent_Done,
     /*  572410 */   // Label 9377: @572410
     /*  572410 */   GIM_Try, /*On fail goto*//*Label 9378*/ GIMT_Encode4(572485), // Rule ID 3745 //
     /*  572415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  572426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  572429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  572432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  572435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572461 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11685:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572483 */     GIR_RootConstrainSelectedInstOperands,
     /*  572484 */     // GIR_Coverage, 3745,
     /*  572484 */     GIR_EraseRootFromParent_Done,
     /*  572485 */   // Label 9378: @572485
     /*  572485 */   GIM_Try, /*On fail goto*//*Label 9379*/ GIMT_Encode4(572560), // Rule ID 3748 //
     /*  572490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  572501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  572504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  572507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  572510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572536 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11685:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  572539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572558 */     GIR_RootConstrainSelectedInstOperands,
     /*  572559 */     // GIR_Coverage, 3748,
     /*  572559 */     GIR_EraseRootFromParent_Done,
     /*  572560 */   // Label 9379: @572560
     /*  572560 */   GIM_Try, /*On fail goto*//*Label 9380*/ GIMT_Encode4(572635), // Rule ID 3749 //
     /*  572565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  572576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  572579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  572582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  572585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572611 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11685:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  572614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572633 */     GIR_RootConstrainSelectedInstOperands,
     /*  572634 */     // GIR_Coverage, 3749,
     /*  572634 */     GIR_EraseRootFromParent_Done,
     /*  572635 */   // Label 9380: @572635
     /*  572635 */   GIM_Try, /*On fail goto*//*Label 9381*/ GIMT_Encode4(572710), // Rule ID 3752 //
     /*  572640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  572651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  572654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  572657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  572660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572686 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11685:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572708 */     GIR_RootConstrainSelectedInstOperands,
     /*  572709 */     // GIR_Coverage, 3752,
     /*  572709 */     GIR_EraseRootFromParent_Done,
     /*  572710 */   // Label 9381: @572710
     /*  572710 */   GIM_Try, /*On fail goto*//*Label 9382*/ GIMT_Encode4(572785), // Rule ID 3753 //
     /*  572715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  572726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  572729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  572732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  572735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572761 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11685:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572783 */     GIR_RootConstrainSelectedInstOperands,
     /*  572784 */     // GIR_Coverage, 3753,
     /*  572784 */     GIR_EraseRootFromParent_Done,
     /*  572785 */   // Label 9382: @572785
     /*  572785 */   GIM_Try, /*On fail goto*//*Label 9383*/ GIMT_Encode4(572860), // Rule ID 3756 //
     /*  572790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  572801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  572804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  572807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  572810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572836 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11685:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572858 */     GIR_RootConstrainSelectedInstOperands,
     /*  572859 */     // GIR_Coverage, 3756,
     /*  572859 */     GIR_EraseRootFromParent_Done,
     /*  572860 */   // Label 9383: @572860
     /*  572860 */   GIM_Try, /*On fail goto*//*Label 9384*/ GIMT_Encode4(572935), // Rule ID 3757 //
     /*  572865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  572876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  572879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  572882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  572885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572911 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11685:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572933 */     GIR_RootConstrainSelectedInstOperands,
     /*  572934 */     // GIR_Coverage, 3757,
     /*  572934 */     GIR_EraseRootFromParent_Done,
     /*  572935 */   // Label 9384: @572935
     /*  572935 */   GIM_Try, /*On fail goto*//*Label 9385*/ GIMT_Encode4(573010), // Rule ID 3760 //
     /*  572940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  572951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  572954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  572957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  572960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572986 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11685:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573008 */     GIR_RootConstrainSelectedInstOperands,
     /*  573009 */     // GIR_Coverage, 3760,
     /*  573009 */     GIR_EraseRootFromParent_Done,
     /*  573010 */   // Label 9385: @573010
     /*  573010 */   GIM_Try, /*On fail goto*//*Label 9386*/ GIMT_Encode4(573085), // Rule ID 3761 //
     /*  573015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  573026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  573029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  573032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  573035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573061 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11685:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  573064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573083 */     GIR_RootConstrainSelectedInstOperands,
     /*  573084 */     // GIR_Coverage, 3761,
     /*  573084 */     GIR_EraseRootFromParent_Done,
     /*  573085 */   // Label 9386: @573085
     /*  573085 */   GIM_Try, /*On fail goto*//*Label 9387*/ GIMT_Encode4(573160), // Rule ID 3764 //
     /*  573090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  573093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  573101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  573104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  573107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  573110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573136 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11685:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  573139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573158 */     GIR_RootConstrainSelectedInstOperands,
     /*  573159 */     // GIR_Coverage, 3764,
     /*  573159 */     GIR_EraseRootFromParent_Done,
     /*  573160 */   // Label 9387: @573160
     /*  573160 */   GIM_Try, /*On fail goto*//*Label 9388*/ GIMT_Encode4(573235), // Rule ID 3765 //
     /*  573165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  573176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  573179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  573182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  573185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573211 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11685:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  573214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573233 */     GIR_RootConstrainSelectedInstOperands,
     /*  573234 */     // GIR_Coverage, 3765,
     /*  573234 */     GIR_EraseRootFromParent_Done,
     /*  573235 */   // Label 9388: @573235
     /*  573235 */   GIM_Try, /*On fail goto*//*Label 9389*/ GIMT_Encode4(573310), // Rule ID 3768 //
     /*  573240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  573243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  573251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  573254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  573257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  573260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573286 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11685:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  573289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573308 */     GIR_RootConstrainSelectedInstOperands,
     /*  573309 */     // GIR_Coverage, 3768,
     /*  573309 */     GIR_EraseRootFromParent_Done,
     /*  573310 */   // Label 9389: @573310
     /*  573310 */   GIM_Try, /*On fail goto*//*Label 9390*/ GIMT_Encode4(573385), // Rule ID 3769 //
     /*  573315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  573326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  573329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  573332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  573335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573361 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11685:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  573364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573383 */     GIR_RootConstrainSelectedInstOperands,
     /*  573384 */     // GIR_Coverage, 3769,
     /*  573384 */     GIR_EraseRootFromParent_Done,
     /*  573385 */   // Label 9390: @573385
     /*  573385 */   GIM_Try, /*On fail goto*//*Label 9391*/ GIMT_Encode4(573460), // Rule ID 3772 //
     /*  573390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  573401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  573404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  573407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573436 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11685:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  573439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573458 */     GIR_RootConstrainSelectedInstOperands,
     /*  573459 */     // GIR_Coverage, 3772,
     /*  573459 */     GIR_EraseRootFromParent_Done,
     /*  573460 */   // Label 9391: @573460
     /*  573460 */   GIM_Try, /*On fail goto*//*Label 9392*/ GIMT_Encode4(573535), // Rule ID 3773 //
     /*  573465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  573476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  573479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  573482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573511 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11685:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  573514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573533 */     GIR_RootConstrainSelectedInstOperands,
     /*  573534 */     // GIR_Coverage, 3773,
     /*  573534 */     GIR_EraseRootFromParent_Done,
     /*  573535 */   // Label 9392: @573535
     /*  573535 */   GIM_Try, /*On fail goto*//*Label 9393*/ GIMT_Encode4(573610), // Rule ID 3776 //
     /*  573540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  573551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  573554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  573557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573586 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11685:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  573589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573608 */     GIR_RootConstrainSelectedInstOperands,
     /*  573609 */     // GIR_Coverage, 3776,
     /*  573609 */     GIR_EraseRootFromParent_Done,
     /*  573610 */   // Label 9393: @573610
     /*  573610 */   GIM_Try, /*On fail goto*//*Label 9394*/ GIMT_Encode4(573685), // Rule ID 3777 //
     /*  573615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  573626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  573629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  573632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573661 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11685:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  573664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573683 */     GIR_RootConstrainSelectedInstOperands,
     /*  573684 */     // GIR_Coverage, 3777,
     /*  573684 */     GIR_EraseRootFromParent_Done,
     /*  573685 */   // Label 9394: @573685
     /*  573685 */   GIM_Try, /*On fail goto*//*Label 9395*/ GIMT_Encode4(573760), // Rule ID 3780 //
     /*  573690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  573701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  573704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  573707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573736 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11685:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  573739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573758 */     GIR_RootConstrainSelectedInstOperands,
     /*  573759 */     // GIR_Coverage, 3780,
     /*  573759 */     GIR_EraseRootFromParent_Done,
     /*  573760 */   // Label 9395: @573760
     /*  573760 */   GIM_Try, /*On fail goto*//*Label 9396*/ GIMT_Encode4(573835), // Rule ID 3781 //
     /*  573765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  573776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  573779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  573782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573811 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11685:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  573814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573833 */     GIR_RootConstrainSelectedInstOperands,
     /*  573834 */     // GIR_Coverage, 3781,
     /*  573834 */     GIR_EraseRootFromParent_Done,
     /*  573835 */   // Label 9396: @573835
     /*  573835 */   GIM_Try, /*On fail goto*//*Label 9397*/ GIMT_Encode4(573910), // Rule ID 3784 //
     /*  573840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  573851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  573854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  573857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11685:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  573889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573908 */     GIR_RootConstrainSelectedInstOperands,
     /*  573909 */     // GIR_Coverage, 3784,
     /*  573909 */     GIR_EraseRootFromParent_Done,
     /*  573910 */   // Label 9397: @573910
     /*  573910 */   GIM_Try, /*On fail goto*//*Label 9398*/ GIMT_Encode4(573985), // Rule ID 3785 //
     /*  573915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  573926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  573929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  573932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573961 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11685:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  573964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573983 */     GIR_RootConstrainSelectedInstOperands,
     /*  573984 */     // GIR_Coverage, 3785,
     /*  573984 */     GIR_EraseRootFromParent_Done,
     /*  573985 */   // Label 9398: @573985
     /*  573985 */   GIM_Try, /*On fail goto*//*Label 9399*/ GIMT_Encode4(574060), // Rule ID 3788 //
     /*  573990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  574001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  574004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  574007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574036 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11685:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574058 */     GIR_RootConstrainSelectedInstOperands,
     /*  574059 */     // GIR_Coverage, 3788,
     /*  574059 */     GIR_EraseRootFromParent_Done,
     /*  574060 */   // Label 9399: @574060
     /*  574060 */   GIM_Try, /*On fail goto*//*Label 9400*/ GIMT_Encode4(574135), // Rule ID 3789 //
     /*  574065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  574076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  574079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  574082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574111 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11685:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574133 */     GIR_RootConstrainSelectedInstOperands,
     /*  574134 */     // GIR_Coverage, 3789,
     /*  574134 */     GIR_EraseRootFromParent_Done,
     /*  574135 */   // Label 9400: @574135
     /*  574135 */   GIM_Try, /*On fail goto*//*Label 9401*/ GIMT_Encode4(574210), // Rule ID 3792 //
     /*  574140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  574151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  574154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  574157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574186 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11685:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  574189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574208 */     GIR_RootConstrainSelectedInstOperands,
     /*  574209 */     // GIR_Coverage, 3792,
     /*  574209 */     GIR_EraseRootFromParent_Done,
     /*  574210 */   // Label 9401: @574210
     /*  574210 */   GIM_Try, /*On fail goto*//*Label 9402*/ GIMT_Encode4(574285), // Rule ID 3793 //
     /*  574215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  574226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  574229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  574232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574261 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11685:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  574264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574283 */     GIR_RootConstrainSelectedInstOperands,
     /*  574284 */     // GIR_Coverage, 3793,
     /*  574284 */     GIR_EraseRootFromParent_Done,
     /*  574285 */   // Label 9402: @574285
     /*  574285 */   GIM_Try, /*On fail goto*//*Label 9403*/ GIMT_Encode4(574360), // Rule ID 3796 //
     /*  574290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  574301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  574304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  574307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574336 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11685:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  574339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574358 */     GIR_RootConstrainSelectedInstOperands,
     /*  574359 */     // GIR_Coverage, 3796,
     /*  574359 */     GIR_EraseRootFromParent_Done,
     /*  574360 */   // Label 9403: @574360
     /*  574360 */   GIM_Try, /*On fail goto*//*Label 9404*/ GIMT_Encode4(574435), // Rule ID 3797 //
     /*  574365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  574376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  574379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  574382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574411 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11685:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  574414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574433 */     GIR_RootConstrainSelectedInstOperands,
     /*  574434 */     // GIR_Coverage, 3797,
     /*  574434 */     GIR_EraseRootFromParent_Done,
     /*  574435 */   // Label 9404: @574435
     /*  574435 */   GIM_Try, /*On fail goto*//*Label 9405*/ GIMT_Encode4(574510), // Rule ID 3800 //
     /*  574440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  574451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  574454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  574457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574486 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11685:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  574489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574508 */     GIR_RootConstrainSelectedInstOperands,
     /*  574509 */     // GIR_Coverage, 3800,
     /*  574509 */     GIR_EraseRootFromParent_Done,
     /*  574510 */   // Label 9405: @574510
     /*  574510 */   GIM_Try, /*On fail goto*//*Label 9406*/ GIMT_Encode4(574585), // Rule ID 3801 //
     /*  574515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  574526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  574529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  574532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574561 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11685:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  574564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574583 */     GIR_RootConstrainSelectedInstOperands,
     /*  574584 */     // GIR_Coverage, 3801,
     /*  574584 */     GIR_EraseRootFromParent_Done,
     /*  574585 */   // Label 9406: @574585
     /*  574585 */   GIM_Try, /*On fail goto*//*Label 9407*/ GIMT_Encode4(574660), // Rule ID 3804 //
     /*  574590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  574601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  574604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  574607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11685:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  574639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574658 */     GIR_RootConstrainSelectedInstOperands,
     /*  574659 */     // GIR_Coverage, 3804,
     /*  574659 */     GIR_EraseRootFromParent_Done,
     /*  574660 */   // Label 9407: @574660
     /*  574660 */   GIM_Try, /*On fail goto*//*Label 9408*/ GIMT_Encode4(574735), // Rule ID 3805 //
     /*  574665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  574676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  574679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  574682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574711 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11685:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  574714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574733 */     GIR_RootConstrainSelectedInstOperands,
     /*  574734 */     // GIR_Coverage, 3805,
     /*  574734 */     GIR_EraseRootFromParent_Done,
     /*  574735 */   // Label 9408: @574735
     /*  574735 */   GIM_Try, /*On fail goto*//*Label 9409*/ GIMT_Encode4(574810), // Rule ID 3808 //
     /*  574740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  574751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  574754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  574757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574786 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11685:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574808 */     GIR_RootConstrainSelectedInstOperands,
     /*  574809 */     // GIR_Coverage, 3808,
     /*  574809 */     GIR_EraseRootFromParent_Done,
     /*  574810 */   // Label 9409: @574810
     /*  574810 */   GIM_Try, /*On fail goto*//*Label 9410*/ GIMT_Encode4(574885), // Rule ID 3809 //
     /*  574815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  574826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  574829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  574832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574861 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11685:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574883 */     GIR_RootConstrainSelectedInstOperands,
     /*  574884 */     // GIR_Coverage, 3809,
     /*  574884 */     GIR_EraseRootFromParent_Done,
     /*  574885 */   // Label 9410: @574885
     /*  574885 */   GIM_Try, /*On fail goto*//*Label 9411*/ GIMT_Encode4(574960), // Rule ID 3812 //
     /*  574890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  574901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  574904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  574907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574936 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11685:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  574939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574958 */     GIR_RootConstrainSelectedInstOperands,
     /*  574959 */     // GIR_Coverage, 3812,
     /*  574959 */     GIR_EraseRootFromParent_Done,
     /*  574960 */   // Label 9411: @574960
     /*  574960 */   GIM_Try, /*On fail goto*//*Label 9412*/ GIMT_Encode4(575035), // Rule ID 3813 //
     /*  574965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  574976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  574979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  574982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575011 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11685:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  575011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  575014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575033 */     GIR_RootConstrainSelectedInstOperands,
     /*  575034 */     // GIR_Coverage, 3813,
     /*  575034 */     GIR_EraseRootFromParent_Done,
     /*  575035 */   // Label 9412: @575035
     /*  575035 */   GIM_Try, /*On fail goto*//*Label 9413*/ GIMT_Encode4(575110), // Rule ID 3816 //
     /*  575040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  575051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  575054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  575057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11685:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  575089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575108 */     GIR_RootConstrainSelectedInstOperands,
     /*  575109 */     // GIR_Coverage, 3816,
     /*  575109 */     GIR_EraseRootFromParent_Done,
     /*  575110 */   // Label 9413: @575110
     /*  575110 */   GIM_Try, /*On fail goto*//*Label 9414*/ GIMT_Encode4(575185), // Rule ID 3817 //
     /*  575115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  575126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  575129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  575132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575161 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11685:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  575164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575183 */     GIR_RootConstrainSelectedInstOperands,
     /*  575184 */     // GIR_Coverage, 3817,
     /*  575184 */     GIR_EraseRootFromParent_Done,
     /*  575185 */   // Label 9414: @575185
     /*  575185 */   GIM_Try, /*On fail goto*//*Label 9415*/ GIMT_Encode4(575260), // Rule ID 3820 //
     /*  575190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  575201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  575204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  575207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575236 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11685:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  575239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575258 */     GIR_RootConstrainSelectedInstOperands,
     /*  575259 */     // GIR_Coverage, 3820,
     /*  575259 */     GIR_EraseRootFromParent_Done,
     /*  575260 */   // Label 9415: @575260
     /*  575260 */   GIM_Try, /*On fail goto*//*Label 9416*/ GIMT_Encode4(575335), // Rule ID 3821 //
     /*  575265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  575276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  575279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  575282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11685:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  575314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575333 */     GIR_RootConstrainSelectedInstOperands,
     /*  575334 */     // GIR_Coverage, 3821,
     /*  575334 */     GIR_EraseRootFromParent_Done,
     /*  575335 */   // Label 9416: @575335
     /*  575335 */   GIM_Try, /*On fail goto*//*Label 9417*/ GIMT_Encode4(575410), // Rule ID 3824 //
     /*  575340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  575351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  575354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  575357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575386 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11685:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  575389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575408 */     GIR_RootConstrainSelectedInstOperands,
     /*  575409 */     // GIR_Coverage, 3824,
     /*  575409 */     GIR_EraseRootFromParent_Done,
     /*  575410 */   // Label 9417: @575410
     /*  575410 */   GIM_Try, /*On fail goto*//*Label 9418*/ GIMT_Encode4(575485), // Rule ID 3825 //
     /*  575415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  575426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  575429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  575432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575461 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11685:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  575464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575483 */     GIR_RootConstrainSelectedInstOperands,
     /*  575484 */     // GIR_Coverage, 3825,
     /*  575484 */     GIR_EraseRootFromParent_Done,
     /*  575485 */   // Label 9418: @575485
     /*  575485 */   GIM_Try, /*On fail goto*//*Label 9419*/ GIMT_Encode4(575560), // Rule ID 3828 //
     /*  575490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  575501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  575504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  575507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11685:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  575539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575558 */     GIR_RootConstrainSelectedInstOperands,
     /*  575559 */     // GIR_Coverage, 3828,
     /*  575559 */     GIR_EraseRootFromParent_Done,
     /*  575560 */   // Label 9419: @575560
     /*  575560 */   GIM_Try, /*On fail goto*//*Label 9420*/ GIMT_Encode4(575635), // Rule ID 3829 //
     /*  575565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  575576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  575579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  575582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575611 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11685:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  575614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575633 */     GIR_RootConstrainSelectedInstOperands,
     /*  575634 */     // GIR_Coverage, 3829,
     /*  575634 */     GIR_EraseRootFromParent_Done,
     /*  575635 */   // Label 9420: @575635
     /*  575635 */   GIM_Try, /*On fail goto*//*Label 9421*/ GIMT_Encode4(575710), // Rule ID 3832 //
     /*  575640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  575651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  575654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  575657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  575660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575686 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  575689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575708 */     GIR_RootConstrainSelectedInstOperands,
     /*  575709 */     // GIR_Coverage, 3832,
     /*  575709 */     GIR_EraseRootFromParent_Done,
     /*  575710 */   // Label 9421: @575710
     /*  575710 */   GIM_Try, /*On fail goto*//*Label 9422*/ GIMT_Encode4(575785), // Rule ID 3833 //
     /*  575715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  575726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  575729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  575732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  575735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575761 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  575764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575783 */     GIR_RootConstrainSelectedInstOperands,
     /*  575784 */     // GIR_Coverage, 3833,
     /*  575784 */     GIR_EraseRootFromParent_Done,
     /*  575785 */   // Label 9422: @575785
     /*  575785 */   GIM_Try, /*On fail goto*//*Label 9423*/ GIMT_Encode4(575860), // Rule ID 3836 //
     /*  575790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  575801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  575804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  575807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  575810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575836 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  575839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575858 */     GIR_RootConstrainSelectedInstOperands,
     /*  575859 */     // GIR_Coverage, 3836,
     /*  575859 */     GIR_EraseRootFromParent_Done,
     /*  575860 */   // Label 9423: @575860
     /*  575860 */   GIM_Try, /*On fail goto*//*Label 9424*/ GIMT_Encode4(575935), // Rule ID 3837 //
     /*  575865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  575876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  575879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  575882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  575885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575911 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  575914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575933 */     GIR_RootConstrainSelectedInstOperands,
     /*  575934 */     // GIR_Coverage, 3837,
     /*  575934 */     GIR_EraseRootFromParent_Done,
     /*  575935 */   // Label 9424: @575935
     /*  575935 */   GIM_Try, /*On fail goto*//*Label 9425*/ GIMT_Encode4(576010), // Rule ID 3840 //
     /*  575940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  575951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  575954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  575957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  575960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575986 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  575989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576008 */     GIR_RootConstrainSelectedInstOperands,
     /*  576009 */     // GIR_Coverage, 3840,
     /*  576009 */     GIR_EraseRootFromParent_Done,
     /*  576010 */   // Label 9425: @576010
     /*  576010 */   GIM_Try, /*On fail goto*//*Label 9426*/ GIMT_Encode4(576085), // Rule ID 3841 //
     /*  576015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  576026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  576029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  576032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  576035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576061 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576083 */     GIR_RootConstrainSelectedInstOperands,
     /*  576084 */     // GIR_Coverage, 3841,
     /*  576084 */     GIR_EraseRootFromParent_Done,
     /*  576085 */   // Label 9426: @576085
     /*  576085 */   GIM_Try, /*On fail goto*//*Label 9427*/ GIMT_Encode4(576160), // Rule ID 3844 //
     /*  576090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  576101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  576104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  576107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  576110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576136 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576158 */     GIR_RootConstrainSelectedInstOperands,
     /*  576159 */     // GIR_Coverage, 3844,
     /*  576159 */     GIR_EraseRootFromParent_Done,
     /*  576160 */   // Label 9427: @576160
     /*  576160 */   GIM_Try, /*On fail goto*//*Label 9428*/ GIMT_Encode4(576235), // Rule ID 3845 //
     /*  576165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  576176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  576179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  576182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  576185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576211 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576233 */     GIR_RootConstrainSelectedInstOperands,
     /*  576234 */     // GIR_Coverage, 3845,
     /*  576234 */     GIR_EraseRootFromParent_Done,
     /*  576235 */   // Label 9428: @576235
     /*  576235 */   GIM_Try, /*On fail goto*//*Label 9429*/ GIMT_Encode4(576310), // Rule ID 3848 //
     /*  576240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  576251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  576254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  576257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  576260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576286 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  576289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576308 */     GIR_RootConstrainSelectedInstOperands,
     /*  576309 */     // GIR_Coverage, 3848,
     /*  576309 */     GIR_EraseRootFromParent_Done,
     /*  576310 */   // Label 9429: @576310
     /*  576310 */   GIM_Try, /*On fail goto*//*Label 9430*/ GIMT_Encode4(576385), // Rule ID 3849 //
     /*  576315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  576326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  576329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  576332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  576335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576361 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  576364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576383 */     GIR_RootConstrainSelectedInstOperands,
     /*  576384 */     // GIR_Coverage, 3849,
     /*  576384 */     GIR_EraseRootFromParent_Done,
     /*  576385 */   // Label 9430: @576385
     /*  576385 */   GIM_Try, /*On fail goto*//*Label 9431*/ GIMT_Encode4(576460), // Rule ID 3852 //
     /*  576390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  576401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  576404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  576407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  576410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576436 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  576439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576458 */     GIR_RootConstrainSelectedInstOperands,
     /*  576459 */     // GIR_Coverage, 3852,
     /*  576459 */     GIR_EraseRootFromParent_Done,
     /*  576460 */   // Label 9431: @576460
     /*  576460 */   GIM_Try, /*On fail goto*//*Label 9432*/ GIMT_Encode4(576535), // Rule ID 3853 //
     /*  576465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  576476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  576479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  576482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  576485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576511 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  576514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576533 */     GIR_RootConstrainSelectedInstOperands,
     /*  576534 */     // GIR_Coverage, 3853,
     /*  576534 */     GIR_EraseRootFromParent_Done,
     /*  576535 */   // Label 9432: @576535
     /*  576535 */   GIM_Try, /*On fail goto*//*Label 9433*/ GIMT_Encode4(576610), // Rule ID 3856 //
     /*  576540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  576551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  576554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  576557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  576560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  576589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576608 */     GIR_RootConstrainSelectedInstOperands,
     /*  576609 */     // GIR_Coverage, 3856,
     /*  576609 */     GIR_EraseRootFromParent_Done,
     /*  576610 */   // Label 9433: @576610
     /*  576610 */   GIM_Try, /*On fail goto*//*Label 9434*/ GIMT_Encode4(576685), // Rule ID 3857 //
     /*  576615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  576626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  576629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  576632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  576635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576661 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  576664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576683 */     GIR_RootConstrainSelectedInstOperands,
     /*  576684 */     // GIR_Coverage, 3857,
     /*  576684 */     GIR_EraseRootFromParent_Done,
     /*  576685 */   // Label 9434: @576685
     /*  576685 */   GIM_Try, /*On fail goto*//*Label 9435*/ GIMT_Encode4(576760), // Rule ID 3860 //
     /*  576690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  576701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  576704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  576707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  576710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576758 */     GIR_RootConstrainSelectedInstOperands,
     /*  576759 */     // GIR_Coverage, 3860,
     /*  576759 */     GIR_EraseRootFromParent_Done,
     /*  576760 */   // Label 9435: @576760
     /*  576760 */   GIM_Try, /*On fail goto*//*Label 9436*/ GIMT_Encode4(576835), // Rule ID 3861 //
     /*  576765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  576776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  576779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  576782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  576785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576811 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576833 */     GIR_RootConstrainSelectedInstOperands,
     /*  576834 */     // GIR_Coverage, 3861,
     /*  576834 */     GIR_EraseRootFromParent_Done,
     /*  576835 */   // Label 9436: @576835
     /*  576835 */   GIM_Try, /*On fail goto*//*Label 9437*/ GIMT_Encode4(576910), // Rule ID 3864 //
     /*  576840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  576851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  576854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  576857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  576860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576886 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576908 */     GIR_RootConstrainSelectedInstOperands,
     /*  576909 */     // GIR_Coverage, 3864,
     /*  576909 */     GIR_EraseRootFromParent_Done,
     /*  576910 */   // Label 9437: @576910
     /*  576910 */   GIM_Try, /*On fail goto*//*Label 9438*/ GIMT_Encode4(576985), // Rule ID 3865 //
     /*  576915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  576926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  576929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  576932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  576935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576961 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576983 */     GIR_RootConstrainSelectedInstOperands,
     /*  576984 */     // GIR_Coverage, 3865,
     /*  576984 */     GIR_EraseRootFromParent_Done,
     /*  576985 */   // Label 9438: @576985
     /*  576985 */   GIM_Try, /*On fail goto*//*Label 9439*/ GIMT_Encode4(577060), // Rule ID 3868 //
     /*  576990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  577001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  577004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  577007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  577010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577058 */     GIR_RootConstrainSelectedInstOperands,
     /*  577059 */     // GIR_Coverage, 3868,
     /*  577059 */     GIR_EraseRootFromParent_Done,
     /*  577060 */   // Label 9439: @577060
     /*  577060 */   GIM_Try, /*On fail goto*//*Label 9440*/ GIMT_Encode4(577135), // Rule ID 3869 //
     /*  577065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  577076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  577079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  577082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  577085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577111 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577133 */     GIR_RootConstrainSelectedInstOperands,
     /*  577134 */     // GIR_Coverage, 3869,
     /*  577134 */     GIR_EraseRootFromParent_Done,
     /*  577135 */   // Label 9440: @577135
     /*  577135 */   GIM_Try, /*On fail goto*//*Label 9441*/ GIMT_Encode4(577210), // Rule ID 3872 //
     /*  577140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  577151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  577154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  577157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  577160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577208 */     GIR_RootConstrainSelectedInstOperands,
     /*  577209 */     // GIR_Coverage, 3872,
     /*  577209 */     GIR_EraseRootFromParent_Done,
     /*  577210 */   // Label 9441: @577210
     /*  577210 */   GIM_Try, /*On fail goto*//*Label 9442*/ GIMT_Encode4(577285), // Rule ID 3873 //
     /*  577215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  577226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  577229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  577232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  577235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577261 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577283 */     GIR_RootConstrainSelectedInstOperands,
     /*  577284 */     // GIR_Coverage, 3873,
     /*  577284 */     GIR_EraseRootFromParent_Done,
     /*  577285 */   // Label 9442: @577285
     /*  577285 */   GIM_Try, /*On fail goto*//*Label 9443*/ GIMT_Encode4(577360), // Rule ID 3876 //
     /*  577290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  577301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  577304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  577307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  577310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  577339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577358 */     GIR_RootConstrainSelectedInstOperands,
     /*  577359 */     // GIR_Coverage, 3876,
     /*  577359 */     GIR_EraseRootFromParent_Done,
     /*  577360 */   // Label 9443: @577360
     /*  577360 */   GIM_Try, /*On fail goto*//*Label 9444*/ GIMT_Encode4(577435), // Rule ID 3877 //
     /*  577365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  577376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  577379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  577382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  577385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577411 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  577414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577433 */     GIR_RootConstrainSelectedInstOperands,
     /*  577434 */     // GIR_Coverage, 3877,
     /*  577434 */     GIR_EraseRootFromParent_Done,
     /*  577435 */   // Label 9444: @577435
     /*  577435 */   GIM_Try, /*On fail goto*//*Label 9445*/ GIMT_Encode4(577510), // Rule ID 3880 //
     /*  577440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  577451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  577454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  577457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  577460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  577489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577508 */     GIR_RootConstrainSelectedInstOperands,
     /*  577509 */     // GIR_Coverage, 3880,
     /*  577509 */     GIR_EraseRootFromParent_Done,
     /*  577510 */   // Label 9445: @577510
     /*  577510 */   GIM_Try, /*On fail goto*//*Label 9446*/ GIMT_Encode4(577585), // Rule ID 3881 //
     /*  577515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  577526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  577529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  577532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  577535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577561 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  577564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577583 */     GIR_RootConstrainSelectedInstOperands,
     /*  577584 */     // GIR_Coverage, 3881,
     /*  577584 */     GIR_EraseRootFromParent_Done,
     /*  577585 */   // Label 9446: @577585
     /*  577585 */   GIM_Try, /*On fail goto*//*Label 9447*/ GIMT_Encode4(577660), // Rule ID 3884 //
     /*  577590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  577601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  577604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  577607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  577610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577636 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577658 */     GIR_RootConstrainSelectedInstOperands,
     /*  577659 */     // GIR_Coverage, 3884,
     /*  577659 */     GIR_EraseRootFromParent_Done,
     /*  577660 */   // Label 9447: @577660
     /*  577660 */   GIM_Try, /*On fail goto*//*Label 9448*/ GIMT_Encode4(577735), // Rule ID 3885 //
     /*  577665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  577676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  577679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  577682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  577685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577711 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577733 */     GIR_RootConstrainSelectedInstOperands,
     /*  577734 */     // GIR_Coverage, 3885,
     /*  577734 */     GIR_EraseRootFromParent_Done,
     /*  577735 */   // Label 9448: @577735
     /*  577735 */   GIM_Try, /*On fail goto*//*Label 9449*/ GIMT_Encode4(577810), // Rule ID 3888 //
     /*  577740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  577751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  577754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  577757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  577760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577808 */     GIR_RootConstrainSelectedInstOperands,
     /*  577809 */     // GIR_Coverage, 3888,
     /*  577809 */     GIR_EraseRootFromParent_Done,
     /*  577810 */   // Label 9449: @577810
     /*  577810 */   GIM_Try, /*On fail goto*//*Label 9450*/ GIMT_Encode4(577885), // Rule ID 3889 //
     /*  577815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  577826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  577829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  577832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  577835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577861 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577883 */     GIR_RootConstrainSelectedInstOperands,
     /*  577884 */     // GIR_Coverage, 3889,
     /*  577884 */     GIR_EraseRootFromParent_Done,
     /*  577885 */   // Label 9450: @577885
     /*  577885 */   GIM_Try, /*On fail goto*//*Label 9451*/ GIMT_Encode4(577960), // Rule ID 3892 //
     /*  577890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  577901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  577904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  577907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577936 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  577939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577958 */     GIR_RootConstrainSelectedInstOperands,
     /*  577959 */     // GIR_Coverage, 3892,
     /*  577959 */     GIR_EraseRootFromParent_Done,
     /*  577960 */   // Label 9451: @577960
     /*  577960 */   GIM_Try, /*On fail goto*//*Label 9452*/ GIMT_Encode4(578035), // Rule ID 3893 //
     /*  577965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  577976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  577979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  577982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578011 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  578014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578033 */     GIR_RootConstrainSelectedInstOperands,
     /*  578034 */     // GIR_Coverage, 3893,
     /*  578034 */     GIR_EraseRootFromParent_Done,
     /*  578035 */   // Label 9452: @578035
     /*  578035 */   GIM_Try, /*On fail goto*//*Label 9453*/ GIMT_Encode4(578110), // Rule ID 3896 //
     /*  578040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  578051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  578054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  578057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578108 */     GIR_RootConstrainSelectedInstOperands,
     /*  578109 */     // GIR_Coverage, 3896,
     /*  578109 */     GIR_EraseRootFromParent_Done,
     /*  578110 */   // Label 9453: @578110
     /*  578110 */   GIM_Try, /*On fail goto*//*Label 9454*/ GIMT_Encode4(578185), // Rule ID 3897 //
     /*  578115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  578126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  578129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  578132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578161 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578183 */     GIR_RootConstrainSelectedInstOperands,
     /*  578184 */     // GIR_Coverage, 3897,
     /*  578184 */     GIR_EraseRootFromParent_Done,
     /*  578185 */   // Label 9454: @578185
     /*  578185 */   GIM_Try, /*On fail goto*//*Label 9455*/ GIMT_Encode4(578260), // Rule ID 3900 //
     /*  578190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  578201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  578204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  578207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578236 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  578239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578258 */     GIR_RootConstrainSelectedInstOperands,
     /*  578259 */     // GIR_Coverage, 3900,
     /*  578259 */     GIR_EraseRootFromParent_Done,
     /*  578260 */   // Label 9455: @578260
     /*  578260 */   GIM_Try, /*On fail goto*//*Label 9456*/ GIMT_Encode4(578335), // Rule ID 3901 //
     /*  578265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  578276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  578279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  578282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578311 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  578314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578333 */     GIR_RootConstrainSelectedInstOperands,
     /*  578334 */     // GIR_Coverage, 3901,
     /*  578334 */     GIR_EraseRootFromParent_Done,
     /*  578335 */   // Label 9456: @578335
     /*  578335 */   GIM_Try, /*On fail goto*//*Label 9457*/ GIMT_Encode4(578410), // Rule ID 3904 //
     /*  578340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  578351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  578354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  578357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578386 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  578389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578408 */     GIR_RootConstrainSelectedInstOperands,
     /*  578409 */     // GIR_Coverage, 3904,
     /*  578409 */     GIR_EraseRootFromParent_Done,
     /*  578410 */   // Label 9457: @578410
     /*  578410 */   GIM_Try, /*On fail goto*//*Label 9458*/ GIMT_Encode4(578485), // Rule ID 3905 //
     /*  578415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  578426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  578429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  578432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578461 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  578464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578483 */     GIR_RootConstrainSelectedInstOperands,
     /*  578484 */     // GIR_Coverage, 3905,
     /*  578484 */     GIR_EraseRootFromParent_Done,
     /*  578485 */   // Label 9458: @578485
     /*  578485 */   GIM_Try, /*On fail goto*//*Label 9459*/ GIMT_Encode4(578560), // Rule ID 3908 //
     /*  578490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  578501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  578504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  578507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578536 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  578539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578558 */     GIR_RootConstrainSelectedInstOperands,
     /*  578559 */     // GIR_Coverage, 3908,
     /*  578559 */     GIR_EraseRootFromParent_Done,
     /*  578560 */   // Label 9459: @578560
     /*  578560 */   GIM_Try, /*On fail goto*//*Label 9460*/ GIMT_Encode4(578635), // Rule ID 3909 //
     /*  578565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  578576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  578579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  578582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578611 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  578614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578633 */     GIR_RootConstrainSelectedInstOperands,
     /*  578634 */     // GIR_Coverage, 3909,
     /*  578634 */     GIR_EraseRootFromParent_Done,
     /*  578635 */   // Label 9460: @578635
     /*  578635 */   GIM_Try, /*On fail goto*//*Label 9461*/ GIMT_Encode4(578710), // Rule ID 3912 //
     /*  578640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  578651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  578654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  578657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578686 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  578689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578708 */     GIR_RootConstrainSelectedInstOperands,
     /*  578709 */     // GIR_Coverage, 3912,
     /*  578709 */     GIR_EraseRootFromParent_Done,
     /*  578710 */   // Label 9461: @578710
     /*  578710 */   GIM_Try, /*On fail goto*//*Label 9462*/ GIMT_Encode4(578785), // Rule ID 3913 //
     /*  578715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  578726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  578729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  578732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578761 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  578764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578783 */     GIR_RootConstrainSelectedInstOperands,
     /*  578784 */     // GIR_Coverage, 3913,
     /*  578784 */     GIR_EraseRootFromParent_Done,
     /*  578785 */   // Label 9462: @578785
     /*  578785 */   GIM_Try, /*On fail goto*//*Label 9463*/ GIMT_Encode4(578860), // Rule ID 3916 //
     /*  578790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  578801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  578804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  578807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578836 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578858 */     GIR_RootConstrainSelectedInstOperands,
     /*  578859 */     // GIR_Coverage, 3916,
     /*  578859 */     GIR_EraseRootFromParent_Done,
     /*  578860 */   // Label 9463: @578860
     /*  578860 */   GIM_Try, /*On fail goto*//*Label 9464*/ GIMT_Encode4(578935), // Rule ID 3917 //
     /*  578865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  578876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  578879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  578882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578911 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578933 */     GIR_RootConstrainSelectedInstOperands,
     /*  578934 */     // GIR_Coverage, 3917,
     /*  578934 */     GIR_EraseRootFromParent_Done,
     /*  578935 */   // Label 9464: @578935
     /*  578935 */   GIM_Try, /*On fail goto*//*Label 9465*/ GIMT_Encode4(579010), // Rule ID 3920 //
     /*  578940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  578951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  578954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  578957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578986 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  578989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579008 */     GIR_RootConstrainSelectedInstOperands,
     /*  579009 */     // GIR_Coverage, 3920,
     /*  579009 */     GIR_EraseRootFromParent_Done,
     /*  579010 */   // Label 9465: @579010
     /*  579010 */   GIM_Try, /*On fail goto*//*Label 9466*/ GIMT_Encode4(579085), // Rule ID 3921 //
     /*  579015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  579026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  579029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  579032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579061 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  579064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579083 */     GIR_RootConstrainSelectedInstOperands,
     /*  579084 */     // GIR_Coverage, 3921,
     /*  579084 */     GIR_EraseRootFromParent_Done,
     /*  579085 */   // Label 9466: @579085
     /*  579085 */   GIM_Try, /*On fail goto*//*Label 9467*/ GIMT_Encode4(579160), // Rule ID 3924 //
     /*  579090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  579101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  579104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  579107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579158 */     GIR_RootConstrainSelectedInstOperands,
     /*  579159 */     // GIR_Coverage, 3924,
     /*  579159 */     GIR_EraseRootFromParent_Done,
     /*  579160 */   // Label 9467: @579160
     /*  579160 */   GIM_Try, /*On fail goto*//*Label 9468*/ GIMT_Encode4(579235), // Rule ID 3925 //
     /*  579165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  579176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  579179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  579182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579233 */     GIR_RootConstrainSelectedInstOperands,
     /*  579234 */     // GIR_Coverage, 3925,
     /*  579234 */     GIR_EraseRootFromParent_Done,
     /*  579235 */   // Label 9468: @579235
     /*  579235 */   GIM_Try, /*On fail goto*//*Label 9469*/ GIMT_Encode4(579310), // Rule ID 3928 //
     /*  579240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  579251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  579254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  579257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579286 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579308 */     GIR_RootConstrainSelectedInstOperands,
     /*  579309 */     // GIR_Coverage, 3928,
     /*  579309 */     GIR_EraseRootFromParent_Done,
     /*  579310 */   // Label 9469: @579310
     /*  579310 */   GIM_Try, /*On fail goto*//*Label 9470*/ GIMT_Encode4(579385), // Rule ID 3929 //
     /*  579315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  579326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  579329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  579332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579361 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579383 */     GIR_RootConstrainSelectedInstOperands,
     /*  579384 */     // GIR_Coverage, 3929,
     /*  579384 */     GIR_EraseRootFromParent_Done,
     /*  579385 */   // Label 9470: @579385
     /*  579385 */   GIM_Try, /*On fail goto*//*Label 9471*/ GIMT_Encode4(579460), // Rule ID 3932 //
     /*  579390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  579401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  579404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  579407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579436 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579458 */     GIR_RootConstrainSelectedInstOperands,
     /*  579459 */     // GIR_Coverage, 3932,
     /*  579459 */     GIR_EraseRootFromParent_Done,
     /*  579460 */   // Label 9471: @579460
     /*  579460 */   GIM_Try, /*On fail goto*//*Label 9472*/ GIMT_Encode4(579535), // Rule ID 3933 //
     /*  579465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  579476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  579479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  579482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579511 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579533 */     GIR_RootConstrainSelectedInstOperands,
     /*  579534 */     // GIR_Coverage, 3933,
     /*  579534 */     GIR_EraseRootFromParent_Done,
     /*  579535 */   // Label 9472: @579535
     /*  579535 */   GIM_Try, /*On fail goto*//*Label 9473*/ GIMT_Encode4(579610), // Rule ID 3936 //
     /*  579540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  579551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  579554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  579557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579586 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  579589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579608 */     GIR_RootConstrainSelectedInstOperands,
     /*  579609 */     // GIR_Coverage, 3936,
     /*  579609 */     GIR_EraseRootFromParent_Done,
     /*  579610 */   // Label 9473: @579610
     /*  579610 */   GIM_Try, /*On fail goto*//*Label 9474*/ GIMT_Encode4(579685), // Rule ID 3937 //
     /*  579615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  579626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  579629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  579632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579661 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  579664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579683 */     GIR_RootConstrainSelectedInstOperands,
     /*  579684 */     // GIR_Coverage, 3937,
     /*  579684 */     GIR_EraseRootFromParent_Done,
     /*  579685 */   // Label 9474: @579685
     /*  579685 */   GIM_Try, /*On fail goto*//*Label 9475*/ GIMT_Encode4(579760), // Rule ID 3940 //
     /*  579690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  579701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  579704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  579707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579736 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579758 */     GIR_RootConstrainSelectedInstOperands,
     /*  579759 */     // GIR_Coverage, 3940,
     /*  579759 */     GIR_EraseRootFromParent_Done,
     /*  579760 */   // Label 9475: @579760
     /*  579760 */   GIM_Try, /*On fail goto*//*Label 9476*/ GIMT_Encode4(579835), // Rule ID 3941 //
     /*  579765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  579776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  579779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  579782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579811 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579833 */     GIR_RootConstrainSelectedInstOperands,
     /*  579834 */     // GIR_Coverage, 3941,
     /*  579834 */     GIR_EraseRootFromParent_Done,
     /*  579835 */   // Label 9476: @579835
     /*  579835 */   GIM_Try, /*On fail goto*//*Label 9477*/ GIMT_Encode4(579910), // Rule ID 3944 //
     /*  579840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  579851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  579854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  579857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579886 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579908 */     GIR_RootConstrainSelectedInstOperands,
     /*  579909 */     // GIR_Coverage, 3944,
     /*  579909 */     GIR_EraseRootFromParent_Done,
     /*  579910 */   // Label 9477: @579910
     /*  579910 */   GIM_Try, /*On fail goto*//*Label 9478*/ GIMT_Encode4(579985), // Rule ID 3945 //
     /*  579915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  579926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  579929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  579932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579961 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579983 */     GIR_RootConstrainSelectedInstOperands,
     /*  579984 */     // GIR_Coverage, 3945,
     /*  579984 */     GIR_EraseRootFromParent_Done,
     /*  579985 */   // Label 9478: @579985
     /*  579985 */   GIM_Try, /*On fail goto*//*Label 9479*/ GIMT_Encode4(580060), // Rule ID 3948 //
     /*  579990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  580001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  580004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  580007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580036 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  580036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  580039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580058 */     GIR_RootConstrainSelectedInstOperands,
     /*  580059 */     // GIR_Coverage, 3948,
     /*  580059 */     GIR_EraseRootFromParent_Done,
     /*  580060 */   // Label 9479: @580060
     /*  580060 */   GIM_Try, /*On fail goto*//*Label 9480*/ GIMT_Encode4(580135), // Rule ID 3949 //
     /*  580065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  580068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  580076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  580079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  580082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580111 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  580111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  580114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580133 */     GIR_RootConstrainSelectedInstOperands,
     /*  580134 */     // GIR_Coverage, 3949,
     /*  580134 */     GIR_EraseRootFromParent_Done,
     /*  580135 */   // Label 9480: @580135
     /*  580135 */   GIM_Try, /*On fail goto*//*Label 9481*/ GIMT_Encode4(580210), // Rule ID 3952 //
     /*  580140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  580151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  580154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  580157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  580160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580186 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11681:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  580189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580208 */     GIR_RootConstrainSelectedInstOperands,
     /*  580209 */     // GIR_Coverage, 3952,
     /*  580209 */     GIR_EraseRootFromParent_Done,
     /*  580210 */   // Label 9481: @580210
     /*  580210 */   GIM_Try, /*On fail goto*//*Label 9482*/ GIMT_Encode4(580285), // Rule ID 3953 //
     /*  580215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  580226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  580229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  580232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  580235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580261 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11681:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  580264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580283 */     GIR_RootConstrainSelectedInstOperands,
     /*  580284 */     // GIR_Coverage, 3953,
     /*  580284 */     GIR_EraseRootFromParent_Done,
     /*  580285 */   // Label 9482: @580285
     /*  580285 */   GIM_Try, /*On fail goto*//*Label 9483*/ GIMT_Encode4(580360), // Rule ID 3956 //
     /*  580290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  580301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  580304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  580307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  580310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580336 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11681:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  580339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580358 */     GIR_RootConstrainSelectedInstOperands,
     /*  580359 */     // GIR_Coverage, 3956,
     /*  580359 */     GIR_EraseRootFromParent_Done,
     /*  580360 */   // Label 9483: @580360
     /*  580360 */   GIM_Try, /*On fail goto*//*Label 9484*/ GIMT_Encode4(580435), // Rule ID 3957 //
     /*  580365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  580376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  580379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  580382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  580385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580411 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11681:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  580414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580433 */     GIR_RootConstrainSelectedInstOperands,
     /*  580434 */     // GIR_Coverage, 3957,
     /*  580434 */     GIR_EraseRootFromParent_Done,
     /*  580435 */   // Label 9484: @580435
     /*  580435 */   GIM_Try, /*On fail goto*//*Label 9485*/ GIMT_Encode4(580510), // Rule ID 3960 //
     /*  580440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  580451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  580454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  580457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  580460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580486 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11681:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  580489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580508 */     GIR_RootConstrainSelectedInstOperands,
     /*  580509 */     // GIR_Coverage, 3960,
     /*  580509 */     GIR_EraseRootFromParent_Done,
     /*  580510 */   // Label 9485: @580510
     /*  580510 */   GIM_Try, /*On fail goto*//*Label 9486*/ GIMT_Encode4(580585), // Rule ID 3961 //
     /*  580515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  580526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  580529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  580532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  580535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580561 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11681:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  580564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580583 */     GIR_RootConstrainSelectedInstOperands,
     /*  580584 */     // GIR_Coverage, 3961,
     /*  580584 */     GIR_EraseRootFromParent_Done,
     /*  580585 */   // Label 9486: @580585
     /*  580585 */   GIM_Try, /*On fail goto*//*Label 9487*/ GIMT_Encode4(580660), // Rule ID 3964 //
     /*  580590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  580601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  580604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  580607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  580610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580636 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11681:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  580639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580658 */     GIR_RootConstrainSelectedInstOperands,
     /*  580659 */     // GIR_Coverage, 3964,
     /*  580659 */     GIR_EraseRootFromParent_Done,
     /*  580660 */   // Label 9487: @580660
     /*  580660 */   GIM_Try, /*On fail goto*//*Label 9488*/ GIMT_Encode4(580735), // Rule ID 3965 //
     /*  580665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  580676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  580679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  580682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  580685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580711 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11681:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  580714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580733 */     GIR_RootConstrainSelectedInstOperands,
     /*  580734 */     // GIR_Coverage, 3965,
     /*  580734 */     GIR_EraseRootFromParent_Done,
     /*  580735 */   // Label 9488: @580735
     /*  580735 */   GIM_Try, /*On fail goto*//*Label 9489*/ GIMT_Encode4(580810), // Rule ID 3968 //
     /*  580740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  580751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  580754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  580757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  580760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580786 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11681:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  580789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580808 */     GIR_RootConstrainSelectedInstOperands,
     /*  580809 */     // GIR_Coverage, 3968,
     /*  580809 */     GIR_EraseRootFromParent_Done,
     /*  580810 */   // Label 9489: @580810
     /*  580810 */   GIM_Try, /*On fail goto*//*Label 9490*/ GIMT_Encode4(580885), // Rule ID 3969 //
     /*  580815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  580826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  580829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  580832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  580835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580861 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11681:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  580864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580883 */     GIR_RootConstrainSelectedInstOperands,
     /*  580884 */     // GIR_Coverage, 3969,
     /*  580884 */     GIR_EraseRootFromParent_Done,
     /*  580885 */   // Label 9490: @580885
     /*  580885 */   GIM_Try, /*On fail goto*//*Label 9491*/ GIMT_Encode4(580960), // Rule ID 3972 //
     /*  580890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  580901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  580904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  580907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  580910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580936 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11681:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  580939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580958 */     GIR_RootConstrainSelectedInstOperands,
     /*  580959 */     // GIR_Coverage, 3972,
     /*  580959 */     GIR_EraseRootFromParent_Done,
     /*  580960 */   // Label 9491: @580960
     /*  580960 */   GIM_Try, /*On fail goto*//*Label 9492*/ GIMT_Encode4(581035), // Rule ID 3973 //
     /*  580965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  580976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  580979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  580982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  580985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581011 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11681:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581033 */     GIR_RootConstrainSelectedInstOperands,
     /*  581034 */     // GIR_Coverage, 3973,
     /*  581034 */     GIR_EraseRootFromParent_Done,
     /*  581035 */   // Label 9492: @581035
     /*  581035 */   GIM_Try, /*On fail goto*//*Label 9493*/ GIMT_Encode4(581110), // Rule ID 3976 //
     /*  581040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  581051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  581054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  581057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  581060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11681:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  581089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581108 */     GIR_RootConstrainSelectedInstOperands,
     /*  581109 */     // GIR_Coverage, 3976,
     /*  581109 */     GIR_EraseRootFromParent_Done,
     /*  581110 */   // Label 9493: @581110
     /*  581110 */   GIM_Try, /*On fail goto*//*Label 9494*/ GIMT_Encode4(581185), // Rule ID 3977 //
     /*  581115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  581126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  581129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  581132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  581135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581161 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11681:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  581164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581183 */     GIR_RootConstrainSelectedInstOperands,
     /*  581184 */     // GIR_Coverage, 3977,
     /*  581184 */     GIR_EraseRootFromParent_Done,
     /*  581185 */   // Label 9494: @581185
     /*  581185 */   GIM_Try, /*On fail goto*//*Label 9495*/ GIMT_Encode4(581260), // Rule ID 3980 //
     /*  581190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  581201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  581204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  581207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  581210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11681:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581258 */     GIR_RootConstrainSelectedInstOperands,
     /*  581259 */     // GIR_Coverage, 3980,
     /*  581259 */     GIR_EraseRootFromParent_Done,
     /*  581260 */   // Label 9495: @581260
     /*  581260 */   GIM_Try, /*On fail goto*//*Label 9496*/ GIMT_Encode4(581335), // Rule ID 3981 //
     /*  581265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  581276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  581279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  581282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  581285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581311 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11681:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581333 */     GIR_RootConstrainSelectedInstOperands,
     /*  581334 */     // GIR_Coverage, 3981,
     /*  581334 */     GIR_EraseRootFromParent_Done,
     /*  581335 */   // Label 9496: @581335
     /*  581335 */   GIM_Try, /*On fail goto*//*Label 9497*/ GIMT_Encode4(581410), // Rule ID 3984 //
     /*  581340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  581351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  581354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  581357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  581360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581386 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11681:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581408 */     GIR_RootConstrainSelectedInstOperands,
     /*  581409 */     // GIR_Coverage, 3984,
     /*  581409 */     GIR_EraseRootFromParent_Done,
     /*  581410 */   // Label 9497: @581410
     /*  581410 */   GIM_Try, /*On fail goto*//*Label 9498*/ GIMT_Encode4(581485), // Rule ID 3985 //
     /*  581415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  581426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  581429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  581432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  581435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581461 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11681:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581483 */     GIR_RootConstrainSelectedInstOperands,
     /*  581484 */     // GIR_Coverage, 3985,
     /*  581484 */     GIR_EraseRootFromParent_Done,
     /*  581485 */   // Label 9498: @581485
     /*  581485 */   GIM_Try, /*On fail goto*//*Label 9499*/ GIMT_Encode4(581560), // Rule ID 3988 //
     /*  581490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  581501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  581504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  581507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  581510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581536 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11681:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  581539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581558 */     GIR_RootConstrainSelectedInstOperands,
     /*  581559 */     // GIR_Coverage, 3988,
     /*  581559 */     GIR_EraseRootFromParent_Done,
     /*  581560 */   // Label 9499: @581560
     /*  581560 */   GIM_Try, /*On fail goto*//*Label 9500*/ GIMT_Encode4(581635), // Rule ID 3989 //
     /*  581565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  581576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  581579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  581582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  581585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581611 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11681:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  581614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581633 */     GIR_RootConstrainSelectedInstOperands,
     /*  581634 */     // GIR_Coverage, 3989,
     /*  581634 */     GIR_EraseRootFromParent_Done,
     /*  581635 */   // Label 9500: @581635
     /*  581635 */   GIM_Try, /*On fail goto*//*Label 9501*/ GIMT_Encode4(581710), // Rule ID 3992 //
     /*  581640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  581651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  581654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  581657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  581660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581686 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11681:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581708 */     GIR_RootConstrainSelectedInstOperands,
     /*  581709 */     // GIR_Coverage, 3992,
     /*  581709 */     GIR_EraseRootFromParent_Done,
     /*  581710 */   // Label 9501: @581710
     /*  581710 */   GIM_Try, /*On fail goto*//*Label 9502*/ GIMT_Encode4(581785), // Rule ID 3993 //
     /*  581715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  581726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  581729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  581732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  581735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581761 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11681:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581783 */     GIR_RootConstrainSelectedInstOperands,
     /*  581784 */     // GIR_Coverage, 3993,
     /*  581784 */     GIR_EraseRootFromParent_Done,
     /*  581785 */   // Label 9502: @581785
     /*  581785 */   GIM_Try, /*On fail goto*//*Label 9503*/ GIMT_Encode4(581860), // Rule ID 3996 //
     /*  581790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  581801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  581804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  581807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  581810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581836 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11681:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581858 */     GIR_RootConstrainSelectedInstOperands,
     /*  581859 */     // GIR_Coverage, 3996,
     /*  581859 */     GIR_EraseRootFromParent_Done,
     /*  581860 */   // Label 9503: @581860
     /*  581860 */   GIM_Try, /*On fail goto*//*Label 9504*/ GIMT_Encode4(581935), // Rule ID 3997 //
     /*  581865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  581876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  581879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  581882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  581885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581911 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11681:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581933 */     GIR_RootConstrainSelectedInstOperands,
     /*  581934 */     // GIR_Coverage, 3997,
     /*  581934 */     GIR_EraseRootFromParent_Done,
     /*  581935 */   // Label 9504: @581935
     /*  581935 */   GIM_Try, /*On fail goto*//*Label 9505*/ GIMT_Encode4(582010), // Rule ID 4000 //
     /*  581940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  581951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  581954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  581957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  581960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581986 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11681:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582008 */     GIR_RootConstrainSelectedInstOperands,
     /*  582009 */     // GIR_Coverage, 4000,
     /*  582009 */     GIR_EraseRootFromParent_Done,
     /*  582010 */   // Label 9505: @582010
     /*  582010 */   GIM_Try, /*On fail goto*//*Label 9506*/ GIMT_Encode4(582085), // Rule ID 4001 //
     /*  582015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  582026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  582029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  582032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  582035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582061 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11681:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  582064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582083 */     GIR_RootConstrainSelectedInstOperands,
     /*  582084 */     // GIR_Coverage, 4001,
     /*  582084 */     GIR_EraseRootFromParent_Done,
     /*  582085 */   // Label 9506: @582085
     /*  582085 */   GIM_Try, /*On fail goto*//*Label 9507*/ GIMT_Encode4(582160), // Rule ID 4004 //
     /*  582090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  582093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  582101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  582104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  582107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  582110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582136 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11681:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  582136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  582139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582158 */     GIR_RootConstrainSelectedInstOperands,
     /*  582159 */     // GIR_Coverage, 4004,
     /*  582159 */     GIR_EraseRootFromParent_Done,
     /*  582160 */   // Label 9507: @582160
     /*  582160 */   GIM_Try, /*On fail goto*//*Label 9508*/ GIMT_Encode4(582235), // Rule ID 4005 //
     /*  582165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  582176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  582179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  582182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  582185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582211 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11681:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  582214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582233 */     GIR_RootConstrainSelectedInstOperands,
     /*  582234 */     // GIR_Coverage, 4005,
     /*  582234 */     GIR_EraseRootFromParent_Done,
     /*  582235 */   // Label 9508: @582235
     /*  582235 */   GIM_Try, /*On fail goto*//*Label 9509*/ GIMT_Encode4(582310), // Rule ID 4008 //
     /*  582240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  582243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  582251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  582254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  582257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  582260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582286 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11681:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  582286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  582289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582308 */     GIR_RootConstrainSelectedInstOperands,
     /*  582309 */     // GIR_Coverage, 4008,
     /*  582309 */     GIR_EraseRootFromParent_Done,
     /*  582310 */   // Label 9509: @582310
     /*  582310 */   GIM_Try, /*On fail goto*//*Label 9510*/ GIMT_Encode4(582385), // Rule ID 4009 //
     /*  582315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  582326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  582329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  582332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  582335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582361 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11681:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  582364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582383 */     GIR_RootConstrainSelectedInstOperands,
     /*  582384 */     // GIR_Coverage, 4009,
     /*  582384 */     GIR_EraseRootFromParent_Done,
     /*  582385 */   // Label 9510: @582385
     /*  582385 */   GIM_Try, /*On fail goto*//*Label 9511*/ GIMT_Encode4(582460), // Rule ID 4012 //
     /*  582390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  582401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  582404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  582407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582436 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11681:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  582439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582458 */     GIR_RootConstrainSelectedInstOperands,
     /*  582459 */     // GIR_Coverage, 4012,
     /*  582459 */     GIR_EraseRootFromParent_Done,
     /*  582460 */   // Label 9511: @582460
     /*  582460 */   GIM_Try, /*On fail goto*//*Label 9512*/ GIMT_Encode4(582535), // Rule ID 4013 //
     /*  582465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  582476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  582479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  582482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582511 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11681:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  582514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582533 */     GIR_RootConstrainSelectedInstOperands,
     /*  582534 */     // GIR_Coverage, 4013,
     /*  582534 */     GIR_EraseRootFromParent_Done,
     /*  582535 */   // Label 9512: @582535
     /*  582535 */   GIM_Try, /*On fail goto*//*Label 9513*/ GIMT_Encode4(582610), // Rule ID 4016 //
     /*  582540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  582551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  582554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  582557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582586 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11681:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  582589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582608 */     GIR_RootConstrainSelectedInstOperands,
     /*  582609 */     // GIR_Coverage, 4016,
     /*  582609 */     GIR_EraseRootFromParent_Done,
     /*  582610 */   // Label 9513: @582610
     /*  582610 */   GIM_Try, /*On fail goto*//*Label 9514*/ GIMT_Encode4(582685), // Rule ID 4017 //
     /*  582615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  582626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  582629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  582632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582661 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11681:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  582664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582683 */     GIR_RootConstrainSelectedInstOperands,
     /*  582684 */     // GIR_Coverage, 4017,
     /*  582684 */     GIR_EraseRootFromParent_Done,
     /*  582685 */   // Label 9514: @582685
     /*  582685 */   GIM_Try, /*On fail goto*//*Label 9515*/ GIMT_Encode4(582760), // Rule ID 4020 //
     /*  582690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  582701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  582704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  582707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582736 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11681:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  582739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582758 */     GIR_RootConstrainSelectedInstOperands,
     /*  582759 */     // GIR_Coverage, 4020,
     /*  582759 */     GIR_EraseRootFromParent_Done,
     /*  582760 */   // Label 9515: @582760
     /*  582760 */   GIM_Try, /*On fail goto*//*Label 9516*/ GIMT_Encode4(582835), // Rule ID 4021 //
     /*  582765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  582776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  582779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  582782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582811 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11681:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  582814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582833 */     GIR_RootConstrainSelectedInstOperands,
     /*  582834 */     // GIR_Coverage, 4021,
     /*  582834 */     GIR_EraseRootFromParent_Done,
     /*  582835 */   // Label 9516: @582835
     /*  582835 */   GIM_Try, /*On fail goto*//*Label 9517*/ GIMT_Encode4(582910), // Rule ID 4024 //
     /*  582840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  582851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  582854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  582857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11681:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  582889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582908 */     GIR_RootConstrainSelectedInstOperands,
     /*  582909 */     // GIR_Coverage, 4024,
     /*  582909 */     GIR_EraseRootFromParent_Done,
     /*  582910 */   // Label 9517: @582910
     /*  582910 */   GIM_Try, /*On fail goto*//*Label 9518*/ GIMT_Encode4(582985), // Rule ID 4025 //
     /*  582915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  582926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  582929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  582932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582961 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11681:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  582964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582983 */     GIR_RootConstrainSelectedInstOperands,
     /*  582984 */     // GIR_Coverage, 4025,
     /*  582984 */     GIR_EraseRootFromParent_Done,
     /*  582985 */   // Label 9518: @582985
     /*  582985 */   GIM_Try, /*On fail goto*//*Label 9519*/ GIMT_Encode4(583060), // Rule ID 4028 //
     /*  582990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  583001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  583004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  583007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583036 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11681:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583058 */     GIR_RootConstrainSelectedInstOperands,
     /*  583059 */     // GIR_Coverage, 4028,
     /*  583059 */     GIR_EraseRootFromParent_Done,
     /*  583060 */   // Label 9519: @583060
     /*  583060 */   GIM_Try, /*On fail goto*//*Label 9520*/ GIMT_Encode4(583135), // Rule ID 4029 //
     /*  583065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  583076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  583079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  583082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583111 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11681:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583133 */     GIR_RootConstrainSelectedInstOperands,
     /*  583134 */     // GIR_Coverage, 4029,
     /*  583134 */     GIR_EraseRootFromParent_Done,
     /*  583135 */   // Label 9520: @583135
     /*  583135 */   GIM_Try, /*On fail goto*//*Label 9521*/ GIMT_Encode4(583210), // Rule ID 4032 //
     /*  583140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  583151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  583154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  583157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583186 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11681:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  583189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583208 */     GIR_RootConstrainSelectedInstOperands,
     /*  583209 */     // GIR_Coverage, 4032,
     /*  583209 */     GIR_EraseRootFromParent_Done,
     /*  583210 */   // Label 9521: @583210
     /*  583210 */   GIM_Try, /*On fail goto*//*Label 9522*/ GIMT_Encode4(583285), // Rule ID 4033 //
     /*  583215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  583226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  583229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  583232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583261 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11681:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  583264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583283 */     GIR_RootConstrainSelectedInstOperands,
     /*  583284 */     // GIR_Coverage, 4033,
     /*  583284 */     GIR_EraseRootFromParent_Done,
     /*  583285 */   // Label 9522: @583285
     /*  583285 */   GIM_Try, /*On fail goto*//*Label 9523*/ GIMT_Encode4(583360), // Rule ID 4036 //
     /*  583290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  583301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  583304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  583307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583336 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11681:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  583339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583358 */     GIR_RootConstrainSelectedInstOperands,
     /*  583359 */     // GIR_Coverage, 4036,
     /*  583359 */     GIR_EraseRootFromParent_Done,
     /*  583360 */   // Label 9523: @583360
     /*  583360 */   GIM_Try, /*On fail goto*//*Label 9524*/ GIMT_Encode4(583435), // Rule ID 4037 //
     /*  583365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  583376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  583379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  583382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583411 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11681:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  583414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583433 */     GIR_RootConstrainSelectedInstOperands,
     /*  583434 */     // GIR_Coverage, 4037,
     /*  583434 */     GIR_EraseRootFromParent_Done,
     /*  583435 */   // Label 9524: @583435
     /*  583435 */   GIM_Try, /*On fail goto*//*Label 9525*/ GIMT_Encode4(583510), // Rule ID 4040 //
     /*  583440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  583451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  583454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  583457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583486 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11681:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  583489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583508 */     GIR_RootConstrainSelectedInstOperands,
     /*  583509 */     // GIR_Coverage, 4040,
     /*  583509 */     GIR_EraseRootFromParent_Done,
     /*  583510 */   // Label 9525: @583510
     /*  583510 */   GIM_Try, /*On fail goto*//*Label 9526*/ GIMT_Encode4(583585), // Rule ID 4041 //
     /*  583515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  583526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  583529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  583532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583561 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11681:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  583564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583583 */     GIR_RootConstrainSelectedInstOperands,
     /*  583584 */     // GIR_Coverage, 4041,
     /*  583584 */     GIR_EraseRootFromParent_Done,
     /*  583585 */   // Label 9526: @583585
     /*  583585 */   GIM_Try, /*On fail goto*//*Label 9527*/ GIMT_Encode4(583660), // Rule ID 4044 //
     /*  583590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  583601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  583604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  583607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11681:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  583639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583658 */     GIR_RootConstrainSelectedInstOperands,
     /*  583659 */     // GIR_Coverage, 4044,
     /*  583659 */     GIR_EraseRootFromParent_Done,
     /*  583660 */   // Label 9527: @583660
     /*  583660 */   GIM_Try, /*On fail goto*//*Label 9528*/ GIMT_Encode4(583735), // Rule ID 4045 //
     /*  583665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  583676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  583679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  583682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583711 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11681:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  583714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583733 */     GIR_RootConstrainSelectedInstOperands,
     /*  583734 */     // GIR_Coverage, 4045,
     /*  583734 */     GIR_EraseRootFromParent_Done,
     /*  583735 */   // Label 9528: @583735
     /*  583735 */   GIM_Try, /*On fail goto*//*Label 9529*/ GIMT_Encode4(583810), // Rule ID 4048 //
     /*  583740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  583751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  583754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  583757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583786 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11681:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583808 */     GIR_RootConstrainSelectedInstOperands,
     /*  583809 */     // GIR_Coverage, 4048,
     /*  583809 */     GIR_EraseRootFromParent_Done,
     /*  583810 */   // Label 9529: @583810
     /*  583810 */   GIM_Try, /*On fail goto*//*Label 9530*/ GIMT_Encode4(583885), // Rule ID 4049 //
     /*  583815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  583826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  583829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  583832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583861 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11681:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583883 */     GIR_RootConstrainSelectedInstOperands,
     /*  583884 */     // GIR_Coverage, 4049,
     /*  583884 */     GIR_EraseRootFromParent_Done,
     /*  583885 */   // Label 9530: @583885
     /*  583885 */   GIM_Try, /*On fail goto*//*Label 9531*/ GIMT_Encode4(583960), // Rule ID 4052 //
     /*  583890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  583901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  583904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  583907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583936 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11681:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  583939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583958 */     GIR_RootConstrainSelectedInstOperands,
     /*  583959 */     // GIR_Coverage, 4052,
     /*  583959 */     GIR_EraseRootFromParent_Done,
     /*  583960 */   // Label 9531: @583960
     /*  583960 */   GIM_Try, /*On fail goto*//*Label 9532*/ GIMT_Encode4(584035), // Rule ID 4053 //
     /*  583965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  583976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  583979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  583982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584011 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11681:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  584014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584033 */     GIR_RootConstrainSelectedInstOperands,
     /*  584034 */     // GIR_Coverage, 4053,
     /*  584034 */     GIR_EraseRootFromParent_Done,
     /*  584035 */   // Label 9532: @584035
     /*  584035 */   GIM_Try, /*On fail goto*//*Label 9533*/ GIMT_Encode4(584110), // Rule ID 4056 //
     /*  584040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  584051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  584054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  584057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11681:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  584089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584108 */     GIR_RootConstrainSelectedInstOperands,
     /*  584109 */     // GIR_Coverage, 4056,
     /*  584109 */     GIR_EraseRootFromParent_Done,
     /*  584110 */   // Label 9533: @584110
     /*  584110 */   GIM_Try, /*On fail goto*//*Label 9534*/ GIMT_Encode4(584185), // Rule ID 4057 //
     /*  584115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  584126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  584129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  584132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584161 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11681:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  584164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584183 */     GIR_RootConstrainSelectedInstOperands,
     /*  584184 */     // GIR_Coverage, 4057,
     /*  584184 */     GIR_EraseRootFromParent_Done,
     /*  584185 */   // Label 9534: @584185
     /*  584185 */   GIM_Try, /*On fail goto*//*Label 9535*/ GIMT_Encode4(584260), // Rule ID 4060 //
     /*  584190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  584201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  584204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  584207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584236 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11681:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  584239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584258 */     GIR_RootConstrainSelectedInstOperands,
     /*  584259 */     // GIR_Coverage, 4060,
     /*  584259 */     GIR_EraseRootFromParent_Done,
     /*  584260 */   // Label 9535: @584260
     /*  584260 */   GIM_Try, /*On fail goto*//*Label 9536*/ GIMT_Encode4(584335), // Rule ID 4061 //
     /*  584265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  584276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  584279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  584282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11681:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  584314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584333 */     GIR_RootConstrainSelectedInstOperands,
     /*  584334 */     // GIR_Coverage, 4061,
     /*  584334 */     GIR_EraseRootFromParent_Done,
     /*  584335 */   // Label 9536: @584335
     /*  584335 */   GIM_Try, /*On fail goto*//*Label 9537*/ GIMT_Encode4(584410), // Rule ID 4064 //
     /*  584340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  584351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  584354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  584357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584386 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11681:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  584389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584408 */     GIR_RootConstrainSelectedInstOperands,
     /*  584409 */     // GIR_Coverage, 4064,
     /*  584409 */     GIR_EraseRootFromParent_Done,
     /*  584410 */   // Label 9537: @584410
     /*  584410 */   GIM_Try, /*On fail goto*//*Label 9538*/ GIMT_Encode4(584485), // Rule ID 4065 //
     /*  584415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  584426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  584429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  584432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584461 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11681:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  584464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584483 */     GIR_RootConstrainSelectedInstOperands,
     /*  584484 */     // GIR_Coverage, 4065,
     /*  584484 */     GIR_EraseRootFromParent_Done,
     /*  584485 */   // Label 9538: @584485
     /*  584485 */   GIM_Try, /*On fail goto*//*Label 9539*/ GIMT_Encode4(584560), // Rule ID 4068 //
     /*  584490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  584501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  584504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  584507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11681:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  584539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584558 */     GIR_RootConstrainSelectedInstOperands,
     /*  584559 */     // GIR_Coverage, 4068,
     /*  584559 */     GIR_EraseRootFromParent_Done,
     /*  584560 */   // Label 9539: @584560
     /*  584560 */   GIM_Try, /*On fail goto*//*Label 9540*/ GIMT_Encode4(584635), // Rule ID 4069 //
     /*  584565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  584576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  584579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  584582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584611 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11681:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  584614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584633 */     GIR_RootConstrainSelectedInstOperands,
     /*  584634 */     // GIR_Coverage, 4069,
     /*  584634 */     GIR_EraseRootFromParent_Done,
     /*  584635 */   // Label 9540: @584635
     /*  584635 */   GIM_Try, /*On fail goto*//*Label 9541*/ GIMT_Encode4(584710), // Rule ID 4074 //
     /*  584640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  584651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  584654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  584657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  584660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584686 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  584689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584708 */     GIR_RootConstrainSelectedInstOperands,
     /*  584709 */     // GIR_Coverage, 4074,
     /*  584709 */     GIR_EraseRootFromParent_Done,
     /*  584710 */   // Label 9541: @584710
     /*  584710 */   GIM_Try, /*On fail goto*//*Label 9542*/ GIMT_Encode4(584785), // Rule ID 4075 //
     /*  584715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  584726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  584729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  584732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  584735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584761 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  584764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584783 */     GIR_RootConstrainSelectedInstOperands,
     /*  584784 */     // GIR_Coverage, 4075,
     /*  584784 */     GIR_EraseRootFromParent_Done,
     /*  584785 */   // Label 9542: @584785
     /*  584785 */   GIM_Try, /*On fail goto*//*Label 9543*/ GIMT_Encode4(584860), // Rule ID 4084 //
     /*  584790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  584801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  584804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  584807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  584810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584836 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  584839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584858 */     GIR_RootConstrainSelectedInstOperands,
     /*  584859 */     // GIR_Coverage, 4084,
     /*  584859 */     GIR_EraseRootFromParent_Done,
     /*  584860 */   // Label 9543: @584860
     /*  584860 */   GIM_Try, /*On fail goto*//*Label 9544*/ GIMT_Encode4(584935), // Rule ID 4085 //
     /*  584865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  584876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  584879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  584882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  584885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584911 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  584914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584933 */     GIR_RootConstrainSelectedInstOperands,
     /*  584934 */     // GIR_Coverage, 4085,
     /*  584934 */     GIR_EraseRootFromParent_Done,
     /*  584935 */   // Label 9544: @584935
     /*  584935 */   GIM_Try, /*On fail goto*//*Label 9545*/ GIMT_Encode4(585010), // Rule ID 4094 //
     /*  584940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  584951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  584954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  584957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  584960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  584989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585008 */     GIR_RootConstrainSelectedInstOperands,
     /*  585009 */     // GIR_Coverage, 4094,
     /*  585009 */     GIR_EraseRootFromParent_Done,
     /*  585010 */   // Label 9545: @585010
     /*  585010 */   GIM_Try, /*On fail goto*//*Label 9546*/ GIMT_Encode4(585085), // Rule ID 4095 //
     /*  585015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  585026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  585029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  585032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  585035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585061 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585083 */     GIR_RootConstrainSelectedInstOperands,
     /*  585084 */     // GIR_Coverage, 4095,
     /*  585084 */     GIR_EraseRootFromParent_Done,
     /*  585085 */   // Label 9546: @585085
     /*  585085 */   GIM_Try, /*On fail goto*//*Label 9547*/ GIMT_Encode4(585160), // Rule ID 4104 //
     /*  585090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  585101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  585104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  585107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  585110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585158 */     GIR_RootConstrainSelectedInstOperands,
     /*  585159 */     // GIR_Coverage, 4104,
     /*  585159 */     GIR_EraseRootFromParent_Done,
     /*  585160 */   // Label 9547: @585160
     /*  585160 */   GIM_Try, /*On fail goto*//*Label 9548*/ GIMT_Encode4(585235), // Rule ID 4105 //
     /*  585165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  585176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  585179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  585182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  585185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585211 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585233 */     GIR_RootConstrainSelectedInstOperands,
     /*  585234 */     // GIR_Coverage, 4105,
     /*  585234 */     GIR_EraseRootFromParent_Done,
     /*  585235 */   // Label 9548: @585235
     /*  585235 */   GIM_Try, /*On fail goto*//*Label 9549*/ GIMT_Encode4(585310), // Rule ID 4114 //
     /*  585240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  585251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  585254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  585257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  585260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  585289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585308 */     GIR_RootConstrainSelectedInstOperands,
     /*  585309 */     // GIR_Coverage, 4114,
     /*  585309 */     GIR_EraseRootFromParent_Done,
     /*  585310 */   // Label 9549: @585310
     /*  585310 */   GIM_Try, /*On fail goto*//*Label 9550*/ GIMT_Encode4(585385), // Rule ID 4115 //
     /*  585315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  585326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  585329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  585332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  585335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585361 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  585364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585383 */     GIR_RootConstrainSelectedInstOperands,
     /*  585384 */     // GIR_Coverage, 4115,
     /*  585384 */     GIR_EraseRootFromParent_Done,
     /*  585385 */   // Label 9550: @585385
     /*  585385 */   GIM_Try, /*On fail goto*//*Label 9551*/ GIMT_Encode4(585460), // Rule ID 4124 //
     /*  585390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  585401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  585404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  585407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  585410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585436 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  585439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585458 */     GIR_RootConstrainSelectedInstOperands,
     /*  585459 */     // GIR_Coverage, 4124,
     /*  585459 */     GIR_EraseRootFromParent_Done,
     /*  585460 */   // Label 9551: @585460
     /*  585460 */   GIM_Try, /*On fail goto*//*Label 9552*/ GIMT_Encode4(585535), // Rule ID 4125 //
     /*  585465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  585476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  585479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  585482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  585485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585511 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  585514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585533 */     GIR_RootConstrainSelectedInstOperands,
     /*  585534 */     // GIR_Coverage, 4125,
     /*  585534 */     GIR_EraseRootFromParent_Done,
     /*  585535 */   // Label 9552: @585535
     /*  585535 */   GIM_Try, /*On fail goto*//*Label 9553*/ GIMT_Encode4(585610), // Rule ID 4134 //
     /*  585540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  585551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  585554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  585557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  585560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585586 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  585589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585608 */     GIR_RootConstrainSelectedInstOperands,
     /*  585609 */     // GIR_Coverage, 4134,
     /*  585609 */     GIR_EraseRootFromParent_Done,
     /*  585610 */   // Label 9553: @585610
     /*  585610 */   GIM_Try, /*On fail goto*//*Label 9554*/ GIMT_Encode4(585685), // Rule ID 4135 //
     /*  585615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  585626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  585629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  585632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  585635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585661 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  585664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585683 */     GIR_RootConstrainSelectedInstOperands,
     /*  585684 */     // GIR_Coverage, 4135,
     /*  585684 */     GIR_EraseRootFromParent_Done,
     /*  585685 */   // Label 9554: @585685
     /*  585685 */   GIM_Try, /*On fail goto*//*Label 9555*/ GIMT_Encode4(585760), // Rule ID 4144 //
     /*  585690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  585701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  585704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  585707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  585710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585758 */     GIR_RootConstrainSelectedInstOperands,
     /*  585759 */     // GIR_Coverage, 4144,
     /*  585759 */     GIR_EraseRootFromParent_Done,
     /*  585760 */   // Label 9555: @585760
     /*  585760 */   GIM_Try, /*On fail goto*//*Label 9556*/ GIMT_Encode4(585835), // Rule ID 4145 //
     /*  585765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  585776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  585779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  585782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  585785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585811 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585833 */     GIR_RootConstrainSelectedInstOperands,
     /*  585834 */     // GIR_Coverage, 4145,
     /*  585834 */     GIR_EraseRootFromParent_Done,
     /*  585835 */   // Label 9556: @585835
     /*  585835 */   GIM_Try, /*On fail goto*//*Label 9557*/ GIMT_Encode4(585910), // Rule ID 4154 //
     /*  585840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  585851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  585854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  585857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  585860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585886 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585908 */     GIR_RootConstrainSelectedInstOperands,
     /*  585909 */     // GIR_Coverage, 4154,
     /*  585909 */     GIR_EraseRootFromParent_Done,
     /*  585910 */   // Label 9557: @585910
     /*  585910 */   GIM_Try, /*On fail goto*//*Label 9558*/ GIMT_Encode4(585985), // Rule ID 4155 //
     /*  585915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  585926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  585929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  585932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  585935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585961 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585983 */     GIR_RootConstrainSelectedInstOperands,
     /*  585984 */     // GIR_Coverage, 4155,
     /*  585984 */     GIR_EraseRootFromParent_Done,
     /*  585985 */   // Label 9558: @585985
     /*  585985 */   GIM_Try, /*On fail goto*//*Label 9559*/ GIMT_Encode4(586060), // Rule ID 4164 //
     /*  585990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  586001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  586004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  586007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  586010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586036 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  586036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586058 */     GIR_RootConstrainSelectedInstOperands,
     /*  586059 */     // GIR_Coverage, 4164,
     /*  586059 */     GIR_EraseRootFromParent_Done,
     /*  586060 */   // Label 9559: @586060
     /*  586060 */   GIM_Try, /*On fail goto*//*Label 9560*/ GIMT_Encode4(586135), // Rule ID 4165 //
     /*  586065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  586076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  586079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  586082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  586085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586111 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  586111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586133 */     GIR_RootConstrainSelectedInstOperands,
     /*  586134 */     // GIR_Coverage, 4165,
     /*  586134 */     GIR_EraseRootFromParent_Done,
     /*  586135 */   // Label 9560: @586135
     /*  586135 */   GIM_Try, /*On fail goto*//*Label 9561*/ GIMT_Encode4(586210), // Rule ID 4174 //
     /*  586140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  586151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  586154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  586157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  586160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  586189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586208 */     GIR_RootConstrainSelectedInstOperands,
     /*  586209 */     // GIR_Coverage, 4174,
     /*  586209 */     GIR_EraseRootFromParent_Done,
     /*  586210 */   // Label 9561: @586210
     /*  586210 */   GIM_Try, /*On fail goto*//*Label 9562*/ GIMT_Encode4(586285), // Rule ID 4175 //
     /*  586215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  586226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  586229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  586232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  586235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586261 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  586264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586283 */     GIR_RootConstrainSelectedInstOperands,
     /*  586284 */     // GIR_Coverage, 4175,
     /*  586284 */     GIR_EraseRootFromParent_Done,
     /*  586285 */   // Label 9562: @586285
     /*  586285 */   GIM_Try, /*On fail goto*//*Label 9563*/ GIMT_Encode4(586360), // Rule ID 4184 //
     /*  586290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  586301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  586304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  586307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  586310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586336 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  586339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586358 */     GIR_RootConstrainSelectedInstOperands,
     /*  586359 */     // GIR_Coverage, 4184,
     /*  586359 */     GIR_EraseRootFromParent_Done,
     /*  586360 */   // Label 9563: @586360
     /*  586360 */   GIM_Try, /*On fail goto*//*Label 9564*/ GIMT_Encode4(586435), // Rule ID 4185 //
     /*  586365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  586376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  586379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  586382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  586385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586411 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  586414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586433 */     GIR_RootConstrainSelectedInstOperands,
     /*  586434 */     // GIR_Coverage, 4185,
     /*  586434 */     GIR_EraseRootFromParent_Done,
     /*  586435 */   // Label 9564: @586435
     /*  586435 */   GIM_Try, /*On fail goto*//*Label 9565*/ GIMT_Encode4(586510), // Rule ID 4194 //
     /*  586440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  586451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  586454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  586457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  586460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586486 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  586489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586508 */     GIR_RootConstrainSelectedInstOperands,
     /*  586509 */     // GIR_Coverage, 4194,
     /*  586509 */     GIR_EraseRootFromParent_Done,
     /*  586510 */   // Label 9565: @586510
     /*  586510 */   GIM_Try, /*On fail goto*//*Label 9566*/ GIMT_Encode4(586585), // Rule ID 4195 //
     /*  586515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  586526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  586529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  586532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  586535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586561 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  586564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586583 */     GIR_RootConstrainSelectedInstOperands,
     /*  586584 */     // GIR_Coverage, 4195,
     /*  586584 */     GIR_EraseRootFromParent_Done,
     /*  586585 */   // Label 9566: @586585
     /*  586585 */   GIM_Try, /*On fail goto*//*Label 9567*/ GIMT_Encode4(586660), // Rule ID 4204 //
     /*  586590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  586601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  586604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  586607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  586610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586636 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586658 */     GIR_RootConstrainSelectedInstOperands,
     /*  586659 */     // GIR_Coverage, 4204,
     /*  586659 */     GIR_EraseRootFromParent_Done,
     /*  586660 */   // Label 9567: @586660
     /*  586660 */   GIM_Try, /*On fail goto*//*Label 9568*/ GIMT_Encode4(586735), // Rule ID 4205 //
     /*  586665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  586676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  586679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  586682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  586685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586711 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586733 */     GIR_RootConstrainSelectedInstOperands,
     /*  586734 */     // GIR_Coverage, 4205,
     /*  586734 */     GIR_EraseRootFromParent_Done,
     /*  586735 */   // Label 9568: @586735
     /*  586735 */   GIM_Try, /*On fail goto*//*Label 9569*/ GIMT_Encode4(586810), // Rule ID 4212 //
     /*  586740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  586751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  586754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  586757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  586789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586808 */     GIR_RootConstrainSelectedInstOperands,
     /*  586809 */     // GIR_Coverage, 4212,
     /*  586809 */     GIR_EraseRootFromParent_Done,
     /*  586810 */   // Label 9569: @586810
     /*  586810 */   GIM_Try, /*On fail goto*//*Label 9570*/ GIMT_Encode4(586885), // Rule ID 4213 //
     /*  586815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  586826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  586829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  586832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586861 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  586864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586883 */     GIR_RootConstrainSelectedInstOperands,
     /*  586884 */     // GIR_Coverage, 4213,
     /*  586884 */     GIR_EraseRootFromParent_Done,
     /*  586885 */   // Label 9570: @586885
     /*  586885 */   GIM_Try, /*On fail goto*//*Label 9571*/ GIMT_Encode4(586960), // Rule ID 4216 //
     /*  586890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  586901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  586904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  586907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586936 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  586939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586958 */     GIR_RootConstrainSelectedInstOperands,
     /*  586959 */     // GIR_Coverage, 4216,
     /*  586959 */     GIR_EraseRootFromParent_Done,
     /*  586960 */   // Label 9571: @586960
     /*  586960 */   GIM_Try, /*On fail goto*//*Label 9572*/ GIMT_Encode4(587035), // Rule ID 4217 //
     /*  586965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  586976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  586979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  586982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587011 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  587014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587033 */     GIR_RootConstrainSelectedInstOperands,
     /*  587034 */     // GIR_Coverage, 4217,
     /*  587034 */     GIR_EraseRootFromParent_Done,
     /*  587035 */   // Label 9572: @587035
     /*  587035 */   GIM_Try, /*On fail goto*//*Label 9573*/ GIMT_Encode4(587110), // Rule ID 4220 //
     /*  587040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  587051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  587054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  587057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587108 */     GIR_RootConstrainSelectedInstOperands,
     /*  587109 */     // GIR_Coverage, 4220,
     /*  587109 */     GIR_EraseRootFromParent_Done,
     /*  587110 */   // Label 9573: @587110
     /*  587110 */   GIM_Try, /*On fail goto*//*Label 9574*/ GIMT_Encode4(587185), // Rule ID 4221 //
     /*  587115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  587126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  587129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  587132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587161 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587183 */     GIR_RootConstrainSelectedInstOperands,
     /*  587184 */     // GIR_Coverage, 4221,
     /*  587184 */     GIR_EraseRootFromParent_Done,
     /*  587185 */   // Label 9574: @587185
     /*  587185 */   GIM_Try, /*On fail goto*//*Label 9575*/ GIMT_Encode4(587260), // Rule ID 4224 //
     /*  587190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  587201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  587204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587236 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  587239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587258 */     GIR_RootConstrainSelectedInstOperands,
     /*  587259 */     // GIR_Coverage, 4224,
     /*  587259 */     GIR_EraseRootFromParent_Done,
     /*  587260 */   // Label 9575: @587260
     /*  587260 */   GIM_Try, /*On fail goto*//*Label 9576*/ GIMT_Encode4(587335), // Rule ID 4225 //
     /*  587265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  587276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  587279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587311 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  587314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587333 */     GIR_RootConstrainSelectedInstOperands,
     /*  587334 */     // GIR_Coverage, 4225,
     /*  587334 */     GIR_EraseRootFromParent_Done,
     /*  587335 */   // Label 9576: @587335
     /*  587335 */   GIM_Try, /*On fail goto*//*Label 9577*/ GIMT_Encode4(587410), // Rule ID 4228 //
     /*  587340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  587351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  587354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587386 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  587389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587408 */     GIR_RootConstrainSelectedInstOperands,
     /*  587409 */     // GIR_Coverage, 4228,
     /*  587409 */     GIR_EraseRootFromParent_Done,
     /*  587410 */   // Label 9577: @587410
     /*  587410 */   GIM_Try, /*On fail goto*//*Label 9578*/ GIMT_Encode4(587485), // Rule ID 4229 //
     /*  587415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  587426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  587429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587461 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  587464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587483 */     GIR_RootConstrainSelectedInstOperands,
     /*  587484 */     // GIR_Coverage, 4229,
     /*  587484 */     GIR_EraseRootFromParent_Done,
     /*  587485 */   // Label 9578: @587485
     /*  587485 */   GIM_Try, /*On fail goto*//*Label 9579*/ GIMT_Encode4(587560), // Rule ID 4232 //
     /*  587490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  587501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  587504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  587507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587536 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  587539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587558 */     GIR_RootConstrainSelectedInstOperands,
     /*  587559 */     // GIR_Coverage, 4232,
     /*  587559 */     GIR_EraseRootFromParent_Done,
     /*  587560 */   // Label 9579: @587560
     /*  587560 */   GIM_Try, /*On fail goto*//*Label 9580*/ GIMT_Encode4(587635), // Rule ID 4233 //
     /*  587565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  587576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  587579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  587582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587611 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  587614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587633 */     GIR_RootConstrainSelectedInstOperands,
     /*  587634 */     // GIR_Coverage, 4233,
     /*  587634 */     GIR_EraseRootFromParent_Done,
     /*  587635 */   // Label 9580: @587635
     /*  587635 */   GIM_Try, /*On fail goto*//*Label 9581*/ GIMT_Encode4(587710), // Rule ID 4236 //
     /*  587640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  587651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  587654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  587657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587686 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  587689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587708 */     GIR_RootConstrainSelectedInstOperands,
     /*  587709 */     // GIR_Coverage, 4236,
     /*  587709 */     GIR_EraseRootFromParent_Done,
     /*  587710 */   // Label 9581: @587710
     /*  587710 */   GIM_Try, /*On fail goto*//*Label 9582*/ GIMT_Encode4(587785), // Rule ID 4237 //
     /*  587715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  587726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  587729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  587732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587761 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  587764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587783 */     GIR_RootConstrainSelectedInstOperands,
     /*  587784 */     // GIR_Coverage, 4237,
     /*  587784 */     GIR_EraseRootFromParent_Done,
     /*  587785 */   // Label 9582: @587785
     /*  587785 */   GIM_Try, /*On fail goto*//*Label 9583*/ GIMT_Encode4(587860), // Rule ID 4240 //
     /*  587790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  587801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  587804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  587807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587836 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587858 */     GIR_RootConstrainSelectedInstOperands,
     /*  587859 */     // GIR_Coverage, 4240,
     /*  587859 */     GIR_EraseRootFromParent_Done,
     /*  587860 */   // Label 9583: @587860
     /*  587860 */   GIM_Try, /*On fail goto*//*Label 9584*/ GIMT_Encode4(587935), // Rule ID 4241 //
     /*  587865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  587876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  587879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  587882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587911 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587933 */     GIR_RootConstrainSelectedInstOperands,
     /*  587934 */     // GIR_Coverage, 4241,
     /*  587934 */     GIR_EraseRootFromParent_Done,
     /*  587935 */   // Label 9584: @587935
     /*  587935 */   GIM_Try, /*On fail goto*//*Label 9585*/ GIMT_Encode4(588010), // Rule ID 4244 //
     /*  587940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  587951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  587954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  587957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  587989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588008 */     GIR_RootConstrainSelectedInstOperands,
     /*  588009 */     // GIR_Coverage, 4244,
     /*  588009 */     GIR_EraseRootFromParent_Done,
     /*  588010 */   // Label 9585: @588010
     /*  588010 */   GIM_Try, /*On fail goto*//*Label 9586*/ GIMT_Encode4(588085), // Rule ID 4245 //
     /*  588015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  588026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  588029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  588032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  588064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588083 */     GIR_RootConstrainSelectedInstOperands,
     /*  588084 */     // GIR_Coverage, 4245,
     /*  588084 */     GIR_EraseRootFromParent_Done,
     /*  588085 */   // Label 9586: @588085
     /*  588085 */   GIM_Try, /*On fail goto*//*Label 9587*/ GIMT_Encode4(588160), // Rule ID 4248 //
     /*  588090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  588101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  588104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588136 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588158 */     GIR_RootConstrainSelectedInstOperands,
     /*  588159 */     // GIR_Coverage, 4248,
     /*  588159 */     GIR_EraseRootFromParent_Done,
     /*  588160 */   // Label 9587: @588160
     /*  588160 */   GIM_Try, /*On fail goto*//*Label 9588*/ GIMT_Encode4(588235), // Rule ID 4249 //
     /*  588165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  588176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  588179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588211 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588233 */     GIR_RootConstrainSelectedInstOperands,
     /*  588234 */     // GIR_Coverage, 4249,
     /*  588234 */     GIR_EraseRootFromParent_Done,
     /*  588235 */   // Label 9588: @588235
     /*  588235 */   GIM_Try, /*On fail goto*//*Label 9589*/ GIMT_Encode4(588310), // Rule ID 4252 //
     /*  588240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  588251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  588254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  588257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588286 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588308 */     GIR_RootConstrainSelectedInstOperands,
     /*  588309 */     // GIR_Coverage, 4252,
     /*  588309 */     GIR_EraseRootFromParent_Done,
     /*  588310 */   // Label 9589: @588310
     /*  588310 */   GIM_Try, /*On fail goto*//*Label 9590*/ GIMT_Encode4(588385), // Rule ID 4253 //
     /*  588315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  588326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  588329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  588332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588361 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588383 */     GIR_RootConstrainSelectedInstOperands,
     /*  588384 */     // GIR_Coverage, 4253,
     /*  588384 */     GIR_EraseRootFromParent_Done,
     /*  588385 */   // Label 9590: @588385
     /*  588385 */   GIM_Try, /*On fail goto*//*Label 9591*/ GIMT_Encode4(588460), // Rule ID 4256 //
     /*  588390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  588401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  588404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  588407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588436 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  588439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588458 */     GIR_RootConstrainSelectedInstOperands,
     /*  588459 */     // GIR_Coverage, 4256,
     /*  588459 */     GIR_EraseRootFromParent_Done,
     /*  588460 */   // Label 9591: @588460
     /*  588460 */   GIM_Try, /*On fail goto*//*Label 9592*/ GIMT_Encode4(588535), // Rule ID 4257 //
     /*  588465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  588476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  588479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  588482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588511 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  588514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588533 */     GIR_RootConstrainSelectedInstOperands,
     /*  588534 */     // GIR_Coverage, 4257,
     /*  588534 */     GIR_EraseRootFromParent_Done,
     /*  588535 */   // Label 9592: @588535
     /*  588535 */   GIM_Try, /*On fail goto*//*Label 9593*/ GIMT_Encode4(588610), // Rule ID 4260 //
     /*  588540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  588551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  588554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  588557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  588589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588608 */     GIR_RootConstrainSelectedInstOperands,
     /*  588609 */     // GIR_Coverage, 4260,
     /*  588609 */     GIR_EraseRootFromParent_Done,
     /*  588610 */   // Label 9593: @588610
     /*  588610 */   GIM_Try, /*On fail goto*//*Label 9594*/ GIMT_Encode4(588685), // Rule ID 4261 //
     /*  588615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  588626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  588629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  588632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588661 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  588664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588683 */     GIR_RootConstrainSelectedInstOperands,
     /*  588684 */     // GIR_Coverage, 4261,
     /*  588684 */     GIR_EraseRootFromParent_Done,
     /*  588685 */   // Label 9594: @588685
     /*  588685 */   GIM_Try, /*On fail goto*//*Label 9595*/ GIMT_Encode4(588760), // Rule ID 4264 //
     /*  588690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  588701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  588704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  588707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588736 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588758 */     GIR_RootConstrainSelectedInstOperands,
     /*  588759 */     // GIR_Coverage, 4264,
     /*  588759 */     GIR_EraseRootFromParent_Done,
     /*  588760 */   // Label 9595: @588760
     /*  588760 */   GIM_Try, /*On fail goto*//*Label 9596*/ GIMT_Encode4(588835), // Rule ID 4265 //
     /*  588765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  588776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  588779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  588782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588811 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588833 */     GIR_RootConstrainSelectedInstOperands,
     /*  588834 */     // GIR_Coverage, 4265,
     /*  588834 */     GIR_EraseRootFromParent_Done,
     /*  588835 */   // Label 9596: @588835
     /*  588835 */   GIM_Try, /*On fail goto*//*Label 9597*/ GIMT_Encode4(588910), // Rule ID 4268 //
     /*  588840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  588851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  588854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  588857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588908 */     GIR_RootConstrainSelectedInstOperands,
     /*  588909 */     // GIR_Coverage, 4268,
     /*  588909 */     GIR_EraseRootFromParent_Done,
     /*  588910 */   // Label 9597: @588910
     /*  588910 */   GIM_Try, /*On fail goto*//*Label 9598*/ GIMT_Encode4(588985), // Rule ID 4269 //
     /*  588915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  588926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  588929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  588932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588961 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588983 */     GIR_RootConstrainSelectedInstOperands,
     /*  588984 */     // GIR_Coverage, 4269,
     /*  588984 */     GIR_EraseRootFromParent_Done,
     /*  588985 */   // Label 9598: @588985
     /*  588985 */   GIM_Try, /*On fail goto*//*Label 9599*/ GIMT_Encode4(589060), // Rule ID 4274 //
     /*  588990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  588998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  589001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  589004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  589007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  589010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589036 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  589039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589058 */     GIR_RootConstrainSelectedInstOperands,
     /*  589059 */     // GIR_Coverage, 4274,
     /*  589059 */     GIR_EraseRootFromParent_Done,
     /*  589060 */   // Label 9599: @589060
     /*  589060 */   GIM_Try, /*On fail goto*//*Label 9600*/ GIMT_Encode4(589135), // Rule ID 4275 //
     /*  589065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  589076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  589079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  589082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  589085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589111 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  589114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589133 */     GIR_RootConstrainSelectedInstOperands,
     /*  589134 */     // GIR_Coverage, 4275,
     /*  589134 */     GIR_EraseRootFromParent_Done,
     /*  589135 */   // Label 9600: @589135
     /*  589135 */   GIM_Try, /*On fail goto*//*Label 9601*/ GIMT_Encode4(589210), // Rule ID 4284 //
     /*  589140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  589151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  589154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  589157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  589160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589186 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  589189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589208 */     GIR_RootConstrainSelectedInstOperands,
     /*  589209 */     // GIR_Coverage, 4284,
     /*  589209 */     GIR_EraseRootFromParent_Done,
     /*  589210 */   // Label 9601: @589210
     /*  589210 */   GIM_Try, /*On fail goto*//*Label 9602*/ GIMT_Encode4(589285), // Rule ID 4285 //
     /*  589215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  589226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  589229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  589232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  589235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589261 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  589264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589283 */     GIR_RootConstrainSelectedInstOperands,
     /*  589284 */     // GIR_Coverage, 4285,
     /*  589284 */     GIR_EraseRootFromParent_Done,
     /*  589285 */   // Label 9602: @589285
     /*  589285 */   GIM_Try, /*On fail goto*//*Label 9603*/ GIMT_Encode4(589360), // Rule ID 4294 //
     /*  589290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  589301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  589304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  589307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  589310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589336 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  589339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589358 */     GIR_RootConstrainSelectedInstOperands,
     /*  589359 */     // GIR_Coverage, 4294,
     /*  589359 */     GIR_EraseRootFromParent_Done,
     /*  589360 */   // Label 9603: @589360
     /*  589360 */   GIM_Try, /*On fail goto*//*Label 9604*/ GIMT_Encode4(589435), // Rule ID 4295 //
     /*  589365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  589376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  589379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  589382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  589385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589411 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  589414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589433 */     GIR_RootConstrainSelectedInstOperands,
     /*  589434 */     // GIR_Coverage, 4295,
     /*  589434 */     GIR_EraseRootFromParent_Done,
     /*  589435 */   // Label 9604: @589435
     /*  589435 */   GIM_Try, /*On fail goto*//*Label 9605*/ GIMT_Encode4(589510), // Rule ID 4304 //
     /*  589440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  589451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  589454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  589457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  589460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589486 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  589489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589508 */     GIR_RootConstrainSelectedInstOperands,
     /*  589509 */     // GIR_Coverage, 4304,
     /*  589509 */     GIR_EraseRootFromParent_Done,
     /*  589510 */   // Label 9605: @589510
     /*  589510 */   GIM_Try, /*On fail goto*//*Label 9606*/ GIMT_Encode4(589585), // Rule ID 4305 //
     /*  589515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  589526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  589529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  589532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  589535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589561 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  589564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589583 */     GIR_RootConstrainSelectedInstOperands,
     /*  589584 */     // GIR_Coverage, 4305,
     /*  589584 */     GIR_EraseRootFromParent_Done,
     /*  589585 */   // Label 9606: @589585
     /*  589585 */   GIM_Try, /*On fail goto*//*Label 9607*/ GIMT_Encode4(589660), // Rule ID 4314 //
     /*  589590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  589601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  589604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  589607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  589610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589636 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  589639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589658 */     GIR_RootConstrainSelectedInstOperands,
     /*  589659 */     // GIR_Coverage, 4314,
     /*  589659 */     GIR_EraseRootFromParent_Done,
     /*  589660 */   // Label 9607: @589660
     /*  589660 */   GIM_Try, /*On fail goto*//*Label 9608*/ GIMT_Encode4(589735), // Rule ID 4315 //
     /*  589665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  589676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  589679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  589682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  589685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589711 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  589714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589733 */     GIR_RootConstrainSelectedInstOperands,
     /*  589734 */     // GIR_Coverage, 4315,
     /*  589734 */     GIR_EraseRootFromParent_Done,
     /*  589735 */   // Label 9608: @589735
     /*  589735 */   GIM_Try, /*On fail goto*//*Label 9609*/ GIMT_Encode4(589810), // Rule ID 4324 //
     /*  589740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  589751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  589754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  589757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  589760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589786 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  589789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589808 */     GIR_RootConstrainSelectedInstOperands,
     /*  589809 */     // GIR_Coverage, 4324,
     /*  589809 */     GIR_EraseRootFromParent_Done,
     /*  589810 */   // Label 9609: @589810
     /*  589810 */   GIM_Try, /*On fail goto*//*Label 9610*/ GIMT_Encode4(589885), // Rule ID 4325 //
     /*  589815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  589826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  589829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  589832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  589835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589861 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  589864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589883 */     GIR_RootConstrainSelectedInstOperands,
     /*  589884 */     // GIR_Coverage, 4325,
     /*  589884 */     GIR_EraseRootFromParent_Done,
     /*  589885 */   // Label 9610: @589885
     /*  589885 */   GIM_Try, /*On fail goto*//*Label 9611*/ GIMT_Encode4(589960), // Rule ID 4334 //
     /*  589890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  589901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  589904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  589907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  589910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589936 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  589939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589958 */     GIR_RootConstrainSelectedInstOperands,
     /*  589959 */     // GIR_Coverage, 4334,
     /*  589959 */     GIR_EraseRootFromParent_Done,
     /*  589960 */   // Label 9611: @589960
     /*  589960 */   GIM_Try, /*On fail goto*//*Label 9612*/ GIMT_Encode4(590035), // Rule ID 4335 //
     /*  589965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  589976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  589979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  589982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  589985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590011 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  590014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590033 */     GIR_RootConstrainSelectedInstOperands,
     /*  590034 */     // GIR_Coverage, 4335,
     /*  590034 */     GIR_EraseRootFromParent_Done,
     /*  590035 */   // Label 9612: @590035
     /*  590035 */   GIM_Try, /*On fail goto*//*Label 9613*/ GIMT_Encode4(590110), // Rule ID 4344 //
     /*  590040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  590051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  590054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  590057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  590060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590086 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11687:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590108 */     GIR_RootConstrainSelectedInstOperands,
     /*  590109 */     // GIR_Coverage, 4344,
     /*  590109 */     GIR_EraseRootFromParent_Done,
     /*  590110 */   // Label 9613: @590110
     /*  590110 */   GIM_Try, /*On fail goto*//*Label 9614*/ GIMT_Encode4(590185), // Rule ID 4345 //
     /*  590115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  590126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  590129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  590132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  590135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590161 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11687:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590183 */     GIR_RootConstrainSelectedInstOperands,
     /*  590184 */     // GIR_Coverage, 4345,
     /*  590184 */     GIR_EraseRootFromParent_Done,
     /*  590185 */   // Label 9614: @590185
     /*  590185 */   GIM_Try, /*On fail goto*//*Label 9615*/ GIMT_Encode4(590260), // Rule ID 4354 //
     /*  590190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  590201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  590204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  590207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  590210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590258 */     GIR_RootConstrainSelectedInstOperands,
     /*  590259 */     // GIR_Coverage, 4354,
     /*  590259 */     GIR_EraseRootFromParent_Done,
     /*  590260 */   // Label 9615: @590260
     /*  590260 */   GIM_Try, /*On fail goto*//*Label 9616*/ GIMT_Encode4(590335), // Rule ID 4355 //
     /*  590265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  590276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  590279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  590282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  590285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590311 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590333 */     GIR_RootConstrainSelectedInstOperands,
     /*  590334 */     // GIR_Coverage, 4355,
     /*  590334 */     GIR_EraseRootFromParent_Done,
     /*  590335 */   // Label 9616: @590335
     /*  590335 */   GIM_Try, /*On fail goto*//*Label 9617*/ GIMT_Encode4(590410), // Rule ID 4364 //
     /*  590340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  590351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  590354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  590357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  590360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590386 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590408 */     GIR_RootConstrainSelectedInstOperands,
     /*  590409 */     // GIR_Coverage, 4364,
     /*  590409 */     GIR_EraseRootFromParent_Done,
     /*  590410 */   // Label 9617: @590410
     /*  590410 */   GIM_Try, /*On fail goto*//*Label 9618*/ GIMT_Encode4(590485), // Rule ID 4365 //
     /*  590415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  590426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  590429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  590432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  590435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590461 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590483 */     GIR_RootConstrainSelectedInstOperands,
     /*  590484 */     // GIR_Coverage, 4365,
     /*  590484 */     GIR_EraseRootFromParent_Done,
     /*  590485 */   // Label 9618: @590485
     /*  590485 */   GIM_Try, /*On fail goto*//*Label 9619*/ GIMT_Encode4(590560), // Rule ID 4374 //
     /*  590490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  590501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  590504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  590507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  590510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  590539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590558 */     GIR_RootConstrainSelectedInstOperands,
     /*  590559 */     // GIR_Coverage, 4374,
     /*  590559 */     GIR_EraseRootFromParent_Done,
     /*  590560 */   // Label 9619: @590560
     /*  590560 */   GIM_Try, /*On fail goto*//*Label 9620*/ GIMT_Encode4(590635), // Rule ID 4375 //
     /*  590565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  590576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  590579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  590582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  590585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590611 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  590614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590633 */     GIR_RootConstrainSelectedInstOperands,
     /*  590634 */     // GIR_Coverage, 4375,
     /*  590634 */     GIR_EraseRootFromParent_Done,
     /*  590635 */   // Label 9620: @590635
     /*  590635 */   GIM_Try, /*On fail goto*//*Label 9621*/ GIMT_Encode4(590710), // Rule ID 4384 //
     /*  590640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  590651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  590654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  590657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  590660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590686 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590708 */     GIR_RootConstrainSelectedInstOperands,
     /*  590709 */     // GIR_Coverage, 4384,
     /*  590709 */     GIR_EraseRootFromParent_Done,
     /*  590710 */   // Label 9621: @590710
     /*  590710 */   GIM_Try, /*On fail goto*//*Label 9622*/ GIMT_Encode4(590785), // Rule ID 4385 //
     /*  590715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  590726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  590729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  590732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  590735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590761 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590783 */     GIR_RootConstrainSelectedInstOperands,
     /*  590784 */     // GIR_Coverage, 4385,
     /*  590784 */     GIR_EraseRootFromParent_Done,
     /*  590785 */   // Label 9622: @590785
     /*  590785 */   GIM_Try, /*On fail goto*//*Label 9623*/ GIMT_Encode4(590860), // Rule ID 4394 //
     /*  590790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  590801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  590804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  590807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  590810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590858 */     GIR_RootConstrainSelectedInstOperands,
     /*  590859 */     // GIR_Coverage, 4394,
     /*  590859 */     GIR_EraseRootFromParent_Done,
     /*  590860 */   // Label 9623: @590860
     /*  590860 */   GIM_Try, /*On fail goto*//*Label 9624*/ GIMT_Encode4(590935), // Rule ID 4395 //
     /*  590865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  590876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  590879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  590882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  590885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590911 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590933 */     GIR_RootConstrainSelectedInstOperands,
     /*  590934 */     // GIR_Coverage, 4395,
     /*  590934 */     GIR_EraseRootFromParent_Done,
     /*  590935 */   // Label 9624: @590935
     /*  590935 */   GIM_Try, /*On fail goto*//*Label 9625*/ GIMT_Encode4(591010), // Rule ID 4404 //
     /*  590940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  590951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  590954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  590957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  590960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591008 */     GIR_RootConstrainSelectedInstOperands,
     /*  591009 */     // GIR_Coverage, 4404,
     /*  591009 */     GIR_EraseRootFromParent_Done,
     /*  591010 */   // Label 9625: @591010
     /*  591010 */   GIM_Try, /*On fail goto*//*Label 9626*/ GIMT_Encode4(591085), // Rule ID 4405 //
     /*  591015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  591018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  591026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  591029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  591032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  591035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591061 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  591064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591083 */     GIR_RootConstrainSelectedInstOperands,
     /*  591084 */     // GIR_Coverage, 4405,
     /*  591084 */     GIR_EraseRootFromParent_Done,
     /*  591085 */   // Label 9626: @591085
     /*  591085 */   GIM_Try, /*On fail goto*//*Label 9627*/ GIMT_Encode4(591160), // Rule ID 4414 //
     /*  591090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  591093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  591101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  591104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  591107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  591110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591136 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  591136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  591139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591158 */     GIR_RootConstrainSelectedInstOperands,
     /*  591159 */     // GIR_Coverage, 4414,
     /*  591159 */     GIR_EraseRootFromParent_Done,
     /*  591160 */   // Label 9627: @591160
     /*  591160 */   GIM_Try, /*On fail goto*//*Label 9628*/ GIMT_Encode4(591235), // Rule ID 4415 //
     /*  591165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  591168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  591176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  591179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  591182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  591185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591211 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  591214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591233 */     GIR_RootConstrainSelectedInstOperands,
     /*  591234 */     // GIR_Coverage, 4415,
     /*  591234 */     GIR_EraseRootFromParent_Done,
     /*  591235 */   // Label 9628: @591235
     /*  591235 */   GIM_Try, /*On fail goto*//*Label 9629*/ GIMT_Encode4(591310), // Rule ID 4422 //
     /*  591240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  591251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  591254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  591257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591286 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  591289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591308 */     GIR_RootConstrainSelectedInstOperands,
     /*  591309 */     // GIR_Coverage, 4422,
     /*  591309 */     GIR_EraseRootFromParent_Done,
     /*  591310 */   // Label 9629: @591310
     /*  591310 */   GIM_Try, /*On fail goto*//*Label 9630*/ GIMT_Encode4(591385), // Rule ID 4423 //
     /*  591315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  591326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  591329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  591332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591361 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  591364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591383 */     GIR_RootConstrainSelectedInstOperands,
     /*  591384 */     // GIR_Coverage, 4423,
     /*  591384 */     GIR_EraseRootFromParent_Done,
     /*  591385 */   // Label 9630: @591385
     /*  591385 */   GIM_Try, /*On fail goto*//*Label 9631*/ GIMT_Encode4(591460), // Rule ID 4426 //
     /*  591390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  591401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  591404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  591407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591436 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  591439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591458 */     GIR_RootConstrainSelectedInstOperands,
     /*  591459 */     // GIR_Coverage, 4426,
     /*  591459 */     GIR_EraseRootFromParent_Done,
     /*  591460 */   // Label 9631: @591460
     /*  591460 */   GIM_Try, /*On fail goto*//*Label 9632*/ GIMT_Encode4(591535), // Rule ID 4427 //
     /*  591465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  591476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  591479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  591482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591511 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  591514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591533 */     GIR_RootConstrainSelectedInstOperands,
     /*  591534 */     // GIR_Coverage, 4427,
     /*  591534 */     GIR_EraseRootFromParent_Done,
     /*  591535 */   // Label 9632: @591535
     /*  591535 */   GIM_Try, /*On fail goto*//*Label 9633*/ GIMT_Encode4(591610), // Rule ID 4430 //
     /*  591540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  591551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  591554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  591557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591586 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  591589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591608 */     GIR_RootConstrainSelectedInstOperands,
     /*  591609 */     // GIR_Coverage, 4430,
     /*  591609 */     GIR_EraseRootFromParent_Done,
     /*  591610 */   // Label 9633: @591610
     /*  591610 */   GIM_Try, /*On fail goto*//*Label 9634*/ GIMT_Encode4(591685), // Rule ID 4431 //
     /*  591615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  591626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  591629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  591632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591661 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11687:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  591664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591683 */     GIR_RootConstrainSelectedInstOperands,
     /*  591684 */     // GIR_Coverage, 4431,
     /*  591684 */     GIR_EraseRootFromParent_Done,
     /*  591685 */   // Label 9634: @591685
     /*  591685 */   GIM_Try, /*On fail goto*//*Label 9635*/ GIMT_Encode4(591760), // Rule ID 4434 //
     /*  591690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  591701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  591704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  591707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  591739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591758 */     GIR_RootConstrainSelectedInstOperands,
     /*  591759 */     // GIR_Coverage, 4434,
     /*  591759 */     GIR_EraseRootFromParent_Done,
     /*  591760 */   // Label 9635: @591760
     /*  591760 */   GIM_Try, /*On fail goto*//*Label 9636*/ GIMT_Encode4(591835), // Rule ID 4435 //
     /*  591765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  591776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  591779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  591782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591811 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  591814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591833 */     GIR_RootConstrainSelectedInstOperands,
     /*  591834 */     // GIR_Coverage, 4435,
     /*  591834 */     GIR_EraseRootFromParent_Done,
     /*  591835 */   // Label 9636: @591835
     /*  591835 */   GIM_Try, /*On fail goto*//*Label 9637*/ GIMT_Encode4(591910), // Rule ID 4438 //
     /*  591840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  591851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  591854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  591857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591886 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  591889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591908 */     GIR_RootConstrainSelectedInstOperands,
     /*  591909 */     // GIR_Coverage, 4438,
     /*  591909 */     GIR_EraseRootFromParent_Done,
     /*  591910 */   // Label 9637: @591910
     /*  591910 */   GIM_Try, /*On fail goto*//*Label 9638*/ GIMT_Encode4(591985), // Rule ID 4439 //
     /*  591915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  591926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  591929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  591932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591961 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  591964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591983 */     GIR_RootConstrainSelectedInstOperands,
     /*  591984 */     // GIR_Coverage, 4439,
     /*  591984 */     GIR_EraseRootFromParent_Done,
     /*  591985 */   // Label 9638: @591985
     /*  591985 */   GIM_Try, /*On fail goto*//*Label 9639*/ GIMT_Encode4(592060), // Rule ID 4442 //
     /*  591990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  592001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  592004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  592007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592036 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592058 */     GIR_RootConstrainSelectedInstOperands,
     /*  592059 */     // GIR_Coverage, 4442,
     /*  592059 */     GIR_EraseRootFromParent_Done,
     /*  592060 */   // Label 9639: @592060
     /*  592060 */   GIM_Try, /*On fail goto*//*Label 9640*/ GIMT_Encode4(592135), // Rule ID 4443 //
     /*  592065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  592076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  592079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  592082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592111 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592133 */     GIR_RootConstrainSelectedInstOperands,
     /*  592134 */     // GIR_Coverage, 4443,
     /*  592134 */     GIR_EraseRootFromParent_Done,
     /*  592135 */   // Label 9640: @592135
     /*  592135 */   GIM_Try, /*On fail goto*//*Label 9641*/ GIMT_Encode4(592210), // Rule ID 4446 //
     /*  592140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  592151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  592154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  592157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  592189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592208 */     GIR_RootConstrainSelectedInstOperands,
     /*  592209 */     // GIR_Coverage, 4446,
     /*  592209 */     GIR_EraseRootFromParent_Done,
     /*  592210 */   // Label 9641: @592210
     /*  592210 */   GIM_Try, /*On fail goto*//*Label 9642*/ GIMT_Encode4(592285), // Rule ID 4447 //
     /*  592215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  592226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  592229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  592232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592261 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  592264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592283 */     GIR_RootConstrainSelectedInstOperands,
     /*  592284 */     // GIR_Coverage, 4447,
     /*  592284 */     GIR_EraseRootFromParent_Done,
     /*  592285 */   // Label 9642: @592285
     /*  592285 */   GIM_Try, /*On fail goto*//*Label 9643*/ GIMT_Encode4(592360), // Rule ID 4450 //
     /*  592290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  592301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  592304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  592307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11687:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592358 */     GIR_RootConstrainSelectedInstOperands,
     /*  592359 */     // GIR_Coverage, 4450,
     /*  592359 */     GIR_EraseRootFromParent_Done,
     /*  592360 */   // Label 9643: @592360
     /*  592360 */   GIM_Try, /*On fail goto*//*Label 9644*/ GIMT_Encode4(592435), // Rule ID 4451 //
     /*  592365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  592376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  592379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  592382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592411 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11687:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592433 */     GIR_RootConstrainSelectedInstOperands,
     /*  592434 */     // GIR_Coverage, 4451,
     /*  592434 */     GIR_EraseRootFromParent_Done,
     /*  592435 */   // Label 9644: @592435
     /*  592435 */   GIM_Try, /*On fail goto*//*Label 9645*/ GIMT_Encode4(592510), // Rule ID 4454 //
     /*  592440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  592451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  592454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  592457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  592489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592508 */     GIR_RootConstrainSelectedInstOperands,
     /*  592509 */     // GIR_Coverage, 4454,
     /*  592509 */     GIR_EraseRootFromParent_Done,
     /*  592510 */   // Label 9645: @592510
     /*  592510 */   GIM_Try, /*On fail goto*//*Label 9646*/ GIMT_Encode4(592585), // Rule ID 4455 //
     /*  592515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  592526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  592529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  592532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592561 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  592564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592583 */     GIR_RootConstrainSelectedInstOperands,
     /*  592584 */     // GIR_Coverage, 4455,
     /*  592584 */     GIR_EraseRootFromParent_Done,
     /*  592585 */   // Label 9646: @592585
     /*  592585 */   GIM_Try, /*On fail goto*//*Label 9647*/ GIMT_Encode4(592660), // Rule ID 4458 //
     /*  592590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  592601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  592604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  592607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592636 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  592639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592658 */     GIR_RootConstrainSelectedInstOperands,
     /*  592659 */     // GIR_Coverage, 4458,
     /*  592659 */     GIR_EraseRootFromParent_Done,
     /*  592660 */   // Label 9647: @592660
     /*  592660 */   GIM_Try, /*On fail goto*//*Label 9648*/ GIMT_Encode4(592735), // Rule ID 4459 //
     /*  592665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  592676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  592679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  592682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592711 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  592714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592733 */     GIR_RootConstrainSelectedInstOperands,
     /*  592734 */     // GIR_Coverage, 4459,
     /*  592734 */     GIR_EraseRootFromParent_Done,
     /*  592735 */   // Label 9648: @592735
     /*  592735 */   GIM_Try, /*On fail goto*//*Label 9649*/ GIMT_Encode4(592810), // Rule ID 4462 //
     /*  592740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  592751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  592754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  592757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592786 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592808 */     GIR_RootConstrainSelectedInstOperands,
     /*  592809 */     // GIR_Coverage, 4462,
     /*  592809 */     GIR_EraseRootFromParent_Done,
     /*  592810 */   // Label 9649: @592810
     /*  592810 */   GIM_Try, /*On fail goto*//*Label 9650*/ GIMT_Encode4(592885), // Rule ID 4463 //
     /*  592815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  592826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  592829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  592832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592861 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592883 */     GIR_RootConstrainSelectedInstOperands,
     /*  592884 */     // GIR_Coverage, 4463,
     /*  592884 */     GIR_EraseRootFromParent_Done,
     /*  592885 */   // Label 9650: @592885
     /*  592885 */   GIM_Try, /*On fail goto*//*Label 9651*/ GIMT_Encode4(592960), // Rule ID 4466 //
     /*  592890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  592901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  592904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  592907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592936 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592958 */     GIR_RootConstrainSelectedInstOperands,
     /*  592959 */     // GIR_Coverage, 4466,
     /*  592959 */     GIR_EraseRootFromParent_Done,
     /*  592960 */   // Label 9651: @592960
     /*  592960 */   GIM_Try, /*On fail goto*//*Label 9652*/ GIMT_Encode4(593035), // Rule ID 4467 //
     /*  592965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  592976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  592979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  592982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593011 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11687:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  593014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593033 */     GIR_RootConstrainSelectedInstOperands,
     /*  593034 */     // GIR_Coverage, 4467,
     /*  593034 */     GIR_EraseRootFromParent_Done,
     /*  593035 */   // Label 9652: @593035
     /*  593035 */   GIM_Try, /*On fail goto*//*Label 9653*/ GIMT_Encode4(593110), // Rule ID 4470 //
     /*  593040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  593051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  593054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  593057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593086 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  593089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593108 */     GIR_RootConstrainSelectedInstOperands,
     /*  593109 */     // GIR_Coverage, 4470,
     /*  593109 */     GIR_EraseRootFromParent_Done,
     /*  593110 */   // Label 9653: @593110
     /*  593110 */   GIM_Try, /*On fail goto*//*Label 9654*/ GIMT_Encode4(593185), // Rule ID 4471 //
     /*  593115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  593126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  593129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  593132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11687:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  593164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593183 */     GIR_RootConstrainSelectedInstOperands,
     /*  593184 */     // GIR_Coverage, 4471,
     /*  593184 */     GIR_EraseRootFromParent_Done,
     /*  593185 */   // Label 9654: @593185
     /*  593185 */   GIM_Try, /*On fail goto*//*Label 9655*/ GIMT_Encode4(593260), // Rule ID 4474 //
     /*  593190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  593201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  593204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  593207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593236 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  593239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593258 */     GIR_RootConstrainSelectedInstOperands,
     /*  593259 */     // GIR_Coverage, 4474,
     /*  593259 */     GIR_EraseRootFromParent_Done,
     /*  593260 */   // Label 9655: @593260
     /*  593260 */   GIM_Try, /*On fail goto*//*Label 9656*/ GIMT_Encode4(593335), // Rule ID 4475 //
     /*  593265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  593276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  593279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  593282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593311 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11687:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  593314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593333 */     GIR_RootConstrainSelectedInstOperands,
     /*  593334 */     // GIR_Coverage, 4475,
     /*  593334 */     GIR_EraseRootFromParent_Done,
     /*  593335 */   // Label 9656: @593335
     /*  593335 */   GIM_Try, /*On fail goto*//*Label 9657*/ GIMT_Encode4(593410), // Rule ID 4478 //
     /*  593340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  593351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  593354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  593357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  593389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593408 */     GIR_RootConstrainSelectedInstOperands,
     /*  593409 */     // GIR_Coverage, 4478,
     /*  593409 */     GIR_EraseRootFromParent_Done,
     /*  593410 */   // Label 9657: @593410
     /*  593410 */   GIM_Try, /*On fail goto*//*Label 9658*/ GIMT_Encode4(593485), // Rule ID 4479 //
     /*  593415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  593426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  593429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  593432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593461 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11687:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  593464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593483 */     GIR_RootConstrainSelectedInstOperands,
     /*  593484 */     // GIR_Coverage, 4479,
     /*  593484 */     GIR_EraseRootFromParent_Done,
     /*  593485 */   // Label 9658: @593485
     /*  593485 */   GIM_Try, /*On fail goto*//*Label 9659*/ GIMT_Encode4(593560), // Rule ID 4484 //
     /*  593490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  593501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  593504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  593507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  593510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593536 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  593539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593558 */     GIR_RootConstrainSelectedInstOperands,
     /*  593559 */     // GIR_Coverage, 4484,
     /*  593559 */     GIR_EraseRootFromParent_Done,
     /*  593560 */   // Label 9659: @593560
     /*  593560 */   GIM_Try, /*On fail goto*//*Label 9660*/ GIMT_Encode4(593635), // Rule ID 4485 //
     /*  593565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  593576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  593579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  593582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  593585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593611 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  593614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593633 */     GIR_RootConstrainSelectedInstOperands,
     /*  593634 */     // GIR_Coverage, 4485,
     /*  593634 */     GIR_EraseRootFromParent_Done,
     /*  593635 */   // Label 9660: @593635
     /*  593635 */   GIM_Try, /*On fail goto*//*Label 9661*/ GIMT_Encode4(593710), // Rule ID 4494 //
     /*  593640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  593651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  593654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  593657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  593660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593686 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  593689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593708 */     GIR_RootConstrainSelectedInstOperands,
     /*  593709 */     // GIR_Coverage, 4494,
     /*  593709 */     GIR_EraseRootFromParent_Done,
     /*  593710 */   // Label 9661: @593710
     /*  593710 */   GIM_Try, /*On fail goto*//*Label 9662*/ GIMT_Encode4(593785), // Rule ID 4495 //
     /*  593715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  593726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  593729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  593732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  593735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593761 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  593764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593783 */     GIR_RootConstrainSelectedInstOperands,
     /*  593784 */     // GIR_Coverage, 4495,
     /*  593784 */     GIR_EraseRootFromParent_Done,
     /*  593785 */   // Label 9662: @593785
     /*  593785 */   GIM_Try, /*On fail goto*//*Label 9663*/ GIMT_Encode4(593860), // Rule ID 4504 //
     /*  593790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  593801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  593804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  593807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  593810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593836 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  593839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593858 */     GIR_RootConstrainSelectedInstOperands,
     /*  593859 */     // GIR_Coverage, 4504,
     /*  593859 */     GIR_EraseRootFromParent_Done,
     /*  593860 */   // Label 9663: @593860
     /*  593860 */   GIM_Try, /*On fail goto*//*Label 9664*/ GIMT_Encode4(593935), // Rule ID 4505 //
     /*  593865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  593876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  593879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  593882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  593885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593911 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  593914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593933 */     GIR_RootConstrainSelectedInstOperands,
     /*  593934 */     // GIR_Coverage, 4505,
     /*  593934 */     GIR_EraseRootFromParent_Done,
     /*  593935 */   // Label 9664: @593935
     /*  593935 */   GIM_Try, /*On fail goto*//*Label 9665*/ GIMT_Encode4(594010), // Rule ID 4514 //
     /*  593940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  593951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  593954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  593957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  593960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  593989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594008 */     GIR_RootConstrainSelectedInstOperands,
     /*  594009 */     // GIR_Coverage, 4514,
     /*  594009 */     GIR_EraseRootFromParent_Done,
     /*  594010 */   // Label 9665: @594010
     /*  594010 */   GIM_Try, /*On fail goto*//*Label 9666*/ GIMT_Encode4(594085), // Rule ID 4515 //
     /*  594015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  594026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  594029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  594032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  594035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594061 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594083 */     GIR_RootConstrainSelectedInstOperands,
     /*  594084 */     // GIR_Coverage, 4515,
     /*  594084 */     GIR_EraseRootFromParent_Done,
     /*  594085 */   // Label 9666: @594085
     /*  594085 */   GIM_Try, /*On fail goto*//*Label 9667*/ GIMT_Encode4(594160), // Rule ID 4524 //
     /*  594090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  594101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  594104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  594107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  594110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594158 */     GIR_RootConstrainSelectedInstOperands,
     /*  594159 */     // GIR_Coverage, 4524,
     /*  594159 */     GIR_EraseRootFromParent_Done,
     /*  594160 */   // Label 9667: @594160
     /*  594160 */   GIM_Try, /*On fail goto*//*Label 9668*/ GIMT_Encode4(594235), // Rule ID 4525 //
     /*  594165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  594176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  594179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  594182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  594185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594211 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594233 */     GIR_RootConstrainSelectedInstOperands,
     /*  594234 */     // GIR_Coverage, 4525,
     /*  594234 */     GIR_EraseRootFromParent_Done,
     /*  594235 */   // Label 9668: @594235
     /*  594235 */   GIM_Try, /*On fail goto*//*Label 9669*/ GIMT_Encode4(594310), // Rule ID 4534 //
     /*  594240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  594251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  594254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  594257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  594260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  594289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594308 */     GIR_RootConstrainSelectedInstOperands,
     /*  594309 */     // GIR_Coverage, 4534,
     /*  594309 */     GIR_EraseRootFromParent_Done,
     /*  594310 */   // Label 9669: @594310
     /*  594310 */   GIM_Try, /*On fail goto*//*Label 9670*/ GIMT_Encode4(594385), // Rule ID 4535 //
     /*  594315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  594326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  594329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  594332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  594335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594361 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  594364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594383 */     GIR_RootConstrainSelectedInstOperands,
     /*  594384 */     // GIR_Coverage, 4535,
     /*  594384 */     GIR_EraseRootFromParent_Done,
     /*  594385 */   // Label 9670: @594385
     /*  594385 */   GIM_Try, /*On fail goto*//*Label 9671*/ GIMT_Encode4(594460), // Rule ID 4544 //
     /*  594390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  594401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  594404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  594407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  594410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594436 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  594439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594458 */     GIR_RootConstrainSelectedInstOperands,
     /*  594459 */     // GIR_Coverage, 4544,
     /*  594459 */     GIR_EraseRootFromParent_Done,
     /*  594460 */   // Label 9671: @594460
     /*  594460 */   GIM_Try, /*On fail goto*//*Label 9672*/ GIMT_Encode4(594535), // Rule ID 4545 //
     /*  594465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  594476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  594479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  594482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  594485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594511 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  594514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594533 */     GIR_RootConstrainSelectedInstOperands,
     /*  594534 */     // GIR_Coverage, 4545,
     /*  594534 */     GIR_EraseRootFromParent_Done,
     /*  594535 */   // Label 9672: @594535
     /*  594535 */   GIM_Try, /*On fail goto*//*Label 9673*/ GIMT_Encode4(594610), // Rule ID 4554 //
     /*  594540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  594551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  594554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  594557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  594560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594586 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  594589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594608 */     GIR_RootConstrainSelectedInstOperands,
     /*  594609 */     // GIR_Coverage, 4554,
     /*  594609 */     GIR_EraseRootFromParent_Done,
     /*  594610 */   // Label 9673: @594610
     /*  594610 */   GIM_Try, /*On fail goto*//*Label 9674*/ GIMT_Encode4(594685), // Rule ID 4555 //
     /*  594615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  594626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  594629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  594632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  594635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594661 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  594664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594683 */     GIR_RootConstrainSelectedInstOperands,
     /*  594684 */     // GIR_Coverage, 4555,
     /*  594684 */     GIR_EraseRootFromParent_Done,
     /*  594685 */   // Label 9674: @594685
     /*  594685 */   GIM_Try, /*On fail goto*//*Label 9675*/ GIMT_Encode4(594760), // Rule ID 4564 //
     /*  594690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  594701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  594704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  594707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  594710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594758 */     GIR_RootConstrainSelectedInstOperands,
     /*  594759 */     // GIR_Coverage, 4564,
     /*  594759 */     GIR_EraseRootFromParent_Done,
     /*  594760 */   // Label 9675: @594760
     /*  594760 */   GIM_Try, /*On fail goto*//*Label 9676*/ GIMT_Encode4(594835), // Rule ID 4565 //
     /*  594765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  594776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  594779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  594782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  594785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594811 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594833 */     GIR_RootConstrainSelectedInstOperands,
     /*  594834 */     // GIR_Coverage, 4565,
     /*  594834 */     GIR_EraseRootFromParent_Done,
     /*  594835 */   // Label 9676: @594835
     /*  594835 */   GIM_Try, /*On fail goto*//*Label 9677*/ GIMT_Encode4(594910), // Rule ID 4574 //
     /*  594840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  594851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  594854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  594857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  594860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594886 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594908 */     GIR_RootConstrainSelectedInstOperands,
     /*  594909 */     // GIR_Coverage, 4574,
     /*  594909 */     GIR_EraseRootFromParent_Done,
     /*  594910 */   // Label 9677: @594910
     /*  594910 */   GIM_Try, /*On fail goto*//*Label 9678*/ GIMT_Encode4(594985), // Rule ID 4575 //
     /*  594915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  594926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  594929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  594932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  594935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594961 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594983 */     GIR_RootConstrainSelectedInstOperands,
     /*  594984 */     // GIR_Coverage, 4575,
     /*  594984 */     GIR_EraseRootFromParent_Done,
     /*  594985 */   // Label 9678: @594985
     /*  594985 */   GIM_Try, /*On fail goto*//*Label 9679*/ GIMT_Encode4(595060), // Rule ID 4584 //
     /*  594990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  595001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  595004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  595007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  595010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595036 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  595036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595058 */     GIR_RootConstrainSelectedInstOperands,
     /*  595059 */     // GIR_Coverage, 4584,
     /*  595059 */     GIR_EraseRootFromParent_Done,
     /*  595060 */   // Label 9679: @595060
     /*  595060 */   GIM_Try, /*On fail goto*//*Label 9680*/ GIMT_Encode4(595135), // Rule ID 4585 //
     /*  595065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  595076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  595079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  595082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  595085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595111 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  595111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595133 */     GIR_RootConstrainSelectedInstOperands,
     /*  595134 */     // GIR_Coverage, 4585,
     /*  595134 */     GIR_EraseRootFromParent_Done,
     /*  595135 */   // Label 9680: @595135
     /*  595135 */   GIM_Try, /*On fail goto*//*Label 9681*/ GIMT_Encode4(595210), // Rule ID 4594 //
     /*  595140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  595151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  595154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  595157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  595160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  595189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595208 */     GIR_RootConstrainSelectedInstOperands,
     /*  595209 */     // GIR_Coverage, 4594,
     /*  595209 */     GIR_EraseRootFromParent_Done,
     /*  595210 */   // Label 9681: @595210
     /*  595210 */   GIM_Try, /*On fail goto*//*Label 9682*/ GIMT_Encode4(595285), // Rule ID 4595 //
     /*  595215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  595226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  595229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  595232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  595235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595261 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  595264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595283 */     GIR_RootConstrainSelectedInstOperands,
     /*  595284 */     // GIR_Coverage, 4595,
     /*  595284 */     GIR_EraseRootFromParent_Done,
     /*  595285 */   // Label 9682: @595285
     /*  595285 */   GIM_Try, /*On fail goto*//*Label 9683*/ GIMT_Encode4(595360), // Rule ID 4604 //
     /*  595290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  595301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  595304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  595307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  595310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595336 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  595339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595358 */     GIR_RootConstrainSelectedInstOperands,
     /*  595359 */     // GIR_Coverage, 4604,
     /*  595359 */     GIR_EraseRootFromParent_Done,
     /*  595360 */   // Label 9683: @595360
     /*  595360 */   GIM_Try, /*On fail goto*//*Label 9684*/ GIMT_Encode4(595435), // Rule ID 4605 //
     /*  595365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  595376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  595379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  595382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  595385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595411 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  595414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595433 */     GIR_RootConstrainSelectedInstOperands,
     /*  595434 */     // GIR_Coverage, 4605,
     /*  595434 */     GIR_EraseRootFromParent_Done,
     /*  595435 */   // Label 9684: @595435
     /*  595435 */   GIM_Try, /*On fail goto*//*Label 9685*/ GIMT_Encode4(595510), // Rule ID 4614 //
     /*  595440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  595451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  595454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  595457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  595460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595486 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  595489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595508 */     GIR_RootConstrainSelectedInstOperands,
     /*  595509 */     // GIR_Coverage, 4614,
     /*  595509 */     GIR_EraseRootFromParent_Done,
     /*  595510 */   // Label 9685: @595510
     /*  595510 */   GIM_Try, /*On fail goto*//*Label 9686*/ GIMT_Encode4(595585), // Rule ID 4615 //
     /*  595515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  595526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  595529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  595532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  595535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595561 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  595564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595583 */     GIR_RootConstrainSelectedInstOperands,
     /*  595584 */     // GIR_Coverage, 4615,
     /*  595584 */     GIR_EraseRootFromParent_Done,
     /*  595585 */   // Label 9686: @595585
     /*  595585 */   GIM_Try, /*On fail goto*//*Label 9687*/ GIMT_Encode4(595660), // Rule ID 4624 //
     /*  595590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  595601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  595604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  595607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  595610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595636 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595658 */     GIR_RootConstrainSelectedInstOperands,
     /*  595659 */     // GIR_Coverage, 4624,
     /*  595659 */     GIR_EraseRootFromParent_Done,
     /*  595660 */   // Label 9687: @595660
     /*  595660 */   GIM_Try, /*On fail goto*//*Label 9688*/ GIMT_Encode4(595735), // Rule ID 4625 //
     /*  595665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  595676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  595679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  595682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  595685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595711 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595733 */     GIR_RootConstrainSelectedInstOperands,
     /*  595734 */     // GIR_Coverage, 4625,
     /*  595734 */     GIR_EraseRootFromParent_Done,
     /*  595735 */   // Label 9688: @595735
     /*  595735 */   GIM_Try, /*On fail goto*//*Label 9689*/ GIMT_Encode4(595810), // Rule ID 4632 //
     /*  595740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  595751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  595754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  595757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  595789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595808 */     GIR_RootConstrainSelectedInstOperands,
     /*  595809 */     // GIR_Coverage, 4632,
     /*  595809 */     GIR_EraseRootFromParent_Done,
     /*  595810 */   // Label 9689: @595810
     /*  595810 */   GIM_Try, /*On fail goto*//*Label 9690*/ GIMT_Encode4(595885), // Rule ID 4633 //
     /*  595815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  595826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  595829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  595832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595861 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  595864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595883 */     GIR_RootConstrainSelectedInstOperands,
     /*  595884 */     // GIR_Coverage, 4633,
     /*  595884 */     GIR_EraseRootFromParent_Done,
     /*  595885 */   // Label 9690: @595885
     /*  595885 */   GIM_Try, /*On fail goto*//*Label 9691*/ GIMT_Encode4(595960), // Rule ID 4636 //
     /*  595890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  595901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  595904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  595907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595936 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  595939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595958 */     GIR_RootConstrainSelectedInstOperands,
     /*  595959 */     // GIR_Coverage, 4636,
     /*  595959 */     GIR_EraseRootFromParent_Done,
     /*  595960 */   // Label 9691: @595960
     /*  595960 */   GIM_Try, /*On fail goto*//*Label 9692*/ GIMT_Encode4(596035), // Rule ID 4637 //
     /*  595965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  595976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  595979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  595982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596011 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  596014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596033 */     GIR_RootConstrainSelectedInstOperands,
     /*  596034 */     // GIR_Coverage, 4637,
     /*  596034 */     GIR_EraseRootFromParent_Done,
     /*  596035 */   // Label 9692: @596035
     /*  596035 */   GIM_Try, /*On fail goto*//*Label 9693*/ GIMT_Encode4(596110), // Rule ID 4640 //
     /*  596040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  596051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  596054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  596057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596108 */     GIR_RootConstrainSelectedInstOperands,
     /*  596109 */     // GIR_Coverage, 4640,
     /*  596109 */     GIR_EraseRootFromParent_Done,
     /*  596110 */   // Label 9693: @596110
     /*  596110 */   GIM_Try, /*On fail goto*//*Label 9694*/ GIMT_Encode4(596185), // Rule ID 4641 //
     /*  596115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  596126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  596129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  596132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596161 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596183 */     GIR_RootConstrainSelectedInstOperands,
     /*  596184 */     // GIR_Coverage, 4641,
     /*  596184 */     GIR_EraseRootFromParent_Done,
     /*  596185 */   // Label 9694: @596185
     /*  596185 */   GIM_Try, /*On fail goto*//*Label 9695*/ GIMT_Encode4(596260), // Rule ID 4644 //
     /*  596190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  596201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  596204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  596207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596236 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  596239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596258 */     GIR_RootConstrainSelectedInstOperands,
     /*  596259 */     // GIR_Coverage, 4644,
     /*  596259 */     GIR_EraseRootFromParent_Done,
     /*  596260 */   // Label 9695: @596260
     /*  596260 */   GIM_Try, /*On fail goto*//*Label 9696*/ GIMT_Encode4(596335), // Rule ID 4645 //
     /*  596265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  596276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  596279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  596282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596311 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  596314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596333 */     GIR_RootConstrainSelectedInstOperands,
     /*  596334 */     // GIR_Coverage, 4645,
     /*  596334 */     GIR_EraseRootFromParent_Done,
     /*  596335 */   // Label 9696: @596335
     /*  596335 */   GIM_Try, /*On fail goto*//*Label 9697*/ GIMT_Encode4(596410), // Rule ID 4648 //
     /*  596340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  596351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  596354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  596357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596386 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  596389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596408 */     GIR_RootConstrainSelectedInstOperands,
     /*  596409 */     // GIR_Coverage, 4648,
     /*  596409 */     GIR_EraseRootFromParent_Done,
     /*  596410 */   // Label 9697: @596410
     /*  596410 */   GIM_Try, /*On fail goto*//*Label 9698*/ GIMT_Encode4(596485), // Rule ID 4649 //
     /*  596415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  596426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  596429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  596432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596461 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  596464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596483 */     GIR_RootConstrainSelectedInstOperands,
     /*  596484 */     // GIR_Coverage, 4649,
     /*  596484 */     GIR_EraseRootFromParent_Done,
     /*  596485 */   // Label 9698: @596485
     /*  596485 */   GIM_Try, /*On fail goto*//*Label 9699*/ GIMT_Encode4(596560), // Rule ID 4652 //
     /*  596490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  596501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  596504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  596507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596536 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  596539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596558 */     GIR_RootConstrainSelectedInstOperands,
     /*  596559 */     // GIR_Coverage, 4652,
     /*  596559 */     GIR_EraseRootFromParent_Done,
     /*  596560 */   // Label 9699: @596560
     /*  596560 */   GIM_Try, /*On fail goto*//*Label 9700*/ GIMT_Encode4(596635), // Rule ID 4653 //
     /*  596565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  596576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  596579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  596582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596611 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  596614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596633 */     GIR_RootConstrainSelectedInstOperands,
     /*  596634 */     // GIR_Coverage, 4653,
     /*  596634 */     GIR_EraseRootFromParent_Done,
     /*  596635 */   // Label 9700: @596635
     /*  596635 */   GIM_Try, /*On fail goto*//*Label 9701*/ GIMT_Encode4(596710), // Rule ID 4656 //
     /*  596640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  596651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  596654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  596657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596686 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  596689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596708 */     GIR_RootConstrainSelectedInstOperands,
     /*  596709 */     // GIR_Coverage, 4656,
     /*  596709 */     GIR_EraseRootFromParent_Done,
     /*  596710 */   // Label 9701: @596710
     /*  596710 */   GIM_Try, /*On fail goto*//*Label 9702*/ GIMT_Encode4(596785), // Rule ID 4657 //
     /*  596715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  596726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  596729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  596732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596761 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  596764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596783 */     GIR_RootConstrainSelectedInstOperands,
     /*  596784 */     // GIR_Coverage, 4657,
     /*  596784 */     GIR_EraseRootFromParent_Done,
     /*  596785 */   // Label 9702: @596785
     /*  596785 */   GIM_Try, /*On fail goto*//*Label 9703*/ GIMT_Encode4(596860), // Rule ID 4660 //
     /*  596790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  596801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  596804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  596807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596836 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596858 */     GIR_RootConstrainSelectedInstOperands,
     /*  596859 */     // GIR_Coverage, 4660,
     /*  596859 */     GIR_EraseRootFromParent_Done,
     /*  596860 */   // Label 9703: @596860
     /*  596860 */   GIM_Try, /*On fail goto*//*Label 9704*/ GIMT_Encode4(596935), // Rule ID 4661 //
     /*  596865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  596876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  596879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  596882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596911 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596933 */     GIR_RootConstrainSelectedInstOperands,
     /*  596934 */     // GIR_Coverage, 4661,
     /*  596934 */     GIR_EraseRootFromParent_Done,
     /*  596935 */   // Label 9704: @596935
     /*  596935 */   GIM_Try, /*On fail goto*//*Label 9705*/ GIMT_Encode4(597010), // Rule ID 4664 //
     /*  596940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  596951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  596954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  596957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  596989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597008 */     GIR_RootConstrainSelectedInstOperands,
     /*  597009 */     // GIR_Coverage, 4664,
     /*  597009 */     GIR_EraseRootFromParent_Done,
     /*  597010 */   // Label 9705: @597010
     /*  597010 */   GIM_Try, /*On fail goto*//*Label 9706*/ GIMT_Encode4(597085), // Rule ID 4665 //
     /*  597015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  597026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  597029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  597032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  597064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597083 */     GIR_RootConstrainSelectedInstOperands,
     /*  597084 */     // GIR_Coverage, 4665,
     /*  597084 */     GIR_EraseRootFromParent_Done,
     /*  597085 */   // Label 9706: @597085
     /*  597085 */   GIM_Try, /*On fail goto*//*Label 9707*/ GIMT_Encode4(597160), // Rule ID 4668 //
     /*  597090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  597101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  597104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  597107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597136 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597158 */     GIR_RootConstrainSelectedInstOperands,
     /*  597159 */     // GIR_Coverage, 4668,
     /*  597159 */     GIR_EraseRootFromParent_Done,
     /*  597160 */   // Label 9707: @597160
     /*  597160 */   GIM_Try, /*On fail goto*//*Label 9708*/ GIMT_Encode4(597235), // Rule ID 4669 //
     /*  597165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  597176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  597179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  597182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597211 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597233 */     GIR_RootConstrainSelectedInstOperands,
     /*  597234 */     // GIR_Coverage, 4669,
     /*  597234 */     GIR_EraseRootFromParent_Done,
     /*  597235 */   // Label 9708: @597235
     /*  597235 */   GIM_Try, /*On fail goto*//*Label 9709*/ GIMT_Encode4(597310), // Rule ID 4672 //
     /*  597240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  597251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  597254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  597257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597286 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597308 */     GIR_RootConstrainSelectedInstOperands,
     /*  597309 */     // GIR_Coverage, 4672,
     /*  597309 */     GIR_EraseRootFromParent_Done,
     /*  597310 */   // Label 9709: @597310
     /*  597310 */   GIM_Try, /*On fail goto*//*Label 9710*/ GIMT_Encode4(597385), // Rule ID 4673 //
     /*  597315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  597326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  597329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  597332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597361 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597383 */     GIR_RootConstrainSelectedInstOperands,
     /*  597384 */     // GIR_Coverage, 4673,
     /*  597384 */     GIR_EraseRootFromParent_Done,
     /*  597385 */   // Label 9710: @597385
     /*  597385 */   GIM_Try, /*On fail goto*//*Label 9711*/ GIMT_Encode4(597460), // Rule ID 4676 //
     /*  597390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  597401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  597404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  597407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597436 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  597439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597458 */     GIR_RootConstrainSelectedInstOperands,
     /*  597459 */     // GIR_Coverage, 4676,
     /*  597459 */     GIR_EraseRootFromParent_Done,
     /*  597460 */   // Label 9711: @597460
     /*  597460 */   GIM_Try, /*On fail goto*//*Label 9712*/ GIMT_Encode4(597535), // Rule ID 4677 //
     /*  597465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  597476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  597479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  597482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597511 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  597514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597533 */     GIR_RootConstrainSelectedInstOperands,
     /*  597534 */     // GIR_Coverage, 4677,
     /*  597534 */     GIR_EraseRootFromParent_Done,
     /*  597535 */   // Label 9712: @597535
     /*  597535 */   GIM_Try, /*On fail goto*//*Label 9713*/ GIMT_Encode4(597610), // Rule ID 4680 //
     /*  597540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  597551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  597554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  597557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  597589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597608 */     GIR_RootConstrainSelectedInstOperands,
     /*  597609 */     // GIR_Coverage, 4680,
     /*  597609 */     GIR_EraseRootFromParent_Done,
     /*  597610 */   // Label 9713: @597610
     /*  597610 */   GIM_Try, /*On fail goto*//*Label 9714*/ GIMT_Encode4(597685), // Rule ID 4681 //
     /*  597615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  597626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  597629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  597632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597661 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  597664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597683 */     GIR_RootConstrainSelectedInstOperands,
     /*  597684 */     // GIR_Coverage, 4681,
     /*  597684 */     GIR_EraseRootFromParent_Done,
     /*  597685 */   // Label 9714: @597685
     /*  597685 */   GIM_Try, /*On fail goto*//*Label 9715*/ GIMT_Encode4(597760), // Rule ID 4684 //
     /*  597690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  597701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  597704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  597707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597736 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597758 */     GIR_RootConstrainSelectedInstOperands,
     /*  597759 */     // GIR_Coverage, 4684,
     /*  597759 */     GIR_EraseRootFromParent_Done,
     /*  597760 */   // Label 9715: @597760
     /*  597760 */   GIM_Try, /*On fail goto*//*Label 9716*/ GIMT_Encode4(597835), // Rule ID 4685 //
     /*  597765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  597776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  597779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  597782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597811 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597833 */     GIR_RootConstrainSelectedInstOperands,
     /*  597834 */     // GIR_Coverage, 4685,
     /*  597834 */     GIR_EraseRootFromParent_Done,
     /*  597835 */   // Label 9716: @597835
     /*  597835 */   GIM_Try, /*On fail goto*//*Label 9717*/ GIMT_Encode4(597910), // Rule ID 4688 //
     /*  597840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  597851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  597854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  597857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597908 */     GIR_RootConstrainSelectedInstOperands,
     /*  597909 */     // GIR_Coverage, 4688,
     /*  597909 */     GIR_EraseRootFromParent_Done,
     /*  597910 */   // Label 9717: @597910
     /*  597910 */   GIM_Try, /*On fail goto*//*Label 9718*/ GIMT_Encode4(597985), // Rule ID 4689 //
     /*  597915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  597926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  597929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  597932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597961 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597983 */     GIR_RootConstrainSelectedInstOperands,
     /*  597984 */     // GIR_Coverage, 4689,
     /*  597984 */     GIR_EraseRootFromParent_Done,
     /*  597985 */   // Label 9718: @597985
     /*  597985 */   GIM_Try, /*On fail goto*//*Label 9719*/ GIMT_Encode4(598060), // Rule ID 4694 //
     /*  597990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  597998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  598001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  598004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  598007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  598010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598036 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  598039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598058 */     GIR_RootConstrainSelectedInstOperands,
     /*  598059 */     // GIR_Coverage, 4694,
     /*  598059 */     GIR_EraseRootFromParent_Done,
     /*  598060 */   // Label 9719: @598060
     /*  598060 */   GIM_Try, /*On fail goto*//*Label 9720*/ GIMT_Encode4(598135), // Rule ID 4695 //
     /*  598065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  598076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  598079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  598082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  598085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598111 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  598114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598133 */     GIR_RootConstrainSelectedInstOperands,
     /*  598134 */     // GIR_Coverage, 4695,
     /*  598134 */     GIR_EraseRootFromParent_Done,
     /*  598135 */   // Label 9720: @598135
     /*  598135 */   GIM_Try, /*On fail goto*//*Label 9721*/ GIMT_Encode4(598210), // Rule ID 4704 //
     /*  598140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  598151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  598154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  598157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  598160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598186 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  598189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598208 */     GIR_RootConstrainSelectedInstOperands,
     /*  598209 */     // GIR_Coverage, 4704,
     /*  598209 */     GIR_EraseRootFromParent_Done,
     /*  598210 */   // Label 9721: @598210
     /*  598210 */   GIM_Try, /*On fail goto*//*Label 9722*/ GIMT_Encode4(598285), // Rule ID 4705 //
     /*  598215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  598226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  598229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  598232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  598235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598261 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  598264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598283 */     GIR_RootConstrainSelectedInstOperands,
     /*  598284 */     // GIR_Coverage, 4705,
     /*  598284 */     GIR_EraseRootFromParent_Done,
     /*  598285 */   // Label 9722: @598285
     /*  598285 */   GIM_Try, /*On fail goto*//*Label 9723*/ GIMT_Encode4(598360), // Rule ID 4714 //
     /*  598290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  598301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  598304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  598307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  598310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598336 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  598339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598358 */     GIR_RootConstrainSelectedInstOperands,
     /*  598359 */     // GIR_Coverage, 4714,
     /*  598359 */     GIR_EraseRootFromParent_Done,
     /*  598360 */   // Label 9723: @598360
     /*  598360 */   GIM_Try, /*On fail goto*//*Label 9724*/ GIMT_Encode4(598435), // Rule ID 4715 //
     /*  598365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  598376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  598379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  598382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  598385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598411 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  598414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598433 */     GIR_RootConstrainSelectedInstOperands,
     /*  598434 */     // GIR_Coverage, 4715,
     /*  598434 */     GIR_EraseRootFromParent_Done,
     /*  598435 */   // Label 9724: @598435
     /*  598435 */   GIM_Try, /*On fail goto*//*Label 9725*/ GIMT_Encode4(598510), // Rule ID 4724 //
     /*  598440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  598451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  598454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  598457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  598460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598486 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  598489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598508 */     GIR_RootConstrainSelectedInstOperands,
     /*  598509 */     // GIR_Coverage, 4724,
     /*  598509 */     GIR_EraseRootFromParent_Done,
     /*  598510 */   // Label 9725: @598510
     /*  598510 */   GIM_Try, /*On fail goto*//*Label 9726*/ GIMT_Encode4(598585), // Rule ID 4725 //
     /*  598515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  598526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  598529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  598532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  598535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598561 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  598564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598583 */     GIR_RootConstrainSelectedInstOperands,
     /*  598584 */     // GIR_Coverage, 4725,
     /*  598584 */     GIR_EraseRootFromParent_Done,
     /*  598585 */   // Label 9726: @598585
     /*  598585 */   GIM_Try, /*On fail goto*//*Label 9727*/ GIMT_Encode4(598660), // Rule ID 4734 //
     /*  598590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  598601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  598604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  598607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  598610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598636 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  598639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598658 */     GIR_RootConstrainSelectedInstOperands,
     /*  598659 */     // GIR_Coverage, 4734,
     /*  598659 */     GIR_EraseRootFromParent_Done,
     /*  598660 */   // Label 9727: @598660
     /*  598660 */   GIM_Try, /*On fail goto*//*Label 9728*/ GIMT_Encode4(598735), // Rule ID 4735 //
     /*  598665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  598676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  598679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  598682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  598685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598711 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  598714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598733 */     GIR_RootConstrainSelectedInstOperands,
     /*  598734 */     // GIR_Coverage, 4735,
     /*  598734 */     GIR_EraseRootFromParent_Done,
     /*  598735 */   // Label 9728: @598735
     /*  598735 */   GIM_Try, /*On fail goto*//*Label 9729*/ GIMT_Encode4(598810), // Rule ID 4744 //
     /*  598740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  598751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  598754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  598757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  598760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598786 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  598789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598808 */     GIR_RootConstrainSelectedInstOperands,
     /*  598809 */     // GIR_Coverage, 4744,
     /*  598809 */     GIR_EraseRootFromParent_Done,
     /*  598810 */   // Label 9729: @598810
     /*  598810 */   GIM_Try, /*On fail goto*//*Label 9730*/ GIMT_Encode4(598885), // Rule ID 4745 //
     /*  598815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  598826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  598829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  598832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  598835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598861 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  598864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598883 */     GIR_RootConstrainSelectedInstOperands,
     /*  598884 */     // GIR_Coverage, 4745,
     /*  598884 */     GIR_EraseRootFromParent_Done,
     /*  598885 */   // Label 9730: @598885
     /*  598885 */   GIM_Try, /*On fail goto*//*Label 9731*/ GIMT_Encode4(598960), // Rule ID 4754 //
     /*  598890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  598901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  598904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  598907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  598910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598936 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  598939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598958 */     GIR_RootConstrainSelectedInstOperands,
     /*  598959 */     // GIR_Coverage, 4754,
     /*  598959 */     GIR_EraseRootFromParent_Done,
     /*  598960 */   // Label 9731: @598960
     /*  598960 */   GIM_Try, /*On fail goto*//*Label 9732*/ GIMT_Encode4(599035), // Rule ID 4755 //
     /*  598965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  598976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  598979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  598982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  598985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599011 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  599014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599033 */     GIR_RootConstrainSelectedInstOperands,
     /*  599034 */     // GIR_Coverage, 4755,
     /*  599034 */     GIR_EraseRootFromParent_Done,
     /*  599035 */   // Label 9732: @599035
     /*  599035 */   GIM_Try, /*On fail goto*//*Label 9733*/ GIMT_Encode4(599110), // Rule ID 4764 //
     /*  599040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  599051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  599054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  599057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  599060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599086 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11683:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599108 */     GIR_RootConstrainSelectedInstOperands,
     /*  599109 */     // GIR_Coverage, 4764,
     /*  599109 */     GIR_EraseRootFromParent_Done,
     /*  599110 */   // Label 9733: @599110
     /*  599110 */   GIM_Try, /*On fail goto*//*Label 9734*/ GIMT_Encode4(599185), // Rule ID 4765 //
     /*  599115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  599126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  599129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  599132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  599135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599161 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11683:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599183 */     GIR_RootConstrainSelectedInstOperands,
     /*  599184 */     // GIR_Coverage, 4765,
     /*  599184 */     GIR_EraseRootFromParent_Done,
     /*  599185 */   // Label 9734: @599185
     /*  599185 */   GIM_Try, /*On fail goto*//*Label 9735*/ GIMT_Encode4(599260), // Rule ID 4774 //
     /*  599190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  599201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  599204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  599207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  599210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599258 */     GIR_RootConstrainSelectedInstOperands,
     /*  599259 */     // GIR_Coverage, 4774,
     /*  599259 */     GIR_EraseRootFromParent_Done,
     /*  599260 */   // Label 9735: @599260
     /*  599260 */   GIM_Try, /*On fail goto*//*Label 9736*/ GIMT_Encode4(599335), // Rule ID 4775 //
     /*  599265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  599276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  599279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  599282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  599285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599311 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599333 */     GIR_RootConstrainSelectedInstOperands,
     /*  599334 */     // GIR_Coverage, 4775,
     /*  599334 */     GIR_EraseRootFromParent_Done,
     /*  599335 */   // Label 9736: @599335
     /*  599335 */   GIM_Try, /*On fail goto*//*Label 9737*/ GIMT_Encode4(599410), // Rule ID 4784 //
     /*  599340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  599351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  599354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  599357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  599360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599386 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599408 */     GIR_RootConstrainSelectedInstOperands,
     /*  599409 */     // GIR_Coverage, 4784,
     /*  599409 */     GIR_EraseRootFromParent_Done,
     /*  599410 */   // Label 9737: @599410
     /*  599410 */   GIM_Try, /*On fail goto*//*Label 9738*/ GIMT_Encode4(599485), // Rule ID 4785 //
     /*  599415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  599426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  599429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  599432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  599435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599461 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599483 */     GIR_RootConstrainSelectedInstOperands,
     /*  599484 */     // GIR_Coverage, 4785,
     /*  599484 */     GIR_EraseRootFromParent_Done,
     /*  599485 */   // Label 9738: @599485
     /*  599485 */   GIM_Try, /*On fail goto*//*Label 9739*/ GIMT_Encode4(599560), // Rule ID 4794 //
     /*  599490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  599501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  599504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  599507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  599510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  599539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599558 */     GIR_RootConstrainSelectedInstOperands,
     /*  599559 */     // GIR_Coverage, 4794,
     /*  599559 */     GIR_EraseRootFromParent_Done,
     /*  599560 */   // Label 9739: @599560
     /*  599560 */   GIM_Try, /*On fail goto*//*Label 9740*/ GIMT_Encode4(599635), // Rule ID 4795 //
     /*  599565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  599576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  599579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  599582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  599585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599611 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  599614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599633 */     GIR_RootConstrainSelectedInstOperands,
     /*  599634 */     // GIR_Coverage, 4795,
     /*  599634 */     GIR_EraseRootFromParent_Done,
     /*  599635 */   // Label 9740: @599635
     /*  599635 */   GIM_Try, /*On fail goto*//*Label 9741*/ GIMT_Encode4(599710), // Rule ID 4804 //
     /*  599640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  599651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  599654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  599657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  599660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599686 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599708 */     GIR_RootConstrainSelectedInstOperands,
     /*  599709 */     // GIR_Coverage, 4804,
     /*  599709 */     GIR_EraseRootFromParent_Done,
     /*  599710 */   // Label 9741: @599710
     /*  599710 */   GIM_Try, /*On fail goto*//*Label 9742*/ GIMT_Encode4(599785), // Rule ID 4805 //
     /*  599715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  599726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  599729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  599732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  599735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599761 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599783 */     GIR_RootConstrainSelectedInstOperands,
     /*  599784 */     // GIR_Coverage, 4805,
     /*  599784 */     GIR_EraseRootFromParent_Done,
     /*  599785 */   // Label 9742: @599785
     /*  599785 */   GIM_Try, /*On fail goto*//*Label 9743*/ GIMT_Encode4(599860), // Rule ID 4814 //
     /*  599790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  599801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  599804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  599807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  599810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599858 */     GIR_RootConstrainSelectedInstOperands,
     /*  599859 */     // GIR_Coverage, 4814,
     /*  599859 */     GIR_EraseRootFromParent_Done,
     /*  599860 */   // Label 9743: @599860
     /*  599860 */   GIM_Try, /*On fail goto*//*Label 9744*/ GIMT_Encode4(599935), // Rule ID 4815 //
     /*  599865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  599876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  599879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  599882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  599885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599911 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599933 */     GIR_RootConstrainSelectedInstOperands,
     /*  599934 */     // GIR_Coverage, 4815,
     /*  599934 */     GIR_EraseRootFromParent_Done,
     /*  599935 */   // Label 9744: @599935
     /*  599935 */   GIM_Try, /*On fail goto*//*Label 9745*/ GIMT_Encode4(600010), // Rule ID 4824 //
     /*  599940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  599951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  599954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  599957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  599960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600008 */     GIR_RootConstrainSelectedInstOperands,
     /*  600009 */     // GIR_Coverage, 4824,
     /*  600009 */     GIR_EraseRootFromParent_Done,
     /*  600010 */   // Label 9745: @600010
     /*  600010 */   GIM_Try, /*On fail goto*//*Label 9746*/ GIMT_Encode4(600085), // Rule ID 4825 //
     /*  600015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  600018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  600026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  600029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  600032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  600035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600061 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  600061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  600064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600083 */     GIR_RootConstrainSelectedInstOperands,
     /*  600084 */     // GIR_Coverage, 4825,
     /*  600084 */     GIR_EraseRootFromParent_Done,
     /*  600085 */   // Label 9746: @600085
     /*  600085 */   GIM_Try, /*On fail goto*//*Label 9747*/ GIMT_Encode4(600160), // Rule ID 4834 //
     /*  600090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  600093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  600101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  600104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  600107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  600110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600136 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  600136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  600139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600158 */     GIR_RootConstrainSelectedInstOperands,
     /*  600159 */     // GIR_Coverage, 4834,
     /*  600159 */     GIR_EraseRootFromParent_Done,
     /*  600160 */   // Label 9747: @600160
     /*  600160 */   GIM_Try, /*On fail goto*//*Label 9748*/ GIMT_Encode4(600235), // Rule ID 4835 //
     /*  600165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  600168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  600176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  600179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  600182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  600185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600211 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  600211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  600214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600233 */     GIR_RootConstrainSelectedInstOperands,
     /*  600234 */     // GIR_Coverage, 4835,
     /*  600234 */     GIR_EraseRootFromParent_Done,
     /*  600235 */   // Label 9748: @600235
     /*  600235 */   GIM_Try, /*On fail goto*//*Label 9749*/ GIMT_Encode4(600310), // Rule ID 4842 //
     /*  600240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  600251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  600254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  600257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600286 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  600289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600308 */     GIR_RootConstrainSelectedInstOperands,
     /*  600309 */     // GIR_Coverage, 4842,
     /*  600309 */     GIR_EraseRootFromParent_Done,
     /*  600310 */   // Label 9749: @600310
     /*  600310 */   GIM_Try, /*On fail goto*//*Label 9750*/ GIMT_Encode4(600385), // Rule ID 4843 //
     /*  600315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  600326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  600329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  600332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600361 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  600364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600383 */     GIR_RootConstrainSelectedInstOperands,
     /*  600384 */     // GIR_Coverage, 4843,
     /*  600384 */     GIR_EraseRootFromParent_Done,
     /*  600385 */   // Label 9750: @600385
     /*  600385 */   GIM_Try, /*On fail goto*//*Label 9751*/ GIMT_Encode4(600460), // Rule ID 4846 //
     /*  600390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  600401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  600404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  600407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600436 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  600439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600458 */     GIR_RootConstrainSelectedInstOperands,
     /*  600459 */     // GIR_Coverage, 4846,
     /*  600459 */     GIR_EraseRootFromParent_Done,
     /*  600460 */   // Label 9751: @600460
     /*  600460 */   GIM_Try, /*On fail goto*//*Label 9752*/ GIMT_Encode4(600535), // Rule ID 4847 //
     /*  600465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  600476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  600479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  600482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600511 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  600514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600533 */     GIR_RootConstrainSelectedInstOperands,
     /*  600534 */     // GIR_Coverage, 4847,
     /*  600534 */     GIR_EraseRootFromParent_Done,
     /*  600535 */   // Label 9752: @600535
     /*  600535 */   GIM_Try, /*On fail goto*//*Label 9753*/ GIMT_Encode4(600610), // Rule ID 4850 //
     /*  600540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  600551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  600554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  600557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600586 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  600589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600608 */     GIR_RootConstrainSelectedInstOperands,
     /*  600609 */     // GIR_Coverage, 4850,
     /*  600609 */     GIR_EraseRootFromParent_Done,
     /*  600610 */   // Label 9753: @600610
     /*  600610 */   GIM_Try, /*On fail goto*//*Label 9754*/ GIMT_Encode4(600685), // Rule ID 4851 //
     /*  600615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  600626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  600629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  600632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600661 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11683:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  600664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600683 */     GIR_RootConstrainSelectedInstOperands,
     /*  600684 */     // GIR_Coverage, 4851,
     /*  600684 */     GIR_EraseRootFromParent_Done,
     /*  600685 */   // Label 9754: @600685
     /*  600685 */   GIM_Try, /*On fail goto*//*Label 9755*/ GIMT_Encode4(600760), // Rule ID 4854 //
     /*  600690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  600701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  600704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  600707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  600739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600758 */     GIR_RootConstrainSelectedInstOperands,
     /*  600759 */     // GIR_Coverage, 4854,
     /*  600759 */     GIR_EraseRootFromParent_Done,
     /*  600760 */   // Label 9755: @600760
     /*  600760 */   GIM_Try, /*On fail goto*//*Label 9756*/ GIMT_Encode4(600835), // Rule ID 4855 //
     /*  600765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  600776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  600779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  600782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600811 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  600814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600833 */     GIR_RootConstrainSelectedInstOperands,
     /*  600834 */     // GIR_Coverage, 4855,
     /*  600834 */     GIR_EraseRootFromParent_Done,
     /*  600835 */   // Label 9756: @600835
     /*  600835 */   GIM_Try, /*On fail goto*//*Label 9757*/ GIMT_Encode4(600910), // Rule ID 4858 //
     /*  600840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  600851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  600854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  600857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600886 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  600889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600908 */     GIR_RootConstrainSelectedInstOperands,
     /*  600909 */     // GIR_Coverage, 4858,
     /*  600909 */     GIR_EraseRootFromParent_Done,
     /*  600910 */   // Label 9757: @600910
     /*  600910 */   GIM_Try, /*On fail goto*//*Label 9758*/ GIMT_Encode4(600985), // Rule ID 4859 //
     /*  600915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  600926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  600929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  600932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600961 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  600964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600983 */     GIR_RootConstrainSelectedInstOperands,
     /*  600984 */     // GIR_Coverage, 4859,
     /*  600984 */     GIR_EraseRootFromParent_Done,
     /*  600985 */   // Label 9758: @600985
     /*  600985 */   GIM_Try, /*On fail goto*//*Label 9759*/ GIMT_Encode4(601060), // Rule ID 4862 //
     /*  600990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  601001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  601004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  601007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601036 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  601036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601058 */     GIR_RootConstrainSelectedInstOperands,
     /*  601059 */     // GIR_Coverage, 4862,
     /*  601059 */     GIR_EraseRootFromParent_Done,
     /*  601060 */   // Label 9759: @601060
     /*  601060 */   GIM_Try, /*On fail goto*//*Label 9760*/ GIMT_Encode4(601135), // Rule ID 4863 //
     /*  601065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  601076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  601079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  601082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601111 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  601111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601133 */     GIR_RootConstrainSelectedInstOperands,
     /*  601134 */     // GIR_Coverage, 4863,
     /*  601134 */     GIR_EraseRootFromParent_Done,
     /*  601135 */   // Label 9760: @601135
     /*  601135 */   GIM_Try, /*On fail goto*//*Label 9761*/ GIMT_Encode4(601210), // Rule ID 4866 //
     /*  601140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  601151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  601154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  601157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  601189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601208 */     GIR_RootConstrainSelectedInstOperands,
     /*  601209 */     // GIR_Coverage, 4866,
     /*  601209 */     GIR_EraseRootFromParent_Done,
     /*  601210 */   // Label 9761: @601210
     /*  601210 */   GIM_Try, /*On fail goto*//*Label 9762*/ GIMT_Encode4(601285), // Rule ID 4867 //
     /*  601215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  601226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  601229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  601232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601261 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  601264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601283 */     GIR_RootConstrainSelectedInstOperands,
     /*  601284 */     // GIR_Coverage, 4867,
     /*  601284 */     GIR_EraseRootFromParent_Done,
     /*  601285 */   // Label 9762: @601285
     /*  601285 */   GIM_Try, /*On fail goto*//*Label 9763*/ GIMT_Encode4(601360), // Rule ID 4870 //
     /*  601290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  601301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  601304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  601307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11683:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601358 */     GIR_RootConstrainSelectedInstOperands,
     /*  601359 */     // GIR_Coverage, 4870,
     /*  601359 */     GIR_EraseRootFromParent_Done,
     /*  601360 */   // Label 9763: @601360
     /*  601360 */   GIM_Try, /*On fail goto*//*Label 9764*/ GIMT_Encode4(601435), // Rule ID 4871 //
     /*  601365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  601376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  601379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  601382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601411 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11683:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601433 */     GIR_RootConstrainSelectedInstOperands,
     /*  601434 */     // GIR_Coverage, 4871,
     /*  601434 */     GIR_EraseRootFromParent_Done,
     /*  601435 */   // Label 9764: @601435
     /*  601435 */   GIM_Try, /*On fail goto*//*Label 9765*/ GIMT_Encode4(601510), // Rule ID 4874 //
     /*  601440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  601451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  601454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  601457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  601489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601508 */     GIR_RootConstrainSelectedInstOperands,
     /*  601509 */     // GIR_Coverage, 4874,
     /*  601509 */     GIR_EraseRootFromParent_Done,
     /*  601510 */   // Label 9765: @601510
     /*  601510 */   GIM_Try, /*On fail goto*//*Label 9766*/ GIMT_Encode4(601585), // Rule ID 4875 //
     /*  601515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  601526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  601529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  601532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601561 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  601564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601583 */     GIR_RootConstrainSelectedInstOperands,
     /*  601584 */     // GIR_Coverage, 4875,
     /*  601584 */     GIR_EraseRootFromParent_Done,
     /*  601585 */   // Label 9766: @601585
     /*  601585 */   GIM_Try, /*On fail goto*//*Label 9767*/ GIMT_Encode4(601660), // Rule ID 4878 //
     /*  601590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  601601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  601604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  601607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601636 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  601639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601658 */     GIR_RootConstrainSelectedInstOperands,
     /*  601659 */     // GIR_Coverage, 4878,
     /*  601659 */     GIR_EraseRootFromParent_Done,
     /*  601660 */   // Label 9767: @601660
     /*  601660 */   GIM_Try, /*On fail goto*//*Label 9768*/ GIMT_Encode4(601735), // Rule ID 4879 //
     /*  601665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  601676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  601679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  601682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601711 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  601714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601733 */     GIR_RootConstrainSelectedInstOperands,
     /*  601734 */     // GIR_Coverage, 4879,
     /*  601734 */     GIR_EraseRootFromParent_Done,
     /*  601735 */   // Label 9768: @601735
     /*  601735 */   GIM_Try, /*On fail goto*//*Label 9769*/ GIMT_Encode4(601810), // Rule ID 4882 //
     /*  601740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  601751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  601754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  601757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601786 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601808 */     GIR_RootConstrainSelectedInstOperands,
     /*  601809 */     // GIR_Coverage, 4882,
     /*  601809 */     GIR_EraseRootFromParent_Done,
     /*  601810 */   // Label 9769: @601810
     /*  601810 */   GIM_Try, /*On fail goto*//*Label 9770*/ GIMT_Encode4(601885), // Rule ID 4883 //
     /*  601815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  601826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  601829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  601832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601861 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601883 */     GIR_RootConstrainSelectedInstOperands,
     /*  601884 */     // GIR_Coverage, 4883,
     /*  601884 */     GIR_EraseRootFromParent_Done,
     /*  601885 */   // Label 9770: @601885
     /*  601885 */   GIM_Try, /*On fail goto*//*Label 9771*/ GIMT_Encode4(601960), // Rule ID 4886 //
     /*  601890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  601901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  601904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  601907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601936 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601958 */     GIR_RootConstrainSelectedInstOperands,
     /*  601959 */     // GIR_Coverage, 4886,
     /*  601959 */     GIR_EraseRootFromParent_Done,
     /*  601960 */   // Label 9771: @601960
     /*  601960 */   GIM_Try, /*On fail goto*//*Label 9772*/ GIMT_Encode4(602035), // Rule ID 4887 //
     /*  601965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  601976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  601979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  601982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602011 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11683:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  602014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602033 */     GIR_RootConstrainSelectedInstOperands,
     /*  602034 */     // GIR_Coverage, 4887,
     /*  602034 */     GIR_EraseRootFromParent_Done,
     /*  602035 */   // Label 9772: @602035
     /*  602035 */   GIM_Try, /*On fail goto*//*Label 9773*/ GIMT_Encode4(602110), // Rule ID 4890 //
     /*  602040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  602051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  602054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  602057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602086 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  602089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602108 */     GIR_RootConstrainSelectedInstOperands,
     /*  602109 */     // GIR_Coverage, 4890,
     /*  602109 */     GIR_EraseRootFromParent_Done,
     /*  602110 */   // Label 9773: @602110
     /*  602110 */   GIM_Try, /*On fail goto*//*Label 9774*/ GIMT_Encode4(602185), // Rule ID 4891 //
     /*  602115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  602126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  602129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  602132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11683:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  602164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602183 */     GIR_RootConstrainSelectedInstOperands,
     /*  602184 */     // GIR_Coverage, 4891,
     /*  602184 */     GIR_EraseRootFromParent_Done,
     /*  602185 */   // Label 9774: @602185
     /*  602185 */   GIM_Try, /*On fail goto*//*Label 9775*/ GIMT_Encode4(602260), // Rule ID 4894 //
     /*  602190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  602201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  602204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  602207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602236 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  602239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602258 */     GIR_RootConstrainSelectedInstOperands,
     /*  602259 */     // GIR_Coverage, 4894,
     /*  602259 */     GIR_EraseRootFromParent_Done,
     /*  602260 */   // Label 9775: @602260
     /*  602260 */   GIM_Try, /*On fail goto*//*Label 9776*/ GIMT_Encode4(602335), // Rule ID 4895 //
     /*  602265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  602276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  602279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  602282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602311 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11683:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  602314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602333 */     GIR_RootConstrainSelectedInstOperands,
     /*  602334 */     // GIR_Coverage, 4895,
     /*  602334 */     GIR_EraseRootFromParent_Done,
     /*  602335 */   // Label 9776: @602335
     /*  602335 */   GIM_Try, /*On fail goto*//*Label 9777*/ GIMT_Encode4(602410), // Rule ID 4898 //
     /*  602340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  602351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  602354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  602357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  602389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602408 */     GIR_RootConstrainSelectedInstOperands,
     /*  602409 */     // GIR_Coverage, 4898,
     /*  602409 */     GIR_EraseRootFromParent_Done,
     /*  602410 */   // Label 9777: @602410
     /*  602410 */   GIM_Try, /*On fail goto*//*Label 9778*/ GIMT_Encode4(602485), // Rule ID 4899 //
     /*  602415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  602426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  602429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  602432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602461 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11683:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  602464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602483 */     GIR_RootConstrainSelectedInstOperands,
     /*  602484 */     // GIR_Coverage, 4899,
     /*  602484 */     GIR_EraseRootFromParent_Done,
     /*  602485 */   // Label 9778: @602485
     /*  602485 */   GIM_Try, /*On fail goto*//*Label 9779*/ GIMT_Encode4(602557), // Rule ID 5252 //
     /*  602490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  602501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  602504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  602507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  602510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602536 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  602536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  602539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602555 */     GIR_RootConstrainSelectedInstOperands,
     /*  602556 */     // GIR_Coverage, 5252,
     /*  602556 */     GIR_EraseRootFromParent_Done,
     /*  602557 */   // Label 9779: @602557
     /*  602557 */   GIM_Try, /*On fail goto*//*Label 9780*/ GIMT_Encode4(602629), // Rule ID 5253 //
     /*  602562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  602573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  602576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  602579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  602582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602608 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  602608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  602611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602627 */     GIR_RootConstrainSelectedInstOperands,
     /*  602628 */     // GIR_Coverage, 5253,
     /*  602628 */     GIR_EraseRootFromParent_Done,
     /*  602629 */   // Label 9780: @602629
     /*  602629 */   GIM_Try, /*On fail goto*//*Label 9781*/ GIMT_Encode4(602701), // Rule ID 5254 //
     /*  602634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  602645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  602648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  602651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  602654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  602680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  602683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602699 */     GIR_RootConstrainSelectedInstOperands,
     /*  602700 */     // GIR_Coverage, 5254,
     /*  602700 */     GIR_EraseRootFromParent_Done,
     /*  602701 */   // Label 9781: @602701
     /*  602701 */   GIM_Try, /*On fail goto*//*Label 9782*/ GIMT_Encode4(602773), // Rule ID 5255 //
     /*  602706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  602717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  602720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  602723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  602726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602752 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  602752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  602755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602771 */     GIR_RootConstrainSelectedInstOperands,
     /*  602772 */     // GIR_Coverage, 5255,
     /*  602772 */     GIR_EraseRootFromParent_Done,
     /*  602773 */   // Label 9782: @602773
     /*  602773 */   GIM_Try, /*On fail goto*//*Label 9783*/ GIMT_Encode4(602845), // Rule ID 5256 //
     /*  602778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  602789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  602792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  602795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  602798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602824 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  602824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  602827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602843 */     GIR_RootConstrainSelectedInstOperands,
     /*  602844 */     // GIR_Coverage, 5256,
     /*  602844 */     GIR_EraseRootFromParent_Done,
     /*  602845 */   // Label 9783: @602845
     /*  602845 */   GIM_Try, /*On fail goto*//*Label 9784*/ GIMT_Encode4(602917), // Rule ID 5257 //
     /*  602850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  602861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  602864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  602867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  602870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602896 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  602896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  602899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602915 */     GIR_RootConstrainSelectedInstOperands,
     /*  602916 */     // GIR_Coverage, 5257,
     /*  602916 */     GIR_EraseRootFromParent_Done,
     /*  602917 */   // Label 9784: @602917
     /*  602917 */   GIM_Try, /*On fail goto*//*Label 9785*/ GIMT_Encode4(602989), // Rule ID 5258 //
     /*  602922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  602933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  602936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  602939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  602942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602968 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  602968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  602971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602987 */     GIR_RootConstrainSelectedInstOperands,
     /*  602988 */     // GIR_Coverage, 5258,
     /*  602988 */     GIR_EraseRootFromParent_Done,
     /*  602989 */   // Label 9785: @602989
     /*  602989 */   GIM_Try, /*On fail goto*//*Label 9786*/ GIMT_Encode4(603061), // Rule ID 5259 //
     /*  602994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  603008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  603011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603040 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  603040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603059 */     GIR_RootConstrainSelectedInstOperands,
     /*  603060 */     // GIR_Coverage, 5259,
     /*  603060 */     GIR_EraseRootFromParent_Done,
     /*  603061 */   // Label 9786: @603061
     /*  603061 */   GIM_Try, /*On fail goto*//*Label 9787*/ GIMT_Encode4(603133), // Rule ID 5260 //
     /*  603066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  603080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  603083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603112 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  603112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603131 */     GIR_RootConstrainSelectedInstOperands,
     /*  603132 */     // GIR_Coverage, 5260,
     /*  603132 */     GIR_EraseRootFromParent_Done,
     /*  603133 */   // Label 9787: @603133
     /*  603133 */   GIM_Try, /*On fail goto*//*Label 9788*/ GIMT_Encode4(603205), // Rule ID 5261 //
     /*  603138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  603152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  603155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603184 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  603184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603203 */     GIR_RootConstrainSelectedInstOperands,
     /*  603204 */     // GIR_Coverage, 5261,
     /*  603204 */     GIR_EraseRootFromParent_Done,
     /*  603205 */   // Label 9788: @603205
     /*  603205 */   GIM_Try, /*On fail goto*//*Label 9789*/ GIMT_Encode4(603277), // Rule ID 5262 //
     /*  603210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  603221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  603224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  603227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  603230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603256 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  603256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603275 */     GIR_RootConstrainSelectedInstOperands,
     /*  603276 */     // GIR_Coverage, 5262,
     /*  603276 */     GIR_EraseRootFromParent_Done,
     /*  603277 */   // Label 9789: @603277
     /*  603277 */   GIM_Try, /*On fail goto*//*Label 9790*/ GIMT_Encode4(603349), // Rule ID 5263 //
     /*  603282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  603293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  603296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  603299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  603302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603328 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  603328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603347 */     GIR_RootConstrainSelectedInstOperands,
     /*  603348 */     // GIR_Coverage, 5263,
     /*  603348 */     GIR_EraseRootFromParent_Done,
     /*  603349 */   // Label 9790: @603349
     /*  603349 */   GIM_Try, /*On fail goto*//*Label 9791*/ GIMT_Encode4(603421), // Rule ID 5264 //
     /*  603354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  603365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  603368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  603371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  603374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603400 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  603400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603419 */     GIR_RootConstrainSelectedInstOperands,
     /*  603420 */     // GIR_Coverage, 5264,
     /*  603420 */     GIR_EraseRootFromParent_Done,
     /*  603421 */   // Label 9791: @603421
     /*  603421 */   GIM_Try, /*On fail goto*//*Label 9792*/ GIMT_Encode4(603493), // Rule ID 5265 //
     /*  603426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  603437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  603440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  603443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  603446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603472 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  603472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603491 */     GIR_RootConstrainSelectedInstOperands,
     /*  603492 */     // GIR_Coverage, 5265,
     /*  603492 */     GIR_EraseRootFromParent_Done,
     /*  603493 */   // Label 9792: @603493
     /*  603493 */   GIM_Try, /*On fail goto*//*Label 9793*/ GIMT_Encode4(603565), // Rule ID 5266 //
     /*  603498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  603512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  603515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  603544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603563 */     GIR_RootConstrainSelectedInstOperands,
     /*  603564 */     // GIR_Coverage, 5266,
     /*  603564 */     GIR_EraseRootFromParent_Done,
     /*  603565 */   // Label 9793: @603565
     /*  603565 */   GIM_Try, /*On fail goto*//*Label 9794*/ GIMT_Encode4(603637), // Rule ID 5267 //
     /*  603570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  603584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  603587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603616 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  603616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603635 */     GIR_RootConstrainSelectedInstOperands,
     /*  603636 */     // GIR_Coverage, 5267,
     /*  603636 */     GIR_EraseRootFromParent_Done,
     /*  603637 */   // Label 9794: @603637
     /*  603637 */   GIM_Try, /*On fail goto*//*Label 9795*/ GIMT_Encode4(603709), // Rule ID 5268 //
     /*  603642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  603645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  603656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  603659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  603688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  603707 */     GIR_RootConstrainSelectedInstOperands,
     /*  603708 */     // GIR_Coverage, 5268,
     /*  603708 */     GIR_EraseRootFromParent_Done,
     /*  603709 */   // Label 9795: @603709
     /*  603709 */   GIM_Try, /*On fail goto*//*Label 9796*/ GIMT_Encode4(603781), // Rule ID 5269 //
     /*  603714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  603717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  603728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  603731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603760 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  603760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  603779 */     GIR_RootConstrainSelectedInstOperands,
     /*  603780 */     // GIR_Coverage, 5269,
     /*  603780 */     GIR_EraseRootFromParent_Done,
     /*  603781 */   // Label 9796: @603781
     /*  603781 */   GIM_Try, /*On fail goto*//*Label 9797*/ GIMT_Encode4(603853), // Rule ID 5270 //
     /*  603786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  603797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  603800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  603803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  603806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603832 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  603832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  603835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603851 */     GIR_RootConstrainSelectedInstOperands,
     /*  603852 */     // GIR_Coverage, 5270,
     /*  603852 */     GIR_EraseRootFromParent_Done,
     /*  603853 */   // Label 9797: @603853
     /*  603853 */   GIM_Try, /*On fail goto*//*Label 9798*/ GIMT_Encode4(603925), // Rule ID 5271 //
     /*  603858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  603869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  603872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  603875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  603878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603904 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  603904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  603907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603923 */     GIR_RootConstrainSelectedInstOperands,
     /*  603924 */     // GIR_Coverage, 5271,
     /*  603924 */     GIR_EraseRootFromParent_Done,
     /*  603925 */   // Label 9798: @603925
     /*  603925 */   GIM_Try, /*On fail goto*//*Label 9799*/ GIMT_Encode4(603997), // Rule ID 5272 //
     /*  603930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  603941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  603944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  603947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  603950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603976 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  603976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  603979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603995 */     GIR_RootConstrainSelectedInstOperands,
     /*  603996 */     // GIR_Coverage, 5272,
     /*  603996 */     GIR_EraseRootFromParent_Done,
     /*  603997 */   // Label 9799: @603997
     /*  603997 */   GIM_Try, /*On fail goto*//*Label 9800*/ GIMT_Encode4(604069), // Rule ID 5273 //
     /*  604002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  604013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  604016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  604019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604048 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  604048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604067 */     GIR_RootConstrainSelectedInstOperands,
     /*  604068 */     // GIR_Coverage, 5273,
     /*  604068 */     GIR_EraseRootFromParent_Done,
     /*  604069 */   // Label 9800: @604069
     /*  604069 */   GIM_Try, /*On fail goto*//*Label 9801*/ GIMT_Encode4(604141), // Rule ID 5274 //
     /*  604074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  604085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  604088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  604091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  604094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604120 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  604120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604139 */     GIR_RootConstrainSelectedInstOperands,
     /*  604140 */     // GIR_Coverage, 5274,
     /*  604140 */     GIR_EraseRootFromParent_Done,
     /*  604141 */   // Label 9801: @604141
     /*  604141 */   GIM_Try, /*On fail goto*//*Label 9802*/ GIMT_Encode4(604213), // Rule ID 5275 //
     /*  604146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  604157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  604160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  604163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  604166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604192 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  604192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604211 */     GIR_RootConstrainSelectedInstOperands,
     /*  604212 */     // GIR_Coverage, 5275,
     /*  604212 */     GIR_EraseRootFromParent_Done,
     /*  604213 */   // Label 9802: @604213
     /*  604213 */   GIM_Try, /*On fail goto*//*Label 9803*/ GIMT_Encode4(604285), // Rule ID 5276 //
     /*  604218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  604264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604283 */     GIR_RootConstrainSelectedInstOperands,
     /*  604284 */     // GIR_Coverage, 5276,
     /*  604284 */     GIR_EraseRootFromParent_Done,
     /*  604285 */   // Label 9803: @604285
     /*  604285 */   GIM_Try, /*On fail goto*//*Label 9804*/ GIMT_Encode4(604357), // Rule ID 5277 //
     /*  604290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604336 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  604336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604355 */     GIR_RootConstrainSelectedInstOperands,
     /*  604356 */     // GIR_Coverage, 5277,
     /*  604356 */     GIR_EraseRootFromParent_Done,
     /*  604357 */   // Label 9804: @604357
     /*  604357 */   GIM_Try, /*On fail goto*//*Label 9805*/ GIMT_Encode4(604429), // Rule ID 5278 //
     /*  604362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604408 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  604408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604427 */     GIR_RootConstrainSelectedInstOperands,
     /*  604428 */     // GIR_Coverage, 5278,
     /*  604428 */     GIR_EraseRootFromParent_Done,
     /*  604429 */   // Label 9805: @604429
     /*  604429 */   GIM_Try, /*On fail goto*//*Label 9806*/ GIMT_Encode4(604501), // Rule ID 5279 //
     /*  604434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604480 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  604480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604499 */     GIR_RootConstrainSelectedInstOperands,
     /*  604500 */     // GIR_Coverage, 5279,
     /*  604500 */     GIR_EraseRootFromParent_Done,
     /*  604501 */   // Label 9806: @604501
     /*  604501 */   GIM_Try, /*On fail goto*//*Label 9807*/ GIMT_Encode4(604573), // Rule ID 5280 //
     /*  604506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  604517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604552 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  604552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604571 */     GIR_RootConstrainSelectedInstOperands,
     /*  604572 */     // GIR_Coverage, 5280,
     /*  604572 */     GIR_EraseRootFromParent_Done,
     /*  604573 */   // Label 9807: @604573
     /*  604573 */   GIM_Try, /*On fail goto*//*Label 9808*/ GIMT_Encode4(604645), // Rule ID 5281 //
     /*  604578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  604589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604624 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  604624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604643 */     GIR_RootConstrainSelectedInstOperands,
     /*  604644 */     // GIR_Coverage, 5281,
     /*  604644 */     GIR_EraseRootFromParent_Done,
     /*  604645 */   // Label 9808: @604645
     /*  604645 */   GIM_Try, /*On fail goto*//*Label 9809*/ GIMT_Encode4(604717), // Rule ID 5282 //
     /*  604650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  604661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  604664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  604667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  604670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604696 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  604696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604715 */     GIR_RootConstrainSelectedInstOperands,
     /*  604716 */     // GIR_Coverage, 5282,
     /*  604716 */     GIR_EraseRootFromParent_Done,
     /*  604717 */   // Label 9809: @604717
     /*  604717 */   GIM_Try, /*On fail goto*//*Label 9810*/ GIMT_Encode4(604789), // Rule ID 5283 //
     /*  604722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  604733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  604736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  604739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  604742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604768 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  604768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604787 */     GIR_RootConstrainSelectedInstOperands,
     /*  604788 */     // GIR_Coverage, 5283,
     /*  604788 */     GIR_EraseRootFromParent_Done,
     /*  604789 */   // Label 9810: @604789
     /*  604789 */   GIM_Try, /*On fail goto*//*Label 9811*/ GIMT_Encode4(604861), // Rule ID 5284 //
     /*  604794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  604808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  604811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604840 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  604840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604859 */     GIR_RootConstrainSelectedInstOperands,
     /*  604860 */     // GIR_Coverage, 5284,
     /*  604860 */     GIR_EraseRootFromParent_Done,
     /*  604861 */   // Label 9811: @604861
     /*  604861 */   GIM_Try, /*On fail goto*//*Label 9812*/ GIMT_Encode4(604933), // Rule ID 5285 //
     /*  604866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  604880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  604883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  604912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604931 */     GIR_RootConstrainSelectedInstOperands,
     /*  604932 */     // GIR_Coverage, 5285,
     /*  604932 */     GIR_EraseRootFromParent_Done,
     /*  604933 */   // Label 9812: @604933
     /*  604933 */   GIM_Try, /*On fail goto*//*Label 9813*/ GIMT_Encode4(605005), // Rule ID 5286 //
     /*  604938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  604952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  604955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604984 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  604984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605003 */     GIR_RootConstrainSelectedInstOperands,
     /*  605004 */     // GIR_Coverage, 5286,
     /*  605004 */     GIR_EraseRootFromParent_Done,
     /*  605005 */   // Label 9813: @605005
     /*  605005 */   GIM_Try, /*On fail goto*//*Label 9814*/ GIMT_Encode4(605077), // Rule ID 5287 //
     /*  605010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  605021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  605024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  605027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  605030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605056 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  605056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605075 */     GIR_RootConstrainSelectedInstOperands,
     /*  605076 */     // GIR_Coverage, 5287,
     /*  605076 */     GIR_EraseRootFromParent_Done,
     /*  605077 */   // Label 9814: @605077
     /*  605077 */   GIM_Try, /*On fail goto*//*Label 9815*/ GIMT_Encode4(605149), // Rule ID 5288 //
     /*  605082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  605085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  605096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  605099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605128 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  605128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  605131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605147 */     GIR_RootConstrainSelectedInstOperands,
     /*  605148 */     // GIR_Coverage, 5288,
     /*  605148 */     GIR_EraseRootFromParent_Done,
     /*  605149 */   // Label 9815: @605149
     /*  605149 */   GIM_Try, /*On fail goto*//*Label 9816*/ GIMT_Encode4(605221), // Rule ID 5289 //
     /*  605154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  605157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  605168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  605171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605200 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  605200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  605203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605219 */     GIR_RootConstrainSelectedInstOperands,
     /*  605220 */     // GIR_Coverage, 5289,
     /*  605220 */     GIR_EraseRootFromParent_Done,
     /*  605221 */   // Label 9816: @605221
     /*  605221 */   GIM_Try, /*On fail goto*//*Label 9817*/ GIMT_Encode4(605293), // Rule ID 5290 //
     /*  605226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  605229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  605240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  605243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605272 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  605272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  605275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605291 */     GIR_RootConstrainSelectedInstOperands,
     /*  605292 */     // GIR_Coverage, 5290,
     /*  605292 */     GIR_EraseRootFromParent_Done,
     /*  605293 */   // Label 9817: @605293
     /*  605293 */   GIM_Try, /*On fail goto*//*Label 9818*/ GIMT_Encode4(605365), // Rule ID 5291 //
     /*  605298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  605301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  605312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  605315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605344 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  605344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  605347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605363 */     GIR_RootConstrainSelectedInstOperands,
     /*  605364 */     // GIR_Coverage, 5291,
     /*  605364 */     GIR_EraseRootFromParent_Done,
     /*  605365 */   // Label 9818: @605365
     /*  605365 */   GIM_Try, /*On fail goto*//*Label 9819*/ GIMT_Encode4(605437), // Rule ID 5292 //
     /*  605370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  605373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  605384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  605387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605416 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  605416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605435 */     GIR_RootConstrainSelectedInstOperands,
     /*  605436 */     // GIR_Coverage, 5292,
     /*  605436 */     GIR_EraseRootFromParent_Done,
     /*  605437 */   // Label 9819: @605437
     /*  605437 */   GIM_Try, /*On fail goto*//*Label 9820*/ GIMT_Encode4(605509), // Rule ID 5293 //
     /*  605442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  605445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  605456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  605459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605488 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  605488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605507 */     GIR_RootConstrainSelectedInstOperands,
     /*  605508 */     // GIR_Coverage, 5293,
     /*  605508 */     GIR_EraseRootFromParent_Done,
     /*  605509 */   // Label 9820: @605509
     /*  605509 */   GIM_Try, /*On fail goto*//*Label 9821*/ GIMT_Encode4(605581), // Rule ID 5294 //
     /*  605514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  605528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605560 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  605560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  605563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605579 */     GIR_RootConstrainSelectedInstOperands,
     /*  605580 */     // GIR_Coverage, 5294,
     /*  605580 */     GIR_EraseRootFromParent_Done,
     /*  605581 */   // Label 9821: @605581
     /*  605581 */   GIM_Try, /*On fail goto*//*Label 9822*/ GIMT_Encode4(605653), // Rule ID 5295 //
     /*  605586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  605600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  605603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605632 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  605632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  605635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605651 */     GIR_RootConstrainSelectedInstOperands,
     /*  605652 */     // GIR_Coverage, 5295,
     /*  605652 */     GIR_EraseRootFromParent_Done,
     /*  605653 */   // Label 9822: @605653
     /*  605653 */   GIM_Try, /*On fail goto*//*Label 9823*/ GIMT_Encode4(605725), // Rule ID 5296 //
     /*  605658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  605672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  605704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  605707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605723 */     GIR_RootConstrainSelectedInstOperands,
     /*  605724 */     // GIR_Coverage, 5296,
     /*  605724 */     GIR_EraseRootFromParent_Done,
     /*  605725 */   // Label 9823: @605725
     /*  605725 */   GIM_Try, /*On fail goto*//*Label 9824*/ GIMT_Encode4(605797), // Rule ID 5297 //
     /*  605730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  605744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  605747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  605776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  605779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605795 */     GIR_RootConstrainSelectedInstOperands,
     /*  605796 */     // GIR_Coverage, 5297,
     /*  605796 */     GIR_EraseRootFromParent_Done,
     /*  605797 */   // Label 9824: @605797
     /*  605797 */   GIM_Try, /*On fail goto*//*Label 9825*/ GIMT_Encode4(605869), // Rule ID 5298 //
     /*  605802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  605816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605848 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  605848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  605851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605867 */     GIR_RootConstrainSelectedInstOperands,
     /*  605868 */     // GIR_Coverage, 5298,
     /*  605868 */     GIR_EraseRootFromParent_Done,
     /*  605869 */   // Label 9825: @605869
     /*  605869 */   GIM_Try, /*On fail goto*//*Label 9826*/ GIMT_Encode4(605941), // Rule ID 5299 //
     /*  605874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  605888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  605891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605920 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  605920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  605923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605939 */     GIR_RootConstrainSelectedInstOperands,
     /*  605940 */     // GIR_Coverage, 5299,
     /*  605940 */     GIR_EraseRootFromParent_Done,
     /*  605941 */   // Label 9826: @605941
     /*  605941 */   GIM_Try, /*On fail goto*//*Label 9827*/ GIMT_Encode4(606013), // Rule ID 5300 //
     /*  605946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  605960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605992 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  605992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  605995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606011 */     GIR_RootConstrainSelectedInstOperands,
     /*  606012 */     // GIR_Coverage, 5300,
     /*  606012 */     GIR_EraseRootFromParent_Done,
     /*  606013 */   // Label 9827: @606013
     /*  606013 */   GIM_Try, /*On fail goto*//*Label 9828*/ GIMT_Encode4(606085), // Rule ID 5301 //
     /*  606018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  606032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606064 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  606067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606083 */     GIR_RootConstrainSelectedInstOperands,
     /*  606084 */     // GIR_Coverage, 5301,
     /*  606084 */     GIR_EraseRootFromParent_Done,
     /*  606085 */   // Label 9828: @606085
     /*  606085 */   GIM_Try, /*On fail goto*//*Label 9829*/ GIMT_Encode4(606157), // Rule ID 5302 //
     /*  606090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  606104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606136 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606155 */     GIR_RootConstrainSelectedInstOperands,
     /*  606156 */     // GIR_Coverage, 5302,
     /*  606156 */     GIR_EraseRootFromParent_Done,
     /*  606157 */   // Label 9829: @606157
     /*  606157 */   GIM_Try, /*On fail goto*//*Label 9830*/ GIMT_Encode4(606229), // Rule ID 5303 //
     /*  606162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  606176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606208 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606227 */     GIR_RootConstrainSelectedInstOperands,
     /*  606228 */     // GIR_Coverage, 5303,
     /*  606228 */     GIR_EraseRootFromParent_Done,
     /*  606229 */   // Label 9830: @606229
     /*  606229 */   GIM_Try, /*On fail goto*//*Label 9831*/ GIMT_Encode4(606301), // Rule ID 5304 //
     /*  606234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  606248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  606280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606299 */     GIR_RootConstrainSelectedInstOperands,
     /*  606300 */     // GIR_Coverage, 5304,
     /*  606300 */     GIR_EraseRootFromParent_Done,
     /*  606301 */   // Label 9831: @606301
     /*  606301 */   GIM_Try, /*On fail goto*//*Label 9832*/ GIMT_Encode4(606373), // Rule ID 5305 //
     /*  606306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  606320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606352 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  606352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606371 */     GIR_RootConstrainSelectedInstOperands,
     /*  606372 */     // GIR_Coverage, 5305,
     /*  606372 */     GIR_EraseRootFromParent_Done,
     /*  606373 */   // Label 9832: @606373
     /*  606373 */   GIM_Try, /*On fail goto*//*Label 9833*/ GIMT_Encode4(606445), // Rule ID 5306 //
     /*  606378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  606389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  606392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  606398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606424 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606443 */     GIR_RootConstrainSelectedInstOperands,
     /*  606444 */     // GIR_Coverage, 5306,
     /*  606444 */     GIR_EraseRootFromParent_Done,
     /*  606445 */   // Label 9833: @606445
     /*  606445 */   GIM_Try, /*On fail goto*//*Label 9834*/ GIMT_Encode4(606517), // Rule ID 5307 //
     /*  606450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  606461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  606464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  606470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606496 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606515 */     GIR_RootConstrainSelectedInstOperands,
     /*  606516 */     // GIR_Coverage, 5307,
     /*  606516 */     GIR_EraseRootFromParent_Done,
     /*  606517 */   // Label 9834: @606517
     /*  606517 */   GIM_Try, /*On fail goto*//*Label 9835*/ GIMT_Encode4(606589), // Rule ID 5308 //
     /*  606522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  606536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606568 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606587 */     GIR_RootConstrainSelectedInstOperands,
     /*  606588 */     // GIR_Coverage, 5308,
     /*  606588 */     GIR_EraseRootFromParent_Done,
     /*  606589 */   // Label 9835: @606589
     /*  606589 */   GIM_Try, /*On fail goto*//*Label 9836*/ GIMT_Encode4(606661), // Rule ID 5309 //
     /*  606594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  606608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606640 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606659 */     GIR_RootConstrainSelectedInstOperands,
     /*  606660 */     // GIR_Coverage, 5309,
     /*  606660 */     GIR_EraseRootFromParent_Done,
     /*  606661 */   // Label 9836: @606661
     /*  606661 */   GIM_Try, /*On fail goto*//*Label 9837*/ GIMT_Encode4(606733), // Rule ID 5310 //
     /*  606666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  606680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606712 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  606712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606731 */     GIR_RootConstrainSelectedInstOperands,
     /*  606732 */     // GIR_Coverage, 5310,
     /*  606732 */     GIR_EraseRootFromParent_Done,
     /*  606733 */   // Label 9837: @606733
     /*  606733 */   GIM_Try, /*On fail goto*//*Label 9838*/ GIMT_Encode4(606805), // Rule ID 5311 //
     /*  606738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  606752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606784 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  606784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606803 */     GIR_RootConstrainSelectedInstOperands,
     /*  606804 */     // GIR_Coverage, 5311,
     /*  606804 */     GIR_EraseRootFromParent_Done,
     /*  606805 */   // Label 9838: @606805
     /*  606805 */   GIM_Try, /*On fail goto*//*Label 9839*/ GIMT_Encode4(606877), // Rule ID 5312 //
     /*  606810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  606813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  606824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606856 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  606856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  606875 */     GIR_RootConstrainSelectedInstOperands,
     /*  606876 */     // GIR_Coverage, 5312,
     /*  606876 */     GIR_EraseRootFromParent_Done,
     /*  606877 */   // Label 9839: @606877
     /*  606877 */   GIM_Try, /*On fail goto*//*Label 9840*/ GIMT_Encode4(606949), // Rule ID 5313 //
     /*  606882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  606885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  606896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606928 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  606928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  606947 */     GIR_RootConstrainSelectedInstOperands,
     /*  606948 */     // GIR_Coverage, 5313,
     /*  606948 */     GIR_EraseRootFromParent_Done,
     /*  606949 */   // Label 9840: @606949
     /*  606949 */   GIM_Try, /*On fail goto*//*Label 9841*/ GIMT_Encode4(607021), // Rule ID 5314 //
     /*  606954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  606965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  606968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  606974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607000 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607019 */     GIR_RootConstrainSelectedInstOperands,
     /*  607020 */     // GIR_Coverage, 5314,
     /*  607020 */     GIR_EraseRootFromParent_Done,
     /*  607021 */   // Label 9841: @607021
     /*  607021 */   GIM_Try, /*On fail goto*//*Label 9842*/ GIMT_Encode4(607093), // Rule ID 5315 //
     /*  607026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  607040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607072 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607091 */     GIR_RootConstrainSelectedInstOperands,
     /*  607092 */     // GIR_Coverage, 5315,
     /*  607092 */     GIR_EraseRootFromParent_Done,
     /*  607093 */   // Label 9842: @607093
     /*  607093 */   GIM_Try, /*On fail goto*//*Label 9843*/ GIMT_Encode4(607165), // Rule ID 5316 //
     /*  607098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  607112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607144 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607163 */     GIR_RootConstrainSelectedInstOperands,
     /*  607164 */     // GIR_Coverage, 5316,
     /*  607164 */     GIR_EraseRootFromParent_Done,
     /*  607165 */   // Label 9843: @607165
     /*  607165 */   GIM_Try, /*On fail goto*//*Label 9844*/ GIMT_Encode4(607237), // Rule ID 5317 //
     /*  607170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  607184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607216 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607235 */     GIR_RootConstrainSelectedInstOperands,
     /*  607236 */     // GIR_Coverage, 5317,
     /*  607236 */     GIR_EraseRootFromParent_Done,
     /*  607237 */   // Label 9844: @607237
     /*  607237 */   GIM_Try, /*On fail goto*//*Label 9845*/ GIMT_Encode4(607309), // Rule ID 5318 //
     /*  607242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  607253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  607256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  607262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607288 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607307 */     GIR_RootConstrainSelectedInstOperands,
     /*  607308 */     // GIR_Coverage, 5318,
     /*  607308 */     GIR_EraseRootFromParent_Done,
     /*  607309 */   // Label 9845: @607309
     /*  607309 */   GIM_Try, /*On fail goto*//*Label 9846*/ GIMT_Encode4(607381), // Rule ID 5319 //
     /*  607314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  607325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  607328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  607334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607360 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607379 */     GIR_RootConstrainSelectedInstOperands,
     /*  607380 */     // GIR_Coverage, 5319,
     /*  607380 */     GIR_EraseRootFromParent_Done,
     /*  607381 */   // Label 9846: @607381
     /*  607381 */   GIM_Try, /*On fail goto*//*Label 9847*/ GIMT_Encode4(607453), // Rule ID 5320 //
     /*  607386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  607400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607451 */     GIR_RootConstrainSelectedInstOperands,
     /*  607452 */     // GIR_Coverage, 5320,
     /*  607452 */     GIR_EraseRootFromParent_Done,
     /*  607453 */   // Label 9847: @607453
     /*  607453 */   GIM_Try, /*On fail goto*//*Label 9848*/ GIMT_Encode4(607525), // Rule ID 5321 //
     /*  607458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  607472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607504 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607523 */     GIR_RootConstrainSelectedInstOperands,
     /*  607524 */     // GIR_Coverage, 5321,
     /*  607524 */     GIR_EraseRootFromParent_Done,
     /*  607525 */   // Label 9848: @607525
     /*  607525 */   GIM_Try, /*On fail goto*//*Label 9849*/ GIMT_Encode4(607597), // Rule ID 5322 //
     /*  607530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  607544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607576 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607595 */     GIR_RootConstrainSelectedInstOperands,
     /*  607596 */     // GIR_Coverage, 5322,
     /*  607596 */     GIR_EraseRootFromParent_Done,
     /*  607597 */   // Label 9849: @607597
     /*  607597 */   GIM_Try, /*On fail goto*//*Label 9850*/ GIMT_Encode4(607669), // Rule ID 5323 //
     /*  607602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  607616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607648 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607667 */     GIR_RootConstrainSelectedInstOperands,
     /*  607668 */     // GIR_Coverage, 5323,
     /*  607668 */     GIR_EraseRootFromParent_Done,
     /*  607669 */   // Label 9850: @607669
     /*  607669 */   GIM_Try, /*On fail goto*//*Label 9851*/ GIMT_Encode4(607741), // Rule ID 5324 //
     /*  607674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  607688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607720 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607739 */     GIR_RootConstrainSelectedInstOperands,
     /*  607740 */     // GIR_Coverage, 5324,
     /*  607740 */     GIR_EraseRootFromParent_Done,
     /*  607741 */   // Label 9851: @607741
     /*  607741 */   GIM_Try, /*On fail goto*//*Label 9852*/ GIMT_Encode4(607813), // Rule ID 5325 //
     /*  607746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  607760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607792 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607811 */     GIR_RootConstrainSelectedInstOperands,
     /*  607812 */     // GIR_Coverage, 5325,
     /*  607812 */     GIR_EraseRootFromParent_Done,
     /*  607813 */   // Label 9852: @607813
     /*  607813 */   GIM_Try, /*On fail goto*//*Label 9853*/ GIMT_Encode4(607885), // Rule ID 5326 //
     /*  607818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  607832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607864 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  607864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607883 */     GIR_RootConstrainSelectedInstOperands,
     /*  607884 */     // GIR_Coverage, 5326,
     /*  607884 */     GIR_EraseRootFromParent_Done,
     /*  607885 */   // Label 9853: @607885
     /*  607885 */   GIM_Try, /*On fail goto*//*Label 9854*/ GIMT_Encode4(607957), // Rule ID 5327 //
     /*  607890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  607904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607936 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  607936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607955 */     GIR_RootConstrainSelectedInstOperands,
     /*  607956 */     // GIR_Coverage, 5327,
     /*  607956 */     GIR_EraseRootFromParent_Done,
     /*  607957 */   // Label 9854: @607957
     /*  607957 */   GIM_Try, /*On fail goto*//*Label 9855*/ GIMT_Encode4(608029), // Rule ID 5328 //
     /*  607962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  607976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608008 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608027 */     GIR_RootConstrainSelectedInstOperands,
     /*  608028 */     // GIR_Coverage, 5328,
     /*  608028 */     GIR_EraseRootFromParent_Done,
     /*  608029 */   // Label 9855: @608029
     /*  608029 */   GIM_Try, /*On fail goto*//*Label 9856*/ GIMT_Encode4(608101), // Rule ID 5329 //
     /*  608034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  608048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608080 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608099 */     GIR_RootConstrainSelectedInstOperands,
     /*  608100 */     // GIR_Coverage, 5329,
     /*  608100 */     GIR_EraseRootFromParent_Done,
     /*  608101 */   // Label 9856: @608101
     /*  608101 */   GIM_Try, /*On fail goto*//*Label 9857*/ GIMT_Encode4(608173), // Rule ID 5330 //
     /*  608106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  608120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608152 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608171 */     GIR_RootConstrainSelectedInstOperands,
     /*  608172 */     // GIR_Coverage, 5330,
     /*  608172 */     GIR_EraseRootFromParent_Done,
     /*  608173 */   // Label 9857: @608173
     /*  608173 */   GIM_Try, /*On fail goto*//*Label 9858*/ GIMT_Encode4(608245), // Rule ID 5331 //
     /*  608178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  608192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608224 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608243 */     GIR_RootConstrainSelectedInstOperands,
     /*  608244 */     // GIR_Coverage, 5331,
     /*  608244 */     GIR_EraseRootFromParent_Done,
     /*  608245 */   // Label 9858: @608245
     /*  608245 */   GIM_Try, /*On fail goto*//*Label 9859*/ GIMT_Encode4(608317), // Rule ID 5332 //
     /*  608250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  608264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608296 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  608296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  608299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608315 */     GIR_RootConstrainSelectedInstOperands,
     /*  608316 */     // GIR_Coverage, 5332,
     /*  608316 */     GIR_EraseRootFromParent_Done,
     /*  608317 */   // Label 9859: @608317
     /*  608317 */   GIM_Try, /*On fail goto*//*Label 9860*/ GIMT_Encode4(608389), // Rule ID 5333 //
     /*  608322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  608325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  608336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  608368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  608371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608387 */     GIR_RootConstrainSelectedInstOperands,
     /*  608388 */     // GIR_Coverage, 5333,
     /*  608388 */     GIR_EraseRootFromParent_Done,
     /*  608389 */   // Label 9860: @608389
     /*  608389 */   GIM_Try, /*On fail goto*//*Label 9861*/ GIMT_Encode4(608461), // Rule ID 5334 //
     /*  608394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  608408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608440 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  608440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608459 */     GIR_RootConstrainSelectedInstOperands,
     /*  608460 */     // GIR_Coverage, 5334,
     /*  608460 */     GIR_EraseRootFromParent_Done,
     /*  608461 */   // Label 9861: @608461
     /*  608461 */   GIM_Try, /*On fail goto*//*Label 9862*/ GIMT_Encode4(608533), // Rule ID 5335 //
     /*  608466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  608469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  608480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  608512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608531 */     GIR_RootConstrainSelectedInstOperands,
     /*  608532 */     // GIR_Coverage, 5335,
     /*  608532 */     GIR_EraseRootFromParent_Done,
     /*  608533 */   // Label 9862: @608533
     /*  608533 */   GIM_Try, /*On fail goto*//*Label 9863*/ GIMT_Encode4(608605), // Rule ID 5336 //
     /*  608538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  608552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608584 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  608584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608603 */     GIR_RootConstrainSelectedInstOperands,
     /*  608604 */     // GIR_Coverage, 5336,
     /*  608604 */     GIR_EraseRootFromParent_Done,
     /*  608605 */   // Label 9863: @608605
     /*  608605 */   GIM_Try, /*On fail goto*//*Label 9864*/ GIMT_Encode4(608677), // Rule ID 5337 //
     /*  608610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  608613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  608624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608656 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  608656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608675 */     GIR_RootConstrainSelectedInstOperands,
     /*  608676 */     // GIR_Coverage, 5337,
     /*  608676 */     GIR_EraseRootFromParent_Done,
     /*  608677 */   // Label 9864: @608677
     /*  608677 */   GIM_Try, /*On fail goto*//*Label 9865*/ GIMT_Encode4(608749), // Rule ID 5600 //
     /*  608682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  608693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  608696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  608699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  608702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608728 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  608728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  608731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608747 */     GIR_RootConstrainSelectedInstOperands,
     /*  608748 */     // GIR_Coverage, 5600,
     /*  608748 */     GIR_EraseRootFromParent_Done,
     /*  608749 */   // Label 9865: @608749
     /*  608749 */   GIM_Try, /*On fail goto*//*Label 9866*/ GIMT_Encode4(608821), // Rule ID 5601 //
     /*  608754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  608765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  608768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  608771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  608774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608800 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  608800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  608803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608819 */     GIR_RootConstrainSelectedInstOperands,
     /*  608820 */     // GIR_Coverage, 5601,
     /*  608820 */     GIR_EraseRootFromParent_Done,
     /*  608821 */   // Label 9866: @608821
     /*  608821 */   GIM_Try, /*On fail goto*//*Label 9867*/ GIMT_Encode4(608893), // Rule ID 5602 //
     /*  608826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  608840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  608843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  608872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  608875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608891 */     GIR_RootConstrainSelectedInstOperands,
     /*  608892 */     // GIR_Coverage, 5602,
     /*  608892 */     GIR_EraseRootFromParent_Done,
     /*  608893 */   // Label 9867: @608893
     /*  608893 */   GIM_Try, /*On fail goto*//*Label 9868*/ GIMT_Encode4(608965), // Rule ID 5603 //
     /*  608898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  608912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  608915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608944 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  608944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  608947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608963 */     GIR_RootConstrainSelectedInstOperands,
     /*  608964 */     // GIR_Coverage, 5603,
     /*  608964 */     GIR_EraseRootFromParent_Done,
     /*  608965 */   // Label 9868: @608965
     /*  608965 */   GIM_Try, /*On fail goto*//*Label 9869*/ GIMT_Encode4(609037), // Rule ID 5604 //
     /*  608970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  608984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  608987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609016 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609035 */     GIR_RootConstrainSelectedInstOperands,
     /*  609036 */     // GIR_Coverage, 5604,
     /*  609036 */     GIR_EraseRootFromParent_Done,
     /*  609037 */   // Label 9869: @609037
     /*  609037 */   GIM_Try, /*On fail goto*//*Label 9870*/ GIMT_Encode4(609109), // Rule ID 5605 //
     /*  609042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  609056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  609059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609088 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609107 */     GIR_RootConstrainSelectedInstOperands,
     /*  609108 */     // GIR_Coverage, 5605,
     /*  609108 */     GIR_EraseRootFromParent_Done,
     /*  609109 */   // Label 9870: @609109
     /*  609109 */   GIM_Try, /*On fail goto*//*Label 9871*/ GIMT_Encode4(609181), // Rule ID 5606 //
     /*  609114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  609128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  609131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609160 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  609163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609179 */     GIR_RootConstrainSelectedInstOperands,
     /*  609180 */     // GIR_Coverage, 5606,
     /*  609180 */     GIR_EraseRootFromParent_Done,
     /*  609181 */   // Label 9871: @609181
     /*  609181 */   GIM_Try, /*On fail goto*//*Label 9872*/ GIMT_Encode4(609253), // Rule ID 5607 //
     /*  609186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  609200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  609203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609232 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  609232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  609235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609251 */     GIR_RootConstrainSelectedInstOperands,
     /*  609252 */     // GIR_Coverage, 5607,
     /*  609252 */     GIR_EraseRootFromParent_Done,
     /*  609253 */   // Label 9872: @609253
     /*  609253 */   GIM_Try, /*On fail goto*//*Label 9873*/ GIMT_Encode4(609325), // Rule ID 5608 //
     /*  609258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  609272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  609275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609304 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609323 */     GIR_RootConstrainSelectedInstOperands,
     /*  609324 */     // GIR_Coverage, 5608,
     /*  609324 */     GIR_EraseRootFromParent_Done,
     /*  609325 */   // Label 9873: @609325
     /*  609325 */   GIM_Try, /*On fail goto*//*Label 9874*/ GIMT_Encode4(609397), // Rule ID 5609 //
     /*  609330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  609344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  609347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  609376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609395 */     GIR_RootConstrainSelectedInstOperands,
     /*  609396 */     // GIR_Coverage, 5609,
     /*  609396 */     GIR_EraseRootFromParent_Done,
     /*  609397 */   // Label 9874: @609397
     /*  609397 */   GIM_Try, /*On fail goto*//*Label 9875*/ GIMT_Encode4(609469), // Rule ID 5610 //
     /*  609402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  609416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  609419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609448 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  609448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609467 */     GIR_RootConstrainSelectedInstOperands,
     /*  609468 */     // GIR_Coverage, 5610,
     /*  609468 */     GIR_EraseRootFromParent_Done,
     /*  609469 */   // Label 9875: @609469
     /*  609469 */   GIM_Try, /*On fail goto*//*Label 9876*/ GIMT_Encode4(609541), // Rule ID 5611 //
     /*  609474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  609488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  609491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609520 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  609520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609539 */     GIR_RootConstrainSelectedInstOperands,
     /*  609540 */     // GIR_Coverage, 5611,
     /*  609540 */     GIR_EraseRootFromParent_Done,
     /*  609541 */   // Label 9876: @609541
     /*  609541 */   GIM_Try, /*On fail goto*//*Label 9877*/ GIMT_Encode4(609613), // Rule ID 5612 //
     /*  609546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  609560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  609563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609592 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609611 */     GIR_RootConstrainSelectedInstOperands,
     /*  609612 */     // GIR_Coverage, 5612,
     /*  609612 */     GIR_EraseRootFromParent_Done,
     /*  609613 */   // Label 9877: @609613
     /*  609613 */   GIM_Try, /*On fail goto*//*Label 9878*/ GIMT_Encode4(609685), // Rule ID 5613 //
     /*  609618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  609632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  609635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609664 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609683 */     GIR_RootConstrainSelectedInstOperands,
     /*  609684 */     // GIR_Coverage, 5613,
     /*  609684 */     GIR_EraseRootFromParent_Done,
     /*  609685 */   // Label 9878: @609685
     /*  609685 */   GIM_Try, /*On fail goto*//*Label 9879*/ GIMT_Encode4(609757), // Rule ID 5614 //
     /*  609690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  609704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  609707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609736 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609755 */     GIR_RootConstrainSelectedInstOperands,
     /*  609756 */     // GIR_Coverage, 5614,
     /*  609756 */     GIR_EraseRootFromParent_Done,
     /*  609757 */   // Label 9879: @609757
     /*  609757 */   GIM_Try, /*On fail goto*//*Label 9880*/ GIMT_Encode4(609829), // Rule ID 5615 //
     /*  609762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  609776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  609779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609808 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  609808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609827 */     GIR_RootConstrainSelectedInstOperands,
     /*  609828 */     // GIR_Coverage, 5615,
     /*  609828 */     GIR_EraseRootFromParent_Done,
     /*  609829 */   // Label 9880: @609829
     /*  609829 */   GIM_Try, /*On fail goto*//*Label 9881*/ GIMT_Encode4(609901), // Rule ID 5616 //
     /*  609834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  609848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  609851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  609880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609899 */     GIR_RootConstrainSelectedInstOperands,
     /*  609900 */     // GIR_Coverage, 5616,
     /*  609900 */     GIR_EraseRootFromParent_Done,
     /*  609901 */   // Label 9881: @609901
     /*  609901 */   GIM_Try, /*On fail goto*//*Label 9882*/ GIMT_Encode4(609973), // Rule ID 5617 //
     /*  609906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  609920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  609923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609952 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  609952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609971 */     GIR_RootConstrainSelectedInstOperands,
     /*  609972 */     // GIR_Coverage, 5617,
     /*  609972 */     GIR_EraseRootFromParent_Done,
     /*  609973 */   // Label 9882: @609973
     /*  609973 */   GIM_Try, /*On fail goto*//*Label 9883*/ GIMT_Encode4(610045), // Rule ID 5618 //
     /*  609978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  609981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  609992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  609995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  610024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  610043 */     GIR_RootConstrainSelectedInstOperands,
     /*  610044 */     // GIR_Coverage, 5618,
     /*  610044 */     GIR_EraseRootFromParent_Done,
     /*  610045 */   // Label 9883: @610045
     /*  610045 */   GIM_Try, /*On fail goto*//*Label 9884*/ GIMT_Encode4(610117), // Rule ID 5619 //
     /*  610050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  610053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  610064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  610067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610096 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  610096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  610115 */     GIR_RootConstrainSelectedInstOperands,
     /*  610116 */     // GIR_Coverage, 5619,
     /*  610116 */     GIR_EraseRootFromParent_Done,
     /*  610117 */   // Label 9884: @610117
     /*  610117 */   GIM_Try, /*On fail goto*//*Label 9885*/ GIMT_Encode4(610189), // Rule ID 5620 //
     /*  610122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  610136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  610139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610168 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610187 */     GIR_RootConstrainSelectedInstOperands,
     /*  610188 */     // GIR_Coverage, 5620,
     /*  610188 */     GIR_EraseRootFromParent_Done,
     /*  610189 */   // Label 9885: @610189
     /*  610189 */   GIM_Try, /*On fail goto*//*Label 9886*/ GIMT_Encode4(610261), // Rule ID 5621 //
     /*  610194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  610208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  610211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610240 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610259 */     GIR_RootConstrainSelectedInstOperands,
     /*  610260 */     // GIR_Coverage, 5621,
     /*  610260 */     GIR_EraseRootFromParent_Done,
     /*  610261 */   // Label 9886: @610261
     /*  610261 */   GIM_Try, /*On fail goto*//*Label 9887*/ GIMT_Encode4(610333), // Rule ID 5622 //
     /*  610266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  610280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  610283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610312 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610331 */     GIR_RootConstrainSelectedInstOperands,
     /*  610332 */     // GIR_Coverage, 5622,
     /*  610332 */     GIR_EraseRootFromParent_Done,
     /*  610333 */   // Label 9887: @610333
     /*  610333 */   GIM_Try, /*On fail goto*//*Label 9888*/ GIMT_Encode4(610405), // Rule ID 5623 //
     /*  610338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  610352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  610355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610384 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610403 */     GIR_RootConstrainSelectedInstOperands,
     /*  610404 */     // GIR_Coverage, 5623,
     /*  610404 */     GIR_EraseRootFromParent_Done,
     /*  610405 */   // Label 9888: @610405
     /*  610405 */   GIM_Try, /*On fail goto*//*Label 9889*/ GIMT_Encode4(610477), // Rule ID 5624 //
     /*  610410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  610421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  610424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  610427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  610430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610456 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610475 */     GIR_RootConstrainSelectedInstOperands,
     /*  610476 */     // GIR_Coverage, 5624,
     /*  610476 */     GIR_EraseRootFromParent_Done,
     /*  610477 */   // Label 9889: @610477
     /*  610477 */   GIM_Try, /*On fail goto*//*Label 9890*/ GIMT_Encode4(610549), // Rule ID 5625 //
     /*  610482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  610493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  610496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  610499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  610502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610528 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610547 */     GIR_RootConstrainSelectedInstOperands,
     /*  610548 */     // GIR_Coverage, 5625,
     /*  610548 */     GIR_EraseRootFromParent_Done,
     /*  610549 */   // Label 9890: @610549
     /*  610549 */   GIM_Try, /*On fail goto*//*Label 9891*/ GIMT_Encode4(610621), // Rule ID 5626 //
     /*  610554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  610568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  610571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610600 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  610600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610619 */     GIR_RootConstrainSelectedInstOperands,
     /*  610620 */     // GIR_Coverage, 5626,
     /*  610620 */     GIR_EraseRootFromParent_Done,
     /*  610621 */   // Label 9891: @610621
     /*  610621 */   GIM_Try, /*On fail goto*//*Label 9892*/ GIMT_Encode4(610693), // Rule ID 5627 //
     /*  610626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  610640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  610643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610691 */     GIR_RootConstrainSelectedInstOperands,
     /*  610692 */     // GIR_Coverage, 5627,
     /*  610692 */     GIR_EraseRootFromParent_Done,
     /*  610693 */   // Label 9892: @610693
     /*  610693 */   GIM_Try, /*On fail goto*//*Label 9893*/ GIMT_Encode4(610765), // Rule ID 5628 //
     /*  610698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  610712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  610715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610744 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  610744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610763 */     GIR_RootConstrainSelectedInstOperands,
     /*  610764 */     // GIR_Coverage, 5628,
     /*  610764 */     GIR_EraseRootFromParent_Done,
     /*  610765 */   // Label 9893: @610765
     /*  610765 */   GIM_Try, /*On fail goto*//*Label 9894*/ GIMT_Encode4(610837), // Rule ID 5629 //
     /*  610770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  610784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  610787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610816 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610835 */     GIR_RootConstrainSelectedInstOperands,
     /*  610836 */     // GIR_Coverage, 5629,
     /*  610836 */     GIR_EraseRootFromParent_Done,
     /*  610837 */   // Label 9894: @610837
     /*  610837 */   GIM_Try, /*On fail goto*//*Label 9895*/ GIMT_Encode4(610909), // Rule ID 5630 //
     /*  610842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  610856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  610859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610888 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  610888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610907 */     GIR_RootConstrainSelectedInstOperands,
     /*  610908 */     // GIR_Coverage, 5630,
     /*  610908 */     GIR_EraseRootFromParent_Done,
     /*  610909 */   // Label 9895: @610909
     /*  610909 */   GIM_Try, /*On fail goto*//*Label 9896*/ GIMT_Encode4(610981), // Rule ID 5631 //
     /*  610914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  610928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  610931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610960 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610979 */     GIR_RootConstrainSelectedInstOperands,
     /*  610980 */     // GIR_Coverage, 5631,
     /*  610980 */     GIR_EraseRootFromParent_Done,
     /*  610981 */   // Label 9896: @610981
     /*  610981 */   GIM_Try, /*On fail goto*//*Label 9897*/ GIMT_Encode4(611053), // Rule ID 5632 //
     /*  610986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  610997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  611000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  611003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611032 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611051 */     GIR_RootConstrainSelectedInstOperands,
     /*  611052 */     // GIR_Coverage, 5632,
     /*  611052 */     GIR_EraseRootFromParent_Done,
     /*  611053 */   // Label 9897: @611053
     /*  611053 */   GIM_Try, /*On fail goto*//*Label 9898*/ GIMT_Encode4(611125), // Rule ID 5633 //
     /*  611058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  611072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  611075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611104 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611123 */     GIR_RootConstrainSelectedInstOperands,
     /*  611124 */     // GIR_Coverage, 5633,
     /*  611124 */     GIR_EraseRootFromParent_Done,
     /*  611125 */   // Label 9898: @611125
     /*  611125 */   GIM_Try, /*On fail goto*//*Label 9899*/ GIMT_Encode4(611197), // Rule ID 5634 //
     /*  611130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  611144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  611147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611176 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611195 */     GIR_RootConstrainSelectedInstOperands,
     /*  611196 */     // GIR_Coverage, 5634,
     /*  611196 */     GIR_EraseRootFromParent_Done,
     /*  611197 */   // Label 9899: @611197
     /*  611197 */   GIM_Try, /*On fail goto*//*Label 9900*/ GIMT_Encode4(611269), // Rule ID 5635 //
     /*  611202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  611216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  611219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611267 */     GIR_RootConstrainSelectedInstOperands,
     /*  611268 */     // GIR_Coverage, 5635,
     /*  611268 */     GIR_EraseRootFromParent_Done,
     /*  611269 */   // Label 9900: @611269
     /*  611269 */   GIM_Try, /*On fail goto*//*Label 9901*/ GIMT_Encode4(611341), // Rule ID 5636 //
     /*  611274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  611288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  611291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611320 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611339 */     GIR_RootConstrainSelectedInstOperands,
     /*  611340 */     // GIR_Coverage, 5636,
     /*  611340 */     GIR_EraseRootFromParent_Done,
     /*  611341 */   // Label 9901: @611341
     /*  611341 */   GIM_Try, /*On fail goto*//*Label 9902*/ GIMT_Encode4(611413), // Rule ID 5637 //
     /*  611346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  611360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  611363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611392 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611411 */     GIR_RootConstrainSelectedInstOperands,
     /*  611412 */     // GIR_Coverage, 5637,
     /*  611412 */     GIR_EraseRootFromParent_Done,
     /*  611413 */   // Label 9902: @611413
     /*  611413 */   GIM_Try, /*On fail goto*//*Label 9903*/ GIMT_Encode4(611485), // Rule ID 5638 //
     /*  611418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  611421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  611429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  611432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  611435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  611438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611464 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  611464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611483 */     GIR_RootConstrainSelectedInstOperands,
     /*  611484 */     // GIR_Coverage, 5638,
     /*  611484 */     GIR_EraseRootFromParent_Done,
     /*  611485 */   // Label 9903: @611485
     /*  611485 */   GIM_Try, /*On fail goto*//*Label 9904*/ GIMT_Encode4(611557), // Rule ID 5639 //
     /*  611490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  611493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  611501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  611504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  611507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  611510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611536 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  611536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611555 */     GIR_RootConstrainSelectedInstOperands,
     /*  611556 */     // GIR_Coverage, 5639,
     /*  611556 */     GIR_EraseRootFromParent_Done,
     /*  611557 */   // Label 9904: @611557
     /*  611557 */   GIM_Try, /*On fail goto*//*Label 9905*/ GIMT_Encode4(611629), // Rule ID 5640 //
     /*  611562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  611565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  611576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  611579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  611608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611627 */     GIR_RootConstrainSelectedInstOperands,
     /*  611628 */     // GIR_Coverage, 5640,
     /*  611628 */     GIR_EraseRootFromParent_Done,
     /*  611629 */   // Label 9905: @611629
     /*  611629 */   GIM_Try, /*On fail goto*//*Label 9906*/ GIMT_Encode4(611701), // Rule ID 5641 //
     /*  611634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  611637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  611648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  611651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  611680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611699 */     GIR_RootConstrainSelectedInstOperands,
     /*  611700 */     // GIR_Coverage, 5641,
     /*  611700 */     GIR_EraseRootFromParent_Done,
     /*  611701 */   // Label 9906: @611701
     /*  611701 */   GIM_Try, /*On fail goto*//*Label 9907*/ GIMT_Encode4(611773), // Rule ID 5642 //
     /*  611706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  611709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  611720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  611723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611752 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  611752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611771 */     GIR_RootConstrainSelectedInstOperands,
     /*  611772 */     // GIR_Coverage, 5642,
     /*  611772 */     GIR_EraseRootFromParent_Done,
     /*  611773 */   // Label 9907: @611773
     /*  611773 */   GIM_Try, /*On fail goto*//*Label 9908*/ GIMT_Encode4(611845), // Rule ID 5643 //
     /*  611778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  611781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  611792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  611795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611824 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  611824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611843 */     GIR_RootConstrainSelectedInstOperands,
     /*  611844 */     // GIR_Coverage, 5643,
     /*  611844 */     GIR_EraseRootFromParent_Done,
     /*  611845 */   // Label 9908: @611845
     /*  611845 */   GIM_Try, /*On fail goto*//*Label 9909*/ GIMT_Encode4(611917), // Rule ID 5644 //
     /*  611850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  611861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  611864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  611870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611896 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  611896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  611899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611915 */     GIR_RootConstrainSelectedInstOperands,
     /*  611916 */     // GIR_Coverage, 5644,
     /*  611916 */     GIR_EraseRootFromParent_Done,
     /*  611917 */   // Label 9909: @611917
     /*  611917 */   GIM_Try, /*On fail goto*//*Label 9910*/ GIMT_Encode4(611989), // Rule ID 5645 //
     /*  611922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  611933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  611936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  611942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611968 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  611968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  611971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611987 */     GIR_RootConstrainSelectedInstOperands,
     /*  611988 */     // GIR_Coverage, 5645,
     /*  611988 */     GIR_EraseRootFromParent_Done,
     /*  611989 */   // Label 9910: @611989
     /*  611989 */   GIM_Try, /*On fail goto*//*Label 9911*/ GIMT_Encode4(612061), // Rule ID 5646 //
     /*  611994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  612008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612040 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612059 */     GIR_RootConstrainSelectedInstOperands,
     /*  612060 */     // GIR_Coverage, 5646,
     /*  612060 */     GIR_EraseRootFromParent_Done,
     /*  612061 */   // Label 9911: @612061
     /*  612061 */   GIM_Try, /*On fail goto*//*Label 9912*/ GIMT_Encode4(612133), // Rule ID 5647 //
     /*  612066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  612080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612112 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612131 */     GIR_RootConstrainSelectedInstOperands,
     /*  612132 */     // GIR_Coverage, 5647,
     /*  612132 */     GIR_EraseRootFromParent_Done,
     /*  612133 */   // Label 9912: @612133
     /*  612133 */   GIM_Try, /*On fail goto*//*Label 9913*/ GIMT_Encode4(612205), // Rule ID 5648 //
     /*  612138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  612152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612184 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612203 */     GIR_RootConstrainSelectedInstOperands,
     /*  612204 */     // GIR_Coverage, 5648,
     /*  612204 */     GIR_EraseRootFromParent_Done,
     /*  612205 */   // Label 9913: @612205
     /*  612205 */   GIM_Try, /*On fail goto*//*Label 9914*/ GIMT_Encode4(612277), // Rule ID 5649 //
     /*  612210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  612224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612256 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612275 */     GIR_RootConstrainSelectedInstOperands,
     /*  612276 */     // GIR_Coverage, 5649,
     /*  612276 */     GIR_EraseRootFromParent_Done,
     /*  612277 */   // Label 9914: @612277
     /*  612277 */   GIM_Try, /*On fail goto*//*Label 9915*/ GIMT_Encode4(612349), // Rule ID 5650 //
     /*  612282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  612296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612328 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  612328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612347 */     GIR_RootConstrainSelectedInstOperands,
     /*  612348 */     // GIR_Coverage, 5650,
     /*  612348 */     GIR_EraseRootFromParent_Done,
     /*  612349 */   // Label 9915: @612349
     /*  612349 */   GIM_Try, /*On fail goto*//*Label 9916*/ GIMT_Encode4(612421), // Rule ID 5651 //
     /*  612354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  612368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612400 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  612400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612419 */     GIR_RootConstrainSelectedInstOperands,
     /*  612420 */     // GIR_Coverage, 5651,
     /*  612420 */     GIR_EraseRootFromParent_Done,
     /*  612421 */   // Label 9916: @612421
     /*  612421 */   GIM_Try, /*On fail goto*//*Label 9917*/ GIMT_Encode4(612493), // Rule ID 5652 //
     /*  612426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  612440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612472 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  612472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612491 */     GIR_RootConstrainSelectedInstOperands,
     /*  612492 */     // GIR_Coverage, 5652,
     /*  612492 */     GIR_EraseRootFromParent_Done,
     /*  612493 */   // Label 9917: @612493
     /*  612493 */   GIM_Try, /*On fail goto*//*Label 9918*/ GIMT_Encode4(612565), // Rule ID 5653 //
     /*  612498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  612512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  612544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612563 */     GIR_RootConstrainSelectedInstOperands,
     /*  612564 */     // GIR_Coverage, 5653,
     /*  612564 */     GIR_EraseRootFromParent_Done,
     /*  612565 */   // Label 9918: @612565
     /*  612565 */   GIM_Try, /*On fail goto*//*Label 9919*/ GIMT_Encode4(612637), // Rule ID 5654 //
     /*  612570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  612584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612616 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  612616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612635 */     GIR_RootConstrainSelectedInstOperands,
     /*  612636 */     // GIR_Coverage, 5654,
     /*  612636 */     GIR_EraseRootFromParent_Done,
     /*  612637 */   // Label 9919: @612637
     /*  612637 */   GIM_Try, /*On fail goto*//*Label 9920*/ GIMT_Encode4(612709), // Rule ID 5655 //
     /*  612642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  612656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  612688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612707 */     GIR_RootConstrainSelectedInstOperands,
     /*  612708 */     // GIR_Coverage, 5655,
     /*  612708 */     GIR_EraseRootFromParent_Done,
     /*  612709 */   // Label 9920: @612709
     /*  612709 */   GIM_Try, /*On fail goto*//*Label 9921*/ GIMT_Encode4(612781), // Rule ID 5656 //
     /*  612714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  612728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612760 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612779 */     GIR_RootConstrainSelectedInstOperands,
     /*  612780 */     // GIR_Coverage, 5656,
     /*  612780 */     GIR_EraseRootFromParent_Done,
     /*  612781 */   // Label 9921: @612781
     /*  612781 */   GIM_Try, /*On fail goto*//*Label 9922*/ GIMT_Encode4(612853), // Rule ID 5657 //
     /*  612786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  612800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612832 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612851 */     GIR_RootConstrainSelectedInstOperands,
     /*  612852 */     // GIR_Coverage, 5657,
     /*  612852 */     GIR_EraseRootFromParent_Done,
     /*  612853 */   // Label 9922: @612853
     /*  612853 */   GIM_Try, /*On fail goto*//*Label 9923*/ GIMT_Encode4(612925), // Rule ID 5658 //
     /*  612858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  612872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612904 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  612904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612923 */     GIR_RootConstrainSelectedInstOperands,
     /*  612924 */     // GIR_Coverage, 5658,
     /*  612924 */     GIR_EraseRootFromParent_Done,
     /*  612925 */   // Label 9923: @612925
     /*  612925 */   GIM_Try, /*On fail goto*//*Label 9924*/ GIMT_Encode4(612997), // Rule ID 5659 //
     /*  612930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  612944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612976 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  612976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612995 */     GIR_RootConstrainSelectedInstOperands,
     /*  612996 */     // GIR_Coverage, 5659,
     /*  612996 */     GIR_EraseRootFromParent_Done,
     /*  612997 */   // Label 9924: @612997
     /*  612997 */   GIM_Try, /*On fail goto*//*Label 9925*/ GIMT_Encode4(613069), // Rule ID 5660 //
     /*  613002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  613016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613048 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  613048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613067 */     GIR_RootConstrainSelectedInstOperands,
     /*  613068 */     // GIR_Coverage, 5660,
     /*  613068 */     GIR_EraseRootFromParent_Done,
     /*  613069 */   // Label 9925: @613069
     /*  613069 */   GIM_Try, /*On fail goto*//*Label 9926*/ GIMT_Encode4(613141), // Rule ID 5661 //
     /*  613074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  613088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613120 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  613120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613139 */     GIR_RootConstrainSelectedInstOperands,
     /*  613140 */     // GIR_Coverage, 5661,
     /*  613140 */     GIR_EraseRootFromParent_Done,
     /*  613141 */   // Label 9926: @613141
     /*  613141 */   GIM_Try, /*On fail goto*//*Label 9927*/ GIMT_Encode4(613213), // Rule ID 5662 //
     /*  613146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  613149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  613160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613192 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  613192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  613211 */     GIR_RootConstrainSelectedInstOperands,
     /*  613212 */     // GIR_Coverage, 5662,
     /*  613212 */     GIR_EraseRootFromParent_Done,
     /*  613213 */   // Label 9927: @613213
     /*  613213 */   GIM_Try, /*On fail goto*//*Label 9928*/ GIMT_Encode4(613285), // Rule ID 5663 //
     /*  613218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  613221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  613232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613264 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  613264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  613283 */     GIR_RootConstrainSelectedInstOperands,
     /*  613284 */     // GIR_Coverage, 5663,
     /*  613284 */     GIR_EraseRootFromParent_Done,
     /*  613285 */   // Label 9928: @613285
     /*  613285 */   GIM_Try, /*On fail goto*//*Label 9929*/ GIMT_Encode4(613357), // Rule ID 5664 //
     /*  613290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  613304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613336 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613355 */     GIR_RootConstrainSelectedInstOperands,
     /*  613356 */     // GIR_Coverage, 5664,
     /*  613356 */     GIR_EraseRootFromParent_Done,
     /*  613357 */   // Label 9929: @613357
     /*  613357 */   GIM_Try, /*On fail goto*//*Label 9930*/ GIMT_Encode4(613429), // Rule ID 5665 //
     /*  613362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  613376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613408 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613427 */     GIR_RootConstrainSelectedInstOperands,
     /*  613428 */     // GIR_Coverage, 5665,
     /*  613428 */     GIR_EraseRootFromParent_Done,
     /*  613429 */   // Label 9930: @613429
     /*  613429 */   GIM_Try, /*On fail goto*//*Label 9931*/ GIMT_Encode4(613501), // Rule ID 5666 //
     /*  613434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  613445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  613448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  613454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613480 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613499 */     GIR_RootConstrainSelectedInstOperands,
     /*  613500 */     // GIR_Coverage, 5666,
     /*  613500 */     GIR_EraseRootFromParent_Done,
     /*  613501 */   // Label 9931: @613501
     /*  613501 */   GIM_Try, /*On fail goto*//*Label 9932*/ GIMT_Encode4(613573), // Rule ID 5667 //
     /*  613506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  613517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  613520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  613526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613552 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613571 */     GIR_RootConstrainSelectedInstOperands,
     /*  613572 */     // GIR_Coverage, 5667,
     /*  613572 */     GIR_EraseRootFromParent_Done,
     /*  613573 */   // Label 9932: @613573
     /*  613573 */   GIM_Try, /*On fail goto*//*Label 9933*/ GIMT_Encode4(613645), // Rule ID 5668 //
     /*  613578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  613589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  613592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  613598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  613609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613624 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  613627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613643 */     GIR_RootConstrainSelectedInstOperands,
     /*  613644 */     // GIR_Coverage, 5668,
     /*  613644 */     GIR_EraseRootFromParent_Done,
     /*  613645 */   // Label 9933: @613645
     /*  613645 */   GIM_Try, /*On fail goto*//*Label 9934*/ GIMT_Encode4(613717), // Rule ID 5669 //
     /*  613650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  613661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  613664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  613670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  613681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613696 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  613699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613715 */     GIR_RootConstrainSelectedInstOperands,
     /*  613716 */     // GIR_Coverage, 5669,
     /*  613716 */     GIR_EraseRootFromParent_Done,
     /*  613717 */   // Label 9934: @613717
     /*  613717 */   GIM_Try, /*On fail goto*//*Label 9935*/ GIMT_Encode4(613789), // Rule ID 5670 //
     /*  613722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  613736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613768 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  613768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613787 */     GIR_RootConstrainSelectedInstOperands,
     /*  613788 */     // GIR_Coverage, 5670,
     /*  613788 */     GIR_EraseRootFromParent_Done,
     /*  613789 */   // Label 9935: @613789
     /*  613789 */   GIM_Try, /*On fail goto*//*Label 9936*/ GIMT_Encode4(613861), // Rule ID 5671 //
     /*  613794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  613808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613840 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613859 */     GIR_RootConstrainSelectedInstOperands,
     /*  613860 */     // GIR_Coverage, 5671,
     /*  613860 */     GIR_EraseRootFromParent_Done,
     /*  613861 */   // Label 9936: @613861
     /*  613861 */   GIM_Try, /*On fail goto*//*Label 9937*/ GIMT_Encode4(613933), // Rule ID 5672 //
     /*  613866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  613880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613912 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  613912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613931 */     GIR_RootConstrainSelectedInstOperands,
     /*  613932 */     // GIR_Coverage, 5672,
     /*  613932 */     GIR_EraseRootFromParent_Done,
     /*  613933 */   // Label 9937: @613933
     /*  613933 */   GIM_Try, /*On fail goto*//*Label 9938*/ GIMT_Encode4(614005), // Rule ID 5673 //
     /*  613938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  613952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613984 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614003 */     GIR_RootConstrainSelectedInstOperands,
     /*  614004 */     // GIR_Coverage, 5673,
     /*  614004 */     GIR_EraseRootFromParent_Done,
     /*  614005 */   // Label 9938: @614005
     /*  614005 */   GIM_Try, /*On fail goto*//*Label 9939*/ GIMT_Encode4(614077), // Rule ID 5674 //
     /*  614010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  614024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614056 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614075 */     GIR_RootConstrainSelectedInstOperands,
     /*  614076 */     // GIR_Coverage, 5674,
     /*  614076 */     GIR_EraseRootFromParent_Done,
     /*  614077 */   // Label 9939: @614077
     /*  614077 */   GIM_Try, /*On fail goto*//*Label 9940*/ GIMT_Encode4(614149), // Rule ID 5675 //
     /*  614082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  614096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614128 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614147 */     GIR_RootConstrainSelectedInstOperands,
     /*  614148 */     // GIR_Coverage, 5675,
     /*  614148 */     GIR_EraseRootFromParent_Done,
     /*  614149 */   // Label 9940: @614149
     /*  614149 */   GIM_Try, /*On fail goto*//*Label 9941*/ GIMT_Encode4(614221), // Rule ID 5676 //
     /*  614154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  614168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614200 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614219 */     GIR_RootConstrainSelectedInstOperands,
     /*  614220 */     // GIR_Coverage, 5676,
     /*  614220 */     GIR_EraseRootFromParent_Done,
     /*  614221 */   // Label 9941: @614221
     /*  614221 */   GIM_Try, /*On fail goto*//*Label 9942*/ GIMT_Encode4(614293), // Rule ID 5677 //
     /*  614226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  614240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614272 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  614272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614291 */     GIR_RootConstrainSelectedInstOperands,
     /*  614292 */     // GIR_Coverage, 5677,
     /*  614292 */     GIR_EraseRootFromParent_Done,
     /*  614293 */   // Label 9942: @614293
     /*  614293 */   GIM_Try, /*On fail goto*//*Label 9943*/ GIMT_Encode4(614365), // Rule ID 5678 //
     /*  614298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  614312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614344 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614363 */     GIR_RootConstrainSelectedInstOperands,
     /*  614364 */     // GIR_Coverage, 5678,
     /*  614364 */     GIR_EraseRootFromParent_Done,
     /*  614365 */   // Label 9943: @614365
     /*  614365 */   GIM_Try, /*On fail goto*//*Label 9944*/ GIMT_Encode4(614437), // Rule ID 5679 //
     /*  614370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  614384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614416 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  614416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614435 */     GIR_RootConstrainSelectedInstOperands,
     /*  614436 */     // GIR_Coverage, 5679,
     /*  614436 */     GIR_EraseRootFromParent_Done,
     /*  614437 */   // Label 9944: @614437
     /*  614437 */   GIM_Try, /*On fail goto*//*Label 9945*/ GIMT_Encode4(614509), // Rule ID 5680 //
     /*  614442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  614456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614488 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614507 */     GIR_RootConstrainSelectedInstOperands,
     /*  614508 */     // GIR_Coverage, 5680,
     /*  614508 */     GIR_EraseRootFromParent_Done,
     /*  614509 */   // Label 9945: @614509
     /*  614509 */   GIM_Try, /*On fail goto*//*Label 9946*/ GIMT_Encode4(614581), // Rule ID 5681 //
     /*  614514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  614528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614560 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  614560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614579 */     GIR_RootConstrainSelectedInstOperands,
     /*  614580 */     // GIR_Coverage, 5681,
     /*  614580 */     GIR_EraseRootFromParent_Done,
     /*  614581 */   // Label 9946: @614581
     /*  614581 */   GIM_Try, /*On fail goto*//*Label 9947*/ GIMT_Encode4(614653), // Rule ID 5682 //
     /*  614586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  614589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  614597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  614600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  614606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614632 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  614632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614651 */     GIR_RootConstrainSelectedInstOperands,
     /*  614652 */     // GIR_Coverage, 5682,
     /*  614652 */     GIR_EraseRootFromParent_Done,
     /*  614653 */   // Label 9947: @614653
     /*  614653 */   GIM_Try, /*On fail goto*//*Label 9948*/ GIMT_Encode4(614725), // Rule ID 5683 //
     /*  614658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  614661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  614669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  614672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  614678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  614704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614723 */     GIR_RootConstrainSelectedInstOperands,
     /*  614724 */     // GIR_Coverage, 5683,
     /*  614724 */     GIR_EraseRootFromParent_Done,
     /*  614725 */   // Label 9948: @614725
     /*  614725 */   GIM_Try, /*On fail goto*//*Label 9949*/ GIMT_Encode4(614797), // Rule ID 5684 //
     /*  614730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  614733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  614744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614776 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  614776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614795 */     GIR_RootConstrainSelectedInstOperands,
     /*  614796 */     // GIR_Coverage, 5684,
     /*  614796 */     GIR_EraseRootFromParent_Done,
     /*  614797 */   // Label 9949: @614797
     /*  614797 */   GIM_Try, /*On fail goto*//*Label 9950*/ GIMT_Encode4(614869), // Rule ID 5685 //
     /*  614802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  614805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  614816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614848 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  614848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614867 */     GIR_RootConstrainSelectedInstOperands,
     /*  614868 */     // GIR_Coverage, 5685,
     /*  614868 */     GIR_EraseRootFromParent_Done,
     /*  614869 */   // Label 9950: @614869
     /*  614869 */   GIM_Try, /*On fail goto*//*Label 9951*/ GIMT_Encode4(614941), // Rule ID 5686 //
     /*  614874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  614877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  614888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614920 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  614920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614939 */     GIR_RootConstrainSelectedInstOperands,
     /*  614940 */     // GIR_Coverage, 5686,
     /*  614940 */     GIR_EraseRootFromParent_Done,
     /*  614941 */   // Label 9951: @614941
     /*  614941 */   GIM_Try, /*On fail goto*//*Label 9952*/ GIMT_Encode4(615013), // Rule ID 5687 //
     /*  614946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  614949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  614960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614992 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  614992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615011 */     GIR_RootConstrainSelectedInstOperands,
     /*  615012 */     // GIR_Coverage, 5687,
     /*  615012 */     GIR_EraseRootFromParent_Done,
     /*  615013 */   // Label 9952: @615013
     /*  615013 */   GIM_Try, /*On fail goto*//*Label 9953*/ GIMT_Encode4(615088), // Rule ID 5776 //
     /*  615018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  615029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  615035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  615038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615064 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  615067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615086 */     GIR_RootConstrainSelectedInstOperands,
     /*  615087 */     // GIR_Coverage, 5776,
     /*  615087 */     GIR_EraseRootFromParent_Done,
     /*  615088 */   // Label 9953: @615088
     /*  615088 */   GIM_Try, /*On fail goto*//*Label 9954*/ GIMT_Encode4(615163), // Rule ID 5777 //
     /*  615093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  615104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  615110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  615113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615139 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  615142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615161 */     GIR_RootConstrainSelectedInstOperands,
     /*  615162 */     // GIR_Coverage, 5777,
     /*  615162 */     GIR_EraseRootFromParent_Done,
     /*  615163 */   // Label 9954: @615163
     /*  615163 */   GIM_Try, /*On fail goto*//*Label 9955*/ GIMT_Encode4(615238), // Rule ID 5780 //
     /*  615168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  615179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  615185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  615188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615214 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615236 */     GIR_RootConstrainSelectedInstOperands,
     /*  615237 */     // GIR_Coverage, 5780,
     /*  615237 */     GIR_EraseRootFromParent_Done,
     /*  615238 */   // Label 9955: @615238
     /*  615238 */   GIM_Try, /*On fail goto*//*Label 9956*/ GIMT_Encode4(615313), // Rule ID 5781 //
     /*  615243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  615254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  615260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  615263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615289 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615311 */     GIR_RootConstrainSelectedInstOperands,
     /*  615312 */     // GIR_Coverage, 5781,
     /*  615312 */     GIR_EraseRootFromParent_Done,
     /*  615313 */   // Label 9956: @615313
     /*  615313 */   GIM_Try, /*On fail goto*//*Label 9957*/ GIMT_Encode4(615388), // Rule ID 5784 //
     /*  615318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  615329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  615332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  615335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  615338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615364 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615386 */     GIR_RootConstrainSelectedInstOperands,
     /*  615387 */     // GIR_Coverage, 5784,
     /*  615387 */     GIR_EraseRootFromParent_Done,
     /*  615388 */   // Label 9957: @615388
     /*  615388 */   GIM_Try, /*On fail goto*//*Label 9958*/ GIMT_Encode4(615463), // Rule ID 5785 //
     /*  615393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  615404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  615407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  615410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  615413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615439 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615461 */     GIR_RootConstrainSelectedInstOperands,
     /*  615462 */     // GIR_Coverage, 5785,
     /*  615462 */     GIR_EraseRootFromParent_Done,
     /*  615463 */   // Label 9958: @615463
     /*  615463 */   GIM_Try, /*On fail goto*//*Label 9959*/ GIMT_Encode4(615538), // Rule ID 5788 //
     /*  615468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  615479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  615482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  615485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  615488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615514 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  615514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615536 */     GIR_RootConstrainSelectedInstOperands,
     /*  615537 */     // GIR_Coverage, 5788,
     /*  615537 */     GIR_EraseRootFromParent_Done,
     /*  615538 */   // Label 9959: @615538
     /*  615538 */   GIM_Try, /*On fail goto*//*Label 9960*/ GIMT_Encode4(615613), // Rule ID 5789 //
     /*  615543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  615554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  615557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  615560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  615563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615589 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  615589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615611 */     GIR_RootConstrainSelectedInstOperands,
     /*  615612 */     // GIR_Coverage, 5789,
     /*  615612 */     GIR_EraseRootFromParent_Done,
     /*  615613 */   // Label 9960: @615613
     /*  615613 */   GIM_Try, /*On fail goto*//*Label 9961*/ GIMT_Encode4(615688), // Rule ID 5792 //
     /*  615618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  615629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  615632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  615635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  615638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615664 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  615664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615686 */     GIR_RootConstrainSelectedInstOperands,
     /*  615687 */     // GIR_Coverage, 5792,
     /*  615687 */     GIR_EraseRootFromParent_Done,
     /*  615688 */   // Label 9961: @615688
     /*  615688 */   GIM_Try, /*On fail goto*//*Label 9962*/ GIMT_Encode4(615763), // Rule ID 5793 //
     /*  615693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  615704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  615707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  615710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  615713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615739 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  615739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615761 */     GIR_RootConstrainSelectedInstOperands,
     /*  615762 */     // GIR_Coverage, 5793,
     /*  615762 */     GIR_EraseRootFromParent_Done,
     /*  615763 */   // Label 9962: @615763
     /*  615763 */   GIM_Try, /*On fail goto*//*Label 9963*/ GIMT_Encode4(615838), // Rule ID 5796 //
     /*  615768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  615779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  615782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  615785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  615788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  615814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615836 */     GIR_RootConstrainSelectedInstOperands,
     /*  615837 */     // GIR_Coverage, 5796,
     /*  615837 */     GIR_EraseRootFromParent_Done,
     /*  615838 */   // Label 9963: @615838
     /*  615838 */   GIM_Try, /*On fail goto*//*Label 9964*/ GIMT_Encode4(615913), // Rule ID 5797 //
     /*  615843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  615854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  615857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  615860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  615863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615889 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  615889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615911 */     GIR_RootConstrainSelectedInstOperands,
     /*  615912 */     // GIR_Coverage, 5797,
     /*  615912 */     GIR_EraseRootFromParent_Done,
     /*  615913 */   // Label 9964: @615913
     /*  615913 */   GIM_Try, /*On fail goto*//*Label 9965*/ GIMT_Encode4(615988), // Rule ID 5800 //
     /*  615918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  615929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  615932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  615935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  615938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615964 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  615967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615986 */     GIR_RootConstrainSelectedInstOperands,
     /*  615987 */     // GIR_Coverage, 5800,
     /*  615987 */     GIR_EraseRootFromParent_Done,
     /*  615988 */   // Label 9965: @615988
     /*  615988 */   GIM_Try, /*On fail goto*//*Label 9966*/ GIMT_Encode4(616063), // Rule ID 5801 //
     /*  615993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  616004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  616007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  616010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  616013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616039 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616061 */     GIR_RootConstrainSelectedInstOperands,
     /*  616062 */     // GIR_Coverage, 5801,
     /*  616062 */     GIR_EraseRootFromParent_Done,
     /*  616063 */   // Label 9966: @616063
     /*  616063 */   GIM_Try, /*On fail goto*//*Label 9967*/ GIMT_Encode4(616138), // Rule ID 5804 //
     /*  616068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  616079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  616085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  616088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  616114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616136 */     GIR_RootConstrainSelectedInstOperands,
     /*  616137 */     // GIR_Coverage, 5804,
     /*  616137 */     GIR_EraseRootFromParent_Done,
     /*  616138 */   // Label 9967: @616138
     /*  616138 */   GIM_Try, /*On fail goto*//*Label 9968*/ GIMT_Encode4(616213), // Rule ID 5805 //
     /*  616143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  616154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  616160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  616163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616189 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616211 */     GIR_RootConstrainSelectedInstOperands,
     /*  616212 */     // GIR_Coverage, 5805,
     /*  616212 */     GIR_EraseRootFromParent_Done,
     /*  616213 */   // Label 9968: @616213
     /*  616213 */   GIM_Try, /*On fail goto*//*Label 9969*/ GIMT_Encode4(616288), // Rule ID 5808 //
     /*  616218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  616229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  616232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  616235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  616238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  616264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616286 */     GIR_RootConstrainSelectedInstOperands,
     /*  616287 */     // GIR_Coverage, 5808,
     /*  616287 */     GIR_EraseRootFromParent_Done,
     /*  616288 */   // Label 9969: @616288
     /*  616288 */   GIM_Try, /*On fail goto*//*Label 9970*/ GIMT_Encode4(616363), // Rule ID 5809 //
     /*  616293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  616304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  616307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  616310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  616313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616339 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  616339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616361 */     GIR_RootConstrainSelectedInstOperands,
     /*  616362 */     // GIR_Coverage, 5809,
     /*  616362 */     GIR_EraseRootFromParent_Done,
     /*  616363 */   // Label 9970: @616363
     /*  616363 */   GIM_Try, /*On fail goto*//*Label 9971*/ GIMT_Encode4(616438), // Rule ID 5812 //
     /*  616368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  616371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  616379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  616382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  616385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  616388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  616414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  616433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616436 */     GIR_RootConstrainSelectedInstOperands,
     /*  616437 */     // GIR_Coverage, 5812,
     /*  616437 */     GIR_EraseRootFromParent_Done,
     /*  616438 */   // Label 9971: @616438
     /*  616438 */   GIM_Try, /*On fail goto*//*Label 9972*/ GIMT_Encode4(616513), // Rule ID 5813 //
     /*  616443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  616446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  616454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  616457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  616460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  616463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616489 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  616489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  616508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616511 */     GIR_RootConstrainSelectedInstOperands,
     /*  616512 */     // GIR_Coverage, 5813,
     /*  616512 */     GIR_EraseRootFromParent_Done,
     /*  616513 */   // Label 9972: @616513
     /*  616513 */   GIM_Try, /*On fail goto*//*Label 9973*/ GIMT_Encode4(616588), // Rule ID 5816 //
     /*  616518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  616529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  616532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  616535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  616538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616564 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  616564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  616567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616586 */     GIR_RootConstrainSelectedInstOperands,
     /*  616587 */     // GIR_Coverage, 5816,
     /*  616587 */     GIR_EraseRootFromParent_Done,
     /*  616588 */   // Label 9973: @616588
     /*  616588 */   GIM_Try, /*On fail goto*//*Label 9974*/ GIMT_Encode4(616663), // Rule ID 5817 //
     /*  616593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  616604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  616607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  616610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  616613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616639 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  616642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616661 */     GIR_RootConstrainSelectedInstOperands,
     /*  616662 */     // GIR_Coverage, 5817,
     /*  616662 */     GIR_EraseRootFromParent_Done,
     /*  616663 */   // Label 9974: @616663
     /*  616663 */   GIM_Try, /*On fail goto*//*Label 9975*/ GIMT_Encode4(616738), // Rule ID 5820 //
     /*  616668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  616679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  616682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  616685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  616688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616714 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  616714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  616717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616736 */     GIR_RootConstrainSelectedInstOperands,
     /*  616737 */     // GIR_Coverage, 5820,
     /*  616737 */     GIR_EraseRootFromParent_Done,
     /*  616738 */   // Label 9975: @616738
     /*  616738 */   GIM_Try, /*On fail goto*//*Label 9976*/ GIMT_Encode4(616813), // Rule ID 5821 //
     /*  616743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  616754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  616757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  616760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  616763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616789 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  616792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616811 */     GIR_RootConstrainSelectedInstOperands,
     /*  616812 */     // GIR_Coverage, 5821,
     /*  616812 */     GIR_EraseRootFromParent_Done,
     /*  616813 */   // Label 9976: @616813
     /*  616813 */   GIM_Try, /*On fail goto*//*Label 9977*/ GIMT_Encode4(616888), // Rule ID 5824 //
     /*  616818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  616829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  616832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  616835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  616838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616864 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  616864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  616867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616886 */     GIR_RootConstrainSelectedInstOperands,
     /*  616887 */     // GIR_Coverage, 5824,
     /*  616887 */     GIR_EraseRootFromParent_Done,
     /*  616888 */   // Label 9977: @616888
     /*  616888 */   GIM_Try, /*On fail goto*//*Label 9978*/ GIMT_Encode4(616963), // Rule ID 5825 //
     /*  616893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  616904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  616907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  616910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  616913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616939 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  616942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616961 */     GIR_RootConstrainSelectedInstOperands,
     /*  616962 */     // GIR_Coverage, 5825,
     /*  616962 */     GIR_EraseRootFromParent_Done,
     /*  616963 */   // Label 9978: @616963
     /*  616963 */   GIM_Try, /*On fail goto*//*Label 9979*/ GIMT_Encode4(617038), // Rule ID 5828 //
     /*  616968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  616979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  616982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  616985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  616988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617036 */     GIR_RootConstrainSelectedInstOperands,
     /*  617037 */     // GIR_Coverage, 5828,
     /*  617037 */     GIR_EraseRootFromParent_Done,
     /*  617038 */   // Label 9979: @617038
     /*  617038 */   GIM_Try, /*On fail goto*//*Label 9980*/ GIMT_Encode4(617113), // Rule ID 5829 //
     /*  617043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  617054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  617057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  617060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  617063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617111 */     GIR_RootConstrainSelectedInstOperands,
     /*  617112 */     // GIR_Coverage, 5829,
     /*  617112 */     GIR_EraseRootFromParent_Done,
     /*  617113 */   // Label 9980: @617113
     /*  617113 */   GIM_Try, /*On fail goto*//*Label 9981*/ GIMT_Encode4(617188), // Rule ID 5832 //
     /*  617118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  617129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  617135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  617138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617164 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617186 */     GIR_RootConstrainSelectedInstOperands,
     /*  617187 */     // GIR_Coverage, 5832,
     /*  617187 */     GIR_EraseRootFromParent_Done,
     /*  617188 */   // Label 9981: @617188
     /*  617188 */   GIM_Try, /*On fail goto*//*Label 9982*/ GIMT_Encode4(617263), // Rule ID 5833 //
     /*  617193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  617204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  617210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  617213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617239 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617261 */     GIR_RootConstrainSelectedInstOperands,
     /*  617262 */     // GIR_Coverage, 5833,
     /*  617262 */     GIR_EraseRootFromParent_Done,
     /*  617263 */   // Label 9982: @617263
     /*  617263 */   GIM_Try, /*On fail goto*//*Label 9983*/ GIMT_Encode4(617338), // Rule ID 5836 //
     /*  617268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  617279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  617285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  617288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617314 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617336 */     GIR_RootConstrainSelectedInstOperands,
     /*  617337 */     // GIR_Coverage, 5836,
     /*  617337 */     GIR_EraseRootFromParent_Done,
     /*  617338 */   // Label 9983: @617338
     /*  617338 */   GIM_Try, /*On fail goto*//*Label 9984*/ GIMT_Encode4(617413), // Rule ID 5837 //
     /*  617343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  617354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  617360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  617363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617389 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617411 */     GIR_RootConstrainSelectedInstOperands,
     /*  617412 */     // GIR_Coverage, 5837,
     /*  617412 */     GIR_EraseRootFromParent_Done,
     /*  617413 */   // Label 9984: @617413
     /*  617413 */   GIM_Try, /*On fail goto*//*Label 9985*/ GIMT_Encode4(617488), // Rule ID 5840 //
     /*  617418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  617429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  617432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  617435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  617438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  617464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617486 */     GIR_RootConstrainSelectedInstOperands,
     /*  617487 */     // GIR_Coverage, 5840,
     /*  617487 */     GIR_EraseRootFromParent_Done,
     /*  617488 */   // Label 9985: @617488
     /*  617488 */   GIM_Try, /*On fail goto*//*Label 9986*/ GIMT_Encode4(617563), // Rule ID 5841 //
     /*  617493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  617504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  617507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  617510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  617513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617539 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  617539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617561 */     GIR_RootConstrainSelectedInstOperands,
     /*  617562 */     // GIR_Coverage, 5841,
     /*  617562 */     GIR_EraseRootFromParent_Done,
     /*  617563 */   // Label 9986: @617563
     /*  617563 */   GIM_Try, /*On fail goto*//*Label 9987*/ GIMT_Encode4(617638), // Rule ID 5844 //
     /*  617568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  617579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  617582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  617585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  617588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617614 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  617614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617636 */     GIR_RootConstrainSelectedInstOperands,
     /*  617637 */     // GIR_Coverage, 5844,
     /*  617637 */     GIR_EraseRootFromParent_Done,
     /*  617638 */   // Label 9987: @617638
     /*  617638 */   GIM_Try, /*On fail goto*//*Label 9988*/ GIMT_Encode4(617713), // Rule ID 5845 //
     /*  617643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  617654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  617657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  617660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  617663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617689 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  617689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617711 */     GIR_RootConstrainSelectedInstOperands,
     /*  617712 */     // GIR_Coverage, 5845,
     /*  617712 */     GIR_EraseRootFromParent_Done,
     /*  617713 */   // Label 9988: @617713
     /*  617713 */   GIM_Try, /*On fail goto*//*Label 9989*/ GIMT_Encode4(617788), // Rule ID 5848 //
     /*  617718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  617729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  617732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  617735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  617738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617764 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  617764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617786 */     GIR_RootConstrainSelectedInstOperands,
     /*  617787 */     // GIR_Coverage, 5848,
     /*  617787 */     GIR_EraseRootFromParent_Done,
     /*  617788 */   // Label 9989: @617788
     /*  617788 */   GIM_Try, /*On fail goto*//*Label 9990*/ GIMT_Encode4(617863), // Rule ID 5849 //
     /*  617793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  617804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  617807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  617810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  617813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617839 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  617839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617861 */     GIR_RootConstrainSelectedInstOperands,
     /*  617862 */     // GIR_Coverage, 5849,
     /*  617862 */     GIR_EraseRootFromParent_Done,
     /*  617863 */   // Label 9990: @617863
     /*  617863 */   GIM_Try, /*On fail goto*//*Label 9991*/ GIMT_Encode4(617938), // Rule ID 5852 //
     /*  617868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  617871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  617879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  617882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  617885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  617888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  617914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  617933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617936 */     GIR_RootConstrainSelectedInstOperands,
     /*  617937 */     // GIR_Coverage, 5852,
     /*  617937 */     GIR_EraseRootFromParent_Done,
     /*  617938 */   // Label 9991: @617938
     /*  617938 */   GIM_Try, /*On fail goto*//*Label 9992*/ GIMT_Encode4(618013), // Rule ID 5853 //
     /*  617943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  617946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  617954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  617957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  617960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  617963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617989 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  617989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618011 */     GIR_RootConstrainSelectedInstOperands,
     /*  618012 */     // GIR_Coverage, 5853,
     /*  618012 */     GIR_EraseRootFromParent_Done,
     /*  618013 */   // Label 9992: @618013
     /*  618013 */   GIM_Try, /*On fail goto*//*Label 9993*/ GIMT_Encode4(618088), // Rule ID 5856 //
     /*  618018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  618029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  618035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  618038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  618067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618086 */     GIR_RootConstrainSelectedInstOperands,
     /*  618087 */     // GIR_Coverage, 5856,
     /*  618087 */     GIR_EraseRootFromParent_Done,
     /*  618088 */   // Label 9993: @618088
     /*  618088 */   GIM_Try, /*On fail goto*//*Label 9994*/ GIMT_Encode4(618163), // Rule ID 5857 //
     /*  618093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  618104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  618110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  618113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618139 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  618142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618161 */     GIR_RootConstrainSelectedInstOperands,
     /*  618162 */     // GIR_Coverage, 5857,
     /*  618162 */     GIR_EraseRootFromParent_Done,
     /*  618163 */   // Label 9994: @618163
     /*  618163 */   GIM_Try, /*On fail goto*//*Label 9995*/ GIMT_Encode4(618238), // Rule ID 5860 //
     /*  618168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  618179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  618185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  618188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  618217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618236 */     GIR_RootConstrainSelectedInstOperands,
     /*  618237 */     // GIR_Coverage, 5860,
     /*  618237 */     GIR_EraseRootFromParent_Done,
     /*  618238 */   // Label 9995: @618238
     /*  618238 */   GIM_Try, /*On fail goto*//*Label 9996*/ GIMT_Encode4(618313), // Rule ID 5861 //
     /*  618243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  618254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  618260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  618263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618289 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  618292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618311 */     GIR_RootConstrainSelectedInstOperands,
     /*  618312 */     // GIR_Coverage, 5861,
     /*  618312 */     GIR_EraseRootFromParent_Done,
     /*  618313 */   // Label 9996: @618313
     /*  618313 */   GIM_Try, /*On fail goto*//*Label 9997*/ GIMT_Encode4(618388), // Rule ID 5864 //
     /*  618318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  618329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  618332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  618335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618364 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  618367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618386 */     GIR_RootConstrainSelectedInstOperands,
     /*  618387 */     // GIR_Coverage, 5864,
     /*  618387 */     GIR_EraseRootFromParent_Done,
     /*  618388 */   // Label 9997: @618388
     /*  618388 */   GIM_Try, /*On fail goto*//*Label 9998*/ GIMT_Encode4(618463), // Rule ID 5865 //
     /*  618393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  618404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  618407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  618410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618439 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  618439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  618442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618461 */     GIR_RootConstrainSelectedInstOperands,
     /*  618462 */     // GIR_Coverage, 5865,
     /*  618462 */     GIR_EraseRootFromParent_Done,
     /*  618463 */   // Label 9998: @618463
     /*  618463 */   GIM_Try, /*On fail goto*//*Label 9999*/ GIMT_Encode4(618538), // Rule ID 5868 //
     /*  618468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  618479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  618482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  618485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618514 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  618517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618536 */     GIR_RootConstrainSelectedInstOperands,
     /*  618537 */     // GIR_Coverage, 5868,
     /*  618537 */     GIR_EraseRootFromParent_Done,
     /*  618538 */   // Label 9999: @618538
     /*  618538 */   GIM_Try, /*On fail goto*//*Label 10000*/ GIMT_Encode4(618613), // Rule ID 5869 //
     /*  618543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  618554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  618557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  618560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618589 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  618589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  618592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618611 */     GIR_RootConstrainSelectedInstOperands,
     /*  618612 */     // GIR_Coverage, 5869,
     /*  618612 */     GIR_EraseRootFromParent_Done,
     /*  618613 */   // Label 10000: @618613
     /*  618613 */   GIM_Try, /*On fail goto*//*Label 10001*/ GIMT_Encode4(618688), // Rule ID 5872 //
     /*  618618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  618629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  618632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  618635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618664 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  618667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618686 */     GIR_RootConstrainSelectedInstOperands,
     /*  618687 */     // GIR_Coverage, 5872,
     /*  618687 */     GIR_EraseRootFromParent_Done,
     /*  618688 */   // Label 10001: @618688
     /*  618688 */   GIM_Try, /*On fail goto*//*Label 10002*/ GIMT_Encode4(618763), // Rule ID 5873 //
     /*  618693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  618704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  618707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  618710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618739 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  618739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  618742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618761 */     GIR_RootConstrainSelectedInstOperands,
     /*  618762 */     // GIR_Coverage, 5873,
     /*  618762 */     GIR_EraseRootFromParent_Done,
     /*  618763 */   // Label 10002: @618763
     /*  618763 */   GIM_Try, /*On fail goto*//*Label 10003*/ GIMT_Encode4(618838), // Rule ID 5876 //
     /*  618768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  618779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  618782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  618785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618814 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  618814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  618817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  618833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618836 */     GIR_RootConstrainSelectedInstOperands,
     /*  618837 */     // GIR_Coverage, 5876,
     /*  618837 */     GIR_EraseRootFromParent_Done,
     /*  618838 */   // Label 10003: @618838
     /*  618838 */   GIM_Try, /*On fail goto*//*Label 10004*/ GIMT_Encode4(618913), // Rule ID 5877 //
     /*  618843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  618854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  618857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  618860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618889 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  618889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  618892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  618908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618911 */     GIR_RootConstrainSelectedInstOperands,
     /*  618912 */     // GIR_Coverage, 5877,
     /*  618912 */     GIR_EraseRootFromParent_Done,
     /*  618913 */   // Label 10004: @618913
     /*  618913 */   GIM_Try, /*On fail goto*//*Label 10005*/ GIMT_Encode4(618988), // Rule ID 5880 //
     /*  618918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  618929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  618932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  618935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  618964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  618967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  618983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618986 */     GIR_RootConstrainSelectedInstOperands,
     /*  618987 */     // GIR_Coverage, 5880,
     /*  618987 */     GIR_EraseRootFromParent_Done,
     /*  618988 */   // Label 10005: @618988
     /*  618988 */   GIM_Try, /*On fail goto*//*Label 10006*/ GIMT_Encode4(619063), // Rule ID 5881 //
     /*  618993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  619004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  619007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  619010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619039 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619061 */     GIR_RootConstrainSelectedInstOperands,
     /*  619062 */     // GIR_Coverage, 5881,
     /*  619062 */     GIR_EraseRootFromParent_Done,
     /*  619063 */   // Label 10006: @619063
     /*  619063 */   GIM_Try, /*On fail goto*//*Label 10007*/ GIMT_Encode4(619138), // Rule ID 5884 //
     /*  619068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  619079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  619082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  619085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619114 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  619114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619136 */     GIR_RootConstrainSelectedInstOperands,
     /*  619137 */     // GIR_Coverage, 5884,
     /*  619137 */     GIR_EraseRootFromParent_Done,
     /*  619138 */   // Label 10007: @619138
     /*  619138 */   GIM_Try, /*On fail goto*//*Label 10008*/ GIMT_Encode4(619213), // Rule ID 5885 //
     /*  619143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  619154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  619157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  619160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619189 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  619189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619211 */     GIR_RootConstrainSelectedInstOperands,
     /*  619212 */     // GIR_Coverage, 5885,
     /*  619212 */     GIR_EraseRootFromParent_Done,
     /*  619213 */   // Label 10008: @619213
     /*  619213 */   GIM_Try, /*On fail goto*//*Label 10009*/ GIMT_Encode4(619288), // Rule ID 5888 //
     /*  619218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  619229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  619232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  619235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619264 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619286 */     GIR_RootConstrainSelectedInstOperands,
     /*  619287 */     // GIR_Coverage, 5888,
     /*  619287 */     GIR_EraseRootFromParent_Done,
     /*  619288 */   // Label 10009: @619288
     /*  619288 */   GIM_Try, /*On fail goto*//*Label 10010*/ GIMT_Encode4(619363), // Rule ID 5889 //
     /*  619293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  619304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  619307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  619310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619339 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619361 */     GIR_RootConstrainSelectedInstOperands,
     /*  619362 */     // GIR_Coverage, 5889,
     /*  619362 */     GIR_EraseRootFromParent_Done,
     /*  619363 */   // Label 10010: @619363
     /*  619363 */   GIM_Try, /*On fail goto*//*Label 10011*/ GIMT_Encode4(619438), // Rule ID 5892 //
     /*  619368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  619379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  619382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  619385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619414 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619436 */     GIR_RootConstrainSelectedInstOperands,
     /*  619437 */     // GIR_Coverage, 5892,
     /*  619437 */     GIR_EraseRootFromParent_Done,
     /*  619438 */   // Label 10011: @619438
     /*  619438 */   GIM_Try, /*On fail goto*//*Label 10012*/ GIMT_Encode4(619513), // Rule ID 5893 //
     /*  619443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  619454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  619457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  619460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619489 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619511 */     GIR_RootConstrainSelectedInstOperands,
     /*  619512 */     // GIR_Coverage, 5893,
     /*  619512 */     GIR_EraseRootFromParent_Done,
     /*  619513 */   // Label 10012: @619513
     /*  619513 */   GIM_Try, /*On fail goto*//*Label 10013*/ GIMT_Encode4(619588), // Rule ID 5896 //
     /*  619518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  619529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  619532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  619535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  619564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619586 */     GIR_RootConstrainSelectedInstOperands,
     /*  619587 */     // GIR_Coverage, 5896,
     /*  619587 */     GIR_EraseRootFromParent_Done,
     /*  619588 */   // Label 10013: @619588
     /*  619588 */   GIM_Try, /*On fail goto*//*Label 10014*/ GIMT_Encode4(619663), // Rule ID 5897 //
     /*  619593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  619604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  619607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  619610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619639 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  619639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619661 */     GIR_RootConstrainSelectedInstOperands,
     /*  619662 */     // GIR_Coverage, 5897,
     /*  619662 */     GIR_EraseRootFromParent_Done,
     /*  619663 */   // Label 10014: @619663
     /*  619663 */   GIM_Try, /*On fail goto*//*Label 10015*/ GIMT_Encode4(619738), // Rule ID 5900 //
     /*  619668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  619671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  619679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  619682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  619685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619714 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  619714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619736 */     GIR_RootConstrainSelectedInstOperands,
     /*  619737 */     // GIR_Coverage, 5900,
     /*  619737 */     GIR_EraseRootFromParent_Done,
     /*  619738 */   // Label 10015: @619738
     /*  619738 */   GIM_Try, /*On fail goto*//*Label 10016*/ GIMT_Encode4(619813), // Rule ID 5901 //
     /*  619743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  619746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  619754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  619757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  619760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619789 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  619789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619811 */     GIR_RootConstrainSelectedInstOperands,
     /*  619812 */     // GIR_Coverage, 5901,
     /*  619812 */     GIR_EraseRootFromParent_Done,
     /*  619813 */   // Label 10016: @619813
     /*  619813 */   GIM_Try, /*On fail goto*//*Label 10017*/ GIMT_Encode4(619888), // Rule ID 5904 //
     /*  619818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  619829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  619832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  619835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  619867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619886 */     GIR_RootConstrainSelectedInstOperands,
     /*  619887 */     // GIR_Coverage, 5904,
     /*  619887 */     GIR_EraseRootFromParent_Done,
     /*  619888 */   // Label 10017: @619888
     /*  619888 */   GIM_Try, /*On fail goto*//*Label 10018*/ GIMT_Encode4(619963), // Rule ID 5905 //
     /*  619893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  619904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  619907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  619910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619939 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  619942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619961 */     GIR_RootConstrainSelectedInstOperands,
     /*  619962 */     // GIR_Coverage, 5905,
     /*  619962 */     GIR_EraseRootFromParent_Done,
     /*  619963 */   // Label 10018: @619963
     /*  619963 */   GIM_Try, /*On fail goto*//*Label 10019*/ GIMT_Encode4(620038), // Rule ID 5908 //
     /*  619968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  619979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  619982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  619985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620014 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620036 */     GIR_RootConstrainSelectedInstOperands,
     /*  620037 */     // GIR_Coverage, 5908,
     /*  620037 */     GIR_EraseRootFromParent_Done,
     /*  620038 */   // Label 10019: @620038
     /*  620038 */   GIM_Try, /*On fail goto*//*Label 10020*/ GIMT_Encode4(620113), // Rule ID 5909 //
     /*  620043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  620054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  620057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  620060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620089 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620111 */     GIR_RootConstrainSelectedInstOperands,
     /*  620112 */     // GIR_Coverage, 5909,
     /*  620112 */     GIR_EraseRootFromParent_Done,
     /*  620113 */   // Label 10020: @620113
     /*  620113 */   GIM_Try, /*On fail goto*//*Label 10021*/ GIMT_Encode4(620188), // Rule ID 5912 //
     /*  620118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  620129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  620132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  620135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620164 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620186 */     GIR_RootConstrainSelectedInstOperands,
     /*  620187 */     // GIR_Coverage, 5912,
     /*  620187 */     GIR_EraseRootFromParent_Done,
     /*  620188 */   // Label 10021: @620188
     /*  620188 */   GIM_Try, /*On fail goto*//*Label 10022*/ GIMT_Encode4(620263), // Rule ID 5913 //
     /*  620193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  620204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  620207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  620210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620239 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620261 */     GIR_RootConstrainSelectedInstOperands,
     /*  620262 */     // GIR_Coverage, 5913,
     /*  620262 */     GIR_EraseRootFromParent_Done,
     /*  620263 */   // Label 10022: @620263
     /*  620263 */   GIM_Try, /*On fail goto*//*Label 10023*/ GIMT_Encode4(620338), // Rule ID 5916 //
     /*  620268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  620279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  620282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  620285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620336 */     GIR_RootConstrainSelectedInstOperands,
     /*  620337 */     // GIR_Coverage, 5916,
     /*  620337 */     GIR_EraseRootFromParent_Done,
     /*  620338 */   // Label 10023: @620338
     /*  620338 */   GIM_Try, /*On fail goto*//*Label 10024*/ GIMT_Encode4(620413), // Rule ID 5917 //
     /*  620343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  620354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  620357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  620360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620389 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620411 */     GIR_RootConstrainSelectedInstOperands,
     /*  620412 */     // GIR_Coverage, 5917,
     /*  620412 */     GIR_EraseRootFromParent_Done,
     /*  620413 */   // Label 10024: @620413
     /*  620413 */   GIM_Try, /*On fail goto*//*Label 10025*/ GIMT_Encode4(620488), // Rule ID 5920 //
     /*  620418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  620429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  620432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  620435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620464 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620486 */     GIR_RootConstrainSelectedInstOperands,
     /*  620487 */     // GIR_Coverage, 5920,
     /*  620487 */     GIR_EraseRootFromParent_Done,
     /*  620488 */   // Label 10025: @620488
     /*  620488 */   GIM_Try, /*On fail goto*//*Label 10026*/ GIMT_Encode4(620563), // Rule ID 5921 //
     /*  620493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  620504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  620507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  620510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620539 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620561 */     GIR_RootConstrainSelectedInstOperands,
     /*  620562 */     // GIR_Coverage, 5921,
     /*  620562 */     GIR_EraseRootFromParent_Done,
     /*  620563 */   // Label 10026: @620563
     /*  620563 */   GIM_Try, /*On fail goto*//*Label 10027*/ GIMT_Encode4(620638), // Rule ID 5924 //
     /*  620568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  620579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  620582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  620585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620636 */     GIR_RootConstrainSelectedInstOperands,
     /*  620637 */     // GIR_Coverage, 5924,
     /*  620637 */     GIR_EraseRootFromParent_Done,
     /*  620638 */   // Label 10027: @620638
     /*  620638 */   GIM_Try, /*On fail goto*//*Label 10028*/ GIMT_Encode4(620713), // Rule ID 5925 //
     /*  620643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  620654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  620657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  620660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620689 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620711 */     GIR_RootConstrainSelectedInstOperands,
     /*  620712 */     // GIR_Coverage, 5925,
     /*  620712 */     GIR_EraseRootFromParent_Done,
     /*  620713 */   // Label 10028: @620713
     /*  620713 */   GIM_Try, /*On fail goto*//*Label 10029*/ GIMT_Encode4(620788), // Rule ID 5928 //
     /*  620718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  620729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  620732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  620735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  620764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620786 */     GIR_RootConstrainSelectedInstOperands,
     /*  620787 */     // GIR_Coverage, 5928,
     /*  620787 */     GIR_EraseRootFromParent_Done,
     /*  620788 */   // Label 10029: @620788
     /*  620788 */   GIM_Try, /*On fail goto*//*Label 10030*/ GIMT_Encode4(620863), // Rule ID 5929 //
     /*  620793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  620804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  620807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  620810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  620839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620861 */     GIR_RootConstrainSelectedInstOperands,
     /*  620862 */     // GIR_Coverage, 5929,
     /*  620862 */     GIR_EraseRootFromParent_Done,
     /*  620863 */   // Label 10030: @620863
     /*  620863 */   GIM_Try, /*On fail goto*//*Label 10031*/ GIMT_Encode4(620938), // Rule ID 5932 //
     /*  620868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  620879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  620882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  620885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  620914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620936 */     GIR_RootConstrainSelectedInstOperands,
     /*  620937 */     // GIR_Coverage, 5932,
     /*  620937 */     GIR_EraseRootFromParent_Done,
     /*  620938 */   // Label 10031: @620938
     /*  620938 */   GIM_Try, /*On fail goto*//*Label 10032*/ GIMT_Encode4(621013), // Rule ID 5933 //
     /*  620943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  620954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  620957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  620960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620989 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  620989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621011 */     GIR_RootConstrainSelectedInstOperands,
     /*  621012 */     // GIR_Coverage, 5933,
     /*  621012 */     GIR_EraseRootFromParent_Done,
     /*  621013 */   // Label 10032: @621013
     /*  621013 */   GIM_Try, /*On fail goto*//*Label 10033*/ GIMT_Encode4(621088), // Rule ID 5936 //
     /*  621018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  621029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  621032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  621035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621064 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621086 */     GIR_RootConstrainSelectedInstOperands,
     /*  621087 */     // GIR_Coverage, 5936,
     /*  621087 */     GIR_EraseRootFromParent_Done,
     /*  621088 */   // Label 10033: @621088
     /*  621088 */   GIM_Try, /*On fail goto*//*Label 10034*/ GIMT_Encode4(621163), // Rule ID 5937 //
     /*  621093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  621104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  621107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  621110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621139 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621161 */     GIR_RootConstrainSelectedInstOperands,
     /*  621162 */     // GIR_Coverage, 5937,
     /*  621162 */     GIR_EraseRootFromParent_Done,
     /*  621163 */   // Label 10034: @621163
     /*  621163 */   GIM_Try, /*On fail goto*//*Label 10035*/ GIMT_Encode4(621238), // Rule ID 5940 //
     /*  621168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  621217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621236 */     GIR_RootConstrainSelectedInstOperands,
     /*  621237 */     // GIR_Coverage, 5940,
     /*  621237 */     GIR_EraseRootFromParent_Done,
     /*  621238 */   // Label 10035: @621238
     /*  621238 */   GIM_Try, /*On fail goto*//*Label 10036*/ GIMT_Encode4(621313), // Rule ID 5941 //
     /*  621243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  621292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621311 */     GIR_RootConstrainSelectedInstOperands,
     /*  621312 */     // GIR_Coverage, 5941,
     /*  621312 */     GIR_EraseRootFromParent_Done,
     /*  621313 */   // Label 10036: @621313
     /*  621313 */   GIM_Try, /*On fail goto*//*Label 10037*/ GIMT_Encode4(621388), // Rule ID 5944 //
     /*  621318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  621367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621386 */     GIR_RootConstrainSelectedInstOperands,
     /*  621387 */     // GIR_Coverage, 5944,
     /*  621387 */     GIR_EraseRootFromParent_Done,
     /*  621388 */   // Label 10037: @621388
     /*  621388 */   GIM_Try, /*On fail goto*//*Label 10038*/ GIMT_Encode4(621463), // Rule ID 5945 //
     /*  621393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621439 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  621442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621461 */     GIR_RootConstrainSelectedInstOperands,
     /*  621462 */     // GIR_Coverage, 5945,
     /*  621462 */     GIR_EraseRootFromParent_Done,
     /*  621463 */   // Label 10038: @621463
     /*  621463 */   GIM_Try, /*On fail goto*//*Label 10039*/ GIMT_Encode4(621538), // Rule ID 5948 //
     /*  621468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  621479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  621482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  621485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621514 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621536 */     GIR_RootConstrainSelectedInstOperands,
     /*  621537 */     // GIR_Coverage, 5948,
     /*  621537 */     GIR_EraseRootFromParent_Done,
     /*  621538 */   // Label 10039: @621538
     /*  621538 */   GIM_Try, /*On fail goto*//*Label 10040*/ GIMT_Encode4(621613), // Rule ID 5949 //
     /*  621543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  621554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  621557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  621560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621589 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621611 */     GIR_RootConstrainSelectedInstOperands,
     /*  621612 */     // GIR_Coverage, 5949,
     /*  621612 */     GIR_EraseRootFromParent_Done,
     /*  621613 */   // Label 10040: @621613
     /*  621613 */   GIM_Try, /*On fail goto*//*Label 10041*/ GIMT_Encode4(621688), // Rule ID 6040 //
     /*  621618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  621629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  621632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  621635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  621638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621664 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  621664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  621667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621686 */     GIR_RootConstrainSelectedInstOperands,
     /*  621687 */     // GIR_Coverage, 6040,
     /*  621687 */     GIR_EraseRootFromParent_Done,
     /*  621688 */   // Label 10041: @621688
     /*  621688 */   GIM_Try, /*On fail goto*//*Label 10042*/ GIMT_Encode4(621763), // Rule ID 6041 //
     /*  621693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  621704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  621707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  621710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  621713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621739 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  621739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  621742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621761 */     GIR_RootConstrainSelectedInstOperands,
     /*  621762 */     // GIR_Coverage, 6041,
     /*  621762 */     GIR_EraseRootFromParent_Done,
     /*  621763 */   // Label 10042: @621763
     /*  621763 */   GIM_Try, /*On fail goto*//*Label 10043*/ GIMT_Encode4(621838), // Rule ID 6044 //
     /*  621768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  621779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  621782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  621785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  621788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621814 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  621814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  621817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621836 */     GIR_RootConstrainSelectedInstOperands,
     /*  621837 */     // GIR_Coverage, 6044,
     /*  621837 */     GIR_EraseRootFromParent_Done,
     /*  621838 */   // Label 10043: @621838
     /*  621838 */   GIM_Try, /*On fail goto*//*Label 10044*/ GIMT_Encode4(621913), // Rule ID 6045 //
     /*  621843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  621854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  621857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  621860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  621863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621889 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  621889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  621892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621911 */     GIR_RootConstrainSelectedInstOperands,
     /*  621912 */     // GIR_Coverage, 6045,
     /*  621912 */     GIR_EraseRootFromParent_Done,
     /*  621913 */   // Label 10044: @621913
     /*  621913 */   GIM_Try, /*On fail goto*//*Label 10045*/ GIMT_Encode4(621988), // Rule ID 6048 //
     /*  621918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  621929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  621932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  621935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  621938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621964 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  621964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  621967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621986 */     GIR_RootConstrainSelectedInstOperands,
     /*  621987 */     // GIR_Coverage, 6048,
     /*  621987 */     GIR_EraseRootFromParent_Done,
     /*  621988 */   // Label 10045: @621988
     /*  621988 */   GIM_Try, /*On fail goto*//*Label 10046*/ GIMT_Encode4(622063), // Rule ID 6049 //
     /*  621993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  622004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  622007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  622010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  622013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622039 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622061 */     GIR_RootConstrainSelectedInstOperands,
     /*  622062 */     // GIR_Coverage, 6049,
     /*  622062 */     GIR_EraseRootFromParent_Done,
     /*  622063 */   // Label 10046: @622063
     /*  622063 */   GIM_Try, /*On fail goto*//*Label 10047*/ GIMT_Encode4(622138), // Rule ID 6052 //
     /*  622068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  622088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  622117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622136 */     GIR_RootConstrainSelectedInstOperands,
     /*  622137 */     // GIR_Coverage, 6052,
     /*  622137 */     GIR_EraseRootFromParent_Done,
     /*  622138 */   // Label 10047: @622138
     /*  622138 */   GIM_Try, /*On fail goto*//*Label 10048*/ GIMT_Encode4(622213), // Rule ID 6053 //
     /*  622143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  622163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622189 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  622192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622211 */     GIR_RootConstrainSelectedInstOperands,
     /*  622212 */     // GIR_Coverage, 6053,
     /*  622212 */     GIR_EraseRootFromParent_Done,
     /*  622213 */   // Label 10048: @622213
     /*  622213 */   GIM_Try, /*On fail goto*//*Label 10049*/ GIMT_Encode4(622288), // Rule ID 6056 //
     /*  622218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  622238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622286 */     GIR_RootConstrainSelectedInstOperands,
     /*  622287 */     // GIR_Coverage, 6056,
     /*  622287 */     GIR_EraseRootFromParent_Done,
     /*  622288 */   // Label 10049: @622288
     /*  622288 */   GIM_Try, /*On fail goto*//*Label 10050*/ GIMT_Encode4(622363), // Rule ID 6057 //
     /*  622293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  622313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622339 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622361 */     GIR_RootConstrainSelectedInstOperands,
     /*  622362 */     // GIR_Coverage, 6057,
     /*  622362 */     GIR_EraseRootFromParent_Done,
     /*  622363 */   // Label 10050: @622363
     /*  622363 */   GIM_Try, /*On fail goto*//*Label 10051*/ GIMT_Encode4(622438), // Rule ID 6060 //
     /*  622368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  622388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622414 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  622414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622436 */     GIR_RootConstrainSelectedInstOperands,
     /*  622437 */     // GIR_Coverage, 6060,
     /*  622437 */     GIR_EraseRootFromParent_Done,
     /*  622438 */   // Label 10051: @622438
     /*  622438 */   GIM_Try, /*On fail goto*//*Label 10052*/ GIMT_Encode4(622513), // Rule ID 6061 //
     /*  622443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  622463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622489 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  622489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622511 */     GIR_RootConstrainSelectedInstOperands,
     /*  622512 */     // GIR_Coverage, 6061,
     /*  622512 */     GIR_EraseRootFromParent_Done,
     /*  622513 */   // Label 10052: @622513
     /*  622513 */   GIM_Try, /*On fail goto*//*Label 10053*/ GIMT_Encode4(622588), // Rule ID 6064 //
     /*  622518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  622529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  622532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  622535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  622538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622564 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622586 */     GIR_RootConstrainSelectedInstOperands,
     /*  622587 */     // GIR_Coverage, 6064,
     /*  622587 */     GIR_EraseRootFromParent_Done,
     /*  622588 */   // Label 10053: @622588
     /*  622588 */   GIM_Try, /*On fail goto*//*Label 10054*/ GIMT_Encode4(622663), // Rule ID 6065 //
     /*  622593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  622604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  622607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  622610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  622613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622639 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622661 */     GIR_RootConstrainSelectedInstOperands,
     /*  622662 */     // GIR_Coverage, 6065,
     /*  622662 */     GIR_EraseRootFromParent_Done,
     /*  622663 */   // Label 10054: @622663
     /*  622663 */   GIM_Try, /*On fail goto*//*Label 10055*/ GIMT_Encode4(622738), // Rule ID 6068 //
     /*  622668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  622679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  622682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  622685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  622688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622736 */     GIR_RootConstrainSelectedInstOperands,
     /*  622737 */     // GIR_Coverage, 6068,
     /*  622737 */     GIR_EraseRootFromParent_Done,
     /*  622738 */   // Label 10055: @622738
     /*  622738 */   GIM_Try, /*On fail goto*//*Label 10056*/ GIMT_Encode4(622813), // Rule ID 6069 //
     /*  622743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  622754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  622757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  622760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  622763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622789 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622811 */     GIR_RootConstrainSelectedInstOperands,
     /*  622812 */     // GIR_Coverage, 6069,
     /*  622812 */     GIR_EraseRootFromParent_Done,
     /*  622813 */   // Label 10056: @622813
     /*  622813 */   GIM_Try, /*On fail goto*//*Label 10057*/ GIMT_Encode4(622888), // Rule ID 6072 //
     /*  622818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  622829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  622832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  622835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  622838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622864 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  622864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622886 */     GIR_RootConstrainSelectedInstOperands,
     /*  622887 */     // GIR_Coverage, 6072,
     /*  622887 */     GIR_EraseRootFromParent_Done,
     /*  622888 */   // Label 10057: @622888
     /*  622888 */   GIM_Try, /*On fail goto*//*Label 10058*/ GIMT_Encode4(622963), // Rule ID 6073 //
     /*  622893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  622904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  622907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  622910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  622913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622939 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  622939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622961 */     GIR_RootConstrainSelectedInstOperands,
     /*  622962 */     // GIR_Coverage, 6073,
     /*  622962 */     GIR_EraseRootFromParent_Done,
     /*  622963 */   // Label 10058: @622963
     /*  622963 */   GIM_Try, /*On fail goto*//*Label 10059*/ GIMT_Encode4(623038), // Rule ID 6076 //
     /*  622968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  622971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  622979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  622982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  622985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  622988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  623014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623036 */     GIR_RootConstrainSelectedInstOperands,
     /*  623037 */     // GIR_Coverage, 6076,
     /*  623037 */     GIR_EraseRootFromParent_Done,
     /*  623038 */   // Label 10059: @623038
     /*  623038 */   GIM_Try, /*On fail goto*//*Label 10060*/ GIMT_Encode4(623113), // Rule ID 6077 //
     /*  623043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  623046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  623054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  623057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  623060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  623063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623089 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  623089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623111 */     GIR_RootConstrainSelectedInstOperands,
     /*  623112 */     // GIR_Coverage, 6077,
     /*  623112 */     GIR_EraseRootFromParent_Done,
     /*  623113 */   // Label 10060: @623113
     /*  623113 */   GIM_Try, /*On fail goto*//*Label 10061*/ GIMT_Encode4(623188), // Rule ID 6080 //
     /*  623118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  623138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623186 */     GIR_RootConstrainSelectedInstOperands,
     /*  623187 */     // GIR_Coverage, 6080,
     /*  623187 */     GIR_EraseRootFromParent_Done,
     /*  623188 */   // Label 10061: @623188
     /*  623188 */   GIM_Try, /*On fail goto*//*Label 10062*/ GIMT_Encode4(623263), // Rule ID 6081 //
     /*  623193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  623213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623239 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623261 */     GIR_RootConstrainSelectedInstOperands,
     /*  623262 */     // GIR_Coverage, 6081,
     /*  623262 */     GIR_EraseRootFromParent_Done,
     /*  623263 */   // Label 10062: @623263
     /*  623263 */   GIM_Try, /*On fail goto*//*Label 10063*/ GIMT_Encode4(623338), // Rule ID 6084 //
     /*  623268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  623288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623314 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623336 */     GIR_RootConstrainSelectedInstOperands,
     /*  623337 */     // GIR_Coverage, 6084,
     /*  623337 */     GIR_EraseRootFromParent_Done,
     /*  623338 */   // Label 10063: @623338
     /*  623338 */   GIM_Try, /*On fail goto*//*Label 10064*/ GIMT_Encode4(623413), // Rule ID 6085 //
     /*  623343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  623363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623389 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623411 */     GIR_RootConstrainSelectedInstOperands,
     /*  623412 */     // GIR_Coverage, 6085,
     /*  623412 */     GIR_EraseRootFromParent_Done,
     /*  623413 */   // Label 10064: @623413
     /*  623413 */   GIM_Try, /*On fail goto*//*Label 10065*/ GIMT_Encode4(623488), // Rule ID 6088 //
     /*  623418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  623429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  623432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  623435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  623438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623464 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623486 */     GIR_RootConstrainSelectedInstOperands,
     /*  623487 */     // GIR_Coverage, 6088,
     /*  623487 */     GIR_EraseRootFromParent_Done,
     /*  623488 */   // Label 10065: @623488
     /*  623488 */   GIM_Try, /*On fail goto*//*Label 10066*/ GIMT_Encode4(623563), // Rule ID 6089 //
     /*  623493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  623504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  623507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  623510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  623513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623539 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623561 */     GIR_RootConstrainSelectedInstOperands,
     /*  623562 */     // GIR_Coverage, 6089,
     /*  623562 */     GIR_EraseRootFromParent_Done,
     /*  623563 */   // Label 10066: @623563
     /*  623563 */   GIM_Try, /*On fail goto*//*Label 10067*/ GIMT_Encode4(623638), // Rule ID 6092 //
     /*  623568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  623579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  623582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  623585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  623588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623614 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623636 */     GIR_RootConstrainSelectedInstOperands,
     /*  623637 */     // GIR_Coverage, 6092,
     /*  623637 */     GIR_EraseRootFromParent_Done,
     /*  623638 */   // Label 10067: @623638
     /*  623638 */   GIM_Try, /*On fail goto*//*Label 10068*/ GIMT_Encode4(623713), // Rule ID 6093 //
     /*  623643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  623654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  623657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  623660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  623663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623689 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623711 */     GIR_RootConstrainSelectedInstOperands,
     /*  623712 */     // GIR_Coverage, 6093,
     /*  623712 */     GIR_EraseRootFromParent_Done,
     /*  623713 */   // Label 10068: @623713
     /*  623713 */   GIM_Try, /*On fail goto*//*Label 10069*/ GIMT_Encode4(623788), // Rule ID 6096 //
     /*  623718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  623729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  623732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  623735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  623738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623764 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623786 */     GIR_RootConstrainSelectedInstOperands,
     /*  623787 */     // GIR_Coverage, 6096,
     /*  623787 */     GIR_EraseRootFromParent_Done,
     /*  623788 */   // Label 10069: @623788
     /*  623788 */   GIM_Try, /*On fail goto*//*Label 10070*/ GIMT_Encode4(623863), // Rule ID 6097 //
     /*  623793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  623804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  623807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  623810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  623813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623839 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623861 */     GIR_RootConstrainSelectedInstOperands,
     /*  623862 */     // GIR_Coverage, 6097,
     /*  623862 */     GIR_EraseRootFromParent_Done,
     /*  623863 */   // Label 10070: @623863
     /*  623863 */   GIM_Try, /*On fail goto*//*Label 10071*/ GIMT_Encode4(623938), // Rule ID 6100 //
     /*  623868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  623879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  623882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  623885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  623888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623914 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623936 */     GIR_RootConstrainSelectedInstOperands,
     /*  623937 */     // GIR_Coverage, 6100,
     /*  623937 */     GIR_EraseRootFromParent_Done,
     /*  623938 */   // Label 10071: @623938
     /*  623938 */   GIM_Try, /*On fail goto*//*Label 10072*/ GIMT_Encode4(624013), // Rule ID 6101 //
     /*  623943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  623954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  623957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  623960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  623963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623989 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624011 */     GIR_RootConstrainSelectedInstOperands,
     /*  624012 */     // GIR_Coverage, 6101,
     /*  624012 */     GIR_EraseRootFromParent_Done,
     /*  624013 */   // Label 10072: @624013
     /*  624013 */   GIM_Try, /*On fail goto*//*Label 10073*/ GIMT_Encode4(624088), // Rule ID 6104 //
     /*  624018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  624038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624086 */     GIR_RootConstrainSelectedInstOperands,
     /*  624087 */     // GIR_Coverage, 6104,
     /*  624087 */     GIR_EraseRootFromParent_Done,
     /*  624088 */   // Label 10073: @624088
     /*  624088 */   GIM_Try, /*On fail goto*//*Label 10074*/ GIMT_Encode4(624163), // Rule ID 6105 //
     /*  624093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  624113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624161 */     GIR_RootConstrainSelectedInstOperands,
     /*  624162 */     // GIR_Coverage, 6105,
     /*  624162 */     GIR_EraseRootFromParent_Done,
     /*  624163 */   // Label 10074: @624163
     /*  624163 */   GIM_Try, /*On fail goto*//*Label 10075*/ GIMT_Encode4(624238), // Rule ID 6108 //
     /*  624168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  624188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624236 */     GIR_RootConstrainSelectedInstOperands,
     /*  624237 */     // GIR_Coverage, 6108,
     /*  624237 */     GIR_EraseRootFromParent_Done,
     /*  624238 */   // Label 10075: @624238
     /*  624238 */   GIM_Try, /*On fail goto*//*Label 10076*/ GIMT_Encode4(624313), // Rule ID 6109 //
     /*  624243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  624263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624289 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624311 */     GIR_RootConstrainSelectedInstOperands,
     /*  624312 */     // GIR_Coverage, 6109,
     /*  624312 */     GIR_EraseRootFromParent_Done,
     /*  624313 */   // Label 10076: @624313
     /*  624313 */   GIM_Try, /*On fail goto*//*Label 10077*/ GIMT_Encode4(624388), // Rule ID 6112 //
     /*  624318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  624338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624386 */     GIR_RootConstrainSelectedInstOperands,
     /*  624387 */     // GIR_Coverage, 6112,
     /*  624387 */     GIR_EraseRootFromParent_Done,
     /*  624388 */   // Label 10077: @624388
     /*  624388 */   GIM_Try, /*On fail goto*//*Label 10078*/ GIMT_Encode4(624463), // Rule ID 6113 //
     /*  624393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  624413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624439 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624461 */     GIR_RootConstrainSelectedInstOperands,
     /*  624462 */     // GIR_Coverage, 6113,
     /*  624462 */     GIR_EraseRootFromParent_Done,
     /*  624463 */   // Label 10078: @624463
     /*  624463 */   GIM_Try, /*On fail goto*//*Label 10079*/ GIMT_Encode4(624538), // Rule ID 6116 //
     /*  624468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  624471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  624479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  624482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  624485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  624488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624514 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  624514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624536 */     GIR_RootConstrainSelectedInstOperands,
     /*  624537 */     // GIR_Coverage, 6116,
     /*  624537 */     GIR_EraseRootFromParent_Done,
     /*  624538 */   // Label 10079: @624538
     /*  624538 */   GIM_Try, /*On fail goto*//*Label 10080*/ GIMT_Encode4(624613), // Rule ID 6117 //
     /*  624543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  624546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  624554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  624557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  624560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  624563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624589 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  624589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624611 */     GIR_RootConstrainSelectedInstOperands,
     /*  624612 */     // GIR_Coverage, 6117,
     /*  624612 */     GIR_EraseRootFromParent_Done,
     /*  624613 */   // Label 10080: @624613
     /*  624613 */   GIM_Try, /*On fail goto*//*Label 10081*/ GIMT_Encode4(624688), // Rule ID 6120 //
     /*  624618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  624621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  624629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  624632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  624635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  624638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624664 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  624664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624686 */     GIR_RootConstrainSelectedInstOperands,
     /*  624687 */     // GIR_Coverage, 6120,
     /*  624687 */     GIR_EraseRootFromParent_Done,
     /*  624688 */   // Label 10081: @624688
     /*  624688 */   GIM_Try, /*On fail goto*//*Label 10082*/ GIMT_Encode4(624763), // Rule ID 6121 //
     /*  624693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  624696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  624704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  624707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  624710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  624713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624739 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  624739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624761 */     GIR_RootConstrainSelectedInstOperands,
     /*  624762 */     // GIR_Coverage, 6121,
     /*  624762 */     GIR_EraseRootFromParent_Done,
     /*  624763 */   // Label 10082: @624763
     /*  624763 */   GIM_Try, /*On fail goto*//*Label 10083*/ GIMT_Encode4(624838), // Rule ID 6124 //
     /*  624768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  624771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  624779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  624782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  624785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  624788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624814 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  624814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624836 */     GIR_RootConstrainSelectedInstOperands,
     /*  624837 */     // GIR_Coverage, 6124,
     /*  624837 */     GIR_EraseRootFromParent_Done,
     /*  624838 */   // Label 10083: @624838
     /*  624838 */   GIM_Try, /*On fail goto*//*Label 10084*/ GIMT_Encode4(624913), // Rule ID 6125 //
     /*  624843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  624846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  624854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  624857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  624860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  624863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624889 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  624889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624911 */     GIR_RootConstrainSelectedInstOperands,
     /*  624912 */     // GIR_Coverage, 6125,
     /*  624912 */     GIR_EraseRootFromParent_Done,
     /*  624913 */   // Label 10084: @624913
     /*  624913 */   GIM_Try, /*On fail goto*//*Label 10085*/ GIMT_Encode4(624988), // Rule ID 6128 //
     /*  624918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  624929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  624932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  624935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624964 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  624964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  624967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624986 */     GIR_RootConstrainSelectedInstOperands,
     /*  624987 */     // GIR_Coverage, 6128,
     /*  624987 */     GIR_EraseRootFromParent_Done,
     /*  624988 */   // Label 10085: @624988
     /*  624988 */   GIM_Try, /*On fail goto*//*Label 10086*/ GIMT_Encode4(625063), // Rule ID 6129 //
     /*  624993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  625004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  625007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  625010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625039 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  625042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625061 */     GIR_RootConstrainSelectedInstOperands,
     /*  625062 */     // GIR_Coverage, 6129,
     /*  625062 */     GIR_EraseRootFromParent_Done,
     /*  625063 */   // Label 10086: @625063
     /*  625063 */   GIM_Try, /*On fail goto*//*Label 10087*/ GIMT_Encode4(625138), // Rule ID 6132 //
     /*  625068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625114 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625136 */     GIR_RootConstrainSelectedInstOperands,
     /*  625137 */     // GIR_Coverage, 6132,
     /*  625137 */     GIR_EraseRootFromParent_Done,
     /*  625138 */   // Label 10087: @625138
     /*  625138 */   GIM_Try, /*On fail goto*//*Label 10088*/ GIMT_Encode4(625213), // Rule ID 6133 //
     /*  625143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625189 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625211 */     GIR_RootConstrainSelectedInstOperands,
     /*  625212 */     // GIR_Coverage, 6133,
     /*  625212 */     GIR_EraseRootFromParent_Done,
     /*  625213 */   // Label 10088: @625213
     /*  625213 */   GIM_Try, /*On fail goto*//*Label 10089*/ GIMT_Encode4(625288), // Rule ID 6136 //
     /*  625218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625264 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625286 */     GIR_RootConstrainSelectedInstOperands,
     /*  625287 */     // GIR_Coverage, 6136,
     /*  625287 */     GIR_EraseRootFromParent_Done,
     /*  625288 */   // Label 10089: @625288
     /*  625288 */   GIM_Try, /*On fail goto*//*Label 10090*/ GIMT_Encode4(625363), // Rule ID 6137 //
     /*  625293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625339 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625361 */     GIR_RootConstrainSelectedInstOperands,
     /*  625362 */     // GIR_Coverage, 6137,
     /*  625362 */     GIR_EraseRootFromParent_Done,
     /*  625363 */   // Label 10090: @625363
     /*  625363 */   GIM_Try, /*On fail goto*//*Label 10091*/ GIMT_Encode4(625438), // Rule ID 6140 //
     /*  625368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625414 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  625414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625436 */     GIR_RootConstrainSelectedInstOperands,
     /*  625437 */     // GIR_Coverage, 6140,
     /*  625437 */     GIR_EraseRootFromParent_Done,
     /*  625438 */   // Label 10091: @625438
     /*  625438 */   GIM_Try, /*On fail goto*//*Label 10092*/ GIMT_Encode4(625513), // Rule ID 6141 //
     /*  625443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625489 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  625489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625511 */     GIR_RootConstrainSelectedInstOperands,
     /*  625512 */     // GIR_Coverage, 6141,
     /*  625512 */     GIR_EraseRootFromParent_Done,
     /*  625513 */   // Label 10092: @625513
     /*  625513 */   GIM_Try, /*On fail goto*//*Label 10093*/ GIMT_Encode4(625588), // Rule ID 6144 //
     /*  625518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  625529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  625532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  625535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  625564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625586 */     GIR_RootConstrainSelectedInstOperands,
     /*  625587 */     // GIR_Coverage, 6144,
     /*  625587 */     GIR_EraseRootFromParent_Done,
     /*  625588 */   // Label 10093: @625588
     /*  625588 */   GIM_Try, /*On fail goto*//*Label 10094*/ GIMT_Encode4(625663), // Rule ID 6145 //
     /*  625593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  625604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  625607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  625610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625639 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  625639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625661 */     GIR_RootConstrainSelectedInstOperands,
     /*  625662 */     // GIR_Coverage, 6145,
     /*  625662 */     GIR_EraseRootFromParent_Done,
     /*  625663 */   // Label 10094: @625663
     /*  625663 */   GIM_Try, /*On fail goto*//*Label 10095*/ GIMT_Encode4(625738), // Rule ID 6148 //
     /*  625668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  625679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  625682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  625685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  625714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  625733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625736 */     GIR_RootConstrainSelectedInstOperands,
     /*  625737 */     // GIR_Coverage, 6148,
     /*  625737 */     GIR_EraseRootFromParent_Done,
     /*  625738 */   // Label 10095: @625738
     /*  625738 */   GIM_Try, /*On fail goto*//*Label 10096*/ GIMT_Encode4(625813), // Rule ID 6149 //
     /*  625743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  625754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  625757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  625760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625789 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  625789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  625808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625811 */     GIR_RootConstrainSelectedInstOperands,
     /*  625812 */     // GIR_Coverage, 6149,
     /*  625812 */     GIR_EraseRootFromParent_Done,
     /*  625813 */   // Label 10096: @625813
     /*  625813 */   GIM_Try, /*On fail goto*//*Label 10097*/ GIMT_Encode4(625888), // Rule ID 6152 //
     /*  625818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  625829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  625832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  625835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625864 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  625867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625886 */     GIR_RootConstrainSelectedInstOperands,
     /*  625887 */     // GIR_Coverage, 6152,
     /*  625887 */     GIR_EraseRootFromParent_Done,
     /*  625888 */   // Label 10097: @625888
     /*  625888 */   GIM_Try, /*On fail goto*//*Label 10098*/ GIMT_Encode4(625963), // Rule ID 6153 //
     /*  625893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  625904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  625907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  625910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625939 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  625942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625961 */     GIR_RootConstrainSelectedInstOperands,
     /*  625962 */     // GIR_Coverage, 6153,
     /*  625962 */     GIR_EraseRootFromParent_Done,
     /*  625963 */   // Label 10098: @625963
     /*  625963 */   GIM_Try, /*On fail goto*//*Label 10099*/ GIMT_Encode4(626038), // Rule ID 6156 //
     /*  625968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  625979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  625982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  625985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626014 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626036 */     GIR_RootConstrainSelectedInstOperands,
     /*  626037 */     // GIR_Coverage, 6156,
     /*  626037 */     GIR_EraseRootFromParent_Done,
     /*  626038 */   // Label 10099: @626038
     /*  626038 */   GIM_Try, /*On fail goto*//*Label 10100*/ GIMT_Encode4(626113), // Rule ID 6157 //
     /*  626043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  626054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  626057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  626060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626089 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626111 */     GIR_RootConstrainSelectedInstOperands,
     /*  626112 */     // GIR_Coverage, 6157,
     /*  626112 */     GIR_EraseRootFromParent_Done,
     /*  626113 */   // Label 10100: @626113
     /*  626113 */   GIM_Try, /*On fail goto*//*Label 10101*/ GIMT_Encode4(626188), // Rule ID 6160 //
     /*  626118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626186 */     GIR_RootConstrainSelectedInstOperands,
     /*  626187 */     // GIR_Coverage, 6160,
     /*  626187 */     GIR_EraseRootFromParent_Done,
     /*  626188 */   // Label 10101: @626188
     /*  626188 */   GIM_Try, /*On fail goto*//*Label 10102*/ GIMT_Encode4(626263), // Rule ID 6161 //
     /*  626193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626239 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  626239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626261 */     GIR_RootConstrainSelectedInstOperands,
     /*  626262 */     // GIR_Coverage, 6161,
     /*  626262 */     GIR_EraseRootFromParent_Done,
     /*  626263 */   // Label 10102: @626263
     /*  626263 */   GIM_Try, /*On fail goto*//*Label 10103*/ GIMT_Encode4(626338), // Rule ID 6164 //
     /*  626268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  626271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626314 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  626314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626336 */     GIR_RootConstrainSelectedInstOperands,
     /*  626337 */     // GIR_Coverage, 6164,
     /*  626337 */     GIR_EraseRootFromParent_Done,
     /*  626338 */   // Label 10103: @626338
     /*  626338 */   GIM_Try, /*On fail goto*//*Label 10104*/ GIMT_Encode4(626413), // Rule ID 6165 //
     /*  626343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  626346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626389 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  626389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626411 */     GIR_RootConstrainSelectedInstOperands,
     /*  626412 */     // GIR_Coverage, 6165,
     /*  626412 */     GIR_EraseRootFromParent_Done,
     /*  626413 */   // Label 10104: @626413
     /*  626413 */   GIM_Try, /*On fail goto*//*Label 10105*/ GIMT_Encode4(626488), // Rule ID 6168 //
     /*  626418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  626429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  626432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  626435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626464 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626486 */     GIR_RootConstrainSelectedInstOperands,
     /*  626487 */     // GIR_Coverage, 6168,
     /*  626487 */     GIR_EraseRootFromParent_Done,
     /*  626488 */   // Label 10105: @626488
     /*  626488 */   GIM_Try, /*On fail goto*//*Label 10106*/ GIMT_Encode4(626563), // Rule ID 6169 //
     /*  626493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  626504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  626507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  626510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626539 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626561 */     GIR_RootConstrainSelectedInstOperands,
     /*  626562 */     // GIR_Coverage, 6169,
     /*  626562 */     GIR_EraseRootFromParent_Done,
     /*  626563 */   // Label 10106: @626563
     /*  626563 */   GIM_Try, /*On fail goto*//*Label 10107*/ GIMT_Encode4(626638), // Rule ID 6172 //
     /*  626568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  626579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  626582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  626585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626614 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  626617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626636 */     GIR_RootConstrainSelectedInstOperands,
     /*  626637 */     // GIR_Coverage, 6172,
     /*  626637 */     GIR_EraseRootFromParent_Done,
     /*  626638 */   // Label 10107: @626638
     /*  626638 */   GIM_Try, /*On fail goto*//*Label 10108*/ GIMT_Encode4(626713), // Rule ID 6173 //
     /*  626643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  626654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  626657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  626660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626689 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  626692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626711 */     GIR_RootConstrainSelectedInstOperands,
     /*  626712 */     // GIR_Coverage, 6173,
     /*  626712 */     GIR_EraseRootFromParent_Done,
     /*  626713 */   // Label 10108: @626713
     /*  626713 */   GIM_Try, /*On fail goto*//*Label 10109*/ GIMT_Encode4(626788), // Rule ID 6176 //
     /*  626718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  626729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  626732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  626735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626764 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  626767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626786 */     GIR_RootConstrainSelectedInstOperands,
     /*  626787 */     // GIR_Coverage, 6176,
     /*  626787 */     GIR_EraseRootFromParent_Done,
     /*  626788 */   // Label 10109: @626788
     /*  626788 */   GIM_Try, /*On fail goto*//*Label 10110*/ GIMT_Encode4(626863), // Rule ID 6177 //
     /*  626793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  626804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  626807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  626810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626839 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  626842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626861 */     GIR_RootConstrainSelectedInstOperands,
     /*  626862 */     // GIR_Coverage, 6177,
     /*  626862 */     GIR_EraseRootFromParent_Done,
     /*  626863 */   // Label 10110: @626863
     /*  626863 */   GIM_Try, /*On fail goto*//*Label 10111*/ GIMT_Encode4(626938), // Rule ID 6180 //
     /*  626868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  626879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  626882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  626885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626936 */     GIR_RootConstrainSelectedInstOperands,
     /*  626937 */     // GIR_Coverage, 6180,
     /*  626937 */     GIR_EraseRootFromParent_Done,
     /*  626938 */   // Label 10111: @626938
     /*  626938 */   GIM_Try, /*On fail goto*//*Label 10112*/ GIMT_Encode4(627013), // Rule ID 6181 //
     /*  626943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  626954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  626957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  626960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626989 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627011 */     GIR_RootConstrainSelectedInstOperands,
     /*  627012 */     // GIR_Coverage, 6181,
     /*  627012 */     GIR_EraseRootFromParent_Done,
     /*  627013 */   // Label 10112: @627013
     /*  627013 */   GIM_Try, /*On fail goto*//*Label 10113*/ GIMT_Encode4(627088), // Rule ID 6184 //
     /*  627018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627086 */     GIR_RootConstrainSelectedInstOperands,
     /*  627087 */     // GIR_Coverage, 6184,
     /*  627087 */     GIR_EraseRootFromParent_Done,
     /*  627088 */   // Label 10113: @627088
     /*  627088 */   GIM_Try, /*On fail goto*//*Label 10114*/ GIMT_Encode4(627163), // Rule ID 6185 //
     /*  627093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627139 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627161 */     GIR_RootConstrainSelectedInstOperands,
     /*  627162 */     // GIR_Coverage, 6185,
     /*  627162 */     GIR_EraseRootFromParent_Done,
     /*  627163 */   // Label 10114: @627163
     /*  627163 */   GIM_Try, /*On fail goto*//*Label 10115*/ GIMT_Encode4(627238), // Rule ID 6188 //
     /*  627168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627214 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627236 */     GIR_RootConstrainSelectedInstOperands,
     /*  627237 */     // GIR_Coverage, 6188,
     /*  627237 */     GIR_EraseRootFromParent_Done,
     /*  627238 */   // Label 10115: @627238
     /*  627238 */   GIM_Try, /*On fail goto*//*Label 10116*/ GIMT_Encode4(627313), // Rule ID 6189 //
     /*  627243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627289 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627311 */     GIR_RootConstrainSelectedInstOperands,
     /*  627312 */     // GIR_Coverage, 6189,
     /*  627312 */     GIR_EraseRootFromParent_Done,
     /*  627313 */   // Label 10116: @627313
     /*  627313 */   GIM_Try, /*On fail goto*//*Label 10117*/ GIMT_Encode4(627388), // Rule ID 6192 //
     /*  627318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627386 */     GIR_RootConstrainSelectedInstOperands,
     /*  627387 */     // GIR_Coverage, 6192,
     /*  627387 */     GIR_EraseRootFromParent_Done,
     /*  627388 */   // Label 10117: @627388
     /*  627388 */   GIM_Try, /*On fail goto*//*Label 10118*/ GIMT_Encode4(627463), // Rule ID 6193 //
     /*  627393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627461 */     GIR_RootConstrainSelectedInstOperands,
     /*  627462 */     // GIR_Coverage, 6193,
     /*  627462 */     GIR_EraseRootFromParent_Done,
     /*  627463 */   // Label 10118: @627463
     /*  627463 */   GIM_Try, /*On fail goto*//*Label 10119*/ GIMT_Encode4(627538), // Rule ID 6196 //
     /*  627468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  627479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  627482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  627485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627536 */     GIR_RootConstrainSelectedInstOperands,
     /*  627537 */     // GIR_Coverage, 6196,
     /*  627537 */     GIR_EraseRootFromParent_Done,
     /*  627538 */   // Label 10119: @627538
     /*  627538 */   GIM_Try, /*On fail goto*//*Label 10120*/ GIMT_Encode4(627613), // Rule ID 6197 //
     /*  627543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  627554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  627557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  627560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627589 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627611 */     GIR_RootConstrainSelectedInstOperands,
     /*  627612 */     // GIR_Coverage, 6197,
     /*  627612 */     GIR_EraseRootFromParent_Done,
     /*  627613 */   // Label 10120: @627613
     /*  627613 */   GIM_Try, /*On fail goto*//*Label 10121*/ GIMT_Encode4(627688), // Rule ID 6200 //
     /*  627618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  627629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  627632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  627635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627664 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627686 */     GIR_RootConstrainSelectedInstOperands,
     /*  627687 */     // GIR_Coverage, 6200,
     /*  627687 */     GIR_EraseRootFromParent_Done,
     /*  627688 */   // Label 10121: @627688
     /*  627688 */   GIM_Try, /*On fail goto*//*Label 10122*/ GIMT_Encode4(627763), // Rule ID 6201 //
     /*  627693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  627704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  627707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  627710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627739 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627761 */     GIR_RootConstrainSelectedInstOperands,
     /*  627762 */     // GIR_Coverage, 6201,
     /*  627762 */     GIR_EraseRootFromParent_Done,
     /*  627763 */   // Label 10122: @627763
     /*  627763 */   GIM_Try, /*On fail goto*//*Label 10123*/ GIMT_Encode4(627838), // Rule ID 6204 //
     /*  627768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  627771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  627779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  627782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  627785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  627814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  627833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627836 */     GIR_RootConstrainSelectedInstOperands,
     /*  627837 */     // GIR_Coverage, 6204,
     /*  627837 */     GIR_EraseRootFromParent_Done,
     /*  627838 */   // Label 10123: @627838
     /*  627838 */   GIM_Try, /*On fail goto*//*Label 10124*/ GIMT_Encode4(627913), // Rule ID 6205 //
     /*  627843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  627846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  627854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  627857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  627860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627889 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  627889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  627908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627911 */     GIR_RootConstrainSelectedInstOperands,
     /*  627912 */     // GIR_Coverage, 6205,
     /*  627912 */     GIR_EraseRootFromParent_Done,
     /*  627913 */   // Label 10124: @627913
     /*  627913 */   GIM_Try, /*On fail goto*//*Label 10125*/ GIMT_Encode4(627988), // Rule ID 6208 //
     /*  627918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  627921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  627929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  627932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  627935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627964 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  627964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  627983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627986 */     GIR_RootConstrainSelectedInstOperands,
     /*  627987 */     // GIR_Coverage, 6208,
     /*  627987 */     GIR_EraseRootFromParent_Done,
     /*  627988 */   // Label 10125: @627988
     /*  627988 */   GIM_Try, /*On fail goto*//*Label 10126*/ GIMT_Encode4(628063), // Rule ID 6209 //
     /*  627993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  627996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  628004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  628007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  628010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628039 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  628042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628061 */     GIR_RootConstrainSelectedInstOperands,
     /*  628062 */     // GIR_Coverage, 6209,
     /*  628062 */     GIR_EraseRootFromParent_Done,
     /*  628063 */   // Label 10126: @628063
     /*  628063 */   GIM_Try, /*On fail goto*//*Label 10127*/ GIMT_Encode4(628138), // Rule ID 6212 //
     /*  628068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  628117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628136 */     GIR_RootConstrainSelectedInstOperands,
     /*  628137 */     // GIR_Coverage, 6212,
     /*  628137 */     GIR_EraseRootFromParent_Done,
     /*  628138 */   // Label 10127: @628138
     /*  628138 */   GIM_Try, /*On fail goto*//*Label 10128*/ GIMT_Encode4(628213), // Rule ID 6213 //
     /*  628143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628189 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  628192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628211 */     GIR_RootConstrainSelectedInstOperands,
     /*  628212 */     // GIR_Coverage, 6213,
     /*  628212 */     GIR_EraseRootFromParent_Done,
     /*  628213 */   // Label 10128: @628213
     /*  628213 */   GIM_Try, /*On fail goto*//*Label 10129*/ GIMT_Encode4(628288), // Rule ID 6304 //
     /*  628218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  628238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628264 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  628267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628286 */     GIR_RootConstrainSelectedInstOperands,
     /*  628287 */     // GIR_Coverage, 6304,
     /*  628287 */     GIR_EraseRootFromParent_Done,
     /*  628288 */   // Label 10129: @628288
     /*  628288 */   GIM_Try, /*On fail goto*//*Label 10130*/ GIMT_Encode4(628363), // Rule ID 6305 //
     /*  628293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  628313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628339 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  628342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628361 */     GIR_RootConstrainSelectedInstOperands,
     /*  628362 */     // GIR_Coverage, 6305,
     /*  628362 */     GIR_EraseRootFromParent_Done,
     /*  628363 */   // Label 10130: @628363
     /*  628363 */   GIM_Try, /*On fail goto*//*Label 10131*/ GIMT_Encode4(628438), // Rule ID 6308 //
     /*  628368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  628388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628414 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628436 */     GIR_RootConstrainSelectedInstOperands,
     /*  628437 */     // GIR_Coverage, 6308,
     /*  628437 */     GIR_EraseRootFromParent_Done,
     /*  628438 */   // Label 10131: @628438
     /*  628438 */   GIM_Try, /*On fail goto*//*Label 10132*/ GIMT_Encode4(628513), // Rule ID 6309 //
     /*  628443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  628463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628489 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628511 */     GIR_RootConstrainSelectedInstOperands,
     /*  628512 */     // GIR_Coverage, 6309,
     /*  628512 */     GIR_EraseRootFromParent_Done,
     /*  628513 */   // Label 10132: @628513
     /*  628513 */   GIM_Try, /*On fail goto*//*Label 10133*/ GIMT_Encode4(628588), // Rule ID 6312 //
     /*  628518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  628529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  628532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  628535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  628538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628564 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628586 */     GIR_RootConstrainSelectedInstOperands,
     /*  628587 */     // GIR_Coverage, 6312,
     /*  628587 */     GIR_EraseRootFromParent_Done,
     /*  628588 */   // Label 10133: @628588
     /*  628588 */   GIM_Try, /*On fail goto*//*Label 10134*/ GIMT_Encode4(628663), // Rule ID 6313 //
     /*  628593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  628604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  628607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  628610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  628613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628639 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628661 */     GIR_RootConstrainSelectedInstOperands,
     /*  628662 */     // GIR_Coverage, 6313,
     /*  628662 */     GIR_EraseRootFromParent_Done,
     /*  628663 */   // Label 10134: @628663
     /*  628663 */   GIM_Try, /*On fail goto*//*Label 10135*/ GIMT_Encode4(628738), // Rule ID 6316 //
     /*  628668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  628679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  628682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  628685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  628688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628714 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  628714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628736 */     GIR_RootConstrainSelectedInstOperands,
     /*  628737 */     // GIR_Coverage, 6316,
     /*  628737 */     GIR_EraseRootFromParent_Done,
     /*  628738 */   // Label 10135: @628738
     /*  628738 */   GIM_Try, /*On fail goto*//*Label 10136*/ GIMT_Encode4(628813), // Rule ID 6317 //
     /*  628743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  628754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  628757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  628760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  628763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628789 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  628789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628811 */     GIR_RootConstrainSelectedInstOperands,
     /*  628812 */     // GIR_Coverage, 6317,
     /*  628812 */     GIR_EraseRootFromParent_Done,
     /*  628813 */   // Label 10136: @628813
     /*  628813 */   GIM_Try, /*On fail goto*//*Label 10137*/ GIMT_Encode4(628888), // Rule ID 6320 //
     /*  628818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  628829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  628832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  628835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  628838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628864 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  628864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628886 */     GIR_RootConstrainSelectedInstOperands,
     /*  628887 */     // GIR_Coverage, 6320,
     /*  628887 */     GIR_EraseRootFromParent_Done,
     /*  628888 */   // Label 10137: @628888
     /*  628888 */   GIM_Try, /*On fail goto*//*Label 10138*/ GIMT_Encode4(628963), // Rule ID 6321 //
     /*  628893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  628904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  628907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  628910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  628913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628939 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  628939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628961 */     GIR_RootConstrainSelectedInstOperands,
     /*  628962 */     // GIR_Coverage, 6321,
     /*  628962 */     GIR_EraseRootFromParent_Done,
     /*  628963 */   // Label 10138: @628963
     /*  628963 */   GIM_Try, /*On fail goto*//*Label 10139*/ GIMT_Encode4(629038), // Rule ID 6324 //
     /*  628968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  628979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  628982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  628985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  628988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629036 */     GIR_RootConstrainSelectedInstOperands,
     /*  629037 */     // GIR_Coverage, 6324,
     /*  629037 */     GIR_EraseRootFromParent_Done,
     /*  629038 */   // Label 10139: @629038
     /*  629038 */   GIM_Try, /*On fail goto*//*Label 10140*/ GIMT_Encode4(629113), // Rule ID 6325 //
     /*  629043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  629054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  629057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  629060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  629063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629089 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  629089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629111 */     GIR_RootConstrainSelectedInstOperands,
     /*  629112 */     // GIR_Coverage, 6325,
     /*  629112 */     GIR_EraseRootFromParent_Done,
     /*  629113 */   // Label 10140: @629113
     /*  629113 */   GIM_Try, /*On fail goto*//*Label 10141*/ GIMT_Encode4(629188), // Rule ID 6328 //
     /*  629118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  629138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629164 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629186 */     GIR_RootConstrainSelectedInstOperands,
     /*  629187 */     // GIR_Coverage, 6328,
     /*  629187 */     GIR_EraseRootFromParent_Done,
     /*  629188 */   // Label 10141: @629188
     /*  629188 */   GIM_Try, /*On fail goto*//*Label 10142*/ GIMT_Encode4(629263), // Rule ID 6329 //
     /*  629193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  629213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629239 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629261 */     GIR_RootConstrainSelectedInstOperands,
     /*  629262 */     // GIR_Coverage, 6329,
     /*  629262 */     GIR_EraseRootFromParent_Done,
     /*  629263 */   // Label 10142: @629263
     /*  629263 */   GIM_Try, /*On fail goto*//*Label 10143*/ GIMT_Encode4(629338), // Rule ID 6332 //
     /*  629268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  629288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629314 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629336 */     GIR_RootConstrainSelectedInstOperands,
     /*  629337 */     // GIR_Coverage, 6332,
     /*  629337 */     GIR_EraseRootFromParent_Done,
     /*  629338 */   // Label 10143: @629338
     /*  629338 */   GIM_Try, /*On fail goto*//*Label 10144*/ GIMT_Encode4(629413), // Rule ID 6333 //
     /*  629343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  629363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629389 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629411 */     GIR_RootConstrainSelectedInstOperands,
     /*  629412 */     // GIR_Coverage, 6333,
     /*  629412 */     GIR_EraseRootFromParent_Done,
     /*  629413 */   // Label 10144: @629413
     /*  629413 */   GIM_Try, /*On fail goto*//*Label 10145*/ GIMT_Encode4(629488), // Rule ID 6336 //
     /*  629418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  629429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  629432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  629435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  629438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629486 */     GIR_RootConstrainSelectedInstOperands,
     /*  629487 */     // GIR_Coverage, 6336,
     /*  629487 */     GIR_EraseRootFromParent_Done,
     /*  629488 */   // Label 10145: @629488
     /*  629488 */   GIM_Try, /*On fail goto*//*Label 10146*/ GIMT_Encode4(629563), // Rule ID 6337 //
     /*  629493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  629504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  629507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  629510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  629513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629539 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  629539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629561 */     GIR_RootConstrainSelectedInstOperands,
     /*  629562 */     // GIR_Coverage, 6337,
     /*  629562 */     GIR_EraseRootFromParent_Done,
     /*  629563 */   // Label 10146: @629563
     /*  629563 */   GIM_Try, /*On fail goto*//*Label 10147*/ GIMT_Encode4(629638), // Rule ID 6340 //
     /*  629568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  629571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  629579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  629582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  629585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  629588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629614 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  629614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  629633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629636 */     GIR_RootConstrainSelectedInstOperands,
     /*  629637 */     // GIR_Coverage, 6340,
     /*  629637 */     GIR_EraseRootFromParent_Done,
     /*  629638 */   // Label 10147: @629638
     /*  629638 */   GIM_Try, /*On fail goto*//*Label 10148*/ GIMT_Encode4(629713), // Rule ID 6341 //
     /*  629643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  629646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  629654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  629657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  629660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  629663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629689 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  629689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  629708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629711 */     GIR_RootConstrainSelectedInstOperands,
     /*  629712 */     // GIR_Coverage, 6341,
     /*  629712 */     GIR_EraseRootFromParent_Done,
     /*  629713 */   // Label 10148: @629713
     /*  629713 */   GIM_Try, /*On fail goto*//*Label 10149*/ GIMT_Encode4(629788), // Rule ID 6344 //
     /*  629718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  629729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  629732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  629735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  629738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629764 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  629767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629786 */     GIR_RootConstrainSelectedInstOperands,
     /*  629787 */     // GIR_Coverage, 6344,
     /*  629787 */     GIR_EraseRootFromParent_Done,
     /*  629788 */   // Label 10149: @629788
     /*  629788 */   GIM_Try, /*On fail goto*//*Label 10150*/ GIMT_Encode4(629863), // Rule ID 6345 //
     /*  629793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  629804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  629807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  629810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  629813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629839 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  629842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629861 */     GIR_RootConstrainSelectedInstOperands,
     /*  629862 */     // GIR_Coverage, 6345,
     /*  629862 */     GIR_EraseRootFromParent_Done,
     /*  629863 */   // Label 10150: @629863
     /*  629863 */   GIM_Try, /*On fail goto*//*Label 10151*/ GIMT_Encode4(629938), // Rule ID 6348 //
     /*  629868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  629879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  629882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  629885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  629888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629914 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  629917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629936 */     GIR_RootConstrainSelectedInstOperands,
     /*  629937 */     // GIR_Coverage, 6348,
     /*  629937 */     GIR_EraseRootFromParent_Done,
     /*  629938 */   // Label 10151: @629938
     /*  629938 */   GIM_Try, /*On fail goto*//*Label 10152*/ GIMT_Encode4(630013), // Rule ID 6349 //
     /*  629943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  629954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  629957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  629960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  629963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629989 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  629992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630011 */     GIR_RootConstrainSelectedInstOperands,
     /*  630012 */     // GIR_Coverage, 6349,
     /*  630012 */     GIR_EraseRootFromParent_Done,
     /*  630013 */   // Label 10152: @630013
     /*  630013 */   GIM_Try, /*On fail goto*//*Label 10153*/ GIMT_Encode4(630088), // Rule ID 6352 //
     /*  630018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  630038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630064 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630086 */     GIR_RootConstrainSelectedInstOperands,
     /*  630087 */     // GIR_Coverage, 6352,
     /*  630087 */     GIR_EraseRootFromParent_Done,
     /*  630088 */   // Label 10153: @630088
     /*  630088 */   GIM_Try, /*On fail goto*//*Label 10154*/ GIMT_Encode4(630163), // Rule ID 6353 //
     /*  630093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  630113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630139 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630161 */     GIR_RootConstrainSelectedInstOperands,
     /*  630162 */     // GIR_Coverage, 6353,
     /*  630162 */     GIR_EraseRootFromParent_Done,
     /*  630163 */   // Label 10154: @630163
     /*  630163 */   GIM_Try, /*On fail goto*//*Label 10155*/ GIMT_Encode4(630238), // Rule ID 6356 //
     /*  630168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  630188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630214 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630236 */     GIR_RootConstrainSelectedInstOperands,
     /*  630237 */     // GIR_Coverage, 6356,
     /*  630237 */     GIR_EraseRootFromParent_Done,
     /*  630238 */   // Label 10155: @630238
     /*  630238 */   GIM_Try, /*On fail goto*//*Label 10156*/ GIMT_Encode4(630313), // Rule ID 6357 //
     /*  630243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  630263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630289 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630311 */     GIR_RootConstrainSelectedInstOperands,
     /*  630312 */     // GIR_Coverage, 6357,
     /*  630312 */     GIR_EraseRootFromParent_Done,
     /*  630313 */   // Label 10156: @630313
     /*  630313 */   GIM_Try, /*On fail goto*//*Label 10157*/ GIMT_Encode4(630388), // Rule ID 6360 //
     /*  630318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  630338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630364 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630386 */     GIR_RootConstrainSelectedInstOperands,
     /*  630387 */     // GIR_Coverage, 6360,
     /*  630387 */     GIR_EraseRootFromParent_Done,
     /*  630388 */   // Label 10157: @630388
     /*  630388 */   GIM_Try, /*On fail goto*//*Label 10158*/ GIMT_Encode4(630463), // Rule ID 6361 //
     /*  630393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  630413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630439 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630461 */     GIR_RootConstrainSelectedInstOperands,
     /*  630462 */     // GIR_Coverage, 6361,
     /*  630462 */     GIR_EraseRootFromParent_Done,
     /*  630463 */   // Label 10158: @630463
     /*  630463 */   GIM_Try, /*On fail goto*//*Label 10159*/ GIMT_Encode4(630538), // Rule ID 6364 //
     /*  630468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  630479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  630482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  630485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  630488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630514 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630536 */     GIR_RootConstrainSelectedInstOperands,
     /*  630537 */     // GIR_Coverage, 6364,
     /*  630537 */     GIR_EraseRootFromParent_Done,
     /*  630538 */   // Label 10159: @630538
     /*  630538 */   GIM_Try, /*On fail goto*//*Label 10160*/ GIMT_Encode4(630613), // Rule ID 6365 //
     /*  630543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  630554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  630557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  630560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  630563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630589 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630611 */     GIR_RootConstrainSelectedInstOperands,
     /*  630612 */     // GIR_Coverage, 6365,
     /*  630612 */     GIR_EraseRootFromParent_Done,
     /*  630613 */   // Label 10160: @630613
     /*  630613 */   GIM_Try, /*On fail goto*//*Label 10161*/ GIMT_Encode4(630688), // Rule ID 6368 //
     /*  630618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  630629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  630632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  630635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  630638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  630664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630686 */     GIR_RootConstrainSelectedInstOperands,
     /*  630687 */     // GIR_Coverage, 6368,
     /*  630687 */     GIR_EraseRootFromParent_Done,
     /*  630688 */   // Label 10161: @630688
     /*  630688 */   GIM_Try, /*On fail goto*//*Label 10162*/ GIMT_Encode4(630763), // Rule ID 6369 //
     /*  630693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  630704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  630707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  630710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  630713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630739 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  630739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630761 */     GIR_RootConstrainSelectedInstOperands,
     /*  630762 */     // GIR_Coverage, 6369,
     /*  630762 */     GIR_EraseRootFromParent_Done,
     /*  630763 */   // Label 10162: @630763
     /*  630763 */   GIM_Try, /*On fail goto*//*Label 10163*/ GIMT_Encode4(630838), // Rule ID 6372 //
     /*  630768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  630779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  630782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  630785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  630788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630814 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  630814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630836 */     GIR_RootConstrainSelectedInstOperands,
     /*  630837 */     // GIR_Coverage, 6372,
     /*  630837 */     GIR_EraseRootFromParent_Done,
     /*  630838 */   // Label 10163: @630838
     /*  630838 */   GIM_Try, /*On fail goto*//*Label 10164*/ GIMT_Encode4(630913), // Rule ID 6373 //
     /*  630843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  630854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  630857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  630860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  630863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630889 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  630889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630911 */     GIR_RootConstrainSelectedInstOperands,
     /*  630912 */     // GIR_Coverage, 6373,
     /*  630912 */     GIR_EraseRootFromParent_Done,
     /*  630913 */   // Label 10164: @630913
     /*  630913 */   GIM_Try, /*On fail goto*//*Label 10165*/ GIMT_Encode4(630988), // Rule ID 6376 //
     /*  630918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  630929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  630932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  630935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  630938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630964 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  630964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630986 */     GIR_RootConstrainSelectedInstOperands,
     /*  630987 */     // GIR_Coverage, 6376,
     /*  630987 */     GIR_EraseRootFromParent_Done,
     /*  630988 */   // Label 10165: @630988
     /*  630988 */   GIM_Try, /*On fail goto*//*Label 10166*/ GIMT_Encode4(631063), // Rule ID 6377 //
     /*  630993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  631004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  631007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  631010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  631013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631039 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631061 */     GIR_RootConstrainSelectedInstOperands,
     /*  631062 */     // GIR_Coverage, 6377,
     /*  631062 */     GIR_EraseRootFromParent_Done,
     /*  631063 */   // Label 10166: @631063
     /*  631063 */   GIM_Try, /*On fail goto*//*Label 10167*/ GIMT_Encode4(631138), // Rule ID 6380 //
     /*  631068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  631088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  631117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631136 */     GIR_RootConstrainSelectedInstOperands,
     /*  631137 */     // GIR_Coverage, 6380,
     /*  631137 */     GIR_EraseRootFromParent_Done,
     /*  631138 */   // Label 10167: @631138
     /*  631138 */   GIM_Try, /*On fail goto*//*Label 10168*/ GIMT_Encode4(631213), // Rule ID 6381 //
     /*  631143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  631163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631189 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  631192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631211 */     GIR_RootConstrainSelectedInstOperands,
     /*  631212 */     // GIR_Coverage, 6381,
     /*  631212 */     GIR_EraseRootFromParent_Done,
     /*  631213 */   // Label 10168: @631213
     /*  631213 */   GIM_Try, /*On fail goto*//*Label 10169*/ GIMT_Encode4(631288), // Rule ID 6384 //
     /*  631218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  631238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  631267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631286 */     GIR_RootConstrainSelectedInstOperands,
     /*  631287 */     // GIR_Coverage, 6384,
     /*  631287 */     GIR_EraseRootFromParent_Done,
     /*  631288 */   // Label 10169: @631288
     /*  631288 */   GIM_Try, /*On fail goto*//*Label 10170*/ GIMT_Encode4(631363), // Rule ID 6385 //
     /*  631293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  631313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631339 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  631342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631361 */     GIR_RootConstrainSelectedInstOperands,
     /*  631362 */     // GIR_Coverage, 6385,
     /*  631362 */     GIR_EraseRootFromParent_Done,
     /*  631363 */   // Label 10170: @631363
     /*  631363 */   GIM_Try, /*On fail goto*//*Label 10171*/ GIMT_Encode4(631438), // Rule ID 6388 //
     /*  631368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  631388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631414 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631436 */     GIR_RootConstrainSelectedInstOperands,
     /*  631437 */     // GIR_Coverage, 6388,
     /*  631437 */     GIR_EraseRootFromParent_Done,
     /*  631438 */   // Label 10171: @631438
     /*  631438 */   GIM_Try, /*On fail goto*//*Label 10172*/ GIMT_Encode4(631513), // Rule ID 6389 //
     /*  631443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  631463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631489 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631511 */     GIR_RootConstrainSelectedInstOperands,
     /*  631512 */     // GIR_Coverage, 6389,
     /*  631512 */     GIR_EraseRootFromParent_Done,
     /*  631513 */   // Label 10172: @631513
     /*  631513 */   GIM_Try, /*On fail goto*//*Label 10173*/ GIMT_Encode4(631588), // Rule ID 6392 //
     /*  631518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  631529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  631532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  631535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631564 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  631564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  631567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631586 */     GIR_RootConstrainSelectedInstOperands,
     /*  631587 */     // GIR_Coverage, 6392,
     /*  631587 */     GIR_EraseRootFromParent_Done,
     /*  631588 */   // Label 10173: @631588
     /*  631588 */   GIM_Try, /*On fail goto*//*Label 10174*/ GIMT_Encode4(631663), // Rule ID 6393 //
     /*  631593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  631604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  631607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  631610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631639 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  631639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  631642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631661 */     GIR_RootConstrainSelectedInstOperands,
     /*  631662 */     // GIR_Coverage, 6393,
     /*  631662 */     GIR_EraseRootFromParent_Done,
     /*  631663 */   // Label 10174: @631663
     /*  631663 */   GIM_Try, /*On fail goto*//*Label 10175*/ GIMT_Encode4(631738), // Rule ID 6396 //
     /*  631668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  631679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  631682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  631685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631714 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  631714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  631717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631736 */     GIR_RootConstrainSelectedInstOperands,
     /*  631737 */     // GIR_Coverage, 6396,
     /*  631737 */     GIR_EraseRootFromParent_Done,
     /*  631738 */   // Label 10175: @631738
     /*  631738 */   GIM_Try, /*On fail goto*//*Label 10176*/ GIMT_Encode4(631813), // Rule ID 6397 //
     /*  631743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  631754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  631757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  631760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631789 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  631789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  631792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631811 */     GIR_RootConstrainSelectedInstOperands,
     /*  631812 */     // GIR_Coverage, 6397,
     /*  631812 */     GIR_EraseRootFromParent_Done,
     /*  631813 */   // Label 10176: @631813
     /*  631813 */   GIM_Try, /*On fail goto*//*Label 10177*/ GIMT_Encode4(631888), // Rule ID 6400 //
     /*  631818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  631829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  631832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  631835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631864 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  631864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  631867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631886 */     GIR_RootConstrainSelectedInstOperands,
     /*  631887 */     // GIR_Coverage, 6400,
     /*  631887 */     GIR_EraseRootFromParent_Done,
     /*  631888 */   // Label 10177: @631888
     /*  631888 */   GIM_Try, /*On fail goto*//*Label 10178*/ GIMT_Encode4(631963), // Rule ID 6401 //
     /*  631893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  631904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  631907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  631910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631939 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  631939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  631942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631961 */     GIR_RootConstrainSelectedInstOperands,
     /*  631962 */     // GIR_Coverage, 6401,
     /*  631962 */     GIR_EraseRootFromParent_Done,
     /*  631963 */   // Label 10178: @631963
     /*  631963 */   GIM_Try, /*On fail goto*//*Label 10179*/ GIMT_Encode4(632038), // Rule ID 6404 //
     /*  631968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  631979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  631982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  631985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632014 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  632017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632036 */     GIR_RootConstrainSelectedInstOperands,
     /*  632037 */     // GIR_Coverage, 6404,
     /*  632037 */     GIR_EraseRootFromParent_Done,
     /*  632038 */   // Label 10179: @632038
     /*  632038 */   GIM_Try, /*On fail goto*//*Label 10180*/ GIMT_Encode4(632113), // Rule ID 6405 //
     /*  632043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  632054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  632057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  632060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632089 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  632092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632111 */     GIR_RootConstrainSelectedInstOperands,
     /*  632112 */     // GIR_Coverage, 6405,
     /*  632112 */     GIR_EraseRootFromParent_Done,
     /*  632113 */   // Label 10180: @632113
     /*  632113 */   GIM_Try, /*On fail goto*//*Label 10181*/ GIMT_Encode4(632188), // Rule ID 6408 //
     /*  632118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632164 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632186 */     GIR_RootConstrainSelectedInstOperands,
     /*  632187 */     // GIR_Coverage, 6408,
     /*  632187 */     GIR_EraseRootFromParent_Done,
     /*  632188 */   // Label 10181: @632188
     /*  632188 */   GIM_Try, /*On fail goto*//*Label 10182*/ GIMT_Encode4(632263), // Rule ID 6409 //
     /*  632193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632239 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632261 */     GIR_RootConstrainSelectedInstOperands,
     /*  632262 */     // GIR_Coverage, 6409,
     /*  632262 */     GIR_EraseRootFromParent_Done,
     /*  632263 */   // Label 10182: @632263
     /*  632263 */   GIM_Try, /*On fail goto*//*Label 10183*/ GIMT_Encode4(632338), // Rule ID 6412 //
     /*  632268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632314 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  632314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632336 */     GIR_RootConstrainSelectedInstOperands,
     /*  632337 */     // GIR_Coverage, 6412,
     /*  632337 */     GIR_EraseRootFromParent_Done,
     /*  632338 */   // Label 10183: @632338
     /*  632338 */   GIM_Try, /*On fail goto*//*Label 10184*/ GIMT_Encode4(632413), // Rule ID 6413 //
     /*  632343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632389 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  632389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632411 */     GIR_RootConstrainSelectedInstOperands,
     /*  632412 */     // GIR_Coverage, 6413,
     /*  632412 */     GIR_EraseRootFromParent_Done,
     /*  632413 */   // Label 10184: @632413
     /*  632413 */   GIM_Try, /*On fail goto*//*Label 10185*/ GIMT_Encode4(632488), // Rule ID 6416 //
     /*  632418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  632429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  632432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  632435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632464 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632486 */     GIR_RootConstrainSelectedInstOperands,
     /*  632487 */     // GIR_Coverage, 6416,
     /*  632487 */     GIR_EraseRootFromParent_Done,
     /*  632488 */   // Label 10185: @632488
     /*  632488 */   GIM_Try, /*On fail goto*//*Label 10186*/ GIMT_Encode4(632563), // Rule ID 6417 //
     /*  632493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  632504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  632507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  632510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632539 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11689:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632561 */     GIR_RootConstrainSelectedInstOperands,
     /*  632562 */     // GIR_Coverage, 6417,
     /*  632562 */     GIR_EraseRootFromParent_Done,
     /*  632563 */   // Label 10186: @632563
     /*  632563 */   GIM_Try, /*On fail goto*//*Label 10187*/ GIMT_Encode4(632638), // Rule ID 6420 //
     /*  632568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  632579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  632582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  632585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632614 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632636 */     GIR_RootConstrainSelectedInstOperands,
     /*  632637 */     // GIR_Coverage, 6420,
     /*  632637 */     GIR_EraseRootFromParent_Done,
     /*  632638 */   // Label 10187: @632638
     /*  632638 */   GIM_Try, /*On fail goto*//*Label 10188*/ GIMT_Encode4(632713), // Rule ID 6421 //
     /*  632643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  632654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  632657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  632660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632689 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11689:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632711 */     GIR_RootConstrainSelectedInstOperands,
     /*  632712 */     // GIR_Coverage, 6421,
     /*  632712 */     GIR_EraseRootFromParent_Done,
     /*  632713 */   // Label 10188: @632713
     /*  632713 */   GIM_Try, /*On fail goto*//*Label 10189*/ GIMT_Encode4(632788), // Rule ID 6424 //
     /*  632718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  632729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  632732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  632735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632764 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  632764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632786 */     GIR_RootConstrainSelectedInstOperands,
     /*  632787 */     // GIR_Coverage, 6424,
     /*  632787 */     GIR_EraseRootFromParent_Done,
     /*  632788 */   // Label 10189: @632788
     /*  632788 */   GIM_Try, /*On fail goto*//*Label 10190*/ GIMT_Encode4(632863), // Rule ID 6425 //
     /*  632793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  632804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  632807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  632810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632839 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11689:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  632839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632861 */     GIR_RootConstrainSelectedInstOperands,
     /*  632862 */     // GIR_Coverage, 6425,
     /*  632862 */     GIR_EraseRootFromParent_Done,
     /*  632863 */   // Label 10190: @632863
     /*  632863 */   GIM_Try, /*On fail goto*//*Label 10191*/ GIMT_Encode4(632938), // Rule ID 6428 //
     /*  632868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  632871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  632879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  632882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  632885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632914 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  632914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  632933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632936 */     GIR_RootConstrainSelectedInstOperands,
     /*  632937 */     // GIR_Coverage, 6428,
     /*  632937 */     GIR_EraseRootFromParent_Done,
     /*  632938 */   // Label 10191: @632938
     /*  632938 */   GIM_Try, /*On fail goto*//*Label 10192*/ GIMT_Encode4(633013), // Rule ID 6429 //
     /*  632943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  632946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  632954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  632957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  632960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632989 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11689:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  632989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  633008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633011 */     GIR_RootConstrainSelectedInstOperands,
     /*  633012 */     // GIR_Coverage, 6429,
     /*  633012 */     GIR_EraseRootFromParent_Done,
     /*  633013 */   // Label 10192: @633013
     /*  633013 */   GIM_Try, /*On fail goto*//*Label 10193*/ GIMT_Encode4(633088), // Rule ID 6432 //
     /*  633018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633064 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633086 */     GIR_RootConstrainSelectedInstOperands,
     /*  633087 */     // GIR_Coverage, 6432,
     /*  633087 */     GIR_EraseRootFromParent_Done,
     /*  633088 */   // Label 10193: @633088
     /*  633088 */   GIM_Try, /*On fail goto*//*Label 10194*/ GIMT_Encode4(633163), // Rule ID 6433 //
     /*  633093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633139 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633161 */     GIR_RootConstrainSelectedInstOperands,
     /*  633162 */     // GIR_Coverage, 6433,
     /*  633162 */     GIR_EraseRootFromParent_Done,
     /*  633163 */   // Label 10194: @633163
     /*  633163 */   GIM_Try, /*On fail goto*//*Label 10195*/ GIMT_Encode4(633238), // Rule ID 6436 //
     /*  633168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633214 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633236 */     GIR_RootConstrainSelectedInstOperands,
     /*  633237 */     // GIR_Coverage, 6436,
     /*  633237 */     GIR_EraseRootFromParent_Done,
     /*  633238 */   // Label 10195: @633238
     /*  633238 */   GIM_Try, /*On fail goto*//*Label 10196*/ GIMT_Encode4(633313), // Rule ID 6437 //
     /*  633243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633289 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633311 */     GIR_RootConstrainSelectedInstOperands,
     /*  633312 */     // GIR_Coverage, 6437,
     /*  633312 */     GIR_EraseRootFromParent_Done,
     /*  633313 */   // Label 10196: @633313
     /*  633313 */   GIM_Try, /*On fail goto*//*Label 10197*/ GIMT_Encode4(633388), // Rule ID 6440 //
     /*  633318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633364 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633386 */     GIR_RootConstrainSelectedInstOperands,
     /*  633387 */     // GIR_Coverage, 6440,
     /*  633387 */     GIR_EraseRootFromParent_Done,
     /*  633388 */   // Label 10197: @633388
     /*  633388 */   GIM_Try, /*On fail goto*//*Label 10198*/ GIMT_Encode4(633463), // Rule ID 6441 //
     /*  633393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633439 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633461 */     GIR_RootConstrainSelectedInstOperands,
     /*  633462 */     // GIR_Coverage, 6441,
     /*  633462 */     GIR_EraseRootFromParent_Done,
     /*  633463 */   // Label 10198: @633463
     /*  633463 */   GIM_Try, /*On fail goto*//*Label 10199*/ GIMT_Encode4(633538), // Rule ID 6444 //
     /*  633468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  633479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  633482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  633485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633536 */     GIR_RootConstrainSelectedInstOperands,
     /*  633537 */     // GIR_Coverage, 6444,
     /*  633537 */     GIR_EraseRootFromParent_Done,
     /*  633538 */   // Label 10199: @633538
     /*  633538 */   GIM_Try, /*On fail goto*//*Label 10200*/ GIMT_Encode4(633613), // Rule ID 6445 //
     /*  633543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  633554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  633557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  633560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633589 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633611 */     GIR_RootConstrainSelectedInstOperands,
     /*  633612 */     // GIR_Coverage, 6445,
     /*  633612 */     GIR_EraseRootFromParent_Done,
     /*  633613 */   // Label 10200: @633613
     /*  633613 */   GIM_Try, /*On fail goto*//*Label 10201*/ GIMT_Encode4(633688), // Rule ID 6448 //
     /*  633618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  633629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  633632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  633635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633664 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633686 */     GIR_RootConstrainSelectedInstOperands,
     /*  633687 */     // GIR_Coverage, 6448,
     /*  633687 */     GIR_EraseRootFromParent_Done,
     /*  633688 */   // Label 10201: @633688
     /*  633688 */   GIM_Try, /*On fail goto*//*Label 10202*/ GIMT_Encode4(633763), // Rule ID 6449 //
     /*  633693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  633704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  633707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  633710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633739 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633761 */     GIR_RootConstrainSelectedInstOperands,
     /*  633762 */     // GIR_Coverage, 6449,
     /*  633762 */     GIR_EraseRootFromParent_Done,
     /*  633763 */   // Label 10202: @633763
     /*  633763 */   GIM_Try, /*On fail goto*//*Label 10203*/ GIMT_Encode4(633838), // Rule ID 6452 //
     /*  633768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  633779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  633782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  633785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633814 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633836 */     GIR_RootConstrainSelectedInstOperands,
     /*  633837 */     // GIR_Coverage, 6452,
     /*  633837 */     GIR_EraseRootFromParent_Done,
     /*  633838 */   // Label 10203: @633838
     /*  633838 */   GIM_Try, /*On fail goto*//*Label 10204*/ GIMT_Encode4(633913), // Rule ID 6453 //
     /*  633843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  633854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  633857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  633860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633889 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633911 */     GIR_RootConstrainSelectedInstOperands,
     /*  633912 */     // GIR_Coverage, 6453,
     /*  633912 */     GIR_EraseRootFromParent_Done,
     /*  633913 */   // Label 10204: @633913
     /*  633913 */   GIM_Try, /*On fail goto*//*Label 10205*/ GIMT_Encode4(633988), // Rule ID 6456 //
     /*  633918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  633929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  633932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  633935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  633964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633986 */     GIR_RootConstrainSelectedInstOperands,
     /*  633987 */     // GIR_Coverage, 6456,
     /*  633987 */     GIR_EraseRootFromParent_Done,
     /*  633988 */   // Label 10205: @633988
     /*  633988 */   GIM_Try, /*On fail goto*//*Label 10206*/ GIMT_Encode4(634063), // Rule ID 6457 //
     /*  633993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  634004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  634007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  634010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634039 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634061 */     GIR_RootConstrainSelectedInstOperands,
     /*  634062 */     // GIR_Coverage, 6457,
     /*  634062 */     GIR_EraseRootFromParent_Done,
     /*  634063 */   // Label 10206: @634063
     /*  634063 */   GIM_Try, /*On fail goto*//*Label 10207*/ GIMT_Encode4(634138), // Rule ID 6460 //
     /*  634068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634114 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634136 */     GIR_RootConstrainSelectedInstOperands,
     /*  634137 */     // GIR_Coverage, 6460,
     /*  634137 */     GIR_EraseRootFromParent_Done,
     /*  634138 */   // Label 10207: @634138
     /*  634138 */   GIM_Try, /*On fail goto*//*Label 10208*/ GIMT_Encode4(634213), // Rule ID 6461 //
     /*  634143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634189 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634211 */     GIR_RootConstrainSelectedInstOperands,
     /*  634212 */     // GIR_Coverage, 6461,
     /*  634212 */     GIR_EraseRootFromParent_Done,
     /*  634213 */   // Label 10208: @634213
     /*  634213 */   GIM_Try, /*On fail goto*//*Label 10209*/ GIMT_Encode4(634288), // Rule ID 6464 //
     /*  634218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634264 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634286 */     GIR_RootConstrainSelectedInstOperands,
     /*  634287 */     // GIR_Coverage, 6464,
     /*  634287 */     GIR_EraseRootFromParent_Done,
     /*  634288 */   // Label 10209: @634288
     /*  634288 */   GIM_Try, /*On fail goto*//*Label 10210*/ GIMT_Encode4(634363), // Rule ID 6465 //
     /*  634293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634339 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634361 */     GIR_RootConstrainSelectedInstOperands,
     /*  634362 */     // GIR_Coverage, 6465,
     /*  634362 */     GIR_EraseRootFromParent_Done,
     /*  634363 */   // Label 10210: @634363
     /*  634363 */   GIM_Try, /*On fail goto*//*Label 10211*/ GIMT_Encode4(634438), // Rule ID 6468 //
     /*  634368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634436 */     GIR_RootConstrainSelectedInstOperands,
     /*  634437 */     // GIR_Coverage, 6468,
     /*  634437 */     GIR_EraseRootFromParent_Done,
     /*  634438 */   // Label 10211: @634438
     /*  634438 */   GIM_Try, /*On fail goto*//*Label 10212*/ GIMT_Encode4(634513), // Rule ID 6469 //
     /*  634443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634489 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11689:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  634489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634511 */     GIR_RootConstrainSelectedInstOperands,
     /*  634512 */     // GIR_Coverage, 6469,
     /*  634512 */     GIR_EraseRootFromParent_Done,
     /*  634513 */   // Label 10212: @634513
     /*  634513 */   GIM_Try, /*On fail goto*//*Label 10213*/ GIMT_Encode4(634588), // Rule ID 6472 //
     /*  634518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  634529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  634532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  634535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634564 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634586 */     GIR_RootConstrainSelectedInstOperands,
     /*  634587 */     // GIR_Coverage, 6472,
     /*  634587 */     GIR_EraseRootFromParent_Done,
     /*  634588 */   // Label 10213: @634588
     /*  634588 */   GIM_Try, /*On fail goto*//*Label 10214*/ GIMT_Encode4(634663), // Rule ID 6473 //
     /*  634593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  634604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  634607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  634610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634639 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11689:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  634639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634661 */     GIR_RootConstrainSelectedInstOperands,
     /*  634662 */     // GIR_Coverage, 6473,
     /*  634662 */     GIR_EraseRootFromParent_Done,
     /*  634663 */   // Label 10214: @634663
     /*  634663 */   GIM_Try, /*On fail goto*//*Label 10215*/ GIMT_Encode4(634738), // Rule ID 6476 //
     /*  634668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  634679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  634682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  634685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634714 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634736 */     GIR_RootConstrainSelectedInstOperands,
     /*  634737 */     // GIR_Coverage, 6476,
     /*  634737 */     GIR_EraseRootFromParent_Done,
     /*  634738 */   // Label 10215: @634738
     /*  634738 */   GIM_Try, /*On fail goto*//*Label 10216*/ GIMT_Encode4(634813), // Rule ID 6477 //
     /*  634743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  634754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  634757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  634760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634789 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11689:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  634789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634811 */     GIR_RootConstrainSelectedInstOperands,
     /*  634812 */     // GIR_Coverage, 6477,
     /*  634812 */     GIR_EraseRootFromParent_Done,
     /*  634813 */   // Label 10216: @634813
     /*  634813 */   GIM_Try, /*On fail goto*//*Label 10217*/ GIMT_Encode4(634888), // Rule ID 6568 //
     /*  634818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  634829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  634832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  634835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  634838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634864 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  634864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  634867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  634883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634886 */     GIR_RootConstrainSelectedInstOperands,
     /*  634887 */     // GIR_Coverage, 6568,
     /*  634887 */     GIR_EraseRootFromParent_Done,
     /*  634888 */   // Label 10217: @634888
     /*  634888 */   GIM_Try, /*On fail goto*//*Label 10218*/ GIMT_Encode4(634963), // Rule ID 6569 //
     /*  634893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  634904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  634907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  634910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  634913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634939 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  634939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  634942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  634958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634961 */     GIR_RootConstrainSelectedInstOperands,
     /*  634962 */     // GIR_Coverage, 6569,
     /*  634962 */     GIR_EraseRootFromParent_Done,
     /*  634963 */   // Label 10218: @634963
     /*  634963 */   GIM_Try, /*On fail goto*//*Label 10219*/ GIMT_Encode4(635038), // Rule ID 6572 //
     /*  634968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  634979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  634982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  634985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  634988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635014 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635036 */     GIR_RootConstrainSelectedInstOperands,
     /*  635037 */     // GIR_Coverage, 6572,
     /*  635037 */     GIR_EraseRootFromParent_Done,
     /*  635038 */   // Label 10219: @635038
     /*  635038 */   GIM_Try, /*On fail goto*//*Label 10220*/ GIMT_Encode4(635113), // Rule ID 6573 //
     /*  635043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  635054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  635057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  635060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  635063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635089 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635111 */     GIR_RootConstrainSelectedInstOperands,
     /*  635112 */     // GIR_Coverage, 6573,
     /*  635112 */     GIR_EraseRootFromParent_Done,
     /*  635113 */   // Label 10220: @635113
     /*  635113 */   GIM_Try, /*On fail goto*//*Label 10221*/ GIMT_Encode4(635188), // Rule ID 6576 //
     /*  635118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  635138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635164 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635186 */     GIR_RootConstrainSelectedInstOperands,
     /*  635187 */     // GIR_Coverage, 6576,
     /*  635187 */     GIR_EraseRootFromParent_Done,
     /*  635188 */   // Label 10221: @635188
     /*  635188 */   GIM_Try, /*On fail goto*//*Label 10222*/ GIMT_Encode4(635263), // Rule ID 6577 //
     /*  635193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  635213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635239 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635261 */     GIR_RootConstrainSelectedInstOperands,
     /*  635262 */     // GIR_Coverage, 6577,
     /*  635262 */     GIR_EraseRootFromParent_Done,
     /*  635263 */   // Label 10222: @635263
     /*  635263 */   GIM_Try, /*On fail goto*//*Label 10223*/ GIMT_Encode4(635338), // Rule ID 6580 //
     /*  635268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  635288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635314 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635336 */     GIR_RootConstrainSelectedInstOperands,
     /*  635337 */     // GIR_Coverage, 6580,
     /*  635337 */     GIR_EraseRootFromParent_Done,
     /*  635338 */   // Label 10223: @635338
     /*  635338 */   GIM_Try, /*On fail goto*//*Label 10224*/ GIMT_Encode4(635413), // Rule ID 6581 //
     /*  635343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  635363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635389 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635411 */     GIR_RootConstrainSelectedInstOperands,
     /*  635412 */     // GIR_Coverage, 6581,
     /*  635412 */     GIR_EraseRootFromParent_Done,
     /*  635413 */   // Label 10224: @635413
     /*  635413 */   GIM_Try, /*On fail goto*//*Label 10225*/ GIMT_Encode4(635488), // Rule ID 6584 //
     /*  635418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  635429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  635432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  635435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  635438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635464 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635486 */     GIR_RootConstrainSelectedInstOperands,
     /*  635487 */     // GIR_Coverage, 6584,
     /*  635487 */     GIR_EraseRootFromParent_Done,
     /*  635488 */   // Label 10225: @635488
     /*  635488 */   GIM_Try, /*On fail goto*//*Label 10226*/ GIMT_Encode4(635563), // Rule ID 6585 //
     /*  635493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  635504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  635507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  635510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  635513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635539 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635561 */     GIR_RootConstrainSelectedInstOperands,
     /*  635562 */     // GIR_Coverage, 6585,
     /*  635562 */     GIR_EraseRootFromParent_Done,
     /*  635563 */   // Label 10226: @635563
     /*  635563 */   GIM_Try, /*On fail goto*//*Label 10227*/ GIMT_Encode4(635638), // Rule ID 6588 //
     /*  635568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  635579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  635582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  635585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  635588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635614 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  635614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  635633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635636 */     GIR_RootConstrainSelectedInstOperands,
     /*  635637 */     // GIR_Coverage, 6588,
     /*  635637 */     GIR_EraseRootFromParent_Done,
     /*  635638 */   // Label 10227: @635638
     /*  635638 */   GIM_Try, /*On fail goto*//*Label 10228*/ GIMT_Encode4(635713), // Rule ID 6589 //
     /*  635643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  635654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  635657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  635660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  635663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635689 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  635689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  635708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635711 */     GIR_RootConstrainSelectedInstOperands,
     /*  635712 */     // GIR_Coverage, 6589,
     /*  635712 */     GIR_EraseRootFromParent_Done,
     /*  635713 */   // Label 10228: @635713
     /*  635713 */   GIM_Try, /*On fail goto*//*Label 10229*/ GIMT_Encode4(635788), // Rule ID 6592 //
     /*  635718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  635729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  635732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  635735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  635738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635764 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635786 */     GIR_RootConstrainSelectedInstOperands,
     /*  635787 */     // GIR_Coverage, 6592,
     /*  635787 */     GIR_EraseRootFromParent_Done,
     /*  635788 */   // Label 10229: @635788
     /*  635788 */   GIM_Try, /*On fail goto*//*Label 10230*/ GIMT_Encode4(635863), // Rule ID 6593 //
     /*  635793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  635804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  635807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  635810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  635813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635839 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635861 */     GIR_RootConstrainSelectedInstOperands,
     /*  635862 */     // GIR_Coverage, 6593,
     /*  635862 */     GIR_EraseRootFromParent_Done,
     /*  635863 */   // Label 10230: @635863
     /*  635863 */   GIM_Try, /*On fail goto*//*Label 10231*/ GIMT_Encode4(635938), // Rule ID 6596 //
     /*  635868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  635879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  635882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  635885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  635888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635914 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635936 */     GIR_RootConstrainSelectedInstOperands,
     /*  635937 */     // GIR_Coverage, 6596,
     /*  635937 */     GIR_EraseRootFromParent_Done,
     /*  635938 */   // Label 10231: @635938
     /*  635938 */   GIM_Try, /*On fail goto*//*Label 10232*/ GIMT_Encode4(636013), // Rule ID 6597 //
     /*  635943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  635954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  635957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  635960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  635963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635989 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636011 */     GIR_RootConstrainSelectedInstOperands,
     /*  636012 */     // GIR_Coverage, 6597,
     /*  636012 */     GIR_EraseRootFromParent_Done,
     /*  636013 */   // Label 10232: @636013
     /*  636013 */   GIM_Try, /*On fail goto*//*Label 10233*/ GIMT_Encode4(636088), // Rule ID 6600 //
     /*  636018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  636038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636064 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636086 */     GIR_RootConstrainSelectedInstOperands,
     /*  636087 */     // GIR_Coverage, 6600,
     /*  636087 */     GIR_EraseRootFromParent_Done,
     /*  636088 */   // Label 10233: @636088
     /*  636088 */   GIM_Try, /*On fail goto*//*Label 10234*/ GIMT_Encode4(636163), // Rule ID 6601 //
     /*  636093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  636113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636139 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636161 */     GIR_RootConstrainSelectedInstOperands,
     /*  636162 */     // GIR_Coverage, 6601,
     /*  636162 */     GIR_EraseRootFromParent_Done,
     /*  636163 */   // Label 10234: @636163
     /*  636163 */   GIM_Try, /*On fail goto*//*Label 10235*/ GIMT_Encode4(636238), // Rule ID 6604 //
     /*  636168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  636171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  636188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636214 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  636214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636236 */     GIR_RootConstrainSelectedInstOperands,
     /*  636237 */     // GIR_Coverage, 6604,
     /*  636237 */     GIR_EraseRootFromParent_Done,
     /*  636238 */   // Label 10235: @636238
     /*  636238 */   GIM_Try, /*On fail goto*//*Label 10236*/ GIMT_Encode4(636313), // Rule ID 6605 //
     /*  636243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  636246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  636263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636289 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  636289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636311 */     GIR_RootConstrainSelectedInstOperands,
     /*  636312 */     // GIR_Coverage, 6605,
     /*  636312 */     GIR_EraseRootFromParent_Done,
     /*  636313 */   // Label 10236: @636313
     /*  636313 */   GIM_Try, /*On fail goto*//*Label 10237*/ GIMT_Encode4(636388), // Rule ID 6608 //
     /*  636318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  636338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636364 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636386 */     GIR_RootConstrainSelectedInstOperands,
     /*  636387 */     // GIR_Coverage, 6608,
     /*  636387 */     GIR_EraseRootFromParent_Done,
     /*  636388 */   // Label 10237: @636388
     /*  636388 */   GIM_Try, /*On fail goto*//*Label 10238*/ GIMT_Encode4(636463), // Rule ID 6609 //
     /*  636393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  636413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636439 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636461 */     GIR_RootConstrainSelectedInstOperands,
     /*  636462 */     // GIR_Coverage, 6609,
     /*  636462 */     GIR_EraseRootFromParent_Done,
     /*  636463 */   // Label 10238: @636463
     /*  636463 */   GIM_Try, /*On fail goto*//*Label 10239*/ GIMT_Encode4(636538), // Rule ID 6612 //
     /*  636468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  636479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  636482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  636485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  636488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636514 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  636517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636536 */     GIR_RootConstrainSelectedInstOperands,
     /*  636537 */     // GIR_Coverage, 6612,
     /*  636537 */     GIR_EraseRootFromParent_Done,
     /*  636538 */   // Label 10239: @636538
     /*  636538 */   GIM_Try, /*On fail goto*//*Label 10240*/ GIMT_Encode4(636613), // Rule ID 6613 //
     /*  636543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  636554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  636557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  636560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  636563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636589 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  636592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636611 */     GIR_RootConstrainSelectedInstOperands,
     /*  636612 */     // GIR_Coverage, 6613,
     /*  636612 */     GIR_EraseRootFromParent_Done,
     /*  636613 */   // Label 10240: @636613
     /*  636613 */   GIM_Try, /*On fail goto*//*Label 10241*/ GIMT_Encode4(636688), // Rule ID 6616 //
     /*  636618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  636629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  636632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  636635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  636638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636664 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  636667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636686 */     GIR_RootConstrainSelectedInstOperands,
     /*  636687 */     // GIR_Coverage, 6616,
     /*  636687 */     GIR_EraseRootFromParent_Done,
     /*  636688 */   // Label 10241: @636688
     /*  636688 */   GIM_Try, /*On fail goto*//*Label 10242*/ GIMT_Encode4(636763), // Rule ID 6617 //
     /*  636693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  636704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  636707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  636710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  636713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636739 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  636742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636761 */     GIR_RootConstrainSelectedInstOperands,
     /*  636762 */     // GIR_Coverage, 6617,
     /*  636762 */     GIR_EraseRootFromParent_Done,
     /*  636763 */   // Label 10242: @636763
     /*  636763 */   GIM_Try, /*On fail goto*//*Label 10243*/ GIMT_Encode4(636838), // Rule ID 6620 //
     /*  636768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  636779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  636782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  636785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  636788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  636814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636836 */     GIR_RootConstrainSelectedInstOperands,
     /*  636837 */     // GIR_Coverage, 6620,
     /*  636837 */     GIR_EraseRootFromParent_Done,
     /*  636838 */   // Label 10243: @636838
     /*  636838 */   GIM_Try, /*On fail goto*//*Label 10244*/ GIMT_Encode4(636913), // Rule ID 6621 //
     /*  636843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  636854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  636857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  636860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  636863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636889 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  636889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636911 */     GIR_RootConstrainSelectedInstOperands,
     /*  636912 */     // GIR_Coverage, 6621,
     /*  636912 */     GIR_EraseRootFromParent_Done,
     /*  636913 */   // Label 10244: @636913
     /*  636913 */   GIM_Try, /*On fail goto*//*Label 10245*/ GIMT_Encode4(636988), // Rule ID 6624 //
     /*  636918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  636929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  636932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  636935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  636938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636964 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  636964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  636967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636986 */     GIR_RootConstrainSelectedInstOperands,
     /*  636987 */     // GIR_Coverage, 6624,
     /*  636987 */     GIR_EraseRootFromParent_Done,
     /*  636988 */   // Label 10245: @636988
     /*  636988 */   GIM_Try, /*On fail goto*//*Label 10246*/ GIMT_Encode4(637063), // Rule ID 6625 //
     /*  636993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  637004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  637007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  637010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  637013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637039 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637061 */     GIR_RootConstrainSelectedInstOperands,
     /*  637062 */     // GIR_Coverage, 6625,
     /*  637062 */     GIR_EraseRootFromParent_Done,
     /*  637063 */   // Label 10246: @637063
     /*  637063 */   GIM_Try, /*On fail goto*//*Label 10247*/ GIMT_Encode4(637138), // Rule ID 6628 //
     /*  637068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  637088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637114 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637136 */     GIR_RootConstrainSelectedInstOperands,
     /*  637137 */     // GIR_Coverage, 6628,
     /*  637137 */     GIR_EraseRootFromParent_Done,
     /*  637138 */   // Label 10247: @637138
     /*  637138 */   GIM_Try, /*On fail goto*//*Label 10248*/ GIMT_Encode4(637213), // Rule ID 6629 //
     /*  637143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  637163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637189 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637211 */     GIR_RootConstrainSelectedInstOperands,
     /*  637212 */     // GIR_Coverage, 6629,
     /*  637212 */     GIR_EraseRootFromParent_Done,
     /*  637213 */   // Label 10248: @637213
     /*  637213 */   GIM_Try, /*On fail goto*//*Label 10249*/ GIMT_Encode4(637288), // Rule ID 6632 //
     /*  637218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  637238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637286 */     GIR_RootConstrainSelectedInstOperands,
     /*  637287 */     // GIR_Coverage, 6632,
     /*  637287 */     GIR_EraseRootFromParent_Done,
     /*  637288 */   // Label 10249: @637288
     /*  637288 */   GIM_Try, /*On fail goto*//*Label 10250*/ GIMT_Encode4(637363), // Rule ID 6633 //
     /*  637293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  637313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637339 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637361 */     GIR_RootConstrainSelectedInstOperands,
     /*  637362 */     // GIR_Coverage, 6633,
     /*  637362 */     GIR_EraseRootFromParent_Done,
     /*  637363 */   // Label 10250: @637363
     /*  637363 */   GIM_Try, /*On fail goto*//*Label 10251*/ GIMT_Encode4(637438), // Rule ID 6636 //
     /*  637368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  637388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637414 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637436 */     GIR_RootConstrainSelectedInstOperands,
     /*  637437 */     // GIR_Coverage, 6636,
     /*  637437 */     GIR_EraseRootFromParent_Done,
     /*  637438 */   // Label 10251: @637438
     /*  637438 */   GIM_Try, /*On fail goto*//*Label 10252*/ GIMT_Encode4(637513), // Rule ID 6637 //
     /*  637443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  637463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637489 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637511 */     GIR_RootConstrainSelectedInstOperands,
     /*  637512 */     // GIR_Coverage, 6637,
     /*  637512 */     GIR_EraseRootFromParent_Done,
     /*  637513 */   // Label 10252: @637513
     /*  637513 */   GIM_Try, /*On fail goto*//*Label 10253*/ GIMT_Encode4(637588), // Rule ID 6640 //
     /*  637518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  637529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  637532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  637535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  637538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637564 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637586 */     GIR_RootConstrainSelectedInstOperands,
     /*  637587 */     // GIR_Coverage, 6640,
     /*  637587 */     GIR_EraseRootFromParent_Done,
     /*  637588 */   // Label 10253: @637588
     /*  637588 */   GIM_Try, /*On fail goto*//*Label 10254*/ GIMT_Encode4(637663), // Rule ID 6641 //
     /*  637593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  637604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  637607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  637610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  637613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637639 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637661 */     GIR_RootConstrainSelectedInstOperands,
     /*  637662 */     // GIR_Coverage, 6641,
     /*  637662 */     GIR_EraseRootFromParent_Done,
     /*  637663 */   // Label 10254: @637663
     /*  637663 */   GIM_Try, /*On fail goto*//*Label 10255*/ GIMT_Encode4(637738), // Rule ID 6644 //
     /*  637668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  637671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  637679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  637682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  637685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  637688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637714 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  637714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637736 */     GIR_RootConstrainSelectedInstOperands,
     /*  637737 */     // GIR_Coverage, 6644,
     /*  637737 */     GIR_EraseRootFromParent_Done,
     /*  637738 */   // Label 10255: @637738
     /*  637738 */   GIM_Try, /*On fail goto*//*Label 10256*/ GIMT_Encode4(637813), // Rule ID 6645 //
     /*  637743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  637746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  637754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  637757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  637760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  637763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637789 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  637789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637811 */     GIR_RootConstrainSelectedInstOperands,
     /*  637812 */     // GIR_Coverage, 6645,
     /*  637812 */     GIR_EraseRootFromParent_Done,
     /*  637813 */   // Label 10256: @637813
     /*  637813 */   GIM_Try, /*On fail goto*//*Label 10257*/ GIMT_Encode4(637888), // Rule ID 6648 //
     /*  637818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  637821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  637829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  637832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  637835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  637838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637864 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  637864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637886 */     GIR_RootConstrainSelectedInstOperands,
     /*  637887 */     // GIR_Coverage, 6648,
     /*  637887 */     GIR_EraseRootFromParent_Done,
     /*  637888 */   // Label 10257: @637888
     /*  637888 */   GIM_Try, /*On fail goto*//*Label 10258*/ GIMT_Encode4(637963), // Rule ID 6649 //
     /*  637893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  637896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  637904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  637907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  637910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  637913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637939 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  637939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637961 */     GIR_RootConstrainSelectedInstOperands,
     /*  637962 */     // GIR_Coverage, 6649,
     /*  637962 */     GIR_EraseRootFromParent_Done,
     /*  637963 */   // Label 10258: @637963
     /*  637963 */   GIM_Try, /*On fail goto*//*Label 10259*/ GIMT_Encode4(638038), // Rule ID 6652 //
     /*  637968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  637971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  637979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  637982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  637985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  637988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638014 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  638017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638036 */     GIR_RootConstrainSelectedInstOperands,
     /*  638037 */     // GIR_Coverage, 6652,
     /*  638037 */     GIR_EraseRootFromParent_Done,
     /*  638038 */   // Label 10259: @638038
     /*  638038 */   GIM_Try, /*On fail goto*//*Label 10260*/ GIMT_Encode4(638113), // Rule ID 6653 //
     /*  638043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  638054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  638057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  638060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  638063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638089 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  638092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638111 */     GIR_RootConstrainSelectedInstOperands,
     /*  638112 */     // GIR_Coverage, 6653,
     /*  638112 */     GIR_EraseRootFromParent_Done,
     /*  638113 */   // Label 10260: @638113
     /*  638113 */   GIM_Try, /*On fail goto*//*Label 10261*/ GIMT_Encode4(638188), // Rule ID 6656 //
     /*  638118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638164 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  638167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638186 */     GIR_RootConstrainSelectedInstOperands,
     /*  638187 */     // GIR_Coverage, 6656,
     /*  638187 */     GIR_EraseRootFromParent_Done,
     /*  638188 */   // Label 10261: @638188
     /*  638188 */   GIM_Try, /*On fail goto*//*Label 10262*/ GIMT_Encode4(638263), // Rule ID 6657 //
     /*  638193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638239 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  638242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638261 */     GIR_RootConstrainSelectedInstOperands,
     /*  638262 */     // GIR_Coverage, 6657,
     /*  638262 */     GIR_EraseRootFromParent_Done,
     /*  638263 */   // Label 10262: @638263
     /*  638263 */   GIM_Try, /*On fail goto*//*Label 10263*/ GIMT_Encode4(638338), // Rule ID 6660 //
     /*  638268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638314 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638336 */     GIR_RootConstrainSelectedInstOperands,
     /*  638337 */     // GIR_Coverage, 6660,
     /*  638337 */     GIR_EraseRootFromParent_Done,
     /*  638338 */   // Label 10263: @638338
     /*  638338 */   GIM_Try, /*On fail goto*//*Label 10264*/ GIMT_Encode4(638413), // Rule ID 6661 //
     /*  638343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638389 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638411 */     GIR_RootConstrainSelectedInstOperands,
     /*  638412 */     // GIR_Coverage, 6661,
     /*  638412 */     GIR_EraseRootFromParent_Done,
     /*  638413 */   // Label 10264: @638413
     /*  638413 */   GIM_Try, /*On fail goto*//*Label 10265*/ GIMT_Encode4(638488), // Rule ID 6664 //
     /*  638418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  638429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  638432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  638435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638464 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638486 */     GIR_RootConstrainSelectedInstOperands,
     /*  638487 */     // GIR_Coverage, 6664,
     /*  638487 */     GIR_EraseRootFromParent_Done,
     /*  638488 */   // Label 10265: @638488
     /*  638488 */   GIM_Try, /*On fail goto*//*Label 10266*/ GIMT_Encode4(638563), // Rule ID 6665 //
     /*  638493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  638504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  638507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  638510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638539 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638561 */     GIR_RootConstrainSelectedInstOperands,
     /*  638562 */     // GIR_Coverage, 6665,
     /*  638562 */     GIR_EraseRootFromParent_Done,
     /*  638563 */   // Label 10266: @638563
     /*  638563 */   GIM_Try, /*On fail goto*//*Label 10267*/ GIMT_Encode4(638638), // Rule ID 6668 //
     /*  638568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  638579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  638582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  638585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638614 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  638614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638636 */     GIR_RootConstrainSelectedInstOperands,
     /*  638637 */     // GIR_Coverage, 6668,
     /*  638637 */     GIR_EraseRootFromParent_Done,
     /*  638638 */   // Label 10267: @638638
     /*  638638 */   GIM_Try, /*On fail goto*//*Label 10268*/ GIMT_Encode4(638713), // Rule ID 6669 //
     /*  638643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  638654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  638657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  638660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638689 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  638689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638711 */     GIR_RootConstrainSelectedInstOperands,
     /*  638712 */     // GIR_Coverage, 6669,
     /*  638712 */     GIR_EraseRootFromParent_Done,
     /*  638713 */   // Label 10268: @638713
     /*  638713 */   GIM_Try, /*On fail goto*//*Label 10269*/ GIMT_Encode4(638788), // Rule ID 6672 //
     /*  638718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  638729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  638732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  638735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638764 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  638764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638786 */     GIR_RootConstrainSelectedInstOperands,
     /*  638787 */     // GIR_Coverage, 6672,
     /*  638787 */     GIR_EraseRootFromParent_Done,
     /*  638788 */   // Label 10269: @638788
     /*  638788 */   GIM_Try, /*On fail goto*//*Label 10270*/ GIMT_Encode4(638863), // Rule ID 6673 //
     /*  638793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  638804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  638807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  638810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638839 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  638839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638861 */     GIR_RootConstrainSelectedInstOperands,
     /*  638862 */     // GIR_Coverage, 6673,
     /*  638862 */     GIR_EraseRootFromParent_Done,
     /*  638863 */   // Label 10270: @638863
     /*  638863 */   GIM_Try, /*On fail goto*//*Label 10271*/ GIMT_Encode4(638938), // Rule ID 6676 //
     /*  638868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  638879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  638882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  638885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638914 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  638914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638936 */     GIR_RootConstrainSelectedInstOperands,
     /*  638937 */     // GIR_Coverage, 6676,
     /*  638937 */     GIR_EraseRootFromParent_Done,
     /*  638938 */   // Label 10271: @638938
     /*  638938 */   GIM_Try, /*On fail goto*//*Label 10272*/ GIMT_Encode4(639013), // Rule ID 6677 //
     /*  638943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  638954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  638957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  638960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638989 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  638989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639011 */     GIR_RootConstrainSelectedInstOperands,
     /*  639012 */     // GIR_Coverage, 6677,
     /*  639012 */     GIR_EraseRootFromParent_Done,
     /*  639013 */   // Label 10272: @639013
     /*  639013 */   GIM_Try, /*On fail goto*//*Label 10273*/ GIMT_Encode4(639088), // Rule ID 6680 //
     /*  639018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639064 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639086 */     GIR_RootConstrainSelectedInstOperands,
     /*  639087 */     // GIR_Coverage, 6680,
     /*  639087 */     GIR_EraseRootFromParent_Done,
     /*  639088 */   // Label 10273: @639088
     /*  639088 */   GIM_Try, /*On fail goto*//*Label 10274*/ GIMT_Encode4(639163), // Rule ID 6681 //
     /*  639093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639139 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639161 */     GIR_RootConstrainSelectedInstOperands,
     /*  639162 */     // GIR_Coverage, 6681,
     /*  639162 */     GIR_EraseRootFromParent_Done,
     /*  639163 */   // Label 10274: @639163
     /*  639163 */   GIM_Try, /*On fail goto*//*Label 10275*/ GIMT_Encode4(639238), // Rule ID 6684 //
     /*  639168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639214 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639236 */     GIR_RootConstrainSelectedInstOperands,
     /*  639237 */     // GIR_Coverage, 6684,
     /*  639237 */     GIR_EraseRootFromParent_Done,
     /*  639238 */   // Label 10275: @639238
     /*  639238 */   GIM_Try, /*On fail goto*//*Label 10276*/ GIMT_Encode4(639313), // Rule ID 6685 //
     /*  639243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639289 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639311 */     GIR_RootConstrainSelectedInstOperands,
     /*  639312 */     // GIR_Coverage, 6685,
     /*  639312 */     GIR_EraseRootFromParent_Done,
     /*  639313 */   // Label 10276: @639313
     /*  639313 */   GIM_Try, /*On fail goto*//*Label 10277*/ GIMT_Encode4(639388), // Rule ID 6688 //
     /*  639318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639364 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  639364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639386 */     GIR_RootConstrainSelectedInstOperands,
     /*  639387 */     // GIR_Coverage, 6688,
     /*  639387 */     GIR_EraseRootFromParent_Done,
     /*  639388 */   // Label 10277: @639388
     /*  639388 */   GIM_Try, /*On fail goto*//*Label 10278*/ GIMT_Encode4(639463), // Rule ID 6689 //
     /*  639393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639439 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  639439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639461 */     GIR_RootConstrainSelectedInstOperands,
     /*  639462 */     // GIR_Coverage, 6689,
     /*  639462 */     GIR_EraseRootFromParent_Done,
     /*  639463 */   // Label 10278: @639463
     /*  639463 */   GIM_Try, /*On fail goto*//*Label 10279*/ GIMT_Encode4(639538), // Rule ID 6692 //
     /*  639468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  639471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  639479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  639482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  639485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639514 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  639514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  639533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639536 */     GIR_RootConstrainSelectedInstOperands,
     /*  639537 */     // GIR_Coverage, 6692,
     /*  639537 */     GIR_EraseRootFromParent_Done,
     /*  639538 */   // Label 10279: @639538
     /*  639538 */   GIM_Try, /*On fail goto*//*Label 10280*/ GIMT_Encode4(639613), // Rule ID 6693 //
     /*  639543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  639546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  639554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  639557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  639560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639589 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  639589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  639608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639611 */     GIR_RootConstrainSelectedInstOperands,
     /*  639612 */     // GIR_Coverage, 6693,
     /*  639612 */     GIR_EraseRootFromParent_Done,
     /*  639613 */   // Label 10280: @639613
     /*  639613 */   GIM_Try, /*On fail goto*//*Label 10281*/ GIMT_Encode4(639688), // Rule ID 6696 //
     /*  639618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  639629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  639632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  639635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639664 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  639667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639686 */     GIR_RootConstrainSelectedInstOperands,
     /*  639687 */     // GIR_Coverage, 6696,
     /*  639687 */     GIR_EraseRootFromParent_Done,
     /*  639688 */   // Label 10281: @639688
     /*  639688 */   GIM_Try, /*On fail goto*//*Label 10282*/ GIMT_Encode4(639763), // Rule ID 6697 //
     /*  639693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  639704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  639707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  639710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639739 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  639742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639761 */     GIR_RootConstrainSelectedInstOperands,
     /*  639762 */     // GIR_Coverage, 6697,
     /*  639762 */     GIR_EraseRootFromParent_Done,
     /*  639763 */   // Label 10282: @639763
     /*  639763 */   GIM_Try, /*On fail goto*//*Label 10283*/ GIMT_Encode4(639838), // Rule ID 6700 //
     /*  639768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  639779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  639782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  639785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639814 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  639817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639836 */     GIR_RootConstrainSelectedInstOperands,
     /*  639837 */     // GIR_Coverage, 6700,
     /*  639837 */     GIR_EraseRootFromParent_Done,
     /*  639838 */   // Label 10283: @639838
     /*  639838 */   GIM_Try, /*On fail goto*//*Label 10284*/ GIMT_Encode4(639913), // Rule ID 6701 //
     /*  639843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  639854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  639857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  639860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639889 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  639892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639911 */     GIR_RootConstrainSelectedInstOperands,
     /*  639912 */     // GIR_Coverage, 6701,
     /*  639912 */     GIR_EraseRootFromParent_Done,
     /*  639913 */   // Label 10284: @639913
     /*  639913 */   GIM_Try, /*On fail goto*//*Label 10285*/ GIMT_Encode4(639988), // Rule ID 6704 //
     /*  639918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  639929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  639932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  639935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639964 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  639967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639986 */     GIR_RootConstrainSelectedInstOperands,
     /*  639987 */     // GIR_Coverage, 6704,
     /*  639987 */     GIR_EraseRootFromParent_Done,
     /*  639988 */   // Label 10285: @639988
     /*  639988 */   GIM_Try, /*On fail goto*//*Label 10286*/ GIMT_Encode4(640063), // Rule ID 6705 //
     /*  639993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  640004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  640007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  640010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640039 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640061 */     GIR_RootConstrainSelectedInstOperands,
     /*  640062 */     // GIR_Coverage, 6705,
     /*  640062 */     GIR_EraseRootFromParent_Done,
     /*  640063 */   // Label 10286: @640063
     /*  640063 */   GIM_Try, /*On fail goto*//*Label 10287*/ GIMT_Encode4(640138), // Rule ID 6708 //
     /*  640068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640136 */     GIR_RootConstrainSelectedInstOperands,
     /*  640137 */     // GIR_Coverage, 6708,
     /*  640137 */     GIR_EraseRootFromParent_Done,
     /*  640138 */   // Label 10287: @640138
     /*  640138 */   GIM_Try, /*On fail goto*//*Label 10288*/ GIMT_Encode4(640213), // Rule ID 6709 //
     /*  640143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640189 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640211 */     GIR_RootConstrainSelectedInstOperands,
     /*  640212 */     // GIR_Coverage, 6709,
     /*  640212 */     GIR_EraseRootFromParent_Done,
     /*  640213 */   // Label 10288: @640213
     /*  640213 */   GIM_Try, /*On fail goto*//*Label 10289*/ GIMT_Encode4(640288), // Rule ID 6712 //
     /*  640218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640264 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640286 */     GIR_RootConstrainSelectedInstOperands,
     /*  640287 */     // GIR_Coverage, 6712,
     /*  640287 */     GIR_EraseRootFromParent_Done,
     /*  640288 */   // Label 10289: @640288
     /*  640288 */   GIM_Try, /*On fail goto*//*Label 10290*/ GIMT_Encode4(640363), // Rule ID 6713 //
     /*  640293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640339 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640361 */     GIR_RootConstrainSelectedInstOperands,
     /*  640362 */     // GIR_Coverage, 6713,
     /*  640362 */     GIR_EraseRootFromParent_Done,
     /*  640363 */   // Label 10290: @640363
     /*  640363 */   GIM_Try, /*On fail goto*//*Label 10291*/ GIMT_Encode4(640438), // Rule ID 6716 //
     /*  640368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640414 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640436 */     GIR_RootConstrainSelectedInstOperands,
     /*  640437 */     // GIR_Coverage, 6716,
     /*  640437 */     GIR_EraseRootFromParent_Done,
     /*  640438 */   // Label 10291: @640438
     /*  640438 */   GIM_Try, /*On fail goto*//*Label 10292*/ GIMT_Encode4(640513), // Rule ID 6717 //
     /*  640443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640489 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640511 */     GIR_RootConstrainSelectedInstOperands,
     /*  640512 */     // GIR_Coverage, 6717,
     /*  640512 */     GIR_EraseRootFromParent_Done,
     /*  640513 */   // Label 10292: @640513
     /*  640513 */   GIM_Try, /*On fail goto*//*Label 10293*/ GIMT_Encode4(640588), // Rule ID 6720 //
     /*  640518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  640529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  640532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  640535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  640564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640586 */     GIR_RootConstrainSelectedInstOperands,
     /*  640587 */     // GIR_Coverage, 6720,
     /*  640587 */     GIR_EraseRootFromParent_Done,
     /*  640588 */   // Label 10293: @640588
     /*  640588 */   GIM_Try, /*On fail goto*//*Label 10294*/ GIMT_Encode4(640663), // Rule ID 6721 //
     /*  640593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  640604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  640607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  640610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  640639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640661 */     GIR_RootConstrainSelectedInstOperands,
     /*  640662 */     // GIR_Coverage, 6721,
     /*  640662 */     GIR_EraseRootFromParent_Done,
     /*  640663 */   // Label 10294: @640663
     /*  640663 */   GIM_Try, /*On fail goto*//*Label 10295*/ GIMT_Encode4(640738), // Rule ID 6724 //
     /*  640668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  640679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  640682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  640685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640714 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  640714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640736 */     GIR_RootConstrainSelectedInstOperands,
     /*  640737 */     // GIR_Coverage, 6724,
     /*  640737 */     GIR_EraseRootFromParent_Done,
     /*  640738 */   // Label 10295: @640738
     /*  640738 */   GIM_Try, /*On fail goto*//*Label 10296*/ GIMT_Encode4(640813), // Rule ID 6725 //
     /*  640743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  640754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  640757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  640760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640789 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  640789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640811 */     GIR_RootConstrainSelectedInstOperands,
     /*  640812 */     // GIR_Coverage, 6725,
     /*  640812 */     GIR_EraseRootFromParent_Done,
     /*  640813 */   // Label 10296: @640813
     /*  640813 */   GIM_Try, /*On fail goto*//*Label 10297*/ GIMT_Encode4(640888), // Rule ID 6728 //
     /*  640818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  640829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  640832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  640835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  640864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640886 */     GIR_RootConstrainSelectedInstOperands,
     /*  640887 */     // GIR_Coverage, 6728,
     /*  640887 */     GIR_EraseRootFromParent_Done,
     /*  640888 */   // Label 10297: @640888
     /*  640888 */   GIM_Try, /*On fail goto*//*Label 10298*/ GIMT_Encode4(640963), // Rule ID 6729 //
     /*  640893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  640904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  640907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  640910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640939 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  640939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640961 */     GIR_RootConstrainSelectedInstOperands,
     /*  640962 */     // GIR_Coverage, 6729,
     /*  640962 */     GIR_EraseRootFromParent_Done,
     /*  640963 */   // Label 10298: @640963
     /*  640963 */   GIM_Try, /*On fail goto*//*Label 10299*/ GIMT_Encode4(641038), // Rule ID 6732 //
     /*  640968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  640971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  640979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  640982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  640985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  641017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641036 */     GIR_RootConstrainSelectedInstOperands,
     /*  641037 */     // GIR_Coverage, 6732,
     /*  641037 */     GIR_EraseRootFromParent_Done,
     /*  641038 */   // Label 10299: @641038
     /*  641038 */   GIM_Try, /*On fail goto*//*Label 10300*/ GIMT_Encode4(641113), // Rule ID 6733 //
     /*  641043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  641054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  641057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  641060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641089 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11567:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  641092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641111 */     GIR_RootConstrainSelectedInstOperands,
     /*  641112 */     // GIR_Coverage, 6733,
     /*  641112 */     GIR_EraseRootFromParent_Done,
     /*  641113 */   // Label 10300: @641113
     /*  641113 */   GIM_Try, /*On fail goto*//*Label 10301*/ GIMT_Encode4(641188), // Rule ID 6736 //
     /*  641118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641164 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  641167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641186 */     GIR_RootConstrainSelectedInstOperands,
     /*  641187 */     // GIR_Coverage, 6736,
     /*  641187 */     GIR_EraseRootFromParent_Done,
     /*  641188 */   // Label 10301: @641188
     /*  641188 */   GIM_Try, /*On fail goto*//*Label 10302*/ GIMT_Encode4(641263), // Rule ID 6737 //
     /*  641193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641239 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11567:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  641242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641261 */     GIR_RootConstrainSelectedInstOperands,
     /*  641262 */     // GIR_Coverage, 6737,
     /*  641262 */     GIR_EraseRootFromParent_Done,
     /*  641263 */   // Label 10302: @641263
     /*  641263 */   GIM_Try, /*On fail goto*//*Label 10303*/ GIMT_Encode4(641338), // Rule ID 6740 //
     /*  641268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641314 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  641317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641336 */     GIR_RootConstrainSelectedInstOperands,
     /*  641337 */     // GIR_Coverage, 6740,
     /*  641337 */     GIR_EraseRootFromParent_Done,
     /*  641338 */   // Label 10303: @641338
     /*  641338 */   GIM_Try, /*On fail goto*//*Label 10304*/ GIMT_Encode4(641413), // Rule ID 6741 //
     /*  641343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641389 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11567:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  641392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641411 */     GIR_RootConstrainSelectedInstOperands,
     /*  641412 */     // GIR_Coverage, 6741,
     /*  641412 */     GIR_EraseRootFromParent_Done,
     /*  641413 */   // Label 10304: @641413
     /*  641413 */   GIM_Try, /*On fail goto*//*Label 10305*/ GIMT_Encode4(641488), // Rule ID 6832 //
     /*  641418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  641429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  641432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  641435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  641438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641464 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  641467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641486 */     GIR_RootConstrainSelectedInstOperands,
     /*  641487 */     // GIR_Coverage, 6832,
     /*  641487 */     GIR_EraseRootFromParent_Done,
     /*  641488 */   // Label 10305: @641488
     /*  641488 */   GIM_Try, /*On fail goto*//*Label 10306*/ GIMT_Encode4(641563), // Rule ID 6833 //
     /*  641493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  641504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  641507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  641510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  641513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641539 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  641539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  641542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641561 */     GIR_RootConstrainSelectedInstOperands,
     /*  641562 */     // GIR_Coverage, 6833,
     /*  641562 */     GIR_EraseRootFromParent_Done,
     /*  641563 */   // Label 10306: @641563
     /*  641563 */   GIM_Try, /*On fail goto*//*Label 10307*/ GIMT_Encode4(641638), // Rule ID 6836 //
     /*  641568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  641579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  641582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  641585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  641588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641614 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  641617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641636 */     GIR_RootConstrainSelectedInstOperands,
     /*  641637 */     // GIR_Coverage, 6836,
     /*  641637 */     GIR_EraseRootFromParent_Done,
     /*  641638 */   // Label 10307: @641638
     /*  641638 */   GIM_Try, /*On fail goto*//*Label 10308*/ GIMT_Encode4(641713), // Rule ID 6837 //
     /*  641643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  641654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  641657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  641660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  641663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641689 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  641689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  641692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641711 */     GIR_RootConstrainSelectedInstOperands,
     /*  641712 */     // GIR_Coverage, 6837,
     /*  641712 */     GIR_EraseRootFromParent_Done,
     /*  641713 */   // Label 10308: @641713
     /*  641713 */   GIM_Try, /*On fail goto*//*Label 10309*/ GIMT_Encode4(641788), // Rule ID 6840 //
     /*  641718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  641729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  641732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  641735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  641738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641764 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  641767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641786 */     GIR_RootConstrainSelectedInstOperands,
     /*  641787 */     // GIR_Coverage, 6840,
     /*  641787 */     GIR_EraseRootFromParent_Done,
     /*  641788 */   // Label 10309: @641788
     /*  641788 */   GIM_Try, /*On fail goto*//*Label 10310*/ GIMT_Encode4(641863), // Rule ID 6841 //
     /*  641793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  641804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  641807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  641810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  641813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641839 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  641839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  641842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641861 */     GIR_RootConstrainSelectedInstOperands,
     /*  641862 */     // GIR_Coverage, 6841,
     /*  641862 */     GIR_EraseRootFromParent_Done,
     /*  641863 */   // Label 10310: @641863
     /*  641863 */   GIM_Try, /*On fail goto*//*Label 10311*/ GIMT_Encode4(641938), // Rule ID 6844 //
     /*  641868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  641879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  641882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  641885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  641888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641914 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  641914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  641917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  641933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641936 */     GIR_RootConstrainSelectedInstOperands,
     /*  641937 */     // GIR_Coverage, 6844,
     /*  641937 */     GIR_EraseRootFromParent_Done,
     /*  641938 */   // Label 10311: @641938
     /*  641938 */   GIM_Try, /*On fail goto*//*Label 10312*/ GIMT_Encode4(642013), // Rule ID 6845 //
     /*  641943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  641954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  641957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  641960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  641963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641989 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  641989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  641992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642011 */     GIR_RootConstrainSelectedInstOperands,
     /*  642012 */     // GIR_Coverage, 6845,
     /*  642012 */     GIR_EraseRootFromParent_Done,
     /*  642013 */   // Label 10312: @642013
     /*  642013 */   GIM_Try, /*On fail goto*//*Label 10313*/ GIMT_Encode4(642088), // Rule ID 6848 //
     /*  642018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  642038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642064 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642086 */     GIR_RootConstrainSelectedInstOperands,
     /*  642087 */     // GIR_Coverage, 6848,
     /*  642087 */     GIR_EraseRootFromParent_Done,
     /*  642088 */   // Label 10313: @642088
     /*  642088 */   GIM_Try, /*On fail goto*//*Label 10314*/ GIMT_Encode4(642163), // Rule ID 6849 //
     /*  642093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  642113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642139 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642161 */     GIR_RootConstrainSelectedInstOperands,
     /*  642162 */     // GIR_Coverage, 6849,
     /*  642162 */     GIR_EraseRootFromParent_Done,
     /*  642163 */   // Label 10314: @642163
     /*  642163 */   GIM_Try, /*On fail goto*//*Label 10315*/ GIMT_Encode4(642238), // Rule ID 6852 //
     /*  642168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  642188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642214 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  642214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642236 */     GIR_RootConstrainSelectedInstOperands,
     /*  642237 */     // GIR_Coverage, 6852,
     /*  642237 */     GIR_EraseRootFromParent_Done,
     /*  642238 */   // Label 10315: @642238
     /*  642238 */   GIM_Try, /*On fail goto*//*Label 10316*/ GIMT_Encode4(642313), // Rule ID 6853 //
     /*  642243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  642263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642289 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  642289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642311 */     GIR_RootConstrainSelectedInstOperands,
     /*  642312 */     // GIR_Coverage, 6853,
     /*  642312 */     GIR_EraseRootFromParent_Done,
     /*  642313 */   // Label 10316: @642313
     /*  642313 */   GIM_Try, /*On fail goto*//*Label 10317*/ GIMT_Encode4(642388), // Rule ID 6856 //
     /*  642318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  642338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642364 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642386 */     GIR_RootConstrainSelectedInstOperands,
     /*  642387 */     // GIR_Coverage, 6856,
     /*  642387 */     GIR_EraseRootFromParent_Done,
     /*  642388 */   // Label 10317: @642388
     /*  642388 */   GIM_Try, /*On fail goto*//*Label 10318*/ GIMT_Encode4(642463), // Rule ID 6857 //
     /*  642393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  642413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642439 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642461 */     GIR_RootConstrainSelectedInstOperands,
     /*  642462 */     // GIR_Coverage, 6857,
     /*  642462 */     GIR_EraseRootFromParent_Done,
     /*  642463 */   // Label 10318: @642463
     /*  642463 */   GIM_Try, /*On fail goto*//*Label 10319*/ GIMT_Encode4(642538), // Rule ID 6860 //
     /*  642468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  642479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  642482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  642485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  642488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642514 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642536 */     GIR_RootConstrainSelectedInstOperands,
     /*  642537 */     // GIR_Coverage, 6860,
     /*  642537 */     GIR_EraseRootFromParent_Done,
     /*  642538 */   // Label 10319: @642538
     /*  642538 */   GIM_Try, /*On fail goto*//*Label 10320*/ GIMT_Encode4(642613), // Rule ID 6861 //
     /*  642543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  642554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  642557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  642560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  642563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642589 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642611 */     GIR_RootConstrainSelectedInstOperands,
     /*  642612 */     // GIR_Coverage, 6861,
     /*  642612 */     GIR_EraseRootFromParent_Done,
     /*  642613 */   // Label 10320: @642613
     /*  642613 */   GIM_Try, /*On fail goto*//*Label 10321*/ GIMT_Encode4(642688), // Rule ID 6864 //
     /*  642618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  642629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  642632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  642635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  642638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642664 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  642664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642686 */     GIR_RootConstrainSelectedInstOperands,
     /*  642687 */     // GIR_Coverage, 6864,
     /*  642687 */     GIR_EraseRootFromParent_Done,
     /*  642688 */   // Label 10321: @642688
     /*  642688 */   GIM_Try, /*On fail goto*//*Label 10322*/ GIMT_Encode4(642763), // Rule ID 6865 //
     /*  642693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  642704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  642707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  642710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  642713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642739 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  642739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642761 */     GIR_RootConstrainSelectedInstOperands,
     /*  642762 */     // GIR_Coverage, 6865,
     /*  642762 */     GIR_EraseRootFromParent_Done,
     /*  642763 */   // Label 10322: @642763
     /*  642763 */   GIM_Try, /*On fail goto*//*Label 10323*/ GIMT_Encode4(642838), // Rule ID 6868 //
     /*  642768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  642771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  642779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  642782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  642785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  642788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642814 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  642814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  642833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642836 */     GIR_RootConstrainSelectedInstOperands,
     /*  642837 */     // GIR_Coverage, 6868,
     /*  642837 */     GIR_EraseRootFromParent_Done,
     /*  642838 */   // Label 10323: @642838
     /*  642838 */   GIM_Try, /*On fail goto*//*Label 10324*/ GIMT_Encode4(642913), // Rule ID 6869 //
     /*  642843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  642846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  642854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  642857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  642860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  642863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642889 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  642889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  642908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642911 */     GIR_RootConstrainSelectedInstOperands,
     /*  642912 */     // GIR_Coverage, 6869,
     /*  642912 */     GIR_EraseRootFromParent_Done,
     /*  642913 */   // Label 10324: @642913
     /*  642913 */   GIM_Try, /*On fail goto*//*Label 10325*/ GIMT_Encode4(642988), // Rule ID 6872 //
     /*  642918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  642929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  642932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  642935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  642938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642964 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  642967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642986 */     GIR_RootConstrainSelectedInstOperands,
     /*  642987 */     // GIR_Coverage, 6872,
     /*  642987 */     GIR_EraseRootFromParent_Done,
     /*  642988 */   // Label 10325: @642988
     /*  642988 */   GIM_Try, /*On fail goto*//*Label 10326*/ GIMT_Encode4(643063), // Rule ID 6873 //
     /*  642993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  643004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  643007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  643010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  643013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643039 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643061 */     GIR_RootConstrainSelectedInstOperands,
     /*  643062 */     // GIR_Coverage, 6873,
     /*  643062 */     GIR_EraseRootFromParent_Done,
     /*  643063 */   // Label 10326: @643063
     /*  643063 */   GIM_Try, /*On fail goto*//*Label 10327*/ GIMT_Encode4(643138), // Rule ID 6876 //
     /*  643068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  643088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643114 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643136 */     GIR_RootConstrainSelectedInstOperands,
     /*  643137 */     // GIR_Coverage, 6876,
     /*  643137 */     GIR_EraseRootFromParent_Done,
     /*  643138 */   // Label 10327: @643138
     /*  643138 */   GIM_Try, /*On fail goto*//*Label 10328*/ GIMT_Encode4(643213), // Rule ID 6877 //
     /*  643143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  643163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643189 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643211 */     GIR_RootConstrainSelectedInstOperands,
     /*  643212 */     // GIR_Coverage, 6877,
     /*  643212 */     GIR_EraseRootFromParent_Done,
     /*  643213 */   // Label 10328: @643213
     /*  643213 */   GIM_Try, /*On fail goto*//*Label 10329*/ GIMT_Encode4(643288), // Rule ID 6880 //
     /*  643218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  643238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643264 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643286 */     GIR_RootConstrainSelectedInstOperands,
     /*  643287 */     // GIR_Coverage, 6880,
     /*  643287 */     GIR_EraseRootFromParent_Done,
     /*  643288 */   // Label 10329: @643288
     /*  643288 */   GIM_Try, /*On fail goto*//*Label 10330*/ GIMT_Encode4(643363), // Rule ID 6881 //
     /*  643293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  643313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643339 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643361 */     GIR_RootConstrainSelectedInstOperands,
     /*  643362 */     // GIR_Coverage, 6881,
     /*  643362 */     GIR_EraseRootFromParent_Done,
     /*  643363 */   // Label 10330: @643363
     /*  643363 */   GIM_Try, /*On fail goto*//*Label 10331*/ GIMT_Encode4(643438), // Rule ID 6884 //
     /*  643368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  643388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643414 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643436 */     GIR_RootConstrainSelectedInstOperands,
     /*  643437 */     // GIR_Coverage, 6884,
     /*  643437 */     GIR_EraseRootFromParent_Done,
     /*  643438 */   // Label 10331: @643438
     /*  643438 */   GIM_Try, /*On fail goto*//*Label 10332*/ GIMT_Encode4(643513), // Rule ID 6885 //
     /*  643443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  643463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643489 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643511 */     GIR_RootConstrainSelectedInstOperands,
     /*  643512 */     // GIR_Coverage, 6885,
     /*  643512 */     GIR_EraseRootFromParent_Done,
     /*  643513 */   // Label 10332: @643513
     /*  643513 */   GIM_Try, /*On fail goto*//*Label 10333*/ GIMT_Encode4(643588), // Rule ID 6888 //
     /*  643518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  643529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  643532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  643535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  643538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643564 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643586 */     GIR_RootConstrainSelectedInstOperands,
     /*  643587 */     // GIR_Coverage, 6888,
     /*  643587 */     GIR_EraseRootFromParent_Done,
     /*  643588 */   // Label 10333: @643588
     /*  643588 */   GIM_Try, /*On fail goto*//*Label 10334*/ GIMT_Encode4(643663), // Rule ID 6889 //
     /*  643593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  643604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  643607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  643610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  643613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643639 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643661 */     GIR_RootConstrainSelectedInstOperands,
     /*  643662 */     // GIR_Coverage, 6889,
     /*  643662 */     GIR_EraseRootFromParent_Done,
     /*  643663 */   // Label 10334: @643663
     /*  643663 */   GIM_Try, /*On fail goto*//*Label 10335*/ GIMT_Encode4(643738), // Rule ID 6892 //
     /*  643668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  643679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  643682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  643685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  643688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643714 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643736 */     GIR_RootConstrainSelectedInstOperands,
     /*  643737 */     // GIR_Coverage, 6892,
     /*  643737 */     GIR_EraseRootFromParent_Done,
     /*  643738 */   // Label 10335: @643738
     /*  643738 */   GIM_Try, /*On fail goto*//*Label 10336*/ GIMT_Encode4(643813), // Rule ID 6893 //
     /*  643743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  643754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  643757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  643760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  643763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643789 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643811 */     GIR_RootConstrainSelectedInstOperands,
     /*  643812 */     // GIR_Coverage, 6893,
     /*  643812 */     GIR_EraseRootFromParent_Done,
     /*  643813 */   // Label 10336: @643813
     /*  643813 */   GIM_Try, /*On fail goto*//*Label 10337*/ GIMT_Encode4(643888), // Rule ID 6896 //
     /*  643818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  643829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  643832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  643835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  643838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  643864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643886 */     GIR_RootConstrainSelectedInstOperands,
     /*  643887 */     // GIR_Coverage, 6896,
     /*  643887 */     GIR_EraseRootFromParent_Done,
     /*  643888 */   // Label 10337: @643888
     /*  643888 */   GIM_Try, /*On fail goto*//*Label 10338*/ GIMT_Encode4(643963), // Rule ID 6897 //
     /*  643893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  643904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  643907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  643910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  643913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643939 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  643939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643961 */     GIR_RootConstrainSelectedInstOperands,
     /*  643962 */     // GIR_Coverage, 6897,
     /*  643962 */     GIR_EraseRootFromParent_Done,
     /*  643963 */   // Label 10338: @643963
     /*  643963 */   GIM_Try, /*On fail goto*//*Label 10339*/ GIMT_Encode4(644038), // Rule ID 6900 //
     /*  643968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  643979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  643982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  643985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  643988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644014 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644036 */     GIR_RootConstrainSelectedInstOperands,
     /*  644037 */     // GIR_Coverage, 6900,
     /*  644037 */     GIR_EraseRootFromParent_Done,
     /*  644038 */   // Label 10339: @644038
     /*  644038 */   GIM_Try, /*On fail goto*//*Label 10340*/ GIMT_Encode4(644113), // Rule ID 6901 //
     /*  644043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  644054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  644057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  644060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  644063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644089 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644111 */     GIR_RootConstrainSelectedInstOperands,
     /*  644112 */     // GIR_Coverage, 6901,
     /*  644112 */     GIR_EraseRootFromParent_Done,
     /*  644113 */   // Label 10340: @644113
     /*  644113 */   GIM_Try, /*On fail goto*//*Label 10341*/ GIMT_Encode4(644188), // Rule ID 6904 //
     /*  644118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  644138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644164 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644186 */     GIR_RootConstrainSelectedInstOperands,
     /*  644187 */     // GIR_Coverage, 6904,
     /*  644187 */     GIR_EraseRootFromParent_Done,
     /*  644188 */   // Label 10341: @644188
     /*  644188 */   GIM_Try, /*On fail goto*//*Label 10342*/ GIMT_Encode4(644263), // Rule ID 6905 //
     /*  644193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  644213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644239 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644261 */     GIR_RootConstrainSelectedInstOperands,
     /*  644262 */     // GIR_Coverage, 6905,
     /*  644262 */     GIR_EraseRootFromParent_Done,
     /*  644263 */   // Label 10342: @644263
     /*  644263 */   GIM_Try, /*On fail goto*//*Label 10343*/ GIMT_Encode4(644338), // Rule ID 6908 //
     /*  644268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  644288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  644317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644336 */     GIR_RootConstrainSelectedInstOperands,
     /*  644337 */     // GIR_Coverage, 6908,
     /*  644337 */     GIR_EraseRootFromParent_Done,
     /*  644338 */   // Label 10343: @644338
     /*  644338 */   GIM_Try, /*On fail goto*//*Label 10344*/ GIMT_Encode4(644413), // Rule ID 6909 //
     /*  644343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  644363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644389 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  644392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644411 */     GIR_RootConstrainSelectedInstOperands,
     /*  644412 */     // GIR_Coverage, 6909,
     /*  644412 */     GIR_EraseRootFromParent_Done,
     /*  644413 */   // Label 10344: @644413
     /*  644413 */   GIM_Try, /*On fail goto*//*Label 10345*/ GIMT_Encode4(644488), // Rule ID 6912 //
     /*  644418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  644429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  644432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  644435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  644438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644464 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644486 */     GIR_RootConstrainSelectedInstOperands,
     /*  644487 */     // GIR_Coverage, 6912,
     /*  644487 */     GIR_EraseRootFromParent_Done,
     /*  644488 */   // Label 10345: @644488
     /*  644488 */   GIM_Try, /*On fail goto*//*Label 10346*/ GIMT_Encode4(644563), // Rule ID 6913 //
     /*  644493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  644504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  644507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  644510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  644513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644539 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644561 */     GIR_RootConstrainSelectedInstOperands,
     /*  644562 */     // GIR_Coverage, 6913,
     /*  644562 */     GIR_EraseRootFromParent_Done,
     /*  644563 */   // Label 10346: @644563
     /*  644563 */   GIM_Try, /*On fail goto*//*Label 10347*/ GIMT_Encode4(644638), // Rule ID 6916 //
     /*  644568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  644579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  644582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  644585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  644588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644614 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644636 */     GIR_RootConstrainSelectedInstOperands,
     /*  644637 */     // GIR_Coverage, 6916,
     /*  644637 */     GIR_EraseRootFromParent_Done,
     /*  644638 */   // Label 10347: @644638
     /*  644638 */   GIM_Try, /*On fail goto*//*Label 10348*/ GIMT_Encode4(644713), // Rule ID 6917 //
     /*  644643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  644654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  644657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  644660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  644663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644689 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644711 */     GIR_RootConstrainSelectedInstOperands,
     /*  644712 */     // GIR_Coverage, 6917,
     /*  644712 */     GIR_EraseRootFromParent_Done,
     /*  644713 */   // Label 10348: @644713
     /*  644713 */   GIM_Try, /*On fail goto*//*Label 10349*/ GIMT_Encode4(644788), // Rule ID 6920 //
     /*  644718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  644729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  644732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  644735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644764 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  644764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  644767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  644783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644786 */     GIR_RootConstrainSelectedInstOperands,
     /*  644787 */     // GIR_Coverage, 6920,
     /*  644787 */     GIR_EraseRootFromParent_Done,
     /*  644788 */   // Label 10349: @644788
     /*  644788 */   GIM_Try, /*On fail goto*//*Label 10350*/ GIMT_Encode4(644863), // Rule ID 6921 //
     /*  644793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  644804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  644807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  644810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644839 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  644839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  644842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  644858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644861 */     GIR_RootConstrainSelectedInstOperands,
     /*  644862 */     // GIR_Coverage, 6921,
     /*  644862 */     GIR_EraseRootFromParent_Done,
     /*  644863 */   // Label 10350: @644863
     /*  644863 */   GIM_Try, /*On fail goto*//*Label 10351*/ GIMT_Encode4(644938), // Rule ID 6924 //
     /*  644868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  644879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  644882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  644885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644914 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  644914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  644917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  644933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644936 */     GIR_RootConstrainSelectedInstOperands,
     /*  644937 */     // GIR_Coverage, 6924,
     /*  644937 */     GIR_EraseRootFromParent_Done,
     /*  644938 */   // Label 10351: @644938
     /*  644938 */   GIM_Try, /*On fail goto*//*Label 10352*/ GIMT_Encode4(645013), // Rule ID 6925 //
     /*  644943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  644954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  644957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  644960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644989 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  644989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  644992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645011 */     GIR_RootConstrainSelectedInstOperands,
     /*  645012 */     // GIR_Coverage, 6925,
     /*  645012 */     GIR_EraseRootFromParent_Done,
     /*  645013 */   // Label 10352: @645013
     /*  645013 */   GIM_Try, /*On fail goto*//*Label 10353*/ GIMT_Encode4(645088), // Rule ID 6928 //
     /*  645018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645064 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645086 */     GIR_RootConstrainSelectedInstOperands,
     /*  645087 */     // GIR_Coverage, 6928,
     /*  645087 */     GIR_EraseRootFromParent_Done,
     /*  645088 */   // Label 10353: @645088
     /*  645088 */   GIM_Try, /*On fail goto*//*Label 10354*/ GIMT_Encode4(645163), // Rule ID 6929 //
     /*  645093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645139 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645161 */     GIR_RootConstrainSelectedInstOperands,
     /*  645162 */     // GIR_Coverage, 6929,
     /*  645162 */     GIR_EraseRootFromParent_Done,
     /*  645163 */   // Label 10354: @645163
     /*  645163 */   GIM_Try, /*On fail goto*//*Label 10355*/ GIMT_Encode4(645238), // Rule ID 6932 //
     /*  645168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  645217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645236 */     GIR_RootConstrainSelectedInstOperands,
     /*  645237 */     // GIR_Coverage, 6932,
     /*  645237 */     GIR_EraseRootFromParent_Done,
     /*  645238 */   // Label 10355: @645238
     /*  645238 */   GIM_Try, /*On fail goto*//*Label 10356*/ GIMT_Encode4(645313), // Rule ID 6933 //
     /*  645243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645289 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  645292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645311 */     GIR_RootConstrainSelectedInstOperands,
     /*  645312 */     // GIR_Coverage, 6933,
     /*  645312 */     GIR_EraseRootFromParent_Done,
     /*  645313 */   // Label 10356: @645313
     /*  645313 */   GIM_Try, /*On fail goto*//*Label 10357*/ GIMT_Encode4(645388), // Rule ID 6936 //
     /*  645318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645364 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645386 */     GIR_RootConstrainSelectedInstOperands,
     /*  645387 */     // GIR_Coverage, 6936,
     /*  645387 */     GIR_EraseRootFromParent_Done,
     /*  645388 */   // Label 10357: @645388
     /*  645388 */   GIM_Try, /*On fail goto*//*Label 10358*/ GIMT_Encode4(645463), // Rule ID 6937 //
     /*  645393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645439 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645461 */     GIR_RootConstrainSelectedInstOperands,
     /*  645462 */     // GIR_Coverage, 6937,
     /*  645462 */     GIR_EraseRootFromParent_Done,
     /*  645463 */   // Label 10358: @645463
     /*  645463 */   GIM_Try, /*On fail goto*//*Label 10359*/ GIMT_Encode4(645538), // Rule ID 6940 //
     /*  645468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  645479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  645482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  645485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645514 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  645514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  645533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645536 */     GIR_RootConstrainSelectedInstOperands,
     /*  645537 */     // GIR_Coverage, 6940,
     /*  645537 */     GIR_EraseRootFromParent_Done,
     /*  645538 */   // Label 10359: @645538
     /*  645538 */   GIM_Try, /*On fail goto*//*Label 10360*/ GIMT_Encode4(645613), // Rule ID 6941 //
     /*  645543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  645554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  645557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  645560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645589 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  645589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  645608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645611 */     GIR_RootConstrainSelectedInstOperands,
     /*  645612 */     // GIR_Coverage, 6941,
     /*  645612 */     GIR_EraseRootFromParent_Done,
     /*  645613 */   // Label 10360: @645613
     /*  645613 */   GIM_Try, /*On fail goto*//*Label 10361*/ GIMT_Encode4(645688), // Rule ID 6944 //
     /*  645618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  645629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  645632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  645635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645664 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645686 */     GIR_RootConstrainSelectedInstOperands,
     /*  645687 */     // GIR_Coverage, 6944,
     /*  645687 */     GIR_EraseRootFromParent_Done,
     /*  645688 */   // Label 10361: @645688
     /*  645688 */   GIM_Try, /*On fail goto*//*Label 10362*/ GIMT_Encode4(645763), // Rule ID 6945 //
     /*  645693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  645704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  645707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  645710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645739 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645761 */     GIR_RootConstrainSelectedInstOperands,
     /*  645762 */     // GIR_Coverage, 6945,
     /*  645762 */     GIR_EraseRootFromParent_Done,
     /*  645763 */   // Label 10362: @645763
     /*  645763 */   GIM_Try, /*On fail goto*//*Label 10363*/ GIMT_Encode4(645838), // Rule ID 6948 //
     /*  645768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  645779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  645782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  645785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645814 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645836 */     GIR_RootConstrainSelectedInstOperands,
     /*  645837 */     // GIR_Coverage, 6948,
     /*  645837 */     GIR_EraseRootFromParent_Done,
     /*  645838 */   // Label 10363: @645838
     /*  645838 */   GIM_Try, /*On fail goto*//*Label 10364*/ GIMT_Encode4(645913), // Rule ID 6949 //
     /*  645843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  645854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  645857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  645860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645889 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645911 */     GIR_RootConstrainSelectedInstOperands,
     /*  645912 */     // GIR_Coverage, 6949,
     /*  645912 */     GIR_EraseRootFromParent_Done,
     /*  645913 */   // Label 10364: @645913
     /*  645913 */   GIM_Try, /*On fail goto*//*Label 10365*/ GIMT_Encode4(645988), // Rule ID 6952 //
     /*  645918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  645929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  645932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  645935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645964 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  645964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  645983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645986 */     GIR_RootConstrainSelectedInstOperands,
     /*  645987 */     // GIR_Coverage, 6952,
     /*  645987 */     GIR_EraseRootFromParent_Done,
     /*  645988 */   // Label 10365: @645988
     /*  645988 */   GIM_Try, /*On fail goto*//*Label 10366*/ GIMT_Encode4(646063), // Rule ID 6953 //
     /*  645993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  646004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  646007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  646010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646039 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  646039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646061 */     GIR_RootConstrainSelectedInstOperands,
     /*  646062 */     // GIR_Coverage, 6953,
     /*  646062 */     GIR_EraseRootFromParent_Done,
     /*  646063 */   // Label 10366: @646063
     /*  646063 */   GIM_Try, /*On fail goto*//*Label 10367*/ GIMT_Encode4(646138), // Rule ID 6956 //
     /*  646068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  646071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646114 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  646114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646136 */     GIR_RootConstrainSelectedInstOperands,
     /*  646137 */     // GIR_Coverage, 6956,
     /*  646137 */     GIR_EraseRootFromParent_Done,
     /*  646138 */   // Label 10367: @646138
     /*  646138 */   GIM_Try, /*On fail goto*//*Label 10368*/ GIMT_Encode4(646213), // Rule ID 6957 //
     /*  646143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  646146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646189 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  646189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646211 */     GIR_RootConstrainSelectedInstOperands,
     /*  646212 */     // GIR_Coverage, 6957,
     /*  646212 */     GIR_EraseRootFromParent_Done,
     /*  646213 */   // Label 10368: @646213
     /*  646213 */   GIM_Try, /*On fail goto*//*Label 10369*/ GIMT_Encode4(646288), // Rule ID 6960 //
     /*  646218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646264 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646286 */     GIR_RootConstrainSelectedInstOperands,
     /*  646287 */     // GIR_Coverage, 6960,
     /*  646287 */     GIR_EraseRootFromParent_Done,
     /*  646288 */   // Label 10369: @646288
     /*  646288 */   GIM_Try, /*On fail goto*//*Label 10370*/ GIMT_Encode4(646363), // Rule ID 6961 //
     /*  646293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646339 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646361 */     GIR_RootConstrainSelectedInstOperands,
     /*  646362 */     // GIR_Coverage, 6961,
     /*  646362 */     GIR_EraseRootFromParent_Done,
     /*  646363 */   // Label 10370: @646363
     /*  646363 */   GIM_Try, /*On fail goto*//*Label 10371*/ GIMT_Encode4(646438), // Rule ID 6964 //
     /*  646368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646414 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646436 */     GIR_RootConstrainSelectedInstOperands,
     /*  646437 */     // GIR_Coverage, 6964,
     /*  646437 */     GIR_EraseRootFromParent_Done,
     /*  646438 */   // Label 10371: @646438
     /*  646438 */   GIM_Try, /*On fail goto*//*Label 10372*/ GIMT_Encode4(646513), // Rule ID 6965 //
     /*  646443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646489 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646511 */     GIR_RootConstrainSelectedInstOperands,
     /*  646512 */     // GIR_Coverage, 6965,
     /*  646512 */     GIR_EraseRootFromParent_Done,
     /*  646513 */   // Label 10372: @646513
     /*  646513 */   GIM_Try, /*On fail goto*//*Label 10373*/ GIMT_Encode4(646588), // Rule ID 6968 //
     /*  646518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  646529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  646532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  646535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646564 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  646567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646586 */     GIR_RootConstrainSelectedInstOperands,
     /*  646587 */     // GIR_Coverage, 6968,
     /*  646587 */     GIR_EraseRootFromParent_Done,
     /*  646588 */   // Label 10373: @646588
     /*  646588 */   GIM_Try, /*On fail goto*//*Label 10374*/ GIMT_Encode4(646663), // Rule ID 6969 //
     /*  646593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  646604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  646607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  646610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646639 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  646642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646661 */     GIR_RootConstrainSelectedInstOperands,
     /*  646662 */     // GIR_Coverage, 6969,
     /*  646662 */     GIR_EraseRootFromParent_Done,
     /*  646663 */   // Label 10374: @646663
     /*  646663 */   GIM_Try, /*On fail goto*//*Label 10375*/ GIMT_Encode4(646738), // Rule ID 6972 //
     /*  646668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  646679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  646682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  646685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  646714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646736 */     GIR_RootConstrainSelectedInstOperands,
     /*  646737 */     // GIR_Coverage, 6972,
     /*  646737 */     GIR_EraseRootFromParent_Done,
     /*  646738 */   // Label 10375: @646738
     /*  646738 */   GIM_Try, /*On fail goto*//*Label 10376*/ GIMT_Encode4(646813), // Rule ID 6973 //
     /*  646743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  646754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  646757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  646760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646789 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  646789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646811 */     GIR_RootConstrainSelectedInstOperands,
     /*  646812 */     // GIR_Coverage, 6973,
     /*  646812 */     GIR_EraseRootFromParent_Done,
     /*  646813 */   // Label 10376: @646813
     /*  646813 */   GIM_Try, /*On fail goto*//*Label 10377*/ GIMT_Encode4(646888), // Rule ID 6976 //
     /*  646818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  646829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  646832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  646835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646864 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  646864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646886 */     GIR_RootConstrainSelectedInstOperands,
     /*  646887 */     // GIR_Coverage, 6976,
     /*  646887 */     GIR_EraseRootFromParent_Done,
     /*  646888 */   // Label 10377: @646888
     /*  646888 */   GIM_Try, /*On fail goto*//*Label 10378*/ GIMT_Encode4(646963), // Rule ID 6977 //
     /*  646893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  646904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  646907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  646910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646939 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  646939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646961 */     GIR_RootConstrainSelectedInstOperands,
     /*  646962 */     // GIR_Coverage, 6977,
     /*  646962 */     GIR_EraseRootFromParent_Done,
     /*  646963 */   // Label 10378: @646963
     /*  646963 */   GIM_Try, /*On fail goto*//*Label 10379*/ GIMT_Encode4(647038), // Rule ID 6980 //
     /*  646968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  646979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  646982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  646985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647014 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647036 */     GIR_RootConstrainSelectedInstOperands,
     /*  647037 */     // GIR_Coverage, 6980,
     /*  647037 */     GIR_EraseRootFromParent_Done,
     /*  647038 */   // Label 10379: @647038
     /*  647038 */   GIM_Try, /*On fail goto*//*Label 10380*/ GIMT_Encode4(647113), // Rule ID 6981 //
     /*  647043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  647054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  647057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  647060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647089 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647111 */     GIR_RootConstrainSelectedInstOperands,
     /*  647112 */     // GIR_Coverage, 6981,
     /*  647112 */     GIR_EraseRootFromParent_Done,
     /*  647113 */   // Label 10380: @647113
     /*  647113 */   GIM_Try, /*On fail goto*//*Label 10381*/ GIMT_Encode4(647188), // Rule ID 6984 //
     /*  647118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647186 */     GIR_RootConstrainSelectedInstOperands,
     /*  647187 */     // GIR_Coverage, 6984,
     /*  647187 */     GIR_EraseRootFromParent_Done,
     /*  647188 */   // Label 10381: @647188
     /*  647188 */   GIM_Try, /*On fail goto*//*Label 10382*/ GIMT_Encode4(647263), // Rule ID 6985 //
     /*  647193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647261 */     GIR_RootConstrainSelectedInstOperands,
     /*  647262 */     // GIR_Coverage, 6985,
     /*  647262 */     GIR_EraseRootFromParent_Done,
     /*  647263 */   // Label 10382: @647263
     /*  647263 */   GIM_Try, /*On fail goto*//*Label 10383*/ GIMT_Encode4(647338), // Rule ID 6988 //
     /*  647268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647336 */     GIR_RootConstrainSelectedInstOperands,
     /*  647337 */     // GIR_Coverage, 6988,
     /*  647337 */     GIR_EraseRootFromParent_Done,
     /*  647338 */   // Label 10383: @647338
     /*  647338 */   GIM_Try, /*On fail goto*//*Label 10384*/ GIMT_Encode4(647413), // Rule ID 6989 //
     /*  647343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647389 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647411 */     GIR_RootConstrainSelectedInstOperands,
     /*  647412 */     // GIR_Coverage, 6989,
     /*  647412 */     GIR_EraseRootFromParent_Done,
     /*  647413 */   // Label 10384: @647413
     /*  647413 */   GIM_Try, /*On fail goto*//*Label 10385*/ GIMT_Encode4(647488), // Rule ID 6992 //
     /*  647418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  647429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  647432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  647435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647486 */     GIR_RootConstrainSelectedInstOperands,
     /*  647487 */     // GIR_Coverage, 6992,
     /*  647487 */     GIR_EraseRootFromParent_Done,
     /*  647488 */   // Label 10385: @647488
     /*  647488 */   GIM_Try, /*On fail goto*//*Label 10386*/ GIMT_Encode4(647563), // Rule ID 6993 //
     /*  647493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  647504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  647507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  647510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647539 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647561 */     GIR_RootConstrainSelectedInstOperands,
     /*  647562 */     // GIR_Coverage, 6993,
     /*  647562 */     GIR_EraseRootFromParent_Done,
     /*  647563 */   // Label 10386: @647563
     /*  647563 */   GIM_Try, /*On fail goto*//*Label 10387*/ GIMT_Encode4(647638), // Rule ID 6996 //
     /*  647568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  647571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  647579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  647582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  647585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647614 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  647614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647636 */     GIR_RootConstrainSelectedInstOperands,
     /*  647637 */     // GIR_Coverage, 6996,
     /*  647637 */     GIR_EraseRootFromParent_Done,
     /*  647638 */   // Label 10387: @647638
     /*  647638 */   GIM_Try, /*On fail goto*//*Label 10388*/ GIMT_Encode4(647713), // Rule ID 6997 //
     /*  647643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  647646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  647654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  647657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  647660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  647689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647711 */     GIR_RootConstrainSelectedInstOperands,
     /*  647712 */     // GIR_Coverage, 6997,
     /*  647712 */     GIR_EraseRootFromParent_Done,
     /*  647713 */   // Label 10388: @647713
     /*  647713 */   GIM_Try, /*On fail goto*//*Label 10389*/ GIMT_Encode4(647788), // Rule ID 7000 //
     /*  647718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  647721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  647729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  647732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  647735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647764 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  647764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647786 */     GIR_RootConstrainSelectedInstOperands,
     /*  647787 */     // GIR_Coverage, 7000,
     /*  647787 */     GIR_EraseRootFromParent_Done,
     /*  647788 */   // Label 10389: @647788
     /*  647788 */   GIM_Try, /*On fail goto*//*Label 10390*/ GIMT_Encode4(647863), // Rule ID 7001 //
     /*  647793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  647796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  647804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  647807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  647810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647839 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  647839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647861 */     GIR_RootConstrainSelectedInstOperands,
     /*  647862 */     // GIR_Coverage, 7001,
     /*  647862 */     GIR_EraseRootFromParent_Done,
     /*  647863 */   // Label 10390: @647863
     /*  647863 */   GIM_Try, /*On fail goto*//*Label 10391*/ GIMT_Encode4(647938), // Rule ID 7004 //
     /*  647868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  647871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  647879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  647882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  647885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647914 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  647914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647936 */     GIR_RootConstrainSelectedInstOperands,
     /*  647937 */     // GIR_Coverage, 7004,
     /*  647937 */     GIR_EraseRootFromParent_Done,
     /*  647938 */   // Label 10391: @647938
     /*  647938 */   GIM_Try, /*On fail goto*//*Label 10392*/ GIMT_Encode4(648013), // Rule ID 7005 //
     /*  647943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  647946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  647954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  647957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  647960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647989 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  647989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648011 */     GIR_RootConstrainSelectedInstOperands,
     /*  648012 */     // GIR_Coverage, 7005,
     /*  648012 */     GIR_EraseRootFromParent_Done,
     /*  648013 */   // Label 10392: @648013
     /*  648013 */   GIM_Try, /*On fail goto*//*Label 10393*/ GIMT_Encode4(648088), // Rule ID 7096 //
     /*  648018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  648029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  648032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  648038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648064 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  648067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648086 */     GIR_RootConstrainSelectedInstOperands,
     /*  648087 */     // GIR_Coverage, 7096,
     /*  648087 */     GIR_EraseRootFromParent_Done,
     /*  648088 */   // Label 10393: @648088
     /*  648088 */   GIM_Try, /*On fail goto*//*Label 10394*/ GIMT_Encode4(648163), // Rule ID 7097 //
     /*  648093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  648104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  648107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  648113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648139 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  648142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648161 */     GIR_RootConstrainSelectedInstOperands,
     /*  648162 */     // GIR_Coverage, 7097,
     /*  648162 */     GIR_EraseRootFromParent_Done,
     /*  648163 */   // Label 10394: @648163
     /*  648163 */   GIM_Try, /*On fail goto*//*Label 10395*/ GIMT_Encode4(648238), // Rule ID 7100 //
     /*  648168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  648179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  648182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  648188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648214 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648236 */     GIR_RootConstrainSelectedInstOperands,
     /*  648237 */     // GIR_Coverage, 7100,
     /*  648237 */     GIR_EraseRootFromParent_Done,
     /*  648238 */   // Label 10395: @648238
     /*  648238 */   GIM_Try, /*On fail goto*//*Label 10396*/ GIMT_Encode4(648313), // Rule ID 7101 //
     /*  648243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  648254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  648257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  648263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648289 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648311 */     GIR_RootConstrainSelectedInstOperands,
     /*  648312 */     // GIR_Coverage, 7101,
     /*  648312 */     GIR_EraseRootFromParent_Done,
     /*  648313 */   // Label 10396: @648313
     /*  648313 */   GIM_Try, /*On fail goto*//*Label 10397*/ GIMT_Encode4(648388), // Rule ID 7104 //
     /*  648318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  648329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  648332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  648338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648364 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648386 */     GIR_RootConstrainSelectedInstOperands,
     /*  648387 */     // GIR_Coverage, 7104,
     /*  648387 */     GIR_EraseRootFromParent_Done,
     /*  648388 */   // Label 10397: @648388
     /*  648388 */   GIM_Try, /*On fail goto*//*Label 10398*/ GIMT_Encode4(648463), // Rule ID 7105 //
     /*  648393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  648404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  648407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  648413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648439 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648461 */     GIR_RootConstrainSelectedInstOperands,
     /*  648462 */     // GIR_Coverage, 7105,
     /*  648462 */     GIR_EraseRootFromParent_Done,
     /*  648463 */   // Label 10398: @648463
     /*  648463 */   GIM_Try, /*On fail goto*//*Label 10399*/ GIMT_Encode4(648538), // Rule ID 7108 //
     /*  648468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  648479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  648482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  648485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  648488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648514 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  648514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648536 */     GIR_RootConstrainSelectedInstOperands,
     /*  648537 */     // GIR_Coverage, 7108,
     /*  648537 */     GIR_EraseRootFromParent_Done,
     /*  648538 */   // Label 10399: @648538
     /*  648538 */   GIM_Try, /*On fail goto*//*Label 10400*/ GIMT_Encode4(648613), // Rule ID 7109 //
     /*  648543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  648554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  648557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  648560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  648563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648589 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  648589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648611 */     GIR_RootConstrainSelectedInstOperands,
     /*  648612 */     // GIR_Coverage, 7109,
     /*  648612 */     GIR_EraseRootFromParent_Done,
     /*  648613 */   // Label 10400: @648613
     /*  648613 */   GIM_Try, /*On fail goto*//*Label 10401*/ GIMT_Encode4(648688), // Rule ID 7112 //
     /*  648618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  648629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  648632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  648635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  648638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648664 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  648664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648686 */     GIR_RootConstrainSelectedInstOperands,
     /*  648687 */     // GIR_Coverage, 7112,
     /*  648687 */     GIR_EraseRootFromParent_Done,
     /*  648688 */   // Label 10401: @648688
     /*  648688 */   GIM_Try, /*On fail goto*//*Label 10402*/ GIMT_Encode4(648763), // Rule ID 7113 //
     /*  648693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  648704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  648707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  648710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  648713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648739 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  648739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648761 */     GIR_RootConstrainSelectedInstOperands,
     /*  648762 */     // GIR_Coverage, 7113,
     /*  648762 */     GIR_EraseRootFromParent_Done,
     /*  648763 */   // Label 10402: @648763
     /*  648763 */   GIM_Try, /*On fail goto*//*Label 10403*/ GIMT_Encode4(648838), // Rule ID 7116 //
     /*  648768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  648779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  648782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  648785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  648788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  648814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648836 */     GIR_RootConstrainSelectedInstOperands,
     /*  648837 */     // GIR_Coverage, 7116,
     /*  648837 */     GIR_EraseRootFromParent_Done,
     /*  648838 */   // Label 10403: @648838
     /*  648838 */   GIM_Try, /*On fail goto*//*Label 10404*/ GIMT_Encode4(648913), // Rule ID 7117 //
     /*  648843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  648854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  648857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  648860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  648863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648889 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  648889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648911 */     GIR_RootConstrainSelectedInstOperands,
     /*  648912 */     // GIR_Coverage, 7117,
     /*  648912 */     GIR_EraseRootFromParent_Done,
     /*  648913 */   // Label 10404: @648913
     /*  648913 */   GIM_Try, /*On fail goto*//*Label 10405*/ GIMT_Encode4(648988), // Rule ID 7120 //
     /*  648918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  648929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  648932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  648935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  648938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648964 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  648967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648986 */     GIR_RootConstrainSelectedInstOperands,
     /*  648987 */     // GIR_Coverage, 7120,
     /*  648987 */     GIR_EraseRootFromParent_Done,
     /*  648988 */   // Label 10405: @648988
     /*  648988 */   GIM_Try, /*On fail goto*//*Label 10406*/ GIMT_Encode4(649063), // Rule ID 7121 //
     /*  648993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  649004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  649007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  649010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  649013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649039 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649061 */     GIR_RootConstrainSelectedInstOperands,
     /*  649062 */     // GIR_Coverage, 7121,
     /*  649062 */     GIR_EraseRootFromParent_Done,
     /*  649063 */   // Label 10406: @649063
     /*  649063 */   GIM_Try, /*On fail goto*//*Label 10407*/ GIMT_Encode4(649138), // Rule ID 7124 //
     /*  649068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  649079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  649082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  649088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649136 */     GIR_RootConstrainSelectedInstOperands,
     /*  649137 */     // GIR_Coverage, 7124,
     /*  649137 */     GIR_EraseRootFromParent_Done,
     /*  649138 */   // Label 10407: @649138
     /*  649138 */   GIM_Try, /*On fail goto*//*Label 10408*/ GIMT_Encode4(649213), // Rule ID 7125 //
     /*  649143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  649154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  649157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  649163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649189 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649211 */     GIR_RootConstrainSelectedInstOperands,
     /*  649212 */     // GIR_Coverage, 7125,
     /*  649212 */     GIR_EraseRootFromParent_Done,
     /*  649213 */   // Label 10408: @649213
     /*  649213 */   GIM_Try, /*On fail goto*//*Label 10409*/ GIMT_Encode4(649288), // Rule ID 7128 //
     /*  649218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  649235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  649238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  649264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649286 */     GIR_RootConstrainSelectedInstOperands,
     /*  649287 */     // GIR_Coverage, 7128,
     /*  649287 */     GIR_EraseRootFromParent_Done,
     /*  649288 */   // Label 10409: @649288
     /*  649288 */   GIM_Try, /*On fail goto*//*Label 10410*/ GIMT_Encode4(649363), // Rule ID 7129 //
     /*  649293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  649310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  649313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649339 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  649339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649361 */     GIR_RootConstrainSelectedInstOperands,
     /*  649362 */     // GIR_Coverage, 7129,
     /*  649362 */     GIR_EraseRootFromParent_Done,
     /*  649363 */   // Label 10410: @649363
     /*  649363 */   GIM_Try, /*On fail goto*//*Label 10411*/ GIMT_Encode4(649438), // Rule ID 7132 //
     /*  649368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  649371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  649379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  649382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  649385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  649388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  649414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  649433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649436 */     GIR_RootConstrainSelectedInstOperands,
     /*  649437 */     // GIR_Coverage, 7132,
     /*  649437 */     GIR_EraseRootFromParent_Done,
     /*  649438 */   // Label 10411: @649438
     /*  649438 */   GIM_Try, /*On fail goto*//*Label 10412*/ GIMT_Encode4(649513), // Rule ID 7133 //
     /*  649443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  649446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  649454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  649457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  649460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  649463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649489 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  649489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  649508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649511 */     GIR_RootConstrainSelectedInstOperands,
     /*  649512 */     // GIR_Coverage, 7133,
     /*  649512 */     GIR_EraseRootFromParent_Done,
     /*  649513 */   // Label 10412: @649513
     /*  649513 */   GIM_Try, /*On fail goto*//*Label 10413*/ GIMT_Encode4(649588), // Rule ID 7136 //
     /*  649518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  649529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  649532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  649535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  649538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649564 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  649567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649586 */     GIR_RootConstrainSelectedInstOperands,
     /*  649587 */     // GIR_Coverage, 7136,
     /*  649587 */     GIR_EraseRootFromParent_Done,
     /*  649588 */   // Label 10413: @649588
     /*  649588 */   GIM_Try, /*On fail goto*//*Label 10414*/ GIMT_Encode4(649663), // Rule ID 7137 //
     /*  649593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  649604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  649607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  649610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  649613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649639 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  649642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649661 */     GIR_RootConstrainSelectedInstOperands,
     /*  649662 */     // GIR_Coverage, 7137,
     /*  649662 */     GIR_EraseRootFromParent_Done,
     /*  649663 */   // Label 10414: @649663
     /*  649663 */   GIM_Try, /*On fail goto*//*Label 10415*/ GIMT_Encode4(649738), // Rule ID 7140 //
     /*  649668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  649679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  649682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  649685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  649688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649714 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  649717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649736 */     GIR_RootConstrainSelectedInstOperands,
     /*  649737 */     // GIR_Coverage, 7140,
     /*  649737 */     GIR_EraseRootFromParent_Done,
     /*  649738 */   // Label 10415: @649738
     /*  649738 */   GIM_Try, /*On fail goto*//*Label 10416*/ GIMT_Encode4(649813), // Rule ID 7141 //
     /*  649743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  649754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  649757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  649760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  649763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649789 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  649792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649811 */     GIR_RootConstrainSelectedInstOperands,
     /*  649812 */     // GIR_Coverage, 7141,
     /*  649812 */     GIR_EraseRootFromParent_Done,
     /*  649813 */   // Label 10416: @649813
     /*  649813 */   GIM_Try, /*On fail goto*//*Label 10417*/ GIMT_Encode4(649888), // Rule ID 7144 //
     /*  649818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  649829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  649832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  649835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  649838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649864 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  649867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649886 */     GIR_RootConstrainSelectedInstOperands,
     /*  649887 */     // GIR_Coverage, 7144,
     /*  649887 */     GIR_EraseRootFromParent_Done,
     /*  649888 */   // Label 10417: @649888
     /*  649888 */   GIM_Try, /*On fail goto*//*Label 10418*/ GIMT_Encode4(649963), // Rule ID 7145 //
     /*  649893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  649904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  649907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  649910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  649913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649939 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  649942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649961 */     GIR_RootConstrainSelectedInstOperands,
     /*  649962 */     // GIR_Coverage, 7145,
     /*  649962 */     GIR_EraseRootFromParent_Done,
     /*  649963 */   // Label 10418: @649963
     /*  649963 */   GIM_Try, /*On fail goto*//*Label 10419*/ GIMT_Encode4(650038), // Rule ID 7148 //
     /*  649968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  649979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  649982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  649985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  649988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650036 */     GIR_RootConstrainSelectedInstOperands,
     /*  650037 */     // GIR_Coverage, 7148,
     /*  650037 */     GIR_EraseRootFromParent_Done,
     /*  650038 */   // Label 10419: @650038
     /*  650038 */   GIM_Try, /*On fail goto*//*Label 10420*/ GIMT_Encode4(650113), // Rule ID 7149 //
     /*  650043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  650054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  650057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  650060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  650063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650111 */     GIR_RootConstrainSelectedInstOperands,
     /*  650112 */     // GIR_Coverage, 7149,
     /*  650112 */     GIR_EraseRootFromParent_Done,
     /*  650113 */   // Label 10420: @650113
     /*  650113 */   GIM_Try, /*On fail goto*//*Label 10421*/ GIMT_Encode4(650188), // Rule ID 7152 //
     /*  650118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  650129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  650132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  650135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  650138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650164 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650186 */     GIR_RootConstrainSelectedInstOperands,
     /*  650187 */     // GIR_Coverage, 7152,
     /*  650187 */     GIR_EraseRootFromParent_Done,
     /*  650188 */   // Label 10421: @650188
     /*  650188 */   GIM_Try, /*On fail goto*//*Label 10422*/ GIMT_Encode4(650263), // Rule ID 7153 //
     /*  650193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  650204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  650207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  650210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  650213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650239 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650261 */     GIR_RootConstrainSelectedInstOperands,
     /*  650262 */     // GIR_Coverage, 7153,
     /*  650262 */     GIR_EraseRootFromParent_Done,
     /*  650263 */   // Label 10422: @650263
     /*  650263 */   GIM_Try, /*On fail goto*//*Label 10423*/ GIMT_Encode4(650338), // Rule ID 7156 //
     /*  650268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  650279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  650282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  650285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  650288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650314 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650336 */     GIR_RootConstrainSelectedInstOperands,
     /*  650337 */     // GIR_Coverage, 7156,
     /*  650337 */     GIR_EraseRootFromParent_Done,
     /*  650338 */   // Label 10423: @650338
     /*  650338 */   GIM_Try, /*On fail goto*//*Label 10424*/ GIMT_Encode4(650413), // Rule ID 7157 //
     /*  650343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  650354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  650357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  650360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  650363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650389 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650411 */     GIR_RootConstrainSelectedInstOperands,
     /*  650412 */     // GIR_Coverage, 7157,
     /*  650412 */     GIR_EraseRootFromParent_Done,
     /*  650413 */   // Label 10424: @650413
     /*  650413 */   GIM_Try, /*On fail goto*//*Label 10425*/ GIMT_Encode4(650488), // Rule ID 7160 //
     /*  650418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  650429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  650432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  650435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  650438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650486 */     GIR_RootConstrainSelectedInstOperands,
     /*  650487 */     // GIR_Coverage, 7160,
     /*  650487 */     GIR_EraseRootFromParent_Done,
     /*  650488 */   // Label 10425: @650488
     /*  650488 */   GIM_Try, /*On fail goto*//*Label 10426*/ GIMT_Encode4(650563), // Rule ID 7161 //
     /*  650493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  650504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  650507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  650510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  650513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650539 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650561 */     GIR_RootConstrainSelectedInstOperands,
     /*  650562 */     // GIR_Coverage, 7161,
     /*  650562 */     GIR_EraseRootFromParent_Done,
     /*  650563 */   // Label 10426: @650563
     /*  650563 */   GIM_Try, /*On fail goto*//*Label 10427*/ GIMT_Encode4(650638), // Rule ID 7164 //
     /*  650568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  650579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  650582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  650585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  650588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650614 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650636 */     GIR_RootConstrainSelectedInstOperands,
     /*  650637 */     // GIR_Coverage, 7164,
     /*  650637 */     GIR_EraseRootFromParent_Done,
     /*  650638 */   // Label 10427: @650638
     /*  650638 */   GIM_Try, /*On fail goto*//*Label 10428*/ GIMT_Encode4(650713), // Rule ID 7165 //
     /*  650643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  650654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  650657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  650660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  650663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650689 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650711 */     GIR_RootConstrainSelectedInstOperands,
     /*  650712 */     // GIR_Coverage, 7165,
     /*  650712 */     GIR_EraseRootFromParent_Done,
     /*  650713 */   // Label 10428: @650713
     /*  650713 */   GIM_Try, /*On fail goto*//*Label 10429*/ GIMT_Encode4(650788), // Rule ID 7168 //
     /*  650718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  650729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  650732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  650735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  650738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650764 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650786 */     GIR_RootConstrainSelectedInstOperands,
     /*  650787 */     // GIR_Coverage, 7168,
     /*  650787 */     GIR_EraseRootFromParent_Done,
     /*  650788 */   // Label 10429: @650788
     /*  650788 */   GIM_Try, /*On fail goto*//*Label 10430*/ GIMT_Encode4(650863), // Rule ID 7169 //
     /*  650793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  650804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  650807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  650810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  650813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650839 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650861 */     GIR_RootConstrainSelectedInstOperands,
     /*  650862 */     // GIR_Coverage, 7169,
     /*  650862 */     GIR_EraseRootFromParent_Done,
     /*  650863 */   // Label 10430: @650863
     /*  650863 */   GIM_Try, /*On fail goto*//*Label 10431*/ GIMT_Encode4(650938), // Rule ID 7172 //
     /*  650868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  650871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  650879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  650882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  650885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  650888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  650914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  650933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650936 */     GIR_RootConstrainSelectedInstOperands,
     /*  650937 */     // GIR_Coverage, 7172,
     /*  650937 */     GIR_EraseRootFromParent_Done,
     /*  650938 */   // Label 10431: @650938
     /*  650938 */   GIM_Try, /*On fail goto*//*Label 10432*/ GIMT_Encode4(651013), // Rule ID 7173 //
     /*  650943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  650946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  650954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  650957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  650960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  650963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650989 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  650989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651011 */     GIR_RootConstrainSelectedInstOperands,
     /*  651012 */     // GIR_Coverage, 7173,
     /*  651012 */     GIR_EraseRootFromParent_Done,
     /*  651013 */   // Label 10432: @651013
     /*  651013 */   GIM_Try, /*On fail goto*//*Label 10433*/ GIMT_Encode4(651088), // Rule ID 7176 //
     /*  651018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  651029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  651032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  651035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  651038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  651067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651086 */     GIR_RootConstrainSelectedInstOperands,
     /*  651087 */     // GIR_Coverage, 7176,
     /*  651087 */     GIR_EraseRootFromParent_Done,
     /*  651088 */   // Label 10433: @651088
     /*  651088 */   GIM_Try, /*On fail goto*//*Label 10434*/ GIMT_Encode4(651163), // Rule ID 7177 //
     /*  651093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  651104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  651107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  651110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  651113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651139 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  651142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651161 */     GIR_RootConstrainSelectedInstOperands,
     /*  651162 */     // GIR_Coverage, 7177,
     /*  651162 */     GIR_EraseRootFromParent_Done,
     /*  651163 */   // Label 10434: @651163
     /*  651163 */   GIM_Try, /*On fail goto*//*Label 10435*/ GIMT_Encode4(651238), // Rule ID 7180 //
     /*  651168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  651179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  651182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  651185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  651188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  651217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651236 */     GIR_RootConstrainSelectedInstOperands,
     /*  651237 */     // GIR_Coverage, 7180,
     /*  651237 */     GIR_EraseRootFromParent_Done,
     /*  651238 */   // Label 10435: @651238
     /*  651238 */   GIM_Try, /*On fail goto*//*Label 10436*/ GIMT_Encode4(651313), // Rule ID 7181 //
     /*  651243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  651254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  651257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  651260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  651263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651289 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  651292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651311 */     GIR_RootConstrainSelectedInstOperands,
     /*  651312 */     // GIR_Coverage, 7181,
     /*  651312 */     GIR_EraseRootFromParent_Done,
     /*  651313 */   // Label 10436: @651313
     /*  651313 */   GIM_Try, /*On fail goto*//*Label 10437*/ GIMT_Encode4(651388), // Rule ID 7184 //
     /*  651318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  651329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  651332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  651335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651364 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  651367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651386 */     GIR_RootConstrainSelectedInstOperands,
     /*  651387 */     // GIR_Coverage, 7184,
     /*  651387 */     GIR_EraseRootFromParent_Done,
     /*  651388 */   // Label 10437: @651388
     /*  651388 */   GIM_Try, /*On fail goto*//*Label 10438*/ GIMT_Encode4(651463), // Rule ID 7185 //
     /*  651393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  651404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  651407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  651410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651439 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  651442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651461 */     GIR_RootConstrainSelectedInstOperands,
     /*  651462 */     // GIR_Coverage, 7185,
     /*  651462 */     GIR_EraseRootFromParent_Done,
     /*  651463 */   // Label 10438: @651463
     /*  651463 */   GIM_Try, /*On fail goto*//*Label 10439*/ GIMT_Encode4(651538), // Rule ID 7188 //
     /*  651468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  651479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  651482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  651485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651514 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  651517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651536 */     GIR_RootConstrainSelectedInstOperands,
     /*  651537 */     // GIR_Coverage, 7188,
     /*  651537 */     GIR_EraseRootFromParent_Done,
     /*  651538 */   // Label 10439: @651538
     /*  651538 */   GIM_Try, /*On fail goto*//*Label 10440*/ GIMT_Encode4(651613), // Rule ID 7189 //
     /*  651543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  651554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  651557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  651560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651589 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  651592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651611 */     GIR_RootConstrainSelectedInstOperands,
     /*  651612 */     // GIR_Coverage, 7189,
     /*  651612 */     GIR_EraseRootFromParent_Done,
     /*  651613 */   // Label 10440: @651613
     /*  651613 */   GIM_Try, /*On fail goto*//*Label 10441*/ GIMT_Encode4(651688), // Rule ID 7192 //
     /*  651618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  651629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  651632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  651635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651664 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  651667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651686 */     GIR_RootConstrainSelectedInstOperands,
     /*  651687 */     // GIR_Coverage, 7192,
     /*  651687 */     GIR_EraseRootFromParent_Done,
     /*  651688 */   // Label 10441: @651688
     /*  651688 */   GIM_Try, /*On fail goto*//*Label 10442*/ GIMT_Encode4(651763), // Rule ID 7193 //
     /*  651693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  651704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  651707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  651710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651739 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  651742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651761 */     GIR_RootConstrainSelectedInstOperands,
     /*  651762 */     // GIR_Coverage, 7193,
     /*  651762 */     GIR_EraseRootFromParent_Done,
     /*  651763 */   // Label 10442: @651763
     /*  651763 */   GIM_Try, /*On fail goto*//*Label 10443*/ GIMT_Encode4(651838), // Rule ID 7196 //
     /*  651768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  651779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  651782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  651785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651814 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  651814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  651817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651836 */     GIR_RootConstrainSelectedInstOperands,
     /*  651837 */     // GIR_Coverage, 7196,
     /*  651837 */     GIR_EraseRootFromParent_Done,
     /*  651838 */   // Label 10443: @651838
     /*  651838 */   GIM_Try, /*On fail goto*//*Label 10444*/ GIMT_Encode4(651913), // Rule ID 7197 //
     /*  651843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  651854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  651857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  651860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651889 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  651889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  651892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651911 */     GIR_RootConstrainSelectedInstOperands,
     /*  651912 */     // GIR_Coverage, 7197,
     /*  651912 */     GIR_EraseRootFromParent_Done,
     /*  651913 */   // Label 10444: @651913
     /*  651913 */   GIM_Try, /*On fail goto*//*Label 10445*/ GIMT_Encode4(651988), // Rule ID 7200 //
     /*  651918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  651929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  651932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  651935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  651964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  651967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651986 */     GIR_RootConstrainSelectedInstOperands,
     /*  651987 */     // GIR_Coverage, 7200,
     /*  651987 */     GIR_EraseRootFromParent_Done,
     /*  651988 */   // Label 10445: @651988
     /*  651988 */   GIM_Try, /*On fail goto*//*Label 10446*/ GIMT_Encode4(652063), // Rule ID 7201 //
     /*  651993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  652004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  652007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  652010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652039 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652061 */     GIR_RootConstrainSelectedInstOperands,
     /*  652062 */     // GIR_Coverage, 7201,
     /*  652062 */     GIR_EraseRootFromParent_Done,
     /*  652063 */   // Label 10446: @652063
     /*  652063 */   GIM_Try, /*On fail goto*//*Label 10447*/ GIMT_Encode4(652138), // Rule ID 7204 //
     /*  652068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  652079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  652082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652114 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  652114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652136 */     GIR_RootConstrainSelectedInstOperands,
     /*  652137 */     // GIR_Coverage, 7204,
     /*  652137 */     GIR_EraseRootFromParent_Done,
     /*  652138 */   // Label 10447: @652138
     /*  652138 */   GIM_Try, /*On fail goto*//*Label 10448*/ GIMT_Encode4(652213), // Rule ID 7205 //
     /*  652143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  652154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  652157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652189 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  652189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652211 */     GIR_RootConstrainSelectedInstOperands,
     /*  652212 */     // GIR_Coverage, 7205,
     /*  652212 */     GIR_EraseRootFromParent_Done,
     /*  652213 */   // Label 10448: @652213
     /*  652213 */   GIM_Try, /*On fail goto*//*Label 10449*/ GIMT_Encode4(652288), // Rule ID 7208 //
     /*  652218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  652229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  652232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  652235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652264 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652286 */     GIR_RootConstrainSelectedInstOperands,
     /*  652287 */     // GIR_Coverage, 7208,
     /*  652287 */     GIR_EraseRootFromParent_Done,
     /*  652288 */   // Label 10449: @652288
     /*  652288 */   GIM_Try, /*On fail goto*//*Label 10450*/ GIMT_Encode4(652363), // Rule ID 7209 //
     /*  652293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  652304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  652307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  652310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652339 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11593:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652361 */     GIR_RootConstrainSelectedInstOperands,
     /*  652362 */     // GIR_Coverage, 7209,
     /*  652362 */     GIR_EraseRootFromParent_Done,
     /*  652363 */   // Label 10450: @652363
     /*  652363 */   GIM_Try, /*On fail goto*//*Label 10451*/ GIMT_Encode4(652438), // Rule ID 7212 //
     /*  652368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  652379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  652382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  652385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652414 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652436 */     GIR_RootConstrainSelectedInstOperands,
     /*  652437 */     // GIR_Coverage, 7212,
     /*  652437 */     GIR_EraseRootFromParent_Done,
     /*  652438 */   // Label 10451: @652438
     /*  652438 */   GIM_Try, /*On fail goto*//*Label 10452*/ GIMT_Encode4(652513), // Rule ID 7213 //
     /*  652443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  652454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  652457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  652460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652489 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652511 */     GIR_RootConstrainSelectedInstOperands,
     /*  652512 */     // GIR_Coverage, 7213,
     /*  652512 */     GIR_EraseRootFromParent_Done,
     /*  652513 */   // Label 10452: @652513
     /*  652513 */   GIM_Try, /*On fail goto*//*Label 10453*/ GIMT_Encode4(652588), // Rule ID 7216 //
     /*  652518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  652529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  652532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  652535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  652564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652586 */     GIR_RootConstrainSelectedInstOperands,
     /*  652587 */     // GIR_Coverage, 7216,
     /*  652587 */     GIR_EraseRootFromParent_Done,
     /*  652588 */   // Label 10453: @652588
     /*  652588 */   GIM_Try, /*On fail goto*//*Label 10454*/ GIMT_Encode4(652663), // Rule ID 7217 //
     /*  652593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  652604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  652607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  652610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652639 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  652639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652661 */     GIR_RootConstrainSelectedInstOperands,
     /*  652662 */     // GIR_Coverage, 7217,
     /*  652662 */     GIR_EraseRootFromParent_Done,
     /*  652663 */   // Label 10454: @652663
     /*  652663 */   GIM_Try, /*On fail goto*//*Label 10455*/ GIMT_Encode4(652738), // Rule ID 7220 //
     /*  652668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  652671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  652679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  652682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  652685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652714 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  652714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  652733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652736 */     GIR_RootConstrainSelectedInstOperands,
     /*  652737 */     // GIR_Coverage, 7220,
     /*  652737 */     GIR_EraseRootFromParent_Done,
     /*  652738 */   // Label 10455: @652738
     /*  652738 */   GIM_Try, /*On fail goto*//*Label 10456*/ GIMT_Encode4(652813), // Rule ID 7221 //
     /*  652743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  652746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  652754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  652757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  652760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652789 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  652789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  652808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652811 */     GIR_RootConstrainSelectedInstOperands,
     /*  652812 */     // GIR_Coverage, 7221,
     /*  652812 */     GIR_EraseRootFromParent_Done,
     /*  652813 */   // Label 10456: @652813
     /*  652813 */   GIM_Try, /*On fail goto*//*Label 10457*/ GIMT_Encode4(652888), // Rule ID 7224 //
     /*  652818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  652829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  652832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  652835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  652867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652886 */     GIR_RootConstrainSelectedInstOperands,
     /*  652887 */     // GIR_Coverage, 7224,
     /*  652887 */     GIR_EraseRootFromParent_Done,
     /*  652888 */   // Label 10457: @652888
     /*  652888 */   GIM_Try, /*On fail goto*//*Label 10458*/ GIMT_Encode4(652963), // Rule ID 7225 //
     /*  652893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  652904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  652907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  652910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652939 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  652942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652961 */     GIR_RootConstrainSelectedInstOperands,
     /*  652962 */     // GIR_Coverage, 7225,
     /*  652962 */     GIR_EraseRootFromParent_Done,
     /*  652963 */   // Label 10458: @652963
     /*  652963 */   GIM_Try, /*On fail goto*//*Label 10459*/ GIMT_Encode4(653038), // Rule ID 7228 //
     /*  652968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  652979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  652982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  652985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653014 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653036 */     GIR_RootConstrainSelectedInstOperands,
     /*  653037 */     // GIR_Coverage, 7228,
     /*  653037 */     GIR_EraseRootFromParent_Done,
     /*  653038 */   // Label 10459: @653038
     /*  653038 */   GIM_Try, /*On fail goto*//*Label 10460*/ GIMT_Encode4(653113), // Rule ID 7229 //
     /*  653043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  653054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  653057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  653060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653089 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653111 */     GIR_RootConstrainSelectedInstOperands,
     /*  653112 */     // GIR_Coverage, 7229,
     /*  653112 */     GIR_EraseRootFromParent_Done,
     /*  653113 */   // Label 10460: @653113
     /*  653113 */   GIM_Try, /*On fail goto*//*Label 10461*/ GIMT_Encode4(653188), // Rule ID 7232 //
     /*  653118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  653129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  653132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  653135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653164 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653186 */     GIR_RootConstrainSelectedInstOperands,
     /*  653187 */     // GIR_Coverage, 7232,
     /*  653187 */     GIR_EraseRootFromParent_Done,
     /*  653188 */   // Label 10461: @653188
     /*  653188 */   GIM_Try, /*On fail goto*//*Label 10462*/ GIMT_Encode4(653263), // Rule ID 7233 //
     /*  653193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  653204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  653207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  653210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653239 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653261 */     GIR_RootConstrainSelectedInstOperands,
     /*  653262 */     // GIR_Coverage, 7233,
     /*  653262 */     GIR_EraseRootFromParent_Done,
     /*  653263 */   // Label 10462: @653263
     /*  653263 */   GIM_Try, /*On fail goto*//*Label 10463*/ GIMT_Encode4(653338), // Rule ID 7236 //
     /*  653268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  653285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653336 */     GIR_RootConstrainSelectedInstOperands,
     /*  653337 */     // GIR_Coverage, 7236,
     /*  653337 */     GIR_EraseRootFromParent_Done,
     /*  653338 */   // Label 10463: @653338
     /*  653338 */   GIM_Try, /*On fail goto*//*Label 10464*/ GIMT_Encode4(653413), // Rule ID 7237 //
     /*  653343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  653360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653389 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653411 */     GIR_RootConstrainSelectedInstOperands,
     /*  653412 */     // GIR_Coverage, 7237,
     /*  653412 */     GIR_EraseRootFromParent_Done,
     /*  653413 */   // Label 10464: @653413
     /*  653413 */   GIM_Try, /*On fail goto*//*Label 10465*/ GIMT_Encode4(653488), // Rule ID 7240 //
     /*  653418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  653429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  653432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  653435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653464 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653486 */     GIR_RootConstrainSelectedInstOperands,
     /*  653487 */     // GIR_Coverage, 7240,
     /*  653487 */     GIR_EraseRootFromParent_Done,
     /*  653488 */   // Label 10465: @653488
     /*  653488 */   GIM_Try, /*On fail goto*//*Label 10466*/ GIMT_Encode4(653563), // Rule ID 7241 //
     /*  653493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  653504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  653507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  653510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653539 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653561 */     GIR_RootConstrainSelectedInstOperands,
     /*  653562 */     // GIR_Coverage, 7241,
     /*  653562 */     GIR_EraseRootFromParent_Done,
     /*  653563 */   // Label 10466: @653563
     /*  653563 */   GIM_Try, /*On fail goto*//*Label 10467*/ GIMT_Encode4(653638), // Rule ID 7244 //
     /*  653568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  653579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  653582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  653585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653636 */     GIR_RootConstrainSelectedInstOperands,
     /*  653637 */     // GIR_Coverage, 7244,
     /*  653637 */     GIR_EraseRootFromParent_Done,
     /*  653638 */   // Label 10467: @653638
     /*  653638 */   GIM_Try, /*On fail goto*//*Label 10468*/ GIMT_Encode4(653713), // Rule ID 7245 //
     /*  653643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  653654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  653657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  653660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653689 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653711 */     GIR_RootConstrainSelectedInstOperands,
     /*  653712 */     // GIR_Coverage, 7245,
     /*  653712 */     GIR_EraseRootFromParent_Done,
     /*  653713 */   // Label 10468: @653713
     /*  653713 */   GIM_Try, /*On fail goto*//*Label 10469*/ GIMT_Encode4(653788), // Rule ID 7248 //
     /*  653718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  653729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  653732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  653735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  653764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653786 */     GIR_RootConstrainSelectedInstOperands,
     /*  653787 */     // GIR_Coverage, 7248,
     /*  653787 */     GIR_EraseRootFromParent_Done,
     /*  653788 */   // Label 10469: @653788
     /*  653788 */   GIM_Try, /*On fail goto*//*Label 10470*/ GIMT_Encode4(653863), // Rule ID 7249 //
     /*  653793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  653804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  653807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  653810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  653839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653861 */     GIR_RootConstrainSelectedInstOperands,
     /*  653862 */     // GIR_Coverage, 7249,
     /*  653862 */     GIR_EraseRootFromParent_Done,
     /*  653863 */   // Label 10470: @653863
     /*  653863 */   GIM_Try, /*On fail goto*//*Label 10471*/ GIMT_Encode4(653938), // Rule ID 7252 //
     /*  653868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  653879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  653882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  653885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  653914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653936 */     GIR_RootConstrainSelectedInstOperands,
     /*  653937 */     // GIR_Coverage, 7252,
     /*  653937 */     GIR_EraseRootFromParent_Done,
     /*  653938 */   // Label 10471: @653938
     /*  653938 */   GIM_Try, /*On fail goto*//*Label 10472*/ GIMT_Encode4(654013), // Rule ID 7253 //
     /*  653943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  653954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  653957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  653960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653989 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  653989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654011 */     GIR_RootConstrainSelectedInstOperands,
     /*  654012 */     // GIR_Coverage, 7253,
     /*  654012 */     GIR_EraseRootFromParent_Done,
     /*  654013 */   // Label 10472: @654013
     /*  654013 */   GIM_Try, /*On fail goto*//*Label 10473*/ GIMT_Encode4(654088), // Rule ID 7256 //
     /*  654018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  654035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654064 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654086 */     GIR_RootConstrainSelectedInstOperands,
     /*  654087 */     // GIR_Coverage, 7256,
     /*  654087 */     GIR_EraseRootFromParent_Done,
     /*  654088 */   // Label 10473: @654088
     /*  654088 */   GIM_Try, /*On fail goto*//*Label 10474*/ GIMT_Encode4(654163), // Rule ID 7257 //
     /*  654093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  654110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654139 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654161 */     GIR_RootConstrainSelectedInstOperands,
     /*  654162 */     // GIR_Coverage, 7257,
     /*  654162 */     GIR_EraseRootFromParent_Done,
     /*  654163 */   // Label 10474: @654163
     /*  654163 */   GIM_Try, /*On fail goto*//*Label 10475*/ GIMT_Encode4(654238), // Rule ID 7260 //
     /*  654168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  654185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  654217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654236 */     GIR_RootConstrainSelectedInstOperands,
     /*  654237 */     // GIR_Coverage, 7260,
     /*  654237 */     GIR_EraseRootFromParent_Done,
     /*  654238 */   // Label 10475: @654238
     /*  654238 */   GIM_Try, /*On fail goto*//*Label 10476*/ GIMT_Encode4(654313), // Rule ID 7261 //
     /*  654243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  654260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  654292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654311 */     GIR_RootConstrainSelectedInstOperands,
     /*  654312 */     // GIR_Coverage, 7261,
     /*  654312 */     GIR_EraseRootFromParent_Done,
     /*  654313 */   // Label 10476: @654313
     /*  654313 */   GIM_Try, /*On fail goto*//*Label 10477*/ GIMT_Encode4(654388), // Rule ID 7264 //
     /*  654318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  654335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  654367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654386 */     GIR_RootConstrainSelectedInstOperands,
     /*  654387 */     // GIR_Coverage, 7264,
     /*  654387 */     GIR_EraseRootFromParent_Done,
     /*  654388 */   // Label 10477: @654388
     /*  654388 */   GIM_Try, /*On fail goto*//*Label 10478*/ GIMT_Encode4(654463), // Rule ID 7265 //
     /*  654393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  654410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654439 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  654442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654461 */     GIR_RootConstrainSelectedInstOperands,
     /*  654462 */     // GIR_Coverage, 7265,
     /*  654462 */     GIR_EraseRootFromParent_Done,
     /*  654463 */   // Label 10478: @654463
     /*  654463 */   GIM_Try, /*On fail goto*//*Label 10479*/ GIMT_Encode4(654538), // Rule ID 7268 //
     /*  654468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  654479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  654482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  654485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654514 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654536 */     GIR_RootConstrainSelectedInstOperands,
     /*  654537 */     // GIR_Coverage, 7268,
     /*  654537 */     GIR_EraseRootFromParent_Done,
     /*  654538 */   // Label 10479: @654538
     /*  654538 */   GIM_Try, /*On fail goto*//*Label 10480*/ GIMT_Encode4(654613), // Rule ID 7269 //
     /*  654543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  654554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  654557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  654560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654589 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654611 */     GIR_RootConstrainSelectedInstOperands,
     /*  654612 */     // GIR_Coverage, 7269,
     /*  654612 */     GIR_EraseRootFromParent_Done,
     /*  654613 */   // Label 10480: @654613
     /*  654613 */   GIM_Try, /*On fail goto*//*Label 10481*/ GIMT_Encode4(654688), // Rule ID 7448 //
     /*  654618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  654629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  654632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  654635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  654638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654664 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  654664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  654667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654686 */     GIR_RootConstrainSelectedInstOperands,
     /*  654687 */     // GIR_Coverage, 7448,
     /*  654687 */     GIR_EraseRootFromParent_Done,
     /*  654688 */   // Label 10481: @654688
     /*  654688 */   GIM_Try, /*On fail goto*//*Label 10482*/ GIMT_Encode4(654763), // Rule ID 7449 //
     /*  654693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  654704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  654707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  654710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  654713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654739 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  654739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  654742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654761 */     GIR_RootConstrainSelectedInstOperands,
     /*  654762 */     // GIR_Coverage, 7449,
     /*  654762 */     GIR_EraseRootFromParent_Done,
     /*  654763 */   // Label 10482: @654763
     /*  654763 */   GIM_Try, /*On fail goto*//*Label 10483*/ GIMT_Encode4(654838), // Rule ID 7452 //
     /*  654768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  654779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  654782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  654785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  654788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654814 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  654814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  654817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654836 */     GIR_RootConstrainSelectedInstOperands,
     /*  654837 */     // GIR_Coverage, 7452,
     /*  654837 */     GIR_EraseRootFromParent_Done,
     /*  654838 */   // Label 10483: @654838
     /*  654838 */   GIM_Try, /*On fail goto*//*Label 10484*/ GIMT_Encode4(654913), // Rule ID 7453 //
     /*  654843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  654854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  654857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  654860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  654863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654889 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  654889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  654892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654911 */     GIR_RootConstrainSelectedInstOperands,
     /*  654912 */     // GIR_Coverage, 7453,
     /*  654912 */     GIR_EraseRootFromParent_Done,
     /*  654913 */   // Label 10484: @654913
     /*  654913 */   GIM_Try, /*On fail goto*//*Label 10485*/ GIMT_Encode4(654988), // Rule ID 7456 //
     /*  654918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  654929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  654932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  654935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  654938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654964 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  654964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  654967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654986 */     GIR_RootConstrainSelectedInstOperands,
     /*  654987 */     // GIR_Coverage, 7456,
     /*  654987 */     GIR_EraseRootFromParent_Done,
     /*  654988 */   // Label 10485: @654988
     /*  654988 */   GIM_Try, /*On fail goto*//*Label 10486*/ GIMT_Encode4(655063), // Rule ID 7457 //
     /*  654993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  655004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  655007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  655010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  655013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655039 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655061 */     GIR_RootConstrainSelectedInstOperands,
     /*  655062 */     // GIR_Coverage, 7457,
     /*  655062 */     GIR_EraseRootFromParent_Done,
     /*  655063 */   // Label 10486: @655063
     /*  655063 */   GIM_Try, /*On fail goto*//*Label 10487*/ GIMT_Encode4(655138), // Rule ID 7460 //
     /*  655068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  655079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  655082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  655085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  655088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655114 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655136 */     GIR_RootConstrainSelectedInstOperands,
     /*  655137 */     // GIR_Coverage, 7460,
     /*  655137 */     GIR_EraseRootFromParent_Done,
     /*  655138 */   // Label 10487: @655138
     /*  655138 */   GIM_Try, /*On fail goto*//*Label 10488*/ GIMT_Encode4(655213), // Rule ID 7461 //
     /*  655143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  655154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  655157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  655160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  655163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655189 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655211 */     GIR_RootConstrainSelectedInstOperands,
     /*  655212 */     // GIR_Coverage, 7461,
     /*  655212 */     GIR_EraseRootFromParent_Done,
     /*  655213 */   // Label 10488: @655213
     /*  655213 */   GIM_Try, /*On fail goto*//*Label 10489*/ GIMT_Encode4(655288), // Rule ID 7464 //
     /*  655218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  655229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  655232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  655235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  655238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655264 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  655267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655286 */     GIR_RootConstrainSelectedInstOperands,
     /*  655287 */     // GIR_Coverage, 7464,
     /*  655287 */     GIR_EraseRootFromParent_Done,
     /*  655288 */   // Label 10489: @655288
     /*  655288 */   GIM_Try, /*On fail goto*//*Label 10490*/ GIMT_Encode4(655363), // Rule ID 7465 //
     /*  655293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  655304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  655307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  655310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  655313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655339 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  655342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655361 */     GIR_RootConstrainSelectedInstOperands,
     /*  655362 */     // GIR_Coverage, 7465,
     /*  655362 */     GIR_EraseRootFromParent_Done,
     /*  655363 */   // Label 10490: @655363
     /*  655363 */   GIM_Try, /*On fail goto*//*Label 10491*/ GIMT_Encode4(655438), // Rule ID 7468 //
     /*  655368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  655379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  655382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  655385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  655388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655414 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  655417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655436 */     GIR_RootConstrainSelectedInstOperands,
     /*  655437 */     // GIR_Coverage, 7468,
     /*  655437 */     GIR_EraseRootFromParent_Done,
     /*  655438 */   // Label 10491: @655438
     /*  655438 */   GIM_Try, /*On fail goto*//*Label 10492*/ GIMT_Encode4(655513), // Rule ID 7469 //
     /*  655443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  655454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  655457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  655460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  655463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655489 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  655492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655511 */     GIR_RootConstrainSelectedInstOperands,
     /*  655512 */     // GIR_Coverage, 7469,
     /*  655512 */     GIR_EraseRootFromParent_Done,
     /*  655513 */   // Label 10492: @655513
     /*  655513 */   GIM_Try, /*On fail goto*//*Label 10493*/ GIMT_Encode4(655588), // Rule ID 7472 //
     /*  655518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  655535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  655538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655564 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  655567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655586 */     GIR_RootConstrainSelectedInstOperands,
     /*  655587 */     // GIR_Coverage, 7472,
     /*  655587 */     GIR_EraseRootFromParent_Done,
     /*  655588 */   // Label 10493: @655588
     /*  655588 */   GIM_Try, /*On fail goto*//*Label 10494*/ GIMT_Encode4(655663), // Rule ID 7473 //
     /*  655593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  655610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  655613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655639 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  655642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655661 */     GIR_RootConstrainSelectedInstOperands,
     /*  655662 */     // GIR_Coverage, 7473,
     /*  655662 */     GIR_EraseRootFromParent_Done,
     /*  655663 */   // Label 10494: @655663
     /*  655663 */   GIM_Try, /*On fail goto*//*Label 10495*/ GIMT_Encode4(655738), // Rule ID 7476 //
     /*  655668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  655679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  655682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  655685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  655688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655714 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655736 */     GIR_RootConstrainSelectedInstOperands,
     /*  655737 */     // GIR_Coverage, 7476,
     /*  655737 */     GIR_EraseRootFromParent_Done,
     /*  655738 */   // Label 10495: @655738
     /*  655738 */   GIM_Try, /*On fail goto*//*Label 10496*/ GIMT_Encode4(655813), // Rule ID 7477 //
     /*  655743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  655754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  655757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  655760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  655763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655789 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655811 */     GIR_RootConstrainSelectedInstOperands,
     /*  655812 */     // GIR_Coverage, 7477,
     /*  655812 */     GIR_EraseRootFromParent_Done,
     /*  655813 */   // Label 10496: @655813
     /*  655813 */   GIM_Try, /*On fail goto*//*Label 10497*/ GIMT_Encode4(655888), // Rule ID 7480 //
     /*  655818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  655829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  655832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  655835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  655838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655864 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655886 */     GIR_RootConstrainSelectedInstOperands,
     /*  655887 */     // GIR_Coverage, 7480,
     /*  655887 */     GIR_EraseRootFromParent_Done,
     /*  655888 */   // Label 10497: @655888
     /*  655888 */   GIM_Try, /*On fail goto*//*Label 10498*/ GIMT_Encode4(655963), // Rule ID 7481 //
     /*  655893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  655904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  655907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  655910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  655913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655939 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655961 */     GIR_RootConstrainSelectedInstOperands,
     /*  655962 */     // GIR_Coverage, 7481,
     /*  655962 */     GIR_EraseRootFromParent_Done,
     /*  655963 */   // Label 10498: @655963
     /*  655963 */   GIM_Try, /*On fail goto*//*Label 10499*/ GIMT_Encode4(656038), // Rule ID 7484 //
     /*  655968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  655979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  655982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  655985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  655988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656036 */     GIR_RootConstrainSelectedInstOperands,
     /*  656037 */     // GIR_Coverage, 7484,
     /*  656037 */     GIR_EraseRootFromParent_Done,
     /*  656038 */   // Label 10499: @656038
     /*  656038 */   GIM_Try, /*On fail goto*//*Label 10500*/ GIMT_Encode4(656113), // Rule ID 7485 //
     /*  656043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  656054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  656057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  656060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  656063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656111 */     GIR_RootConstrainSelectedInstOperands,
     /*  656112 */     // GIR_Coverage, 7485,
     /*  656112 */     GIR_EraseRootFromParent_Done,
     /*  656113 */   // Label 10500: @656113
     /*  656113 */   GIM_Try, /*On fail goto*//*Label 10501*/ GIMT_Encode4(656188), // Rule ID 7488 //
     /*  656118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  656129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  656132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  656135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  656138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656164 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656186 */     GIR_RootConstrainSelectedInstOperands,
     /*  656187 */     // GIR_Coverage, 7488,
     /*  656187 */     GIR_EraseRootFromParent_Done,
     /*  656188 */   // Label 10501: @656188
     /*  656188 */   GIM_Try, /*On fail goto*//*Label 10502*/ GIMT_Encode4(656263), // Rule ID 7489 //
     /*  656193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  656204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  656207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  656210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  656213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656239 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656261 */     GIR_RootConstrainSelectedInstOperands,
     /*  656262 */     // GIR_Coverage, 7489,
     /*  656262 */     GIR_EraseRootFromParent_Done,
     /*  656263 */   // Label 10502: @656263
     /*  656263 */   GIM_Try, /*On fail goto*//*Label 10503*/ GIMT_Encode4(656338), // Rule ID 7492 //
     /*  656268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  656279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  656282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  656285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  656288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656314 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  656317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656336 */     GIR_RootConstrainSelectedInstOperands,
     /*  656337 */     // GIR_Coverage, 7492,
     /*  656337 */     GIR_EraseRootFromParent_Done,
     /*  656338 */   // Label 10503: @656338
     /*  656338 */   GIM_Try, /*On fail goto*//*Label 10504*/ GIMT_Encode4(656413), // Rule ID 7493 //
     /*  656343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  656354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  656357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  656360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  656363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656389 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  656392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656411 */     GIR_RootConstrainSelectedInstOperands,
     /*  656412 */     // GIR_Coverage, 7493,
     /*  656412 */     GIR_EraseRootFromParent_Done,
     /*  656413 */   // Label 10504: @656413
     /*  656413 */   GIM_Try, /*On fail goto*//*Label 10505*/ GIMT_Encode4(656488), // Rule ID 7496 //
     /*  656418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  656435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  656438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  656467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656486 */     GIR_RootConstrainSelectedInstOperands,
     /*  656487 */     // GIR_Coverage, 7496,
     /*  656487 */     GIR_EraseRootFromParent_Done,
     /*  656488 */   // Label 10505: @656488
     /*  656488 */   GIM_Try, /*On fail goto*//*Label 10506*/ GIMT_Encode4(656563), // Rule ID 7497 //
     /*  656493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  656510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  656513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656539 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  656542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656561 */     GIR_RootConstrainSelectedInstOperands,
     /*  656562 */     // GIR_Coverage, 7497,
     /*  656562 */     GIR_EraseRootFromParent_Done,
     /*  656563 */   // Label 10506: @656563
     /*  656563 */   GIM_Try, /*On fail goto*//*Label 10507*/ GIMT_Encode4(656638), // Rule ID 7500 //
     /*  656568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  656579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  656582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  656585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  656588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656636 */     GIR_RootConstrainSelectedInstOperands,
     /*  656637 */     // GIR_Coverage, 7500,
     /*  656637 */     GIR_EraseRootFromParent_Done,
     /*  656638 */   // Label 10507: @656638
     /*  656638 */   GIM_Try, /*On fail goto*//*Label 10508*/ GIMT_Encode4(656713), // Rule ID 7501 //
     /*  656643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  656654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  656657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  656660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  656663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656689 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656711 */     GIR_RootConstrainSelectedInstOperands,
     /*  656712 */     // GIR_Coverage, 7501,
     /*  656712 */     GIR_EraseRootFromParent_Done,
     /*  656713 */   // Label 10508: @656713
     /*  656713 */   GIM_Try, /*On fail goto*//*Label 10509*/ GIMT_Encode4(656788), // Rule ID 7504 //
     /*  656718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  656729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  656732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  656735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  656738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656764 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656786 */     GIR_RootConstrainSelectedInstOperands,
     /*  656787 */     // GIR_Coverage, 7504,
     /*  656787 */     GIR_EraseRootFromParent_Done,
     /*  656788 */   // Label 10509: @656788
     /*  656788 */   GIM_Try, /*On fail goto*//*Label 10510*/ GIMT_Encode4(656863), // Rule ID 7505 //
     /*  656793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  656804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  656807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  656810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  656813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656839 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656861 */     GIR_RootConstrainSelectedInstOperands,
     /*  656862 */     // GIR_Coverage, 7505,
     /*  656862 */     GIR_EraseRootFromParent_Done,
     /*  656863 */   // Label 10510: @656863
     /*  656863 */   GIM_Try, /*On fail goto*//*Label 10511*/ GIMT_Encode4(656938), // Rule ID 7508 //
     /*  656868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  656879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  656882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  656885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656914 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  656917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656936 */     GIR_RootConstrainSelectedInstOperands,
     /*  656937 */     // GIR_Coverage, 7508,
     /*  656937 */     GIR_EraseRootFromParent_Done,
     /*  656938 */   // Label 10511: @656938
     /*  656938 */   GIM_Try, /*On fail goto*//*Label 10512*/ GIMT_Encode4(657013), // Rule ID 7509 //
     /*  656943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  656954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  656957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  656960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656989 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  656989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  656992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657011 */     GIR_RootConstrainSelectedInstOperands,
     /*  657012 */     // GIR_Coverage, 7509,
     /*  657012 */     GIR_EraseRootFromParent_Done,
     /*  657013 */   // Label 10512: @657013
     /*  657013 */   GIM_Try, /*On fail goto*//*Label 10513*/ GIMT_Encode4(657088), // Rule ID 7512 //
     /*  657018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  657029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  657032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  657035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657064 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657086 */     GIR_RootConstrainSelectedInstOperands,
     /*  657087 */     // GIR_Coverage, 7512,
     /*  657087 */     GIR_EraseRootFromParent_Done,
     /*  657088 */   // Label 10513: @657088
     /*  657088 */   GIM_Try, /*On fail goto*//*Label 10514*/ GIMT_Encode4(657163), // Rule ID 7513 //
     /*  657093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  657104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  657107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  657110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657139 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657161 */     GIR_RootConstrainSelectedInstOperands,
     /*  657162 */     // GIR_Coverage, 7513,
     /*  657162 */     GIR_EraseRootFromParent_Done,
     /*  657163 */   // Label 10514: @657163
     /*  657163 */   GIM_Try, /*On fail goto*//*Label 10515*/ GIMT_Encode4(657238), // Rule ID 7516 //
     /*  657168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  657179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  657182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  657185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657214 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  657217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657236 */     GIR_RootConstrainSelectedInstOperands,
     /*  657237 */     // GIR_Coverage, 7516,
     /*  657237 */     GIR_EraseRootFromParent_Done,
     /*  657238 */   // Label 10515: @657238
     /*  657238 */   GIM_Try, /*On fail goto*//*Label 10516*/ GIMT_Encode4(657313), // Rule ID 7517 //
     /*  657243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  657254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  657257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  657260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657289 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  657292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657311 */     GIR_RootConstrainSelectedInstOperands,
     /*  657312 */     // GIR_Coverage, 7517,
     /*  657312 */     GIR_EraseRootFromParent_Done,
     /*  657313 */   // Label 10516: @657313
     /*  657313 */   GIM_Try, /*On fail goto*//*Label 10517*/ GIMT_Encode4(657388), // Rule ID 7520 //
     /*  657318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  657329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  657332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  657335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657364 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  657367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657386 */     GIR_RootConstrainSelectedInstOperands,
     /*  657387 */     // GIR_Coverage, 7520,
     /*  657387 */     GIR_EraseRootFromParent_Done,
     /*  657388 */   // Label 10517: @657388
     /*  657388 */   GIM_Try, /*On fail goto*//*Label 10518*/ GIMT_Encode4(657463), // Rule ID 7521 //
     /*  657393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  657404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  657407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  657410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657439 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  657442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657461 */     GIR_RootConstrainSelectedInstOperands,
     /*  657462 */     // GIR_Coverage, 7521,
     /*  657462 */     GIR_EraseRootFromParent_Done,
     /*  657463 */   // Label 10518: @657463
     /*  657463 */   GIM_Try, /*On fail goto*//*Label 10519*/ GIMT_Encode4(657538), // Rule ID 7524 //
     /*  657468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  657479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  657482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  657485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657514 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  657517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657536 */     GIR_RootConstrainSelectedInstOperands,
     /*  657537 */     // GIR_Coverage, 7524,
     /*  657537 */     GIR_EraseRootFromParent_Done,
     /*  657538 */   // Label 10519: @657538
     /*  657538 */   GIM_Try, /*On fail goto*//*Label 10520*/ GIMT_Encode4(657613), // Rule ID 7525 //
     /*  657543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  657554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  657557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  657560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657589 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  657592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657611 */     GIR_RootConstrainSelectedInstOperands,
     /*  657612 */     // GIR_Coverage, 7525,
     /*  657612 */     GIR_EraseRootFromParent_Done,
     /*  657613 */   // Label 10520: @657613
     /*  657613 */   GIM_Try, /*On fail goto*//*Label 10521*/ GIMT_Encode4(657688), // Rule ID 7528 //
     /*  657618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  657629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  657632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  657635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657664 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  657667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657686 */     GIR_RootConstrainSelectedInstOperands,
     /*  657687 */     // GIR_Coverage, 7528,
     /*  657687 */     GIR_EraseRootFromParent_Done,
     /*  657688 */   // Label 10521: @657688
     /*  657688 */   GIM_Try, /*On fail goto*//*Label 10522*/ GIMT_Encode4(657763), // Rule ID 7529 //
     /*  657693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  657704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  657707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  657710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657739 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  657742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657761 */     GIR_RootConstrainSelectedInstOperands,
     /*  657762 */     // GIR_Coverage, 7529,
     /*  657762 */     GIR_EraseRootFromParent_Done,
     /*  657763 */   // Label 10522: @657763
     /*  657763 */   GIM_Try, /*On fail goto*//*Label 10523*/ GIMT_Encode4(657838), // Rule ID 7532 //
     /*  657768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  657779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  657782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  657785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657814 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657836 */     GIR_RootConstrainSelectedInstOperands,
     /*  657837 */     // GIR_Coverage, 7532,
     /*  657837 */     GIR_EraseRootFromParent_Done,
     /*  657838 */   // Label 10523: @657838
     /*  657838 */   GIM_Try, /*On fail goto*//*Label 10524*/ GIMT_Encode4(657913), // Rule ID 7533 //
     /*  657843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  657854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  657857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  657860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657889 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  657889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657911 */     GIR_RootConstrainSelectedInstOperands,
     /*  657912 */     // GIR_Coverage, 7533,
     /*  657912 */     GIR_EraseRootFromParent_Done,
     /*  657913 */   // Label 10524: @657913
     /*  657913 */   GIM_Try, /*On fail goto*//*Label 10525*/ GIMT_Encode4(657988), // Rule ID 7536 //
     /*  657918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  657929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  657932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  657935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  657967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657986 */     GIR_RootConstrainSelectedInstOperands,
     /*  657987 */     // GIR_Coverage, 7536,
     /*  657987 */     GIR_EraseRootFromParent_Done,
     /*  657988 */   // Label 10525: @657988
     /*  657988 */   GIM_Try, /*On fail goto*//*Label 10526*/ GIMT_Encode4(658063), // Rule ID 7537 //
     /*  657993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  658004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  658007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  658010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658039 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  658042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658061 */     GIR_RootConstrainSelectedInstOperands,
     /*  658062 */     // GIR_Coverage, 7537,
     /*  658062 */     GIR_EraseRootFromParent_Done,
     /*  658063 */   // Label 10526: @658063
     /*  658063 */   GIM_Try, /*On fail goto*//*Label 10527*/ GIMT_Encode4(658138), // Rule ID 7540 //
     /*  658068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  658079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  658082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  658085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658136 */     GIR_RootConstrainSelectedInstOperands,
     /*  658137 */     // GIR_Coverage, 7540,
     /*  658137 */     GIR_EraseRootFromParent_Done,
     /*  658138 */   // Label 10527: @658138
     /*  658138 */   GIM_Try, /*On fail goto*//*Label 10528*/ GIMT_Encode4(658213), // Rule ID 7541 //
     /*  658143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  658154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  658157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  658160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658189 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658211 */     GIR_RootConstrainSelectedInstOperands,
     /*  658212 */     // GIR_Coverage, 7541,
     /*  658212 */     GIR_EraseRootFromParent_Done,
     /*  658213 */   // Label 10528: @658213
     /*  658213 */   GIM_Try, /*On fail goto*//*Label 10529*/ GIMT_Encode4(658288), // Rule ID 7544 //
     /*  658218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  658229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  658232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  658235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658264 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658286 */     GIR_RootConstrainSelectedInstOperands,
     /*  658287 */     // GIR_Coverage, 7544,
     /*  658287 */     GIR_EraseRootFromParent_Done,
     /*  658288 */   // Label 10529: @658288
     /*  658288 */   GIM_Try, /*On fail goto*//*Label 10530*/ GIMT_Encode4(658363), // Rule ID 7545 //
     /*  658293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  658304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  658307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  658310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658361 */     GIR_RootConstrainSelectedInstOperands,
     /*  658362 */     // GIR_Coverage, 7545,
     /*  658362 */     GIR_EraseRootFromParent_Done,
     /*  658363 */   // Label 10530: @658363
     /*  658363 */   GIM_Try, /*On fail goto*//*Label 10531*/ GIMT_Encode4(658438), // Rule ID 7548 //
     /*  658368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  658379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  658382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  658385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658414 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658436 */     GIR_RootConstrainSelectedInstOperands,
     /*  658437 */     // GIR_Coverage, 7548,
     /*  658437 */     GIR_EraseRootFromParent_Done,
     /*  658438 */   // Label 10531: @658438
     /*  658438 */   GIM_Try, /*On fail goto*//*Label 10532*/ GIMT_Encode4(658513), // Rule ID 7549 //
     /*  658443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  658454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  658457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  658460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658489 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658511 */     GIR_RootConstrainSelectedInstOperands,
     /*  658512 */     // GIR_Coverage, 7549,
     /*  658512 */     GIR_EraseRootFromParent_Done,
     /*  658513 */   // Label 10532: @658513
     /*  658513 */   GIM_Try, /*On fail goto*//*Label 10533*/ GIMT_Encode4(658588), // Rule ID 7552 //
     /*  658518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  658529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  658532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  658535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658564 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  658564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  658567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658586 */     GIR_RootConstrainSelectedInstOperands,
     /*  658587 */     // GIR_Coverage, 7552,
     /*  658587 */     GIR_EraseRootFromParent_Done,
     /*  658588 */   // Label 10533: @658588
     /*  658588 */   GIM_Try, /*On fail goto*//*Label 10534*/ GIMT_Encode4(658663), // Rule ID 7553 //
     /*  658593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  658596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  658604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  658607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  658610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658639 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  658639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  658642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658661 */     GIR_RootConstrainSelectedInstOperands,
     /*  658662 */     // GIR_Coverage, 7553,
     /*  658662 */     GIR_EraseRootFromParent_Done,
     /*  658663 */   // Label 10534: @658663
     /*  658663 */   GIM_Try, /*On fail goto*//*Label 10535*/ GIMT_Encode4(658738), // Rule ID 7556 //
     /*  658668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  658679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  658682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  658685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658714 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  658714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658736 */     GIR_RootConstrainSelectedInstOperands,
     /*  658737 */     // GIR_Coverage, 7556,
     /*  658737 */     GIR_EraseRootFromParent_Done,
     /*  658738 */   // Label 10535: @658738
     /*  658738 */   GIM_Try, /*On fail goto*//*Label 10536*/ GIMT_Encode4(658813), // Rule ID 7557 //
     /*  658743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  658746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  658754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  658757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  658760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658789 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  658789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658811 */     GIR_RootConstrainSelectedInstOperands,
     /*  658812 */     // GIR_Coverage, 7557,
     /*  658812 */     GIR_EraseRootFromParent_Done,
     /*  658813 */   // Label 10536: @658813
     /*  658813 */   GIM_Try, /*On fail goto*//*Label 10537*/ GIMT_Encode4(658888), // Rule ID 7560 //
     /*  658818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  658829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  658832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  658835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  658864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658886 */     GIR_RootConstrainSelectedInstOperands,
     /*  658887 */     // GIR_Coverage, 7560,
     /*  658887 */     GIR_EraseRootFromParent_Done,
     /*  658888 */   // Label 10537: @658888
     /*  658888 */   GIM_Try, /*On fail goto*//*Label 10538*/ GIMT_Encode4(658963), // Rule ID 7561 //
     /*  658893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  658896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  658904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  658907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  658910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658939 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  658939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658961 */     GIR_RootConstrainSelectedInstOperands,
     /*  658962 */     // GIR_Coverage, 7561,
     /*  658962 */     GIR_EraseRootFromParent_Done,
     /*  658963 */   // Label 10538: @658963
     /*  658963 */   GIM_Try, /*On fail goto*//*Label 10539*/ GIMT_Encode4(659038), // Rule ID 7564 //
     /*  658968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  658979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  658982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  658985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659014 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  659017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659036 */     GIR_RootConstrainSelectedInstOperands,
     /*  659037 */     // GIR_Coverage, 7564,
     /*  659037 */     GIR_EraseRootFromParent_Done,
     /*  659038 */   // Label 10539: @659038
     /*  659038 */   GIM_Try, /*On fail goto*//*Label 10540*/ GIMT_Encode4(659113), // Rule ID 7565 //
     /*  659043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  659054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  659057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  659060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  659063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659089 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  659092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659111 */     GIR_RootConstrainSelectedInstOperands,
     /*  659112 */     // GIR_Coverage, 7565,
     /*  659112 */     GIR_EraseRootFromParent_Done,
     /*  659113 */   // Label 10540: @659113
     /*  659113 */   GIM_Try, /*On fail goto*//*Label 10541*/ GIMT_Encode4(659188), // Rule ID 7628 //
     /*  659118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  659129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  659132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  659135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  659138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659164 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  659167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659186 */     GIR_RootConstrainSelectedInstOperands,
     /*  659187 */     // GIR_Coverage, 7628,
     /*  659187 */     GIR_EraseRootFromParent_Done,
     /*  659188 */   // Label 10541: @659188
     /*  659188 */   GIM_Try, /*On fail goto*//*Label 10542*/ GIMT_Encode4(659263), // Rule ID 7629 //
     /*  659193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  659204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  659207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  659210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  659213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659239 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  659242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659261 */     GIR_RootConstrainSelectedInstOperands,
     /*  659262 */     // GIR_Coverage, 7629,
     /*  659262 */     GIR_EraseRootFromParent_Done,
     /*  659263 */   // Label 10542: @659263
     /*  659263 */   GIM_Try, /*On fail goto*//*Label 10543*/ GIMT_Encode4(659338), // Rule ID 7632 //
     /*  659268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  659279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  659282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  659285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  659288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659314 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  659317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659336 */     GIR_RootConstrainSelectedInstOperands,
     /*  659337 */     // GIR_Coverage, 7632,
     /*  659337 */     GIR_EraseRootFromParent_Done,
     /*  659338 */   // Label 10543: @659338
     /*  659338 */   GIM_Try, /*On fail goto*//*Label 10544*/ GIMT_Encode4(659413), // Rule ID 7633 //
     /*  659343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  659354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  659357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  659360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  659363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659389 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  659392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659411 */     GIR_RootConstrainSelectedInstOperands,
     /*  659412 */     // GIR_Coverage, 7633,
     /*  659412 */     GIR_EraseRootFromParent_Done,
     /*  659413 */   // Label 10544: @659413
     /*  659413 */   GIM_Try, /*On fail goto*//*Label 10545*/ GIMT_Encode4(659488), // Rule ID 7636 //
     /*  659418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  659429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  659432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  659435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  659438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659464 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  659467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659486 */     GIR_RootConstrainSelectedInstOperands,
     /*  659487 */     // GIR_Coverage, 7636,
     /*  659487 */     GIR_EraseRootFromParent_Done,
     /*  659488 */   // Label 10545: @659488
     /*  659488 */   GIM_Try, /*On fail goto*//*Label 10546*/ GIMT_Encode4(659563), // Rule ID 7637 //
     /*  659493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  659504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  659507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  659510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  659513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659539 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  659542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659561 */     GIR_RootConstrainSelectedInstOperands,
     /*  659562 */     // GIR_Coverage, 7637,
     /*  659562 */     GIR_EraseRootFromParent_Done,
     /*  659563 */   // Label 10546: @659563
     /*  659563 */   GIM_Try, /*On fail goto*//*Label 10547*/ GIMT_Encode4(659638), // Rule ID 7640 //
     /*  659568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  659579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  659582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  659585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  659588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659614 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  659617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659636 */     GIR_RootConstrainSelectedInstOperands,
     /*  659637 */     // GIR_Coverage, 7640,
     /*  659637 */     GIR_EraseRootFromParent_Done,
     /*  659638 */   // Label 10547: @659638
     /*  659638 */   GIM_Try, /*On fail goto*//*Label 10548*/ GIMT_Encode4(659713), // Rule ID 7641 //
     /*  659643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  659654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  659657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  659660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  659663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659689 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  659692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659711 */     GIR_RootConstrainSelectedInstOperands,
     /*  659712 */     // GIR_Coverage, 7641,
     /*  659712 */     GIR_EraseRootFromParent_Done,
     /*  659713 */   // Label 10548: @659713
     /*  659713 */   GIM_Try, /*On fail goto*//*Label 10549*/ GIMT_Encode4(659788), // Rule ID 7644 //
     /*  659718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  659729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  659732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  659735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  659738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659764 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  659767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659786 */     GIR_RootConstrainSelectedInstOperands,
     /*  659787 */     // GIR_Coverage, 7644,
     /*  659787 */     GIR_EraseRootFromParent_Done,
     /*  659788 */   // Label 10549: @659788
     /*  659788 */   GIM_Try, /*On fail goto*//*Label 10550*/ GIMT_Encode4(659863), // Rule ID 7645 //
     /*  659793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  659804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  659807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  659810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  659813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659839 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  659842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659861 */     GIR_RootConstrainSelectedInstOperands,
     /*  659862 */     // GIR_Coverage, 7645,
     /*  659862 */     GIR_EraseRootFromParent_Done,
     /*  659863 */   // Label 10550: @659863
     /*  659863 */   GIM_Try, /*On fail goto*//*Label 10551*/ GIMT_Encode4(659938), // Rule ID 7648 //
     /*  659868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  659879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  659882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  659885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  659888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659914 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  659917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659936 */     GIR_RootConstrainSelectedInstOperands,
     /*  659937 */     // GIR_Coverage, 7648,
     /*  659937 */     GIR_EraseRootFromParent_Done,
     /*  659938 */   // Label 10551: @659938
     /*  659938 */   GIM_Try, /*On fail goto*//*Label 10552*/ GIMT_Encode4(660013), // Rule ID 7649 //
     /*  659943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  659954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  659957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  659960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  659963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659989 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  659992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660011 */     GIR_RootConstrainSelectedInstOperands,
     /*  660012 */     // GIR_Coverage, 7649,
     /*  660012 */     GIR_EraseRootFromParent_Done,
     /*  660013 */   // Label 10552: @660013
     /*  660013 */   GIM_Try, /*On fail goto*//*Label 10553*/ GIMT_Encode4(660088), // Rule ID 7652 //
     /*  660018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  660029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  660032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  660035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  660038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660064 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  660067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660086 */     GIR_RootConstrainSelectedInstOperands,
     /*  660087 */     // GIR_Coverage, 7652,
     /*  660087 */     GIR_EraseRootFromParent_Done,
     /*  660088 */   // Label 10553: @660088
     /*  660088 */   GIM_Try, /*On fail goto*//*Label 10554*/ GIMT_Encode4(660163), // Rule ID 7653 //
     /*  660093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  660104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  660107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  660110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  660113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660139 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  660142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660161 */     GIR_RootConstrainSelectedInstOperands,
     /*  660162 */     // GIR_Coverage, 7653,
     /*  660162 */     GIR_EraseRootFromParent_Done,
     /*  660163 */   // Label 10554: @660163
     /*  660163 */   GIM_Try, /*On fail goto*//*Label 10555*/ GIMT_Encode4(660238), // Rule ID 7656 //
     /*  660168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  660179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  660182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  660185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  660188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660214 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660236 */     GIR_RootConstrainSelectedInstOperands,
     /*  660237 */     // GIR_Coverage, 7656,
     /*  660237 */     GIR_EraseRootFromParent_Done,
     /*  660238 */   // Label 10555: @660238
     /*  660238 */   GIM_Try, /*On fail goto*//*Label 10556*/ GIMT_Encode4(660313), // Rule ID 7657 //
     /*  660243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  660254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  660257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  660260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  660263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660289 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660311 */     GIR_RootConstrainSelectedInstOperands,
     /*  660312 */     // GIR_Coverage, 7657,
     /*  660312 */     GIR_EraseRootFromParent_Done,
     /*  660313 */   // Label 10556: @660313
     /*  660313 */   GIM_Try, /*On fail goto*//*Label 10557*/ GIMT_Encode4(660388), // Rule ID 7660 //
     /*  660318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  660329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  660332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  660335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  660338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660364 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660386 */     GIR_RootConstrainSelectedInstOperands,
     /*  660387 */     // GIR_Coverage, 7660,
     /*  660387 */     GIR_EraseRootFromParent_Done,
     /*  660388 */   // Label 10557: @660388
     /*  660388 */   GIM_Try, /*On fail goto*//*Label 10558*/ GIMT_Encode4(660463), // Rule ID 7661 //
     /*  660393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  660404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  660407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  660410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  660413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660439 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660461 */     GIR_RootConstrainSelectedInstOperands,
     /*  660462 */     // GIR_Coverage, 7661,
     /*  660462 */     GIR_EraseRootFromParent_Done,
     /*  660463 */   // Label 10558: @660463
     /*  660463 */   GIM_Try, /*On fail goto*//*Label 10559*/ GIMT_Encode4(660538), // Rule ID 7664 //
     /*  660468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  660479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  660482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  660485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  660488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  660517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660536 */     GIR_RootConstrainSelectedInstOperands,
     /*  660537 */     // GIR_Coverage, 7664,
     /*  660537 */     GIR_EraseRootFromParent_Done,
     /*  660538 */   // Label 10559: @660538
     /*  660538 */   GIM_Try, /*On fail goto*//*Label 10560*/ GIMT_Encode4(660613), // Rule ID 7665 //
     /*  660543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  660554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  660557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  660560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  660563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660589 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  660592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660611 */     GIR_RootConstrainSelectedInstOperands,
     /*  660612 */     // GIR_Coverage, 7665,
     /*  660612 */     GIR_EraseRootFromParent_Done,
     /*  660613 */   // Label 10560: @660613
     /*  660613 */   GIM_Try, /*On fail goto*//*Label 10561*/ GIMT_Encode4(660688), // Rule ID 7668 //
     /*  660618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  660629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  660632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  660635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  660638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660664 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  660667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660686 */     GIR_RootConstrainSelectedInstOperands,
     /*  660687 */     // GIR_Coverage, 7668,
     /*  660687 */     GIR_EraseRootFromParent_Done,
     /*  660688 */   // Label 10561: @660688
     /*  660688 */   GIM_Try, /*On fail goto*//*Label 10562*/ GIMT_Encode4(660763), // Rule ID 7669 //
     /*  660693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  660704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  660707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  660710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  660713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660739 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  660742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660761 */     GIR_RootConstrainSelectedInstOperands,
     /*  660762 */     // GIR_Coverage, 7669,
     /*  660762 */     GIR_EraseRootFromParent_Done,
     /*  660763 */   // Label 10562: @660763
     /*  660763 */   GIM_Try, /*On fail goto*//*Label 10563*/ GIMT_Encode4(660838), // Rule ID 7672 //
     /*  660768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  660779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  660782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  660785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  660788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660836 */     GIR_RootConstrainSelectedInstOperands,
     /*  660837 */     // GIR_Coverage, 7672,
     /*  660837 */     GIR_EraseRootFromParent_Done,
     /*  660838 */   // Label 10563: @660838
     /*  660838 */   GIM_Try, /*On fail goto*//*Label 10564*/ GIMT_Encode4(660913), // Rule ID 7673 //
     /*  660843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  660854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  660857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  660860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  660863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660889 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660911 */     GIR_RootConstrainSelectedInstOperands,
     /*  660912 */     // GIR_Coverage, 7673,
     /*  660912 */     GIR_EraseRootFromParent_Done,
     /*  660913 */   // Label 10564: @660913
     /*  660913 */   GIM_Try, /*On fail goto*//*Label 10565*/ GIMT_Encode4(660988), // Rule ID 7676 //
     /*  660918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  660929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  660932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  660935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  660938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660964 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660986 */     GIR_RootConstrainSelectedInstOperands,
     /*  660987 */     // GIR_Coverage, 7676,
     /*  660987 */     GIR_EraseRootFromParent_Done,
     /*  660988 */   // Label 10565: @660988
     /*  660988 */   GIM_Try, /*On fail goto*//*Label 10566*/ GIMT_Encode4(661063), // Rule ID 7677 //
     /*  660993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  661004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  661007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  661010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  661013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661039 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  661042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661061 */     GIR_RootConstrainSelectedInstOperands,
     /*  661062 */     // GIR_Coverage, 7677,
     /*  661062 */     GIR_EraseRootFromParent_Done,
     /*  661063 */   // Label 10566: @661063
     /*  661063 */   GIM_Try, /*On fail goto*//*Label 10567*/ GIMT_Encode4(661138), // Rule ID 7680 //
     /*  661068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  661079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  661082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  661085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  661088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661114 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  661117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661136 */     GIR_RootConstrainSelectedInstOperands,
     /*  661137 */     // GIR_Coverage, 7680,
     /*  661137 */     GIR_EraseRootFromParent_Done,
     /*  661138 */   // Label 10567: @661138
     /*  661138 */   GIM_Try, /*On fail goto*//*Label 10568*/ GIMT_Encode4(661213), // Rule ID 7681 //
     /*  661143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  661154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  661157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  661160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  661163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661189 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  661192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661211 */     GIR_RootConstrainSelectedInstOperands,
     /*  661212 */     // GIR_Coverage, 7681,
     /*  661212 */     GIR_EraseRootFromParent_Done,
     /*  661213 */   // Label 10568: @661213
     /*  661213 */   GIM_Try, /*On fail goto*//*Label 10569*/ GIMT_Encode4(661288), // Rule ID 7684 //
     /*  661218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  661229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  661232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  661235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  661238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661264 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  661267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661286 */     GIR_RootConstrainSelectedInstOperands,
     /*  661287 */     // GIR_Coverage, 7684,
     /*  661287 */     GIR_EraseRootFromParent_Done,
     /*  661288 */   // Label 10569: @661288
     /*  661288 */   GIM_Try, /*On fail goto*//*Label 10570*/ GIMT_Encode4(661363), // Rule ID 7685 //
     /*  661293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  661304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  661307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  661310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  661313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661339 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  661342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661361 */     GIR_RootConstrainSelectedInstOperands,
     /*  661362 */     // GIR_Coverage, 7685,
     /*  661362 */     GIR_EraseRootFromParent_Done,
     /*  661363 */   // Label 10570: @661363
     /*  661363 */   GIM_Try, /*On fail goto*//*Label 10571*/ GIMT_Encode4(661438), // Rule ID 7688 //
     /*  661368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  661379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  661382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  661385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661414 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  661417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661436 */     GIR_RootConstrainSelectedInstOperands,
     /*  661437 */     // GIR_Coverage, 7688,
     /*  661437 */     GIR_EraseRootFromParent_Done,
     /*  661438 */   // Label 10571: @661438
     /*  661438 */   GIM_Try, /*On fail goto*//*Label 10572*/ GIMT_Encode4(661513), // Rule ID 7689 //
     /*  661443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  661454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  661457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  661460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661489 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  661492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661511 */     GIR_RootConstrainSelectedInstOperands,
     /*  661512 */     // GIR_Coverage, 7689,
     /*  661512 */     GIR_EraseRootFromParent_Done,
     /*  661513 */   // Label 10572: @661513
     /*  661513 */   GIM_Try, /*On fail goto*//*Label 10573*/ GIMT_Encode4(661588), // Rule ID 7692 //
     /*  661518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  661529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  661532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  661535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661564 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  661567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661586 */     GIR_RootConstrainSelectedInstOperands,
     /*  661587 */     // GIR_Coverage, 7692,
     /*  661587 */     GIR_EraseRootFromParent_Done,
     /*  661588 */   // Label 10573: @661588
     /*  661588 */   GIM_Try, /*On fail goto*//*Label 10574*/ GIMT_Encode4(661663), // Rule ID 7693 //
     /*  661593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  661604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  661607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  661610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661639 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  661642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661661 */     GIR_RootConstrainSelectedInstOperands,
     /*  661662 */     // GIR_Coverage, 7693,
     /*  661662 */     GIR_EraseRootFromParent_Done,
     /*  661663 */   // Label 10574: @661663
     /*  661663 */   GIM_Try, /*On fail goto*//*Label 10575*/ GIMT_Encode4(661738), // Rule ID 7696 //
     /*  661668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  661679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  661682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  661685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661714 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  661717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661736 */     GIR_RootConstrainSelectedInstOperands,
     /*  661737 */     // GIR_Coverage, 7696,
     /*  661737 */     GIR_EraseRootFromParent_Done,
     /*  661738 */   // Label 10575: @661738
     /*  661738 */   GIM_Try, /*On fail goto*//*Label 10576*/ GIMT_Encode4(661813), // Rule ID 7697 //
     /*  661743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  661754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  661757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  661760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661789 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  661792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661811 */     GIR_RootConstrainSelectedInstOperands,
     /*  661812 */     // GIR_Coverage, 7697,
     /*  661812 */     GIR_EraseRootFromParent_Done,
     /*  661813 */   // Label 10576: @661813
     /*  661813 */   GIM_Try, /*On fail goto*//*Label 10577*/ GIMT_Encode4(661888), // Rule ID 7700 //
     /*  661818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  661829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  661832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  661835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661864 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  661867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661886 */     GIR_RootConstrainSelectedInstOperands,
     /*  661887 */     // GIR_Coverage, 7700,
     /*  661887 */     GIR_EraseRootFromParent_Done,
     /*  661888 */   // Label 10577: @661888
     /*  661888 */   GIM_Try, /*On fail goto*//*Label 10578*/ GIMT_Encode4(661963), // Rule ID 7701 //
     /*  661893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  661904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  661907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  661910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661939 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  661942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661961 */     GIR_RootConstrainSelectedInstOperands,
     /*  661962 */     // GIR_Coverage, 7701,
     /*  661962 */     GIR_EraseRootFromParent_Done,
     /*  661963 */   // Label 10578: @661963
     /*  661963 */   GIM_Try, /*On fail goto*//*Label 10579*/ GIMT_Encode4(662038), // Rule ID 7704 //
     /*  661968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  661979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  661982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  661985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662036 */     GIR_RootConstrainSelectedInstOperands,
     /*  662037 */     // GIR_Coverage, 7704,
     /*  662037 */     GIR_EraseRootFromParent_Done,
     /*  662038 */   // Label 10579: @662038
     /*  662038 */   GIM_Try, /*On fail goto*//*Label 10580*/ GIMT_Encode4(662113), // Rule ID 7705 //
     /*  662043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  662054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  662057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  662060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662089 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662111 */     GIR_RootConstrainSelectedInstOperands,
     /*  662112 */     // GIR_Coverage, 7705,
     /*  662112 */     GIR_EraseRootFromParent_Done,
     /*  662113 */   // Label 10580: @662113
     /*  662113 */   GIM_Try, /*On fail goto*//*Label 10581*/ GIMT_Encode4(662188), // Rule ID 7708 //
     /*  662118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  662129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  662132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  662135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662164 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662186 */     GIR_RootConstrainSelectedInstOperands,
     /*  662187 */     // GIR_Coverage, 7708,
     /*  662187 */     GIR_EraseRootFromParent_Done,
     /*  662188 */   // Label 10581: @662188
     /*  662188 */   GIM_Try, /*On fail goto*//*Label 10582*/ GIMT_Encode4(662263), // Rule ID 7709 //
     /*  662193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  662204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  662207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  662210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662239 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662261 */     GIR_RootConstrainSelectedInstOperands,
     /*  662262 */     // GIR_Coverage, 7709,
     /*  662262 */     GIR_EraseRootFromParent_Done,
     /*  662263 */   // Label 10582: @662263
     /*  662263 */   GIM_Try, /*On fail goto*//*Label 10583*/ GIMT_Encode4(662338), // Rule ID 7712 //
     /*  662268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  662279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  662282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  662285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662314 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  662317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662336 */     GIR_RootConstrainSelectedInstOperands,
     /*  662337 */     // GIR_Coverage, 7712,
     /*  662337 */     GIR_EraseRootFromParent_Done,
     /*  662338 */   // Label 10583: @662338
     /*  662338 */   GIM_Try, /*On fail goto*//*Label 10584*/ GIMT_Encode4(662413), // Rule ID 7713 //
     /*  662343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  662354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  662357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  662360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662389 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  662392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662411 */     GIR_RootConstrainSelectedInstOperands,
     /*  662412 */     // GIR_Coverage, 7713,
     /*  662412 */     GIR_EraseRootFromParent_Done,
     /*  662413 */   // Label 10584: @662413
     /*  662413 */   GIM_Try, /*On fail goto*//*Label 10585*/ GIMT_Encode4(662488), // Rule ID 7716 //
     /*  662418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  662429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  662432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  662435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662464 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662486 */     GIR_RootConstrainSelectedInstOperands,
     /*  662487 */     // GIR_Coverage, 7716,
     /*  662487 */     GIR_EraseRootFromParent_Done,
     /*  662488 */   // Label 10585: @662488
     /*  662488 */   GIM_Try, /*On fail goto*//*Label 10586*/ GIMT_Encode4(662563), // Rule ID 7717 //
     /*  662493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  662504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  662507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  662510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662539 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662561 */     GIR_RootConstrainSelectedInstOperands,
     /*  662562 */     // GIR_Coverage, 7717,
     /*  662562 */     GIR_EraseRootFromParent_Done,
     /*  662563 */   // Label 10586: @662563
     /*  662563 */   GIM_Try, /*On fail goto*//*Label 10587*/ GIMT_Encode4(662638), // Rule ID 7720 //
     /*  662568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  662579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  662582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  662585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662614 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  662617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662636 */     GIR_RootConstrainSelectedInstOperands,
     /*  662637 */     // GIR_Coverage, 7720,
     /*  662637 */     GIR_EraseRootFromParent_Done,
     /*  662638 */   // Label 10587: @662638
     /*  662638 */   GIM_Try, /*On fail goto*//*Label 10588*/ GIMT_Encode4(662713), // Rule ID 7721 //
     /*  662643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  662654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  662657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  662660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662689 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  662692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662711 */     GIR_RootConstrainSelectedInstOperands,
     /*  662712 */     // GIR_Coverage, 7721,
     /*  662712 */     GIR_EraseRootFromParent_Done,
     /*  662713 */   // Label 10588: @662713
     /*  662713 */   GIM_Try, /*On fail goto*//*Label 10589*/ GIMT_Encode4(662788), // Rule ID 7724 //
     /*  662718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  662729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  662732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  662735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662764 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662786 */     GIR_RootConstrainSelectedInstOperands,
     /*  662787 */     // GIR_Coverage, 7724,
     /*  662787 */     GIR_EraseRootFromParent_Done,
     /*  662788 */   // Label 10589: @662788
     /*  662788 */   GIM_Try, /*On fail goto*//*Label 10590*/ GIMT_Encode4(662863), // Rule ID 7725 //
     /*  662793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  662804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  662807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  662810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662839 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662861 */     GIR_RootConstrainSelectedInstOperands,
     /*  662862 */     // GIR_Coverage, 7725,
     /*  662862 */     GIR_EraseRootFromParent_Done,
     /*  662863 */   // Label 10590: @662863
     /*  662863 */   GIM_Try, /*On fail goto*//*Label 10591*/ GIMT_Encode4(662938), // Rule ID 7728 //
     /*  662868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  662879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  662882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  662885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662914 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662936 */     GIR_RootConstrainSelectedInstOperands,
     /*  662937 */     // GIR_Coverage, 7728,
     /*  662937 */     GIR_EraseRootFromParent_Done,
     /*  662938 */   // Label 10591: @662938
     /*  662938 */   GIM_Try, /*On fail goto*//*Label 10592*/ GIMT_Encode4(663013), // Rule ID 7729 //
     /*  662943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  662954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  662957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  662960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662989 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663011 */     GIR_RootConstrainSelectedInstOperands,
     /*  663012 */     // GIR_Coverage, 7729,
     /*  663012 */     GIR_EraseRootFromParent_Done,
     /*  663013 */   // Label 10592: @663013
     /*  663013 */   GIM_Try, /*On fail goto*//*Label 10593*/ GIMT_Encode4(663088), // Rule ID 7732 //
     /*  663018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  663029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  663032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  663035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663064 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  663067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663086 */     GIR_RootConstrainSelectedInstOperands,
     /*  663087 */     // GIR_Coverage, 7732,
     /*  663087 */     GIR_EraseRootFromParent_Done,
     /*  663088 */   // Label 10593: @663088
     /*  663088 */   GIM_Try, /*On fail goto*//*Label 10594*/ GIMT_Encode4(663163), // Rule ID 7733 //
     /*  663093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  663104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  663107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  663110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663139 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  663142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663161 */     GIR_RootConstrainSelectedInstOperands,
     /*  663162 */     // GIR_Coverage, 7733,
     /*  663162 */     GIR_EraseRootFromParent_Done,
     /*  663163 */   // Label 10594: @663163
     /*  663163 */   GIM_Try, /*On fail goto*//*Label 10595*/ GIMT_Encode4(663238), // Rule ID 7736 //
     /*  663168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  663179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  663182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  663185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663214 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  663217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663236 */     GIR_RootConstrainSelectedInstOperands,
     /*  663237 */     // GIR_Coverage, 7736,
     /*  663237 */     GIR_EraseRootFromParent_Done,
     /*  663238 */   // Label 10595: @663238
     /*  663238 */   GIM_Try, /*On fail goto*//*Label 10596*/ GIMT_Encode4(663313), // Rule ID 7737 //
     /*  663243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  663254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  663257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  663260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663289 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  663292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663311 */     GIR_RootConstrainSelectedInstOperands,
     /*  663312 */     // GIR_Coverage, 7737,
     /*  663312 */     GIR_EraseRootFromParent_Done,
     /*  663313 */   // Label 10596: @663313
     /*  663313 */   GIM_Try, /*On fail goto*//*Label 10597*/ GIMT_Encode4(663388), // Rule ID 7740 //
     /*  663318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  663329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  663332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  663335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  663367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663386 */     GIR_RootConstrainSelectedInstOperands,
     /*  663387 */     // GIR_Coverage, 7740,
     /*  663387 */     GIR_EraseRootFromParent_Done,
     /*  663388 */   // Label 10597: @663388
     /*  663388 */   GIM_Try, /*On fail goto*//*Label 10598*/ GIMT_Encode4(663463), // Rule ID 7741 //
     /*  663393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  663404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  663407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  663410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  663442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663461 */     GIR_RootConstrainSelectedInstOperands,
     /*  663462 */     // GIR_Coverage, 7741,
     /*  663462 */     GIR_EraseRootFromParent_Done,
     /*  663463 */   // Label 10598: @663463
     /*  663463 */   GIM_Try, /*On fail goto*//*Label 10599*/ GIMT_Encode4(663538), // Rule ID 7744 //
     /*  663468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  663479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  663482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  663485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  663517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663536 */     GIR_RootConstrainSelectedInstOperands,
     /*  663537 */     // GIR_Coverage, 7744,
     /*  663537 */     GIR_EraseRootFromParent_Done,
     /*  663538 */   // Label 10599: @663538
     /*  663538 */   GIM_Try, /*On fail goto*//*Label 10600*/ GIMT_Encode4(663613), // Rule ID 7745 //
     /*  663543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  663554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  663557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  663560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663589 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  663592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663611 */     GIR_RootConstrainSelectedInstOperands,
     /*  663612 */     // GIR_Coverage, 7745,
     /*  663612 */     GIR_EraseRootFromParent_Done,
     /*  663613 */   // Label 10600: @663613
     /*  663613 */   GIM_Try, /*On fail goto*//*Label 10601*/ GIMT_Encode4(663688), // Rule ID 10260 //
     /*  663618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  663629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  663632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  663635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  663638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663664 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  663667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663686 */     GIR_RootConstrainSelectedInstOperands,
     /*  663687 */     // GIR_Coverage, 10260,
     /*  663687 */     GIR_EraseRootFromParent_Done,
     /*  663688 */   // Label 10601: @663688
     /*  663688 */   GIM_Try, /*On fail goto*//*Label 10602*/ GIMT_Encode4(663763), // Rule ID 10261 //
     /*  663693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  663704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  663707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  663710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  663713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663739 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  663742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663761 */     GIR_RootConstrainSelectedInstOperands,
     /*  663762 */     // GIR_Coverage, 10261,
     /*  663762 */     GIR_EraseRootFromParent_Done,
     /*  663763 */   // Label 10602: @663763
     /*  663763 */   GIM_Try, /*On fail goto*//*Label 10603*/ GIMT_Encode4(663838), // Rule ID 10264 //
     /*  663768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  663779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  663782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  663785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  663788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663814 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  663817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663836 */     GIR_RootConstrainSelectedInstOperands,
     /*  663837 */     // GIR_Coverage, 10264,
     /*  663837 */     GIR_EraseRootFromParent_Done,
     /*  663838 */   // Label 10603: @663838
     /*  663838 */   GIM_Try, /*On fail goto*//*Label 10604*/ GIMT_Encode4(663913), // Rule ID 10265 //
     /*  663843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  663854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  663857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  663860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  663863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663889 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  663892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663911 */     GIR_RootConstrainSelectedInstOperands,
     /*  663912 */     // GIR_Coverage, 10265,
     /*  663912 */     GIR_EraseRootFromParent_Done,
     /*  663913 */   // Label 10604: @663913
     /*  663913 */   GIM_Try, /*On fail goto*//*Label 10605*/ GIMT_Encode4(663988), // Rule ID 10268 //
     /*  663918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  663929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  663932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  663935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  663938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663964 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  663967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663986 */     GIR_RootConstrainSelectedInstOperands,
     /*  663987 */     // GIR_Coverage, 10268,
     /*  663987 */     GIR_EraseRootFromParent_Done,
     /*  663988 */   // Label 10605: @663988
     /*  663988 */   GIM_Try, /*On fail goto*//*Label 10606*/ GIMT_Encode4(664063), // Rule ID 10269 //
     /*  663993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  664004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  664007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  664010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  664013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664039 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  664039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664061 */     GIR_RootConstrainSelectedInstOperands,
     /*  664062 */     // GIR_Coverage, 10269,
     /*  664062 */     GIR_EraseRootFromParent_Done,
     /*  664063 */   // Label 10606: @664063
     /*  664063 */   GIM_Try, /*On fail goto*//*Label 10607*/ GIMT_Encode4(664138), // Rule ID 10272 //
     /*  664068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  664079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  664082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  664085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  664088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  664117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664136 */     GIR_RootConstrainSelectedInstOperands,
     /*  664137 */     // GIR_Coverage, 10272,
     /*  664137 */     GIR_EraseRootFromParent_Done,
     /*  664138 */   // Label 10607: @664138
     /*  664138 */   GIM_Try, /*On fail goto*//*Label 10608*/ GIMT_Encode4(664213), // Rule ID 10273 //
     /*  664143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  664154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  664157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  664160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  664163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664189 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  664192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664211 */     GIR_RootConstrainSelectedInstOperands,
     /*  664212 */     // GIR_Coverage, 10273,
     /*  664212 */     GIR_EraseRootFromParent_Done,
     /*  664213 */   // Label 10608: @664213
     /*  664213 */   GIM_Try, /*On fail goto*//*Label 10609*/ GIMT_Encode4(664288), // Rule ID 10276 //
     /*  664218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  664229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  664232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  664235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  664238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664286 */     GIR_RootConstrainSelectedInstOperands,
     /*  664287 */     // GIR_Coverage, 10276,
     /*  664287 */     GIR_EraseRootFromParent_Done,
     /*  664288 */   // Label 10609: @664288
     /*  664288 */   GIM_Try, /*On fail goto*//*Label 10610*/ GIMT_Encode4(664363), // Rule ID 10277 //
     /*  664293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  664304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  664307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  664310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  664313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664339 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664361 */     GIR_RootConstrainSelectedInstOperands,
     /*  664362 */     // GIR_Coverage, 10277,
     /*  664362 */     GIR_EraseRootFromParent_Done,
     /*  664363 */   // Label 10610: @664363
     /*  664363 */   GIM_Try, /*On fail goto*//*Label 10611*/ GIMT_Encode4(664438), // Rule ID 10280 //
     /*  664368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  664379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  664382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  664385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  664388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664414 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664436 */     GIR_RootConstrainSelectedInstOperands,
     /*  664437 */     // GIR_Coverage, 10280,
     /*  664437 */     GIR_EraseRootFromParent_Done,
     /*  664438 */   // Label 10611: @664438
     /*  664438 */   GIM_Try, /*On fail goto*//*Label 10612*/ GIMT_Encode4(664513), // Rule ID 10281 //
     /*  664443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  664454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  664457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  664460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  664463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664489 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664511 */     GIR_RootConstrainSelectedInstOperands,
     /*  664512 */     // GIR_Coverage, 10281,
     /*  664512 */     GIR_EraseRootFromParent_Done,
     /*  664513 */   // Label 10612: @664513
     /*  664513 */   GIM_Try, /*On fail goto*//*Label 10613*/ GIMT_Encode4(664588), // Rule ID 10284 //
     /*  664518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  664529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  664532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  664535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  664538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664564 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  664564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664586 */     GIR_RootConstrainSelectedInstOperands,
     /*  664587 */     // GIR_Coverage, 10284,
     /*  664587 */     GIR_EraseRootFromParent_Done,
     /*  664588 */   // Label 10613: @664588
     /*  664588 */   GIM_Try, /*On fail goto*//*Label 10614*/ GIMT_Encode4(664663), // Rule ID 10285 //
     /*  664593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  664604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  664607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  664610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  664613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664639 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  664639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664661 */     GIR_RootConstrainSelectedInstOperands,
     /*  664662 */     // GIR_Coverage, 10285,
     /*  664662 */     GIR_EraseRootFromParent_Done,
     /*  664663 */   // Label 10614: @664663
     /*  664663 */   GIM_Try, /*On fail goto*//*Label 10615*/ GIMT_Encode4(664738), // Rule ID 10288 //
     /*  664668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  664679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  664682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  664685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  664688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664736 */     GIR_RootConstrainSelectedInstOperands,
     /*  664737 */     // GIR_Coverage, 10288,
     /*  664737 */     GIR_EraseRootFromParent_Done,
     /*  664738 */   // Label 10615: @664738
     /*  664738 */   GIM_Try, /*On fail goto*//*Label 10616*/ GIMT_Encode4(664813), // Rule ID 10289 //
     /*  664743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  664754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  664757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  664760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  664763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664789 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664811 */     GIR_RootConstrainSelectedInstOperands,
     /*  664812 */     // GIR_Coverage, 10289,
     /*  664812 */     GIR_EraseRootFromParent_Done,
     /*  664813 */   // Label 10616: @664813
     /*  664813 */   GIM_Try, /*On fail goto*//*Label 10617*/ GIMT_Encode4(664888), // Rule ID 10292 //
     /*  664818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  664829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  664832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  664835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  664838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664864 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664886 */     GIR_RootConstrainSelectedInstOperands,
     /*  664887 */     // GIR_Coverage, 10292,
     /*  664887 */     GIR_EraseRootFromParent_Done,
     /*  664888 */   // Label 10617: @664888
     /*  664888 */   GIM_Try, /*On fail goto*//*Label 10618*/ GIMT_Encode4(664963), // Rule ID 10293 //
     /*  664893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  664904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  664907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  664910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  664913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664939 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664961 */     GIR_RootConstrainSelectedInstOperands,
     /*  664962 */     // GIR_Coverage, 10293,
     /*  664962 */     GIR_EraseRootFromParent_Done,
     /*  664963 */   // Label 10618: @664963
     /*  664963 */   GIM_Try, /*On fail goto*//*Label 10619*/ GIMT_Encode4(665038), // Rule ID 10296 //
     /*  664968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  664971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  664979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  664982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  664985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  664988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  665014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  665033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665036 */     GIR_RootConstrainSelectedInstOperands,
     /*  665037 */     // GIR_Coverage, 10296,
     /*  665037 */     GIR_EraseRootFromParent_Done,
     /*  665038 */   // Label 10619: @665038
     /*  665038 */   GIM_Try, /*On fail goto*//*Label 10620*/ GIMT_Encode4(665113), // Rule ID 10297 //
     /*  665043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  665046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  665054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  665057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  665060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  665063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665089 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  665089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  665108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665111 */     GIR_RootConstrainSelectedInstOperands,
     /*  665112 */     // GIR_Coverage, 10297,
     /*  665112 */     GIR_EraseRootFromParent_Done,
     /*  665113 */   // Label 10620: @665113
     /*  665113 */   GIM_Try, /*On fail goto*//*Label 10621*/ GIMT_Encode4(665188), // Rule ID 10300 //
     /*  665118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  665129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  665132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  665135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  665138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665186 */     GIR_RootConstrainSelectedInstOperands,
     /*  665187 */     // GIR_Coverage, 10300,
     /*  665187 */     GIR_EraseRootFromParent_Done,
     /*  665188 */   // Label 10621: @665188
     /*  665188 */   GIM_Try, /*On fail goto*//*Label 10622*/ GIMT_Encode4(665263), // Rule ID 10301 //
     /*  665193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  665204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  665207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  665210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  665213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665239 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665261 */     GIR_RootConstrainSelectedInstOperands,
     /*  665262 */     // GIR_Coverage, 10301,
     /*  665262 */     GIR_EraseRootFromParent_Done,
     /*  665263 */   // Label 10622: @665263
     /*  665263 */   GIM_Try, /*On fail goto*//*Label 10623*/ GIMT_Encode4(665338), // Rule ID 10304 //
     /*  665268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  665279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  665282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  665285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  665288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665314 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665336 */     GIR_RootConstrainSelectedInstOperands,
     /*  665337 */     // GIR_Coverage, 10304,
     /*  665337 */     GIR_EraseRootFromParent_Done,
     /*  665338 */   // Label 10623: @665338
     /*  665338 */   GIM_Try, /*On fail goto*//*Label 10624*/ GIMT_Encode4(665413), // Rule ID 10305 //
     /*  665343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  665354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  665357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  665360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  665363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665389 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665411 */     GIR_RootConstrainSelectedInstOperands,
     /*  665412 */     // GIR_Coverage, 10305,
     /*  665412 */     GIR_EraseRootFromParent_Done,
     /*  665413 */   // Label 10624: @665413
     /*  665413 */   GIM_Try, /*On fail goto*//*Label 10625*/ GIMT_Encode4(665488), // Rule ID 10308 //
     /*  665418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  665429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  665432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  665435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  665438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665464 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665486 */     GIR_RootConstrainSelectedInstOperands,
     /*  665487 */     // GIR_Coverage, 10308,
     /*  665487 */     GIR_EraseRootFromParent_Done,
     /*  665488 */   // Label 10625: @665488
     /*  665488 */   GIM_Try, /*On fail goto*//*Label 10626*/ GIMT_Encode4(665563), // Rule ID 10309 //
     /*  665493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  665504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  665507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  665510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  665513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665539 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665561 */     GIR_RootConstrainSelectedInstOperands,
     /*  665562 */     // GIR_Coverage, 10309,
     /*  665562 */     GIR_EraseRootFromParent_Done,
     /*  665563 */   // Label 10626: @665563
     /*  665563 */   GIM_Try, /*On fail goto*//*Label 10627*/ GIMT_Encode4(665638), // Rule ID 10312 //
     /*  665568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  665579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  665582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  665585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  665588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665614 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  665614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665636 */     GIR_RootConstrainSelectedInstOperands,
     /*  665637 */     // GIR_Coverage, 10312,
     /*  665637 */     GIR_EraseRootFromParent_Done,
     /*  665638 */   // Label 10627: @665638
     /*  665638 */   GIM_Try, /*On fail goto*//*Label 10628*/ GIMT_Encode4(665713), // Rule ID 10313 //
     /*  665643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  665654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  665657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  665660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  665663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665689 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  665689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665711 */     GIR_RootConstrainSelectedInstOperands,
     /*  665712 */     // GIR_Coverage, 10313,
     /*  665712 */     GIR_EraseRootFromParent_Done,
     /*  665713 */   // Label 10628: @665713
     /*  665713 */   GIM_Try, /*On fail goto*//*Label 10629*/ GIMT_Encode4(665788), // Rule ID 10316 //
     /*  665718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  665729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  665732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  665735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  665738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665764 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  665764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665786 */     GIR_RootConstrainSelectedInstOperands,
     /*  665787 */     // GIR_Coverage, 10316,
     /*  665787 */     GIR_EraseRootFromParent_Done,
     /*  665788 */   // Label 10629: @665788
     /*  665788 */   GIM_Try, /*On fail goto*//*Label 10630*/ GIMT_Encode4(665863), // Rule ID 10317 //
     /*  665793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  665804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  665807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  665810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  665813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665839 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  665839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665861 */     GIR_RootConstrainSelectedInstOperands,
     /*  665862 */     // GIR_Coverage, 10317,
     /*  665862 */     GIR_EraseRootFromParent_Done,
     /*  665863 */   // Label 10630: @665863
     /*  665863 */   GIM_Try, /*On fail goto*//*Label 10631*/ GIMT_Encode4(665938), // Rule ID 10320 //
     /*  665868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  665879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  665882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  665885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  665888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665914 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  665914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665936 */     GIR_RootConstrainSelectedInstOperands,
     /*  665937 */     // GIR_Coverage, 10320,
     /*  665937 */     GIR_EraseRootFromParent_Done,
     /*  665938 */   // Label 10631: @665938
     /*  665938 */   GIM_Try, /*On fail goto*//*Label 10632*/ GIMT_Encode4(666013), // Rule ID 10321 //
     /*  665943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  665954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  665957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  665960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  665963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665989 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  665989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666011 */     GIR_RootConstrainSelectedInstOperands,
     /*  666012 */     // GIR_Coverage, 10321,
     /*  666012 */     GIR_EraseRootFromParent_Done,
     /*  666013 */   // Label 10632: @666013
     /*  666013 */   GIM_Try, /*On fail goto*//*Label 10633*/ GIMT_Encode4(666088), // Rule ID 10324 //
     /*  666018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  666029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  666032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  666035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  666038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666086 */     GIR_RootConstrainSelectedInstOperands,
     /*  666087 */     // GIR_Coverage, 10324,
     /*  666087 */     GIR_EraseRootFromParent_Done,
     /*  666088 */   // Label 10633: @666088
     /*  666088 */   GIM_Try, /*On fail goto*//*Label 10634*/ GIMT_Encode4(666163), // Rule ID 10325 //
     /*  666093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  666104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  666107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  666110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  666113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666161 */     GIR_RootConstrainSelectedInstOperands,
     /*  666162 */     // GIR_Coverage, 10325,
     /*  666162 */     GIR_EraseRootFromParent_Done,
     /*  666163 */   // Label 10634: @666163
     /*  666163 */   GIM_Try, /*On fail goto*//*Label 10635*/ GIMT_Encode4(666238), // Rule ID 10328 //
     /*  666168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  666179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  666182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  666185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  666188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666236 */     GIR_RootConstrainSelectedInstOperands,
     /*  666237 */     // GIR_Coverage, 10328,
     /*  666237 */     GIR_EraseRootFromParent_Done,
     /*  666238 */   // Label 10635: @666238
     /*  666238 */   GIM_Try, /*On fail goto*//*Label 10636*/ GIMT_Encode4(666313), // Rule ID 10329 //
     /*  666243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  666254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  666257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  666260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  666263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666289 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666311 */     GIR_RootConstrainSelectedInstOperands,
     /*  666312 */     // GIR_Coverage, 10329,
     /*  666312 */     GIR_EraseRootFromParent_Done,
     /*  666313 */   // Label 10636: @666313
     /*  666313 */   GIM_Try, /*On fail goto*//*Label 10637*/ GIMT_Encode4(666388), // Rule ID 10332 //
     /*  666318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  666329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  666332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  666335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  666338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666386 */     GIR_RootConstrainSelectedInstOperands,
     /*  666387 */     // GIR_Coverage, 10332,
     /*  666387 */     GIR_EraseRootFromParent_Done,
     /*  666388 */   // Label 10637: @666388
     /*  666388 */   GIM_Try, /*On fail goto*//*Label 10638*/ GIMT_Encode4(666463), // Rule ID 10333 //
     /*  666393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  666404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  666407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  666410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  666413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666439 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666461 */     GIR_RootConstrainSelectedInstOperands,
     /*  666462 */     // GIR_Coverage, 10333,
     /*  666462 */     GIR_EraseRootFromParent_Done,
     /*  666463 */   // Label 10638: @666463
     /*  666463 */   GIM_Try, /*On fail goto*//*Label 10639*/ GIMT_Encode4(666538), // Rule ID 10336 //
     /*  666468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  666471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  666479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  666482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  666485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  666488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666514 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  666514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666536 */     GIR_RootConstrainSelectedInstOperands,
     /*  666537 */     // GIR_Coverage, 10336,
     /*  666537 */     GIR_EraseRootFromParent_Done,
     /*  666538 */   // Label 10639: @666538
     /*  666538 */   GIM_Try, /*On fail goto*//*Label 10640*/ GIMT_Encode4(666613), // Rule ID 10337 //
     /*  666543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  666546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  666554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  666557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  666560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  666563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666589 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  666589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666611 */     GIR_RootConstrainSelectedInstOperands,
     /*  666612 */     // GIR_Coverage, 10337,
     /*  666612 */     GIR_EraseRootFromParent_Done,
     /*  666613 */   // Label 10640: @666613
     /*  666613 */   GIM_Try, /*On fail goto*//*Label 10641*/ GIMT_Encode4(666688), // Rule ID 10340 //
     /*  666618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  666621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  666629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  666632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  666635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  666638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666664 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  666664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666686 */     GIR_RootConstrainSelectedInstOperands,
     /*  666687 */     // GIR_Coverage, 10340,
     /*  666687 */     GIR_EraseRootFromParent_Done,
     /*  666688 */   // Label 10641: @666688
     /*  666688 */   GIM_Try, /*On fail goto*//*Label 10642*/ GIMT_Encode4(666763), // Rule ID 10341 //
     /*  666693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  666696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  666704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  666707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  666710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  666713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666739 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  666739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666761 */     GIR_RootConstrainSelectedInstOperands,
     /*  666762 */     // GIR_Coverage, 10341,
     /*  666762 */     GIR_EraseRootFromParent_Done,
     /*  666763 */   // Label 10642: @666763
     /*  666763 */   GIM_Try, /*On fail goto*//*Label 10643*/ GIMT_Encode4(666838), // Rule ID 10344 //
     /*  666768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  666771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  666779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  666782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  666785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  666788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666814 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  666814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666836 */     GIR_RootConstrainSelectedInstOperands,
     /*  666837 */     // GIR_Coverage, 10344,
     /*  666837 */     GIR_EraseRootFromParent_Done,
     /*  666838 */   // Label 10643: @666838
     /*  666838 */   GIM_Try, /*On fail goto*//*Label 10644*/ GIMT_Encode4(666913), // Rule ID 10345 //
     /*  666843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  666846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  666854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  666857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  666860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  666863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666889 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  666889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666911 */     GIR_RootConstrainSelectedInstOperands,
     /*  666912 */     // GIR_Coverage, 10345,
     /*  666912 */     GIR_EraseRootFromParent_Done,
     /*  666913 */   // Label 10644: @666913
     /*  666913 */   GIM_Try, /*On fail goto*//*Label 10645*/ GIMT_Encode4(666988), // Rule ID 10348 //
     /*  666918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  666929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  666932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  666935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666964 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  666964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  666967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666986 */     GIR_RootConstrainSelectedInstOperands,
     /*  666987 */     // GIR_Coverage, 10348,
     /*  666987 */     GIR_EraseRootFromParent_Done,
     /*  666988 */   // Label 10645: @666988
     /*  666988 */   GIM_Try, /*On fail goto*//*Label 10646*/ GIMT_Encode4(667063), // Rule ID 10349 //
     /*  666993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  667004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  667007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  667010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667039 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  667042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667061 */     GIR_RootConstrainSelectedInstOperands,
     /*  667062 */     // GIR_Coverage, 10349,
     /*  667062 */     GIR_EraseRootFromParent_Done,
     /*  667063 */   // Label 10646: @667063
     /*  667063 */   GIM_Try, /*On fail goto*//*Label 10647*/ GIMT_Encode4(667138), // Rule ID 10352 //
     /*  667068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  667079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  667082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  667085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667114 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667136 */     GIR_RootConstrainSelectedInstOperands,
     /*  667137 */     // GIR_Coverage, 10352,
     /*  667137 */     GIR_EraseRootFromParent_Done,
     /*  667138 */   // Label 10647: @667138
     /*  667138 */   GIM_Try, /*On fail goto*//*Label 10648*/ GIMT_Encode4(667213), // Rule ID 10353 //
     /*  667143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  667154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  667157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  667160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667189 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667211 */     GIR_RootConstrainSelectedInstOperands,
     /*  667212 */     // GIR_Coverage, 10353,
     /*  667212 */     GIR_EraseRootFromParent_Done,
     /*  667213 */   // Label 10648: @667213
     /*  667213 */   GIM_Try, /*On fail goto*//*Label 10649*/ GIMT_Encode4(667288), // Rule ID 10356 //
     /*  667218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  667229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  667232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  667235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667264 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667286 */     GIR_RootConstrainSelectedInstOperands,
     /*  667287 */     // GIR_Coverage, 10356,
     /*  667287 */     GIR_EraseRootFromParent_Done,
     /*  667288 */   // Label 10649: @667288
     /*  667288 */   GIM_Try, /*On fail goto*//*Label 10650*/ GIMT_Encode4(667363), // Rule ID 10357 //
     /*  667293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  667304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  667307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  667310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667339 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667361 */     GIR_RootConstrainSelectedInstOperands,
     /*  667362 */     // GIR_Coverage, 10357,
     /*  667362 */     GIR_EraseRootFromParent_Done,
     /*  667363 */   // Label 10650: @667363
     /*  667363 */   GIM_Try, /*On fail goto*//*Label 10651*/ GIMT_Encode4(667438), // Rule ID 10360 //
     /*  667368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  667379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  667382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  667385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667414 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  667414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667436 */     GIR_RootConstrainSelectedInstOperands,
     /*  667437 */     // GIR_Coverage, 10360,
     /*  667437 */     GIR_EraseRootFromParent_Done,
     /*  667438 */   // Label 10651: @667438
     /*  667438 */   GIM_Try, /*On fail goto*//*Label 10652*/ GIMT_Encode4(667513), // Rule ID 10361 //
     /*  667443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  667454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  667457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  667460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667489 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  667489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667511 */     GIR_RootConstrainSelectedInstOperands,
     /*  667512 */     // GIR_Coverage, 10361,
     /*  667512 */     GIR_EraseRootFromParent_Done,
     /*  667513 */   // Label 10652: @667513
     /*  667513 */   GIM_Try, /*On fail goto*//*Label 10653*/ GIMT_Encode4(667588), // Rule ID 10364 //
     /*  667518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  667529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  667532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  667535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  667564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667586 */     GIR_RootConstrainSelectedInstOperands,
     /*  667587 */     // GIR_Coverage, 10364,
     /*  667587 */     GIR_EraseRootFromParent_Done,
     /*  667588 */   // Label 10653: @667588
     /*  667588 */   GIM_Try, /*On fail goto*//*Label 10654*/ GIMT_Encode4(667663), // Rule ID 10365 //
     /*  667593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  667604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  667607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  667610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667639 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  667639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667661 */     GIR_RootConstrainSelectedInstOperands,
     /*  667662 */     // GIR_Coverage, 10365,
     /*  667662 */     GIR_EraseRootFromParent_Done,
     /*  667663 */   // Label 10654: @667663
     /*  667663 */   GIM_Try, /*On fail goto*//*Label 10655*/ GIMT_Encode4(667738), // Rule ID 10368 //
     /*  667668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  667679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  667682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  667685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  667714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667736 */     GIR_RootConstrainSelectedInstOperands,
     /*  667737 */     // GIR_Coverage, 10368,
     /*  667737 */     GIR_EraseRootFromParent_Done,
     /*  667738 */   // Label 10655: @667738
     /*  667738 */   GIM_Try, /*On fail goto*//*Label 10656*/ GIMT_Encode4(667813), // Rule ID 10369 //
     /*  667743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  667754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  667757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  667760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667789 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  667789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667811 */     GIR_RootConstrainSelectedInstOperands,
     /*  667812 */     // GIR_Coverage, 10369,
     /*  667812 */     GIR_EraseRootFromParent_Done,
     /*  667813 */   // Label 10656: @667813
     /*  667813 */   GIM_Try, /*On fail goto*//*Label 10657*/ GIMT_Encode4(667888), // Rule ID 10372 //
     /*  667818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  667829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  667832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  667835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667864 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  667867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667886 */     GIR_RootConstrainSelectedInstOperands,
     /*  667887 */     // GIR_Coverage, 10372,
     /*  667887 */     GIR_EraseRootFromParent_Done,
     /*  667888 */   // Label 10657: @667888
     /*  667888 */   GIM_Try, /*On fail goto*//*Label 10658*/ GIMT_Encode4(667963), // Rule ID 10373 //
     /*  667893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  667904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  667907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  667910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667939 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  667942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667961 */     GIR_RootConstrainSelectedInstOperands,
     /*  667962 */     // GIR_Coverage, 10373,
     /*  667962 */     GIR_EraseRootFromParent_Done,
     /*  667963 */   // Label 10658: @667963
     /*  667963 */   GIM_Try, /*On fail goto*//*Label 10659*/ GIMT_Encode4(668038), // Rule ID 10376 //
     /*  667968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  667979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  667982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  667985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668014 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668036 */     GIR_RootConstrainSelectedInstOperands,
     /*  668037 */     // GIR_Coverage, 10376,
     /*  668037 */     GIR_EraseRootFromParent_Done,
     /*  668038 */   // Label 10659: @668038
     /*  668038 */   GIM_Try, /*On fail goto*//*Label 10660*/ GIMT_Encode4(668113), // Rule ID 10377 //
     /*  668043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  668054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  668057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  668060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668089 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668111 */     GIR_RootConstrainSelectedInstOperands,
     /*  668112 */     // GIR_Coverage, 10377,
     /*  668112 */     GIR_EraseRootFromParent_Done,
     /*  668113 */   // Label 10660: @668113
     /*  668113 */   GIM_Try, /*On fail goto*//*Label 10661*/ GIMT_Encode4(668188), // Rule ID 10380 //
     /*  668118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  668129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  668132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  668135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668186 */     GIR_RootConstrainSelectedInstOperands,
     /*  668187 */     // GIR_Coverage, 10380,
     /*  668187 */     GIR_EraseRootFromParent_Done,
     /*  668188 */   // Label 10661: @668188
     /*  668188 */   GIM_Try, /*On fail goto*//*Label 10662*/ GIMT_Encode4(668263), // Rule ID 10381 //
     /*  668193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  668204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  668207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  668210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668239 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  668239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668261 */     GIR_RootConstrainSelectedInstOperands,
     /*  668262 */     // GIR_Coverage, 10381,
     /*  668262 */     GIR_EraseRootFromParent_Done,
     /*  668263 */   // Label 10662: @668263
     /*  668263 */   GIM_Try, /*On fail goto*//*Label 10663*/ GIMT_Encode4(668338), // Rule ID 10384 //
     /*  668268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  668271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  668279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  668282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  668285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668314 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  668314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668336 */     GIR_RootConstrainSelectedInstOperands,
     /*  668337 */     // GIR_Coverage, 10384,
     /*  668337 */     GIR_EraseRootFromParent_Done,
     /*  668338 */   // Label 10663: @668338
     /*  668338 */   GIM_Try, /*On fail goto*//*Label 10664*/ GIMT_Encode4(668413), // Rule ID 10385 //
     /*  668343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  668346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  668354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  668357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  668360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668389 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  668389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668411 */     GIR_RootConstrainSelectedInstOperands,
     /*  668412 */     // GIR_Coverage, 10385,
     /*  668412 */     GIR_EraseRootFromParent_Done,
     /*  668413 */   // Label 10664: @668413
     /*  668413 */   GIM_Try, /*On fail goto*//*Label 10665*/ GIMT_Encode4(668488), // Rule ID 10388 //
     /*  668418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  668429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  668432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  668435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668464 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668486 */     GIR_RootConstrainSelectedInstOperands,
     /*  668487 */     // GIR_Coverage, 10388,
     /*  668487 */     GIR_EraseRootFromParent_Done,
     /*  668488 */   // Label 10665: @668488
     /*  668488 */   GIM_Try, /*On fail goto*//*Label 10666*/ GIMT_Encode4(668563), // Rule ID 10389 //
     /*  668493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  668504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  668507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  668510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668539 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668561 */     GIR_RootConstrainSelectedInstOperands,
     /*  668562 */     // GIR_Coverage, 10389,
     /*  668562 */     GIR_EraseRootFromParent_Done,
     /*  668563 */   // Label 10666: @668563
     /*  668563 */   GIM_Try, /*On fail goto*//*Label 10667*/ GIMT_Encode4(668638), // Rule ID 10392 //
     /*  668568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  668579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  668582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  668585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668614 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  668617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668636 */     GIR_RootConstrainSelectedInstOperands,
     /*  668637 */     // GIR_Coverage, 10392,
     /*  668637 */     GIR_EraseRootFromParent_Done,
     /*  668638 */   // Label 10667: @668638
     /*  668638 */   GIM_Try, /*On fail goto*//*Label 10668*/ GIMT_Encode4(668713), // Rule ID 10393 //
     /*  668643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  668654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  668657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  668660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668689 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  668692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668711 */     GIR_RootConstrainSelectedInstOperands,
     /*  668712 */     // GIR_Coverage, 10393,
     /*  668712 */     GIR_EraseRootFromParent_Done,
     /*  668713 */   // Label 10668: @668713
     /*  668713 */   GIM_Try, /*On fail goto*//*Label 10669*/ GIMT_Encode4(668788), // Rule ID 10396 //
     /*  668718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  668729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  668732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  668735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668764 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  668767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668786 */     GIR_RootConstrainSelectedInstOperands,
     /*  668787 */     // GIR_Coverage, 10396,
     /*  668787 */     GIR_EraseRootFromParent_Done,
     /*  668788 */   // Label 10669: @668788
     /*  668788 */   GIM_Try, /*On fail goto*//*Label 10670*/ GIMT_Encode4(668863), // Rule ID 10397 //
     /*  668793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  668804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  668807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  668810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668839 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  668842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668861 */     GIR_RootConstrainSelectedInstOperands,
     /*  668862 */     // GIR_Coverage, 10397,
     /*  668862 */     GIR_EraseRootFromParent_Done,
     /*  668863 */   // Label 10670: @668863
     /*  668863 */   GIM_Try, /*On fail goto*//*Label 10671*/ GIMT_Encode4(668938), // Rule ID 10400 //
     /*  668868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  668879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  668882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  668885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668936 */     GIR_RootConstrainSelectedInstOperands,
     /*  668937 */     // GIR_Coverage, 10400,
     /*  668937 */     GIR_EraseRootFromParent_Done,
     /*  668938 */   // Label 10671: @668938
     /*  668938 */   GIM_Try, /*On fail goto*//*Label 10672*/ GIMT_Encode4(669013), // Rule ID 10401 //
     /*  668943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  668954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  668957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  668960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668989 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669011 */     GIR_RootConstrainSelectedInstOperands,
     /*  669012 */     // GIR_Coverage, 10401,
     /*  669012 */     GIR_EraseRootFromParent_Done,
     /*  669013 */   // Label 10672: @669013
     /*  669013 */   GIM_Try, /*On fail goto*//*Label 10673*/ GIMT_Encode4(669088), // Rule ID 10404 //
     /*  669018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  669029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  669032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  669035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669086 */     GIR_RootConstrainSelectedInstOperands,
     /*  669087 */     // GIR_Coverage, 10404,
     /*  669087 */     GIR_EraseRootFromParent_Done,
     /*  669088 */   // Label 10673: @669088
     /*  669088 */   GIM_Try, /*On fail goto*//*Label 10674*/ GIMT_Encode4(669163), // Rule ID 10405 //
     /*  669093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  669104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  669107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  669110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669139 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669161 */     GIR_RootConstrainSelectedInstOperands,
     /*  669162 */     // GIR_Coverage, 10405,
     /*  669162 */     GIR_EraseRootFromParent_Done,
     /*  669163 */   // Label 10674: @669163
     /*  669163 */   GIM_Try, /*On fail goto*//*Label 10675*/ GIMT_Encode4(669238), // Rule ID 10408 //
     /*  669168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  669179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  669182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  669185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669214 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669236 */     GIR_RootConstrainSelectedInstOperands,
     /*  669237 */     // GIR_Coverage, 10408,
     /*  669237 */     GIR_EraseRootFromParent_Done,
     /*  669238 */   // Label 10675: @669238
     /*  669238 */   GIM_Try, /*On fail goto*//*Label 10676*/ GIMT_Encode4(669313), // Rule ID 10409 //
     /*  669243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  669254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  669257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  669260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669289 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669311 */     GIR_RootConstrainSelectedInstOperands,
     /*  669312 */     // GIR_Coverage, 10409,
     /*  669312 */     GIR_EraseRootFromParent_Done,
     /*  669313 */   // Label 10676: @669313
     /*  669313 */   GIM_Try, /*On fail goto*//*Label 10677*/ GIMT_Encode4(669388), // Rule ID 10412 //
     /*  669318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  669329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  669332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  669335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669386 */     GIR_RootConstrainSelectedInstOperands,
     /*  669387 */     // GIR_Coverage, 10412,
     /*  669387 */     GIR_EraseRootFromParent_Done,
     /*  669388 */   // Label 10677: @669388
     /*  669388 */   GIM_Try, /*On fail goto*//*Label 10678*/ GIMT_Encode4(669463), // Rule ID 10413 //
     /*  669393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  669404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  669407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  669410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  669439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669461 */     GIR_RootConstrainSelectedInstOperands,
     /*  669462 */     // GIR_Coverage, 10413,
     /*  669462 */     GIR_EraseRootFromParent_Done,
     /*  669463 */   // Label 10678: @669463
     /*  669463 */   GIM_Try, /*On fail goto*//*Label 10679*/ GIMT_Encode4(669538), // Rule ID 10416 //
     /*  669468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  669479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  669482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  669485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669536 */     GIR_RootConstrainSelectedInstOperands,
     /*  669537 */     // GIR_Coverage, 10416,
     /*  669537 */     GIR_EraseRootFromParent_Done,
     /*  669538 */   // Label 10679: @669538
     /*  669538 */   GIM_Try, /*On fail goto*//*Label 10680*/ GIMT_Encode4(669613), // Rule ID 10417 //
     /*  669543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  669554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  669557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  669560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669589 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  669589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669611 */     GIR_RootConstrainSelectedInstOperands,
     /*  669612 */     // GIR_Coverage, 10417,
     /*  669612 */     GIR_EraseRootFromParent_Done,
     /*  669613 */   // Label 10680: @669613
     /*  669613 */   GIM_Try, /*On fail goto*//*Label 10681*/ GIMT_Encode4(669688), // Rule ID 10420 //
     /*  669618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  669629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  669632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  669635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669664 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669686 */     GIR_RootConstrainSelectedInstOperands,
     /*  669687 */     // GIR_Coverage, 10420,
     /*  669687 */     GIR_EraseRootFromParent_Done,
     /*  669688 */   // Label 10681: @669688
     /*  669688 */   GIM_Try, /*On fail goto*//*Label 10682*/ GIMT_Encode4(669763), // Rule ID 10421 //
     /*  669693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  669704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  669707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  669710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669739 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  669739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669761 */     GIR_RootConstrainSelectedInstOperands,
     /*  669762 */     // GIR_Coverage, 10421,
     /*  669762 */     GIR_EraseRootFromParent_Done,
     /*  669763 */   // Label 10682: @669763
     /*  669763 */   GIM_Try, /*On fail goto*//*Label 10683*/ GIMT_Encode4(669838), // Rule ID 10424 //
     /*  669768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  669771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  669779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  669782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  669785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  669814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  669833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669836 */     GIR_RootConstrainSelectedInstOperands,
     /*  669837 */     // GIR_Coverage, 10424,
     /*  669837 */     GIR_EraseRootFromParent_Done,
     /*  669838 */   // Label 10683: @669838
     /*  669838 */   GIM_Try, /*On fail goto*//*Label 10684*/ GIMT_Encode4(669913), // Rule ID 10425 //
     /*  669843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  669846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  669854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  669857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  669860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669889 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  669889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  669908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669911 */     GIR_RootConstrainSelectedInstOperands,
     /*  669912 */     // GIR_Coverage, 10425,
     /*  669912 */     GIR_EraseRootFromParent_Done,
     /*  669913 */   // Label 10684: @669913
     /*  669913 */   GIM_Try, /*On fail goto*//*Label 10685*/ GIMT_Encode4(669988), // Rule ID 10428 //
     /*  669918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  669921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  669929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  669932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  669935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669964 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  669964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  669983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669986 */     GIR_RootConstrainSelectedInstOperands,
     /*  669987 */     // GIR_Coverage, 10428,
     /*  669987 */     GIR_EraseRootFromParent_Done,
     /*  669988 */   // Label 10685: @669988
     /*  669988 */   GIM_Try, /*On fail goto*//*Label 10686*/ GIMT_Encode4(670063), // Rule ID 10429 //
     /*  669993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  669996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  670004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  670007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  670010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670039 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  670042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670061 */     GIR_RootConstrainSelectedInstOperands,
     /*  670062 */     // GIR_Coverage, 10429,
     /*  670062 */     GIR_EraseRootFromParent_Done,
     /*  670063 */   // Label 10686: @670063
     /*  670063 */   GIM_Try, /*On fail goto*//*Label 10687*/ GIMT_Encode4(670138), // Rule ID 10432 //
     /*  670068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  670079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  670082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  670085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  670117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670136 */     GIR_RootConstrainSelectedInstOperands,
     /*  670137 */     // GIR_Coverage, 10432,
     /*  670137 */     GIR_EraseRootFromParent_Done,
     /*  670138 */   // Label 10687: @670138
     /*  670138 */   GIM_Try, /*On fail goto*//*Label 10688*/ GIMT_Encode4(670213), // Rule ID 10433 //
     /*  670143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  670154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  670157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  670160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670189 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  670192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670211 */     GIR_RootConstrainSelectedInstOperands,
     /*  670212 */     // GIR_Coverage, 10433,
     /*  670212 */     GIR_EraseRootFromParent_Done,
     /*  670213 */   // Label 10688: @670213
     /*  670213 */   GIM_Try, /*On fail goto*//*Label 10689*/ GIMT_Encode4(670288), // Rule ID 10436 //
     /*  670218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  670229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  670232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  670235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  670238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670264 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  670267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670286 */     GIR_RootConstrainSelectedInstOperands,
     /*  670287 */     // GIR_Coverage, 10436,
     /*  670287 */     GIR_EraseRootFromParent_Done,
     /*  670288 */   // Label 10689: @670288
     /*  670288 */   GIM_Try, /*On fail goto*//*Label 10690*/ GIMT_Encode4(670363), // Rule ID 10437 //
     /*  670293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  670304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  670307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  670310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  670313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670339 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  670342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670361 */     GIR_RootConstrainSelectedInstOperands,
     /*  670362 */     // GIR_Coverage, 10437,
     /*  670362 */     GIR_EraseRootFromParent_Done,
     /*  670363 */   // Label 10690: @670363
     /*  670363 */   GIM_Try, /*On fail goto*//*Label 10691*/ GIMT_Encode4(670438), // Rule ID 10440 //
     /*  670368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  670379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  670382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  670385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  670388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670414 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670436 */     GIR_RootConstrainSelectedInstOperands,
     /*  670437 */     // GIR_Coverage, 10440,
     /*  670437 */     GIR_EraseRootFromParent_Done,
     /*  670438 */   // Label 10691: @670438
     /*  670438 */   GIM_Try, /*On fail goto*//*Label 10692*/ GIMT_Encode4(670513), // Rule ID 10441 //
     /*  670443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  670454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  670457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  670460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  670463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670489 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670511 */     GIR_RootConstrainSelectedInstOperands,
     /*  670512 */     // GIR_Coverage, 10441,
     /*  670512 */     GIR_EraseRootFromParent_Done,
     /*  670513 */   // Label 10692: @670513
     /*  670513 */   GIM_Try, /*On fail goto*//*Label 10693*/ GIMT_Encode4(670588), // Rule ID 10444 //
     /*  670518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  670529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  670532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  670535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  670538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670564 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670586 */     GIR_RootConstrainSelectedInstOperands,
     /*  670587 */     // GIR_Coverage, 10444,
     /*  670587 */     GIR_EraseRootFromParent_Done,
     /*  670588 */   // Label 10693: @670588
     /*  670588 */   GIM_Try, /*On fail goto*//*Label 10694*/ GIMT_Encode4(670663), // Rule ID 10445 //
     /*  670593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  670604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  670607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  670610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  670613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670639 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670661 */     GIR_RootConstrainSelectedInstOperands,
     /*  670662 */     // GIR_Coverage, 10445,
     /*  670662 */     GIR_EraseRootFromParent_Done,
     /*  670663 */   // Label 10694: @670663
     /*  670663 */   GIM_Try, /*On fail goto*//*Label 10695*/ GIMT_Encode4(670738), // Rule ID 10448 //
     /*  670668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  670679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  670682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  670685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  670688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670714 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  670714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670736 */     GIR_RootConstrainSelectedInstOperands,
     /*  670737 */     // GIR_Coverage, 10448,
     /*  670737 */     GIR_EraseRootFromParent_Done,
     /*  670738 */   // Label 10695: @670738
     /*  670738 */   GIM_Try, /*On fail goto*//*Label 10696*/ GIMT_Encode4(670813), // Rule ID 10449 //
     /*  670743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  670754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  670757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  670760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  670763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670789 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  670789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670811 */     GIR_RootConstrainSelectedInstOperands,
     /*  670812 */     // GIR_Coverage, 10449,
     /*  670812 */     GIR_EraseRootFromParent_Done,
     /*  670813 */   // Label 10696: @670813
     /*  670813 */   GIM_Try, /*On fail goto*//*Label 10697*/ GIMT_Encode4(670888), // Rule ID 10452 //
     /*  670818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  670829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  670832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  670835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  670838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670864 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  670864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670886 */     GIR_RootConstrainSelectedInstOperands,
     /*  670887 */     // GIR_Coverage, 10452,
     /*  670887 */     GIR_EraseRootFromParent_Done,
     /*  670888 */   // Label 10697: @670888
     /*  670888 */   GIM_Try, /*On fail goto*//*Label 10698*/ GIMT_Encode4(670963), // Rule ID 10453 //
     /*  670893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  670904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  670907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  670910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  670913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670939 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  670939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670961 */     GIR_RootConstrainSelectedInstOperands,
     /*  670962 */     // GIR_Coverage, 10453,
     /*  670962 */     GIR_EraseRootFromParent_Done,
     /*  670963 */   // Label 10698: @670963
     /*  670963 */   GIM_Try, /*On fail goto*//*Label 10699*/ GIMT_Encode4(671038), // Rule ID 10456 //
     /*  670968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  670979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  670982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  670985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  670988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671036 */     GIR_RootConstrainSelectedInstOperands,
     /*  671037 */     // GIR_Coverage, 10456,
     /*  671037 */     GIR_EraseRootFromParent_Done,
     /*  671038 */   // Label 10699: @671038
     /*  671038 */   GIM_Try, /*On fail goto*//*Label 10700*/ GIMT_Encode4(671113), // Rule ID 10457 //
     /*  671043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  671054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  671057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  671060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  671063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671089 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  671089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671111 */     GIR_RootConstrainSelectedInstOperands,
     /*  671112 */     // GIR_Coverage, 10457,
     /*  671112 */     GIR_EraseRootFromParent_Done,
     /*  671113 */   // Label 10700: @671113
     /*  671113 */   GIM_Try, /*On fail goto*//*Label 10701*/ GIMT_Encode4(671188), // Rule ID 10460 //
     /*  671118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  671129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  671132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  671135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  671138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671164 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671186 */     GIR_RootConstrainSelectedInstOperands,
     /*  671187 */     // GIR_Coverage, 10460,
     /*  671187 */     GIR_EraseRootFromParent_Done,
     /*  671188 */   // Label 10701: @671188
     /*  671188 */   GIM_Try, /*On fail goto*//*Label 10702*/ GIMT_Encode4(671263), // Rule ID 10461 //
     /*  671193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  671204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  671207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  671210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  671213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671239 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671261 */     GIR_RootConstrainSelectedInstOperands,
     /*  671262 */     // GIR_Coverage, 10461,
     /*  671262 */     GIR_EraseRootFromParent_Done,
     /*  671263 */   // Label 10702: @671263
     /*  671263 */   GIM_Try, /*On fail goto*//*Label 10703*/ GIMT_Encode4(671338), // Rule ID 10464 //
     /*  671268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  671279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  671282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  671285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  671288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671314 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671336 */     GIR_RootConstrainSelectedInstOperands,
     /*  671337 */     // GIR_Coverage, 10464,
     /*  671337 */     GIR_EraseRootFromParent_Done,
     /*  671338 */   // Label 10703: @671338
     /*  671338 */   GIM_Try, /*On fail goto*//*Label 10704*/ GIMT_Encode4(671413), // Rule ID 10465 //
     /*  671343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  671354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  671357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  671360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  671363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671389 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671411 */     GIR_RootConstrainSelectedInstOperands,
     /*  671412 */     // GIR_Coverage, 10465,
     /*  671412 */     GIR_EraseRootFromParent_Done,
     /*  671413 */   // Label 10704: @671413
     /*  671413 */   GIM_Try, /*On fail goto*//*Label 10705*/ GIMT_Encode4(671488), // Rule ID 10468 //
     /*  671418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  671429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  671432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  671435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  671438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671486 */     GIR_RootConstrainSelectedInstOperands,
     /*  671487 */     // GIR_Coverage, 10468,
     /*  671487 */     GIR_EraseRootFromParent_Done,
     /*  671488 */   // Label 10705: @671488
     /*  671488 */   GIM_Try, /*On fail goto*//*Label 10706*/ GIMT_Encode4(671563), // Rule ID 10469 //
     /*  671493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  671504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  671507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  671510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  671513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671539 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  671539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671561 */     GIR_RootConstrainSelectedInstOperands,
     /*  671562 */     // GIR_Coverage, 10469,
     /*  671562 */     GIR_EraseRootFromParent_Done,
     /*  671563 */   // Label 10706: @671563
     /*  671563 */   GIM_Try, /*On fail goto*//*Label 10707*/ GIMT_Encode4(671638), // Rule ID 10472 //
     /*  671568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  671571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  671579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  671582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  671585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  671588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671614 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  671614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  671633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671636 */     GIR_RootConstrainSelectedInstOperands,
     /*  671637 */     // GIR_Coverage, 10472,
     /*  671637 */     GIR_EraseRootFromParent_Done,
     /*  671638 */   // Label 10707: @671638
     /*  671638 */   GIM_Try, /*On fail goto*//*Label 10708*/ GIMT_Encode4(671713), // Rule ID 10473 //
     /*  671643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  671646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  671654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  671657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  671660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  671663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671689 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  671689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  671708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671711 */     GIR_RootConstrainSelectedInstOperands,
     /*  671712 */     // GIR_Coverage, 10473,
     /*  671712 */     GIR_EraseRootFromParent_Done,
     /*  671713 */   // Label 10708: @671713
     /*  671713 */   GIM_Try, /*On fail goto*//*Label 10709*/ GIMT_Encode4(671788), // Rule ID 10476 //
     /*  671718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  671729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  671732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  671735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  671738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671764 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  671767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671786 */     GIR_RootConstrainSelectedInstOperands,
     /*  671787 */     // GIR_Coverage, 10476,
     /*  671787 */     GIR_EraseRootFromParent_Done,
     /*  671788 */   // Label 10709: @671788
     /*  671788 */   GIM_Try, /*On fail goto*//*Label 10710*/ GIMT_Encode4(671863), // Rule ID 10477 //
     /*  671793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  671804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  671807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  671810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  671813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671839 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  671842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671861 */     GIR_RootConstrainSelectedInstOperands,
     /*  671862 */     // GIR_Coverage, 10477,
     /*  671862 */     GIR_EraseRootFromParent_Done,
     /*  671863 */   // Label 10710: @671863
     /*  671863 */   GIM_Try, /*On fail goto*//*Label 10711*/ GIMT_Encode4(671938), // Rule ID 10480 //
     /*  671868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  671879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  671882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  671885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  671888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671914 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  671917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671936 */     GIR_RootConstrainSelectedInstOperands,
     /*  671937 */     // GIR_Coverage, 10480,
     /*  671937 */     GIR_EraseRootFromParent_Done,
     /*  671938 */   // Label 10711: @671938
     /*  671938 */   GIM_Try, /*On fail goto*//*Label 10712*/ GIMT_Encode4(672013), // Rule ID 10481 //
     /*  671943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  671954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  671957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  671960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  671963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671989 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  671992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672011 */     GIR_RootConstrainSelectedInstOperands,
     /*  672012 */     // GIR_Coverage, 10481,
     /*  672012 */     GIR_EraseRootFromParent_Done,
     /*  672013 */   // Label 10712: @672013
     /*  672013 */   GIM_Try, /*On fail goto*//*Label 10713*/ GIMT_Encode4(672088), // Rule ID 10484 //
     /*  672018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  672029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  672032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  672035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  672038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672064 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672086 */     GIR_RootConstrainSelectedInstOperands,
     /*  672087 */     // GIR_Coverage, 10484,
     /*  672087 */     GIR_EraseRootFromParent_Done,
     /*  672088 */   // Label 10713: @672088
     /*  672088 */   GIM_Try, /*On fail goto*//*Label 10714*/ GIMT_Encode4(672163), // Rule ID 10485 //
     /*  672093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  672104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  672107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  672110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  672113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672139 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672161 */     GIR_RootConstrainSelectedInstOperands,
     /*  672162 */     // GIR_Coverage, 10485,
     /*  672162 */     GIR_EraseRootFromParent_Done,
     /*  672163 */   // Label 10714: @672163
     /*  672163 */   GIM_Try, /*On fail goto*//*Label 10715*/ GIMT_Encode4(672238), // Rule ID 10488 //
     /*  672168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  672179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  672182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  672185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  672188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672214 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672236 */     GIR_RootConstrainSelectedInstOperands,
     /*  672237 */     // GIR_Coverage, 10488,
     /*  672237 */     GIR_EraseRootFromParent_Done,
     /*  672238 */   // Label 10715: @672238
     /*  672238 */   GIM_Try, /*On fail goto*//*Label 10716*/ GIMT_Encode4(672313), // Rule ID 10489 //
     /*  672243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  672254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  672257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  672260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  672263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672289 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672311 */     GIR_RootConstrainSelectedInstOperands,
     /*  672312 */     // GIR_Coverage, 10489,
     /*  672312 */     GIR_EraseRootFromParent_Done,
     /*  672313 */   // Label 10716: @672313
     /*  672313 */   GIM_Try, /*On fail goto*//*Label 10717*/ GIMT_Encode4(672388), // Rule ID 10492 //
     /*  672318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  672329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  672332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  672335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  672338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672364 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672386 */     GIR_RootConstrainSelectedInstOperands,
     /*  672387 */     // GIR_Coverage, 10492,
     /*  672387 */     GIR_EraseRootFromParent_Done,
     /*  672388 */   // Label 10717: @672388
     /*  672388 */   GIM_Try, /*On fail goto*//*Label 10718*/ GIMT_Encode4(672463), // Rule ID 10493 //
     /*  672393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  672404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  672407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  672410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  672413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672439 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672461 */     GIR_RootConstrainSelectedInstOperands,
     /*  672462 */     // GIR_Coverage, 10493,
     /*  672462 */     GIR_EraseRootFromParent_Done,
     /*  672463 */   // Label 10718: @672463
     /*  672463 */   GIM_Try, /*On fail goto*//*Label 10719*/ GIMT_Encode4(672538), // Rule ID 10496 //
     /*  672468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  672479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  672482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  672485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  672488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672514 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672536 */     GIR_RootConstrainSelectedInstOperands,
     /*  672537 */     // GIR_Coverage, 10496,
     /*  672537 */     GIR_EraseRootFromParent_Done,
     /*  672538 */   // Label 10719: @672538
     /*  672538 */   GIM_Try, /*On fail goto*//*Label 10720*/ GIMT_Encode4(672613), // Rule ID 10497 //
     /*  672543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  672554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  672557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  672560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  672563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672589 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672611 */     GIR_RootConstrainSelectedInstOperands,
     /*  672612 */     // GIR_Coverage, 10497,
     /*  672612 */     GIR_EraseRootFromParent_Done,
     /*  672613 */   // Label 10720: @672613
     /*  672613 */   GIM_Try, /*On fail goto*//*Label 10721*/ GIMT_Encode4(672688), // Rule ID 10500 //
     /*  672618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  672629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  672632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  672635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  672638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  672664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672686 */     GIR_RootConstrainSelectedInstOperands,
     /*  672687 */     // GIR_Coverage, 10500,
     /*  672687 */     GIR_EraseRootFromParent_Done,
     /*  672688 */   // Label 10721: @672688
     /*  672688 */   GIM_Try, /*On fail goto*//*Label 10722*/ GIMT_Encode4(672763), // Rule ID 10501 //
     /*  672693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  672704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  672707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  672710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  672713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672739 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  672739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672761 */     GIR_RootConstrainSelectedInstOperands,
     /*  672762 */     // GIR_Coverage, 10501,
     /*  672762 */     GIR_EraseRootFromParent_Done,
     /*  672763 */   // Label 10722: @672763
     /*  672763 */   GIM_Try, /*On fail goto*//*Label 10723*/ GIMT_Encode4(672838), // Rule ID 10504 //
     /*  672768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  672779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  672782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  672785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  672788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672814 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  672814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672836 */     GIR_RootConstrainSelectedInstOperands,
     /*  672837 */     // GIR_Coverage, 10504,
     /*  672837 */     GIR_EraseRootFromParent_Done,
     /*  672838 */   // Label 10723: @672838
     /*  672838 */   GIM_Try, /*On fail goto*//*Label 10724*/ GIMT_Encode4(672913), // Rule ID 10505 //
     /*  672843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  672854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  672857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  672860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  672863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672889 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  672889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672911 */     GIR_RootConstrainSelectedInstOperands,
     /*  672912 */     // GIR_Coverage, 10505,
     /*  672912 */     GIR_EraseRootFromParent_Done,
     /*  672913 */   // Label 10724: @672913
     /*  672913 */   GIM_Try, /*On fail goto*//*Label 10725*/ GIMT_Encode4(672988), // Rule ID 10508 //
     /*  672918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  672929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  672932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  672935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  672938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672964 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  672964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672986 */     GIR_RootConstrainSelectedInstOperands,
     /*  672987 */     // GIR_Coverage, 10508,
     /*  672987 */     GIR_EraseRootFromParent_Done,
     /*  672988 */   // Label 10725: @672988
     /*  672988 */   GIM_Try, /*On fail goto*//*Label 10726*/ GIMT_Encode4(673063), // Rule ID 10509 //
     /*  672993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  673004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  673007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  673010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  673013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673039 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673061 */     GIR_RootConstrainSelectedInstOperands,
     /*  673062 */     // GIR_Coverage, 10509,
     /*  673062 */     GIR_EraseRootFromParent_Done,
     /*  673063 */   // Label 10726: @673063
     /*  673063 */   GIM_Try, /*On fail goto*//*Label 10727*/ GIMT_Encode4(673138), // Rule ID 10512 //
     /*  673068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  673079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  673082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  673085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  673088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  673117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673136 */     GIR_RootConstrainSelectedInstOperands,
     /*  673137 */     // GIR_Coverage, 10512,
     /*  673137 */     GIR_EraseRootFromParent_Done,
     /*  673138 */   // Label 10727: @673138
     /*  673138 */   GIM_Try, /*On fail goto*//*Label 10728*/ GIMT_Encode4(673213), // Rule ID 10513 //
     /*  673143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  673154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  673157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  673160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  673163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673189 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  673192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673211 */     GIR_RootConstrainSelectedInstOperands,
     /*  673212 */     // GIR_Coverage, 10513,
     /*  673212 */     GIR_EraseRootFromParent_Done,
     /*  673213 */   // Label 10728: @673213
     /*  673213 */   GIM_Try, /*On fail goto*//*Label 10729*/ GIMT_Encode4(673288), // Rule ID 10516 //
     /*  673218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  673229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  673232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  673235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  673238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  673267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673286 */     GIR_RootConstrainSelectedInstOperands,
     /*  673287 */     // GIR_Coverage, 10516,
     /*  673287 */     GIR_EraseRootFromParent_Done,
     /*  673288 */   // Label 10729: @673288
     /*  673288 */   GIM_Try, /*On fail goto*//*Label 10730*/ GIMT_Encode4(673363), // Rule ID 10517 //
     /*  673293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  673304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  673307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  673310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  673313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673339 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  673342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673361 */     GIR_RootConstrainSelectedInstOperands,
     /*  673362 */     // GIR_Coverage, 10517,
     /*  673362 */     GIR_EraseRootFromParent_Done,
     /*  673363 */   // Label 10730: @673363
     /*  673363 */   GIM_Try, /*On fail goto*//*Label 10731*/ GIMT_Encode4(673438), // Rule ID 10520 //
     /*  673368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  673379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  673382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  673385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  673388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673414 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673436 */     GIR_RootConstrainSelectedInstOperands,
     /*  673437 */     // GIR_Coverage, 10520,
     /*  673437 */     GIR_EraseRootFromParent_Done,
     /*  673438 */   // Label 10731: @673438
     /*  673438 */   GIM_Try, /*On fail goto*//*Label 10732*/ GIMT_Encode4(673513), // Rule ID 10521 //
     /*  673443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  673454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  673457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  673460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  673463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673489 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673511 */     GIR_RootConstrainSelectedInstOperands,
     /*  673512 */     // GIR_Coverage, 10521,
     /*  673512 */     GIR_EraseRootFromParent_Done,
     /*  673513 */   // Label 10732: @673513
     /*  673513 */   GIM_Try, /*On fail goto*//*Label 10733*/ GIMT_Encode4(673588), // Rule ID 10524 //
     /*  673518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  673529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  673532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  673535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673564 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  673564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  673567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673586 */     GIR_RootConstrainSelectedInstOperands,
     /*  673587 */     // GIR_Coverage, 10524,
     /*  673587 */     GIR_EraseRootFromParent_Done,
     /*  673588 */   // Label 10733: @673588
     /*  673588 */   GIM_Try, /*On fail goto*//*Label 10734*/ GIMT_Encode4(673663), // Rule ID 10525 //
     /*  673593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  673604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  673607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  673610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673639 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  673639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  673642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673661 */     GIR_RootConstrainSelectedInstOperands,
     /*  673662 */     // GIR_Coverage, 10525,
     /*  673662 */     GIR_EraseRootFromParent_Done,
     /*  673663 */   // Label 10734: @673663
     /*  673663 */   GIM_Try, /*On fail goto*//*Label 10735*/ GIMT_Encode4(673738), // Rule ID 10528 //
     /*  673668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  673679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  673682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  673685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673714 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  673714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  673717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673736 */     GIR_RootConstrainSelectedInstOperands,
     /*  673737 */     // GIR_Coverage, 10528,
     /*  673737 */     GIR_EraseRootFromParent_Done,
     /*  673738 */   // Label 10735: @673738
     /*  673738 */   GIM_Try, /*On fail goto*//*Label 10736*/ GIMT_Encode4(673813), // Rule ID 10529 //
     /*  673743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  673754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  673757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  673760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673789 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  673789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  673792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673811 */     GIR_RootConstrainSelectedInstOperands,
     /*  673812 */     // GIR_Coverage, 10529,
     /*  673812 */     GIR_EraseRootFromParent_Done,
     /*  673813 */   // Label 10736: @673813
     /*  673813 */   GIM_Try, /*On fail goto*//*Label 10737*/ GIMT_Encode4(673888), // Rule ID 10532 //
     /*  673818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  673829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  673832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  673835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673864 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  673864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  673867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673886 */     GIR_RootConstrainSelectedInstOperands,
     /*  673887 */     // GIR_Coverage, 10532,
     /*  673887 */     GIR_EraseRootFromParent_Done,
     /*  673888 */   // Label 10737: @673888
     /*  673888 */   GIM_Try, /*On fail goto*//*Label 10738*/ GIMT_Encode4(673963), // Rule ID 10533 //
     /*  673893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  673904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  673907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  673910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673939 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  673939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  673942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673961 */     GIR_RootConstrainSelectedInstOperands,
     /*  673962 */     // GIR_Coverage, 10533,
     /*  673962 */     GIR_EraseRootFromParent_Done,
     /*  673963 */   // Label 10738: @673963
     /*  673963 */   GIM_Try, /*On fail goto*//*Label 10739*/ GIMT_Encode4(674038), // Rule ID 10536 //
     /*  673968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  673979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  673982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  673985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674014 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  674017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674036 */     GIR_RootConstrainSelectedInstOperands,
     /*  674037 */     // GIR_Coverage, 10536,
     /*  674037 */     GIR_EraseRootFromParent_Done,
     /*  674038 */   // Label 10739: @674038
     /*  674038 */   GIM_Try, /*On fail goto*//*Label 10740*/ GIMT_Encode4(674113), // Rule ID 10537 //
     /*  674043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  674054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  674057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  674060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674089 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  674092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674111 */     GIR_RootConstrainSelectedInstOperands,
     /*  674112 */     // GIR_Coverage, 10537,
     /*  674112 */     GIR_EraseRootFromParent_Done,
     /*  674113 */   // Label 10740: @674113
     /*  674113 */   GIM_Try, /*On fail goto*//*Label 10741*/ GIMT_Encode4(674188), // Rule ID 10540 //
     /*  674118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  674129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  674132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  674135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674164 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674186 */     GIR_RootConstrainSelectedInstOperands,
     /*  674187 */     // GIR_Coverage, 10540,
     /*  674187 */     GIR_EraseRootFromParent_Done,
     /*  674188 */   // Label 10741: @674188
     /*  674188 */   GIM_Try, /*On fail goto*//*Label 10742*/ GIMT_Encode4(674263), // Rule ID 10541 //
     /*  674193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  674204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  674207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  674210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674239 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674261 */     GIR_RootConstrainSelectedInstOperands,
     /*  674262 */     // GIR_Coverage, 10541,
     /*  674262 */     GIR_EraseRootFromParent_Done,
     /*  674263 */   // Label 10742: @674263
     /*  674263 */   GIM_Try, /*On fail goto*//*Label 10743*/ GIMT_Encode4(674338), // Rule ID 10544 //
     /*  674268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  674279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  674282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  674285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674314 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  674314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674336 */     GIR_RootConstrainSelectedInstOperands,
     /*  674337 */     // GIR_Coverage, 10544,
     /*  674337 */     GIR_EraseRootFromParent_Done,
     /*  674338 */   // Label 10743: @674338
     /*  674338 */   GIM_Try, /*On fail goto*//*Label 10744*/ GIMT_Encode4(674413), // Rule ID 10545 //
     /*  674343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  674354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  674357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  674360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674389 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  674389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674411 */     GIR_RootConstrainSelectedInstOperands,
     /*  674412 */     // GIR_Coverage, 10545,
     /*  674412 */     GIR_EraseRootFromParent_Done,
     /*  674413 */   // Label 10744: @674413
     /*  674413 */   GIM_Try, /*On fail goto*//*Label 10745*/ GIMT_Encode4(674488), // Rule ID 10548 //
     /*  674418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  674429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  674432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  674435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674464 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674486 */     GIR_RootConstrainSelectedInstOperands,
     /*  674487 */     // GIR_Coverage, 10548,
     /*  674487 */     GIR_EraseRootFromParent_Done,
     /*  674488 */   // Label 10745: @674488
     /*  674488 */   GIM_Try, /*On fail goto*//*Label 10746*/ GIMT_Encode4(674563), // Rule ID 10549 //
     /*  674493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  674504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  674507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  674510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674539 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674561 */     GIR_RootConstrainSelectedInstOperands,
     /*  674562 */     // GIR_Coverage, 10549,
     /*  674562 */     GIR_EraseRootFromParent_Done,
     /*  674563 */   // Label 10746: @674563
     /*  674563 */   GIM_Try, /*On fail goto*//*Label 10747*/ GIMT_Encode4(674638), // Rule ID 10552 //
     /*  674568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  674579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  674582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  674585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674614 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674636 */     GIR_RootConstrainSelectedInstOperands,
     /*  674637 */     // GIR_Coverage, 10552,
     /*  674637 */     GIR_EraseRootFromParent_Done,
     /*  674638 */   // Label 10747: @674638
     /*  674638 */   GIM_Try, /*On fail goto*//*Label 10748*/ GIMT_Encode4(674713), // Rule ID 10553 //
     /*  674643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  674654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  674657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  674660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674689 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674711 */     GIR_RootConstrainSelectedInstOperands,
     /*  674712 */     // GIR_Coverage, 10553,
     /*  674712 */     GIR_EraseRootFromParent_Done,
     /*  674713 */   // Label 10748: @674713
     /*  674713 */   GIM_Try, /*On fail goto*//*Label 10749*/ GIMT_Encode4(674788), // Rule ID 10556 //
     /*  674718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  674729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  674732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  674735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674764 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  674764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674786 */     GIR_RootConstrainSelectedInstOperands,
     /*  674787 */     // GIR_Coverage, 10556,
     /*  674787 */     GIR_EraseRootFromParent_Done,
     /*  674788 */   // Label 10749: @674788
     /*  674788 */   GIM_Try, /*On fail goto*//*Label 10750*/ GIMT_Encode4(674863), // Rule ID 10557 //
     /*  674793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  674804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  674807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  674810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674839 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  674839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674861 */     GIR_RootConstrainSelectedInstOperands,
     /*  674862 */     // GIR_Coverage, 10557,
     /*  674862 */     GIR_EraseRootFromParent_Done,
     /*  674863 */   // Label 10750: @674863
     /*  674863 */   GIM_Try, /*On fail goto*//*Label 10751*/ GIMT_Encode4(674938), // Rule ID 10560 //
     /*  674868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  674871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  674879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  674882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  674885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674914 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  674914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  674933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674936 */     GIR_RootConstrainSelectedInstOperands,
     /*  674937 */     // GIR_Coverage, 10560,
     /*  674937 */     GIR_EraseRootFromParent_Done,
     /*  674938 */   // Label 10751: @674938
     /*  674938 */   GIM_Try, /*On fail goto*//*Label 10752*/ GIMT_Encode4(675013), // Rule ID 10561 //
     /*  674943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  674946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  674954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  674957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  674960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674989 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  674989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675011 */     GIR_RootConstrainSelectedInstOperands,
     /*  675012 */     // GIR_Coverage, 10561,
     /*  675012 */     GIR_EraseRootFromParent_Done,
     /*  675013 */   // Label 10752: @675013
     /*  675013 */   GIM_Try, /*On fail goto*//*Label 10753*/ GIMT_Encode4(675088), // Rule ID 10564 //
     /*  675018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  675029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  675032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  675035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675064 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675086 */     GIR_RootConstrainSelectedInstOperands,
     /*  675087 */     // GIR_Coverage, 10564,
     /*  675087 */     GIR_EraseRootFromParent_Done,
     /*  675088 */   // Label 10753: @675088
     /*  675088 */   GIM_Try, /*On fail goto*//*Label 10754*/ GIMT_Encode4(675163), // Rule ID 10565 //
     /*  675093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  675104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  675107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  675110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675139 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675161 */     GIR_RootConstrainSelectedInstOperands,
     /*  675162 */     // GIR_Coverage, 10565,
     /*  675162 */     GIR_EraseRootFromParent_Done,
     /*  675163 */   // Label 10754: @675163
     /*  675163 */   GIM_Try, /*On fail goto*//*Label 10755*/ GIMT_Encode4(675238), // Rule ID 10568 //
     /*  675168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  675179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  675182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  675185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675214 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675236 */     GIR_RootConstrainSelectedInstOperands,
     /*  675237 */     // GIR_Coverage, 10568,
     /*  675237 */     GIR_EraseRootFromParent_Done,
     /*  675238 */   // Label 10755: @675238
     /*  675238 */   GIM_Try, /*On fail goto*//*Label 10756*/ GIMT_Encode4(675313), // Rule ID 10569 //
     /*  675243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  675254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  675257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  675260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675289 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675311 */     GIR_RootConstrainSelectedInstOperands,
     /*  675312 */     // GIR_Coverage, 10569,
     /*  675312 */     GIR_EraseRootFromParent_Done,
     /*  675313 */   // Label 10756: @675313
     /*  675313 */   GIM_Try, /*On fail goto*//*Label 10757*/ GIMT_Encode4(675388), // Rule ID 10572 //
     /*  675318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  675329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  675332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  675335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675364 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675386 */     GIR_RootConstrainSelectedInstOperands,
     /*  675387 */     // GIR_Coverage, 10572,
     /*  675387 */     GIR_EraseRootFromParent_Done,
     /*  675388 */   // Label 10757: @675388
     /*  675388 */   GIM_Try, /*On fail goto*//*Label 10758*/ GIMT_Encode4(675463), // Rule ID 10573 //
     /*  675393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  675404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  675407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  675410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675439 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675461 */     GIR_RootConstrainSelectedInstOperands,
     /*  675462 */     // GIR_Coverage, 10573,
     /*  675462 */     GIR_EraseRootFromParent_Done,
     /*  675463 */   // Label 10758: @675463
     /*  675463 */   GIM_Try, /*On fail goto*//*Label 10759*/ GIMT_Encode4(675538), // Rule ID 10576 //
     /*  675468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  675479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  675482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  675485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675536 */     GIR_RootConstrainSelectedInstOperands,
     /*  675537 */     // GIR_Coverage, 10576,
     /*  675537 */     GIR_EraseRootFromParent_Done,
     /*  675538 */   // Label 10759: @675538
     /*  675538 */   GIM_Try, /*On fail goto*//*Label 10760*/ GIMT_Encode4(675613), // Rule ID 10577 //
     /*  675543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  675554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  675557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  675560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675589 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  675589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675611 */     GIR_RootConstrainSelectedInstOperands,
     /*  675612 */     // GIR_Coverage, 10577,
     /*  675612 */     GIR_EraseRootFromParent_Done,
     /*  675613 */   // Label 10760: @675613
     /*  675613 */   GIM_Try, /*On fail goto*//*Label 10761*/ GIMT_Encode4(675688), // Rule ID 10580 //
     /*  675618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  675629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  675632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  675635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675664 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675686 */     GIR_RootConstrainSelectedInstOperands,
     /*  675687 */     // GIR_Coverage, 10580,
     /*  675687 */     GIR_EraseRootFromParent_Done,
     /*  675688 */   // Label 10761: @675688
     /*  675688 */   GIM_Try, /*On fail goto*//*Label 10762*/ GIMT_Encode4(675763), // Rule ID 10581 //
     /*  675693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  675704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  675707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  675710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675739 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  675739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675761 */     GIR_RootConstrainSelectedInstOperands,
     /*  675762 */     // GIR_Coverage, 10581,
     /*  675762 */     GIR_EraseRootFromParent_Done,
     /*  675763 */   // Label 10762: @675763
     /*  675763 */   GIM_Try, /*On fail goto*//*Label 10763*/ GIMT_Encode4(675838), // Rule ID 10584 //
     /*  675768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  675779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  675782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  675785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675814 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675836 */     GIR_RootConstrainSelectedInstOperands,
     /*  675837 */     // GIR_Coverage, 10584,
     /*  675837 */     GIR_EraseRootFromParent_Done,
     /*  675838 */   // Label 10763: @675838
     /*  675838 */   GIM_Try, /*On fail goto*//*Label 10764*/ GIMT_Encode4(675913), // Rule ID 10585 //
     /*  675843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  675854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  675857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  675860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675889 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  675889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675911 */     GIR_RootConstrainSelectedInstOperands,
     /*  675912 */     // GIR_Coverage, 10585,
     /*  675912 */     GIR_EraseRootFromParent_Done,
     /*  675913 */   // Label 10764: @675913
     /*  675913 */   GIM_Try, /*On fail goto*//*Label 10765*/ GIMT_Encode4(675988), // Rule ID 10588 //
     /*  675918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  675929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  675932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  675935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  675964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675986 */     GIR_RootConstrainSelectedInstOperands,
     /*  675987 */     // GIR_Coverage, 10588,
     /*  675987 */     GIR_EraseRootFromParent_Done,
     /*  675988 */   // Label 10765: @675988
     /*  675988 */   GIM_Try, /*On fail goto*//*Label 10766*/ GIMT_Encode4(676063), // Rule ID 10589 //
     /*  675993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  676004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  676007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  676010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676039 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676061 */     GIR_RootConstrainSelectedInstOperands,
     /*  676062 */     // GIR_Coverage, 10589,
     /*  676062 */     GIR_EraseRootFromParent_Done,
     /*  676063 */   // Label 10766: @676063
     /*  676063 */   GIM_Try, /*On fail goto*//*Label 10767*/ GIMT_Encode4(676138), // Rule ID 10592 //
     /*  676068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  676079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  676082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  676085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676114 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676136 */     GIR_RootConstrainSelectedInstOperands,
     /*  676137 */     // GIR_Coverage, 10592,
     /*  676137 */     GIR_EraseRootFromParent_Done,
     /*  676138 */   // Label 10767: @676138
     /*  676138 */   GIM_Try, /*On fail goto*//*Label 10768*/ GIMT_Encode4(676213), // Rule ID 10593 //
     /*  676143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  676154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  676157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  676160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676189 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676211 */     GIR_RootConstrainSelectedInstOperands,
     /*  676212 */     // GIR_Coverage, 10593,
     /*  676212 */     GIR_EraseRootFromParent_Done,
     /*  676213 */   // Label 10768: @676213
     /*  676213 */   GIM_Try, /*On fail goto*//*Label 10769*/ GIMT_Encode4(676288), // Rule ID 10596 //
     /*  676218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  676229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  676232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  676235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676264 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676286 */     GIR_RootConstrainSelectedInstOperands,
     /*  676287 */     // GIR_Coverage, 10596,
     /*  676287 */     GIR_EraseRootFromParent_Done,
     /*  676288 */   // Label 10769: @676288
     /*  676288 */   GIM_Try, /*On fail goto*//*Label 10770*/ GIMT_Encode4(676363), // Rule ID 10597 //
     /*  676293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  676304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  676307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  676310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676339 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676361 */     GIR_RootConstrainSelectedInstOperands,
     /*  676362 */     // GIR_Coverage, 10597,
     /*  676362 */     GIR_EraseRootFromParent_Done,
     /*  676363 */   // Label 10770: @676363
     /*  676363 */   GIM_Try, /*On fail goto*//*Label 10771*/ GIMT_Encode4(676438), // Rule ID 10600 //
     /*  676368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  676379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  676382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  676385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  676414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676436 */     GIR_RootConstrainSelectedInstOperands,
     /*  676437 */     // GIR_Coverage, 10600,
     /*  676437 */     GIR_EraseRootFromParent_Done,
     /*  676438 */   // Label 10771: @676438
     /*  676438 */   GIM_Try, /*On fail goto*//*Label 10772*/ GIMT_Encode4(676513), // Rule ID 10601 //
     /*  676443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  676446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  676454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  676457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  676460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676489 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  676489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676511 */     GIR_RootConstrainSelectedInstOperands,
     /*  676512 */     // GIR_Coverage, 10601,
     /*  676512 */     GIR_EraseRootFromParent_Done,
     /*  676513 */   // Label 10772: @676513
     /*  676513 */   GIM_Try, /*On fail goto*//*Label 10773*/ GIMT_Encode4(676588), // Rule ID 10604 //
     /*  676518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  676529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  676532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  676535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676564 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  676564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676586 */     GIR_RootConstrainSelectedInstOperands,
     /*  676587 */     // GIR_Coverage, 10604,
     /*  676587 */     GIR_EraseRootFromParent_Done,
     /*  676588 */   // Label 10773: @676588
     /*  676588 */   GIM_Try, /*On fail goto*//*Label 10774*/ GIMT_Encode4(676663), // Rule ID 10605 //
     /*  676593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  676596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  676604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  676607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  676610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676639 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  676639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676661 */     GIR_RootConstrainSelectedInstOperands,
     /*  676662 */     // GIR_Coverage, 10605,
     /*  676662 */     GIR_EraseRootFromParent_Done,
     /*  676663 */   // Label 10774: @676663
     /*  676663 */   GIM_Try, /*On fail goto*//*Label 10775*/ GIMT_Encode4(676738), // Rule ID 10608 //
     /*  676668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  676679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  676682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  676685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676714 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  676714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676736 */     GIR_RootConstrainSelectedInstOperands,
     /*  676737 */     // GIR_Coverage, 10608,
     /*  676737 */     GIR_EraseRootFromParent_Done,
     /*  676738 */   // Label 10775: @676738
     /*  676738 */   GIM_Try, /*On fail goto*//*Label 10776*/ GIMT_Encode4(676813), // Rule ID 10609 //
     /*  676743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  676746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  676754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  676757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  676760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676789 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  676789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676811 */     GIR_RootConstrainSelectedInstOperands,
     /*  676812 */     // GIR_Coverage, 10609,
     /*  676812 */     GIR_EraseRootFromParent_Done,
     /*  676813 */   // Label 10776: @676813
     /*  676813 */   GIM_Try, /*On fail goto*//*Label 10777*/ GIMT_Encode4(676888), // Rule ID 10612 //
     /*  676818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  676829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  676832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  676835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  676838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676864 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  676864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  676867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676886 */     GIR_RootConstrainSelectedInstOperands,
     /*  676887 */     // GIR_Coverage, 10612,
     /*  676887 */     GIR_EraseRootFromParent_Done,
     /*  676888 */   // Label 10777: @676888
     /*  676888 */   GIM_Try, /*On fail goto*//*Label 10778*/ GIMT_Encode4(676963), // Rule ID 10613 //
     /*  676893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  676904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  676907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  676910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  676913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676939 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  676939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  676942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676961 */     GIR_RootConstrainSelectedInstOperands,
     /*  676962 */     // GIR_Coverage, 10613,
     /*  676962 */     GIR_EraseRootFromParent_Done,
     /*  676963 */   // Label 10778: @676963
     /*  676963 */   GIM_Try, /*On fail goto*//*Label 10779*/ GIMT_Encode4(677038), // Rule ID 10616 //
     /*  676968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  676979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  676982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  676985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  676988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677014 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677036 */     GIR_RootConstrainSelectedInstOperands,
     /*  677037 */     // GIR_Coverage, 10616,
     /*  677037 */     GIR_EraseRootFromParent_Done,
     /*  677038 */   // Label 10779: @677038
     /*  677038 */   GIM_Try, /*On fail goto*//*Label 10780*/ GIMT_Encode4(677113), // Rule ID 10617 //
     /*  677043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  677054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  677057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  677060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  677063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677089 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677111 */     GIR_RootConstrainSelectedInstOperands,
     /*  677112 */     // GIR_Coverage, 10617,
     /*  677112 */     GIR_EraseRootFromParent_Done,
     /*  677113 */   // Label 10780: @677113
     /*  677113 */   GIM_Try, /*On fail goto*//*Label 10781*/ GIMT_Encode4(677188), // Rule ID 10620 //
     /*  677118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  677129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  677132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  677135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  677138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677164 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677186 */     GIR_RootConstrainSelectedInstOperands,
     /*  677187 */     // GIR_Coverage, 10620,
     /*  677187 */     GIR_EraseRootFromParent_Done,
     /*  677188 */   // Label 10781: @677188
     /*  677188 */   GIM_Try, /*On fail goto*//*Label 10782*/ GIMT_Encode4(677263), // Rule ID 10621 //
     /*  677193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  677204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  677207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  677210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  677213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677239 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677261 */     GIR_RootConstrainSelectedInstOperands,
     /*  677262 */     // GIR_Coverage, 10621,
     /*  677262 */     GIR_EraseRootFromParent_Done,
     /*  677263 */   // Label 10782: @677263
     /*  677263 */   GIM_Try, /*On fail goto*//*Label 10783*/ GIMT_Encode4(677338), // Rule ID 10624 //
     /*  677268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  677279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  677282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  677285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  677288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677314 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677336 */     GIR_RootConstrainSelectedInstOperands,
     /*  677337 */     // GIR_Coverage, 10624,
     /*  677337 */     GIR_EraseRootFromParent_Done,
     /*  677338 */   // Label 10783: @677338
     /*  677338 */   GIM_Try, /*On fail goto*//*Label 10784*/ GIMT_Encode4(677413), // Rule ID 10625 //
     /*  677343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  677354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  677357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  677360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  677363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677389 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677411 */     GIR_RootConstrainSelectedInstOperands,
     /*  677412 */     // GIR_Coverage, 10625,
     /*  677412 */     GIR_EraseRootFromParent_Done,
     /*  677413 */   // Label 10784: @677413
     /*  677413 */   GIM_Try, /*On fail goto*//*Label 10785*/ GIMT_Encode4(677488), // Rule ID 10628 //
     /*  677418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  677429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  677432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  677435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  677438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677464 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677486 */     GIR_RootConstrainSelectedInstOperands,
     /*  677487 */     // GIR_Coverage, 10628,
     /*  677487 */     GIR_EraseRootFromParent_Done,
     /*  677488 */   // Label 10785: @677488
     /*  677488 */   GIM_Try, /*On fail goto*//*Label 10786*/ GIMT_Encode4(677563), // Rule ID 10629 //
     /*  677493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  677504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  677507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  677510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  677513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677539 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677561 */     GIR_RootConstrainSelectedInstOperands,
     /*  677562 */     // GIR_Coverage, 10629,
     /*  677562 */     GIR_EraseRootFromParent_Done,
     /*  677563 */   // Label 10786: @677563
     /*  677563 */   GIM_Try, /*On fail goto*//*Label 10787*/ GIMT_Encode4(677638), // Rule ID 10632 //
     /*  677568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  677579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  677582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  677585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  677588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677614 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  677614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  677633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677636 */     GIR_RootConstrainSelectedInstOperands,
     /*  677637 */     // GIR_Coverage, 10632,
     /*  677637 */     GIR_EraseRootFromParent_Done,
     /*  677638 */   // Label 10787: @677638
     /*  677638 */   GIM_Try, /*On fail goto*//*Label 10788*/ GIMT_Encode4(677713), // Rule ID 10633 //
     /*  677643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  677654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  677657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  677660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  677663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677689 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  677689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  677708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677711 */     GIR_RootConstrainSelectedInstOperands,
     /*  677712 */     // GIR_Coverage, 10633,
     /*  677712 */     GIR_EraseRootFromParent_Done,
     /*  677713 */   // Label 10788: @677713
     /*  677713 */   GIM_Try, /*On fail goto*//*Label 10789*/ GIMT_Encode4(677788), // Rule ID 10636 //
     /*  677718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  677729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  677732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  677735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  677738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677764 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677786 */     GIR_RootConstrainSelectedInstOperands,
     /*  677787 */     // GIR_Coverage, 10636,
     /*  677787 */     GIR_EraseRootFromParent_Done,
     /*  677788 */   // Label 10789: @677788
     /*  677788 */   GIM_Try, /*On fail goto*//*Label 10790*/ GIMT_Encode4(677863), // Rule ID 10637 //
     /*  677793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  677804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  677807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  677810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  677813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677839 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677861 */     GIR_RootConstrainSelectedInstOperands,
     /*  677862 */     // GIR_Coverage, 10637,
     /*  677862 */     GIR_EraseRootFromParent_Done,
     /*  677863 */   // Label 10790: @677863
     /*  677863 */   GIM_Try, /*On fail goto*//*Label 10791*/ GIMT_Encode4(677938), // Rule ID 10640 //
     /*  677868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  677879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  677882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  677885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  677888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677914 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677936 */     GIR_RootConstrainSelectedInstOperands,
     /*  677937 */     // GIR_Coverage, 10640,
     /*  677937 */     GIR_EraseRootFromParent_Done,
     /*  677938 */   // Label 10791: @677938
     /*  677938 */   GIM_Try, /*On fail goto*//*Label 10792*/ GIMT_Encode4(678013), // Rule ID 10641 //
     /*  677943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  677954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  677957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  677960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  677963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677989 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678011 */     GIR_RootConstrainSelectedInstOperands,
     /*  678012 */     // GIR_Coverage, 10641,
     /*  678012 */     GIR_EraseRootFromParent_Done,
     /*  678013 */   // Label 10792: @678013
     /*  678013 */   GIM_Try, /*On fail goto*//*Label 10793*/ GIMT_Encode4(678088), // Rule ID 10644 //
     /*  678018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  678029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  678032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  678035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  678038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678064 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678086 */     GIR_RootConstrainSelectedInstOperands,
     /*  678087 */     // GIR_Coverage, 10644,
     /*  678087 */     GIR_EraseRootFromParent_Done,
     /*  678088 */   // Label 10793: @678088
     /*  678088 */   GIM_Try, /*On fail goto*//*Label 10794*/ GIMT_Encode4(678163), // Rule ID 10645 //
     /*  678093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  678104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  678107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  678110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  678113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678139 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678161 */     GIR_RootConstrainSelectedInstOperands,
     /*  678162 */     // GIR_Coverage, 10645,
     /*  678162 */     GIR_EraseRootFromParent_Done,
     /*  678163 */   // Label 10794: @678163
     /*  678163 */   GIM_Try, /*On fail goto*//*Label 10795*/ GIMT_Encode4(678238), // Rule ID 10648 //
     /*  678168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  678171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  678179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  678182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  678185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  678188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678214 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  678214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678236 */     GIR_RootConstrainSelectedInstOperands,
     /*  678237 */     // GIR_Coverage, 10648,
     /*  678237 */     GIR_EraseRootFromParent_Done,
     /*  678238 */   // Label 10795: @678238
     /*  678238 */   GIM_Try, /*On fail goto*//*Label 10796*/ GIMT_Encode4(678313), // Rule ID 10649 //
     /*  678243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  678246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  678254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  678257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  678260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  678263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678289 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  678289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678311 */     GIR_RootConstrainSelectedInstOperands,
     /*  678312 */     // GIR_Coverage, 10649,
     /*  678312 */     GIR_EraseRootFromParent_Done,
     /*  678313 */   // Label 10796: @678313
     /*  678313 */   GIM_Try, /*On fail goto*//*Label 10797*/ GIMT_Encode4(678388), // Rule ID 10652 //
     /*  678318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  678329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  678332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  678335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  678338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678364 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678386 */     GIR_RootConstrainSelectedInstOperands,
     /*  678387 */     // GIR_Coverage, 10652,
     /*  678387 */     GIR_EraseRootFromParent_Done,
     /*  678388 */   // Label 10797: @678388
     /*  678388 */   GIM_Try, /*On fail goto*//*Label 10798*/ GIMT_Encode4(678463), // Rule ID 10653 //
     /*  678393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  678404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  678407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  678410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  678413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678439 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678461 */     GIR_RootConstrainSelectedInstOperands,
     /*  678462 */     // GIR_Coverage, 10653,
     /*  678462 */     GIR_EraseRootFromParent_Done,
     /*  678463 */   // Label 10798: @678463
     /*  678463 */   GIM_Try, /*On fail goto*//*Label 10799*/ GIMT_Encode4(678538), // Rule ID 10656 //
     /*  678468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  678479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  678482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  678485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  678488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678514 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  678517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678536 */     GIR_RootConstrainSelectedInstOperands,
     /*  678537 */     // GIR_Coverage, 10656,
     /*  678537 */     GIR_EraseRootFromParent_Done,
     /*  678538 */   // Label 10799: @678538
     /*  678538 */   GIM_Try, /*On fail goto*//*Label 10800*/ GIMT_Encode4(678613), // Rule ID 10657 //
     /*  678543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  678554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  678557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  678560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  678563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678589 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  678592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678611 */     GIR_RootConstrainSelectedInstOperands,
     /*  678612 */     // GIR_Coverage, 10657,
     /*  678612 */     GIR_EraseRootFromParent_Done,
     /*  678613 */   // Label 10800: @678613
     /*  678613 */   GIM_Try, /*On fail goto*//*Label 10801*/ GIMT_Encode4(678688), // Rule ID 10660 //
     /*  678618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  678629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  678632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  678635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  678638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678664 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  678667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678686 */     GIR_RootConstrainSelectedInstOperands,
     /*  678687 */     // GIR_Coverage, 10660,
     /*  678687 */     GIR_EraseRootFromParent_Done,
     /*  678688 */   // Label 10801: @678688
     /*  678688 */   GIM_Try, /*On fail goto*//*Label 10802*/ GIMT_Encode4(678763), // Rule ID 10661 //
     /*  678693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  678704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  678707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  678710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  678713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678739 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  678742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678761 */     GIR_RootConstrainSelectedInstOperands,
     /*  678762 */     // GIR_Coverage, 10661,
     /*  678762 */     GIR_EraseRootFromParent_Done,
     /*  678763 */   // Label 10802: @678763
     /*  678763 */   GIM_Try, /*On fail goto*//*Label 10803*/ GIMT_Encode4(678838), // Rule ID 10664 //
     /*  678768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  678779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  678782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  678785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  678788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  678814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678836 */     GIR_RootConstrainSelectedInstOperands,
     /*  678837 */     // GIR_Coverage, 10664,
     /*  678837 */     GIR_EraseRootFromParent_Done,
     /*  678838 */   // Label 10803: @678838
     /*  678838 */   GIM_Try, /*On fail goto*//*Label 10804*/ GIMT_Encode4(678913), // Rule ID 10665 //
     /*  678843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  678854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  678857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  678860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  678863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678889 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  678889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678911 */     GIR_RootConstrainSelectedInstOperands,
     /*  678912 */     // GIR_Coverage, 10665,
     /*  678912 */     GIR_EraseRootFromParent_Done,
     /*  678913 */   // Label 10804: @678913
     /*  678913 */   GIM_Try, /*On fail goto*//*Label 10805*/ GIMT_Encode4(678988), // Rule ID 10668 //
     /*  678918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  678929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  678932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  678935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  678938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678964 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  678964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  678967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678986 */     GIR_RootConstrainSelectedInstOperands,
     /*  678987 */     // GIR_Coverage, 10668,
     /*  678987 */     GIR_EraseRootFromParent_Done,
     /*  678988 */   // Label 10805: @678988
     /*  678988 */   GIM_Try, /*On fail goto*//*Label 10806*/ GIMT_Encode4(679063), // Rule ID 10669 //
     /*  678993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  679004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  679007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  679010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  679013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679039 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679061 */     GIR_RootConstrainSelectedInstOperands,
     /*  679062 */     // GIR_Coverage, 10669,
     /*  679062 */     GIR_EraseRootFromParent_Done,
     /*  679063 */   // Label 10806: @679063
     /*  679063 */   GIM_Try, /*On fail goto*//*Label 10807*/ GIMT_Encode4(679138), // Rule ID 10672 //
     /*  679068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  679079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  679082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  679085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  679088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679114 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679136 */     GIR_RootConstrainSelectedInstOperands,
     /*  679137 */     // GIR_Coverage, 10672,
     /*  679137 */     GIR_EraseRootFromParent_Done,
     /*  679138 */   // Label 10807: @679138
     /*  679138 */   GIM_Try, /*On fail goto*//*Label 10808*/ GIMT_Encode4(679213), // Rule ID 10673 //
     /*  679143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  679154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  679157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  679160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  679163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679189 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679211 */     GIR_RootConstrainSelectedInstOperands,
     /*  679212 */     // GIR_Coverage, 10673,
     /*  679212 */     GIR_EraseRootFromParent_Done,
     /*  679213 */   // Label 10808: @679213
     /*  679213 */   GIM_Try, /*On fail goto*//*Label 10809*/ GIMT_Encode4(679288), // Rule ID 10676 //
     /*  679218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  679229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  679232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  679235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  679238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679286 */     GIR_RootConstrainSelectedInstOperands,
     /*  679287 */     // GIR_Coverage, 10676,
     /*  679287 */     GIR_EraseRootFromParent_Done,
     /*  679288 */   // Label 10809: @679288
     /*  679288 */   GIM_Try, /*On fail goto*//*Label 10810*/ GIMT_Encode4(679363), // Rule ID 10677 //
     /*  679293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  679304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  679307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  679310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  679313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679339 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679361 */     GIR_RootConstrainSelectedInstOperands,
     /*  679362 */     // GIR_Coverage, 10677,
     /*  679362 */     GIR_EraseRootFromParent_Done,
     /*  679363 */   // Label 10810: @679363
     /*  679363 */   GIM_Try, /*On fail goto*//*Label 10811*/ GIMT_Encode4(679438), // Rule ID 10680 //
     /*  679368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  679379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  679382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  679385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  679388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679414 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679436 */     GIR_RootConstrainSelectedInstOperands,
     /*  679437 */     // GIR_Coverage, 10680,
     /*  679437 */     GIR_EraseRootFromParent_Done,
     /*  679438 */   // Label 10811: @679438
     /*  679438 */   GIM_Try, /*On fail goto*//*Label 10812*/ GIMT_Encode4(679513), // Rule ID 10681 //
     /*  679443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  679454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  679457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  679460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  679463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679489 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679511 */     GIR_RootConstrainSelectedInstOperands,
     /*  679512 */     // GIR_Coverage, 10681,
     /*  679512 */     GIR_EraseRootFromParent_Done,
     /*  679513 */   // Label 10812: @679513
     /*  679513 */   GIM_Try, /*On fail goto*//*Label 10813*/ GIMT_Encode4(679588), // Rule ID 10684 //
     /*  679518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  679529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  679532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  679535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  679538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679564 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679586 */     GIR_RootConstrainSelectedInstOperands,
     /*  679587 */     // GIR_Coverage, 10684,
     /*  679587 */     GIR_EraseRootFromParent_Done,
     /*  679588 */   // Label 10813: @679588
     /*  679588 */   GIM_Try, /*On fail goto*//*Label 10814*/ GIMT_Encode4(679663), // Rule ID 10685 //
     /*  679593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  679604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  679607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  679610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  679613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679639 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679661 */     GIR_RootConstrainSelectedInstOperands,
     /*  679662 */     // GIR_Coverage, 10685,
     /*  679662 */     GIR_EraseRootFromParent_Done,
     /*  679663 */   // Label 10814: @679663
     /*  679663 */   GIM_Try, /*On fail goto*//*Label 10815*/ GIMT_Encode4(679738), // Rule ID 10688 //
     /*  679668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  679671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  679679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  679682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  679685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  679688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679714 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  679714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679736 */     GIR_RootConstrainSelectedInstOperands,
     /*  679737 */     // GIR_Coverage, 10688,
     /*  679737 */     GIR_EraseRootFromParent_Done,
     /*  679738 */   // Label 10815: @679738
     /*  679738 */   GIM_Try, /*On fail goto*//*Label 10816*/ GIMT_Encode4(679813), // Rule ID 10689 //
     /*  679743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  679746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  679754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  679757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  679760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  679763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679789 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  679789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679811 */     GIR_RootConstrainSelectedInstOperands,
     /*  679812 */     // GIR_Coverage, 10689,
     /*  679812 */     GIR_EraseRootFromParent_Done,
     /*  679813 */   // Label 10816: @679813
     /*  679813 */   GIM_Try, /*On fail goto*//*Label 10817*/ GIMT_Encode4(679888), // Rule ID 10692 //
     /*  679818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  679821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  679829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  679832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  679835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  679838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679864 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  679864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679886 */     GIR_RootConstrainSelectedInstOperands,
     /*  679887 */     // GIR_Coverage, 10692,
     /*  679887 */     GIR_EraseRootFromParent_Done,
     /*  679888 */   // Label 10817: @679888
     /*  679888 */   GIM_Try, /*On fail goto*//*Label 10818*/ GIMT_Encode4(679963), // Rule ID 10693 //
     /*  679893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  679896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  679904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  679907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  679910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  679913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679939 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  679939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679961 */     GIR_RootConstrainSelectedInstOperands,
     /*  679962 */     // GIR_Coverage, 10693,
     /*  679962 */     GIR_EraseRootFromParent_Done,
     /*  679963 */   // Label 10818: @679963
     /*  679963 */   GIM_Try, /*On fail goto*//*Label 10819*/ GIMT_Encode4(680038), // Rule ID 10696 //
     /*  679968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  679971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  679979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  679982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  679985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  679988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680014 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  680017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680036 */     GIR_RootConstrainSelectedInstOperands,
     /*  680037 */     // GIR_Coverage, 10696,
     /*  680037 */     GIR_EraseRootFromParent_Done,
     /*  680038 */   // Label 10819: @680038
     /*  680038 */   GIM_Try, /*On fail goto*//*Label 10820*/ GIMT_Encode4(680113), // Rule ID 10697 //
     /*  680043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  680054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  680057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  680060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  680063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680089 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  680092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680111 */     GIR_RootConstrainSelectedInstOperands,
     /*  680112 */     // GIR_Coverage, 10697,
     /*  680112 */     GIR_EraseRootFromParent_Done,
     /*  680113 */   // Label 10820: @680113
     /*  680113 */   GIM_Try, /*On fail goto*//*Label 10821*/ GIMT_Encode4(680188), // Rule ID 10700 //
     /*  680118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  680129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  680132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  680135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680164 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  680167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680186 */     GIR_RootConstrainSelectedInstOperands,
     /*  680187 */     // GIR_Coverage, 10700,
     /*  680187 */     GIR_EraseRootFromParent_Done,
     /*  680188 */   // Label 10821: @680188
     /*  680188 */   GIM_Try, /*On fail goto*//*Label 10822*/ GIMT_Encode4(680263), // Rule ID 10701 //
     /*  680193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  680204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  680207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  680210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680239 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  680242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680261 */     GIR_RootConstrainSelectedInstOperands,
     /*  680262 */     // GIR_Coverage, 10701,
     /*  680262 */     GIR_EraseRootFromParent_Done,
     /*  680263 */   // Label 10822: @680263
     /*  680263 */   GIM_Try, /*On fail goto*//*Label 10823*/ GIMT_Encode4(680338), // Rule ID 10704 //
     /*  680268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  680279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  680282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  680285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680314 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680336 */     GIR_RootConstrainSelectedInstOperands,
     /*  680337 */     // GIR_Coverage, 10704,
     /*  680337 */     GIR_EraseRootFromParent_Done,
     /*  680338 */   // Label 10823: @680338
     /*  680338 */   GIM_Try, /*On fail goto*//*Label 10824*/ GIMT_Encode4(680413), // Rule ID 10705 //
     /*  680343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  680354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  680357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  680360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680389 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680411 */     GIR_RootConstrainSelectedInstOperands,
     /*  680412 */     // GIR_Coverage, 10705,
     /*  680412 */     GIR_EraseRootFromParent_Done,
     /*  680413 */   // Label 10824: @680413
     /*  680413 */   GIM_Try, /*On fail goto*//*Label 10825*/ GIMT_Encode4(680488), // Rule ID 10708 //
     /*  680418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  680429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  680432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  680435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680464 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680486 */     GIR_RootConstrainSelectedInstOperands,
     /*  680487 */     // GIR_Coverage, 10708,
     /*  680487 */     GIR_EraseRootFromParent_Done,
     /*  680488 */   // Label 10825: @680488
     /*  680488 */   GIM_Try, /*On fail goto*//*Label 10826*/ GIMT_Encode4(680563), // Rule ID 10709 //
     /*  680493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  680504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  680507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  680510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680539 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680561 */     GIR_RootConstrainSelectedInstOperands,
     /*  680562 */     // GIR_Coverage, 10709,
     /*  680562 */     GIR_EraseRootFromParent_Done,
     /*  680563 */   // Label 10826: @680563
     /*  680563 */   GIM_Try, /*On fail goto*//*Label 10827*/ GIMT_Encode4(680638), // Rule ID 10712 //
     /*  680568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  680579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  680582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  680585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680614 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  680614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680636 */     GIR_RootConstrainSelectedInstOperands,
     /*  680637 */     // GIR_Coverage, 10712,
     /*  680637 */     GIR_EraseRootFromParent_Done,
     /*  680638 */   // Label 10827: @680638
     /*  680638 */   GIM_Try, /*On fail goto*//*Label 10828*/ GIMT_Encode4(680713), // Rule ID 10713 //
     /*  680643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  680654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  680657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  680660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680689 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  680689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680711 */     GIR_RootConstrainSelectedInstOperands,
     /*  680712 */     // GIR_Coverage, 10713,
     /*  680712 */     GIR_EraseRootFromParent_Done,
     /*  680713 */   // Label 10828: @680713
     /*  680713 */   GIM_Try, /*On fail goto*//*Label 10829*/ GIMT_Encode4(680788), // Rule ID 10716 //
     /*  680718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  680729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  680732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  680735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680764 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  680764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680786 */     GIR_RootConstrainSelectedInstOperands,
     /*  680787 */     // GIR_Coverage, 10716,
     /*  680787 */     GIR_EraseRootFromParent_Done,
     /*  680788 */   // Label 10829: @680788
     /*  680788 */   GIM_Try, /*On fail goto*//*Label 10830*/ GIMT_Encode4(680863), // Rule ID 10717 //
     /*  680793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  680804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  680807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  680810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680839 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  680839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680861 */     GIR_RootConstrainSelectedInstOperands,
     /*  680862 */     // GIR_Coverage, 10717,
     /*  680862 */     GIR_EraseRootFromParent_Done,
     /*  680863 */   // Label 10830: @680863
     /*  680863 */   GIM_Try, /*On fail goto*//*Label 10831*/ GIMT_Encode4(680938), // Rule ID 10720 //
     /*  680868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  680879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  680882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  680885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680914 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  680914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680936 */     GIR_RootConstrainSelectedInstOperands,
     /*  680937 */     // GIR_Coverage, 10720,
     /*  680937 */     GIR_EraseRootFromParent_Done,
     /*  680938 */   // Label 10831: @680938
     /*  680938 */   GIM_Try, /*On fail goto*//*Label 10832*/ GIMT_Encode4(681013), // Rule ID 10721 //
     /*  680943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  680954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  680957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  680960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680989 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  680989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681011 */     GIR_RootConstrainSelectedInstOperands,
     /*  681012 */     // GIR_Coverage, 10721,
     /*  681012 */     GIR_EraseRootFromParent_Done,
     /*  681013 */   // Label 10832: @681013
     /*  681013 */   GIM_Try, /*On fail goto*//*Label 10833*/ GIMT_Encode4(681088), // Rule ID 10724 //
     /*  681018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  681029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  681032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  681035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681064 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681086 */     GIR_RootConstrainSelectedInstOperands,
     /*  681087 */     // GIR_Coverage, 10724,
     /*  681087 */     GIR_EraseRootFromParent_Done,
     /*  681088 */   // Label 10833: @681088
     /*  681088 */   GIM_Try, /*On fail goto*//*Label 10834*/ GIMT_Encode4(681163), // Rule ID 10725 //
     /*  681093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  681104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  681107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  681110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681139 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681161 */     GIR_RootConstrainSelectedInstOperands,
     /*  681162 */     // GIR_Coverage, 10725,
     /*  681162 */     GIR_EraseRootFromParent_Done,
     /*  681163 */   // Label 10834: @681163
     /*  681163 */   GIM_Try, /*On fail goto*//*Label 10835*/ GIMT_Encode4(681238), // Rule ID 10728 //
     /*  681168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  681179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  681182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  681185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681214 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681236 */     GIR_RootConstrainSelectedInstOperands,
     /*  681237 */     // GIR_Coverage, 10728,
     /*  681237 */     GIR_EraseRootFromParent_Done,
     /*  681238 */   // Label 10835: @681238
     /*  681238 */   GIM_Try, /*On fail goto*//*Label 10836*/ GIMT_Encode4(681313), // Rule ID 10729 //
     /*  681243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  681254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  681257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  681260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681289 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681311 */     GIR_RootConstrainSelectedInstOperands,
     /*  681312 */     // GIR_Coverage, 10729,
     /*  681312 */     GIR_EraseRootFromParent_Done,
     /*  681313 */   // Label 10836: @681313
     /*  681313 */   GIM_Try, /*On fail goto*//*Label 10837*/ GIMT_Encode4(681388), // Rule ID 10732 //
     /*  681318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  681329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  681332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  681335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681364 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  681364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681386 */     GIR_RootConstrainSelectedInstOperands,
     /*  681387 */     // GIR_Coverage, 10732,
     /*  681387 */     GIR_EraseRootFromParent_Done,
     /*  681388 */   // Label 10837: @681388
     /*  681388 */   GIM_Try, /*On fail goto*//*Label 10838*/ GIMT_Encode4(681463), // Rule ID 10733 //
     /*  681393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  681404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  681407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  681410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681439 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  681439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681461 */     GIR_RootConstrainSelectedInstOperands,
     /*  681462 */     // GIR_Coverage, 10733,
     /*  681462 */     GIR_EraseRootFromParent_Done,
     /*  681463 */   // Label 10838: @681463
     /*  681463 */   GIM_Try, /*On fail goto*//*Label 10839*/ GIMT_Encode4(681538), // Rule ID 10736 //
     /*  681468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  681471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  681479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  681482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  681485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681514 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  681514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  681533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681536 */     GIR_RootConstrainSelectedInstOperands,
     /*  681537 */     // GIR_Coverage, 10736,
     /*  681537 */     GIR_EraseRootFromParent_Done,
     /*  681538 */   // Label 10839: @681538
     /*  681538 */   GIM_Try, /*On fail goto*//*Label 10840*/ GIMT_Encode4(681613), // Rule ID 10737 //
     /*  681543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  681546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  681554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  681557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  681560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681589 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  681589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  681608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681611 */     GIR_RootConstrainSelectedInstOperands,
     /*  681612 */     // GIR_Coverage, 10737,
     /*  681612 */     GIR_EraseRootFromParent_Done,
     /*  681613 */   // Label 10840: @681613
     /*  681613 */   GIM_Try, /*On fail goto*//*Label 10841*/ GIMT_Encode4(681688), // Rule ID 10740 //
     /*  681618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  681629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  681632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  681635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681664 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  681667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681686 */     GIR_RootConstrainSelectedInstOperands,
     /*  681687 */     // GIR_Coverage, 10740,
     /*  681687 */     GIR_EraseRootFromParent_Done,
     /*  681688 */   // Label 10841: @681688
     /*  681688 */   GIM_Try, /*On fail goto*//*Label 10842*/ GIMT_Encode4(681763), // Rule ID 10741 //
     /*  681693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  681704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  681707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  681710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681739 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  681742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681761 */     GIR_RootConstrainSelectedInstOperands,
     /*  681762 */     // GIR_Coverage, 10741,
     /*  681762 */     GIR_EraseRootFromParent_Done,
     /*  681763 */   // Label 10842: @681763
     /*  681763 */   GIM_Try, /*On fail goto*//*Label 10843*/ GIMT_Encode4(681838), // Rule ID 10744 //
     /*  681768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  681779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  681782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  681785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681814 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  681817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681836 */     GIR_RootConstrainSelectedInstOperands,
     /*  681837 */     // GIR_Coverage, 10744,
     /*  681837 */     GIR_EraseRootFromParent_Done,
     /*  681838 */   // Label 10843: @681838
     /*  681838 */   GIM_Try, /*On fail goto*//*Label 10844*/ GIMT_Encode4(681913), // Rule ID 10745 //
     /*  681843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  681854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  681857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  681860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681889 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  681892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681911 */     GIR_RootConstrainSelectedInstOperands,
     /*  681912 */     // GIR_Coverage, 10745,
     /*  681912 */     GIR_EraseRootFromParent_Done,
     /*  681913 */   // Label 10844: @681913
     /*  681913 */   GIM_Try, /*On fail goto*//*Label 10845*/ GIMT_Encode4(681988), // Rule ID 10748 //
     /*  681918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  681929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  681932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  681935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681964 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  681967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681986 */     GIR_RootConstrainSelectedInstOperands,
     /*  681987 */     // GIR_Coverage, 10748,
     /*  681987 */     GIR_EraseRootFromParent_Done,
     /*  681988 */   // Label 10845: @681988
     /*  681988 */   GIM_Try, /*On fail goto*//*Label 10846*/ GIMT_Encode4(682063), // Rule ID 10749 //
     /*  681993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  682004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  682007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  682010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682039 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682061 */     GIR_RootConstrainSelectedInstOperands,
     /*  682062 */     // GIR_Coverage, 10749,
     /*  682062 */     GIR_EraseRootFromParent_Done,
     /*  682063 */   // Label 10846: @682063
     /*  682063 */   GIM_Try, /*On fail goto*//*Label 10847*/ GIMT_Encode4(682138), // Rule ID 10752 //
     /*  682068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  682079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  682082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  682085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682136 */     GIR_RootConstrainSelectedInstOperands,
     /*  682137 */     // GIR_Coverage, 10752,
     /*  682137 */     GIR_EraseRootFromParent_Done,
     /*  682138 */   // Label 10847: @682138
     /*  682138 */   GIM_Try, /*On fail goto*//*Label 10848*/ GIMT_Encode4(682213), // Rule ID 10753 //
     /*  682143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  682154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  682157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  682160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682189 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682211 */     GIR_RootConstrainSelectedInstOperands,
     /*  682212 */     // GIR_Coverage, 10753,
     /*  682212 */     GIR_EraseRootFromParent_Done,
     /*  682213 */   // Label 10848: @682213
     /*  682213 */   GIM_Try, /*On fail goto*//*Label 10849*/ GIMT_Encode4(682288), // Rule ID 10756 //
     /*  682218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  682229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  682232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  682235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682264 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682286 */     GIR_RootConstrainSelectedInstOperands,
     /*  682287 */     // GIR_Coverage, 10756,
     /*  682287 */     GIR_EraseRootFromParent_Done,
     /*  682288 */   // Label 10849: @682288
     /*  682288 */   GIM_Try, /*On fail goto*//*Label 10850*/ GIMT_Encode4(682363), // Rule ID 10757 //
     /*  682293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  682304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  682307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  682310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682339 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682361 */     GIR_RootConstrainSelectedInstOperands,
     /*  682362 */     // GIR_Coverage, 10757,
     /*  682362 */     GIR_EraseRootFromParent_Done,
     /*  682363 */   // Label 10850: @682363
     /*  682363 */   GIM_Try, /*On fail goto*//*Label 10851*/ GIMT_Encode4(682438), // Rule ID 10760 //
     /*  682368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  682379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  682382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  682385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682414 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682436 */     GIR_RootConstrainSelectedInstOperands,
     /*  682437 */     // GIR_Coverage, 10760,
     /*  682437 */     GIR_EraseRootFromParent_Done,
     /*  682438 */   // Label 10851: @682438
     /*  682438 */   GIM_Try, /*On fail goto*//*Label 10852*/ GIMT_Encode4(682513), // Rule ID 10761 //
     /*  682443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  682454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  682457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  682460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682489 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682511 */     GIR_RootConstrainSelectedInstOperands,
     /*  682512 */     // GIR_Coverage, 10761,
     /*  682512 */     GIR_EraseRootFromParent_Done,
     /*  682513 */   // Label 10852: @682513
     /*  682513 */   GIM_Try, /*On fail goto*//*Label 10853*/ GIMT_Encode4(682588), // Rule ID 10764 //
     /*  682518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  682529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  682532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  682535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  682564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682586 */     GIR_RootConstrainSelectedInstOperands,
     /*  682587 */     // GIR_Coverage, 10764,
     /*  682587 */     GIR_EraseRootFromParent_Done,
     /*  682588 */   // Label 10853: @682588
     /*  682588 */   GIM_Try, /*On fail goto*//*Label 10854*/ GIMT_Encode4(682663), // Rule ID 10765 //
     /*  682593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  682604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  682607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  682610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  682639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682661 */     GIR_RootConstrainSelectedInstOperands,
     /*  682662 */     // GIR_Coverage, 10765,
     /*  682662 */     GIR_EraseRootFromParent_Done,
     /*  682663 */   // Label 10854: @682663
     /*  682663 */   GIM_Try, /*On fail goto*//*Label 10855*/ GIMT_Encode4(682738), // Rule ID 10768 //
     /*  682668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  682679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  682682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  682685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682714 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  682714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682736 */     GIR_RootConstrainSelectedInstOperands,
     /*  682737 */     // GIR_Coverage, 10768,
     /*  682737 */     GIR_EraseRootFromParent_Done,
     /*  682738 */   // Label 10855: @682738
     /*  682738 */   GIM_Try, /*On fail goto*//*Label 10856*/ GIMT_Encode4(682813), // Rule ID 10769 //
     /*  682743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  682754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  682757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  682760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682789 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  682789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682811 */     GIR_RootConstrainSelectedInstOperands,
     /*  682812 */     // GIR_Coverage, 10769,
     /*  682812 */     GIR_EraseRootFromParent_Done,
     /*  682813 */   // Label 10856: @682813
     /*  682813 */   GIM_Try, /*On fail goto*//*Label 10857*/ GIMT_Encode4(682888), // Rule ID 10772 //
     /*  682818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  682829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  682832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  682835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  682864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682886 */     GIR_RootConstrainSelectedInstOperands,
     /*  682887 */     // GIR_Coverage, 10772,
     /*  682887 */     GIR_EraseRootFromParent_Done,
     /*  682888 */   // Label 10857: @682888
     /*  682888 */   GIM_Try, /*On fail goto*//*Label 10858*/ GIMT_Encode4(682963), // Rule ID 10773 //
     /*  682893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  682904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  682907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  682910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682939 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  682939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682961 */     GIR_RootConstrainSelectedInstOperands,
     /*  682962 */     // GIR_Coverage, 10773,
     /*  682962 */     GIR_EraseRootFromParent_Done,
     /*  682963 */   // Label 10858: @682963
     /*  682963 */   GIM_Try, /*On fail goto*//*Label 10859*/ GIMT_Encode4(683038), // Rule ID 10776 //
     /*  682968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  682971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  682979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  682982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  682985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  683017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683036 */     GIR_RootConstrainSelectedInstOperands,
     /*  683037 */     // GIR_Coverage, 10776,
     /*  683037 */     GIR_EraseRootFromParent_Done,
     /*  683038 */   // Label 10859: @683038
     /*  683038 */   GIM_Try, /*On fail goto*//*Label 10860*/ GIMT_Encode4(683113), // Rule ID 10777 //
     /*  683043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  683054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  683057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  683060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683089 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  683092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683111 */     GIR_RootConstrainSelectedInstOperands,
     /*  683112 */     // GIR_Coverage, 10777,
     /*  683112 */     GIR_EraseRootFromParent_Done,
     /*  683113 */   // Label 10860: @683113
     /*  683113 */   GIM_Try, /*On fail goto*//*Label 10861*/ GIMT_Encode4(683188), // Rule ID 10780 //
     /*  683118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  683129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  683132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  683135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683164 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  683167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683186 */     GIR_RootConstrainSelectedInstOperands,
     /*  683187 */     // GIR_Coverage, 10780,
     /*  683187 */     GIR_EraseRootFromParent_Done,
     /*  683188 */   // Label 10861: @683188
     /*  683188 */   GIM_Try, /*On fail goto*//*Label 10862*/ GIMT_Encode4(683263), // Rule ID 10781 //
     /*  683193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  683204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  683207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  683210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683239 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  683242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683261 */     GIR_RootConstrainSelectedInstOperands,
     /*  683262 */     // GIR_Coverage, 10781,
     /*  683262 */     GIR_EraseRootFromParent_Done,
     /*  683263 */   // Label 10862: @683263
     /*  683263 */   GIM_Try, /*On fail goto*//*Label 10863*/ GIMT_Encode4(683338), // Rule ID 10784 //
     /*  683268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  683279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  683282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  683285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683314 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  683317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683336 */     GIR_RootConstrainSelectedInstOperands,
     /*  683337 */     // GIR_Coverage, 10784,
     /*  683337 */     GIR_EraseRootFromParent_Done,
     /*  683338 */   // Label 10863: @683338
     /*  683338 */   GIM_Try, /*On fail goto*//*Label 10864*/ GIMT_Encode4(683413), // Rule ID 10785 //
     /*  683343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  683354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  683357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  683360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683389 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  683392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683411 */     GIR_RootConstrainSelectedInstOperands,
     /*  683412 */     // GIR_Coverage, 10785,
     /*  683412 */     GIR_EraseRootFromParent_Done,
     /*  683413 */   // Label 10864: @683413
     /*  683413 */   GIM_Try, /*On fail goto*//*Label 10865*/ GIMT_Encode4(683488), // Rule ID 10788 //
     /*  683418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  683429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  683432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  683435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  683438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683464 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  683467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683486 */     GIR_RootConstrainSelectedInstOperands,
     /*  683487 */     // GIR_Coverage, 10788,
     /*  683487 */     GIR_EraseRootFromParent_Done,
     /*  683488 */   // Label 10865: @683488
     /*  683488 */   GIM_Try, /*On fail goto*//*Label 10866*/ GIMT_Encode4(683563), // Rule ID 10789 //
     /*  683493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  683504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  683507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  683510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  683513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683539 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  683539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  683542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683561 */     GIR_RootConstrainSelectedInstOperands,
     /*  683562 */     // GIR_Coverage, 10789,
     /*  683562 */     GIR_EraseRootFromParent_Done,
     /*  683563 */   // Label 10866: @683563
     /*  683563 */   GIM_Try, /*On fail goto*//*Label 10867*/ GIMT_Encode4(683638), // Rule ID 10792 //
     /*  683568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  683579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  683582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  683585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  683588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683614 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  683617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683636 */     GIR_RootConstrainSelectedInstOperands,
     /*  683637 */     // GIR_Coverage, 10792,
     /*  683637 */     GIR_EraseRootFromParent_Done,
     /*  683638 */   // Label 10867: @683638
     /*  683638 */   GIM_Try, /*On fail goto*//*Label 10868*/ GIMT_Encode4(683713), // Rule ID 10793 //
     /*  683643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  683654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  683657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  683660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  683663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683689 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  683689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  683692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683711 */     GIR_RootConstrainSelectedInstOperands,
     /*  683712 */     // GIR_Coverage, 10793,
     /*  683712 */     GIR_EraseRootFromParent_Done,
     /*  683713 */   // Label 10868: @683713
     /*  683713 */   GIM_Try, /*On fail goto*//*Label 10869*/ GIMT_Encode4(683788), // Rule ID 10796 //
     /*  683718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  683729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  683732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  683735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  683738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683764 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  683767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683786 */     GIR_RootConstrainSelectedInstOperands,
     /*  683787 */     // GIR_Coverage, 10796,
     /*  683787 */     GIR_EraseRootFromParent_Done,
     /*  683788 */   // Label 10869: @683788
     /*  683788 */   GIM_Try, /*On fail goto*//*Label 10870*/ GIMT_Encode4(683863), // Rule ID 10797 //
     /*  683793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  683804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  683807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  683810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  683813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683839 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  683839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  683842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683861 */     GIR_RootConstrainSelectedInstOperands,
     /*  683862 */     // GIR_Coverage, 10797,
     /*  683862 */     GIR_EraseRootFromParent_Done,
     /*  683863 */   // Label 10870: @683863
     /*  683863 */   GIM_Try, /*On fail goto*//*Label 10871*/ GIMT_Encode4(683938), // Rule ID 10800 //
     /*  683868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  683879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  683882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  683885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  683888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683914 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  683914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  683917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683936 */     GIR_RootConstrainSelectedInstOperands,
     /*  683937 */     // GIR_Coverage, 10800,
     /*  683937 */     GIR_EraseRootFromParent_Done,
     /*  683938 */   // Label 10871: @683938
     /*  683938 */   GIM_Try, /*On fail goto*//*Label 10872*/ GIMT_Encode4(684013), // Rule ID 10801 //
     /*  683943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  683954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  683957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  683960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  683963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683989 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  683989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  683992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684011 */     GIR_RootConstrainSelectedInstOperands,
     /*  684012 */     // GIR_Coverage, 10801,
     /*  684012 */     GIR_EraseRootFromParent_Done,
     /*  684013 */   // Label 10872: @684013
     /*  684013 */   GIM_Try, /*On fail goto*//*Label 10873*/ GIMT_Encode4(684088), // Rule ID 10804 //
     /*  684018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  684029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  684032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  684035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  684038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684064 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684086 */     GIR_RootConstrainSelectedInstOperands,
     /*  684087 */     // GIR_Coverage, 10804,
     /*  684087 */     GIR_EraseRootFromParent_Done,
     /*  684088 */   // Label 10873: @684088
     /*  684088 */   GIM_Try, /*On fail goto*//*Label 10874*/ GIMT_Encode4(684163), // Rule ID 10805 //
     /*  684093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  684104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  684107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  684110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  684113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684139 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684161 */     GIR_RootConstrainSelectedInstOperands,
     /*  684162 */     // GIR_Coverage, 10805,
     /*  684162 */     GIR_EraseRootFromParent_Done,
     /*  684163 */   // Label 10874: @684163
     /*  684163 */   GIM_Try, /*On fail goto*//*Label 10875*/ GIMT_Encode4(684238), // Rule ID 10808 //
     /*  684168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  684179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  684182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  684185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  684188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684214 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  684214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684236 */     GIR_RootConstrainSelectedInstOperands,
     /*  684237 */     // GIR_Coverage, 10808,
     /*  684237 */     GIR_EraseRootFromParent_Done,
     /*  684238 */   // Label 10875: @684238
     /*  684238 */   GIM_Try, /*On fail goto*//*Label 10876*/ GIMT_Encode4(684313), // Rule ID 10809 //
     /*  684243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  684254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  684257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  684260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  684263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684289 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  684289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684311 */     GIR_RootConstrainSelectedInstOperands,
     /*  684312 */     // GIR_Coverage, 10809,
     /*  684312 */     GIR_EraseRootFromParent_Done,
     /*  684313 */   // Label 10876: @684313
     /*  684313 */   GIM_Try, /*On fail goto*//*Label 10877*/ GIMT_Encode4(684388), // Rule ID 10812 //
     /*  684318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  684329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  684332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  684335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  684338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684364 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684386 */     GIR_RootConstrainSelectedInstOperands,
     /*  684387 */     // GIR_Coverage, 10812,
     /*  684387 */     GIR_EraseRootFromParent_Done,
     /*  684388 */   // Label 10877: @684388
     /*  684388 */   GIM_Try, /*On fail goto*//*Label 10878*/ GIMT_Encode4(684463), // Rule ID 10813 //
     /*  684393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  684404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  684407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  684410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  684413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684439 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684461 */     GIR_RootConstrainSelectedInstOperands,
     /*  684462 */     // GIR_Coverage, 10813,
     /*  684462 */     GIR_EraseRootFromParent_Done,
     /*  684463 */   // Label 10878: @684463
     /*  684463 */   GIM_Try, /*On fail goto*//*Label 10879*/ GIMT_Encode4(684538), // Rule ID 10816 //
     /*  684468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  684479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  684482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  684485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  684488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684514 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684536 */     GIR_RootConstrainSelectedInstOperands,
     /*  684537 */     // GIR_Coverage, 10816,
     /*  684537 */     GIR_EraseRootFromParent_Done,
     /*  684538 */   // Label 10879: @684538
     /*  684538 */   GIM_Try, /*On fail goto*//*Label 10880*/ GIMT_Encode4(684613), // Rule ID 10817 //
     /*  684543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  684554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  684557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  684560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  684563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684589 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684611 */     GIR_RootConstrainSelectedInstOperands,
     /*  684612 */     // GIR_Coverage, 10817,
     /*  684612 */     GIR_EraseRootFromParent_Done,
     /*  684613 */   // Label 10880: @684613
     /*  684613 */   GIM_Try, /*On fail goto*//*Label 10881*/ GIMT_Encode4(684688), // Rule ID 10820 //
     /*  684618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  684629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  684632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  684635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  684638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684664 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  684664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684686 */     GIR_RootConstrainSelectedInstOperands,
     /*  684687 */     // GIR_Coverage, 10820,
     /*  684687 */     GIR_EraseRootFromParent_Done,
     /*  684688 */   // Label 10881: @684688
     /*  684688 */   GIM_Try, /*On fail goto*//*Label 10882*/ GIMT_Encode4(684763), // Rule ID 10821 //
     /*  684693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  684704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  684707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  684710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  684713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684739 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  684739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684761 */     GIR_RootConstrainSelectedInstOperands,
     /*  684762 */     // GIR_Coverage, 10821,
     /*  684762 */     GIR_EraseRootFromParent_Done,
     /*  684763 */   // Label 10882: @684763
     /*  684763 */   GIM_Try, /*On fail goto*//*Label 10883*/ GIMT_Encode4(684838), // Rule ID 10824 //
     /*  684768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  684771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  684779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  684782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  684785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  684788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684814 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  684814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  684833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684836 */     GIR_RootConstrainSelectedInstOperands,
     /*  684837 */     // GIR_Coverage, 10824,
     /*  684837 */     GIR_EraseRootFromParent_Done,
     /*  684838 */   // Label 10883: @684838
     /*  684838 */   GIM_Try, /*On fail goto*//*Label 10884*/ GIMT_Encode4(684913), // Rule ID 10825 //
     /*  684843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  684846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  684854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  684857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  684860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  684863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684889 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  684889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  684908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684911 */     GIR_RootConstrainSelectedInstOperands,
     /*  684912 */     // GIR_Coverage, 10825,
     /*  684912 */     GIR_EraseRootFromParent_Done,
     /*  684913 */   // Label 10884: @684913
     /*  684913 */   GIM_Try, /*On fail goto*//*Label 10885*/ GIMT_Encode4(684988), // Rule ID 10828 //
     /*  684918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  684929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  684932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  684935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  684938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684964 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  684967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684986 */     GIR_RootConstrainSelectedInstOperands,
     /*  684987 */     // GIR_Coverage, 10828,
     /*  684987 */     GIR_EraseRootFromParent_Done,
     /*  684988 */   // Label 10885: @684988
     /*  684988 */   GIM_Try, /*On fail goto*//*Label 10886*/ GIMT_Encode4(685063), // Rule ID 10829 //
     /*  684993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  685004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  685007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  685010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  685013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685039 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685061 */     GIR_RootConstrainSelectedInstOperands,
     /*  685062 */     // GIR_Coverage, 10829,
     /*  685062 */     GIR_EraseRootFromParent_Done,
     /*  685063 */   // Label 10886: @685063
     /*  685063 */   GIM_Try, /*On fail goto*//*Label 10887*/ GIMT_Encode4(685138), // Rule ID 10832 //
     /*  685068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  685079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  685082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  685085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  685088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685114 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685136 */     GIR_RootConstrainSelectedInstOperands,
     /*  685137 */     // GIR_Coverage, 10832,
     /*  685137 */     GIR_EraseRootFromParent_Done,
     /*  685138 */   // Label 10887: @685138
     /*  685138 */   GIM_Try, /*On fail goto*//*Label 10888*/ GIMT_Encode4(685213), // Rule ID 10833 //
     /*  685143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  685154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  685157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  685160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  685163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685189 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685211 */     GIR_RootConstrainSelectedInstOperands,
     /*  685212 */     // GIR_Coverage, 10833,
     /*  685212 */     GIR_EraseRootFromParent_Done,
     /*  685213 */   // Label 10888: @685213
     /*  685213 */   GIM_Try, /*On fail goto*//*Label 10889*/ GIMT_Encode4(685288), // Rule ID 10836 //
     /*  685218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  685229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  685232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  685235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  685238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685264 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685286 */     GIR_RootConstrainSelectedInstOperands,
     /*  685287 */     // GIR_Coverage, 10836,
     /*  685287 */     GIR_EraseRootFromParent_Done,
     /*  685288 */   // Label 10889: @685288
     /*  685288 */   GIM_Try, /*On fail goto*//*Label 10890*/ GIMT_Encode4(685363), // Rule ID 10837 //
     /*  685293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  685304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  685307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  685310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  685313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685339 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685361 */     GIR_RootConstrainSelectedInstOperands,
     /*  685362 */     // GIR_Coverage, 10837,
     /*  685362 */     GIR_EraseRootFromParent_Done,
     /*  685363 */   // Label 10890: @685363
     /*  685363 */   GIM_Try, /*On fail goto*//*Label 10891*/ GIMT_Encode4(685438), // Rule ID 10840 //
     /*  685368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  685379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  685382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  685385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  685388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685414 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685436 */     GIR_RootConstrainSelectedInstOperands,
     /*  685437 */     // GIR_Coverage, 10840,
     /*  685437 */     GIR_EraseRootFromParent_Done,
     /*  685438 */   // Label 10891: @685438
     /*  685438 */   GIM_Try, /*On fail goto*//*Label 10892*/ GIMT_Encode4(685513), // Rule ID 10841 //
     /*  685443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  685454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  685457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  685460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  685463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685489 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685511 */     GIR_RootConstrainSelectedInstOperands,
     /*  685512 */     // GIR_Coverage, 10841,
     /*  685512 */     GIR_EraseRootFromParent_Done,
     /*  685513 */   // Label 10892: @685513
     /*  685513 */   GIM_Try, /*On fail goto*//*Label 10893*/ GIMT_Encode4(685588), // Rule ID 10844 //
     /*  685518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  685529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  685532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  685535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  685538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685564 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685586 */     GIR_RootConstrainSelectedInstOperands,
     /*  685587 */     // GIR_Coverage, 10844,
     /*  685587 */     GIR_EraseRootFromParent_Done,
     /*  685588 */   // Label 10893: @685588
     /*  685588 */   GIM_Try, /*On fail goto*//*Label 10894*/ GIMT_Encode4(685663), // Rule ID 10845 //
     /*  685593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  685604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  685607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  685610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  685613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685639 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685661 */     GIR_RootConstrainSelectedInstOperands,
     /*  685662 */     // GIR_Coverage, 10845,
     /*  685662 */     GIR_EraseRootFromParent_Done,
     /*  685663 */   // Label 10894: @685663
     /*  685663 */   GIM_Try, /*On fail goto*//*Label 10895*/ GIMT_Encode4(685738), // Rule ID 10848 //
     /*  685668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  685679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  685682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  685685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  685688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685714 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685736 */     GIR_RootConstrainSelectedInstOperands,
     /*  685737 */     // GIR_Coverage, 10848,
     /*  685737 */     GIR_EraseRootFromParent_Done,
     /*  685738 */   // Label 10895: @685738
     /*  685738 */   GIM_Try, /*On fail goto*//*Label 10896*/ GIMT_Encode4(685813), // Rule ID 10849 //
     /*  685743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  685754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  685757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  685760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  685763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685789 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685811 */     GIR_RootConstrainSelectedInstOperands,
     /*  685812 */     // GIR_Coverage, 10849,
     /*  685812 */     GIR_EraseRootFromParent_Done,
     /*  685813 */   // Label 10896: @685813
     /*  685813 */   GIM_Try, /*On fail goto*//*Label 10897*/ GIMT_Encode4(685888), // Rule ID 10852 //
     /*  685818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  685829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  685832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  685835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  685838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  685864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685886 */     GIR_RootConstrainSelectedInstOperands,
     /*  685887 */     // GIR_Coverage, 10852,
     /*  685887 */     GIR_EraseRootFromParent_Done,
     /*  685888 */   // Label 10897: @685888
     /*  685888 */   GIM_Try, /*On fail goto*//*Label 10898*/ GIMT_Encode4(685963), // Rule ID 10853 //
     /*  685893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  685904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  685907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  685910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  685913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685939 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  685939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685961 */     GIR_RootConstrainSelectedInstOperands,
     /*  685962 */     // GIR_Coverage, 10853,
     /*  685962 */     GIR_EraseRootFromParent_Done,
     /*  685963 */   // Label 10898: @685963
     /*  685963 */   GIM_Try, /*On fail goto*//*Label 10899*/ GIMT_Encode4(686038), // Rule ID 10856 //
     /*  685968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  685979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  685982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  685985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  685988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686014 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686036 */     GIR_RootConstrainSelectedInstOperands,
     /*  686037 */     // GIR_Coverage, 10856,
     /*  686037 */     GIR_EraseRootFromParent_Done,
     /*  686038 */   // Label 10899: @686038
     /*  686038 */   GIM_Try, /*On fail goto*//*Label 10900*/ GIMT_Encode4(686113), // Rule ID 10857 //
     /*  686043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  686054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  686057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  686060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  686063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686089 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686111 */     GIR_RootConstrainSelectedInstOperands,
     /*  686112 */     // GIR_Coverage, 10857,
     /*  686112 */     GIR_EraseRootFromParent_Done,
     /*  686113 */   // Label 10900: @686113
     /*  686113 */   GIM_Try, /*On fail goto*//*Label 10901*/ GIMT_Encode4(686188), // Rule ID 10860 //
     /*  686118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  686129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  686132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  686135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  686138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686164 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686186 */     GIR_RootConstrainSelectedInstOperands,
     /*  686187 */     // GIR_Coverage, 10860,
     /*  686187 */     GIR_EraseRootFromParent_Done,
     /*  686188 */   // Label 10901: @686188
     /*  686188 */   GIM_Try, /*On fail goto*//*Label 10902*/ GIMT_Encode4(686263), // Rule ID 10861 //
     /*  686193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  686204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  686207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  686210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  686213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686239 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686261 */     GIR_RootConstrainSelectedInstOperands,
     /*  686262 */     // GIR_Coverage, 10861,
     /*  686262 */     GIR_EraseRootFromParent_Done,
     /*  686263 */   // Label 10902: @686263
     /*  686263 */   GIM_Try, /*On fail goto*//*Label 10903*/ GIMT_Encode4(686338), // Rule ID 10864 //
     /*  686268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  686279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  686282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  686285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  686288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  686317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686336 */     GIR_RootConstrainSelectedInstOperands,
     /*  686337 */     // GIR_Coverage, 10864,
     /*  686337 */     GIR_EraseRootFromParent_Done,
     /*  686338 */   // Label 10903: @686338
     /*  686338 */   GIM_Try, /*On fail goto*//*Label 10904*/ GIMT_Encode4(686413), // Rule ID 10865 //
     /*  686343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  686346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  686354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  686357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  686360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  686363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686389 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  686389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  686392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686411 */     GIR_RootConstrainSelectedInstOperands,
     /*  686412 */     // GIR_Coverage, 10865,
     /*  686412 */     GIR_EraseRootFromParent_Done,
     /*  686413 */   // Label 10904: @686413
     /*  686413 */   GIM_Try, /*On fail goto*//*Label 10905*/ GIMT_Encode4(686488), // Rule ID 10868 //
     /*  686418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  686429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  686432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  686435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  686438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686464 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686486 */     GIR_RootConstrainSelectedInstOperands,
     /*  686487 */     // GIR_Coverage, 10868,
     /*  686487 */     GIR_EraseRootFromParent_Done,
     /*  686488 */   // Label 10905: @686488
     /*  686488 */   GIM_Try, /*On fail goto*//*Label 10906*/ GIMT_Encode4(686563), // Rule ID 10869 //
     /*  686493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  686496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  686504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  686507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  686510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  686513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686539 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  686539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686561 */     GIR_RootConstrainSelectedInstOperands,
     /*  686562 */     // GIR_Coverage, 10869,
     /*  686562 */     GIR_EraseRootFromParent_Done,
     /*  686563 */   // Label 10906: @686563
     /*  686563 */   GIM_Try, /*On fail goto*//*Label 10907*/ GIMT_Encode4(686638), // Rule ID 10872 //
     /*  686568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  686579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  686582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  686585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  686588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686614 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686636 */     GIR_RootConstrainSelectedInstOperands,
     /*  686637 */     // GIR_Coverage, 10872,
     /*  686637 */     GIR_EraseRootFromParent_Done,
     /*  686638 */   // Label 10907: @686638
     /*  686638 */   GIM_Try, /*On fail goto*//*Label 10908*/ GIMT_Encode4(686713), // Rule ID 10873 //
     /*  686643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  686646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  686654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  686657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  686660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  686663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686689 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  686689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686711 */     GIR_RootConstrainSelectedInstOperands,
     /*  686712 */     // GIR_Coverage, 10873,
     /*  686712 */     GIR_EraseRootFromParent_Done,
     /*  686713 */   // Label 10908: @686713
     /*  686713 */   GIM_Try, /*On fail goto*//*Label 10909*/ GIMT_Encode4(686788), // Rule ID 10876 //
     /*  686718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  686729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  686732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  686735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686764 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  686764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  686767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686786 */     GIR_RootConstrainSelectedInstOperands,
     /*  686787 */     // GIR_Coverage, 10876,
     /*  686787 */     GIR_EraseRootFromParent_Done,
     /*  686788 */   // Label 10909: @686788
     /*  686788 */   GIM_Try, /*On fail goto*//*Label 10910*/ GIMT_Encode4(686863), // Rule ID 10877 //
     /*  686793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  686804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  686807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  686810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686839 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  686839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  686842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686861 */     GIR_RootConstrainSelectedInstOperands,
     /*  686862 */     // GIR_Coverage, 10877,
     /*  686862 */     GIR_EraseRootFromParent_Done,
     /*  686863 */   // Label 10910: @686863
     /*  686863 */   GIM_Try, /*On fail goto*//*Label 10911*/ GIMT_Encode4(686938), // Rule ID 10880 //
     /*  686868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  686879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  686882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  686885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686914 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  686914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  686917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686936 */     GIR_RootConstrainSelectedInstOperands,
     /*  686937 */     // GIR_Coverage, 10880,
     /*  686937 */     GIR_EraseRootFromParent_Done,
     /*  686938 */   // Label 10911: @686938
     /*  686938 */   GIM_Try, /*On fail goto*//*Label 10912*/ GIMT_Encode4(687013), // Rule ID 10881 //
     /*  686943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  686954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  686957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  686960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686989 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  686989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  686992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687011 */     GIR_RootConstrainSelectedInstOperands,
     /*  687012 */     // GIR_Coverage, 10881,
     /*  687012 */     GIR_EraseRootFromParent_Done,
     /*  687013 */   // Label 10912: @687013
     /*  687013 */   GIM_Try, /*On fail goto*//*Label 10913*/ GIMT_Encode4(687088), // Rule ID 10884 //
     /*  687018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  687029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  687032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  687035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687064 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687086 */     GIR_RootConstrainSelectedInstOperands,
     /*  687087 */     // GIR_Coverage, 10884,
     /*  687087 */     GIR_EraseRootFromParent_Done,
     /*  687088 */   // Label 10913: @687088
     /*  687088 */   GIM_Try, /*On fail goto*//*Label 10914*/ GIMT_Encode4(687163), // Rule ID 10885 //
     /*  687093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  687104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  687107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  687110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687139 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687161 */     GIR_RootConstrainSelectedInstOperands,
     /*  687162 */     // GIR_Coverage, 10885,
     /*  687162 */     GIR_EraseRootFromParent_Done,
     /*  687163 */   // Label 10914: @687163
     /*  687163 */   GIM_Try, /*On fail goto*//*Label 10915*/ GIMT_Encode4(687238), // Rule ID 10888 //
     /*  687168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  687179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  687182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  687185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  687217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687236 */     GIR_RootConstrainSelectedInstOperands,
     /*  687237 */     // GIR_Coverage, 10888,
     /*  687237 */     GIR_EraseRootFromParent_Done,
     /*  687238 */   // Label 10915: @687238
     /*  687238 */   GIM_Try, /*On fail goto*//*Label 10916*/ GIMT_Encode4(687313), // Rule ID 10889 //
     /*  687243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  687254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  687257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  687260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687289 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  687292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687311 */     GIR_RootConstrainSelectedInstOperands,
     /*  687312 */     // GIR_Coverage, 10889,
     /*  687312 */     GIR_EraseRootFromParent_Done,
     /*  687313 */   // Label 10916: @687313
     /*  687313 */   GIM_Try, /*On fail goto*//*Label 10917*/ GIMT_Encode4(687388), // Rule ID 10892 //
     /*  687318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  687329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  687332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  687335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687364 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687386 */     GIR_RootConstrainSelectedInstOperands,
     /*  687387 */     // GIR_Coverage, 10892,
     /*  687387 */     GIR_EraseRootFromParent_Done,
     /*  687388 */   // Label 10917: @687388
     /*  687388 */   GIM_Try, /*On fail goto*//*Label 10918*/ GIMT_Encode4(687463), // Rule ID 10893 //
     /*  687393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  687404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  687407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  687410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687439 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687461 */     GIR_RootConstrainSelectedInstOperands,
     /*  687462 */     // GIR_Coverage, 10893,
     /*  687462 */     GIR_EraseRootFromParent_Done,
     /*  687463 */   // Label 10918: @687463
     /*  687463 */   GIM_Try, /*On fail goto*//*Label 10919*/ GIMT_Encode4(687538), // Rule ID 10896 //
     /*  687468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  687479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  687482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  687485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687514 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  687514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687536 */     GIR_RootConstrainSelectedInstOperands,
     /*  687537 */     // GIR_Coverage, 10896,
     /*  687537 */     GIR_EraseRootFromParent_Done,
     /*  687538 */   // Label 10919: @687538
     /*  687538 */   GIM_Try, /*On fail goto*//*Label 10920*/ GIMT_Encode4(687613), // Rule ID 10897 //
     /*  687543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  687554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  687557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  687560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687589 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  687589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687611 */     GIR_RootConstrainSelectedInstOperands,
     /*  687612 */     // GIR_Coverage, 10897,
     /*  687612 */     GIR_EraseRootFromParent_Done,
     /*  687613 */   // Label 10920: @687613
     /*  687613 */   GIM_Try, /*On fail goto*//*Label 10921*/ GIMT_Encode4(687688), // Rule ID 10900 //
     /*  687618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  687629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  687632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  687635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687664 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687686 */     GIR_RootConstrainSelectedInstOperands,
     /*  687687 */     // GIR_Coverage, 10900,
     /*  687687 */     GIR_EraseRootFromParent_Done,
     /*  687688 */   // Label 10921: @687688
     /*  687688 */   GIM_Try, /*On fail goto*//*Label 10922*/ GIMT_Encode4(687763), // Rule ID 10901 //
     /*  687693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  687704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  687707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  687710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687739 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687761 */     GIR_RootConstrainSelectedInstOperands,
     /*  687762 */     // GIR_Coverage, 10901,
     /*  687762 */     GIR_EraseRootFromParent_Done,
     /*  687763 */   // Label 10922: @687763
     /*  687763 */   GIM_Try, /*On fail goto*//*Label 10923*/ GIMT_Encode4(687838), // Rule ID 10904 //
     /*  687768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  687779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  687782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  687785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687814 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687836 */     GIR_RootConstrainSelectedInstOperands,
     /*  687837 */     // GIR_Coverage, 10904,
     /*  687837 */     GIR_EraseRootFromParent_Done,
     /*  687838 */   // Label 10923: @687838
     /*  687838 */   GIM_Try, /*On fail goto*//*Label 10924*/ GIMT_Encode4(687913), // Rule ID 10905 //
     /*  687843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  687854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  687857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  687860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687889 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687911 */     GIR_RootConstrainSelectedInstOperands,
     /*  687912 */     // GIR_Coverage, 10905,
     /*  687912 */     GIR_EraseRootFromParent_Done,
     /*  687913 */   // Label 10924: @687913
     /*  687913 */   GIM_Try, /*On fail goto*//*Label 10925*/ GIMT_Encode4(687988), // Rule ID 10908 //
     /*  687918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  687929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  687932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  687935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687964 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  687964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687986 */     GIR_RootConstrainSelectedInstOperands,
     /*  687987 */     // GIR_Coverage, 10908,
     /*  687987 */     GIR_EraseRootFromParent_Done,
     /*  687988 */   // Label 10925: @687988
     /*  687988 */   GIM_Try, /*On fail goto*//*Label 10926*/ GIMT_Encode4(688063), // Rule ID 10909 //
     /*  687993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  688004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  688007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  688010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688039 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688061 */     GIR_RootConstrainSelectedInstOperands,
     /*  688062 */     // GIR_Coverage, 10909,
     /*  688062 */     GIR_EraseRootFromParent_Done,
     /*  688063 */   // Label 10926: @688063
     /*  688063 */   GIM_Try, /*On fail goto*//*Label 10927*/ GIMT_Encode4(688138), // Rule ID 10912 //
     /*  688068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  688071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  688079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  688082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  688085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688114 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  688114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  688133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688136 */     GIR_RootConstrainSelectedInstOperands,
     /*  688137 */     // GIR_Coverage, 10912,
     /*  688137 */     GIR_EraseRootFromParent_Done,
     /*  688138 */   // Label 10927: @688138
     /*  688138 */   GIM_Try, /*On fail goto*//*Label 10928*/ GIMT_Encode4(688213), // Rule ID 10913 //
     /*  688143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  688146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  688154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  688157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  688160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688189 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  688189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  688208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688211 */     GIR_RootConstrainSelectedInstOperands,
     /*  688212 */     // GIR_Coverage, 10913,
     /*  688212 */     GIR_EraseRootFromParent_Done,
     /*  688213 */   // Label 10928: @688213
     /*  688213 */   GIM_Try, /*On fail goto*//*Label 10929*/ GIMT_Encode4(688288), // Rule ID 10916 //
     /*  688218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  688229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  688232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  688235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688264 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688286 */     GIR_RootConstrainSelectedInstOperands,
     /*  688287 */     // GIR_Coverage, 10916,
     /*  688287 */     GIR_EraseRootFromParent_Done,
     /*  688288 */   // Label 10929: @688288
     /*  688288 */   GIM_Try, /*On fail goto*//*Label 10930*/ GIMT_Encode4(688363), // Rule ID 10917 //
     /*  688293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  688304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  688307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  688310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688339 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688361 */     GIR_RootConstrainSelectedInstOperands,
     /*  688362 */     // GIR_Coverage, 10917,
     /*  688362 */     GIR_EraseRootFromParent_Done,
     /*  688363 */   // Label 10930: @688363
     /*  688363 */   GIM_Try, /*On fail goto*//*Label 10931*/ GIMT_Encode4(688438), // Rule ID 10920 //
     /*  688368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  688379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  688382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  688385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688414 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688436 */     GIR_RootConstrainSelectedInstOperands,
     /*  688437 */     // GIR_Coverage, 10920,
     /*  688437 */     GIR_EraseRootFromParent_Done,
     /*  688438 */   // Label 10931: @688438
     /*  688438 */   GIM_Try, /*On fail goto*//*Label 10932*/ GIMT_Encode4(688513), // Rule ID 10921 //
     /*  688443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  688454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  688457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  688460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688489 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688511 */     GIR_RootConstrainSelectedInstOperands,
     /*  688512 */     // GIR_Coverage, 10921,
     /*  688512 */     GIR_EraseRootFromParent_Done,
     /*  688513 */   // Label 10932: @688513
     /*  688513 */   GIM_Try, /*On fail goto*//*Label 10933*/ GIMT_Encode4(688588), // Rule ID 10924 //
     /*  688518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  688529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  688532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  688535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688564 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  688567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688586 */     GIR_RootConstrainSelectedInstOperands,
     /*  688587 */     // GIR_Coverage, 10924,
     /*  688587 */     GIR_EraseRootFromParent_Done,
     /*  688588 */   // Label 10933: @688588
     /*  688588 */   GIM_Try, /*On fail goto*//*Label 10934*/ GIMT_Encode4(688663), // Rule ID 10925 //
     /*  688593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  688604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  688607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  688610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688639 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  688642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688661 */     GIR_RootConstrainSelectedInstOperands,
     /*  688662 */     // GIR_Coverage, 10925,
     /*  688662 */     GIR_EraseRootFromParent_Done,
     /*  688663 */   // Label 10934: @688663
     /*  688663 */   GIM_Try, /*On fail goto*//*Label 10935*/ GIMT_Encode4(688738), // Rule ID 10928 //
     /*  688668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  688679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  688682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  688685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688736 */     GIR_RootConstrainSelectedInstOperands,
     /*  688737 */     // GIR_Coverage, 10928,
     /*  688737 */     GIR_EraseRootFromParent_Done,
     /*  688738 */   // Label 10935: @688738
     /*  688738 */   GIM_Try, /*On fail goto*//*Label 10936*/ GIMT_Encode4(688813), // Rule ID 10929 //
     /*  688743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  688754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  688757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  688760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688789 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688811 */     GIR_RootConstrainSelectedInstOperands,
     /*  688812 */     // GIR_Coverage, 10929,
     /*  688812 */     GIR_EraseRootFromParent_Done,
     /*  688813 */   // Label 10936: @688813
     /*  688813 */   GIM_Try, /*On fail goto*//*Label 10937*/ GIMT_Encode4(688888), // Rule ID 10932 //
     /*  688818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  688829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  688832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  688835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688864 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688886 */     GIR_RootConstrainSelectedInstOperands,
     /*  688887 */     // GIR_Coverage, 10932,
     /*  688887 */     GIR_EraseRootFromParent_Done,
     /*  688888 */   // Label 10937: @688888
     /*  688888 */   GIM_Try, /*On fail goto*//*Label 10938*/ GIMT_Encode4(688963), // Rule ID 10933 //
     /*  688893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  688904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  688907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  688910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688939 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688961 */     GIR_RootConstrainSelectedInstOperands,
     /*  688962 */     // GIR_Coverage, 10933,
     /*  688962 */     GIR_EraseRootFromParent_Done,
     /*  688963 */   // Label 10938: @688963
     /*  688963 */   GIM_Try, /*On fail goto*//*Label 10939*/ GIMT_Encode4(689038), // Rule ID 10936 //
     /*  688968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  688979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  688982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  688985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689014 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689036 */     GIR_RootConstrainSelectedInstOperands,
     /*  689037 */     // GIR_Coverage, 10936,
     /*  689037 */     GIR_EraseRootFromParent_Done,
     /*  689038 */   // Label 10939: @689038
     /*  689038 */   GIM_Try, /*On fail goto*//*Label 10940*/ GIMT_Encode4(689113), // Rule ID 10937 //
     /*  689043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  689054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  689057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  689060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689089 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689111 */     GIR_RootConstrainSelectedInstOperands,
     /*  689112 */     // GIR_Coverage, 10937,
     /*  689112 */     GIR_EraseRootFromParent_Done,
     /*  689113 */   // Label 10940: @689113
     /*  689113 */   GIM_Try, /*On fail goto*//*Label 10941*/ GIMT_Encode4(689188), // Rule ID 10940 //
     /*  689118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  689129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  689132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  689135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689186 */     GIR_RootConstrainSelectedInstOperands,
     /*  689187 */     // GIR_Coverage, 10940,
     /*  689187 */     GIR_EraseRootFromParent_Done,
     /*  689188 */   // Label 10941: @689188
     /*  689188 */   GIM_Try, /*On fail goto*//*Label 10942*/ GIMT_Encode4(689263), // Rule ID 10941 //
     /*  689193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  689204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  689207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  689210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689261 */     GIR_RootConstrainSelectedInstOperands,
     /*  689262 */     // GIR_Coverage, 10941,
     /*  689262 */     GIR_EraseRootFromParent_Done,
     /*  689263 */   // Label 10942: @689263
     /*  689263 */   GIM_Try, /*On fail goto*//*Label 10943*/ GIMT_Encode4(689338), // Rule ID 10944 //
     /*  689268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  689279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  689282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  689285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689336 */     GIR_RootConstrainSelectedInstOperands,
     /*  689337 */     // GIR_Coverage, 10944,
     /*  689337 */     GIR_EraseRootFromParent_Done,
     /*  689338 */   // Label 10943: @689338
     /*  689338 */   GIM_Try, /*On fail goto*//*Label 10944*/ GIMT_Encode4(689413), // Rule ID 10945 //
     /*  689343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  689354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  689357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  689360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689389 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689411 */     GIR_RootConstrainSelectedInstOperands,
     /*  689412 */     // GIR_Coverage, 10945,
     /*  689412 */     GIR_EraseRootFromParent_Done,
     /*  689413 */   // Label 10944: @689413
     /*  689413 */   GIM_Try, /*On fail goto*//*Label 10945*/ GIMT_Encode4(689488), // Rule ID 10948 //
     /*  689418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  689429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  689432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  689435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689486 */     GIR_RootConstrainSelectedInstOperands,
     /*  689487 */     // GIR_Coverage, 10948,
     /*  689487 */     GIR_EraseRootFromParent_Done,
     /*  689488 */   // Label 10945: @689488
     /*  689488 */   GIM_Try, /*On fail goto*//*Label 10946*/ GIMT_Encode4(689563), // Rule ID 10949 //
     /*  689493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  689504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  689507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  689510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689539 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689561 */     GIR_RootConstrainSelectedInstOperands,
     /*  689562 */     // GIR_Coverage, 10949,
     /*  689562 */     GIR_EraseRootFromParent_Done,
     /*  689563 */   // Label 10946: @689563
     /*  689563 */   GIM_Try, /*On fail goto*//*Label 10947*/ GIMT_Encode4(689638), // Rule ID 10952 //
     /*  689568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  689571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  689579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  689582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  689585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689614 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  689614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689636 */     GIR_RootConstrainSelectedInstOperands,
     /*  689637 */     // GIR_Coverage, 10952,
     /*  689637 */     GIR_EraseRootFromParent_Done,
     /*  689638 */   // Label 10947: @689638
     /*  689638 */   GIM_Try, /*On fail goto*//*Label 10948*/ GIMT_Encode4(689713), // Rule ID 10953 //
     /*  689643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  689646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  689654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  689657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  689660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  689689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689711 */     GIR_RootConstrainSelectedInstOperands,
     /*  689712 */     // GIR_Coverage, 10953,
     /*  689712 */     GIR_EraseRootFromParent_Done,
     /*  689713 */   // Label 10948: @689713
     /*  689713 */   GIM_Try, /*On fail goto*//*Label 10949*/ GIMT_Encode4(689788), // Rule ID 10956 //
     /*  689718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  689721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  689729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  689732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  689735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689764 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  689764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689786 */     GIR_RootConstrainSelectedInstOperands,
     /*  689787 */     // GIR_Coverage, 10956,
     /*  689787 */     GIR_EraseRootFromParent_Done,
     /*  689788 */   // Label 10949: @689788
     /*  689788 */   GIM_Try, /*On fail goto*//*Label 10950*/ GIMT_Encode4(689863), // Rule ID 10957 //
     /*  689793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  689796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  689804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  689807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  689810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689839 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  689839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689861 */     GIR_RootConstrainSelectedInstOperands,
     /*  689862 */     // GIR_Coverage, 10957,
     /*  689862 */     GIR_EraseRootFromParent_Done,
     /*  689863 */   // Label 10950: @689863
     /*  689863 */   GIM_Try, /*On fail goto*//*Label 10951*/ GIMT_Encode4(689938), // Rule ID 10960 //
     /*  689868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  689871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  689879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  689882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  689885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689914 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  689914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689936 */     GIR_RootConstrainSelectedInstOperands,
     /*  689937 */     // GIR_Coverage, 10960,
     /*  689937 */     GIR_EraseRootFromParent_Done,
     /*  689938 */   // Label 10951: @689938
     /*  689938 */   GIM_Try, /*On fail goto*//*Label 10952*/ GIMT_Encode4(690013), // Rule ID 10961 //
     /*  689943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  689946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  689954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  689957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  689960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689989 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  689989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690011 */     GIR_RootConstrainSelectedInstOperands,
     /*  690012 */     // GIR_Coverage, 10961,
     /*  690012 */     GIR_EraseRootFromParent_Done,
     /*  690013 */   // Label 10952: @690013
     /*  690013 */   GIM_Try, /*On fail goto*//*Label 10953*/ GIMT_Encode4(690088), // Rule ID 10964 //
     /*  690018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  690029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  690032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  690035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  690038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690064 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  690067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690086 */     GIR_RootConstrainSelectedInstOperands,
     /*  690087 */     // GIR_Coverage, 10964,
     /*  690087 */     GIR_EraseRootFromParent_Done,
     /*  690088 */   // Label 10953: @690088
     /*  690088 */   GIM_Try, /*On fail goto*//*Label 10954*/ GIMT_Encode4(690163), // Rule ID 10965 //
     /*  690093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  690104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  690107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  690110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  690113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690139 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  690142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690161 */     GIR_RootConstrainSelectedInstOperands,
     /*  690162 */     // GIR_Coverage, 10965,
     /*  690162 */     GIR_EraseRootFromParent_Done,
     /*  690163 */   // Label 10954: @690163
     /*  690163 */   GIM_Try, /*On fail goto*//*Label 10955*/ GIMT_Encode4(690238), // Rule ID 10968 //
     /*  690168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  690179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  690182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  690185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  690188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690214 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690236 */     GIR_RootConstrainSelectedInstOperands,
     /*  690237 */     // GIR_Coverage, 10968,
     /*  690237 */     GIR_EraseRootFromParent_Done,
     /*  690238 */   // Label 10955: @690238
     /*  690238 */   GIM_Try, /*On fail goto*//*Label 10956*/ GIMT_Encode4(690313), // Rule ID 10969 //
     /*  690243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  690254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  690257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  690260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  690263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690289 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690311 */     GIR_RootConstrainSelectedInstOperands,
     /*  690312 */     // GIR_Coverage, 10969,
     /*  690312 */     GIR_EraseRootFromParent_Done,
     /*  690313 */   // Label 10956: @690313
     /*  690313 */   GIM_Try, /*On fail goto*//*Label 10957*/ GIMT_Encode4(690388), // Rule ID 10972 //
     /*  690318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  690329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  690332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  690335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  690338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690364 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690386 */     GIR_RootConstrainSelectedInstOperands,
     /*  690387 */     // GIR_Coverage, 10972,
     /*  690387 */     GIR_EraseRootFromParent_Done,
     /*  690388 */   // Label 10957: @690388
     /*  690388 */   GIM_Try, /*On fail goto*//*Label 10958*/ GIMT_Encode4(690463), // Rule ID 10973 //
     /*  690393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  690404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  690407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  690410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  690413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690439 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690461 */     GIR_RootConstrainSelectedInstOperands,
     /*  690462 */     // GIR_Coverage, 10973,
     /*  690462 */     GIR_EraseRootFromParent_Done,
     /*  690463 */   // Label 10958: @690463
     /*  690463 */   GIM_Try, /*On fail goto*//*Label 10959*/ GIMT_Encode4(690538), // Rule ID 10976 //
     /*  690468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  690479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  690482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  690485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  690488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690514 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  690514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690536 */     GIR_RootConstrainSelectedInstOperands,
     /*  690537 */     // GIR_Coverage, 10976,
     /*  690537 */     GIR_EraseRootFromParent_Done,
     /*  690538 */   // Label 10959: @690538
     /*  690538 */   GIM_Try, /*On fail goto*//*Label 10960*/ GIMT_Encode4(690613), // Rule ID 10977 //
     /*  690543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  690554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  690557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  690560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  690563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690589 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  690589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690611 */     GIR_RootConstrainSelectedInstOperands,
     /*  690612 */     // GIR_Coverage, 10977,
     /*  690612 */     GIR_EraseRootFromParent_Done,
     /*  690613 */   // Label 10960: @690613
     /*  690613 */   GIM_Try, /*On fail goto*//*Label 10961*/ GIMT_Encode4(690688), // Rule ID 10980 //
     /*  690618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  690629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  690632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  690635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  690638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690664 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  690664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690686 */     GIR_RootConstrainSelectedInstOperands,
     /*  690687 */     // GIR_Coverage, 10980,
     /*  690687 */     GIR_EraseRootFromParent_Done,
     /*  690688 */   // Label 10961: @690688
     /*  690688 */   GIM_Try, /*On fail goto*//*Label 10962*/ GIMT_Encode4(690763), // Rule ID 10981 //
     /*  690693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  690704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  690707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  690710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  690713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690739 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  690739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690761 */     GIR_RootConstrainSelectedInstOperands,
     /*  690762 */     // GIR_Coverage, 10981,
     /*  690762 */     GIR_EraseRootFromParent_Done,
     /*  690763 */   // Label 10962: @690763
     /*  690763 */   GIM_Try, /*On fail goto*//*Label 10963*/ GIMT_Encode4(690838), // Rule ID 10984 //
     /*  690768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  690779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  690782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  690785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  690788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  690814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690836 */     GIR_RootConstrainSelectedInstOperands,
     /*  690837 */     // GIR_Coverage, 10984,
     /*  690837 */     GIR_EraseRootFromParent_Done,
     /*  690838 */   // Label 10963: @690838
     /*  690838 */   GIM_Try, /*On fail goto*//*Label 10964*/ GIMT_Encode4(690913), // Rule ID 10985 //
     /*  690843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  690854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  690857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  690860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  690863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690889 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  690889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690911 */     GIR_RootConstrainSelectedInstOperands,
     /*  690912 */     // GIR_Coverage, 10985,
     /*  690912 */     GIR_EraseRootFromParent_Done,
     /*  690913 */   // Label 10964: @690913
     /*  690913 */   GIM_Try, /*On fail goto*//*Label 10965*/ GIMT_Encode4(690988), // Rule ID 10988 //
     /*  690918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  690929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  690932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  690935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  690938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690964 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  690967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690986 */     GIR_RootConstrainSelectedInstOperands,
     /*  690987 */     // GIR_Coverage, 10988,
     /*  690987 */     GIR_EraseRootFromParent_Done,
     /*  690988 */   // Label 10965: @690988
     /*  690988 */   GIM_Try, /*On fail goto*//*Label 10966*/ GIMT_Encode4(691063), // Rule ID 10989 //
     /*  690993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  691004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  691007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  691010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  691013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691039 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691061 */     GIR_RootConstrainSelectedInstOperands,
     /*  691062 */     // GIR_Coverage, 10989,
     /*  691062 */     GIR_EraseRootFromParent_Done,
     /*  691063 */   // Label 10966: @691063
     /*  691063 */   GIM_Try, /*On fail goto*//*Label 10967*/ GIMT_Encode4(691138), // Rule ID 10992 //
     /*  691068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  691079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  691082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  691085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  691088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691136 */     GIR_RootConstrainSelectedInstOperands,
     /*  691137 */     // GIR_Coverage, 10992,
     /*  691137 */     GIR_EraseRootFromParent_Done,
     /*  691138 */   // Label 10967: @691138
     /*  691138 */   GIM_Try, /*On fail goto*//*Label 10968*/ GIMT_Encode4(691213), // Rule ID 10993 //
     /*  691143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  691154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  691157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  691160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  691163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691189 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691211 */     GIR_RootConstrainSelectedInstOperands,
     /*  691212 */     // GIR_Coverage, 10993,
     /*  691212 */     GIR_EraseRootFromParent_Done,
     /*  691213 */   // Label 10968: @691213
     /*  691213 */   GIM_Try, /*On fail goto*//*Label 10969*/ GIMT_Encode4(691288), // Rule ID 10996 //
     /*  691218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  691229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  691232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  691235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  691238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  691264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691286 */     GIR_RootConstrainSelectedInstOperands,
     /*  691287 */     // GIR_Coverage, 10996,
     /*  691287 */     GIR_EraseRootFromParent_Done,
     /*  691288 */   // Label 10969: @691288
     /*  691288 */   GIM_Try, /*On fail goto*//*Label 10970*/ GIMT_Encode4(691363), // Rule ID 10997 //
     /*  691293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  691304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  691307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  691310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  691313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691339 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  691339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691361 */     GIR_RootConstrainSelectedInstOperands,
     /*  691362 */     // GIR_Coverage, 10997,
     /*  691362 */     GIR_EraseRootFromParent_Done,
     /*  691363 */   // Label 10970: @691363
     /*  691363 */   GIM_Try, /*On fail goto*//*Label 10971*/ GIMT_Encode4(691438), // Rule ID 11000 //
     /*  691368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  691371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  691379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  691382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  691385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  691388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  691414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691436 */     GIR_RootConstrainSelectedInstOperands,
     /*  691437 */     // GIR_Coverage, 11000,
     /*  691437 */     GIR_EraseRootFromParent_Done,
     /*  691438 */   // Label 10971: @691438
     /*  691438 */   GIM_Try, /*On fail goto*//*Label 10972*/ GIMT_Encode4(691513), // Rule ID 11001 //
     /*  691443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  691446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  691454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  691457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  691460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  691463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691489 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  691489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691511 */     GIR_RootConstrainSelectedInstOperands,
     /*  691512 */     // GIR_Coverage, 11001,
     /*  691512 */     GIR_EraseRootFromParent_Done,
     /*  691513 */   // Label 10972: @691513
     /*  691513 */   GIM_Try, /*On fail goto*//*Label 10973*/ GIMT_Encode4(691588), // Rule ID 11004 //
     /*  691518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  691529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  691532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  691535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  691538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691564 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  691564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  691567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691586 */     GIR_RootConstrainSelectedInstOperands,
     /*  691587 */     // GIR_Coverage, 11004,
     /*  691587 */     GIR_EraseRootFromParent_Done,
     /*  691588 */   // Label 10973: @691588
     /*  691588 */   GIM_Try, /*On fail goto*//*Label 10974*/ GIMT_Encode4(691663), // Rule ID 11005 //
     /*  691593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  691604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  691607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  691610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  691613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691639 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  691642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691661 */     GIR_RootConstrainSelectedInstOperands,
     /*  691662 */     // GIR_Coverage, 11005,
     /*  691662 */     GIR_EraseRootFromParent_Done,
     /*  691663 */   // Label 10974: @691663
     /*  691663 */   GIM_Try, /*On fail goto*//*Label 10975*/ GIMT_Encode4(691738), // Rule ID 11008 //
     /*  691668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  691679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  691682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  691685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  691688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691714 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  691714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  691717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691736 */     GIR_RootConstrainSelectedInstOperands,
     /*  691737 */     // GIR_Coverage, 11008,
     /*  691737 */     GIR_EraseRootFromParent_Done,
     /*  691738 */   // Label 10975: @691738
     /*  691738 */   GIM_Try, /*On fail goto*//*Label 10976*/ GIMT_Encode4(691813), // Rule ID 11009 //
     /*  691743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  691754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  691757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  691760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  691763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691789 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  691792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691811 */     GIR_RootConstrainSelectedInstOperands,
     /*  691812 */     // GIR_Coverage, 11009,
     /*  691812 */     GIR_EraseRootFromParent_Done,
     /*  691813 */   // Label 10976: @691813
     /*  691813 */   GIM_Try, /*On fail goto*//*Label 10977*/ GIMT_Encode4(691888), // Rule ID 11012 //
     /*  691818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  691829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  691832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  691835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  691838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691864 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  691864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  691867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691886 */     GIR_RootConstrainSelectedInstOperands,
     /*  691887 */     // GIR_Coverage, 11012,
     /*  691887 */     GIR_EraseRootFromParent_Done,
     /*  691888 */   // Label 10977: @691888
     /*  691888 */   GIM_Try, /*On fail goto*//*Label 10978*/ GIMT_Encode4(691963), // Rule ID 11013 //
     /*  691893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  691904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  691907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  691910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  691913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691939 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  691942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691961 */     GIR_RootConstrainSelectedInstOperands,
     /*  691962 */     // GIR_Coverage, 11013,
     /*  691962 */     GIR_EraseRootFromParent_Done,
     /*  691963 */   // Label 10978: @691963
     /*  691963 */   GIM_Try, /*On fail goto*//*Label 10979*/ GIMT_Encode4(692038), // Rule ID 11016 //
     /*  691968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  691979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  691982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  691985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  691988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692036 */     GIR_RootConstrainSelectedInstOperands,
     /*  692037 */     // GIR_Coverage, 11016,
     /*  692037 */     GIR_EraseRootFromParent_Done,
     /*  692038 */   // Label 10979: @692038
     /*  692038 */   GIM_Try, /*On fail goto*//*Label 10980*/ GIMT_Encode4(692113), // Rule ID 11017 //
     /*  692043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  692054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  692057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  692060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  692063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692111 */     GIR_RootConstrainSelectedInstOperands,
     /*  692112 */     // GIR_Coverage, 11017,
     /*  692112 */     GIR_EraseRootFromParent_Done,
     /*  692113 */   // Label 10980: @692113
     /*  692113 */   GIM_Try, /*On fail goto*//*Label 10981*/ GIMT_Encode4(692188), // Rule ID 11020 //
     /*  692118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  692138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692164 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692186 */     GIR_RootConstrainSelectedInstOperands,
     /*  692187 */     // GIR_Coverage, 11020,
     /*  692187 */     GIR_EraseRootFromParent_Done,
     /*  692188 */   // Label 10981: @692188
     /*  692188 */   GIM_Try, /*On fail goto*//*Label 10982*/ GIMT_Encode4(692263), // Rule ID 11021 //
     /*  692193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  692213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692239 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692261 */     GIR_RootConstrainSelectedInstOperands,
     /*  692262 */     // GIR_Coverage, 11021,
     /*  692262 */     GIR_EraseRootFromParent_Done,
     /*  692263 */   // Label 10982: @692263
     /*  692263 */   GIM_Try, /*On fail goto*//*Label 10983*/ GIMT_Encode4(692338), // Rule ID 11024 //
     /*  692268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  692288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692314 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692336 */     GIR_RootConstrainSelectedInstOperands,
     /*  692337 */     // GIR_Coverage, 11024,
     /*  692337 */     GIR_EraseRootFromParent_Done,
     /*  692338 */   // Label 10983: @692338
     /*  692338 */   GIM_Try, /*On fail goto*//*Label 10984*/ GIMT_Encode4(692413), // Rule ID 11025 //
     /*  692343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  692363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692389 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692411 */     GIR_RootConstrainSelectedInstOperands,
     /*  692412 */     // GIR_Coverage, 11025,
     /*  692412 */     GIR_EraseRootFromParent_Done,
     /*  692413 */   // Label 10984: @692413
     /*  692413 */   GIM_Try, /*On fail goto*//*Label 10985*/ GIMT_Encode4(692488), // Rule ID 11028 //
     /*  692418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  692429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  692432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  692435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  692438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  692464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692486 */     GIR_RootConstrainSelectedInstOperands,
     /*  692487 */     // GIR_Coverage, 11028,
     /*  692487 */     GIR_EraseRootFromParent_Done,
     /*  692488 */   // Label 10985: @692488
     /*  692488 */   GIM_Try, /*On fail goto*//*Label 10986*/ GIMT_Encode4(692563), // Rule ID 11029 //
     /*  692493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  692504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  692507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  692510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  692513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692539 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  692539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692561 */     GIR_RootConstrainSelectedInstOperands,
     /*  692562 */     // GIR_Coverage, 11029,
     /*  692562 */     GIR_EraseRootFromParent_Done,
     /*  692563 */   // Label 10986: @692563
     /*  692563 */   GIM_Try, /*On fail goto*//*Label 10987*/ GIMT_Encode4(692638), // Rule ID 11032 //
     /*  692568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  692579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  692582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  692585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  692588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692614 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  692614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692636 */     GIR_RootConstrainSelectedInstOperands,
     /*  692637 */     // GIR_Coverage, 11032,
     /*  692637 */     GIR_EraseRootFromParent_Done,
     /*  692638 */   // Label 10987: @692638
     /*  692638 */   GIM_Try, /*On fail goto*//*Label 10988*/ GIMT_Encode4(692713), // Rule ID 11033 //
     /*  692643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  692654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  692657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  692660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  692663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692689 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  692689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692711 */     GIR_RootConstrainSelectedInstOperands,
     /*  692712 */     // GIR_Coverage, 11033,
     /*  692712 */     GIR_EraseRootFromParent_Done,
     /*  692713 */   // Label 10988: @692713
     /*  692713 */   GIM_Try, /*On fail goto*//*Label 10989*/ GIMT_Encode4(692788), // Rule ID 11036 //
     /*  692718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  692729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  692732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  692735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  692738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692764 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  692764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692786 */     GIR_RootConstrainSelectedInstOperands,
     /*  692787 */     // GIR_Coverage, 11036,
     /*  692787 */     GIR_EraseRootFromParent_Done,
     /*  692788 */   // Label 10989: @692788
     /*  692788 */   GIM_Try, /*On fail goto*//*Label 10990*/ GIMT_Encode4(692863), // Rule ID 11037 //
     /*  692793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  692804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  692807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  692810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  692813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692839 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  692839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692861 */     GIR_RootConstrainSelectedInstOperands,
     /*  692862 */     // GIR_Coverage, 11037,
     /*  692862 */     GIR_EraseRootFromParent_Done,
     /*  692863 */   // Label 10990: @692863
     /*  692863 */   GIM_Try, /*On fail goto*//*Label 10991*/ GIMT_Encode4(692938), // Rule ID 11040 //
     /*  692868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  692871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  692879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  692882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  692885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  692888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  692914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  692933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692936 */     GIR_RootConstrainSelectedInstOperands,
     /*  692937 */     // GIR_Coverage, 11040,
     /*  692937 */     GIR_EraseRootFromParent_Done,
     /*  692938 */   // Label 10991: @692938
     /*  692938 */   GIM_Try, /*On fail goto*//*Label 10992*/ GIMT_Encode4(693013), // Rule ID 11041 //
     /*  692943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  692946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  692954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  692957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  692960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  692963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692989 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  692989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693011 */     GIR_RootConstrainSelectedInstOperands,
     /*  693012 */     // GIR_Coverage, 11041,
     /*  693012 */     GIR_EraseRootFromParent_Done,
     /*  693013 */   // Label 10992: @693013
     /*  693013 */   GIM_Try, /*On fail goto*//*Label 10993*/ GIMT_Encode4(693088), // Rule ID 11044 //
     /*  693018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  693038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  693067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693086 */     GIR_RootConstrainSelectedInstOperands,
     /*  693087 */     // GIR_Coverage, 11044,
     /*  693087 */     GIR_EraseRootFromParent_Done,
     /*  693088 */   // Label 10993: @693088
     /*  693088 */   GIM_Try, /*On fail goto*//*Label 10994*/ GIMT_Encode4(693163), // Rule ID 11045 //
     /*  693093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  693113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693139 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  693142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693161 */     GIR_RootConstrainSelectedInstOperands,
     /*  693162 */     // GIR_Coverage, 11045,
     /*  693162 */     GIR_EraseRootFromParent_Done,
     /*  693163 */   // Label 10994: @693163
     /*  693163 */   GIM_Try, /*On fail goto*//*Label 10995*/ GIMT_Encode4(693238), // Rule ID 11048 //
     /*  693168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  693188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  693217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693236 */     GIR_RootConstrainSelectedInstOperands,
     /*  693237 */     // GIR_Coverage, 11048,
     /*  693237 */     GIR_EraseRootFromParent_Done,
     /*  693238 */   // Label 10995: @693238
     /*  693238 */   GIM_Try, /*On fail goto*//*Label 10996*/ GIMT_Encode4(693313), // Rule ID 11049 //
     /*  693243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  693263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693289 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  693292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693311 */     GIR_RootConstrainSelectedInstOperands,
     /*  693312 */     // GIR_Coverage, 11049,
     /*  693312 */     GIR_EraseRootFromParent_Done,
     /*  693313 */   // Label 10996: @693313
     /*  693313 */   GIM_Try, /*On fail goto*//*Label 10997*/ GIMT_Encode4(693388), // Rule ID 11052 //
     /*  693318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  693329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  693332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  693335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693364 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  693367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693386 */     GIR_RootConstrainSelectedInstOperands,
     /*  693387 */     // GIR_Coverage, 11052,
     /*  693387 */     GIR_EraseRootFromParent_Done,
     /*  693388 */   // Label 10997: @693388
     /*  693388 */   GIM_Try, /*On fail goto*//*Label 10998*/ GIMT_Encode4(693463), // Rule ID 11053 //
     /*  693393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  693404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  693407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  693410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693439 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  693439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  693442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693461 */     GIR_RootConstrainSelectedInstOperands,
     /*  693462 */     // GIR_Coverage, 11053,
     /*  693462 */     GIR_EraseRootFromParent_Done,
     /*  693463 */   // Label 10998: @693463
     /*  693463 */   GIM_Try, /*On fail goto*//*Label 10999*/ GIMT_Encode4(693538), // Rule ID 11056 //
     /*  693468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  693479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  693482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  693485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693514 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  693517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693536 */     GIR_RootConstrainSelectedInstOperands,
     /*  693537 */     // GIR_Coverage, 11056,
     /*  693537 */     GIR_EraseRootFromParent_Done,
     /*  693538 */   // Label 10999: @693538
     /*  693538 */   GIM_Try, /*On fail goto*//*Label 11000*/ GIMT_Encode4(693613), // Rule ID 11057 //
     /*  693543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  693554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  693557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  693560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693589 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  693589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  693592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693611 */     GIR_RootConstrainSelectedInstOperands,
     /*  693612 */     // GIR_Coverage, 11057,
     /*  693612 */     GIR_EraseRootFromParent_Done,
     /*  693613 */   // Label 11000: @693613
     /*  693613 */   GIM_Try, /*On fail goto*//*Label 11001*/ GIMT_Encode4(693688), // Rule ID 11060 //
     /*  693618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  693629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  693632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  693635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693664 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  693667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693686 */     GIR_RootConstrainSelectedInstOperands,
     /*  693687 */     // GIR_Coverage, 11060,
     /*  693687 */     GIR_EraseRootFromParent_Done,
     /*  693688 */   // Label 11001: @693688
     /*  693688 */   GIM_Try, /*On fail goto*//*Label 11002*/ GIMT_Encode4(693763), // Rule ID 11061 //
     /*  693693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  693704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  693707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  693710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693739 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  693739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  693742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693761 */     GIR_RootConstrainSelectedInstOperands,
     /*  693762 */     // GIR_Coverage, 11061,
     /*  693762 */     GIR_EraseRootFromParent_Done,
     /*  693763 */   // Label 11002: @693763
     /*  693763 */   GIM_Try, /*On fail goto*//*Label 11003*/ GIMT_Encode4(693838), // Rule ID 11064 //
     /*  693768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  693779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  693782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  693785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693814 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  693814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  693817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  693833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693836 */     GIR_RootConstrainSelectedInstOperands,
     /*  693837 */     // GIR_Coverage, 11064,
     /*  693837 */     GIR_EraseRootFromParent_Done,
     /*  693838 */   // Label 11003: @693838
     /*  693838 */   GIM_Try, /*On fail goto*//*Label 11004*/ GIMT_Encode4(693913), // Rule ID 11065 //
     /*  693843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  693854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  693857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  693860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693889 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  693889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  693892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  693908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693911 */     GIR_RootConstrainSelectedInstOperands,
     /*  693912 */     // GIR_Coverage, 11065,
     /*  693912 */     GIR_EraseRootFromParent_Done,
     /*  693913 */   // Label 11004: @693913
     /*  693913 */   GIM_Try, /*On fail goto*//*Label 11005*/ GIMT_Encode4(693988), // Rule ID 11068 //
     /*  693918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  693929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  693932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  693935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  693964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  693967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  693983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693986 */     GIR_RootConstrainSelectedInstOperands,
     /*  693987 */     // GIR_Coverage, 11068,
     /*  693987 */     GIR_EraseRootFromParent_Done,
     /*  693988 */   // Label 11005: @693988
     /*  693988 */   GIM_Try, /*On fail goto*//*Label 11006*/ GIMT_Encode4(694063), // Rule ID 11069 //
     /*  693993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  694004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  694007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  694010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694039 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694061 */     GIR_RootConstrainSelectedInstOperands,
     /*  694062 */     // GIR_Coverage, 11069,
     /*  694062 */     GIR_EraseRootFromParent_Done,
     /*  694063 */   // Label 11006: @694063
     /*  694063 */   GIM_Try, /*On fail goto*//*Label 11007*/ GIMT_Encode4(694138), // Rule ID 11072 //
     /*  694068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694114 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  694114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694136 */     GIR_RootConstrainSelectedInstOperands,
     /*  694137 */     // GIR_Coverage, 11072,
     /*  694137 */     GIR_EraseRootFromParent_Done,
     /*  694138 */   // Label 11007: @694138
     /*  694138 */   GIM_Try, /*On fail goto*//*Label 11008*/ GIMT_Encode4(694213), // Rule ID 11073 //
     /*  694143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694189 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  694189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694211 */     GIR_RootConstrainSelectedInstOperands,
     /*  694212 */     // GIR_Coverage, 11073,
     /*  694212 */     GIR_EraseRootFromParent_Done,
     /*  694213 */   // Label 11008: @694213
     /*  694213 */   GIM_Try, /*On fail goto*//*Label 11009*/ GIMT_Encode4(694288), // Rule ID 11076 //
     /*  694218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  694229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  694232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  694235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694264 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694286 */     GIR_RootConstrainSelectedInstOperands,
     /*  694287 */     // GIR_Coverage, 11076,
     /*  694287 */     GIR_EraseRootFromParent_Done,
     /*  694288 */   // Label 11009: @694288
     /*  694288 */   GIM_Try, /*On fail goto*//*Label 11010*/ GIMT_Encode4(694363), // Rule ID 11077 //
     /*  694293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  694304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  694307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  694310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694339 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694361 */     GIR_RootConstrainSelectedInstOperands,
     /*  694362 */     // GIR_Coverage, 11077,
     /*  694362 */     GIR_EraseRootFromParent_Done,
     /*  694363 */   // Label 11010: @694363
     /*  694363 */   GIM_Try, /*On fail goto*//*Label 11011*/ GIMT_Encode4(694438), // Rule ID 11080 //
     /*  694368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694414 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694436 */     GIR_RootConstrainSelectedInstOperands,
     /*  694437 */     // GIR_Coverage, 11080,
     /*  694437 */     GIR_EraseRootFromParent_Done,
     /*  694438 */   // Label 11011: @694438
     /*  694438 */   GIM_Try, /*On fail goto*//*Label 11012*/ GIMT_Encode4(694513), // Rule ID 11081 //
     /*  694443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694489 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694511 */     GIR_RootConstrainSelectedInstOperands,
     /*  694512 */     // GIR_Coverage, 11081,
     /*  694512 */     GIR_EraseRootFromParent_Done,
     /*  694513 */   // Label 11012: @694513
     /*  694513 */   GIM_Try, /*On fail goto*//*Label 11013*/ GIMT_Encode4(694588), // Rule ID 11084 //
     /*  694518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  694529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  694532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  694535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  694564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694586 */     GIR_RootConstrainSelectedInstOperands,
     /*  694587 */     // GIR_Coverage, 11084,
     /*  694587 */     GIR_EraseRootFromParent_Done,
     /*  694588 */   // Label 11013: @694588
     /*  694588 */   GIM_Try, /*On fail goto*//*Label 11014*/ GIMT_Encode4(694663), // Rule ID 11085 //
     /*  694593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  694604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  694607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  694610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694639 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  694639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694661 */     GIR_RootConstrainSelectedInstOperands,
     /*  694662 */     // GIR_Coverage, 11085,
     /*  694662 */     GIR_EraseRootFromParent_Done,
     /*  694663 */   // Label 11014: @694663
     /*  694663 */   GIM_Try, /*On fail goto*//*Label 11015*/ GIMT_Encode4(694738), // Rule ID 11088 //
     /*  694668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  694671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  694679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  694682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  694685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694714 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  694714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  694733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694736 */     GIR_RootConstrainSelectedInstOperands,
     /*  694737 */     // GIR_Coverage, 11088,
     /*  694737 */     GIR_EraseRootFromParent_Done,
     /*  694738 */   // Label 11015: @694738
     /*  694738 */   GIM_Try, /*On fail goto*//*Label 11016*/ GIMT_Encode4(694813), // Rule ID 11089 //
     /*  694743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  694746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  694754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  694757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  694760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694789 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  694789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  694808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694811 */     GIR_RootConstrainSelectedInstOperands,
     /*  694812 */     // GIR_Coverage, 11089,
     /*  694812 */     GIR_EraseRootFromParent_Done,
     /*  694813 */   // Label 11016: @694813
     /*  694813 */   GIM_Try, /*On fail goto*//*Label 11017*/ GIMT_Encode4(694888), // Rule ID 11092 //
     /*  694818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  694829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  694832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  694835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  694867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694886 */     GIR_RootConstrainSelectedInstOperands,
     /*  694887 */     // GIR_Coverage, 11092,
     /*  694887 */     GIR_EraseRootFromParent_Done,
     /*  694888 */   // Label 11017: @694888
     /*  694888 */   GIM_Try, /*On fail goto*//*Label 11018*/ GIMT_Encode4(694963), // Rule ID 11093 //
     /*  694893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  694904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  694907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  694910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694939 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  694942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694961 */     GIR_RootConstrainSelectedInstOperands,
     /*  694962 */     // GIR_Coverage, 11093,
     /*  694962 */     GIR_EraseRootFromParent_Done,
     /*  694963 */   // Label 11018: @694963
     /*  694963 */   GIM_Try, /*On fail goto*//*Label 11019*/ GIMT_Encode4(695038), // Rule ID 11096 //
     /*  694968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  694979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  694982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  694985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695014 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695036 */     GIR_RootConstrainSelectedInstOperands,
     /*  695037 */     // GIR_Coverage, 11096,
     /*  695037 */     GIR_EraseRootFromParent_Done,
     /*  695038 */   // Label 11019: @695038
     /*  695038 */   GIM_Try, /*On fail goto*//*Label 11020*/ GIMT_Encode4(695113), // Rule ID 11097 //
     /*  695043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  695054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  695057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  695060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695089 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695111 */     GIR_RootConstrainSelectedInstOperands,
     /*  695112 */     // GIR_Coverage, 11097,
     /*  695112 */     GIR_EraseRootFromParent_Done,
     /*  695113 */   // Label 11020: @695113
     /*  695113 */   GIM_Try, /*On fail goto*//*Label 11021*/ GIMT_Encode4(695188), // Rule ID 11100 //
     /*  695118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  695129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  695132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  695135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695164 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695186 */     GIR_RootConstrainSelectedInstOperands,
     /*  695187 */     // GIR_Coverage, 11100,
     /*  695187 */     GIR_EraseRootFromParent_Done,
     /*  695188 */   // Label 11021: @695188
     /*  695188 */   GIM_Try, /*On fail goto*//*Label 11022*/ GIMT_Encode4(695263), // Rule ID 11101 //
     /*  695193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  695204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  695207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  695210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695239 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695261 */     GIR_RootConstrainSelectedInstOperands,
     /*  695262 */     // GIR_Coverage, 11101,
     /*  695262 */     GIR_EraseRootFromParent_Done,
     /*  695263 */   // Label 11022: @695263
     /*  695263 */   GIM_Try, /*On fail goto*//*Label 11023*/ GIMT_Encode4(695338), // Rule ID 11104 //
     /*  695268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  695279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  695282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  695285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695336 */     GIR_RootConstrainSelectedInstOperands,
     /*  695337 */     // GIR_Coverage, 11104,
     /*  695337 */     GIR_EraseRootFromParent_Done,
     /*  695338 */   // Label 11023: @695338
     /*  695338 */   GIM_Try, /*On fail goto*//*Label 11024*/ GIMT_Encode4(695413), // Rule ID 11105 //
     /*  695343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  695354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  695357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  695360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695389 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695411 */     GIR_RootConstrainSelectedInstOperands,
     /*  695412 */     // GIR_Coverage, 11105,
     /*  695412 */     GIR_EraseRootFromParent_Done,
     /*  695413 */   // Label 11024: @695413
     /*  695413 */   GIM_Try, /*On fail goto*//*Label 11025*/ GIMT_Encode4(695488), // Rule ID 11108 //
     /*  695418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  695429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  695432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  695435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695464 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695486 */     GIR_RootConstrainSelectedInstOperands,
     /*  695487 */     // GIR_Coverage, 11108,
     /*  695487 */     GIR_EraseRootFromParent_Done,
     /*  695488 */   // Label 11025: @695488
     /*  695488 */   GIM_Try, /*On fail goto*//*Label 11026*/ GIMT_Encode4(695563), // Rule ID 11109 //
     /*  695493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  695504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  695507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  695510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695539 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695561 */     GIR_RootConstrainSelectedInstOperands,
     /*  695562 */     // GIR_Coverage, 11109,
     /*  695562 */     GIR_EraseRootFromParent_Done,
     /*  695563 */   // Label 11026: @695563
     /*  695563 */   GIM_Try, /*On fail goto*//*Label 11027*/ GIMT_Encode4(695638), // Rule ID 11112 //
     /*  695568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  695579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  695582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  695585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695636 */     GIR_RootConstrainSelectedInstOperands,
     /*  695637 */     // GIR_Coverage, 11112,
     /*  695637 */     GIR_EraseRootFromParent_Done,
     /*  695638 */   // Label 11027: @695638
     /*  695638 */   GIM_Try, /*On fail goto*//*Label 11028*/ GIMT_Encode4(695713), // Rule ID 11113 //
     /*  695643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  695654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  695657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  695660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695689 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695711 */     GIR_RootConstrainSelectedInstOperands,
     /*  695712 */     // GIR_Coverage, 11113,
     /*  695712 */     GIR_EraseRootFromParent_Done,
     /*  695713 */   // Label 11028: @695713
     /*  695713 */   GIM_Try, /*On fail goto*//*Label 11029*/ GIMT_Encode4(695788), // Rule ID 11116 //
     /*  695718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  695729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  695732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  695735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695786 */     GIR_RootConstrainSelectedInstOperands,
     /*  695787 */     // GIR_Coverage, 11116,
     /*  695787 */     GIR_EraseRootFromParent_Done,
     /*  695788 */   // Label 11029: @695788
     /*  695788 */   GIM_Try, /*On fail goto*//*Label 11030*/ GIMT_Encode4(695863), // Rule ID 11117 //
     /*  695793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  695804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  695807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  695810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695861 */     GIR_RootConstrainSelectedInstOperands,
     /*  695862 */     // GIR_Coverage, 11117,
     /*  695862 */     GIR_EraseRootFromParent_Done,
     /*  695863 */   // Label 11030: @695863
     /*  695863 */   GIM_Try, /*On fail goto*//*Label 11031*/ GIMT_Encode4(695938), // Rule ID 11120 //
     /*  695868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  695879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  695882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  695885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695936 */     GIR_RootConstrainSelectedInstOperands,
     /*  695937 */     // GIR_Coverage, 11120,
     /*  695937 */     GIR_EraseRootFromParent_Done,
     /*  695938 */   // Label 11031: @695938
     /*  695938 */   GIM_Try, /*On fail goto*//*Label 11032*/ GIMT_Encode4(696013), // Rule ID 11121 //
     /*  695943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  695954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  695957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  695960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695989 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696011 */     GIR_RootConstrainSelectedInstOperands,
     /*  696012 */     // GIR_Coverage, 11121,
     /*  696012 */     GIR_EraseRootFromParent_Done,
     /*  696013 */   // Label 11032: @696013
     /*  696013 */   GIM_Try, /*On fail goto*//*Label 11033*/ GIMT_Encode4(696088), // Rule ID 11124 //
     /*  696018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  696029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  696032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  696035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696064 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696086 */     GIR_RootConstrainSelectedInstOperands,
     /*  696087 */     // GIR_Coverage, 11124,
     /*  696087 */     GIR_EraseRootFromParent_Done,
     /*  696088 */   // Label 11033: @696088
     /*  696088 */   GIM_Try, /*On fail goto*//*Label 11034*/ GIMT_Encode4(696163), // Rule ID 11125 //
     /*  696093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  696104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  696107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  696110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696139 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696161 */     GIR_RootConstrainSelectedInstOperands,
     /*  696162 */     // GIR_Coverage, 11125,
     /*  696162 */     GIR_EraseRootFromParent_Done,
     /*  696163 */   // Label 11034: @696163
     /*  696163 */   GIM_Try, /*On fail goto*//*Label 11035*/ GIMT_Encode4(696238), // Rule ID 11128 //
     /*  696168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  696179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  696182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  696185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  696217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696236 */     GIR_RootConstrainSelectedInstOperands,
     /*  696237 */     // GIR_Coverage, 11128,
     /*  696237 */     GIR_EraseRootFromParent_Done,
     /*  696238 */   // Label 11035: @696238
     /*  696238 */   GIM_Try, /*On fail goto*//*Label 11036*/ GIMT_Encode4(696313), // Rule ID 11129 //
     /*  696243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  696254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  696257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  696260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  696292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696311 */     GIR_RootConstrainSelectedInstOperands,
     /*  696312 */     // GIR_Coverage, 11129,
     /*  696312 */     GIR_EraseRootFromParent_Done,
     /*  696313 */   // Label 11036: @696313
     /*  696313 */   GIM_Try, /*On fail goto*//*Label 11037*/ GIMT_Encode4(696388), // Rule ID 11132 //
     /*  696318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  696329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  696332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  696335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  696367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696386 */     GIR_RootConstrainSelectedInstOperands,
     /*  696387 */     // GIR_Coverage, 11132,
     /*  696387 */     GIR_EraseRootFromParent_Done,
     /*  696388 */   // Label 11037: @696388
     /*  696388 */   GIM_Try, /*On fail goto*//*Label 11038*/ GIMT_Encode4(696463), // Rule ID 11133 //
     /*  696393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  696404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  696407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  696410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696439 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  696442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696461 */     GIR_RootConstrainSelectedInstOperands,
     /*  696462 */     // GIR_Coverage, 11133,
     /*  696462 */     GIR_EraseRootFromParent_Done,
     /*  696463 */   // Label 11038: @696463
     /*  696463 */   GIM_Try, /*On fail goto*//*Label 11039*/ GIMT_Encode4(696538), // Rule ID 11136 //
     /*  696468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  696479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  696482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  696485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696514 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696536 */     GIR_RootConstrainSelectedInstOperands,
     /*  696537 */     // GIR_Coverage, 11136,
     /*  696537 */     GIR_EraseRootFromParent_Done,
     /*  696538 */   // Label 11039: @696538
     /*  696538 */   GIM_Try, /*On fail goto*//*Label 11040*/ GIMT_Encode4(696613), // Rule ID 11137 //
     /*  696543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  696554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  696557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  696560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696589 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696611 */     GIR_RootConstrainSelectedInstOperands,
     /*  696612 */     // GIR_Coverage, 11137,
     /*  696612 */     GIR_EraseRootFromParent_Done,
     /*  696613 */   // Label 11040: @696613
     /*  696613 */   GIM_Try, /*On fail goto*//*Label 11041*/ GIMT_Encode4(696688), // Rule ID 11140 //
     /*  696618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  696629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  696632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  696635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  696638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696664 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  696664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  696667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696686 */     GIR_RootConstrainSelectedInstOperands,
     /*  696687 */     // GIR_Coverage, 11140,
     /*  696687 */     GIR_EraseRootFromParent_Done,
     /*  696688 */   // Label 11041: @696688
     /*  696688 */   GIM_Try, /*On fail goto*//*Label 11042*/ GIMT_Encode4(696763), // Rule ID 11141 //
     /*  696693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  696704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  696707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  696710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  696713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696739 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  696739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  696742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696761 */     GIR_RootConstrainSelectedInstOperands,
     /*  696762 */     // GIR_Coverage, 11141,
     /*  696762 */     GIR_EraseRootFromParent_Done,
     /*  696763 */   // Label 11042: @696763
     /*  696763 */   GIM_Try, /*On fail goto*//*Label 11043*/ GIMT_Encode4(696838), // Rule ID 11144 //
     /*  696768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  696779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  696782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  696785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  696788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696814 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  696814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  696817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696836 */     GIR_RootConstrainSelectedInstOperands,
     /*  696837 */     // GIR_Coverage, 11144,
     /*  696837 */     GIR_EraseRootFromParent_Done,
     /*  696838 */   // Label 11043: @696838
     /*  696838 */   GIM_Try, /*On fail goto*//*Label 11044*/ GIMT_Encode4(696913), // Rule ID 11145 //
     /*  696843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  696854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  696857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  696860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  696863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696889 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  696889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  696892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696911 */     GIR_RootConstrainSelectedInstOperands,
     /*  696912 */     // GIR_Coverage, 11145,
     /*  696912 */     GIR_EraseRootFromParent_Done,
     /*  696913 */   // Label 11044: @696913
     /*  696913 */   GIM_Try, /*On fail goto*//*Label 11045*/ GIMT_Encode4(696988), // Rule ID 11148 //
     /*  696918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  696929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  696932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  696935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  696938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696964 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  696964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  696967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696986 */     GIR_RootConstrainSelectedInstOperands,
     /*  696987 */     // GIR_Coverage, 11148,
     /*  696987 */     GIR_EraseRootFromParent_Done,
     /*  696988 */   // Label 11045: @696988
     /*  696988 */   GIM_Try, /*On fail goto*//*Label 11046*/ GIMT_Encode4(697063), // Rule ID 11149 //
     /*  696993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  697004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  697007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  697010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  697013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697039 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697061 */     GIR_RootConstrainSelectedInstOperands,
     /*  697062 */     // GIR_Coverage, 11149,
     /*  697062 */     GIR_EraseRootFromParent_Done,
     /*  697063 */   // Label 11046: @697063
     /*  697063 */   GIM_Try, /*On fail goto*//*Label 11047*/ GIMT_Encode4(697138), // Rule ID 11152 //
     /*  697068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  697079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  697082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  697085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  697088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  697117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697136 */     GIR_RootConstrainSelectedInstOperands,
     /*  697137 */     // GIR_Coverage, 11152,
     /*  697137 */     GIR_EraseRootFromParent_Done,
     /*  697138 */   // Label 11047: @697138
     /*  697138 */   GIM_Try, /*On fail goto*//*Label 11048*/ GIMT_Encode4(697213), // Rule ID 11153 //
     /*  697143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  697154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  697157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  697160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  697163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697189 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  697192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697211 */     GIR_RootConstrainSelectedInstOperands,
     /*  697212 */     // GIR_Coverage, 11153,
     /*  697212 */     GIR_EraseRootFromParent_Done,
     /*  697213 */   // Label 11048: @697213
     /*  697213 */   GIM_Try, /*On fail goto*//*Label 11049*/ GIMT_Encode4(697288), // Rule ID 11156 //
     /*  697218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  697229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  697232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  697235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  697238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697286 */     GIR_RootConstrainSelectedInstOperands,
     /*  697287 */     // GIR_Coverage, 11156,
     /*  697287 */     GIR_EraseRootFromParent_Done,
     /*  697288 */   // Label 11049: @697288
     /*  697288 */   GIM_Try, /*On fail goto*//*Label 11050*/ GIMT_Encode4(697363), // Rule ID 11157 //
     /*  697293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  697304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  697307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  697310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  697313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697339 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697361 */     GIR_RootConstrainSelectedInstOperands,
     /*  697362 */     // GIR_Coverage, 11157,
     /*  697362 */     GIR_EraseRootFromParent_Done,
     /*  697363 */   // Label 11050: @697363
     /*  697363 */   GIM_Try, /*On fail goto*//*Label 11051*/ GIMT_Encode4(697438), // Rule ID 11160 //
     /*  697368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  697379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  697382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  697385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  697388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697414 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  697414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697436 */     GIR_RootConstrainSelectedInstOperands,
     /*  697437 */     // GIR_Coverage, 11160,
     /*  697437 */     GIR_EraseRootFromParent_Done,
     /*  697438 */   // Label 11051: @697438
     /*  697438 */   GIM_Try, /*On fail goto*//*Label 11052*/ GIMT_Encode4(697513), // Rule ID 11161 //
     /*  697443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  697454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  697457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  697460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  697463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697489 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  697489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697511 */     GIR_RootConstrainSelectedInstOperands,
     /*  697512 */     // GIR_Coverage, 11161,
     /*  697512 */     GIR_EraseRootFromParent_Done,
     /*  697513 */   // Label 11052: @697513
     /*  697513 */   GIM_Try, /*On fail goto*//*Label 11053*/ GIMT_Encode4(697588), // Rule ID 11164 //
     /*  697518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  697529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  697532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  697535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  697538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697564 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697586 */     GIR_RootConstrainSelectedInstOperands,
     /*  697587 */     // GIR_Coverage, 11164,
     /*  697587 */     GIR_EraseRootFromParent_Done,
     /*  697588 */   // Label 11053: @697588
     /*  697588 */   GIM_Try, /*On fail goto*//*Label 11054*/ GIMT_Encode4(697663), // Rule ID 11165 //
     /*  697593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  697604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  697607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  697610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  697613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697639 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697661 */     GIR_RootConstrainSelectedInstOperands,
     /*  697662 */     // GIR_Coverage, 11165,
     /*  697662 */     GIR_EraseRootFromParent_Done,
     /*  697663 */   // Label 11054: @697663
     /*  697663 */   GIM_Try, /*On fail goto*//*Label 11055*/ GIMT_Encode4(697738), // Rule ID 11168 //
     /*  697668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  697679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  697682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  697685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  697688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697736 */     GIR_RootConstrainSelectedInstOperands,
     /*  697737 */     // GIR_Coverage, 11168,
     /*  697737 */     GIR_EraseRootFromParent_Done,
     /*  697738 */   // Label 11055: @697738
     /*  697738 */   GIM_Try, /*On fail goto*//*Label 11056*/ GIMT_Encode4(697813), // Rule ID 11169 //
     /*  697743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  697754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  697757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  697760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  697763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697789 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697811 */     GIR_RootConstrainSelectedInstOperands,
     /*  697812 */     // GIR_Coverage, 11169,
     /*  697812 */     GIR_EraseRootFromParent_Done,
     /*  697813 */   // Label 11056: @697813
     /*  697813 */   GIM_Try, /*On fail goto*//*Label 11057*/ GIMT_Encode4(697888), // Rule ID 11172 //
     /*  697818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  697829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  697832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  697835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  697838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697864 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  697864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697886 */     GIR_RootConstrainSelectedInstOperands,
     /*  697887 */     // GIR_Coverage, 11172,
     /*  697887 */     GIR_EraseRootFromParent_Done,
     /*  697888 */   // Label 11057: @697888
     /*  697888 */   GIM_Try, /*On fail goto*//*Label 11058*/ GIMT_Encode4(697963), // Rule ID 11173 //
     /*  697893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  697904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  697907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  697910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  697913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697939 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  697939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697961 */     GIR_RootConstrainSelectedInstOperands,
     /*  697962 */     // GIR_Coverage, 11173,
     /*  697962 */     GIR_EraseRootFromParent_Done,
     /*  697963 */   // Label 11058: @697963
     /*  697963 */   GIM_Try, /*On fail goto*//*Label 11059*/ GIMT_Encode4(698038), // Rule ID 11176 //
     /*  697968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  697979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  697982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  697985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  697988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698036 */     GIR_RootConstrainSelectedInstOperands,
     /*  698037 */     // GIR_Coverage, 11176,
     /*  698037 */     GIR_EraseRootFromParent_Done,
     /*  698038 */   // Label 11059: @698038
     /*  698038 */   GIM_Try, /*On fail goto*//*Label 11060*/ GIMT_Encode4(698113), // Rule ID 11177 //
     /*  698043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  698054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  698057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  698060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  698063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698089 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698111 */     GIR_RootConstrainSelectedInstOperands,
     /*  698112 */     // GIR_Coverage, 11177,
     /*  698112 */     GIR_EraseRootFromParent_Done,
     /*  698113 */   // Label 11060: @698113
     /*  698113 */   GIM_Try, /*On fail goto*//*Label 11061*/ GIMT_Encode4(698188), // Rule ID 11180 //
     /*  698118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  698129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  698132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  698135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  698138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698164 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698186 */     GIR_RootConstrainSelectedInstOperands,
     /*  698187 */     // GIR_Coverage, 11180,
     /*  698187 */     GIR_EraseRootFromParent_Done,
     /*  698188 */   // Label 11061: @698188
     /*  698188 */   GIM_Try, /*On fail goto*//*Label 11062*/ GIMT_Encode4(698263), // Rule ID 11181 //
     /*  698193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  698204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  698207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  698210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  698213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698239 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698261 */     GIR_RootConstrainSelectedInstOperands,
     /*  698262 */     // GIR_Coverage, 11181,
     /*  698262 */     GIR_EraseRootFromParent_Done,
     /*  698263 */   // Label 11062: @698263
     /*  698263 */   GIM_Try, /*On fail goto*//*Label 11063*/ GIMT_Encode4(698338), // Rule ID 11184 //
     /*  698268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  698279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  698282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  698285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  698288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698314 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698336 */     GIR_RootConstrainSelectedInstOperands,
     /*  698337 */     // GIR_Coverage, 11184,
     /*  698337 */     GIR_EraseRootFromParent_Done,
     /*  698338 */   // Label 11063: @698338
     /*  698338 */   GIM_Try, /*On fail goto*//*Label 11064*/ GIMT_Encode4(698413), // Rule ID 11185 //
     /*  698343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  698354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  698357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  698360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  698363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698389 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698411 */     GIR_RootConstrainSelectedInstOperands,
     /*  698412 */     // GIR_Coverage, 11185,
     /*  698412 */     GIR_EraseRootFromParent_Done,
     /*  698413 */   // Label 11064: @698413
     /*  698413 */   GIM_Try, /*On fail goto*//*Label 11065*/ GIMT_Encode4(698488), // Rule ID 11188 //
     /*  698418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  698429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  698432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  698435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  698438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698486 */     GIR_RootConstrainSelectedInstOperands,
     /*  698487 */     // GIR_Coverage, 11188,
     /*  698487 */     GIR_EraseRootFromParent_Done,
     /*  698488 */   // Label 11065: @698488
     /*  698488 */   GIM_Try, /*On fail goto*//*Label 11066*/ GIMT_Encode4(698563), // Rule ID 11189 //
     /*  698493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  698504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  698507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  698510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  698513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698539 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698561 */     GIR_RootConstrainSelectedInstOperands,
     /*  698562 */     // GIR_Coverage, 11189,
     /*  698562 */     GIR_EraseRootFromParent_Done,
     /*  698563 */   // Label 11066: @698563
     /*  698563 */   GIM_Try, /*On fail goto*//*Label 11067*/ GIMT_Encode4(698638), // Rule ID 11192 //
     /*  698568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  698579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  698582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  698585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  698588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698614 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698636 */     GIR_RootConstrainSelectedInstOperands,
     /*  698637 */     // GIR_Coverage, 11192,
     /*  698637 */     GIR_EraseRootFromParent_Done,
     /*  698638 */   // Label 11067: @698638
     /*  698638 */   GIM_Try, /*On fail goto*//*Label 11068*/ GIMT_Encode4(698713), // Rule ID 11193 //
     /*  698643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  698654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  698657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  698660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  698663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698689 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698711 */     GIR_RootConstrainSelectedInstOperands,
     /*  698712 */     // GIR_Coverage, 11193,
     /*  698712 */     GIR_EraseRootFromParent_Done,
     /*  698713 */   // Label 11068: @698713
     /*  698713 */   GIM_Try, /*On fail goto*//*Label 11069*/ GIMT_Encode4(698788), // Rule ID 11196 //
     /*  698718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  698729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  698732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  698735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  698738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698764 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698786 */     GIR_RootConstrainSelectedInstOperands,
     /*  698787 */     // GIR_Coverage, 11196,
     /*  698787 */     GIR_EraseRootFromParent_Done,
     /*  698788 */   // Label 11069: @698788
     /*  698788 */   GIM_Try, /*On fail goto*//*Label 11070*/ GIMT_Encode4(698863), // Rule ID 11197 //
     /*  698793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  698804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  698807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  698810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  698813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698839 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698861 */     GIR_RootConstrainSelectedInstOperands,
     /*  698862 */     // GIR_Coverage, 11197,
     /*  698862 */     GIR_EraseRootFromParent_Done,
     /*  698863 */   // Label 11070: @698863
     /*  698863 */   GIM_Try, /*On fail goto*//*Label 11071*/ GIMT_Encode4(698938), // Rule ID 11200 //
     /*  698868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  698879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  698882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  698885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  698888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698914 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  698914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698936 */     GIR_RootConstrainSelectedInstOperands,
     /*  698937 */     // GIR_Coverage, 11200,
     /*  698937 */     GIR_EraseRootFromParent_Done,
     /*  698938 */   // Label 11071: @698938
     /*  698938 */   GIM_Try, /*On fail goto*//*Label 11072*/ GIMT_Encode4(699013), // Rule ID 11201 //
     /*  698943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  698954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  698957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  698960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  698963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698989 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  698989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699011 */     GIR_RootConstrainSelectedInstOperands,
     /*  699012 */     // GIR_Coverage, 11201,
     /*  699012 */     GIR_EraseRootFromParent_Done,
     /*  699013 */   // Label 11072: @699013
     /*  699013 */   GIM_Try, /*On fail goto*//*Label 11073*/ GIMT_Encode4(699088), // Rule ID 11204 //
     /*  699018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  699038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699064 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  699067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699086 */     GIR_RootConstrainSelectedInstOperands,
     /*  699087 */     // GIR_Coverage, 11204,
     /*  699087 */     GIR_EraseRootFromParent_Done,
     /*  699088 */   // Label 11073: @699088
     /*  699088 */   GIM_Try, /*On fail goto*//*Label 11074*/ GIMT_Encode4(699163), // Rule ID 11205 //
     /*  699093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  699113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699139 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  699142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699161 */     GIR_RootConstrainSelectedInstOperands,
     /*  699162 */     // GIR_Coverage, 11205,
     /*  699162 */     GIR_EraseRootFromParent_Done,
     /*  699163 */   // Label 11074: @699163
     /*  699163 */   GIM_Try, /*On fail goto*//*Label 11075*/ GIMT_Encode4(699238), // Rule ID 11208 //
     /*  699168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  699179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  699182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  699185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  699188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699214 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  699217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699236 */     GIR_RootConstrainSelectedInstOperands,
     /*  699237 */     // GIR_Coverage, 11208,
     /*  699237 */     GIR_EraseRootFromParent_Done,
     /*  699238 */   // Label 11075: @699238
     /*  699238 */   GIM_Try, /*On fail goto*//*Label 11076*/ GIMT_Encode4(699313), // Rule ID 11209 //
     /*  699243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  699254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  699257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  699260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  699263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699289 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  699292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699311 */     GIR_RootConstrainSelectedInstOperands,
     /*  699312 */     // GIR_Coverage, 11209,
     /*  699312 */     GIR_EraseRootFromParent_Done,
     /*  699313 */   // Label 11076: @699313
     /*  699313 */   GIM_Try, /*On fail goto*//*Label 11077*/ GIMT_Encode4(699388), // Rule ID 11212 //
     /*  699318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  699329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  699332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  699335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699364 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  699364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  699367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699386 */     GIR_RootConstrainSelectedInstOperands,
     /*  699387 */     // GIR_Coverage, 11212,
     /*  699387 */     GIR_EraseRootFromParent_Done,
     /*  699388 */   // Label 11077: @699388
     /*  699388 */   GIM_Try, /*On fail goto*//*Label 11078*/ GIMT_Encode4(699463), // Rule ID 11213 //
     /*  699393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  699404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  699407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  699410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699439 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  699439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  699442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699461 */     GIR_RootConstrainSelectedInstOperands,
     /*  699462 */     // GIR_Coverage, 11213,
     /*  699462 */     GIR_EraseRootFromParent_Done,
     /*  699463 */   // Label 11078: @699463
     /*  699463 */   GIM_Try, /*On fail goto*//*Label 11079*/ GIMT_Encode4(699538), // Rule ID 11216 //
     /*  699468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  699479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  699482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  699485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699514 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  699514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  699517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699536 */     GIR_RootConstrainSelectedInstOperands,
     /*  699537 */     // GIR_Coverage, 11216,
     /*  699537 */     GIR_EraseRootFromParent_Done,
     /*  699538 */   // Label 11079: @699538
     /*  699538 */   GIM_Try, /*On fail goto*//*Label 11080*/ GIMT_Encode4(699613), // Rule ID 11217 //
     /*  699543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  699554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  699557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  699560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699589 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  699589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  699592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699611 */     GIR_RootConstrainSelectedInstOperands,
     /*  699612 */     // GIR_Coverage, 11217,
     /*  699612 */     GIR_EraseRootFromParent_Done,
     /*  699613 */   // Label 11080: @699613
     /*  699613 */   GIM_Try, /*On fail goto*//*Label 11081*/ GIMT_Encode4(699688), // Rule ID 11220 //
     /*  699618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  699629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  699632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  699635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699664 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  699664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  699667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699686 */     GIR_RootConstrainSelectedInstOperands,
     /*  699687 */     // GIR_Coverage, 11220,
     /*  699687 */     GIR_EraseRootFromParent_Done,
     /*  699688 */   // Label 11081: @699688
     /*  699688 */   GIM_Try, /*On fail goto*//*Label 11082*/ GIMT_Encode4(699763), // Rule ID 11221 //
     /*  699693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  699704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  699707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  699710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699739 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  699739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  699742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699761 */     GIR_RootConstrainSelectedInstOperands,
     /*  699762 */     // GIR_Coverage, 11221,
     /*  699762 */     GIR_EraseRootFromParent_Done,
     /*  699763 */   // Label 11082: @699763
     /*  699763 */   GIM_Try, /*On fail goto*//*Label 11083*/ GIMT_Encode4(699838), // Rule ID 11224 //
     /*  699768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  699779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  699782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  699785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699814 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  699817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699836 */     GIR_RootConstrainSelectedInstOperands,
     /*  699837 */     // GIR_Coverage, 11224,
     /*  699837 */     GIR_EraseRootFromParent_Done,
     /*  699838 */   // Label 11083: @699838
     /*  699838 */   GIM_Try, /*On fail goto*//*Label 11084*/ GIMT_Encode4(699913), // Rule ID 11225 //
     /*  699843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  699854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  699857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  699860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699889 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  699892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699911 */     GIR_RootConstrainSelectedInstOperands,
     /*  699912 */     // GIR_Coverage, 11225,
     /*  699912 */     GIR_EraseRootFromParent_Done,
     /*  699913 */   // Label 11084: @699913
     /*  699913 */   GIM_Try, /*On fail goto*//*Label 11085*/ GIMT_Encode4(699988), // Rule ID 11228 //
     /*  699918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  699929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  699932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  699935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  699967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699986 */     GIR_RootConstrainSelectedInstOperands,
     /*  699987 */     // GIR_Coverage, 11228,
     /*  699987 */     GIR_EraseRootFromParent_Done,
     /*  699988 */   // Label 11085: @699988
     /*  699988 */   GIM_Try, /*On fail goto*//*Label 11086*/ GIMT_Encode4(700063), // Rule ID 11229 //
     /*  699993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  700004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  700007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  700010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700039 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700061 */     GIR_RootConstrainSelectedInstOperands,
     /*  700062 */     // GIR_Coverage, 11229,
     /*  700062 */     GIR_EraseRootFromParent_Done,
     /*  700063 */   // Label 11086: @700063
     /*  700063 */   GIM_Try, /*On fail goto*//*Label 11087*/ GIMT_Encode4(700138), // Rule ID 11232 //
     /*  700068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  700079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  700082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  700085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700114 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  700114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700136 */     GIR_RootConstrainSelectedInstOperands,
     /*  700137 */     // GIR_Coverage, 11232,
     /*  700137 */     GIR_EraseRootFromParent_Done,
     /*  700138 */   // Label 11087: @700138
     /*  700138 */   GIM_Try, /*On fail goto*//*Label 11088*/ GIMT_Encode4(700213), // Rule ID 11233 //
     /*  700143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  700154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  700157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  700160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700189 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  700189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700211 */     GIR_RootConstrainSelectedInstOperands,
     /*  700212 */     // GIR_Coverage, 11233,
     /*  700212 */     GIR_EraseRootFromParent_Done,
     /*  700213 */   // Label 11088: @700213
     /*  700213 */   GIM_Try, /*On fail goto*//*Label 11089*/ GIMT_Encode4(700288), // Rule ID 11236 //
     /*  700218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  700229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  700232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  700235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700264 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700286 */     GIR_RootConstrainSelectedInstOperands,
     /*  700287 */     // GIR_Coverage, 11236,
     /*  700287 */     GIR_EraseRootFromParent_Done,
     /*  700288 */   // Label 11089: @700288
     /*  700288 */   GIM_Try, /*On fail goto*//*Label 11090*/ GIMT_Encode4(700363), // Rule ID 11237 //
     /*  700293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  700304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  700307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  700310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700339 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700361 */     GIR_RootConstrainSelectedInstOperands,
     /*  700362 */     // GIR_Coverage, 11237,
     /*  700362 */     GIR_EraseRootFromParent_Done,
     /*  700363 */   // Label 11090: @700363
     /*  700363 */   GIM_Try, /*On fail goto*//*Label 11091*/ GIMT_Encode4(700438), // Rule ID 11240 //
     /*  700368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  700379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  700382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  700385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700414 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700436 */     GIR_RootConstrainSelectedInstOperands,
     /*  700437 */     // GIR_Coverage, 11240,
     /*  700437 */     GIR_EraseRootFromParent_Done,
     /*  700438 */   // Label 11091: @700438
     /*  700438 */   GIM_Try, /*On fail goto*//*Label 11092*/ GIMT_Encode4(700513), // Rule ID 11241 //
     /*  700443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  700454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  700457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  700460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700489 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700511 */     GIR_RootConstrainSelectedInstOperands,
     /*  700512 */     // GIR_Coverage, 11241,
     /*  700512 */     GIR_EraseRootFromParent_Done,
     /*  700513 */   // Label 11092: @700513
     /*  700513 */   GIM_Try, /*On fail goto*//*Label 11093*/ GIMT_Encode4(700588), // Rule ID 11244 //
     /*  700518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  700529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  700532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  700535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  700564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700586 */     GIR_RootConstrainSelectedInstOperands,
     /*  700587 */     // GIR_Coverage, 11244,
     /*  700587 */     GIR_EraseRootFromParent_Done,
     /*  700588 */   // Label 11093: @700588
     /*  700588 */   GIM_Try, /*On fail goto*//*Label 11094*/ GIMT_Encode4(700663), // Rule ID 11245 //
     /*  700593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  700604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  700607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  700610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700639 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  700639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700661 */     GIR_RootConstrainSelectedInstOperands,
     /*  700662 */     // GIR_Coverage, 11245,
     /*  700662 */     GIR_EraseRootFromParent_Done,
     /*  700663 */   // Label 11094: @700663
     /*  700663 */   GIM_Try, /*On fail goto*//*Label 11095*/ GIMT_Encode4(700738), // Rule ID 11248 //
     /*  700668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  700679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  700682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  700685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700714 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  700717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700736 */     GIR_RootConstrainSelectedInstOperands,
     /*  700737 */     // GIR_Coverage, 11248,
     /*  700737 */     GIR_EraseRootFromParent_Done,
     /*  700738 */   // Label 11095: @700738
     /*  700738 */   GIM_Try, /*On fail goto*//*Label 11096*/ GIMT_Encode4(700813), // Rule ID 11249 //
     /*  700743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  700754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  700757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  700760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700789 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  700792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700811 */     GIR_RootConstrainSelectedInstOperands,
     /*  700812 */     // GIR_Coverage, 11249,
     /*  700812 */     GIR_EraseRootFromParent_Done,
     /*  700813 */   // Label 11096: @700813
     /*  700813 */   GIM_Try, /*On fail goto*//*Label 11097*/ GIMT_Encode4(700888), // Rule ID 11252 //
     /*  700818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  700829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  700832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  700835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700864 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  700867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700886 */     GIR_RootConstrainSelectedInstOperands,
     /*  700887 */     // GIR_Coverage, 11252,
     /*  700887 */     GIR_EraseRootFromParent_Done,
     /*  700888 */   // Label 11097: @700888
     /*  700888 */   GIM_Try, /*On fail goto*//*Label 11098*/ GIMT_Encode4(700963), // Rule ID 11253 //
     /*  700893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  700904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  700907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  700910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700939 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  700942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700961 */     GIR_RootConstrainSelectedInstOperands,
     /*  700962 */     // GIR_Coverage, 11253,
     /*  700962 */     GIR_EraseRootFromParent_Done,
     /*  700963 */   // Label 11098: @700963
     /*  700963 */   GIM_Try, /*On fail goto*//*Label 11099*/ GIMT_Encode4(701038), // Rule ID 11256 //
     /*  700968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  700979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  700982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  700985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701014 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701036 */     GIR_RootConstrainSelectedInstOperands,
     /*  701037 */     // GIR_Coverage, 11256,
     /*  701037 */     GIR_EraseRootFromParent_Done,
     /*  701038 */   // Label 11099: @701038
     /*  701038 */   GIM_Try, /*On fail goto*//*Label 11100*/ GIMT_Encode4(701113), // Rule ID 11257 //
     /*  701043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  701054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  701057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  701060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701089 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701111 */     GIR_RootConstrainSelectedInstOperands,
     /*  701112 */     // GIR_Coverage, 11257,
     /*  701112 */     GIR_EraseRootFromParent_Done,
     /*  701113 */   // Label 11100: @701113
     /*  701113 */   GIM_Try, /*On fail goto*//*Label 11101*/ GIMT_Encode4(701188), // Rule ID 11260 //
     /*  701118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  701129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  701132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  701135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701164 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701186 */     GIR_RootConstrainSelectedInstOperands,
     /*  701187 */     // GIR_Coverage, 11260,
     /*  701187 */     GIR_EraseRootFromParent_Done,
     /*  701188 */   // Label 11101: @701188
     /*  701188 */   GIM_Try, /*On fail goto*//*Label 11102*/ GIMT_Encode4(701263), // Rule ID 11261 //
     /*  701193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  701204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  701207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  701210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701239 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701261 */     GIR_RootConstrainSelectedInstOperands,
     /*  701262 */     // GIR_Coverage, 11261,
     /*  701262 */     GIR_EraseRootFromParent_Done,
     /*  701263 */   // Label 11102: @701263
     /*  701263 */   GIM_Try, /*On fail goto*//*Label 11103*/ GIMT_Encode4(701338), // Rule ID 11264 //
     /*  701268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  701279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  701282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  701285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701314 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701336 */     GIR_RootConstrainSelectedInstOperands,
     /*  701337 */     // GIR_Coverage, 11264,
     /*  701337 */     GIR_EraseRootFromParent_Done,
     /*  701338 */   // Label 11103: @701338
     /*  701338 */   GIM_Try, /*On fail goto*//*Label 11104*/ GIMT_Encode4(701413), // Rule ID 11265 //
     /*  701343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  701354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  701357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  701360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701389 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701411 */     GIR_RootConstrainSelectedInstOperands,
     /*  701412 */     // GIR_Coverage, 11265,
     /*  701412 */     GIR_EraseRootFromParent_Done,
     /*  701413 */   // Label 11104: @701413
     /*  701413 */   GIM_Try, /*On fail goto*//*Label 11105*/ GIMT_Encode4(701488), // Rule ID 11268 //
     /*  701418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  701429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  701432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  701435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701464 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701486 */     GIR_RootConstrainSelectedInstOperands,
     /*  701487 */     // GIR_Coverage, 11268,
     /*  701487 */     GIR_EraseRootFromParent_Done,
     /*  701488 */   // Label 11105: @701488
     /*  701488 */   GIM_Try, /*On fail goto*//*Label 11106*/ GIMT_Encode4(701563), // Rule ID 11269 //
     /*  701493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  701504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  701507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  701510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701539 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701561 */     GIR_RootConstrainSelectedInstOperands,
     /*  701562 */     // GIR_Coverage, 11269,
     /*  701562 */     GIR_EraseRootFromParent_Done,
     /*  701563 */   // Label 11106: @701563
     /*  701563 */   GIM_Try, /*On fail goto*//*Label 11107*/ GIMT_Encode4(701638), // Rule ID 11272 //
     /*  701568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  701579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  701582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  701585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701636 */     GIR_RootConstrainSelectedInstOperands,
     /*  701637 */     // GIR_Coverage, 11272,
     /*  701637 */     GIR_EraseRootFromParent_Done,
     /*  701638 */   // Label 11107: @701638
     /*  701638 */   GIM_Try, /*On fail goto*//*Label 11108*/ GIMT_Encode4(701713), // Rule ID 11273 //
     /*  701643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  701654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  701657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  701660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701689 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701711 */     GIR_RootConstrainSelectedInstOperands,
     /*  701712 */     // GIR_Coverage, 11273,
     /*  701712 */     GIR_EraseRootFromParent_Done,
     /*  701713 */   // Label 11108: @701713
     /*  701713 */   GIM_Try, /*On fail goto*//*Label 11109*/ GIMT_Encode4(701788), // Rule ID 11276 //
     /*  701718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  701729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  701732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  701735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701764 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701786 */     GIR_RootConstrainSelectedInstOperands,
     /*  701787 */     // GIR_Coverage, 11276,
     /*  701787 */     GIR_EraseRootFromParent_Done,
     /*  701788 */   // Label 11109: @701788
     /*  701788 */   GIM_Try, /*On fail goto*//*Label 11110*/ GIMT_Encode4(701863), // Rule ID 11277 //
     /*  701793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  701804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  701807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  701810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701839 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701861 */     GIR_RootConstrainSelectedInstOperands,
     /*  701862 */     // GIR_Coverage, 11277,
     /*  701862 */     GIR_EraseRootFromParent_Done,
     /*  701863 */   // Label 11110: @701863
     /*  701863 */   GIM_Try, /*On fail goto*//*Label 11111*/ GIMT_Encode4(701938), // Rule ID 11280 //
     /*  701868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  701879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  701882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  701885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701936 */     GIR_RootConstrainSelectedInstOperands,
     /*  701937 */     // GIR_Coverage, 11280,
     /*  701937 */     GIR_EraseRootFromParent_Done,
     /*  701938 */   // Label 11111: @701938
     /*  701938 */   GIM_Try, /*On fail goto*//*Label 11112*/ GIMT_Encode4(702013), // Rule ID 11281 //
     /*  701943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  701954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  701957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  701960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701989 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702011 */     GIR_RootConstrainSelectedInstOperands,
     /*  702012 */     // GIR_Coverage, 11281,
     /*  702012 */     GIR_EraseRootFromParent_Done,
     /*  702013 */   // Label 11112: @702013
     /*  702013 */   GIM_Try, /*On fail goto*//*Label 11113*/ GIMT_Encode4(702088), // Rule ID 11284 //
     /*  702018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  702029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  702032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  702035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  702038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702064 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  702067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702086 */     GIR_RootConstrainSelectedInstOperands,
     /*  702087 */     // GIR_Coverage, 11284,
     /*  702087 */     GIR_EraseRootFromParent_Done,
     /*  702088 */   // Label 11113: @702088
     /*  702088 */   GIM_Try, /*On fail goto*//*Label 11114*/ GIMT_Encode4(702163), // Rule ID 11285 //
     /*  702093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  702104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  702107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  702110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  702113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702139 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  702142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702161 */     GIR_RootConstrainSelectedInstOperands,
     /*  702162 */     // GIR_Coverage, 11285,
     /*  702162 */     GIR_EraseRootFromParent_Done,
     /*  702163 */   // Label 11114: @702163
     /*  702163 */   GIM_Try, /*On fail goto*//*Label 11115*/ GIMT_Encode4(702238), // Rule ID 11288 //
     /*  702168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  702179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  702182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  702185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  702188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702214 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702236 */     GIR_RootConstrainSelectedInstOperands,
     /*  702237 */     // GIR_Coverage, 11288,
     /*  702237 */     GIR_EraseRootFromParent_Done,
     /*  702238 */   // Label 11115: @702238
     /*  702238 */   GIM_Try, /*On fail goto*//*Label 11116*/ GIMT_Encode4(702313), // Rule ID 11289 //
     /*  702243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  702254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  702257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  702260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  702263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702289 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702311 */     GIR_RootConstrainSelectedInstOperands,
     /*  702312 */     // GIR_Coverage, 11289,
     /*  702312 */     GIR_EraseRootFromParent_Done,
     /*  702313 */   // Label 11116: @702313
     /*  702313 */   GIM_Try, /*On fail goto*//*Label 11117*/ GIMT_Encode4(702388), // Rule ID 11292 //
     /*  702318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  702329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  702332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  702335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  702338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702364 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702386 */     GIR_RootConstrainSelectedInstOperands,
     /*  702387 */     // GIR_Coverage, 11292,
     /*  702387 */     GIR_EraseRootFromParent_Done,
     /*  702388 */   // Label 11117: @702388
     /*  702388 */   GIM_Try, /*On fail goto*//*Label 11118*/ GIMT_Encode4(702463), // Rule ID 11293 //
     /*  702393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  702404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  702407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  702410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  702413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702439 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702461 */     GIR_RootConstrainSelectedInstOperands,
     /*  702462 */     // GIR_Coverage, 11293,
     /*  702462 */     GIR_EraseRootFromParent_Done,
     /*  702463 */   // Label 11118: @702463
     /*  702463 */   GIM_Try, /*On fail goto*//*Label 11119*/ GIMT_Encode4(702538), // Rule ID 11296 //
     /*  702468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  702479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  702482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  702485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  702488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702514 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702536 */     GIR_RootConstrainSelectedInstOperands,
     /*  702537 */     // GIR_Coverage, 11296,
     /*  702537 */     GIR_EraseRootFromParent_Done,
     /*  702538 */   // Label 11119: @702538
     /*  702538 */   GIM_Try, /*On fail goto*//*Label 11120*/ GIMT_Encode4(702613), // Rule ID 11297 //
     /*  702543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  702554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  702557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  702560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  702563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702589 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702611 */     GIR_RootConstrainSelectedInstOperands,
     /*  702612 */     // GIR_Coverage, 11297,
     /*  702612 */     GIR_EraseRootFromParent_Done,
     /*  702613 */   // Label 11120: @702613
     /*  702613 */   GIM_Try, /*On fail goto*//*Label 11121*/ GIMT_Encode4(702688), // Rule ID 11300 //
     /*  702618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  702629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  702632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  702635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  702638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702664 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702686 */     GIR_RootConstrainSelectedInstOperands,
     /*  702687 */     // GIR_Coverage, 11300,
     /*  702687 */     GIR_EraseRootFromParent_Done,
     /*  702688 */   // Label 11121: @702688
     /*  702688 */   GIM_Try, /*On fail goto*//*Label 11122*/ GIMT_Encode4(702763), // Rule ID 11301 //
     /*  702693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  702704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  702707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  702710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  702713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702739 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702761 */     GIR_RootConstrainSelectedInstOperands,
     /*  702762 */     // GIR_Coverage, 11301,
     /*  702762 */     GIR_EraseRootFromParent_Done,
     /*  702763 */   // Label 11122: @702763
     /*  702763 */   GIM_Try, /*On fail goto*//*Label 11123*/ GIMT_Encode4(702838), // Rule ID 11304 //
     /*  702768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  702779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  702782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  702785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  702788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702836 */     GIR_RootConstrainSelectedInstOperands,
     /*  702837 */     // GIR_Coverage, 11304,
     /*  702837 */     GIR_EraseRootFromParent_Done,
     /*  702838 */   // Label 11123: @702838
     /*  702838 */   GIM_Try, /*On fail goto*//*Label 11124*/ GIMT_Encode4(702913), // Rule ID 11305 //
     /*  702843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  702854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  702857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  702860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  702863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702889 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702911 */     GIR_RootConstrainSelectedInstOperands,
     /*  702912 */     // GIR_Coverage, 11305,
     /*  702912 */     GIR_EraseRootFromParent_Done,
     /*  702913 */   // Label 11124: @702913
     /*  702913 */   GIM_Try, /*On fail goto*//*Label 11125*/ GIMT_Encode4(702988), // Rule ID 11308 //
     /*  702918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  702929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  702932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  702935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  702938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702964 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  702967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702986 */     GIR_RootConstrainSelectedInstOperands,
     /*  702987 */     // GIR_Coverage, 11308,
     /*  702987 */     GIR_EraseRootFromParent_Done,
     /*  702988 */   // Label 11125: @702988
     /*  702988 */   GIM_Try, /*On fail goto*//*Label 11126*/ GIMT_Encode4(703063), // Rule ID 11309 //
     /*  702993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  703004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  703007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  703010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  703013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703039 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703061 */     GIR_RootConstrainSelectedInstOperands,
     /*  703062 */     // GIR_Coverage, 11309,
     /*  703062 */     GIR_EraseRootFromParent_Done,
     /*  703063 */   // Label 11126: @703063
     /*  703063 */   GIM_Try, /*On fail goto*//*Label 11127*/ GIMT_Encode4(703138), // Rule ID 11312 //
     /*  703068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  703079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  703082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  703085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  703088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703136 */     GIR_RootConstrainSelectedInstOperands,
     /*  703137 */     // GIR_Coverage, 11312,
     /*  703137 */     GIR_EraseRootFromParent_Done,
     /*  703138 */   // Label 11127: @703138
     /*  703138 */   GIM_Try, /*On fail goto*//*Label 11128*/ GIMT_Encode4(703213), // Rule ID 11313 //
     /*  703143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  703154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  703157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  703160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  703163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703189 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703211 */     GIR_RootConstrainSelectedInstOperands,
     /*  703212 */     // GIR_Coverage, 11313,
     /*  703212 */     GIR_EraseRootFromParent_Done,
     /*  703213 */   // Label 11128: @703213
     /*  703213 */   GIM_Try, /*On fail goto*//*Label 11129*/ GIMT_Encode4(703288), // Rule ID 11316 //
     /*  703218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  703229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  703232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  703235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  703238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703286 */     GIR_RootConstrainSelectedInstOperands,
     /*  703287 */     // GIR_Coverage, 11316,
     /*  703287 */     GIR_EraseRootFromParent_Done,
     /*  703288 */   // Label 11129: @703288
     /*  703288 */   GIM_Try, /*On fail goto*//*Label 11130*/ GIMT_Encode4(703363), // Rule ID 11317 //
     /*  703293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  703304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  703307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  703310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  703313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703339 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  703339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703361 */     GIR_RootConstrainSelectedInstOperands,
     /*  703362 */     // GIR_Coverage, 11317,
     /*  703362 */     GIR_EraseRootFromParent_Done,
     /*  703363 */   // Label 11130: @703363
     /*  703363 */   GIM_Try, /*On fail goto*//*Label 11131*/ GIMT_Encode4(703438), // Rule ID 11320 //
     /*  703368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  703379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  703382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  703385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  703388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703414 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703436 */     GIR_RootConstrainSelectedInstOperands,
     /*  703437 */     // GIR_Coverage, 11320,
     /*  703437 */     GIR_EraseRootFromParent_Done,
     /*  703438 */   // Label 11131: @703438
     /*  703438 */   GIM_Try, /*On fail goto*//*Label 11132*/ GIMT_Encode4(703513), // Rule ID 11321 //
     /*  703443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  703454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  703457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  703460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  703463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703489 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703511 */     GIR_RootConstrainSelectedInstOperands,
     /*  703512 */     // GIR_Coverage, 11321,
     /*  703512 */     GIR_EraseRootFromParent_Done,
     /*  703513 */   // Label 11132: @703513
     /*  703513 */   GIM_Try, /*On fail goto*//*Label 11133*/ GIMT_Encode4(703588), // Rule ID 11324 //
     /*  703518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  703529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  703532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  703535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  703538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703564 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  703567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703586 */     GIR_RootConstrainSelectedInstOperands,
     /*  703587 */     // GIR_Coverage, 11324,
     /*  703587 */     GIR_EraseRootFromParent_Done,
     /*  703588 */   // Label 11133: @703588
     /*  703588 */   GIM_Try, /*On fail goto*//*Label 11134*/ GIMT_Encode4(703663), // Rule ID 11325 //
     /*  703593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  703604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  703607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  703610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  703613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703639 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  703642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703661 */     GIR_RootConstrainSelectedInstOperands,
     /*  703662 */     // GIR_Coverage, 11325,
     /*  703662 */     GIR_EraseRootFromParent_Done,
     /*  703663 */   // Label 11134: @703663
     /*  703663 */   GIM_Try, /*On fail goto*//*Label 11135*/ GIMT_Encode4(703738), // Rule ID 11328 //
     /*  703668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  703679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  703682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  703685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  703688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703714 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  703717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703736 */     GIR_RootConstrainSelectedInstOperands,
     /*  703737 */     // GIR_Coverage, 11328,
     /*  703737 */     GIR_EraseRootFromParent_Done,
     /*  703738 */   // Label 11135: @703738
     /*  703738 */   GIM_Try, /*On fail goto*//*Label 11136*/ GIMT_Encode4(703813), // Rule ID 11329 //
     /*  703743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  703754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  703757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  703760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  703763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703789 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  703792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703811 */     GIR_RootConstrainSelectedInstOperands,
     /*  703812 */     // GIR_Coverage, 11329,
     /*  703812 */     GIR_EraseRootFromParent_Done,
     /*  703813 */   // Label 11136: @703813
     /*  703813 */   GIM_Try, /*On fail goto*//*Label 11137*/ GIMT_Encode4(703888), // Rule ID 11332 //
     /*  703818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  703829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  703832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  703835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  703838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703864 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703886 */     GIR_RootConstrainSelectedInstOperands,
     /*  703887 */     // GIR_Coverage, 11332,
     /*  703887 */     GIR_EraseRootFromParent_Done,
     /*  703888 */   // Label 11137: @703888
     /*  703888 */   GIM_Try, /*On fail goto*//*Label 11138*/ GIMT_Encode4(703963), // Rule ID 11333 //
     /*  703893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  703904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  703907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  703910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  703913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703939 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703961 */     GIR_RootConstrainSelectedInstOperands,
     /*  703962 */     // GIR_Coverage, 11333,
     /*  703962 */     GIR_EraseRootFromParent_Done,
     /*  703963 */   // Label 11138: @703963
     /*  703963 */   GIM_Try, /*On fail goto*//*Label 11139*/ GIMT_Encode4(704038), // Rule ID 11336 //
     /*  703968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  703979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  703982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  703985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  703988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704014 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704036 */     GIR_RootConstrainSelectedInstOperands,
     /*  704037 */     // GIR_Coverage, 11336,
     /*  704037 */     GIR_EraseRootFromParent_Done,
     /*  704038 */   // Label 11139: @704038
     /*  704038 */   GIM_Try, /*On fail goto*//*Label 11140*/ GIMT_Encode4(704113), // Rule ID 11337 //
     /*  704043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  704054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  704057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  704060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  704063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704089 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704111 */     GIR_RootConstrainSelectedInstOperands,
     /*  704112 */     // GIR_Coverage, 11337,
     /*  704112 */     GIR_EraseRootFromParent_Done,
     /*  704113 */   // Label 11140: @704113
     /*  704113 */   GIM_Try, /*On fail goto*//*Label 11141*/ GIMT_Encode4(704188), // Rule ID 11340 //
     /*  704118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  704129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  704132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  704135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  704138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704164 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704186 */     GIR_RootConstrainSelectedInstOperands,
     /*  704187 */     // GIR_Coverage, 11340,
     /*  704187 */     GIR_EraseRootFromParent_Done,
     /*  704188 */   // Label 11141: @704188
     /*  704188 */   GIM_Try, /*On fail goto*//*Label 11142*/ GIMT_Encode4(704263), // Rule ID 11341 //
     /*  704193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  704204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  704207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  704210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  704213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704239 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704261 */     GIR_RootConstrainSelectedInstOperands,
     /*  704262 */     // GIR_Coverage, 11341,
     /*  704262 */     GIR_EraseRootFromParent_Done,
     /*  704263 */   // Label 11142: @704263
     /*  704263 */   GIM_Try, /*On fail goto*//*Label 11143*/ GIMT_Encode4(704338), // Rule ID 11344 //
     /*  704268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  704279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  704282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  704285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  704288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704314 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  704317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704336 */     GIR_RootConstrainSelectedInstOperands,
     /*  704337 */     // GIR_Coverage, 11344,
     /*  704337 */     GIR_EraseRootFromParent_Done,
     /*  704338 */   // Label 11143: @704338
     /*  704338 */   GIM_Try, /*On fail goto*//*Label 11144*/ GIMT_Encode4(704413), // Rule ID 11345 //
     /*  704343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  704354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  704357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  704360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  704363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  704392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704411 */     GIR_RootConstrainSelectedInstOperands,
     /*  704412 */     // GIR_Coverage, 11345,
     /*  704412 */     GIR_EraseRootFromParent_Done,
     /*  704413 */   // Label 11144: @704413
     /*  704413 */   GIM_Try, /*On fail goto*//*Label 11145*/ GIMT_Encode4(704488), // Rule ID 11348 //
     /*  704418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  704429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  704432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  704435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  704438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704486 */     GIR_RootConstrainSelectedInstOperands,
     /*  704487 */     // GIR_Coverage, 11348,
     /*  704487 */     GIR_EraseRootFromParent_Done,
     /*  704488 */   // Label 11145: @704488
     /*  704488 */   GIM_Try, /*On fail goto*//*Label 11146*/ GIMT_Encode4(704563), // Rule ID 11349 //
     /*  704493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  704504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  704507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  704510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  704513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704539 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704561 */     GIR_RootConstrainSelectedInstOperands,
     /*  704562 */     // GIR_Coverage, 11349,
     /*  704562 */     GIR_EraseRootFromParent_Done,
     /*  704563 */   // Label 11146: @704563
     /*  704563 */   GIM_Try, /*On fail goto*//*Label 11147*/ GIMT_Encode4(704638), // Rule ID 11352 //
     /*  704568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  704579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  704582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  704585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  704588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704636 */     GIR_RootConstrainSelectedInstOperands,
     /*  704637 */     // GIR_Coverage, 11352,
     /*  704637 */     GIR_EraseRootFromParent_Done,
     /*  704638 */   // Label 11147: @704638
     /*  704638 */   GIM_Try, /*On fail goto*//*Label 11148*/ GIMT_Encode4(704713), // Rule ID 11353 //
     /*  704643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  704654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  704657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  704660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  704663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704689 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704711 */     GIR_RootConstrainSelectedInstOperands,
     /*  704712 */     // GIR_Coverage, 11353,
     /*  704712 */     GIR_EraseRootFromParent_Done,
     /*  704713 */   // Label 11148: @704713
     /*  704713 */   GIM_Try, /*On fail goto*//*Label 11149*/ GIMT_Encode4(704788), // Rule ID 11356 //
     /*  704718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  704729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  704732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  704735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704764 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  704767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704786 */     GIR_RootConstrainSelectedInstOperands,
     /*  704787 */     // GIR_Coverage, 11356,
     /*  704787 */     GIR_EraseRootFromParent_Done,
     /*  704788 */   // Label 11149: @704788
     /*  704788 */   GIM_Try, /*On fail goto*//*Label 11150*/ GIMT_Encode4(704863), // Rule ID 11357 //
     /*  704793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  704804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  704807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  704810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704839 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  704842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704861 */     GIR_RootConstrainSelectedInstOperands,
     /*  704862 */     // GIR_Coverage, 11357,
     /*  704862 */     GIR_EraseRootFromParent_Done,
     /*  704863 */   // Label 11150: @704863
     /*  704863 */   GIM_Try, /*On fail goto*//*Label 11151*/ GIMT_Encode4(704938), // Rule ID 11360 //
     /*  704868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  704879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  704882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  704885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704914 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  704917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704936 */     GIR_RootConstrainSelectedInstOperands,
     /*  704937 */     // GIR_Coverage, 11360,
     /*  704937 */     GIR_EraseRootFromParent_Done,
     /*  704938 */   // Label 11151: @704938
     /*  704938 */   GIM_Try, /*On fail goto*//*Label 11152*/ GIMT_Encode4(705013), // Rule ID 11361 //
     /*  704943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  704954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  704957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  704960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704989 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  704992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705011 */     GIR_RootConstrainSelectedInstOperands,
     /*  705012 */     // GIR_Coverage, 11361,
     /*  705012 */     GIR_EraseRootFromParent_Done,
     /*  705013 */   // Label 11152: @705013
     /*  705013 */   GIM_Try, /*On fail goto*//*Label 11153*/ GIMT_Encode4(705088), // Rule ID 11364 //
     /*  705018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  705029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  705032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  705035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705064 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705086 */     GIR_RootConstrainSelectedInstOperands,
     /*  705087 */     // GIR_Coverage, 11364,
     /*  705087 */     GIR_EraseRootFromParent_Done,
     /*  705088 */   // Label 11153: @705088
     /*  705088 */   GIM_Try, /*On fail goto*//*Label 11154*/ GIMT_Encode4(705163), // Rule ID 11365 //
     /*  705093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  705104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  705107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  705110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705139 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705161 */     GIR_RootConstrainSelectedInstOperands,
     /*  705162 */     // GIR_Coverage, 11365,
     /*  705162 */     GIR_EraseRootFromParent_Done,
     /*  705163 */   // Label 11154: @705163
     /*  705163 */   GIM_Try, /*On fail goto*//*Label 11155*/ GIMT_Encode4(705238), // Rule ID 11368 //
     /*  705168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  705179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  705182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  705185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  705217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705236 */     GIR_RootConstrainSelectedInstOperands,
     /*  705237 */     // GIR_Coverage, 11368,
     /*  705237 */     GIR_EraseRootFromParent_Done,
     /*  705238 */   // Label 11155: @705238
     /*  705238 */   GIM_Try, /*On fail goto*//*Label 11156*/ GIMT_Encode4(705313), // Rule ID 11369 //
     /*  705243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  705254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  705257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  705260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705289 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  705292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705311 */     GIR_RootConstrainSelectedInstOperands,
     /*  705312 */     // GIR_Coverage, 11369,
     /*  705312 */     GIR_EraseRootFromParent_Done,
     /*  705313 */   // Label 11156: @705313
     /*  705313 */   GIM_Try, /*On fail goto*//*Label 11157*/ GIMT_Encode4(705388), // Rule ID 11372 //
     /*  705318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  705329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  705332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  705335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705364 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705386 */     GIR_RootConstrainSelectedInstOperands,
     /*  705387 */     // GIR_Coverage, 11372,
     /*  705387 */     GIR_EraseRootFromParent_Done,
     /*  705388 */   // Label 11157: @705388
     /*  705388 */   GIM_Try, /*On fail goto*//*Label 11158*/ GIMT_Encode4(705463), // Rule ID 11373 //
     /*  705393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  705404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  705407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  705410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705439 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705461 */     GIR_RootConstrainSelectedInstOperands,
     /*  705462 */     // GIR_Coverage, 11373,
     /*  705462 */     GIR_EraseRootFromParent_Done,
     /*  705463 */   // Label 11158: @705463
     /*  705463 */   GIM_Try, /*On fail goto*//*Label 11159*/ GIMT_Encode4(705538), // Rule ID 11376 //
     /*  705468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  705479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  705482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  705485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705514 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705536 */     GIR_RootConstrainSelectedInstOperands,
     /*  705537 */     // GIR_Coverage, 11376,
     /*  705537 */     GIR_EraseRootFromParent_Done,
     /*  705538 */   // Label 11159: @705538
     /*  705538 */   GIM_Try, /*On fail goto*//*Label 11160*/ GIMT_Encode4(705613), // Rule ID 11377 //
     /*  705543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  705554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  705557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  705560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705589 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705611 */     GIR_RootConstrainSelectedInstOperands,
     /*  705612 */     // GIR_Coverage, 11377,
     /*  705612 */     GIR_EraseRootFromParent_Done,
     /*  705613 */   // Label 11160: @705613
     /*  705613 */   GIM_Try, /*On fail goto*//*Label 11161*/ GIMT_Encode4(705688), // Rule ID 11380 //
     /*  705618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  705629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  705632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  705635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705664 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705686 */     GIR_RootConstrainSelectedInstOperands,
     /*  705687 */     // GIR_Coverage, 11380,
     /*  705687 */     GIR_EraseRootFromParent_Done,
     /*  705688 */   // Label 11161: @705688
     /*  705688 */   GIM_Try, /*On fail goto*//*Label 11162*/ GIMT_Encode4(705763), // Rule ID 11381 //
     /*  705693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  705704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  705707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  705710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705739 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705761 */     GIR_RootConstrainSelectedInstOperands,
     /*  705762 */     // GIR_Coverage, 11381,
     /*  705762 */     GIR_EraseRootFromParent_Done,
     /*  705763 */   // Label 11162: @705763
     /*  705763 */   GIM_Try, /*On fail goto*//*Label 11163*/ GIMT_Encode4(705838), // Rule ID 11384 //
     /*  705768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  705779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  705782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  705785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705814 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705836 */     GIR_RootConstrainSelectedInstOperands,
     /*  705837 */     // GIR_Coverage, 11384,
     /*  705837 */     GIR_EraseRootFromParent_Done,
     /*  705838 */   // Label 11163: @705838
     /*  705838 */   GIM_Try, /*On fail goto*//*Label 11164*/ GIMT_Encode4(705913), // Rule ID 11385 //
     /*  705843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  705854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  705857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  705860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705889 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705911 */     GIR_RootConstrainSelectedInstOperands,
     /*  705912 */     // GIR_Coverage, 11385,
     /*  705912 */     GIR_EraseRootFromParent_Done,
     /*  705913 */   // Label 11164: @705913
     /*  705913 */   GIM_Try, /*On fail goto*//*Label 11165*/ GIMT_Encode4(705988), // Rule ID 11388 //
     /*  705918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  705929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  705932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  705935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705964 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705986 */     GIR_RootConstrainSelectedInstOperands,
     /*  705987 */     // GIR_Coverage, 11388,
     /*  705987 */     GIR_EraseRootFromParent_Done,
     /*  705988 */   // Label 11165: @705988
     /*  705988 */   GIM_Try, /*On fail goto*//*Label 11166*/ GIMT_Encode4(706063), // Rule ID 11389 //
     /*  705993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  706004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  706007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  706010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706039 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706061 */     GIR_RootConstrainSelectedInstOperands,
     /*  706062 */     // GIR_Coverage, 11389,
     /*  706062 */     GIR_EraseRootFromParent_Done,
     /*  706063 */   // Label 11166: @706063
     /*  706063 */   GIM_Try, /*On fail goto*//*Label 11167*/ GIMT_Encode4(706138), // Rule ID 11392 //
     /*  706068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  706079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  706082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  706085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706114 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706136 */     GIR_RootConstrainSelectedInstOperands,
     /*  706137 */     // GIR_Coverage, 11392,
     /*  706137 */     GIR_EraseRootFromParent_Done,
     /*  706138 */   // Label 11167: @706138
     /*  706138 */   GIM_Try, /*On fail goto*//*Label 11168*/ GIMT_Encode4(706213), // Rule ID 11393 //
     /*  706143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  706154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  706157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  706160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706189 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706211 */     GIR_RootConstrainSelectedInstOperands,
     /*  706212 */     // GIR_Coverage, 11393,
     /*  706212 */     GIR_EraseRootFromParent_Done,
     /*  706213 */   // Label 11168: @706213
     /*  706213 */   GIM_Try, /*On fail goto*//*Label 11169*/ GIMT_Encode4(706288), // Rule ID 11396 //
     /*  706218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  706229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  706232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  706235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706264 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706286 */     GIR_RootConstrainSelectedInstOperands,
     /*  706287 */     // GIR_Coverage, 11396,
     /*  706287 */     GIR_EraseRootFromParent_Done,
     /*  706288 */   // Label 11169: @706288
     /*  706288 */   GIM_Try, /*On fail goto*//*Label 11170*/ GIMT_Encode4(706363), // Rule ID 11397 //
     /*  706293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  706304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  706307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  706310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706339 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706361 */     GIR_RootConstrainSelectedInstOperands,
     /*  706362 */     // GIR_Coverage, 11397,
     /*  706362 */     GIR_EraseRootFromParent_Done,
     /*  706363 */   // Label 11170: @706363
     /*  706363 */   GIM_Try, /*On fail goto*//*Label 11171*/ GIMT_Encode4(706438), // Rule ID 11400 //
     /*  706368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  706379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  706382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  706385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706414 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706436 */     GIR_RootConstrainSelectedInstOperands,
     /*  706437 */     // GIR_Coverage, 11400,
     /*  706437 */     GIR_EraseRootFromParent_Done,
     /*  706438 */   // Label 11171: @706438
     /*  706438 */   GIM_Try, /*On fail goto*//*Label 11172*/ GIMT_Encode4(706513), // Rule ID 11401 //
     /*  706443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  706454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  706457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  706460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706489 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706511 */     GIR_RootConstrainSelectedInstOperands,
     /*  706512 */     // GIR_Coverage, 11401,
     /*  706512 */     GIR_EraseRootFromParent_Done,
     /*  706513 */   // Label 11172: @706513
     /*  706513 */   GIM_Try, /*On fail goto*//*Label 11173*/ GIMT_Encode4(706588), // Rule ID 11404 //
     /*  706518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  706529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  706532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  706535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706564 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706586 */     GIR_RootConstrainSelectedInstOperands,
     /*  706587 */     // GIR_Coverage, 11404,
     /*  706587 */     GIR_EraseRootFromParent_Done,
     /*  706588 */   // Label 11173: @706588
     /*  706588 */   GIM_Try, /*On fail goto*//*Label 11174*/ GIMT_Encode4(706663), // Rule ID 11405 //
     /*  706593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  706604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  706607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  706610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706639 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706661 */     GIR_RootConstrainSelectedInstOperands,
     /*  706662 */     // GIR_Coverage, 11405,
     /*  706662 */     GIR_EraseRootFromParent_Done,
     /*  706663 */   // Label 11174: @706663
     /*  706663 */   GIM_Try, /*On fail goto*//*Label 11175*/ GIMT_Encode4(706738), // Rule ID 11408 //
     /*  706668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  706679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  706682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  706685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706714 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706736 */     GIR_RootConstrainSelectedInstOperands,
     /*  706737 */     // GIR_Coverage, 11408,
     /*  706737 */     GIR_EraseRootFromParent_Done,
     /*  706738 */   // Label 11175: @706738
     /*  706738 */   GIM_Try, /*On fail goto*//*Label 11176*/ GIMT_Encode4(706813), // Rule ID 11409 //
     /*  706743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  706754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  706757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  706760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706789 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706811 */     GIR_RootConstrainSelectedInstOperands,
     /*  706812 */     // GIR_Coverage, 11409,
     /*  706812 */     GIR_EraseRootFromParent_Done,
     /*  706813 */   // Label 11176: @706813
     /*  706813 */   GIM_Try, /*On fail goto*//*Label 11177*/ GIMT_Encode4(706888), // Rule ID 11412 //
     /*  706818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  706829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  706832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  706835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706864 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706886 */     GIR_RootConstrainSelectedInstOperands,
     /*  706887 */     // GIR_Coverage, 11412,
     /*  706887 */     GIR_EraseRootFromParent_Done,
     /*  706888 */   // Label 11177: @706888
     /*  706888 */   GIM_Try, /*On fail goto*//*Label 11178*/ GIMT_Encode4(706963), // Rule ID 11413 //
     /*  706893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  706904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  706907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  706910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706939 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706961 */     GIR_RootConstrainSelectedInstOperands,
     /*  706962 */     // GIR_Coverage, 11413,
     /*  706962 */     GIR_EraseRootFromParent_Done,
     /*  706963 */   // Label 11178: @706963
     /*  706963 */   GIM_Try, /*On fail goto*//*Label 11179*/ GIMT_Encode4(707038), // Rule ID 11416 //
     /*  706968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  706979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  706982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  706985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  707017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707036 */     GIR_RootConstrainSelectedInstOperands,
     /*  707037 */     // GIR_Coverage, 11416,
     /*  707037 */     GIR_EraseRootFromParent_Done,
     /*  707038 */   // Label 11179: @707038
     /*  707038 */   GIM_Try, /*On fail goto*//*Label 11180*/ GIMT_Encode4(707113), // Rule ID 11417 //
     /*  707043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  707054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  707057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  707060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707089 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  707092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707111 */     GIR_RootConstrainSelectedInstOperands,
     /*  707112 */     // GIR_Coverage, 11417,
     /*  707112 */     GIR_EraseRootFromParent_Done,
     /*  707113 */   // Label 11180: @707113
     /*  707113 */   GIM_Try, /*On fail goto*//*Label 11181*/ GIMT_Encode4(707188), // Rule ID 11420 //
     /*  707118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  707129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  707132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  707135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707164 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  707167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707186 */     GIR_RootConstrainSelectedInstOperands,
     /*  707187 */     // GIR_Coverage, 11420,
     /*  707187 */     GIR_EraseRootFromParent_Done,
     /*  707188 */   // Label 11181: @707188
     /*  707188 */   GIM_Try, /*On fail goto*//*Label 11182*/ GIMT_Encode4(707263), // Rule ID 11421 //
     /*  707193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  707204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  707207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  707210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707239 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  707242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707261 */     GIR_RootConstrainSelectedInstOperands,
     /*  707262 */     // GIR_Coverage, 11421,
     /*  707262 */     GIR_EraseRootFromParent_Done,
     /*  707263 */   // Label 11182: @707263
     /*  707263 */   GIM_Try, /*On fail goto*//*Label 11183*/ GIMT_Encode4(707338), // Rule ID 11424 //
     /*  707268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  707279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  707282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  707285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707314 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  707317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707336 */     GIR_RootConstrainSelectedInstOperands,
     /*  707337 */     // GIR_Coverage, 11424,
     /*  707337 */     GIR_EraseRootFromParent_Done,
     /*  707338 */   // Label 11183: @707338
     /*  707338 */   GIM_Try, /*On fail goto*//*Label 11184*/ GIMT_Encode4(707413), // Rule ID 11425 //
     /*  707343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  707354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  707357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  707360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707389 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  707392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707411 */     GIR_RootConstrainSelectedInstOperands,
     /*  707412 */     // GIR_Coverage, 11425,
     /*  707412 */     GIR_EraseRootFromParent_Done,
     /*  707413 */   // Label 11184: @707413
     /*  707413 */   GIM_Try, /*On fail goto*//*Label 11185*/ GIMT_Encode4(707488), // Rule ID 11428 //
     /*  707418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  707429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  707432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  707435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  707438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707464 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  707467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707486 */     GIR_RootConstrainSelectedInstOperands,
     /*  707487 */     // GIR_Coverage, 11428,
     /*  707487 */     GIR_EraseRootFromParent_Done,
     /*  707488 */   // Label 11185: @707488
     /*  707488 */   GIM_Try, /*On fail goto*//*Label 11186*/ GIMT_Encode4(707563), // Rule ID 11429 //
     /*  707493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  707504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  707507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  707510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  707513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707539 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  707542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707561 */     GIR_RootConstrainSelectedInstOperands,
     /*  707562 */     // GIR_Coverage, 11429,
     /*  707562 */     GIR_EraseRootFromParent_Done,
     /*  707563 */   // Label 11186: @707563
     /*  707563 */   GIM_Try, /*On fail goto*//*Label 11187*/ GIMT_Encode4(707638), // Rule ID 11432 //
     /*  707568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  707579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  707582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  707585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  707588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707614 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  707617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707636 */     GIR_RootConstrainSelectedInstOperands,
     /*  707637 */     // GIR_Coverage, 11432,
     /*  707637 */     GIR_EraseRootFromParent_Done,
     /*  707638 */   // Label 11187: @707638
     /*  707638 */   GIM_Try, /*On fail goto*//*Label 11188*/ GIMT_Encode4(707713), // Rule ID 11433 //
     /*  707643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  707654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  707657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  707660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  707663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707689 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  707692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707711 */     GIR_RootConstrainSelectedInstOperands,
     /*  707712 */     // GIR_Coverage, 11433,
     /*  707712 */     GIR_EraseRootFromParent_Done,
     /*  707713 */   // Label 11188: @707713
     /*  707713 */   GIM_Try, /*On fail goto*//*Label 11189*/ GIMT_Encode4(707788), // Rule ID 11436 //
     /*  707718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  707729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  707732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  707735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  707738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707764 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  707767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707786 */     GIR_RootConstrainSelectedInstOperands,
     /*  707787 */     // GIR_Coverage, 11436,
     /*  707787 */     GIR_EraseRootFromParent_Done,
     /*  707788 */   // Label 11189: @707788
     /*  707788 */   GIM_Try, /*On fail goto*//*Label 11190*/ GIMT_Encode4(707863), // Rule ID 11437 //
     /*  707793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  707804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  707807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  707810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  707813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707839 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  707842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707861 */     GIR_RootConstrainSelectedInstOperands,
     /*  707862 */     // GIR_Coverage, 11437,
     /*  707862 */     GIR_EraseRootFromParent_Done,
     /*  707863 */   // Label 11190: @707863
     /*  707863 */   GIM_Try, /*On fail goto*//*Label 11191*/ GIMT_Encode4(707938), // Rule ID 11440 //
     /*  707868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  707879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  707882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  707885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  707888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707914 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  707917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707936 */     GIR_RootConstrainSelectedInstOperands,
     /*  707937 */     // GIR_Coverage, 11440,
     /*  707937 */     GIR_EraseRootFromParent_Done,
     /*  707938 */   // Label 11191: @707938
     /*  707938 */   GIM_Try, /*On fail goto*//*Label 11192*/ GIMT_Encode4(708013), // Rule ID 11441 //
     /*  707943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  707954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  707957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  707960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  707963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707989 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  707992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708011 */     GIR_RootConstrainSelectedInstOperands,
     /*  708012 */     // GIR_Coverage, 11441,
     /*  708012 */     GIR_EraseRootFromParent_Done,
     /*  708013 */   // Label 11192: @708013
     /*  708013 */   GIM_Try, /*On fail goto*//*Label 11193*/ GIMT_Encode4(708088), // Rule ID 11444 //
     /*  708018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  708029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  708032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  708035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  708038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708064 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708086 */     GIR_RootConstrainSelectedInstOperands,
     /*  708087 */     // GIR_Coverage, 11444,
     /*  708087 */     GIR_EraseRootFromParent_Done,
     /*  708088 */   // Label 11193: @708088
     /*  708088 */   GIM_Try, /*On fail goto*//*Label 11194*/ GIMT_Encode4(708163), // Rule ID 11445 //
     /*  708093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  708104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  708107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  708110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  708113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708139 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708161 */     GIR_RootConstrainSelectedInstOperands,
     /*  708162 */     // GIR_Coverage, 11445,
     /*  708162 */     GIR_EraseRootFromParent_Done,
     /*  708163 */   // Label 11194: @708163
     /*  708163 */   GIM_Try, /*On fail goto*//*Label 11195*/ GIMT_Encode4(708238), // Rule ID 11448 //
     /*  708168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  708179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  708182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  708185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  708188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708214 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708236 */     GIR_RootConstrainSelectedInstOperands,
     /*  708237 */     // GIR_Coverage, 11448,
     /*  708237 */     GIR_EraseRootFromParent_Done,
     /*  708238 */   // Label 11195: @708238
     /*  708238 */   GIM_Try, /*On fail goto*//*Label 11196*/ GIMT_Encode4(708313), // Rule ID 11449 //
     /*  708243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  708254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  708257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  708260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  708263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708289 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708311 */     GIR_RootConstrainSelectedInstOperands,
     /*  708312 */     // GIR_Coverage, 11449,
     /*  708312 */     GIR_EraseRootFromParent_Done,
     /*  708313 */   // Label 11196: @708313
     /*  708313 */   GIM_Try, /*On fail goto*//*Label 11197*/ GIMT_Encode4(708388), // Rule ID 11452 //
     /*  708318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  708329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  708332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  708335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  708338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708364 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708386 */     GIR_RootConstrainSelectedInstOperands,
     /*  708387 */     // GIR_Coverage, 11452,
     /*  708387 */     GIR_EraseRootFromParent_Done,
     /*  708388 */   // Label 11197: @708388
     /*  708388 */   GIM_Try, /*On fail goto*//*Label 11198*/ GIMT_Encode4(708463), // Rule ID 11453 //
     /*  708393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  708404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  708407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  708410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  708413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708439 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708461 */     GIR_RootConstrainSelectedInstOperands,
     /*  708462 */     // GIR_Coverage, 11453,
     /*  708462 */     GIR_EraseRootFromParent_Done,
     /*  708463 */   // Label 11198: @708463
     /*  708463 */   GIM_Try, /*On fail goto*//*Label 11199*/ GIMT_Encode4(708538), // Rule ID 11456 //
     /*  708468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  708479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  708482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  708485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  708488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708514 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708536 */     GIR_RootConstrainSelectedInstOperands,
     /*  708537 */     // GIR_Coverage, 11456,
     /*  708537 */     GIR_EraseRootFromParent_Done,
     /*  708538 */   // Label 11199: @708538
     /*  708538 */   GIM_Try, /*On fail goto*//*Label 11200*/ GIMT_Encode4(708613), // Rule ID 11457 //
     /*  708543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  708554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  708557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  708560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  708563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708589 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708611 */     GIR_RootConstrainSelectedInstOperands,
     /*  708612 */     // GIR_Coverage, 11457,
     /*  708612 */     GIR_EraseRootFromParent_Done,
     /*  708613 */   // Label 11200: @708613
     /*  708613 */   GIM_Try, /*On fail goto*//*Label 11201*/ GIMT_Encode4(708688), // Rule ID 11460 //
     /*  708618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  708629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  708632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  708635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  708638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708664 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708686 */     GIR_RootConstrainSelectedInstOperands,
     /*  708687 */     // GIR_Coverage, 11460,
     /*  708687 */     GIR_EraseRootFromParent_Done,
     /*  708688 */   // Label 11201: @708688
     /*  708688 */   GIM_Try, /*On fail goto*//*Label 11202*/ GIMT_Encode4(708763), // Rule ID 11461 //
     /*  708693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  708704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  708707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  708710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  708713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708739 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708761 */     GIR_RootConstrainSelectedInstOperands,
     /*  708762 */     // GIR_Coverage, 11461,
     /*  708762 */     GIR_EraseRootFromParent_Done,
     /*  708763 */   // Label 11202: @708763
     /*  708763 */   GIM_Try, /*On fail goto*//*Label 11203*/ GIMT_Encode4(708838), // Rule ID 11464 //
     /*  708768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  708779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  708782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  708785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  708788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708814 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  708817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708836 */     GIR_RootConstrainSelectedInstOperands,
     /*  708837 */     // GIR_Coverage, 11464,
     /*  708837 */     GIR_EraseRootFromParent_Done,
     /*  708838 */   // Label 11203: @708838
     /*  708838 */   GIM_Try, /*On fail goto*//*Label 11204*/ GIMT_Encode4(708913), // Rule ID 11465 //
     /*  708843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  708854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  708857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  708860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  708863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708889 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  708892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708911 */     GIR_RootConstrainSelectedInstOperands,
     /*  708912 */     // GIR_Coverage, 11465,
     /*  708912 */     GIR_EraseRootFromParent_Done,
     /*  708913 */   // Label 11204: @708913
     /*  708913 */   GIM_Try, /*On fail goto*//*Label 11205*/ GIMT_Encode4(708988), // Rule ID 11468 //
     /*  708918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  708929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  708932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  708935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  708938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708964 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  708967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708986 */     GIR_RootConstrainSelectedInstOperands,
     /*  708987 */     // GIR_Coverage, 11468,
     /*  708987 */     GIR_EraseRootFromParent_Done,
     /*  708988 */   // Label 11205: @708988
     /*  708988 */   GIM_Try, /*On fail goto*//*Label 11206*/ GIMT_Encode4(709063), // Rule ID 11469 //
     /*  708993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  709004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  709007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  709010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  709013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709039 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709061 */     GIR_RootConstrainSelectedInstOperands,
     /*  709062 */     // GIR_Coverage, 11469,
     /*  709062 */     GIR_EraseRootFromParent_Done,
     /*  709063 */   // Label 11206: @709063
     /*  709063 */   GIM_Try, /*On fail goto*//*Label 11207*/ GIMT_Encode4(709138), // Rule ID 11472 //
     /*  709068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  709079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  709082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  709085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  709088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709114 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709136 */     GIR_RootConstrainSelectedInstOperands,
     /*  709137 */     // GIR_Coverage, 11472,
     /*  709137 */     GIR_EraseRootFromParent_Done,
     /*  709138 */   // Label 11207: @709138
     /*  709138 */   GIM_Try, /*On fail goto*//*Label 11208*/ GIMT_Encode4(709213), // Rule ID 11473 //
     /*  709143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  709154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  709157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  709160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  709163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709189 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709211 */     GIR_RootConstrainSelectedInstOperands,
     /*  709212 */     // GIR_Coverage, 11473,
     /*  709212 */     GIR_EraseRootFromParent_Done,
     /*  709213 */   // Label 11208: @709213
     /*  709213 */   GIM_Try, /*On fail goto*//*Label 11209*/ GIMT_Encode4(709288), // Rule ID 11476 //
     /*  709218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  709229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  709232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  709235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  709238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709264 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709286 */     GIR_RootConstrainSelectedInstOperands,
     /*  709287 */     // GIR_Coverage, 11476,
     /*  709287 */     GIR_EraseRootFromParent_Done,
     /*  709288 */   // Label 11209: @709288
     /*  709288 */   GIM_Try, /*On fail goto*//*Label 11210*/ GIMT_Encode4(709363), // Rule ID 11477 //
     /*  709293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  709304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  709307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  709310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  709313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709361 */     GIR_RootConstrainSelectedInstOperands,
     /*  709362 */     // GIR_Coverage, 11477,
     /*  709362 */     GIR_EraseRootFromParent_Done,
     /*  709363 */   // Label 11210: @709363
     /*  709363 */   GIM_Try, /*On fail goto*//*Label 11211*/ GIMT_Encode4(709438), // Rule ID 11480 //
     /*  709368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  709379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  709382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  709385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  709388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709414 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709436 */     GIR_RootConstrainSelectedInstOperands,
     /*  709437 */     // GIR_Coverage, 11480,
     /*  709437 */     GIR_EraseRootFromParent_Done,
     /*  709438 */   // Label 11211: @709438
     /*  709438 */   GIM_Try, /*On fail goto*//*Label 11212*/ GIMT_Encode4(709513), // Rule ID 11481 //
     /*  709443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  709454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  709457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  709460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  709463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709489 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709511 */     GIR_RootConstrainSelectedInstOperands,
     /*  709512 */     // GIR_Coverage, 11481,
     /*  709512 */     GIR_EraseRootFromParent_Done,
     /*  709513 */   // Label 11212: @709513
     /*  709513 */   GIM_Try, /*On fail goto*//*Label 11213*/ GIMT_Encode4(709588), // Rule ID 11484 //
     /*  709518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  709529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  709532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  709535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  709538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709564 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709586 */     GIR_RootConstrainSelectedInstOperands,
     /*  709587 */     // GIR_Coverage, 11484,
     /*  709587 */     GIR_EraseRootFromParent_Done,
     /*  709588 */   // Label 11213: @709588
     /*  709588 */   GIM_Try, /*On fail goto*//*Label 11214*/ GIMT_Encode4(709663), // Rule ID 11485 //
     /*  709593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  709604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  709607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  709610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  709613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709639 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709661 */     GIR_RootConstrainSelectedInstOperands,
     /*  709662 */     // GIR_Coverage, 11485,
     /*  709662 */     GIR_EraseRootFromParent_Done,
     /*  709663 */   // Label 11214: @709663
     /*  709663 */   GIM_Try, /*On fail goto*//*Label 11215*/ GIMT_Encode4(709738), // Rule ID 11488 //
     /*  709668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  709679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  709682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  709685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  709688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709714 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709736 */     GIR_RootConstrainSelectedInstOperands,
     /*  709737 */     // GIR_Coverage, 11488,
     /*  709737 */     GIR_EraseRootFromParent_Done,
     /*  709738 */   // Label 11215: @709738
     /*  709738 */   GIM_Try, /*On fail goto*//*Label 11216*/ GIMT_Encode4(709813), // Rule ID 11489 //
     /*  709743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  709754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  709757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  709760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  709763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709789 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709811 */     GIR_RootConstrainSelectedInstOperands,
     /*  709812 */     // GIR_Coverage, 11489,
     /*  709812 */     GIR_EraseRootFromParent_Done,
     /*  709813 */   // Label 11216: @709813
     /*  709813 */   GIM_Try, /*On fail goto*//*Label 11217*/ GIMT_Encode4(709888), // Rule ID 11492 //
     /*  709818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  709829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  709832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  709835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  709838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709864 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709886 */     GIR_RootConstrainSelectedInstOperands,
     /*  709887 */     // GIR_Coverage, 11492,
     /*  709887 */     GIR_EraseRootFromParent_Done,
     /*  709888 */   // Label 11217: @709888
     /*  709888 */   GIM_Try, /*On fail goto*//*Label 11218*/ GIMT_Encode4(709963), // Rule ID 11493 //
     /*  709893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  709904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  709907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  709910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  709913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709939 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709961 */     GIR_RootConstrainSelectedInstOperands,
     /*  709962 */     // GIR_Coverage, 11493,
     /*  709962 */     GIR_EraseRootFromParent_Done,
     /*  709963 */   // Label 11218: @709963
     /*  709963 */   GIM_Try, /*On fail goto*//*Label 11219*/ GIMT_Encode4(710038), // Rule ID 11496 //
     /*  709968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  709979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  709982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  709985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  709988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710014 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  710017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710036 */     GIR_RootConstrainSelectedInstOperands,
     /*  710037 */     // GIR_Coverage, 11496,
     /*  710037 */     GIR_EraseRootFromParent_Done,
     /*  710038 */   // Label 11219: @710038
     /*  710038 */   GIM_Try, /*On fail goto*//*Label 11220*/ GIMT_Encode4(710113), // Rule ID 11497 //
     /*  710043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  710054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  710057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  710060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  710063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710089 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  710092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710111 */     GIR_RootConstrainSelectedInstOperands,
     /*  710112 */     // GIR_Coverage, 11497,
     /*  710112 */     GIR_EraseRootFromParent_Done,
     /*  710113 */   // Label 11220: @710113
     /*  710113 */   GIM_Try, /*On fail goto*//*Label 11221*/ GIMT_Encode4(710188), // Rule ID 11500 //
     /*  710118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  710129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  710132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  710135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710164 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  710167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710186 */     GIR_RootConstrainSelectedInstOperands,
     /*  710187 */     // GIR_Coverage, 11500,
     /*  710187 */     GIR_EraseRootFromParent_Done,
     /*  710188 */   // Label 11221: @710188
     /*  710188 */   GIM_Try, /*On fail goto*//*Label 11222*/ GIMT_Encode4(710263), // Rule ID 11501 //
     /*  710193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  710204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  710207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  710210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710239 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  710242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710261 */     GIR_RootConstrainSelectedInstOperands,
     /*  710262 */     // GIR_Coverage, 11501,
     /*  710262 */     GIR_EraseRootFromParent_Done,
     /*  710263 */   // Label 11222: @710263
     /*  710263 */   GIM_Try, /*On fail goto*//*Label 11223*/ GIMT_Encode4(710338), // Rule ID 11504 //
     /*  710268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  710279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  710282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  710285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710314 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710336 */     GIR_RootConstrainSelectedInstOperands,
     /*  710337 */     // GIR_Coverage, 11504,
     /*  710337 */     GIR_EraseRootFromParent_Done,
     /*  710338 */   // Label 11223: @710338
     /*  710338 */   GIM_Try, /*On fail goto*//*Label 11224*/ GIMT_Encode4(710413), // Rule ID 11505 //
     /*  710343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  710354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  710357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  710360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710389 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710411 */     GIR_RootConstrainSelectedInstOperands,
     /*  710412 */     // GIR_Coverage, 11505,
     /*  710412 */     GIR_EraseRootFromParent_Done,
     /*  710413 */   // Label 11224: @710413
     /*  710413 */   GIM_Try, /*On fail goto*//*Label 11225*/ GIMT_Encode4(710488), // Rule ID 11508 //
     /*  710418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  710429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  710432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  710435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710464 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710486 */     GIR_RootConstrainSelectedInstOperands,
     /*  710487 */     // GIR_Coverage, 11508,
     /*  710487 */     GIR_EraseRootFromParent_Done,
     /*  710488 */   // Label 11225: @710488
     /*  710488 */   GIM_Try, /*On fail goto*//*Label 11226*/ GIMT_Encode4(710563), // Rule ID 11509 //
     /*  710493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  710504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  710507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  710510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710539 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710561 */     GIR_RootConstrainSelectedInstOperands,
     /*  710562 */     // GIR_Coverage, 11509,
     /*  710562 */     GIR_EraseRootFromParent_Done,
     /*  710563 */   // Label 11226: @710563
     /*  710563 */   GIM_Try, /*On fail goto*//*Label 11227*/ GIMT_Encode4(710638), // Rule ID 11512 //
     /*  710568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  710579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  710582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  710585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710614 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710636 */     GIR_RootConstrainSelectedInstOperands,
     /*  710637 */     // GIR_Coverage, 11512,
     /*  710637 */     GIR_EraseRootFromParent_Done,
     /*  710638 */   // Label 11227: @710638
     /*  710638 */   GIM_Try, /*On fail goto*//*Label 11228*/ GIMT_Encode4(710713), // Rule ID 11513 //
     /*  710643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  710654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  710657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  710660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710689 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710711 */     GIR_RootConstrainSelectedInstOperands,
     /*  710712 */     // GIR_Coverage, 11513,
     /*  710712 */     GIR_EraseRootFromParent_Done,
     /*  710713 */   // Label 11228: @710713
     /*  710713 */   GIM_Try, /*On fail goto*//*Label 11229*/ GIMT_Encode4(710788), // Rule ID 11516 //
     /*  710718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  710729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  710732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  710735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710764 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710786 */     GIR_RootConstrainSelectedInstOperands,
     /*  710787 */     // GIR_Coverage, 11516,
     /*  710787 */     GIR_EraseRootFromParent_Done,
     /*  710788 */   // Label 11229: @710788
     /*  710788 */   GIM_Try, /*On fail goto*//*Label 11230*/ GIMT_Encode4(710863), // Rule ID 11517 //
     /*  710793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  710804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  710807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  710810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710839 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710861 */     GIR_RootConstrainSelectedInstOperands,
     /*  710862 */     // GIR_Coverage, 11517,
     /*  710862 */     GIR_EraseRootFromParent_Done,
     /*  710863 */   // Label 11230: @710863
     /*  710863 */   GIM_Try, /*On fail goto*//*Label 11231*/ GIMT_Encode4(710938), // Rule ID 11520 //
     /*  710868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  710879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  710882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  710885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710914 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710936 */     GIR_RootConstrainSelectedInstOperands,
     /*  710937 */     // GIR_Coverage, 11520,
     /*  710937 */     GIR_EraseRootFromParent_Done,
     /*  710938 */   // Label 11231: @710938
     /*  710938 */   GIM_Try, /*On fail goto*//*Label 11232*/ GIMT_Encode4(711013), // Rule ID 11521 //
     /*  710943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  710954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  710957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  710960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710989 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711011 */     GIR_RootConstrainSelectedInstOperands,
     /*  711012 */     // GIR_Coverage, 11521,
     /*  711012 */     GIR_EraseRootFromParent_Done,
     /*  711013 */   // Label 11232: @711013
     /*  711013 */   GIM_Try, /*On fail goto*//*Label 11233*/ GIMT_Encode4(711088), // Rule ID 11524 //
     /*  711018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  711029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  711032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  711035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711064 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711086 */     GIR_RootConstrainSelectedInstOperands,
     /*  711087 */     // GIR_Coverage, 11524,
     /*  711087 */     GIR_EraseRootFromParent_Done,
     /*  711088 */   // Label 11233: @711088
     /*  711088 */   GIM_Try, /*On fail goto*//*Label 11234*/ GIMT_Encode4(711163), // Rule ID 11525 //
     /*  711093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  711104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  711107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  711110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711139 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711161 */     GIR_RootConstrainSelectedInstOperands,
     /*  711162 */     // GIR_Coverage, 11525,
     /*  711162 */     GIR_EraseRootFromParent_Done,
     /*  711163 */   // Label 11234: @711163
     /*  711163 */   GIM_Try, /*On fail goto*//*Label 11235*/ GIMT_Encode4(711238), // Rule ID 11528 //
     /*  711168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  711179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  711182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  711185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711214 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711236 */     GIR_RootConstrainSelectedInstOperands,
     /*  711237 */     // GIR_Coverage, 11528,
     /*  711237 */     GIR_EraseRootFromParent_Done,
     /*  711238 */   // Label 11235: @711238
     /*  711238 */   GIM_Try, /*On fail goto*//*Label 11236*/ GIMT_Encode4(711313), // Rule ID 11529 //
     /*  711243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  711254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  711257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  711260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711289 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711311 */     GIR_RootConstrainSelectedInstOperands,
     /*  711312 */     // GIR_Coverage, 11529,
     /*  711312 */     GIR_EraseRootFromParent_Done,
     /*  711313 */   // Label 11236: @711313
     /*  711313 */   GIM_Try, /*On fail goto*//*Label 11237*/ GIMT_Encode4(711388), // Rule ID 11532 //
     /*  711318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  711329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  711332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  711335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711364 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  711364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711386 */     GIR_RootConstrainSelectedInstOperands,
     /*  711387 */     // GIR_Coverage, 11532,
     /*  711387 */     GIR_EraseRootFromParent_Done,
     /*  711388 */   // Label 11237: @711388
     /*  711388 */   GIM_Try, /*On fail goto*//*Label 11238*/ GIMT_Encode4(711463), // Rule ID 11533 //
     /*  711393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  711404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  711407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  711410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711439 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711461 */     GIR_RootConstrainSelectedInstOperands,
     /*  711462 */     // GIR_Coverage, 11533,
     /*  711462 */     GIR_EraseRootFromParent_Done,
     /*  711463 */   // Label 11238: @711463
     /*  711463 */   GIM_Try, /*On fail goto*//*Label 11239*/ GIMT_Encode4(711538), // Rule ID 11536 //
     /*  711468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  711479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  711482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  711485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711514 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  711517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711536 */     GIR_RootConstrainSelectedInstOperands,
     /*  711537 */     // GIR_Coverage, 11536,
     /*  711537 */     GIR_EraseRootFromParent_Done,
     /*  711538 */   // Label 11239: @711538
     /*  711538 */   GIM_Try, /*On fail goto*//*Label 11240*/ GIMT_Encode4(711613), // Rule ID 11537 //
     /*  711543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  711554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  711557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  711560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711589 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  711592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711611 */     GIR_RootConstrainSelectedInstOperands,
     /*  711612 */     // GIR_Coverage, 11537,
     /*  711612 */     GIR_EraseRootFromParent_Done,
     /*  711613 */   // Label 11240: @711613
     /*  711613 */   GIM_Try, /*On fail goto*//*Label 11241*/ GIMT_Encode4(711688), // Rule ID 11540 //
     /*  711618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  711629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  711632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  711635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711664 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  711667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711686 */     GIR_RootConstrainSelectedInstOperands,
     /*  711687 */     // GIR_Coverage, 11540,
     /*  711687 */     GIR_EraseRootFromParent_Done,
     /*  711688 */   // Label 11241: @711688
     /*  711688 */   GIM_Try, /*On fail goto*//*Label 11242*/ GIMT_Encode4(711763), // Rule ID 11541 //
     /*  711693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  711704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  711707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  711710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711739 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  711742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711761 */     GIR_RootConstrainSelectedInstOperands,
     /*  711762 */     // GIR_Coverage, 11541,
     /*  711762 */     GIR_EraseRootFromParent_Done,
     /*  711763 */   // Label 11242: @711763
     /*  711763 */   GIM_Try, /*On fail goto*//*Label 11243*/ GIMT_Encode4(711838), // Rule ID 11544 //
     /*  711768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  711779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  711782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  711785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711814 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  711817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711836 */     GIR_RootConstrainSelectedInstOperands,
     /*  711837 */     // GIR_Coverage, 11544,
     /*  711837 */     GIR_EraseRootFromParent_Done,
     /*  711838 */   // Label 11243: @711838
     /*  711838 */   GIM_Try, /*On fail goto*//*Label 11244*/ GIMT_Encode4(711913), // Rule ID 11545 //
     /*  711843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  711854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  711857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  711860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711889 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  711892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711911 */     GIR_RootConstrainSelectedInstOperands,
     /*  711912 */     // GIR_Coverage, 11545,
     /*  711912 */     GIR_EraseRootFromParent_Done,
     /*  711913 */   // Label 11244: @711913
     /*  711913 */   GIM_Try, /*On fail goto*//*Label 11245*/ GIMT_Encode4(711988), // Rule ID 11548 //
     /*  711918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  711929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  711932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  711935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  711967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711986 */     GIR_RootConstrainSelectedInstOperands,
     /*  711987 */     // GIR_Coverage, 11548,
     /*  711987 */     GIR_EraseRootFromParent_Done,
     /*  711988 */   // Label 11245: @711988
     /*  711988 */   GIM_Try, /*On fail goto*//*Label 11246*/ GIMT_Encode4(712063), // Rule ID 11549 //
     /*  711993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  712004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  712007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  712010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712039 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712061 */     GIR_RootConstrainSelectedInstOperands,
     /*  712062 */     // GIR_Coverage, 11549,
     /*  712062 */     GIR_EraseRootFromParent_Done,
     /*  712063 */   // Label 11246: @712063
     /*  712063 */   GIM_Try, /*On fail goto*//*Label 11247*/ GIMT_Encode4(712138), // Rule ID 11552 //
     /*  712068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  712079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  712082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  712085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712114 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712136 */     GIR_RootConstrainSelectedInstOperands,
     /*  712137 */     // GIR_Coverage, 11552,
     /*  712137 */     GIR_EraseRootFromParent_Done,
     /*  712138 */   // Label 11247: @712138
     /*  712138 */   GIM_Try, /*On fail goto*//*Label 11248*/ GIMT_Encode4(712213), // Rule ID 11553 //
     /*  712143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  712154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  712157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  712160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712189 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712211 */     GIR_RootConstrainSelectedInstOperands,
     /*  712212 */     // GIR_Coverage, 11553,
     /*  712212 */     GIR_EraseRootFromParent_Done,
     /*  712213 */   // Label 11248: @712213
     /*  712213 */   GIM_Try, /*On fail goto*//*Label 11249*/ GIMT_Encode4(712288), // Rule ID 11556 //
     /*  712218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  712229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  712232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  712235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712264 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712286 */     GIR_RootConstrainSelectedInstOperands,
     /*  712287 */     // GIR_Coverage, 11556,
     /*  712287 */     GIR_EraseRootFromParent_Done,
     /*  712288 */   // Label 11249: @712288
     /*  712288 */   GIM_Try, /*On fail goto*//*Label 11250*/ GIMT_Encode4(712363), // Rule ID 11557 //
     /*  712293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  712304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  712307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  712310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712339 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712361 */     GIR_RootConstrainSelectedInstOperands,
     /*  712362 */     // GIR_Coverage, 11557,
     /*  712362 */     GIR_EraseRootFromParent_Done,
     /*  712363 */   // Label 11250: @712363
     /*  712363 */   GIM_Try, /*On fail goto*//*Label 11251*/ GIMT_Encode4(712438), // Rule ID 11560 //
     /*  712368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  712379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  712382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  712385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712436 */     GIR_RootConstrainSelectedInstOperands,
     /*  712437 */     // GIR_Coverage, 11560,
     /*  712437 */     GIR_EraseRootFromParent_Done,
     /*  712438 */   // Label 11251: @712438
     /*  712438 */   GIM_Try, /*On fail goto*//*Label 11252*/ GIMT_Encode4(712513), // Rule ID 11561 //
     /*  712443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  712454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  712457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  712460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712511 */     GIR_RootConstrainSelectedInstOperands,
     /*  712512 */     // GIR_Coverage, 11561,
     /*  712512 */     GIR_EraseRootFromParent_Done,
     /*  712513 */   // Label 11252: @712513
     /*  712513 */   GIM_Try, /*On fail goto*//*Label 11253*/ GIMT_Encode4(712588), // Rule ID 11564 //
     /*  712518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  712529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  712532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  712535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712564 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712586 */     GIR_RootConstrainSelectedInstOperands,
     /*  712587 */     // GIR_Coverage, 11564,
     /*  712587 */     GIR_EraseRootFromParent_Done,
     /*  712588 */   // Label 11253: @712588
     /*  712588 */   GIM_Try, /*On fail goto*//*Label 11254*/ GIMT_Encode4(712663), // Rule ID 11565 //
     /*  712593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  712604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  712607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  712610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712639 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712661 */     GIR_RootConstrainSelectedInstOperands,
     /*  712662 */     // GIR_Coverage, 11565,
     /*  712662 */     GIR_EraseRootFromParent_Done,
     /*  712663 */   // Label 11254: @712663
     /*  712663 */   GIM_Try, /*On fail goto*//*Label 11255*/ GIMT_Encode4(712738), // Rule ID 11568 //
     /*  712668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  712679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  712682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  712685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712714 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712736 */     GIR_RootConstrainSelectedInstOperands,
     /*  712737 */     // GIR_Coverage, 11568,
     /*  712737 */     GIR_EraseRootFromParent_Done,
     /*  712738 */   // Label 11255: @712738
     /*  712738 */   GIM_Try, /*On fail goto*//*Label 11256*/ GIMT_Encode4(712813), // Rule ID 11569 //
     /*  712743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  712754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  712757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  712760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712789 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712811 */     GIR_RootConstrainSelectedInstOperands,
     /*  712812 */     // GIR_Coverage, 11569,
     /*  712812 */     GIR_EraseRootFromParent_Done,
     /*  712813 */   // Label 11256: @712813
     /*  712813 */   GIM_Try, /*On fail goto*//*Label 11257*/ GIMT_Encode4(712888), // Rule ID 11572 //
     /*  712818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  712821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  712829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  712832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  712835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  712838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712864 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  712864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  712867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  712883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712886 */     GIR_RootConstrainSelectedInstOperands,
     /*  712887 */     // GIR_Coverage, 11572,
     /*  712887 */     GIR_EraseRootFromParent_Done,
     /*  712888 */   // Label 11257: @712888
     /*  712888 */   GIM_Try, /*On fail goto*//*Label 11258*/ GIMT_Encode4(712963), // Rule ID 11573 //
     /*  712893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  712896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  712904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  712907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  712910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  712913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712939 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  712939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  712942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  712958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712961 */     GIR_RootConstrainSelectedInstOperands,
     /*  712962 */     // GIR_Coverage, 11573,
     /*  712962 */     GIR_EraseRootFromParent_Done,
     /*  712963 */   // Label 11258: @712963
     /*  712963 */   GIM_Try, /*On fail goto*//*Label 11259*/ GIMT_Encode4(713038), // Rule ID 11576 //
     /*  712968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  712971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  712979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  712982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  712985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  712988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  713017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713036 */     GIR_RootConstrainSelectedInstOperands,
     /*  713037 */     // GIR_Coverage, 11576,
     /*  713037 */     GIR_EraseRootFromParent_Done,
     /*  713038 */   // Label 11259: @713038
     /*  713038 */   GIM_Try, /*On fail goto*//*Label 11260*/ GIMT_Encode4(713113), // Rule ID 11577 //
     /*  713043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  713063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713089 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  713092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713111 */     GIR_RootConstrainSelectedInstOperands,
     /*  713112 */     // GIR_Coverage, 11577,
     /*  713112 */     GIR_EraseRootFromParent_Done,
     /*  713113 */   // Label 11260: @713113
     /*  713113 */   GIM_Try, /*On fail goto*//*Label 11261*/ GIMT_Encode4(713188), // Rule ID 11580 //
     /*  713118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  713138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713164 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  713167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713186 */     GIR_RootConstrainSelectedInstOperands,
     /*  713187 */     // GIR_Coverage, 11580,
     /*  713187 */     GIR_EraseRootFromParent_Done,
     /*  713188 */   // Label 11261: @713188
     /*  713188 */   GIM_Try, /*On fail goto*//*Label 11262*/ GIMT_Encode4(713263), // Rule ID 11581 //
     /*  713193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  713213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713239 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  713242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713261 */     GIR_RootConstrainSelectedInstOperands,
     /*  713262 */     // GIR_Coverage, 11581,
     /*  713262 */     GIR_EraseRootFromParent_Done,
     /*  713263 */   // Label 11262: @713263
     /*  713263 */   GIM_Try, /*On fail goto*//*Label 11263*/ GIMT_Encode4(713338), // Rule ID 11584 //
     /*  713268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  713288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713314 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  713317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713336 */     GIR_RootConstrainSelectedInstOperands,
     /*  713337 */     // GIR_Coverage, 11584,
     /*  713337 */     GIR_EraseRootFromParent_Done,
     /*  713338 */   // Label 11263: @713338
     /*  713338 */   GIM_Try, /*On fail goto*//*Label 11264*/ GIMT_Encode4(713413), // Rule ID 11585 //
     /*  713343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  713363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713389 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  713392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713411 */     GIR_RootConstrainSelectedInstOperands,
     /*  713412 */     // GIR_Coverage, 11585,
     /*  713412 */     GIR_EraseRootFromParent_Done,
     /*  713413 */   // Label 11264: @713413
     /*  713413 */   GIM_Try, /*On fail goto*//*Label 11265*/ GIMT_Encode4(713488), // Rule ID 11588 //
     /*  713418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713464 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  713467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713486 */     GIR_RootConstrainSelectedInstOperands,
     /*  713487 */     // GIR_Coverage, 11588,
     /*  713487 */     GIR_EraseRootFromParent_Done,
     /*  713488 */   // Label 11265: @713488
     /*  713488 */   GIM_Try, /*On fail goto*//*Label 11266*/ GIMT_Encode4(713563), // Rule ID 11589 //
     /*  713493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713539 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  713542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713561 */     GIR_RootConstrainSelectedInstOperands,
     /*  713562 */     // GIR_Coverage, 11589,
     /*  713562 */     GIR_EraseRootFromParent_Done,
     /*  713563 */   // Label 11266: @713563
     /*  713563 */   GIM_Try, /*On fail goto*//*Label 11267*/ GIMT_Encode4(713638), // Rule ID 11592 //
     /*  713568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713614 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  713617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713636 */     GIR_RootConstrainSelectedInstOperands,
     /*  713637 */     // GIR_Coverage, 11592,
     /*  713637 */     GIR_EraseRootFromParent_Done,
     /*  713638 */   // Label 11267: @713638
     /*  713638 */   GIM_Try, /*On fail goto*//*Label 11268*/ GIMT_Encode4(713713), // Rule ID 11593 //
     /*  713643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  713692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713711 */     GIR_RootConstrainSelectedInstOperands,
     /*  713712 */     // GIR_Coverage, 11593,
     /*  713712 */     GIR_EraseRootFromParent_Done,
     /*  713713 */   // Label 11268: @713713
     /*  713713 */   GIM_Try, /*On fail goto*//*Label 11269*/ GIMT_Encode4(713788), // Rule ID 11596 //
     /*  713718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713764 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  713767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713786 */     GIR_RootConstrainSelectedInstOperands,
     /*  713787 */     // GIR_Coverage, 11596,
     /*  713787 */     GIR_EraseRootFromParent_Done,
     /*  713788 */   // Label 11269: @713788
     /*  713788 */   GIM_Try, /*On fail goto*//*Label 11270*/ GIMT_Encode4(713863), // Rule ID 11597 //
     /*  713793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713839 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  713842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713861 */     GIR_RootConstrainSelectedInstOperands,
     /*  713862 */     // GIR_Coverage, 11597,
     /*  713862 */     GIR_EraseRootFromParent_Done,
     /*  713863 */   // Label 11270: @713863
     /*  713863 */   GIM_Try, /*On fail goto*//*Label 11271*/ GIMT_Encode4(713938), // Rule ID 11600 //
     /*  713868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713914 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  713917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713936 */     GIR_RootConstrainSelectedInstOperands,
     /*  713937 */     // GIR_Coverage, 11600,
     /*  713937 */     GIR_EraseRootFromParent_Done,
     /*  713938 */   // Label 11271: @713938
     /*  713938 */   GIM_Try, /*On fail goto*//*Label 11272*/ GIMT_Encode4(714013), // Rule ID 11601 //
     /*  713943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713989 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  713992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714011 */     GIR_RootConstrainSelectedInstOperands,
     /*  714012 */     // GIR_Coverage, 11601,
     /*  714012 */     GIR_EraseRootFromParent_Done,
     /*  714013 */   // Label 11272: @714013
     /*  714013 */   GIM_Try, /*On fail goto*//*Label 11273*/ GIMT_Encode4(714088), // Rule ID 11604 //
     /*  714018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714064 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  714067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714086 */     GIR_RootConstrainSelectedInstOperands,
     /*  714087 */     // GIR_Coverage, 11604,
     /*  714087 */     GIR_EraseRootFromParent_Done,
     /*  714088 */   // Label 11273: @714088
     /*  714088 */   GIM_Try, /*On fail goto*//*Label 11274*/ GIMT_Encode4(714163), // Rule ID 11605 //
     /*  714093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714139 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  714142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714161 */     GIR_RootConstrainSelectedInstOperands,
     /*  714162 */     // GIR_Coverage, 11605,
     /*  714162 */     GIR_EraseRootFromParent_Done,
     /*  714163 */   // Label 11274: @714163
     /*  714163 */   GIM_Try, /*On fail goto*//*Label 11275*/ GIMT_Encode4(714238), // Rule ID 11608 //
     /*  714168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  714188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  714217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714236 */     GIR_RootConstrainSelectedInstOperands,
     /*  714237 */     // GIR_Coverage, 11608,
     /*  714237 */     GIR_EraseRootFromParent_Done,
     /*  714238 */   // Label 11275: @714238
     /*  714238 */   GIM_Try, /*On fail goto*//*Label 11276*/ GIMT_Encode4(714313), // Rule ID 11609 //
     /*  714243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  714263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  714292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714311 */     GIR_RootConstrainSelectedInstOperands,
     /*  714312 */     // GIR_Coverage, 11609,
     /*  714312 */     GIR_EraseRootFromParent_Done,
     /*  714313 */   // Label 11276: @714313
     /*  714313 */   GIM_Try, /*On fail goto*//*Label 11277*/ GIMT_Encode4(714388), // Rule ID 11612 //
     /*  714318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  714338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  714367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714386 */     GIR_RootConstrainSelectedInstOperands,
     /*  714387 */     // GIR_Coverage, 11612,
     /*  714387 */     GIR_EraseRootFromParent_Done,
     /*  714388 */   // Label 11277: @714388
     /*  714388 */   GIM_Try, /*On fail goto*//*Label 11278*/ GIMT_Encode4(714463), // Rule ID 11613 //
     /*  714393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  714413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714439 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  714442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714461 */     GIR_RootConstrainSelectedInstOperands,
     /*  714462 */     // GIR_Coverage, 11613,
     /*  714462 */     GIR_EraseRootFromParent_Done,
     /*  714463 */   // Label 11278: @714463
     /*  714463 */   GIM_Try, /*On fail goto*//*Label 11279*/ GIMT_Encode4(714538), // Rule ID 11616 //
     /*  714468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  714479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  714482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  714488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714514 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  714517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714536 */     GIR_RootConstrainSelectedInstOperands,
     /*  714537 */     // GIR_Coverage, 11616,
     /*  714537 */     GIR_EraseRootFromParent_Done,
     /*  714538 */   // Label 11279: @714538
     /*  714538 */   GIM_Try, /*On fail goto*//*Label 11280*/ GIMT_Encode4(714613), // Rule ID 11617 //
     /*  714543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  714554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  714557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  714563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714589 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  714592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714611 */     GIR_RootConstrainSelectedInstOperands,
     /*  714612 */     // GIR_Coverage, 11617,
     /*  714612 */     GIR_EraseRootFromParent_Done,
     /*  714613 */   // Label 11280: @714613
     /*  714613 */   GIM_Try, /*On fail goto*//*Label 11281*/ GIMT_Encode4(714688), // Rule ID 11620 //
     /*  714618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714664 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  714667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714686 */     GIR_RootConstrainSelectedInstOperands,
     /*  714687 */     // GIR_Coverage, 11620,
     /*  714687 */     GIR_EraseRootFromParent_Done,
     /*  714688 */   // Label 11281: @714688
     /*  714688 */   GIM_Try, /*On fail goto*//*Label 11282*/ GIMT_Encode4(714763), // Rule ID 11621 //
     /*  714693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714739 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  714742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714761 */     GIR_RootConstrainSelectedInstOperands,
     /*  714762 */     // GIR_Coverage, 11621,
     /*  714762 */     GIR_EraseRootFromParent_Done,
     /*  714763 */   // Label 11282: @714763
     /*  714763 */   GIM_Try, /*On fail goto*//*Label 11283*/ GIMT_Encode4(714838), // Rule ID 11624 //
     /*  714768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  714817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714836 */     GIR_RootConstrainSelectedInstOperands,
     /*  714837 */     // GIR_Coverage, 11624,
     /*  714837 */     GIR_EraseRootFromParent_Done,
     /*  714838 */   // Label 11283: @714838
     /*  714838 */   GIM_Try, /*On fail goto*//*Label 11284*/ GIMT_Encode4(714913), // Rule ID 11625 //
     /*  714843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714889 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  714892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714911 */     GIR_RootConstrainSelectedInstOperands,
     /*  714912 */     // GIR_Coverage, 11625,
     /*  714912 */     GIR_EraseRootFromParent_Done,
     /*  714913 */   // Label 11284: @714913
     /*  714913 */   GIM_Try, /*On fail goto*//*Label 11285*/ GIMT_Encode4(714988), // Rule ID 11628 //
     /*  714918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714964 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  714967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714986 */     GIR_RootConstrainSelectedInstOperands,
     /*  714987 */     // GIR_Coverage, 11628,
     /*  714987 */     GIR_EraseRootFromParent_Done,
     /*  714988 */   // Label 11285: @714988
     /*  714988 */   GIM_Try, /*On fail goto*//*Label 11286*/ GIMT_Encode4(715063), // Rule ID 11629 //
     /*  714993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715039 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  715042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715061 */     GIR_RootConstrainSelectedInstOperands,
     /*  715062 */     // GIR_Coverage, 11629,
     /*  715062 */     GIR_EraseRootFromParent_Done,
     /*  715063 */   // Label 11286: @715063
     /*  715063 */   GIM_Try, /*On fail goto*//*Label 11287*/ GIMT_Encode4(715138), // Rule ID 11632 //
     /*  715068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  715117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715136 */     GIR_RootConstrainSelectedInstOperands,
     /*  715137 */     // GIR_Coverage, 11632,
     /*  715137 */     GIR_EraseRootFromParent_Done,
     /*  715138 */   // Label 11287: @715138
     /*  715138 */   GIM_Try, /*On fail goto*//*Label 11288*/ GIMT_Encode4(715213), // Rule ID 11633 //
     /*  715143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715189 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  715192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715211 */     GIR_RootConstrainSelectedInstOperands,
     /*  715212 */     // GIR_Coverage, 11633,
     /*  715212 */     GIR_EraseRootFromParent_Done,
     /*  715213 */   // Label 11288: @715213
     /*  715213 */   GIM_Try, /*On fail goto*//*Label 11289*/ GIMT_Encode4(715288), // Rule ID 11636 //
     /*  715218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  715238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715264 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  715267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715286 */     GIR_RootConstrainSelectedInstOperands,
     /*  715287 */     // GIR_Coverage, 11636,
     /*  715287 */     GIR_EraseRootFromParent_Done,
     /*  715288 */   // Label 11289: @715288
     /*  715288 */   GIM_Try, /*On fail goto*//*Label 11290*/ GIMT_Encode4(715363), // Rule ID 11637 //
     /*  715293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  715313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715339 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  715342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715361 */     GIR_RootConstrainSelectedInstOperands,
     /*  715362 */     // GIR_Coverage, 11637,
     /*  715362 */     GIR_EraseRootFromParent_Done,
     /*  715363 */   // Label 11290: @715363
     /*  715363 */   GIM_Try, /*On fail goto*//*Label 11291*/ GIMT_Encode4(715438), // Rule ID 11640 //
     /*  715368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  715388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  715417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715436 */     GIR_RootConstrainSelectedInstOperands,
     /*  715437 */     // GIR_Coverage, 11640,
     /*  715437 */     GIR_EraseRootFromParent_Done,
     /*  715438 */   // Label 11291: @715438
     /*  715438 */   GIM_Try, /*On fail goto*//*Label 11292*/ GIMT_Encode4(715513), // Rule ID 11641 //
     /*  715443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  715463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715489 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  715492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715511 */     GIR_RootConstrainSelectedInstOperands,
     /*  715512 */     // GIR_Coverage, 11641,
     /*  715512 */     GIR_EraseRootFromParent_Done,
     /*  715513 */   // Label 11292: @715513
     /*  715513 */   GIM_Try, /*On fail goto*//*Label 11293*/ GIMT_Encode4(715588), // Rule ID 11644 //
     /*  715518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  715538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715564 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  715567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715586 */     GIR_RootConstrainSelectedInstOperands,
     /*  715587 */     // GIR_Coverage, 11644,
     /*  715587 */     GIR_EraseRootFromParent_Done,
     /*  715588 */   // Label 11293: @715588
     /*  715588 */   GIM_Try, /*On fail goto*//*Label 11294*/ GIMT_Encode4(715663), // Rule ID 11645 //
     /*  715593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  715613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715639 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  715642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715661 */     GIR_RootConstrainSelectedInstOperands,
     /*  715662 */     // GIR_Coverage, 11645,
     /*  715662 */     GIR_EraseRootFromParent_Done,
     /*  715663 */   // Label 11294: @715663
     /*  715663 */   GIM_Try, /*On fail goto*//*Label 11295*/ GIMT_Encode4(715738), // Rule ID 11648 //
     /*  715668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  715688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715714 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  715717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715736 */     GIR_RootConstrainSelectedInstOperands,
     /*  715737 */     // GIR_Coverage, 11648,
     /*  715737 */     GIR_EraseRootFromParent_Done,
     /*  715738 */   // Label 11295: @715738
     /*  715738 */   GIM_Try, /*On fail goto*//*Label 11296*/ GIMT_Encode4(715813), // Rule ID 11649 //
     /*  715743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  715763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715789 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  715792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715811 */     GIR_RootConstrainSelectedInstOperands,
     /*  715812 */     // GIR_Coverage, 11649,
     /*  715812 */     GIR_EraseRootFromParent_Done,
     /*  715813 */   // Label 11296: @715813
     /*  715813 */   GIM_Try, /*On fail goto*//*Label 11297*/ GIMT_Encode4(715888), // Rule ID 11652 //
     /*  715818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715864 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715886 */     GIR_RootConstrainSelectedInstOperands,
     /*  715887 */     // GIR_Coverage, 11652,
     /*  715887 */     GIR_EraseRootFromParent_Done,
     /*  715888 */   // Label 11297: @715888
     /*  715888 */   GIM_Try, /*On fail goto*//*Label 11298*/ GIMT_Encode4(715963), // Rule ID 11653 //
     /*  715893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715939 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715961 */     GIR_RootConstrainSelectedInstOperands,
     /*  715962 */     // GIR_Coverage, 11653,
     /*  715962 */     GIR_EraseRootFromParent_Done,
     /*  715963 */   // Label 11298: @715963
     /*  715963 */   GIM_Try, /*On fail goto*//*Label 11299*/ GIMT_Encode4(716038), // Rule ID 11656 //
     /*  715968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  716017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716036 */     GIR_RootConstrainSelectedInstOperands,
     /*  716037 */     // GIR_Coverage, 11656,
     /*  716037 */     GIR_EraseRootFromParent_Done,
     /*  716038 */   // Label 11299: @716038
     /*  716038 */   GIM_Try, /*On fail goto*//*Label 11300*/ GIMT_Encode4(716113), // Rule ID 11657 //
     /*  716043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  716054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  716057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  716060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716089 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  716092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716111 */     GIR_RootConstrainSelectedInstOperands,
     /*  716112 */     // GIR_Coverage, 11657,
     /*  716112 */     GIR_EraseRootFromParent_Done,
     /*  716113 */   // Label 11300: @716113
     /*  716113 */   GIM_Try, /*On fail goto*//*Label 11301*/ GIMT_Encode4(716188), // Rule ID 11660 //
     /*  716118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  716129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  716132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  716135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716164 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716186 */     GIR_RootConstrainSelectedInstOperands,
     /*  716187 */     // GIR_Coverage, 11660,
     /*  716187 */     GIR_EraseRootFromParent_Done,
     /*  716188 */   // Label 11301: @716188
     /*  716188 */   GIM_Try, /*On fail goto*//*Label 11302*/ GIMT_Encode4(716263), // Rule ID 11661 //
     /*  716193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  716204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  716207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  716210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716239 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716261 */     GIR_RootConstrainSelectedInstOperands,
     /*  716262 */     // GIR_Coverage, 11661,
     /*  716262 */     GIR_EraseRootFromParent_Done,
     /*  716263 */   // Label 11302: @716263
     /*  716263 */   GIM_Try, /*On fail goto*//*Label 11303*/ GIMT_Encode4(716338), // Rule ID 11664 //
     /*  716268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  716279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  716282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  716285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716314 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716336 */     GIR_RootConstrainSelectedInstOperands,
     /*  716337 */     // GIR_Coverage, 11664,
     /*  716337 */     GIR_EraseRootFromParent_Done,
     /*  716338 */   // Label 11303: @716338
     /*  716338 */   GIM_Try, /*On fail goto*//*Label 11304*/ GIMT_Encode4(716413), // Rule ID 11665 //
     /*  716343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  716354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  716357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  716360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716389 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716411 */     GIR_RootConstrainSelectedInstOperands,
     /*  716412 */     // GIR_Coverage, 11665,
     /*  716412 */     GIR_EraseRootFromParent_Done,
     /*  716413 */   // Label 11304: @716413
     /*  716413 */   GIM_Try, /*On fail goto*//*Label 11305*/ GIMT_Encode4(716488), // Rule ID 11668 //
     /*  716418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  716429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  716432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  716435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  716438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716464 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  716467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716486 */     GIR_RootConstrainSelectedInstOperands,
     /*  716487 */     // GIR_Coverage, 11668,
     /*  716487 */     GIR_EraseRootFromParent_Done,
     /*  716488 */   // Label 11305: @716488
     /*  716488 */   GIM_Try, /*On fail goto*//*Label 11306*/ GIMT_Encode4(716563), // Rule ID 11669 //
     /*  716493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  716504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  716507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  716510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  716513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716539 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  716542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716561 */     GIR_RootConstrainSelectedInstOperands,
     /*  716562 */     // GIR_Coverage, 11669,
     /*  716562 */     GIR_EraseRootFromParent_Done,
     /*  716563 */   // Label 11306: @716563
     /*  716563 */   GIM_Try, /*On fail goto*//*Label 11307*/ GIMT_Encode4(716638), // Rule ID 11672 //
     /*  716568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  716579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  716582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  716585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  716588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716614 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  716617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716636 */     GIR_RootConstrainSelectedInstOperands,
     /*  716637 */     // GIR_Coverage, 11672,
     /*  716637 */     GIR_EraseRootFromParent_Done,
     /*  716638 */   // Label 11307: @716638
     /*  716638 */   GIM_Try, /*On fail goto*//*Label 11308*/ GIMT_Encode4(716713), // Rule ID 11673 //
     /*  716643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  716654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  716657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  716660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  716663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716689 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  716692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716711 */     GIR_RootConstrainSelectedInstOperands,
     /*  716712 */     // GIR_Coverage, 11673,
     /*  716712 */     GIR_EraseRootFromParent_Done,
     /*  716713 */   // Label 11308: @716713
     /*  716713 */   GIM_Try, /*On fail goto*//*Label 11309*/ GIMT_Encode4(716788), // Rule ID 11676 //
     /*  716718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  716729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  716732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  716735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  716738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716764 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  716767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716786 */     GIR_RootConstrainSelectedInstOperands,
     /*  716787 */     // GIR_Coverage, 11676,
     /*  716787 */     GIR_EraseRootFromParent_Done,
     /*  716788 */   // Label 11309: @716788
     /*  716788 */   GIM_Try, /*On fail goto*//*Label 11310*/ GIMT_Encode4(716863), // Rule ID 11677 //
     /*  716793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  716804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  716807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  716810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  716813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716839 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  716842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716861 */     GIR_RootConstrainSelectedInstOperands,
     /*  716862 */     // GIR_Coverage, 11677,
     /*  716862 */     GIR_EraseRootFromParent_Done,
     /*  716863 */   // Label 11310: @716863
     /*  716863 */   GIM_Try, /*On fail goto*//*Label 11311*/ GIMT_Encode4(716938), // Rule ID 11680 //
     /*  716868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  716879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  716882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  716885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  716888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716914 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  716914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  716917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716936 */     GIR_RootConstrainSelectedInstOperands,
     /*  716937 */     // GIR_Coverage, 11680,
     /*  716937 */     GIR_EraseRootFromParent_Done,
     /*  716938 */   // Label 11311: @716938
     /*  716938 */   GIM_Try, /*On fail goto*//*Label 11312*/ GIMT_Encode4(717013), // Rule ID 11681 //
     /*  716943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  716954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  716957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  716960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  716963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716989 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  716989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  716992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717011 */     GIR_RootConstrainSelectedInstOperands,
     /*  717012 */     // GIR_Coverage, 11681,
     /*  717012 */     GIR_EraseRootFromParent_Done,
     /*  717013 */   // Label 11312: @717013
     /*  717013 */   GIM_Try, /*On fail goto*//*Label 11313*/ GIMT_Encode4(717088), // Rule ID 11684 //
     /*  717018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  717029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  717032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  717035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  717038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717064 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  717067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717086 */     GIR_RootConstrainSelectedInstOperands,
     /*  717087 */     // GIR_Coverage, 11684,
     /*  717087 */     GIR_EraseRootFromParent_Done,
     /*  717088 */   // Label 11313: @717088
     /*  717088 */   GIM_Try, /*On fail goto*//*Label 11314*/ GIMT_Encode4(717163), // Rule ID 11685 //
     /*  717093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  717104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  717107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  717110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  717113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717139 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  717139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  717142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717161 */     GIR_RootConstrainSelectedInstOperands,
     /*  717162 */     // GIR_Coverage, 11685,
     /*  717162 */     GIR_EraseRootFromParent_Done,
     /*  717163 */   // Label 11314: @717163
     /*  717163 */   GIM_Try, /*On fail goto*//*Label 11315*/ GIMT_Encode4(717238), // Rule ID 11688 //
     /*  717168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  717179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  717182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  717185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  717188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717214 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  717214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  717217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717236 */     GIR_RootConstrainSelectedInstOperands,
     /*  717237 */     // GIR_Coverage, 11688,
     /*  717237 */     GIR_EraseRootFromParent_Done,
     /*  717238 */   // Label 11315: @717238
     /*  717238 */   GIM_Try, /*On fail goto*//*Label 11316*/ GIMT_Encode4(717313), // Rule ID 11689 //
     /*  717243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  717254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  717257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  717260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  717263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717289 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  717289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  717292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717311 */     GIR_RootConstrainSelectedInstOperands,
     /*  717312 */     // GIR_Coverage, 11689,
     /*  717312 */     GIR_EraseRootFromParent_Done,
     /*  717313 */   // Label 11316: @717313
     /*  717313 */   GIM_Try, /*On fail goto*//*Label 11317*/ GIMT_Encode4(717388), // Rule ID 11692 //
     /*  717318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  717329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  717332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  717335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  717338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717364 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  717364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  717367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717386 */     GIR_RootConstrainSelectedInstOperands,
     /*  717387 */     // GIR_Coverage, 11692,
     /*  717387 */     GIR_EraseRootFromParent_Done,
     /*  717388 */   // Label 11317: @717388
     /*  717388 */   GIM_Try, /*On fail goto*//*Label 11318*/ GIMT_Encode4(717463), // Rule ID 11693 //
     /*  717393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  717404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  717407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  717410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  717413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717439 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  717439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  717442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717461 */     GIR_RootConstrainSelectedInstOperands,
     /*  717462 */     // GIR_Coverage, 11693,
     /*  717462 */     GIR_EraseRootFromParent_Done,
     /*  717463 */   // Label 11318: @717463
     /*  717463 */   GIM_Try, /*On fail goto*//*Label 11319*/ GIMT_Encode4(717538), // Rule ID 11696 //
     /*  717468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  717479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  717482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  717485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  717488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717514 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  717517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717536 */     GIR_RootConstrainSelectedInstOperands,
     /*  717537 */     // GIR_Coverage, 11696,
     /*  717537 */     GIR_EraseRootFromParent_Done,
     /*  717538 */   // Label 11319: @717538
     /*  717538 */   GIM_Try, /*On fail goto*//*Label 11320*/ GIMT_Encode4(717613), // Rule ID 11697 //
     /*  717543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  717554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  717557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  717560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  717563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717589 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  717589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  717592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717611 */     GIR_RootConstrainSelectedInstOperands,
     /*  717612 */     // GIR_Coverage, 11697,
     /*  717612 */     GIR_EraseRootFromParent_Done,
     /*  717613 */   // Label 11320: @717613
     /*  717613 */   GIM_Try, /*On fail goto*//*Label 11321*/ GIMT_Encode4(717688), // Rule ID 11700 //
     /*  717618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  717629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  717632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  717635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  717638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717664 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  717664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  717667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717686 */     GIR_RootConstrainSelectedInstOperands,
     /*  717687 */     // GIR_Coverage, 11700,
     /*  717687 */     GIR_EraseRootFromParent_Done,
     /*  717688 */   // Label 11321: @717688
     /*  717688 */   GIM_Try, /*On fail goto*//*Label 11322*/ GIMT_Encode4(717763), // Rule ID 11701 //
     /*  717693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  717704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  717707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  717710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  717713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717739 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  717739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  717742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717761 */     GIR_RootConstrainSelectedInstOperands,
     /*  717762 */     // GIR_Coverage, 11701,
     /*  717762 */     GIR_EraseRootFromParent_Done,
     /*  717763 */   // Label 11322: @717763
     /*  717763 */   GIM_Try, /*On fail goto*//*Label 11323*/ GIMT_Encode4(717838), // Rule ID 11704 //
     /*  717768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  717771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  717788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717814 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  717817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717836 */     GIR_RootConstrainSelectedInstOperands,
     /*  717837 */     // GIR_Coverage, 11704,
     /*  717837 */     GIR_EraseRootFromParent_Done,
     /*  717838 */   // Label 11323: @717838
     /*  717838 */   GIM_Try, /*On fail goto*//*Label 11324*/ GIMT_Encode4(717913), // Rule ID 11705 //
     /*  717843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  717846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  717863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717889 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  717892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717911 */     GIR_RootConstrainSelectedInstOperands,
     /*  717912 */     // GIR_Coverage, 11705,
     /*  717912 */     GIR_EraseRootFromParent_Done,
     /*  717913 */   // Label 11324: @717913
     /*  717913 */   GIM_Try, /*On fail goto*//*Label 11325*/ GIMT_Encode4(717988), // Rule ID 11708 //
     /*  717918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  717929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  717932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  717935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  717938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717964 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  717964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  717967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717986 */     GIR_RootConstrainSelectedInstOperands,
     /*  717987 */     // GIR_Coverage, 11708,
     /*  717987 */     GIR_EraseRootFromParent_Done,
     /*  717988 */   // Label 11325: @717988
     /*  717988 */   GIM_Try, /*On fail goto*//*Label 11326*/ GIMT_Encode4(718063), // Rule ID 11709 //
     /*  717993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  718004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  718007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  718010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  718013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718039 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  718042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718061 */     GIR_RootConstrainSelectedInstOperands,
     /*  718062 */     // GIR_Coverage, 11709,
     /*  718062 */     GIR_EraseRootFromParent_Done,
     /*  718063 */   // Label 11326: @718063
     /*  718063 */   GIM_Try, /*On fail goto*//*Label 11327*/ GIMT_Encode4(718138), // Rule ID 11712 //
     /*  718068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  718079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  718082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  718085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  718088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718114 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  718114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  718117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718136 */     GIR_RootConstrainSelectedInstOperands,
     /*  718137 */     // GIR_Coverage, 11712,
     /*  718137 */     GIR_EraseRootFromParent_Done,
     /*  718138 */   // Label 11327: @718138
     /*  718138 */   GIM_Try, /*On fail goto*//*Label 11328*/ GIMT_Encode4(718213), // Rule ID 11713 //
     /*  718143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  718154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  718157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  718160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  718163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718189 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  718192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718211 */     GIR_RootConstrainSelectedInstOperands,
     /*  718212 */     // GIR_Coverage, 11713,
     /*  718212 */     GIR_EraseRootFromParent_Done,
     /*  718213 */   // Label 11328: @718213
     /*  718213 */   GIM_Try, /*On fail goto*//*Label 11329*/ GIMT_Encode4(718288), // Rule ID 11716 //
     /*  718218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  718229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  718232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  718235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  718238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718264 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  718264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  718267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718286 */     GIR_RootConstrainSelectedInstOperands,
     /*  718287 */     // GIR_Coverage, 11716,
     /*  718287 */     GIR_EraseRootFromParent_Done,
     /*  718288 */   // Label 11329: @718288
     /*  718288 */   GIM_Try, /*On fail goto*//*Label 11330*/ GIMT_Encode4(718363), // Rule ID 11717 //
     /*  718293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  718304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  718307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  718310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  718313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718339 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  718342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718361 */     GIR_RootConstrainSelectedInstOperands,
     /*  718362 */     // GIR_Coverage, 11717,
     /*  718362 */     GIR_EraseRootFromParent_Done,
     /*  718363 */   // Label 11330: @718363
     /*  718363 */   GIM_Try, /*On fail goto*//*Label 11331*/ GIMT_Encode4(718438), // Rule ID 11720 //
     /*  718368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  718379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  718382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  718385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  718388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718414 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  718414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  718417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718436 */     GIR_RootConstrainSelectedInstOperands,
     /*  718437 */     // GIR_Coverage, 11720,
     /*  718437 */     GIR_EraseRootFromParent_Done,
     /*  718438 */   // Label 11331: @718438
     /*  718438 */   GIM_Try, /*On fail goto*//*Label 11332*/ GIMT_Encode4(718513), // Rule ID 11721 //
     /*  718443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  718454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  718457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  718460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  718463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718489 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  718489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  718492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718511 */     GIR_RootConstrainSelectedInstOperands,
     /*  718512 */     // GIR_Coverage, 11721,
     /*  718512 */     GIR_EraseRootFromParent_Done,
     /*  718513 */   // Label 11332: @718513
     /*  718513 */   GIM_Try, /*On fail goto*//*Label 11333*/ GIMT_Encode4(718588), // Rule ID 11724 //
     /*  718518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  718529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  718532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  718535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  718538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718564 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  718564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  718567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718586 */     GIR_RootConstrainSelectedInstOperands,
     /*  718587 */     // GIR_Coverage, 11724,
     /*  718587 */     GIR_EraseRootFromParent_Done,
     /*  718588 */   // Label 11333: @718588
     /*  718588 */   GIM_Try, /*On fail goto*//*Label 11334*/ GIMT_Encode4(718663), // Rule ID 11725 //
     /*  718593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  718604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  718607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  718610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  718613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718639 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  718639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  718642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718661 */     GIR_RootConstrainSelectedInstOperands,
     /*  718662 */     // GIR_Coverage, 11725,
     /*  718662 */     GIR_EraseRootFromParent_Done,
     /*  718663 */   // Label 11334: @718663
     /*  718663 */   GIM_Try, /*On fail goto*//*Label 11335*/ GIMT_Encode4(718738), // Rule ID 11728 //
     /*  718668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  718679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  718682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  718685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  718688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718714 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  718714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  718717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718736 */     GIR_RootConstrainSelectedInstOperands,
     /*  718737 */     // GIR_Coverage, 11728,
     /*  718737 */     GIR_EraseRootFromParent_Done,
     /*  718738 */   // Label 11335: @718738
     /*  718738 */   GIM_Try, /*On fail goto*//*Label 11336*/ GIMT_Encode4(718813), // Rule ID 11729 //
     /*  718743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  718754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  718757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  718760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  718763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718789 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  718789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  718792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718811 */     GIR_RootConstrainSelectedInstOperands,
     /*  718812 */     // GIR_Coverage, 11729,
     /*  718812 */     GIR_EraseRootFromParent_Done,
     /*  718813 */   // Label 11336: @718813
     /*  718813 */   GIM_Try, /*On fail goto*//*Label 11337*/ GIMT_Encode4(718888), // Rule ID 11732 //
     /*  718818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  718829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  718832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  718835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  718838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  718864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  718867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718886 */     GIR_RootConstrainSelectedInstOperands,
     /*  718887 */     // GIR_Coverage, 11732,
     /*  718887 */     GIR_EraseRootFromParent_Done,
     /*  718888 */   // Label 11337: @718888
     /*  718888 */   GIM_Try, /*On fail goto*//*Label 11338*/ GIMT_Encode4(718963), // Rule ID 11733 //
     /*  718893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  718904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  718907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  718910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  718913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718939 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  718939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  718942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718961 */     GIR_RootConstrainSelectedInstOperands,
     /*  718962 */     // GIR_Coverage, 11733,
     /*  718962 */     GIR_EraseRootFromParent_Done,
     /*  718963 */   // Label 11338: @718963
     /*  718963 */   GIM_Try, /*On fail goto*//*Label 11339*/ GIMT_Encode4(719038), // Rule ID 11736 //
     /*  718968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  718979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  718982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  718985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  718988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719014 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  719014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  719017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719036 */     GIR_RootConstrainSelectedInstOperands,
     /*  719037 */     // GIR_Coverage, 11736,
     /*  719037 */     GIR_EraseRootFromParent_Done,
     /*  719038 */   // Label 11339: @719038
     /*  719038 */   GIM_Try, /*On fail goto*//*Label 11340*/ GIMT_Encode4(719113), // Rule ID 11737 //
     /*  719043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  719054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  719057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  719060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  719063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719089 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  719089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  719092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719111 */     GIR_RootConstrainSelectedInstOperands,
     /*  719112 */     // GIR_Coverage, 11737,
     /*  719112 */     GIR_EraseRootFromParent_Done,
     /*  719113 */   // Label 11340: @719113
     /*  719113 */   GIM_Try, /*On fail goto*//*Label 11341*/ GIMT_Encode4(719188), // Rule ID 11740 //
     /*  719118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  719129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  719132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  719135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  719138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719164 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  719164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  719167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719186 */     GIR_RootConstrainSelectedInstOperands,
     /*  719187 */     // GIR_Coverage, 11740,
     /*  719187 */     GIR_EraseRootFromParent_Done,
     /*  719188 */   // Label 11341: @719188
     /*  719188 */   GIM_Try, /*On fail goto*//*Label 11342*/ GIMT_Encode4(719263), // Rule ID 11741 //
     /*  719193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  719204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  719207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  719210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  719213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719239 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  719239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  719242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719261 */     GIR_RootConstrainSelectedInstOperands,
     /*  719262 */     // GIR_Coverage, 11741,
     /*  719262 */     GIR_EraseRootFromParent_Done,
     /*  719263 */   // Label 11342: @719263
     /*  719263 */   GIM_Try, /*On fail goto*//*Label 11343*/ GIMT_Encode4(719338), // Rule ID 11744 //
     /*  719268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  719271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  719288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  719317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719336 */     GIR_RootConstrainSelectedInstOperands,
     /*  719337 */     // GIR_Coverage, 11744,
     /*  719337 */     GIR_EraseRootFromParent_Done,
     /*  719338 */   // Label 11343: @719338
     /*  719338 */   GIM_Try, /*On fail goto*//*Label 11344*/ GIMT_Encode4(719413), // Rule ID 11745 //
     /*  719343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  719346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  719363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719389 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  719392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719411 */     GIR_RootConstrainSelectedInstOperands,
     /*  719412 */     // GIR_Coverage, 11745,
     /*  719412 */     GIR_EraseRootFromParent_Done,
     /*  719413 */   // Label 11344: @719413
     /*  719413 */   GIM_Try, /*On fail goto*//*Label 11345*/ GIMT_Encode4(719488), // Rule ID 11748 //
     /*  719418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  719421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  719438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719464 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  719467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719486 */     GIR_RootConstrainSelectedInstOperands,
     /*  719487 */     // GIR_Coverage, 11748,
     /*  719487 */     GIR_EraseRootFromParent_Done,
     /*  719488 */   // Label 11345: @719488
     /*  719488 */   GIM_Try, /*On fail goto*//*Label 11346*/ GIMT_Encode4(719563), // Rule ID 11749 //
     /*  719493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  719496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  719513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719539 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  719542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719561 */     GIR_RootConstrainSelectedInstOperands,
     /*  719562 */     // GIR_Coverage, 11749,
     /*  719562 */     GIR_EraseRootFromParent_Done,
     /*  719563 */   // Label 11346: @719563
     /*  719563 */   GIM_Try, /*On fail goto*//*Label 11347*/ GIMT_Encode4(719638), // Rule ID 11752 //
     /*  719568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  719571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  719579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  719582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  719585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  719588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719614 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  719617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719636 */     GIR_RootConstrainSelectedInstOperands,
     /*  719637 */     // GIR_Coverage, 11752,
     /*  719637 */     GIR_EraseRootFromParent_Done,
     /*  719638 */   // Label 11347: @719638
     /*  719638 */   GIM_Try, /*On fail goto*//*Label 11348*/ GIMT_Encode4(719713), // Rule ID 11753 //
     /*  719643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  719646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  719654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  719657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  719660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  719663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719689 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  719692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719711 */     GIR_RootConstrainSelectedInstOperands,
     /*  719712 */     // GIR_Coverage, 11753,
     /*  719712 */     GIR_EraseRootFromParent_Done,
     /*  719713 */   // Label 11348: @719713
     /*  719713 */   GIM_Try, /*On fail goto*//*Label 11349*/ GIMT_Encode4(719788), // Rule ID 11756 //
     /*  719718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  719729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  719732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  719735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719764 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  719764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  719767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719786 */     GIR_RootConstrainSelectedInstOperands,
     /*  719787 */     // GIR_Coverage, 11756,
     /*  719787 */     GIR_EraseRootFromParent_Done,
     /*  719788 */   // Label 11349: @719788
     /*  719788 */   GIM_Try, /*On fail goto*//*Label 11350*/ GIMT_Encode4(719863), // Rule ID 11757 //
     /*  719793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  719804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  719807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  719810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  719813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719839 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  719839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  719842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719861 */     GIR_RootConstrainSelectedInstOperands,
     /*  719862 */     // GIR_Coverage, 11757,
     /*  719862 */     GIR_EraseRootFromParent_Done,
     /*  719863 */   // Label 11350: @719863
     /*  719863 */   GIM_Try, /*On fail goto*//*Label 11351*/ GIMT_Encode4(719938), // Rule ID 11760 //
     /*  719868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  719879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  719882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  719885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719914 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  719914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  719917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719936 */     GIR_RootConstrainSelectedInstOperands,
     /*  719937 */     // GIR_Coverage, 11760,
     /*  719937 */     GIR_EraseRootFromParent_Done,
     /*  719938 */   // Label 11351: @719938
     /*  719938 */   GIM_Try, /*On fail goto*//*Label 11352*/ GIMT_Encode4(720013), // Rule ID 11761 //
     /*  719943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  719954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  719957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  719960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  719963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719989 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  719989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  719992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720011 */     GIR_RootConstrainSelectedInstOperands,
     /*  720012 */     // GIR_Coverage, 11761,
     /*  720012 */     GIR_EraseRootFromParent_Done,
     /*  720013 */   // Label 11352: @720013
     /*  720013 */   GIM_Try, /*On fail goto*//*Label 11353*/ GIMT_Encode4(720088), // Rule ID 11764 //
     /*  720018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  720029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  720032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  720035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720064 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  720067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720086 */     GIR_RootConstrainSelectedInstOperands,
     /*  720087 */     // GIR_Coverage, 11764,
     /*  720087 */     GIR_EraseRootFromParent_Done,
     /*  720088 */   // Label 11353: @720088
     /*  720088 */   GIM_Try, /*On fail goto*//*Label 11354*/ GIMT_Encode4(720163), // Rule ID 11765 //
     /*  720093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  720104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  720107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  720110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720139 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  720142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720161 */     GIR_RootConstrainSelectedInstOperands,
     /*  720162 */     // GIR_Coverage, 11765,
     /*  720162 */     GIR_EraseRootFromParent_Done,
     /*  720163 */   // Label 11354: @720163
     /*  720163 */   GIM_Try, /*On fail goto*//*Label 11355*/ GIMT_Encode4(720238), // Rule ID 11768 //
     /*  720168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  720179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  720182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  720185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  720217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720236 */     GIR_RootConstrainSelectedInstOperands,
     /*  720237 */     // GIR_Coverage, 11768,
     /*  720237 */     GIR_EraseRootFromParent_Done,
     /*  720238 */   // Label 11355: @720238
     /*  720238 */   GIM_Try, /*On fail goto*//*Label 11356*/ GIMT_Encode4(720313), // Rule ID 11769 //
     /*  720243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  720254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  720257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  720260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720289 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  720292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720311 */     GIR_RootConstrainSelectedInstOperands,
     /*  720312 */     // GIR_Coverage, 11769,
     /*  720312 */     GIR_EraseRootFromParent_Done,
     /*  720313 */   // Label 11356: @720313
     /*  720313 */   GIM_Try, /*On fail goto*//*Label 11357*/ GIMT_Encode4(720388), // Rule ID 11772 //
     /*  720318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  720329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  720332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  720335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720364 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  720367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720386 */     GIR_RootConstrainSelectedInstOperands,
     /*  720387 */     // GIR_Coverage, 11772,
     /*  720387 */     GIR_EraseRootFromParent_Done,
     /*  720388 */   // Label 11357: @720388
     /*  720388 */   GIM_Try, /*On fail goto*//*Label 11358*/ GIMT_Encode4(720463), // Rule ID 11773 //
     /*  720393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  720404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  720407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  720410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720439 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  720442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720461 */     GIR_RootConstrainSelectedInstOperands,
     /*  720462 */     // GIR_Coverage, 11773,
     /*  720462 */     GIR_EraseRootFromParent_Done,
     /*  720463 */   // Label 11358: @720463
     /*  720463 */   GIM_Try, /*On fail goto*//*Label 11359*/ GIMT_Encode4(720538), // Rule ID 11776 //
     /*  720468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  720479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  720482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  720485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720514 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  720514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  720517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720536 */     GIR_RootConstrainSelectedInstOperands,
     /*  720537 */     // GIR_Coverage, 11776,
     /*  720537 */     GIR_EraseRootFromParent_Done,
     /*  720538 */   // Label 11359: @720538
     /*  720538 */   GIM_Try, /*On fail goto*//*Label 11360*/ GIMT_Encode4(720613), // Rule ID 11777 //
     /*  720543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  720554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  720557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  720560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720589 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  720589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  720592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720611 */     GIR_RootConstrainSelectedInstOperands,
     /*  720612 */     // GIR_Coverage, 11777,
     /*  720612 */     GIR_EraseRootFromParent_Done,
     /*  720613 */   // Label 11360: @720613
     /*  720613 */   GIM_Try, /*On fail goto*//*Label 11361*/ GIMT_Encode4(720688), // Rule ID 11780 //
     /*  720618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  720629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  720632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  720635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720664 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  720667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720686 */     GIR_RootConstrainSelectedInstOperands,
     /*  720687 */     // GIR_Coverage, 11780,
     /*  720687 */     GIR_EraseRootFromParent_Done,
     /*  720688 */   // Label 11361: @720688
     /*  720688 */   GIM_Try, /*On fail goto*//*Label 11362*/ GIMT_Encode4(720763), // Rule ID 11781 //
     /*  720693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  720704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  720707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  720710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720739 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  720742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720761 */     GIR_RootConstrainSelectedInstOperands,
     /*  720762 */     // GIR_Coverage, 11781,
     /*  720762 */     GIR_EraseRootFromParent_Done,
     /*  720763 */   // Label 11362: @720763
     /*  720763 */   GIM_Try, /*On fail goto*//*Label 11363*/ GIMT_Encode4(720838), // Rule ID 11784 //
     /*  720768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  720779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  720782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  720785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720814 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  720817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720836 */     GIR_RootConstrainSelectedInstOperands,
     /*  720837 */     // GIR_Coverage, 11784,
     /*  720837 */     GIR_EraseRootFromParent_Done,
     /*  720838 */   // Label 11363: @720838
     /*  720838 */   GIM_Try, /*On fail goto*//*Label 11364*/ GIMT_Encode4(720913), // Rule ID 11785 //
     /*  720843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  720854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  720857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  720860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720889 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  720892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720911 */     GIR_RootConstrainSelectedInstOperands,
     /*  720912 */     // GIR_Coverage, 11785,
     /*  720912 */     GIR_EraseRootFromParent_Done,
     /*  720913 */   // Label 11364: @720913
     /*  720913 */   GIM_Try, /*On fail goto*//*Label 11365*/ GIMT_Encode4(720988), // Rule ID 11788 //
     /*  720918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  720929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  720932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  720935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720964 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  720964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  720967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720986 */     GIR_RootConstrainSelectedInstOperands,
     /*  720987 */     // GIR_Coverage, 11788,
     /*  720987 */     GIR_EraseRootFromParent_Done,
     /*  720988 */   // Label 11365: @720988
     /*  720988 */   GIM_Try, /*On fail goto*//*Label 11366*/ GIMT_Encode4(721063), // Rule ID 11789 //
     /*  720993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  721004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  721007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  721010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721039 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  721039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  721042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721061 */     GIR_RootConstrainSelectedInstOperands,
     /*  721062 */     // GIR_Coverage, 11789,
     /*  721062 */     GIR_EraseRootFromParent_Done,
     /*  721063 */   // Label 11366: @721063
     /*  721063 */   GIM_Try, /*On fail goto*//*Label 11367*/ GIMT_Encode4(721138), // Rule ID 11792 //
     /*  721068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  721071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  721085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721114 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  721114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  721117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721136 */     GIR_RootConstrainSelectedInstOperands,
     /*  721137 */     // GIR_Coverage, 11792,
     /*  721137 */     GIR_EraseRootFromParent_Done,
     /*  721138 */   // Label 11367: @721138
     /*  721138 */   GIM_Try, /*On fail goto*//*Label 11368*/ GIMT_Encode4(721213), // Rule ID 11793 //
     /*  721143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  721146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  721160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721189 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  721189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  721192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721211 */     GIR_RootConstrainSelectedInstOperands,
     /*  721212 */     // GIR_Coverage, 11793,
     /*  721212 */     GIR_EraseRootFromParent_Done,
     /*  721213 */   // Label 11368: @721213
     /*  721213 */   GIM_Try, /*On fail goto*//*Label 11369*/ GIMT_Encode4(721288), // Rule ID 11796 //
     /*  721218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  721229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  721232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  721235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721264 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  721267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721286 */     GIR_RootConstrainSelectedInstOperands,
     /*  721287 */     // GIR_Coverage, 11796,
     /*  721287 */     GIR_EraseRootFromParent_Done,
     /*  721288 */   // Label 11369: @721288
     /*  721288 */   GIM_Try, /*On fail goto*//*Label 11370*/ GIMT_Encode4(721363), // Rule ID 11797 //
     /*  721293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  721304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  721307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  721310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721339 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  721342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721361 */     GIR_RootConstrainSelectedInstOperands,
     /*  721362 */     // GIR_Coverage, 11797,
     /*  721362 */     GIR_EraseRootFromParent_Done,
     /*  721363 */   // Label 11370: @721363
     /*  721363 */   GIM_Try, /*On fail goto*//*Label 11371*/ GIMT_Encode4(721438), // Rule ID 11800 //
     /*  721368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  721379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  721382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  721385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721414 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  721417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721436 */     GIR_RootConstrainSelectedInstOperands,
     /*  721437 */     // GIR_Coverage, 11800,
     /*  721437 */     GIR_EraseRootFromParent_Done,
     /*  721438 */   // Label 11371: @721438
     /*  721438 */   GIM_Try, /*On fail goto*//*Label 11372*/ GIMT_Encode4(721513), // Rule ID 11801 //
     /*  721443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  721454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  721457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  721460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721489 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  721492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721511 */     GIR_RootConstrainSelectedInstOperands,
     /*  721512 */     // GIR_Coverage, 11801,
     /*  721512 */     GIR_EraseRootFromParent_Done,
     /*  721513 */   // Label 11372: @721513
     /*  721513 */   GIM_Try, /*On fail goto*//*Label 11373*/ GIMT_Encode4(721588), // Rule ID 11804 //
     /*  721518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  721529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  721532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  721535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721564 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  721567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721586 */     GIR_RootConstrainSelectedInstOperands,
     /*  721587 */     // GIR_Coverage, 11804,
     /*  721587 */     GIR_EraseRootFromParent_Done,
     /*  721588 */   // Label 11373: @721588
     /*  721588 */   GIM_Try, /*On fail goto*//*Label 11374*/ GIMT_Encode4(721663), // Rule ID 11805 //
     /*  721593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  721604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  721607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  721610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721639 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  721642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721661 */     GIR_RootConstrainSelectedInstOperands,
     /*  721662 */     // GIR_Coverage, 11805,
     /*  721662 */     GIR_EraseRootFromParent_Done,
     /*  721663 */   // Label 11374: @721663
     /*  721663 */   GIM_Try, /*On fail goto*//*Label 11375*/ GIMT_Encode4(721738), // Rule ID 11808 //
     /*  721668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  721679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  721682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  721685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  721714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  721717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721736 */     GIR_RootConstrainSelectedInstOperands,
     /*  721737 */     // GIR_Coverage, 11808,
     /*  721737 */     GIR_EraseRootFromParent_Done,
     /*  721738 */   // Label 11375: @721738
     /*  721738 */   GIM_Try, /*On fail goto*//*Label 11376*/ GIMT_Encode4(721813), // Rule ID 11809 //
     /*  721743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  721754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  721757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  721760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721789 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  721789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  721792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721811 */     GIR_RootConstrainSelectedInstOperands,
     /*  721812 */     // GIR_Coverage, 11809,
     /*  721812 */     GIR_EraseRootFromParent_Done,
     /*  721813 */   // Label 11376: @721813
     /*  721813 */   GIM_Try, /*On fail goto*//*Label 11377*/ GIMT_Encode4(721888), // Rule ID 11812 //
     /*  721818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  721829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  721832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  721835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721864 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  721864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  721867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721886 */     GIR_RootConstrainSelectedInstOperands,
     /*  721887 */     // GIR_Coverage, 11812,
     /*  721887 */     GIR_EraseRootFromParent_Done,
     /*  721888 */   // Label 11377: @721888
     /*  721888 */   GIM_Try, /*On fail goto*//*Label 11378*/ GIMT_Encode4(721963), // Rule ID 11813 //
     /*  721893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  721904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  721907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  721910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721939 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  721939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  721942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721961 */     GIR_RootConstrainSelectedInstOperands,
     /*  721962 */     // GIR_Coverage, 11813,
     /*  721962 */     GIR_EraseRootFromParent_Done,
     /*  721963 */   // Label 11378: @721963
     /*  721963 */   GIM_Try, /*On fail goto*//*Label 11379*/ GIMT_Encode4(722038), // Rule ID 11816 //
     /*  721968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  721979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  721982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  721985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722014 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  722017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722036 */     GIR_RootConstrainSelectedInstOperands,
     /*  722037 */     // GIR_Coverage, 11816,
     /*  722037 */     GIR_EraseRootFromParent_Done,
     /*  722038 */   // Label 11379: @722038
     /*  722038 */   GIM_Try, /*On fail goto*//*Label 11380*/ GIMT_Encode4(722113), // Rule ID 11817 //
     /*  722043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  722054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  722057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  722060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722089 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  722092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722111 */     GIR_RootConstrainSelectedInstOperands,
     /*  722112 */     // GIR_Coverage, 11817,
     /*  722112 */     GIR_EraseRootFromParent_Done,
     /*  722113 */   // Label 11380: @722113
     /*  722113 */   GIM_Try, /*On fail goto*//*Label 11381*/ GIMT_Encode4(722188), // Rule ID 11820 //
     /*  722118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  722129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  722132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  722135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  722167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722186 */     GIR_RootConstrainSelectedInstOperands,
     /*  722187 */     // GIR_Coverage, 11820,
     /*  722187 */     GIR_EraseRootFromParent_Done,
     /*  722188 */   // Label 11381: @722188
     /*  722188 */   GIM_Try, /*On fail goto*//*Label 11382*/ GIMT_Encode4(722263), // Rule ID 11821 //
     /*  722193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  722204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  722207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  722210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  722242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722261 */     GIR_RootConstrainSelectedInstOperands,
     /*  722262 */     // GIR_Coverage, 11821,
     /*  722262 */     GIR_EraseRootFromParent_Done,
     /*  722263 */   // Label 11382: @722263
     /*  722263 */   GIM_Try, /*On fail goto*//*Label 11383*/ GIMT_Encode4(722338), // Rule ID 11824 //
     /*  722268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  722279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  722282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  722285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  722317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722336 */     GIR_RootConstrainSelectedInstOperands,
     /*  722337 */     // GIR_Coverage, 11824,
     /*  722337 */     GIR_EraseRootFromParent_Done,
     /*  722338 */   // Label 11383: @722338
     /*  722338 */   GIM_Try, /*On fail goto*//*Label 11384*/ GIMT_Encode4(722413), // Rule ID 11825 //
     /*  722343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  722354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  722357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  722360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722389 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  722392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722411 */     GIR_RootConstrainSelectedInstOperands,
     /*  722412 */     // GIR_Coverage, 11825,
     /*  722412 */     GIR_EraseRootFromParent_Done,
     /*  722413 */   // Label 11384: @722413
     /*  722413 */   GIM_Try, /*On fail goto*//*Label 11385*/ GIMT_Encode4(722488), // Rule ID 11828 //
     /*  722418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  722429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  722432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  722435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  722467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722486 */     GIR_RootConstrainSelectedInstOperands,
     /*  722487 */     // GIR_Coverage, 11828,
     /*  722487 */     GIR_EraseRootFromParent_Done,
     /*  722488 */   // Label 11385: @722488
     /*  722488 */   GIM_Try, /*On fail goto*//*Label 11386*/ GIMT_Encode4(722563), // Rule ID 11829 //
     /*  722493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  722504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  722507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  722510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722539 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  722542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722561 */     GIR_RootConstrainSelectedInstOperands,
     /*  722562 */     // GIR_Coverage, 11829,
     /*  722562 */     GIR_EraseRootFromParent_Done,
     /*  722563 */   // Label 11386: @722563
     /*  722563 */   GIM_Try, /*On fail goto*//*Label 11387*/ GIMT_Encode4(722638), // Rule ID 11832 //
     /*  722568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  722571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  722579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  722582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  722585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722614 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  722614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  722617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722636 */     GIR_RootConstrainSelectedInstOperands,
     /*  722637 */     // GIR_Coverage, 11832,
     /*  722637 */     GIR_EraseRootFromParent_Done,
     /*  722638 */   // Label 11387: @722638
     /*  722638 */   GIM_Try, /*On fail goto*//*Label 11388*/ GIMT_Encode4(722713), // Rule ID 11833 //
     /*  722643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  722646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  722654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  722657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  722660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  722689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  722692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722711 */     GIR_RootConstrainSelectedInstOperands,
     /*  722712 */     // GIR_Coverage, 11833,
     /*  722712 */     GIR_EraseRootFromParent_Done,
     /*  722713 */   // Label 11388: @722713
     /*  722713 */   GIM_Try, /*On fail goto*//*Label 11389*/ GIMT_Encode4(722788), // Rule ID 11836 //
     /*  722718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  722721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  722729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  722732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  722735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722764 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  722764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  722767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722786 */     GIR_RootConstrainSelectedInstOperands,
     /*  722787 */     // GIR_Coverage, 11836,
     /*  722787 */     GIR_EraseRootFromParent_Done,
     /*  722788 */   // Label 11389: @722788
     /*  722788 */   GIM_Try, /*On fail goto*//*Label 11390*/ GIMT_Encode4(722863), // Rule ID 11837 //
     /*  722793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  722796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  722804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  722807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  722810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722839 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  722839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  722842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722861 */     GIR_RootConstrainSelectedInstOperands,
     /*  722862 */     // GIR_Coverage, 11837,
     /*  722862 */     GIR_EraseRootFromParent_Done,
     /*  722863 */   // Label 11390: @722863
     /*  722863 */   GIM_Try, /*On fail goto*//*Label 11391*/ GIMT_Encode4(722938), // Rule ID 11840 //
     /*  722868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  722871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  722879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  722882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  722885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722914 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  722914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  722917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722936 */     GIR_RootConstrainSelectedInstOperands,
     /*  722937 */     // GIR_Coverage, 11840,
     /*  722937 */     GIR_EraseRootFromParent_Done,
     /*  722938 */   // Label 11391: @722938
     /*  722938 */   GIM_Try, /*On fail goto*//*Label 11392*/ GIMT_Encode4(723013), // Rule ID 11841 //
     /*  722943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  722946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  722954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  722957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  722960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722989 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  722989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  722992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723011 */     GIR_RootConstrainSelectedInstOperands,
     /*  723012 */     // GIR_Coverage, 11841,
     /*  723012 */     GIR_EraseRootFromParent_Done,
     /*  723013 */   // Label 11392: @723013
     /*  723013 */   GIM_Try, /*On fail goto*//*Label 11393*/ GIMT_Encode4(723088), // Rule ID 11844 //
     /*  723018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  723029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  723032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  723035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  723038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723064 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  723067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723086 */     GIR_RootConstrainSelectedInstOperands,
     /*  723087 */     // GIR_Coverage, 11844,
     /*  723087 */     GIR_EraseRootFromParent_Done,
     /*  723088 */   // Label 11393: @723088
     /*  723088 */   GIM_Try, /*On fail goto*//*Label 11394*/ GIMT_Encode4(723163), // Rule ID 11845 //
     /*  723093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  723104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  723107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  723110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  723113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723139 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  723142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723161 */     GIR_RootConstrainSelectedInstOperands,
     /*  723162 */     // GIR_Coverage, 11845,
     /*  723162 */     GIR_EraseRootFromParent_Done,
     /*  723163 */   // Label 11394: @723163
     /*  723163 */   GIM_Try, /*On fail goto*//*Label 11395*/ GIMT_Encode4(723238), // Rule ID 11848 //
     /*  723168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  723179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  723182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  723185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  723188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723214 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  723217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723236 */     GIR_RootConstrainSelectedInstOperands,
     /*  723237 */     // GIR_Coverage, 11848,
     /*  723237 */     GIR_EraseRootFromParent_Done,
     /*  723238 */   // Label 11395: @723238
     /*  723238 */   GIM_Try, /*On fail goto*//*Label 11396*/ GIMT_Encode4(723313), // Rule ID 11849 //
     /*  723243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  723254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  723257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  723260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  723263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723289 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  723292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723311 */     GIR_RootConstrainSelectedInstOperands,
     /*  723312 */     // GIR_Coverage, 11849,
     /*  723312 */     GIR_EraseRootFromParent_Done,
     /*  723313 */   // Label 11396: @723313
     /*  723313 */   GIM_Try, /*On fail goto*//*Label 11397*/ GIMT_Encode4(723388), // Rule ID 11852 //
     /*  723318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  723329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  723332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  723335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  723338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723364 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  723367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723386 */     GIR_RootConstrainSelectedInstOperands,
     /*  723387 */     // GIR_Coverage, 11852,
     /*  723387 */     GIR_EraseRootFromParent_Done,
     /*  723388 */   // Label 11397: @723388
     /*  723388 */   GIM_Try, /*On fail goto*//*Label 11398*/ GIMT_Encode4(723463), // Rule ID 11853 //
     /*  723393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  723404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  723407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  723410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  723413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723439 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  723442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723461 */     GIR_RootConstrainSelectedInstOperands,
     /*  723462 */     // GIR_Coverage, 11853,
     /*  723462 */     GIR_EraseRootFromParent_Done,
     /*  723463 */   // Label 11398: @723463
     /*  723463 */   GIM_Try, /*On fail goto*//*Label 11399*/ GIMT_Encode4(723538), // Rule ID 11856 //
     /*  723468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  723479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  723482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  723485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  723488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723514 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  723514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  723517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723536 */     GIR_RootConstrainSelectedInstOperands,
     /*  723537 */     // GIR_Coverage, 11856,
     /*  723537 */     GIR_EraseRootFromParent_Done,
     /*  723538 */   // Label 11399: @723538
     /*  723538 */   GIM_Try, /*On fail goto*//*Label 11400*/ GIMT_Encode4(723613), // Rule ID 11857 //
     /*  723543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  723554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  723557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  723560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  723563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723589 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  723589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  723592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723611 */     GIR_RootConstrainSelectedInstOperands,
     /*  723612 */     // GIR_Coverage, 11857,
     /*  723612 */     GIR_EraseRootFromParent_Done,
     /*  723613 */   // Label 11400: @723613
     /*  723613 */   GIM_Try, /*On fail goto*//*Label 11401*/ GIMT_Encode4(723688), // Rule ID 11860 //
     /*  723618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  723629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  723632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  723635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  723638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723664 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  723664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  723667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723686 */     GIR_RootConstrainSelectedInstOperands,
     /*  723687 */     // GIR_Coverage, 11860,
     /*  723687 */     GIR_EraseRootFromParent_Done,
     /*  723688 */   // Label 11401: @723688
     /*  723688 */   GIM_Try, /*On fail goto*//*Label 11402*/ GIMT_Encode4(723763), // Rule ID 11861 //
     /*  723693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  723704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  723707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  723710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  723713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723739 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  723739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  723742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723761 */     GIR_RootConstrainSelectedInstOperands,
     /*  723762 */     // GIR_Coverage, 11861,
     /*  723762 */     GIR_EraseRootFromParent_Done,
     /*  723763 */   // Label 11402: @723763
     /*  723763 */   GIM_Try, /*On fail goto*//*Label 11403*/ GIMT_Encode4(723838), // Rule ID 11864 //
     /*  723768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  723779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  723782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  723785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  723788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  723814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  723817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723836 */     GIR_RootConstrainSelectedInstOperands,
     /*  723837 */     // GIR_Coverage, 11864,
     /*  723837 */     GIR_EraseRootFromParent_Done,
     /*  723838 */   // Label 11403: @723838
     /*  723838 */   GIM_Try, /*On fail goto*//*Label 11404*/ GIMT_Encode4(723913), // Rule ID 11865 //
     /*  723843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  723854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  723857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  723860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  723863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723889 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  723889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  723892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723911 */     GIR_RootConstrainSelectedInstOperands,
     /*  723912 */     // GIR_Coverage, 11865,
     /*  723912 */     GIR_EraseRootFromParent_Done,
     /*  723913 */   // Label 11404: @723913
     /*  723913 */   GIM_Try, /*On fail goto*//*Label 11405*/ GIMT_Encode4(723988), // Rule ID 11868 //
     /*  723918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  723929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  723932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  723935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  723938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723964 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  723967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723986 */     GIR_RootConstrainSelectedInstOperands,
     /*  723987 */     // GIR_Coverage, 11868,
     /*  723987 */     GIR_EraseRootFromParent_Done,
     /*  723988 */   // Label 11405: @723988
     /*  723988 */   GIM_Try, /*On fail goto*//*Label 11406*/ GIMT_Encode4(724063), // Rule ID 11869 //
     /*  723993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  724004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  724007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  724010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  724013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724039 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  724042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724061 */     GIR_RootConstrainSelectedInstOperands,
     /*  724062 */     // GIR_Coverage, 11869,
     /*  724062 */     GIR_EraseRootFromParent_Done,
     /*  724063 */   // Label 11406: @724063
     /*  724063 */   GIM_Try, /*On fail goto*//*Label 11407*/ GIMT_Encode4(724138), // Rule ID 11872 //
     /*  724068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  724079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  724082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  724085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  724088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  724117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724136 */     GIR_RootConstrainSelectedInstOperands,
     /*  724137 */     // GIR_Coverage, 11872,
     /*  724137 */     GIR_EraseRootFromParent_Done,
     /*  724138 */   // Label 11407: @724138
     /*  724138 */   GIM_Try, /*On fail goto*//*Label 11408*/ GIMT_Encode4(724213), // Rule ID 11873 //
     /*  724143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  724154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  724157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  724160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  724163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724189 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  724192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724211 */     GIR_RootConstrainSelectedInstOperands,
     /*  724212 */     // GIR_Coverage, 11873,
     /*  724212 */     GIR_EraseRootFromParent_Done,
     /*  724213 */   // Label 11408: @724213
     /*  724213 */   GIM_Try, /*On fail goto*//*Label 11409*/ GIMT_Encode4(724288), // Rule ID 11876 //
     /*  724218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  724235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  724267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724286 */     GIR_RootConstrainSelectedInstOperands,
     /*  724287 */     // GIR_Coverage, 11876,
     /*  724287 */     GIR_EraseRootFromParent_Done,
     /*  724288 */   // Label 11409: @724288
     /*  724288 */   GIM_Try, /*On fail goto*//*Label 11410*/ GIMT_Encode4(724363), // Rule ID 11877 //
     /*  724293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  724310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724339 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  724339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  724342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724361 */     GIR_RootConstrainSelectedInstOperands,
     /*  724362 */     // GIR_Coverage, 11877,
     /*  724362 */     GIR_EraseRootFromParent_Done,
     /*  724363 */   // Label 11410: @724363
     /*  724363 */   GIM_Try, /*On fail goto*//*Label 11411*/ GIMT_Encode4(724438), // Rule ID 11880 //
     /*  724368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  724371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  724385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  724414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  724417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724436 */     GIR_RootConstrainSelectedInstOperands,
     /*  724437 */     // GIR_Coverage, 11880,
     /*  724437 */     GIR_EraseRootFromParent_Done,
     /*  724438 */   // Label 11411: @724438
     /*  724438 */   GIM_Try, /*On fail goto*//*Label 11412*/ GIMT_Encode4(724513), // Rule ID 11881 //
     /*  724443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  724446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  724460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724489 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  724489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  724492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724511 */     GIR_RootConstrainSelectedInstOperands,
     /*  724512 */     // GIR_Coverage, 11881,
     /*  724512 */     GIR_EraseRootFromParent_Done,
     /*  724513 */   // Label 11412: @724513
     /*  724513 */   GIM_Try, /*On fail goto*//*Label 11413*/ GIMT_Encode4(724588), // Rule ID 11884 //
     /*  724518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  724529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  724532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  724535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  724538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724564 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  724567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724586 */     GIR_RootConstrainSelectedInstOperands,
     /*  724587 */     // GIR_Coverage, 11884,
     /*  724587 */     GIR_EraseRootFromParent_Done,
     /*  724588 */   // Label 11413: @724588
     /*  724588 */   GIM_Try, /*On fail goto*//*Label 11414*/ GIMT_Encode4(724663), // Rule ID 11885 //
     /*  724593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  724604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  724607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  724610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  724613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724639 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  724642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724661 */     GIR_RootConstrainSelectedInstOperands,
     /*  724662 */     // GIR_Coverage, 11885,
     /*  724662 */     GIR_EraseRootFromParent_Done,
     /*  724663 */   // Label 11414: @724663
     /*  724663 */   GIM_Try, /*On fail goto*//*Label 11415*/ GIMT_Encode4(724738), // Rule ID 11888 //
     /*  724668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  724679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  724682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  724685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  724688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724714 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  724717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724736 */     GIR_RootConstrainSelectedInstOperands,
     /*  724737 */     // GIR_Coverage, 11888,
     /*  724737 */     GIR_EraseRootFromParent_Done,
     /*  724738 */   // Label 11415: @724738
     /*  724738 */   GIM_Try, /*On fail goto*//*Label 11416*/ GIMT_Encode4(724813), // Rule ID 11889 //
     /*  724743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  724754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  724757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  724760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  724763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724789 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  724792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724811 */     GIR_RootConstrainSelectedInstOperands,
     /*  724812 */     // GIR_Coverage, 11889,
     /*  724812 */     GIR_EraseRootFromParent_Done,
     /*  724813 */   // Label 11416: @724813
     /*  724813 */   GIM_Try, /*On fail goto*//*Label 11417*/ GIMT_Encode4(724888), // Rule ID 11892 //
     /*  724818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  724829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  724832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  724835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  724838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724864 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  724867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724886 */     GIR_RootConstrainSelectedInstOperands,
     /*  724887 */     // GIR_Coverage, 11892,
     /*  724887 */     GIR_EraseRootFromParent_Done,
     /*  724888 */   // Label 11417: @724888
     /*  724888 */   GIM_Try, /*On fail goto*//*Label 11418*/ GIMT_Encode4(724963), // Rule ID 11893 //
     /*  724893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  724904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  724907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  724910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  724913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724939 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  724942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724961 */     GIR_RootConstrainSelectedInstOperands,
     /*  724962 */     // GIR_Coverage, 11893,
     /*  724962 */     GIR_EraseRootFromParent_Done,
     /*  724963 */   // Label 11418: @724963
     /*  724963 */   GIM_Try, /*On fail goto*//*Label 11419*/ GIMT_Encode4(725038), // Rule ID 11896 //
     /*  724968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  724979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  724982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  724985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  724988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  725017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725036 */     GIR_RootConstrainSelectedInstOperands,
     /*  725037 */     // GIR_Coverage, 11896,
     /*  725037 */     GIR_EraseRootFromParent_Done,
     /*  725038 */   // Label 11419: @725038
     /*  725038 */   GIM_Try, /*On fail goto*//*Label 11420*/ GIMT_Encode4(725113), // Rule ID 11897 //
     /*  725043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  725054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  725057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  725060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  725063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  725092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725111 */     GIR_RootConstrainSelectedInstOperands,
     /*  725112 */     // GIR_Coverage, 11897,
     /*  725112 */     GIR_EraseRootFromParent_Done,
     /*  725113 */   // Label 11420: @725113
     /*  725113 */   GIM_Try, /*On fail goto*//*Label 11421*/ GIMT_Encode4(725188), // Rule ID 11900 //
     /*  725118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  725129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  725132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  725135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  725138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725164 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  725167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725186 */     GIR_RootConstrainSelectedInstOperands,
     /*  725187 */     // GIR_Coverage, 11900,
     /*  725187 */     GIR_EraseRootFromParent_Done,
     /*  725188 */   // Label 11421: @725188
     /*  725188 */   GIM_Try, /*On fail goto*//*Label 11422*/ GIMT_Encode4(725263), // Rule ID 11901 //
     /*  725193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  725204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  725207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  725210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  725213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725239 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  725242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725261 */     GIR_RootConstrainSelectedInstOperands,
     /*  725262 */     // GIR_Coverage, 11901,
     /*  725262 */     GIR_EraseRootFromParent_Done,
     /*  725263 */   // Label 11422: @725263
     /*  725263 */   GIM_Try, /*On fail goto*//*Label 11423*/ GIMT_Encode4(725338), // Rule ID 11904 //
     /*  725268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  725279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  725282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  725285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  725288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725314 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  725317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725336 */     GIR_RootConstrainSelectedInstOperands,
     /*  725337 */     // GIR_Coverage, 11904,
     /*  725337 */     GIR_EraseRootFromParent_Done,
     /*  725338 */   // Label 11423: @725338
     /*  725338 */   GIM_Try, /*On fail goto*//*Label 11424*/ GIMT_Encode4(725413), // Rule ID 11905 //
     /*  725343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  725354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  725357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  725360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  725363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725389 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  725392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725411 */     GIR_RootConstrainSelectedInstOperands,
     /*  725412 */     // GIR_Coverage, 11905,
     /*  725412 */     GIR_EraseRootFromParent_Done,
     /*  725413 */   // Label 11424: @725413
     /*  725413 */   GIM_Try, /*On fail goto*//*Label 11425*/ GIMT_Encode4(725488), // Rule ID 11908 //
     /*  725418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  725429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  725432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  725435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  725438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  725464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  725467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725486 */     GIR_RootConstrainSelectedInstOperands,
     /*  725487 */     // GIR_Coverage, 11908,
     /*  725487 */     GIR_EraseRootFromParent_Done,
     /*  725488 */   // Label 11425: @725488
     /*  725488 */   GIM_Try, /*On fail goto*//*Label 11426*/ GIMT_Encode4(725563), // Rule ID 11909 //
     /*  725493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  725504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  725507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  725510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  725513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725539 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  725539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  725542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725561 */     GIR_RootConstrainSelectedInstOperands,
     /*  725562 */     // GIR_Coverage, 11909,
     /*  725562 */     GIR_EraseRootFromParent_Done,
     /*  725563 */   // Label 11426: @725563
     /*  725563 */   GIM_Try, /*On fail goto*//*Label 11427*/ GIMT_Encode4(725638), // Rule ID 11912 //
     /*  725568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  725579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  725582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  725585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  725588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725614 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  725614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  725617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725636 */     GIR_RootConstrainSelectedInstOperands,
     /*  725637 */     // GIR_Coverage, 11912,
     /*  725637 */     GIR_EraseRootFromParent_Done,
     /*  725638 */   // Label 11427: @725638
     /*  725638 */   GIM_Try, /*On fail goto*//*Label 11428*/ GIMT_Encode4(725713), // Rule ID 11913 //
     /*  725643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  725654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  725657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  725660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  725663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725689 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  725689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  725692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725711 */     GIR_RootConstrainSelectedInstOperands,
     /*  725712 */     // GIR_Coverage, 11913,
     /*  725712 */     GIR_EraseRootFromParent_Done,
     /*  725713 */   // Label 11428: @725713
     /*  725713 */   GIM_Try, /*On fail goto*//*Label 11429*/ GIMT_Encode4(725788), // Rule ID 11916 //
     /*  725718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  725729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  725732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  725735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  725738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725764 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  725764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  725767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725786 */     GIR_RootConstrainSelectedInstOperands,
     /*  725787 */     // GIR_Coverage, 11916,
     /*  725787 */     GIR_EraseRootFromParent_Done,
     /*  725788 */   // Label 11429: @725788
     /*  725788 */   GIM_Try, /*On fail goto*//*Label 11430*/ GIMT_Encode4(725863), // Rule ID 11917 //
     /*  725793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  725804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  725807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  725810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  725813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725839 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  725839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  725842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725861 */     GIR_RootConstrainSelectedInstOperands,
     /*  725862 */     // GIR_Coverage, 11917,
     /*  725862 */     GIR_EraseRootFromParent_Done,
     /*  725863 */   // Label 11430: @725863
     /*  725863 */   GIM_Try, /*On fail goto*//*Label 11431*/ GIMT_Encode4(725938), // Rule ID 11920 //
     /*  725868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  725871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  725879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  725882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  725885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  725888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  725914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  725917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  725933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725936 */     GIR_RootConstrainSelectedInstOperands,
     /*  725937 */     // GIR_Coverage, 11920,
     /*  725937 */     GIR_EraseRootFromParent_Done,
     /*  725938 */   // Label 11431: @725938
     /*  725938 */   GIM_Try, /*On fail goto*//*Label 11432*/ GIMT_Encode4(726013), // Rule ID 11921 //
     /*  725943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  725946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  725954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  725957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  725960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  725963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725989 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  725989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  725992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726011 */     GIR_RootConstrainSelectedInstOperands,
     /*  726012 */     // GIR_Coverage, 11921,
     /*  726012 */     GIR_EraseRootFromParent_Done,
     /*  726013 */   // Label 11432: @726013
     /*  726013 */   GIM_Try, /*On fail goto*//*Label 11433*/ GIMT_Encode4(726088), // Rule ID 11924 //
     /*  726018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  726029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  726032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  726035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  726038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  726067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726086 */     GIR_RootConstrainSelectedInstOperands,
     /*  726087 */     // GIR_Coverage, 11924,
     /*  726087 */     GIR_EraseRootFromParent_Done,
     /*  726088 */   // Label 11433: @726088
     /*  726088 */   GIM_Try, /*On fail goto*//*Label 11434*/ GIMT_Encode4(726163), // Rule ID 11925 //
     /*  726093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  726104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  726107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  726110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  726113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726139 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  726142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726161 */     GIR_RootConstrainSelectedInstOperands,
     /*  726162 */     // GIR_Coverage, 11925,
     /*  726162 */     GIR_EraseRootFromParent_Done,
     /*  726163 */   // Label 11434: @726163
     /*  726163 */   GIM_Try, /*On fail goto*//*Label 11435*/ GIMT_Encode4(726238), // Rule ID 11928 //
     /*  726168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  726179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  726182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  726185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  726188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  726217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726236 */     GIR_RootConstrainSelectedInstOperands,
     /*  726237 */     // GIR_Coverage, 11928,
     /*  726237 */     GIR_EraseRootFromParent_Done,
     /*  726238 */   // Label 11435: @726238
     /*  726238 */   GIM_Try, /*On fail goto*//*Label 11436*/ GIMT_Encode4(726313), // Rule ID 11929 //
     /*  726243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  726254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  726257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  726260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  726263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726289 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  726292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726311 */     GIR_RootConstrainSelectedInstOperands,
     /*  726312 */     // GIR_Coverage, 11929,
     /*  726312 */     GIR_EraseRootFromParent_Done,
     /*  726313 */   // Label 11436: @726313
     /*  726313 */   GIM_Try, /*On fail goto*//*Label 11437*/ GIMT_Encode4(726388), // Rule ID 11932 //
     /*  726318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  726329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  726332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  726335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726364 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  726367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726386 */     GIR_RootConstrainSelectedInstOperands,
     /*  726387 */     // GIR_Coverage, 11932,
     /*  726387 */     GIR_EraseRootFromParent_Done,
     /*  726388 */   // Label 11437: @726388
     /*  726388 */   GIM_Try, /*On fail goto*//*Label 11438*/ GIMT_Encode4(726463), // Rule ID 11933 //
     /*  726393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  726404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  726407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  726410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726439 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  726442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726461 */     GIR_RootConstrainSelectedInstOperands,
     /*  726462 */     // GIR_Coverage, 11933,
     /*  726462 */     GIR_EraseRootFromParent_Done,
     /*  726463 */   // Label 11438: @726463
     /*  726463 */   GIM_Try, /*On fail goto*//*Label 11439*/ GIMT_Encode4(726538), // Rule ID 11936 //
     /*  726468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  726479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  726482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  726485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726514 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  726517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726536 */     GIR_RootConstrainSelectedInstOperands,
     /*  726537 */     // GIR_Coverage, 11936,
     /*  726537 */     GIR_EraseRootFromParent_Done,
     /*  726538 */   // Label 11439: @726538
     /*  726538 */   GIM_Try, /*On fail goto*//*Label 11440*/ GIMT_Encode4(726613), // Rule ID 11937 //
     /*  726543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  726554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  726557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  726560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726589 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  726592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726611 */     GIR_RootConstrainSelectedInstOperands,
     /*  726612 */     // GIR_Coverage, 11937,
     /*  726612 */     GIR_EraseRootFromParent_Done,
     /*  726613 */   // Label 11440: @726613
     /*  726613 */   GIM_Try, /*On fail goto*//*Label 11441*/ GIMT_Encode4(726688), // Rule ID 11940 //
     /*  726618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  726629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  726632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  726635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726664 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  726667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726686 */     GIR_RootConstrainSelectedInstOperands,
     /*  726687 */     // GIR_Coverage, 11940,
     /*  726687 */     GIR_EraseRootFromParent_Done,
     /*  726688 */   // Label 11441: @726688
     /*  726688 */   GIM_Try, /*On fail goto*//*Label 11442*/ GIMT_Encode4(726763), // Rule ID 11941 //
     /*  726693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  726704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  726707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  726710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726739 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  726742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726761 */     GIR_RootConstrainSelectedInstOperands,
     /*  726762 */     // GIR_Coverage, 11941,
     /*  726762 */     GIR_EraseRootFromParent_Done,
     /*  726763 */   // Label 11442: @726763
     /*  726763 */   GIM_Try, /*On fail goto*//*Label 11443*/ GIMT_Encode4(726838), // Rule ID 11944 //
     /*  726768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  726779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  726782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  726785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726814 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  726814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  726817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726836 */     GIR_RootConstrainSelectedInstOperands,
     /*  726837 */     // GIR_Coverage, 11944,
     /*  726837 */     GIR_EraseRootFromParent_Done,
     /*  726838 */   // Label 11443: @726838
     /*  726838 */   GIM_Try, /*On fail goto*//*Label 11444*/ GIMT_Encode4(726913), // Rule ID 11945 //
     /*  726843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  726854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  726857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  726860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726889 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  726889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  726892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726911 */     GIR_RootConstrainSelectedInstOperands,
     /*  726912 */     // GIR_Coverage, 11945,
     /*  726912 */     GIR_EraseRootFromParent_Done,
     /*  726913 */   // Label 11444: @726913
     /*  726913 */   GIM_Try, /*On fail goto*//*Label 11445*/ GIMT_Encode4(726988), // Rule ID 11948 //
     /*  726918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  726929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  726932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  726935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  726964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  726967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726986 */     GIR_RootConstrainSelectedInstOperands,
     /*  726987 */     // GIR_Coverage, 11948,
     /*  726987 */     GIR_EraseRootFromParent_Done,
     /*  726988 */   // Label 11445: @726988
     /*  726988 */   GIM_Try, /*On fail goto*//*Label 11446*/ GIMT_Encode4(727063), // Rule ID 11949 //
     /*  726993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  727004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  727007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  727010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727039 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  727042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727061 */     GIR_RootConstrainSelectedInstOperands,
     /*  727062 */     // GIR_Coverage, 11949,
     /*  727062 */     GIR_EraseRootFromParent_Done,
     /*  727063 */   // Label 11446: @727063
     /*  727063 */   GIM_Try, /*On fail goto*//*Label 11447*/ GIMT_Encode4(727138), // Rule ID 11952 //
     /*  727068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  727079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  727082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  727085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727114 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  727114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  727117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727136 */     GIR_RootConstrainSelectedInstOperands,
     /*  727137 */     // GIR_Coverage, 11952,
     /*  727137 */     GIR_EraseRootFromParent_Done,
     /*  727138 */   // Label 11447: @727138
     /*  727138 */   GIM_Try, /*On fail goto*//*Label 11448*/ GIMT_Encode4(727213), // Rule ID 11953 //
     /*  727143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  727154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  727157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  727160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727189 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  727189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  727192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727211 */     GIR_RootConstrainSelectedInstOperands,
     /*  727212 */     // GIR_Coverage, 11953,
     /*  727212 */     GIR_EraseRootFromParent_Done,
     /*  727213 */   // Label 11448: @727213
     /*  727213 */   GIM_Try, /*On fail goto*//*Label 11449*/ GIMT_Encode4(727288), // Rule ID 11956 //
     /*  727218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  727229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  727232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  727235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727264 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  727267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727286 */     GIR_RootConstrainSelectedInstOperands,
     /*  727287 */     // GIR_Coverage, 11956,
     /*  727287 */     GIR_EraseRootFromParent_Done,
     /*  727288 */   // Label 11449: @727288
     /*  727288 */   GIM_Try, /*On fail goto*//*Label 11450*/ GIMT_Encode4(727363), // Rule ID 11957 //
     /*  727293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  727304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  727307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  727310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727339 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  727342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727361 */     GIR_RootConstrainSelectedInstOperands,
     /*  727362 */     // GIR_Coverage, 11957,
     /*  727362 */     GIR_EraseRootFromParent_Done,
     /*  727363 */   // Label 11450: @727363
     /*  727363 */   GIM_Try, /*On fail goto*//*Label 11451*/ GIMT_Encode4(727438), // Rule ID 11960 //
     /*  727368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  727385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727414 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  727417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727436 */     GIR_RootConstrainSelectedInstOperands,
     /*  727437 */     // GIR_Coverage, 11960,
     /*  727437 */     GIR_EraseRootFromParent_Done,
     /*  727438 */   // Label 11451: @727438
     /*  727438 */   GIM_Try, /*On fail goto*//*Label 11452*/ GIMT_Encode4(727513), // Rule ID 11961 //
     /*  727443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  727460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727489 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  727492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727511 */     GIR_RootConstrainSelectedInstOperands,
     /*  727512 */     // GIR_Coverage, 11961,
     /*  727512 */     GIR_EraseRootFromParent_Done,
     /*  727513 */   // Label 11452: @727513
     /*  727513 */   GIM_Try, /*On fail goto*//*Label 11453*/ GIMT_Encode4(727588), // Rule ID 11964 //
     /*  727518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  727535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  727564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  727567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727586 */     GIR_RootConstrainSelectedInstOperands,
     /*  727587 */     // GIR_Coverage, 11964,
     /*  727587 */     GIR_EraseRootFromParent_Done,
     /*  727588 */   // Label 11453: @727588
     /*  727588 */   GIM_Try, /*On fail goto*//*Label 11454*/ GIMT_Encode4(727663), // Rule ID 11965 //
     /*  727593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  727610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727639 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  727639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  727642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727661 */     GIR_RootConstrainSelectedInstOperands,
     /*  727662 */     // GIR_Coverage, 11965,
     /*  727662 */     GIR_EraseRootFromParent_Done,
     /*  727663 */   // Label 11454: @727663
     /*  727663 */   GIM_Try, /*On fail goto*//*Label 11455*/ GIMT_Encode4(727738), // Rule ID 11968 //
     /*  727668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  727671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  727679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  727682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  727685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727714 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  727714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  727717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  727733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727736 */     GIR_RootConstrainSelectedInstOperands,
     /*  727737 */     // GIR_Coverage, 11968,
     /*  727737 */     GIR_EraseRootFromParent_Done,
     /*  727738 */   // Label 11455: @727738
     /*  727738 */   GIM_Try, /*On fail goto*//*Label 11456*/ GIMT_Encode4(727813), // Rule ID 11969 //
     /*  727743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  727746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  727754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  727757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  727760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727789 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  727789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  727792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  727808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727811 */     GIR_RootConstrainSelectedInstOperands,
     /*  727812 */     // GIR_Coverage, 11969,
     /*  727812 */     GIR_EraseRootFromParent_Done,
     /*  727813 */   // Label 11456: @727813
     /*  727813 */   GIM_Try, /*On fail goto*//*Label 11457*/ GIMT_Encode4(727888), // Rule ID 11972 //
     /*  727818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  727829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  727832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  727835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  727867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727886 */     GIR_RootConstrainSelectedInstOperands,
     /*  727887 */     // GIR_Coverage, 11972,
     /*  727887 */     GIR_EraseRootFromParent_Done,
     /*  727888 */   // Label 11457: @727888
     /*  727888 */   GIM_Try, /*On fail goto*//*Label 11458*/ GIMT_Encode4(727963), // Rule ID 11973 //
     /*  727893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  727904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  727907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  727910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727939 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  727942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727961 */     GIR_RootConstrainSelectedInstOperands,
     /*  727962 */     // GIR_Coverage, 11973,
     /*  727962 */     GIR_EraseRootFromParent_Done,
     /*  727963 */   // Label 11458: @727963
     /*  727963 */   GIM_Try, /*On fail goto*//*Label 11459*/ GIMT_Encode4(728038), // Rule ID 11976 //
     /*  727968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  727979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  727982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  727985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728014 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  728017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728036 */     GIR_RootConstrainSelectedInstOperands,
     /*  728037 */     // GIR_Coverage, 11976,
     /*  728037 */     GIR_EraseRootFromParent_Done,
     /*  728038 */   // Label 11459: @728038
     /*  728038 */   GIM_Try, /*On fail goto*//*Label 11460*/ GIMT_Encode4(728113), // Rule ID 11977 //
     /*  728043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  728054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  728057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  728060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728089 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  728092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728111 */     GIR_RootConstrainSelectedInstOperands,
     /*  728112 */     // GIR_Coverage, 11977,
     /*  728112 */     GIR_EraseRootFromParent_Done,
     /*  728113 */   // Label 11460: @728113
     /*  728113 */   GIM_Try, /*On fail goto*//*Label 11461*/ GIMT_Encode4(728188), // Rule ID 11980 //
     /*  728118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  728129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  728132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  728135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728164 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  728167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728186 */     GIR_RootConstrainSelectedInstOperands,
     /*  728187 */     // GIR_Coverage, 11980,
     /*  728187 */     GIR_EraseRootFromParent_Done,
     /*  728188 */   // Label 11461: @728188
     /*  728188 */   GIM_Try, /*On fail goto*//*Label 11462*/ GIMT_Encode4(728263), // Rule ID 11981 //
     /*  728193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  728204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  728207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  728210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728239 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  728242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728261 */     GIR_RootConstrainSelectedInstOperands,
     /*  728262 */     // GIR_Coverage, 11981,
     /*  728262 */     GIR_EraseRootFromParent_Done,
     /*  728263 */   // Label 11462: @728263
     /*  728263 */   GIM_Try, /*On fail goto*//*Label 11463*/ GIMT_Encode4(728338), // Rule ID 11984 //
     /*  728268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  728279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  728282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  728285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  728317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728336 */     GIR_RootConstrainSelectedInstOperands,
     /*  728337 */     // GIR_Coverage, 11984,
     /*  728337 */     GIR_EraseRootFromParent_Done,
     /*  728338 */   // Label 11463: @728338
     /*  728338 */   GIM_Try, /*On fail goto*//*Label 11464*/ GIMT_Encode4(728413), // Rule ID 11985 //
     /*  728343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  728354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  728357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  728360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728389 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  728392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728411 */     GIR_RootConstrainSelectedInstOperands,
     /*  728412 */     // GIR_Coverage, 11985,
     /*  728412 */     GIR_EraseRootFromParent_Done,
     /*  728413 */   // Label 11464: @728413
     /*  728413 */   GIM_Try, /*On fail goto*//*Label 11465*/ GIMT_Encode4(728488), // Rule ID 11988 //
     /*  728418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  728429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  728432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  728435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728464 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  728467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728486 */     GIR_RootConstrainSelectedInstOperands,
     /*  728487 */     // GIR_Coverage, 11988,
     /*  728487 */     GIR_EraseRootFromParent_Done,
     /*  728488 */   // Label 11465: @728488
     /*  728488 */   GIM_Try, /*On fail goto*//*Label 11466*/ GIMT_Encode4(728563), // Rule ID 11989 //
     /*  728493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  728504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  728507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  728510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728539 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  728542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728561 */     GIR_RootConstrainSelectedInstOperands,
     /*  728562 */     // GIR_Coverage, 11989,
     /*  728562 */     GIR_EraseRootFromParent_Done,
     /*  728563 */   // Label 11466: @728563
     /*  728563 */   GIM_Try, /*On fail goto*//*Label 11467*/ GIMT_Encode4(728638), // Rule ID 11992 //
     /*  728568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  728579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  728582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  728585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  728617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728636 */     GIR_RootConstrainSelectedInstOperands,
     /*  728637 */     // GIR_Coverage, 11992,
     /*  728637 */     GIR_EraseRootFromParent_Done,
     /*  728638 */   // Label 11467: @728638
     /*  728638 */   GIM_Try, /*On fail goto*//*Label 11468*/ GIMT_Encode4(728713), // Rule ID 11993 //
     /*  728643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  728654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  728657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  728660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728689 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  728692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728711 */     GIR_RootConstrainSelectedInstOperands,
     /*  728712 */     // GIR_Coverage, 11993,
     /*  728712 */     GIR_EraseRootFromParent_Done,
     /*  728713 */   // Label 11468: @728713
     /*  728713 */   GIM_Try, /*On fail goto*//*Label 11469*/ GIMT_Encode4(728788), // Rule ID 11996 //
     /*  728718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  728729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  728732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  728735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  728764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  728767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728786 */     GIR_RootConstrainSelectedInstOperands,
     /*  728787 */     // GIR_Coverage, 11996,
     /*  728787 */     GIR_EraseRootFromParent_Done,
     /*  728788 */   // Label 11469: @728788
     /*  728788 */   GIM_Try, /*On fail goto*//*Label 11470*/ GIMT_Encode4(728863), // Rule ID 11997 //
     /*  728793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  728804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  728807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  728810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  728839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  728842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728861 */     GIR_RootConstrainSelectedInstOperands,
     /*  728862 */     // GIR_Coverage, 11997,
     /*  728862 */     GIR_EraseRootFromParent_Done,
     /*  728863 */   // Label 11470: @728863
     /*  728863 */   GIM_Try, /*On fail goto*//*Label 11471*/ GIMT_Encode4(728938), // Rule ID 12000 //
     /*  728868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  728879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  728882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  728885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  728914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  728917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728936 */     GIR_RootConstrainSelectedInstOperands,
     /*  728937 */     // GIR_Coverage, 12000,
     /*  728937 */     GIR_EraseRootFromParent_Done,
     /*  728938 */   // Label 11471: @728938
     /*  728938 */   GIM_Try, /*On fail goto*//*Label 11472*/ GIMT_Encode4(729013), // Rule ID 12001 //
     /*  728943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  728954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  728957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  728960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728989 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  728989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  728992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729011 */     GIR_RootConstrainSelectedInstOperands,
     /*  729012 */     // GIR_Coverage, 12001,
     /*  729012 */     GIR_EraseRootFromParent_Done,
     /*  729013 */   // Label 11472: @729013
     /*  729013 */   GIM_Try, /*On fail goto*//*Label 11473*/ GIMT_Encode4(729088), // Rule ID 12004 //
     /*  729018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  729029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  729032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  729035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729064 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  729067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729086 */     GIR_RootConstrainSelectedInstOperands,
     /*  729087 */     // GIR_Coverage, 12004,
     /*  729087 */     GIR_EraseRootFromParent_Done,
     /*  729088 */   // Label 11473: @729088
     /*  729088 */   GIM_Try, /*On fail goto*//*Label 11474*/ GIMT_Encode4(729163), // Rule ID 12005 //
     /*  729093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  729104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  729107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  729110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729139 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  729142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729161 */     GIR_RootConstrainSelectedInstOperands,
     /*  729162 */     // GIR_Coverage, 12005,
     /*  729162 */     GIR_EraseRootFromParent_Done,
     /*  729163 */   // Label 11474: @729163
     /*  729163 */   GIM_Try, /*On fail goto*//*Label 11475*/ GIMT_Encode4(729238), // Rule ID 12008 //
     /*  729168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  729179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  729182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  729185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  729217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729236 */     GIR_RootConstrainSelectedInstOperands,
     /*  729237 */     // GIR_Coverage, 12008,
     /*  729237 */     GIR_EraseRootFromParent_Done,
     /*  729238 */   // Label 11475: @729238
     /*  729238 */   GIM_Try, /*On fail goto*//*Label 11476*/ GIMT_Encode4(729313), // Rule ID 12009 //
     /*  729243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  729254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  729257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  729260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  729292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729311 */     GIR_RootConstrainSelectedInstOperands,
     /*  729312 */     // GIR_Coverage, 12009,
     /*  729312 */     GIR_EraseRootFromParent_Done,
     /*  729313 */   // Label 11476: @729313
     /*  729313 */   GIM_Try, /*On fail goto*//*Label 11477*/ GIMT_Encode4(729388), // Rule ID 12012 //
     /*  729318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  729329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  729332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  729335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  729367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729386 */     GIR_RootConstrainSelectedInstOperands,
     /*  729387 */     // GIR_Coverage, 12012,
     /*  729387 */     GIR_EraseRootFromParent_Done,
     /*  729388 */   // Label 11477: @729388
     /*  729388 */   GIM_Try, /*On fail goto*//*Label 11478*/ GIMT_Encode4(729463), // Rule ID 12013 //
     /*  729393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  729404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  729407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  729410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729439 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  729442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729461 */     GIR_RootConstrainSelectedInstOperands,
     /*  729462 */     // GIR_Coverage, 12013,
     /*  729462 */     GIR_EraseRootFromParent_Done,
     /*  729463 */   // Label 11478: @729463
     /*  729463 */   GIM_Try, /*On fail goto*//*Label 11479*/ GIMT_Encode4(729538), // Rule ID 12016 //
     /*  729468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  729479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  729482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  729485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729514 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  729517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729536 */     GIR_RootConstrainSelectedInstOperands,
     /*  729537 */     // GIR_Coverage, 12016,
     /*  729537 */     GIR_EraseRootFromParent_Done,
     /*  729538 */   // Label 11479: @729538
     /*  729538 */   GIM_Try, /*On fail goto*//*Label 11480*/ GIMT_Encode4(729613), // Rule ID 12017 //
     /*  729543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  729554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  729557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  729560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729589 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  729592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729611 */     GIR_RootConstrainSelectedInstOperands,
     /*  729612 */     // GIR_Coverage, 12017,
     /*  729612 */     GIR_EraseRootFromParent_Done,
     /*  729613 */   // Label 11480: @729613
     /*  729613 */   GIM_Try, /*On fail goto*//*Label 11481*/ GIMT_Encode4(729688), // Rule ID 12020 //
     /*  729618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  729629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  729632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  729635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  729638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729664 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  729664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  729667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729686 */     GIR_RootConstrainSelectedInstOperands,
     /*  729687 */     // GIR_Coverage, 12020,
     /*  729687 */     GIR_EraseRootFromParent_Done,
     /*  729688 */   // Label 11481: @729688
     /*  729688 */   GIM_Try, /*On fail goto*//*Label 11482*/ GIMT_Encode4(729763), // Rule ID 12021 //
     /*  729693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  729704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  729707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  729710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  729713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729739 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  729739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  729742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729761 */     GIR_RootConstrainSelectedInstOperands,
     /*  729762 */     // GIR_Coverage, 12021,
     /*  729762 */     GIR_EraseRootFromParent_Done,
     /*  729763 */   // Label 11482: @729763
     /*  729763 */   GIM_Try, /*On fail goto*//*Label 11483*/ GIMT_Encode4(729838), // Rule ID 12024 //
     /*  729768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  729779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  729782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  729785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  729788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729814 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  729814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  729817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729836 */     GIR_RootConstrainSelectedInstOperands,
     /*  729837 */     // GIR_Coverage, 12024,
     /*  729837 */     GIR_EraseRootFromParent_Done,
     /*  729838 */   // Label 11483: @729838
     /*  729838 */   GIM_Try, /*On fail goto*//*Label 11484*/ GIMT_Encode4(729913), // Rule ID 12025 //
     /*  729843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  729854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  729857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  729860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  729863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729889 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  729889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  729892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729911 */     GIR_RootConstrainSelectedInstOperands,
     /*  729912 */     // GIR_Coverage, 12025,
     /*  729912 */     GIR_EraseRootFromParent_Done,
     /*  729913 */   // Label 11484: @729913
     /*  729913 */   GIM_Try, /*On fail goto*//*Label 11485*/ GIMT_Encode4(729988), // Rule ID 12028 //
     /*  729918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  729929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  729932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  729935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  729938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729964 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  729964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  729967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729986 */     GIR_RootConstrainSelectedInstOperands,
     /*  729987 */     // GIR_Coverage, 12028,
     /*  729987 */     GIR_EraseRootFromParent_Done,
     /*  729988 */   // Label 11485: @729988
     /*  729988 */   GIM_Try, /*On fail goto*//*Label 11486*/ GIMT_Encode4(730063), // Rule ID 12029 //
     /*  729993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  730004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  730007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  730010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  730013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730039 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  730042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730061 */     GIR_RootConstrainSelectedInstOperands,
     /*  730062 */     // GIR_Coverage, 12029,
     /*  730062 */     GIR_EraseRootFromParent_Done,
     /*  730063 */   // Label 11486: @730063
     /*  730063 */   GIM_Try, /*On fail goto*//*Label 11487*/ GIMT_Encode4(730138), // Rule ID 12032 //
     /*  730068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  730079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  730082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  730085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  730088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  730117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730136 */     GIR_RootConstrainSelectedInstOperands,
     /*  730137 */     // GIR_Coverage, 12032,
     /*  730137 */     GIR_EraseRootFromParent_Done,
     /*  730138 */   // Label 11487: @730138
     /*  730138 */   GIM_Try, /*On fail goto*//*Label 11488*/ GIMT_Encode4(730213), // Rule ID 12033 //
     /*  730143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  730154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  730157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  730160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  730163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730189 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  730192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730211 */     GIR_RootConstrainSelectedInstOperands,
     /*  730212 */     // GIR_Coverage, 12033,
     /*  730212 */     GIR_EraseRootFromParent_Done,
     /*  730213 */   // Label 11488: @730213
     /*  730213 */   GIM_Try, /*On fail goto*//*Label 11489*/ GIMT_Encode4(730288), // Rule ID 12036 //
     /*  730218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  730229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  730232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  730235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  730238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  730267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730286 */     GIR_RootConstrainSelectedInstOperands,
     /*  730287 */     // GIR_Coverage, 12036,
     /*  730287 */     GIR_EraseRootFromParent_Done,
     /*  730288 */   // Label 11489: @730288
     /*  730288 */   GIM_Try, /*On fail goto*//*Label 11490*/ GIMT_Encode4(730363), // Rule ID 12037 //
     /*  730293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  730304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  730307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  730310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  730313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730339 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  730342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730361 */     GIR_RootConstrainSelectedInstOperands,
     /*  730362 */     // GIR_Coverage, 12037,
     /*  730362 */     GIR_EraseRootFromParent_Done,
     /*  730363 */   // Label 11490: @730363
     /*  730363 */   GIM_Try, /*On fail goto*//*Label 11491*/ GIMT_Encode4(730438), // Rule ID 12040 //
     /*  730368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  730379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  730382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  730385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  730388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730414 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  730414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  730417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730436 */     GIR_RootConstrainSelectedInstOperands,
     /*  730437 */     // GIR_Coverage, 12040,
     /*  730437 */     GIR_EraseRootFromParent_Done,
     /*  730438 */   // Label 11491: @730438
     /*  730438 */   GIM_Try, /*On fail goto*//*Label 11492*/ GIMT_Encode4(730513), // Rule ID 12041 //
     /*  730443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  730454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  730457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  730460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  730463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730489 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  730489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  730492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730511 */     GIR_RootConstrainSelectedInstOperands,
     /*  730512 */     // GIR_Coverage, 12041,
     /*  730512 */     GIR_EraseRootFromParent_Done,
     /*  730513 */   // Label 11492: @730513
     /*  730513 */   GIM_Try, /*On fail goto*//*Label 11493*/ GIMT_Encode4(730588), // Rule ID 12044 //
     /*  730518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  730529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  730532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  730535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  730538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730564 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  730567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730586 */     GIR_RootConstrainSelectedInstOperands,
     /*  730587 */     // GIR_Coverage, 12044,
     /*  730587 */     GIR_EraseRootFromParent_Done,
     /*  730588 */   // Label 11493: @730588
     /*  730588 */   GIM_Try, /*On fail goto*//*Label 11494*/ GIMT_Encode4(730663), // Rule ID 12045 //
     /*  730593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  730604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  730607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  730610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  730613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730639 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  730642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730661 */     GIR_RootConstrainSelectedInstOperands,
     /*  730662 */     // GIR_Coverage, 12045,
     /*  730662 */     GIR_EraseRootFromParent_Done,
     /*  730663 */   // Label 11494: @730663
     /*  730663 */   GIM_Try, /*On fail goto*//*Label 11495*/ GIMT_Encode4(730738), // Rule ID 12048 //
     /*  730668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  730679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  730682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  730685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  730688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  730717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730736 */     GIR_RootConstrainSelectedInstOperands,
     /*  730737 */     // GIR_Coverage, 12048,
     /*  730737 */     GIR_EraseRootFromParent_Done,
     /*  730738 */   // Label 11495: @730738
     /*  730738 */   GIM_Try, /*On fail goto*//*Label 11496*/ GIMT_Encode4(730813), // Rule ID 12049 //
     /*  730743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  730754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  730757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  730760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  730763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730789 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  730792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730811 */     GIR_RootConstrainSelectedInstOperands,
     /*  730812 */     // GIR_Coverage, 12049,
     /*  730812 */     GIR_EraseRootFromParent_Done,
     /*  730813 */   // Label 11496: @730813
     /*  730813 */   GIM_Try, /*On fail goto*//*Label 11497*/ GIMT_Encode4(730888), // Rule ID 12052 //
     /*  730818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  730829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  730832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  730835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  730838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730864 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  730864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  730867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730886 */     GIR_RootConstrainSelectedInstOperands,
     /*  730887 */     // GIR_Coverage, 12052,
     /*  730887 */     GIR_EraseRootFromParent_Done,
     /*  730888 */   // Label 11497: @730888
     /*  730888 */   GIM_Try, /*On fail goto*//*Label 11498*/ GIMT_Encode4(730963), // Rule ID 12053 //
     /*  730893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  730904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  730907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  730910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  730913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730939 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  730939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  730942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730961 */     GIR_RootConstrainSelectedInstOperands,
     /*  730962 */     // GIR_Coverage, 12053,
     /*  730962 */     GIR_EraseRootFromParent_Done,
     /*  730963 */   // Label 11498: @730963
     /*  730963 */   GIM_Try, /*On fail goto*//*Label 11499*/ GIMT_Encode4(731038), // Rule ID 12056 //
     /*  730968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  730971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  730979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  730982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  730985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  730988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  731014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  731017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731036 */     GIR_RootConstrainSelectedInstOperands,
     /*  731037 */     // GIR_Coverage, 12056,
     /*  731037 */     GIR_EraseRootFromParent_Done,
     /*  731038 */   // Label 11499: @731038
     /*  731038 */   GIM_Try, /*On fail goto*//*Label 11500*/ GIMT_Encode4(731113), // Rule ID 12057 //
     /*  731043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  731046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  731060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  731063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731089 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  731089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  731092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731111 */     GIR_RootConstrainSelectedInstOperands,
     /*  731112 */     // GIR_Coverage, 12057,
     /*  731112 */     GIR_EraseRootFromParent_Done,
     /*  731113 */   // Label 11500: @731113
     /*  731113 */   GIM_Try, /*On fail goto*//*Label 11501*/ GIMT_Encode4(731188), // Rule ID 12060 //
     /*  731118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  731129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  731132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  731135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  731138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  731167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731186 */     GIR_RootConstrainSelectedInstOperands,
     /*  731187 */     // GIR_Coverage, 12060,
     /*  731187 */     GIR_EraseRootFromParent_Done,
     /*  731188 */   // Label 11501: @731188
     /*  731188 */   GIM_Try, /*On fail goto*//*Label 11502*/ GIMT_Encode4(731263), // Rule ID 12061 //
     /*  731193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  731204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  731207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  731210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  731213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731239 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  731242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731261 */     GIR_RootConstrainSelectedInstOperands,
     /*  731262 */     // GIR_Coverage, 12061,
     /*  731262 */     GIR_EraseRootFromParent_Done,
     /*  731263 */   // Label 11502: @731263
     /*  731263 */   GIM_Try, /*On fail goto*//*Label 11503*/ GIMT_Encode4(731338), // Rule ID 12064 //
     /*  731268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  731279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  731282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  731285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  731288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731314 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  731317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731336 */     GIR_RootConstrainSelectedInstOperands,
     /*  731337 */     // GIR_Coverage, 12064,
     /*  731337 */     GIR_EraseRootFromParent_Done,
     /*  731338 */   // Label 11503: @731338
     /*  731338 */   GIM_Try, /*On fail goto*//*Label 11504*/ GIMT_Encode4(731413), // Rule ID 12065 //
     /*  731343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  731354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  731357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  731360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  731363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731389 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  731392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731411 */     GIR_RootConstrainSelectedInstOperands,
     /*  731412 */     // GIR_Coverage, 12065,
     /*  731412 */     GIR_EraseRootFromParent_Done,
     /*  731413 */   // Label 11504: @731413
     /*  731413 */   GIM_Try, /*On fail goto*//*Label 11505*/ GIMT_Encode4(731488), // Rule ID 12068 //
     /*  731418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  731429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  731432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  731435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  731438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731464 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  731467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731486 */     GIR_RootConstrainSelectedInstOperands,
     /*  731487 */     // GIR_Coverage, 12068,
     /*  731487 */     GIR_EraseRootFromParent_Done,
     /*  731488 */   // Label 11505: @731488
     /*  731488 */   GIM_Try, /*On fail goto*//*Label 11506*/ GIMT_Encode4(731563), // Rule ID 12069 //
     /*  731493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  731504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  731507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  731510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  731513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731539 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  731542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731561 */     GIR_RootConstrainSelectedInstOperands,
     /*  731562 */     // GIR_Coverage, 12069,
     /*  731562 */     GIR_EraseRootFromParent_Done,
     /*  731563 */   // Label 11506: @731563
     /*  731563 */   GIM_Try, /*On fail goto*//*Label 11507*/ GIMT_Encode4(731638), // Rule ID 12072 //
     /*  731568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  731579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  731582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  731585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  731588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731614 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  731614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  731617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731636 */     GIR_RootConstrainSelectedInstOperands,
     /*  731637 */     // GIR_Coverage, 12072,
     /*  731637 */     GIR_EraseRootFromParent_Done,
     /*  731638 */   // Label 11507: @731638
     /*  731638 */   GIM_Try, /*On fail goto*//*Label 11508*/ GIMT_Encode4(731713), // Rule ID 12073 //
     /*  731643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  731654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  731657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  731660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  731663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731689 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  731689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  731692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731711 */     GIR_RootConstrainSelectedInstOperands,
     /*  731712 */     // GIR_Coverage, 12073,
     /*  731712 */     GIR_EraseRootFromParent_Done,
     /*  731713 */   // Label 11508: @731713
     /*  731713 */   GIM_Try, /*On fail goto*//*Label 11509*/ GIMT_Encode4(731788), // Rule ID 12076 //
     /*  731718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  731729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  731732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  731735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  731738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731764 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  731764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  731767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731786 */     GIR_RootConstrainSelectedInstOperands,
     /*  731787 */     // GIR_Coverage, 12076,
     /*  731787 */     GIR_EraseRootFromParent_Done,
     /*  731788 */   // Label 11509: @731788
     /*  731788 */   GIM_Try, /*On fail goto*//*Label 11510*/ GIMT_Encode4(731863), // Rule ID 12077 //
     /*  731793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  731804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  731807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  731810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  731813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731839 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  731839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  731842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731861 */     GIR_RootConstrainSelectedInstOperands,
     /*  731862 */     // GIR_Coverage, 12077,
     /*  731862 */     GIR_EraseRootFromParent_Done,
     /*  731863 */   // Label 11510: @731863
     /*  731863 */   GIM_Try, /*On fail goto*//*Label 11511*/ GIMT_Encode4(731938), // Rule ID 12080 //
     /*  731868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  731879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  731882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  731885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  731888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731914 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  731914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  731917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731936 */     GIR_RootConstrainSelectedInstOperands,
     /*  731937 */     // GIR_Coverage, 12080,
     /*  731937 */     GIR_EraseRootFromParent_Done,
     /*  731938 */   // Label 11511: @731938
     /*  731938 */   GIM_Try, /*On fail goto*//*Label 11512*/ GIMT_Encode4(732013), // Rule ID 12081 //
     /*  731943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  731954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  731957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  731960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  731963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731989 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  731989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  731992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732011 */     GIR_RootConstrainSelectedInstOperands,
     /*  732012 */     // GIR_Coverage, 12081,
     /*  732012 */     GIR_EraseRootFromParent_Done,
     /*  732013 */   // Label 11512: @732013
     /*  732013 */   GIM_Try, /*On fail goto*//*Label 11513*/ GIMT_Encode4(732088), // Rule ID 12084 //
     /*  732018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  732029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  732032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  732035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  732038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  732067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732086 */     GIR_RootConstrainSelectedInstOperands,
     /*  732087 */     // GIR_Coverage, 12084,
     /*  732087 */     GIR_EraseRootFromParent_Done,
     /*  732088 */   // Label 11513: @732088
     /*  732088 */   GIM_Try, /*On fail goto*//*Label 11514*/ GIMT_Encode4(732163), // Rule ID 12085 //
     /*  732093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  732104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  732107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  732110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  732113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  732142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732161 */     GIR_RootConstrainSelectedInstOperands,
     /*  732162 */     // GIR_Coverage, 12085,
     /*  732162 */     GIR_EraseRootFromParent_Done,
     /*  732163 */   // Label 11514: @732163
     /*  732163 */   GIM_Try, /*On fail goto*//*Label 11515*/ GIMT_Encode4(732238), // Rule ID 12088 //
     /*  732168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  732179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  732182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  732185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  732188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  732217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732236 */     GIR_RootConstrainSelectedInstOperands,
     /*  732237 */     // GIR_Coverage, 12088,
     /*  732237 */     GIR_EraseRootFromParent_Done,
     /*  732238 */   // Label 11515: @732238
     /*  732238 */   GIM_Try, /*On fail goto*//*Label 11516*/ GIMT_Encode4(732313), // Rule ID 12089 //
     /*  732243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  732254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  732257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  732260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  732263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732289 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  732292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732311 */     GIR_RootConstrainSelectedInstOperands,
     /*  732312 */     // GIR_Coverage, 12089,
     /*  732312 */     GIR_EraseRootFromParent_Done,
     /*  732313 */   // Label 11516: @732313
     /*  732313 */   GIM_Try, /*On fail goto*//*Label 11517*/ GIMT_Encode4(732388), // Rule ID 12092 //
     /*  732318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  732329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  732332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  732335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  732338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  732367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732386 */     GIR_RootConstrainSelectedInstOperands,
     /*  732387 */     // GIR_Coverage, 12092,
     /*  732387 */     GIR_EraseRootFromParent_Done,
     /*  732388 */   // Label 11517: @732388
     /*  732388 */   GIM_Try, /*On fail goto*//*Label 11518*/ GIMT_Encode4(732463), // Rule ID 12093 //
     /*  732393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  732404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  732407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  732410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  732413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732439 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  732442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732461 */     GIR_RootConstrainSelectedInstOperands,
     /*  732462 */     // GIR_Coverage, 12093,
     /*  732462 */     GIR_EraseRootFromParent_Done,
     /*  732463 */   // Label 11518: @732463
     /*  732463 */   GIM_Try, /*On fail goto*//*Label 11519*/ GIMT_Encode4(732538), // Rule ID 12096 //
     /*  732468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  732471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  732479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  732482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  732485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  732488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732514 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  732514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  732517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732536 */     GIR_RootConstrainSelectedInstOperands,
     /*  732537 */     // GIR_Coverage, 12096,
     /*  732537 */     GIR_EraseRootFromParent_Done,
     /*  732538 */   // Label 11519: @732538
     /*  732538 */   GIM_Try, /*On fail goto*//*Label 11520*/ GIMT_Encode4(732613), // Rule ID 12097 //
     /*  732543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  732546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  732554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  732557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  732560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  732563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732589 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  732589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  732592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732611 */     GIR_RootConstrainSelectedInstOperands,
     /*  732612 */     // GIR_Coverage, 12097,
     /*  732612 */     GIR_EraseRootFromParent_Done,
     /*  732613 */   // Label 11520: @732613
     /*  732613 */   GIM_Try, /*On fail goto*//*Label 11521*/ GIMT_Encode4(732688), // Rule ID 12100 //
     /*  732618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  732621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  732629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  732632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  732635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  732638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732664 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  732664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  732667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732686 */     GIR_RootConstrainSelectedInstOperands,
     /*  732687 */     // GIR_Coverage, 12100,
     /*  732687 */     GIR_EraseRootFromParent_Done,
     /*  732688 */   // Label 11521: @732688
     /*  732688 */   GIM_Try, /*On fail goto*//*Label 11522*/ GIMT_Encode4(732763), // Rule ID 12101 //
     /*  732693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  732696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  732704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  732707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  732710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  732713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732739 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  732739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  732742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732761 */     GIR_RootConstrainSelectedInstOperands,
     /*  732762 */     // GIR_Coverage, 12101,
     /*  732762 */     GIR_EraseRootFromParent_Done,
     /*  732763 */   // Label 11522: @732763
     /*  732763 */   GIM_Try, /*On fail goto*//*Label 11523*/ GIMT_Encode4(732838), // Rule ID 12104 //
     /*  732768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  732771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  732779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  732782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  732785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  732788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732814 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  732814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  732817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732836 */     GIR_RootConstrainSelectedInstOperands,
     /*  732837 */     // GIR_Coverage, 12104,
     /*  732837 */     GIR_EraseRootFromParent_Done,
     /*  732838 */   // Label 11523: @732838
     /*  732838 */   GIM_Try, /*On fail goto*//*Label 11524*/ GIMT_Encode4(732913), // Rule ID 12105 //
     /*  732843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  732846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  732854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  732857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  732860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  732863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732889 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  732889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  732892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732911 */     GIR_RootConstrainSelectedInstOperands,
     /*  732912 */     // GIR_Coverage, 12105,
     /*  732912 */     GIR_EraseRootFromParent_Done,
     /*  732913 */   // Label 11524: @732913
     /*  732913 */   GIM_Try, /*On fail goto*//*Label 11525*/ GIMT_Encode4(732988), // Rule ID 12108 //
     /*  732918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  732929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  732932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  732935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732964 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  732964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  732967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732986 */     GIR_RootConstrainSelectedInstOperands,
     /*  732987 */     // GIR_Coverage, 12108,
     /*  732987 */     GIR_EraseRootFromParent_Done,
     /*  732988 */   // Label 11525: @732988
     /*  732988 */   GIM_Try, /*On fail goto*//*Label 11526*/ GIMT_Encode4(733063), // Rule ID 12109 //
     /*  732993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  733004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  733007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  733010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733039 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  733042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733061 */     GIR_RootConstrainSelectedInstOperands,
     /*  733062 */     // GIR_Coverage, 12109,
     /*  733062 */     GIR_EraseRootFromParent_Done,
     /*  733063 */   // Label 11526: @733063
     /*  733063 */   GIM_Try, /*On fail goto*//*Label 11527*/ GIMT_Encode4(733138), // Rule ID 12112 //
     /*  733068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  733079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  733082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  733085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733114 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  733117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733136 */     GIR_RootConstrainSelectedInstOperands,
     /*  733137 */     // GIR_Coverage, 12112,
     /*  733137 */     GIR_EraseRootFromParent_Done,
     /*  733138 */   // Label 11527: @733138
     /*  733138 */   GIM_Try, /*On fail goto*//*Label 11528*/ GIMT_Encode4(733213), // Rule ID 12113 //
     /*  733143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  733154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  733157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  733160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733189 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  733192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733211 */     GIR_RootConstrainSelectedInstOperands,
     /*  733212 */     // GIR_Coverage, 12113,
     /*  733212 */     GIR_EraseRootFromParent_Done,
     /*  733213 */   // Label 11528: @733213
     /*  733213 */   GIM_Try, /*On fail goto*//*Label 11529*/ GIMT_Encode4(733288), // Rule ID 12116 //
     /*  733218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  733229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  733232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  733235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733264 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  733267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733286 */     GIR_RootConstrainSelectedInstOperands,
     /*  733287 */     // GIR_Coverage, 12116,
     /*  733287 */     GIR_EraseRootFromParent_Done,
     /*  733288 */   // Label 11529: @733288
     /*  733288 */   GIM_Try, /*On fail goto*//*Label 11530*/ GIMT_Encode4(733363), // Rule ID 12117 //
     /*  733293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  733304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  733307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  733310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733339 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  733342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733361 */     GIR_RootConstrainSelectedInstOperands,
     /*  733362 */     // GIR_Coverage, 12117,
     /*  733362 */     GIR_EraseRootFromParent_Done,
     /*  733363 */   // Label 11530: @733363
     /*  733363 */   GIM_Try, /*On fail goto*//*Label 11531*/ GIMT_Encode4(733438), // Rule ID 12120 //
     /*  733368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  733379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  733382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  733385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733414 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  733414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  733417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733436 */     GIR_RootConstrainSelectedInstOperands,
     /*  733437 */     // GIR_Coverage, 12120,
     /*  733437 */     GIR_EraseRootFromParent_Done,
     /*  733438 */   // Label 11531: @733438
     /*  733438 */   GIM_Try, /*On fail goto*//*Label 11532*/ GIMT_Encode4(733513), // Rule ID 12121 //
     /*  733443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  733454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  733457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  733460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733489 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  733489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  733492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733511 */     GIR_RootConstrainSelectedInstOperands,
     /*  733512 */     // GIR_Coverage, 12121,
     /*  733512 */     GIR_EraseRootFromParent_Done,
     /*  733513 */   // Label 11532: @733513
     /*  733513 */   GIM_Try, /*On fail goto*//*Label 11533*/ GIMT_Encode4(733588), // Rule ID 12124 //
     /*  733518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  733529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  733532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  733535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  733564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  733567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733586 */     GIR_RootConstrainSelectedInstOperands,
     /*  733587 */     // GIR_Coverage, 12124,
     /*  733587 */     GIR_EraseRootFromParent_Done,
     /*  733588 */   // Label 11533: @733588
     /*  733588 */   GIM_Try, /*On fail goto*//*Label 11534*/ GIMT_Encode4(733663), // Rule ID 12125 //
     /*  733593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  733604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  733607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  733610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733639 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  733639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  733642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733661 */     GIR_RootConstrainSelectedInstOperands,
     /*  733662 */     // GIR_Coverage, 12125,
     /*  733662 */     GIR_EraseRootFromParent_Done,
     /*  733663 */   // Label 11534: @733663
     /*  733663 */   GIM_Try, /*On fail goto*//*Label 11535*/ GIMT_Encode4(733738), // Rule ID 12128 //
     /*  733668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  733679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  733682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  733685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  733714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  733717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  733733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733736 */     GIR_RootConstrainSelectedInstOperands,
     /*  733737 */     // GIR_Coverage, 12128,
     /*  733737 */     GIR_EraseRootFromParent_Done,
     /*  733738 */   // Label 11535: @733738
     /*  733738 */   GIM_Try, /*On fail goto*//*Label 11536*/ GIMT_Encode4(733813), // Rule ID 12129 //
     /*  733743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  733754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  733757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  733760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733789 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  733789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  733792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  733808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733811 */     GIR_RootConstrainSelectedInstOperands,
     /*  733812 */     // GIR_Coverage, 12129,
     /*  733812 */     GIR_EraseRootFromParent_Done,
     /*  733813 */   // Label 11536: @733813
     /*  733813 */   GIM_Try, /*On fail goto*//*Label 11537*/ GIMT_Encode4(733888), // Rule ID 12132 //
     /*  733818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  733829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  733832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  733835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733864 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  733867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733886 */     GIR_RootConstrainSelectedInstOperands,
     /*  733887 */     // GIR_Coverage, 12132,
     /*  733887 */     GIR_EraseRootFromParent_Done,
     /*  733888 */   // Label 11537: @733888
     /*  733888 */   GIM_Try, /*On fail goto*//*Label 11538*/ GIMT_Encode4(733963), // Rule ID 12133 //
     /*  733893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  733904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  733907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  733910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733939 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  733942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733961 */     GIR_RootConstrainSelectedInstOperands,
     /*  733962 */     // GIR_Coverage, 12133,
     /*  733962 */     GIR_EraseRootFromParent_Done,
     /*  733963 */   // Label 11538: @733963
     /*  733963 */   GIM_Try, /*On fail goto*//*Label 11539*/ GIMT_Encode4(734038), // Rule ID 12136 //
     /*  733968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  733979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  733982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  733985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734014 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  734017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734036 */     GIR_RootConstrainSelectedInstOperands,
     /*  734037 */     // GIR_Coverage, 12136,
     /*  734037 */     GIR_EraseRootFromParent_Done,
     /*  734038 */   // Label 11539: @734038
     /*  734038 */   GIM_Try, /*On fail goto*//*Label 11540*/ GIMT_Encode4(734113), // Rule ID 12137 //
     /*  734043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  734054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  734057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  734060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734089 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  734092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734111 */     GIR_RootConstrainSelectedInstOperands,
     /*  734112 */     // GIR_Coverage, 12137,
     /*  734112 */     GIR_EraseRootFromParent_Done,
     /*  734113 */   // Label 11540: @734113
     /*  734113 */   GIM_Try, /*On fail goto*//*Label 11541*/ GIMT_Encode4(734188), // Rule ID 12140 //
     /*  734118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  734135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  734167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734186 */     GIR_RootConstrainSelectedInstOperands,
     /*  734187 */     // GIR_Coverage, 12140,
     /*  734187 */     GIR_EraseRootFromParent_Done,
     /*  734188 */   // Label 11541: @734188
     /*  734188 */   GIM_Try, /*On fail goto*//*Label 11542*/ GIMT_Encode4(734263), // Rule ID 12141 //
     /*  734193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  734210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734239 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  734242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734261 */     GIR_RootConstrainSelectedInstOperands,
     /*  734262 */     // GIR_Coverage, 12141,
     /*  734262 */     GIR_EraseRootFromParent_Done,
     /*  734263 */   // Label 11542: @734263
     /*  734263 */   GIM_Try, /*On fail goto*//*Label 11543*/ GIMT_Encode4(734338), // Rule ID 12144 //
     /*  734268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  734271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  734285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734314 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  734314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  734317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734336 */     GIR_RootConstrainSelectedInstOperands,
     /*  734337 */     // GIR_Coverage, 12144,
     /*  734337 */     GIR_EraseRootFromParent_Done,
     /*  734338 */   // Label 11543: @734338
     /*  734338 */   GIM_Try, /*On fail goto*//*Label 11544*/ GIMT_Encode4(734413), // Rule ID 12145 //
     /*  734343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  734346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  734360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734389 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  734389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  734392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734411 */     GIR_RootConstrainSelectedInstOperands,
     /*  734412 */     // GIR_Coverage, 12145,
     /*  734412 */     GIR_EraseRootFromParent_Done,
     /*  734413 */   // Label 11544: @734413
     /*  734413 */   GIM_Try, /*On fail goto*//*Label 11545*/ GIMT_Encode4(734488), // Rule ID 12148 //
     /*  734418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  734429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  734432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  734435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734464 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  734467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734486 */     GIR_RootConstrainSelectedInstOperands,
     /*  734487 */     // GIR_Coverage, 12148,
     /*  734487 */     GIR_EraseRootFromParent_Done,
     /*  734488 */   // Label 11545: @734488
     /*  734488 */   GIM_Try, /*On fail goto*//*Label 11546*/ GIMT_Encode4(734563), // Rule ID 12149 //
     /*  734493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  734504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  734507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  734510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734539 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  734542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734561 */     GIR_RootConstrainSelectedInstOperands,
     /*  734562 */     // GIR_Coverage, 12149,
     /*  734562 */     GIR_EraseRootFromParent_Done,
     /*  734563 */   // Label 11546: @734563
     /*  734563 */   GIM_Try, /*On fail goto*//*Label 11547*/ GIMT_Encode4(734638), // Rule ID 12152 //
     /*  734568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  734579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  734582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  734585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734614 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  734617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734636 */     GIR_RootConstrainSelectedInstOperands,
     /*  734637 */     // GIR_Coverage, 12152,
     /*  734637 */     GIR_EraseRootFromParent_Done,
     /*  734638 */   // Label 11547: @734638
     /*  734638 */   GIM_Try, /*On fail goto*//*Label 11548*/ GIMT_Encode4(734713), // Rule ID 12153 //
     /*  734643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  734654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  734657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  734660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734689 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  734692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734711 */     GIR_RootConstrainSelectedInstOperands,
     /*  734712 */     // GIR_Coverage, 12153,
     /*  734712 */     GIR_EraseRootFromParent_Done,
     /*  734713 */   // Label 11548: @734713
     /*  734713 */   GIM_Try, /*On fail goto*//*Label 11549*/ GIMT_Encode4(734788), // Rule ID 12156 //
     /*  734718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  734729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  734732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  734735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734764 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  734767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734786 */     GIR_RootConstrainSelectedInstOperands,
     /*  734787 */     // GIR_Coverage, 12156,
     /*  734787 */     GIR_EraseRootFromParent_Done,
     /*  734788 */   // Label 11549: @734788
     /*  734788 */   GIM_Try, /*On fail goto*//*Label 11550*/ GIMT_Encode4(734863), // Rule ID 12157 //
     /*  734793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  734804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  734807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  734810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734839 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  734842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734861 */     GIR_RootConstrainSelectedInstOperands,
     /*  734862 */     // GIR_Coverage, 12157,
     /*  734862 */     GIR_EraseRootFromParent_Done,
     /*  734863 */   // Label 11550: @734863
     /*  734863 */   GIM_Try, /*On fail goto*//*Label 11551*/ GIMT_Encode4(734938), // Rule ID 12160 //
     /*  734868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  734879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  734882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  734885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  734917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734936 */     GIR_RootConstrainSelectedInstOperands,
     /*  734937 */     // GIR_Coverage, 12160,
     /*  734937 */     GIR_EraseRootFromParent_Done,
     /*  734938 */   // Label 11551: @734938
     /*  734938 */   GIM_Try, /*On fail goto*//*Label 11552*/ GIMT_Encode4(735013), // Rule ID 12161 //
     /*  734943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  734954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  734957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  734960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734989 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  734992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735011 */     GIR_RootConstrainSelectedInstOperands,
     /*  735012 */     // GIR_Coverage, 12161,
     /*  735012 */     GIR_EraseRootFromParent_Done,
     /*  735013 */   // Label 11552: @735013
     /*  735013 */   GIM_Try, /*On fail goto*//*Label 11553*/ GIMT_Encode4(735088), // Rule ID 12164 //
     /*  735018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  735029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  735032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  735035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  735067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735086 */     GIR_RootConstrainSelectedInstOperands,
     /*  735087 */     // GIR_Coverage, 12164,
     /*  735087 */     GIR_EraseRootFromParent_Done,
     /*  735088 */   // Label 11553: @735088
     /*  735088 */   GIM_Try, /*On fail goto*//*Label 11554*/ GIMT_Encode4(735163), // Rule ID 12165 //
     /*  735093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  735104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  735107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  735110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735139 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  735142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735161 */     GIR_RootConstrainSelectedInstOperands,
     /*  735162 */     // GIR_Coverage, 12165,
     /*  735162 */     GIR_EraseRootFromParent_Done,
     /*  735163 */   // Label 11554: @735163
     /*  735163 */   GIM_Try, /*On fail goto*//*Label 11555*/ GIMT_Encode4(735238), // Rule ID 12168 //
     /*  735168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  735179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  735182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  735185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735214 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  735217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735236 */     GIR_RootConstrainSelectedInstOperands,
     /*  735237 */     // GIR_Coverage, 12168,
     /*  735237 */     GIR_EraseRootFromParent_Done,
     /*  735238 */   // Label 11555: @735238
     /*  735238 */   GIM_Try, /*On fail goto*//*Label 11556*/ GIMT_Encode4(735313), // Rule ID 12169 //
     /*  735243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  735254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  735257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  735260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735289 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  735292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735311 */     GIR_RootConstrainSelectedInstOperands,
     /*  735312 */     // GIR_Coverage, 12169,
     /*  735312 */     GIR_EraseRootFromParent_Done,
     /*  735313 */   // Label 11556: @735313
     /*  735313 */   GIM_Try, /*On fail goto*//*Label 11557*/ GIMT_Encode4(735388), // Rule ID 12172 //
     /*  735318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  735329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  735332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  735335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  735367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735386 */     GIR_RootConstrainSelectedInstOperands,
     /*  735387 */     // GIR_Coverage, 12172,
     /*  735387 */     GIR_EraseRootFromParent_Done,
     /*  735388 */   // Label 11557: @735388
     /*  735388 */   GIM_Try, /*On fail goto*//*Label 11558*/ GIMT_Encode4(735463), // Rule ID 12173 //
     /*  735393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  735404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  735407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  735410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  735439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  735442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735461 */     GIR_RootConstrainSelectedInstOperands,
     /*  735462 */     // GIR_Coverage, 12173,
     /*  735462 */     GIR_EraseRootFromParent_Done,
     /*  735463 */   // Label 11558: @735463
     /*  735463 */   GIM_Try, /*On fail goto*//*Label 11559*/ GIMT_Encode4(735538), // Rule ID 12176 //
     /*  735468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  735479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  735482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  735485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  735517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735536 */     GIR_RootConstrainSelectedInstOperands,
     /*  735537 */     // GIR_Coverage, 12176,
     /*  735537 */     GIR_EraseRootFromParent_Done,
     /*  735538 */   // Label 11559: @735538
     /*  735538 */   GIM_Try, /*On fail goto*//*Label 11560*/ GIMT_Encode4(735613), // Rule ID 12177 //
     /*  735543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  735554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  735557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  735560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735589 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  735589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  735592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735611 */     GIR_RootConstrainSelectedInstOperands,
     /*  735612 */     // GIR_Coverage, 12177,
     /*  735612 */     GIR_EraseRootFromParent_Done,
     /*  735613 */   // Label 11560: @735613
     /*  735613 */   GIM_Try, /*On fail goto*//*Label 11561*/ GIMT_Encode4(735688), // Rule ID 12180 //
     /*  735618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  735629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  735632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  735635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735664 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  735667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735686 */     GIR_RootConstrainSelectedInstOperands,
     /*  735687 */     // GIR_Coverage, 12180,
     /*  735687 */     GIR_EraseRootFromParent_Done,
     /*  735688 */   // Label 11561: @735688
     /*  735688 */   GIM_Try, /*On fail goto*//*Label 11562*/ GIMT_Encode4(735763), // Rule ID 12181 //
     /*  735693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  735704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  735707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  735710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735739 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  735739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  735742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735761 */     GIR_RootConstrainSelectedInstOperands,
     /*  735762 */     // GIR_Coverage, 12181,
     /*  735762 */     GIR_EraseRootFromParent_Done,
     /*  735763 */   // Label 11562: @735763
     /*  735763 */   GIM_Try, /*On fail goto*//*Label 11563*/ GIMT_Encode4(735838), // Rule ID 12184 //
     /*  735768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  735771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  735779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  735782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  735785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  735814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  735817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  735833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735836 */     GIR_RootConstrainSelectedInstOperands,
     /*  735837 */     // GIR_Coverage, 12184,
     /*  735837 */     GIR_EraseRootFromParent_Done,
     /*  735838 */   // Label 11563: @735838
     /*  735838 */   GIM_Try, /*On fail goto*//*Label 11564*/ GIMT_Encode4(735913), // Rule ID 12185 //
     /*  735843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  735846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  735854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  735857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  735860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735889 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  735889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  735892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  735908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735911 */     GIR_RootConstrainSelectedInstOperands,
     /*  735912 */     // GIR_Coverage, 12185,
     /*  735912 */     GIR_EraseRootFromParent_Done,
     /*  735913 */   // Label 11564: @735913
     /*  735913 */   GIM_Try, /*On fail goto*//*Label 11565*/ GIMT_Encode4(735988), // Rule ID 12188 //
     /*  735918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  735921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  735929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  735932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  735935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735964 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  735964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  735967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  735983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735986 */     GIR_RootConstrainSelectedInstOperands,
     /*  735987 */     // GIR_Coverage, 12188,
     /*  735987 */     GIR_EraseRootFromParent_Done,
     /*  735988 */   // Label 11565: @735988
     /*  735988 */   GIM_Try, /*On fail goto*//*Label 11566*/ GIMT_Encode4(736063), // Rule ID 12189 //
     /*  735993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  735996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  736004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  736007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  736010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736039 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  736042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736061 */     GIR_RootConstrainSelectedInstOperands,
     /*  736062 */     // GIR_Coverage, 12189,
     /*  736062 */     GIR_EraseRootFromParent_Done,
     /*  736063 */   // Label 11566: @736063
     /*  736063 */   GIM_Try, /*On fail goto*//*Label 11567*/ GIMT_Encode4(736138), // Rule ID 12192 //
     /*  736068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  736079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  736082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  736085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  736117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736136 */     GIR_RootConstrainSelectedInstOperands,
     /*  736137 */     // GIR_Coverage, 12192,
     /*  736137 */     GIR_EraseRootFromParent_Done,
     /*  736138 */   // Label 11567: @736138
     /*  736138 */   GIM_Try, /*On fail goto*//*Label 11568*/ GIMT_Encode4(736213), // Rule ID 12193 //
     /*  736143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  736154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  736157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  736160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736189 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  736192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736211 */     GIR_RootConstrainSelectedInstOperands,
     /*  736212 */     // GIR_Coverage, 12193,
     /*  736212 */     GIR_EraseRootFromParent_Done,
     /*  736213 */   // Label 11568: @736213
     /*  736213 */   GIM_Try, /*On fail goto*//*Label 11569*/ GIMT_Encode4(736288), // Rule ID 12196 //
     /*  736218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  736229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  736232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  736235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  736238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736264 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  736267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736286 */     GIR_RootConstrainSelectedInstOperands,
     /*  736287 */     // GIR_Coverage, 12196,
     /*  736287 */     GIR_EraseRootFromParent_Done,
     /*  736288 */   // Label 11569: @736288
     /*  736288 */   GIM_Try, /*On fail goto*//*Label 11570*/ GIMT_Encode4(736363), // Rule ID 12197 //
     /*  736293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  736304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  736307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  736310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  736313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736339 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  736342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736361 */     GIR_RootConstrainSelectedInstOperands,
     /*  736362 */     // GIR_Coverage, 12197,
     /*  736362 */     GIR_EraseRootFromParent_Done,
     /*  736363 */   // Label 11570: @736363
     /*  736363 */   GIM_Try, /*On fail goto*//*Label 11571*/ GIMT_Encode4(736438), // Rule ID 12200 //
     /*  736368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  736379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  736382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  736385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  736388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736414 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  736417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736436 */     GIR_RootConstrainSelectedInstOperands,
     /*  736437 */     // GIR_Coverage, 12200,
     /*  736437 */     GIR_EraseRootFromParent_Done,
     /*  736438 */   // Label 11571: @736438
     /*  736438 */   GIM_Try, /*On fail goto*//*Label 11572*/ GIMT_Encode4(736513), // Rule ID 12201 //
     /*  736443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  736454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  736457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  736460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  736463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736489 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  736492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736511 */     GIR_RootConstrainSelectedInstOperands,
     /*  736512 */     // GIR_Coverage, 12201,
     /*  736512 */     GIR_EraseRootFromParent_Done,
     /*  736513 */   // Label 11572: @736513
     /*  736513 */   GIM_Try, /*On fail goto*//*Label 11573*/ GIMT_Encode4(736588), // Rule ID 12204 //
     /*  736518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  736529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  736532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  736535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  736538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736564 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  736567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736586 */     GIR_RootConstrainSelectedInstOperands,
     /*  736587 */     // GIR_Coverage, 12204,
     /*  736587 */     GIR_EraseRootFromParent_Done,
     /*  736588 */   // Label 11573: @736588
     /*  736588 */   GIM_Try, /*On fail goto*//*Label 11574*/ GIMT_Encode4(736663), // Rule ID 12205 //
     /*  736593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  736604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  736607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  736610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  736613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736639 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  736642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736661 */     GIR_RootConstrainSelectedInstOperands,
     /*  736662 */     // GIR_Coverage, 12205,
     /*  736662 */     GIR_EraseRootFromParent_Done,
     /*  736663 */   // Label 11574: @736663
     /*  736663 */   GIM_Try, /*On fail goto*//*Label 11575*/ GIMT_Encode4(736738), // Rule ID 12208 //
     /*  736668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  736679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  736682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  736685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  736688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736714 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  736714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  736717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736736 */     GIR_RootConstrainSelectedInstOperands,
     /*  736737 */     // GIR_Coverage, 12208,
     /*  736737 */     GIR_EraseRootFromParent_Done,
     /*  736738 */   // Label 11575: @736738
     /*  736738 */   GIM_Try, /*On fail goto*//*Label 11576*/ GIMT_Encode4(736813), // Rule ID 12209 //
     /*  736743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  736754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  736757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  736760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  736763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736789 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  736789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  736792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736811 */     GIR_RootConstrainSelectedInstOperands,
     /*  736812 */     // GIR_Coverage, 12209,
     /*  736812 */     GIR_EraseRootFromParent_Done,
     /*  736813 */   // Label 11576: @736813
     /*  736813 */   GIM_Try, /*On fail goto*//*Label 11577*/ GIMT_Encode4(736888), // Rule ID 12212 //
     /*  736818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  736829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  736832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  736835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  736838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736864 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  736864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  736867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736886 */     GIR_RootConstrainSelectedInstOperands,
     /*  736887 */     // GIR_Coverage, 12212,
     /*  736887 */     GIR_EraseRootFromParent_Done,
     /*  736888 */   // Label 11577: @736888
     /*  736888 */   GIM_Try, /*On fail goto*//*Label 11578*/ GIMT_Encode4(736963), // Rule ID 12213 //
     /*  736893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  736904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  736907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  736910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  736913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736939 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  736939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  736942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736961 */     GIR_RootConstrainSelectedInstOperands,
     /*  736962 */     // GIR_Coverage, 12213,
     /*  736962 */     GIR_EraseRootFromParent_Done,
     /*  736963 */   // Label 11578: @736963
     /*  736963 */   GIM_Try, /*On fail goto*//*Label 11579*/ GIMT_Encode4(737038), // Rule ID 12216 //
     /*  736968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  736979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  736982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  736985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  736988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  737017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737036 */     GIR_RootConstrainSelectedInstOperands,
     /*  737037 */     // GIR_Coverage, 12216,
     /*  737037 */     GIR_EraseRootFromParent_Done,
     /*  737038 */   // Label 11579: @737038
     /*  737038 */   GIM_Try, /*On fail goto*//*Label 11580*/ GIMT_Encode4(737113), // Rule ID 12217 //
     /*  737043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  737054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  737057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  737060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  737063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737089 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  737089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  737092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737111 */     GIR_RootConstrainSelectedInstOperands,
     /*  737112 */     // GIR_Coverage, 12217,
     /*  737112 */     GIR_EraseRootFromParent_Done,
     /*  737113 */   // Label 11580: @737113
     /*  737113 */   GIM_Try, /*On fail goto*//*Label 11581*/ GIMT_Encode4(737188), // Rule ID 12220 //
     /*  737118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  737129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  737132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  737135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  737138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737164 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  737167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737186 */     GIR_RootConstrainSelectedInstOperands,
     /*  737187 */     // GIR_Coverage, 12220,
     /*  737187 */     GIR_EraseRootFromParent_Done,
     /*  737188 */   // Label 11581: @737188
     /*  737188 */   GIM_Try, /*On fail goto*//*Label 11582*/ GIMT_Encode4(737263), // Rule ID 12221 //
     /*  737193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  737204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  737207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  737210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  737213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737239 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  737242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737261 */     GIR_RootConstrainSelectedInstOperands,
     /*  737262 */     // GIR_Coverage, 12221,
     /*  737262 */     GIR_EraseRootFromParent_Done,
     /*  737263 */   // Label 11582: @737263
     /*  737263 */   GIM_Try, /*On fail goto*//*Label 11583*/ GIMT_Encode4(737338), // Rule ID 12224 //
     /*  737268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  737285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  737288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737314 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  737317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737336 */     GIR_RootConstrainSelectedInstOperands,
     /*  737337 */     // GIR_Coverage, 12224,
     /*  737337 */     GIR_EraseRootFromParent_Done,
     /*  737338 */   // Label 11583: @737338
     /*  737338 */   GIM_Try, /*On fail goto*//*Label 11584*/ GIMT_Encode4(737413), // Rule ID 12225 //
     /*  737343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  737360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  737363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737389 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  737392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737411 */     GIR_RootConstrainSelectedInstOperands,
     /*  737412 */     // GIR_Coverage, 12225,
     /*  737412 */     GIR_EraseRootFromParent_Done,
     /*  737413 */   // Label 11584: @737413
     /*  737413 */   GIM_Try, /*On fail goto*//*Label 11585*/ GIMT_Encode4(737488), // Rule ID 12228 //
     /*  737418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  737435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  737467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737486 */     GIR_RootConstrainSelectedInstOperands,
     /*  737487 */     // GIR_Coverage, 12228,
     /*  737487 */     GIR_EraseRootFromParent_Done,
     /*  737488 */   // Label 11585: @737488
     /*  737488 */   GIM_Try, /*On fail goto*//*Label 11586*/ GIMT_Encode4(737563), // Rule ID 12229 //
     /*  737493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  737510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737539 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  737539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  737542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737561 */     GIR_RootConstrainSelectedInstOperands,
     /*  737562 */     // GIR_Coverage, 12229,
     /*  737562 */     GIR_EraseRootFromParent_Done,
     /*  737563 */   // Label 11586: @737563
     /*  737563 */   GIM_Try, /*On fail goto*//*Label 11587*/ GIMT_Encode4(737638), // Rule ID 12232 //
     /*  737568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  737571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  737579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  737582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  737585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  737588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737614 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  737614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  737617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  737633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737636 */     GIR_RootConstrainSelectedInstOperands,
     /*  737637 */     // GIR_Coverage, 12232,
     /*  737637 */     GIR_EraseRootFromParent_Done,
     /*  737638 */   // Label 11587: @737638
     /*  737638 */   GIM_Try, /*On fail goto*//*Label 11588*/ GIMT_Encode4(737713), // Rule ID 12233 //
     /*  737643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  737646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  737654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  737657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  737660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  737663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737689 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  737689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  737692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  737708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737711 */     GIR_RootConstrainSelectedInstOperands,
     /*  737712 */     // GIR_Coverage, 12233,
     /*  737712 */     GIR_EraseRootFromParent_Done,
     /*  737713 */   // Label 11588: @737713
     /*  737713 */   GIM_Try, /*On fail goto*//*Label 11589*/ GIMT_Encode4(737788), // Rule ID 12236 //
     /*  737718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  737729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  737732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  737735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  737738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737764 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  737767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737786 */     GIR_RootConstrainSelectedInstOperands,
     /*  737787 */     // GIR_Coverage, 12236,
     /*  737787 */     GIR_EraseRootFromParent_Done,
     /*  737788 */   // Label 11589: @737788
     /*  737788 */   GIM_Try, /*On fail goto*//*Label 11590*/ GIMT_Encode4(737863), // Rule ID 12237 //
     /*  737793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  737804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  737807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  737810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  737813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737839 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  737842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737861 */     GIR_RootConstrainSelectedInstOperands,
     /*  737862 */     // GIR_Coverage, 12237,
     /*  737862 */     GIR_EraseRootFromParent_Done,
     /*  737863 */   // Label 11590: @737863
     /*  737863 */   GIM_Try, /*On fail goto*//*Label 11591*/ GIMT_Encode4(737938), // Rule ID 12240 //
     /*  737868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  737879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  737882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  737885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  737888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737914 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  737917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737936 */     GIR_RootConstrainSelectedInstOperands,
     /*  737937 */     // GIR_Coverage, 12240,
     /*  737937 */     GIR_EraseRootFromParent_Done,
     /*  737938 */   // Label 11591: @737938
     /*  737938 */   GIM_Try, /*On fail goto*//*Label 11592*/ GIMT_Encode4(738013), // Rule ID 12241 //
     /*  737943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  737954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  737957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  737960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  737963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737989 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  737992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738011 */     GIR_RootConstrainSelectedInstOperands,
     /*  738012 */     // GIR_Coverage, 12241,
     /*  738012 */     GIR_EraseRootFromParent_Done,
     /*  738013 */   // Label 11592: @738013
     /*  738013 */   GIM_Try, /*On fail goto*//*Label 11593*/ GIMT_Encode4(738088), // Rule ID 12244 //
     /*  738018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  738029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  738032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  738035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  738038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738064 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  738067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738086 */     GIR_RootConstrainSelectedInstOperands,
     /*  738087 */     // GIR_Coverage, 12244,
     /*  738087 */     GIR_EraseRootFromParent_Done,
     /*  738088 */   // Label 11593: @738088
     /*  738088 */   GIM_Try, /*On fail goto*//*Label 11594*/ GIMT_Encode4(738163), // Rule ID 12245 //
     /*  738093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  738104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  738107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  738110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  738113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738139 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  738142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738161 */     GIR_RootConstrainSelectedInstOperands,
     /*  738162 */     // GIR_Coverage, 12245,
     /*  738162 */     GIR_EraseRootFromParent_Done,
     /*  738163 */   // Label 11594: @738163
     /*  738163 */   GIM_Try, /*On fail goto*//*Label 11595*/ GIMT_Encode4(738238), // Rule ID 12248 //
     /*  738168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  738179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  738182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  738185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  738188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738214 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  738217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738236 */     GIR_RootConstrainSelectedInstOperands,
     /*  738237 */     // GIR_Coverage, 12248,
     /*  738237 */     GIR_EraseRootFromParent_Done,
     /*  738238 */   // Label 11595: @738238
     /*  738238 */   GIM_Try, /*On fail goto*//*Label 11596*/ GIMT_Encode4(738313), // Rule ID 12249 //
     /*  738243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  738254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  738257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  738260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  738263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738289 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  738292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738311 */     GIR_RootConstrainSelectedInstOperands,
     /*  738312 */     // GIR_Coverage, 12249,
     /*  738312 */     GIR_EraseRootFromParent_Done,
     /*  738313 */   // Label 11596: @738313
     /*  738313 */   GIM_Try, /*On fail goto*//*Label 11597*/ GIMT_Encode4(738388), // Rule ID 12252 //
     /*  738318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  738329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  738332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  738335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  738338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738364 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  738367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738386 */     GIR_RootConstrainSelectedInstOperands,
     /*  738387 */     // GIR_Coverage, 12252,
     /*  738387 */     GIR_EraseRootFromParent_Done,
     /*  738388 */   // Label 11597: @738388
     /*  738388 */   GIM_Try, /*On fail goto*//*Label 11598*/ GIMT_Encode4(738463), // Rule ID 12253 //
     /*  738393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  738404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  738407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  738410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  738413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738439 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  738442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738461 */     GIR_RootConstrainSelectedInstOperands,
     /*  738462 */     // GIR_Coverage, 12253,
     /*  738462 */     GIR_EraseRootFromParent_Done,
     /*  738463 */   // Label 11598: @738463
     /*  738463 */   GIM_Try, /*On fail goto*//*Label 11599*/ GIMT_Encode4(738538), // Rule ID 12256 //
     /*  738468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  738479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  738482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  738485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  738488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738514 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  738517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738536 */     GIR_RootConstrainSelectedInstOperands,
     /*  738537 */     // GIR_Coverage, 12256,
     /*  738537 */     GIR_EraseRootFromParent_Done,
     /*  738538 */   // Label 11599: @738538
     /*  738538 */   GIM_Try, /*On fail goto*//*Label 11600*/ GIMT_Encode4(738613), // Rule ID 12257 //
     /*  738543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  738554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  738557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  738560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  738563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738589 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  738592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738611 */     GIR_RootConstrainSelectedInstOperands,
     /*  738612 */     // GIR_Coverage, 12257,
     /*  738612 */     GIR_EraseRootFromParent_Done,
     /*  738613 */   // Label 11600: @738613
     /*  738613 */   GIM_Try, /*On fail goto*//*Label 11601*/ GIMT_Encode4(738688), // Rule ID 12260 //
     /*  738618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  738629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  738632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  738635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  738638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  738664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  738667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738686 */     GIR_RootConstrainSelectedInstOperands,
     /*  738687 */     // GIR_Coverage, 12260,
     /*  738687 */     GIR_EraseRootFromParent_Done,
     /*  738688 */   // Label 11601: @738688
     /*  738688 */   GIM_Try, /*On fail goto*//*Label 11602*/ GIMT_Encode4(738763), // Rule ID 12261 //
     /*  738693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  738704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  738707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  738710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  738713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738739 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  738739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  738742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738761 */     GIR_RootConstrainSelectedInstOperands,
     /*  738762 */     // GIR_Coverage, 12261,
     /*  738762 */     GIR_EraseRootFromParent_Done,
     /*  738763 */   // Label 11602: @738763
     /*  738763 */   GIM_Try, /*On fail goto*//*Label 11603*/ GIMT_Encode4(738838), // Rule ID 12264 //
     /*  738768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  738779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  738782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  738785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  738788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738814 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  738814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  738817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738836 */     GIR_RootConstrainSelectedInstOperands,
     /*  738837 */     // GIR_Coverage, 12264,
     /*  738837 */     GIR_EraseRootFromParent_Done,
     /*  738838 */   // Label 11603: @738838
     /*  738838 */   GIM_Try, /*On fail goto*//*Label 11604*/ GIMT_Encode4(738913), // Rule ID 12265 //
     /*  738843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  738854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  738857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  738860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  738863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738889 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  738889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  738892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738911 */     GIR_RootConstrainSelectedInstOperands,
     /*  738912 */     // GIR_Coverage, 12265,
     /*  738912 */     GIR_EraseRootFromParent_Done,
     /*  738913 */   // Label 11604: @738913
     /*  738913 */   GIM_Try, /*On fail goto*//*Label 11605*/ GIMT_Encode4(738988), // Rule ID 12268 //
     /*  738918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  738929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  738932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  738935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  738938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738964 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  738964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  738967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738986 */     GIR_RootConstrainSelectedInstOperands,
     /*  738987 */     // GIR_Coverage, 12268,
     /*  738987 */     GIR_EraseRootFromParent_Done,
     /*  738988 */   // Label 11605: @738988
     /*  738988 */   GIM_Try, /*On fail goto*//*Label 11606*/ GIMT_Encode4(739063), // Rule ID 12269 //
     /*  738993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  739004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  739007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  739010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  739013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739039 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  739042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739061 */     GIR_RootConstrainSelectedInstOperands,
     /*  739062 */     // GIR_Coverage, 12269,
     /*  739062 */     GIR_EraseRootFromParent_Done,
     /*  739063 */   // Label 11606: @739063
     /*  739063 */   GIM_Try, /*On fail goto*//*Label 11607*/ GIMT_Encode4(739138), // Rule ID 12272 //
     /*  739068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  739079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  739082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  739085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  739088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  739117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739136 */     GIR_RootConstrainSelectedInstOperands,
     /*  739137 */     // GIR_Coverage, 12272,
     /*  739137 */     GIR_EraseRootFromParent_Done,
     /*  739138 */   // Label 11607: @739138
     /*  739138 */   GIM_Try, /*On fail goto*//*Label 11608*/ GIMT_Encode4(739213), // Rule ID 12273 //
     /*  739143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  739154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  739157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  739160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  739163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739189 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  739192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739211 */     GIR_RootConstrainSelectedInstOperands,
     /*  739212 */     // GIR_Coverage, 12273,
     /*  739212 */     GIR_EraseRootFromParent_Done,
     /*  739213 */   // Label 11608: @739213
     /*  739213 */   GIM_Try, /*On fail goto*//*Label 11609*/ GIMT_Encode4(739288), // Rule ID 12276 //
     /*  739218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  739229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  739232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  739235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  739238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  739267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739286 */     GIR_RootConstrainSelectedInstOperands,
     /*  739287 */     // GIR_Coverage, 12276,
     /*  739287 */     GIR_EraseRootFromParent_Done,
     /*  739288 */   // Label 11609: @739288
     /*  739288 */   GIM_Try, /*On fail goto*//*Label 11610*/ GIMT_Encode4(739363), // Rule ID 12277 //
     /*  739293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  739304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  739307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  739310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  739313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739339 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  739342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739361 */     GIR_RootConstrainSelectedInstOperands,
     /*  739362 */     // GIR_Coverage, 12277,
     /*  739362 */     GIR_EraseRootFromParent_Done,
     /*  739363 */   // Label 11610: @739363
     /*  739363 */   GIM_Try, /*On fail goto*//*Label 11611*/ GIMT_Encode4(739438), // Rule ID 12280 //
     /*  739368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  739379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  739382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  739385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  739388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739414 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  739417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739436 */     GIR_RootConstrainSelectedInstOperands,
     /*  739437 */     // GIR_Coverage, 12280,
     /*  739437 */     GIR_EraseRootFromParent_Done,
     /*  739438 */   // Label 11611: @739438
     /*  739438 */   GIM_Try, /*On fail goto*//*Label 11612*/ GIMT_Encode4(739513), // Rule ID 12281 //
     /*  739443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  739454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  739457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  739460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  739463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739489 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  739492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739511 */     GIR_RootConstrainSelectedInstOperands,
     /*  739512 */     // GIR_Coverage, 12281,
     /*  739512 */     GIR_EraseRootFromParent_Done,
     /*  739513 */   // Label 11612: @739513
     /*  739513 */   GIM_Try, /*On fail goto*//*Label 11613*/ GIMT_Encode4(739588), // Rule ID 12284 //
     /*  739518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  739529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  739532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  739535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739564 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  739567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739586 */     GIR_RootConstrainSelectedInstOperands,
     /*  739587 */     // GIR_Coverage, 12284,
     /*  739587 */     GIR_EraseRootFromParent_Done,
     /*  739588 */   // Label 11613: @739588
     /*  739588 */   GIM_Try, /*On fail goto*//*Label 11614*/ GIMT_Encode4(739663), // Rule ID 12285 //
     /*  739593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  739604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  739607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  739610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739639 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  739639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  739642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739661 */     GIR_RootConstrainSelectedInstOperands,
     /*  739662 */     // GIR_Coverage, 12285,
     /*  739662 */     GIR_EraseRootFromParent_Done,
     /*  739663 */   // Label 11614: @739663
     /*  739663 */   GIM_Try, /*On fail goto*//*Label 11615*/ GIMT_Encode4(739738), // Rule ID 12288 //
     /*  739668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  739679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  739682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  739685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739714 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  739717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739736 */     GIR_RootConstrainSelectedInstOperands,
     /*  739737 */     // GIR_Coverage, 12288,
     /*  739737 */     GIR_EraseRootFromParent_Done,
     /*  739738 */   // Label 11615: @739738
     /*  739738 */   GIM_Try, /*On fail goto*//*Label 11616*/ GIMT_Encode4(739813), // Rule ID 12289 //
     /*  739743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  739754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  739757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  739760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739789 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  739789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  739792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739811 */     GIR_RootConstrainSelectedInstOperands,
     /*  739812 */     // GIR_Coverage, 12289,
     /*  739812 */     GIR_EraseRootFromParent_Done,
     /*  739813 */   // Label 11616: @739813
     /*  739813 */   GIM_Try, /*On fail goto*//*Label 11617*/ GIMT_Encode4(739888), // Rule ID 12292 //
     /*  739818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  739829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  739832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  739835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739864 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  739867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739886 */     GIR_RootConstrainSelectedInstOperands,
     /*  739887 */     // GIR_Coverage, 12292,
     /*  739887 */     GIR_EraseRootFromParent_Done,
     /*  739888 */   // Label 11617: @739888
     /*  739888 */   GIM_Try, /*On fail goto*//*Label 11618*/ GIMT_Encode4(739963), // Rule ID 12293 //
     /*  739893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  739904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  739907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  739910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739939 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  739939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  739942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739961 */     GIR_RootConstrainSelectedInstOperands,
     /*  739962 */     // GIR_Coverage, 12293,
     /*  739962 */     GIR_EraseRootFromParent_Done,
     /*  739963 */   // Label 11618: @739963
     /*  739963 */   GIM_Try, /*On fail goto*//*Label 11619*/ GIMT_Encode4(740038), // Rule ID 12296 //
     /*  739968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  739979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  739982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  739985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740014 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  740017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740036 */     GIR_RootConstrainSelectedInstOperands,
     /*  740037 */     // GIR_Coverage, 12296,
     /*  740037 */     GIR_EraseRootFromParent_Done,
     /*  740038 */   // Label 11619: @740038
     /*  740038 */   GIM_Try, /*On fail goto*//*Label 11620*/ GIMT_Encode4(740113), // Rule ID 12297 //
     /*  740043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  740054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  740057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  740060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740089 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  740092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740111 */     GIR_RootConstrainSelectedInstOperands,
     /*  740112 */     // GIR_Coverage, 12297,
     /*  740112 */     GIR_EraseRootFromParent_Done,
     /*  740113 */   // Label 11620: @740113
     /*  740113 */   GIM_Try, /*On fail goto*//*Label 11621*/ GIMT_Encode4(740188), // Rule ID 12300 //
     /*  740118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  740129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  740132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  740135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740164 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  740167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740186 */     GIR_RootConstrainSelectedInstOperands,
     /*  740187 */     // GIR_Coverage, 12300,
     /*  740187 */     GIR_EraseRootFromParent_Done,
     /*  740188 */   // Label 11621: @740188
     /*  740188 */   GIM_Try, /*On fail goto*//*Label 11622*/ GIMT_Encode4(740263), // Rule ID 12301 //
     /*  740193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  740204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  740207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  740210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740239 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  740242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740261 */     GIR_RootConstrainSelectedInstOperands,
     /*  740262 */     // GIR_Coverage, 12301,
     /*  740262 */     GIR_EraseRootFromParent_Done,
     /*  740263 */   // Label 11622: @740263
     /*  740263 */   GIM_Try, /*On fail goto*//*Label 11623*/ GIMT_Encode4(740338), // Rule ID 12304 //
     /*  740268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  740279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  740282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  740285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740314 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  740314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  740317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740336 */     GIR_RootConstrainSelectedInstOperands,
     /*  740337 */     // GIR_Coverage, 12304,
     /*  740337 */     GIR_EraseRootFromParent_Done,
     /*  740338 */   // Label 11623: @740338
     /*  740338 */   GIM_Try, /*On fail goto*//*Label 11624*/ GIMT_Encode4(740413), // Rule ID 12305 //
     /*  740343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  740354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  740357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  740360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740389 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  740389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  740392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740411 */     GIR_RootConstrainSelectedInstOperands,
     /*  740412 */     // GIR_Coverage, 12305,
     /*  740412 */     GIR_EraseRootFromParent_Done,
     /*  740413 */   // Label 11624: @740413
     /*  740413 */   GIM_Try, /*On fail goto*//*Label 11625*/ GIMT_Encode4(740488), // Rule ID 12308 //
     /*  740418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  740429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  740432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  740435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740464 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  740467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740486 */     GIR_RootConstrainSelectedInstOperands,
     /*  740487 */     // GIR_Coverage, 12308,
     /*  740487 */     GIR_EraseRootFromParent_Done,
     /*  740488 */   // Label 11625: @740488
     /*  740488 */   GIM_Try, /*On fail goto*//*Label 11626*/ GIMT_Encode4(740563), // Rule ID 12309 //
     /*  740493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  740504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  740507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  740510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740539 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  740542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740561 */     GIR_RootConstrainSelectedInstOperands,
     /*  740562 */     // GIR_Coverage, 12309,
     /*  740562 */     GIR_EraseRootFromParent_Done,
     /*  740563 */   // Label 11626: @740563
     /*  740563 */   GIM_Try, /*On fail goto*//*Label 11627*/ GIMT_Encode4(740638), // Rule ID 12312 //
     /*  740568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  740579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  740582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  740585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740614 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  740617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740636 */     GIR_RootConstrainSelectedInstOperands,
     /*  740637 */     // GIR_Coverage, 12312,
     /*  740637 */     GIR_EraseRootFromParent_Done,
     /*  740638 */   // Label 11627: @740638
     /*  740638 */   GIM_Try, /*On fail goto*//*Label 11628*/ GIMT_Encode4(740713), // Rule ID 12313 //
     /*  740643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  740654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  740657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  740660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740689 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  740692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740711 */     GIR_RootConstrainSelectedInstOperands,
     /*  740712 */     // GIR_Coverage, 12313,
     /*  740712 */     GIR_EraseRootFromParent_Done,
     /*  740713 */   // Label 11628: @740713
     /*  740713 */   GIM_Try, /*On fail goto*//*Label 11629*/ GIMT_Encode4(740788), // Rule ID 12316 //
     /*  740718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  740729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  740732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  740735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740764 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  740764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  740767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740786 */     GIR_RootConstrainSelectedInstOperands,
     /*  740787 */     // GIR_Coverage, 12316,
     /*  740787 */     GIR_EraseRootFromParent_Done,
     /*  740788 */   // Label 11629: @740788
     /*  740788 */   GIM_Try, /*On fail goto*//*Label 11630*/ GIMT_Encode4(740863), // Rule ID 12317 //
     /*  740793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  740804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  740807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  740810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740839 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  740839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  740842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740861 */     GIR_RootConstrainSelectedInstOperands,
     /*  740862 */     // GIR_Coverage, 12317,
     /*  740862 */     GIR_EraseRootFromParent_Done,
     /*  740863 */   // Label 11630: @740863
     /*  740863 */   GIM_Try, /*On fail goto*//*Label 11631*/ GIMT_Encode4(740938), // Rule ID 12320 //
     /*  740868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  740871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  740879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  740882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  740885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740914 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  740914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  740917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  740933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740936 */     GIR_RootConstrainSelectedInstOperands,
     /*  740937 */     // GIR_Coverage, 12320,
     /*  740937 */     GIR_EraseRootFromParent_Done,
     /*  740938 */   // Label 11631: @740938
     /*  740938 */   GIM_Try, /*On fail goto*//*Label 11632*/ GIMT_Encode4(741013), // Rule ID 12321 //
     /*  740943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  740946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  740954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  740957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  740960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740989 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  740989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  740992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  741008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741011 */     GIR_RootConstrainSelectedInstOperands,
     /*  741012 */     // GIR_Coverage, 12321,
     /*  741012 */     GIR_EraseRootFromParent_Done,
     /*  741013 */   // Label 11632: @741013
     /*  741013 */   GIM_Try, /*On fail goto*//*Label 11633*/ GIMT_Encode4(741088), // Rule ID 12324 //
     /*  741018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  741029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  741032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  741035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741064 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  741067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741086 */     GIR_RootConstrainSelectedInstOperands,
     /*  741087 */     // GIR_Coverage, 12324,
     /*  741087 */     GIR_EraseRootFromParent_Done,
     /*  741088 */   // Label 11633: @741088
     /*  741088 */   GIM_Try, /*On fail goto*//*Label 11634*/ GIMT_Encode4(741163), // Rule ID 12325 //
     /*  741093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  741104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  741107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  741110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741139 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  741142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741161 */     GIR_RootConstrainSelectedInstOperands,
     /*  741162 */     // GIR_Coverage, 12325,
     /*  741162 */     GIR_EraseRootFromParent_Done,
     /*  741163 */   // Label 11634: @741163
     /*  741163 */   GIM_Try, /*On fail goto*//*Label 11635*/ GIMT_Encode4(741238), // Rule ID 12328 //
     /*  741168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  741179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  741182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  741185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741214 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  741217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741236 */     GIR_RootConstrainSelectedInstOperands,
     /*  741237 */     // GIR_Coverage, 12328,
     /*  741237 */     GIR_EraseRootFromParent_Done,
     /*  741238 */   // Label 11635: @741238
     /*  741238 */   GIM_Try, /*On fail goto*//*Label 11636*/ GIMT_Encode4(741313), // Rule ID 12329 //
     /*  741243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  741254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  741257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  741260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741289 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  741292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741311 */     GIR_RootConstrainSelectedInstOperands,
     /*  741312 */     // GIR_Coverage, 12329,
     /*  741312 */     GIR_EraseRootFromParent_Done,
     /*  741313 */   // Label 11636: @741313
     /*  741313 */   GIM_Try, /*On fail goto*//*Label 11637*/ GIMT_Encode4(741388), // Rule ID 12332 //
     /*  741318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  741329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  741332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  741335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741364 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  741367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741386 */     GIR_RootConstrainSelectedInstOperands,
     /*  741387 */     // GIR_Coverage, 12332,
     /*  741387 */     GIR_EraseRootFromParent_Done,
     /*  741388 */   // Label 11637: @741388
     /*  741388 */   GIM_Try, /*On fail goto*//*Label 11638*/ GIMT_Encode4(741463), // Rule ID 12333 //
     /*  741393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  741404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  741407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  741410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741439 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  741442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741461 */     GIR_RootConstrainSelectedInstOperands,
     /*  741462 */     // GIR_Coverage, 12333,
     /*  741462 */     GIR_EraseRootFromParent_Done,
     /*  741463 */   // Label 11638: @741463
     /*  741463 */   GIM_Try, /*On fail goto*//*Label 11639*/ GIMT_Encode4(741538), // Rule ID 12336 //
     /*  741468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  741479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  741482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  741485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  741517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741536 */     GIR_RootConstrainSelectedInstOperands,
     /*  741537 */     // GIR_Coverage, 12336,
     /*  741537 */     GIR_EraseRootFromParent_Done,
     /*  741538 */   // Label 11639: @741538
     /*  741538 */   GIM_Try, /*On fail goto*//*Label 11640*/ GIMT_Encode4(741613), // Rule ID 12337 //
     /*  741543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  741554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  741557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  741560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741589 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  741592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741611 */     GIR_RootConstrainSelectedInstOperands,
     /*  741612 */     // GIR_Coverage, 12337,
     /*  741612 */     GIR_EraseRootFromParent_Done,
     /*  741613 */   // Label 11640: @741613
     /*  741613 */   GIM_Try, /*On fail goto*//*Label 11641*/ GIMT_Encode4(741688), // Rule ID 12340 //
     /*  741618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  741629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  741632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  741635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741664 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  741667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741686 */     GIR_RootConstrainSelectedInstOperands,
     /*  741687 */     // GIR_Coverage, 12340,
     /*  741687 */     GIR_EraseRootFromParent_Done,
     /*  741688 */   // Label 11641: @741688
     /*  741688 */   GIM_Try, /*On fail goto*//*Label 11642*/ GIMT_Encode4(741763), // Rule ID 12341 //
     /*  741693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  741704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  741707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  741710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741739 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  741742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741761 */     GIR_RootConstrainSelectedInstOperands,
     /*  741762 */     // GIR_Coverage, 12341,
     /*  741762 */     GIR_EraseRootFromParent_Done,
     /*  741763 */   // Label 11642: @741763
     /*  741763 */   GIM_Try, /*On fail goto*//*Label 11643*/ GIMT_Encode4(741838), // Rule ID 12344 //
     /*  741768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  741779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  741782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  741785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741814 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  741817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741836 */     GIR_RootConstrainSelectedInstOperands,
     /*  741837 */     // GIR_Coverage, 12344,
     /*  741837 */     GIR_EraseRootFromParent_Done,
     /*  741838 */   // Label 11643: @741838
     /*  741838 */   GIM_Try, /*On fail goto*//*Label 11644*/ GIMT_Encode4(741913), // Rule ID 12345 //
     /*  741843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  741854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  741857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  741860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741889 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  741892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741911 */     GIR_RootConstrainSelectedInstOperands,
     /*  741912 */     // GIR_Coverage, 12345,
     /*  741912 */     GIR_EraseRootFromParent_Done,
     /*  741913 */   // Label 11644: @741913
     /*  741913 */   GIM_Try, /*On fail goto*//*Label 11645*/ GIMT_Encode4(741988), // Rule ID 12348 //
     /*  741918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  741929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  741932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  741935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  741964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  741967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741986 */     GIR_RootConstrainSelectedInstOperands,
     /*  741987 */     // GIR_Coverage, 12348,
     /*  741987 */     GIR_EraseRootFromParent_Done,
     /*  741988 */   // Label 11645: @741988
     /*  741988 */   GIM_Try, /*On fail goto*//*Label 11646*/ GIMT_Encode4(742063), // Rule ID 12349 //
     /*  741993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  742004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  742007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  742010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742039 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  742042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742061 */     GIR_RootConstrainSelectedInstOperands,
     /*  742062 */     // GIR_Coverage, 12349,
     /*  742062 */     GIR_EraseRootFromParent_Done,
     /*  742063 */   // Label 11646: @742063
     /*  742063 */   GIM_Try, /*On fail goto*//*Label 11647*/ GIMT_Encode4(742138), // Rule ID 12352 //
     /*  742068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  742079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  742082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  742085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742114 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  742117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742136 */     GIR_RootConstrainSelectedInstOperands,
     /*  742137 */     // GIR_Coverage, 12352,
     /*  742137 */     GIR_EraseRootFromParent_Done,
     /*  742138 */   // Label 11647: @742138
     /*  742138 */   GIM_Try, /*On fail goto*//*Label 11648*/ GIMT_Encode4(742213), // Rule ID 12353 //
     /*  742143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  742154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  742157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  742160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742189 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  742192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742211 */     GIR_RootConstrainSelectedInstOperands,
     /*  742212 */     // GIR_Coverage, 12353,
     /*  742212 */     GIR_EraseRootFromParent_Done,
     /*  742213 */   // Label 11648: @742213
     /*  742213 */   GIM_Try, /*On fail goto*//*Label 11649*/ GIMT_Encode4(742288), // Rule ID 12356 //
     /*  742218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  742229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  742232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  742235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742264 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  742267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742286 */     GIR_RootConstrainSelectedInstOperands,
     /*  742287 */     // GIR_Coverage, 12356,
     /*  742287 */     GIR_EraseRootFromParent_Done,
     /*  742288 */   // Label 11649: @742288
     /*  742288 */   GIM_Try, /*On fail goto*//*Label 11650*/ GIMT_Encode4(742363), // Rule ID 12357 //
     /*  742293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  742304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  742307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  742310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742339 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  742342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742361 */     GIR_RootConstrainSelectedInstOperands,
     /*  742362 */     // GIR_Coverage, 12357,
     /*  742362 */     GIR_EraseRootFromParent_Done,
     /*  742363 */   // Label 11650: @742363
     /*  742363 */   GIM_Try, /*On fail goto*//*Label 11651*/ GIMT_Encode4(742438), // Rule ID 12360 //
     /*  742368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  742379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  742382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  742385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  742414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  742417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742436 */     GIR_RootConstrainSelectedInstOperands,
     /*  742437 */     // GIR_Coverage, 12360,
     /*  742437 */     GIR_EraseRootFromParent_Done,
     /*  742438 */   // Label 11651: @742438
     /*  742438 */   GIM_Try, /*On fail goto*//*Label 11652*/ GIMT_Encode4(742513), // Rule ID 12361 //
     /*  742443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  742446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  742454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  742457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  742460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742489 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  742489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  742492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742511 */     GIR_RootConstrainSelectedInstOperands,
     /*  742512 */     // GIR_Coverage, 12361,
     /*  742512 */     GIR_EraseRootFromParent_Done,
     /*  742513 */   // Label 11652: @742513
     /*  742513 */   GIM_Try, /*On fail goto*//*Label 11653*/ GIMT_Encode4(742588), // Rule ID 12364 //
     /*  742518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  742529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  742532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  742535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742564 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  742564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  742567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742586 */     GIR_RootConstrainSelectedInstOperands,
     /*  742587 */     // GIR_Coverage, 12364,
     /*  742587 */     GIR_EraseRootFromParent_Done,
     /*  742588 */   // Label 11653: @742588
     /*  742588 */   GIM_Try, /*On fail goto*//*Label 11654*/ GIMT_Encode4(742663), // Rule ID 12365 //
     /*  742593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  742596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  742604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  742607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  742610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742639 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  742639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  742642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742661 */     GIR_RootConstrainSelectedInstOperands,
     /*  742662 */     // GIR_Coverage, 12365,
     /*  742662 */     GIR_EraseRootFromParent_Done,
     /*  742663 */   // Label 11654: @742663
     /*  742663 */   GIM_Try, /*On fail goto*//*Label 11655*/ GIMT_Encode4(742738), // Rule ID 12368 //
     /*  742668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  742679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  742682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  742685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742714 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  742714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  742717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742736 */     GIR_RootConstrainSelectedInstOperands,
     /*  742737 */     // GIR_Coverage, 12368,
     /*  742737 */     GIR_EraseRootFromParent_Done,
     /*  742738 */   // Label 11655: @742738
     /*  742738 */   GIM_Try, /*On fail goto*//*Label 11656*/ GIMT_Encode4(742813), // Rule ID 12369 //
     /*  742743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  742746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  742754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  742757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  742760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742789 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  742789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  742792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742811 */     GIR_RootConstrainSelectedInstOperands,
     /*  742812 */     // GIR_Coverage, 12369,
     /*  742812 */     GIR_EraseRootFromParent_Done,
     /*  742813 */   // Label 11656: @742813
     /*  742813 */   GIM_Try, /*On fail goto*//*Label 11657*/ GIMT_Encode4(742888), // Rule ID 12372 //
     /*  742818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  742829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  742832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  742835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  742838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742864 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  742864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  742867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742886 */     GIR_RootConstrainSelectedInstOperands,
     /*  742887 */     // GIR_Coverage, 12372,
     /*  742887 */     GIR_EraseRootFromParent_Done,
     /*  742888 */   // Label 11657: @742888
     /*  742888 */   GIM_Try, /*On fail goto*//*Label 11658*/ GIMT_Encode4(742963), // Rule ID 12373 //
     /*  742893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  742904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  742907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  742910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  742913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742939 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  742939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  742942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742961 */     GIR_RootConstrainSelectedInstOperands,
     /*  742962 */     // GIR_Coverage, 12373,
     /*  742962 */     GIR_EraseRootFromParent_Done,
     /*  742963 */   // Label 11658: @742963
     /*  742963 */   GIM_Try, /*On fail goto*//*Label 11659*/ GIMT_Encode4(743038), // Rule ID 12376 //
     /*  742968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  742979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  742982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  742985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  742988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743014 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743036 */     GIR_RootConstrainSelectedInstOperands,
     /*  743037 */     // GIR_Coverage, 12376,
     /*  743037 */     GIR_EraseRootFromParent_Done,
     /*  743038 */   // Label 11659: @743038
     /*  743038 */   GIM_Try, /*On fail goto*//*Label 11660*/ GIMT_Encode4(743113), // Rule ID 12377 //
     /*  743043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  743054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  743057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  743060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  743063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743089 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743111 */     GIR_RootConstrainSelectedInstOperands,
     /*  743112 */     // GIR_Coverage, 12377,
     /*  743112 */     GIR_EraseRootFromParent_Done,
     /*  743113 */   // Label 11660: @743113
     /*  743113 */   GIM_Try, /*On fail goto*//*Label 11661*/ GIMT_Encode4(743188), // Rule ID 12380 //
     /*  743118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  743129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  743132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  743135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  743138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743164 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743186 */     GIR_RootConstrainSelectedInstOperands,
     /*  743187 */     // GIR_Coverage, 12380,
     /*  743187 */     GIR_EraseRootFromParent_Done,
     /*  743188 */   // Label 11661: @743188
     /*  743188 */   GIM_Try, /*On fail goto*//*Label 11662*/ GIMT_Encode4(743263), // Rule ID 12381 //
     /*  743193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  743204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  743207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  743210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  743213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743239 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743261 */     GIR_RootConstrainSelectedInstOperands,
     /*  743262 */     // GIR_Coverage, 12381,
     /*  743262 */     GIR_EraseRootFromParent_Done,
     /*  743263 */   // Label 11662: @743263
     /*  743263 */   GIM_Try, /*On fail goto*//*Label 11663*/ GIMT_Encode4(743338), // Rule ID 12384 //
     /*  743268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  743279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  743282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  743285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  743288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  743317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743336 */     GIR_RootConstrainSelectedInstOperands,
     /*  743337 */     // GIR_Coverage, 12384,
     /*  743337 */     GIR_EraseRootFromParent_Done,
     /*  743338 */   // Label 11663: @743338
     /*  743338 */   GIM_Try, /*On fail goto*//*Label 11664*/ GIMT_Encode4(743413), // Rule ID 12385 //
     /*  743343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  743354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  743357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  743360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  743363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743389 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  743392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743411 */     GIR_RootConstrainSelectedInstOperands,
     /*  743412 */     // GIR_Coverage, 12385,
     /*  743412 */     GIR_EraseRootFromParent_Done,
     /*  743413 */   // Label 11664: @743413
     /*  743413 */   GIM_Try, /*On fail goto*//*Label 11665*/ GIMT_Encode4(743488), // Rule ID 12388 //
     /*  743418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  743429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  743432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  743435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  743438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743464 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  743467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743486 */     GIR_RootConstrainSelectedInstOperands,
     /*  743487 */     // GIR_Coverage, 12388,
     /*  743487 */     GIR_EraseRootFromParent_Done,
     /*  743488 */   // Label 11665: @743488
     /*  743488 */   GIM_Try, /*On fail goto*//*Label 11666*/ GIMT_Encode4(743563), // Rule ID 12389 //
     /*  743493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  743504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  743507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  743510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  743513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743539 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  743542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743561 */     GIR_RootConstrainSelectedInstOperands,
     /*  743562 */     // GIR_Coverage, 12389,
     /*  743562 */     GIR_EraseRootFromParent_Done,
     /*  743563 */   // Label 11666: @743563
     /*  743563 */   GIM_Try, /*On fail goto*//*Label 11667*/ GIMT_Encode4(743638), // Rule ID 12392 //
     /*  743568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  743579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  743582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  743585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  743588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  743617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743636 */     GIR_RootConstrainSelectedInstOperands,
     /*  743637 */     // GIR_Coverage, 12392,
     /*  743637 */     GIR_EraseRootFromParent_Done,
     /*  743638 */   // Label 11667: @743638
     /*  743638 */   GIM_Try, /*On fail goto*//*Label 11668*/ GIMT_Encode4(743713), // Rule ID 12393 //
     /*  743643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  743654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  743657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  743660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  743663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743689 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  743692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743711 */     GIR_RootConstrainSelectedInstOperands,
     /*  743712 */     // GIR_Coverage, 12393,
     /*  743712 */     GIR_EraseRootFromParent_Done,
     /*  743713 */   // Label 11668: @743713
     /*  743713 */   GIM_Try, /*On fail goto*//*Label 11669*/ GIMT_Encode4(743788), // Rule ID 12396 //
     /*  743718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  743729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  743732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  743735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  743738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743764 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743786 */     GIR_RootConstrainSelectedInstOperands,
     /*  743787 */     // GIR_Coverage, 12396,
     /*  743787 */     GIR_EraseRootFromParent_Done,
     /*  743788 */   // Label 11669: @743788
     /*  743788 */   GIM_Try, /*On fail goto*//*Label 11670*/ GIMT_Encode4(743863), // Rule ID 12397 //
     /*  743793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  743804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  743807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  743810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  743813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743839 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743861 */     GIR_RootConstrainSelectedInstOperands,
     /*  743862 */     // GIR_Coverage, 12397,
     /*  743862 */     GIR_EraseRootFromParent_Done,
     /*  743863 */   // Label 11670: @743863
     /*  743863 */   GIM_Try, /*On fail goto*//*Label 11671*/ GIMT_Encode4(743938), // Rule ID 12400 //
     /*  743868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  743879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  743882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  743885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  743888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743914 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743936 */     GIR_RootConstrainSelectedInstOperands,
     /*  743937 */     // GIR_Coverage, 12400,
     /*  743937 */     GIR_EraseRootFromParent_Done,
     /*  743938 */   // Label 11671: @743938
     /*  743938 */   GIM_Try, /*On fail goto*//*Label 11672*/ GIMT_Encode4(744013), // Rule ID 12401 //
     /*  743943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  743954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  743957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  743960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  743963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743989 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744011 */     GIR_RootConstrainSelectedInstOperands,
     /*  744012 */     // GIR_Coverage, 12401,
     /*  744012 */     GIR_EraseRootFromParent_Done,
     /*  744013 */   // Label 11672: @744013
     /*  744013 */   GIM_Try, /*On fail goto*//*Label 11673*/ GIMT_Encode4(744088), // Rule ID 12404 //
     /*  744018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  744029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  744032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  744035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744086 */     GIR_RootConstrainSelectedInstOperands,
     /*  744087 */     // GIR_Coverage, 12404,
     /*  744087 */     GIR_EraseRootFromParent_Done,
     /*  744088 */   // Label 11673: @744088
     /*  744088 */   GIM_Try, /*On fail goto*//*Label 11674*/ GIMT_Encode4(744163), // Rule ID 12405 //
     /*  744093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  744104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  744107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  744110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744161 */     GIR_RootConstrainSelectedInstOperands,
     /*  744162 */     // GIR_Coverage, 12405,
     /*  744162 */     GIR_EraseRootFromParent_Done,
     /*  744163 */   // Label 11674: @744163
     /*  744163 */   GIM_Try, /*On fail goto*//*Label 11675*/ GIMT_Encode4(744238), // Rule ID 12408 //
     /*  744168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  744179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  744182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  744185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  744188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744236 */     GIR_RootConstrainSelectedInstOperands,
     /*  744237 */     // GIR_Coverage, 12408,
     /*  744237 */     GIR_EraseRootFromParent_Done,
     /*  744238 */   // Label 11675: @744238
     /*  744238 */   GIM_Try, /*On fail goto*//*Label 11676*/ GIMT_Encode4(744313), // Rule ID 12409 //
     /*  744243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  744254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  744257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  744260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  744263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744289 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744311 */     GIR_RootConstrainSelectedInstOperands,
     /*  744312 */     // GIR_Coverage, 12409,
     /*  744312 */     GIR_EraseRootFromParent_Done,
     /*  744313 */   // Label 11676: @744313
     /*  744313 */   GIM_Try, /*On fail goto*//*Label 11677*/ GIMT_Encode4(744388), // Rule ID 12412 //
     /*  744318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  744329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  744332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  744335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  744338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744386 */     GIR_RootConstrainSelectedInstOperands,
     /*  744387 */     // GIR_Coverage, 12412,
     /*  744387 */     GIR_EraseRootFromParent_Done,
     /*  744388 */   // Label 11677: @744388
     /*  744388 */   GIM_Try, /*On fail goto*//*Label 11678*/ GIMT_Encode4(744463), // Rule ID 12413 //
     /*  744393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  744404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  744407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  744410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  744413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744439 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744461 */     GIR_RootConstrainSelectedInstOperands,
     /*  744462 */     // GIR_Coverage, 12413,
     /*  744462 */     GIR_EraseRootFromParent_Done,
     /*  744463 */   // Label 11678: @744463
     /*  744463 */   GIM_Try, /*On fail goto*//*Label 11679*/ GIMT_Encode4(744538), // Rule ID 12416 //
     /*  744468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  744471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  744479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  744482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  744485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  744488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744514 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  744517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744536 */     GIR_RootConstrainSelectedInstOperands,
     /*  744537 */     // GIR_Coverage, 12416,
     /*  744537 */     GIR_EraseRootFromParent_Done,
     /*  744538 */   // Label 11679: @744538
     /*  744538 */   GIM_Try, /*On fail goto*//*Label 11680*/ GIMT_Encode4(744613), // Rule ID 12417 //
     /*  744543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  744546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  744554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  744557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  744560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  744563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744589 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  744592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744611 */     GIR_RootConstrainSelectedInstOperands,
     /*  744612 */     // GIR_Coverage, 12417,
     /*  744612 */     GIR_EraseRootFromParent_Done,
     /*  744613 */   // Label 11680: @744613
     /*  744613 */   GIM_Try, /*On fail goto*//*Label 11681*/ GIMT_Encode4(744688), // Rule ID 12420 //
     /*  744618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  744621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  744629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  744632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  744635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  744638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744664 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744686 */     GIR_RootConstrainSelectedInstOperands,
     /*  744687 */     // GIR_Coverage, 12420,
     /*  744687 */     GIR_EraseRootFromParent_Done,
     /*  744688 */   // Label 11681: @744688
     /*  744688 */   GIM_Try, /*On fail goto*//*Label 11682*/ GIMT_Encode4(744763), // Rule ID 12421 //
     /*  744693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  744696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  744704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  744707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  744710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  744713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744739 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744761 */     GIR_RootConstrainSelectedInstOperands,
     /*  744762 */     // GIR_Coverage, 12421,
     /*  744762 */     GIR_EraseRootFromParent_Done,
     /*  744763 */   // Label 11682: @744763
     /*  744763 */   GIM_Try, /*On fail goto*//*Label 11683*/ GIMT_Encode4(744838), // Rule ID 12424 //
     /*  744768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  744771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  744779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  744782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  744785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  744788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744814 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744836 */     GIR_RootConstrainSelectedInstOperands,
     /*  744837 */     // GIR_Coverage, 12424,
     /*  744837 */     GIR_EraseRootFromParent_Done,
     /*  744838 */   // Label 11683: @744838
     /*  744838 */   GIM_Try, /*On fail goto*//*Label 11684*/ GIMT_Encode4(744913), // Rule ID 12425 //
     /*  744843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  744846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  744854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  744857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  744860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  744863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744889 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744911 */     GIR_RootConstrainSelectedInstOperands,
     /*  744912 */     // GIR_Coverage, 12425,
     /*  744912 */     GIR_EraseRootFromParent_Done,
     /*  744913 */   // Label 11684: @744913
     /*  744913 */   GIM_Try, /*On fail goto*//*Label 11685*/ GIMT_Encode4(744988), // Rule ID 12428 //
     /*  744918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  744921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  744929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  744932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  744935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  744938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744964 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744986 */     GIR_RootConstrainSelectedInstOperands,
     /*  744987 */     // GIR_Coverage, 12428,
     /*  744987 */     GIR_EraseRootFromParent_Done,
     /*  744988 */   // Label 11685: @744988
     /*  744988 */   GIM_Try, /*On fail goto*//*Label 11686*/ GIMT_Encode4(745063), // Rule ID 12429 //
     /*  744993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  744996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  745004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  745007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  745010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  745013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745039 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  745042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745061 */     GIR_RootConstrainSelectedInstOperands,
     /*  745062 */     // GIR_Coverage, 12429,
     /*  745062 */     GIR_EraseRootFromParent_Done,
     /*  745063 */   // Label 11686: @745063
     /*  745063 */   GIM_Try, /*On fail goto*//*Label 11687*/ GIMT_Encode4(745138), // Rule ID 12432 //
     /*  745068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  745079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  745082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  745085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  745117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745136 */     GIR_RootConstrainSelectedInstOperands,
     /*  745137 */     // GIR_Coverage, 12432,
     /*  745137 */     GIR_EraseRootFromParent_Done,
     /*  745138 */   // Label 11687: @745138
     /*  745138 */   GIM_Try, /*On fail goto*//*Label 11688*/ GIMT_Encode4(745213), // Rule ID 12433 //
     /*  745143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  745154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  745157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  745160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745189 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  745192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745211 */     GIR_RootConstrainSelectedInstOperands,
     /*  745212 */     // GIR_Coverage, 12433,
     /*  745212 */     GIR_EraseRootFromParent_Done,
     /*  745213 */   // Label 11688: @745213
     /*  745213 */   GIM_Try, /*On fail goto*//*Label 11689*/ GIMT_Encode4(745288), // Rule ID 12436 //
     /*  745218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  745229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  745232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  745235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  745267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745286 */     GIR_RootConstrainSelectedInstOperands,
     /*  745287 */     // GIR_Coverage, 12436,
     /*  745287 */     GIR_EraseRootFromParent_Done,
     /*  745288 */   // Label 11689: @745288
     /*  745288 */   GIM_Try, /*On fail goto*//*Label 11690*/ GIMT_Encode4(745363), // Rule ID 12437 //
     /*  745293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  745304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  745307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  745310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745339 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  745342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745361 */     GIR_RootConstrainSelectedInstOperands,
     /*  745362 */     // GIR_Coverage, 12437,
     /*  745362 */     GIR_EraseRootFromParent_Done,
     /*  745363 */   // Label 11690: @745363
     /*  745363 */   GIM_Try, /*On fail goto*//*Label 11691*/ GIMT_Encode4(745438), // Rule ID 12440 //
     /*  745368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  745379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  745382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  745385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745414 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  745417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745436 */     GIR_RootConstrainSelectedInstOperands,
     /*  745437 */     // GIR_Coverage, 12440,
     /*  745437 */     GIR_EraseRootFromParent_Done,
     /*  745438 */   // Label 11691: @745438
     /*  745438 */   GIM_Try, /*On fail goto*//*Label 11692*/ GIMT_Encode4(745513), // Rule ID 12441 //
     /*  745443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  745454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  745457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  745460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745489 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  745492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745511 */     GIR_RootConstrainSelectedInstOperands,
     /*  745512 */     // GIR_Coverage, 12441,
     /*  745512 */     GIR_EraseRootFromParent_Done,
     /*  745513 */   // Label 11692: @745513
     /*  745513 */   GIM_Try, /*On fail goto*//*Label 11693*/ GIMT_Encode4(745588), // Rule ID 12444 //
     /*  745518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  745529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  745532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  745535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745564 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  745567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745586 */     GIR_RootConstrainSelectedInstOperands,
     /*  745587 */     // GIR_Coverage, 12444,
     /*  745587 */     GIR_EraseRootFromParent_Done,
     /*  745588 */   // Label 11693: @745588
     /*  745588 */   GIM_Try, /*On fail goto*//*Label 11694*/ GIMT_Encode4(745663), // Rule ID 12445 //
     /*  745593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  745604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  745607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  745610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745639 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  745642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745661 */     GIR_RootConstrainSelectedInstOperands,
     /*  745662 */     // GIR_Coverage, 12445,
     /*  745662 */     GIR_EraseRootFromParent_Done,
     /*  745663 */   // Label 11694: @745663
     /*  745663 */   GIM_Try, /*On fail goto*//*Label 11695*/ GIMT_Encode4(745738), // Rule ID 12448 //
     /*  745668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  745679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  745682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  745685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745714 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  745717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745736 */     GIR_RootConstrainSelectedInstOperands,
     /*  745737 */     // GIR_Coverage, 12448,
     /*  745737 */     GIR_EraseRootFromParent_Done,
     /*  745738 */   // Label 11695: @745738
     /*  745738 */   GIM_Try, /*On fail goto*//*Label 11696*/ GIMT_Encode4(745813), // Rule ID 12449 //
     /*  745743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  745754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  745757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  745760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745789 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  745792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745811 */     GIR_RootConstrainSelectedInstOperands,
     /*  745812 */     // GIR_Coverage, 12449,
     /*  745812 */     GIR_EraseRootFromParent_Done,
     /*  745813 */   // Label 11696: @745813
     /*  745813 */   GIM_Try, /*On fail goto*//*Label 11697*/ GIMT_Encode4(745888), // Rule ID 12452 //
     /*  745818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  745829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  745832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  745835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745864 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  745867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745886 */     GIR_RootConstrainSelectedInstOperands,
     /*  745887 */     // GIR_Coverage, 12452,
     /*  745887 */     GIR_EraseRootFromParent_Done,
     /*  745888 */   // Label 11697: @745888
     /*  745888 */   GIM_Try, /*On fail goto*//*Label 11698*/ GIMT_Encode4(745963), // Rule ID 12453 //
     /*  745893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  745904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  745907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  745910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745939 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  745942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745961 */     GIR_RootConstrainSelectedInstOperands,
     /*  745962 */     // GIR_Coverage, 12453,
     /*  745962 */     GIR_EraseRootFromParent_Done,
     /*  745963 */   // Label 11698: @745963
     /*  745963 */   GIM_Try, /*On fail goto*//*Label 11699*/ GIMT_Encode4(746038), // Rule ID 12456 //
     /*  745968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  745979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  745982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  745985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  746017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746036 */     GIR_RootConstrainSelectedInstOperands,
     /*  746037 */     // GIR_Coverage, 12456,
     /*  746037 */     GIR_EraseRootFromParent_Done,
     /*  746038 */   // Label 11699: @746038
     /*  746038 */   GIM_Try, /*On fail goto*//*Label 11700*/ GIMT_Encode4(746113), // Rule ID 12457 //
     /*  746043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  746054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  746057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  746060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746089 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  746092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746111 */     GIR_RootConstrainSelectedInstOperands,
     /*  746112 */     // GIR_Coverage, 12457,
     /*  746112 */     GIR_EraseRootFromParent_Done,
     /*  746113 */   // Label 11700: @746113
     /*  746113 */   GIM_Try, /*On fail goto*//*Label 11701*/ GIMT_Encode4(746188), // Rule ID 12460 //
     /*  746118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  746129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  746132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  746135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746186 */     GIR_RootConstrainSelectedInstOperands,
     /*  746187 */     // GIR_Coverage, 12460,
     /*  746187 */     GIR_EraseRootFromParent_Done,
     /*  746188 */   // Label 11701: @746188
     /*  746188 */   GIM_Try, /*On fail goto*//*Label 11702*/ GIMT_Encode4(746263), // Rule ID 12461 //
     /*  746193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  746204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  746207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  746210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746239 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746261 */     GIR_RootConstrainSelectedInstOperands,
     /*  746262 */     // GIR_Coverage, 12461,
     /*  746262 */     GIR_EraseRootFromParent_Done,
     /*  746263 */   // Label 11702: @746263
     /*  746263 */   GIM_Try, /*On fail goto*//*Label 11703*/ GIMT_Encode4(746338), // Rule ID 12464 //
     /*  746268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  746279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  746282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  746285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746314 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746336 */     GIR_RootConstrainSelectedInstOperands,
     /*  746337 */     // GIR_Coverage, 12464,
     /*  746337 */     GIR_EraseRootFromParent_Done,
     /*  746338 */   // Label 11703: @746338
     /*  746338 */   GIM_Try, /*On fail goto*//*Label 11704*/ GIMT_Encode4(746413), // Rule ID 12465 //
     /*  746343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  746354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  746357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  746360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746411 */     GIR_RootConstrainSelectedInstOperands,
     /*  746412 */     // GIR_Coverage, 12465,
     /*  746412 */     GIR_EraseRootFromParent_Done,
     /*  746413 */   // Label 11704: @746413
     /*  746413 */   GIM_Try, /*On fail goto*//*Label 11705*/ GIMT_Encode4(746488), // Rule ID 12468 //
     /*  746418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  746429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  746432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  746435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746486 */     GIR_RootConstrainSelectedInstOperands,
     /*  746487 */     // GIR_Coverage, 12468,
     /*  746487 */     GIR_EraseRootFromParent_Done,
     /*  746488 */   // Label 11705: @746488
     /*  746488 */   GIM_Try, /*On fail goto*//*Label 11706*/ GIMT_Encode4(746563), // Rule ID 12469 //
     /*  746493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  746504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  746507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  746510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746539 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746561 */     GIR_RootConstrainSelectedInstOperands,
     /*  746562 */     // GIR_Coverage, 12469,
     /*  746562 */     GIR_EraseRootFromParent_Done,
     /*  746563 */   // Label 11706: @746563
     /*  746563 */   GIM_Try, /*On fail goto*//*Label 11707*/ GIMT_Encode4(746638), // Rule ID 12472 //
     /*  746568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  746579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  746582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  746585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  746617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746636 */     GIR_RootConstrainSelectedInstOperands,
     /*  746637 */     // GIR_Coverage, 12472,
     /*  746637 */     GIR_EraseRootFromParent_Done,
     /*  746638 */   // Label 11707: @746638
     /*  746638 */   GIM_Try, /*On fail goto*//*Label 11708*/ GIMT_Encode4(746713), // Rule ID 12473 //
     /*  746643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  746654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  746657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  746660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746689 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  746692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746711 */     GIR_RootConstrainSelectedInstOperands,
     /*  746712 */     // GIR_Coverage, 12473,
     /*  746712 */     GIR_EraseRootFromParent_Done,
     /*  746713 */   // Label 11708: @746713
     /*  746713 */   GIM_Try, /*On fail goto*//*Label 11709*/ GIMT_Encode4(746788), // Rule ID 12476 //
     /*  746718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  746721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  746729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  746732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  746735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746764 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  746764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746786 */     GIR_RootConstrainSelectedInstOperands,
     /*  746787 */     // GIR_Coverage, 12476,
     /*  746787 */     GIR_EraseRootFromParent_Done,
     /*  746788 */   // Label 11709: @746788
     /*  746788 */   GIM_Try, /*On fail goto*//*Label 11710*/ GIMT_Encode4(746863), // Rule ID 12477 //
     /*  746793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  746796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  746804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  746807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  746810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746839 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746861 */     GIR_RootConstrainSelectedInstOperands,
     /*  746862 */     // GIR_Coverage, 12477,
     /*  746862 */     GIR_EraseRootFromParent_Done,
     /*  746863 */   // Label 11710: @746863
     /*  746863 */   GIM_Try, /*On fail goto*//*Label 11711*/ GIMT_Encode4(746938), // Rule ID 12480 //
     /*  746868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  746871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  746879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  746882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  746885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  746914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746936 */     GIR_RootConstrainSelectedInstOperands,
     /*  746937 */     // GIR_Coverage, 12480,
     /*  746937 */     GIR_EraseRootFromParent_Done,
     /*  746938 */   // Label 11711: @746938
     /*  746938 */   GIM_Try, /*On fail goto*//*Label 11712*/ GIMT_Encode4(747013), // Rule ID 12481 //
     /*  746943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  746946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  746954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  746957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  746960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746989 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747011 */     GIR_RootConstrainSelectedInstOperands,
     /*  747012 */     // GIR_Coverage, 12481,
     /*  747012 */     GIR_EraseRootFromParent_Done,
     /*  747013 */   // Label 11712: @747013
     /*  747013 */   GIM_Try, /*On fail goto*//*Label 11713*/ GIMT_Encode4(747088), // Rule ID 12484 //
     /*  747018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  747021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  747029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  747032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  747035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  747067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747086 */     GIR_RootConstrainSelectedInstOperands,
     /*  747087 */     // GIR_Coverage, 12484,
     /*  747087 */     GIR_EraseRootFromParent_Done,
     /*  747088 */   // Label 11713: @747088
     /*  747088 */   GIM_Try, /*On fail goto*//*Label 11714*/ GIMT_Encode4(747163), // Rule ID 12485 //
     /*  747093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  747096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  747104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  747107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  747110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747139 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  747142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747161 */     GIR_RootConstrainSelectedInstOperands,
     /*  747162 */     // GIR_Coverage, 12485,
     /*  747162 */     GIR_EraseRootFromParent_Done,
     /*  747163 */   // Label 11714: @747163
     /*  747163 */   GIM_Try, /*On fail goto*//*Label 11715*/ GIMT_Encode4(747238), // Rule ID 12488 //
     /*  747168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  747171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  747179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  747182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  747185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  747217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747236 */     GIR_RootConstrainSelectedInstOperands,
     /*  747237 */     // GIR_Coverage, 12488,
     /*  747237 */     GIR_EraseRootFromParent_Done,
     /*  747238 */   // Label 11715: @747238
     /*  747238 */   GIM_Try, /*On fail goto*//*Label 11716*/ GIMT_Encode4(747313), // Rule ID 12489 //
     /*  747243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  747246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  747254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  747257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  747260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747289 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  747292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747311 */     GIR_RootConstrainSelectedInstOperands,
     /*  747312 */     // GIR_Coverage, 12489,
     /*  747312 */     GIR_EraseRootFromParent_Done,
     /*  747313 */   // Label 11716: @747313
     /*  747313 */   GIM_Try, /*On fail goto*//*Label 11717*/ GIMT_Encode4(747388), // Rule ID 12492 //
     /*  747318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  747329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  747332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  747335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  747338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747364 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  747367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747386 */     GIR_RootConstrainSelectedInstOperands,
     /*  747387 */     // GIR_Coverage, 12492,
     /*  747387 */     GIR_EraseRootFromParent_Done,
     /*  747388 */   // Label 11717: @747388
     /*  747388 */   GIM_Try, /*On fail goto*//*Label 11718*/ GIMT_Encode4(747463), // Rule ID 12493 //
     /*  747393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  747404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  747407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  747410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  747413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747439 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  747442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747461 */     GIR_RootConstrainSelectedInstOperands,
     /*  747462 */     // GIR_Coverage, 12493,
     /*  747462 */     GIR_EraseRootFromParent_Done,
     /*  747463 */   // Label 11718: @747463
     /*  747463 */   GIM_Try, /*On fail goto*//*Label 11719*/ GIMT_Encode4(747538), // Rule ID 12496 //
     /*  747468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  747479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  747482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  747485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  747488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747514 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  747517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747536 */     GIR_RootConstrainSelectedInstOperands,
     /*  747537 */     // GIR_Coverage, 12496,
     /*  747537 */     GIR_EraseRootFromParent_Done,
     /*  747538 */   // Label 11719: @747538
     /*  747538 */   GIM_Try, /*On fail goto*//*Label 11720*/ GIMT_Encode4(747613), // Rule ID 12497 //
     /*  747543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  747554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  747557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  747560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  747563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747589 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  747592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747611 */     GIR_RootConstrainSelectedInstOperands,
     /*  747612 */     // GIR_Coverage, 12497,
     /*  747612 */     GIR_EraseRootFromParent_Done,
     /*  747613 */   // Label 11720: @747613
     /*  747613 */   GIM_Try, /*On fail goto*//*Label 11721*/ GIMT_Encode4(747688), // Rule ID 12500 //
     /*  747618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  747629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  747632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  747635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  747638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747664 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  747667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747686 */     GIR_RootConstrainSelectedInstOperands,
     /*  747687 */     // GIR_Coverage, 12500,
     /*  747687 */     GIR_EraseRootFromParent_Done,
     /*  747688 */   // Label 11721: @747688
     /*  747688 */   GIM_Try, /*On fail goto*//*Label 11722*/ GIMT_Encode4(747763), // Rule ID 12501 //
     /*  747693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  747704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  747707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  747710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  747713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747739 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  747742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747761 */     GIR_RootConstrainSelectedInstOperands,
     /*  747762 */     // GIR_Coverage, 12501,
     /*  747762 */     GIR_EraseRootFromParent_Done,
     /*  747763 */   // Label 11722: @747763
     /*  747763 */   GIM_Try, /*On fail goto*//*Label 11723*/ GIMT_Encode4(747838), // Rule ID 12504 //
     /*  747768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  747779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  747782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  747785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  747788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  747817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747836 */     GIR_RootConstrainSelectedInstOperands,
     /*  747837 */     // GIR_Coverage, 12504,
     /*  747837 */     GIR_EraseRootFromParent_Done,
     /*  747838 */   // Label 11723: @747838
     /*  747838 */   GIM_Try, /*On fail goto*//*Label 11724*/ GIMT_Encode4(747913), // Rule ID 12505 //
     /*  747843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  747854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  747857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  747860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  747863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747889 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  747892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747911 */     GIR_RootConstrainSelectedInstOperands,
     /*  747912 */     // GIR_Coverage, 12505,
     /*  747912 */     GIR_EraseRootFromParent_Done,
     /*  747913 */   // Label 11724: @747913
     /*  747913 */   GIM_Try, /*On fail goto*//*Label 11725*/ GIMT_Encode4(747988), // Rule ID 12508 //
     /*  747918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  747929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  747932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  747935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  747938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747964 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  747967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747986 */     GIR_RootConstrainSelectedInstOperands,
     /*  747987 */     // GIR_Coverage, 12508,
     /*  747987 */     GIR_EraseRootFromParent_Done,
     /*  747988 */   // Label 11725: @747988
     /*  747988 */   GIM_Try, /*On fail goto*//*Label 11726*/ GIMT_Encode4(748063), // Rule ID 12509 //
     /*  747993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  748004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  748007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  748010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  748013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748039 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748061 */     GIR_RootConstrainSelectedInstOperands,
     /*  748062 */     // GIR_Coverage, 12509,
     /*  748062 */     GIR_EraseRootFromParent_Done,
     /*  748063 */   // Label 11726: @748063
     /*  748063 */   GIM_Try, /*On fail goto*//*Label 11727*/ GIMT_Encode4(748138), // Rule ID 12512 //
     /*  748068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  748079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  748082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  748085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  748088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748114 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  748114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748136 */     GIR_RootConstrainSelectedInstOperands,
     /*  748137 */     // GIR_Coverage, 12512,
     /*  748137 */     GIR_EraseRootFromParent_Done,
     /*  748138 */   // Label 11727: @748138
     /*  748138 */   GIM_Try, /*On fail goto*//*Label 11728*/ GIMT_Encode4(748213), // Rule ID 12513 //
     /*  748143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  748154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  748157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  748160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  748163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748189 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748211 */     GIR_RootConstrainSelectedInstOperands,
     /*  748212 */     // GIR_Coverage, 12513,
     /*  748212 */     GIR_EraseRootFromParent_Done,
     /*  748213 */   // Label 11728: @748213
     /*  748213 */   GIM_Try, /*On fail goto*//*Label 11729*/ GIMT_Encode4(748288), // Rule ID 12516 //
     /*  748218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  748229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  748232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  748235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  748238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  748267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748286 */     GIR_RootConstrainSelectedInstOperands,
     /*  748287 */     // GIR_Coverage, 12516,
     /*  748287 */     GIR_EraseRootFromParent_Done,
     /*  748288 */   // Label 11729: @748288
     /*  748288 */   GIM_Try, /*On fail goto*//*Label 11730*/ GIMT_Encode4(748363), // Rule ID 12517 //
     /*  748293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  748304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  748307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  748310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  748313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748339 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  748342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748361 */     GIR_RootConstrainSelectedInstOperands,
     /*  748362 */     // GIR_Coverage, 12517,
     /*  748362 */     GIR_EraseRootFromParent_Done,
     /*  748363 */   // Label 11730: @748363
     /*  748363 */   GIM_Try, /*On fail goto*//*Label 11731*/ GIMT_Encode4(748438), // Rule ID 12520 //
     /*  748368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  748379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  748382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  748385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  748388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748414 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748436 */     GIR_RootConstrainSelectedInstOperands,
     /*  748437 */     // GIR_Coverage, 12520,
     /*  748437 */     GIR_EraseRootFromParent_Done,
     /*  748438 */   // Label 11731: @748438
     /*  748438 */   GIM_Try, /*On fail goto*//*Label 11732*/ GIMT_Encode4(748513), // Rule ID 12521 //
     /*  748443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  748454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  748457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  748460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  748463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748489 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748511 */     GIR_RootConstrainSelectedInstOperands,
     /*  748512 */     // GIR_Coverage, 12521,
     /*  748512 */     GIR_EraseRootFromParent_Done,
     /*  748513 */   // Label 11732: @748513
     /*  748513 */   GIM_Try, /*On fail goto*//*Label 11733*/ GIMT_Encode4(748588), // Rule ID 12524 //
     /*  748518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  748529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  748532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  748535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  748538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  748567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748586 */     GIR_RootConstrainSelectedInstOperands,
     /*  748587 */     // GIR_Coverage, 12524,
     /*  748587 */     GIR_EraseRootFromParent_Done,
     /*  748588 */   // Label 11733: @748588
     /*  748588 */   GIM_Try, /*On fail goto*//*Label 11734*/ GIMT_Encode4(748663), // Rule ID 12525 //
     /*  748593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  748604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  748607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  748610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  748613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  748642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748661 */     GIR_RootConstrainSelectedInstOperands,
     /*  748662 */     // GIR_Coverage, 12525,
     /*  748662 */     GIR_EraseRootFromParent_Done,
     /*  748663 */   // Label 11734: @748663
     /*  748663 */   GIM_Try, /*On fail goto*//*Label 11735*/ GIMT_Encode4(748738), // Rule ID 12528 //
     /*  748668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  748679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  748682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  748685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  748688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748714 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748736 */     GIR_RootConstrainSelectedInstOperands,
     /*  748737 */     // GIR_Coverage, 12528,
     /*  748737 */     GIR_EraseRootFromParent_Done,
     /*  748738 */   // Label 11735: @748738
     /*  748738 */   GIM_Try, /*On fail goto*//*Label 11736*/ GIMT_Encode4(748813), // Rule ID 12529 //
     /*  748743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  748754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  748757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  748760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  748763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748789 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748811 */     GIR_RootConstrainSelectedInstOperands,
     /*  748812 */     // GIR_Coverage, 12529,
     /*  748812 */     GIR_EraseRootFromParent_Done,
     /*  748813 */   // Label 11736: @748813
     /*  748813 */   GIM_Try, /*On fail goto*//*Label 11737*/ GIMT_Encode4(748888), // Rule ID 12532 //
     /*  748818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  748829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  748832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  748835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  748838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748886 */     GIR_RootConstrainSelectedInstOperands,
     /*  748887 */     // GIR_Coverage, 12532,
     /*  748887 */     GIR_EraseRootFromParent_Done,
     /*  748888 */   // Label 11737: @748888
     /*  748888 */   GIM_Try, /*On fail goto*//*Label 11738*/ GIMT_Encode4(748963), // Rule ID 12533 //
     /*  748893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  748904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  748907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  748910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  748913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748939 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748961 */     GIR_RootConstrainSelectedInstOperands,
     /*  748962 */     // GIR_Coverage, 12533,
     /*  748962 */     GIR_EraseRootFromParent_Done,
     /*  748963 */   // Label 11738: @748963
     /*  748963 */   GIM_Try, /*On fail goto*//*Label 11739*/ GIMT_Encode4(749038), // Rule ID 12536 //
     /*  748968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  748979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  748982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  748985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  748988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  749017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749036 */     GIR_RootConstrainSelectedInstOperands,
     /*  749037 */     // GIR_Coverage, 12536,
     /*  749037 */     GIR_EraseRootFromParent_Done,
     /*  749038 */   // Label 11739: @749038
     /*  749038 */   GIM_Try, /*On fail goto*//*Label 11740*/ GIMT_Encode4(749113), // Rule ID 12537 //
     /*  749043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  749054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  749057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  749060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  749063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749089 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  749092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749111 */     GIR_RootConstrainSelectedInstOperands,
     /*  749112 */     // GIR_Coverage, 12537,
     /*  749112 */     GIR_EraseRootFromParent_Done,
     /*  749113 */   // Label 11740: @749113
     /*  749113 */   GIM_Try, /*On fail goto*//*Label 11741*/ GIMT_Encode4(749188), // Rule ID 12540 //
     /*  749118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  749129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  749132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  749135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  749138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  749167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749186 */     GIR_RootConstrainSelectedInstOperands,
     /*  749187 */     // GIR_Coverage, 12540,
     /*  749187 */     GIR_EraseRootFromParent_Done,
     /*  749188 */   // Label 11741: @749188
     /*  749188 */   GIM_Try, /*On fail goto*//*Label 11742*/ GIMT_Encode4(749263), // Rule ID 12541 //
     /*  749193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  749204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  749207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  749210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  749213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749239 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  749242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749261 */     GIR_RootConstrainSelectedInstOperands,
     /*  749262 */     // GIR_Coverage, 12541,
     /*  749262 */     GIR_EraseRootFromParent_Done,
     /*  749263 */   // Label 11742: @749263
     /*  749263 */   GIM_Try, /*On fail goto*//*Label 11743*/ GIMT_Encode4(749338), // Rule ID 12544 //
     /*  749268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  749279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  749282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  749285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  749288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749314 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  749317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749336 */     GIR_RootConstrainSelectedInstOperands,
     /*  749337 */     // GIR_Coverage, 12544,
     /*  749337 */     GIR_EraseRootFromParent_Done,
     /*  749338 */   // Label 11743: @749338
     /*  749338 */   GIM_Try, /*On fail goto*//*Label 11744*/ GIMT_Encode4(749413), // Rule ID 12545 //
     /*  749343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  749354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  749357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  749360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  749363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749389 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  749392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749411 */     GIR_RootConstrainSelectedInstOperands,
     /*  749412 */     // GIR_Coverage, 12545,
     /*  749412 */     GIR_EraseRootFromParent_Done,
     /*  749413 */   // Label 11744: @749413
     /*  749413 */   GIM_Try, /*On fail goto*//*Label 11745*/ GIMT_Encode4(749488), // Rule ID 12548 //
     /*  749418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  749429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  749432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  749435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  749438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749464 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  749467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749486 */     GIR_RootConstrainSelectedInstOperands,
     /*  749487 */     // GIR_Coverage, 12548,
     /*  749487 */     GIR_EraseRootFromParent_Done,
     /*  749488 */   // Label 11745: @749488
     /*  749488 */   GIM_Try, /*On fail goto*//*Label 11746*/ GIMT_Encode4(749563), // Rule ID 12549 //
     /*  749493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  749504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  749507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  749510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  749513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749539 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  749542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749561 */     GIR_RootConstrainSelectedInstOperands,
     /*  749562 */     // GIR_Coverage, 12549,
     /*  749562 */     GIR_EraseRootFromParent_Done,
     /*  749563 */   // Label 11746: @749563
     /*  749563 */   GIM_Try, /*On fail goto*//*Label 11747*/ GIMT_Encode4(749638), // Rule ID 12552 //
     /*  749568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  749579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  749582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  749585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749614 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  749617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749636 */     GIR_RootConstrainSelectedInstOperands,
     /*  749637 */     // GIR_Coverage, 12552,
     /*  749637 */     GIR_EraseRootFromParent_Done,
     /*  749638 */   // Label 11747: @749638
     /*  749638 */   GIM_Try, /*On fail goto*//*Label 11748*/ GIMT_Encode4(749713), // Rule ID 12553 //
     /*  749643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  749654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  749657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  749660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749689 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  749692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749711 */     GIR_RootConstrainSelectedInstOperands,
     /*  749712 */     // GIR_Coverage, 12553,
     /*  749712 */     GIR_EraseRootFromParent_Done,
     /*  749713 */   // Label 11748: @749713
     /*  749713 */   GIM_Try, /*On fail goto*//*Label 11749*/ GIMT_Encode4(749788), // Rule ID 12556 //
     /*  749718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  749729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  749732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  749735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749764 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  749767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749786 */     GIR_RootConstrainSelectedInstOperands,
     /*  749787 */     // GIR_Coverage, 12556,
     /*  749787 */     GIR_EraseRootFromParent_Done,
     /*  749788 */   // Label 11749: @749788
     /*  749788 */   GIM_Try, /*On fail goto*//*Label 11750*/ GIMT_Encode4(749863), // Rule ID 12557 //
     /*  749793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  749804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  749807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  749810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749839 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  749842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749861 */     GIR_RootConstrainSelectedInstOperands,
     /*  749862 */     // GIR_Coverage, 12557,
     /*  749862 */     GIR_EraseRootFromParent_Done,
     /*  749863 */   // Label 11750: @749863
     /*  749863 */   GIM_Try, /*On fail goto*//*Label 11751*/ GIMT_Encode4(749938), // Rule ID 12560 //
     /*  749868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  749879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  749882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  749885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749914 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  749917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749936 */     GIR_RootConstrainSelectedInstOperands,
     /*  749937 */     // GIR_Coverage, 12560,
     /*  749937 */     GIR_EraseRootFromParent_Done,
     /*  749938 */   // Label 11751: @749938
     /*  749938 */   GIM_Try, /*On fail goto*//*Label 11752*/ GIMT_Encode4(750013), // Rule ID 12561 //
     /*  749943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  749954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  749957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  749960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749989 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  749992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750011 */     GIR_RootConstrainSelectedInstOperands,
     /*  750012 */     // GIR_Coverage, 12561,
     /*  750012 */     GIR_EraseRootFromParent_Done,
     /*  750013 */   // Label 11752: @750013
     /*  750013 */   GIM_Try, /*On fail goto*//*Label 11753*/ GIMT_Encode4(750088), // Rule ID 12564 //
     /*  750018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  750029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  750032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  750035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750086 */     GIR_RootConstrainSelectedInstOperands,
     /*  750087 */     // GIR_Coverage, 12564,
     /*  750087 */     GIR_EraseRootFromParent_Done,
     /*  750088 */   // Label 11753: @750088
     /*  750088 */   GIM_Try, /*On fail goto*//*Label 11754*/ GIMT_Encode4(750163), // Rule ID 12565 //
     /*  750093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  750104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  750107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  750110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750139 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750161 */     GIR_RootConstrainSelectedInstOperands,
     /*  750162 */     // GIR_Coverage, 12565,
     /*  750162 */     GIR_EraseRootFromParent_Done,
     /*  750163 */   // Label 11754: @750163
     /*  750163 */   GIM_Try, /*On fail goto*//*Label 11755*/ GIMT_Encode4(750238), // Rule ID 12568 //
     /*  750168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  750179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  750182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  750185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750214 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  750217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750236 */     GIR_RootConstrainSelectedInstOperands,
     /*  750237 */     // GIR_Coverage, 12568,
     /*  750237 */     GIR_EraseRootFromParent_Done,
     /*  750238 */   // Label 11755: @750238
     /*  750238 */   GIM_Try, /*On fail goto*//*Label 11756*/ GIMT_Encode4(750313), // Rule ID 12569 //
     /*  750243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  750254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  750257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  750260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750289 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  750292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750311 */     GIR_RootConstrainSelectedInstOperands,
     /*  750312 */     // GIR_Coverage, 12569,
     /*  750312 */     GIR_EraseRootFromParent_Done,
     /*  750313 */   // Label 11756: @750313
     /*  750313 */   GIM_Try, /*On fail goto*//*Label 11757*/ GIMT_Encode4(750388), // Rule ID 12572 //
     /*  750318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  750329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  750332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  750335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750364 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  750367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750386 */     GIR_RootConstrainSelectedInstOperands,
     /*  750387 */     // GIR_Coverage, 12572,
     /*  750387 */     GIR_EraseRootFromParent_Done,
     /*  750388 */   // Label 11757: @750388
     /*  750388 */   GIM_Try, /*On fail goto*//*Label 11758*/ GIMT_Encode4(750463), // Rule ID 12573 //
     /*  750393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  750404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  750407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  750410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750439 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  750442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750461 */     GIR_RootConstrainSelectedInstOperands,
     /*  750462 */     // GIR_Coverage, 12573,
     /*  750462 */     GIR_EraseRootFromParent_Done,
     /*  750463 */   // Label 11758: @750463
     /*  750463 */   GIM_Try, /*On fail goto*//*Label 11759*/ GIMT_Encode4(750538), // Rule ID 12576 //
     /*  750468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  750479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  750482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  750485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750514 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  750517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750536 */     GIR_RootConstrainSelectedInstOperands,
     /*  750537 */     // GIR_Coverage, 12576,
     /*  750537 */     GIR_EraseRootFromParent_Done,
     /*  750538 */   // Label 11759: @750538
     /*  750538 */   GIM_Try, /*On fail goto*//*Label 11760*/ GIMT_Encode4(750613), // Rule ID 12577 //
     /*  750543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  750554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  750557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  750560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750589 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  750592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750611 */     GIR_RootConstrainSelectedInstOperands,
     /*  750612 */     // GIR_Coverage, 12577,
     /*  750612 */     GIR_EraseRootFromParent_Done,
     /*  750613 */   // Label 11760: @750613
     /*  750613 */   GIM_Try, /*On fail goto*//*Label 11761*/ GIMT_Encode4(750688), // Rule ID 12580 //
     /*  750618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  750629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  750632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  750635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750664 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  750667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750686 */     GIR_RootConstrainSelectedInstOperands,
     /*  750687 */     // GIR_Coverage, 12580,
     /*  750687 */     GIR_EraseRootFromParent_Done,
     /*  750688 */   // Label 11761: @750688
     /*  750688 */   GIM_Try, /*On fail goto*//*Label 11762*/ GIMT_Encode4(750763), // Rule ID 12581 //
     /*  750693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  750704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  750707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  750710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750739 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  750742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750761 */     GIR_RootConstrainSelectedInstOperands,
     /*  750762 */     // GIR_Coverage, 12581,
     /*  750762 */     GIR_EraseRootFromParent_Done,
     /*  750763 */   // Label 11762: @750763
     /*  750763 */   GIM_Try, /*On fail goto*//*Label 11763*/ GIMT_Encode4(750838), // Rule ID 12584 //
     /*  750768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  750779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  750782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  750785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750814 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750836 */     GIR_RootConstrainSelectedInstOperands,
     /*  750837 */     // GIR_Coverage, 12584,
     /*  750837 */     GIR_EraseRootFromParent_Done,
     /*  750838 */   // Label 11763: @750838
     /*  750838 */   GIM_Try, /*On fail goto*//*Label 11764*/ GIMT_Encode4(750913), // Rule ID 12585 //
     /*  750843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  750854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  750857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  750860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750889 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750911 */     GIR_RootConstrainSelectedInstOperands,
     /*  750912 */     // GIR_Coverage, 12585,
     /*  750912 */     GIR_EraseRootFromParent_Done,
     /*  750913 */   // Label 11764: @750913
     /*  750913 */   GIM_Try, /*On fail goto*//*Label 11765*/ GIMT_Encode4(750988), // Rule ID 12588 //
     /*  750918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  750929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  750932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  750935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750964 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  750967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750986 */     GIR_RootConstrainSelectedInstOperands,
     /*  750987 */     // GIR_Coverage, 12588,
     /*  750987 */     GIR_EraseRootFromParent_Done,
     /*  750988 */   // Label 11765: @750988
     /*  750988 */   GIM_Try, /*On fail goto*//*Label 11766*/ GIMT_Encode4(751063), // Rule ID 12589 //
     /*  750993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  751004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  751007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  751010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751039 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  751042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751061 */     GIR_RootConstrainSelectedInstOperands,
     /*  751062 */     // GIR_Coverage, 12589,
     /*  751062 */     GIR_EraseRootFromParent_Done,
     /*  751063 */   // Label 11766: @751063
     /*  751063 */   GIM_Try, /*On fail goto*//*Label 11767*/ GIMT_Encode4(751138), // Rule ID 12592 //
     /*  751068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  751079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  751082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  751085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751114 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  751114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751136 */     GIR_RootConstrainSelectedInstOperands,
     /*  751137 */     // GIR_Coverage, 12592,
     /*  751137 */     GIR_EraseRootFromParent_Done,
     /*  751138 */   // Label 11767: @751138
     /*  751138 */   GIM_Try, /*On fail goto*//*Label 11768*/ GIMT_Encode4(751213), // Rule ID 12593 //
     /*  751143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  751154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  751157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  751160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751189 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751211 */     GIR_RootConstrainSelectedInstOperands,
     /*  751212 */     // GIR_Coverage, 12593,
     /*  751212 */     GIR_EraseRootFromParent_Done,
     /*  751213 */   // Label 11768: @751213
     /*  751213 */   GIM_Try, /*On fail goto*//*Label 11769*/ GIMT_Encode4(751288), // Rule ID 12596 //
     /*  751218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  751229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  751232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  751235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751264 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  751267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751286 */     GIR_RootConstrainSelectedInstOperands,
     /*  751287 */     // GIR_Coverage, 12596,
     /*  751287 */     GIR_EraseRootFromParent_Done,
     /*  751288 */   // Label 11769: @751288
     /*  751288 */   GIM_Try, /*On fail goto*//*Label 11770*/ GIMT_Encode4(751363), // Rule ID 12597 //
     /*  751293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  751304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  751307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  751310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751339 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  751342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751361 */     GIR_RootConstrainSelectedInstOperands,
     /*  751362 */     // GIR_Coverage, 12597,
     /*  751362 */     GIR_EraseRootFromParent_Done,
     /*  751363 */   // Label 11770: @751363
     /*  751363 */   GIM_Try, /*On fail goto*//*Label 11771*/ GIMT_Encode4(751438), // Rule ID 12600 //
     /*  751368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  751379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  751382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  751385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  751417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751436 */     GIR_RootConstrainSelectedInstOperands,
     /*  751437 */     // GIR_Coverage, 12600,
     /*  751437 */     GIR_EraseRootFromParent_Done,
     /*  751438 */   // Label 11771: @751438
     /*  751438 */   GIM_Try, /*On fail goto*//*Label 11772*/ GIMT_Encode4(751513), // Rule ID 12601 //
     /*  751443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  751454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  751457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  751460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751489 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  751492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751511 */     GIR_RootConstrainSelectedInstOperands,
     /*  751512 */     // GIR_Coverage, 12601,
     /*  751512 */     GIR_EraseRootFromParent_Done,
     /*  751513 */   // Label 11772: @751513
     /*  751513 */   GIM_Try, /*On fail goto*//*Label 11773*/ GIMT_Encode4(751588), // Rule ID 12604 //
     /*  751518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  751529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  751532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  751535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751564 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  751567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751586 */     GIR_RootConstrainSelectedInstOperands,
     /*  751587 */     // GIR_Coverage, 12604,
     /*  751587 */     GIR_EraseRootFromParent_Done,
     /*  751588 */   // Label 11773: @751588
     /*  751588 */   GIM_Try, /*On fail goto*//*Label 11774*/ GIMT_Encode4(751663), // Rule ID 12605 //
     /*  751593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  751604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  751607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  751610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751639 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  751642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751661 */     GIR_RootConstrainSelectedInstOperands,
     /*  751662 */     // GIR_Coverage, 12605,
     /*  751662 */     GIR_EraseRootFromParent_Done,
     /*  751663 */   // Label 11774: @751663
     /*  751663 */   GIM_Try, /*On fail goto*//*Label 11775*/ GIMT_Encode4(751738), // Rule ID 12608 //
     /*  751668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  751679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  751682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  751685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751714 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751736 */     GIR_RootConstrainSelectedInstOperands,
     /*  751737 */     // GIR_Coverage, 12608,
     /*  751737 */     GIR_EraseRootFromParent_Done,
     /*  751738 */   // Label 11775: @751738
     /*  751738 */   GIM_Try, /*On fail goto*//*Label 11776*/ GIMT_Encode4(751813), // Rule ID 12609 //
     /*  751743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  751754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  751757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  751760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751789 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751811 */     GIR_RootConstrainSelectedInstOperands,
     /*  751812 */     // GIR_Coverage, 12609,
     /*  751812 */     GIR_EraseRootFromParent_Done,
     /*  751813 */   // Label 11776: @751813
     /*  751813 */   GIM_Try, /*On fail goto*//*Label 11777*/ GIMT_Encode4(751888), // Rule ID 12612 //
     /*  751818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  751829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  751832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  751835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  751838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751864 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  751867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751886 */     GIR_RootConstrainSelectedInstOperands,
     /*  751887 */     // GIR_Coverage, 12612,
     /*  751887 */     GIR_EraseRootFromParent_Done,
     /*  751888 */   // Label 11777: @751888
     /*  751888 */   GIM_Try, /*On fail goto*//*Label 11778*/ GIMT_Encode4(751963), // Rule ID 12613 //
     /*  751893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  751904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  751907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  751910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  751913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751939 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  751942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751961 */     GIR_RootConstrainSelectedInstOperands,
     /*  751962 */     // GIR_Coverage, 12613,
     /*  751962 */     GIR_EraseRootFromParent_Done,
     /*  751963 */   // Label 11778: @751963
     /*  751963 */   GIM_Try, /*On fail goto*//*Label 11779*/ GIMT_Encode4(752038), // Rule ID 12616 //
     /*  751968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  751979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  751982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  751985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  751988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752014 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752036 */     GIR_RootConstrainSelectedInstOperands,
     /*  752037 */     // GIR_Coverage, 12616,
     /*  752037 */     GIR_EraseRootFromParent_Done,
     /*  752038 */   // Label 11779: @752038
     /*  752038 */   GIM_Try, /*On fail goto*//*Label 11780*/ GIMT_Encode4(752113), // Rule ID 12617 //
     /*  752043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  752054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  752057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  752060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  752063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752089 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752111 */     GIR_RootConstrainSelectedInstOperands,
     /*  752112 */     // GIR_Coverage, 12617,
     /*  752112 */     GIR_EraseRootFromParent_Done,
     /*  752113 */   // Label 11780: @752113
     /*  752113 */   GIM_Try, /*On fail goto*//*Label 11781*/ GIMT_Encode4(752188), // Rule ID 12620 //
     /*  752118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  752129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  752132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  752135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  752138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752164 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752186 */     GIR_RootConstrainSelectedInstOperands,
     /*  752187 */     // GIR_Coverage, 12620,
     /*  752187 */     GIR_EraseRootFromParent_Done,
     /*  752188 */   // Label 11781: @752188
     /*  752188 */   GIM_Try, /*On fail goto*//*Label 11782*/ GIMT_Encode4(752263), // Rule ID 12621 //
     /*  752193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  752204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  752207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  752210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  752213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752239 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752261 */     GIR_RootConstrainSelectedInstOperands,
     /*  752262 */     // GIR_Coverage, 12621,
     /*  752262 */     GIR_EraseRootFromParent_Done,
     /*  752263 */   // Label 11782: @752263
     /*  752263 */   GIM_Try, /*On fail goto*//*Label 11783*/ GIMT_Encode4(752338), // Rule ID 12624 //
     /*  752268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  752279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  752282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  752285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  752288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  752317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752336 */     GIR_RootConstrainSelectedInstOperands,
     /*  752337 */     // GIR_Coverage, 12624,
     /*  752337 */     GIR_EraseRootFromParent_Done,
     /*  752338 */   // Label 11783: @752338
     /*  752338 */   GIM_Try, /*On fail goto*//*Label 11784*/ GIMT_Encode4(752413), // Rule ID 12625 //
     /*  752343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  752354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  752357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  752360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  752363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752389 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  752392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752411 */     GIR_RootConstrainSelectedInstOperands,
     /*  752412 */     // GIR_Coverage, 12625,
     /*  752412 */     GIR_EraseRootFromParent_Done,
     /*  752413 */   // Label 11784: @752413
     /*  752413 */   GIM_Try, /*On fail goto*//*Label 11785*/ GIMT_Encode4(752488), // Rule ID 12628 //
     /*  752418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  752429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  752432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  752435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  752438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752464 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  752467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752486 */     GIR_RootConstrainSelectedInstOperands,
     /*  752487 */     // GIR_Coverage, 12628,
     /*  752487 */     GIR_EraseRootFromParent_Done,
     /*  752488 */   // Label 11785: @752488
     /*  752488 */   GIM_Try, /*On fail goto*//*Label 11786*/ GIMT_Encode4(752563), // Rule ID 12629 //
     /*  752493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  752504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  752507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  752510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  752513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752539 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  752542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752561 */     GIR_RootConstrainSelectedInstOperands,
     /*  752562 */     // GIR_Coverage, 12629,
     /*  752562 */     GIR_EraseRootFromParent_Done,
     /*  752563 */   // Label 11786: @752563
     /*  752563 */   GIM_Try, /*On fail goto*//*Label 11787*/ GIMT_Encode4(752638), // Rule ID 12632 //
     /*  752568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  752579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  752582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  752585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  752588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  752617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752636 */     GIR_RootConstrainSelectedInstOperands,
     /*  752637 */     // GIR_Coverage, 12632,
     /*  752637 */     GIR_EraseRootFromParent_Done,
     /*  752638 */   // Label 11787: @752638
     /*  752638 */   GIM_Try, /*On fail goto*//*Label 11788*/ GIMT_Encode4(752713), // Rule ID 12633 //
     /*  752643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  752654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  752657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  752660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  752663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752689 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  752692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752711 */     GIR_RootConstrainSelectedInstOperands,
     /*  752712 */     // GIR_Coverage, 12633,
     /*  752712 */     GIR_EraseRootFromParent_Done,
     /*  752713 */   // Label 11788: @752713
     /*  752713 */   GIM_Try, /*On fail goto*//*Label 11789*/ GIMT_Encode4(752788), // Rule ID 12636 //
     /*  752718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  752729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  752732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  752735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  752738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752764 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752786 */     GIR_RootConstrainSelectedInstOperands,
     /*  752787 */     // GIR_Coverage, 12636,
     /*  752787 */     GIR_EraseRootFromParent_Done,
     /*  752788 */   // Label 11789: @752788
     /*  752788 */   GIM_Try, /*On fail goto*//*Label 11790*/ GIMT_Encode4(752863), // Rule ID 12637 //
     /*  752793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  752804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  752807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  752810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  752813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752839 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752861 */     GIR_RootConstrainSelectedInstOperands,
     /*  752862 */     // GIR_Coverage, 12637,
     /*  752862 */     GIR_EraseRootFromParent_Done,
     /*  752863 */   // Label 11790: @752863
     /*  752863 */   GIM_Try, /*On fail goto*//*Label 11791*/ GIMT_Encode4(752938), // Rule ID 12640 //
     /*  752868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  752879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  752882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  752885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  752888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752914 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752936 */     GIR_RootConstrainSelectedInstOperands,
     /*  752937 */     // GIR_Coverage, 12640,
     /*  752937 */     GIR_EraseRootFromParent_Done,
     /*  752938 */   // Label 11791: @752938
     /*  752938 */   GIM_Try, /*On fail goto*//*Label 11792*/ GIMT_Encode4(753013), // Rule ID 12641 //
     /*  752943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  752954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  752957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  752960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  752963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752989 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753011 */     GIR_RootConstrainSelectedInstOperands,
     /*  753012 */     // GIR_Coverage, 12641,
     /*  753012 */     GIR_EraseRootFromParent_Done,
     /*  753013 */   // Label 11792: @753013
     /*  753013 */   GIM_Try, /*On fail goto*//*Label 11793*/ GIMT_Encode4(753088), // Rule ID 12644 //
     /*  753018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  753029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  753032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  753035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  753038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753086 */     GIR_RootConstrainSelectedInstOperands,
     /*  753087 */     // GIR_Coverage, 12644,
     /*  753087 */     GIR_EraseRootFromParent_Done,
     /*  753088 */   // Label 11793: @753088
     /*  753088 */   GIM_Try, /*On fail goto*//*Label 11794*/ GIMT_Encode4(753163), // Rule ID 12645 //
     /*  753093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  753104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  753107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  753110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  753113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753161 */     GIR_RootConstrainSelectedInstOperands,
     /*  753162 */     // GIR_Coverage, 12645,
     /*  753162 */     GIR_EraseRootFromParent_Done,
     /*  753163 */   // Label 11794: @753163
     /*  753163 */   GIM_Try, /*On fail goto*//*Label 11795*/ GIMT_Encode4(753238), // Rule ID 12648 //
     /*  753168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  753179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  753182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  753185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  753188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753236 */     GIR_RootConstrainSelectedInstOperands,
     /*  753237 */     // GIR_Coverage, 12648,
     /*  753237 */     GIR_EraseRootFromParent_Done,
     /*  753238 */   // Label 11795: @753238
     /*  753238 */   GIM_Try, /*On fail goto*//*Label 11796*/ GIMT_Encode4(753313), // Rule ID 12649 //
     /*  753243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  753254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  753257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  753260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  753263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753289 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753311 */     GIR_RootConstrainSelectedInstOperands,
     /*  753312 */     // GIR_Coverage, 12649,
     /*  753312 */     GIR_EraseRootFromParent_Done,
     /*  753313 */   // Label 11796: @753313
     /*  753313 */   GIM_Try, /*On fail goto*//*Label 11797*/ GIMT_Encode4(753388), // Rule ID 12652 //
     /*  753318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  753329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  753332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  753335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  753338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753386 */     GIR_RootConstrainSelectedInstOperands,
     /*  753387 */     // GIR_Coverage, 12652,
     /*  753387 */     GIR_EraseRootFromParent_Done,
     /*  753388 */   // Label 11797: @753388
     /*  753388 */   GIM_Try, /*On fail goto*//*Label 11798*/ GIMT_Encode4(753463), // Rule ID 12653 //
     /*  753393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  753404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  753407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  753410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  753413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753439 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753461 */     GIR_RootConstrainSelectedInstOperands,
     /*  753462 */     // GIR_Coverage, 12653,
     /*  753462 */     GIR_EraseRootFromParent_Done,
     /*  753463 */   // Label 11798: @753463
     /*  753463 */   GIM_Try, /*On fail goto*//*Label 11799*/ GIMT_Encode4(753538), // Rule ID 12656 //
     /*  753468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  753479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  753482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  753485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  753488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753514 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  753517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753536 */     GIR_RootConstrainSelectedInstOperands,
     /*  753537 */     // GIR_Coverage, 12656,
     /*  753537 */     GIR_EraseRootFromParent_Done,
     /*  753538 */   // Label 11799: @753538
     /*  753538 */   GIM_Try, /*On fail goto*//*Label 11800*/ GIMT_Encode4(753613), // Rule ID 12657 //
     /*  753543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  753554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  753557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  753560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  753563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753589 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  753592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753611 */     GIR_RootConstrainSelectedInstOperands,
     /*  753612 */     // GIR_Coverage, 12657,
     /*  753612 */     GIR_EraseRootFromParent_Done,
     /*  753613 */   // Label 11800: @753613
     /*  753613 */   GIM_Try, /*On fail goto*//*Label 11801*/ GIMT_Encode4(753688), // Rule ID 12660 //
     /*  753618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  753629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  753632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  753635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  753638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753664 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753686 */     GIR_RootConstrainSelectedInstOperands,
     /*  753687 */     // GIR_Coverage, 12660,
     /*  753687 */     GIR_EraseRootFromParent_Done,
     /*  753688 */   // Label 11801: @753688
     /*  753688 */   GIM_Try, /*On fail goto*//*Label 11802*/ GIMT_Encode4(753763), // Rule ID 12661 //
     /*  753693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  753704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  753707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  753710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  753713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753739 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753761 */     GIR_RootConstrainSelectedInstOperands,
     /*  753762 */     // GIR_Coverage, 12661,
     /*  753762 */     GIR_EraseRootFromParent_Done,
     /*  753763 */   // Label 11802: @753763
     /*  753763 */   GIM_Try, /*On fail goto*//*Label 11803*/ GIMT_Encode4(753838), // Rule ID 12664 //
     /*  753768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  753779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  753782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  753785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  753788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753814 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753836 */     GIR_RootConstrainSelectedInstOperands,
     /*  753837 */     // GIR_Coverage, 12664,
     /*  753837 */     GIR_EraseRootFromParent_Done,
     /*  753838 */   // Label 11803: @753838
     /*  753838 */   GIM_Try, /*On fail goto*//*Label 11804*/ GIMT_Encode4(753913), // Rule ID 12665 //
     /*  753843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  753854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  753857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  753860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  753863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753889 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753911 */     GIR_RootConstrainSelectedInstOperands,
     /*  753912 */     // GIR_Coverage, 12665,
     /*  753912 */     GIR_EraseRootFromParent_Done,
     /*  753913 */   // Label 11804: @753913
     /*  753913 */   GIM_Try, /*On fail goto*//*Label 11805*/ GIMT_Encode4(753988), // Rule ID 12668 //
     /*  753918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  753929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  753932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  753935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  753938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753964 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753986 */     GIR_RootConstrainSelectedInstOperands,
     /*  753987 */     // GIR_Coverage, 12668,
     /*  753987 */     GIR_EraseRootFromParent_Done,
     /*  753988 */   // Label 11805: @753988
     /*  753988 */   GIM_Try, /*On fail goto*//*Label 11806*/ GIMT_Encode4(754063), // Rule ID 12669 //
     /*  753993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  754004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  754007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  754010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  754013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754039 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  754039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  754042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754061 */     GIR_RootConstrainSelectedInstOperands,
     /*  754062 */     // GIR_Coverage, 12669,
     /*  754062 */     GIR_EraseRootFromParent_Done,
     /*  754063 */   // Label 11806: @754063
     /*  754063 */   GIM_Try, /*On fail goto*//*Label 11807*/ GIMT_Encode4(754138), // Rule ID 12672 //
     /*  754068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  754079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  754082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  754085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  754117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754136 */     GIR_RootConstrainSelectedInstOperands,
     /*  754137 */     // GIR_Coverage, 12672,
     /*  754137 */     GIR_EraseRootFromParent_Done,
     /*  754138 */   // Label 11807: @754138
     /*  754138 */   GIM_Try, /*On fail goto*//*Label 11808*/ GIMT_Encode4(754213), // Rule ID 12673 //
     /*  754143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  754154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  754157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  754160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754189 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  754192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754211 */     GIR_RootConstrainSelectedInstOperands,
     /*  754212 */     // GIR_Coverage, 12673,
     /*  754212 */     GIR_EraseRootFromParent_Done,
     /*  754213 */   // Label 11808: @754213
     /*  754213 */   GIM_Try, /*On fail goto*//*Label 11809*/ GIMT_Encode4(754288), // Rule ID 12676 //
     /*  754218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  754229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  754232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  754235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  754267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754286 */     GIR_RootConstrainSelectedInstOperands,
     /*  754287 */     // GIR_Coverage, 12676,
     /*  754287 */     GIR_EraseRootFromParent_Done,
     /*  754288 */   // Label 11809: @754288
     /*  754288 */   GIM_Try, /*On fail goto*//*Label 11810*/ GIMT_Encode4(754363), // Rule ID 12677 //
     /*  754293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  754304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  754307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  754310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754339 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  754342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754361 */     GIR_RootConstrainSelectedInstOperands,
     /*  754362 */     // GIR_Coverage, 12677,
     /*  754362 */     GIR_EraseRootFromParent_Done,
     /*  754363 */   // Label 11810: @754363
     /*  754363 */   GIM_Try, /*On fail goto*//*Label 11811*/ GIMT_Encode4(754438), // Rule ID 12680 //
     /*  754368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  754379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  754382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  754385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754414 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  754417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754436 */     GIR_RootConstrainSelectedInstOperands,
     /*  754437 */     // GIR_Coverage, 12680,
     /*  754437 */     GIR_EraseRootFromParent_Done,
     /*  754438 */   // Label 11811: @754438
     /*  754438 */   GIM_Try, /*On fail goto*//*Label 11812*/ GIMT_Encode4(754513), // Rule ID 12681 //
     /*  754443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  754454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  754457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  754460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754489 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  754492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754511 */     GIR_RootConstrainSelectedInstOperands,
     /*  754512 */     // GIR_Coverage, 12681,
     /*  754512 */     GIR_EraseRootFromParent_Done,
     /*  754513 */   // Label 11812: @754513
     /*  754513 */   GIM_Try, /*On fail goto*//*Label 11813*/ GIMT_Encode4(754588), // Rule ID 12684 //
     /*  754518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  754529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  754532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  754535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754564 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  754567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754586 */     GIR_RootConstrainSelectedInstOperands,
     /*  754587 */     // GIR_Coverage, 12684,
     /*  754587 */     GIR_EraseRootFromParent_Done,
     /*  754588 */   // Label 11813: @754588
     /*  754588 */   GIM_Try, /*On fail goto*//*Label 11814*/ GIMT_Encode4(754663), // Rule ID 12685 //
     /*  754593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  754604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  754607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  754610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754639 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  754642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754661 */     GIR_RootConstrainSelectedInstOperands,
     /*  754662 */     // GIR_Coverage, 12685,
     /*  754662 */     GIR_EraseRootFromParent_Done,
     /*  754663 */   // Label 11814: @754663
     /*  754663 */   GIM_Try, /*On fail goto*//*Label 11815*/ GIMT_Encode4(754738), // Rule ID 12688 //
     /*  754668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  754679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  754682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  754685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754714 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  754717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754736 */     GIR_RootConstrainSelectedInstOperands,
     /*  754737 */     // GIR_Coverage, 12688,
     /*  754737 */     GIR_EraseRootFromParent_Done,
     /*  754738 */   // Label 11815: @754738
     /*  754738 */   GIM_Try, /*On fail goto*//*Label 11816*/ GIMT_Encode4(754813), // Rule ID 12689 //
     /*  754743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  754754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  754757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  754760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754789 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  754792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754811 */     GIR_RootConstrainSelectedInstOperands,
     /*  754812 */     // GIR_Coverage, 12689,
     /*  754812 */     GIR_EraseRootFromParent_Done,
     /*  754813 */   // Label 11816: @754813
     /*  754813 */   GIM_Try, /*On fail goto*//*Label 11817*/ GIMT_Encode4(754888), // Rule ID 12692 //
     /*  754818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  754829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  754832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  754835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754864 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  754867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754886 */     GIR_RootConstrainSelectedInstOperands,
     /*  754887 */     // GIR_Coverage, 12692,
     /*  754887 */     GIR_EraseRootFromParent_Done,
     /*  754888 */   // Label 11817: @754888
     /*  754888 */   GIM_Try, /*On fail goto*//*Label 11818*/ GIMT_Encode4(754963), // Rule ID 12693 //
     /*  754893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  754904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  754907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  754910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754939 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  754942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754961 */     GIR_RootConstrainSelectedInstOperands,
     /*  754962 */     // GIR_Coverage, 12693,
     /*  754962 */     GIR_EraseRootFromParent_Done,
     /*  754963 */   // Label 11818: @754963
     /*  754963 */   GIM_Try, /*On fail goto*//*Label 11819*/ GIMT_Encode4(755038), // Rule ID 12696 //
     /*  754968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  754979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  754982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  754985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  755017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755036 */     GIR_RootConstrainSelectedInstOperands,
     /*  755037 */     // GIR_Coverage, 12696,
     /*  755037 */     GIR_EraseRootFromParent_Done,
     /*  755038 */   // Label 11819: @755038
     /*  755038 */   GIM_Try, /*On fail goto*//*Label 11820*/ GIMT_Encode4(755113), // Rule ID 12697 //
     /*  755043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  755054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  755057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  755060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755089 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  755092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755111 */     GIR_RootConstrainSelectedInstOperands,
     /*  755112 */     // GIR_Coverage, 12697,
     /*  755112 */     GIR_EraseRootFromParent_Done,
     /*  755113 */   // Label 11820: @755113
     /*  755113 */   GIM_Try, /*On fail goto*//*Label 11821*/ GIMT_Encode4(755188), // Rule ID 12700 //
     /*  755118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  755129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  755132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  755135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755186 */     GIR_RootConstrainSelectedInstOperands,
     /*  755187 */     // GIR_Coverage, 12700,
     /*  755187 */     GIR_EraseRootFromParent_Done,
     /*  755188 */   // Label 11821: @755188
     /*  755188 */   GIM_Try, /*On fail goto*//*Label 11822*/ GIMT_Encode4(755263), // Rule ID 12701 //
     /*  755193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  755204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  755207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  755210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755239 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755261 */     GIR_RootConstrainSelectedInstOperands,
     /*  755262 */     // GIR_Coverage, 12701,
     /*  755262 */     GIR_EraseRootFromParent_Done,
     /*  755263 */   // Label 11822: @755263
     /*  755263 */   GIM_Try, /*On fail goto*//*Label 11823*/ GIMT_Encode4(755338), // Rule ID 12704 //
     /*  755268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  755279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  755282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  755285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755314 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755336 */     GIR_RootConstrainSelectedInstOperands,
     /*  755337 */     // GIR_Coverage, 12704,
     /*  755337 */     GIR_EraseRootFromParent_Done,
     /*  755338 */   // Label 11823: @755338
     /*  755338 */   GIM_Try, /*On fail goto*//*Label 11824*/ GIMT_Encode4(755413), // Rule ID 12705 //
     /*  755343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  755354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  755357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  755360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755411 */     GIR_RootConstrainSelectedInstOperands,
     /*  755412 */     // GIR_Coverage, 12705,
     /*  755412 */     GIR_EraseRootFromParent_Done,
     /*  755413 */   // Label 11824: @755413
     /*  755413 */   GIM_Try, /*On fail goto*//*Label 11825*/ GIMT_Encode4(755488), // Rule ID 12708 //
     /*  755418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  755429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  755432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  755435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755486 */     GIR_RootConstrainSelectedInstOperands,
     /*  755487 */     // GIR_Coverage, 12708,
     /*  755487 */     GIR_EraseRootFromParent_Done,
     /*  755488 */   // Label 11825: @755488
     /*  755488 */   GIM_Try, /*On fail goto*//*Label 11826*/ GIMT_Encode4(755563), // Rule ID 12709 //
     /*  755493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  755504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  755507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  755510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755539 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755561 */     GIR_RootConstrainSelectedInstOperands,
     /*  755562 */     // GIR_Coverage, 12709,
     /*  755562 */     GIR_EraseRootFromParent_Done,
     /*  755563 */   // Label 11826: @755563
     /*  755563 */   GIM_Try, /*On fail goto*//*Label 11827*/ GIMT_Encode4(755638), // Rule ID 12712 //
     /*  755568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  755579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  755582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  755585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  755617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755636 */     GIR_RootConstrainSelectedInstOperands,
     /*  755637 */     // GIR_Coverage, 12712,
     /*  755637 */     GIR_EraseRootFromParent_Done,
     /*  755638 */   // Label 11827: @755638
     /*  755638 */   GIM_Try, /*On fail goto*//*Label 11828*/ GIMT_Encode4(755713), // Rule ID 12713 //
     /*  755643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  755654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  755657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  755660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755689 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  755692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755711 */     GIR_RootConstrainSelectedInstOperands,
     /*  755712 */     // GIR_Coverage, 12713,
     /*  755712 */     GIR_EraseRootFromParent_Done,
     /*  755713 */   // Label 11828: @755713
     /*  755713 */   GIM_Try, /*On fail goto*//*Label 11829*/ GIMT_Encode4(755788), // Rule ID 12716 //
     /*  755718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  755729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  755732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  755735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755764 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755786 */     GIR_RootConstrainSelectedInstOperands,
     /*  755787 */     // GIR_Coverage, 12716,
     /*  755787 */     GIR_EraseRootFromParent_Done,
     /*  755788 */   // Label 11829: @755788
     /*  755788 */   GIM_Try, /*On fail goto*//*Label 11830*/ GIMT_Encode4(755863), // Rule ID 12717 //
     /*  755793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  755804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  755807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  755810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755839 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755861 */     GIR_RootConstrainSelectedInstOperands,
     /*  755862 */     // GIR_Coverage, 12717,
     /*  755862 */     GIR_EraseRootFromParent_Done,
     /*  755863 */   // Label 11830: @755863
     /*  755863 */   GIM_Try, /*On fail goto*//*Label 11831*/ GIMT_Encode4(755938), // Rule ID 12720 //
     /*  755868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  755879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  755882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  755885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755936 */     GIR_RootConstrainSelectedInstOperands,
     /*  755937 */     // GIR_Coverage, 12720,
     /*  755937 */     GIR_EraseRootFromParent_Done,
     /*  755938 */   // Label 11831: @755938
     /*  755938 */   GIM_Try, /*On fail goto*//*Label 11832*/ GIMT_Encode4(756013), // Rule ID 12721 //
     /*  755943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  755954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  755957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  755960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755989 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756011 */     GIR_RootConstrainSelectedInstOperands,
     /*  756012 */     // GIR_Coverage, 12721,
     /*  756012 */     GIR_EraseRootFromParent_Done,
     /*  756013 */   // Label 11832: @756013
     /*  756013 */   GIM_Try, /*On fail goto*//*Label 11833*/ GIMT_Encode4(756088), // Rule ID 12724 //
     /*  756018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  756021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  756029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  756032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  756035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  756067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756086 */     GIR_RootConstrainSelectedInstOperands,
     /*  756087 */     // GIR_Coverage, 12724,
     /*  756087 */     GIR_EraseRootFromParent_Done,
     /*  756088 */   // Label 11833: @756088
     /*  756088 */   GIM_Try, /*On fail goto*//*Label 11834*/ GIMT_Encode4(756163), // Rule ID 12725 //
     /*  756093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  756096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  756104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  756107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  756110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756139 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  756142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756161 */     GIR_RootConstrainSelectedInstOperands,
     /*  756162 */     // GIR_Coverage, 12725,
     /*  756162 */     GIR_EraseRootFromParent_Done,
     /*  756163 */   // Label 11834: @756163
     /*  756163 */   GIM_Try, /*On fail goto*//*Label 11835*/ GIMT_Encode4(756238), // Rule ID 12728 //
     /*  756168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  756171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  756179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  756182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  756185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  756217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756236 */     GIR_RootConstrainSelectedInstOperands,
     /*  756237 */     // GIR_Coverage, 12728,
     /*  756237 */     GIR_EraseRootFromParent_Done,
     /*  756238 */   // Label 11835: @756238
     /*  756238 */   GIM_Try, /*On fail goto*//*Label 11836*/ GIMT_Encode4(756313), // Rule ID 12729 //
     /*  756243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  756246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  756254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  756257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  756260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756289 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  756292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756311 */     GIR_RootConstrainSelectedInstOperands,
     /*  756312 */     // GIR_Coverage, 12729,
     /*  756312 */     GIR_EraseRootFromParent_Done,
     /*  756313 */   // Label 11836: @756313
     /*  756313 */   GIM_Try, /*On fail goto*//*Label 11837*/ GIMT_Encode4(756391), // Rule ID 14058 //
     /*  756318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  756329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  756332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  756335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  756338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756364 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  756367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756389 */     GIR_RootConstrainSelectedInstOperands,
     /*  756390 */     // GIR_Coverage, 14058,
     /*  756390 */     GIR_EraseRootFromParent_Done,
     /*  756391 */   // Label 11837: @756391
     /*  756391 */   GIM_Try, /*On fail goto*//*Label 11838*/ GIMT_Encode4(756469), // Rule ID 14059 //
     /*  756396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  756407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  756410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  756413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  756416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756442 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  756445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756467 */     GIR_RootConstrainSelectedInstOperands,
     /*  756468 */     // GIR_Coverage, 14059,
     /*  756468 */     GIR_EraseRootFromParent_Done,
     /*  756469 */   // Label 11838: @756469
     /*  756469 */   GIM_Try, /*On fail goto*//*Label 11839*/ GIMT_Encode4(756547), // Rule ID 14062 //
     /*  756474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  756485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  756488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  756491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  756494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756520 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756545 */     GIR_RootConstrainSelectedInstOperands,
     /*  756546 */     // GIR_Coverage, 14062,
     /*  756546 */     GIR_EraseRootFromParent_Done,
     /*  756547 */   // Label 11839: @756547
     /*  756547 */   GIM_Try, /*On fail goto*//*Label 11840*/ GIMT_Encode4(756625), // Rule ID 14063 //
     /*  756552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  756563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  756566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  756569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  756572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756598 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756623 */     GIR_RootConstrainSelectedInstOperands,
     /*  756624 */     // GIR_Coverage, 14063,
     /*  756624 */     GIR_EraseRootFromParent_Done,
     /*  756625 */   // Label 11840: @756625
     /*  756625 */   GIM_Try, /*On fail goto*//*Label 11841*/ GIMT_Encode4(756703), // Rule ID 14066 //
     /*  756630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  756641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  756644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  756647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  756650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756676 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  756679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756701 */     GIR_RootConstrainSelectedInstOperands,
     /*  756702 */     // GIR_Coverage, 14066,
     /*  756702 */     GIR_EraseRootFromParent_Done,
     /*  756703 */   // Label 11841: @756703
     /*  756703 */   GIM_Try, /*On fail goto*//*Label 11842*/ GIMT_Encode4(756781), // Rule ID 14067 //
     /*  756708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  756719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  756722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  756725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  756728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756754 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  756757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756779 */     GIR_RootConstrainSelectedInstOperands,
     /*  756780 */     // GIR_Coverage, 14067,
     /*  756780 */     GIR_EraseRootFromParent_Done,
     /*  756781 */   // Label 11842: @756781
     /*  756781 */   GIM_Try, /*On fail goto*//*Label 11843*/ GIMT_Encode4(756859), // Rule ID 14070 //
     /*  756786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  756797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  756800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  756803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  756806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756832 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756857 */     GIR_RootConstrainSelectedInstOperands,
     /*  756858 */     // GIR_Coverage, 14070,
     /*  756858 */     GIR_EraseRootFromParent_Done,
     /*  756859 */   // Label 11843: @756859
     /*  756859 */   GIM_Try, /*On fail goto*//*Label 11844*/ GIMT_Encode4(756937), // Rule ID 14071 //
     /*  756864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  756875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  756878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  756881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  756884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756910 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756935 */     GIR_RootConstrainSelectedInstOperands,
     /*  756936 */     // GIR_Coverage, 14071,
     /*  756936 */     GIR_EraseRootFromParent_Done,
     /*  756937 */   // Label 11844: @756937
     /*  756937 */   GIM_Try, /*On fail goto*//*Label 11845*/ GIMT_Encode4(757015), // Rule ID 14074 //
     /*  756942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  756953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  756956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  756959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  756962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756988 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  756991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757013 */     GIR_RootConstrainSelectedInstOperands,
     /*  757014 */     // GIR_Coverage, 14074,
     /*  757014 */     GIR_EraseRootFromParent_Done,
     /*  757015 */   // Label 11845: @757015
     /*  757015 */   GIM_Try, /*On fail goto*//*Label 11846*/ GIMT_Encode4(757093), // Rule ID 14075 //
     /*  757020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  757031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  757034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  757037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  757040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757066 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757091 */     GIR_RootConstrainSelectedInstOperands,
     /*  757092 */     // GIR_Coverage, 14075,
     /*  757092 */     GIR_EraseRootFromParent_Done,
     /*  757093 */   // Label 11846: @757093
     /*  757093 */   GIM_Try, /*On fail goto*//*Label 11847*/ GIMT_Encode4(757171), // Rule ID 14078 //
     /*  757098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  757109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  757112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  757115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  757118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757144 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757169 */     GIR_RootConstrainSelectedInstOperands,
     /*  757170 */     // GIR_Coverage, 14078,
     /*  757170 */     GIR_EraseRootFromParent_Done,
     /*  757171 */   // Label 11847: @757171
     /*  757171 */   GIM_Try, /*On fail goto*//*Label 11848*/ GIMT_Encode4(757249), // Rule ID 14079 //
     /*  757176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  757187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  757190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  757193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  757196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757222 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757247 */     GIR_RootConstrainSelectedInstOperands,
     /*  757248 */     // GIR_Coverage, 14079,
     /*  757248 */     GIR_EraseRootFromParent_Done,
     /*  757249 */   // Label 11848: @757249
     /*  757249 */   GIM_Try, /*On fail goto*//*Label 11849*/ GIMT_Encode4(757327), // Rule ID 14082 //
     /*  757254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  757265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  757268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  757271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  757274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  757300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757325 */     GIR_RootConstrainSelectedInstOperands,
     /*  757326 */     // GIR_Coverage, 14082,
     /*  757326 */     GIR_EraseRootFromParent_Done,
     /*  757327 */   // Label 11849: @757327
     /*  757327 */   GIM_Try, /*On fail goto*//*Label 11850*/ GIMT_Encode4(757405), // Rule ID 14083 //
     /*  757332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  757343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  757346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  757349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  757352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757378 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  757378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757403 */     GIR_RootConstrainSelectedInstOperands,
     /*  757404 */     // GIR_Coverage, 14083,
     /*  757404 */     GIR_EraseRootFromParent_Done,
     /*  757405 */   // Label 11850: @757405
     /*  757405 */   GIM_Try, /*On fail goto*//*Label 11851*/ GIMT_Encode4(757483), // Rule ID 14086 //
     /*  757410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  757421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  757424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  757427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  757430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757456 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757481 */     GIR_RootConstrainSelectedInstOperands,
     /*  757482 */     // GIR_Coverage, 14086,
     /*  757482 */     GIR_EraseRootFromParent_Done,
     /*  757483 */   // Label 11851: @757483
     /*  757483 */   GIM_Try, /*On fail goto*//*Label 11852*/ GIMT_Encode4(757561), // Rule ID 14087 //
     /*  757488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  757499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  757502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  757505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  757508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757534 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757559 */     GIR_RootConstrainSelectedInstOperands,
     /*  757560 */     // GIR_Coverage, 14087,
     /*  757560 */     GIR_EraseRootFromParent_Done,
     /*  757561 */   // Label 11852: @757561
     /*  757561 */   GIM_Try, /*On fail goto*//*Label 11853*/ GIMT_Encode4(757639), // Rule ID 14090 //
     /*  757566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  757577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  757580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  757583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  757586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757612 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757637 */     GIR_RootConstrainSelectedInstOperands,
     /*  757638 */     // GIR_Coverage, 14090,
     /*  757638 */     GIR_EraseRootFromParent_Done,
     /*  757639 */   // Label 11853: @757639
     /*  757639 */   GIM_Try, /*On fail goto*//*Label 11854*/ GIMT_Encode4(757717), // Rule ID 14091 //
     /*  757644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  757655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  757658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  757661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  757664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757715 */     GIR_RootConstrainSelectedInstOperands,
     /*  757716 */     // GIR_Coverage, 14091,
     /*  757716 */     GIR_EraseRootFromParent_Done,
     /*  757717 */   // Label 11854: @757717
     /*  757717 */   GIM_Try, /*On fail goto*//*Label 11855*/ GIMT_Encode4(757795), // Rule ID 14094 //
     /*  757722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  757725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  757733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  757736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  757739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  757742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757768 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  757768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  757787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757793 */     GIR_RootConstrainSelectedInstOperands,
     /*  757794 */     // GIR_Coverage, 14094,
     /*  757794 */     GIR_EraseRootFromParent_Done,
     /*  757795 */   // Label 11855: @757795
     /*  757795 */   GIM_Try, /*On fail goto*//*Label 11856*/ GIMT_Encode4(757873), // Rule ID 14095 //
     /*  757800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  757803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  757811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  757814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  757817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  757820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757846 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  757846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  757865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757871 */     GIR_RootConstrainSelectedInstOperands,
     /*  757872 */     // GIR_Coverage, 14095,
     /*  757872 */     GIR_EraseRootFromParent_Done,
     /*  757873 */   // Label 11856: @757873
     /*  757873 */   GIM_Try, /*On fail goto*//*Label 11857*/ GIMT_Encode4(757951), // Rule ID 14098 //
     /*  757878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  757889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  757892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  757895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  757898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757924 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  757924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  757927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757949 */     GIR_RootConstrainSelectedInstOperands,
     /*  757950 */     // GIR_Coverage, 14098,
     /*  757950 */     GIR_EraseRootFromParent_Done,
     /*  757951 */   // Label 11857: @757951
     /*  757951 */   GIM_Try, /*On fail goto*//*Label 11858*/ GIMT_Encode4(758029), // Rule ID 14099 //
     /*  757956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  757967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  757970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  757973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  757976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758002 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758027 */     GIR_RootConstrainSelectedInstOperands,
     /*  758028 */     // GIR_Coverage, 14099,
     /*  758028 */     GIR_EraseRootFromParent_Done,
     /*  758029 */   // Label 11858: @758029
     /*  758029 */   GIM_Try, /*On fail goto*//*Label 11859*/ GIMT_Encode4(758107), // Rule ID 14102 //
     /*  758034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  758045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  758048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  758051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  758054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758080 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758102 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758105 */     GIR_RootConstrainSelectedInstOperands,
     /*  758106 */     // GIR_Coverage, 14102,
     /*  758106 */     GIR_EraseRootFromParent_Done,
     /*  758107 */   // Label 11859: @758107
     /*  758107 */   GIM_Try, /*On fail goto*//*Label 11860*/ GIMT_Encode4(758185), // Rule ID 14103 //
     /*  758112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  758123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  758126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  758129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  758132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758158 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758183 */     GIR_RootConstrainSelectedInstOperands,
     /*  758184 */     // GIR_Coverage, 14103,
     /*  758184 */     GIR_EraseRootFromParent_Done,
     /*  758185 */   // Label 11860: @758185
     /*  758185 */   GIM_Try, /*On fail goto*//*Label 11861*/ GIMT_Encode4(758263), // Rule ID 14106 //
     /*  758190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  758201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  758204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  758207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  758210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758236 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758261 */     GIR_RootConstrainSelectedInstOperands,
     /*  758262 */     // GIR_Coverage, 14106,
     /*  758262 */     GIR_EraseRootFromParent_Done,
     /*  758263 */   // Label 11861: @758263
     /*  758263 */   GIM_Try, /*On fail goto*//*Label 11862*/ GIMT_Encode4(758341), // Rule ID 14107 //
     /*  758268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  758279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  758282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  758285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  758288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758314 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758339 */     GIR_RootConstrainSelectedInstOperands,
     /*  758340 */     // GIR_Coverage, 14107,
     /*  758340 */     GIR_EraseRootFromParent_Done,
     /*  758341 */   // Label 11862: @758341
     /*  758341 */   GIM_Try, /*On fail goto*//*Label 11863*/ GIMT_Encode4(758419), // Rule ID 14110 //
     /*  758346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  758363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  758366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758417 */     GIR_RootConstrainSelectedInstOperands,
     /*  758418 */     // GIR_Coverage, 14110,
     /*  758418 */     GIR_EraseRootFromParent_Done,
     /*  758419 */   // Label 11863: @758419
     /*  758419 */   GIM_Try, /*On fail goto*//*Label 11864*/ GIMT_Encode4(758497), // Rule ID 14111 //
     /*  758424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  758441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  758444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758495 */     GIR_RootConstrainSelectedInstOperands,
     /*  758496 */     // GIR_Coverage, 14111,
     /*  758496 */     GIR_EraseRootFromParent_Done,
     /*  758497 */   // Label 11864: @758497
     /*  758497 */   GIM_Try, /*On fail goto*//*Label 11865*/ GIMT_Encode4(758575), // Rule ID 14114 //
     /*  758502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  758513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  758516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  758519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  758522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758548 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758573 */     GIR_RootConstrainSelectedInstOperands,
     /*  758574 */     // GIR_Coverage, 14114,
     /*  758574 */     GIR_EraseRootFromParent_Done,
     /*  758575 */   // Label 11865: @758575
     /*  758575 */   GIM_Try, /*On fail goto*//*Label 11866*/ GIMT_Encode4(758653), // Rule ID 14115 //
     /*  758580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  758591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  758594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  758597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  758600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758651 */     GIR_RootConstrainSelectedInstOperands,
     /*  758652 */     // GIR_Coverage, 14115,
     /*  758652 */     GIR_EraseRootFromParent_Done,
     /*  758653 */   // Label 11866: @758653
     /*  758653 */   GIM_Try, /*On fail goto*//*Label 11867*/ GIMT_Encode4(758731), // Rule ID 14118 //
     /*  758658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  758669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  758672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  758675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  758678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758704 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758729 */     GIR_RootConstrainSelectedInstOperands,
     /*  758730 */     // GIR_Coverage, 14118,
     /*  758730 */     GIR_EraseRootFromParent_Done,
     /*  758731 */   // Label 11867: @758731
     /*  758731 */   GIM_Try, /*On fail goto*//*Label 11868*/ GIMT_Encode4(758809), // Rule ID 14119 //
     /*  758736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  758747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  758750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  758753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  758756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758782 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758807 */     GIR_RootConstrainSelectedInstOperands,
     /*  758808 */     // GIR_Coverage, 14119,
     /*  758808 */     GIR_EraseRootFromParent_Done,
     /*  758809 */   // Label 11868: @758809
     /*  758809 */   GIM_Try, /*On fail goto*//*Label 11869*/ GIMT_Encode4(758887), // Rule ID 14122 //
     /*  758814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  758825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  758828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  758831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  758834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758860 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  758860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758885 */     GIR_RootConstrainSelectedInstOperands,
     /*  758886 */     // GIR_Coverage, 14122,
     /*  758886 */     GIR_EraseRootFromParent_Done,
     /*  758887 */   // Label 11869: @758887
     /*  758887 */   GIM_Try, /*On fail goto*//*Label 11870*/ GIMT_Encode4(758965), // Rule ID 14123 //
     /*  758892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  758903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  758906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  758909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  758912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  758938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758963 */     GIR_RootConstrainSelectedInstOperands,
     /*  758964 */     // GIR_Coverage, 14123,
     /*  758964 */     GIR_EraseRootFromParent_Done,
     /*  758965 */   // Label 11870: @758965
     /*  758965 */   GIM_Try, /*On fail goto*//*Label 11871*/ GIMT_Encode4(759043), // Rule ID 14126 //
     /*  758970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  758981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  758984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  758987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  758990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759016 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759041 */     GIR_RootConstrainSelectedInstOperands,
     /*  759042 */     // GIR_Coverage, 14126,
     /*  759042 */     GIR_EraseRootFromParent_Done,
     /*  759043 */   // Label 11871: @759043
     /*  759043 */   GIM_Try, /*On fail goto*//*Label 11872*/ GIMT_Encode4(759121), // Rule ID 14127 //
     /*  759048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  759059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  759062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  759065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  759068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759119 */     GIR_RootConstrainSelectedInstOperands,
     /*  759120 */     // GIR_Coverage, 14127,
     /*  759120 */     GIR_EraseRootFromParent_Done,
     /*  759121 */   // Label 11872: @759121
     /*  759121 */   GIM_Try, /*On fail goto*//*Label 11873*/ GIMT_Encode4(759199), // Rule ID 14130 //
     /*  759126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  759143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  759146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759172 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759197 */     GIR_RootConstrainSelectedInstOperands,
     /*  759198 */     // GIR_Coverage, 14130,
     /*  759198 */     GIR_EraseRootFromParent_Done,
     /*  759199 */   // Label 11873: @759199
     /*  759199 */   GIM_Try, /*On fail goto*//*Label 11874*/ GIMT_Encode4(759277), // Rule ID 14131 //
     /*  759204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  759221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  759224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759250 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759275 */     GIR_RootConstrainSelectedInstOperands,
     /*  759276 */     // GIR_Coverage, 14131,
     /*  759276 */     GIR_EraseRootFromParent_Done,
     /*  759277 */   // Label 11874: @759277
     /*  759277 */   GIM_Try, /*On fail goto*//*Label 11875*/ GIMT_Encode4(759355), // Rule ID 14134 //
     /*  759282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  759285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  759299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  759302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759328 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  759331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759353 */     GIR_RootConstrainSelectedInstOperands,
     /*  759354 */     // GIR_Coverage, 14134,
     /*  759354 */     GIR_EraseRootFromParent_Done,
     /*  759355 */   // Label 11875: @759355
     /*  759355 */   GIM_Try, /*On fail goto*//*Label 11876*/ GIMT_Encode4(759433), // Rule ID 14135 //
     /*  759360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  759363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  759377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  759380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759406 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  759406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  759409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759431 */     GIR_RootConstrainSelectedInstOperands,
     /*  759432 */     // GIR_Coverage, 14135,
     /*  759432 */     GIR_EraseRootFromParent_Done,
     /*  759433 */   // Label 11876: @759433
     /*  759433 */   GIM_Try, /*On fail goto*//*Label 11877*/ GIMT_Encode4(759511), // Rule ID 14138 //
     /*  759438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  759441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  759455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  759458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759509 */     GIR_RootConstrainSelectedInstOperands,
     /*  759510 */     // GIR_Coverage, 14138,
     /*  759510 */     GIR_EraseRootFromParent_Done,
     /*  759511 */   // Label 11877: @759511
     /*  759511 */   GIM_Try, /*On fail goto*//*Label 11878*/ GIMT_Encode4(759589), // Rule ID 14139 //
     /*  759516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  759519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  759533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  759536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759562 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  759562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759587 */     GIR_RootConstrainSelectedInstOperands,
     /*  759588 */     // GIR_Coverage, 14139,
     /*  759588 */     GIR_EraseRootFromParent_Done,
     /*  759589 */   // Label 11878: @759589
     /*  759589 */   GIM_Try, /*On fail goto*//*Label 11879*/ GIMT_Encode4(759667), // Rule ID 14142 //
     /*  759594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  759597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  759605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  759608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  759611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  759614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759640 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759665 */     GIR_RootConstrainSelectedInstOperands,
     /*  759666 */     // GIR_Coverage, 14142,
     /*  759666 */     GIR_EraseRootFromParent_Done,
     /*  759667 */   // Label 11879: @759667
     /*  759667 */   GIM_Try, /*On fail goto*//*Label 11880*/ GIMT_Encode4(759745), // Rule ID 14143 //
     /*  759672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  759675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  759683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  759686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  759689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  759692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  759718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759743 */     GIR_RootConstrainSelectedInstOperands,
     /*  759744 */     // GIR_Coverage, 14143,
     /*  759744 */     GIR_EraseRootFromParent_Done,
     /*  759745 */   // Label 11880: @759745
     /*  759745 */   GIM_Try, /*On fail goto*//*Label 11881*/ GIMT_Encode4(759823), // Rule ID 14146 //
     /*  759750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  759761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  759764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  759767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759796 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  759796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  759799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  759815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759821 */     GIR_RootConstrainSelectedInstOperands,
     /*  759822 */     // GIR_Coverage, 14146,
     /*  759822 */     GIR_EraseRootFromParent_Done,
     /*  759823 */   // Label 11881: @759823
     /*  759823 */   GIM_Try, /*On fail goto*//*Label 11882*/ GIMT_Encode4(759901), // Rule ID 14147 //
     /*  759828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  759839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  759842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  759845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759874 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  759874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  759877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  759893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759899 */     GIR_RootConstrainSelectedInstOperands,
     /*  759900 */     // GIR_Coverage, 14147,
     /*  759900 */     GIR_EraseRootFromParent_Done,
     /*  759901 */   // Label 11882: @759901
     /*  759901 */   GIM_Try, /*On fail goto*//*Label 11883*/ GIMT_Encode4(759979), // Rule ID 14150 //
     /*  759906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  759917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  759920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  759923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759952 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  759952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  759955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  759971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759977 */     GIR_RootConstrainSelectedInstOperands,
     /*  759978 */     // GIR_Coverage, 14150,
     /*  759978 */     GIR_EraseRootFromParent_Done,
     /*  759979 */   // Label 11883: @759979
     /*  759979 */   GIM_Try, /*On fail goto*//*Label 11884*/ GIMT_Encode4(760057), // Rule ID 14151 //
     /*  759984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  759995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  759998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  760001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760030 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760055 */     GIR_RootConstrainSelectedInstOperands,
     /*  760056 */     // GIR_Coverage, 14151,
     /*  760056 */     GIR_EraseRootFromParent_Done,
     /*  760057 */   // Label 11884: @760057
     /*  760057 */   GIM_Try, /*On fail goto*//*Label 11885*/ GIMT_Encode4(760135), // Rule ID 14154 //
     /*  760062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  760073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  760076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  760079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760108 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760133 */     GIR_RootConstrainSelectedInstOperands,
     /*  760134 */     // GIR_Coverage, 14154,
     /*  760134 */     GIR_EraseRootFromParent_Done,
     /*  760135 */   // Label 11885: @760135
     /*  760135 */   GIM_Try, /*On fail goto*//*Label 11886*/ GIMT_Encode4(760213), // Rule ID 14155 //
     /*  760140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  760151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  760154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  760157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760186 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760211 */     GIR_RootConstrainSelectedInstOperands,
     /*  760212 */     // GIR_Coverage, 14155,
     /*  760212 */     GIR_EraseRootFromParent_Done,
     /*  760213 */   // Label 11886: @760213
     /*  760213 */   GIM_Try, /*On fail goto*//*Label 11887*/ GIMT_Encode4(760291), // Rule ID 14158 //
     /*  760218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  760229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  760232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  760235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760264 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760289 */     GIR_RootConstrainSelectedInstOperands,
     /*  760290 */     // GIR_Coverage, 14158,
     /*  760290 */     GIR_EraseRootFromParent_Done,
     /*  760291 */   // Label 11887: @760291
     /*  760291 */   GIM_Try, /*On fail goto*//*Label 11888*/ GIMT_Encode4(760369), // Rule ID 14159 //
     /*  760296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  760307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  760310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  760313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760342 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760367 */     GIR_RootConstrainSelectedInstOperands,
     /*  760368 */     // GIR_Coverage, 14159,
     /*  760368 */     GIR_EraseRootFromParent_Done,
     /*  760369 */   // Label 11888: @760369
     /*  760369 */   GIM_Try, /*On fail goto*//*Label 11889*/ GIMT_Encode4(760447), // Rule ID 14162 //
     /*  760374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760420 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760445 */     GIR_RootConstrainSelectedInstOperands,
     /*  760446 */     // GIR_Coverage, 14162,
     /*  760446 */     GIR_EraseRootFromParent_Done,
     /*  760447 */   // Label 11889: @760447
     /*  760447 */   GIM_Try, /*On fail goto*//*Label 11890*/ GIMT_Encode4(760525), // Rule ID 14163 //
     /*  760452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760498 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760523 */     GIR_RootConstrainSelectedInstOperands,
     /*  760524 */     // GIR_Coverage, 14163,
     /*  760524 */     GIR_EraseRootFromParent_Done,
     /*  760525 */   // Label 11890: @760525
     /*  760525 */   GIM_Try, /*On fail goto*//*Label 11891*/ GIMT_Encode4(760603), // Rule ID 14166 //
     /*  760530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  760541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  760544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  760547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760576 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  760576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760601 */     GIR_RootConstrainSelectedInstOperands,
     /*  760602 */     // GIR_Coverage, 14166,
     /*  760602 */     GIR_EraseRootFromParent_Done,
     /*  760603 */   // Label 11891: @760603
     /*  760603 */   GIM_Try, /*On fail goto*//*Label 11892*/ GIMT_Encode4(760681), // Rule ID 14167 //
     /*  760608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  760619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  760622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  760625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  760654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760679 */     GIR_RootConstrainSelectedInstOperands,
     /*  760680 */     // GIR_Coverage, 14167,
     /*  760680 */     GIR_EraseRootFromParent_Done,
     /*  760681 */   // Label 11892: @760681
     /*  760681 */   GIM_Try, /*On fail goto*//*Label 11893*/ GIMT_Encode4(760759), // Rule ID 14170 //
     /*  760686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  760697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  760700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  760703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760757 */     GIR_RootConstrainSelectedInstOperands,
     /*  760758 */     // GIR_Coverage, 14170,
     /*  760758 */     GIR_EraseRootFromParent_Done,
     /*  760759 */   // Label 11893: @760759
     /*  760759 */   GIM_Try, /*On fail goto*//*Label 11894*/ GIMT_Encode4(760837), // Rule ID 14171 //
     /*  760764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  760775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  760778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  760781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760810 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760835 */     GIR_RootConstrainSelectedInstOperands,
     /*  760836 */     // GIR_Coverage, 14171,
     /*  760836 */     GIR_EraseRootFromParent_Done,
     /*  760837 */   // Label 11894: @760837
     /*  760837 */   GIM_Try, /*On fail goto*//*Label 11895*/ GIMT_Encode4(760915), // Rule ID 14174 //
     /*  760842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  760853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  760856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  760859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760888 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760913 */     GIR_RootConstrainSelectedInstOperands,
     /*  760914 */     // GIR_Coverage, 14174,
     /*  760914 */     GIR_EraseRootFromParent_Done,
     /*  760915 */   // Label 11895: @760915
     /*  760915 */   GIM_Try, /*On fail goto*//*Label 11896*/ GIMT_Encode4(760993), // Rule ID 14175 //
     /*  760920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  760931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  760934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  760937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760966 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760991 */     GIR_RootConstrainSelectedInstOperands,
     /*  760992 */     // GIR_Coverage, 14175,
     /*  760992 */     GIR_EraseRootFromParent_Done,
     /*  760993 */   // Label 11896: @760993
     /*  760993 */   GIM_Try, /*On fail goto*//*Label 11897*/ GIMT_Encode4(761071), // Rule ID 14178 //
     /*  760998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  761009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  761012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  761015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761044 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  761044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761069 */     GIR_RootConstrainSelectedInstOperands,
     /*  761070 */     // GIR_Coverage, 14178,
     /*  761070 */     GIR_EraseRootFromParent_Done,
     /*  761071 */   // Label 11897: @761071
     /*  761071 */   GIM_Try, /*On fail goto*//*Label 11898*/ GIMT_Encode4(761149), // Rule ID 14179 //
     /*  761076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  761087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  761090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  761093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761122 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761147 */     GIR_RootConstrainSelectedInstOperands,
     /*  761148 */     // GIR_Coverage, 14179,
     /*  761148 */     GIR_EraseRootFromParent_Done,
     /*  761149 */   // Label 11898: @761149
     /*  761149 */   GIM_Try, /*On fail goto*//*Label 11899*/ GIMT_Encode4(761227), // Rule ID 14182 //
     /*  761154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  761157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  761165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  761168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  761171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761200 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  761200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761225 */     GIR_RootConstrainSelectedInstOperands,
     /*  761226 */     // GIR_Coverage, 14182,
     /*  761226 */     GIR_EraseRootFromParent_Done,
     /*  761227 */   // Label 11899: @761227
     /*  761227 */   GIM_Try, /*On fail goto*//*Label 11900*/ GIMT_Encode4(761305), // Rule ID 14183 //
     /*  761232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  761235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  761243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  761246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  761249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761278 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  761278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761303 */     GIR_RootConstrainSelectedInstOperands,
     /*  761304 */     // GIR_Coverage, 14183,
     /*  761304 */     GIR_EraseRootFromParent_Done,
     /*  761305 */   // Label 11900: @761305
     /*  761305 */   GIM_Try, /*On fail goto*//*Label 11901*/ GIMT_Encode4(761383), // Rule ID 14186 //
     /*  761310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  761321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  761324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  761327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761356 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761381 */     GIR_RootConstrainSelectedInstOperands,
     /*  761382 */     // GIR_Coverage, 14186,
     /*  761382 */     GIR_EraseRootFromParent_Done,
     /*  761383 */   // Label 11901: @761383
     /*  761383 */   GIM_Try, /*On fail goto*//*Label 11902*/ GIMT_Encode4(761461), // Rule ID 14187 //
     /*  761388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  761399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  761402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  761405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761434 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761459 */     GIR_RootConstrainSelectedInstOperands,
     /*  761460 */     // GIR_Coverage, 14187,
     /*  761460 */     GIR_EraseRootFromParent_Done,
     /*  761461 */   // Label 11902: @761461
     /*  761461 */   GIM_Try, /*On fail goto*//*Label 11903*/ GIMT_Encode4(761539), // Rule ID 14190 //
     /*  761466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  761477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  761480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  761483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761512 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  761515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761537 */     GIR_RootConstrainSelectedInstOperands,
     /*  761538 */     // GIR_Coverage, 14190,
     /*  761538 */     GIR_EraseRootFromParent_Done,
     /*  761539 */   // Label 11903: @761539
     /*  761539 */   GIM_Try, /*On fail goto*//*Label 11904*/ GIMT_Encode4(761617), // Rule ID 14191 //
     /*  761544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  761555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  761558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  761561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761590 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  761593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761615 */     GIR_RootConstrainSelectedInstOperands,
     /*  761616 */     // GIR_Coverage, 14191,
     /*  761616 */     GIR_EraseRootFromParent_Done,
     /*  761617 */   // Label 11904: @761617
     /*  761617 */   GIM_Try, /*On fail goto*//*Label 11905*/ GIMT_Encode4(761695), // Rule ID 14194 //
     /*  761622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  761633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  761636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  761639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761668 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  761671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761693 */     GIR_RootConstrainSelectedInstOperands,
     /*  761694 */     // GIR_Coverage, 14194,
     /*  761694 */     GIR_EraseRootFromParent_Done,
     /*  761695 */   // Label 11905: @761695
     /*  761695 */   GIM_Try, /*On fail goto*//*Label 11906*/ GIMT_Encode4(761773), // Rule ID 14195 //
     /*  761700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  761711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  761714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  761717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761746 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  761749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761771 */     GIR_RootConstrainSelectedInstOperands,
     /*  761772 */     // GIR_Coverage, 14195,
     /*  761772 */     GIR_EraseRootFromParent_Done,
     /*  761773 */   // Label 11906: @761773
     /*  761773 */   GIM_Try, /*On fail goto*//*Label 11907*/ GIMT_Encode4(761851), // Rule ID 14198 //
     /*  761778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  761789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  761792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  761795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761824 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  761824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761849 */     GIR_RootConstrainSelectedInstOperands,
     /*  761850 */     // GIR_Coverage, 14198,
     /*  761850 */     GIR_EraseRootFromParent_Done,
     /*  761851 */   // Label 11907: @761851
     /*  761851 */   GIM_Try, /*On fail goto*//*Label 11908*/ GIMT_Encode4(761929), // Rule ID 14199 //
     /*  761856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  761867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  761870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  761873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  761902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761927 */     GIR_RootConstrainSelectedInstOperands,
     /*  761928 */     // GIR_Coverage, 14199,
     /*  761928 */     GIR_EraseRootFromParent_Done,
     /*  761929 */   // Label 11908: @761929
     /*  761929 */   GIM_Try, /*On fail goto*//*Label 11909*/ GIMT_Encode4(762007), // Rule ID 14202 //
     /*  761934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  761945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  761948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  761951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761980 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  761980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  761983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762005 */     GIR_RootConstrainSelectedInstOperands,
     /*  762006 */     // GIR_Coverage, 14202,
     /*  762006 */     GIR_EraseRootFromParent_Done,
     /*  762007 */   // Label 11909: @762007
     /*  762007 */   GIM_Try, /*On fail goto*//*Label 11910*/ GIMT_Encode4(762085), // Rule ID 14203 //
     /*  762012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  762023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  762026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  762029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762058 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762080 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762083 */     GIR_RootConstrainSelectedInstOperands,
     /*  762084 */     // GIR_Coverage, 14203,
     /*  762084 */     GIR_EraseRootFromParent_Done,
     /*  762085 */   // Label 11910: @762085
     /*  762085 */   GIM_Try, /*On fail goto*//*Label 11911*/ GIMT_Encode4(762163), // Rule ID 14206 //
     /*  762090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  762101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  762104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  762107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762136 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762161 */     GIR_RootConstrainSelectedInstOperands,
     /*  762162 */     // GIR_Coverage, 14206,
     /*  762162 */     GIR_EraseRootFromParent_Done,
     /*  762163 */   // Label 11911: @762163
     /*  762163 */   GIM_Try, /*On fail goto*//*Label 11912*/ GIMT_Encode4(762241), // Rule ID 14207 //
     /*  762168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  762179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  762182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  762185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762214 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762239 */     GIR_RootConstrainSelectedInstOperands,
     /*  762240 */     // GIR_Coverage, 14207,
     /*  762240 */     GIR_EraseRootFromParent_Done,
     /*  762241 */   // Label 11912: @762241
     /*  762241 */   GIM_Try, /*On fail goto*//*Label 11913*/ GIMT_Encode4(762319), // Rule ID 14210 //
     /*  762246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  762257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  762260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  762263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762317 */     GIR_RootConstrainSelectedInstOperands,
     /*  762318 */     // GIR_Coverage, 14210,
     /*  762318 */     GIR_EraseRootFromParent_Done,
     /*  762319 */   // Label 11913: @762319
     /*  762319 */   GIM_Try, /*On fail goto*//*Label 11914*/ GIMT_Encode4(762397), // Rule ID 14211 //
     /*  762324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  762335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  762338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  762341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762370 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762395 */     GIR_RootConstrainSelectedInstOperands,
     /*  762396 */     // GIR_Coverage, 14211,
     /*  762396 */     GIR_EraseRootFromParent_Done,
     /*  762397 */   // Label 11914: @762397
     /*  762397 */   GIM_Try, /*On fail goto*//*Label 11915*/ GIMT_Encode4(762475), // Rule ID 14214 //
     /*  762402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  762413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  762416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  762419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762448 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762473 */     GIR_RootConstrainSelectedInstOperands,
     /*  762474 */     // GIR_Coverage, 14214,
     /*  762474 */     GIR_EraseRootFromParent_Done,
     /*  762475 */   // Label 11915: @762475
     /*  762475 */   GIM_Try, /*On fail goto*//*Label 11916*/ GIMT_Encode4(762553), // Rule ID 14215 //
     /*  762480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  762491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  762494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  762497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762526 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762551 */     GIR_RootConstrainSelectedInstOperands,
     /*  762552 */     // GIR_Coverage, 14215,
     /*  762552 */     GIR_EraseRootFromParent_Done,
     /*  762553 */   // Label 11916: @762553
     /*  762553 */   GIM_Try, /*On fail goto*//*Label 11917*/ GIMT_Encode4(762631), // Rule ID 14218 //
     /*  762558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  762569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  762572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  762575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762604 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762629 */     GIR_RootConstrainSelectedInstOperands,
     /*  762630 */     // GIR_Coverage, 14218,
     /*  762630 */     GIR_EraseRootFromParent_Done,
     /*  762631 */   // Label 11917: @762631
     /*  762631 */   GIM_Try, /*On fail goto*//*Label 11918*/ GIMT_Encode4(762709), // Rule ID 14219 //
     /*  762636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  762647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  762650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  762653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762682 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762707 */     GIR_RootConstrainSelectedInstOperands,
     /*  762708 */     // GIR_Coverage, 14219,
     /*  762708 */     GIR_EraseRootFromParent_Done,
     /*  762709 */   // Label 11918: @762709
     /*  762709 */   GIM_Try, /*On fail goto*//*Label 11919*/ GIMT_Encode4(762787), // Rule ID 14222 //
     /*  762714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  762717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  762725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  762728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  762731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  762760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762782 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762785 */     GIR_RootConstrainSelectedInstOperands,
     /*  762786 */     // GIR_Coverage, 14222,
     /*  762786 */     GIR_EraseRootFromParent_Done,
     /*  762787 */   // Label 11919: @762787
     /*  762787 */   GIM_Try, /*On fail goto*//*Label 11920*/ GIMT_Encode4(762865), // Rule ID 14223 //
     /*  762792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  762795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  762803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  762806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  762809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762838 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  762838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762863 */     GIR_RootConstrainSelectedInstOperands,
     /*  762864 */     // GIR_Coverage, 14223,
     /*  762864 */     GIR_EraseRootFromParent_Done,
     /*  762865 */   // Label 11920: @762865
     /*  762865 */   GIM_Try, /*On fail goto*//*Label 11921*/ GIMT_Encode4(762943), // Rule ID 14226 //
     /*  762870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  762873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  762881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  762884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  762887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762916 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  762916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762938 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762941 */     GIR_RootConstrainSelectedInstOperands,
     /*  762942 */     // GIR_Coverage, 14226,
     /*  762942 */     GIR_EraseRootFromParent_Done,
     /*  762943 */   // Label 11921: @762943
     /*  762943 */   GIM_Try, /*On fail goto*//*Label 11922*/ GIMT_Encode4(763021), // Rule ID 14227 //
     /*  762948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  762951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  762959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  762962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  762965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762994 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  762994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763019 */     GIR_RootConstrainSelectedInstOperands,
     /*  763020 */     // GIR_Coverage, 14227,
     /*  763020 */     GIR_EraseRootFromParent_Done,
     /*  763021 */   // Label 11922: @763021
     /*  763021 */   GIM_Try, /*On fail goto*//*Label 11923*/ GIMT_Encode4(763099), // Rule ID 14230 //
     /*  763026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  763037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  763040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  763043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763072 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  763075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763097 */     GIR_RootConstrainSelectedInstOperands,
     /*  763098 */     // GIR_Coverage, 14230,
     /*  763098 */     GIR_EraseRootFromParent_Done,
     /*  763099 */   // Label 11923: @763099
     /*  763099 */   GIM_Try, /*On fail goto*//*Label 11924*/ GIMT_Encode4(763177), // Rule ID 14231 //
     /*  763104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  763115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  763118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  763121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763150 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  763153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763175 */     GIR_RootConstrainSelectedInstOperands,
     /*  763176 */     // GIR_Coverage, 14231,
     /*  763176 */     GIR_EraseRootFromParent_Done,
     /*  763177 */   // Label 11924: @763177
     /*  763177 */   GIM_Try, /*On fail goto*//*Label 11925*/ GIMT_Encode4(763255), // Rule ID 14322 //
     /*  763182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  763193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  763196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  763199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  763202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763228 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  763231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763253 */     GIR_RootConstrainSelectedInstOperands,
     /*  763254 */     // GIR_Coverage, 14322,
     /*  763254 */     GIR_EraseRootFromParent_Done,
     /*  763255 */   // Label 11925: @763255
     /*  763255 */   GIM_Try, /*On fail goto*//*Label 11926*/ GIMT_Encode4(763333), // Rule ID 14323 //
     /*  763260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  763271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  763274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  763277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  763280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763306 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  763309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763331 */     GIR_RootConstrainSelectedInstOperands,
     /*  763332 */     // GIR_Coverage, 14323,
     /*  763332 */     GIR_EraseRootFromParent_Done,
     /*  763333 */   // Label 11926: @763333
     /*  763333 */   GIM_Try, /*On fail goto*//*Label 11927*/ GIMT_Encode4(763411), // Rule ID 14326 //
     /*  763338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  763349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  763352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  763355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  763358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763384 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763409 */     GIR_RootConstrainSelectedInstOperands,
     /*  763410 */     // GIR_Coverage, 14326,
     /*  763410 */     GIR_EraseRootFromParent_Done,
     /*  763411 */   // Label 11927: @763411
     /*  763411 */   GIM_Try, /*On fail goto*//*Label 11928*/ GIMT_Encode4(763489), // Rule ID 14327 //
     /*  763416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  763427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  763430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  763433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  763436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763462 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763487 */     GIR_RootConstrainSelectedInstOperands,
     /*  763488 */     // GIR_Coverage, 14327,
     /*  763488 */     GIR_EraseRootFromParent_Done,
     /*  763489 */   // Label 11928: @763489
     /*  763489 */   GIM_Try, /*On fail goto*//*Label 11929*/ GIMT_Encode4(763567), // Rule ID 14330 //
     /*  763494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  763505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  763508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  763511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  763514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763540 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763565 */     GIR_RootConstrainSelectedInstOperands,
     /*  763566 */     // GIR_Coverage, 14330,
     /*  763566 */     GIR_EraseRootFromParent_Done,
     /*  763567 */   // Label 11929: @763567
     /*  763567 */   GIM_Try, /*On fail goto*//*Label 11930*/ GIMT_Encode4(763645), // Rule ID 14331 //
     /*  763572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  763583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  763586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  763589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  763592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763618 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763643 */     GIR_RootConstrainSelectedInstOperands,
     /*  763644 */     // GIR_Coverage, 14331,
     /*  763644 */     GIR_EraseRootFromParent_Done,
     /*  763645 */   // Label 11930: @763645
     /*  763645 */   GIM_Try, /*On fail goto*//*Label 11931*/ GIMT_Encode4(763723), // Rule ID 14334 //
     /*  763650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  763661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  763664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  763667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  763670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763696 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  763696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763721 */     GIR_RootConstrainSelectedInstOperands,
     /*  763722 */     // GIR_Coverage, 14334,
     /*  763722 */     GIR_EraseRootFromParent_Done,
     /*  763723 */   // Label 11931: @763723
     /*  763723 */   GIM_Try, /*On fail goto*//*Label 11932*/ GIMT_Encode4(763801), // Rule ID 14335 //
     /*  763728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  763739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  763742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  763745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  763748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763774 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  763774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763799 */     GIR_RootConstrainSelectedInstOperands,
     /*  763800 */     // GIR_Coverage, 14335,
     /*  763800 */     GIR_EraseRootFromParent_Done,
     /*  763801 */   // Label 11932: @763801
     /*  763801 */   GIM_Try, /*On fail goto*//*Label 11933*/ GIMT_Encode4(763879), // Rule ID 14338 //
     /*  763806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  763817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  763820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  763823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  763826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  763852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763877 */     GIR_RootConstrainSelectedInstOperands,
     /*  763878 */     // GIR_Coverage, 14338,
     /*  763878 */     GIR_EraseRootFromParent_Done,
     /*  763879 */   // Label 11933: @763879
     /*  763879 */   GIM_Try, /*On fail goto*//*Label 11934*/ GIMT_Encode4(763957), // Rule ID 14339 //
     /*  763884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  763895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  763898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  763901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  763904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763930 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  763930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763955 */     GIR_RootConstrainSelectedInstOperands,
     /*  763956 */     // GIR_Coverage, 14339,
     /*  763956 */     GIR_EraseRootFromParent_Done,
     /*  763957 */   // Label 11934: @763957
     /*  763957 */   GIM_Try, /*On fail goto*//*Label 11935*/ GIMT_Encode4(764035), // Rule ID 14342 //
     /*  763962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  763973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  763976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  763979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  763982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764008 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764033 */     GIR_RootConstrainSelectedInstOperands,
     /*  764034 */     // GIR_Coverage, 14342,
     /*  764034 */     GIR_EraseRootFromParent_Done,
     /*  764035 */   // Label 11935: @764035
     /*  764035 */   GIM_Try, /*On fail goto*//*Label 11936*/ GIMT_Encode4(764113), // Rule ID 14343 //
     /*  764040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  764051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  764054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  764057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  764060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764111 */     GIR_RootConstrainSelectedInstOperands,
     /*  764112 */     // GIR_Coverage, 14343,
     /*  764112 */     GIR_EraseRootFromParent_Done,
     /*  764113 */   // Label 11936: @764113
     /*  764113 */   GIM_Try, /*On fail goto*//*Label 11937*/ GIMT_Encode4(764191), // Rule ID 14346 //
     /*  764118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  764129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  764132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  764135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  764138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764164 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764189 */     GIR_RootConstrainSelectedInstOperands,
     /*  764190 */     // GIR_Coverage, 14346,
     /*  764190 */     GIR_EraseRootFromParent_Done,
     /*  764191 */   // Label 11937: @764191
     /*  764191 */   GIM_Try, /*On fail goto*//*Label 11938*/ GIMT_Encode4(764269), // Rule ID 14347 //
     /*  764196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  764207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  764210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  764213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  764216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764242 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764267 */     GIR_RootConstrainSelectedInstOperands,
     /*  764268 */     // GIR_Coverage, 14347,
     /*  764268 */     GIR_EraseRootFromParent_Done,
     /*  764269 */   // Label 11938: @764269
     /*  764269 */   GIM_Try, /*On fail goto*//*Label 11939*/ GIMT_Encode4(764347), // Rule ID 14350 //
     /*  764274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  764285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  764288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  764291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  764294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764320 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764345 */     GIR_RootConstrainSelectedInstOperands,
     /*  764346 */     // GIR_Coverage, 14350,
     /*  764346 */     GIR_EraseRootFromParent_Done,
     /*  764347 */   // Label 11939: @764347
     /*  764347 */   GIM_Try, /*On fail goto*//*Label 11940*/ GIMT_Encode4(764425), // Rule ID 14351 //
     /*  764352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  764363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  764366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  764369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  764372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764423 */     GIR_RootConstrainSelectedInstOperands,
     /*  764424 */     // GIR_Coverage, 14351,
     /*  764424 */     GIR_EraseRootFromParent_Done,
     /*  764425 */   // Label 11940: @764425
     /*  764425 */   GIM_Try, /*On fail goto*//*Label 11941*/ GIMT_Encode4(764503), // Rule ID 14354 //
     /*  764430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  764441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  764444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  764447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  764450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764476 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764501 */     GIR_RootConstrainSelectedInstOperands,
     /*  764502 */     // GIR_Coverage, 14354,
     /*  764502 */     GIR_EraseRootFromParent_Done,
     /*  764503 */   // Label 11941: @764503
     /*  764503 */   GIM_Try, /*On fail goto*//*Label 11942*/ GIMT_Encode4(764581), // Rule ID 14355 //
     /*  764508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  764519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  764522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  764525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  764528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764554 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764579 */     GIR_RootConstrainSelectedInstOperands,
     /*  764580 */     // GIR_Coverage, 14355,
     /*  764580 */     GIR_EraseRootFromParent_Done,
     /*  764581 */   // Label 11942: @764581
     /*  764581 */   GIM_Try, /*On fail goto*//*Label 11943*/ GIMT_Encode4(764659), // Rule ID 14358 //
     /*  764586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  764589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  764597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  764600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  764603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  764606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764632 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  764632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  764651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764657 */     GIR_RootConstrainSelectedInstOperands,
     /*  764658 */     // GIR_Coverage, 14358,
     /*  764658 */     GIR_EraseRootFromParent_Done,
     /*  764659 */   // Label 11943: @764659
     /*  764659 */   GIM_Try, /*On fail goto*//*Label 11944*/ GIMT_Encode4(764737), // Rule ID 14359 //
     /*  764664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  764667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  764675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  764678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  764681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  764684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764710 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  764710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  764729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764735 */     GIR_RootConstrainSelectedInstOperands,
     /*  764736 */     // GIR_Coverage, 14359,
     /*  764736 */     GIR_EraseRootFromParent_Done,
     /*  764737 */   // Label 11944: @764737
     /*  764737 */   GIM_Try, /*On fail goto*//*Label 11945*/ GIMT_Encode4(764815), // Rule ID 14362 //
     /*  764742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  764753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  764756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  764759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  764762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764788 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  764791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764813 */     GIR_RootConstrainSelectedInstOperands,
     /*  764814 */     // GIR_Coverage, 14362,
     /*  764814 */     GIR_EraseRootFromParent_Done,
     /*  764815 */   // Label 11945: @764815
     /*  764815 */   GIM_Try, /*On fail goto*//*Label 11946*/ GIMT_Encode4(764893), // Rule ID 14363 //
     /*  764820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  764831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  764834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  764837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  764840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764866 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  764869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764891 */     GIR_RootConstrainSelectedInstOperands,
     /*  764892 */     // GIR_Coverage, 14363,
     /*  764892 */     GIR_EraseRootFromParent_Done,
     /*  764893 */   // Label 11946: @764893
     /*  764893 */   GIM_Try, /*On fail goto*//*Label 11947*/ GIMT_Encode4(764971), // Rule ID 14366 //
     /*  764898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  764909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  764912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  764915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  764918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764944 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  764947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764966 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764969 */     GIR_RootConstrainSelectedInstOperands,
     /*  764970 */     // GIR_Coverage, 14366,
     /*  764970 */     GIR_EraseRootFromParent_Done,
     /*  764971 */   // Label 11947: @764971
     /*  764971 */   GIM_Try, /*On fail goto*//*Label 11948*/ GIMT_Encode4(765049), // Rule ID 14367 //
     /*  764976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  764987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  764990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  764993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  764996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765022 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765047 */     GIR_RootConstrainSelectedInstOperands,
     /*  765048 */     // GIR_Coverage, 14367,
     /*  765048 */     GIR_EraseRootFromParent_Done,
     /*  765049 */   // Label 11948: @765049
     /*  765049 */   GIM_Try, /*On fail goto*//*Label 11949*/ GIMT_Encode4(765127), // Rule ID 14370 //
     /*  765054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  765065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  765068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  765071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  765074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765100 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765125 */     GIR_RootConstrainSelectedInstOperands,
     /*  765126 */     // GIR_Coverage, 14370,
     /*  765126 */     GIR_EraseRootFromParent_Done,
     /*  765127 */   // Label 11949: @765127
     /*  765127 */   GIM_Try, /*On fail goto*//*Label 11950*/ GIMT_Encode4(765205), // Rule ID 14371 //
     /*  765132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  765143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  765146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  765149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  765152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765178 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765203 */     GIR_RootConstrainSelectedInstOperands,
     /*  765204 */     // GIR_Coverage, 14371,
     /*  765204 */     GIR_EraseRootFromParent_Done,
     /*  765205 */   // Label 11950: @765205
     /*  765205 */   GIM_Try, /*On fail goto*//*Label 11951*/ GIMT_Encode4(765283), // Rule ID 14374 //
     /*  765210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  765221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  765224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  765227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  765230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765256 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765281 */     GIR_RootConstrainSelectedInstOperands,
     /*  765282 */     // GIR_Coverage, 14374,
     /*  765282 */     GIR_EraseRootFromParent_Done,
     /*  765283 */   // Label 11951: @765283
     /*  765283 */   GIM_Try, /*On fail goto*//*Label 11952*/ GIMT_Encode4(765361), // Rule ID 14375 //
     /*  765288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  765299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  765302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  765305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  765308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765359 */     GIR_RootConstrainSelectedInstOperands,
     /*  765360 */     // GIR_Coverage, 14375,
     /*  765360 */     GIR_EraseRootFromParent_Done,
     /*  765361 */   // Label 11952: @765361
     /*  765361 */   GIM_Try, /*On fail goto*//*Label 11953*/ GIMT_Encode4(765439), // Rule ID 14378 //
     /*  765366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  765377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  765380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  765383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  765386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765412 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765437 */     GIR_RootConstrainSelectedInstOperands,
     /*  765438 */     // GIR_Coverage, 14378,
     /*  765438 */     GIR_EraseRootFromParent_Done,
     /*  765439 */   // Label 11953: @765439
     /*  765439 */   GIM_Try, /*On fail goto*//*Label 11954*/ GIMT_Encode4(765517), // Rule ID 14379 //
     /*  765444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  765455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  765458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  765461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  765464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765490 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765515 */     GIR_RootConstrainSelectedInstOperands,
     /*  765516 */     // GIR_Coverage, 14379,
     /*  765516 */     GIR_EraseRootFromParent_Done,
     /*  765517 */   // Label 11954: @765517
     /*  765517 */   GIM_Try, /*On fail goto*//*Label 11955*/ GIMT_Encode4(765595), // Rule ID 14382 //
     /*  765522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  765533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  765536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  765539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  765542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765568 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765593 */     GIR_RootConstrainSelectedInstOperands,
     /*  765594 */     // GIR_Coverage, 14382,
     /*  765594 */     GIR_EraseRootFromParent_Done,
     /*  765595 */   // Label 11955: @765595
     /*  765595 */   GIM_Try, /*On fail goto*//*Label 11956*/ GIMT_Encode4(765673), // Rule ID 14383 //
     /*  765600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  765611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  765614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  765617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  765620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765671 */     GIR_RootConstrainSelectedInstOperands,
     /*  765672 */     // GIR_Coverage, 14383,
     /*  765672 */     GIR_EraseRootFromParent_Done,
     /*  765673 */   // Label 11956: @765673
     /*  765673 */   GIM_Try, /*On fail goto*//*Label 11957*/ GIMT_Encode4(765751), // Rule ID 14386 //
     /*  765678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  765689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  765692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  765695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  765698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  765724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765749 */     GIR_RootConstrainSelectedInstOperands,
     /*  765750 */     // GIR_Coverage, 14386,
     /*  765750 */     GIR_EraseRootFromParent_Done,
     /*  765751 */   // Label 11957: @765751
     /*  765751 */   GIM_Try, /*On fail goto*//*Label 11958*/ GIMT_Encode4(765829), // Rule ID 14387 //
     /*  765756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  765767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  765770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  765773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  765776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  765802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765827 */     GIR_RootConstrainSelectedInstOperands,
     /*  765828 */     // GIR_Coverage, 14387,
     /*  765828 */     GIR_EraseRootFromParent_Done,
     /*  765829 */   // Label 11958: @765829
     /*  765829 */   GIM_Try, /*On fail goto*//*Label 11959*/ GIMT_Encode4(765907), // Rule ID 14390 //
     /*  765834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  765845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  765848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  765851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  765854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765880 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  765880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765902 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765905 */     GIR_RootConstrainSelectedInstOperands,
     /*  765906 */     // GIR_Coverage, 14390,
     /*  765906 */     GIR_EraseRootFromParent_Done,
     /*  765907 */   // Label 11959: @765907
     /*  765907 */   GIM_Try, /*On fail goto*//*Label 11960*/ GIMT_Encode4(765985), // Rule ID 14391 //
     /*  765912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  765923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  765926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  765929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  765932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765958 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  765958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765983 */     GIR_RootConstrainSelectedInstOperands,
     /*  765984 */     // GIR_Coverage, 14391,
     /*  765984 */     GIR_EraseRootFromParent_Done,
     /*  765985 */   // Label 11960: @765985
     /*  765985 */   GIM_Try, /*On fail goto*//*Label 11961*/ GIMT_Encode4(766063), // Rule ID 14394 //
     /*  765990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  766001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  766004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  766007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  766010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766036 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766061 */     GIR_RootConstrainSelectedInstOperands,
     /*  766062 */     // GIR_Coverage, 14394,
     /*  766062 */     GIR_EraseRootFromParent_Done,
     /*  766063 */   // Label 11961: @766063
     /*  766063 */   GIM_Try, /*On fail goto*//*Label 11962*/ GIMT_Encode4(766141), // Rule ID 14395 //
     /*  766068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  766079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  766082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  766085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  766088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766114 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766139 */     GIR_RootConstrainSelectedInstOperands,
     /*  766140 */     // GIR_Coverage, 14395,
     /*  766140 */     GIR_EraseRootFromParent_Done,
     /*  766141 */   // Label 11962: @766141
     /*  766141 */   GIM_Try, /*On fail goto*//*Label 11963*/ GIMT_Encode4(766219), // Rule ID 14398 //
     /*  766146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  766157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  766160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  766163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  766166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  766195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766217 */     GIR_RootConstrainSelectedInstOperands,
     /*  766218 */     // GIR_Coverage, 14398,
     /*  766218 */     GIR_EraseRootFromParent_Done,
     /*  766219 */   // Label 11963: @766219
     /*  766219 */   GIM_Try, /*On fail goto*//*Label 11964*/ GIMT_Encode4(766297), // Rule ID 14399 //
     /*  766224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  766235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  766238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  766241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  766244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766270 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  766273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766295 */     GIR_RootConstrainSelectedInstOperands,
     /*  766296 */     // GIR_Coverage, 14399,
     /*  766296 */     GIR_EraseRootFromParent_Done,
     /*  766297 */   // Label 11964: @766297
     /*  766297 */   GIM_Try, /*On fail goto*//*Label 11965*/ GIMT_Encode4(766375), // Rule ID 14402 //
     /*  766302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  766313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  766316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  766319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  766322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766348 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  766351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766373 */     GIR_RootConstrainSelectedInstOperands,
     /*  766374 */     // GIR_Coverage, 14402,
     /*  766374 */     GIR_EraseRootFromParent_Done,
     /*  766375 */   // Label 11965: @766375
     /*  766375 */   GIM_Try, /*On fail goto*//*Label 11966*/ GIMT_Encode4(766453), // Rule ID 14403 //
     /*  766380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  766391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  766394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  766397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  766400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766426 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  766429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766448 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766451 */     GIR_RootConstrainSelectedInstOperands,
     /*  766452 */     // GIR_Coverage, 14403,
     /*  766452 */     GIR_EraseRootFromParent_Done,
     /*  766453 */   // Label 11966: @766453
     /*  766453 */   GIM_Try, /*On fail goto*//*Label 11967*/ GIMT_Encode4(766531), // Rule ID 14406 //
     /*  766458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  766469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  766472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  766475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  766478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766504 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766529 */     GIR_RootConstrainSelectedInstOperands,
     /*  766530 */     // GIR_Coverage, 14406,
     /*  766530 */     GIR_EraseRootFromParent_Done,
     /*  766531 */   // Label 11967: @766531
     /*  766531 */   GIM_Try, /*On fail goto*//*Label 11968*/ GIMT_Encode4(766609), // Rule ID 14407 //
     /*  766536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  766547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  766550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  766553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  766556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766582 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766607 */     GIR_RootConstrainSelectedInstOperands,
     /*  766608 */     // GIR_Coverage, 14407,
     /*  766608 */     GIR_EraseRootFromParent_Done,
     /*  766609 */   // Label 11968: @766609
     /*  766609 */   GIM_Try, /*On fail goto*//*Label 11969*/ GIMT_Encode4(766687), // Rule ID 14410 //
     /*  766614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  766625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  766628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  766631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766660 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  766660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  766663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766685 */     GIR_RootConstrainSelectedInstOperands,
     /*  766686 */     // GIR_Coverage, 14410,
     /*  766686 */     GIR_EraseRootFromParent_Done,
     /*  766687 */   // Label 11969: @766687
     /*  766687 */   GIM_Try, /*On fail goto*//*Label 11970*/ GIMT_Encode4(766765), // Rule ID 14411 //
     /*  766692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  766703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  766706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  766709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766738 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  766738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  766741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766763 */     GIR_RootConstrainSelectedInstOperands,
     /*  766764 */     // GIR_Coverage, 14411,
     /*  766764 */     GIR_EraseRootFromParent_Done,
     /*  766765 */   // Label 11970: @766765
     /*  766765 */   GIM_Try, /*On fail goto*//*Label 11971*/ GIMT_Encode4(766843), // Rule ID 14414 //
     /*  766770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  766781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  766784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  766787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766816 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  766816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  766819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766841 */     GIR_RootConstrainSelectedInstOperands,
     /*  766842 */     // GIR_Coverage, 14414,
     /*  766842 */     GIR_EraseRootFromParent_Done,
     /*  766843 */   // Label 11971: @766843
     /*  766843 */   GIM_Try, /*On fail goto*//*Label 11972*/ GIMT_Encode4(766921), // Rule ID 14415 //
     /*  766848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  766859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  766862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  766865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766894 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  766894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  766897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766919 */     GIR_RootConstrainSelectedInstOperands,
     /*  766920 */     // GIR_Coverage, 14415,
     /*  766920 */     GIR_EraseRootFromParent_Done,
     /*  766921 */   // Label 11972: @766921
     /*  766921 */   GIM_Try, /*On fail goto*//*Label 11973*/ GIMT_Encode4(766999), // Rule ID 14418 //
     /*  766926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  766937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  766940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  766943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766972 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  766972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  766975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766997 */     GIR_RootConstrainSelectedInstOperands,
     /*  766998 */     // GIR_Coverage, 14418,
     /*  766998 */     GIR_EraseRootFromParent_Done,
     /*  766999 */   // Label 11973: @766999
     /*  766999 */   GIM_Try, /*On fail goto*//*Label 11974*/ GIMT_Encode4(767077), // Rule ID 14419 //
     /*  767004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  767015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  767018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  767021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767050 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767075 */     GIR_RootConstrainSelectedInstOperands,
     /*  767076 */     // GIR_Coverage, 14419,
     /*  767076 */     GIR_EraseRootFromParent_Done,
     /*  767077 */   // Label 11974: @767077
     /*  767077 */   GIM_Try, /*On fail goto*//*Label 11975*/ GIMT_Encode4(767155), // Rule ID 14422 //
     /*  767082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  767093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  767096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  767099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767128 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  767131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767153 */     GIR_RootConstrainSelectedInstOperands,
     /*  767154 */     // GIR_Coverage, 14422,
     /*  767154 */     GIR_EraseRootFromParent_Done,
     /*  767155 */   // Label 11975: @767155
     /*  767155 */   GIM_Try, /*On fail goto*//*Label 11976*/ GIMT_Encode4(767233), // Rule ID 14423 //
     /*  767160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  767171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  767174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  767177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767206 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  767209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767231 */     GIR_RootConstrainSelectedInstOperands,
     /*  767232 */     // GIR_Coverage, 14423,
     /*  767232 */     GIR_EraseRootFromParent_Done,
     /*  767233 */   // Label 11976: @767233
     /*  767233 */   GIM_Try, /*On fail goto*//*Label 11977*/ GIMT_Encode4(767311), // Rule ID 14426 //
     /*  767238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  767249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  767252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  767255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767284 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767309 */     GIR_RootConstrainSelectedInstOperands,
     /*  767310 */     // GIR_Coverage, 14426,
     /*  767310 */     GIR_EraseRootFromParent_Done,
     /*  767311 */   // Label 11977: @767311
     /*  767311 */   GIM_Try, /*On fail goto*//*Label 11978*/ GIMT_Encode4(767389), // Rule ID 14427 //
     /*  767316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  767327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  767330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  767333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767362 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767387 */     GIR_RootConstrainSelectedInstOperands,
     /*  767388 */     // GIR_Coverage, 14427,
     /*  767388 */     GIR_EraseRootFromParent_Done,
     /*  767389 */   // Label 11978: @767389
     /*  767389 */   GIM_Try, /*On fail goto*//*Label 11979*/ GIMT_Encode4(767467), // Rule ID 14430 //
     /*  767394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  767405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  767408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  767411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767440 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  767440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767465 */     GIR_RootConstrainSelectedInstOperands,
     /*  767466 */     // GIR_Coverage, 14430,
     /*  767466 */     GIR_EraseRootFromParent_Done,
     /*  767467 */   // Label 11979: @767467
     /*  767467 */   GIM_Try, /*On fail goto*//*Label 11980*/ GIMT_Encode4(767545), // Rule ID 14431 //
     /*  767472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  767483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  767486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  767489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767518 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  767518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767543 */     GIR_RootConstrainSelectedInstOperands,
     /*  767544 */     // GIR_Coverage, 14431,
     /*  767544 */     GIR_EraseRootFromParent_Done,
     /*  767545 */   // Label 11980: @767545
     /*  767545 */   GIM_Try, /*On fail goto*//*Label 11981*/ GIMT_Encode4(767623), // Rule ID 14434 //
     /*  767550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  767561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  767564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  767567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767621 */     GIR_RootConstrainSelectedInstOperands,
     /*  767622 */     // GIR_Coverage, 14434,
     /*  767622 */     GIR_EraseRootFromParent_Done,
     /*  767623 */   // Label 11981: @767623
     /*  767623 */   GIM_Try, /*On fail goto*//*Label 11982*/ GIMT_Encode4(767701), // Rule ID 14435 //
     /*  767628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  767639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  767642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  767645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767674 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767699 */     GIR_RootConstrainSelectedInstOperands,
     /*  767700 */     // GIR_Coverage, 14435,
     /*  767700 */     GIR_EraseRootFromParent_Done,
     /*  767701 */   // Label 11982: @767701
     /*  767701 */   GIM_Try, /*On fail goto*//*Label 11983*/ GIMT_Encode4(767779), // Rule ID 14438 //
     /*  767706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  767717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  767720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  767723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767777 */     GIR_RootConstrainSelectedInstOperands,
     /*  767778 */     // GIR_Coverage, 14438,
     /*  767778 */     GIR_EraseRootFromParent_Done,
     /*  767779 */   // Label 11983: @767779
     /*  767779 */   GIM_Try, /*On fail goto*//*Label 11984*/ GIMT_Encode4(767857), // Rule ID 14439 //
     /*  767784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  767795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  767798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  767801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767830 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767855 */     GIR_RootConstrainSelectedInstOperands,
     /*  767856 */     // GIR_Coverage, 14439,
     /*  767856 */     GIR_EraseRootFromParent_Done,
     /*  767857 */   // Label 11984: @767857
     /*  767857 */   GIM_Try, /*On fail goto*//*Label 11985*/ GIMT_Encode4(767935), // Rule ID 14442 //
     /*  767862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  767873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  767876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  767879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767908 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  767908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767933 */     GIR_RootConstrainSelectedInstOperands,
     /*  767934 */     // GIR_Coverage, 14442,
     /*  767934 */     GIR_EraseRootFromParent_Done,
     /*  767935 */   // Label 11985: @767935
     /*  767935 */   GIM_Try, /*On fail goto*//*Label 11986*/ GIMT_Encode4(768013), // Rule ID 14443 //
     /*  767940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  767951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  767954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  767957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767986 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  767986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768011 */     GIR_RootConstrainSelectedInstOperands,
     /*  768012 */     // GIR_Coverage, 14443,
     /*  768012 */     GIR_EraseRootFromParent_Done,
     /*  768013 */   // Label 11986: @768013
     /*  768013 */   GIM_Try, /*On fail goto*//*Label 11987*/ GIMT_Encode4(768091), // Rule ID 14446 //
     /*  768018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  768021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  768029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  768032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  768035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768064 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  768064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768089 */     GIR_RootConstrainSelectedInstOperands,
     /*  768090 */     // GIR_Coverage, 14446,
     /*  768090 */     GIR_EraseRootFromParent_Done,
     /*  768091 */   // Label 11987: @768091
     /*  768091 */   GIM_Try, /*On fail goto*//*Label 11988*/ GIMT_Encode4(768169), // Rule ID 14447 //
     /*  768096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  768099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  768107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  768110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  768113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768142 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  768142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768167 */     GIR_RootConstrainSelectedInstOperands,
     /*  768168 */     // GIR_Coverage, 14447,
     /*  768168 */     GIR_EraseRootFromParent_Done,
     /*  768169 */   // Label 11988: @768169
     /*  768169 */   GIM_Try, /*On fail goto*//*Label 11989*/ GIMT_Encode4(768247), // Rule ID 14450 //
     /*  768174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  768185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  768188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  768191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768220 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768245 */     GIR_RootConstrainSelectedInstOperands,
     /*  768246 */     // GIR_Coverage, 14450,
     /*  768246 */     GIR_EraseRootFromParent_Done,
     /*  768247 */   // Label 11989: @768247
     /*  768247 */   GIM_Try, /*On fail goto*//*Label 11990*/ GIMT_Encode4(768325), // Rule ID 14451 //
     /*  768252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  768263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  768266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  768269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768298 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768323 */     GIR_RootConstrainSelectedInstOperands,
     /*  768324 */     // GIR_Coverage, 14451,
     /*  768324 */     GIR_EraseRootFromParent_Done,
     /*  768325 */   // Label 11990: @768325
     /*  768325 */   GIM_Try, /*On fail goto*//*Label 11991*/ GIMT_Encode4(768403), // Rule ID 14454 //
     /*  768330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  768341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  768344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  768347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768376 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768401 */     GIR_RootConstrainSelectedInstOperands,
     /*  768402 */     // GIR_Coverage, 14454,
     /*  768402 */     GIR_EraseRootFromParent_Done,
     /*  768403 */   // Label 11991: @768403
     /*  768403 */   GIM_Try, /*On fail goto*//*Label 11992*/ GIMT_Encode4(768481), // Rule ID 14455 //
     /*  768408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  768419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  768422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  768425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768454 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768479 */     GIR_RootConstrainSelectedInstOperands,
     /*  768480 */     // GIR_Coverage, 14455,
     /*  768480 */     GIR_EraseRootFromParent_Done,
     /*  768481 */   // Label 11992: @768481
     /*  768481 */   GIM_Try, /*On fail goto*//*Label 11993*/ GIMT_Encode4(768559), // Rule ID 14458 //
     /*  768486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  768497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  768500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  768503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768532 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  768535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768557 */     GIR_RootConstrainSelectedInstOperands,
     /*  768558 */     // GIR_Coverage, 14458,
     /*  768558 */     GIR_EraseRootFromParent_Done,
     /*  768559 */   // Label 11993: @768559
     /*  768559 */   GIM_Try, /*On fail goto*//*Label 11994*/ GIMT_Encode4(768637), // Rule ID 14459 //
     /*  768564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  768575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  768578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  768581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768610 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  768613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768635 */     GIR_RootConstrainSelectedInstOperands,
     /*  768636 */     // GIR_Coverage, 14459,
     /*  768636 */     GIR_EraseRootFromParent_Done,
     /*  768637 */   // Label 11994: @768637
     /*  768637 */   GIM_Try, /*On fail goto*//*Label 11995*/ GIMT_Encode4(768715), // Rule ID 14462 //
     /*  768642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  768653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  768656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  768659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768688 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  768688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768713 */     GIR_RootConstrainSelectedInstOperands,
     /*  768714 */     // GIR_Coverage, 14462,
     /*  768714 */     GIR_EraseRootFromParent_Done,
     /*  768715 */   // Label 11995: @768715
     /*  768715 */   GIM_Try, /*On fail goto*//*Label 11996*/ GIMT_Encode4(768793), // Rule ID 14463 //
     /*  768720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  768731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  768734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  768737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768766 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  768766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768791 */     GIR_RootConstrainSelectedInstOperands,
     /*  768792 */     // GIR_Coverage, 14463,
     /*  768792 */     GIR_EraseRootFromParent_Done,
     /*  768793 */   // Label 11996: @768793
     /*  768793 */   GIM_Try, /*On fail goto*//*Label 11997*/ GIMT_Encode4(768871), // Rule ID 14466 //
     /*  768798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  768809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  768812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  768815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768844 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  768844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768869 */     GIR_RootConstrainSelectedInstOperands,
     /*  768870 */     // GIR_Coverage, 14466,
     /*  768870 */     GIR_EraseRootFromParent_Done,
     /*  768871 */   // Label 11997: @768871
     /*  768871 */   GIM_Try, /*On fail goto*//*Label 11998*/ GIMT_Encode4(768949), // Rule ID 14467 //
     /*  768876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  768887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  768890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  768893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768922 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  768922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768947 */     GIR_RootConstrainSelectedInstOperands,
     /*  768948 */     // GIR_Coverage, 14467,
     /*  768948 */     GIR_EraseRootFromParent_Done,
     /*  768949 */   // Label 11998: @768949
     /*  768949 */   GIM_Try, /*On fail goto*//*Label 11999*/ GIMT_Encode4(769027), // Rule ID 14470 //
     /*  768954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  768965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  768968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  768971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769000 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769025 */     GIR_RootConstrainSelectedInstOperands,
     /*  769026 */     // GIR_Coverage, 14470,
     /*  769026 */     GIR_EraseRootFromParent_Done,
     /*  769027 */   // Label 11999: @769027
     /*  769027 */   GIM_Try, /*On fail goto*//*Label 12000*/ GIMT_Encode4(769105), // Rule ID 14471 //
     /*  769032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  769043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  769046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  769049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769078 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769103 */     GIR_RootConstrainSelectedInstOperands,
     /*  769104 */     // GIR_Coverage, 14471,
     /*  769104 */     GIR_EraseRootFromParent_Done,
     /*  769105 */   // Label 12000: @769105
     /*  769105 */   GIM_Try, /*On fail goto*//*Label 12001*/ GIMT_Encode4(769183), // Rule ID 14474 //
     /*  769110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  769121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  769124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  769127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769181 */     GIR_RootConstrainSelectedInstOperands,
     /*  769182 */     // GIR_Coverage, 14474,
     /*  769182 */     GIR_EraseRootFromParent_Done,
     /*  769183 */   // Label 12001: @769183
     /*  769183 */   GIM_Try, /*On fail goto*//*Label 12002*/ GIMT_Encode4(769261), // Rule ID 14475 //
     /*  769188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  769199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  769202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  769205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769259 */     GIR_RootConstrainSelectedInstOperands,
     /*  769260 */     // GIR_Coverage, 14475,
     /*  769260 */     GIR_EraseRootFromParent_Done,
     /*  769261 */   // Label 12002: @769261
     /*  769261 */   GIM_Try, /*On fail goto*//*Label 12003*/ GIMT_Encode4(769339), // Rule ID 14478 //
     /*  769266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  769277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  769280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  769283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769312 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769337 */     GIR_RootConstrainSelectedInstOperands,
     /*  769338 */     // GIR_Coverage, 14478,
     /*  769338 */     GIR_EraseRootFromParent_Done,
     /*  769339 */   // Label 12003: @769339
     /*  769339 */   GIM_Try, /*On fail goto*//*Label 12004*/ GIMT_Encode4(769417), // Rule ID 14479 //
     /*  769344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  769355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  769358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  769361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769390 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769415 */     GIR_RootConstrainSelectedInstOperands,
     /*  769416 */     // GIR_Coverage, 14479,
     /*  769416 */     GIR_EraseRootFromParent_Done,
     /*  769417 */   // Label 12004: @769417
     /*  769417 */   GIM_Try, /*On fail goto*//*Label 12005*/ GIMT_Encode4(769495), // Rule ID 14482 //
     /*  769422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  769433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  769436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  769439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769468 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769493 */     GIR_RootConstrainSelectedInstOperands,
     /*  769494 */     // GIR_Coverage, 14482,
     /*  769494 */     GIR_EraseRootFromParent_Done,
     /*  769495 */   // Label 12005: @769495
     /*  769495 */   GIM_Try, /*On fail goto*//*Label 12006*/ GIMT_Encode4(769573), // Rule ID 14483 //
     /*  769500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  769511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  769514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  769517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769571 */     GIR_RootConstrainSelectedInstOperands,
     /*  769572 */     // GIR_Coverage, 14483,
     /*  769572 */     GIR_EraseRootFromParent_Done,
     /*  769573 */   // Label 12006: @769573
     /*  769573 */   GIM_Try, /*On fail goto*//*Label 12007*/ GIMT_Encode4(769651), // Rule ID 14486 //
     /*  769578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  769581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  769589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  769592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  769595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769624 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  769624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769649 */     GIR_RootConstrainSelectedInstOperands,
     /*  769650 */     // GIR_Coverage, 14486,
     /*  769650 */     GIR_EraseRootFromParent_Done,
     /*  769651 */   // Label 12007: @769651
     /*  769651 */   GIM_Try, /*On fail goto*//*Label 12008*/ GIMT_Encode4(769729), // Rule ID 14487 //
     /*  769656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  769659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  769667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  769670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  769673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  769702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769727 */     GIR_RootConstrainSelectedInstOperands,
     /*  769728 */     // GIR_Coverage, 14487,
     /*  769728 */     GIR_EraseRootFromParent_Done,
     /*  769729 */   // Label 12008: @769729
     /*  769729 */   GIM_Try, /*On fail goto*//*Label 12009*/ GIMT_Encode4(769807), // Rule ID 14490 //
     /*  769734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  769737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  769745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  769748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  769751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769780 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  769780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769805 */     GIR_RootConstrainSelectedInstOperands,
     /*  769806 */     // GIR_Coverage, 14490,
     /*  769806 */     GIR_EraseRootFromParent_Done,
     /*  769807 */   // Label 12009: @769807
     /*  769807 */   GIM_Try, /*On fail goto*//*Label 12010*/ GIMT_Encode4(769885), // Rule ID 14491 //
     /*  769812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  769815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  769823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  769826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  769829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769858 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  769858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769883 */     GIR_RootConstrainSelectedInstOperands,
     /*  769884 */     // GIR_Coverage, 14491,
     /*  769884 */     GIR_EraseRootFromParent_Done,
     /*  769885 */   // Label 12010: @769885
     /*  769885 */   GIM_Try, /*On fail goto*//*Label 12011*/ GIMT_Encode4(769963), // Rule ID 14494 //
     /*  769890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  769893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  769901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  769904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  769907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769936 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  769936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769961 */     GIR_RootConstrainSelectedInstOperands,
     /*  769962 */     // GIR_Coverage, 14494,
     /*  769962 */     GIR_EraseRootFromParent_Done,
     /*  769963 */   // Label 12011: @769963
     /*  769963 */   GIM_Try, /*On fail goto*//*Label 12012*/ GIMT_Encode4(770041), // Rule ID 14495 //
     /*  769968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  769971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  769979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  769982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  769985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770014 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  770017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770039 */     GIR_RootConstrainSelectedInstOperands,
     /*  770040 */     // GIR_Coverage, 14495,
     /*  770040 */     GIR_EraseRootFromParent_Done,
     /*  770041 */   // Label 12012: @770041
     /*  770041 */   GIM_Try, /*On fail goto*//*Label 12013*/ GIMT_Encode4(770119), // Rule ID 14586 //
     /*  770046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  770057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  770060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  770063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  770066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770092 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  770095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770117 */     GIR_RootConstrainSelectedInstOperands,
     /*  770118 */     // GIR_Coverage, 14586,
     /*  770118 */     GIR_EraseRootFromParent_Done,
     /*  770119 */   // Label 12013: @770119
     /*  770119 */   GIM_Try, /*On fail goto*//*Label 12014*/ GIMT_Encode4(770197), // Rule ID 14587 //
     /*  770124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  770135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  770138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  770141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  770144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770170 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  770173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770195 */     GIR_RootConstrainSelectedInstOperands,
     /*  770196 */     // GIR_Coverage, 14587,
     /*  770196 */     GIR_EraseRootFromParent_Done,
     /*  770197 */   // Label 12014: @770197
     /*  770197 */   GIM_Try, /*On fail goto*//*Label 12015*/ GIMT_Encode4(770275), // Rule ID 14590 //
     /*  770202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  770213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  770216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  770219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  770222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770248 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770273 */     GIR_RootConstrainSelectedInstOperands,
     /*  770274 */     // GIR_Coverage, 14590,
     /*  770274 */     GIR_EraseRootFromParent_Done,
     /*  770275 */   // Label 12015: @770275
     /*  770275 */   GIM_Try, /*On fail goto*//*Label 12016*/ GIMT_Encode4(770353), // Rule ID 14591 //
     /*  770280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  770291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  770294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  770297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  770300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770326 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770351 */     GIR_RootConstrainSelectedInstOperands,
     /*  770352 */     // GIR_Coverage, 14591,
     /*  770352 */     GIR_EraseRootFromParent_Done,
     /*  770353 */   // Label 12016: @770353
     /*  770353 */   GIM_Try, /*On fail goto*//*Label 12017*/ GIMT_Encode4(770431), // Rule ID 14594 //
     /*  770358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  770369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  770372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  770375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  770378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770404 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770429 */     GIR_RootConstrainSelectedInstOperands,
     /*  770430 */     // GIR_Coverage, 14594,
     /*  770430 */     GIR_EraseRootFromParent_Done,
     /*  770431 */   // Label 12017: @770431
     /*  770431 */   GIM_Try, /*On fail goto*//*Label 12018*/ GIMT_Encode4(770509), // Rule ID 14595 //
     /*  770436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  770447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  770450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  770453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  770456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770482 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770507 */     GIR_RootConstrainSelectedInstOperands,
     /*  770508 */     // GIR_Coverage, 14595,
     /*  770508 */     GIR_EraseRootFromParent_Done,
     /*  770509 */   // Label 12018: @770509
     /*  770509 */   GIM_Try, /*On fail goto*//*Label 12019*/ GIMT_Encode4(770587), // Rule ID 14598 //
     /*  770514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  770525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  770528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  770531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  770534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770560 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  770560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770585 */     GIR_RootConstrainSelectedInstOperands,
     /*  770586 */     // GIR_Coverage, 14598,
     /*  770586 */     GIR_EraseRootFromParent_Done,
     /*  770587 */   // Label 12019: @770587
     /*  770587 */   GIM_Try, /*On fail goto*//*Label 12020*/ GIMT_Encode4(770665), // Rule ID 14599 //
     /*  770592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  770603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  770606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  770609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  770612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770638 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  770638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770663 */     GIR_RootConstrainSelectedInstOperands,
     /*  770664 */     // GIR_Coverage, 14599,
     /*  770664 */     GIR_EraseRootFromParent_Done,
     /*  770665 */   // Label 12020: @770665
     /*  770665 */   GIM_Try, /*On fail goto*//*Label 12021*/ GIMT_Encode4(770743), // Rule ID 14602 //
     /*  770670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  770681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  770684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  770687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  770690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770716 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  770716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770741 */     GIR_RootConstrainSelectedInstOperands,
     /*  770742 */     // GIR_Coverage, 14602,
     /*  770742 */     GIR_EraseRootFromParent_Done,
     /*  770743 */   // Label 12021: @770743
     /*  770743 */   GIM_Try, /*On fail goto*//*Label 12022*/ GIMT_Encode4(770821), // Rule ID 14603 //
     /*  770748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  770759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  770762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  770765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  770768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770794 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  770794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770819 */     GIR_RootConstrainSelectedInstOperands,
     /*  770820 */     // GIR_Coverage, 14603,
     /*  770820 */     GIR_EraseRootFromParent_Done,
     /*  770821 */   // Label 12022: @770821
     /*  770821 */   GIM_Try, /*On fail goto*//*Label 12023*/ GIMT_Encode4(770899), // Rule ID 14606 //
     /*  770826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  770837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  770840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  770843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  770846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770872 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  770872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  770891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770897 */     GIR_RootConstrainSelectedInstOperands,
     /*  770898 */     // GIR_Coverage, 14606,
     /*  770898 */     GIR_EraseRootFromParent_Done,
     /*  770899 */   // Label 12023: @770899
     /*  770899 */   GIM_Try, /*On fail goto*//*Label 12024*/ GIMT_Encode4(770977), // Rule ID 14607 //
     /*  770904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  770915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  770918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  770921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  770924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770950 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  770950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  770969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770975 */     GIR_RootConstrainSelectedInstOperands,
     /*  770976 */     // GIR_Coverage, 14607,
     /*  770976 */     GIR_EraseRootFromParent_Done,
     /*  770977 */   // Label 12024: @770977
     /*  770977 */   GIM_Try, /*On fail goto*//*Label 12025*/ GIMT_Encode4(771055), // Rule ID 14610 //
     /*  770982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  770993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  770996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  770999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  771002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771028 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771053 */     GIR_RootConstrainSelectedInstOperands,
     /*  771054 */     // GIR_Coverage, 14610,
     /*  771054 */     GIR_EraseRootFromParent_Done,
     /*  771055 */   // Label 12025: @771055
     /*  771055 */   GIM_Try, /*On fail goto*//*Label 12026*/ GIMT_Encode4(771133), // Rule ID 14611 //
     /*  771060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  771071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  771074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  771077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  771080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771106 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  771106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771131 */     GIR_RootConstrainSelectedInstOperands,
     /*  771132 */     // GIR_Coverage, 14611,
     /*  771132 */     GIR_EraseRootFromParent_Done,
     /*  771133 */   // Label 12026: @771133
     /*  771133 */   GIM_Try, /*On fail goto*//*Label 12027*/ GIMT_Encode4(771211), // Rule ID 14614 //
     /*  771138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  771149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  771152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  771155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  771158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771209 */     GIR_RootConstrainSelectedInstOperands,
     /*  771210 */     // GIR_Coverage, 14614,
     /*  771210 */     GIR_EraseRootFromParent_Done,
     /*  771211 */   // Label 12027: @771211
     /*  771211 */   GIM_Try, /*On fail goto*//*Label 12028*/ GIMT_Encode4(771289), // Rule ID 14615 //
     /*  771216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  771227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  771230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  771233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  771236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771262 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771287 */     GIR_RootConstrainSelectedInstOperands,
     /*  771288 */     // GIR_Coverage, 14615,
     /*  771288 */     GIR_EraseRootFromParent_Done,
     /*  771289 */   // Label 12028: @771289
     /*  771289 */   GIM_Try, /*On fail goto*//*Label 12029*/ GIMT_Encode4(771367), // Rule ID 14618 //
     /*  771294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  771305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  771308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  771311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  771314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771365 */     GIR_RootConstrainSelectedInstOperands,
     /*  771366 */     // GIR_Coverage, 14618,
     /*  771366 */     GIR_EraseRootFromParent_Done,
     /*  771367 */   // Label 12029: @771367
     /*  771367 */   GIM_Try, /*On fail goto*//*Label 12030*/ GIMT_Encode4(771445), // Rule ID 14619 //
     /*  771372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  771383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  771386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  771389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  771392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771443 */     GIR_RootConstrainSelectedInstOperands,
     /*  771444 */     // GIR_Coverage, 14619,
     /*  771444 */     GIR_EraseRootFromParent_Done,
     /*  771445 */   // Label 12030: @771445
     /*  771445 */   GIM_Try, /*On fail goto*//*Label 12031*/ GIMT_Encode4(771523), // Rule ID 14622 //
     /*  771450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  771453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  771461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  771464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  771467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  771470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771496 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  771496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771521 */     GIR_RootConstrainSelectedInstOperands,
     /*  771522 */     // GIR_Coverage, 14622,
     /*  771522 */     GIR_EraseRootFromParent_Done,
     /*  771523 */   // Label 12031: @771523
     /*  771523 */   GIM_Try, /*On fail goto*//*Label 12032*/ GIMT_Encode4(771601), // Rule ID 14623 //
     /*  771528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  771531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  771539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  771542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  771545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  771548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  771574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771599 */     GIR_RootConstrainSelectedInstOperands,
     /*  771600 */     // GIR_Coverage, 14623,
     /*  771600 */     GIR_EraseRootFromParent_Done,
     /*  771601 */   // Label 12032: @771601
     /*  771601 */   GIM_Try, /*On fail goto*//*Label 12033*/ GIMT_Encode4(771679), // Rule ID 14626 //
     /*  771606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  771617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  771620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  771623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  771626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771652 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  771655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771677 */     GIR_RootConstrainSelectedInstOperands,
     /*  771678 */     // GIR_Coverage, 14626,
     /*  771678 */     GIR_EraseRootFromParent_Done,
     /*  771679 */   // Label 12033: @771679
     /*  771679 */   GIM_Try, /*On fail goto*//*Label 12034*/ GIMT_Encode4(771757), // Rule ID 14627 //
     /*  771684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  771695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  771698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  771701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  771704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771730 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  771730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  771733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771755 */     GIR_RootConstrainSelectedInstOperands,
     /*  771756 */     // GIR_Coverage, 14627,
     /*  771756 */     GIR_EraseRootFromParent_Done,
     /*  771757 */   // Label 12034: @771757
     /*  771757 */   GIM_Try, /*On fail goto*//*Label 12035*/ GIMT_Encode4(771835), // Rule ID 14630 //
     /*  771762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  771773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  771776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  771779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  771782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771808 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  771811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771833 */     GIR_RootConstrainSelectedInstOperands,
     /*  771834 */     // GIR_Coverage, 14630,
     /*  771834 */     GIR_EraseRootFromParent_Done,
     /*  771835 */   // Label 12035: @771835
     /*  771835 */   GIM_Try, /*On fail goto*//*Label 12036*/ GIMT_Encode4(771913), // Rule ID 14631 //
     /*  771840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  771851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  771854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  771857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  771860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771886 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  771886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  771889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771911 */     GIR_RootConstrainSelectedInstOperands,
     /*  771912 */     // GIR_Coverage, 14631,
     /*  771912 */     GIR_EraseRootFromParent_Done,
     /*  771913 */   // Label 12036: @771913
     /*  771913 */   GIM_Try, /*On fail goto*//*Label 12037*/ GIMT_Encode4(771991), // Rule ID 14634 //
     /*  771918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  771929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  771932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  771935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  771938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771964 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  771967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771986 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771989 */     GIR_RootConstrainSelectedInstOperands,
     /*  771990 */     // GIR_Coverage, 14634,
     /*  771990 */     GIR_EraseRootFromParent_Done,
     /*  771991 */   // Label 12037: @771991
     /*  771991 */   GIM_Try, /*On fail goto*//*Label 12038*/ GIMT_Encode4(772069), // Rule ID 14635 //
     /*  771996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  772007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  772010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  772013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  772016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772042 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772067 */     GIR_RootConstrainSelectedInstOperands,
     /*  772068 */     // GIR_Coverage, 14635,
     /*  772068 */     GIR_EraseRootFromParent_Done,
     /*  772069 */   // Label 12038: @772069
     /*  772069 */   GIM_Try, /*On fail goto*//*Label 12039*/ GIMT_Encode4(772147), // Rule ID 14638 //
     /*  772074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  772085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  772088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  772091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  772094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772120 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772145 */     GIR_RootConstrainSelectedInstOperands,
     /*  772146 */     // GIR_Coverage, 14638,
     /*  772146 */     GIR_EraseRootFromParent_Done,
     /*  772147 */   // Label 12039: @772147
     /*  772147 */   GIM_Try, /*On fail goto*//*Label 12040*/ GIMT_Encode4(772225), // Rule ID 14639 //
     /*  772152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  772163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  772166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  772169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  772172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772223 */     GIR_RootConstrainSelectedInstOperands,
     /*  772224 */     // GIR_Coverage, 14639,
     /*  772224 */     GIR_EraseRootFromParent_Done,
     /*  772225 */   // Label 12040: @772225
     /*  772225 */   GIM_Try, /*On fail goto*//*Label 12041*/ GIMT_Encode4(772303), // Rule ID 14642 //
     /*  772230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  772241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  772244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  772247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  772250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772276 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772301 */     GIR_RootConstrainSelectedInstOperands,
     /*  772302 */     // GIR_Coverage, 14642,
     /*  772302 */     GIR_EraseRootFromParent_Done,
     /*  772303 */   // Label 12041: @772303
     /*  772303 */   GIM_Try, /*On fail goto*//*Label 12042*/ GIMT_Encode4(772381), // Rule ID 14643 //
     /*  772308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  772319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  772322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  772325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  772328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772354 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772379 */     GIR_RootConstrainSelectedInstOperands,
     /*  772380 */     // GIR_Coverage, 14643,
     /*  772380 */     GIR_EraseRootFromParent_Done,
     /*  772381 */   // Label 12042: @772381
     /*  772381 */   GIM_Try, /*On fail goto*//*Label 12043*/ GIMT_Encode4(772459), // Rule ID 14646 //
     /*  772386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  772397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  772400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  772403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  772406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772432 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772457 */     GIR_RootConstrainSelectedInstOperands,
     /*  772458 */     // GIR_Coverage, 14646,
     /*  772458 */     GIR_EraseRootFromParent_Done,
     /*  772459 */   // Label 12043: @772459
     /*  772459 */   GIM_Try, /*On fail goto*//*Label 12044*/ GIMT_Encode4(772537), // Rule ID 14647 //
     /*  772464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  772475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  772478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  772481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  772484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772510 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772535 */     GIR_RootConstrainSelectedInstOperands,
     /*  772536 */     // GIR_Coverage, 14647,
     /*  772536 */     GIR_EraseRootFromParent_Done,
     /*  772537 */   // Label 12044: @772537
     /*  772537 */   GIM_Try, /*On fail goto*//*Label 12045*/ GIMT_Encode4(772615), // Rule ID 14650 //
     /*  772542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  772553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  772556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  772559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  772562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772610 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772613 */     GIR_RootConstrainSelectedInstOperands,
     /*  772614 */     // GIR_Coverage, 14650,
     /*  772614 */     GIR_EraseRootFromParent_Done,
     /*  772615 */   // Label 12045: @772615
     /*  772615 */   GIM_Try, /*On fail goto*//*Label 12046*/ GIMT_Encode4(772693), // Rule ID 14651 //
     /*  772620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  772631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  772634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  772637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  772640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772666 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  772666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772691 */     GIR_RootConstrainSelectedInstOperands,
     /*  772692 */     // GIR_Coverage, 14651,
     /*  772692 */     GIR_EraseRootFromParent_Done,
     /*  772693 */   // Label 12046: @772693
     /*  772693 */   GIM_Try, /*On fail goto*//*Label 12047*/ GIMT_Encode4(772771), // Rule ID 14654 //
     /*  772698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  772709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  772712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  772715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  772718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772744 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772769 */     GIR_RootConstrainSelectedInstOperands,
     /*  772770 */     // GIR_Coverage, 14654,
     /*  772770 */     GIR_EraseRootFromParent_Done,
     /*  772771 */   // Label 12047: @772771
     /*  772771 */   GIM_Try, /*On fail goto*//*Label 12048*/ GIMT_Encode4(772849), // Rule ID 14655 //
     /*  772776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  772787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  772790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  772793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  772796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  772822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772847 */     GIR_RootConstrainSelectedInstOperands,
     /*  772848 */     // GIR_Coverage, 14655,
     /*  772848 */     GIR_EraseRootFromParent_Done,
     /*  772849 */   // Label 12048: @772849
     /*  772849 */   GIM_Try, /*On fail goto*//*Label 12049*/ GIMT_Encode4(772927), // Rule ID 14658 //
     /*  772854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  772865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  772868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  772871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  772874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772900 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772925 */     GIR_RootConstrainSelectedInstOperands,
     /*  772926 */     // GIR_Coverage, 14658,
     /*  772926 */     GIR_EraseRootFromParent_Done,
     /*  772927 */   // Label 12049: @772927
     /*  772927 */   GIM_Try, /*On fail goto*//*Label 12050*/ GIMT_Encode4(773005), // Rule ID 14659 //
     /*  772932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  772943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  772946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  772949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  772952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772978 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  772978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773003 */     GIR_RootConstrainSelectedInstOperands,
     /*  773004 */     // GIR_Coverage, 14659,
     /*  773004 */     GIR_EraseRootFromParent_Done,
     /*  773005 */   // Label 12050: @773005
     /*  773005 */   GIM_Try, /*On fail goto*//*Label 12051*/ GIMT_Encode4(773083), // Rule ID 14662 //
     /*  773010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  773021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  773024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  773027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  773030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773056 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  773059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773081 */     GIR_RootConstrainSelectedInstOperands,
     /*  773082 */     // GIR_Coverage, 14662,
     /*  773082 */     GIR_EraseRootFromParent_Done,
     /*  773083 */   // Label 12051: @773083
     /*  773083 */   GIM_Try, /*On fail goto*//*Label 12052*/ GIMT_Encode4(773161), // Rule ID 14663 //
     /*  773088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  773099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  773102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  773105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  773108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773134 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  773137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773159 */     GIR_RootConstrainSelectedInstOperands,
     /*  773160 */     // GIR_Coverage, 14663,
     /*  773160 */     GIR_EraseRootFromParent_Done,
     /*  773161 */   // Label 12052: @773161
     /*  773161 */   GIM_Try, /*On fail goto*//*Label 12053*/ GIMT_Encode4(773239), // Rule ID 14666 //
     /*  773166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  773177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  773180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  773183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  773186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773212 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  773215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773237 */     GIR_RootConstrainSelectedInstOperands,
     /*  773238 */     // GIR_Coverage, 14666,
     /*  773238 */     GIR_EraseRootFromParent_Done,
     /*  773239 */   // Label 12053: @773239
     /*  773239 */   GIM_Try, /*On fail goto*//*Label 12054*/ GIMT_Encode4(773317), // Rule ID 14667 //
     /*  773244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  773255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  773258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  773261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  773264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773290 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  773293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773315 */     GIR_RootConstrainSelectedInstOperands,
     /*  773316 */     // GIR_Coverage, 14667,
     /*  773316 */     GIR_EraseRootFromParent_Done,
     /*  773317 */   // Label 12054: @773317
     /*  773317 */   GIM_Try, /*On fail goto*//*Label 12055*/ GIMT_Encode4(773395), // Rule ID 14670 //
     /*  773322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  773342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  773371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773393 */     GIR_RootConstrainSelectedInstOperands,
     /*  773394 */     // GIR_Coverage, 14670,
     /*  773394 */     GIR_EraseRootFromParent_Done,
     /*  773395 */   // Label 12055: @773395
     /*  773395 */   GIM_Try, /*On fail goto*//*Label 12056*/ GIMT_Encode4(773473), // Rule ID 14671 //
     /*  773400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  773420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773446 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  773449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773471 */     GIR_RootConstrainSelectedInstOperands,
     /*  773472 */     // GIR_Coverage, 14671,
     /*  773472 */     GIR_EraseRootFromParent_Done,
     /*  773473 */   // Label 12056: @773473
     /*  773473 */   GIM_Try, /*On fail goto*//*Label 12057*/ GIMT_Encode4(773551), // Rule ID 14674 //
     /*  773478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  773489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  773492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  773495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773524 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  773527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773549 */     GIR_RootConstrainSelectedInstOperands,
     /*  773550 */     // GIR_Coverage, 14674,
     /*  773550 */     GIR_EraseRootFromParent_Done,
     /*  773551 */   // Label 12057: @773551
     /*  773551 */   GIM_Try, /*On fail goto*//*Label 12058*/ GIMT_Encode4(773629), // Rule ID 14675 //
     /*  773556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  773567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  773570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  773573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773602 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  773602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  773605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773627 */     GIR_RootConstrainSelectedInstOperands,
     /*  773628 */     // GIR_Coverage, 14675,
     /*  773628 */     GIR_EraseRootFromParent_Done,
     /*  773629 */   // Label 12058: @773629
     /*  773629 */   GIM_Try, /*On fail goto*//*Label 12059*/ GIMT_Encode4(773707), // Rule ID 14678 //
     /*  773634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  773645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  773648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  773651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773680 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  773683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773705 */     GIR_RootConstrainSelectedInstOperands,
     /*  773706 */     // GIR_Coverage, 14678,
     /*  773706 */     GIR_EraseRootFromParent_Done,
     /*  773707 */   // Label 12059: @773707
     /*  773707 */   GIM_Try, /*On fail goto*//*Label 12060*/ GIMT_Encode4(773785), // Rule ID 14679 //
     /*  773712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  773723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  773726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  773729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773758 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  773758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  773761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773783 */     GIR_RootConstrainSelectedInstOperands,
     /*  773784 */     // GIR_Coverage, 14679,
     /*  773784 */     GIR_EraseRootFromParent_Done,
     /*  773785 */   // Label 12060: @773785
     /*  773785 */   GIM_Try, /*On fail goto*//*Label 12061*/ GIMT_Encode4(773863), // Rule ID 14682 //
     /*  773790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  773801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  773804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  773807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773836 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  773839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773861 */     GIR_RootConstrainSelectedInstOperands,
     /*  773862 */     // GIR_Coverage, 14682,
     /*  773862 */     GIR_EraseRootFromParent_Done,
     /*  773863 */   // Label 12061: @773863
     /*  773863 */   GIM_Try, /*On fail goto*//*Label 12062*/ GIMT_Encode4(773941), // Rule ID 14683 //
     /*  773868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  773879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  773882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  773885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773914 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  773914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  773917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773939 */     GIR_RootConstrainSelectedInstOperands,
     /*  773940 */     // GIR_Coverage, 14683,
     /*  773940 */     GIR_EraseRootFromParent_Done,
     /*  773941 */   // Label 12062: @773941
     /*  773941 */   GIM_Try, /*On fail goto*//*Label 12063*/ GIMT_Encode4(774019), // Rule ID 14686 //
     /*  773946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  773957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  773960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  773963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773992 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  773992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  773995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774017 */     GIR_RootConstrainSelectedInstOperands,
     /*  774018 */     // GIR_Coverage, 14686,
     /*  774018 */     GIR_EraseRootFromParent_Done,
     /*  774019 */   // Label 12063: @774019
     /*  774019 */   GIM_Try, /*On fail goto*//*Label 12064*/ GIMT_Encode4(774097), // Rule ID 14687 //
     /*  774024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  774035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  774038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  774041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774070 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  774073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774095 */     GIR_RootConstrainSelectedInstOperands,
     /*  774096 */     // GIR_Coverage, 14687,
     /*  774096 */     GIR_EraseRootFromParent_Done,
     /*  774097 */   // Label 12064: @774097
     /*  774097 */   GIM_Try, /*On fail goto*//*Label 12065*/ GIMT_Encode4(774175), // Rule ID 14690 //
     /*  774102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774173 */     GIR_RootConstrainSelectedInstOperands,
     /*  774174 */     // GIR_Coverage, 14690,
     /*  774174 */     GIR_EraseRootFromParent_Done,
     /*  774175 */   // Label 12065: @774175
     /*  774175 */   GIM_Try, /*On fail goto*//*Label 12066*/ GIMT_Encode4(774253), // Rule ID 14691 //
     /*  774180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774226 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774251 */     GIR_RootConstrainSelectedInstOperands,
     /*  774252 */     // GIR_Coverage, 14691,
     /*  774252 */     GIR_EraseRootFromParent_Done,
     /*  774253 */   // Label 12066: @774253
     /*  774253 */   GIM_Try, /*On fail goto*//*Label 12067*/ GIMT_Encode4(774331), // Rule ID 14694 //
     /*  774258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  774269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  774272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  774275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774304 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  774304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774326 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774329 */     GIR_RootConstrainSelectedInstOperands,
     /*  774330 */     // GIR_Coverage, 14694,
     /*  774330 */     GIR_EraseRootFromParent_Done,
     /*  774331 */   // Label 12067: @774331
     /*  774331 */   GIM_Try, /*On fail goto*//*Label 12068*/ GIMT_Encode4(774409), // Rule ID 14695 //
     /*  774336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  774347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  774350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  774353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774382 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  774382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774407 */     GIR_RootConstrainSelectedInstOperands,
     /*  774408 */     // GIR_Coverage, 14695,
     /*  774408 */     GIR_EraseRootFromParent_Done,
     /*  774409 */   // Label 12068: @774409
     /*  774409 */   GIM_Try, /*On fail goto*//*Label 12069*/ GIMT_Encode4(774487), // Rule ID 14698 //
     /*  774414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  774425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  774428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  774431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774460 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774485 */     GIR_RootConstrainSelectedInstOperands,
     /*  774486 */     // GIR_Coverage, 14698,
     /*  774486 */     GIR_EraseRootFromParent_Done,
     /*  774487 */   // Label 12069: @774487
     /*  774487 */   GIM_Try, /*On fail goto*//*Label 12070*/ GIMT_Encode4(774565), // Rule ID 14699 //
     /*  774492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  774503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  774506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  774509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774538 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11633:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774563 */     GIR_RootConstrainSelectedInstOperands,
     /*  774564 */     // GIR_Coverage, 14699,
     /*  774564 */     GIR_EraseRootFromParent_Done,
     /*  774565 */   // Label 12070: @774565
     /*  774565 */   GIM_Try, /*On fail goto*//*Label 12071*/ GIMT_Encode4(774643), // Rule ID 14702 //
     /*  774570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  774581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  774584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  774587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774616 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774641 */     GIR_RootConstrainSelectedInstOperands,
     /*  774642 */     // GIR_Coverage, 14702,
     /*  774642 */     GIR_EraseRootFromParent_Done,
     /*  774643 */   // Label 12071: @774643
     /*  774643 */   GIM_Try, /*On fail goto*//*Label 12072*/ GIMT_Encode4(774721), // Rule ID 14703 //
     /*  774648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  774659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  774662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  774665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774719 */     GIR_RootConstrainSelectedInstOperands,
     /*  774720 */     // GIR_Coverage, 14703,
     /*  774720 */     GIR_EraseRootFromParent_Done,
     /*  774721 */   // Label 12072: @774721
     /*  774721 */   GIM_Try, /*On fail goto*//*Label 12073*/ GIMT_Encode4(774799), // Rule ID 14706 //
     /*  774726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  774737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  774740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  774743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774772 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  774772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774797 */     GIR_RootConstrainSelectedInstOperands,
     /*  774798 */     // GIR_Coverage, 14706,
     /*  774798 */     GIR_EraseRootFromParent_Done,
     /*  774799 */   // Label 12073: @774799
     /*  774799 */   GIM_Try, /*On fail goto*//*Label 12074*/ GIMT_Encode4(774877), // Rule ID 14707 //
     /*  774804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  774815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  774818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  774821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774850 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  774850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774875 */     GIR_RootConstrainSelectedInstOperands,
     /*  774876 */     // GIR_Coverage, 14707,
     /*  774876 */     GIR_EraseRootFromParent_Done,
     /*  774877 */   // Label 12074: @774877
     /*  774877 */   GIM_Try, /*On fail goto*//*Label 12075*/ GIMT_Encode4(774955), // Rule ID 14710 //
     /*  774882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  774885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  774893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  774896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  774899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  774928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  774947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774953 */     GIR_RootConstrainSelectedInstOperands,
     /*  774954 */     // GIR_Coverage, 14710,
     /*  774954 */     GIR_EraseRootFromParent_Done,
     /*  774955 */   // Label 12075: @774955
     /*  774955 */   GIM_Try, /*On fail goto*//*Label 12076*/ GIMT_Encode4(775033), // Rule ID 14711 //
     /*  774960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  774963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  774971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  774974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  774977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775006 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  775006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  775025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775031 */     GIR_RootConstrainSelectedInstOperands,
     /*  775032 */     // GIR_Coverage, 14711,
     /*  775032 */     GIR_EraseRootFromParent_Done,
     /*  775033 */   // Label 12076: @775033
     /*  775033 */   GIM_Try, /*On fail goto*//*Label 12077*/ GIMT_Encode4(775111), // Rule ID 14714 //
     /*  775038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  775049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  775052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  775055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775084 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775109 */     GIR_RootConstrainSelectedInstOperands,
     /*  775110 */     // GIR_Coverage, 14714,
     /*  775110 */     GIR_EraseRootFromParent_Done,
     /*  775111 */   // Label 12077: @775111
     /*  775111 */   GIM_Try, /*On fail goto*//*Label 12078*/ GIMT_Encode4(775189), // Rule ID 14715 //
     /*  775116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  775127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  775130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  775133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775162 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775187 */     GIR_RootConstrainSelectedInstOperands,
     /*  775188 */     // GIR_Coverage, 14715,
     /*  775188 */     GIR_EraseRootFromParent_Done,
     /*  775189 */   // Label 12078: @775189
     /*  775189 */   GIM_Try, /*On fail goto*//*Label 12079*/ GIMT_Encode4(775267), // Rule ID 14718 //
     /*  775194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  775205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  775208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  775211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775240 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775265 */     GIR_RootConstrainSelectedInstOperands,
     /*  775266 */     // GIR_Coverage, 14718,
     /*  775266 */     GIR_EraseRootFromParent_Done,
     /*  775267 */   // Label 12079: @775267
     /*  775267 */   GIM_Try, /*On fail goto*//*Label 12080*/ GIMT_Encode4(775345), // Rule ID 14719 //
     /*  775272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  775283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  775286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  775289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775318 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775343 */     GIR_RootConstrainSelectedInstOperands,
     /*  775344 */     // GIR_Coverage, 14719,
     /*  775344 */     GIR_EraseRootFromParent_Done,
     /*  775345 */   // Label 12080: @775345
     /*  775345 */   GIM_Try, /*On fail goto*//*Label 12081*/ GIMT_Encode4(775423), // Rule ID 14722 //
     /*  775350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  775361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  775364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  775367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775396 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775421 */     GIR_RootConstrainSelectedInstOperands,
     /*  775422 */     // GIR_Coverage, 14722,
     /*  775422 */     GIR_EraseRootFromParent_Done,
     /*  775423 */   // Label 12081: @775423
     /*  775423 */   GIM_Try, /*On fail goto*//*Label 12082*/ GIMT_Encode4(775501), // Rule ID 14723 //
     /*  775428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  775439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  775442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  775445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775474 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775499 */     GIR_RootConstrainSelectedInstOperands,
     /*  775500 */     // GIR_Coverage, 14723,
     /*  775500 */     GIR_EraseRootFromParent_Done,
     /*  775501 */   // Label 12082: @775501
     /*  775501 */   GIM_Try, /*On fail goto*//*Label 12083*/ GIMT_Encode4(775579), // Rule ID 14726 //
     /*  775506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  775523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775577 */     GIR_RootConstrainSelectedInstOperands,
     /*  775578 */     // GIR_Coverage, 14726,
     /*  775578 */     GIR_EraseRootFromParent_Done,
     /*  775579 */   // Label 12083: @775579
     /*  775579 */   GIM_Try, /*On fail goto*//*Label 12084*/ GIMT_Encode4(775657), // Rule ID 14727 //
     /*  775584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  775601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775655 */     GIR_RootConstrainSelectedInstOperands,
     /*  775656 */     // GIR_Coverage, 14727,
     /*  775656 */     GIR_EraseRootFromParent_Done,
     /*  775657 */   // Label 12084: @775657
     /*  775657 */   GIM_Try, /*On fail goto*//*Label 12085*/ GIMT_Encode4(775735), // Rule ID 14730 //
     /*  775662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  775673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  775676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  775679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775708 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775733 */     GIR_RootConstrainSelectedInstOperands,
     /*  775734 */     // GIR_Coverage, 14730,
     /*  775734 */     GIR_EraseRootFromParent_Done,
     /*  775735 */   // Label 12085: @775735
     /*  775735 */   GIM_Try, /*On fail goto*//*Label 12086*/ GIMT_Encode4(775813), // Rule ID 14731 //
     /*  775740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  775751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  775754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  775757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775786 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775811 */     GIR_RootConstrainSelectedInstOperands,
     /*  775812 */     // GIR_Coverage, 14731,
     /*  775812 */     GIR_EraseRootFromParent_Done,
     /*  775813 */   // Label 12086: @775813
     /*  775813 */   GIM_Try, /*On fail goto*//*Label 12087*/ GIMT_Encode4(775891), // Rule ID 14734 //
     /*  775818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  775829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  775832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  775835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775864 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775889 */     GIR_RootConstrainSelectedInstOperands,
     /*  775890 */     // GIR_Coverage, 14734,
     /*  775890 */     GIR_EraseRootFromParent_Done,
     /*  775891 */   // Label 12087: @775891
     /*  775891 */   GIM_Try, /*On fail goto*//*Label 12088*/ GIMT_Encode4(775969), // Rule ID 14735 //
     /*  775896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  775907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  775910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  775913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775942 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775967 */     GIR_RootConstrainSelectedInstOperands,
     /*  775968 */     // GIR_Coverage, 14735,
     /*  775968 */     GIR_EraseRootFromParent_Done,
     /*  775969 */   // Label 12088: @775969
     /*  775969 */   GIM_Try, /*On fail goto*//*Label 12089*/ GIMT_Encode4(776047), // Rule ID 14738 //
     /*  775974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  775985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  775988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  775991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776020 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776045 */     GIR_RootConstrainSelectedInstOperands,
     /*  776046 */     // GIR_Coverage, 14738,
     /*  776046 */     GIR_EraseRootFromParent_Done,
     /*  776047 */   // Label 12089: @776047
     /*  776047 */   GIM_Try, /*On fail goto*//*Label 12090*/ GIMT_Encode4(776125), // Rule ID 14739 //
     /*  776052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  776063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  776066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  776069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776098 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776123 */     GIR_RootConstrainSelectedInstOperands,
     /*  776124 */     // GIR_Coverage, 14739,
     /*  776124 */     GIR_EraseRootFromParent_Done,
     /*  776125 */   // Label 12090: @776125
     /*  776125 */   GIM_Try, /*On fail goto*//*Label 12091*/ GIMT_Encode4(776203), // Rule ID 14742 //
     /*  776130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  776141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  776144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  776147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776176 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776201 */     GIR_RootConstrainSelectedInstOperands,
     /*  776202 */     // GIR_Coverage, 14742,
     /*  776202 */     GIR_EraseRootFromParent_Done,
     /*  776203 */   // Label 12091: @776203
     /*  776203 */   GIM_Try, /*On fail goto*//*Label 12092*/ GIMT_Encode4(776281), // Rule ID 14743 //
     /*  776208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  776219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  776222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  776225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776279 */     GIR_RootConstrainSelectedInstOperands,
     /*  776280 */     // GIR_Coverage, 14743,
     /*  776280 */     GIR_EraseRootFromParent_Done,
     /*  776281 */   // Label 12092: @776281
     /*  776281 */   GIM_Try, /*On fail goto*//*Label 12093*/ GIMT_Encode4(776359), // Rule ID 14746 //
     /*  776286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  776297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  776300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  776303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776332 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776357 */     GIR_RootConstrainSelectedInstOperands,
     /*  776358 */     // GIR_Coverage, 14746,
     /*  776358 */     GIR_EraseRootFromParent_Done,
     /*  776359 */   // Label 12093: @776359
     /*  776359 */   GIM_Try, /*On fail goto*//*Label 12094*/ GIMT_Encode4(776437), // Rule ID 14747 //
     /*  776364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  776375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  776378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  776381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776410 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776435 */     GIR_RootConstrainSelectedInstOperands,
     /*  776436 */     // GIR_Coverage, 14747,
     /*  776436 */     GIR_EraseRootFromParent_Done,
     /*  776437 */   // Label 12094: @776437
     /*  776437 */   GIM_Try, /*On fail goto*//*Label 12095*/ GIMT_Encode4(776515), // Rule ID 14750 //
     /*  776442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  776445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  776453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  776456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  776459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776488 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  776488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776513 */     GIR_RootConstrainSelectedInstOperands,
     /*  776514 */     // GIR_Coverage, 14750,
     /*  776514 */     GIR_EraseRootFromParent_Done,
     /*  776515 */   // Label 12095: @776515
     /*  776515 */   GIM_Try, /*On fail goto*//*Label 12096*/ GIMT_Encode4(776593), // Rule ID 14751 //
     /*  776520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  776523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  776531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  776534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  776537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  776566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776591 */     GIR_RootConstrainSelectedInstOperands,
     /*  776592 */     // GIR_Coverage, 14751,
     /*  776592 */     GIR_EraseRootFromParent_Done,
     /*  776593 */   // Label 12096: @776593
     /*  776593 */   GIM_Try, /*On fail goto*//*Label 12097*/ GIMT_Encode4(776671), // Rule ID 14754 //
     /*  776598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  776601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  776609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  776612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  776615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776644 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  776644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776669 */     GIR_RootConstrainSelectedInstOperands,
     /*  776670 */     // GIR_Coverage, 14754,
     /*  776670 */     GIR_EraseRootFromParent_Done,
     /*  776671 */   // Label 12097: @776671
     /*  776671 */   GIM_Try, /*On fail goto*//*Label 12098*/ GIMT_Encode4(776749), // Rule ID 14755 //
     /*  776676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  776679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  776687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  776690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  776693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776722 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  776722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776747 */     GIR_RootConstrainSelectedInstOperands,
     /*  776748 */     // GIR_Coverage, 14755,
     /*  776748 */     GIR_EraseRootFromParent_Done,
     /*  776749 */   // Label 12098: @776749
     /*  776749 */   GIM_Try, /*On fail goto*//*Label 12099*/ GIMT_Encode4(776827), // Rule ID 14758 //
     /*  776754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  776757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  776765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  776768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  776771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776800 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  776800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776825 */     GIR_RootConstrainSelectedInstOperands,
     /*  776826 */     // GIR_Coverage, 14758,
     /*  776826 */     GIR_EraseRootFromParent_Done,
     /*  776827 */   // Label 12099: @776827
     /*  776827 */   GIM_Try, /*On fail goto*//*Label 12100*/ GIMT_Encode4(776905), // Rule ID 14759 //
     /*  776832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  776835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  776843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  776846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  776849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776878 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  776878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776903 */     GIR_RootConstrainSelectedInstOperands,
     /*  776904 */     // GIR_Coverage, 14759,
     /*  776904 */     GIR_EraseRootFromParent_Done,
     /*  776905 */   // Label 12100: @776905
     /*  776905 */   GIM_Try, /*On fail goto*//*Label 12101*/ GIMT_Encode4(776983), // Rule ID 14762 //
     /*  776910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  776918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  776921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  776924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  776927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  776930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776956 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  776956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  776959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  776975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776978 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776981 */     GIR_RootConstrainSelectedInstOperands,
     /*  776982 */     // GIR_Coverage, 14762,
     /*  776982 */     GIR_EraseRootFromParent_Done,
     /*  776983 */   // Label 12101: @776983
     /*  776983 */   GIM_Try, /*On fail goto*//*Label 12102*/ GIMT_Encode4(777061), // Rule ID 14763 //
     /*  776988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  776996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  776999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  777002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  777005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  777008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777034 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  777037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777059 */     GIR_RootConstrainSelectedInstOperands,
     /*  777060 */     // GIR_Coverage, 14763,
     /*  777060 */     GIR_EraseRootFromParent_Done,
     /*  777061 */   // Label 12102: @777061
     /*  777061 */   GIM_Try, /*On fail goto*//*Label 12103*/ GIMT_Encode4(777139), // Rule ID 14766 //
     /*  777066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  777077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  777080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  777083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  777086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777112 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777137 */     GIR_RootConstrainSelectedInstOperands,
     /*  777138 */     // GIR_Coverage, 14766,
     /*  777138 */     GIR_EraseRootFromParent_Done,
     /*  777139 */   // Label 12103: @777139
     /*  777139 */   GIM_Try, /*On fail goto*//*Label 12104*/ GIMT_Encode4(777217), // Rule ID 14767 //
     /*  777144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  777155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  777158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  777161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  777164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777190 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777215 */     GIR_RootConstrainSelectedInstOperands,
     /*  777216 */     // GIR_Coverage, 14767,
     /*  777216 */     GIR_EraseRootFromParent_Done,
     /*  777217 */   // Label 12104: @777217
     /*  777217 */   GIM_Try, /*On fail goto*//*Label 12105*/ GIMT_Encode4(777295), // Rule ID 14770 //
     /*  777222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  777233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  777236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  777239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  777242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777268 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777293 */     GIR_RootConstrainSelectedInstOperands,
     /*  777294 */     // GIR_Coverage, 14770,
     /*  777294 */     GIR_EraseRootFromParent_Done,
     /*  777295 */   // Label 12105: @777295
     /*  777295 */   GIM_Try, /*On fail goto*//*Label 12106*/ GIMT_Encode4(777373), // Rule ID 14771 //
     /*  777300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  777311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  777314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  777317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  777320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777346 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777371 */     GIR_RootConstrainSelectedInstOperands,
     /*  777372 */     // GIR_Coverage, 14771,
     /*  777372 */     GIR_EraseRootFromParent_Done,
     /*  777373 */   // Label 12106: @777373
     /*  777373 */   GIM_Try, /*On fail goto*//*Label 12107*/ GIMT_Encode4(777451), // Rule ID 14774 //
     /*  777378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  777389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  777392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  777395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  777398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777424 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777449 */     GIR_RootConstrainSelectedInstOperands,
     /*  777450 */     // GIR_Coverage, 14774,
     /*  777450 */     GIR_EraseRootFromParent_Done,
     /*  777451 */   // Label 12107: @777451
     /*  777451 */   GIM_Try, /*On fail goto*//*Label 12108*/ GIMT_Encode4(777529), // Rule ID 14775 //
     /*  777456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  777467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  777470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  777473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  777476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777502 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  777502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777527 */     GIR_RootConstrainSelectedInstOperands,
     /*  777528 */     // GIR_Coverage, 14775,
     /*  777528 */     GIR_EraseRootFromParent_Done,
     /*  777529 */   // Label 12108: @777529
     /*  777529 */   GIM_Try, /*On fail goto*//*Label 12109*/ GIMT_Encode4(777607), // Rule ID 14778 //
     /*  777534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  777545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  777548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  777551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  777554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777580 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777605 */     GIR_RootConstrainSelectedInstOperands,
     /*  777606 */     // GIR_Coverage, 14778,
     /*  777606 */     GIR_EraseRootFromParent_Done,
     /*  777607 */   // Label 12109: @777607
     /*  777607 */   GIM_Try, /*On fail goto*//*Label 12110*/ GIMT_Encode4(777685), // Rule ID 14779 //
     /*  777612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  777623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  777626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  777629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  777632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777658 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  777658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777683 */     GIR_RootConstrainSelectedInstOperands,
     /*  777684 */     // GIR_Coverage, 14779,
     /*  777684 */     GIR_EraseRootFromParent_Done,
     /*  777685 */   // Label 12110: @777685
     /*  777685 */   GIM_Try, /*On fail goto*//*Label 12111*/ GIMT_Encode4(777763), // Rule ID 14782 //
     /*  777690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  777701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  777704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  777707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  777710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777736 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  777736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  777755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777761 */     GIR_RootConstrainSelectedInstOperands,
     /*  777762 */     // GIR_Coverage, 14782,
     /*  777762 */     GIR_EraseRootFromParent_Done,
     /*  777763 */   // Label 12111: @777763
     /*  777763 */   GIM_Try, /*On fail goto*//*Label 12112*/ GIMT_Encode4(777841), // Rule ID 14783 //
     /*  777768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  777779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  777782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  777785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  777788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  777814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  777833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777839 */     GIR_RootConstrainSelectedInstOperands,
     /*  777840 */     // GIR_Coverage, 14783,
     /*  777840 */     GIR_EraseRootFromParent_Done,
     /*  777841 */   // Label 12112: @777841
     /*  777841 */   GIM_Try, /*On fail goto*//*Label 12113*/ GIMT_Encode4(777919), // Rule ID 14786 //
     /*  777846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  777857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  777860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  777863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  777866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777892 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  777895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777917 */     GIR_RootConstrainSelectedInstOperands,
     /*  777918 */     // GIR_Coverage, 14786,
     /*  777918 */     GIR_EraseRootFromParent_Done,
     /*  777919 */   // Label 12113: @777919
     /*  777919 */   GIM_Try, /*On fail goto*//*Label 12114*/ GIMT_Encode4(777997), // Rule ID 14787 //
     /*  777924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  777935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  777938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  777941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  777944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777970 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  777973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777995 */     GIR_RootConstrainSelectedInstOperands,
     /*  777996 */     // GIR_Coverage, 14787,
     /*  777996 */     GIR_EraseRootFromParent_Done,
     /*  777997 */   // Label 12114: @777997
     /*  777997 */   GIM_Try, /*On fail goto*//*Label 12115*/ GIMT_Encode4(778075), // Rule ID 14790 //
     /*  778002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  778013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  778016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  778019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  778022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778048 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  778048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778073 */     GIR_RootConstrainSelectedInstOperands,
     /*  778074 */     // GIR_Coverage, 14790,
     /*  778074 */     GIR_EraseRootFromParent_Done,
     /*  778075 */   // Label 12115: @778075
     /*  778075 */   GIM_Try, /*On fail goto*//*Label 12116*/ GIMT_Encode4(778153), // Rule ID 14791 //
     /*  778080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  778091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  778094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  778097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  778100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778126 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  778126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778151 */     GIR_RootConstrainSelectedInstOperands,
     /*  778152 */     // GIR_Coverage, 14791,
     /*  778152 */     GIR_EraseRootFromParent_Done,
     /*  778153 */   // Label 12116: @778153
     /*  778153 */   GIM_Try, /*On fail goto*//*Label 12117*/ GIMT_Encode4(778231), // Rule ID 14794 //
     /*  778158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  778169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  778172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  778175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  778178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778204 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  778204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778229 */     GIR_RootConstrainSelectedInstOperands,
     /*  778230 */     // GIR_Coverage, 14794,
     /*  778230 */     GIR_EraseRootFromParent_Done,
     /*  778231 */   // Label 12117: @778231
     /*  778231 */   GIM_Try, /*On fail goto*//*Label 12118*/ GIMT_Encode4(778309), // Rule ID 14795 //
     /*  778236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  778247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  778250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  778253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  778256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778282 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  778282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778307 */     GIR_RootConstrainSelectedInstOperands,
     /*  778308 */     // GIR_Coverage, 14795,
     /*  778308 */     GIR_EraseRootFromParent_Done,
     /*  778309 */   // Label 12118: @778309
     /*  778309 */   GIM_Try, /*On fail goto*//*Label 12119*/ GIMT_Encode4(778387), // Rule ID 14798 //
     /*  778314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  778317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  778325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  778328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  778331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  778334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778360 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  778360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778385 */     GIR_RootConstrainSelectedInstOperands,
     /*  778386 */     // GIR_Coverage, 14798,
     /*  778386 */     GIR_EraseRootFromParent_Done,
     /*  778387 */   // Label 12119: @778387
     /*  778387 */   GIM_Try, /*On fail goto*//*Label 12120*/ GIMT_Encode4(778465), // Rule ID 14799 //
     /*  778392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  778395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  778403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  778406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  778409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  778412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778438 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  778438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778463 */     GIR_RootConstrainSelectedInstOperands,
     /*  778464 */     // GIR_Coverage, 14799,
     /*  778464 */     GIR_EraseRootFromParent_Done,
     /*  778465 */   // Label 12120: @778465
     /*  778465 */   GIM_Try, /*On fail goto*//*Label 12121*/ GIMT_Encode4(778543), // Rule ID 14802 //
     /*  778470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  778481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  778484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  778487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  778490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778516 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  778519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778541 */     GIR_RootConstrainSelectedInstOperands,
     /*  778542 */     // GIR_Coverage, 14802,
     /*  778542 */     GIR_EraseRootFromParent_Done,
     /*  778543 */   // Label 12121: @778543
     /*  778543 */   GIM_Try, /*On fail goto*//*Label 12122*/ GIMT_Encode4(778621), // Rule ID 14803 //
     /*  778548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  778559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  778562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  778565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  778568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778594 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  778597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778619 */     GIR_RootConstrainSelectedInstOperands,
     /*  778620 */     // GIR_Coverage, 14803,
     /*  778620 */     GIR_EraseRootFromParent_Done,
     /*  778621 */   // Label 12122: @778621
     /*  778621 */   GIM_Try, /*On fail goto*//*Label 12123*/ GIMT_Encode4(778699), // Rule ID 14806 //
     /*  778626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  778637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  778640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  778643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  778646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778672 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  778675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778697 */     GIR_RootConstrainSelectedInstOperands,
     /*  778698 */     // GIR_Coverage, 14806,
     /*  778698 */     GIR_EraseRootFromParent_Done,
     /*  778699 */   // Label 12123: @778699
     /*  778699 */   GIM_Try, /*On fail goto*//*Label 12124*/ GIMT_Encode4(778777), // Rule ID 14807 //
     /*  778704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  778715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  778718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  778721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  778724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778750 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  778753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778775 */     GIR_RootConstrainSelectedInstOperands,
     /*  778776 */     // GIR_Coverage, 14807,
     /*  778776 */     GIR_EraseRootFromParent_Done,
     /*  778777 */   // Label 12124: @778777
     /*  778777 */   GIM_Try, /*On fail goto*//*Label 12125*/ GIMT_Encode4(778855), // Rule ID 14810 //
     /*  778782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  778793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  778796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  778799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  778802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778828 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  778831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778853 */     GIR_RootConstrainSelectedInstOperands,
     /*  778854 */     // GIR_Coverage, 14810,
     /*  778854 */     GIR_EraseRootFromParent_Done,
     /*  778855 */   // Label 12125: @778855
     /*  778855 */   GIM_Try, /*On fail goto*//*Label 12126*/ GIMT_Encode4(778933), // Rule ID 14811 //
     /*  778860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  778871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  778874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  778877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  778880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778906 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  778909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778931 */     GIR_RootConstrainSelectedInstOperands,
     /*  778932 */     // GIR_Coverage, 14811,
     /*  778932 */     GIR_EraseRootFromParent_Done,
     /*  778933 */   // Label 12126: @778933
     /*  778933 */   GIM_Try, /*On fail goto*//*Label 12127*/ GIMT_Encode4(779011), // Rule ID 14814 //
     /*  778938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  778949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  778952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  778955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  778958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  778984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  778987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779009 */     GIR_RootConstrainSelectedInstOperands,
     /*  779010 */     // GIR_Coverage, 14814,
     /*  779010 */     GIR_EraseRootFromParent_Done,
     /*  779011 */   // Label 12127: @779011
     /*  779011 */   GIM_Try, /*On fail goto*//*Label 12128*/ GIMT_Encode4(779089), // Rule ID 14815 //
     /*  779016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  779027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  779030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  779033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  779036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779062 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779087 */     GIR_RootConstrainSelectedInstOperands,
     /*  779088 */     // GIR_Coverage, 14815,
     /*  779088 */     GIR_EraseRootFromParent_Done,
     /*  779089 */   // Label 12128: @779089
     /*  779089 */   GIM_Try, /*On fail goto*//*Label 12129*/ GIMT_Encode4(779167), // Rule ID 14818 //
     /*  779094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  779105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  779108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  779111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  779114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779140 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779165 */     GIR_RootConstrainSelectedInstOperands,
     /*  779166 */     // GIR_Coverage, 14818,
     /*  779166 */     GIR_EraseRootFromParent_Done,
     /*  779167 */   // Label 12129: @779167
     /*  779167 */   GIM_Try, /*On fail goto*//*Label 12130*/ GIMT_Encode4(779245), // Rule ID 14819 //
     /*  779172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  779183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  779186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  779189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  779192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779243 */     GIR_RootConstrainSelectedInstOperands,
     /*  779244 */     // GIR_Coverage, 14819,
     /*  779244 */     GIR_EraseRootFromParent_Done,
     /*  779245 */   // Label 12130: @779245
     /*  779245 */   GIM_Try, /*On fail goto*//*Label 12131*/ GIMT_Encode4(779323), // Rule ID 14822 //
     /*  779250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  779261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  779264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  779267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  779270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779296 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779321 */     GIR_RootConstrainSelectedInstOperands,
     /*  779322 */     // GIR_Coverage, 14822,
     /*  779322 */     GIR_EraseRootFromParent_Done,
     /*  779323 */   // Label 12131: @779323
     /*  779323 */   GIM_Try, /*On fail goto*//*Label 12132*/ GIMT_Encode4(779401), // Rule ID 14823 //
     /*  779328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  779339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  779342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  779345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  779348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779374 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779399 */     GIR_RootConstrainSelectedInstOperands,
     /*  779400 */     // GIR_Coverage, 14823,
     /*  779400 */     GIR_EraseRootFromParent_Done,
     /*  779401 */   // Label 12132: @779401
     /*  779401 */   GIM_Try, /*On fail goto*//*Label 12133*/ GIMT_Encode4(779479), // Rule ID 14826 //
     /*  779406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  779417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  779420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  779423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  779426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  779452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779477 */     GIR_RootConstrainSelectedInstOperands,
     /*  779478 */     // GIR_Coverage, 14826,
     /*  779478 */     GIR_EraseRootFromParent_Done,
     /*  779479 */   // Label 12133: @779479
     /*  779479 */   GIM_Try, /*On fail goto*//*Label 12134*/ GIMT_Encode4(779557), // Rule ID 14827 //
     /*  779484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  779495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  779498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  779501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  779504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779530 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  779530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779555 */     GIR_RootConstrainSelectedInstOperands,
     /*  779556 */     // GIR_Coverage, 14827,
     /*  779556 */     GIR_EraseRootFromParent_Done,
     /*  779557 */   // Label 12134: @779557
     /*  779557 */   GIM_Try, /*On fail goto*//*Label 12135*/ GIMT_Encode4(779635), // Rule ID 14830 //
     /*  779562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  779573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  779576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  779579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  779582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779608 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  779608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779633 */     GIR_RootConstrainSelectedInstOperands,
     /*  779634 */     // GIR_Coverage, 14830,
     /*  779634 */     GIR_EraseRootFromParent_Done,
     /*  779635 */   // Label 12135: @779635
     /*  779635 */   GIM_Try, /*On fail goto*//*Label 12136*/ GIMT_Encode4(779713), // Rule ID 14831 //
     /*  779640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  779651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  779654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  779657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  779660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  779686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779711 */     GIR_RootConstrainSelectedInstOperands,
     /*  779712 */     // GIR_Coverage, 14831,
     /*  779712 */     GIR_EraseRootFromParent_Done,
     /*  779713 */   // Label 12136: @779713
     /*  779713 */   GIM_Try, /*On fail goto*//*Label 12137*/ GIMT_Encode4(779791), // Rule ID 14834 //
     /*  779718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  779729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  779732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  779735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  779738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779764 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  779764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779789 */     GIR_RootConstrainSelectedInstOperands,
     /*  779790 */     // GIR_Coverage, 14834,
     /*  779790 */     GIR_EraseRootFromParent_Done,
     /*  779791 */   // Label 12137: @779791
     /*  779791 */   GIM_Try, /*On fail goto*//*Label 12138*/ GIMT_Encode4(779869), // Rule ID 14835 //
     /*  779796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  779807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  779810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  779813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  779816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779842 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  779842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779867 */     GIR_RootConstrainSelectedInstOperands,
     /*  779868 */     // GIR_Coverage, 14835,
     /*  779868 */     GIR_EraseRootFromParent_Done,
     /*  779869 */   // Label 12138: @779869
     /*  779869 */   GIM_Try, /*On fail goto*//*Label 12139*/ GIMT_Encode4(779947), // Rule ID 14838 //
     /*  779874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  779877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  779885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  779888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  779891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  779894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779920 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  779920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  779939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779945 */     GIR_RootConstrainSelectedInstOperands,
     /*  779946 */     // GIR_Coverage, 14838,
     /*  779946 */     GIR_EraseRootFromParent_Done,
     /*  779947 */   // Label 12139: @779947
     /*  779947 */   GIM_Try, /*On fail goto*//*Label 12140*/ GIMT_Encode4(780025), // Rule ID 14839 //
     /*  779952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  779955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  779963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  779966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  779969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  779972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779998 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  779998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  780001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780023 */     GIR_RootConstrainSelectedInstOperands,
     /*  780024 */     // GIR_Coverage, 14839,
     /*  780024 */     GIR_EraseRootFromParent_Done,
     /*  780025 */   // Label 12140: @780025
     /*  780025 */   GIM_Try, /*On fail goto*//*Label 12141*/ GIMT_Encode4(780103), // Rule ID 14842 //
     /*  780030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  780041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  780044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  780047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  780050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780076 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  780079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780101 */     GIR_RootConstrainSelectedInstOperands,
     /*  780102 */     // GIR_Coverage, 14842,
     /*  780102 */     GIR_EraseRootFromParent_Done,
     /*  780103 */   // Label 12141: @780103
     /*  780103 */   GIM_Try, /*On fail goto*//*Label 12142*/ GIMT_Encode4(780181), // Rule ID 14843 //
     /*  780108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  780119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  780122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  780125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  780128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780154 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  780157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780179 */     GIR_RootConstrainSelectedInstOperands,
     /*  780180 */     // GIR_Coverage, 14843,
     /*  780180 */     GIR_EraseRootFromParent_Done,
     /*  780181 */   // Label 12142: @780181
     /*  780181 */   GIM_Try, /*On fail goto*//*Label 12143*/ GIMT_Encode4(780259), // Rule ID 14846 //
     /*  780186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  780197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  780200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  780203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  780206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780232 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  780235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780257 */     GIR_RootConstrainSelectedInstOperands,
     /*  780258 */     // GIR_Coverage, 14846,
     /*  780258 */     GIR_EraseRootFromParent_Done,
     /*  780259 */   // Label 12143: @780259
     /*  780259 */   GIM_Try, /*On fail goto*//*Label 12144*/ GIMT_Encode4(780337), // Rule ID 14847 //
     /*  780264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  780275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  780278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  780281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  780284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780310 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  780313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780335 */     GIR_RootConstrainSelectedInstOperands,
     /*  780336 */     // GIR_Coverage, 14847,
     /*  780336 */     GIR_EraseRootFromParent_Done,
     /*  780337 */   // Label 12144: @780337
     /*  780337 */   GIM_Try, /*On fail goto*//*Label 12145*/ GIMT_Encode4(780415), // Rule ID 14850 //
     /*  780342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  780353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  780356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  780359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780388 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  780391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780413 */     GIR_RootConstrainSelectedInstOperands,
     /*  780414 */     // GIR_Coverage, 14850,
     /*  780414 */     GIR_EraseRootFromParent_Done,
     /*  780415 */   // Label 12145: @780415
     /*  780415 */   GIM_Try, /*On fail goto*//*Label 12146*/ GIMT_Encode4(780493), // Rule ID 14851 //
     /*  780420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  780431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  780434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  780437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780466 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  780466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  780469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780488 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780491 */     GIR_RootConstrainSelectedInstOperands,
     /*  780492 */     // GIR_Coverage, 14851,
     /*  780492 */     GIR_EraseRootFromParent_Done,
     /*  780493 */   // Label 12146: @780493
     /*  780493 */   GIM_Try, /*On fail goto*//*Label 12147*/ GIMT_Encode4(780571), // Rule ID 14854 //
     /*  780498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  780509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  780512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  780515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780544 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  780547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780569 */     GIR_RootConstrainSelectedInstOperands,
     /*  780570 */     // GIR_Coverage, 14854,
     /*  780570 */     GIR_EraseRootFromParent_Done,
     /*  780571 */   // Label 12147: @780571
     /*  780571 */   GIM_Try, /*On fail goto*//*Label 12148*/ GIMT_Encode4(780649), // Rule ID 14855 //
     /*  780576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  780587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  780590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  780593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780622 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  780622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  780625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780647 */     GIR_RootConstrainSelectedInstOperands,
     /*  780648 */     // GIR_Coverage, 14855,
     /*  780648 */     GIR_EraseRootFromParent_Done,
     /*  780649 */   // Label 12148: @780649
     /*  780649 */   GIM_Try, /*On fail goto*//*Label 12149*/ GIMT_Encode4(780727), // Rule ID 14858 //
     /*  780654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  780665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  780668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  780671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780700 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  780703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780725 */     GIR_RootConstrainSelectedInstOperands,
     /*  780726 */     // GIR_Coverage, 14858,
     /*  780726 */     GIR_EraseRootFromParent_Done,
     /*  780727 */   // Label 12149: @780727
     /*  780727 */   GIM_Try, /*On fail goto*//*Label 12150*/ GIMT_Encode4(780805), // Rule ID 14859 //
     /*  780732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  780743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  780746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  780749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780778 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  780778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  780781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780803 */     GIR_RootConstrainSelectedInstOperands,
     /*  780804 */     // GIR_Coverage, 14859,
     /*  780804 */     GIR_EraseRootFromParent_Done,
     /*  780805 */   // Label 12150: @780805
     /*  780805 */   GIM_Try, /*On fail goto*//*Label 12151*/ GIMT_Encode4(780883), // Rule ID 14862 //
     /*  780810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  780821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  780824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  780827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780856 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  780856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  780859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780881 */     GIR_RootConstrainSelectedInstOperands,
     /*  780882 */     // GIR_Coverage, 14862,
     /*  780882 */     GIR_EraseRootFromParent_Done,
     /*  780883 */   // Label 12151: @780883
     /*  780883 */   GIM_Try, /*On fail goto*//*Label 12152*/ GIMT_Encode4(780961), // Rule ID 14863 //
     /*  780888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  780899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  780902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  780905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780934 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  780934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  780937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780959 */     GIR_RootConstrainSelectedInstOperands,
     /*  780960 */     // GIR_Coverage, 14863,
     /*  780960 */     GIR_EraseRootFromParent_Done,
     /*  780961 */   // Label 12152: @780961
     /*  780961 */   GIM_Try, /*On fail goto*//*Label 12153*/ GIMT_Encode4(781039), // Rule ID 14866 //
     /*  780966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  780977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  780980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  780983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781012 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781037 */     GIR_RootConstrainSelectedInstOperands,
     /*  781038 */     // GIR_Coverage, 14866,
     /*  781038 */     GIR_EraseRootFromParent_Done,
     /*  781039 */   // Label 12153: @781039
     /*  781039 */   GIM_Try, /*On fail goto*//*Label 12154*/ GIMT_Encode4(781117), // Rule ID 14867 //
     /*  781044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  781055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  781058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  781061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781090 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781115 */     GIR_RootConstrainSelectedInstOperands,
     /*  781116 */     // GIR_Coverage, 14867,
     /*  781116 */     GIR_EraseRootFromParent_Done,
     /*  781117 */   // Label 12154: @781117
     /*  781117 */   GIM_Try, /*On fail goto*//*Label 12155*/ GIMT_Encode4(781195), // Rule ID 14870 //
     /*  781122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  781168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781193 */     GIR_RootConstrainSelectedInstOperands,
     /*  781194 */     // GIR_Coverage, 14870,
     /*  781194 */     GIR_EraseRootFromParent_Done,
     /*  781195 */   // Label 12155: @781195
     /*  781195 */   GIM_Try, /*On fail goto*//*Label 12156*/ GIMT_Encode4(781273), // Rule ID 14871 //
     /*  781200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  781246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781271 */     GIR_RootConstrainSelectedInstOperands,
     /*  781272 */     // GIR_Coverage, 14871,
     /*  781272 */     GIR_EraseRootFromParent_Done,
     /*  781273 */   // Label 12156: @781273
     /*  781273 */   GIM_Try, /*On fail goto*//*Label 12157*/ GIMT_Encode4(781351), // Rule ID 14874 //
     /*  781278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  781289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  781292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  781295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781324 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781349 */     GIR_RootConstrainSelectedInstOperands,
     /*  781350 */     // GIR_Coverage, 14874,
     /*  781350 */     GIR_EraseRootFromParent_Done,
     /*  781351 */   // Label 12157: @781351
     /*  781351 */   GIM_Try, /*On fail goto*//*Label 12158*/ GIMT_Encode4(781429), // Rule ID 14875 //
     /*  781356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  781367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  781370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  781373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781402 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11631:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781427 */     GIR_RootConstrainSelectedInstOperands,
     /*  781428 */     // GIR_Coverage, 14875,
     /*  781428 */     GIR_EraseRootFromParent_Done,
     /*  781429 */   // Label 12158: @781429
     /*  781429 */   GIM_Try, /*On fail goto*//*Label 12159*/ GIMT_Encode4(781507), // Rule ID 14878 //
     /*  781434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  781445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  781448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  781451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781480 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781505 */     GIR_RootConstrainSelectedInstOperands,
     /*  781506 */     // GIR_Coverage, 14878,
     /*  781506 */     GIR_EraseRootFromParent_Done,
     /*  781507 */   // Label 12159: @781507
     /*  781507 */   GIM_Try, /*On fail goto*//*Label 12160*/ GIMT_Encode4(781585), // Rule ID 14879 //
     /*  781512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  781523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  781526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  781529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781583 */     GIR_RootConstrainSelectedInstOperands,
     /*  781584 */     // GIR_Coverage, 14879,
     /*  781584 */     GIR_EraseRootFromParent_Done,
     /*  781585 */   // Label 12160: @781585
     /*  781585 */   GIM_Try, /*On fail goto*//*Label 12161*/ GIMT_Encode4(781663), // Rule ID 14882 //
     /*  781590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  781601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  781604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  781607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781636 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  781636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781658 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781661 */     GIR_RootConstrainSelectedInstOperands,
     /*  781662 */     // GIR_Coverage, 14882,
     /*  781662 */     GIR_EraseRootFromParent_Done,
     /*  781663 */   // Label 12161: @781663
     /*  781663 */   GIM_Try, /*On fail goto*//*Label 12162*/ GIMT_Encode4(781741), // Rule ID 14883 //
     /*  781668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  781679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  781682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  781685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781714 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  781714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781739 */     GIR_RootConstrainSelectedInstOperands,
     /*  781740 */     // GIR_Coverage, 14883,
     /*  781740 */     GIR_EraseRootFromParent_Done,
     /*  781741 */   // Label 12162: @781741
     /*  781741 */   GIM_Try, /*On fail goto*//*Label 12163*/ GIMT_Encode4(781819), // Rule ID 14886 //
     /*  781746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  781749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  781757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  781760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  781763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781792 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  781792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  781811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781817 */     GIR_RootConstrainSelectedInstOperands,
     /*  781818 */     // GIR_Coverage, 14886,
     /*  781818 */     GIR_EraseRootFromParent_Done,
     /*  781819 */   // Label 12163: @781819
     /*  781819 */   GIM_Try, /*On fail goto*//*Label 12164*/ GIMT_Encode4(781897), // Rule ID 14887 //
     /*  781824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  781827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  781835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  781838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  781841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781870 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  781870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  781889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781895 */     GIR_RootConstrainSelectedInstOperands,
     /*  781896 */     // GIR_Coverage, 14887,
     /*  781896 */     GIR_EraseRootFromParent_Done,
     /*  781897 */   // Label 12164: @781897
     /*  781897 */   GIM_Try, /*On fail goto*//*Label 12165*/ GIMT_Encode4(781975), // Rule ID 14890 //
     /*  781902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  781913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  781916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  781919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  781951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781973 */     GIR_RootConstrainSelectedInstOperands,
     /*  781974 */     // GIR_Coverage, 14890,
     /*  781974 */     GIR_EraseRootFromParent_Done,
     /*  781975 */   // Label 12165: @781975
     /*  781975 */   GIM_Try, /*On fail goto*//*Label 12166*/ GIMT_Encode4(782053), // Rule ID 14891 //
     /*  781980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  781991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  781994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  781997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782048 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782051 */     GIR_RootConstrainSelectedInstOperands,
     /*  782052 */     // GIR_Coverage, 14891,
     /*  782052 */     GIR_EraseRootFromParent_Done,
     /*  782053 */   // Label 12166: @782053
     /*  782053 */   GIM_Try, /*On fail goto*//*Label 12167*/ GIMT_Encode4(782131), // Rule ID 14894 //
     /*  782058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  782069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  782072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  782075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782104 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782129 */     GIR_RootConstrainSelectedInstOperands,
     /*  782130 */     // GIR_Coverage, 14894,
     /*  782130 */     GIR_EraseRootFromParent_Done,
     /*  782131 */   // Label 12167: @782131
     /*  782131 */   GIM_Try, /*On fail goto*//*Label 12168*/ GIMT_Encode4(782209), // Rule ID 14895 //
     /*  782136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  782147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  782150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  782153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782182 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782207 */     GIR_RootConstrainSelectedInstOperands,
     /*  782208 */     // GIR_Coverage, 14895,
     /*  782208 */     GIR_EraseRootFromParent_Done,
     /*  782209 */   // Label 12168: @782209
     /*  782209 */   GIM_Try, /*On fail goto*//*Label 12169*/ GIMT_Encode4(782287), // Rule ID 14898 //
     /*  782214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  782225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  782228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  782231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782260 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782285 */     GIR_RootConstrainSelectedInstOperands,
     /*  782286 */     // GIR_Coverage, 14898,
     /*  782286 */     GIR_EraseRootFromParent_Done,
     /*  782287 */   // Label 12169: @782287
     /*  782287 */   GIM_Try, /*On fail goto*//*Label 12170*/ GIMT_Encode4(782365), // Rule ID 14899 //
     /*  782292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  782303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  782306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  782309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782338 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782363 */     GIR_RootConstrainSelectedInstOperands,
     /*  782364 */     // GIR_Coverage, 14899,
     /*  782364 */     GIR_EraseRootFromParent_Done,
     /*  782365 */   // Label 12170: @782365
     /*  782365 */   GIM_Try, /*On fail goto*//*Label 12171*/ GIMT_Encode4(782443), // Rule ID 14902 //
     /*  782370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  782381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  782384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  782387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782416 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782441 */     GIR_RootConstrainSelectedInstOperands,
     /*  782442 */     // GIR_Coverage, 14902,
     /*  782442 */     GIR_EraseRootFromParent_Done,
     /*  782443 */   // Label 12171: @782443
     /*  782443 */   GIM_Try, /*On fail goto*//*Label 12172*/ GIMT_Encode4(782521), // Rule ID 14903 //
     /*  782448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  782459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  782462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  782465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782519 */     GIR_RootConstrainSelectedInstOperands,
     /*  782520 */     // GIR_Coverage, 14903,
     /*  782520 */     GIR_EraseRootFromParent_Done,
     /*  782521 */   // Label 12172: @782521
     /*  782521 */   GIM_Try, /*On fail goto*//*Label 12173*/ GIMT_Encode4(782599), // Rule ID 14906 //
     /*  782526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  782537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  782540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  782543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782572 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782594 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782597 */     GIR_RootConstrainSelectedInstOperands,
     /*  782598 */     // GIR_Coverage, 14906,
     /*  782598 */     GIR_EraseRootFromParent_Done,
     /*  782599 */   // Label 12173: @782599
     /*  782599 */   GIM_Try, /*On fail goto*//*Label 12174*/ GIMT_Encode4(782677), // Rule ID 14907 //
     /*  782604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  782615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  782618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  782621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782650 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782675 */     GIR_RootConstrainSelectedInstOperands,
     /*  782676 */     // GIR_Coverage, 14907,
     /*  782676 */     GIR_EraseRootFromParent_Done,
     /*  782677 */   // Label 12174: @782677
     /*  782677 */   GIM_Try, /*On fail goto*//*Label 12175*/ GIMT_Encode4(782755), // Rule ID 14910 //
     /*  782682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  782693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  782696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  782699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782728 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782753 */     GIR_RootConstrainSelectedInstOperands,
     /*  782754 */     // GIR_Coverage, 14910,
     /*  782754 */     GIR_EraseRootFromParent_Done,
     /*  782755 */   // Label 12175: @782755
     /*  782755 */   GIM_Try, /*On fail goto*//*Label 12176*/ GIMT_Encode4(782833), // Rule ID 14911 //
     /*  782760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  782771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  782774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  782777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782806 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782831 */     GIR_RootConstrainSelectedInstOperands,
     /*  782832 */     // GIR_Coverage, 14911,
     /*  782832 */     GIR_EraseRootFromParent_Done,
     /*  782833 */   // Label 12176: @782833
     /*  782833 */   GIM_Try, /*On fail goto*//*Label 12177*/ GIMT_Encode4(782911), // Rule ID 14914 //
     /*  782838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  782849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  782852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  782855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782884 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  782884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782909 */     GIR_RootConstrainSelectedInstOperands,
     /*  782910 */     // GIR_Coverage, 14914,
     /*  782910 */     GIR_EraseRootFromParent_Done,
     /*  782911 */   // Label 12177: @782911
     /*  782911 */   GIM_Try, /*On fail goto*//*Label 12178*/ GIMT_Encode4(782989), // Rule ID 14915 //
     /*  782916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  782927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  782930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  782933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782962 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  782962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782987 */     GIR_RootConstrainSelectedInstOperands,
     /*  782988 */     // GIR_Coverage, 14915,
     /*  782988 */     GIR_EraseRootFromParent_Done,
     /*  782989 */   // Label 12178: @782989
     /*  782989 */   GIM_Try, /*On fail goto*//*Label 12179*/ GIMT_Encode4(783067), // Rule ID 14918 //
     /*  782994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  783005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  783008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  783011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783040 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783065 */     GIR_RootConstrainSelectedInstOperands,
     /*  783066 */     // GIR_Coverage, 14918,
     /*  783066 */     GIR_EraseRootFromParent_Done,
     /*  783067 */   // Label 12179: @783067
     /*  783067 */   GIM_Try, /*On fail goto*//*Label 12180*/ GIMT_Encode4(783145), // Rule ID 14919 //
     /*  783072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  783083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  783086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  783089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783143 */     GIR_RootConstrainSelectedInstOperands,
     /*  783144 */     // GIR_Coverage, 14919,
     /*  783144 */     GIR_EraseRootFromParent_Done,
     /*  783145 */   // Label 12180: @783145
     /*  783145 */   GIM_Try, /*On fail goto*//*Label 12181*/ GIMT_Encode4(783223), // Rule ID 14922 //
     /*  783150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  783161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  783164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  783167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783221 */     GIR_RootConstrainSelectedInstOperands,
     /*  783222 */     // GIR_Coverage, 14922,
     /*  783222 */     GIR_EraseRootFromParent_Done,
     /*  783223 */   // Label 12181: @783223
     /*  783223 */   GIM_Try, /*On fail goto*//*Label 12182*/ GIMT_Encode4(783301), // Rule ID 14923 //
     /*  783228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  783239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  783242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  783245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783274 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783299 */     GIR_RootConstrainSelectedInstOperands,
     /*  783300 */     // GIR_Coverage, 14923,
     /*  783300 */     GIR_EraseRootFromParent_Done,
     /*  783301 */   // Label 12182: @783301
     /*  783301 */   GIM_Try, /*On fail goto*//*Label 12183*/ GIMT_Encode4(783379), // Rule ID 14926 //
     /*  783306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  783317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  783320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  783323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783352 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  783355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783377 */     GIR_RootConstrainSelectedInstOperands,
     /*  783378 */     // GIR_Coverage, 14926,
     /*  783378 */     GIR_EraseRootFromParent_Done,
     /*  783379 */   // Label 12183: @783379
     /*  783379 */   GIM_Try, /*On fail goto*//*Label 12184*/ GIMT_Encode4(783457), // Rule ID 14927 //
     /*  783384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  783395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  783398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  783401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783430 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  783433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783455 */     GIR_RootConstrainSelectedInstOperands,
     /*  783456 */     // GIR_Coverage, 14927,
     /*  783456 */     GIR_EraseRootFromParent_Done,
     /*  783457 */   // Label 12184: @783457
     /*  783457 */   GIM_Try, /*On fail goto*//*Label 12185*/ GIMT_Encode4(783535), // Rule ID 14930 //
     /*  783462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  783473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  783476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  783479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783508 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783533 */     GIR_RootConstrainSelectedInstOperands,
     /*  783534 */     // GIR_Coverage, 14930,
     /*  783534 */     GIR_EraseRootFromParent_Done,
     /*  783535 */   // Label 12185: @783535
     /*  783535 */   GIM_Try, /*On fail goto*//*Label 12186*/ GIMT_Encode4(783613), // Rule ID 14931 //
     /*  783540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  783551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  783554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  783557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783586 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783611 */     GIR_RootConstrainSelectedInstOperands,
     /*  783612 */     // GIR_Coverage, 14931,
     /*  783612 */     GIR_EraseRootFromParent_Done,
     /*  783613 */   // Label 12186: @783613
     /*  783613 */   GIM_Try, /*On fail goto*//*Label 12187*/ GIMT_Encode4(783691), // Rule ID 14934 //
     /*  783618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  783629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  783632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  783635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783664 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783689 */     GIR_RootConstrainSelectedInstOperands,
     /*  783690 */     // GIR_Coverage, 14934,
     /*  783690 */     GIR_EraseRootFromParent_Done,
     /*  783691 */   // Label 12187: @783691
     /*  783691 */   GIM_Try, /*On fail goto*//*Label 12188*/ GIMT_Encode4(783769), // Rule ID 14935 //
     /*  783696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  783707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  783710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  783713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783742 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783767 */     GIR_RootConstrainSelectedInstOperands,
     /*  783768 */     // GIR_Coverage, 14935,
     /*  783768 */     GIR_EraseRootFromParent_Done,
     /*  783769 */   // Label 12188: @783769
     /*  783769 */   GIM_Try, /*On fail goto*//*Label 12189*/ GIMT_Encode4(783844), // Rule ID 19176 //
     /*  783774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  783777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  783785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  783788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  783791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  783794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783820 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  783820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  783823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783842 */     GIR_RootConstrainSelectedInstOperands,
     /*  783843 */     // GIR_Coverage, 19176,
     /*  783843 */     GIR_EraseRootFromParent_Done,
     /*  783844 */   // Label 12189: @783844
     /*  783844 */   GIM_Try, /*On fail goto*//*Label 12190*/ GIMT_Encode4(783919), // Rule ID 19177 //
     /*  783849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  783852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  783860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  783863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  783866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  783869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783895 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  783895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  783898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783917 */     GIR_RootConstrainSelectedInstOperands,
     /*  783918 */     // GIR_Coverage, 19177,
     /*  783918 */     GIR_EraseRootFromParent_Done,
     /*  783919 */   // Label 12190: @783919
     /*  783919 */   GIM_Try, /*On fail goto*//*Label 12191*/ GIMT_Encode4(783994), // Rule ID 19180 //
     /*  783924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  783927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  783935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  783938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  783941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  783944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783970 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  783970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  783973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783992 */     GIR_RootConstrainSelectedInstOperands,
     /*  783993 */     // GIR_Coverage, 19180,
     /*  783993 */     GIR_EraseRootFromParent_Done,
     /*  783994 */   // Label 12191: @783994
     /*  783994 */   GIM_Try, /*On fail goto*//*Label 12192*/ GIMT_Encode4(784069), // Rule ID 19181 //
     /*  783999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  784010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  784013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  784016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  784019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784045 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  784048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784067 */     GIR_RootConstrainSelectedInstOperands,
     /*  784068 */     // GIR_Coverage, 19181,
     /*  784068 */     GIR_EraseRootFromParent_Done,
     /*  784069 */   // Label 12192: @784069
     /*  784069 */   GIM_Try, /*On fail goto*//*Label 12193*/ GIMT_Encode4(784144), // Rule ID 19184 //
     /*  784074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  784077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  784085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  784088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  784091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  784094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784120 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  784120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  784123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784142 */     GIR_RootConstrainSelectedInstOperands,
     /*  784143 */     // GIR_Coverage, 19184,
     /*  784143 */     GIR_EraseRootFromParent_Done,
     /*  784144 */   // Label 12193: @784144
     /*  784144 */   GIM_Try, /*On fail goto*//*Label 12194*/ GIMT_Encode4(784219), // Rule ID 19185 //
     /*  784149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  784152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  784160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  784163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  784166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  784169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784195 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  784195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  784198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784217 */     GIR_RootConstrainSelectedInstOperands,
     /*  784218 */     // GIR_Coverage, 19185,
     /*  784218 */     GIR_EraseRootFromParent_Done,
     /*  784219 */   // Label 12194: @784219
     /*  784219 */   GIM_Try, /*On fail goto*//*Label 12195*/ GIMT_Encode4(784294), // Rule ID 19188 //
     /*  784224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  784235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  784238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  784241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  784244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784270 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  784273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784292 */     GIR_RootConstrainSelectedInstOperands,
     /*  784293 */     // GIR_Coverage, 19188,
     /*  784293 */     GIR_EraseRootFromParent_Done,
     /*  784294 */   // Label 12195: @784294
     /*  784294 */   GIM_Try, /*On fail goto*//*Label 12196*/ GIMT_Encode4(784369), // Rule ID 19189 //
     /*  784299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  784310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  784313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  784316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  784319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784345 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  784348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784367 */     GIR_RootConstrainSelectedInstOperands,
     /*  784368 */     // GIR_Coverage, 19189,
     /*  784368 */     GIR_EraseRootFromParent_Done,
     /*  784369 */   // Label 12196: @784369
     /*  784369 */   GIM_Try, /*On fail goto*//*Label 12197*/ GIMT_Encode4(784444), // Rule ID 19192 //
     /*  784374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  784377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  784385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  784388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  784391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  784394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784420 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  784420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  784423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784442 */     GIR_RootConstrainSelectedInstOperands,
     /*  784443 */     // GIR_Coverage, 19192,
     /*  784443 */     GIR_EraseRootFromParent_Done,
     /*  784444 */   // Label 12197: @784444
     /*  784444 */   GIM_Try, /*On fail goto*//*Label 12198*/ GIMT_Encode4(784519), // Rule ID 19193 //
     /*  784449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  784452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  784460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  784463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  784466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  784469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784495 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  784495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  784498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784517 */     GIR_RootConstrainSelectedInstOperands,
     /*  784518 */     // GIR_Coverage, 19193,
     /*  784518 */     GIR_EraseRootFromParent_Done,
     /*  784519 */   // Label 12198: @784519
     /*  784519 */   GIM_Try, /*On fail goto*//*Label 12199*/ GIMT_Encode4(784594), // Rule ID 19196 //
     /*  784524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  784527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  784535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  784538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  784541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  784544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784570 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  784570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  784573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784592 */     GIR_RootConstrainSelectedInstOperands,
     /*  784593 */     // GIR_Coverage, 19196,
     /*  784593 */     GIR_EraseRootFromParent_Done,
     /*  784594 */   // Label 12199: @784594
     /*  784594 */   GIM_Try, /*On fail goto*//*Label 12200*/ GIMT_Encode4(784669), // Rule ID 19197 //
     /*  784599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  784602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  784610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  784613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  784616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  784619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784645 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  784645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  784648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784667 */     GIR_RootConstrainSelectedInstOperands,
     /*  784668 */     // GIR_Coverage, 19197,
     /*  784668 */     GIR_EraseRootFromParent_Done,
     /*  784669 */   // Label 12200: @784669
     /*  784669 */   GIM_Try, /*On fail goto*//*Label 12201*/ GIMT_Encode4(784744), // Rule ID 19200 //
     /*  784674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  784685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  784688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  784691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  784694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784720 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  784723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784742 */     GIR_RootConstrainSelectedInstOperands,
     /*  784743 */     // GIR_Coverage, 19200,
     /*  784743 */     GIR_EraseRootFromParent_Done,
     /*  784744 */   // Label 12201: @784744
     /*  784744 */   GIM_Try, /*On fail goto*//*Label 12202*/ GIMT_Encode4(784819), // Rule ID 19201 //
     /*  784749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  784760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  784763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  784766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  784769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784795 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  784798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784817 */     GIR_RootConstrainSelectedInstOperands,
     /*  784818 */     // GIR_Coverage, 19201,
     /*  784818 */     GIR_EraseRootFromParent_Done,
     /*  784819 */   // Label 12202: @784819
     /*  784819 */   GIM_Try, /*On fail goto*//*Label 12203*/ GIMT_Encode4(784894), // Rule ID 19204 //
     /*  784824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  784835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  784838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  784841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  784844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784870 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  784873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784892 */     GIR_RootConstrainSelectedInstOperands,
     /*  784893 */     // GIR_Coverage, 19204,
     /*  784893 */     GIR_EraseRootFromParent_Done,
     /*  784894 */   // Label 12203: @784894
     /*  784894 */   GIM_Try, /*On fail goto*//*Label 12204*/ GIMT_Encode4(784969), // Rule ID 19205 //
     /*  784899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  784910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  784913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  784916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  784919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784945 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  784948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784967 */     GIR_RootConstrainSelectedInstOperands,
     /*  784968 */     // GIR_Coverage, 19205,
     /*  784968 */     GIR_EraseRootFromParent_Done,
     /*  784969 */   // Label 12204: @784969
     /*  784969 */   GIM_Try, /*On fail goto*//*Label 12205*/ GIMT_Encode4(785044), // Rule ID 19208 //
     /*  784974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  784985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  784988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  784991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  784994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785020 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  785023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785042 */     GIR_RootConstrainSelectedInstOperands,
     /*  785043 */     // GIR_Coverage, 19208,
     /*  785043 */     GIR_EraseRootFromParent_Done,
     /*  785044 */   // Label 12205: @785044
     /*  785044 */   GIM_Try, /*On fail goto*//*Label 12206*/ GIMT_Encode4(785119), // Rule ID 19209 //
     /*  785049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  785052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  785060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  785063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  785066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  785069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785095 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  785098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785117 */     GIR_RootConstrainSelectedInstOperands,
     /*  785118 */     // GIR_Coverage, 19209,
     /*  785118 */     GIR_EraseRootFromParent_Done,
     /*  785119 */   // Label 12206: @785119
     /*  785119 */   GIM_Try, /*On fail goto*//*Label 12207*/ GIMT_Encode4(785194), // Rule ID 19212 //
     /*  785124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  785127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  785135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  785138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  785141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  785144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785170 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  785173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785192 */     GIR_RootConstrainSelectedInstOperands,
     /*  785193 */     // GIR_Coverage, 19212,
     /*  785193 */     GIR_EraseRootFromParent_Done,
     /*  785194 */   // Label 12207: @785194
     /*  785194 */   GIM_Try, /*On fail goto*//*Label 12208*/ GIMT_Encode4(785269), // Rule ID 19213 //
     /*  785199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  785202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  785210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  785213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  785216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  785219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785245 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  785248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785267 */     GIR_RootConstrainSelectedInstOperands,
     /*  785268 */     // GIR_Coverage, 19213,
     /*  785268 */     GIR_EraseRootFromParent_Done,
     /*  785269 */   // Label 12208: @785269
     /*  785269 */   GIM_Try, /*On fail goto*//*Label 12209*/ GIMT_Encode4(785344), // Rule ID 19216 //
     /*  785274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  785277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  785285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  785288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  785291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  785294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785320 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  785323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785342 */     GIR_RootConstrainSelectedInstOperands,
     /*  785343 */     // GIR_Coverage, 19216,
     /*  785343 */     GIR_EraseRootFromParent_Done,
     /*  785344 */   // Label 12209: @785344
     /*  785344 */   GIM_Try, /*On fail goto*//*Label 12210*/ GIMT_Encode4(785419), // Rule ID 19217 //
     /*  785349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  785352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  785360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  785363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  785366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  785369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785395 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  785398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785417 */     GIR_RootConstrainSelectedInstOperands,
     /*  785418 */     // GIR_Coverage, 19217,
     /*  785418 */     GIR_EraseRootFromParent_Done,
     /*  785419 */   // Label 12210: @785419
     /*  785419 */   GIM_Try, /*On fail goto*//*Label 12211*/ GIMT_Encode4(785494), // Rule ID 19220 //
     /*  785424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  785427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  785435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  785438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  785441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  785444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785470 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  785473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785492 */     GIR_RootConstrainSelectedInstOperands,
     /*  785493 */     // GIR_Coverage, 19220,
     /*  785493 */     GIR_EraseRootFromParent_Done,
     /*  785494 */   // Label 12211: @785494
     /*  785494 */   GIM_Try, /*On fail goto*//*Label 12212*/ GIMT_Encode4(785569), // Rule ID 19221 //
     /*  785499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  785502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  785510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  785513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  785516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  785519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785545 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  785548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785567 */     GIR_RootConstrainSelectedInstOperands,
     /*  785568 */     // GIR_Coverage, 19221,
     /*  785568 */     GIR_EraseRootFromParent_Done,
     /*  785569 */   // Label 12212: @785569
     /*  785569 */   GIM_Try, /*On fail goto*//*Label 12213*/ GIMT_Encode4(785644), // Rule ID 19224 //
     /*  785574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  785577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  785585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  785588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  785591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  785594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785620 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  785620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  785623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785642 */     GIR_RootConstrainSelectedInstOperands,
     /*  785643 */     // GIR_Coverage, 19224,
     /*  785643 */     GIR_EraseRootFromParent_Done,
     /*  785644 */   // Label 12213: @785644
     /*  785644 */   GIM_Try, /*On fail goto*//*Label 12214*/ GIMT_Encode4(785719), // Rule ID 19225 //
     /*  785649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  785652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  785660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  785663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  785666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  785669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785695 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  785695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  785698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785717 */     GIR_RootConstrainSelectedInstOperands,
     /*  785718 */     // GIR_Coverage, 19225,
     /*  785718 */     GIR_EraseRootFromParent_Done,
     /*  785719 */   // Label 12214: @785719
     /*  785719 */   GIM_Try, /*On fail goto*//*Label 12215*/ GIMT_Encode4(785794), // Rule ID 19228 //
     /*  785724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  785727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  785735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  785738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  785741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  785744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785770 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  785770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  785773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785792 */     GIR_RootConstrainSelectedInstOperands,
     /*  785793 */     // GIR_Coverage, 19228,
     /*  785793 */     GIR_EraseRootFromParent_Done,
     /*  785794 */   // Label 12215: @785794
     /*  785794 */   GIM_Try, /*On fail goto*//*Label 12216*/ GIMT_Encode4(785869), // Rule ID 19229 //
     /*  785799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  785802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  785810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  785813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  785816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  785819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785845 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  785845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  785848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785867 */     GIR_RootConstrainSelectedInstOperands,
     /*  785868 */     // GIR_Coverage, 19229,
     /*  785868 */     GIR_EraseRootFromParent_Done,
     /*  785869 */   // Label 12216: @785869
     /*  785869 */   GIM_Try, /*On fail goto*//*Label 12217*/ GIMT_Encode4(785944), // Rule ID 19232 //
     /*  785874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  785877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  785885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  785888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  785891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  785894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785920 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  785920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  785923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785942 */     GIR_RootConstrainSelectedInstOperands,
     /*  785943 */     // GIR_Coverage, 19232,
     /*  785943 */     GIR_EraseRootFromParent_Done,
     /*  785944 */   // Label 12217: @785944
     /*  785944 */   GIM_Try, /*On fail goto*//*Label 12218*/ GIMT_Encode4(786019), // Rule ID 19233 //
     /*  785949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  785952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  785960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  785963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  785966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  785969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785995 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  785995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  785998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786017 */     GIR_RootConstrainSelectedInstOperands,
     /*  786018 */     // GIR_Coverage, 19233,
     /*  786018 */     GIR_EraseRootFromParent_Done,
     /*  786019 */   // Label 12218: @786019
     /*  786019 */   GIM_Try, /*On fail goto*//*Label 12219*/ GIMT_Encode4(786094), // Rule ID 19236 //
     /*  786024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  786035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  786038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  786041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786070 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  786073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786092 */     GIR_RootConstrainSelectedInstOperands,
     /*  786093 */     // GIR_Coverage, 19236,
     /*  786093 */     GIR_EraseRootFromParent_Done,
     /*  786094 */   // Label 12219: @786094
     /*  786094 */   GIM_Try, /*On fail goto*//*Label 12220*/ GIMT_Encode4(786169), // Rule ID 19237 //
     /*  786099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  786110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  786113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  786116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786145 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  786148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786167 */     GIR_RootConstrainSelectedInstOperands,
     /*  786168 */     // GIR_Coverage, 19237,
     /*  786168 */     GIR_EraseRootFromParent_Done,
     /*  786169 */   // Label 12220: @786169
     /*  786169 */   GIM_Try, /*On fail goto*//*Label 12221*/ GIMT_Encode4(786244), // Rule ID 19240 //
     /*  786174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  786185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  786188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  786191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786220 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  786223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786242 */     GIR_RootConstrainSelectedInstOperands,
     /*  786243 */     // GIR_Coverage, 19240,
     /*  786243 */     GIR_EraseRootFromParent_Done,
     /*  786244 */   // Label 12221: @786244
     /*  786244 */   GIM_Try, /*On fail goto*//*Label 12222*/ GIMT_Encode4(786319), // Rule ID 19241 //
     /*  786249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  786260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  786263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  786266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786295 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  786298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786317 */     GIR_RootConstrainSelectedInstOperands,
     /*  786318 */     // GIR_Coverage, 19241,
     /*  786318 */     GIR_EraseRootFromParent_Done,
     /*  786319 */   // Label 12222: @786319
     /*  786319 */   GIM_Try, /*On fail goto*//*Label 12223*/ GIMT_Encode4(786394), // Rule ID 19244 //
     /*  786324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  786327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  786335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  786338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  786341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786370 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  786370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  786373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786392 */     GIR_RootConstrainSelectedInstOperands,
     /*  786393 */     // GIR_Coverage, 19244,
     /*  786393 */     GIR_EraseRootFromParent_Done,
     /*  786394 */   // Label 12223: @786394
     /*  786394 */   GIM_Try, /*On fail goto*//*Label 12224*/ GIMT_Encode4(786469), // Rule ID 19245 //
     /*  786399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  786402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  786410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  786413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  786416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786445 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  786448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786467 */     GIR_RootConstrainSelectedInstOperands,
     /*  786468 */     // GIR_Coverage, 19245,
     /*  786468 */     GIR_EraseRootFromParent_Done,
     /*  786469 */   // Label 12224: @786469
     /*  786469 */   GIM_Try, /*On fail goto*//*Label 12225*/ GIMT_Encode4(786544), // Rule ID 19248 //
     /*  786474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  786485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  786488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  786491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786520 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  786523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786542 */     GIR_RootConstrainSelectedInstOperands,
     /*  786543 */     // GIR_Coverage, 19248,
     /*  786543 */     GIR_EraseRootFromParent_Done,
     /*  786544 */   // Label 12225: @786544
     /*  786544 */   GIM_Try, /*On fail goto*//*Label 12226*/ GIMT_Encode4(786619), // Rule ID 19249 //
     /*  786549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  786560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  786563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  786566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786595 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  786598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786617 */     GIR_RootConstrainSelectedInstOperands,
     /*  786618 */     // GIR_Coverage, 19249,
     /*  786618 */     GIR_EraseRootFromParent_Done,
     /*  786619 */   // Label 12226: @786619
     /*  786619 */   GIM_Try, /*On fail goto*//*Label 12227*/ GIMT_Encode4(786694), // Rule ID 19252 //
     /*  786624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  786627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  786635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  786638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  786641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786670 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  786670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  786673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786692 */     GIR_RootConstrainSelectedInstOperands,
     /*  786693 */     // GIR_Coverage, 19252,
     /*  786693 */     GIR_EraseRootFromParent_Done,
     /*  786694 */   // Label 12227: @786694
     /*  786694 */   GIM_Try, /*On fail goto*//*Label 12228*/ GIMT_Encode4(786769), // Rule ID 19253 //
     /*  786699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  786702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  786710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  786713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  786716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786745 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  786748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786767 */     GIR_RootConstrainSelectedInstOperands,
     /*  786768 */     // GIR_Coverage, 19253,
     /*  786768 */     GIR_EraseRootFromParent_Done,
     /*  786769 */   // Label 12228: @786769
     /*  786769 */   GIM_Try, /*On fail goto*//*Label 12229*/ GIMT_Encode4(786844), // Rule ID 19256 //
     /*  786774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  786777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  786785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  786788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  786791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  786813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786820 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  786820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  786823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786842 */     GIR_RootConstrainSelectedInstOperands,
     /*  786843 */     // GIR_Coverage, 19256,
     /*  786843 */     GIR_EraseRootFromParent_Done,
     /*  786844 */   // Label 12229: @786844
     /*  786844 */   GIM_Try, /*On fail goto*//*Label 12230*/ GIMT_Encode4(786919), // Rule ID 19257 //
     /*  786849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  786852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  786860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  786863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  786866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  786888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786895 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  786895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  786898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786917 */     GIR_RootConstrainSelectedInstOperands,
     /*  786918 */     // GIR_Coverage, 19257,
     /*  786918 */     GIR_EraseRootFromParent_Done,
     /*  786919 */   // Label 12230: @786919
     /*  786919 */   GIM_Try, /*On fail goto*//*Label 12231*/ GIMT_Encode4(786994), // Rule ID 19260 //
     /*  786924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  786935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  786938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  786941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786970 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  786973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786992 */     GIR_RootConstrainSelectedInstOperands,
     /*  786993 */     // GIR_Coverage, 19260,
     /*  786993 */     GIR_EraseRootFromParent_Done,
     /*  786994 */   // Label 12231: @786994
     /*  786994 */   GIM_Try, /*On fail goto*//*Label 12232*/ GIMT_Encode4(787069), // Rule ID 19261 //
     /*  786999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  787010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  787013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  787016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787045 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  787048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787067 */     GIR_RootConstrainSelectedInstOperands,
     /*  787068 */     // GIR_Coverage, 19261,
     /*  787068 */     GIR_EraseRootFromParent_Done,
     /*  787069 */   // Label 12232: @787069
     /*  787069 */   GIM_Try, /*On fail goto*//*Label 12233*/ GIMT_Encode4(787144), // Rule ID 19264 //
     /*  787074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  787085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  787088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  787091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787120 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  787123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787142 */     GIR_RootConstrainSelectedInstOperands,
     /*  787143 */     // GIR_Coverage, 19264,
     /*  787143 */     GIR_EraseRootFromParent_Done,
     /*  787144 */   // Label 12233: @787144
     /*  787144 */   GIM_Try, /*On fail goto*//*Label 12234*/ GIMT_Encode4(787219), // Rule ID 19265 //
     /*  787149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  787160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  787163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  787166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787195 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  787198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787217 */     GIR_RootConstrainSelectedInstOperands,
     /*  787218 */     // GIR_Coverage, 19265,
     /*  787218 */     GIR_EraseRootFromParent_Done,
     /*  787219 */   // Label 12234: @787219
     /*  787219 */   GIM_Try, /*On fail goto*//*Label 12235*/ GIMT_Encode4(787294), // Rule ID 19268 //
     /*  787224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  787235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  787238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  787241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787270 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  787273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787292 */     GIR_RootConstrainSelectedInstOperands,
     /*  787293 */     // GIR_Coverage, 19268,
     /*  787293 */     GIR_EraseRootFromParent_Done,
     /*  787294 */   // Label 12235: @787294
     /*  787294 */   GIM_Try, /*On fail goto*//*Label 12236*/ GIMT_Encode4(787369), // Rule ID 19269 //
     /*  787299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  787310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  787313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  787316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787345 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  787348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787367 */     GIR_RootConstrainSelectedInstOperands,
     /*  787368 */     // GIR_Coverage, 19269,
     /*  787368 */     GIR_EraseRootFromParent_Done,
     /*  787369 */   // Label 12236: @787369
     /*  787369 */   GIM_Try, /*On fail goto*//*Label 12237*/ GIMT_Encode4(787444), // Rule ID 19272 //
     /*  787374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  787385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  787388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  787391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787420 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  787423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787442 */     GIR_RootConstrainSelectedInstOperands,
     /*  787443 */     // GIR_Coverage, 19272,
     /*  787443 */     GIR_EraseRootFromParent_Done,
     /*  787444 */   // Label 12237: @787444
     /*  787444 */   GIM_Try, /*On fail goto*//*Label 12238*/ GIMT_Encode4(787519), // Rule ID 19273 //
     /*  787449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  787460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  787463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  787466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787495 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  787498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787517 */     GIR_RootConstrainSelectedInstOperands,
     /*  787518 */     // GIR_Coverage, 19273,
     /*  787518 */     GIR_EraseRootFromParent_Done,
     /*  787519 */   // Label 12238: @787519
     /*  787519 */   GIM_Try, /*On fail goto*//*Label 12239*/ GIMT_Encode4(787594), // Rule ID 19276 //
     /*  787524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  787535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  787538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  787541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787570 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  787573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787592 */     GIR_RootConstrainSelectedInstOperands,
     /*  787593 */     // GIR_Coverage, 19276,
     /*  787593 */     GIR_EraseRootFromParent_Done,
     /*  787594 */   // Label 12239: @787594
     /*  787594 */   GIM_Try, /*On fail goto*//*Label 12240*/ GIMT_Encode4(787669), // Rule ID 19277 //
     /*  787599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  787610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  787613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  787616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787645 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  787648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787667 */     GIR_RootConstrainSelectedInstOperands,
     /*  787668 */     // GIR_Coverage, 19277,
     /*  787668 */     GIR_EraseRootFromParent_Done,
     /*  787669 */   // Label 12240: @787669
     /*  787669 */   GIM_Try, /*On fail goto*//*Label 12241*/ GIMT_Encode4(787744), // Rule ID 19280 //
     /*  787674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  787685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  787688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  787691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787720 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  787723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787742 */     GIR_RootConstrainSelectedInstOperands,
     /*  787743 */     // GIR_Coverage, 19280,
     /*  787743 */     GIR_EraseRootFromParent_Done,
     /*  787744 */   // Label 12241: @787744
     /*  787744 */   GIM_Try, /*On fail goto*//*Label 12242*/ GIMT_Encode4(787819), // Rule ID 19281 //
     /*  787749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  787760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  787763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  787766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787795 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  787798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787817 */     GIR_RootConstrainSelectedInstOperands,
     /*  787818 */     // GIR_Coverage, 19281,
     /*  787818 */     GIR_EraseRootFromParent_Done,
     /*  787819 */   // Label 12242: @787819
     /*  787819 */   GIM_Try, /*On fail goto*//*Label 12243*/ GIMT_Encode4(787894), // Rule ID 19284 //
     /*  787824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  787827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  787835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  787838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  787841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787870 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  787870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  787873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787892 */     GIR_RootConstrainSelectedInstOperands,
     /*  787893 */     // GIR_Coverage, 19284,
     /*  787893 */     GIR_EraseRootFromParent_Done,
     /*  787894 */   // Label 12243: @787894
     /*  787894 */   GIM_Try, /*On fail goto*//*Label 12244*/ GIMT_Encode4(787969), // Rule ID 19285 //
     /*  787899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  787902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  787910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  787913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  787916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787945 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  787945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  787948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787967 */     GIR_RootConstrainSelectedInstOperands,
     /*  787968 */     // GIR_Coverage, 19285,
     /*  787968 */     GIR_EraseRootFromParent_Done,
     /*  787969 */   // Label 12244: @787969
     /*  787969 */   GIM_Try, /*On fail goto*//*Label 12245*/ GIMT_Encode4(788044), // Rule ID 19288 //
     /*  787974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  787977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  787985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  787988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  787991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788020 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  788023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788042 */     GIR_RootConstrainSelectedInstOperands,
     /*  788043 */     // GIR_Coverage, 19288,
     /*  788043 */     GIR_EraseRootFromParent_Done,
     /*  788044 */   // Label 12245: @788044
     /*  788044 */   GIM_Try, /*On fail goto*//*Label 12246*/ GIMT_Encode4(788119), // Rule ID 19289 //
     /*  788049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  788052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  788060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  788063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  788066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788095 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  788098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788117 */     GIR_RootConstrainSelectedInstOperands,
     /*  788118 */     // GIR_Coverage, 19289,
     /*  788118 */     GIR_EraseRootFromParent_Done,
     /*  788119 */   // Label 12246: @788119
     /*  788119 */   GIM_Try, /*On fail goto*//*Label 12247*/ GIMT_Encode4(788194), // Rule ID 19292 //
     /*  788124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  788127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  788135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  788138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  788141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788170 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  788173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788192 */     GIR_RootConstrainSelectedInstOperands,
     /*  788193 */     // GIR_Coverage, 19292,
     /*  788193 */     GIR_EraseRootFromParent_Done,
     /*  788194 */   // Label 12247: @788194
     /*  788194 */   GIM_Try, /*On fail goto*//*Label 12248*/ GIMT_Encode4(788269), // Rule ID 19293 //
     /*  788199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  788202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  788210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  788213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  788216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788245 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  788248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788267 */     GIR_RootConstrainSelectedInstOperands,
     /*  788268 */     // GIR_Coverage, 19293,
     /*  788268 */     GIR_EraseRootFromParent_Done,
     /*  788269 */   // Label 12248: @788269
     /*  788269 */   GIM_Try, /*On fail goto*//*Label 12249*/ GIMT_Encode4(788344), // Rule ID 19296 //
     /*  788274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  788285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  788288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  788291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  788294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788320 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  788323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788342 */     GIR_RootConstrainSelectedInstOperands,
     /*  788343 */     // GIR_Coverage, 19296,
     /*  788343 */     GIR_EraseRootFromParent_Done,
     /*  788344 */   // Label 12249: @788344
     /*  788344 */   GIM_Try, /*On fail goto*//*Label 12250*/ GIMT_Encode4(788419), // Rule ID 19297 //
     /*  788349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  788360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  788363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  788366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  788369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788395 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  788398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788417 */     GIR_RootConstrainSelectedInstOperands,
     /*  788418 */     // GIR_Coverage, 19297,
     /*  788418 */     GIR_EraseRootFromParent_Done,
     /*  788419 */   // Label 12250: @788419
     /*  788419 */   GIM_Try, /*On fail goto*//*Label 12251*/ GIMT_Encode4(788494), // Rule ID 19300 //
     /*  788424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  788435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  788438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  788441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  788444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788470 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  788473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788492 */     GIR_RootConstrainSelectedInstOperands,
     /*  788493 */     // GIR_Coverage, 19300,
     /*  788493 */     GIR_EraseRootFromParent_Done,
     /*  788494 */   // Label 12251: @788494
     /*  788494 */   GIM_Try, /*On fail goto*//*Label 12252*/ GIMT_Encode4(788569), // Rule ID 19301 //
     /*  788499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  788510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  788513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  788516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  788519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788545 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  788548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788567 */     GIR_RootConstrainSelectedInstOperands,
     /*  788568 */     // GIR_Coverage, 19301,
     /*  788568 */     GIR_EraseRootFromParent_Done,
     /*  788569 */   // Label 12252: @788569
     /*  788569 */   GIM_Try, /*On fail goto*//*Label 12253*/ GIMT_Encode4(788644), // Rule ID 19304 //
     /*  788574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  788577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  788585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  788588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  788591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  788594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788620 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  788623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788642 */     GIR_RootConstrainSelectedInstOperands,
     /*  788643 */     // GIR_Coverage, 19304,
     /*  788643 */     GIR_EraseRootFromParent_Done,
     /*  788644 */   // Label 12253: @788644
     /*  788644 */   GIM_Try, /*On fail goto*//*Label 12254*/ GIMT_Encode4(788719), // Rule ID 19305 //
     /*  788649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  788652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  788660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  788663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  788666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  788669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788695 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  788698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788717 */     GIR_RootConstrainSelectedInstOperands,
     /*  788718 */     // GIR_Coverage, 19305,
     /*  788718 */     GIR_EraseRootFromParent_Done,
     /*  788719 */   // Label 12254: @788719
     /*  788719 */   GIM_Try, /*On fail goto*//*Label 12255*/ GIMT_Encode4(788794), // Rule ID 19308 //
     /*  788724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  788735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  788738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  788741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  788744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788770 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  788773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788792 */     GIR_RootConstrainSelectedInstOperands,
     /*  788793 */     // GIR_Coverage, 19308,
     /*  788793 */     GIR_EraseRootFromParent_Done,
     /*  788794 */   // Label 12255: @788794
     /*  788794 */   GIM_Try, /*On fail goto*//*Label 12256*/ GIMT_Encode4(788869), // Rule ID 19309 //
     /*  788799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  788810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  788813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  788816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  788819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788845 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  788848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788867 */     GIR_RootConstrainSelectedInstOperands,
     /*  788868 */     // GIR_Coverage, 19309,
     /*  788868 */     GIR_EraseRootFromParent_Done,
     /*  788869 */   // Label 12256: @788869
     /*  788869 */   GIM_Try, /*On fail goto*//*Label 12257*/ GIMT_Encode4(788944), // Rule ID 19312 //
     /*  788874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  788877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  788885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  788888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  788891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  788894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788920 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  788923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788942 */     GIR_RootConstrainSelectedInstOperands,
     /*  788943 */     // GIR_Coverage, 19312,
     /*  788943 */     GIR_EraseRootFromParent_Done,
     /*  788944 */   // Label 12257: @788944
     /*  788944 */   GIM_Try, /*On fail goto*//*Label 12258*/ GIMT_Encode4(789019), // Rule ID 19313 //
     /*  788949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  788952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  788960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  788963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  788966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  788969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788995 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  788998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789017 */     GIR_RootConstrainSelectedInstOperands,
     /*  789018 */     // GIR_Coverage, 19313,
     /*  789018 */     GIR_EraseRootFromParent_Done,
     /*  789019 */   // Label 12258: @789019
     /*  789019 */   GIM_Try, /*On fail goto*//*Label 12259*/ GIMT_Encode4(789094), // Rule ID 19316 //
     /*  789024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  789027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  789035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  789038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  789041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  789044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789070 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  789073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789092 */     GIR_RootConstrainSelectedInstOperands,
     /*  789093 */     // GIR_Coverage, 19316,
     /*  789093 */     GIR_EraseRootFromParent_Done,
     /*  789094 */   // Label 12259: @789094
     /*  789094 */   GIM_Try, /*On fail goto*//*Label 12260*/ GIMT_Encode4(789169), // Rule ID 19317 //
     /*  789099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  789102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  789110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  789113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  789116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  789119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789145 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  789148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789167 */     GIR_RootConstrainSelectedInstOperands,
     /*  789168 */     // GIR_Coverage, 19317,
     /*  789168 */     GIR_EraseRootFromParent_Done,
     /*  789169 */   // Label 12260: @789169
     /*  789169 */   GIM_Try, /*On fail goto*//*Label 12261*/ GIMT_Encode4(789244), // Rule ID 19320 //
     /*  789174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  789185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  789188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  789191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  789194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789220 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  789223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789242 */     GIR_RootConstrainSelectedInstOperands,
     /*  789243 */     // GIR_Coverage, 19320,
     /*  789243 */     GIR_EraseRootFromParent_Done,
     /*  789244 */   // Label 12261: @789244
     /*  789244 */   GIM_Try, /*On fail goto*//*Label 12262*/ GIMT_Encode4(789319), // Rule ID 19321 //
     /*  789249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  789260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  789263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  789266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  789269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789295 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  789298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789317 */     GIR_RootConstrainSelectedInstOperands,
     /*  789318 */     // GIR_Coverage, 19321,
     /*  789318 */     GIR_EraseRootFromParent_Done,
     /*  789319 */   // Label 12262: @789319
     /*  789319 */   GIM_Try, /*On fail goto*//*Label 12263*/ GIMT_Encode4(789394), // Rule ID 19324 //
     /*  789324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  789335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  789338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  789341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  789344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789370 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  789373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789392 */     GIR_RootConstrainSelectedInstOperands,
     /*  789393 */     // GIR_Coverage, 19324,
     /*  789393 */     GIR_EraseRootFromParent_Done,
     /*  789394 */   // Label 12263: @789394
     /*  789394 */   GIM_Try, /*On fail goto*//*Label 12264*/ GIMT_Encode4(789469), // Rule ID 19325 //
     /*  789399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  789410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  789413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  789416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  789419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789445 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  789448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789467 */     GIR_RootConstrainSelectedInstOperands,
     /*  789468 */     // GIR_Coverage, 19325,
     /*  789468 */     GIR_EraseRootFromParent_Done,
     /*  789469 */   // Label 12264: @789469
     /*  789469 */   GIM_Try, /*On fail goto*//*Label 12265*/ GIMT_Encode4(789544), // Rule ID 19328 //
     /*  789474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  789485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  789488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  789491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  789494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789520 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  789523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789542 */     GIR_RootConstrainSelectedInstOperands,
     /*  789543 */     // GIR_Coverage, 19328,
     /*  789543 */     GIR_EraseRootFromParent_Done,
     /*  789544 */   // Label 12265: @789544
     /*  789544 */   GIM_Try, /*On fail goto*//*Label 12266*/ GIMT_Encode4(789619), // Rule ID 19329 //
     /*  789549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  789560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  789563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  789566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  789569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789595 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  789598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789617 */     GIR_RootConstrainSelectedInstOperands,
     /*  789618 */     // GIR_Coverage, 19329,
     /*  789618 */     GIR_EraseRootFromParent_Done,
     /*  789619 */   // Label 12266: @789619
     /*  789619 */   GIM_Try, /*On fail goto*//*Label 12267*/ GIMT_Encode4(789694), // Rule ID 19332 //
     /*  789624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  789635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  789638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  789641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  789644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789670 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  789673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789692 */     GIR_RootConstrainSelectedInstOperands,
     /*  789693 */     // GIR_Coverage, 19332,
     /*  789693 */     GIR_EraseRootFromParent_Done,
     /*  789694 */   // Label 12267: @789694
     /*  789694 */   GIM_Try, /*On fail goto*//*Label 12268*/ GIMT_Encode4(789769), // Rule ID 19333 //
     /*  789699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  789710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  789713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  789716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  789719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789745 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  789748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789767 */     GIR_RootConstrainSelectedInstOperands,
     /*  789768 */     // GIR_Coverage, 19333,
     /*  789768 */     GIR_EraseRootFromParent_Done,
     /*  789769 */   // Label 12268: @789769
     /*  789769 */   GIM_Try, /*On fail goto*//*Label 12269*/ GIMT_Encode4(789844), // Rule ID 19336 //
     /*  789774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  789785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  789788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  789791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  789794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789820 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  789823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789842 */     GIR_RootConstrainSelectedInstOperands,
     /*  789843 */     // GIR_Coverage, 19336,
     /*  789843 */     GIR_EraseRootFromParent_Done,
     /*  789844 */   // Label 12269: @789844
     /*  789844 */   GIM_Try, /*On fail goto*//*Label 12270*/ GIMT_Encode4(789919), // Rule ID 19337 //
     /*  789849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  789860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  789863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  789866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  789869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789895 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  789898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789917 */     GIR_RootConstrainSelectedInstOperands,
     /*  789918 */     // GIR_Coverage, 19337,
     /*  789918 */     GIR_EraseRootFromParent_Done,
     /*  789919 */   // Label 12270: @789919
     /*  789919 */   GIM_Try, /*On fail goto*//*Label 12271*/ GIMT_Encode4(789994), // Rule ID 19340 //
     /*  789924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  789935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  789938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  789941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  789944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789970 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  789973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789992 */     GIR_RootConstrainSelectedInstOperands,
     /*  789993 */     // GIR_Coverage, 19340,
     /*  789993 */     GIR_EraseRootFromParent_Done,
     /*  789994 */   // Label 12271: @789994
     /*  789994 */   GIM_Try, /*On fail goto*//*Label 12272*/ GIMT_Encode4(790069), // Rule ID 19341 //
     /*  789999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  790010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  790013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  790016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  790019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790045 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  790048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790067 */     GIR_RootConstrainSelectedInstOperands,
     /*  790068 */     // GIR_Coverage, 19341,
     /*  790068 */     GIR_EraseRootFromParent_Done,
     /*  790069 */   // Label 12272: @790069
     /*  790069 */   GIM_Try, /*On fail goto*//*Label 12273*/ GIMT_Encode4(790144), // Rule ID 19344 //
     /*  790074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  790085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  790088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  790091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  790094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790120 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  790123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790142 */     GIR_RootConstrainSelectedInstOperands,
     /*  790143 */     // GIR_Coverage, 19344,
     /*  790143 */     GIR_EraseRootFromParent_Done,
     /*  790144 */   // Label 12273: @790144
     /*  790144 */   GIM_Try, /*On fail goto*//*Label 12274*/ GIMT_Encode4(790219), // Rule ID 19345 //
     /*  790149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  790160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  790163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  790166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  790169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790195 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  790198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790217 */     GIR_RootConstrainSelectedInstOperands,
     /*  790218 */     // GIR_Coverage, 19345,
     /*  790218 */     GIR_EraseRootFromParent_Done,
     /*  790219 */   // Label 12274: @790219
     /*  790219 */   GIM_Try, /*On fail goto*//*Label 12275*/ GIMT_Encode4(790294), // Rule ID 19348 //
     /*  790224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  790235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  790238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  790241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  790244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790270 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  790273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790292 */     GIR_RootConstrainSelectedInstOperands,
     /*  790293 */     // GIR_Coverage, 19348,
     /*  790293 */     GIR_EraseRootFromParent_Done,
     /*  790294 */   // Label 12275: @790294
     /*  790294 */   GIM_Try, /*On fail goto*//*Label 12276*/ GIMT_Encode4(790369), // Rule ID 19349 //
     /*  790299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  790310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  790313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  790316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  790319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790345 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  790348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790367 */     GIR_RootConstrainSelectedInstOperands,
     /*  790368 */     // GIR_Coverage, 19349,
     /*  790368 */     GIR_EraseRootFromParent_Done,
     /*  790369 */   // Label 12276: @790369
     /*  790369 */   GIM_Try, /*On fail goto*//*Label 12277*/ GIMT_Encode4(790444), // Rule ID 19352 //
     /*  790374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  790385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  790388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  790391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  790394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790420 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  790423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790442 */     GIR_RootConstrainSelectedInstOperands,
     /*  790443 */     // GIR_Coverage, 19352,
     /*  790443 */     GIR_EraseRootFromParent_Done,
     /*  790444 */   // Label 12277: @790444
     /*  790444 */   GIM_Try, /*On fail goto*//*Label 12278*/ GIMT_Encode4(790519), // Rule ID 19353 //
     /*  790449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  790460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  790463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  790466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  790469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790495 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  790498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790517 */     GIR_RootConstrainSelectedInstOperands,
     /*  790518 */     // GIR_Coverage, 19353,
     /*  790518 */     GIR_EraseRootFromParent_Done,
     /*  790519 */   // Label 12278: @790519
     /*  790519 */   GIM_Try, /*On fail goto*//*Label 12279*/ GIMT_Encode4(790594), // Rule ID 19356 //
     /*  790524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  790535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  790538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  790541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790570 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  790573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790592 */     GIR_RootConstrainSelectedInstOperands,
     /*  790593 */     // GIR_Coverage, 19356,
     /*  790593 */     GIR_EraseRootFromParent_Done,
     /*  790594 */   // Label 12279: @790594
     /*  790594 */   GIM_Try, /*On fail goto*//*Label 12280*/ GIMT_Encode4(790669), // Rule ID 19357 //
     /*  790599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  790610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  790613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  790616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790645 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  790648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790667 */     GIR_RootConstrainSelectedInstOperands,
     /*  790668 */     // GIR_Coverage, 19357,
     /*  790668 */     GIR_EraseRootFromParent_Done,
     /*  790669 */   // Label 12280: @790669
     /*  790669 */   GIM_Try, /*On fail goto*//*Label 12281*/ GIMT_Encode4(790744), // Rule ID 19360 //
     /*  790674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  790685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  790688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  790691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790720 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  790723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790742 */     GIR_RootConstrainSelectedInstOperands,
     /*  790743 */     // GIR_Coverage, 19360,
     /*  790743 */     GIR_EraseRootFromParent_Done,
     /*  790744 */   // Label 12281: @790744
     /*  790744 */   GIM_Try, /*On fail goto*//*Label 12282*/ GIMT_Encode4(790819), // Rule ID 19361 //
     /*  790749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  790760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  790763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  790766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790795 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  790798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790817 */     GIR_RootConstrainSelectedInstOperands,
     /*  790818 */     // GIR_Coverage, 19361,
     /*  790818 */     GIR_EraseRootFromParent_Done,
     /*  790819 */   // Label 12282: @790819
     /*  790819 */   GIM_Try, /*On fail goto*//*Label 12283*/ GIMT_Encode4(790894), // Rule ID 19364 //
     /*  790824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  790835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  790838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  790841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790870 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  790873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790892 */     GIR_RootConstrainSelectedInstOperands,
     /*  790893 */     // GIR_Coverage, 19364,
     /*  790893 */     GIR_EraseRootFromParent_Done,
     /*  790894 */   // Label 12283: @790894
     /*  790894 */   GIM_Try, /*On fail goto*//*Label 12284*/ GIMT_Encode4(790969), // Rule ID 19365 //
     /*  790899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  790910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  790913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  790916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790945 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  790948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790967 */     GIR_RootConstrainSelectedInstOperands,
     /*  790968 */     // GIR_Coverage, 19365,
     /*  790968 */     GIR_EraseRootFromParent_Done,
     /*  790969 */   // Label 12284: @790969
     /*  790969 */   GIM_Try, /*On fail goto*//*Label 12285*/ GIMT_Encode4(791044), // Rule ID 19368 //
     /*  790974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  790985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  790988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  790991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791020 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  791023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791042 */     GIR_RootConstrainSelectedInstOperands,
     /*  791043 */     // GIR_Coverage, 19368,
     /*  791043 */     GIR_EraseRootFromParent_Done,
     /*  791044 */   // Label 12285: @791044
     /*  791044 */   GIM_Try, /*On fail goto*//*Label 12286*/ GIMT_Encode4(791119), // Rule ID 19369 //
     /*  791049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  791060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  791063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  791066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791095 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  791098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791117 */     GIR_RootConstrainSelectedInstOperands,
     /*  791118 */     // GIR_Coverage, 19369,
     /*  791118 */     GIR_EraseRootFromParent_Done,
     /*  791119 */   // Label 12286: @791119
     /*  791119 */   GIM_Try, /*On fail goto*//*Label 12287*/ GIMT_Encode4(791194), // Rule ID 19372 //
     /*  791124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  791135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  791138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  791141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791170 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  791173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791192 */     GIR_RootConstrainSelectedInstOperands,
     /*  791193 */     // GIR_Coverage, 19372,
     /*  791193 */     GIR_EraseRootFromParent_Done,
     /*  791194 */   // Label 12287: @791194
     /*  791194 */   GIM_Try, /*On fail goto*//*Label 12288*/ GIMT_Encode4(791269), // Rule ID 19373 //
     /*  791199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  791210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  791213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  791216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791245 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  791248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791267 */     GIR_RootConstrainSelectedInstOperands,
     /*  791268 */     // GIR_Coverage, 19373,
     /*  791268 */     GIR_EraseRootFromParent_Done,
     /*  791269 */   // Label 12288: @791269
     /*  791269 */   GIM_Try, /*On fail goto*//*Label 12289*/ GIMT_Encode4(791344), // Rule ID 19376 //
     /*  791274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  791277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  791285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  791288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  791291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791320 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  791320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  791323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791342 */     GIR_RootConstrainSelectedInstOperands,
     /*  791343 */     // GIR_Coverage, 19376,
     /*  791343 */     GIR_EraseRootFromParent_Done,
     /*  791344 */   // Label 12289: @791344
     /*  791344 */   GIM_Try, /*On fail goto*//*Label 12290*/ GIMT_Encode4(791419), // Rule ID 19377 //
     /*  791349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  791352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  791360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  791363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  791366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791395 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  791395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  791398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791417 */     GIR_RootConstrainSelectedInstOperands,
     /*  791418 */     // GIR_Coverage, 19377,
     /*  791418 */     GIR_EraseRootFromParent_Done,
     /*  791419 */   // Label 12290: @791419
     /*  791419 */   GIM_Try, /*On fail goto*//*Label 12291*/ GIMT_Encode4(791494), // Rule ID 19380 //
     /*  791424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  791435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  791438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  791441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791470 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  791473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791492 */     GIR_RootConstrainSelectedInstOperands,
     /*  791493 */     // GIR_Coverage, 19380,
     /*  791493 */     GIR_EraseRootFromParent_Done,
     /*  791494 */   // Label 12291: @791494
     /*  791494 */   GIM_Try, /*On fail goto*//*Label 12292*/ GIMT_Encode4(791569), // Rule ID 19381 //
     /*  791499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  791510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  791513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  791516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791545 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  791548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791567 */     GIR_RootConstrainSelectedInstOperands,
     /*  791568 */     // GIR_Coverage, 19381,
     /*  791568 */     GIR_EraseRootFromParent_Done,
     /*  791569 */   // Label 12292: @791569
     /*  791569 */   GIM_Try, /*On fail goto*//*Label 12293*/ GIMT_Encode4(791644), // Rule ID 19384 //
     /*  791574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  791585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  791588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  791591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791620 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  791623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791642 */     GIR_RootConstrainSelectedInstOperands,
     /*  791643 */     // GIR_Coverage, 19384,
     /*  791643 */     GIR_EraseRootFromParent_Done,
     /*  791644 */   // Label 12293: @791644
     /*  791644 */   GIM_Try, /*On fail goto*//*Label 12294*/ GIMT_Encode4(791719), // Rule ID 19385 //
     /*  791649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  791660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  791663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  791666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791695 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  791698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791717 */     GIR_RootConstrainSelectedInstOperands,
     /*  791718 */     // GIR_Coverage, 19385,
     /*  791718 */     GIR_EraseRootFromParent_Done,
     /*  791719 */   // Label 12294: @791719
     /*  791719 */   GIM_Try, /*On fail goto*//*Label 12295*/ GIMT_Encode4(791794), // Rule ID 19388 //
     /*  791724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  791735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  791738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  791741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791770 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  791773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791792 */     GIR_RootConstrainSelectedInstOperands,
     /*  791793 */     // GIR_Coverage, 19388,
     /*  791793 */     GIR_EraseRootFromParent_Done,
     /*  791794 */   // Label 12295: @791794
     /*  791794 */   GIM_Try, /*On fail goto*//*Label 12296*/ GIMT_Encode4(791869), // Rule ID 19389 //
     /*  791799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  791810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  791813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  791816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791845 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  791848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791867 */     GIR_RootConstrainSelectedInstOperands,
     /*  791868 */     // GIR_Coverage, 19389,
     /*  791868 */     GIR_EraseRootFromParent_Done,
     /*  791869 */   // Label 12296: @791869
     /*  791869 */   GIM_Try, /*On fail goto*//*Label 12297*/ GIMT_Encode4(791944), // Rule ID 19392 //
     /*  791874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  791885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  791888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  791891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791920 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  791923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791942 */     GIR_RootConstrainSelectedInstOperands,
     /*  791943 */     // GIR_Coverage, 19392,
     /*  791943 */     GIR_EraseRootFromParent_Done,
     /*  791944 */   // Label 12297: @791944
     /*  791944 */   GIM_Try, /*On fail goto*//*Label 12298*/ GIMT_Encode4(792019), // Rule ID 19393 //
     /*  791949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  791960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  791963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  791966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791995 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  791998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792017 */     GIR_RootConstrainSelectedInstOperands,
     /*  792018 */     // GIR_Coverage, 19393,
     /*  792018 */     GIR_EraseRootFromParent_Done,
     /*  792019 */   // Label 12298: @792019
     /*  792019 */   GIM_Try, /*On fail goto*//*Label 12299*/ GIMT_Encode4(792094), // Rule ID 19396 //
     /*  792024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  792035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  792038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  792041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792070 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  792073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792092 */     GIR_RootConstrainSelectedInstOperands,
     /*  792093 */     // GIR_Coverage, 19396,
     /*  792093 */     GIR_EraseRootFromParent_Done,
     /*  792094 */   // Label 12299: @792094
     /*  792094 */   GIM_Try, /*On fail goto*//*Label 12300*/ GIMT_Encode4(792169), // Rule ID 19397 //
     /*  792099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  792110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  792113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  792116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792145 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  792148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792167 */     GIR_RootConstrainSelectedInstOperands,
     /*  792168 */     // GIR_Coverage, 19397,
     /*  792168 */     GIR_EraseRootFromParent_Done,
     /*  792169 */   // Label 12300: @792169
     /*  792169 */   GIM_Try, /*On fail goto*//*Label 12301*/ GIMT_Encode4(792244), // Rule ID 19400 //
     /*  792174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  792185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  792188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  792191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792220 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  792223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792242 */     GIR_RootConstrainSelectedInstOperands,
     /*  792243 */     // GIR_Coverage, 19400,
     /*  792243 */     GIR_EraseRootFromParent_Done,
     /*  792244 */   // Label 12301: @792244
     /*  792244 */   GIM_Try, /*On fail goto*//*Label 12302*/ GIMT_Encode4(792319), // Rule ID 19401 //
     /*  792249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  792260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  792263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  792266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792295 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  792298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792317 */     GIR_RootConstrainSelectedInstOperands,
     /*  792318 */     // GIR_Coverage, 19401,
     /*  792318 */     GIR_EraseRootFromParent_Done,
     /*  792319 */   // Label 12302: @792319
     /*  792319 */   GIM_Try, /*On fail goto*//*Label 12303*/ GIMT_Encode4(792394), // Rule ID 19404 //
     /*  792324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  792327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  792335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  792338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  792341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792370 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  792373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792392 */     GIR_RootConstrainSelectedInstOperands,
     /*  792393 */     // GIR_Coverage, 19404,
     /*  792393 */     GIR_EraseRootFromParent_Done,
     /*  792394 */   // Label 12303: @792394
     /*  792394 */   GIM_Try, /*On fail goto*//*Label 12304*/ GIMT_Encode4(792469), // Rule ID 19405 //
     /*  792399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  792410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  792413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  792416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792445 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  792448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792467 */     GIR_RootConstrainSelectedInstOperands,
     /*  792468 */     // GIR_Coverage, 19405,
     /*  792468 */     GIR_EraseRootFromParent_Done,
     /*  792469 */   // Label 12304: @792469
     /*  792469 */   GIM_Try, /*On fail goto*//*Label 12305*/ GIMT_Encode4(792544), // Rule ID 19408 //
     /*  792474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  792477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  792485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  792488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  792491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792520 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  792523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792542 */     GIR_RootConstrainSelectedInstOperands,
     /*  792543 */     // GIR_Coverage, 19408,
     /*  792543 */     GIR_EraseRootFromParent_Done,
     /*  792544 */   // Label 12305: @792544
     /*  792544 */   GIM_Try, /*On fail goto*//*Label 12306*/ GIMT_Encode4(792619), // Rule ID 19409 //
     /*  792549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  792560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  792563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  792566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792595 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  792598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792617 */     GIR_RootConstrainSelectedInstOperands,
     /*  792618 */     // GIR_Coverage, 19409,
     /*  792618 */     GIR_EraseRootFromParent_Done,
     /*  792619 */   // Label 12306: @792619
     /*  792619 */   GIM_Try, /*On fail goto*//*Label 12307*/ GIMT_Encode4(792694), // Rule ID 19412 //
     /*  792624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  792627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  792635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  792638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  792641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792670 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  792673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792692 */     GIR_RootConstrainSelectedInstOperands,
     /*  792693 */     // GIR_Coverage, 19412,
     /*  792693 */     GIR_EraseRootFromParent_Done,
     /*  792694 */   // Label 12307: @792694
     /*  792694 */   GIM_Try, /*On fail goto*//*Label 12308*/ GIMT_Encode4(792769), // Rule ID 19413 //
     /*  792699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  792710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  792713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  792716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792745 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  792748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792767 */     GIR_RootConstrainSelectedInstOperands,
     /*  792768 */     // GIR_Coverage, 19413,
     /*  792768 */     GIR_EraseRootFromParent_Done,
     /*  792769 */   // Label 12308: @792769
     /*  792769 */   GIM_Try, /*On fail goto*//*Label 12309*/ GIMT_Encode4(792844), // Rule ID 19416 //
     /*  792774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  792785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  792788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  792791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  792794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792820 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  792823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792842 */     GIR_RootConstrainSelectedInstOperands,
     /*  792843 */     // GIR_Coverage, 19416,
     /*  792843 */     GIR_EraseRootFromParent_Done,
     /*  792844 */   // Label 12309: @792844
     /*  792844 */   GIM_Try, /*On fail goto*//*Label 12310*/ GIMT_Encode4(792919), // Rule ID 19417 //
     /*  792849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  792860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  792863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  792866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  792869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792895 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  792898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792917 */     GIR_RootConstrainSelectedInstOperands,
     /*  792918 */     // GIR_Coverage, 19417,
     /*  792918 */     GIR_EraseRootFromParent_Done,
     /*  792919 */   // Label 12310: @792919
     /*  792919 */   GIM_Try, /*On fail goto*//*Label 12311*/ GIMT_Encode4(792994), // Rule ID 19420 //
     /*  792924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  792935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  792938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  792941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  792944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792970 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  792973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792992 */     GIR_RootConstrainSelectedInstOperands,
     /*  792993 */     // GIR_Coverage, 19420,
     /*  792993 */     GIR_EraseRootFromParent_Done,
     /*  792994 */   // Label 12311: @792994
     /*  792994 */   GIM_Try, /*On fail goto*//*Label 12312*/ GIMT_Encode4(793069), // Rule ID 19421 //
     /*  792999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  793010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  793013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  793016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  793019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793045 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  793048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793067 */     GIR_RootConstrainSelectedInstOperands,
     /*  793068 */     // GIR_Coverage, 19421,
     /*  793068 */     GIR_EraseRootFromParent_Done,
     /*  793069 */   // Label 12312: @793069
     /*  793069 */   GIM_Try, /*On fail goto*//*Label 12313*/ GIMT_Encode4(793144), // Rule ID 19424 //
     /*  793074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  793085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  793088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  793091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  793094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793120 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  793123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793142 */     GIR_RootConstrainSelectedInstOperands,
     /*  793143 */     // GIR_Coverage, 19424,
     /*  793143 */     GIR_EraseRootFromParent_Done,
     /*  793144 */   // Label 12313: @793144
     /*  793144 */   GIM_Try, /*On fail goto*//*Label 12314*/ GIMT_Encode4(793219), // Rule ID 19425 //
     /*  793149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  793160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  793163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  793166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  793169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793195 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  793198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793217 */     GIR_RootConstrainSelectedInstOperands,
     /*  793218 */     // GIR_Coverage, 19425,
     /*  793218 */     GIR_EraseRootFromParent_Done,
     /*  793219 */   // Label 12314: @793219
     /*  793219 */   GIM_Try, /*On fail goto*//*Label 12315*/ GIMT_Encode4(793294), // Rule ID 19428 //
     /*  793224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  793235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  793238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  793241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  793244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793270 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  793273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793292 */     GIR_RootConstrainSelectedInstOperands,
     /*  793293 */     // GIR_Coverage, 19428,
     /*  793293 */     GIR_EraseRootFromParent_Done,
     /*  793294 */   // Label 12315: @793294
     /*  793294 */   GIM_Try, /*On fail goto*//*Label 12316*/ GIMT_Encode4(793369), // Rule ID 19429 //
     /*  793299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  793310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  793313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  793316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  793319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793345 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  793348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793367 */     GIR_RootConstrainSelectedInstOperands,
     /*  793368 */     // GIR_Coverage, 19429,
     /*  793368 */     GIR_EraseRootFromParent_Done,
     /*  793369 */   // Label 12316: @793369
     /*  793369 */   GIM_Try, /*On fail goto*//*Label 12317*/ GIMT_Encode4(793444), // Rule ID 19432 //
     /*  793374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  793385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  793388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  793391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  793394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793420 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  793423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793442 */     GIR_RootConstrainSelectedInstOperands,
     /*  793443 */     // GIR_Coverage, 19432,
     /*  793443 */     GIR_EraseRootFromParent_Done,
     /*  793444 */   // Label 12317: @793444
     /*  793444 */   GIM_Try, /*On fail goto*//*Label 12318*/ GIMT_Encode4(793519), // Rule ID 19433 //
     /*  793449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  793460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  793463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  793466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  793469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793495 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  793498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793517 */     GIR_RootConstrainSelectedInstOperands,
     /*  793518 */     // GIR_Coverage, 19433,
     /*  793518 */     GIR_EraseRootFromParent_Done,
     /*  793519 */   // Label 12318: @793519
     /*  793519 */   GIM_Try, /*On fail goto*//*Label 12319*/ GIMT_Encode4(793594), // Rule ID 19436 //
     /*  793524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  793527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  793535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  793538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  793541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  793544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793570 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  793570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  793573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793592 */     GIR_RootConstrainSelectedInstOperands,
     /*  793593 */     // GIR_Coverage, 19436,
     /*  793593 */     GIR_EraseRootFromParent_Done,
     /*  793594 */   // Label 12319: @793594
     /*  793594 */   GIM_Try, /*On fail goto*//*Label 12320*/ GIMT_Encode4(793669), // Rule ID 19437 //
     /*  793599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  793602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  793610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  793613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  793616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  793619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793645 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  793645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  793648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793667 */     GIR_RootConstrainSelectedInstOperands,
     /*  793668 */     // GIR_Coverage, 19437,
     /*  793668 */     GIR_EraseRootFromParent_Done,
     /*  793669 */   // Label 12320: @793669
     /*  793669 */   GIM_Try, /*On fail goto*//*Label 12321*/ GIMT_Encode4(793744), // Rule ID 19440 //
     /*  793674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  793685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  793688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  793691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  793694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793720 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  793723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793742 */     GIR_RootConstrainSelectedInstOperands,
     /*  793743 */     // GIR_Coverage, 19440,
     /*  793743 */     GIR_EraseRootFromParent_Done,
     /*  793744 */   // Label 12321: @793744
     /*  793744 */   GIM_Try, /*On fail goto*//*Label 12322*/ GIMT_Encode4(793819), // Rule ID 19441 //
     /*  793749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  793760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  793763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  793766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  793769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793795 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  793798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793817 */     GIR_RootConstrainSelectedInstOperands,
     /*  793818 */     // GIR_Coverage, 19441,
     /*  793818 */     GIR_EraseRootFromParent_Done,
     /*  793819 */   // Label 12322: @793819
     /*  793819 */   GIM_Try, /*On fail goto*//*Label 12323*/ GIMT_Encode4(793894), // Rule ID 19444 //
     /*  793824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  793835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  793838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  793841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  793844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793870 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  793873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793892 */     GIR_RootConstrainSelectedInstOperands,
     /*  793893 */     // GIR_Coverage, 19444,
     /*  793893 */     GIR_EraseRootFromParent_Done,
     /*  793894 */   // Label 12323: @793894
     /*  793894 */   GIM_Try, /*On fail goto*//*Label 12324*/ GIMT_Encode4(793969), // Rule ID 19445 //
     /*  793899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  793910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  793913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  793916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  793919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793945 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  793948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793967 */     GIR_RootConstrainSelectedInstOperands,
     /*  793968 */     // GIR_Coverage, 19445,
     /*  793968 */     GIR_EraseRootFromParent_Done,
     /*  793969 */   // Label 12324: @793969
     /*  793969 */   GIM_Try, /*On fail goto*//*Label 12325*/ GIMT_Encode4(794044), // Rule ID 19448 //
     /*  793974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  793985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  793988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  793991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  793994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794020 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  794023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794042 */     GIR_RootConstrainSelectedInstOperands,
     /*  794043 */     // GIR_Coverage, 19448,
     /*  794043 */     GIR_EraseRootFromParent_Done,
     /*  794044 */   // Label 12325: @794044
     /*  794044 */   GIM_Try, /*On fail goto*//*Label 12326*/ GIMT_Encode4(794119), // Rule ID 19449 //
     /*  794049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  794060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  794063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  794066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  794069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794095 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  794098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794117 */     GIR_RootConstrainSelectedInstOperands,
     /*  794118 */     // GIR_Coverage, 19449,
     /*  794118 */     GIR_EraseRootFromParent_Done,
     /*  794119 */   // Label 12326: @794119
     /*  794119 */   GIM_Try, /*On fail goto*//*Label 12327*/ GIMT_Encode4(794194), // Rule ID 19452 //
     /*  794124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  794135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  794138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  794141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  794144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794170 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  794173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794192 */     GIR_RootConstrainSelectedInstOperands,
     /*  794193 */     // GIR_Coverage, 19452,
     /*  794193 */     GIR_EraseRootFromParent_Done,
     /*  794194 */   // Label 12327: @794194
     /*  794194 */   GIM_Try, /*On fail goto*//*Label 12328*/ GIMT_Encode4(794269), // Rule ID 19453 //
     /*  794199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  794210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  794213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  794216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  794219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794245 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  794248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794267 */     GIR_RootConstrainSelectedInstOperands,
     /*  794268 */     // GIR_Coverage, 19453,
     /*  794268 */     GIR_EraseRootFromParent_Done,
     /*  794269 */   // Label 12328: @794269
     /*  794269 */   GIM_Try, /*On fail goto*//*Label 12329*/ GIMT_Encode4(794344), // Rule ID 19456 //
     /*  794274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  794285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  794288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  794291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  794294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794320 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  794323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794342 */     GIR_RootConstrainSelectedInstOperands,
     /*  794343 */     // GIR_Coverage, 19456,
     /*  794343 */     GIR_EraseRootFromParent_Done,
     /*  794344 */   // Label 12329: @794344
     /*  794344 */   GIM_Try, /*On fail goto*//*Label 12330*/ GIMT_Encode4(794419), // Rule ID 19457 //
     /*  794349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  794360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  794363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  794366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  794369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794395 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  794398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794417 */     GIR_RootConstrainSelectedInstOperands,
     /*  794418 */     // GIR_Coverage, 19457,
     /*  794418 */     GIR_EraseRootFromParent_Done,
     /*  794419 */   // Label 12330: @794419
     /*  794419 */   GIM_Try, /*On fail goto*//*Label 12331*/ GIMT_Encode4(794494), // Rule ID 19460 //
     /*  794424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  794435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  794438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  794441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  794444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794470 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  794473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794492 */     GIR_RootConstrainSelectedInstOperands,
     /*  794493 */     // GIR_Coverage, 19460,
     /*  794493 */     GIR_EraseRootFromParent_Done,
     /*  794494 */   // Label 12331: @794494
     /*  794494 */   GIM_Try, /*On fail goto*//*Label 12332*/ GIMT_Encode4(794569), // Rule ID 19461 //
     /*  794499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  794510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  794513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  794516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  794519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794545 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  794548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794567 */     GIR_RootConstrainSelectedInstOperands,
     /*  794568 */     // GIR_Coverage, 19461,
     /*  794568 */     GIR_EraseRootFromParent_Done,
     /*  794569 */   // Label 12332: @794569
     /*  794569 */   GIM_Try, /*On fail goto*//*Label 12333*/ GIMT_Encode4(794644), // Rule ID 19464 //
     /*  794574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  794577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  794585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  794588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  794591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  794594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794620 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  794623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794642 */     GIR_RootConstrainSelectedInstOperands,
     /*  794643 */     // GIR_Coverage, 19464,
     /*  794643 */     GIR_EraseRootFromParent_Done,
     /*  794644 */   // Label 12333: @794644
     /*  794644 */   GIM_Try, /*On fail goto*//*Label 12334*/ GIMT_Encode4(794719), // Rule ID 19465 //
     /*  794649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  794660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  794663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  794666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  794669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794695 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  794698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794717 */     GIR_RootConstrainSelectedInstOperands,
     /*  794718 */     // GIR_Coverage, 19465,
     /*  794718 */     GIR_EraseRootFromParent_Done,
     /*  794719 */   // Label 12334: @794719
     /*  794719 */   GIM_Try, /*On fail goto*//*Label 12335*/ GIMT_Encode4(794794), // Rule ID 19468 //
     /*  794724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  794727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  794735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  794738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  794741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  794744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794770 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  794773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794792 */     GIR_RootConstrainSelectedInstOperands,
     /*  794793 */     // GIR_Coverage, 19468,
     /*  794793 */     GIR_EraseRootFromParent_Done,
     /*  794794 */   // Label 12335: @794794
     /*  794794 */   GIM_Try, /*On fail goto*//*Label 12336*/ GIMT_Encode4(794869), // Rule ID 19469 //
     /*  794799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  794810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  794813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  794816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  794819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794845 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  794848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794867 */     GIR_RootConstrainSelectedInstOperands,
     /*  794868 */     // GIR_Coverage, 19469,
     /*  794868 */     GIR_EraseRootFromParent_Done,
     /*  794869 */   // Label 12336: @794869
     /*  794869 */   GIM_Try, /*On fail goto*//*Label 12337*/ GIMT_Encode4(794944), // Rule ID 19472 //
     /*  794874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  794877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  794885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  794888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  794891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  794894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794920 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  794923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794942 */     GIR_RootConstrainSelectedInstOperands,
     /*  794943 */     // GIR_Coverage, 19472,
     /*  794943 */     GIR_EraseRootFromParent_Done,
     /*  794944 */   // Label 12337: @794944
     /*  794944 */   GIM_Try, /*On fail goto*//*Label 12338*/ GIMT_Encode4(795019), // Rule ID 19473 //
     /*  794949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  794960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  794963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  794966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  794969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794995 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  794998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795017 */     GIR_RootConstrainSelectedInstOperands,
     /*  795018 */     // GIR_Coverage, 19473,
     /*  795018 */     GIR_EraseRootFromParent_Done,
     /*  795019 */   // Label 12338: @795019
     /*  795019 */   GIM_Try, /*On fail goto*//*Label 12339*/ GIMT_Encode4(795094), // Rule ID 19476 //
     /*  795024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  795035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  795038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  795041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795070 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  795073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795092 */     GIR_RootConstrainSelectedInstOperands,
     /*  795093 */     // GIR_Coverage, 19476,
     /*  795093 */     GIR_EraseRootFromParent_Done,
     /*  795094 */   // Label 12339: @795094
     /*  795094 */   GIM_Try, /*On fail goto*//*Label 12340*/ GIMT_Encode4(795169), // Rule ID 19477 //
     /*  795099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  795110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  795113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  795116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795145 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  795148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795167 */     GIR_RootConstrainSelectedInstOperands,
     /*  795168 */     // GIR_Coverage, 19477,
     /*  795168 */     GIR_EraseRootFromParent_Done,
     /*  795169 */   // Label 12340: @795169
     /*  795169 */   GIM_Try, /*On fail goto*//*Label 12341*/ GIMT_Encode4(795244), // Rule ID 19480 //
     /*  795174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  795185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  795188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  795191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795220 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  795223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795242 */     GIR_RootConstrainSelectedInstOperands,
     /*  795243 */     // GIR_Coverage, 19480,
     /*  795243 */     GIR_EraseRootFromParent_Done,
     /*  795244 */   // Label 12341: @795244
     /*  795244 */   GIM_Try, /*On fail goto*//*Label 12342*/ GIMT_Encode4(795319), // Rule ID 19481 //
     /*  795249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  795260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  795263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  795266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795295 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  795298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795317 */     GIR_RootConstrainSelectedInstOperands,
     /*  795318 */     // GIR_Coverage, 19481,
     /*  795318 */     GIR_EraseRootFromParent_Done,
     /*  795319 */   // Label 12342: @795319
     /*  795319 */   GIM_Try, /*On fail goto*//*Label 12343*/ GIMT_Encode4(795394), // Rule ID 19484 //
     /*  795324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  795327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  795335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  795338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  795341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795370 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  795373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795392 */     GIR_RootConstrainSelectedInstOperands,
     /*  795393 */     // GIR_Coverage, 19484,
     /*  795393 */     GIR_EraseRootFromParent_Done,
     /*  795394 */   // Label 12343: @795394
     /*  795394 */   GIM_Try, /*On fail goto*//*Label 12344*/ GIMT_Encode4(795469), // Rule ID 19485 //
     /*  795399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  795410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  795413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  795416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795445 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  795448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795467 */     GIR_RootConstrainSelectedInstOperands,
     /*  795468 */     // GIR_Coverage, 19485,
     /*  795468 */     GIR_EraseRootFromParent_Done,
     /*  795469 */   // Label 12344: @795469
     /*  795469 */   GIM_Try, /*On fail goto*//*Label 12345*/ GIMT_Encode4(795544), // Rule ID 19488 //
     /*  795474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  795485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  795488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  795491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795520 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  795523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795542 */     GIR_RootConstrainSelectedInstOperands,
     /*  795543 */     // GIR_Coverage, 19488,
     /*  795543 */     GIR_EraseRootFromParent_Done,
     /*  795544 */   // Label 12345: @795544
     /*  795544 */   GIM_Try, /*On fail goto*//*Label 12346*/ GIMT_Encode4(795619), // Rule ID 19489 //
     /*  795549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  795560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  795563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  795566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795595 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  795598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795617 */     GIR_RootConstrainSelectedInstOperands,
     /*  795618 */     // GIR_Coverage, 19489,
     /*  795618 */     GIR_EraseRootFromParent_Done,
     /*  795619 */   // Label 12346: @795619
     /*  795619 */   GIM_Try, /*On fail goto*//*Label 12347*/ GIMT_Encode4(795694), // Rule ID 19492 //
     /*  795624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  795627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  795635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  795638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  795641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795670 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  795673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795692 */     GIR_RootConstrainSelectedInstOperands,
     /*  795693 */     // GIR_Coverage, 19492,
     /*  795693 */     GIR_EraseRootFromParent_Done,
     /*  795694 */   // Label 12347: @795694
     /*  795694 */   GIM_Try, /*On fail goto*//*Label 12348*/ GIMT_Encode4(795769), // Rule ID 19493 //
     /*  795699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  795710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  795713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  795716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795745 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  795748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795767 */     GIR_RootConstrainSelectedInstOperands,
     /*  795768 */     // GIR_Coverage, 19493,
     /*  795768 */     GIR_EraseRootFromParent_Done,
     /*  795769 */   // Label 12348: @795769
     /*  795769 */   GIM_Try, /*On fail goto*//*Label 12349*/ GIMT_Encode4(795844), // Rule ID 19496 //
     /*  795774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  795777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  795785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  795788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  795791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  795813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795820 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  795820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  795823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795842 */     GIR_RootConstrainSelectedInstOperands,
     /*  795843 */     // GIR_Coverage, 19496,
     /*  795843 */     GIR_EraseRootFromParent_Done,
     /*  795844 */   // Label 12349: @795844
     /*  795844 */   GIM_Try, /*On fail goto*//*Label 12350*/ GIMT_Encode4(795919), // Rule ID 19497 //
     /*  795849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  795852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  795860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  795863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  795866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  795888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795895 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  795895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  795898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795917 */     GIR_RootConstrainSelectedInstOperands,
     /*  795918 */     // GIR_Coverage, 19497,
     /*  795918 */     GIR_EraseRootFromParent_Done,
     /*  795919 */   // Label 12350: @795919
     /*  795919 */   GIM_Try, /*On fail goto*//*Label 12351*/ GIMT_Encode4(795994), // Rule ID 19500 //
     /*  795924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  795935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  795938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  795941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795970 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  795973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795992 */     GIR_RootConstrainSelectedInstOperands,
     /*  795993 */     // GIR_Coverage, 19500,
     /*  795993 */     GIR_EraseRootFromParent_Done,
     /*  795994 */   // Label 12351: @795994
     /*  795994 */   GIM_Try, /*On fail goto*//*Label 12352*/ GIMT_Encode4(796069), // Rule ID 19501 //
     /*  795999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  796010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  796013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  796016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796045 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  796048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796067 */     GIR_RootConstrainSelectedInstOperands,
     /*  796068 */     // GIR_Coverage, 19501,
     /*  796068 */     GIR_EraseRootFromParent_Done,
     /*  796069 */   // Label 12352: @796069
     /*  796069 */   GIM_Try, /*On fail goto*//*Label 12353*/ GIMT_Encode4(796144), // Rule ID 19504 //
     /*  796074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  796085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  796088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  796091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796120 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  796123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796142 */     GIR_RootConstrainSelectedInstOperands,
     /*  796143 */     // GIR_Coverage, 19504,
     /*  796143 */     GIR_EraseRootFromParent_Done,
     /*  796144 */   // Label 12353: @796144
     /*  796144 */   GIM_Try, /*On fail goto*//*Label 12354*/ GIMT_Encode4(796219), // Rule ID 19505 //
     /*  796149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  796160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  796163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  796166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796195 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  796198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796217 */     GIR_RootConstrainSelectedInstOperands,
     /*  796218 */     // GIR_Coverage, 19505,
     /*  796218 */     GIR_EraseRootFromParent_Done,
     /*  796219 */   // Label 12354: @796219
     /*  796219 */   GIM_Try, /*On fail goto*//*Label 12355*/ GIMT_Encode4(796294), // Rule ID 19508 //
     /*  796224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  796235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  796238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  796241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796270 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  796273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796292 */     GIR_RootConstrainSelectedInstOperands,
     /*  796293 */     // GIR_Coverage, 19508,
     /*  796293 */     GIR_EraseRootFromParent_Done,
     /*  796294 */   // Label 12355: @796294
     /*  796294 */   GIM_Try, /*On fail goto*//*Label 12356*/ GIMT_Encode4(796369), // Rule ID 19509 //
     /*  796299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  796310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  796313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  796316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796345 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  796348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796367 */     GIR_RootConstrainSelectedInstOperands,
     /*  796368 */     // GIR_Coverage, 19509,
     /*  796368 */     GIR_EraseRootFromParent_Done,
     /*  796369 */   // Label 12356: @796369
     /*  796369 */   GIM_Try, /*On fail goto*//*Label 12357*/ GIMT_Encode4(796444), // Rule ID 19512 //
     /*  796374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  796385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  796388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  796391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796420 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  796423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796442 */     GIR_RootConstrainSelectedInstOperands,
     /*  796443 */     // GIR_Coverage, 19512,
     /*  796443 */     GIR_EraseRootFromParent_Done,
     /*  796444 */   // Label 12357: @796444
     /*  796444 */   GIM_Try, /*On fail goto*//*Label 12358*/ GIMT_Encode4(796519), // Rule ID 19513 //
     /*  796449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  796460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  796463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  796466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796495 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  796498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796517 */     GIR_RootConstrainSelectedInstOperands,
     /*  796518 */     // GIR_Coverage, 19513,
     /*  796518 */     GIR_EraseRootFromParent_Done,
     /*  796519 */   // Label 12358: @796519
     /*  796519 */   GIM_Try, /*On fail goto*//*Label 12359*/ GIMT_Encode4(796594), // Rule ID 19516 //
     /*  796524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  796535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  796538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  796541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796570 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  796573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796592 */     GIR_RootConstrainSelectedInstOperands,
     /*  796593 */     // GIR_Coverage, 19516,
     /*  796593 */     GIR_EraseRootFromParent_Done,
     /*  796594 */   // Label 12359: @796594
     /*  796594 */   GIM_Try, /*On fail goto*//*Label 12360*/ GIMT_Encode4(796669), // Rule ID 19517 //
     /*  796599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  796610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  796613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  796616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796645 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  796648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796667 */     GIR_RootConstrainSelectedInstOperands,
     /*  796668 */     // GIR_Coverage, 19517,
     /*  796668 */     GIR_EraseRootFromParent_Done,
     /*  796669 */   // Label 12360: @796669
     /*  796669 */   GIM_Try, /*On fail goto*//*Label 12361*/ GIMT_Encode4(796744), // Rule ID 19520 //
     /*  796674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  796685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  796688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  796691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796720 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  796723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796742 */     GIR_RootConstrainSelectedInstOperands,
     /*  796743 */     // GIR_Coverage, 19520,
     /*  796743 */     GIR_EraseRootFromParent_Done,
     /*  796744 */   // Label 12361: @796744
     /*  796744 */   GIM_Try, /*On fail goto*//*Label 12362*/ GIMT_Encode4(796819), // Rule ID 19521 //
     /*  796749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  796760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  796763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  796766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796795 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  796798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796817 */     GIR_RootConstrainSelectedInstOperands,
     /*  796818 */     // GIR_Coverage, 19521,
     /*  796818 */     GIR_EraseRootFromParent_Done,
     /*  796819 */   // Label 12362: @796819
     /*  796819 */   GIM_Try, /*On fail goto*//*Label 12363*/ GIMT_Encode4(796894), // Rule ID 19524 //
     /*  796824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  796835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  796838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  796841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796870 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  796870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  796873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796892 */     GIR_RootConstrainSelectedInstOperands,
     /*  796893 */     // GIR_Coverage, 19524,
     /*  796893 */     GIR_EraseRootFromParent_Done,
     /*  796894 */   // Label 12363: @796894
     /*  796894 */   GIM_Try, /*On fail goto*//*Label 12364*/ GIMT_Encode4(796969), // Rule ID 19525 //
     /*  796899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  796902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  796910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  796913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  796916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796945 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  796945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  796948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796967 */     GIR_RootConstrainSelectedInstOperands,
     /*  796968 */     // GIR_Coverage, 19525,
     /*  796968 */     GIR_EraseRootFromParent_Done,
     /*  796969 */   // Label 12364: @796969
     /*  796969 */   GIM_Try, /*On fail goto*//*Label 12365*/ GIMT_Encode4(797044), // Rule ID 19528 //
     /*  796974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  796985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  796988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  796991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797020 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  797023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797042 */     GIR_RootConstrainSelectedInstOperands,
     /*  797043 */     // GIR_Coverage, 19528,
     /*  797043 */     GIR_EraseRootFromParent_Done,
     /*  797044 */   // Label 12365: @797044
     /*  797044 */   GIM_Try, /*On fail goto*//*Label 12366*/ GIMT_Encode4(797119), // Rule ID 19529 //
     /*  797049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  797052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  797060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  797063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  797066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797095 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  797098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797117 */     GIR_RootConstrainSelectedInstOperands,
     /*  797118 */     // GIR_Coverage, 19529,
     /*  797118 */     GIR_EraseRootFromParent_Done,
     /*  797119 */   // Label 12366: @797119
     /*  797119 */   GIM_Try, /*On fail goto*//*Label 12367*/ GIMT_Encode4(797194), // Rule ID 19532 //
     /*  797124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  797127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  797135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  797138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  797141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797170 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  797173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797192 */     GIR_RootConstrainSelectedInstOperands,
     /*  797193 */     // GIR_Coverage, 19532,
     /*  797193 */     GIR_EraseRootFromParent_Done,
     /*  797194 */   // Label 12367: @797194
     /*  797194 */   GIM_Try, /*On fail goto*//*Label 12368*/ GIMT_Encode4(797269), // Rule ID 19533 //
     /*  797199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  797202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  797210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  797213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  797216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797245 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  797248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797267 */     GIR_RootConstrainSelectedInstOperands,
     /*  797268 */     // GIR_Coverage, 19533,
     /*  797268 */     GIR_EraseRootFromParent_Done,
     /*  797269 */   // Label 12368: @797269
     /*  797269 */   GIM_Try, /*On fail goto*//*Label 12369*/ GIMT_Encode4(797344), // Rule ID 19536 //
     /*  797274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  797285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  797288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  797291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  797294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797320 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  797323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797342 */     GIR_RootConstrainSelectedInstOperands,
     /*  797343 */     // GIR_Coverage, 19536,
     /*  797343 */     GIR_EraseRootFromParent_Done,
     /*  797344 */   // Label 12369: @797344
     /*  797344 */   GIM_Try, /*On fail goto*//*Label 12370*/ GIMT_Encode4(797419), // Rule ID 19537 //
     /*  797349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  797360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  797363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  797366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  797369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797395 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  797398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797417 */     GIR_RootConstrainSelectedInstOperands,
     /*  797418 */     // GIR_Coverage, 19537,
     /*  797418 */     GIR_EraseRootFromParent_Done,
     /*  797419 */   // Label 12370: @797419
     /*  797419 */   GIM_Try, /*On fail goto*//*Label 12371*/ GIMT_Encode4(797494), // Rule ID 19540 //
     /*  797424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  797435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  797438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  797441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  797444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797470 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  797473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797492 */     GIR_RootConstrainSelectedInstOperands,
     /*  797493 */     // GIR_Coverage, 19540,
     /*  797493 */     GIR_EraseRootFromParent_Done,
     /*  797494 */   // Label 12371: @797494
     /*  797494 */   GIM_Try, /*On fail goto*//*Label 12372*/ GIMT_Encode4(797569), // Rule ID 19541 //
     /*  797499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  797510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  797513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  797516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  797519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797545 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  797548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797567 */     GIR_RootConstrainSelectedInstOperands,
     /*  797568 */     // GIR_Coverage, 19541,
     /*  797568 */     GIR_EraseRootFromParent_Done,
     /*  797569 */   // Label 12372: @797569
     /*  797569 */   GIM_Try, /*On fail goto*//*Label 12373*/ GIMT_Encode4(797644), // Rule ID 19544 //
     /*  797574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  797577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  797585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  797588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  797591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  797594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797620 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  797620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  797623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797642 */     GIR_RootConstrainSelectedInstOperands,
     /*  797643 */     // GIR_Coverage, 19544,
     /*  797643 */     GIR_EraseRootFromParent_Done,
     /*  797644 */   // Label 12373: @797644
     /*  797644 */   GIM_Try, /*On fail goto*//*Label 12374*/ GIMT_Encode4(797719), // Rule ID 19545 //
     /*  797649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  797652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  797660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  797663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  797666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  797669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797695 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  797698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797717 */     GIR_RootConstrainSelectedInstOperands,
     /*  797718 */     // GIR_Coverage, 19545,
     /*  797718 */     GIR_EraseRootFromParent_Done,
     /*  797719 */   // Label 12374: @797719
     /*  797719 */   GIM_Try, /*On fail goto*//*Label 12375*/ GIMT_Encode4(797794), // Rule ID 19548 //
     /*  797724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  797735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  797738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  797741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  797744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797770 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  797773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797792 */     GIR_RootConstrainSelectedInstOperands,
     /*  797793 */     // GIR_Coverage, 19548,
     /*  797793 */     GIR_EraseRootFromParent_Done,
     /*  797794 */   // Label 12375: @797794
     /*  797794 */   GIM_Try, /*On fail goto*//*Label 12376*/ GIMT_Encode4(797869), // Rule ID 19549 //
     /*  797799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  797810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  797813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  797816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  797819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797845 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  797848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797867 */     GIR_RootConstrainSelectedInstOperands,
     /*  797868 */     // GIR_Coverage, 19549,
     /*  797868 */     GIR_EraseRootFromParent_Done,
     /*  797869 */   // Label 12376: @797869
     /*  797869 */   GIM_Try, /*On fail goto*//*Label 12377*/ GIMT_Encode4(797944), // Rule ID 19552 //
     /*  797874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  797877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  797885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  797888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  797891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  797894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797920 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  797920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  797923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797942 */     GIR_RootConstrainSelectedInstOperands,
     /*  797943 */     // GIR_Coverage, 19552,
     /*  797943 */     GIR_EraseRootFromParent_Done,
     /*  797944 */   // Label 12377: @797944
     /*  797944 */   GIM_Try, /*On fail goto*//*Label 12378*/ GIMT_Encode4(798019), // Rule ID 19553 //
     /*  797949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  797952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  797960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  797963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  797966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  797969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797995 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  797998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798017 */     GIR_RootConstrainSelectedInstOperands,
     /*  798018 */     // GIR_Coverage, 19553,
     /*  798018 */     GIR_EraseRootFromParent_Done,
     /*  798019 */   // Label 12378: @798019
     /*  798019 */   GIM_Try, /*On fail goto*//*Label 12379*/ GIMT_Encode4(798094), // Rule ID 19556 //
     /*  798024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  798027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  798035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  798038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  798041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  798044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798070 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  798073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798092 */     GIR_RootConstrainSelectedInstOperands,
     /*  798093 */     // GIR_Coverage, 19556,
     /*  798093 */     GIR_EraseRootFromParent_Done,
     /*  798094 */   // Label 12379: @798094
     /*  798094 */   GIM_Try, /*On fail goto*//*Label 12380*/ GIMT_Encode4(798169), // Rule ID 19557 //
     /*  798099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  798102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  798110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  798113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  798116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  798119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798145 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  798148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798167 */     GIR_RootConstrainSelectedInstOperands,
     /*  798168 */     // GIR_Coverage, 19557,
     /*  798168 */     GIR_EraseRootFromParent_Done,
     /*  798169 */   // Label 12380: @798169
     /*  798169 */   GIM_Try, /*On fail goto*//*Label 12381*/ GIMT_Encode4(798244), // Rule ID 19560 //
     /*  798174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  798185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  798188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  798191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  798194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798220 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  798223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798242 */     GIR_RootConstrainSelectedInstOperands,
     /*  798243 */     // GIR_Coverage, 19560,
     /*  798243 */     GIR_EraseRootFromParent_Done,
     /*  798244 */   // Label 12381: @798244
     /*  798244 */   GIM_Try, /*On fail goto*//*Label 12382*/ GIMT_Encode4(798319), // Rule ID 19561 //
     /*  798249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  798260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  798263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  798266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  798269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798295 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  798298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798317 */     GIR_RootConstrainSelectedInstOperands,
     /*  798318 */     // GIR_Coverage, 19561,
     /*  798318 */     GIR_EraseRootFromParent_Done,
     /*  798319 */   // Label 12382: @798319
     /*  798319 */   GIM_Try, /*On fail goto*//*Label 12383*/ GIMT_Encode4(798394), // Rule ID 19564 //
     /*  798324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  798335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  798338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  798341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  798344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798370 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  798373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798392 */     GIR_RootConstrainSelectedInstOperands,
     /*  798393 */     // GIR_Coverage, 19564,
     /*  798393 */     GIR_EraseRootFromParent_Done,
     /*  798394 */   // Label 12383: @798394
     /*  798394 */   GIM_Try, /*On fail goto*//*Label 12384*/ GIMT_Encode4(798469), // Rule ID 19565 //
     /*  798399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  798410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  798413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  798416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  798419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798445 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  798448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798467 */     GIR_RootConstrainSelectedInstOperands,
     /*  798468 */     // GIR_Coverage, 19565,
     /*  798468 */     GIR_EraseRootFromParent_Done,
     /*  798469 */   // Label 12384: @798469
     /*  798469 */   GIM_Try, /*On fail goto*//*Label 12385*/ GIMT_Encode4(798544), // Rule ID 19568 //
     /*  798474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  798485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  798488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  798491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  798494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798520 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  798523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798542 */     GIR_RootConstrainSelectedInstOperands,
     /*  798543 */     // GIR_Coverage, 19568,
     /*  798543 */     GIR_EraseRootFromParent_Done,
     /*  798544 */   // Label 12385: @798544
     /*  798544 */   GIM_Try, /*On fail goto*//*Label 12386*/ GIMT_Encode4(798619), // Rule ID 19569 //
     /*  798549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  798560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  798563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  798566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  798569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798595 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  798598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798617 */     GIR_RootConstrainSelectedInstOperands,
     /*  798618 */     // GIR_Coverage, 19569,
     /*  798618 */     GIR_EraseRootFromParent_Done,
     /*  798619 */   // Label 12386: @798619
     /*  798619 */   GIM_Try, /*On fail goto*//*Label 12387*/ GIMT_Encode4(798694), // Rule ID 19572 //
     /*  798624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  798635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  798638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  798641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  798644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798670 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  798673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798692 */     GIR_RootConstrainSelectedInstOperands,
     /*  798693 */     // GIR_Coverage, 19572,
     /*  798693 */     GIR_EraseRootFromParent_Done,
     /*  798694 */   // Label 12387: @798694
     /*  798694 */   GIM_Try, /*On fail goto*//*Label 12388*/ GIMT_Encode4(798769), // Rule ID 19573 //
     /*  798699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  798710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  798713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  798716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  798719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798745 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  798748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798767 */     GIR_RootConstrainSelectedInstOperands,
     /*  798768 */     // GIR_Coverage, 19573,
     /*  798768 */     GIR_EraseRootFromParent_Done,
     /*  798769 */   // Label 12388: @798769
     /*  798769 */   GIM_Try, /*On fail goto*//*Label 12389*/ GIMT_Encode4(798844), // Rule ID 19576 //
     /*  798774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  798785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  798788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  798791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  798794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798820 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  798823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798842 */     GIR_RootConstrainSelectedInstOperands,
     /*  798843 */     // GIR_Coverage, 19576,
     /*  798843 */     GIR_EraseRootFromParent_Done,
     /*  798844 */   // Label 12389: @798844
     /*  798844 */   GIM_Try, /*On fail goto*//*Label 12390*/ GIMT_Encode4(798919), // Rule ID 19577 //
     /*  798849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  798860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  798863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  798866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  798869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798895 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  798898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798917 */     GIR_RootConstrainSelectedInstOperands,
     /*  798918 */     // GIR_Coverage, 19577,
     /*  798918 */     GIR_EraseRootFromParent_Done,
     /*  798919 */   // Label 12390: @798919
     /*  798919 */   GIM_Try, /*On fail goto*//*Label 12391*/ GIMT_Encode4(798994), // Rule ID 19580 //
     /*  798924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  798935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  798938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  798941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  798944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798970 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  798973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798992 */     GIR_RootConstrainSelectedInstOperands,
     /*  798993 */     // GIR_Coverage, 19580,
     /*  798993 */     GIR_EraseRootFromParent_Done,
     /*  798994 */   // Label 12391: @798994
     /*  798994 */   GIM_Try, /*On fail goto*//*Label 12392*/ GIMT_Encode4(799069), // Rule ID 19581 //
     /*  798999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  799010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  799013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  799016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  799019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799045 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  799048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799067 */     GIR_RootConstrainSelectedInstOperands,
     /*  799068 */     // GIR_Coverage, 19581,
     /*  799068 */     GIR_EraseRootFromParent_Done,
     /*  799069 */   // Label 12392: @799069
     /*  799069 */   GIM_Try, /*On fail goto*//*Label 12393*/ GIMT_Encode4(799144), // Rule ID 19584 //
     /*  799074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  799085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  799088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  799091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  799094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799120 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  799123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799142 */     GIR_RootConstrainSelectedInstOperands,
     /*  799143 */     // GIR_Coverage, 19584,
     /*  799143 */     GIR_EraseRootFromParent_Done,
     /*  799144 */   // Label 12393: @799144
     /*  799144 */   GIM_Try, /*On fail goto*//*Label 12394*/ GIMT_Encode4(799219), // Rule ID 19585 //
     /*  799149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  799160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  799163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  799166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  799169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799195 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  799198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799217 */     GIR_RootConstrainSelectedInstOperands,
     /*  799218 */     // GIR_Coverage, 19585,
     /*  799218 */     GIR_EraseRootFromParent_Done,
     /*  799219 */   // Label 12394: @799219
     /*  799219 */   GIM_Try, /*On fail goto*//*Label 12395*/ GIMT_Encode4(799294), // Rule ID 19588 //
     /*  799224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  799235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  799238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  799241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  799244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799270 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  799273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799292 */     GIR_RootConstrainSelectedInstOperands,
     /*  799293 */     // GIR_Coverage, 19588,
     /*  799293 */     GIR_EraseRootFromParent_Done,
     /*  799294 */   // Label 12395: @799294
     /*  799294 */   GIM_Try, /*On fail goto*//*Label 12396*/ GIMT_Encode4(799369), // Rule ID 19589 //
     /*  799299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  799310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  799313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  799316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  799319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799345 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  799348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799367 */     GIR_RootConstrainSelectedInstOperands,
     /*  799368 */     // GIR_Coverage, 19589,
     /*  799368 */     GIR_EraseRootFromParent_Done,
     /*  799369 */   // Label 12396: @799369
     /*  799369 */   GIM_Try, /*On fail goto*//*Label 12397*/ GIMT_Encode4(799444), // Rule ID 19592 //
     /*  799374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  799385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  799388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  799391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  799394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799420 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  799423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799442 */     GIR_RootConstrainSelectedInstOperands,
     /*  799443 */     // GIR_Coverage, 19592,
     /*  799443 */     GIR_EraseRootFromParent_Done,
     /*  799444 */   // Label 12397: @799444
     /*  799444 */   GIM_Try, /*On fail goto*//*Label 12398*/ GIMT_Encode4(799519), // Rule ID 19593 //
     /*  799449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  799460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  799463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  799466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  799469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799495 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  799498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799517 */     GIR_RootConstrainSelectedInstOperands,
     /*  799518 */     // GIR_Coverage, 19593,
     /*  799518 */     GIR_EraseRootFromParent_Done,
     /*  799519 */   // Label 12398: @799519
     /*  799519 */   GIM_Try, /*On fail goto*//*Label 12399*/ GIMT_Encode4(799594), // Rule ID 19596 //
     /*  799524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  799535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  799538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  799541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799570 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  799573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799592 */     GIR_RootConstrainSelectedInstOperands,
     /*  799593 */     // GIR_Coverage, 19596,
     /*  799593 */     GIR_EraseRootFromParent_Done,
     /*  799594 */   // Label 12399: @799594
     /*  799594 */   GIM_Try, /*On fail goto*//*Label 12400*/ GIMT_Encode4(799669), // Rule ID 19597 //
     /*  799599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  799610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  799613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  799616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799645 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  799648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799667 */     GIR_RootConstrainSelectedInstOperands,
     /*  799668 */     // GIR_Coverage, 19597,
     /*  799668 */     GIR_EraseRootFromParent_Done,
     /*  799669 */   // Label 12400: @799669
     /*  799669 */   GIM_Try, /*On fail goto*//*Label 12401*/ GIMT_Encode4(799744), // Rule ID 19600 //
     /*  799674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  799685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  799688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  799691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799720 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  799723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799742 */     GIR_RootConstrainSelectedInstOperands,
     /*  799743 */     // GIR_Coverage, 19600,
     /*  799743 */     GIR_EraseRootFromParent_Done,
     /*  799744 */   // Label 12401: @799744
     /*  799744 */   GIM_Try, /*On fail goto*//*Label 12402*/ GIMT_Encode4(799819), // Rule ID 19601 //
     /*  799749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  799760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  799763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  799766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799795 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  799798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799817 */     GIR_RootConstrainSelectedInstOperands,
     /*  799818 */     // GIR_Coverage, 19601,
     /*  799818 */     GIR_EraseRootFromParent_Done,
     /*  799819 */   // Label 12402: @799819
     /*  799819 */   GIM_Try, /*On fail goto*//*Label 12403*/ GIMT_Encode4(799894), // Rule ID 19604 //
     /*  799824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  799835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  799838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  799841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799870 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  799873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799892 */     GIR_RootConstrainSelectedInstOperands,
     /*  799893 */     // GIR_Coverage, 19604,
     /*  799893 */     GIR_EraseRootFromParent_Done,
     /*  799894 */   // Label 12403: @799894
     /*  799894 */   GIM_Try, /*On fail goto*//*Label 12404*/ GIMT_Encode4(799969), // Rule ID 19605 //
     /*  799899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  799910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  799913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  799916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799945 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  799948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799967 */     GIR_RootConstrainSelectedInstOperands,
     /*  799968 */     // GIR_Coverage, 19605,
     /*  799968 */     GIR_EraseRootFromParent_Done,
     /*  799969 */   // Label 12404: @799969
     /*  799969 */   GIM_Try, /*On fail goto*//*Label 12405*/ GIMT_Encode4(800044), // Rule ID 19608 //
     /*  799974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  799985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  799988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  799991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800020 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  800023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800042 */     GIR_RootConstrainSelectedInstOperands,
     /*  800043 */     // GIR_Coverage, 19608,
     /*  800043 */     GIR_EraseRootFromParent_Done,
     /*  800044 */   // Label 12405: @800044
     /*  800044 */   GIM_Try, /*On fail goto*//*Label 12406*/ GIMT_Encode4(800119), // Rule ID 19609 //
     /*  800049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  800060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  800063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  800066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800095 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  800098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800117 */     GIR_RootConstrainSelectedInstOperands,
     /*  800118 */     // GIR_Coverage, 19609,
     /*  800118 */     GIR_EraseRootFromParent_Done,
     /*  800119 */   // Label 12406: @800119
     /*  800119 */   GIM_Try, /*On fail goto*//*Label 12407*/ GIMT_Encode4(800194), // Rule ID 19612 //
     /*  800124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  800135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  800138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  800141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800170 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  800173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800192 */     GIR_RootConstrainSelectedInstOperands,
     /*  800193 */     // GIR_Coverage, 19612,
     /*  800193 */     GIR_EraseRootFromParent_Done,
     /*  800194 */   // Label 12407: @800194
     /*  800194 */   GIM_Try, /*On fail goto*//*Label 12408*/ GIMT_Encode4(800269), // Rule ID 19613 //
     /*  800199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  800210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  800213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  800216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800245 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  800248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800267 */     GIR_RootConstrainSelectedInstOperands,
     /*  800268 */     // GIR_Coverage, 19613,
     /*  800268 */     GIR_EraseRootFromParent_Done,
     /*  800269 */   // Label 12408: @800269
     /*  800269 */   GIM_Try, /*On fail goto*//*Label 12409*/ GIMT_Encode4(800344), // Rule ID 19616 //
     /*  800274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  800277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  800285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  800288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  800291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800320 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  800320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  800323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800342 */     GIR_RootConstrainSelectedInstOperands,
     /*  800343 */     // GIR_Coverage, 19616,
     /*  800343 */     GIR_EraseRootFromParent_Done,
     /*  800344 */   // Label 12409: @800344
     /*  800344 */   GIM_Try, /*On fail goto*//*Label 12410*/ GIMT_Encode4(800419), // Rule ID 19617 //
     /*  800349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  800352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  800360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  800363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  800366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800395 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  800395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  800398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800417 */     GIR_RootConstrainSelectedInstOperands,
     /*  800418 */     // GIR_Coverage, 19617,
     /*  800418 */     GIR_EraseRootFromParent_Done,
     /*  800419 */   // Label 12410: @800419
     /*  800419 */   GIM_Try, /*On fail goto*//*Label 12411*/ GIMT_Encode4(800494), // Rule ID 19620 //
     /*  800424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  800435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  800438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  800441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800470 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  800473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800492 */     GIR_RootConstrainSelectedInstOperands,
     /*  800493 */     // GIR_Coverage, 19620,
     /*  800493 */     GIR_EraseRootFromParent_Done,
     /*  800494 */   // Label 12411: @800494
     /*  800494 */   GIM_Try, /*On fail goto*//*Label 12412*/ GIMT_Encode4(800569), // Rule ID 19621 //
     /*  800499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  800510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  800513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  800516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800545 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  800548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800567 */     GIR_RootConstrainSelectedInstOperands,
     /*  800568 */     // GIR_Coverage, 19621,
     /*  800568 */     GIR_EraseRootFromParent_Done,
     /*  800569 */   // Label 12412: @800569
     /*  800569 */   GIM_Try, /*On fail goto*//*Label 12413*/ GIMT_Encode4(800644), // Rule ID 19624 //
     /*  800574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  800585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  800588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  800591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800620 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  800623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800642 */     GIR_RootConstrainSelectedInstOperands,
     /*  800643 */     // GIR_Coverage, 19624,
     /*  800643 */     GIR_EraseRootFromParent_Done,
     /*  800644 */   // Label 12413: @800644
     /*  800644 */   GIM_Try, /*On fail goto*//*Label 12414*/ GIMT_Encode4(800719), // Rule ID 19625 //
     /*  800649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  800660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  800663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  800666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800695 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  800698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800717 */     GIR_RootConstrainSelectedInstOperands,
     /*  800718 */     // GIR_Coverage, 19625,
     /*  800718 */     GIR_EraseRootFromParent_Done,
     /*  800719 */   // Label 12414: @800719
     /*  800719 */   GIM_Try, /*On fail goto*//*Label 12415*/ GIMT_Encode4(800794), // Rule ID 19628 //
     /*  800724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  800735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  800738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  800741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800770 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  800773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800792 */     GIR_RootConstrainSelectedInstOperands,
     /*  800793 */     // GIR_Coverage, 19628,
     /*  800793 */     GIR_EraseRootFromParent_Done,
     /*  800794 */   // Label 12415: @800794
     /*  800794 */   GIM_Try, /*On fail goto*//*Label 12416*/ GIMT_Encode4(800869), // Rule ID 19629 //
     /*  800799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  800810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  800813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  800816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800845 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  800848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800867 */     GIR_RootConstrainSelectedInstOperands,
     /*  800868 */     // GIR_Coverage, 19629,
     /*  800868 */     GIR_EraseRootFromParent_Done,
     /*  800869 */   // Label 12416: @800869
     /*  800869 */   GIM_Try, /*On fail goto*//*Label 12417*/ GIMT_Encode4(800944), // Rule ID 19632 //
     /*  800874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  800885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  800888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  800891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800920 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  800923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800942 */     GIR_RootConstrainSelectedInstOperands,
     /*  800943 */     // GIR_Coverage, 19632,
     /*  800943 */     GIR_EraseRootFromParent_Done,
     /*  800944 */   // Label 12417: @800944
     /*  800944 */   GIM_Try, /*On fail goto*//*Label 12418*/ GIMT_Encode4(801019), // Rule ID 19633 //
     /*  800949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  800960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  800963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  800966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800995 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  800998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801017 */     GIR_RootConstrainSelectedInstOperands,
     /*  801018 */     // GIR_Coverage, 19633,
     /*  801018 */     GIR_EraseRootFromParent_Done,
     /*  801019 */   // Label 12418: @801019
     /*  801019 */   GIM_Try, /*On fail goto*//*Label 12419*/ GIMT_Encode4(801094), // Rule ID 19636 //
     /*  801024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  801035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  801038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  801041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801070 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  801073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801092 */     GIR_RootConstrainSelectedInstOperands,
     /*  801093 */     // GIR_Coverage, 19636,
     /*  801093 */     GIR_EraseRootFromParent_Done,
     /*  801094 */   // Label 12419: @801094
     /*  801094 */   GIM_Try, /*On fail goto*//*Label 12420*/ GIMT_Encode4(801169), // Rule ID 19637 //
     /*  801099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  801110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  801113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  801116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801145 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  801148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801167 */     GIR_RootConstrainSelectedInstOperands,
     /*  801168 */     // GIR_Coverage, 19637,
     /*  801168 */     GIR_EraseRootFromParent_Done,
     /*  801169 */   // Label 12420: @801169
     /*  801169 */   GIM_Try, /*On fail goto*//*Label 12421*/ GIMT_Encode4(801244), // Rule ID 19640 //
     /*  801174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  801185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  801188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  801191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801220 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  801223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801242 */     GIR_RootConstrainSelectedInstOperands,
     /*  801243 */     // GIR_Coverage, 19640,
     /*  801243 */     GIR_EraseRootFromParent_Done,
     /*  801244 */   // Label 12421: @801244
     /*  801244 */   GIM_Try, /*On fail goto*//*Label 12422*/ GIMT_Encode4(801319), // Rule ID 19641 //
     /*  801249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  801260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  801263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  801266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801295 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  801298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801317 */     GIR_RootConstrainSelectedInstOperands,
     /*  801318 */     // GIR_Coverage, 19641,
     /*  801318 */     GIR_EraseRootFromParent_Done,
     /*  801319 */   // Label 12422: @801319
     /*  801319 */   GIM_Try, /*On fail goto*//*Label 12423*/ GIMT_Encode4(801394), // Rule ID 19644 //
     /*  801324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  801327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  801335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  801338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  801341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801370 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  801373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801392 */     GIR_RootConstrainSelectedInstOperands,
     /*  801393 */     // GIR_Coverage, 19644,
     /*  801393 */     GIR_EraseRootFromParent_Done,
     /*  801394 */   // Label 12423: @801394
     /*  801394 */   GIM_Try, /*On fail goto*//*Label 12424*/ GIMT_Encode4(801469), // Rule ID 19645 //
     /*  801399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  801410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  801413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  801416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801445 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  801448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801467 */     GIR_RootConstrainSelectedInstOperands,
     /*  801468 */     // GIR_Coverage, 19645,
     /*  801468 */     GIR_EraseRootFromParent_Done,
     /*  801469 */   // Label 12424: @801469
     /*  801469 */   GIM_Try, /*On fail goto*//*Label 12425*/ GIMT_Encode4(801544), // Rule ID 19648 //
     /*  801474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  801477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  801485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  801488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  801491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801520 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  801523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801542 */     GIR_RootConstrainSelectedInstOperands,
     /*  801543 */     // GIR_Coverage, 19648,
     /*  801543 */     GIR_EraseRootFromParent_Done,
     /*  801544 */   // Label 12425: @801544
     /*  801544 */   GIM_Try, /*On fail goto*//*Label 12426*/ GIMT_Encode4(801619), // Rule ID 19649 //
     /*  801549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  801560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  801563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  801566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801595 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  801598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801617 */     GIR_RootConstrainSelectedInstOperands,
     /*  801618 */     // GIR_Coverage, 19649,
     /*  801618 */     GIR_EraseRootFromParent_Done,
     /*  801619 */   // Label 12426: @801619
     /*  801619 */   GIM_Try, /*On fail goto*//*Label 12427*/ GIMT_Encode4(801694), // Rule ID 19652 //
     /*  801624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  801627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  801635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  801638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  801641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801670 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  801673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801692 */     GIR_RootConstrainSelectedInstOperands,
     /*  801693 */     // GIR_Coverage, 19652,
     /*  801693 */     GIR_EraseRootFromParent_Done,
     /*  801694 */   // Label 12427: @801694
     /*  801694 */   GIM_Try, /*On fail goto*//*Label 12428*/ GIMT_Encode4(801769), // Rule ID 19653 //
     /*  801699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  801710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  801713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  801716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801745 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  801748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801767 */     GIR_RootConstrainSelectedInstOperands,
     /*  801768 */     // GIR_Coverage, 19653,
     /*  801768 */     GIR_EraseRootFromParent_Done,
     /*  801769 */   // Label 12428: @801769
     /*  801769 */   GIM_Try, /*On fail goto*//*Label 12429*/ GIMT_Encode4(801844), // Rule ID 19656 //
     /*  801774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  801785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  801788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  801791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  801794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801820 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  801823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801842 */     GIR_RootConstrainSelectedInstOperands,
     /*  801843 */     // GIR_Coverage, 19656,
     /*  801843 */     GIR_EraseRootFromParent_Done,
     /*  801844 */   // Label 12429: @801844
     /*  801844 */   GIM_Try, /*On fail goto*//*Label 12430*/ GIMT_Encode4(801919), // Rule ID 19657 //
     /*  801849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  801860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  801863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  801866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  801869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801895 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  801898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801917 */     GIR_RootConstrainSelectedInstOperands,
     /*  801918 */     // GIR_Coverage, 19657,
     /*  801918 */     GIR_EraseRootFromParent_Done,
     /*  801919 */   // Label 12430: @801919
     /*  801919 */   GIM_Try, /*On fail goto*//*Label 12431*/ GIMT_Encode4(801994), // Rule ID 19660 //
     /*  801924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  801935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  801938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  801941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  801944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801970 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  801973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801992 */     GIR_RootConstrainSelectedInstOperands,
     /*  801993 */     // GIR_Coverage, 19660,
     /*  801993 */     GIR_EraseRootFromParent_Done,
     /*  801994 */   // Label 12431: @801994
     /*  801994 */   GIM_Try, /*On fail goto*//*Label 12432*/ GIMT_Encode4(802069), // Rule ID 19661 //
     /*  801999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  802010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  802013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  802016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  802019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802045 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  802048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802067 */     GIR_RootConstrainSelectedInstOperands,
     /*  802068 */     // GIR_Coverage, 19661,
     /*  802068 */     GIR_EraseRootFromParent_Done,
     /*  802069 */   // Label 12432: @802069
     /*  802069 */   GIM_Try, /*On fail goto*//*Label 12433*/ GIMT_Encode4(802144), // Rule ID 19664 //
     /*  802074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  802085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  802088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  802091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  802094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802120 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  802123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802142 */     GIR_RootConstrainSelectedInstOperands,
     /*  802143 */     // GIR_Coverage, 19664,
     /*  802143 */     GIR_EraseRootFromParent_Done,
     /*  802144 */   // Label 12433: @802144
     /*  802144 */   GIM_Try, /*On fail goto*//*Label 12434*/ GIMT_Encode4(802219), // Rule ID 19665 //
     /*  802149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  802160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  802163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  802166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  802169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802195 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  802198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802217 */     GIR_RootConstrainSelectedInstOperands,
     /*  802218 */     // GIR_Coverage, 19665,
     /*  802218 */     GIR_EraseRootFromParent_Done,
     /*  802219 */   // Label 12434: @802219
     /*  802219 */   GIM_Try, /*On fail goto*//*Label 12435*/ GIMT_Encode4(802294), // Rule ID 19668 //
     /*  802224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  802235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  802238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  802241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  802244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802270 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  802273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802292 */     GIR_RootConstrainSelectedInstOperands,
     /*  802293 */     // GIR_Coverage, 19668,
     /*  802293 */     GIR_EraseRootFromParent_Done,
     /*  802294 */   // Label 12435: @802294
     /*  802294 */   GIM_Try, /*On fail goto*//*Label 12436*/ GIMT_Encode4(802369), // Rule ID 19669 //
     /*  802299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  802310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  802313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  802316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  802319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802345 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  802348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802367 */     GIR_RootConstrainSelectedInstOperands,
     /*  802368 */     // GIR_Coverage, 19669,
     /*  802368 */     GIR_EraseRootFromParent_Done,
     /*  802369 */   // Label 12436: @802369
     /*  802369 */   GIM_Try, /*On fail goto*//*Label 12437*/ GIMT_Encode4(802444), // Rule ID 19672 //
     /*  802374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  802385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  802388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  802391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  802394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802420 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  802423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802442 */     GIR_RootConstrainSelectedInstOperands,
     /*  802443 */     // GIR_Coverage, 19672,
     /*  802443 */     GIR_EraseRootFromParent_Done,
     /*  802444 */   // Label 12437: @802444
     /*  802444 */   GIM_Try, /*On fail goto*//*Label 12438*/ GIMT_Encode4(802519), // Rule ID 19673 //
     /*  802449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  802460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  802463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  802466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  802469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802495 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  802498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802517 */     GIR_RootConstrainSelectedInstOperands,
     /*  802518 */     // GIR_Coverage, 19673,
     /*  802518 */     GIR_EraseRootFromParent_Done,
     /*  802519 */   // Label 12438: @802519
     /*  802519 */   GIM_Try, /*On fail goto*//*Label 12439*/ GIMT_Encode4(802594), // Rule ID 19676 //
     /*  802524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  802527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  802535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  802538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  802541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  802544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802570 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  802570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  802573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802592 */     GIR_RootConstrainSelectedInstOperands,
     /*  802593 */     // GIR_Coverage, 19676,
     /*  802593 */     GIR_EraseRootFromParent_Done,
     /*  802594 */   // Label 12439: @802594
     /*  802594 */   GIM_Try, /*On fail goto*//*Label 12440*/ GIMT_Encode4(802669), // Rule ID 19677 //
     /*  802599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  802602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  802610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  802613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  802616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  802619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802645 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  802645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  802648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802667 */     GIR_RootConstrainSelectedInstOperands,
     /*  802668 */     // GIR_Coverage, 19677,
     /*  802668 */     GIR_EraseRootFromParent_Done,
     /*  802669 */   // Label 12440: @802669
     /*  802669 */   GIM_Try, /*On fail goto*//*Label 12441*/ GIMT_Encode4(802744), // Rule ID 19680 //
     /*  802674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  802685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  802688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  802691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  802694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802720 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  802723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802742 */     GIR_RootConstrainSelectedInstOperands,
     /*  802743 */     // GIR_Coverage, 19680,
     /*  802743 */     GIR_EraseRootFromParent_Done,
     /*  802744 */   // Label 12441: @802744
     /*  802744 */   GIM_Try, /*On fail goto*//*Label 12442*/ GIMT_Encode4(802819), // Rule ID 19681 //
     /*  802749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  802760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  802763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  802766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  802769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802795 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  802798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802817 */     GIR_RootConstrainSelectedInstOperands,
     /*  802818 */     // GIR_Coverage, 19681,
     /*  802818 */     GIR_EraseRootFromParent_Done,
     /*  802819 */   // Label 12442: @802819
     /*  802819 */   GIM_Try, /*On fail goto*//*Label 12443*/ GIMT_Encode4(802894), // Rule ID 19684 //
     /*  802824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  802835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  802838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  802841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  802844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802870 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  802873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802892 */     GIR_RootConstrainSelectedInstOperands,
     /*  802893 */     // GIR_Coverage, 19684,
     /*  802893 */     GIR_EraseRootFromParent_Done,
     /*  802894 */   // Label 12443: @802894
     /*  802894 */   GIM_Try, /*On fail goto*//*Label 12444*/ GIMT_Encode4(802969), // Rule ID 19685 //
     /*  802899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  802910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  802913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  802916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  802919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802945 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  802948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802967 */     GIR_RootConstrainSelectedInstOperands,
     /*  802968 */     // GIR_Coverage, 19685,
     /*  802968 */     GIR_EraseRootFromParent_Done,
     /*  802969 */   // Label 12444: @802969
     /*  802969 */   GIM_Try, /*On fail goto*//*Label 12445*/ GIMT_Encode4(803044), // Rule ID 19688 //
     /*  802974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  802985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  802988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  802991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  802994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803020 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  803023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803042 */     GIR_RootConstrainSelectedInstOperands,
     /*  803043 */     // GIR_Coverage, 19688,
     /*  803043 */     GIR_EraseRootFromParent_Done,
     /*  803044 */   // Label 12445: @803044
     /*  803044 */   GIM_Try, /*On fail goto*//*Label 12446*/ GIMT_Encode4(803119), // Rule ID 19689 //
     /*  803049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  803060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  803063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  803066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  803069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803095 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  803098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803117 */     GIR_RootConstrainSelectedInstOperands,
     /*  803118 */     // GIR_Coverage, 19689,
     /*  803118 */     GIR_EraseRootFromParent_Done,
     /*  803119 */   // Label 12446: @803119
     /*  803119 */   GIM_Try, /*On fail goto*//*Label 12447*/ GIMT_Encode4(803194), // Rule ID 19692 //
     /*  803124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  803135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  803138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  803141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  803144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803170 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  803173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803192 */     GIR_RootConstrainSelectedInstOperands,
     /*  803193 */     // GIR_Coverage, 19692,
     /*  803193 */     GIR_EraseRootFromParent_Done,
     /*  803194 */   // Label 12447: @803194
     /*  803194 */   GIM_Try, /*On fail goto*//*Label 12448*/ GIMT_Encode4(803269), // Rule ID 19693 //
     /*  803199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  803210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  803213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  803216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  803219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803245 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  803248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803267 */     GIR_RootConstrainSelectedInstOperands,
     /*  803268 */     // GIR_Coverage, 19693,
     /*  803268 */     GIR_EraseRootFromParent_Done,
     /*  803269 */   // Label 12448: @803269
     /*  803269 */   GIM_Try, /*On fail goto*//*Label 12449*/ GIMT_Encode4(803344), // Rule ID 19696 //
     /*  803274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  803285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  803288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  803291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  803294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803320 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  803323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803342 */     GIR_RootConstrainSelectedInstOperands,
     /*  803343 */     // GIR_Coverage, 19696,
     /*  803343 */     GIR_EraseRootFromParent_Done,
     /*  803344 */   // Label 12449: @803344
     /*  803344 */   GIM_Try, /*On fail goto*//*Label 12450*/ GIMT_Encode4(803419), // Rule ID 19697 //
     /*  803349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  803360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  803363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  803366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  803369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803395 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  803398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803417 */     GIR_RootConstrainSelectedInstOperands,
     /*  803418 */     // GIR_Coverage, 19697,
     /*  803418 */     GIR_EraseRootFromParent_Done,
     /*  803419 */   // Label 12450: @803419
     /*  803419 */   GIM_Try, /*On fail goto*//*Label 12451*/ GIMT_Encode4(803494), // Rule ID 19700 //
     /*  803424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  803435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  803438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  803441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  803444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803470 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  803473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803492 */     GIR_RootConstrainSelectedInstOperands,
     /*  803493 */     // GIR_Coverage, 19700,
     /*  803493 */     GIR_EraseRootFromParent_Done,
     /*  803494 */   // Label 12451: @803494
     /*  803494 */   GIM_Try, /*On fail goto*//*Label 12452*/ GIMT_Encode4(803569), // Rule ID 19701 //
     /*  803499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  803510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  803513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  803516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  803519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803545 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  803548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803567 */     GIR_RootConstrainSelectedInstOperands,
     /*  803568 */     // GIR_Coverage, 19701,
     /*  803568 */     GIR_EraseRootFromParent_Done,
     /*  803569 */   // Label 12452: @803569
     /*  803569 */   GIM_Try, /*On fail goto*//*Label 12453*/ GIMT_Encode4(803644), // Rule ID 19704 //
     /*  803574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  803577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  803585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  803588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  803591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  803594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803620 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  803623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803642 */     GIR_RootConstrainSelectedInstOperands,
     /*  803643 */     // GIR_Coverage, 19704,
     /*  803643 */     GIR_EraseRootFromParent_Done,
     /*  803644 */   // Label 12453: @803644
     /*  803644 */   GIM_Try, /*On fail goto*//*Label 12454*/ GIMT_Encode4(803719), // Rule ID 19705 //
     /*  803649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  803660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  803663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  803666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  803669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803695 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  803698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803717 */     GIR_RootConstrainSelectedInstOperands,
     /*  803718 */     // GIR_Coverage, 19705,
     /*  803718 */     GIR_EraseRootFromParent_Done,
     /*  803719 */   // Label 12454: @803719
     /*  803719 */   GIM_Try, /*On fail goto*//*Label 12455*/ GIMT_Encode4(803794), // Rule ID 19708 //
     /*  803724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  803727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  803735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  803738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  803741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  803744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803770 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  803773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803792 */     GIR_RootConstrainSelectedInstOperands,
     /*  803793 */     // GIR_Coverage, 19708,
     /*  803793 */     GIR_EraseRootFromParent_Done,
     /*  803794 */   // Label 12455: @803794
     /*  803794 */   GIM_Try, /*On fail goto*//*Label 12456*/ GIMT_Encode4(803869), // Rule ID 19709 //
     /*  803799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  803810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  803813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  803816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  803819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803845 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  803848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803867 */     GIR_RootConstrainSelectedInstOperands,
     /*  803868 */     // GIR_Coverage, 19709,
     /*  803868 */     GIR_EraseRootFromParent_Done,
     /*  803869 */   // Label 12456: @803869
     /*  803869 */   GIM_Try, /*On fail goto*//*Label 12457*/ GIMT_Encode4(803944), // Rule ID 19712 //
     /*  803874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  803877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  803885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  803888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  803891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  803894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803920 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  803923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803942 */     GIR_RootConstrainSelectedInstOperands,
     /*  803943 */     // GIR_Coverage, 19712,
     /*  803943 */     GIR_EraseRootFromParent_Done,
     /*  803944 */   // Label 12457: @803944
     /*  803944 */   GIM_Try, /*On fail goto*//*Label 12458*/ GIMT_Encode4(804019), // Rule ID 19713 //
     /*  803949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  803960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  803963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  803966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  803969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803995 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  803998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804017 */     GIR_RootConstrainSelectedInstOperands,
     /*  804018 */     // GIR_Coverage, 19713,
     /*  804018 */     GIR_EraseRootFromParent_Done,
     /*  804019 */   // Label 12458: @804019
     /*  804019 */   GIM_Try, /*On fail goto*//*Label 12459*/ GIMT_Encode4(804094), // Rule ID 19716 //
     /*  804024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  804035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  804038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  804041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804070 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  804073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804092 */     GIR_RootConstrainSelectedInstOperands,
     /*  804093 */     // GIR_Coverage, 19716,
     /*  804093 */     GIR_EraseRootFromParent_Done,
     /*  804094 */   // Label 12459: @804094
     /*  804094 */   GIM_Try, /*On fail goto*//*Label 12460*/ GIMT_Encode4(804169), // Rule ID 19717 //
     /*  804099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  804110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  804113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  804116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804145 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  804148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804167 */     GIR_RootConstrainSelectedInstOperands,
     /*  804168 */     // GIR_Coverage, 19717,
     /*  804168 */     GIR_EraseRootFromParent_Done,
     /*  804169 */   // Label 12460: @804169
     /*  804169 */   GIM_Try, /*On fail goto*//*Label 12461*/ GIMT_Encode4(804244), // Rule ID 19720 //
     /*  804174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  804185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  804188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  804191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804220 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  804223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804242 */     GIR_RootConstrainSelectedInstOperands,
     /*  804243 */     // GIR_Coverage, 19720,
     /*  804243 */     GIR_EraseRootFromParent_Done,
     /*  804244 */   // Label 12461: @804244
     /*  804244 */   GIM_Try, /*On fail goto*//*Label 12462*/ GIMT_Encode4(804319), // Rule ID 19721 //
     /*  804249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  804260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  804263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  804266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804295 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  804298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804317 */     GIR_RootConstrainSelectedInstOperands,
     /*  804318 */     // GIR_Coverage, 19721,
     /*  804318 */     GIR_EraseRootFromParent_Done,
     /*  804319 */   // Label 12462: @804319
     /*  804319 */   GIM_Try, /*On fail goto*//*Label 12463*/ GIMT_Encode4(804394), // Rule ID 19724 //
     /*  804324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  804327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  804335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  804338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  804341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804370 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  804373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804392 */     GIR_RootConstrainSelectedInstOperands,
     /*  804393 */     // GIR_Coverage, 19724,
     /*  804393 */     GIR_EraseRootFromParent_Done,
     /*  804394 */   // Label 12463: @804394
     /*  804394 */   GIM_Try, /*On fail goto*//*Label 12464*/ GIMT_Encode4(804469), // Rule ID 19725 //
     /*  804399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  804410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  804413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  804416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804445 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  804448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804467 */     GIR_RootConstrainSelectedInstOperands,
     /*  804468 */     // GIR_Coverage, 19725,
     /*  804468 */     GIR_EraseRootFromParent_Done,
     /*  804469 */   // Label 12464: @804469
     /*  804469 */   GIM_Try, /*On fail goto*//*Label 12465*/ GIMT_Encode4(804544), // Rule ID 19728 //
     /*  804474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  804485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  804488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  804491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804520 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  804523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804542 */     GIR_RootConstrainSelectedInstOperands,
     /*  804543 */     // GIR_Coverage, 19728,
     /*  804543 */     GIR_EraseRootFromParent_Done,
     /*  804544 */   // Label 12465: @804544
     /*  804544 */   GIM_Try, /*On fail goto*//*Label 12466*/ GIMT_Encode4(804619), // Rule ID 19729 //
     /*  804549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  804560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  804563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  804566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804595 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  804598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804617 */     GIR_RootConstrainSelectedInstOperands,
     /*  804618 */     // GIR_Coverage, 19729,
     /*  804618 */     GIR_EraseRootFromParent_Done,
     /*  804619 */   // Label 12466: @804619
     /*  804619 */   GIM_Try, /*On fail goto*//*Label 12467*/ GIMT_Encode4(804694), // Rule ID 19732 //
     /*  804624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  804627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  804635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  804638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  804641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804670 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  804673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804692 */     GIR_RootConstrainSelectedInstOperands,
     /*  804693 */     // GIR_Coverage, 19732,
     /*  804693 */     GIR_EraseRootFromParent_Done,
     /*  804694 */   // Label 12467: @804694
     /*  804694 */   GIM_Try, /*On fail goto*//*Label 12468*/ GIMT_Encode4(804769), // Rule ID 19733 //
     /*  804699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  804710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  804713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  804716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804745 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  804748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804767 */     GIR_RootConstrainSelectedInstOperands,
     /*  804768 */     // GIR_Coverage, 19733,
     /*  804768 */     GIR_EraseRootFromParent_Done,
     /*  804769 */   // Label 12468: @804769
     /*  804769 */   GIM_Try, /*On fail goto*//*Label 12469*/ GIMT_Encode4(804844), // Rule ID 19736 //
     /*  804774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  804777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  804785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  804788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  804791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  804794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  804813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804820 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  804820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  804823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804842 */     GIR_RootConstrainSelectedInstOperands,
     /*  804843 */     // GIR_Coverage, 19736,
     /*  804843 */     GIR_EraseRootFromParent_Done,
     /*  804844 */   // Label 12469: @804844
     /*  804844 */   GIM_Try, /*On fail goto*//*Label 12470*/ GIMT_Encode4(804919), // Rule ID 19737 //
     /*  804849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  804852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  804860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  804863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  804866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  804869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  804888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804895 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  804895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  804898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804917 */     GIR_RootConstrainSelectedInstOperands,
     /*  804918 */     // GIR_Coverage, 19737,
     /*  804918 */     GIR_EraseRootFromParent_Done,
     /*  804919 */   // Label 12470: @804919
     /*  804919 */   GIM_Try, /*On fail goto*//*Label 12471*/ GIMT_Encode4(804994), // Rule ID 19740 //
     /*  804924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  804935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  804938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  804941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804970 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  804973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804992 */     GIR_RootConstrainSelectedInstOperands,
     /*  804993 */     // GIR_Coverage, 19740,
     /*  804993 */     GIR_EraseRootFromParent_Done,
     /*  804994 */   // Label 12471: @804994
     /*  804994 */   GIM_Try, /*On fail goto*//*Label 12472*/ GIMT_Encode4(805069), // Rule ID 19741 //
     /*  804999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  805010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  805013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  805016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805045 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  805048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805067 */     GIR_RootConstrainSelectedInstOperands,
     /*  805068 */     // GIR_Coverage, 19741,
     /*  805068 */     GIR_EraseRootFromParent_Done,
     /*  805069 */   // Label 12472: @805069
     /*  805069 */   GIM_Try, /*On fail goto*//*Label 12473*/ GIMT_Encode4(805144), // Rule ID 19744 //
     /*  805074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  805085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  805088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  805091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805120 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  805123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805142 */     GIR_RootConstrainSelectedInstOperands,
     /*  805143 */     // GIR_Coverage, 19744,
     /*  805143 */     GIR_EraseRootFromParent_Done,
     /*  805144 */   // Label 12473: @805144
     /*  805144 */   GIM_Try, /*On fail goto*//*Label 12474*/ GIMT_Encode4(805219), // Rule ID 19745 //
     /*  805149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  805160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  805163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  805166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805195 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  805198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805217 */     GIR_RootConstrainSelectedInstOperands,
     /*  805218 */     // GIR_Coverage, 19745,
     /*  805218 */     GIR_EraseRootFromParent_Done,
     /*  805219 */   // Label 12474: @805219
     /*  805219 */   GIM_Try, /*On fail goto*//*Label 12475*/ GIMT_Encode4(805294), // Rule ID 19748 //
     /*  805224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  805235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  805238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  805241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805270 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  805273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805292 */     GIR_RootConstrainSelectedInstOperands,
     /*  805293 */     // GIR_Coverage, 19748,
     /*  805293 */     GIR_EraseRootFromParent_Done,
     /*  805294 */   // Label 12475: @805294
     /*  805294 */   GIM_Try, /*On fail goto*//*Label 12476*/ GIMT_Encode4(805369), // Rule ID 19749 //
     /*  805299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  805310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  805313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  805316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805345 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  805348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805367 */     GIR_RootConstrainSelectedInstOperands,
     /*  805368 */     // GIR_Coverage, 19749,
     /*  805368 */     GIR_EraseRootFromParent_Done,
     /*  805369 */   // Label 12476: @805369
     /*  805369 */   GIM_Try, /*On fail goto*//*Label 12477*/ GIMT_Encode4(805444), // Rule ID 19752 //
     /*  805374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  805385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  805388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  805391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805420 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  805423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805442 */     GIR_RootConstrainSelectedInstOperands,
     /*  805443 */     // GIR_Coverage, 19752,
     /*  805443 */     GIR_EraseRootFromParent_Done,
     /*  805444 */   // Label 12477: @805444
     /*  805444 */   GIM_Try, /*On fail goto*//*Label 12478*/ GIMT_Encode4(805519), // Rule ID 19753 //
     /*  805449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  805460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  805463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  805466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805495 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  805498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805517 */     GIR_RootConstrainSelectedInstOperands,
     /*  805518 */     // GIR_Coverage, 19753,
     /*  805518 */     GIR_EraseRootFromParent_Done,
     /*  805519 */   // Label 12478: @805519
     /*  805519 */   GIM_Try, /*On fail goto*//*Label 12479*/ GIMT_Encode4(805594), // Rule ID 19756 //
     /*  805524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  805535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  805538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  805541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805570 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  805573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805592 */     GIR_RootConstrainSelectedInstOperands,
     /*  805593 */     // GIR_Coverage, 19756,
     /*  805593 */     GIR_EraseRootFromParent_Done,
     /*  805594 */   // Label 12479: @805594
     /*  805594 */   GIM_Try, /*On fail goto*//*Label 12480*/ GIMT_Encode4(805669), // Rule ID 19757 //
     /*  805599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  805610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  805613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  805616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805645 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  805648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805667 */     GIR_RootConstrainSelectedInstOperands,
     /*  805668 */     // GIR_Coverage, 19757,
     /*  805668 */     GIR_EraseRootFromParent_Done,
     /*  805669 */   // Label 12480: @805669
     /*  805669 */   GIM_Try, /*On fail goto*//*Label 12481*/ GIMT_Encode4(805744), // Rule ID 19760 //
     /*  805674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  805685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  805688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  805691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805720 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  805723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805742 */     GIR_RootConstrainSelectedInstOperands,
     /*  805743 */     // GIR_Coverage, 19760,
     /*  805743 */     GIR_EraseRootFromParent_Done,
     /*  805744 */   // Label 12481: @805744
     /*  805744 */   GIM_Try, /*On fail goto*//*Label 12482*/ GIMT_Encode4(805819), // Rule ID 19761 //
     /*  805749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  805760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  805763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  805766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805795 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  805798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805817 */     GIR_RootConstrainSelectedInstOperands,
     /*  805818 */     // GIR_Coverage, 19761,
     /*  805818 */     GIR_EraseRootFromParent_Done,
     /*  805819 */   // Label 12482: @805819
     /*  805819 */   GIM_Try, /*On fail goto*//*Label 12483*/ GIMT_Encode4(805894), // Rule ID 19764 //
     /*  805824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  805835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  805838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  805841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805870 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  805873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805892 */     GIR_RootConstrainSelectedInstOperands,
     /*  805893 */     // GIR_Coverage, 19764,
     /*  805893 */     GIR_EraseRootFromParent_Done,
     /*  805894 */   // Label 12483: @805894
     /*  805894 */   GIM_Try, /*On fail goto*//*Label 12484*/ GIMT_Encode4(805969), // Rule ID 19765 //
     /*  805899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  805902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  805910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  805913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  805916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805945 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  805948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805967 */     GIR_RootConstrainSelectedInstOperands,
     /*  805968 */     // GIR_Coverage, 19765,
     /*  805968 */     GIR_EraseRootFromParent_Done,
     /*  805969 */   // Label 12484: @805969
     /*  805969 */   GIM_Try, /*On fail goto*//*Label 12485*/ GIMT_Encode4(806044), // Rule ID 19768 //
     /*  805974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  805985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  805988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  805991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806020 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  806020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  806023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806042 */     GIR_RootConstrainSelectedInstOperands,
     /*  806043 */     // GIR_Coverage, 19768,
     /*  806043 */     GIR_EraseRootFromParent_Done,
     /*  806044 */   // Label 12485: @806044
     /*  806044 */   GIM_Try, /*On fail goto*//*Label 12486*/ GIMT_Encode4(806119), // Rule ID 19769 //
     /*  806049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  806052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  806060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  806063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  806066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806095 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  806095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  806098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806117 */     GIR_RootConstrainSelectedInstOperands,
     /*  806118 */     // GIR_Coverage, 19769,
     /*  806118 */     GIR_EraseRootFromParent_Done,
     /*  806119 */   // Label 12486: @806119
     /*  806119 */   GIM_Try, /*On fail goto*//*Label 12487*/ GIMT_Encode4(806194), // Rule ID 19772 //
     /*  806124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  806127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  806135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  806138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  806141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806170 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  806170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  806173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806192 */     GIR_RootConstrainSelectedInstOperands,
     /*  806193 */     // GIR_Coverage, 19772,
     /*  806193 */     GIR_EraseRootFromParent_Done,
     /*  806194 */   // Label 12487: @806194
     /*  806194 */   GIM_Try, /*On fail goto*//*Label 12488*/ GIMT_Encode4(806269), // Rule ID 19773 //
     /*  806199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  806202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  806210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  806213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  806216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806245 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  806245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  806248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806267 */     GIR_RootConstrainSelectedInstOperands,
     /*  806268 */     // GIR_Coverage, 19773,
     /*  806268 */     GIR_EraseRootFromParent_Done,
     /*  806269 */   // Label 12488: @806269
     /*  806269 */   GIM_Try, /*On fail goto*//*Label 12489*/ GIMT_Encode4(806344), // Rule ID 21990 //
     /*  806274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  806291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806320 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  806320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  806323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806342 */     GIR_RootConstrainSelectedInstOperands,
     /*  806343 */     // GIR_Coverage, 21990,
     /*  806343 */     GIR_EraseRootFromParent_Done,
     /*  806344 */   // Label 12489: @806344
     /*  806344 */   GIM_Try, /*On fail goto*//*Label 12490*/ GIMT_Encode4(806419), // Rule ID 21991 //
     /*  806349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  806366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806395 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  806395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  806398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806417 */     GIR_RootConstrainSelectedInstOperands,
     /*  806418 */     // GIR_Coverage, 21991,
     /*  806418 */     GIR_EraseRootFromParent_Done,
     /*  806419 */   // Label 12490: @806419
     /*  806419 */   GIM_Try, /*On fail goto*//*Label 12491*/ GIMT_Encode4(806494), // Rule ID 21994 //
     /*  806424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  806441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806470 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  806470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  806473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806492 */     GIR_RootConstrainSelectedInstOperands,
     /*  806493 */     // GIR_Coverage, 21994,
     /*  806493 */     GIR_EraseRootFromParent_Done,
     /*  806494 */   // Label 12491: @806494
     /*  806494 */   GIM_Try, /*On fail goto*//*Label 12492*/ GIMT_Encode4(806569), // Rule ID 21995 //
     /*  806499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  806516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806545 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  806545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  806548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806567 */     GIR_RootConstrainSelectedInstOperands,
     /*  806568 */     // GIR_Coverage, 21995,
     /*  806568 */     GIR_EraseRootFromParent_Done,
     /*  806569 */   // Label 12492: @806569
     /*  806569 */   GIM_Try, /*On fail goto*//*Label 12493*/ GIMT_Encode4(806644), // Rule ID 21998 //
     /*  806574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  806591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  806623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806642 */     GIR_RootConstrainSelectedInstOperands,
     /*  806643 */     // GIR_Coverage, 21998,
     /*  806643 */     GIR_EraseRootFromParent_Done,
     /*  806644 */   // Label 12493: @806644
     /*  806644 */   GIM_Try, /*On fail goto*//*Label 12494*/ GIMT_Encode4(806719), // Rule ID 21999 //
     /*  806649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  806666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806695 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  806698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806717 */     GIR_RootConstrainSelectedInstOperands,
     /*  806718 */     // GIR_Coverage, 21999,
     /*  806718 */     GIR_EraseRootFromParent_Done,
     /*  806719 */   // Label 12494: @806719
     /*  806719 */   GIM_Try, /*On fail goto*//*Label 12495*/ GIMT_Encode4(806794), // Rule ID 22002 //
     /*  806724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  806741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  806773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806792 */     GIR_RootConstrainSelectedInstOperands,
     /*  806793 */     // GIR_Coverage, 22002,
     /*  806793 */     GIR_EraseRootFromParent_Done,
     /*  806794 */   // Label 12495: @806794
     /*  806794 */   GIM_Try, /*On fail goto*//*Label 12496*/ GIMT_Encode4(806869), // Rule ID 22003 //
     /*  806799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  806816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806845 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  806848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806867 */     GIR_RootConstrainSelectedInstOperands,
     /*  806868 */     // GIR_Coverage, 22003,
     /*  806868 */     GIR_EraseRootFromParent_Done,
     /*  806869 */   // Label 12496: @806869
     /*  806869 */   GIM_Try, /*On fail goto*//*Label 12497*/ GIMT_Encode4(806944), // Rule ID 22006 //
     /*  806874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  806885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  806888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  806891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  806894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806920 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  806920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  806923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806942 */     GIR_RootConstrainSelectedInstOperands,
     /*  806943 */     // GIR_Coverage, 22006,
     /*  806943 */     GIR_EraseRootFromParent_Done,
     /*  806944 */   // Label 12497: @806944
     /*  806944 */   GIM_Try, /*On fail goto*//*Label 12498*/ GIMT_Encode4(807019), // Rule ID 22007 //
     /*  806949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  806960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  806963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  806966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  806969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806995 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  806998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807017 */     GIR_RootConstrainSelectedInstOperands,
     /*  807018 */     // GIR_Coverage, 22007,
     /*  807018 */     GIR_EraseRootFromParent_Done,
     /*  807019 */   // Label 12498: @807019
     /*  807019 */   GIM_Try, /*On fail goto*//*Label 12499*/ GIMT_Encode4(807094), // Rule ID 22010 //
     /*  807024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  807041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  807073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807092 */     GIR_RootConstrainSelectedInstOperands,
     /*  807093 */     // GIR_Coverage, 22010,
     /*  807093 */     GIR_EraseRootFromParent_Done,
     /*  807094 */   // Label 12499: @807094
     /*  807094 */   GIM_Try, /*On fail goto*//*Label 12500*/ GIMT_Encode4(807169), // Rule ID 22011 //
     /*  807099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  807116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807145 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  807148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807167 */     GIR_RootConstrainSelectedInstOperands,
     /*  807168 */     // GIR_Coverage, 22011,
     /*  807168 */     GIR_EraseRootFromParent_Done,
     /*  807169 */   // Label 12500: @807169
     /*  807169 */   GIM_Try, /*On fail goto*//*Label 12501*/ GIMT_Encode4(807244), // Rule ID 22014 //
     /*  807174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  807191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807220 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  807223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807242 */     GIR_RootConstrainSelectedInstOperands,
     /*  807243 */     // GIR_Coverage, 22014,
     /*  807243 */     GIR_EraseRootFromParent_Done,
     /*  807244 */   // Label 12501: @807244
     /*  807244 */   GIM_Try, /*On fail goto*//*Label 12502*/ GIMT_Encode4(807319), // Rule ID 22015 //
     /*  807249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  807266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807295 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  807298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807317 */     GIR_RootConstrainSelectedInstOperands,
     /*  807318 */     // GIR_Coverage, 22015,
     /*  807318 */     GIR_EraseRootFromParent_Done,
     /*  807319 */   // Label 12502: @807319
     /*  807319 */   GIM_Try, /*On fail goto*//*Label 12503*/ GIMT_Encode4(807394), // Rule ID 22018 //
     /*  807324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  807335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  807338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  807341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  807344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807370 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  807370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  807373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807392 */     GIR_RootConstrainSelectedInstOperands,
     /*  807393 */     // GIR_Coverage, 22018,
     /*  807393 */     GIR_EraseRootFromParent_Done,
     /*  807394 */   // Label 12503: @807394
     /*  807394 */   GIM_Try, /*On fail goto*//*Label 12504*/ GIMT_Encode4(807469), // Rule ID 22019 //
     /*  807399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  807410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  807413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  807416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  807419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807445 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  807445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  807448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807467 */     GIR_RootConstrainSelectedInstOperands,
     /*  807468 */     // GIR_Coverage, 22019,
     /*  807468 */     GIR_EraseRootFromParent_Done,
     /*  807469 */   // Label 12504: @807469
     /*  807469 */   GIM_Try, /*On fail goto*//*Label 12505*/ GIMT_Encode4(807544), // Rule ID 22022 //
     /*  807474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  807477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  807485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  807488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  807491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  807494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807520 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  807520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  807523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807542 */     GIR_RootConstrainSelectedInstOperands,
     /*  807543 */     // GIR_Coverage, 22022,
     /*  807543 */     GIR_EraseRootFromParent_Done,
     /*  807544 */   // Label 12505: @807544
     /*  807544 */   GIM_Try, /*On fail goto*//*Label 12506*/ GIMT_Encode4(807619), // Rule ID 22023 //
     /*  807549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  807552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  807560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  807563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  807566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  807569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807595 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  807595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  807598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807617 */     GIR_RootConstrainSelectedInstOperands,
     /*  807618 */     // GIR_Coverage, 22023,
     /*  807618 */     GIR_EraseRootFromParent_Done,
     /*  807619 */   // Label 12506: @807619
     /*  807619 */   GIM_Try, /*On fail goto*//*Label 12507*/ GIMT_Encode4(807694), // Rule ID 22026 //
     /*  807624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  807641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807670 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  807673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807692 */     GIR_RootConstrainSelectedInstOperands,
     /*  807693 */     // GIR_Coverage, 22026,
     /*  807693 */     GIR_EraseRootFromParent_Done,
     /*  807694 */   // Label 12507: @807694
     /*  807694 */   GIM_Try, /*On fail goto*//*Label 12508*/ GIMT_Encode4(807769), // Rule ID 22027 //
     /*  807699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  807716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807745 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  807748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807767 */     GIR_RootConstrainSelectedInstOperands,
     /*  807768 */     // GIR_Coverage, 22027,
     /*  807768 */     GIR_EraseRootFromParent_Done,
     /*  807769 */   // Label 12508: @807769
     /*  807769 */   GIM_Try, /*On fail goto*//*Label 12509*/ GIMT_Encode4(807844), // Rule ID 22030 //
     /*  807774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  807791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807820 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  807823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807842 */     GIR_RootConstrainSelectedInstOperands,
     /*  807843 */     // GIR_Coverage, 22030,
     /*  807843 */     GIR_EraseRootFromParent_Done,
     /*  807844 */   // Label 12509: @807844
     /*  807844 */   GIM_Try, /*On fail goto*//*Label 12510*/ GIMT_Encode4(807919), // Rule ID 22031 //
     /*  807849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  807866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807895 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  807898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807917 */     GIR_RootConstrainSelectedInstOperands,
     /*  807918 */     // GIR_Coverage, 22031,
     /*  807918 */     GIR_EraseRootFromParent_Done,
     /*  807919 */   // Label 12510: @807919
     /*  807919 */   GIM_Try, /*On fail goto*//*Label 12511*/ GIMT_Encode4(807994), // Rule ID 22034 //
     /*  807924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  807941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807970 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  807973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807992 */     GIR_RootConstrainSelectedInstOperands,
     /*  807993 */     // GIR_Coverage, 22034,
     /*  807993 */     GIR_EraseRootFromParent_Done,
     /*  807994 */   // Label 12511: @807994
     /*  807994 */   GIM_Try, /*On fail goto*//*Label 12512*/ GIMT_Encode4(808069), // Rule ID 22035 //
     /*  807999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  808016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808045 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  808045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  808048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808067 */     GIR_RootConstrainSelectedInstOperands,
     /*  808068 */     // GIR_Coverage, 22035,
     /*  808068 */     GIR_EraseRootFromParent_Done,
     /*  808069 */   // Label 12512: @808069
     /*  808069 */   GIM_Try, /*On fail goto*//*Label 12513*/ GIMT_Encode4(808144), // Rule ID 22038 //
     /*  808074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  808091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  808123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808142 */     GIR_RootConstrainSelectedInstOperands,
     /*  808143 */     // GIR_Coverage, 22038,
     /*  808143 */     GIR_EraseRootFromParent_Done,
     /*  808144 */   // Label 12513: @808144
     /*  808144 */   GIM_Try, /*On fail goto*//*Label 12514*/ GIMT_Encode4(808219), // Rule ID 22039 //
     /*  808149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  808166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808195 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  808198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808217 */     GIR_RootConstrainSelectedInstOperands,
     /*  808218 */     // GIR_Coverage, 22039,
     /*  808218 */     GIR_EraseRootFromParent_Done,
     /*  808219 */   // Label 12514: @808219
     /*  808219 */   GIM_Try, /*On fail goto*//*Label 12515*/ GIMT_Encode4(808294), // Rule ID 22042 //
     /*  808224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  808241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808270 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  808273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808292 */     GIR_RootConstrainSelectedInstOperands,
     /*  808293 */     // GIR_Coverage, 22042,
     /*  808293 */     GIR_EraseRootFromParent_Done,
     /*  808294 */   // Label 12515: @808294
     /*  808294 */   GIM_Try, /*On fail goto*//*Label 12516*/ GIMT_Encode4(808369), // Rule ID 22043 //
     /*  808299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  808316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808345 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  808348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808367 */     GIR_RootConstrainSelectedInstOperands,
     /*  808368 */     // GIR_Coverage, 22043,
     /*  808368 */     GIR_EraseRootFromParent_Done,
     /*  808369 */   // Label 12516: @808369
     /*  808369 */   GIM_Try, /*On fail goto*//*Label 12517*/ GIMT_Encode4(808444), // Rule ID 22046 //
     /*  808374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  808391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808420 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  808423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808442 */     GIR_RootConstrainSelectedInstOperands,
     /*  808443 */     // GIR_Coverage, 22046,
     /*  808443 */     GIR_EraseRootFromParent_Done,
     /*  808444 */   // Label 12517: @808444
     /*  808444 */   GIM_Try, /*On fail goto*//*Label 12518*/ GIMT_Encode4(808519), // Rule ID 22047 //
     /*  808449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  808466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808495 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  808498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808517 */     GIR_RootConstrainSelectedInstOperands,
     /*  808518 */     // GIR_Coverage, 22047,
     /*  808518 */     GIR_EraseRootFromParent_Done,
     /*  808519 */   // Label 12518: @808519
     /*  808519 */   GIM_Try, /*On fail goto*//*Label 12519*/ GIMT_Encode4(808594), // Rule ID 22050 //
     /*  808524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  808541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  808573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808592 */     GIR_RootConstrainSelectedInstOperands,
     /*  808593 */     // GIR_Coverage, 22050,
     /*  808593 */     GIR_EraseRootFromParent_Done,
     /*  808594 */   // Label 12519: @808594
     /*  808594 */   GIM_Try, /*On fail goto*//*Label 12520*/ GIMT_Encode4(808669), // Rule ID 22051 //
     /*  808599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  808616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808645 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  808648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808667 */     GIR_RootConstrainSelectedInstOperands,
     /*  808668 */     // GIR_Coverage, 22051,
     /*  808668 */     GIR_EraseRootFromParent_Done,
     /*  808669 */   // Label 12520: @808669
     /*  808669 */   GIM_Try, /*On fail goto*//*Label 12521*/ GIMT_Encode4(808744), // Rule ID 22054 //
     /*  808674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  808691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808720 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  808723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808742 */     GIR_RootConstrainSelectedInstOperands,
     /*  808743 */     // GIR_Coverage, 22054,
     /*  808743 */     GIR_EraseRootFromParent_Done,
     /*  808744 */   // Label 12521: @808744
     /*  808744 */   GIM_Try, /*On fail goto*//*Label 12522*/ GIMT_Encode4(808819), // Rule ID 22055 //
     /*  808749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  808766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808795 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  808798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808817 */     GIR_RootConstrainSelectedInstOperands,
     /*  808818 */     // GIR_Coverage, 22055,
     /*  808818 */     GIR_EraseRootFromParent_Done,
     /*  808819 */   // Label 12522: @808819
     /*  808819 */   GIM_Try, /*On fail goto*//*Label 12523*/ GIMT_Encode4(808894), // Rule ID 22058 //
     /*  808824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  808841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808870 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  808873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808892 */     GIR_RootConstrainSelectedInstOperands,
     /*  808893 */     // GIR_Coverage, 22058,
     /*  808893 */     GIR_EraseRootFromParent_Done,
     /*  808894 */   // Label 12523: @808894
     /*  808894 */   GIM_Try, /*On fail goto*//*Label 12524*/ GIMT_Encode4(808969), // Rule ID 22059 //
     /*  808899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  808916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808945 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  808948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808967 */     GIR_RootConstrainSelectedInstOperands,
     /*  808968 */     // GIR_Coverage, 22059,
     /*  808968 */     GIR_EraseRootFromParent_Done,
     /*  808969 */   // Label 12524: @808969
     /*  808969 */   GIM_Try, /*On fail goto*//*Label 12525*/ GIMT_Encode4(809044), // Rule ID 22062 //
     /*  808974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  808977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  808991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  808994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  809023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809042 */     GIR_RootConstrainSelectedInstOperands,
     /*  809043 */     // GIR_Coverage, 22062,
     /*  809043 */     GIR_EraseRootFromParent_Done,
     /*  809044 */   // Label 12525: @809044
     /*  809044 */   GIM_Try, /*On fail goto*//*Label 12526*/ GIMT_Encode4(809119), // Rule ID 22063 //
     /*  809049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  809052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  809066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809095 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  809098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809117 */     GIR_RootConstrainSelectedInstOperands,
     /*  809118 */     // GIR_Coverage, 22063,
     /*  809118 */     GIR_EraseRootFromParent_Done,
     /*  809119 */   // Label 12526: @809119
     /*  809119 */   GIM_Try, /*On fail goto*//*Label 12527*/ GIMT_Encode4(809194), // Rule ID 22066 //
     /*  809124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  809127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  809141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809170 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  809173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809192 */     GIR_RootConstrainSelectedInstOperands,
     /*  809193 */     // GIR_Coverage, 22066,
     /*  809193 */     GIR_EraseRootFromParent_Done,
     /*  809194 */   // Label 12527: @809194
     /*  809194 */   GIM_Try, /*On fail goto*//*Label 12528*/ GIMT_Encode4(809269), // Rule ID 22067 //
     /*  809199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  809202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  809216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809245 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  809248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809267 */     GIR_RootConstrainSelectedInstOperands,
     /*  809268 */     // GIR_Coverage, 22067,
     /*  809268 */     GIR_EraseRootFromParent_Done,
     /*  809269 */   // Label 12528: @809269
     /*  809269 */   GIM_Try, /*On fail goto*//*Label 12529*/ GIMT_Encode4(809344), // Rule ID 22070 //
     /*  809274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  809277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  809291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809320 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  809323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809342 */     GIR_RootConstrainSelectedInstOperands,
     /*  809343 */     // GIR_Coverage, 22070,
     /*  809343 */     GIR_EraseRootFromParent_Done,
     /*  809344 */   // Label 12529: @809344
     /*  809344 */   GIM_Try, /*On fail goto*//*Label 12530*/ GIMT_Encode4(809419), // Rule ID 22071 //
     /*  809349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  809352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  809366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809395 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  809398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809417 */     GIR_RootConstrainSelectedInstOperands,
     /*  809418 */     // GIR_Coverage, 22071,
     /*  809418 */     GIR_EraseRootFromParent_Done,
     /*  809419 */   // Label 12530: @809419
     /*  809419 */   GIM_Try, /*On fail goto*//*Label 12531*/ GIMT_Encode4(809494), // Rule ID 22074 //
     /*  809424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  809441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809470 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  809470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  809473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809492 */     GIR_RootConstrainSelectedInstOperands,
     /*  809493 */     // GIR_Coverage, 22074,
     /*  809493 */     GIR_EraseRootFromParent_Done,
     /*  809494 */   // Label 12531: @809494
     /*  809494 */   GIM_Try, /*On fail goto*//*Label 12532*/ GIMT_Encode4(809569), // Rule ID 22075 //
     /*  809499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  809516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809545 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  809545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  809548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809567 */     GIR_RootConstrainSelectedInstOperands,
     /*  809568 */     // GIR_Coverage, 22075,
     /*  809568 */     GIR_EraseRootFromParent_Done,
     /*  809569 */   // Label 12532: @809569
     /*  809569 */   GIM_Try, /*On fail goto*//*Label 12533*/ GIMT_Encode4(809644), // Rule ID 22078 //
     /*  809574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  809591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809620 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  809620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  809623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809642 */     GIR_RootConstrainSelectedInstOperands,
     /*  809643 */     // GIR_Coverage, 22078,
     /*  809643 */     GIR_EraseRootFromParent_Done,
     /*  809644 */   // Label 12533: @809644
     /*  809644 */   GIM_Try, /*On fail goto*//*Label 12534*/ GIMT_Encode4(809719), // Rule ID 22079 //
     /*  809649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  809666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809695 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  809695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  809698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809717 */     GIR_RootConstrainSelectedInstOperands,
     /*  809718 */     // GIR_Coverage, 22079,
     /*  809718 */     GIR_EraseRootFromParent_Done,
     /*  809719 */   // Label 12534: @809719
     /*  809719 */   GIM_Try, /*On fail goto*//*Label 12535*/ GIMT_Encode4(809794), // Rule ID 22082 //
     /*  809724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  809741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809770 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  809770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  809773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809792 */     GIR_RootConstrainSelectedInstOperands,
     /*  809793 */     // GIR_Coverage, 22082,
     /*  809793 */     GIR_EraseRootFromParent_Done,
     /*  809794 */   // Label 12535: @809794
     /*  809794 */   GIM_Try, /*On fail goto*//*Label 12536*/ GIMT_Encode4(809869), // Rule ID 22083 //
     /*  809799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  809816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809845 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  809845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  809848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809867 */     GIR_RootConstrainSelectedInstOperands,
     /*  809868 */     // GIR_Coverage, 22083,
     /*  809868 */     GIR_EraseRootFromParent_Done,
     /*  809869 */   // Label 12536: @809869
     /*  809869 */   GIM_Try, /*On fail goto*//*Label 12537*/ GIMT_Encode4(809944), // Rule ID 22086 //
     /*  809874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  809885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  809888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  809891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  809894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809920 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  809920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  809923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809942 */     GIR_RootConstrainSelectedInstOperands,
     /*  809943 */     // GIR_Coverage, 22086,
     /*  809943 */     GIR_EraseRootFromParent_Done,
     /*  809944 */   // Label 12537: @809944
     /*  809944 */   GIM_Try, /*On fail goto*//*Label 12538*/ GIMT_Encode4(810019), // Rule ID 22087 //
     /*  809949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  809960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  809963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  809966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  809969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809995 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  809995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  809998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810017 */     GIR_RootConstrainSelectedInstOperands,
     /*  810018 */     // GIR_Coverage, 22087,
     /*  810018 */     GIR_EraseRootFromParent_Done,
     /*  810019 */   // Label 12538: @810019
     /*  810019 */   GIM_Try, /*On fail goto*//*Label 12539*/ GIMT_Encode4(810094), // Rule ID 22090 //
     /*  810024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  810041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810070 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  810073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810092 */     GIR_RootConstrainSelectedInstOperands,
     /*  810093 */     // GIR_Coverage, 22090,
     /*  810093 */     GIR_EraseRootFromParent_Done,
     /*  810094 */   // Label 12539: @810094
     /*  810094 */   GIM_Try, /*On fail goto*//*Label 12540*/ GIMT_Encode4(810169), // Rule ID 22091 //
     /*  810099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  810116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810145 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  810148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810167 */     GIR_RootConstrainSelectedInstOperands,
     /*  810168 */     // GIR_Coverage, 22091,
     /*  810168 */     GIR_EraseRootFromParent_Done,
     /*  810169 */   // Label 12540: @810169
     /*  810169 */   GIM_Try, /*On fail goto*//*Label 12541*/ GIMT_Encode4(810244), // Rule ID 22094 //
     /*  810174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  810191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810220 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  810220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  810223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810242 */     GIR_RootConstrainSelectedInstOperands,
     /*  810243 */     // GIR_Coverage, 22094,
     /*  810243 */     GIR_EraseRootFromParent_Done,
     /*  810244 */   // Label 12541: @810244
     /*  810244 */   GIM_Try, /*On fail goto*//*Label 12542*/ GIMT_Encode4(810319), // Rule ID 22095 //
     /*  810249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  810266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810295 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  810295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  810298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810317 */     GIR_RootConstrainSelectedInstOperands,
     /*  810318 */     // GIR_Coverage, 22095,
     /*  810318 */     GIR_EraseRootFromParent_Done,
     /*  810319 */   // Label 12542: @810319
     /*  810319 */   GIM_Try, /*On fail goto*//*Label 12543*/ GIMT_Encode4(810394), // Rule ID 22098 //
     /*  810324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  810341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810370 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  810373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810392 */     GIR_RootConstrainSelectedInstOperands,
     /*  810393 */     // GIR_Coverage, 22098,
     /*  810393 */     GIR_EraseRootFromParent_Done,
     /*  810394 */   // Label 12543: @810394
     /*  810394 */   GIM_Try, /*On fail goto*//*Label 12544*/ GIMT_Encode4(810469), // Rule ID 22099 //
     /*  810399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  810416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810445 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  810448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810467 */     GIR_RootConstrainSelectedInstOperands,
     /*  810468 */     // GIR_Coverage, 22099,
     /*  810468 */     GIR_EraseRootFromParent_Done,
     /*  810469 */   // Label 12544: @810469
     /*  810469 */   GIM_Try, /*On fail goto*//*Label 12545*/ GIMT_Encode4(810544), // Rule ID 22102 //
     /*  810474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  810491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810520 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  810523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810542 */     GIR_RootConstrainSelectedInstOperands,
     /*  810543 */     // GIR_Coverage, 22102,
     /*  810543 */     GIR_EraseRootFromParent_Done,
     /*  810544 */   // Label 12545: @810544
     /*  810544 */   GIM_Try, /*On fail goto*//*Label 12546*/ GIMT_Encode4(810619), // Rule ID 22103 //
     /*  810549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  810566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810595 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  810598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810617 */     GIR_RootConstrainSelectedInstOperands,
     /*  810618 */     // GIR_Coverage, 22103,
     /*  810618 */     GIR_EraseRootFromParent_Done,
     /*  810619 */   // Label 12546: @810619
     /*  810619 */   GIM_Try, /*On fail goto*//*Label 12547*/ GIMT_Encode4(810694), // Rule ID 22106 //
     /*  810624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  810641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  810670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  810673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810692 */     GIR_RootConstrainSelectedInstOperands,
     /*  810693 */     // GIR_Coverage, 22106,
     /*  810693 */     GIR_EraseRootFromParent_Done,
     /*  810694 */   // Label 12547: @810694
     /*  810694 */   GIM_Try, /*On fail goto*//*Label 12548*/ GIMT_Encode4(810769), // Rule ID 22107 //
     /*  810699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  810716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810745 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  810745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  810748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810767 */     GIR_RootConstrainSelectedInstOperands,
     /*  810768 */     // GIR_Coverage, 22107,
     /*  810768 */     GIR_EraseRootFromParent_Done,
     /*  810769 */   // Label 12548: @810769
     /*  810769 */   GIM_Try, /*On fail goto*//*Label 12549*/ GIMT_Encode4(810844), // Rule ID 22110 //
     /*  810774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  810777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  810785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  810788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  810791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  810794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810820 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  810820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  810823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810842 */     GIR_RootConstrainSelectedInstOperands,
     /*  810843 */     // GIR_Coverage, 22110,
     /*  810843 */     GIR_EraseRootFromParent_Done,
     /*  810844 */   // Label 12549: @810844
     /*  810844 */   GIM_Try, /*On fail goto*//*Label 12550*/ GIMT_Encode4(810919), // Rule ID 22111 //
     /*  810849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  810852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  810860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  810863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  810866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  810869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810895 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  810895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  810898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810917 */     GIR_RootConstrainSelectedInstOperands,
     /*  810918 */     // GIR_Coverage, 22111,
     /*  810918 */     GIR_EraseRootFromParent_Done,
     /*  810919 */   // Label 12550: @810919
     /*  810919 */   GIM_Try, /*On fail goto*//*Label 12551*/ GIMT_Encode4(810994), // Rule ID 22114 //
     /*  810924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  810941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810970 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  810973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810992 */     GIR_RootConstrainSelectedInstOperands,
     /*  810993 */     // GIR_Coverage, 22114,
     /*  810993 */     GIR_EraseRootFromParent_Done,
     /*  810994 */   // Label 12551: @810994
     /*  810994 */   GIM_Try, /*On fail goto*//*Label 12552*/ GIMT_Encode4(811069), // Rule ID 22115 //
     /*  810999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  811016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811045 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  811048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811067 */     GIR_RootConstrainSelectedInstOperands,
     /*  811068 */     // GIR_Coverage, 22115,
     /*  811068 */     GIR_EraseRootFromParent_Done,
     /*  811069 */   // Label 12552: @811069
     /*  811069 */   GIM_Try, /*On fail goto*//*Label 12553*/ GIMT_Encode4(811144), // Rule ID 22118 //
     /*  811074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  811091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811120 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  811123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811142 */     GIR_RootConstrainSelectedInstOperands,
     /*  811143 */     // GIR_Coverage, 22118,
     /*  811143 */     GIR_EraseRootFromParent_Done,
     /*  811144 */   // Label 12553: @811144
     /*  811144 */   GIM_Try, /*On fail goto*//*Label 12554*/ GIMT_Encode4(811219), // Rule ID 22119 //
     /*  811149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  811166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811195 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  811198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811217 */     GIR_RootConstrainSelectedInstOperands,
     /*  811218 */     // GIR_Coverage, 22119,
     /*  811218 */     GIR_EraseRootFromParent_Done,
     /*  811219 */   // Label 12554: @811219
     /*  811219 */   GIM_Try, /*On fail goto*//*Label 12555*/ GIMT_Encode4(811294), // Rule ID 22122 //
     /*  811224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  811241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811270 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  811273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811292 */     GIR_RootConstrainSelectedInstOperands,
     /*  811293 */     // GIR_Coverage, 22122,
     /*  811293 */     GIR_EraseRootFromParent_Done,
     /*  811294 */   // Label 12555: @811294
     /*  811294 */   GIM_Try, /*On fail goto*//*Label 12556*/ GIMT_Encode4(811369), // Rule ID 22123 //
     /*  811299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  811316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811345 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  811348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811367 */     GIR_RootConstrainSelectedInstOperands,
     /*  811368 */     // GIR_Coverage, 22123,
     /*  811368 */     GIR_EraseRootFromParent_Done,
     /*  811369 */   // Label 12556: @811369
     /*  811369 */   GIM_Try, /*On fail goto*//*Label 12557*/ GIMT_Encode4(811444), // Rule ID 22126 //
     /*  811374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  811391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811420 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  811423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811442 */     GIR_RootConstrainSelectedInstOperands,
     /*  811443 */     // GIR_Coverage, 22126,
     /*  811443 */     GIR_EraseRootFromParent_Done,
     /*  811444 */   // Label 12557: @811444
     /*  811444 */   GIM_Try, /*On fail goto*//*Label 12558*/ GIMT_Encode4(811519), // Rule ID 22127 //
     /*  811449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  811466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811495 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  811498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811517 */     GIR_RootConstrainSelectedInstOperands,
     /*  811518 */     // GIR_Coverage, 22127,
     /*  811518 */     GIR_EraseRootFromParent_Done,
     /*  811519 */   // Label 12558: @811519
     /*  811519 */   GIM_Try, /*On fail goto*//*Label 12559*/ GIMT_Encode4(811594), // Rule ID 22130 //
     /*  811524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  811541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811570 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  811573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811592 */     GIR_RootConstrainSelectedInstOperands,
     /*  811593 */     // GIR_Coverage, 22130,
     /*  811593 */     GIR_EraseRootFromParent_Done,
     /*  811594 */   // Label 12559: @811594
     /*  811594 */   GIM_Try, /*On fail goto*//*Label 12560*/ GIMT_Encode4(811669), // Rule ID 22131 //
     /*  811599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  811616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811645 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  811648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811667 */     GIR_RootConstrainSelectedInstOperands,
     /*  811668 */     // GIR_Coverage, 22131,
     /*  811668 */     GIR_EraseRootFromParent_Done,
     /*  811669 */   // Label 12560: @811669
     /*  811669 */   GIM_Try, /*On fail goto*//*Label 12561*/ GIMT_Encode4(811744), // Rule ID 22134 //
     /*  811674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  811691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  811723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811742 */     GIR_RootConstrainSelectedInstOperands,
     /*  811743 */     // GIR_Coverage, 22134,
     /*  811743 */     GIR_EraseRootFromParent_Done,
     /*  811744 */   // Label 12561: @811744
     /*  811744 */   GIM_Try, /*On fail goto*//*Label 12562*/ GIMT_Encode4(811819), // Rule ID 22135 //
     /*  811749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  811766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811795 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  811798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811817 */     GIR_RootConstrainSelectedInstOperands,
     /*  811818 */     // GIR_Coverage, 22135,
     /*  811818 */     GIR_EraseRootFromParent_Done,
     /*  811819 */   // Label 12562: @811819
     /*  811819 */   GIM_Try, /*On fail goto*//*Label 12563*/ GIMT_Encode4(811894), // Rule ID 22138 //
     /*  811824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  811841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811870 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  811870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  811873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811892 */     GIR_RootConstrainSelectedInstOperands,
     /*  811893 */     // GIR_Coverage, 22138,
     /*  811893 */     GIR_EraseRootFromParent_Done,
     /*  811894 */   // Label 12563: @811894
     /*  811894 */   GIM_Try, /*On fail goto*//*Label 12564*/ GIMT_Encode4(811969), // Rule ID 22139 //
     /*  811899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  811916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811945 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  811945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  811948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811967 */     GIR_RootConstrainSelectedInstOperands,
     /*  811968 */     // GIR_Coverage, 22139,
     /*  811968 */     GIR_EraseRootFromParent_Done,
     /*  811969 */   // Label 12564: @811969
     /*  811969 */   GIM_Try, /*On fail goto*//*Label 12565*/ GIMT_Encode4(812044), // Rule ID 22142 //
     /*  811974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  811991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  812023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812042 */     GIR_RootConstrainSelectedInstOperands,
     /*  812043 */     // GIR_Coverage, 22142,
     /*  812043 */     GIR_EraseRootFromParent_Done,
     /*  812044 */   // Label 12565: @812044
     /*  812044 */   GIM_Try, /*On fail goto*//*Label 12566*/ GIMT_Encode4(812119), // Rule ID 22143 //
     /*  812049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  812066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812095 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  812098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812117 */     GIR_RootConstrainSelectedInstOperands,
     /*  812118 */     // GIR_Coverage, 22143,
     /*  812118 */     GIR_EraseRootFromParent_Done,
     /*  812119 */   // Label 12566: @812119
     /*  812119 */   GIM_Try, /*On fail goto*//*Label 12567*/ GIMT_Encode4(812194), // Rule ID 22146 //
     /*  812124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  812141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  812173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812192 */     GIR_RootConstrainSelectedInstOperands,
     /*  812193 */     // GIR_Coverage, 22146,
     /*  812193 */     GIR_EraseRootFromParent_Done,
     /*  812194 */   // Label 12567: @812194
     /*  812194 */   GIM_Try, /*On fail goto*//*Label 12568*/ GIMT_Encode4(812269), // Rule ID 22147 //
     /*  812199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  812216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812245 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  812248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812267 */     GIR_RootConstrainSelectedInstOperands,
     /*  812268 */     // GIR_Coverage, 22147,
     /*  812268 */     GIR_EraseRootFromParent_Done,
     /*  812269 */   // Label 12568: @812269
     /*  812269 */   GIM_Try, /*On fail goto*//*Label 12569*/ GIMT_Encode4(812344), // Rule ID 22150 //
     /*  812274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  812291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812320 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  812320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  812323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812342 */     GIR_RootConstrainSelectedInstOperands,
     /*  812343 */     // GIR_Coverage, 22150,
     /*  812343 */     GIR_EraseRootFromParent_Done,
     /*  812344 */   // Label 12569: @812344
     /*  812344 */   GIM_Try, /*On fail goto*//*Label 12570*/ GIMT_Encode4(812419), // Rule ID 22151 //
     /*  812349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  812352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  812366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812395 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  812395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  812398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812417 */     GIR_RootConstrainSelectedInstOperands,
     /*  812418 */     // GIR_Coverage, 22151,
     /*  812418 */     GIR_EraseRootFromParent_Done,
     /*  812419 */   // Label 12570: @812419
     /*  812419 */   GIM_Try, /*On fail goto*//*Label 12571*/ GIMT_Encode4(812494), // Rule ID 22154 //
     /*  812424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  812441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  812470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  812473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812492 */     GIR_RootConstrainSelectedInstOperands,
     /*  812493 */     // GIR_Coverage, 22154,
     /*  812493 */     GIR_EraseRootFromParent_Done,
     /*  812494 */   // Label 12571: @812494
     /*  812494 */   GIM_Try, /*On fail goto*//*Label 12572*/ GIMT_Encode4(812569), // Rule ID 22155 //
     /*  812499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  812502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  812516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812545 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  812545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  812548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812567 */     GIR_RootConstrainSelectedInstOperands,
     /*  812568 */     // GIR_Coverage, 22155,
     /*  812568 */     GIR_EraseRootFromParent_Done,
     /*  812569 */   // Label 12572: @812569
     /*  812569 */   GIM_Try, /*On fail goto*//*Label 12573*/ GIMT_Encode4(812644), // Rule ID 22158 //
     /*  812574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  812591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812620 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  812620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  812623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812642 */     GIR_RootConstrainSelectedInstOperands,
     /*  812643 */     // GIR_Coverage, 22158,
     /*  812643 */     GIR_EraseRootFromParent_Done,
     /*  812644 */   // Label 12573: @812644
     /*  812644 */   GIM_Try, /*On fail goto*//*Label 12574*/ GIMT_Encode4(812719), // Rule ID 22159 //
     /*  812649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  812652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  812666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812695 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  812695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  812698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812717 */     GIR_RootConstrainSelectedInstOperands,
     /*  812718 */     // GIR_Coverage, 22159,
     /*  812718 */     GIR_EraseRootFromParent_Done,
     /*  812719 */   // Label 12574: @812719
     /*  812719 */   GIM_Try, /*On fail goto*//*Label 12575*/ GIMT_Encode4(812794), // Rule ID 22162 //
     /*  812724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  812741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812770 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  812770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  812773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812792 */     GIR_RootConstrainSelectedInstOperands,
     /*  812793 */     // GIR_Coverage, 22162,
     /*  812793 */     GIR_EraseRootFromParent_Done,
     /*  812794 */   // Label 12575: @812794
     /*  812794 */   GIM_Try, /*On fail goto*//*Label 12576*/ GIMT_Encode4(812869), // Rule ID 22163 //
     /*  812799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  812816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812845 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  812845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  812848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812867 */     GIR_RootConstrainSelectedInstOperands,
     /*  812868 */     // GIR_Coverage, 22163,
     /*  812868 */     GIR_EraseRootFromParent_Done,
     /*  812869 */   // Label 12576: @812869
     /*  812869 */   GIM_Try, /*On fail goto*//*Label 12577*/ GIMT_Encode4(812944), // Rule ID 22166 //
     /*  812874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  812891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812920 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  812920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  812923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812942 */     GIR_RootConstrainSelectedInstOperands,
     /*  812943 */     // GIR_Coverage, 22166,
     /*  812943 */     GIR_EraseRootFromParent_Done,
     /*  812944 */   // Label 12577: @812944
     /*  812944 */   GIM_Try, /*On fail goto*//*Label 12578*/ GIMT_Encode4(813019), // Rule ID 22167 //
     /*  812949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  812966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812995 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  812995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  812998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813017 */     GIR_RootConstrainSelectedInstOperands,
     /*  813018 */     // GIR_Coverage, 22167,
     /*  813018 */     GIR_EraseRootFromParent_Done,
     /*  813019 */   // Label 12578: @813019
     /*  813019 */   GIM_Try, /*On fail goto*//*Label 12579*/ GIMT_Encode4(813094), // Rule ID 22170 //
     /*  813024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  813041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  813073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813092 */     GIR_RootConstrainSelectedInstOperands,
     /*  813093 */     // GIR_Coverage, 22170,
     /*  813093 */     GIR_EraseRootFromParent_Done,
     /*  813094 */   // Label 12579: @813094
     /*  813094 */   GIM_Try, /*On fail goto*//*Label 12580*/ GIMT_Encode4(813169), // Rule ID 22171 //
     /*  813099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  813116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813145 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  813148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813167 */     GIR_RootConstrainSelectedInstOperands,
     /*  813168 */     // GIR_Coverage, 22171,
     /*  813168 */     GIR_EraseRootFromParent_Done,
     /*  813169 */   // Label 12580: @813169
     /*  813169 */   GIM_Try, /*On fail goto*//*Label 12581*/ GIMT_Encode4(813244), // Rule ID 22174 //
     /*  813174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  813191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813220 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  813223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813242 */     GIR_RootConstrainSelectedInstOperands,
     /*  813243 */     // GIR_Coverage, 22174,
     /*  813243 */     GIR_EraseRootFromParent_Done,
     /*  813244 */   // Label 12581: @813244
     /*  813244 */   GIM_Try, /*On fail goto*//*Label 12582*/ GIMT_Encode4(813319), // Rule ID 22175 //
     /*  813249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  813266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813295 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  813298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813317 */     GIR_RootConstrainSelectedInstOperands,
     /*  813318 */     // GIR_Coverage, 22175,
     /*  813318 */     GIR_EraseRootFromParent_Done,
     /*  813319 */   // Label 12582: @813319
     /*  813319 */   GIM_Try, /*On fail goto*//*Label 12583*/ GIMT_Encode4(813394), // Rule ID 22178 //
     /*  813324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  813341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813370 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  813373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813392 */     GIR_RootConstrainSelectedInstOperands,
     /*  813393 */     // GIR_Coverage, 22178,
     /*  813393 */     GIR_EraseRootFromParent_Done,
     /*  813394 */   // Label 12583: @813394
     /*  813394 */   GIM_Try, /*On fail goto*//*Label 12584*/ GIMT_Encode4(813469), // Rule ID 22179 //
     /*  813399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  813416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813445 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  813448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813467 */     GIR_RootConstrainSelectedInstOperands,
     /*  813468 */     // GIR_Coverage, 22179,
     /*  813468 */     GIR_EraseRootFromParent_Done,
     /*  813469 */   // Label 12584: @813469
     /*  813469 */   GIM_Try, /*On fail goto*//*Label 12585*/ GIMT_Encode4(813544), // Rule ID 22182 //
     /*  813474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  813488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  813491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  813494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813520 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  813520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  813523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  813539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813542 */     GIR_RootConstrainSelectedInstOperands,
     /*  813543 */     // GIR_Coverage, 22182,
     /*  813543 */     GIR_EraseRootFromParent_Done,
     /*  813544 */   // Label 12585: @813544
     /*  813544 */   GIM_Try, /*On fail goto*//*Label 12586*/ GIMT_Encode4(813619), // Rule ID 22183 //
     /*  813549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  813563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  813566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  813569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813595 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  813595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  813598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  813614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813617 */     GIR_RootConstrainSelectedInstOperands,
     /*  813618 */     // GIR_Coverage, 22183,
     /*  813618 */     GIR_EraseRootFromParent_Done,
     /*  813619 */   // Label 12586: @813619
     /*  813619 */   GIM_Try, /*On fail goto*//*Label 12587*/ GIMT_Encode4(813694), // Rule ID 22186 //
     /*  813624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  813641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813670 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  813673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813692 */     GIR_RootConstrainSelectedInstOperands,
     /*  813693 */     // GIR_Coverage, 22186,
     /*  813693 */     GIR_EraseRootFromParent_Done,
     /*  813694 */   // Label 12587: @813694
     /*  813694 */   GIM_Try, /*On fail goto*//*Label 12588*/ GIMT_Encode4(813769), // Rule ID 22187 //
     /*  813699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  813716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813745 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  813748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813767 */     GIR_RootConstrainSelectedInstOperands,
     /*  813768 */     // GIR_Coverage, 22187,
     /*  813768 */     GIR_EraseRootFromParent_Done,
     /*  813769 */   // Label 12588: @813769
     /*  813769 */   GIM_Try, /*On fail goto*//*Label 12589*/ GIMT_Encode4(813844), // Rule ID 22190 //
     /*  813774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  813791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813820 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  813823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813842 */     GIR_RootConstrainSelectedInstOperands,
     /*  813843 */     // GIR_Coverage, 22190,
     /*  813843 */     GIR_EraseRootFromParent_Done,
     /*  813844 */   // Label 12589: @813844
     /*  813844 */   GIM_Try, /*On fail goto*//*Label 12590*/ GIMT_Encode4(813919), // Rule ID 22191 //
     /*  813849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  813866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813895 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  813898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813917 */     GIR_RootConstrainSelectedInstOperands,
     /*  813918 */     // GIR_Coverage, 22191,
     /*  813918 */     GIR_EraseRootFromParent_Done,
     /*  813919 */   // Label 12590: @813919
     /*  813919 */   GIM_Try, /*On fail goto*//*Label 12591*/ GIMT_Encode4(813994), // Rule ID 22194 //
     /*  813924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  813938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  813941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  813944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  813970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  813973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  813989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813992 */     GIR_RootConstrainSelectedInstOperands,
     /*  813993 */     // GIR_Coverage, 22194,
     /*  813993 */     GIR_EraseRootFromParent_Done,
     /*  813994 */   // Label 12591: @813994
     /*  813994 */   GIM_Try, /*On fail goto*//*Label 12592*/ GIMT_Encode4(814069), // Rule ID 22195 //
     /*  813999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  814016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814045 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  814045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  814048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814067 */     GIR_RootConstrainSelectedInstOperands,
     /*  814068 */     // GIR_Coverage, 22195,
     /*  814068 */     GIR_EraseRootFromParent_Done,
     /*  814069 */   // Label 12592: @814069
     /*  814069 */   GIM_Try, /*On fail goto*//*Label 12593*/ GIMT_Encode4(814144), // Rule ID 22198 //
     /*  814074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  814077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  814085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  814088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  814091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  814094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  814120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  814123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  814139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814142 */     GIR_RootConstrainSelectedInstOperands,
     /*  814143 */     // GIR_Coverage, 22198,
     /*  814143 */     GIR_EraseRootFromParent_Done,
     /*  814144 */   // Label 12593: @814144
     /*  814144 */   GIM_Try, /*On fail goto*//*Label 12594*/ GIMT_Encode4(814219), // Rule ID 22199 //
     /*  814149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  814152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  814160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  814163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  814166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  814169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814195 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  814195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  814198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  814214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814217 */     GIR_RootConstrainSelectedInstOperands,
     /*  814218 */     // GIR_Coverage, 22199,
     /*  814218 */     GIR_EraseRootFromParent_Done,
     /*  814219 */   // Label 12594: @814219
     /*  814219 */   GIM_Try, /*On fail goto*//*Label 12595*/ GIMT_Encode4(814294), // Rule ID 22202 //
     /*  814224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  814241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814270 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  814273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814292 */     GIR_RootConstrainSelectedInstOperands,
     /*  814293 */     // GIR_Coverage, 22202,
     /*  814293 */     GIR_EraseRootFromParent_Done,
     /*  814294 */   // Label 12595: @814294
     /*  814294 */   GIM_Try, /*On fail goto*//*Label 12596*/ GIMT_Encode4(814369), // Rule ID 22203 //
     /*  814299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  814316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814345 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  814348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814367 */     GIR_RootConstrainSelectedInstOperands,
     /*  814368 */     // GIR_Coverage, 22203,
     /*  814368 */     GIR_EraseRootFromParent_Done,
     /*  814369 */   // Label 12596: @814369
     /*  814369 */   GIM_Try, /*On fail goto*//*Label 12597*/ GIMT_Encode4(814444), // Rule ID 22206 //
     /*  814374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  814391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814420 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  814423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814442 */     GIR_RootConstrainSelectedInstOperands,
     /*  814443 */     // GIR_Coverage, 22206,
     /*  814443 */     GIR_EraseRootFromParent_Done,
     /*  814444 */   // Label 12597: @814444
     /*  814444 */   GIM_Try, /*On fail goto*//*Label 12598*/ GIMT_Encode4(814519), // Rule ID 22207 //
     /*  814449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  814466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814495 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  814498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814517 */     GIR_RootConstrainSelectedInstOperands,
     /*  814518 */     // GIR_Coverage, 22207,
     /*  814518 */     GIR_EraseRootFromParent_Done,
     /*  814519 */   // Label 12598: @814519
     /*  814519 */   GIM_Try, /*On fail goto*//*Label 12599*/ GIMT_Encode4(814594), // Rule ID 22210 //
     /*  814524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  814541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814570 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  814573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814592 */     GIR_RootConstrainSelectedInstOperands,
     /*  814593 */     // GIR_Coverage, 22210,
     /*  814593 */     GIR_EraseRootFromParent_Done,
     /*  814594 */   // Label 12599: @814594
     /*  814594 */   GIM_Try, /*On fail goto*//*Label 12600*/ GIMT_Encode4(814669), // Rule ID 22211 //
     /*  814599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  814616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814645 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  814648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814667 */     GIR_RootConstrainSelectedInstOperands,
     /*  814668 */     // GIR_Coverage, 22211,
     /*  814668 */     GIR_EraseRootFromParent_Done,
     /*  814669 */   // Label 12600: @814669
     /*  814669 */   GIM_Try, /*On fail goto*//*Label 12601*/ GIMT_Encode4(814744), // Rule ID 22214 //
     /*  814674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  814691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  814720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  814723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814742 */     GIR_RootConstrainSelectedInstOperands,
     /*  814743 */     // GIR_Coverage, 22214,
     /*  814743 */     GIR_EraseRootFromParent_Done,
     /*  814744 */   // Label 12601: @814744
     /*  814744 */   GIM_Try, /*On fail goto*//*Label 12602*/ GIMT_Encode4(814819), // Rule ID 22215 //
     /*  814749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  814766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814795 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  814795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  814798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814817 */     GIR_RootConstrainSelectedInstOperands,
     /*  814818 */     // GIR_Coverage, 22215,
     /*  814818 */     GIR_EraseRootFromParent_Done,
     /*  814819 */   // Label 12602: @814819
     /*  814819 */   GIM_Try, /*On fail goto*//*Label 12603*/ GIMT_Encode4(814894), // Rule ID 22218 //
     /*  814824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  814841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814870 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  814870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  814873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814892 */     GIR_RootConstrainSelectedInstOperands,
     /*  814893 */     // GIR_Coverage, 22218,
     /*  814893 */     GIR_EraseRootFromParent_Done,
     /*  814894 */   // Label 12603: @814894
     /*  814894 */   GIM_Try, /*On fail goto*//*Label 12604*/ GIMT_Encode4(814969), // Rule ID 22219 //
     /*  814899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  814916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814945 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  814945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  814948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814967 */     GIR_RootConstrainSelectedInstOperands,
     /*  814968 */     // GIR_Coverage, 22219,
     /*  814968 */     GIR_EraseRootFromParent_Done,
     /*  814969 */   // Label 12604: @814969
     /*  814969 */   GIM_Try, /*On fail goto*//*Label 12605*/ GIMT_Encode4(815044), // Rule ID 22222 //
     /*  814974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  814991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  815023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815042 */     GIR_RootConstrainSelectedInstOperands,
     /*  815043 */     // GIR_Coverage, 22222,
     /*  815043 */     GIR_EraseRootFromParent_Done,
     /*  815044 */   // Label 12605: @815044
     /*  815044 */   GIM_Try, /*On fail goto*//*Label 12606*/ GIMT_Encode4(815119), // Rule ID 22223 //
     /*  815049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  815066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815095 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  815098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815117 */     GIR_RootConstrainSelectedInstOperands,
     /*  815118 */     // GIR_Coverage, 22223,
     /*  815118 */     GIR_EraseRootFromParent_Done,
     /*  815119 */   // Label 12606: @815119
     /*  815119 */   GIM_Try, /*On fail goto*//*Label 12607*/ GIMT_Encode4(815194), // Rule ID 22226 //
     /*  815124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  815141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  815173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815192 */     GIR_RootConstrainSelectedInstOperands,
     /*  815193 */     // GIR_Coverage, 22226,
     /*  815193 */     GIR_EraseRootFromParent_Done,
     /*  815194 */   // Label 12607: @815194
     /*  815194 */   GIM_Try, /*On fail goto*//*Label 12608*/ GIMT_Encode4(815269), // Rule ID 22227 //
     /*  815199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  815216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815245 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  815248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815267 */     GIR_RootConstrainSelectedInstOperands,
     /*  815268 */     // GIR_Coverage, 22227,
     /*  815268 */     GIR_EraseRootFromParent_Done,
     /*  815269 */   // Label 12608: @815269
     /*  815269 */   GIM_Try, /*On fail goto*//*Label 12609*/ GIMT_Encode4(815344), // Rule ID 22230 //
     /*  815274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  815291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  815323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815342 */     GIR_RootConstrainSelectedInstOperands,
     /*  815343 */     // GIR_Coverage, 22230,
     /*  815343 */     GIR_EraseRootFromParent_Done,
     /*  815344 */   // Label 12609: @815344
     /*  815344 */   GIM_Try, /*On fail goto*//*Label 12610*/ GIMT_Encode4(815419), // Rule ID 22231 //
     /*  815349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  815366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815395 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  815398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815417 */     GIR_RootConstrainSelectedInstOperands,
     /*  815418 */     // GIR_Coverage, 22231,
     /*  815418 */     GIR_EraseRootFromParent_Done,
     /*  815419 */   // Label 12610: @815419
     /*  815419 */   GIM_Try, /*On fail goto*//*Label 12611*/ GIMT_Encode4(815494), // Rule ID 22234 //
     /*  815424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  815441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815470 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  815473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815492 */     GIR_RootConstrainSelectedInstOperands,
     /*  815493 */     // GIR_Coverage, 22234,
     /*  815493 */     GIR_EraseRootFromParent_Done,
     /*  815494 */   // Label 12611: @815494
     /*  815494 */   GIM_Try, /*On fail goto*//*Label 12612*/ GIMT_Encode4(815569), // Rule ID 22235 //
     /*  815499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  815516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815545 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  815548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815567 */     GIR_RootConstrainSelectedInstOperands,
     /*  815568 */     // GIR_Coverage, 22235,
     /*  815568 */     GIR_EraseRootFromParent_Done,
     /*  815569 */   // Label 12612: @815569
     /*  815569 */   GIM_Try, /*On fail goto*//*Label 12613*/ GIMT_Encode4(815644), // Rule ID 22238 //
     /*  815574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  815577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  815591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815620 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  815620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  815623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815642 */     GIR_RootConstrainSelectedInstOperands,
     /*  815643 */     // GIR_Coverage, 22238,
     /*  815643 */     GIR_EraseRootFromParent_Done,
     /*  815644 */   // Label 12613: @815644
     /*  815644 */   GIM_Try, /*On fail goto*//*Label 12614*/ GIMT_Encode4(815719), // Rule ID 22239 //
     /*  815649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  815652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  815666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815695 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  815695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  815698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815717 */     GIR_RootConstrainSelectedInstOperands,
     /*  815718 */     // GIR_Coverage, 22239,
     /*  815718 */     GIR_EraseRootFromParent_Done,
     /*  815719 */   // Label 12614: @815719
     /*  815719 */   GIM_Try, /*On fail goto*//*Label 12615*/ GIMT_Encode4(815794), // Rule ID 22242 //
     /*  815724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  815727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  815741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815770 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  815770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  815773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815792 */     GIR_RootConstrainSelectedInstOperands,
     /*  815793 */     // GIR_Coverage, 22242,
     /*  815793 */     GIR_EraseRootFromParent_Done,
     /*  815794 */   // Label 12615: @815794
     /*  815794 */   GIM_Try, /*On fail goto*//*Label 12616*/ GIMT_Encode4(815869), // Rule ID 22243 //
     /*  815799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  815802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  815816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815845 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  815845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  815848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815867 */     GIR_RootConstrainSelectedInstOperands,
     /*  815868 */     // GIR_Coverage, 22243,
     /*  815868 */     GIR_EraseRootFromParent_Done,
     /*  815869 */   // Label 12616: @815869
     /*  815869 */   GIM_Try, /*On fail goto*//*Label 12617*/ GIMT_Encode4(815944), // Rule ID 22246 //
     /*  815874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  815877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  815891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815920 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  815920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  815923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815942 */     GIR_RootConstrainSelectedInstOperands,
     /*  815943 */     // GIR_Coverage, 22246,
     /*  815943 */     GIR_EraseRootFromParent_Done,
     /*  815944 */   // Label 12617: @815944
     /*  815944 */   GIM_Try, /*On fail goto*//*Label 12618*/ GIMT_Encode4(816019), // Rule ID 22247 //
     /*  815949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  815952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  815966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815995 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  815995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  815998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816017 */     GIR_RootConstrainSelectedInstOperands,
     /*  816018 */     // GIR_Coverage, 22247,
     /*  816018 */     GIR_EraseRootFromParent_Done,
     /*  816019 */   // Label 12618: @816019
     /*  816019 */   GIM_Try, /*On fail goto*//*Label 12619*/ GIMT_Encode4(816094), // Rule ID 22250 //
     /*  816024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  816041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  816073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816092 */     GIR_RootConstrainSelectedInstOperands,
     /*  816093 */     // GIR_Coverage, 22250,
     /*  816093 */     GIR_EraseRootFromParent_Done,
     /*  816094 */   // Label 12619: @816094
     /*  816094 */   GIM_Try, /*On fail goto*//*Label 12620*/ GIMT_Encode4(816169), // Rule ID 22251 //
     /*  816099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  816116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816145 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  816148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816167 */     GIR_RootConstrainSelectedInstOperands,
     /*  816168 */     // GIR_Coverage, 22251,
     /*  816168 */     GIR_EraseRootFromParent_Done,
     /*  816169 */   // Label 12620: @816169
     /*  816169 */   GIM_Try, /*On fail goto*//*Label 12621*/ GIMT_Encode4(816244), // Rule ID 22254 //
     /*  816174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  816191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  816223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816242 */     GIR_RootConstrainSelectedInstOperands,
     /*  816243 */     // GIR_Coverage, 22254,
     /*  816243 */     GIR_EraseRootFromParent_Done,
     /*  816244 */   // Label 12621: @816244
     /*  816244 */   GIM_Try, /*On fail goto*//*Label 12622*/ GIMT_Encode4(816319), // Rule ID 22255 //
     /*  816249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  816266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816295 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  816298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816317 */     GIR_RootConstrainSelectedInstOperands,
     /*  816318 */     // GIR_Coverage, 22255,
     /*  816318 */     GIR_EraseRootFromParent_Done,
     /*  816319 */   // Label 12622: @816319
     /*  816319 */   GIM_Try, /*On fail goto*//*Label 12623*/ GIMT_Encode4(816394), // Rule ID 22258 //
     /*  816324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  816341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816370 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  816373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816392 */     GIR_RootConstrainSelectedInstOperands,
     /*  816393 */     // GIR_Coverage, 22258,
     /*  816393 */     GIR_EraseRootFromParent_Done,
     /*  816394 */   // Label 12623: @816394
     /*  816394 */   GIM_Try, /*On fail goto*//*Label 12624*/ GIMT_Encode4(816469), // Rule ID 22259 //
     /*  816399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  816416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816445 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  816448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816467 */     GIR_RootConstrainSelectedInstOperands,
     /*  816468 */     // GIR_Coverage, 22259,
     /*  816468 */     GIR_EraseRootFromParent_Done,
     /*  816469 */   // Label 12624: @816469
     /*  816469 */   GIM_Try, /*On fail goto*//*Label 12625*/ GIMT_Encode4(816544), // Rule ID 22262 //
     /*  816474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  816491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816520 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  816520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  816523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816542 */     GIR_RootConstrainSelectedInstOperands,
     /*  816543 */     // GIR_Coverage, 22262,
     /*  816543 */     GIR_EraseRootFromParent_Done,
     /*  816544 */   // Label 12625: @816544
     /*  816544 */   GIM_Try, /*On fail goto*//*Label 12626*/ GIMT_Encode4(816619), // Rule ID 22263 //
     /*  816549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  816566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816595 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  816595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  816598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816617 */     GIR_RootConstrainSelectedInstOperands,
     /*  816618 */     // GIR_Coverage, 22263,
     /*  816618 */     GIR_EraseRootFromParent_Done,
     /*  816619 */   // Label 12626: @816619
     /*  816619 */   GIM_Try, /*On fail goto*//*Label 12627*/ GIMT_Encode4(816694), // Rule ID 22266 //
     /*  816624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  816641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816670 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  816670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  816673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816692 */     GIR_RootConstrainSelectedInstOperands,
     /*  816693 */     // GIR_Coverage, 22266,
     /*  816693 */     GIR_EraseRootFromParent_Done,
     /*  816694 */   // Label 12627: @816694
     /*  816694 */   GIM_Try, /*On fail goto*//*Label 12628*/ GIMT_Encode4(816769), // Rule ID 22267 //
     /*  816699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  816716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816745 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  816745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  816748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816767 */     GIR_RootConstrainSelectedInstOperands,
     /*  816768 */     // GIR_Coverage, 22267,
     /*  816768 */     GIR_EraseRootFromParent_Done,
     /*  816769 */   // Label 12628: @816769
     /*  816769 */   GIM_Try, /*On fail goto*//*Label 12629*/ GIMT_Encode4(816844), // Rule ID 22270 //
     /*  816774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  816785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  816788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  816791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  816794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816820 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  816820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  816823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816842 */     GIR_RootConstrainSelectedInstOperands,
     /*  816843 */     // GIR_Coverage, 22270,
     /*  816843 */     GIR_EraseRootFromParent_Done,
     /*  816844 */   // Label 12629: @816844
     /*  816844 */   GIM_Try, /*On fail goto*//*Label 12630*/ GIMT_Encode4(816919), // Rule ID 22271 //
     /*  816849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  816860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  816863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  816866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  816869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816895 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  816895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  816898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816917 */     GIR_RootConstrainSelectedInstOperands,
     /*  816918 */     // GIR_Coverage, 22271,
     /*  816918 */     GIR_EraseRootFromParent_Done,
     /*  816919 */   // Label 12630: @816919
     /*  816919 */   GIM_Try, /*On fail goto*//*Label 12631*/ GIMT_Encode4(816994), // Rule ID 22274 //
     /*  816924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  816941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816970 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  816973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816992 */     GIR_RootConstrainSelectedInstOperands,
     /*  816993 */     // GIR_Coverage, 22274,
     /*  816993 */     GIR_EraseRootFromParent_Done,
     /*  816994 */   // Label 12631: @816994
     /*  816994 */   GIM_Try, /*On fail goto*//*Label 12632*/ GIMT_Encode4(817069), // Rule ID 22275 //
     /*  816999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  817016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817045 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  817048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817067 */     GIR_RootConstrainSelectedInstOperands,
     /*  817068 */     // GIR_Coverage, 22275,
     /*  817068 */     GIR_EraseRootFromParent_Done,
     /*  817069 */   // Label 12632: @817069
     /*  817069 */   GIM_Try, /*On fail goto*//*Label 12633*/ GIMT_Encode4(817144), // Rule ID 22278 //
     /*  817074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  817091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  817123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817142 */     GIR_RootConstrainSelectedInstOperands,
     /*  817143 */     // GIR_Coverage, 22278,
     /*  817143 */     GIR_EraseRootFromParent_Done,
     /*  817144 */   // Label 12633: @817144
     /*  817144 */   GIM_Try, /*On fail goto*//*Label 12634*/ GIMT_Encode4(817219), // Rule ID 22279 //
     /*  817149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  817166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817195 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  817198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817217 */     GIR_RootConstrainSelectedInstOperands,
     /*  817218 */     // GIR_Coverage, 22279,
     /*  817218 */     GIR_EraseRootFromParent_Done,
     /*  817219 */   // Label 12634: @817219
     /*  817219 */   GIM_Try, /*On fail goto*//*Label 12635*/ GIMT_Encode4(817294), // Rule ID 22282 //
     /*  817224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  817241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  817270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  817273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817292 */     GIR_RootConstrainSelectedInstOperands,
     /*  817293 */     // GIR_Coverage, 22282,
     /*  817293 */     GIR_EraseRootFromParent_Done,
     /*  817294 */   // Label 12635: @817294
     /*  817294 */   GIM_Try, /*On fail goto*//*Label 12636*/ GIMT_Encode4(817369), // Rule ID 22283 //
     /*  817299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  817316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817345 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  817345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  817348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817367 */     GIR_RootConstrainSelectedInstOperands,
     /*  817368 */     // GIR_Coverage, 22283,
     /*  817368 */     GIR_EraseRootFromParent_Done,
     /*  817369 */   // Label 12636: @817369
     /*  817369 */   GIM_Try, /*On fail goto*//*Label 12637*/ GIMT_Encode4(817444), // Rule ID 22286 //
     /*  817374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  817377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  817388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  817394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  817420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  817423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  817439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817442 */     GIR_RootConstrainSelectedInstOperands,
     /*  817443 */     // GIR_Coverage, 22286,
     /*  817443 */     GIR_EraseRootFromParent_Done,
     /*  817444 */   // Label 12637: @817444
     /*  817444 */   GIM_Try, /*On fail goto*//*Label 12638*/ GIMT_Encode4(817519), // Rule ID 22287 //
     /*  817449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  817452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  817463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  817469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817495 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  817495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  817498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  817514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817517 */     GIR_RootConstrainSelectedInstOperands,
     /*  817518 */     // GIR_Coverage, 22287,
     /*  817518 */     GIR_EraseRootFromParent_Done,
     /*  817519 */   // Label 12638: @817519
     /*  817519 */   GIM_Try, /*On fail goto*//*Label 12639*/ GIMT_Encode4(817594), // Rule ID 22290 //
     /*  817524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  817541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817570 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  817570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  817573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817592 */     GIR_RootConstrainSelectedInstOperands,
     /*  817593 */     // GIR_Coverage, 22290,
     /*  817593 */     GIR_EraseRootFromParent_Done,
     /*  817594 */   // Label 12639: @817594
     /*  817594 */   GIM_Try, /*On fail goto*//*Label 12640*/ GIMT_Encode4(817669), // Rule ID 22291 //
     /*  817599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  817616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817645 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  817648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817667 */     GIR_RootConstrainSelectedInstOperands,
     /*  817668 */     // GIR_Coverage, 22291,
     /*  817668 */     GIR_EraseRootFromParent_Done,
     /*  817669 */   // Label 12640: @817669
     /*  817669 */   GIM_Try, /*On fail goto*//*Label 12641*/ GIMT_Encode4(817744), // Rule ID 22294 //
     /*  817674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  817691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817720 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  817720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  817723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817742 */     GIR_RootConstrainSelectedInstOperands,
     /*  817743 */     // GIR_Coverage, 22294,
     /*  817743 */     GIR_EraseRootFromParent_Done,
     /*  817744 */   // Label 12641: @817744
     /*  817744 */   GIM_Try, /*On fail goto*//*Label 12642*/ GIMT_Encode4(817819), // Rule ID 22295 //
     /*  817749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  817766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817795 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  817798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817817 */     GIR_RootConstrainSelectedInstOperands,
     /*  817818 */     // GIR_Coverage, 22295,
     /*  817818 */     GIR_EraseRootFromParent_Done,
     /*  817819 */   // Label 12642: @817819
     /*  817819 */   GIM_Try, /*On fail goto*//*Label 12643*/ GIMT_Encode4(817894), // Rule ID 22298 //
     /*  817824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  817841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817870 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  817870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  817873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817892 */     GIR_RootConstrainSelectedInstOperands,
     /*  817893 */     // GIR_Coverage, 22298,
     /*  817893 */     GIR_EraseRootFromParent_Done,
     /*  817894 */   // Label 12643: @817894
     /*  817894 */   GIM_Try, /*On fail goto*//*Label 12644*/ GIMT_Encode4(817969), // Rule ID 22299 //
     /*  817899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  817916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817945 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  817948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817967 */     GIR_RootConstrainSelectedInstOperands,
     /*  817968 */     // GIR_Coverage, 22299,
     /*  817968 */     GIR_EraseRootFromParent_Done,
     /*  817969 */   // Label 12644: @817969
     /*  817969 */   GIM_Try, /*On fail goto*//*Label 12645*/ GIMT_Encode4(818044), // Rule ID 22302 //
     /*  817974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  817991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  818023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818042 */     GIR_RootConstrainSelectedInstOperands,
     /*  818043 */     // GIR_Coverage, 22302,
     /*  818043 */     GIR_EraseRootFromParent_Done,
     /*  818044 */   // Label 12645: @818044
     /*  818044 */   GIM_Try, /*On fail goto*//*Label 12646*/ GIMT_Encode4(818119), // Rule ID 22303 //
     /*  818049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  818066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818095 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  818098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818117 */     GIR_RootConstrainSelectedInstOperands,
     /*  818118 */     // GIR_Coverage, 22303,
     /*  818118 */     GIR_EraseRootFromParent_Done,
     /*  818119 */   // Label 12646: @818119
     /*  818119 */   GIM_Try, /*On fail goto*//*Label 12647*/ GIMT_Encode4(818194), // Rule ID 22306 //
     /*  818124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  818141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818170 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  818173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818192 */     GIR_RootConstrainSelectedInstOperands,
     /*  818193 */     // GIR_Coverage, 22306,
     /*  818193 */     GIR_EraseRootFromParent_Done,
     /*  818194 */   // Label 12647: @818194
     /*  818194 */   GIM_Try, /*On fail goto*//*Label 12648*/ GIMT_Encode4(818269), // Rule ID 22307 //
     /*  818199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  818216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818245 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  818248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818267 */     GIR_RootConstrainSelectedInstOperands,
     /*  818268 */     // GIR_Coverage, 22307,
     /*  818268 */     GIR_EraseRootFromParent_Done,
     /*  818269 */   // Label 12648: @818269
     /*  818269 */   GIM_Try, /*On fail goto*//*Label 12649*/ GIMT_Encode4(818344), // Rule ID 22310 //
     /*  818274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  818291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818320 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  818323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818342 */     GIR_RootConstrainSelectedInstOperands,
     /*  818343 */     // GIR_Coverage, 22310,
     /*  818343 */     GIR_EraseRootFromParent_Done,
     /*  818344 */   // Label 12649: @818344
     /*  818344 */   GIM_Try, /*On fail goto*//*Label 12650*/ GIMT_Encode4(818419), // Rule ID 22311 //
     /*  818349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  818366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818395 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  818398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818417 */     GIR_RootConstrainSelectedInstOperands,
     /*  818418 */     // GIR_Coverage, 22311,
     /*  818418 */     GIR_EraseRootFromParent_Done,
     /*  818419 */   // Label 12650: @818419
     /*  818419 */   GIM_Try, /*On fail goto*//*Label 12651*/ GIMT_Encode4(818494), // Rule ID 22314 //
     /*  818424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  818441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818470 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  818470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  818473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818492 */     GIR_RootConstrainSelectedInstOperands,
     /*  818493 */     // GIR_Coverage, 22314,
     /*  818493 */     GIR_EraseRootFromParent_Done,
     /*  818494 */   // Label 12651: @818494
     /*  818494 */   GIM_Try, /*On fail goto*//*Label 12652*/ GIMT_Encode4(818569), // Rule ID 22315 //
     /*  818499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  818516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818545 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  818545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  818548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818567 */     GIR_RootConstrainSelectedInstOperands,
     /*  818568 */     // GIR_Coverage, 22315,
     /*  818568 */     GIR_EraseRootFromParent_Done,
     /*  818569 */   // Label 12652: @818569
     /*  818569 */   GIM_Try, /*On fail goto*//*Label 12653*/ GIMT_Encode4(818644), // Rule ID 22318 //
     /*  818574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  818591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818620 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  818620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  818623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818642 */     GIR_RootConstrainSelectedInstOperands,
     /*  818643 */     // GIR_Coverage, 22318,
     /*  818643 */     GIR_EraseRootFromParent_Done,
     /*  818644 */   // Label 12653: @818644
     /*  818644 */   GIM_Try, /*On fail goto*//*Label 12654*/ GIMT_Encode4(818719), // Rule ID 22319 //
     /*  818649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  818666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818695 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  818695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  818698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818717 */     GIR_RootConstrainSelectedInstOperands,
     /*  818718 */     // GIR_Coverage, 22319,
     /*  818718 */     GIR_EraseRootFromParent_Done,
     /*  818719 */   // Label 12654: @818719
     /*  818719 */   GIM_Try, /*On fail goto*//*Label 12655*/ GIMT_Encode4(818794), // Rule ID 22322 //
     /*  818724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  818741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  818770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  818773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818792 */     GIR_RootConstrainSelectedInstOperands,
     /*  818793 */     // GIR_Coverage, 22322,
     /*  818793 */     GIR_EraseRootFromParent_Done,
     /*  818794 */   // Label 12655: @818794
     /*  818794 */   GIM_Try, /*On fail goto*//*Label 12656*/ GIMT_Encode4(818869), // Rule ID 22323 //
     /*  818799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  818816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818845 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  818845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  818848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818867 */     GIR_RootConstrainSelectedInstOperands,
     /*  818868 */     // GIR_Coverage, 22323,
     /*  818868 */     GIR_EraseRootFromParent_Done,
     /*  818869 */   // Label 12656: @818869
     /*  818869 */   GIM_Try, /*On fail goto*//*Label 12657*/ GIMT_Encode4(818944), // Rule ID 22326 //
     /*  818874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  818877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  818885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  818888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  818891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  818894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818920 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  818920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  818923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  818939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818942 */     GIR_RootConstrainSelectedInstOperands,
     /*  818943 */     // GIR_Coverage, 22326,
     /*  818943 */     GIR_EraseRootFromParent_Done,
     /*  818944 */   // Label 12657: @818944
     /*  818944 */   GIM_Try, /*On fail goto*//*Label 12658*/ GIMT_Encode4(819019), // Rule ID 22327 //
     /*  818949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  818952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  818960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  818963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  818966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  818969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818995 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  818995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  818998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819017 */     GIR_RootConstrainSelectedInstOperands,
     /*  819018 */     // GIR_Coverage, 22327,
     /*  819018 */     GIR_EraseRootFromParent_Done,
     /*  819019 */   // Label 12658: @819019
     /*  819019 */   GIM_Try, /*On fail goto*//*Label 12659*/ GIMT_Encode4(819094), // Rule ID 22330 //
     /*  819024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  819041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819070 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  819073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819092 */     GIR_RootConstrainSelectedInstOperands,
     /*  819093 */     // GIR_Coverage, 22330,
     /*  819093 */     GIR_EraseRootFromParent_Done,
     /*  819094 */   // Label 12659: @819094
     /*  819094 */   GIM_Try, /*On fail goto*//*Label 12660*/ GIMT_Encode4(819169), // Rule ID 22331 //
     /*  819099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  819116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819145 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  819148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819167 */     GIR_RootConstrainSelectedInstOperands,
     /*  819168 */     // GIR_Coverage, 22331,
     /*  819168 */     GIR_EraseRootFromParent_Done,
     /*  819169 */   // Label 12660: @819169
     /*  819169 */   GIM_Try, /*On fail goto*//*Label 12661*/ GIMT_Encode4(819244), // Rule ID 22334 //
     /*  819174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  819191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819220 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  819223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819242 */     GIR_RootConstrainSelectedInstOperands,
     /*  819243 */     // GIR_Coverage, 22334,
     /*  819243 */     GIR_EraseRootFromParent_Done,
     /*  819244 */   // Label 12661: @819244
     /*  819244 */   GIM_Try, /*On fail goto*//*Label 12662*/ GIMT_Encode4(819319), // Rule ID 22335 //
     /*  819249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  819266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819295 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  819298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819317 */     GIR_RootConstrainSelectedInstOperands,
     /*  819318 */     // GIR_Coverage, 22335,
     /*  819318 */     GIR_EraseRootFromParent_Done,
     /*  819319 */   // Label 12662: @819319
     /*  819319 */   GIM_Try, /*On fail goto*//*Label 12663*/ GIMT_Encode4(819394), // Rule ID 22338 //
     /*  819324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819370 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  819373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819392 */     GIR_RootConstrainSelectedInstOperands,
     /*  819393 */     // GIR_Coverage, 22338,
     /*  819393 */     GIR_EraseRootFromParent_Done,
     /*  819394 */   // Label 12663: @819394
     /*  819394 */   GIM_Try, /*On fail goto*//*Label 12664*/ GIMT_Encode4(819469), // Rule ID 22339 //
     /*  819399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819445 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  819445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  819448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819467 */     GIR_RootConstrainSelectedInstOperands,
     /*  819468 */     // GIR_Coverage, 22339,
     /*  819468 */     GIR_EraseRootFromParent_Done,
     /*  819469 */   // Label 12664: @819469
     /*  819469 */   GIM_Try, /*On fail goto*//*Label 12665*/ GIMT_Encode4(819544), // Rule ID 22342 //
     /*  819474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  819491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819520 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  819523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819542 */     GIR_RootConstrainSelectedInstOperands,
     /*  819543 */     // GIR_Coverage, 22342,
     /*  819543 */     GIR_EraseRootFromParent_Done,
     /*  819544 */   // Label 12665: @819544
     /*  819544 */   GIM_Try, /*On fail goto*//*Label 12666*/ GIMT_Encode4(819619), // Rule ID 22343 //
     /*  819549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  819566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819595 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  819595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  819598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819617 */     GIR_RootConstrainSelectedInstOperands,
     /*  819618 */     // GIR_Coverage, 22343,
     /*  819618 */     GIR_EraseRootFromParent_Done,
     /*  819619 */   // Label 12666: @819619
     /*  819619 */   GIM_Try, /*On fail goto*//*Label 12667*/ GIMT_Encode4(819694), // Rule ID 22346 //
     /*  819624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  819641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819670 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  819673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819692 */     GIR_RootConstrainSelectedInstOperands,
     /*  819693 */     // GIR_Coverage, 22346,
     /*  819693 */     GIR_EraseRootFromParent_Done,
     /*  819694 */   // Label 12667: @819694
     /*  819694 */   GIM_Try, /*On fail goto*//*Label 12668*/ GIMT_Encode4(819769), // Rule ID 22347 //
     /*  819699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  819716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819745 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  819745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  819748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819767 */     GIR_RootConstrainSelectedInstOperands,
     /*  819768 */     // GIR_Coverage, 22347,
     /*  819768 */     GIR_EraseRootFromParent_Done,
     /*  819769 */   // Label 12668: @819769
     /*  819769 */   GIM_Try, /*On fail goto*//*Label 12669*/ GIMT_Encode4(819844), // Rule ID 22350 //
     /*  819774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  819785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  819788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  819791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  819794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819820 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  819820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  819823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  819839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819842 */     GIR_RootConstrainSelectedInstOperands,
     /*  819843 */     // GIR_Coverage, 22350,
     /*  819843 */     GIR_EraseRootFromParent_Done,
     /*  819844 */   // Label 12669: @819844
     /*  819844 */   GIM_Try, /*On fail goto*//*Label 12670*/ GIMT_Encode4(819919), // Rule ID 22351 //
     /*  819849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  819860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  819863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  819866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  819869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819895 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  819895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  819898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  819914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819917 */     GIR_RootConstrainSelectedInstOperands,
     /*  819918 */     // GIR_Coverage, 22351,
     /*  819918 */     GIR_EraseRootFromParent_Done,
     /*  819919 */   // Label 12670: @819919
     /*  819919 */   GIM_Try, /*On fail goto*//*Label 12671*/ GIMT_Encode4(819994), // Rule ID 22354 //
     /*  819924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  819935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  819938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  819941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  819944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819970 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  819970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  819973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  819989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819992 */     GIR_RootConstrainSelectedInstOperands,
     /*  819993 */     // GIR_Coverage, 22354,
     /*  819993 */     GIR_EraseRootFromParent_Done,
     /*  819994 */   // Label 12671: @819994
     /*  819994 */   GIM_Try, /*On fail goto*//*Label 12672*/ GIMT_Encode4(820069), // Rule ID 22355 //
     /*  819999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  820016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820045 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  820048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820067 */     GIR_RootConstrainSelectedInstOperands,
     /*  820068 */     // GIR_Coverage, 22355,
     /*  820068 */     GIR_EraseRootFromParent_Done,
     /*  820069 */   // Label 12672: @820069
     /*  820069 */   GIM_Try, /*On fail goto*//*Label 12673*/ GIMT_Encode4(820144), // Rule ID 22358 //
     /*  820074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820120 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  820120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  820123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820142 */     GIR_RootConstrainSelectedInstOperands,
     /*  820143 */     // GIR_Coverage, 22358,
     /*  820143 */     GIR_EraseRootFromParent_Done,
     /*  820144 */   // Label 12673: @820144
     /*  820144 */   GIM_Try, /*On fail goto*//*Label 12674*/ GIMT_Encode4(820219), // Rule ID 22359 //
     /*  820149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820195 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  820195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  820198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820217 */     GIR_RootConstrainSelectedInstOperands,
     /*  820218 */     // GIR_Coverage, 22359,
     /*  820218 */     GIR_EraseRootFromParent_Done,
     /*  820219 */   // Label 12674: @820219
     /*  820219 */   GIM_Try, /*On fail goto*//*Label 12675*/ GIMT_Encode4(820294), // Rule ID 22362 //
     /*  820224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820270 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  820273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820292 */     GIR_RootConstrainSelectedInstOperands,
     /*  820293 */     // GIR_Coverage, 22362,
     /*  820293 */     GIR_EraseRootFromParent_Done,
     /*  820294 */   // Label 12675: @820294
     /*  820294 */   GIM_Try, /*On fail goto*//*Label 12676*/ GIMT_Encode4(820369), // Rule ID 22363 //
     /*  820299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820345 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  820348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820367 */     GIR_RootConstrainSelectedInstOperands,
     /*  820368 */     // GIR_Coverage, 22363,
     /*  820368 */     GIR_EraseRootFromParent_Done,
     /*  820369 */   // Label 12676: @820369
     /*  820369 */   GIM_Try, /*On fail goto*//*Label 12677*/ GIMT_Encode4(820444), // Rule ID 22366 //
     /*  820374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820420 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  820423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820442 */     GIR_RootConstrainSelectedInstOperands,
     /*  820443 */     // GIR_Coverage, 22366,
     /*  820443 */     GIR_EraseRootFromParent_Done,
     /*  820444 */   // Label 12677: @820444
     /*  820444 */   GIM_Try, /*On fail goto*//*Label 12678*/ GIMT_Encode4(820519), // Rule ID 22367 //
     /*  820449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820495 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  820498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820517 */     GIR_RootConstrainSelectedInstOperands,
     /*  820518 */     // GIR_Coverage, 22367,
     /*  820518 */     GIR_EraseRootFromParent_Done,
     /*  820519 */   // Label 12678: @820519
     /*  820519 */   GIM_Try, /*On fail goto*//*Label 12679*/ GIMT_Encode4(820594), // Rule ID 22370 //
     /*  820524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  820541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  820570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  820573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820592 */     GIR_RootConstrainSelectedInstOperands,
     /*  820593 */     // GIR_Coverage, 22370,
     /*  820593 */     GIR_EraseRootFromParent_Done,
     /*  820594 */   // Label 12679: @820594
     /*  820594 */   GIM_Try, /*On fail goto*//*Label 12680*/ GIMT_Encode4(820669), // Rule ID 22371 //
     /*  820599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  820616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820645 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  820645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  820648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820667 */     GIR_RootConstrainSelectedInstOperands,
     /*  820668 */     // GIR_Coverage, 22371,
     /*  820668 */     GIR_EraseRootFromParent_Done,
     /*  820669 */   // Label 12680: @820669
     /*  820669 */   GIM_Try, /*On fail goto*//*Label 12681*/ GIMT_Encode4(820744), // Rule ID 22374 //
     /*  820674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  820677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  820685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  820688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  820691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  820694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820720 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  820720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  820723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  820739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820742 */     GIR_RootConstrainSelectedInstOperands,
     /*  820743 */     // GIR_Coverage, 22374,
     /*  820743 */     GIR_EraseRootFromParent_Done,
     /*  820744 */   // Label 12681: @820744
     /*  820744 */   GIM_Try, /*On fail goto*//*Label 12682*/ GIMT_Encode4(820819), // Rule ID 22375 //
     /*  820749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  820752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  820760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  820763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  820766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  820769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820795 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  820795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  820798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  820814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820817 */     GIR_RootConstrainSelectedInstOperands,
     /*  820818 */     // GIR_Coverage, 22375,
     /*  820818 */     GIR_EraseRootFromParent_Done,
     /*  820819 */   // Label 12682: @820819
     /*  820819 */   GIM_Try, /*On fail goto*//*Label 12683*/ GIMT_Encode4(820894), // Rule ID 22378 //
     /*  820824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  820841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  820859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820870 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  820873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820892 */     GIR_RootConstrainSelectedInstOperands,
     /*  820893 */     // GIR_Coverage, 22378,
     /*  820893 */     GIR_EraseRootFromParent_Done,
     /*  820894 */   // Label 12683: @820894
     /*  820894 */   GIM_Try, /*On fail goto*//*Label 12684*/ GIMT_Encode4(820969), // Rule ID 22379 //
     /*  820899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  820916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  820934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820945 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  820948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820967 */     GIR_RootConstrainSelectedInstOperands,
     /*  820968 */     // GIR_Coverage, 22379,
     /*  820968 */     GIR_EraseRootFromParent_Done,
     /*  820969 */   // Label 12684: @820969
     /*  820969 */   GIM_Try, /*On fail goto*//*Label 12685*/ GIMT_Encode4(821044), // Rule ID 22382 //
     /*  820974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  820991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821020 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  821023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821042 */     GIR_RootConstrainSelectedInstOperands,
     /*  821043 */     // GIR_Coverage, 22382,
     /*  821043 */     GIR_EraseRootFromParent_Done,
     /*  821044 */   // Label 12685: @821044
     /*  821044 */   GIM_Try, /*On fail goto*//*Label 12686*/ GIMT_Encode4(821119), // Rule ID 22383 //
     /*  821049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  821066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821095 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  821098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821117 */     GIR_RootConstrainSelectedInstOperands,
     /*  821118 */     // GIR_Coverage, 22383,
     /*  821118 */     GIR_EraseRootFromParent_Done,
     /*  821119 */   // Label 12686: @821119
     /*  821119 */   GIM_Try, /*On fail goto*//*Label 12687*/ GIMT_Encode4(821194), // Rule ID 22386 //
     /*  821124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821170 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  821173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821192 */     GIR_RootConstrainSelectedInstOperands,
     /*  821193 */     // GIR_Coverage, 22386,
     /*  821193 */     GIR_EraseRootFromParent_Done,
     /*  821194 */   // Label 12687: @821194
     /*  821194 */   GIM_Try, /*On fail goto*//*Label 12688*/ GIMT_Encode4(821269), // Rule ID 22387 //
     /*  821199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821245 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  821248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821267 */     GIR_RootConstrainSelectedInstOperands,
     /*  821268 */     // GIR_Coverage, 22387,
     /*  821268 */     GIR_EraseRootFromParent_Done,
     /*  821269 */   // Label 12688: @821269
     /*  821269 */   GIM_Try, /*On fail goto*//*Label 12689*/ GIMT_Encode4(821344), // Rule ID 22390 //
     /*  821274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821320 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  821320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  821323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821342 */     GIR_RootConstrainSelectedInstOperands,
     /*  821343 */     // GIR_Coverage, 22390,
     /*  821343 */     GIR_EraseRootFromParent_Done,
     /*  821344 */   // Label 12689: @821344
     /*  821344 */   GIM_Try, /*On fail goto*//*Label 12690*/ GIMT_Encode4(821419), // Rule ID 22391 //
     /*  821349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821395 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  821398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821417 */     GIR_RootConstrainSelectedInstOperands,
     /*  821418 */     // GIR_Coverage, 22391,
     /*  821418 */     GIR_EraseRootFromParent_Done,
     /*  821419 */   // Label 12690: @821419
     /*  821419 */   GIM_Try, /*On fail goto*//*Label 12691*/ GIMT_Encode4(821494), // Rule ID 22394 //
     /*  821424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  821441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821470 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  821470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  821473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821492 */     GIR_RootConstrainSelectedInstOperands,
     /*  821493 */     // GIR_Coverage, 22394,
     /*  821493 */     GIR_EraseRootFromParent_Done,
     /*  821494 */   // Label 12691: @821494
     /*  821494 */   GIM_Try, /*On fail goto*//*Label 12692*/ GIMT_Encode4(821569), // Rule ID 22395 //
     /*  821499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  821516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821545 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  821548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821567 */     GIR_RootConstrainSelectedInstOperands,
     /*  821568 */     // GIR_Coverage, 22395,
     /*  821568 */     GIR_EraseRootFromParent_Done,
     /*  821569 */   // Label 12692: @821569
     /*  821569 */   GIM_Try, /*On fail goto*//*Label 12693*/ GIMT_Encode4(821644), // Rule ID 22398 //
     /*  821574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  821591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  821620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  821623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821642 */     GIR_RootConstrainSelectedInstOperands,
     /*  821643 */     // GIR_Coverage, 22398,
     /*  821643 */     GIR_EraseRootFromParent_Done,
     /*  821644 */   // Label 12693: @821644
     /*  821644 */   GIM_Try, /*On fail goto*//*Label 12694*/ GIMT_Encode4(821719), // Rule ID 22399 //
     /*  821649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  821666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821695 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  821698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821717 */     GIR_RootConstrainSelectedInstOperands,
     /*  821718 */     // GIR_Coverage, 22399,
     /*  821718 */     GIR_EraseRootFromParent_Done,
     /*  821719 */   // Label 12694: @821719
     /*  821719 */   GIM_Try, /*On fail goto*//*Label 12695*/ GIMT_Encode4(821794), // Rule ID 22402 //
     /*  821724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  821741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  821770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  821773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821792 */     GIR_RootConstrainSelectedInstOperands,
     /*  821793 */     // GIR_Coverage, 22402,
     /*  821793 */     GIR_EraseRootFromParent_Done,
     /*  821794 */   // Label 12695: @821794
     /*  821794 */   GIM_Try, /*On fail goto*//*Label 12696*/ GIMT_Encode4(821869), // Rule ID 22403 //
     /*  821799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  821816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821845 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  821845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  821848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821867 */     GIR_RootConstrainSelectedInstOperands,
     /*  821868 */     // GIR_Coverage, 22403,
     /*  821868 */     GIR_EraseRootFromParent_Done,
     /*  821869 */   // Label 12696: @821869
     /*  821869 */   GIM_Try, /*On fail goto*//*Label 12697*/ GIMT_Encode4(821944), // Rule ID 22406 //
     /*  821874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  821891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821920 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  821920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  821923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821942 */     GIR_RootConstrainSelectedInstOperands,
     /*  821943 */     // GIR_Coverage, 22406,
     /*  821943 */     GIR_EraseRootFromParent_Done,
     /*  821944 */   // Label 12697: @821944
     /*  821944 */   GIM_Try, /*On fail goto*//*Label 12698*/ GIMT_Encode4(822019), // Rule ID 22407 //
     /*  821949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  821966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821995 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  821995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  821998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822017 */     GIR_RootConstrainSelectedInstOperands,
     /*  822018 */     // GIR_Coverage, 22407,
     /*  822018 */     GIR_EraseRootFromParent_Done,
     /*  822019 */   // Label 12698: @822019
     /*  822019 */   GIM_Try, /*On fail goto*//*Label 12699*/ GIMT_Encode4(822094), // Rule ID 22410 //
     /*  822024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822070 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  822073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822092 */     GIR_RootConstrainSelectedInstOperands,
     /*  822093 */     // GIR_Coverage, 22410,
     /*  822093 */     GIR_EraseRootFromParent_Done,
     /*  822094 */   // Label 12699: @822094
     /*  822094 */   GIM_Try, /*On fail goto*//*Label 12700*/ GIMT_Encode4(822169), // Rule ID 22411 //
     /*  822099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822145 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  822148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822167 */     GIR_RootConstrainSelectedInstOperands,
     /*  822168 */     // GIR_Coverage, 22411,
     /*  822168 */     GIR_EraseRootFromParent_Done,
     /*  822169 */   // Label 12700: @822169
     /*  822169 */   GIM_Try, /*On fail goto*//*Label 12701*/ GIMT_Encode4(822244), // Rule ID 22414 //
     /*  822174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822220 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  822223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822242 */     GIR_RootConstrainSelectedInstOperands,
     /*  822243 */     // GIR_Coverage, 22414,
     /*  822243 */     GIR_EraseRootFromParent_Done,
     /*  822244 */   // Label 12701: @822244
     /*  822244 */   GIM_Try, /*On fail goto*//*Label 12702*/ GIMT_Encode4(822319), // Rule ID 22415 //
     /*  822249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822295 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  822298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822317 */     GIR_RootConstrainSelectedInstOperands,
     /*  822318 */     // GIR_Coverage, 22415,
     /*  822318 */     GIR_EraseRootFromParent_Done,
     /*  822319 */   // Label 12702: @822319
     /*  822319 */   GIM_Try, /*On fail goto*//*Label 12703*/ GIMT_Encode4(822394), // Rule ID 22418 //
     /*  822324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  822341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822370 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  822373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822392 */     GIR_RootConstrainSelectedInstOperands,
     /*  822393 */     // GIR_Coverage, 22418,
     /*  822393 */     GIR_EraseRootFromParent_Done,
     /*  822394 */   // Label 12703: @822394
     /*  822394 */   GIM_Try, /*On fail goto*//*Label 12704*/ GIMT_Encode4(822469), // Rule ID 22419 //
     /*  822399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  822416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822445 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  822448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822467 */     GIR_RootConstrainSelectedInstOperands,
     /*  822468 */     // GIR_Coverage, 22419,
     /*  822468 */     GIR_EraseRootFromParent_Done,
     /*  822469 */   // Label 12704: @822469
     /*  822469 */   GIM_Try, /*On fail goto*//*Label 12705*/ GIMT_Encode4(822544), // Rule ID 22422 //
     /*  822474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  822491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822520 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  822523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822542 */     GIR_RootConstrainSelectedInstOperands,
     /*  822543 */     // GIR_Coverage, 22422,
     /*  822543 */     GIR_EraseRootFromParent_Done,
     /*  822544 */   // Label 12705: @822544
     /*  822544 */   GIM_Try, /*On fail goto*//*Label 12706*/ GIMT_Encode4(822619), // Rule ID 22423 //
     /*  822549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  822566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822595 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  822598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822617 */     GIR_RootConstrainSelectedInstOperands,
     /*  822618 */     // GIR_Coverage, 22423,
     /*  822618 */     GIR_EraseRootFromParent_Done,
     /*  822619 */   // Label 12706: @822619
     /*  822619 */   GIM_Try, /*On fail goto*//*Label 12707*/ GIMT_Encode4(822694), // Rule ID 22426 //
     /*  822624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  822641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822670 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  822670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  822673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822692 */     GIR_RootConstrainSelectedInstOperands,
     /*  822693 */     // GIR_Coverage, 22426,
     /*  822693 */     GIR_EraseRootFromParent_Done,
     /*  822694 */   // Label 12707: @822694
     /*  822694 */   GIM_Try, /*On fail goto*//*Label 12708*/ GIMT_Encode4(822769), // Rule ID 22427 //
     /*  822699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  822716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822745 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  822745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  822748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822767 */     GIR_RootConstrainSelectedInstOperands,
     /*  822768 */     // GIR_Coverage, 22427,
     /*  822768 */     GIR_EraseRootFromParent_Done,
     /*  822769 */   // Label 12708: @822769
     /*  822769 */   GIM_Try, /*On fail goto*//*Label 12709*/ GIMT_Encode4(822844), // Rule ID 22430 //
     /*  822774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  822791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822820 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  822820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  822823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822842 */     GIR_RootConstrainSelectedInstOperands,
     /*  822843 */     // GIR_Coverage, 22430,
     /*  822843 */     GIR_EraseRootFromParent_Done,
     /*  822844 */   // Label 12709: @822844
     /*  822844 */   GIM_Try, /*On fail goto*//*Label 12710*/ GIMT_Encode4(822919), // Rule ID 22431 //
     /*  822849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  822866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822895 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  822895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  822898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822917 */     GIR_RootConstrainSelectedInstOperands,
     /*  822918 */     // GIR_Coverage, 22431,
     /*  822918 */     GIR_EraseRootFromParent_Done,
     /*  822919 */   // Label 12710: @822919
     /*  822919 */   GIM_Try, /*On fail goto*//*Label 12711*/ GIMT_Encode4(822994), // Rule ID 22434 //
     /*  822924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  822941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822970 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  822970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  822973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822992 */     GIR_RootConstrainSelectedInstOperands,
     /*  822993 */     // GIR_Coverage, 22434,
     /*  822993 */     GIR_EraseRootFromParent_Done,
     /*  822994 */   // Label 12711: @822994
     /*  822994 */   GIM_Try, /*On fail goto*//*Label 12712*/ GIMT_Encode4(823069), // Rule ID 22435 //
     /*  822999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  823016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823045 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  823048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823067 */     GIR_RootConstrainSelectedInstOperands,
     /*  823068 */     // GIR_Coverage, 22435,
     /*  823068 */     GIR_EraseRootFromParent_Done,
     /*  823069 */   // Label 12712: @823069
     /*  823069 */   GIM_Try, /*On fail goto*//*Label 12713*/ GIMT_Encode4(823144), // Rule ID 22438 //
     /*  823074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  823123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823142 */     GIR_RootConstrainSelectedInstOperands,
     /*  823143 */     // GIR_Coverage, 22438,
     /*  823143 */     GIR_EraseRootFromParent_Done,
     /*  823144 */   // Label 12713: @823144
     /*  823144 */   GIM_Try, /*On fail goto*//*Label 12714*/ GIMT_Encode4(823219), // Rule ID 22439 //
     /*  823149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823195 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  823198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823217 */     GIR_RootConstrainSelectedInstOperands,
     /*  823218 */     // GIR_Coverage, 22439,
     /*  823218 */     GIR_EraseRootFromParent_Done,
     /*  823219 */   // Label 12714: @823219
     /*  823219 */   GIM_Try, /*On fail goto*//*Label 12715*/ GIMT_Encode4(823294), // Rule ID 22442 //
     /*  823224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  823241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823270 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  823273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823292 */     GIR_RootConstrainSelectedInstOperands,
     /*  823293 */     // GIR_Coverage, 22442,
     /*  823293 */     GIR_EraseRootFromParent_Done,
     /*  823294 */   // Label 12715: @823294
     /*  823294 */   GIM_Try, /*On fail goto*//*Label 12716*/ GIMT_Encode4(823369), // Rule ID 22443 //
     /*  823299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  823316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823345 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  823348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823367 */     GIR_RootConstrainSelectedInstOperands,
     /*  823368 */     // GIR_Coverage, 22443,
     /*  823368 */     GIR_EraseRootFromParent_Done,
     /*  823369 */   // Label 12716: @823369
     /*  823369 */   GIM_Try, /*On fail goto*//*Label 12717*/ GIMT_Encode4(823444), // Rule ID 22446 //
     /*  823374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  823391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823420 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  823420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  823423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823442 */     GIR_RootConstrainSelectedInstOperands,
     /*  823443 */     // GIR_Coverage, 22446,
     /*  823443 */     GIR_EraseRootFromParent_Done,
     /*  823444 */   // Label 12717: @823444
     /*  823444 */   GIM_Try, /*On fail goto*//*Label 12718*/ GIMT_Encode4(823519), // Rule ID 22447 //
     /*  823449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  823466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823495 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  823495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  823498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823517 */     GIR_RootConstrainSelectedInstOperands,
     /*  823518 */     // GIR_Coverage, 22447,
     /*  823518 */     GIR_EraseRootFromParent_Done,
     /*  823519 */   // Label 12718: @823519
     /*  823519 */   GIM_Try, /*On fail goto*//*Label 12719*/ GIMT_Encode4(823594), // Rule ID 22450 //
     /*  823524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  823541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823570 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  823573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823592 */     GIR_RootConstrainSelectedInstOperands,
     /*  823593 */     // GIR_Coverage, 22450,
     /*  823593 */     GIR_EraseRootFromParent_Done,
     /*  823594 */   // Label 12719: @823594
     /*  823594 */   GIM_Try, /*On fail goto*//*Label 12720*/ GIMT_Encode4(823669), // Rule ID 22451 //
     /*  823599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  823616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823645 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  823648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823667 */     GIR_RootConstrainSelectedInstOperands,
     /*  823668 */     // GIR_Coverage, 22451,
     /*  823668 */     GIR_EraseRootFromParent_Done,
     /*  823669 */   // Label 12720: @823669
     /*  823669 */   GIM_Try, /*On fail goto*//*Label 12721*/ GIMT_Encode4(823744), // Rule ID 22454 //
     /*  823674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  823691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  823723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823742 */     GIR_RootConstrainSelectedInstOperands,
     /*  823743 */     // GIR_Coverage, 22454,
     /*  823743 */     GIR_EraseRootFromParent_Done,
     /*  823744 */   // Label 12721: @823744
     /*  823744 */   GIM_Try, /*On fail goto*//*Label 12722*/ GIMT_Encode4(823819), // Rule ID 22455 //
     /*  823749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  823766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823795 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  823798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823817 */     GIR_RootConstrainSelectedInstOperands,
     /*  823818 */     // GIR_Coverage, 22455,
     /*  823818 */     GIR_EraseRootFromParent_Done,
     /*  823819 */   // Label 12722: @823819
     /*  823819 */   GIM_Try, /*On fail goto*//*Label 12723*/ GIMT_Encode4(823894), // Rule ID 22458 //
     /*  823824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  823841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823870 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  823870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  823873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823892 */     GIR_RootConstrainSelectedInstOperands,
     /*  823893 */     // GIR_Coverage, 22458,
     /*  823893 */     GIR_EraseRootFromParent_Done,
     /*  823894 */   // Label 12723: @823894
     /*  823894 */   GIM_Try, /*On fail goto*//*Label 12724*/ GIMT_Encode4(823969), // Rule ID 22459 //
     /*  823899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  823916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823945 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  823945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  823948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823967 */     GIR_RootConstrainSelectedInstOperands,
     /*  823968 */     // GIR_Coverage, 22459,
     /*  823968 */     GIR_EraseRootFromParent_Done,
     /*  823969 */   // Label 12724: @823969
     /*  823969 */   GIM_Try, /*On fail goto*//*Label 12725*/ GIMT_Encode4(824044), // Rule ID 22462 //
     /*  823974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  823977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  823985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  823988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  823991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  823994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  824020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  824023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  824039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824042 */     GIR_RootConstrainSelectedInstOperands,
     /*  824043 */     // GIR_Coverage, 22462,
     /*  824043 */     GIR_EraseRootFromParent_Done,
     /*  824044 */   // Label 12725: @824044
     /*  824044 */   GIM_Try, /*On fail goto*//*Label 12726*/ GIMT_Encode4(824119), // Rule ID 22463 //
     /*  824049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  824052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  824060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  824063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  824066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  824069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824095 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  824095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  824098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  824114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824117 */     GIR_RootConstrainSelectedInstOperands,
     /*  824118 */     // GIR_Coverage, 22463,
     /*  824118 */     GIR_EraseRootFromParent_Done,
     /*  824119 */   // Label 12726: @824119
     /*  824119 */   GIM_Try, /*On fail goto*//*Label 12727*/ GIMT_Encode4(824194), // Rule ID 22466 //
     /*  824124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  824141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824170 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  824173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824192 */     GIR_RootConstrainSelectedInstOperands,
     /*  824193 */     // GIR_Coverage, 22466,
     /*  824193 */     GIR_EraseRootFromParent_Done,
     /*  824194 */   // Label 12727: @824194
     /*  824194 */   GIM_Try, /*On fail goto*//*Label 12728*/ GIMT_Encode4(824269), // Rule ID 22467 //
     /*  824199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  824216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824245 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  824248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824267 */     GIR_RootConstrainSelectedInstOperands,
     /*  824268 */     // GIR_Coverage, 22467,
     /*  824268 */     GIR_EraseRootFromParent_Done,
     /*  824269 */   // Label 12728: @824269
     /*  824269 */   GIM_Try, /*On fail goto*//*Label 12729*/ GIMT_Encode4(824344), // Rule ID 22470 //
     /*  824274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  824291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824320 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  824323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824342 */     GIR_RootConstrainSelectedInstOperands,
     /*  824343 */     // GIR_Coverage, 22470,
     /*  824343 */     GIR_EraseRootFromParent_Done,
     /*  824344 */   // Label 12729: @824344
     /*  824344 */   GIM_Try, /*On fail goto*//*Label 12730*/ GIMT_Encode4(824419), // Rule ID 22471 //
     /*  824349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  824366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824395 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  824398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824417 */     GIR_RootConstrainSelectedInstOperands,
     /*  824418 */     // GIR_Coverage, 22471,
     /*  824418 */     GIR_EraseRootFromParent_Done,
     /*  824419 */   // Label 12730: @824419
     /*  824419 */   GIM_Try, /*On fail goto*//*Label 12731*/ GIMT_Encode4(824494), // Rule ID 22474 //
     /*  824424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  824441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824470 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  824473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824492 */     GIR_RootConstrainSelectedInstOperands,
     /*  824493 */     // GIR_Coverage, 22474,
     /*  824493 */     GIR_EraseRootFromParent_Done,
     /*  824494 */   // Label 12731: @824494
     /*  824494 */   GIM_Try, /*On fail goto*//*Label 12732*/ GIMT_Encode4(824569), // Rule ID 22475 //
     /*  824499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  824516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824545 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  824548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824567 */     GIR_RootConstrainSelectedInstOperands,
     /*  824568 */     // GIR_Coverage, 22475,
     /*  824568 */     GIR_EraseRootFromParent_Done,
     /*  824569 */   // Label 12732: @824569
     /*  824569 */   GIM_Try, /*On fail goto*//*Label 12733*/ GIMT_Encode4(824644), // Rule ID 22478 //
     /*  824574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  824591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  824620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  824623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824642 */     GIR_RootConstrainSelectedInstOperands,
     /*  824643 */     // GIR_Coverage, 22478,
     /*  824643 */     GIR_EraseRootFromParent_Done,
     /*  824644 */   // Label 12733: @824644
     /*  824644 */   GIM_Try, /*On fail goto*//*Label 12734*/ GIMT_Encode4(824719), // Rule ID 22479 //
     /*  824649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  824666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824695 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  824695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  824698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824717 */     GIR_RootConstrainSelectedInstOperands,
     /*  824718 */     // GIR_Coverage, 22479,
     /*  824718 */     GIR_EraseRootFromParent_Done,
     /*  824719 */   // Label 12734: @824719
     /*  824719 */   GIM_Try, /*On fail goto*//*Label 12735*/ GIMT_Encode4(824794), // Rule ID 22482 //
     /*  824724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  824741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  824770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  824773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824792 */     GIR_RootConstrainSelectedInstOperands,
     /*  824793 */     // GIR_Coverage, 22482,
     /*  824793 */     GIR_EraseRootFromParent_Done,
     /*  824794 */   // Label 12735: @824794
     /*  824794 */   GIM_Try, /*On fail goto*//*Label 12736*/ GIMT_Encode4(824869), // Rule ID 22483 //
     /*  824799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  824816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824845 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  824845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  824848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824867 */     GIR_RootConstrainSelectedInstOperands,
     /*  824868 */     // GIR_Coverage, 22483,
     /*  824868 */     GIR_EraseRootFromParent_Done,
     /*  824869 */   // Label 12736: @824869
     /*  824869 */   GIM_Try, /*On fail goto*//*Label 12737*/ GIMT_Encode4(824944), // Rule ID 22486 //
     /*  824874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  824891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824920 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  824920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  824923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824942 */     GIR_RootConstrainSelectedInstOperands,
     /*  824943 */     // GIR_Coverage, 22486,
     /*  824943 */     GIR_EraseRootFromParent_Done,
     /*  824944 */   // Label 12737: @824944
     /*  824944 */   GIM_Try, /*On fail goto*//*Label 12738*/ GIMT_Encode4(825019), // Rule ID 22487 //
     /*  824949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  824966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824995 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  824995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  824998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825017 */     GIR_RootConstrainSelectedInstOperands,
     /*  825018 */     // GIR_Coverage, 22487,
     /*  825018 */     GIR_EraseRootFromParent_Done,
     /*  825019 */   // Label 12738: @825019
     /*  825019 */   GIM_Try, /*On fail goto*//*Label 12739*/ GIMT_Encode4(825094), // Rule ID 22490 //
     /*  825024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  825041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825070 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  825073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825092 */     GIR_RootConstrainSelectedInstOperands,
     /*  825093 */     // GIR_Coverage, 22490,
     /*  825093 */     GIR_EraseRootFromParent_Done,
     /*  825094 */   // Label 12739: @825094
     /*  825094 */   GIM_Try, /*On fail goto*//*Label 12740*/ GIMT_Encode4(825169), // Rule ID 22491 //
     /*  825099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  825116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825145 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  825148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825167 */     GIR_RootConstrainSelectedInstOperands,
     /*  825168 */     // GIR_Coverage, 22491,
     /*  825168 */     GIR_EraseRootFromParent_Done,
     /*  825169 */   // Label 12740: @825169
     /*  825169 */   GIM_Try, /*On fail goto*//*Label 12741*/ GIMT_Encode4(825244), // Rule ID 22494 //
     /*  825174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  825191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825220 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  825223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825242 */     GIR_RootConstrainSelectedInstOperands,
     /*  825243 */     // GIR_Coverage, 22494,
     /*  825243 */     GIR_EraseRootFromParent_Done,
     /*  825244 */   // Label 12741: @825244
     /*  825244 */   GIM_Try, /*On fail goto*//*Label 12742*/ GIMT_Encode4(825319), // Rule ID 22495 //
     /*  825249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  825266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825295 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  825298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825317 */     GIR_RootConstrainSelectedInstOperands,
     /*  825318 */     // GIR_Coverage, 22495,
     /*  825318 */     GIR_EraseRootFromParent_Done,
     /*  825319 */   // Label 12742: @825319
     /*  825319 */   GIM_Try, /*On fail goto*//*Label 12743*/ GIMT_Encode4(825394), // Rule ID 22498 //
     /*  825324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  825341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825370 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  825373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825392 */     GIR_RootConstrainSelectedInstOperands,
     /*  825393 */     // GIR_Coverage, 22498,
     /*  825393 */     GIR_EraseRootFromParent_Done,
     /*  825394 */   // Label 12743: @825394
     /*  825394 */   GIM_Try, /*On fail goto*//*Label 12744*/ GIMT_Encode4(825469), // Rule ID 22499 //
     /*  825399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  825416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825445 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  825448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825467 */     GIR_RootConstrainSelectedInstOperands,
     /*  825468 */     // GIR_Coverage, 22499,
     /*  825468 */     GIR_EraseRootFromParent_Done,
     /*  825469 */   // Label 12744: @825469
     /*  825469 */   GIM_Try, /*On fail goto*//*Label 12745*/ GIMT_Encode4(825544), // Rule ID 22502 //
     /*  825474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  825477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  825491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825520 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  825520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  825523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825542 */     GIR_RootConstrainSelectedInstOperands,
     /*  825543 */     // GIR_Coverage, 22502,
     /*  825543 */     GIR_EraseRootFromParent_Done,
     /*  825544 */   // Label 12745: @825544
     /*  825544 */   GIM_Try, /*On fail goto*//*Label 12746*/ GIMT_Encode4(825619), // Rule ID 22503 //
     /*  825549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  825552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  825566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825595 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  825595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  825598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825617 */     GIR_RootConstrainSelectedInstOperands,
     /*  825618 */     // GIR_Coverage, 22503,
     /*  825618 */     GIR_EraseRootFromParent_Done,
     /*  825619 */   // Label 12746: @825619
     /*  825619 */   GIM_Try, /*On fail goto*//*Label 12747*/ GIMT_Encode4(825694), // Rule ID 22506 //
     /*  825624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  825627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  825641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825670 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  825670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  825673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825692 */     GIR_RootConstrainSelectedInstOperands,
     /*  825693 */     // GIR_Coverage, 22506,
     /*  825693 */     GIR_EraseRootFromParent_Done,
     /*  825694 */   // Label 12747: @825694
     /*  825694 */   GIM_Try, /*On fail goto*//*Label 12748*/ GIMT_Encode4(825769), // Rule ID 22507 //
     /*  825699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  825702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  825716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825745 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  825745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  825748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825767 */     GIR_RootConstrainSelectedInstOperands,
     /*  825768 */     // GIR_Coverage, 22507,
     /*  825768 */     GIR_EraseRootFromParent_Done,
     /*  825769 */   // Label 12748: @825769
     /*  825769 */   GIM_Try, /*On fail goto*//*Label 12749*/ GIMT_Encode4(825844), // Rule ID 22510 //
     /*  825774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  825777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  825791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825820 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  825820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  825823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825842 */     GIR_RootConstrainSelectedInstOperands,
     /*  825843 */     // GIR_Coverage, 22510,
     /*  825843 */     GIR_EraseRootFromParent_Done,
     /*  825844 */   // Label 12749: @825844
     /*  825844 */   GIM_Try, /*On fail goto*//*Label 12750*/ GIMT_Encode4(825919), // Rule ID 22511 //
     /*  825849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  825852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  825866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825895 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  825895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  825898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825917 */     GIR_RootConstrainSelectedInstOperands,
     /*  825918 */     // GIR_Coverage, 22511,
     /*  825918 */     GIR_EraseRootFromParent_Done,
     /*  825919 */   // Label 12750: @825919
     /*  825919 */   GIM_Try, /*On fail goto*//*Label 12751*/ GIMT_Encode4(825994), // Rule ID 22514 //
     /*  825924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  825932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  825935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  825938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  825941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  825944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825970 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  825970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  825973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825992 */     GIR_RootConstrainSelectedInstOperands,
     /*  825993 */     // GIR_Coverage, 22514,
     /*  825993 */     GIR_EraseRootFromParent_Done,
     /*  825994 */   // Label 12751: @825994
     /*  825994 */   GIM_Try, /*On fail goto*//*Label 12752*/ GIMT_Encode4(826069), // Rule ID 22515 //
     /*  825999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  826016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826045 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  826048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826067 */     GIR_RootConstrainSelectedInstOperands,
     /*  826068 */     // GIR_Coverage, 22515,
     /*  826068 */     GIR_EraseRootFromParent_Done,
     /*  826069 */   // Label 12752: @826069
     /*  826069 */   GIM_Try, /*On fail goto*//*Label 12753*/ GIMT_Encode4(826144), // Rule ID 22518 //
     /*  826074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  826091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826120 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  826123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826142 */     GIR_RootConstrainSelectedInstOperands,
     /*  826143 */     // GIR_Coverage, 22518,
     /*  826143 */     GIR_EraseRootFromParent_Done,
     /*  826144 */   // Label 12753: @826144
     /*  826144 */   GIM_Try, /*On fail goto*//*Label 12754*/ GIMT_Encode4(826219), // Rule ID 22519 //
     /*  826149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  826166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826195 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  826198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826217 */     GIR_RootConstrainSelectedInstOperands,
     /*  826218 */     // GIR_Coverage, 22519,
     /*  826218 */     GIR_EraseRootFromParent_Done,
     /*  826219 */   // Label 12754: @826219
     /*  826219 */   GIM_Try, /*On fail goto*//*Label 12755*/ GIMT_Encode4(826294), // Rule ID 22522 //
     /*  826224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  826241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826270 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  826273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826292 */     GIR_RootConstrainSelectedInstOperands,
     /*  826293 */     // GIR_Coverage, 22522,
     /*  826293 */     GIR_EraseRootFromParent_Done,
     /*  826294 */   // Label 12755: @826294
     /*  826294 */   GIM_Try, /*On fail goto*//*Label 12756*/ GIMT_Encode4(826369), // Rule ID 22523 //
     /*  826299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  826316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826345 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  826348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826367 */     GIR_RootConstrainSelectedInstOperands,
     /*  826368 */     // GIR_Coverage, 22523,
     /*  826368 */     GIR_EraseRootFromParent_Done,
     /*  826369 */   // Label 12756: @826369
     /*  826369 */   GIM_Try, /*On fail goto*//*Label 12757*/ GIMT_Encode4(826444), // Rule ID 22526 //
     /*  826374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  826391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826420 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  826420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  826423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826442 */     GIR_RootConstrainSelectedInstOperands,
     /*  826443 */     // GIR_Coverage, 22526,
     /*  826443 */     GIR_EraseRootFromParent_Done,
     /*  826444 */   // Label 12757: @826444
     /*  826444 */   GIM_Try, /*On fail goto*//*Label 12758*/ GIMT_Encode4(826519), // Rule ID 22527 //
     /*  826449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  826466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826495 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  826495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  826498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826517 */     GIR_RootConstrainSelectedInstOperands,
     /*  826518 */     // GIR_Coverage, 22527,
     /*  826518 */     GIR_EraseRootFromParent_Done,
     /*  826519 */   // Label 12758: @826519
     /*  826519 */   GIM_Try, /*On fail goto*//*Label 12759*/ GIMT_Encode4(826594), // Rule ID 22530 //
     /*  826524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  826541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826570 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  826570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  826573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826592 */     GIR_RootConstrainSelectedInstOperands,
     /*  826593 */     // GIR_Coverage, 22530,
     /*  826593 */     GIR_EraseRootFromParent_Done,
     /*  826594 */   // Label 12759: @826594
     /*  826594 */   GIM_Try, /*On fail goto*//*Label 12760*/ GIMT_Encode4(826669), // Rule ID 22531 //
     /*  826599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  826616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826645 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  826645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  826648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826667 */     GIR_RootConstrainSelectedInstOperands,
     /*  826668 */     // GIR_Coverage, 22531,
     /*  826668 */     GIR_EraseRootFromParent_Done,
     /*  826669 */   // Label 12760: @826669
     /*  826669 */   GIM_Try, /*On fail goto*//*Label 12761*/ GIMT_Encode4(826744), // Rule ID 22534 //
     /*  826674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  826685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  826688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  826691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  826694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826720 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  826720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  826723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826742 */     GIR_RootConstrainSelectedInstOperands,
     /*  826743 */     // GIR_Coverage, 22534,
     /*  826743 */     GIR_EraseRootFromParent_Done,
     /*  826744 */   // Label 12761: @826744
     /*  826744 */   GIM_Try, /*On fail goto*//*Label 12762*/ GIMT_Encode4(826819), // Rule ID 22535 //
     /*  826749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  826760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  826763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  826766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  826769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826795 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  826795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  826798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826817 */     GIR_RootConstrainSelectedInstOperands,
     /*  826818 */     // GIR_Coverage, 22535,
     /*  826818 */     GIR_EraseRootFromParent_Done,
     /*  826819 */   // Label 12762: @826819
     /*  826819 */   GIM_Try, /*On fail goto*//*Label 12763*/ GIMT_Encode4(826894), // Rule ID 22538 //
     /*  826824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  826841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826870 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  826873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826892 */     GIR_RootConstrainSelectedInstOperands,
     /*  826893 */     // GIR_Coverage, 22538,
     /*  826893 */     GIR_EraseRootFromParent_Done,
     /*  826894 */   // Label 12763: @826894
     /*  826894 */   GIM_Try, /*On fail goto*//*Label 12764*/ GIMT_Encode4(826969), // Rule ID 22539 //
     /*  826899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  826916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826945 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  826948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826967 */     GIR_RootConstrainSelectedInstOperands,
     /*  826968 */     // GIR_Coverage, 22539,
     /*  826968 */     GIR_EraseRootFromParent_Done,
     /*  826969 */   // Label 12764: @826969
     /*  826969 */   GIM_Try, /*On fail goto*//*Label 12765*/ GIMT_Encode4(827044), // Rule ID 22542 //
     /*  826974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  826991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  827023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827042 */     GIR_RootConstrainSelectedInstOperands,
     /*  827043 */     // GIR_Coverage, 22542,
     /*  827043 */     GIR_EraseRootFromParent_Done,
     /*  827044 */   // Label 12765: @827044
     /*  827044 */   GIM_Try, /*On fail goto*//*Label 12766*/ GIMT_Encode4(827119), // Rule ID 22543 //
     /*  827049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  827066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827095 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  827098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827117 */     GIR_RootConstrainSelectedInstOperands,
     /*  827118 */     // GIR_Coverage, 22543,
     /*  827118 */     GIR_EraseRootFromParent_Done,
     /*  827119 */   // Label 12766: @827119
     /*  827119 */   GIM_Try, /*On fail goto*//*Label 12767*/ GIMT_Encode4(827194), // Rule ID 22546 //
     /*  827124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  827141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  827170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  827173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827192 */     GIR_RootConstrainSelectedInstOperands,
     /*  827193 */     // GIR_Coverage, 22546,
     /*  827193 */     GIR_EraseRootFromParent_Done,
     /*  827194 */   // Label 12767: @827194
     /*  827194 */   GIM_Try, /*On fail goto*//*Label 12768*/ GIMT_Encode4(827269), // Rule ID 22547 //
     /*  827199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  827216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827245 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  827245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  827248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827267 */     GIR_RootConstrainSelectedInstOperands,
     /*  827268 */     // GIR_Coverage, 22547,
     /*  827268 */     GIR_EraseRootFromParent_Done,
     /*  827269 */   // Label 12768: @827269
     /*  827269 */   GIM_Try, /*On fail goto*//*Label 12769*/ GIMT_Encode4(827344), // Rule ID 22550 //
     /*  827274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  827277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  827285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  827288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  827291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  827294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827320 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  827320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  827323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827342 */     GIR_RootConstrainSelectedInstOperands,
     /*  827343 */     // GIR_Coverage, 22550,
     /*  827343 */     GIR_EraseRootFromParent_Done,
     /*  827344 */   // Label 12769: @827344
     /*  827344 */   GIM_Try, /*On fail goto*//*Label 12770*/ GIMT_Encode4(827419), // Rule ID 22551 //
     /*  827349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  827352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  827360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  827363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  827366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  827369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827395 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  827395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  827398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827417 */     GIR_RootConstrainSelectedInstOperands,
     /*  827418 */     // GIR_Coverage, 22551,
     /*  827418 */     GIR_EraseRootFromParent_Done,
     /*  827419 */   // Label 12770: @827419
     /*  827419 */   GIM_Try, /*On fail goto*//*Label 12771*/ GIMT_Encode4(827494), // Rule ID 22554 //
     /*  827424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  827441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827470 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  827473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827492 */     GIR_RootConstrainSelectedInstOperands,
     /*  827493 */     // GIR_Coverage, 22554,
     /*  827493 */     GIR_EraseRootFromParent_Done,
     /*  827494 */   // Label 12771: @827494
     /*  827494 */   GIM_Try, /*On fail goto*//*Label 12772*/ GIMT_Encode4(827569), // Rule ID 22555 //
     /*  827499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  827516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827545 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  827548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827567 */     GIR_RootConstrainSelectedInstOperands,
     /*  827568 */     // GIR_Coverage, 22555,
     /*  827568 */     GIR_EraseRootFromParent_Done,
     /*  827569 */   // Label 12772: @827569
     /*  827569 */   GIM_Try, /*On fail goto*//*Label 12773*/ GIMT_Encode4(827644), // Rule ID 22558 //
     /*  827574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  827591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  827609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827620 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  827623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827642 */     GIR_RootConstrainSelectedInstOperands,
     /*  827643 */     // GIR_Coverage, 22558,
     /*  827643 */     GIR_EraseRootFromParent_Done,
     /*  827644 */   // Label 12773: @827644
     /*  827644 */   GIM_Try, /*On fail goto*//*Label 12774*/ GIMT_Encode4(827719), // Rule ID 22559 //
     /*  827649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  827666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  827684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827695 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  827698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827717 */     GIR_RootConstrainSelectedInstOperands,
     /*  827718 */     // GIR_Coverage, 22559,
     /*  827718 */     GIR_EraseRootFromParent_Done,
     /*  827719 */   // Label 12774: @827719
     /*  827719 */   GIM_Try, /*On fail goto*//*Label 12775*/ GIMT_Encode4(827794), // Rule ID 22562 //
     /*  827724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  827741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827770 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  827773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827792 */     GIR_RootConstrainSelectedInstOperands,
     /*  827793 */     // GIR_Coverage, 22562,
     /*  827793 */     GIR_EraseRootFromParent_Done,
     /*  827794 */   // Label 12775: @827794
     /*  827794 */   GIM_Try, /*On fail goto*//*Label 12776*/ GIMT_Encode4(827869), // Rule ID 22563 //
     /*  827799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  827816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827845 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  827848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827867 */     GIR_RootConstrainSelectedInstOperands,
     /*  827868 */     // GIR_Coverage, 22563,
     /*  827868 */     GIR_EraseRootFromParent_Done,
     /*  827869 */   // Label 12776: @827869
     /*  827869 */   GIM_Try, /*On fail goto*//*Label 12777*/ GIMT_Encode4(827944), // Rule ID 22566 //
     /*  827874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  827891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827920 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  827923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827942 */     GIR_RootConstrainSelectedInstOperands,
     /*  827943 */     // GIR_Coverage, 22566,
     /*  827943 */     GIR_EraseRootFromParent_Done,
     /*  827944 */   // Label 12777: @827944
     /*  827944 */   GIM_Try, /*On fail goto*//*Label 12778*/ GIMT_Encode4(828019), // Rule ID 22567 //
     /*  827949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  827966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827995 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  827998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828017 */     GIR_RootConstrainSelectedInstOperands,
     /*  828018 */     // GIR_Coverage, 22567,
     /*  828018 */     GIR_EraseRootFromParent_Done,
     /*  828019 */   // Label 12778: @828019
     /*  828019 */   GIM_Try, /*On fail goto*//*Label 12779*/ GIMT_Encode4(828094), // Rule ID 22570 //
     /*  828024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828070 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  828073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828092 */     GIR_RootConstrainSelectedInstOperands,
     /*  828093 */     // GIR_Coverage, 22570,
     /*  828093 */     GIR_EraseRootFromParent_Done,
     /*  828094 */   // Label 12779: @828094
     /*  828094 */   GIM_Try, /*On fail goto*//*Label 12780*/ GIMT_Encode4(828169), // Rule ID 22571 //
     /*  828099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828145 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  828148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828167 */     GIR_RootConstrainSelectedInstOperands,
     /*  828168 */     // GIR_Coverage, 22571,
     /*  828168 */     GIR_EraseRootFromParent_Done,
     /*  828169 */   // Label 12780: @828169
     /*  828169 */   GIM_Try, /*On fail goto*//*Label 12781*/ GIMT_Encode4(828244), // Rule ID 22574 //
     /*  828174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828220 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  828223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828242 */     GIR_RootConstrainSelectedInstOperands,
     /*  828243 */     // GIR_Coverage, 22574,
     /*  828243 */     GIR_EraseRootFromParent_Done,
     /*  828244 */   // Label 12781: @828244
     /*  828244 */   GIM_Try, /*On fail goto*//*Label 12782*/ GIMT_Encode4(828319), // Rule ID 22575 //
     /*  828249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828295 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  828298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828317 */     GIR_RootConstrainSelectedInstOperands,
     /*  828318 */     // GIR_Coverage, 22575,
     /*  828318 */     GIR_EraseRootFromParent_Done,
     /*  828319 */   // Label 12782: @828319
     /*  828319 */   GIM_Try, /*On fail goto*//*Label 12783*/ GIMT_Encode4(828394), // Rule ID 22578 //
     /*  828324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828370 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  828373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828392 */     GIR_RootConstrainSelectedInstOperands,
     /*  828393 */     // GIR_Coverage, 22578,
     /*  828393 */     GIR_EraseRootFromParent_Done,
     /*  828394 */   // Label 12783: @828394
     /*  828394 */   GIM_Try, /*On fail goto*//*Label 12784*/ GIMT_Encode4(828469), // Rule ID 22579 //
     /*  828399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828445 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  828445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  828448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828467 */     GIR_RootConstrainSelectedInstOperands,
     /*  828468 */     // GIR_Coverage, 22579,
     /*  828468 */     GIR_EraseRootFromParent_Done,
     /*  828469 */   // Label 12784: @828469
     /*  828469 */   GIM_Try, /*On fail goto*//*Label 12785*/ GIMT_Encode4(828544), // Rule ID 22582 //
     /*  828474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  828491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828520 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  828523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828542 */     GIR_RootConstrainSelectedInstOperands,
     /*  828543 */     // GIR_Coverage, 22582,
     /*  828543 */     GIR_EraseRootFromParent_Done,
     /*  828544 */   // Label 12785: @828544
     /*  828544 */   GIM_Try, /*On fail goto*//*Label 12786*/ GIMT_Encode4(828619), // Rule ID 22583 //
     /*  828549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  828566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828595 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  828595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  828598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828617 */     GIR_RootConstrainSelectedInstOperands,
     /*  828618 */     // GIR_Coverage, 22583,
     /*  828618 */     GIR_EraseRootFromParent_Done,
     /*  828619 */   // Label 12786: @828619
     /*  828619 */   GIM_Try, /*On fail goto*//*Label 12787*/ GIMT_Encode4(828694), // Rule ID 22586 //
     /*  828624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  828641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  828673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828692 */     GIR_RootConstrainSelectedInstOperands,
     /*  828693 */     // GIR_Coverage, 22586,
     /*  828693 */     GIR_EraseRootFromParent_Done,
     /*  828694 */   // Label 12787: @828694
     /*  828694 */   GIM_Try, /*On fail goto*//*Label 12788*/ GIMT_Encode4(828769), // Rule ID 22587 //
     /*  828699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  828716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828745 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  828745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  828748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828767 */     GIR_RootConstrainSelectedInstOperands,
     /*  828768 */     // GIR_Coverage, 22587,
     /*  828768 */     GIR_EraseRootFromParent_Done,
     /*  828769 */   // Label 12788: @828769
     /*  828769 */   GIM_Try, /*On fail goto*//*Label 12789*/ GIMT_Encode4(828844), // Rule ID 22590 //
     /*  828774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  828777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  828791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  828794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828820 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  828820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  828823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828842 */     GIR_RootConstrainSelectedInstOperands,
     /*  828843 */     // GIR_Coverage, 22590,
     /*  828843 */     GIR_EraseRootFromParent_Done,
     /*  828844 */   // Label 12789: @828844
     /*  828844 */   GIM_Try, /*On fail goto*//*Label 12790*/ GIMT_Encode4(828919), // Rule ID 22591 //
     /*  828849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  828852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  828866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  828869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828895 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  828895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  828898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828917 */     GIR_RootConstrainSelectedInstOperands,
     /*  828918 */     // GIR_Coverage, 22591,
     /*  828918 */     GIR_EraseRootFromParent_Done,
     /*  828919 */   // Label 12790: @828919
     /*  828919 */   GIM_Try, /*On fail goto*//*Label 12791*/ GIMT_Encode4(828994), // Rule ID 22594 //
     /*  828924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  828927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  828941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  828944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828970 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  828970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  828973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828992 */     GIR_RootConstrainSelectedInstOperands,
     /*  828993 */     // GIR_Coverage, 22594,
     /*  828993 */     GIR_EraseRootFromParent_Done,
     /*  828994 */   // Label 12791: @828994
     /*  828994 */   GIM_Try, /*On fail goto*//*Label 12792*/ GIMT_Encode4(829069), // Rule ID 22595 //
     /*  828999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  829016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829045 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  829048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829067 */     GIR_RootConstrainSelectedInstOperands,
     /*  829068 */     // GIR_Coverage, 22595,
     /*  829068 */     GIR_EraseRootFromParent_Done,
     /*  829069 */   // Label 12792: @829069
     /*  829069 */   GIM_Try, /*On fail goto*//*Label 12793*/ GIMT_Encode4(829144), // Rule ID 22598 //
     /*  829074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  829123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829142 */     GIR_RootConstrainSelectedInstOperands,
     /*  829143 */     // GIR_Coverage, 22598,
     /*  829143 */     GIR_EraseRootFromParent_Done,
     /*  829144 */   // Label 12793: @829144
     /*  829144 */   GIM_Try, /*On fail goto*//*Label 12794*/ GIMT_Encode4(829219), // Rule ID 22599 //
     /*  829149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829195 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  829198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829217 */     GIR_RootConstrainSelectedInstOperands,
     /*  829218 */     // GIR_Coverage, 22599,
     /*  829218 */     GIR_EraseRootFromParent_Done,
     /*  829219 */   // Label 12794: @829219
     /*  829219 */   GIM_Try, /*On fail goto*//*Label 12795*/ GIMT_Encode4(829294), // Rule ID 22602 //
     /*  829224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  829241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829270 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  829273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829292 */     GIR_RootConstrainSelectedInstOperands,
     /*  829293 */     // GIR_Coverage, 22602,
     /*  829293 */     GIR_EraseRootFromParent_Done,
     /*  829294 */   // Label 12795: @829294
     /*  829294 */   GIM_Try, /*On fail goto*//*Label 12796*/ GIMT_Encode4(829369), // Rule ID 22603 //
     /*  829299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  829316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829345 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  829348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829367 */     GIR_RootConstrainSelectedInstOperands,
     /*  829368 */     // GIR_Coverage, 22603,
     /*  829368 */     GIR_EraseRootFromParent_Done,
     /*  829369 */   // Label 12796: @829369
     /*  829369 */   GIM_Try, /*On fail goto*//*Label 12797*/ GIMT_Encode4(829444), // Rule ID 22606 //
     /*  829374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  829391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829420 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  829423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829442 */     GIR_RootConstrainSelectedInstOperands,
     /*  829443 */     // GIR_Coverage, 22606,
     /*  829443 */     GIR_EraseRootFromParent_Done,
     /*  829444 */   // Label 12797: @829444
     /*  829444 */   GIM_Try, /*On fail goto*//*Label 12798*/ GIMT_Encode4(829519), // Rule ID 22607 //
     /*  829449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  829466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829495 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  829498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829517 */     GIR_RootConstrainSelectedInstOperands,
     /*  829518 */     // GIR_Coverage, 22607,
     /*  829518 */     GIR_EraseRootFromParent_Done,
     /*  829519 */   // Label 12798: @829519
     /*  829519 */   GIM_Try, /*On fail goto*//*Label 12799*/ GIMT_Encode4(829594), // Rule ID 22610 //
     /*  829524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  829541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829570 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  829573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829592 */     GIR_RootConstrainSelectedInstOperands,
     /*  829593 */     // GIR_Coverage, 22610,
     /*  829593 */     GIR_EraseRootFromParent_Done,
     /*  829594 */   // Label 12799: @829594
     /*  829594 */   GIM_Try, /*On fail goto*//*Label 12800*/ GIMT_Encode4(829669), // Rule ID 22611 //
     /*  829599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  829616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829645 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  829648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829667 */     GIR_RootConstrainSelectedInstOperands,
     /*  829668 */     // GIR_Coverage, 22611,
     /*  829668 */     GIR_EraseRootFromParent_Done,
     /*  829669 */   // Label 12800: @829669
     /*  829669 */   GIM_Try, /*On fail goto*//*Label 12801*/ GIMT_Encode4(829744), // Rule ID 22614 //
     /*  829674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  829691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  829720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  829723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829742 */     GIR_RootConstrainSelectedInstOperands,
     /*  829743 */     // GIR_Coverage, 22614,
     /*  829743 */     GIR_EraseRootFromParent_Done,
     /*  829744 */   // Label 12801: @829744
     /*  829744 */   GIM_Try, /*On fail goto*//*Label 12802*/ GIMT_Encode4(829819), // Rule ID 22615 //
     /*  829749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  829766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829795 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  829795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  829798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829817 */     GIR_RootConstrainSelectedInstOperands,
     /*  829818 */     // GIR_Coverage, 22615,
     /*  829818 */     GIR_EraseRootFromParent_Done,
     /*  829819 */   // Label 12802: @829819
     /*  829819 */   GIM_Try, /*On fail goto*//*Label 12803*/ GIMT_Encode4(829894), // Rule ID 22618 //
     /*  829824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  829841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829870 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  829870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  829873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829892 */     GIR_RootConstrainSelectedInstOperands,
     /*  829893 */     // GIR_Coverage, 22618,
     /*  829893 */     GIR_EraseRootFromParent_Done,
     /*  829894 */   // Label 12803: @829894
     /*  829894 */   GIM_Try, /*On fail goto*//*Label 12804*/ GIMT_Encode4(829969), // Rule ID 22619 //
     /*  829899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  829916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829945 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  829945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  829948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829967 */     GIR_RootConstrainSelectedInstOperands,
     /*  829968 */     // GIR_Coverage, 22619,
     /*  829968 */     GIR_EraseRootFromParent_Done,
     /*  829969 */   // Label 12804: @829969
     /*  829969 */   GIM_Try, /*On fail goto*//*Label 12805*/ GIMT_Encode4(830044), // Rule ID 22622 //
     /*  829974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  829991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  830020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  830023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830042 */     GIR_RootConstrainSelectedInstOperands,
     /*  830043 */     // GIR_Coverage, 22622,
     /*  830043 */     GIR_EraseRootFromParent_Done,
     /*  830044 */   // Label 12805: @830044
     /*  830044 */   GIM_Try, /*On fail goto*//*Label 12806*/ GIMT_Encode4(830119), // Rule ID 22623 //
     /*  830049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  830066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830095 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  830095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  830098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830117 */     GIR_RootConstrainSelectedInstOperands,
     /*  830118 */     // GIR_Coverage, 22623,
     /*  830118 */     GIR_EraseRootFromParent_Done,
     /*  830119 */   // Label 12806: @830119
     /*  830119 */   GIM_Try, /*On fail goto*//*Label 12807*/ GIMT_Encode4(830194), // Rule ID 22626 //
     /*  830124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  830141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830170 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  830173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830192 */     GIR_RootConstrainSelectedInstOperands,
     /*  830193 */     // GIR_Coverage, 22626,
     /*  830193 */     GIR_EraseRootFromParent_Done,
     /*  830194 */   // Label 12807: @830194
     /*  830194 */   GIM_Try, /*On fail goto*//*Label 12808*/ GIMT_Encode4(830269), // Rule ID 22627 //
     /*  830199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  830216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830245 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  830248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830267 */     GIR_RootConstrainSelectedInstOperands,
     /*  830268 */     // GIR_Coverage, 22627,
     /*  830268 */     GIR_EraseRootFromParent_Done,
     /*  830269 */   // Label 12808: @830269
     /*  830269 */   GIM_Try, /*On fail goto*//*Label 12809*/ GIMT_Encode4(830344), // Rule ID 22630 //
     /*  830274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830320 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  830323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830342 */     GIR_RootConstrainSelectedInstOperands,
     /*  830343 */     // GIR_Coverage, 22630,
     /*  830343 */     GIR_EraseRootFromParent_Done,
     /*  830344 */   // Label 12809: @830344
     /*  830344 */   GIM_Try, /*On fail goto*//*Label 12810*/ GIMT_Encode4(830419), // Rule ID 22631 //
     /*  830349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830395 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  830398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830417 */     GIR_RootConstrainSelectedInstOperands,
     /*  830418 */     // GIR_Coverage, 22631,
     /*  830418 */     GIR_EraseRootFromParent_Done,
     /*  830419 */   // Label 12810: @830419
     /*  830419 */   GIM_Try, /*On fail goto*//*Label 12811*/ GIMT_Encode4(830494), // Rule ID 22634 //
     /*  830424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  830441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830470 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  830470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  830473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830492 */     GIR_RootConstrainSelectedInstOperands,
     /*  830493 */     // GIR_Coverage, 22634,
     /*  830493 */     GIR_EraseRootFromParent_Done,
     /*  830494 */   // Label 12811: @830494
     /*  830494 */   GIM_Try, /*On fail goto*//*Label 12812*/ GIMT_Encode4(830569), // Rule ID 22635 //
     /*  830499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  830516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830545 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  830545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  830548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830567 */     GIR_RootConstrainSelectedInstOperands,
     /*  830568 */     // GIR_Coverage, 22635,
     /*  830568 */     GIR_EraseRootFromParent_Done,
     /*  830569 */   // Label 12812: @830569
     /*  830569 */   GIM_Try, /*On fail goto*//*Label 12813*/ GIMT_Encode4(830644), // Rule ID 22638 //
     /*  830574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  830577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  830585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  830588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  830591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  830594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830620 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  830620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  830623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  830639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830642 */     GIR_RootConstrainSelectedInstOperands,
     /*  830643 */     // GIR_Coverage, 22638,
     /*  830643 */     GIR_EraseRootFromParent_Done,
     /*  830644 */   // Label 12813: @830644
     /*  830644 */   GIM_Try, /*On fail goto*//*Label 12814*/ GIMT_Encode4(830719), // Rule ID 22639 //
     /*  830649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  830652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  830660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  830663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  830666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  830669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830695 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  830695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  830698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  830714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830717 */     GIR_RootConstrainSelectedInstOperands,
     /*  830718 */     // GIR_Coverage, 22639,
     /*  830718 */     GIR_EraseRootFromParent_Done,
     /*  830719 */   // Label 12814: @830719
     /*  830719 */   GIM_Try, /*On fail goto*//*Label 12815*/ GIMT_Encode4(830794), // Rule ID 22642 //
     /*  830724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  830741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  830759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830770 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  830773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830792 */     GIR_RootConstrainSelectedInstOperands,
     /*  830793 */     // GIR_Coverage, 22642,
     /*  830793 */     GIR_EraseRootFromParent_Done,
     /*  830794 */   // Label 12815: @830794
     /*  830794 */   GIM_Try, /*On fail goto*//*Label 12816*/ GIMT_Encode4(830869), // Rule ID 22643 //
     /*  830799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  830816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  830834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830845 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  830848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830867 */     GIR_RootConstrainSelectedInstOperands,
     /*  830868 */     // GIR_Coverage, 22643,
     /*  830868 */     GIR_EraseRootFromParent_Done,
     /*  830869 */   // Label 12816: @830869
     /*  830869 */   GIM_Try, /*On fail goto*//*Label 12817*/ GIMT_Encode4(830944), // Rule ID 22646 //
     /*  830874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  830891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  830909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830920 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  830923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830942 */     GIR_RootConstrainSelectedInstOperands,
     /*  830943 */     // GIR_Coverage, 22646,
     /*  830943 */     GIR_EraseRootFromParent_Done,
     /*  830944 */   // Label 12817: @830944
     /*  830944 */   GIM_Try, /*On fail goto*//*Label 12818*/ GIMT_Encode4(831019), // Rule ID 22647 //
     /*  830949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  830966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  830984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830995 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  830998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831017 */     GIR_RootConstrainSelectedInstOperands,
     /*  831018 */     // GIR_Coverage, 22647,
     /*  831018 */     GIR_EraseRootFromParent_Done,
     /*  831019 */   // Label 12818: @831019
     /*  831019 */   GIM_Try, /*On fail goto*//*Label 12819*/ GIMT_Encode4(831094), // Rule ID 22650 //
     /*  831024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  831041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  831073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831092 */     GIR_RootConstrainSelectedInstOperands,
     /*  831093 */     // GIR_Coverage, 22650,
     /*  831093 */     GIR_EraseRootFromParent_Done,
     /*  831094 */   // Label 12819: @831094
     /*  831094 */   GIM_Try, /*On fail goto*//*Label 12820*/ GIMT_Encode4(831169), // Rule ID 22651 //
     /*  831099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  831116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831145 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  831148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831167 */     GIR_RootConstrainSelectedInstOperands,
     /*  831168 */     // GIR_Coverage, 22651,
     /*  831168 */     GIR_EraseRootFromParent_Done,
     /*  831169 */   // Label 12820: @831169
     /*  831169 */   GIM_Try, /*On fail goto*//*Label 12821*/ GIMT_Encode4(831244), // Rule ID 22654 //
     /*  831174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  831191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831220 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  831223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831242 */     GIR_RootConstrainSelectedInstOperands,
     /*  831243 */     // GIR_Coverage, 22654,
     /*  831243 */     GIR_EraseRootFromParent_Done,
     /*  831244 */   // Label 12821: @831244
     /*  831244 */   GIM_Try, /*On fail goto*//*Label 12822*/ GIMT_Encode4(831319), // Rule ID 22655 //
     /*  831249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  831266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831295 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  831298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831317 */     GIR_RootConstrainSelectedInstOperands,
     /*  831318 */     // GIR_Coverage, 22655,
     /*  831318 */     GIR_EraseRootFromParent_Done,
     /*  831319 */   // Label 12822: @831319
     /*  831319 */   GIM_Try, /*On fail goto*//*Label 12823*/ GIMT_Encode4(831394), // Rule ID 22658 //
     /*  831324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831370 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  831373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831392 */     GIR_RootConstrainSelectedInstOperands,
     /*  831393 */     // GIR_Coverage, 22658,
     /*  831393 */     GIR_EraseRootFromParent_Done,
     /*  831394 */   // Label 12823: @831394
     /*  831394 */   GIM_Try, /*On fail goto*//*Label 12824*/ GIMT_Encode4(831469), // Rule ID 22659 //
     /*  831399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831445 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  831448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831467 */     GIR_RootConstrainSelectedInstOperands,
     /*  831468 */     // GIR_Coverage, 22659,
     /*  831468 */     GIR_EraseRootFromParent_Done,
     /*  831469 */   // Label 12824: @831469
     /*  831469 */   GIM_Try, /*On fail goto*//*Label 12825*/ GIMT_Encode4(831544), // Rule ID 22662 //
     /*  831474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  831491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831520 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  831523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831542 */     GIR_RootConstrainSelectedInstOperands,
     /*  831543 */     // GIR_Coverage, 22662,
     /*  831543 */     GIR_EraseRootFromParent_Done,
     /*  831544 */   // Label 12825: @831544
     /*  831544 */   GIM_Try, /*On fail goto*//*Label 12826*/ GIMT_Encode4(831619), // Rule ID 22663 //
     /*  831549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  831566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831595 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  831598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831617 */     GIR_RootConstrainSelectedInstOperands,
     /*  831618 */     // GIR_Coverage, 22663,
     /*  831618 */     GIR_EraseRootFromParent_Done,
     /*  831619 */   // Label 12826: @831619
     /*  831619 */   GIM_Try, /*On fail goto*//*Label 12827*/ GIMT_Encode4(831694), // Rule ID 22666 //
     /*  831624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  831641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  831670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  831673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831692 */     GIR_RootConstrainSelectedInstOperands,
     /*  831693 */     // GIR_Coverage, 22666,
     /*  831693 */     GIR_EraseRootFromParent_Done,
     /*  831694 */   // Label 12827: @831694
     /*  831694 */   GIM_Try, /*On fail goto*//*Label 12828*/ GIMT_Encode4(831769), // Rule ID 22667 //
     /*  831699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  831716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831745 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  831745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  831748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831767 */     GIR_RootConstrainSelectedInstOperands,
     /*  831768 */     // GIR_Coverage, 22667,
     /*  831768 */     GIR_EraseRootFromParent_Done,
     /*  831769 */   // Label 12828: @831769
     /*  831769 */   GIM_Try, /*On fail goto*//*Label 12829*/ GIMT_Encode4(831844), // Rule ID 22670 //
     /*  831774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  831791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831820 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  831820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  831823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831842 */     GIR_RootConstrainSelectedInstOperands,
     /*  831843 */     // GIR_Coverage, 22670,
     /*  831843 */     GIR_EraseRootFromParent_Done,
     /*  831844 */   // Label 12829: @831844
     /*  831844 */   GIM_Try, /*On fail goto*//*Label 12830*/ GIMT_Encode4(831919), // Rule ID 22671 //
     /*  831849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  831866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831895 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  831895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  831898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831917 */     GIR_RootConstrainSelectedInstOperands,
     /*  831918 */     // GIR_Coverage, 22671,
     /*  831918 */     GIR_EraseRootFromParent_Done,
     /*  831919 */   // Label 12830: @831919
     /*  831919 */   GIM_Try, /*On fail goto*//*Label 12831*/ GIMT_Encode4(831994), // Rule ID 22674 //
     /*  831924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  831941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  831970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  831973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831992 */     GIR_RootConstrainSelectedInstOperands,
     /*  831993 */     // GIR_Coverage, 22674,
     /*  831993 */     GIR_EraseRootFromParent_Done,
     /*  831994 */   // Label 12831: @831994
     /*  831994 */   GIM_Try, /*On fail goto*//*Label 12832*/ GIMT_Encode4(832069), // Rule ID 22675 //
     /*  831999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  832016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832045 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  832048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832067 */     GIR_RootConstrainSelectedInstOperands,
     /*  832068 */     // GIR_Coverage, 22675,
     /*  832068 */     GIR_EraseRootFromParent_Done,
     /*  832069 */   // Label 12832: @832069
     /*  832069 */   GIM_Try, /*On fail goto*//*Label 12833*/ GIMT_Encode4(832144), // Rule ID 22678 //
     /*  832074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  832091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  832123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832142 */     GIR_RootConstrainSelectedInstOperands,
     /*  832143 */     // GIR_Coverage, 22678,
     /*  832143 */     GIR_EraseRootFromParent_Done,
     /*  832144 */   // Label 12833: @832144
     /*  832144 */   GIM_Try, /*On fail goto*//*Label 12834*/ GIMT_Encode4(832219), // Rule ID 22679 //
     /*  832149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  832166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832195 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  832198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832217 */     GIR_RootConstrainSelectedInstOperands,
     /*  832218 */     // GIR_Coverage, 22679,
     /*  832218 */     GIR_EraseRootFromParent_Done,
     /*  832219 */   // Label 12834: @832219
     /*  832219 */   GIM_Try, /*On fail goto*//*Label 12835*/ GIMT_Encode4(832294), // Rule ID 22682 //
     /*  832224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832270 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  832273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832292 */     GIR_RootConstrainSelectedInstOperands,
     /*  832293 */     // GIR_Coverage, 22682,
     /*  832293 */     GIR_EraseRootFromParent_Done,
     /*  832294 */   // Label 12835: @832294
     /*  832294 */   GIM_Try, /*On fail goto*//*Label 12836*/ GIMT_Encode4(832369), // Rule ID 22683 //
     /*  832299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832345 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  832348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832367 */     GIR_RootConstrainSelectedInstOperands,
     /*  832368 */     // GIR_Coverage, 22683,
     /*  832368 */     GIR_EraseRootFromParent_Done,
     /*  832369 */   // Label 12836: @832369
     /*  832369 */   GIM_Try, /*On fail goto*//*Label 12837*/ GIMT_Encode4(832444), // Rule ID 22686 //
     /*  832374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  832423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832442 */     GIR_RootConstrainSelectedInstOperands,
     /*  832443 */     // GIR_Coverage, 22686,
     /*  832443 */     GIR_EraseRootFromParent_Done,
     /*  832444 */   // Label 12837: @832444
     /*  832444 */   GIM_Try, /*On fail goto*//*Label 12838*/ GIMT_Encode4(832519), // Rule ID 22687 //
     /*  832449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832495 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  832498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832517 */     GIR_RootConstrainSelectedInstOperands,
     /*  832518 */     // GIR_Coverage, 22687,
     /*  832518 */     GIR_EraseRootFromParent_Done,
     /*  832519 */   // Label 12838: @832519
     /*  832519 */   GIM_Try, /*On fail goto*//*Label 12839*/ GIMT_Encode4(832594), // Rule ID 22690 //
     /*  832524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  832541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832570 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  832570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  832573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832592 */     GIR_RootConstrainSelectedInstOperands,
     /*  832593 */     // GIR_Coverage, 22690,
     /*  832593 */     GIR_EraseRootFromParent_Done,
     /*  832594 */   // Label 12839: @832594
     /*  832594 */   GIM_Try, /*On fail goto*//*Label 12840*/ GIMT_Encode4(832669), // Rule ID 22691 //
     /*  832599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  832616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832645 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  832645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  832648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832667 */     GIR_RootConstrainSelectedInstOperands,
     /*  832668 */     // GIR_Coverage, 22691,
     /*  832668 */     GIR_EraseRootFromParent_Done,
     /*  832669 */   // Label 12840: @832669
     /*  832669 */   GIM_Try, /*On fail goto*//*Label 12841*/ GIMT_Encode4(832744), // Rule ID 22694 //
     /*  832674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  832691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  832720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  832723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832742 */     GIR_RootConstrainSelectedInstOperands,
     /*  832743 */     // GIR_Coverage, 22694,
     /*  832743 */     GIR_EraseRootFromParent_Done,
     /*  832744 */   // Label 12841: @832744
     /*  832744 */   GIM_Try, /*On fail goto*//*Label 12842*/ GIMT_Encode4(832819), // Rule ID 22695 //
     /*  832749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  832766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832795 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  832795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  832798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832817 */     GIR_RootConstrainSelectedInstOperands,
     /*  832818 */     // GIR_Coverage, 22695,
     /*  832818 */     GIR_EraseRootFromParent_Done,
     /*  832819 */   // Label 12842: @832819
     /*  832819 */   GIM_Try, /*On fail goto*//*Label 12843*/ GIMT_Encode4(832894), // Rule ID 22698 //
     /*  832824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  832841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832870 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  832870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  832873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832892 */     GIR_RootConstrainSelectedInstOperands,
     /*  832893 */     // GIR_Coverage, 22698,
     /*  832893 */     GIR_EraseRootFromParent_Done,
     /*  832894 */   // Label 12843: @832894
     /*  832894 */   GIM_Try, /*On fail goto*//*Label 12844*/ GIMT_Encode4(832969), // Rule ID 22699 //
     /*  832899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  832916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832945 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  832945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  832948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832967 */     GIR_RootConstrainSelectedInstOperands,
     /*  832968 */     // GIR_Coverage, 22699,
     /*  832968 */     GIR_EraseRootFromParent_Done,
     /*  832969 */   // Label 12844: @832969
     /*  832969 */   GIM_Try, /*On fail goto*//*Label 12845*/ GIMT_Encode4(833044), // Rule ID 22702 //
     /*  832974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  832991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  833023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833042 */     GIR_RootConstrainSelectedInstOperands,
     /*  833043 */     // GIR_Coverage, 22702,
     /*  833043 */     GIR_EraseRootFromParent_Done,
     /*  833044 */   // Label 12845: @833044
     /*  833044 */   GIM_Try, /*On fail goto*//*Label 12846*/ GIMT_Encode4(833119), // Rule ID 22703 //
     /*  833049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  833066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833095 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  833098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833117 */     GIR_RootConstrainSelectedInstOperands,
     /*  833118 */     // GIR_Coverage, 22703,
     /*  833118 */     GIR_EraseRootFromParent_Done,
     /*  833119 */   // Label 12846: @833119
     /*  833119 */   GIM_Try, /*On fail goto*//*Label 12847*/ GIMT_Encode4(833194), // Rule ID 22706 //
     /*  833124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  833173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833192 */     GIR_RootConstrainSelectedInstOperands,
     /*  833193 */     // GIR_Coverage, 22706,
     /*  833193 */     GIR_EraseRootFromParent_Done,
     /*  833194 */   // Label 12847: @833194
     /*  833194 */   GIM_Try, /*On fail goto*//*Label 12848*/ GIMT_Encode4(833269), // Rule ID 22707 //
     /*  833199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833245 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  833248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833267 */     GIR_RootConstrainSelectedInstOperands,
     /*  833268 */     // GIR_Coverage, 22707,
     /*  833268 */     GIR_EraseRootFromParent_Done,
     /*  833269 */   // Label 12848: @833269
     /*  833269 */   GIM_Try, /*On fail goto*//*Label 12849*/ GIMT_Encode4(833344), // Rule ID 22710 //
     /*  833274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833320 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  833320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  833323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833342 */     GIR_RootConstrainSelectedInstOperands,
     /*  833343 */     // GIR_Coverage, 22710,
     /*  833343 */     GIR_EraseRootFromParent_Done,
     /*  833344 */   // Label 12849: @833344
     /*  833344 */   GIM_Try, /*On fail goto*//*Label 12850*/ GIMT_Encode4(833419), // Rule ID 22711 //
     /*  833349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833395 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  833395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  833398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833417 */     GIR_RootConstrainSelectedInstOperands,
     /*  833418 */     // GIR_Coverage, 22711,
     /*  833418 */     GIR_EraseRootFromParent_Done,
     /*  833419 */   // Label 12850: @833419
     /*  833419 */   GIM_Try, /*On fail goto*//*Label 12851*/ GIMT_Encode4(833494), // Rule ID 22714 //
     /*  833424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  833441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833470 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  833473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833492 */     GIR_RootConstrainSelectedInstOperands,
     /*  833493 */     // GIR_Coverage, 22714,
     /*  833493 */     GIR_EraseRootFromParent_Done,
     /*  833494 */   // Label 12851: @833494
     /*  833494 */   GIM_Try, /*On fail goto*//*Label 12852*/ GIMT_Encode4(833569), // Rule ID 22715 //
     /*  833499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  833516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833545 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  833548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833567 */     GIR_RootConstrainSelectedInstOperands,
     /*  833568 */     // GIR_Coverage, 22715,
     /*  833568 */     GIR_EraseRootFromParent_Done,
     /*  833569 */   // Label 12852: @833569
     /*  833569 */   GIM_Try, /*On fail goto*//*Label 12853*/ GIMT_Encode4(833644), // Rule ID 22718 //
     /*  833574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  833591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833620 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  833623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833642 */     GIR_RootConstrainSelectedInstOperands,
     /*  833643 */     // GIR_Coverage, 22718,
     /*  833643 */     GIR_EraseRootFromParent_Done,
     /*  833644 */   // Label 12853: @833644
     /*  833644 */   GIM_Try, /*On fail goto*//*Label 12854*/ GIMT_Encode4(833719), // Rule ID 22719 //
     /*  833649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  833666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833695 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  833698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833717 */     GIR_RootConstrainSelectedInstOperands,
     /*  833718 */     // GIR_Coverage, 22719,
     /*  833718 */     GIR_EraseRootFromParent_Done,
     /*  833719 */   // Label 12854: @833719
     /*  833719 */   GIM_Try, /*On fail goto*//*Label 12855*/ GIMT_Encode4(833794), // Rule ID 22722 //
     /*  833724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  833741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833770 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  833770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  833773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833792 */     GIR_RootConstrainSelectedInstOperands,
     /*  833793 */     // GIR_Coverage, 22722,
     /*  833793 */     GIR_EraseRootFromParent_Done,
     /*  833794 */   // Label 12855: @833794
     /*  833794 */   GIM_Try, /*On fail goto*//*Label 12856*/ GIMT_Encode4(833869), // Rule ID 22723 //
     /*  833799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  833816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833845 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  833845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  833848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833867 */     GIR_RootConstrainSelectedInstOperands,
     /*  833868 */     // GIR_Coverage, 22723,
     /*  833868 */     GIR_EraseRootFromParent_Done,
     /*  833869 */   // Label 12856: @833869
     /*  833869 */   GIM_Try, /*On fail goto*//*Label 12857*/ GIMT_Encode4(833944), // Rule ID 22726 //
     /*  833874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  833891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  833909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833920 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  833923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833942 */     GIR_RootConstrainSelectedInstOperands,
     /*  833943 */     // GIR_Coverage, 22726,
     /*  833943 */     GIR_EraseRootFromParent_Done,
     /*  833944 */   // Label 12857: @833944
     /*  833944 */   GIM_Try, /*On fail goto*//*Label 12858*/ GIMT_Encode4(834019), // Rule ID 22727 //
     /*  833949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  833966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  833984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833995 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  833998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834017 */     GIR_RootConstrainSelectedInstOperands,
     /*  834018 */     // GIR_Coverage, 22727,
     /*  834018 */     GIR_EraseRootFromParent_Done,
     /*  834019 */   // Label 12858: @834019
     /*  834019 */   GIM_Try, /*On fail goto*//*Label 12859*/ GIMT_Encode4(834094), // Rule ID 22730 //
     /*  834024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834070 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  834073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834092 */     GIR_RootConstrainSelectedInstOperands,
     /*  834093 */     // GIR_Coverage, 22730,
     /*  834093 */     GIR_EraseRootFromParent_Done,
     /*  834094 */   // Label 12859: @834094
     /*  834094 */   GIM_Try, /*On fail goto*//*Label 12860*/ GIMT_Encode4(834169), // Rule ID 22731 //
     /*  834099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834145 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  834148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834167 */     GIR_RootConstrainSelectedInstOperands,
     /*  834168 */     // GIR_Coverage, 22731,
     /*  834168 */     GIR_EraseRootFromParent_Done,
     /*  834169 */   // Label 12860: @834169
     /*  834169 */   GIM_Try, /*On fail goto*//*Label 12861*/ GIMT_Encode4(834244), // Rule ID 22734 //
     /*  834174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834220 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  834223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834242 */     GIR_RootConstrainSelectedInstOperands,
     /*  834243 */     // GIR_Coverage, 22734,
     /*  834243 */     GIR_EraseRootFromParent_Done,
     /*  834244 */   // Label 12861: @834244
     /*  834244 */   GIM_Try, /*On fail goto*//*Label 12862*/ GIMT_Encode4(834319), // Rule ID 22735 //
     /*  834249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834295 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  834298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834317 */     GIR_RootConstrainSelectedInstOperands,
     /*  834318 */     // GIR_Coverage, 22735,
     /*  834318 */     GIR_EraseRootFromParent_Done,
     /*  834319 */   // Label 12862: @834319
     /*  834319 */   GIM_Try, /*On fail goto*//*Label 12863*/ GIMT_Encode4(834394), // Rule ID 22738 //
     /*  834324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  834341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834370 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  834373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834392 */     GIR_RootConstrainSelectedInstOperands,
     /*  834393 */     // GIR_Coverage, 22738,
     /*  834393 */     GIR_EraseRootFromParent_Done,
     /*  834394 */   // Label 12863: @834394
     /*  834394 */   GIM_Try, /*On fail goto*//*Label 12864*/ GIMT_Encode4(834469), // Rule ID 22739 //
     /*  834399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  834416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834445 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  834448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834467 */     GIR_RootConstrainSelectedInstOperands,
     /*  834468 */     // GIR_Coverage, 22739,
     /*  834468 */     GIR_EraseRootFromParent_Done,
     /*  834469 */   // Label 12864: @834469
     /*  834469 */   GIM_Try, /*On fail goto*//*Label 12865*/ GIMT_Encode4(834544), // Rule ID 22742 //
     /*  834474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  834491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834520 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  834523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834542 */     GIR_RootConstrainSelectedInstOperands,
     /*  834543 */     // GIR_Coverage, 22742,
     /*  834543 */     GIR_EraseRootFromParent_Done,
     /*  834544 */   // Label 12865: @834544
     /*  834544 */   GIM_Try, /*On fail goto*//*Label 12866*/ GIMT_Encode4(834619), // Rule ID 22743 //
     /*  834549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  834566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834595 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  834598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834617 */     GIR_RootConstrainSelectedInstOperands,
     /*  834618 */     // GIR_Coverage, 22743,
     /*  834618 */     GIR_EraseRootFromParent_Done,
     /*  834619 */   // Label 12866: @834619
     /*  834619 */   GIM_Try, /*On fail goto*//*Label 12867*/ GIMT_Encode4(834694), // Rule ID 22746 //
     /*  834624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  834641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  834673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834692 */     GIR_RootConstrainSelectedInstOperands,
     /*  834693 */     // GIR_Coverage, 22746,
     /*  834693 */     GIR_EraseRootFromParent_Done,
     /*  834694 */   // Label 12867: @834694
     /*  834694 */   GIM_Try, /*On fail goto*//*Label 12868*/ GIMT_Encode4(834769), // Rule ID 22747 //
     /*  834699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  834716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834745 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  834748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834767 */     GIR_RootConstrainSelectedInstOperands,
     /*  834768 */     // GIR_Coverage, 22747,
     /*  834768 */     GIR_EraseRootFromParent_Done,
     /*  834769 */   // Label 12868: @834769
     /*  834769 */   GIM_Try, /*On fail goto*//*Label 12869*/ GIMT_Encode4(834844), // Rule ID 22750 //
     /*  834774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  834791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834820 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  834820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  834823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834842 */     GIR_RootConstrainSelectedInstOperands,
     /*  834843 */     // GIR_Coverage, 22750,
     /*  834843 */     GIR_EraseRootFromParent_Done,
     /*  834844 */   // Label 12869: @834844
     /*  834844 */   GIM_Try, /*On fail goto*//*Label 12870*/ GIMT_Encode4(834919), // Rule ID 22751 //
     /*  834849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  834866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834895 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  834895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  834898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834917 */     GIR_RootConstrainSelectedInstOperands,
     /*  834918 */     // GIR_Coverage, 22751,
     /*  834918 */     GIR_EraseRootFromParent_Done,
     /*  834919 */   // Label 12870: @834919
     /*  834919 */   GIM_Try, /*On fail goto*//*Label 12871*/ GIMT_Encode4(834994), // Rule ID 22754 //
     /*  834924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  834941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834970 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  834970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  834973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834992 */     GIR_RootConstrainSelectedInstOperands,
     /*  834993 */     // GIR_Coverage, 22754,
     /*  834993 */     GIR_EraseRootFromParent_Done,
     /*  834994 */   // Label 12871: @834994
     /*  834994 */   GIM_Try, /*On fail goto*//*Label 12872*/ GIMT_Encode4(835069), // Rule ID 22755 //
     /*  834999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  835016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835045 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  835048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835067 */     GIR_RootConstrainSelectedInstOperands,
     /*  835068 */     // GIR_Coverage, 22755,
     /*  835068 */     GIR_EraseRootFromParent_Done,
     /*  835069 */   // Label 12872: @835069
     /*  835069 */   GIM_Try, /*On fail goto*//*Label 12873*/ GIMT_Encode4(835144), // Rule ID 22758 //
     /*  835074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  835123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835142 */     GIR_RootConstrainSelectedInstOperands,
     /*  835143 */     // GIR_Coverage, 22758,
     /*  835143 */     GIR_EraseRootFromParent_Done,
     /*  835144 */   // Label 12873: @835144
     /*  835144 */   GIM_Try, /*On fail goto*//*Label 12874*/ GIMT_Encode4(835219), // Rule ID 22759 //
     /*  835149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835195 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  835198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835217 */     GIR_RootConstrainSelectedInstOperands,
     /*  835218 */     // GIR_Coverage, 22759,
     /*  835218 */     GIR_EraseRootFromParent_Done,
     /*  835219 */   // Label 12874: @835219
     /*  835219 */   GIM_Try, /*On fail goto*//*Label 12875*/ GIMT_Encode4(835294), // Rule ID 22762 //
     /*  835224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  835241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835270 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  835270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  835273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835292 */     GIR_RootConstrainSelectedInstOperands,
     /*  835293 */     // GIR_Coverage, 22762,
     /*  835293 */     GIR_EraseRootFromParent_Done,
     /*  835294 */   // Label 12875: @835294
     /*  835294 */   GIM_Try, /*On fail goto*//*Label 12876*/ GIMT_Encode4(835369), // Rule ID 22763 //
     /*  835299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  835316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835345 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  835345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  835348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835367 */     GIR_RootConstrainSelectedInstOperands,
     /*  835368 */     // GIR_Coverage, 22763,
     /*  835368 */     GIR_EraseRootFromParent_Done,
     /*  835369 */   // Label 12876: @835369
     /*  835369 */   GIM_Try, /*On fail goto*//*Label 12877*/ GIMT_Encode4(835444), // Rule ID 22766 //
     /*  835374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  835391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835420 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  835420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  835423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835442 */     GIR_RootConstrainSelectedInstOperands,
     /*  835443 */     // GIR_Coverage, 22766,
     /*  835443 */     GIR_EraseRootFromParent_Done,
     /*  835444 */   // Label 12877: @835444
     /*  835444 */   GIM_Try, /*On fail goto*//*Label 12878*/ GIMT_Encode4(835519), // Rule ID 22767 //
     /*  835449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  835466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835495 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  835495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  835498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835517 */     GIR_RootConstrainSelectedInstOperands,
     /*  835518 */     // GIR_Coverage, 22767,
     /*  835518 */     GIR_EraseRootFromParent_Done,
     /*  835519 */   // Label 12878: @835519
     /*  835519 */   GIM_Try, /*On fail goto*//*Label 12879*/ GIMT_Encode4(835594), // Rule ID 22770 //
     /*  835524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  835541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835570 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  835570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  835573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835592 */     GIR_RootConstrainSelectedInstOperands,
     /*  835593 */     // GIR_Coverage, 22770,
     /*  835593 */     GIR_EraseRootFromParent_Done,
     /*  835594 */   // Label 12879: @835594
     /*  835594 */   GIM_Try, /*On fail goto*//*Label 12880*/ GIMT_Encode4(835669), // Rule ID 22771 //
     /*  835599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  835616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835645 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  835645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  835648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835667 */     GIR_RootConstrainSelectedInstOperands,
     /*  835668 */     // GIR_Coverage, 22771,
     /*  835668 */     GIR_EraseRootFromParent_Done,
     /*  835669 */   // Label 12880: @835669
     /*  835669 */   GIM_Try, /*On fail goto*//*Label 12881*/ GIMT_Encode4(835744), // Rule ID 22774 //
     /*  835674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  835691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835720 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  835723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835742 */     GIR_RootConstrainSelectedInstOperands,
     /*  835743 */     // GIR_Coverage, 22774,
     /*  835743 */     GIR_EraseRootFromParent_Done,
     /*  835744 */   // Label 12881: @835744
     /*  835744 */   GIM_Try, /*On fail goto*//*Label 12882*/ GIMT_Encode4(835819), // Rule ID 22775 //
     /*  835749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  835766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835795 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  835798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835817 */     GIR_RootConstrainSelectedInstOperands,
     /*  835818 */     // GIR_Coverage, 22775,
     /*  835818 */     GIR_EraseRootFromParent_Done,
     /*  835819 */   // Label 12882: @835819
     /*  835819 */   GIM_Try, /*On fail goto*//*Label 12883*/ GIMT_Encode4(835894), // Rule ID 22778 //
     /*  835824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  835841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835870 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  835873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835892 */     GIR_RootConstrainSelectedInstOperands,
     /*  835893 */     // GIR_Coverage, 22778,
     /*  835893 */     GIR_EraseRootFromParent_Done,
     /*  835894 */   // Label 12883: @835894
     /*  835894 */   GIM_Try, /*On fail goto*//*Label 12884*/ GIMT_Encode4(835969), // Rule ID 22779 //
     /*  835899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  835916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835945 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  835948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835967 */     GIR_RootConstrainSelectedInstOperands,
     /*  835968 */     // GIR_Coverage, 22779,
     /*  835968 */     GIR_EraseRootFromParent_Done,
     /*  835969 */   // Label 12884: @835969
     /*  835969 */   GIM_Try, /*On fail goto*//*Label 12885*/ GIMT_Encode4(836044), // Rule ID 22782 //
     /*  835974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  835991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  836020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  836023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836042 */     GIR_RootConstrainSelectedInstOperands,
     /*  836043 */     // GIR_Coverage, 22782,
     /*  836043 */     GIR_EraseRootFromParent_Done,
     /*  836044 */   // Label 12885: @836044
     /*  836044 */   GIM_Try, /*On fail goto*//*Label 12886*/ GIMT_Encode4(836119), // Rule ID 22783 //
     /*  836049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  836066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836095 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  836095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  836098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836117 */     GIR_RootConstrainSelectedInstOperands,
     /*  836118 */     // GIR_Coverage, 22783,
     /*  836118 */     GIR_EraseRootFromParent_Done,
     /*  836119 */   // Label 12886: @836119
     /*  836119 */   GIM_Try, /*On fail goto*//*Label 12887*/ GIMT_Encode4(836194), // Rule ID 22786 //
     /*  836124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  836141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836170 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  836173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836192 */     GIR_RootConstrainSelectedInstOperands,
     /*  836193 */     // GIR_Coverage, 22786,
     /*  836193 */     GIR_EraseRootFromParent_Done,
     /*  836194 */   // Label 12887: @836194
     /*  836194 */   GIM_Try, /*On fail goto*//*Label 12888*/ GIMT_Encode4(836269), // Rule ID 22787 //
     /*  836199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  836216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836245 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  836248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836267 */     GIR_RootConstrainSelectedInstOperands,
     /*  836268 */     // GIR_Coverage, 22787,
     /*  836268 */     GIR_EraseRootFromParent_Done,
     /*  836269 */   // Label 12888: @836269
     /*  836269 */   GIM_Try, /*On fail goto*//*Label 12889*/ GIMT_Encode4(836344), // Rule ID 22790 //
     /*  836274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  836291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  836320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  836323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836342 */     GIR_RootConstrainSelectedInstOperands,
     /*  836343 */     // GIR_Coverage, 22790,
     /*  836343 */     GIR_EraseRootFromParent_Done,
     /*  836344 */   // Label 12889: @836344
     /*  836344 */   GIM_Try, /*On fail goto*//*Label 12890*/ GIMT_Encode4(836419), // Rule ID 22791 //
     /*  836349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  836366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836395 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  836395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  836398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836417 */     GIR_RootConstrainSelectedInstOperands,
     /*  836418 */     // GIR_Coverage, 22791,
     /*  836418 */     GIR_EraseRootFromParent_Done,
     /*  836419 */   // Label 12890: @836419
     /*  836419 */   GIM_Try, /*On fail goto*//*Label 12891*/ GIMT_Encode4(836494), // Rule ID 22794 //
     /*  836424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  836441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  836470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  836473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836492 */     GIR_RootConstrainSelectedInstOperands,
     /*  836493 */     // GIR_Coverage, 22794,
     /*  836493 */     GIR_EraseRootFromParent_Done,
     /*  836494 */   // Label 12891: @836494
     /*  836494 */   GIM_Try, /*On fail goto*//*Label 12892*/ GIMT_Encode4(836569), // Rule ID 22795 //
     /*  836499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  836516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836545 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  836545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  836548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836567 */     GIR_RootConstrainSelectedInstOperands,
     /*  836568 */     // GIR_Coverage, 22795,
     /*  836568 */     GIR_EraseRootFromParent_Done,
     /*  836569 */   // Label 12892: @836569
     /*  836569 */   GIM_Try, /*On fail goto*//*Label 12893*/ GIMT_Encode4(836644), // Rule ID 22798 //
     /*  836574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  836591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  836623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836642 */     GIR_RootConstrainSelectedInstOperands,
     /*  836643 */     // GIR_Coverage, 22798,
     /*  836643 */     GIR_EraseRootFromParent_Done,
     /*  836644 */   // Label 12893: @836644
     /*  836644 */   GIM_Try, /*On fail goto*//*Label 12894*/ GIMT_Encode4(836719), // Rule ID 22799 //
     /*  836649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  836666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836695 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  836698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836717 */     GIR_RootConstrainSelectedInstOperands,
     /*  836718 */     // GIR_Coverage, 22799,
     /*  836718 */     GIR_EraseRootFromParent_Done,
     /*  836719 */   // Label 12894: @836719
     /*  836719 */   GIM_Try, /*On fail goto*//*Label 12895*/ GIMT_Encode4(836794), // Rule ID 22802 //
     /*  836724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  836741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  836773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836792 */     GIR_RootConstrainSelectedInstOperands,
     /*  836793 */     // GIR_Coverage, 22802,
     /*  836793 */     GIR_EraseRootFromParent_Done,
     /*  836794 */   // Label 12895: @836794
     /*  836794 */   GIM_Try, /*On fail goto*//*Label 12896*/ GIMT_Encode4(836869), // Rule ID 22803 //
     /*  836799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  836816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836845 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  836848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836867 */     GIR_RootConstrainSelectedInstOperands,
     /*  836868 */     // GIR_Coverage, 22803,
     /*  836868 */     GIR_EraseRootFromParent_Done,
     /*  836869 */   // Label 12896: @836869
     /*  836869 */   GIM_Try, /*On fail goto*//*Label 12897*/ GIMT_Encode4(836944), // Rule ID 22806 //
     /*  836874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  836891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836920 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  836923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836942 */     GIR_RootConstrainSelectedInstOperands,
     /*  836943 */     // GIR_Coverage, 22806,
     /*  836943 */     GIR_EraseRootFromParent_Done,
     /*  836944 */   // Label 12897: @836944
     /*  836944 */   GIM_Try, /*On fail goto*//*Label 12898*/ GIMT_Encode4(837019), // Rule ID 22807 //
     /*  836949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  836966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836995 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  836998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837017 */     GIR_RootConstrainSelectedInstOperands,
     /*  837018 */     // GIR_Coverage, 22807,
     /*  837018 */     GIR_EraseRootFromParent_Done,
     /*  837019 */   // Label 12898: @837019
     /*  837019 */   GIM_Try, /*On fail goto*//*Label 12899*/ GIMT_Encode4(837094), // Rule ID 22810 //
     /*  837024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  837041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837070 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  837073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837092 */     GIR_RootConstrainSelectedInstOperands,
     /*  837093 */     // GIR_Coverage, 22810,
     /*  837093 */     GIR_EraseRootFromParent_Done,
     /*  837094 */   // Label 12899: @837094
     /*  837094 */   GIM_Try, /*On fail goto*//*Label 12900*/ GIMT_Encode4(837169), // Rule ID 22811 //
     /*  837099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  837116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837145 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  837148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837167 */     GIR_RootConstrainSelectedInstOperands,
     /*  837168 */     // GIR_Coverage, 22811,
     /*  837168 */     GIR_EraseRootFromParent_Done,
     /*  837169 */   // Label 12900: @837169
     /*  837169 */   GIM_Try, /*On fail goto*//*Label 12901*/ GIMT_Encode4(837244), // Rule ID 22814 //
     /*  837174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  837191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837220 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  837223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837242 */     GIR_RootConstrainSelectedInstOperands,
     /*  837243 */     // GIR_Coverage, 22814,
     /*  837243 */     GIR_EraseRootFromParent_Done,
     /*  837244 */   // Label 12901: @837244
     /*  837244 */   GIM_Try, /*On fail goto*//*Label 12902*/ GIMT_Encode4(837319), // Rule ID 22815 //
     /*  837249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  837266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837295 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  837298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837317 */     GIR_RootConstrainSelectedInstOperands,
     /*  837318 */     // GIR_Coverage, 22815,
     /*  837318 */     GIR_EraseRootFromParent_Done,
     /*  837319 */   // Label 12902: @837319
     /*  837319 */   GIM_Try, /*On fail goto*//*Label 12903*/ GIMT_Encode4(837394), // Rule ID 22818 //
     /*  837324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  837341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837370 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  837373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837392 */     GIR_RootConstrainSelectedInstOperands,
     /*  837393 */     // GIR_Coverage, 22818,
     /*  837393 */     GIR_EraseRootFromParent_Done,
     /*  837394 */   // Label 12903: @837394
     /*  837394 */   GIM_Try, /*On fail goto*//*Label 12904*/ GIMT_Encode4(837469), // Rule ID 22819 //
     /*  837399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  837416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837445 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  837448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837467 */     GIR_RootConstrainSelectedInstOperands,
     /*  837468 */     // GIR_Coverage, 22819,
     /*  837468 */     GIR_EraseRootFromParent_Done,
     /*  837469 */   // Label 12904: @837469
     /*  837469 */   GIM_Try, /*On fail goto*//*Label 12905*/ GIMT_Encode4(837544), // Rule ID 22822 //
     /*  837474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  837491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837520 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  837523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837542 */     GIR_RootConstrainSelectedInstOperands,
     /*  837543 */     // GIR_Coverage, 22822,
     /*  837543 */     GIR_EraseRootFromParent_Done,
     /*  837544 */   // Label 12905: @837544
     /*  837544 */   GIM_Try, /*On fail goto*//*Label 12906*/ GIMT_Encode4(837619), // Rule ID 22823 //
     /*  837549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  837566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837595 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  837598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837617 */     GIR_RootConstrainSelectedInstOperands,
     /*  837618 */     // GIR_Coverage, 22823,
     /*  837618 */     GIR_EraseRootFromParent_Done,
     /*  837619 */   // Label 12906: @837619
     /*  837619 */   GIM_Try, /*On fail goto*//*Label 12907*/ GIMT_Encode4(837694), // Rule ID 22826 //
     /*  837624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  837641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837670 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  837673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837692 */     GIR_RootConstrainSelectedInstOperands,
     /*  837693 */     // GIR_Coverage, 22826,
     /*  837693 */     GIR_EraseRootFromParent_Done,
     /*  837694 */   // Label 12907: @837694
     /*  837694 */   GIM_Try, /*On fail goto*//*Label 12908*/ GIMT_Encode4(837769), // Rule ID 22827 //
     /*  837699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  837716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837745 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  837748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837767 */     GIR_RootConstrainSelectedInstOperands,
     /*  837768 */     // GIR_Coverage, 22827,
     /*  837768 */     GIR_EraseRootFromParent_Done,
     /*  837769 */   // Label 12908: @837769
     /*  837769 */   GIM_Try, /*On fail goto*//*Label 12909*/ GIMT_Encode4(837844), // Rule ID 22830 //
     /*  837774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  837791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837820 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  837823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837842 */     GIR_RootConstrainSelectedInstOperands,
     /*  837843 */     // GIR_Coverage, 22830,
     /*  837843 */     GIR_EraseRootFromParent_Done,
     /*  837844 */   // Label 12909: @837844
     /*  837844 */   GIM_Try, /*On fail goto*//*Label 12910*/ GIMT_Encode4(837919), // Rule ID 22831 //
     /*  837849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  837866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837895 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  837898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837917 */     GIR_RootConstrainSelectedInstOperands,
     /*  837918 */     // GIR_Coverage, 22831,
     /*  837918 */     GIR_EraseRootFromParent_Done,
     /*  837919 */   // Label 12910: @837919
     /*  837919 */   GIM_Try, /*On fail goto*//*Label 12911*/ GIMT_Encode4(837994), // Rule ID 22950 //
     /*  837924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  837927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  837932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  837941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837970 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  837973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837992 */     GIR_RootConstrainSelectedInstOperands,
     /*  837993 */     // GIR_Coverage, 22950,
     /*  837993 */     GIR_EraseRootFromParent_Done,
     /*  837994 */   // Label 12911: @837994
     /*  837994 */   GIM_Try, /*On fail goto*//*Label 12912*/ GIMT_Encode4(838069), // Rule ID 22951 //
     /*  837999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  838016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838045 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  838048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838067 */     GIR_RootConstrainSelectedInstOperands,
     /*  838068 */     // GIR_Coverage, 22951,
     /*  838068 */     GIR_EraseRootFromParent_Done,
     /*  838069 */   // Label 12912: @838069
     /*  838069 */   GIM_Try, /*On fail goto*//*Label 12913*/ GIMT_Encode4(838144), // Rule ID 22954 //
     /*  838074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  838091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838120 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  838123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838142 */     GIR_RootConstrainSelectedInstOperands,
     /*  838143 */     // GIR_Coverage, 22954,
     /*  838143 */     GIR_EraseRootFromParent_Done,
     /*  838144 */   // Label 12913: @838144
     /*  838144 */   GIM_Try, /*On fail goto*//*Label 12914*/ GIMT_Encode4(838219), // Rule ID 22955 //
     /*  838149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  838166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838195 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  838198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838217 */     GIR_RootConstrainSelectedInstOperands,
     /*  838218 */     // GIR_Coverage, 22955,
     /*  838218 */     GIR_EraseRootFromParent_Done,
     /*  838219 */   // Label 12914: @838219
     /*  838219 */   GIM_Try, /*On fail goto*//*Label 12915*/ GIMT_Encode4(838294), // Rule ID 22958 //
     /*  838224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  838227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  838241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838270 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  838273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838292 */     GIR_RootConstrainSelectedInstOperands,
     /*  838293 */     // GIR_Coverage, 22958,
     /*  838293 */     GIR_EraseRootFromParent_Done,
     /*  838294 */   // Label 12915: @838294
     /*  838294 */   GIM_Try, /*On fail goto*//*Label 12916*/ GIMT_Encode4(838369), // Rule ID 22959 //
     /*  838299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  838302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  838316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838345 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  838348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838367 */     GIR_RootConstrainSelectedInstOperands,
     /*  838368 */     // GIR_Coverage, 22959,
     /*  838368 */     GIR_EraseRootFromParent_Done,
     /*  838369 */   // Label 12916: @838369
     /*  838369 */   GIM_Try, /*On fail goto*//*Label 12917*/ GIMT_Encode4(838444), // Rule ID 22962 //
     /*  838374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  838391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838420 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  838423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838442 */     GIR_RootConstrainSelectedInstOperands,
     /*  838443 */     // GIR_Coverage, 22962,
     /*  838443 */     GIR_EraseRootFromParent_Done,
     /*  838444 */   // Label 12917: @838444
     /*  838444 */   GIM_Try, /*On fail goto*//*Label 12918*/ GIMT_Encode4(838519), // Rule ID 22963 //
     /*  838449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  838466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838495 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  838498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838517 */     GIR_RootConstrainSelectedInstOperands,
     /*  838518 */     // GIR_Coverage, 22963,
     /*  838518 */     GIR_EraseRootFromParent_Done,
     /*  838519 */   // Label 12918: @838519
     /*  838519 */   GIM_Try, /*On fail goto*//*Label 12919*/ GIMT_Encode4(838594), // Rule ID 22966 //
     /*  838524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  838527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  838541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838570 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  838573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838592 */     GIR_RootConstrainSelectedInstOperands,
     /*  838593 */     // GIR_Coverage, 22966,
     /*  838593 */     GIR_EraseRootFromParent_Done,
     /*  838594 */   // Label 12919: @838594
     /*  838594 */   GIM_Try, /*On fail goto*//*Label 12920*/ GIMT_Encode4(838669), // Rule ID 22967 //
     /*  838599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  838602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  838616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838645 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  838648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838667 */     GIR_RootConstrainSelectedInstOperands,
     /*  838668 */     // GIR_Coverage, 22967,
     /*  838668 */     GIR_EraseRootFromParent_Done,
     /*  838669 */   // Label 12920: @838669
     /*  838669 */   GIM_Try, /*On fail goto*//*Label 12921*/ GIMT_Encode4(838744), // Rule ID 22970 //
     /*  838674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  838677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  838691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838720 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  838720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  838723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  838739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838742 */     GIR_RootConstrainSelectedInstOperands,
     /*  838743 */     // GIR_Coverage, 22970,
     /*  838743 */     GIR_EraseRootFromParent_Done,
     /*  838744 */   // Label 12921: @838744
     /*  838744 */   GIM_Try, /*On fail goto*//*Label 12922*/ GIMT_Encode4(838819), // Rule ID 22971 //
     /*  838749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  838752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  838766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838795 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  838795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  838798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  838814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838817 */     GIR_RootConstrainSelectedInstOperands,
     /*  838818 */     // GIR_Coverage, 22971,
     /*  838818 */     GIR_EraseRootFromParent_Done,
     /*  838819 */   // Label 12922: @838819
     /*  838819 */   GIM_Try, /*On fail goto*//*Label 12923*/ GIMT_Encode4(838894), // Rule ID 22974 //
     /*  838824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  838841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838870 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  838873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838892 */     GIR_RootConstrainSelectedInstOperands,
     /*  838893 */     // GIR_Coverage, 22974,
     /*  838893 */     GIR_EraseRootFromParent_Done,
     /*  838894 */   // Label 12923: @838894
     /*  838894 */   GIM_Try, /*On fail goto*//*Label 12924*/ GIMT_Encode4(838969), // Rule ID 22975 //
     /*  838899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  838916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838945 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  838948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838967 */     GIR_RootConstrainSelectedInstOperands,
     /*  838968 */     // GIR_Coverage, 22975,
     /*  838968 */     GIR_EraseRootFromParent_Done,
     /*  838969 */   // Label 12924: @838969
     /*  838969 */   GIM_Try, /*On fail goto*//*Label 12925*/ GIMT_Encode4(839044), // Rule ID 22978 //
     /*  838974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  838991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839020 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  839023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839042 */     GIR_RootConstrainSelectedInstOperands,
     /*  839043 */     // GIR_Coverage, 22978,
     /*  839043 */     GIR_EraseRootFromParent_Done,
     /*  839044 */   // Label 12925: @839044
     /*  839044 */   GIM_Try, /*On fail goto*//*Label 12926*/ GIMT_Encode4(839119), // Rule ID 22979 //
     /*  839049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  839052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  839066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839095 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  839098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839117 */     GIR_RootConstrainSelectedInstOperands,
     /*  839118 */     // GIR_Coverage, 22979,
     /*  839118 */     GIR_EraseRootFromParent_Done,
     /*  839119 */   // Label 12926: @839119
     /*  839119 */   GIM_Try, /*On fail goto*//*Label 12927*/ GIMT_Encode4(839194), // Rule ID 22982 //
     /*  839124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  839127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  839141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839170 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  839173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839192 */     GIR_RootConstrainSelectedInstOperands,
     /*  839193 */     // GIR_Coverage, 22982,
     /*  839193 */     GIR_EraseRootFromParent_Done,
     /*  839194 */   // Label 12927: @839194
     /*  839194 */   GIM_Try, /*On fail goto*//*Label 12928*/ GIMT_Encode4(839269), // Rule ID 22983 //
     /*  839199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  839202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  839216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839245 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  839248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839267 */     GIR_RootConstrainSelectedInstOperands,
     /*  839268 */     // GIR_Coverage, 22983,
     /*  839268 */     GIR_EraseRootFromParent_Done,
     /*  839269 */   // Label 12928: @839269
     /*  839269 */   GIM_Try, /*On fail goto*//*Label 12929*/ GIMT_Encode4(839344), // Rule ID 22986 //
     /*  839274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  839277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  839291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839320 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  839323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839342 */     GIR_RootConstrainSelectedInstOperands,
     /*  839343 */     // GIR_Coverage, 22986,
     /*  839343 */     GIR_EraseRootFromParent_Done,
     /*  839344 */   // Label 12929: @839344
     /*  839344 */   GIM_Try, /*On fail goto*//*Label 12930*/ GIMT_Encode4(839419), // Rule ID 22987 //
     /*  839349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  839352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  839366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839395 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  839398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839417 */     GIR_RootConstrainSelectedInstOperands,
     /*  839418 */     // GIR_Coverage, 22987,
     /*  839418 */     GIR_EraseRootFromParent_Done,
     /*  839419 */   // Label 12930: @839419
     /*  839419 */   GIM_Try, /*On fail goto*//*Label 12931*/ GIMT_Encode4(839494), // Rule ID 22990 //
     /*  839424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  839427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  839441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839470 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  839473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839492 */     GIR_RootConstrainSelectedInstOperands,
     /*  839493 */     // GIR_Coverage, 22990,
     /*  839493 */     GIR_EraseRootFromParent_Done,
     /*  839494 */   // Label 12931: @839494
     /*  839494 */   GIM_Try, /*On fail goto*//*Label 12932*/ GIMT_Encode4(839569), // Rule ID 22991 //
     /*  839499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  839502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  839516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839545 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  839548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839567 */     GIR_RootConstrainSelectedInstOperands,
     /*  839568 */     // GIR_Coverage, 22991,
     /*  839568 */     GIR_EraseRootFromParent_Done,
     /*  839569 */   // Label 12932: @839569
     /*  839569 */   GIM_Try, /*On fail goto*//*Label 12933*/ GIMT_Encode4(839644), // Rule ID 22994 //
     /*  839574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  839577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  839591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839620 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  839623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839642 */     GIR_RootConstrainSelectedInstOperands,
     /*  839643 */     // GIR_Coverage, 22994,
     /*  839643 */     GIR_EraseRootFromParent_Done,
     /*  839644 */   // Label 12933: @839644
     /*  839644 */   GIM_Try, /*On fail goto*//*Label 12934*/ GIMT_Encode4(839719), // Rule ID 22995 //
     /*  839649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  839652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  839666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839695 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  839698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839717 */     GIR_RootConstrainSelectedInstOperands,
     /*  839718 */     // GIR_Coverage, 22995,
     /*  839718 */     GIR_EraseRootFromParent_Done,
     /*  839719 */   // Label 12934: @839719
     /*  839719 */   GIM_Try, /*On fail goto*//*Label 12935*/ GIMT_Encode4(839794), // Rule ID 22998 //
     /*  839724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  839727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  839741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839770 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  839770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  839773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839792 */     GIR_RootConstrainSelectedInstOperands,
     /*  839793 */     // GIR_Coverage, 22998,
     /*  839793 */     GIR_EraseRootFromParent_Done,
     /*  839794 */   // Label 12935: @839794
     /*  839794 */   GIM_Try, /*On fail goto*//*Label 12936*/ GIMT_Encode4(839869), // Rule ID 22999 //
     /*  839799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  839802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  839816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839845 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  839845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  839848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839867 */     GIR_RootConstrainSelectedInstOperands,
     /*  839868 */     // GIR_Coverage, 22999,
     /*  839868 */     GIR_EraseRootFromParent_Done,
     /*  839869 */   // Label 12936: @839869
     /*  839869 */   GIM_Try, /*On fail goto*//*Label 12937*/ GIMT_Encode4(839944), // Rule ID 23002 //
     /*  839874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  839877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  839891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839920 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  839920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  839923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839942 */     GIR_RootConstrainSelectedInstOperands,
     /*  839943 */     // GIR_Coverage, 23002,
     /*  839943 */     GIR_EraseRootFromParent_Done,
     /*  839944 */   // Label 12937: @839944
     /*  839944 */   GIM_Try, /*On fail goto*//*Label 12938*/ GIMT_Encode4(840019), // Rule ID 23003 //
     /*  839949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  839952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  839966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839995 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  839995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  839998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840017 */     GIR_RootConstrainSelectedInstOperands,
     /*  840018 */     // GIR_Coverage, 23003,
     /*  840018 */     GIR_EraseRootFromParent_Done,
     /*  840019 */   // Label 12938: @840019
     /*  840019 */   GIM_Try, /*On fail goto*//*Label 12939*/ GIMT_Encode4(840094), // Rule ID 23006 //
     /*  840024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  840027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  840041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840070 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  840073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840092 */     GIR_RootConstrainSelectedInstOperands,
     /*  840093 */     // GIR_Coverage, 23006,
     /*  840093 */     GIR_EraseRootFromParent_Done,
     /*  840094 */   // Label 12939: @840094
     /*  840094 */   GIM_Try, /*On fail goto*//*Label 12940*/ GIMT_Encode4(840169), // Rule ID 23007 //
     /*  840099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  840102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  840116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840145 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  840145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  840148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840167 */     GIR_RootConstrainSelectedInstOperands,
     /*  840168 */     // GIR_Coverage, 23007,
     /*  840168 */     GIR_EraseRootFromParent_Done,
     /*  840169 */   // Label 12940: @840169
     /*  840169 */   GIM_Try, /*On fail goto*//*Label 12941*/ GIMT_Encode4(840244), // Rule ID 23010 //
     /*  840174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  840191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840220 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  840223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840242 */     GIR_RootConstrainSelectedInstOperands,
     /*  840243 */     // GIR_Coverage, 23010,
     /*  840243 */     GIR_EraseRootFromParent_Done,
     /*  840244 */   // Label 12941: @840244
     /*  840244 */   GIM_Try, /*On fail goto*//*Label 12942*/ GIMT_Encode4(840319), // Rule ID 23011 //
     /*  840249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  840266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840295 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  840298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840317 */     GIR_RootConstrainSelectedInstOperands,
     /*  840318 */     // GIR_Coverage, 23011,
     /*  840318 */     GIR_EraseRootFromParent_Done,
     /*  840319 */   // Label 12942: @840319
     /*  840319 */   GIM_Try, /*On fail goto*//*Label 12943*/ GIMT_Encode4(840394), // Rule ID 23014 //
     /*  840324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  840341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840370 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  840373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840392 */     GIR_RootConstrainSelectedInstOperands,
     /*  840393 */     // GIR_Coverage, 23014,
     /*  840393 */     GIR_EraseRootFromParent_Done,
     /*  840394 */   // Label 12943: @840394
     /*  840394 */   GIM_Try, /*On fail goto*//*Label 12944*/ GIMT_Encode4(840469), // Rule ID 23015 //
     /*  840399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  840416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840445 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  840448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840467 */     GIR_RootConstrainSelectedInstOperands,
     /*  840468 */     // GIR_Coverage, 23015,
     /*  840468 */     GIR_EraseRootFromParent_Done,
     /*  840469 */   // Label 12944: @840469
     /*  840469 */   GIM_Try, /*On fail goto*//*Label 12945*/ GIMT_Encode4(840544), // Rule ID 23018 //
     /*  840474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  840477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  840491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840520 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  840520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  840523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840542 */     GIR_RootConstrainSelectedInstOperands,
     /*  840543 */     // GIR_Coverage, 23018,
     /*  840543 */     GIR_EraseRootFromParent_Done,
     /*  840544 */   // Label 12945: @840544
     /*  840544 */   GIM_Try, /*On fail goto*//*Label 12946*/ GIMT_Encode4(840619), // Rule ID 23019 //
     /*  840549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  840552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  840566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840595 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  840595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  840598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840617 */     GIR_RootConstrainSelectedInstOperands,
     /*  840618 */     // GIR_Coverage, 23019,
     /*  840618 */     GIR_EraseRootFromParent_Done,
     /*  840619 */   // Label 12946: @840619
     /*  840619 */   GIM_Try, /*On fail goto*//*Label 12947*/ GIMT_Encode4(840694), // Rule ID 23022 //
     /*  840624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  840641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840670 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  840673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840692 */     GIR_RootConstrainSelectedInstOperands,
     /*  840693 */     // GIR_Coverage, 23022,
     /*  840693 */     GIR_EraseRootFromParent_Done,
     /*  840694 */   // Label 12947: @840694
     /*  840694 */   GIM_Try, /*On fail goto*//*Label 12948*/ GIMT_Encode4(840769), // Rule ID 23023 //
     /*  840699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  840716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840745 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  840748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840767 */     GIR_RootConstrainSelectedInstOperands,
     /*  840768 */     // GIR_Coverage, 23023,
     /*  840768 */     GIR_EraseRootFromParent_Done,
     /*  840769 */   // Label 12948: @840769
     /*  840769 */   GIM_Try, /*On fail goto*//*Label 12949*/ GIMT_Encode4(840844), // Rule ID 23026 //
     /*  840774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  840777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  840791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840820 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  840820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  840823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840842 */     GIR_RootConstrainSelectedInstOperands,
     /*  840843 */     // GIR_Coverage, 23026,
     /*  840843 */     GIR_EraseRootFromParent_Done,
     /*  840844 */   // Label 12949: @840844
     /*  840844 */   GIM_Try, /*On fail goto*//*Label 12950*/ GIMT_Encode4(840919), // Rule ID 23027 //
     /*  840849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  840852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  840866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840895 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  840895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  840898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840917 */     GIR_RootConstrainSelectedInstOperands,
     /*  840918 */     // GIR_Coverage, 23027,
     /*  840918 */     GIR_EraseRootFromParent_Done,
     /*  840919 */   // Label 12950: @840919
     /*  840919 */   GIM_Try, /*On fail goto*//*Label 12951*/ GIMT_Encode4(840994), // Rule ID 23030 //
     /*  840924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  840927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  840941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840970 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  840973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840992 */     GIR_RootConstrainSelectedInstOperands,
     /*  840993 */     // GIR_Coverage, 23030,
     /*  840993 */     GIR_EraseRootFromParent_Done,
     /*  840994 */   // Label 12951: @840994
     /*  840994 */   GIM_Try, /*On fail goto*//*Label 12952*/ GIMT_Encode4(841069), // Rule ID 23031 //
     /*  840999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  841002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  841016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841045 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  841045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  841048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  841064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841067 */     GIR_RootConstrainSelectedInstOperands,
     /*  841068 */     // GIR_Coverage, 23031,
     /*  841068 */     GIR_EraseRootFromParent_Done,
     /*  841069 */   // Label 12952: @841069
     /*  841069 */   GIM_Try, /*On fail goto*//*Label 12953*/ GIMT_Encode4(841144), // Rule ID 23034 //
     /*  841074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  841091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841120 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  841123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841142 */     GIR_RootConstrainSelectedInstOperands,
     /*  841143 */     // GIR_Coverage, 23034,
     /*  841143 */     GIR_EraseRootFromParent_Done,
     /*  841144 */   // Label 12953: @841144
     /*  841144 */   GIM_Try, /*On fail goto*//*Label 12954*/ GIMT_Encode4(841219), // Rule ID 23035 //
     /*  841149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  841166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841195 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  841198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841217 */     GIR_RootConstrainSelectedInstOperands,
     /*  841218 */     // GIR_Coverage, 23035,
     /*  841218 */     GIR_EraseRootFromParent_Done,
     /*  841219 */   // Label 12954: @841219
     /*  841219 */   GIM_Try, /*On fail goto*//*Label 12955*/ GIMT_Encode4(841294), // Rule ID 23038 //
     /*  841224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841270 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  841273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841292 */     GIR_RootConstrainSelectedInstOperands,
     /*  841293 */     // GIR_Coverage, 23038,
     /*  841293 */     GIR_EraseRootFromParent_Done,
     /*  841294 */   // Label 12955: @841294
     /*  841294 */   GIM_Try, /*On fail goto*//*Label 12956*/ GIMT_Encode4(841369), // Rule ID 23039 //
     /*  841299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841345 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  841348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841367 */     GIR_RootConstrainSelectedInstOperands,
     /*  841368 */     // GIR_Coverage, 23039,
     /*  841368 */     GIR_EraseRootFromParent_Done,
     /*  841369 */   // Label 12956: @841369
     /*  841369 */   GIM_Try, /*On fail goto*//*Label 12957*/ GIMT_Encode4(841444), // Rule ID 23042 //
     /*  841374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841420 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  841423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841442 */     GIR_RootConstrainSelectedInstOperands,
     /*  841443 */     // GIR_Coverage, 23042,
     /*  841443 */     GIR_EraseRootFromParent_Done,
     /*  841444 */   // Label 12957: @841444
     /*  841444 */   GIM_Try, /*On fail goto*//*Label 12958*/ GIMT_Encode4(841519), // Rule ID 23043 //
     /*  841449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841495 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  841498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841517 */     GIR_RootConstrainSelectedInstOperands,
     /*  841518 */     // GIR_Coverage, 23043,
     /*  841518 */     GIR_EraseRootFromParent_Done,
     /*  841519 */   // Label 12958: @841519
     /*  841519 */   GIM_Try, /*On fail goto*//*Label 12959*/ GIMT_Encode4(841594), // Rule ID 23046 //
     /*  841524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  841527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  841541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841570 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  841573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841592 */     GIR_RootConstrainSelectedInstOperands,
     /*  841593 */     // GIR_Coverage, 23046,
     /*  841593 */     GIR_EraseRootFromParent_Done,
     /*  841594 */   // Label 12959: @841594
     /*  841594 */   GIM_Try, /*On fail goto*//*Label 12960*/ GIMT_Encode4(841669), // Rule ID 23047 //
     /*  841599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  841602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  841616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841645 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  841648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841667 */     GIR_RootConstrainSelectedInstOperands,
     /*  841668 */     // GIR_Coverage, 23047,
     /*  841668 */     GIR_EraseRootFromParent_Done,
     /*  841669 */   // Label 12960: @841669
     /*  841669 */   GIM_Try, /*On fail goto*//*Label 12961*/ GIMT_Encode4(841744), // Rule ID 23050 //
     /*  841674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  841677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  841691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841720 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  841723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841742 */     GIR_RootConstrainSelectedInstOperands,
     /*  841743 */     // GIR_Coverage, 23050,
     /*  841743 */     GIR_EraseRootFromParent_Done,
     /*  841744 */   // Label 12961: @841744
     /*  841744 */   GIM_Try, /*On fail goto*//*Label 12962*/ GIMT_Encode4(841819), // Rule ID 23051 //
     /*  841749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  841752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  841766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841795 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  841798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841817 */     GIR_RootConstrainSelectedInstOperands,
     /*  841818 */     // GIR_Coverage, 23051,
     /*  841818 */     GIR_EraseRootFromParent_Done,
     /*  841819 */   // Label 12962: @841819
     /*  841819 */   GIM_Try, /*On fail goto*//*Label 12963*/ GIMT_Encode4(841894), // Rule ID 23054 //
     /*  841824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  841827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  841841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841870 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  841873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841892 */     GIR_RootConstrainSelectedInstOperands,
     /*  841893 */     // GIR_Coverage, 23054,
     /*  841893 */     GIR_EraseRootFromParent_Done,
     /*  841894 */   // Label 12963: @841894
     /*  841894 */   GIM_Try, /*On fail goto*//*Label 12964*/ GIMT_Encode4(841969), // Rule ID 23055 //
     /*  841899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  841902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  841916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841945 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  841948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841967 */     GIR_RootConstrainSelectedInstOperands,
     /*  841968 */     // GIR_Coverage, 23055,
     /*  841968 */     GIR_EraseRootFromParent_Done,
     /*  841969 */   // Label 12964: @841969
     /*  841969 */   GIM_Try, /*On fail goto*//*Label 12965*/ GIMT_Encode4(842044), // Rule ID 23058 //
     /*  841974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  841977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  841991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842020 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  842023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842042 */     GIR_RootConstrainSelectedInstOperands,
     /*  842043 */     // GIR_Coverage, 23058,
     /*  842043 */     GIR_EraseRootFromParent_Done,
     /*  842044 */   // Label 12965: @842044
     /*  842044 */   GIM_Try, /*On fail goto*//*Label 12966*/ GIMT_Encode4(842119), // Rule ID 23059 //
     /*  842049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  842066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842095 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  842098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842117 */     GIR_RootConstrainSelectedInstOperands,
     /*  842118 */     // GIR_Coverage, 23059,
     /*  842118 */     GIR_EraseRootFromParent_Done,
     /*  842119 */   // Label 12966: @842119
     /*  842119 */   GIM_Try, /*On fail goto*//*Label 12967*/ GIMT_Encode4(842194), // Rule ID 23062 //
     /*  842124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  842127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  842141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842170 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  842173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842192 */     GIR_RootConstrainSelectedInstOperands,
     /*  842193 */     // GIR_Coverage, 23062,
     /*  842193 */     GIR_EraseRootFromParent_Done,
     /*  842194 */   // Label 12967: @842194
     /*  842194 */   GIM_Try, /*On fail goto*//*Label 12968*/ GIMT_Encode4(842269), // Rule ID 23063 //
     /*  842199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  842216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842245 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  842248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842267 */     GIR_RootConstrainSelectedInstOperands,
     /*  842268 */     // GIR_Coverage, 23063,
     /*  842268 */     GIR_EraseRootFromParent_Done,
     /*  842269 */   // Label 12968: @842269
     /*  842269 */   GIM_Try, /*On fail goto*//*Label 12969*/ GIMT_Encode4(842344), // Rule ID 23066 //
     /*  842274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  842277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  842291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842320 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  842323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842342 */     GIR_RootConstrainSelectedInstOperands,
     /*  842343 */     // GIR_Coverage, 23066,
     /*  842343 */     GIR_EraseRootFromParent_Done,
     /*  842344 */   // Label 12969: @842344
     /*  842344 */   GIM_Try, /*On fail goto*//*Label 12970*/ GIMT_Encode4(842419), // Rule ID 23067 //
     /*  842349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  842366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842395 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  842398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842417 */     GIR_RootConstrainSelectedInstOperands,
     /*  842418 */     // GIR_Coverage, 23067,
     /*  842418 */     GIR_EraseRootFromParent_Done,
     /*  842419 */   // Label 12970: @842419
     /*  842419 */   GIM_Try, /*On fail goto*//*Label 12971*/ GIMT_Encode4(842494), // Rule ID 23348 //
     /*  842424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  842435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  842438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  842441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  842444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842470 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  842473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842492 */     GIR_RootConstrainSelectedInstOperands,
     /*  842493 */     // GIR_Coverage, 23348,
     /*  842493 */     GIR_EraseRootFromParent_Done,
     /*  842494 */   // Label 12971: @842494
     /*  842494 */   GIM_Try, /*On fail goto*//*Label 12972*/ GIMT_Encode4(842569), // Rule ID 23349 //
     /*  842499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  842510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  842513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  842516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  842519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842545 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  842548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842554 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842567 */     GIR_RootConstrainSelectedInstOperands,
     /*  842568 */     // GIR_Coverage, 23349,
     /*  842568 */     GIR_EraseRootFromParent_Done,
     /*  842569 */   // Label 12972: @842569
     /*  842569 */   GIM_Try, /*On fail goto*//*Label 12973*/ GIMT_Encode4(842644), // Rule ID 23352 //
     /*  842574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  842585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  842588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  842591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  842594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842620 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  842623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842642 */     GIR_RootConstrainSelectedInstOperands,
     /*  842643 */     // GIR_Coverage, 23352,
     /*  842643 */     GIR_EraseRootFromParent_Done,
     /*  842644 */   // Label 12973: @842644
     /*  842644 */   GIM_Try, /*On fail goto*//*Label 12974*/ GIMT_Encode4(842719), // Rule ID 23353 //
     /*  842649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  842660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  842663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  842666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  842669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842695 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  842698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842717 */     GIR_RootConstrainSelectedInstOperands,
     /*  842718 */     // GIR_Coverage, 23353,
     /*  842718 */     GIR_EraseRootFromParent_Done,
     /*  842719 */   // Label 12974: @842719
     /*  842719 */   GIM_Try, /*On fail goto*//*Label 12975*/ GIMT_Encode4(842794), // Rule ID 23356 //
     /*  842724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  842735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  842738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  842741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  842744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842770 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  842773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842792 */     GIR_RootConstrainSelectedInstOperands,
     /*  842793 */     // GIR_Coverage, 23356,
     /*  842793 */     GIR_EraseRootFromParent_Done,
     /*  842794 */   // Label 12975: @842794
     /*  842794 */   GIM_Try, /*On fail goto*//*Label 12976*/ GIMT_Encode4(842869), // Rule ID 23357 //
     /*  842799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  842810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  842813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  842816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  842819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842845 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  842848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842854 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842867 */     GIR_RootConstrainSelectedInstOperands,
     /*  842868 */     // GIR_Coverage, 23357,
     /*  842868 */     GIR_EraseRootFromParent_Done,
     /*  842869 */   // Label 12976: @842869
     /*  842869 */   GIM_Try, /*On fail goto*//*Label 12977*/ GIMT_Encode4(842944), // Rule ID 23360 //
     /*  842874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  842885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  842888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  842891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  842894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842920 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  842923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842942 */     GIR_RootConstrainSelectedInstOperands,
     /*  842943 */     // GIR_Coverage, 23360,
     /*  842943 */     GIR_EraseRootFromParent_Done,
     /*  842944 */   // Label 12977: @842944
     /*  842944 */   GIM_Try, /*On fail goto*//*Label 12978*/ GIMT_Encode4(843019), // Rule ID 23361 //
     /*  842949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  842960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  842963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  842966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  842969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842995 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  842998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843017 */     GIR_RootConstrainSelectedInstOperands,
     /*  843018 */     // GIR_Coverage, 23361,
     /*  843018 */     GIR_EraseRootFromParent_Done,
     /*  843019 */   // Label 12978: @843019
     /*  843019 */   GIM_Try, /*On fail goto*//*Label 12979*/ GIMT_Encode4(843094), // Rule ID 23364 //
     /*  843024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  843035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  843038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  843041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  843044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843070 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  843073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843092 */     GIR_RootConstrainSelectedInstOperands,
     /*  843093 */     // GIR_Coverage, 23364,
     /*  843093 */     GIR_EraseRootFromParent_Done,
     /*  843094 */   // Label 12979: @843094
     /*  843094 */   GIM_Try, /*On fail goto*//*Label 12980*/ GIMT_Encode4(843169), // Rule ID 23365 //
     /*  843099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  843110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  843113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  843116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  843119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843145 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  843148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843154 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843167 */     GIR_RootConstrainSelectedInstOperands,
     /*  843168 */     // GIR_Coverage, 23365,
     /*  843168 */     GIR_EraseRootFromParent_Done,
     /*  843169 */   // Label 12980: @843169
     /*  843169 */   GIM_Try, /*On fail goto*//*Label 12981*/ GIMT_Encode4(843244), // Rule ID 23368 //
     /*  843174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  843185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  843188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  843191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  843194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843220 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  843223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843242 */     GIR_RootConstrainSelectedInstOperands,
     /*  843243 */     // GIR_Coverage, 23368,
     /*  843243 */     GIR_EraseRootFromParent_Done,
     /*  843244 */   // Label 12981: @843244
     /*  843244 */   GIM_Try, /*On fail goto*//*Label 12982*/ GIMT_Encode4(843319), // Rule ID 23369 //
     /*  843249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  843260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  843263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  843266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  843269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843295 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  843298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843304 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843317 */     GIR_RootConstrainSelectedInstOperands,
     /*  843318 */     // GIR_Coverage, 23369,
     /*  843318 */     GIR_EraseRootFromParent_Done,
     /*  843319 */   // Label 12982: @843319
     /*  843319 */   GIM_Try, /*On fail goto*//*Label 12983*/ GIMT_Encode4(843394), // Rule ID 23372 //
     /*  843324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  843335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  843338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  843341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  843344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843370 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  843373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843392 */     GIR_RootConstrainSelectedInstOperands,
     /*  843393 */     // GIR_Coverage, 23372,
     /*  843393 */     GIR_EraseRootFromParent_Done,
     /*  843394 */   // Label 12983: @843394
     /*  843394 */   GIM_Try, /*On fail goto*//*Label 12984*/ GIMT_Encode4(843469), // Rule ID 23373 //
     /*  843399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  843410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  843413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  843416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  843419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843445 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  843448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843454 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843467 */     GIR_RootConstrainSelectedInstOperands,
     /*  843468 */     // GIR_Coverage, 23373,
     /*  843468 */     GIR_EraseRootFromParent_Done,
     /*  843469 */   // Label 12984: @843469
     /*  843469 */   GIM_Try, /*On fail goto*//*Label 12985*/ GIMT_Encode4(843544), // Rule ID 23376 //
     /*  843474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  843485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  843488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  843491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  843494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843520 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  843523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843542 */     GIR_RootConstrainSelectedInstOperands,
     /*  843543 */     // GIR_Coverage, 23376,
     /*  843543 */     GIR_EraseRootFromParent_Done,
     /*  843544 */   // Label 12985: @843544
     /*  843544 */   GIM_Try, /*On fail goto*//*Label 12986*/ GIMT_Encode4(843619), // Rule ID 23377 //
     /*  843549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  843560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  843563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  843566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  843569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843595 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  843598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843604 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843617 */     GIR_RootConstrainSelectedInstOperands,
     /*  843618 */     // GIR_Coverage, 23377,
     /*  843618 */     GIR_EraseRootFromParent_Done,
     /*  843619 */   // Label 12986: @843619
     /*  843619 */   GIM_Try, /*On fail goto*//*Label 12987*/ GIMT_Encode4(843694), // Rule ID 23380 //
     /*  843624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  843635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  843638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  843641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  843644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843670 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  843673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843692 */     GIR_RootConstrainSelectedInstOperands,
     /*  843693 */     // GIR_Coverage, 23380,
     /*  843693 */     GIR_EraseRootFromParent_Done,
     /*  843694 */   // Label 12987: @843694
     /*  843694 */   GIM_Try, /*On fail goto*//*Label 12988*/ GIMT_Encode4(843769), // Rule ID 23381 //
     /*  843699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  843710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  843713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  843716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  843719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843745 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  843748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843754 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843767 */     GIR_RootConstrainSelectedInstOperands,
     /*  843768 */     // GIR_Coverage, 23381,
     /*  843768 */     GIR_EraseRootFromParent_Done,
     /*  843769 */   // Label 12988: @843769
     /*  843769 */   GIM_Try, /*On fail goto*//*Label 12989*/ GIMT_Encode4(843844), // Rule ID 23384 //
     /*  843774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  843785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  843788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  843791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  843794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843820 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  843823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843842 */     GIR_RootConstrainSelectedInstOperands,
     /*  843843 */     // GIR_Coverage, 23384,
     /*  843843 */     GIR_EraseRootFromParent_Done,
     /*  843844 */   // Label 12989: @843844
     /*  843844 */   GIM_Try, /*On fail goto*//*Label 12990*/ GIMT_Encode4(843919), // Rule ID 23385 //
     /*  843849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  843860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  843863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  843866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  843869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843895 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  843898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843904 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843917 */     GIR_RootConstrainSelectedInstOperands,
     /*  843918 */     // GIR_Coverage, 23385,
     /*  843918 */     GIR_EraseRootFromParent_Done,
     /*  843919 */   // Label 12990: @843919
     /*  843919 */   GIM_Try, /*On fail goto*//*Label 12991*/ GIMT_Encode4(843994), // Rule ID 23388 //
     /*  843924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  843935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  843938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  843941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  843944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843970 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  843973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843992 */     GIR_RootConstrainSelectedInstOperands,
     /*  843993 */     // GIR_Coverage, 23388,
     /*  843993 */     GIR_EraseRootFromParent_Done,
     /*  843994 */   // Label 12991: @843994
     /*  843994 */   GIM_Try, /*On fail goto*//*Label 12992*/ GIMT_Encode4(844069), // Rule ID 23389 //
     /*  843999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  844010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  844013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  844016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  844019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844045 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  844048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844054 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844067 */     GIR_RootConstrainSelectedInstOperands,
     /*  844068 */     // GIR_Coverage, 23389,
     /*  844068 */     GIR_EraseRootFromParent_Done,
     /*  844069 */   // Label 12992: @844069
     /*  844069 */   GIM_Try, /*On fail goto*//*Label 12993*/ GIMT_Encode4(844144), // Rule ID 23392 //
     /*  844074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  844085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  844088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  844091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  844094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844120 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  844123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844142 */     GIR_RootConstrainSelectedInstOperands,
     /*  844143 */     // GIR_Coverage, 23392,
     /*  844143 */     GIR_EraseRootFromParent_Done,
     /*  844144 */   // Label 12993: @844144
     /*  844144 */   GIM_Try, /*On fail goto*//*Label 12994*/ GIMT_Encode4(844219), // Rule ID 23393 //
     /*  844149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  844160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  844163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  844166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  844169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844195 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  844198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844204 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844217 */     GIR_RootConstrainSelectedInstOperands,
     /*  844218 */     // GIR_Coverage, 23393,
     /*  844218 */     GIR_EraseRootFromParent_Done,
     /*  844219 */   // Label 12994: @844219
     /*  844219 */   GIM_Try, /*On fail goto*//*Label 12995*/ GIMT_Encode4(844294), // Rule ID 23396 //
     /*  844224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  844235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  844238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  844241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  844244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844270 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  844273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844292 */     GIR_RootConstrainSelectedInstOperands,
     /*  844293 */     // GIR_Coverage, 23396,
     /*  844293 */     GIR_EraseRootFromParent_Done,
     /*  844294 */   // Label 12995: @844294
     /*  844294 */   GIM_Try, /*On fail goto*//*Label 12996*/ GIMT_Encode4(844369), // Rule ID 23397 //
     /*  844299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  844310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  844313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  844316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  844319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844345 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11470:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  844348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844354 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844367 */     GIR_RootConstrainSelectedInstOperands,
     /*  844368 */     // GIR_Coverage, 23397,
     /*  844368 */     GIR_EraseRootFromParent_Done,
     /*  844369 */   // Label 12996: @844369
     /*  844369 */   GIM_Try, /*On fail goto*//*Label 12997*/ GIMT_Encode4(844444), // Rule ID 23400 //
     /*  844374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  844385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  844388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  844391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  844394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844420 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  844423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844442 */     GIR_RootConstrainSelectedInstOperands,
     /*  844443 */     // GIR_Coverage, 23400,
     /*  844443 */     GIR_EraseRootFromParent_Done,
     /*  844444 */   // Label 12997: @844444
     /*  844444 */   GIM_Try, /*On fail goto*//*Label 12998*/ GIMT_Encode4(844519), // Rule ID 23401 //
     /*  844449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  844460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  844463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  844466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  844469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844495 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  844498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844504 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844517 */     GIR_RootConstrainSelectedInstOperands,
     /*  844518 */     // GIR_Coverage, 23401,
     /*  844518 */     GIR_EraseRootFromParent_Done,
     /*  844519 */   // Label 12998: @844519
     /*  844519 */   GIM_Try, /*On fail goto*//*Label 12999*/ GIMT_Encode4(844594), // Rule ID 23404 //
     /*  844524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  844535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  844538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  844541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  844544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844570 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  844573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844579 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844592 */     GIR_RootConstrainSelectedInstOperands,
     /*  844593 */     // GIR_Coverage, 23404,
     /*  844593 */     GIR_EraseRootFromParent_Done,
     /*  844594 */   // Label 12999: @844594
     /*  844594 */   GIM_Try, /*On fail goto*//*Label 13000*/ GIMT_Encode4(844669), // Rule ID 23405 //
     /*  844599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  844610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  844613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  844616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  844619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844645 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  844648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844654 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844667 */     GIR_RootConstrainSelectedInstOperands,
     /*  844668 */     // GIR_Coverage, 23405,
     /*  844668 */     GIR_EraseRootFromParent_Done,
     /*  844669 */   // Label 13000: @844669
     /*  844669 */   GIM_Try, /*On fail goto*//*Label 13001*/ GIMT_Encode4(844744), // Rule ID 23408 //
     /*  844674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  844685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  844688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  844691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  844694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844720 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  844723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844742 */     GIR_RootConstrainSelectedInstOperands,
     /*  844743 */     // GIR_Coverage, 23408,
     /*  844743 */     GIR_EraseRootFromParent_Done,
     /*  844744 */   // Label 13001: @844744
     /*  844744 */   GIM_Try, /*On fail goto*//*Label 13002*/ GIMT_Encode4(844819), // Rule ID 23409 //
     /*  844749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  844760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  844763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  844766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  844769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844795 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  844798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844804 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844817 */     GIR_RootConstrainSelectedInstOperands,
     /*  844818 */     // GIR_Coverage, 23409,
     /*  844818 */     GIR_EraseRootFromParent_Done,
     /*  844819 */   // Label 13002: @844819
     /*  844819 */   GIM_Try, /*On fail goto*//*Label 13003*/ GIMT_Encode4(844894), // Rule ID 23412 //
     /*  844824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  844835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  844838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  844841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  844844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844870 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  844873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844892 */     GIR_RootConstrainSelectedInstOperands,
     /*  844893 */     // GIR_Coverage, 23412,
     /*  844893 */     GIR_EraseRootFromParent_Done,
     /*  844894 */   // Label 13003: @844894
     /*  844894 */   GIM_Try, /*On fail goto*//*Label 13004*/ GIMT_Encode4(844969), // Rule ID 23413 //
     /*  844899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  844910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  844913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  844916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  844919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844945 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  844948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844954 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844967 */     GIR_RootConstrainSelectedInstOperands,
     /*  844968 */     // GIR_Coverage, 23413,
     /*  844968 */     GIR_EraseRootFromParent_Done,
     /*  844969 */   // Label 13004: @844969
     /*  844969 */   GIM_Try, /*On fail goto*//*Label 13005*/ GIMT_Encode4(845044), // Rule ID 23416 //
     /*  844974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  844985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  844988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  844991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  844994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845020 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  845023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845042 */     GIR_RootConstrainSelectedInstOperands,
     /*  845043 */     // GIR_Coverage, 23416,
     /*  845043 */     GIR_EraseRootFromParent_Done,
     /*  845044 */   // Label 13005: @845044
     /*  845044 */   GIM_Try, /*On fail goto*//*Label 13006*/ GIMT_Encode4(845119), // Rule ID 23417 //
     /*  845049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  845060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  845063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  845066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  845069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845095 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  845098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845104 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845117 */     GIR_RootConstrainSelectedInstOperands,
     /*  845118 */     // GIR_Coverage, 23417,
     /*  845118 */     GIR_EraseRootFromParent_Done,
     /*  845119 */   // Label 13006: @845119
     /*  845119 */   GIM_Try, /*On fail goto*//*Label 13007*/ GIMT_Encode4(845194), // Rule ID 23420 //
     /*  845124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  845135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  845138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  845141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  845144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845170 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  845173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845179 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845192 */     GIR_RootConstrainSelectedInstOperands,
     /*  845193 */     // GIR_Coverage, 23420,
     /*  845193 */     GIR_EraseRootFromParent_Done,
     /*  845194 */   // Label 13007: @845194
     /*  845194 */   GIM_Try, /*On fail goto*//*Label 13008*/ GIMT_Encode4(845269), // Rule ID 23421 //
     /*  845199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  845210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  845213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  845216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  845219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845245 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  845248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845254 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845267 */     GIR_RootConstrainSelectedInstOperands,
     /*  845268 */     // GIR_Coverage, 23421,
     /*  845268 */     GIR_EraseRootFromParent_Done,
     /*  845269 */   // Label 13008: @845269
     /*  845269 */   GIM_Try, /*On fail goto*//*Label 13009*/ GIMT_Encode4(845344), // Rule ID 23424 //
     /*  845274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  845285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  845288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  845291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  845294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845320 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  845323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845342 */     GIR_RootConstrainSelectedInstOperands,
     /*  845343 */     // GIR_Coverage, 23424,
     /*  845343 */     GIR_EraseRootFromParent_Done,
     /*  845344 */   // Label 13009: @845344
     /*  845344 */   GIM_Try, /*On fail goto*//*Label 13010*/ GIMT_Encode4(845419), // Rule ID 23425 //
     /*  845349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  845360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  845363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  845366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  845369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845395 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  845398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845417 */     GIR_RootConstrainSelectedInstOperands,
     /*  845418 */     // GIR_Coverage, 23425,
     /*  845418 */     GIR_EraseRootFromParent_Done,
     /*  845419 */   // Label 13010: @845419
     /*  845419 */   GIM_Try, /*On fail goto*//*Label 13011*/ GIMT_Encode4(845494), // Rule ID 23966 //
     /*  845424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  845435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  845438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  845441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845470 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  845470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  845473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845492 */     GIR_RootConstrainSelectedInstOperands,
     /*  845493 */     // GIR_Coverage, 23966,
     /*  845493 */     GIR_EraseRootFromParent_Done,
     /*  845494 */   // Label 13011: @845494
     /*  845494 */   GIM_Try, /*On fail goto*//*Label 13012*/ GIMT_Encode4(845569), // Rule ID 23967 //
     /*  845499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  845510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  845513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  845516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845545 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  845545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  845548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845567 */     GIR_RootConstrainSelectedInstOperands,
     /*  845568 */     // GIR_Coverage, 23967,
     /*  845568 */     GIR_EraseRootFromParent_Done,
     /*  845569 */   // Label 13012: @845569
     /*  845569 */   GIM_Try, /*On fail goto*//*Label 13013*/ GIMT_Encode4(845644), // Rule ID 23970 //
     /*  845574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  845585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  845588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  845591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845620 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  845620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  845623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845642 */     GIR_RootConstrainSelectedInstOperands,
     /*  845643 */     // GIR_Coverage, 23970,
     /*  845643 */     GIR_EraseRootFromParent_Done,
     /*  845644 */   // Label 13013: @845644
     /*  845644 */   GIM_Try, /*On fail goto*//*Label 13014*/ GIMT_Encode4(845719), // Rule ID 23971 //
     /*  845649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  845660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  845663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  845666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845695 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  845695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  845698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845717 */     GIR_RootConstrainSelectedInstOperands,
     /*  845718 */     // GIR_Coverage, 23971,
     /*  845718 */     GIR_EraseRootFromParent_Done,
     /*  845719 */   // Label 13014: @845719
     /*  845719 */   GIM_Try, /*On fail goto*//*Label 13015*/ GIMT_Encode4(845794), // Rule ID 23974 //
     /*  845724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  845735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  845738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  845741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845770 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  845770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  845773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845792 */     GIR_RootConstrainSelectedInstOperands,
     /*  845793 */     // GIR_Coverage, 23974,
     /*  845793 */     GIR_EraseRootFromParent_Done,
     /*  845794 */   // Label 13015: @845794
     /*  845794 */   GIM_Try, /*On fail goto*//*Label 13016*/ GIMT_Encode4(845869), // Rule ID 23975 //
     /*  845799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  845810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  845813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  845816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845845 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  845845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  845848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845867 */     GIR_RootConstrainSelectedInstOperands,
     /*  845868 */     // GIR_Coverage, 23975,
     /*  845868 */     GIR_EraseRootFromParent_Done,
     /*  845869 */   // Label 13016: @845869
     /*  845869 */   GIM_Try, /*On fail goto*//*Label 13017*/ GIMT_Encode4(845944), // Rule ID 23978 //
     /*  845874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  845885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  845888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  845891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845920 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  845920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  845923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845942 */     GIR_RootConstrainSelectedInstOperands,
     /*  845943 */     // GIR_Coverage, 23978,
     /*  845943 */     GIR_EraseRootFromParent_Done,
     /*  845944 */   // Label 13017: @845944
     /*  845944 */   GIM_Try, /*On fail goto*//*Label 13018*/ GIMT_Encode4(846019), // Rule ID 23979 //
     /*  845949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  845960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  845963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  845966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845995 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  845995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  845998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846017 */     GIR_RootConstrainSelectedInstOperands,
     /*  846018 */     // GIR_Coverage, 23979,
     /*  846018 */     GIR_EraseRootFromParent_Done,
     /*  846019 */   // Label 13018: @846019
     /*  846019 */   GIM_Try, /*On fail goto*//*Label 13019*/ GIMT_Encode4(846094), // Rule ID 23982 //
     /*  846024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  846035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  846038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  846041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846070 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  846070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846092 */     GIR_RootConstrainSelectedInstOperands,
     /*  846093 */     // GIR_Coverage, 23982,
     /*  846093 */     GIR_EraseRootFromParent_Done,
     /*  846094 */   // Label 13019: @846094
     /*  846094 */   GIM_Try, /*On fail goto*//*Label 13020*/ GIMT_Encode4(846169), // Rule ID 23983 //
     /*  846099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  846110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  846113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  846116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846145 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  846145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846167 */     GIR_RootConstrainSelectedInstOperands,
     /*  846168 */     // GIR_Coverage, 23983,
     /*  846168 */     GIR_EraseRootFromParent_Done,
     /*  846169 */   // Label 13020: @846169
     /*  846169 */   GIM_Try, /*On fail goto*//*Label 13021*/ GIMT_Encode4(846244), // Rule ID 23986 //
     /*  846174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  846185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  846188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  846191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846220 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  846220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846242 */     GIR_RootConstrainSelectedInstOperands,
     /*  846243 */     // GIR_Coverage, 23986,
     /*  846243 */     GIR_EraseRootFromParent_Done,
     /*  846244 */   // Label 13021: @846244
     /*  846244 */   GIM_Try, /*On fail goto*//*Label 13022*/ GIMT_Encode4(846319), // Rule ID 23987 //
     /*  846249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  846260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  846263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  846266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846295 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  846295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846317 */     GIR_RootConstrainSelectedInstOperands,
     /*  846318 */     // GIR_Coverage, 23987,
     /*  846318 */     GIR_EraseRootFromParent_Done,
     /*  846319 */   // Label 13022: @846319
     /*  846319 */   GIM_Try, /*On fail goto*//*Label 13023*/ GIMT_Encode4(846394), // Rule ID 23990 //
     /*  846324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  846335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  846338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  846341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846370 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  846370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846392 */     GIR_RootConstrainSelectedInstOperands,
     /*  846393 */     // GIR_Coverage, 23990,
     /*  846393 */     GIR_EraseRootFromParent_Done,
     /*  846394 */   // Label 13023: @846394
     /*  846394 */   GIM_Try, /*On fail goto*//*Label 13024*/ GIMT_Encode4(846469), // Rule ID 23991 //
     /*  846399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  846410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  846413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  846416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846445 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  846445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846467 */     GIR_RootConstrainSelectedInstOperands,
     /*  846468 */     // GIR_Coverage, 23991,
     /*  846468 */     GIR_EraseRootFromParent_Done,
     /*  846469 */   // Label 13024: @846469
     /*  846469 */   GIM_Try, /*On fail goto*//*Label 13025*/ GIMT_Encode4(846544), // Rule ID 23994 //
     /*  846474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  846485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  846488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  846491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846520 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  846520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846542 */     GIR_RootConstrainSelectedInstOperands,
     /*  846543 */     // GIR_Coverage, 23994,
     /*  846543 */     GIR_EraseRootFromParent_Done,
     /*  846544 */   // Label 13025: @846544
     /*  846544 */   GIM_Try, /*On fail goto*//*Label 13026*/ GIMT_Encode4(846619), // Rule ID 23995 //
     /*  846549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  846560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  846563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  846566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846595 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  846595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846617 */     GIR_RootConstrainSelectedInstOperands,
     /*  846618 */     // GIR_Coverage, 23995,
     /*  846618 */     GIR_EraseRootFromParent_Done,
     /*  846619 */   // Label 13026: @846619
     /*  846619 */   GIM_Try, /*On fail goto*//*Label 13027*/ GIMT_Encode4(846694), // Rule ID 23998 //
     /*  846624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  846635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  846638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  846641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  846670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846692 */     GIR_RootConstrainSelectedInstOperands,
     /*  846693 */     // GIR_Coverage, 23998,
     /*  846693 */     GIR_EraseRootFromParent_Done,
     /*  846694 */   // Label 13027: @846694
     /*  846694 */   GIM_Try, /*On fail goto*//*Label 13028*/ GIMT_Encode4(846769), // Rule ID 23999 //
     /*  846699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  846710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  846713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  846716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846745 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  846745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846767 */     GIR_RootConstrainSelectedInstOperands,
     /*  846768 */     // GIR_Coverage, 23999,
     /*  846768 */     GIR_EraseRootFromParent_Done,
     /*  846769 */   // Label 13028: @846769
     /*  846769 */   GIM_Try, /*On fail goto*//*Label 13029*/ GIMT_Encode4(846844), // Rule ID 24002 //
     /*  846774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  846777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  846785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  846788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  846791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846820 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  846820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846842 */     GIR_RootConstrainSelectedInstOperands,
     /*  846843 */     // GIR_Coverage, 24002,
     /*  846843 */     GIR_EraseRootFromParent_Done,
     /*  846844 */   // Label 13029: @846844
     /*  846844 */   GIM_Try, /*On fail goto*//*Label 13030*/ GIMT_Encode4(846919), // Rule ID 24003 //
     /*  846849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  846852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  846860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  846863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  846866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846895 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  846895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846917 */     GIR_RootConstrainSelectedInstOperands,
     /*  846918 */     // GIR_Coverage, 24003,
     /*  846918 */     GIR_EraseRootFromParent_Done,
     /*  846919 */   // Label 13030: @846919
     /*  846919 */   GIM_Try, /*On fail goto*//*Label 13031*/ GIMT_Encode4(846994), // Rule ID 24006 //
     /*  846924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  846935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  846938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  846941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846970 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  846970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  846973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846992 */     GIR_RootConstrainSelectedInstOperands,
     /*  846993 */     // GIR_Coverage, 24006,
     /*  846993 */     GIR_EraseRootFromParent_Done,
     /*  846994 */   // Label 13031: @846994
     /*  846994 */   GIM_Try, /*On fail goto*//*Label 13032*/ GIMT_Encode4(847069), // Rule ID 24007 //
     /*  846999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  847010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  847013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  847016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847045 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  847045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847067 */     GIR_RootConstrainSelectedInstOperands,
     /*  847068 */     // GIR_Coverage, 24007,
     /*  847068 */     GIR_EraseRootFromParent_Done,
     /*  847069 */   // Label 13032: @847069
     /*  847069 */   GIM_Try, /*On fail goto*//*Label 13033*/ GIMT_Encode4(847144), // Rule ID 24010 //
     /*  847074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  847085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  847088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  847091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847120 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  847120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847142 */     GIR_RootConstrainSelectedInstOperands,
     /*  847143 */     // GIR_Coverage, 24010,
     /*  847143 */     GIR_EraseRootFromParent_Done,
     /*  847144 */   // Label 13033: @847144
     /*  847144 */   GIM_Try, /*On fail goto*//*Label 13034*/ GIMT_Encode4(847219), // Rule ID 24011 //
     /*  847149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  847160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  847163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  847166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847195 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  847195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847217 */     GIR_RootConstrainSelectedInstOperands,
     /*  847218 */     // GIR_Coverage, 24011,
     /*  847218 */     GIR_EraseRootFromParent_Done,
     /*  847219 */   // Label 13034: @847219
     /*  847219 */   GIM_Try, /*On fail goto*//*Label 13035*/ GIMT_Encode4(847294), // Rule ID 24014 //
     /*  847224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  847235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  847238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  847241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847270 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  847270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847292 */     GIR_RootConstrainSelectedInstOperands,
     /*  847293 */     // GIR_Coverage, 24014,
     /*  847293 */     GIR_EraseRootFromParent_Done,
     /*  847294 */   // Label 13035: @847294
     /*  847294 */   GIM_Try, /*On fail goto*//*Label 13036*/ GIMT_Encode4(847369), // Rule ID 24015 //
     /*  847299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  847310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  847313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  847316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847345 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  847345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847367 */     GIR_RootConstrainSelectedInstOperands,
     /*  847368 */     // GIR_Coverage, 24015,
     /*  847368 */     GIR_EraseRootFromParent_Done,
     /*  847369 */   // Label 13036: @847369
     /*  847369 */   GIM_Try, /*On fail goto*//*Label 13037*/ GIMT_Encode4(847444), // Rule ID 24018 //
     /*  847374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  847385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  847388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  847391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847420 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  847420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847442 */     GIR_RootConstrainSelectedInstOperands,
     /*  847443 */     // GIR_Coverage, 24018,
     /*  847443 */     GIR_EraseRootFromParent_Done,
     /*  847444 */   // Label 13037: @847444
     /*  847444 */   GIM_Try, /*On fail goto*//*Label 13038*/ GIMT_Encode4(847519), // Rule ID 24019 //
     /*  847449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  847460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  847463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  847466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847495 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  847495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847517 */     GIR_RootConstrainSelectedInstOperands,
     /*  847518 */     // GIR_Coverage, 24019,
     /*  847518 */     GIR_EraseRootFromParent_Done,
     /*  847519 */   // Label 13038: @847519
     /*  847519 */   GIM_Try, /*On fail goto*//*Label 13039*/ GIMT_Encode4(847594), // Rule ID 24022 //
     /*  847524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  847535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  847538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  847541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847570 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  847570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847592 */     GIR_RootConstrainSelectedInstOperands,
     /*  847593 */     // GIR_Coverage, 24022,
     /*  847593 */     GIR_EraseRootFromParent_Done,
     /*  847594 */   // Label 13039: @847594
     /*  847594 */   GIM_Try, /*On fail goto*//*Label 13040*/ GIMT_Encode4(847669), // Rule ID 24023 //
     /*  847599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  847610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  847613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  847616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847645 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  847645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847667 */     GIR_RootConstrainSelectedInstOperands,
     /*  847668 */     // GIR_Coverage, 24023,
     /*  847668 */     GIR_EraseRootFromParent_Done,
     /*  847669 */   // Label 13040: @847669
     /*  847669 */   GIM_Try, /*On fail goto*//*Label 13041*/ GIMT_Encode4(847744), // Rule ID 24026 //
     /*  847674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  847685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  847688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  847691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847720 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  847720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847742 */     GIR_RootConstrainSelectedInstOperands,
     /*  847743 */     // GIR_Coverage, 24026,
     /*  847743 */     GIR_EraseRootFromParent_Done,
     /*  847744 */   // Label 13041: @847744
     /*  847744 */   GIM_Try, /*On fail goto*//*Label 13042*/ GIMT_Encode4(847819), // Rule ID 24027 //
     /*  847749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  847760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  847763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  847766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847795 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  847795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847817 */     GIR_RootConstrainSelectedInstOperands,
     /*  847818 */     // GIR_Coverage, 24027,
     /*  847818 */     GIR_EraseRootFromParent_Done,
     /*  847819 */   // Label 13042: @847819
     /*  847819 */   GIM_Try, /*On fail goto*//*Label 13043*/ GIMT_Encode4(847894), // Rule ID 24030 //
     /*  847824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  847835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  847838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  847841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  847870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847892 */     GIR_RootConstrainSelectedInstOperands,
     /*  847893 */     // GIR_Coverage, 24030,
     /*  847893 */     GIR_EraseRootFromParent_Done,
     /*  847894 */   // Label 13043: @847894
     /*  847894 */   GIM_Try, /*On fail goto*//*Label 13044*/ GIMT_Encode4(847969), // Rule ID 24031 //
     /*  847899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  847910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  847913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  847916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847945 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  847945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847967 */     GIR_RootConstrainSelectedInstOperands,
     /*  847968 */     // GIR_Coverage, 24031,
     /*  847968 */     GIR_EraseRootFromParent_Done,
     /*  847969 */   // Label 13044: @847969
     /*  847969 */   GIM_Try, /*On fail goto*//*Label 13045*/ GIMT_Encode4(848044), // Rule ID 24034 //
     /*  847974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  847985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  847988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  847991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848020 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  848020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848042 */     GIR_RootConstrainSelectedInstOperands,
     /*  848043 */     // GIR_Coverage, 24034,
     /*  848043 */     GIR_EraseRootFromParent_Done,
     /*  848044 */   // Label 13045: @848044
     /*  848044 */   GIM_Try, /*On fail goto*//*Label 13046*/ GIMT_Encode4(848119), // Rule ID 24035 //
     /*  848049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  848060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  848063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  848066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848095 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  848095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848117 */     GIR_RootConstrainSelectedInstOperands,
     /*  848118 */     // GIR_Coverage, 24035,
     /*  848118 */     GIR_EraseRootFromParent_Done,
     /*  848119 */   // Label 13046: @848119
     /*  848119 */   GIM_Try, /*On fail goto*//*Label 13047*/ GIMT_Encode4(848194), // Rule ID 24038 //
     /*  848124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  848135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  848138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  848141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848170 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  848170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848192 */     GIR_RootConstrainSelectedInstOperands,
     /*  848193 */     // GIR_Coverage, 24038,
     /*  848193 */     GIR_EraseRootFromParent_Done,
     /*  848194 */   // Label 13047: @848194
     /*  848194 */   GIM_Try, /*On fail goto*//*Label 13048*/ GIMT_Encode4(848269), // Rule ID 24039 //
     /*  848199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  848210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  848213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  848216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848245 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  848245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848267 */     GIR_RootConstrainSelectedInstOperands,
     /*  848268 */     // GIR_Coverage, 24039,
     /*  848268 */     GIR_EraseRootFromParent_Done,
     /*  848269 */   // Label 13048: @848269
     /*  848269 */   GIM_Try, /*On fail goto*//*Label 13049*/ GIMT_Encode4(848344), // Rule ID 24042 //
     /*  848274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  848277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  848285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  848288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  848291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  848320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  848323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848342 */     GIR_RootConstrainSelectedInstOperands,
     /*  848343 */     // GIR_Coverage, 24042,
     /*  848343 */     GIR_EraseRootFromParent_Done,
     /*  848344 */   // Label 13049: @848344
     /*  848344 */   GIM_Try, /*On fail goto*//*Label 13050*/ GIMT_Encode4(848419), // Rule ID 24043 //
     /*  848349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  848352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  848360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  848363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  848366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848395 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  848395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  848398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848417 */     GIR_RootConstrainSelectedInstOperands,
     /*  848418 */     // GIR_Coverage, 24043,
     /*  848418 */     GIR_EraseRootFromParent_Done,
     /*  848419 */   // Label 13050: @848419
     /*  848419 */   GIM_Try, /*On fail goto*//*Label 13051*/ GIMT_Encode4(848494), // Rule ID 24046 //
     /*  848424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  848427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  848435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  848438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  848441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848470 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  848470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848492 */     GIR_RootConstrainSelectedInstOperands,
     /*  848493 */     // GIR_Coverage, 24046,
     /*  848493 */     GIR_EraseRootFromParent_Done,
     /*  848494 */   // Label 13051: @848494
     /*  848494 */   GIM_Try, /*On fail goto*//*Label 13052*/ GIMT_Encode4(848569), // Rule ID 24047 //
     /*  848499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  848502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  848510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  848513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  848516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848545 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  848545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848567 */     GIR_RootConstrainSelectedInstOperands,
     /*  848568 */     // GIR_Coverage, 24047,
     /*  848568 */     GIR_EraseRootFromParent_Done,
     /*  848569 */   // Label 13052: @848569
     /*  848569 */   GIM_Try, /*On fail goto*//*Label 13053*/ GIMT_Encode4(848644), // Rule ID 24050 //
     /*  848574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  848577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  848585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  848588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  848591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848620 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  848620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848642 */     GIR_RootConstrainSelectedInstOperands,
     /*  848643 */     // GIR_Coverage, 24050,
     /*  848643 */     GIR_EraseRootFromParent_Done,
     /*  848644 */   // Label 13053: @848644
     /*  848644 */   GIM_Try, /*On fail goto*//*Label 13054*/ GIMT_Encode4(848719), // Rule ID 24051 //
     /*  848649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  848652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  848660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  848663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  848666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848695 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  848695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848717 */     GIR_RootConstrainSelectedInstOperands,
     /*  848718 */     // GIR_Coverage, 24051,
     /*  848718 */     GIR_EraseRootFromParent_Done,
     /*  848719 */   // Label 13054: @848719
     /*  848719 */   GIM_Try, /*On fail goto*//*Label 13055*/ GIMT_Encode4(848794), // Rule ID 24054 //
     /*  848724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  848735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  848738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  848741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848770 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  848770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  848773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  848789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848792 */     GIR_RootConstrainSelectedInstOperands,
     /*  848793 */     // GIR_Coverage, 24054,
     /*  848793 */     GIR_EraseRootFromParent_Done,
     /*  848794 */   // Label 13055: @848794
     /*  848794 */   GIM_Try, /*On fail goto*//*Label 13056*/ GIMT_Encode4(848869), // Rule ID 24055 //
     /*  848799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  848810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  848813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  848816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848845 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  848845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  848848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  848864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848867 */     GIR_RootConstrainSelectedInstOperands,
     /*  848868 */     // GIR_Coverage, 24055,
     /*  848868 */     GIR_EraseRootFromParent_Done,
     /*  848869 */   // Label 13056: @848869
     /*  848869 */   GIM_Try, /*On fail goto*//*Label 13057*/ GIMT_Encode4(848944), // Rule ID 24058 //
     /*  848874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  848885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  848888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  848891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848920 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  848920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  848923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  848939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848942 */     GIR_RootConstrainSelectedInstOperands,
     /*  848943 */     // GIR_Coverage, 24058,
     /*  848943 */     GIR_EraseRootFromParent_Done,
     /*  848944 */   // Label 13057: @848944
     /*  848944 */   GIM_Try, /*On fail goto*//*Label 13058*/ GIMT_Encode4(849019), // Rule ID 24059 //
     /*  848949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  848960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  848963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  848966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848995 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  848995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  848998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849017 */     GIR_RootConstrainSelectedInstOperands,
     /*  849018 */     // GIR_Coverage, 24059,
     /*  849018 */     GIR_EraseRootFromParent_Done,
     /*  849019 */   // Label 13058: @849019
     /*  849019 */   GIM_Try, /*On fail goto*//*Label 13059*/ GIMT_Encode4(849094), // Rule ID 24062 //
     /*  849024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  849038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849070 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849092 */     GIR_RootConstrainSelectedInstOperands,
     /*  849093 */     // GIR_Coverage, 24062,
     /*  849093 */     GIR_EraseRootFromParent_Done,
     /*  849094 */   // Label 13059: @849094
     /*  849094 */   GIM_Try, /*On fail goto*//*Label 13060*/ GIMT_Encode4(849169), // Rule ID 24063 //
     /*  849099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  849113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849145 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849167 */     GIR_RootConstrainSelectedInstOperands,
     /*  849168 */     // GIR_Coverage, 24063,
     /*  849168 */     GIR_EraseRootFromParent_Done,
     /*  849169 */   // Label 13060: @849169
     /*  849169 */   GIM_Try, /*On fail goto*//*Label 13061*/ GIMT_Encode4(849244), // Rule ID 24066 //
     /*  849174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  849185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  849188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  849191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849220 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  849223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849242 */     GIR_RootConstrainSelectedInstOperands,
     /*  849243 */     // GIR_Coverage, 24066,
     /*  849243 */     GIR_EraseRootFromParent_Done,
     /*  849244 */   // Label 13061: @849244
     /*  849244 */   GIM_Try, /*On fail goto*//*Label 13062*/ GIMT_Encode4(849319), // Rule ID 24067 //
     /*  849249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  849260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  849263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  849266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849295 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  849298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849317 */     GIR_RootConstrainSelectedInstOperands,
     /*  849318 */     // GIR_Coverage, 24067,
     /*  849318 */     GIR_EraseRootFromParent_Done,
     /*  849319 */   // Label 13062: @849319
     /*  849319 */   GIM_Try, /*On fail goto*//*Label 13063*/ GIMT_Encode4(849394), // Rule ID 24070 //
     /*  849324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  849335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  849338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  849341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849370 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849392 */     GIR_RootConstrainSelectedInstOperands,
     /*  849393 */     // GIR_Coverage, 24070,
     /*  849393 */     GIR_EraseRootFromParent_Done,
     /*  849394 */   // Label 13063: @849394
     /*  849394 */   GIM_Try, /*On fail goto*//*Label 13064*/ GIMT_Encode4(849469), // Rule ID 24071 //
     /*  849399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  849410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  849413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  849416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849445 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849467 */     GIR_RootConstrainSelectedInstOperands,
     /*  849468 */     // GIR_Coverage, 24071,
     /*  849468 */     GIR_EraseRootFromParent_Done,
     /*  849469 */   // Label 13064: @849469
     /*  849469 */   GIM_Try, /*On fail goto*//*Label 13065*/ GIMT_Encode4(849544), // Rule ID 24074 //
     /*  849474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  849485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  849488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  849491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849520 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  849520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  849539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849542 */     GIR_RootConstrainSelectedInstOperands,
     /*  849543 */     // GIR_Coverage, 24074,
     /*  849543 */     GIR_EraseRootFromParent_Done,
     /*  849544 */   // Label 13065: @849544
     /*  849544 */   GIM_Try, /*On fail goto*//*Label 13066*/ GIMT_Encode4(849619), // Rule ID 24075 //
     /*  849549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  849560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  849563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  849566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849595 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  849595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  849614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849617 */     GIR_RootConstrainSelectedInstOperands,
     /*  849618 */     // GIR_Coverage, 24075,
     /*  849618 */     GIR_EraseRootFromParent_Done,
     /*  849619 */   // Label 13066: @849619
     /*  849619 */   GIM_Try, /*On fail goto*//*Label 13067*/ GIMT_Encode4(849694), // Rule ID 24078 //
     /*  849624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  849635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  849638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  849641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849670 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849692 */     GIR_RootConstrainSelectedInstOperands,
     /*  849693 */     // GIR_Coverage, 24078,
     /*  849693 */     GIR_EraseRootFromParent_Done,
     /*  849694 */   // Label 13067: @849694
     /*  849694 */   GIM_Try, /*On fail goto*//*Label 13068*/ GIMT_Encode4(849769), // Rule ID 24079 //
     /*  849699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  849710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  849713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  849716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849745 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849767 */     GIR_RootConstrainSelectedInstOperands,
     /*  849768 */     // GIR_Coverage, 24079,
     /*  849768 */     GIR_EraseRootFromParent_Done,
     /*  849769 */   // Label 13068: @849769
     /*  849769 */   GIM_Try, /*On fail goto*//*Label 13069*/ GIMT_Encode4(849844), // Rule ID 24082 //
     /*  849774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  849785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  849788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  849791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849820 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849842 */     GIR_RootConstrainSelectedInstOperands,
     /*  849843 */     // GIR_Coverage, 24082,
     /*  849843 */     GIR_EraseRootFromParent_Done,
     /*  849844 */   // Label 13069: @849844
     /*  849844 */   GIM_Try, /*On fail goto*//*Label 13070*/ GIMT_Encode4(849919), // Rule ID 24083 //
     /*  849849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  849860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  849863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  849866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849895 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849917 */     GIR_RootConstrainSelectedInstOperands,
     /*  849918 */     // GIR_Coverage, 24083,
     /*  849918 */     GIR_EraseRootFromParent_Done,
     /*  849919 */   // Label 13070: @849919
     /*  849919 */   GIM_Try, /*On fail goto*//*Label 13071*/ GIMT_Encode4(849994), // Rule ID 24086 //
     /*  849924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  849935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  849938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  849941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  849970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  849989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849992 */     GIR_RootConstrainSelectedInstOperands,
     /*  849993 */     // GIR_Coverage, 24086,
     /*  849993 */     GIR_EraseRootFromParent_Done,
     /*  849994 */   // Label 13071: @849994
     /*  849994 */   GIM_Try, /*On fail goto*//*Label 13072*/ GIMT_Encode4(850069), // Rule ID 24087 //
     /*  849999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  850010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  850013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  850016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850045 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  850045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850067 */     GIR_RootConstrainSelectedInstOperands,
     /*  850068 */     // GIR_Coverage, 24087,
     /*  850068 */     GIR_EraseRootFromParent_Done,
     /*  850069 */   // Label 13072: @850069
     /*  850069 */   GIM_Try, /*On fail goto*//*Label 13073*/ GIMT_Encode4(850144), // Rule ID 24090 //
     /*  850074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  850077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  850085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  850088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  850091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  850120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  850139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850142 */     GIR_RootConstrainSelectedInstOperands,
     /*  850143 */     // GIR_Coverage, 24090,
     /*  850143 */     GIR_EraseRootFromParent_Done,
     /*  850144 */   // Label 13073: @850144
     /*  850144 */   GIM_Try, /*On fail goto*//*Label 13074*/ GIMT_Encode4(850219), // Rule ID 24091 //
     /*  850149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  850152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  850160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  850163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  850166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850195 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  850195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  850214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850217 */     GIR_RootConstrainSelectedInstOperands,
     /*  850218 */     // GIR_Coverage, 24091,
     /*  850218 */     GIR_EraseRootFromParent_Done,
     /*  850219 */   // Label 13074: @850219
     /*  850219 */   GIM_Try, /*On fail goto*//*Label 13075*/ GIMT_Encode4(850294), // Rule ID 24094 //
     /*  850224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  850235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  850238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  850241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850270 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850292 */     GIR_RootConstrainSelectedInstOperands,
     /*  850293 */     // GIR_Coverage, 24094,
     /*  850293 */     GIR_EraseRootFromParent_Done,
     /*  850294 */   // Label 13075: @850294
     /*  850294 */   GIM_Try, /*On fail goto*//*Label 13076*/ GIMT_Encode4(850369), // Rule ID 24095 //
     /*  850299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  850310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  850313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  850316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850345 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850367 */     GIR_RootConstrainSelectedInstOperands,
     /*  850368 */     // GIR_Coverage, 24095,
     /*  850368 */     GIR_EraseRootFromParent_Done,
     /*  850369 */   // Label 13076: @850369
     /*  850369 */   GIM_Try, /*On fail goto*//*Label 13077*/ GIMT_Encode4(850444), // Rule ID 24098 //
     /*  850374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  850385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  850388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  850391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850420 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850442 */     GIR_RootConstrainSelectedInstOperands,
     /*  850443 */     // GIR_Coverage, 24098,
     /*  850443 */     GIR_EraseRootFromParent_Done,
     /*  850444 */   // Label 13077: @850444
     /*  850444 */   GIM_Try, /*On fail goto*//*Label 13078*/ GIMT_Encode4(850519), // Rule ID 24099 //
     /*  850449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  850460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  850463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  850466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850495 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850517 */     GIR_RootConstrainSelectedInstOperands,
     /*  850518 */     // GIR_Coverage, 24099,
     /*  850518 */     GIR_EraseRootFromParent_Done,
     /*  850519 */   // Label 13078: @850519
     /*  850519 */   GIM_Try, /*On fail goto*//*Label 13079*/ GIMT_Encode4(850594), // Rule ID 24102 //
     /*  850524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  850535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  850538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  850541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850570 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  850573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850592 */     GIR_RootConstrainSelectedInstOperands,
     /*  850593 */     // GIR_Coverage, 24102,
     /*  850593 */     GIR_EraseRootFromParent_Done,
     /*  850594 */   // Label 13079: @850594
     /*  850594 */   GIM_Try, /*On fail goto*//*Label 13080*/ GIMT_Encode4(850669), // Rule ID 24103 //
     /*  850599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  850610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  850613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  850616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850645 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  850648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850667 */     GIR_RootConstrainSelectedInstOperands,
     /*  850668 */     // GIR_Coverage, 24103,
     /*  850668 */     GIR_EraseRootFromParent_Done,
     /*  850669 */   // Label 13080: @850669
     /*  850669 */   GIM_Try, /*On fail goto*//*Label 13081*/ GIMT_Encode4(850744), // Rule ID 24106 //
     /*  850674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  850685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  850688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  850691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  850720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850742 */     GIR_RootConstrainSelectedInstOperands,
     /*  850743 */     // GIR_Coverage, 24106,
     /*  850743 */     GIR_EraseRootFromParent_Done,
     /*  850744 */   // Label 13081: @850744
     /*  850744 */   GIM_Try, /*On fail goto*//*Label 13082*/ GIMT_Encode4(850819), // Rule ID 24107 //
     /*  850749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  850760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  850763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  850766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850795 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  850795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850817 */     GIR_RootConstrainSelectedInstOperands,
     /*  850818 */     // GIR_Coverage, 24107,
     /*  850818 */     GIR_EraseRootFromParent_Done,
     /*  850819 */   // Label 13082: @850819
     /*  850819 */   GIM_Try, /*On fail goto*//*Label 13083*/ GIMT_Encode4(850894), // Rule ID 24110 //
     /*  850824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  850835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  850838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  850841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850870 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  850870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850892 */     GIR_RootConstrainSelectedInstOperands,
     /*  850893 */     // GIR_Coverage, 24110,
     /*  850893 */     GIR_EraseRootFromParent_Done,
     /*  850894 */   // Label 13083: @850894
     /*  850894 */   GIM_Try, /*On fail goto*//*Label 13084*/ GIMT_Encode4(850969), // Rule ID 24111 //
     /*  850899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  850910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  850913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  850916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850945 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  850945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850967 */     GIR_RootConstrainSelectedInstOperands,
     /*  850968 */     // GIR_Coverage, 24111,
     /*  850968 */     GIR_EraseRootFromParent_Done,
     /*  850969 */   // Label 13084: @850969
     /*  850969 */   GIM_Try, /*On fail goto*//*Label 13085*/ GIMT_Encode4(851044), // Rule ID 24114 //
     /*  850974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  850985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  850988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  850991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851020 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851042 */     GIR_RootConstrainSelectedInstOperands,
     /*  851043 */     // GIR_Coverage, 24114,
     /*  851043 */     GIR_EraseRootFromParent_Done,
     /*  851044 */   // Label 13085: @851044
     /*  851044 */   GIM_Try, /*On fail goto*//*Label 13086*/ GIMT_Encode4(851119), // Rule ID 24115 //
     /*  851049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  851060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  851063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  851066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851095 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851117 */     GIR_RootConstrainSelectedInstOperands,
     /*  851118 */     // GIR_Coverage, 24115,
     /*  851118 */     GIR_EraseRootFromParent_Done,
     /*  851119 */   // Label 13086: @851119
     /*  851119 */   GIM_Try, /*On fail goto*//*Label 13087*/ GIMT_Encode4(851194), // Rule ID 24118 //
     /*  851124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  851135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  851138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  851141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851170 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851192 */     GIR_RootConstrainSelectedInstOperands,
     /*  851193 */     // GIR_Coverage, 24118,
     /*  851193 */     GIR_EraseRootFromParent_Done,
     /*  851194 */   // Label 13087: @851194
     /*  851194 */   GIM_Try, /*On fail goto*//*Label 13088*/ GIMT_Encode4(851269), // Rule ID 24119 //
     /*  851199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  851210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  851213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  851216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851245 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851267 */     GIR_RootConstrainSelectedInstOperands,
     /*  851268 */     // GIR_Coverage, 24119,
     /*  851268 */     GIR_EraseRootFromParent_Done,
     /*  851269 */   // Label 13088: @851269
     /*  851269 */   GIM_Try, /*On fail goto*//*Label 13089*/ GIMT_Encode4(851344), // Rule ID 24122 //
     /*  851274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  851285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  851288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  851291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851320 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851342 */     GIR_RootConstrainSelectedInstOperands,
     /*  851343 */     // GIR_Coverage, 24122,
     /*  851343 */     GIR_EraseRootFromParent_Done,
     /*  851344 */   // Label 13089: @851344
     /*  851344 */   GIM_Try, /*On fail goto*//*Label 13090*/ GIMT_Encode4(851419), // Rule ID 24123 //
     /*  851349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  851360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  851363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  851366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851395 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851417 */     GIR_RootConstrainSelectedInstOperands,
     /*  851418 */     // GIR_Coverage, 24123,
     /*  851418 */     GIR_EraseRootFromParent_Done,
     /*  851419 */   // Label 13090: @851419
     /*  851419 */   GIM_Try, /*On fail goto*//*Label 13091*/ GIMT_Encode4(851494), // Rule ID 24126 //
     /*  851424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  851435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  851438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  851441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851470 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851492 */     GIR_RootConstrainSelectedInstOperands,
     /*  851493 */     // GIR_Coverage, 24126,
     /*  851493 */     GIR_EraseRootFromParent_Done,
     /*  851494 */   // Label 13091: @851494
     /*  851494 */   GIM_Try, /*On fail goto*//*Label 13092*/ GIMT_Encode4(851569), // Rule ID 24127 //
     /*  851499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  851510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  851513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  851516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851545 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851567 */     GIR_RootConstrainSelectedInstOperands,
     /*  851568 */     // GIR_Coverage, 24127,
     /*  851568 */     GIR_EraseRootFromParent_Done,
     /*  851569 */   // Label 13092: @851569
     /*  851569 */   GIM_Try, /*On fail goto*//*Label 13093*/ GIMT_Encode4(851644), // Rule ID 24130 //
     /*  851574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  851577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  851585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  851588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  851591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851620 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  851620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851642 */     GIR_RootConstrainSelectedInstOperands,
     /*  851643 */     // GIR_Coverage, 24130,
     /*  851643 */     GIR_EraseRootFromParent_Done,
     /*  851644 */   // Label 13093: @851644
     /*  851644 */   GIM_Try, /*On fail goto*//*Label 13094*/ GIMT_Encode4(851719), // Rule ID 24131 //
     /*  851649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  851652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  851660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  851663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  851666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851695 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  851695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851717 */     GIR_RootConstrainSelectedInstOperands,
     /*  851718 */     // GIR_Coverage, 24131,
     /*  851718 */     GIR_EraseRootFromParent_Done,
     /*  851719 */   // Label 13094: @851719
     /*  851719 */   GIM_Try, /*On fail goto*//*Label 13095*/ GIMT_Encode4(851794), // Rule ID 24134 //
     /*  851724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  851727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  851735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  851738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  851741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851770 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  851770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851792 */     GIR_RootConstrainSelectedInstOperands,
     /*  851793 */     // GIR_Coverage, 24134,
     /*  851793 */     GIR_EraseRootFromParent_Done,
     /*  851794 */   // Label 13095: @851794
     /*  851794 */   GIM_Try, /*On fail goto*//*Label 13096*/ GIMT_Encode4(851869), // Rule ID 24135 //
     /*  851799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  851802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  851810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  851813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  851816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851845 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  851845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851867 */     GIR_RootConstrainSelectedInstOperands,
     /*  851868 */     // GIR_Coverage, 24135,
     /*  851868 */     GIR_EraseRootFromParent_Done,
     /*  851869 */   // Label 13096: @851869
     /*  851869 */   GIM_Try, /*On fail goto*//*Label 13097*/ GIMT_Encode4(851944), // Rule ID 24138 //
     /*  851874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  851877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  851885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  851888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  851891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851920 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  851920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851942 */     GIR_RootConstrainSelectedInstOperands,
     /*  851943 */     // GIR_Coverage, 24138,
     /*  851943 */     GIR_EraseRootFromParent_Done,
     /*  851944 */   // Label 13097: @851944
     /*  851944 */   GIM_Try, /*On fail goto*//*Label 13098*/ GIMT_Encode4(852019), // Rule ID 24139 //
     /*  851949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  851952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  851960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  851963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  851966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851995 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  851995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852017 */     GIR_RootConstrainSelectedInstOperands,
     /*  852018 */     // GIR_Coverage, 24139,
     /*  852018 */     GIR_EraseRootFromParent_Done,
     /*  852019 */   // Label 13098: @852019
     /*  852019 */   GIM_Try, /*On fail goto*//*Label 13099*/ GIMT_Encode4(852094), // Rule ID 24382 //
     /*  852024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  852035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  852038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  852041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852070 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  852073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852092 */     GIR_RootConstrainSelectedInstOperands,
     /*  852093 */     // GIR_Coverage, 24382,
     /*  852093 */     GIR_EraseRootFromParent_Done,
     /*  852094 */   // Label 13099: @852094
     /*  852094 */   GIM_Try, /*On fail goto*//*Label 13100*/ GIMT_Encode4(852169), // Rule ID 24383 //
     /*  852099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  852110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  852113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  852116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852145 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  852148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852167 */     GIR_RootConstrainSelectedInstOperands,
     /*  852168 */     // GIR_Coverage, 24383,
     /*  852168 */     GIR_EraseRootFromParent_Done,
     /*  852169 */   // Label 13100: @852169
     /*  852169 */   GIM_Try, /*On fail goto*//*Label 13101*/ GIMT_Encode4(852244), // Rule ID 24386 //
     /*  852174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  852185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  852188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  852191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852220 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  852223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852242 */     GIR_RootConstrainSelectedInstOperands,
     /*  852243 */     // GIR_Coverage, 24386,
     /*  852243 */     GIR_EraseRootFromParent_Done,
     /*  852244 */   // Label 13101: @852244
     /*  852244 */   GIM_Try, /*On fail goto*//*Label 13102*/ GIMT_Encode4(852319), // Rule ID 24387 //
     /*  852249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  852260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  852263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  852266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852295 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  852298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852317 */     GIR_RootConstrainSelectedInstOperands,
     /*  852318 */     // GIR_Coverage, 24387,
     /*  852318 */     GIR_EraseRootFromParent_Done,
     /*  852319 */   // Label 13102: @852319
     /*  852319 */   GIM_Try, /*On fail goto*//*Label 13103*/ GIMT_Encode4(852394), // Rule ID 24390 //
     /*  852324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  852327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  852335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  852338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  852341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852370 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  852370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  852373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852392 */     GIR_RootConstrainSelectedInstOperands,
     /*  852393 */     // GIR_Coverage, 24390,
     /*  852393 */     GIR_EraseRootFromParent_Done,
     /*  852394 */   // Label 13103: @852394
     /*  852394 */   GIM_Try, /*On fail goto*//*Label 13104*/ GIMT_Encode4(852469), // Rule ID 24391 //
     /*  852399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  852402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  852410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  852413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  852416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852445 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  852445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  852448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852467 */     GIR_RootConstrainSelectedInstOperands,
     /*  852468 */     // GIR_Coverage, 24391,
     /*  852468 */     GIR_EraseRootFromParent_Done,
     /*  852469 */   // Label 13104: @852469
     /*  852469 */   GIM_Try, /*On fail goto*//*Label 13105*/ GIMT_Encode4(852544), // Rule ID 24394 //
     /*  852474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  852485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  852488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  852491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852520 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  852523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852542 */     GIR_RootConstrainSelectedInstOperands,
     /*  852543 */     // GIR_Coverage, 24394,
     /*  852543 */     GIR_EraseRootFromParent_Done,
     /*  852544 */   // Label 13105: @852544
     /*  852544 */   GIM_Try, /*On fail goto*//*Label 13106*/ GIMT_Encode4(852619), // Rule ID 24395 //
     /*  852549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  852560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  852563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  852566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852595 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  852598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852617 */     GIR_RootConstrainSelectedInstOperands,
     /*  852618 */     // GIR_Coverage, 24395,
     /*  852618 */     GIR_EraseRootFromParent_Done,
     /*  852619 */   // Label 13106: @852619
     /*  852619 */   GIM_Try, /*On fail goto*//*Label 13107*/ GIMT_Encode4(852694), // Rule ID 24398 //
     /*  852624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  852627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  852635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  852638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  852641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852670 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  852670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  852673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852692 */     GIR_RootConstrainSelectedInstOperands,
     /*  852693 */     // GIR_Coverage, 24398,
     /*  852693 */     GIR_EraseRootFromParent_Done,
     /*  852694 */   // Label 13107: @852694
     /*  852694 */   GIM_Try, /*On fail goto*//*Label 13108*/ GIMT_Encode4(852769), // Rule ID 24399 //
     /*  852699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  852702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  852710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  852713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  852716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852745 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  852745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  852748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852767 */     GIR_RootConstrainSelectedInstOperands,
     /*  852768 */     // GIR_Coverage, 24399,
     /*  852768 */     GIR_EraseRootFromParent_Done,
     /*  852769 */   // Label 13108: @852769
     /*  852769 */   GIM_Try, /*On fail goto*//*Label 13109*/ GIMT_Encode4(852844), // Rule ID 24402 //
     /*  852774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  852777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  852785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  852788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  852791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  852813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852820 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  852823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852842 */     GIR_RootConstrainSelectedInstOperands,
     /*  852843 */     // GIR_Coverage, 24402,
     /*  852843 */     GIR_EraseRootFromParent_Done,
     /*  852844 */   // Label 13109: @852844
     /*  852844 */   GIM_Try, /*On fail goto*//*Label 13110*/ GIMT_Encode4(852919), // Rule ID 24403 //
     /*  852849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  852852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  852860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  852863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  852866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  852888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852895 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  852898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852917 */     GIR_RootConstrainSelectedInstOperands,
     /*  852918 */     // GIR_Coverage, 24403,
     /*  852918 */     GIR_EraseRootFromParent_Done,
     /*  852919 */   // Label 13110: @852919
     /*  852919 */   GIM_Try, /*On fail goto*//*Label 13111*/ GIMT_Encode4(852994), // Rule ID 24406 //
     /*  852924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  852935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  852938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  852941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852970 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  852973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852992 */     GIR_RootConstrainSelectedInstOperands,
     /*  852993 */     // GIR_Coverage, 24406,
     /*  852993 */     GIR_EraseRootFromParent_Done,
     /*  852994 */   // Label 13111: @852994
     /*  852994 */   GIM_Try, /*On fail goto*//*Label 13112*/ GIMT_Encode4(853069), // Rule ID 24407 //
     /*  852999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  853010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  853013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  853016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853045 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  853048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853067 */     GIR_RootConstrainSelectedInstOperands,
     /*  853068 */     // GIR_Coverage, 24407,
     /*  853068 */     GIR_EraseRootFromParent_Done,
     /*  853069 */   // Label 13112: @853069
     /*  853069 */   GIM_Try, /*On fail goto*//*Label 13113*/ GIMT_Encode4(853144), // Rule ID 24410 //
     /*  853074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  853077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  853085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  853088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  853091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853120 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  853123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853142 */     GIR_RootConstrainSelectedInstOperands,
     /*  853143 */     // GIR_Coverage, 24410,
     /*  853143 */     GIR_EraseRootFromParent_Done,
     /*  853144 */   // Label 13113: @853144
     /*  853144 */   GIM_Try, /*On fail goto*//*Label 13114*/ GIMT_Encode4(853219), // Rule ID 24411 //
     /*  853149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  853160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  853163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  853166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853195 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  853198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853217 */     GIR_RootConstrainSelectedInstOperands,
     /*  853218 */     // GIR_Coverage, 24411,
     /*  853218 */     GIR_EraseRootFromParent_Done,
     /*  853219 */   // Label 13114: @853219
     /*  853219 */   GIM_Try, /*On fail goto*//*Label 13115*/ GIMT_Encode4(853294), // Rule ID 24414 //
     /*  853224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  853227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  853235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  853238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  853241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853270 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  853273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853292 */     GIR_RootConstrainSelectedInstOperands,
     /*  853293 */     // GIR_Coverage, 24414,
     /*  853293 */     GIR_EraseRootFromParent_Done,
     /*  853294 */   // Label 13115: @853294
     /*  853294 */   GIM_Try, /*On fail goto*//*Label 13116*/ GIMT_Encode4(853369), // Rule ID 24415 //
     /*  853299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  853310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  853313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  853316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853345 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  853348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853367 */     GIR_RootConstrainSelectedInstOperands,
     /*  853368 */     // GIR_Coverage, 24415,
     /*  853368 */     GIR_EraseRootFromParent_Done,
     /*  853369 */   // Label 13116: @853369
     /*  853369 */   GIM_Try, /*On fail goto*//*Label 13117*/ GIMT_Encode4(853444), // Rule ID 24418 //
     /*  853374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  853385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  853388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  853391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853420 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  853423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853442 */     GIR_RootConstrainSelectedInstOperands,
     /*  853443 */     // GIR_Coverage, 24418,
     /*  853443 */     GIR_EraseRootFromParent_Done,
     /*  853444 */   // Label 13117: @853444
     /*  853444 */   GIM_Try, /*On fail goto*//*Label 13118*/ GIMT_Encode4(853519), // Rule ID 24419 //
     /*  853449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  853452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  853460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  853463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  853466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853495 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  853498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853517 */     GIR_RootConstrainSelectedInstOperands,
     /*  853518 */     // GIR_Coverage, 24419,
     /*  853518 */     GIR_EraseRootFromParent_Done,
     /*  853519 */   // Label 13118: @853519
     /*  853519 */   GIM_Try, /*On fail goto*//*Label 13119*/ GIMT_Encode4(853594), // Rule ID 24422 //
     /*  853524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  853535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  853538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  853541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853570 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  853573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853592 */     GIR_RootConstrainSelectedInstOperands,
     /*  853593 */     // GIR_Coverage, 24422,
     /*  853593 */     GIR_EraseRootFromParent_Done,
     /*  853594 */   // Label 13119: @853594
     /*  853594 */   GIM_Try, /*On fail goto*//*Label 13120*/ GIMT_Encode4(853669), // Rule ID 24423 //
     /*  853599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  853602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  853610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  853613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  853616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853645 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  853648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853667 */     GIR_RootConstrainSelectedInstOperands,
     /*  853668 */     // GIR_Coverage, 24423,
     /*  853668 */     GIR_EraseRootFromParent_Done,
     /*  853669 */   // Label 13120: @853669
     /*  853669 */   GIM_Try, /*On fail goto*//*Label 13121*/ GIMT_Encode4(853744), // Rule ID 24426 //
     /*  853674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  853685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  853688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  853691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853720 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  853723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853742 */     GIR_RootConstrainSelectedInstOperands,
     /*  853743 */     // GIR_Coverage, 24426,
     /*  853743 */     GIR_EraseRootFromParent_Done,
     /*  853744 */   // Label 13121: @853744
     /*  853744 */   GIM_Try, /*On fail goto*//*Label 13122*/ GIMT_Encode4(853819), // Rule ID 24427 //
     /*  853749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  853752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  853760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  853763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  853766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853795 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  853798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853817 */     GIR_RootConstrainSelectedInstOperands,
     /*  853818 */     // GIR_Coverage, 24427,
     /*  853818 */     GIR_EraseRootFromParent_Done,
     /*  853819 */   // Label 13122: @853819
     /*  853819 */   GIM_Try, /*On fail goto*//*Label 13123*/ GIMT_Encode4(853894), // Rule ID 24430 //
     /*  853824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  853827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  853835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  853838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  853841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853870 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  853870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  853873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853892 */     GIR_RootConstrainSelectedInstOperands,
     /*  853893 */     // GIR_Coverage, 24430,
     /*  853893 */     GIR_EraseRootFromParent_Done,
     /*  853894 */   // Label 13123: @853894
     /*  853894 */   GIM_Try, /*On fail goto*//*Label 13124*/ GIMT_Encode4(853969), // Rule ID 24431 //
     /*  853899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  853902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  853910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  853913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  853916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853945 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  853945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  853948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853967 */     GIR_RootConstrainSelectedInstOperands,
     /*  853968 */     // GIR_Coverage, 24431,
     /*  853968 */     GIR_EraseRootFromParent_Done,
     /*  853969 */   // Label 13124: @853969
     /*  853969 */   GIM_Try, /*On fail goto*//*Label 13125*/ GIMT_Encode4(854044), // Rule ID 24434 //
     /*  853974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  853977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  853985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  853988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  853991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854020 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  854020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  854023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854042 */     GIR_RootConstrainSelectedInstOperands,
     /*  854043 */     // GIR_Coverage, 24434,
     /*  854043 */     GIR_EraseRootFromParent_Done,
     /*  854044 */   // Label 13125: @854044
     /*  854044 */   GIM_Try, /*On fail goto*//*Label 13126*/ GIMT_Encode4(854119), // Rule ID 24435 //
     /*  854049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  854052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  854060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  854063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  854066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854095 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  854095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  854098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854117 */     GIR_RootConstrainSelectedInstOperands,
     /*  854118 */     // GIR_Coverage, 24435,
     /*  854118 */     GIR_EraseRootFromParent_Done,
     /*  854119 */   // Label 13126: @854119
     /*  854119 */   GIM_Try, /*On fail goto*//*Label 13127*/ GIMT_Encode4(854194), // Rule ID 24438 //
     /*  854124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  854127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  854135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  854138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  854141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854170 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  854170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  854173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854192 */     GIR_RootConstrainSelectedInstOperands,
     /*  854193 */     // GIR_Coverage, 24438,
     /*  854193 */     GIR_EraseRootFromParent_Done,
     /*  854194 */   // Label 13127: @854194
     /*  854194 */   GIM_Try, /*On fail goto*//*Label 13128*/ GIMT_Encode4(854269), // Rule ID 24439 //
     /*  854199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  854202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  854210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  854213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  854216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854245 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  854245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  854248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854267 */     GIR_RootConstrainSelectedInstOperands,
     /*  854268 */     // GIR_Coverage, 24439,
     /*  854268 */     GIR_EraseRootFromParent_Done,
     /*  854269 */   // Label 13128: @854269
     /*  854269 */   GIM_Try, /*On fail goto*//*Label 13129*/ GIMT_Encode4(854344), // Rule ID 24442 //
     /*  854274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  854285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  854288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  854291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854320 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  854323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854342 */     GIR_RootConstrainSelectedInstOperands,
     /*  854343 */     // GIR_Coverage, 24442,
     /*  854343 */     GIR_EraseRootFromParent_Done,
     /*  854344 */   // Label 13129: @854344
     /*  854344 */   GIM_Try, /*On fail goto*//*Label 13130*/ GIMT_Encode4(854419), // Rule ID 24443 //
     /*  854349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  854352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  854360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  854363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  854366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854395 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  854398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854417 */     GIR_RootConstrainSelectedInstOperands,
     /*  854418 */     // GIR_Coverage, 24443,
     /*  854418 */     GIR_EraseRootFromParent_Done,
     /*  854419 */   // Label 13130: @854419
     /*  854419 */   GIM_Try, /*On fail goto*//*Label 13131*/ GIMT_Encode4(854494), // Rule ID 24446 //
     /*  854424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  854435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  854438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  854441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854470 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  854473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854492 */     GIR_RootConstrainSelectedInstOperands,
     /*  854493 */     // GIR_Coverage, 24446,
     /*  854493 */     GIR_EraseRootFromParent_Done,
     /*  854494 */   // Label 13131: @854494
     /*  854494 */   GIM_Try, /*On fail goto*//*Label 13132*/ GIMT_Encode4(854569), // Rule ID 24447 //
     /*  854499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  854502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  854510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  854513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  854516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854545 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  854548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854567 */     GIR_RootConstrainSelectedInstOperands,
     /*  854568 */     // GIR_Coverage, 24447,
     /*  854568 */     GIR_EraseRootFromParent_Done,
     /*  854569 */   // Label 13132: @854569
     /*  854569 */   GIM_Try, /*On fail goto*//*Label 13133*/ GIMT_Encode4(854644), // Rule ID 24450 //
     /*  854574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  854577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  854585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  854588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  854591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854620 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  854620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  854623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854642 */     GIR_RootConstrainSelectedInstOperands,
     /*  854643 */     // GIR_Coverage, 24450,
     /*  854643 */     GIR_EraseRootFromParent_Done,
     /*  854644 */   // Label 13133: @854644
     /*  854644 */   GIM_Try, /*On fail goto*//*Label 13134*/ GIMT_Encode4(854719), // Rule ID 24451 //
     /*  854649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  854652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  854660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  854663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  854666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854695 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  854695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  854698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854717 */     GIR_RootConstrainSelectedInstOperands,
     /*  854718 */     // GIR_Coverage, 24451,
     /*  854718 */     GIR_EraseRootFromParent_Done,
     /*  854719 */   // Label 13134: @854719
     /*  854719 */   GIM_Try, /*On fail goto*//*Label 13135*/ GIMT_Encode4(854794), // Rule ID 24454 //
     /*  854724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  854735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  854738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  854741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854770 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  854773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854792 */     GIR_RootConstrainSelectedInstOperands,
     /*  854793 */     // GIR_Coverage, 24454,
     /*  854793 */     GIR_EraseRootFromParent_Done,
     /*  854794 */   // Label 13135: @854794
     /*  854794 */   GIM_Try, /*On fail goto*//*Label 13136*/ GIMT_Encode4(854869), // Rule ID 24455 //
     /*  854799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  854802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  854810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  854813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  854816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854845 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  854848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854867 */     GIR_RootConstrainSelectedInstOperands,
     /*  854868 */     // GIR_Coverage, 24455,
     /*  854868 */     GIR_EraseRootFromParent_Done,
     /*  854869 */   // Label 13136: @854869
     /*  854869 */   GIM_Try, /*On fail goto*//*Label 13137*/ GIMT_Encode4(854944), // Rule ID 24458 //
     /*  854874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  854877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  854885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  854888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  854891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854920 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  854920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  854923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854942 */     GIR_RootConstrainSelectedInstOperands,
     /*  854943 */     // GIR_Coverage, 24458,
     /*  854943 */     GIR_EraseRootFromParent_Done,
     /*  854944 */   // Label 13137: @854944
     /*  854944 */   GIM_Try, /*On fail goto*//*Label 13138*/ GIMT_Encode4(855019), // Rule ID 24459 //
     /*  854949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  854952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  854960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  854963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  854966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854995 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  854995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  854998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855017 */     GIR_RootConstrainSelectedInstOperands,
     /*  855018 */     // GIR_Coverage, 24459,
     /*  855018 */     GIR_EraseRootFromParent_Done,
     /*  855019 */   // Label 13138: @855019
     /*  855019 */   GIM_Try, /*On fail goto*//*Label 13139*/ GIMT_Encode4(855094), // Rule ID 24462 //
     /*  855024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  855027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  855035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  855038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  855041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855070 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  855070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  855073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855092 */     GIR_RootConstrainSelectedInstOperands,
     /*  855093 */     // GIR_Coverage, 24462,
     /*  855093 */     GIR_EraseRootFromParent_Done,
     /*  855094 */   // Label 13139: @855094
     /*  855094 */   GIM_Try, /*On fail goto*//*Label 13140*/ GIMT_Encode4(855169), // Rule ID 24463 //
     /*  855099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  855102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  855110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  855113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  855116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855145 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  855145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  855148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855167 */     GIR_RootConstrainSelectedInstOperands,
     /*  855168 */     // GIR_Coverage, 24463,
     /*  855168 */     GIR_EraseRootFromParent_Done,
     /*  855169 */   // Label 13140: @855169
     /*  855169 */   GIM_Try, /*On fail goto*//*Label 13141*/ GIMT_Encode4(855244), // Rule ID 24466 //
     /*  855174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  855185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  855188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  855191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855220 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  855223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855242 */     GIR_RootConstrainSelectedInstOperands,
     /*  855243 */     // GIR_Coverage, 24466,
     /*  855243 */     GIR_EraseRootFromParent_Done,
     /*  855244 */   // Label 13141: @855244
     /*  855244 */   GIM_Try, /*On fail goto*//*Label 13142*/ GIMT_Encode4(855319), // Rule ID 24467 //
     /*  855249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  855260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  855263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  855266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855295 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  855298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855317 */     GIR_RootConstrainSelectedInstOperands,
     /*  855318 */     // GIR_Coverage, 24467,
     /*  855318 */     GIR_EraseRootFromParent_Done,
     /*  855319 */   // Label 13142: @855319
     /*  855319 */   GIM_Try, /*On fail goto*//*Label 13143*/ GIMT_Encode4(855394), // Rule ID 24470 //
     /*  855324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  855335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  855338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  855341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855370 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  855373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855392 */     GIR_RootConstrainSelectedInstOperands,
     /*  855393 */     // GIR_Coverage, 24470,
     /*  855393 */     GIR_EraseRootFromParent_Done,
     /*  855394 */   // Label 13143: @855394
     /*  855394 */   GIM_Try, /*On fail goto*//*Label 13144*/ GIMT_Encode4(855469), // Rule ID 24471 //
     /*  855399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  855410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  855413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  855416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855445 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  855448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855467 */     GIR_RootConstrainSelectedInstOperands,
     /*  855468 */     // GIR_Coverage, 24471,
     /*  855468 */     GIR_EraseRootFromParent_Done,
     /*  855469 */   // Label 13144: @855469
     /*  855469 */   GIM_Try, /*On fail goto*//*Label 13145*/ GIMT_Encode4(855544), // Rule ID 24474 //
     /*  855474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  855485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  855488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  855491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855520 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  855523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855542 */     GIR_RootConstrainSelectedInstOperands,
     /*  855543 */     // GIR_Coverage, 24474,
     /*  855543 */     GIR_EraseRootFromParent_Done,
     /*  855544 */   // Label 13145: @855544
     /*  855544 */   GIM_Try, /*On fail goto*//*Label 13146*/ GIMT_Encode4(855619), // Rule ID 24475 //
     /*  855549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  855560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  855563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  855566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855595 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  855598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855617 */     GIR_RootConstrainSelectedInstOperands,
     /*  855618 */     // GIR_Coverage, 24475,
     /*  855618 */     GIR_EraseRootFromParent_Done,
     /*  855619 */   // Label 13146: @855619
     /*  855619 */   GIM_Try, /*On fail goto*//*Label 13147*/ GIMT_Encode4(855694), // Rule ID 24478 //
     /*  855624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  855627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  855635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  855638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  855641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855670 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  855673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855692 */     GIR_RootConstrainSelectedInstOperands,
     /*  855693 */     // GIR_Coverage, 24478,
     /*  855693 */     GIR_EraseRootFromParent_Done,
     /*  855694 */   // Label 13147: @855694
     /*  855694 */   GIM_Try, /*On fail goto*//*Label 13148*/ GIMT_Encode4(855769), // Rule ID 24479 //
     /*  855699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  855702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  855710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  855713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  855716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855745 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  855748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855767 */     GIR_RootConstrainSelectedInstOperands,
     /*  855768 */     // GIR_Coverage, 24479,
     /*  855768 */     GIR_EraseRootFromParent_Done,
     /*  855769 */   // Label 13148: @855769
     /*  855769 */   GIM_Try, /*On fail goto*//*Label 13149*/ GIMT_Encode4(855844), // Rule ID 24482 //
     /*  855774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  855777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  855785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  855788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  855791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855820 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  855823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855842 */     GIR_RootConstrainSelectedInstOperands,
     /*  855843 */     // GIR_Coverage, 24482,
     /*  855843 */     GIR_EraseRootFromParent_Done,
     /*  855844 */   // Label 13149: @855844
     /*  855844 */   GIM_Try, /*On fail goto*//*Label 13150*/ GIMT_Encode4(855919), // Rule ID 24483 //
     /*  855849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  855852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  855860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  855863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  855866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855895 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  855898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855917 */     GIR_RootConstrainSelectedInstOperands,
     /*  855918 */     // GIR_Coverage, 24483,
     /*  855918 */     GIR_EraseRootFromParent_Done,
     /*  855919 */   // Label 13150: @855919
     /*  855919 */   GIM_Try, /*On fail goto*//*Label 13151*/ GIMT_Encode4(855994), // Rule ID 24486 //
     /*  855924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  855927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  855935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  855938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  855941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855970 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  855973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855992 */     GIR_RootConstrainSelectedInstOperands,
     /*  855993 */     // GIR_Coverage, 24486,
     /*  855993 */     GIR_EraseRootFromParent_Done,
     /*  855994 */   // Label 13151: @855994
     /*  855994 */   GIM_Try, /*On fail goto*//*Label 13152*/ GIMT_Encode4(856069), // Rule ID 24487 //
     /*  855999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  856002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  856010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  856013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  856016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856045 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  856045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  856048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856067 */     GIR_RootConstrainSelectedInstOperands,
     /*  856068 */     // GIR_Coverage, 24487,
     /*  856068 */     GIR_EraseRootFromParent_Done,
     /*  856069 */   // Label 13152: @856069
     /*  856069 */   GIM_Try, /*On fail goto*//*Label 13153*/ GIMT_Encode4(856144), // Rule ID 24490 //
     /*  856074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  856085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  856088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  856091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856120 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  856123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856142 */     GIR_RootConstrainSelectedInstOperands,
     /*  856143 */     // GIR_Coverage, 24490,
     /*  856143 */     GIR_EraseRootFromParent_Done,
     /*  856144 */   // Label 13153: @856144
     /*  856144 */   GIM_Try, /*On fail goto*//*Label 13154*/ GIMT_Encode4(856219), // Rule ID 24491 //
     /*  856149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  856160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  856163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  856166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856195 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  856198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856217 */     GIR_RootConstrainSelectedInstOperands,
     /*  856218 */     // GIR_Coverage, 24491,
     /*  856218 */     GIR_EraseRootFromParent_Done,
     /*  856219 */   // Label 13154: @856219
     /*  856219 */   GIM_Try, /*On fail goto*//*Label 13155*/ GIMT_Encode4(856294), // Rule ID 24494 //
     /*  856224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  856235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  856238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  856241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856270 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  856273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856292 */     GIR_RootConstrainSelectedInstOperands,
     /*  856293 */     // GIR_Coverage, 24494,
     /*  856293 */     GIR_EraseRootFromParent_Done,
     /*  856294 */   // Label 13155: @856294
     /*  856294 */   GIM_Try, /*On fail goto*//*Label 13156*/ GIMT_Encode4(856369), // Rule ID 24495 //
     /*  856299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  856310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  856313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  856316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856345 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  856348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856367 */     GIR_RootConstrainSelectedInstOperands,
     /*  856368 */     // GIR_Coverage, 24495,
     /*  856368 */     GIR_EraseRootFromParent_Done,
     /*  856369 */   // Label 13156: @856369
     /*  856369 */   GIM_Try, /*On fail goto*//*Label 13157*/ GIMT_Encode4(856444), // Rule ID 24498 //
     /*  856374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  856385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  856388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  856391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856420 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  856423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856442 */     GIR_RootConstrainSelectedInstOperands,
     /*  856443 */     // GIR_Coverage, 24498,
     /*  856443 */     GIR_EraseRootFromParent_Done,
     /*  856444 */   // Label 13157: @856444
     /*  856444 */   GIM_Try, /*On fail goto*//*Label 13158*/ GIMT_Encode4(856519), // Rule ID 24499 //
     /*  856449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  856460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  856463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  856466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856495 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  856498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856517 */     GIR_RootConstrainSelectedInstOperands,
     /*  856518 */     // GIR_Coverage, 24499,
     /*  856518 */     GIR_EraseRootFromParent_Done,
     /*  856519 */   // Label 13158: @856519
     /*  856519 */   GIM_Try, /*On fail goto*//*Label 13159*/ GIMT_Encode4(856594), // Rule ID 24502 //
     /*  856524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  856535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  856538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  856541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  856544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856570 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  856570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  856573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856592 */     GIR_RootConstrainSelectedInstOperands,
     /*  856593 */     // GIR_Coverage, 24502,
     /*  856593 */     GIR_EraseRootFromParent_Done,
     /*  856594 */   // Label 13159: @856594
     /*  856594 */   GIM_Try, /*On fail goto*//*Label 13160*/ GIMT_Encode4(856669), // Rule ID 24503 //
     /*  856599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  856602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  856610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  856613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  856616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  856619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856645 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  856645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  856648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856667 */     GIR_RootConstrainSelectedInstOperands,
     /*  856668 */     // GIR_Coverage, 24503,
     /*  856668 */     GIR_EraseRootFromParent_Done,
     /*  856669 */   // Label 13160: @856669
     /*  856669 */   GIM_Try, /*On fail goto*//*Label 13161*/ GIMT_Encode4(856744), // Rule ID 24506 //
     /*  856674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  856685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  856688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  856691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  856694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856720 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  856720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  856723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856742 */     GIR_RootConstrainSelectedInstOperands,
     /*  856743 */     // GIR_Coverage, 24506,
     /*  856743 */     GIR_EraseRootFromParent_Done,
     /*  856744 */   // Label 13161: @856744
     /*  856744 */   GIM_Try, /*On fail goto*//*Label 13162*/ GIMT_Encode4(856819), // Rule ID 24507 //
     /*  856749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  856752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  856760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  856763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  856766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  856769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856795 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  856795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  856798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856817 */     GIR_RootConstrainSelectedInstOperands,
     /*  856818 */     // GIR_Coverage, 24507,
     /*  856818 */     GIR_EraseRootFromParent_Done,
     /*  856819 */   // Label 13162: @856819
     /*  856819 */   GIM_Try, /*On fail goto*//*Label 13163*/ GIMT_Encode4(856894), // Rule ID 24510 //
     /*  856824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  856835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  856838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  856841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  856844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856870 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  856870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  856873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856892 */     GIR_RootConstrainSelectedInstOperands,
     /*  856893 */     // GIR_Coverage, 24510,
     /*  856893 */     GIR_EraseRootFromParent_Done,
     /*  856894 */   // Label 13163: @856894
     /*  856894 */   GIM_Try, /*On fail goto*//*Label 13164*/ GIMT_Encode4(856969), // Rule ID 24511 //
     /*  856899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  856902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  856910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  856913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  856916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  856919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856945 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  856945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  856948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856967 */     GIR_RootConstrainSelectedInstOperands,
     /*  856968 */     // GIR_Coverage, 24511,
     /*  856968 */     GIR_EraseRootFromParent_Done,
     /*  856969 */   // Label 13164: @856969
     /*  856969 */   GIM_Try, /*On fail goto*//*Label 13165*/ GIMT_Encode4(857044), // Rule ID 24514 //
     /*  856974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  856985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  856988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  856991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  856994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857020 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  857020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  857023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857042 */     GIR_RootConstrainSelectedInstOperands,
     /*  857043 */     // GIR_Coverage, 24514,
     /*  857043 */     GIR_EraseRootFromParent_Done,
     /*  857044 */   // Label 13165: @857044
     /*  857044 */   GIM_Try, /*On fail goto*//*Label 13166*/ GIMT_Encode4(857119), // Rule ID 24515 //
     /*  857049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  857060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  857063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  857066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  857069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857095 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  857098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857117 */     GIR_RootConstrainSelectedInstOperands,
     /*  857118 */     // GIR_Coverage, 24515,
     /*  857118 */     GIR_EraseRootFromParent_Done,
     /*  857119 */   // Label 13166: @857119
     /*  857119 */   GIM_Try, /*On fail goto*//*Label 13167*/ GIMT_Encode4(857194), // Rule ID 24518 //
     /*  857124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  857135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  857138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  857141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  857144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857170 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  857170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  857173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857192 */     GIR_RootConstrainSelectedInstOperands,
     /*  857193 */     // GIR_Coverage, 24518,
     /*  857193 */     GIR_EraseRootFromParent_Done,
     /*  857194 */   // Label 13167: @857194
     /*  857194 */   GIM_Try, /*On fail goto*//*Label 13168*/ GIMT_Encode4(857269), // Rule ID 24519 //
     /*  857199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  857210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  857213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  857216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  857219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857245 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  857248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857267 */     GIR_RootConstrainSelectedInstOperands,
     /*  857268 */     // GIR_Coverage, 24519,
     /*  857268 */     GIR_EraseRootFromParent_Done,
     /*  857269 */   // Label 13168: @857269
     /*  857269 */   GIM_Try, /*On fail goto*//*Label 13169*/ GIMT_Encode4(857344), // Rule ID 24522 //
     /*  857274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  857285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  857288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  857291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  857294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857320 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  857320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  857323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857342 */     GIR_RootConstrainSelectedInstOperands,
     /*  857343 */     // GIR_Coverage, 24522,
     /*  857343 */     GIR_EraseRootFromParent_Done,
     /*  857344 */   // Label 13169: @857344
     /*  857344 */   GIM_Try, /*On fail goto*//*Label 13170*/ GIMT_Encode4(857419), // Rule ID 24523 //
     /*  857349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  857360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  857363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  857366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  857369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857395 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  857395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  857398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857417 */     GIR_RootConstrainSelectedInstOperands,
     /*  857418 */     // GIR_Coverage, 24523,
     /*  857418 */     GIR_EraseRootFromParent_Done,
     /*  857419 */   // Label 13170: @857419
     /*  857419 */   GIM_Try, /*On fail goto*//*Label 13171*/ GIMT_Encode4(857494), // Rule ID 24526 //
     /*  857424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  857435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  857438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  857441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  857444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857470 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  857470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  857473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857492 */     GIR_RootConstrainSelectedInstOperands,
     /*  857493 */     // GIR_Coverage, 24526,
     /*  857493 */     GIR_EraseRootFromParent_Done,
     /*  857494 */   // Label 13171: @857494
     /*  857494 */   GIM_Try, /*On fail goto*//*Label 13172*/ GIMT_Encode4(857569), // Rule ID 24527 //
     /*  857499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  857510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  857513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  857516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  857519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857545 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  857545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  857548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857567 */     GIR_RootConstrainSelectedInstOperands,
     /*  857568 */     // GIR_Coverage, 24527,
     /*  857568 */     GIR_EraseRootFromParent_Done,
     /*  857569 */   // Label 13172: @857569
     /*  857569 */   GIM_Try, /*On fail goto*//*Label 13173*/ GIMT_Encode4(857644), // Rule ID 24530 //
     /*  857574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  857585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  857588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  857591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  857594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  857620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  857623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857642 */     GIR_RootConstrainSelectedInstOperands,
     /*  857643 */     // GIR_Coverage, 24530,
     /*  857643 */     GIR_EraseRootFromParent_Done,
     /*  857644 */   // Label 13173: @857644
     /*  857644 */   GIM_Try, /*On fail goto*//*Label 13174*/ GIMT_Encode4(857719), // Rule ID 24531 //
     /*  857649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  857660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  857663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  857666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  857669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857695 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  857698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857717 */     GIR_RootConstrainSelectedInstOperands,
     /*  857718 */     // GIR_Coverage, 24531,
     /*  857718 */     GIR_EraseRootFromParent_Done,
     /*  857719 */   // Label 13174: @857719
     /*  857719 */   GIM_Try, /*On fail goto*//*Label 13175*/ GIMT_Encode4(857794), // Rule ID 24534 //
     /*  857724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  857735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  857738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  857741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  857744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  857770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  857773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857792 */     GIR_RootConstrainSelectedInstOperands,
     /*  857793 */     // GIR_Coverage, 24534,
     /*  857793 */     GIR_EraseRootFromParent_Done,
     /*  857794 */   // Label 13175: @857794
     /*  857794 */   GIM_Try, /*On fail goto*//*Label 13176*/ GIMT_Encode4(857869), // Rule ID 24535 //
     /*  857799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  857810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  857813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  857816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  857819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857845 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  857845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  857848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857867 */     GIR_RootConstrainSelectedInstOperands,
     /*  857868 */     // GIR_Coverage, 24535,
     /*  857868 */     GIR_EraseRootFromParent_Done,
     /*  857869 */   // Label 13176: @857869
     /*  857869 */   GIM_Try, /*On fail goto*//*Label 13177*/ GIMT_Encode4(857944), // Rule ID 24538 //
     /*  857874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  857877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  857885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  857888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  857891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  857894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857920 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  857920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  857923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857942 */     GIR_RootConstrainSelectedInstOperands,
     /*  857943 */     // GIR_Coverage, 24538,
     /*  857943 */     GIR_EraseRootFromParent_Done,
     /*  857944 */   // Label 13177: @857944
     /*  857944 */   GIM_Try, /*On fail goto*//*Label 13178*/ GIMT_Encode4(858019), // Rule ID 24539 //
     /*  857949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  857952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  857960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  857963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  857966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  857969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857995 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  857995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  857998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858017 */     GIR_RootConstrainSelectedInstOperands,
     /*  858018 */     // GIR_Coverage, 24539,
     /*  858018 */     GIR_EraseRootFromParent_Done,
     /*  858019 */   // Label 13178: @858019
     /*  858019 */   GIM_Try, /*On fail goto*//*Label 13179*/ GIMT_Encode4(858094), // Rule ID 24542 //
     /*  858024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  858035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  858038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  858041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  858044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858070 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  858070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  858073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858092 */     GIR_RootConstrainSelectedInstOperands,
     /*  858093 */     // GIR_Coverage, 24542,
     /*  858093 */     GIR_EraseRootFromParent_Done,
     /*  858094 */   // Label 13179: @858094
     /*  858094 */   GIM_Try, /*On fail goto*//*Label 13180*/ GIMT_Encode4(858169), // Rule ID 24543 //
     /*  858099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  858110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  858113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  858116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  858119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858145 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  858145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  858148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858167 */     GIR_RootConstrainSelectedInstOperands,
     /*  858168 */     // GIR_Coverage, 24543,
     /*  858168 */     GIR_EraseRootFromParent_Done,
     /*  858169 */   // Label 13180: @858169
     /*  858169 */   GIM_Try, /*On fail goto*//*Label 13181*/ GIMT_Encode4(858244), // Rule ID 24546 //
     /*  858174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  858185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  858188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  858191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  858194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858220 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  858220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  858223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858242 */     GIR_RootConstrainSelectedInstOperands,
     /*  858243 */     // GIR_Coverage, 24546,
     /*  858243 */     GIR_EraseRootFromParent_Done,
     /*  858244 */   // Label 13181: @858244
     /*  858244 */   GIM_Try, /*On fail goto*//*Label 13182*/ GIMT_Encode4(858319), // Rule ID 24547 //
     /*  858249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  858260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  858263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  858266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  858269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858295 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  858295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  858298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858317 */     GIR_RootConstrainSelectedInstOperands,
     /*  858318 */     // GIR_Coverage, 24547,
     /*  858318 */     GIR_EraseRootFromParent_Done,
     /*  858319 */   // Label 13182: @858319
     /*  858319 */   GIM_Try, /*On fail goto*//*Label 13183*/ GIMT_Encode4(858394), // Rule ID 24550 //
     /*  858324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  858335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  858338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  858341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  858344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858370 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  858370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  858373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858392 */     GIR_RootConstrainSelectedInstOperands,
     /*  858393 */     // GIR_Coverage, 24550,
     /*  858393 */     GIR_EraseRootFromParent_Done,
     /*  858394 */   // Label 13183: @858394
     /*  858394 */   GIM_Try, /*On fail goto*//*Label 13184*/ GIMT_Encode4(858469), // Rule ID 24551 //
     /*  858399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  858410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  858413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  858416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  858419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858445 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  858445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  858448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858467 */     GIR_RootConstrainSelectedInstOperands,
     /*  858468 */     // GIR_Coverage, 24551,
     /*  858468 */     GIR_EraseRootFromParent_Done,
     /*  858469 */   // Label 13184: @858469
     /*  858469 */   GIM_Try, /*On fail goto*//*Label 13185*/ GIMT_Encode4(858544), // Rule ID 24554 //
     /*  858474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  858485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  858488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  858491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  858494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858520 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  858523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858542 */     GIR_RootConstrainSelectedInstOperands,
     /*  858543 */     // GIR_Coverage, 24554,
     /*  858543 */     GIR_EraseRootFromParent_Done,
     /*  858544 */   // Label 13185: @858544
     /*  858544 */   GIM_Try, /*On fail goto*//*Label 13186*/ GIMT_Encode4(858619), // Rule ID 24555 //
     /*  858549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  858560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  858563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  858566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  858569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858595 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  858598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858617 */     GIR_RootConstrainSelectedInstOperands,
     /*  858618 */     // GIR_Coverage, 24555,
     /*  858618 */     GIR_EraseRootFromParent_Done,
     /*  858619 */   // Label 13186: @858619
     /*  858619 */   GIM_Try, /*On fail goto*//*Label 13187*/ GIMT_Encode4(858694), // Rule ID 24558 //
     /*  858624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  858635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  858638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  858641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  858644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858670 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  858673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858692 */     GIR_RootConstrainSelectedInstOperands,
     /*  858693 */     // GIR_Coverage, 24558,
     /*  858693 */     GIR_EraseRootFromParent_Done,
     /*  858694 */   // Label 13187: @858694
     /*  858694 */   GIM_Try, /*On fail goto*//*Label 13188*/ GIMT_Encode4(858769), // Rule ID 24559 //
     /*  858699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  858710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  858713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  858716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  858719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858745 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  858748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858767 */     GIR_RootConstrainSelectedInstOperands,
     /*  858768 */     // GIR_Coverage, 24559,
     /*  858768 */     GIR_EraseRootFromParent_Done,
     /*  858769 */   // Label 13188: @858769
     /*  858769 */   GIM_Try, /*On fail goto*//*Label 13189*/ GIMT_Encode4(858844), // Rule ID 24562 //
     /*  858774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  858785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  858788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  858791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  858794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858820 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  858823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858842 */     GIR_RootConstrainSelectedInstOperands,
     /*  858843 */     // GIR_Coverage, 24562,
     /*  858843 */     GIR_EraseRootFromParent_Done,
     /*  858844 */   // Label 13189: @858844
     /*  858844 */   GIM_Try, /*On fail goto*//*Label 13190*/ GIMT_Encode4(858919), // Rule ID 24563 //
     /*  858849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  858860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  858863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  858866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  858869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858895 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  858898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858917 */     GIR_RootConstrainSelectedInstOperands,
     /*  858918 */     // GIR_Coverage, 24563,
     /*  858918 */     GIR_EraseRootFromParent_Done,
     /*  858919 */   // Label 13190: @858919
     /*  858919 */   GIM_Try, /*On fail goto*//*Label 13191*/ GIMT_Encode4(858994), // Rule ID 24566 //
     /*  858924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  858935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  858938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  858941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  858944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858970 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  858970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  858973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858992 */     GIR_RootConstrainSelectedInstOperands,
     /*  858993 */     // GIR_Coverage, 24566,
     /*  858993 */     GIR_EraseRootFromParent_Done,
     /*  858994 */   // Label 13191: @858994
     /*  858994 */   GIM_Try, /*On fail goto*//*Label 13192*/ GIMT_Encode4(859069), // Rule ID 24567 //
     /*  858999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  859010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  859013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  859016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  859019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859045 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  859048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859067 */     GIR_RootConstrainSelectedInstOperands,
     /*  859068 */     // GIR_Coverage, 24567,
     /*  859068 */     GIR_EraseRootFromParent_Done,
     /*  859069 */   // Label 13192: @859069
     /*  859069 */   GIM_Try, /*On fail goto*//*Label 13193*/ GIMT_Encode4(859144), // Rule ID 24570 //
     /*  859074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  859085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  859088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  859091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  859094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859120 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  859123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859142 */     GIR_RootConstrainSelectedInstOperands,
     /*  859143 */     // GIR_Coverage, 24570,
     /*  859143 */     GIR_EraseRootFromParent_Done,
     /*  859144 */   // Label 13193: @859144
     /*  859144 */   GIM_Try, /*On fail goto*//*Label 13194*/ GIMT_Encode4(859219), // Rule ID 24571 //
     /*  859149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  859160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  859163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  859166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  859169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859195 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  859198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859217 */     GIR_RootConstrainSelectedInstOperands,
     /*  859218 */     // GIR_Coverage, 24571,
     /*  859218 */     GIR_EraseRootFromParent_Done,
     /*  859219 */   // Label 13194: @859219
     /*  859219 */   GIM_Try, /*On fail goto*//*Label 13195*/ GIMT_Encode4(859294), // Rule ID 24574 //
     /*  859224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  859235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  859238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  859241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  859244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859270 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  859273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859292 */     GIR_RootConstrainSelectedInstOperands,
     /*  859293 */     // GIR_Coverage, 24574,
     /*  859293 */     GIR_EraseRootFromParent_Done,
     /*  859294 */   // Label 13195: @859294
     /*  859294 */   GIM_Try, /*On fail goto*//*Label 13196*/ GIMT_Encode4(859369), // Rule ID 24575 //
     /*  859299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  859310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  859313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  859316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  859319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859345 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  859348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859367 */     GIR_RootConstrainSelectedInstOperands,
     /*  859368 */     // GIR_Coverage, 24575,
     /*  859368 */     GIR_EraseRootFromParent_Done,
     /*  859369 */   // Label 13196: @859369
     /*  859369 */   GIM_Try, /*On fail goto*//*Label 13197*/ GIMT_Encode4(859444), // Rule ID 24578 //
     /*  859374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  859377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  859385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  859388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  859391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  859394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859420 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  859420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  859423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859442 */     GIR_RootConstrainSelectedInstOperands,
     /*  859443 */     // GIR_Coverage, 24578,
     /*  859443 */     GIR_EraseRootFromParent_Done,
     /*  859444 */   // Label 13197: @859444
     /*  859444 */   GIM_Try, /*On fail goto*//*Label 13198*/ GIMT_Encode4(859519), // Rule ID 24579 //
     /*  859449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  859452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  859460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  859463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  859466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  859469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859495 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  859495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  859498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859517 */     GIR_RootConstrainSelectedInstOperands,
     /*  859518 */     // GIR_Coverage, 24579,
     /*  859518 */     GIR_EraseRootFromParent_Done,
     /*  859519 */   // Label 13198: @859519
     /*  859519 */   GIM_Try, /*On fail goto*//*Label 13199*/ GIMT_Encode4(859594), // Rule ID 24582 //
     /*  859524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  859527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  859535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  859538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  859541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  859544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859570 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  859570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  859573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859592 */     GIR_RootConstrainSelectedInstOperands,
     /*  859593 */     // GIR_Coverage, 24582,
     /*  859593 */     GIR_EraseRootFromParent_Done,
     /*  859594 */   // Label 13199: @859594
     /*  859594 */   GIM_Try, /*On fail goto*//*Label 13200*/ GIMT_Encode4(859669), // Rule ID 24583 //
     /*  859599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  859602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  859610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  859613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  859616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  859619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859645 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  859645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  859648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859667 */     GIR_RootConstrainSelectedInstOperands,
     /*  859668 */     // GIR_Coverage, 24583,
     /*  859668 */     GIR_EraseRootFromParent_Done,
     /*  859669 */   // Label 13200: @859669
     /*  859669 */   GIM_Try, /*On fail goto*//*Label 13201*/ GIMT_Encode4(859744), // Rule ID 24586 //
     /*  859674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  859677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  859685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  859688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  859691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  859694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859720 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  859720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  859723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859742 */     GIR_RootConstrainSelectedInstOperands,
     /*  859743 */     // GIR_Coverage, 24586,
     /*  859743 */     GIR_EraseRootFromParent_Done,
     /*  859744 */   // Label 13201: @859744
     /*  859744 */   GIM_Try, /*On fail goto*//*Label 13202*/ GIMT_Encode4(859819), // Rule ID 24587 //
     /*  859749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  859752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  859760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  859763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  859766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  859769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859795 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  859795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  859798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859817 */     GIR_RootConstrainSelectedInstOperands,
     /*  859818 */     // GIR_Coverage, 24587,
     /*  859818 */     GIR_EraseRootFromParent_Done,
     /*  859819 */   // Label 13202: @859819
     /*  859819 */   GIM_Try, /*On fail goto*//*Label 13203*/ GIMT_Encode4(859894), // Rule ID 24590 //
     /*  859824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  859835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  859838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  859841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  859844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859870 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  859870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  859873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859892 */     GIR_RootConstrainSelectedInstOperands,
     /*  859893 */     // GIR_Coverage, 24590,
     /*  859893 */     GIR_EraseRootFromParent_Done,
     /*  859894 */   // Label 13203: @859894
     /*  859894 */   GIM_Try, /*On fail goto*//*Label 13204*/ GIMT_Encode4(859969), // Rule ID 24591 //
     /*  859899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  859910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  859913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  859916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859945 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  859945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  859948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859967 */     GIR_RootConstrainSelectedInstOperands,
     /*  859968 */     // GIR_Coverage, 24591,
     /*  859968 */     GIR_EraseRootFromParent_Done,
     /*  859969 */   // Label 13204: @859969
     /*  859969 */   GIM_Try, /*On fail goto*//*Label 13205*/ GIMT_Encode4(860044), // Rule ID 24594 //
     /*  859974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  859985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  859988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  859991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  859994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860020 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860042 */     GIR_RootConstrainSelectedInstOperands,
     /*  860043 */     // GIR_Coverage, 24594,
     /*  860043 */     GIR_EraseRootFromParent_Done,
     /*  860044 */   // Label 13205: @860044
     /*  860044 */   GIM_Try, /*On fail goto*//*Label 13206*/ GIMT_Encode4(860119), // Rule ID 24595 //
     /*  860049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  860060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  860063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  860066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860095 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860117 */     GIR_RootConstrainSelectedInstOperands,
     /*  860118 */     // GIR_Coverage, 24595,
     /*  860118 */     GIR_EraseRootFromParent_Done,
     /*  860119 */   // Label 13206: @860119
     /*  860119 */   GIM_Try, /*On fail goto*//*Label 13207*/ GIMT_Encode4(860194), // Rule ID 24598 //
     /*  860124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  860135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  860138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  860141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860170 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860192 */     GIR_RootConstrainSelectedInstOperands,
     /*  860193 */     // GIR_Coverage, 24598,
     /*  860193 */     GIR_EraseRootFromParent_Done,
     /*  860194 */   // Label 13207: @860194
     /*  860194 */   GIM_Try, /*On fail goto*//*Label 13208*/ GIMT_Encode4(860269), // Rule ID 24599 //
     /*  860199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  860210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  860213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  860216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860245 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860267 */     GIR_RootConstrainSelectedInstOperands,
     /*  860268 */     // GIR_Coverage, 24599,
     /*  860268 */     GIR_EraseRootFromParent_Done,
     /*  860269 */   // Label 13208: @860269
     /*  860269 */   GIM_Try, /*On fail goto*//*Label 13209*/ GIMT_Encode4(860344), // Rule ID 24602 //
     /*  860274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  860285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  860288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  860291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860320 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  860320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860342 */     GIR_RootConstrainSelectedInstOperands,
     /*  860343 */     // GIR_Coverage, 24602,
     /*  860343 */     GIR_EraseRootFromParent_Done,
     /*  860344 */   // Label 13209: @860344
     /*  860344 */   GIM_Try, /*On fail goto*//*Label 13210*/ GIMT_Encode4(860419), // Rule ID 24603 //
     /*  860349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  860360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  860363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  860366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860395 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  860395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860417 */     GIR_RootConstrainSelectedInstOperands,
     /*  860418 */     // GIR_Coverage, 24603,
     /*  860418 */     GIR_EraseRootFromParent_Done,
     /*  860419 */   // Label 13210: @860419
     /*  860419 */   GIM_Try, /*On fail goto*//*Label 13211*/ GIMT_Encode4(860494), // Rule ID 24606 //
     /*  860424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  860435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  860438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  860441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860470 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  860470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860492 */     GIR_RootConstrainSelectedInstOperands,
     /*  860493 */     // GIR_Coverage, 24606,
     /*  860493 */     GIR_EraseRootFromParent_Done,
     /*  860494 */   // Label 13211: @860494
     /*  860494 */   GIM_Try, /*On fail goto*//*Label 13212*/ GIMT_Encode4(860569), // Rule ID 24607 //
     /*  860499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  860510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  860513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  860516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860545 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  860545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860567 */     GIR_RootConstrainSelectedInstOperands,
     /*  860568 */     // GIR_Coverage, 24607,
     /*  860568 */     GIR_EraseRootFromParent_Done,
     /*  860569 */   // Label 13212: @860569
     /*  860569 */   GIM_Try, /*On fail goto*//*Label 13213*/ GIMT_Encode4(860644), // Rule ID 24610 //
     /*  860574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  860585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  860588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  860591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860620 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  860620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  860639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860642 */     GIR_RootConstrainSelectedInstOperands,
     /*  860643 */     // GIR_Coverage, 24610,
     /*  860643 */     GIR_EraseRootFromParent_Done,
     /*  860644 */   // Label 13213: @860644
     /*  860644 */   GIM_Try, /*On fail goto*//*Label 13214*/ GIMT_Encode4(860719), // Rule ID 24611 //
     /*  860649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  860660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  860663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  860666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860695 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  860695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  860714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860717 */     GIR_RootConstrainSelectedInstOperands,
     /*  860718 */     // GIR_Coverage, 24611,
     /*  860718 */     GIR_EraseRootFromParent_Done,
     /*  860719 */   // Label 13214: @860719
     /*  860719 */   GIM_Try, /*On fail goto*//*Label 13215*/ GIMT_Encode4(860794), // Rule ID 24614 //
     /*  860724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  860735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  860738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  860741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860770 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860792 */     GIR_RootConstrainSelectedInstOperands,
     /*  860793 */     // GIR_Coverage, 24614,
     /*  860793 */     GIR_EraseRootFromParent_Done,
     /*  860794 */   // Label 13215: @860794
     /*  860794 */   GIM_Try, /*On fail goto*//*Label 13216*/ GIMT_Encode4(860869), // Rule ID 24615 //
     /*  860799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  860810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  860813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  860816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860845 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860867 */     GIR_RootConstrainSelectedInstOperands,
     /*  860868 */     // GIR_Coverage, 24615,
     /*  860868 */     GIR_EraseRootFromParent_Done,
     /*  860869 */   // Label 13216: @860869
     /*  860869 */   GIM_Try, /*On fail goto*//*Label 13217*/ GIMT_Encode4(860944), // Rule ID 24618 //
     /*  860874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  860885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  860888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  860891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860920 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  860920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860942 */     GIR_RootConstrainSelectedInstOperands,
     /*  860943 */     // GIR_Coverage, 24618,
     /*  860943 */     GIR_EraseRootFromParent_Done,
     /*  860944 */   // Label 13217: @860944
     /*  860944 */   GIM_Try, /*On fail goto*//*Label 13218*/ GIMT_Encode4(861019), // Rule ID 24619 //
     /*  860949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  860960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  860963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  860966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860995 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  860995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861017 */     GIR_RootConstrainSelectedInstOperands,
     /*  861018 */     // GIR_Coverage, 24619,
     /*  861018 */     GIR_EraseRootFromParent_Done,
     /*  861019 */   // Label 13218: @861019
     /*  861019 */   GIM_Try, /*On fail goto*//*Label 13219*/ GIMT_Encode4(861094), // Rule ID 24622 //
     /*  861024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  861038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861070 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  861070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861092 */     GIR_RootConstrainSelectedInstOperands,
     /*  861093 */     // GIR_Coverage, 24622,
     /*  861093 */     GIR_EraseRootFromParent_Done,
     /*  861094 */   // Label 13219: @861094
     /*  861094 */   GIM_Try, /*On fail goto*//*Label 13220*/ GIMT_Encode4(861169), // Rule ID 24623 //
     /*  861099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  861113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861145 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  861145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861167 */     GIR_RootConstrainSelectedInstOperands,
     /*  861168 */     // GIR_Coverage, 24623,
     /*  861168 */     GIR_EraseRootFromParent_Done,
     /*  861169 */   // Label 13220: @861169
     /*  861169 */   GIM_Try, /*On fail goto*//*Label 13221*/ GIMT_Encode4(861244), // Rule ID 24626 //
     /*  861174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  861177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  861185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  861188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  861191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861220 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  861220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  861239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861242 */     GIR_RootConstrainSelectedInstOperands,
     /*  861243 */     // GIR_Coverage, 24626,
     /*  861243 */     GIR_EraseRootFromParent_Done,
     /*  861244 */   // Label 13221: @861244
     /*  861244 */   GIM_Try, /*On fail goto*//*Label 13222*/ GIMT_Encode4(861319), // Rule ID 24627 //
     /*  861249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  861252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  861260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  861263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  861266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861295 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  861295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  861314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861317 */     GIR_RootConstrainSelectedInstOperands,
     /*  861318 */     // GIR_Coverage, 24627,
     /*  861318 */     GIR_EraseRootFromParent_Done,
     /*  861319 */   // Label 13222: @861319
     /*  861319 */   GIM_Try, /*On fail goto*//*Label 13223*/ GIMT_Encode4(861394), // Rule ID 24630 //
     /*  861324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  861335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  861338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  861341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861370 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861392 */     GIR_RootConstrainSelectedInstOperands,
     /*  861393 */     // GIR_Coverage, 24630,
     /*  861393 */     GIR_EraseRootFromParent_Done,
     /*  861394 */   // Label 13223: @861394
     /*  861394 */   GIM_Try, /*On fail goto*//*Label 13224*/ GIMT_Encode4(861469), // Rule ID 24631 //
     /*  861399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  861410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  861413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  861416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861445 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861467 */     GIR_RootConstrainSelectedInstOperands,
     /*  861468 */     // GIR_Coverage, 24631,
     /*  861468 */     GIR_EraseRootFromParent_Done,
     /*  861469 */   // Label 13224: @861469
     /*  861469 */   GIM_Try, /*On fail goto*//*Label 13225*/ GIMT_Encode4(861544), // Rule ID 24634 //
     /*  861474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  861485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  861488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  861491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861520 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861542 */     GIR_RootConstrainSelectedInstOperands,
     /*  861543 */     // GIR_Coverage, 24634,
     /*  861543 */     GIR_EraseRootFromParent_Done,
     /*  861544 */   // Label 13225: @861544
     /*  861544 */   GIM_Try, /*On fail goto*//*Label 13226*/ GIMT_Encode4(861619), // Rule ID 24635 //
     /*  861549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  861560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  861563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  861566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861595 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861617 */     GIR_RootConstrainSelectedInstOperands,
     /*  861618 */     // GIR_Coverage, 24635,
     /*  861618 */     GIR_EraseRootFromParent_Done,
     /*  861619 */   // Label 13226: @861619
     /*  861619 */   GIM_Try, /*On fail goto*//*Label 13227*/ GIMT_Encode4(861694), // Rule ID 24638 //
     /*  861624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  861635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  861638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  861641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861670 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  861673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861692 */     GIR_RootConstrainSelectedInstOperands,
     /*  861693 */     // GIR_Coverage, 24638,
     /*  861693 */     GIR_EraseRootFromParent_Done,
     /*  861694 */   // Label 13227: @861694
     /*  861694 */   GIM_Try, /*On fail goto*//*Label 13228*/ GIMT_Encode4(861769), // Rule ID 24639 //
     /*  861699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  861710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  861713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  861716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861745 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  861748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861767 */     GIR_RootConstrainSelectedInstOperands,
     /*  861768 */     // GIR_Coverage, 24639,
     /*  861768 */     GIR_EraseRootFromParent_Done,
     /*  861769 */   // Label 13228: @861769
     /*  861769 */   GIM_Try, /*On fail goto*//*Label 13229*/ GIMT_Encode4(861844), // Rule ID 24642 //
     /*  861774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  861785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  861788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  861791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861820 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  861820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861842 */     GIR_RootConstrainSelectedInstOperands,
     /*  861843 */     // GIR_Coverage, 24642,
     /*  861843 */     GIR_EraseRootFromParent_Done,
     /*  861844 */   // Label 13229: @861844
     /*  861844 */   GIM_Try, /*On fail goto*//*Label 13230*/ GIMT_Encode4(861919), // Rule ID 24643 //
     /*  861849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  861860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  861863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  861866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861895 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  861895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861917 */     GIR_RootConstrainSelectedInstOperands,
     /*  861918 */     // GIR_Coverage, 24643,
     /*  861918 */     GIR_EraseRootFromParent_Done,
     /*  861919 */   // Label 13230: @861919
     /*  861919 */   GIM_Try, /*On fail goto*//*Label 13231*/ GIMT_Encode4(861994), // Rule ID 24646 //
     /*  861924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  861935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  861938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  861941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861970 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  861970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861992 */     GIR_RootConstrainSelectedInstOperands,
     /*  861993 */     // GIR_Coverage, 24646,
     /*  861993 */     GIR_EraseRootFromParent_Done,
     /*  861994 */   // Label 13231: @861994
     /*  861994 */   GIM_Try, /*On fail goto*//*Label 13232*/ GIMT_Encode4(862069), // Rule ID 24647 //
     /*  861999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  862010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  862013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  862016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862045 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862067 */     GIR_RootConstrainSelectedInstOperands,
     /*  862068 */     // GIR_Coverage, 24647,
     /*  862068 */     GIR_EraseRootFromParent_Done,
     /*  862069 */   // Label 13232: @862069
     /*  862069 */   GIM_Try, /*On fail goto*//*Label 13233*/ GIMT_Encode4(862144), // Rule ID 24650 //
     /*  862074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  862085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  862088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  862091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862120 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862142 */     GIR_RootConstrainSelectedInstOperands,
     /*  862143 */     // GIR_Coverage, 24650,
     /*  862143 */     GIR_EraseRootFromParent_Done,
     /*  862144 */   // Label 13233: @862144
     /*  862144 */   GIM_Try, /*On fail goto*//*Label 13234*/ GIMT_Encode4(862219), // Rule ID 24651 //
     /*  862149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  862160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  862163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  862166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862195 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862217 */     GIR_RootConstrainSelectedInstOperands,
     /*  862218 */     // GIR_Coverage, 24651,
     /*  862218 */     GIR_EraseRootFromParent_Done,
     /*  862219 */   // Label 13234: @862219
     /*  862219 */   GIM_Try, /*On fail goto*//*Label 13235*/ GIMT_Encode4(862294), // Rule ID 24654 //
     /*  862224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  862238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862292 */     GIR_RootConstrainSelectedInstOperands,
     /*  862293 */     // GIR_Coverage, 24654,
     /*  862293 */     GIR_EraseRootFromParent_Done,
     /*  862294 */   // Label 13235: @862294
     /*  862294 */   GIM_Try, /*On fail goto*//*Label 13236*/ GIMT_Encode4(862369), // Rule ID 24655 //
     /*  862299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  862313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862345 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  862345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862367 */     GIR_RootConstrainSelectedInstOperands,
     /*  862368 */     // GIR_Coverage, 24655,
     /*  862368 */     GIR_EraseRootFromParent_Done,
     /*  862369 */   // Label 13236: @862369
     /*  862369 */   GIM_Try, /*On fail goto*//*Label 13237*/ GIMT_Encode4(862444), // Rule ID 24658 //
     /*  862374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  862388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862420 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862442 */     GIR_RootConstrainSelectedInstOperands,
     /*  862443 */     // GIR_Coverage, 24658,
     /*  862443 */     GIR_EraseRootFromParent_Done,
     /*  862444 */   // Label 13237: @862444
     /*  862444 */   GIM_Try, /*On fail goto*//*Label 13238*/ GIMT_Encode4(862519), // Rule ID 24659 //
     /*  862449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  862463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862495 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  862495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862517 */     GIR_RootConstrainSelectedInstOperands,
     /*  862518 */     // GIR_Coverage, 24659,
     /*  862518 */     GIR_EraseRootFromParent_Done,
     /*  862519 */   // Label 13238: @862519
     /*  862519 */   GIM_Try, /*On fail goto*//*Label 13239*/ GIMT_Encode4(862594), // Rule ID 24662 //
     /*  862524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  862535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  862538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  862541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862570 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862592 */     GIR_RootConstrainSelectedInstOperands,
     /*  862593 */     // GIR_Coverage, 24662,
     /*  862593 */     GIR_EraseRootFromParent_Done,
     /*  862594 */   // Label 13239: @862594
     /*  862594 */   GIM_Try, /*On fail goto*//*Label 13240*/ GIMT_Encode4(862669), // Rule ID 24663 //
     /*  862599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  862610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  862613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  862616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862645 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  862645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862667 */     GIR_RootConstrainSelectedInstOperands,
     /*  862668 */     // GIR_Coverage, 24663,
     /*  862668 */     GIR_EraseRootFromParent_Done,
     /*  862669 */   // Label 13240: @862669
     /*  862669 */   GIM_Try, /*On fail goto*//*Label 13241*/ GIMT_Encode4(862744), // Rule ID 24666 //
     /*  862674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  862677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  862685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  862688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  862691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862720 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  862720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862742 */     GIR_RootConstrainSelectedInstOperands,
     /*  862743 */     // GIR_Coverage, 24666,
     /*  862743 */     GIR_EraseRootFromParent_Done,
     /*  862744 */   // Label 13241: @862744
     /*  862744 */   GIM_Try, /*On fail goto*//*Label 13242*/ GIMT_Encode4(862819), // Rule ID 24667 //
     /*  862749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  862752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  862760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  862763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  862766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862795 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  862795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862817 */     GIR_RootConstrainSelectedInstOperands,
     /*  862818 */     // GIR_Coverage, 24667,
     /*  862818 */     GIR_EraseRootFromParent_Done,
     /*  862819 */   // Label 13242: @862819
     /*  862819 */   GIM_Try, /*On fail goto*//*Label 13243*/ GIMT_Encode4(862894), // Rule ID 24670 //
     /*  862824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  862827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  862835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  862838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  862841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862870 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  862870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862892 */     GIR_RootConstrainSelectedInstOperands,
     /*  862893 */     // GIR_Coverage, 24670,
     /*  862893 */     GIR_EraseRootFromParent_Done,
     /*  862894 */   // Label 13243: @862894
     /*  862894 */   GIM_Try, /*On fail goto*//*Label 13244*/ GIMT_Encode4(862969), // Rule ID 24671 //
     /*  862899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  862902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  862910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  862913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  862916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862945 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  862945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862967 */     GIR_RootConstrainSelectedInstOperands,
     /*  862968 */     // GIR_Coverage, 24671,
     /*  862968 */     GIR_EraseRootFromParent_Done,
     /*  862969 */   // Label 13244: @862969
     /*  862969 */   GIM_Try, /*On fail goto*//*Label 13245*/ GIMT_Encode4(863044), // Rule ID 24674 //
     /*  862974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  862977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  862985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  862988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  862991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863020 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  863023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863042 */     GIR_RootConstrainSelectedInstOperands,
     /*  863043 */     // GIR_Coverage, 24674,
     /*  863043 */     GIR_EraseRootFromParent_Done,
     /*  863044 */   // Label 13245: @863044
     /*  863044 */   GIM_Try, /*On fail goto*//*Label 13246*/ GIMT_Encode4(863119), // Rule ID 24675 //
     /*  863049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  863060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  863063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  863066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863095 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  863098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863117 */     GIR_RootConstrainSelectedInstOperands,
     /*  863118 */     // GIR_Coverage, 24675,
     /*  863118 */     GIR_EraseRootFromParent_Done,
     /*  863119 */   // Label 13246: @863119
     /*  863119 */   GIM_Try, /*On fail goto*//*Label 13247*/ GIMT_Encode4(863194), // Rule ID 24766 //
     /*  863124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  863135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  863138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  863141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863170 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  863173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863192 */     GIR_RootConstrainSelectedInstOperands,
     /*  863193 */     // GIR_Coverage, 24766,
     /*  863193 */     GIR_EraseRootFromParent_Done,
     /*  863194 */   // Label 13247: @863194
     /*  863194 */   GIM_Try, /*On fail goto*//*Label 13248*/ GIMT_Encode4(863269), // Rule ID 24767 //
     /*  863199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  863210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  863213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  863216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863245 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  863248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863267 */     GIR_RootConstrainSelectedInstOperands,
     /*  863268 */     // GIR_Coverage, 24767,
     /*  863268 */     GIR_EraseRootFromParent_Done,
     /*  863269 */   // Label 13248: @863269
     /*  863269 */   GIM_Try, /*On fail goto*//*Label 13249*/ GIMT_Encode4(863344), // Rule ID 24770 //
     /*  863274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  863285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  863288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  863291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863320 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  863323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863342 */     GIR_RootConstrainSelectedInstOperands,
     /*  863343 */     // GIR_Coverage, 24770,
     /*  863343 */     GIR_EraseRootFromParent_Done,
     /*  863344 */   // Label 13249: @863344
     /*  863344 */   GIM_Try, /*On fail goto*//*Label 13250*/ GIMT_Encode4(863419), // Rule ID 24771 //
     /*  863349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  863360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  863363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  863366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863395 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  863398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863417 */     GIR_RootConstrainSelectedInstOperands,
     /*  863418 */     // GIR_Coverage, 24771,
     /*  863418 */     GIR_EraseRootFromParent_Done,
     /*  863419 */   // Label 13250: @863419
     /*  863419 */   GIM_Try, /*On fail goto*//*Label 13251*/ GIMT_Encode4(863494), // Rule ID 24774 //
     /*  863424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  863435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  863438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  863441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  863444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863470 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11537:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  863473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863492 */     GIR_RootConstrainSelectedInstOperands,
     /*  863493 */     // GIR_Coverage, 24774,
     /*  863493 */     GIR_EraseRootFromParent_Done,
     /*  863494 */   // Label 13251: @863494
     /*  863494 */   GIM_Try, /*On fail goto*//*Label 13252*/ GIMT_Encode4(863569), // Rule ID 24775 //
     /*  863499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  863510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  863513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  863516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  863519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863545 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11537:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  863548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863567 */     GIR_RootConstrainSelectedInstOperands,
     /*  863568 */     // GIR_Coverage, 24775,
     /*  863568 */     GIR_EraseRootFromParent_Done,
     /*  863569 */   // Label 13252: @863569
     /*  863569 */   GIM_Try, /*On fail goto*//*Label 13253*/ GIMT_Encode4(863644), // Rule ID 24778 //
     /*  863574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  863585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  863588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  863591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863620 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  863620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  863623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863642 */     GIR_RootConstrainSelectedInstOperands,
     /*  863643 */     // GIR_Coverage, 24778,
     /*  863643 */     GIR_EraseRootFromParent_Done,
     /*  863644 */   // Label 13253: @863644
     /*  863644 */   GIM_Try, /*On fail goto*//*Label 13254*/ GIMT_Encode4(863719), // Rule ID 24779 //
     /*  863649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  863660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  863663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  863666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863695 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  863695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  863698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863717 */     GIR_RootConstrainSelectedInstOperands,
     /*  863718 */     // GIR_Coverage, 24779,
     /*  863718 */     GIR_EraseRootFromParent_Done,
     /*  863719 */   // Label 13254: @863719
     /*  863719 */   GIM_Try, /*On fail goto*//*Label 13255*/ GIMT_Encode4(863794), // Rule ID 24782 //
     /*  863724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  863735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  863738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  863741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863770 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  863770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  863773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863792 */     GIR_RootConstrainSelectedInstOperands,
     /*  863793 */     // GIR_Coverage, 24782,
     /*  863793 */     GIR_EraseRootFromParent_Done,
     /*  863794 */   // Label 13255: @863794
     /*  863794 */   GIM_Try, /*On fail goto*//*Label 13256*/ GIMT_Encode4(863869), // Rule ID 24783 //
     /*  863799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  863810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  863813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  863816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863845 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  863845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  863848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863867 */     GIR_RootConstrainSelectedInstOperands,
     /*  863868 */     // GIR_Coverage, 24783,
     /*  863868 */     GIR_EraseRootFromParent_Done,
     /*  863869 */   // Label 13256: @863869
     /*  863869 */   GIM_Try, /*On fail goto*//*Label 13257*/ GIMT_Encode4(863944), // Rule ID 24786 //
     /*  863874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  863885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  863888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  863891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863920 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  863920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  863923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863942 */     GIR_RootConstrainSelectedInstOperands,
     /*  863943 */     // GIR_Coverage, 24786,
     /*  863943 */     GIR_EraseRootFromParent_Done,
     /*  863944 */   // Label 13257: @863944
     /*  863944 */   GIM_Try, /*On fail goto*//*Label 13258*/ GIMT_Encode4(864019), // Rule ID 24787 //
     /*  863949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  863960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  863963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  863966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863995 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  863995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  863998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864017 */     GIR_RootConstrainSelectedInstOperands,
     /*  864018 */     // GIR_Coverage, 24787,
     /*  864018 */     GIR_EraseRootFromParent_Done,
     /*  864019 */   // Label 13258: @864019
     /*  864019 */   GIM_Try, /*On fail goto*//*Label 13259*/ GIMT_Encode4(864094), // Rule ID 24790 //
     /*  864024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  864035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  864038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  864041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  864044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11537:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  864073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864092 */     GIR_RootConstrainSelectedInstOperands,
     /*  864093 */     // GIR_Coverage, 24790,
     /*  864093 */     GIR_EraseRootFromParent_Done,
     /*  864094 */   // Label 13259: @864094
     /*  864094 */   GIM_Try, /*On fail goto*//*Label 13260*/ GIMT_Encode4(864169), // Rule ID 24791 //
     /*  864099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  864110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  864113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  864116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  864119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864145 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11537:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  864148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864167 */     GIR_RootConstrainSelectedInstOperands,
     /*  864168 */     // GIR_Coverage, 24791,
     /*  864168 */     GIR_EraseRootFromParent_Done,
     /*  864169 */   // Label 13260: @864169
     /*  864169 */   GIM_Try, /*On fail goto*//*Label 13261*/ GIMT_Encode4(864244), // Rule ID 24794 //
     /*  864174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  864185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  864188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  864191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  864194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864220 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11537:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  864223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864242 */     GIR_RootConstrainSelectedInstOperands,
     /*  864243 */     // GIR_Coverage, 24794,
     /*  864243 */     GIR_EraseRootFromParent_Done,
     /*  864244 */   // Label 13261: @864244
     /*  864244 */   GIM_Try, /*On fail goto*//*Label 13262*/ GIMT_Encode4(864319), // Rule ID 24795 //
     /*  864249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  864260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  864263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  864266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  864269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864295 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11537:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  864298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864317 */     GIR_RootConstrainSelectedInstOperands,
     /*  864318 */     // GIR_Coverage, 24795,
     /*  864318 */     GIR_EraseRootFromParent_Done,
     /*  864319 */   // Label 13262: @864319
     /*  864319 */   GIM_Try, /*On fail goto*//*Label 13263*/ GIMT_Encode4(864394), // Rule ID 24798 //
     /*  864324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  864335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  864338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  864341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  864344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864370 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  864370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  864373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864392 */     GIR_RootConstrainSelectedInstOperands,
     /*  864393 */     // GIR_Coverage, 24798,
     /*  864393 */     GIR_EraseRootFromParent_Done,
     /*  864394 */   // Label 13263: @864394
     /*  864394 */   GIM_Try, /*On fail goto*//*Label 13264*/ GIMT_Encode4(864469), // Rule ID 24799 //
     /*  864399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  864410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  864413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  864416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  864419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864445 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  864445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  864448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864467 */     GIR_RootConstrainSelectedInstOperands,
     /*  864468 */     // GIR_Coverage, 24799,
     /*  864468 */     GIR_EraseRootFromParent_Done,
     /*  864469 */   // Label 13264: @864469
     /*  864469 */   GIM_Try, /*On fail goto*//*Label 13265*/ GIMT_Encode4(864544), // Rule ID 24802 //
     /*  864474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  864477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  864485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  864488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  864491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864520 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  864520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  864523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  864539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864542 */     GIR_RootConstrainSelectedInstOperands,
     /*  864543 */     // GIR_Coverage, 24802,
     /*  864543 */     GIR_EraseRootFromParent_Done,
     /*  864544 */   // Label 13265: @864544
     /*  864544 */   GIM_Try, /*On fail goto*//*Label 13266*/ GIMT_Encode4(864619), // Rule ID 24803 //
     /*  864549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  864552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  864560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  864563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  864566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864595 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  864595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  864598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  864614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864617 */     GIR_RootConstrainSelectedInstOperands,
     /*  864618 */     // GIR_Coverage, 24803,
     /*  864618 */     GIR_EraseRootFromParent_Done,
     /*  864619 */   // Label 13266: @864619
     /*  864619 */   GIM_Try, /*On fail goto*//*Label 13267*/ GIMT_Encode4(864694), // Rule ID 24806 //
     /*  864624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  864635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  864638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  864641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  864644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864670 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  864673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864692 */     GIR_RootConstrainSelectedInstOperands,
     /*  864693 */     // GIR_Coverage, 24806,
     /*  864693 */     GIR_EraseRootFromParent_Done,
     /*  864694 */   // Label 13267: @864694
     /*  864694 */   GIM_Try, /*On fail goto*//*Label 13268*/ GIMT_Encode4(864769), // Rule ID 24807 //
     /*  864699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  864710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  864713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  864716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  864719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864745 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  864748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864767 */     GIR_RootConstrainSelectedInstOperands,
     /*  864768 */     // GIR_Coverage, 24807,
     /*  864768 */     GIR_EraseRootFromParent_Done,
     /*  864769 */   // Label 13268: @864769
     /*  864769 */   GIM_Try, /*On fail goto*//*Label 13269*/ GIMT_Encode4(864844), // Rule ID 24810 //
     /*  864774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  864785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  864788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  864791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  864794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864820 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  864823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864842 */     GIR_RootConstrainSelectedInstOperands,
     /*  864843 */     // GIR_Coverage, 24810,
     /*  864843 */     GIR_EraseRootFromParent_Done,
     /*  864844 */   // Label 13269: @864844
     /*  864844 */   GIM_Try, /*On fail goto*//*Label 13270*/ GIMT_Encode4(864919), // Rule ID 24811 //
     /*  864849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  864860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  864863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  864866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  864869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864895 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  864898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864917 */     GIR_RootConstrainSelectedInstOperands,
     /*  864918 */     // GIR_Coverage, 24811,
     /*  864918 */     GIR_EraseRootFromParent_Done,
     /*  864919 */   // Label 13270: @864919
     /*  864919 */   GIM_Try, /*On fail goto*//*Label 13271*/ GIMT_Encode4(864994), // Rule ID 24814 //
     /*  864924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  864935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  864938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  864941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  864944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864970 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  864973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864992 */     GIR_RootConstrainSelectedInstOperands,
     /*  864993 */     // GIR_Coverage, 24814,
     /*  864993 */     GIR_EraseRootFromParent_Done,
     /*  864994 */   // Label 13271: @864994
     /*  864994 */   GIM_Try, /*On fail goto*//*Label 13272*/ GIMT_Encode4(865069), // Rule ID 24815 //
     /*  864999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  865010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  865013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  865016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865045 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  865048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865067 */     GIR_RootConstrainSelectedInstOperands,
     /*  865068 */     // GIR_Coverage, 24815,
     /*  865068 */     GIR_EraseRootFromParent_Done,
     /*  865069 */   // Label 13272: @865069
     /*  865069 */   GIM_Try, /*On fail goto*//*Label 13273*/ GIMT_Encode4(865144), // Rule ID 24818 //
     /*  865074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  865085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  865088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  865091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865120 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  865123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865142 */     GIR_RootConstrainSelectedInstOperands,
     /*  865143 */     // GIR_Coverage, 24818,
     /*  865143 */     GIR_EraseRootFromParent_Done,
     /*  865144 */   // Label 13273: @865144
     /*  865144 */   GIM_Try, /*On fail goto*//*Label 13274*/ GIMT_Encode4(865219), // Rule ID 24819 //
     /*  865149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  865160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  865163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  865166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865195 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  865198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865217 */     GIR_RootConstrainSelectedInstOperands,
     /*  865218 */     // GIR_Coverage, 24819,
     /*  865218 */     GIR_EraseRootFromParent_Done,
     /*  865219 */   // Label 13274: @865219
     /*  865219 */   GIM_Try, /*On fail goto*//*Label 13275*/ GIMT_Encode4(865294), // Rule ID 24822 //
     /*  865224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  865235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  865238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  865241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  865244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865270 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  865273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865292 */     GIR_RootConstrainSelectedInstOperands,
     /*  865293 */     // GIR_Coverage, 24822,
     /*  865293 */     GIR_EraseRootFromParent_Done,
     /*  865294 */   // Label 13275: @865294
     /*  865294 */   GIM_Try, /*On fail goto*//*Label 13276*/ GIMT_Encode4(865369), // Rule ID 24823 //
     /*  865299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  865310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  865313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  865316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  865319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865345 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  865348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865367 */     GIR_RootConstrainSelectedInstOperands,
     /*  865368 */     // GIR_Coverage, 24823,
     /*  865368 */     GIR_EraseRootFromParent_Done,
     /*  865369 */   // Label 13276: @865369
     /*  865369 */   GIM_Try, /*On fail goto*//*Label 13277*/ GIMT_Encode4(865444), // Rule ID 24826 //
     /*  865374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  865385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  865388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  865391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  865394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  865420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  865423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865442 */     GIR_RootConstrainSelectedInstOperands,
     /*  865443 */     // GIR_Coverage, 24826,
     /*  865443 */     GIR_EraseRootFromParent_Done,
     /*  865444 */   // Label 13277: @865444
     /*  865444 */   GIM_Try, /*On fail goto*//*Label 13278*/ GIMT_Encode4(865519), // Rule ID 24827 //
     /*  865449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  865460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  865463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  865466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  865469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865495 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  865495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  865498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865517 */     GIR_RootConstrainSelectedInstOperands,
     /*  865518 */     // GIR_Coverage, 24827,
     /*  865518 */     GIR_EraseRootFromParent_Done,
     /*  865519 */   // Label 13278: @865519
     /*  865519 */   GIM_Try, /*On fail goto*//*Label 13279*/ GIMT_Encode4(865594), // Rule ID 24830 //
     /*  865524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  865535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  865538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  865541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865570 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  865570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  865573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865592 */     GIR_RootConstrainSelectedInstOperands,
     /*  865593 */     // GIR_Coverage, 24830,
     /*  865593 */     GIR_EraseRootFromParent_Done,
     /*  865594 */   // Label 13279: @865594
     /*  865594 */   GIM_Try, /*On fail goto*//*Label 13280*/ GIMT_Encode4(865669), // Rule ID 24831 //
     /*  865599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  865610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  865613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  865616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865645 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  865645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  865648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865667 */     GIR_RootConstrainSelectedInstOperands,
     /*  865668 */     // GIR_Coverage, 24831,
     /*  865668 */     GIR_EraseRootFromParent_Done,
     /*  865669 */   // Label 13280: @865669
     /*  865669 */   GIM_Try, /*On fail goto*//*Label 13281*/ GIMT_Encode4(865744), // Rule ID 24834 //
     /*  865674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  865685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  865688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  865691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865720 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  865720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  865723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865742 */     GIR_RootConstrainSelectedInstOperands,
     /*  865743 */     // GIR_Coverage, 24834,
     /*  865743 */     GIR_EraseRootFromParent_Done,
     /*  865744 */   // Label 13281: @865744
     /*  865744 */   GIM_Try, /*On fail goto*//*Label 13282*/ GIMT_Encode4(865819), // Rule ID 24835 //
     /*  865749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  865760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  865763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  865766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865795 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  865795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  865798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865817 */     GIR_RootConstrainSelectedInstOperands,
     /*  865818 */     // GIR_Coverage, 24835,
     /*  865818 */     GIR_EraseRootFromParent_Done,
     /*  865819 */   // Label 13282: @865819
     /*  865819 */   GIM_Try, /*On fail goto*//*Label 13283*/ GIMT_Encode4(865894), // Rule ID 24838 //
     /*  865824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  865827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  865835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  865838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  865841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  865844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865870 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  865870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  865873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865892 */     GIR_RootConstrainSelectedInstOperands,
     /*  865893 */     // GIR_Coverage, 24838,
     /*  865893 */     GIR_EraseRootFromParent_Done,
     /*  865894 */   // Label 13283: @865894
     /*  865894 */   GIM_Try, /*On fail goto*//*Label 13284*/ GIMT_Encode4(865969), // Rule ID 24839 //
     /*  865899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  865902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  865910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  865913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  865916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  865919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865945 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  865945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  865948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865967 */     GIR_RootConstrainSelectedInstOperands,
     /*  865968 */     // GIR_Coverage, 24839,
     /*  865968 */     GIR_EraseRootFromParent_Done,
     /*  865969 */   // Label 13284: @865969
     /*  865969 */   GIM_Try, /*On fail goto*//*Label 13285*/ GIMT_Encode4(866044), // Rule ID 24842 //
     /*  865974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  865977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  865985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  865988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  865991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  865994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866020 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  866023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866042 */     GIR_RootConstrainSelectedInstOperands,
     /*  866043 */     // GIR_Coverage, 24842,
     /*  866043 */     GIR_EraseRootFromParent_Done,
     /*  866044 */   // Label 13285: @866044
     /*  866044 */   GIM_Try, /*On fail goto*//*Label 13286*/ GIMT_Encode4(866119), // Rule ID 24843 //
     /*  866049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  866052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  866060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  866063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  866066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  866069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866095 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  866098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866117 */     GIR_RootConstrainSelectedInstOperands,
     /*  866118 */     // GIR_Coverage, 24843,
     /*  866118 */     GIR_EraseRootFromParent_Done,
     /*  866119 */   // Label 13286: @866119
     /*  866119 */   GIM_Try, /*On fail goto*//*Label 13287*/ GIMT_Encode4(866194), // Rule ID 24846 //
     /*  866124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  866127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  866135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  866138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  866141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  866144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866170 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  866173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866192 */     GIR_RootConstrainSelectedInstOperands,
     /*  866193 */     // GIR_Coverage, 24846,
     /*  866193 */     GIR_EraseRootFromParent_Done,
     /*  866194 */   // Label 13287: @866194
     /*  866194 */   GIM_Try, /*On fail goto*//*Label 13288*/ GIMT_Encode4(866269), // Rule ID 24847 //
     /*  866199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  866202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  866210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  866213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  866216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  866219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866245 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  866248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866267 */     GIR_RootConstrainSelectedInstOperands,
     /*  866268 */     // GIR_Coverage, 24847,
     /*  866268 */     GIR_EraseRootFromParent_Done,
     /*  866269 */   // Label 13288: @866269
     /*  866269 */   GIM_Try, /*On fail goto*//*Label 13289*/ GIMT_Encode4(866344), // Rule ID 24850 //
     /*  866274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  866285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  866288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  866291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  866294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866320 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  866320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  866323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866342 */     GIR_RootConstrainSelectedInstOperands,
     /*  866343 */     // GIR_Coverage, 24850,
     /*  866343 */     GIR_EraseRootFromParent_Done,
     /*  866344 */   // Label 13289: @866344
     /*  866344 */   GIM_Try, /*On fail goto*//*Label 13290*/ GIMT_Encode4(866419), // Rule ID 24851 //
     /*  866349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  866360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  866363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  866366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  866369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866395 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  866395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  866398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866417 */     GIR_RootConstrainSelectedInstOperands,
     /*  866418 */     // GIR_Coverage, 24851,
     /*  866418 */     GIR_EraseRootFromParent_Done,
     /*  866419 */   // Label 13290: @866419
     /*  866419 */   GIM_Try, /*On fail goto*//*Label 13291*/ GIMT_Encode4(866494), // Rule ID 24854 //
     /*  866424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  866435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  866438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  866441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  866444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866470 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  866470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  866473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866492 */     GIR_RootConstrainSelectedInstOperands,
     /*  866493 */     // GIR_Coverage, 24854,
     /*  866493 */     GIR_EraseRootFromParent_Done,
     /*  866494 */   // Label 13291: @866494
     /*  866494 */   GIM_Try, /*On fail goto*//*Label 13292*/ GIMT_Encode4(866569), // Rule ID 24855 //
     /*  866499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  866510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  866513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  866516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  866519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866545 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  866545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  866548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866567 */     GIR_RootConstrainSelectedInstOperands,
     /*  866568 */     // GIR_Coverage, 24855,
     /*  866568 */     GIR_EraseRootFromParent_Done,
     /*  866569 */   // Label 13292: @866569
     /*  866569 */   GIM_Try, /*On fail goto*//*Label 13293*/ GIMT_Encode4(866644), // Rule ID 24858 //
     /*  866574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  866585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  866588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  866591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  866594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866620 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  866623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866642 */     GIR_RootConstrainSelectedInstOperands,
     /*  866643 */     // GIR_Coverage, 24858,
     /*  866643 */     GIR_EraseRootFromParent_Done,
     /*  866644 */   // Label 13293: @866644
     /*  866644 */   GIM_Try, /*On fail goto*//*Label 13294*/ GIMT_Encode4(866719), // Rule ID 24859 //
     /*  866649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  866660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  866663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  866666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  866669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866695 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  866698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866717 */     GIR_RootConstrainSelectedInstOperands,
     /*  866718 */     // GIR_Coverage, 24859,
     /*  866718 */     GIR_EraseRootFromParent_Done,
     /*  866719 */   // Label 13294: @866719
     /*  866719 */   GIM_Try, /*On fail goto*//*Label 13295*/ GIMT_Encode4(866794), // Rule ID 24862 //
     /*  866724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  866735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  866738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  866741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  866744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866770 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  866770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  866773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866792 */     GIR_RootConstrainSelectedInstOperands,
     /*  866793 */     // GIR_Coverage, 24862,
     /*  866793 */     GIR_EraseRootFromParent_Done,
     /*  866794 */   // Label 13295: @866794
     /*  866794 */   GIM_Try, /*On fail goto*//*Label 13296*/ GIMT_Encode4(866869), // Rule ID 24863 //
     /*  866799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  866810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  866813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  866816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  866819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866845 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  866845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  866848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866867 */     GIR_RootConstrainSelectedInstOperands,
     /*  866868 */     // GIR_Coverage, 24863,
     /*  866868 */     GIR_EraseRootFromParent_Done,
     /*  866869 */   // Label 13296: @866869
     /*  866869 */   GIM_Try, /*On fail goto*//*Label 13297*/ GIMT_Encode4(866944), // Rule ID 24866 //
     /*  866874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  866885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  866888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  866891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  866894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866920 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  866923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866942 */     GIR_RootConstrainSelectedInstOperands,
     /*  866943 */     // GIR_Coverage, 24866,
     /*  866943 */     GIR_EraseRootFromParent_Done,
     /*  866944 */   // Label 13297: @866944
     /*  866944 */   GIM_Try, /*On fail goto*//*Label 13298*/ GIMT_Encode4(867019), // Rule ID 24867 //
     /*  866949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  866960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  866963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  866966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  866969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866995 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  866998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867017 */     GIR_RootConstrainSelectedInstOperands,
     /*  867018 */     // GIR_Coverage, 24867,
     /*  867018 */     GIR_EraseRootFromParent_Done,
     /*  867019 */   // Label 13298: @867019
     /*  867019 */   GIM_Try, /*On fail goto*//*Label 13299*/ GIMT_Encode4(867094), // Rule ID 24870 //
     /*  867024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  867027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  867035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  867038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  867041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  867044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867070 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  867070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  867073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  867089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867092 */     GIR_RootConstrainSelectedInstOperands,
     /*  867093 */     // GIR_Coverage, 24870,
     /*  867093 */     GIR_EraseRootFromParent_Done,
     /*  867094 */   // Label 13299: @867094
     /*  867094 */   GIM_Try, /*On fail goto*//*Label 13300*/ GIMT_Encode4(867169), // Rule ID 24871 //
     /*  867099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  867102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  867110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  867113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  867116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  867119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867145 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  867145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  867148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  867164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867167 */     GIR_RootConstrainSelectedInstOperands,
     /*  867168 */     // GIR_Coverage, 24871,
     /*  867168 */     GIR_EraseRootFromParent_Done,
     /*  867169 */   // Label 13300: @867169
     /*  867169 */   GIM_Try, /*On fail goto*//*Label 13301*/ GIMT_Encode4(867244), // Rule ID 24874 //
     /*  867174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  867185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  867188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  867191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  867194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867220 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  867223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867242 */     GIR_RootConstrainSelectedInstOperands,
     /*  867243 */     // GIR_Coverage, 24874,
     /*  867243 */     GIR_EraseRootFromParent_Done,
     /*  867244 */   // Label 13301: @867244
     /*  867244 */   GIM_Try, /*On fail goto*//*Label 13302*/ GIMT_Encode4(867319), // Rule ID 24875 //
     /*  867249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  867260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  867263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  867266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  867269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867295 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  867298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867317 */     GIR_RootConstrainSelectedInstOperands,
     /*  867318 */     // GIR_Coverage, 24875,
     /*  867318 */     GIR_EraseRootFromParent_Done,
     /*  867319 */   // Label 13302: @867319
     /*  867319 */   GIM_Try, /*On fail goto*//*Label 13303*/ GIMT_Encode4(867394), // Rule ID 24878 //
     /*  867324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  867335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  867338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  867341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  867344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867370 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  867373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867392 */     GIR_RootConstrainSelectedInstOperands,
     /*  867393 */     // GIR_Coverage, 24878,
     /*  867393 */     GIR_EraseRootFromParent_Done,
     /*  867394 */   // Label 13303: @867394
     /*  867394 */   GIM_Try, /*On fail goto*//*Label 13304*/ GIMT_Encode4(867469), // Rule ID 24879 //
     /*  867399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  867410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  867413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  867416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  867419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867445 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  867448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867467 */     GIR_RootConstrainSelectedInstOperands,
     /*  867468 */     // GIR_Coverage, 24879,
     /*  867468 */     GIR_EraseRootFromParent_Done,
     /*  867469 */   // Label 13304: @867469
     /*  867469 */   GIM_Try, /*On fail goto*//*Label 13305*/ GIMT_Encode4(867544), // Rule ID 24882 //
     /*  867474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  867485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  867488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  867491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  867494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867520 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  867523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867542 */     GIR_RootConstrainSelectedInstOperands,
     /*  867543 */     // GIR_Coverage, 24882,
     /*  867543 */     GIR_EraseRootFromParent_Done,
     /*  867544 */   // Label 13305: @867544
     /*  867544 */   GIM_Try, /*On fail goto*//*Label 13306*/ GIMT_Encode4(867619), // Rule ID 24883 //
     /*  867549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  867560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  867563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  867566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  867569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867595 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  867598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867617 */     GIR_RootConstrainSelectedInstOperands,
     /*  867618 */     // GIR_Coverage, 24883,
     /*  867618 */     GIR_EraseRootFromParent_Done,
     /*  867619 */   // Label 13306: @867619
     /*  867619 */   GIM_Try, /*On fail goto*//*Label 13307*/ GIMT_Encode4(867694), // Rule ID 24886 //
     /*  867624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  867635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  867638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  867641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  867644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867670 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  867673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867692 */     GIR_RootConstrainSelectedInstOperands,
     /*  867693 */     // GIR_Coverage, 24886,
     /*  867693 */     GIR_EraseRootFromParent_Done,
     /*  867694 */   // Label 13307: @867694
     /*  867694 */   GIM_Try, /*On fail goto*//*Label 13308*/ GIMT_Encode4(867769), // Rule ID 24887 //
     /*  867699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  867710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  867713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  867716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  867719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867745 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  867748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867767 */     GIR_RootConstrainSelectedInstOperands,
     /*  867768 */     // GIR_Coverage, 24887,
     /*  867768 */     GIR_EraseRootFromParent_Done,
     /*  867769 */   // Label 13308: @867769
     /*  867769 */   GIM_Try, /*On fail goto*//*Label 13309*/ GIMT_Encode4(867844), // Rule ID 24890 //
     /*  867774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  867785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  867788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  867791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  867794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867820 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  867823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867842 */     GIR_RootConstrainSelectedInstOperands,
     /*  867843 */     // GIR_Coverage, 24890,
     /*  867843 */     GIR_EraseRootFromParent_Done,
     /*  867844 */   // Label 13309: @867844
     /*  867844 */   GIM_Try, /*On fail goto*//*Label 13310*/ GIMT_Encode4(867919), // Rule ID 24891 //
     /*  867849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  867860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  867863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  867866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  867869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867895 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  867898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867917 */     GIR_RootConstrainSelectedInstOperands,
     /*  867918 */     // GIR_Coverage, 24891,
     /*  867918 */     GIR_EraseRootFromParent_Done,
     /*  867919 */   // Label 13310: @867919
     /*  867919 */   GIM_Try, /*On fail goto*//*Label 13311*/ GIMT_Encode4(867994), // Rule ID 24894 //
     /*  867924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  867935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  867938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  867941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  867944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867970 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  867973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867992 */     GIR_RootConstrainSelectedInstOperands,
     /*  867993 */     // GIR_Coverage, 24894,
     /*  867993 */     GIR_EraseRootFromParent_Done,
     /*  867994 */   // Label 13311: @867994
     /*  867994 */   GIM_Try, /*On fail goto*//*Label 13312*/ GIMT_Encode4(868069), // Rule ID 24895 //
     /*  867999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  868010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  868013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  868016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  868019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868045 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  868045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  868048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868067 */     GIR_RootConstrainSelectedInstOperands,
     /*  868068 */     // GIR_Coverage, 24895,
     /*  868068 */     GIR_EraseRootFromParent_Done,
     /*  868069 */   // Label 13312: @868069
     /*  868069 */   GIM_Try, /*On fail goto*//*Label 13313*/ GIMT_Encode4(868144), // Rule ID 24898 //
     /*  868074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  868077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  868085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  868088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  868091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  868094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868120 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  868123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868142 */     GIR_RootConstrainSelectedInstOperands,
     /*  868143 */     // GIR_Coverage, 24898,
     /*  868143 */     GIR_EraseRootFromParent_Done,
     /*  868144 */   // Label 13313: @868144
     /*  868144 */   GIM_Try, /*On fail goto*//*Label 13314*/ GIMT_Encode4(868219), // Rule ID 24899 //
     /*  868149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  868152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  868160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  868163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  868166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  868169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868195 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  868198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868217 */     GIR_RootConstrainSelectedInstOperands,
     /*  868218 */     // GIR_Coverage, 24899,
     /*  868218 */     GIR_EraseRootFromParent_Done,
     /*  868219 */   // Label 13314: @868219
     /*  868219 */   GIM_Try, /*On fail goto*//*Label 13315*/ GIMT_Encode4(868294), // Rule ID 24902 //
     /*  868224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  868227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  868235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  868238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  868241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  868244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868270 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  868273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868292 */     GIR_RootConstrainSelectedInstOperands,
     /*  868293 */     // GIR_Coverage, 24902,
     /*  868293 */     GIR_EraseRootFromParent_Done,
     /*  868294 */   // Label 13315: @868294
     /*  868294 */   GIM_Try, /*On fail goto*//*Label 13316*/ GIMT_Encode4(868369), // Rule ID 24903 //
     /*  868299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  868302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  868310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  868313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  868316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  868319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868345 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  868348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868367 */     GIR_RootConstrainSelectedInstOperands,
     /*  868368 */     // GIR_Coverage, 24903,
     /*  868368 */     GIR_EraseRootFromParent_Done,
     /*  868369 */   // Label 13316: @868369
     /*  868369 */   GIM_Try, /*On fail goto*//*Label 13317*/ GIMT_Encode4(868444), // Rule ID 24906 //
     /*  868374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  868377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  868385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  868388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  868391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  868394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868420 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  868423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868442 */     GIR_RootConstrainSelectedInstOperands,
     /*  868443 */     // GIR_Coverage, 24906,
     /*  868443 */     GIR_EraseRootFromParent_Done,
     /*  868444 */   // Label 13317: @868444
     /*  868444 */   GIM_Try, /*On fail goto*//*Label 13318*/ GIMT_Encode4(868519), // Rule ID 24907 //
     /*  868449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  868452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  868460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  868463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  868466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  868469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868495 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  868498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868517 */     GIR_RootConstrainSelectedInstOperands,
     /*  868518 */     // GIR_Coverage, 24907,
     /*  868518 */     GIR_EraseRootFromParent_Done,
     /*  868519 */   // Label 13318: @868519
     /*  868519 */   GIM_Try, /*On fail goto*//*Label 13319*/ GIMT_Encode4(868594), // Rule ID 24910 //
     /*  868524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  868535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  868538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  868541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868570 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  868573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868592 */     GIR_RootConstrainSelectedInstOperands,
     /*  868593 */     // GIR_Coverage, 24910,
     /*  868593 */     GIR_EraseRootFromParent_Done,
     /*  868594 */   // Label 13319: @868594
     /*  868594 */   GIM_Try, /*On fail goto*//*Label 13320*/ GIMT_Encode4(868669), // Rule ID 24911 //
     /*  868599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  868610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  868613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  868616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868645 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  868645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  868648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868667 */     GIR_RootConstrainSelectedInstOperands,
     /*  868668 */     // GIR_Coverage, 24911,
     /*  868668 */     GIR_EraseRootFromParent_Done,
     /*  868669 */   // Label 13320: @868669
     /*  868669 */   GIM_Try, /*On fail goto*//*Label 13321*/ GIMT_Encode4(868744), // Rule ID 24914 //
     /*  868674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  868685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  868688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  868691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868720 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  868723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868742 */     GIR_RootConstrainSelectedInstOperands,
     /*  868743 */     // GIR_Coverage, 24914,
     /*  868743 */     GIR_EraseRootFromParent_Done,
     /*  868744 */   // Label 13321: @868744
     /*  868744 */   GIM_Try, /*On fail goto*//*Label 13322*/ GIMT_Encode4(868819), // Rule ID 24915 //
     /*  868749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  868760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  868763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  868766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868795 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  868795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  868798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868817 */     GIR_RootConstrainSelectedInstOperands,
     /*  868818 */     // GIR_Coverage, 24915,
     /*  868818 */     GIR_EraseRootFromParent_Done,
     /*  868819 */   // Label 13322: @868819
     /*  868819 */   GIM_Try, /*On fail goto*//*Label 13323*/ GIMT_Encode4(868894), // Rule ID 24918 //
     /*  868824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  868835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  868838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  868841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868870 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  868870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  868873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868892 */     GIR_RootConstrainSelectedInstOperands,
     /*  868893 */     // GIR_Coverage, 24918,
     /*  868893 */     GIR_EraseRootFromParent_Done,
     /*  868894 */   // Label 13323: @868894
     /*  868894 */   GIM_Try, /*On fail goto*//*Label 13324*/ GIMT_Encode4(868969), // Rule ID 24919 //
     /*  868899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  868910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  868913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  868916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868945 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  868945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  868948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868967 */     GIR_RootConstrainSelectedInstOperands,
     /*  868968 */     // GIR_Coverage, 24919,
     /*  868968 */     GIR_EraseRootFromParent_Done,
     /*  868969 */   // Label 13324: @868969
     /*  868969 */   GIM_Try, /*On fail goto*//*Label 13325*/ GIMT_Encode4(869044), // Rule ID 24922 //
     /*  868974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  868985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  868988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  868991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869020 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869042 */     GIR_RootConstrainSelectedInstOperands,
     /*  869043 */     // GIR_Coverage, 24922,
     /*  869043 */     GIR_EraseRootFromParent_Done,
     /*  869044 */   // Label 13325: @869044
     /*  869044 */   GIM_Try, /*On fail goto*//*Label 13326*/ GIMT_Encode4(869119), // Rule ID 24923 //
     /*  869049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  869060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  869063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  869066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869095 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869117 */     GIR_RootConstrainSelectedInstOperands,
     /*  869118 */     // GIR_Coverage, 24923,
     /*  869118 */     GIR_EraseRootFromParent_Done,
     /*  869119 */   // Label 13326: @869119
     /*  869119 */   GIM_Try, /*On fail goto*//*Label 13327*/ GIMT_Encode4(869194), // Rule ID 24926 //
     /*  869124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  869135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  869138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  869141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869170 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869192 */     GIR_RootConstrainSelectedInstOperands,
     /*  869193 */     // GIR_Coverage, 24926,
     /*  869193 */     GIR_EraseRootFromParent_Done,
     /*  869194 */   // Label 13327: @869194
     /*  869194 */   GIM_Try, /*On fail goto*//*Label 13328*/ GIMT_Encode4(869269), // Rule ID 24927 //
     /*  869199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  869210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  869213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  869216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869245 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869267 */     GIR_RootConstrainSelectedInstOperands,
     /*  869268 */     // GIR_Coverage, 24927,
     /*  869268 */     GIR_EraseRootFromParent_Done,
     /*  869269 */   // Label 13328: @869269
     /*  869269 */   GIM_Try, /*On fail goto*//*Label 13329*/ GIMT_Encode4(869344), // Rule ID 24930 //
     /*  869274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  869277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  869285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  869288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  869291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869320 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  869320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869342 */     GIR_RootConstrainSelectedInstOperands,
     /*  869343 */     // GIR_Coverage, 24930,
     /*  869343 */     GIR_EraseRootFromParent_Done,
     /*  869344 */   // Label 13329: @869344
     /*  869344 */   GIM_Try, /*On fail goto*//*Label 13330*/ GIMT_Encode4(869419), // Rule ID 24931 //
     /*  869349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  869352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  869360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  869363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  869366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869395 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  869395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869417 */     GIR_RootConstrainSelectedInstOperands,
     /*  869418 */     // GIR_Coverage, 24931,
     /*  869418 */     GIR_EraseRootFromParent_Done,
     /*  869419 */   // Label 13330: @869419
     /*  869419 */   GIM_Try, /*On fail goto*//*Label 13331*/ GIMT_Encode4(869494), // Rule ID 24934 //
     /*  869424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  869435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  869438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  869441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869470 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  869473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869492 */     GIR_RootConstrainSelectedInstOperands,
     /*  869493 */     // GIR_Coverage, 24934,
     /*  869493 */     GIR_EraseRootFromParent_Done,
     /*  869494 */   // Label 13331: @869494
     /*  869494 */   GIM_Try, /*On fail goto*//*Label 13332*/ GIMT_Encode4(869569), // Rule ID 24935 //
     /*  869499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  869510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  869513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  869516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869545 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  869548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869567 */     GIR_RootConstrainSelectedInstOperands,
     /*  869568 */     // GIR_Coverage, 24935,
     /*  869568 */     GIR_EraseRootFromParent_Done,
     /*  869569 */   // Label 13332: @869569
     /*  869569 */   GIM_Try, /*On fail goto*//*Label 13333*/ GIMT_Encode4(869644), // Rule ID 24938 //
     /*  869574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  869585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  869588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  869591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869620 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  869623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869642 */     GIR_RootConstrainSelectedInstOperands,
     /*  869643 */     // GIR_Coverage, 24938,
     /*  869643 */     GIR_EraseRootFromParent_Done,
     /*  869644 */   // Label 13333: @869644
     /*  869644 */   GIM_Try, /*On fail goto*//*Label 13334*/ GIMT_Encode4(869719), // Rule ID 24939 //
     /*  869649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  869660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  869663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  869666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869695 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  869698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869717 */     GIR_RootConstrainSelectedInstOperands,
     /*  869718 */     // GIR_Coverage, 24939,
     /*  869718 */     GIR_EraseRootFromParent_Done,
     /*  869719 */   // Label 13334: @869719
     /*  869719 */   GIM_Try, /*On fail goto*//*Label 13335*/ GIMT_Encode4(869794), // Rule ID 24942 //
     /*  869724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  869735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  869738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  869741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869770 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  869773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869792 */     GIR_RootConstrainSelectedInstOperands,
     /*  869793 */     // GIR_Coverage, 24942,
     /*  869793 */     GIR_EraseRootFromParent_Done,
     /*  869794 */   // Label 13335: @869794
     /*  869794 */   GIM_Try, /*On fail goto*//*Label 13336*/ GIMT_Encode4(869869), // Rule ID 24943 //
     /*  869799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  869810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  869813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  869816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869845 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  869848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869867 */     GIR_RootConstrainSelectedInstOperands,
     /*  869868 */     // GIR_Coverage, 24943,
     /*  869868 */     GIR_EraseRootFromParent_Done,
     /*  869869 */   // Label 13336: @869869
     /*  869869 */   GIM_Try, /*On fail goto*//*Label 13337*/ GIMT_Encode4(869944), // Rule ID 24946 //
     /*  869874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  869885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  869888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  869891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869920 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  869923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869942 */     GIR_RootConstrainSelectedInstOperands,
     /*  869943 */     // GIR_Coverage, 24946,
     /*  869943 */     GIR_EraseRootFromParent_Done,
     /*  869944 */   // Label 13337: @869944
     /*  869944 */   GIM_Try, /*On fail goto*//*Label 13338*/ GIMT_Encode4(870019), // Rule ID 24947 //
     /*  869949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  869960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  869963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  869966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869995 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  869998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870017 */     GIR_RootConstrainSelectedInstOperands,
     /*  870018 */     // GIR_Coverage, 24947,
     /*  870018 */     GIR_EraseRootFromParent_Done,
     /*  870019 */   // Label 13338: @870019
     /*  870019 */   GIM_Try, /*On fail goto*//*Label 13339*/ GIMT_Encode4(870094), // Rule ID 24950 //
     /*  870024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  870035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  870038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  870041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870070 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870092 */     GIR_RootConstrainSelectedInstOperands,
     /*  870093 */     // GIR_Coverage, 24950,
     /*  870093 */     GIR_EraseRootFromParent_Done,
     /*  870094 */   // Label 13339: @870094
     /*  870094 */   GIM_Try, /*On fail goto*//*Label 13340*/ GIMT_Encode4(870169), // Rule ID 24951 //
     /*  870099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  870110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  870113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  870116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870145 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870167 */     GIR_RootConstrainSelectedInstOperands,
     /*  870168 */     // GIR_Coverage, 24951,
     /*  870168 */     GIR_EraseRootFromParent_Done,
     /*  870169 */   // Label 13340: @870169
     /*  870169 */   GIM_Try, /*On fail goto*//*Label 13341*/ GIMT_Encode4(870244), // Rule ID 24954 //
     /*  870174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  870185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  870188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  870191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870220 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870242 */     GIR_RootConstrainSelectedInstOperands,
     /*  870243 */     // GIR_Coverage, 24954,
     /*  870243 */     GIR_EraseRootFromParent_Done,
     /*  870244 */   // Label 13341: @870244
     /*  870244 */   GIM_Try, /*On fail goto*//*Label 13342*/ GIMT_Encode4(870319), // Rule ID 24955 //
     /*  870249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  870260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  870263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  870266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870295 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870317 */     GIR_RootConstrainSelectedInstOperands,
     /*  870318 */     // GIR_Coverage, 24955,
     /*  870318 */     GIR_EraseRootFromParent_Done,
     /*  870319 */   // Label 13342: @870319
     /*  870319 */   GIM_Try, /*On fail goto*//*Label 13343*/ GIMT_Encode4(870394), // Rule ID 24958 //
     /*  870324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  870327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  870335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  870338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  870341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870370 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870392 */     GIR_RootConstrainSelectedInstOperands,
     /*  870393 */     // GIR_Coverage, 24958,
     /*  870393 */     GIR_EraseRootFromParent_Done,
     /*  870394 */   // Label 13343: @870394
     /*  870394 */   GIM_Try, /*On fail goto*//*Label 13344*/ GIMT_Encode4(870469), // Rule ID 24959 //
     /*  870399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  870402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  870410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  870413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  870416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870445 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  870445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870467 */     GIR_RootConstrainSelectedInstOperands,
     /*  870468 */     // GIR_Coverage, 24959,
     /*  870468 */     GIR_EraseRootFromParent_Done,
     /*  870469 */   // Label 13344: @870469
     /*  870469 */   GIM_Try, /*On fail goto*//*Label 13345*/ GIMT_Encode4(870544), // Rule ID 24962 //
     /*  870474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  870477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  870485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  870488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  870491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870520 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870542 */     GIR_RootConstrainSelectedInstOperands,
     /*  870543 */     // GIR_Coverage, 24962,
     /*  870543 */     GIR_EraseRootFromParent_Done,
     /*  870544 */   // Label 13345: @870544
     /*  870544 */   GIM_Try, /*On fail goto*//*Label 13346*/ GIMT_Encode4(870619), // Rule ID 24963 //
     /*  870549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  870552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  870560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  870563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  870566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870595 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  870595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870617 */     GIR_RootConstrainSelectedInstOperands,
     /*  870618 */     // GIR_Coverage, 24963,
     /*  870618 */     GIR_EraseRootFromParent_Done,
     /*  870619 */   // Label 13346: @870619
     /*  870619 */   GIM_Try, /*On fail goto*//*Label 13347*/ GIMT_Encode4(870694), // Rule ID 24966 //
     /*  870624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  870627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  870635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  870638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  870641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870670 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870692 */     GIR_RootConstrainSelectedInstOperands,
     /*  870693 */     // GIR_Coverage, 24966,
     /*  870693 */     GIR_EraseRootFromParent_Done,
     /*  870694 */   // Label 13347: @870694
     /*  870694 */   GIM_Try, /*On fail goto*//*Label 13348*/ GIMT_Encode4(870769), // Rule ID 24967 //
     /*  870699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  870702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  870710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  870713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  870716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870745 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  870745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870767 */     GIR_RootConstrainSelectedInstOperands,
     /*  870768 */     // GIR_Coverage, 24967,
     /*  870768 */     GIR_EraseRootFromParent_Done,
     /*  870769 */   // Label 13348: @870769
     /*  870769 */   GIM_Try, /*On fail goto*//*Label 13349*/ GIMT_Encode4(870844), // Rule ID 25030 //
     /*  870774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  870785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  870788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  870791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  870794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870820 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  870820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  870823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870842 */     GIR_RootConstrainSelectedInstOperands,
     /*  870843 */     // GIR_Coverage, 25030,
     /*  870843 */     GIR_EraseRootFromParent_Done,
     /*  870844 */   // Label 13349: @870844
     /*  870844 */   GIM_Try, /*On fail goto*//*Label 13350*/ GIMT_Encode4(870919), // Rule ID 25031 //
     /*  870849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  870860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  870863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  870866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  870869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870895 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  870895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  870898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870917 */     GIR_RootConstrainSelectedInstOperands,
     /*  870918 */     // GIR_Coverage, 25031,
     /*  870918 */     GIR_EraseRootFromParent_Done,
     /*  870919 */   // Label 13350: @870919
     /*  870919 */   GIM_Try, /*On fail goto*//*Label 13351*/ GIMT_Encode4(870994), // Rule ID 25034 //
     /*  870924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  870935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  870938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  870941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  870944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870970 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  870970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  870973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870992 */     GIR_RootConstrainSelectedInstOperands,
     /*  870993 */     // GIR_Coverage, 25034,
     /*  870993 */     GIR_EraseRootFromParent_Done,
     /*  870994 */   // Label 13351: @870994
     /*  870994 */   GIM_Try, /*On fail goto*//*Label 13352*/ GIMT_Encode4(871069), // Rule ID 25035 //
     /*  870999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  871010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  871013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  871016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871045 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  871048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871067 */     GIR_RootConstrainSelectedInstOperands,
     /*  871068 */     // GIR_Coverage, 25035,
     /*  871068 */     GIR_EraseRootFromParent_Done,
     /*  871069 */   // Label 13352: @871069
     /*  871069 */   GIM_Try, /*On fail goto*//*Label 13353*/ GIMT_Encode4(871144), // Rule ID 25038 //
     /*  871074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  871085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  871088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  871091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871120 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  871123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871142 */     GIR_RootConstrainSelectedInstOperands,
     /*  871143 */     // GIR_Coverage, 25038,
     /*  871143 */     GIR_EraseRootFromParent_Done,
     /*  871144 */   // Label 13353: @871144
     /*  871144 */   GIM_Try, /*On fail goto*//*Label 13354*/ GIMT_Encode4(871219), // Rule ID 25039 //
     /*  871149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  871160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  871163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  871166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871195 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  871198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871217 */     GIR_RootConstrainSelectedInstOperands,
     /*  871218 */     // GIR_Coverage, 25039,
     /*  871218 */     GIR_EraseRootFromParent_Done,
     /*  871219 */   // Label 13354: @871219
     /*  871219 */   GIM_Try, /*On fail goto*//*Label 13355*/ GIMT_Encode4(871294), // Rule ID 25042 //
     /*  871224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  871235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  871238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  871241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  871244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871270 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11537:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  871273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871292 */     GIR_RootConstrainSelectedInstOperands,
     /*  871293 */     // GIR_Coverage, 25042,
     /*  871293 */     GIR_EraseRootFromParent_Done,
     /*  871294 */   // Label 13355: @871294
     /*  871294 */   GIM_Try, /*On fail goto*//*Label 13356*/ GIMT_Encode4(871369), // Rule ID 25043 //
     /*  871299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  871310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  871313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  871316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  871319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871345 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11537:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  871348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871367 */     GIR_RootConstrainSelectedInstOperands,
     /*  871368 */     // GIR_Coverage, 25043,
     /*  871368 */     GIR_EraseRootFromParent_Done,
     /*  871369 */   // Label 13356: @871369
     /*  871369 */   GIM_Try, /*On fail goto*//*Label 13357*/ GIMT_Encode4(871444), // Rule ID 25046 //
     /*  871374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  871385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  871388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  871391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871420 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  871423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871442 */     GIR_RootConstrainSelectedInstOperands,
     /*  871443 */     // GIR_Coverage, 25046,
     /*  871443 */     GIR_EraseRootFromParent_Done,
     /*  871444 */   // Label 13357: @871444
     /*  871444 */   GIM_Try, /*On fail goto*//*Label 13358*/ GIMT_Encode4(871519), // Rule ID 25047 //
     /*  871449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  871460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  871463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  871466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871495 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  871498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871517 */     GIR_RootConstrainSelectedInstOperands,
     /*  871518 */     // GIR_Coverage, 25047,
     /*  871518 */     GIR_EraseRootFromParent_Done,
     /*  871519 */   // Label 13358: @871519
     /*  871519 */   GIM_Try, /*On fail goto*//*Label 13359*/ GIMT_Encode4(871594), // Rule ID 25050 //
     /*  871524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  871527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  871535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  871538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  871541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871570 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  871570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  871573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871592 */     GIR_RootConstrainSelectedInstOperands,
     /*  871593 */     // GIR_Coverage, 25050,
     /*  871593 */     GIR_EraseRootFromParent_Done,
     /*  871594 */   // Label 13359: @871594
     /*  871594 */   GIM_Try, /*On fail goto*//*Label 13360*/ GIMT_Encode4(871669), // Rule ID 25051 //
     /*  871599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  871602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  871610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  871613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  871616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871645 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  871648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871667 */     GIR_RootConstrainSelectedInstOperands,
     /*  871668 */     // GIR_Coverage, 25051,
     /*  871668 */     GIR_EraseRootFromParent_Done,
     /*  871669 */   // Label 13360: @871669
     /*  871669 */   GIM_Try, /*On fail goto*//*Label 13361*/ GIMT_Encode4(871744), // Rule ID 25054 //
     /*  871674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  871685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  871688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  871691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  871694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871720 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  871723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871742 */     GIR_RootConstrainSelectedInstOperands,
     /*  871743 */     // GIR_Coverage, 25054,
     /*  871743 */     GIR_EraseRootFromParent_Done,
     /*  871744 */   // Label 13361: @871744
     /*  871744 */   GIM_Try, /*On fail goto*//*Label 13362*/ GIMT_Encode4(871819), // Rule ID 25055 //
     /*  871749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  871760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  871763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  871766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  871769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871795 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  871798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871817 */     GIR_RootConstrainSelectedInstOperands,
     /*  871818 */     // GIR_Coverage, 25055,
     /*  871818 */     GIR_EraseRootFromParent_Done,
     /*  871819 */   // Label 13362: @871819
     /*  871819 */   GIM_Try, /*On fail goto*//*Label 13363*/ GIMT_Encode4(871894), // Rule ID 25058 //
     /*  871824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  871835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  871838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  871841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  871844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871870 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  871873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871892 */     GIR_RootConstrainSelectedInstOperands,
     /*  871893 */     // GIR_Coverage, 25058,
     /*  871893 */     GIR_EraseRootFromParent_Done,
     /*  871894 */   // Label 13363: @871894
     /*  871894 */   GIM_Try, /*On fail goto*//*Label 13364*/ GIMT_Encode4(871969), // Rule ID 25059 //
     /*  871899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  871910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  871913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  871916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  871919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871945 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  871948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871967 */     GIR_RootConstrainSelectedInstOperands,
     /*  871968 */     // GIR_Coverage, 25059,
     /*  871968 */     GIR_EraseRootFromParent_Done,
     /*  871969 */   // Label 13364: @871969
     /*  871969 */   GIM_Try, /*On fail goto*//*Label 13365*/ GIMT_Encode4(872044), // Rule ID 25062 //
     /*  871974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  871985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  871988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  871991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  871994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872020 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  872020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  872023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872042 */     GIR_RootConstrainSelectedInstOperands,
     /*  872043 */     // GIR_Coverage, 25062,
     /*  872043 */     GIR_EraseRootFromParent_Done,
     /*  872044 */   // Label 13365: @872044
     /*  872044 */   GIM_Try, /*On fail goto*//*Label 13366*/ GIMT_Encode4(872119), // Rule ID 25063 //
     /*  872049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  872060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  872063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  872066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  872069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872095 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  872095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  872098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872117 */     GIR_RootConstrainSelectedInstOperands,
     /*  872118 */     // GIR_Coverage, 25063,
     /*  872118 */     GIR_EraseRootFromParent_Done,
     /*  872119 */   // Label 13366: @872119
     /*  872119 */   GIM_Try, /*On fail goto*//*Label 13367*/ GIMT_Encode4(872194), // Rule ID 25066 //
     /*  872124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  872135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  872138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  872141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872170 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  872173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872192 */     GIR_RootConstrainSelectedInstOperands,
     /*  872193 */     // GIR_Coverage, 25066,
     /*  872193 */     GIR_EraseRootFromParent_Done,
     /*  872194 */   // Label 13367: @872194
     /*  872194 */   GIM_Try, /*On fail goto*//*Label 13368*/ GIMT_Encode4(872269), // Rule ID 25067 //
     /*  872199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  872210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  872213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  872216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872245 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  872248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872267 */     GIR_RootConstrainSelectedInstOperands,
     /*  872268 */     // GIR_Coverage, 25067,
     /*  872268 */     GIR_EraseRootFromParent_Done,
     /*  872269 */   // Label 13368: @872269
     /*  872269 */   GIM_Try, /*On fail goto*//*Label 13369*/ GIMT_Encode4(872344), // Rule ID 25070 //
     /*  872274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  872285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  872288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872320 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  872323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872342 */     GIR_RootConstrainSelectedInstOperands,
     /*  872343 */     // GIR_Coverage, 25070,
     /*  872343 */     GIR_EraseRootFromParent_Done,
     /*  872344 */   // Label 13369: @872344
     /*  872344 */   GIM_Try, /*On fail goto*//*Label 13370*/ GIMT_Encode4(872419), // Rule ID 25071 //
     /*  872349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  872360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  872363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872395 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  872398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872417 */     GIR_RootConstrainSelectedInstOperands,
     /*  872418 */     // GIR_Coverage, 25071,
     /*  872418 */     GIR_EraseRootFromParent_Done,
     /*  872419 */   // Label 13370: @872419
     /*  872419 */   GIM_Try, /*On fail goto*//*Label 13371*/ GIMT_Encode4(872494), // Rule ID 25074 //
     /*  872424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  872435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  872438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  872444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872470 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  872473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872492 */     GIR_RootConstrainSelectedInstOperands,
     /*  872493 */     // GIR_Coverage, 25074,
     /*  872493 */     GIR_EraseRootFromParent_Done,
     /*  872494 */   // Label 13371: @872494
     /*  872494 */   GIM_Try, /*On fail goto*//*Label 13372*/ GIMT_Encode4(872569), // Rule ID 25075 //
     /*  872499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  872510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  872513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  872519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872545 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  872548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872567 */     GIR_RootConstrainSelectedInstOperands,
     /*  872568 */     // GIR_Coverage, 25075,
     /*  872568 */     GIR_EraseRootFromParent_Done,
     /*  872569 */   // Label 13372: @872569
     /*  872569 */   GIM_Try, /*On fail goto*//*Label 13373*/ GIMT_Encode4(872644), // Rule ID 25078 //
     /*  872574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  872577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  872585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  872588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  872591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  872594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872620 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  872623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872642 */     GIR_RootConstrainSelectedInstOperands,
     /*  872643 */     // GIR_Coverage, 25078,
     /*  872643 */     GIR_EraseRootFromParent_Done,
     /*  872644 */   // Label 13373: @872644
     /*  872644 */   GIM_Try, /*On fail goto*//*Label 13374*/ GIMT_Encode4(872719), // Rule ID 25079 //
     /*  872649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  872652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  872660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  872663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  872666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  872669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872695 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  872698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872717 */     GIR_RootConstrainSelectedInstOperands,
     /*  872718 */     // GIR_Coverage, 25079,
     /*  872718 */     GIR_EraseRootFromParent_Done,
     /*  872719 */   // Label 13374: @872719
     /*  872719 */   GIM_Try, /*On fail goto*//*Label 13375*/ GIMT_Encode4(872794), // Rule ID 25082 //
     /*  872724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  872727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  872735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  872738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  872741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872770 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  872773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872792 */     GIR_RootConstrainSelectedInstOperands,
     /*  872793 */     // GIR_Coverage, 25082,
     /*  872793 */     GIR_EraseRootFromParent_Done,
     /*  872794 */   // Label 13375: @872794
     /*  872794 */   GIM_Try, /*On fail goto*//*Label 13376*/ GIMT_Encode4(872869), // Rule ID 25083 //
     /*  872799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  872802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  872810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  872813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  872816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872845 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  872848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872867 */     GIR_RootConstrainSelectedInstOperands,
     /*  872868 */     // GIR_Coverage, 25083,
     /*  872868 */     GIR_EraseRootFromParent_Done,
     /*  872869 */   // Label 13376: @872869
     /*  872869 */   GIM_Try, /*On fail goto*//*Label 13377*/ GIMT_Encode4(872944), // Rule ID 25086 //
     /*  872874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  872877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  872885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  872888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  872891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872920 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  872923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872942 */     GIR_RootConstrainSelectedInstOperands,
     /*  872943 */     // GIR_Coverage, 25086,
     /*  872943 */     GIR_EraseRootFromParent_Done,
     /*  872944 */   // Label 13377: @872944
     /*  872944 */   GIM_Try, /*On fail goto*//*Label 13378*/ GIMT_Encode4(873019), // Rule ID 25087 //
     /*  872949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  872952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  872960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  872963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  872966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872995 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  872998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873017 */     GIR_RootConstrainSelectedInstOperands,
     /*  873018 */     // GIR_Coverage, 25087,
     /*  873018 */     GIR_EraseRootFromParent_Done,
     /*  873019 */   // Label 13378: @873019
     /*  873019 */   GIM_Try, /*On fail goto*//*Label 13379*/ GIMT_Encode4(873091), // Rule ID 25090 //
     /*  873024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  873035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  873038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  873041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873070 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  873070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  873073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873089 */     GIR_RootConstrainSelectedInstOperands,
     /*  873090 */     // GIR_Coverage, 25090,
     /*  873090 */     GIR_EraseRootFromParent_Done,
     /*  873091 */   // Label 13379: @873091
     /*  873091 */   GIM_Try, /*On fail goto*//*Label 13380*/ GIMT_Encode4(873163), // Rule ID 25091 //
     /*  873096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  873107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  873110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  873113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873142 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  873142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  873145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873161 */     GIR_RootConstrainSelectedInstOperands,
     /*  873162 */     // GIR_Coverage, 25091,
     /*  873162 */     GIR_EraseRootFromParent_Done,
     /*  873163 */   // Label 13380: @873163
     /*  873163 */   GIM_Try, /*On fail goto*//*Label 13381*/ GIMT_Encode4(873235), // Rule ID 25092 //
     /*  873168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  873179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  873182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  873185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873214 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  873214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  873217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873233 */     GIR_RootConstrainSelectedInstOperands,
     /*  873234 */     // GIR_Coverage, 25092,
     /*  873234 */     GIR_EraseRootFromParent_Done,
     /*  873235 */   // Label 13381: @873235
     /*  873235 */   GIM_Try, /*On fail goto*//*Label 13382*/ GIMT_Encode4(873307), // Rule ID 25093 //
     /*  873240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  873251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  873254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  873257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873286 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  873286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  873289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873305 */     GIR_RootConstrainSelectedInstOperands,
     /*  873306 */     // GIR_Coverage, 25093,
     /*  873306 */     GIR_EraseRootFromParent_Done,
     /*  873307 */   // Label 13382: @873307
     /*  873307 */   GIM_Try, /*On fail goto*//*Label 13383*/ GIMT_Encode4(873379), // Rule ID 25094 //
     /*  873312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  873323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  873326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  873329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873358 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  873358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  873361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873377 */     GIR_RootConstrainSelectedInstOperands,
     /*  873378 */     // GIR_Coverage, 25094,
     /*  873378 */     GIR_EraseRootFromParent_Done,
     /*  873379 */   // Label 13383: @873379
     /*  873379 */   GIM_Try, /*On fail goto*//*Label 13384*/ GIMT_Encode4(873451), // Rule ID 25095 //
     /*  873384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  873395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  873398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  873401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873430 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  873430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  873433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873449 */     GIR_RootConstrainSelectedInstOperands,
     /*  873450 */     // GIR_Coverage, 25095,
     /*  873450 */     GIR_EraseRootFromParent_Done,
     /*  873451 */   // Label 13384: @873451
     /*  873451 */   GIM_Try, /*On fail goto*//*Label 13385*/ GIMT_Encode4(873523), // Rule ID 25096 //
     /*  873456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873502 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  873502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  873505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873521 */     GIR_RootConstrainSelectedInstOperands,
     /*  873522 */     // GIR_Coverage, 25096,
     /*  873522 */     GIR_EraseRootFromParent_Done,
     /*  873523 */   // Label 13385: @873523
     /*  873523 */   GIM_Try, /*On fail goto*//*Label 13386*/ GIMT_Encode4(873595), // Rule ID 25097 //
     /*  873528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873574 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  873574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  873577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873593 */     GIR_RootConstrainSelectedInstOperands,
     /*  873594 */     // GIR_Coverage, 25097,
     /*  873594 */     GIR_EraseRootFromParent_Done,
     /*  873595 */   // Label 13386: @873595
     /*  873595 */   GIM_Try, /*On fail goto*//*Label 13387*/ GIMT_Encode4(873667), // Rule ID 25098 //
     /*  873600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  873611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  873614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  873617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  873646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  873649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  873665 */     GIR_RootConstrainSelectedInstOperands,
     /*  873666 */     // GIR_Coverage, 25098,
     /*  873666 */     GIR_EraseRootFromParent_Done,
     /*  873667 */   // Label 13387: @873667
     /*  873667 */   GIM_Try, /*On fail goto*//*Label 13388*/ GIMT_Encode4(873739), // Rule ID 25099 //
     /*  873672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  873683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  873686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  873689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873718 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  873718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  873721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  873737 */     GIR_RootConstrainSelectedInstOperands,
     /*  873738 */     // GIR_Coverage, 25099,
     /*  873738 */     GIR_EraseRootFromParent_Done,
     /*  873739 */   // Label 13388: @873739
     /*  873739 */   GIM_Try, /*On fail goto*//*Label 13389*/ GIMT_Encode4(873811), // Rule ID 25100 //
     /*  873744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  873755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  873758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  873761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  873764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873790 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  873790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  873793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873809 */     GIR_RootConstrainSelectedInstOperands,
     /*  873810 */     // GIR_Coverage, 25100,
     /*  873810 */     GIR_EraseRootFromParent_Done,
     /*  873811 */   // Label 13389: @873811
     /*  873811 */   GIM_Try, /*On fail goto*//*Label 13390*/ GIMT_Encode4(873883), // Rule ID 25101 //
     /*  873816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  873827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  873830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  873833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  873836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873862 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  873862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  873865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873881 */     GIR_RootConstrainSelectedInstOperands,
     /*  873882 */     // GIR_Coverage, 25101,
     /*  873882 */     GIR_EraseRootFromParent_Done,
     /*  873883 */   // Label 13390: @873883
     /*  873883 */   GIM_Try, /*On fail goto*//*Label 13391*/ GIMT_Encode4(873955), // Rule ID 25102 //
     /*  873888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  873899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  873902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  873905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873934 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  873934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  873937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873953 */     GIR_RootConstrainSelectedInstOperands,
     /*  873954 */     // GIR_Coverage, 25102,
     /*  873954 */     GIR_EraseRootFromParent_Done,
     /*  873955 */   // Label 13391: @873955
     /*  873955 */   GIM_Try, /*On fail goto*//*Label 13392*/ GIMT_Encode4(874027), // Rule ID 25103 //
     /*  873960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  873971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  873974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  873977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874006 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  874006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  874009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874025 */     GIR_RootConstrainSelectedInstOperands,
     /*  874026 */     // GIR_Coverage, 25103,
     /*  874026 */     GIR_EraseRootFromParent_Done,
     /*  874027 */   // Label 13392: @874027
     /*  874027 */   GIM_Try, /*On fail goto*//*Label 13393*/ GIMT_Encode4(874099), // Rule ID 25104 //
     /*  874032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  874043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  874046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  874049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  874052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874078 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  874078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  874081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874097 */     GIR_RootConstrainSelectedInstOperands,
     /*  874098 */     // GIR_Coverage, 25104,
     /*  874098 */     GIR_EraseRootFromParent_Done,
     /*  874099 */   // Label 13393: @874099
     /*  874099 */   GIM_Try, /*On fail goto*//*Label 13394*/ GIMT_Encode4(874171), // Rule ID 25105 //
     /*  874104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  874115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  874118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  874121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  874124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  874150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  874153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874169 */     GIR_RootConstrainSelectedInstOperands,
     /*  874170 */     // GIR_Coverage, 25105,
     /*  874170 */     GIR_EraseRootFromParent_Done,
     /*  874171 */   // Label 13394: @874171
     /*  874171 */   GIM_Try, /*On fail goto*//*Label 13395*/ GIMT_Encode4(874243), // Rule ID 25106 //
     /*  874176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  874179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  874187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  874190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  874193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  874196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874222 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  874222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  874225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  874241 */     GIR_RootConstrainSelectedInstOperands,
     /*  874242 */     // GIR_Coverage, 25106,
     /*  874242 */     GIR_EraseRootFromParent_Done,
     /*  874243 */   // Label 13395: @874243
     /*  874243 */   GIM_Try, /*On fail goto*//*Label 13396*/ GIMT_Encode4(874315), // Rule ID 25107 //
     /*  874248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  874251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  874259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  874262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  874265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  874268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874294 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  874294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  874297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  874313 */     GIR_RootConstrainSelectedInstOperands,
     /*  874314 */     // GIR_Coverage, 25107,
     /*  874314 */     GIR_EraseRootFromParent_Done,
     /*  874315 */   // Label 13396: @874315
     /*  874315 */   GIM_Try, /*On fail goto*//*Label 13397*/ GIMT_Encode4(874387), // Rule ID 25108 //
     /*  874320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  874331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  874334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  874337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874366 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  874366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  874369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874385 */     GIR_RootConstrainSelectedInstOperands,
     /*  874386 */     // GIR_Coverage, 25108,
     /*  874386 */     GIR_EraseRootFromParent_Done,
     /*  874387 */   // Label 13397: @874387
     /*  874387 */   GIM_Try, /*On fail goto*//*Label 13398*/ GIMT_Encode4(874459), // Rule ID 25109 //
     /*  874392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  874403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  874406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  874409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874438 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  874438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  874441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874457 */     GIR_RootConstrainSelectedInstOperands,
     /*  874458 */     // GIR_Coverage, 25109,
     /*  874458 */     GIR_EraseRootFromParent_Done,
     /*  874459 */   // Label 13398: @874459
     /*  874459 */   GIM_Try, /*On fail goto*//*Label 13399*/ GIMT_Encode4(874531), // Rule ID 25110 //
     /*  874464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  874475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  874478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  874481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  874484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874510 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  874510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  874513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874529 */     GIR_RootConstrainSelectedInstOperands,
     /*  874530 */     // GIR_Coverage, 25110,
     /*  874530 */     GIR_EraseRootFromParent_Done,
     /*  874531 */   // Label 13399: @874531
     /*  874531 */   GIM_Try, /*On fail goto*//*Label 13400*/ GIMT_Encode4(874603), // Rule ID 25111 //
     /*  874536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  874547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  874550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  874553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  874556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874582 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  874582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  874585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874601 */     GIR_RootConstrainSelectedInstOperands,
     /*  874602 */     // GIR_Coverage, 25111,
     /*  874602 */     GIR_EraseRootFromParent_Done,
     /*  874603 */   // Label 13400: @874603
     /*  874603 */   GIM_Try, /*On fail goto*//*Label 13401*/ GIMT_Encode4(874675), // Rule ID 25112 //
     /*  874608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  874619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  874622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  874625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  874628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874654 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  874654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  874657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874673 */     GIR_RootConstrainSelectedInstOperands,
     /*  874674 */     // GIR_Coverage, 25112,
     /*  874674 */     GIR_EraseRootFromParent_Done,
     /*  874675 */   // Label 13401: @874675
     /*  874675 */   GIM_Try, /*On fail goto*//*Label 13402*/ GIMT_Encode4(874747), // Rule ID 25113 //
     /*  874680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  874691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  874694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  874697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  874700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874726 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  874726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  874729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874745 */     GIR_RootConstrainSelectedInstOperands,
     /*  874746 */     // GIR_Coverage, 25113,
     /*  874746 */     GIR_EraseRootFromParent_Done,
     /*  874747 */   // Label 13402: @874747
     /*  874747 */   GIM_Try, /*On fail goto*//*Label 13403*/ GIMT_Encode4(874819), // Rule ID 25114 //
     /*  874752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  874763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  874766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  874769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  874772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  874798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  874801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874817 */     GIR_RootConstrainSelectedInstOperands,
     /*  874818 */     // GIR_Coverage, 25114,
     /*  874818 */     GIR_EraseRootFromParent_Done,
     /*  874819 */   // Label 13403: @874819
     /*  874819 */   GIM_Try, /*On fail goto*//*Label 13404*/ GIMT_Encode4(874891), // Rule ID 25115 //
     /*  874824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  874835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  874838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  874841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  874844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874870 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  874870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  874873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874889 */     GIR_RootConstrainSelectedInstOperands,
     /*  874890 */     // GIR_Coverage, 25115,
     /*  874890 */     GIR_EraseRootFromParent_Done,
     /*  874891 */   // Label 13404: @874891
     /*  874891 */   GIM_Try, /*On fail goto*//*Label 13405*/ GIMT_Encode4(874963), // Rule ID 25116 //
     /*  874896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  874907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  874910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  874913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874942 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  874942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  874945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874961 */     GIR_RootConstrainSelectedInstOperands,
     /*  874962 */     // GIR_Coverage, 25116,
     /*  874962 */     GIR_EraseRootFromParent_Done,
     /*  874963 */   // Label 13405: @874963
     /*  874963 */   GIM_Try, /*On fail goto*//*Label 13406*/ GIMT_Encode4(875035), // Rule ID 25117 //
     /*  874968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  874979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  874982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  874985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875014 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  875014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  875017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875033 */     GIR_RootConstrainSelectedInstOperands,
     /*  875034 */     // GIR_Coverage, 25117,
     /*  875034 */     GIR_EraseRootFromParent_Done,
     /*  875035 */   // Label 13406: @875035
     /*  875035 */   GIM_Try, /*On fail goto*//*Label 13407*/ GIMT_Encode4(875107), // Rule ID 25118 //
     /*  875040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  875051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  875054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  875057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  875060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875086 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  875086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  875089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875105 */     GIR_RootConstrainSelectedInstOperands,
     /*  875106 */     // GIR_Coverage, 25118,
     /*  875106 */     GIR_EraseRootFromParent_Done,
     /*  875107 */   // Label 13407: @875107
     /*  875107 */   GIM_Try, /*On fail goto*//*Label 13408*/ GIMT_Encode4(875179), // Rule ID 25119 //
     /*  875112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  875123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  875126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  875129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  875132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875158 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  875158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  875161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875177 */     GIR_RootConstrainSelectedInstOperands,
     /*  875178 */     // GIR_Coverage, 25119,
     /*  875178 */     GIR_EraseRootFromParent_Done,
     /*  875179 */   // Label 13408: @875179
     /*  875179 */   GIM_Try, /*On fail goto*//*Label 13409*/ GIMT_Encode4(875251), // Rule ID 25120 //
     /*  875184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  875195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  875198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  875201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  875233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875249 */     GIR_RootConstrainSelectedInstOperands,
     /*  875250 */     // GIR_Coverage, 25120,
     /*  875250 */     GIR_EraseRootFromParent_Done,
     /*  875251 */   // Label 13409: @875251
     /*  875251 */   GIM_Try, /*On fail goto*//*Label 13410*/ GIMT_Encode4(875323), // Rule ID 25121 //
     /*  875256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  875267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  875270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  875273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  875302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  875305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875321 */     GIR_RootConstrainSelectedInstOperands,
     /*  875322 */     // GIR_Coverage, 25121,
     /*  875322 */     GIR_EraseRootFromParent_Done,
     /*  875323 */   // Label 13410: @875323
     /*  875323 */   GIM_Try, /*On fail goto*//*Label 13411*/ GIMT_Encode4(875395), // Rule ID 25122 //
     /*  875328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  875339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  875342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  875345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875374 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  875377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875393 */     GIR_RootConstrainSelectedInstOperands,
     /*  875394 */     // GIR_Coverage, 25122,
     /*  875394 */     GIR_EraseRootFromParent_Done,
     /*  875395 */   // Label 13411: @875395
     /*  875395 */   GIM_Try, /*On fail goto*//*Label 13412*/ GIMT_Encode4(875467), // Rule ID 25123 //
     /*  875400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  875411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  875414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  875417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  875446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  875449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875465 */     GIR_RootConstrainSelectedInstOperands,
     /*  875466 */     // GIR_Coverage, 25123,
     /*  875466 */     GIR_EraseRootFromParent_Done,
     /*  875467 */   // Label 13412: @875467
     /*  875467 */   GIM_Try, /*On fail goto*//*Label 13413*/ GIMT_Encode4(875539), // Rule ID 25124 //
     /*  875472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  875483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  875486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  875489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  875492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  875521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875537 */     GIR_RootConstrainSelectedInstOperands,
     /*  875538 */     // GIR_Coverage, 25124,
     /*  875538 */     GIR_EraseRootFromParent_Done,
     /*  875539 */   // Label 13413: @875539
     /*  875539 */   GIM_Try, /*On fail goto*//*Label 13414*/ GIMT_Encode4(875611), // Rule ID 25125 //
     /*  875544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  875555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  875558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  875561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  875564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875590 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  875590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  875593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875609 */     GIR_RootConstrainSelectedInstOperands,
     /*  875610 */     // GIR_Coverage, 25125,
     /*  875610 */     GIR_EraseRootFromParent_Done,
     /*  875611 */   // Label 13414: @875611
     /*  875611 */   GIM_Try, /*On fail goto*//*Label 13415*/ GIMT_Encode4(875683), // Rule ID 25126 //
     /*  875616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  875619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  875627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  875630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  875633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  875636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875662 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  875662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  875665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875681 */     GIR_RootConstrainSelectedInstOperands,
     /*  875682 */     // GIR_Coverage, 25126,
     /*  875682 */     GIR_EraseRootFromParent_Done,
     /*  875683 */   // Label 13415: @875683
     /*  875683 */   GIM_Try, /*On fail goto*//*Label 13416*/ GIMT_Encode4(875755), // Rule ID 25127 //
     /*  875688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  875691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  875699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  875702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  875705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  875708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875734 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  875734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  875737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875753 */     GIR_RootConstrainSelectedInstOperands,
     /*  875754 */     // GIR_Coverage, 25127,
     /*  875754 */     GIR_EraseRootFromParent_Done,
     /*  875755 */   // Label 13416: @875755
     /*  875755 */   GIM_Try, /*On fail goto*//*Label 13417*/ GIMT_Encode4(875827), // Rule ID 25128 //
     /*  875760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  875763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  875771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  875774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  875777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875806 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  875806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  875809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875825 */     GIR_RootConstrainSelectedInstOperands,
     /*  875826 */     // GIR_Coverage, 25128,
     /*  875826 */     GIR_EraseRootFromParent_Done,
     /*  875827 */   // Label 13417: @875827
     /*  875827 */   GIM_Try, /*On fail goto*//*Label 13418*/ GIMT_Encode4(875899), // Rule ID 25129 //
     /*  875832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  875835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  875843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  875846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  875849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875878 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  875878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  875881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875897 */     GIR_RootConstrainSelectedInstOperands,
     /*  875898 */     // GIR_Coverage, 25129,
     /*  875898 */     GIR_EraseRootFromParent_Done,
     /*  875899 */   // Label 13418: @875899
     /*  875899 */   GIM_Try, /*On fail goto*//*Label 13419*/ GIMT_Encode4(875971), // Rule ID 25130 //
     /*  875904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  875907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  875915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  875918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  875921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875950 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  875950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  875953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875969 */     GIR_RootConstrainSelectedInstOperands,
     /*  875970 */     // GIR_Coverage, 25130,
     /*  875970 */     GIR_EraseRootFromParent_Done,
     /*  875971 */   // Label 13419: @875971
     /*  875971 */   GIM_Try, /*On fail goto*//*Label 13420*/ GIMT_Encode4(876043), // Rule ID 25131 //
     /*  875976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  875979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  875987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  875990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  875993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876022 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  876022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  876025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876041 */     GIR_RootConstrainSelectedInstOperands,
     /*  876042 */     // GIR_Coverage, 25131,
     /*  876042 */     GIR_EraseRootFromParent_Done,
     /*  876043 */   // Label 13420: @876043
     /*  876043 */   GIM_Try, /*On fail goto*//*Label 13421*/ GIMT_Encode4(876115), // Rule ID 25132 //
     /*  876048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  876059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  876062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  876065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876094 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  876097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876113 */     GIR_RootConstrainSelectedInstOperands,
     /*  876114 */     // GIR_Coverage, 25132,
     /*  876114 */     GIR_EraseRootFromParent_Done,
     /*  876115 */   // Label 13421: @876115
     /*  876115 */   GIM_Try, /*On fail goto*//*Label 13422*/ GIMT_Encode4(876187), // Rule ID 25133 //
     /*  876120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  876131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  876134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  876137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876166 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  876166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  876169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876185 */     GIR_RootConstrainSelectedInstOperands,
     /*  876186 */     // GIR_Coverage, 25133,
     /*  876186 */     GIR_EraseRootFromParent_Done,
     /*  876187 */   // Label 13422: @876187
     /*  876187 */   GIM_Try, /*On fail goto*//*Label 13423*/ GIMT_Encode4(876259), // Rule ID 25134 //
     /*  876192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  876203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  876206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  876209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876238 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  876241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876257 */     GIR_RootConstrainSelectedInstOperands,
     /*  876258 */     // GIR_Coverage, 25134,
     /*  876258 */     GIR_EraseRootFromParent_Done,
     /*  876259 */   // Label 13423: @876259
     /*  876259 */   GIM_Try, /*On fail goto*//*Label 13424*/ GIMT_Encode4(876331), // Rule ID 25135 //
     /*  876264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  876275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  876278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  876281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876310 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  876310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  876313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876329 */     GIR_RootConstrainSelectedInstOperands,
     /*  876330 */     // GIR_Coverage, 25135,
     /*  876330 */     GIR_EraseRootFromParent_Done,
     /*  876331 */   // Label 13424: @876331
     /*  876331 */   GIM_Try, /*On fail goto*//*Label 13425*/ GIMT_Encode4(876403), // Rule ID 25136 //
     /*  876336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  876347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  876350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  876353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876382 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  876382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  876385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876401 */     GIR_RootConstrainSelectedInstOperands,
     /*  876402 */     // GIR_Coverage, 25136,
     /*  876402 */     GIR_EraseRootFromParent_Done,
     /*  876403 */   // Label 13425: @876403
     /*  876403 */   GIM_Try, /*On fail goto*//*Label 13426*/ GIMT_Encode4(876475), // Rule ID 25137 //
     /*  876408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  876419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  876422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  876425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876454 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  876454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  876457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876473 */     GIR_RootConstrainSelectedInstOperands,
     /*  876474 */     // GIR_Coverage, 25137,
     /*  876474 */     GIR_EraseRootFromParent_Done,
     /*  876475 */   // Label 13426: @876475
     /*  876475 */   GIM_Try, /*On fail goto*//*Label 13427*/ GIMT_Encode4(876547), // Rule ID 25138 //
     /*  876480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  876491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  876494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  876497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  876500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876526 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  876529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876545 */     GIR_RootConstrainSelectedInstOperands,
     /*  876546 */     // GIR_Coverage, 25138,
     /*  876546 */     GIR_EraseRootFromParent_Done,
     /*  876547 */   // Label 13427: @876547
     /*  876547 */   GIM_Try, /*On fail goto*//*Label 13428*/ GIMT_Encode4(876619), // Rule ID 25139 //
     /*  876552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  876563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  876566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  876569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  876572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876598 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  876598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  876601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876617 */     GIR_RootConstrainSelectedInstOperands,
     /*  876618 */     // GIR_Coverage, 25139,
     /*  876618 */     GIR_EraseRootFromParent_Done,
     /*  876619 */   // Label 13428: @876619
     /*  876619 */   GIM_Try, /*On fail goto*//*Label 13429*/ GIMT_Encode4(876691), // Rule ID 25140 //
     /*  876624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  876635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  876638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  876641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876670 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  876670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  876673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876689 */     GIR_RootConstrainSelectedInstOperands,
     /*  876690 */     // GIR_Coverage, 25140,
     /*  876690 */     GIR_EraseRootFromParent_Done,
     /*  876691 */   // Label 13429: @876691
     /*  876691 */   GIM_Try, /*On fail goto*//*Label 13430*/ GIMT_Encode4(876763), // Rule ID 25141 //
     /*  876696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  876707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  876710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  876713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876742 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  876742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  876745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876761 */     GIR_RootConstrainSelectedInstOperands,
     /*  876762 */     // GIR_Coverage, 25141,
     /*  876762 */     GIR_EraseRootFromParent_Done,
     /*  876763 */   // Label 13430: @876763
     /*  876763 */   GIM_Try, /*On fail goto*//*Label 13431*/ GIMT_Encode4(876835), // Rule ID 25142 //
     /*  876768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  876771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  876779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  876782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  876785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876814 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  876814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  876817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876833 */     GIR_RootConstrainSelectedInstOperands,
     /*  876834 */     // GIR_Coverage, 25142,
     /*  876834 */     GIR_EraseRootFromParent_Done,
     /*  876835 */   // Label 13431: @876835
     /*  876835 */   GIM_Try, /*On fail goto*//*Label 13432*/ GIMT_Encode4(876907), // Rule ID 25143 //
     /*  876840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  876843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  876851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  876854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  876857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876886 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  876886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  876889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876905 */     GIR_RootConstrainSelectedInstOperands,
     /*  876906 */     // GIR_Coverage, 25143,
     /*  876906 */     GIR_EraseRootFromParent_Done,
     /*  876907 */   // Label 13432: @876907
     /*  876907 */   GIM_Try, /*On fail goto*//*Label 13433*/ GIMT_Encode4(876979), // Rule ID 25144 //
     /*  876912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  876923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  876926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  876929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  876932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876958 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  876961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876977 */     GIR_RootConstrainSelectedInstOperands,
     /*  876978 */     // GIR_Coverage, 25144,
     /*  876978 */     GIR_EraseRootFromParent_Done,
     /*  876979 */   // Label 13433: @876979
     /*  876979 */   GIM_Try, /*On fail goto*//*Label 13434*/ GIMT_Encode4(877051), // Rule ID 25145 //
     /*  876984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  876995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  876998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  877001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877030 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  877033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877049 */     GIR_RootConstrainSelectedInstOperands,
     /*  877050 */     // GIR_Coverage, 25145,
     /*  877050 */     GIR_EraseRootFromParent_Done,
     /*  877051 */   // Label 13434: @877051
     /*  877051 */   GIM_Try, /*On fail goto*//*Label 13435*/ GIMT_Encode4(877123), // Rule ID 25146 //
     /*  877056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  877067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  877070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  877073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877102 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  877105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877121 */     GIR_RootConstrainSelectedInstOperands,
     /*  877122 */     // GIR_Coverage, 25146,
     /*  877122 */     GIR_EraseRootFromParent_Done,
     /*  877123 */   // Label 13435: @877123
     /*  877123 */   GIM_Try, /*On fail goto*//*Label 13436*/ GIMT_Encode4(877195), // Rule ID 25147 //
     /*  877128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  877139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  877142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  877145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877174 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  877177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877193 */     GIR_RootConstrainSelectedInstOperands,
     /*  877194 */     // GIR_Coverage, 25147,
     /*  877194 */     GIR_EraseRootFromParent_Done,
     /*  877195 */   // Label 13436: @877195
     /*  877195 */   GIM_Try, /*On fail goto*//*Label 13437*/ GIMT_Encode4(877267), // Rule ID 25148 //
     /*  877200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  877211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  877214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  877217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  877220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877246 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  877249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877265 */     GIR_RootConstrainSelectedInstOperands,
     /*  877266 */     // GIR_Coverage, 25148,
     /*  877266 */     GIR_EraseRootFromParent_Done,
     /*  877267 */   // Label 13437: @877267
     /*  877267 */   GIM_Try, /*On fail goto*//*Label 13438*/ GIMT_Encode4(877339), // Rule ID 25149 //
     /*  877272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  877283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  877286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  877289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  877292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877318 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  877321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877337 */     GIR_RootConstrainSelectedInstOperands,
     /*  877338 */     // GIR_Coverage, 25149,
     /*  877338 */     GIR_EraseRootFromParent_Done,
     /*  877339 */   // Label 13438: @877339
     /*  877339 */   GIM_Try, /*On fail goto*//*Label 13439*/ GIMT_Encode4(877411), // Rule ID 25150 //
     /*  877344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  877355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  877358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  877361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877390 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  877393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877409 */     GIR_RootConstrainSelectedInstOperands,
     /*  877410 */     // GIR_Coverage, 25150,
     /*  877410 */     GIR_EraseRootFromParent_Done,
     /*  877411 */   // Label 13439: @877411
     /*  877411 */   GIM_Try, /*On fail goto*//*Label 13440*/ GIMT_Encode4(877483), // Rule ID 25151 //
     /*  877416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  877427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  877430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  877433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877462 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  877465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877481 */     GIR_RootConstrainSelectedInstOperands,
     /*  877482 */     // GIR_Coverage, 25151,
     /*  877482 */     GIR_EraseRootFromParent_Done,
     /*  877483 */   // Label 13440: @877483
     /*  877483 */   GIM_Try, /*On fail goto*//*Label 13441*/ GIMT_Encode4(877555), // Rule ID 25152 //
     /*  877488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  877499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  877502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  877505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877534 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  877537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877553 */     GIR_RootConstrainSelectedInstOperands,
     /*  877554 */     // GIR_Coverage, 25152,
     /*  877554 */     GIR_EraseRootFromParent_Done,
     /*  877555 */   // Label 13441: @877555
     /*  877555 */   GIM_Try, /*On fail goto*//*Label 13442*/ GIMT_Encode4(877627), // Rule ID 25153 //
     /*  877560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  877571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  877574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  877577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877606 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  877609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877625 */     GIR_RootConstrainSelectedInstOperands,
     /*  877626 */     // GIR_Coverage, 25153,
     /*  877626 */     GIR_EraseRootFromParent_Done,
     /*  877627 */   // Label 13442: @877627
     /*  877627 */   GIM_Try, /*On fail goto*//*Label 13443*/ GIMT_Encode4(877699), // Rule ID 25154 //
     /*  877632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  877643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  877646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  877649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877678 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  877681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877697 */     GIR_RootConstrainSelectedInstOperands,
     /*  877698 */     // GIR_Coverage, 25154,
     /*  877698 */     GIR_EraseRootFromParent_Done,
     /*  877699 */   // Label 13443: @877699
     /*  877699 */   GIM_Try, /*On fail goto*//*Label 13444*/ GIMT_Encode4(877771), // Rule ID 25155 //
     /*  877704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  877715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  877718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  877721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877750 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  877753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877769 */     GIR_RootConstrainSelectedInstOperands,
     /*  877770 */     // GIR_Coverage, 25155,
     /*  877770 */     GIR_EraseRootFromParent_Done,
     /*  877771 */   // Label 13444: @877771
     /*  877771 */   GIM_Try, /*On fail goto*//*Label 13445*/ GIMT_Encode4(877843), // Rule ID 25156 //
     /*  877776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  877779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  877787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  877790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  877793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877822 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  877822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  877825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877841 */     GIR_RootConstrainSelectedInstOperands,
     /*  877842 */     // GIR_Coverage, 25156,
     /*  877842 */     GIR_EraseRootFromParent_Done,
     /*  877843 */   // Label 13445: @877843
     /*  877843 */   GIM_Try, /*On fail goto*//*Label 13446*/ GIMT_Encode4(877915), // Rule ID 25157 //
     /*  877848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  877851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  877859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  877862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  877865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877894 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  877894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  877897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877913 */     GIR_RootConstrainSelectedInstOperands,
     /*  877914 */     // GIR_Coverage, 25157,
     /*  877914 */     GIR_EraseRootFromParent_Done,
     /*  877915 */   // Label 13446: @877915
     /*  877915 */   GIM_Try, /*On fail goto*//*Label 13447*/ GIMT_Encode4(877987), // Rule ID 25158 //
     /*  877920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  877923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  877931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  877934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  877937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877966 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  877966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  877969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877985 */     GIR_RootConstrainSelectedInstOperands,
     /*  877986 */     // GIR_Coverage, 25158,
     /*  877986 */     GIR_EraseRootFromParent_Done,
     /*  877987 */   // Label 13447: @877987
     /*  877987 */   GIM_Try, /*On fail goto*//*Label 13448*/ GIMT_Encode4(878059), // Rule ID 25159 //
     /*  877992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  877995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  878003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  878006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  878009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  878012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878038 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  878038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  878041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878057 */     GIR_RootConstrainSelectedInstOperands,
     /*  878058 */     // GIR_Coverage, 25159,
     /*  878058 */     GIR_EraseRootFromParent_Done,
     /*  878059 */   // Label 13448: @878059
     /*  878059 */   GIM_Try, /*On fail goto*//*Label 13449*/ GIMT_Encode4(878131), // Rule ID 25160 //
     /*  878064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  878067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  878075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  878078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  878081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878110 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  878110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  878113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878129 */     GIR_RootConstrainSelectedInstOperands,
     /*  878130 */     // GIR_Coverage, 25160,
     /*  878130 */     GIR_EraseRootFromParent_Done,
     /*  878131 */   // Label 13449: @878131
     /*  878131 */   GIM_Try, /*On fail goto*//*Label 13450*/ GIMT_Encode4(878203), // Rule ID 25161 //
     /*  878136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  878139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  878147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  878150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  878153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878182 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  878182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  878185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878201 */     GIR_RootConstrainSelectedInstOperands,
     /*  878202 */     // GIR_Coverage, 25161,
     /*  878202 */     GIR_EraseRootFromParent_Done,
     /*  878203 */   // Label 13450: @878203
     /*  878203 */   GIM_Try, /*On fail goto*//*Label 13451*/ GIMT_Encode4(878278), // Rule ID 60616 //
     /*  878208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  878211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  878216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  878219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  878222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  878225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  878228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878254 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  878254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  878257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878276 */     GIR_RootConstrainSelectedInstOperands,
     /*  878277 */     // GIR_Coverage, 60616,
     /*  878277 */     GIR_EraseRootFromParent_Done,
     /*  878278 */   // Label 13451: @878278
     /*  878278 */   GIM_Try, /*On fail goto*//*Label 13452*/ GIMT_Encode4(878353), // Rule ID 60617 //
     /*  878283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  878286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  878291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  878294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  878297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  878300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  878303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878329 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  878329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  878332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878351 */     GIR_RootConstrainSelectedInstOperands,
     /*  878352 */     // GIR_Coverage, 60617,
     /*  878352 */     GIR_EraseRootFromParent_Done,
     /*  878353 */   // Label 13452: @878353
     /*  878353 */   GIM_Try, /*On fail goto*//*Label 13453*/ GIMT_Encode4(878428), // Rule ID 60974 //
     /*  878358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  878369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  878372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  878375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  878378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878404 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  878407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878426 */     GIR_RootConstrainSelectedInstOperands,
     /*  878427 */     // GIR_Coverage, 60974,
     /*  878427 */     GIR_EraseRootFromParent_Done,
     /*  878428 */   // Label 13453: @878428
     /*  878428 */   GIM_Try, /*On fail goto*//*Label 13454*/ GIMT_Encode4(878503), // Rule ID 60975 //
     /*  878433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  878444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  878447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  878450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  878453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878479 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  878482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878501 */     GIR_RootConstrainSelectedInstOperands,
     /*  878502 */     // GIR_Coverage, 60975,
     /*  878502 */     GIR_EraseRootFromParent_Done,
     /*  878503 */   // Label 13454: @878503
     /*  878503 */   GIM_Try, /*On fail goto*//*Label 13455*/ GIMT_Encode4(878578), // Rule ID 60978 //
     /*  878508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  878519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  878522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  878525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  878528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878554 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  878557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878576 */     GIR_RootConstrainSelectedInstOperands,
     /*  878577 */     // GIR_Coverage, 60978,
     /*  878577 */     GIR_EraseRootFromParent_Done,
     /*  878578 */   // Label 13455: @878578
     /*  878578 */   GIM_Try, /*On fail goto*//*Label 13456*/ GIMT_Encode4(878653), // Rule ID 60979 //
     /*  878583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  878594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  878597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  878600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  878603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878629 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  878632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878651 */     GIR_RootConstrainSelectedInstOperands,
     /*  878652 */     // GIR_Coverage, 60979,
     /*  878652 */     GIR_EraseRootFromParent_Done,
     /*  878653 */   // Label 13456: @878653
     /*  878653 */   GIM_Try, /*On fail goto*//*Label 13457*/ GIMT_Encode4(878728), // Rule ID 60982 //
     /*  878658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  878669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  878672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  878675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  878678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878704 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  878707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878726 */     GIR_RootConstrainSelectedInstOperands,
     /*  878727 */     // GIR_Coverage, 60982,
     /*  878727 */     GIR_EraseRootFromParent_Done,
     /*  878728 */   // Label 13457: @878728
     /*  878728 */   GIM_Try, /*On fail goto*//*Label 13458*/ GIMT_Encode4(878803), // Rule ID 60983 //
     /*  878733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  878744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  878747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  878750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  878753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878779 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  878782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878801 */     GIR_RootConstrainSelectedInstOperands,
     /*  878802 */     // GIR_Coverage, 60983,
     /*  878802 */     GIR_EraseRootFromParent_Done,
     /*  878803 */   // Label 13458: @878803
     /*  878803 */   GIM_Try, /*On fail goto*//*Label 13459*/ GIMT_Encode4(878878), // Rule ID 60986 //
     /*  878808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  878819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  878822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  878825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  878828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878854 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  878857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878876 */     GIR_RootConstrainSelectedInstOperands,
     /*  878877 */     // GIR_Coverage, 60986,
     /*  878877 */     GIR_EraseRootFromParent_Done,
     /*  878878 */   // Label 13459: @878878
     /*  878878 */   GIM_Try, /*On fail goto*//*Label 13460*/ GIMT_Encode4(878953), // Rule ID 60987 //
     /*  878883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  878894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  878897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  878900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  878903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878929 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  878932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878951 */     GIR_RootConstrainSelectedInstOperands,
     /*  878952 */     // GIR_Coverage, 60987,
     /*  878952 */     GIR_EraseRootFromParent_Done,
     /*  878953 */   // Label 13460: @878953
     /*  878953 */   GIM_Try, /*On fail goto*//*Label 13461*/ GIMT_Encode4(879028), // Rule ID 60990 //
     /*  878958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  878969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  878972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  878975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  878978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879004 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  879004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879026 */     GIR_RootConstrainSelectedInstOperands,
     /*  879027 */     // GIR_Coverage, 60990,
     /*  879027 */     GIR_EraseRootFromParent_Done,
     /*  879028 */   // Label 13461: @879028
     /*  879028 */   GIM_Try, /*On fail goto*//*Label 13462*/ GIMT_Encode4(879103), // Rule ID 60991 //
     /*  879033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  879044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  879047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  879050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  879053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879079 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879101 */     GIR_RootConstrainSelectedInstOperands,
     /*  879102 */     // GIR_Coverage, 60991,
     /*  879102 */     GIR_EraseRootFromParent_Done,
     /*  879103 */   // Label 13462: @879103
     /*  879103 */   GIM_Try, /*On fail goto*//*Label 13463*/ GIMT_Encode4(879178), // Rule ID 60994 //
     /*  879108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  879119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  879122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  879125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  879128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879154 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  879154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879176 */     GIR_RootConstrainSelectedInstOperands,
     /*  879177 */     // GIR_Coverage, 60994,
     /*  879177 */     GIR_EraseRootFromParent_Done,
     /*  879178 */   // Label 13463: @879178
     /*  879178 */   GIM_Try, /*On fail goto*//*Label 13464*/ GIMT_Encode4(879253), // Rule ID 60995 //
     /*  879183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  879194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  879197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  879200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  879203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879229 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879251 */     GIR_RootConstrainSelectedInstOperands,
     /*  879252 */     // GIR_Coverage, 60995,
     /*  879252 */     GIR_EraseRootFromParent_Done,
     /*  879253 */   // Label 13464: @879253
     /*  879253 */   GIM_Try, /*On fail goto*//*Label 13465*/ GIMT_Encode4(879328), // Rule ID 60998 //
     /*  879258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  879269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  879272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  879275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  879278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879304 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  879307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879326 */     GIR_RootConstrainSelectedInstOperands,
     /*  879327 */     // GIR_Coverage, 60998,
     /*  879327 */     GIR_EraseRootFromParent_Done,
     /*  879328 */   // Label 13465: @879328
     /*  879328 */   GIM_Try, /*On fail goto*//*Label 13466*/ GIMT_Encode4(879403), // Rule ID 60999 //
     /*  879333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  879344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  879347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  879350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  879353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879379 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  879382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879401 */     GIR_RootConstrainSelectedInstOperands,
     /*  879402 */     // GIR_Coverage, 60999,
     /*  879402 */     GIR_EraseRootFromParent_Done,
     /*  879403 */   // Label 13466: @879403
     /*  879403 */   GIM_Try, /*On fail goto*//*Label 13467*/ GIMT_Encode4(879478), // Rule ID 61002 //
     /*  879408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  879419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  879422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  879425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  879428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879454 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11679:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879476 */     GIR_RootConstrainSelectedInstOperands,
     /*  879477 */     // GIR_Coverage, 61002,
     /*  879477 */     GIR_EraseRootFromParent_Done,
     /*  879478 */   // Label 13467: @879478
     /*  879478 */   GIM_Try, /*On fail goto*//*Label 13468*/ GIMT_Encode4(879553), // Rule ID 61003 //
     /*  879483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  879494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  879497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  879500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  879503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879529 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11679:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879551 */     GIR_RootConstrainSelectedInstOperands,
     /*  879552 */     // GIR_Coverage, 61003,
     /*  879552 */     GIR_EraseRootFromParent_Done,
     /*  879553 */   // Label 13468: @879553
     /*  879553 */   GIM_Try, /*On fail goto*//*Label 13469*/ GIMT_Encode4(879628), // Rule ID 61006 //
     /*  879558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  879569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  879572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  879575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  879578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  879607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879626 */     GIR_RootConstrainSelectedInstOperands,
     /*  879627 */     // GIR_Coverage, 61006,
     /*  879627 */     GIR_EraseRootFromParent_Done,
     /*  879628 */   // Label 13469: @879628
     /*  879628 */   GIM_Try, /*On fail goto*//*Label 13470*/ GIMT_Encode4(879703), // Rule ID 61007 //
     /*  879633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  879644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  879647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  879650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  879653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  879682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879701 */     GIR_RootConstrainSelectedInstOperands,
     /*  879702 */     // GIR_Coverage, 61007,
     /*  879702 */     GIR_EraseRootFromParent_Done,
     /*  879703 */   // Label 13470: @879703
     /*  879703 */   GIM_Try, /*On fail goto*//*Label 13471*/ GIMT_Encode4(879778), // Rule ID 61010 //
     /*  879708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  879719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  879722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  879725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  879728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879754 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879776 */     GIR_RootConstrainSelectedInstOperands,
     /*  879777 */     // GIR_Coverage, 61010,
     /*  879777 */     GIR_EraseRootFromParent_Done,
     /*  879778 */   // Label 13471: @879778
     /*  879778 */   GIM_Try, /*On fail goto*//*Label 13472*/ GIMT_Encode4(879853), // Rule ID 61011 //
     /*  879783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  879794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  879797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  879800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  879803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879829 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879851 */     GIR_RootConstrainSelectedInstOperands,
     /*  879852 */     // GIR_Coverage, 61011,
     /*  879852 */     GIR_EraseRootFromParent_Done,
     /*  879853 */   // Label 13472: @879853
     /*  879853 */   GIM_Try, /*On fail goto*//*Label 13473*/ GIMT_Encode4(879928), // Rule ID 61014 //
     /*  879858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  879869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  879872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  879875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  879878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879904 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879926 */     GIR_RootConstrainSelectedInstOperands,
     /*  879927 */     // GIR_Coverage, 61014,
     /*  879927 */     GIR_EraseRootFromParent_Done,
     /*  879928 */   // Label 13473: @879928
     /*  879928 */   GIM_Try, /*On fail goto*//*Label 13474*/ GIMT_Encode4(880003), // Rule ID 61015 //
     /*  879933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  879944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  879947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  879950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  879953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879979 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880001 */     GIR_RootConstrainSelectedInstOperands,
     /*  880002 */     // GIR_Coverage, 61015,
     /*  880002 */     GIR_EraseRootFromParent_Done,
     /*  880003 */   // Label 13474: @880003
     /*  880003 */   GIM_Try, /*On fail goto*//*Label 13475*/ GIMT_Encode4(880078), // Rule ID 61018 //
     /*  880008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  880019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  880022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  880025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  880028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880054 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  880057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880076 */     GIR_RootConstrainSelectedInstOperands,
     /*  880077 */     // GIR_Coverage, 61018,
     /*  880077 */     GIR_EraseRootFromParent_Done,
     /*  880078 */   // Label 13475: @880078
     /*  880078 */   GIM_Try, /*On fail goto*//*Label 13476*/ GIMT_Encode4(880153), // Rule ID 61019 //
     /*  880083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  880094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  880097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  880100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  880103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880129 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  880132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880151 */     GIR_RootConstrainSelectedInstOperands,
     /*  880152 */     // GIR_Coverage, 61019,
     /*  880152 */     GIR_EraseRootFromParent_Done,
     /*  880153 */   // Label 13476: @880153
     /*  880153 */   GIM_Try, /*On fail goto*//*Label 13477*/ GIMT_Encode4(880228), // Rule ID 61022 //
     /*  880158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  880169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  880172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  880175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  880178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880204 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  880207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880226 */     GIR_RootConstrainSelectedInstOperands,
     /*  880227 */     // GIR_Coverage, 61022,
     /*  880227 */     GIR_EraseRootFromParent_Done,
     /*  880228 */   // Label 13477: @880228
     /*  880228 */   GIM_Try, /*On fail goto*//*Label 13478*/ GIMT_Encode4(880303), // Rule ID 61023 //
     /*  880233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  880244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  880247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  880250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  880253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880279 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  880282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880301 */     GIR_RootConstrainSelectedInstOperands,
     /*  880302 */     // GIR_Coverage, 61023,
     /*  880302 */     GIR_EraseRootFromParent_Done,
     /*  880303 */   // Label 13478: @880303
     /*  880303 */   GIM_Try, /*On fail goto*//*Label 13479*/ GIMT_Encode4(880378), // Rule ID 61026 //
     /*  880308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  880319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  880322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  880328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880354 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  880357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880376 */     GIR_RootConstrainSelectedInstOperands,
     /*  880377 */     // GIR_Coverage, 61026,
     /*  880377 */     GIR_EraseRootFromParent_Done,
     /*  880378 */   // Label 13479: @880378
     /*  880378 */   GIM_Try, /*On fail goto*//*Label 13480*/ GIMT_Encode4(880453), // Rule ID 61027 //
     /*  880383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  880394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  880397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  880403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880429 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  880432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880451 */     GIR_RootConstrainSelectedInstOperands,
     /*  880452 */     // GIR_Coverage, 61027,
     /*  880452 */     GIR_EraseRootFromParent_Done,
     /*  880453 */   // Label 13480: @880453
     /*  880453 */   GIM_Try, /*On fail goto*//*Label 13481*/ GIMT_Encode4(880528), // Rule ID 61030 //
     /*  880458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  880469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  880472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  880475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  880478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880504 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  880507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880526 */     GIR_RootConstrainSelectedInstOperands,
     /*  880527 */     // GIR_Coverage, 61030,
     /*  880527 */     GIR_EraseRootFromParent_Done,
     /*  880528 */   // Label 13481: @880528
     /*  880528 */   GIM_Try, /*On fail goto*//*Label 13482*/ GIMT_Encode4(880603), // Rule ID 61031 //
     /*  880533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  880544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  880547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  880550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  880553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880579 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  880582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880601 */     GIR_RootConstrainSelectedInstOperands,
     /*  880602 */     // GIR_Coverage, 61031,
     /*  880602 */     GIR_EraseRootFromParent_Done,
     /*  880603 */   // Label 13482: @880603
     /*  880603 */   GIM_Try, /*On fail goto*//*Label 13483*/ GIMT_Encode4(880678), // Rule ID 61034 //
     /*  880608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  880619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  880622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  880625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880654 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  880654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  880657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880676 */     GIR_RootConstrainSelectedInstOperands,
     /*  880677 */     // GIR_Coverage, 61034,
     /*  880677 */     GIR_EraseRootFromParent_Done,
     /*  880678 */   // Label 13483: @880678
     /*  880678 */   GIM_Try, /*On fail goto*//*Label 13484*/ GIMT_Encode4(880753), // Rule ID 61035 //
     /*  880683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  880694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  880697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  880700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880729 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  880729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  880732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880751 */     GIR_RootConstrainSelectedInstOperands,
     /*  880752 */     // GIR_Coverage, 61035,
     /*  880752 */     GIR_EraseRootFromParent_Done,
     /*  880753 */   // Label 13484: @880753
     /*  880753 */   GIM_Try, /*On fail goto*//*Label 13485*/ GIMT_Encode4(880828), // Rule ID 61042 //
     /*  880758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  880769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  880772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  880775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880804 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  880804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  880807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880826 */     GIR_RootConstrainSelectedInstOperands,
     /*  880827 */     // GIR_Coverage, 61042,
     /*  880827 */     GIR_EraseRootFromParent_Done,
     /*  880828 */   // Label 13485: @880828
     /*  880828 */   GIM_Try, /*On fail goto*//*Label 13486*/ GIMT_Encode4(880903), // Rule ID 61043 //
     /*  880833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  880844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  880847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  880850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880879 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  880879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  880882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880901 */     GIR_RootConstrainSelectedInstOperands,
     /*  880902 */     // GIR_Coverage, 61043,
     /*  880902 */     GIR_EraseRootFromParent_Done,
     /*  880903 */   // Label 13486: @880903
     /*  880903 */   GIM_Try, /*On fail goto*//*Label 13487*/ GIMT_Encode4(880978), // Rule ID 61050 //
     /*  880908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  880919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  880922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  880925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880954 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  880954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  880957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880976 */     GIR_RootConstrainSelectedInstOperands,
     /*  880977 */     // GIR_Coverage, 61050,
     /*  880977 */     GIR_EraseRootFromParent_Done,
     /*  880978 */   // Label 13487: @880978
     /*  880978 */   GIM_Try, /*On fail goto*//*Label 13488*/ GIMT_Encode4(881053), // Rule ID 61051 //
     /*  880983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  880994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  880997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  881000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881029 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11679:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881051 */     GIR_RootConstrainSelectedInstOperands,
     /*  881052 */     // GIR_Coverage, 61051,
     /*  881052 */     GIR_EraseRootFromParent_Done,
     /*  881053 */   // Label 13488: @881053
     /*  881053 */   GIM_Try, /*On fail goto*//*Label 13489*/ GIMT_Encode4(881128), // Rule ID 61058 //
     /*  881058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  881069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  881072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  881075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881104 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881126 */     GIR_RootConstrainSelectedInstOperands,
     /*  881127 */     // GIR_Coverage, 61058,
     /*  881127 */     GIR_EraseRootFromParent_Done,
     /*  881128 */   // Label 13489: @881128
     /*  881128 */   GIM_Try, /*On fail goto*//*Label 13490*/ GIMT_Encode4(881203), // Rule ID 61059 //
     /*  881133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  881144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  881147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  881150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881179 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881201 */     GIR_RootConstrainSelectedInstOperands,
     /*  881202 */     // GIR_Coverage, 61059,
     /*  881202 */     GIR_EraseRootFromParent_Done,
     /*  881203 */   // Label 13490: @881203
     /*  881203 */   GIM_Try, /*On fail goto*//*Label 13491*/ GIMT_Encode4(881278), // Rule ID 61066 //
     /*  881208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  881219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  881222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  881225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881254 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  881257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881276 */     GIR_RootConstrainSelectedInstOperands,
     /*  881277 */     // GIR_Coverage, 61066,
     /*  881277 */     GIR_EraseRootFromParent_Done,
     /*  881278 */   // Label 13491: @881278
     /*  881278 */   GIM_Try, /*On fail goto*//*Label 13492*/ GIMT_Encode4(881353), // Rule ID 61067 //
     /*  881283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  881294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  881297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  881300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881329 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  881332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881351 */     GIR_RootConstrainSelectedInstOperands,
     /*  881352 */     // GIR_Coverage, 61067,
     /*  881352 */     GIR_EraseRootFromParent_Done,
     /*  881353 */   // Label 13492: @881353
     /*  881353 */   GIM_Try, /*On fail goto*//*Label 13493*/ GIMT_Encode4(881428), // Rule ID 61074 //
     /*  881358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  881369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  881372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  881375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881404 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  881407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881426 */     GIR_RootConstrainSelectedInstOperands,
     /*  881427 */     // GIR_Coverage, 61074,
     /*  881427 */     GIR_EraseRootFromParent_Done,
     /*  881428 */   // Label 13493: @881428
     /*  881428 */   GIM_Try, /*On fail goto*//*Label 13494*/ GIMT_Encode4(881503), // Rule ID 61075 //
     /*  881433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  881444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  881447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  881450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881479 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  881482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881501 */     GIR_RootConstrainSelectedInstOperands,
     /*  881502 */     // GIR_Coverage, 61075,
     /*  881502 */     GIR_EraseRootFromParent_Done,
     /*  881503 */   // Label 13494: @881503
     /*  881503 */   GIM_Try, /*On fail goto*//*Label 13495*/ GIMT_Encode4(881578), // Rule ID 61082 //
     /*  881508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  881519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  881522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  881525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881554 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  881554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  881557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881576 */     GIR_RootConstrainSelectedInstOperands,
     /*  881577 */     // GIR_Coverage, 61082,
     /*  881577 */     GIR_EraseRootFromParent_Done,
     /*  881578 */   // Label 13495: @881578
     /*  881578 */   GIM_Try, /*On fail goto*//*Label 13496*/ GIMT_Encode4(881653), // Rule ID 61083 //
     /*  881583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  881594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  881597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  881600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881629 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  881629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  881632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881651 */     GIR_RootConstrainSelectedInstOperands,
     /*  881652 */     // GIR_Coverage, 61083,
     /*  881652 */     GIR_EraseRootFromParent_Done,
     /*  881653 */   // Label 13496: @881653
     /*  881653 */   GIM_Try, /*On fail goto*//*Label 13497*/ GIMT_Encode4(881728), // Rule ID 61090 //
     /*  881658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  881669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  881672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  881675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881704 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11679:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  881704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881726 */     GIR_RootConstrainSelectedInstOperands,
     /*  881727 */     // GIR_Coverage, 61090,
     /*  881727 */     GIR_EraseRootFromParent_Done,
     /*  881728 */   // Label 13497: @881728
     /*  881728 */   GIM_Try, /*On fail goto*//*Label 13498*/ GIMT_Encode4(881803), // Rule ID 61091 //
     /*  881733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  881744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  881747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  881750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881779 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11679:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  881779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881801 */     GIR_RootConstrainSelectedInstOperands,
     /*  881802 */     // GIR_Coverage, 61091,
     /*  881802 */     GIR_EraseRootFromParent_Done,
     /*  881803 */   // Label 13498: @881803
     /*  881803 */   GIM_Try, /*On fail goto*//*Label 13499*/ GIMT_Encode4(881878), // Rule ID 61098 //
     /*  881808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  881819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  881822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  881825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  881854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881876 */     GIR_RootConstrainSelectedInstOperands,
     /*  881877 */     // GIR_Coverage, 61098,
     /*  881877 */     GIR_EraseRootFromParent_Done,
     /*  881878 */   // Label 13499: @881878
     /*  881878 */   GIM_Try, /*On fail goto*//*Label 13500*/ GIMT_Encode4(881953), // Rule ID 61099 //
     /*  881883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  881894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  881897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  881900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881929 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  881929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881951 */     GIR_RootConstrainSelectedInstOperands,
     /*  881952 */     // GIR_Coverage, 61099,
     /*  881952 */     GIR_EraseRootFromParent_Done,
     /*  881953 */   // Label 13500: @881953
     /*  881953 */   GIM_Try, /*On fail goto*//*Label 13501*/ GIMT_Encode4(882028), // Rule ID 61106 //
     /*  881958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  881969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  881972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  881975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882004 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  882004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  882007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882026 */     GIR_RootConstrainSelectedInstOperands,
     /*  882027 */     // GIR_Coverage, 61106,
     /*  882027 */     GIR_EraseRootFromParent_Done,
     /*  882028 */   // Label 13501: @882028
     /*  882028 */   GIM_Try, /*On fail goto*//*Label 13502*/ GIMT_Encode4(882103), // Rule ID 61107 //
     /*  882033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  882044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  882047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  882050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882079 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  882082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882101 */     GIR_RootConstrainSelectedInstOperands,
     /*  882102 */     // GIR_Coverage, 61107,
     /*  882102 */     GIR_EraseRootFromParent_Done,
     /*  882103 */   // Label 13502: @882103
     /*  882103 */   GIM_Try, /*On fail goto*//*Label 13503*/ GIMT_Encode4(882178), // Rule ID 61114 //
     /*  882108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  882119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  882122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  882125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882154 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  882154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882176 */     GIR_RootConstrainSelectedInstOperands,
     /*  882177 */     // GIR_Coverage, 61114,
     /*  882177 */     GIR_EraseRootFromParent_Done,
     /*  882178 */   // Label 13503: @882178
     /*  882178 */   GIM_Try, /*On fail goto*//*Label 13504*/ GIMT_Encode4(882253), // Rule ID 61115 //
     /*  882183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  882194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  882197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  882200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882229 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882251 */     GIR_RootConstrainSelectedInstOperands,
     /*  882252 */     // GIR_Coverage, 61115,
     /*  882252 */     GIR_EraseRootFromParent_Done,
     /*  882253 */   // Label 13504: @882253
     /*  882253 */   GIM_Try, /*On fail goto*//*Label 13505*/ GIMT_Encode4(882328), // Rule ID 61122 //
     /*  882258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882304 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  882307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882326 */     GIR_RootConstrainSelectedInstOperands,
     /*  882327 */     // GIR_Coverage, 61122,
     /*  882327 */     GIR_EraseRootFromParent_Done,
     /*  882328 */   // Label 13505: @882328
     /*  882328 */   GIM_Try, /*On fail goto*//*Label 13506*/ GIMT_Encode4(882403), // Rule ID 61123 //
     /*  882333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882379 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11679:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  882382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882401 */     GIR_RootConstrainSelectedInstOperands,
     /*  882402 */     // GIR_Coverage, 61123,
     /*  882402 */     GIR_EraseRootFromParent_Done,
     /*  882403 */   // Label 13506: @882403
     /*  882403 */   GIM_Try, /*On fail goto*//*Label 13507*/ GIMT_Encode4(882478), // Rule ID 61130 //
     /*  882408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  882419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  882422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  882425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882454 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  882457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882476 */     GIR_RootConstrainSelectedInstOperands,
     /*  882477 */     // GIR_Coverage, 61130,
     /*  882477 */     GIR_EraseRootFromParent_Done,
     /*  882478 */   // Label 13507: @882478
     /*  882478 */   GIM_Try, /*On fail goto*//*Label 13508*/ GIMT_Encode4(882553), // Rule ID 61131 //
     /*  882483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  882494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  882497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  882500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882529 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11679:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  882532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882551 */     GIR_RootConstrainSelectedInstOperands,
     /*  882552 */     // GIR_Coverage, 61131,
     /*  882552 */     GIR_EraseRootFromParent_Done,
     /*  882553 */   // Label 13508: @882553
     /*  882553 */   GIM_Try, /*On fail goto*//*Label 13509*/ GIMT_Encode4(882628), // Rule ID 61138 //
     /*  882558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  882569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  882572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  882575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  882607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882626 */     GIR_RootConstrainSelectedInstOperands,
     /*  882627 */     // GIR_Coverage, 61138,
     /*  882627 */     GIR_EraseRootFromParent_Done,
     /*  882628 */   // Label 13509: @882628
     /*  882628 */   GIM_Try, /*On fail goto*//*Label 13510*/ GIMT_Encode4(882703), // Rule ID 61139 //
     /*  882633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  882644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  882647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  882650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882679 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11679:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  882682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882701 */     GIR_RootConstrainSelectedInstOperands,
     /*  882702 */     // GIR_Coverage, 61139,
     /*  882702 */     GIR_EraseRootFromParent_Done,
     /*  882703 */   // Label 13510: @882703
     /*  882703 */   GIM_Try, /*On fail goto*//*Label 13511*/ GIMT_Encode4(882778), // Rule ID 61146 //
     /*  882708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  882719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  882722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  882725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882754 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882776 */     GIR_RootConstrainSelectedInstOperands,
     /*  882777 */     // GIR_Coverage, 61146,
     /*  882777 */     GIR_EraseRootFromParent_Done,
     /*  882778 */   // Label 13511: @882778
     /*  882778 */   GIM_Try, /*On fail goto*//*Label 13512*/ GIMT_Encode4(882853), // Rule ID 61147 //
     /*  882783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  882794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  882797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  882800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882829 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11679:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882851 */     GIR_RootConstrainSelectedInstOperands,
     /*  882852 */     // GIR_Coverage, 61147,
     /*  882852 */     GIR_EraseRootFromParent_Done,
     /*  882853 */   // Label 13512: @882853
     /*  882853 */   GIM_Try, /*On fail goto*//*Label 13513*/ GIMT_Encode4(882928), // Rule ID 61154 //
     /*  882858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  882861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  882866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  882875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  882878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882904 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  882904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  882907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  882923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882926 */     GIR_RootConstrainSelectedInstOperands,
     /*  882927 */     // GIR_Coverage, 61154,
     /*  882927 */     GIR_EraseRootFromParent_Done,
     /*  882928 */   // Label 13513: @882928
     /*  882928 */   GIM_Try, /*On fail goto*//*Label 13514*/ GIMT_Encode4(883003), // Rule ID 61155 //
     /*  882933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  882936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  882941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  882950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  882953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882979 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  882979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  882982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  882998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883001 */     GIR_RootConstrainSelectedInstOperands,
     /*  883002 */     // GIR_Coverage, 61155,
     /*  883002 */     GIR_EraseRootFromParent_Done,
     /*  883003 */   // Label 13514: @883003
     /*  883003 */   GIM_Try, /*On fail goto*//*Label 13515*/ GIMT_Encode4(883078), // Rule ID 61158 //
     /*  883008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  883028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883054 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  883057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883076 */     GIR_RootConstrainSelectedInstOperands,
     /*  883077 */     // GIR_Coverage, 61158,
     /*  883077 */     GIR_EraseRootFromParent_Done,
     /*  883078 */   // Label 13515: @883078
     /*  883078 */   GIM_Try, /*On fail goto*//*Label 13516*/ GIMT_Encode4(883153), // Rule ID 61159 //
     /*  883083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  883103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883129 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  883132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883151 */     GIR_RootConstrainSelectedInstOperands,
     /*  883152 */     // GIR_Coverage, 61159,
     /*  883152 */     GIR_EraseRootFromParent_Done,
     /*  883153 */   // Label 13516: @883153
     /*  883153 */   GIM_Try, /*On fail goto*//*Label 13517*/ GIMT_Encode4(883228), // Rule ID 61162 //
     /*  883158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  883178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883204 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  883207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883226 */     GIR_RootConstrainSelectedInstOperands,
     /*  883227 */     // GIR_Coverage, 61162,
     /*  883227 */     GIR_EraseRootFromParent_Done,
     /*  883228 */   // Label 13517: @883228
     /*  883228 */   GIM_Try, /*On fail goto*//*Label 13518*/ GIMT_Encode4(883303), // Rule ID 61163 //
     /*  883233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  883253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883279 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  883282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883301 */     GIR_RootConstrainSelectedInstOperands,
     /*  883302 */     // GIR_Coverage, 61163,
     /*  883302 */     GIR_EraseRootFromParent_Done,
     /*  883303 */   // Label 13518: @883303
     /*  883303 */   GIM_Try, /*On fail goto*//*Label 13519*/ GIMT_Encode4(883378), // Rule ID 61166 //
     /*  883308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  883325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  883328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883354 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  883357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883376 */     GIR_RootConstrainSelectedInstOperands,
     /*  883377 */     // GIR_Coverage, 61166,
     /*  883377 */     GIR_EraseRootFromParent_Done,
     /*  883378 */   // Label 13519: @883378
     /*  883378 */   GIM_Try, /*On fail goto*//*Label 13520*/ GIMT_Encode4(883453), // Rule ID 61167 //
     /*  883383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  883400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  883403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883429 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  883432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883451 */     GIR_RootConstrainSelectedInstOperands,
     /*  883452 */     // GIR_Coverage, 61167,
     /*  883452 */     GIR_EraseRootFromParent_Done,
     /*  883453 */   // Label 13520: @883453
     /*  883453 */   GIM_Try, /*On fail goto*//*Label 13521*/ GIMT_Encode4(883528), // Rule ID 61170 //
     /*  883458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883504 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  883507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883526 */     GIR_RootConstrainSelectedInstOperands,
     /*  883527 */     // GIR_Coverage, 61170,
     /*  883527 */     GIR_EraseRootFromParent_Done,
     /*  883528 */   // Label 13521: @883528
     /*  883528 */   GIM_Try, /*On fail goto*//*Label 13522*/ GIMT_Encode4(883603), // Rule ID 61171 //
     /*  883533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883579 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  883582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883601 */     GIR_RootConstrainSelectedInstOperands,
     /*  883602 */     // GIR_Coverage, 61171,
     /*  883602 */     GIR_EraseRootFromParent_Done,
     /*  883603 */   // Label 13522: @883603
     /*  883603 */   GIM_Try, /*On fail goto*//*Label 13523*/ GIMT_Encode4(883678), // Rule ID 61174 //
     /*  883608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  883657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883676 */     GIR_RootConstrainSelectedInstOperands,
     /*  883677 */     // GIR_Coverage, 61174,
     /*  883677 */     GIR_EraseRootFromParent_Done,
     /*  883678 */   // Label 13523: @883678
     /*  883678 */   GIM_Try, /*On fail goto*//*Label 13524*/ GIMT_Encode4(883753), // Rule ID 61175 //
     /*  883683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883729 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  883732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883751 */     GIR_RootConstrainSelectedInstOperands,
     /*  883752 */     // GIR_Coverage, 61175,
     /*  883752 */     GIR_EraseRootFromParent_Done,
     /*  883753 */   // Label 13524: @883753
     /*  883753 */   GIM_Try, /*On fail goto*//*Label 13525*/ GIMT_Encode4(883828), // Rule ID 61178 //
     /*  883758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883804 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  883807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883826 */     GIR_RootConstrainSelectedInstOperands,
     /*  883827 */     // GIR_Coverage, 61178,
     /*  883827 */     GIR_EraseRootFromParent_Done,
     /*  883828 */   // Label 13525: @883828
     /*  883828 */   GIM_Try, /*On fail goto*//*Label 13526*/ GIMT_Encode4(883903), // Rule ID 61179 //
     /*  883833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883879 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  883882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883901 */     GIR_RootConstrainSelectedInstOperands,
     /*  883902 */     // GIR_Coverage, 61179,
     /*  883902 */     GIR_EraseRootFromParent_Done,
     /*  883903 */   // Label 13526: @883903
     /*  883903 */   GIM_Try, /*On fail goto*//*Label 13527*/ GIMT_Encode4(883978), // Rule ID 61182 //
     /*  883908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  883925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883954 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  883957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883976 */     GIR_RootConstrainSelectedInstOperands,
     /*  883977 */     // GIR_Coverage, 61182,
     /*  883977 */     GIR_EraseRootFromParent_Done,
     /*  883978 */   // Label 13527: @883978
     /*  883978 */   GIM_Try, /*On fail goto*//*Label 13528*/ GIMT_Encode4(884053), // Rule ID 61183 //
     /*  883983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884029 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  884032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884051 */     GIR_RootConstrainSelectedInstOperands,
     /*  884052 */     // GIR_Coverage, 61183,
     /*  884052 */     GIR_EraseRootFromParent_Done,
     /*  884053 */   // Label 13528: @884053
     /*  884053 */   GIM_Try, /*On fail goto*//*Label 13529*/ GIMT_Encode4(884128), // Rule ID 61186 //
     /*  884058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  884078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884104 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  884107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884126 */     GIR_RootConstrainSelectedInstOperands,
     /*  884127 */     // GIR_Coverage, 61186,
     /*  884127 */     GIR_EraseRootFromParent_Done,
     /*  884128 */   // Label 13529: @884128
     /*  884128 */   GIM_Try, /*On fail goto*//*Label 13530*/ GIMT_Encode4(884203), // Rule ID 61187 //
     /*  884133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  884153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884179 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  884182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884201 */     GIR_RootConstrainSelectedInstOperands,
     /*  884202 */     // GIR_Coverage, 61187,
     /*  884202 */     GIR_EraseRootFromParent_Done,
     /*  884203 */   // Label 13530: @884203
     /*  884203 */   GIM_Try, /*On fail goto*//*Label 13531*/ GIMT_Encode4(884278), // Rule ID 61190 //
     /*  884208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  884228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884254 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  884257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884276 */     GIR_RootConstrainSelectedInstOperands,
     /*  884277 */     // GIR_Coverage, 61190,
     /*  884277 */     GIR_EraseRootFromParent_Done,
     /*  884278 */   // Label 13531: @884278
     /*  884278 */   GIM_Try, /*On fail goto*//*Label 13532*/ GIMT_Encode4(884353), // Rule ID 61191 //
     /*  884283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  884303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884329 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  884332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884351 */     GIR_RootConstrainSelectedInstOperands,
     /*  884352 */     // GIR_Coverage, 61191,
     /*  884352 */     GIR_EraseRootFromParent_Done,
     /*  884353 */   // Label 13532: @884353
     /*  884353 */   GIM_Try, /*On fail goto*//*Label 13533*/ GIMT_Encode4(884428), // Rule ID 61194 //
     /*  884358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  884378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884404 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  884407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884426 */     GIR_RootConstrainSelectedInstOperands,
     /*  884427 */     // GIR_Coverage, 61194,
     /*  884427 */     GIR_EraseRootFromParent_Done,
     /*  884428 */   // Label 13533: @884428
     /*  884428 */   GIM_Try, /*On fail goto*//*Label 13534*/ GIMT_Encode4(884503), // Rule ID 61195 //
     /*  884433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  884453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884479 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  884482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884501 */     GIR_RootConstrainSelectedInstOperands,
     /*  884502 */     // GIR_Coverage, 61195,
     /*  884502 */     GIR_EraseRootFromParent_Done,
     /*  884503 */   // Label 13534: @884503
     /*  884503 */   GIM_Try, /*On fail goto*//*Label 13535*/ GIMT_Encode4(884578), // Rule ID 61198 //
     /*  884508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  884528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884554 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  884557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884576 */     GIR_RootConstrainSelectedInstOperands,
     /*  884577 */     // GIR_Coverage, 61198,
     /*  884577 */     GIR_EraseRootFromParent_Done,
     /*  884578 */   // Label 13535: @884578
     /*  884578 */   GIM_Try, /*On fail goto*//*Label 13536*/ GIMT_Encode4(884653), // Rule ID 61199 //
     /*  884583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  884603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884629 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  884632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884651 */     GIR_RootConstrainSelectedInstOperands,
     /*  884652 */     // GIR_Coverage, 61199,
     /*  884652 */     GIR_EraseRootFromParent_Done,
     /*  884653 */   // Label 13536: @884653
     /*  884653 */   GIM_Try, /*On fail goto*//*Label 13537*/ GIMT_Encode4(884728), // Rule ID 61202 //
     /*  884658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884704 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  884707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884726 */     GIR_RootConstrainSelectedInstOperands,
     /*  884727 */     // GIR_Coverage, 61202,
     /*  884727 */     GIR_EraseRootFromParent_Done,
     /*  884728 */   // Label 13537: @884728
     /*  884728 */   GIM_Try, /*On fail goto*//*Label 13538*/ GIMT_Encode4(884803), // Rule ID 61203 //
     /*  884733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884779 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  884782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884801 */     GIR_RootConstrainSelectedInstOperands,
     /*  884802 */     // GIR_Coverage, 61203,
     /*  884802 */     GIR_EraseRootFromParent_Done,
     /*  884803 */   // Label 13538: @884803
     /*  884803 */   GIM_Try, /*On fail goto*//*Label 13539*/ GIMT_Encode4(884878), // Rule ID 61206 //
     /*  884808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884854 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  884857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884876 */     GIR_RootConstrainSelectedInstOperands,
     /*  884877 */     // GIR_Coverage, 61206,
     /*  884877 */     GIR_EraseRootFromParent_Done,
     /*  884878 */   // Label 13539: @884878
     /*  884878 */   GIM_Try, /*On fail goto*//*Label 13540*/ GIMT_Encode4(884953), // Rule ID 61207 //
     /*  884883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884929 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  884932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884951 */     GIR_RootConstrainSelectedInstOperands,
     /*  884952 */     // GIR_Coverage, 61207,
     /*  884952 */     GIR_EraseRootFromParent_Done,
     /*  884953 */   // Label 13540: @884953
     /*  884953 */   GIM_Try, /*On fail goto*//*Label 13541*/ GIMT_Encode4(885028), // Rule ID 61210 //
     /*  884958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885004 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  885004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  885007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885026 */     GIR_RootConstrainSelectedInstOperands,
     /*  885027 */     // GIR_Coverage, 61210,
     /*  885027 */     GIR_EraseRootFromParent_Done,
     /*  885028 */   // Label 13541: @885028
     /*  885028 */   GIM_Try, /*On fail goto*//*Label 13542*/ GIMT_Encode4(885103), // Rule ID 61211 //
     /*  885033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  885044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  885047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  885050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885079 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  885082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885101 */     GIR_RootConstrainSelectedInstOperands,
     /*  885102 */     // GIR_Coverage, 61211,
     /*  885102 */     GIR_EraseRootFromParent_Done,
     /*  885103 */   // Label 13542: @885103
     /*  885103 */   GIM_Try, /*On fail goto*//*Label 13543*/ GIMT_Encode4(885178), // Rule ID 61214 //
     /*  885108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  885111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  885119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  885122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  885125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885154 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  885154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  885157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885176 */     GIR_RootConstrainSelectedInstOperands,
     /*  885177 */     // GIR_Coverage, 61214,
     /*  885177 */     GIR_EraseRootFromParent_Done,
     /*  885178 */   // Label 13543: @885178
     /*  885178 */   GIM_Try, /*On fail goto*//*Label 13544*/ GIMT_Encode4(885253), // Rule ID 61215 //
     /*  885183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  885194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  885197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  885200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885229 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  885232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885251 */     GIR_RootConstrainSelectedInstOperands,
     /*  885252 */     // GIR_Coverage, 61215,
     /*  885252 */     GIR_EraseRootFromParent_Done,
     /*  885253 */   // Label 13544: @885253
     /*  885253 */   GIM_Try, /*On fail goto*//*Label 13545*/ GIMT_Encode4(885328), // Rule ID 61218 //
     /*  885258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  885269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  885272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  885275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  885278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885304 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  885307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885326 */     GIR_RootConstrainSelectedInstOperands,
     /*  885327 */     // GIR_Coverage, 61218,
     /*  885327 */     GIR_EraseRootFromParent_Done,
     /*  885328 */   // Label 13545: @885328
     /*  885328 */   GIM_Try, /*On fail goto*//*Label 13546*/ GIMT_Encode4(885403), // Rule ID 61219 //
     /*  885333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  885344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  885347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  885350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  885353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885379 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  885382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885401 */     GIR_RootConstrainSelectedInstOperands,
     /*  885402 */     // GIR_Coverage, 61219,
     /*  885402 */     GIR_EraseRootFromParent_Done,
     /*  885403 */   // Label 13546: @885403
     /*  885403 */   GIM_Try, /*On fail goto*//*Label 13547*/ GIMT_Encode4(885478), // Rule ID 61222 //
     /*  885408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  885419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  885422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  885425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  885428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885454 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885476 */     GIR_RootConstrainSelectedInstOperands,
     /*  885477 */     // GIR_Coverage, 61222,
     /*  885477 */     GIR_EraseRootFromParent_Done,
     /*  885478 */   // Label 13547: @885478
     /*  885478 */   GIM_Try, /*On fail goto*//*Label 13548*/ GIMT_Encode4(885553), // Rule ID 61223 //
     /*  885483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  885494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  885497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  885500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  885503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885529 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885551 */     GIR_RootConstrainSelectedInstOperands,
     /*  885552 */     // GIR_Coverage, 61223,
     /*  885552 */     GIR_EraseRootFromParent_Done,
     /*  885553 */   // Label 13548: @885553
     /*  885553 */   GIM_Try, /*On fail goto*//*Label 13549*/ GIMT_Encode4(885628), // Rule ID 61226 //
     /*  885558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  885569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  885572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  885575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  885578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885604 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885626 */     GIR_RootConstrainSelectedInstOperands,
     /*  885627 */     // GIR_Coverage, 61226,
     /*  885627 */     GIR_EraseRootFromParent_Done,
     /*  885628 */   // Label 13549: @885628
     /*  885628 */   GIM_Try, /*On fail goto*//*Label 13550*/ GIMT_Encode4(885703), // Rule ID 61227 //
     /*  885633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  885644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  885647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  885650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  885653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885679 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885701 */     GIR_RootConstrainSelectedInstOperands,
     /*  885702 */     // GIR_Coverage, 61227,
     /*  885702 */     GIR_EraseRootFromParent_Done,
     /*  885703 */   // Label 13550: @885703
     /*  885703 */   GIM_Try, /*On fail goto*//*Label 13551*/ GIMT_Encode4(885778), // Rule ID 61230 //
     /*  885708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  885719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  885722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  885725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  885728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885754 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885776 */     GIR_RootConstrainSelectedInstOperands,
     /*  885777 */     // GIR_Coverage, 61230,
     /*  885777 */     GIR_EraseRootFromParent_Done,
     /*  885778 */   // Label 13551: @885778
     /*  885778 */   GIM_Try, /*On fail goto*//*Label 13552*/ GIMT_Encode4(885853), // Rule ID 61231 //
     /*  885783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  885794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  885797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  885800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  885803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885829 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885851 */     GIR_RootConstrainSelectedInstOperands,
     /*  885852 */     // GIR_Coverage, 61231,
     /*  885852 */     GIR_EraseRootFromParent_Done,
     /*  885853 */   // Label 13552: @885853
     /*  885853 */   GIM_Try, /*On fail goto*//*Label 13553*/ GIMT_Encode4(885928), // Rule ID 61234 //
     /*  885858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  885869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  885872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  885875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  885878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885904 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885926 */     GIR_RootConstrainSelectedInstOperands,
     /*  885927 */     // GIR_Coverage, 61234,
     /*  885927 */     GIR_EraseRootFromParent_Done,
     /*  885928 */   // Label 13553: @885928
     /*  885928 */   GIM_Try, /*On fail goto*//*Label 13554*/ GIMT_Encode4(886003), // Rule ID 61235 //
     /*  885933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  885944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  885947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  885950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  885953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885979 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886001 */     GIR_RootConstrainSelectedInstOperands,
     /*  886002 */     // GIR_Coverage, 61235,
     /*  886002 */     GIR_EraseRootFromParent_Done,
     /*  886003 */   // Label 13554: @886003
     /*  886003 */   GIM_Try, /*On fail goto*//*Label 13555*/ GIMT_Encode4(886078), // Rule ID 61238 //
     /*  886008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  886019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  886022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  886025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  886028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886076 */     GIR_RootConstrainSelectedInstOperands,
     /*  886077 */     // GIR_Coverage, 61238,
     /*  886077 */     GIR_EraseRootFromParent_Done,
     /*  886078 */   // Label 13555: @886078
     /*  886078 */   GIM_Try, /*On fail goto*//*Label 13556*/ GIMT_Encode4(886153), // Rule ID 61239 //
     /*  886083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  886094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  886097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  886100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  886103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886129 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886151 */     GIR_RootConstrainSelectedInstOperands,
     /*  886152 */     // GIR_Coverage, 61239,
     /*  886152 */     GIR_EraseRootFromParent_Done,
     /*  886153 */   // Label 13556: @886153
     /*  886153 */   GIM_Try, /*On fail goto*//*Label 13557*/ GIMT_Encode4(886228), // Rule ID 61242 //
     /*  886158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  886169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  886172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  886175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  886178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886204 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  886204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886226 */     GIR_RootConstrainSelectedInstOperands,
     /*  886227 */     // GIR_Coverage, 61242,
     /*  886227 */     GIR_EraseRootFromParent_Done,
     /*  886228 */   // Label 13557: @886228
     /*  886228 */   GIM_Try, /*On fail goto*//*Label 13558*/ GIMT_Encode4(886303), // Rule ID 61243 //
     /*  886233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  886244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  886247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  886250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  886253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886279 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  886279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886301 */     GIR_RootConstrainSelectedInstOperands,
     /*  886302 */     // GIR_Coverage, 61243,
     /*  886302 */     GIR_EraseRootFromParent_Done,
     /*  886303 */   // Label 13558: @886303
     /*  886303 */   GIM_Try, /*On fail goto*//*Label 13559*/ GIMT_Encode4(886378), // Rule ID 61246 //
     /*  886308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  886319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  886322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  886325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  886328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886354 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  886354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886376 */     GIR_RootConstrainSelectedInstOperands,
     /*  886377 */     // GIR_Coverage, 61246,
     /*  886377 */     GIR_EraseRootFromParent_Done,
     /*  886378 */   // Label 13559: @886378
     /*  886378 */   GIM_Try, /*On fail goto*//*Label 13560*/ GIMT_Encode4(886453), // Rule ID 61247 //
     /*  886383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  886394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  886397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  886400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  886403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886429 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  886429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886451 */     GIR_RootConstrainSelectedInstOperands,
     /*  886452 */     // GIR_Coverage, 61247,
     /*  886452 */     GIR_EraseRootFromParent_Done,
     /*  886453 */   // Label 13560: @886453
     /*  886453 */   GIM_Try, /*On fail goto*//*Label 13561*/ GIMT_Encode4(886528), // Rule ID 61250 //
     /*  886458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  886469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  886472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  886475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  886478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886504 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886526 */     GIR_RootConstrainSelectedInstOperands,
     /*  886527 */     // GIR_Coverage, 61250,
     /*  886527 */     GIR_EraseRootFromParent_Done,
     /*  886528 */   // Label 13561: @886528
     /*  886528 */   GIM_Try, /*On fail goto*//*Label 13562*/ GIMT_Encode4(886603), // Rule ID 61251 //
     /*  886533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  886544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  886547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  886550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  886553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886579 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886601 */     GIR_RootConstrainSelectedInstOperands,
     /*  886602 */     // GIR_Coverage, 61251,
     /*  886602 */     GIR_EraseRootFromParent_Done,
     /*  886603 */   // Label 13562: @886603
     /*  886603 */   GIM_Try, /*On fail goto*//*Label 13563*/ GIMT_Encode4(886678), // Rule ID 61254 //
     /*  886608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  886625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  886628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886654 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  886654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886676 */     GIR_RootConstrainSelectedInstOperands,
     /*  886677 */     // GIR_Coverage, 61254,
     /*  886677 */     GIR_EraseRootFromParent_Done,
     /*  886678 */   // Label 13563: @886678
     /*  886678 */   GIM_Try, /*On fail goto*//*Label 13564*/ GIMT_Encode4(886753), // Rule ID 61255 //
     /*  886683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  886700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  886703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886729 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  886729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886751 */     GIR_RootConstrainSelectedInstOperands,
     /*  886752 */     // GIR_Coverage, 61255,
     /*  886752 */     GIR_EraseRootFromParent_Done,
     /*  886753 */   // Label 13564: @886753
     /*  886753 */   GIM_Try, /*On fail goto*//*Label 13565*/ GIMT_Encode4(886828), // Rule ID 61258 //
     /*  886758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  886769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  886772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  886775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  886778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886804 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  886804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  886807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886826 */     GIR_RootConstrainSelectedInstOperands,
     /*  886827 */     // GIR_Coverage, 61258,
     /*  886827 */     GIR_EraseRootFromParent_Done,
     /*  886828 */   // Label 13565: @886828
     /*  886828 */   GIM_Try, /*On fail goto*//*Label 13566*/ GIMT_Encode4(886903), // Rule ID 61259 //
     /*  886833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  886844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  886847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  886850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  886853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886879 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  886879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  886882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886901 */     GIR_RootConstrainSelectedInstOperands,
     /*  886902 */     // GIR_Coverage, 61259,
     /*  886902 */     GIR_EraseRootFromParent_Done,
     /*  886903 */   // Label 13566: @886903
     /*  886903 */   GIM_Try, /*On fail goto*//*Label 13567*/ GIMT_Encode4(886978), // Rule ID 61262 //
     /*  886908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  886919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  886922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  886925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  886928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886954 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  886954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  886957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886976 */     GIR_RootConstrainSelectedInstOperands,
     /*  886977 */     // GIR_Coverage, 61262,
     /*  886977 */     GIR_EraseRootFromParent_Done,
     /*  886978 */   // Label 13567: @886978
     /*  886978 */   GIM_Try, /*On fail goto*//*Label 13568*/ GIMT_Encode4(887053), // Rule ID 61263 //
     /*  886983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  886994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  886997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  887000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  887003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887029 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  887029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887051 */     GIR_RootConstrainSelectedInstOperands,
     /*  887052 */     // GIR_Coverage, 61263,
     /*  887052 */     GIR_EraseRootFromParent_Done,
     /*  887053 */   // Label 13568: @887053
     /*  887053 */   GIM_Try, /*On fail goto*//*Label 13569*/ GIMT_Encode4(887128), // Rule ID 61266 //
     /*  887058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  887069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  887072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  887075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  887078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887104 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  887104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887126 */     GIR_RootConstrainSelectedInstOperands,
     /*  887127 */     // GIR_Coverage, 61266,
     /*  887127 */     GIR_EraseRootFromParent_Done,
     /*  887128 */   // Label 13569: @887128
     /*  887128 */   GIM_Try, /*On fail goto*//*Label 13570*/ GIMT_Encode4(887203), // Rule ID 61267 //
     /*  887133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  887144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  887147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  887150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  887153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887179 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  887179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887201 */     GIR_RootConstrainSelectedInstOperands,
     /*  887202 */     // GIR_Coverage, 61267,
     /*  887202 */     GIR_EraseRootFromParent_Done,
     /*  887203 */   // Label 13570: @887203
     /*  887203 */   GIM_Try, /*On fail goto*//*Label 13571*/ GIMT_Encode4(887278), // Rule ID 61270 //
     /*  887208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  887219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  887222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  887225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  887228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887254 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  887254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887276 */     GIR_RootConstrainSelectedInstOperands,
     /*  887277 */     // GIR_Coverage, 61270,
     /*  887277 */     GIR_EraseRootFromParent_Done,
     /*  887278 */   // Label 13571: @887278
     /*  887278 */   GIM_Try, /*On fail goto*//*Label 13572*/ GIMT_Encode4(887353), // Rule ID 61271 //
     /*  887283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  887294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  887297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  887300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  887303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887329 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  887329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887351 */     GIR_RootConstrainSelectedInstOperands,
     /*  887352 */     // GIR_Coverage, 61271,
     /*  887352 */     GIR_EraseRootFromParent_Done,
     /*  887353 */   // Label 13572: @887353
     /*  887353 */   GIM_Try, /*On fail goto*//*Label 13573*/ GIMT_Encode4(887428), // Rule ID 61274 //
     /*  887358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  887369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  887372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  887375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  887378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  887404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887426 */     GIR_RootConstrainSelectedInstOperands,
     /*  887427 */     // GIR_Coverage, 61274,
     /*  887427 */     GIR_EraseRootFromParent_Done,
     /*  887428 */   // Label 13573: @887428
     /*  887428 */   GIM_Try, /*On fail goto*//*Label 13574*/ GIMT_Encode4(887503), // Rule ID 61275 //
     /*  887433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  887444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  887447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  887450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  887453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887479 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  887479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887501 */     GIR_RootConstrainSelectedInstOperands,
     /*  887502 */     // GIR_Coverage, 61275,
     /*  887502 */     GIR_EraseRootFromParent_Done,
     /*  887503 */   // Label 13574: @887503
     /*  887503 */   GIM_Try, /*On fail goto*//*Label 13575*/ GIMT_Encode4(887578), // Rule ID 61278 //
     /*  887508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  887519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  887522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  887525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  887528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887554 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  887554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887576 */     GIR_RootConstrainSelectedInstOperands,
     /*  887577 */     // GIR_Coverage, 61278,
     /*  887577 */     GIR_EraseRootFromParent_Done,
     /*  887578 */   // Label 13575: @887578
     /*  887578 */   GIM_Try, /*On fail goto*//*Label 13576*/ GIMT_Encode4(887653), // Rule ID 61279 //
     /*  887583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  887594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  887597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  887600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  887603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887629 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  887629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887651 */     GIR_RootConstrainSelectedInstOperands,
     /*  887652 */     // GIR_Coverage, 61279,
     /*  887652 */     GIR_EraseRootFromParent_Done,
     /*  887653 */   // Label 13576: @887653
     /*  887653 */   GIM_Try, /*On fail goto*//*Label 13577*/ GIMT_Encode4(887728), // Rule ID 61282 //
     /*  887658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  887669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  887672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  887675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  887678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  887704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887726 */     GIR_RootConstrainSelectedInstOperands,
     /*  887727 */     // GIR_Coverage, 61282,
     /*  887727 */     GIR_EraseRootFromParent_Done,
     /*  887728 */   // Label 13577: @887728
     /*  887728 */   GIM_Try, /*On fail goto*//*Label 13578*/ GIMT_Encode4(887803), // Rule ID 61283 //
     /*  887733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  887744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  887747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  887750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  887753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887779 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  887779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887801 */     GIR_RootConstrainSelectedInstOperands,
     /*  887802 */     // GIR_Coverage, 61283,
     /*  887802 */     GIR_EraseRootFromParent_Done,
     /*  887803 */   // Label 13578: @887803
     /*  887803 */   GIM_Try, /*On fail goto*//*Label 13579*/ GIMT_Encode4(887878), // Rule ID 61286 //
     /*  887808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  887819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  887822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  887825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  887828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887854 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  887854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887876 */     GIR_RootConstrainSelectedInstOperands,
     /*  887877 */     // GIR_Coverage, 61286,
     /*  887877 */     GIR_EraseRootFromParent_Done,
     /*  887878 */   // Label 13579: @887878
     /*  887878 */   GIM_Try, /*On fail goto*//*Label 13580*/ GIMT_Encode4(887953), // Rule ID 61287 //
     /*  887883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  887894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  887897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  887900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  887903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887929 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  887929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887951 */     GIR_RootConstrainSelectedInstOperands,
     /*  887952 */     // GIR_Coverage, 61287,
     /*  887952 */     GIR_EraseRootFromParent_Done,
     /*  887953 */   // Label 13580: @887953
     /*  887953 */   GIM_Try, /*On fail goto*//*Label 13581*/ GIMT_Encode4(888028), // Rule ID 61290 //
     /*  887958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  887969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  887972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  887975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  887978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888004 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  888004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888026 */     GIR_RootConstrainSelectedInstOperands,
     /*  888027 */     // GIR_Coverage, 61290,
     /*  888027 */     GIR_EraseRootFromParent_Done,
     /*  888028 */   // Label 13581: @888028
     /*  888028 */   GIM_Try, /*On fail goto*//*Label 13582*/ GIMT_Encode4(888103), // Rule ID 61291 //
     /*  888033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  888044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  888047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  888050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  888053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888079 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  888079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888101 */     GIR_RootConstrainSelectedInstOperands,
     /*  888102 */     // GIR_Coverage, 61291,
     /*  888102 */     GIR_EraseRootFromParent_Done,
     /*  888103 */   // Label 13582: @888103
     /*  888103 */   GIM_Try, /*On fail goto*//*Label 13583*/ GIMT_Encode4(888178), // Rule ID 61294 //
     /*  888108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  888128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888154 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  888157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888176 */     GIR_RootConstrainSelectedInstOperands,
     /*  888177 */     // GIR_Coverage, 61294,
     /*  888177 */     GIR_EraseRootFromParent_Done,
     /*  888178 */   // Label 13583: @888178
     /*  888178 */   GIM_Try, /*On fail goto*//*Label 13584*/ GIMT_Encode4(888253), // Rule ID 61295 //
     /*  888183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  888203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888229 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  888232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888251 */     GIR_RootConstrainSelectedInstOperands,
     /*  888252 */     // GIR_Coverage, 61295,
     /*  888252 */     GIR_EraseRootFromParent_Done,
     /*  888253 */   // Label 13584: @888253
     /*  888253 */   GIM_Try, /*On fail goto*//*Label 13585*/ GIMT_Encode4(888328), // Rule ID 61298 //
     /*  888258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  888278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888304 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  888307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888326 */     GIR_RootConstrainSelectedInstOperands,
     /*  888327 */     // GIR_Coverage, 61298,
     /*  888327 */     GIR_EraseRootFromParent_Done,
     /*  888328 */   // Label 13585: @888328
     /*  888328 */   GIM_Try, /*On fail goto*//*Label 13586*/ GIMT_Encode4(888403), // Rule ID 61299 //
     /*  888333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  888353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888379 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  888382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888401 */     GIR_RootConstrainSelectedInstOperands,
     /*  888402 */     // GIR_Coverage, 61299,
     /*  888402 */     GIR_EraseRootFromParent_Done,
     /*  888403 */   // Label 13586: @888403
     /*  888403 */   GIM_Try, /*On fail goto*//*Label 13587*/ GIMT_Encode4(888478), // Rule ID 61302 //
     /*  888408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  888428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888476 */     GIR_RootConstrainSelectedInstOperands,
     /*  888477 */     // GIR_Coverage, 61302,
     /*  888477 */     GIR_EraseRootFromParent_Done,
     /*  888478 */   // Label 13587: @888478
     /*  888478 */   GIM_Try, /*On fail goto*//*Label 13588*/ GIMT_Encode4(888553), // Rule ID 61303 //
     /*  888483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  888503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888529 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888551 */     GIR_RootConstrainSelectedInstOperands,
     /*  888552 */     // GIR_Coverage, 61303,
     /*  888552 */     GIR_EraseRootFromParent_Done,
     /*  888553 */   // Label 13588: @888553
     /*  888553 */   GIM_Try, /*On fail goto*//*Label 13589*/ GIMT_Encode4(888628), // Rule ID 61306 //
     /*  888558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  888569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  888572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  888575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888604 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  888604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  888607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888626 */     GIR_RootConstrainSelectedInstOperands,
     /*  888627 */     // GIR_Coverage, 61306,
     /*  888627 */     GIR_EraseRootFromParent_Done,
     /*  888628 */   // Label 13589: @888628
     /*  888628 */   GIM_Try, /*On fail goto*//*Label 13590*/ GIMT_Encode4(888703), // Rule ID 61307 //
     /*  888633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  888644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  888647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  888650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888679 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  888679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  888682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888701 */     GIR_RootConstrainSelectedInstOperands,
     /*  888702 */     // GIR_Coverage, 61307,
     /*  888702 */     GIR_EraseRootFromParent_Done,
     /*  888703 */   // Label 13590: @888703
     /*  888703 */   GIM_Try, /*On fail goto*//*Label 13591*/ GIMT_Encode4(888778), // Rule ID 61310 //
     /*  888708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  888719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  888722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  888725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888754 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  888754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  888757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888776 */     GIR_RootConstrainSelectedInstOperands,
     /*  888777 */     // GIR_Coverage, 61310,
     /*  888777 */     GIR_EraseRootFromParent_Done,
     /*  888778 */   // Label 13591: @888778
     /*  888778 */   GIM_Try, /*On fail goto*//*Label 13592*/ GIMT_Encode4(888853), // Rule ID 61311 //
     /*  888783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  888794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  888797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  888800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888829 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  888829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  888832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888851 */     GIR_RootConstrainSelectedInstOperands,
     /*  888852 */     // GIR_Coverage, 61311,
     /*  888852 */     GIR_EraseRootFromParent_Done,
     /*  888853 */   // Label 13592: @888853
     /*  888853 */   GIM_Try, /*On fail goto*//*Label 13593*/ GIMT_Encode4(888928), // Rule ID 61314 //
     /*  888858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  888869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  888872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  888875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888904 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  888904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  888907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888926 */     GIR_RootConstrainSelectedInstOperands,
     /*  888927 */     // GIR_Coverage, 61314,
     /*  888927 */     GIR_EraseRootFromParent_Done,
     /*  888928 */   // Label 13593: @888928
     /*  888928 */   GIM_Try, /*On fail goto*//*Label 13594*/ GIMT_Encode4(889003), // Rule ID 61315 //
     /*  888933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  888944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  888947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  888950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888979 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  888979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  888982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889001 */     GIR_RootConstrainSelectedInstOperands,
     /*  889002 */     // GIR_Coverage, 61315,
     /*  889002 */     GIR_EraseRootFromParent_Done,
     /*  889003 */   // Label 13594: @889003
     /*  889003 */   GIM_Try, /*On fail goto*//*Label 13595*/ GIMT_Encode4(889078), // Rule ID 61318 //
     /*  889008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  889019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  889022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  889025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889054 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  889057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889076 */     GIR_RootConstrainSelectedInstOperands,
     /*  889077 */     // GIR_Coverage, 61318,
     /*  889077 */     GIR_EraseRootFromParent_Done,
     /*  889078 */   // Label 13595: @889078
     /*  889078 */   GIM_Try, /*On fail goto*//*Label 13596*/ GIMT_Encode4(889153), // Rule ID 61319 //
     /*  889083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  889094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  889097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  889100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889129 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  889132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889151 */     GIR_RootConstrainSelectedInstOperands,
     /*  889152 */     // GIR_Coverage, 61319,
     /*  889152 */     GIR_EraseRootFromParent_Done,
     /*  889153 */   // Label 13596: @889153
     /*  889153 */   GIM_Try, /*On fail goto*//*Label 13597*/ GIMT_Encode4(889228), // Rule ID 61322 //
     /*  889158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  889169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  889172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  889175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889204 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889226 */     GIR_RootConstrainSelectedInstOperands,
     /*  889227 */     // GIR_Coverage, 61322,
     /*  889227 */     GIR_EraseRootFromParent_Done,
     /*  889228 */   // Label 13597: @889228
     /*  889228 */   GIM_Try, /*On fail goto*//*Label 13598*/ GIMT_Encode4(889303), // Rule ID 61323 //
     /*  889233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  889244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  889247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  889250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889279 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889301 */     GIR_RootConstrainSelectedInstOperands,
     /*  889302 */     // GIR_Coverage, 61323,
     /*  889302 */     GIR_EraseRootFromParent_Done,
     /*  889303 */   // Label 13598: @889303
     /*  889303 */   GIM_Try, /*On fail goto*//*Label 13599*/ GIMT_Encode4(889378), // Rule ID 61326 //
     /*  889308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  889319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  889322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  889325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889354 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  889354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889376 */     GIR_RootConstrainSelectedInstOperands,
     /*  889377 */     // GIR_Coverage, 61326,
     /*  889377 */     GIR_EraseRootFromParent_Done,
     /*  889378 */   // Label 13599: @889378
     /*  889378 */   GIM_Try, /*On fail goto*//*Label 13600*/ GIMT_Encode4(889453), // Rule ID 61327 //
     /*  889383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  889394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  889397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  889400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889429 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  889429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889451 */     GIR_RootConstrainSelectedInstOperands,
     /*  889452 */     // GIR_Coverage, 61327,
     /*  889452 */     GIR_EraseRootFromParent_Done,
     /*  889453 */   // Label 13600: @889453
     /*  889453 */   GIM_Try, /*On fail goto*//*Label 13601*/ GIMT_Encode4(889528), // Rule ID 61330 //
     /*  889458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  889469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  889472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  889475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889504 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889526 */     GIR_RootConstrainSelectedInstOperands,
     /*  889527 */     // GIR_Coverage, 61330,
     /*  889527 */     GIR_EraseRootFromParent_Done,
     /*  889528 */   // Label 13601: @889528
     /*  889528 */   GIM_Try, /*On fail goto*//*Label 13602*/ GIMT_Encode4(889603), // Rule ID 61331 //
     /*  889533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  889544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  889547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  889550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889579 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889601 */     GIR_RootConstrainSelectedInstOperands,
     /*  889602 */     // GIR_Coverage, 61331,
     /*  889602 */     GIR_EraseRootFromParent_Done,
     /*  889603 */   // Label 13602: @889603
     /*  889603 */   GIM_Try, /*On fail goto*//*Label 13603*/ GIMT_Encode4(889678), // Rule ID 61334 //
     /*  889608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  889619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  889622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  889625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889654 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889676 */     GIR_RootConstrainSelectedInstOperands,
     /*  889677 */     // GIR_Coverage, 61334,
     /*  889677 */     GIR_EraseRootFromParent_Done,
     /*  889678 */   // Label 13603: @889678
     /*  889678 */   GIM_Try, /*On fail goto*//*Label 13604*/ GIMT_Encode4(889753), // Rule ID 61335 //
     /*  889683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  889694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  889697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  889700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889729 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889751 */     GIR_RootConstrainSelectedInstOperands,
     /*  889752 */     // GIR_Coverage, 61335,
     /*  889752 */     GIR_EraseRootFromParent_Done,
     /*  889753 */   // Label 13604: @889753
     /*  889753 */   GIM_Try, /*On fail goto*//*Label 13605*/ GIMT_Encode4(889828), // Rule ID 61338 //
     /*  889758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  889769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  889772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  889775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889804 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  889804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889826 */     GIR_RootConstrainSelectedInstOperands,
     /*  889827 */     // GIR_Coverage, 61338,
     /*  889827 */     GIR_EraseRootFromParent_Done,
     /*  889828 */   // Label 13605: @889828
     /*  889828 */   GIM_Try, /*On fail goto*//*Label 13606*/ GIMT_Encode4(889903), // Rule ID 61339 //
     /*  889833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  889844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  889847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  889850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889879 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  889879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889901 */     GIR_RootConstrainSelectedInstOperands,
     /*  889902 */     // GIR_Coverage, 61339,
     /*  889902 */     GIR_EraseRootFromParent_Done,
     /*  889903 */   // Label 13606: @889903
     /*  889903 */   GIM_Try, /*On fail goto*//*Label 13607*/ GIMT_Encode4(889978), // Rule ID 61342 //
     /*  889908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  889919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  889922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  889925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889954 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  889954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889976 */     GIR_RootConstrainSelectedInstOperands,
     /*  889977 */     // GIR_Coverage, 61342,
     /*  889977 */     GIR_EraseRootFromParent_Done,
     /*  889978 */   // Label 13607: @889978
     /*  889978 */   GIM_Try, /*On fail goto*//*Label 13608*/ GIMT_Encode4(890053), // Rule ID 61343 //
     /*  889983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  889994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  889997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  890000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890029 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  890029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  890048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890051 */     GIR_RootConstrainSelectedInstOperands,
     /*  890052 */     // GIR_Coverage, 61343,
     /*  890052 */     GIR_EraseRootFromParent_Done,
     /*  890053 */   // Label 13608: @890053
     /*  890053 */   GIM_Try, /*On fail goto*//*Label 13609*/ GIMT_Encode4(890128), // Rule ID 61346 //
     /*  890058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  890069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  890072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  890075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890104 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890126 */     GIR_RootConstrainSelectedInstOperands,
     /*  890127 */     // GIR_Coverage, 61346,
     /*  890127 */     GIR_EraseRootFromParent_Done,
     /*  890128 */   // Label 13609: @890128
     /*  890128 */   GIM_Try, /*On fail goto*//*Label 13610*/ GIMT_Encode4(890203), // Rule ID 61347 //
     /*  890133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  890144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  890147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  890150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890179 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890201 */     GIR_RootConstrainSelectedInstOperands,
     /*  890202 */     // GIR_Coverage, 61347,
     /*  890202 */     GIR_EraseRootFromParent_Done,
     /*  890203 */   // Label 13610: @890203
     /*  890203 */   GIM_Try, /*On fail goto*//*Label 13611*/ GIMT_Encode4(890278), // Rule ID 61350 //
     /*  890208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  890219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  890222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  890225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890254 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890276 */     GIR_RootConstrainSelectedInstOperands,
     /*  890277 */     // GIR_Coverage, 61350,
     /*  890277 */     GIR_EraseRootFromParent_Done,
     /*  890278 */   // Label 13611: @890278
     /*  890278 */   GIM_Try, /*On fail goto*//*Label 13612*/ GIMT_Encode4(890353), // Rule ID 61351 //
     /*  890283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  890294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  890297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  890300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890329 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890351 */     GIR_RootConstrainSelectedInstOperands,
     /*  890352 */     // GIR_Coverage, 61351,
     /*  890352 */     GIR_EraseRootFromParent_Done,
     /*  890353 */   // Label 13612: @890353
     /*  890353 */   GIM_Try, /*On fail goto*//*Label 13613*/ GIMT_Encode4(890428), // Rule ID 61354 //
     /*  890358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  890369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  890372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  890375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890404 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890426 */     GIR_RootConstrainSelectedInstOperands,
     /*  890427 */     // GIR_Coverage, 61354,
     /*  890427 */     GIR_EraseRootFromParent_Done,
     /*  890428 */   // Label 13613: @890428
     /*  890428 */   GIM_Try, /*On fail goto*//*Label 13614*/ GIMT_Encode4(890503), // Rule ID 61355 //
     /*  890433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  890444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  890447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  890450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890479 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890501 */     GIR_RootConstrainSelectedInstOperands,
     /*  890502 */     // GIR_Coverage, 61355,
     /*  890502 */     GIR_EraseRootFromParent_Done,
     /*  890503 */   // Label 13614: @890503
     /*  890503 */   GIM_Try, /*On fail goto*//*Label 13615*/ GIMT_Encode4(890578), // Rule ID 61358 //
     /*  890508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  890519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  890522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  890525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890554 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  890554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890576 */     GIR_RootConstrainSelectedInstOperands,
     /*  890577 */     // GIR_Coverage, 61358,
     /*  890577 */     GIR_EraseRootFromParent_Done,
     /*  890578 */   // Label 13615: @890578
     /*  890578 */   GIM_Try, /*On fail goto*//*Label 13616*/ GIMT_Encode4(890653), // Rule ID 61359 //
     /*  890583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  890594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  890597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  890600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890629 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  890629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890651 */     GIR_RootConstrainSelectedInstOperands,
     /*  890652 */     // GIR_Coverage, 61359,
     /*  890652 */     GIR_EraseRootFromParent_Done,
     /*  890653 */   // Label 13616: @890653
     /*  890653 */   GIM_Try, /*On fail goto*//*Label 13617*/ GIMT_Encode4(890728), // Rule ID 61362 //
     /*  890658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  890669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  890672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  890675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890704 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  890704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890726 */     GIR_RootConstrainSelectedInstOperands,
     /*  890727 */     // GIR_Coverage, 61362,
     /*  890727 */     GIR_EraseRootFromParent_Done,
     /*  890728 */   // Label 13617: @890728
     /*  890728 */   GIM_Try, /*On fail goto*//*Label 13618*/ GIMT_Encode4(890803), // Rule ID 61363 //
     /*  890733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  890744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  890747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  890750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890779 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  890779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890801 */     GIR_RootConstrainSelectedInstOperands,
     /*  890802 */     // GIR_Coverage, 61363,
     /*  890802 */     GIR_EraseRootFromParent_Done,
     /*  890803 */   // Label 13618: @890803
     /*  890803 */   GIM_Try, /*On fail goto*//*Label 13619*/ GIMT_Encode4(890878), // Rule ID 61366 //
     /*  890808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  890819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  890822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  890825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890854 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  890854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890876 */     GIR_RootConstrainSelectedInstOperands,
     /*  890877 */     // GIR_Coverage, 61366,
     /*  890877 */     GIR_EraseRootFromParent_Done,
     /*  890878 */   // Label 13619: @890878
     /*  890878 */   GIM_Try, /*On fail goto*//*Label 13620*/ GIMT_Encode4(890953), // Rule ID 61367 //
     /*  890883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  890894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  890897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  890900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890929 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  890929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890951 */     GIR_RootConstrainSelectedInstOperands,
     /*  890952 */     // GIR_Coverage, 61367,
     /*  890952 */     GIR_EraseRootFromParent_Done,
     /*  890953 */   // Label 13620: @890953
     /*  890953 */   GIM_Try, /*On fail goto*//*Label 13621*/ GIMT_Encode4(891028), // Rule ID 61370 //
     /*  890958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  890969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  890972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  890975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891004 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891026 */     GIR_RootConstrainSelectedInstOperands,
     /*  891027 */     // GIR_Coverage, 61370,
     /*  891027 */     GIR_EraseRootFromParent_Done,
     /*  891028 */   // Label 13621: @891028
     /*  891028 */   GIM_Try, /*On fail goto*//*Label 13622*/ GIMT_Encode4(891103), // Rule ID 61371 //
     /*  891033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  891044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  891047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  891050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891079 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891101 */     GIR_RootConstrainSelectedInstOperands,
     /*  891102 */     // GIR_Coverage, 61371,
     /*  891102 */     GIR_EraseRootFromParent_Done,
     /*  891103 */   // Label 13622: @891103
     /*  891103 */   GIM_Try, /*On fail goto*//*Label 13623*/ GIMT_Encode4(891178), // Rule ID 61374 //
     /*  891108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  891119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  891122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  891125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891154 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891176 */     GIR_RootConstrainSelectedInstOperands,
     /*  891177 */     // GIR_Coverage, 61374,
     /*  891177 */     GIR_EraseRootFromParent_Done,
     /*  891178 */   // Label 13623: @891178
     /*  891178 */   GIM_Try, /*On fail goto*//*Label 13624*/ GIMT_Encode4(891253), // Rule ID 61375 //
     /*  891183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  891194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  891197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  891200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891229 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891251 */     GIR_RootConstrainSelectedInstOperands,
     /*  891252 */     // GIR_Coverage, 61375,
     /*  891252 */     GIR_EraseRootFromParent_Done,
     /*  891253 */   // Label 13624: @891253
     /*  891253 */   GIM_Try, /*On fail goto*//*Label 13625*/ GIMT_Encode4(891328), // Rule ID 61378 //
     /*  891258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  891269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  891272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  891275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891304 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891326 */     GIR_RootConstrainSelectedInstOperands,
     /*  891327 */     // GIR_Coverage, 61378,
     /*  891327 */     GIR_EraseRootFromParent_Done,
     /*  891328 */   // Label 13625: @891328
     /*  891328 */   GIM_Try, /*On fail goto*//*Label 13626*/ GIMT_Encode4(891403), // Rule ID 61379 //
     /*  891333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  891344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  891347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  891350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891379 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891401 */     GIR_RootConstrainSelectedInstOperands,
     /*  891402 */     // GIR_Coverage, 61379,
     /*  891402 */     GIR_EraseRootFromParent_Done,
     /*  891403 */   // Label 13626: @891403
     /*  891403 */   GIM_Try, /*On fail goto*//*Label 13627*/ GIMT_Encode4(891478), // Rule ID 61382 //
     /*  891408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  891419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  891422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  891425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891454 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  891454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891476 */     GIR_RootConstrainSelectedInstOperands,
     /*  891477 */     // GIR_Coverage, 61382,
     /*  891477 */     GIR_EraseRootFromParent_Done,
     /*  891478 */   // Label 13627: @891478
     /*  891478 */   GIM_Try, /*On fail goto*//*Label 13628*/ GIMT_Encode4(891553), // Rule ID 61383 //
     /*  891483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  891494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  891497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  891500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891529 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  891529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891551 */     GIR_RootConstrainSelectedInstOperands,
     /*  891552 */     // GIR_Coverage, 61383,
     /*  891552 */     GIR_EraseRootFromParent_Done,
     /*  891553 */   // Label 13628: @891553
     /*  891553 */   GIM_Try, /*On fail goto*//*Label 13629*/ GIMT_Encode4(891628), // Rule ID 61386 //
     /*  891558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  891569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  891572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  891575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  891604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891626 */     GIR_RootConstrainSelectedInstOperands,
     /*  891627 */     // GIR_Coverage, 61386,
     /*  891627 */     GIR_EraseRootFromParent_Done,
     /*  891628 */   // Label 13629: @891628
     /*  891628 */   GIM_Try, /*On fail goto*//*Label 13630*/ GIMT_Encode4(891703), // Rule ID 61387 //
     /*  891633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  891644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  891647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  891650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891679 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  891679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891701 */     GIR_RootConstrainSelectedInstOperands,
     /*  891702 */     // GIR_Coverage, 61387,
     /*  891702 */     GIR_EraseRootFromParent_Done,
     /*  891703 */   // Label 13630: @891703
     /*  891703 */   GIM_Try, /*On fail goto*//*Label 13631*/ GIMT_Encode4(891778), // Rule ID 61390 //
     /*  891708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  891719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  891722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  891725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891754 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  891754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891776 */     GIR_RootConstrainSelectedInstOperands,
     /*  891777 */     // GIR_Coverage, 61390,
     /*  891777 */     GIR_EraseRootFromParent_Done,
     /*  891778 */   // Label 13631: @891778
     /*  891778 */   GIM_Try, /*On fail goto*//*Label 13632*/ GIMT_Encode4(891853), // Rule ID 61391 //
     /*  891783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  891794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  891797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  891800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891829 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  891829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891851 */     GIR_RootConstrainSelectedInstOperands,
     /*  891852 */     // GIR_Coverage, 61391,
     /*  891852 */     GIR_EraseRootFromParent_Done,
     /*  891853 */   // Label 13632: @891853
     /*  891853 */   GIM_Try, /*On fail goto*//*Label 13633*/ GIMT_Encode4(891928), // Rule ID 61570 //
     /*  891858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  891866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  891869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  891872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  891875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  891878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891904 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  891904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  891907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891926 */     GIR_RootConstrainSelectedInstOperands,
     /*  891927 */     // GIR_Coverage, 61570,
     /*  891927 */     GIR_EraseRootFromParent_Done,
     /*  891928 */   // Label 13633: @891928
     /*  891928 */   GIM_Try, /*On fail goto*//*Label 13634*/ GIMT_Encode4(892003), // Rule ID 61571 //
     /*  891933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  891941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  891944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  891947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  891950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  891953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891979 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  891979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  891982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892001 */     GIR_RootConstrainSelectedInstOperands,
     /*  892002 */     // GIR_Coverage, 61571,
     /*  892002 */     GIR_EraseRootFromParent_Done,
     /*  892003 */   // Label 13634: @892003
     /*  892003 */   GIM_Try, /*On fail goto*//*Label 13635*/ GIMT_Encode4(892078), // Rule ID 61574 //
     /*  892008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  892019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  892022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  892025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  892028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892054 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892076 */     GIR_RootConstrainSelectedInstOperands,
     /*  892077 */     // GIR_Coverage, 61574,
     /*  892077 */     GIR_EraseRootFromParent_Done,
     /*  892078 */   // Label 13635: @892078
     /*  892078 */   GIM_Try, /*On fail goto*//*Label 13636*/ GIMT_Encode4(892153), // Rule ID 61575 //
     /*  892083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  892094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  892097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  892100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  892103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892129 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892151 */     GIR_RootConstrainSelectedInstOperands,
     /*  892152 */     // GIR_Coverage, 61575,
     /*  892152 */     GIR_EraseRootFromParent_Done,
     /*  892153 */   // Label 13636: @892153
     /*  892153 */   GIM_Try, /*On fail goto*//*Label 13637*/ GIMT_Encode4(892228), // Rule ID 61578 //
     /*  892158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  892169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  892172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  892175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  892178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892204 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892226 */     GIR_RootConstrainSelectedInstOperands,
     /*  892227 */     // GIR_Coverage, 61578,
     /*  892227 */     GIR_EraseRootFromParent_Done,
     /*  892228 */   // Label 13637: @892228
     /*  892228 */   GIM_Try, /*On fail goto*//*Label 13638*/ GIMT_Encode4(892303), // Rule ID 61579 //
     /*  892233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  892244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  892247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  892250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  892253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892279 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892301 */     GIR_RootConstrainSelectedInstOperands,
     /*  892302 */     // GIR_Coverage, 61579,
     /*  892302 */     GIR_EraseRootFromParent_Done,
     /*  892303 */   // Label 13638: @892303
     /*  892303 */   GIM_Try, /*On fail goto*//*Label 13639*/ GIMT_Encode4(892378), // Rule ID 61582 //
     /*  892308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  892319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  892322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  892325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  892328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892354 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  892354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892376 */     GIR_RootConstrainSelectedInstOperands,
     /*  892377 */     // GIR_Coverage, 61582,
     /*  892377 */     GIR_EraseRootFromParent_Done,
     /*  892378 */   // Label 13639: @892378
     /*  892378 */   GIM_Try, /*On fail goto*//*Label 13640*/ GIMT_Encode4(892453), // Rule ID 61583 //
     /*  892383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  892394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  892397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  892400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  892403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892429 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  892429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892451 */     GIR_RootConstrainSelectedInstOperands,
     /*  892452 */     // GIR_Coverage, 61583,
     /*  892452 */     GIR_EraseRootFromParent_Done,
     /*  892453 */   // Label 13640: @892453
     /*  892453 */   GIM_Try, /*On fail goto*//*Label 13641*/ GIMT_Encode4(892528), // Rule ID 61586 //
     /*  892458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  892469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  892472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  892475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  892478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892504 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  892504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892526 */     GIR_RootConstrainSelectedInstOperands,
     /*  892527 */     // GIR_Coverage, 61586,
     /*  892527 */     GIR_EraseRootFromParent_Done,
     /*  892528 */   // Label 13641: @892528
     /*  892528 */   GIM_Try, /*On fail goto*//*Label 13642*/ GIMT_Encode4(892603), // Rule ID 61587 //
     /*  892533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  892544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  892547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  892550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  892553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892579 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  892579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892601 */     GIR_RootConstrainSelectedInstOperands,
     /*  892602 */     // GIR_Coverage, 61587,
     /*  892602 */     GIR_EraseRootFromParent_Done,
     /*  892603 */   // Label 13642: @892603
     /*  892603 */   GIM_Try, /*On fail goto*//*Label 13643*/ GIMT_Encode4(892678), // Rule ID 61590 //
     /*  892608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  892619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  892622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  892625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  892628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  892654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  892673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892676 */     GIR_RootConstrainSelectedInstOperands,
     /*  892677 */     // GIR_Coverage, 61590,
     /*  892677 */     GIR_EraseRootFromParent_Done,
     /*  892678 */   // Label 13643: @892678
     /*  892678 */   GIM_Try, /*On fail goto*//*Label 13644*/ GIMT_Encode4(892753), // Rule ID 61591 //
     /*  892683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  892694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  892697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  892700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  892703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892729 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  892729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  892748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892751 */     GIR_RootConstrainSelectedInstOperands,
     /*  892752 */     // GIR_Coverage, 61591,
     /*  892752 */     GIR_EraseRootFromParent_Done,
     /*  892753 */   // Label 13644: @892753
     /*  892753 */   GIM_Try, /*On fail goto*//*Label 13645*/ GIMT_Encode4(892828), // Rule ID 61594 //
     /*  892758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  892769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  892772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  892775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  892778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892804 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892826 */     GIR_RootConstrainSelectedInstOperands,
     /*  892827 */     // GIR_Coverage, 61594,
     /*  892827 */     GIR_EraseRootFromParent_Done,
     /*  892828 */   // Label 13645: @892828
     /*  892828 */   GIM_Try, /*On fail goto*//*Label 13646*/ GIMT_Encode4(892903), // Rule ID 61595 //
     /*  892833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  892844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  892847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  892850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  892853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892879 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892901 */     GIR_RootConstrainSelectedInstOperands,
     /*  892902 */     // GIR_Coverage, 61595,
     /*  892902 */     GIR_EraseRootFromParent_Done,
     /*  892903 */   // Label 13646: @892903
     /*  892903 */   GIM_Try, /*On fail goto*//*Label 13647*/ GIMT_Encode4(892978), // Rule ID 61598 //
     /*  892908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  892919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  892922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  892925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  892928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892954 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  892954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892976 */     GIR_RootConstrainSelectedInstOperands,
     /*  892977 */     // GIR_Coverage, 61598,
     /*  892977 */     GIR_EraseRootFromParent_Done,
     /*  892978 */   // Label 13647: @892978
     /*  892978 */   GIM_Try, /*On fail goto*//*Label 13648*/ GIMT_Encode4(893053), // Rule ID 61599 //
     /*  892983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  892994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  892997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  893000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  893003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893029 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893051 */     GIR_RootConstrainSelectedInstOperands,
     /*  893052 */     // GIR_Coverage, 61599,
     /*  893052 */     GIR_EraseRootFromParent_Done,
     /*  893053 */   // Label 13648: @893053
     /*  893053 */   GIM_Try, /*On fail goto*//*Label 13649*/ GIMT_Encode4(893128), // Rule ID 61602 //
     /*  893058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  893069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  893072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  893075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  893078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  893104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893126 */     GIR_RootConstrainSelectedInstOperands,
     /*  893127 */     // GIR_Coverage, 61602,
     /*  893127 */     GIR_EraseRootFromParent_Done,
     /*  893128 */   // Label 13649: @893128
     /*  893128 */   GIM_Try, /*On fail goto*//*Label 13650*/ GIMT_Encode4(893203), // Rule ID 61603 //
     /*  893133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  893144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  893147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  893150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  893153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893179 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  893179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893201 */     GIR_RootConstrainSelectedInstOperands,
     /*  893202 */     // GIR_Coverage, 61603,
     /*  893202 */     GIR_EraseRootFromParent_Done,
     /*  893203 */   // Label 13650: @893203
     /*  893203 */   GIM_Try, /*On fail goto*//*Label 13651*/ GIMT_Encode4(893278), // Rule ID 61606 //
     /*  893208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  893219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  893222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  893225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  893228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893254 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  893254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893276 */     GIR_RootConstrainSelectedInstOperands,
     /*  893277 */     // GIR_Coverage, 61606,
     /*  893277 */     GIR_EraseRootFromParent_Done,
     /*  893278 */   // Label 13651: @893278
     /*  893278 */   GIM_Try, /*On fail goto*//*Label 13652*/ GIMT_Encode4(893353), // Rule ID 61607 //
     /*  893283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  893294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  893297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  893300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  893303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893329 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  893329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893351 */     GIR_RootConstrainSelectedInstOperands,
     /*  893352 */     // GIR_Coverage, 61607,
     /*  893352 */     GIR_EraseRootFromParent_Done,
     /*  893353 */   // Label 13652: @893353
     /*  893353 */   GIM_Try, /*On fail goto*//*Label 13653*/ GIMT_Encode4(893428), // Rule ID 61610 //
     /*  893358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  893369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  893372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  893375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  893378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893404 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893426 */     GIR_RootConstrainSelectedInstOperands,
     /*  893427 */     // GIR_Coverage, 61610,
     /*  893427 */     GIR_EraseRootFromParent_Done,
     /*  893428 */   // Label 13653: @893428
     /*  893428 */   GIM_Try, /*On fail goto*//*Label 13654*/ GIMT_Encode4(893503), // Rule ID 61611 //
     /*  893433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  893444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  893447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  893450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  893453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893479 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893501 */     GIR_RootConstrainSelectedInstOperands,
     /*  893502 */     // GIR_Coverage, 61611,
     /*  893502 */     GIR_EraseRootFromParent_Done,
     /*  893503 */   // Label 13654: @893503
     /*  893503 */   GIM_Try, /*On fail goto*//*Label 13655*/ GIMT_Encode4(893578), // Rule ID 61614 //
     /*  893508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  893519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  893522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  893525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  893528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893554 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  893557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893576 */     GIR_RootConstrainSelectedInstOperands,
     /*  893577 */     // GIR_Coverage, 61614,
     /*  893577 */     GIR_EraseRootFromParent_Done,
     /*  893578 */   // Label 13655: @893578
     /*  893578 */   GIM_Try, /*On fail goto*//*Label 13656*/ GIMT_Encode4(893653), // Rule ID 61615 //
     /*  893583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  893594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  893597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  893600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  893603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893629 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  893632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893651 */     GIR_RootConstrainSelectedInstOperands,
     /*  893652 */     // GIR_Coverage, 61615,
     /*  893652 */     GIR_EraseRootFromParent_Done,
     /*  893653 */   // Label 13656: @893653
     /*  893653 */   GIM_Try, /*On fail goto*//*Label 13657*/ GIMT_Encode4(893728), // Rule ID 61618 //
     /*  893658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  893669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  893672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  893675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  893678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893704 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  893707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893726 */     GIR_RootConstrainSelectedInstOperands,
     /*  893727 */     // GIR_Coverage, 61618,
     /*  893727 */     GIR_EraseRootFromParent_Done,
     /*  893728 */   // Label 13657: @893728
     /*  893728 */   GIM_Try, /*On fail goto*//*Label 13658*/ GIMT_Encode4(893803), // Rule ID 61619 //
     /*  893733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  893744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  893747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  893750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  893753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893779 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  893782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893801 */     GIR_RootConstrainSelectedInstOperands,
     /*  893802 */     // GIR_Coverage, 61619,
     /*  893802 */     GIR_EraseRootFromParent_Done,
     /*  893803 */   // Label 13658: @893803
     /*  893803 */   GIM_Try, /*On fail goto*//*Label 13659*/ GIMT_Encode4(893878), // Rule ID 61622 //
     /*  893808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  893819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  893822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  893825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  893828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893854 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  893854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893876 */     GIR_RootConstrainSelectedInstOperands,
     /*  893877 */     // GIR_Coverage, 61622,
     /*  893877 */     GIR_EraseRootFromParent_Done,
     /*  893878 */   // Label 13659: @893878
     /*  893878 */   GIM_Try, /*On fail goto*//*Label 13660*/ GIMT_Encode4(893953), // Rule ID 61623 //
     /*  893883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  893894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  893897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  893900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  893903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893929 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893951 */     GIR_RootConstrainSelectedInstOperands,
     /*  893952 */     // GIR_Coverage, 61623,
     /*  893952 */     GIR_EraseRootFromParent_Done,
     /*  893953 */   // Label 13660: @893953
     /*  893953 */   GIM_Try, /*On fail goto*//*Label 13661*/ GIMT_Encode4(894028), // Rule ID 61626 //
     /*  893958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  893969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  893972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  893975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  893978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894004 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894026 */     GIR_RootConstrainSelectedInstOperands,
     /*  894027 */     // GIR_Coverage, 61626,
     /*  894027 */     GIR_EraseRootFromParent_Done,
     /*  894028 */   // Label 13661: @894028
     /*  894028 */   GIM_Try, /*On fail goto*//*Label 13662*/ GIMT_Encode4(894103), // Rule ID 61627 //
     /*  894033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  894044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  894047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  894050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  894053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894079 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894101 */     GIR_RootConstrainSelectedInstOperands,
     /*  894102 */     // GIR_Coverage, 61627,
     /*  894102 */     GIR_EraseRootFromParent_Done,
     /*  894103 */   // Label 13662: @894103
     /*  894103 */   GIM_Try, /*On fail goto*//*Label 13663*/ GIMT_Encode4(894178), // Rule ID 61630 //
     /*  894108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  894119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  894122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  894125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  894128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894154 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894176 */     GIR_RootConstrainSelectedInstOperands,
     /*  894177 */     // GIR_Coverage, 61630,
     /*  894177 */     GIR_EraseRootFromParent_Done,
     /*  894178 */   // Label 13663: @894178
     /*  894178 */   GIM_Try, /*On fail goto*//*Label 13664*/ GIMT_Encode4(894253), // Rule ID 61631 //
     /*  894183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  894194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  894197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  894200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  894203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894229 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894251 */     GIR_RootConstrainSelectedInstOperands,
     /*  894252 */     // GIR_Coverage, 61631,
     /*  894252 */     GIR_EraseRootFromParent_Done,
     /*  894253 */   // Label 13664: @894253
     /*  894253 */   GIM_Try, /*On fail goto*//*Label 13665*/ GIMT_Encode4(894328), // Rule ID 61634 //
     /*  894258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  894269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  894272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  894275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  894278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894304 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894326 */     GIR_RootConstrainSelectedInstOperands,
     /*  894327 */     // GIR_Coverage, 61634,
     /*  894327 */     GIR_EraseRootFromParent_Done,
     /*  894328 */   // Label 13665: @894328
     /*  894328 */   GIM_Try, /*On fail goto*//*Label 13666*/ GIMT_Encode4(894403), // Rule ID 61635 //
     /*  894333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  894344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  894347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  894350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  894353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894379 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894401 */     GIR_RootConstrainSelectedInstOperands,
     /*  894402 */     // GIR_Coverage, 61635,
     /*  894402 */     GIR_EraseRootFromParent_Done,
     /*  894403 */   // Label 13666: @894403
     /*  894403 */   GIM_Try, /*On fail goto*//*Label 13667*/ GIMT_Encode4(894478), // Rule ID 61638 //
     /*  894408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  894419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  894422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  894425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  894428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894454 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894476 */     GIR_RootConstrainSelectedInstOperands,
     /*  894477 */     // GIR_Coverage, 61638,
     /*  894477 */     GIR_EraseRootFromParent_Done,
     /*  894478 */   // Label 13667: @894478
     /*  894478 */   GIM_Try, /*On fail goto*//*Label 13668*/ GIMT_Encode4(894553), // Rule ID 61639 //
     /*  894483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  894494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  894497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  894500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  894503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894529 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894551 */     GIR_RootConstrainSelectedInstOperands,
     /*  894552 */     // GIR_Coverage, 61639,
     /*  894552 */     GIR_EraseRootFromParent_Done,
     /*  894553 */   // Label 13668: @894553
     /*  894553 */   GIM_Try, /*On fail goto*//*Label 13669*/ GIMT_Encode4(894628), // Rule ID 61642 //
     /*  894558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  894569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  894572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  894575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  894578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894604 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894626 */     GIR_RootConstrainSelectedInstOperands,
     /*  894627 */     // GIR_Coverage, 61642,
     /*  894627 */     GIR_EraseRootFromParent_Done,
     /*  894628 */   // Label 13669: @894628
     /*  894628 */   GIM_Try, /*On fail goto*//*Label 13670*/ GIMT_Encode4(894703), // Rule ID 61643 //
     /*  894633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  894644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  894647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  894650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  894653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894679 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894701 */     GIR_RootConstrainSelectedInstOperands,
     /*  894702 */     // GIR_Coverage, 61643,
     /*  894702 */     GIR_EraseRootFromParent_Done,
     /*  894703 */   // Label 13670: @894703
     /*  894703 */   GIM_Try, /*On fail goto*//*Label 13671*/ GIMT_Encode4(894778), // Rule ID 61646 //
     /*  894708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  894719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  894722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  894725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  894728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894754 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  894754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894776 */     GIR_RootConstrainSelectedInstOperands,
     /*  894777 */     // GIR_Coverage, 61646,
     /*  894777 */     GIR_EraseRootFromParent_Done,
     /*  894778 */   // Label 13671: @894778
     /*  894778 */   GIM_Try, /*On fail goto*//*Label 13672*/ GIMT_Encode4(894853), // Rule ID 61647 //
     /*  894783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  894794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  894797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  894800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  894803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894829 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  894829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894851 */     GIR_RootConstrainSelectedInstOperands,
     /*  894852 */     // GIR_Coverage, 61647,
     /*  894852 */     GIR_EraseRootFromParent_Done,
     /*  894853 */   // Label 13672: @894853
     /*  894853 */   GIM_Try, /*On fail goto*//*Label 13673*/ GIMT_Encode4(894928), // Rule ID 61650 //
     /*  894858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  894869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  894872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  894875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  894878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894904 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  894904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894926 */     GIR_RootConstrainSelectedInstOperands,
     /*  894927 */     // GIR_Coverage, 61650,
     /*  894927 */     GIR_EraseRootFromParent_Done,
     /*  894928 */   // Label 13673: @894928
     /*  894928 */   GIM_Try, /*On fail goto*//*Label 13674*/ GIMT_Encode4(895003), // Rule ID 61651 //
     /*  894933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  894944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  894947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  894950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  894953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894979 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  894979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895001 */     GIR_RootConstrainSelectedInstOperands,
     /*  895002 */     // GIR_Coverage, 61651,
     /*  895002 */     GIR_EraseRootFromParent_Done,
     /*  895003 */   // Label 13674: @895003
     /*  895003 */   GIM_Try, /*On fail goto*//*Label 13675*/ GIMT_Encode4(895078), // Rule ID 61654 //
     /*  895008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  895019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  895022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  895025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  895028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895054 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  895057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895076 */     GIR_RootConstrainSelectedInstOperands,
     /*  895077 */     // GIR_Coverage, 61654,
     /*  895077 */     GIR_EraseRootFromParent_Done,
     /*  895078 */   // Label 13675: @895078
     /*  895078 */   GIM_Try, /*On fail goto*//*Label 13676*/ GIMT_Encode4(895153), // Rule ID 61655 //
     /*  895083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  895094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  895097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  895100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  895103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895129 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  895132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895151 */     GIR_RootConstrainSelectedInstOperands,
     /*  895152 */     // GIR_Coverage, 61655,
     /*  895152 */     GIR_EraseRootFromParent_Done,
     /*  895153 */   // Label 13676: @895153
     /*  895153 */   GIM_Try, /*On fail goto*//*Label 13677*/ GIMT_Encode4(895228), // Rule ID 61658 //
     /*  895158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  895169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  895172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  895175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895204 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  895207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895226 */     GIR_RootConstrainSelectedInstOperands,
     /*  895227 */     // GIR_Coverage, 61658,
     /*  895227 */     GIR_EraseRootFromParent_Done,
     /*  895228 */   // Label 13677: @895228
     /*  895228 */   GIM_Try, /*On fail goto*//*Label 13678*/ GIMT_Encode4(895303), // Rule ID 61659 //
     /*  895233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  895244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  895247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  895250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895279 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  895282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895301 */     GIR_RootConstrainSelectedInstOperands,
     /*  895302 */     // GIR_Coverage, 61659,
     /*  895302 */     GIR_EraseRootFromParent_Done,
     /*  895303 */   // Label 13678: @895303
     /*  895303 */   GIM_Try, /*On fail goto*//*Label 13679*/ GIMT_Encode4(895378), // Rule ID 61662 //
     /*  895308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  895319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  895322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  895325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895354 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895376 */     GIR_RootConstrainSelectedInstOperands,
     /*  895377 */     // GIR_Coverage, 61662,
     /*  895377 */     GIR_EraseRootFromParent_Done,
     /*  895378 */   // Label 13679: @895378
     /*  895378 */   GIM_Try, /*On fail goto*//*Label 13680*/ GIMT_Encode4(895453), // Rule ID 61663 //
     /*  895383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  895394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  895397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  895400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895429 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895451 */     GIR_RootConstrainSelectedInstOperands,
     /*  895452 */     // GIR_Coverage, 61663,
     /*  895452 */     GIR_EraseRootFromParent_Done,
     /*  895453 */   // Label 13680: @895453
     /*  895453 */   GIM_Try, /*On fail goto*//*Label 13681*/ GIMT_Encode4(895528), // Rule ID 61666 //
     /*  895458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  895469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  895472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  895475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895504 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895526 */     GIR_RootConstrainSelectedInstOperands,
     /*  895527 */     // GIR_Coverage, 61666,
     /*  895527 */     GIR_EraseRootFromParent_Done,
     /*  895528 */   // Label 13681: @895528
     /*  895528 */   GIM_Try, /*On fail goto*//*Label 13682*/ GIMT_Encode4(895603), // Rule ID 61667 //
     /*  895533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  895544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  895547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  895550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895579 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895601 */     GIR_RootConstrainSelectedInstOperands,
     /*  895602 */     // GIR_Coverage, 61667,
     /*  895602 */     GIR_EraseRootFromParent_Done,
     /*  895603 */   // Label 13682: @895603
     /*  895603 */   GIM_Try, /*On fail goto*//*Label 13683*/ GIMT_Encode4(895678), // Rule ID 61670 //
     /*  895608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  895619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  895622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  895625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895654 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  895654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895676 */     GIR_RootConstrainSelectedInstOperands,
     /*  895677 */     // GIR_Coverage, 61670,
     /*  895677 */     GIR_EraseRootFromParent_Done,
     /*  895678 */   // Label 13683: @895678
     /*  895678 */   GIM_Try, /*On fail goto*//*Label 13684*/ GIMT_Encode4(895753), // Rule ID 61671 //
     /*  895683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  895694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  895697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  895700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895729 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  895729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895751 */     GIR_RootConstrainSelectedInstOperands,
     /*  895752 */     // GIR_Coverage, 61671,
     /*  895752 */     GIR_EraseRootFromParent_Done,
     /*  895753 */   // Label 13684: @895753
     /*  895753 */   GIM_Try, /*On fail goto*//*Label 13685*/ GIMT_Encode4(895828), // Rule ID 61674 //
     /*  895758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  895769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  895772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  895775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895804 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  895804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895826 */     GIR_RootConstrainSelectedInstOperands,
     /*  895827 */     // GIR_Coverage, 61674,
     /*  895827 */     GIR_EraseRootFromParent_Done,
     /*  895828 */   // Label 13685: @895828
     /*  895828 */   GIM_Try, /*On fail goto*//*Label 13686*/ GIMT_Encode4(895903), // Rule ID 61675 //
     /*  895833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  895844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  895847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  895850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895879 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  895879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895901 */     GIR_RootConstrainSelectedInstOperands,
     /*  895902 */     // GIR_Coverage, 61675,
     /*  895902 */     GIR_EraseRootFromParent_Done,
     /*  895903 */   // Label 13686: @895903
     /*  895903 */   GIM_Try, /*On fail goto*//*Label 13687*/ GIMT_Encode4(895978), // Rule ID 61678 //
     /*  895908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  895919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  895922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  895925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895954 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  895954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895976 */     GIR_RootConstrainSelectedInstOperands,
     /*  895977 */     // GIR_Coverage, 61678,
     /*  895977 */     GIR_EraseRootFromParent_Done,
     /*  895978 */   // Label 13687: @895978
     /*  895978 */   GIM_Try, /*On fail goto*//*Label 13688*/ GIMT_Encode4(896053), // Rule ID 61679 //
     /*  895983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  895994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  895997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  896000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896029 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  896029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  896032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896051 */     GIR_RootConstrainSelectedInstOperands,
     /*  896052 */     // GIR_Coverage, 61679,
     /*  896052 */     GIR_EraseRootFromParent_Done,
     /*  896053 */   // Label 13688: @896053
     /*  896053 */   GIM_Try, /*On fail goto*//*Label 13689*/ GIMT_Encode4(896128), // Rule ID 61682 //
     /*  896058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  896069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  896072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  896075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896104 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896126 */     GIR_RootConstrainSelectedInstOperands,
     /*  896127 */     // GIR_Coverage, 61682,
     /*  896127 */     GIR_EraseRootFromParent_Done,
     /*  896128 */   // Label 13689: @896128
     /*  896128 */   GIM_Try, /*On fail goto*//*Label 13690*/ GIMT_Encode4(896203), // Rule ID 61683 //
     /*  896133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  896144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  896147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  896150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896179 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896201 */     GIR_RootConstrainSelectedInstOperands,
     /*  896202 */     // GIR_Coverage, 61683,
     /*  896202 */     GIR_EraseRootFromParent_Done,
     /*  896203 */   // Label 13690: @896203
     /*  896203 */   GIM_Try, /*On fail goto*//*Label 13691*/ GIMT_Encode4(896278), // Rule ID 61686 //
     /*  896208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  896219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  896222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  896225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896254 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896276 */     GIR_RootConstrainSelectedInstOperands,
     /*  896277 */     // GIR_Coverage, 61686,
     /*  896277 */     GIR_EraseRootFromParent_Done,
     /*  896278 */   // Label 13691: @896278
     /*  896278 */   GIM_Try, /*On fail goto*//*Label 13692*/ GIMT_Encode4(896353), // Rule ID 61687 //
     /*  896283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  896294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  896297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  896300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896329 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896351 */     GIR_RootConstrainSelectedInstOperands,
     /*  896352 */     // GIR_Coverage, 61687,
     /*  896352 */     GIR_EraseRootFromParent_Done,
     /*  896353 */   // Label 13692: @896353
     /*  896353 */   GIM_Try, /*On fail goto*//*Label 13693*/ GIMT_Encode4(896428), // Rule ID 61690 //
     /*  896358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  896369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  896372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  896375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896404 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  896404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896426 */     GIR_RootConstrainSelectedInstOperands,
     /*  896427 */     // GIR_Coverage, 61690,
     /*  896427 */     GIR_EraseRootFromParent_Done,
     /*  896428 */   // Label 13693: @896428
     /*  896428 */   GIM_Try, /*On fail goto*//*Label 13694*/ GIMT_Encode4(896503), // Rule ID 61691 //
     /*  896433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  896444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  896447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  896450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896479 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  896479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896501 */     GIR_RootConstrainSelectedInstOperands,
     /*  896502 */     // GIR_Coverage, 61691,
     /*  896502 */     GIR_EraseRootFromParent_Done,
     /*  896503 */   // Label 13694: @896503
     /*  896503 */   GIM_Try, /*On fail goto*//*Label 13695*/ GIMT_Encode4(896578), // Rule ID 61694 //
     /*  896508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  896519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  896522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  896525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896554 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  896554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  896573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896576 */     GIR_RootConstrainSelectedInstOperands,
     /*  896577 */     // GIR_Coverage, 61694,
     /*  896577 */     GIR_EraseRootFromParent_Done,
     /*  896578 */   // Label 13695: @896578
     /*  896578 */   GIM_Try, /*On fail goto*//*Label 13696*/ GIMT_Encode4(896653), // Rule ID 61695 //
     /*  896583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  896594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  896597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  896600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896629 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  896629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  896648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896651 */     GIR_RootConstrainSelectedInstOperands,
     /*  896652 */     // GIR_Coverage, 61695,
     /*  896652 */     GIR_EraseRootFromParent_Done,
     /*  896653 */   // Label 13696: @896653
     /*  896653 */   GIM_Try, /*On fail goto*//*Label 13697*/ GIMT_Encode4(896728), // Rule ID 61698 //
     /*  896658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  896669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  896672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  896675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  896707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896726 */     GIR_RootConstrainSelectedInstOperands,
     /*  896727 */     // GIR_Coverage, 61698,
     /*  896727 */     GIR_EraseRootFromParent_Done,
     /*  896728 */   // Label 13697: @896728
     /*  896728 */   GIM_Try, /*On fail goto*//*Label 13698*/ GIMT_Encode4(896803), // Rule ID 61699 //
     /*  896733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  896744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  896747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  896750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896779 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  896782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896801 */     GIR_RootConstrainSelectedInstOperands,
     /*  896802 */     // GIR_Coverage, 61699,
     /*  896802 */     GIR_EraseRootFromParent_Done,
     /*  896803 */   // Label 13698: @896803
     /*  896803 */   GIM_Try, /*On fail goto*//*Label 13699*/ GIMT_Encode4(896878), // Rule ID 61702 //
     /*  896808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  896819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  896822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  896825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896854 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  896857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896876 */     GIR_RootConstrainSelectedInstOperands,
     /*  896877 */     // GIR_Coverage, 61702,
     /*  896877 */     GIR_EraseRootFromParent_Done,
     /*  896878 */   // Label 13699: @896878
     /*  896878 */   GIM_Try, /*On fail goto*//*Label 13700*/ GIMT_Encode4(896953), // Rule ID 61703 //
     /*  896883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  896894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  896897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  896900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896929 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  896932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896951 */     GIR_RootConstrainSelectedInstOperands,
     /*  896952 */     // GIR_Coverage, 61703,
     /*  896952 */     GIR_EraseRootFromParent_Done,
     /*  896953 */   // Label 13700: @896953
     /*  896953 */   GIM_Try, /*On fail goto*//*Label 13701*/ GIMT_Encode4(897028), // Rule ID 61706 //
     /*  896958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  896969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  896972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  896975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897004 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897026 */     GIR_RootConstrainSelectedInstOperands,
     /*  897027 */     // GIR_Coverage, 61706,
     /*  897027 */     GIR_EraseRootFromParent_Done,
     /*  897028 */   // Label 13701: @897028
     /*  897028 */   GIM_Try, /*On fail goto*//*Label 13702*/ GIMT_Encode4(897103), // Rule ID 61707 //
     /*  897033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  897044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  897047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  897050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897079 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897101 */     GIR_RootConstrainSelectedInstOperands,
     /*  897102 */     // GIR_Coverage, 61707,
     /*  897102 */     GIR_EraseRootFromParent_Done,
     /*  897103 */   // Label 13702: @897103
     /*  897103 */   GIM_Try, /*On fail goto*//*Label 13703*/ GIMT_Encode4(897178), // Rule ID 61710 //
     /*  897108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  897119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  897122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  897125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897154 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897176 */     GIR_RootConstrainSelectedInstOperands,
     /*  897177 */     // GIR_Coverage, 61710,
     /*  897177 */     GIR_EraseRootFromParent_Done,
     /*  897178 */   // Label 13703: @897178
     /*  897178 */   GIM_Try, /*On fail goto*//*Label 13704*/ GIMT_Encode4(897253), // Rule ID 61711 //
     /*  897183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  897194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  897197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  897200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897229 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897251 */     GIR_RootConstrainSelectedInstOperands,
     /*  897252 */     // GIR_Coverage, 61711,
     /*  897252 */     GIR_EraseRootFromParent_Done,
     /*  897253 */   // Label 13704: @897253
     /*  897253 */   GIM_Try, /*On fail goto*//*Label 13705*/ GIMT_Encode4(897328), // Rule ID 61714 //
     /*  897258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  897269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  897272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  897275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897304 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897326 */     GIR_RootConstrainSelectedInstOperands,
     /*  897327 */     // GIR_Coverage, 61714,
     /*  897327 */     GIR_EraseRootFromParent_Done,
     /*  897328 */   // Label 13705: @897328
     /*  897328 */   GIM_Try, /*On fail goto*//*Label 13706*/ GIMT_Encode4(897403), // Rule ID 61715 //
     /*  897333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  897344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  897347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  897350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897379 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897401 */     GIR_RootConstrainSelectedInstOperands,
     /*  897402 */     // GIR_Coverage, 61715,
     /*  897402 */     GIR_EraseRootFromParent_Done,
     /*  897403 */   // Label 13706: @897403
     /*  897403 */   GIM_Try, /*On fail goto*//*Label 13707*/ GIMT_Encode4(897478), // Rule ID 61718 //
     /*  897408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  897419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  897422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  897425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897454 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897476 */     GIR_RootConstrainSelectedInstOperands,
     /*  897477 */     // GIR_Coverage, 61718,
     /*  897477 */     GIR_EraseRootFromParent_Done,
     /*  897478 */   // Label 13707: @897478
     /*  897478 */   GIM_Try, /*On fail goto*//*Label 13708*/ GIMT_Encode4(897553), // Rule ID 61719 //
     /*  897483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  897494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  897497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  897500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897529 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897551 */     GIR_RootConstrainSelectedInstOperands,
     /*  897552 */     // GIR_Coverage, 61719,
     /*  897552 */     GIR_EraseRootFromParent_Done,
     /*  897553 */   // Label 13708: @897553
     /*  897553 */   GIM_Try, /*On fail goto*//*Label 13709*/ GIMT_Encode4(897628), // Rule ID 61722 //
     /*  897558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  897569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  897572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  897575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  897604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897626 */     GIR_RootConstrainSelectedInstOperands,
     /*  897627 */     // GIR_Coverage, 61722,
     /*  897627 */     GIR_EraseRootFromParent_Done,
     /*  897628 */   // Label 13709: @897628
     /*  897628 */   GIM_Try, /*On fail goto*//*Label 13710*/ GIMT_Encode4(897703), // Rule ID 61723 //
     /*  897633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  897644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  897647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  897650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  897679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897701 */     GIR_RootConstrainSelectedInstOperands,
     /*  897702 */     // GIR_Coverage, 61723,
     /*  897702 */     GIR_EraseRootFromParent_Done,
     /*  897703 */   // Label 13710: @897703
     /*  897703 */   GIM_Try, /*On fail goto*//*Label 13711*/ GIMT_Encode4(897778), // Rule ID 61726 //
     /*  897708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  897719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  897722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  897725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897754 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  897754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897776 */     GIR_RootConstrainSelectedInstOperands,
     /*  897777 */     // GIR_Coverage, 61726,
     /*  897777 */     GIR_EraseRootFromParent_Done,
     /*  897778 */   // Label 13711: @897778
     /*  897778 */   GIM_Try, /*On fail goto*//*Label 13712*/ GIMT_Encode4(897853), // Rule ID 61727 //
     /*  897783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  897794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  897797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  897800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897829 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  897829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897851 */     GIR_RootConstrainSelectedInstOperands,
     /*  897852 */     // GIR_Coverage, 61727,
     /*  897852 */     GIR_EraseRootFromParent_Done,
     /*  897853 */   // Label 13712: @897853
     /*  897853 */   GIM_Try, /*On fail goto*//*Label 13713*/ GIMT_Encode4(897928), // Rule ID 61730 //
     /*  897858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  897869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  897872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  897875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897904 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  897904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897926 */     GIR_RootConstrainSelectedInstOperands,
     /*  897927 */     // GIR_Coverage, 61730,
     /*  897927 */     GIR_EraseRootFromParent_Done,
     /*  897928 */   // Label 13713: @897928
     /*  897928 */   GIM_Try, /*On fail goto*//*Label 13714*/ GIMT_Encode4(898003), // Rule ID 61731 //
     /*  897933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  897944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  897947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  897950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897979 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  897979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898001 */     GIR_RootConstrainSelectedInstOperands,
     /*  898002 */     // GIR_Coverage, 61731,
     /*  898002 */     GIR_EraseRootFromParent_Done,
     /*  898003 */   // Label 13714: @898003
     /*  898003 */   GIM_Try, /*On fail goto*//*Label 13715*/ GIMT_Encode4(898078), // Rule ID 61734 //
     /*  898008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  898019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  898022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  898025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898054 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  898057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898076 */     GIR_RootConstrainSelectedInstOperands,
     /*  898077 */     // GIR_Coverage, 61734,
     /*  898077 */     GIR_EraseRootFromParent_Done,
     /*  898078 */   // Label 13715: @898078
     /*  898078 */   GIM_Try, /*On fail goto*//*Label 13716*/ GIMT_Encode4(898153), // Rule ID 61735 //
     /*  898083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  898094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  898097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  898100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898129 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  898132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898151 */     GIR_RootConstrainSelectedInstOperands,
     /*  898152 */     // GIR_Coverage, 61735,
     /*  898152 */     GIR_EraseRootFromParent_Done,
     /*  898153 */   // Label 13716: @898153
     /*  898153 */   GIM_Try, /*On fail goto*//*Label 13717*/ GIMT_Encode4(898228), // Rule ID 61738 //
     /*  898158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898204 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  898207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898226 */     GIR_RootConstrainSelectedInstOperands,
     /*  898227 */     // GIR_Coverage, 61738,
     /*  898227 */     GIR_EraseRootFromParent_Done,
     /*  898228 */   // Label 13717: @898228
     /*  898228 */   GIM_Try, /*On fail goto*//*Label 13718*/ GIMT_Encode4(898303), // Rule ID 61739 //
     /*  898233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898279 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  898282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898301 */     GIR_RootConstrainSelectedInstOperands,
     /*  898302 */     // GIR_Coverage, 61739,
     /*  898302 */     GIR_EraseRootFromParent_Done,
     /*  898303 */   // Label 13718: @898303
     /*  898303 */   GIM_Try, /*On fail goto*//*Label 13719*/ GIMT_Encode4(898378), // Rule ID 61742 //
     /*  898308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898354 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  898357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898376 */     GIR_RootConstrainSelectedInstOperands,
     /*  898377 */     // GIR_Coverage, 61742,
     /*  898377 */     GIR_EraseRootFromParent_Done,
     /*  898378 */   // Label 13719: @898378
     /*  898378 */   GIM_Try, /*On fail goto*//*Label 13720*/ GIMT_Encode4(898453), // Rule ID 61743 //
     /*  898383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898429 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  898432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898451 */     GIR_RootConstrainSelectedInstOperands,
     /*  898452 */     // GIR_Coverage, 61743,
     /*  898452 */     GIR_EraseRootFromParent_Done,
     /*  898453 */   // Label 13720: @898453
     /*  898453 */   GIM_Try, /*On fail goto*//*Label 13721*/ GIMT_Encode4(898528), // Rule ID 61830 //
     /*  898458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  898469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  898472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  898475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  898478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898504 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  898504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  898507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898526 */     GIR_RootConstrainSelectedInstOperands,
     /*  898527 */     // GIR_Coverage, 61830,
     /*  898527 */     GIR_EraseRootFromParent_Done,
     /*  898528 */   // Label 13721: @898528
     /*  898528 */   GIM_Try, /*On fail goto*//*Label 13722*/ GIMT_Encode4(898603), // Rule ID 61831 //
     /*  898533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  898544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  898547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  898550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  898553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898579 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  898579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  898582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898601 */     GIR_RootConstrainSelectedInstOperands,
     /*  898602 */     // GIR_Coverage, 61831,
     /*  898602 */     GIR_EraseRootFromParent_Done,
     /*  898603 */   // Label 13722: @898603
     /*  898603 */   GIM_Try, /*On fail goto*//*Label 13723*/ GIMT_Encode4(898678), // Rule ID 61834 //
     /*  898608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  898619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  898622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  898625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  898628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898654 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  898654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  898657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898676 */     GIR_RootConstrainSelectedInstOperands,
     /*  898677 */     // GIR_Coverage, 61834,
     /*  898677 */     GIR_EraseRootFromParent_Done,
     /*  898678 */   // Label 13723: @898678
     /*  898678 */   GIM_Try, /*On fail goto*//*Label 13724*/ GIMT_Encode4(898753), // Rule ID 61835 //
     /*  898683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  898694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  898697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  898700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  898703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898729 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  898729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  898732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898751 */     GIR_RootConstrainSelectedInstOperands,
     /*  898752 */     // GIR_Coverage, 61835,
     /*  898752 */     GIR_EraseRootFromParent_Done,
     /*  898753 */   // Label 13724: @898753
     /*  898753 */   GIM_Try, /*On fail goto*//*Label 13725*/ GIMT_Encode4(898828), // Rule ID 61838 //
     /*  898758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  898769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  898772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  898775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  898778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898804 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  898804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  898807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898826 */     GIR_RootConstrainSelectedInstOperands,
     /*  898827 */     // GIR_Coverage, 61838,
     /*  898827 */     GIR_EraseRootFromParent_Done,
     /*  898828 */   // Label 13725: @898828
     /*  898828 */   GIM_Try, /*On fail goto*//*Label 13726*/ GIMT_Encode4(898903), // Rule ID 61839 //
     /*  898833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  898844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  898847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  898850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  898853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898879 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  898879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  898882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898901 */     GIR_RootConstrainSelectedInstOperands,
     /*  898902 */     // GIR_Coverage, 61839,
     /*  898902 */     GIR_EraseRootFromParent_Done,
     /*  898903 */   // Label 13726: @898903
     /*  898903 */   GIM_Try, /*On fail goto*//*Label 13727*/ GIMT_Encode4(898978), // Rule ID 61842 //
     /*  898908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  898919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  898922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  898925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  898928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898954 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  898954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  898957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898976 */     GIR_RootConstrainSelectedInstOperands,
     /*  898977 */     // GIR_Coverage, 61842,
     /*  898977 */     GIR_EraseRootFromParent_Done,
     /*  898978 */   // Label 13727: @898978
     /*  898978 */   GIM_Try, /*On fail goto*//*Label 13728*/ GIMT_Encode4(899053), // Rule ID 61843 //
     /*  898983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  898994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  898997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  899000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  899003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899029 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  899032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899051 */     GIR_RootConstrainSelectedInstOperands,
     /*  899052 */     // GIR_Coverage, 61843,
     /*  899052 */     GIR_EraseRootFromParent_Done,
     /*  899053 */   // Label 13728: @899053
     /*  899053 */   GIM_Try, /*On fail goto*//*Label 13729*/ GIMT_Encode4(899128), // Rule ID 61846 //
     /*  899058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  899069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  899072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  899075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  899078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899104 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899126 */     GIR_RootConstrainSelectedInstOperands,
     /*  899127 */     // GIR_Coverage, 61846,
     /*  899127 */     GIR_EraseRootFromParent_Done,
     /*  899128 */   // Label 13729: @899128
     /*  899128 */   GIM_Try, /*On fail goto*//*Label 13730*/ GIMT_Encode4(899203), // Rule ID 61847 //
     /*  899133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  899144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  899147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  899150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  899153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899179 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899201 */     GIR_RootConstrainSelectedInstOperands,
     /*  899202 */     // GIR_Coverage, 61847,
     /*  899202 */     GIR_EraseRootFromParent_Done,
     /*  899203 */   // Label 13730: @899203
     /*  899203 */   GIM_Try, /*On fail goto*//*Label 13731*/ GIMT_Encode4(899278), // Rule ID 61850 //
     /*  899208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  899225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  899228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899254 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  899254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899276 */     GIR_RootConstrainSelectedInstOperands,
     /*  899277 */     // GIR_Coverage, 61850,
     /*  899277 */     GIR_EraseRootFromParent_Done,
     /*  899278 */   // Label 13731: @899278
     /*  899278 */   GIM_Try, /*On fail goto*//*Label 13732*/ GIMT_Encode4(899353), // Rule ID 61851 //
     /*  899283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  899300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  899303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899329 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  899329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899351 */     GIR_RootConstrainSelectedInstOperands,
     /*  899352 */     // GIR_Coverage, 61851,
     /*  899352 */     GIR_EraseRootFromParent_Done,
     /*  899353 */   // Label 13732: @899353
     /*  899353 */   GIM_Try, /*On fail goto*//*Label 13733*/ GIMT_Encode4(899428), // Rule ID 61854 //
     /*  899358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  899369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  899372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  899375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  899378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899404 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899426 */     GIR_RootConstrainSelectedInstOperands,
     /*  899427 */     // GIR_Coverage, 61854,
     /*  899427 */     GIR_EraseRootFromParent_Done,
     /*  899428 */   // Label 13733: @899428
     /*  899428 */   GIM_Try, /*On fail goto*//*Label 13734*/ GIMT_Encode4(899503), // Rule ID 61855 //
     /*  899433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  899444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  899447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  899450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  899453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899479 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899501 */     GIR_RootConstrainSelectedInstOperands,
     /*  899502 */     // GIR_Coverage, 61855,
     /*  899502 */     GIR_EraseRootFromParent_Done,
     /*  899503 */   // Label 13734: @899503
     /*  899503 */   GIM_Try, /*On fail goto*//*Label 13735*/ GIMT_Encode4(899578), // Rule ID 61858 //
     /*  899508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  899519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  899522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  899525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  899528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899554 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899576 */     GIR_RootConstrainSelectedInstOperands,
     /*  899577 */     // GIR_Coverage, 61858,
     /*  899577 */     GIR_EraseRootFromParent_Done,
     /*  899578 */   // Label 13735: @899578
     /*  899578 */   GIM_Try, /*On fail goto*//*Label 13736*/ GIMT_Encode4(899653), // Rule ID 61859 //
     /*  899583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  899594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  899597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  899600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  899603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899629 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899651 */     GIR_RootConstrainSelectedInstOperands,
     /*  899652 */     // GIR_Coverage, 61859,
     /*  899652 */     GIR_EraseRootFromParent_Done,
     /*  899653 */   // Label 13736: @899653
     /*  899653 */   GIM_Try, /*On fail goto*//*Label 13737*/ GIMT_Encode4(899728), // Rule ID 61862 //
     /*  899658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  899669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  899672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  899675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  899678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899704 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  899704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899726 */     GIR_RootConstrainSelectedInstOperands,
     /*  899727 */     // GIR_Coverage, 61862,
     /*  899727 */     GIR_EraseRootFromParent_Done,
     /*  899728 */   // Label 13737: @899728
     /*  899728 */   GIM_Try, /*On fail goto*//*Label 13738*/ GIMT_Encode4(899803), // Rule ID 61863 //
     /*  899733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  899744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  899747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  899750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  899753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899779 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  899779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899801 */     GIR_RootConstrainSelectedInstOperands,
     /*  899802 */     // GIR_Coverage, 61863,
     /*  899802 */     GIR_EraseRootFromParent_Done,
     /*  899803 */   // Label 13738: @899803
     /*  899803 */   GIM_Try, /*On fail goto*//*Label 13739*/ GIMT_Encode4(899878), // Rule ID 61866 //
     /*  899808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  899819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  899822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  899825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  899828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899854 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  899854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  899873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899876 */     GIR_RootConstrainSelectedInstOperands,
     /*  899877 */     // GIR_Coverage, 61866,
     /*  899877 */     GIR_EraseRootFromParent_Done,
     /*  899878 */   // Label 13739: @899878
     /*  899878 */   GIM_Try, /*On fail goto*//*Label 13740*/ GIMT_Encode4(899953), // Rule ID 61867 //
     /*  899883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  899894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  899897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  899900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  899903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899929 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  899929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  899948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899951 */     GIR_RootConstrainSelectedInstOperands,
     /*  899952 */     // GIR_Coverage, 61867,
     /*  899952 */     GIR_EraseRootFromParent_Done,
     /*  899953 */   // Label 13740: @899953
     /*  899953 */   GIM_Try, /*On fail goto*//*Label 13741*/ GIMT_Encode4(900028), // Rule ID 61870 //
     /*  899958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  899969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  899972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  899975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  899978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900004 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900026 */     GIR_RootConstrainSelectedInstOperands,
     /*  900027 */     // GIR_Coverage, 61870,
     /*  900027 */     GIR_EraseRootFromParent_Done,
     /*  900028 */   // Label 13741: @900028
     /*  900028 */   GIM_Try, /*On fail goto*//*Label 13742*/ GIMT_Encode4(900103), // Rule ID 61871 //
     /*  900033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  900044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  900047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  900050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  900053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900079 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900101 */     GIR_RootConstrainSelectedInstOperands,
     /*  900102 */     // GIR_Coverage, 61871,
     /*  900102 */     GIR_EraseRootFromParent_Done,
     /*  900103 */   // Label 13742: @900103
     /*  900103 */   GIM_Try, /*On fail goto*//*Label 13743*/ GIMT_Encode4(900178), // Rule ID 61874 //
     /*  900108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  900119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  900122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  900125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  900128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900154 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900176 */     GIR_RootConstrainSelectedInstOperands,
     /*  900177 */     // GIR_Coverage, 61874,
     /*  900177 */     GIR_EraseRootFromParent_Done,
     /*  900178 */   // Label 13743: @900178
     /*  900178 */   GIM_Try, /*On fail goto*//*Label 13744*/ GIMT_Encode4(900253), // Rule ID 61875 //
     /*  900183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  900194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  900197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  900200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  900203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900229 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900251 */     GIR_RootConstrainSelectedInstOperands,
     /*  900252 */     // GIR_Coverage, 61875,
     /*  900252 */     GIR_EraseRootFromParent_Done,
     /*  900253 */   // Label 13744: @900253
     /*  900253 */   GIM_Try, /*On fail goto*//*Label 13745*/ GIMT_Encode4(900328), // Rule ID 61878 //
     /*  900258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  900269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  900272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  900275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  900278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900304 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900326 */     GIR_RootConstrainSelectedInstOperands,
     /*  900327 */     // GIR_Coverage, 61878,
     /*  900327 */     GIR_EraseRootFromParent_Done,
     /*  900328 */   // Label 13745: @900328
     /*  900328 */   GIM_Try, /*On fail goto*//*Label 13746*/ GIMT_Encode4(900403), // Rule ID 61879 //
     /*  900333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  900344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  900347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  900350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  900353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900379 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900401 */     GIR_RootConstrainSelectedInstOperands,
     /*  900402 */     // GIR_Coverage, 61879,
     /*  900402 */     GIR_EraseRootFromParent_Done,
     /*  900403 */   // Label 13746: @900403
     /*  900403 */   GIM_Try, /*On fail goto*//*Label 13747*/ GIMT_Encode4(900478), // Rule ID 61882 //
     /*  900408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  900419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  900422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  900425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  900428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900454 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900476 */     GIR_RootConstrainSelectedInstOperands,
     /*  900477 */     // GIR_Coverage, 61882,
     /*  900477 */     GIR_EraseRootFromParent_Done,
     /*  900478 */   // Label 13747: @900478
     /*  900478 */   GIM_Try, /*On fail goto*//*Label 13748*/ GIMT_Encode4(900553), // Rule ID 61883 //
     /*  900483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  900494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  900497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  900500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  900503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900529 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900551 */     GIR_RootConstrainSelectedInstOperands,
     /*  900552 */     // GIR_Coverage, 61883,
     /*  900552 */     GIR_EraseRootFromParent_Done,
     /*  900553 */   // Label 13748: @900553
     /*  900553 */   GIM_Try, /*On fail goto*//*Label 13749*/ GIMT_Encode4(900628), // Rule ID 61886 //
     /*  900558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  900569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  900572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  900575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  900578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900604 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900626 */     GIR_RootConstrainSelectedInstOperands,
     /*  900627 */     // GIR_Coverage, 61886,
     /*  900627 */     GIR_EraseRootFromParent_Done,
     /*  900628 */   // Label 13749: @900628
     /*  900628 */   GIM_Try, /*On fail goto*//*Label 13750*/ GIMT_Encode4(900703), // Rule ID 61887 //
     /*  900633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  900644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  900647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  900650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  900653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900679 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900701 */     GIR_RootConstrainSelectedInstOperands,
     /*  900702 */     // GIR_Coverage, 61887,
     /*  900702 */     GIR_EraseRootFromParent_Done,
     /*  900703 */   // Label 13750: @900703
     /*  900703 */   GIM_Try, /*On fail goto*//*Label 13751*/ GIMT_Encode4(900778), // Rule ID 61890 //
     /*  900708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  900719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  900722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  900725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  900728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900754 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900776 */     GIR_RootConstrainSelectedInstOperands,
     /*  900777 */     // GIR_Coverage, 61890,
     /*  900777 */     GIR_EraseRootFromParent_Done,
     /*  900778 */   // Label 13751: @900778
     /*  900778 */   GIM_Try, /*On fail goto*//*Label 13752*/ GIMT_Encode4(900853), // Rule ID 61891 //
     /*  900783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  900794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  900797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  900800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  900803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900829 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900851 */     GIR_RootConstrainSelectedInstOperands,
     /*  900852 */     // GIR_Coverage, 61891,
     /*  900852 */     GIR_EraseRootFromParent_Done,
     /*  900853 */   // Label 13752: @900853
     /*  900853 */   GIM_Try, /*On fail goto*//*Label 13753*/ GIMT_Encode4(900928), // Rule ID 61894 //
     /*  900858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  900869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  900872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  900875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  900878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900904 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  900904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900926 */     GIR_RootConstrainSelectedInstOperands,
     /*  900927 */     // GIR_Coverage, 61894,
     /*  900927 */     GIR_EraseRootFromParent_Done,
     /*  900928 */   // Label 13753: @900928
     /*  900928 */   GIM_Try, /*On fail goto*//*Label 13754*/ GIMT_Encode4(901003), // Rule ID 61895 //
     /*  900933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  900944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  900947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  900950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  900953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900979 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  900979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901001 */     GIR_RootConstrainSelectedInstOperands,
     /*  901002 */     // GIR_Coverage, 61895,
     /*  901002 */     GIR_EraseRootFromParent_Done,
     /*  901003 */   // Label 13754: @901003
     /*  901003 */   GIM_Try, /*On fail goto*//*Label 13755*/ GIMT_Encode4(901078), // Rule ID 61898 //
     /*  901008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  901019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  901022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  901025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  901028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901054 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901076 */     GIR_RootConstrainSelectedInstOperands,
     /*  901077 */     // GIR_Coverage, 61898,
     /*  901077 */     GIR_EraseRootFromParent_Done,
     /*  901078 */   // Label 13755: @901078
     /*  901078 */   GIM_Try, /*On fail goto*//*Label 13756*/ GIMT_Encode4(901153), // Rule ID 61899 //
     /*  901083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  901094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  901097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  901100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  901103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901129 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901151 */     GIR_RootConstrainSelectedInstOperands,
     /*  901152 */     // GIR_Coverage, 61899,
     /*  901152 */     GIR_EraseRootFromParent_Done,
     /*  901153 */   // Label 13756: @901153
     /*  901153 */   GIM_Try, /*On fail goto*//*Label 13757*/ GIMT_Encode4(901228), // Rule ID 61902 //
     /*  901158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  901169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  901172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  901175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  901178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901204 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901226 */     GIR_RootConstrainSelectedInstOperands,
     /*  901227 */     // GIR_Coverage, 61902,
     /*  901227 */     GIR_EraseRootFromParent_Done,
     /*  901228 */   // Label 13757: @901228
     /*  901228 */   GIM_Try, /*On fail goto*//*Label 13758*/ GIMT_Encode4(901303), // Rule ID 61903 //
     /*  901233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  901244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  901247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  901250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  901253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901279 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901301 */     GIR_RootConstrainSelectedInstOperands,
     /*  901302 */     // GIR_Coverage, 61903,
     /*  901302 */     GIR_EraseRootFromParent_Done,
     /*  901303 */   // Label 13758: @901303
     /*  901303 */   GIM_Try, /*On fail goto*//*Label 13759*/ GIMT_Encode4(901378), // Rule ID 61906 //
     /*  901308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  901319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  901322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  901325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  901328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901354 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  901354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  901357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901376 */     GIR_RootConstrainSelectedInstOperands,
     /*  901377 */     // GIR_Coverage, 61906,
     /*  901377 */     GIR_EraseRootFromParent_Done,
     /*  901378 */   // Label 13759: @901378
     /*  901378 */   GIM_Try, /*On fail goto*//*Label 13760*/ GIMT_Encode4(901453), // Rule ID 61907 //
     /*  901383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  901394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  901397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  901400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  901403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901429 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  901429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  901432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901451 */     GIR_RootConstrainSelectedInstOperands,
     /*  901452 */     // GIR_Coverage, 61907,
     /*  901452 */     GIR_EraseRootFromParent_Done,
     /*  901453 */   // Label 13760: @901453
     /*  901453 */   GIM_Try, /*On fail goto*//*Label 13761*/ GIMT_Encode4(901528), // Rule ID 61910 //
     /*  901458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  901469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  901472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  901475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  901478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901504 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  901504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901526 */     GIR_RootConstrainSelectedInstOperands,
     /*  901527 */     // GIR_Coverage, 61910,
     /*  901527 */     GIR_EraseRootFromParent_Done,
     /*  901528 */   // Label 13761: @901528
     /*  901528 */   GIM_Try, /*On fail goto*//*Label 13762*/ GIMT_Encode4(901603), // Rule ID 61911 //
     /*  901533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  901544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  901547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  901550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  901553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901579 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  901579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901601 */     GIR_RootConstrainSelectedInstOperands,
     /*  901602 */     // GIR_Coverage, 61911,
     /*  901602 */     GIR_EraseRootFromParent_Done,
     /*  901603 */   // Label 13762: @901603
     /*  901603 */   GIM_Try, /*On fail goto*//*Label 13763*/ GIMT_Encode4(901678), // Rule ID 61914 //
     /*  901608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  901619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  901622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  901625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  901628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901654 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  901654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901676 */     GIR_RootConstrainSelectedInstOperands,
     /*  901677 */     // GIR_Coverage, 61914,
     /*  901677 */     GIR_EraseRootFromParent_Done,
     /*  901678 */   // Label 13763: @901678
     /*  901678 */   GIM_Try, /*On fail goto*//*Label 13764*/ GIMT_Encode4(901753), // Rule ID 61915 //
     /*  901683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  901694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  901697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  901700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  901703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901729 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  901729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901751 */     GIR_RootConstrainSelectedInstOperands,
     /*  901752 */     // GIR_Coverage, 61915,
     /*  901752 */     GIR_EraseRootFromParent_Done,
     /*  901753 */   // Label 13764: @901753
     /*  901753 */   GIM_Try, /*On fail goto*//*Label 13765*/ GIMT_Encode4(901828), // Rule ID 61918 //
     /*  901758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  901769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  901772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  901775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901804 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  901804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  901807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901826 */     GIR_RootConstrainSelectedInstOperands,
     /*  901827 */     // GIR_Coverage, 61918,
     /*  901827 */     GIR_EraseRootFromParent_Done,
     /*  901828 */   // Label 13765: @901828
     /*  901828 */   GIM_Try, /*On fail goto*//*Label 13766*/ GIMT_Encode4(901903), // Rule ID 61919 //
     /*  901833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  901844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  901847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  901850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901879 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  901879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  901882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901901 */     GIR_RootConstrainSelectedInstOperands,
     /*  901902 */     // GIR_Coverage, 61919,
     /*  901902 */     GIR_EraseRootFromParent_Done,
     /*  901903 */   // Label 13766: @901903
     /*  901903 */   GIM_Try, /*On fail goto*//*Label 13767*/ GIMT_Encode4(901978), // Rule ID 61922 //
     /*  901908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  901919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  901922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  901925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901954 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  901954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  901957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901976 */     GIR_RootConstrainSelectedInstOperands,
     /*  901977 */     // GIR_Coverage, 61922,
     /*  901977 */     GIR_EraseRootFromParent_Done,
     /*  901978 */   // Label 13767: @901978
     /*  901978 */   GIM_Try, /*On fail goto*//*Label 13768*/ GIMT_Encode4(902053), // Rule ID 61923 //
     /*  901983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  901994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  901997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  902000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902029 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902051 */     GIR_RootConstrainSelectedInstOperands,
     /*  902052 */     // GIR_Coverage, 61923,
     /*  902052 */     GIR_EraseRootFromParent_Done,
     /*  902053 */   // Label 13768: @902053
     /*  902053 */   GIM_Try, /*On fail goto*//*Label 13769*/ GIMT_Encode4(902128), // Rule ID 61926 //
     /*  902058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  902069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  902072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902104 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902126 */     GIR_RootConstrainSelectedInstOperands,
     /*  902127 */     // GIR_Coverage, 61926,
     /*  902127 */     GIR_EraseRootFromParent_Done,
     /*  902128 */   // Label 13769: @902128
     /*  902128 */   GIM_Try, /*On fail goto*//*Label 13770*/ GIMT_Encode4(902203), // Rule ID 61927 //
     /*  902133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  902144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  902147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902179 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902201 */     GIR_RootConstrainSelectedInstOperands,
     /*  902202 */     // GIR_Coverage, 61927,
     /*  902202 */     GIR_EraseRootFromParent_Done,
     /*  902203 */   // Label 13770: @902203
     /*  902203 */   GIM_Try, /*On fail goto*//*Label 13771*/ GIMT_Encode4(902278), // Rule ID 61930 //
     /*  902208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  902219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  902222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902254 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902276 */     GIR_RootConstrainSelectedInstOperands,
     /*  902277 */     // GIR_Coverage, 61930,
     /*  902277 */     GIR_EraseRootFromParent_Done,
     /*  902278 */   // Label 13771: @902278
     /*  902278 */   GIM_Try, /*On fail goto*//*Label 13772*/ GIMT_Encode4(902353), // Rule ID 61931 //
     /*  902283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  902294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  902297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902329 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  902329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902351 */     GIR_RootConstrainSelectedInstOperands,
     /*  902352 */     // GIR_Coverage, 61931,
     /*  902352 */     GIR_EraseRootFromParent_Done,
     /*  902353 */   // Label 13772: @902353
     /*  902353 */   GIM_Try, /*On fail goto*//*Label 13773*/ GIMT_Encode4(902428), // Rule ID 61934 //
     /*  902358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  902369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  902372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902404 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902426 */     GIR_RootConstrainSelectedInstOperands,
     /*  902427 */     // GIR_Coverage, 61934,
     /*  902427 */     GIR_EraseRootFromParent_Done,
     /*  902428 */   // Label 13773: @902428
     /*  902428 */   GIM_Try, /*On fail goto*//*Label 13774*/ GIMT_Encode4(902503), // Rule ID 61935 //
     /*  902433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  902444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  902447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902479 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  902479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902501 */     GIR_RootConstrainSelectedInstOperands,
     /*  902502 */     // GIR_Coverage, 61935,
     /*  902502 */     GIR_EraseRootFromParent_Done,
     /*  902503 */   // Label 13774: @902503
     /*  902503 */   GIM_Try, /*On fail goto*//*Label 13775*/ GIMT_Encode4(902578), // Rule ID 61938 //
     /*  902508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  902519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  902522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  902525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902554 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  902554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  902573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902576 */     GIR_RootConstrainSelectedInstOperands,
     /*  902577 */     // GIR_Coverage, 61938,
     /*  902577 */     GIR_EraseRootFromParent_Done,
     /*  902578 */   // Label 13775: @902578
     /*  902578 */   GIM_Try, /*On fail goto*//*Label 13776*/ GIMT_Encode4(902653), // Rule ID 61939 //
     /*  902583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  902594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  902597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  902600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902629 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  902629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  902648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902651 */     GIR_RootConstrainSelectedInstOperands,
     /*  902652 */     // GIR_Coverage, 61939,
     /*  902652 */     GIR_EraseRootFromParent_Done,
     /*  902653 */   // Label 13776: @902653
     /*  902653 */   GIM_Try, /*On fail goto*//*Label 13777*/ GIMT_Encode4(902728), // Rule ID 61942 //
     /*  902658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  902669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  902672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  902675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902704 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902726 */     GIR_RootConstrainSelectedInstOperands,
     /*  902727 */     // GIR_Coverage, 61942,
     /*  902727 */     GIR_EraseRootFromParent_Done,
     /*  902728 */   // Label 13777: @902728
     /*  902728 */   GIM_Try, /*On fail goto*//*Label 13778*/ GIMT_Encode4(902803), // Rule ID 61943 //
     /*  902733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  902744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  902747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  902750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902779 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902801 */     GIR_RootConstrainSelectedInstOperands,
     /*  902802 */     // GIR_Coverage, 61943,
     /*  902802 */     GIR_EraseRootFromParent_Done,
     /*  902803 */   // Label 13778: @902803
     /*  902803 */   GIM_Try, /*On fail goto*//*Label 13779*/ GIMT_Encode4(902878), // Rule ID 61946 //
     /*  902808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  902819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  902822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  902825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902854 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902876 */     GIR_RootConstrainSelectedInstOperands,
     /*  902877 */     // GIR_Coverage, 61946,
     /*  902877 */     GIR_EraseRootFromParent_Done,
     /*  902878 */   // Label 13779: @902878
     /*  902878 */   GIM_Try, /*On fail goto*//*Label 13780*/ GIMT_Encode4(902953), // Rule ID 61947 //
     /*  902883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  902894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  902897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  902900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902929 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  902929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902951 */     GIR_RootConstrainSelectedInstOperands,
     /*  902952 */     // GIR_Coverage, 61947,
     /*  902952 */     GIR_EraseRootFromParent_Done,
     /*  902953 */   // Label 13780: @902953
     /*  902953 */   GIM_Try, /*On fail goto*//*Label 13781*/ GIMT_Encode4(903028), // Rule ID 61950 //
     /*  902958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  902969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  902972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  902975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903004 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  903004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903026 */     GIR_RootConstrainSelectedInstOperands,
     /*  903027 */     // GIR_Coverage, 61950,
     /*  903027 */     GIR_EraseRootFromParent_Done,
     /*  903028 */   // Label 13781: @903028
     /*  903028 */   GIM_Try, /*On fail goto*//*Label 13782*/ GIMT_Encode4(903103), // Rule ID 61951 //
     /*  903033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  903044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  903047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  903050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903079 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  903079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903101 */     GIR_RootConstrainSelectedInstOperands,
     /*  903102 */     // GIR_Coverage, 61951,
     /*  903102 */     GIR_EraseRootFromParent_Done,
     /*  903103 */   // Label 13782: @903103
     /*  903103 */   GIM_Try, /*On fail goto*//*Label 13783*/ GIMT_Encode4(903178), // Rule ID 61954 //
     /*  903108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  903125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903154 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  903154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903176 */     GIR_RootConstrainSelectedInstOperands,
     /*  903177 */     // GIR_Coverage, 61954,
     /*  903177 */     GIR_EraseRootFromParent_Done,
     /*  903178 */   // Label 13783: @903178
     /*  903178 */   GIM_Try, /*On fail goto*//*Label 13784*/ GIMT_Encode4(903253), // Rule ID 61955 //
     /*  903183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  903200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903229 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  903229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903251 */     GIR_RootConstrainSelectedInstOperands,
     /*  903252 */     // GIR_Coverage, 61955,
     /*  903252 */     GIR_EraseRootFromParent_Done,
     /*  903253 */   // Label 13784: @903253
     /*  903253 */   GIM_Try, /*On fail goto*//*Label 13785*/ GIMT_Encode4(903328), // Rule ID 61958 //
     /*  903258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  903269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  903272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  903275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903304 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903326 */     GIR_RootConstrainSelectedInstOperands,
     /*  903327 */     // GIR_Coverage, 61958,
     /*  903327 */     GIR_EraseRootFromParent_Done,
     /*  903328 */   // Label 13785: @903328
     /*  903328 */   GIM_Try, /*On fail goto*//*Label 13786*/ GIMT_Encode4(903403), // Rule ID 61959 //
     /*  903333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  903344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  903347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  903350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903379 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903401 */     GIR_RootConstrainSelectedInstOperands,
     /*  903402 */     // GIR_Coverage, 61959,
     /*  903402 */     GIR_EraseRootFromParent_Done,
     /*  903403 */   // Label 13786: @903403
     /*  903403 */   GIM_Try, /*On fail goto*//*Label 13787*/ GIMT_Encode4(903478), // Rule ID 61962 //
     /*  903408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  903419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  903422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  903425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903454 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903476 */     GIR_RootConstrainSelectedInstOperands,
     /*  903477 */     // GIR_Coverage, 61962,
     /*  903477 */     GIR_EraseRootFromParent_Done,
     /*  903478 */   // Label 13787: @903478
     /*  903478 */   GIM_Try, /*On fail goto*//*Label 13788*/ GIMT_Encode4(903553), // Rule ID 61963 //
     /*  903483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  903494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  903497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  903500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903529 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903551 */     GIR_RootConstrainSelectedInstOperands,
     /*  903552 */     // GIR_Coverage, 61963,
     /*  903552 */     GIR_EraseRootFromParent_Done,
     /*  903553 */   // Label 13788: @903553
     /*  903553 */   GIM_Try, /*On fail goto*//*Label 13789*/ GIMT_Encode4(903628), // Rule ID 61966 //
     /*  903558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  903569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  903572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  903575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903604 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  903607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903626 */     GIR_RootConstrainSelectedInstOperands,
     /*  903627 */     // GIR_Coverage, 61966,
     /*  903627 */     GIR_EraseRootFromParent_Done,
     /*  903628 */   // Label 13789: @903628
     /*  903628 */   GIM_Try, /*On fail goto*//*Label 13790*/ GIMT_Encode4(903703), // Rule ID 61967 //
     /*  903633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  903644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  903647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  903650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903679 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  903682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903701 */     GIR_RootConstrainSelectedInstOperands,
     /*  903702 */     // GIR_Coverage, 61967,
     /*  903702 */     GIR_EraseRootFromParent_Done,
     /*  903703 */   // Label 13790: @903703
     /*  903703 */   GIM_Try, /*On fail goto*//*Label 13791*/ GIMT_Encode4(903778), // Rule ID 61970 //
     /*  903708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  903719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  903722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  903725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  903754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903776 */     GIR_RootConstrainSelectedInstOperands,
     /*  903777 */     // GIR_Coverage, 61970,
     /*  903777 */     GIR_EraseRootFromParent_Done,
     /*  903778 */   // Label 13791: @903778
     /*  903778 */   GIM_Try, /*On fail goto*//*Label 13792*/ GIMT_Encode4(903853), // Rule ID 61971 //
     /*  903783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  903794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  903797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  903800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903829 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  903829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903851 */     GIR_RootConstrainSelectedInstOperands,
     /*  903852 */     // GIR_Coverage, 61971,
     /*  903852 */     GIR_EraseRootFromParent_Done,
     /*  903853 */   // Label 13792: @903853
     /*  903853 */   GIM_Try, /*On fail goto*//*Label 13793*/ GIMT_Encode4(903928), // Rule ID 61974 //
     /*  903858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  903869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  903872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  903875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903904 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  903904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903926 */     GIR_RootConstrainSelectedInstOperands,
     /*  903927 */     // GIR_Coverage, 61974,
     /*  903927 */     GIR_EraseRootFromParent_Done,
     /*  903928 */   // Label 13793: @903928
     /*  903928 */   GIM_Try, /*On fail goto*//*Label 13794*/ GIMT_Encode4(904003), // Rule ID 61975 //
     /*  903933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  903944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  903947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  903950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903979 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  903979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904001 */     GIR_RootConstrainSelectedInstOperands,
     /*  904002 */     // GIR_Coverage, 61975,
     /*  904002 */     GIR_EraseRootFromParent_Done,
     /*  904003 */   // Label 13794: @904003
     /*  904003 */   GIM_Try, /*On fail goto*//*Label 13795*/ GIMT_Encode4(904078), // Rule ID 61978 //
     /*  904008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  904019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  904022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  904025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904054 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904076 */     GIR_RootConstrainSelectedInstOperands,
     /*  904077 */     // GIR_Coverage, 61978,
     /*  904077 */     GIR_EraseRootFromParent_Done,
     /*  904078 */   // Label 13795: @904078
     /*  904078 */   GIM_Try, /*On fail goto*//*Label 13796*/ GIMT_Encode4(904153), // Rule ID 61979 //
     /*  904083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  904094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  904097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  904100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904129 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904151 */     GIR_RootConstrainSelectedInstOperands,
     /*  904152 */     // GIR_Coverage, 61979,
     /*  904152 */     GIR_EraseRootFromParent_Done,
     /*  904153 */   // Label 13796: @904153
     /*  904153 */   GIM_Try, /*On fail goto*//*Label 13797*/ GIMT_Encode4(904228), // Rule ID 61982 //
     /*  904158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904204 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904226 */     GIR_RootConstrainSelectedInstOperands,
     /*  904227 */     // GIR_Coverage, 61982,
     /*  904227 */     GIR_EraseRootFromParent_Done,
     /*  904228 */   // Label 13797: @904228
     /*  904228 */   GIM_Try, /*On fail goto*//*Label 13798*/ GIMT_Encode4(904303), // Rule ID 61983 //
     /*  904233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904279 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904301 */     GIR_RootConstrainSelectedInstOperands,
     /*  904302 */     // GIR_Coverage, 61983,
     /*  904302 */     GIR_EraseRootFromParent_Done,
     /*  904303 */   // Label 13798: @904303
     /*  904303 */   GIM_Try, /*On fail goto*//*Label 13799*/ GIMT_Encode4(904378), // Rule ID 61986 //
     /*  904308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904354 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904376 */     GIR_RootConstrainSelectedInstOperands,
     /*  904377 */     // GIR_Coverage, 61986,
     /*  904377 */     GIR_EraseRootFromParent_Done,
     /*  904378 */   // Label 13799: @904378
     /*  904378 */   GIM_Try, /*On fail goto*//*Label 13800*/ GIMT_Encode4(904453), // Rule ID 61987 //
     /*  904383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904429 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904451 */     GIR_RootConstrainSelectedInstOperands,
     /*  904452 */     // GIR_Coverage, 61987,
     /*  904452 */     GIR_EraseRootFromParent_Done,
     /*  904453 */   // Label 13800: @904453
     /*  904453 */   GIM_Try, /*On fail goto*//*Label 13801*/ GIMT_Encode4(904528), // Rule ID 61990 //
     /*  904458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  904469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  904472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  904475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904504 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904526 */     GIR_RootConstrainSelectedInstOperands,
     /*  904527 */     // GIR_Coverage, 61990,
     /*  904527 */     GIR_EraseRootFromParent_Done,
     /*  904528 */   // Label 13801: @904528
     /*  904528 */   GIM_Try, /*On fail goto*//*Label 13802*/ GIMT_Encode4(904603), // Rule ID 61991 //
     /*  904533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  904544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  904547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  904550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904579 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904601 */     GIR_RootConstrainSelectedInstOperands,
     /*  904602 */     // GIR_Coverage, 61991,
     /*  904602 */     GIR_EraseRootFromParent_Done,
     /*  904603 */   // Label 13802: @904603
     /*  904603 */   GIM_Try, /*On fail goto*//*Label 13803*/ GIMT_Encode4(904678), // Rule ID 61994 //
     /*  904608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  904619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  904622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  904625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  904654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904676 */     GIR_RootConstrainSelectedInstOperands,
     /*  904677 */     // GIR_Coverage, 61994,
     /*  904677 */     GIR_EraseRootFromParent_Done,
     /*  904678 */   // Label 13803: @904678
     /*  904678 */   GIM_Try, /*On fail goto*//*Label 13804*/ GIMT_Encode4(904753), // Rule ID 61995 //
     /*  904683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  904694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  904697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  904700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904729 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  904729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904751 */     GIR_RootConstrainSelectedInstOperands,
     /*  904752 */     // GIR_Coverage, 61995,
     /*  904752 */     GIR_EraseRootFromParent_Done,
     /*  904753 */   // Label 13804: @904753
     /*  904753 */   GIM_Try, /*On fail goto*//*Label 13805*/ GIMT_Encode4(904828), // Rule ID 61998 //
     /*  904758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  904769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  904772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  904775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904804 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  904804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904826 */     GIR_RootConstrainSelectedInstOperands,
     /*  904827 */     // GIR_Coverage, 61998,
     /*  904827 */     GIR_EraseRootFromParent_Done,
     /*  904828 */   // Label 13805: @904828
     /*  904828 */   GIM_Try, /*On fail goto*//*Label 13806*/ GIMT_Encode4(904903), // Rule ID 61999 //
     /*  904833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  904844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  904847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  904850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904879 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  904879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904901 */     GIR_RootConstrainSelectedInstOperands,
     /*  904902 */     // GIR_Coverage, 61999,
     /*  904902 */     GIR_EraseRootFromParent_Done,
     /*  904903 */   // Label 13806: @904903
     /*  904903 */   GIM_Try, /*On fail goto*//*Label 13807*/ GIMT_Encode4(904978), // Rule ID 62002 //
     /*  904908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  904919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  904922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  904925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904954 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  904954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904976 */     GIR_RootConstrainSelectedInstOperands,
     /*  904977 */     // GIR_Coverage, 62002,
     /*  904977 */     GIR_EraseRootFromParent_Done,
     /*  904978 */   // Label 13807: @904978
     /*  904978 */   GIM_Try, /*On fail goto*//*Label 13808*/ GIMT_Encode4(905053), // Rule ID 62003 //
     /*  904983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  904994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  904997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  905000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905029 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  905032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905051 */     GIR_RootConstrainSelectedInstOperands,
     /*  905052 */     // GIR_Coverage, 62003,
     /*  905052 */     GIR_EraseRootFromParent_Done,
     /*  905053 */   // Label 13808: @905053
     /*  905053 */   GIM_Try, /*On fail goto*//*Label 13809*/ GIMT_Encode4(905128), // Rule ID 62446 //
     /*  905058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  905069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  905072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  905075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  905078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  905107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905126 */     GIR_RootConstrainSelectedInstOperands,
     /*  905127 */     // GIR_Coverage, 62446,
     /*  905127 */     GIR_EraseRootFromParent_Done,
     /*  905128 */   // Label 13809: @905128
     /*  905128 */   GIM_Try, /*On fail goto*//*Label 13810*/ GIMT_Encode4(905203), // Rule ID 62447 //
     /*  905133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  905144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  905147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  905150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  905153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905179 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  905182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905201 */     GIR_RootConstrainSelectedInstOperands,
     /*  905202 */     // GIR_Coverage, 62447,
     /*  905202 */     GIR_EraseRootFromParent_Done,
     /*  905203 */   // Label 13810: @905203
     /*  905203 */   GIM_Try, /*On fail goto*//*Label 13811*/ GIMT_Encode4(905278), // Rule ID 62448 //
     /*  905208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  905219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  905222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  905225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  905228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905254 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  905257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905276 */     GIR_RootConstrainSelectedInstOperands,
     /*  905277 */     // GIR_Coverage, 62448,
     /*  905277 */     GIR_EraseRootFromParent_Done,
     /*  905278 */   // Label 13811: @905278
     /*  905278 */   GIM_Try, /*On fail goto*//*Label 13812*/ GIMT_Encode4(905353), // Rule ID 62449 //
     /*  905283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  905294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  905297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  905300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  905303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905329 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  905332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905351 */     GIR_RootConstrainSelectedInstOperands,
     /*  905352 */     // GIR_Coverage, 62449,
     /*  905352 */     GIR_EraseRootFromParent_Done,
     /*  905353 */   // Label 13812: @905353
     /*  905353 */   GIM_Try, /*On fail goto*//*Label 13813*/ GIMT_Encode4(905428), // Rule ID 62450 //
     /*  905358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  905369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  905372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  905375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  905378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905404 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  905407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905426 */     GIR_RootConstrainSelectedInstOperands,
     /*  905427 */     // GIR_Coverage, 62450,
     /*  905427 */     GIR_EraseRootFromParent_Done,
     /*  905428 */   // Label 13813: @905428
     /*  905428 */   GIM_Try, /*On fail goto*//*Label 13814*/ GIMT_Encode4(905503), // Rule ID 62451 //
     /*  905433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  905444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  905447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  905450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  905453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905479 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  905482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905501 */     GIR_RootConstrainSelectedInstOperands,
     /*  905502 */     // GIR_Coverage, 62451,
     /*  905502 */     GIR_EraseRootFromParent_Done,
     /*  905503 */   // Label 13814: @905503
     /*  905503 */   GIM_Try, /*On fail goto*//*Label 13815*/ GIMT_Encode4(905578), // Rule ID 62452 //
     /*  905508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  905519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  905528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905554 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  905557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905576 */     GIR_RootConstrainSelectedInstOperands,
     /*  905577 */     // GIR_Coverage, 62452,
     /*  905577 */     GIR_EraseRootFromParent_Done,
     /*  905578 */   // Label 13815: @905578
     /*  905578 */   GIM_Try, /*On fail goto*//*Label 13816*/ GIMT_Encode4(905653), // Rule ID 62453 //
     /*  905583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  905594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  905603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905629 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  905632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905651 */     GIR_RootConstrainSelectedInstOperands,
     /*  905652 */     // GIR_Coverage, 62453,
     /*  905652 */     GIR_EraseRootFromParent_Done,
     /*  905653 */   // Label 13816: @905653
     /*  905653 */   GIM_Try, /*On fail goto*//*Label 13817*/ GIMT_Encode4(905717), // Rule ID 64522 //
     /*  905658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuN),
     /*  905666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905694 */     // MIs[0] imm5
     /*  905694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905697 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905702 */     // (intrinsic_wo_chain:{ *:[i32] } 11005:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACUN),
     /*  905705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905713 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905715 */     GIR_RootConstrainSelectedInstOperands,
     /*  905716 */     // GIR_Coverage, 64522,
     /*  905716 */     GIR_EraseRootFromParent_Done,
     /*  905717 */   // Label 13817: @905717
     /*  905717 */   GIM_Try, /*On fail goto*//*Label 13818*/ GIMT_Encode4(905781), // Rule ID 64523 //
     /*  905722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuN),
     /*  905730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905758 */     // MIs[0] imm5
     /*  905758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905766 */     // (intrinsic_wo_chain:{ *:[i32] } 11001:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHUN),
     /*  905769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905777 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905779 */     GIR_RootConstrainSelectedInstOperands,
     /*  905780 */     // GIR_Coverage, 64523,
     /*  905780 */     GIR_EraseRootFromParent_Done,
     /*  905781 */   // Label 13818: @905781
     /*  905781 */   GIM_Try, /*On fail goto*//*Label 13819*/ GIMT_Encode4(905845), // Rule ID 64524 //
     /*  905786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsN),
     /*  905794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905822 */     // MIs[0] imm5
     /*  905822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905825 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905830 */     // (intrinsic_wo_chain:{ *:[i32] } 11003:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSN),
     /*  905833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905841 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905843 */     GIR_RootConstrainSelectedInstOperands,
     /*  905844 */     // GIR_Coverage, 64524,
     /*  905844 */     GIR_EraseRootFromParent_Done,
     /*  905845 */   // Label 13819: @905845
     /*  905845 */   GIM_Try, /*On fail goto*//*Label 13820*/ GIMT_Encode4(905909), // Rule ID 64525 //
     /*  905850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsN),
     /*  905858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905886 */     // MIs[0] imm5
     /*  905886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905894 */     // (intrinsic_wo_chain:{ *:[i32] } 10999:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSN),
     /*  905897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905905 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905907 */     GIR_RootConstrainSelectedInstOperands,
     /*  905908 */     // GIR_Coverage, 64525,
     /*  905908 */     GIR_EraseRootFromParent_Done,
     /*  905909 */   // Label 13820: @905909
     /*  905909 */   GIM_Try, /*On fail goto*//*Label 13821*/ GIMT_Encode4(905973), // Rule ID 64526 //
     /*  905914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuRN),
     /*  905922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905950 */     // MIs[0] imm5
     /*  905950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905958 */     // (intrinsic_wo_chain:{ *:[i32] } 11006:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACURN),
     /*  905961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905969 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905971 */     GIR_RootConstrainSelectedInstOperands,
     /*  905972 */     // GIR_Coverage, 64526,
     /*  905972 */     GIR_EraseRootFromParent_Done,
     /*  905973 */   // Label 13821: @905973
     /*  905973 */   GIM_Try, /*On fail goto*//*Label 13822*/ GIMT_Encode4(906037), // Rule ID 64527 //
     /*  905978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuRN),
     /*  905986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906014 */     // MIs[0] imm5
     /*  906014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906022 */     // (intrinsic_wo_chain:{ *:[i32] } 11002:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHURN),
     /*  906025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906033 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906035 */     GIR_RootConstrainSelectedInstOperands,
     /*  906036 */     // GIR_Coverage, 64527,
     /*  906036 */     GIR_EraseRootFromParent_Done,
     /*  906037 */   // Label 13822: @906037
     /*  906037 */   GIM_Try, /*On fail goto*//*Label 13823*/ GIMT_Encode4(906101), // Rule ID 64528 //
     /*  906042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsRN),
     /*  906050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906078 */     // MIs[0] imm5
     /*  906078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906081 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906086 */     // (intrinsic_wo_chain:{ *:[i32] } 11004:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSRN),
     /*  906089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906097 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906099 */     GIR_RootConstrainSelectedInstOperands,
     /*  906100 */     // GIR_Coverage, 64528,
     /*  906100 */     GIR_EraseRootFromParent_Done,
     /*  906101 */   // Label 13823: @906101
     /*  906101 */   GIM_Try, /*On fail goto*//*Label 13824*/ GIMT_Encode4(906165), // Rule ID 64529 //
     /*  906106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsRN),
     /*  906114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906142 */     // MIs[0] imm5
     /*  906142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906145 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906150 */     // (intrinsic_wo_chain:{ *:[i32] } 11000:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSRN),
     /*  906153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906161 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906163 */     GIR_RootConstrainSelectedInstOperands,
     /*  906164 */     // GIR_Coverage, 64529,
     /*  906164 */     GIR_EraseRootFromParent_Done,
     /*  906165 */   // Label 13824: @906165
     /*  906165 */   GIM_Reject,
     /*  906166 */ // Label 6978: @906166
     /*  906166 */ GIM_Try, /*On fail goto*//*Label 13825*/ GIMT_Encode4(1401717),
     /*  906171 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  906174 */   GIM_Try, /*On fail goto*//*Label 13826*/ GIMT_Encode4(906257), // Rule ID 62861 //
     /*  906179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  906190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  906193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  906196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906203 */     // MIs[0] op1
     /*  906203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906219 */     // MIs[0] op4
     /*  906219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906234 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  906234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF8),
     /*  906237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906239 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906241 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906243 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906245 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906255 */     GIR_RootConstrainSelectedInstOperands,
     /*  906256 */     // GIR_Coverage, 62861,
     /*  906256 */     GIR_EraseRootFromParent_Done,
     /*  906257 */   // Label 13826: @906257
     /*  906257 */   GIM_Try, /*On fail goto*//*Label 13827*/ GIMT_Encode4(906340), // Rule ID 62862 //
     /*  906262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  906273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  906276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  906279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906286 */     // MIs[0] op1
     /*  906286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906302 */     // MIs[0] op4
     /*  906302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906317 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  906317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF8),
     /*  906320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906322 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906324 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906326 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906328 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906338 */     GIR_RootConstrainSelectedInstOperands,
     /*  906339 */     // GIR_Coverage, 62862,
     /*  906339 */     GIR_EraseRootFromParent_Done,
     /*  906340 */   // Label 13827: @906340
     /*  906340 */   GIM_Try, /*On fail goto*//*Label 13828*/ GIMT_Encode4(906423), // Rule ID 62905 //
     /*  906345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  906356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  906359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  906362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906369 */     // MIs[0] op1
     /*  906369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906385 */     // MIs[0] op4
     /*  906385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906400 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  906400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF4),
     /*  906403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906405 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906407 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906409 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906411 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906421 */     GIR_RootConstrainSelectedInstOperands,
     /*  906422 */     // GIR_Coverage, 62905,
     /*  906422 */     GIR_EraseRootFromParent_Done,
     /*  906423 */   // Label 13828: @906423
     /*  906423 */   GIM_Try, /*On fail goto*//*Label 13829*/ GIMT_Encode4(906506), // Rule ID 62906 //
     /*  906428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  906439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  906442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  906445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906452 */     // MIs[0] op1
     /*  906452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906455 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906468 */     // MIs[0] op4
     /*  906468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906483 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  906483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF4),
     /*  906486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906488 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906490 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906492 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906494 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906504 */     GIR_RootConstrainSelectedInstOperands,
     /*  906505 */     // GIR_Coverage, 62906,
     /*  906505 */     GIR_EraseRootFromParent_Done,
     /*  906506 */   // Label 13829: @906506
     /*  906506 */   GIM_Try, /*On fail goto*//*Label 13830*/ GIMT_Encode4(906589), // Rule ID 62949 //
     /*  906511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  906522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  906525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  906528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906535 */     // MIs[0] op1
     /*  906535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906551 */     // MIs[0] op4
     /*  906551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906554 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906566 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  906566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  906569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906571 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906573 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906575 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906577 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906587 */     GIR_RootConstrainSelectedInstOperands,
     /*  906588 */     // GIR_Coverage, 62949,
     /*  906588 */     GIR_EraseRootFromParent_Done,
     /*  906589 */   // Label 13830: @906589
     /*  906589 */   GIM_Try, /*On fail goto*//*Label 13831*/ GIMT_Encode4(906672), // Rule ID 62950 //
     /*  906594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  906605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  906608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  906611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906618 */     // MIs[0] op1
     /*  906618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906634 */     // MIs[0] op4
     /*  906634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906637 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906649 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  906649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  906652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906654 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906656 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906658 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906660 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906670 */     GIR_RootConstrainSelectedInstOperands,
     /*  906671 */     // GIR_Coverage, 62950,
     /*  906671 */     GIR_EraseRootFromParent_Done,
     /*  906672 */   // Label 13831: @906672
     /*  906672 */   GIM_Try, /*On fail goto*//*Label 13832*/ GIMT_Encode4(906755), // Rule ID 62993 //
     /*  906677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  906688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  906691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  906694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906701 */     // MIs[0] op1
     /*  906701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906704 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906717 */     // MIs[0] op4
     /*  906717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906720 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906732 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  906732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF4),
     /*  906735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906737 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906739 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906741 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906743 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906753 */     GIR_RootConstrainSelectedInstOperands,
     /*  906754 */     // GIR_Coverage, 62993,
     /*  906754 */     GIR_EraseRootFromParent_Done,
     /*  906755 */   // Label 13832: @906755
     /*  906755 */   GIM_Try, /*On fail goto*//*Label 13833*/ GIMT_Encode4(906838), // Rule ID 62994 //
     /*  906760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  906771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  906774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  906777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906784 */     // MIs[0] op1
     /*  906784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906800 */     // MIs[0] op4
     /*  906800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906803 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906815 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  906815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF4),
     /*  906818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906820 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906822 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906824 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906826 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906836 */     GIR_RootConstrainSelectedInstOperands,
     /*  906837 */     // GIR_Coverage, 62994,
     /*  906837 */     GIR_EraseRootFromParent_Done,
     /*  906838 */   // Label 13833: @906838
     /*  906838 */   GIM_Try, /*On fail goto*//*Label 13834*/ GIMT_Encode4(906921), // Rule ID 63049 //
     /*  906843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  906854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  906857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  906860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906867 */     // MIs[0] op1
     /*  906867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906883 */     // MIs[0] op4
     /*  906883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906898 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  906898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  906901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906903 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906905 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906907 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906909 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906919 */     GIR_RootConstrainSelectedInstOperands,
     /*  906920 */     // GIR_Coverage, 63049,
     /*  906920 */     GIR_EraseRootFromParent_Done,
     /*  906921 */   // Label 13834: @906921
     /*  906921 */   GIM_Try, /*On fail goto*//*Label 13835*/ GIMT_Encode4(907004), // Rule ID 63050 //
     /*  906926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  906937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  906940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  906943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906950 */     // MIs[0] op1
     /*  906950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906966 */     // MIs[0] op4
     /*  906966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906981 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  906981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  906984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906986 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906988 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906990 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906992 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907002 */     GIR_RootConstrainSelectedInstOperands,
     /*  907003 */     // GIR_Coverage, 63050,
     /*  907003 */     GIR_EraseRootFromParent_Done,
     /*  907004 */   // Label 13835: @907004
     /*  907004 */   GIM_Try, /*On fail goto*//*Label 13836*/ GIMT_Encode4(907087), // Rule ID 63105 //
     /*  907009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  907020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  907023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  907026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907033 */     // MIs[0] op1
     /*  907033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907049 */     // MIs[0] op4
     /*  907049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907064 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  907064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907069 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907071 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907073 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907075 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907085 */     GIR_RootConstrainSelectedInstOperands,
     /*  907086 */     // GIR_Coverage, 63105,
     /*  907086 */     GIR_EraseRootFromParent_Done,
     /*  907087 */   // Label 13836: @907087
     /*  907087 */   GIM_Try, /*On fail goto*//*Label 13837*/ GIMT_Encode4(907170), // Rule ID 63106 //
     /*  907092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  907103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  907106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  907109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907116 */     // MIs[0] op1
     /*  907116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907119 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907132 */     // MIs[0] op4
     /*  907132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907147 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  907147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907152 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907154 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907156 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907158 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907168 */     GIR_RootConstrainSelectedInstOperands,
     /*  907169 */     // GIR_Coverage, 63106,
     /*  907169 */     GIR_EraseRootFromParent_Done,
     /*  907170 */   // Label 13837: @907170
     /*  907170 */   GIM_Try, /*On fail goto*//*Label 13838*/ GIMT_Encode4(907253), // Rule ID 63161 //
     /*  907175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  907186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  907189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  907192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907199 */     // MIs[0] op1
     /*  907199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907215 */     // MIs[0] op4
     /*  907215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907218 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907230 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  907230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907235 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907237 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907239 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907241 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907251 */     GIR_RootConstrainSelectedInstOperands,
     /*  907252 */     // GIR_Coverage, 63161,
     /*  907252 */     GIR_EraseRootFromParent_Done,
     /*  907253 */   // Label 13838: @907253
     /*  907253 */   GIM_Try, /*On fail goto*//*Label 13839*/ GIMT_Encode4(907336), // Rule ID 63162 //
     /*  907258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  907269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  907272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  907275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907282 */     // MIs[0] op1
     /*  907282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907298 */     // MIs[0] op4
     /*  907298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907301 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907313 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  907313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907318 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907320 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907322 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907324 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907334 */     GIR_RootConstrainSelectedInstOperands,
     /*  907335 */     // GIR_Coverage, 63162,
     /*  907335 */     GIR_EraseRootFromParent_Done,
     /*  907336 */   // Label 13839: @907336
     /*  907336 */   GIM_Try, /*On fail goto*//*Label 13840*/ GIMT_Encode4(907419), // Rule ID 63205 //
     /*  907341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  907352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  907355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  907358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907365 */     // MIs[0] op1
     /*  907365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907381 */     // MIs[0] op4
     /*  907381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907384 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907396 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  907396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907401 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907403 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907405 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907407 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907417 */     GIR_RootConstrainSelectedInstOperands,
     /*  907418 */     // GIR_Coverage, 63205,
     /*  907418 */     GIR_EraseRootFromParent_Done,
     /*  907419 */   // Label 13840: @907419
     /*  907419 */   GIM_Try, /*On fail goto*//*Label 13841*/ GIMT_Encode4(907502), // Rule ID 63206 //
     /*  907424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  907435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  907438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  907441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907448 */     // MIs[0] op1
     /*  907448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907464 */     // MIs[0] op4
     /*  907464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907479 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  907479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907484 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907486 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907488 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907490 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907500 */     GIR_RootConstrainSelectedInstOperands,
     /*  907501 */     // GIR_Coverage, 63206,
     /*  907501 */     GIR_EraseRootFromParent_Done,
     /*  907502 */   // Label 13841: @907502
     /*  907502 */   GIM_Try, /*On fail goto*//*Label 13842*/ GIMT_Encode4(907585), // Rule ID 63261 //
     /*  907507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  907518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  907521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  907524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907531 */     // MIs[0] op1
     /*  907531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907547 */     // MIs[0] op4
     /*  907547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907562 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  907562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907567 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907569 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907571 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907573 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907583 */     GIR_RootConstrainSelectedInstOperands,
     /*  907584 */     // GIR_Coverage, 63261,
     /*  907584 */     GIR_EraseRootFromParent_Done,
     /*  907585 */   // Label 13842: @907585
     /*  907585 */   GIM_Try, /*On fail goto*//*Label 13843*/ GIMT_Encode4(907668), // Rule ID 63262 //
     /*  907590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  907601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  907604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  907607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907614 */     // MIs[0] op1
     /*  907614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907630 */     // MIs[0] op4
     /*  907630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907633 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907645 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  907645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907650 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907652 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907654 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907656 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907666 */     GIR_RootConstrainSelectedInstOperands,
     /*  907667 */     // GIR_Coverage, 63262,
     /*  907667 */     GIR_EraseRootFromParent_Done,
     /*  907668 */   // Label 13843: @907668
     /*  907668 */   GIM_Try, /*On fail goto*//*Label 13844*/ GIMT_Encode4(907751), // Rule ID 63317 //
     /*  907673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  907684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  907687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  907690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907697 */     // MIs[0] op1
     /*  907697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907713 */     // MIs[0] op4
     /*  907713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907716 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907728 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  907728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907733 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907735 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907737 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907739 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  907749 */     GIR_RootConstrainSelectedInstOperands,
     /*  907750 */     // GIR_Coverage, 63317,
     /*  907750 */     GIR_EraseRootFromParent_Done,
     /*  907751 */   // Label 13844: @907751
     /*  907751 */   GIM_Try, /*On fail goto*//*Label 13845*/ GIMT_Encode4(907834), // Rule ID 63318 //
     /*  907756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  907767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  907770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  907773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907780 */     // MIs[0] op1
     /*  907780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907796 */     // MIs[0] op4
     /*  907796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907811 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  907811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907816 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907818 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907820 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907822 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  907832 */     GIR_RootConstrainSelectedInstOperands,
     /*  907833 */     // GIR_Coverage, 63318,
     /*  907833 */     GIR_EraseRootFromParent_Done,
     /*  907834 */   // Label 13845: @907834
     /*  907834 */   GIM_Try, /*On fail goto*//*Label 13846*/ GIMT_Encode4(907917), // Rule ID 63373 //
     /*  907839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  907850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  907853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  907856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907863 */     // MIs[0] op1
     /*  907863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907866 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907879 */     // MIs[0] op4
     /*  907879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907894 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  907894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  907897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907899 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907901 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907903 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907905 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907915 */     GIR_RootConstrainSelectedInstOperands,
     /*  907916 */     // GIR_Coverage, 63373,
     /*  907916 */     GIR_EraseRootFromParent_Done,
     /*  907917 */   // Label 13846: @907917
     /*  907917 */   GIM_Try, /*On fail goto*//*Label 13847*/ GIMT_Encode4(908000), // Rule ID 63374 //
     /*  907922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  907933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  907936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  907939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907946 */     // MIs[0] op1
     /*  907946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907949 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907962 */     // MIs[0] op4
     /*  907962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907965 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907977 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  907977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  907980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907982 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907984 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907986 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907988 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907998 */     GIR_RootConstrainSelectedInstOperands,
     /*  907999 */     // GIR_Coverage, 63374,
     /*  907999 */     GIR_EraseRootFromParent_Done,
     /*  908000 */   // Label 13847: @908000
     /*  908000 */   GIM_Try, /*On fail goto*//*Label 13848*/ GIMT_Encode4(908083), // Rule ID 63417 //
     /*  908005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  908016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  908019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  908022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908029 */     // MIs[0] op1
     /*  908029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908032 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908045 */     // MIs[0] op4
     /*  908045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908048 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908060 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  908060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  908063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908065 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908067 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908069 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908071 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908081 */     GIR_RootConstrainSelectedInstOperands,
     /*  908082 */     // GIR_Coverage, 63417,
     /*  908082 */     GIR_EraseRootFromParent_Done,
     /*  908083 */   // Label 13848: @908083
     /*  908083 */   GIM_Try, /*On fail goto*//*Label 13849*/ GIMT_Encode4(908166), // Rule ID 63418 //
     /*  908088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  908099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  908102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  908105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908112 */     // MIs[0] op1
     /*  908112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908128 */     // MIs[0] op4
     /*  908128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908143 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  908143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  908146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908148 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908150 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908152 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908154 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908164 */     GIR_RootConstrainSelectedInstOperands,
     /*  908165 */     // GIR_Coverage, 63418,
     /*  908165 */     GIR_EraseRootFromParent_Done,
     /*  908166 */   // Label 13849: @908166
     /*  908166 */   GIM_Try, /*On fail goto*//*Label 13850*/ GIMT_Encode4(908249), // Rule ID 63461 //
     /*  908171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  908182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  908185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  908188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908195 */     // MIs[0] op1
     /*  908195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908211 */     // MIs[0] op4
     /*  908211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908226 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  908226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  908229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908231 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908233 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908235 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908237 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908247 */     GIR_RootConstrainSelectedInstOperands,
     /*  908248 */     // GIR_Coverage, 63461,
     /*  908248 */     GIR_EraseRootFromParent_Done,
     /*  908249 */   // Label 13850: @908249
     /*  908249 */   GIM_Try, /*On fail goto*//*Label 13851*/ GIMT_Encode4(908332), // Rule ID 63462 //
     /*  908254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  908265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  908268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  908271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908278 */     // MIs[0] op1
     /*  908278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908294 */     // MIs[0] op4
     /*  908294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908297 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908309 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  908309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  908312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908314 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908316 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908318 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908320 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908330 */     GIR_RootConstrainSelectedInstOperands,
     /*  908331 */     // GIR_Coverage, 63462,
     /*  908331 */     GIR_EraseRootFromParent_Done,
     /*  908332 */   // Label 13851: @908332
     /*  908332 */   GIM_Try, /*On fail goto*//*Label 13852*/ GIMT_Encode4(908415), // Rule ID 63505 //
     /*  908337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  908348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  908351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  908354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908361 */     // MIs[0] op1
     /*  908361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908377 */     // MIs[0] op4
     /*  908377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  908392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  908395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908397 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908399 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908401 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908403 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908413 */     GIR_RootConstrainSelectedInstOperands,
     /*  908414 */     // GIR_Coverage, 63505,
     /*  908414 */     GIR_EraseRootFromParent_Done,
     /*  908415 */   // Label 13852: @908415
     /*  908415 */   GIM_Try, /*On fail goto*//*Label 13853*/ GIMT_Encode4(908498), // Rule ID 63506 //
     /*  908420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  908431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  908434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  908437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908444 */     // MIs[0] op1
     /*  908444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908447 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908460 */     // MIs[0] op4
     /*  908460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908463 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908475 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  908475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  908478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908480 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908482 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908484 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908486 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908496 */     GIR_RootConstrainSelectedInstOperands,
     /*  908497 */     // GIR_Coverage, 63506,
     /*  908497 */     GIR_EraseRootFromParent_Done,
     /*  908498 */   // Label 13853: @908498
     /*  908498 */   GIM_Try, /*On fail goto*//*Label 13854*/ GIMT_Encode4(908581), // Rule ID 63561 //
     /*  908503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  908514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  908517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  908520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908527 */     // MIs[0] op1
     /*  908527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908530 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908543 */     // MIs[0] op4
     /*  908543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908558 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  908558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  908561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908563 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908565 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908567 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908569 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908579 */     GIR_RootConstrainSelectedInstOperands,
     /*  908580 */     // GIR_Coverage, 63561,
     /*  908580 */     GIR_EraseRootFromParent_Done,
     /*  908581 */   // Label 13854: @908581
     /*  908581 */   GIM_Try, /*On fail goto*//*Label 13855*/ GIMT_Encode4(908664), // Rule ID 63562 //
     /*  908586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  908597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  908600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  908603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908610 */     // MIs[0] op1
     /*  908610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908613 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908626 */     // MIs[0] op4
     /*  908626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908641 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  908641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  908644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908646 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908648 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908650 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908652 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908662 */     GIR_RootConstrainSelectedInstOperands,
     /*  908663 */     // GIR_Coverage, 63562,
     /*  908663 */     GIR_EraseRootFromParent_Done,
     /*  908664 */   // Label 13855: @908664
     /*  908664 */   GIM_Try, /*On fail goto*//*Label 13856*/ GIMT_Encode4(908747), // Rule ID 63617 //
     /*  908669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  908680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  908683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  908686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908693 */     // MIs[0] op1
     /*  908693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908709 */     // MIs[0] op4
     /*  908709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908724 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  908724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  908727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908729 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908731 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908733 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908735 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908745 */     GIR_RootConstrainSelectedInstOperands,
     /*  908746 */     // GIR_Coverage, 63617,
     /*  908746 */     GIR_EraseRootFromParent_Done,
     /*  908747 */   // Label 13856: @908747
     /*  908747 */   GIM_Try, /*On fail goto*//*Label 13857*/ GIMT_Encode4(908830), // Rule ID 63618 //
     /*  908752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  908763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  908766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  908769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908776 */     // MIs[0] op1
     /*  908776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908779 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908792 */     // MIs[0] op4
     /*  908792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908795 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908807 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  908807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  908810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908812 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908814 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908816 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908818 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908828 */     GIR_RootConstrainSelectedInstOperands,
     /*  908829 */     // GIR_Coverage, 63618,
     /*  908829 */     GIR_EraseRootFromParent_Done,
     /*  908830 */   // Label 13857: @908830
     /*  908830 */   GIM_Try, /*On fail goto*//*Label 13858*/ GIMT_Encode4(908913), // Rule ID 63673 //
     /*  908835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  908846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  908849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  908852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908859 */     // MIs[0] op1
     /*  908859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908875 */     // MIs[0] op4
     /*  908875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  908890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  908893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908895 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908897 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908899 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908901 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908911 */     GIR_RootConstrainSelectedInstOperands,
     /*  908912 */     // GIR_Coverage, 63673,
     /*  908912 */     GIR_EraseRootFromParent_Done,
     /*  908913 */   // Label 13858: @908913
     /*  908913 */   GIM_Try, /*On fail goto*//*Label 13859*/ GIMT_Encode4(908996), // Rule ID 63674 //
     /*  908918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  908929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  908932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  908935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908942 */     // MIs[0] op1
     /*  908942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908958 */     // MIs[0] op4
     /*  908958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908973 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  908973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  908976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908978 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908980 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908982 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908984 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908994 */     GIR_RootConstrainSelectedInstOperands,
     /*  908995 */     // GIR_Coverage, 63674,
     /*  908995 */     GIR_EraseRootFromParent_Done,
     /*  908996 */   // Label 13859: @908996
     /*  908996 */   GIM_Try, /*On fail goto*//*Label 13860*/ GIMT_Encode4(909079), // Rule ID 63729 //
     /*  909001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  909012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  909015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  909018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909025 */     // MIs[0] op1
     /*  909025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909041 */     // MIs[0] op4
     /*  909041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909056 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  909056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  909059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909061 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909063 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909065 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909067 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909077 */     GIR_RootConstrainSelectedInstOperands,
     /*  909078 */     // GIR_Coverage, 63729,
     /*  909078 */     GIR_EraseRootFromParent_Done,
     /*  909079 */   // Label 13860: @909079
     /*  909079 */   GIM_Try, /*On fail goto*//*Label 13861*/ GIMT_Encode4(909162), // Rule ID 63730 //
     /*  909084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  909095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  909098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  909101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909108 */     // MIs[0] op1
     /*  909108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909111 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909124 */     // MIs[0] op4
     /*  909124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909127 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909139 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  909139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  909142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909144 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909146 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909148 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909150 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909160 */     GIR_RootConstrainSelectedInstOperands,
     /*  909161 */     // GIR_Coverage, 63730,
     /*  909161 */     GIR_EraseRootFromParent_Done,
     /*  909162 */   // Label 13861: @909162
     /*  909162 */   GIM_Try, /*On fail goto*//*Label 13862*/ GIMT_Encode4(909245), // Rule ID 63785 //
     /*  909167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  909181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  909184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909191 */     // MIs[0] op1
     /*  909191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909207 */     // MIs[0] op4
     /*  909207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909222 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  909222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  909225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909227 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909229 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909231 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909233 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909243 */     GIR_RootConstrainSelectedInstOperands,
     /*  909244 */     // GIR_Coverage, 63785,
     /*  909244 */     GIR_EraseRootFromParent_Done,
     /*  909245 */   // Label 13862: @909245
     /*  909245 */   GIM_Try, /*On fail goto*//*Label 13863*/ GIMT_Encode4(909328), // Rule ID 63786 //
     /*  909250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  909264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  909267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909274 */     // MIs[0] op1
     /*  909274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909290 */     // MIs[0] op4
     /*  909290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909305 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  909305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  909308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909310 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909312 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909314 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909316 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909326 */     GIR_RootConstrainSelectedInstOperands,
     /*  909327 */     // GIR_Coverage, 63786,
     /*  909327 */     GIR_EraseRootFromParent_Done,
     /*  909328 */   // Label 13863: @909328
     /*  909328 */   GIM_Try, /*On fail goto*//*Label 13864*/ GIMT_Encode4(909411), // Rule ID 63841 //
     /*  909333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  909344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  909347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  909350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909357 */     // MIs[0] op1
     /*  909357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909373 */     // MIs[0] op4
     /*  909373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909388 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  909388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  909391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909393 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909395 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909397 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909399 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909409 */     GIR_RootConstrainSelectedInstOperands,
     /*  909410 */     // GIR_Coverage, 63841,
     /*  909410 */     GIR_EraseRootFromParent_Done,
     /*  909411 */   // Label 13864: @909411
     /*  909411 */   GIM_Try, /*On fail goto*//*Label 13865*/ GIMT_Encode4(909494), // Rule ID 63842 //
     /*  909416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  909427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  909430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  909433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909440 */     // MIs[0] op1
     /*  909440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909456 */     // MIs[0] op4
     /*  909456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909471 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  909471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  909474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909476 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909478 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909480 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909482 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909492 */     GIR_RootConstrainSelectedInstOperands,
     /*  909493 */     // GIR_Coverage, 63842,
     /*  909493 */     GIR_EraseRootFromParent_Done,
     /*  909494 */   // Label 13865: @909494
     /*  909494 */   GIM_Try, /*On fail goto*//*Label 13866*/ GIMT_Encode4(909577), // Rule ID 63897 //
     /*  909499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  909510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  909513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  909516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909523 */     // MIs[0] op1
     /*  909523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909539 */     // MIs[0] op4
     /*  909539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909542 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909554 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  909554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  909557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909559 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909561 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909563 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909565 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909575 */     GIR_RootConstrainSelectedInstOperands,
     /*  909576 */     // GIR_Coverage, 63897,
     /*  909576 */     GIR_EraseRootFromParent_Done,
     /*  909577 */   // Label 13866: @909577
     /*  909577 */   GIM_Try, /*On fail goto*//*Label 13867*/ GIMT_Encode4(909660), // Rule ID 63898 //
     /*  909582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  909593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  909596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  909599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909606 */     // MIs[0] op1
     /*  909606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909622 */     // MIs[0] op4
     /*  909622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909637 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  909637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  909640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909642 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909644 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909646 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909648 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909658 */     GIR_RootConstrainSelectedInstOperands,
     /*  909659 */     // GIR_Coverage, 63898,
     /*  909659 */     GIR_EraseRootFromParent_Done,
     /*  909660 */   // Label 13867: @909660
     /*  909660 */   GIM_Try, /*On fail goto*//*Label 13868*/ GIMT_Encode4(909743), // Rule ID 63953 //
     /*  909665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  909676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  909679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  909682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909689 */     // MIs[0] op1
     /*  909689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909705 */     // MIs[0] op4
     /*  909705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909708 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909720 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  909720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  909723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909725 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909727 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909729 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909731 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909741 */     GIR_RootConstrainSelectedInstOperands,
     /*  909742 */     // GIR_Coverage, 63953,
     /*  909742 */     GIR_EraseRootFromParent_Done,
     /*  909743 */   // Label 13868: @909743
     /*  909743 */   GIM_Try, /*On fail goto*//*Label 13869*/ GIMT_Encode4(909826), // Rule ID 63954 //
     /*  909748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  909759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  909762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  909765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909772 */     // MIs[0] op1
     /*  909772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909788 */     // MIs[0] op4
     /*  909788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909791 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909803 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  909803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  909806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909808 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909810 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909812 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909814 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909824 */     GIR_RootConstrainSelectedInstOperands,
     /*  909825 */     // GIR_Coverage, 63954,
     /*  909825 */     GIR_EraseRootFromParent_Done,
     /*  909826 */   // Label 13869: @909826
     /*  909826 */   GIM_Try, /*On fail goto*//*Label 13870*/ GIMT_Encode4(909909), // Rule ID 63983 //
     /*  909831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  909842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  909845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  909848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909855 */     // MIs[0] op1
     /*  909855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909858 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909871 */     // MIs[0] op4
     /*  909871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909874 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909886 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  909886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF8),
     /*  909889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909891 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909893 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909895 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909897 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  909907 */     GIR_RootConstrainSelectedInstOperands,
     /*  909908 */     // GIR_Coverage, 63983,
     /*  909908 */     GIR_EraseRootFromParent_Done,
     /*  909909 */   // Label 13870: @909909
     /*  909909 */   GIM_Try, /*On fail goto*//*Label 13871*/ GIMT_Encode4(909992), // Rule ID 63984 //
     /*  909914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  909925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  909928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  909931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909938 */     // MIs[0] op1
     /*  909938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909954 */     // MIs[0] op4
     /*  909954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909957 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909969 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  909969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF8),
     /*  909972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909974 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909976 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909978 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909980 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  909990 */     GIR_RootConstrainSelectedInstOperands,
     /*  909991 */     // GIR_Coverage, 63984,
     /*  909991 */     GIR_EraseRootFromParent_Done,
     /*  909992 */   // Label 13871: @909992
     /*  909992 */   GIM_Try, /*On fail goto*//*Label 13872*/ GIMT_Encode4(910075), // Rule ID 64001 //
     /*  909997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  910008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  910011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910021 */     // MIs[0] op1
     /*  910021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910024 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910037 */     // MIs[0] op4
     /*  910037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910040 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910052 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF4),
     /*  910055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910057 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910059 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910061 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910063 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910073 */     GIR_RootConstrainSelectedInstOperands,
     /*  910074 */     // GIR_Coverage, 64001,
     /*  910074 */     GIR_EraseRootFromParent_Done,
     /*  910075 */   // Label 13872: @910075
     /*  910075 */   GIM_Try, /*On fail goto*//*Label 13873*/ GIMT_Encode4(910158), // Rule ID 64002 //
     /*  910080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  910091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  910094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910104 */     // MIs[0] op1
     /*  910104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910120 */     // MIs[0] op4
     /*  910120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910135 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF4),
     /*  910138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910140 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910142 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910144 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910146 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910156 */     GIR_RootConstrainSelectedInstOperands,
     /*  910157 */     // GIR_Coverage, 64002,
     /*  910157 */     GIR_EraseRootFromParent_Done,
     /*  910158 */   // Label 13873: @910158
     /*  910158 */   GIM_Try, /*On fail goto*//*Label 13874*/ GIMT_Encode4(910241), // Rule ID 64019 //
     /*  910163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  910174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  910177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910187 */     // MIs[0] op1
     /*  910187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910203 */     // MIs[0] op4
     /*  910203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910218 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  910221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910223 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910225 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910227 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910229 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910239 */     GIR_RootConstrainSelectedInstOperands,
     /*  910240 */     // GIR_Coverage, 64019,
     /*  910240 */     GIR_EraseRootFromParent_Done,
     /*  910241 */   // Label 13874: @910241
     /*  910241 */   GIM_Try, /*On fail goto*//*Label 13875*/ GIMT_Encode4(910324), // Rule ID 64020 //
     /*  910246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  910257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  910260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910270 */     // MIs[0] op1
     /*  910270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910273 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910286 */     // MIs[0] op4
     /*  910286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910301 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  910304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910306 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910308 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910310 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910312 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910322 */     GIR_RootConstrainSelectedInstOperands,
     /*  910323 */     // GIR_Coverage, 64020,
     /*  910323 */     GIR_EraseRootFromParent_Done,
     /*  910324 */   // Label 13875: @910324
     /*  910324 */   GIM_Try, /*On fail goto*//*Label 13876*/ GIMT_Encode4(910407), // Rule ID 64037 //
     /*  910329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  910340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  910343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  910346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910353 */     // MIs[0] op1
     /*  910353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910369 */     // MIs[0] op4
     /*  910369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  910387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910389 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910391 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910393 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910395 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910405 */     GIR_RootConstrainSelectedInstOperands,
     /*  910406 */     // GIR_Coverage, 64037,
     /*  910406 */     GIR_EraseRootFromParent_Done,
     /*  910407 */   // Label 13876: @910407
     /*  910407 */   GIM_Try, /*On fail goto*//*Label 13877*/ GIMT_Encode4(910490), // Rule ID 64038 //
     /*  910412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  910423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  910426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  910429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910436 */     // MIs[0] op1
     /*  910436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910452 */     // MIs[0] op4
     /*  910452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910455 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910467 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  910470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910472 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910474 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910476 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910478 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910488 */     GIR_RootConstrainSelectedInstOperands,
     /*  910489 */     // GIR_Coverage, 64038,
     /*  910489 */     GIR_EraseRootFromParent_Done,
     /*  910490 */   // Label 13877: @910490
     /*  910490 */   GIM_Try, /*On fail goto*//*Label 13878*/ GIMT_Encode4(910573), // Rule ID 64055 //
     /*  910495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  910506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  910509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  910512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910519 */     // MIs[0] op1
     /*  910519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910522 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910535 */     // MIs[0] op4
     /*  910535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910550 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  910553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910555 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910557 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910559 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910561 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910571 */     GIR_RootConstrainSelectedInstOperands,
     /*  910572 */     // GIR_Coverage, 64055,
     /*  910572 */     GIR_EraseRootFromParent_Done,
     /*  910573 */   // Label 13878: @910573
     /*  910573 */   GIM_Try, /*On fail goto*//*Label 13879*/ GIMT_Encode4(910656), // Rule ID 64056 //
     /*  910578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  910589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  910592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  910595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910602 */     // MIs[0] op1
     /*  910602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910605 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910618 */     // MIs[0] op4
     /*  910618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910633 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  910636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910638 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910640 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910642 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910644 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910654 */     GIR_RootConstrainSelectedInstOperands,
     /*  910655 */     // GIR_Coverage, 64056,
     /*  910655 */     GIR_EraseRootFromParent_Done,
     /*  910656 */   // Label 13879: @910656
     /*  910656 */   GIM_Try, /*On fail goto*//*Label 13880*/ GIMT_Encode4(910739), // Rule ID 64073 //
     /*  910661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  910672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  910675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  910678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910685 */     // MIs[0] op1
     /*  910685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910688 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910701 */     // MIs[0] op4
     /*  910701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910704 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910716 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  910719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910721 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910723 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910725 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910727 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910737 */     GIR_RootConstrainSelectedInstOperands,
     /*  910738 */     // GIR_Coverage, 64073,
     /*  910738 */     GIR_EraseRootFromParent_Done,
     /*  910739 */   // Label 13880: @910739
     /*  910739 */   GIM_Try, /*On fail goto*//*Label 13881*/ GIMT_Encode4(910822), // Rule ID 64074 //
     /*  910744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  910755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  910758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  910761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910768 */     // MIs[0] op1
     /*  910768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910784 */     // MIs[0] op4
     /*  910784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910799 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  910802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910804 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910806 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910808 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910810 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910820 */     GIR_RootConstrainSelectedInstOperands,
     /*  910821 */     // GIR_Coverage, 64074,
     /*  910821 */     GIR_EraseRootFromParent_Done,
     /*  910822 */   // Label 13881: @910822
     /*  910822 */   GIM_Try, /*On fail goto*//*Label 13882*/ GIMT_Encode4(910905), // Rule ID 64091 //
     /*  910827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  910838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  910841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  910844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910851 */     // MIs[0] op1
     /*  910851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910867 */     // MIs[0] op4
     /*  910867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910882 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  910882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF4),
     /*  910885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910887 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910889 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910891 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910893 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910903 */     GIR_RootConstrainSelectedInstOperands,
     /*  910904 */     // GIR_Coverage, 64091,
     /*  910904 */     GIR_EraseRootFromParent_Done,
     /*  910905 */   // Label 13882: @910905
     /*  910905 */   GIM_Try, /*On fail goto*//*Label 13883*/ GIMT_Encode4(910988), // Rule ID 64092 //
     /*  910910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  910921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  910924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  910927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910934 */     // MIs[0] op1
     /*  910934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910950 */     // MIs[0] op4
     /*  910950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910965 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  910965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF4),
     /*  910968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910970 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910972 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910974 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910976 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910986 */     GIR_RootConstrainSelectedInstOperands,
     /*  910987 */     // GIR_Coverage, 64092,
     /*  910987 */     GIR_EraseRootFromParent_Done,
     /*  910988 */   // Label 13883: @910988
     /*  910988 */   GIM_Try, /*On fail goto*//*Label 13884*/ GIMT_Encode4(911071), // Rule ID 64115 //
     /*  910993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  911010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911017 */     // MIs[0] op1
     /*  911017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911033 */     // MIs[0] op4
     /*  911033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  911051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911053 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911055 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911057 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911059 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911069 */     GIR_RootConstrainSelectedInstOperands,
     /*  911070 */     // GIR_Coverage, 64115,
     /*  911070 */     GIR_EraseRootFromParent_Done,
     /*  911071 */   // Label 13884: @911071
     /*  911071 */   GIM_Try, /*On fail goto*//*Label 13885*/ GIMT_Encode4(911154), // Rule ID 64116 //
     /*  911076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  911093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911100 */     // MIs[0] op1
     /*  911100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911116 */     // MIs[0] op4
     /*  911116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911119 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911131 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  911134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911136 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911138 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911140 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911142 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911152 */     GIR_RootConstrainSelectedInstOperands,
     /*  911153 */     // GIR_Coverage, 64116,
     /*  911153 */     GIR_EraseRootFromParent_Done,
     /*  911154 */   // Label 13885: @911154
     /*  911154 */   GIM_Try, /*On fail goto*//*Label 13886*/ GIMT_Encode4(911237), // Rule ID 64139 //
     /*  911159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  911170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  911173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911183 */     // MIs[0] op1
     /*  911183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911199 */     // MIs[0] op4
     /*  911199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  911217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911219 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911221 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911223 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911225 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911235 */     GIR_RootConstrainSelectedInstOperands,
     /*  911236 */     // GIR_Coverage, 64139,
     /*  911236 */     GIR_EraseRootFromParent_Done,
     /*  911237 */   // Label 13886: @911237
     /*  911237 */   GIM_Try, /*On fail goto*//*Label 13887*/ GIMT_Encode4(911320), // Rule ID 64140 //
     /*  911242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  911253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  911256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911266 */     // MIs[0] op1
     /*  911266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911282 */     // MIs[0] op4
     /*  911282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911297 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  911300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911302 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911304 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911306 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911308 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911318 */     GIR_RootConstrainSelectedInstOperands,
     /*  911319 */     // GIR_Coverage, 64140,
     /*  911319 */     GIR_EraseRootFromParent_Done,
     /*  911320 */   // Label 13887: @911320
     /*  911320 */   GIM_Try, /*On fail goto*//*Label 13888*/ GIMT_Encode4(911403), // Rule ID 64163 //
     /*  911325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  911336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  911339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  911342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911349 */     // MIs[0] op1
     /*  911349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911365 */     // MIs[0] op4
     /*  911365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911380 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  911383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911385 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911387 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911389 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911391 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911401 */     GIR_RootConstrainSelectedInstOperands,
     /*  911402 */     // GIR_Coverage, 64163,
     /*  911402 */     GIR_EraseRootFromParent_Done,
     /*  911403 */   // Label 13888: @911403
     /*  911403 */   GIM_Try, /*On fail goto*//*Label 13889*/ GIMT_Encode4(911486), // Rule ID 64164 //
     /*  911408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  911419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  911422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  911425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911432 */     // MIs[0] op1
     /*  911432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911448 */     // MIs[0] op4
     /*  911448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911463 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  911466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911468 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911470 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911472 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911474 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911484 */     GIR_RootConstrainSelectedInstOperands,
     /*  911485 */     // GIR_Coverage, 64164,
     /*  911485 */     GIR_EraseRootFromParent_Done,
     /*  911486 */   // Label 13889: @911486
     /*  911486 */   GIM_Try, /*On fail goto*//*Label 13890*/ GIMT_Encode4(911569), // Rule ID 64187 //
     /*  911491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  911502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  911505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  911508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911515 */     // MIs[0] op1
     /*  911515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911531 */     // MIs[0] op4
     /*  911531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  911549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911551 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911553 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911555 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911557 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911567 */     GIR_RootConstrainSelectedInstOperands,
     /*  911568 */     // GIR_Coverage, 64187,
     /*  911568 */     GIR_EraseRootFromParent_Done,
     /*  911569 */   // Label 13890: @911569
     /*  911569 */   GIM_Try, /*On fail goto*//*Label 13891*/ GIMT_Encode4(911652), // Rule ID 64188 //
     /*  911574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  911585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  911588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  911591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911598 */     // MIs[0] op1
     /*  911598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911601 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911614 */     // MIs[0] op4
     /*  911614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911629 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  911632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911634 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911636 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911638 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911640 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911650 */     GIR_RootConstrainSelectedInstOperands,
     /*  911651 */     // GIR_Coverage, 64188,
     /*  911651 */     GIR_EraseRootFromParent_Done,
     /*  911652 */   // Label 13891: @911652
     /*  911652 */   GIM_Try, /*On fail goto*//*Label 13892*/ GIMT_Encode4(911735), // Rule ID 64211 //
     /*  911657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  911668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  911671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  911674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911681 */     // MIs[0] op1
     /*  911681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911697 */     // MIs[0] op4
     /*  911697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911712 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  911712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  911715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911717 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911719 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911721 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911723 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911733 */     GIR_RootConstrainSelectedInstOperands,
     /*  911734 */     // GIR_Coverage, 64211,
     /*  911734 */     GIR_EraseRootFromParent_Done,
     /*  911735 */   // Label 13892: @911735
     /*  911735 */   GIM_Try, /*On fail goto*//*Label 13893*/ GIMT_Encode4(911818), // Rule ID 64212 //
     /*  911740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  911751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  911754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  911757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911764 */     // MIs[0] op1
     /*  911764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911767 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911780 */     // MIs[0] op4
     /*  911780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911795 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  911795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  911798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911800 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911802 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911804 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911806 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911816 */     GIR_RootConstrainSelectedInstOperands,
     /*  911817 */     // GIR_Coverage, 64212,
     /*  911817 */     GIR_EraseRootFromParent_Done,
     /*  911818 */   // Label 13893: @911818
     /*  911818 */   GIM_Try, /*On fail goto*//*Label 13894*/ GIMT_Encode4(911901), // Rule ID 64235 //
     /*  911823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  911834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  911837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  911840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911847 */     // MIs[0] op1
     /*  911847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911850 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911863 */     // MIs[0] op4
     /*  911863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911866 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911878 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  911878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  911881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911883 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911885 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911887 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911889 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911899 */     GIR_RootConstrainSelectedInstOperands,
     /*  911900 */     // GIR_Coverage, 64235,
     /*  911900 */     GIR_EraseRootFromParent_Done,
     /*  911901 */   // Label 13894: @911901
     /*  911901 */   GIM_Try, /*On fail goto*//*Label 13895*/ GIMT_Encode4(911984), // Rule ID 64236 //
     /*  911906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  911917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  911920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  911923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911930 */     // MIs[0] op1
     /*  911930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911946 */     // MIs[0] op4
     /*  911946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911949 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  911961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  911964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911966 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911968 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911970 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911972 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911982 */     GIR_RootConstrainSelectedInstOperands,
     /*  911983 */     // GIR_Coverage, 64236,
     /*  911983 */     GIR_EraseRootFromParent_Done,
     /*  911984 */   // Label 13895: @911984
     /*  911984 */   GIM_Try, /*On fail goto*//*Label 13896*/ GIMT_Encode4(912067), // Rule ID 64259 //
     /*  911989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  912000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  912003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  912006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912013 */     // MIs[0] op1
     /*  912013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912016 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912029 */     // MIs[0] op4
     /*  912029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912032 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912044 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  912047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912049 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912051 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912053 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912055 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912065 */     GIR_RootConstrainSelectedInstOperands,
     /*  912066 */     // GIR_Coverage, 64259,
     /*  912066 */     GIR_EraseRootFromParent_Done,
     /*  912067 */   // Label 13896: @912067
     /*  912067 */   GIM_Try, /*On fail goto*//*Label 13897*/ GIMT_Encode4(912150), // Rule ID 64260 //
     /*  912072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  912083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  912086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  912089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912096 */     // MIs[0] op1
     /*  912096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912112 */     // MIs[0] op4
     /*  912112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912127 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  912130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912132 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912134 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912136 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912138 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912148 */     GIR_RootConstrainSelectedInstOperands,
     /*  912149 */     // GIR_Coverage, 64260,
     /*  912149 */     GIR_EraseRootFromParent_Done,
     /*  912150 */   // Label 13897: @912150
     /*  912150 */   GIM_Try, /*On fail goto*//*Label 13898*/ GIMT_Encode4(912233), // Rule ID 64283 //
     /*  912155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  912166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  912169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912179 */     // MIs[0] op1
     /*  912179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912195 */     // MIs[0] op4
     /*  912195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912210 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  912213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912215 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912217 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912219 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912221 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912231 */     GIR_RootConstrainSelectedInstOperands,
     /*  912232 */     // GIR_Coverage, 64283,
     /*  912232 */     GIR_EraseRootFromParent_Done,
     /*  912233 */   // Label 13898: @912233
     /*  912233 */   GIM_Try, /*On fail goto*//*Label 13899*/ GIMT_Encode4(912316), // Rule ID 64284 //
     /*  912238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  912249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  912252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912262 */     // MIs[0] op1
     /*  912262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912278 */     // MIs[0] op4
     /*  912278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912293 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  912296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912298 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912300 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912302 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912304 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912314 */     GIR_RootConstrainSelectedInstOperands,
     /*  912315 */     // GIR_Coverage, 64284,
     /*  912315 */     GIR_EraseRootFromParent_Done,
     /*  912316 */   // Label 13899: @912316
     /*  912316 */   GIM_Try, /*On fail goto*//*Label 13900*/ GIMT_Encode4(912394), // Rule ID 60612 //
     /*  912321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  912332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  912335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  912338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912353 */     // MIs[0] rs2
     /*  912353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912361 */     // MIs[0] policy
     /*  912361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912371 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  912374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912392 */     GIR_RootConstrainSelectedInstOperands,
     /*  912393 */     // GIR_Coverage, 60612,
     /*  912393 */     GIR_EraseRootFromParent_Done,
     /*  912394 */   // Label 13900: @912394
     /*  912394 */   GIM_Try, /*On fail goto*//*Label 13901*/ GIMT_Encode4(912472), // Rule ID 60613 //
     /*  912399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  912410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  912413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  912416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912431 */     // MIs[0] rs2
     /*  912431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912439 */     // MIs[0] policy
     /*  912439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912449 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  912452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912470 */     GIR_RootConstrainSelectedInstOperands,
     /*  912471 */     // GIR_Coverage, 60613,
     /*  912471 */     GIR_EraseRootFromParent_Done,
     /*  912472 */   // Label 13901: @912472
     /*  912472 */   GIM_Try, /*On fail goto*//*Label 13902*/ GIMT_Encode4(912550), // Rule ID 62268 //
     /*  912477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  912488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  912491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  912494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912509 */     // MIs[0] rs2
     /*  912509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912512 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912517 */     // MIs[0] policy
     /*  912517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912527 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  912530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912548 */     GIR_RootConstrainSelectedInstOperands,
     /*  912549 */     // GIR_Coverage, 62268,
     /*  912549 */     GIR_EraseRootFromParent_Done,
     /*  912550 */   // Label 13902: @912550
     /*  912550 */   GIM_Try, /*On fail goto*//*Label 13903*/ GIMT_Encode4(912628), // Rule ID 62269 //
     /*  912555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  912566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  912569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  912572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912587 */     // MIs[0] rs2
     /*  912587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912590 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912595 */     // MIs[0] policy
     /*  912595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912605 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  912608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912626 */     GIR_RootConstrainSelectedInstOperands,
     /*  912627 */     // GIR_Coverage, 62269,
     /*  912627 */     GIR_EraseRootFromParent_Done,
     /*  912628 */   // Label 13903: @912628
     /*  912628 */   GIM_Try, /*On fail goto*//*Label 13904*/ GIMT_Encode4(912706), // Rule ID 62270 //
     /*  912633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  912647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912665 */     // MIs[0] rs2
     /*  912665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912673 */     // MIs[0] policy
     /*  912673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912683 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  912686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912704 */     GIR_RootConstrainSelectedInstOperands,
     /*  912705 */     // GIR_Coverage, 62270,
     /*  912705 */     GIR_EraseRootFromParent_Done,
     /*  912706 */   // Label 13904: @912706
     /*  912706 */   GIM_Try, /*On fail goto*//*Label 13905*/ GIMT_Encode4(912784), // Rule ID 62271 //
     /*  912711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  912725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912743 */     // MIs[0] rs2
     /*  912743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912751 */     // MIs[0] policy
     /*  912751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912761 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  912764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912782 */     GIR_RootConstrainSelectedInstOperands,
     /*  912783 */     // GIR_Coverage, 62271,
     /*  912783 */     GIR_EraseRootFromParent_Done,
     /*  912784 */   // Label 13905: @912784
     /*  912784 */   GIM_Try, /*On fail goto*//*Label 13906*/ GIMT_Encode4(912862), // Rule ID 62272 //
     /*  912789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  912800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  912803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  912806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912821 */     // MIs[0] rs2
     /*  912821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912824 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912829 */     // MIs[0] policy
     /*  912829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912839 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  912842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912860 */     GIR_RootConstrainSelectedInstOperands,
     /*  912861 */     // GIR_Coverage, 62272,
     /*  912861 */     GIR_EraseRootFromParent_Done,
     /*  912862 */   // Label 13906: @912862
     /*  912862 */   GIM_Try, /*On fail goto*//*Label 13907*/ GIMT_Encode4(912940), // Rule ID 62273 //
     /*  912867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  912878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  912881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  912884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912899 */     // MIs[0] rs2
     /*  912899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912907 */     // MIs[0] policy
     /*  912907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912917 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  912920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912938 */     GIR_RootConstrainSelectedInstOperands,
     /*  912939 */     // GIR_Coverage, 62273,
     /*  912939 */     GIR_EraseRootFromParent_Done,
     /*  912940 */   // Label 13907: @912940
     /*  912940 */   GIM_Try, /*On fail goto*//*Label 13908*/ GIMT_Encode4(913018), // Rule ID 62274 //
     /*  912945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  912956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  912959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  912962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912977 */     // MIs[0] rs2
     /*  912977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912985 */     // MIs[0] policy
     /*  912985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912995 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  912998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913016 */     GIR_RootConstrainSelectedInstOperands,
     /*  913017 */     // GIR_Coverage, 62274,
     /*  913017 */     GIR_EraseRootFromParent_Done,
     /*  913018 */   // Label 13908: @913018
     /*  913018 */   GIM_Try, /*On fail goto*//*Label 13909*/ GIMT_Encode4(913096), // Rule ID 62275 //
     /*  913023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  913026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913055 */     // MIs[0] rs2
     /*  913055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913063 */     // MIs[0] policy
     /*  913063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913073 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  913076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913094 */     GIR_RootConstrainSelectedInstOperands,
     /*  913095 */     // GIR_Coverage, 62275,
     /*  913095 */     GIR_EraseRootFromParent_Done,
     /*  913096 */   // Label 13909: @913096
     /*  913096 */   GIM_Try, /*On fail goto*//*Label 13910*/ GIMT_Encode4(913174), // Rule ID 62436 //
     /*  913101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  913112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  913115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  913118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913133 */     // MIs[0] rs2
     /*  913133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913136 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913141 */     // MIs[0] policy
     /*  913141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913151 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  913154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913172 */     GIR_RootConstrainSelectedInstOperands,
     /*  913173 */     // GIR_Coverage, 62436,
     /*  913173 */     GIR_EraseRootFromParent_Done,
     /*  913174 */   // Label 13910: @913174
     /*  913174 */   GIM_Try, /*On fail goto*//*Label 13911*/ GIMT_Encode4(913252), // Rule ID 62437 //
     /*  913179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  913190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  913193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  913196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913211 */     // MIs[0] rs2
     /*  913211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913219 */     // MIs[0] policy
     /*  913219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913229 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  913232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913250 */     GIR_RootConstrainSelectedInstOperands,
     /*  913251 */     // GIR_Coverage, 62437,
     /*  913251 */     GIR_EraseRootFromParent_Done,
     /*  913252 */   // Label 13911: @913252
     /*  913252 */   GIM_Try, /*On fail goto*//*Label 13912*/ GIMT_Encode4(913330), // Rule ID 62438 //
     /*  913257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  913268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  913271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  913274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913289 */     // MIs[0] rs2
     /*  913289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913297 */     // MIs[0] policy
     /*  913297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913307 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  913310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913328 */     GIR_RootConstrainSelectedInstOperands,
     /*  913329 */     // GIR_Coverage, 62438,
     /*  913329 */     GIR_EraseRootFromParent_Done,
     /*  913330 */   // Label 13912: @913330
     /*  913330 */   GIM_Try, /*On fail goto*//*Label 13913*/ GIMT_Encode4(913408), // Rule ID 62439 //
     /*  913335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  913346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  913349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  913352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913367 */     // MIs[0] rs2
     /*  913367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913375 */     // MIs[0] policy
     /*  913375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913385 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  913388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913406 */     GIR_RootConstrainSelectedInstOperands,
     /*  913407 */     // GIR_Coverage, 62439,
     /*  913407 */     GIR_EraseRootFromParent_Done,
     /*  913408 */   // Label 13913: @913408
     /*  913408 */   GIM_Try, /*On fail goto*//*Label 13914*/ GIMT_Encode4(913486), // Rule ID 62440 //
     /*  913413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  913424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  913427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  913430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913445 */     // MIs[0] rs2
     /*  913445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913448 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913453 */     // MIs[0] policy
     /*  913453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  913466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913484 */     GIR_RootConstrainSelectedInstOperands,
     /*  913485 */     // GIR_Coverage, 62440,
     /*  913485 */     GIR_EraseRootFromParent_Done,
     /*  913486 */   // Label 13914: @913486
     /*  913486 */   GIM_Try, /*On fail goto*//*Label 13915*/ GIMT_Encode4(913564), // Rule ID 62441 //
     /*  913491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  913502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  913505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  913508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913523 */     // MIs[0] rs2
     /*  913523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913531 */     // MIs[0] policy
     /*  913531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  913544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913562 */     GIR_RootConstrainSelectedInstOperands,
     /*  913563 */     // GIR_Coverage, 62441,
     /*  913563 */     GIR_EraseRootFromParent_Done,
     /*  913564 */   // Label 13915: @913564
     /*  913564 */   GIM_Try, /*On fail goto*//*Label 13916*/ GIMT_Encode4(913642), // Rule ID 62442 //
     /*  913569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  913580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  913583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  913586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913601 */     // MIs[0] rs2
     /*  913601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913604 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913609 */     // MIs[0] policy
     /*  913609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913619 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  913622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913640 */     GIR_RootConstrainSelectedInstOperands,
     /*  913641 */     // GIR_Coverage, 62442,
     /*  913641 */     GIR_EraseRootFromParent_Done,
     /*  913642 */   // Label 13916: @913642
     /*  913642 */   GIM_Try, /*On fail goto*//*Label 13917*/ GIMT_Encode4(913720), // Rule ID 62443 //
     /*  913647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  913658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  913661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  913664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913679 */     // MIs[0] rs2
     /*  913679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913687 */     // MIs[0] policy
     /*  913687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913697 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  913700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913718 */     GIR_RootConstrainSelectedInstOperands,
     /*  913719 */     // GIR_Coverage, 62443,
     /*  913719 */     GIR_EraseRootFromParent_Done,
     /*  913720 */   // Label 13917: @913720
     /*  913720 */   GIM_Try, /*On fail goto*//*Label 13918*/ GIMT_Encode4(913798), // Rule ID 62444 //
     /*  913725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913757 */     // MIs[0] rs2
     /*  913757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913765 */     // MIs[0] policy
     /*  913765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913775 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  913778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913796 */     GIR_RootConstrainSelectedInstOperands,
     /*  913797 */     // GIR_Coverage, 62444,
     /*  913797 */     GIR_EraseRootFromParent_Done,
     /*  913798 */   // Label 13918: @913798
     /*  913798 */   GIM_Try, /*On fail goto*//*Label 13919*/ GIMT_Encode4(913876), // Rule ID 62445 //
     /*  913803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913835 */     // MIs[0] rs2
     /*  913835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913843 */     // MIs[0] policy
     /*  913843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913853 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  913856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913874 */     GIR_RootConstrainSelectedInstOperands,
     /*  913875 */     // GIR_Coverage, 62445,
     /*  913875 */     GIR_EraseRootFromParent_Done,
     /*  913876 */   // Label 13919: @913876
     /*  913876 */   GIM_Try, /*On fail goto*//*Label 13920*/ GIMT_Encode4(913964), // Rule ID 23702 //
     /*  913881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  913884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  913889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  913892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  913895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  913898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  913901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  913920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  913924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  913928 */     // MIs[1] Operand 1
     /*  913928 */     // No operand predicates
     /*  913928 */     // MIs[0] policy
     /*  913928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  913933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913940 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  913943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  913952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913962 */     GIR_RootConstrainSelectedInstOperands,
     /*  913963 */     // GIR_Coverage, 23702,
     /*  913963 */     GIR_EraseRootFromParent_Done,
     /*  913964 */   // Label 13920: @913964
     /*  913964 */   GIM_Try, /*On fail goto*//*Label 13921*/ GIMT_Encode4(914052), // Rule ID 23703 //
     /*  913969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  913972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  913977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  913980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  913983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  913986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  913989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914016 */     // MIs[1] Operand 1
     /*  914016 */     // No operand predicates
     /*  914016 */     // MIs[0] policy
     /*  914016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914028 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  914031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914050 */     GIR_RootConstrainSelectedInstOperands,
     /*  914051 */     // GIR_Coverage, 23703,
     /*  914051 */     GIR_EraseRootFromParent_Done,
     /*  914052 */   // Label 13921: @914052
     /*  914052 */   GIM_Try, /*On fail goto*//*Label 13922*/ GIMT_Encode4(914140), // Rule ID 23706 //
     /*  914057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  914068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  914071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  914074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914104 */     // MIs[1] Operand 1
     /*  914104 */     // No operand predicates
     /*  914104 */     // MIs[0] policy
     /*  914104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914116 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914138 */     GIR_RootConstrainSelectedInstOperands,
     /*  914139 */     // GIR_Coverage, 23706,
     /*  914139 */     GIR_EraseRootFromParent_Done,
     /*  914140 */   // Label 13922: @914140
     /*  914140 */   GIM_Try, /*On fail goto*//*Label 13923*/ GIMT_Encode4(914228), // Rule ID 23707 //
     /*  914145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  914156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  914159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  914162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914192 */     // MIs[1] Operand 1
     /*  914192 */     // No operand predicates
     /*  914192 */     // MIs[0] policy
     /*  914192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914204 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914226 */     GIR_RootConstrainSelectedInstOperands,
     /*  914227 */     // GIR_Coverage, 23707,
     /*  914227 */     GIR_EraseRootFromParent_Done,
     /*  914228 */   // Label 13923: @914228
     /*  914228 */   GIM_Try, /*On fail goto*//*Label 13924*/ GIMT_Encode4(914316), // Rule ID 23710 //
     /*  914233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  914244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  914247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  914250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914280 */     // MIs[1] Operand 1
     /*  914280 */     // No operand predicates
     /*  914280 */     // MIs[0] policy
     /*  914280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914292 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914314 */     GIR_RootConstrainSelectedInstOperands,
     /*  914315 */     // GIR_Coverage, 23710,
     /*  914315 */     GIR_EraseRootFromParent_Done,
     /*  914316 */   // Label 13924: @914316
     /*  914316 */   GIM_Try, /*On fail goto*//*Label 13925*/ GIMT_Encode4(914404), // Rule ID 23711 //
     /*  914321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  914332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  914335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  914338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914368 */     // MIs[1] Operand 1
     /*  914368 */     // No operand predicates
     /*  914368 */     // MIs[0] policy
     /*  914368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914380 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914402 */     GIR_RootConstrainSelectedInstOperands,
     /*  914403 */     // GIR_Coverage, 23711,
     /*  914403 */     GIR_EraseRootFromParent_Done,
     /*  914404 */   // Label 13925: @914404
     /*  914404 */   GIM_Try, /*On fail goto*//*Label 13926*/ GIMT_Encode4(914492), // Rule ID 23714 //
     /*  914409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  914420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  914423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  914426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914456 */     // MIs[1] Operand 1
     /*  914456 */     // No operand predicates
     /*  914456 */     // MIs[0] policy
     /*  914456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914468 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914490 */     GIR_RootConstrainSelectedInstOperands,
     /*  914491 */     // GIR_Coverage, 23714,
     /*  914491 */     GIR_EraseRootFromParent_Done,
     /*  914492 */   // Label 13926: @914492
     /*  914492 */   GIM_Try, /*On fail goto*//*Label 13927*/ GIMT_Encode4(914580), // Rule ID 23715 //
     /*  914497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  914508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  914511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  914514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914544 */     // MIs[1] Operand 1
     /*  914544 */     // No operand predicates
     /*  914544 */     // MIs[0] policy
     /*  914544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914556 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914578 */     GIR_RootConstrainSelectedInstOperands,
     /*  914579 */     // GIR_Coverage, 23715,
     /*  914579 */     GIR_EraseRootFromParent_Done,
     /*  914580 */   // Label 13927: @914580
     /*  914580 */   GIM_Try, /*On fail goto*//*Label 13928*/ GIMT_Encode4(914668), // Rule ID 23718 //
     /*  914585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  914596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  914599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  914602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914632 */     // MIs[1] Operand 1
     /*  914632 */     // No operand predicates
     /*  914632 */     // MIs[0] policy
     /*  914632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914644 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914666 */     GIR_RootConstrainSelectedInstOperands,
     /*  914667 */     // GIR_Coverage, 23718,
     /*  914667 */     GIR_EraseRootFromParent_Done,
     /*  914668 */   // Label 13928: @914668
     /*  914668 */   GIM_Try, /*On fail goto*//*Label 13929*/ GIMT_Encode4(914756), // Rule ID 23719 //
     /*  914673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  914684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  914687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  914690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914720 */     // MIs[1] Operand 1
     /*  914720 */     // No operand predicates
     /*  914720 */     // MIs[0] policy
     /*  914720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914732 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914754 */     GIR_RootConstrainSelectedInstOperands,
     /*  914755 */     // GIR_Coverage, 23719,
     /*  914755 */     GIR_EraseRootFromParent_Done,
     /*  914756 */   // Label 13929: @914756
     /*  914756 */   GIM_Try, /*On fail goto*//*Label 13930*/ GIMT_Encode4(914844), // Rule ID 23722 //
     /*  914761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  914772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  914775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  914778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914808 */     // MIs[1] Operand 1
     /*  914808 */     // No operand predicates
     /*  914808 */     // MIs[0] policy
     /*  914808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914820 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914842 */     GIR_RootConstrainSelectedInstOperands,
     /*  914843 */     // GIR_Coverage, 23722,
     /*  914843 */     GIR_EraseRootFromParent_Done,
     /*  914844 */   // Label 13930: @914844
     /*  914844 */   GIM_Try, /*On fail goto*//*Label 13931*/ GIMT_Encode4(914932), // Rule ID 23723 //
     /*  914849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  914860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  914863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  914866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914896 */     // MIs[1] Operand 1
     /*  914896 */     // No operand predicates
     /*  914896 */     // MIs[0] policy
     /*  914896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914908 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914930 */     GIR_RootConstrainSelectedInstOperands,
     /*  914931 */     // GIR_Coverage, 23723,
     /*  914931 */     GIR_EraseRootFromParent_Done,
     /*  914932 */   // Label 13931: @914932
     /*  914932 */   GIM_Try, /*On fail goto*//*Label 13932*/ GIMT_Encode4(915020), // Rule ID 23726 //
     /*  914937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  914948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  914951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  914954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914984 */     // MIs[1] Operand 1
     /*  914984 */     // No operand predicates
     /*  914984 */     // MIs[0] policy
     /*  914984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  914999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915018 */     GIR_RootConstrainSelectedInstOperands,
     /*  915019 */     // GIR_Coverage, 23726,
     /*  915019 */     GIR_EraseRootFromParent_Done,
     /*  915020 */   // Label 13932: @915020
     /*  915020 */   GIM_Try, /*On fail goto*//*Label 13933*/ GIMT_Encode4(915108), // Rule ID 23727 //
     /*  915025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  915036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  915039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  915042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915072 */     // MIs[1] Operand 1
     /*  915072 */     // No operand predicates
     /*  915072 */     // MIs[0] policy
     /*  915072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915084 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915106 */     GIR_RootConstrainSelectedInstOperands,
     /*  915107 */     // GIR_Coverage, 23727,
     /*  915107 */     GIR_EraseRootFromParent_Done,
     /*  915108 */   // Label 13933: @915108
     /*  915108 */   GIM_Try, /*On fail goto*//*Label 13934*/ GIMT_Encode4(915196), // Rule ID 23730 //
     /*  915113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  915124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  915127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  915130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915160 */     // MIs[1] Operand 1
     /*  915160 */     // No operand predicates
     /*  915160 */     // MIs[0] policy
     /*  915160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915172 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915194 */     GIR_RootConstrainSelectedInstOperands,
     /*  915195 */     // GIR_Coverage, 23730,
     /*  915195 */     GIR_EraseRootFromParent_Done,
     /*  915196 */   // Label 13934: @915196
     /*  915196 */   GIM_Try, /*On fail goto*//*Label 13935*/ GIMT_Encode4(915284), // Rule ID 23731 //
     /*  915201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  915212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  915215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  915218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915244 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915248 */     // MIs[1] Operand 1
     /*  915248 */     // No operand predicates
     /*  915248 */     // MIs[0] policy
     /*  915248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915260 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915282 */     GIR_RootConstrainSelectedInstOperands,
     /*  915283 */     // GIR_Coverage, 23731,
     /*  915283 */     GIR_EraseRootFromParent_Done,
     /*  915284 */   // Label 13935: @915284
     /*  915284 */   GIM_Try, /*On fail goto*//*Label 13936*/ GIMT_Encode4(915372), // Rule ID 23734 //
     /*  915289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  915300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  915303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  915306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915336 */     // MIs[1] Operand 1
     /*  915336 */     // No operand predicates
     /*  915336 */     // MIs[0] policy
     /*  915336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915348 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915370 */     GIR_RootConstrainSelectedInstOperands,
     /*  915371 */     // GIR_Coverage, 23734,
     /*  915371 */     GIR_EraseRootFromParent_Done,
     /*  915372 */   // Label 13936: @915372
     /*  915372 */   GIM_Try, /*On fail goto*//*Label 13937*/ GIMT_Encode4(915460), // Rule ID 23735 //
     /*  915377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  915388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  915391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  915394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915424 */     // MIs[1] Operand 1
     /*  915424 */     // No operand predicates
     /*  915424 */     // MIs[0] policy
     /*  915424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915436 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915458 */     GIR_RootConstrainSelectedInstOperands,
     /*  915459 */     // GIR_Coverage, 23735,
     /*  915459 */     GIR_EraseRootFromParent_Done,
     /*  915460 */   // Label 13937: @915460
     /*  915460 */   GIM_Try, /*On fail goto*//*Label 13938*/ GIMT_Encode4(915548), // Rule ID 23738 //
     /*  915465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  915468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  915476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  915479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  915482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915512 */     // MIs[1] Operand 1
     /*  915512 */     // No operand predicates
     /*  915512 */     // MIs[0] policy
     /*  915512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915524 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  915544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915546 */     GIR_RootConstrainSelectedInstOperands,
     /*  915547 */     // GIR_Coverage, 23738,
     /*  915547 */     GIR_EraseRootFromParent_Done,
     /*  915548 */   // Label 13938: @915548
     /*  915548 */   GIM_Try, /*On fail goto*//*Label 13939*/ GIMT_Encode4(915636), // Rule ID 23739 //
     /*  915553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  915556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  915564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  915567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  915570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915600 */     // MIs[1] Operand 1
     /*  915600 */     // No operand predicates
     /*  915600 */     // MIs[0] policy
     /*  915600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915612 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  915632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915634 */     GIR_RootConstrainSelectedInstOperands,
     /*  915635 */     // GIR_Coverage, 23739,
     /*  915635 */     GIR_EraseRootFromParent_Done,
     /*  915636 */   // Label 13939: @915636
     /*  915636 */   GIM_Try, /*On fail goto*//*Label 13940*/ GIMT_Encode4(915724), // Rule ID 23742 //
     /*  915641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  915652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  915655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  915658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915688 */     // MIs[1] Operand 1
     /*  915688 */     // No operand predicates
     /*  915688 */     // MIs[0] policy
     /*  915688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915700 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  915703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915722 */     GIR_RootConstrainSelectedInstOperands,
     /*  915723 */     // GIR_Coverage, 23742,
     /*  915723 */     GIR_EraseRootFromParent_Done,
     /*  915724 */   // Label 13940: @915724
     /*  915724 */   GIM_Try, /*On fail goto*//*Label 13941*/ GIMT_Encode4(915812), // Rule ID 23743 //
     /*  915729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  915740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  915743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  915746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915776 */     // MIs[1] Operand 1
     /*  915776 */     // No operand predicates
     /*  915776 */     // MIs[0] policy
     /*  915776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915788 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  915791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915810 */     GIR_RootConstrainSelectedInstOperands,
     /*  915811 */     // GIR_Coverage, 23743,
     /*  915811 */     GIR_EraseRootFromParent_Done,
     /*  915812 */   // Label 13941: @915812
     /*  915812 */   GIM_Try, /*On fail goto*//*Label 13942*/ GIMT_Encode4(915900), // Rule ID 23746 //
     /*  915817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  915828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  915831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  915834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915864 */     // MIs[1] Operand 1
     /*  915864 */     // No operand predicates
     /*  915864 */     // MIs[0] policy
     /*  915864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915876 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  915879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915898 */     GIR_RootConstrainSelectedInstOperands,
     /*  915899 */     // GIR_Coverage, 23746,
     /*  915899 */     GIR_EraseRootFromParent_Done,
     /*  915900 */   // Label 13942: @915900
     /*  915900 */   GIM_Try, /*On fail goto*//*Label 13943*/ GIMT_Encode4(915988), // Rule ID 23747 //
     /*  915905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  915916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  915919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  915922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915952 */     // MIs[1] Operand 1
     /*  915952 */     // No operand predicates
     /*  915952 */     // MIs[0] policy
     /*  915952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915964 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  915967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915986 */     GIR_RootConstrainSelectedInstOperands,
     /*  915987 */     // GIR_Coverage, 23747,
     /*  915987 */     GIR_EraseRootFromParent_Done,
     /*  915988 */   // Label 13943: @915988
     /*  915988 */   GIM_Try, /*On fail goto*//*Label 13944*/ GIMT_Encode4(916076), // Rule ID 23750 //
     /*  915993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  916004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  916007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  916010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916040 */     // MIs[1] Operand 1
     /*  916040 */     // No operand predicates
     /*  916040 */     // MIs[0] policy
     /*  916040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916052 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916074 */     GIR_RootConstrainSelectedInstOperands,
     /*  916075 */     // GIR_Coverage, 23750,
     /*  916075 */     GIR_EraseRootFromParent_Done,
     /*  916076 */   // Label 13944: @916076
     /*  916076 */   GIM_Try, /*On fail goto*//*Label 13945*/ GIMT_Encode4(916164), // Rule ID 23751 //
     /*  916081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  916092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  916095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  916098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916128 */     // MIs[1] Operand 1
     /*  916128 */     // No operand predicates
     /*  916128 */     // MIs[0] policy
     /*  916128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916140 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916162 */     GIR_RootConstrainSelectedInstOperands,
     /*  916163 */     // GIR_Coverage, 23751,
     /*  916163 */     GIR_EraseRootFromParent_Done,
     /*  916164 */   // Label 13945: @916164
     /*  916164 */   GIM_Try, /*On fail goto*//*Label 13946*/ GIMT_Encode4(916252), // Rule ID 23754 //
     /*  916169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  916180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  916183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  916186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916216 */     // MIs[1] Operand 1
     /*  916216 */     // No operand predicates
     /*  916216 */     // MIs[0] policy
     /*  916216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916250 */     GIR_RootConstrainSelectedInstOperands,
     /*  916251 */     // GIR_Coverage, 23754,
     /*  916251 */     GIR_EraseRootFromParent_Done,
     /*  916252 */   // Label 13946: @916252
     /*  916252 */   GIM_Try, /*On fail goto*//*Label 13947*/ GIMT_Encode4(916340), // Rule ID 23755 //
     /*  916257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  916268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  916271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  916274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916304 */     // MIs[1] Operand 1
     /*  916304 */     // No operand predicates
     /*  916304 */     // MIs[0] policy
     /*  916304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916338 */     GIR_RootConstrainSelectedInstOperands,
     /*  916339 */     // GIR_Coverage, 23755,
     /*  916339 */     GIR_EraseRootFromParent_Done,
     /*  916340 */   // Label 13947: @916340
     /*  916340 */   GIM_Try, /*On fail goto*//*Label 13948*/ GIMT_Encode4(916428), // Rule ID 23758 //
     /*  916345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  916356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  916359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  916362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916392 */     // MIs[1] Operand 1
     /*  916392 */     // No operand predicates
     /*  916392 */     // MIs[0] policy
     /*  916392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916426 */     GIR_RootConstrainSelectedInstOperands,
     /*  916427 */     // GIR_Coverage, 23758,
     /*  916427 */     GIR_EraseRootFromParent_Done,
     /*  916428 */   // Label 13948: @916428
     /*  916428 */   GIM_Try, /*On fail goto*//*Label 13949*/ GIMT_Encode4(916516), // Rule ID 23759 //
     /*  916433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  916444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  916447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  916450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916480 */     // MIs[1] Operand 1
     /*  916480 */     // No operand predicates
     /*  916480 */     // MIs[0] policy
     /*  916480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916492 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916514 */     GIR_RootConstrainSelectedInstOperands,
     /*  916515 */     // GIR_Coverage, 23759,
     /*  916515 */     GIR_EraseRootFromParent_Done,
     /*  916516 */   // Label 13949: @916516
     /*  916516 */   GIM_Try, /*On fail goto*//*Label 13950*/ GIMT_Encode4(916604), // Rule ID 23762 //
     /*  916521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  916532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  916535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  916538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916568 */     // MIs[1] Operand 1
     /*  916568 */     // No operand predicates
     /*  916568 */     // MIs[0] policy
     /*  916568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916580 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916602 */     GIR_RootConstrainSelectedInstOperands,
     /*  916603 */     // GIR_Coverage, 23762,
     /*  916603 */     GIR_EraseRootFromParent_Done,
     /*  916604 */   // Label 13950: @916604
     /*  916604 */   GIM_Try, /*On fail goto*//*Label 13951*/ GIMT_Encode4(916692), // Rule ID 23763 //
     /*  916609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  916620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  916623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  916626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916656 */     // MIs[1] Operand 1
     /*  916656 */     // No operand predicates
     /*  916656 */     // MIs[0] policy
     /*  916656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916668 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916690 */     GIR_RootConstrainSelectedInstOperands,
     /*  916691 */     // GIR_Coverage, 23763,
     /*  916691 */     GIR_EraseRootFromParent_Done,
     /*  916692 */   // Label 13951: @916692
     /*  916692 */   GIM_Try, /*On fail goto*//*Label 13952*/ GIMT_Encode4(916780), // Rule ID 23766 //
     /*  916697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  916708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  916711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  916714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916744 */     // MIs[1] Operand 1
     /*  916744 */     // No operand predicates
     /*  916744 */     // MIs[0] policy
     /*  916744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916778 */     GIR_RootConstrainSelectedInstOperands,
     /*  916779 */     // GIR_Coverage, 23766,
     /*  916779 */     GIR_EraseRootFromParent_Done,
     /*  916780 */   // Label 13952: @916780
     /*  916780 */   GIM_Try, /*On fail goto*//*Label 13953*/ GIMT_Encode4(916868), // Rule ID 23767 //
     /*  916785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  916796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  916799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  916802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916832 */     // MIs[1] Operand 1
     /*  916832 */     // No operand predicates
     /*  916832 */     // MIs[0] policy
     /*  916832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916866 */     GIR_RootConstrainSelectedInstOperands,
     /*  916867 */     // GIR_Coverage, 23767,
     /*  916867 */     GIR_EraseRootFromParent_Done,
     /*  916868 */   // Label 13953: @916868
     /*  916868 */   GIM_Try, /*On fail goto*//*Label 13954*/ GIMT_Encode4(916956), // Rule ID 23770 //
     /*  916873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  916884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  916887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  916890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916920 */     // MIs[1] Operand 1
     /*  916920 */     // No operand predicates
     /*  916920 */     // MIs[0] policy
     /*  916920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916932 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916954 */     GIR_RootConstrainSelectedInstOperands,
     /*  916955 */     // GIR_Coverage, 23770,
     /*  916955 */     GIR_EraseRootFromParent_Done,
     /*  916956 */   // Label 13954: @916956
     /*  916956 */   GIM_Try, /*On fail goto*//*Label 13955*/ GIMT_Encode4(917044), // Rule ID 23771 //
     /*  916961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  916972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  916975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  916978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917008 */     // MIs[1] Operand 1
     /*  917008 */     // No operand predicates
     /*  917008 */     // MIs[0] policy
     /*  917008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917020 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  917023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917042 */     GIR_RootConstrainSelectedInstOperands,
     /*  917043 */     // GIR_Coverage, 23771,
     /*  917043 */     GIR_EraseRootFromParent_Done,
     /*  917044 */   // Label 13955: @917044
     /*  917044 */   GIM_Try, /*On fail goto*//*Label 13956*/ GIMT_Encode4(917132), // Rule ID 23774 //
     /*  917049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  917060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  917063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  917066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917096 */     // MIs[1] Operand 1
     /*  917096 */     // No operand predicates
     /*  917096 */     // MIs[0] policy
     /*  917096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917108 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917130 */     GIR_RootConstrainSelectedInstOperands,
     /*  917131 */     // GIR_Coverage, 23774,
     /*  917131 */     GIR_EraseRootFromParent_Done,
     /*  917132 */   // Label 13956: @917132
     /*  917132 */   GIM_Try, /*On fail goto*//*Label 13957*/ GIMT_Encode4(917220), // Rule ID 23775 //
     /*  917137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  917148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  917151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  917154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917184 */     // MIs[1] Operand 1
     /*  917184 */     // No operand predicates
     /*  917184 */     // MIs[0] policy
     /*  917184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917218 */     GIR_RootConstrainSelectedInstOperands,
     /*  917219 */     // GIR_Coverage, 23775,
     /*  917219 */     GIR_EraseRootFromParent_Done,
     /*  917220 */   // Label 13957: @917220
     /*  917220 */   GIM_Try, /*On fail goto*//*Label 13958*/ GIMT_Encode4(917308), // Rule ID 23778 //
     /*  917225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  917228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  917236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  917239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  917242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917272 */     // MIs[1] Operand 1
     /*  917272 */     // No operand predicates
     /*  917272 */     // MIs[0] policy
     /*  917272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  917287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917306 */     GIR_RootConstrainSelectedInstOperands,
     /*  917307 */     // GIR_Coverage, 23778,
     /*  917307 */     GIR_EraseRootFromParent_Done,
     /*  917308 */   // Label 13958: @917308
     /*  917308 */   GIM_Try, /*On fail goto*//*Label 13959*/ GIMT_Encode4(917396), // Rule ID 23779 //
     /*  917313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  917316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  917324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  917327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  917330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917360 */     // MIs[1] Operand 1
     /*  917360 */     // No operand predicates
     /*  917360 */     // MIs[0] policy
     /*  917360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917372 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  917375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917394 */     GIR_RootConstrainSelectedInstOperands,
     /*  917395 */     // GIR_Coverage, 23779,
     /*  917395 */     GIR_EraseRootFromParent_Done,
     /*  917396 */   // Label 13959: @917396
     /*  917396 */   GIM_Try, /*On fail goto*//*Label 13960*/ GIMT_Encode4(917484), // Rule ID 23782 //
     /*  917401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  917404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  917412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  917415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  917418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917448 */     // MIs[1] Operand 1
     /*  917448 */     // No operand predicates
     /*  917448 */     // MIs[0] policy
     /*  917448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917460 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  917463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917482 */     GIR_RootConstrainSelectedInstOperands,
     /*  917483 */     // GIR_Coverage, 23782,
     /*  917483 */     GIR_EraseRootFromParent_Done,
     /*  917484 */   // Label 13960: @917484
     /*  917484 */   GIM_Try, /*On fail goto*//*Label 13961*/ GIMT_Encode4(917572), // Rule ID 23783 //
     /*  917489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  917492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  917500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  917503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  917506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917536 */     // MIs[1] Operand 1
     /*  917536 */     // No operand predicates
     /*  917536 */     // MIs[0] policy
     /*  917536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917548 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  917551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917570 */     GIR_RootConstrainSelectedInstOperands,
     /*  917571 */     // GIR_Coverage, 23783,
     /*  917571 */     GIR_EraseRootFromParent_Done,
     /*  917572 */   // Label 13961: @917572
     /*  917572 */   GIM_Try, /*On fail goto*//*Label 13962*/ GIMT_Encode4(917660), // Rule ID 23786 //
     /*  917577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  917580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  917588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  917591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  917594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917624 */     // MIs[1] Operand 1
     /*  917624 */     // No operand predicates
     /*  917624 */     // MIs[0] policy
     /*  917624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917636 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917658 */     GIR_RootConstrainSelectedInstOperands,
     /*  917659 */     // GIR_Coverage, 23786,
     /*  917659 */     GIR_EraseRootFromParent_Done,
     /*  917660 */   // Label 13962: @917660
     /*  917660 */   GIM_Try, /*On fail goto*//*Label 13963*/ GIMT_Encode4(917748), // Rule ID 23787 //
     /*  917665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  917668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  917676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  917679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  917682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917712 */     // MIs[1] Operand 1
     /*  917712 */     // No operand predicates
     /*  917712 */     // MIs[0] policy
     /*  917712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917724 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917746 */     GIR_RootConstrainSelectedInstOperands,
     /*  917747 */     // GIR_Coverage, 23787,
     /*  917747 */     GIR_EraseRootFromParent_Done,
     /*  917748 */   // Label 13963: @917748
     /*  917748 */   GIM_Try, /*On fail goto*//*Label 13964*/ GIMT_Encode4(917836), // Rule ID 23878 //
     /*  917753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  917764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  917767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  917770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917800 */     // MIs[1] Operand 1
     /*  917800 */     // No operand predicates
     /*  917800 */     // MIs[0] policy
     /*  917800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917812 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  917815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917834 */     GIR_RootConstrainSelectedInstOperands,
     /*  917835 */     // GIR_Coverage, 23878,
     /*  917835 */     GIR_EraseRootFromParent_Done,
     /*  917836 */   // Label 13964: @917836
     /*  917836 */   GIM_Try, /*On fail goto*//*Label 13965*/ GIMT_Encode4(917924), // Rule ID 23879 //
     /*  917841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  917852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  917855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  917858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917888 */     // MIs[1] Operand 1
     /*  917888 */     // No operand predicates
     /*  917888 */     // MIs[0] policy
     /*  917888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917900 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  917903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917922 */     GIR_RootConstrainSelectedInstOperands,
     /*  917923 */     // GIR_Coverage, 23879,
     /*  917923 */     GIR_EraseRootFromParent_Done,
     /*  917924 */   // Label 13965: @917924
     /*  917924 */   GIM_Try, /*On fail goto*//*Label 13966*/ GIMT_Encode4(918012), // Rule ID 23882 //
     /*  917929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  917940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  917943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  917946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917976 */     // MIs[1] Operand 1
     /*  917976 */     // No operand predicates
     /*  917976 */     // MIs[0] policy
     /*  917976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917988 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  917991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918010 */     GIR_RootConstrainSelectedInstOperands,
     /*  918011 */     // GIR_Coverage, 23882,
     /*  918011 */     GIR_EraseRootFromParent_Done,
     /*  918012 */   // Label 13966: @918012
     /*  918012 */   GIM_Try, /*On fail goto*//*Label 13967*/ GIMT_Encode4(918100), // Rule ID 23883 //
     /*  918017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  918028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  918031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  918034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918064 */     // MIs[1] Operand 1
     /*  918064 */     // No operand predicates
     /*  918064 */     // MIs[0] policy
     /*  918064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918076 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918098 */     GIR_RootConstrainSelectedInstOperands,
     /*  918099 */     // GIR_Coverage, 23883,
     /*  918099 */     GIR_EraseRootFromParent_Done,
     /*  918100 */   // Label 13967: @918100
     /*  918100 */   GIM_Try, /*On fail goto*//*Label 13968*/ GIMT_Encode4(918188), // Rule ID 23886 //
     /*  918105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  918116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  918119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  918122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918152 */     // MIs[1] Operand 1
     /*  918152 */     // No operand predicates
     /*  918152 */     // MIs[0] policy
     /*  918152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918164 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918186 */     GIR_RootConstrainSelectedInstOperands,
     /*  918187 */     // GIR_Coverage, 23886,
     /*  918187 */     GIR_EraseRootFromParent_Done,
     /*  918188 */   // Label 13968: @918188
     /*  918188 */   GIM_Try, /*On fail goto*//*Label 13969*/ GIMT_Encode4(918276), // Rule ID 23887 //
     /*  918193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  918204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  918207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  918210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918240 */     // MIs[1] Operand 1
     /*  918240 */     // No operand predicates
     /*  918240 */     // MIs[0] policy
     /*  918240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918252 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918274 */     GIR_RootConstrainSelectedInstOperands,
     /*  918275 */     // GIR_Coverage, 23887,
     /*  918275 */     GIR_EraseRootFromParent_Done,
     /*  918276 */   // Label 13969: @918276
     /*  918276 */   GIM_Try, /*On fail goto*//*Label 13970*/ GIMT_Encode4(918364), // Rule ID 23890 //
     /*  918281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  918292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  918295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  918298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918328 */     // MIs[1] Operand 1
     /*  918328 */     // No operand predicates
     /*  918328 */     // MIs[0] policy
     /*  918328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918340 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918362 */     GIR_RootConstrainSelectedInstOperands,
     /*  918363 */     // GIR_Coverage, 23890,
     /*  918363 */     GIR_EraseRootFromParent_Done,
     /*  918364 */   // Label 13970: @918364
     /*  918364 */   GIM_Try, /*On fail goto*//*Label 13971*/ GIMT_Encode4(918452), // Rule ID 23891 //
     /*  918369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  918380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  918383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  918386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918416 */     // MIs[1] Operand 1
     /*  918416 */     // No operand predicates
     /*  918416 */     // MIs[0] policy
     /*  918416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918428 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918450 */     GIR_RootConstrainSelectedInstOperands,
     /*  918451 */     // GIR_Coverage, 23891,
     /*  918451 */     GIR_EraseRootFromParent_Done,
     /*  918452 */   // Label 13971: @918452
     /*  918452 */   GIM_Try, /*On fail goto*//*Label 13972*/ GIMT_Encode4(918540), // Rule ID 23894 //
     /*  918457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  918468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  918471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  918474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918504 */     // MIs[1] Operand 1
     /*  918504 */     // No operand predicates
     /*  918504 */     // MIs[0] policy
     /*  918504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918516 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918538 */     GIR_RootConstrainSelectedInstOperands,
     /*  918539 */     // GIR_Coverage, 23894,
     /*  918539 */     GIR_EraseRootFromParent_Done,
     /*  918540 */   // Label 13972: @918540
     /*  918540 */   GIM_Try, /*On fail goto*//*Label 13973*/ GIMT_Encode4(918628), // Rule ID 23895 //
     /*  918545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  918556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  918559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  918562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918592 */     // MIs[1] Operand 1
     /*  918592 */     // No operand predicates
     /*  918592 */     // MIs[0] policy
     /*  918592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918604 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918626 */     GIR_RootConstrainSelectedInstOperands,
     /*  918627 */     // GIR_Coverage, 23895,
     /*  918627 */     GIR_EraseRootFromParent_Done,
     /*  918628 */   // Label 13973: @918628
     /*  918628 */   GIM_Try, /*On fail goto*//*Label 13974*/ GIMT_Encode4(918716), // Rule ID 23898 //
     /*  918633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  918644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  918647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  918650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918680 */     // MIs[1] Operand 1
     /*  918680 */     // No operand predicates
     /*  918680 */     // MIs[0] policy
     /*  918680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918692 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918714 */     GIR_RootConstrainSelectedInstOperands,
     /*  918715 */     // GIR_Coverage, 23898,
     /*  918715 */     GIR_EraseRootFromParent_Done,
     /*  918716 */   // Label 13974: @918716
     /*  918716 */   GIM_Try, /*On fail goto*//*Label 13975*/ GIMT_Encode4(918804), // Rule ID 23899 //
     /*  918721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  918732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  918735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  918738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918768 */     // MIs[1] Operand 1
     /*  918768 */     // No operand predicates
     /*  918768 */     // MIs[0] policy
     /*  918768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918780 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918802 */     GIR_RootConstrainSelectedInstOperands,
     /*  918803 */     // GIR_Coverage, 23899,
     /*  918803 */     GIR_EraseRootFromParent_Done,
     /*  918804 */   // Label 13975: @918804
     /*  918804 */   GIM_Try, /*On fail goto*//*Label 13976*/ GIMT_Encode4(918892), // Rule ID 23902 //
     /*  918809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  918820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  918823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  918826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918856 */     // MIs[1] Operand 1
     /*  918856 */     // No operand predicates
     /*  918856 */     // MIs[0] policy
     /*  918856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918868 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  918871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918890 */     GIR_RootConstrainSelectedInstOperands,
     /*  918891 */     // GIR_Coverage, 23902,
     /*  918891 */     GIR_EraseRootFromParent_Done,
     /*  918892 */   // Label 13976: @918892
     /*  918892 */   GIM_Try, /*On fail goto*//*Label 13977*/ GIMT_Encode4(918980), // Rule ID 23903 //
     /*  918897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  918908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  918911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  918914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918944 */     // MIs[1] Operand 1
     /*  918944 */     // No operand predicates
     /*  918944 */     // MIs[0] policy
     /*  918944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918956 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  918959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918978 */     GIR_RootConstrainSelectedInstOperands,
     /*  918979 */     // GIR_Coverage, 23903,
     /*  918979 */     GIR_EraseRootFromParent_Done,
     /*  918980 */   // Label 13977: @918980
     /*  918980 */   GIM_Try, /*On fail goto*//*Label 13978*/ GIMT_Encode4(919068), // Rule ID 23906 //
     /*  918985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  918996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  918999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  919002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919032 */     // MIs[1] Operand 1
     /*  919032 */     // No operand predicates
     /*  919032 */     // MIs[0] policy
     /*  919032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919044 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919066 */     GIR_RootConstrainSelectedInstOperands,
     /*  919067 */     // GIR_Coverage, 23906,
     /*  919067 */     GIR_EraseRootFromParent_Done,
     /*  919068 */   // Label 13978: @919068
     /*  919068 */   GIM_Try, /*On fail goto*//*Label 13979*/ GIMT_Encode4(919156), // Rule ID 23907 //
     /*  919073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  919084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  919087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  919090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919120 */     // MIs[1] Operand 1
     /*  919120 */     // No operand predicates
     /*  919120 */     // MIs[0] policy
     /*  919120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919132 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919154 */     GIR_RootConstrainSelectedInstOperands,
     /*  919155 */     // GIR_Coverage, 23907,
     /*  919155 */     GIR_EraseRootFromParent_Done,
     /*  919156 */   // Label 13979: @919156
     /*  919156 */   GIM_Try, /*On fail goto*//*Label 13980*/ GIMT_Encode4(919244), // Rule ID 23910 //
     /*  919161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  919172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  919175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  919178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919208 */     // MIs[1] Operand 1
     /*  919208 */     // No operand predicates
     /*  919208 */     // MIs[0] policy
     /*  919208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919220 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919242 */     GIR_RootConstrainSelectedInstOperands,
     /*  919243 */     // GIR_Coverage, 23910,
     /*  919243 */     GIR_EraseRootFromParent_Done,
     /*  919244 */   // Label 13980: @919244
     /*  919244 */   GIM_Try, /*On fail goto*//*Label 13981*/ GIMT_Encode4(919332), // Rule ID 23911 //
     /*  919249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  919260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  919263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  919266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919296 */     // MIs[1] Operand 1
     /*  919296 */     // No operand predicates
     /*  919296 */     // MIs[0] policy
     /*  919296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919308 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919330 */     GIR_RootConstrainSelectedInstOperands,
     /*  919331 */     // GIR_Coverage, 23911,
     /*  919331 */     GIR_EraseRootFromParent_Done,
     /*  919332 */   // Label 13981: @919332
     /*  919332 */   GIM_Try, /*On fail goto*//*Label 13982*/ GIMT_Encode4(919420), // Rule ID 23914 //
     /*  919337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  919340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  919348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  919351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  919354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919384 */     // MIs[1] Operand 1
     /*  919384 */     // No operand predicates
     /*  919384 */     // MIs[0] policy
     /*  919384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919396 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  919416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919418 */     GIR_RootConstrainSelectedInstOperands,
     /*  919419 */     // GIR_Coverage, 23914,
     /*  919419 */     GIR_EraseRootFromParent_Done,
     /*  919420 */   // Label 13982: @919420
     /*  919420 */   GIM_Try, /*On fail goto*//*Label 13983*/ GIMT_Encode4(919508), // Rule ID 23915 //
     /*  919425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  919428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  919436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  919439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  919442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919472 */     // MIs[1] Operand 1
     /*  919472 */     // No operand predicates
     /*  919472 */     // MIs[0] policy
     /*  919472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919484 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  919504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919506 */     GIR_RootConstrainSelectedInstOperands,
     /*  919507 */     // GIR_Coverage, 23915,
     /*  919507 */     GIR_EraseRootFromParent_Done,
     /*  919508 */   // Label 13983: @919508
     /*  919508 */   GIM_Try, /*On fail goto*//*Label 13984*/ GIMT_Encode4(919596), // Rule ID 23918 //
     /*  919513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  919524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  919527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  919530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919560 */     // MIs[1] Operand 1
     /*  919560 */     // No operand predicates
     /*  919560 */     // MIs[0] policy
     /*  919560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919572 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  919575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919594 */     GIR_RootConstrainSelectedInstOperands,
     /*  919595 */     // GIR_Coverage, 23918,
     /*  919595 */     GIR_EraseRootFromParent_Done,
     /*  919596 */   // Label 13984: @919596
     /*  919596 */   GIM_Try, /*On fail goto*//*Label 13985*/ GIMT_Encode4(919684), // Rule ID 23919 //
     /*  919601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  919612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  919615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  919618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919648 */     // MIs[1] Operand 1
     /*  919648 */     // No operand predicates
     /*  919648 */     // MIs[0] policy
     /*  919648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919660 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  919663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919682 */     GIR_RootConstrainSelectedInstOperands,
     /*  919683 */     // GIR_Coverage, 23919,
     /*  919683 */     GIR_EraseRootFromParent_Done,
     /*  919684 */   // Label 13985: @919684
     /*  919684 */   GIM_Try, /*On fail goto*//*Label 13986*/ GIMT_Encode4(919772), // Rule ID 23922 //
     /*  919689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  919700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  919703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  919706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919736 */     // MIs[1] Operand 1
     /*  919736 */     // No operand predicates
     /*  919736 */     // MIs[0] policy
     /*  919736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919748 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  919751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919770 */     GIR_RootConstrainSelectedInstOperands,
     /*  919771 */     // GIR_Coverage, 23922,
     /*  919771 */     GIR_EraseRootFromParent_Done,
     /*  919772 */   // Label 13986: @919772
     /*  919772 */   GIM_Try, /*On fail goto*//*Label 13987*/ GIMT_Encode4(919860), // Rule ID 23923 //
     /*  919777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  919788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  919791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  919794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919824 */     // MIs[1] Operand 1
     /*  919824 */     // No operand predicates
     /*  919824 */     // MIs[0] policy
     /*  919824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919836 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  919839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919858 */     GIR_RootConstrainSelectedInstOperands,
     /*  919859 */     // GIR_Coverage, 23923,
     /*  919859 */     GIR_EraseRootFromParent_Done,
     /*  919860 */   // Label 13987: @919860
     /*  919860 */   GIM_Try, /*On fail goto*//*Label 13988*/ GIMT_Encode4(919948), // Rule ID 23926 //
     /*  919865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  919876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  919879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  919882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919912 */     // MIs[1] Operand 1
     /*  919912 */     // No operand predicates
     /*  919912 */     // MIs[0] policy
     /*  919912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919924 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  919927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919946 */     GIR_RootConstrainSelectedInstOperands,
     /*  919947 */     // GIR_Coverage, 23926,
     /*  919947 */     GIR_EraseRootFromParent_Done,
     /*  919948 */   // Label 13988: @919948
     /*  919948 */   GIM_Try, /*On fail goto*//*Label 13989*/ GIMT_Encode4(920036), // Rule ID 23927 //
     /*  919953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  919964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  919967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  919970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920000 */     // MIs[1] Operand 1
     /*  920000 */     // No operand predicates
     /*  920000 */     // MIs[0] policy
     /*  920000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920012 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920034 */     GIR_RootConstrainSelectedInstOperands,
     /*  920035 */     // GIR_Coverage, 23927,
     /*  920035 */     GIR_EraseRootFromParent_Done,
     /*  920036 */   // Label 13989: @920036
     /*  920036 */   GIM_Try, /*On fail goto*//*Label 13990*/ GIMT_Encode4(920124), // Rule ID 23930 //
     /*  920041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  920052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  920055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  920058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920088 */     // MIs[1] Operand 1
     /*  920088 */     // No operand predicates
     /*  920088 */     // MIs[0] policy
     /*  920088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920100 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920122 */     GIR_RootConstrainSelectedInstOperands,
     /*  920123 */     // GIR_Coverage, 23930,
     /*  920123 */     GIR_EraseRootFromParent_Done,
     /*  920124 */   // Label 13990: @920124
     /*  920124 */   GIM_Try, /*On fail goto*//*Label 13991*/ GIMT_Encode4(920212), // Rule ID 23931 //
     /*  920129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  920140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  920143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  920146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920176 */     // MIs[1] Operand 1
     /*  920176 */     // No operand predicates
     /*  920176 */     // MIs[0] policy
     /*  920176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920210 */     GIR_RootConstrainSelectedInstOperands,
     /*  920211 */     // GIR_Coverage, 23931,
     /*  920211 */     GIR_EraseRootFromParent_Done,
     /*  920212 */   // Label 13991: @920212
     /*  920212 */   GIM_Try, /*On fail goto*//*Label 13992*/ GIMT_Encode4(920300), // Rule ID 23934 //
     /*  920217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  920228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  920231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  920234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920264 */     // MIs[1] Operand 1
     /*  920264 */     // No operand predicates
     /*  920264 */     // MIs[0] policy
     /*  920264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920276 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920298 */     GIR_RootConstrainSelectedInstOperands,
     /*  920299 */     // GIR_Coverage, 23934,
     /*  920299 */     GIR_EraseRootFromParent_Done,
     /*  920300 */   // Label 13992: @920300
     /*  920300 */   GIM_Try, /*On fail goto*//*Label 13993*/ GIMT_Encode4(920388), // Rule ID 23935 //
     /*  920305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  920316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  920319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  920322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920352 */     // MIs[1] Operand 1
     /*  920352 */     // No operand predicates
     /*  920352 */     // MIs[0] policy
     /*  920352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920364 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920386 */     GIR_RootConstrainSelectedInstOperands,
     /*  920387 */     // GIR_Coverage, 23935,
     /*  920387 */     GIR_EraseRootFromParent_Done,
     /*  920388 */   // Label 13993: @920388
     /*  920388 */   GIM_Try, /*On fail goto*//*Label 13994*/ GIMT_Encode4(920476), // Rule ID 23938 //
     /*  920393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  920404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  920407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  920410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920440 */     // MIs[1] Operand 1
     /*  920440 */     // No operand predicates
     /*  920440 */     // MIs[0] policy
     /*  920440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920452 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920474 */     GIR_RootConstrainSelectedInstOperands,
     /*  920475 */     // GIR_Coverage, 23938,
     /*  920475 */     GIR_EraseRootFromParent_Done,
     /*  920476 */   // Label 13994: @920476
     /*  920476 */   GIM_Try, /*On fail goto*//*Label 13995*/ GIMT_Encode4(920564), // Rule ID 23939 //
     /*  920481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  920492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  920495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  920498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920528 */     // MIs[1] Operand 1
     /*  920528 */     // No operand predicates
     /*  920528 */     // MIs[0] policy
     /*  920528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920540 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920562 */     GIR_RootConstrainSelectedInstOperands,
     /*  920563 */     // GIR_Coverage, 23939,
     /*  920563 */     GIR_EraseRootFromParent_Done,
     /*  920564 */   // Label 13995: @920564
     /*  920564 */   GIM_Try, /*On fail goto*//*Label 13996*/ GIMT_Encode4(920652), // Rule ID 23942 //
     /*  920569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  920580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  920583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  920586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920616 */     // MIs[1] Operand 1
     /*  920616 */     // No operand predicates
     /*  920616 */     // MIs[0] policy
     /*  920616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920628 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920650 */     GIR_RootConstrainSelectedInstOperands,
     /*  920651 */     // GIR_Coverage, 23942,
     /*  920651 */     GIR_EraseRootFromParent_Done,
     /*  920652 */   // Label 13996: @920652
     /*  920652 */   GIM_Try, /*On fail goto*//*Label 13997*/ GIMT_Encode4(920740), // Rule ID 23943 //
     /*  920657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  920668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  920671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  920674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920704 */     // MIs[1] Operand 1
     /*  920704 */     // No operand predicates
     /*  920704 */     // MIs[0] policy
     /*  920704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920716 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920738 */     GIR_RootConstrainSelectedInstOperands,
     /*  920739 */     // GIR_Coverage, 23943,
     /*  920739 */     GIR_EraseRootFromParent_Done,
     /*  920740 */   // Label 13997: @920740
     /*  920740 */   GIM_Try, /*On fail goto*//*Label 13998*/ GIMT_Encode4(920828), // Rule ID 23946 //
     /*  920745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  920756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  920759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  920762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920792 */     // MIs[1] Operand 1
     /*  920792 */     // No operand predicates
     /*  920792 */     // MIs[0] policy
     /*  920792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920804 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920826 */     GIR_RootConstrainSelectedInstOperands,
     /*  920827 */     // GIR_Coverage, 23946,
     /*  920827 */     GIR_EraseRootFromParent_Done,
     /*  920828 */   // Label 13998: @920828
     /*  920828 */   GIM_Try, /*On fail goto*//*Label 13999*/ GIMT_Encode4(920916), // Rule ID 23947 //
     /*  920833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  920844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  920847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  920850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920880 */     // MIs[1] Operand 1
     /*  920880 */     // No operand predicates
     /*  920880 */     // MIs[0] policy
     /*  920880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920892 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920914 */     GIR_RootConstrainSelectedInstOperands,
     /*  920915 */     // GIR_Coverage, 23947,
     /*  920915 */     GIR_EraseRootFromParent_Done,
     /*  920916 */   // Label 13999: @920916
     /*  920916 */   GIM_Try, /*On fail goto*//*Label 14000*/ GIMT_Encode4(921004), // Rule ID 23950 //
     /*  920921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  920932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  920935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  920938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920968 */     // MIs[1] Operand 1
     /*  920968 */     // No operand predicates
     /*  920968 */     // MIs[0] policy
     /*  920968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920980 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921002 */     GIR_RootConstrainSelectedInstOperands,
     /*  921003 */     // GIR_Coverage, 23950,
     /*  921003 */     GIR_EraseRootFromParent_Done,
     /*  921004 */   // Label 14000: @921004
     /*  921004 */   GIM_Try, /*On fail goto*//*Label 14001*/ GIMT_Encode4(921092), // Rule ID 23951 //
     /*  921009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  921020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  921023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  921026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921056 */     // MIs[1] Operand 1
     /*  921056 */     // No operand predicates
     /*  921056 */     // MIs[0] policy
     /*  921056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921068 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921090 */     GIR_RootConstrainSelectedInstOperands,
     /*  921091 */     // GIR_Coverage, 23951,
     /*  921091 */     GIR_EraseRootFromParent_Done,
     /*  921092 */   // Label 14001: @921092
     /*  921092 */   GIM_Try, /*On fail goto*//*Label 14002*/ GIMT_Encode4(921180), // Rule ID 23954 //
     /*  921097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  921108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  921111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  921114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921144 */     // MIs[1] Operand 1
     /*  921144 */     // No operand predicates
     /*  921144 */     // MIs[0] policy
     /*  921144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921156 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  921159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921178 */     GIR_RootConstrainSelectedInstOperands,
     /*  921179 */     // GIR_Coverage, 23954,
     /*  921179 */     GIR_EraseRootFromParent_Done,
     /*  921180 */   // Label 14002: @921180
     /*  921180 */   GIM_Try, /*On fail goto*//*Label 14003*/ GIMT_Encode4(921268), // Rule ID 23955 //
     /*  921185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  921196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  921199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  921202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921232 */     // MIs[1] Operand 1
     /*  921232 */     // No operand predicates
     /*  921232 */     // MIs[0] policy
     /*  921232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  921247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921266 */     GIR_RootConstrainSelectedInstOperands,
     /*  921267 */     // GIR_Coverage, 23955,
     /*  921267 */     GIR_EraseRootFromParent_Done,
     /*  921268 */   // Label 14003: @921268
     /*  921268 */   GIM_Try, /*On fail goto*//*Label 14004*/ GIMT_Encode4(921356), // Rule ID 23958 //
     /*  921273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  921284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  921287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  921290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921320 */     // MIs[1] Operand 1
     /*  921320 */     // No operand predicates
     /*  921320 */     // MIs[0] policy
     /*  921320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921332 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  921335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921354 */     GIR_RootConstrainSelectedInstOperands,
     /*  921355 */     // GIR_Coverage, 23958,
     /*  921355 */     GIR_EraseRootFromParent_Done,
     /*  921356 */   // Label 14004: @921356
     /*  921356 */   GIM_Try, /*On fail goto*//*Label 14005*/ GIMT_Encode4(921444), // Rule ID 23959 //
     /*  921361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  921372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  921375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  921378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921408 */     // MIs[1] Operand 1
     /*  921408 */     // No operand predicates
     /*  921408 */     // MIs[0] policy
     /*  921408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921420 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  921423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921442 */     GIR_RootConstrainSelectedInstOperands,
     /*  921443 */     // GIR_Coverage, 23959,
     /*  921443 */     GIR_EraseRootFromParent_Done,
     /*  921444 */   // Label 14005: @921444
     /*  921444 */   GIM_Try, /*On fail goto*//*Label 14006*/ GIMT_Encode4(921532), // Rule ID 23962 //
     /*  921449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  921460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  921463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  921466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921496 */     // MIs[1] Operand 1
     /*  921496 */     // No operand predicates
     /*  921496 */     // MIs[0] policy
     /*  921496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921508 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921530 */     GIR_RootConstrainSelectedInstOperands,
     /*  921531 */     // GIR_Coverage, 23962,
     /*  921531 */     GIR_EraseRootFromParent_Done,
     /*  921532 */   // Label 14006: @921532
     /*  921532 */   GIM_Try, /*On fail goto*//*Label 14007*/ GIMT_Encode4(921620), // Rule ID 23963 //
     /*  921537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  921548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  921551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  921554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921584 */     // MIs[1] Operand 1
     /*  921584 */     // No operand predicates
     /*  921584 */     // MIs[0] policy
     /*  921584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921596 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921618 */     GIR_RootConstrainSelectedInstOperands,
     /*  921619 */     // GIR_Coverage, 23963,
     /*  921619 */     GIR_EraseRootFromParent_Done,
     /*  921620 */   // Label 14007: @921620
     /*  921620 */   GIM_Try, /*On fail goto*//*Label 14008*/ GIMT_Encode4(921708), // Rule ID 24202 //
     /*  921625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  921636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  921639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  921642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921672 */     // MIs[1] Operand 1
     /*  921672 */     // No operand predicates
     /*  921672 */     // MIs[0] policy
     /*  921672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921684 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  921687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921706 */     GIR_RootConstrainSelectedInstOperands,
     /*  921707 */     // GIR_Coverage, 24202,
     /*  921707 */     GIR_EraseRootFromParent_Done,
     /*  921708 */   // Label 14008: @921708
     /*  921708 */   GIM_Try, /*On fail goto*//*Label 14009*/ GIMT_Encode4(921796), // Rule ID 24203 //
     /*  921713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  921724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  921727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  921730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921760 */     // MIs[1] Operand 1
     /*  921760 */     // No operand predicates
     /*  921760 */     // MIs[0] policy
     /*  921760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921772 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  921775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921794 */     GIR_RootConstrainSelectedInstOperands,
     /*  921795 */     // GIR_Coverage, 24203,
     /*  921795 */     GIR_EraseRootFromParent_Done,
     /*  921796 */   // Label 14009: @921796
     /*  921796 */   GIM_Try, /*On fail goto*//*Label 14010*/ GIMT_Encode4(921884), // Rule ID 24206 //
     /*  921801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  921812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  921815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  921818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921848 */     // MIs[1] Operand 1
     /*  921848 */     // No operand predicates
     /*  921848 */     // MIs[0] policy
     /*  921848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921860 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  921863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921882 */     GIR_RootConstrainSelectedInstOperands,
     /*  921883 */     // GIR_Coverage, 24206,
     /*  921883 */     GIR_EraseRootFromParent_Done,
     /*  921884 */   // Label 14010: @921884
     /*  921884 */   GIM_Try, /*On fail goto*//*Label 14011*/ GIMT_Encode4(921972), // Rule ID 24207 //
     /*  921889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  921900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  921903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  921906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921936 */     // MIs[1] Operand 1
     /*  921936 */     // No operand predicates
     /*  921936 */     // MIs[0] policy
     /*  921936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921948 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  921951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921970 */     GIR_RootConstrainSelectedInstOperands,
     /*  921971 */     // GIR_Coverage, 24207,
     /*  921971 */     GIR_EraseRootFromParent_Done,
     /*  921972 */   // Label 14011: @921972
     /*  921972 */   GIM_Try, /*On fail goto*//*Label 14012*/ GIMT_Encode4(922060), // Rule ID 24210 //
     /*  921977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  921988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  921991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  921994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922024 */     // MIs[1] Operand 1
     /*  922024 */     // No operand predicates
     /*  922024 */     // MIs[0] policy
     /*  922024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922036 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  922039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922058 */     GIR_RootConstrainSelectedInstOperands,
     /*  922059 */     // GIR_Coverage, 24210,
     /*  922059 */     GIR_EraseRootFromParent_Done,
     /*  922060 */   // Label 14012: @922060
     /*  922060 */   GIM_Try, /*On fail goto*//*Label 14013*/ GIMT_Encode4(922148), // Rule ID 24211 //
     /*  922065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  922076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  922079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  922082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922112 */     // MIs[1] Operand 1
     /*  922112 */     // No operand predicates
     /*  922112 */     // MIs[0] policy
     /*  922112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922124 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  922127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922146 */     GIR_RootConstrainSelectedInstOperands,
     /*  922147 */     // GIR_Coverage, 24211,
     /*  922147 */     GIR_EraseRootFromParent_Done,
     /*  922148 */   // Label 14013: @922148
     /*  922148 */   GIM_Try, /*On fail goto*//*Label 14014*/ GIMT_Encode4(922236), // Rule ID 24214 //
     /*  922153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  922164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  922167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  922170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922200 */     // MIs[1] Operand 1
     /*  922200 */     // No operand predicates
     /*  922200 */     // MIs[0] policy
     /*  922200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922212 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922234 */     GIR_RootConstrainSelectedInstOperands,
     /*  922235 */     // GIR_Coverage, 24214,
     /*  922235 */     GIR_EraseRootFromParent_Done,
     /*  922236 */   // Label 14014: @922236
     /*  922236 */   GIM_Try, /*On fail goto*//*Label 14015*/ GIMT_Encode4(922324), // Rule ID 24215 //
     /*  922241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  922252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  922255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  922258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922288 */     // MIs[1] Operand 1
     /*  922288 */     // No operand predicates
     /*  922288 */     // MIs[0] policy
     /*  922288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922300 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922322 */     GIR_RootConstrainSelectedInstOperands,
     /*  922323 */     // GIR_Coverage, 24215,
     /*  922323 */     GIR_EraseRootFromParent_Done,
     /*  922324 */   // Label 14015: @922324
     /*  922324 */   GIM_Try, /*On fail goto*//*Label 14016*/ GIMT_Encode4(922412), // Rule ID 24218 //
     /*  922329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  922340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  922343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  922346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922376 */     // MIs[1] Operand 1
     /*  922376 */     // No operand predicates
     /*  922376 */     // MIs[0] policy
     /*  922376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922388 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922410 */     GIR_RootConstrainSelectedInstOperands,
     /*  922411 */     // GIR_Coverage, 24218,
     /*  922411 */     GIR_EraseRootFromParent_Done,
     /*  922412 */   // Label 14016: @922412
     /*  922412 */   GIM_Try, /*On fail goto*//*Label 14017*/ GIMT_Encode4(922500), // Rule ID 24219 //
     /*  922417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  922428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  922431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  922434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922464 */     // MIs[1] Operand 1
     /*  922464 */     // No operand predicates
     /*  922464 */     // MIs[0] policy
     /*  922464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922476 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922498 */     GIR_RootConstrainSelectedInstOperands,
     /*  922499 */     // GIR_Coverage, 24219,
     /*  922499 */     GIR_EraseRootFromParent_Done,
     /*  922500 */   // Label 14017: @922500
     /*  922500 */   GIM_Try, /*On fail goto*//*Label 14018*/ GIMT_Encode4(922588), // Rule ID 24222 //
     /*  922505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  922508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  922516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  922519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  922522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922552 */     // MIs[1] Operand 1
     /*  922552 */     // No operand predicates
     /*  922552 */     // MIs[0] policy
     /*  922552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922564 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  922584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922586 */     GIR_RootConstrainSelectedInstOperands,
     /*  922587 */     // GIR_Coverage, 24222,
     /*  922587 */     GIR_EraseRootFromParent_Done,
     /*  922588 */   // Label 14018: @922588
     /*  922588 */   GIM_Try, /*On fail goto*//*Label 14019*/ GIMT_Encode4(922676), // Rule ID 24223 //
     /*  922593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  922596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  922604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  922607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  922610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922640 */     // MIs[1] Operand 1
     /*  922640 */     // No operand predicates
     /*  922640 */     // MIs[0] policy
     /*  922640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922652 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  922672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922674 */     GIR_RootConstrainSelectedInstOperands,
     /*  922675 */     // GIR_Coverage, 24223,
     /*  922675 */     GIR_EraseRootFromParent_Done,
     /*  922676 */   // Label 14019: @922676
     /*  922676 */   GIM_Try, /*On fail goto*//*Label 14020*/ GIMT_Encode4(922764), // Rule ID 24226 //
     /*  922681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  922692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  922695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  922698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922728 */     // MIs[1] Operand 1
     /*  922728 */     // No operand predicates
     /*  922728 */     // MIs[0] policy
     /*  922728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922740 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  922743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922762 */     GIR_RootConstrainSelectedInstOperands,
     /*  922763 */     // GIR_Coverage, 24226,
     /*  922763 */     GIR_EraseRootFromParent_Done,
     /*  922764 */   // Label 14020: @922764
     /*  922764 */   GIM_Try, /*On fail goto*//*Label 14021*/ GIMT_Encode4(922852), // Rule ID 24227 //
     /*  922769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  922780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  922783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  922786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922816 */     // MIs[1] Operand 1
     /*  922816 */     // No operand predicates
     /*  922816 */     // MIs[0] policy
     /*  922816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922828 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  922831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922850 */     GIR_RootConstrainSelectedInstOperands,
     /*  922851 */     // GIR_Coverage, 24227,
     /*  922851 */     GIR_EraseRootFromParent_Done,
     /*  922852 */   // Label 14021: @922852
     /*  922852 */   GIM_Try, /*On fail goto*//*Label 14022*/ GIMT_Encode4(922940), // Rule ID 24230 //
     /*  922857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  922868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  922871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  922874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922904 */     // MIs[1] Operand 1
     /*  922904 */     // No operand predicates
     /*  922904 */     // MIs[0] policy
     /*  922904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922916 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  922919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922938 */     GIR_RootConstrainSelectedInstOperands,
     /*  922939 */     // GIR_Coverage, 24230,
     /*  922939 */     GIR_EraseRootFromParent_Done,
     /*  922940 */   // Label 14022: @922940
     /*  922940 */   GIM_Try, /*On fail goto*//*Label 14023*/ GIMT_Encode4(923028), // Rule ID 24231 //
     /*  922945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  922956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  922959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  922962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922992 */     // MIs[1] Operand 1
     /*  922992 */     // No operand predicates
     /*  922992 */     // MIs[0] policy
     /*  922992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923004 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923026 */     GIR_RootConstrainSelectedInstOperands,
     /*  923027 */     // GIR_Coverage, 24231,
     /*  923027 */     GIR_EraseRootFromParent_Done,
     /*  923028 */   // Label 14023: @923028
     /*  923028 */   GIM_Try, /*On fail goto*//*Label 14024*/ GIMT_Encode4(923116), // Rule ID 24234 //
     /*  923033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  923044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  923047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  923050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923080 */     // MIs[1] Operand 1
     /*  923080 */     // No operand predicates
     /*  923080 */     // MIs[0] policy
     /*  923080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923092 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923114 */     GIR_RootConstrainSelectedInstOperands,
     /*  923115 */     // GIR_Coverage, 24234,
     /*  923115 */     GIR_EraseRootFromParent_Done,
     /*  923116 */   // Label 14024: @923116
     /*  923116 */   GIM_Try, /*On fail goto*//*Label 14025*/ GIMT_Encode4(923204), // Rule ID 24235 //
     /*  923121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  923132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  923135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  923138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923168 */     // MIs[1] Operand 1
     /*  923168 */     // No operand predicates
     /*  923168 */     // MIs[0] policy
     /*  923168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923180 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923202 */     GIR_RootConstrainSelectedInstOperands,
     /*  923203 */     // GIR_Coverage, 24235,
     /*  923203 */     GIR_EraseRootFromParent_Done,
     /*  923204 */   // Label 14025: @923204
     /*  923204 */   GIM_Try, /*On fail goto*//*Label 14026*/ GIMT_Encode4(923292), // Rule ID 24238 //
     /*  923209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  923220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  923223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  923226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923256 */     // MIs[1] Operand 1
     /*  923256 */     // No operand predicates
     /*  923256 */     // MIs[0] policy
     /*  923256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923268 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923290 */     GIR_RootConstrainSelectedInstOperands,
     /*  923291 */     // GIR_Coverage, 24238,
     /*  923291 */     GIR_EraseRootFromParent_Done,
     /*  923292 */   // Label 14026: @923292
     /*  923292 */   GIM_Try, /*On fail goto*//*Label 14027*/ GIMT_Encode4(923380), // Rule ID 24239 //
     /*  923297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  923308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  923311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  923314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923344 */     // MIs[1] Operand 1
     /*  923344 */     // No operand predicates
     /*  923344 */     // MIs[0] policy
     /*  923344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923356 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923378 */     GIR_RootConstrainSelectedInstOperands,
     /*  923379 */     // GIR_Coverage, 24239,
     /*  923379 */     GIR_EraseRootFromParent_Done,
     /*  923380 */   // Label 14027: @923380
     /*  923380 */   GIM_Try, /*On fail goto*//*Label 14028*/ GIMT_Encode4(923468), // Rule ID 24242 //
     /*  923385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  923396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  923399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  923402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923432 */     // MIs[1] Operand 1
     /*  923432 */     // No operand predicates
     /*  923432 */     // MIs[0] policy
     /*  923432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923444 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923466 */     GIR_RootConstrainSelectedInstOperands,
     /*  923467 */     // GIR_Coverage, 24242,
     /*  923467 */     GIR_EraseRootFromParent_Done,
     /*  923468 */   // Label 14028: @923468
     /*  923468 */   GIM_Try, /*On fail goto*//*Label 14029*/ GIMT_Encode4(923556), // Rule ID 24243 //
     /*  923473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  923484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  923487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  923490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923520 */     // MIs[1] Operand 1
     /*  923520 */     // No operand predicates
     /*  923520 */     // MIs[0] policy
     /*  923520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923532 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923554 */     GIR_RootConstrainSelectedInstOperands,
     /*  923555 */     // GIR_Coverage, 24243,
     /*  923555 */     GIR_EraseRootFromParent_Done,
     /*  923556 */   // Label 14029: @923556
     /*  923556 */   GIM_Try, /*On fail goto*//*Label 14030*/ GIMT_Encode4(923644), // Rule ID 24246 //
     /*  923561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  923572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  923575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  923578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923608 */     // MIs[1] Operand 1
     /*  923608 */     // No operand predicates
     /*  923608 */     // MIs[0] policy
     /*  923608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923620 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923642 */     GIR_RootConstrainSelectedInstOperands,
     /*  923643 */     // GIR_Coverage, 24246,
     /*  923643 */     GIR_EraseRootFromParent_Done,
     /*  923644 */   // Label 14030: @923644
     /*  923644 */   GIM_Try, /*On fail goto*//*Label 14031*/ GIMT_Encode4(923732), // Rule ID 24247 //
     /*  923649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  923660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  923663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  923666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923696 */     // MIs[1] Operand 1
     /*  923696 */     // No operand predicates
     /*  923696 */     // MIs[0] policy
     /*  923696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923708 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923730 */     GIR_RootConstrainSelectedInstOperands,
     /*  923731 */     // GIR_Coverage, 24247,
     /*  923731 */     GIR_EraseRootFromParent_Done,
     /*  923732 */   // Label 14031: @923732
     /*  923732 */   GIM_Try, /*On fail goto*//*Label 14032*/ GIMT_Encode4(923820), // Rule ID 24250 //
     /*  923737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  923740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  923748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  923751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  923754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923784 */     // MIs[1] Operand 1
     /*  923784 */     // No operand predicates
     /*  923784 */     // MIs[0] policy
     /*  923784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923796 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923818 */     GIR_RootConstrainSelectedInstOperands,
     /*  923819 */     // GIR_Coverage, 24250,
     /*  923819 */     GIR_EraseRootFromParent_Done,
     /*  923820 */   // Label 14032: @923820
     /*  923820 */   GIM_Try, /*On fail goto*//*Label 14033*/ GIMT_Encode4(923908), // Rule ID 24251 //
     /*  923825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  923828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  923836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  923839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  923842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923872 */     // MIs[1] Operand 1
     /*  923872 */     // No operand predicates
     /*  923872 */     // MIs[0] policy
     /*  923872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923884 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923906 */     GIR_RootConstrainSelectedInstOperands,
     /*  923907 */     // GIR_Coverage, 24251,
     /*  923907 */     GIR_EraseRootFromParent_Done,
     /*  923908 */   // Label 14033: @923908
     /*  923908 */   GIM_Try, /*On fail goto*//*Label 14034*/ GIMT_Encode4(923996), // Rule ID 24254 //
     /*  923913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  923916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  923924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  923927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  923930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923960 */     // MIs[1] Operand 1
     /*  923960 */     // No operand predicates
     /*  923960 */     // MIs[0] policy
     /*  923960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923972 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923994 */     GIR_RootConstrainSelectedInstOperands,
     /*  923995 */     // GIR_Coverage, 24254,
     /*  923995 */     GIR_EraseRootFromParent_Done,
     /*  923996 */   // Label 14034: @923996
     /*  923996 */   GIM_Try, /*On fail goto*//*Label 14035*/ GIMT_Encode4(924084), // Rule ID 24255 //
     /*  924001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  924004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  924012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  924015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  924018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924048 */     // MIs[1] Operand 1
     /*  924048 */     // No operand predicates
     /*  924048 */     // MIs[0] policy
     /*  924048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924060 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  924063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924082 */     GIR_RootConstrainSelectedInstOperands,
     /*  924083 */     // GIR_Coverage, 24255,
     /*  924083 */     GIR_EraseRootFromParent_Done,
     /*  924084 */   // Label 14035: @924084
     /*  924084 */   GIM_Try, /*On fail goto*//*Label 14036*/ GIMT_Encode4(924172), // Rule ID 24258 //
     /*  924089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  924092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  924100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  924103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  924106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924136 */     // MIs[1] Operand 1
     /*  924136 */     // No operand predicates
     /*  924136 */     // MIs[0] policy
     /*  924136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924148 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  924151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924170 */     GIR_RootConstrainSelectedInstOperands,
     /*  924171 */     // GIR_Coverage, 24258,
     /*  924171 */     GIR_EraseRootFromParent_Done,
     /*  924172 */   // Label 14036: @924172
     /*  924172 */   GIM_Try, /*On fail goto*//*Label 14037*/ GIMT_Encode4(924260), // Rule ID 24259 //
     /*  924177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  924180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  924188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  924191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  924194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924224 */     // MIs[1] Operand 1
     /*  924224 */     // No operand predicates
     /*  924224 */     // MIs[0] policy
     /*  924224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924236 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  924239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924258 */     GIR_RootConstrainSelectedInstOperands,
     /*  924259 */     // GIR_Coverage, 24259,
     /*  924259 */     GIR_EraseRootFromParent_Done,
     /*  924260 */   // Label 14037: @924260
     /*  924260 */   GIM_Try, /*On fail goto*//*Label 14038*/ GIMT_Encode4(924348), // Rule ID 24322 //
     /*  924265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  924276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  924279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  924282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924312 */     // MIs[1] Operand 1
     /*  924312 */     // No operand predicates
     /*  924312 */     // MIs[0] policy
     /*  924312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924324 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  924327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924346 */     GIR_RootConstrainSelectedInstOperands,
     /*  924347 */     // GIR_Coverage, 24322,
     /*  924347 */     GIR_EraseRootFromParent_Done,
     /*  924348 */   // Label 14038: @924348
     /*  924348 */   GIM_Try, /*On fail goto*//*Label 14039*/ GIMT_Encode4(924436), // Rule ID 24323 //
     /*  924353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  924364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  924367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  924370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924400 */     // MIs[1] Operand 1
     /*  924400 */     // No operand predicates
     /*  924400 */     // MIs[0] policy
     /*  924400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924412 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  924415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924434 */     GIR_RootConstrainSelectedInstOperands,
     /*  924435 */     // GIR_Coverage, 24323,
     /*  924435 */     GIR_EraseRootFromParent_Done,
     /*  924436 */   // Label 14039: @924436
     /*  924436 */   GIM_Try, /*On fail goto*//*Label 14040*/ GIMT_Encode4(924524), // Rule ID 24326 //
     /*  924441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  924452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  924455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  924458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924488 */     // MIs[1] Operand 1
     /*  924488 */     // No operand predicates
     /*  924488 */     // MIs[0] policy
     /*  924488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924500 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  924503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924522 */     GIR_RootConstrainSelectedInstOperands,
     /*  924523 */     // GIR_Coverage, 24326,
     /*  924523 */     GIR_EraseRootFromParent_Done,
     /*  924524 */   // Label 14040: @924524
     /*  924524 */   GIM_Try, /*On fail goto*//*Label 14041*/ GIMT_Encode4(924612), // Rule ID 24327 //
     /*  924529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  924540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  924543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  924546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924576 */     // MIs[1] Operand 1
     /*  924576 */     // No operand predicates
     /*  924576 */     // MIs[0] policy
     /*  924576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924588 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  924591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924610 */     GIR_RootConstrainSelectedInstOperands,
     /*  924611 */     // GIR_Coverage, 24327,
     /*  924611 */     GIR_EraseRootFromParent_Done,
     /*  924612 */   // Label 14041: @924612
     /*  924612 */   GIM_Try, /*On fail goto*//*Label 14042*/ GIMT_Encode4(924700), // Rule ID 24330 //
     /*  924617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  924628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  924631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  924634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924664 */     // MIs[1] Operand 1
     /*  924664 */     // No operand predicates
     /*  924664 */     // MIs[0] policy
     /*  924664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924676 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  924679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924698 */     GIR_RootConstrainSelectedInstOperands,
     /*  924699 */     // GIR_Coverage, 24330,
     /*  924699 */     GIR_EraseRootFromParent_Done,
     /*  924700 */   // Label 14042: @924700
     /*  924700 */   GIM_Try, /*On fail goto*//*Label 14043*/ GIMT_Encode4(924788), // Rule ID 24331 //
     /*  924705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  924716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  924719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  924722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924752 */     // MIs[1] Operand 1
     /*  924752 */     // No operand predicates
     /*  924752 */     // MIs[0] policy
     /*  924752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924764 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  924767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924786 */     GIR_RootConstrainSelectedInstOperands,
     /*  924787 */     // GIR_Coverage, 24331,
     /*  924787 */     GIR_EraseRootFromParent_Done,
     /*  924788 */   // Label 14043: @924788
     /*  924788 */   GIM_Try, /*On fail goto*//*Label 14044*/ GIMT_Encode4(924876), // Rule ID 24334 //
     /*  924793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  924804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  924807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  924810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924840 */     // MIs[1] Operand 1
     /*  924840 */     // No operand predicates
     /*  924840 */     // MIs[0] policy
     /*  924840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924852 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  924855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924874 */     GIR_RootConstrainSelectedInstOperands,
     /*  924875 */     // GIR_Coverage, 24334,
     /*  924875 */     GIR_EraseRootFromParent_Done,
     /*  924876 */   // Label 14044: @924876
     /*  924876 */   GIM_Try, /*On fail goto*//*Label 14045*/ GIMT_Encode4(924964), // Rule ID 24335 //
     /*  924881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  924892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  924895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  924898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924928 */     // MIs[1] Operand 1
     /*  924928 */     // No operand predicates
     /*  924928 */     // MIs[0] policy
     /*  924928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924940 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  924943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924962 */     GIR_RootConstrainSelectedInstOperands,
     /*  924963 */     // GIR_Coverage, 24335,
     /*  924963 */     GIR_EraseRootFromParent_Done,
     /*  924964 */   // Label 14045: @924964
     /*  924964 */   GIM_Try, /*On fail goto*//*Label 14046*/ GIMT_Encode4(925052), // Rule ID 24338 //
     /*  924969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  924980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  924983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  924986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925016 */     // MIs[1] Operand 1
     /*  925016 */     // No operand predicates
     /*  925016 */     // MIs[0] policy
     /*  925016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925028 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925050 */     GIR_RootConstrainSelectedInstOperands,
     /*  925051 */     // GIR_Coverage, 24338,
     /*  925051 */     GIR_EraseRootFromParent_Done,
     /*  925052 */   // Label 14046: @925052
     /*  925052 */   GIM_Try, /*On fail goto*//*Label 14047*/ GIMT_Encode4(925140), // Rule ID 24339 //
     /*  925057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  925068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  925071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  925074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925104 */     // MIs[1] Operand 1
     /*  925104 */     // No operand predicates
     /*  925104 */     // MIs[0] policy
     /*  925104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925116 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925138 */     GIR_RootConstrainSelectedInstOperands,
     /*  925139 */     // GIR_Coverage, 24339,
     /*  925139 */     GIR_EraseRootFromParent_Done,
     /*  925140 */   // Label 14047: @925140
     /*  925140 */   GIM_Try, /*On fail goto*//*Label 14048*/ GIMT_Encode4(925228), // Rule ID 24342 //
     /*  925145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  925148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  925156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  925159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  925162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925192 */     // MIs[1] Operand 1
     /*  925192 */     // No operand predicates
     /*  925192 */     // MIs[0] policy
     /*  925192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925204 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925226 */     GIR_RootConstrainSelectedInstOperands,
     /*  925227 */     // GIR_Coverage, 24342,
     /*  925227 */     GIR_EraseRootFromParent_Done,
     /*  925228 */   // Label 14048: @925228
     /*  925228 */   GIM_Try, /*On fail goto*//*Label 14049*/ GIMT_Encode4(925316), // Rule ID 24343 //
     /*  925233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  925236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  925244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  925247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  925250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925280 */     // MIs[1] Operand 1
     /*  925280 */     // No operand predicates
     /*  925280 */     // MIs[0] policy
     /*  925280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925292 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925314 */     GIR_RootConstrainSelectedInstOperands,
     /*  925315 */     // GIR_Coverage, 24343,
     /*  925315 */     GIR_EraseRootFromParent_Done,
     /*  925316 */   // Label 14049: @925316
     /*  925316 */   GIM_Try, /*On fail goto*//*Label 14050*/ GIMT_Encode4(925404), // Rule ID 24346 //
     /*  925321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  925332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  925335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  925338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925368 */     // MIs[1] Operand 1
     /*  925368 */     // No operand predicates
     /*  925368 */     // MIs[0] policy
     /*  925368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925380 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925402 */     GIR_RootConstrainSelectedInstOperands,
     /*  925403 */     // GIR_Coverage, 24346,
     /*  925403 */     GIR_EraseRootFromParent_Done,
     /*  925404 */   // Label 14050: @925404
     /*  925404 */   GIM_Try, /*On fail goto*//*Label 14051*/ GIMT_Encode4(925492), // Rule ID 24347 //
     /*  925409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  925420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  925423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  925426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925456 */     // MIs[1] Operand 1
     /*  925456 */     // No operand predicates
     /*  925456 */     // MIs[0] policy
     /*  925456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925468 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925490 */     GIR_RootConstrainSelectedInstOperands,
     /*  925491 */     // GIR_Coverage, 24347,
     /*  925491 */     GIR_EraseRootFromParent_Done,
     /*  925492 */   // Label 14051: @925492
     /*  925492 */   GIM_Try, /*On fail goto*//*Label 14052*/ GIMT_Encode4(925580), // Rule ID 24350 //
     /*  925497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  925508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  925511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  925514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925544 */     // MIs[1] Operand 1
     /*  925544 */     // No operand predicates
     /*  925544 */     // MIs[0] policy
     /*  925544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925556 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  925559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925578 */     GIR_RootConstrainSelectedInstOperands,
     /*  925579 */     // GIR_Coverage, 24350,
     /*  925579 */     GIR_EraseRootFromParent_Done,
     /*  925580 */   // Label 14052: @925580
     /*  925580 */   GIM_Try, /*On fail goto*//*Label 14053*/ GIMT_Encode4(925668), // Rule ID 24351 //
     /*  925585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  925596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  925599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  925602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925632 */     // MIs[1] Operand 1
     /*  925632 */     // No operand predicates
     /*  925632 */     // MIs[0] policy
     /*  925632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925644 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  925647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925666 */     GIR_RootConstrainSelectedInstOperands,
     /*  925667 */     // GIR_Coverage, 24351,
     /*  925667 */     GIR_EraseRootFromParent_Done,
     /*  925668 */   // Label 14053: @925668
     /*  925668 */   GIM_Try, /*On fail goto*//*Label 14054*/ GIMT_Encode4(925756), // Rule ID 24354 //
     /*  925673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  925684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  925687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  925690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925720 */     // MIs[1] Operand 1
     /*  925720 */     // No operand predicates
     /*  925720 */     // MIs[0] policy
     /*  925720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925732 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  925735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925754 */     GIR_RootConstrainSelectedInstOperands,
     /*  925755 */     // GIR_Coverage, 24354,
     /*  925755 */     GIR_EraseRootFromParent_Done,
     /*  925756 */   // Label 14054: @925756
     /*  925756 */   GIM_Try, /*On fail goto*//*Label 14055*/ GIMT_Encode4(925844), // Rule ID 24355 //
     /*  925761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  925772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  925775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  925778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925808 */     // MIs[1] Operand 1
     /*  925808 */     // No operand predicates
     /*  925808 */     // MIs[0] policy
     /*  925808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925820 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  925823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925842 */     GIR_RootConstrainSelectedInstOperands,
     /*  925843 */     // GIR_Coverage, 24355,
     /*  925843 */     GIR_EraseRootFromParent_Done,
     /*  925844 */   // Label 14055: @925844
     /*  925844 */   GIM_Try, /*On fail goto*//*Label 14056*/ GIMT_Encode4(925932), // Rule ID 24358 //
     /*  925849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  925860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  925863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  925866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925896 */     // MIs[1] Operand 1
     /*  925896 */     // No operand predicates
     /*  925896 */     // MIs[0] policy
     /*  925896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925908 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925930 */     GIR_RootConstrainSelectedInstOperands,
     /*  925931 */     // GIR_Coverage, 24358,
     /*  925931 */     GIR_EraseRootFromParent_Done,
     /*  925932 */   // Label 14056: @925932
     /*  925932 */   GIM_Try, /*On fail goto*//*Label 14057*/ GIMT_Encode4(926020), // Rule ID 24359 //
     /*  925937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  925948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  925951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  925954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925984 */     // MIs[1] Operand 1
     /*  925984 */     // No operand predicates
     /*  925984 */     // MIs[0] policy
     /*  925984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925996 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926018 */     GIR_RootConstrainSelectedInstOperands,
     /*  926019 */     // GIR_Coverage, 24359,
     /*  926019 */     GIR_EraseRootFromParent_Done,
     /*  926020 */   // Label 14057: @926020
     /*  926020 */   GIM_Try, /*On fail goto*//*Label 14058*/ GIMT_Encode4(926108), // Rule ID 24362 //
     /*  926025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  926036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  926039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  926042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926072 */     // MIs[1] Operand 1
     /*  926072 */     // No operand predicates
     /*  926072 */     // MIs[0] policy
     /*  926072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926084 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926106 */     GIR_RootConstrainSelectedInstOperands,
     /*  926107 */     // GIR_Coverage, 24362,
     /*  926107 */     GIR_EraseRootFromParent_Done,
     /*  926108 */   // Label 14058: @926108
     /*  926108 */   GIM_Try, /*On fail goto*//*Label 14059*/ GIMT_Encode4(926196), // Rule ID 24363 //
     /*  926113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  926124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  926127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  926130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926160 */     // MIs[1] Operand 1
     /*  926160 */     // No operand predicates
     /*  926160 */     // MIs[0] policy
     /*  926160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926172 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926194 */     GIR_RootConstrainSelectedInstOperands,
     /*  926195 */     // GIR_Coverage, 24363,
     /*  926195 */     GIR_EraseRootFromParent_Done,
     /*  926196 */   // Label 14059: @926196
     /*  926196 */   GIM_Try, /*On fail goto*//*Label 14060*/ GIMT_Encode4(926284), // Rule ID 24366 //
     /*  926201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  926212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  926215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  926218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926244 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926248 */     // MIs[1] Operand 1
     /*  926248 */     // No operand predicates
     /*  926248 */     // MIs[0] policy
     /*  926248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926260 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926282 */     GIR_RootConstrainSelectedInstOperands,
     /*  926283 */     // GIR_Coverage, 24366,
     /*  926283 */     GIR_EraseRootFromParent_Done,
     /*  926284 */   // Label 14060: @926284
     /*  926284 */   GIM_Try, /*On fail goto*//*Label 14061*/ GIMT_Encode4(926372), // Rule ID 24367 //
     /*  926289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  926300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  926303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  926306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926336 */     // MIs[1] Operand 1
     /*  926336 */     // No operand predicates
     /*  926336 */     // MIs[0] policy
     /*  926336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926348 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926370 */     GIR_RootConstrainSelectedInstOperands,
     /*  926371 */     // GIR_Coverage, 24367,
     /*  926371 */     GIR_EraseRootFromParent_Done,
     /*  926372 */   // Label 14061: @926372
     /*  926372 */   GIM_Try, /*On fail goto*//*Label 14062*/ GIMT_Encode4(926460), // Rule ID 24370 //
     /*  926377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  926380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  926388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  926391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  926394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926424 */     // MIs[1] Operand 1
     /*  926424 */     // No operand predicates
     /*  926424 */     // MIs[0] policy
     /*  926424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926436 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  926439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926458 */     GIR_RootConstrainSelectedInstOperands,
     /*  926459 */     // GIR_Coverage, 24370,
     /*  926459 */     GIR_EraseRootFromParent_Done,
     /*  926460 */   // Label 14062: @926460
     /*  926460 */   GIM_Try, /*On fail goto*//*Label 14063*/ GIMT_Encode4(926548), // Rule ID 24371 //
     /*  926465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  926468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  926476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  926479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  926482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926512 */     // MIs[1] Operand 1
     /*  926512 */     // No operand predicates
     /*  926512 */     // MIs[0] policy
     /*  926512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926524 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  926527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926546 */     GIR_RootConstrainSelectedInstOperands,
     /*  926547 */     // GIR_Coverage, 24371,
     /*  926547 */     GIR_EraseRootFromParent_Done,
     /*  926548 */   // Label 14063: @926548
     /*  926548 */   GIM_Try, /*On fail goto*//*Label 14064*/ GIMT_Encode4(926636), // Rule ID 24374 //
     /*  926553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  926556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  926564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  926567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  926570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926600 */     // MIs[1] Operand 1
     /*  926600 */     // No operand predicates
     /*  926600 */     // MIs[0] policy
     /*  926600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926612 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926634 */     GIR_RootConstrainSelectedInstOperands,
     /*  926635 */     // GIR_Coverage, 24374,
     /*  926635 */     GIR_EraseRootFromParent_Done,
     /*  926636 */   // Label 14064: @926636
     /*  926636 */   GIM_Try, /*On fail goto*//*Label 14065*/ GIMT_Encode4(926724), // Rule ID 24375 //
     /*  926641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  926644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  926652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  926655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  926658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926688 */     // MIs[1] Operand 1
     /*  926688 */     // No operand predicates
     /*  926688 */     // MIs[0] policy
     /*  926688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926700 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926722 */     GIR_RootConstrainSelectedInstOperands,
     /*  926723 */     // GIR_Coverage, 24375,
     /*  926723 */     GIR_EraseRootFromParent_Done,
     /*  926724 */   // Label 14065: @926724
     /*  926724 */   GIM_Try, /*On fail goto*//*Label 14066*/ GIMT_Encode4(926812), // Rule ID 24378 //
     /*  926729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  926732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  926740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  926743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  926746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926776 */     // MIs[1] Operand 1
     /*  926776 */     // No operand predicates
     /*  926776 */     // MIs[0] policy
     /*  926776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926788 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926810 */     GIR_RootConstrainSelectedInstOperands,
     /*  926811 */     // GIR_Coverage, 24378,
     /*  926811 */     GIR_EraseRootFromParent_Done,
     /*  926812 */   // Label 14066: @926812
     /*  926812 */   GIM_Try, /*On fail goto*//*Label 14067*/ GIMT_Encode4(926900), // Rule ID 24379 //
     /*  926817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  926820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  926828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  926831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  926834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926864 */     // MIs[1] Operand 1
     /*  926864 */     // No operand predicates
     /*  926864 */     // MIs[0] policy
     /*  926864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926876 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926898 */     GIR_RootConstrainSelectedInstOperands,
     /*  926899 */     // GIR_Coverage, 24379,
     /*  926899 */     GIR_EraseRootFromParent_Done,
     /*  926900 */   // Label 14067: @926900
     /*  926900 */   GIM_Try, /*On fail goto*//*Label 14068*/ GIMT_Encode4(926991), // Rule ID 15990 //
     /*  926905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  926913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  926916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  926919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  926922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  926928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926952 */     // MIs[1] Operand 1
     /*  926952 */     // No operand predicates
     /*  926952 */     // MIs[0] round
     /*  926952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  926955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926964 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  926964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  926967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  926971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926976 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  926978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  926986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  926989 */     GIR_RootConstrainSelectedInstOperands,
     /*  926990 */     // GIR_Coverage, 15990,
     /*  926990 */     GIR_EraseRootFromParent_Done,
     /*  926991 */   // Label 14068: @926991
     /*  926991 */   GIM_Try, /*On fail goto*//*Label 14069*/ GIMT_Encode4(927082), // Rule ID 15991 //
     /*  926996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  927007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  927010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  927013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927043 */     // MIs[1] Operand 1
     /*  927043 */     // No operand predicates
     /*  927043 */     // MIs[0] round
     /*  927043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927055 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  927055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  927058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927080 */     GIR_RootConstrainSelectedInstOperands,
     /*  927081 */     // GIR_Coverage, 15991,
     /*  927081 */     GIR_EraseRootFromParent_Done,
     /*  927082 */   // Label 14069: @927082
     /*  927082 */   GIM_Try, /*On fail goto*//*Label 14070*/ GIMT_Encode4(927173), // Rule ID 15994 //
     /*  927087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  927098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  927101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  927104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927134 */     // MIs[1] Operand 1
     /*  927134 */     // No operand predicates
     /*  927134 */     // MIs[0] round
     /*  927134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927146 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  927146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927158 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927171 */     GIR_RootConstrainSelectedInstOperands,
     /*  927172 */     // GIR_Coverage, 15994,
     /*  927172 */     GIR_EraseRootFromParent_Done,
     /*  927173 */   // Label 14070: @927173
     /*  927173 */   GIM_Try, /*On fail goto*//*Label 14071*/ GIMT_Encode4(927264), // Rule ID 15995 //
     /*  927178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  927189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  927192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  927195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927225 */     // MIs[1] Operand 1
     /*  927225 */     // No operand predicates
     /*  927225 */     // MIs[0] round
     /*  927225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927237 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  927237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927262 */     GIR_RootConstrainSelectedInstOperands,
     /*  927263 */     // GIR_Coverage, 15995,
     /*  927263 */     GIR_EraseRootFromParent_Done,
     /*  927264 */   // Label 14071: @927264
     /*  927264 */   GIM_Try, /*On fail goto*//*Label 14072*/ GIMT_Encode4(927355), // Rule ID 15998 //
     /*  927269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  927280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  927283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  927286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927316 */     // MIs[1] Operand 1
     /*  927316 */     // No operand predicates
     /*  927316 */     // MIs[0] round
     /*  927316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927328 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  927328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927340 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927353 */     GIR_RootConstrainSelectedInstOperands,
     /*  927354 */     // GIR_Coverage, 15998,
     /*  927354 */     GIR_EraseRootFromParent_Done,
     /*  927355 */   // Label 14072: @927355
     /*  927355 */   GIM_Try, /*On fail goto*//*Label 14073*/ GIMT_Encode4(927446), // Rule ID 15999 //
     /*  927360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  927371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  927374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  927377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927407 */     // MIs[1] Operand 1
     /*  927407 */     // No operand predicates
     /*  927407 */     // MIs[0] round
     /*  927407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927419 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  927419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927444 */     GIR_RootConstrainSelectedInstOperands,
     /*  927445 */     // GIR_Coverage, 15999,
     /*  927445 */     GIR_EraseRootFromParent_Done,
     /*  927446 */   // Label 14073: @927446
     /*  927446 */   GIM_Try, /*On fail goto*//*Label 14074*/ GIMT_Encode4(927537), // Rule ID 16002 //
     /*  927451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  927462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  927465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  927468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927498 */     // MIs[1] Operand 1
     /*  927498 */     // No operand predicates
     /*  927498 */     // MIs[0] round
     /*  927498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927510 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  927510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927522 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927535 */     GIR_RootConstrainSelectedInstOperands,
     /*  927536 */     // GIR_Coverage, 16002,
     /*  927536 */     GIR_EraseRootFromParent_Done,
     /*  927537 */   // Label 14074: @927537
     /*  927537 */   GIM_Try, /*On fail goto*//*Label 14075*/ GIMT_Encode4(927628), // Rule ID 16003 //
     /*  927542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  927553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  927556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  927559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927589 */     // MIs[1] Operand 1
     /*  927589 */     // No operand predicates
     /*  927589 */     // MIs[0] round
     /*  927589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927601 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  927601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927626 */     GIR_RootConstrainSelectedInstOperands,
     /*  927627 */     // GIR_Coverage, 16003,
     /*  927627 */     GIR_EraseRootFromParent_Done,
     /*  927628 */   // Label 14075: @927628
     /*  927628 */   GIM_Try, /*On fail goto*//*Label 14076*/ GIMT_Encode4(927719), // Rule ID 16006 //
     /*  927633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  927644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  927647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  927650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927680 */     // MIs[1] Operand 1
     /*  927680 */     // No operand predicates
     /*  927680 */     // MIs[0] round
     /*  927680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927692 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  927692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927704 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927717 */     GIR_RootConstrainSelectedInstOperands,
     /*  927718 */     // GIR_Coverage, 16006,
     /*  927718 */     GIR_EraseRootFromParent_Done,
     /*  927719 */   // Label 14076: @927719
     /*  927719 */   GIM_Try, /*On fail goto*//*Label 14077*/ GIMT_Encode4(927810), // Rule ID 16007 //
     /*  927724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  927735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  927738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  927741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927771 */     // MIs[1] Operand 1
     /*  927771 */     // No operand predicates
     /*  927771 */     // MIs[0] round
     /*  927771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927783 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  927783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927808 */     GIR_RootConstrainSelectedInstOperands,
     /*  927809 */     // GIR_Coverage, 16007,
     /*  927809 */     GIR_EraseRootFromParent_Done,
     /*  927810 */   // Label 14077: @927810
     /*  927810 */   GIM_Try, /*On fail goto*//*Label 14078*/ GIMT_Encode4(927901), // Rule ID 16010 //
     /*  927815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  927826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  927829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  927832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927862 */     // MIs[1] Operand 1
     /*  927862 */     // No operand predicates
     /*  927862 */     // MIs[0] round
     /*  927862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927874 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  927874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927899 */     GIR_RootConstrainSelectedInstOperands,
     /*  927900 */     // GIR_Coverage, 16010,
     /*  927900 */     GIR_EraseRootFromParent_Done,
     /*  927901 */   // Label 14078: @927901
     /*  927901 */   GIM_Try, /*On fail goto*//*Label 14079*/ GIMT_Encode4(927992), // Rule ID 16011 //
     /*  927906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  927917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  927920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  927923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927953 */     // MIs[1] Operand 1
     /*  927953 */     // No operand predicates
     /*  927953 */     // MIs[0] round
     /*  927953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927965 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  927965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927990 */     GIR_RootConstrainSelectedInstOperands,
     /*  927991 */     // GIR_Coverage, 16011,
     /*  927991 */     GIR_EraseRootFromParent_Done,
     /*  927992 */   // Label 14079: @927992
     /*  927992 */   GIM_Try, /*On fail goto*//*Label 14080*/ GIMT_Encode4(928083), // Rule ID 16014 //
     /*  927997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  928008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  928011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  928014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928044 */     // MIs[1] Operand 1
     /*  928044 */     // No operand predicates
     /*  928044 */     // MIs[0] round
     /*  928044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928056 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  928056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928068 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928081 */     GIR_RootConstrainSelectedInstOperands,
     /*  928082 */     // GIR_Coverage, 16014,
     /*  928082 */     GIR_EraseRootFromParent_Done,
     /*  928083 */   // Label 14080: @928083
     /*  928083 */   GIM_Try, /*On fail goto*//*Label 14081*/ GIMT_Encode4(928174), // Rule ID 16015 //
     /*  928088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  928099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  928102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  928105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928135 */     // MIs[1] Operand 1
     /*  928135 */     // No operand predicates
     /*  928135 */     // MIs[0] round
     /*  928135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928147 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  928147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928172 */     GIR_RootConstrainSelectedInstOperands,
     /*  928173 */     // GIR_Coverage, 16015,
     /*  928173 */     GIR_EraseRootFromParent_Done,
     /*  928174 */   // Label 14081: @928174
     /*  928174 */   GIM_Try, /*On fail goto*//*Label 14082*/ GIMT_Encode4(928265), // Rule ID 16018 //
     /*  928179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  928196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928226 */     // MIs[1] Operand 1
     /*  928226 */     // No operand predicates
     /*  928226 */     // MIs[0] round
     /*  928226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928238 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  928238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928250 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928263 */     GIR_RootConstrainSelectedInstOperands,
     /*  928264 */     // GIR_Coverage, 16018,
     /*  928264 */     GIR_EraseRootFromParent_Done,
     /*  928265 */   // Label 14082: @928265
     /*  928265 */   GIM_Try, /*On fail goto*//*Label 14083*/ GIMT_Encode4(928356), // Rule ID 16019 //
     /*  928270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  928287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928317 */     // MIs[1] Operand 1
     /*  928317 */     // No operand predicates
     /*  928317 */     // MIs[0] round
     /*  928317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928329 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  928329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928354 */     GIR_RootConstrainSelectedInstOperands,
     /*  928355 */     // GIR_Coverage, 16019,
     /*  928355 */     GIR_EraseRootFromParent_Done,
     /*  928356 */   // Label 14083: @928356
     /*  928356 */   GIM_Try, /*On fail goto*//*Label 14084*/ GIMT_Encode4(928447), // Rule ID 16022 //
     /*  928361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  928378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928408 */     // MIs[1] Operand 1
     /*  928408 */     // No operand predicates
     /*  928408 */     // MIs[0] round
     /*  928408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928420 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  928420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928432 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928445 */     GIR_RootConstrainSelectedInstOperands,
     /*  928446 */     // GIR_Coverage, 16022,
     /*  928446 */     GIR_EraseRootFromParent_Done,
     /*  928447 */   // Label 14084: @928447
     /*  928447 */   GIM_Try, /*On fail goto*//*Label 14085*/ GIMT_Encode4(928538), // Rule ID 16023 //
     /*  928452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  928469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928499 */     // MIs[1] Operand 1
     /*  928499 */     // No operand predicates
     /*  928499 */     // MIs[0] round
     /*  928499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928511 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  928511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928536 */     GIR_RootConstrainSelectedInstOperands,
     /*  928537 */     // GIR_Coverage, 16023,
     /*  928537 */     GIR_EraseRootFromParent_Done,
     /*  928538 */   // Label 14085: @928538
     /*  928538 */   GIM_Try, /*On fail goto*//*Label 14086*/ GIMT_Encode4(928629), // Rule ID 16026 //
     /*  928543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  928546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  928554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  928557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  928560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928590 */     // MIs[1] Operand 1
     /*  928590 */     // No operand predicates
     /*  928590 */     // MIs[0] round
     /*  928590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928602 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  928602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928614 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  928624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928627 */     GIR_RootConstrainSelectedInstOperands,
     /*  928628 */     // GIR_Coverage, 16026,
     /*  928628 */     GIR_EraseRootFromParent_Done,
     /*  928629 */   // Label 14086: @928629
     /*  928629 */   GIM_Try, /*On fail goto*//*Label 14087*/ GIMT_Encode4(928720), // Rule ID 16027 //
     /*  928634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  928637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  928645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  928648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  928651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928681 */     // MIs[1] Operand 1
     /*  928681 */     // No operand predicates
     /*  928681 */     // MIs[0] round
     /*  928681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928693 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  928693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  928715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928718 */     GIR_RootConstrainSelectedInstOperands,
     /*  928719 */     // GIR_Coverage, 16027,
     /*  928719 */     GIR_EraseRootFromParent_Done,
     /*  928720 */   // Label 14087: @928720
     /*  928720 */   GIM_Try, /*On fail goto*//*Label 14088*/ GIMT_Encode4(928811), // Rule ID 16030 //
     /*  928725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  928736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  928739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  928742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928772 */     // MIs[1] Operand 1
     /*  928772 */     // No operand predicates
     /*  928772 */     // MIs[0] round
     /*  928772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  928784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  928787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928796 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928809 */     GIR_RootConstrainSelectedInstOperands,
     /*  928810 */     // GIR_Coverage, 16030,
     /*  928810 */     GIR_EraseRootFromParent_Done,
     /*  928811 */   // Label 14088: @928811
     /*  928811 */   GIM_Try, /*On fail goto*//*Label 14089*/ GIMT_Encode4(928902), // Rule ID 16031 //
     /*  928816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  928827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  928830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  928833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928863 */     // MIs[1] Operand 1
     /*  928863 */     // No operand predicates
     /*  928863 */     // MIs[0] round
     /*  928863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928875 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  928875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  928878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928900 */     GIR_RootConstrainSelectedInstOperands,
     /*  928901 */     // GIR_Coverage, 16031,
     /*  928901 */     GIR_EraseRootFromParent_Done,
     /*  928902 */   // Label 14089: @928902
     /*  928902 */   GIM_Try, /*On fail goto*//*Label 14090*/ GIMT_Encode4(928993), // Rule ID 16034 //
     /*  928907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  928918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  928921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  928924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928954 */     // MIs[1] Operand 1
     /*  928954 */     // No operand predicates
     /*  928954 */     // MIs[0] round
     /*  928954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928966 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  928966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  928969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928978 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928991 */     GIR_RootConstrainSelectedInstOperands,
     /*  928992 */     // GIR_Coverage, 16034,
     /*  928992 */     GIR_EraseRootFromParent_Done,
     /*  928993 */   // Label 14090: @928993
     /*  928993 */   GIM_Try, /*On fail goto*//*Label 14091*/ GIMT_Encode4(929084), // Rule ID 16035 //
     /*  928998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  929009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  929012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  929015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929045 */     // MIs[1] Operand 1
     /*  929045 */     // No operand predicates
     /*  929045 */     // MIs[0] round
     /*  929045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929057 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  929057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929082 */     GIR_RootConstrainSelectedInstOperands,
     /*  929083 */     // GIR_Coverage, 16035,
     /*  929083 */     GIR_EraseRootFromParent_Done,
     /*  929084 */   // Label 14091: @929084
     /*  929084 */   GIM_Try, /*On fail goto*//*Label 14092*/ GIMT_Encode4(929175), // Rule ID 16038 //
     /*  929089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  929100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  929103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  929106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929136 */     // MIs[1] Operand 1
     /*  929136 */     // No operand predicates
     /*  929136 */     // MIs[0] round
     /*  929136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929148 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  929148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929160 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929173 */     GIR_RootConstrainSelectedInstOperands,
     /*  929174 */     // GIR_Coverage, 16038,
     /*  929174 */     GIR_EraseRootFromParent_Done,
     /*  929175 */   // Label 14092: @929175
     /*  929175 */   GIM_Try, /*On fail goto*//*Label 14093*/ GIMT_Encode4(929266), // Rule ID 16039 //
     /*  929180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  929191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  929194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  929197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929227 */     // MIs[1] Operand 1
     /*  929227 */     // No operand predicates
     /*  929227 */     // MIs[0] round
     /*  929227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929239 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  929239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929264 */     GIR_RootConstrainSelectedInstOperands,
     /*  929265 */     // GIR_Coverage, 16039,
     /*  929265 */     GIR_EraseRootFromParent_Done,
     /*  929266 */   // Label 14093: @929266
     /*  929266 */   GIM_Try, /*On fail goto*//*Label 14094*/ GIMT_Encode4(929357), // Rule ID 16042 //
     /*  929271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  929288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929318 */     // MIs[1] Operand 1
     /*  929318 */     // No operand predicates
     /*  929318 */     // MIs[0] round
     /*  929318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929330 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  929330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929342 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929355 */     GIR_RootConstrainSelectedInstOperands,
     /*  929356 */     // GIR_Coverage, 16042,
     /*  929356 */     GIR_EraseRootFromParent_Done,
     /*  929357 */   // Label 14094: @929357
     /*  929357 */   GIM_Try, /*On fail goto*//*Label 14095*/ GIMT_Encode4(929448), // Rule ID 16043 //
     /*  929362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  929379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929409 */     // MIs[1] Operand 1
     /*  929409 */     // No operand predicates
     /*  929409 */     // MIs[0] round
     /*  929409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  929421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929446 */     GIR_RootConstrainSelectedInstOperands,
     /*  929447 */     // GIR_Coverage, 16043,
     /*  929447 */     GIR_EraseRootFromParent_Done,
     /*  929448 */   // Label 14095: @929448
     /*  929448 */   GIM_Try, /*On fail goto*//*Label 14096*/ GIMT_Encode4(929539), // Rule ID 16046 //
     /*  929453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  929464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  929467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  929470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929500 */     // MIs[1] Operand 1
     /*  929500 */     // No operand predicates
     /*  929500 */     // MIs[0] round
     /*  929500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929512 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  929512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929524 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929537 */     GIR_RootConstrainSelectedInstOperands,
     /*  929538 */     // GIR_Coverage, 16046,
     /*  929538 */     GIR_EraseRootFromParent_Done,
     /*  929539 */   // Label 14096: @929539
     /*  929539 */   GIM_Try, /*On fail goto*//*Label 14097*/ GIMT_Encode4(929630), // Rule ID 16047 //
     /*  929544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  929555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  929558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  929561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929591 */     // MIs[1] Operand 1
     /*  929591 */     // No operand predicates
     /*  929591 */     // MIs[0] round
     /*  929591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929603 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  929603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929628 */     GIR_RootConstrainSelectedInstOperands,
     /*  929629 */     // GIR_Coverage, 16047,
     /*  929629 */     GIR_EraseRootFromParent_Done,
     /*  929630 */   // Label 14097: @929630
     /*  929630 */   GIM_Try, /*On fail goto*//*Label 14098*/ GIMT_Encode4(929721), // Rule ID 16050 //
     /*  929635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  929646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  929649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  929652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929682 */     // MIs[1] Operand 1
     /*  929682 */     // No operand predicates
     /*  929682 */     // MIs[0] round
     /*  929682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929694 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  929694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929706 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929719 */     GIR_RootConstrainSelectedInstOperands,
     /*  929720 */     // GIR_Coverage, 16050,
     /*  929720 */     GIR_EraseRootFromParent_Done,
     /*  929721 */   // Label 14098: @929721
     /*  929721 */   GIM_Try, /*On fail goto*//*Label 14099*/ GIMT_Encode4(929812), // Rule ID 16051 //
     /*  929726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  929737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  929740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  929743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929773 */     // MIs[1] Operand 1
     /*  929773 */     // No operand predicates
     /*  929773 */     // MIs[0] round
     /*  929773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929785 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  929785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929810 */     GIR_RootConstrainSelectedInstOperands,
     /*  929811 */     // GIR_Coverage, 16051,
     /*  929811 */     GIR_EraseRootFromParent_Done,
     /*  929812 */   // Label 14099: @929812
     /*  929812 */   GIM_Try, /*On fail goto*//*Label 14100*/ GIMT_Encode4(929903), // Rule ID 16054 //
     /*  929817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  929828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  929831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  929834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929864 */     // MIs[1] Operand 1
     /*  929864 */     // No operand predicates
     /*  929864 */     // MIs[0] round
     /*  929864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  929876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929888 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929901 */     GIR_RootConstrainSelectedInstOperands,
     /*  929902 */     // GIR_Coverage, 16054,
     /*  929902 */     GIR_EraseRootFromParent_Done,
     /*  929903 */   // Label 14100: @929903
     /*  929903 */   GIM_Try, /*On fail goto*//*Label 14101*/ GIMT_Encode4(929994), // Rule ID 16055 //
     /*  929908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  929919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  929922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  929925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929955 */     // MIs[1] Operand 1
     /*  929955 */     // No operand predicates
     /*  929955 */     // MIs[0] round
     /*  929955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929967 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  929967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929992 */     GIR_RootConstrainSelectedInstOperands,
     /*  929993 */     // GIR_Coverage, 16055,
     /*  929993 */     GIR_EraseRootFromParent_Done,
     /*  929994 */   // Label 14101: @929994
     /*  929994 */   GIM_Try, /*On fail goto*//*Label 14102*/ GIMT_Encode4(930085), // Rule ID 16058 //
     /*  929999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  930010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  930013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  930016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930046 */     // MIs[1] Operand 1
     /*  930046 */     // No operand predicates
     /*  930046 */     // MIs[0] round
     /*  930046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930058 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  930058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930083 */     GIR_RootConstrainSelectedInstOperands,
     /*  930084 */     // GIR_Coverage, 16058,
     /*  930084 */     GIR_EraseRootFromParent_Done,
     /*  930085 */   // Label 14102: @930085
     /*  930085 */   GIM_Try, /*On fail goto*//*Label 14103*/ GIMT_Encode4(930176), // Rule ID 16059 //
     /*  930090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  930101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  930104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  930107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930137 */     // MIs[1] Operand 1
     /*  930137 */     // No operand predicates
     /*  930137 */     // MIs[0] round
     /*  930137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930149 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  930149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930174 */     GIR_RootConstrainSelectedInstOperands,
     /*  930175 */     // GIR_Coverage, 16059,
     /*  930175 */     GIR_EraseRootFromParent_Done,
     /*  930176 */   // Label 14103: @930176
     /*  930176 */   GIM_Try, /*On fail goto*//*Label 14104*/ GIMT_Encode4(930267), // Rule ID 16062 //
     /*  930181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  930192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  930195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  930198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930228 */     // MIs[1] Operand 1
     /*  930228 */     // No operand predicates
     /*  930228 */     // MIs[0] round
     /*  930228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930240 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  930240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930252 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930265 */     GIR_RootConstrainSelectedInstOperands,
     /*  930266 */     // GIR_Coverage, 16062,
     /*  930266 */     GIR_EraseRootFromParent_Done,
     /*  930267 */   // Label 14104: @930267
     /*  930267 */   GIM_Try, /*On fail goto*//*Label 14105*/ GIMT_Encode4(930358), // Rule ID 16063 //
     /*  930272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  930283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  930286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  930289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930319 */     // MIs[1] Operand 1
     /*  930319 */     // No operand predicates
     /*  930319 */     // MIs[0] round
     /*  930319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930331 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  930331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930356 */     GIR_RootConstrainSelectedInstOperands,
     /*  930357 */     // GIR_Coverage, 16063,
     /*  930357 */     GIR_EraseRootFromParent_Done,
     /*  930358 */   // Label 14105: @930358
     /*  930358 */   GIM_Try, /*On fail goto*//*Label 14106*/ GIMT_Encode4(930449), // Rule ID 16066 //
     /*  930363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  930366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  930380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930410 */     // MIs[1] Operand 1
     /*  930410 */     // No operand predicates
     /*  930410 */     // MIs[0] round
     /*  930410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930422 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  930422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  930425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930434 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930447 */     GIR_RootConstrainSelectedInstOperands,
     /*  930448 */     // GIR_Coverage, 16066,
     /*  930448 */     GIR_EraseRootFromParent_Done,
     /*  930449 */   // Label 14106: @930449
     /*  930449 */   GIM_Try, /*On fail goto*//*Label 14107*/ GIMT_Encode4(930540), // Rule ID 16067 //
     /*  930454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  930457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  930471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930501 */     // MIs[1] Operand 1
     /*  930501 */     // No operand predicates
     /*  930501 */     // MIs[0] round
     /*  930501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930513 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  930513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  930516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930538 */     GIR_RootConstrainSelectedInstOperands,
     /*  930539 */     // GIR_Coverage, 16067,
     /*  930539 */     GIR_EraseRootFromParent_Done,
     /*  930540 */   // Label 14107: @930540
     /*  930540 */   GIM_Try, /*On fail goto*//*Label 14108*/ GIMT_Encode4(930631), // Rule ID 16070 //
     /*  930545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  930548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  930556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  930559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  930562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930592 */     // MIs[1] Operand 1
     /*  930592 */     // No operand predicates
     /*  930592 */     // MIs[0] round
     /*  930592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  930604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930616 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930629 */     GIR_RootConstrainSelectedInstOperands,
     /*  930630 */     // GIR_Coverage, 16070,
     /*  930630 */     GIR_EraseRootFromParent_Done,
     /*  930631 */   // Label 14108: @930631
     /*  930631 */   GIM_Try, /*On fail goto*//*Label 14109*/ GIMT_Encode4(930722), // Rule ID 16071 //
     /*  930636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  930639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  930647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  930650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  930653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930683 */     // MIs[1] Operand 1
     /*  930683 */     // No operand predicates
     /*  930683 */     // MIs[0] round
     /*  930683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930695 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  930695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930720 */     GIR_RootConstrainSelectedInstOperands,
     /*  930721 */     // GIR_Coverage, 16071,
     /*  930721 */     GIR_EraseRootFromParent_Done,
     /*  930722 */   // Label 14109: @930722
     /*  930722 */   GIM_Try, /*On fail goto*//*Label 14110*/ GIMT_Encode4(930813), // Rule ID 16074 //
     /*  930727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  930730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  930738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  930741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  930744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930774 */     // MIs[1] Operand 1
     /*  930774 */     // No operand predicates
     /*  930774 */     // MIs[0] round
     /*  930774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  930786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930798 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930811 */     GIR_RootConstrainSelectedInstOperands,
     /*  930812 */     // GIR_Coverage, 16074,
     /*  930812 */     GIR_EraseRootFromParent_Done,
     /*  930813 */   // Label 14110: @930813
     /*  930813 */   GIM_Try, /*On fail goto*//*Label 14111*/ GIMT_Encode4(930904), // Rule ID 16075 //
     /*  930818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  930821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  930829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  930832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  930835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930865 */     // MIs[1] Operand 1
     /*  930865 */     // No operand predicates
     /*  930865 */     // MIs[0] round
     /*  930865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930877 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  930877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930902 */     GIR_RootConstrainSelectedInstOperands,
     /*  930903 */     // GIR_Coverage, 16075,
     /*  930903 */     GIR_EraseRootFromParent_Done,
     /*  930904 */   // Label 14111: @930904
     /*  930904 */   GIM_Try, /*On fail goto*//*Label 14112*/ GIMT_Encode4(930995), // Rule ID 16254 //
     /*  930909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  930917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  930920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  930923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  930926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930956 */     // MIs[1] Operand 1
     /*  930956 */     // No operand predicates
     /*  930956 */     // MIs[0] round
     /*  930956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930968 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  930968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  930971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930980 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930993 */     GIR_RootConstrainSelectedInstOperands,
     /*  930994 */     // GIR_Coverage, 16254,
     /*  930994 */     GIR_EraseRootFromParent_Done,
     /*  930995 */   // Label 14112: @930995
     /*  930995 */   GIM_Try, /*On fail goto*//*Label 14113*/ GIMT_Encode4(931086), // Rule ID 16255 //
     /*  931000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  931011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  931014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  931017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931047 */     // MIs[1] Operand 1
     /*  931047 */     // No operand predicates
     /*  931047 */     // MIs[0] round
     /*  931047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931059 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  931062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931084 */     GIR_RootConstrainSelectedInstOperands,
     /*  931085 */     // GIR_Coverage, 16255,
     /*  931085 */     GIR_EraseRootFromParent_Done,
     /*  931086 */   // Label 14113: @931086
     /*  931086 */   GIM_Try, /*On fail goto*//*Label 14114*/ GIMT_Encode4(931177), // Rule ID 16258 //
     /*  931091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  931102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  931105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  931108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931138 */     // MIs[1] Operand 1
     /*  931138 */     // No operand predicates
     /*  931138 */     // MIs[0] round
     /*  931138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931150 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931162 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931175 */     GIR_RootConstrainSelectedInstOperands,
     /*  931176 */     // GIR_Coverage, 16258,
     /*  931176 */     GIR_EraseRootFromParent_Done,
     /*  931177 */   // Label 14114: @931177
     /*  931177 */   GIM_Try, /*On fail goto*//*Label 14115*/ GIMT_Encode4(931268), // Rule ID 16259 //
     /*  931182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  931193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  931196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  931199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931229 */     // MIs[1] Operand 1
     /*  931229 */     // No operand predicates
     /*  931229 */     // MIs[0] round
     /*  931229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931241 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931266 */     GIR_RootConstrainSelectedInstOperands,
     /*  931267 */     // GIR_Coverage, 16259,
     /*  931267 */     GIR_EraseRootFromParent_Done,
     /*  931268 */   // Label 14115: @931268
     /*  931268 */   GIM_Try, /*On fail goto*//*Label 14116*/ GIMT_Encode4(931359), // Rule ID 16262 //
     /*  931273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  931284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  931287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  931290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931320 */     // MIs[1] Operand 1
     /*  931320 */     // No operand predicates
     /*  931320 */     // MIs[0] round
     /*  931320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931332 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931344 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931357 */     GIR_RootConstrainSelectedInstOperands,
     /*  931358 */     // GIR_Coverage, 16262,
     /*  931358 */     GIR_EraseRootFromParent_Done,
     /*  931359 */   // Label 14116: @931359
     /*  931359 */   GIM_Try, /*On fail goto*//*Label 14117*/ GIMT_Encode4(931450), // Rule ID 16263 //
     /*  931364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  931375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  931378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  931381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931411 */     // MIs[1] Operand 1
     /*  931411 */     // No operand predicates
     /*  931411 */     // MIs[0] round
     /*  931411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931423 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931448 */     GIR_RootConstrainSelectedInstOperands,
     /*  931449 */     // GIR_Coverage, 16263,
     /*  931449 */     GIR_EraseRootFromParent_Done,
     /*  931450 */   // Label 14117: @931450
     /*  931450 */   GIM_Try, /*On fail goto*//*Label 14118*/ GIMT_Encode4(931541), // Rule ID 16266 //
     /*  931455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  931466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  931469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  931472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931502 */     // MIs[1] Operand 1
     /*  931502 */     // No operand predicates
     /*  931502 */     // MIs[0] round
     /*  931502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931514 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  931514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931539 */     GIR_RootConstrainSelectedInstOperands,
     /*  931540 */     // GIR_Coverage, 16266,
     /*  931540 */     GIR_EraseRootFromParent_Done,
     /*  931541 */   // Label 14118: @931541
     /*  931541 */   GIM_Try, /*On fail goto*//*Label 14119*/ GIMT_Encode4(931632), // Rule ID 16267 //
     /*  931546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  931557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  931560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  931563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931593 */     // MIs[1] Operand 1
     /*  931593 */     // No operand predicates
     /*  931593 */     // MIs[0] round
     /*  931593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931605 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  931605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931630 */     GIR_RootConstrainSelectedInstOperands,
     /*  931631 */     // GIR_Coverage, 16267,
     /*  931631 */     GIR_EraseRootFromParent_Done,
     /*  931632 */   // Label 14119: @931632
     /*  931632 */   GIM_Try, /*On fail goto*//*Label 14120*/ GIMT_Encode4(931723), // Rule ID 16270 //
     /*  931637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  931648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  931651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  931654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931684 */     // MIs[1] Operand 1
     /*  931684 */     // No operand predicates
     /*  931684 */     // MIs[0] round
     /*  931684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  931696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931708 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931721 */     GIR_RootConstrainSelectedInstOperands,
     /*  931722 */     // GIR_Coverage, 16270,
     /*  931722 */     GIR_EraseRootFromParent_Done,
     /*  931723 */   // Label 14120: @931723
     /*  931723 */   GIM_Try, /*On fail goto*//*Label 14121*/ GIMT_Encode4(931814), // Rule ID 16271 //
     /*  931728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  931739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  931742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  931745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931775 */     // MIs[1] Operand 1
     /*  931775 */     // No operand predicates
     /*  931775 */     // MIs[0] round
     /*  931775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931787 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  931787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931812 */     GIR_RootConstrainSelectedInstOperands,
     /*  931813 */     // GIR_Coverage, 16271,
     /*  931813 */     GIR_EraseRootFromParent_Done,
     /*  931814 */   // Label 14121: @931814
     /*  931814 */   GIM_Try, /*On fail goto*//*Label 14122*/ GIMT_Encode4(931905), // Rule ID 16274 //
     /*  931819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  931830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  931833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  931836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931866 */     // MIs[1] Operand 1
     /*  931866 */     // No operand predicates
     /*  931866 */     // MIs[0] round
     /*  931866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931878 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  931878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931890 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931903 */     GIR_RootConstrainSelectedInstOperands,
     /*  931904 */     // GIR_Coverage, 16274,
     /*  931904 */     GIR_EraseRootFromParent_Done,
     /*  931905 */   // Label 14122: @931905
     /*  931905 */   GIM_Try, /*On fail goto*//*Label 14123*/ GIMT_Encode4(931996), // Rule ID 16275 //
     /*  931910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  931921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  931924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  931927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931957 */     // MIs[1] Operand 1
     /*  931957 */     // No operand predicates
     /*  931957 */     // MIs[0] round
     /*  931957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931969 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  931969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931994 */     GIR_RootConstrainSelectedInstOperands,
     /*  931995 */     // GIR_Coverage, 16275,
     /*  931995 */     GIR_EraseRootFromParent_Done,
     /*  931996 */   // Label 14123: @931996
     /*  931996 */   GIM_Try, /*On fail goto*//*Label 14124*/ GIMT_Encode4(932087), // Rule ID 16278 //
     /*  932001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  932012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  932015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  932018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932048 */     // MIs[1] Operand 1
     /*  932048 */     // No operand predicates
     /*  932048 */     // MIs[0] round
     /*  932048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932060 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932072 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932085 */     GIR_RootConstrainSelectedInstOperands,
     /*  932086 */     // GIR_Coverage, 16278,
     /*  932086 */     GIR_EraseRootFromParent_Done,
     /*  932087 */   // Label 14124: @932087
     /*  932087 */   GIM_Try, /*On fail goto*//*Label 14125*/ GIMT_Encode4(932178), // Rule ID 16279 //
     /*  932092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  932103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  932106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  932109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932139 */     // MIs[1] Operand 1
     /*  932139 */     // No operand predicates
     /*  932139 */     // MIs[0] round
     /*  932139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932151 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  932151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932176 */     GIR_RootConstrainSelectedInstOperands,
     /*  932177 */     // GIR_Coverage, 16279,
     /*  932177 */     GIR_EraseRootFromParent_Done,
     /*  932178 */   // Label 14125: @932178
     /*  932178 */   GIM_Try, /*On fail goto*//*Label 14126*/ GIMT_Encode4(932269), // Rule ID 16282 //
     /*  932183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  932194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  932197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  932200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932230 */     // MIs[1] Operand 1
     /*  932230 */     // No operand predicates
     /*  932230 */     // MIs[0] round
     /*  932230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932242 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  932242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932254 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932267 */     GIR_RootConstrainSelectedInstOperands,
     /*  932268 */     // GIR_Coverage, 16282,
     /*  932268 */     GIR_EraseRootFromParent_Done,
     /*  932269 */   // Label 14126: @932269
     /*  932269 */   GIM_Try, /*On fail goto*//*Label 14127*/ GIMT_Encode4(932360), // Rule ID 16283 //
     /*  932274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  932285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  932288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  932291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932321 */     // MIs[1] Operand 1
     /*  932321 */     // No operand predicates
     /*  932321 */     // MIs[0] round
     /*  932321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932333 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  932333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932358 */     GIR_RootConstrainSelectedInstOperands,
     /*  932359 */     // GIR_Coverage, 16283,
     /*  932359 */     GIR_EraseRootFromParent_Done,
     /*  932360 */   // Label 14127: @932360
     /*  932360 */   GIM_Try, /*On fail goto*//*Label 14128*/ GIMT_Encode4(932451), // Rule ID 16286 //
     /*  932365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  932376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  932379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  932382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932412 */     // MIs[1] Operand 1
     /*  932412 */     // No operand predicates
     /*  932412 */     // MIs[0] round
     /*  932412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932424 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  932424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932436 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932449 */     GIR_RootConstrainSelectedInstOperands,
     /*  932450 */     // GIR_Coverage, 16286,
     /*  932450 */     GIR_EraseRootFromParent_Done,
     /*  932451 */   // Label 14128: @932451
     /*  932451 */   GIM_Try, /*On fail goto*//*Label 14129*/ GIMT_Encode4(932542), // Rule ID 16287 //
     /*  932456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  932467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  932470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  932473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932503 */     // MIs[1] Operand 1
     /*  932503 */     // No operand predicates
     /*  932503 */     // MIs[0] round
     /*  932503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932515 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  932515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932540 */     GIR_RootConstrainSelectedInstOperands,
     /*  932541 */     // GIR_Coverage, 16287,
     /*  932541 */     GIR_EraseRootFromParent_Done,
     /*  932542 */   // Label 14129: @932542
     /*  932542 */   GIM_Try, /*On fail goto*//*Label 14130*/ GIMT_Encode4(932633), // Rule ID 16290 //
     /*  932547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  932550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  932558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  932561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  932564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932594 */     // MIs[1] Operand 1
     /*  932594 */     // No operand predicates
     /*  932594 */     // MIs[0] round
     /*  932594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932606 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  932606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932618 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  932628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932631 */     GIR_RootConstrainSelectedInstOperands,
     /*  932632 */     // GIR_Coverage, 16290,
     /*  932632 */     GIR_EraseRootFromParent_Done,
     /*  932633 */   // Label 14130: @932633
     /*  932633 */   GIM_Try, /*On fail goto*//*Label 14131*/ GIMT_Encode4(932724), // Rule ID 16291 //
     /*  932638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  932641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  932649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  932652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  932655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932685 */     // MIs[1] Operand 1
     /*  932685 */     // No operand predicates
     /*  932685 */     // MIs[0] round
     /*  932685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932697 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  932697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  932719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932722 */     GIR_RootConstrainSelectedInstOperands,
     /*  932723 */     // GIR_Coverage, 16291,
     /*  932723 */     GIR_EraseRootFromParent_Done,
     /*  932724 */   // Label 14131: @932724
     /*  932724 */   GIM_Try, /*On fail goto*//*Label 14132*/ GIMT_Encode4(932815), // Rule ID 16294 //
     /*  932729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  932740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  932743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  932746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932776 */     // MIs[1] Operand 1
     /*  932776 */     // No operand predicates
     /*  932776 */     // MIs[0] round
     /*  932776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932788 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  932791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932800 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932813 */     GIR_RootConstrainSelectedInstOperands,
     /*  932814 */     // GIR_Coverage, 16294,
     /*  932814 */     GIR_EraseRootFromParent_Done,
     /*  932815 */   // Label 14132: @932815
     /*  932815 */   GIM_Try, /*On fail goto*//*Label 14133*/ GIMT_Encode4(932906), // Rule ID 16295 //
     /*  932820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  932831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  932834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  932837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932867 */     // MIs[1] Operand 1
     /*  932867 */     // No operand predicates
     /*  932867 */     // MIs[0] round
     /*  932867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932879 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  932879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  932882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932904 */     GIR_RootConstrainSelectedInstOperands,
     /*  932905 */     // GIR_Coverage, 16295,
     /*  932905 */     GIR_EraseRootFromParent_Done,
     /*  932906 */   // Label 14133: @932906
     /*  932906 */   GIM_Try, /*On fail goto*//*Label 14134*/ GIMT_Encode4(932997), // Rule ID 16298 //
     /*  932911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  932922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  932925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  932928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932958 */     // MIs[1] Operand 1
     /*  932958 */     // No operand predicates
     /*  932958 */     // MIs[0] round
     /*  932958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932970 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  932973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932982 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932995 */     GIR_RootConstrainSelectedInstOperands,
     /*  932996 */     // GIR_Coverage, 16298,
     /*  932996 */     GIR_EraseRootFromParent_Done,
     /*  932997 */   // Label 14134: @932997
     /*  932997 */   GIM_Try, /*On fail goto*//*Label 14135*/ GIMT_Encode4(933088), // Rule ID 16299 //
     /*  933002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  933013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  933016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  933019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933049 */     // MIs[1] Operand 1
     /*  933049 */     // No operand predicates
     /*  933049 */     // MIs[0] round
     /*  933049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933061 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  933061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933086 */     GIR_RootConstrainSelectedInstOperands,
     /*  933087 */     // GIR_Coverage, 16299,
     /*  933087 */     GIR_EraseRootFromParent_Done,
     /*  933088 */   // Label 14135: @933088
     /*  933088 */   GIM_Try, /*On fail goto*//*Label 14136*/ GIMT_Encode4(933179), // Rule ID 16302 //
     /*  933093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  933104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  933107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  933110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933140 */     // MIs[1] Operand 1
     /*  933140 */     // No operand predicates
     /*  933140 */     // MIs[0] round
     /*  933140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933152 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  933152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933164 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933177 */     GIR_RootConstrainSelectedInstOperands,
     /*  933178 */     // GIR_Coverage, 16302,
     /*  933178 */     GIR_EraseRootFromParent_Done,
     /*  933179 */   // Label 14136: @933179
     /*  933179 */   GIM_Try, /*On fail goto*//*Label 14137*/ GIMT_Encode4(933270), // Rule ID 16303 //
     /*  933184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  933195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  933198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  933201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933231 */     // MIs[1] Operand 1
     /*  933231 */     // No operand predicates
     /*  933231 */     // MIs[0] round
     /*  933231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933243 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  933243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933268 */     GIR_RootConstrainSelectedInstOperands,
     /*  933269 */     // GIR_Coverage, 16303,
     /*  933269 */     GIR_EraseRootFromParent_Done,
     /*  933270 */   // Label 14137: @933270
     /*  933270 */   GIM_Try, /*On fail goto*//*Label 14138*/ GIMT_Encode4(933361), // Rule ID 16306 //
     /*  933275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  933286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  933289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  933292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933322 */     // MIs[1] Operand 1
     /*  933322 */     // No operand predicates
     /*  933322 */     // MIs[0] round
     /*  933322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933346 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933359 */     GIR_RootConstrainSelectedInstOperands,
     /*  933360 */     // GIR_Coverage, 16306,
     /*  933360 */     GIR_EraseRootFromParent_Done,
     /*  933361 */   // Label 14138: @933361
     /*  933361 */   GIM_Try, /*On fail goto*//*Label 14139*/ GIMT_Encode4(933452), // Rule ID 16307 //
     /*  933366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  933377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  933380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  933383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933413 */     // MIs[1] Operand 1
     /*  933413 */     // No operand predicates
     /*  933413 */     // MIs[0] round
     /*  933413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933425 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933450 */     GIR_RootConstrainSelectedInstOperands,
     /*  933451 */     // GIR_Coverage, 16307,
     /*  933451 */     GIR_EraseRootFromParent_Done,
     /*  933452 */   // Label 14139: @933452
     /*  933452 */   GIM_Try, /*On fail goto*//*Label 14140*/ GIMT_Encode4(933543), // Rule ID 16310 //
     /*  933457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  933468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  933471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  933474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933504 */     // MIs[1] Operand 1
     /*  933504 */     // No operand predicates
     /*  933504 */     // MIs[0] round
     /*  933504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933516 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933528 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933541 */     GIR_RootConstrainSelectedInstOperands,
     /*  933542 */     // GIR_Coverage, 16310,
     /*  933542 */     GIR_EraseRootFromParent_Done,
     /*  933543 */   // Label 14140: @933543
     /*  933543 */   GIM_Try, /*On fail goto*//*Label 14141*/ GIMT_Encode4(933634), // Rule ID 16311 //
     /*  933548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  933559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  933562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  933565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933595 */     // MIs[1] Operand 1
     /*  933595 */     // No operand predicates
     /*  933595 */     // MIs[0] round
     /*  933595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933607 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933632 */     GIR_RootConstrainSelectedInstOperands,
     /*  933633 */     // GIR_Coverage, 16311,
     /*  933633 */     GIR_EraseRootFromParent_Done,
     /*  933634 */   // Label 14141: @933634
     /*  933634 */   GIM_Try, /*On fail goto*//*Label 14142*/ GIMT_Encode4(933725), // Rule ID 16314 //
     /*  933639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  933650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  933653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  933656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933686 */     // MIs[1] Operand 1
     /*  933686 */     // No operand predicates
     /*  933686 */     // MIs[0] round
     /*  933686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933698 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933723 */     GIR_RootConstrainSelectedInstOperands,
     /*  933724 */     // GIR_Coverage, 16314,
     /*  933724 */     GIR_EraseRootFromParent_Done,
     /*  933725 */   // Label 14142: @933725
     /*  933725 */   GIM_Try, /*On fail goto*//*Label 14143*/ GIMT_Encode4(933816), // Rule ID 16315 //
     /*  933730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  933741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  933744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  933747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933777 */     // MIs[1] Operand 1
     /*  933777 */     // No operand predicates
     /*  933777 */     // MIs[0] round
     /*  933777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933789 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933814 */     GIR_RootConstrainSelectedInstOperands,
     /*  933815 */     // GIR_Coverage, 16315,
     /*  933815 */     GIR_EraseRootFromParent_Done,
     /*  933816 */   // Label 14143: @933816
     /*  933816 */   GIM_Try, /*On fail goto*//*Label 14144*/ GIMT_Encode4(933907), // Rule ID 16318 //
     /*  933821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  933832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  933835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  933838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933868 */     // MIs[1] Operand 1
     /*  933868 */     // No operand predicates
     /*  933868 */     // MIs[0] round
     /*  933868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  933880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933892 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933905 */     GIR_RootConstrainSelectedInstOperands,
     /*  933906 */     // GIR_Coverage, 16318,
     /*  933906 */     GIR_EraseRootFromParent_Done,
     /*  933907 */   // Label 14144: @933907
     /*  933907 */   GIM_Try, /*On fail goto*//*Label 14145*/ GIMT_Encode4(933998), // Rule ID 16319 //
     /*  933912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  933923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  933926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  933929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933959 */     // MIs[1] Operand 1
     /*  933959 */     // No operand predicates
     /*  933959 */     // MIs[0] round
     /*  933959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  933971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933996 */     GIR_RootConstrainSelectedInstOperands,
     /*  933997 */     // GIR_Coverage, 16319,
     /*  933997 */     GIR_EraseRootFromParent_Done,
     /*  933998 */   // Label 14145: @933998
     /*  933998 */   GIM_Try, /*On fail goto*//*Label 14146*/ GIMT_Encode4(934089), // Rule ID 16322 //
     /*  934003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  934014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  934017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  934020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934050 */     // MIs[1] Operand 1
     /*  934050 */     // No operand predicates
     /*  934050 */     // MIs[0] round
     /*  934050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934062 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  934062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934074 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934087 */     GIR_RootConstrainSelectedInstOperands,
     /*  934088 */     // GIR_Coverage, 16322,
     /*  934088 */     GIR_EraseRootFromParent_Done,
     /*  934089 */   // Label 14146: @934089
     /*  934089 */   GIM_Try, /*On fail goto*//*Label 14147*/ GIMT_Encode4(934180), // Rule ID 16323 //
     /*  934094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  934105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  934108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  934111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934141 */     // MIs[1] Operand 1
     /*  934141 */     // No operand predicates
     /*  934141 */     // MIs[0] round
     /*  934141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934153 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  934153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934178 */     GIR_RootConstrainSelectedInstOperands,
     /*  934179 */     // GIR_Coverage, 16323,
     /*  934179 */     GIR_EraseRootFromParent_Done,
     /*  934180 */   // Label 14147: @934180
     /*  934180 */   GIM_Try, /*On fail goto*//*Label 14148*/ GIMT_Encode4(934271), // Rule ID 16326 //
     /*  934185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  934196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  934199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  934202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934232 */     // MIs[1] Operand 1
     /*  934232 */     // No operand predicates
     /*  934232 */     // MIs[0] round
     /*  934232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934244 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  934244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934256 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934269 */     GIR_RootConstrainSelectedInstOperands,
     /*  934270 */     // GIR_Coverage, 16326,
     /*  934270 */     GIR_EraseRootFromParent_Done,
     /*  934271 */   // Label 14148: @934271
     /*  934271 */   GIM_Try, /*On fail goto*//*Label 14149*/ GIMT_Encode4(934362), // Rule ID 16327 //
     /*  934276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  934287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  934290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  934293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934323 */     // MIs[1] Operand 1
     /*  934323 */     // No operand predicates
     /*  934323 */     // MIs[0] round
     /*  934323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934335 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  934335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934360 */     GIR_RootConstrainSelectedInstOperands,
     /*  934361 */     // GIR_Coverage, 16327,
     /*  934361 */     GIR_EraseRootFromParent_Done,
     /*  934362 */   // Label 14149: @934362
     /*  934362 */   GIM_Try, /*On fail goto*//*Label 14150*/ GIMT_Encode4(934453), // Rule ID 16330 //
     /*  934367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  934378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  934381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  934384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934414 */     // MIs[1] Operand 1
     /*  934414 */     // No operand predicates
     /*  934414 */     // MIs[0] round
     /*  934414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  934429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934438 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934451 */     GIR_RootConstrainSelectedInstOperands,
     /*  934452 */     // GIR_Coverage, 16330,
     /*  934452 */     GIR_EraseRootFromParent_Done,
     /*  934453 */   // Label 14150: @934453
     /*  934453 */   GIM_Try, /*On fail goto*//*Label 14151*/ GIMT_Encode4(934544), // Rule ID 16331 //
     /*  934458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  934469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  934472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  934475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934505 */     // MIs[1] Operand 1
     /*  934505 */     // No operand predicates
     /*  934505 */     // MIs[0] round
     /*  934505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934517 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  934520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934542 */     GIR_RootConstrainSelectedInstOperands,
     /*  934543 */     // GIR_Coverage, 16331,
     /*  934543 */     GIR_EraseRootFromParent_Done,
     /*  934544 */   // Label 14151: @934544
     /*  934544 */   GIM_Try, /*On fail goto*//*Label 14152*/ GIMT_Encode4(934635), // Rule ID 16334 //
     /*  934549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  934560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  934563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  934566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934596 */     // MIs[1] Operand 1
     /*  934596 */     // No operand predicates
     /*  934596 */     // MIs[0] round
     /*  934596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934608 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934620 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934633 */     GIR_RootConstrainSelectedInstOperands,
     /*  934634 */     // GIR_Coverage, 16334,
     /*  934634 */     GIR_EraseRootFromParent_Done,
     /*  934635 */   // Label 14152: @934635
     /*  934635 */   GIM_Try, /*On fail goto*//*Label 14153*/ GIMT_Encode4(934726), // Rule ID 16335 //
     /*  934640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  934651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  934654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  934657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934687 */     // MIs[1] Operand 1
     /*  934687 */     // No operand predicates
     /*  934687 */     // MIs[0] round
     /*  934687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934699 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934724 */     GIR_RootConstrainSelectedInstOperands,
     /*  934725 */     // GIR_Coverage, 16335,
     /*  934725 */     GIR_EraseRootFromParent_Done,
     /*  934726 */   // Label 14153: @934726
     /*  934726 */   GIM_Try, /*On fail goto*//*Label 14154*/ GIMT_Encode4(934817), // Rule ID 16338 //
     /*  934731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  934742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  934745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  934748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934778 */     // MIs[1] Operand 1
     /*  934778 */     // No operand predicates
     /*  934778 */     // MIs[0] round
     /*  934778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934790 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934802 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934815 */     GIR_RootConstrainSelectedInstOperands,
     /*  934816 */     // GIR_Coverage, 16338,
     /*  934816 */     GIR_EraseRootFromParent_Done,
     /*  934817 */   // Label 14154: @934817
     /*  934817 */   GIM_Try, /*On fail goto*//*Label 14155*/ GIMT_Encode4(934908), // Rule ID 16339 //
     /*  934822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  934833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  934836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  934839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934869 */     // MIs[1] Operand 1
     /*  934869 */     // No operand predicates
     /*  934869 */     // MIs[0] round
     /*  934869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934881 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934906 */     GIR_RootConstrainSelectedInstOperands,
     /*  934907 */     // GIR_Coverage, 16339,
     /*  934907 */     GIR_EraseRootFromParent_Done,
     /*  934908 */   // Label 14155: @934908
     /*  934908 */   GIM_Try, /*On fail goto*//*Label 14156*/ GIMT_Encode4(935002), // Rule ID 16462 //
     /*  934913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  934921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  934924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  934927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  934930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934960 */     // MIs[1] Operand 1
     /*  934960 */     // No operand predicates
     /*  934960 */     // MIs[0] round
     /*  934960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934972 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  934972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  934975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934984 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935000 */     GIR_RootConstrainSelectedInstOperands,
     /*  935001 */     // GIR_Coverage, 16462,
     /*  935001 */     GIR_EraseRootFromParent_Done,
     /*  935002 */   // Label 14156: @935002
     /*  935002 */   GIM_Try, /*On fail goto*//*Label 14157*/ GIMT_Encode4(935096), // Rule ID 16463 //
     /*  935007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  935018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  935021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  935024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935054 */     // MIs[1] Operand 1
     /*  935054 */     // No operand predicates
     /*  935054 */     // MIs[0] round
     /*  935054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935066 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  935069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935078 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935094 */     GIR_RootConstrainSelectedInstOperands,
     /*  935095 */     // GIR_Coverage, 16463,
     /*  935095 */     GIR_EraseRootFromParent_Done,
     /*  935096 */   // Label 14157: @935096
     /*  935096 */   GIM_Try, /*On fail goto*//*Label 14158*/ GIMT_Encode4(935190), // Rule ID 16466 //
     /*  935101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  935112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  935115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  935118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935148 */     // MIs[1] Operand 1
     /*  935148 */     // No operand predicates
     /*  935148 */     // MIs[0] round
     /*  935148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935160 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  935163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935172 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935188 */     GIR_RootConstrainSelectedInstOperands,
     /*  935189 */     // GIR_Coverage, 16466,
     /*  935189 */     GIR_EraseRootFromParent_Done,
     /*  935190 */   // Label 14158: @935190
     /*  935190 */   GIM_Try, /*On fail goto*//*Label 14159*/ GIMT_Encode4(935284), // Rule ID 16467 //
     /*  935195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  935206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  935209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  935212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935242 */     // MIs[1] Operand 1
     /*  935242 */     // No operand predicates
     /*  935242 */     // MIs[0] round
     /*  935242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935254 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  935257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935266 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935282 */     GIR_RootConstrainSelectedInstOperands,
     /*  935283 */     // GIR_Coverage, 16467,
     /*  935283 */     GIR_EraseRootFromParent_Done,
     /*  935284 */   // Label 14159: @935284
     /*  935284 */   GIM_Try, /*On fail goto*//*Label 14160*/ GIMT_Encode4(935378), // Rule ID 16470 //
     /*  935289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  935300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  935303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  935306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935336 */     // MIs[1] Operand 1
     /*  935336 */     // No operand predicates
     /*  935336 */     // MIs[0] round
     /*  935336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935348 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  935351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935360 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935376 */     GIR_RootConstrainSelectedInstOperands,
     /*  935377 */     // GIR_Coverage, 16470,
     /*  935377 */     GIR_EraseRootFromParent_Done,
     /*  935378 */   // Label 14160: @935378
     /*  935378 */   GIM_Try, /*On fail goto*//*Label 14161*/ GIMT_Encode4(935472), // Rule ID 16471 //
     /*  935383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  935394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  935397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  935400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935430 */     // MIs[1] Operand 1
     /*  935430 */     // No operand predicates
     /*  935430 */     // MIs[0] round
     /*  935430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935442 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  935445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935454 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935470 */     GIR_RootConstrainSelectedInstOperands,
     /*  935471 */     // GIR_Coverage, 16471,
     /*  935471 */     GIR_EraseRootFromParent_Done,
     /*  935472 */   // Label 14161: @935472
     /*  935472 */   GIM_Try, /*On fail goto*//*Label 14162*/ GIMT_Encode4(935566), // Rule ID 16474 //
     /*  935477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  935488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  935491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  935494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935524 */     // MIs[1] Operand 1
     /*  935524 */     // No operand predicates
     /*  935524 */     // MIs[0] round
     /*  935524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935536 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  935539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935548 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935564 */     GIR_RootConstrainSelectedInstOperands,
     /*  935565 */     // GIR_Coverage, 16474,
     /*  935565 */     GIR_EraseRootFromParent_Done,
     /*  935566 */   // Label 14162: @935566
     /*  935566 */   GIM_Try, /*On fail goto*//*Label 14163*/ GIMT_Encode4(935660), // Rule ID 16475 //
     /*  935571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  935582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  935585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  935588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935618 */     // MIs[1] Operand 1
     /*  935618 */     // No operand predicates
     /*  935618 */     // MIs[0] round
     /*  935618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935630 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  935633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935642 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935658 */     GIR_RootConstrainSelectedInstOperands,
     /*  935659 */     // GIR_Coverage, 16475,
     /*  935659 */     GIR_EraseRootFromParent_Done,
     /*  935660 */   // Label 14163: @935660
     /*  935660 */   GIM_Try, /*On fail goto*//*Label 14164*/ GIMT_Encode4(935754), // Rule ID 16478 //
     /*  935665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  935676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  935679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  935682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935712 */     // MIs[1] Operand 1
     /*  935712 */     // No operand predicates
     /*  935712 */     // MIs[0] round
     /*  935712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935724 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  935727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935736 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935752 */     GIR_RootConstrainSelectedInstOperands,
     /*  935753 */     // GIR_Coverage, 16478,
     /*  935753 */     GIR_EraseRootFromParent_Done,
     /*  935754 */   // Label 14164: @935754
     /*  935754 */   GIM_Try, /*On fail goto*//*Label 14165*/ GIMT_Encode4(935848), // Rule ID 16479 //
     /*  935759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  935770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  935773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  935776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935806 */     // MIs[1] Operand 1
     /*  935806 */     // No operand predicates
     /*  935806 */     // MIs[0] round
     /*  935806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  935821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935846 */     GIR_RootConstrainSelectedInstOperands,
     /*  935847 */     // GIR_Coverage, 16479,
     /*  935847 */     GIR_EraseRootFromParent_Done,
     /*  935848 */   // Label 14165: @935848
     /*  935848 */   GIM_Try, /*On fail goto*//*Label 14166*/ GIMT_Encode4(935942), // Rule ID 16482 //
     /*  935853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  935864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  935867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  935870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935900 */     // MIs[1] Operand 1
     /*  935900 */     // No operand predicates
     /*  935900 */     // MIs[0] round
     /*  935900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935912 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  935915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935924 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935940 */     GIR_RootConstrainSelectedInstOperands,
     /*  935941 */     // GIR_Coverage, 16482,
     /*  935941 */     GIR_EraseRootFromParent_Done,
     /*  935942 */   // Label 14166: @935942
     /*  935942 */   GIM_Try, /*On fail goto*//*Label 14167*/ GIMT_Encode4(936036), // Rule ID 16483 //
     /*  935947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  935958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  935961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  935964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935994 */     // MIs[1] Operand 1
     /*  935994 */     // No operand predicates
     /*  935994 */     // MIs[0] round
     /*  935994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936006 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  936006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  936009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936018 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936034 */     GIR_RootConstrainSelectedInstOperands,
     /*  936035 */     // GIR_Coverage, 16483,
     /*  936035 */     GIR_EraseRootFromParent_Done,
     /*  936036 */   // Label 14167: @936036
     /*  936036 */   GIM_Try, /*On fail goto*//*Label 14168*/ GIMT_Encode4(936130), // Rule ID 16486 //
     /*  936041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  936052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  936055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  936058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936088 */     // MIs[1] Operand 1
     /*  936088 */     // No operand predicates
     /*  936088 */     // MIs[0] round
     /*  936088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936100 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  936103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936112 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936128 */     GIR_RootConstrainSelectedInstOperands,
     /*  936129 */     // GIR_Coverage, 16486,
     /*  936129 */     GIR_EraseRootFromParent_Done,
     /*  936130 */   // Label 14168: @936130
     /*  936130 */   GIM_Try, /*On fail goto*//*Label 14169*/ GIMT_Encode4(936224), // Rule ID 16487 //
     /*  936135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  936146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  936149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  936152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936182 */     // MIs[1] Operand 1
     /*  936182 */     // No operand predicates
     /*  936182 */     // MIs[0] round
     /*  936182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  936197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936222 */     GIR_RootConstrainSelectedInstOperands,
     /*  936223 */     // GIR_Coverage, 16487,
     /*  936223 */     GIR_EraseRootFromParent_Done,
     /*  936224 */   // Label 14169: @936224
     /*  936224 */   GIM_Try, /*On fail goto*//*Label 14170*/ GIMT_Encode4(936318), // Rule ID 16490 //
     /*  936229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  936240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  936243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  936246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936276 */     // MIs[1] Operand 1
     /*  936276 */     // No operand predicates
     /*  936276 */     // MIs[0] round
     /*  936276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936288 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  936291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936300 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936316 */     GIR_RootConstrainSelectedInstOperands,
     /*  936317 */     // GIR_Coverage, 16490,
     /*  936317 */     GIR_EraseRootFromParent_Done,
     /*  936318 */   // Label 14170: @936318
     /*  936318 */   GIM_Try, /*On fail goto*//*Label 14171*/ GIMT_Encode4(936412), // Rule ID 16491 //
     /*  936323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  936334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  936337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  936340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936370 */     // MIs[1] Operand 1
     /*  936370 */     // No operand predicates
     /*  936370 */     // MIs[0] round
     /*  936370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  936385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936394 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936410 */     GIR_RootConstrainSelectedInstOperands,
     /*  936411 */     // GIR_Coverage, 16491,
     /*  936411 */     GIR_EraseRootFromParent_Done,
     /*  936412 */   // Label 14171: @936412
     /*  936412 */   GIM_Try, /*On fail goto*//*Label 14172*/ GIMT_Encode4(936506), // Rule ID 16494 //
     /*  936417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  936428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  936431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  936434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936464 */     // MIs[1] Operand 1
     /*  936464 */     // No operand predicates
     /*  936464 */     // MIs[0] round
     /*  936464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  936479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936488 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936504 */     GIR_RootConstrainSelectedInstOperands,
     /*  936505 */     // GIR_Coverage, 16494,
     /*  936505 */     GIR_EraseRootFromParent_Done,
     /*  936506 */   // Label 14172: @936506
     /*  936506 */   GIM_Try, /*On fail goto*//*Label 14173*/ GIMT_Encode4(936600), // Rule ID 16495 //
     /*  936511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  936522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  936525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  936528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936558 */     // MIs[1] Operand 1
     /*  936558 */     // No operand predicates
     /*  936558 */     // MIs[0] round
     /*  936558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936570 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  936573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936582 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936598 */     GIR_RootConstrainSelectedInstOperands,
     /*  936599 */     // GIR_Coverage, 16495,
     /*  936599 */     GIR_EraseRootFromParent_Done,
     /*  936600 */   // Label 14173: @936600
     /*  936600 */   GIM_Try, /*On fail goto*//*Label 14174*/ GIMT_Encode4(936694), // Rule ID 16498 //
     /*  936605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  936616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  936619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  936622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936652 */     // MIs[1] Operand 1
     /*  936652 */     // No operand predicates
     /*  936652 */     // MIs[0] round
     /*  936652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936664 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  936667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936676 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936692 */     GIR_RootConstrainSelectedInstOperands,
     /*  936693 */     // GIR_Coverage, 16498,
     /*  936693 */     GIR_EraseRootFromParent_Done,
     /*  936694 */   // Label 14174: @936694
     /*  936694 */   GIM_Try, /*On fail goto*//*Label 14175*/ GIMT_Encode4(936788), // Rule ID 16499 //
     /*  936699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  936710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  936713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  936716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936746 */     // MIs[1] Operand 1
     /*  936746 */     // No operand predicates
     /*  936746 */     // MIs[0] round
     /*  936746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936758 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  936761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936770 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936786 */     GIR_RootConstrainSelectedInstOperands,
     /*  936787 */     // GIR_Coverage, 16499,
     /*  936787 */     GIR_EraseRootFromParent_Done,
     /*  936788 */   // Label 14175: @936788
     /*  936788 */   GIM_Try, /*On fail goto*//*Label 14176*/ GIMT_Encode4(936882), // Rule ID 16502 //
     /*  936793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  936804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  936807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  936810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936840 */     // MIs[1] Operand 1
     /*  936840 */     // No operand predicates
     /*  936840 */     // MIs[0] round
     /*  936840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936852 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  936855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936864 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936880 */     GIR_RootConstrainSelectedInstOperands,
     /*  936881 */     // GIR_Coverage, 16502,
     /*  936881 */     GIR_EraseRootFromParent_Done,
     /*  936882 */   // Label 14176: @936882
     /*  936882 */   GIM_Try, /*On fail goto*//*Label 14177*/ GIMT_Encode4(936976), // Rule ID 16503 //
     /*  936887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  936898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  936901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  936904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936934 */     // MIs[1] Operand 1
     /*  936934 */     // No operand predicates
     /*  936934 */     // MIs[0] round
     /*  936934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936946 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  936949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936958 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936974 */     GIR_RootConstrainSelectedInstOperands,
     /*  936975 */     // GIR_Coverage, 16503,
     /*  936975 */     GIR_EraseRootFromParent_Done,
     /*  936976 */   // Label 14177: @936976
     /*  936976 */   GIM_Try, /*On fail goto*//*Label 14178*/ GIMT_Encode4(937070), // Rule ID 16506 //
     /*  936981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  936984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  936992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  936995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  936998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937024 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937028 */     // MIs[1] Operand 1
     /*  937028 */     // No operand predicates
     /*  937028 */     // MIs[0] round
     /*  937028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937040 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  937043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937052 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937068 */     GIR_RootConstrainSelectedInstOperands,
     /*  937069 */     // GIR_Coverage, 16506,
     /*  937069 */     GIR_EraseRootFromParent_Done,
     /*  937070 */   // Label 14178: @937070
     /*  937070 */   GIM_Try, /*On fail goto*//*Label 14179*/ GIMT_Encode4(937164), // Rule ID 16507 //
     /*  937075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  937086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  937089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  937092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937122 */     // MIs[1] Operand 1
     /*  937122 */     // No operand predicates
     /*  937122 */     // MIs[0] round
     /*  937122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937134 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  937137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937146 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937162 */     GIR_RootConstrainSelectedInstOperands,
     /*  937163 */     // GIR_Coverage, 16507,
     /*  937163 */     GIR_EraseRootFromParent_Done,
     /*  937164 */   // Label 14179: @937164
     /*  937164 */   GIM_Try, /*On fail goto*//*Label 14180*/ GIMT_Encode4(937258), // Rule ID 16510 //
     /*  937169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  937172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  937180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  937183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  937186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937216 */     // MIs[1] Operand 1
     /*  937216 */     // No operand predicates
     /*  937216 */     // MIs[0] round
     /*  937216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937228 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  937231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937240 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937256 */     GIR_RootConstrainSelectedInstOperands,
     /*  937257 */     // GIR_Coverage, 16510,
     /*  937257 */     GIR_EraseRootFromParent_Done,
     /*  937258 */   // Label 14180: @937258
     /*  937258 */   GIM_Try, /*On fail goto*//*Label 14181*/ GIMT_Encode4(937352), // Rule ID 16511 //
     /*  937263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  937274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  937277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  937280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937310 */     // MIs[1] Operand 1
     /*  937310 */     // No operand predicates
     /*  937310 */     // MIs[0] round
     /*  937310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  937325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937334 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937350 */     GIR_RootConstrainSelectedInstOperands,
     /*  937351 */     // GIR_Coverage, 16511,
     /*  937351 */     GIR_EraseRootFromParent_Done,
     /*  937352 */   // Label 14181: @937352
     /*  937352 */   GIM_Try, /*On fail goto*//*Label 14182*/ GIMT_Encode4(937446), // Rule ID 16514 //
     /*  937357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  937360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  937368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  937371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  937374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937404 */     // MIs[1] Operand 1
     /*  937404 */     // No operand predicates
     /*  937404 */     // MIs[0] round
     /*  937404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937416 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  937419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937428 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937444 */     GIR_RootConstrainSelectedInstOperands,
     /*  937445 */     // GIR_Coverage, 16514,
     /*  937445 */     GIR_EraseRootFromParent_Done,
     /*  937446 */   // Label 14182: @937446
     /*  937446 */   GIM_Try, /*On fail goto*//*Label 14183*/ GIMT_Encode4(937540), // Rule ID 16515 //
     /*  937451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  937462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  937465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  937468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937498 */     // MIs[1] Operand 1
     /*  937498 */     // No operand predicates
     /*  937498 */     // MIs[0] round
     /*  937498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937510 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  937513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937522 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937538 */     GIR_RootConstrainSelectedInstOperands,
     /*  937539 */     // GIR_Coverage, 16515,
     /*  937539 */     GIR_EraseRootFromParent_Done,
     /*  937540 */   // Label 14183: @937540
     /*  937540 */   GIM_Try, /*On fail goto*//*Label 14184*/ GIMT_Encode4(937634), // Rule ID 16518 //
     /*  937545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  937548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  937556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  937559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  937562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937592 */     // MIs[1] Operand 1
     /*  937592 */     // No operand predicates
     /*  937592 */     // MIs[0] round
     /*  937592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937604 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  937607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937616 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937632 */     GIR_RootConstrainSelectedInstOperands,
     /*  937633 */     // GIR_Coverage, 16518,
     /*  937633 */     GIR_EraseRootFromParent_Done,
     /*  937634 */   // Label 14184: @937634
     /*  937634 */   GIM_Try, /*On fail goto*//*Label 14185*/ GIMT_Encode4(937728), // Rule ID 16519 //
     /*  937639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  937650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  937653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  937656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937686 */     // MIs[1] Operand 1
     /*  937686 */     // No operand predicates
     /*  937686 */     // MIs[0] round
     /*  937686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937698 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  937701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937726 */     GIR_RootConstrainSelectedInstOperands,
     /*  937727 */     // GIR_Coverage, 16519,
     /*  937727 */     GIR_EraseRootFromParent_Done,
     /*  937728 */   // Label 14185: @937728
     /*  937728 */   GIM_Try, /*On fail goto*//*Label 14186*/ GIMT_Encode4(937822), // Rule ID 16642 //
     /*  937733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  937744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  937747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  937750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937780 */     // MIs[1] Operand 1
     /*  937780 */     // No operand predicates
     /*  937780 */     // MIs[0] round
     /*  937780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937792 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  937792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  937795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937804 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937820 */     GIR_RootConstrainSelectedInstOperands,
     /*  937821 */     // GIR_Coverage, 16642,
     /*  937821 */     GIR_EraseRootFromParent_Done,
     /*  937822 */   // Label 14186: @937822
     /*  937822 */   GIM_Try, /*On fail goto*//*Label 14187*/ GIMT_Encode4(937916), // Rule ID 16643 //
     /*  937827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  937838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  937841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  937844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937874 */     // MIs[1] Operand 1
     /*  937874 */     // No operand predicates
     /*  937874 */     // MIs[0] round
     /*  937874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937886 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  937886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  937889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937898 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937914 */     GIR_RootConstrainSelectedInstOperands,
     /*  937915 */     // GIR_Coverage, 16643,
     /*  937915 */     GIR_EraseRootFromParent_Done,
     /*  937916 */   // Label 14187: @937916
     /*  937916 */   GIM_Try, /*On fail goto*//*Label 14188*/ GIMT_Encode4(938010), // Rule ID 16646 //
     /*  937921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  937932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  937935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  937938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937968 */     // MIs[1] Operand 1
     /*  937968 */     // No operand predicates
     /*  937968 */     // MIs[0] round
     /*  937968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937980 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  937980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  937983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937992 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938008 */     GIR_RootConstrainSelectedInstOperands,
     /*  938009 */     // GIR_Coverage, 16646,
     /*  938009 */     GIR_EraseRootFromParent_Done,
     /*  938010 */   // Label 14188: @938010
     /*  938010 */   GIM_Try, /*On fail goto*//*Label 14189*/ GIMT_Encode4(938104), // Rule ID 16647 //
     /*  938015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  938026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  938029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  938032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938062 */     // MIs[1] Operand 1
     /*  938062 */     // No operand predicates
     /*  938062 */     // MIs[0] round
     /*  938062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938074 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  938077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938102 */     GIR_RootConstrainSelectedInstOperands,
     /*  938103 */     // GIR_Coverage, 16647,
     /*  938103 */     GIR_EraseRootFromParent_Done,
     /*  938104 */   // Label 14189: @938104
     /*  938104 */   GIM_Try, /*On fail goto*//*Label 14190*/ GIMT_Encode4(938198), // Rule ID 16650 //
     /*  938109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  938120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  938123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  938126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938156 */     // MIs[1] Operand 1
     /*  938156 */     // No operand predicates
     /*  938156 */     // MIs[0] round
     /*  938156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938168 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  938171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938180 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938196 */     GIR_RootConstrainSelectedInstOperands,
     /*  938197 */     // GIR_Coverage, 16650,
     /*  938197 */     GIR_EraseRootFromParent_Done,
     /*  938198 */   // Label 14190: @938198
     /*  938198 */   GIM_Try, /*On fail goto*//*Label 14191*/ GIMT_Encode4(938292), // Rule ID 16651 //
     /*  938203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  938214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  938217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  938220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938250 */     // MIs[1] Operand 1
     /*  938250 */     // No operand predicates
     /*  938250 */     // MIs[0] round
     /*  938250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938262 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  938265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938274 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938290 */     GIR_RootConstrainSelectedInstOperands,
     /*  938291 */     // GIR_Coverage, 16651,
     /*  938291 */     GIR_EraseRootFromParent_Done,
     /*  938292 */   // Label 14191: @938292
     /*  938292 */   GIM_Try, /*On fail goto*//*Label 14192*/ GIMT_Encode4(938386), // Rule ID 16654 //
     /*  938297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  938308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  938311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  938314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938344 */     // MIs[1] Operand 1
     /*  938344 */     // No operand predicates
     /*  938344 */     // MIs[0] round
     /*  938344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938356 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  938359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938368 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938384 */     GIR_RootConstrainSelectedInstOperands,
     /*  938385 */     // GIR_Coverage, 16654,
     /*  938385 */     GIR_EraseRootFromParent_Done,
     /*  938386 */   // Label 14192: @938386
     /*  938386 */   GIM_Try, /*On fail goto*//*Label 14193*/ GIMT_Encode4(938480), // Rule ID 16655 //
     /*  938391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  938402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  938405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  938408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938438 */     // MIs[1] Operand 1
     /*  938438 */     // No operand predicates
     /*  938438 */     // MIs[0] round
     /*  938438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938450 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  938453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938462 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938478 */     GIR_RootConstrainSelectedInstOperands,
     /*  938479 */     // GIR_Coverage, 16655,
     /*  938479 */     GIR_EraseRootFromParent_Done,
     /*  938480 */   // Label 14193: @938480
     /*  938480 */   GIM_Try, /*On fail goto*//*Label 14194*/ GIMT_Encode4(938574), // Rule ID 16658 //
     /*  938485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  938496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  938499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  938502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938532 */     // MIs[1] Operand 1
     /*  938532 */     // No operand predicates
     /*  938532 */     // MIs[0] round
     /*  938532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938544 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  938547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938556 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938572 */     GIR_RootConstrainSelectedInstOperands,
     /*  938573 */     // GIR_Coverage, 16658,
     /*  938573 */     GIR_EraseRootFromParent_Done,
     /*  938574 */   // Label 14194: @938574
     /*  938574 */   GIM_Try, /*On fail goto*//*Label 14195*/ GIMT_Encode4(938668), // Rule ID 16659 //
     /*  938579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  938590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  938593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  938596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938622 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938626 */     // MIs[1] Operand 1
     /*  938626 */     // No operand predicates
     /*  938626 */     // MIs[0] round
     /*  938626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938638 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  938641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938650 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938666 */     GIR_RootConstrainSelectedInstOperands,
     /*  938667 */     // GIR_Coverage, 16659,
     /*  938667 */     GIR_EraseRootFromParent_Done,
     /*  938668 */   // Label 14195: @938668
     /*  938668 */   GIM_Try, /*On fail goto*//*Label 14196*/ GIMT_Encode4(938762), // Rule ID 16662 //
     /*  938673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  938684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  938687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  938690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938720 */     // MIs[1] Operand 1
     /*  938720 */     // No operand predicates
     /*  938720 */     // MIs[0] round
     /*  938720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938732 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  938735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938744 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938760 */     GIR_RootConstrainSelectedInstOperands,
     /*  938761 */     // GIR_Coverage, 16662,
     /*  938761 */     GIR_EraseRootFromParent_Done,
     /*  938762 */   // Label 14196: @938762
     /*  938762 */   GIM_Try, /*On fail goto*//*Label 14197*/ GIMT_Encode4(938856), // Rule ID 16663 //
     /*  938767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  938778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  938781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  938784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938814 */     // MIs[1] Operand 1
     /*  938814 */     // No operand predicates
     /*  938814 */     // MIs[0] round
     /*  938814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938826 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  938829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938838 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938854 */     GIR_RootConstrainSelectedInstOperands,
     /*  938855 */     // GIR_Coverage, 16663,
     /*  938855 */     GIR_EraseRootFromParent_Done,
     /*  938856 */   // Label 14197: @938856
     /*  938856 */   GIM_Try, /*On fail goto*//*Label 14198*/ GIMT_Encode4(938950), // Rule ID 16666 //
     /*  938861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  938872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  938875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  938878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938904 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938908 */     // MIs[1] Operand 1
     /*  938908 */     // No operand predicates
     /*  938908 */     // MIs[0] round
     /*  938908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938920 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  938920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  938923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938932 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938948 */     GIR_RootConstrainSelectedInstOperands,
     /*  938949 */     // GIR_Coverage, 16666,
     /*  938949 */     GIR_EraseRootFromParent_Done,
     /*  938950 */   // Label 14198: @938950
     /*  938950 */   GIM_Try, /*On fail goto*//*Label 14199*/ GIMT_Encode4(939044), // Rule ID 16667 //
     /*  938955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  938966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  938969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  938972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939002 */     // MIs[1] Operand 1
     /*  939002 */     // No operand predicates
     /*  939002 */     // MIs[0] round
     /*  939002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939014 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  939017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939026 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939042 */     GIR_RootConstrainSelectedInstOperands,
     /*  939043 */     // GIR_Coverage, 16667,
     /*  939043 */     GIR_EraseRootFromParent_Done,
     /*  939044 */   // Label 14199: @939044
     /*  939044 */   GIM_Try, /*On fail goto*//*Label 14200*/ GIMT_Encode4(939138), // Rule ID 16670 //
     /*  939049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  939060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  939063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  939066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939096 */     // MIs[1] Operand 1
     /*  939096 */     // No operand predicates
     /*  939096 */     // MIs[0] round
     /*  939096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939108 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939120 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939136 */     GIR_RootConstrainSelectedInstOperands,
     /*  939137 */     // GIR_Coverage, 16670,
     /*  939137 */     GIR_EraseRootFromParent_Done,
     /*  939138 */   // Label 14200: @939138
     /*  939138 */   GIM_Try, /*On fail goto*//*Label 14201*/ GIMT_Encode4(939232), // Rule ID 16671 //
     /*  939143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  939154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  939157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  939160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939190 */     // MIs[1] Operand 1
     /*  939190 */     // No operand predicates
     /*  939190 */     // MIs[0] round
     /*  939190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939202 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939214 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939230 */     GIR_RootConstrainSelectedInstOperands,
     /*  939231 */     // GIR_Coverage, 16671,
     /*  939231 */     GIR_EraseRootFromParent_Done,
     /*  939232 */   // Label 14201: @939232
     /*  939232 */   GIM_Try, /*On fail goto*//*Label 14202*/ GIMT_Encode4(939326), // Rule ID 16674 //
     /*  939237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  939248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  939251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  939254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939284 */     // MIs[1] Operand 1
     /*  939284 */     // No operand predicates
     /*  939284 */     // MIs[0] round
     /*  939284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939296 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  939299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939308 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939324 */     GIR_RootConstrainSelectedInstOperands,
     /*  939325 */     // GIR_Coverage, 16674,
     /*  939325 */     GIR_EraseRootFromParent_Done,
     /*  939326 */   // Label 14202: @939326
     /*  939326 */   GIM_Try, /*On fail goto*//*Label 14203*/ GIMT_Encode4(939420), // Rule ID 16675 //
     /*  939331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  939342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  939345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  939348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939378 */     // MIs[1] Operand 1
     /*  939378 */     // No operand predicates
     /*  939378 */     // MIs[0] round
     /*  939378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  939393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939402 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939418 */     GIR_RootConstrainSelectedInstOperands,
     /*  939419 */     // GIR_Coverage, 16675,
     /*  939419 */     GIR_EraseRootFromParent_Done,
     /*  939420 */   // Label 14203: @939420
     /*  939420 */   GIM_Try, /*On fail goto*//*Label 14204*/ GIMT_Encode4(939514), // Rule ID 16678 //
     /*  939425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  939436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  939439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  939442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939472 */     // MIs[1] Operand 1
     /*  939472 */     // No operand predicates
     /*  939472 */     // MIs[0] round
     /*  939472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  939487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939496 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939512 */     GIR_RootConstrainSelectedInstOperands,
     /*  939513 */     // GIR_Coverage, 16678,
     /*  939513 */     GIR_EraseRootFromParent_Done,
     /*  939514 */   // Label 14204: @939514
     /*  939514 */   GIM_Try, /*On fail goto*//*Label 14205*/ GIMT_Encode4(939608), // Rule ID 16679 //
     /*  939519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  939530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  939533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  939536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939566 */     // MIs[1] Operand 1
     /*  939566 */     // No operand predicates
     /*  939566 */     // MIs[0] round
     /*  939566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939578 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  939581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939606 */     GIR_RootConstrainSelectedInstOperands,
     /*  939607 */     // GIR_Coverage, 16679,
     /*  939607 */     GIR_EraseRootFromParent_Done,
     /*  939608 */   // Label 14205: @939608
     /*  939608 */   GIM_Try, /*On fail goto*//*Label 14206*/ GIMT_Encode4(939702), // Rule ID 16682 //
     /*  939613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  939624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  939627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  939630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939660 */     // MIs[1] Operand 1
     /*  939660 */     // No operand predicates
     /*  939660 */     // MIs[0] round
     /*  939660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939672 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  939675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939684 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939700 */     GIR_RootConstrainSelectedInstOperands,
     /*  939701 */     // GIR_Coverage, 16682,
     /*  939701 */     GIR_EraseRootFromParent_Done,
     /*  939702 */   // Label 14206: @939702
     /*  939702 */   GIM_Try, /*On fail goto*//*Label 14207*/ GIMT_Encode4(939796), // Rule ID 16683 //
     /*  939707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  939718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  939721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  939724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939754 */     // MIs[1] Operand 1
     /*  939754 */     // No operand predicates
     /*  939754 */     // MIs[0] round
     /*  939754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939766 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  939769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939778 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939794 */     GIR_RootConstrainSelectedInstOperands,
     /*  939795 */     // GIR_Coverage, 16683,
     /*  939795 */     GIR_EraseRootFromParent_Done,
     /*  939796 */   // Label 14207: @939796
     /*  939796 */   GIM_Try, /*On fail goto*//*Label 14208*/ GIMT_Encode4(939890), // Rule ID 16686 //
     /*  939801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  939804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  939812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  939815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  939818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939848 */     // MIs[1] Operand 1
     /*  939848 */     // No operand predicates
     /*  939848 */     // MIs[0] round
     /*  939848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939860 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  939860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939872 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939888 */     GIR_RootConstrainSelectedInstOperands,
     /*  939889 */     // GIR_Coverage, 16686,
     /*  939889 */     GIR_EraseRootFromParent_Done,
     /*  939890 */   // Label 14208: @939890
     /*  939890 */   GIM_Try, /*On fail goto*//*Label 14209*/ GIMT_Encode4(939984), // Rule ID 16687 //
     /*  939895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  939898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  939906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  939909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  939912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939942 */     // MIs[1] Operand 1
     /*  939942 */     // No operand predicates
     /*  939942 */     // MIs[0] round
     /*  939942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939954 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  939954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939982 */     GIR_RootConstrainSelectedInstOperands,
     /*  939983 */     // GIR_Coverage, 16687,
     /*  939983 */     GIR_EraseRootFromParent_Done,
     /*  939984 */   // Label 14209: @939984
     /*  939984 */   GIM_Try, /*On fail goto*//*Label 14210*/ GIMT_Encode4(940078), // Rule ID 16690 //
     /*  939989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  939992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  940006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940036 */     // MIs[1] Operand 1
     /*  940036 */     // No operand predicates
     /*  940036 */     // MIs[0] round
     /*  940036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  940051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940060 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940076 */     GIR_RootConstrainSelectedInstOperands,
     /*  940077 */     // GIR_Coverage, 16690,
     /*  940077 */     GIR_EraseRootFromParent_Done,
     /*  940078 */   // Label 14210: @940078
     /*  940078 */   GIM_Try, /*On fail goto*//*Label 14211*/ GIMT_Encode4(940172), // Rule ID 16691 //
     /*  940083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  940100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940130 */     // MIs[1] Operand 1
     /*  940130 */     // No operand predicates
     /*  940130 */     // MIs[0] round
     /*  940130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940142 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  940145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940154 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940170 */     GIR_RootConstrainSelectedInstOperands,
     /*  940171 */     // GIR_Coverage, 16691,
     /*  940171 */     GIR_EraseRootFromParent_Done,
     /*  940172 */   // Label 14211: @940172
     /*  940172 */   GIM_Try, /*On fail goto*//*Label 14212*/ GIMT_Encode4(940266), // Rule ID 16694 //
     /*  940177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  940194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940224 */     // MIs[1] Operand 1
     /*  940224 */     // No operand predicates
     /*  940224 */     // MIs[0] round
     /*  940224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  940239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940248 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940264 */     GIR_RootConstrainSelectedInstOperands,
     /*  940265 */     // GIR_Coverage, 16694,
     /*  940265 */     GIR_EraseRootFromParent_Done,
     /*  940266 */   // Label 14212: @940266
     /*  940266 */   GIM_Try, /*On fail goto*//*Label 14213*/ GIMT_Encode4(940360), // Rule ID 16695 //
     /*  940271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  940288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940318 */     // MIs[1] Operand 1
     /*  940318 */     // No operand predicates
     /*  940318 */     // MIs[0] round
     /*  940318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  940333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940342 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940358 */     GIR_RootConstrainSelectedInstOperands,
     /*  940359 */     // GIR_Coverage, 16695,
     /*  940359 */     GIR_EraseRootFromParent_Done,
     /*  940360 */   // Label 14213: @940360
     /*  940360 */   GIM_Try, /*On fail goto*//*Label 14214*/ GIMT_Encode4(940454), // Rule ID 16698 //
     /*  940365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  940376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  940379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  940382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940412 */     // MIs[1] Operand 1
     /*  940412 */     // No operand predicates
     /*  940412 */     // MIs[0] round
     /*  940412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940424 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  940427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940436 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940452 */     GIR_RootConstrainSelectedInstOperands,
     /*  940453 */     // GIR_Coverage, 16698,
     /*  940453 */     GIR_EraseRootFromParent_Done,
     /*  940454 */   // Label 14214: @940454
     /*  940454 */   GIM_Try, /*On fail goto*//*Label 14215*/ GIMT_Encode4(940548), // Rule ID 16699 //
     /*  940459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  940470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  940473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  940476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940502 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940506 */     // MIs[1] Operand 1
     /*  940506 */     // No operand predicates
     /*  940506 */     // MIs[0] round
     /*  940506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  940521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940530 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940546 */     GIR_RootConstrainSelectedInstOperands,
     /*  940547 */     // GIR_Coverage, 16699,
     /*  940547 */     GIR_EraseRootFromParent_Done,
     /*  940548 */   // Label 14215: @940548
     /*  940548 */   GIM_Try, /*On fail goto*//*Label 14216*/ GIMT_Encode4(940632), // Rule ID 2766 //
     /*  940553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  940556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  940570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  940573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940596 */     // MIs[0] round
     /*  940596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940608 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  940608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  940611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940630 */     GIR_RootConstrainSelectedInstOperands,
     /*  940631 */     // GIR_Coverage, 2766,
     /*  940631 */     GIR_EraseRootFromParent_Done,
     /*  940632 */   // Label 14216: @940632
     /*  940632 */   GIM_Try, /*On fail goto*//*Label 14217*/ GIMT_Encode4(940716), // Rule ID 2767 //
     /*  940637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  940640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  940654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  940657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940680 */     // MIs[0] round
     /*  940680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940692 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  940692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  940695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940714 */     GIR_RootConstrainSelectedInstOperands,
     /*  940715 */     // GIR_Coverage, 2767,
     /*  940715 */     GIR_EraseRootFromParent_Done,
     /*  940716 */   // Label 14217: @940716
     /*  940716 */   GIM_Try, /*On fail goto*//*Label 14218*/ GIMT_Encode4(940800), // Rule ID 17146 //
     /*  940721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  940724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  940738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  940741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940764 */     // MIs[0] round
     /*  940764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940776 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  940776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  940779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940798 */     GIR_RootConstrainSelectedInstOperands,
     /*  940799 */     // GIR_Coverage, 17146,
     /*  940799 */     GIR_EraseRootFromParent_Done,
     /*  940800 */   // Label 14218: @940800
     /*  940800 */   GIM_Try, /*On fail goto*//*Label 14219*/ GIMT_Encode4(940884), // Rule ID 17147 //
     /*  940805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  940808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  940822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  940825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940848 */     // MIs[0] round
     /*  940848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940860 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  940860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  940863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940882 */     GIR_RootConstrainSelectedInstOperands,
     /*  940883 */     // GIR_Coverage, 17147,
     /*  940883 */     GIR_EraseRootFromParent_Done,
     /*  940884 */   // Label 14219: @940884
     /*  940884 */   GIM_Try, /*On fail goto*//*Label 14220*/ GIMT_Encode4(940968), // Rule ID 17156 //
     /*  940889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  940892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  940906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  940909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940932 */     // MIs[0] round
     /*  940932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940944 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  940944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  940947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940966 */     GIR_RootConstrainSelectedInstOperands,
     /*  940967 */     // GIR_Coverage, 17156,
     /*  940967 */     GIR_EraseRootFromParent_Done,
     /*  940968 */   // Label 14220: @940968
     /*  940968 */   GIM_Try, /*On fail goto*//*Label 14221*/ GIMT_Encode4(941052), // Rule ID 17157 //
     /*  940973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  940976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  940990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  940993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941016 */     // MIs[0] round
     /*  941016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941028 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  941031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941050 */     GIR_RootConstrainSelectedInstOperands,
     /*  941051 */     // GIR_Coverage, 17157,
     /*  941051 */     GIR_EraseRootFromParent_Done,
     /*  941052 */   // Label 14221: @941052
     /*  941052 */   GIM_Try, /*On fail goto*//*Label 14222*/ GIMT_Encode4(941136), // Rule ID 17166 //
     /*  941057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  941074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  941077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941100 */     // MIs[0] round
     /*  941100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941112 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  941115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941134 */     GIR_RootConstrainSelectedInstOperands,
     /*  941135 */     // GIR_Coverage, 17166,
     /*  941135 */     GIR_EraseRootFromParent_Done,
     /*  941136 */   // Label 14222: @941136
     /*  941136 */   GIM_Try, /*On fail goto*//*Label 14223*/ GIMT_Encode4(941220), // Rule ID 17167 //
     /*  941141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  941158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  941161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941184 */     // MIs[0] round
     /*  941184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941196 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  941199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941218 */     GIR_RootConstrainSelectedInstOperands,
     /*  941219 */     // GIR_Coverage, 17167,
     /*  941219 */     GIR_EraseRootFromParent_Done,
     /*  941220 */   // Label 14223: @941220
     /*  941220 */   GIM_Try, /*On fail goto*//*Label 14224*/ GIMT_Encode4(941304), // Rule ID 17176 //
     /*  941225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  941236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  941239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  941242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  941245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941268 */     // MIs[0] round
     /*  941268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941280 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  941283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941302 */     GIR_RootConstrainSelectedInstOperands,
     /*  941303 */     // GIR_Coverage, 17176,
     /*  941303 */     GIR_EraseRootFromParent_Done,
     /*  941304 */   // Label 14224: @941304
     /*  941304 */   GIM_Try, /*On fail goto*//*Label 14225*/ GIMT_Encode4(941388), // Rule ID 17177 //
     /*  941309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  941320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  941323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  941326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  941329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941352 */     // MIs[0] round
     /*  941352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941364 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  941367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941386 */     GIR_RootConstrainSelectedInstOperands,
     /*  941387 */     // GIR_Coverage, 17177,
     /*  941387 */     GIR_EraseRootFromParent_Done,
     /*  941388 */   // Label 14225: @941388
     /*  941388 */   GIM_Try, /*On fail goto*//*Label 14226*/ GIMT_Encode4(941472), // Rule ID 17186 //
     /*  941393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  941396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  941404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  941407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  941410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  941413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941436 */     // MIs[0] round
     /*  941436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941448 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  941448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  941451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941470 */     GIR_RootConstrainSelectedInstOperands,
     /*  941471 */     // GIR_Coverage, 17186,
     /*  941471 */     GIR_EraseRootFromParent_Done,
     /*  941472 */   // Label 14226: @941472
     /*  941472 */   GIM_Try, /*On fail goto*//*Label 14227*/ GIMT_Encode4(941556), // Rule ID 17187 //
     /*  941477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  941480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  941488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  941491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  941494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  941497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941520 */     // MIs[0] round
     /*  941520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941532 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  941532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  941535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941554 */     GIR_RootConstrainSelectedInstOperands,
     /*  941555 */     // GIR_Coverage, 17187,
     /*  941555 */     GIR_EraseRootFromParent_Done,
     /*  941556 */   // Label 14227: @941556
     /*  941556 */   GIM_Try, /*On fail goto*//*Label 14228*/ GIMT_Encode4(941640), // Rule ID 17196 //
     /*  941561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  941564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  941572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  941575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  941578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  941581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941604 */     // MIs[0] round
     /*  941604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941616 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  941616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  941619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941638 */     GIR_RootConstrainSelectedInstOperands,
     /*  941639 */     // GIR_Coverage, 17196,
     /*  941639 */     GIR_EraseRootFromParent_Done,
     /*  941640 */   // Label 14228: @941640
     /*  941640 */   GIM_Try, /*On fail goto*//*Label 14229*/ GIMT_Encode4(941724), // Rule ID 17197 //
     /*  941645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  941648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  941656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  941659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  941662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  941665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941688 */     // MIs[0] round
     /*  941688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941700 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  941700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  941703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941722 */     GIR_RootConstrainSelectedInstOperands,
     /*  941723 */     // GIR_Coverage, 17197,
     /*  941723 */     GIR_EraseRootFromParent_Done,
     /*  941724 */   // Label 14229: @941724
     /*  941724 */   GIM_Try, /*On fail goto*//*Label 14230*/ GIMT_Encode4(941808), // Rule ID 17206 //
     /*  941729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  941732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  941740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  941743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  941746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  941749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941772 */     // MIs[0] round
     /*  941772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941784 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  941784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  941787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941806 */     GIR_RootConstrainSelectedInstOperands,
     /*  941807 */     // GIR_Coverage, 17206,
     /*  941807 */     GIR_EraseRootFromParent_Done,
     /*  941808 */   // Label 14230: @941808
     /*  941808 */   GIM_Try, /*On fail goto*//*Label 14231*/ GIMT_Encode4(941892), // Rule ID 17207 //
     /*  941813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  941816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  941824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  941827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  941830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  941833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941856 */     // MIs[0] round
     /*  941856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941868 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  941868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  941871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941890 */     GIR_RootConstrainSelectedInstOperands,
     /*  941891 */     // GIR_Coverage, 17207,
     /*  941891 */     GIR_EraseRootFromParent_Done,
     /*  941892 */   // Label 14231: @941892
     /*  941892 */   GIM_Try, /*On fail goto*//*Label 14232*/ GIMT_Encode4(941976), // Rule ID 17216 //
     /*  941897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  941900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  941908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  941911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  941914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  941917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941940 */     // MIs[0] round
     /*  941940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941952 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  941952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  941955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941974 */     GIR_RootConstrainSelectedInstOperands,
     /*  941975 */     // GIR_Coverage, 17216,
     /*  941975 */     GIR_EraseRootFromParent_Done,
     /*  941976 */   // Label 14232: @941976
     /*  941976 */   GIM_Try, /*On fail goto*//*Label 14233*/ GIMT_Encode4(942060), // Rule ID 17217 //
     /*  941981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  941984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  941992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  941995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  941998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  942001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942024 */     // MIs[0] round
     /*  942024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942036 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  942036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  942039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942058 */     GIR_RootConstrainSelectedInstOperands,
     /*  942059 */     // GIR_Coverage, 17217,
     /*  942059 */     GIR_EraseRootFromParent_Done,
     /*  942060 */   // Label 14233: @942060
     /*  942060 */   GIM_Try, /*On fail goto*//*Label 14234*/ GIMT_Encode4(942144), // Rule ID 17262 //
     /*  942065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  942076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  942079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  942082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  942085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942108 */     // MIs[0] round
     /*  942108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942120 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  942123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942142 */     GIR_RootConstrainSelectedInstOperands,
     /*  942143 */     // GIR_Coverage, 17262,
     /*  942143 */     GIR_EraseRootFromParent_Done,
     /*  942144 */   // Label 14234: @942144
     /*  942144 */   GIM_Try, /*On fail goto*//*Label 14235*/ GIMT_Encode4(942228), // Rule ID 17263 //
     /*  942149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  942160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  942163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  942166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  942169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942192 */     // MIs[0] round
     /*  942192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942204 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  942207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942226 */     GIR_RootConstrainSelectedInstOperands,
     /*  942227 */     // GIR_Coverage, 17263,
     /*  942227 */     GIR_EraseRootFromParent_Done,
     /*  942228 */   // Label 14235: @942228
     /*  942228 */   GIM_Try, /*On fail goto*//*Label 14236*/ GIMT_Encode4(942312), // Rule ID 17272 //
     /*  942233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  942244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  942247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  942250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  942253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942276 */     // MIs[0] round
     /*  942276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942288 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  942291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942310 */     GIR_RootConstrainSelectedInstOperands,
     /*  942311 */     // GIR_Coverage, 17272,
     /*  942311 */     GIR_EraseRootFromParent_Done,
     /*  942312 */   // Label 14236: @942312
     /*  942312 */   GIM_Try, /*On fail goto*//*Label 14237*/ GIMT_Encode4(942396), // Rule ID 17273 //
     /*  942317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  942328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  942331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  942334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  942337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942360 */     // MIs[0] round
     /*  942360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942372 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  942375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942394 */     GIR_RootConstrainSelectedInstOperands,
     /*  942395 */     // GIR_Coverage, 17273,
     /*  942395 */     GIR_EraseRootFromParent_Done,
     /*  942396 */   // Label 14237: @942396
     /*  942396 */   GIM_Try, /*On fail goto*//*Label 14238*/ GIMT_Encode4(942480), // Rule ID 17282 //
     /*  942401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  942412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  942415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  942418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  942421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942444 */     // MIs[0] round
     /*  942444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942456 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  942459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942478 */     GIR_RootConstrainSelectedInstOperands,
     /*  942479 */     // GIR_Coverage, 17282,
     /*  942479 */     GIR_EraseRootFromParent_Done,
     /*  942480 */   // Label 14238: @942480
     /*  942480 */   GIM_Try, /*On fail goto*//*Label 14239*/ GIMT_Encode4(942564), // Rule ID 17283 //
     /*  942485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  942496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  942499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  942502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  942505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942528 */     // MIs[0] round
     /*  942528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942540 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  942543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942562 */     GIR_RootConstrainSelectedInstOperands,
     /*  942563 */     // GIR_Coverage, 17283,
     /*  942563 */     GIR_EraseRootFromParent_Done,
     /*  942564 */   // Label 14239: @942564
     /*  942564 */   GIM_Try, /*On fail goto*//*Label 14240*/ GIMT_Encode4(942648), // Rule ID 17292 //
     /*  942569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  942580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  942583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  942586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  942589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942612 */     // MIs[0] round
     /*  942612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942624 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  942627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942646 */     GIR_RootConstrainSelectedInstOperands,
     /*  942647 */     // GIR_Coverage, 17292,
     /*  942647 */     GIR_EraseRootFromParent_Done,
     /*  942648 */   // Label 14240: @942648
     /*  942648 */   GIM_Try, /*On fail goto*//*Label 14241*/ GIMT_Encode4(942732), // Rule ID 17293 //
     /*  942653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  942664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  942667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  942670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  942673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942696 */     // MIs[0] round
     /*  942696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942708 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  942711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942730 */     GIR_RootConstrainSelectedInstOperands,
     /*  942731 */     // GIR_Coverage, 17293,
     /*  942731 */     GIR_EraseRootFromParent_Done,
     /*  942732 */   // Label 14241: @942732
     /*  942732 */   GIM_Try, /*On fail goto*//*Label 14242*/ GIMT_Encode4(942816), // Rule ID 17302 //
     /*  942737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  942748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  942751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  942754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  942757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942780 */     // MIs[0] round
     /*  942780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942792 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  942795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942814 */     GIR_RootConstrainSelectedInstOperands,
     /*  942815 */     // GIR_Coverage, 17302,
     /*  942815 */     GIR_EraseRootFromParent_Done,
     /*  942816 */   // Label 14242: @942816
     /*  942816 */   GIM_Try, /*On fail goto*//*Label 14243*/ GIMT_Encode4(942900), // Rule ID 17303 //
     /*  942821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  942832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  942835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  942838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  942841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942864 */     // MIs[0] round
     /*  942864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942876 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  942879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942898 */     GIR_RootConstrainSelectedInstOperands,
     /*  942899 */     // GIR_Coverage, 17303,
     /*  942899 */     GIR_EraseRootFromParent_Done,
     /*  942900 */   // Label 14243: @942900
     /*  942900 */   GIM_Try, /*On fail goto*//*Label 14244*/ GIMT_Encode4(942984), // Rule ID 17312 //
     /*  942905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  942908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  942916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  942919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  942922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  942925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942948 */     // MIs[0] round
     /*  942948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942960 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  942960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  942963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942982 */     GIR_RootConstrainSelectedInstOperands,
     /*  942983 */     // GIR_Coverage, 17312,
     /*  942983 */     GIR_EraseRootFromParent_Done,
     /*  942984 */   // Label 14244: @942984
     /*  942984 */   GIM_Try, /*On fail goto*//*Label 14245*/ GIMT_Encode4(943068), // Rule ID 17313 //
     /*  942989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  942992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  943000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  943003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  943006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  943009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943032 */     // MIs[0] round
     /*  943032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943044 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  943047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943066 */     GIR_RootConstrainSelectedInstOperands,
     /*  943067 */     // GIR_Coverage, 17313,
     /*  943067 */     GIR_EraseRootFromParent_Done,
     /*  943068 */   // Label 14245: @943068
     /*  943068 */   GIM_Try, /*On fail goto*//*Label 14246*/ GIMT_Encode4(943152), // Rule ID 17322 //
     /*  943073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  943084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  943087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  943090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  943093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943116 */     // MIs[0] round
     /*  943116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943128 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  943131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943150 */     GIR_RootConstrainSelectedInstOperands,
     /*  943151 */     // GIR_Coverage, 17322,
     /*  943151 */     GIR_EraseRootFromParent_Done,
     /*  943152 */   // Label 14246: @943152
     /*  943152 */   GIM_Try, /*On fail goto*//*Label 14247*/ GIMT_Encode4(943236), // Rule ID 17323 //
     /*  943157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  943168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  943171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  943174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  943177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943200 */     // MIs[0] round
     /*  943200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943212 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  943215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943234 */     GIR_RootConstrainSelectedInstOperands,
     /*  943235 */     // GIR_Coverage, 17323,
     /*  943235 */     GIR_EraseRootFromParent_Done,
     /*  943236 */   // Label 14247: @943236
     /*  943236 */   GIM_Try, /*On fail goto*//*Label 14248*/ GIMT_Encode4(943320), // Rule ID 17332 //
     /*  943241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  943252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  943255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  943258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  943261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943284 */     // MIs[0] round
     /*  943284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943296 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  943299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943318 */     GIR_RootConstrainSelectedInstOperands,
     /*  943319 */     // GIR_Coverage, 17332,
     /*  943319 */     GIR_EraseRootFromParent_Done,
     /*  943320 */   // Label 14248: @943320
     /*  943320 */   GIM_Try, /*On fail goto*//*Label 14249*/ GIMT_Encode4(943404), // Rule ID 17333 //
     /*  943325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  943336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  943339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  943342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  943345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943368 */     // MIs[0] round
     /*  943368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943380 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  943383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943402 */     GIR_RootConstrainSelectedInstOperands,
     /*  943403 */     // GIR_Coverage, 17333,
     /*  943403 */     GIR_EraseRootFromParent_Done,
     /*  943404 */   // Label 14249: @943404
     /*  943404 */   GIM_Try, /*On fail goto*//*Label 14250*/ GIMT_Encode4(943488), // Rule ID 17342 //
     /*  943409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  943420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  943423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  943426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  943429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943452 */     // MIs[0] round
     /*  943452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943464 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  943467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943486 */     GIR_RootConstrainSelectedInstOperands,
     /*  943487 */     // GIR_Coverage, 17342,
     /*  943487 */     GIR_EraseRootFromParent_Done,
     /*  943488 */   // Label 14250: @943488
     /*  943488 */   GIM_Try, /*On fail goto*//*Label 14251*/ GIMT_Encode4(943572), // Rule ID 17343 //
     /*  943493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  943504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  943507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  943510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  943513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943536 */     // MIs[0] round
     /*  943536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943548 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11331:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  943551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943570 */     GIR_RootConstrainSelectedInstOperands,
     /*  943571 */     // GIR_Coverage, 17343,
     /*  943571 */     GIR_EraseRootFromParent_Done,
     /*  943572 */   // Label 14251: @943572
     /*  943572 */   GIM_Try, /*On fail goto*//*Label 14252*/ GIMT_Encode4(943654), // Rule ID 62837 //
     /*  943577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  943580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  943588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  943591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  943594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943604 */     // MIs[0] op1
     /*  943604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943607 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  943624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943631 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  943631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF8),
     /*  943634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943636 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943638 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943640 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943642 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943652 */     GIR_RootConstrainSelectedInstOperands,
     /*  943653 */     // GIR_Coverage, 62837,
     /*  943653 */     GIR_EraseRootFromParent_Done,
     /*  943654 */   // Label 14252: @943654
     /*  943654 */   GIM_Try, /*On fail goto*//*Label 14253*/ GIMT_Encode4(943736), // Rule ID 62838 //
     /*  943659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  943662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  943670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  943673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  943676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  943679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943686 */     // MIs[0] op1
     /*  943686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  943706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943713 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  943713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF8),
     /*  943716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943718 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943720 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943722 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943724 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943734 */     GIR_RootConstrainSelectedInstOperands,
     /*  943735 */     // GIR_Coverage, 62838,
     /*  943735 */     GIR_EraseRootFromParent_Done,
     /*  943736 */   // Label 14253: @943736
     /*  943736 */   GIM_Try, /*On fail goto*//*Label 14254*/ GIMT_Encode4(943818), // Rule ID 62867 //
     /*  943741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  943744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  943749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  943752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  943755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  943758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  943761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943768 */     // MIs[0] op1
     /*  943768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943795 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  943795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF8),
     /*  943798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943800 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943802 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943804 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943806 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943816 */     GIR_RootConstrainSelectedInstOperands,
     /*  943817 */     // GIR_Coverage, 62867,
     /*  943817 */     GIR_EraseRootFromParent_Done,
     /*  943818 */   // Label 14254: @943818
     /*  943818 */   GIM_Try, /*On fail goto*//*Label 14255*/ GIMT_Encode4(943900), // Rule ID 62868 //
     /*  943823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  943826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  943831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  943834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  943837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  943840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  943843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943850 */     // MIs[0] op1
     /*  943850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943853 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943877 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  943877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF8),
     /*  943880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943882 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943884 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943886 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943888 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943898 */     GIR_RootConstrainSelectedInstOperands,
     /*  943899 */     // GIR_Coverage, 62868,
     /*  943899 */     GIR_EraseRootFromParent_Done,
     /*  943900 */   // Label 14255: @943900
     /*  943900 */   GIM_Try, /*On fail goto*//*Label 14256*/ GIMT_Encode4(943982), // Rule ID 62899 //
     /*  943905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  943908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  943916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  943919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  943922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943932 */     // MIs[0] op1
     /*  943932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  943952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943959 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  943959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF4),
     /*  943962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943964 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943966 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943968 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943970 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943980 */     GIR_RootConstrainSelectedInstOperands,
     /*  943981 */     // GIR_Coverage, 62899,
     /*  943981 */     GIR_EraseRootFromParent_Done,
     /*  943982 */   // Label 14256: @943982
     /*  943982 */   GIM_Try, /*On fail goto*//*Label 14257*/ GIMT_Encode4(944064), // Rule ID 62900 //
     /*  943987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  943990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  943998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  944001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944014 */     // MIs[0] op1
     /*  944014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944041 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF4),
     /*  944044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944046 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944048 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944050 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944052 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944062 */     GIR_RootConstrainSelectedInstOperands,
     /*  944063 */     // GIR_Coverage, 62900,
     /*  944063 */     GIR_EraseRootFromParent_Done,
     /*  944064 */   // Label 14257: @944064
     /*  944064 */   GIM_Try, /*On fail goto*//*Label 14258*/ GIMT_Encode4(944146), // Rule ID 62911 //
     /*  944069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  944080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  944083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  944089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944096 */     // MIs[0] op1
     /*  944096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944123 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF4),
     /*  944126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944128 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944130 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944132 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944134 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944144 */     GIR_RootConstrainSelectedInstOperands,
     /*  944145 */     // GIR_Coverage, 62911,
     /*  944145 */     GIR_EraseRootFromParent_Done,
     /*  944146 */   // Label 14258: @944146
     /*  944146 */   GIM_Try, /*On fail goto*//*Label 14259*/ GIMT_Encode4(944228), // Rule ID 62912 //
     /*  944151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  944162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  944165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  944171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944178 */     // MIs[0] op1
     /*  944178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944205 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF4),
     /*  944208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944210 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944212 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944214 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944216 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944226 */     GIR_RootConstrainSelectedInstOperands,
     /*  944227 */     // GIR_Coverage, 62912,
     /*  944227 */     GIR_EraseRootFromParent_Done,
     /*  944228 */   // Label 14259: @944228
     /*  944228 */   GIM_Try, /*On fail goto*//*Label 14260*/ GIMT_Encode4(944310), // Rule ID 62943 //
     /*  944233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944260 */     // MIs[0] op1
     /*  944260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944287 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  944290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944292 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944294 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944296 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944298 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944308 */     GIR_RootConstrainSelectedInstOperands,
     /*  944309 */     // GIR_Coverage, 62943,
     /*  944309 */     GIR_EraseRootFromParent_Done,
     /*  944310 */   // Label 14260: @944310
     /*  944310 */   GIM_Try, /*On fail goto*//*Label 14261*/ GIMT_Encode4(944392), // Rule ID 62944 //
     /*  944315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944342 */     // MIs[0] op1
     /*  944342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944369 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  944372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944374 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944376 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944378 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944380 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944390 */     GIR_RootConstrainSelectedInstOperands,
     /*  944391 */     // GIR_Coverage, 62944,
     /*  944391 */     GIR_EraseRootFromParent_Done,
     /*  944392 */   // Label 14261: @944392
     /*  944392 */   GIM_Try, /*On fail goto*//*Label 14262*/ GIMT_Encode4(944474), // Rule ID 62955 //
     /*  944397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  944417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944424 */     // MIs[0] op1
     /*  944424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944451 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  944454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944456 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944458 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944460 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944462 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944472 */     GIR_RootConstrainSelectedInstOperands,
     /*  944473 */     // GIR_Coverage, 62955,
     /*  944473 */     GIR_EraseRootFromParent_Done,
     /*  944474 */   // Label 14262: @944474
     /*  944474 */   GIM_Try, /*On fail goto*//*Label 14263*/ GIMT_Encode4(944556), // Rule ID 62956 //
     /*  944479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  944499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944506 */     // MIs[0] op1
     /*  944506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944509 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944533 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  944536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944538 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944540 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944542 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944544 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944554 */     GIR_RootConstrainSelectedInstOperands,
     /*  944555 */     // GIR_Coverage, 62956,
     /*  944555 */     GIR_EraseRootFromParent_Done,
     /*  944556 */   // Label 14263: @944556
     /*  944556 */   GIM_Try, /*On fail goto*//*Label 14264*/ GIMT_Encode4(944638), // Rule ID 62987 //
     /*  944561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944588 */     // MIs[0] op1
     /*  944588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944591 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944615 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  944615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF4),
     /*  944618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944620 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944622 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944624 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944626 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944636 */     GIR_RootConstrainSelectedInstOperands,
     /*  944637 */     // GIR_Coverage, 62987,
     /*  944637 */     GIR_EraseRootFromParent_Done,
     /*  944638 */   // Label 14264: @944638
     /*  944638 */   GIM_Try, /*On fail goto*//*Label 14265*/ GIMT_Encode4(944720), // Rule ID 62988 //
     /*  944643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944670 */     // MIs[0] op1
     /*  944670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944697 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  944697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF4),
     /*  944700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944702 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944704 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944706 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944708 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944718 */     GIR_RootConstrainSelectedInstOperands,
     /*  944719 */     // GIR_Coverage, 62988,
     /*  944719 */     GIR_EraseRootFromParent_Done,
     /*  944720 */   // Label 14265: @944720
     /*  944720 */   GIM_Try, /*On fail goto*//*Label 14266*/ GIMT_Encode4(944802), // Rule ID 62999 //
     /*  944725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  944745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944752 */     // MIs[0] op1
     /*  944752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944755 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944779 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  944779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF4),
     /*  944782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944784 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944786 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944788 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944790 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944800 */     GIR_RootConstrainSelectedInstOperands,
     /*  944801 */     // GIR_Coverage, 62999,
     /*  944801 */     GIR_EraseRootFromParent_Done,
     /*  944802 */   // Label 14266: @944802
     /*  944802 */   GIM_Try, /*On fail goto*//*Label 14267*/ GIMT_Encode4(944884), // Rule ID 63000 //
     /*  944807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  944827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944834 */     // MIs[0] op1
     /*  944834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944837 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944861 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  944861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF4),
     /*  944864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944866 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944868 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944870 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944872 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944882 */     GIR_RootConstrainSelectedInstOperands,
     /*  944883 */     // GIR_Coverage, 63000,
     /*  944883 */     GIR_EraseRootFromParent_Done,
     /*  944884 */   // Label 14267: @944884
     /*  944884 */   GIM_Try, /*On fail goto*//*Label 14268*/ GIMT_Encode4(944966), // Rule ID 63011 //
     /*  944889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  944897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  944909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944916 */     // MIs[0] op1
     /*  944916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  944924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  944936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944943 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  944943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_MF4),
     /*  944946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944948 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944950 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944952 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944954 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944964 */     GIR_RootConstrainSelectedInstOperands,
     /*  944965 */     // GIR_Coverage, 63011,
     /*  944965 */     GIR_EraseRootFromParent_Done,
     /*  944966 */   // Label 14268: @944966
     /*  944966 */   GIM_Try, /*On fail goto*//*Label 14269*/ GIMT_Encode4(945048), // Rule ID 63012 //
     /*  944971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  944979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  944991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944998 */     // MIs[0] op1
     /*  944998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945025 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_MF4),
     /*  945028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945030 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945032 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945034 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945036 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945046 */     GIR_RootConstrainSelectedInstOperands,
     /*  945047 */     // GIR_Coverage, 63012,
     /*  945047 */     GIR_EraseRootFromParent_Done,
     /*  945048 */   // Label 14269: @945048
     /*  945048 */   GIM_Try, /*On fail goto*//*Label 14270*/ GIMT_Encode4(945130), // Rule ID 63043 //
     /*  945053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945080 */     // MIs[0] op1
     /*  945080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945107 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  945110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945112 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945114 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945116 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945118 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945128 */     GIR_RootConstrainSelectedInstOperands,
     /*  945129 */     // GIR_Coverage, 63043,
     /*  945129 */     GIR_EraseRootFromParent_Done,
     /*  945130 */   // Label 14270: @945130
     /*  945130 */   GIM_Try, /*On fail goto*//*Label 14271*/ GIMT_Encode4(945212), // Rule ID 63044 //
     /*  945135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945162 */     // MIs[0] op1
     /*  945162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945165 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945189 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  945192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945194 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945196 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945198 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945200 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945210 */     GIR_RootConstrainSelectedInstOperands,
     /*  945211 */     // GIR_Coverage, 63044,
     /*  945211 */     GIR_EraseRootFromParent_Done,
     /*  945212 */   // Label 14271: @945212
     /*  945212 */   GIM_Try, /*On fail goto*//*Label 14272*/ GIMT_Encode4(945294), // Rule ID 63055 //
     /*  945217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  945237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945244 */     // MIs[0] op1
     /*  945244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945247 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945271 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  945274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945276 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945278 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945280 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945282 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945292 */     GIR_RootConstrainSelectedInstOperands,
     /*  945293 */     // GIR_Coverage, 63055,
     /*  945293 */     GIR_EraseRootFromParent_Done,
     /*  945294 */   // Label 14272: @945294
     /*  945294 */   GIM_Try, /*On fail goto*//*Label 14273*/ GIMT_Encode4(945376), // Rule ID 63056 //
     /*  945299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  945319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945326 */     // MIs[0] op1
     /*  945326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945353 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  945356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945358 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945360 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945362 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945364 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945374 */     GIR_RootConstrainSelectedInstOperands,
     /*  945375 */     // GIR_Coverage, 63056,
     /*  945375 */     GIR_EraseRootFromParent_Done,
     /*  945376 */   // Label 14273: @945376
     /*  945376 */   GIM_Try, /*On fail goto*//*Label 14274*/ GIMT_Encode4(945458), // Rule ID 63067 //
     /*  945381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  945401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945408 */     // MIs[0] op1
     /*  945408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945435 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_MF2),
     /*  945438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945440 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945442 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945444 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945446 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945456 */     GIR_RootConstrainSelectedInstOperands,
     /*  945457 */     // GIR_Coverage, 63067,
     /*  945457 */     GIR_EraseRootFromParent_Done,
     /*  945458 */   // Label 14274: @945458
     /*  945458 */   GIM_Try, /*On fail goto*//*Label 14275*/ GIMT_Encode4(945540), // Rule ID 63068 //
     /*  945463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  945483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945490 */     // MIs[0] op1
     /*  945490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945493 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945517 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_MF2),
     /*  945520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945522 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945524 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945526 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945528 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945538 */     GIR_RootConstrainSelectedInstOperands,
     /*  945539 */     // GIR_Coverage, 63068,
     /*  945539 */     GIR_EraseRootFromParent_Done,
     /*  945540 */   // Label 14275: @945540
     /*  945540 */   GIM_Try, /*On fail goto*//*Label 14276*/ GIMT_Encode4(945622), // Rule ID 63099 //
     /*  945545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945572 */     // MIs[0] op1
     /*  945572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945599 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  945599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  945602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945604 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945606 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945608 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945610 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945620 */     GIR_RootConstrainSelectedInstOperands,
     /*  945621 */     // GIR_Coverage, 63099,
     /*  945621 */     GIR_EraseRootFromParent_Done,
     /*  945622 */   // Label 14276: @945622
     /*  945622 */   GIM_Try, /*On fail goto*//*Label 14277*/ GIMT_Encode4(945704), // Rule ID 63100 //
     /*  945627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945654 */     // MIs[0] op1
     /*  945654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945657 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945681 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  945681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  945684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945686 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945688 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945690 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945692 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945702 */     GIR_RootConstrainSelectedInstOperands,
     /*  945703 */     // GIR_Coverage, 63100,
     /*  945703 */     GIR_EraseRootFromParent_Done,
     /*  945704 */   // Label 14277: @945704
     /*  945704 */   GIM_Try, /*On fail goto*//*Label 14278*/ GIMT_Encode4(945786), // Rule ID 63111 //
     /*  945709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  945729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945736 */     // MIs[0] op1
     /*  945736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945763 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  945763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  945766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945768 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945770 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945772 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945774 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945784 */     GIR_RootConstrainSelectedInstOperands,
     /*  945785 */     // GIR_Coverage, 63111,
     /*  945785 */     GIR_EraseRootFromParent_Done,
     /*  945786 */   // Label 14278: @945786
     /*  945786 */   GIM_Try, /*On fail goto*//*Label 14279*/ GIMT_Encode4(945868), // Rule ID 63112 //
     /*  945791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  945811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945818 */     // MIs[0] op1
     /*  945818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945845 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  945845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  945848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945850 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945852 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945854 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945856 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945866 */     GIR_RootConstrainSelectedInstOperands,
     /*  945867 */     // GIR_Coverage, 63112,
     /*  945867 */     GIR_EraseRootFromParent_Done,
     /*  945868 */   // Label 14279: @945868
     /*  945868 */   GIM_Try, /*On fail goto*//*Label 14280*/ GIMT_Encode4(945950), // Rule ID 63123 //
     /*  945873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945900 */     // MIs[0] op1
     /*  945900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  945920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945927 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  945927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_MF2),
     /*  945930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945932 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945934 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945936 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945938 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945948 */     GIR_RootConstrainSelectedInstOperands,
     /*  945949 */     // GIR_Coverage, 63123,
     /*  945949 */     GIR_EraseRootFromParent_Done,
     /*  945950 */   // Label 14280: @945950
     /*  945950 */   GIM_Try, /*On fail goto*//*Label 14281*/ GIMT_Encode4(946032), // Rule ID 63124 //
     /*  945955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945982 */     // MIs[0] op1
     /*  945982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945985 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  946002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946009 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  946009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_MF2),
     /*  946012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946014 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946016 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946018 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946020 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946030 */     GIR_RootConstrainSelectedInstOperands,
     /*  946031 */     // GIR_Coverage, 63124,
     /*  946031 */     GIR_EraseRootFromParent_Done,
     /*  946032 */   // Label 14281: @946032
     /*  946032 */   GIM_Try, /*On fail goto*//*Label 14282*/ GIMT_Encode4(946114), // Rule ID 63155 //
     /*  946037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946064 */     // MIs[0] op1
     /*  946064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946091 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  946091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946096 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946098 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946100 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946102 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946112 */     GIR_RootConstrainSelectedInstOperands,
     /*  946113 */     // GIR_Coverage, 63155,
     /*  946113 */     GIR_EraseRootFromParent_Done,
     /*  946114 */   // Label 14282: @946114
     /*  946114 */   GIM_Try, /*On fail goto*//*Label 14283*/ GIMT_Encode4(946196), // Rule ID 63156 //
     /*  946119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946146 */     // MIs[0] op1
     /*  946146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946173 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  946173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946178 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946180 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946182 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946184 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946194 */     GIR_RootConstrainSelectedInstOperands,
     /*  946195 */     // GIR_Coverage, 63156,
     /*  946195 */     GIR_EraseRootFromParent_Done,
     /*  946196 */   // Label 14283: @946196
     /*  946196 */   GIM_Try, /*On fail goto*//*Label 14284*/ GIMT_Encode4(946278), // Rule ID 63167 //
     /*  946201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  946221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946228 */     // MIs[0] op1
     /*  946228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946255 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  946255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  946258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946260 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946262 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946264 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946266 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946276 */     GIR_RootConstrainSelectedInstOperands,
     /*  946277 */     // GIR_Coverage, 63167,
     /*  946277 */     GIR_EraseRootFromParent_Done,
     /*  946278 */   // Label 14284: @946278
     /*  946278 */   GIM_Try, /*On fail goto*//*Label 14285*/ GIMT_Encode4(946360), // Rule ID 63168 //
     /*  946283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  946303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946310 */     // MIs[0] op1
     /*  946310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946313 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946337 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  946337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  946340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946342 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946344 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946346 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946348 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946358 */     GIR_RootConstrainSelectedInstOperands,
     /*  946359 */     // GIR_Coverage, 63168,
     /*  946359 */     GIR_EraseRootFromParent_Done,
     /*  946360 */   // Label 14285: @946360
     /*  946360 */   GIM_Try, /*On fail goto*//*Label 14286*/ GIMT_Encode4(946442), // Rule ID 63199 //
     /*  946365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946392 */     // MIs[0] op1
     /*  946392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946419 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  946419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946424 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946426 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946428 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946430 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946440 */     GIR_RootConstrainSelectedInstOperands,
     /*  946441 */     // GIR_Coverage, 63199,
     /*  946441 */     GIR_EraseRootFromParent_Done,
     /*  946442 */   // Label 14286: @946442
     /*  946442 */   GIM_Try, /*On fail goto*//*Label 14287*/ GIMT_Encode4(946524), // Rule ID 63200 //
     /*  946447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946474 */     // MIs[0] op1
     /*  946474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946501 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  946501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946506 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946508 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946510 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946512 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946522 */     GIR_RootConstrainSelectedInstOperands,
     /*  946523 */     // GIR_Coverage, 63200,
     /*  946523 */     GIR_EraseRootFromParent_Done,
     /*  946524 */   // Label 14287: @946524
     /*  946524 */   GIM_Try, /*On fail goto*//*Label 14288*/ GIMT_Encode4(946606), // Rule ID 63211 //
     /*  946529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  946549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946556 */     // MIs[0] op1
     /*  946556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946559 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946583 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  946583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  946586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946588 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946590 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946592 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946594 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946604 */     GIR_RootConstrainSelectedInstOperands,
     /*  946605 */     // GIR_Coverage, 63211,
     /*  946605 */     GIR_EraseRootFromParent_Done,
     /*  946606 */   // Label 14288: @946606
     /*  946606 */   GIM_Try, /*On fail goto*//*Label 14289*/ GIMT_Encode4(946688), // Rule ID 63212 //
     /*  946611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  946631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946638 */     // MIs[0] op1
     /*  946638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946641 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946665 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  946665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  946668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946670 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946672 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946674 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946676 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946686 */     GIR_RootConstrainSelectedInstOperands,
     /*  946687 */     // GIR_Coverage, 63212,
     /*  946687 */     GIR_EraseRootFromParent_Done,
     /*  946688 */   // Label 14289: @946688
     /*  946688 */   GIM_Try, /*On fail goto*//*Label 14290*/ GIMT_Encode4(946770), // Rule ID 63223 //
     /*  946693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  946701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  946713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946720 */     // MIs[0] op1
     /*  946720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  946728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  946740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946747 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  946747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M1),
     /*  946750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946752 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946754 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946756 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946758 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946768 */     GIR_RootConstrainSelectedInstOperands,
     /*  946769 */     // GIR_Coverage, 63223,
     /*  946769 */     GIR_EraseRootFromParent_Done,
     /*  946770 */   // Label 14290: @946770
     /*  946770 */   GIM_Try, /*On fail goto*//*Label 14291*/ GIMT_Encode4(946852), // Rule ID 63224 //
     /*  946775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  946783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  946795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946802 */     // MIs[0] op1
     /*  946802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946805 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  946810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  946822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946829 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  946829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M1),
     /*  946832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946834 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946836 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946838 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946840 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946850 */     GIR_RootConstrainSelectedInstOperands,
     /*  946851 */     // GIR_Coverage, 63224,
     /*  946851 */     GIR_EraseRootFromParent_Done,
     /*  946852 */   // Label 14291: @946852
     /*  946852 */   GIM_Try, /*On fail goto*//*Label 14292*/ GIMT_Encode4(946934), // Rule ID 63255 //
     /*  946857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946884 */     // MIs[0] op1
     /*  946884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946887 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946911 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  946911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946916 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946918 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946920 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946922 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946932 */     GIR_RootConstrainSelectedInstOperands,
     /*  946933 */     // GIR_Coverage, 63255,
     /*  946933 */     GIR_EraseRootFromParent_Done,
     /*  946934 */   // Label 14292: @946934
     /*  946934 */   GIM_Try, /*On fail goto*//*Label 14293*/ GIMT_Encode4(947016), // Rule ID 63256 //
     /*  946939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946966 */     // MIs[0] op1
     /*  946966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946993 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  946993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946998 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947000 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947002 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947004 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947014 */     GIR_RootConstrainSelectedInstOperands,
     /*  947015 */     // GIR_Coverage, 63256,
     /*  947015 */     GIR_EraseRootFromParent_Done,
     /*  947016 */   // Label 14293: @947016
     /*  947016 */   GIM_Try, /*On fail goto*//*Label 14294*/ GIMT_Encode4(947098), // Rule ID 63267 //
     /*  947021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  947041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947048 */     // MIs[0] op1
     /*  947048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947051 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947075 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  947075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  947078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947080 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947082 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947084 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947086 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947096 */     GIR_RootConstrainSelectedInstOperands,
     /*  947097 */     // GIR_Coverage, 63267,
     /*  947097 */     GIR_EraseRootFromParent_Done,
     /*  947098 */   // Label 14294: @947098
     /*  947098 */   GIM_Try, /*On fail goto*//*Label 14295*/ GIMT_Encode4(947180), // Rule ID 63268 //
     /*  947103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  947123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947130 */     // MIs[0] op1
     /*  947130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947157 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  947157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  947160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947162 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947164 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947166 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947168 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947178 */     GIR_RootConstrainSelectedInstOperands,
     /*  947179 */     // GIR_Coverage, 63268,
     /*  947179 */     GIR_EraseRootFromParent_Done,
     /*  947180 */   // Label 14295: @947180
     /*  947180 */   GIM_Try, /*On fail goto*//*Label 14296*/ GIMT_Encode4(947262), // Rule ID 63279 //
     /*  947185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947212 */     // MIs[0] op1
     /*  947212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947215 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  947232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947239 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  947239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M1),
     /*  947242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947244 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947246 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947248 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947250 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947260 */     GIR_RootConstrainSelectedInstOperands,
     /*  947261 */     // GIR_Coverage, 63279,
     /*  947261 */     GIR_EraseRootFromParent_Done,
     /*  947262 */   // Label 14296: @947262
     /*  947262 */   GIM_Try, /*On fail goto*//*Label 14297*/ GIMT_Encode4(947344), // Rule ID 63280 //
     /*  947267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947294 */     // MIs[0] op1
     /*  947294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947297 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  947314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947321 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  947321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M1),
     /*  947324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947326 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947328 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947330 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947332 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947342 */     GIR_RootConstrainSelectedInstOperands,
     /*  947343 */     // GIR_Coverage, 63280,
     /*  947343 */     GIR_EraseRootFromParent_Done,
     /*  947344 */   // Label 14297: @947344
     /*  947344 */   GIM_Try, /*On fail goto*//*Label 14298*/ GIMT_Encode4(947426), // Rule ID 63311 //
     /*  947349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947376 */     // MIs[0] op1
     /*  947376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947379 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947403 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  947403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  947406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947408 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947410 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947412 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947414 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947424 */     GIR_RootConstrainSelectedInstOperands,
     /*  947425 */     // GIR_Coverage, 63311,
     /*  947425 */     GIR_EraseRootFromParent_Done,
     /*  947426 */   // Label 14298: @947426
     /*  947426 */   GIM_Try, /*On fail goto*//*Label 14299*/ GIMT_Encode4(947508), // Rule ID 63312 //
     /*  947431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947458 */     // MIs[0] op1
     /*  947458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947485 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  947485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  947488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947490 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947492 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947494 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947496 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947506 */     GIR_RootConstrainSelectedInstOperands,
     /*  947507 */     // GIR_Coverage, 63312,
     /*  947507 */     GIR_EraseRootFromParent_Done,
     /*  947508 */   // Label 14299: @947508
     /*  947508 */   GIM_Try, /*On fail goto*//*Label 14300*/ GIMT_Encode4(947590), // Rule ID 63323 //
     /*  947513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  947533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947540 */     // MIs[0] op1
     /*  947540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947567 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  947567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  947570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947572 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947574 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947576 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947578 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947588 */     GIR_RootConstrainSelectedInstOperands,
     /*  947589 */     // GIR_Coverage, 63323,
     /*  947589 */     GIR_EraseRootFromParent_Done,
     /*  947590 */   // Label 14300: @947590
     /*  947590 */   GIM_Try, /*On fail goto*//*Label 14301*/ GIMT_Encode4(947672), // Rule ID 63324 //
     /*  947595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  947615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947622 */     // MIs[0] op1
     /*  947622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947649 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  947649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  947652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947654 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947656 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947658 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947660 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947670 */     GIR_RootConstrainSelectedInstOperands,
     /*  947671 */     // GIR_Coverage, 63324,
     /*  947671 */     GIR_EraseRootFromParent_Done,
     /*  947672 */   // Label 14301: @947672
     /*  947672 */   GIM_Try, /*On fail goto*//*Label 14302*/ GIMT_Encode4(947754), // Rule ID 63335 //
     /*  947677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947704 */     // MIs[0] op1
     /*  947704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  947724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947731 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  947731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M1),
     /*  947734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947736 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947738 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947740 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947742 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947752 */     GIR_RootConstrainSelectedInstOperands,
     /*  947753 */     // GIR_Coverage, 63335,
     /*  947753 */     GIR_EraseRootFromParent_Done,
     /*  947754 */   // Label 14302: @947754
     /*  947754 */   GIM_Try, /*On fail goto*//*Label 14303*/ GIMT_Encode4(947836), // Rule ID 63336 //
     /*  947759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947786 */     // MIs[0] op1
     /*  947786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  947806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947813 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  947813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M1),
     /*  947816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947818 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947820 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947822 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947824 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947834 */     GIR_RootConstrainSelectedInstOperands,
     /*  947835 */     // GIR_Coverage, 63336,
     /*  947835 */     GIR_EraseRootFromParent_Done,
     /*  947836 */   // Label 14303: @947836
     /*  947836 */   GIM_Try, /*On fail goto*//*Label 14304*/ GIMT_Encode4(947918), // Rule ID 63367 //
     /*  947841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  947852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  947855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  947858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947868 */     // MIs[0] op1
     /*  947868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947871 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947895 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  947898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947900 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947902 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947904 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947906 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947916 */     GIR_RootConstrainSelectedInstOperands,
     /*  947917 */     // GIR_Coverage, 63367,
     /*  947917 */     GIR_EraseRootFromParent_Done,
     /*  947918 */   // Label 14304: @947918
     /*  947918 */   GIM_Try, /*On fail goto*//*Label 14305*/ GIMT_Encode4(948000), // Rule ID 63368 //
     /*  947923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  947934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  947937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  947940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947950 */     // MIs[0] op1
     /*  947950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947977 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  947977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  947980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947982 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947984 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947986 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947988 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947998 */     GIR_RootConstrainSelectedInstOperands,
     /*  947999 */     // GIR_Coverage, 63368,
     /*  947999 */     GIR_EraseRootFromParent_Done,
     /*  948000 */   // Label 14305: @948000
     /*  948000 */   GIM_Try, /*On fail goto*//*Label 14306*/ GIMT_Encode4(948082), // Rule ID 63379 //
     /*  948005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  948016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  948019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  948022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  948025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948032 */     // MIs[0] op1
     /*  948032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948059 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  948062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948064 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948066 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948068 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948070 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948080 */     GIR_RootConstrainSelectedInstOperands,
     /*  948081 */     // GIR_Coverage, 63379,
     /*  948081 */     GIR_EraseRootFromParent_Done,
     /*  948082 */   // Label 14306: @948082
     /*  948082 */   GIM_Try, /*On fail goto*//*Label 14307*/ GIMT_Encode4(948164), // Rule ID 63380 //
     /*  948087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  948098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  948101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  948104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  948107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948114 */     // MIs[0] op1
     /*  948114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948141 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  948144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948146 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948148 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948150 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948152 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948162 */     GIR_RootConstrainSelectedInstOperands,
     /*  948163 */     // GIR_Coverage, 63380,
     /*  948163 */     GIR_EraseRootFromParent_Done,
     /*  948164 */   // Label 14307: @948164
     /*  948164 */   GIM_Try, /*On fail goto*//*Label 14308*/ GIMT_Encode4(948246), // Rule ID 63411 //
     /*  948169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948196 */     // MIs[0] op1
     /*  948196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948199 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948223 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  948226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948228 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948230 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948232 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948234 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948244 */     GIR_RootConstrainSelectedInstOperands,
     /*  948245 */     // GIR_Coverage, 63411,
     /*  948245 */     GIR_EraseRootFromParent_Done,
     /*  948246 */   // Label 14308: @948246
     /*  948246 */   GIM_Try, /*On fail goto*//*Label 14309*/ GIMT_Encode4(948328), // Rule ID 63412 //
     /*  948251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948278 */     // MIs[0] op1
     /*  948278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948305 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  948308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948310 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948312 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948314 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948316 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948326 */     GIR_RootConstrainSelectedInstOperands,
     /*  948327 */     // GIR_Coverage, 63412,
     /*  948327 */     GIR_EraseRootFromParent_Done,
     /*  948328 */   // Label 14309: @948328
     /*  948328 */   GIM_Try, /*On fail goto*//*Label 14310*/ GIMT_Encode4(948410), // Rule ID 63423 //
     /*  948333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  948353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948360 */     // MIs[0] op1
     /*  948360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948387 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  948390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948392 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948394 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948396 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948398 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948408 */     GIR_RootConstrainSelectedInstOperands,
     /*  948409 */     // GIR_Coverage, 63423,
     /*  948409 */     GIR_EraseRootFromParent_Done,
     /*  948410 */   // Label 14310: @948410
     /*  948410 */   GIM_Try, /*On fail goto*//*Label 14311*/ GIMT_Encode4(948492), // Rule ID 63424 //
     /*  948415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  948435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948442 */     // MIs[0] op1
     /*  948442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948469 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  948472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948474 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948476 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948478 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948480 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948490 */     GIR_RootConstrainSelectedInstOperands,
     /*  948491 */     // GIR_Coverage, 63424,
     /*  948491 */     GIR_EraseRootFromParent_Done,
     /*  948492 */   // Label 14311: @948492
     /*  948492 */   GIM_Try, /*On fail goto*//*Label 14312*/ GIMT_Encode4(948574), // Rule ID 63455 //
     /*  948497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  948508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  948511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  948514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948524 */     // MIs[0] op1
     /*  948524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948551 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  948554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948556 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948558 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948560 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948562 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948572 */     GIR_RootConstrainSelectedInstOperands,
     /*  948573 */     // GIR_Coverage, 63455,
     /*  948573 */     GIR_EraseRootFromParent_Done,
     /*  948574 */   // Label 14312: @948574
     /*  948574 */   GIM_Try, /*On fail goto*//*Label 14313*/ GIMT_Encode4(948656), // Rule ID 63456 //
     /*  948579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  948590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  948593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  948596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948606 */     // MIs[0] op1
     /*  948606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948633 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  948636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948638 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948640 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948642 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948644 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948654 */     GIR_RootConstrainSelectedInstOperands,
     /*  948655 */     // GIR_Coverage, 63456,
     /*  948655 */     GIR_EraseRootFromParent_Done,
     /*  948656 */   // Label 14313: @948656
     /*  948656 */   GIM_Try, /*On fail goto*//*Label 14314*/ GIMT_Encode4(948738), // Rule ID 63467 //
     /*  948661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  948672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  948675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  948678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  948681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948688 */     // MIs[0] op1
     /*  948688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948691 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948715 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  948718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948720 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948722 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948724 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948726 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948736 */     GIR_RootConstrainSelectedInstOperands,
     /*  948737 */     // GIR_Coverage, 63467,
     /*  948737 */     GIR_EraseRootFromParent_Done,
     /*  948738 */   // Label 14314: @948738
     /*  948738 */   GIM_Try, /*On fail goto*//*Label 14315*/ GIMT_Encode4(948820), // Rule ID 63468 //
     /*  948743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  948754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  948757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  948760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  948763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948770 */     // MIs[0] op1
     /*  948770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948797 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  948800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948802 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948804 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948806 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948808 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948818 */     GIR_RootConstrainSelectedInstOperands,
     /*  948819 */     // GIR_Coverage, 63468,
     /*  948819 */     GIR_EraseRootFromParent_Done,
     /*  948820 */   // Label 14315: @948820
     /*  948820 */   GIM_Try, /*On fail goto*//*Label 14316*/ GIMT_Encode4(948902), // Rule ID 63499 //
     /*  948825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  948836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  948839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  948842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948852 */     // MIs[0] op1
     /*  948852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948879 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  948882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948884 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948886 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948888 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948890 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948900 */     GIR_RootConstrainSelectedInstOperands,
     /*  948901 */     // GIR_Coverage, 63499,
     /*  948901 */     GIR_EraseRootFromParent_Done,
     /*  948902 */   // Label 14316: @948902
     /*  948902 */   GIM_Try, /*On fail goto*//*Label 14317*/ GIMT_Encode4(948984), // Rule ID 63500 //
     /*  948907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  948918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  948921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  948924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948934 */     // MIs[0] op1
     /*  948934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948961 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  948961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  948964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948966 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948968 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948970 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948972 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948982 */     GIR_RootConstrainSelectedInstOperands,
     /*  948983 */     // GIR_Coverage, 63500,
     /*  948983 */     GIR_EraseRootFromParent_Done,
     /*  948984 */   // Label 14317: @948984
     /*  948984 */   GIM_Try, /*On fail goto*//*Label 14318*/ GIMT_Encode4(949066), // Rule ID 63511 //
     /*  948989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  949009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949016 */     // MIs[0] op1
     /*  949016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  949046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949048 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949050 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949052 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949054 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949064 */     GIR_RootConstrainSelectedInstOperands,
     /*  949065 */     // GIR_Coverage, 63511,
     /*  949065 */     GIR_EraseRootFromParent_Done,
     /*  949066 */   // Label 14318: @949066
     /*  949066 */   GIM_Try, /*On fail goto*//*Label 14319*/ GIMT_Encode4(949148), // Rule ID 63512 //
     /*  949071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  949091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949098 */     // MIs[0] op1
     /*  949098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949125 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  949128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949130 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949132 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949134 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949136 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949146 */     GIR_RootConstrainSelectedInstOperands,
     /*  949147 */     // GIR_Coverage, 63512,
     /*  949147 */     GIR_EraseRootFromParent_Done,
     /*  949148 */   // Label 14319: @949148
     /*  949148 */   GIM_Try, /*On fail goto*//*Label 14320*/ GIMT_Encode4(949230), // Rule ID 63523 //
     /*  949153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949180 */     // MIs[0] op1
     /*  949180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949207 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M2),
     /*  949210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949212 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949214 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949216 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949218 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949228 */     GIR_RootConstrainSelectedInstOperands,
     /*  949229 */     // GIR_Coverage, 63523,
     /*  949229 */     GIR_EraseRootFromParent_Done,
     /*  949230 */   // Label 14320: @949230
     /*  949230 */   GIM_Try, /*On fail goto*//*Label 14321*/ GIMT_Encode4(949312), // Rule ID 63524 //
     /*  949235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949262 */     // MIs[0] op1
     /*  949262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949289 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M2),
     /*  949292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949294 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949296 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949298 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949300 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949310 */     GIR_RootConstrainSelectedInstOperands,
     /*  949311 */     // GIR_Coverage, 63524,
     /*  949311 */     GIR_EraseRootFromParent_Done,
     /*  949312 */   // Label 14321: @949312
     /*  949312 */   GIM_Try, /*On fail goto*//*Label 14322*/ GIMT_Encode4(949394), // Rule ID 63555 //
     /*  949317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949344 */     // MIs[0] op1
     /*  949344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949347 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949371 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  949374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949376 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949378 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949380 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949382 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949392 */     GIR_RootConstrainSelectedInstOperands,
     /*  949393 */     // GIR_Coverage, 63555,
     /*  949393 */     GIR_EraseRootFromParent_Done,
     /*  949394 */   // Label 14322: @949394
     /*  949394 */   GIM_Try, /*On fail goto*//*Label 14323*/ GIMT_Encode4(949476), // Rule ID 63556 //
     /*  949399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949426 */     // MIs[0] op1
     /*  949426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949453 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  949456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949458 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949460 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949462 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949464 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949474 */     GIR_RootConstrainSelectedInstOperands,
     /*  949475 */     // GIR_Coverage, 63556,
     /*  949475 */     GIR_EraseRootFromParent_Done,
     /*  949476 */   // Label 14323: @949476
     /*  949476 */   GIM_Try, /*On fail goto*//*Label 14324*/ GIMT_Encode4(949558), // Rule ID 63567 //
     /*  949481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  949501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949508 */     // MIs[0] op1
     /*  949508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949535 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  949538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949540 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949542 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949544 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949546 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949556 */     GIR_RootConstrainSelectedInstOperands,
     /*  949557 */     // GIR_Coverage, 63567,
     /*  949557 */     GIR_EraseRootFromParent_Done,
     /*  949558 */   // Label 14324: @949558
     /*  949558 */   GIM_Try, /*On fail goto*//*Label 14325*/ GIMT_Encode4(949640), // Rule ID 63568 //
     /*  949563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  949583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949590 */     // MIs[0] op1
     /*  949590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949617 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  949620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949622 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949624 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949626 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949628 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949638 */     GIR_RootConstrainSelectedInstOperands,
     /*  949639 */     // GIR_Coverage, 63568,
     /*  949639 */     GIR_EraseRootFromParent_Done,
     /*  949640 */   // Label 14325: @949640
     /*  949640 */   GIM_Try, /*On fail goto*//*Label 14326*/ GIMT_Encode4(949722), // Rule ID 63579 //
     /*  949645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949672 */     // MIs[0] op1
     /*  949672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949675 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949699 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M4),
     /*  949702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949704 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949706 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949708 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949710 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949720 */     GIR_RootConstrainSelectedInstOperands,
     /*  949721 */     // GIR_Coverage, 63579,
     /*  949721 */     GIR_EraseRootFromParent_Done,
     /*  949722 */   // Label 14326: @949722
     /*  949722 */   GIM_Try, /*On fail goto*//*Label 14327*/ GIMT_Encode4(949804), // Rule ID 63580 //
     /*  949727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949754 */     // MIs[0] op1
     /*  949754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949757 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949781 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M4),
     /*  949784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949786 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949788 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949790 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949792 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949802 */     GIR_RootConstrainSelectedInstOperands,
     /*  949803 */     // GIR_Coverage, 63580,
     /*  949803 */     GIR_EraseRootFromParent_Done,
     /*  949804 */   // Label 14327: @949804
     /*  949804 */   GIM_Try, /*On fail goto*//*Label 14328*/ GIMT_Encode4(949886), // Rule ID 63611 //
     /*  949809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  949823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  949826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949836 */     // MIs[0] op1
     /*  949836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949839 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949863 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  949866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949868 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949870 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949872 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949874 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949884 */     GIR_RootConstrainSelectedInstOperands,
     /*  949885 */     // GIR_Coverage, 63611,
     /*  949885 */     GIR_EraseRootFromParent_Done,
     /*  949886 */   // Label 14328: @949886
     /*  949886 */   GIM_Try, /*On fail goto*//*Label 14329*/ GIMT_Encode4(949968), // Rule ID 63612 //
     /*  949891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  949905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  949908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949918 */     // MIs[0] op1
     /*  949918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949945 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  949948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949950 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949952 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949954 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949956 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949966 */     GIR_RootConstrainSelectedInstOperands,
     /*  949967 */     // GIR_Coverage, 63612,
     /*  949967 */     GIR_EraseRootFromParent_Done,
     /*  949968 */   // Label 14329: @949968
     /*  949968 */   GIM_Try, /*On fail goto*//*Label 14330*/ GIMT_Encode4(950050), // Rule ID 63623 //
     /*  949973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  949987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  949990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  949993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950000 */     // MIs[0] op1
     /*  950000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950003 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950027 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  950030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950032 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950034 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950036 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950038 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950048 */     GIR_RootConstrainSelectedInstOperands,
     /*  950049 */     // GIR_Coverage, 63623,
     /*  950049 */     GIR_EraseRootFromParent_Done,
     /*  950050 */   // Label 14330: @950050
     /*  950050 */   GIM_Try, /*On fail goto*//*Label 14331*/ GIMT_Encode4(950132), // Rule ID 63624 //
     /*  950055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  950075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950082 */     // MIs[0] op1
     /*  950082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950085 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950109 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  950112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950114 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950116 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950118 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950120 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950130 */     GIR_RootConstrainSelectedInstOperands,
     /*  950131 */     // GIR_Coverage, 63624,
     /*  950131 */     GIR_EraseRootFromParent_Done,
     /*  950132 */   // Label 14331: @950132
     /*  950132 */   GIM_Try, /*On fail goto*//*Label 14332*/ GIMT_Encode4(950214), // Rule ID 63635 //
     /*  950137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950164 */     // MIs[0] op1
     /*  950164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950167 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950191 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M8),
     /*  950194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950196 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950198 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950200 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950202 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950212 */     GIR_RootConstrainSelectedInstOperands,
     /*  950213 */     // GIR_Coverage, 63635,
     /*  950213 */     GIR_EraseRootFromParent_Done,
     /*  950214 */   // Label 14332: @950214
     /*  950214 */   GIM_Try, /*On fail goto*//*Label 14333*/ GIMT_Encode4(950296), // Rule ID 63636 //
     /*  950219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950246 */     // MIs[0] op1
     /*  950246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950249 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950273 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M8),
     /*  950276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950278 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950280 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950282 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950284 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950294 */     GIR_RootConstrainSelectedInstOperands,
     /*  950295 */     // GIR_Coverage, 63636,
     /*  950295 */     GIR_EraseRootFromParent_Done,
     /*  950296 */   // Label 14333: @950296
     /*  950296 */   GIM_Try, /*On fail goto*//*Label 14334*/ GIMT_Encode4(950378), // Rule ID 63667 //
     /*  950301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950328 */     // MIs[0] op1
     /*  950328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950331 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950355 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  950358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950360 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950362 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950364 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950366 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950376 */     GIR_RootConstrainSelectedInstOperands,
     /*  950377 */     // GIR_Coverage, 63667,
     /*  950377 */     GIR_EraseRootFromParent_Done,
     /*  950378 */   // Label 14334: @950378
     /*  950378 */   GIM_Try, /*On fail goto*//*Label 14335*/ GIMT_Encode4(950460), // Rule ID 63668 //
     /*  950383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950410 */     // MIs[0] op1
     /*  950410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950413 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950437 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  950440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950442 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950444 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950446 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950448 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950458 */     GIR_RootConstrainSelectedInstOperands,
     /*  950459 */     // GIR_Coverage, 63668,
     /*  950459 */     GIR_EraseRootFromParent_Done,
     /*  950460 */   // Label 14335: @950460
     /*  950460 */   GIM_Try, /*On fail goto*//*Label 14336*/ GIMT_Encode4(950542), // Rule ID 63679 //
     /*  950465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  950485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950492 */     // MIs[0] op1
     /*  950492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950495 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  950522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950524 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950526 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950528 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950530 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950540 */     GIR_RootConstrainSelectedInstOperands,
     /*  950541 */     // GIR_Coverage, 63679,
     /*  950541 */     GIR_EraseRootFromParent_Done,
     /*  950542 */   // Label 14336: @950542
     /*  950542 */   GIM_Try, /*On fail goto*//*Label 14337*/ GIMT_Encode4(950624), // Rule ID 63680 //
     /*  950547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  950567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950574 */     // MIs[0] op1
     /*  950574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950601 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  950604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950606 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950608 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950610 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950612 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950622 */     GIR_RootConstrainSelectedInstOperands,
     /*  950623 */     // GIR_Coverage, 63680,
     /*  950623 */     GIR_EraseRootFromParent_Done,
     /*  950624 */   // Label 14337: @950624
     /*  950624 */   GIM_Try, /*On fail goto*//*Label 14338*/ GIMT_Encode4(950706), // Rule ID 63691 //
     /*  950629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950656 */     // MIs[0] op1
     /*  950656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950659 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  950676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950683 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M2),
     /*  950686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950688 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950690 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950692 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950694 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950704 */     GIR_RootConstrainSelectedInstOperands,
     /*  950705 */     // GIR_Coverage, 63691,
     /*  950705 */     GIR_EraseRootFromParent_Done,
     /*  950706 */   // Label 14338: @950706
     /*  950706 */   GIM_Try, /*On fail goto*//*Label 14339*/ GIMT_Encode4(950788), // Rule ID 63692 //
     /*  950711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950738 */     // MIs[0] op1
     /*  950738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950741 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  950758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M2),
     /*  950768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950770 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950772 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950774 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950776 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950786 */     GIR_RootConstrainSelectedInstOperands,
     /*  950787 */     // GIR_Coverage, 63692,
     /*  950787 */     GIR_EraseRootFromParent_Done,
     /*  950788 */   // Label 14339: @950788
     /*  950788 */   GIM_Try, /*On fail goto*//*Label 14340*/ GIMT_Encode4(950870), // Rule ID 63723 //
     /*  950793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  950807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  950810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950820 */     // MIs[0] op1
     /*  950820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950823 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950847 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  950850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950852 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950854 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950856 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950858 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950868 */     GIR_RootConstrainSelectedInstOperands,
     /*  950869 */     // GIR_Coverage, 63723,
     /*  950869 */     GIR_EraseRootFromParent_Done,
     /*  950870 */   // Label 14340: @950870
     /*  950870 */   GIM_Try, /*On fail goto*//*Label 14341*/ GIMT_Encode4(950952), // Rule ID 63724 //
     /*  950875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  950889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  950892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950902 */     // MIs[0] op1
     /*  950902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950929 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  950932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950934 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950936 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950938 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950940 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950950 */     GIR_RootConstrainSelectedInstOperands,
     /*  950951 */     // GIR_Coverage, 63724,
     /*  950951 */     GIR_EraseRootFromParent_Done,
     /*  950952 */   // Label 14341: @950952
     /*  950952 */   GIM_Try, /*On fail goto*//*Label 14342*/ GIMT_Encode4(951034), // Rule ID 63735 //
     /*  950957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  950971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  950974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  950977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950984 */     // MIs[0] op1
     /*  950984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950987 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951011 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  951014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951016 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951018 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951020 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951022 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951032 */     GIR_RootConstrainSelectedInstOperands,
     /*  951033 */     // GIR_Coverage, 63735,
     /*  951033 */     GIR_EraseRootFromParent_Done,
     /*  951034 */   // Label 14342: @951034
     /*  951034 */   GIM_Try, /*On fail goto*//*Label 14343*/ GIMT_Encode4(951116), // Rule ID 63736 //
     /*  951039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  951059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951066 */     // MIs[0] op1
     /*  951066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951093 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  951096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951098 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951100 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951102 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951104 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951114 */     GIR_RootConstrainSelectedInstOperands,
     /*  951115 */     // GIR_Coverage, 63736,
     /*  951115 */     GIR_EraseRootFromParent_Done,
     /*  951116 */   // Label 14343: @951116
     /*  951116 */   GIM_Try, /*On fail goto*//*Label 14344*/ GIMT_Encode4(951198), // Rule ID 63747 //
     /*  951121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951148 */     // MIs[0] op1
     /*  951148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951151 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951175 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M4),
     /*  951178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951180 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951182 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951184 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951186 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951196 */     GIR_RootConstrainSelectedInstOperands,
     /*  951197 */     // GIR_Coverage, 63747,
     /*  951197 */     GIR_EraseRootFromParent_Done,
     /*  951198 */   // Label 14344: @951198
     /*  951198 */   GIM_Try, /*On fail goto*//*Label 14345*/ GIMT_Encode4(951280), // Rule ID 63748 //
     /*  951203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951230 */     // MIs[0] op1
     /*  951230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951257 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M4),
     /*  951260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951262 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951264 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951266 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951268 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951278 */     GIR_RootConstrainSelectedInstOperands,
     /*  951279 */     // GIR_Coverage, 63748,
     /*  951279 */     GIR_EraseRootFromParent_Done,
     /*  951280 */   // Label 14345: @951280
     /*  951280 */   GIM_Try, /*On fail goto*//*Label 14346*/ GIMT_Encode4(951362), // Rule ID 63779 //
     /*  951285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951312 */     // MIs[0] op1
     /*  951312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951339 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  951342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951344 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951346 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951348 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951350 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951360 */     GIR_RootConstrainSelectedInstOperands,
     /*  951361 */     // GIR_Coverage, 63779,
     /*  951361 */     GIR_EraseRootFromParent_Done,
     /*  951362 */   // Label 14346: @951362
     /*  951362 */   GIM_Try, /*On fail goto*//*Label 14347*/ GIMT_Encode4(951444), // Rule ID 63780 //
     /*  951367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951394 */     // MIs[0] op1
     /*  951394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951397 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951421 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  951424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951426 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951428 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951430 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951432 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951442 */     GIR_RootConstrainSelectedInstOperands,
     /*  951443 */     // GIR_Coverage, 63780,
     /*  951443 */     GIR_EraseRootFromParent_Done,
     /*  951444 */   // Label 14347: @951444
     /*  951444 */   GIM_Try, /*On fail goto*//*Label 14348*/ GIMT_Encode4(951526), // Rule ID 63791 //
     /*  951449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  951469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951476 */     // MIs[0] op1
     /*  951476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951479 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951503 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  951506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951508 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951510 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951512 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951514 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951524 */     GIR_RootConstrainSelectedInstOperands,
     /*  951525 */     // GIR_Coverage, 63791,
     /*  951525 */     GIR_EraseRootFromParent_Done,
     /*  951526 */   // Label 14348: @951526
     /*  951526 */   GIM_Try, /*On fail goto*//*Label 14349*/ GIMT_Encode4(951608), // Rule ID 63792 //
     /*  951531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  951551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951558 */     // MIs[0] op1
     /*  951558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951585 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  951588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951590 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951592 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951594 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951596 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951606 */     GIR_RootConstrainSelectedInstOperands,
     /*  951607 */     // GIR_Coverage, 63792,
     /*  951607 */     GIR_EraseRootFromParent_Done,
     /*  951608 */   // Label 14349: @951608
     /*  951608 */   GIM_Try, /*On fail goto*//*Label 14350*/ GIMT_Encode4(951690), // Rule ID 63803 //
     /*  951613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951640 */     // MIs[0] op1
     /*  951640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951667 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M8),
     /*  951670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951672 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951674 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951676 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951678 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951688 */     GIR_RootConstrainSelectedInstOperands,
     /*  951689 */     // GIR_Coverage, 63803,
     /*  951689 */     GIR_EraseRootFromParent_Done,
     /*  951690 */   // Label 14350: @951690
     /*  951690 */   GIM_Try, /*On fail goto*//*Label 14351*/ GIMT_Encode4(951772), // Rule ID 63804 //
     /*  951695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951722 */     // MIs[0] op1
     /*  951722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951725 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951749 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M8),
     /*  951752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951754 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951756 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951758 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951760 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951770 */     GIR_RootConstrainSelectedInstOperands,
     /*  951771 */     // GIR_Coverage, 63804,
     /*  951771 */     GIR_EraseRootFromParent_Done,
     /*  951772 */   // Label 14351: @951772
     /*  951772 */   GIM_Try, /*On fail goto*//*Label 14352*/ GIMT_Encode4(951854), // Rule ID 63835 //
     /*  951777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  951788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  951791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  951794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951804 */     // MIs[0] op1
     /*  951804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951807 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951831 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  951834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951836 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951838 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951840 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951842 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951852 */     GIR_RootConstrainSelectedInstOperands,
     /*  951853 */     // GIR_Coverage, 63835,
     /*  951853 */     GIR_EraseRootFromParent_Done,
     /*  951854 */   // Label 14352: @951854
     /*  951854 */   GIM_Try, /*On fail goto*//*Label 14353*/ GIMT_Encode4(951936), // Rule ID 63836 //
     /*  951859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  951870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  951873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  951876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951886 */     // MIs[0] op1
     /*  951886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951913 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  951913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  951916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951918 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951920 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951922 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951924 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951934 */     GIR_RootConstrainSelectedInstOperands,
     /*  951935 */     // GIR_Coverage, 63836,
     /*  951935 */     GIR_EraseRootFromParent_Done,
     /*  951936 */   // Label 14353: @951936
     /*  951936 */   GIM_Try, /*On fail goto*//*Label 14354*/ GIMT_Encode4(952018), // Rule ID 63847 //
     /*  951941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  951952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  951955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  951958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  951961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951968 */     // MIs[0] op1
     /*  951968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951995 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  951998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952000 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952002 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952004 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952006 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952016 */     GIR_RootConstrainSelectedInstOperands,
     /*  952017 */     // GIR_Coverage, 63847,
     /*  952017 */     GIR_EraseRootFromParent_Done,
     /*  952018 */   // Label 14354: @952018
     /*  952018 */   GIM_Try, /*On fail goto*//*Label 14355*/ GIMT_Encode4(952100), // Rule ID 63848 //
     /*  952023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  952043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952050 */     // MIs[0] op1
     /*  952050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952053 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952077 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  952080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952082 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952084 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952086 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952088 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952098 */     GIR_RootConstrainSelectedInstOperands,
     /*  952099 */     // GIR_Coverage, 63848,
     /*  952099 */     GIR_EraseRootFromParent_Done,
     /*  952100 */   // Label 14355: @952100
     /*  952100 */   GIM_Try, /*On fail goto*//*Label 14356*/ GIMT_Encode4(952182), // Rule ID 63859 //
     /*  952105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952132 */     // MIs[0] op1
     /*  952132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952159 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M2),
     /*  952162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952164 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952166 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952168 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952170 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952180 */     GIR_RootConstrainSelectedInstOperands,
     /*  952181 */     // GIR_Coverage, 63859,
     /*  952181 */     GIR_EraseRootFromParent_Done,
     /*  952182 */   // Label 14356: @952182
     /*  952182 */   GIM_Try, /*On fail goto*//*Label 14357*/ GIMT_Encode4(952264), // Rule ID 63860 //
     /*  952187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952214 */     // MIs[0] op1
     /*  952214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952241 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M2),
     /*  952244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952246 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952248 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952250 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952252 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952262 */     GIR_RootConstrainSelectedInstOperands,
     /*  952263 */     // GIR_Coverage, 63860,
     /*  952263 */     GIR_EraseRootFromParent_Done,
     /*  952264 */   // Label 14357: @952264
     /*  952264 */   GIM_Try, /*On fail goto*//*Label 14358*/ GIMT_Encode4(952346), // Rule ID 63891 //
     /*  952269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952296 */     // MIs[0] op1
     /*  952296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952299 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952323 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  952326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952328 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952330 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952332 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952334 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952344 */     GIR_RootConstrainSelectedInstOperands,
     /*  952345 */     // GIR_Coverage, 63891,
     /*  952345 */     GIR_EraseRootFromParent_Done,
     /*  952346 */   // Label 14358: @952346
     /*  952346 */   GIM_Try, /*On fail goto*//*Label 14359*/ GIMT_Encode4(952428), // Rule ID 63892 //
     /*  952351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952378 */     // MIs[0] op1
     /*  952378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952381 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952405 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  952408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952410 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952412 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952414 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952416 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952426 */     GIR_RootConstrainSelectedInstOperands,
     /*  952427 */     // GIR_Coverage, 63892,
     /*  952427 */     GIR_EraseRootFromParent_Done,
     /*  952428 */   // Label 14359: @952428
     /*  952428 */   GIM_Try, /*On fail goto*//*Label 14360*/ GIMT_Encode4(952510), // Rule ID 63903 //
     /*  952433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  952453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952460 */     // MIs[0] op1
     /*  952460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952463 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952487 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  952490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952492 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952494 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952496 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952498 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952508 */     GIR_RootConstrainSelectedInstOperands,
     /*  952509 */     // GIR_Coverage, 63903,
     /*  952509 */     GIR_EraseRootFromParent_Done,
     /*  952510 */   // Label 14360: @952510
     /*  952510 */   GIM_Try, /*On fail goto*//*Label 14361*/ GIMT_Encode4(952592), // Rule ID 63904 //
     /*  952515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  952535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952542 */     // MIs[0] op1
     /*  952542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952545 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952569 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  952572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952574 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952576 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952578 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952580 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952590 */     GIR_RootConstrainSelectedInstOperands,
     /*  952591 */     // GIR_Coverage, 63904,
     /*  952591 */     GIR_EraseRootFromParent_Done,
     /*  952592 */   // Label 14361: @952592
     /*  952592 */   GIM_Try, /*On fail goto*//*Label 14362*/ GIMT_Encode4(952674), // Rule ID 63915 //
     /*  952597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952624 */     // MIs[0] op1
     /*  952624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952651 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M4),
     /*  952654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952656 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952658 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952660 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952662 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952672 */     GIR_RootConstrainSelectedInstOperands,
     /*  952673 */     // GIR_Coverage, 63915,
     /*  952673 */     GIR_EraseRootFromParent_Done,
     /*  952674 */   // Label 14362: @952674
     /*  952674 */   GIM_Try, /*On fail goto*//*Label 14363*/ GIMT_Encode4(952756), // Rule ID 63916 //
     /*  952679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952706 */     // MIs[0] op1
     /*  952706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952709 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952733 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M4),
     /*  952736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952738 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952740 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952742 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952744 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952754 */     GIR_RootConstrainSelectedInstOperands,
     /*  952755 */     // GIR_Coverage, 63916,
     /*  952755 */     GIR_EraseRootFromParent_Done,
     /*  952756 */   // Label 14363: @952756
     /*  952756 */   GIM_Try, /*On fail goto*//*Label 14364*/ GIMT_Encode4(952838), // Rule ID 63947 //
     /*  952761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  952772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  952775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  952778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952788 */     // MIs[0] op1
     /*  952788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952791 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952815 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11099:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  952818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952820 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952822 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952824 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952826 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952836 */     GIR_RootConstrainSelectedInstOperands,
     /*  952837 */     // GIR_Coverage, 63947,
     /*  952837 */     GIR_EraseRootFromParent_Done,
     /*  952838 */   // Label 14364: @952838
     /*  952838 */   GIM_Try, /*On fail goto*//*Label 14365*/ GIMT_Encode4(952920), // Rule ID 63948 //
     /*  952843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  952854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  952857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  952860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952870 */     // MIs[0] op1
     /*  952870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952873 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952897 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11099:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  952900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952902 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952904 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952906 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952908 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952918 */     GIR_RootConstrainSelectedInstOperands,
     /*  952919 */     // GIR_Coverage, 63948,
     /*  952919 */     GIR_EraseRootFromParent_Done,
     /*  952920 */   // Label 14365: @952920
     /*  952920 */   GIM_Try, /*On fail goto*//*Label 14366*/ GIMT_Encode4(953002), // Rule ID 63959 //
     /*  952925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  952936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  952939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  952942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  952945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952952 */     // MIs[0] op1
     /*  952952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952979 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11091:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  952982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952984 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952986 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952988 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952990 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953000 */     GIR_RootConstrainSelectedInstOperands,
     /*  953001 */     // GIR_Coverage, 63959,
     /*  953001 */     GIR_EraseRootFromParent_Done,
     /*  953002 */   // Label 14366: @953002
     /*  953002 */   GIM_Try, /*On fail goto*//*Label 14367*/ GIMT_Encode4(953084), // Rule ID 63960 //
     /*  953007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  953027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953034 */     // MIs[0] op1
     /*  953034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953037 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953061 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  953064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953066 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953068 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953070 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953072 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953082 */     GIR_RootConstrainSelectedInstOperands,
     /*  953083 */     // GIR_Coverage, 63960,
     /*  953083 */     GIR_EraseRootFromParent_Done,
     /*  953084 */   // Label 14367: @953084
     /*  953084 */   GIM_Try, /*On fail goto*//*Label 14368*/ GIMT_Encode4(953166), // Rule ID 63971 //
     /*  953089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953116 */     // MIs[0] op1
     /*  953116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953119 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  953136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953143 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  953143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M8),
     /*  953146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953148 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953150 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953152 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953154 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953164 */     GIR_RootConstrainSelectedInstOperands,
     /*  953165 */     // GIR_Coverage, 63971,
     /*  953165 */     GIR_EraseRootFromParent_Done,
     /*  953166 */   // Label 14368: @953166
     /*  953166 */   GIM_Try, /*On fail goto*//*Label 14369*/ GIMT_Encode4(953248), // Rule ID 63972 //
     /*  953171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953198 */     // MIs[0] op1
     /*  953198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  953218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953225 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M8),
     /*  953228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953230 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953232 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953234 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953236 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953246 */     GIR_RootConstrainSelectedInstOperands,
     /*  953247 */     // GIR_Coverage, 63972,
     /*  953247 */     GIR_EraseRootFromParent_Done,
     /*  953248 */   // Label 14369: @953248
     /*  953248 */   GIM_Try, /*On fail goto*//*Label 14370*/ GIMT_Encode4(953330), // Rule ID 63977 //
     /*  953253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953280 */     // MIs[0] op1
     /*  953280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953307 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF8),
     /*  953310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953312 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953314 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953316 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953318 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953328 */     GIR_RootConstrainSelectedInstOperands,
     /*  953329 */     // GIR_Coverage, 63977,
     /*  953329 */     GIR_EraseRootFromParent_Done,
     /*  953330 */   // Label 14370: @953330
     /*  953330 */   GIM_Try, /*On fail goto*//*Label 14371*/ GIMT_Encode4(953412), // Rule ID 63978 //
     /*  953335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953362 */     // MIs[0] op1
     /*  953362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953365 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953389 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF8),
     /*  953392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953394 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953396 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953398 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953400 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953410 */     GIR_RootConstrainSelectedInstOperands,
     /*  953411 */     // GIR_Coverage, 63978,
     /*  953411 */     GIR_EraseRootFromParent_Done,
     /*  953412 */   // Label 14371: @953412
     /*  953412 */   GIM_Try, /*On fail goto*//*Label 14372*/ GIMT_Encode4(953494), // Rule ID 63989 //
     /*  953417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  953437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953444 */     // MIs[0] op1
     /*  953444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953447 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953471 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF8),
     /*  953474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953476 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953478 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953480 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953482 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953492 */     GIR_RootConstrainSelectedInstOperands,
     /*  953493 */     // GIR_Coverage, 63989,
     /*  953493 */     GIR_EraseRootFromParent_Done,
     /*  953494 */   // Label 14372: @953494
     /*  953494 */   GIM_Try, /*On fail goto*//*Label 14373*/ GIMT_Encode4(953576), // Rule ID 63990 //
     /*  953499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  953519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953526 */     // MIs[0] op1
     /*  953526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953529 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953553 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF8),
     /*  953556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953558 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953560 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953562 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953564 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953574 */     GIR_RootConstrainSelectedInstOperands,
     /*  953575 */     // GIR_Coverage, 63990,
     /*  953575 */     GIR_EraseRootFromParent_Done,
     /*  953576 */   // Label 14373: @953576
     /*  953576 */   GIM_Try, /*On fail goto*//*Label 14374*/ GIMT_Encode4(953658), // Rule ID 63995 //
     /*  953581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  953598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953608 */     // MIs[0] op1
     /*  953608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953635 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF4),
     /*  953638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953640 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953642 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953644 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953646 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953656 */     GIR_RootConstrainSelectedInstOperands,
     /*  953657 */     // GIR_Coverage, 63995,
     /*  953657 */     GIR_EraseRootFromParent_Done,
     /*  953658 */   // Label 14374: @953658
     /*  953658 */   GIM_Try, /*On fail goto*//*Label 14375*/ GIMT_Encode4(953740), // Rule ID 63996 //
     /*  953663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  953680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953690 */     // MIs[0] op1
     /*  953690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953717 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF4),
     /*  953720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953722 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953724 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953726 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953728 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953738 */     GIR_RootConstrainSelectedInstOperands,
     /*  953739 */     // GIR_Coverage, 63996,
     /*  953739 */     GIR_EraseRootFromParent_Done,
     /*  953740 */   // Label 14375: @953740
     /*  953740 */   GIM_Try, /*On fail goto*//*Label 14376*/ GIMT_Encode4(953822), // Rule ID 64007 //
     /*  953745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  953762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  953765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953772 */     // MIs[0] op1
     /*  953772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953799 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF4),
     /*  953802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953804 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953806 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953808 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953810 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953820 */     GIR_RootConstrainSelectedInstOperands,
     /*  953821 */     // GIR_Coverage, 64007,
     /*  953821 */     GIR_EraseRootFromParent_Done,
     /*  953822 */   // Label 14376: @953822
     /*  953822 */   GIM_Try, /*On fail goto*//*Label 14377*/ GIMT_Encode4(953904), // Rule ID 64008 //
     /*  953827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  953844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  953847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953854 */     // MIs[0] op1
     /*  953854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953857 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953881 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF4),
     /*  953884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953886 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953888 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953890 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953892 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953902 */     GIR_RootConstrainSelectedInstOperands,
     /*  953903 */     // GIR_Coverage, 64008,
     /*  953903 */     GIR_EraseRootFromParent_Done,
     /*  953904 */   // Label 14377: @953904
     /*  953904 */   GIM_Try, /*On fail goto*//*Label 14378*/ GIMT_Encode4(953986), // Rule ID 64013 //
     /*  953909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  953920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  953923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  953926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953936 */     // MIs[0] op1
     /*  953936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953963 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  953966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953968 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953970 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953972 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953974 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953984 */     GIR_RootConstrainSelectedInstOperands,
     /*  953985 */     // GIR_Coverage, 64013,
     /*  953985 */     GIR_EraseRootFromParent_Done,
     /*  953986 */   // Label 14378: @953986
     /*  953986 */   GIM_Try, /*On fail goto*//*Label 14379*/ GIMT_Encode4(954068), // Rule ID 64014 //
     /*  953991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  954002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  954005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  954008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954018 */     // MIs[0] op1
     /*  954018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954045 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  954048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954050 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954052 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954054 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954056 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954066 */     GIR_RootConstrainSelectedInstOperands,
     /*  954067 */     // GIR_Coverage, 64014,
     /*  954067 */     GIR_EraseRootFromParent_Done,
     /*  954068 */   // Label 14379: @954068
     /*  954068 */   GIM_Try, /*On fail goto*//*Label 14380*/ GIMT_Encode4(954150), // Rule ID 64025 //
     /*  954073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  954084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  954087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  954090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  954093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954100 */     // MIs[0] op1
     /*  954100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  954130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954132 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954134 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954136 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954138 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954148 */     GIR_RootConstrainSelectedInstOperands,
     /*  954149 */     // GIR_Coverage, 64025,
     /*  954149 */     GIR_EraseRootFromParent_Done,
     /*  954150 */   // Label 14380: @954150
     /*  954150 */   GIM_Try, /*On fail goto*//*Label 14381*/ GIMT_Encode4(954232), // Rule ID 64026 //
     /*  954155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  954166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  954169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  954172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  954175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954182 */     // MIs[0] op1
     /*  954182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954185 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954209 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  954212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954214 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954216 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954218 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954220 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954230 */     GIR_RootConstrainSelectedInstOperands,
     /*  954231 */     // GIR_Coverage, 64026,
     /*  954231 */     GIR_EraseRootFromParent_Done,
     /*  954232 */   // Label 14381: @954232
     /*  954232 */   GIM_Try, /*On fail goto*//*Label 14382*/ GIMT_Encode4(954314), // Rule ID 64031 //
     /*  954237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954264 */     // MIs[0] op1
     /*  954264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954291 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  954294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954296 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954298 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954300 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954302 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954312 */     GIR_RootConstrainSelectedInstOperands,
     /*  954313 */     // GIR_Coverage, 64031,
     /*  954313 */     GIR_EraseRootFromParent_Done,
     /*  954314 */   // Label 14382: @954314
     /*  954314 */   GIM_Try, /*On fail goto*//*Label 14383*/ GIMT_Encode4(954396), // Rule ID 64032 //
     /*  954319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954346 */     // MIs[0] op1
     /*  954346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954349 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954373 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  954376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954378 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954380 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954382 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954384 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954394 */     GIR_RootConstrainSelectedInstOperands,
     /*  954395 */     // GIR_Coverage, 64032,
     /*  954395 */     GIR_EraseRootFromParent_Done,
     /*  954396 */   // Label 14383: @954396
     /*  954396 */   GIM_Try, /*On fail goto*//*Label 14384*/ GIMT_Encode4(954478), // Rule ID 64043 //
     /*  954401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  954421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954428 */     // MIs[0] op1
     /*  954428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954431 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954455 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  954458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954460 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954462 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954464 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954466 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954476 */     GIR_RootConstrainSelectedInstOperands,
     /*  954477 */     // GIR_Coverage, 64043,
     /*  954477 */     GIR_EraseRootFromParent_Done,
     /*  954478 */   // Label 14384: @954478
     /*  954478 */   GIM_Try, /*On fail goto*//*Label 14385*/ GIMT_Encode4(954560), // Rule ID 64044 //
     /*  954483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  954503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954510 */     // MIs[0] op1
     /*  954510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954537 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  954540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954542 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954544 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954546 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954548 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954558 */     GIR_RootConstrainSelectedInstOperands,
     /*  954559 */     // GIR_Coverage, 64044,
     /*  954559 */     GIR_EraseRootFromParent_Done,
     /*  954560 */   // Label 14385: @954560
     /*  954560 */   GIM_Try, /*On fail goto*//*Label 14386*/ GIMT_Encode4(954642), // Rule ID 64049 //
     /*  954565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  954582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954592 */     // MIs[0] op1
     /*  954592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954619 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  954622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954624 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954626 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954628 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954630 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954640 */     GIR_RootConstrainSelectedInstOperands,
     /*  954641 */     // GIR_Coverage, 64049,
     /*  954641 */     GIR_EraseRootFromParent_Done,
     /*  954642 */   // Label 14386: @954642
     /*  954642 */   GIM_Try, /*On fail goto*//*Label 14387*/ GIMT_Encode4(954724), // Rule ID 64050 //
     /*  954647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  954664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954674 */     // MIs[0] op1
     /*  954674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954701 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  954704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954706 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954708 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954710 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954712 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954722 */     GIR_RootConstrainSelectedInstOperands,
     /*  954723 */     // GIR_Coverage, 64050,
     /*  954723 */     GIR_EraseRootFromParent_Done,
     /*  954724 */   // Label 14387: @954724
     /*  954724 */   GIM_Try, /*On fail goto*//*Label 14388*/ GIMT_Encode4(954806), // Rule ID 64061 //
     /*  954729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  954746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  954749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954756 */     // MIs[0] op1
     /*  954756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954783 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  954786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954788 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954790 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954792 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954794 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954804 */     GIR_RootConstrainSelectedInstOperands,
     /*  954805 */     // GIR_Coverage, 64061,
     /*  954805 */     GIR_EraseRootFromParent_Done,
     /*  954806 */   // Label 14388: @954806
     /*  954806 */   GIM_Try, /*On fail goto*//*Label 14389*/ GIMT_Encode4(954888), // Rule ID 64062 //
     /*  954811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  954828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  954831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954838 */     // MIs[0] op1
     /*  954838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954865 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  954868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954870 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954872 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954874 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954876 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954886 */     GIR_RootConstrainSelectedInstOperands,
     /*  954887 */     // GIR_Coverage, 64062,
     /*  954887 */     GIR_EraseRootFromParent_Done,
     /*  954888 */   // Label 14389: @954888
     /*  954888 */   GIM_Try, /*On fail goto*//*Label 14390*/ GIMT_Encode4(954970), // Rule ID 64067 //
     /*  954893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  954904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  954907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  954910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954920 */     // MIs[0] op1
     /*  954920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954923 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954947 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  954950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954952 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954954 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954956 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954958 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954968 */     GIR_RootConstrainSelectedInstOperands,
     /*  954969 */     // GIR_Coverage, 64067,
     /*  954969 */     GIR_EraseRootFromParent_Done,
     /*  954970 */   // Label 14390: @954970
     /*  954970 */   GIM_Try, /*On fail goto*//*Label 14391*/ GIMT_Encode4(955052), // Rule ID 64068 //
     /*  954975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  954986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  954989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  954992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955002 */     // MIs[0] op1
     /*  955002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955029 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  955029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  955032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955034 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955036 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955038 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955040 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955050 */     GIR_RootConstrainSelectedInstOperands,
     /*  955051 */     // GIR_Coverage, 64068,
     /*  955051 */     GIR_EraseRootFromParent_Done,
     /*  955052 */   // Label 14391: @955052
     /*  955052 */   GIM_Try, /*On fail goto*//*Label 14392*/ GIMT_Encode4(955134), // Rule ID 64079 //
     /*  955057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  955068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  955071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  955074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  955077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955084 */     // MIs[0] op1
     /*  955084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955087 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955111 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  955111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  955114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955116 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955118 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955120 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955122 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955132 */     GIR_RootConstrainSelectedInstOperands,
     /*  955133 */     // GIR_Coverage, 64079,
     /*  955133 */     GIR_EraseRootFromParent_Done,
     /*  955134 */   // Label 14392: @955134
     /*  955134 */   GIM_Try, /*On fail goto*//*Label 14393*/ GIMT_Encode4(955216), // Rule ID 64080 //
     /*  955139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  955150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  955153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  955156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  955159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955166 */     // MIs[0] op1
     /*  955166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955193 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  955193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  955196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955198 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955200 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955202 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955204 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955214 */     GIR_RootConstrainSelectedInstOperands,
     /*  955215 */     // GIR_Coverage, 64080,
     /*  955215 */     GIR_EraseRootFromParent_Done,
     /*  955216 */   // Label 14393: @955216
     /*  955216 */   GIM_Try, /*On fail goto*//*Label 14394*/ GIMT_Encode4(955298), // Rule ID 64085 //
     /*  955221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955248 */     // MIs[0] op1
     /*  955248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955275 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF4),
     /*  955278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955280 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955282 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955284 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955286 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955296 */     GIR_RootConstrainSelectedInstOperands,
     /*  955297 */     // GIR_Coverage, 64085,
     /*  955297 */     GIR_EraseRootFromParent_Done,
     /*  955298 */   // Label 14394: @955298
     /*  955298 */   GIM_Try, /*On fail goto*//*Label 14395*/ GIMT_Encode4(955380), // Rule ID 64086 //
     /*  955303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955330 */     // MIs[0] op1
     /*  955330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955333 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955357 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF4),
     /*  955360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955362 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955364 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955366 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955368 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955378 */     GIR_RootConstrainSelectedInstOperands,
     /*  955379 */     // GIR_Coverage, 64086,
     /*  955379 */     GIR_EraseRootFromParent_Done,
     /*  955380 */   // Label 14395: @955380
     /*  955380 */   GIM_Try, /*On fail goto*//*Label 14396*/ GIMT_Encode4(955462), // Rule ID 64097 //
     /*  955385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  955405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955412 */     // MIs[0] op1
     /*  955412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955439 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF4),
     /*  955442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955444 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955446 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955448 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955450 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955460 */     GIR_RootConstrainSelectedInstOperands,
     /*  955461 */     // GIR_Coverage, 64097,
     /*  955461 */     GIR_EraseRootFromParent_Done,
     /*  955462 */   // Label 14396: @955462
     /*  955462 */   GIM_Try, /*On fail goto*//*Label 14397*/ GIMT_Encode4(955544), // Rule ID 64098 //
     /*  955467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  955487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955494 */     // MIs[0] op1
     /*  955494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955521 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF4),
     /*  955524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955526 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955528 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955530 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955532 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955542 */     GIR_RootConstrainSelectedInstOperands,
     /*  955543 */     // GIR_Coverage, 64098,
     /*  955543 */     GIR_EraseRootFromParent_Done,
     /*  955544 */   // Label 14397: @955544
     /*  955544 */   GIM_Try, /*On fail goto*//*Label 14398*/ GIMT_Encode4(955626), // Rule ID 64103 //
     /*  955549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  955557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  955569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955576 */     // MIs[0] op1
     /*  955576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955579 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  955596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955603 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_MF4),
     /*  955606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955608 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955610 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955612 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955614 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955624 */     GIR_RootConstrainSelectedInstOperands,
     /*  955625 */     // GIR_Coverage, 64103,
     /*  955625 */     GIR_EraseRootFromParent_Done,
     /*  955626 */   // Label 14398: @955626
     /*  955626 */   GIM_Try, /*On fail goto*//*Label 14399*/ GIMT_Encode4(955708), // Rule ID 64104 //
     /*  955631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  955639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  955651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955658 */     // MIs[0] op1
     /*  955658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  955678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955685 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_MF4),
     /*  955688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955690 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955692 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955694 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955696 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955706 */     GIR_RootConstrainSelectedInstOperands,
     /*  955707 */     // GIR_Coverage, 64104,
     /*  955707 */     GIR_EraseRootFromParent_Done,
     /*  955708 */   // Label 14399: @955708
     /*  955708 */   GIM_Try, /*On fail goto*//*Label 14400*/ GIMT_Encode4(955790), // Rule ID 64109 //
     /*  955713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955740 */     // MIs[0] op1
     /*  955740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955767 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  955770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955772 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955774 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955776 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955778 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955788 */     GIR_RootConstrainSelectedInstOperands,
     /*  955789 */     // GIR_Coverage, 64109,
     /*  955789 */     GIR_EraseRootFromParent_Done,
     /*  955790 */   // Label 14400: @955790
     /*  955790 */   GIM_Try, /*On fail goto*//*Label 14401*/ GIMT_Encode4(955872), // Rule ID 64110 //
     /*  955795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955822 */     // MIs[0] op1
     /*  955822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955825 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955849 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  955852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955854 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955856 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955858 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955860 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955870 */     GIR_RootConstrainSelectedInstOperands,
     /*  955871 */     // GIR_Coverage, 64110,
     /*  955871 */     GIR_EraseRootFromParent_Done,
     /*  955872 */   // Label 14401: @955872
     /*  955872 */   GIM_Try, /*On fail goto*//*Label 14402*/ GIMT_Encode4(955954), // Rule ID 64121 //
     /*  955877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  955897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955904 */     // MIs[0] op1
     /*  955904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955907 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955931 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  955934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955936 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955938 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955940 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955942 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955952 */     GIR_RootConstrainSelectedInstOperands,
     /*  955953 */     // GIR_Coverage, 64121,
     /*  955953 */     GIR_EraseRootFromParent_Done,
     /*  955954 */   // Label 14402: @955954
     /*  955954 */   GIM_Try, /*On fail goto*//*Label 14403*/ GIMT_Encode4(956036), // Rule ID 64122 //
     /*  955959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  955979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955986 */     // MIs[0] op1
     /*  955986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955989 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956013 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  956016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956018 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956020 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956022 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956024 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956034 */     GIR_RootConstrainSelectedInstOperands,
     /*  956035 */     // GIR_Coverage, 64122,
     /*  956035 */     GIR_EraseRootFromParent_Done,
     /*  956036 */   // Label 14403: @956036
     /*  956036 */   GIM_Try, /*On fail goto*//*Label 14404*/ GIMT_Encode4(956118), // Rule ID 64127 //
     /*  956041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956068 */     // MIs[0] op1
     /*  956068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956095 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_MF2),
     /*  956098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956100 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956102 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956104 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956106 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956116 */     GIR_RootConstrainSelectedInstOperands,
     /*  956117 */     // GIR_Coverage, 64127,
     /*  956117 */     GIR_EraseRootFromParent_Done,
     /*  956118 */   // Label 14404: @956118
     /*  956118 */   GIM_Try, /*On fail goto*//*Label 14405*/ GIMT_Encode4(956200), // Rule ID 64128 //
     /*  956123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956150 */     // MIs[0] op1
     /*  956150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956153 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956177 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_MF2),
     /*  956180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956182 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956184 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956186 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956188 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956198 */     GIR_RootConstrainSelectedInstOperands,
     /*  956199 */     // GIR_Coverage, 64128,
     /*  956199 */     GIR_EraseRootFromParent_Done,
     /*  956200 */   // Label 14405: @956200
     /*  956200 */   GIM_Try, /*On fail goto*//*Label 14406*/ GIMT_Encode4(956282), // Rule ID 64133 //
     /*  956205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956232 */     // MIs[0] op1
     /*  956232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956259 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  956262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956264 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956266 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956268 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956270 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956280 */     GIR_RootConstrainSelectedInstOperands,
     /*  956281 */     // GIR_Coverage, 64133,
     /*  956281 */     GIR_EraseRootFromParent_Done,
     /*  956282 */   // Label 14406: @956282
     /*  956282 */   GIM_Try, /*On fail goto*//*Label 14407*/ GIMT_Encode4(956364), // Rule ID 64134 //
     /*  956287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956314 */     // MIs[0] op1
     /*  956314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956317 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956341 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  956344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956346 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956348 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956350 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956352 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956362 */     GIR_RootConstrainSelectedInstOperands,
     /*  956363 */     // GIR_Coverage, 64134,
     /*  956363 */     GIR_EraseRootFromParent_Done,
     /*  956364 */   // Label 14407: @956364
     /*  956364 */   GIM_Try, /*On fail goto*//*Label 14408*/ GIMT_Encode4(956446), // Rule ID 64145 //
     /*  956369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  956389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956396 */     // MIs[0] op1
     /*  956396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956423 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  956426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956428 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956430 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956432 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956434 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956444 */     GIR_RootConstrainSelectedInstOperands,
     /*  956445 */     // GIR_Coverage, 64145,
     /*  956445 */     GIR_EraseRootFromParent_Done,
     /*  956446 */   // Label 14408: @956446
     /*  956446 */   GIM_Try, /*On fail goto*//*Label 14409*/ GIMT_Encode4(956528), // Rule ID 64146 //
     /*  956451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  956471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956478 */     // MIs[0] op1
     /*  956478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956505 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  956508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956510 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956512 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956514 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956516 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956526 */     GIR_RootConstrainSelectedInstOperands,
     /*  956527 */     // GIR_Coverage, 64146,
     /*  956527 */     GIR_EraseRootFromParent_Done,
     /*  956528 */   // Label 14409: @956528
     /*  956528 */   GIM_Try, /*On fail goto*//*Label 14410*/ GIMT_Encode4(956610), // Rule ID 64151 //
     /*  956533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956560 */     // MIs[0] op1
     /*  956560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956587 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M1),
     /*  956590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956592 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956594 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956596 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956598 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956608 */     GIR_RootConstrainSelectedInstOperands,
     /*  956609 */     // GIR_Coverage, 64151,
     /*  956609 */     GIR_EraseRootFromParent_Done,
     /*  956610 */   // Label 14410: @956610
     /*  956610 */   GIM_Try, /*On fail goto*//*Label 14411*/ GIMT_Encode4(956692), // Rule ID 64152 //
     /*  956615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956642 */     // MIs[0] op1
     /*  956642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956645 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956669 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M1),
     /*  956672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956674 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956676 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956678 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956680 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956690 */     GIR_RootConstrainSelectedInstOperands,
     /*  956691 */     // GIR_Coverage, 64152,
     /*  956691 */     GIR_EraseRootFromParent_Done,
     /*  956692 */   // Label 14411: @956692
     /*  956692 */   GIM_Try, /*On fail goto*//*Label 14412*/ GIMT_Encode4(956774), // Rule ID 64157 //
     /*  956697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956724 */     // MIs[0] op1
     /*  956724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956751 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  956754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956756 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956758 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956760 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956762 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956772 */     GIR_RootConstrainSelectedInstOperands,
     /*  956773 */     // GIR_Coverage, 64157,
     /*  956773 */     GIR_EraseRootFromParent_Done,
     /*  956774 */   // Label 14412: @956774
     /*  956774 */   GIM_Try, /*On fail goto*//*Label 14413*/ GIMT_Encode4(956856), // Rule ID 64158 //
     /*  956779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956806 */     // MIs[0] op1
     /*  956806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956833 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  956836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956838 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956840 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956842 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956844 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956854 */     GIR_RootConstrainSelectedInstOperands,
     /*  956855 */     // GIR_Coverage, 64158,
     /*  956855 */     GIR_EraseRootFromParent_Done,
     /*  956856 */   // Label 14413: @956856
     /*  956856 */   GIM_Try, /*On fail goto*//*Label 14414*/ GIMT_Encode4(956938), // Rule ID 64169 //
     /*  956861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  956881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956888 */     // MIs[0] op1
     /*  956888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956891 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956915 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  956918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956920 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956922 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956924 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956926 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956936 */     GIR_RootConstrainSelectedInstOperands,
     /*  956937 */     // GIR_Coverage, 64169,
     /*  956937 */     GIR_EraseRootFromParent_Done,
     /*  956938 */   // Label 14414: @956938
     /*  956938 */   GIM_Try, /*On fail goto*//*Label 14415*/ GIMT_Encode4(957020), // Rule ID 64170 //
     /*  956943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  956963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956970 */     // MIs[0] op1
     /*  956970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956973 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956997 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  957000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957002 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957004 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957006 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957008 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957018 */     GIR_RootConstrainSelectedInstOperands,
     /*  957019 */     // GIR_Coverage, 64170,
     /*  957019 */     GIR_EraseRootFromParent_Done,
     /*  957020 */   // Label 14415: @957020
     /*  957020 */   GIM_Try, /*On fail goto*//*Label 14416*/ GIMT_Encode4(957102), // Rule ID 64175 //
     /*  957025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957052 */     // MIs[0] op1
     /*  957052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957079 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M2),
     /*  957082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957084 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957086 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957088 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957090 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957100 */     GIR_RootConstrainSelectedInstOperands,
     /*  957101 */     // GIR_Coverage, 64175,
     /*  957101 */     GIR_EraseRootFromParent_Done,
     /*  957102 */   // Label 14416: @957102
     /*  957102 */   GIM_Try, /*On fail goto*//*Label 14417*/ GIMT_Encode4(957184), // Rule ID 64176 //
     /*  957107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957134 */     // MIs[0] op1
     /*  957134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957161 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M2),
     /*  957164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957166 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957168 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957170 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957172 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957182 */     GIR_RootConstrainSelectedInstOperands,
     /*  957183 */     // GIR_Coverage, 64176,
     /*  957183 */     GIR_EraseRootFromParent_Done,
     /*  957184 */   // Label 14417: @957184
     /*  957184 */   GIM_Try, /*On fail goto*//*Label 14418*/ GIMT_Encode4(957266), // Rule ID 64181 //
     /*  957189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957216 */     // MIs[0] op1
     /*  957216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957243 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  957246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957248 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957250 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957252 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957254 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957264 */     GIR_RootConstrainSelectedInstOperands,
     /*  957265 */     // GIR_Coverage, 64181,
     /*  957265 */     GIR_EraseRootFromParent_Done,
     /*  957266 */   // Label 14418: @957266
     /*  957266 */   GIM_Try, /*On fail goto*//*Label 14419*/ GIMT_Encode4(957348), // Rule ID 64182 //
     /*  957271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957298 */     // MIs[0] op1
     /*  957298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957301 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957325 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  957328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957330 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957332 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957334 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957336 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957346 */     GIR_RootConstrainSelectedInstOperands,
     /*  957347 */     // GIR_Coverage, 64182,
     /*  957347 */     GIR_EraseRootFromParent_Done,
     /*  957348 */   // Label 14419: @957348
     /*  957348 */   GIM_Try, /*On fail goto*//*Label 14420*/ GIMT_Encode4(957430), // Rule ID 64193 //
     /*  957353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  957373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957380 */     // MIs[0] op1
     /*  957380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957383 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957407 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  957410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957412 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957414 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957416 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957418 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957428 */     GIR_RootConstrainSelectedInstOperands,
     /*  957429 */     // GIR_Coverage, 64193,
     /*  957429 */     GIR_EraseRootFromParent_Done,
     /*  957430 */   // Label 14420: @957430
     /*  957430 */   GIM_Try, /*On fail goto*//*Label 14421*/ GIMT_Encode4(957512), // Rule ID 64194 //
     /*  957435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  957455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957462 */     // MIs[0] op1
     /*  957462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957489 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  957492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957494 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957496 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957498 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957500 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957510 */     GIR_RootConstrainSelectedInstOperands,
     /*  957511 */     // GIR_Coverage, 64194,
     /*  957511 */     GIR_EraseRootFromParent_Done,
     /*  957512 */   // Label 14421: @957512
     /*  957512 */   GIM_Try, /*On fail goto*//*Label 14422*/ GIMT_Encode4(957594), // Rule ID 64199 //
     /*  957517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957544 */     // MIs[0] op1
     /*  957544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957547 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957571 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M4),
     /*  957574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957576 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957578 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957580 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957582 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957592 */     GIR_RootConstrainSelectedInstOperands,
     /*  957593 */     // GIR_Coverage, 64199,
     /*  957593 */     GIR_EraseRootFromParent_Done,
     /*  957594 */   // Label 14422: @957594
     /*  957594 */   GIM_Try, /*On fail goto*//*Label 14423*/ GIMT_Encode4(957676), // Rule ID 64200 //
     /*  957599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957626 */     // MIs[0] op1
     /*  957626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957653 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M4),
     /*  957656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957658 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957660 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957662 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957664 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957674 */     GIR_RootConstrainSelectedInstOperands,
     /*  957675 */     // GIR_Coverage, 64200,
     /*  957675 */     GIR_EraseRootFromParent_Done,
     /*  957676 */   // Label 14423: @957676
     /*  957676 */   GIM_Try, /*On fail goto*//*Label 14424*/ GIMT_Encode4(957758), // Rule ID 64205 //
     /*  957681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957708 */     // MIs[0] op1
     /*  957708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957711 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957735 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  957735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  957738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957740 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957742 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957744 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957746 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957756 */     GIR_RootConstrainSelectedInstOperands,
     /*  957757 */     // GIR_Coverage, 64205,
     /*  957757 */     GIR_EraseRootFromParent_Done,
     /*  957758 */   // Label 14424: @957758
     /*  957758 */   GIM_Try, /*On fail goto*//*Label 14425*/ GIMT_Encode4(957840), // Rule ID 64206 //
     /*  957763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957790 */     // MIs[0] op1
     /*  957790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957817 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  957817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  957820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957822 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957824 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957826 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957828 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957838 */     GIR_RootConstrainSelectedInstOperands,
     /*  957839 */     // GIR_Coverage, 64206,
     /*  957839 */     GIR_EraseRootFromParent_Done,
     /*  957840 */   // Label 14425: @957840
     /*  957840 */   GIM_Try, /*On fail goto*//*Label 14426*/ GIMT_Encode4(957922), // Rule ID 64217 //
     /*  957845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  957865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957872 */     // MIs[0] op1
     /*  957872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957899 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  957899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  957902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957904 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957906 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957908 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957910 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957920 */     GIR_RootConstrainSelectedInstOperands,
     /*  957921 */     // GIR_Coverage, 64217,
     /*  957921 */     GIR_EraseRootFromParent_Done,
     /*  957922 */   // Label 14426: @957922
     /*  957922 */   GIM_Try, /*On fail goto*//*Label 14427*/ GIMT_Encode4(958004), // Rule ID 64218 //
     /*  957927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  957947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957954 */     // MIs[0] op1
     /*  957954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957957 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957981 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  957981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  957984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957986 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957988 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957990 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957992 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958002 */     GIR_RootConstrainSelectedInstOperands,
     /*  958003 */     // GIR_Coverage, 64218,
     /*  958003 */     GIR_EraseRootFromParent_Done,
     /*  958004 */   // Label 14427: @958004
     /*  958004 */   GIM_Try, /*On fail goto*//*Label 14428*/ GIMT_Encode4(958086), // Rule ID 64223 //
     /*  958009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958036 */     // MIs[0] op1
     /*  958036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958063 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_MF2),
     /*  958066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958068 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958070 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958072 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958074 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958084 */     GIR_RootConstrainSelectedInstOperands,
     /*  958085 */     // GIR_Coverage, 64223,
     /*  958085 */     GIR_EraseRootFromParent_Done,
     /*  958086 */   // Label 14428: @958086
     /*  958086 */   GIM_Try, /*On fail goto*//*Label 14429*/ GIMT_Encode4(958168), // Rule ID 64224 //
     /*  958091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958118 */     // MIs[0] op1
     /*  958118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958145 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_MF2),
     /*  958148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958150 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958152 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958154 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958156 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958166 */     GIR_RootConstrainSelectedInstOperands,
     /*  958167 */     // GIR_Coverage, 64224,
     /*  958167 */     GIR_EraseRootFromParent_Done,
     /*  958168 */   // Label 14429: @958168
     /*  958168 */   GIM_Try, /*On fail goto*//*Label 14430*/ GIMT_Encode4(958250), // Rule ID 64229 //
     /*  958173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958200 */     // MIs[0] op1
     /*  958200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958227 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  958230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958232 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958234 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958236 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958238 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958248 */     GIR_RootConstrainSelectedInstOperands,
     /*  958249 */     // GIR_Coverage, 64229,
     /*  958249 */     GIR_EraseRootFromParent_Done,
     /*  958250 */   // Label 14430: @958250
     /*  958250 */   GIM_Try, /*On fail goto*//*Label 14431*/ GIMT_Encode4(958332), // Rule ID 64230 //
     /*  958255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958282 */     // MIs[0] op1
     /*  958282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958309 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  958312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958314 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958316 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958318 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958320 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958330 */     GIR_RootConstrainSelectedInstOperands,
     /*  958331 */     // GIR_Coverage, 64230,
     /*  958331 */     GIR_EraseRootFromParent_Done,
     /*  958332 */   // Label 14431: @958332
     /*  958332 */   GIM_Try, /*On fail goto*//*Label 14432*/ GIMT_Encode4(958414), // Rule ID 64241 //
     /*  958337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  958357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958364 */     // MIs[0] op1
     /*  958364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958367 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958391 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  958394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958396 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958398 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958400 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958402 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958412 */     GIR_RootConstrainSelectedInstOperands,
     /*  958413 */     // GIR_Coverage, 64241,
     /*  958413 */     GIR_EraseRootFromParent_Done,
     /*  958414 */   // Label 14432: @958414
     /*  958414 */   GIM_Try, /*On fail goto*//*Label 14433*/ GIMT_Encode4(958496), // Rule ID 64242 //
     /*  958419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  958439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958446 */     // MIs[0] op1
     /*  958446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958473 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  958476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958478 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958480 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958482 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958484 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958494 */     GIR_RootConstrainSelectedInstOperands,
     /*  958495 */     // GIR_Coverage, 64242,
     /*  958495 */     GIR_EraseRootFromParent_Done,
     /*  958496 */   // Label 14433: @958496
     /*  958496 */   GIM_Try, /*On fail goto*//*Label 14434*/ GIMT_Encode4(958578), // Rule ID 64247 //
     /*  958501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958528 */     // MIs[0] op1
     /*  958528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958555 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M1),
     /*  958558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958560 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958562 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958564 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958566 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958576 */     GIR_RootConstrainSelectedInstOperands,
     /*  958577 */     // GIR_Coverage, 64247,
     /*  958577 */     GIR_EraseRootFromParent_Done,
     /*  958578 */   // Label 14434: @958578
     /*  958578 */   GIM_Try, /*On fail goto*//*Label 14435*/ GIMT_Encode4(958660), // Rule ID 64248 //
     /*  958583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958610 */     // MIs[0] op1
     /*  958610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958613 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958637 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M1),
     /*  958640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958642 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958644 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958646 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958648 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958658 */     GIR_RootConstrainSelectedInstOperands,
     /*  958659 */     // GIR_Coverage, 64248,
     /*  958659 */     GIR_EraseRootFromParent_Done,
     /*  958660 */   // Label 14435: @958660
     /*  958660 */   GIM_Try, /*On fail goto*//*Label 14436*/ GIMT_Encode4(958742), // Rule ID 64253 //
     /*  958665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958692 */     // MIs[0] op1
     /*  958692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958719 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  958722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958724 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958726 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958728 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958730 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958740 */     GIR_RootConstrainSelectedInstOperands,
     /*  958741 */     // GIR_Coverage, 64253,
     /*  958741 */     GIR_EraseRootFromParent_Done,
     /*  958742 */   // Label 14436: @958742
     /*  958742 */   GIM_Try, /*On fail goto*//*Label 14437*/ GIMT_Encode4(958824), // Rule ID 64254 //
     /*  958747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958774 */     // MIs[0] op1
     /*  958774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958801 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  958804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958806 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958808 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958810 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958812 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958822 */     GIR_RootConstrainSelectedInstOperands,
     /*  958823 */     // GIR_Coverage, 64254,
     /*  958823 */     GIR_EraseRootFromParent_Done,
     /*  958824 */   // Label 14437: @958824
     /*  958824 */   GIM_Try, /*On fail goto*//*Label 14438*/ GIMT_Encode4(958906), // Rule ID 64265 //
     /*  958829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  958849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958856 */     // MIs[0] op1
     /*  958856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958859 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958883 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  958886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958888 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958890 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958892 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958894 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958904 */     GIR_RootConstrainSelectedInstOperands,
     /*  958905 */     // GIR_Coverage, 64265,
     /*  958905 */     GIR_EraseRootFromParent_Done,
     /*  958906 */   // Label 14438: @958906
     /*  958906 */   GIM_Try, /*On fail goto*//*Label 14439*/ GIMT_Encode4(958988), // Rule ID 64266 //
     /*  958911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  958931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958938 */     // MIs[0] op1
     /*  958938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958965 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  958968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958970 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958972 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958974 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958976 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958986 */     GIR_RootConstrainSelectedInstOperands,
     /*  958987 */     // GIR_Coverage, 64266,
     /*  958987 */     GIR_EraseRootFromParent_Done,
     /*  958988 */   // Label 14439: @958988
     /*  958988 */   GIM_Try, /*On fail goto*//*Label 14440*/ GIMT_Encode4(959070), // Rule ID 64271 //
     /*  958993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959020 */     // MIs[0] op1
     /*  959020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959047 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M2),
     /*  959050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959052 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959054 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959056 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959058 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959068 */     GIR_RootConstrainSelectedInstOperands,
     /*  959069 */     // GIR_Coverage, 64271,
     /*  959069 */     GIR_EraseRootFromParent_Done,
     /*  959070 */   // Label 14440: @959070
     /*  959070 */   GIM_Try, /*On fail goto*//*Label 14441*/ GIMT_Encode4(959152), // Rule ID 64272 //
     /*  959075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959102 */     // MIs[0] op1
     /*  959102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959129 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M2),
     /*  959132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959134 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959136 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959138 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959140 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959150 */     GIR_RootConstrainSelectedInstOperands,
     /*  959151 */     // GIR_Coverage, 64272,
     /*  959151 */     GIR_EraseRootFromParent_Done,
     /*  959152 */   // Label 14441: @959152
     /*  959152 */   GIM_Try, /*On fail goto*//*Label 14442*/ GIMT_Encode4(959234), // Rule ID 64277 //
     /*  959157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959184 */     // MIs[0] op1
     /*  959184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959187 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959211 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  959214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959216 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959218 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959220 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959222 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959232 */     GIR_RootConstrainSelectedInstOperands,
     /*  959233 */     // GIR_Coverage, 64277,
     /*  959233 */     GIR_EraseRootFromParent_Done,
     /*  959234 */   // Label 14442: @959234
     /*  959234 */   GIM_Try, /*On fail goto*//*Label 14443*/ GIMT_Encode4(959316), // Rule ID 64278 //
     /*  959239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959266 */     // MIs[0] op1
     /*  959266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959293 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  959296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959298 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959300 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959302 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959304 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959314 */     GIR_RootConstrainSelectedInstOperands,
     /*  959315 */     // GIR_Coverage, 64278,
     /*  959315 */     GIR_EraseRootFromParent_Done,
     /*  959316 */   // Label 14443: @959316
     /*  959316 */   GIM_Try, /*On fail goto*//*Label 14444*/ GIMT_Encode4(959398), // Rule ID 64289 //
     /*  959321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  959341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959348 */     // MIs[0] op1
     /*  959348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959375 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11093:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  959378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959380 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959382 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959384 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959386 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959396 */     GIR_RootConstrainSelectedInstOperands,
     /*  959397 */     // GIR_Coverage, 64289,
     /*  959397 */     GIR_EraseRootFromParent_Done,
     /*  959398 */   // Label 14444: @959398
     /*  959398 */   GIM_Try, /*On fail goto*//*Label 14445*/ GIMT_Encode4(959480), // Rule ID 64290 //
     /*  959403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  959423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959430 */     // MIs[0] op1
     /*  959430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959457 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  959460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959462 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959464 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959466 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959468 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959478 */     GIR_RootConstrainSelectedInstOperands,
     /*  959479 */     // GIR_Coverage, 64290,
     /*  959479 */     GIR_EraseRootFromParent_Done,
     /*  959480 */   // Label 14445: @959480
     /*  959480 */   GIM_Try, /*On fail goto*//*Label 14446*/ GIMT_Encode4(959562), // Rule ID 64295 //
     /*  959485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959512 */     // MIs[0] op1
     /*  959512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959515 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959539 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M4),
     /*  959542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959544 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959546 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959548 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959550 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959560 */     GIR_RootConstrainSelectedInstOperands,
     /*  959561 */     // GIR_Coverage, 64295,
     /*  959561 */     GIR_EraseRootFromParent_Done,
     /*  959562 */   // Label 14446: @959562
     /*  959562 */   GIM_Try, /*On fail goto*//*Label 14447*/ GIMT_Encode4(959644), // Rule ID 64296 //
     /*  959567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959594 */     // MIs[0] op1
     /*  959594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959597 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959621 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M4),
     /*  959624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959626 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959628 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959630 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959632 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959642 */     GIR_RootConstrainSelectedInstOperands,
     /*  959643 */     // GIR_Coverage, 64296,
     /*  959643 */     GIR_EraseRootFromParent_Done,
     /*  959644 */   // Label 14447: @959644
     /*  959644 */   GIM_Try, /*On fail goto*//*Label 14448*/ GIMT_Encode4(959736), // Rule ID 5208 //
     /*  959649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  959652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  959660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  959663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  959666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  959669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  959672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959699 */     // MIs[1] Operand 1
     /*  959699 */     // No operand predicates
     /*  959699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959712 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  959712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  959715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959734 */     GIR_RootConstrainSelectedInstOperands,
     /*  959735 */     // GIR_Coverage, 5208,
     /*  959735 */     GIR_EraseRootFromParent_Done,
     /*  959736 */   // Label 14448: @959736
     /*  959736 */   GIM_Try, /*On fail goto*//*Label 14449*/ GIMT_Encode4(959828), // Rule ID 5209 //
     /*  959741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  959744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  959752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  959755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  959758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  959761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  959764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959791 */     // MIs[1] Operand 1
     /*  959791 */     // No operand predicates
     /*  959791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959804 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  959804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  959807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959826 */     GIR_RootConstrainSelectedInstOperands,
     /*  959827 */     // GIR_Coverage, 5209,
     /*  959827 */     GIR_EraseRootFromParent_Done,
     /*  959828 */   // Label 14449: @959828
     /*  959828 */   GIM_Try, /*On fail goto*//*Label 14450*/ GIMT_Encode4(959920), // Rule ID 5210 //
     /*  959833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  959836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  959844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  959847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  959850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  959853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  959856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959883 */     // MIs[1] Operand 1
     /*  959883 */     // No operand predicates
     /*  959883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959896 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  959896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  959899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959918 */     GIR_RootConstrainSelectedInstOperands,
     /*  959919 */     // GIR_Coverage, 5210,
     /*  959919 */     GIR_EraseRootFromParent_Done,
     /*  959920 */   // Label 14450: @959920
     /*  959920 */   GIM_Try, /*On fail goto*//*Label 14451*/ GIMT_Encode4(960012), // Rule ID 5211 //
     /*  959925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  959928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  959936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  959939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  959942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  959945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  959948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959975 */     // MIs[1] Operand 1
     /*  959975 */     // No operand predicates
     /*  959975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959988 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  959988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  959991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960010 */     GIR_RootConstrainSelectedInstOperands,
     /*  960011 */     // GIR_Coverage, 5211,
     /*  960011 */     GIR_EraseRootFromParent_Done,
     /*  960012 */   // Label 14451: @960012
     /*  960012 */   GIM_Try, /*On fail goto*//*Label 14452*/ GIMT_Encode4(960104), // Rule ID 5212 //
     /*  960017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  960028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  960031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  960034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  960040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960067 */     // MIs[1] Operand 1
     /*  960067 */     // No operand predicates
     /*  960067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960080 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  960080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960102 */     GIR_RootConstrainSelectedInstOperands,
     /*  960103 */     // GIR_Coverage, 5212,
     /*  960103 */     GIR_EraseRootFromParent_Done,
     /*  960104 */   // Label 14452: @960104
     /*  960104 */   GIM_Try, /*On fail goto*//*Label 14453*/ GIMT_Encode4(960196), // Rule ID 5213 //
     /*  960109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  960120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  960123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  960126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  960132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960159 */     // MIs[1] Operand 1
     /*  960159 */     // No operand predicates
     /*  960159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960172 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  960172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960194 */     GIR_RootConstrainSelectedInstOperands,
     /*  960195 */     // GIR_Coverage, 5213,
     /*  960195 */     GIR_EraseRootFromParent_Done,
     /*  960196 */   // Label 14453: @960196
     /*  960196 */   GIM_Try, /*On fail goto*//*Label 14454*/ GIMT_Encode4(960288), // Rule ID 5214 //
     /*  960201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  960212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  960215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  960218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960251 */     // MIs[1] Operand 1
     /*  960251 */     // No operand predicates
     /*  960251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960264 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  960267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960286 */     GIR_RootConstrainSelectedInstOperands,
     /*  960287 */     // GIR_Coverage, 5214,
     /*  960287 */     GIR_EraseRootFromParent_Done,
     /*  960288 */   // Label 14454: @960288
     /*  960288 */   GIM_Try, /*On fail goto*//*Label 14455*/ GIMT_Encode4(960380), // Rule ID 5215 //
     /*  960293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  960304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  960307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  960310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960343 */     // MIs[1] Operand 1
     /*  960343 */     // No operand predicates
     /*  960343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960356 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  960359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960378 */     GIR_RootConstrainSelectedInstOperands,
     /*  960379 */     // GIR_Coverage, 5215,
     /*  960379 */     GIR_EraseRootFromParent_Done,
     /*  960380 */   // Label 14455: @960380
     /*  960380 */   GIM_Try, /*On fail goto*//*Label 14456*/ GIMT_Encode4(960472), // Rule ID 5216 //
     /*  960385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  960396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  960399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  960402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960435 */     // MIs[1] Operand 1
     /*  960435 */     // No operand predicates
     /*  960435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960448 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960470 */     GIR_RootConstrainSelectedInstOperands,
     /*  960471 */     // GIR_Coverage, 5216,
     /*  960471 */     GIR_EraseRootFromParent_Done,
     /*  960472 */   // Label 14456: @960472
     /*  960472 */   GIM_Try, /*On fail goto*//*Label 14457*/ GIMT_Encode4(960564), // Rule ID 5217 //
     /*  960477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  960488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  960491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  960494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960527 */     // MIs[1] Operand 1
     /*  960527 */     // No operand predicates
     /*  960527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960540 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960562 */     GIR_RootConstrainSelectedInstOperands,
     /*  960563 */     // GIR_Coverage, 5217,
     /*  960563 */     GIR_EraseRootFromParent_Done,
     /*  960564 */   // Label 14457: @960564
     /*  960564 */   GIM_Try, /*On fail goto*//*Label 14458*/ GIMT_Encode4(960656), // Rule ID 5218 //
     /*  960569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  960580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  960583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  960586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960619 */     // MIs[1] Operand 1
     /*  960619 */     // No operand predicates
     /*  960619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960632 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  960632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960654 */     GIR_RootConstrainSelectedInstOperands,
     /*  960655 */     // GIR_Coverage, 5218,
     /*  960655 */     GIR_EraseRootFromParent_Done,
     /*  960656 */   // Label 14458: @960656
     /*  960656 */   GIM_Try, /*On fail goto*//*Label 14459*/ GIMT_Encode4(960748), // Rule ID 5219 //
     /*  960661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  960672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  960675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  960678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960711 */     // MIs[1] Operand 1
     /*  960711 */     // No operand predicates
     /*  960711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  960724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960746 */     GIR_RootConstrainSelectedInstOperands,
     /*  960747 */     // GIR_Coverage, 5219,
     /*  960747 */     GIR_EraseRootFromParent_Done,
     /*  960748 */   // Label 14459: @960748
     /*  960748 */   GIM_Try, /*On fail goto*//*Label 14460*/ GIMT_Encode4(960840), // Rule ID 5220 //
     /*  960753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  960764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  960767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  960770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  960776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960803 */     // MIs[1] Operand 1
     /*  960803 */     // No operand predicates
     /*  960803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960816 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  960816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  960819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960838 */     GIR_RootConstrainSelectedInstOperands,
     /*  960839 */     // GIR_Coverage, 5220,
     /*  960839 */     GIR_EraseRootFromParent_Done,
     /*  960840 */   // Label 14460: @960840
     /*  960840 */   GIM_Try, /*On fail goto*//*Label 14461*/ GIMT_Encode4(960932), // Rule ID 5221 //
     /*  960845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  960856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  960859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  960862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  960868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960895 */     // MIs[1] Operand 1
     /*  960895 */     // No operand predicates
     /*  960895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960908 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  960908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  960911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960930 */     GIR_RootConstrainSelectedInstOperands,
     /*  960931 */     // GIR_Coverage, 5221,
     /*  960931 */     GIR_EraseRootFromParent_Done,
     /*  960932 */   // Label 14461: @960932
     /*  960932 */   GIM_Try, /*On fail goto*//*Label 14462*/ GIMT_Encode4(961024), // Rule ID 5222 //
     /*  960937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  960948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  960951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  960954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  960960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960987 */     // MIs[1] Operand 1
     /*  960987 */     // No operand predicates
     /*  960987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961000 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  961000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961022 */     GIR_RootConstrainSelectedInstOperands,
     /*  961023 */     // GIR_Coverage, 5222,
     /*  961023 */     GIR_EraseRootFromParent_Done,
     /*  961024 */   // Label 14462: @961024
     /*  961024 */   GIM_Try, /*On fail goto*//*Label 14463*/ GIMT_Encode4(961116), // Rule ID 5223 //
     /*  961029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  961040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  961043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  961046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  961052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961079 */     // MIs[1] Operand 1
     /*  961079 */     // No operand predicates
     /*  961079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961092 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  961092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961114 */     GIR_RootConstrainSelectedInstOperands,
     /*  961115 */     // GIR_Coverage, 5223,
     /*  961115 */     GIR_EraseRootFromParent_Done,
     /*  961116 */   // Label 14463: @961116
     /*  961116 */   GIM_Try, /*On fail goto*//*Label 14464*/ GIMT_Encode4(961208), // Rule ID 5224 //
     /*  961121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  961132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  961135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  961138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  961144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961171 */     // MIs[1] Operand 1
     /*  961171 */     // No operand predicates
     /*  961171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961184 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  961184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961206 */     GIR_RootConstrainSelectedInstOperands,
     /*  961207 */     // GIR_Coverage, 5224,
     /*  961207 */     GIR_EraseRootFromParent_Done,
     /*  961208 */   // Label 14464: @961208
     /*  961208 */   GIM_Try, /*On fail goto*//*Label 14465*/ GIMT_Encode4(961300), // Rule ID 5225 //
     /*  961213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  961224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  961227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  961230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  961236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961263 */     // MIs[1] Operand 1
     /*  961263 */     // No operand predicates
     /*  961263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961276 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  961276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961298 */     GIR_RootConstrainSelectedInstOperands,
     /*  961299 */     // GIR_Coverage, 5225,
     /*  961299 */     GIR_EraseRootFromParent_Done,
     /*  961300 */   // Label 14465: @961300
     /*  961300 */   GIM_Try, /*On fail goto*//*Label 14466*/ GIMT_Encode4(961392), // Rule ID 5226 //
     /*  961305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  961308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  961319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  961328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961355 */     // MIs[1] Operand 1
     /*  961355 */     // No operand predicates
     /*  961355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961368 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  961368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  961390 */     GIR_RootConstrainSelectedInstOperands,
     /*  961391 */     // GIR_Coverage, 5226,
     /*  961391 */     GIR_EraseRootFromParent_Done,
     /*  961392 */   // Label 14466: @961392
     /*  961392 */   GIM_Try, /*On fail goto*//*Label 14467*/ GIMT_Encode4(961484), // Rule ID 5227 //
     /*  961397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  961400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  961411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  961420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961447 */     // MIs[1] Operand 1
     /*  961447 */     // No operand predicates
     /*  961447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961460 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  961460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  961482 */     GIR_RootConstrainSelectedInstOperands,
     /*  961483 */     // GIR_Coverage, 5227,
     /*  961483 */     GIR_EraseRootFromParent_Done,
     /*  961484 */   // Label 14467: @961484
     /*  961484 */   GIM_Try, /*On fail goto*//*Label 14468*/ GIMT_Encode4(961576), // Rule ID 5228 //
     /*  961489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  961500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  961503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  961506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  961512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  961519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961539 */     // MIs[1] Operand 1
     /*  961539 */     // No operand predicates
     /*  961539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  961552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  961555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961574 */     GIR_RootConstrainSelectedInstOperands,
     /*  961575 */     // GIR_Coverage, 5228,
     /*  961575 */     GIR_EraseRootFromParent_Done,
     /*  961576 */   // Label 14468: @961576
     /*  961576 */   GIM_Try, /*On fail goto*//*Label 14469*/ GIMT_Encode4(961668), // Rule ID 5229 //
     /*  961581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  961592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  961595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  961598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  961604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  961611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961631 */     // MIs[1] Operand 1
     /*  961631 */     // No operand predicates
     /*  961631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  961644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  961647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961666 */     GIR_RootConstrainSelectedInstOperands,
     /*  961667 */     // GIR_Coverage, 5229,
     /*  961667 */     GIR_EraseRootFromParent_Done,
     /*  961668 */   // Label 14469: @961668
     /*  961668 */   GIM_Try, /*On fail goto*//*Label 14470*/ GIMT_Encode4(961760), // Rule ID 5230 //
     /*  961673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  961684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  961687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  961690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  961696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  961703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961723 */     // MIs[1] Operand 1
     /*  961723 */     // No operand predicates
     /*  961723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961736 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  961736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  961739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961758 */     GIR_RootConstrainSelectedInstOperands,
     /*  961759 */     // GIR_Coverage, 5230,
     /*  961759 */     GIR_EraseRootFromParent_Done,
     /*  961760 */   // Label 14470: @961760
     /*  961760 */   GIM_Try, /*On fail goto*//*Label 14471*/ GIMT_Encode4(961852), // Rule ID 5231 //
     /*  961765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  961776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  961779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  961782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  961788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  961795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961815 */     // MIs[1] Operand 1
     /*  961815 */     // No operand predicates
     /*  961815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961828 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  961828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  961831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961850 */     GIR_RootConstrainSelectedInstOperands,
     /*  961851 */     // GIR_Coverage, 5231,
     /*  961851 */     GIR_EraseRootFromParent_Done,
     /*  961852 */   // Label 14471: @961852
     /*  961852 */   GIM_Try, /*On fail goto*//*Label 14472*/ GIMT_Encode4(961944), // Rule ID 5232 //
     /*  961857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  961868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  961871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  961874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  961880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  961887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961907 */     // MIs[1] Operand 1
     /*  961907 */     // No operand predicates
     /*  961907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961920 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  961920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  961923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961942 */     GIR_RootConstrainSelectedInstOperands,
     /*  961943 */     // GIR_Coverage, 5232,
     /*  961943 */     GIR_EraseRootFromParent_Done,
     /*  961944 */   // Label 14472: @961944
     /*  961944 */   GIM_Try, /*On fail goto*//*Label 14473*/ GIMT_Encode4(962036), // Rule ID 5233 //
     /*  961949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  961960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  961963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  961966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  961972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  961979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961999 */     // MIs[1] Operand 1
     /*  961999 */     // No operand predicates
     /*  961999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962012 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  962012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962034 */     GIR_RootConstrainSelectedInstOperands,
     /*  962035 */     // GIR_Coverage, 5233,
     /*  962035 */     GIR_EraseRootFromParent_Done,
     /*  962036 */   // Label 14473: @962036
     /*  962036 */   GIM_Try, /*On fail goto*//*Label 14474*/ GIMT_Encode4(962128), // Rule ID 5234 //
     /*  962041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  962052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  962055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  962058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962091 */     // MIs[1] Operand 1
     /*  962091 */     // No operand predicates
     /*  962091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962104 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  962104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962126 */     GIR_RootConstrainSelectedInstOperands,
     /*  962127 */     // GIR_Coverage, 5234,
     /*  962127 */     GIR_EraseRootFromParent_Done,
     /*  962128 */   // Label 14474: @962128
     /*  962128 */   GIM_Try, /*On fail goto*//*Label 14475*/ GIMT_Encode4(962220), // Rule ID 5235 //
     /*  962133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  962144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  962147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  962150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962183 */     // MIs[1] Operand 1
     /*  962183 */     // No operand predicates
     /*  962183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962196 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  962196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962218 */     GIR_RootConstrainSelectedInstOperands,
     /*  962219 */     // GIR_Coverage, 5235,
     /*  962219 */     GIR_EraseRootFromParent_Done,
     /*  962220 */   // Label 14475: @962220
     /*  962220 */   GIM_Try, /*On fail goto*//*Label 14476*/ GIMT_Encode4(962312), // Rule ID 5236 //
     /*  962225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  962236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  962239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  962242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962275 */     // MIs[1] Operand 1
     /*  962275 */     // No operand predicates
     /*  962275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962288 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  962288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962310 */     GIR_RootConstrainSelectedInstOperands,
     /*  962311 */     // GIR_Coverage, 5236,
     /*  962311 */     GIR_EraseRootFromParent_Done,
     /*  962312 */   // Label 14476: @962312
     /*  962312 */   GIM_Try, /*On fail goto*//*Label 14477*/ GIMT_Encode4(962404), // Rule ID 5237 //
     /*  962317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  962328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  962331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  962334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962367 */     // MIs[1] Operand 1
     /*  962367 */     // No operand predicates
     /*  962367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962380 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  962380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962402 */     GIR_RootConstrainSelectedInstOperands,
     /*  962403 */     // GIR_Coverage, 5237,
     /*  962403 */     GIR_EraseRootFromParent_Done,
     /*  962404 */   // Label 14477: @962404
     /*  962404 */   GIM_Try, /*On fail goto*//*Label 14478*/ GIMT_Encode4(962496), // Rule ID 5238 //
     /*  962409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  962420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  962423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  962426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  962432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962459 */     // MIs[1] Operand 1
     /*  962459 */     // No operand predicates
     /*  962459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962472 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  962472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962494 */     GIR_RootConstrainSelectedInstOperands,
     /*  962495 */     // GIR_Coverage, 5238,
     /*  962495 */     GIR_EraseRootFromParent_Done,
     /*  962496 */   // Label 14478: @962496
     /*  962496 */   GIM_Try, /*On fail goto*//*Label 14479*/ GIMT_Encode4(962588), // Rule ID 5239 //
     /*  962501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  962512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  962515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  962518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  962524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962551 */     // MIs[1] Operand 1
     /*  962551 */     // No operand predicates
     /*  962551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962564 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  962564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962586 */     GIR_RootConstrainSelectedInstOperands,
     /*  962587 */     // GIR_Coverage, 5239,
     /*  962587 */     GIR_EraseRootFromParent_Done,
     /*  962588 */   // Label 14479: @962588
     /*  962588 */   GIM_Try, /*On fail goto*//*Label 14480*/ GIMT_Encode4(962680), // Rule ID 5240 //
     /*  962593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  962604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  962607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  962610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  962616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962643 */     // MIs[1] Operand 1
     /*  962643 */     // No operand predicates
     /*  962643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962678 */     GIR_RootConstrainSelectedInstOperands,
     /*  962679 */     // GIR_Coverage, 5240,
     /*  962679 */     GIR_EraseRootFromParent_Done,
     /*  962680 */   // Label 14480: @962680
     /*  962680 */   GIM_Try, /*On fail goto*//*Label 14481*/ GIMT_Encode4(962772), // Rule ID 5241 //
     /*  962685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  962696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  962699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  962702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  962708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962735 */     // MIs[1] Operand 1
     /*  962735 */     // No operand predicates
     /*  962735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962770 */     GIR_RootConstrainSelectedInstOperands,
     /*  962771 */     // GIR_Coverage, 5241,
     /*  962771 */     GIR_EraseRootFromParent_Done,
     /*  962772 */   // Label 14481: @962772
     /*  962772 */   GIM_Try, /*On fail goto*//*Label 14482*/ GIMT_Encode4(962864), // Rule ID 5242 //
     /*  962777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  962788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  962791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  962794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962827 */     // MIs[1] Operand 1
     /*  962827 */     // No operand predicates
     /*  962827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962862 */     GIR_RootConstrainSelectedInstOperands,
     /*  962863 */     // GIR_Coverage, 5242,
     /*  962863 */     GIR_EraseRootFromParent_Done,
     /*  962864 */   // Label 14482: @962864
     /*  962864 */   GIM_Try, /*On fail goto*//*Label 14483*/ GIMT_Encode4(962956), // Rule ID 5243 //
     /*  962869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  962880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  962883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  962886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962919 */     // MIs[1] Operand 1
     /*  962919 */     // No operand predicates
     /*  962919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962932 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962954 */     GIR_RootConstrainSelectedInstOperands,
     /*  962955 */     // GIR_Coverage, 5243,
     /*  962955 */     GIR_EraseRootFromParent_Done,
     /*  962956 */   // Label 14483: @962956
     /*  962956 */   GIM_Try, /*On fail goto*//*Label 14484*/ GIMT_Encode4(963048), // Rule ID 5244 //
     /*  962961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  962972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  962975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  962978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963011 */     // MIs[1] Operand 1
     /*  963011 */     // No operand predicates
     /*  963011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963024 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963046 */     GIR_RootConstrainSelectedInstOperands,
     /*  963047 */     // GIR_Coverage, 5244,
     /*  963047 */     GIR_EraseRootFromParent_Done,
     /*  963048 */   // Label 14484: @963048
     /*  963048 */   GIM_Try, /*On fail goto*//*Label 14485*/ GIMT_Encode4(963140), // Rule ID 5245 //
     /*  963053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  963064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  963067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  963070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  963076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963103 */     // MIs[1] Operand 1
     /*  963103 */     // No operand predicates
     /*  963103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963116 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963138 */     GIR_RootConstrainSelectedInstOperands,
     /*  963139 */     // GIR_Coverage, 5245,
     /*  963139 */     GIR_EraseRootFromParent_Done,
     /*  963140 */   // Label 14485: @963140
     /*  963140 */   GIM_Try, /*On fail goto*//*Label 14486*/ GIMT_Encode4(963232), // Rule ID 5246 //
     /*  963145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  963148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  963156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  963159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  963162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963195 */     // MIs[1] Operand 1
     /*  963195 */     // No operand predicates
     /*  963195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963208 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  963208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  963211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963230 */     GIR_RootConstrainSelectedInstOperands,
     /*  963231 */     // GIR_Coverage, 5246,
     /*  963231 */     GIR_EraseRootFromParent_Done,
     /*  963232 */   // Label 14486: @963232
     /*  963232 */   GIM_Try, /*On fail goto*//*Label 14487*/ GIMT_Encode4(963324), // Rule ID 5247 //
     /*  963237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  963240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  963248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  963251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  963254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963287 */     // MIs[1] Operand 1
     /*  963287 */     // No operand predicates
     /*  963287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  963300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  963303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963322 */     GIR_RootConstrainSelectedInstOperands,
     /*  963323 */     // GIR_Coverage, 5247,
     /*  963323 */     GIR_EraseRootFromParent_Done,
     /*  963324 */   // Label 14487: @963324
     /*  963324 */   GIM_Try, /*On fail goto*//*Label 14488*/ GIMT_Encode4(963416), // Rule ID 5248 //
     /*  963329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  963332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  963340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  963343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  963346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963379 */     // MIs[1] Operand 1
     /*  963379 */     // No operand predicates
     /*  963379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963392 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  963392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  963395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963414 */     GIR_RootConstrainSelectedInstOperands,
     /*  963415 */     // GIR_Coverage, 5248,
     /*  963415 */     GIR_EraseRootFromParent_Done,
     /*  963416 */   // Label 14488: @963416
     /*  963416 */   GIM_Try, /*On fail goto*//*Label 14489*/ GIMT_Encode4(963508), // Rule ID 5249 //
     /*  963421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  963424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  963432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  963435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  963438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963471 */     // MIs[1] Operand 1
     /*  963471 */     // No operand predicates
     /*  963471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  963484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  963487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963506 */     GIR_RootConstrainSelectedInstOperands,
     /*  963507 */     // GIR_Coverage, 5249,
     /*  963507 */     GIR_EraseRootFromParent_Done,
     /*  963508 */   // Label 14489: @963508
     /*  963508 */   GIM_Try, /*On fail goto*//*Label 14490*/ GIMT_Encode4(963600), // Rule ID 5250 //
     /*  963513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  963516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  963527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  963536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963563 */     // MIs[1] Operand 1
     /*  963563 */     // No operand predicates
     /*  963563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963576 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  963576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963598 */     GIR_RootConstrainSelectedInstOperands,
     /*  963599 */     // GIR_Coverage, 5250,
     /*  963599 */     GIR_EraseRootFromParent_Done,
     /*  963600 */   // Label 14490: @963600
     /*  963600 */   GIM_Try, /*On fail goto*//*Label 14491*/ GIMT_Encode4(963692), // Rule ID 5251 //
     /*  963605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  963608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  963619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  963628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963655 */     // MIs[1] Operand 1
     /*  963655 */     // No operand predicates
     /*  963655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963668 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  963668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963690 */     GIR_RootConstrainSelectedInstOperands,
     /*  963691 */     // GIR_Coverage, 5251,
     /*  963691 */     GIR_EraseRootFromParent_Done,
     /*  963692 */   // Label 14491: @963692
     /*  963692 */   GIM_Try, /*On fail goto*//*Label 14492*/ GIMT_Encode4(963787), // Rule ID 7982 //
     /*  963697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  963708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  963711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  963714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  963720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963747 */     // MIs[1] Operand 1
     /*  963747 */     // No operand predicates
     /*  963747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963760 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  963760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  963763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963785 */     GIR_RootConstrainSelectedInstOperands,
     /*  963786 */     // GIR_Coverage, 7982,
     /*  963786 */     GIR_EraseRootFromParent_Done,
     /*  963787 */   // Label 14492: @963787
     /*  963787 */   GIM_Try, /*On fail goto*//*Label 14493*/ GIMT_Encode4(963882), // Rule ID 7983 //
     /*  963792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  963803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  963806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  963809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  963815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963842 */     // MIs[1] Operand 1
     /*  963842 */     // No operand predicates
     /*  963842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963855 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  963855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  963858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963880 */     GIR_RootConstrainSelectedInstOperands,
     /*  963881 */     // GIR_Coverage, 7983,
     /*  963881 */     GIR_EraseRootFromParent_Done,
     /*  963882 */   // Label 14493: @963882
     /*  963882 */   GIM_Try, /*On fail goto*//*Label 14494*/ GIMT_Encode4(963977), // Rule ID 7986 //
     /*  963887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  963898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  963901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  963904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963937 */     // MIs[1] Operand 1
     /*  963937 */     // No operand predicates
     /*  963937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963950 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  963950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  963953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963975 */     GIR_RootConstrainSelectedInstOperands,
     /*  963976 */     // GIR_Coverage, 7986,
     /*  963976 */     GIR_EraseRootFromParent_Done,
     /*  963977 */   // Label 14494: @963977
     /*  963977 */   GIM_Try, /*On fail goto*//*Label 14495*/ GIMT_Encode4(964072), // Rule ID 7987 //
     /*  963982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  963993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  963996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  963999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964032 */     // MIs[1] Operand 1
     /*  964032 */     // No operand predicates
     /*  964032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964045 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  964045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964070 */     GIR_RootConstrainSelectedInstOperands,
     /*  964071 */     // GIR_Coverage, 7987,
     /*  964071 */     GIR_EraseRootFromParent_Done,
     /*  964072 */   // Label 14495: @964072
     /*  964072 */   GIM_Try, /*On fail goto*//*Label 14496*/ GIMT_Encode4(964167), // Rule ID 7990 //
     /*  964077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  964088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  964091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  964094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964127 */     // MIs[1] Operand 1
     /*  964127 */     // No operand predicates
     /*  964127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  964140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964165 */     GIR_RootConstrainSelectedInstOperands,
     /*  964166 */     // GIR_Coverage, 7990,
     /*  964166 */     GIR_EraseRootFromParent_Done,
     /*  964167 */   // Label 14496: @964167
     /*  964167 */   GIM_Try, /*On fail goto*//*Label 14497*/ GIMT_Encode4(964262), // Rule ID 7991 //
     /*  964172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  964183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  964186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  964189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964222 */     // MIs[1] Operand 1
     /*  964222 */     // No operand predicates
     /*  964222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964235 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  964235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964260 */     GIR_RootConstrainSelectedInstOperands,
     /*  964261 */     // GIR_Coverage, 7991,
     /*  964261 */     GIR_EraseRootFromParent_Done,
     /*  964262 */   // Label 14497: @964262
     /*  964262 */   GIM_Try, /*On fail goto*//*Label 14498*/ GIMT_Encode4(964357), // Rule ID 7994 //
     /*  964267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  964284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964317 */     // MIs[1] Operand 1
     /*  964317 */     // No operand predicates
     /*  964317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964330 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  964330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964355 */     GIR_RootConstrainSelectedInstOperands,
     /*  964356 */     // GIR_Coverage, 7994,
     /*  964356 */     GIR_EraseRootFromParent_Done,
     /*  964357 */   // Label 14498: @964357
     /*  964357 */   GIM_Try, /*On fail goto*//*Label 14499*/ GIMT_Encode4(964452), // Rule ID 7995 //
     /*  964362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  964379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964412 */     // MIs[1] Operand 1
     /*  964412 */     // No operand predicates
     /*  964412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964425 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  964425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964450 */     GIR_RootConstrainSelectedInstOperands,
     /*  964451 */     // GIR_Coverage, 7995,
     /*  964451 */     GIR_EraseRootFromParent_Done,
     /*  964452 */   // Label 14499: @964452
     /*  964452 */   GIM_Try, /*On fail goto*//*Label 14500*/ GIMT_Encode4(964547), // Rule ID 7998 //
     /*  964457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  964468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  964471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  964474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964507 */     // MIs[1] Operand 1
     /*  964507 */     // No operand predicates
     /*  964507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964520 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  964520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964545 */     GIR_RootConstrainSelectedInstOperands,
     /*  964546 */     // GIR_Coverage, 7998,
     /*  964546 */     GIR_EraseRootFromParent_Done,
     /*  964547 */   // Label 14500: @964547
     /*  964547 */   GIM_Try, /*On fail goto*//*Label 14501*/ GIMT_Encode4(964642), // Rule ID 7999 //
     /*  964552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  964563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  964566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  964569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964602 */     // MIs[1] Operand 1
     /*  964602 */     // No operand predicates
     /*  964602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964615 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  964615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964640 */     GIR_RootConstrainSelectedInstOperands,
     /*  964641 */     // GIR_Coverage, 7999,
     /*  964641 */     GIR_EraseRootFromParent_Done,
     /*  964642 */   // Label 14501: @964642
     /*  964642 */   GIM_Try, /*On fail goto*//*Label 14502*/ GIMT_Encode4(964737), // Rule ID 8002 //
     /*  964647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  964664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964697 */     // MIs[1] Operand 1
     /*  964697 */     // No operand predicates
     /*  964697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964710 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  964710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964735 */     GIR_RootConstrainSelectedInstOperands,
     /*  964736 */     // GIR_Coverage, 8002,
     /*  964736 */     GIR_EraseRootFromParent_Done,
     /*  964737 */   // Label 14502: @964737
     /*  964737 */   GIM_Try, /*On fail goto*//*Label 14503*/ GIMT_Encode4(964832), // Rule ID 8003 //
     /*  964742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  964759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964792 */     // MIs[1] Operand 1
     /*  964792 */     // No operand predicates
     /*  964792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964805 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  964805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964830 */     GIR_RootConstrainSelectedInstOperands,
     /*  964831 */     // GIR_Coverage, 8003,
     /*  964831 */     GIR_EraseRootFromParent_Done,
     /*  964832 */   // Label 14503: @964832
     /*  964832 */   GIM_Try, /*On fail goto*//*Label 14504*/ GIMT_Encode4(964927), // Rule ID 8006 //
     /*  964837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  964848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  964851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  964854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  964860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964887 */     // MIs[1] Operand 1
     /*  964887 */     // No operand predicates
     /*  964887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964900 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  964900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  964903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964925 */     GIR_RootConstrainSelectedInstOperands,
     /*  964926 */     // GIR_Coverage, 8006,
     /*  964926 */     GIR_EraseRootFromParent_Done,
     /*  964927 */   // Label 14504: @964927
     /*  964927 */   GIM_Try, /*On fail goto*//*Label 14505*/ GIMT_Encode4(965022), // Rule ID 8007 //
     /*  964932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  964943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  964946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  964949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  964955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964982 */     // MIs[1] Operand 1
     /*  964982 */     // No operand predicates
     /*  964982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964995 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  964995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  964998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965020 */     GIR_RootConstrainSelectedInstOperands,
     /*  965021 */     // GIR_Coverage, 8007,
     /*  965021 */     GIR_EraseRootFromParent_Done,
     /*  965022 */   // Label 14505: @965022
     /*  965022 */   GIM_Try, /*On fail goto*//*Label 14506*/ GIMT_Encode4(965117), // Rule ID 8010 //
     /*  965027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  965038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  965041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  965044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  965050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965077 */     // MIs[1] Operand 1
     /*  965077 */     // No operand predicates
     /*  965077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965090 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  965090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965115 */     GIR_RootConstrainSelectedInstOperands,
     /*  965116 */     // GIR_Coverage, 8010,
     /*  965116 */     GIR_EraseRootFromParent_Done,
     /*  965117 */   // Label 14506: @965117
     /*  965117 */   GIM_Try, /*On fail goto*//*Label 14507*/ GIMT_Encode4(965212), // Rule ID 8011 //
     /*  965122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  965133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  965136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  965139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  965145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965172 */     // MIs[1] Operand 1
     /*  965172 */     // No operand predicates
     /*  965172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965185 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  965185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965210 */     GIR_RootConstrainSelectedInstOperands,
     /*  965211 */     // GIR_Coverage, 8011,
     /*  965211 */     GIR_EraseRootFromParent_Done,
     /*  965212 */   // Label 14507: @965212
     /*  965212 */   GIM_Try, /*On fail goto*//*Label 14508*/ GIMT_Encode4(965307), // Rule ID 8014 //
     /*  965217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  965228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  965231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  965234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  965240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965267 */     // MIs[1] Operand 1
     /*  965267 */     // No operand predicates
     /*  965267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965280 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  965280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965305 */     GIR_RootConstrainSelectedInstOperands,
     /*  965306 */     // GIR_Coverage, 8014,
     /*  965306 */     GIR_EraseRootFromParent_Done,
     /*  965307 */   // Label 14508: @965307
     /*  965307 */   GIM_Try, /*On fail goto*//*Label 14509*/ GIMT_Encode4(965402), // Rule ID 8015 //
     /*  965312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  965323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  965326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  965329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  965335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965362 */     // MIs[1] Operand 1
     /*  965362 */     // No operand predicates
     /*  965362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965375 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  965375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965400 */     GIR_RootConstrainSelectedInstOperands,
     /*  965401 */     // GIR_Coverage, 8015,
     /*  965401 */     GIR_EraseRootFromParent_Done,
     /*  965402 */   // Label 14509: @965402
     /*  965402 */   GIM_Try, /*On fail goto*//*Label 14510*/ GIMT_Encode4(965497), // Rule ID 8018 //
     /*  965407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  965410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  965418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  965421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  965424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965457 */     // MIs[1] Operand 1
     /*  965457 */     // No operand predicates
     /*  965457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965470 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  965470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  965492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965495 */     GIR_RootConstrainSelectedInstOperands,
     /*  965496 */     // GIR_Coverage, 8018,
     /*  965496 */     GIR_EraseRootFromParent_Done,
     /*  965497 */   // Label 14510: @965497
     /*  965497 */   GIM_Try, /*On fail goto*//*Label 14511*/ GIMT_Encode4(965592), // Rule ID 8019 //
     /*  965502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  965505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  965513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  965516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  965519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965552 */     // MIs[1] Operand 1
     /*  965552 */     // No operand predicates
     /*  965552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965565 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  965565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  965587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965590 */     GIR_RootConstrainSelectedInstOperands,
     /*  965591 */     // GIR_Coverage, 8019,
     /*  965591 */     GIR_EraseRootFromParent_Done,
     /*  965592 */   // Label 14511: @965592
     /*  965592 */   GIM_Try, /*On fail goto*//*Label 14512*/ GIMT_Encode4(965687), // Rule ID 8022 //
     /*  965597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  965608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  965611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  965614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  965620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965647 */     // MIs[1] Operand 1
     /*  965647 */     // No operand predicates
     /*  965647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965660 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  965660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  965663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965685 */     GIR_RootConstrainSelectedInstOperands,
     /*  965686 */     // GIR_Coverage, 8022,
     /*  965686 */     GIR_EraseRootFromParent_Done,
     /*  965687 */   // Label 14512: @965687
     /*  965687 */   GIM_Try, /*On fail goto*//*Label 14513*/ GIMT_Encode4(965782), // Rule ID 8023 //
     /*  965692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  965703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  965706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  965709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  965715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965742 */     // MIs[1] Operand 1
     /*  965742 */     // No operand predicates
     /*  965742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965755 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  965755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  965758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965780 */     GIR_RootConstrainSelectedInstOperands,
     /*  965781 */     // GIR_Coverage, 8023,
     /*  965781 */     GIR_EraseRootFromParent_Done,
     /*  965782 */   // Label 14513: @965782
     /*  965782 */   GIM_Try, /*On fail goto*//*Label 14514*/ GIMT_Encode4(965877), // Rule ID 8026 //
     /*  965787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  965798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  965801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  965804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  965810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965837 */     // MIs[1] Operand 1
     /*  965837 */     // No operand predicates
     /*  965837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965850 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  965850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  965853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965875 */     GIR_RootConstrainSelectedInstOperands,
     /*  965876 */     // GIR_Coverage, 8026,
     /*  965876 */     GIR_EraseRootFromParent_Done,
     /*  965877 */   // Label 14514: @965877
     /*  965877 */   GIM_Try, /*On fail goto*//*Label 14515*/ GIMT_Encode4(965972), // Rule ID 8027 //
     /*  965882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  965893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  965896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  965899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  965905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965932 */     // MIs[1] Operand 1
     /*  965932 */     // No operand predicates
     /*  965932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965945 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  965945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  965948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965970 */     GIR_RootConstrainSelectedInstOperands,
     /*  965971 */     // GIR_Coverage, 8027,
     /*  965971 */     GIR_EraseRootFromParent_Done,
     /*  965972 */   // Label 14515: @965972
     /*  965972 */   GIM_Try, /*On fail goto*//*Label 14516*/ GIMT_Encode4(966067), // Rule ID 8030 //
     /*  965977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  965988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  965991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  965994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  966000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966027 */     // MIs[1] Operand 1
     /*  966027 */     // No operand predicates
     /*  966027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966040 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  966040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966065 */     GIR_RootConstrainSelectedInstOperands,
     /*  966066 */     // GIR_Coverage, 8030,
     /*  966066 */     GIR_EraseRootFromParent_Done,
     /*  966067 */   // Label 14516: @966067
     /*  966067 */   GIM_Try, /*On fail goto*//*Label 14517*/ GIMT_Encode4(966162), // Rule ID 8031 //
     /*  966072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  966083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  966086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  966089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  966095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966122 */     // MIs[1] Operand 1
     /*  966122 */     // No operand predicates
     /*  966122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966135 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  966135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966160 */     GIR_RootConstrainSelectedInstOperands,
     /*  966161 */     // GIR_Coverage, 8031,
     /*  966161 */     GIR_EraseRootFromParent_Done,
     /*  966162 */   // Label 14517: @966162
     /*  966162 */   GIM_Try, /*On fail goto*//*Label 14518*/ GIMT_Encode4(966257), // Rule ID 8034 //
     /*  966167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  966178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  966181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  966184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966217 */     // MIs[1] Operand 1
     /*  966217 */     // No operand predicates
     /*  966217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966230 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  966230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966255 */     GIR_RootConstrainSelectedInstOperands,
     /*  966256 */     // GIR_Coverage, 8034,
     /*  966256 */     GIR_EraseRootFromParent_Done,
     /*  966257 */   // Label 14518: @966257
     /*  966257 */   GIM_Try, /*On fail goto*//*Label 14519*/ GIMT_Encode4(966352), // Rule ID 8035 //
     /*  966262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  966273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  966276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  966279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966312 */     // MIs[1] Operand 1
     /*  966312 */     // No operand predicates
     /*  966312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966325 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  966325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966350 */     GIR_RootConstrainSelectedInstOperands,
     /*  966351 */     // GIR_Coverage, 8035,
     /*  966351 */     GIR_EraseRootFromParent_Done,
     /*  966352 */   // Label 14519: @966352
     /*  966352 */   GIM_Try, /*On fail goto*//*Label 14520*/ GIMT_Encode4(966447), // Rule ID 8038 //
     /*  966357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966407 */     // MIs[1] Operand 1
     /*  966407 */     // No operand predicates
     /*  966407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966420 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  966420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966445 */     GIR_RootConstrainSelectedInstOperands,
     /*  966446 */     // GIR_Coverage, 8038,
     /*  966446 */     GIR_EraseRootFromParent_Done,
     /*  966447 */   // Label 14520: @966447
     /*  966447 */   GIM_Try, /*On fail goto*//*Label 14521*/ GIMT_Encode4(966542), // Rule ID 8039 //
     /*  966452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966502 */     // MIs[1] Operand 1
     /*  966502 */     // No operand predicates
     /*  966502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966515 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  966515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966540 */     GIR_RootConstrainSelectedInstOperands,
     /*  966541 */     // GIR_Coverage, 8039,
     /*  966541 */     GIR_EraseRootFromParent_Done,
     /*  966542 */   // Label 14521: @966542
     /*  966542 */   GIM_Try, /*On fail goto*//*Label 14522*/ GIMT_Encode4(966637), // Rule ID 8042 //
     /*  966547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  966558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  966561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  966564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966597 */     // MIs[1] Operand 1
     /*  966597 */     // No operand predicates
     /*  966597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966610 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  966610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966635 */     GIR_RootConstrainSelectedInstOperands,
     /*  966636 */     // GIR_Coverage, 8042,
     /*  966636 */     GIR_EraseRootFromParent_Done,
     /*  966637 */   // Label 14522: @966637
     /*  966637 */   GIM_Try, /*On fail goto*//*Label 14523*/ GIMT_Encode4(966732), // Rule ID 8043 //
     /*  966642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  966653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  966656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  966659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966692 */     // MIs[1] Operand 1
     /*  966692 */     // No operand predicates
     /*  966692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966705 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  966705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966730 */     GIR_RootConstrainSelectedInstOperands,
     /*  966731 */     // GIR_Coverage, 8043,
     /*  966731 */     GIR_EraseRootFromParent_Done,
     /*  966732 */   // Label 14523: @966732
     /*  966732 */   GIM_Try, /*On fail goto*//*Label 14524*/ GIMT_Encode4(966827), // Rule ID 8046 //
     /*  966737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  966748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  966751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  966754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  966760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966787 */     // MIs[1] Operand 1
     /*  966787 */     // No operand predicates
     /*  966787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966800 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  966800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966825 */     GIR_RootConstrainSelectedInstOperands,
     /*  966826 */     // GIR_Coverage, 8046,
     /*  966826 */     GIR_EraseRootFromParent_Done,
     /*  966827 */   // Label 14524: @966827
     /*  966827 */   GIM_Try, /*On fail goto*//*Label 14525*/ GIMT_Encode4(966922), // Rule ID 8047 //
     /*  966832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  966843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  966846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  966849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  966855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966882 */     // MIs[1] Operand 1
     /*  966882 */     // No operand predicates
     /*  966882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966895 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  966895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966920 */     GIR_RootConstrainSelectedInstOperands,
     /*  966921 */     // GIR_Coverage, 8047,
     /*  966921 */     GIR_EraseRootFromParent_Done,
     /*  966922 */   // Label 14525: @966922
     /*  966922 */   GIM_Try, /*On fail goto*//*Label 14526*/ GIMT_Encode4(967017), // Rule ID 8050 //
     /*  966927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  966938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  966941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  966944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966977 */     // MIs[1] Operand 1
     /*  966977 */     // No operand predicates
     /*  966977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966990 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  966990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967015 */     GIR_RootConstrainSelectedInstOperands,
     /*  967016 */     // GIR_Coverage, 8050,
     /*  967016 */     GIR_EraseRootFromParent_Done,
     /*  967017 */   // Label 14526: @967017
     /*  967017 */   GIM_Try, /*On fail goto*//*Label 14527*/ GIMT_Encode4(967112), // Rule ID 8051 //
     /*  967022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  967033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  967036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  967039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967072 */     // MIs[1] Operand 1
     /*  967072 */     // No operand predicates
     /*  967072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967085 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  967085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  967088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967110 */     GIR_RootConstrainSelectedInstOperands,
     /*  967111 */     // GIR_Coverage, 8051,
     /*  967111 */     GIR_EraseRootFromParent_Done,
     /*  967112 */   // Label 14527: @967112
     /*  967112 */   GIM_Try, /*On fail goto*//*Label 14528*/ GIMT_Encode4(967207), // Rule ID 8054 //
     /*  967117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  967128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  967131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  967134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  967140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967167 */     // MIs[1] Operand 1
     /*  967167 */     // No operand predicates
     /*  967167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967180 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  967180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967205 */     GIR_RootConstrainSelectedInstOperands,
     /*  967206 */     // GIR_Coverage, 8054,
     /*  967206 */     GIR_EraseRootFromParent_Done,
     /*  967207 */   // Label 14528: @967207
     /*  967207 */   GIM_Try, /*On fail goto*//*Label 14529*/ GIMT_Encode4(967302), // Rule ID 8055 //
     /*  967212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  967223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  967226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  967229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  967235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967262 */     // MIs[1] Operand 1
     /*  967262 */     // No operand predicates
     /*  967262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967275 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  967275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967300 */     GIR_RootConstrainSelectedInstOperands,
     /*  967301 */     // GIR_Coverage, 8055,
     /*  967301 */     GIR_EraseRootFromParent_Done,
     /*  967302 */   // Label 14529: @967302
     /*  967302 */   GIM_Try, /*On fail goto*//*Label 14530*/ GIMT_Encode4(967397), // Rule ID 8058 //
     /*  967307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  967324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967357 */     // MIs[1] Operand 1
     /*  967357 */     // No operand predicates
     /*  967357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967370 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  967370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  967373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967395 */     GIR_RootConstrainSelectedInstOperands,
     /*  967396 */     // GIR_Coverage, 8058,
     /*  967396 */     GIR_EraseRootFromParent_Done,
     /*  967397 */   // Label 14530: @967397
     /*  967397 */   GIM_Try, /*On fail goto*//*Label 14531*/ GIMT_Encode4(967492), // Rule ID 8059 //
     /*  967402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  967419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967452 */     // MIs[1] Operand 1
     /*  967452 */     // No operand predicates
     /*  967452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967465 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  967465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  967468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967490 */     GIR_RootConstrainSelectedInstOperands,
     /*  967491 */     // GIR_Coverage, 8059,
     /*  967491 */     GIR_EraseRootFromParent_Done,
     /*  967492 */   // Label 14531: @967492
     /*  967492 */   GIM_Try, /*On fail goto*//*Label 14532*/ GIMT_Encode4(967587), // Rule ID 8062 //
     /*  967497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  967514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967547 */     // MIs[1] Operand 1
     /*  967547 */     // No operand predicates
     /*  967547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967560 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  967560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  967563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967585 */     GIR_RootConstrainSelectedInstOperands,
     /*  967586 */     // GIR_Coverage, 8062,
     /*  967586 */     GIR_EraseRootFromParent_Done,
     /*  967587 */   // Label 14532: @967587
     /*  967587 */   GIM_Try, /*On fail goto*//*Label 14533*/ GIMT_Encode4(967682), // Rule ID 8063 //
     /*  967592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  967609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967642 */     // MIs[1] Operand 1
     /*  967642 */     // No operand predicates
     /*  967642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967655 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  967655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  967658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967680 */     GIR_RootConstrainSelectedInstOperands,
     /*  967681 */     // GIR_Coverage, 8063,
     /*  967681 */     GIR_EraseRootFromParent_Done,
     /*  967682 */   // Label 14533: @967682
     /*  967682 */   GIM_Try, /*On fail goto*//*Label 14534*/ GIMT_Encode4(967777), // Rule ID 8066 //
     /*  967687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  967698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  967701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  967704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967737 */     // MIs[1] Operand 1
     /*  967737 */     // No operand predicates
     /*  967737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967750 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  967750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967775 */     GIR_RootConstrainSelectedInstOperands,
     /*  967776 */     // GIR_Coverage, 8066,
     /*  967776 */     GIR_EraseRootFromParent_Done,
     /*  967777 */   // Label 14534: @967777
     /*  967777 */   GIM_Try, /*On fail goto*//*Label 14535*/ GIMT_Encode4(967872), // Rule ID 8067 //
     /*  967782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  967793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  967796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  967799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967832 */     // MIs[1] Operand 1
     /*  967832 */     // No operand predicates
     /*  967832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967845 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  967845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967870 */     GIR_RootConstrainSelectedInstOperands,
     /*  967871 */     // GIR_Coverage, 8067,
     /*  967871 */     GIR_EraseRootFromParent_Done,
     /*  967872 */   // Label 14535: @967872
     /*  967872 */   GIM_Try, /*On fail goto*//*Label 14536*/ GIMT_Encode4(967967), // Rule ID 8246 //
     /*  967877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  967885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  967888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  967891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  967894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  967900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967927 */     // MIs[1] Operand 1
     /*  967927 */     // No operand predicates
     /*  967927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967940 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  967940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  967943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967965 */     GIR_RootConstrainSelectedInstOperands,
     /*  967966 */     // GIR_Coverage, 8246,
     /*  967966 */     GIR_EraseRootFromParent_Done,
     /*  967967 */   // Label 14536: @967967
     /*  967967 */   GIM_Try, /*On fail goto*//*Label 14537*/ GIMT_Encode4(968062), // Rule ID 8247 //
     /*  967972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  967980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  967983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  967986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  967989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  967995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968022 */     // MIs[1] Operand 1
     /*  968022 */     // No operand predicates
     /*  968022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968035 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  968038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968060 */     GIR_RootConstrainSelectedInstOperands,
     /*  968061 */     // GIR_Coverage, 8247,
     /*  968061 */     GIR_EraseRootFromParent_Done,
     /*  968062 */   // Label 14537: @968062
     /*  968062 */   GIM_Try, /*On fail goto*//*Label 14538*/ GIMT_Encode4(968157), // Rule ID 8250 //
     /*  968067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  968084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968117 */     // MIs[1] Operand 1
     /*  968117 */     // No operand predicates
     /*  968117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968130 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  968130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968155 */     GIR_RootConstrainSelectedInstOperands,
     /*  968156 */     // GIR_Coverage, 8250,
     /*  968156 */     GIR_EraseRootFromParent_Done,
     /*  968157 */   // Label 14538: @968157
     /*  968157 */   GIM_Try, /*On fail goto*//*Label 14539*/ GIMT_Encode4(968252), // Rule ID 8251 //
     /*  968162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  968179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968212 */     // MIs[1] Operand 1
     /*  968212 */     // No operand predicates
     /*  968212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968225 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968250 */     GIR_RootConstrainSelectedInstOperands,
     /*  968251 */     // GIR_Coverage, 8251,
     /*  968251 */     GIR_EraseRootFromParent_Done,
     /*  968252 */   // Label 14539: @968252
     /*  968252 */   GIM_Try, /*On fail goto*//*Label 14540*/ GIMT_Encode4(968347), // Rule ID 8254 //
     /*  968257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  968274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968307 */     // MIs[1] Operand 1
     /*  968307 */     // No operand predicates
     /*  968307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968320 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  968320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968345 */     GIR_RootConstrainSelectedInstOperands,
     /*  968346 */     // GIR_Coverage, 8254,
     /*  968346 */     GIR_EraseRootFromParent_Done,
     /*  968347 */   // Label 14540: @968347
     /*  968347 */   GIM_Try, /*On fail goto*//*Label 14541*/ GIMT_Encode4(968442), // Rule ID 8255 //
     /*  968352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  968369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968402 */     // MIs[1] Operand 1
     /*  968402 */     // No operand predicates
     /*  968402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968415 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968440 */     GIR_RootConstrainSelectedInstOperands,
     /*  968441 */     // GIR_Coverage, 8255,
     /*  968441 */     GIR_EraseRootFromParent_Done,
     /*  968442 */   // Label 14541: @968442
     /*  968442 */   GIM_Try, /*On fail goto*//*Label 14542*/ GIMT_Encode4(968537), // Rule ID 8258 //
     /*  968447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  968464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968497 */     // MIs[1] Operand 1
     /*  968497 */     // No operand predicates
     /*  968497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968510 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968535 */     GIR_RootConstrainSelectedInstOperands,
     /*  968536 */     // GIR_Coverage, 8258,
     /*  968536 */     GIR_EraseRootFromParent_Done,
     /*  968537 */   // Label 14542: @968537
     /*  968537 */   GIM_Try, /*On fail goto*//*Label 14543*/ GIMT_Encode4(968632), // Rule ID 8259 //
     /*  968542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  968559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968592 */     // MIs[1] Operand 1
     /*  968592 */     // No operand predicates
     /*  968592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968605 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  968605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968630 */     GIR_RootConstrainSelectedInstOperands,
     /*  968631 */     // GIR_Coverage, 8259,
     /*  968631 */     GIR_EraseRootFromParent_Done,
     /*  968632 */   // Label 14543: @968632
     /*  968632 */   GIM_Try, /*On fail goto*//*Label 14544*/ GIMT_Encode4(968727), // Rule ID 8262 //
     /*  968637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  968654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968687 */     // MIs[1] Operand 1
     /*  968687 */     // No operand predicates
     /*  968687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968700 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968725 */     GIR_RootConstrainSelectedInstOperands,
     /*  968726 */     // GIR_Coverage, 8262,
     /*  968726 */     GIR_EraseRootFromParent_Done,
     /*  968727 */   // Label 14544: @968727
     /*  968727 */   GIM_Try, /*On fail goto*//*Label 14545*/ GIMT_Encode4(968822), // Rule ID 8263 //
     /*  968732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  968749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968782 */     // MIs[1] Operand 1
     /*  968782 */     // No operand predicates
     /*  968782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968795 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  968795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968820 */     GIR_RootConstrainSelectedInstOperands,
     /*  968821 */     // GIR_Coverage, 8263,
     /*  968821 */     GIR_EraseRootFromParent_Done,
     /*  968822 */   // Label 14545: @968822
     /*  968822 */   GIM_Try, /*On fail goto*//*Label 14546*/ GIMT_Encode4(968917), // Rule ID 8266 //
     /*  968827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  968844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968877 */     // MIs[1] Operand 1
     /*  968877 */     // No operand predicates
     /*  968877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968890 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  968890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  968912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968915 */     GIR_RootConstrainSelectedInstOperands,
     /*  968916 */     // GIR_Coverage, 8266,
     /*  968916 */     GIR_EraseRootFromParent_Done,
     /*  968917 */   // Label 14546: @968917
     /*  968917 */   GIM_Try, /*On fail goto*//*Label 14547*/ GIMT_Encode4(969012), // Rule ID 8267 //
     /*  968922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  968939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968972 */     // MIs[1] Operand 1
     /*  968972 */     // No operand predicates
     /*  968972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968985 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  968985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969010 */     GIR_RootConstrainSelectedInstOperands,
     /*  969011 */     // GIR_Coverage, 8267,
     /*  969011 */     GIR_EraseRootFromParent_Done,
     /*  969012 */   // Label 14547: @969012
     /*  969012 */   GIM_Try, /*On fail goto*//*Label 14548*/ GIMT_Encode4(969107), // Rule ID 8270 //
     /*  969017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  969028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  969031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  969034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  969040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969067 */     // MIs[1] Operand 1
     /*  969067 */     // No operand predicates
     /*  969067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969080 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969105 */     GIR_RootConstrainSelectedInstOperands,
     /*  969106 */     // GIR_Coverage, 8270,
     /*  969106 */     GIR_EraseRootFromParent_Done,
     /*  969107 */   // Label 14548: @969107
     /*  969107 */   GIM_Try, /*On fail goto*//*Label 14549*/ GIMT_Encode4(969202), // Rule ID 8271 //
     /*  969112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  969123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  969126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  969129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  969135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969162 */     // MIs[1] Operand 1
     /*  969162 */     // No operand predicates
     /*  969162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969175 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969200 */     GIR_RootConstrainSelectedInstOperands,
     /*  969201 */     // GIR_Coverage, 8271,
     /*  969201 */     GIR_EraseRootFromParent_Done,
     /*  969202 */   // Label 14549: @969202
     /*  969202 */   GIM_Try, /*On fail goto*//*Label 14550*/ GIMT_Encode4(969297), // Rule ID 8274 //
     /*  969207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  969218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  969221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  969224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  969230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969257 */     // MIs[1] Operand 1
     /*  969257 */     // No operand predicates
     /*  969257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969270 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  969270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969295 */     GIR_RootConstrainSelectedInstOperands,
     /*  969296 */     // GIR_Coverage, 8274,
     /*  969296 */     GIR_EraseRootFromParent_Done,
     /*  969297 */   // Label 14550: @969297
     /*  969297 */   GIM_Try, /*On fail goto*//*Label 14551*/ GIMT_Encode4(969392), // Rule ID 8275 //
     /*  969302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  969313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  969316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  969319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  969325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969352 */     // MIs[1] Operand 1
     /*  969352 */     // No operand predicates
     /*  969352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969365 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  969365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969390 */     GIR_RootConstrainSelectedInstOperands,
     /*  969391 */     // GIR_Coverage, 8275,
     /*  969391 */     GIR_EraseRootFromParent_Done,
     /*  969392 */   // Label 14551: @969392
     /*  969392 */   GIM_Try, /*On fail goto*//*Label 14552*/ GIMT_Encode4(969487), // Rule ID 8278 //
     /*  969397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969447 */     // MIs[1] Operand 1
     /*  969447 */     // No operand predicates
     /*  969447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969460 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  969460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969485 */     GIR_RootConstrainSelectedInstOperands,
     /*  969486 */     // GIR_Coverage, 8278,
     /*  969486 */     GIR_EraseRootFromParent_Done,
     /*  969487 */   // Label 14552: @969487
     /*  969487 */   GIM_Try, /*On fail goto*//*Label 14553*/ GIMT_Encode4(969582), // Rule ID 8279 //
     /*  969492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969542 */     // MIs[1] Operand 1
     /*  969542 */     // No operand predicates
     /*  969542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969555 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  969555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969580 */     GIR_RootConstrainSelectedInstOperands,
     /*  969581 */     // GIR_Coverage, 8279,
     /*  969581 */     GIR_EraseRootFromParent_Done,
     /*  969582 */   // Label 14553: @969582
     /*  969582 */   GIM_Try, /*On fail goto*//*Label 14554*/ GIMT_Encode4(969677), // Rule ID 8282 //
     /*  969587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  969590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  969604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969637 */     // MIs[1] Operand 1
     /*  969637 */     // No operand predicates
     /*  969637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969650 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  969650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  969672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969675 */     GIR_RootConstrainSelectedInstOperands,
     /*  969676 */     // GIR_Coverage, 8282,
     /*  969676 */     GIR_EraseRootFromParent_Done,
     /*  969677 */   // Label 14554: @969677
     /*  969677 */   GIM_Try, /*On fail goto*//*Label 14555*/ GIMT_Encode4(969772), // Rule ID 8283 //
     /*  969682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  969685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  969699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969732 */     // MIs[1] Operand 1
     /*  969732 */     // No operand predicates
     /*  969732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969745 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  969745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  969767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969770 */     GIR_RootConstrainSelectedInstOperands,
     /*  969771 */     // GIR_Coverage, 8283,
     /*  969771 */     GIR_EraseRootFromParent_Done,
     /*  969772 */   // Label 14555: @969772
     /*  969772 */   GIM_Try, /*On fail goto*//*Label 14556*/ GIMT_Encode4(969867), // Rule ID 8286 //
     /*  969777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  969788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  969791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  969794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  969800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969827 */     // MIs[1] Operand 1
     /*  969827 */     // No operand predicates
     /*  969827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969840 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  969843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969865 */     GIR_RootConstrainSelectedInstOperands,
     /*  969866 */     // GIR_Coverage, 8286,
     /*  969866 */     GIR_EraseRootFromParent_Done,
     /*  969867 */   // Label 14556: @969867
     /*  969867 */   GIM_Try, /*On fail goto*//*Label 14557*/ GIMT_Encode4(969962), // Rule ID 8287 //
     /*  969872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  969883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  969886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  969889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  969895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969922 */     // MIs[1] Operand 1
     /*  969922 */     // No operand predicates
     /*  969922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969935 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  969938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969960 */     GIR_RootConstrainSelectedInstOperands,
     /*  969961 */     // GIR_Coverage, 8287,
     /*  969961 */     GIR_EraseRootFromParent_Done,
     /*  969962 */   // Label 14557: @969962
     /*  969962 */   GIM_Try, /*On fail goto*//*Label 14558*/ GIMT_Encode4(970057), // Rule ID 8290 //
     /*  969967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  969978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  969981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  969984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  969990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970017 */     // MIs[1] Operand 1
     /*  970017 */     // No operand predicates
     /*  970017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970030 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  970030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970055 */     GIR_RootConstrainSelectedInstOperands,
     /*  970056 */     // GIR_Coverage, 8290,
     /*  970056 */     GIR_EraseRootFromParent_Done,
     /*  970057 */   // Label 14558: @970057
     /*  970057 */   GIM_Try, /*On fail goto*//*Label 14559*/ GIMT_Encode4(970152), // Rule ID 8291 //
     /*  970062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  970079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970112 */     // MIs[1] Operand 1
     /*  970112 */     // No operand predicates
     /*  970112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970125 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  970125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970150 */     GIR_RootConstrainSelectedInstOperands,
     /*  970151 */     // GIR_Coverage, 8291,
     /*  970151 */     GIR_EraseRootFromParent_Done,
     /*  970152 */   // Label 14559: @970152
     /*  970152 */   GIM_Try, /*On fail goto*//*Label 14560*/ GIMT_Encode4(970247), // Rule ID 8294 //
     /*  970157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  970168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  970171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  970174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  970180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970207 */     // MIs[1] Operand 1
     /*  970207 */     // No operand predicates
     /*  970207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970220 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  970220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970245 */     GIR_RootConstrainSelectedInstOperands,
     /*  970246 */     // GIR_Coverage, 8294,
     /*  970246 */     GIR_EraseRootFromParent_Done,
     /*  970247 */   // Label 14560: @970247
     /*  970247 */   GIM_Try, /*On fail goto*//*Label 14561*/ GIMT_Encode4(970342), // Rule ID 8295 //
     /*  970252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  970263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  970266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  970269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  970275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970302 */     // MIs[1] Operand 1
     /*  970302 */     // No operand predicates
     /*  970302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970315 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  970315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970340 */     GIR_RootConstrainSelectedInstOperands,
     /*  970341 */     // GIR_Coverage, 8295,
     /*  970341 */     GIR_EraseRootFromParent_Done,
     /*  970342 */   // Label 14561: @970342
     /*  970342 */   GIM_Try, /*On fail goto*//*Label 14562*/ GIMT_Encode4(970437), // Rule ID 8298 //
     /*  970347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970397 */     // MIs[1] Operand 1
     /*  970397 */     // No operand predicates
     /*  970397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970410 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970435 */     GIR_RootConstrainSelectedInstOperands,
     /*  970436 */     // GIR_Coverage, 8298,
     /*  970436 */     GIR_EraseRootFromParent_Done,
     /*  970437 */   // Label 14562: @970437
     /*  970437 */   GIM_Try, /*On fail goto*//*Label 14563*/ GIMT_Encode4(970532), // Rule ID 8299 //
     /*  970442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970492 */     // MIs[1] Operand 1
     /*  970492 */     // No operand predicates
     /*  970492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970505 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970530 */     GIR_RootConstrainSelectedInstOperands,
     /*  970531 */     // GIR_Coverage, 8299,
     /*  970531 */     GIR_EraseRootFromParent_Done,
     /*  970532 */   // Label 14563: @970532
     /*  970532 */   GIM_Try, /*On fail goto*//*Label 14564*/ GIMT_Encode4(970627), // Rule ID 8302 //
     /*  970537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  970554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970587 */     // MIs[1] Operand 1
     /*  970587 */     // No operand predicates
     /*  970587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970600 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970625 */     GIR_RootConstrainSelectedInstOperands,
     /*  970626 */     // GIR_Coverage, 8302,
     /*  970626 */     GIR_EraseRootFromParent_Done,
     /*  970627 */   // Label 14564: @970627
     /*  970627 */   GIM_Try, /*On fail goto*//*Label 14565*/ GIMT_Encode4(970722), // Rule ID 8303 //
     /*  970632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  970649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970682 */     // MIs[1] Operand 1
     /*  970682 */     // No operand predicates
     /*  970682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970695 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970720 */     GIR_RootConstrainSelectedInstOperands,
     /*  970721 */     // GIR_Coverage, 8303,
     /*  970721 */     GIR_EraseRootFromParent_Done,
     /*  970722 */   // Label 14565: @970722
     /*  970722 */   GIM_Try, /*On fail goto*//*Label 14566*/ GIMT_Encode4(970817), // Rule ID 8306 //
     /*  970727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  970744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970777 */     // MIs[1] Operand 1
     /*  970777 */     // No operand predicates
     /*  970777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970790 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970815 */     GIR_RootConstrainSelectedInstOperands,
     /*  970816 */     // GIR_Coverage, 8306,
     /*  970816 */     GIR_EraseRootFromParent_Done,
     /*  970817 */   // Label 14566: @970817
     /*  970817 */   GIM_Try, /*On fail goto*//*Label 14567*/ GIMT_Encode4(970912), // Rule ID 8307 //
     /*  970822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  970839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970872 */     // MIs[1] Operand 1
     /*  970872 */     // No operand predicates
     /*  970872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970885 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970910 */     GIR_RootConstrainSelectedInstOperands,
     /*  970911 */     // GIR_Coverage, 8307,
     /*  970911 */     GIR_EraseRootFromParent_Done,
     /*  970912 */   // Label 14567: @970912
     /*  970912 */   GIM_Try, /*On fail goto*//*Label 14568*/ GIMT_Encode4(971007), // Rule ID 8310 //
     /*  970917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  970928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  970931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  970934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  970940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970967 */     // MIs[1] Operand 1
     /*  970967 */     // No operand predicates
     /*  970967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970980 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  970980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971005 */     GIR_RootConstrainSelectedInstOperands,
     /*  971006 */     // GIR_Coverage, 8310,
     /*  971006 */     GIR_EraseRootFromParent_Done,
     /*  971007 */   // Label 14568: @971007
     /*  971007 */   GIM_Try, /*On fail goto*//*Label 14569*/ GIMT_Encode4(971102), // Rule ID 8311 //
     /*  971012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  971029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971062 */     // MIs[1] Operand 1
     /*  971062 */     // No operand predicates
     /*  971062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971075 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  971078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971100 */     GIR_RootConstrainSelectedInstOperands,
     /*  971101 */     // GIR_Coverage, 8311,
     /*  971101 */     GIR_EraseRootFromParent_Done,
     /*  971102 */   // Label 14569: @971102
     /*  971102 */   GIM_Try, /*On fail goto*//*Label 14570*/ GIMT_Encode4(971197), // Rule ID 8314 //
     /*  971107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  971124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971157 */     // MIs[1] Operand 1
     /*  971157 */     // No operand predicates
     /*  971157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971170 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  971170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971195 */     GIR_RootConstrainSelectedInstOperands,
     /*  971196 */     // GIR_Coverage, 8314,
     /*  971196 */     GIR_EraseRootFromParent_Done,
     /*  971197 */   // Label 14570: @971197
     /*  971197 */   GIM_Try, /*On fail goto*//*Label 14571*/ GIMT_Encode4(971292), // Rule ID 8315 //
     /*  971202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  971219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971252 */     // MIs[1] Operand 1
     /*  971252 */     // No operand predicates
     /*  971252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971265 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971290 */     GIR_RootConstrainSelectedInstOperands,
     /*  971291 */     // GIR_Coverage, 8315,
     /*  971291 */     GIR_EraseRootFromParent_Done,
     /*  971292 */   // Label 14571: @971292
     /*  971292 */   GIM_Try, /*On fail goto*//*Label 14572*/ GIMT_Encode4(971387), // Rule ID 8318 //
     /*  971297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  971314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971347 */     // MIs[1] Operand 1
     /*  971347 */     // No operand predicates
     /*  971347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971360 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  971360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971385 */     GIR_RootConstrainSelectedInstOperands,
     /*  971386 */     // GIR_Coverage, 8318,
     /*  971386 */     GIR_EraseRootFromParent_Done,
     /*  971387 */   // Label 14572: @971387
     /*  971387 */   GIM_Try, /*On fail goto*//*Label 14573*/ GIMT_Encode4(971482), // Rule ID 8319 //
     /*  971392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  971409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971442 */     // MIs[1] Operand 1
     /*  971442 */     // No operand predicates
     /*  971442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971455 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971480 */     GIR_RootConstrainSelectedInstOperands,
     /*  971481 */     // GIR_Coverage, 8319,
     /*  971481 */     GIR_EraseRootFromParent_Done,
     /*  971482 */   // Label 14573: @971482
     /*  971482 */   GIM_Try, /*On fail goto*//*Label 14574*/ GIMT_Encode4(971577), // Rule ID 8322 //
     /*  971487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  971504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971537 */     // MIs[1] Operand 1
     /*  971537 */     // No operand predicates
     /*  971537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971550 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  971553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971575 */     GIR_RootConstrainSelectedInstOperands,
     /*  971576 */     // GIR_Coverage, 8322,
     /*  971576 */     GIR_EraseRootFromParent_Done,
     /*  971577 */   // Label 14574: @971577
     /*  971577 */   GIM_Try, /*On fail goto*//*Label 14575*/ GIMT_Encode4(971672), // Rule ID 8323 //
     /*  971582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  971599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971632 */     // MIs[1] Operand 1
     /*  971632 */     // No operand predicates
     /*  971632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971645 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  971645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  971648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971670 */     GIR_RootConstrainSelectedInstOperands,
     /*  971671 */     // GIR_Coverage, 8323,
     /*  971671 */     GIR_EraseRootFromParent_Done,
     /*  971672 */   // Label 14575: @971672
     /*  971672 */   GIM_Try, /*On fail goto*//*Label 14576*/ GIMT_Encode4(971767), // Rule ID 8326 //
     /*  971677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  971694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971727 */     // MIs[1] Operand 1
     /*  971727 */     // No operand predicates
     /*  971727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971740 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971765 */     GIR_RootConstrainSelectedInstOperands,
     /*  971766 */     // GIR_Coverage, 8326,
     /*  971766 */     GIR_EraseRootFromParent_Done,
     /*  971767 */   // Label 14576: @971767
     /*  971767 */   GIM_Try, /*On fail goto*//*Label 14577*/ GIMT_Encode4(971862), // Rule ID 8327 //
     /*  971772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  971789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971822 */     // MIs[1] Operand 1
     /*  971822 */     // No operand predicates
     /*  971822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971835 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  971835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971860 */     GIR_RootConstrainSelectedInstOperands,
     /*  971861 */     // GIR_Coverage, 8327,
     /*  971861 */     GIR_EraseRootFromParent_Done,
     /*  971862 */   // Label 14577: @971862
     /*  971862 */   GIM_Try, /*On fail goto*//*Label 14578*/ GIMT_Encode4(971957), // Rule ID 8330 //
     /*  971867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  971884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971917 */     // MIs[1] Operand 1
     /*  971917 */     // No operand predicates
     /*  971917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971930 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971955 */     GIR_RootConstrainSelectedInstOperands,
     /*  971956 */     // GIR_Coverage, 8330,
     /*  971956 */     GIR_EraseRootFromParent_Done,
     /*  971957 */   // Label 14578: @971957
     /*  971957 */   GIM_Try, /*On fail goto*//*Label 14579*/ GIMT_Encode4(972052), // Rule ID 8331 //
     /*  971962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  971979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  972000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972012 */     // MIs[1] Operand 1
     /*  972012 */     // No operand predicates
     /*  972012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972025 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  972025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  972028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972050 */     GIR_RootConstrainSelectedInstOperands,
     /*  972051 */     // GIR_Coverage, 8331,
     /*  972051 */     GIR_EraseRootFromParent_Done,
     /*  972052 */   // Label 14579: @972052
     /*  972052 */   GIM_Try, /*On fail goto*//*Label 14580*/ GIMT_Encode4(972147), // Rule ID 8862 //
     /*  972057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  972074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972107 */     // MIs[1] Operand 1
     /*  972107 */     // No operand predicates
     /*  972107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972120 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  972123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972145 */     GIR_RootConstrainSelectedInstOperands,
     /*  972146 */     // GIR_Coverage, 8862,
     /*  972146 */     GIR_EraseRootFromParent_Done,
     /*  972147 */   // Label 14580: @972147
     /*  972147 */   GIM_Try, /*On fail goto*//*Label 14581*/ GIMT_Encode4(972242), // Rule ID 8863 //
     /*  972152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  972169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972202 */     // MIs[1] Operand 1
     /*  972202 */     // No operand predicates
     /*  972202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972215 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  972218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972240 */     GIR_RootConstrainSelectedInstOperands,
     /*  972241 */     // GIR_Coverage, 8863,
     /*  972241 */     GIR_EraseRootFromParent_Done,
     /*  972242 */   // Label 14581: @972242
     /*  972242 */   GIM_Try, /*On fail goto*//*Label 14582*/ GIMT_Encode4(972337), // Rule ID 8866 //
     /*  972247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  972264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972297 */     // MIs[1] Operand 1
     /*  972297 */     // No operand predicates
     /*  972297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972310 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972335 */     GIR_RootConstrainSelectedInstOperands,
     /*  972336 */     // GIR_Coverage, 8866,
     /*  972336 */     GIR_EraseRootFromParent_Done,
     /*  972337 */   // Label 14582: @972337
     /*  972337 */   GIM_Try, /*On fail goto*//*Label 14583*/ GIMT_Encode4(972432), // Rule ID 8867 //
     /*  972342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  972359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972392 */     // MIs[1] Operand 1
     /*  972392 */     // No operand predicates
     /*  972392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972405 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972430 */     GIR_RootConstrainSelectedInstOperands,
     /*  972431 */     // GIR_Coverage, 8867,
     /*  972431 */     GIR_EraseRootFromParent_Done,
     /*  972432 */   // Label 14583: @972432
     /*  972432 */   GIM_Try, /*On fail goto*//*Label 14584*/ GIMT_Encode4(972527), // Rule ID 8870 //
     /*  972437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  972454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972487 */     // MIs[1] Operand 1
     /*  972487 */     // No operand predicates
     /*  972487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972500 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972525 */     GIR_RootConstrainSelectedInstOperands,
     /*  972526 */     // GIR_Coverage, 8870,
     /*  972526 */     GIR_EraseRootFromParent_Done,
     /*  972527 */   // Label 14584: @972527
     /*  972527 */   GIM_Try, /*On fail goto*//*Label 14585*/ GIMT_Encode4(972622), // Rule ID 8871 //
     /*  972532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  972549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972582 */     // MIs[1] Operand 1
     /*  972582 */     // No operand predicates
     /*  972582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972595 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972620 */     GIR_RootConstrainSelectedInstOperands,
     /*  972621 */     // GIR_Coverage, 8871,
     /*  972621 */     GIR_EraseRootFromParent_Done,
     /*  972622 */   // Label 14585: @972622
     /*  972622 */   GIM_Try, /*On fail goto*//*Label 14586*/ GIMT_Encode4(972717), // Rule ID 8874 //
     /*  972627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  972644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972677 */     // MIs[1] Operand 1
     /*  972677 */     // No operand predicates
     /*  972677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972690 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  972690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972715 */     GIR_RootConstrainSelectedInstOperands,
     /*  972716 */     // GIR_Coverage, 8874,
     /*  972716 */     GIR_EraseRootFromParent_Done,
     /*  972717 */   // Label 14586: @972717
     /*  972717 */   GIM_Try, /*On fail goto*//*Label 14587*/ GIMT_Encode4(972812), // Rule ID 8875 //
     /*  972722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  972739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972772 */     // MIs[1] Operand 1
     /*  972772 */     // No operand predicates
     /*  972772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972785 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  972785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972810 */     GIR_RootConstrainSelectedInstOperands,
     /*  972811 */     // GIR_Coverage, 8875,
     /*  972811 */     GIR_EraseRootFromParent_Done,
     /*  972812 */   // Label 14587: @972812
     /*  972812 */   GIM_Try, /*On fail goto*//*Label 14588*/ GIMT_Encode4(972907), // Rule ID 8878 //
     /*  972817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  972834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972867 */     // MIs[1] Operand 1
     /*  972867 */     // No operand predicates
     /*  972867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  972880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972905 */     GIR_RootConstrainSelectedInstOperands,
     /*  972906 */     // GIR_Coverage, 8878,
     /*  972906 */     GIR_EraseRootFromParent_Done,
     /*  972907 */   // Label 14588: @972907
     /*  972907 */   GIM_Try, /*On fail goto*//*Label 14589*/ GIMT_Encode4(973002), // Rule ID 8879 //
     /*  972912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  972929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972962 */     // MIs[1] Operand 1
     /*  972962 */     // No operand predicates
     /*  972962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972975 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  972975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973000 */     GIR_RootConstrainSelectedInstOperands,
     /*  973001 */     // GIR_Coverage, 8879,
     /*  973001 */     GIR_EraseRootFromParent_Done,
     /*  973002 */   // Label 14589: @973002
     /*  973002 */   GIM_Try, /*On fail goto*//*Label 14590*/ GIMT_Encode4(973097), // Rule ID 8882 //
     /*  973007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  973024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973057 */     // MIs[1] Operand 1
     /*  973057 */     // No operand predicates
     /*  973057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973070 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  973070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973095 */     GIR_RootConstrainSelectedInstOperands,
     /*  973096 */     // GIR_Coverage, 8882,
     /*  973096 */     GIR_EraseRootFromParent_Done,
     /*  973097 */   // Label 14590: @973097
     /*  973097 */   GIM_Try, /*On fail goto*//*Label 14591*/ GIMT_Encode4(973192), // Rule ID 8883 //
     /*  973102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  973119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973152 */     // MIs[1] Operand 1
     /*  973152 */     // No operand predicates
     /*  973152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973165 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  973165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973190 */     GIR_RootConstrainSelectedInstOperands,
     /*  973191 */     // GIR_Coverage, 8883,
     /*  973191 */     GIR_EraseRootFromParent_Done,
     /*  973192 */   // Label 14591: @973192
     /*  973192 */   GIM_Try, /*On fail goto*//*Label 14592*/ GIMT_Encode4(973287), // Rule ID 8886 //
     /*  973197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  973208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  973211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  973214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  973220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973247 */     // MIs[1] Operand 1
     /*  973247 */     // No operand predicates
     /*  973247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973260 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  973260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973285 */     GIR_RootConstrainSelectedInstOperands,
     /*  973286 */     // GIR_Coverage, 8886,
     /*  973286 */     GIR_EraseRootFromParent_Done,
     /*  973287 */   // Label 14592: @973287
     /*  973287 */   GIM_Try, /*On fail goto*//*Label 14593*/ GIMT_Encode4(973382), // Rule ID 8887 //
     /*  973292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  973303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  973306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  973309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  973315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973342 */     // MIs[1] Operand 1
     /*  973342 */     // No operand predicates
     /*  973342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973355 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973380 */     GIR_RootConstrainSelectedInstOperands,
     /*  973381 */     // GIR_Coverage, 8887,
     /*  973381 */     GIR_EraseRootFromParent_Done,
     /*  973382 */   // Label 14593: @973382
     /*  973382 */   GIM_Try, /*On fail goto*//*Label 14594*/ GIMT_Encode4(973477), // Rule ID 8890 //
     /*  973387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  973398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973437 */     // MIs[1] Operand 1
     /*  973437 */     // No operand predicates
     /*  973437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973450 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  973450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973475 */     GIR_RootConstrainSelectedInstOperands,
     /*  973476 */     // GIR_Coverage, 8890,
     /*  973476 */     GIR_EraseRootFromParent_Done,
     /*  973477 */   // Label 14594: @973477
     /*  973477 */   GIM_Try, /*On fail goto*//*Label 14595*/ GIMT_Encode4(973572), // Rule ID 8891 //
     /*  973482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  973493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973532 */     // MIs[1] Operand 1
     /*  973532 */     // No operand predicates
     /*  973532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973545 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  973545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973570 */     GIR_RootConstrainSelectedInstOperands,
     /*  973571 */     // GIR_Coverage, 8891,
     /*  973571 */     GIR_EraseRootFromParent_Done,
     /*  973572 */   // Label 14595: @973572
     /*  973572 */   GIM_Try, /*On fail goto*//*Label 14596*/ GIMT_Encode4(973667), // Rule ID 8894 //
     /*  973577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  973594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973627 */     // MIs[1] Operand 1
     /*  973627 */     // No operand predicates
     /*  973627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973640 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  973640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973665 */     GIR_RootConstrainSelectedInstOperands,
     /*  973666 */     // GIR_Coverage, 8894,
     /*  973666 */     GIR_EraseRootFromParent_Done,
     /*  973667 */   // Label 14596: @973667
     /*  973667 */   GIM_Try, /*On fail goto*//*Label 14597*/ GIMT_Encode4(973762), // Rule ID 8895 //
     /*  973672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  973689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973722 */     // MIs[1] Operand 1
     /*  973722 */     // No operand predicates
     /*  973722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973735 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  973735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973760 */     GIR_RootConstrainSelectedInstOperands,
     /*  973761 */     // GIR_Coverage, 8895,
     /*  973761 */     GIR_EraseRootFromParent_Done,
     /*  973762 */   // Label 14597: @973762
     /*  973762 */   GIM_Try, /*On fail goto*//*Label 14598*/ GIMT_Encode4(973857), // Rule ID 8898 //
     /*  973767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  973770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  973784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973817 */     // MIs[1] Operand 1
     /*  973817 */     // No operand predicates
     /*  973817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973830 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  973830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  973852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973855 */     GIR_RootConstrainSelectedInstOperands,
     /*  973856 */     // GIR_Coverage, 8898,
     /*  973856 */     GIR_EraseRootFromParent_Done,
     /*  973857 */   // Label 14598: @973857
     /*  973857 */   GIM_Try, /*On fail goto*//*Label 14599*/ GIMT_Encode4(973952), // Rule ID 8899 //
     /*  973862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  973865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  973879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973912 */     // MIs[1] Operand 1
     /*  973912 */     // No operand predicates
     /*  973912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973925 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  973925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  973947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973950 */     GIR_RootConstrainSelectedInstOperands,
     /*  973951 */     // GIR_Coverage, 8899,
     /*  973951 */     GIR_EraseRootFromParent_Done,
     /*  973952 */   // Label 14599: @973952
     /*  973952 */   GIM_Try, /*On fail goto*//*Label 14600*/ GIMT_Encode4(974047), // Rule ID 8902 //
     /*  973957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  973968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  973971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  973974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  973980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  973995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974007 */     // MIs[1] Operand 1
     /*  974007 */     // No operand predicates
     /*  974007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974020 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974045 */     GIR_RootConstrainSelectedInstOperands,
     /*  974046 */     // GIR_Coverage, 8902,
     /*  974046 */     GIR_EraseRootFromParent_Done,
     /*  974047 */   // Label 14600: @974047
     /*  974047 */   GIM_Try, /*On fail goto*//*Label 14601*/ GIMT_Encode4(974142), // Rule ID 8903 //
     /*  974052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  974069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974102 */     // MIs[1] Operand 1
     /*  974102 */     // No operand predicates
     /*  974102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974115 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974140 */     GIR_RootConstrainSelectedInstOperands,
     /*  974141 */     // GIR_Coverage, 8903,
     /*  974141 */     GIR_EraseRootFromParent_Done,
     /*  974142 */   // Label 14601: @974142
     /*  974142 */   GIM_Try, /*On fail goto*//*Label 14602*/ GIMT_Encode4(974237), // Rule ID 8906 //
     /*  974147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  974164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974197 */     // MIs[1] Operand 1
     /*  974197 */     // No operand predicates
     /*  974197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974210 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974235 */     GIR_RootConstrainSelectedInstOperands,
     /*  974236 */     // GIR_Coverage, 8906,
     /*  974236 */     GIR_EraseRootFromParent_Done,
     /*  974237 */   // Label 14602: @974237
     /*  974237 */   GIM_Try, /*On fail goto*//*Label 14603*/ GIMT_Encode4(974332), // Rule ID 8907 //
     /*  974242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  974259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974292 */     // MIs[1] Operand 1
     /*  974292 */     // No operand predicates
     /*  974292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974305 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974330 */     GIR_RootConstrainSelectedInstOperands,
     /*  974331 */     // GIR_Coverage, 8907,
     /*  974331 */     GIR_EraseRootFromParent_Done,
     /*  974332 */   // Label 14603: @974332
     /*  974332 */   GIM_Try, /*On fail goto*//*Label 14604*/ GIMT_Encode4(974427), // Rule ID 8910 //
     /*  974337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  974348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  974351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  974354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  974360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974387 */     // MIs[1] Operand 1
     /*  974387 */     // No operand predicates
     /*  974387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974400 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  974403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974425 */     GIR_RootConstrainSelectedInstOperands,
     /*  974426 */     // GIR_Coverage, 8910,
     /*  974426 */     GIR_EraseRootFromParent_Done,
     /*  974427 */   // Label 14604: @974427
     /*  974427 */   GIM_Try, /*On fail goto*//*Label 14605*/ GIMT_Encode4(974522), // Rule ID 8911 //
     /*  974432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  974443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  974446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  974449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  974455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974482 */     // MIs[1] Operand 1
     /*  974482 */     // No operand predicates
     /*  974482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974495 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  974498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974520 */     GIR_RootConstrainSelectedInstOperands,
     /*  974521 */     // GIR_Coverage, 8911,
     /*  974521 */     GIR_EraseRootFromParent_Done,
     /*  974522 */   // Label 14605: @974522
     /*  974522 */   GIM_Try, /*On fail goto*//*Label 14606*/ GIMT_Encode4(974617), // Rule ID 8914 //
     /*  974527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  974544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974577 */     // MIs[1] Operand 1
     /*  974577 */     // No operand predicates
     /*  974577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974590 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974615 */     GIR_RootConstrainSelectedInstOperands,
     /*  974616 */     // GIR_Coverage, 8914,
     /*  974616 */     GIR_EraseRootFromParent_Done,
     /*  974617 */   // Label 14606: @974617
     /*  974617 */   GIM_Try, /*On fail goto*//*Label 14607*/ GIMT_Encode4(974712), // Rule ID 8915 //
     /*  974622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  974639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974672 */     // MIs[1] Operand 1
     /*  974672 */     // No operand predicates
     /*  974672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974685 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974710 */     GIR_RootConstrainSelectedInstOperands,
     /*  974711 */     // GIR_Coverage, 8915,
     /*  974711 */     GIR_EraseRootFromParent_Done,
     /*  974712 */   // Label 14607: @974712
     /*  974712 */   GIM_Try, /*On fail goto*//*Label 14608*/ GIMT_Encode4(974807), // Rule ID 8918 //
     /*  974717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  974734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974767 */     // MIs[1] Operand 1
     /*  974767 */     // No operand predicates
     /*  974767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974780 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974805 */     GIR_RootConstrainSelectedInstOperands,
     /*  974806 */     // GIR_Coverage, 8918,
     /*  974806 */     GIR_EraseRootFromParent_Done,
     /*  974807 */   // Label 14608: @974807
     /*  974807 */   GIM_Try, /*On fail goto*//*Label 14609*/ GIMT_Encode4(974902), // Rule ID 8919 //
     /*  974812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  974829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974862 */     // MIs[1] Operand 1
     /*  974862 */     // No operand predicates
     /*  974862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974875 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974900 */     GIR_RootConstrainSelectedInstOperands,
     /*  974901 */     // GIR_Coverage, 8919,
     /*  974901 */     GIR_EraseRootFromParent_Done,
     /*  974902 */   // Label 14609: @974902
     /*  974902 */   GIM_Try, /*On fail goto*//*Label 14610*/ GIMT_Encode4(974997), // Rule ID 8922 //
     /*  974907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  974924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974957 */     // MIs[1] Operand 1
     /*  974957 */     // No operand predicates
     /*  974957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974970 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  974973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974995 */     GIR_RootConstrainSelectedInstOperands,
     /*  974996 */     // GIR_Coverage, 8922,
     /*  974996 */     GIR_EraseRootFromParent_Done,
     /*  974997 */   // Label 14610: @974997
     /*  974997 */   GIM_Try, /*On fail goto*//*Label 14611*/ GIMT_Encode4(975092), // Rule ID 8923 //
     /*  975002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  975013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  975016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  975019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  975025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975052 */     // MIs[1] Operand 1
     /*  975052 */     // No operand predicates
     /*  975052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975065 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  975065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975090 */     GIR_RootConstrainSelectedInstOperands,
     /*  975091 */     // GIR_Coverage, 8923,
     /*  975091 */     GIR_EraseRootFromParent_Done,
     /*  975092 */   // Label 14611: @975092
     /*  975092 */   GIM_Try, /*On fail goto*//*Label 14612*/ GIMT_Encode4(975187), // Rule ID 8926 //
     /*  975097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  975114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975147 */     // MIs[1] Operand 1
     /*  975147 */     // No operand predicates
     /*  975147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975160 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975185 */     GIR_RootConstrainSelectedInstOperands,
     /*  975186 */     // GIR_Coverage, 8926,
     /*  975186 */     GIR_EraseRootFromParent_Done,
     /*  975187 */   // Label 14612: @975187
     /*  975187 */   GIM_Try, /*On fail goto*//*Label 14613*/ GIMT_Encode4(975282), // Rule ID 8927 //
     /*  975192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  975209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975242 */     // MIs[1] Operand 1
     /*  975242 */     // No operand predicates
     /*  975242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975255 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975280 */     GIR_RootConstrainSelectedInstOperands,
     /*  975281 */     // GIR_Coverage, 8927,
     /*  975281 */     GIR_EraseRootFromParent_Done,
     /*  975282 */   // Label 14613: @975282
     /*  975282 */   GIM_Try, /*On fail goto*//*Label 14614*/ GIMT_Encode4(975377), // Rule ID 8930 //
     /*  975287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  975304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975337 */     // MIs[1] Operand 1
     /*  975337 */     // No operand predicates
     /*  975337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975350 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975375 */     GIR_RootConstrainSelectedInstOperands,
     /*  975376 */     // GIR_Coverage, 8930,
     /*  975376 */     GIR_EraseRootFromParent_Done,
     /*  975377 */   // Label 14614: @975377
     /*  975377 */   GIM_Try, /*On fail goto*//*Label 14615*/ GIMT_Encode4(975472), // Rule ID 8931 //
     /*  975382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  975399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975432 */     // MIs[1] Operand 1
     /*  975432 */     // No operand predicates
     /*  975432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975445 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975470 */     GIR_RootConstrainSelectedInstOperands,
     /*  975471 */     // GIR_Coverage, 8931,
     /*  975471 */     GIR_EraseRootFromParent_Done,
     /*  975472 */   // Label 14615: @975472
     /*  975472 */   GIM_Try, /*On fail goto*//*Label 14616*/ GIMT_Encode4(975567), // Rule ID 8934 //
     /*  975477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  975494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975527 */     // MIs[1] Operand 1
     /*  975527 */     // No operand predicates
     /*  975527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975540 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975565 */     GIR_RootConstrainSelectedInstOperands,
     /*  975566 */     // GIR_Coverage, 8934,
     /*  975566 */     GIR_EraseRootFromParent_Done,
     /*  975567 */   // Label 14616: @975567
     /*  975567 */   GIM_Try, /*On fail goto*//*Label 14617*/ GIMT_Encode4(975662), // Rule ID 8935 //
     /*  975572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  975589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975622 */     // MIs[1] Operand 1
     /*  975622 */     // No operand predicates
     /*  975622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975635 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975660 */     GIR_RootConstrainSelectedInstOperands,
     /*  975661 */     // GIR_Coverage, 8935,
     /*  975661 */     GIR_EraseRootFromParent_Done,
     /*  975662 */   // Label 14617: @975662
     /*  975662 */   GIM_Try, /*On fail goto*//*Label 14618*/ GIMT_Encode4(975757), // Rule ID 8938 //
     /*  975667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  975670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  975678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  975681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  975684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  975690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975717 */     // MIs[1] Operand 1
     /*  975717 */     // No operand predicates
     /*  975717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975730 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  975730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975755 */     GIR_RootConstrainSelectedInstOperands,
     /*  975756 */     // GIR_Coverage, 8938,
     /*  975756 */     GIR_EraseRootFromParent_Done,
     /*  975757 */   // Label 14618: @975757
     /*  975757 */   GIM_Try, /*On fail goto*//*Label 14619*/ GIMT_Encode4(975852), // Rule ID 8939 //
     /*  975762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  975765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  975773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  975776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  975779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  975785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975812 */     // MIs[1] Operand 1
     /*  975812 */     // No operand predicates
     /*  975812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975825 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  975825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975850 */     GIR_RootConstrainSelectedInstOperands,
     /*  975851 */     // GIR_Coverage, 8939,
     /*  975851 */     GIR_EraseRootFromParent_Done,
     /*  975852 */   // Label 14619: @975852
     /*  975852 */   GIM_Try, /*On fail goto*//*Label 14620*/ GIMT_Encode4(975947), // Rule ID 8942 //
     /*  975857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  975860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  975874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975907 */     // MIs[1] Operand 1
     /*  975907 */     // No operand predicates
     /*  975907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975920 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  975920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975945 */     GIR_RootConstrainSelectedInstOperands,
     /*  975946 */     // GIR_Coverage, 8942,
     /*  975946 */     GIR_EraseRootFromParent_Done,
     /*  975947 */   // Label 14620: @975947
     /*  975947 */   GIM_Try, /*On fail goto*//*Label 14621*/ GIMT_Encode4(976042), // Rule ID 8943 //
     /*  975952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  975955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  975969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976002 */     // MIs[1] Operand 1
     /*  976002 */     // No operand predicates
     /*  976002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976015 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  976015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  976018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976040 */     GIR_RootConstrainSelectedInstOperands,
     /*  976041 */     // GIR_Coverage, 8943,
     /*  976041 */     GIR_EraseRootFromParent_Done,
     /*  976042 */   // Label 14621: @976042
     /*  976042 */   GIM_Try, /*On fail goto*//*Label 14622*/ GIMT_Encode4(976137), // Rule ID 8946 //
     /*  976047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  976050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  976058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  976061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  976064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  976070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  976085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976097 */     // MIs[1] Operand 1
     /*  976097 */     // No operand predicates
     /*  976097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976110 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  976110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  976113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976135 */     GIR_RootConstrainSelectedInstOperands,
     /*  976136 */     // GIR_Coverage, 8946,
     /*  976136 */     GIR_EraseRootFromParent_Done,
     /*  976137 */   // Label 14622: @976137
     /*  976137 */   GIM_Try, /*On fail goto*//*Label 14623*/ GIMT_Encode4(976232), // Rule ID 8947 //
     /*  976142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  976145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  976153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  976156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  976159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  976165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  976180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976192 */     // MIs[1] Operand 1
     /*  976192 */     // No operand predicates
     /*  976192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976205 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  976205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  976208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976230 */     GIR_RootConstrainSelectedInstOperands,
     /*  976231 */     // GIR_Coverage, 8947,
     /*  976231 */     GIR_EraseRootFromParent_Done,
     /*  976232 */   // Label 14623: @976232
     /*  976232 */   GIM_Try, /*On fail goto*//*Label 14624*/ GIMT_Encode4(976327), // Rule ID 9126 //
     /*  976237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  976254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976287 */     // MIs[1] Operand 1
     /*  976287 */     // No operand predicates
     /*  976287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976300 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  976303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976325 */     GIR_RootConstrainSelectedInstOperands,
     /*  976326 */     // GIR_Coverage, 9126,
     /*  976326 */     GIR_EraseRootFromParent_Done,
     /*  976327 */   // Label 14624: @976327
     /*  976327 */   GIM_Try, /*On fail goto*//*Label 14625*/ GIMT_Encode4(976422), // Rule ID 9127 //
     /*  976332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  976349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976382 */     // MIs[1] Operand 1
     /*  976382 */     // No operand predicates
     /*  976382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976395 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  976398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976420 */     GIR_RootConstrainSelectedInstOperands,
     /*  976421 */     // GIR_Coverage, 9127,
     /*  976421 */     GIR_EraseRootFromParent_Done,
     /*  976422 */   // Label 14625: @976422
     /*  976422 */   GIM_Try, /*On fail goto*//*Label 14626*/ GIMT_Encode4(976517), // Rule ID 9130 //
     /*  976427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  976444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976477 */     // MIs[1] Operand 1
     /*  976477 */     // No operand predicates
     /*  976477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976490 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  976493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976515 */     GIR_RootConstrainSelectedInstOperands,
     /*  976516 */     // GIR_Coverage, 9130,
     /*  976516 */     GIR_EraseRootFromParent_Done,
     /*  976517 */   // Label 14626: @976517
     /*  976517 */   GIM_Try, /*On fail goto*//*Label 14627*/ GIMT_Encode4(976612), // Rule ID 9131 //
     /*  976522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  976539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976572 */     // MIs[1] Operand 1
     /*  976572 */     // No operand predicates
     /*  976572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976585 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  976588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976610 */     GIR_RootConstrainSelectedInstOperands,
     /*  976611 */     // GIR_Coverage, 9131,
     /*  976611 */     GIR_EraseRootFromParent_Done,
     /*  976612 */   // Label 14627: @976612
     /*  976612 */   GIM_Try, /*On fail goto*//*Label 14628*/ GIMT_Encode4(976707), // Rule ID 9134 //
     /*  976617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  976634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976667 */     // MIs[1] Operand 1
     /*  976667 */     // No operand predicates
     /*  976667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  976683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976705 */     GIR_RootConstrainSelectedInstOperands,
     /*  976706 */     // GIR_Coverage, 9134,
     /*  976706 */     GIR_EraseRootFromParent_Done,
     /*  976707 */   // Label 14628: @976707
     /*  976707 */   GIM_Try, /*On fail goto*//*Label 14629*/ GIMT_Encode4(976802), // Rule ID 9135 //
     /*  976712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  976729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976762 */     // MIs[1] Operand 1
     /*  976762 */     // No operand predicates
     /*  976762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976775 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  976778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976800 */     GIR_RootConstrainSelectedInstOperands,
     /*  976801 */     // GIR_Coverage, 9135,
     /*  976801 */     GIR_EraseRootFromParent_Done,
     /*  976802 */   // Label 14629: @976802
     /*  976802 */   GIM_Try, /*On fail goto*//*Label 14630*/ GIMT_Encode4(976897), // Rule ID 9138 //
     /*  976807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  976824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976857 */     // MIs[1] Operand 1
     /*  976857 */     // No operand predicates
     /*  976857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976870 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  976870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  976873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976895 */     GIR_RootConstrainSelectedInstOperands,
     /*  976896 */     // GIR_Coverage, 9138,
     /*  976896 */     GIR_EraseRootFromParent_Done,
     /*  976897 */   // Label 14630: @976897
     /*  976897 */   GIM_Try, /*On fail goto*//*Label 14631*/ GIMT_Encode4(976992), // Rule ID 9139 //
     /*  976902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  976919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976952 */     // MIs[1] Operand 1
     /*  976952 */     // No operand predicates
     /*  976952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976965 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  976965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  976968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976990 */     GIR_RootConstrainSelectedInstOperands,
     /*  976991 */     // GIR_Coverage, 9139,
     /*  976991 */     GIR_EraseRootFromParent_Done,
     /*  976992 */   // Label 14631: @976992
     /*  976992 */   GIM_Try, /*On fail goto*//*Label 14632*/ GIMT_Encode4(977087), // Rule ID 9142 //
     /*  976997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  977014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977047 */     // MIs[1] Operand 1
     /*  977047 */     // No operand predicates
     /*  977047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977060 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  977060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977085 */     GIR_RootConstrainSelectedInstOperands,
     /*  977086 */     // GIR_Coverage, 9142,
     /*  977086 */     GIR_EraseRootFromParent_Done,
     /*  977087 */   // Label 14632: @977087
     /*  977087 */   GIM_Try, /*On fail goto*//*Label 14633*/ GIMT_Encode4(977182), // Rule ID 9143 //
     /*  977092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  977109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977142 */     // MIs[1] Operand 1
     /*  977142 */     // No operand predicates
     /*  977142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977155 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  977155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977180 */     GIR_RootConstrainSelectedInstOperands,
     /*  977181 */     // GIR_Coverage, 9143,
     /*  977181 */     GIR_EraseRootFromParent_Done,
     /*  977182 */   // Label 14633: @977182
     /*  977182 */   GIM_Try, /*On fail goto*//*Label 14634*/ GIMT_Encode4(977277), // Rule ID 9146 //
     /*  977187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  977204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977237 */     // MIs[1] Operand 1
     /*  977237 */     // No operand predicates
     /*  977237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977250 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  977250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977275 */     GIR_RootConstrainSelectedInstOperands,
     /*  977276 */     // GIR_Coverage, 9146,
     /*  977276 */     GIR_EraseRootFromParent_Done,
     /*  977277 */   // Label 14634: @977277
     /*  977277 */   GIM_Try, /*On fail goto*//*Label 14635*/ GIMT_Encode4(977372), // Rule ID 9147 //
     /*  977282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  977299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977332 */     // MIs[1] Operand 1
     /*  977332 */     // No operand predicates
     /*  977332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977345 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  977345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977370 */     GIR_RootConstrainSelectedInstOperands,
     /*  977371 */     // GIR_Coverage, 9147,
     /*  977371 */     GIR_EraseRootFromParent_Done,
     /*  977372 */   // Label 14635: @977372
     /*  977372 */   GIM_Try, /*On fail goto*//*Label 14636*/ GIMT_Encode4(977467), // Rule ID 9150 //
     /*  977377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  977388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  977391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  977394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  977400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977427 */     // MIs[1] Operand 1
     /*  977427 */     // No operand predicates
     /*  977427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977440 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  977440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977465 */     GIR_RootConstrainSelectedInstOperands,
     /*  977466 */     // GIR_Coverage, 9150,
     /*  977466 */     GIR_EraseRootFromParent_Done,
     /*  977467 */   // Label 14636: @977467
     /*  977467 */   GIM_Try, /*On fail goto*//*Label 14637*/ GIMT_Encode4(977562), // Rule ID 9151 //
     /*  977472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  977483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  977486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  977489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  977495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977522 */     // MIs[1] Operand 1
     /*  977522 */     // No operand predicates
     /*  977522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977535 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977560 */     GIR_RootConstrainSelectedInstOperands,
     /*  977561 */     // GIR_Coverage, 9151,
     /*  977561 */     GIR_EraseRootFromParent_Done,
     /*  977562 */   // Label 14637: @977562
     /*  977562 */   GIM_Try, /*On fail goto*//*Label 14638*/ GIMT_Encode4(977657), // Rule ID 9154 //
     /*  977567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  977584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977617 */     // MIs[1] Operand 1
     /*  977617 */     // No operand predicates
     /*  977617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977630 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  977630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977655 */     GIR_RootConstrainSelectedInstOperands,
     /*  977656 */     // GIR_Coverage, 9154,
     /*  977656 */     GIR_EraseRootFromParent_Done,
     /*  977657 */   // Label 14638: @977657
     /*  977657 */   GIM_Try, /*On fail goto*//*Label 14639*/ GIMT_Encode4(977752), // Rule ID 9155 //
     /*  977662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  977679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977712 */     // MIs[1] Operand 1
     /*  977712 */     // No operand predicates
     /*  977712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977725 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  977725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977750 */     GIR_RootConstrainSelectedInstOperands,
     /*  977751 */     // GIR_Coverage, 9155,
     /*  977751 */     GIR_EraseRootFromParent_Done,
     /*  977752 */   // Label 14639: @977752
     /*  977752 */   GIM_Try, /*On fail goto*//*Label 14640*/ GIMT_Encode4(977847), // Rule ID 9158 //
     /*  977757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  977774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977807 */     // MIs[1] Operand 1
     /*  977807 */     // No operand predicates
     /*  977807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977820 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  977820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977845 */     GIR_RootConstrainSelectedInstOperands,
     /*  977846 */     // GIR_Coverage, 9158,
     /*  977846 */     GIR_EraseRootFromParent_Done,
     /*  977847 */   // Label 14640: @977847
     /*  977847 */   GIM_Try, /*On fail goto*//*Label 14641*/ GIMT_Encode4(977942), // Rule ID 9159 //
     /*  977852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  977869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977902 */     // MIs[1] Operand 1
     /*  977902 */     // No operand predicates
     /*  977902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977915 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  977915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977940 */     GIR_RootConstrainSelectedInstOperands,
     /*  977941 */     // GIR_Coverage, 9159,
     /*  977941 */     GIR_EraseRootFromParent_Done,
     /*  977942 */   // Label 14641: @977942
     /*  977942 */   GIM_Try, /*On fail goto*//*Label 14642*/ GIMT_Encode4(978037), // Rule ID 9162 //
     /*  977947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  977950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  977964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977997 */     // MIs[1] Operand 1
     /*  977997 */     // No operand predicates
     /*  977997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978010 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  978010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  978032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978035 */     GIR_RootConstrainSelectedInstOperands,
     /*  978036 */     // GIR_Coverage, 9162,
     /*  978036 */     GIR_EraseRootFromParent_Done,
     /*  978037 */   // Label 14642: @978037
     /*  978037 */   GIM_Try, /*On fail goto*//*Label 14643*/ GIMT_Encode4(978132), // Rule ID 9163 //
     /*  978042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  978045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  978053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  978056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  978059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  978065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978092 */     // MIs[1] Operand 1
     /*  978092 */     // No operand predicates
     /*  978092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978105 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  978105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  978127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978130 */     GIR_RootConstrainSelectedInstOperands,
     /*  978131 */     // GIR_Coverage, 9163,
     /*  978131 */     GIR_EraseRootFromParent_Done,
     /*  978132 */   // Label 14643: @978132
     /*  978132 */   GIM_Try, /*On fail goto*//*Label 14644*/ GIMT_Encode4(978227), // Rule ID 9166 //
     /*  978137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  978154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978187 */     // MIs[1] Operand 1
     /*  978187 */     // No operand predicates
     /*  978187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978200 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978225 */     GIR_RootConstrainSelectedInstOperands,
     /*  978226 */     // GIR_Coverage, 9166,
     /*  978226 */     GIR_EraseRootFromParent_Done,
     /*  978227 */   // Label 14644: @978227
     /*  978227 */   GIM_Try, /*On fail goto*//*Label 14645*/ GIMT_Encode4(978322), // Rule ID 9167 //
     /*  978232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  978249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978282 */     // MIs[1] Operand 1
     /*  978282 */     // No operand predicates
     /*  978282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978295 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978320 */     GIR_RootConstrainSelectedInstOperands,
     /*  978321 */     // GIR_Coverage, 9167,
     /*  978321 */     GIR_EraseRootFromParent_Done,
     /*  978322 */   // Label 14645: @978322
     /*  978322 */   GIM_Try, /*On fail goto*//*Label 14646*/ GIMT_Encode4(978417), // Rule ID 9170 //
     /*  978327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  978344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978377 */     // MIs[1] Operand 1
     /*  978377 */     // No operand predicates
     /*  978377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978390 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  978393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978415 */     GIR_RootConstrainSelectedInstOperands,
     /*  978416 */     // GIR_Coverage, 9170,
     /*  978416 */     GIR_EraseRootFromParent_Done,
     /*  978417 */   // Label 14646: @978417
     /*  978417 */   GIM_Try, /*On fail goto*//*Label 14647*/ GIMT_Encode4(978512), // Rule ID 9171 //
     /*  978422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  978439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978472 */     // MIs[1] Operand 1
     /*  978472 */     // No operand predicates
     /*  978472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978485 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  978488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978510 */     GIR_RootConstrainSelectedInstOperands,
     /*  978511 */     // GIR_Coverage, 9171,
     /*  978511 */     GIR_EraseRootFromParent_Done,
     /*  978512 */   // Label 14647: @978512
     /*  978512 */   GIM_Try, /*On fail goto*//*Label 14648*/ GIMT_Encode4(978607), // Rule ID 9174 //
     /*  978517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  978528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  978531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  978534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  978540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978567 */     // MIs[1] Operand 1
     /*  978567 */     // No operand predicates
     /*  978567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978580 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  978583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978605 */     GIR_RootConstrainSelectedInstOperands,
     /*  978606 */     // GIR_Coverage, 9174,
     /*  978606 */     GIR_EraseRootFromParent_Done,
     /*  978607 */   // Label 14648: @978607
     /*  978607 */   GIM_Try, /*On fail goto*//*Label 14649*/ GIMT_Encode4(978702), // Rule ID 9175 //
     /*  978612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  978623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  978626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  978629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  978635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978662 */     // MIs[1] Operand 1
     /*  978662 */     // No operand predicates
     /*  978662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978675 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  978678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978700 */     GIR_RootConstrainSelectedInstOperands,
     /*  978701 */     // GIR_Coverage, 9175,
     /*  978701 */     GIR_EraseRootFromParent_Done,
     /*  978702 */   // Label 14649: @978702
     /*  978702 */   GIM_Try, /*On fail goto*//*Label 14650*/ GIMT_Encode4(978797), // Rule ID 9178 //
     /*  978707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  978718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  978721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  978724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  978730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978757 */     // MIs[1] Operand 1
     /*  978757 */     // No operand predicates
     /*  978757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978770 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978795 */     GIR_RootConstrainSelectedInstOperands,
     /*  978796 */     // GIR_Coverage, 9178,
     /*  978796 */     GIR_EraseRootFromParent_Done,
     /*  978797 */   // Label 14650: @978797
     /*  978797 */   GIM_Try, /*On fail goto*//*Label 14651*/ GIMT_Encode4(978892), // Rule ID 9179 //
     /*  978802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  978813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  978816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  978819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  978825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978852 */     // MIs[1] Operand 1
     /*  978852 */     // No operand predicates
     /*  978852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978865 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  978865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978890 */     GIR_RootConstrainSelectedInstOperands,
     /*  978891 */     // GIR_Coverage, 9179,
     /*  978891 */     GIR_EraseRootFromParent_Done,
     /*  978892 */   // Label 14651: @978892
     /*  978892 */   GIM_Try, /*On fail goto*//*Label 14652*/ GIMT_Encode4(978987), // Rule ID 9182 //
     /*  978897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  978914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978947 */     // MIs[1] Operand 1
     /*  978947 */     // No operand predicates
     /*  978947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978960 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  978963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978985 */     GIR_RootConstrainSelectedInstOperands,
     /*  978986 */     // GIR_Coverage, 9182,
     /*  978986 */     GIR_EraseRootFromParent_Done,
     /*  978987 */   // Label 14652: @978987
     /*  978987 */   GIM_Try, /*On fail goto*//*Label 14653*/ GIMT_Encode4(979082), // Rule ID 9183 //
     /*  978992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  979009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979042 */     // MIs[1] Operand 1
     /*  979042 */     // No operand predicates
     /*  979042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979055 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  979055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979080 */     GIR_RootConstrainSelectedInstOperands,
     /*  979081 */     // GIR_Coverage, 9183,
     /*  979081 */     GIR_EraseRootFromParent_Done,
     /*  979082 */   // Label 14653: @979082
     /*  979082 */   GIM_Try, /*On fail goto*//*Label 14654*/ GIMT_Encode4(979177), // Rule ID 9186 //
     /*  979087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  979098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  979101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  979104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  979110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979137 */     // MIs[1] Operand 1
     /*  979137 */     // No operand predicates
     /*  979137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979150 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  979150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979175 */     GIR_RootConstrainSelectedInstOperands,
     /*  979176 */     // GIR_Coverage, 9186,
     /*  979176 */     GIR_EraseRootFromParent_Done,
     /*  979177 */   // Label 14654: @979177
     /*  979177 */   GIM_Try, /*On fail goto*//*Label 14655*/ GIMT_Encode4(979272), // Rule ID 9187 //
     /*  979182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  979193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  979196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  979199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  979205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979232 */     // MIs[1] Operand 1
     /*  979232 */     // No operand predicates
     /*  979232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979245 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  979245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979270 */     GIR_RootConstrainSelectedInstOperands,
     /*  979271 */     // GIR_Coverage, 9187,
     /*  979271 */     GIR_EraseRootFromParent_Done,
     /*  979272 */   // Label 14655: @979272
     /*  979272 */   GIM_Try, /*On fail goto*//*Label 14656*/ GIMT_Encode4(979367), // Rule ID 9190 //
     /*  979277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  979294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979327 */     // MIs[1] Operand 1
     /*  979327 */     // No operand predicates
     /*  979327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979340 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979365 */     GIR_RootConstrainSelectedInstOperands,
     /*  979366 */     // GIR_Coverage, 9190,
     /*  979366 */     GIR_EraseRootFromParent_Done,
     /*  979367 */   // Label 14656: @979367
     /*  979367 */   GIM_Try, /*On fail goto*//*Label 14657*/ GIMT_Encode4(979462), // Rule ID 9191 //
     /*  979372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  979389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979422 */     // MIs[1] Operand 1
     /*  979422 */     // No operand predicates
     /*  979422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979435 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979460 */     GIR_RootConstrainSelectedInstOperands,
     /*  979461 */     // GIR_Coverage, 9191,
     /*  979461 */     GIR_EraseRootFromParent_Done,
     /*  979462 */   // Label 14657: @979462
     /*  979462 */   GIM_Try, /*On fail goto*//*Label 14658*/ GIMT_Encode4(979557), // Rule ID 9194 //
     /*  979467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  979484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979517 */     // MIs[1] Operand 1
     /*  979517 */     // No operand predicates
     /*  979517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979530 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979555 */     GIR_RootConstrainSelectedInstOperands,
     /*  979556 */     // GIR_Coverage, 9194,
     /*  979556 */     GIR_EraseRootFromParent_Done,
     /*  979557 */   // Label 14658: @979557
     /*  979557 */   GIM_Try, /*On fail goto*//*Label 14659*/ GIMT_Encode4(979652), // Rule ID 9195 //
     /*  979562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  979579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979612 */     // MIs[1] Operand 1
     /*  979612 */     // No operand predicates
     /*  979612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979625 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979650 */     GIR_RootConstrainSelectedInstOperands,
     /*  979651 */     // GIR_Coverage, 9195,
     /*  979651 */     GIR_EraseRootFromParent_Done,
     /*  979652 */   // Label 14659: @979652
     /*  979652 */   GIM_Try, /*On fail goto*//*Label 14660*/ GIMT_Encode4(979747), // Rule ID 9198 //
     /*  979657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  979674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979707 */     // MIs[1] Operand 1
     /*  979707 */     // No operand predicates
     /*  979707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979720 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979745 */     GIR_RootConstrainSelectedInstOperands,
     /*  979746 */     // GIR_Coverage, 9198,
     /*  979746 */     GIR_EraseRootFromParent_Done,
     /*  979747 */   // Label 14660: @979747
     /*  979747 */   GIM_Try, /*On fail goto*//*Label 14661*/ GIMT_Encode4(979842), // Rule ID 9199 //
     /*  979752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  979769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979802 */     // MIs[1] Operand 1
     /*  979802 */     // No operand predicates
     /*  979802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979815 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979840 */     GIR_RootConstrainSelectedInstOperands,
     /*  979841 */     // GIR_Coverage, 9199,
     /*  979841 */     GIR_EraseRootFromParent_Done,
     /*  979842 */   // Label 14661: @979842
     /*  979842 */   GIM_Try, /*On fail goto*//*Label 14662*/ GIMT_Encode4(979937), // Rule ID 9202 //
     /*  979847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  979850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  979858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  979861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  979864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  979870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979897 */     // MIs[1] Operand 1
     /*  979897 */     // No operand predicates
     /*  979897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979910 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  979910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979935 */     GIR_RootConstrainSelectedInstOperands,
     /*  979936 */     // GIR_Coverage, 9202,
     /*  979936 */     GIR_EraseRootFromParent_Done,
     /*  979937 */   // Label 14662: @979937
     /*  979937 */   GIM_Try, /*On fail goto*//*Label 14663*/ GIMT_Encode4(980032), // Rule ID 9203 //
     /*  979942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  979945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  979953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  979956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  979959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  979965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979992 */     // MIs[1] Operand 1
     /*  979992 */     // No operand predicates
     /*  979992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980005 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  980005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  980008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980030 */     GIR_RootConstrainSelectedInstOperands,
     /*  980031 */     // GIR_Coverage, 9203,
     /*  980031 */     GIR_EraseRootFromParent_Done,
     /*  980032 */   // Label 14663: @980032
     /*  980032 */   GIM_Try, /*On fail goto*//*Label 14664*/ GIMT_Encode4(980127), // Rule ID 9206 //
     /*  980037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  980040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  980054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  980075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980087 */     // MIs[1] Operand 1
     /*  980087 */     // No operand predicates
     /*  980087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980100 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  980100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  980103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980125 */     GIR_RootConstrainSelectedInstOperands,
     /*  980126 */     // GIR_Coverage, 9206,
     /*  980126 */     GIR_EraseRootFromParent_Done,
     /*  980127 */   // Label 14664: @980127
     /*  980127 */   GIM_Try, /*On fail goto*//*Label 14665*/ GIMT_Encode4(980222), // Rule ID 9207 //
     /*  980132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  980135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  980149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  980170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980182 */     // MIs[1] Operand 1
     /*  980182 */     // No operand predicates
     /*  980182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980195 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  980195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  980198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980220 */     GIR_RootConstrainSelectedInstOperands,
     /*  980221 */     // GIR_Coverage, 9207,
     /*  980221 */     GIR_EraseRootFromParent_Done,
     /*  980222 */   // Label 14665: @980222
     /*  980222 */   GIM_Try, /*On fail goto*//*Label 14666*/ GIMT_Encode4(980317), // Rule ID 9210 //
     /*  980227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  980230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  980238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  980241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  980244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  980250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980277 */     // MIs[1] Operand 1
     /*  980277 */     // No operand predicates
     /*  980277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980290 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  980290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  980293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980315 */     GIR_RootConstrainSelectedInstOperands,
     /*  980316 */     // GIR_Coverage, 9210,
     /*  980316 */     GIR_EraseRootFromParent_Done,
     /*  980317 */   // Label 14666: @980317
     /*  980317 */   GIM_Try, /*On fail goto*//*Label 14667*/ GIMT_Encode4(980412), // Rule ID 9211 //
     /*  980322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  980325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  980333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  980336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  980339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  980345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980372 */     // MIs[1] Operand 1
     /*  980372 */     // No operand predicates
     /*  980372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980385 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  980385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  980388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980410 */     GIR_RootConstrainSelectedInstOperands,
     /*  980411 */     // GIR_Coverage, 9211,
     /*  980411 */     GIR_EraseRootFromParent_Done,
     /*  980412 */   // Label 14667: @980412
     /*  980412 */   GIM_Try, /*On fail goto*//*Label 14668*/ GIMT_Encode4(980507), // Rule ID 9302 //
     /*  980417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980467 */     // MIs[1] Operand 1
     /*  980467 */     // No operand predicates
     /*  980467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980480 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  980483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980505 */     GIR_RootConstrainSelectedInstOperands,
     /*  980506 */     // GIR_Coverage, 9302,
     /*  980506 */     GIR_EraseRootFromParent_Done,
     /*  980507 */   // Label 14668: @980507
     /*  980507 */   GIM_Try, /*On fail goto*//*Label 14669*/ GIMT_Encode4(980602), // Rule ID 9303 //
     /*  980512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980562 */     // MIs[1] Operand 1
     /*  980562 */     // No operand predicates
     /*  980562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980575 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  980578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980600 */     GIR_RootConstrainSelectedInstOperands,
     /*  980601 */     // GIR_Coverage, 9303,
     /*  980601 */     GIR_EraseRootFromParent_Done,
     /*  980602 */   // Label 14669: @980602
     /*  980602 */   GIM_Try, /*On fail goto*//*Label 14670*/ GIMT_Encode4(980697), // Rule ID 9306 //
     /*  980607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  980624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980657 */     // MIs[1] Operand 1
     /*  980657 */     // No operand predicates
     /*  980657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980670 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  980673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980695 */     GIR_RootConstrainSelectedInstOperands,
     /*  980696 */     // GIR_Coverage, 9306,
     /*  980696 */     GIR_EraseRootFromParent_Done,
     /*  980697 */   // Label 14670: @980697
     /*  980697 */   GIM_Try, /*On fail goto*//*Label 14671*/ GIMT_Encode4(980792), // Rule ID 9307 //
     /*  980702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  980719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980752 */     // MIs[1] Operand 1
     /*  980752 */     // No operand predicates
     /*  980752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980765 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  980768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980790 */     GIR_RootConstrainSelectedInstOperands,
     /*  980791 */     // GIR_Coverage, 9307,
     /*  980791 */     GIR_EraseRootFromParent_Done,
     /*  980792 */   // Label 14671: @980792
     /*  980792 */   GIM_Try, /*On fail goto*//*Label 14672*/ GIMT_Encode4(980887), // Rule ID 9310 //
     /*  980797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  980814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980847 */     // MIs[1] Operand 1
     /*  980847 */     // No operand predicates
     /*  980847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980860 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  980863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980885 */     GIR_RootConstrainSelectedInstOperands,
     /*  980886 */     // GIR_Coverage, 9310,
     /*  980886 */     GIR_EraseRootFromParent_Done,
     /*  980887 */   // Label 14672: @980887
     /*  980887 */   GIM_Try, /*On fail goto*//*Label 14673*/ GIMT_Encode4(980982), // Rule ID 9311 //
     /*  980892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  980909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980942 */     // MIs[1] Operand 1
     /*  980942 */     // No operand predicates
     /*  980942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980955 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  980958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980980 */     GIR_RootConstrainSelectedInstOperands,
     /*  980981 */     // GIR_Coverage, 9311,
     /*  980981 */     GIR_EraseRootFromParent_Done,
     /*  980982 */   // Label 14673: @980982
     /*  980982 */   GIM_Try, /*On fail goto*//*Label 14674*/ GIMT_Encode4(981077), // Rule ID 9314 //
     /*  980987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  981004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981037 */     // MIs[1] Operand 1
     /*  981037 */     // No operand predicates
     /*  981037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981050 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  981050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  981053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981075 */     GIR_RootConstrainSelectedInstOperands,
     /*  981076 */     // GIR_Coverage, 9314,
     /*  981076 */     GIR_EraseRootFromParent_Done,
     /*  981077 */   // Label 14674: @981077
     /*  981077 */   GIM_Try, /*On fail goto*//*Label 14675*/ GIMT_Encode4(981172), // Rule ID 9315 //
     /*  981082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  981099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981132 */     // MIs[1] Operand 1
     /*  981132 */     // No operand predicates
     /*  981132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981145 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  981145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  981148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981170 */     GIR_RootConstrainSelectedInstOperands,
     /*  981171 */     // GIR_Coverage, 9315,
     /*  981171 */     GIR_EraseRootFromParent_Done,
     /*  981172 */   // Label 14675: @981172
     /*  981172 */   GIM_Try, /*On fail goto*//*Label 14676*/ GIMT_Encode4(981267), // Rule ID 9318 //
     /*  981177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  981194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981227 */     // MIs[1] Operand 1
     /*  981227 */     // No operand predicates
     /*  981227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981240 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  981240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981265 */     GIR_RootConstrainSelectedInstOperands,
     /*  981266 */     // GIR_Coverage, 9318,
     /*  981266 */     GIR_EraseRootFromParent_Done,
     /*  981267 */   // Label 14676: @981267
     /*  981267 */   GIM_Try, /*On fail goto*//*Label 14677*/ GIMT_Encode4(981362), // Rule ID 9319 //
     /*  981272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  981289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981322 */     // MIs[1] Operand 1
     /*  981322 */     // No operand predicates
     /*  981322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981335 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  981335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981360 */     GIR_RootConstrainSelectedInstOperands,
     /*  981361 */     // GIR_Coverage, 9319,
     /*  981361 */     GIR_EraseRootFromParent_Done,
     /*  981362 */   // Label 14677: @981362
     /*  981362 */   GIM_Try, /*On fail goto*//*Label 14678*/ GIMT_Encode4(981457), // Rule ID 9322 //
     /*  981367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981417 */     // MIs[1] Operand 1
     /*  981417 */     // No operand predicates
     /*  981417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981430 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  981430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981455 */     GIR_RootConstrainSelectedInstOperands,
     /*  981456 */     // GIR_Coverage, 9322,
     /*  981456 */     GIR_EraseRootFromParent_Done,
     /*  981457 */   // Label 14678: @981457
     /*  981457 */   GIM_Try, /*On fail goto*//*Label 14679*/ GIMT_Encode4(981552), // Rule ID 9323 //
     /*  981462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981512 */     // MIs[1] Operand 1
     /*  981512 */     // No operand predicates
     /*  981512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981525 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  981525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981550 */     GIR_RootConstrainSelectedInstOperands,
     /*  981551 */     // GIR_Coverage, 9323,
     /*  981551 */     GIR_EraseRootFromParent_Done,
     /*  981552 */   // Label 14679: @981552
     /*  981552 */   GIM_Try, /*On fail goto*//*Label 14680*/ GIMT_Encode4(981647), // Rule ID 9326 //
     /*  981557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  981568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  981571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  981574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  981580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981607 */     // MIs[1] Operand 1
     /*  981607 */     // No operand predicates
     /*  981607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  981620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981645 */     GIR_RootConstrainSelectedInstOperands,
     /*  981646 */     // GIR_Coverage, 9326,
     /*  981646 */     GIR_EraseRootFromParent_Done,
     /*  981647 */   // Label 14680: @981647
     /*  981647 */   GIM_Try, /*On fail goto*//*Label 14681*/ GIMT_Encode4(981742), // Rule ID 9327 //
     /*  981652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  981663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  981666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  981669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  981675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981702 */     // MIs[1] Operand 1
     /*  981702 */     // No operand predicates
     /*  981702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981715 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  981715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981740 */     GIR_RootConstrainSelectedInstOperands,
     /*  981741 */     // GIR_Coverage, 9327,
     /*  981741 */     GIR_EraseRootFromParent_Done,
     /*  981742 */   // Label 14681: @981742
     /*  981742 */   GIM_Try, /*On fail goto*//*Label 14682*/ GIMT_Encode4(981837), // Rule ID 9330 //
     /*  981747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  981764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981797 */     // MIs[1] Operand 1
     /*  981797 */     // No operand predicates
     /*  981797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981810 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  981810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981835 */     GIR_RootConstrainSelectedInstOperands,
     /*  981836 */     // GIR_Coverage, 9330,
     /*  981836 */     GIR_EraseRootFromParent_Done,
     /*  981837 */   // Label 14682: @981837
     /*  981837 */   GIM_Try, /*On fail goto*//*Label 14683*/ GIMT_Encode4(981932), // Rule ID 9331 //
     /*  981842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  981859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981892 */     // MIs[1] Operand 1
     /*  981892 */     // No operand predicates
     /*  981892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981905 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  981905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981930 */     GIR_RootConstrainSelectedInstOperands,
     /*  981931 */     // GIR_Coverage, 9331,
     /*  981931 */     GIR_EraseRootFromParent_Done,
     /*  981932 */   // Label 14683: @981932
     /*  981932 */   GIM_Try, /*On fail goto*//*Label 14684*/ GIMT_Encode4(982027), // Rule ID 9334 //
     /*  981937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  981954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981987 */     // MIs[1] Operand 1
     /*  981987 */     // No operand predicates
     /*  981987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982000 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  982000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  982022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982025 */     GIR_RootConstrainSelectedInstOperands,
     /*  982026 */     // GIR_Coverage, 9334,
     /*  982026 */     GIR_EraseRootFromParent_Done,
     /*  982027 */   // Label 14684: @982027
     /*  982027 */   GIM_Try, /*On fail goto*//*Label 14685*/ GIMT_Encode4(982122), // Rule ID 9335 //
     /*  982032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  982043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  982046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  982049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  982055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982082 */     // MIs[1] Operand 1
     /*  982082 */     // No operand predicates
     /*  982082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982095 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  982095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  982117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982120 */     GIR_RootConstrainSelectedInstOperands,
     /*  982121 */     // GIR_Coverage, 9335,
     /*  982121 */     GIR_EraseRootFromParent_Done,
     /*  982122 */   // Label 14685: @982122
     /*  982122 */   GIM_Try, /*On fail goto*//*Label 14686*/ GIMT_Encode4(982217), // Rule ID 9338 //
     /*  982127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  982130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  982138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  982141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  982144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  982150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982177 */     // MIs[1] Operand 1
     /*  982177 */     // No operand predicates
     /*  982177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  982190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  982212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982215 */     GIR_RootConstrainSelectedInstOperands,
     /*  982216 */     // GIR_Coverage, 9338,
     /*  982216 */     GIR_EraseRootFromParent_Done,
     /*  982217 */   // Label 14686: @982217
     /*  982217 */   GIM_Try, /*On fail goto*//*Label 14687*/ GIMT_Encode4(982312), // Rule ID 9339 //
     /*  982222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  982225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  982233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  982236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  982239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  982245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982272 */     // MIs[1] Operand 1
     /*  982272 */     // No operand predicates
     /*  982272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982285 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  982285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  982307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982310 */     GIR_RootConstrainSelectedInstOperands,
     /*  982311 */     // GIR_Coverage, 9339,
     /*  982311 */     GIR_EraseRootFromParent_Done,
     /*  982312 */   // Label 14687: @982312
     /*  982312 */   GIM_Try, /*On fail goto*//*Label 14688*/ GIMT_Encode4(982407), // Rule ID 9342 //
     /*  982317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  982334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982367 */     // MIs[1] Operand 1
     /*  982367 */     // No operand predicates
     /*  982367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982380 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  982383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982405 */     GIR_RootConstrainSelectedInstOperands,
     /*  982406 */     // GIR_Coverage, 9342,
     /*  982406 */     GIR_EraseRootFromParent_Done,
     /*  982407 */   // Label 14688: @982407
     /*  982407 */   GIM_Try, /*On fail goto*//*Label 14689*/ GIMT_Encode4(982502), // Rule ID 9343 //
     /*  982412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  982429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982462 */     // MIs[1] Operand 1
     /*  982462 */     // No operand predicates
     /*  982462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982475 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  982478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982500 */     GIR_RootConstrainSelectedInstOperands,
     /*  982501 */     // GIR_Coverage, 9343,
     /*  982501 */     GIR_EraseRootFromParent_Done,
     /*  982502 */   // Label 14689: @982502
     /*  982502 */   GIM_Try, /*On fail goto*//*Label 14690*/ GIMT_Encode4(982597), // Rule ID 9346 //
     /*  982507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982557 */     // MIs[1] Operand 1
     /*  982557 */     // No operand predicates
     /*  982557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982570 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  982573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982595 */     GIR_RootConstrainSelectedInstOperands,
     /*  982596 */     // GIR_Coverage, 9346,
     /*  982596 */     GIR_EraseRootFromParent_Done,
     /*  982597 */   // Label 14690: @982597
     /*  982597 */   GIM_Try, /*On fail goto*//*Label 14691*/ GIMT_Encode4(982692), // Rule ID 9347 //
     /*  982602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982652 */     // MIs[1] Operand 1
     /*  982652 */     // No operand predicates
     /*  982652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982665 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  982668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982690 */     GIR_RootConstrainSelectedInstOperands,
     /*  982691 */     // GIR_Coverage, 9347,
     /*  982691 */     GIR_EraseRootFromParent_Done,
     /*  982692 */   // Label 14691: @982692
     /*  982692 */   GIM_Try, /*On fail goto*//*Label 14692*/ GIMT_Encode4(982787), // Rule ID 9350 //
     /*  982697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  982708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  982711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  982714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  982720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982747 */     // MIs[1] Operand 1
     /*  982747 */     // No operand predicates
     /*  982747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982760 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  982763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982785 */     GIR_RootConstrainSelectedInstOperands,
     /*  982786 */     // GIR_Coverage, 9350,
     /*  982786 */     GIR_EraseRootFromParent_Done,
     /*  982787 */   // Label 14692: @982787
     /*  982787 */   GIM_Try, /*On fail goto*//*Label 14693*/ GIMT_Encode4(982882), // Rule ID 9351 //
     /*  982792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  982803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  982806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  982809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  982815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982842 */     // MIs[1] Operand 1
     /*  982842 */     // No operand predicates
     /*  982842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982855 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  982858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982880 */     GIR_RootConstrainSelectedInstOperands,
     /*  982881 */     // GIR_Coverage, 9351,
     /*  982881 */     GIR_EraseRootFromParent_Done,
     /*  982882 */   // Label 14693: @982882
     /*  982882 */   GIM_Try, /*On fail goto*//*Label 14694*/ GIMT_Encode4(982977), // Rule ID 9354 //
     /*  982887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  982904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  982910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982937 */     // MIs[1] Operand 1
     /*  982937 */     // No operand predicates
     /*  982937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982950 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  982950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  982953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982975 */     GIR_RootConstrainSelectedInstOperands,
     /*  982976 */     // GIR_Coverage, 9354,
     /*  982976 */     GIR_EraseRootFromParent_Done,
     /*  982977 */   // Label 14694: @982977
     /*  982977 */   GIM_Try, /*On fail goto*//*Label 14695*/ GIMT_Encode4(983072), // Rule ID 9355 //
     /*  982982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  982999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983032 */     // MIs[1] Operand 1
     /*  983032 */     // No operand predicates
     /*  983032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983045 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983070 */     GIR_RootConstrainSelectedInstOperands,
     /*  983071 */     // GIR_Coverage, 9355,
     /*  983071 */     GIR_EraseRootFromParent_Done,
     /*  983072 */   // Label 14695: @983072
     /*  983072 */   GIM_Try, /*On fail goto*//*Label 14696*/ GIMT_Encode4(983167), // Rule ID 9358 //
     /*  983077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  983094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983127 */     // MIs[1] Operand 1
     /*  983127 */     // No operand predicates
     /*  983127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983140 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  983140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983165 */     GIR_RootConstrainSelectedInstOperands,
     /*  983166 */     // GIR_Coverage, 9358,
     /*  983166 */     GIR_EraseRootFromParent_Done,
     /*  983167 */   // Label 14696: @983167
     /*  983167 */   GIM_Try, /*On fail goto*//*Label 14697*/ GIMT_Encode4(983262), // Rule ID 9359 //
     /*  983172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  983189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983222 */     // MIs[1] Operand 1
     /*  983222 */     // No operand predicates
     /*  983222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983235 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983260 */     GIR_RootConstrainSelectedInstOperands,
     /*  983261 */     // GIR_Coverage, 9359,
     /*  983261 */     GIR_EraseRootFromParent_Done,
     /*  983262 */   // Label 14697: @983262
     /*  983262 */   GIM_Try, /*On fail goto*//*Label 14698*/ GIMT_Encode4(983357), // Rule ID 9362 //
     /*  983267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  983278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  983281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  983284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  983290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983317 */     // MIs[1] Operand 1
     /*  983317 */     // No operand predicates
     /*  983317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983330 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  983330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983355 */     GIR_RootConstrainSelectedInstOperands,
     /*  983356 */     // GIR_Coverage, 9362,
     /*  983356 */     GIR_EraseRootFromParent_Done,
     /*  983357 */   // Label 14698: @983357
     /*  983357 */   GIM_Try, /*On fail goto*//*Label 14699*/ GIMT_Encode4(983452), // Rule ID 9363 //
     /*  983362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  983373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  983376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  983379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  983385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983412 */     // MIs[1] Operand 1
     /*  983412 */     // No operand predicates
     /*  983412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983425 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983450 */     GIR_RootConstrainSelectedInstOperands,
     /*  983451 */     // GIR_Coverage, 9363,
     /*  983451 */     GIR_EraseRootFromParent_Done,
     /*  983452 */   // Label 14699: @983452
     /*  983452 */   GIM_Try, /*On fail goto*//*Label 14700*/ GIMT_Encode4(983547), // Rule ID 9366 //
     /*  983457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  983474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983507 */     // MIs[1] Operand 1
     /*  983507 */     // No operand predicates
     /*  983507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983520 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983545 */     GIR_RootConstrainSelectedInstOperands,
     /*  983546 */     // GIR_Coverage, 9366,
     /*  983546 */     GIR_EraseRootFromParent_Done,
     /*  983547 */   // Label 14700: @983547
     /*  983547 */   GIM_Try, /*On fail goto*//*Label 14701*/ GIMT_Encode4(983642), // Rule ID 9367 //
     /*  983552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  983569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983602 */     // MIs[1] Operand 1
     /*  983602 */     // No operand predicates
     /*  983602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983615 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983640 */     GIR_RootConstrainSelectedInstOperands,
     /*  983641 */     // GIR_Coverage, 9367,
     /*  983641 */     GIR_EraseRootFromParent_Done,
     /*  983642 */   // Label 14701: @983642
     /*  983642 */   GIM_Try, /*On fail goto*//*Label 14702*/ GIMT_Encode4(983737), // Rule ID 9370 //
     /*  983647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  983664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983697 */     // MIs[1] Operand 1
     /*  983697 */     // No operand predicates
     /*  983697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983710 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983735 */     GIR_RootConstrainSelectedInstOperands,
     /*  983736 */     // GIR_Coverage, 9370,
     /*  983736 */     GIR_EraseRootFromParent_Done,
     /*  983737 */   // Label 14702: @983737
     /*  983737 */   GIM_Try, /*On fail goto*//*Label 14703*/ GIMT_Encode4(983832), // Rule ID 9371 //
     /*  983742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  983759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983792 */     // MIs[1] Operand 1
     /*  983792 */     // No operand predicates
     /*  983792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983805 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983830 */     GIR_RootConstrainSelectedInstOperands,
     /*  983831 */     // GIR_Coverage, 9371,
     /*  983831 */     GIR_EraseRootFromParent_Done,
     /*  983832 */   // Label 14703: @983832
     /*  983832 */   GIM_Try, /*On fail goto*//*Label 14704*/ GIMT_Encode4(983927), // Rule ID 9374 //
     /*  983837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  983854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983887 */     // MIs[1] Operand 1
     /*  983887 */     // No operand predicates
     /*  983887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983900 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983925 */     GIR_RootConstrainSelectedInstOperands,
     /*  983926 */     // GIR_Coverage, 9374,
     /*  983926 */     GIR_EraseRootFromParent_Done,
     /*  983927 */   // Label 14704: @983927
     /*  983927 */   GIM_Try, /*On fail goto*//*Label 14705*/ GIMT_Encode4(984022), // Rule ID 9375 //
     /*  983932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  983949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983982 */     // MIs[1] Operand 1
     /*  983982 */     // No operand predicates
     /*  983982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983995 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984020 */     GIR_RootConstrainSelectedInstOperands,
     /*  984021 */     // GIR_Coverage, 9375,
     /*  984021 */     GIR_EraseRootFromParent_Done,
     /*  984022 */   // Label 14705: @984022
     /*  984022 */   GIM_Try, /*On fail goto*//*Label 14706*/ GIMT_Encode4(984117), // Rule ID 9378 //
     /*  984027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  984044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  984065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984077 */     // MIs[1] Operand 1
     /*  984077 */     // No operand predicates
     /*  984077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984090 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  984093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984115 */     GIR_RootConstrainSelectedInstOperands,
     /*  984116 */     // GIR_Coverage, 9378,
     /*  984116 */     GIR_EraseRootFromParent_Done,
     /*  984117 */   // Label 14706: @984117
     /*  984117 */   GIM_Try, /*On fail goto*//*Label 14707*/ GIMT_Encode4(984212), // Rule ID 9379 //
     /*  984122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  984139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  984160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984172 */     // MIs[1] Operand 1
     /*  984172 */     // No operand predicates
     /*  984172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984185 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  984188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984210 */     GIR_RootConstrainSelectedInstOperands,
     /*  984211 */     // GIR_Coverage, 9379,
     /*  984211 */     GIR_EraseRootFromParent_Done,
     /*  984212 */   // Label 14707: @984212
     /*  984212 */   GIM_Try, /*On fail goto*//*Label 14708*/ GIMT_Encode4(984307), // Rule ID 9382 //
     /*  984217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  984234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984267 */     // MIs[1] Operand 1
     /*  984267 */     // No operand predicates
     /*  984267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984280 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  984283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984305 */     GIR_RootConstrainSelectedInstOperands,
     /*  984306 */     // GIR_Coverage, 9382,
     /*  984306 */     GIR_EraseRootFromParent_Done,
     /*  984307 */   // Label 14708: @984307
     /*  984307 */   GIM_Try, /*On fail goto*//*Label 14709*/ GIMT_Encode4(984402), // Rule ID 9383 //
     /*  984312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  984329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984362 */     // MIs[1] Operand 1
     /*  984362 */     // No operand predicates
     /*  984362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984375 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  984378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984400 */     GIR_RootConstrainSelectedInstOperands,
     /*  984401 */     // GIR_Coverage, 9383,
     /*  984401 */     GIR_EraseRootFromParent_Done,
     /*  984402 */   // Label 14709: @984402
     /*  984402 */   GIM_Try, /*On fail goto*//*Label 14710*/ GIMT_Encode4(984497), // Rule ID 9386 //
     /*  984407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  984424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984457 */     // MIs[1] Operand 1
     /*  984457 */     // No operand predicates
     /*  984457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984470 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  984473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984495 */     GIR_RootConstrainSelectedInstOperands,
     /*  984496 */     // GIR_Coverage, 9386,
     /*  984496 */     GIR_EraseRootFromParent_Done,
     /*  984497 */   // Label 14710: @984497
     /*  984497 */   GIM_Try, /*On fail goto*//*Label 14711*/ GIMT_Encode4(984592), // Rule ID 9387 //
     /*  984502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  984519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984552 */     // MIs[1] Operand 1
     /*  984552 */     // No operand predicates
     /*  984552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984565 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  984568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984590 */     GIR_RootConstrainSelectedInstOperands,
     /*  984591 */     // GIR_Coverage, 9387,
     /*  984591 */     GIR_EraseRootFromParent_Done,
     /*  984592 */   // Label 14711: @984592
     /*  984592 */   GIM_Try, /*On fail goto*//*Label 14712*/ GIMT_Encode4(984687), // Rule ID 9478 //
     /*  984597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  984614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984647 */     // MIs[1] Operand 1
     /*  984647 */     // No operand predicates
     /*  984647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984660 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  984660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  984663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984685 */     GIR_RootConstrainSelectedInstOperands,
     /*  984686 */     // GIR_Coverage, 9478,
     /*  984686 */     GIR_EraseRootFromParent_Done,
     /*  984687 */   // Label 14712: @984687
     /*  984687 */   GIM_Try, /*On fail goto*//*Label 14713*/ GIMT_Encode4(984782), // Rule ID 9479 //
     /*  984692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  984709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984742 */     // MIs[1] Operand 1
     /*  984742 */     // No operand predicates
     /*  984742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984755 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  984755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  984758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984780 */     GIR_RootConstrainSelectedInstOperands,
     /*  984781 */     // GIR_Coverage, 9479,
     /*  984781 */     GIR_EraseRootFromParent_Done,
     /*  984782 */   // Label 14713: @984782
     /*  984782 */   GIM_Try, /*On fail goto*//*Label 14714*/ GIMT_Encode4(984877), // Rule ID 9482 //
     /*  984787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  984804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984837 */     // MIs[1] Operand 1
     /*  984837 */     // No operand predicates
     /*  984837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984850 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  984850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  984853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984875 */     GIR_RootConstrainSelectedInstOperands,
     /*  984876 */     // GIR_Coverage, 9482,
     /*  984876 */     GIR_EraseRootFromParent_Done,
     /*  984877 */   // Label 14714: @984877
     /*  984877 */   GIM_Try, /*On fail goto*//*Label 14715*/ GIMT_Encode4(984972), // Rule ID 9483 //
     /*  984882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  984899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984932 */     // MIs[1] Operand 1
     /*  984932 */     // No operand predicates
     /*  984932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984945 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  984945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  984948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984970 */     GIR_RootConstrainSelectedInstOperands,
     /*  984971 */     // GIR_Coverage, 9483,
     /*  984971 */     GIR_EraseRootFromParent_Done,
     /*  984972 */   // Label 14715: @984972
     /*  984972 */   GIM_Try, /*On fail goto*//*Label 14716*/ GIMT_Encode4(985067), // Rule ID 9486 //
     /*  984977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  984994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985027 */     // MIs[1] Operand 1
     /*  985027 */     // No operand predicates
     /*  985027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985040 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  985040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985065 */     GIR_RootConstrainSelectedInstOperands,
     /*  985066 */     // GIR_Coverage, 9486,
     /*  985066 */     GIR_EraseRootFromParent_Done,
     /*  985067 */   // Label 14716: @985067
     /*  985067 */   GIM_Try, /*On fail goto*//*Label 14717*/ GIMT_Encode4(985162), // Rule ID 9487 //
     /*  985072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  985089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985122 */     // MIs[1] Operand 1
     /*  985122 */     // No operand predicates
     /*  985122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985135 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  985135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985160 */     GIR_RootConstrainSelectedInstOperands,
     /*  985161 */     // GIR_Coverage, 9487,
     /*  985161 */     GIR_EraseRootFromParent_Done,
     /*  985162 */   // Label 14717: @985162
     /*  985162 */   GIM_Try, /*On fail goto*//*Label 14718*/ GIMT_Encode4(985257), // Rule ID 9490 //
     /*  985167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  985184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985217 */     // MIs[1] Operand 1
     /*  985217 */     // No operand predicates
     /*  985217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985230 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  985233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985255 */     GIR_RootConstrainSelectedInstOperands,
     /*  985256 */     // GIR_Coverage, 9490,
     /*  985256 */     GIR_EraseRootFromParent_Done,
     /*  985257 */   // Label 14718: @985257
     /*  985257 */   GIM_Try, /*On fail goto*//*Label 14719*/ GIMT_Encode4(985352), // Rule ID 9491 //
     /*  985262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  985279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985312 */     // MIs[1] Operand 1
     /*  985312 */     // No operand predicates
     /*  985312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985325 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  985325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  985328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985350 */     GIR_RootConstrainSelectedInstOperands,
     /*  985351 */     // GIR_Coverage, 9491,
     /*  985351 */     GIR_EraseRootFromParent_Done,
     /*  985352 */   // Label 14719: @985352
     /*  985352 */   GIM_Try, /*On fail goto*//*Label 14720*/ GIMT_Encode4(985447), // Rule ID 9494 //
     /*  985357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  985374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985407 */     // MIs[1] Operand 1
     /*  985407 */     // No operand predicates
     /*  985407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985420 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985445 */     GIR_RootConstrainSelectedInstOperands,
     /*  985446 */     // GIR_Coverage, 9494,
     /*  985446 */     GIR_EraseRootFromParent_Done,
     /*  985447 */   // Label 14720: @985447
     /*  985447 */   GIM_Try, /*On fail goto*//*Label 14721*/ GIMT_Encode4(985542), // Rule ID 9495 //
     /*  985452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  985469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985502 */     // MIs[1] Operand 1
     /*  985502 */     // No operand predicates
     /*  985502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985515 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  985515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985540 */     GIR_RootConstrainSelectedInstOperands,
     /*  985541 */     // GIR_Coverage, 9495,
     /*  985541 */     GIR_EraseRootFromParent_Done,
     /*  985542 */   // Label 14721: @985542
     /*  985542 */   GIM_Try, /*On fail goto*//*Label 14722*/ GIMT_Encode4(985637), // Rule ID 9498 //
     /*  985547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  985564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985597 */     // MIs[1] Operand 1
     /*  985597 */     // No operand predicates
     /*  985597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985610 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  985610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985635 */     GIR_RootConstrainSelectedInstOperands,
     /*  985636 */     // GIR_Coverage, 9498,
     /*  985636 */     GIR_EraseRootFromParent_Done,
     /*  985637 */   // Label 14722: @985637
     /*  985637 */   GIM_Try, /*On fail goto*//*Label 14723*/ GIMT_Encode4(985732), // Rule ID 9499 //
     /*  985642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  985659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985692 */     // MIs[1] Operand 1
     /*  985692 */     // No operand predicates
     /*  985692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985705 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  985705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985730 */     GIR_RootConstrainSelectedInstOperands,
     /*  985731 */     // GIR_Coverage, 9499,
     /*  985731 */     GIR_EraseRootFromParent_Done,
     /*  985732 */   // Label 14723: @985732
     /*  985732 */   GIM_Try, /*On fail goto*//*Label 14724*/ GIMT_Encode4(985827), // Rule ID 9502 //
     /*  985737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  985748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  985751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  985754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  985760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985787 */     // MIs[1] Operand 1
     /*  985787 */     // No operand predicates
     /*  985787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985800 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  985800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985825 */     GIR_RootConstrainSelectedInstOperands,
     /*  985826 */     // GIR_Coverage, 9502,
     /*  985826 */     GIR_EraseRootFromParent_Done,
     /*  985827 */   // Label 14724: @985827
     /*  985827 */   GIM_Try, /*On fail goto*//*Label 14725*/ GIMT_Encode4(985922), // Rule ID 9503 //
     /*  985832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  985843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  985846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  985849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  985855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985882 */     // MIs[1] Operand 1
     /*  985882 */     // No operand predicates
     /*  985882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985895 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  985895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985920 */     GIR_RootConstrainSelectedInstOperands,
     /*  985921 */     // GIR_Coverage, 9503,
     /*  985921 */     GIR_EraseRootFromParent_Done,
     /*  985922 */   // Label 14725: @985922
     /*  985922 */   GIM_Try, /*On fail goto*//*Label 14726*/ GIMT_Encode4(986017), // Rule ID 9506 //
     /*  985927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  985944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985977 */     // MIs[1] Operand 1
     /*  985977 */     // No operand predicates
     /*  985977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985990 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986015 */     GIR_RootConstrainSelectedInstOperands,
     /*  986016 */     // GIR_Coverage, 9506,
     /*  986016 */     GIR_EraseRootFromParent_Done,
     /*  986017 */   // Label 14726: @986017
     /*  986017 */   GIM_Try, /*On fail goto*//*Label 14727*/ GIMT_Encode4(986112), // Rule ID 9507 //
     /*  986022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  986033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  986036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  986039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  986045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986072 */     // MIs[1] Operand 1
     /*  986072 */     // No operand predicates
     /*  986072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986085 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  986085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986110 */     GIR_RootConstrainSelectedInstOperands,
     /*  986111 */     // GIR_Coverage, 9507,
     /*  986111 */     GIR_EraseRootFromParent_Done,
     /*  986112 */   // Label 14727: @986112
     /*  986112 */   GIM_Try, /*On fail goto*//*Label 14728*/ GIMT_Encode4(986207), // Rule ID 9510 //
     /*  986117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  986128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  986131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  986134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  986140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986167 */     // MIs[1] Operand 1
     /*  986167 */     // No operand predicates
     /*  986167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986180 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  986180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986205 */     GIR_RootConstrainSelectedInstOperands,
     /*  986206 */     // GIR_Coverage, 9510,
     /*  986206 */     GIR_EraseRootFromParent_Done,
     /*  986207 */   // Label 14728: @986207
     /*  986207 */   GIM_Try, /*On fail goto*//*Label 14729*/ GIMT_Encode4(986302), // Rule ID 9511 //
     /*  986212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  986223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  986226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  986229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  986235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986262 */     // MIs[1] Operand 1
     /*  986262 */     // No operand predicates
     /*  986262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986275 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  986275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986300 */     GIR_RootConstrainSelectedInstOperands,
     /*  986301 */     // GIR_Coverage, 9511,
     /*  986301 */     GIR_EraseRootFromParent_Done,
     /*  986302 */   // Label 14729: @986302
     /*  986302 */   GIM_Try, /*On fail goto*//*Label 14730*/ GIMT_Encode4(986397), // Rule ID 9514 //
     /*  986307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  986310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  986324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986357 */     // MIs[1] Operand 1
     /*  986357 */     // No operand predicates
     /*  986357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986370 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  986370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986395 */     GIR_RootConstrainSelectedInstOperands,
     /*  986396 */     // GIR_Coverage, 9514,
     /*  986396 */     GIR_EraseRootFromParent_Done,
     /*  986397 */   // Label 14730: @986397
     /*  986397 */   GIM_Try, /*On fail goto*//*Label 14731*/ GIMT_Encode4(986492), // Rule ID 9515 //
     /*  986402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  986405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  986419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986452 */     // MIs[1] Operand 1
     /*  986452 */     // No operand predicates
     /*  986452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986465 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  986465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986490 */     GIR_RootConstrainSelectedInstOperands,
     /*  986491 */     // GIR_Coverage, 9515,
     /*  986491 */     GIR_EraseRootFromParent_Done,
     /*  986492 */   // Label 14731: @986492
     /*  986492 */   GIM_Try, /*On fail goto*//*Label 14732*/ GIMT_Encode4(986587), // Rule ID 9518 //
     /*  986497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  986514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986547 */     // MIs[1] Operand 1
     /*  986547 */     // No operand predicates
     /*  986547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986560 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  986563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986585 */     GIR_RootConstrainSelectedInstOperands,
     /*  986586 */     // GIR_Coverage, 9518,
     /*  986586 */     GIR_EraseRootFromParent_Done,
     /*  986587 */   // Label 14732: @986587
     /*  986587 */   GIM_Try, /*On fail goto*//*Label 14733*/ GIMT_Encode4(986682), // Rule ID 9519 //
     /*  986592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  986609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986642 */     // MIs[1] Operand 1
     /*  986642 */     // No operand predicates
     /*  986642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986655 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  986658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986680 */     GIR_RootConstrainSelectedInstOperands,
     /*  986681 */     // GIR_Coverage, 9519,
     /*  986681 */     GIR_EraseRootFromParent_Done,
     /*  986682 */   // Label 14733: @986682
     /*  986682 */   GIM_Try, /*On fail goto*//*Label 14734*/ GIMT_Encode4(986777), // Rule ID 9522 //
     /*  986687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  986698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  986701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  986704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  986710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986737 */     // MIs[1] Operand 1
     /*  986737 */     // No operand predicates
     /*  986737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986750 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  986753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986775 */     GIR_RootConstrainSelectedInstOperands,
     /*  986776 */     // GIR_Coverage, 9522,
     /*  986776 */     GIR_EraseRootFromParent_Done,
     /*  986777 */   // Label 14734: @986777
     /*  986777 */   GIM_Try, /*On fail goto*//*Label 14735*/ GIMT_Encode4(986872), // Rule ID 9523 //
     /*  986782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  986793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  986796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  986799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  986805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986832 */     // MIs[1] Operand 1
     /*  986832 */     // No operand predicates
     /*  986832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986845 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  986848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986870 */     GIR_RootConstrainSelectedInstOperands,
     /*  986871 */     // GIR_Coverage, 9523,
     /*  986871 */     GIR_EraseRootFromParent_Done,
     /*  986872 */   // Label 14735: @986872
     /*  986872 */   GIM_Try, /*On fail goto*//*Label 14736*/ GIMT_Encode4(986967), // Rule ID 9526 //
     /*  986877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  986888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  986891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  986894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  986900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986927 */     // MIs[1] Operand 1
     /*  986927 */     // No operand predicates
     /*  986927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986940 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  986943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986965 */     GIR_RootConstrainSelectedInstOperands,
     /*  986966 */     // GIR_Coverage, 9526,
     /*  986966 */     GIR_EraseRootFromParent_Done,
     /*  986967 */   // Label 14736: @986967
     /*  986967 */   GIM_Try, /*On fail goto*//*Label 14737*/ GIMT_Encode4(987062), // Rule ID 9527 //
     /*  986972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  986983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  986986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  986989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  986995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987022 */     // MIs[1] Operand 1
     /*  987022 */     // No operand predicates
     /*  987022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987035 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  987035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987060 */     GIR_RootConstrainSelectedInstOperands,
     /*  987061 */     // GIR_Coverage, 9527,
     /*  987061 */     GIR_EraseRootFromParent_Done,
     /*  987062 */   // Label 14737: @987062
     /*  987062 */   GIM_Try, /*On fail goto*//*Label 14738*/ GIMT_Encode4(987157), // Rule ID 9530 //
     /*  987067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  987084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987117 */     // MIs[1] Operand 1
     /*  987117 */     // No operand predicates
     /*  987117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987130 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987155 */     GIR_RootConstrainSelectedInstOperands,
     /*  987156 */     // GIR_Coverage, 9530,
     /*  987156 */     GIR_EraseRootFromParent_Done,
     /*  987157 */   // Label 14738: @987157
     /*  987157 */   GIM_Try, /*On fail goto*//*Label 14739*/ GIMT_Encode4(987252), // Rule ID 9531 //
     /*  987162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  987179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987212 */     // MIs[1] Operand 1
     /*  987212 */     // No operand predicates
     /*  987212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987225 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987250 */     GIR_RootConstrainSelectedInstOperands,
     /*  987251 */     // GIR_Coverage, 9531,
     /*  987251 */     GIR_EraseRootFromParent_Done,
     /*  987252 */   // Label 14739: @987252
     /*  987252 */   GIM_Try, /*On fail goto*//*Label 14740*/ GIMT_Encode4(987347), // Rule ID 9534 //
     /*  987257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  987274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987307 */     // MIs[1] Operand 1
     /*  987307 */     // No operand predicates
     /*  987307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987320 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987345 */     GIR_RootConstrainSelectedInstOperands,
     /*  987346 */     // GIR_Coverage, 9534,
     /*  987346 */     GIR_EraseRootFromParent_Done,
     /*  987347 */   // Label 14740: @987347
     /*  987347 */   GIM_Try, /*On fail goto*//*Label 14741*/ GIMT_Encode4(987442), // Rule ID 9535 //
     /*  987352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  987369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987402 */     // MIs[1] Operand 1
     /*  987402 */     // No operand predicates
     /*  987402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987415 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987440 */     GIR_RootConstrainSelectedInstOperands,
     /*  987441 */     // GIR_Coverage, 9535,
     /*  987441 */     GIR_EraseRootFromParent_Done,
     /*  987442 */   // Label 14741: @987442
     /*  987442 */   GIM_Try, /*On fail goto*//*Label 14742*/ GIMT_Encode4(987537), // Rule ID 9538 //
     /*  987447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  987464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987497 */     // MIs[1] Operand 1
     /*  987497 */     // No operand predicates
     /*  987497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987510 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987535 */     GIR_RootConstrainSelectedInstOperands,
     /*  987536 */     // GIR_Coverage, 9538,
     /*  987536 */     GIR_EraseRootFromParent_Done,
     /*  987537 */   // Label 14742: @987537
     /*  987537 */   GIM_Try, /*On fail goto*//*Label 14743*/ GIMT_Encode4(987632), // Rule ID 9539 //
     /*  987542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  987559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987592 */     // MIs[1] Operand 1
     /*  987592 */     // No operand predicates
     /*  987592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987605 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987630 */     GIR_RootConstrainSelectedInstOperands,
     /*  987631 */     // GIR_Coverage, 9539,
     /*  987631 */     GIR_EraseRootFromParent_Done,
     /*  987632 */   // Label 14743: @987632
     /*  987632 */   GIM_Try, /*On fail goto*//*Label 14744*/ GIMT_Encode4(987727), // Rule ID 9542 //
     /*  987637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  987648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  987651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  987654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  987660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987687 */     // MIs[1] Operand 1
     /*  987687 */     // No operand predicates
     /*  987687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987700 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  987700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987725 */     GIR_RootConstrainSelectedInstOperands,
     /*  987726 */     // GIR_Coverage, 9542,
     /*  987726 */     GIR_EraseRootFromParent_Done,
     /*  987727 */   // Label 14744: @987727
     /*  987727 */   GIM_Try, /*On fail goto*//*Label 14745*/ GIMT_Encode4(987822), // Rule ID 9543 //
     /*  987732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  987743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  987746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  987749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  987755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987782 */     // MIs[1] Operand 1
     /*  987782 */     // No operand predicates
     /*  987782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987795 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  987795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987820 */     GIR_RootConstrainSelectedInstOperands,
     /*  987821 */     // GIR_Coverage, 9543,
     /*  987821 */     GIR_EraseRootFromParent_Done,
     /*  987822 */   // Label 14745: @987822
     /*  987822 */   GIM_Try, /*On fail goto*//*Label 14746*/ GIMT_Encode4(987917), // Rule ID 9546 //
     /*  987827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  987844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987877 */     // MIs[1] Operand 1
     /*  987877 */     // No operand predicates
     /*  987877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987890 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  987890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987915 */     GIR_RootConstrainSelectedInstOperands,
     /*  987916 */     // GIR_Coverage, 9546,
     /*  987916 */     GIR_EraseRootFromParent_Done,
     /*  987917 */   // Label 14746: @987917
     /*  987917 */   GIM_Try, /*On fail goto*//*Label 14747*/ GIMT_Encode4(988012), // Rule ID 9547 //
     /*  987922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  987939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987972 */     // MIs[1] Operand 1
     /*  987972 */     // No operand predicates
     /*  987972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987985 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  987985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988010 */     GIR_RootConstrainSelectedInstOperands,
     /*  988011 */     // GIR_Coverage, 9547,
     /*  988011 */     GIR_EraseRootFromParent_Done,
     /*  988012 */   // Label 14747: @988012
     /*  988012 */   GIM_Try, /*On fail goto*//*Label 14748*/ GIMT_Encode4(988107), // Rule ID 9550 //
     /*  988017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  988028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  988031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  988034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  988040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988067 */     // MIs[1] Operand 1
     /*  988067 */     // No operand predicates
     /*  988067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988080 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  988080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988105 */     GIR_RootConstrainSelectedInstOperands,
     /*  988106 */     // GIR_Coverage, 9550,
     /*  988106 */     GIR_EraseRootFromParent_Done,
     /*  988107 */   // Label 14748: @988107
     /*  988107 */   GIM_Try, /*On fail goto*//*Label 14749*/ GIMT_Encode4(988202), // Rule ID 9551 //
     /*  988112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  988123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  988126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  988129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  988135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988162 */     // MIs[1] Operand 1
     /*  988162 */     // No operand predicates
     /*  988162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988175 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  988175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988200 */     GIR_RootConstrainSelectedInstOperands,
     /*  988201 */     // GIR_Coverage, 9551,
     /*  988201 */     GIR_EraseRootFromParent_Done,
     /*  988202 */   // Label 14749: @988202
     /*  988202 */   GIM_Try, /*On fail goto*//*Label 14750*/ GIMT_Encode4(988297), // Rule ID 9554 //
     /*  988207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  988218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  988221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  988224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988257 */     // MIs[1] Operand 1
     /*  988257 */     // No operand predicates
     /*  988257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988270 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  988273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988295 */     GIR_RootConstrainSelectedInstOperands,
     /*  988296 */     // GIR_Coverage, 9554,
     /*  988296 */     GIR_EraseRootFromParent_Done,
     /*  988297 */   // Label 14750: @988297
     /*  988297 */   GIM_Try, /*On fail goto*//*Label 14751*/ GIMT_Encode4(988392), // Rule ID 9555 //
     /*  988302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  988313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  988316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  988319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988352 */     // MIs[1] Operand 1
     /*  988352 */     // No operand predicates
     /*  988352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988365 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  988368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988390 */     GIR_RootConstrainSelectedInstOperands,
     /*  988391 */     // GIR_Coverage, 9555,
     /*  988391 */     GIR_EraseRootFromParent_Done,
     /*  988392 */   // Label 14751: @988392
     /*  988392 */   GIM_Try, /*On fail goto*//*Label 14752*/ GIMT_Encode4(988487), // Rule ID 9558 //
     /*  988397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  988414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988447 */     // MIs[1] Operand 1
     /*  988447 */     // No operand predicates
     /*  988447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988460 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  988463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988485 */     GIR_RootConstrainSelectedInstOperands,
     /*  988486 */     // GIR_Coverage, 9558,
     /*  988486 */     GIR_EraseRootFromParent_Done,
     /*  988487 */   // Label 14752: @988487
     /*  988487 */   GIM_Try, /*On fail goto*//*Label 14753*/ GIMT_Encode4(988582), // Rule ID 9559 //
     /*  988492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  988509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988542 */     // MIs[1] Operand 1
     /*  988542 */     // No operand predicates
     /*  988542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988555 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  988558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988580 */     GIR_RootConstrainSelectedInstOperands,
     /*  988581 */     // GIR_Coverage, 9559,
     /*  988581 */     GIR_EraseRootFromParent_Done,
     /*  988582 */   // Label 14753: @988582
     /*  988582 */   GIM_Try, /*On fail goto*//*Label 14754*/ GIMT_Encode4(988677), // Rule ID 9562 //
     /*  988587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  988604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988637 */     // MIs[1] Operand 1
     /*  988637 */     // No operand predicates
     /*  988637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988650 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988675 */     GIR_RootConstrainSelectedInstOperands,
     /*  988676 */     // GIR_Coverage, 9562,
     /*  988676 */     GIR_EraseRootFromParent_Done,
     /*  988677 */   // Label 14754: @988677
     /*  988677 */   GIM_Try, /*On fail goto*//*Label 14755*/ GIMT_Encode4(988772), // Rule ID 9563 //
     /*  988682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  988699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988732 */     // MIs[1] Operand 1
     /*  988732 */     // No operand predicates
     /*  988732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988745 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988770 */     GIR_RootConstrainSelectedInstOperands,
     /*  988771 */     // GIR_Coverage, 9563,
     /*  988771 */     GIR_EraseRootFromParent_Done,
     /*  988772 */   // Label 14755: @988772
     /*  988772 */   GIM_Try, /*On fail goto*//*Label 14756*/ GIMT_Encode4(988864), // Rule ID 13940 //
     /*  988777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  988788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  988791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  988794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  988800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988827 */     // MIs[1] Operand 1
     /*  988827 */     // No operand predicates
     /*  988827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988840 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  988840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  988843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988862 */     GIR_RootConstrainSelectedInstOperands,
     /*  988863 */     // GIR_Coverage, 13940,
     /*  988863 */     GIR_EraseRootFromParent_Done,
     /*  988864 */   // Label 14756: @988864
     /*  988864 */   GIM_Try, /*On fail goto*//*Label 14757*/ GIMT_Encode4(988956), // Rule ID 13941 //
     /*  988869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  988880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  988883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  988886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  988892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988919 */     // MIs[1] Operand 1
     /*  988919 */     // No operand predicates
     /*  988919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988932 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  988932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  988935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988954 */     GIR_RootConstrainSelectedInstOperands,
     /*  988955 */     // GIR_Coverage, 13941,
     /*  988955 */     GIR_EraseRootFromParent_Done,
     /*  988956 */   // Label 14757: @988956
     /*  988956 */   GIM_Try, /*On fail goto*//*Label 14758*/ GIMT_Encode4(989048), // Rule ID 13942 //
     /*  988961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  988972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  988975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  988978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989011 */     // MIs[1] Operand 1
     /*  989011 */     // No operand predicates
     /*  989011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989024 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  989024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989046 */     GIR_RootConstrainSelectedInstOperands,
     /*  989047 */     // GIR_Coverage, 13942,
     /*  989047 */     GIR_EraseRootFromParent_Done,
     /*  989048 */   // Label 14758: @989048
     /*  989048 */   GIM_Try, /*On fail goto*//*Label 14759*/ GIMT_Encode4(989140), // Rule ID 13943 //
     /*  989053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  989064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  989067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  989070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989103 */     // MIs[1] Operand 1
     /*  989103 */     // No operand predicates
     /*  989103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989116 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  989116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989138 */     GIR_RootConstrainSelectedInstOperands,
     /*  989139 */     // GIR_Coverage, 13943,
     /*  989139 */     GIR_EraseRootFromParent_Done,
     /*  989140 */   // Label 14759: @989140
     /*  989140 */   GIM_Try, /*On fail goto*//*Label 14760*/ GIMT_Encode4(989232), // Rule ID 13944 //
     /*  989145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  989156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  989159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  989162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989195 */     // MIs[1] Operand 1
     /*  989195 */     // No operand predicates
     /*  989195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  989208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989230 */     GIR_RootConstrainSelectedInstOperands,
     /*  989231 */     // GIR_Coverage, 13944,
     /*  989231 */     GIR_EraseRootFromParent_Done,
     /*  989232 */   // Label 14760: @989232
     /*  989232 */   GIM_Try, /*On fail goto*//*Label 14761*/ GIMT_Encode4(989324), // Rule ID 13945 //
     /*  989237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  989248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  989251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  989254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989287 */     // MIs[1] Operand 1
     /*  989287 */     // No operand predicates
     /*  989287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989300 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  989300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989322 */     GIR_RootConstrainSelectedInstOperands,
     /*  989323 */     // GIR_Coverage, 13945,
     /*  989323 */     GIR_EraseRootFromParent_Done,
     /*  989324 */   // Label 14761: @989324
     /*  989324 */   GIM_Try, /*On fail goto*//*Label 14762*/ GIMT_Encode4(989416), // Rule ID 13946 //
     /*  989329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  989340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  989343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989379 */     // MIs[1] Operand 1
     /*  989379 */     // No operand predicates
     /*  989379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989392 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  989392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989414 */     GIR_RootConstrainSelectedInstOperands,
     /*  989415 */     // GIR_Coverage, 13946,
     /*  989415 */     GIR_EraseRootFromParent_Done,
     /*  989416 */   // Label 14762: @989416
     /*  989416 */   GIM_Try, /*On fail goto*//*Label 14763*/ GIMT_Encode4(989508), // Rule ID 13947 //
     /*  989421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  989432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  989435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989471 */     // MIs[1] Operand 1
     /*  989471 */     // No operand predicates
     /*  989471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  989484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989506 */     GIR_RootConstrainSelectedInstOperands,
     /*  989507 */     // GIR_Coverage, 13947,
     /*  989507 */     GIR_EraseRootFromParent_Done,
     /*  989508 */   // Label 14763: @989508
     /*  989508 */   GIM_Try, /*On fail goto*//*Label 14764*/ GIMT_Encode4(989600), // Rule ID 13948 //
     /*  989513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  989524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  989527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989563 */     // MIs[1] Operand 1
     /*  989563 */     // No operand predicates
     /*  989563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989576 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  989576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989598 */     GIR_RootConstrainSelectedInstOperands,
     /*  989599 */     // GIR_Coverage, 13948,
     /*  989599 */     GIR_EraseRootFromParent_Done,
     /*  989600 */   // Label 14764: @989600
     /*  989600 */   GIM_Try, /*On fail goto*//*Label 14765*/ GIMT_Encode4(989692), // Rule ID 13949 //
     /*  989605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  989616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  989619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989655 */     // MIs[1] Operand 1
     /*  989655 */     // No operand predicates
     /*  989655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989668 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  989668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989690 */     GIR_RootConstrainSelectedInstOperands,
     /*  989691 */     // GIR_Coverage, 13949,
     /*  989691 */     GIR_EraseRootFromParent_Done,
     /*  989692 */   // Label 14765: @989692
     /*  989692 */   GIM_Try, /*On fail goto*//*Label 14766*/ GIMT_Encode4(989784), // Rule ID 13950 //
     /*  989697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  989708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  989711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  989714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989747 */     // MIs[1] Operand 1
     /*  989747 */     // No operand predicates
     /*  989747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989760 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  989760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989782 */     GIR_RootConstrainSelectedInstOperands,
     /*  989783 */     // GIR_Coverage, 13950,
     /*  989783 */     GIR_EraseRootFromParent_Done,
     /*  989784 */   // Label 14766: @989784
     /*  989784 */   GIM_Try, /*On fail goto*//*Label 14767*/ GIMT_Encode4(989876), // Rule ID 13951 //
     /*  989789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  989800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  989803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  989806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989839 */     // MIs[1] Operand 1
     /*  989839 */     // No operand predicates
     /*  989839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989852 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  989852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989874 */     GIR_RootConstrainSelectedInstOperands,
     /*  989875 */     // GIR_Coverage, 13951,
     /*  989875 */     GIR_EraseRootFromParent_Done,
     /*  989876 */   // Label 14767: @989876
     /*  989876 */   GIM_Try, /*On fail goto*//*Label 14768*/ GIMT_Encode4(989968), // Rule ID 13952 //
     /*  989881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  989892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  989895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  989898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989931 */     // MIs[1] Operand 1
     /*  989931 */     // No operand predicates
     /*  989931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989944 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  989944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  989947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989966 */     GIR_RootConstrainSelectedInstOperands,
     /*  989967 */     // GIR_Coverage, 13952,
     /*  989967 */     GIR_EraseRootFromParent_Done,
     /*  989968 */   // Label 14768: @989968
     /*  989968 */   GIM_Try, /*On fail goto*//*Label 14769*/ GIMT_Encode4(990060), // Rule ID 13953 //
     /*  989973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  989984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  989987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  989990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990023 */     // MIs[1] Operand 1
     /*  990023 */     // No operand predicates
     /*  990023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990036 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  990036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990058 */     GIR_RootConstrainSelectedInstOperands,
     /*  990059 */     // GIR_Coverage, 13953,
     /*  990059 */     GIR_EraseRootFromParent_Done,
     /*  990060 */   // Label 14769: @990060
     /*  990060 */   GIM_Try, /*On fail goto*//*Label 14770*/ GIMT_Encode4(990152), // Rule ID 13954 //
     /*  990065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  990076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  990079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  990082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  990088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990115 */     // MIs[1] Operand 1
     /*  990115 */     // No operand predicates
     /*  990115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990128 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  990128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990150 */     GIR_RootConstrainSelectedInstOperands,
     /*  990151 */     // GIR_Coverage, 13954,
     /*  990151 */     GIR_EraseRootFromParent_Done,
     /*  990152 */   // Label 14770: @990152
     /*  990152 */   GIM_Try, /*On fail goto*//*Label 14771*/ GIMT_Encode4(990244), // Rule ID 13955 //
     /*  990157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  990168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  990171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  990174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  990180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990207 */     // MIs[1] Operand 1
     /*  990207 */     // No operand predicates
     /*  990207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990220 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  990220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990242 */     GIR_RootConstrainSelectedInstOperands,
     /*  990243 */     // GIR_Coverage, 13955,
     /*  990243 */     GIR_EraseRootFromParent_Done,
     /*  990244 */   // Label 14771: @990244
     /*  990244 */   GIM_Try, /*On fail goto*//*Label 14772*/ GIMT_Encode4(990336), // Rule ID 13956 //
     /*  990249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  990260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  990263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  990266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  990272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990299 */     // MIs[1] Operand 1
     /*  990299 */     // No operand predicates
     /*  990299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990312 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  990312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990334 */     GIR_RootConstrainSelectedInstOperands,
     /*  990335 */     // GIR_Coverage, 13956,
     /*  990335 */     GIR_EraseRootFromParent_Done,
     /*  990336 */   // Label 14772: @990336
     /*  990336 */   GIM_Try, /*On fail goto*//*Label 14773*/ GIMT_Encode4(990428), // Rule ID 13957 //
     /*  990341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  990352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  990355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  990358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  990364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990391 */     // MIs[1] Operand 1
     /*  990391 */     // No operand predicates
     /*  990391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990404 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  990404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990426 */     GIR_RootConstrainSelectedInstOperands,
     /*  990427 */     // GIR_Coverage, 13957,
     /*  990427 */     GIR_EraseRootFromParent_Done,
     /*  990428 */   // Label 14773: @990428
     /*  990428 */   GIM_Try, /*On fail goto*//*Label 14774*/ GIMT_Encode4(990520), // Rule ID 13958 //
     /*  990433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  990436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  990444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  990447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990483 */     // MIs[1] Operand 1
     /*  990483 */     // No operand predicates
     /*  990483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990496 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  990496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  990518 */     GIR_RootConstrainSelectedInstOperands,
     /*  990519 */     // GIR_Coverage, 13958,
     /*  990519 */     GIR_EraseRootFromParent_Done,
     /*  990520 */   // Label 14774: @990520
     /*  990520 */   GIM_Try, /*On fail goto*//*Label 14775*/ GIMT_Encode4(990612), // Rule ID 13959 //
     /*  990525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  990528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  990536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  990539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990575 */     // MIs[1] Operand 1
     /*  990575 */     // No operand predicates
     /*  990575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990588 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  990588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  990610 */     GIR_RootConstrainSelectedInstOperands,
     /*  990611 */     // GIR_Coverage, 13959,
     /*  990611 */     GIR_EraseRootFromParent_Done,
     /*  990612 */   // Label 14775: @990612
     /*  990612 */   GIM_Try, /*On fail goto*//*Label 14776*/ GIMT_Encode4(990704), // Rule ID 13960 //
     /*  990617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  990628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  990631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  990634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  990640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  990647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990667 */     // MIs[1] Operand 1
     /*  990667 */     // No operand predicates
     /*  990667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990680 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  990680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  990683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990702 */     GIR_RootConstrainSelectedInstOperands,
     /*  990703 */     // GIR_Coverage, 13960,
     /*  990703 */     GIR_EraseRootFromParent_Done,
     /*  990704 */   // Label 14776: @990704
     /*  990704 */   GIM_Try, /*On fail goto*//*Label 14777*/ GIMT_Encode4(990796), // Rule ID 13961 //
     /*  990709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  990720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  990723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  990726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  990732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  990739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990759 */     // MIs[1] Operand 1
     /*  990759 */     // No operand predicates
     /*  990759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990772 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  990772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  990775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990794 */     GIR_RootConstrainSelectedInstOperands,
     /*  990795 */     // GIR_Coverage, 13961,
     /*  990795 */     GIR_EraseRootFromParent_Done,
     /*  990796 */   // Label 14777: @990796
     /*  990796 */   GIM_Try, /*On fail goto*//*Label 14778*/ GIMT_Encode4(990888), // Rule ID 13962 //
     /*  990801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  990812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  990815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  990818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  990824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  990831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990851 */     // MIs[1] Operand 1
     /*  990851 */     // No operand predicates
     /*  990851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990864 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  990864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  990867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990886 */     GIR_RootConstrainSelectedInstOperands,
     /*  990887 */     // GIR_Coverage, 13962,
     /*  990887 */     GIR_EraseRootFromParent_Done,
     /*  990888 */   // Label 14778: @990888
     /*  990888 */   GIM_Try, /*On fail goto*//*Label 14779*/ GIMT_Encode4(990980), // Rule ID 13963 //
     /*  990893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  990904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  990907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  990910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  990916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  990923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990943 */     // MIs[1] Operand 1
     /*  990943 */     // No operand predicates
     /*  990943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990956 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  990956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  990959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990978 */     GIR_RootConstrainSelectedInstOperands,
     /*  990979 */     // GIR_Coverage, 13963,
     /*  990979 */     GIR_EraseRootFromParent_Done,
     /*  990980 */   // Label 14779: @990980
     /*  990980 */   GIM_Try, /*On fail goto*//*Label 14780*/ GIMT_Encode4(991072), // Rule ID 13964 //
     /*  990985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  990996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  990999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  991002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  991008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991035 */     // MIs[1] Operand 1
     /*  991035 */     // No operand predicates
     /*  991035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991048 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  991048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991070 */     GIR_RootConstrainSelectedInstOperands,
     /*  991071 */     // GIR_Coverage, 13964,
     /*  991071 */     GIR_EraseRootFromParent_Done,
     /*  991072 */   // Label 14780: @991072
     /*  991072 */   GIM_Try, /*On fail goto*//*Label 14781*/ GIMT_Encode4(991164), // Rule ID 13965 //
     /*  991077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  991088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  991091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  991094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  991100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991127 */     // MIs[1] Operand 1
     /*  991127 */     // No operand predicates
     /*  991127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991140 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  991140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991162 */     GIR_RootConstrainSelectedInstOperands,
     /*  991163 */     // GIR_Coverage, 13965,
     /*  991163 */     GIR_EraseRootFromParent_Done,
     /*  991164 */   // Label 14781: @991164
     /*  991164 */   GIM_Try, /*On fail goto*//*Label 14782*/ GIMT_Encode4(991256), // Rule ID 13966 //
     /*  991169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  991180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  991183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  991186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991219 */     // MIs[1] Operand 1
     /*  991219 */     // No operand predicates
     /*  991219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991232 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  991232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991254 */     GIR_RootConstrainSelectedInstOperands,
     /*  991255 */     // GIR_Coverage, 13966,
     /*  991255 */     GIR_EraseRootFromParent_Done,
     /*  991256 */   // Label 14782: @991256
     /*  991256 */   GIM_Try, /*On fail goto*//*Label 14783*/ GIMT_Encode4(991348), // Rule ID 13967 //
     /*  991261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  991272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  991275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  991278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991311 */     // MIs[1] Operand 1
     /*  991311 */     // No operand predicates
     /*  991311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  991324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991346 */     GIR_RootConstrainSelectedInstOperands,
     /*  991347 */     // GIR_Coverage, 13967,
     /*  991347 */     GIR_EraseRootFromParent_Done,
     /*  991348 */   // Label 14783: @991348
     /*  991348 */   GIM_Try, /*On fail goto*//*Label 14784*/ GIMT_Encode4(991440), // Rule ID 13968 //
     /*  991353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  991364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  991367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  991370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991403 */     // MIs[1] Operand 1
     /*  991403 */     // No operand predicates
     /*  991403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991416 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  991416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991438 */     GIR_RootConstrainSelectedInstOperands,
     /*  991439 */     // GIR_Coverage, 13968,
     /*  991439 */     GIR_EraseRootFromParent_Done,
     /*  991440 */   // Label 14784: @991440
     /*  991440 */   GIM_Try, /*On fail goto*//*Label 14785*/ GIMT_Encode4(991532), // Rule ID 13969 //
     /*  991445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  991456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  991459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  991462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991495 */     // MIs[1] Operand 1
     /*  991495 */     // No operand predicates
     /*  991495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991508 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  991508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991530 */     GIR_RootConstrainSelectedInstOperands,
     /*  991531 */     // GIR_Coverage, 13969,
     /*  991531 */     GIR_EraseRootFromParent_Done,
     /*  991532 */   // Label 14785: @991532
     /*  991532 */   GIM_Try, /*On fail goto*//*Label 14786*/ GIMT_Encode4(991624), // Rule ID 13970 //
     /*  991537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  991548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  991551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  991554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991587 */     // MIs[1] Operand 1
     /*  991587 */     // No operand predicates
     /*  991587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991600 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  991600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991622 */     GIR_RootConstrainSelectedInstOperands,
     /*  991623 */     // GIR_Coverage, 13970,
     /*  991623 */     GIR_EraseRootFromParent_Done,
     /*  991624 */   // Label 14786: @991624
     /*  991624 */   GIM_Try, /*On fail goto*//*Label 14787*/ GIMT_Encode4(991716), // Rule ID 13971 //
     /*  991629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  991640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  991643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  991646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991679 */     // MIs[1] Operand 1
     /*  991679 */     // No operand predicates
     /*  991679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991692 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  991692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991714 */     GIR_RootConstrainSelectedInstOperands,
     /*  991715 */     // GIR_Coverage, 13971,
     /*  991715 */     GIR_EraseRootFromParent_Done,
     /*  991716 */   // Label 14787: @991716
     /*  991716 */   GIM_Try, /*On fail goto*//*Label 14788*/ GIMT_Encode4(991808), // Rule ID 13972 //
     /*  991721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  991732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  991735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  991738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  991744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991771 */     // MIs[1] Operand 1
     /*  991771 */     // No operand predicates
     /*  991771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  991784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991806 */     GIR_RootConstrainSelectedInstOperands,
     /*  991807 */     // GIR_Coverage, 13972,
     /*  991807 */     GIR_EraseRootFromParent_Done,
     /*  991808 */   // Label 14788: @991808
     /*  991808 */   GIM_Try, /*On fail goto*//*Label 14789*/ GIMT_Encode4(991900), // Rule ID 13973 //
     /*  991813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  991824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  991827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  991830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  991836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991863 */     // MIs[1] Operand 1
     /*  991863 */     // No operand predicates
     /*  991863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  991876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991898 */     GIR_RootConstrainSelectedInstOperands,
     /*  991899 */     // GIR_Coverage, 13973,
     /*  991899 */     GIR_EraseRootFromParent_Done,
     /*  991900 */   // Label 14789: @991900
     /*  991900 */   GIM_Try, /*On fail goto*//*Label 14790*/ GIMT_Encode4(991992), // Rule ID 13974 //
     /*  991905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  991916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  991919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  991922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991955 */     // MIs[1] Operand 1
     /*  991955 */     // No operand predicates
     /*  991955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  991968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991990 */     GIR_RootConstrainSelectedInstOperands,
     /*  991991 */     // GIR_Coverage, 13974,
     /*  991991 */     GIR_EraseRootFromParent_Done,
     /*  991992 */   // Label 14790: @991992
     /*  991992 */   GIM_Try, /*On fail goto*//*Label 14791*/ GIMT_Encode4(992084), // Rule ID 13975 //
     /*  991997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  992008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  992011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  992014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  992027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992047 */     // MIs[1] Operand 1
     /*  992047 */     // No operand predicates
     /*  992047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992060 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  992060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992082 */     GIR_RootConstrainSelectedInstOperands,
     /*  992083 */     // GIR_Coverage, 13975,
     /*  992083 */     GIR_EraseRootFromParent_Done,
     /*  992084 */   // Label 14791: @992084
     /*  992084 */   GIM_Try, /*On fail goto*//*Label 14792*/ GIMT_Encode4(992176), // Rule ID 13976 //
     /*  992089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  992100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  992103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  992106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  992112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992139 */     // MIs[1] Operand 1
     /*  992139 */     // No operand predicates
     /*  992139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992152 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  992152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992174 */     GIR_RootConstrainSelectedInstOperands,
     /*  992175 */     // GIR_Coverage, 13976,
     /*  992175 */     GIR_EraseRootFromParent_Done,
     /*  992176 */   // Label 14792: @992176
     /*  992176 */   GIM_Try, /*On fail goto*//*Label 14793*/ GIMT_Encode4(992268), // Rule ID 13977 //
     /*  992181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  992192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  992195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  992198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  992204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992231 */     // MIs[1] Operand 1
     /*  992231 */     // No operand predicates
     /*  992231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992244 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  992244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992266 */     GIR_RootConstrainSelectedInstOperands,
     /*  992267 */     // GIR_Coverage, 13977,
     /*  992267 */     GIR_EraseRootFromParent_Done,
     /*  992268 */   // Label 14793: @992268
     /*  992268 */   GIM_Try, /*On fail goto*//*Label 14794*/ GIMT_Encode4(992360), // Rule ID 13978 //
     /*  992273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  992284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  992287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  992290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  992303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992323 */     // MIs[1] Operand 1
     /*  992323 */     // No operand predicates
     /*  992323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992336 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  992336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  992339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992358 */     GIR_RootConstrainSelectedInstOperands,
     /*  992359 */     // GIR_Coverage, 13978,
     /*  992359 */     GIR_EraseRootFromParent_Done,
     /*  992360 */   // Label 14794: @992360
     /*  992360 */   GIM_Try, /*On fail goto*//*Label 14795*/ GIMT_Encode4(992452), // Rule ID 13979 //
     /*  992365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  992376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  992379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  992382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  992395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992415 */     // MIs[1] Operand 1
     /*  992415 */     // No operand predicates
     /*  992415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992428 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  992428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  992431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992450 */     GIR_RootConstrainSelectedInstOperands,
     /*  992451 */     // GIR_Coverage, 13979,
     /*  992451 */     GIR_EraseRootFromParent_Done,
     /*  992452 */   // Label 14795: @992452
     /*  992452 */   GIM_Try, /*On fail goto*//*Label 14796*/ GIMT_Encode4(992544), // Rule ID 13980 //
     /*  992457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  992468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  992471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  992474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  992487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992507 */     // MIs[1] Operand 1
     /*  992507 */     // No operand predicates
     /*  992507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992520 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  992520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992542 */     GIR_RootConstrainSelectedInstOperands,
     /*  992543 */     // GIR_Coverage, 13980,
     /*  992543 */     GIR_EraseRootFromParent_Done,
     /*  992544 */   // Label 14796: @992544
     /*  992544 */   GIM_Try, /*On fail goto*//*Label 14797*/ GIMT_Encode4(992636), // Rule ID 13981 //
     /*  992549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  992560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  992563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  992566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  992579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992599 */     // MIs[1] Operand 1
     /*  992599 */     // No operand predicates
     /*  992599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992612 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  992612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992634 */     GIR_RootConstrainSelectedInstOperands,
     /*  992635 */     // GIR_Coverage, 13981,
     /*  992635 */     GIR_EraseRootFromParent_Done,
     /*  992636 */   // Label 14797: @992636
     /*  992636 */   GIM_Try, /*On fail goto*//*Label 14798*/ GIMT_Encode4(992728), // Rule ID 13982 //
     /*  992641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  992652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  992655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  992658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992691 */     // MIs[1] Operand 1
     /*  992691 */     // No operand predicates
     /*  992691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992704 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  992704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992726 */     GIR_RootConstrainSelectedInstOperands,
     /*  992727 */     // GIR_Coverage, 13982,
     /*  992727 */     GIR_EraseRootFromParent_Done,
     /*  992728 */   // Label 14798: @992728
     /*  992728 */   GIM_Try, /*On fail goto*//*Label 14799*/ GIMT_Encode4(992820), // Rule ID 13983 //
     /*  992733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  992744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  992747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  992750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992783 */     // MIs[1] Operand 1
     /*  992783 */     // No operand predicates
     /*  992783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992796 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  992796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992818 */     GIR_RootConstrainSelectedInstOperands,
     /*  992819 */     // GIR_Coverage, 13983,
     /*  992819 */     GIR_EraseRootFromParent_Done,
     /*  992820 */   // Label 14799: @992820
     /*  992820 */   GIM_Try, /*On fail goto*//*Label 14800*/ GIMT_Encode4(992896), // Rule ID 2770 //
     /*  992825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  992828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  992836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  992839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  992842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992853 */     // MIs[0] passthru
     /*  992853 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992862 */     // MIs[0] round
     /*  992862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  992865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992872 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  992872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  992875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  992881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  992883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  992894 */     GIR_RootConstrainSelectedInstOperands,
     /*  992895 */     // GIR_Coverage, 2770,
     /*  992895 */     GIR_EraseRootFromParent_Done,
     /*  992896 */   // Label 14800: @992896
     /*  992896 */   GIM_Try, /*On fail goto*//*Label 14801*/ GIMT_Encode4(992972), // Rule ID 2771 //
     /*  992901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  992904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  992912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  992915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  992918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992929 */     // MIs[0] passthru
     /*  992929 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992938 */     // MIs[0] round
     /*  992938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  992941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992948 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  992948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  992951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  992957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  992959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  992970 */     GIR_RootConstrainSelectedInstOperands,
     /*  992971 */     // GIR_Coverage, 2771,
     /*  992971 */     GIR_EraseRootFromParent_Done,
     /*  992972 */   // Label 14801: @992972
     /*  992972 */   GIM_Try, /*On fail goto*//*Label 14802*/ GIMT_Encode4(993048), // Rule ID 17150 //
     /*  992977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  992980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  992988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  992991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  992994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993005 */     // MIs[0] passthru
     /*  993005 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993014 */     // MIs[0] round
     /*  993014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993024 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  993027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993046 */     GIR_RootConstrainSelectedInstOperands,
     /*  993047 */     // GIR_Coverage, 17150,
     /*  993047 */     GIR_EraseRootFromParent_Done,
     /*  993048 */   // Label 14802: @993048
     /*  993048 */   GIM_Try, /*On fail goto*//*Label 14803*/ GIMT_Encode4(993124), // Rule ID 17151 //
     /*  993053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  993064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  993067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  993070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993081 */     // MIs[0] passthru
     /*  993081 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993090 */     // MIs[0] round
     /*  993090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993100 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  993103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993122 */     GIR_RootConstrainSelectedInstOperands,
     /*  993123 */     // GIR_Coverage, 17151,
     /*  993123 */     GIR_EraseRootFromParent_Done,
     /*  993124 */   // Label 14803: @993124
     /*  993124 */   GIM_Try, /*On fail goto*//*Label 14804*/ GIMT_Encode4(993200), // Rule ID 17160 //
     /*  993129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  993140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  993143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  993146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993157 */     // MIs[0] passthru
     /*  993157 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993166 */     // MIs[0] round
     /*  993166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993176 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  993179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993198 */     GIR_RootConstrainSelectedInstOperands,
     /*  993199 */     // GIR_Coverage, 17160,
     /*  993199 */     GIR_EraseRootFromParent_Done,
     /*  993200 */   // Label 14804: @993200
     /*  993200 */   GIM_Try, /*On fail goto*//*Label 14805*/ GIMT_Encode4(993276), // Rule ID 17161 //
     /*  993205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  993216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  993219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  993222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993233 */     // MIs[0] passthru
     /*  993233 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993242 */     // MIs[0] round
     /*  993242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  993255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993274 */     GIR_RootConstrainSelectedInstOperands,
     /*  993275 */     // GIR_Coverage, 17161,
     /*  993275 */     GIR_EraseRootFromParent_Done,
     /*  993276 */   // Label 14805: @993276
     /*  993276 */   GIM_Try, /*On fail goto*//*Label 14806*/ GIMT_Encode4(993352), // Rule ID 17170 //
     /*  993281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  993292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  993295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  993298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993309 */     // MIs[0] passthru
     /*  993309 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993318 */     // MIs[0] round
     /*  993318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993328 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  993331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993350 */     GIR_RootConstrainSelectedInstOperands,
     /*  993351 */     // GIR_Coverage, 17170,
     /*  993351 */     GIR_EraseRootFromParent_Done,
     /*  993352 */   // Label 14806: @993352
     /*  993352 */   GIM_Try, /*On fail goto*//*Label 14807*/ GIMT_Encode4(993428), // Rule ID 17171 //
     /*  993357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  993368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  993371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  993374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993385 */     // MIs[0] passthru
     /*  993385 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993394 */     // MIs[0] round
     /*  993394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993404 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  993407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993426 */     GIR_RootConstrainSelectedInstOperands,
     /*  993427 */     // GIR_Coverage, 17171,
     /*  993427 */     GIR_EraseRootFromParent_Done,
     /*  993428 */   // Label 14807: @993428
     /*  993428 */   GIM_Try, /*On fail goto*//*Label 14808*/ GIMT_Encode4(993504), // Rule ID 17180 //
     /*  993433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  993444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  993447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  993450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993461 */     // MIs[0] passthru
     /*  993461 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993470 */     // MIs[0] round
     /*  993470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993480 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  993483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993502 */     GIR_RootConstrainSelectedInstOperands,
     /*  993503 */     // GIR_Coverage, 17180,
     /*  993503 */     GIR_EraseRootFromParent_Done,
     /*  993504 */   // Label 14808: @993504
     /*  993504 */   GIM_Try, /*On fail goto*//*Label 14809*/ GIMT_Encode4(993580), // Rule ID 17181 //
     /*  993509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  993520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  993523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  993526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993537 */     // MIs[0] passthru
     /*  993537 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993546 */     // MIs[0] round
     /*  993546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993556 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  993559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993578 */     GIR_RootConstrainSelectedInstOperands,
     /*  993579 */     // GIR_Coverage, 17181,
     /*  993579 */     GIR_EraseRootFromParent_Done,
     /*  993580 */   // Label 14809: @993580
     /*  993580 */   GIM_Try, /*On fail goto*//*Label 14810*/ GIMT_Encode4(993656), // Rule ID 17190 //
     /*  993585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  993588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  993596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  993599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  993602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993613 */     // MIs[0] passthru
     /*  993613 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993622 */     // MIs[0] round
     /*  993622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993632 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  993632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  993635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993654 */     GIR_RootConstrainSelectedInstOperands,
     /*  993655 */     // GIR_Coverage, 17190,
     /*  993655 */     GIR_EraseRootFromParent_Done,
     /*  993656 */   // Label 14810: @993656
     /*  993656 */   GIM_Try, /*On fail goto*//*Label 14811*/ GIMT_Encode4(993732), // Rule ID 17191 //
     /*  993661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  993664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  993672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  993675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  993678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993689 */     // MIs[0] passthru
     /*  993689 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993698 */     // MIs[0] round
     /*  993698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993708 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  993708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  993711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993730 */     GIR_RootConstrainSelectedInstOperands,
     /*  993731 */     // GIR_Coverage, 17191,
     /*  993731 */     GIR_EraseRootFromParent_Done,
     /*  993732 */   // Label 14811: @993732
     /*  993732 */   GIM_Try, /*On fail goto*//*Label 14812*/ GIMT_Encode4(993808), // Rule ID 17200 //
     /*  993737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  993740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  993748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  993751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  993754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993765 */     // MIs[0] passthru
     /*  993765 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993774 */     // MIs[0] round
     /*  993774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993784 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  993784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  993787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993806 */     GIR_RootConstrainSelectedInstOperands,
     /*  993807 */     // GIR_Coverage, 17200,
     /*  993807 */     GIR_EraseRootFromParent_Done,
     /*  993808 */   // Label 14812: @993808
     /*  993808 */   GIM_Try, /*On fail goto*//*Label 14813*/ GIMT_Encode4(993884), // Rule ID 17201 //
     /*  993813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  993816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  993824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  993827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  993830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993841 */     // MIs[0] passthru
     /*  993841 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993850 */     // MIs[0] round
     /*  993850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993860 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  993860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  993863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993882 */     GIR_RootConstrainSelectedInstOperands,
     /*  993883 */     // GIR_Coverage, 17201,
     /*  993883 */     GIR_EraseRootFromParent_Done,
     /*  993884 */   // Label 14813: @993884
     /*  993884 */   GIM_Try, /*On fail goto*//*Label 14814*/ GIMT_Encode4(993960), // Rule ID 17210 //
     /*  993889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  993892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  993900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  993903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  993906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993917 */     // MIs[0] passthru
     /*  993917 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993926 */     // MIs[0] round
     /*  993926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993936 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  993936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  993939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993958 */     GIR_RootConstrainSelectedInstOperands,
     /*  993959 */     // GIR_Coverage, 17210,
     /*  993959 */     GIR_EraseRootFromParent_Done,
     /*  993960 */   // Label 14814: @993960
     /*  993960 */   GIM_Try, /*On fail goto*//*Label 14815*/ GIMT_Encode4(994036), // Rule ID 17211 //
     /*  993965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  993968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  993976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  993979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  993982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993993 */     // MIs[0] passthru
     /*  993993 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994002 */     // MIs[0] round
     /*  994002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994012 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  994015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994034 */     GIR_RootConstrainSelectedInstOperands,
     /*  994035 */     // GIR_Coverage, 17211,
     /*  994035 */     GIR_EraseRootFromParent_Done,
     /*  994036 */   // Label 14815: @994036
     /*  994036 */   GIM_Try, /*On fail goto*//*Label 14816*/ GIMT_Encode4(994112), // Rule ID 17220 //
     /*  994041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  994052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  994055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  994058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994069 */     // MIs[0] passthru
     /*  994069 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994078 */     // MIs[0] round
     /*  994078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994088 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  994091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994110 */     GIR_RootConstrainSelectedInstOperands,
     /*  994111 */     // GIR_Coverage, 17220,
     /*  994111 */     GIR_EraseRootFromParent_Done,
     /*  994112 */   // Label 14816: @994112
     /*  994112 */   GIM_Try, /*On fail goto*//*Label 14817*/ GIMT_Encode4(994188), // Rule ID 17221 //
     /*  994117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  994128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  994131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  994134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994145 */     // MIs[0] passthru
     /*  994145 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994154 */     // MIs[0] round
     /*  994154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994164 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  994167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994186 */     GIR_RootConstrainSelectedInstOperands,
     /*  994187 */     // GIR_Coverage, 17221,
     /*  994187 */     GIR_EraseRootFromParent_Done,
     /*  994188 */   // Label 14817: @994188
     /*  994188 */   GIM_Try, /*On fail goto*//*Label 14818*/ GIMT_Encode4(994264), // Rule ID 17266 //
     /*  994193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  994204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  994207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  994210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994221 */     // MIs[0] passthru
     /*  994221 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994230 */     // MIs[0] round
     /*  994230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994240 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  994243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994262 */     GIR_RootConstrainSelectedInstOperands,
     /*  994263 */     // GIR_Coverage, 17266,
     /*  994263 */     GIR_EraseRootFromParent_Done,
     /*  994264 */   // Label 14818: @994264
     /*  994264 */   GIM_Try, /*On fail goto*//*Label 14819*/ GIMT_Encode4(994340), // Rule ID 17267 //
     /*  994269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  994280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  994283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  994286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994297 */     // MIs[0] passthru
     /*  994297 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994306 */     // MIs[0] round
     /*  994306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994316 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  994319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994338 */     GIR_RootConstrainSelectedInstOperands,
     /*  994339 */     // GIR_Coverage, 17267,
     /*  994339 */     GIR_EraseRootFromParent_Done,
     /*  994340 */   // Label 14819: @994340
     /*  994340 */   GIM_Try, /*On fail goto*//*Label 14820*/ GIMT_Encode4(994416), // Rule ID 17276 //
     /*  994345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  994356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  994359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  994362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994373 */     // MIs[0] passthru
     /*  994373 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994382 */     // MIs[0] round
     /*  994382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994392 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  994395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994414 */     GIR_RootConstrainSelectedInstOperands,
     /*  994415 */     // GIR_Coverage, 17276,
     /*  994415 */     GIR_EraseRootFromParent_Done,
     /*  994416 */   // Label 14820: @994416
     /*  994416 */   GIM_Try, /*On fail goto*//*Label 14821*/ GIMT_Encode4(994492), // Rule ID 17277 //
     /*  994421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  994432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  994435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  994438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994449 */     // MIs[0] passthru
     /*  994449 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994458 */     // MIs[0] round
     /*  994458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994468 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  994471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994490 */     GIR_RootConstrainSelectedInstOperands,
     /*  994491 */     // GIR_Coverage, 17277,
     /*  994491 */     GIR_EraseRootFromParent_Done,
     /*  994492 */   // Label 14821: @994492
     /*  994492 */   GIM_Try, /*On fail goto*//*Label 14822*/ GIMT_Encode4(994568), // Rule ID 17286 //
     /*  994497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  994508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  994511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  994514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994525 */     // MIs[0] passthru
     /*  994525 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994534 */     // MIs[0] round
     /*  994534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994544 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  994547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994566 */     GIR_RootConstrainSelectedInstOperands,
     /*  994567 */     // GIR_Coverage, 17286,
     /*  994567 */     GIR_EraseRootFromParent_Done,
     /*  994568 */   // Label 14822: @994568
     /*  994568 */   GIM_Try, /*On fail goto*//*Label 14823*/ GIMT_Encode4(994644), // Rule ID 17287 //
     /*  994573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  994584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  994587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  994590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994601 */     // MIs[0] passthru
     /*  994601 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994610 */     // MIs[0] round
     /*  994610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994620 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  994623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994642 */     GIR_RootConstrainSelectedInstOperands,
     /*  994643 */     // GIR_Coverage, 17287,
     /*  994643 */     GIR_EraseRootFromParent_Done,
     /*  994644 */   // Label 14823: @994644
     /*  994644 */   GIM_Try, /*On fail goto*//*Label 14824*/ GIMT_Encode4(994720), // Rule ID 17296 //
     /*  994649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  994660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  994663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  994666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994677 */     // MIs[0] passthru
     /*  994677 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994686 */     // MIs[0] round
     /*  994686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994696 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  994699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994718 */     GIR_RootConstrainSelectedInstOperands,
     /*  994719 */     // GIR_Coverage, 17296,
     /*  994719 */     GIR_EraseRootFromParent_Done,
     /*  994720 */   // Label 14824: @994720
     /*  994720 */   GIM_Try, /*On fail goto*//*Label 14825*/ GIMT_Encode4(994796), // Rule ID 17297 //
     /*  994725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  994736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  994739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  994742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994753 */     // MIs[0] passthru
     /*  994753 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994762 */     // MIs[0] round
     /*  994762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994772 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  994775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994794 */     GIR_RootConstrainSelectedInstOperands,
     /*  994795 */     // GIR_Coverage, 17297,
     /*  994795 */     GIR_EraseRootFromParent_Done,
     /*  994796 */   // Label 14825: @994796
     /*  994796 */   GIM_Try, /*On fail goto*//*Label 14826*/ GIMT_Encode4(994872), // Rule ID 17306 //
     /*  994801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  994812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  994815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  994818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994829 */     // MIs[0] passthru
     /*  994829 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994838 */     // MIs[0] round
     /*  994838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994848 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  994851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994870 */     GIR_RootConstrainSelectedInstOperands,
     /*  994871 */     // GIR_Coverage, 17306,
     /*  994871 */     GIR_EraseRootFromParent_Done,
     /*  994872 */   // Label 14826: @994872
     /*  994872 */   GIM_Try, /*On fail goto*//*Label 14827*/ GIMT_Encode4(994948), // Rule ID 17307 //
     /*  994877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  994888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  994891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  994894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994905 */     // MIs[0] passthru
     /*  994905 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994914 */     // MIs[0] round
     /*  994914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994924 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  994927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994946 */     GIR_RootConstrainSelectedInstOperands,
     /*  994947 */     // GIR_Coverage, 17307,
     /*  994947 */     GIR_EraseRootFromParent_Done,
     /*  994948 */   // Label 14827: @994948
     /*  994948 */   GIM_Try, /*On fail goto*//*Label 14828*/ GIMT_Encode4(995024), // Rule ID 17316 //
     /*  994953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  994964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  994967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  994970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994981 */     // MIs[0] passthru
     /*  994981 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994990 */     // MIs[0] round
     /*  994990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995000 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  995003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995022 */     GIR_RootConstrainSelectedInstOperands,
     /*  995023 */     // GIR_Coverage, 17316,
     /*  995023 */     GIR_EraseRootFromParent_Done,
     /*  995024 */   // Label 14828: @995024
     /*  995024 */   GIM_Try, /*On fail goto*//*Label 14829*/ GIMT_Encode4(995100), // Rule ID 17317 //
     /*  995029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  995040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  995043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  995046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995057 */     // MIs[0] passthru
     /*  995057 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995066 */     // MIs[0] round
     /*  995066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995076 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  995079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995098 */     GIR_RootConstrainSelectedInstOperands,
     /*  995099 */     // GIR_Coverage, 17317,
     /*  995099 */     GIR_EraseRootFromParent_Done,
     /*  995100 */   // Label 14829: @995100
     /*  995100 */   GIM_Try, /*On fail goto*//*Label 14830*/ GIMT_Encode4(995176), // Rule ID 17326 //
     /*  995105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  995116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  995119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  995122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995133 */     // MIs[0] passthru
     /*  995133 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995142 */     // MIs[0] round
     /*  995142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995152 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  995155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995174 */     GIR_RootConstrainSelectedInstOperands,
     /*  995175 */     // GIR_Coverage, 17326,
     /*  995175 */     GIR_EraseRootFromParent_Done,
     /*  995176 */   // Label 14830: @995176
     /*  995176 */   GIM_Try, /*On fail goto*//*Label 14831*/ GIMT_Encode4(995252), // Rule ID 17327 //
     /*  995181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  995192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  995195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  995198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995209 */     // MIs[0] passthru
     /*  995209 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995218 */     // MIs[0] round
     /*  995218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995228 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  995231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995250 */     GIR_RootConstrainSelectedInstOperands,
     /*  995251 */     // GIR_Coverage, 17327,
     /*  995251 */     GIR_EraseRootFromParent_Done,
     /*  995252 */   // Label 14831: @995252
     /*  995252 */   GIM_Try, /*On fail goto*//*Label 14832*/ GIMT_Encode4(995328), // Rule ID 17336 //
     /*  995257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  995268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  995271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  995274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995285 */     // MIs[0] passthru
     /*  995285 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995294 */     // MIs[0] round
     /*  995294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995304 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  995307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995326 */     GIR_RootConstrainSelectedInstOperands,
     /*  995327 */     // GIR_Coverage, 17336,
     /*  995327 */     GIR_EraseRootFromParent_Done,
     /*  995328 */   // Label 14832: @995328
     /*  995328 */   GIM_Try, /*On fail goto*//*Label 14833*/ GIMT_Encode4(995404), // Rule ID 17337 //
     /*  995333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  995344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  995347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  995350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995361 */     // MIs[0] passthru
     /*  995361 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995370 */     // MIs[0] round
     /*  995370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995380 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  995383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995402 */     GIR_RootConstrainSelectedInstOperands,
     /*  995403 */     // GIR_Coverage, 17337,
     /*  995403 */     GIR_EraseRootFromParent_Done,
     /*  995404 */   // Label 14833: @995404
     /*  995404 */   GIM_Try, /*On fail goto*//*Label 14834*/ GIMT_Encode4(995480), // Rule ID 17346 //
     /*  995409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  995420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  995423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  995426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995437 */     // MIs[0] passthru
     /*  995437 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995446 */     // MIs[0] round
     /*  995446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995456 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  995459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995478 */     GIR_RootConstrainSelectedInstOperands,
     /*  995479 */     // GIR_Coverage, 17346,
     /*  995479 */     GIR_EraseRootFromParent_Done,
     /*  995480 */   // Label 14834: @995480
     /*  995480 */   GIM_Try, /*On fail goto*//*Label 14835*/ GIMT_Encode4(995556), // Rule ID 17347 //
     /*  995485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  995496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  995499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  995502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995513 */     // MIs[0] passthru
     /*  995513 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995522 */     // MIs[0] round
     /*  995522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995532 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  995535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995554 */     GIR_RootConstrainSelectedInstOperands,
     /*  995555 */     // GIR_Coverage, 17347,
     /*  995555 */     GIR_EraseRootFromParent_Done,
     /*  995556 */   // Label 14835: @995556
     /*  995556 */   GIM_Try, /*On fail goto*//*Label 14836*/ GIMT_Encode4(995633), // Rule ID 2700 //
     /*  995561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  995569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  995572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  995575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  995578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995600 */     // MIs[0] policy
     /*  995600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995610 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  995613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995631 */     GIR_RootConstrainSelectedInstOperands,
     /*  995632 */     // GIR_Coverage, 2700,
     /*  995632 */     GIR_EraseRootFromParent_Done,
     /*  995633 */   // Label 14836: @995633
     /*  995633 */   GIM_Try, /*On fail goto*//*Label 14837*/ GIMT_Encode4(995710), // Rule ID 2701 //
     /*  995638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  995646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  995649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  995652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  995655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995677 */     // MIs[0] policy
     /*  995677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995687 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  995690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995696 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995708 */     GIR_RootConstrainSelectedInstOperands,
     /*  995709 */     // GIR_Coverage, 2701,
     /*  995709 */     GIR_EraseRootFromParent_Done,
     /*  995710 */   // Label 14837: @995710
     /*  995710 */   GIM_Try, /*On fail goto*//*Label 14838*/ GIMT_Encode4(995787), // Rule ID 2704 //
     /*  995715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  995723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  995732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995754 */     // MIs[0] policy
     /*  995754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995764 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11692:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  995767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995785 */     GIR_RootConstrainSelectedInstOperands,
     /*  995786 */     // GIR_Coverage, 2704,
     /*  995786 */     GIR_EraseRootFromParent_Done,
     /*  995787 */   // Label 14838: @995787
     /*  995787 */   GIM_Try, /*On fail goto*//*Label 14839*/ GIMT_Encode4(995864), // Rule ID 2705 //
     /*  995792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  995800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  995809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995831 */     // MIs[0] policy
     /*  995831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995841 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11692:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  995844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995850 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995862 */     GIR_RootConstrainSelectedInstOperands,
     /*  995863 */     // GIR_Coverage, 2705,
     /*  995863 */     GIR_EraseRootFromParent_Done,
     /*  995864 */   // Label 14839: @995864
     /*  995864 */   GIM_Try, /*On fail goto*//*Label 14840*/ GIMT_Encode4(995941), // Rule ID 2708 //
     /*  995869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  995872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  995877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  995886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995908 */     // MIs[0] policy
     /*  995908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995918 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  995921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995939 */     GIR_RootConstrainSelectedInstOperands,
     /*  995940 */     // GIR_Coverage, 2708,
     /*  995940 */     GIR_EraseRootFromParent_Done,
     /*  995941 */   // Label 14840: @995941
     /*  995941 */   GIM_Try, /*On fail goto*//*Label 14841*/ GIMT_Encode4(996018), // Rule ID 2709 //
     /*  995946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  995949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  995954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  995963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995985 */     // MIs[0] policy
     /*  995985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995995 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  995998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996016 */     GIR_RootConstrainSelectedInstOperands,
     /*  996017 */     // GIR_Coverage, 2709,
     /*  996017 */     GIR_EraseRootFromParent_Done,
     /*  996018 */   // Label 14841: @996018
     /*  996018 */   GIM_Try, /*On fail goto*//*Label 14842*/ GIMT_Encode4(996095), // Rule ID 2744 //
     /*  996023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  996026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  996031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996062 */     // MIs[0] policy
     /*  996062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996072 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  996075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996093 */     GIR_RootConstrainSelectedInstOperands,
     /*  996094 */     // GIR_Coverage, 2744,
     /*  996094 */     GIR_EraseRootFromParent_Done,
     /*  996095 */   // Label 14842: @996095
     /*  996095 */   GIM_Try, /*On fail goto*//*Label 14843*/ GIMT_Encode4(996172), // Rule ID 2745 //
     /*  996100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  996103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  996108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996139 */     // MIs[0] policy
     /*  996139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996149 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  996152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996170 */     GIR_RootConstrainSelectedInstOperands,
     /*  996171 */     // GIR_Coverage, 2745,
     /*  996171 */     GIR_EraseRootFromParent_Done,
     /*  996172 */   // Label 14843: @996172
     /*  996172 */   GIM_Try, /*On fail goto*//*Label 14844*/ GIMT_Encode4(996249), // Rule ID 2776 //
     /*  996177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  996185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  996188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  996191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  996194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  996197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996216 */     // MIs[0] policy
     /*  996216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996226 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*  996229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  996233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996247 */     GIR_RootConstrainSelectedInstOperands,
     /*  996248 */     // GIR_Coverage, 2776,
     /*  996248 */     GIR_EraseRootFromParent_Done,
     /*  996249 */   // Label 14844: @996249
     /*  996249 */   GIM_Try, /*On fail goto*//*Label 14845*/ GIMT_Encode4(996326), // Rule ID 2777 //
     /*  996254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  996262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  996265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  996268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  996271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  996274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996293 */     // MIs[0] policy
     /*  996293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996303 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*  996306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  996310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996324 */     GIR_RootConstrainSelectedInstOperands,
     /*  996325 */     // GIR_Coverage, 2777,
     /*  996325 */     GIR_EraseRootFromParent_Done,
     /*  996326 */   // Label 14845: @996326
     /*  996326 */   GIM_Try, /*On fail goto*//*Label 14846*/ GIMT_Encode4(996403), // Rule ID 4904 //
     /*  996331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  996342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  996345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  996348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996370 */     // MIs[0] policy
     /*  996370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996380 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11692:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  996383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996401 */     GIR_RootConstrainSelectedInstOperands,
     /*  996402 */     // GIR_Coverage, 4904,
     /*  996402 */     GIR_EraseRootFromParent_Done,
     /*  996403 */   // Label 14846: @996403
     /*  996403 */   GIM_Try, /*On fail goto*//*Label 14847*/ GIMT_Encode4(996480), // Rule ID 4905 //
     /*  996408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  996419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  996422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  996425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996447 */     // MIs[0] policy
     /*  996447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996457 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11692:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  996460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996478 */     GIR_RootConstrainSelectedInstOperands,
     /*  996479 */     // GIR_Coverage, 4905,
     /*  996479 */     GIR_EraseRootFromParent_Done,
     /*  996480 */   // Label 14847: @996480
     /*  996480 */   GIM_Try, /*On fail goto*//*Label 14848*/ GIMT_Encode4(996557), // Rule ID 4908 //
     /*  996485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  996496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  996499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  996502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  996505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996524 */     // MIs[0] policy
     /*  996524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996534 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11692:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  996537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996555 */     GIR_RootConstrainSelectedInstOperands,
     /*  996556 */     // GIR_Coverage, 4908,
     /*  996556 */     GIR_EraseRootFromParent_Done,
     /*  996557 */   // Label 14848: @996557
     /*  996557 */   GIM_Try, /*On fail goto*//*Label 14849*/ GIMT_Encode4(996634), // Rule ID 4909 //
     /*  996562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  996573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  996576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  996579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  996582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996601 */     // MIs[0] policy
     /*  996601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996611 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11692:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  996614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996632 */     GIR_RootConstrainSelectedInstOperands,
     /*  996633 */     // GIR_Coverage, 4909,
     /*  996633 */     GIR_EraseRootFromParent_Done,
     /*  996634 */   // Label 14849: @996634
     /*  996634 */   GIM_Try, /*On fail goto*//*Label 14850*/ GIMT_Encode4(996711), // Rule ID 4912 //
     /*  996639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  996650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  996653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  996656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  996659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  996666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996678 */     // MIs[0] policy
     /*  996678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996688 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11692:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  996691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996709 */     GIR_RootConstrainSelectedInstOperands,
     /*  996710 */     // GIR_Coverage, 4912,
     /*  996710 */     GIR_EraseRootFromParent_Done,
     /*  996711 */   // Label 14850: @996711
     /*  996711 */   GIM_Try, /*On fail goto*//*Label 14851*/ GIMT_Encode4(996788), // Rule ID 4913 //
     /*  996716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  996727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  996730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  996733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  996736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  996743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996755 */     // MIs[0] policy
     /*  996755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11692:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  996768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996774 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996786 */     GIR_RootConstrainSelectedInstOperands,
     /*  996787 */     // GIR_Coverage, 4913,
     /*  996787 */     GIR_EraseRootFromParent_Done,
     /*  996788 */   // Label 14851: @996788
     /*  996788 */   GIM_Try, /*On fail goto*//*Label 14852*/ GIMT_Encode4(996865), // Rule ID 4916 //
     /*  996793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  996804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  996807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  996810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  996813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  996820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996832 */     // MIs[0] policy
     /*  996832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996842 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11692:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  996845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996863 */     GIR_RootConstrainSelectedInstOperands,
     /*  996864 */     // GIR_Coverage, 4916,
     /*  996864 */     GIR_EraseRootFromParent_Done,
     /*  996865 */   // Label 14852: @996865
     /*  996865 */   GIM_Try, /*On fail goto*//*Label 14853*/ GIMT_Encode4(996942), // Rule ID 4917 //
     /*  996870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  996881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  996884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  996887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  996890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  996897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996909 */     // MIs[0] policy
     /*  996909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996919 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11692:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  996922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996928 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996940 */     GIR_RootConstrainSelectedInstOperands,
     /*  996941 */     // GIR_Coverage, 4917,
     /*  996941 */     GIR_EraseRootFromParent_Done,
     /*  996942 */   // Label 14853: @996942
     /*  996942 */   GIM_Try, /*On fail goto*//*Label 14854*/ GIMT_Encode4(997019), // Rule ID 4920 //
     /*  996947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  996958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  996961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  996964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  996967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  996974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996986 */     // MIs[0] policy
     /*  996986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996996 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11692:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  996999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997017 */     GIR_RootConstrainSelectedInstOperands,
     /*  997018 */     // GIR_Coverage, 4920,
     /*  997018 */     GIR_EraseRootFromParent_Done,
     /*  997019 */   // Label 14854: @997019
     /*  997019 */   GIM_Try, /*On fail goto*//*Label 14855*/ GIMT_Encode4(997096), // Rule ID 4921 //
     /*  997024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  997035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  997038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  997041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  997044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997063 */     // MIs[0] policy
     /*  997063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997073 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11692:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997082 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997094 */     GIR_RootConstrainSelectedInstOperands,
     /*  997095 */     // GIR_Coverage, 4921,
     /*  997095 */     GIR_EraseRootFromParent_Done,
     /*  997096 */   // Label 14855: @997096
     /*  997096 */   GIM_Try, /*On fail goto*//*Label 14856*/ GIMT_Encode4(997173), // Rule ID 4924 //
     /*  997101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  997112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  997115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  997118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997140 */     // MIs[0] policy
     /*  997140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997150 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11692:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  997153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997171 */     GIR_RootConstrainSelectedInstOperands,
     /*  997172 */     // GIR_Coverage, 4924,
     /*  997172 */     GIR_EraseRootFromParent_Done,
     /*  997173 */   // Label 14856: @997173
     /*  997173 */   GIM_Try, /*On fail goto*//*Label 14857*/ GIMT_Encode4(997250), // Rule ID 4925 //
     /*  997178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  997189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  997192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  997195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997217 */     // MIs[0] policy
     /*  997217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997227 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11692:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  997230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997248 */     GIR_RootConstrainSelectedInstOperands,
     /*  997249 */     // GIR_Coverage, 4925,
     /*  997249 */     GIR_EraseRootFromParent_Done,
     /*  997250 */   // Label 14857: @997250
     /*  997250 */   GIM_Try, /*On fail goto*//*Label 14858*/ GIMT_Encode4(997327), // Rule ID 4928 //
     /*  997255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  997266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  997269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  997272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  997275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997294 */     // MIs[0] policy
     /*  997294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11692:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997325 */     GIR_RootConstrainSelectedInstOperands,
     /*  997326 */     // GIR_Coverage, 4928,
     /*  997326 */     GIR_EraseRootFromParent_Done,
     /*  997327 */   // Label 14858: @997327
     /*  997327 */   GIM_Try, /*On fail goto*//*Label 14859*/ GIMT_Encode4(997404), // Rule ID 4929 //
     /*  997332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  997343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  997346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  997349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  997352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997371 */     // MIs[0] policy
     /*  997371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997381 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11692:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997390 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997402 */     GIR_RootConstrainSelectedInstOperands,
     /*  997403 */     // GIR_Coverage, 4929,
     /*  997403 */     GIR_EraseRootFromParent_Done,
     /*  997404 */   // Label 14859: @997404
     /*  997404 */   GIM_Try, /*On fail goto*//*Label 14860*/ GIMT_Encode4(997481), // Rule ID 4932 //
     /*  997409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  997420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  997423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  997426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997448 */     // MIs[0] policy
     /*  997448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11692:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997479 */     GIR_RootConstrainSelectedInstOperands,
     /*  997480 */     // GIR_Coverage, 4932,
     /*  997480 */     GIR_EraseRootFromParent_Done,
     /*  997481 */   // Label 14860: @997481
     /*  997481 */   GIM_Try, /*On fail goto*//*Label 14861*/ GIMT_Encode4(997558), // Rule ID 4933 //
     /*  997486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  997497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  997500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  997503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997525 */     // MIs[0] policy
     /*  997525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997535 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11692:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997556 */     GIR_RootConstrainSelectedInstOperands,
     /*  997557 */     // GIR_Coverage, 4933,
     /*  997557 */     GIR_EraseRootFromParent_Done,
     /*  997558 */   // Label 14861: @997558
     /*  997558 */   GIM_Try, /*On fail goto*//*Label 14862*/ GIMT_Encode4(997635), // Rule ID 4936 //
     /*  997563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  997574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  997577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  997580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997602 */     // MIs[0] policy
     /*  997602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997612 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11692:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  997615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997633 */     GIR_RootConstrainSelectedInstOperands,
     /*  997634 */     // GIR_Coverage, 4936,
     /*  997634 */     GIR_EraseRootFromParent_Done,
     /*  997635 */   // Label 14862: @997635
     /*  997635 */   GIM_Try, /*On fail goto*//*Label 14863*/ GIMT_Encode4(997712), // Rule ID 4937 //
     /*  997640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  997651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  997654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  997657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997679 */     // MIs[0] policy
     /*  997679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997689 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11692:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  997692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997710 */     GIR_RootConstrainSelectedInstOperands,
     /*  997711 */     // GIR_Coverage, 4937,
     /*  997711 */     GIR_EraseRootFromParent_Done,
     /*  997712 */   // Label 14863: @997712
     /*  997712 */   GIM_Try, /*On fail goto*//*Label 14864*/ GIMT_Encode4(997789), // Rule ID 4940 //
     /*  997717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  997728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  997731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  997734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  997737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997756 */     // MIs[0] policy
     /*  997756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997766 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11692:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997787 */     GIR_RootConstrainSelectedInstOperands,
     /*  997788 */     // GIR_Coverage, 4940,
     /*  997788 */     GIR_EraseRootFromParent_Done,
     /*  997789 */   // Label 14864: @997789
     /*  997789 */   GIM_Try, /*On fail goto*//*Label 14865*/ GIMT_Encode4(997866), // Rule ID 4941 //
     /*  997794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  997805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  997808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  997811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  997814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997833 */     // MIs[0] policy
     /*  997833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997843 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11692:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997864 */     GIR_RootConstrainSelectedInstOperands,
     /*  997865 */     // GIR_Coverage, 4941,
     /*  997865 */     GIR_EraseRootFromParent_Done,
     /*  997866 */   // Label 14865: @997866
     /*  997866 */   GIM_Try, /*On fail goto*//*Label 14866*/ GIMT_Encode4(997943), // Rule ID 4944 //
     /*  997871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  997874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  997882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  997885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  997888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997910 */     // MIs[0] policy
     /*  997910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997920 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11692:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  997939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997941 */     GIR_RootConstrainSelectedInstOperands,
     /*  997942 */     // GIR_Coverage, 4944,
     /*  997942 */     GIR_EraseRootFromParent_Done,
     /*  997943 */   // Label 14866: @997943
     /*  997943 */   GIM_Try, /*On fail goto*//*Label 14867*/ GIMT_Encode4(998020), // Rule ID 4945 //
     /*  997948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  997951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  997959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  997962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  997965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997987 */     // MIs[0] policy
     /*  997987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997997 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11692:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  998000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998006 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998018 */     GIR_RootConstrainSelectedInstOperands,
     /*  998019 */     // GIR_Coverage, 4945,
     /*  998019 */     GIR_EraseRootFromParent_Done,
     /*  998020 */   // Label 14867: @998020
     /*  998020 */   GIM_Try, /*On fail goto*//*Label 14868*/ GIMT_Encode4(998097), // Rule ID 4948 //
     /*  998025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  998042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998064 */     // MIs[0] policy
     /*  998064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998074 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11692:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  998077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998095 */     GIR_RootConstrainSelectedInstOperands,
     /*  998096 */     // GIR_Coverage, 4948,
     /*  998096 */     GIR_EraseRootFromParent_Done,
     /*  998097 */   // Label 14868: @998097
     /*  998097 */   GIM_Try, /*On fail goto*//*Label 14869*/ GIMT_Encode4(998174), // Rule ID 4949 //
     /*  998102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  998119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998141 */     // MIs[0] policy
     /*  998141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998151 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11692:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  998154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998160 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998172 */     GIR_RootConstrainSelectedInstOperands,
     /*  998173 */     // GIR_Coverage, 4949,
     /*  998173 */     GIR_EraseRootFromParent_Done,
     /*  998174 */   // Label 14869: @998174
     /*  998174 */   GIM_Try, /*On fail goto*//*Label 14870*/ GIMT_Encode4(998251), // Rule ID 4952 //
     /*  998179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  998190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  998193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  998196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998218 */     // MIs[0] policy
     /*  998218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998228 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11692:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  998231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998249 */     GIR_RootConstrainSelectedInstOperands,
     /*  998250 */     // GIR_Coverage, 4952,
     /*  998250 */     GIR_EraseRootFromParent_Done,
     /*  998251 */   // Label 14870: @998251
     /*  998251 */   GIM_Try, /*On fail goto*//*Label 14871*/ GIMT_Encode4(998328), // Rule ID 4953 //
     /*  998256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  998267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  998270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  998273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998295 */     // MIs[0] policy
     /*  998295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998305 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11692:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  998308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998314 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998326 */     GIR_RootConstrainSelectedInstOperands,
     /*  998327 */     // GIR_Coverage, 4953,
     /*  998327 */     GIR_EraseRootFromParent_Done,
     /*  998328 */   // Label 14871: @998328
     /*  998328 */   GIM_Try, /*On fail goto*//*Label 14872*/ GIMT_Encode4(998405), // Rule ID 4956 //
     /*  998333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  998344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  998347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  998350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998372 */     // MIs[0] policy
     /*  998372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998382 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11692:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  998385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998403 */     GIR_RootConstrainSelectedInstOperands,
     /*  998404 */     // GIR_Coverage, 4956,
     /*  998404 */     GIR_EraseRootFromParent_Done,
     /*  998405 */   // Label 14872: @998405
     /*  998405 */   GIM_Try, /*On fail goto*//*Label 14873*/ GIMT_Encode4(998482), // Rule ID 4957 //
     /*  998410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  998421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  998424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  998427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998449 */     // MIs[0] policy
     /*  998449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998459 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11692:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  998462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998468 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998480 */     GIR_RootConstrainSelectedInstOperands,
     /*  998481 */     // GIR_Coverage, 4957,
     /*  998481 */     GIR_EraseRootFromParent_Done,
     /*  998482 */   // Label 14873: @998482
     /*  998482 */   GIM_Try, /*On fail goto*//*Label 14874*/ GIMT_Encode4(998559), // Rule ID 4960 //
     /*  998487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  998498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  998501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  998504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998526 */     // MIs[0] policy
     /*  998526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998536 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11692:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /*  998539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998557 */     GIR_RootConstrainSelectedInstOperands,
     /*  998558 */     // GIR_Coverage, 4960,
     /*  998558 */     GIR_EraseRootFromParent_Done,
     /*  998559 */   // Label 14874: @998559
     /*  998559 */   GIM_Try, /*On fail goto*//*Label 14875*/ GIMT_Encode4(998636), // Rule ID 4961 //
     /*  998564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  998575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  998578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  998581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998603 */     // MIs[0] policy
     /*  998603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998613 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11692:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /*  998616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998622 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998634 */     GIR_RootConstrainSelectedInstOperands,
     /*  998635 */     // GIR_Coverage, 4961,
     /*  998635 */     GIR_EraseRootFromParent_Done,
     /*  998636 */   // Label 14875: @998636
     /*  998636 */   GIM_Try, /*On fail goto*//*Label 14876*/ GIMT_Encode4(998713), // Rule ID 4964 //
     /*  998641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  998652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  998655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  998658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998680 */     // MIs[0] policy
     /*  998680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11692:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  998693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998711 */     GIR_RootConstrainSelectedInstOperands,
     /*  998712 */     // GIR_Coverage, 4964,
     /*  998712 */     GIR_EraseRootFromParent_Done,
     /*  998713 */   // Label 14876: @998713
     /*  998713 */   GIM_Try, /*On fail goto*//*Label 14877*/ GIMT_Encode4(998790), // Rule ID 4965 //
     /*  998718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  998729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  998732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  998735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998757 */     // MIs[0] policy
     /*  998757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998767 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11692:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  998770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998776 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998788 */     GIR_RootConstrainSelectedInstOperands,
     /*  998789 */     // GIR_Coverage, 4965,
     /*  998789 */     GIR_EraseRootFromParent_Done,
     /*  998790 */   // Label 14877: @998790
     /*  998790 */   GIM_Try, /*On fail goto*//*Label 14878*/ GIMT_Encode4(998867), // Rule ID 4968 //
     /*  998795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  998806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  998809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  998812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998834 */     // MIs[0] policy
     /*  998834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11692:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  998847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998865 */     GIR_RootConstrainSelectedInstOperands,
     /*  998866 */     // GIR_Coverage, 4968,
     /*  998866 */     GIR_EraseRootFromParent_Done,
     /*  998867 */   // Label 14878: @998867
     /*  998867 */   GIM_Try, /*On fail goto*//*Label 14879*/ GIMT_Encode4(998944), // Rule ID 4969 //
     /*  998872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  998883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  998886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  998889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998911 */     // MIs[0] policy
     /*  998911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998921 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11692:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  998924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998930 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998942 */     GIR_RootConstrainSelectedInstOperands,
     /*  998943 */     // GIR_Coverage, 4969,
     /*  998943 */     GIR_EraseRootFromParent_Done,
     /*  998944 */   // Label 14879: @998944
     /*  998944 */   GIM_Try, /*On fail goto*//*Label 14880*/ GIMT_Encode4(999021), // Rule ID 4972 //
     /*  998949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  998966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998988 */     // MIs[0] policy
     /*  998988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998998 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11692:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  999001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999019 */     GIR_RootConstrainSelectedInstOperands,
     /*  999020 */     // GIR_Coverage, 4972,
     /*  999020 */     GIR_EraseRootFromParent_Done,
     /*  999021 */   // Label 14880: @999021
     /*  999021 */   GIM_Try, /*On fail goto*//*Label 14881*/ GIMT_Encode4(999098), // Rule ID 4973 //
     /*  999026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  999037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  999040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  999043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999065 */     // MIs[0] policy
     /*  999065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999075 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11692:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  999078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999084 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999096 */     GIR_RootConstrainSelectedInstOperands,
     /*  999097 */     // GIR_Coverage, 4973,
     /*  999097 */     GIR_EraseRootFromParent_Done,
     /*  999098 */   // Label 14881: @999098
     /*  999098 */   GIM_Try, /*On fail goto*//*Label 14882*/ GIMT_Encode4(999175), // Rule ID 4976 //
     /*  999103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  999114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  999117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  999120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  999123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999142 */     // MIs[0] policy
     /*  999142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999152 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11692:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999173 */     GIR_RootConstrainSelectedInstOperands,
     /*  999174 */     // GIR_Coverage, 4976,
     /*  999174 */     GIR_EraseRootFromParent_Done,
     /*  999175 */   // Label 14882: @999175
     /*  999175 */   GIM_Try, /*On fail goto*//*Label 14883*/ GIMT_Encode4(999252), // Rule ID 4977 //
     /*  999180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  999191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  999194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  999197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  999200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999219 */     // MIs[0] policy
     /*  999219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999229 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11692:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999238 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999250 */     GIR_RootConstrainSelectedInstOperands,
     /*  999251 */     // GIR_Coverage, 4977,
     /*  999251 */     GIR_EraseRootFromParent_Done,
     /*  999252 */   // Label 14883: @999252
     /*  999252 */   GIM_Try, /*On fail goto*//*Label 14884*/ GIMT_Encode4(999329), // Rule ID 4980 //
     /*  999257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999296 */     // MIs[0] policy
     /*  999296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999306 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11692:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  999309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999327 */     GIR_RootConstrainSelectedInstOperands,
     /*  999328 */     // GIR_Coverage, 4980,
     /*  999328 */     GIR_EraseRootFromParent_Done,
     /*  999329 */   // Label 14884: @999329
     /*  999329 */   GIM_Try, /*On fail goto*//*Label 14885*/ GIMT_Encode4(999406), // Rule ID 4981 //
     /*  999334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999373 */     // MIs[0] policy
     /*  999373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999383 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11692:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  999386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999392 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999404 */     GIR_RootConstrainSelectedInstOperands,
     /*  999405 */     // GIR_Coverage, 4981,
     /*  999405 */     GIR_EraseRootFromParent_Done,
     /*  999406 */   // Label 14885: @999406
     /*  999406 */   GIM_Try, /*On fail goto*//*Label 14886*/ GIMT_Encode4(999483), // Rule ID 4984 //
     /*  999411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  999422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  999425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  999428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999450 */     // MIs[0] policy
     /*  999450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999460 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11692:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  999463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999481 */     GIR_RootConstrainSelectedInstOperands,
     /*  999482 */     // GIR_Coverage, 4984,
     /*  999482 */     GIR_EraseRootFromParent_Done,
     /*  999483 */   // Label 14886: @999483
     /*  999483 */   GIM_Try, /*On fail goto*//*Label 14887*/ GIMT_Encode4(999560), // Rule ID 4985 //
     /*  999488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  999499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  999502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  999505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999527 */     // MIs[0] policy
     /*  999527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999537 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11692:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  999540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999546 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999558 */     GIR_RootConstrainSelectedInstOperands,
     /*  999559 */     // GIR_Coverage, 4985,
     /*  999559 */     GIR_EraseRootFromParent_Done,
     /*  999560 */   // Label 14887: @999560
     /*  999560 */   GIM_Try, /*On fail goto*//*Label 14888*/ GIMT_Encode4(999637), // Rule ID 4988 //
     /*  999565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  999576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  999579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  999582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999604 */     // MIs[0] policy
     /*  999604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999614 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11692:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  999617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999635 */     GIR_RootConstrainSelectedInstOperands,
     /*  999636 */     // GIR_Coverage, 4988,
     /*  999636 */     GIR_EraseRootFromParent_Done,
     /*  999637 */   // Label 14888: @999637
     /*  999637 */   GIM_Try, /*On fail goto*//*Label 14889*/ GIMT_Encode4(999714), // Rule ID 4989 //
     /*  999642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  999653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  999656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  999659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999681 */     // MIs[0] policy
     /*  999681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999691 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11692:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  999694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999700 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999712 */     GIR_RootConstrainSelectedInstOperands,
     /*  999713 */     // GIR_Coverage, 4989,
     /*  999713 */     GIR_EraseRootFromParent_Done,
     /*  999714 */   // Label 14889: @999714
     /*  999714 */   GIM_Try, /*On fail goto*//*Label 14890*/ GIMT_Encode4(999791), // Rule ID 4992 //
     /*  999719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  999730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  999733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  999736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999758 */     // MIs[0] policy
     /*  999758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11692:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999789 */     GIR_RootConstrainSelectedInstOperands,
     /*  999790 */     // GIR_Coverage, 4992,
     /*  999790 */     GIR_EraseRootFromParent_Done,
     /*  999791 */   // Label 14890: @999791
     /*  999791 */   GIM_Try, /*On fail goto*//*Label 14891*/ GIMT_Encode4(999868), // Rule ID 4993 //
     /*  999796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  999807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  999810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  999813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999835 */     // MIs[0] policy
     /*  999835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999845 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11692:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999854 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999866 */     GIR_RootConstrainSelectedInstOperands,
     /*  999867 */     // GIR_Coverage, 4993,
     /*  999867 */     GIR_EraseRootFromParent_Done,
     /*  999868 */   // Label 14891: @999868
     /*  999868 */   GIM_Try, /*On fail goto*//*Label 14892*/ GIMT_Encode4(999945), // Rule ID 4996 //
     /*  999873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  999890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999912 */     // MIs[0] policy
     /*  999912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999922 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11692:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /*  999925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999943 */     GIR_RootConstrainSelectedInstOperands,
     /*  999944 */     // GIR_Coverage, 4996,
     /*  999944 */     GIR_EraseRootFromParent_Done,
     /*  999945 */   // Label 14892: @999945
     /*  999945 */   GIM_Try, /*On fail goto*//*Label 14893*/ GIMT_Encode4(1000022), // Rule ID 4997 //
     /*  999950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  999967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999989 */     // MIs[0] policy
     /*  999989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999999 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11692:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /* 1000002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000021 */     // GIR_Coverage, 4997,
     /* 1000021 */     GIR_EraseRootFromParent_Done,
     /* 1000022 */   // Label 14893: @1000022
     /* 1000022 */   GIM_Try, /*On fail goto*//*Label 14894*/ GIMT_Encode4(1000099), // Rule ID 5000 //
     /* 1000027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1000038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1000041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000066 */     // MIs[0] policy
     /* 1000066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11692:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /* 1000079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000098 */     // GIR_Coverage, 5000,
     /* 1000098 */     GIR_EraseRootFromParent_Done,
     /* 1000099 */   // Label 14894: @1000099
     /* 1000099 */   GIM_Try, /*On fail goto*//*Label 14895*/ GIMT_Encode4(1000176), // Rule ID 5001 //
     /* 1000104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1000115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1000118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000143 */     // MIs[0] policy
     /* 1000143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000153 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11692:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /* 1000156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000162 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000175 */     // GIR_Coverage, 5001,
     /* 1000175 */     GIR_EraseRootFromParent_Done,
     /* 1000176 */   // Label 14895: @1000176
     /* 1000176 */   GIM_Try, /*On fail goto*//*Label 14896*/ GIMT_Encode4(1000253), // Rule ID 5004 //
     /* 1000181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1000192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1000195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000220 */     // MIs[0] policy
     /* 1000220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000230 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11692:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /* 1000233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000252 */     // GIR_Coverage, 5004,
     /* 1000252 */     GIR_EraseRootFromParent_Done,
     /* 1000253 */   // Label 14896: @1000253
     /* 1000253 */   GIM_Try, /*On fail goto*//*Label 14897*/ GIMT_Encode4(1000330), // Rule ID 5005 //
     /* 1000258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1000269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1000272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000297 */     // MIs[0] policy
     /* 1000297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000307 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11692:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /* 1000310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000329 */     // GIR_Coverage, 5005,
     /* 1000329 */     GIR_EraseRootFromParent_Done,
     /* 1000330 */   // Label 14897: @1000330
     /* 1000330 */   GIM_Try, /*On fail goto*//*Label 14898*/ GIMT_Encode4(1000407), // Rule ID 5008 //
     /* 1000335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1000346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1000349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000374 */     // MIs[0] policy
     /* 1000374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000384 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11692:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /* 1000387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000406 */     // GIR_Coverage, 5008,
     /* 1000406 */     GIR_EraseRootFromParent_Done,
     /* 1000407 */   // Label 14898: @1000407
     /* 1000407 */   GIM_Try, /*On fail goto*//*Label 14899*/ GIMT_Encode4(1000484), // Rule ID 5009 //
     /* 1000412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1000423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1000426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000451 */     // MIs[0] policy
     /* 1000451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000461 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11692:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /* 1000464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000470 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000483 */     // GIR_Coverage, 5009,
     /* 1000483 */     GIR_EraseRootFromParent_Done,
     /* 1000484 */   // Label 14899: @1000484
     /* 1000484 */   GIM_Try, /*On fail goto*//*Label 14900*/ GIMT_Encode4(1000561), // Rule ID 5012 //
     /* 1000489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1000500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1000503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000528 */     // MIs[0] policy
     /* 1000528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000538 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1000541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000547 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000560 */     // GIR_Coverage, 5012,
     /* 1000560 */     GIR_EraseRootFromParent_Done,
     /* 1000561 */   // Label 14900: @1000561
     /* 1000561 */   GIM_Try, /*On fail goto*//*Label 14901*/ GIMT_Encode4(1000638), // Rule ID 5013 //
     /* 1000566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1000577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1000580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000605 */     // MIs[0] policy
     /* 1000605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000615 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1000618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000624 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000637 */     // GIR_Coverage, 5013,
     /* 1000637 */     GIR_EraseRootFromParent_Done,
     /* 1000638 */   // Label 14901: @1000638
     /* 1000638 */   GIM_Try, /*On fail goto*//*Label 14902*/ GIMT_Encode4(1000715), // Rule ID 5016 //
     /* 1000643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1000654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1000657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000682 */     // MIs[0] policy
     /* 1000682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000692 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1000695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000714 */     // GIR_Coverage, 5016,
     /* 1000714 */     GIR_EraseRootFromParent_Done,
     /* 1000715 */   // Label 14902: @1000715
     /* 1000715 */   GIM_Try, /*On fail goto*//*Label 14903*/ GIMT_Encode4(1000792), // Rule ID 5017 //
     /* 1000720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1000731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1000734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000759 */     // MIs[0] policy
     /* 1000759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000769 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1000772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000778 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000791 */     // GIR_Coverage, 5017,
     /* 1000791 */     GIR_EraseRootFromParent_Done,
     /* 1000792 */   // Label 14903: @1000792
     /* 1000792 */   GIM_Try, /*On fail goto*//*Label 14904*/ GIMT_Encode4(1000869), // Rule ID 5020 //
     /* 1000797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1000808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1000811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000836 */     // MIs[0] policy
     /* 1000836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000846 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1000849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000868 */     // GIR_Coverage, 5020,
     /* 1000868 */     GIR_EraseRootFromParent_Done,
     /* 1000869 */   // Label 14904: @1000869
     /* 1000869 */   GIM_Try, /*On fail goto*//*Label 14905*/ GIMT_Encode4(1000946), // Rule ID 5021 //
     /* 1000874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1000885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1000888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000913 */     // MIs[0] policy
     /* 1000913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000923 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1000926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000932 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000945 */     // GIR_Coverage, 5021,
     /* 1000945 */     GIR_EraseRootFromParent_Done,
     /* 1000946 */   // Label 14905: @1000946
     /* 1000946 */   GIM_Try, /*On fail goto*//*Label 14906*/ GIMT_Encode4(1001023), // Rule ID 5024 //
     /* 1000951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1000962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1000965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000990 */     // MIs[0] policy
     /* 1000990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001000 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11555:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001022 */     // GIR_Coverage, 5024,
     /* 1001022 */     GIR_EraseRootFromParent_Done,
     /* 1001023 */   // Label 14906: @1001023
     /* 1001023 */   GIM_Try, /*On fail goto*//*Label 14907*/ GIMT_Encode4(1001100), // Rule ID 5025 //
     /* 1001028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1001039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1001042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1001045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001067 */     // MIs[0] policy
     /* 1001067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11555:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001099 */     // GIR_Coverage, 5025,
     /* 1001099 */     GIR_EraseRootFromParent_Done,
     /* 1001100 */   // Label 14907: @1001100
     /* 1001100 */   GIM_Try, /*On fail goto*//*Label 14908*/ GIMT_Encode4(1001177), // Rule ID 5028 //
     /* 1001105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1001116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1001119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1001122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001144 */     // MIs[0] policy
     /* 1001144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001154 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11555:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1001157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001176 */     // GIR_Coverage, 5028,
     /* 1001176 */     GIR_EraseRootFromParent_Done,
     /* 1001177 */   // Label 14908: @1001177
     /* 1001177 */   GIM_Try, /*On fail goto*//*Label 14909*/ GIMT_Encode4(1001254), // Rule ID 5029 //
     /* 1001182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1001193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1001196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1001199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001221 */     // MIs[0] policy
     /* 1001221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001231 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11555:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1001234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001240 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001253 */     // GIR_Coverage, 5029,
     /* 1001253 */     GIR_EraseRootFromParent_Done,
     /* 1001254 */   // Label 14909: @1001254
     /* 1001254 */   GIM_Try, /*On fail goto*//*Label 14910*/ GIMT_Encode4(1001331), // Rule ID 5032 //
     /* 1001259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1001270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1001273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1001276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1001279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001298 */     // MIs[0] policy
     /* 1001298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001308 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11555:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1001311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001330 */     // GIR_Coverage, 5032,
     /* 1001330 */     GIR_EraseRootFromParent_Done,
     /* 1001331 */   // Label 14910: @1001331
     /* 1001331 */   GIM_Try, /*On fail goto*//*Label 14911*/ GIMT_Encode4(1001408), // Rule ID 5033 //
     /* 1001336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1001347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1001350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1001353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1001356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001375 */     // MIs[0] policy
     /* 1001375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001385 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11555:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1001388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001394 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001407 */     // GIR_Coverage, 5033,
     /* 1001407 */     GIR_EraseRootFromParent_Done,
     /* 1001408 */   // Label 14911: @1001408
     /* 1001408 */   GIM_Try, /*On fail goto*//*Label 14912*/ GIMT_Encode4(1001485), // Rule ID 5036 //
     /* 1001413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1001424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1001427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1001430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001452 */     // MIs[0] policy
     /* 1001452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001462 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1001465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001484 */     // GIR_Coverage, 5036,
     /* 1001484 */     GIR_EraseRootFromParent_Done,
     /* 1001485 */   // Label 14912: @1001485
     /* 1001485 */   GIM_Try, /*On fail goto*//*Label 14913*/ GIMT_Encode4(1001562), // Rule ID 5037 //
     /* 1001490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1001501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1001504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1001507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001529 */     // MIs[0] policy
     /* 1001529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001539 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1001542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001561 */     // GIR_Coverage, 5037,
     /* 1001561 */     GIR_EraseRootFromParent_Done,
     /* 1001562 */   // Label 14913: @1001562
     /* 1001562 */   GIM_Try, /*On fail goto*//*Label 14914*/ GIMT_Encode4(1001639), // Rule ID 5040 //
     /* 1001567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1001578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1001581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1001584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001606 */     // MIs[0] policy
     /* 1001606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001616 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1001619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001638 */     // GIR_Coverage, 5040,
     /* 1001638 */     GIR_EraseRootFromParent_Done,
     /* 1001639 */   // Label 14914: @1001639
     /* 1001639 */   GIM_Try, /*On fail goto*//*Label 14915*/ GIMT_Encode4(1001716), // Rule ID 5041 //
     /* 1001644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1001655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1001658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1001661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001683 */     // MIs[0] policy
     /* 1001683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001693 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1001696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001702 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001715 */     // GIR_Coverage, 5041,
     /* 1001715 */     GIR_EraseRootFromParent_Done,
     /* 1001716 */   // Label 14915: @1001716
     /* 1001716 */   GIM_Try, /*On fail goto*//*Label 14916*/ GIMT_Encode4(1001793), // Rule ID 5044 //
     /* 1001721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1001732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1001735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1001738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001760 */     // MIs[0] policy
     /* 1001760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11555:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001792 */     // GIR_Coverage, 5044,
     /* 1001792 */     GIR_EraseRootFromParent_Done,
     /* 1001793 */   // Label 14916: @1001793
     /* 1001793 */   GIM_Try, /*On fail goto*//*Label 14917*/ GIMT_Encode4(1001870), // Rule ID 5045 //
     /* 1001798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1001809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1001812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1001815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001837 */     // MIs[0] policy
     /* 1001837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001847 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11555:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001856 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001869 */     // GIR_Coverage, 5045,
     /* 1001869 */     GIR_EraseRootFromParent_Done,
     /* 1001870 */   // Label 14917: @1001870
     /* 1001870 */   GIM_Try, /*On fail goto*//*Label 14918*/ GIMT_Encode4(1001947), // Rule ID 5048 //
     /* 1001875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1001886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1001889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1001892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001914 */     // MIs[0] policy
     /* 1001914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001924 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11555:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1001927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001946 */     // GIR_Coverage, 5048,
     /* 1001946 */     GIR_EraseRootFromParent_Done,
     /* 1001947 */   // Label 14918: @1001947
     /* 1001947 */   GIM_Try, /*On fail goto*//*Label 14919*/ GIMT_Encode4(1002024), // Rule ID 5049 //
     /* 1001952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1001963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1001966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1001969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001991 */     // MIs[0] policy
     /* 1001991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002001 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11555:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1002004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002010 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002023 */     // GIR_Coverage, 5049,
     /* 1002023 */     GIR_EraseRootFromParent_Done,
     /* 1002024 */   // Label 14919: @1002024
     /* 1002024 */   GIM_Try, /*On fail goto*//*Label 14920*/ GIMT_Encode4(1002101), // Rule ID 5052 //
     /* 1002029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1002040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1002043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1002046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1002049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002068 */     // MIs[0] policy
     /* 1002068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002078 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11555:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002100 */     // GIR_Coverage, 5052,
     /* 1002100 */     GIR_EraseRootFromParent_Done,
     /* 1002101 */   // Label 14920: @1002101
     /* 1002101 */   GIM_Try, /*On fail goto*//*Label 14921*/ GIMT_Encode4(1002178), // Rule ID 5053 //
     /* 1002106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1002117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1002120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1002123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1002126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002145 */     // MIs[0] policy
     /* 1002145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002155 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11555:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002164 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002177 */     // GIR_Coverage, 5053,
     /* 1002177 */     GIR_EraseRootFromParent_Done,
     /* 1002178 */   // Label 14921: @1002178
     /* 1002178 */   GIM_Try, /*On fail goto*//*Label 14922*/ GIMT_Encode4(1002255), // Rule ID 5056 //
     /* 1002183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1002194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1002197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1002200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002222 */     // MIs[0] policy
     /* 1002222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002232 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1002235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002254 */     // GIR_Coverage, 5056,
     /* 1002254 */     GIR_EraseRootFromParent_Done,
     /* 1002255 */   // Label 14922: @1002255
     /* 1002255 */   GIM_Try, /*On fail goto*//*Label 14923*/ GIMT_Encode4(1002332), // Rule ID 5057 //
     /* 1002260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1002271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1002274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1002277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002299 */     // MIs[0] policy
     /* 1002299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002309 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1002312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002318 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002331 */     // GIR_Coverage, 5057,
     /* 1002331 */     GIR_EraseRootFromParent_Done,
     /* 1002332 */   // Label 14923: @1002332
     /* 1002332 */   GIM_Try, /*On fail goto*//*Label 14924*/ GIMT_Encode4(1002409), // Rule ID 5060 //
     /* 1002337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1002348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1002351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1002354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002376 */     // MIs[0] policy
     /* 1002376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11555:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1002389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002408 */     // GIR_Coverage, 5060,
     /* 1002408 */     GIR_EraseRootFromParent_Done,
     /* 1002409 */   // Label 14924: @1002409
     /* 1002409 */   GIM_Try, /*On fail goto*//*Label 14925*/ GIMT_Encode4(1002486), // Rule ID 5061 //
     /* 1002414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1002425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1002428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1002431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002453 */     // MIs[0] policy
     /* 1002453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002463 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11555:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1002466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002472 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002485 */     // GIR_Coverage, 5061,
     /* 1002485 */     GIR_EraseRootFromParent_Done,
     /* 1002486 */   // Label 14925: @1002486
     /* 1002486 */   GIM_Try, /*On fail goto*//*Label 14926*/ GIMT_Encode4(1002563), // Rule ID 5064 //
     /* 1002491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1002502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1002505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1002508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002530 */     // MIs[0] policy
     /* 1002530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002540 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11555:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1002543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002562 */     // GIR_Coverage, 5064,
     /* 1002562 */     GIR_EraseRootFromParent_Done,
     /* 1002563 */   // Label 14926: @1002563
     /* 1002563 */   GIM_Try, /*On fail goto*//*Label 14927*/ GIMT_Encode4(1002640), // Rule ID 5065 //
     /* 1002568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1002579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1002582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1002585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002607 */     // MIs[0] policy
     /* 1002607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002617 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11555:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1002620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002639 */     // GIR_Coverage, 5065,
     /* 1002639 */     GIR_EraseRootFromParent_Done,
     /* 1002640 */   // Label 14927: @1002640
     /* 1002640 */   GIM_Try, /*On fail goto*//*Label 14928*/ GIMT_Encode4(1002717), // Rule ID 5068 //
     /* 1002645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1002656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1002659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1002662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002684 */     // MIs[0] policy
     /* 1002684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11555:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002716 */     // GIR_Coverage, 5068,
     /* 1002716 */     GIR_EraseRootFromParent_Done,
     /* 1002717 */   // Label 14928: @1002717
     /* 1002717 */   GIM_Try, /*On fail goto*//*Label 14929*/ GIMT_Encode4(1002794), // Rule ID 5069 //
     /* 1002722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1002733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1002736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1002739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002761 */     // MIs[0] policy
     /* 1002761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002771 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11555:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002793 */     // GIR_Coverage, 5069,
     /* 1002793 */     GIR_EraseRootFromParent_Done,
     /* 1002794 */   // Label 14929: @1002794
     /* 1002794 */   GIM_Try, /*On fail goto*//*Label 14930*/ GIMT_Encode4(1002871), // Rule ID 5072 //
     /* 1002799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1002810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1002813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1002816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002838 */     // MIs[0] policy
     /* 1002838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002848 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1002851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002870 */     // GIR_Coverage, 5072,
     /* 1002870 */     GIR_EraseRootFromParent_Done,
     /* 1002871 */   // Label 14930: @1002871
     /* 1002871 */   GIM_Try, /*On fail goto*//*Label 14931*/ GIMT_Encode4(1002948), // Rule ID 5073 //
     /* 1002876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1002887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1002890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1002893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002915 */     // MIs[0] policy
     /* 1002915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002925 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1002928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002934 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002947 */     // GIR_Coverage, 5073,
     /* 1002947 */     GIR_EraseRootFromParent_Done,
     /* 1002948 */   // Label 14931: @1002948
     /* 1002948 */   GIM_Try, /*On fail goto*//*Label 14932*/ GIMT_Encode4(1003025), // Rule ID 5076 //
     /* 1002953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1002964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1002967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1002970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002992 */     // MIs[0] policy
     /* 1002992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1003005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003024 */     // GIR_Coverage, 5076,
     /* 1003024 */     GIR_EraseRootFromParent_Done,
     /* 1003025 */   // Label 14932: @1003025
     /* 1003025 */   GIM_Try, /*On fail goto*//*Label 14933*/ GIMT_Encode4(1003102), // Rule ID 5077 //
     /* 1003030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1003041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1003044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1003047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003069 */     // MIs[0] policy
     /* 1003069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003079 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1003082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003088 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003101 */     // GIR_Coverage, 5077,
     /* 1003101 */     GIR_EraseRootFromParent_Done,
     /* 1003102 */   // Label 14933: @1003102
     /* 1003102 */   GIM_Try, /*On fail goto*//*Label 14934*/ GIMT_Encode4(1003179), // Rule ID 5080 //
     /* 1003107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1003118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1003121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1003124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003146 */     // MIs[0] policy
     /* 1003146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11555:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003178 */     // GIR_Coverage, 5080,
     /* 1003178 */     GIR_EraseRootFromParent_Done,
     /* 1003179 */   // Label 14934: @1003179
     /* 1003179 */   GIM_Try, /*On fail goto*//*Label 14935*/ GIMT_Encode4(1003256), // Rule ID 5081 //
     /* 1003184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1003195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1003198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1003201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003223 */     // MIs[0] policy
     /* 1003223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003233 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11555:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003242 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003255 */     // GIR_Coverage, 5081,
     /* 1003255 */     GIR_EraseRootFromParent_Done,
     /* 1003256 */   // Label 14935: @1003256
     /* 1003256 */   GIM_Try, /*On fail goto*//*Label 14936*/ GIMT_Encode4(1003333), // Rule ID 5084 //
     /* 1003261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1003272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1003275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1003278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003300 */     // MIs[0] policy
     /* 1003300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003310 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11555:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1003313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003332 */     // GIR_Coverage, 5084,
     /* 1003332 */     GIR_EraseRootFromParent_Done,
     /* 1003333 */   // Label 14936: @1003333
     /* 1003333 */   GIM_Try, /*On fail goto*//*Label 14937*/ GIMT_Encode4(1003410), // Rule ID 5085 //
     /* 1003338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1003349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1003352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1003355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003377 */     // MIs[0] policy
     /* 1003377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003387 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11555:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1003390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003396 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003409 */     // GIR_Coverage, 5085,
     /* 1003409 */     GIR_EraseRootFromParent_Done,
     /* 1003410 */   // Label 14937: @1003410
     /* 1003410 */   GIM_Try, /*On fail goto*//*Label 14938*/ GIMT_Encode4(1003487), // Rule ID 5088 //
     /* 1003415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1003426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1003429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1003432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1003435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003454 */     // MIs[0] policy
     /* 1003454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11555:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1003467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003486 */     // GIR_Coverage, 5088,
     /* 1003486 */     GIR_EraseRootFromParent_Done,
     /* 1003487 */   // Label 14938: @1003487
     /* 1003487 */   GIM_Try, /*On fail goto*//*Label 14939*/ GIMT_Encode4(1003564), // Rule ID 5089 //
     /* 1003492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1003503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1003506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1003509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1003512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003531 */     // MIs[0] policy
     /* 1003531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003541 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11555:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1003544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003550 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003563 */     // GIR_Coverage, 5089,
     /* 1003563 */     GIR_EraseRootFromParent_Done,
     /* 1003564 */   // Label 14939: @1003564
     /* 1003564 */   GIM_Try, /*On fail goto*//*Label 14940*/ GIMT_Encode4(1003641), // Rule ID 5092 //
     /* 1003569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1003586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003608 */     // MIs[0] policy
     /* 1003608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003618 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1003621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003640 */     // GIR_Coverage, 5092,
     /* 1003640 */     GIR_EraseRootFromParent_Done,
     /* 1003641 */   // Label 14940: @1003641
     /* 1003641 */   GIM_Try, /*On fail goto*//*Label 14941*/ GIMT_Encode4(1003718), // Rule ID 5093 //
     /* 1003646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1003663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003685 */     // MIs[0] policy
     /* 1003685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003695 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1003698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003717 */     // GIR_Coverage, 5093,
     /* 1003717 */     GIR_EraseRootFromParent_Done,
     /* 1003718 */   // Label 14941: @1003718
     /* 1003718 */   GIM_Try, /*On fail goto*//*Label 14942*/ GIMT_Encode4(1003795), // Rule ID 5096 //
     /* 1003723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1003740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003762 */     // MIs[0] policy
     /* 1003762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003772 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11555:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003794 */     // GIR_Coverage, 5096,
     /* 1003794 */     GIR_EraseRootFromParent_Done,
     /* 1003795 */   // Label 14942: @1003795
     /* 1003795 */   GIM_Try, /*On fail goto*//*Label 14943*/ GIMT_Encode4(1003872), // Rule ID 5097 //
     /* 1003800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1003817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003839 */     // MIs[0] policy
     /* 1003839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11555:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003858 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003871 */     // GIR_Coverage, 5097,
     /* 1003871 */     GIR_EraseRootFromParent_Done,
     /* 1003872 */   // Label 14943: @1003872
     /* 1003872 */   GIM_Try, /*On fail goto*//*Label 14944*/ GIMT_Encode4(1003949), // Rule ID 5100 //
     /* 1003877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1003888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1003891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1003894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003916 */     // MIs[0] policy
     /* 1003916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003926 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11555:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1003929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003948 */     // GIR_Coverage, 5100,
     /* 1003948 */     GIR_EraseRootFromParent_Done,
     /* 1003949 */   // Label 14944: @1003949
     /* 1003949 */   GIM_Try, /*On fail goto*//*Label 14945*/ GIMT_Encode4(1004026), // Rule ID 5101 //
     /* 1003954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1003965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1003968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1003971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003993 */     // MIs[0] policy
     /* 1003993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004003 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11555:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1004006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004012 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004025 */     // GIR_Coverage, 5101,
     /* 1004025 */     GIR_EraseRootFromParent_Done,
     /* 1004026 */   // Label 14945: @1004026
     /* 1004026 */   GIM_Try, /*On fail goto*//*Label 14946*/ GIMT_Encode4(1004103), // Rule ID 5104 //
     /* 1004031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1004048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004070 */     // MIs[0] policy
     /* 1004070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004080 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11555:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1004083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004102 */     // GIR_Coverage, 5104,
     /* 1004102 */     GIR_EraseRootFromParent_Done,
     /* 1004103 */   // Label 14946: @1004103
     /* 1004103 */   GIM_Try, /*On fail goto*//*Label 14947*/ GIMT_Encode4(1004180), // Rule ID 5105 //
     /* 1004108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1004125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004147 */     // MIs[0] policy
     /* 1004147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004157 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11555:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1004160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004179 */     // GIR_Coverage, 5105,
     /* 1004179 */     GIR_EraseRootFromParent_Done,
     /* 1004180 */   // Label 14947: @1004180
     /* 1004180 */   GIM_Try, /*On fail goto*//*Label 14948*/ GIMT_Encode4(1004257), // Rule ID 5108 //
     /* 1004185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1004196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1004199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1004202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004224 */     // MIs[0] policy
     /* 1004224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004234 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1004237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004256 */     // GIR_Coverage, 5108,
     /* 1004256 */     GIR_EraseRootFromParent_Done,
     /* 1004257 */   // Label 14948: @1004257
     /* 1004257 */   GIM_Try, /*On fail goto*//*Label 14949*/ GIMT_Encode4(1004334), // Rule ID 5109 //
     /* 1004262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1004273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1004276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1004279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004301 */     // MIs[0] policy
     /* 1004301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004311 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1004314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004320 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004333 */     // GIR_Coverage, 5109,
     /* 1004333 */     GIR_EraseRootFromParent_Done,
     /* 1004334 */   // Label 14949: @1004334
     /* 1004334 */   GIM_Try, /*On fail goto*//*Label 14950*/ GIMT_Encode4(1004411), // Rule ID 5112 //
     /* 1004339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1004350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1004353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004378 */     // MIs[0] policy
     /* 1004378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004388 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11555:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1004391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004410 */     // GIR_Coverage, 5112,
     /* 1004410 */     GIR_EraseRootFromParent_Done,
     /* 1004411 */   // Label 14950: @1004411
     /* 1004411 */   GIM_Try, /*On fail goto*//*Label 14951*/ GIMT_Encode4(1004488), // Rule ID 5113 //
     /* 1004416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1004427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1004430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004455 */     // MIs[0] policy
     /* 1004455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004465 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11555:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1004468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004474 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004487 */     // GIR_Coverage, 5113,
     /* 1004487 */     GIR_EraseRootFromParent_Done,
     /* 1004488 */   // Label 14951: @1004488
     /* 1004488 */   GIM_Try, /*On fail goto*//*Label 14952*/ GIMT_Encode4(1004565), // Rule ID 5116 //
     /* 1004493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004532 */     // MIs[0] policy
     /* 1004532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004542 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11555:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1004545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004564 */     // GIR_Coverage, 5116,
     /* 1004564 */     GIR_EraseRootFromParent_Done,
     /* 1004565 */   // Label 14952: @1004565
     /* 1004565 */   GIM_Try, /*On fail goto*//*Label 14953*/ GIMT_Encode4(1004642), // Rule ID 5117 //
     /* 1004570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004609 */     // MIs[0] policy
     /* 1004609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004619 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11555:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1004622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004641 */     // GIR_Coverage, 5117,
     /* 1004641 */     GIR_EraseRootFromParent_Done,
     /* 1004642 */   // Label 14953: @1004642
     /* 1004642 */   GIM_Try, /*On fail goto*//*Label 14954*/ GIMT_Encode4(1004719), // Rule ID 5120 //
     /* 1004647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004686 */     // MIs[0] policy
     /* 1004686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004696 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11555:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1004699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004718 */     // GIR_Coverage, 5120,
     /* 1004718 */     GIR_EraseRootFromParent_Done,
     /* 1004719 */   // Label 14954: @1004719
     /* 1004719 */   GIM_Try, /*On fail goto*//*Label 14955*/ GIMT_Encode4(1004796), // Rule ID 5121 //
     /* 1004724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004763 */     // MIs[0] policy
     /* 1004763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004773 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11555:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1004776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004782 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004795 */     // GIR_Coverage, 5121,
     /* 1004795 */     GIR_EraseRootFromParent_Done,
     /* 1004796 */   // Label 14955: @1004796
     /* 1004796 */   GIM_Try, /*On fail goto*//*Label 14956*/ GIMT_Encode4(1004873), // Rule ID 12732 //
     /* 1004801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1004812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1004815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1004821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004840 */     // MIs[0] policy
     /* 1004840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004850 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1004853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1004859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1004861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1004869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004872 */     // GIR_Coverage, 12732,
     /* 1004872 */     GIR_EraseRootFromParent_Done,
     /* 1004873 */   // Label 14956: @1004873
     /* 1004873 */   GIM_Try, /*On fail goto*//*Label 14957*/ GIMT_Encode4(1004950), // Rule ID 12733 //
     /* 1004878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1004889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1004892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1004898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004917 */     // MIs[0] policy
     /* 1004917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004927 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1004930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1004936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1004938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1004946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004949 */     // GIR_Coverage, 12733,
     /* 1004949 */     GIR_EraseRootFromParent_Done,
     /* 1004950 */   // Label 14957: @1004950
     /* 1004950 */   GIM_Try, /*On fail goto*//*Label 14958*/ GIMT_Encode4(1005027), // Rule ID 12736 //
     /* 1004955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1004966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1004969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1004975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004994 */     // MIs[0] policy
     /* 1004994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005004 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005026 */     // GIR_Coverage, 12736,
     /* 1005026 */     GIR_EraseRootFromParent_Done,
     /* 1005027 */   // Label 14958: @1005027
     /* 1005027 */   GIM_Try, /*On fail goto*//*Label 14959*/ GIMT_Encode4(1005104), // Rule ID 12737 //
     /* 1005032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1005043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1005046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1005049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1005052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005071 */     // MIs[0] policy
     /* 1005071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005081 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005103 */     // GIR_Coverage, 12737,
     /* 1005103 */     GIR_EraseRootFromParent_Done,
     /* 1005104 */   // Label 14959: @1005104
     /* 1005104 */   GIM_Try, /*On fail goto*//*Label 14960*/ GIMT_Encode4(1005181), // Rule ID 12740 //
     /* 1005109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1005120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1005123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1005126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1005129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005148 */     // MIs[0] policy
     /* 1005148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005158 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1005161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005180 */     // GIR_Coverage, 12740,
     /* 1005180 */     GIR_EraseRootFromParent_Done,
     /* 1005181 */   // Label 14960: @1005181
     /* 1005181 */   GIM_Try, /*On fail goto*//*Label 14961*/ GIMT_Encode4(1005258), // Rule ID 12741 //
     /* 1005186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1005197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1005200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1005203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1005206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005225 */     // MIs[0] policy
     /* 1005225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005235 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1005238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005257 */     // GIR_Coverage, 12741,
     /* 1005257 */     GIR_EraseRootFromParent_Done,
     /* 1005258 */   // Label 14961: @1005258
     /* 1005258 */   GIM_Try, /*On fail goto*//*Label 14962*/ GIMT_Encode4(1005335), // Rule ID 12744 //
     /* 1005263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1005274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1005277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1005280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1005283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005302 */     // MIs[0] policy
     /* 1005302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005312 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005334 */     // GIR_Coverage, 12744,
     /* 1005334 */     GIR_EraseRootFromParent_Done,
     /* 1005335 */   // Label 14962: @1005335
     /* 1005335 */   GIM_Try, /*On fail goto*//*Label 14963*/ GIMT_Encode4(1005412), // Rule ID 12745 //
     /* 1005340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1005351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1005354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1005357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1005360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005379 */     // MIs[0] policy
     /* 1005379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005389 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005411 */     // GIR_Coverage, 12745,
     /* 1005411 */     GIR_EraseRootFromParent_Done,
     /* 1005412 */   // Label 14963: @1005412
     /* 1005412 */   GIM_Try, /*On fail goto*//*Label 14964*/ GIMT_Encode4(1005489), // Rule ID 12748 //
     /* 1005417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1005428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1005431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1005434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1005437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005456 */     // MIs[0] policy
     /* 1005456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005488 */     // GIR_Coverage, 12748,
     /* 1005488 */     GIR_EraseRootFromParent_Done,
     /* 1005489 */   // Label 14964: @1005489
     /* 1005489 */   GIM_Try, /*On fail goto*//*Label 14965*/ GIMT_Encode4(1005566), // Rule ID 12749 //
     /* 1005494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1005505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1005508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1005511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1005514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005533 */     // MIs[0] policy
     /* 1005533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005543 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005565 */     // GIR_Coverage, 12749,
     /* 1005565 */     GIR_EraseRootFromParent_Done,
     /* 1005566 */   // Label 14965: @1005566
     /* 1005566 */   GIM_Try, /*On fail goto*//*Label 14966*/ GIMT_Encode4(1005643), // Rule ID 12752 //
     /* 1005571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1005582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1005585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1005588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1005591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005610 */     // MIs[0] policy
     /* 1005610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005620 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005642 */     // GIR_Coverage, 12752,
     /* 1005642 */     GIR_EraseRootFromParent_Done,
     /* 1005643 */   // Label 14966: @1005643
     /* 1005643 */   GIM_Try, /*On fail goto*//*Label 14967*/ GIMT_Encode4(1005720), // Rule ID 12753 //
     /* 1005648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1005659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1005662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1005665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1005668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005687 */     // MIs[0] policy
     /* 1005687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005697 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005719 */     // GIR_Coverage, 12753,
     /* 1005719 */     GIR_EraseRootFromParent_Done,
     /* 1005720 */   // Label 14967: @1005720
     /* 1005720 */   GIM_Try, /*On fail goto*//*Label 14968*/ GIMT_Encode4(1005797), // Rule ID 12756 //
     /* 1005725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1005736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1005739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1005742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1005745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005764 */     // MIs[0] policy
     /* 1005764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005774 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005796 */     // GIR_Coverage, 12756,
     /* 1005796 */     GIR_EraseRootFromParent_Done,
     /* 1005797 */   // Label 14968: @1005797
     /* 1005797 */   GIM_Try, /*On fail goto*//*Label 14969*/ GIMT_Encode4(1005874), // Rule ID 12757 //
     /* 1005802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1005813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1005816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1005819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1005822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005841 */     // MIs[0] policy
     /* 1005841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005851 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005873 */     // GIR_Coverage, 12757,
     /* 1005873 */     GIR_EraseRootFromParent_Done,
     /* 1005874 */   // Label 14969: @1005874
     /* 1005874 */   GIM_Try, /*On fail goto*//*Label 14970*/ GIMT_Encode4(1005951), // Rule ID 12760 //
     /* 1005879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1005890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1005893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1005896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1005899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005918 */     // MIs[0] policy
     /* 1005918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005928 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005950 */     // GIR_Coverage, 12760,
     /* 1005950 */     GIR_EraseRootFromParent_Done,
     /* 1005951 */   // Label 14970: @1005951
     /* 1005951 */   GIM_Try, /*On fail goto*//*Label 14971*/ GIMT_Encode4(1006028), // Rule ID 12761 //
     /* 1005956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1005967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1005970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1005973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1005976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005995 */     // MIs[0] policy
     /* 1005995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006005 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006027 */     // GIR_Coverage, 12761,
     /* 1006027 */     GIR_EraseRootFromParent_Done,
     /* 1006028 */   // Label 14971: @1006028
     /* 1006028 */   GIM_Try, /*On fail goto*//*Label 14972*/ GIMT_Encode4(1006105), // Rule ID 12764 //
     /* 1006033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1006036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1006044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1006047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1006050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1006053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006072 */     // MIs[0] policy
     /* 1006072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006104 */     // GIR_Coverage, 12764,
     /* 1006104 */     GIR_EraseRootFromParent_Done,
     /* 1006105 */   // Label 14972: @1006105
     /* 1006105 */   GIM_Try, /*On fail goto*//*Label 14973*/ GIMT_Encode4(1006182), // Rule ID 12765 //
     /* 1006110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1006113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1006121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1006124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1006127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1006130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006149 */     // MIs[0] policy
     /* 1006149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006159 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006181 */     // GIR_Coverage, 12765,
     /* 1006181 */     GIR_EraseRootFromParent_Done,
     /* 1006182 */   // Label 14973: @1006182
     /* 1006182 */   GIM_Try, /*On fail goto*//*Label 14974*/ GIMT_Encode4(1006259), // Rule ID 12768 //
     /* 1006187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1006198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1006201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1006204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1006207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006226 */     // MIs[0] policy
     /* 1006226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006236 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006258 */     // GIR_Coverage, 12768,
     /* 1006258 */     GIR_EraseRootFromParent_Done,
     /* 1006259 */   // Label 14974: @1006259
     /* 1006259 */   GIM_Try, /*On fail goto*//*Label 14975*/ GIMT_Encode4(1006336), // Rule ID 12769 //
     /* 1006264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1006275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1006278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1006281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1006284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006303 */     // MIs[0] policy
     /* 1006303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006313 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006335 */     // GIR_Coverage, 12769,
     /* 1006335 */     GIR_EraseRootFromParent_Done,
     /* 1006336 */   // Label 14975: @1006336
     /* 1006336 */   GIM_Try, /*On fail goto*//*Label 14976*/ GIMT_Encode4(1006413), // Rule ID 12772 //
     /* 1006341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1006352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1006355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1006358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1006361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006380 */     // MIs[0] policy
     /* 1006380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006390 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006412 */     // GIR_Coverage, 12772,
     /* 1006412 */     GIR_EraseRootFromParent_Done,
     /* 1006413 */   // Label 14976: @1006413
     /* 1006413 */   GIM_Try, /*On fail goto*//*Label 14977*/ GIMT_Encode4(1006490), // Rule ID 12773 //
     /* 1006418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1006429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1006432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1006435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1006438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006457 */     // MIs[0] policy
     /* 1006457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006467 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006489 */     // GIR_Coverage, 12773,
     /* 1006489 */     GIR_EraseRootFromParent_Done,
     /* 1006490 */   // Label 14977: @1006490
     /* 1006490 */   GIM_Try, /*On fail goto*//*Label 14978*/ GIMT_Encode4(1006567), // Rule ID 12776 //
     /* 1006495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1006506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1006509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1006512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1006515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006534 */     // MIs[0] policy
     /* 1006534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006544 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1006547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006566 */     // GIR_Coverage, 12776,
     /* 1006566 */     GIR_EraseRootFromParent_Done,
     /* 1006567 */   // Label 14978: @1006567
     /* 1006567 */   GIM_Try, /*On fail goto*//*Label 14979*/ GIMT_Encode4(1006644), // Rule ID 12777 //
     /* 1006572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1006583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1006586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1006589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1006592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006611 */     // MIs[0] policy
     /* 1006611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006621 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1006624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006643 */     // GIR_Coverage, 12777,
     /* 1006643 */     GIR_EraseRootFromParent_Done,
     /* 1006644 */   // Label 14979: @1006644
     /* 1006644 */   GIM_Try, /*On fail goto*//*Label 14980*/ GIMT_Encode4(1006721), // Rule ID 12780 //
     /* 1006649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1006660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1006663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1006666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1006669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006688 */     // MIs[0] policy
     /* 1006688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006698 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006720 */     // GIR_Coverage, 12780,
     /* 1006720 */     GIR_EraseRootFromParent_Done,
     /* 1006721 */   // Label 14980: @1006721
     /* 1006721 */   GIM_Try, /*On fail goto*//*Label 14981*/ GIMT_Encode4(1006798), // Rule ID 12781 //
     /* 1006726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1006737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1006740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1006743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1006746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006765 */     // MIs[0] policy
     /* 1006765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006775 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006797 */     // GIR_Coverage, 12781,
     /* 1006797 */     GIR_EraseRootFromParent_Done,
     /* 1006798 */   // Label 14981: @1006798
     /* 1006798 */   GIM_Try, /*On fail goto*//*Label 14982*/ GIMT_Encode4(1006875), // Rule ID 12784 //
     /* 1006803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1006814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1006817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1006820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1006823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006842 */     // MIs[0] policy
     /* 1006842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006852 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006874 */     // GIR_Coverage, 12784,
     /* 1006874 */     GIR_EraseRootFromParent_Done,
     /* 1006875 */   // Label 14982: @1006875
     /* 1006875 */   GIM_Try, /*On fail goto*//*Label 14983*/ GIMT_Encode4(1006952), // Rule ID 12785 //
     /* 1006880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1006891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1006894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1006897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1006900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006919 */     // MIs[0] policy
     /* 1006919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006929 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006951 */     // GIR_Coverage, 12785,
     /* 1006951 */     GIR_EraseRootFromParent_Done,
     /* 1006952 */   // Label 14983: @1006952
     /* 1006952 */   GIM_Try, /*On fail goto*//*Label 14984*/ GIMT_Encode4(1007029), // Rule ID 12788 //
     /* 1006957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1006968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1006971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1006974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1006977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006996 */     // MIs[0] policy
     /* 1006996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007006 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007028 */     // GIR_Coverage, 12788,
     /* 1007028 */     GIR_EraseRootFromParent_Done,
     /* 1007029 */   // Label 14984: @1007029
     /* 1007029 */   GIM_Try, /*On fail goto*//*Label 14985*/ GIMT_Encode4(1007106), // Rule ID 12789 //
     /* 1007034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1007045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1007048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1007051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1007054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007073 */     // MIs[0] policy
     /* 1007073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007083 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007105 */     // GIR_Coverage, 12789,
     /* 1007105 */     GIR_EraseRootFromParent_Done,
     /* 1007106 */   // Label 14985: @1007106
     /* 1007106 */   GIM_Try, /*On fail goto*//*Label 14986*/ GIMT_Encode4(1007183), // Rule ID 12792 //
     /* 1007111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1007122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1007125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1007128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1007131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007150 */     // MIs[0] policy
     /* 1007150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007182 */     // GIR_Coverage, 12792,
     /* 1007182 */     GIR_EraseRootFromParent_Done,
     /* 1007183 */   // Label 14986: @1007183
     /* 1007183 */   GIM_Try, /*On fail goto*//*Label 14987*/ GIMT_Encode4(1007260), // Rule ID 12793 //
     /* 1007188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1007199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1007202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1007205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1007208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007227 */     // MIs[0] policy
     /* 1007227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007237 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007259 */     // GIR_Coverage, 12793,
     /* 1007259 */     GIR_EraseRootFromParent_Done,
     /* 1007260 */   // Label 14987: @1007260
     /* 1007260 */   GIM_Try, /*On fail goto*//*Label 14988*/ GIMT_Encode4(1007337), // Rule ID 12796 //
     /* 1007265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1007276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1007279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1007282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1007285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007304 */     // MIs[0] policy
     /* 1007304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007336 */     // GIR_Coverage, 12796,
     /* 1007336 */     GIR_EraseRootFromParent_Done,
     /* 1007337 */   // Label 14988: @1007337
     /* 1007337 */   GIM_Try, /*On fail goto*//*Label 14989*/ GIMT_Encode4(1007414), // Rule ID 12797 //
     /* 1007342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1007353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1007356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1007359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1007362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007381 */     // MIs[0] policy
     /* 1007381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007391 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007413 */     // GIR_Coverage, 12797,
     /* 1007413 */     GIR_EraseRootFromParent_Done,
     /* 1007414 */   // Label 14989: @1007414
     /* 1007414 */   GIM_Try, /*On fail goto*//*Label 14990*/ GIMT_Encode4(1007491), // Rule ID 12800 //
     /* 1007419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1007430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1007433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1007436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1007439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007458 */     // MIs[0] policy
     /* 1007458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007468 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007490 */     // GIR_Coverage, 12800,
     /* 1007490 */     GIR_EraseRootFromParent_Done,
     /* 1007491 */   // Label 14990: @1007491
     /* 1007491 */   GIM_Try, /*On fail goto*//*Label 14991*/ GIMT_Encode4(1007568), // Rule ID 12801 //
     /* 1007496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1007507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1007510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1007513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1007516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007535 */     // MIs[0] policy
     /* 1007535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007545 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007567 */     // GIR_Coverage, 12801,
     /* 1007567 */     GIR_EraseRootFromParent_Done,
     /* 1007568 */   // Label 14991: @1007568
     /* 1007568 */   GIM_Try, /*On fail goto*//*Label 14992*/ GIMT_Encode4(1007645), // Rule ID 12804 //
     /* 1007573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1007576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1007584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1007587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1007590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1007593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007612 */     // MIs[0] policy
     /* 1007612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007622 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007644 */     // GIR_Coverage, 12804,
     /* 1007644 */     GIR_EraseRootFromParent_Done,
     /* 1007645 */   // Label 14992: @1007645
     /* 1007645 */   GIM_Try, /*On fail goto*//*Label 14993*/ GIMT_Encode4(1007722), // Rule ID 12805 //
     /* 1007650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1007653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1007661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1007664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1007667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1007670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007689 */     // MIs[0] policy
     /* 1007689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007699 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007721 */     // GIR_Coverage, 12805,
     /* 1007721 */     GIR_EraseRootFromParent_Done,
     /* 1007722 */   // Label 14993: @1007722
     /* 1007722 */   GIM_Try, /*On fail goto*//*Label 14994*/ GIMT_Encode4(1007799), // Rule ID 12808 //
     /* 1007727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1007730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1007738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1007741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1007744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1007747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007766 */     // MIs[0] policy
     /* 1007766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007776 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007798 */     // GIR_Coverage, 12808,
     /* 1007798 */     GIR_EraseRootFromParent_Done,
     /* 1007799 */   // Label 14994: @1007799
     /* 1007799 */   GIM_Try, /*On fail goto*//*Label 14995*/ GIMT_Encode4(1007876), // Rule ID 12809 //
     /* 1007804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1007807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1007815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1007818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1007821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1007824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007843 */     // MIs[0] policy
     /* 1007843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007853 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007875 */     // GIR_Coverage, 12809,
     /* 1007875 */     GIR_EraseRootFromParent_Done,
     /* 1007876 */   // Label 14995: @1007876
     /* 1007876 */   GIM_Try, /*On fail goto*//*Label 14996*/ GIMT_Encode4(1007953), // Rule ID 12812 //
     /* 1007881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1007884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1007892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1007895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1007898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1007901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007920 */     // MIs[0] policy
     /* 1007920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007930 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007952 */     // GIR_Coverage, 12812,
     /* 1007952 */     GIR_EraseRootFromParent_Done,
     /* 1007953 */   // Label 14996: @1007953
     /* 1007953 */   GIM_Try, /*On fail goto*//*Label 14997*/ GIMT_Encode4(1008030), // Rule ID 12813 //
     /* 1007958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1007961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1007969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1007972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1007975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1007978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007997 */     // MIs[0] policy
     /* 1007997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008007 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1008010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008029 */     // GIR_Coverage, 12813,
     /* 1008029 */     GIR_EraseRootFromParent_Done,
     /* 1008030 */   // Label 14997: @1008030
     /* 1008030 */   GIM_Try, /*On fail goto*//*Label 14998*/ GIMT_Encode4(1008107), // Rule ID 12816 //
     /* 1008035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1008046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1008049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1008055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008074 */     // MIs[0] policy
     /* 1008074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008084 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1008087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008106 */     // GIR_Coverage, 12816,
     /* 1008106 */     GIR_EraseRootFromParent_Done,
     /* 1008107 */   // Label 14998: @1008107
     /* 1008107 */   GIM_Try, /*On fail goto*//*Label 14999*/ GIMT_Encode4(1008184), // Rule ID 12817 //
     /* 1008112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1008123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1008126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1008132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008151 */     // MIs[0] policy
     /* 1008151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008161 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1008164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008183 */     // GIR_Coverage, 12817,
     /* 1008183 */     GIR_EraseRootFromParent_Done,
     /* 1008184 */   // Label 14999: @1008184
     /* 1008184 */   GIM_Try, /*On fail goto*//*Label 15000*/ GIMT_Encode4(1008261), // Rule ID 12820 //
     /* 1008189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1008200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1008203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1008209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008228 */     // MIs[0] policy
     /* 1008228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008238 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008260 */     // GIR_Coverage, 12820,
     /* 1008260 */     GIR_EraseRootFromParent_Done,
     /* 1008261 */   // Label 15000: @1008261
     /* 1008261 */   GIM_Try, /*On fail goto*//*Label 15001*/ GIMT_Encode4(1008338), // Rule ID 12821 //
     /* 1008266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1008277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1008280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1008286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008305 */     // MIs[0] policy
     /* 1008305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008315 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008337 */     // GIR_Coverage, 12821,
     /* 1008337 */     GIR_EraseRootFromParent_Done,
     /* 1008338 */   // Label 15001: @1008338
     /* 1008338 */   GIM_Try, /*On fail goto*//*Label 15002*/ GIMT_Encode4(1008415), // Rule ID 12824 //
     /* 1008343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1008354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1008357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1008363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008382 */     // MIs[0] policy
     /* 1008382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008392 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008414 */     // GIR_Coverage, 12824,
     /* 1008414 */     GIR_EraseRootFromParent_Done,
     /* 1008415 */   // Label 15002: @1008415
     /* 1008415 */   GIM_Try, /*On fail goto*//*Label 15003*/ GIMT_Encode4(1008492), // Rule ID 12825 //
     /* 1008420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1008431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1008434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1008440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008459 */     // MIs[0] policy
     /* 1008459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008469 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008491 */     // GIR_Coverage, 12825,
     /* 1008491 */     GIR_EraseRootFromParent_Done,
     /* 1008492 */   // Label 15003: @1008492
     /* 1008492 */   GIM_Try, /*On fail goto*//*Label 15004*/ GIMT_Encode4(1008569), // Rule ID 12828 //
     /* 1008497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1008508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1008511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1008517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008536 */     // MIs[0] policy
     /* 1008536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008568 */     // GIR_Coverage, 12828,
     /* 1008568 */     GIR_EraseRootFromParent_Done,
     /* 1008569 */   // Label 15004: @1008569
     /* 1008569 */   GIM_Try, /*On fail goto*//*Label 15005*/ GIMT_Encode4(1008646), // Rule ID 12829 //
     /* 1008574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1008585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1008588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1008594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008613 */     // MIs[0] policy
     /* 1008613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008623 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008645 */     // GIR_Coverage, 12829,
     /* 1008645 */     GIR_EraseRootFromParent_Done,
     /* 1008646 */   // Label 15005: @1008646
     /* 1008646 */   GIM_Try, /*On fail goto*//*Label 15006*/ GIMT_Encode4(1008723), // Rule ID 12832 //
     /* 1008651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1008662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1008665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1008671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008690 */     // MIs[0] policy
     /* 1008690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008700 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008722 */     // GIR_Coverage, 12832,
     /* 1008722 */     GIR_EraseRootFromParent_Done,
     /* 1008723 */   // Label 15006: @1008723
     /* 1008723 */   GIM_Try, /*On fail goto*//*Label 15007*/ GIMT_Encode4(1008800), // Rule ID 12833 //
     /* 1008728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1008739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1008742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1008748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008767 */     // MIs[0] policy
     /* 1008767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008777 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008799 */     // GIR_Coverage, 12833,
     /* 1008799 */     GIR_EraseRootFromParent_Done,
     /* 1008800 */   // Label 15007: @1008800
     /* 1008800 */   GIM_Try, /*On fail goto*//*Label 15008*/ GIMT_Encode4(1008877), // Rule ID 12836 //
     /* 1008805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1008816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1008819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1008825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008844 */     // MIs[0] policy
     /* 1008844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008854 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008876 */     // GIR_Coverage, 12836,
     /* 1008876 */     GIR_EraseRootFromParent_Done,
     /* 1008877 */   // Label 15008: @1008877
     /* 1008877 */   GIM_Try, /*On fail goto*//*Label 15009*/ GIMT_Encode4(1008954), // Rule ID 12837 //
     /* 1008882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1008893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1008896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1008902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008921 */     // MIs[0] policy
     /* 1008921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008931 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008953 */     // GIR_Coverage, 12837,
     /* 1008953 */     GIR_EraseRootFromParent_Done,
     /* 1008954 */   // Label 15009: @1008954
     /* 1008954 */   GIM_Try, /*On fail goto*//*Label 15010*/ GIMT_Encode4(1009031), // Rule ID 12840 //
     /* 1008959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1008970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1008973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1008979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008998 */     // MIs[0] policy
     /* 1008998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009008 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009030 */     // GIR_Coverage, 12840,
     /* 1009030 */     GIR_EraseRootFromParent_Done,
     /* 1009031 */   // Label 15010: @1009031
     /* 1009031 */   GIM_Try, /*On fail goto*//*Label 15011*/ GIMT_Encode4(1009108), // Rule ID 12841 //
     /* 1009036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1009047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1009050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1009056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009075 */     // MIs[0] policy
     /* 1009075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009085 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009107 */     // GIR_Coverage, 12841,
     /* 1009107 */     GIR_EraseRootFromParent_Done,
     /* 1009108 */   // Label 15011: @1009108
     /* 1009108 */   GIM_Try, /*On fail goto*//*Label 15012*/ GIMT_Encode4(1009185), // Rule ID 12844 //
     /* 1009113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1009124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1009127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1009133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009152 */     // MIs[0] policy
     /* 1009152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009162 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009184 */     // GIR_Coverage, 12844,
     /* 1009184 */     GIR_EraseRootFromParent_Done,
     /* 1009185 */   // Label 15012: @1009185
     /* 1009185 */   GIM_Try, /*On fail goto*//*Label 15013*/ GIMT_Encode4(1009262), // Rule ID 12845 //
     /* 1009190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1009201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1009204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1009210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009229 */     // MIs[0] policy
     /* 1009229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009239 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009261 */     // GIR_Coverage, 12845,
     /* 1009261 */     GIR_EraseRootFromParent_Done,
     /* 1009262 */   // Label 15013: @1009262
     /* 1009262 */   GIM_Try, /*On fail goto*//*Label 15014*/ GIMT_Encode4(1009339), // Rule ID 12848 //
     /* 1009267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1009278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1009281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1009287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009306 */     // MIs[0] policy
     /* 1009306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009338 */     // GIR_Coverage, 12848,
     /* 1009338 */     GIR_EraseRootFromParent_Done,
     /* 1009339 */   // Label 15014: @1009339
     /* 1009339 */   GIM_Try, /*On fail goto*//*Label 15015*/ GIMT_Encode4(1009416), // Rule ID 12849 //
     /* 1009344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1009355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1009358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1009364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009383 */     // MIs[0] policy
     /* 1009383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009393 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009415 */     // GIR_Coverage, 12849,
     /* 1009415 */     GIR_EraseRootFromParent_Done,
     /* 1009416 */   // Label 15015: @1009416
     /* 1009416 */   GIM_Try, /*On fail goto*//*Label 15016*/ GIMT_Encode4(1009493), // Rule ID 12852 //
     /* 1009421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1009424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1009432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1009435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1009441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009460 */     // MIs[0] policy
     /* 1009460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1009489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009492 */     // GIR_Coverage, 12852,
     /* 1009492 */     GIR_EraseRootFromParent_Done,
     /* 1009493 */   // Label 15016: @1009493
     /* 1009493 */   GIM_Try, /*On fail goto*//*Label 15017*/ GIMT_Encode4(1009570), // Rule ID 12853 //
     /* 1009498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1009501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1009509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1009512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1009518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009537 */     // MIs[0] policy
     /* 1009537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009547 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1009566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009569 */     // GIR_Coverage, 12853,
     /* 1009569 */     GIR_EraseRootFromParent_Done,
     /* 1009570 */   // Label 15017: @1009570
     /* 1009570 */   GIM_Try, /*On fail goto*//*Label 15018*/ GIMT_Encode4(1009647), // Rule ID 12856 //
     /* 1009575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1009586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1009589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1009595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009614 */     // MIs[0] policy
     /* 1009614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009624 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1009627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009646 */     // GIR_Coverage, 12856,
     /* 1009646 */     GIR_EraseRootFromParent_Done,
     /* 1009647 */   // Label 15018: @1009647
     /* 1009647 */   GIM_Try, /*On fail goto*//*Label 15019*/ GIMT_Encode4(1009724), // Rule ID 12857 //
     /* 1009652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1009663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1009666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1009672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009691 */     // MIs[0] policy
     /* 1009691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009701 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1009704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009723 */     // GIR_Coverage, 12857,
     /* 1009723 */     GIR_EraseRootFromParent_Done,
     /* 1009724 */   // Label 15019: @1009724
     /* 1009724 */   GIM_Try, /*On fail goto*//*Label 15020*/ GIMT_Encode4(1009801), // Rule ID 12860 //
     /* 1009729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1009740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1009743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1009749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009768 */     // MIs[0] policy
     /* 1009768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009778 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1009781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009800 */     // GIR_Coverage, 12860,
     /* 1009800 */     GIR_EraseRootFromParent_Done,
     /* 1009801 */   // Label 15020: @1009801
     /* 1009801 */   GIM_Try, /*On fail goto*//*Label 15021*/ GIMT_Encode4(1009878), // Rule ID 12861 //
     /* 1009806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1009817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1009820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1009826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009845 */     // MIs[0] policy
     /* 1009845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009855 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1009858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009877 */     // GIR_Coverage, 12861,
     /* 1009877 */     GIR_EraseRootFromParent_Done,
     /* 1009878 */   // Label 15021: @1009878
     /* 1009878 */   GIM_Try, /*On fail goto*//*Label 15022*/ GIMT_Encode4(1009955), // Rule ID 12864 //
     /* 1009883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1009894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1009897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1009903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009922 */     // MIs[0] policy
     /* 1009922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009932 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1009935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009954 */     // GIR_Coverage, 12864,
     /* 1009954 */     GIR_EraseRootFromParent_Done,
     /* 1009955 */   // Label 15022: @1009955
     /* 1009955 */   GIM_Try, /*On fail goto*//*Label 15023*/ GIMT_Encode4(1010032), // Rule ID 12865 //
     /* 1009960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1009971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1009974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1009980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009999 */     // MIs[0] policy
     /* 1009999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010009 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010031 */     // GIR_Coverage, 12865,
     /* 1010031 */     GIR_EraseRootFromParent_Done,
     /* 1010032 */   // Label 15023: @1010032
     /* 1010032 */   GIM_Try, /*On fail goto*//*Label 15024*/ GIMT_Encode4(1010109), // Rule ID 12868 //
     /* 1010037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1010048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1010051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1010057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010076 */     // MIs[0] policy
     /* 1010076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010086 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010108 */     // GIR_Coverage, 12868,
     /* 1010108 */     GIR_EraseRootFromParent_Done,
     /* 1010109 */   // Label 15024: @1010109
     /* 1010109 */   GIM_Try, /*On fail goto*//*Label 15025*/ GIMT_Encode4(1010186), // Rule ID 12869 //
     /* 1010114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1010125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1010128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1010134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010153 */     // MIs[0] policy
     /* 1010153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010163 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010185 */     // GIR_Coverage, 12869,
     /* 1010185 */     GIR_EraseRootFromParent_Done,
     /* 1010186 */   // Label 15025: @1010186
     /* 1010186 */   GIM_Try, /*On fail goto*//*Label 15026*/ GIMT_Encode4(1010263), // Rule ID 12872 //
     /* 1010191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1010202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1010205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1010211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010230 */     // MIs[0] policy
     /* 1010230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010240 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010262 */     // GIR_Coverage, 12872,
     /* 1010262 */     GIR_EraseRootFromParent_Done,
     /* 1010263 */   // Label 15026: @1010263
     /* 1010263 */   GIM_Try, /*On fail goto*//*Label 15027*/ GIMT_Encode4(1010340), // Rule ID 12873 //
     /* 1010268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1010279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1010282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1010288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010307 */     // MIs[0] policy
     /* 1010307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010317 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010339 */     // GIR_Coverage, 12873,
     /* 1010339 */     GIR_EraseRootFromParent_Done,
     /* 1010340 */   // Label 15027: @1010340
     /* 1010340 */   GIM_Try, /*On fail goto*//*Label 15028*/ GIMT_Encode4(1010417), // Rule ID 12876 //
     /* 1010345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1010356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1010359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1010365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010384 */     // MIs[0] policy
     /* 1010384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010394 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010416 */     // GIR_Coverage, 12876,
     /* 1010416 */     GIR_EraseRootFromParent_Done,
     /* 1010417 */   // Label 15028: @1010417
     /* 1010417 */   GIM_Try, /*On fail goto*//*Label 15029*/ GIMT_Encode4(1010494), // Rule ID 12877 //
     /* 1010422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1010433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1010436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1010442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010461 */     // MIs[0] policy
     /* 1010461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010471 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010493 */     // GIR_Coverage, 12877,
     /* 1010493 */     GIR_EraseRootFromParent_Done,
     /* 1010494 */   // Label 15029: @1010494
     /* 1010494 */   GIM_Try, /*On fail goto*//*Label 15030*/ GIMT_Encode4(1010571), // Rule ID 12880 //
     /* 1010499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1010510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1010513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1010519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010538 */     // MIs[0] policy
     /* 1010538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010548 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010570 */     // GIR_Coverage, 12880,
     /* 1010570 */     GIR_EraseRootFromParent_Done,
     /* 1010571 */   // Label 15030: @1010571
     /* 1010571 */   GIM_Try, /*On fail goto*//*Label 15031*/ GIMT_Encode4(1010648), // Rule ID 12881 //
     /* 1010576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1010587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1010590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1010596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010615 */     // MIs[0] policy
     /* 1010615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010625 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010647 */     // GIR_Coverage, 12881,
     /* 1010647 */     GIR_EraseRootFromParent_Done,
     /* 1010648 */   // Label 15031: @1010648
     /* 1010648 */   GIM_Try, /*On fail goto*//*Label 15032*/ GIMT_Encode4(1010725), // Rule ID 12884 //
     /* 1010653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1010664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1010667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1010673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010692 */     // MIs[0] policy
     /* 1010692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010702 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010724 */     // GIR_Coverage, 12884,
     /* 1010724 */     GIR_EraseRootFromParent_Done,
     /* 1010725 */   // Label 15032: @1010725
     /* 1010725 */   GIM_Try, /*On fail goto*//*Label 15033*/ GIMT_Encode4(1010802), // Rule ID 12885 //
     /* 1010730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1010741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1010744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1010750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010769 */     // MIs[0] policy
     /* 1010769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010779 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010801 */     // GIR_Coverage, 12885,
     /* 1010801 */     GIR_EraseRootFromParent_Done,
     /* 1010802 */   // Label 15033: @1010802
     /* 1010802 */   GIM_Try, /*On fail goto*//*Label 15034*/ GIMT_Encode4(1010879), // Rule ID 12888 //
     /* 1010807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1010818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1010821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1010827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010846 */     // MIs[0] policy
     /* 1010846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010856 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010878 */     // GIR_Coverage, 12888,
     /* 1010878 */     GIR_EraseRootFromParent_Done,
     /* 1010879 */   // Label 15034: @1010879
     /* 1010879 */   GIM_Try, /*On fail goto*//*Label 15035*/ GIMT_Encode4(1010956), // Rule ID 12889 //
     /* 1010884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1010895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1010898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1010904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010923 */     // MIs[0] policy
     /* 1010923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010933 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010955 */     // GIR_Coverage, 12889,
     /* 1010955 */     GIR_EraseRootFromParent_Done,
     /* 1010956 */   // Label 15035: @1010956
     /* 1010956 */   GIM_Try, /*On fail goto*//*Label 15036*/ GIMT_Encode4(1011033), // Rule ID 12892 //
     /* 1010961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1010964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1010972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1010975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1010981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011000 */     // MIs[0] policy
     /* 1011000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1011013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011032 */     // GIR_Coverage, 12892,
     /* 1011032 */     GIR_EraseRootFromParent_Done,
     /* 1011033 */   // Label 15036: @1011033
     /* 1011033 */   GIM_Try, /*On fail goto*//*Label 15037*/ GIMT_Encode4(1011110), // Rule ID 12893 //
     /* 1011038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1011049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1011052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1011058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011077 */     // MIs[0] policy
     /* 1011077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011087 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1011090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011109 */     // GIR_Coverage, 12893,
     /* 1011109 */     GIR_EraseRootFromParent_Done,
     /* 1011110 */   // Label 15037: @1011110
     /* 1011110 */   GIM_Try, /*On fail goto*//*Label 15038*/ GIMT_Encode4(1011187), // Rule ID 12896 //
     /* 1011115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1011126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1011129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1011135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011154 */     // MIs[0] policy
     /* 1011154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011164 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1011167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011186 */     // GIR_Coverage, 12896,
     /* 1011186 */     GIR_EraseRootFromParent_Done,
     /* 1011187 */   // Label 15038: @1011187
     /* 1011187 */   GIM_Try, /*On fail goto*//*Label 15039*/ GIMT_Encode4(1011264), // Rule ID 12897 //
     /* 1011192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1011203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1011206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1011212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011231 */     // MIs[0] policy
     /* 1011231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011241 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1011244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011263 */     // GIR_Coverage, 12897,
     /* 1011263 */     GIR_EraseRootFromParent_Done,
     /* 1011264 */   // Label 15039: @1011264
     /* 1011264 */   GIM_Try, /*On fail goto*//*Label 15040*/ GIMT_Encode4(1011341), // Rule ID 12900 //
     /* 1011269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1011280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1011283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1011289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011308 */     // MIs[0] policy
     /* 1011308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011318 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1011321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011340 */     // GIR_Coverage, 12900,
     /* 1011340 */     GIR_EraseRootFromParent_Done,
     /* 1011341 */   // Label 15040: @1011341
     /* 1011341 */   GIM_Try, /*On fail goto*//*Label 15041*/ GIMT_Encode4(1011418), // Rule ID 12901 //
     /* 1011346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1011357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1011360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1011366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011385 */     // MIs[0] policy
     /* 1011385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011395 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1011398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011417 */     // GIR_Coverage, 12901,
     /* 1011417 */     GIR_EraseRootFromParent_Done,
     /* 1011418 */   // Label 15041: @1011418
     /* 1011418 */   GIM_Try, /*On fail goto*//*Label 15042*/ GIMT_Encode4(1011495), // Rule ID 12904 //
     /* 1011423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1011434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1011437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1011440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1011443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011462 */     // MIs[0] policy
     /* 1011462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011472 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1011475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011494 */     // GIR_Coverage, 12904,
     /* 1011494 */     GIR_EraseRootFromParent_Done,
     /* 1011495 */   // Label 15042: @1011495
     /* 1011495 */   GIM_Try, /*On fail goto*//*Label 15043*/ GIMT_Encode4(1011572), // Rule ID 12905 //
     /* 1011500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1011511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1011514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1011517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1011520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011539 */     // MIs[0] policy
     /* 1011539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011549 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1011552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011571 */     // GIR_Coverage, 12905,
     /* 1011571 */     GIR_EraseRootFromParent_Done,
     /* 1011572 */   // Label 15043: @1011572
     /* 1011572 */   GIM_Try, /*On fail goto*//*Label 15044*/ GIMT_Encode4(1011649), // Rule ID 12908 //
     /* 1011577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1011588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1011591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1011594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1011597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011616 */     // MIs[0] policy
     /* 1011616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011626 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1011629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011648 */     // GIR_Coverage, 12908,
     /* 1011648 */     GIR_EraseRootFromParent_Done,
     /* 1011649 */   // Label 15044: @1011649
     /* 1011649 */   GIM_Try, /*On fail goto*//*Label 15045*/ GIMT_Encode4(1011726), // Rule ID 12909 //
     /* 1011654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1011665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1011668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1011671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1011674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011693 */     // MIs[0] policy
     /* 1011693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011703 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1011706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011725 */     // GIR_Coverage, 12909,
     /* 1011725 */     GIR_EraseRootFromParent_Done,
     /* 1011726 */   // Label 15045: @1011726
     /* 1011726 */   GIM_Try, /*On fail goto*//*Label 15046*/ GIMT_Encode4(1011803), // Rule ID 12912 //
     /* 1011731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1011742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1011745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1011748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1011751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011770 */     // MIs[0] policy
     /* 1011770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011780 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1011783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011802 */     // GIR_Coverage, 12912,
     /* 1011802 */     GIR_EraseRootFromParent_Done,
     /* 1011803 */   // Label 15046: @1011803
     /* 1011803 */   GIM_Try, /*On fail goto*//*Label 15047*/ GIMT_Encode4(1011880), // Rule ID 12913 //
     /* 1011808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1011819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1011822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1011825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1011828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011847 */     // MIs[0] policy
     /* 1011847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011857 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1011860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011879 */     // GIR_Coverage, 12913,
     /* 1011879 */     GIR_EraseRootFromParent_Done,
     /* 1011880 */   // Label 15047: @1011880
     /* 1011880 */   GIM_Try, /*On fail goto*//*Label 15048*/ GIMT_Encode4(1011957), // Rule ID 12916 //
     /* 1011885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1011896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1011899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1011902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1011905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011924 */     // MIs[0] policy
     /* 1011924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011934 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1011937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1011953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011956 */     // GIR_Coverage, 12916,
     /* 1011956 */     GIR_EraseRootFromParent_Done,
     /* 1011957 */   // Label 15048: @1011957
     /* 1011957 */   GIM_Try, /*On fail goto*//*Label 15049*/ GIMT_Encode4(1012034), // Rule ID 12917 //
     /* 1011962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1011973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1011976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1011979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1011982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012001 */     // MIs[0] policy
     /* 1012001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012011 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1012014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012033 */     // GIR_Coverage, 12917,
     /* 1012033 */     GIR_EraseRootFromParent_Done,
     /* 1012034 */   // Label 15049: @1012034
     /* 1012034 */   GIM_Try, /*On fail goto*//*Label 15050*/ GIMT_Encode4(1012111), // Rule ID 12920 //
     /* 1012039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1012050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1012053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1012056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1012059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012078 */     // MIs[0] policy
     /* 1012078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012088 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012110 */     // GIR_Coverage, 12920,
     /* 1012110 */     GIR_EraseRootFromParent_Done,
     /* 1012111 */   // Label 15050: @1012111
     /* 1012111 */   GIM_Try, /*On fail goto*//*Label 15051*/ GIMT_Encode4(1012188), // Rule ID 12921 //
     /* 1012116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1012127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1012130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1012133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1012136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012155 */     // MIs[0] policy
     /* 1012155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012165 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012187 */     // GIR_Coverage, 12921,
     /* 1012187 */     GIR_EraseRootFromParent_Done,
     /* 1012188 */   // Label 15051: @1012188
     /* 1012188 */   GIM_Try, /*On fail goto*//*Label 15052*/ GIMT_Encode4(1012265), // Rule ID 12924 //
     /* 1012193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1012204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1012207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1012210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1012213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012232 */     // MIs[0] policy
     /* 1012232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012242 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012264 */     // GIR_Coverage, 12924,
     /* 1012264 */     GIR_EraseRootFromParent_Done,
     /* 1012265 */   // Label 15052: @1012265
     /* 1012265 */   GIM_Try, /*On fail goto*//*Label 15053*/ GIMT_Encode4(1012342), // Rule ID 12925 //
     /* 1012270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1012281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1012284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1012287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1012290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012309 */     // MIs[0] policy
     /* 1012309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012319 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012341 */     // GIR_Coverage, 12925,
     /* 1012341 */     GIR_EraseRootFromParent_Done,
     /* 1012342 */   // Label 15053: @1012342
     /* 1012342 */   GIM_Try, /*On fail goto*//*Label 15054*/ GIMT_Encode4(1012419), // Rule ID 12928 //
     /* 1012347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1012358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1012361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1012364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1012367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012386 */     // MIs[0] policy
     /* 1012386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012418 */     // GIR_Coverage, 12928,
     /* 1012418 */     GIR_EraseRootFromParent_Done,
     /* 1012419 */   // Label 15054: @1012419
     /* 1012419 */   GIM_Try, /*On fail goto*//*Label 15055*/ GIMT_Encode4(1012496), // Rule ID 12929 //
     /* 1012424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1012435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1012438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1012441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1012444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012463 */     // MIs[0] policy
     /* 1012463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012473 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012495 */     // GIR_Coverage, 12929,
     /* 1012495 */     GIR_EraseRootFromParent_Done,
     /* 1012496 */   // Label 15055: @1012496
     /* 1012496 */   GIM_Try, /*On fail goto*//*Label 15056*/ GIMT_Encode4(1012573), // Rule ID 12932 //
     /* 1012501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1012512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1012515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1012518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1012521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012540 */     // MIs[0] policy
     /* 1012540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012550 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012572 */     // GIR_Coverage, 12932,
     /* 1012572 */     GIR_EraseRootFromParent_Done,
     /* 1012573 */   // Label 15056: @1012573
     /* 1012573 */   GIM_Try, /*On fail goto*//*Label 15057*/ GIMT_Encode4(1012650), // Rule ID 12933 //
     /* 1012578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1012589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1012592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1012595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1012598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012617 */     // MIs[0] policy
     /* 1012617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012627 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012649 */     // GIR_Coverage, 12933,
     /* 1012649 */     GIR_EraseRootFromParent_Done,
     /* 1012650 */   // Label 15057: @1012650
     /* 1012650 */   GIM_Try, /*On fail goto*//*Label 15058*/ GIMT_Encode4(1012727), // Rule ID 12936 //
     /* 1012655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1012666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1012669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1012672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1012675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012694 */     // MIs[0] policy
     /* 1012694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012704 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012726 */     // GIR_Coverage, 12936,
     /* 1012726 */     GIR_EraseRootFromParent_Done,
     /* 1012727 */   // Label 15058: @1012727
     /* 1012727 */   GIM_Try, /*On fail goto*//*Label 15059*/ GIMT_Encode4(1012804), // Rule ID 12937 //
     /* 1012732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1012743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1012746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1012749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1012752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012771 */     // MIs[0] policy
     /* 1012771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012781 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012803 */     // GIR_Coverage, 12937,
     /* 1012803 */     GIR_EraseRootFromParent_Done,
     /* 1012804 */   // Label 15059: @1012804
     /* 1012804 */   GIM_Try, /*On fail goto*//*Label 15060*/ GIMT_Encode4(1012881), // Rule ID 12940 //
     /* 1012809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1012812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1012820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1012823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1012826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1012829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012848 */     // MIs[0] policy
     /* 1012848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012858 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1012877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012880 */     // GIR_Coverage, 12940,
     /* 1012880 */     GIR_EraseRootFromParent_Done,
     /* 1012881 */   // Label 15060: @1012881
     /* 1012881 */   GIM_Try, /*On fail goto*//*Label 15061*/ GIMT_Encode4(1012958), // Rule ID 12941 //
     /* 1012886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1012889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1012897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1012900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1012903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1012906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012925 */     // MIs[0] policy
     /* 1012925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012935 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1012954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012957 */     // GIR_Coverage, 12941,
     /* 1012957 */     GIR_EraseRootFromParent_Done,
     /* 1012958 */   // Label 15061: @1012958
     /* 1012958 */   GIM_Try, /*On fail goto*//*Label 15062*/ GIMT_Encode4(1013035), // Rule ID 12944 //
     /* 1012963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1012974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1012977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1012980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1012983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013002 */     // MIs[0] policy
     /* 1013002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013012 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013034 */     // GIR_Coverage, 12944,
     /* 1013034 */     GIR_EraseRootFromParent_Done,
     /* 1013035 */   // Label 15062: @1013035
     /* 1013035 */   GIM_Try, /*On fail goto*//*Label 15063*/ GIMT_Encode4(1013112), // Rule ID 12945 //
     /* 1013040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1013051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1013054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1013057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1013060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013079 */     // MIs[0] policy
     /* 1013079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013089 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013111 */     // GIR_Coverage, 12945,
     /* 1013111 */     GIR_EraseRootFromParent_Done,
     /* 1013112 */   // Label 15063: @1013112
     /* 1013112 */   GIM_Try, /*On fail goto*//*Label 15064*/ GIMT_Encode4(1013189), // Rule ID 12948 //
     /* 1013117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1013128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1013131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1013134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1013137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013156 */     // MIs[0] policy
     /* 1013156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013166 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013188 */     // GIR_Coverage, 12948,
     /* 1013188 */     GIR_EraseRootFromParent_Done,
     /* 1013189 */   // Label 15064: @1013189
     /* 1013189 */   GIM_Try, /*On fail goto*//*Label 15065*/ GIMT_Encode4(1013266), // Rule ID 12949 //
     /* 1013194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1013205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1013208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1013211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1013214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013233 */     // MIs[0] policy
     /* 1013233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013243 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013265 */     // GIR_Coverage, 12949,
     /* 1013265 */     GIR_EraseRootFromParent_Done,
     /* 1013266 */   // Label 15065: @1013266
     /* 1013266 */   GIM_Try, /*On fail goto*//*Label 15066*/ GIMT_Encode4(1013343), // Rule ID 12952 //
     /* 1013271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1013282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1013285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1013288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1013291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013310 */     // MIs[0] policy
     /* 1013310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013320 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013342 */     // GIR_Coverage, 12952,
     /* 1013342 */     GIR_EraseRootFromParent_Done,
     /* 1013343 */   // Label 15066: @1013343
     /* 1013343 */   GIM_Try, /*On fail goto*//*Label 15067*/ GIMT_Encode4(1013420), // Rule ID 12953 //
     /* 1013348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1013359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1013362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1013365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1013368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013387 */     // MIs[0] policy
     /* 1013387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013397 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013419 */     // GIR_Coverage, 12953,
     /* 1013419 */     GIR_EraseRootFromParent_Done,
     /* 1013420 */   // Label 15067: @1013420
     /* 1013420 */   GIM_Try, /*On fail goto*//*Label 15068*/ GIMT_Encode4(1013497), // Rule ID 12956 //
     /* 1013425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1013436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1013439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1013442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1013445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013464 */     // MIs[0] policy
     /* 1013464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013474 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013496 */     // GIR_Coverage, 12956,
     /* 1013496 */     GIR_EraseRootFromParent_Done,
     /* 1013497 */   // Label 15068: @1013497
     /* 1013497 */   GIM_Try, /*On fail goto*//*Label 15069*/ GIMT_Encode4(1013574), // Rule ID 12957 //
     /* 1013502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1013513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1013516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1013519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1013522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013541 */     // MIs[0] policy
     /* 1013541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013551 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013573 */     // GIR_Coverage, 12957,
     /* 1013573 */     GIR_EraseRootFromParent_Done,
     /* 1013574 */   // Label 15069: @1013574
     /* 1013574 */   GIM_Try, /*On fail goto*//*Label 15070*/ GIMT_Encode4(1013651), // Rule ID 12960 //
     /* 1013579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1013590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1013593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1013596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1013599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013618 */     // MIs[0] policy
     /* 1013618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013628 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013650 */     // GIR_Coverage, 12960,
     /* 1013650 */     GIR_EraseRootFromParent_Done,
     /* 1013651 */   // Label 15070: @1013651
     /* 1013651 */   GIM_Try, /*On fail goto*//*Label 15071*/ GIMT_Encode4(1013728), // Rule ID 12961 //
     /* 1013656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1013667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1013670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1013673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1013676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013695 */     // MIs[0] policy
     /* 1013695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013705 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013727 */     // GIR_Coverage, 12961,
     /* 1013727 */     GIR_EraseRootFromParent_Done,
     /* 1013728 */   // Label 15071: @1013728
     /* 1013728 */   GIM_Try, /*On fail goto*//*Label 15072*/ GIMT_Encode4(1013805), // Rule ID 12964 //
     /* 1013733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1013744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1013747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1013750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1013753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013772 */     // MIs[0] policy
     /* 1013772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013782 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013804 */     // GIR_Coverage, 12964,
     /* 1013804 */     GIR_EraseRootFromParent_Done,
     /* 1013805 */   // Label 15072: @1013805
     /* 1013805 */   GIM_Try, /*On fail goto*//*Label 15073*/ GIMT_Encode4(1013882), // Rule ID 12965 //
     /* 1013810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1013821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1013824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1013827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1013830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013849 */     // MIs[0] policy
     /* 1013849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013859 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013881 */     // GIR_Coverage, 12965,
     /* 1013881 */     GIR_EraseRootFromParent_Done,
     /* 1013882 */   // Label 15073: @1013882
     /* 1013882 */   GIM_Try, /*On fail goto*//*Label 15074*/ GIMT_Encode4(1013959), // Rule ID 12968 //
     /* 1013887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1013898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1013901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1013904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1013907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013926 */     // MIs[0] policy
     /* 1013926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013936 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013958 */     // GIR_Coverage, 12968,
     /* 1013958 */     GIR_EraseRootFromParent_Done,
     /* 1013959 */   // Label 15074: @1013959
     /* 1013959 */   GIM_Try, /*On fail goto*//*Label 15075*/ GIMT_Encode4(1014036), // Rule ID 12969 //
     /* 1013964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1013975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1013978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1013981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1013984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014003 */     // MIs[0] policy
     /* 1014003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014013 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014035 */     // GIR_Coverage, 12969,
     /* 1014035 */     GIR_EraseRootFromParent_Done,
     /* 1014036 */   // Label 15075: @1014036
     /* 1014036 */   GIM_Try, /*On fail goto*//*Label 15076*/ GIMT_Encode4(1014113), // Rule ID 12972 //
     /* 1014041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1014058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014080 */     // MIs[0] policy
     /* 1014080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014090 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014112 */     // GIR_Coverage, 12972,
     /* 1014112 */     GIR_EraseRootFromParent_Done,
     /* 1014113 */   // Label 15076: @1014113
     /* 1014113 */   GIM_Try, /*On fail goto*//*Label 15077*/ GIMT_Encode4(1014190), // Rule ID 12973 //
     /* 1014118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1014135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014157 */     // MIs[0] policy
     /* 1014157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014167 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014189 */     // GIR_Coverage, 12973,
     /* 1014189 */     GIR_EraseRootFromParent_Done,
     /* 1014190 */   // Label 15077: @1014190
     /* 1014190 */   GIM_Try, /*On fail goto*//*Label 15078*/ GIMT_Encode4(1014267), // Rule ID 12976 //
     /* 1014195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1014212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014234 */     // MIs[0] policy
     /* 1014234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014244 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014266 */     // GIR_Coverage, 12976,
     /* 1014266 */     GIR_EraseRootFromParent_Done,
     /* 1014267 */   // Label 15078: @1014267
     /* 1014267 */   GIM_Try, /*On fail goto*//*Label 15079*/ GIMT_Encode4(1014344), // Rule ID 12977 //
     /* 1014272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1014289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014311 */     // MIs[0] policy
     /* 1014311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014321 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014343 */     // GIR_Coverage, 12977,
     /* 1014343 */     GIR_EraseRootFromParent_Done,
     /* 1014344 */   // Label 15079: @1014344
     /* 1014344 */   GIM_Try, /*On fail goto*//*Label 15080*/ GIMT_Encode4(1014421), // Rule ID 12980 //
     /* 1014349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1014360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1014363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1014366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1014369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014388 */     // MIs[0] policy
     /* 1014388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014420 */     // GIR_Coverage, 12980,
     /* 1014420 */     GIR_EraseRootFromParent_Done,
     /* 1014421 */   // Label 15080: @1014421
     /* 1014421 */   GIM_Try, /*On fail goto*//*Label 15081*/ GIMT_Encode4(1014498), // Rule ID 12981 //
     /* 1014426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1014429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1014437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1014440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1014443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1014446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014465 */     // MIs[0] policy
     /* 1014465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014475 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014497 */     // GIR_Coverage, 12981,
     /* 1014497 */     GIR_EraseRootFromParent_Done,
     /* 1014498 */   // Label 15081: @1014498
     /* 1014498 */   GIM_Try, /*On fail goto*//*Label 15082*/ GIMT_Encode4(1014575), // Rule ID 12984 //
     /* 1014503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1014514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1014517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1014520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1014523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014542 */     // MIs[0] policy
     /* 1014542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014552 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014574 */     // GIR_Coverage, 12984,
     /* 1014574 */     GIR_EraseRootFromParent_Done,
     /* 1014575 */   // Label 15082: @1014575
     /* 1014575 */   GIM_Try, /*On fail goto*//*Label 15083*/ GIMT_Encode4(1014652), // Rule ID 12985 //
     /* 1014580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1014583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1014591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1014594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1014597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1014600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014619 */     // MIs[0] policy
     /* 1014619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014629 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014651 */     // GIR_Coverage, 12985,
     /* 1014651 */     GIR_EraseRootFromParent_Done,
     /* 1014652 */   // Label 15083: @1014652
     /* 1014652 */   GIM_Try, /*On fail goto*//*Label 15084*/ GIMT_Encode4(1014729), // Rule ID 12988 //
     /* 1014657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1014668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1014671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1014674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1014677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014696 */     // MIs[0] policy
     /* 1014696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014706 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014728 */     // GIR_Coverage, 12988,
     /* 1014728 */     GIR_EraseRootFromParent_Done,
     /* 1014729 */   // Label 15084: @1014729
     /* 1014729 */   GIM_Try, /*On fail goto*//*Label 15085*/ GIMT_Encode4(1014806), // Rule ID 12989 //
     /* 1014734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1014737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1014745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1014748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1014751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1014754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014773 */     // MIs[0] policy
     /* 1014773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014783 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014805 */     // GIR_Coverage, 12989,
     /* 1014805 */     GIR_EraseRootFromParent_Done,
     /* 1014806 */   // Label 15085: @1014806
     /* 1014806 */   GIM_Try, /*On fail goto*//*Label 15086*/ GIMT_Encode4(1014883), // Rule ID 12992 //
     /* 1014811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1014822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1014825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1014831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014850 */     // MIs[0] policy
     /* 1014850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014860 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1014863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1014879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014882 */     // GIR_Coverage, 12992,
     /* 1014882 */     GIR_EraseRootFromParent_Done,
     /* 1014883 */   // Label 15086: @1014883
     /* 1014883 */   GIM_Try, /*On fail goto*//*Label 15087*/ GIMT_Encode4(1014960), // Rule ID 12993 //
     /* 1014888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1014899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1014902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1014908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014927 */     // MIs[0] policy
     /* 1014927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014937 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1014940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1014956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014959 */     // GIR_Coverage, 12993,
     /* 1014959 */     GIR_EraseRootFromParent_Done,
     /* 1014960 */   // Label 15087: @1014960
     /* 1014960 */   GIM_Try, /*On fail goto*//*Label 15088*/ GIMT_Encode4(1015037), // Rule ID 12996 //
     /* 1014965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1014976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1014979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1014985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015004 */     // MIs[0] policy
     /* 1015004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015014 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015036 */     // GIR_Coverage, 12996,
     /* 1015036 */     GIR_EraseRootFromParent_Done,
     /* 1015037 */   // Label 15088: @1015037
     /* 1015037 */   GIM_Try, /*On fail goto*//*Label 15089*/ GIMT_Encode4(1015114), // Rule ID 12997 //
     /* 1015042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1015053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1015056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1015062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015081 */     // MIs[0] policy
     /* 1015081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015091 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015113 */     // GIR_Coverage, 12997,
     /* 1015113 */     GIR_EraseRootFromParent_Done,
     /* 1015114 */   // Label 15089: @1015114
     /* 1015114 */   GIM_Try, /*On fail goto*//*Label 15090*/ GIMT_Encode4(1015191), // Rule ID 13000 //
     /* 1015119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1015130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1015133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1015139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015158 */     // MIs[0] policy
     /* 1015158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015168 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015190 */     // GIR_Coverage, 13000,
     /* 1015190 */     GIR_EraseRootFromParent_Done,
     /* 1015191 */   // Label 15090: @1015191
     /* 1015191 */   GIM_Try, /*On fail goto*//*Label 15091*/ GIMT_Encode4(1015268), // Rule ID 13001 //
     /* 1015196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1015207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1015210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1015216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015235 */     // MIs[0] policy
     /* 1015235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015245 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015267 */     // GIR_Coverage, 13001,
     /* 1015267 */     GIR_EraseRootFromParent_Done,
     /* 1015268 */   // Label 15091: @1015268
     /* 1015268 */   GIM_Try, /*On fail goto*//*Label 15092*/ GIMT_Encode4(1015345), // Rule ID 13004 //
     /* 1015273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1015284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1015287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1015293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015312 */     // MIs[0] policy
     /* 1015312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015322 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015344 */     // GIR_Coverage, 13004,
     /* 1015344 */     GIR_EraseRootFromParent_Done,
     /* 1015345 */   // Label 15092: @1015345
     /* 1015345 */   GIM_Try, /*On fail goto*//*Label 15093*/ GIMT_Encode4(1015422), // Rule ID 13005 //
     /* 1015350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1015361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1015364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1015370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015389 */     // MIs[0] policy
     /* 1015389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015399 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015421 */     // GIR_Coverage, 13005,
     /* 1015421 */     GIR_EraseRootFromParent_Done,
     /* 1015422 */   // Label 15093: @1015422
     /* 1015422 */   GIM_Try, /*On fail goto*//*Label 15094*/ GIMT_Encode4(1015499), // Rule ID 13008 //
     /* 1015427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1015438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1015441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1015447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015466 */     // MIs[0] policy
     /* 1015466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015476 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015498 */     // GIR_Coverage, 13008,
     /* 1015498 */     GIR_EraseRootFromParent_Done,
     /* 1015499 */   // Label 15094: @1015499
     /* 1015499 */   GIM_Try, /*On fail goto*//*Label 15095*/ GIMT_Encode4(1015576), // Rule ID 13009 //
     /* 1015504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1015515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1015518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1015524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015543 */     // MIs[0] policy
     /* 1015543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015553 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015575 */     // GIR_Coverage, 13009,
     /* 1015575 */     GIR_EraseRootFromParent_Done,
     /* 1015576 */   // Label 15095: @1015576
     /* 1015576 */   GIM_Try, /*On fail goto*//*Label 15096*/ GIMT_Encode4(1015653), // Rule ID 13012 //
     /* 1015581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1015592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1015595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1015601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015620 */     // MIs[0] policy
     /* 1015620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015630 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015652 */     // GIR_Coverage, 13012,
     /* 1015652 */     GIR_EraseRootFromParent_Done,
     /* 1015653 */   // Label 15096: @1015653
     /* 1015653 */   GIM_Try, /*On fail goto*//*Label 15097*/ GIMT_Encode4(1015730), // Rule ID 13013 //
     /* 1015658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1015669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1015672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1015678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015697 */     // MIs[0] policy
     /* 1015697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015707 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015729 */     // GIR_Coverage, 13013,
     /* 1015729 */     GIR_EraseRootFromParent_Done,
     /* 1015730 */   // Label 15097: @1015730
     /* 1015730 */   GIM_Try, /*On fail goto*//*Label 15098*/ GIMT_Encode4(1015807), // Rule ID 13016 //
     /* 1015735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1015746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1015749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1015755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015774 */     // MIs[0] policy
     /* 1015774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015784 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015806 */     // GIR_Coverage, 13016,
     /* 1015806 */     GIR_EraseRootFromParent_Done,
     /* 1015807 */   // Label 15098: @1015807
     /* 1015807 */   GIM_Try, /*On fail goto*//*Label 15099*/ GIMT_Encode4(1015884), // Rule ID 13017 //
     /* 1015812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1015823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1015826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1015832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015851 */     // MIs[0] policy
     /* 1015851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015861 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015883 */     // GIR_Coverage, 13017,
     /* 1015883 */     GIR_EraseRootFromParent_Done,
     /* 1015884 */   // Label 15099: @1015884
     /* 1015884 */   GIM_Try, /*On fail goto*//*Label 15100*/ GIMT_Encode4(1015961), // Rule ID 13020 //
     /* 1015889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1015900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1015903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1015909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015928 */     // MIs[0] policy
     /* 1015928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015938 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015960 */     // GIR_Coverage, 13020,
     /* 1015960 */     GIR_EraseRootFromParent_Done,
     /* 1015961 */   // Label 15100: @1015961
     /* 1015961 */   GIM_Try, /*On fail goto*//*Label 15101*/ GIMT_Encode4(1016038), // Rule ID 13021 //
     /* 1015966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1015977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1015980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1015986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016005 */     // MIs[0] policy
     /* 1016005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016015 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016037 */     // GIR_Coverage, 13021,
     /* 1016037 */     GIR_EraseRootFromParent_Done,
     /* 1016038 */   // Label 15101: @1016038
     /* 1016038 */   GIM_Try, /*On fail goto*//*Label 15102*/ GIMT_Encode4(1016115), // Rule ID 13024 //
     /* 1016043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016082 */     // MIs[0] policy
     /* 1016082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016092 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016114 */     // GIR_Coverage, 13024,
     /* 1016114 */     GIR_EraseRootFromParent_Done,
     /* 1016115 */   // Label 15102: @1016115
     /* 1016115 */   GIM_Try, /*On fail goto*//*Label 15103*/ GIMT_Encode4(1016192), // Rule ID 13025 //
     /* 1016120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016159 */     // MIs[0] policy
     /* 1016159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016169 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016191 */     // GIR_Coverage, 13025,
     /* 1016191 */     GIR_EraseRootFromParent_Done,
     /* 1016192 */   // Label 15103: @1016192
     /* 1016192 */   GIM_Try, /*On fail goto*//*Label 15104*/ GIMT_Encode4(1016269), // Rule ID 13028 //
     /* 1016197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1016200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1016208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1016211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1016217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016236 */     // MIs[0] policy
     /* 1016236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016268 */     // GIR_Coverage, 13028,
     /* 1016268 */     GIR_EraseRootFromParent_Done,
     /* 1016269 */   // Label 15104: @1016269
     /* 1016269 */   GIM_Try, /*On fail goto*//*Label 15105*/ GIMT_Encode4(1016346), // Rule ID 13029 //
     /* 1016274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1016277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1016285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1016288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1016294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016313 */     // MIs[0] policy
     /* 1016313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016323 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016345 */     // GIR_Coverage, 13029,
     /* 1016345 */     GIR_EraseRootFromParent_Done,
     /* 1016346 */   // Label 15105: @1016346
     /* 1016346 */   GIM_Try, /*On fail goto*//*Label 15106*/ GIMT_Encode4(1016423), // Rule ID 13032 //
     /* 1016351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1016362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1016365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1016371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016390 */     // MIs[0] policy
     /* 1016390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016400 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016422 */     // GIR_Coverage, 13032,
     /* 1016422 */     GIR_EraseRootFromParent_Done,
     /* 1016423 */   // Label 15106: @1016423
     /* 1016423 */   GIM_Try, /*On fail goto*//*Label 15107*/ GIMT_Encode4(1016500), // Rule ID 13033 //
     /* 1016428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1016439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1016442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1016448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016467 */     // MIs[0] policy
     /* 1016467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016477 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016499 */     // GIR_Coverage, 13033,
     /* 1016499 */     GIR_EraseRootFromParent_Done,
     /* 1016500 */   // Label 15107: @1016500
     /* 1016500 */   GIM_Try, /*On fail goto*//*Label 15108*/ GIMT_Encode4(1016577), // Rule ID 13036 //
     /* 1016505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1016516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1016519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1016525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016544 */     // MIs[0] policy
     /* 1016544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016554 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1016557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016576 */     // GIR_Coverage, 13036,
     /* 1016576 */     GIR_EraseRootFromParent_Done,
     /* 1016577 */   // Label 15108: @1016577
     /* 1016577 */   GIM_Try, /*On fail goto*//*Label 15109*/ GIMT_Encode4(1016654), // Rule ID 13037 //
     /* 1016582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1016593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1016596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1016602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016621 */     // MIs[0] policy
     /* 1016621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016631 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1016634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016653 */     // GIR_Coverage, 13037,
     /* 1016653 */     GIR_EraseRootFromParent_Done,
     /* 1016654 */   // Label 15109: @1016654
     /* 1016654 */   GIM_Try, /*On fail goto*//*Label 15110*/ GIMT_Encode4(1016731), // Rule ID 13040 //
     /* 1016659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1016670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1016673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1016679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016698 */     // MIs[0] policy
     /* 1016698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016708 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1016711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016730 */     // GIR_Coverage, 13040,
     /* 1016730 */     GIR_EraseRootFromParent_Done,
     /* 1016731 */   // Label 15110: @1016731
     /* 1016731 */   GIM_Try, /*On fail goto*//*Label 15111*/ GIMT_Encode4(1016808), // Rule ID 13041 //
     /* 1016736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1016747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1016750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1016756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016775 */     // MIs[0] policy
     /* 1016775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016785 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1016788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016807 */     // GIR_Coverage, 13041,
     /* 1016807 */     GIR_EraseRootFromParent_Done,
     /* 1016808 */   // Label 15111: @1016808
     /* 1016808 */   GIM_Try, /*On fail goto*//*Label 15112*/ GIMT_Encode4(1016885), // Rule ID 13044 //
     /* 1016813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1016824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1016827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1016833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016852 */     // MIs[0] policy
     /* 1016852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016862 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016884 */     // GIR_Coverage, 13044,
     /* 1016884 */     GIR_EraseRootFromParent_Done,
     /* 1016885 */   // Label 15112: @1016885
     /* 1016885 */   GIM_Try, /*On fail goto*//*Label 15113*/ GIMT_Encode4(1016962), // Rule ID 13045 //
     /* 1016890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1016901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1016904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1016910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016929 */     // MIs[0] policy
     /* 1016929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016939 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016961 */     // GIR_Coverage, 13045,
     /* 1016961 */     GIR_EraseRootFromParent_Done,
     /* 1016962 */   // Label 15113: @1016962
     /* 1016962 */   GIM_Try, /*On fail goto*//*Label 15114*/ GIMT_Encode4(1017039), // Rule ID 13048 //
     /* 1016967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1016978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1016981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1016987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017006 */     // MIs[0] policy
     /* 1017006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017016 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017038 */     // GIR_Coverage, 13048,
     /* 1017038 */     GIR_EraseRootFromParent_Done,
     /* 1017039 */   // Label 15114: @1017039
     /* 1017039 */   GIM_Try, /*On fail goto*//*Label 15115*/ GIMT_Encode4(1017116), // Rule ID 13049 //
     /* 1017044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1017055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1017058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1017064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017083 */     // MIs[0] policy
     /* 1017083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017093 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017115 */     // GIR_Coverage, 13049,
     /* 1017115 */     GIR_EraseRootFromParent_Done,
     /* 1017116 */   // Label 15115: @1017116
     /* 1017116 */   GIM_Try, /*On fail goto*//*Label 15116*/ GIMT_Encode4(1017193), // Rule ID 13052 //
     /* 1017121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1017132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1017135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1017141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017160 */     // MIs[0] policy
     /* 1017160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017170 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017192 */     // GIR_Coverage, 13052,
     /* 1017192 */     GIR_EraseRootFromParent_Done,
     /* 1017193 */   // Label 15116: @1017193
     /* 1017193 */   GIM_Try, /*On fail goto*//*Label 15117*/ GIMT_Encode4(1017270), // Rule ID 13053 //
     /* 1017198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1017209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1017212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1017218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017237 */     // MIs[0] policy
     /* 1017237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017247 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017269 */     // GIR_Coverage, 13053,
     /* 1017269 */     GIR_EraseRootFromParent_Done,
     /* 1017270 */   // Label 15117: @1017270
     /* 1017270 */   GIM_Try, /*On fail goto*//*Label 15118*/ GIMT_Encode4(1017347), // Rule ID 13056 //
     /* 1017275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017314 */     // MIs[0] policy
     /* 1017314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017346 */     // GIR_Coverage, 13056,
     /* 1017346 */     GIR_EraseRootFromParent_Done,
     /* 1017347 */   // Label 15118: @1017347
     /* 1017347 */   GIM_Try, /*On fail goto*//*Label 15119*/ GIMT_Encode4(1017424), // Rule ID 13057 //
     /* 1017352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017391 */     // MIs[0] policy
     /* 1017391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017423 */     // GIR_Coverage, 13057,
     /* 1017423 */     GIR_EraseRootFromParent_Done,
     /* 1017424 */   // Label 15119: @1017424
     /* 1017424 */   GIM_Try, /*On fail goto*//*Label 15120*/ GIMT_Encode4(1017501), // Rule ID 13060 //
     /* 1017429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017468 */     // MIs[0] policy
     /* 1017468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017500 */     // GIR_Coverage, 13060,
     /* 1017500 */     GIR_EraseRootFromParent_Done,
     /* 1017501 */   // Label 15120: @1017501
     /* 1017501 */   GIM_Try, /*On fail goto*//*Label 15121*/ GIMT_Encode4(1017578), // Rule ID 13061 //
     /* 1017506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017545 */     // MIs[0] policy
     /* 1017545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017555 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017577 */     // GIR_Coverage, 13061,
     /* 1017577 */     GIR_EraseRootFromParent_Done,
     /* 1017578 */   // Label 15121: @1017578
     /* 1017578 */   GIM_Try, /*On fail goto*//*Label 15122*/ GIMT_Encode4(1017655), // Rule ID 13064 //
     /* 1017583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1017594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1017597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1017603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017622 */     // MIs[0] policy
     /* 1017622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017654 */     // GIR_Coverage, 13064,
     /* 1017654 */     GIR_EraseRootFromParent_Done,
     /* 1017655 */   // Label 15122: @1017655
     /* 1017655 */   GIM_Try, /*On fail goto*//*Label 15123*/ GIMT_Encode4(1017732), // Rule ID 13065 //
     /* 1017660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1017671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1017674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1017680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017699 */     // MIs[0] policy
     /* 1017699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017709 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017731 */     // GIR_Coverage, 13065,
     /* 1017731 */     GIR_EraseRootFromParent_Done,
     /* 1017732 */   // Label 15123: @1017732
     /* 1017732 */   GIM_Try, /*On fail goto*//*Label 15124*/ GIMT_Encode4(1017809), // Rule ID 13068 //
     /* 1017737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1017740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1017748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1017751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1017757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017776 */     // MIs[0] policy
     /* 1017776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017808 */     // GIR_Coverage, 13068,
     /* 1017808 */     GIR_EraseRootFromParent_Done,
     /* 1017809 */   // Label 15124: @1017809
     /* 1017809 */   GIM_Try, /*On fail goto*//*Label 15125*/ GIMT_Encode4(1017886), // Rule ID 13069 //
     /* 1017814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1017817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1017825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1017828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1017834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017853 */     // MIs[0] policy
     /* 1017853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017863 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017885 */     // GIR_Coverage, 13069,
     /* 1017885 */     GIR_EraseRootFromParent_Done,
     /* 1017886 */   // Label 15125: @1017886
     /* 1017886 */   GIM_Try, /*On fail goto*//*Label 15126*/ GIMT_Encode4(1017963), // Rule ID 13072 //
     /* 1017891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1017894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1017902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1017905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1017911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017930 */     // MIs[0] policy
     /* 1017930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017940 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017962 */     // GIR_Coverage, 13072,
     /* 1017962 */     GIR_EraseRootFromParent_Done,
     /* 1017963 */   // Label 15126: @1017963
     /* 1017963 */   GIM_Try, /*On fail goto*//*Label 15127*/ GIMT_Encode4(1018040), // Rule ID 13073 //
     /* 1017968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1017971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1017979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1017982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1017988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018007 */     // MIs[0] policy
     /* 1018007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018017 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1018020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018039 */     // GIR_Coverage, 13073,
     /* 1018039 */     GIR_EraseRootFromParent_Done,
     /* 1018040 */   // Label 15127: @1018040
     /* 1018040 */   GIM_Try, /*On fail goto*//*Label 15128*/ GIMT_Encode4(1018117), // Rule ID 13076 //
     /* 1018045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1018056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1018059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1018065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018084 */     // MIs[0] policy
     /* 1018084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018094 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1018097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018116 */     // GIR_Coverage, 13076,
     /* 1018116 */     GIR_EraseRootFromParent_Done,
     /* 1018117 */   // Label 15128: @1018117
     /* 1018117 */   GIM_Try, /*On fail goto*//*Label 15129*/ GIMT_Encode4(1018194), // Rule ID 13077 //
     /* 1018122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1018133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1018136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1018142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018161 */     // MIs[0] policy
     /* 1018161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018171 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1018174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018193 */     // GIR_Coverage, 13077,
     /* 1018193 */     GIR_EraseRootFromParent_Done,
     /* 1018194 */   // Label 15129: @1018194
     /* 1018194 */   GIM_Try, /*On fail goto*//*Label 15130*/ GIMT_Encode4(1018271), // Rule ID 13080 //
     /* 1018199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1018210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1018213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1018216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1018219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018238 */     // MIs[0] policy
     /* 1018238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018248 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1018251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018270 */     // GIR_Coverage, 13080,
     /* 1018270 */     GIR_EraseRootFromParent_Done,
     /* 1018271 */   // Label 15130: @1018271
     /* 1018271 */   GIM_Try, /*On fail goto*//*Label 15131*/ GIMT_Encode4(1018348), // Rule ID 13081 //
     /* 1018276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1018287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1018290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1018293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1018296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018315 */     // MIs[0] policy
     /* 1018315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018325 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1018328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018347 */     // GIR_Coverage, 13081,
     /* 1018347 */     GIR_EraseRootFromParent_Done,
     /* 1018348 */   // Label 15131: @1018348
     /* 1018348 */   GIM_Try, /*On fail goto*//*Label 15132*/ GIMT_Encode4(1018425), // Rule ID 13084 //
     /* 1018353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1018364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1018367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1018370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1018373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018392 */     // MIs[0] policy
     /* 1018392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018402 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018424 */     // GIR_Coverage, 13084,
     /* 1018424 */     GIR_EraseRootFromParent_Done,
     /* 1018425 */   // Label 15132: @1018425
     /* 1018425 */   GIM_Try, /*On fail goto*//*Label 15133*/ GIMT_Encode4(1018502), // Rule ID 13085 //
     /* 1018430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1018441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1018444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1018447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1018450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018469 */     // MIs[0] policy
     /* 1018469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018479 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018501 */     // GIR_Coverage, 13085,
     /* 1018501 */     GIR_EraseRootFromParent_Done,
     /* 1018502 */   // Label 15133: @1018502
     /* 1018502 */   GIM_Try, /*On fail goto*//*Label 15134*/ GIMT_Encode4(1018579), // Rule ID 13088 //
     /* 1018507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1018518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1018521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1018524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1018527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018546 */     // MIs[0] policy
     /* 1018546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018556 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018578 */     // GIR_Coverage, 13088,
     /* 1018578 */     GIR_EraseRootFromParent_Done,
     /* 1018579 */   // Label 15134: @1018579
     /* 1018579 */   GIM_Try, /*On fail goto*//*Label 15135*/ GIMT_Encode4(1018656), // Rule ID 13089 //
     /* 1018584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1018595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1018598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1018601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1018604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018623 */     // MIs[0] policy
     /* 1018623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018633 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018655 */     // GIR_Coverage, 13089,
     /* 1018655 */     GIR_EraseRootFromParent_Done,
     /* 1018656 */   // Label 15135: @1018656
     /* 1018656 */   GIM_Try, /*On fail goto*//*Label 15136*/ GIMT_Encode4(1018733), // Rule ID 13092 //
     /* 1018661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1018672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1018675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1018678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1018681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018700 */     // MIs[0] policy
     /* 1018700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018710 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018732 */     // GIR_Coverage, 13092,
     /* 1018732 */     GIR_EraseRootFromParent_Done,
     /* 1018733 */   // Label 15136: @1018733
     /* 1018733 */   GIM_Try, /*On fail goto*//*Label 15137*/ GIMT_Encode4(1018810), // Rule ID 13093 //
     /* 1018738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1018749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1018752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1018755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1018758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018777 */     // MIs[0] policy
     /* 1018777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018787 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018809 */     // GIR_Coverage, 13093,
     /* 1018809 */     GIR_EraseRootFromParent_Done,
     /* 1018810 */   // Label 15137: @1018810
     /* 1018810 */   GIM_Try, /*On fail goto*//*Label 15138*/ GIMT_Encode4(1018887), // Rule ID 13096 //
     /* 1018815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1018826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1018829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1018832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1018835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018854 */     // MIs[0] policy
     /* 1018854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018864 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018886 */     // GIR_Coverage, 13096,
     /* 1018886 */     GIR_EraseRootFromParent_Done,
     /* 1018887 */   // Label 15138: @1018887
     /* 1018887 */   GIM_Try, /*On fail goto*//*Label 15139*/ GIMT_Encode4(1018964), // Rule ID 13097 //
     /* 1018892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1018903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1018906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1018909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1018912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018931 */     // MIs[0] policy
     /* 1018931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018941 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018963 */     // GIR_Coverage, 13097,
     /* 1018963 */     GIR_EraseRootFromParent_Done,
     /* 1018964 */   // Label 15139: @1018964
     /* 1018964 */   GIM_Try, /*On fail goto*//*Label 15140*/ GIMT_Encode4(1019041), // Rule ID 13100 //
     /* 1018969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1018980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1018983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1018986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1018989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019008 */     // MIs[0] policy
     /* 1019008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019040 */     // GIR_Coverage, 13100,
     /* 1019040 */     GIR_EraseRootFromParent_Done,
     /* 1019041 */   // Label 15140: @1019041
     /* 1019041 */   GIM_Try, /*On fail goto*//*Label 15141*/ GIMT_Encode4(1019118), // Rule ID 13101 //
     /* 1019046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1019057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1019060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1019063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1019066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019085 */     // MIs[0] policy
     /* 1019085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019095 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019117 */     // GIR_Coverage, 13101,
     /* 1019117 */     GIR_EraseRootFromParent_Done,
     /* 1019118 */   // Label 15141: @1019118
     /* 1019118 */   GIM_Try, /*On fail goto*//*Label 15142*/ GIMT_Encode4(1019195), // Rule ID 13104 //
     /* 1019123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1019134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1019137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1019140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019162 */     // MIs[0] policy
     /* 1019162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019172 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019194 */     // GIR_Coverage, 13104,
     /* 1019194 */     GIR_EraseRootFromParent_Done,
     /* 1019195 */   // Label 15142: @1019195
     /* 1019195 */   GIM_Try, /*On fail goto*//*Label 15143*/ GIMT_Encode4(1019272), // Rule ID 13105 //
     /* 1019200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1019211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1019214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1019217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019239 */     // MIs[0] policy
     /* 1019239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019249 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019271 */     // GIR_Coverage, 13105,
     /* 1019271 */     GIR_EraseRootFromParent_Done,
     /* 1019272 */   // Label 15143: @1019272
     /* 1019272 */   GIM_Try, /*On fail goto*//*Label 15144*/ GIMT_Encode4(1019349), // Rule ID 13108 //
     /* 1019277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1019288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1019291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1019294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1019297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019316 */     // MIs[0] policy
     /* 1019316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019326 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019348 */     // GIR_Coverage, 13108,
     /* 1019348 */     GIR_EraseRootFromParent_Done,
     /* 1019349 */   // Label 15144: @1019349
     /* 1019349 */   GIM_Try, /*On fail goto*//*Label 15145*/ GIMT_Encode4(1019426), // Rule ID 13109 //
     /* 1019354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1019365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1019368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1019371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1019374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019393 */     // MIs[0] policy
     /* 1019393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019403 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019425 */     // GIR_Coverage, 13109,
     /* 1019425 */     GIR_EraseRootFromParent_Done,
     /* 1019426 */   // Label 15145: @1019426
     /* 1019426 */   GIM_Try, /*On fail goto*//*Label 15146*/ GIMT_Encode4(1019503), // Rule ID 13112 //
     /* 1019431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1019448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1019451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019470 */     // MIs[0] policy
     /* 1019470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019480 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019502 */     // GIR_Coverage, 13112,
     /* 1019502 */     GIR_EraseRootFromParent_Done,
     /* 1019503 */   // Label 15146: @1019503
     /* 1019503 */   GIM_Try, /*On fail goto*//*Label 15147*/ GIMT_Encode4(1019580), // Rule ID 13113 //
     /* 1019508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1019525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1019528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019547 */     // MIs[0] policy
     /* 1019547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019557 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019579 */     // GIR_Coverage, 13113,
     /* 1019579 */     GIR_EraseRootFromParent_Done,
     /* 1019580 */   // Label 15147: @1019580
     /* 1019580 */   GIM_Try, /*On fail goto*//*Label 15148*/ GIMT_Encode4(1019657), // Rule ID 13116 //
     /* 1019585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1019588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1019596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1019599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1019602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1019605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019624 */     // MIs[0] policy
     /* 1019624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019634 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1019653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019656 */     // GIR_Coverage, 13116,
     /* 1019656 */     GIR_EraseRootFromParent_Done,
     /* 1019657 */   // Label 15148: @1019657
     /* 1019657 */   GIM_Try, /*On fail goto*//*Label 15149*/ GIMT_Encode4(1019734), // Rule ID 13117 //
     /* 1019662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1019665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1019673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1019676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1019679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1019682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019701 */     // MIs[0] policy
     /* 1019701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019711 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1019730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019733 */     // GIR_Coverage, 13117,
     /* 1019733 */     GIR_EraseRootFromParent_Done,
     /* 1019734 */   // Label 15149: @1019734
     /* 1019734 */   GIM_Try, /*On fail goto*//*Label 15150*/ GIMT_Encode4(1019811), // Rule ID 13120 //
     /* 1019739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1019750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1019753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1019756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1019759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019778 */     // MIs[0] policy
     /* 1019778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019788 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1019791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019810 */     // GIR_Coverage, 13120,
     /* 1019810 */     GIR_EraseRootFromParent_Done,
     /* 1019811 */   // Label 15150: @1019811
     /* 1019811 */   GIM_Try, /*On fail goto*//*Label 15151*/ GIMT_Encode4(1019888), // Rule ID 13121 //
     /* 1019816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1019827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1019830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1019833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1019836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019855 */     // MIs[0] policy
     /* 1019855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019865 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1019868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019887 */     // GIR_Coverage, 13121,
     /* 1019887 */     GIR_EraseRootFromParent_Done,
     /* 1019888 */   // Label 15151: @1019888
     /* 1019888 */   GIM_Try, /*On fail goto*//*Label 15152*/ GIMT_Encode4(1019965), // Rule ID 13124 //
     /* 1019893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1019904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1019907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1019910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1019913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019932 */     // MIs[0] policy
     /* 1019932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019942 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1019945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019964 */     // GIR_Coverage, 13124,
     /* 1019964 */     GIR_EraseRootFromParent_Done,
     /* 1019965 */   // Label 15152: @1019965
     /* 1019965 */   GIM_Try, /*On fail goto*//*Label 15153*/ GIMT_Encode4(1020042), // Rule ID 13125 //
     /* 1019970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1019981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1019984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1019987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1019990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020009 */     // MIs[0] policy
     /* 1020009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020019 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020041 */     // GIR_Coverage, 13125,
     /* 1020041 */     GIR_EraseRootFromParent_Done,
     /* 1020042 */   // Label 15153: @1020042
     /* 1020042 */   GIM_Try, /*On fail goto*//*Label 15154*/ GIMT_Encode4(1020119), // Rule ID 13128 //
     /* 1020047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1020058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1020061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1020064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020086 */     // MIs[0] policy
     /* 1020086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020096 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020118 */     // GIR_Coverage, 13128,
     /* 1020118 */     GIR_EraseRootFromParent_Done,
     /* 1020119 */   // Label 15154: @1020119
     /* 1020119 */   GIM_Try, /*On fail goto*//*Label 15155*/ GIMT_Encode4(1020196), // Rule ID 13129 //
     /* 1020124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1020135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1020138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1020141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020163 */     // MIs[0] policy
     /* 1020163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020173 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020195 */     // GIR_Coverage, 13129,
     /* 1020195 */     GIR_EraseRootFromParent_Done,
     /* 1020196 */   // Label 15155: @1020196
     /* 1020196 */   GIM_Try, /*On fail goto*//*Label 15156*/ GIMT_Encode4(1020273), // Rule ID 13132 //
     /* 1020201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1020212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1020215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1020218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1020221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020240 */     // MIs[0] policy
     /* 1020240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020250 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020272 */     // GIR_Coverage, 13132,
     /* 1020272 */     GIR_EraseRootFromParent_Done,
     /* 1020273 */   // Label 15156: @1020273
     /* 1020273 */   GIM_Try, /*On fail goto*//*Label 15157*/ GIMT_Encode4(1020350), // Rule ID 13133 //
     /* 1020278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1020289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1020292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1020295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1020298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020317 */     // MIs[0] policy
     /* 1020317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020327 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020349 */     // GIR_Coverage, 13133,
     /* 1020349 */     GIR_EraseRootFromParent_Done,
     /* 1020350 */   // Label 15157: @1020350
     /* 1020350 */   GIM_Try, /*On fail goto*//*Label 15158*/ GIMT_Encode4(1020427), // Rule ID 13136 //
     /* 1020355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1020366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1020369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1020372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1020375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020394 */     // MIs[0] policy
     /* 1020394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020426 */     // GIR_Coverage, 13136,
     /* 1020426 */     GIR_EraseRootFromParent_Done,
     /* 1020427 */   // Label 15158: @1020427
     /* 1020427 */   GIM_Try, /*On fail goto*//*Label 15159*/ GIMT_Encode4(1020504), // Rule ID 13137 //
     /* 1020432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1020443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1020446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1020449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1020452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020471 */     // MIs[0] policy
     /* 1020471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020481 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020503 */     // GIR_Coverage, 13137,
     /* 1020503 */     GIR_EraseRootFromParent_Done,
     /* 1020504 */   // Label 15159: @1020504
     /* 1020504 */   GIM_Try, /*On fail goto*//*Label 15160*/ GIMT_Encode4(1020581), // Rule ID 13140 //
     /* 1020509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1020520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1020523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1020526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1020529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020548 */     // MIs[0] policy
     /* 1020548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020580 */     // GIR_Coverage, 13140,
     /* 1020580 */     GIR_EraseRootFromParent_Done,
     /* 1020581 */   // Label 15160: @1020581
     /* 1020581 */   GIM_Try, /*On fail goto*//*Label 15161*/ GIMT_Encode4(1020658), // Rule ID 13141 //
     /* 1020586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1020597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1020600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1020603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1020606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020625 */     // MIs[0] policy
     /* 1020625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020635 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020657 */     // GIR_Coverage, 13141,
     /* 1020657 */     GIR_EraseRootFromParent_Done,
     /* 1020658 */   // Label 15161: @1020658
     /* 1020658 */   GIM_Try, /*On fail goto*//*Label 15162*/ GIMT_Encode4(1020735), // Rule ID 13144 //
     /* 1020663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1020674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1020677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1020680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1020683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020702 */     // MIs[0] policy
     /* 1020702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020734 */     // GIR_Coverage, 13144,
     /* 1020734 */     GIR_EraseRootFromParent_Done,
     /* 1020735 */   // Label 15162: @1020735
     /* 1020735 */   GIM_Try, /*On fail goto*//*Label 15163*/ GIMT_Encode4(1020812), // Rule ID 13145 //
     /* 1020740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1020751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1020754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1020757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1020760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020779 */     // MIs[0] policy
     /* 1020779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020789 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020811 */     // GIR_Coverage, 13145,
     /* 1020811 */     GIR_EraseRootFromParent_Done,
     /* 1020812 */   // Label 15163: @1020812
     /* 1020812 */   GIM_Try, /*On fail goto*//*Label 15164*/ GIMT_Encode4(1020889), // Rule ID 13148 //
     /* 1020817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1020828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1020831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1020834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1020837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020856 */     // MIs[0] policy
     /* 1020856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020888 */     // GIR_Coverage, 13148,
     /* 1020888 */     GIR_EraseRootFromParent_Done,
     /* 1020889 */   // Label 15164: @1020889
     /* 1020889 */   GIM_Try, /*On fail goto*//*Label 15165*/ GIMT_Encode4(1020966), // Rule ID 13149 //
     /* 1020894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1020905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1020908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1020911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1020914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020933 */     // MIs[0] policy
     /* 1020933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020943 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020965 */     // GIR_Coverage, 13149,
     /* 1020965 */     GIR_EraseRootFromParent_Done,
     /* 1020966 */   // Label 15165: @1020966
     /* 1020966 */   GIM_Try, /*On fail goto*//*Label 15166*/ GIMT_Encode4(1021043), // Rule ID 13152 //
     /* 1020971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1020982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1020985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1020988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1020991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021010 */     // MIs[0] policy
     /* 1021010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021020 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021042 */     // GIR_Coverage, 13152,
     /* 1021042 */     GIR_EraseRootFromParent_Done,
     /* 1021043 */   // Label 15166: @1021043
     /* 1021043 */   GIM_Try, /*On fail goto*//*Label 15167*/ GIMT_Encode4(1021120), // Rule ID 13153 //
     /* 1021048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1021059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1021062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1021065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1021068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021087 */     // MIs[0] policy
     /* 1021087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021097 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021119 */     // GIR_Coverage, 13153,
     /* 1021119 */     GIR_EraseRootFromParent_Done,
     /* 1021120 */   // Label 15167: @1021120
     /* 1021120 */   GIM_Try, /*On fail goto*//*Label 15168*/ GIMT_Encode4(1021197), // Rule ID 13156 //
     /* 1021125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1021136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1021139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1021142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1021145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021164 */     // MIs[0] policy
     /* 1021164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021174 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1021177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021196 */     // GIR_Coverage, 13156,
     /* 1021196 */     GIR_EraseRootFromParent_Done,
     /* 1021197 */   // Label 15168: @1021197
     /* 1021197 */   GIM_Try, /*On fail goto*//*Label 15169*/ GIMT_Encode4(1021274), // Rule ID 13157 //
     /* 1021202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1021213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1021216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1021219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1021222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021241 */     // MIs[0] policy
     /* 1021241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021251 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1021254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021273 */     // GIR_Coverage, 13157,
     /* 1021273 */     GIR_EraseRootFromParent_Done,
     /* 1021274 */   // Label 15169: @1021274
     /* 1021274 */   GIM_Try, /*On fail goto*//*Label 15170*/ GIMT_Encode4(1021351), // Rule ID 13160 //
     /* 1021279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1021290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1021293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1021296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1021299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021318 */     // MIs[0] policy
     /* 1021318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021328 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1021331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021350 */     // GIR_Coverage, 13160,
     /* 1021350 */     GIR_EraseRootFromParent_Done,
     /* 1021351 */   // Label 15170: @1021351
     /* 1021351 */   GIM_Try, /*On fail goto*//*Label 15171*/ GIMT_Encode4(1021428), // Rule ID 13161 //
     /* 1021356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1021367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1021370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1021373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1021376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021395 */     // MIs[0] policy
     /* 1021395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021405 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1021408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021427 */     // GIR_Coverage, 13161,
     /* 1021427 */     GIR_EraseRootFromParent_Done,
     /* 1021428 */   // Label 15171: @1021428
     /* 1021428 */   GIM_Try, /*On fail goto*//*Label 15172*/ GIMT_Encode4(1021505), // Rule ID 13164 //
     /* 1021433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1021444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1021447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1021450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1021453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021472 */     // MIs[0] policy
     /* 1021472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021482 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021504 */     // GIR_Coverage, 13164,
     /* 1021504 */     GIR_EraseRootFromParent_Done,
     /* 1021505 */   // Label 15172: @1021505
     /* 1021505 */   GIM_Try, /*On fail goto*//*Label 15173*/ GIMT_Encode4(1021582), // Rule ID 13165 //
     /* 1021510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1021521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1021524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1021527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1021530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021549 */     // MIs[0] policy
     /* 1021549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021559 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021581 */     // GIR_Coverage, 13165,
     /* 1021581 */     GIR_EraseRootFromParent_Done,
     /* 1021582 */   // Label 15173: @1021582
     /* 1021582 */   GIM_Try, /*On fail goto*//*Label 15174*/ GIMT_Encode4(1021659), // Rule ID 13168 //
     /* 1021587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1021598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1021601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1021607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021626 */     // MIs[0] policy
     /* 1021626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021636 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1021639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021658 */     // GIR_Coverage, 13168,
     /* 1021658 */     GIR_EraseRootFromParent_Done,
     /* 1021659 */   // Label 15174: @1021659
     /* 1021659 */   GIM_Try, /*On fail goto*//*Label 15175*/ GIMT_Encode4(1021736), // Rule ID 13169 //
     /* 1021664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1021675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1021678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1021684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021703 */     // MIs[0] policy
     /* 1021703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021713 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1021716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021735 */     // GIR_Coverage, 13169,
     /* 1021735 */     GIR_EraseRootFromParent_Done,
     /* 1021736 */   // Label 15175: @1021736
     /* 1021736 */   GIM_Try, /*On fail goto*//*Label 15176*/ GIMT_Encode4(1021813), // Rule ID 13172 //
     /* 1021741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1021752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1021755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1021761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021780 */     // MIs[0] policy
     /* 1021780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021790 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1021793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021812 */     // GIR_Coverage, 13172,
     /* 1021812 */     GIR_EraseRootFromParent_Done,
     /* 1021813 */   // Label 15176: @1021813
     /* 1021813 */   GIM_Try, /*On fail goto*//*Label 15177*/ GIMT_Encode4(1021890), // Rule ID 13173 //
     /* 1021818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1021829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1021832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1021838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021857 */     // MIs[0] policy
     /* 1021857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021867 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1021870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021889 */     // GIR_Coverage, 13173,
     /* 1021889 */     GIR_EraseRootFromParent_Done,
     /* 1021890 */   // Label 15177: @1021890
     /* 1021890 */   GIM_Try, /*On fail goto*//*Label 15178*/ GIMT_Encode4(1021967), // Rule ID 13176 //
     /* 1021895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1021906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1021909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1021915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021934 */     // MIs[0] policy
     /* 1021934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021944 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1021947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021966 */     // GIR_Coverage, 13176,
     /* 1021966 */     GIR_EraseRootFromParent_Done,
     /* 1021967 */   // Label 15178: @1021967
     /* 1021967 */   GIM_Try, /*On fail goto*//*Label 15179*/ GIMT_Encode4(1022044), // Rule ID 13177 //
     /* 1021972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1021983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1021986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1021992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022011 */     // MIs[0] policy
     /* 1022011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022021 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022043 */     // GIR_Coverage, 13177,
     /* 1022043 */     GIR_EraseRootFromParent_Done,
     /* 1022044 */   // Label 15179: @1022044
     /* 1022044 */   GIM_Try, /*On fail goto*//*Label 15180*/ GIMT_Encode4(1022121), // Rule ID 13180 //
     /* 1022049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1022060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1022063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1022069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022088 */     // MIs[0] policy
     /* 1022088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022098 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1022101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022120 */     // GIR_Coverage, 13180,
     /* 1022120 */     GIR_EraseRootFromParent_Done,
     /* 1022121 */   // Label 15180: @1022121
     /* 1022121 */   GIM_Try, /*On fail goto*//*Label 15181*/ GIMT_Encode4(1022198), // Rule ID 13181 //
     /* 1022126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1022137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1022140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1022146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022165 */     // MIs[0] policy
     /* 1022165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022175 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1022178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022197 */     // GIR_Coverage, 13181,
     /* 1022197 */     GIR_EraseRootFromParent_Done,
     /* 1022198 */   // Label 15181: @1022198
     /* 1022198 */   GIM_Try, /*On fail goto*//*Label 15182*/ GIMT_Encode4(1022275), // Rule ID 13184 //
     /* 1022203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1022214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1022217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1022223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022242 */     // MIs[0] policy
     /* 1022242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022274 */     // GIR_Coverage, 13184,
     /* 1022274 */     GIR_EraseRootFromParent_Done,
     /* 1022275 */   // Label 15182: @1022275
     /* 1022275 */   GIM_Try, /*On fail goto*//*Label 15183*/ GIMT_Encode4(1022352), // Rule ID 13185 //
     /* 1022280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1022291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1022294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1022300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022319 */     // MIs[0] policy
     /* 1022319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022329 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022351 */     // GIR_Coverage, 13185,
     /* 1022351 */     GIR_EraseRootFromParent_Done,
     /* 1022352 */   // Label 15183: @1022352
     /* 1022352 */   GIM_Try, /*On fail goto*//*Label 15184*/ GIMT_Encode4(1022429), // Rule ID 13188 //
     /* 1022357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1022377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022396 */     // MIs[0] policy
     /* 1022396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022406 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022428 */     // GIR_Coverage, 13188,
     /* 1022428 */     GIR_EraseRootFromParent_Done,
     /* 1022429 */   // Label 15184: @1022429
     /* 1022429 */   GIM_Try, /*On fail goto*//*Label 15185*/ GIMT_Encode4(1022506), // Rule ID 13189 //
     /* 1022434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1022454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022473 */     // MIs[0] policy
     /* 1022473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022483 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022505 */     // GIR_Coverage, 13189,
     /* 1022505 */     GIR_EraseRootFromParent_Done,
     /* 1022506 */   // Label 15185: @1022506
     /* 1022506 */   GIM_Try, /*On fail goto*//*Label 15186*/ GIMT_Encode4(1022583), // Rule ID 13192 //
     /* 1022511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1022522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1022525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1022531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022550 */     // MIs[0] policy
     /* 1022550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022560 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022582 */     // GIR_Coverage, 13192,
     /* 1022582 */     GIR_EraseRootFromParent_Done,
     /* 1022583 */   // Label 15186: @1022583
     /* 1022583 */   GIM_Try, /*On fail goto*//*Label 15187*/ GIMT_Encode4(1022660), // Rule ID 13193 //
     /* 1022588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1022599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1022602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1022608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022627 */     // MIs[0] policy
     /* 1022627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022637 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022659 */     // GIR_Coverage, 13193,
     /* 1022659 */     GIR_EraseRootFromParent_Done,
     /* 1022660 */   // Label 15187: @1022660
     /* 1022660 */   GIM_Try, /*On fail goto*//*Label 15188*/ GIMT_Encode4(1022737), // Rule ID 13196 //
     /* 1022665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1022676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1022679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1022685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022704 */     // MIs[0] policy
     /* 1022704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022736 */     // GIR_Coverage, 13196,
     /* 1022736 */     GIR_EraseRootFromParent_Done,
     /* 1022737 */   // Label 15188: @1022737
     /* 1022737 */   GIM_Try, /*On fail goto*//*Label 15189*/ GIMT_Encode4(1022814), // Rule ID 13197 //
     /* 1022742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1022753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1022756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1022762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022781 */     // MIs[0] policy
     /* 1022781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022791 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022813 */     // GIR_Coverage, 13197,
     /* 1022813 */     GIR_EraseRootFromParent_Done,
     /* 1022814 */   // Label 15189: @1022814
     /* 1022814 */   GIM_Try, /*On fail goto*//*Label 15190*/ GIMT_Encode4(1022891), // Rule ID 13200 //
     /* 1022819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1022830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1022833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1022839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022858 */     // MIs[0] policy
     /* 1022858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022868 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022890 */     // GIR_Coverage, 13200,
     /* 1022890 */     GIR_EraseRootFromParent_Done,
     /* 1022891 */   // Label 15190: @1022891
     /* 1022891 */   GIM_Try, /*On fail goto*//*Label 15191*/ GIMT_Encode4(1022968), // Rule ID 13201 //
     /* 1022896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1022907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1022910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1022916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022935 */     // MIs[0] policy
     /* 1022935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022945 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022967 */     // GIR_Coverage, 13201,
     /* 1022967 */     GIR_EraseRootFromParent_Done,
     /* 1022968 */   // Label 15191: @1022968
     /* 1022968 */   GIM_Try, /*On fail goto*//*Label 15192*/ GIMT_Encode4(1023045), // Rule ID 13204 //
     /* 1022973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1022976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1022984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1022987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1022993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023012 */     // MIs[0] policy
     /* 1023012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023022 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1023041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023044 */     // GIR_Coverage, 13204,
     /* 1023044 */     GIR_EraseRootFromParent_Done,
     /* 1023045 */   // Label 15192: @1023045
     /* 1023045 */   GIM_Try, /*On fail goto*//*Label 15193*/ GIMT_Encode4(1023122), // Rule ID 13205 //
     /* 1023050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1023053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1023061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1023064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1023070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023089 */     // MIs[0] policy
     /* 1023089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023099 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1023118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023121 */     // GIR_Coverage, 13205,
     /* 1023121 */     GIR_EraseRootFromParent_Done,
     /* 1023122 */   // Label 15193: @1023122
     /* 1023122 */   GIM_Try, /*On fail goto*//*Label 15194*/ GIMT_Encode4(1023199), // Rule ID 13208 //
     /* 1023127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1023138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1023141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023166 */     // MIs[0] policy
     /* 1023166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023176 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023198 */     // GIR_Coverage, 13208,
     /* 1023198 */     GIR_EraseRootFromParent_Done,
     /* 1023199 */   // Label 15194: @1023199
     /* 1023199 */   GIM_Try, /*On fail goto*//*Label 15195*/ GIMT_Encode4(1023276), // Rule ID 13209 //
     /* 1023204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1023215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1023218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023243 */     // MIs[0] policy
     /* 1023243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023253 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023275 */     // GIR_Coverage, 13209,
     /* 1023275 */     GIR_EraseRootFromParent_Done,
     /* 1023276 */   // Label 15195: @1023276
     /* 1023276 */   GIM_Try, /*On fail goto*//*Label 15196*/ GIMT_Encode4(1023353), // Rule ID 13212 //
     /* 1023281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1023292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1023295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023320 */     // MIs[0] policy
     /* 1023320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023330 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023352 */     // GIR_Coverage, 13212,
     /* 1023352 */     GIR_EraseRootFromParent_Done,
     /* 1023353 */   // Label 15196: @1023353
     /* 1023353 */   GIM_Try, /*On fail goto*//*Label 15197*/ GIMT_Encode4(1023430), // Rule ID 13213 //
     /* 1023358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1023369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1023372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023397 */     // MIs[0] policy
     /* 1023397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023407 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023429 */     // GIR_Coverage, 13213,
     /* 1023429 */     GIR_EraseRootFromParent_Done,
     /* 1023430 */   // Label 15197: @1023430
     /* 1023430 */   GIM_Try, /*On fail goto*//*Label 15198*/ GIMT_Encode4(1023507), // Rule ID 13216 //
     /* 1023435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1023446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1023449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023474 */     // MIs[0] policy
     /* 1023474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023484 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1023487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023506 */     // GIR_Coverage, 13216,
     /* 1023506 */     GIR_EraseRootFromParent_Done,
     /* 1023507 */   // Label 15198: @1023507
     /* 1023507 */   GIM_Try, /*On fail goto*//*Label 15199*/ GIMT_Encode4(1023584), // Rule ID 13217 //
     /* 1023512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1023523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1023526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023551 */     // MIs[0] policy
     /* 1023551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023561 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1023564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023583 */     // GIR_Coverage, 13217,
     /* 1023583 */     GIR_EraseRootFromParent_Done,
     /* 1023584 */   // Label 15199: @1023584
     /* 1023584 */   GIM_Try, /*On fail goto*//*Label 15200*/ GIMT_Encode4(1023661), // Rule ID 13220 //
     /* 1023589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1023600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1023603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1023609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023628 */     // MIs[0] policy
     /* 1023628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023638 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023660 */     // GIR_Coverage, 13220,
     /* 1023660 */     GIR_EraseRootFromParent_Done,
     /* 1023661 */   // Label 15200: @1023661
     /* 1023661 */   GIM_Try, /*On fail goto*//*Label 15201*/ GIMT_Encode4(1023738), // Rule ID 13221 //
     /* 1023666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1023677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1023680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1023686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023705 */     // MIs[0] policy
     /* 1023705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023715 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023737 */     // GIR_Coverage, 13221,
     /* 1023737 */     GIR_EraseRootFromParent_Done,
     /* 1023738 */   // Label 15201: @1023738
     /* 1023738 */   GIM_Try, /*On fail goto*//*Label 15202*/ GIMT_Encode4(1023815), // Rule ID 13224 //
     /* 1023743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1023754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1023757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1023763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023782 */     // MIs[0] policy
     /* 1023782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023792 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023814 */     // GIR_Coverage, 13224,
     /* 1023814 */     GIR_EraseRootFromParent_Done,
     /* 1023815 */   // Label 15202: @1023815
     /* 1023815 */   GIM_Try, /*On fail goto*//*Label 15203*/ GIMT_Encode4(1023892), // Rule ID 13225 //
     /* 1023820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1023831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1023834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1023840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023859 */     // MIs[0] policy
     /* 1023859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023869 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023891 */     // GIR_Coverage, 13225,
     /* 1023891 */     GIR_EraseRootFromParent_Done,
     /* 1023892 */   // Label 15203: @1023892
     /* 1023892 */   GIM_Try, /*On fail goto*//*Label 15204*/ GIMT_Encode4(1023969), // Rule ID 13228 //
     /* 1023897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1023908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1023911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1023917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023936 */     // MIs[0] policy
     /* 1023936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023946 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1023949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023968 */     // GIR_Coverage, 13228,
     /* 1023968 */     GIR_EraseRootFromParent_Done,
     /* 1023969 */   // Label 15204: @1023969
     /* 1023969 */   GIM_Try, /*On fail goto*//*Label 15205*/ GIMT_Encode4(1024046), // Rule ID 13229 //
     /* 1023974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1023985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1023988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1023994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024013 */     // MIs[0] policy
     /* 1024013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024023 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024045 */     // GIR_Coverage, 13229,
     /* 1024045 */     GIR_EraseRootFromParent_Done,
     /* 1024046 */   // Label 15205: @1024046
     /* 1024046 */   GIM_Try, /*On fail goto*//*Label 15206*/ GIMT_Encode4(1024123), // Rule ID 13232 //
     /* 1024051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1024071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024090 */     // MIs[0] policy
     /* 1024090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024122 */     // GIR_Coverage, 13232,
     /* 1024122 */     GIR_EraseRootFromParent_Done,
     /* 1024123 */   // Label 15206: @1024123
     /* 1024123 */   GIM_Try, /*On fail goto*//*Label 15207*/ GIMT_Encode4(1024200), // Rule ID 13233 //
     /* 1024128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1024148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024167 */     // MIs[0] policy
     /* 1024167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024199 */     // GIR_Coverage, 13233,
     /* 1024199 */     GIR_EraseRootFromParent_Done,
     /* 1024200 */   // Label 15207: @1024200
     /* 1024200 */   GIM_Try, /*On fail goto*//*Label 15208*/ GIMT_Encode4(1024277), // Rule ID 13236 //
     /* 1024205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1024225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024244 */     // MIs[0] policy
     /* 1024244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024276 */     // GIR_Coverage, 13236,
     /* 1024276 */     GIR_EraseRootFromParent_Done,
     /* 1024277 */   // Label 15208: @1024277
     /* 1024277 */   GIM_Try, /*On fail goto*//*Label 15209*/ GIMT_Encode4(1024354), // Rule ID 13237 //
     /* 1024282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1024302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024321 */     // MIs[0] policy
     /* 1024321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024331 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024353 */     // GIR_Coverage, 13237,
     /* 1024353 */     GIR_EraseRootFromParent_Done,
     /* 1024354 */   // Label 15209: @1024354
     /* 1024354 */   GIM_Try, /*On fail goto*//*Label 15210*/ GIMT_Encode4(1024431), // Rule ID 13240 //
     /* 1024359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1024379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024398 */     // MIs[0] policy
     /* 1024398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024408 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024430 */     // GIR_Coverage, 13240,
     /* 1024430 */     GIR_EraseRootFromParent_Done,
     /* 1024431 */   // Label 15210: @1024431
     /* 1024431 */   GIM_Try, /*On fail goto*//*Label 15211*/ GIMT_Encode4(1024508), // Rule ID 13241 //
     /* 1024436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1024456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024475 */     // MIs[0] policy
     /* 1024475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024485 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024507 */     // GIR_Coverage, 13241,
     /* 1024507 */     GIR_EraseRootFromParent_Done,
     /* 1024508 */   // Label 15211: @1024508
     /* 1024508 */   GIM_Try, /*On fail goto*//*Label 15212*/ GIMT_Encode4(1024585), // Rule ID 13244 //
     /* 1024513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1024516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1024524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1024527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1024533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024552 */     // MIs[0] policy
     /* 1024552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024562 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024584 */     // GIR_Coverage, 13244,
     /* 1024584 */     GIR_EraseRootFromParent_Done,
     /* 1024585 */   // Label 15212: @1024585
     /* 1024585 */   GIM_Try, /*On fail goto*//*Label 15213*/ GIMT_Encode4(1024662), // Rule ID 13245 //
     /* 1024590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1024593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1024601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1024604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1024610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024629 */     // MIs[0] policy
     /* 1024629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024639 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024661 */     // GIR_Coverage, 13245,
     /* 1024661 */     GIR_EraseRootFromParent_Done,
     /* 1024662 */   // Label 15213: @1024662
     /* 1024662 */   GIM_Try, /*On fail goto*//*Label 15214*/ GIMT_Encode4(1024739), // Rule ID 13248 //
     /* 1024667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1024670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1024678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1024681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1024687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024706 */     // MIs[0] policy
     /* 1024706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024716 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024738 */     // GIR_Coverage, 13248,
     /* 1024738 */     GIR_EraseRootFromParent_Done,
     /* 1024739 */   // Label 15214: @1024739
     /* 1024739 */   GIM_Try, /*On fail goto*//*Label 15215*/ GIMT_Encode4(1024816), // Rule ID 13249 //
     /* 1024744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1024747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1024755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1024758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1024764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024783 */     // MIs[0] policy
     /* 1024783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024793 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024815 */     // GIR_Coverage, 13249,
     /* 1024815 */     GIR_EraseRootFromParent_Done,
     /* 1024816 */   // Label 15215: @1024816
     /* 1024816 */   GIM_Try, /*On fail goto*//*Label 15216*/ GIMT_Encode4(1024893), // Rule ID 13252 //
     /* 1024821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1024824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1024832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1024835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1024841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024860 */     // MIs[0] policy
     /* 1024860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024870 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024892 */     // GIR_Coverage, 13252,
     /* 1024892 */     GIR_EraseRootFromParent_Done,
     /* 1024893 */   // Label 15216: @1024893
     /* 1024893 */   GIM_Try, /*On fail goto*//*Label 15217*/ GIMT_Encode4(1024970), // Rule ID 13253 //
     /* 1024898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1024901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1024909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1024912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1024918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024937 */     // MIs[0] policy
     /* 1024937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024947 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024969 */     // GIR_Coverage, 13253,
     /* 1024969 */     GIR_EraseRootFromParent_Done,
     /* 1024970 */   // Label 15217: @1024970
     /* 1024970 */   GIM_Try, /*On fail goto*//*Label 15218*/ GIMT_Encode4(1025047), // Rule ID 13256 //
     /* 1024975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1024983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1024986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1024989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1024992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1024995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025014 */     // MIs[0] policy
     /* 1025014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025024 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1025027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025046 */     // GIR_Coverage, 13256,
     /* 1025046 */     GIR_EraseRootFromParent_Done,
     /* 1025047 */   // Label 15218: @1025047
     /* 1025047 */   GIM_Try, /*On fail goto*//*Label 15219*/ GIMT_Encode4(1025124), // Rule ID 13257 //
     /* 1025052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1025063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1025066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1025069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1025072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025091 */     // MIs[0] policy
     /* 1025091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025101 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1025104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025123 */     // GIR_Coverage, 13257,
     /* 1025123 */     GIR_EraseRootFromParent_Done,
     /* 1025124 */   // Label 15219: @1025124
     /* 1025124 */   GIM_Try, /*On fail goto*//*Label 15220*/ GIMT_Encode4(1025201), // Rule ID 13260 //
     /* 1025129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1025140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1025143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1025146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1025149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025168 */     // MIs[0] policy
     /* 1025168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025178 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025200 */     // GIR_Coverage, 13260,
     /* 1025200 */     GIR_EraseRootFromParent_Done,
     /* 1025201 */   // Label 15220: @1025201
     /* 1025201 */   GIM_Try, /*On fail goto*//*Label 15221*/ GIMT_Encode4(1025278), // Rule ID 13261 //
     /* 1025206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1025217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1025220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1025223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1025226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025245 */     // MIs[0] policy
     /* 1025245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025255 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025277 */     // GIR_Coverage, 13261,
     /* 1025277 */     GIR_EraseRootFromParent_Done,
     /* 1025278 */   // Label 15221: @1025278
     /* 1025278 */   GIM_Try, /*On fail goto*//*Label 15222*/ GIMT_Encode4(1025355), // Rule ID 13264 //
     /* 1025283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1025294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1025297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1025300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1025303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025322 */     // MIs[0] policy
     /* 1025322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025332 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025354 */     // GIR_Coverage, 13264,
     /* 1025354 */     GIR_EraseRootFromParent_Done,
     /* 1025355 */   // Label 15222: @1025355
     /* 1025355 */   GIM_Try, /*On fail goto*//*Label 15223*/ GIMT_Encode4(1025432), // Rule ID 13265 //
     /* 1025360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1025371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1025374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1025377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1025380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025399 */     // MIs[0] policy
     /* 1025399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025409 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025431 */     // GIR_Coverage, 13265,
     /* 1025431 */     GIR_EraseRootFromParent_Done,
     /* 1025432 */   // Label 15223: @1025432
     /* 1025432 */   GIM_Try, /*On fail goto*//*Label 15224*/ GIMT_Encode4(1025509), // Rule ID 13268 //
     /* 1025437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1025448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1025451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1025454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1025457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025476 */     // MIs[0] policy
     /* 1025476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025486 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025508 */     // GIR_Coverage, 13268,
     /* 1025508 */     GIR_EraseRootFromParent_Done,
     /* 1025509 */   // Label 15224: @1025509
     /* 1025509 */   GIM_Try, /*On fail goto*//*Label 15225*/ GIMT_Encode4(1025586), // Rule ID 13269 //
     /* 1025514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1025525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1025528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1025531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1025534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025553 */     // MIs[0] policy
     /* 1025553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025563 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025585 */     // GIR_Coverage, 13269,
     /* 1025585 */     GIR_EraseRootFromParent_Done,
     /* 1025586 */   // Label 15225: @1025586
     /* 1025586 */   GIM_Try, /*On fail goto*//*Label 15226*/ GIMT_Encode4(1025663), // Rule ID 13272 //
     /* 1025591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1025602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1025605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1025608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1025611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025630 */     // MIs[0] policy
     /* 1025630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025640 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025662 */     // GIR_Coverage, 13272,
     /* 1025662 */     GIR_EraseRootFromParent_Done,
     /* 1025663 */   // Label 15226: @1025663
     /* 1025663 */   GIM_Try, /*On fail goto*//*Label 15227*/ GIMT_Encode4(1025740), // Rule ID 13273 //
     /* 1025668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1025679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1025682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1025685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1025688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025707 */     // MIs[0] policy
     /* 1025707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025717 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025739 */     // GIR_Coverage, 13273,
     /* 1025739 */     GIR_EraseRootFromParent_Done,
     /* 1025740 */   // Label 15227: @1025740
     /* 1025740 */   GIM_Try, /*On fail goto*//*Label 15228*/ GIMT_Encode4(1025817), // Rule ID 13276 //
     /* 1025745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1025756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1025759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1025762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1025765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025784 */     // MIs[0] policy
     /* 1025784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025794 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1025813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025816 */     // GIR_Coverage, 13276,
     /* 1025816 */     GIR_EraseRootFromParent_Done,
     /* 1025817 */   // Label 15228: @1025817
     /* 1025817 */   GIM_Try, /*On fail goto*//*Label 15229*/ GIMT_Encode4(1025894), // Rule ID 13277 //
     /* 1025822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1025833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1025836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1025839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1025842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025861 */     // MIs[0] policy
     /* 1025861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025871 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1025890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025893 */     // GIR_Coverage, 13277,
     /* 1025893 */     GIR_EraseRootFromParent_Done,
     /* 1025894 */   // Label 15229: @1025894
     /* 1025894 */   GIM_Try, /*On fail goto*//*Label 15230*/ GIMT_Encode4(1025971), // Rule ID 13280 //
     /* 1025899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1025910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1025913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1025919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025938 */     // MIs[0] policy
     /* 1025938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025948 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1025951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025970 */     // GIR_Coverage, 13280,
     /* 1025970 */     GIR_EraseRootFromParent_Done,
     /* 1025971 */   // Label 15230: @1025971
     /* 1025971 */   GIM_Try, /*On fail goto*//*Label 15231*/ GIMT_Encode4(1026048), // Rule ID 13281 //
     /* 1025976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1025987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1025990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1025996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026015 */     // MIs[0] policy
     /* 1026015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026025 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026047 */     // GIR_Coverage, 13281,
     /* 1026047 */     GIR_EraseRootFromParent_Done,
     /* 1026048 */   // Label 15231: @1026048
     /* 1026048 */   GIM_Try, /*On fail goto*//*Label 15232*/ GIMT_Encode4(1026125), // Rule ID 13284 //
     /* 1026053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1026064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1026067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1026070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1026073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026092 */     // MIs[0] policy
     /* 1026092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026124 */     // GIR_Coverage, 13284,
     /* 1026124 */     GIR_EraseRootFromParent_Done,
     /* 1026125 */   // Label 15232: @1026125
     /* 1026125 */   GIM_Try, /*On fail goto*//*Label 15233*/ GIMT_Encode4(1026202), // Rule ID 13285 //
     /* 1026130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1026141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1026144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1026147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1026150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026169 */     // MIs[0] policy
     /* 1026169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026179 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026201 */     // GIR_Coverage, 13285,
     /* 1026201 */     GIR_EraseRootFromParent_Done,
     /* 1026202 */   // Label 15233: @1026202
     /* 1026202 */   GIM_Try, /*On fail goto*//*Label 15234*/ GIMT_Encode4(1026279), // Rule ID 13288 //
     /* 1026207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1026224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1026227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026246 */     // MIs[0] policy
     /* 1026246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026278 */     // GIR_Coverage, 13288,
     /* 1026278 */     GIR_EraseRootFromParent_Done,
     /* 1026279 */   // Label 15234: @1026279
     /* 1026279 */   GIM_Try, /*On fail goto*//*Label 15235*/ GIMT_Encode4(1026356), // Rule ID 13289 //
     /* 1026284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1026301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1026304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026323 */     // MIs[0] policy
     /* 1026323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026333 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026355 */     // GIR_Coverage, 13289,
     /* 1026355 */     GIR_EraseRootFromParent_Done,
     /* 1026356 */   // Label 15235: @1026356
     /* 1026356 */   GIM_Try, /*On fail goto*//*Label 15236*/ GIMT_Encode4(1026433), // Rule ID 13292 //
     /* 1026361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1026364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1026372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1026375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1026378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1026381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026400 */     // MIs[0] policy
     /* 1026400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026410 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1026429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026432 */     // GIR_Coverage, 13292,
     /* 1026432 */     GIR_EraseRootFromParent_Done,
     /* 1026433 */   // Label 15236: @1026433
     /* 1026433 */   GIM_Try, /*On fail goto*//*Label 15237*/ GIMT_Encode4(1026510), // Rule ID 13293 //
     /* 1026438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1026441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1026449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1026452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1026455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1026458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026477 */     // MIs[0] policy
     /* 1026477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026487 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1026506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026509 */     // GIR_Coverage, 13293,
     /* 1026509 */     GIR_EraseRootFromParent_Done,
     /* 1026510 */   // Label 15237: @1026510
     /* 1026510 */   GIM_Try, /*On fail goto*//*Label 15238*/ GIMT_Encode4(1026587), // Rule ID 13296 //
     /* 1026515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1026526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1026529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1026532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026554 */     // MIs[0] policy
     /* 1026554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026564 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1026567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026586 */     // GIR_Coverage, 13296,
     /* 1026586 */     GIR_EraseRootFromParent_Done,
     /* 1026587 */   // Label 15238: @1026587
     /* 1026587 */   GIM_Try, /*On fail goto*//*Label 15239*/ GIMT_Encode4(1026664), // Rule ID 13297 //
     /* 1026592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1026603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1026606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1026609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026631 */     // MIs[0] policy
     /* 1026631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026641 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1026644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026663 */     // GIR_Coverage, 13297,
     /* 1026663 */     GIR_EraseRootFromParent_Done,
     /* 1026664 */   // Label 15239: @1026664
     /* 1026664 */   GIM_Try, /*On fail goto*//*Label 15240*/ GIMT_Encode4(1026741), // Rule ID 13300 //
     /* 1026669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1026680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1026683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1026686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1026689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026708 */     // MIs[0] policy
     /* 1026708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026718 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1026721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026740 */     // GIR_Coverage, 13300,
     /* 1026740 */     GIR_EraseRootFromParent_Done,
     /* 1026741 */   // Label 15240: @1026741
     /* 1026741 */   GIM_Try, /*On fail goto*//*Label 15241*/ GIMT_Encode4(1026818), // Rule ID 13301 //
     /* 1026746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1026757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1026760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1026763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1026766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026785 */     // MIs[0] policy
     /* 1026785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026795 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1026798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026817 */     // GIR_Coverage, 13301,
     /* 1026817 */     GIR_EraseRootFromParent_Done,
     /* 1026818 */   // Label 15241: @1026818
     /* 1026818 */   GIM_Try, /*On fail goto*//*Label 15242*/ GIMT_Encode4(1026895), // Rule ID 13304 //
     /* 1026823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1026834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1026837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1026840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1026843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026862 */     // MIs[0] policy
     /* 1026862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026872 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1026875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026894 */     // GIR_Coverage, 13304,
     /* 1026894 */     GIR_EraseRootFromParent_Done,
     /* 1026895 */   // Label 15242: @1026895
     /* 1026895 */   GIM_Try, /*On fail goto*//*Label 15243*/ GIMT_Encode4(1026972), // Rule ID 13305 //
     /* 1026900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1026911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1026914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1026917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1026920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026939 */     // MIs[0] policy
     /* 1026939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026949 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1026952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026971 */     // GIR_Coverage, 13305,
     /* 1026971 */     GIR_EraseRootFromParent_Done,
     /* 1026972 */   // Label 15243: @1026972
     /* 1026972 */   GIM_Try, /*On fail goto*//*Label 15244*/ GIMT_Encode4(1027049), // Rule ID 13308 //
     /* 1026977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1026988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1026991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1026994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1026997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027016 */     // MIs[0] policy
     /* 1027016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027026 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027048 */     // GIR_Coverage, 13308,
     /* 1027048 */     GIR_EraseRootFromParent_Done,
     /* 1027049 */   // Label 15244: @1027049
     /* 1027049 */   GIM_Try, /*On fail goto*//*Label 15245*/ GIMT_Encode4(1027126), // Rule ID 13309 //
     /* 1027054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1027065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1027068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1027071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1027074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027093 */     // MIs[0] policy
     /* 1027093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027103 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027125 */     // GIR_Coverage, 13309,
     /* 1027125 */     GIR_EraseRootFromParent_Done,
     /* 1027126 */   // Label 15245: @1027126
     /* 1027126 */   GIM_Try, /*On fail goto*//*Label 15246*/ GIMT_Encode4(1027203), // Rule ID 13312 //
     /* 1027131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1027142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1027145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1027148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1027151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027170 */     // MIs[0] policy
     /* 1027170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027180 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027202 */     // GIR_Coverage, 13312,
     /* 1027202 */     GIR_EraseRootFromParent_Done,
     /* 1027203 */   // Label 15246: @1027203
     /* 1027203 */   GIM_Try, /*On fail goto*//*Label 15247*/ GIMT_Encode4(1027280), // Rule ID 13313 //
     /* 1027208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1027219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1027222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1027225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1027228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027247 */     // MIs[0] policy
     /* 1027247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027257 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027279 */     // GIR_Coverage, 13313,
     /* 1027279 */     GIR_EraseRootFromParent_Done,
     /* 1027280 */   // Label 15247: @1027280
     /* 1027280 */   GIM_Try, /*On fail goto*//*Label 15248*/ GIMT_Encode4(1027357), // Rule ID 13316 //
     /* 1027285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1027296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1027299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1027302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1027305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027324 */     // MIs[0] policy
     /* 1027324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027334 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027356 */     // GIR_Coverage, 13316,
     /* 1027356 */     GIR_EraseRootFromParent_Done,
     /* 1027357 */   // Label 15248: @1027357
     /* 1027357 */   GIM_Try, /*On fail goto*//*Label 15249*/ GIMT_Encode4(1027434), // Rule ID 13317 //
     /* 1027362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1027373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1027376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1027379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1027382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027401 */     // MIs[0] policy
     /* 1027401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027411 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027433 */     // GIR_Coverage, 13317,
     /* 1027433 */     GIR_EraseRootFromParent_Done,
     /* 1027434 */   // Label 15249: @1027434
     /* 1027434 */   GIM_Try, /*On fail goto*//*Label 15250*/ GIMT_Encode4(1027511), // Rule ID 13320 //
     /* 1027439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1027456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1027459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027478 */     // MIs[0] policy
     /* 1027478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027488 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027510 */     // GIR_Coverage, 13320,
     /* 1027510 */     GIR_EraseRootFromParent_Done,
     /* 1027511 */   // Label 15250: @1027511
     /* 1027511 */   GIM_Try, /*On fail goto*//*Label 15251*/ GIMT_Encode4(1027588), // Rule ID 13321 //
     /* 1027516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1027533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1027536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027555 */     // MIs[0] policy
     /* 1027555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027565 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027587 */     // GIR_Coverage, 13321,
     /* 1027587 */     GIR_EraseRootFromParent_Done,
     /* 1027588 */   // Label 15251: @1027588
     /* 1027588 */   GIM_Try, /*On fail goto*//*Label 15252*/ GIMT_Encode4(1027665), // Rule ID 13324 //
     /* 1027593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1027604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1027607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1027610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1027613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027632 */     // MIs[0] policy
     /* 1027632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027642 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027664 */     // GIR_Coverage, 13324,
     /* 1027664 */     GIR_EraseRootFromParent_Done,
     /* 1027665 */   // Label 15252: @1027665
     /* 1027665 */   GIM_Try, /*On fail goto*//*Label 15253*/ GIMT_Encode4(1027742), // Rule ID 13325 //
     /* 1027670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1027681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1027684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1027687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1027690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027709 */     // MIs[0] policy
     /* 1027709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027719 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027741 */     // GIR_Coverage, 13325,
     /* 1027741 */     GIR_EraseRootFromParent_Done,
     /* 1027742 */   // Label 15253: @1027742
     /* 1027742 */   GIM_Try, /*On fail goto*//*Label 15254*/ GIMT_Encode4(1027819), // Rule ID 13328 //
     /* 1027747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1027758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1027761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1027764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1027767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027786 */     // MIs[0] policy
     /* 1027786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027818 */     // GIR_Coverage, 13328,
     /* 1027818 */     GIR_EraseRootFromParent_Done,
     /* 1027819 */   // Label 15254: @1027819
     /* 1027819 */   GIM_Try, /*On fail goto*//*Label 15255*/ GIMT_Encode4(1027896), // Rule ID 13329 //
     /* 1027824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1027835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1027838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1027841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1027844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027863 */     // MIs[0] policy
     /* 1027863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027873 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027895 */     // GIR_Coverage, 13329,
     /* 1027895 */     GIR_EraseRootFromParent_Done,
     /* 1027896 */   // Label 15255: @1027896
     /* 1027896 */   GIM_Try, /*On fail goto*//*Label 15256*/ GIMT_Encode4(1027973), // Rule ID 13332 //
     /* 1027901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1027904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1027912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1027915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1027918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1027921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027940 */     // MIs[0] policy
     /* 1027940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1027969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027972 */     // GIR_Coverage, 13332,
     /* 1027972 */     GIR_EraseRootFromParent_Done,
     /* 1027973 */   // Label 15256: @1027973
     /* 1027973 */   GIM_Try, /*On fail goto*//*Label 15257*/ GIMT_Encode4(1028050), // Rule ID 13333 //
     /* 1027978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1027981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1027989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1027992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1027995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1027998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028017 */     // MIs[0] policy
     /* 1028017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028027 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1028030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028049 */     // GIR_Coverage, 13333,
     /* 1028049 */     GIR_EraseRootFromParent_Done,
     /* 1028050 */   // Label 15257: @1028050
     /* 1028050 */   GIM_Try, /*On fail goto*//*Label 15258*/ GIMT_Encode4(1028127), // Rule ID 13336 //
     /* 1028055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1028066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1028069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1028072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1028075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028094 */     // MIs[0] policy
     /* 1028094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028104 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1028107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028126 */     // GIR_Coverage, 13336,
     /* 1028126 */     GIR_EraseRootFromParent_Done,
     /* 1028127 */   // Label 15258: @1028127
     /* 1028127 */   GIM_Try, /*On fail goto*//*Label 15259*/ GIMT_Encode4(1028204), // Rule ID 13337 //
     /* 1028132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1028143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1028146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1028149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1028152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028171 */     // MIs[0] policy
     /* 1028171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028181 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1028184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028203 */     // GIR_Coverage, 13337,
     /* 1028203 */     GIR_EraseRootFromParent_Done,
     /* 1028204 */   // Label 15259: @1028204
     /* 1028204 */   GIM_Try, /*On fail goto*//*Label 15260*/ GIMT_Encode4(1028281), // Rule ID 13340 //
     /* 1028209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1028220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1028223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1028226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1028229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028248 */     // MIs[0] policy
     /* 1028248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028258 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1028261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028280 */     // GIR_Coverage, 13340,
     /* 1028280 */     GIR_EraseRootFromParent_Done,
     /* 1028281 */   // Label 15260: @1028281
     /* 1028281 */   GIM_Try, /*On fail goto*//*Label 15261*/ GIMT_Encode4(1028358), // Rule ID 13341 //
     /* 1028286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1028297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1028300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1028303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1028306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028325 */     // MIs[0] policy
     /* 1028325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028335 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1028338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028357 */     // GIR_Coverage, 13341,
     /* 1028357 */     GIR_EraseRootFromParent_Done,
     /* 1028358 */   // Label 15261: @1028358
     /* 1028358 */   GIM_Try, /*On fail goto*//*Label 15262*/ GIMT_Encode4(1028435), // Rule ID 13344 //
     /* 1028363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1028374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1028377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1028383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028402 */     // MIs[0] policy
     /* 1028402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028412 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1028415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028434 */     // GIR_Coverage, 13344,
     /* 1028434 */     GIR_EraseRootFromParent_Done,
     /* 1028435 */   // Label 15262: @1028435
     /* 1028435 */   GIM_Try, /*On fail goto*//*Label 15263*/ GIMT_Encode4(1028512), // Rule ID 13345 //
     /* 1028440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1028451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1028454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1028460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028479 */     // MIs[0] policy
     /* 1028479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028489 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1028492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028511 */     // GIR_Coverage, 13345,
     /* 1028511 */     GIR_EraseRootFromParent_Done,
     /* 1028512 */   // Label 15263: @1028512
     /* 1028512 */   GIM_Try, /*On fail goto*//*Label 15264*/ GIMT_Encode4(1028589), // Rule ID 13348 //
     /* 1028517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1028528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1028531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1028537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028556 */     // MIs[0] policy
     /* 1028556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028566 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1028569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028588 */     // GIR_Coverage, 13348,
     /* 1028588 */     GIR_EraseRootFromParent_Done,
     /* 1028589 */   // Label 15264: @1028589
     /* 1028589 */   GIM_Try, /*On fail goto*//*Label 15265*/ GIMT_Encode4(1028666), // Rule ID 13349 //
     /* 1028594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1028605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1028608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1028614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028633 */     // MIs[0] policy
     /* 1028633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028643 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1028646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028665 */     // GIR_Coverage, 13349,
     /* 1028665 */     GIR_EraseRootFromParent_Done,
     /* 1028666 */   // Label 15265: @1028666
     /* 1028666 */   GIM_Try, /*On fail goto*//*Label 15266*/ GIMT_Encode4(1028743), // Rule ID 13352 //
     /* 1028671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1028682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1028685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1028691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028710 */     // MIs[0] policy
     /* 1028710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028720 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1028723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028742 */     // GIR_Coverage, 13352,
     /* 1028742 */     GIR_EraseRootFromParent_Done,
     /* 1028743 */   // Label 15266: @1028743
     /* 1028743 */   GIM_Try, /*On fail goto*//*Label 15267*/ GIMT_Encode4(1028820), // Rule ID 13353 //
     /* 1028748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1028759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1028762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1028768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028787 */     // MIs[0] policy
     /* 1028787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028797 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1028800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028819 */     // GIR_Coverage, 13353,
     /* 1028819 */     GIR_EraseRootFromParent_Done,
     /* 1028820 */   // Label 15267: @1028820
     /* 1028820 */   GIM_Try, /*On fail goto*//*Label 15268*/ GIMT_Encode4(1028897), // Rule ID 13356 //
     /* 1028825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1028836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1028839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1028845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028864 */     // MIs[0] policy
     /* 1028864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028874 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1028877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1028893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028896 */     // GIR_Coverage, 13356,
     /* 1028896 */     GIR_EraseRootFromParent_Done,
     /* 1028897 */   // Label 15268: @1028897
     /* 1028897 */   GIM_Try, /*On fail goto*//*Label 15269*/ GIMT_Encode4(1028974), // Rule ID 13357 //
     /* 1028902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1028913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1028916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1028922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028941 */     // MIs[0] policy
     /* 1028941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028951 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1028954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1028970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028973 */     // GIR_Coverage, 13357,
     /* 1028973 */     GIR_EraseRootFromParent_Done,
     /* 1028974 */   // Label 15269: @1028974
     /* 1028974 */   GIM_Try, /*On fail goto*//*Label 15270*/ GIMT_Encode4(1029051), // Rule ID 13360 //
     /* 1028979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1028990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1028993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1028999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029018 */     // MIs[0] policy
     /* 1029018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029028 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029050 */     // GIR_Coverage, 13360,
     /* 1029050 */     GIR_EraseRootFromParent_Done,
     /* 1029051 */   // Label 15270: @1029051
     /* 1029051 */   GIM_Try, /*On fail goto*//*Label 15271*/ GIMT_Encode4(1029128), // Rule ID 13361 //
     /* 1029056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1029067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1029070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1029076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029095 */     // MIs[0] policy
     /* 1029095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029105 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029127 */     // GIR_Coverage, 13361,
     /* 1029127 */     GIR_EraseRootFromParent_Done,
     /* 1029128 */   // Label 15271: @1029128
     /* 1029128 */   GIM_Try, /*On fail goto*//*Label 15272*/ GIMT_Encode4(1029205), // Rule ID 13364 //
     /* 1029133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1029147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1029153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029172 */     // MIs[0] policy
     /* 1029172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029182 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029204 */     // GIR_Coverage, 13364,
     /* 1029204 */     GIR_EraseRootFromParent_Done,
     /* 1029205 */   // Label 15272: @1029205
     /* 1029205 */   GIM_Try, /*On fail goto*//*Label 15273*/ GIMT_Encode4(1029282), // Rule ID 13365 //
     /* 1029210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1029224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1029230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029249 */     // MIs[0] policy
     /* 1029249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029259 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029281 */     // GIR_Coverage, 13365,
     /* 1029281 */     GIR_EraseRootFromParent_Done,
     /* 1029282 */   // Label 15273: @1029282
     /* 1029282 */   GIM_Try, /*On fail goto*//*Label 15274*/ GIMT_Encode4(1029359), // Rule ID 13368 //
     /* 1029287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1029298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1029301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029326 */     // MIs[0] policy
     /* 1029326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029336 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029358 */     // GIR_Coverage, 13368,
     /* 1029358 */     GIR_EraseRootFromParent_Done,
     /* 1029359 */   // Label 15274: @1029359
     /* 1029359 */   GIM_Try, /*On fail goto*//*Label 15275*/ GIMT_Encode4(1029436), // Rule ID 13369 //
     /* 1029364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1029375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1029378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029403 */     // MIs[0] policy
     /* 1029403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029413 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029435 */     // GIR_Coverage, 13369,
     /* 1029435 */     GIR_EraseRootFromParent_Done,
     /* 1029436 */   // Label 15275: @1029436
     /* 1029436 */   GIM_Try, /*On fail goto*//*Label 15276*/ GIMT_Encode4(1029513), // Rule ID 13372 //
     /* 1029441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1029452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1029455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1029461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029480 */     // MIs[0] policy
     /* 1029480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029512 */     // GIR_Coverage, 13372,
     /* 1029512 */     GIR_EraseRootFromParent_Done,
     /* 1029513 */   // Label 15276: @1029513
     /* 1029513 */   GIM_Try, /*On fail goto*//*Label 15277*/ GIMT_Encode4(1029590), // Rule ID 13373 //
     /* 1029518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1029529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1029532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1029538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029557 */     // MIs[0] policy
     /* 1029557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029567 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029589 */     // GIR_Coverage, 13373,
     /* 1029589 */     GIR_EraseRootFromParent_Done,
     /* 1029590 */   // Label 15277: @1029590
     /* 1029590 */   GIM_Try, /*On fail goto*//*Label 15278*/ GIMT_Encode4(1029667), // Rule ID 13376 //
     /* 1029595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1029606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1029609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1029615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029634 */     // MIs[0] policy
     /* 1029634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029666 */     // GIR_Coverage, 13376,
     /* 1029666 */     GIR_EraseRootFromParent_Done,
     /* 1029667 */   // Label 15278: @1029667
     /* 1029667 */   GIM_Try, /*On fail goto*//*Label 15279*/ GIMT_Encode4(1029744), // Rule ID 13377 //
     /* 1029672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1029683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1029686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1029692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029711 */     // MIs[0] policy
     /* 1029711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029721 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029743 */     // GIR_Coverage, 13377,
     /* 1029743 */     GIR_EraseRootFromParent_Done,
     /* 1029744 */   // Label 15279: @1029744
     /* 1029744 */   GIM_Try, /*On fail goto*//*Label 15280*/ GIMT_Encode4(1029821), // Rule ID 13380 //
     /* 1029749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1029752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1029760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1029763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1029769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029788 */     // MIs[0] policy
     /* 1029788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029798 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1029817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029820 */     // GIR_Coverage, 13380,
     /* 1029820 */     GIR_EraseRootFromParent_Done,
     /* 1029821 */   // Label 15280: @1029821
     /* 1029821 */   GIM_Try, /*On fail goto*//*Label 15281*/ GIMT_Encode4(1029898), // Rule ID 13381 //
     /* 1029826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1029829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1029837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1029840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1029846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029865 */     // MIs[0] policy
     /* 1029865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029875 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1029894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029897 */     // GIR_Coverage, 13381,
     /* 1029897 */     GIR_EraseRootFromParent_Done,
     /* 1029898 */   // Label 15281: @1029898
     /* 1029898 */   GIM_Try, /*On fail goto*//*Label 15282*/ GIMT_Encode4(1029975), // Rule ID 13384 //
     /* 1029903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1029914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1029917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1029923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029942 */     // MIs[0] policy
     /* 1029942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029952 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1029955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029974 */     // GIR_Coverage, 13384,
     /* 1029974 */     GIR_EraseRootFromParent_Done,
     /* 1029975 */   // Label 15282: @1029975
     /* 1029975 */   GIM_Try, /*On fail goto*//*Label 15283*/ GIMT_Encode4(1030052), // Rule ID 13385 //
     /* 1029980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1029991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1029994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1030000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030019 */     // MIs[0] policy
     /* 1030019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030029 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030051 */     // GIR_Coverage, 13385,
     /* 1030051 */     GIR_EraseRootFromParent_Done,
     /* 1030052 */   // Label 15283: @1030052
     /* 1030052 */   GIM_Try, /*On fail goto*//*Label 15284*/ GIMT_Encode4(1030129), // Rule ID 13388 //
     /* 1030057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1030068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1030071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1030077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030096 */     // MIs[0] policy
     /* 1030096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030106 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030128 */     // GIR_Coverage, 13388,
     /* 1030128 */     GIR_EraseRootFromParent_Done,
     /* 1030129 */   // Label 15284: @1030129
     /* 1030129 */   GIM_Try, /*On fail goto*//*Label 15285*/ GIMT_Encode4(1030206), // Rule ID 13389 //
     /* 1030134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1030145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1030148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1030154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030173 */     // MIs[0] policy
     /* 1030173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030183 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030205 */     // GIR_Coverage, 13389,
     /* 1030205 */     GIR_EraseRootFromParent_Done,
     /* 1030206 */   // Label 15285: @1030206
     /* 1030206 */   GIM_Try, /*On fail goto*//*Label 15286*/ GIMT_Encode4(1030283), // Rule ID 13392 //
     /* 1030211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1030222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1030225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1030231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030250 */     // MIs[0] policy
     /* 1030250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030260 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030282 */     // GIR_Coverage, 13392,
     /* 1030282 */     GIR_EraseRootFromParent_Done,
     /* 1030283 */   // Label 15286: @1030283
     /* 1030283 */   GIM_Try, /*On fail goto*//*Label 15287*/ GIMT_Encode4(1030360), // Rule ID 13393 //
     /* 1030288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1030299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1030302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1030308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030327 */     // MIs[0] policy
     /* 1030327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030337 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030359 */     // GIR_Coverage, 13393,
     /* 1030359 */     GIR_EraseRootFromParent_Done,
     /* 1030360 */   // Label 15287: @1030360
     /* 1030360 */   GIM_Try, /*On fail goto*//*Label 15288*/ GIMT_Encode4(1030437), // Rule ID 13396 //
     /* 1030365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1030376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1030379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1030385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030404 */     // MIs[0] policy
     /* 1030404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030414 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030436 */     // GIR_Coverage, 13396,
     /* 1030436 */     GIR_EraseRootFromParent_Done,
     /* 1030437 */   // Label 15288: @1030437
     /* 1030437 */   GIM_Try, /*On fail goto*//*Label 15289*/ GIMT_Encode4(1030514), // Rule ID 13397 //
     /* 1030442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1030453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1030456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1030462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030481 */     // MIs[0] policy
     /* 1030481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030491 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030513 */     // GIR_Coverage, 13397,
     /* 1030513 */     GIR_EraseRootFromParent_Done,
     /* 1030514 */   // Label 15289: @1030514
     /* 1030514 */   GIM_Try, /*On fail goto*//*Label 15290*/ GIMT_Encode4(1030591), // Rule ID 13400 //
     /* 1030519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1030530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1030533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1030539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030558 */     // MIs[0] policy
     /* 1030558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030568 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030590 */     // GIR_Coverage, 13400,
     /* 1030590 */     GIR_EraseRootFromParent_Done,
     /* 1030591 */   // Label 15290: @1030591
     /* 1030591 */   GIM_Try, /*On fail goto*//*Label 15291*/ GIMT_Encode4(1030668), // Rule ID 13401 //
     /* 1030596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1030607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1030610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1030616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030635 */     // MIs[0] policy
     /* 1030635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030645 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030667 */     // GIR_Coverage, 13401,
     /* 1030667 */     GIR_EraseRootFromParent_Done,
     /* 1030668 */   // Label 15291: @1030668
     /* 1030668 */   GIM_Try, /*On fail goto*//*Label 15292*/ GIMT_Encode4(1030745), // Rule ID 13404 //
     /* 1030673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1030684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1030687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1030693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030712 */     // MIs[0] policy
     /* 1030712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030722 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030744 */     // GIR_Coverage, 13404,
     /* 1030744 */     GIR_EraseRootFromParent_Done,
     /* 1030745 */   // Label 15292: @1030745
     /* 1030745 */   GIM_Try, /*On fail goto*//*Label 15293*/ GIMT_Encode4(1030822), // Rule ID 13405 //
     /* 1030750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1030761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1030764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1030770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030789 */     // MIs[0] policy
     /* 1030789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030799 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030821 */     // GIR_Coverage, 13405,
     /* 1030821 */     GIR_EraseRootFromParent_Done,
     /* 1030822 */   // Label 15293: @1030822
     /* 1030822 */   GIM_Try, /*On fail goto*//*Label 15294*/ GIMT_Encode4(1030899), // Rule ID 13408 //
     /* 1030827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1030838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1030841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1030847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030866 */     // MIs[0] policy
     /* 1030866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030898 */     // GIR_Coverage, 13408,
     /* 1030898 */     GIR_EraseRootFromParent_Done,
     /* 1030899 */   // Label 15294: @1030899
     /* 1030899 */   GIM_Try, /*On fail goto*//*Label 15295*/ GIMT_Encode4(1030976), // Rule ID 13409 //
     /* 1030904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1030915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1030918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1030924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030943 */     // MIs[0] policy
     /* 1030943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030953 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030975 */     // GIR_Coverage, 13409,
     /* 1030975 */     GIR_EraseRootFromParent_Done,
     /* 1030976 */   // Label 15295: @1030976
     /* 1030976 */   GIM_Try, /*On fail goto*//*Label 15296*/ GIMT_Encode4(1031053), // Rule ID 13412 //
     /* 1030981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1030992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1030995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1031001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031020 */     // MIs[0] policy
     /* 1031020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031030 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031052 */     // GIR_Coverage, 13412,
     /* 1031052 */     GIR_EraseRootFromParent_Done,
     /* 1031053 */   // Label 15296: @1031053
     /* 1031053 */   GIM_Try, /*On fail goto*//*Label 15297*/ GIMT_Encode4(1031130), // Rule ID 13413 //
     /* 1031058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1031069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1031072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1031078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031097 */     // MIs[0] policy
     /* 1031097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031107 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031129 */     // GIR_Coverage, 13413,
     /* 1031129 */     GIR_EraseRootFromParent_Done,
     /* 1031130 */   // Label 15297: @1031130
     /* 1031130 */   GIM_Try, /*On fail goto*//*Label 15298*/ GIMT_Encode4(1031207), // Rule ID 13416 //
     /* 1031135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1031146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1031149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1031155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031174 */     // MIs[0] policy
     /* 1031174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031184 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031206 */     // GIR_Coverage, 13416,
     /* 1031206 */     GIR_EraseRootFromParent_Done,
     /* 1031207 */   // Label 15298: @1031207
     /* 1031207 */   GIM_Try, /*On fail goto*//*Label 15299*/ GIMT_Encode4(1031284), // Rule ID 13417 //
     /* 1031212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1031223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1031226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1031232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031251 */     // MIs[0] policy
     /* 1031251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031261 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031283 */     // GIR_Coverage, 13417,
     /* 1031283 */     GIR_EraseRootFromParent_Done,
     /* 1031284 */   // Label 15299: @1031284
     /* 1031284 */   GIM_Try, /*On fail goto*//*Label 15300*/ GIMT_Encode4(1031361), // Rule ID 13420 //
     /* 1031289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1031300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1031303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1031309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031328 */     // MIs[0] policy
     /* 1031328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031338 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1031341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031360 */     // GIR_Coverage, 13420,
     /* 1031360 */     GIR_EraseRootFromParent_Done,
     /* 1031361 */   // Label 15300: @1031361
     /* 1031361 */   GIM_Try, /*On fail goto*//*Label 15301*/ GIMT_Encode4(1031438), // Rule ID 13421 //
     /* 1031366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1031377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1031380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1031386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031405 */     // MIs[0] policy
     /* 1031405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031415 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1031418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031437 */     // GIR_Coverage, 13421,
     /* 1031437 */     GIR_EraseRootFromParent_Done,
     /* 1031438 */   // Label 15301: @1031438
     /* 1031438 */   GIM_Try, /*On fail goto*//*Label 15302*/ GIMT_Encode4(1031515), // Rule ID 13424 //
     /* 1031443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1031454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1031457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1031463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031482 */     // MIs[0] policy
     /* 1031482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031492 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031514 */     // GIR_Coverage, 13424,
     /* 1031514 */     GIR_EraseRootFromParent_Done,
     /* 1031515 */   // Label 15302: @1031515
     /* 1031515 */   GIM_Try, /*On fail goto*//*Label 15303*/ GIMT_Encode4(1031592), // Rule ID 13425 //
     /* 1031520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1031531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1031534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1031540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031559 */     // MIs[0] policy
     /* 1031559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031569 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031591 */     // GIR_Coverage, 13425,
     /* 1031591 */     GIR_EraseRootFromParent_Done,
     /* 1031592 */   // Label 15303: @1031592
     /* 1031592 */   GIM_Try, /*On fail goto*//*Label 15304*/ GIMT_Encode4(1031669), // Rule ID 13428 //
     /* 1031597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1031608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1031611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1031617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031636 */     // MIs[0] policy
     /* 1031636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031668 */     // GIR_Coverage, 13428,
     /* 1031668 */     GIR_EraseRootFromParent_Done,
     /* 1031669 */   // Label 15304: @1031669
     /* 1031669 */   GIM_Try, /*On fail goto*//*Label 15305*/ GIMT_Encode4(1031746), // Rule ID 13429 //
     /* 1031674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1031685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1031688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1031694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031713 */     // MIs[0] policy
     /* 1031713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031723 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031745 */     // GIR_Coverage, 13429,
     /* 1031745 */     GIR_EraseRootFromParent_Done,
     /* 1031746 */   // Label 15305: @1031746
     /* 1031746 */   GIM_Try, /*On fail goto*//*Label 15306*/ GIMT_Encode4(1031823), // Rule ID 13432 //
     /* 1031751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1031762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1031765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1031768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1031771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031790 */     // MIs[0] policy
     /* 1031790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031800 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1031803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031822 */     // GIR_Coverage, 13432,
     /* 1031822 */     GIR_EraseRootFromParent_Done,
     /* 1031823 */   // Label 15306: @1031823
     /* 1031823 */   GIM_Try, /*On fail goto*//*Label 15307*/ GIMT_Encode4(1031900), // Rule ID 13433 //
     /* 1031828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1031839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1031842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1031845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1031848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031867 */     // MIs[0] policy
     /* 1031867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031877 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1031880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031899 */     // GIR_Coverage, 13433,
     /* 1031899 */     GIR_EraseRootFromParent_Done,
     /* 1031900 */   // Label 15307: @1031900
     /* 1031900 */   GIM_Try, /*On fail goto*//*Label 15308*/ GIMT_Encode4(1031977), // Rule ID 13436 //
     /* 1031905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1031916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1031919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1031922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1031925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031944 */     // MIs[0] policy
     /* 1031944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031954 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1031957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031976 */     // GIR_Coverage, 13436,
     /* 1031976 */     GIR_EraseRootFromParent_Done,
     /* 1031977 */   // Label 15308: @1031977
     /* 1031977 */   GIM_Try, /*On fail goto*//*Label 15309*/ GIMT_Encode4(1032054), // Rule ID 13437 //
     /* 1031982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1031993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1031996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1031999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1032002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032021 */     // MIs[0] policy
     /* 1032021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032031 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1032034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032053 */     // GIR_Coverage, 13437,
     /* 1032053 */     GIR_EraseRootFromParent_Done,
     /* 1032054 */   // Label 15309: @1032054
     /* 1032054 */   GIM_Try, /*On fail goto*//*Label 15310*/ GIMT_Encode4(1032131), // Rule ID 13440 //
     /* 1032059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1032070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1032073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1032076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1032079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032098 */     // MIs[0] policy
     /* 1032098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032130 */     // GIR_Coverage, 13440,
     /* 1032130 */     GIR_EraseRootFromParent_Done,
     /* 1032131 */   // Label 15310: @1032131
     /* 1032131 */   GIM_Try, /*On fail goto*//*Label 15311*/ GIMT_Encode4(1032208), // Rule ID 13441 //
     /* 1032136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1032147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1032150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1032153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1032156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032175 */     // MIs[0] policy
     /* 1032175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032185 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032207 */     // GIR_Coverage, 13441,
     /* 1032207 */     GIR_EraseRootFromParent_Done,
     /* 1032208 */   // Label 15311: @1032208
     /* 1032208 */   GIM_Try, /*On fail goto*//*Label 15312*/ GIMT_Encode4(1032285), // Rule ID 13444 //
     /* 1032213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1032224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1032227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1032230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1032233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032252 */     // MIs[0] policy
     /* 1032252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032262 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1032265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032284 */     // GIR_Coverage, 13444,
     /* 1032284 */     GIR_EraseRootFromParent_Done,
     /* 1032285 */   // Label 15312: @1032285
     /* 1032285 */   GIM_Try, /*On fail goto*//*Label 15313*/ GIMT_Encode4(1032362), // Rule ID 13445 //
     /* 1032290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1032301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1032304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1032307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1032310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032329 */     // MIs[0] policy
     /* 1032329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1032342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032361 */     // GIR_Coverage, 13445,
     /* 1032361 */     GIR_EraseRootFromParent_Done,
     /* 1032362 */   // Label 15313: @1032362
     /* 1032362 */   GIM_Try, /*On fail goto*//*Label 15314*/ GIMT_Encode4(1032439), // Rule ID 13448 //
     /* 1032367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1032378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1032381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1032384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1032387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032406 */     // MIs[0] policy
     /* 1032406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032416 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1032419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032438 */     // GIR_Coverage, 13448,
     /* 1032438 */     GIR_EraseRootFromParent_Done,
     /* 1032439 */   // Label 15314: @1032439
     /* 1032439 */   GIM_Try, /*On fail goto*//*Label 15315*/ GIMT_Encode4(1032516), // Rule ID 13449 //
     /* 1032444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1032455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1032458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1032461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1032464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032483 */     // MIs[0] policy
     /* 1032483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032493 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1032496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032515 */     // GIR_Coverage, 13449,
     /* 1032515 */     GIR_EraseRootFromParent_Done,
     /* 1032516 */   // Label 15315: @1032516
     /* 1032516 */   GIM_Try, /*On fail goto*//*Label 15316*/ GIMT_Encode4(1032593), // Rule ID 13452 //
     /* 1032521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1032532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1032535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1032538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1032541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032560 */     // MIs[0] policy
     /* 1032560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032570 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1032573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032592 */     // GIR_Coverage, 13452,
     /* 1032592 */     GIR_EraseRootFromParent_Done,
     /* 1032593 */   // Label 15316: @1032593
     /* 1032593 */   GIM_Try, /*On fail goto*//*Label 15317*/ GIMT_Encode4(1032670), // Rule ID 13453 //
     /* 1032598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1032609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1032612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1032615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1032618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032637 */     // MIs[0] policy
     /* 1032637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032647 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1032650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032669 */     // GIR_Coverage, 13453,
     /* 1032669 */     GIR_EraseRootFromParent_Done,
     /* 1032670 */   // Label 15317: @1032670
     /* 1032670 */   GIM_Try, /*On fail goto*//*Label 15318*/ GIMT_Encode4(1032747), // Rule ID 13456 //
     /* 1032675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1032686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1032689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1032692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1032695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032714 */     // MIs[0] policy
     /* 1032714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1032727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032746 */     // GIR_Coverage, 13456,
     /* 1032746 */     GIR_EraseRootFromParent_Done,
     /* 1032747 */   // Label 15318: @1032747
     /* 1032747 */   GIM_Try, /*On fail goto*//*Label 15319*/ GIMT_Encode4(1032824), // Rule ID 13457 //
     /* 1032752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1032763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1032766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1032769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1032772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032791 */     // MIs[0] policy
     /* 1032791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032801 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1032804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032823 */     // GIR_Coverage, 13457,
     /* 1032823 */     GIR_EraseRootFromParent_Done,
     /* 1032824 */   // Label 15319: @1032824
     /* 1032824 */   GIM_Try, /*On fail goto*//*Label 15320*/ GIMT_Encode4(1032901), // Rule ID 13460 //
     /* 1032829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1032840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1032843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1032846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1032849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032868 */     // MIs[0] policy
     /* 1032868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032878 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032900 */     // GIR_Coverage, 13460,
     /* 1032900 */     GIR_EraseRootFromParent_Done,
     /* 1032901 */   // Label 15320: @1032901
     /* 1032901 */   GIM_Try, /*On fail goto*//*Label 15321*/ GIMT_Encode4(1032978), // Rule ID 13461 //
     /* 1032906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1032917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1032920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1032923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1032926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032945 */     // MIs[0] policy
     /* 1032945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032955 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032977 */     // GIR_Coverage, 13461,
     /* 1032977 */     GIR_EraseRootFromParent_Done,
     /* 1032978 */   // Label 15321: @1032978
     /* 1032978 */   GIM_Try, /*On fail goto*//*Label 15322*/ GIMT_Encode4(1033055), // Rule ID 13464 //
     /* 1032983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1032994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1032997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1033000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1033003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033022 */     // MIs[0] policy
     /* 1033022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033054 */     // GIR_Coverage, 13464,
     /* 1033054 */     GIR_EraseRootFromParent_Done,
     /* 1033055 */   // Label 15322: @1033055
     /* 1033055 */   GIM_Try, /*On fail goto*//*Label 15323*/ GIMT_Encode4(1033132), // Rule ID 13465 //
     /* 1033060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1033071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1033074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1033077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1033080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033099 */     // MIs[0] policy
     /* 1033099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033109 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033131 */     // GIR_Coverage, 13465,
     /* 1033131 */     GIR_EraseRootFromParent_Done,
     /* 1033132 */   // Label 15323: @1033132
     /* 1033132 */   GIM_Try, /*On fail goto*//*Label 15324*/ GIMT_Encode4(1033209), // Rule ID 13468 //
     /* 1033137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1033148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1033151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1033154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1033157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033176 */     // MIs[0] policy
     /* 1033176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033186 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033208 */     // GIR_Coverage, 13468,
     /* 1033208 */     GIR_EraseRootFromParent_Done,
     /* 1033209 */   // Label 15324: @1033209
     /* 1033209 */   GIM_Try, /*On fail goto*//*Label 15325*/ GIMT_Encode4(1033286), // Rule ID 13469 //
     /* 1033214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1033225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1033228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1033231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1033234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033253 */     // MIs[0] policy
     /* 1033253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033263 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033285 */     // GIR_Coverage, 13469,
     /* 1033285 */     GIR_EraseRootFromParent_Done,
     /* 1033286 */   // Label 15325: @1033286
     /* 1033286 */   GIM_Try, /*On fail goto*//*Label 15326*/ GIMT_Encode4(1033363), // Rule ID 13472 //
     /* 1033291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1033302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1033305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1033308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1033311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033330 */     // MIs[0] policy
     /* 1033330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033340 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033362 */     // GIR_Coverage, 13472,
     /* 1033362 */     GIR_EraseRootFromParent_Done,
     /* 1033363 */   // Label 15326: @1033363
     /* 1033363 */   GIM_Try, /*On fail goto*//*Label 15327*/ GIMT_Encode4(1033440), // Rule ID 13473 //
     /* 1033368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1033379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1033382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1033385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1033388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033407 */     // MIs[0] policy
     /* 1033407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033417 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033439 */     // GIR_Coverage, 13473,
     /* 1033439 */     GIR_EraseRootFromParent_Done,
     /* 1033440 */   // Label 15327: @1033440
     /* 1033440 */   GIM_Try, /*On fail goto*//*Label 15328*/ GIMT_Encode4(1033517), // Rule ID 13476 //
     /* 1033445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1033448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1033456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1033459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1033462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1033465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033484 */     // MIs[0] policy
     /* 1033484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1033497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033516 */     // GIR_Coverage, 13476,
     /* 1033516 */     GIR_EraseRootFromParent_Done,
     /* 1033517 */   // Label 15328: @1033517
     /* 1033517 */   GIM_Try, /*On fail goto*//*Label 15329*/ GIMT_Encode4(1033594), // Rule ID 13477 //
     /* 1033522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1033533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1033536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1033539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1033542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033561 */     // MIs[0] policy
     /* 1033561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033571 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1033574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033593 */     // GIR_Coverage, 13477,
     /* 1033593 */     GIR_EraseRootFromParent_Done,
     /* 1033594 */   // Label 15329: @1033594
     /* 1033594 */   GIM_Try, /*On fail goto*//*Label 15330*/ GIMT_Encode4(1033671), // Rule ID 13480 //
     /* 1033599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1033602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1033610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1033613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1033616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1033619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033638 */     // MIs[0] policy
     /* 1033638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033648 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033670 */     // GIR_Coverage, 13480,
     /* 1033670 */     GIR_EraseRootFromParent_Done,
     /* 1033671 */   // Label 15330: @1033671
     /* 1033671 */   GIM_Try, /*On fail goto*//*Label 15331*/ GIMT_Encode4(1033748), // Rule ID 13481 //
     /* 1033676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1033687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1033690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1033693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1033696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033715 */     // MIs[0] policy
     /* 1033715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033725 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033747 */     // GIR_Coverage, 13481,
     /* 1033747 */     GIR_EraseRootFromParent_Done,
     /* 1033748 */   // Label 15331: @1033748
     /* 1033748 */   GIM_Try, /*On fail goto*//*Label 15332*/ GIMT_Encode4(1033825), // Rule ID 13484 //
     /* 1033753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1033756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1033764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1033767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1033770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1033773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033792 */     // MIs[0] policy
     /* 1033792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033802 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033824 */     // GIR_Coverage, 13484,
     /* 1033824 */     GIR_EraseRootFromParent_Done,
     /* 1033825 */   // Label 15332: @1033825
     /* 1033825 */   GIM_Try, /*On fail goto*//*Label 15333*/ GIMT_Encode4(1033902), // Rule ID 13485 //
     /* 1033830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1033841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1033844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1033847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1033850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033869 */     // MIs[0] policy
     /* 1033869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033879 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033901 */     // GIR_Coverage, 13485,
     /* 1033901 */     GIR_EraseRootFromParent_Done,
     /* 1033902 */   // Label 15333: @1033902
     /* 1033902 */   GIM_Try, /*On fail goto*//*Label 15334*/ GIMT_Encode4(1033979), // Rule ID 13488 //
     /* 1033907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1033910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1033918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1033921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1033924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1033927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033946 */     // MIs[0] policy
     /* 1033946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033956 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033978 */     // GIR_Coverage, 13488,
     /* 1033978 */     GIR_EraseRootFromParent_Done,
     /* 1033979 */   // Label 15334: @1033979
     /* 1033979 */   GIM_Try, /*On fail goto*//*Label 15335*/ GIMT_Encode4(1034056), // Rule ID 13489 //
     /* 1033984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1033995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1033998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1034001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1034004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034023 */     // MIs[0] policy
     /* 1034023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034033 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1034036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034055 */     // GIR_Coverage, 13489,
     /* 1034055 */     GIR_EraseRootFromParent_Done,
     /* 1034056 */   // Label 15335: @1034056
     /* 1034056 */   GIM_Try, /*On fail goto*//*Label 15336*/ GIMT_Encode4(1034133), // Rule ID 13492 //
     /* 1034061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1034072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1034075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1034081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034100 */     // MIs[0] policy
     /* 1034100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034110 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1034113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034132 */     // GIR_Coverage, 13492,
     /* 1034132 */     GIR_EraseRootFromParent_Done,
     /* 1034133 */   // Label 15336: @1034133
     /* 1034133 */   GIM_Try, /*On fail goto*//*Label 15337*/ GIMT_Encode4(1034210), // Rule ID 13493 //
     /* 1034138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1034149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1034152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1034158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034177 */     // MIs[0] policy
     /* 1034177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034187 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1034190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034209 */     // GIR_Coverage, 13493,
     /* 1034209 */     GIR_EraseRootFromParent_Done,
     /* 1034210 */   // Label 15337: @1034210
     /* 1034210 */   GIM_Try, /*On fail goto*//*Label 15338*/ GIMT_Encode4(1034287), // Rule ID 13496 //
     /* 1034215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1034226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1034229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1034235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034254 */     // MIs[0] policy
     /* 1034254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1034267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034286 */     // GIR_Coverage, 13496,
     /* 1034286 */     GIR_EraseRootFromParent_Done,
     /* 1034287 */   // Label 15338: @1034287
     /* 1034287 */   GIM_Try, /*On fail goto*//*Label 15339*/ GIMT_Encode4(1034364), // Rule ID 13497 //
     /* 1034292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1034303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1034306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1034312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034331 */     // MIs[0] policy
     /* 1034331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034341 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1034344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034363 */     // GIR_Coverage, 13497,
     /* 1034363 */     GIR_EraseRootFromParent_Done,
     /* 1034364 */   // Label 15339: @1034364
     /* 1034364 */   GIM_Try, /*On fail goto*//*Label 15340*/ GIMT_Encode4(1034441), // Rule ID 13500 //
     /* 1034369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1034380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1034383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1034389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034408 */     // MIs[0] policy
     /* 1034408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034418 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1034421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034440 */     // GIR_Coverage, 13500,
     /* 1034440 */     GIR_EraseRootFromParent_Done,
     /* 1034441 */   // Label 15340: @1034441
     /* 1034441 */   GIM_Try, /*On fail goto*//*Label 15341*/ GIMT_Encode4(1034518), // Rule ID 13501 //
     /* 1034446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1034457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1034460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1034466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034485 */     // MIs[0] policy
     /* 1034485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034495 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1034498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034517 */     // GIR_Coverage, 13501,
     /* 1034517 */     GIR_EraseRootFromParent_Done,
     /* 1034518 */   // Label 15341: @1034518
     /* 1034518 */   GIM_Try, /*On fail goto*//*Label 15342*/ GIMT_Encode4(1034595), // Rule ID 13504 //
     /* 1034523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1034534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1034537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1034543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034562 */     // MIs[0] policy
     /* 1034562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034572 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1034575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034594 */     // GIR_Coverage, 13504,
     /* 1034594 */     GIR_EraseRootFromParent_Done,
     /* 1034595 */   // Label 15342: @1034595
     /* 1034595 */   GIM_Try, /*On fail goto*//*Label 15343*/ GIMT_Encode4(1034672), // Rule ID 13505 //
     /* 1034600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1034611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1034614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1034620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034639 */     // MIs[0] policy
     /* 1034639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034649 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1034652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034671 */     // GIR_Coverage, 13505,
     /* 1034671 */     GIR_EraseRootFromParent_Done,
     /* 1034672 */   // Label 15343: @1034672
     /* 1034672 */   GIM_Try, /*On fail goto*//*Label 15344*/ GIMT_Encode4(1034749), // Rule ID 13508 //
     /* 1034677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1034688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1034691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1034697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034716 */     // MIs[0] policy
     /* 1034716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034726 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1034729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034748 */     // GIR_Coverage, 13508,
     /* 1034748 */     GIR_EraseRootFromParent_Done,
     /* 1034749 */   // Label 15344: @1034749
     /* 1034749 */   GIM_Try, /*On fail goto*//*Label 15345*/ GIMT_Encode4(1034826), // Rule ID 13509 //
     /* 1034754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1034765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1034768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1034774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034793 */     // MIs[0] policy
     /* 1034793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034803 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1034806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034825 */     // GIR_Coverage, 13509,
     /* 1034825 */     GIR_EraseRootFromParent_Done,
     /* 1034826 */   // Label 15345: @1034826
     /* 1034826 */   GIM_Try, /*On fail goto*//*Label 15346*/ GIMT_Encode4(1034903), // Rule ID 13512 //
     /* 1034831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1034842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1034845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1034851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034870 */     // MIs[0] policy
     /* 1034870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034880 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1034883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034902 */     // GIR_Coverage, 13512,
     /* 1034902 */     GIR_EraseRootFromParent_Done,
     /* 1034903 */   // Label 15346: @1034903
     /* 1034903 */   GIM_Try, /*On fail goto*//*Label 15347*/ GIMT_Encode4(1034980), // Rule ID 13513 //
     /* 1034908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1034919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1034922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1034928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034947 */     // MIs[0] policy
     /* 1034947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034957 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1034960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034979 */     // GIR_Coverage, 13513,
     /* 1034979 */     GIR_EraseRootFromParent_Done,
     /* 1034980 */   // Label 15347: @1034980
     /* 1034980 */   GIM_Try, /*On fail goto*//*Label 15348*/ GIMT_Encode4(1035057), // Rule ID 13516 //
     /* 1034985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1034996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1034999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1035005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035024 */     // MIs[0] policy
     /* 1035024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1035037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035056 */     // GIR_Coverage, 13516,
     /* 1035056 */     GIR_EraseRootFromParent_Done,
     /* 1035057 */   // Label 15348: @1035057
     /* 1035057 */   GIM_Try, /*On fail goto*//*Label 15349*/ GIMT_Encode4(1035134), // Rule ID 13517 //
     /* 1035062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1035073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1035076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1035082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035101 */     // MIs[0] policy
     /* 1035101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035111 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1035114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035133 */     // GIR_Coverage, 13517,
     /* 1035133 */     GIR_EraseRootFromParent_Done,
     /* 1035134 */   // Label 15349: @1035134
     /* 1035134 */   GIM_Try, /*On fail goto*//*Label 15350*/ GIMT_Encode4(1035211), // Rule ID 13520 //
     /* 1035139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1035150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1035153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1035159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035178 */     // MIs[0] policy
     /* 1035178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035188 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035210 */     // GIR_Coverage, 13520,
     /* 1035210 */     GIR_EraseRootFromParent_Done,
     /* 1035211 */   // Label 15350: @1035211
     /* 1035211 */   GIM_Try, /*On fail goto*//*Label 15351*/ GIMT_Encode4(1035288), // Rule ID 13521 //
     /* 1035216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1035227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1035230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1035236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035255 */     // MIs[0] policy
     /* 1035255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035265 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035287 */     // GIR_Coverage, 13521,
     /* 1035287 */     GIR_EraseRootFromParent_Done,
     /* 1035288 */   // Label 15351: @1035288
     /* 1035288 */   GIM_Try, /*On fail goto*//*Label 15352*/ GIMT_Encode4(1035365), // Rule ID 13524 //
     /* 1035293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1035304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1035307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1035313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035332 */     // MIs[0] policy
     /* 1035332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035364 */     // GIR_Coverage, 13524,
     /* 1035364 */     GIR_EraseRootFromParent_Done,
     /* 1035365 */   // Label 15352: @1035365
     /* 1035365 */   GIM_Try, /*On fail goto*//*Label 15353*/ GIMT_Encode4(1035442), // Rule ID 13525 //
     /* 1035370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1035381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1035384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1035390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035409 */     // MIs[0] policy
     /* 1035409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035419 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035441 */     // GIR_Coverage, 13525,
     /* 1035441 */     GIR_EraseRootFromParent_Done,
     /* 1035442 */   // Label 15353: @1035442
     /* 1035442 */   GIM_Try, /*On fail goto*//*Label 15354*/ GIMT_Encode4(1035519), // Rule ID 13528 //
     /* 1035447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1035458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1035461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1035467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035486 */     // MIs[0] policy
     /* 1035486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1035499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035518 */     // GIR_Coverage, 13528,
     /* 1035518 */     GIR_EraseRootFromParent_Done,
     /* 1035519 */   // Label 15354: @1035519
     /* 1035519 */   GIM_Try, /*On fail goto*//*Label 15355*/ GIMT_Encode4(1035596), // Rule ID 13529 //
     /* 1035524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1035535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1035538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1035544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035563 */     // MIs[0] policy
     /* 1035563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035573 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1035576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035595 */     // GIR_Coverage, 13529,
     /* 1035595 */     GIR_EraseRootFromParent_Done,
     /* 1035596 */   // Label 15355: @1035596
     /* 1035596 */   GIM_Try, /*On fail goto*//*Label 15356*/ GIMT_Encode4(1035673), // Rule ID 13532 //
     /* 1035601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1035612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1035615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1035621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035640 */     // MIs[0] policy
     /* 1035640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035650 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1035653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035672 */     // GIR_Coverage, 13532,
     /* 1035672 */     GIR_EraseRootFromParent_Done,
     /* 1035673 */   // Label 15356: @1035673
     /* 1035673 */   GIM_Try, /*On fail goto*//*Label 15357*/ GIMT_Encode4(1035750), // Rule ID 13533 //
     /* 1035678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1035689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1035692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1035698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035717 */     // MIs[0] policy
     /* 1035717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035727 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1035730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035749 */     // GIR_Coverage, 13533,
     /* 1035749 */     GIR_EraseRootFromParent_Done,
     /* 1035750 */   // Label 15357: @1035750
     /* 1035750 */   GIM_Try, /*On fail goto*//*Label 15358*/ GIMT_Encode4(1035827), // Rule ID 13536 //
     /* 1035755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1035758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1035766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1035769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1035775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035794 */     // MIs[0] policy
     /* 1035794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035804 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035826 */     // GIR_Coverage, 13536,
     /* 1035826 */     GIR_EraseRootFromParent_Done,
     /* 1035827 */   // Label 15358: @1035827
     /* 1035827 */   GIM_Try, /*On fail goto*//*Label 15359*/ GIMT_Encode4(1035904), // Rule ID 13537 //
     /* 1035832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1035835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1035843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1035846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1035852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035871 */     // MIs[0] policy
     /* 1035871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035881 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035903 */     // GIR_Coverage, 13537,
     /* 1035903 */     GIR_EraseRootFromParent_Done,
     /* 1035904 */   // Label 15359: @1035904
     /* 1035904 */   GIM_Try, /*On fail goto*//*Label 15360*/ GIMT_Encode4(1035981), // Rule ID 13540 //
     /* 1035909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1035912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1035920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1035923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1035929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035948 */     // MIs[0] policy
     /* 1035948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035958 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035980 */     // GIR_Coverage, 13540,
     /* 1035980 */     GIR_EraseRootFromParent_Done,
     /* 1035981 */   // Label 15360: @1035981
     /* 1035981 */   GIM_Try, /*On fail goto*//*Label 15361*/ GIMT_Encode4(1036058), // Rule ID 13541 //
     /* 1035986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1035989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1035997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1036000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1036006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036025 */     // MIs[0] policy
     /* 1036025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036035 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1036038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036057 */     // GIR_Coverage, 13541,
     /* 1036057 */     GIR_EraseRootFromParent_Done,
     /* 1036058 */   // Label 15361: @1036058
     /* 1036058 */   GIM_Try, /*On fail goto*//*Label 15362*/ GIMT_Encode4(1036135), // Rule ID 13544 //
     /* 1036063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1036066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1036074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1036077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1036083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036102 */     // MIs[0] policy
     /* 1036102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036112 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1036115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036134 */     // GIR_Coverage, 13544,
     /* 1036134 */     GIR_EraseRootFromParent_Done,
     /* 1036135 */   // Label 15362: @1036135
     /* 1036135 */   GIM_Try, /*On fail goto*//*Label 15363*/ GIMT_Encode4(1036212), // Rule ID 13545 //
     /* 1036140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1036143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1036151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1036154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1036160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036179 */     // MIs[0] policy
     /* 1036179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036189 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1036192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036211 */     // GIR_Coverage, 13545,
     /* 1036211 */     GIR_EraseRootFromParent_Done,
     /* 1036212 */   // Label 15363: @1036212
     /* 1036212 */   GIM_Try, /*On fail goto*//*Label 15364*/ GIMT_Encode4(1036289), // Rule ID 13548 //
     /* 1036217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1036220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1036228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1036231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1036237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036256 */     // MIs[0] policy
     /* 1036256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036266 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1036269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036288 */     // GIR_Coverage, 13548,
     /* 1036288 */     GIR_EraseRootFromParent_Done,
     /* 1036289 */   // Label 15364: @1036289
     /* 1036289 */   GIM_Try, /*On fail goto*//*Label 15365*/ GIMT_Encode4(1036366), // Rule ID 13549 //
     /* 1036294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1036297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1036305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1036308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1036314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036333 */     // MIs[0] policy
     /* 1036333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036343 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1036346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036365 */     // GIR_Coverage, 13549,
     /* 1036365 */     GIR_EraseRootFromParent_Done,
     /* 1036366 */   // Label 15365: @1036366
     /* 1036366 */   GIM_Try, /*On fail goto*//*Label 15366*/ GIMT_Encode4(1036443), // Rule ID 13552 //
     /* 1036371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1036382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1036385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1036388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1036391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036410 */     // MIs[0] policy
     /* 1036410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036420 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1036423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036442 */     // GIR_Coverage, 13552,
     /* 1036442 */     GIR_EraseRootFromParent_Done,
     /* 1036443 */   // Label 15366: @1036443
     /* 1036443 */   GIM_Try, /*On fail goto*//*Label 15367*/ GIMT_Encode4(1036520), // Rule ID 13553 //
     /* 1036448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1036459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1036462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1036465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1036468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036487 */     // MIs[0] policy
     /* 1036487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036497 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1036500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036519 */     // GIR_Coverage, 13553,
     /* 1036519 */     GIR_EraseRootFromParent_Done,
     /* 1036520 */   // Label 15367: @1036520
     /* 1036520 */   GIM_Try, /*On fail goto*//*Label 15368*/ GIMT_Encode4(1036597), // Rule ID 13556 //
     /* 1036525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1036536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1036539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1036542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1036545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036564 */     // MIs[0] policy
     /* 1036564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036574 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1036577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036596 */     // GIR_Coverage, 13556,
     /* 1036596 */     GIR_EraseRootFromParent_Done,
     /* 1036597 */   // Label 15368: @1036597
     /* 1036597 */   GIM_Try, /*On fail goto*//*Label 15369*/ GIMT_Encode4(1036674), // Rule ID 13557 //
     /* 1036602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1036613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1036616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1036619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1036622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036641 */     // MIs[0] policy
     /* 1036641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036651 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1036654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036673 */     // GIR_Coverage, 13557,
     /* 1036673 */     GIR_EraseRootFromParent_Done,
     /* 1036674 */   // Label 15369: @1036674
     /* 1036674 */   GIM_Try, /*On fail goto*//*Label 15370*/ GIMT_Encode4(1036751), // Rule ID 13560 //
     /* 1036679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1036690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1036693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1036696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1036699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036718 */     // MIs[0] policy
     /* 1036718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036728 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1036731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036750 */     // GIR_Coverage, 13560,
     /* 1036750 */     GIR_EraseRootFromParent_Done,
     /* 1036751 */   // Label 15370: @1036751
     /* 1036751 */   GIM_Try, /*On fail goto*//*Label 15371*/ GIMT_Encode4(1036828), // Rule ID 13561 //
     /* 1036756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1036767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1036770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1036773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1036776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036795 */     // MIs[0] policy
     /* 1036795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036805 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1036808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036827 */     // GIR_Coverage, 13561,
     /* 1036827 */     GIR_EraseRootFromParent_Done,
     /* 1036828 */   // Label 15371: @1036828
     /* 1036828 */   GIM_Try, /*On fail goto*//*Label 15372*/ GIMT_Encode4(1036905), // Rule ID 13564 //
     /* 1036833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1036844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1036847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1036850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1036853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036872 */     // MIs[0] policy
     /* 1036872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036882 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11661:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1036885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036904 */     // GIR_Coverage, 13564,
     /* 1036904 */     GIR_EraseRootFromParent_Done,
     /* 1036905 */   // Label 15372: @1036905
     /* 1036905 */   GIM_Try, /*On fail goto*//*Label 15373*/ GIMT_Encode4(1036982), // Rule ID 13565 //
     /* 1036910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1036921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1036924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1036927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1036930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036949 */     // MIs[0] policy
     /* 1036949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036959 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11661:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1036962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036981 */     // GIR_Coverage, 13565,
     /* 1036981 */     GIR_EraseRootFromParent_Done,
     /* 1036982 */   // Label 15373: @1036982
     /* 1036982 */   GIM_Try, /*On fail goto*//*Label 15374*/ GIMT_Encode4(1037059), // Rule ID 13568 //
     /* 1036987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1036998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1037001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1037004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1037007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037026 */     // MIs[0] policy
     /* 1037026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037036 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11661:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037058 */     // GIR_Coverage, 13568,
     /* 1037058 */     GIR_EraseRootFromParent_Done,
     /* 1037059 */   // Label 15374: @1037059
     /* 1037059 */   GIM_Try, /*On fail goto*//*Label 15375*/ GIMT_Encode4(1037136), // Rule ID 13569 //
     /* 1037064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1037075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1037078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1037081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1037084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037103 */     // MIs[0] policy
     /* 1037103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037113 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11661:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037135 */     // GIR_Coverage, 13569,
     /* 1037135 */     GIR_EraseRootFromParent_Done,
     /* 1037136 */   // Label 15375: @1037136
     /* 1037136 */   GIM_Try, /*On fail goto*//*Label 15376*/ GIMT_Encode4(1037213), // Rule ID 13572 //
     /* 1037141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1037152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1037155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1037158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1037161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037180 */     // MIs[0] policy
     /* 1037180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037190 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11661:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1037193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037212 */     // GIR_Coverage, 13572,
     /* 1037212 */     GIR_EraseRootFromParent_Done,
     /* 1037213 */   // Label 15376: @1037213
     /* 1037213 */   GIM_Try, /*On fail goto*//*Label 15377*/ GIMT_Encode4(1037290), // Rule ID 13573 //
     /* 1037218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1037229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1037232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1037235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1037238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037257 */     // MIs[0] policy
     /* 1037257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037267 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11661:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1037270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037289 */     // GIR_Coverage, 13573,
     /* 1037289 */     GIR_EraseRootFromParent_Done,
     /* 1037290 */   // Label 15377: @1037290
     /* 1037290 */   GIM_Try, /*On fail goto*//*Label 15378*/ GIMT_Encode4(1037367), // Rule ID 13576 //
     /* 1037295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1037306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1037309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1037312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1037315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037334 */     // MIs[0] policy
     /* 1037334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037344 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1037347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037366 */     // GIR_Coverage, 13576,
     /* 1037366 */     GIR_EraseRootFromParent_Done,
     /* 1037367 */   // Label 15378: @1037367
     /* 1037367 */   GIM_Try, /*On fail goto*//*Label 15379*/ GIMT_Encode4(1037444), // Rule ID 13577 //
     /* 1037372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1037383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1037386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1037389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1037392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037411 */     // MIs[0] policy
     /* 1037411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1037424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037443 */     // GIR_Coverage, 13577,
     /* 1037443 */     GIR_EraseRootFromParent_Done,
     /* 1037444 */   // Label 15379: @1037444
     /* 1037444 */   GIM_Try, /*On fail goto*//*Label 15380*/ GIMT_Encode4(1037521), // Rule ID 13580 //
     /* 1037449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1037460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1037463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1037466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1037469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037488 */     // MIs[0] policy
     /* 1037488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037498 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1037501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037520 */     // GIR_Coverage, 13580,
     /* 1037520 */     GIR_EraseRootFromParent_Done,
     /* 1037521 */   // Label 15380: @1037521
     /* 1037521 */   GIM_Try, /*On fail goto*//*Label 15381*/ GIMT_Encode4(1037598), // Rule ID 13581 //
     /* 1037526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1037537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1037540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1037543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1037546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037565 */     // MIs[0] policy
     /* 1037565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037575 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1037578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037597 */     // GIR_Coverage, 13581,
     /* 1037597 */     GIR_EraseRootFromParent_Done,
     /* 1037598 */   // Label 15381: @1037598
     /* 1037598 */   GIM_Try, /*On fail goto*//*Label 15382*/ GIMT_Encode4(1037675), // Rule ID 13584 //
     /* 1037603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1037614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1037617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1037620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1037623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037642 */     // MIs[0] policy
     /* 1037642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037652 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11661:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1037655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037674 */     // GIR_Coverage, 13584,
     /* 1037674 */     GIR_EraseRootFromParent_Done,
     /* 1037675 */   // Label 15382: @1037675
     /* 1037675 */   GIM_Try, /*On fail goto*//*Label 15383*/ GIMT_Encode4(1037752), // Rule ID 13585 //
     /* 1037680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1037691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1037694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1037697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1037700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037719 */     // MIs[0] policy
     /* 1037719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037729 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11661:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1037732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037751 */     // GIR_Coverage, 13585,
     /* 1037751 */     GIR_EraseRootFromParent_Done,
     /* 1037752 */   // Label 15383: @1037752
     /* 1037752 */   GIM_Try, /*On fail goto*//*Label 15384*/ GIMT_Encode4(1037829), // Rule ID 13588 //
     /* 1037757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1037768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1037771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1037774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1037777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037796 */     // MIs[0] policy
     /* 1037796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037806 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11661:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037828 */     // GIR_Coverage, 13588,
     /* 1037828 */     GIR_EraseRootFromParent_Done,
     /* 1037829 */   // Label 15384: @1037829
     /* 1037829 */   GIM_Try, /*On fail goto*//*Label 15385*/ GIMT_Encode4(1037906), // Rule ID 13589 //
     /* 1037834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1037845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1037848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1037851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1037854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037873 */     // MIs[0] policy
     /* 1037873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037883 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11661:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037905 */     // GIR_Coverage, 13589,
     /* 1037905 */     GIR_EraseRootFromParent_Done,
     /* 1037906 */   // Label 15385: @1037906
     /* 1037906 */   GIM_Try, /*On fail goto*//*Label 15386*/ GIMT_Encode4(1037983), // Rule ID 13592 //
     /* 1037911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1037922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1037925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1037928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1037931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037950 */     // MIs[0] policy
     /* 1037950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11661:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1037963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037982 */     // GIR_Coverage, 13592,
     /* 1037982 */     GIR_EraseRootFromParent_Done,
     /* 1037983 */   // Label 15386: @1037983
     /* 1037983 */   GIM_Try, /*On fail goto*//*Label 15387*/ GIMT_Encode4(1038060), // Rule ID 13593 //
     /* 1037988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1037999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1038002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1038005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1038008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038027 */     // MIs[0] policy
     /* 1038027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038037 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11661:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1038040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038059 */     // GIR_Coverage, 13593,
     /* 1038059 */     GIR_EraseRootFromParent_Done,
     /* 1038060 */   // Label 15387: @1038060
     /* 1038060 */   GIM_Try, /*On fail goto*//*Label 15388*/ GIMT_Encode4(1038137), // Rule ID 13596 //
     /* 1038065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1038076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1038079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1038082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1038085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038104 */     // MIs[0] policy
     /* 1038104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038114 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1038117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038136 */     // GIR_Coverage, 13596,
     /* 1038136 */     GIR_EraseRootFromParent_Done,
     /* 1038137 */   // Label 15388: @1038137
     /* 1038137 */   GIM_Try, /*On fail goto*//*Label 15389*/ GIMT_Encode4(1038214), // Rule ID 13597 //
     /* 1038142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1038153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1038156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1038159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1038162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038181 */     // MIs[0] policy
     /* 1038181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038191 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1038194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038213 */     // GIR_Coverage, 13597,
     /* 1038213 */     GIR_EraseRootFromParent_Done,
     /* 1038214 */   // Label 15389: @1038214
     /* 1038214 */   GIM_Try, /*On fail goto*//*Label 15390*/ GIMT_Encode4(1038291), // Rule ID 13600 //
     /* 1038219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1038230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1038233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1038236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1038239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038258 */     // MIs[0] policy
     /* 1038258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038268 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11661:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1038271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038290 */     // GIR_Coverage, 13600,
     /* 1038290 */     GIR_EraseRootFromParent_Done,
     /* 1038291 */   // Label 15390: @1038291
     /* 1038291 */   GIM_Try, /*On fail goto*//*Label 15391*/ GIMT_Encode4(1038368), // Rule ID 13601 //
     /* 1038296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1038307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1038310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1038313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1038316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038335 */     // MIs[0] policy
     /* 1038335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038345 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11661:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1038348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038367 */     // GIR_Coverage, 13601,
     /* 1038367 */     GIR_EraseRootFromParent_Done,
     /* 1038368 */   // Label 15391: @1038368
     /* 1038368 */   GIM_Try, /*On fail goto*//*Label 15392*/ GIMT_Encode4(1038445), // Rule ID 13604 //
     /* 1038373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1038384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1038387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1038390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1038393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038412 */     // MIs[0] policy
     /* 1038412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038422 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11661:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1038425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038444 */     // GIR_Coverage, 13604,
     /* 1038444 */     GIR_EraseRootFromParent_Done,
     /* 1038445 */   // Label 15392: @1038445
     /* 1038445 */   GIM_Try, /*On fail goto*//*Label 15393*/ GIMT_Encode4(1038522), // Rule ID 13605 //
     /* 1038450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1038461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1038464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1038467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1038470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038489 */     // MIs[0] policy
     /* 1038489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038499 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11661:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1038502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038521 */     // GIR_Coverage, 13605,
     /* 1038521 */     GIR_EraseRootFromParent_Done,
     /* 1038522 */   // Label 15393: @1038522
     /* 1038522 */   GIM_Try, /*On fail goto*//*Label 15394*/ GIMT_Encode4(1038599), // Rule ID 13608 //
     /* 1038527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1038538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1038541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1038544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1038547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038566 */     // MIs[0] policy
     /* 1038566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038576 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11661:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1038579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038598 */     // GIR_Coverage, 13608,
     /* 1038598 */     GIR_EraseRootFromParent_Done,
     /* 1038599 */   // Label 15394: @1038599
     /* 1038599 */   GIM_Try, /*On fail goto*//*Label 15395*/ GIMT_Encode4(1038676), // Rule ID 13609 //
     /* 1038604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1038615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1038618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1038621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1038624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038643 */     // MIs[0] policy
     /* 1038643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038653 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11661:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1038656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038675 */     // GIR_Coverage, 13609,
     /* 1038675 */     GIR_EraseRootFromParent_Done,
     /* 1038676 */   // Label 15395: @1038676
     /* 1038676 */   GIM_Try, /*On fail goto*//*Label 15396*/ GIMT_Encode4(1038753), // Rule ID 13612 //
     /* 1038681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1038692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1038695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1038701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038720 */     // MIs[0] policy
     /* 1038720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038730 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1038733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038752 */     // GIR_Coverage, 13612,
     /* 1038752 */     GIR_EraseRootFromParent_Done,
     /* 1038753 */   // Label 15396: @1038753
     /* 1038753 */   GIM_Try, /*On fail goto*//*Label 15397*/ GIMT_Encode4(1038830), // Rule ID 13613 //
     /* 1038758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1038769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1038772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1038778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038797 */     // MIs[0] policy
     /* 1038797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038807 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1038810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038829 */     // GIR_Coverage, 13613,
     /* 1038829 */     GIR_EraseRootFromParent_Done,
     /* 1038830 */   // Label 15397: @1038830
     /* 1038830 */   GIM_Try, /*On fail goto*//*Label 15398*/ GIMT_Encode4(1038907), // Rule ID 13616 //
     /* 1038835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1038846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1038849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1038855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038874 */     // MIs[0] policy
     /* 1038874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038884 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1038887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038906 */     // GIR_Coverage, 13616,
     /* 1038906 */     GIR_EraseRootFromParent_Done,
     /* 1038907 */   // Label 15398: @1038907
     /* 1038907 */   GIM_Try, /*On fail goto*//*Label 15399*/ GIMT_Encode4(1038984), // Rule ID 13617 //
     /* 1038912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1038923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1038926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1038932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038951 */     // MIs[0] policy
     /* 1038951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038961 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1038964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038983 */     // GIR_Coverage, 13617,
     /* 1038983 */     GIR_EraseRootFromParent_Done,
     /* 1038984 */   // Label 15399: @1038984
     /* 1038984 */   GIM_Try, /*On fail goto*//*Label 15400*/ GIMT_Encode4(1039061), // Rule ID 13620 //
     /* 1038989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1039000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1039003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1039009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039028 */     // MIs[0] policy
     /* 1039028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039038 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039060 */     // GIR_Coverage, 13620,
     /* 1039060 */     GIR_EraseRootFromParent_Done,
     /* 1039061 */   // Label 15400: @1039061
     /* 1039061 */   GIM_Try, /*On fail goto*//*Label 15401*/ GIMT_Encode4(1039138), // Rule ID 13621 //
     /* 1039066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1039077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1039080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1039086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039105 */     // MIs[0] policy
     /* 1039105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039115 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039137 */     // GIR_Coverage, 13621,
     /* 1039137 */     GIR_EraseRootFromParent_Done,
     /* 1039138 */   // Label 15401: @1039138
     /* 1039138 */   GIM_Try, /*On fail goto*//*Label 15402*/ GIMT_Encode4(1039215), // Rule ID 13624 //
     /* 1039143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1039154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1039157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1039163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039182 */     // MIs[0] policy
     /* 1039182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039192 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11661:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1039195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039214 */     // GIR_Coverage, 13624,
     /* 1039214 */     GIR_EraseRootFromParent_Done,
     /* 1039215 */   // Label 15402: @1039215
     /* 1039215 */   GIM_Try, /*On fail goto*//*Label 15403*/ GIMT_Encode4(1039292), // Rule ID 13625 //
     /* 1039220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1039231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1039234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1039240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039259 */     // MIs[0] policy
     /* 1039259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11661:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1039272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039291 */     // GIR_Coverage, 13625,
     /* 1039291 */     GIR_EraseRootFromParent_Done,
     /* 1039292 */   // Label 15403: @1039292
     /* 1039292 */   GIM_Try, /*On fail goto*//*Label 15404*/ GIMT_Encode4(1039369), // Rule ID 13628 //
     /* 1039297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1039308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1039311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1039317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039336 */     // MIs[0] policy
     /* 1039336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039346 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11661:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1039349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039368 */     // GIR_Coverage, 13628,
     /* 1039368 */     GIR_EraseRootFromParent_Done,
     /* 1039369 */   // Label 15404: @1039369
     /* 1039369 */   GIM_Try, /*On fail goto*//*Label 15405*/ GIMT_Encode4(1039446), // Rule ID 13629 //
     /* 1039374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1039385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1039388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1039394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039413 */     // MIs[0] policy
     /* 1039413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039423 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11661:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1039426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039445 */     // GIR_Coverage, 13629,
     /* 1039445 */     GIR_EraseRootFromParent_Done,
     /* 1039446 */   // Label 15405: @1039446
     /* 1039446 */   GIM_Try, /*On fail goto*//*Label 15406*/ GIMT_Encode4(1039523), // Rule ID 13632 //
     /* 1039451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1039462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1039465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1039471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039490 */     // MIs[0] policy
     /* 1039490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039500 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11661:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1039503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039522 */     // GIR_Coverage, 13632,
     /* 1039522 */     GIR_EraseRootFromParent_Done,
     /* 1039523 */   // Label 15406: @1039523
     /* 1039523 */   GIM_Try, /*On fail goto*//*Label 15407*/ GIMT_Encode4(1039600), // Rule ID 13633 //
     /* 1039528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1039539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1039542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1039548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039567 */     // MIs[0] policy
     /* 1039567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039577 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11661:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1039580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039599 */     // GIR_Coverage, 13633,
     /* 1039599 */     GIR_EraseRootFromParent_Done,
     /* 1039600 */   // Label 15407: @1039600
     /* 1039600 */   GIM_Try, /*On fail goto*//*Label 15408*/ GIMT_Encode4(1039677), // Rule ID 13636 //
     /* 1039605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1039616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1039619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1039625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039644 */     // MIs[0] policy
     /* 1039644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1039657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039676 */     // GIR_Coverage, 13636,
     /* 1039676 */     GIR_EraseRootFromParent_Done,
     /* 1039677 */   // Label 15408: @1039677
     /* 1039677 */   GIM_Try, /*On fail goto*//*Label 15409*/ GIMT_Encode4(1039754), // Rule ID 13637 //
     /* 1039682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1039693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1039696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1039702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039721 */     // MIs[0] policy
     /* 1039721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039731 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1039734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039753 */     // GIR_Coverage, 13637,
     /* 1039753 */     GIR_EraseRootFromParent_Done,
     /* 1039754 */   // Label 15409: @1039754
     /* 1039754 */   GIM_Try, /*On fail goto*//*Label 15410*/ GIMT_Encode4(1039831), // Rule ID 13640 //
     /* 1039759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1039770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1039773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1039779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039798 */     // MIs[0] policy
     /* 1039798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039808 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039830 */     // GIR_Coverage, 13640,
     /* 1039830 */     GIR_EraseRootFromParent_Done,
     /* 1039831 */   // Label 15410: @1039831
     /* 1039831 */   GIM_Try, /*On fail goto*//*Label 15411*/ GIMT_Encode4(1039908), // Rule ID 13641 //
     /* 1039836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1039847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1039850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1039856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039875 */     // MIs[0] policy
     /* 1039875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039885 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039907 */     // GIR_Coverage, 13641,
     /* 1039907 */     GIR_EraseRootFromParent_Done,
     /* 1039908 */   // Label 15411: @1039908
     /* 1039908 */   GIM_Try, /*On fail goto*//*Label 15412*/ GIMT_Encode4(1039985), // Rule ID 13644 //
     /* 1039913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1039924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1039927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1039933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039952 */     // MIs[0] policy
     /* 1039952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039962 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11661:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1039965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039984 */     // GIR_Coverage, 13644,
     /* 1039984 */     GIR_EraseRootFromParent_Done,
     /* 1039985 */   // Label 15412: @1039985
     /* 1039985 */   GIM_Try, /*On fail goto*//*Label 15413*/ GIMT_Encode4(1040062), // Rule ID 13645 //
     /* 1039990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1040001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1040004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1040010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040029 */     // MIs[0] policy
     /* 1040029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040039 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11661:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1040042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040058 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040061 */     // GIR_Coverage, 13645,
     /* 1040061 */     GIR_EraseRootFromParent_Done,
     /* 1040062 */   // Label 15413: @1040062
     /* 1040062 */   GIM_Try, /*On fail goto*//*Label 15414*/ GIMT_Encode4(1040139), // Rule ID 13648 //
     /* 1040067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1040078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1040081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1040087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040106 */     // MIs[0] policy
     /* 1040106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040116 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11661:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040138 */     // GIR_Coverage, 13648,
     /* 1040138 */     GIR_EraseRootFromParent_Done,
     /* 1040139 */   // Label 15414: @1040139
     /* 1040139 */   GIM_Try, /*On fail goto*//*Label 15415*/ GIMT_Encode4(1040216), // Rule ID 13649 //
     /* 1040144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1040155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1040158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1040164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040183 */     // MIs[0] policy
     /* 1040183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040193 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11661:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040215 */     // GIR_Coverage, 13649,
     /* 1040215 */     GIR_EraseRootFromParent_Done,
     /* 1040216 */   // Label 15415: @1040216
     /* 1040216 */   GIM_Try, /*On fail goto*//*Label 15416*/ GIMT_Encode4(1040293), // Rule ID 13652 //
     /* 1040221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1040232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1040235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1040241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040260 */     // MIs[0] policy
     /* 1040260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040270 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11661:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040289 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040292 */     // GIR_Coverage, 13652,
     /* 1040292 */     GIR_EraseRootFromParent_Done,
     /* 1040293 */   // Label 15416: @1040293
     /* 1040293 */   GIM_Try, /*On fail goto*//*Label 15417*/ GIMT_Encode4(1040370), // Rule ID 13653 //
     /* 1040298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1040309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1040312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1040318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040337 */     // MIs[0] policy
     /* 1040337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040347 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11661:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040369 */     // GIR_Coverage, 13653,
     /* 1040369 */     GIR_EraseRootFromParent_Done,
     /* 1040370 */   // Label 15417: @1040370
     /* 1040370 */   GIM_Try, /*On fail goto*//*Label 15418*/ GIMT_Encode4(1040447), // Rule ID 13656 //
     /* 1040375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1040386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1040389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1040395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040414 */     // MIs[0] policy
     /* 1040414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040424 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1040427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040446 */     // GIR_Coverage, 13656,
     /* 1040446 */     GIR_EraseRootFromParent_Done,
     /* 1040447 */   // Label 15418: @1040447
     /* 1040447 */   GIM_Try, /*On fail goto*//*Label 15419*/ GIMT_Encode4(1040524), // Rule ID 13657 //
     /* 1040452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1040463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1040466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1040472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040491 */     // MIs[0] policy
     /* 1040491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040501 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1040504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040523 */     // GIR_Coverage, 13657,
     /* 1040523 */     GIR_EraseRootFromParent_Done,
     /* 1040524 */   // Label 15419: @1040524
     /* 1040524 */   GIM_Try, /*On fail goto*//*Label 15420*/ GIMT_Encode4(1040601), // Rule ID 13660 //
     /* 1040529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1040540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1040543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1040549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040568 */     // MIs[0] policy
     /* 1040568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11661:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1040581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040600 */     // GIR_Coverage, 13660,
     /* 1040600 */     GIR_EraseRootFromParent_Done,
     /* 1040601 */   // Label 15420: @1040601
     /* 1040601 */   GIM_Try, /*On fail goto*//*Label 15421*/ GIMT_Encode4(1040678), // Rule ID 13661 //
     /* 1040606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1040617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1040620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1040626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040645 */     // MIs[0] policy
     /* 1040645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040655 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11661:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1040658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040674 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040677 */     // GIR_Coverage, 13661,
     /* 1040677 */     GIR_EraseRootFromParent_Done,
     /* 1040678 */   // Label 15421: @1040678
     /* 1040678 */   GIM_Try, /*On fail goto*//*Label 15422*/ GIMT_Encode4(1040755), // Rule ID 13664 //
     /* 1040683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1040694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1040697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1040703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040722 */     // MIs[0] policy
     /* 1040722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040732 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11661:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040751 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040754 */     // GIR_Coverage, 13664,
     /* 1040754 */     GIR_EraseRootFromParent_Done,
     /* 1040755 */   // Label 15422: @1040755
     /* 1040755 */   GIM_Try, /*On fail goto*//*Label 15423*/ GIMT_Encode4(1040832), // Rule ID 13665 //
     /* 1040760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1040771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1040774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1040780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040799 */     // MIs[0] policy
     /* 1040799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040809 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11661:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040831 */     // GIR_Coverage, 13665,
     /* 1040831 */     GIR_EraseRootFromParent_Done,
     /* 1040832 */   // Label 15423: @1040832
     /* 1040832 */   GIM_Try, /*On fail goto*//*Label 15424*/ GIMT_Encode4(1040909), // Rule ID 13668 //
     /* 1040837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1040848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1040851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1040857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040876 */     // MIs[0] policy
     /* 1040876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11661:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040905 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040908 */     // GIR_Coverage, 13668,
     /* 1040908 */     GIR_EraseRootFromParent_Done,
     /* 1040909 */   // Label 15424: @1040909
     /* 1040909 */   GIM_Try, /*On fail goto*//*Label 15425*/ GIMT_Encode4(1040986), // Rule ID 13669 //
     /* 1040914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1040925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1040928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1040934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040953 */     // MIs[0] policy
     /* 1040953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040963 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11661:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040985 */     // GIR_Coverage, 13669,
     /* 1040985 */     GIR_EraseRootFromParent_Done,
     /* 1040986 */   // Label 15425: @1040986
     /* 1040986 */   GIM_Try, /*On fail goto*//*Label 15426*/ GIMT_Encode4(1041063), // Rule ID 13672 //
     /* 1040991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1040999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1041002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1041005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1041008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1041011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041030 */     // MIs[0] policy
     /* 1041030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041040 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1041043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041062 */     // GIR_Coverage, 13672,
     /* 1041062 */     GIR_EraseRootFromParent_Done,
     /* 1041063 */   // Label 15426: @1041063
     /* 1041063 */   GIM_Try, /*On fail goto*//*Label 15427*/ GIMT_Encode4(1041140), // Rule ID 13673 //
     /* 1041068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1041079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1041082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1041085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1041088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041107 */     // MIs[0] policy
     /* 1041107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041117 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1041120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041139 */     // GIR_Coverage, 13673,
     /* 1041139 */     GIR_EraseRootFromParent_Done,
     /* 1041140 */   // Label 15427: @1041140
     /* 1041140 */   GIM_Try, /*On fail goto*//*Label 15428*/ GIMT_Encode4(1041217), // Rule ID 13676 //
     /* 1041145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1041156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1041159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1041162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1041165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041184 */     // MIs[0] policy
     /* 1041184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041194 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1041197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041213 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041216 */     // GIR_Coverage, 13676,
     /* 1041216 */     GIR_EraseRootFromParent_Done,
     /* 1041217 */   // Label 15428: @1041217
     /* 1041217 */   GIM_Try, /*On fail goto*//*Label 15429*/ GIMT_Encode4(1041294), // Rule ID 13677 //
     /* 1041222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1041233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1041236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1041239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1041242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041261 */     // MIs[0] policy
     /* 1041261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041271 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1041274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041293 */     // GIR_Coverage, 13677,
     /* 1041293 */     GIR_EraseRootFromParent_Done,
     /* 1041294 */   // Label 15429: @1041294
     /* 1041294 */   GIM_Try, /*On fail goto*//*Label 15430*/ GIMT_Encode4(1041371), // Rule ID 13680 //
     /* 1041299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1041310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1041313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1041316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1041319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041338 */     // MIs[0] policy
     /* 1041338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041348 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1041351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041370 */     // GIR_Coverage, 13680,
     /* 1041370 */     GIR_EraseRootFromParent_Done,
     /* 1041371 */   // Label 15430: @1041371
     /* 1041371 */   GIM_Try, /*On fail goto*//*Label 15431*/ GIMT_Encode4(1041448), // Rule ID 13681 //
     /* 1041376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1041387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1041390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1041393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1041396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041415 */     // MIs[0] policy
     /* 1041415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041425 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1041428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041447 */     // GIR_Coverage, 13681,
     /* 1041447 */     GIR_EraseRootFromParent_Done,
     /* 1041448 */   // Label 15431: @1041448
     /* 1041448 */   GIM_Try, /*On fail goto*//*Label 15432*/ GIMT_Encode4(1041525), // Rule ID 13684 //
     /* 1041453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1041464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1041467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1041470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1041473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041492 */     // MIs[0] policy
     /* 1041492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11663:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1041505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041524 */     // GIR_Coverage, 13684,
     /* 1041524 */     GIR_EraseRootFromParent_Done,
     /* 1041525 */   // Label 15432: @1041525
     /* 1041525 */   GIM_Try, /*On fail goto*//*Label 15433*/ GIMT_Encode4(1041602), // Rule ID 13685 //
     /* 1041530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1041541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1041544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1041547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1041550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041569 */     // MIs[0] policy
     /* 1041569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041579 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11663:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1041582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041601 */     // GIR_Coverage, 13685,
     /* 1041601 */     GIR_EraseRootFromParent_Done,
     /* 1041602 */   // Label 15433: @1041602
     /* 1041602 */   GIM_Try, /*On fail goto*//*Label 15434*/ GIMT_Encode4(1041679), // Rule ID 13688 //
     /* 1041607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1041618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1041621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1041624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1041627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041646 */     // MIs[0] policy
     /* 1041646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041656 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11663:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1041659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041675 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041678 */     // GIR_Coverage, 13688,
     /* 1041678 */     GIR_EraseRootFromParent_Done,
     /* 1041679 */   // Label 15434: @1041679
     /* 1041679 */   GIM_Try, /*On fail goto*//*Label 15435*/ GIMT_Encode4(1041756), // Rule ID 13689 //
     /* 1041684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1041695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1041698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1041701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1041704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041723 */     // MIs[0] policy
     /* 1041723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041733 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11663:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1041736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041755 */     // GIR_Coverage, 13689,
     /* 1041755 */     GIR_EraseRootFromParent_Done,
     /* 1041756 */   // Label 15435: @1041756
     /* 1041756 */   GIM_Try, /*On fail goto*//*Label 15436*/ GIMT_Encode4(1041833), // Rule ID 13692 //
     /* 1041761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1041772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1041775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1041778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1041781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041800 */     // MIs[0] policy
     /* 1041800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041810 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11663:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1041813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041832 */     // GIR_Coverage, 13692,
     /* 1041832 */     GIR_EraseRootFromParent_Done,
     /* 1041833 */   // Label 15436: @1041833
     /* 1041833 */   GIM_Try, /*On fail goto*//*Label 15437*/ GIMT_Encode4(1041910), // Rule ID 13693 //
     /* 1041838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1041849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1041852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1041855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1041858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041877 */     // MIs[0] policy
     /* 1041877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041887 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11663:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1041890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041909 */     // GIR_Coverage, 13693,
     /* 1041909 */     GIR_EraseRootFromParent_Done,
     /* 1041910 */   // Label 15437: @1041910
     /* 1041910 */   GIM_Try, /*On fail goto*//*Label 15438*/ GIMT_Encode4(1041987), // Rule ID 13696 //
     /* 1041915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1041926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1041929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1041932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1041935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041954 */     // MIs[0] policy
     /* 1041954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041964 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1041967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041986 */     // GIR_Coverage, 13696,
     /* 1041986 */     GIR_EraseRootFromParent_Done,
     /* 1041987 */   // Label 15438: @1041987
     /* 1041987 */   GIM_Try, /*On fail goto*//*Label 15439*/ GIMT_Encode4(1042064), // Rule ID 13697 //
     /* 1041992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1042003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1042006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1042009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1042012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042031 */     // MIs[0] policy
     /* 1042031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042041 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1042044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042063 */     // GIR_Coverage, 13697,
     /* 1042063 */     GIR_EraseRootFromParent_Done,
     /* 1042064 */   // Label 15439: @1042064
     /* 1042064 */   GIM_Try, /*On fail goto*//*Label 15440*/ GIMT_Encode4(1042141), // Rule ID 13700 //
     /* 1042069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1042080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1042083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1042086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1042089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042108 */     // MIs[0] policy
     /* 1042108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042140 */     // GIR_Coverage, 13700,
     /* 1042140 */     GIR_EraseRootFromParent_Done,
     /* 1042141 */   // Label 15440: @1042141
     /* 1042141 */   GIM_Try, /*On fail goto*//*Label 15441*/ GIMT_Encode4(1042218), // Rule ID 13701 //
     /* 1042146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1042157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1042160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1042163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1042166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042185 */     // MIs[0] policy
     /* 1042185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042195 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042217 */     // GIR_Coverage, 13701,
     /* 1042217 */     GIR_EraseRootFromParent_Done,
     /* 1042218 */   // Label 15441: @1042218
     /* 1042218 */   GIM_Try, /*On fail goto*//*Label 15442*/ GIMT_Encode4(1042295), // Rule ID 13704 //
     /* 1042223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1042234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1042237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1042240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1042243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042262 */     // MIs[0] policy
     /* 1042262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042272 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11663:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042294 */     // GIR_Coverage, 13704,
     /* 1042294 */     GIR_EraseRootFromParent_Done,
     /* 1042295 */   // Label 15442: @1042295
     /* 1042295 */   GIM_Try, /*On fail goto*//*Label 15443*/ GIMT_Encode4(1042372), // Rule ID 13705 //
     /* 1042300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1042311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1042314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1042317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1042320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042339 */     // MIs[0] policy
     /* 1042339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042349 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11663:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042371 */     // GIR_Coverage, 13705,
     /* 1042371 */     GIR_EraseRootFromParent_Done,
     /* 1042372 */   // Label 15443: @1042372
     /* 1042372 */   GIM_Try, /*On fail goto*//*Label 15444*/ GIMT_Encode4(1042449), // Rule ID 13708 //
     /* 1042377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1042388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1042391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1042394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1042397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042416 */     // MIs[0] policy
     /* 1042416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042426 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11663:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042448 */     // GIR_Coverage, 13708,
     /* 1042448 */     GIR_EraseRootFromParent_Done,
     /* 1042449 */   // Label 15444: @1042449
     /* 1042449 */   GIM_Try, /*On fail goto*//*Label 15445*/ GIMT_Encode4(1042526), // Rule ID 13709 //
     /* 1042454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1042465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1042468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1042471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1042474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042493 */     // MIs[0] policy
     /* 1042493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042503 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11663:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042525 */     // GIR_Coverage, 13709,
     /* 1042525 */     GIR_EraseRootFromParent_Done,
     /* 1042526 */   // Label 15445: @1042526
     /* 1042526 */   GIM_Try, /*On fail goto*//*Label 15446*/ GIMT_Encode4(1042603), // Rule ID 13712 //
     /* 1042531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1042542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1042545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1042548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1042551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042570 */     // MIs[0] policy
     /* 1042570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042580 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11663:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1042583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042602 */     // GIR_Coverage, 13712,
     /* 1042602 */     GIR_EraseRootFromParent_Done,
     /* 1042603 */   // Label 15446: @1042603
     /* 1042603 */   GIM_Try, /*On fail goto*//*Label 15447*/ GIMT_Encode4(1042680), // Rule ID 13713 //
     /* 1042608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1042619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1042622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1042625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1042628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042647 */     // MIs[0] policy
     /* 1042647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042657 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11663:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1042660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042679 */     // GIR_Coverage, 13713,
     /* 1042679 */     GIR_EraseRootFromParent_Done,
     /* 1042680 */   // Label 15447: @1042680
     /* 1042680 */   GIM_Try, /*On fail goto*//*Label 15448*/ GIMT_Encode4(1042757), // Rule ID 13716 //
     /* 1042685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1042696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1042699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1042702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1042705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042724 */     // MIs[0] policy
     /* 1042724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042734 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042756 */     // GIR_Coverage, 13716,
     /* 1042756 */     GIR_EraseRootFromParent_Done,
     /* 1042757 */   // Label 15448: @1042757
     /* 1042757 */   GIM_Try, /*On fail goto*//*Label 15449*/ GIMT_Encode4(1042834), // Rule ID 13717 //
     /* 1042762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1042773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1042776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1042779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1042782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042801 */     // MIs[0] policy
     /* 1042801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042811 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042833 */     // GIR_Coverage, 13717,
     /* 1042833 */     GIR_EraseRootFromParent_Done,
     /* 1042834 */   // Label 15449: @1042834
     /* 1042834 */   GIM_Try, /*On fail goto*//*Label 15450*/ GIMT_Encode4(1042911), // Rule ID 13720 //
     /* 1042839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1042850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1042853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1042856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1042859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042878 */     // MIs[0] policy
     /* 1042878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042888 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11663:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042910 */     // GIR_Coverage, 13720,
     /* 1042910 */     GIR_EraseRootFromParent_Done,
     /* 1042911 */   // Label 15450: @1042911
     /* 1042911 */   GIM_Try, /*On fail goto*//*Label 15451*/ GIMT_Encode4(1042988), // Rule ID 13721 //
     /* 1042916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1042927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1042930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1042933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1042936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042955 */     // MIs[0] policy
     /* 1042955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042965 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11663:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042987 */     // GIR_Coverage, 13721,
     /* 1042987 */     GIR_EraseRootFromParent_Done,
     /* 1042988 */   // Label 15451: @1042988
     /* 1042988 */   GIM_Try, /*On fail goto*//*Label 15452*/ GIMT_Encode4(1043065), // Rule ID 13724 //
     /* 1042993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1043004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1043007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1043010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1043013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043032 */     // MIs[0] policy
     /* 1043032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043042 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11663:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1043045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043064 */     // GIR_Coverage, 13724,
     /* 1043064 */     GIR_EraseRootFromParent_Done,
     /* 1043065 */   // Label 15452: @1043065
     /* 1043065 */   GIM_Try, /*On fail goto*//*Label 15453*/ GIMT_Encode4(1043142), // Rule ID 13725 //
     /* 1043070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1043073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1043081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1043084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1043087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1043090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043109 */     // MIs[0] policy
     /* 1043109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043119 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11663:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1043122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043138 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043141 */     // GIR_Coverage, 13725,
     /* 1043141 */     GIR_EraseRootFromParent_Done,
     /* 1043142 */   // Label 15453: @1043142
     /* 1043142 */   GIM_Try, /*On fail goto*//*Label 15454*/ GIMT_Encode4(1043219), // Rule ID 13728 //
     /* 1043147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1043150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1043158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1043161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1043164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1043167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043186 */     // MIs[0] policy
     /* 1043186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043196 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11663:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1043199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043218 */     // GIR_Coverage, 13728,
     /* 1043218 */     GIR_EraseRootFromParent_Done,
     /* 1043219 */   // Label 15454: @1043219
     /* 1043219 */   GIM_Try, /*On fail goto*//*Label 15455*/ GIMT_Encode4(1043296), // Rule ID 13729 //
     /* 1043224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1043227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1043235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1043238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1043241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1043244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043263 */     // MIs[0] policy
     /* 1043263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043273 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11663:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1043276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043295 */     // GIR_Coverage, 13729,
     /* 1043295 */     GIR_EraseRootFromParent_Done,
     /* 1043296 */   // Label 15455: @1043296
     /* 1043296 */   GIM_Try, /*On fail goto*//*Label 15456*/ GIMT_Encode4(1043373), // Rule ID 13732 //
     /* 1043301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1043312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1043315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1043321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043340 */     // MIs[0] policy
     /* 1043340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043350 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1043353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043372 */     // GIR_Coverage, 13732,
     /* 1043372 */     GIR_EraseRootFromParent_Done,
     /* 1043373 */   // Label 15456: @1043373
     /* 1043373 */   GIM_Try, /*On fail goto*//*Label 15457*/ GIMT_Encode4(1043450), // Rule ID 13733 //
     /* 1043378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1043389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1043392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1043398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043417 */     // MIs[0] policy
     /* 1043417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043427 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1043430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043449 */     // GIR_Coverage, 13733,
     /* 1043449 */     GIR_EraseRootFromParent_Done,
     /* 1043450 */   // Label 15457: @1043450
     /* 1043450 */   GIM_Try, /*On fail goto*//*Label 15458*/ GIMT_Encode4(1043527), // Rule ID 13736 //
     /* 1043455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1043466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1043469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1043475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043494 */     // MIs[0] policy
     /* 1043494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043504 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1043507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043526 */     // GIR_Coverage, 13736,
     /* 1043526 */     GIR_EraseRootFromParent_Done,
     /* 1043527 */   // Label 15458: @1043527
     /* 1043527 */   GIM_Try, /*On fail goto*//*Label 15459*/ GIMT_Encode4(1043604), // Rule ID 13737 //
     /* 1043532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1043543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1043546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1043552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043571 */     // MIs[0] policy
     /* 1043571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043581 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1043584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043603 */     // GIR_Coverage, 13737,
     /* 1043603 */     GIR_EraseRootFromParent_Done,
     /* 1043604 */   // Label 15459: @1043604
     /* 1043604 */   GIM_Try, /*On fail goto*//*Label 15460*/ GIMT_Encode4(1043681), // Rule ID 13740 //
     /* 1043609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1043620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1043623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1043629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043648 */     // MIs[0] policy
     /* 1043648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043658 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1043661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043677 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043680 */     // GIR_Coverage, 13740,
     /* 1043680 */     GIR_EraseRootFromParent_Done,
     /* 1043681 */   // Label 15460: @1043681
     /* 1043681 */   GIM_Try, /*On fail goto*//*Label 15461*/ GIMT_Encode4(1043758), // Rule ID 13741 //
     /* 1043686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1043697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1043700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1043706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043725 */     // MIs[0] policy
     /* 1043725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043735 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1043738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043757 */     // GIR_Coverage, 13741,
     /* 1043757 */     GIR_EraseRootFromParent_Done,
     /* 1043758 */   // Label 15461: @1043758
     /* 1043758 */   GIM_Try, /*On fail goto*//*Label 15462*/ GIMT_Encode4(1043835), // Rule ID 13744 //
     /* 1043763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1043774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1043777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1043783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043802 */     // MIs[0] policy
     /* 1043802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043812 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11663:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1043815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043834 */     // GIR_Coverage, 13744,
     /* 1043834 */     GIR_EraseRootFromParent_Done,
     /* 1043835 */   // Label 15462: @1043835
     /* 1043835 */   GIM_Try, /*On fail goto*//*Label 15463*/ GIMT_Encode4(1043912), // Rule ID 13745 //
     /* 1043840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1043851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1043854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1043860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043879 */     // MIs[0] policy
     /* 1043879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043889 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11663:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1043892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043911 */     // GIR_Coverage, 13745,
     /* 1043911 */     GIR_EraseRootFromParent_Done,
     /* 1043912 */   // Label 15463: @1043912
     /* 1043912 */   GIM_Try, /*On fail goto*//*Label 15464*/ GIMT_Encode4(1043989), // Rule ID 13748 //
     /* 1043917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1043928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1043931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1043937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043956 */     // MIs[0] policy
     /* 1043956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043966 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11663:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1043969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043988 */     // GIR_Coverage, 13748,
     /* 1043988 */     GIR_EraseRootFromParent_Done,
     /* 1043989 */   // Label 15464: @1043989
     /* 1043989 */   GIM_Try, /*On fail goto*//*Label 15465*/ GIMT_Encode4(1044066), // Rule ID 13749 //
     /* 1043994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1044005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1044008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1044014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044033 */     // MIs[0] policy
     /* 1044033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044043 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11663:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044065 */     // GIR_Coverage, 13749,
     /* 1044065 */     GIR_EraseRootFromParent_Done,
     /* 1044066 */   // Label 15465: @1044066
     /* 1044066 */   GIM_Try, /*On fail goto*//*Label 15466*/ GIMT_Encode4(1044143), // Rule ID 13752 //
     /* 1044071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1044082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1044085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1044091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044110 */     // MIs[0] policy
     /* 1044110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044120 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11663:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044142 */     // GIR_Coverage, 13752,
     /* 1044142 */     GIR_EraseRootFromParent_Done,
     /* 1044143 */   // Label 15466: @1044143
     /* 1044143 */   GIM_Try, /*On fail goto*//*Label 15467*/ GIMT_Encode4(1044220), // Rule ID 13753 //
     /* 1044148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1044159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1044162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1044168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044187 */     // MIs[0] policy
     /* 1044187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044197 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11663:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044219 */     // GIR_Coverage, 13753,
     /* 1044219 */     GIR_EraseRootFromParent_Done,
     /* 1044220 */   // Label 15467: @1044220
     /* 1044220 */   GIM_Try, /*On fail goto*//*Label 15468*/ GIMT_Encode4(1044297), // Rule ID 13756 //
     /* 1044225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1044236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1044239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1044245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044264 */     // MIs[0] policy
     /* 1044264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044274 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1044277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044293 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044296 */     // GIR_Coverage, 13756,
     /* 1044296 */     GIR_EraseRootFromParent_Done,
     /* 1044297 */   // Label 15468: @1044297
     /* 1044297 */   GIM_Try, /*On fail goto*//*Label 15469*/ GIMT_Encode4(1044374), // Rule ID 13757 //
     /* 1044302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1044313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1044316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1044322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044341 */     // MIs[0] policy
     /* 1044341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044351 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1044354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044373 */     // GIR_Coverage, 13757,
     /* 1044373 */     GIR_EraseRootFromParent_Done,
     /* 1044374 */   // Label 15469: @1044374
     /* 1044374 */   GIM_Try, /*On fail goto*//*Label 15470*/ GIMT_Encode4(1044451), // Rule ID 13760 //
     /* 1044379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1044390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1044393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1044399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044418 */     // MIs[0] policy
     /* 1044418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044428 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044450 */     // GIR_Coverage, 13760,
     /* 1044450 */     GIR_EraseRootFromParent_Done,
     /* 1044451 */   // Label 15470: @1044451
     /* 1044451 */   GIM_Try, /*On fail goto*//*Label 15471*/ GIMT_Encode4(1044528), // Rule ID 13761 //
     /* 1044456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1044467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1044470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1044476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044495 */     // MIs[0] policy
     /* 1044495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044505 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044527 */     // GIR_Coverage, 13761,
     /* 1044527 */     GIR_EraseRootFromParent_Done,
     /* 1044528 */   // Label 15471: @1044528
     /* 1044528 */   GIM_Try, /*On fail goto*//*Label 15472*/ GIMT_Encode4(1044605), // Rule ID 13764 //
     /* 1044533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1044544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1044547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1044553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044572 */     // MIs[0] policy
     /* 1044572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11663:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1044585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044601 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044604 */     // GIR_Coverage, 13764,
     /* 1044604 */     GIR_EraseRootFromParent_Done,
     /* 1044605 */   // Label 15472: @1044605
     /* 1044605 */   GIM_Try, /*On fail goto*//*Label 15473*/ GIMT_Encode4(1044682), // Rule ID 13765 //
     /* 1044610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1044621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1044624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1044630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044649 */     // MIs[0] policy
     /* 1044649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044659 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11663:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1044662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044681 */     // GIR_Coverage, 13765,
     /* 1044681 */     GIR_EraseRootFromParent_Done,
     /* 1044682 */   // Label 15473: @1044682
     /* 1044682 */   GIM_Try, /*On fail goto*//*Label 15474*/ GIMT_Encode4(1044759), // Rule ID 13768 //
     /* 1044687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1044698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1044701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1044707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044726 */     // MIs[0] policy
     /* 1044726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11663:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044755 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044758 */     // GIR_Coverage, 13768,
     /* 1044758 */     GIR_EraseRootFromParent_Done,
     /* 1044759 */   // Label 15474: @1044759
     /* 1044759 */   GIM_Try, /*On fail goto*//*Label 15475*/ GIMT_Encode4(1044836), // Rule ID 13769 //
     /* 1044764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1044775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1044778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1044784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044803 */     // MIs[0] policy
     /* 1044803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044813 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11663:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044835 */     // GIR_Coverage, 13769,
     /* 1044835 */     GIR_EraseRootFromParent_Done,
     /* 1044836 */   // Label 15475: @1044836
     /* 1044836 */   GIM_Try, /*On fail goto*//*Label 15476*/ GIMT_Encode4(1044913), // Rule ID 13772 //
     /* 1044841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1044852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1044855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1044861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044880 */     // MIs[0] policy
     /* 1044880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11663:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044909 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044912 */     // GIR_Coverage, 13772,
     /* 1044912 */     GIR_EraseRootFromParent_Done,
     /* 1044913 */   // Label 15476: @1044913
     /* 1044913 */   GIM_Try, /*On fail goto*//*Label 15477*/ GIMT_Encode4(1044990), // Rule ID 13773 //
     /* 1044918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1044929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1044932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1044938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044957 */     // MIs[0] policy
     /* 1044957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044967 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11663:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044986 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044989 */     // GIR_Coverage, 13773,
     /* 1044989 */     GIR_EraseRootFromParent_Done,
     /* 1044990 */   // Label 15477: @1044990
     /* 1044990 */   GIM_Try, /*On fail goto*//*Label 15478*/ GIMT_Encode4(1045067), // Rule ID 13776 //
     /* 1044995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1045006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1045009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1045015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045034 */     // MIs[0] policy
     /* 1045034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045044 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1045047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045063 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045066 */     // GIR_Coverage, 13776,
     /* 1045066 */     GIR_EraseRootFromParent_Done,
     /* 1045067 */   // Label 15478: @1045067
     /* 1045067 */   GIM_Try, /*On fail goto*//*Label 15479*/ GIMT_Encode4(1045144), // Rule ID 13777 //
     /* 1045072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1045083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1045086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1045092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045111 */     // MIs[0] policy
     /* 1045111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045121 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1045124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045143 */     // GIR_Coverage, 13777,
     /* 1045143 */     GIR_EraseRootFromParent_Done,
     /* 1045144 */   // Label 15479: @1045144
     /* 1045144 */   GIM_Try, /*On fail goto*//*Label 15480*/ GIMT_Encode4(1045221), // Rule ID 13780 //
     /* 1045149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1045160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1045163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1045169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045188 */     // MIs[0] policy
     /* 1045188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11663:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1045201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045217 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045220 */     // GIR_Coverage, 13780,
     /* 1045220 */     GIR_EraseRootFromParent_Done,
     /* 1045221 */   // Label 15480: @1045221
     /* 1045221 */   GIM_Try, /*On fail goto*//*Label 15481*/ GIMT_Encode4(1045298), // Rule ID 13781 //
     /* 1045226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1045237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1045240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1045246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045265 */     // MIs[0] policy
     /* 1045265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045275 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11663:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1045278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045297 */     // GIR_Coverage, 13781,
     /* 1045297 */     GIR_EraseRootFromParent_Done,
     /* 1045298 */   // Label 15481: @1045298
     /* 1045298 */   GIM_Try, /*On fail goto*//*Label 15482*/ GIMT_Encode4(1045375), // Rule ID 13784 //
     /* 1045303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1045314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1045317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1045323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045342 */     // MIs[0] policy
     /* 1045342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11663:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1045355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045374 */     // GIR_Coverage, 13784,
     /* 1045374 */     GIR_EraseRootFromParent_Done,
     /* 1045375 */   // Label 15482: @1045375
     /* 1045375 */   GIM_Try, /*On fail goto*//*Label 15483*/ GIMT_Encode4(1045452), // Rule ID 13785 //
     /* 1045380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1045391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1045394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1045400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045419 */     // MIs[0] policy
     /* 1045419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045429 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11663:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1045432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045451 */     // GIR_Coverage, 13785,
     /* 1045451 */     GIR_EraseRootFromParent_Done,
     /* 1045452 */   // Label 15483: @1045452
     /* 1045452 */   GIM_Try, /*On fail goto*//*Label 15484*/ GIMT_Encode4(1045529), // Rule ID 13788 //
     /* 1045457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1045468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1045471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1045477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045496 */     // MIs[0] policy
     /* 1045496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045506 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11663:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1045509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045528 */     // GIR_Coverage, 13788,
     /* 1045528 */     GIR_EraseRootFromParent_Done,
     /* 1045529 */   // Label 15484: @1045529
     /* 1045529 */   GIM_Try, /*On fail goto*//*Label 15485*/ GIMT_Encode4(1045606), // Rule ID 13789 //
     /* 1045534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1045545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1045548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1045554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045573 */     // MIs[0] policy
     /* 1045573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045583 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11663:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1045586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045602 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045605 */     // GIR_Coverage, 13789,
     /* 1045605 */     GIR_EraseRootFromParent_Done,
     /* 1045606 */   // Label 15485: @1045606
     /* 1045606 */   GIM_Try, /*On fail goto*//*Label 15486*/ GIMT_Encode4(1045683), // Rule ID 13792 //
     /* 1045611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1045622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1045625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1045631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045650 */     // MIs[0] policy
     /* 1045650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045660 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1045663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045682 */     // GIR_Coverage, 13792,
     /* 1045682 */     GIR_EraseRootFromParent_Done,
     /* 1045683 */   // Label 15486: @1045683
     /* 1045683 */   GIM_Try, /*On fail goto*//*Label 15487*/ GIMT_Encode4(1045760), // Rule ID 13793 //
     /* 1045688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1045699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1045702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1045708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045727 */     // MIs[0] policy
     /* 1045727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045737 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1045740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045759 */     // GIR_Coverage, 13793,
     /* 1045759 */     GIR_EraseRootFromParent_Done,
     /* 1045760 */   // Label 15487: @1045760
     /* 1045760 */   GIM_Try, /*On fail goto*//*Label 15488*/ GIMT_Encode4(1045837), // Rule ID 13796 //
     /* 1045765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1045776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1045779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1045785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045804 */     // MIs[0] policy
     /* 1045804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045814 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1045817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045833 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045836 */     // GIR_Coverage, 13796,
     /* 1045836 */     GIR_EraseRootFromParent_Done,
     /* 1045837 */   // Label 15488: @1045837
     /* 1045837 */   GIM_Try, /*On fail goto*//*Label 15489*/ GIMT_Encode4(1045914), // Rule ID 13797 //
     /* 1045842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1045853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1045856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1045862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045881 */     // MIs[0] policy
     /* 1045881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045891 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1045894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045913 */     // GIR_Coverage, 13797,
     /* 1045913 */     GIR_EraseRootFromParent_Done,
     /* 1045914 */   // Label 15489: @1045914
     /* 1045914 */   GIM_Try, /*On fail goto*//*Label 15490*/ GIMT_Encode4(1045991), // Rule ID 13800 //
     /* 1045919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1045930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1045933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1045939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045958 */     // MIs[0] policy
     /* 1045958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045968 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1045971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045987 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045990 */     // GIR_Coverage, 13800,
     /* 1045990 */     GIR_EraseRootFromParent_Done,
     /* 1045991 */   // Label 15490: @1045991
     /* 1045991 */   GIM_Try, /*On fail goto*//*Label 15491*/ GIMT_Encode4(1046068), // Rule ID 13801 //
     /* 1045996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1046007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1046010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1046016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046035 */     // MIs[0] policy
     /* 1046035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046045 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046067 */     // GIR_Coverage, 13801,
     /* 1046067 */     GIR_EraseRootFromParent_Done,
     /* 1046068 */   // Label 15491: @1046068
     /* 1046068 */   GIM_Try, /*On fail goto*//*Label 15492*/ GIMT_Encode4(1046145), // Rule ID 13804 //
     /* 1046073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1046084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1046087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1046093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046112 */     // MIs[0] policy
     /* 1046112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046122 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046141 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046144 */     // GIR_Coverage, 13804,
     /* 1046144 */     GIR_EraseRootFromParent_Done,
     /* 1046145 */   // Label 15492: @1046145
     /* 1046145 */   GIM_Try, /*On fail goto*//*Label 15493*/ GIMT_Encode4(1046222), // Rule ID 13805 //
     /* 1046150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1046161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1046164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1046170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046189 */     // MIs[0] policy
     /* 1046189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046199 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046218 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046221 */     // GIR_Coverage, 13805,
     /* 1046221 */     GIR_EraseRootFromParent_Done,
     /* 1046222 */   // Label 15493: @1046222
     /* 1046222 */   GIM_Try, /*On fail goto*//*Label 15494*/ GIMT_Encode4(1046299), // Rule ID 13808 //
     /* 1046227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1046238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1046241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1046247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046266 */     // MIs[0] policy
     /* 1046266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046276 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1046279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046295 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046298 */     // GIR_Coverage, 13808,
     /* 1046298 */     GIR_EraseRootFromParent_Done,
     /* 1046299 */   // Label 15494: @1046299
     /* 1046299 */   GIM_Try, /*On fail goto*//*Label 15495*/ GIMT_Encode4(1046376), // Rule ID 13809 //
     /* 1046304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1046315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1046318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1046324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046343 */     // MIs[0] policy
     /* 1046343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046353 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1046356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046375 */     // GIR_Coverage, 13809,
     /* 1046375 */     GIR_EraseRootFromParent_Done,
     /* 1046376 */   // Label 15495: @1046376
     /* 1046376 */   GIM_Try, /*On fail goto*//*Label 15496*/ GIMT_Encode4(1046453), // Rule ID 13812 //
     /* 1046381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1046392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1046395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1046401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046420 */     // MIs[0] policy
     /* 1046420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046430 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1046433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046452 */     // GIR_Coverage, 13812,
     /* 1046452 */     GIR_EraseRootFromParent_Done,
     /* 1046453 */   // Label 15496: @1046453
     /* 1046453 */   GIM_Try, /*On fail goto*//*Label 15497*/ GIMT_Encode4(1046530), // Rule ID 13813 //
     /* 1046458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1046469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1046472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1046478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046497 */     // MIs[0] policy
     /* 1046497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046507 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1046510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046529 */     // GIR_Coverage, 13813,
     /* 1046529 */     GIR_EraseRootFromParent_Done,
     /* 1046530 */   // Label 15497: @1046530
     /* 1046530 */   GIM_Try, /*On fail goto*//*Label 15498*/ GIMT_Encode4(1046607), // Rule ID 13816 //
     /* 1046535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1046546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1046549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1046555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046574 */     // MIs[0] policy
     /* 1046574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046584 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1046587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046606 */     // GIR_Coverage, 13816,
     /* 1046606 */     GIR_EraseRootFromParent_Done,
     /* 1046607 */   // Label 15498: @1046607
     /* 1046607 */   GIM_Try, /*On fail goto*//*Label 15499*/ GIMT_Encode4(1046684), // Rule ID 13817 //
     /* 1046612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1046623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1046626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1046632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046651 */     // MIs[0] policy
     /* 1046651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046661 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1046664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046683 */     // GIR_Coverage, 13817,
     /* 1046683 */     GIR_EraseRootFromParent_Done,
     /* 1046684 */   // Label 15499: @1046684
     /* 1046684 */   GIM_Try, /*On fail goto*//*Label 15500*/ GIMT_Encode4(1046761), // Rule ID 13820 //
     /* 1046689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1046700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1046703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1046709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046728 */     // MIs[0] policy
     /* 1046728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046738 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11667:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046760 */     // GIR_Coverage, 13820,
     /* 1046760 */     GIR_EraseRootFromParent_Done,
     /* 1046761 */   // Label 15500: @1046761
     /* 1046761 */   GIM_Try, /*On fail goto*//*Label 15501*/ GIMT_Encode4(1046838), // Rule ID 13821 //
     /* 1046766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1046777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1046780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1046786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046805 */     // MIs[0] policy
     /* 1046805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046815 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11667:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046837 */     // GIR_Coverage, 13821,
     /* 1046837 */     GIR_EraseRootFromParent_Done,
     /* 1046838 */   // Label 15501: @1046838
     /* 1046838 */   GIM_Try, /*On fail goto*//*Label 15502*/ GIMT_Encode4(1046915), // Rule ID 13824 //
     /* 1046843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1046854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1046857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1046863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046882 */     // MIs[0] policy
     /* 1046882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046914 */     // GIR_Coverage, 13824,
     /* 1046914 */     GIR_EraseRootFromParent_Done,
     /* 1046915 */   // Label 15502: @1046915
     /* 1046915 */   GIM_Try, /*On fail goto*//*Label 15503*/ GIMT_Encode4(1046992), // Rule ID 13825 //
     /* 1046920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1046931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1046934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1046940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046959 */     // MIs[0] policy
     /* 1046959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046969 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046988 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046991 */     // GIR_Coverage, 13825,
     /* 1046991 */     GIR_EraseRootFromParent_Done,
     /* 1046992 */   // Label 15503: @1046992
     /* 1046992 */   GIM_Try, /*On fail goto*//*Label 15504*/ GIMT_Encode4(1047069), // Rule ID 13828 //
     /* 1046997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1047008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1047011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1047017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047036 */     // MIs[0] policy
     /* 1047036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047068 */     // GIR_Coverage, 13828,
     /* 1047068 */     GIR_EraseRootFromParent_Done,
     /* 1047069 */   // Label 15504: @1047069
     /* 1047069 */   GIM_Try, /*On fail goto*//*Label 15505*/ GIMT_Encode4(1047146), // Rule ID 13829 //
     /* 1047074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1047085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1047088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1047094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047113 */     // MIs[0] policy
     /* 1047113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047123 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047145 */     // GIR_Coverage, 13829,
     /* 1047145 */     GIR_EraseRootFromParent_Done,
     /* 1047146 */   // Label 15505: @1047146
     /* 1047146 */   GIM_Try, /*On fail goto*//*Label 15506*/ GIMT_Encode4(1047223), // Rule ID 13832 //
     /* 1047151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1047162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1047165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1047171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047190 */     // MIs[0] policy
     /* 1047190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047200 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047222 */     // GIR_Coverage, 13832,
     /* 1047222 */     GIR_EraseRootFromParent_Done,
     /* 1047223 */   // Label 15506: @1047223
     /* 1047223 */   GIM_Try, /*On fail goto*//*Label 15507*/ GIMT_Encode4(1047300), // Rule ID 13833 //
     /* 1047228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1047239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1047242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1047248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047267 */     // MIs[0] policy
     /* 1047267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047277 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047299 */     // GIR_Coverage, 13833,
     /* 1047299 */     GIR_EraseRootFromParent_Done,
     /* 1047300 */   // Label 15507: @1047300
     /* 1047300 */   GIM_Try, /*On fail goto*//*Label 15508*/ GIMT_Encode4(1047377), // Rule ID 13836 //
     /* 1047305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1047316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1047319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1047325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047344 */     // MIs[0] policy
     /* 1047344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047354 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1047357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047373 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047376 */     // GIR_Coverage, 13836,
     /* 1047376 */     GIR_EraseRootFromParent_Done,
     /* 1047377 */   // Label 15508: @1047377
     /* 1047377 */   GIM_Try, /*On fail goto*//*Label 15509*/ GIMT_Encode4(1047454), // Rule ID 13837 //
     /* 1047382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1047393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1047396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1047402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047421 */     // MIs[0] policy
     /* 1047421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047431 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1047434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047450 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047453 */     // GIR_Coverage, 13837,
     /* 1047453 */     GIR_EraseRootFromParent_Done,
     /* 1047454 */   // Label 15509: @1047454
     /* 1047454 */   GIM_Try, /*On fail goto*//*Label 15510*/ GIMT_Encode4(1047531), // Rule ID 13840 //
     /* 1047459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1047470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1047473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1047479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047498 */     // MIs[0] policy
     /* 1047498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1047511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047527 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047530 */     // GIR_Coverage, 13840,
     /* 1047530 */     GIR_EraseRootFromParent_Done,
     /* 1047531 */   // Label 15510: @1047531
     /* 1047531 */   GIM_Try, /*On fail goto*//*Label 15511*/ GIMT_Encode4(1047608), // Rule ID 13841 //
     /* 1047536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1047547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1047550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1047556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047575 */     // MIs[0] policy
     /* 1047575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047585 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1047588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047604 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047607 */     // GIR_Coverage, 13841,
     /* 1047607 */     GIR_EraseRootFromParent_Done,
     /* 1047608 */   // Label 15511: @1047608
     /* 1047608 */   GIM_Try, /*On fail goto*//*Label 15512*/ GIMT_Encode4(1047685), // Rule ID 13844 //
     /* 1047613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1047624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1047627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1047633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047652 */     // MIs[0] policy
     /* 1047652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047662 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047681 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047684 */     // GIR_Coverage, 13844,
     /* 1047684 */     GIR_EraseRootFromParent_Done,
     /* 1047685 */   // Label 15512: @1047685
     /* 1047685 */   GIM_Try, /*On fail goto*//*Label 15513*/ GIMT_Encode4(1047762), // Rule ID 13845 //
     /* 1047690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1047701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1047704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1047710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047729 */     // MIs[0] policy
     /* 1047729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047739 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047761 */     // GIR_Coverage, 13845,
     /* 1047761 */     GIR_EraseRootFromParent_Done,
     /* 1047762 */   // Label 15513: @1047762
     /* 1047762 */   GIM_Try, /*On fail goto*//*Label 15514*/ GIMT_Encode4(1047839), // Rule ID 13848 //
     /* 1047767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1047778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1047781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1047787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047806 */     // MIs[0] policy
     /* 1047806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047816 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047838 */     // GIR_Coverage, 13848,
     /* 1047838 */     GIR_EraseRootFromParent_Done,
     /* 1047839 */   // Label 15514: @1047839
     /* 1047839 */   GIM_Try, /*On fail goto*//*Label 15515*/ GIMT_Encode4(1047916), // Rule ID 13849 //
     /* 1047844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1047855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1047858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1047864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047883 */     // MIs[0] policy
     /* 1047883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047893 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047915 */     // GIR_Coverage, 13849,
     /* 1047915 */     GIR_EraseRootFromParent_Done,
     /* 1047916 */   // Label 15515: @1047916
     /* 1047916 */   GIM_Try, /*On fail goto*//*Label 15516*/ GIMT_Encode4(1047993), // Rule ID 19062 //
     /* 1047921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1047924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1047929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1047932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1047935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1047938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1047941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1047948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1047960 */     // MIs[0] policy
     /* 1047960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047970 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1047973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1047979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1047981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047989 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047992 */     // GIR_Coverage, 19062,
     /* 1047992 */     GIR_EraseRootFromParent_Done,
     /* 1047993 */   // Label 15516: @1047993
     /* 1047993 */   GIM_Try, /*On fail goto*//*Label 15517*/ GIMT_Encode4(1048070), // Rule ID 19063 //
     /* 1047998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1048009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1048012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1048015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048037 */     // MIs[0] policy
     /* 1048037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048047 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1048050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048056 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048069 */     // GIR_Coverage, 19063,
     /* 1048069 */     GIR_EraseRootFromParent_Done,
     /* 1048070 */   // Label 15517: @1048070
     /* 1048070 */   GIM_Try, /*On fail goto*//*Label 15518*/ GIMT_Encode4(1048147), // Rule ID 19066 //
     /* 1048075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1048078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1048092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048114 */     // MIs[0] policy
     /* 1048114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048124 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1048127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048146 */     // GIR_Coverage, 19066,
     /* 1048146 */     GIR_EraseRootFromParent_Done,
     /* 1048147 */   // Label 15518: @1048147
     /* 1048147 */   GIM_Try, /*On fail goto*//*Label 15519*/ GIMT_Encode4(1048224), // Rule ID 19067 //
     /* 1048152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1048155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1048169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048191 */     // MIs[0] policy
     /* 1048191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048201 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1048204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048210 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048223 */     // GIR_Coverage, 19067,
     /* 1048223 */     GIR_EraseRootFromParent_Done,
     /* 1048224 */   // Label 15519: @1048224
     /* 1048224 */   GIM_Try, /*On fail goto*//*Label 15520*/ GIMT_Encode4(1048301), // Rule ID 19070 //
     /* 1048229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1048240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1048243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1048246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1048249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048268 */     // MIs[0] policy
     /* 1048268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048278 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1048281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048300 */     // GIR_Coverage, 19070,
     /* 1048300 */     GIR_EraseRootFromParent_Done,
     /* 1048301 */   // Label 15520: @1048301
     /* 1048301 */   GIM_Try, /*On fail goto*//*Label 15521*/ GIMT_Encode4(1048378), // Rule ID 19071 //
     /* 1048306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1048317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1048320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1048323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1048326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048345 */     // MIs[0] policy
     /* 1048345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048355 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1048358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048377 */     // GIR_Coverage, 19071,
     /* 1048377 */     GIR_EraseRootFromParent_Done,
     /* 1048378 */   // Label 15521: @1048378
     /* 1048378 */   GIM_Try, /*On fail goto*//*Label 15522*/ GIMT_Encode4(1048455), // Rule ID 19074 //
     /* 1048383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1048386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1048394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1048397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1048400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048422 */     // MIs[0] policy
     /* 1048422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048432 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1048435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048454 */     // GIR_Coverage, 19074,
     /* 1048454 */     GIR_EraseRootFromParent_Done,
     /* 1048455 */   // Label 15522: @1048455
     /* 1048455 */   GIM_Try, /*On fail goto*//*Label 15523*/ GIMT_Encode4(1048532), // Rule ID 19075 //
     /* 1048460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1048463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1048471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1048474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1048477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048499 */     // MIs[0] policy
     /* 1048499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048509 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1048512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048518 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048531 */     // GIR_Coverage, 19075,
     /* 1048531 */     GIR_EraseRootFromParent_Done,
     /* 1048532 */   // Label 15523: @1048532
     /* 1048532 */   GIM_Try, /*On fail goto*//*Label 15524*/ GIMT_Encode4(1048609), // Rule ID 19078 //
     /* 1048537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1048540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1048548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1048551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1048554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048576 */     // MIs[0] policy
     /* 1048576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048586 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1048589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1048605 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048608 */     // GIR_Coverage, 19078,
     /* 1048608 */     GIR_EraseRootFromParent_Done,
     /* 1048609 */   // Label 15524: @1048609
     /* 1048609 */   GIM_Try, /*On fail goto*//*Label 15525*/ GIMT_Encode4(1048686), // Rule ID 19079 //
     /* 1048614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1048617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1048625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1048628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1048631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048653 */     // MIs[0] policy
     /* 1048653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048663 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1048666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048672 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1048682 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048685 */     // GIR_Coverage, 19079,
     /* 1048685 */     GIR_EraseRootFromParent_Done,
     /* 1048686 */   // Label 15525: @1048686
     /* 1048686 */   GIM_Try, /*On fail goto*//*Label 15526*/ GIMT_Encode4(1048763), // Rule ID 19082 //
     /* 1048691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1048702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1048705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1048708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1048711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1048718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048730 */     // MIs[0] policy
     /* 1048730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048740 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1048743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048759 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048762 */     // GIR_Coverage, 19082,
     /* 1048762 */     GIR_EraseRootFromParent_Done,
     /* 1048763 */   // Label 15526: @1048763
     /* 1048763 */   GIM_Try, /*On fail goto*//*Label 15527*/ GIMT_Encode4(1048840), // Rule ID 19083 //
     /* 1048768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1048779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1048782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1048785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1048788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1048795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048807 */     // MIs[0] policy
     /* 1048807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048817 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1048820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048826 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048836 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048839 */     // GIR_Coverage, 19083,
     /* 1048839 */     GIR_EraseRootFromParent_Done,
     /* 1048840 */   // Label 15527: @1048840
     /* 1048840 */   GIM_Try, /*On fail goto*//*Label 15528*/ GIMT_Encode4(1048917), // Rule ID 19086 //
     /* 1048845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1048856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1048859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1048862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1048865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1048872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048884 */     // MIs[0] policy
     /* 1048884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048894 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1048897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048916 */     // GIR_Coverage, 19086,
     /* 1048916 */     GIR_EraseRootFromParent_Done,
     /* 1048917 */   // Label 15528: @1048917
     /* 1048917 */   GIM_Try, /*On fail goto*//*Label 15529*/ GIMT_Encode4(1048994), // Rule ID 19087 //
     /* 1048922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1048933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1048936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1048939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1048942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1048949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048961 */     // MIs[0] policy
     /* 1048961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048971 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1048974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048980 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048993 */     // GIR_Coverage, 19087,
     /* 1048993 */     GIR_EraseRootFromParent_Done,
     /* 1048994 */   // Label 15529: @1048994
     /* 1048994 */   GIM_Try, /*On fail goto*//*Label 15530*/ GIMT_Encode4(1049071), // Rule ID 19090 //
     /* 1048999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1049002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1049010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1049013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1049016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1049019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049038 */     // MIs[0] policy
     /* 1049038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049048 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1049051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049070 */     // GIR_Coverage, 19090,
     /* 1049070 */     GIR_EraseRootFromParent_Done,
     /* 1049071 */   // Label 15530: @1049071
     /* 1049071 */   GIM_Try, /*On fail goto*//*Label 15531*/ GIMT_Encode4(1049148), // Rule ID 19091 //
     /* 1049076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1049079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1049087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1049090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1049093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1049096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049115 */     // MIs[0] policy
     /* 1049115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049125 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1049128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049134 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049147 */     // GIR_Coverage, 19091,
     /* 1049147 */     GIR_EraseRootFromParent_Done,
     /* 1049148 */   // Label 15531: @1049148
     /* 1049148 */   GIM_Try, /*On fail goto*//*Label 15532*/ GIMT_Encode4(1049225), // Rule ID 19094 //
     /* 1049153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1049156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1049164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1049167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1049170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049192 */     // MIs[0] policy
     /* 1049192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049202 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1049205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049221 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049224 */     // GIR_Coverage, 19094,
     /* 1049224 */     GIR_EraseRootFromParent_Done,
     /* 1049225 */   // Label 15532: @1049225
     /* 1049225 */   GIM_Try, /*On fail goto*//*Label 15533*/ GIMT_Encode4(1049302), // Rule ID 19095 //
     /* 1049230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1049233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1049241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1049244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1049247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049269 */     // MIs[0] policy
     /* 1049269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049279 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1049282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049301 */     // GIR_Coverage, 19095,
     /* 1049301 */     GIR_EraseRootFromParent_Done,
     /* 1049302 */   // Label 15533: @1049302
     /* 1049302 */   GIM_Try, /*On fail goto*//*Label 15534*/ GIMT_Encode4(1049379), // Rule ID 19098 //
     /* 1049307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1049310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1049318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1049321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1049324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049346 */     // MIs[0] policy
     /* 1049346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049356 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1049359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049378 */     // GIR_Coverage, 19098,
     /* 1049378 */     GIR_EraseRootFromParent_Done,
     /* 1049379 */   // Label 15534: @1049379
     /* 1049379 */   GIM_Try, /*On fail goto*//*Label 15535*/ GIMT_Encode4(1049456), // Rule ID 19099 //
     /* 1049384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1049387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1049395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1049398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1049401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049423 */     // MIs[0] policy
     /* 1049423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049433 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1049436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049442 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049455 */     // GIR_Coverage, 19099,
     /* 1049455 */     GIR_EraseRootFromParent_Done,
     /* 1049456 */   // Label 15535: @1049456
     /* 1049456 */   GIM_Try, /*On fail goto*//*Label 15536*/ GIMT_Encode4(1049533), // Rule ID 19102 //
     /* 1049461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1049464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1049472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1049475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1049478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1049481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049500 */     // MIs[0] policy
     /* 1049500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049510 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1049513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049529 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049532 */     // GIR_Coverage, 19102,
     /* 1049532 */     GIR_EraseRootFromParent_Done,
     /* 1049533 */   // Label 15536: @1049533
     /* 1049533 */   GIM_Try, /*On fail goto*//*Label 15537*/ GIMT_Encode4(1049610), // Rule ID 19103 //
     /* 1049538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1049541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1049549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1049552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1049555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1049558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049577 */     // MIs[0] policy
     /* 1049577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049587 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1049590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049609 */     // GIR_Coverage, 19103,
     /* 1049609 */     GIR_EraseRootFromParent_Done,
     /* 1049610 */   // Label 15537: @1049610
     /* 1049610 */   GIM_Try, /*On fail goto*//*Label 15538*/ GIMT_Encode4(1049687), // Rule ID 19106 //
     /* 1049615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1049618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1049626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1049629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1049632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1049635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049654 */     // MIs[0] policy
     /* 1049654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049664 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1049667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049683 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049686 */     // GIR_Coverage, 19106,
     /* 1049686 */     GIR_EraseRootFromParent_Done,
     /* 1049687 */   // Label 15538: @1049687
     /* 1049687 */   GIM_Try, /*On fail goto*//*Label 15539*/ GIMT_Encode4(1049764), // Rule ID 19107 //
     /* 1049692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1049695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1049703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1049706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1049709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1049712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049731 */     // MIs[0] policy
     /* 1049731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049741 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1049744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049750 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049763 */     // GIR_Coverage, 19107,
     /* 1049763 */     GIR_EraseRootFromParent_Done,
     /* 1049764 */   // Label 15539: @1049764
     /* 1049764 */   GIM_Try, /*On fail goto*//*Label 15540*/ GIMT_Encode4(1049841), // Rule ID 19110 //
     /* 1049769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1049772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1049780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1049783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1049786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049808 */     // MIs[0] policy
     /* 1049808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049818 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1049821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049840 */     // GIR_Coverage, 19110,
     /* 1049840 */     GIR_EraseRootFromParent_Done,
     /* 1049841 */   // Label 15540: @1049841
     /* 1049841 */   GIM_Try, /*On fail goto*//*Label 15541*/ GIMT_Encode4(1049918), // Rule ID 19111 //
     /* 1049846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1049849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1049857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1049860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1049863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049885 */     // MIs[0] policy
     /* 1049885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049895 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1049898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049904 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049917 */     // GIR_Coverage, 19111,
     /* 1049917 */     GIR_EraseRootFromParent_Done,
     /* 1049918 */   // Label 15541: @1049918
     /* 1049918 */   GIM_Try, /*On fail goto*//*Label 15542*/ GIMT_Encode4(1049995), // Rule ID 19114 //
     /* 1049923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1049926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1049934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1049937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1049940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049962 */     // MIs[0] policy
     /* 1049962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049972 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1049975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049991 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049994 */     // GIR_Coverage, 19114,
     /* 1049994 */     GIR_EraseRootFromParent_Done,
     /* 1049995 */   // Label 15542: @1049995
     /* 1049995 */   GIM_Try, /*On fail goto*//*Label 15543*/ GIMT_Encode4(1050072), // Rule ID 19115 //
     /* 1050000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1050003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1050011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1050014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1050017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1050020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1050027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050039 */     // MIs[0] policy
     /* 1050039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050049 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1050052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050058 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050068 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050071 */     // GIR_Coverage, 19115,
     /* 1050071 */     GIR_EraseRootFromParent_Done,
     /* 1050072 */   // Label 15543: @1050072
     /* 1050072 */   GIM_Try, /*On fail goto*//*Label 15544*/ GIMT_Encode4(1050149), // Rule ID 20498 //
     /* 1050077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1050088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1050091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1050094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050116 */     // MIs[0] policy
     /* 1050116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050145 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050148 */     // GIR_Coverage, 20498,
     /* 1050148 */     GIR_EraseRootFromParent_Done,
     /* 1050149 */   // Label 15544: @1050149
     /* 1050149 */   GIM_Try, /*On fail goto*//*Label 15545*/ GIMT_Encode4(1050226), // Rule ID 20499 //
     /* 1050154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1050157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1050165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1050168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1050171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050193 */     // MIs[0] policy
     /* 1050193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050203 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050225 */     // GIR_Coverage, 20499,
     /* 1050225 */     GIR_EraseRootFromParent_Done,
     /* 1050226 */   // Label 15545: @1050226
     /* 1050226 */   GIM_Try, /*On fail goto*//*Label 15546*/ GIMT_Encode4(1050303), // Rule ID 20502 //
     /* 1050231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1050234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1050242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1050245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1050248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050270 */     // MIs[0] policy
     /* 1050270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050280 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050302 */     // GIR_Coverage, 20502,
     /* 1050302 */     GIR_EraseRootFromParent_Done,
     /* 1050303 */   // Label 15546: @1050303
     /* 1050303 */   GIM_Try, /*On fail goto*//*Label 15547*/ GIMT_Encode4(1050380), // Rule ID 20503 //
     /* 1050308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1050311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1050319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1050322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1050325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050347 */     // MIs[0] policy
     /* 1050347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050357 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050379 */     // GIR_Coverage, 20503,
     /* 1050379 */     GIR_EraseRootFromParent_Done,
     /* 1050380 */   // Label 15547: @1050380
     /* 1050380 */   GIM_Try, /*On fail goto*//*Label 15548*/ GIMT_Encode4(1050457), // Rule ID 20506 //
     /* 1050385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1050396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1050399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1050402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050424 */     // MIs[0] policy
     /* 1050424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050434 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050456 */     // GIR_Coverage, 20506,
     /* 1050456 */     GIR_EraseRootFromParent_Done,
     /* 1050457 */   // Label 15548: @1050457
     /* 1050457 */   GIM_Try, /*On fail goto*//*Label 15549*/ GIMT_Encode4(1050534), // Rule ID 20507 //
     /* 1050462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1050465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1050473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1050476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1050479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050501 */     // MIs[0] policy
     /* 1050501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050511 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050520 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050530 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050533 */     // GIR_Coverage, 20507,
     /* 1050533 */     GIR_EraseRootFromParent_Done,
     /* 1050534 */   // Label 15549: @1050534
     /* 1050534 */   GIM_Try, /*On fail goto*//*Label 15550*/ GIMT_Encode4(1050611), // Rule ID 20510 //
     /* 1050539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1050542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1050550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1050553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1050556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050578 */     // MIs[0] policy
     /* 1050578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050610 */     // GIR_Coverage, 20510,
     /* 1050610 */     GIR_EraseRootFromParent_Done,
     /* 1050611 */   // Label 15550: @1050611
     /* 1050611 */   GIM_Try, /*On fail goto*//*Label 15551*/ GIMT_Encode4(1050688), // Rule ID 20511 //
     /* 1050616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1050619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1050627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1050630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1050633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050655 */     // MIs[0] policy
     /* 1050655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050665 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050687 */     // GIR_Coverage, 20511,
     /* 1050687 */     GIR_EraseRootFromParent_Done,
     /* 1050688 */   // Label 15551: @1050688
     /* 1050688 */   GIM_Try, /*On fail goto*//*Label 15552*/ GIMT_Encode4(1050765), // Rule ID 20514 //
     /* 1050693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1050696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1050704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1050707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1050710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050732 */     // MIs[0] policy
     /* 1050732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050742 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050764 */     // GIR_Coverage, 20514,
     /* 1050764 */     GIR_EraseRootFromParent_Done,
     /* 1050765 */   // Label 15552: @1050765
     /* 1050765 */   GIM_Try, /*On fail goto*//*Label 15553*/ GIMT_Encode4(1050842), // Rule ID 20515 //
     /* 1050770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1050773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1050781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1050784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1050787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050809 */     // MIs[0] policy
     /* 1050809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050819 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050828 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050841 */     // GIR_Coverage, 20515,
     /* 1050841 */     GIR_EraseRootFromParent_Done,
     /* 1050842 */   // Label 15553: @1050842
     /* 1050842 */   GIM_Try, /*On fail goto*//*Label 15554*/ GIMT_Encode4(1050919), // Rule ID 20518 //
     /* 1050847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1050858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1050861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1050864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1050867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1050874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050886 */     // MIs[0] policy
     /* 1050886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1050899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050918 */     // GIR_Coverage, 20518,
     /* 1050918 */     GIR_EraseRootFromParent_Done,
     /* 1050919 */   // Label 15554: @1050919
     /* 1050919 */   GIM_Try, /*On fail goto*//*Label 15555*/ GIMT_Encode4(1050996), // Rule ID 20519 //
     /* 1050924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1050927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1050935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1050938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1050941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1050944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1050951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050963 */     // MIs[0] policy
     /* 1050963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050973 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1050976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050982 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050995 */     // GIR_Coverage, 20519,
     /* 1050995 */     GIR_EraseRootFromParent_Done,
     /* 1050996 */   // Label 15555: @1050996
     /* 1050996 */   GIM_Try, /*On fail goto*//*Label 15556*/ GIMT_Encode4(1051073), // Rule ID 20522 //
     /* 1051001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1051004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1051012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1051015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1051018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051040 */     // MIs[0] policy
     /* 1051040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051050 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051069 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051072 */     // GIR_Coverage, 20522,
     /* 1051072 */     GIR_EraseRootFromParent_Done,
     /* 1051073 */   // Label 15556: @1051073
     /* 1051073 */   GIM_Try, /*On fail goto*//*Label 15557*/ GIMT_Encode4(1051150), // Rule ID 20523 //
     /* 1051078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1051081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1051089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1051092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1051095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051117 */     // MIs[0] policy
     /* 1051117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051127 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051136 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051146 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051149 */     // GIR_Coverage, 20523,
     /* 1051149 */     GIR_EraseRootFromParent_Done,
     /* 1051150 */   // Label 15557: @1051150
     /* 1051150 */   GIM_Try, /*On fail goto*//*Label 15558*/ GIMT_Encode4(1051227), // Rule ID 20526 //
     /* 1051155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1051158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1051166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1051169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1051172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1051175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051194 */     // MIs[0] policy
     /* 1051194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051204 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051223 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051226 */     // GIR_Coverage, 20526,
     /* 1051226 */     GIR_EraseRootFromParent_Done,
     /* 1051227 */   // Label 15558: @1051227
     /* 1051227 */   GIM_Try, /*On fail goto*//*Label 15559*/ GIMT_Encode4(1051304), // Rule ID 20527 //
     /* 1051232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1051235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1051243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1051246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1051249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1051252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051271 */     // MIs[0] policy
     /* 1051271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051281 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051290 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051303 */     // GIR_Coverage, 20527,
     /* 1051303 */     GIR_EraseRootFromParent_Done,
     /* 1051304 */   // Label 15559: @1051304
     /* 1051304 */   GIM_Try, /*On fail goto*//*Label 15560*/ GIMT_Encode4(1051381), // Rule ID 20530 //
     /* 1051309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1051312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1051320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1051323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1051326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1051329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051348 */     // MIs[0] policy
     /* 1051348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051377 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051380 */     // GIR_Coverage, 20530,
     /* 1051380 */     GIR_EraseRootFromParent_Done,
     /* 1051381 */   // Label 15560: @1051381
     /* 1051381 */   GIM_Try, /*On fail goto*//*Label 15561*/ GIMT_Encode4(1051458), // Rule ID 20531 //
     /* 1051386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1051389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1051397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1051400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1051403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1051406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051425 */     // MIs[0] policy
     /* 1051425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051435 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051457 */     // GIR_Coverage, 20531,
     /* 1051457 */     GIR_EraseRootFromParent_Done,
     /* 1051458 */   // Label 15561: @1051458
     /* 1051458 */   GIM_Try, /*On fail goto*//*Label 15562*/ GIMT_Encode4(1051535), // Rule ID 20534 //
     /* 1051463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1051466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1051474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1051477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1051480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1051483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051502 */     // MIs[0] policy
     /* 1051502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051512 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051534 */     // GIR_Coverage, 20534,
     /* 1051534 */     GIR_EraseRootFromParent_Done,
     /* 1051535 */   // Label 15562: @1051535
     /* 1051535 */   GIM_Try, /*On fail goto*//*Label 15563*/ GIMT_Encode4(1051612), // Rule ID 20535 //
     /* 1051540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1051543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1051551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1051554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1051557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1051560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051579 */     // MIs[0] policy
     /* 1051579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051589 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051598 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051611 */     // GIR_Coverage, 20535,
     /* 1051611 */     GIR_EraseRootFromParent_Done,
     /* 1051612 */   // Label 15563: @1051612
     /* 1051612 */   GIM_Try, /*On fail goto*//*Label 15564*/ GIMT_Encode4(1051689), // Rule ID 20538 //
     /* 1051617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1051620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1051628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1051631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1051634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051656 */     // MIs[0] policy
     /* 1051656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051688 */     // GIR_Coverage, 20538,
     /* 1051688 */     GIR_EraseRootFromParent_Done,
     /* 1051689 */   // Label 15564: @1051689
     /* 1051689 */   GIM_Try, /*On fail goto*//*Label 15565*/ GIMT_Encode4(1051766), // Rule ID 20539 //
     /* 1051694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1051697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1051705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1051708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1051711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051733 */     // MIs[0] policy
     /* 1051733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051743 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051752 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051765 */     // GIR_Coverage, 20539,
     /* 1051765 */     GIR_EraseRootFromParent_Done,
     /* 1051766 */   // Label 15565: @1051766
     /* 1051766 */   GIM_Try, /*On fail goto*//*Label 15566*/ GIMT_Encode4(1051843), // Rule ID 20542 //
     /* 1051771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1051774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1051782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1051785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1051788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051810 */     // MIs[0] policy
     /* 1051810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051820 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051839 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051842 */     // GIR_Coverage, 20542,
     /* 1051842 */     GIR_EraseRootFromParent_Done,
     /* 1051843 */   // Label 15566: @1051843
     /* 1051843 */   GIM_Try, /*On fail goto*//*Label 15567*/ GIMT_Encode4(1051920), // Rule ID 20543 //
     /* 1051848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1051851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1051859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1051862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1051865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051887 */     // MIs[0] policy
     /* 1051887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051897 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051906 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051916 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051919 */     // GIR_Coverage, 20543,
     /* 1051919 */     GIR_EraseRootFromParent_Done,
     /* 1051920 */   // Label 15567: @1051920
     /* 1051920 */   GIM_Try, /*On fail goto*//*Label 15568*/ GIMT_Encode4(1051997), // Rule ID 20546 //
     /* 1051925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1051928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1051936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1051939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1051942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1051945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051964 */     // MIs[0] policy
     /* 1051964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051974 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051993 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051996 */     // GIR_Coverage, 20546,
     /* 1051996 */     GIR_EraseRootFromParent_Done,
     /* 1051997 */   // Label 15568: @1051997
     /* 1051997 */   GIM_Try, /*On fail goto*//*Label 15569*/ GIMT_Encode4(1052074), // Rule ID 20547 //
     /* 1052002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1052005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1052013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1052016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1052019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052041 */     // MIs[0] policy
     /* 1052041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052051 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1052054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052060 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052070 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052073 */     // GIR_Coverage, 20547,
     /* 1052073 */     GIR_EraseRootFromParent_Done,
     /* 1052074 */   // Label 15569: @1052074
     /* 1052074 */   GIM_Try, /*On fail goto*//*Label 15570*/ GIMT_Encode4(1052151), // Rule ID 20550 //
     /* 1052079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1052082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1052090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1052093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1052096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052118 */     // MIs[0] policy
     /* 1052118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052128 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1052131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052147 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052150 */     // GIR_Coverage, 20550,
     /* 1052150 */     GIR_EraseRootFromParent_Done,
     /* 1052151 */   // Label 15570: @1052151
     /* 1052151 */   GIM_Try, /*On fail goto*//*Label 15571*/ GIMT_Encode4(1052228), // Rule ID 20551 //
     /* 1052156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1052159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1052167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1052170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1052173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052195 */     // MIs[0] policy
     /* 1052195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052205 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1052208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052214 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052227 */     // GIR_Coverage, 20551,
     /* 1052227 */     GIR_EraseRootFromParent_Done,
     /* 1052228 */   // Label 15571: @1052228
     /* 1052228 */   GIM_Try, /*On fail goto*//*Label 15572*/ GIMT_Encode4(1052305), // Rule ID 20876 //
     /* 1052233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1052244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1052247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1052250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052272 */     // MIs[0] policy
     /* 1052272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052282 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1052285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052301 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052304 */     // GIR_Coverage, 20876,
     /* 1052304 */     GIR_EraseRootFromParent_Done,
     /* 1052305 */   // Label 15572: @1052305
     /* 1052305 */   GIM_Try, /*On fail goto*//*Label 15573*/ GIMT_Encode4(1052382), // Rule ID 20877 //
     /* 1052310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1052313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1052321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1052324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1052327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052349 */     // MIs[0] policy
     /* 1052349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052359 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1052362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052368 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052381 */     // GIR_Coverage, 20877,
     /* 1052381 */     GIR_EraseRootFromParent_Done,
     /* 1052382 */   // Label 15573: @1052382
     /* 1052382 */   GIM_Try, /*On fail goto*//*Label 15574*/ GIMT_Encode4(1052459), // Rule ID 20880 //
     /* 1052387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1052398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1052401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1052404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052426 */     // MIs[0] policy
     /* 1052426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052436 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052455 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052458 */     // GIR_Coverage, 20880,
     /* 1052458 */     GIR_EraseRootFromParent_Done,
     /* 1052459 */   // Label 15574: @1052459
     /* 1052459 */   GIM_Try, /*On fail goto*//*Label 15575*/ GIMT_Encode4(1052536), // Rule ID 20881 //
     /* 1052464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1052467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1052475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1052478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1052481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052503 */     // MIs[0] policy
     /* 1052503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052513 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052522 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052535 */     // GIR_Coverage, 20881,
     /* 1052535 */     GIR_EraseRootFromParent_Done,
     /* 1052536 */   // Label 15575: @1052536
     /* 1052536 */   GIM_Try, /*On fail goto*//*Label 15576*/ GIMT_Encode4(1052613), // Rule ID 20884 //
     /* 1052541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1052544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1052552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1052555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1052558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052580 */     // MIs[0] policy
     /* 1052580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052590 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052612 */     // GIR_Coverage, 20884,
     /* 1052612 */     GIR_EraseRootFromParent_Done,
     /* 1052613 */   // Label 15576: @1052613
     /* 1052613 */   GIM_Try, /*On fail goto*//*Label 15577*/ GIMT_Encode4(1052690), // Rule ID 20885 //
     /* 1052618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1052621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1052629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1052632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1052635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052657 */     // MIs[0] policy
     /* 1052657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052667 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052676 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052689 */     // GIR_Coverage, 20885,
     /* 1052689 */     GIR_EraseRootFromParent_Done,
     /* 1052690 */   // Label 15577: @1052690
     /* 1052690 */   GIM_Try, /*On fail goto*//*Label 15578*/ GIMT_Encode4(1052767), // Rule ID 20888 //
     /* 1052695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1052706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1052709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1052712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052734 */     // MIs[0] policy
     /* 1052734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052744 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052763 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052766 */     // GIR_Coverage, 20888,
     /* 1052766 */     GIR_EraseRootFromParent_Done,
     /* 1052767 */   // Label 15578: @1052767
     /* 1052767 */   GIM_Try, /*On fail goto*//*Label 15579*/ GIMT_Encode4(1052844), // Rule ID 20889 //
     /* 1052772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1052775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1052783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1052786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1052789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052811 */     // MIs[0] policy
     /* 1052811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052821 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052830 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052843 */     // GIR_Coverage, 20889,
     /* 1052843 */     GIR_EraseRootFromParent_Done,
     /* 1052844 */   // Label 15579: @1052844
     /* 1052844 */   GIM_Try, /*On fail goto*//*Label 15580*/ GIMT_Encode4(1052921), // Rule ID 20892 //
     /* 1052849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1052852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1052860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1052863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1052866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052888 */     // MIs[0] policy
     /* 1052888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052898 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052917 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052920 */     // GIR_Coverage, 20892,
     /* 1052920 */     GIR_EraseRootFromParent_Done,
     /* 1052921 */   // Label 15580: @1052921
     /* 1052921 */   GIM_Try, /*On fail goto*//*Label 15581*/ GIMT_Encode4(1052998), // Rule ID 20893 //
     /* 1052926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1052929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1052937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1052940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1052943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052965 */     // MIs[0] policy
     /* 1052965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052975 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052984 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052994 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052997 */     // GIR_Coverage, 20893,
     /* 1052997 */     GIR_EraseRootFromParent_Done,
     /* 1052998 */   // Label 15581: @1052998
     /* 1052998 */   GIM_Try, /*On fail goto*//*Label 15582*/ GIMT_Encode4(1053075), // Rule ID 20896 //
     /* 1053003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1053006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1053014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1053017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1053020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1053023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053042 */     // MIs[0] policy
     /* 1053042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053071 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053074 */     // GIR_Coverage, 20896,
     /* 1053074 */     GIR_EraseRootFromParent_Done,
     /* 1053075 */   // Label 15582: @1053075
     /* 1053075 */   GIM_Try, /*On fail goto*//*Label 15583*/ GIMT_Encode4(1053152), // Rule ID 20897 //
     /* 1053080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1053083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1053091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1053094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1053097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1053100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053119 */     // MIs[0] policy
     /* 1053119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053129 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053151 */     // GIR_Coverage, 20897,
     /* 1053151 */     GIR_EraseRootFromParent_Done,
     /* 1053152 */   // Label 15583: @1053152
     /* 1053152 */   GIM_Try, /*On fail goto*//*Label 15584*/ GIMT_Encode4(1053229), // Rule ID 20900 //
     /* 1053157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1053168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1053171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1053174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053196 */     // MIs[0] policy
     /* 1053196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053228 */     // GIR_Coverage, 20900,
     /* 1053228 */     GIR_EraseRootFromParent_Done,
     /* 1053229 */   // Label 15584: @1053229
     /* 1053229 */   GIM_Try, /*On fail goto*//*Label 15585*/ GIMT_Encode4(1053306), // Rule ID 20901 //
     /* 1053234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1053245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1053248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1053251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053273 */     // MIs[0] policy
     /* 1053273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053283 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053305 */     // GIR_Coverage, 20901,
     /* 1053305 */     GIR_EraseRootFromParent_Done,
     /* 1053306 */   // Label 15585: @1053306
     /* 1053306 */   GIM_Try, /*On fail goto*//*Label 15586*/ GIMT_Encode4(1053383), // Rule ID 20904 //
     /* 1053311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1053322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1053325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1053328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053350 */     // MIs[0] policy
     /* 1053350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053360 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053379 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053382 */     // GIR_Coverage, 20904,
     /* 1053382 */     GIR_EraseRootFromParent_Done,
     /* 1053383 */   // Label 15586: @1053383
     /* 1053383 */   GIM_Try, /*On fail goto*//*Label 15587*/ GIMT_Encode4(1053460), // Rule ID 20905 //
     /* 1053388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1053399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1053402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1053405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053427 */     // MIs[0] policy
     /* 1053427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053437 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053446 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053459 */     // GIR_Coverage, 20905,
     /* 1053459 */     GIR_EraseRootFromParent_Done,
     /* 1053460 */   // Label 15587: @1053460
     /* 1053460 */   GIM_Try, /*On fail goto*//*Label 15588*/ GIMT_Encode4(1053537), // Rule ID 20908 //
     /* 1053465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1053476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1053479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1053482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1053485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053504 */     // MIs[0] policy
     /* 1053504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053514 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1053517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053533 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053536 */     // GIR_Coverage, 20908,
     /* 1053536 */     GIR_EraseRootFromParent_Done,
     /* 1053537 */   // Label 15588: @1053537
     /* 1053537 */   GIM_Try, /*On fail goto*//*Label 15589*/ GIMT_Encode4(1053614), // Rule ID 20909 //
     /* 1053542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1053553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1053556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1053559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1053562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053581 */     // MIs[0] policy
     /* 1053581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053591 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1053594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053600 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053610 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053613 */     // GIR_Coverage, 20909,
     /* 1053613 */     GIR_EraseRootFromParent_Done,
     /* 1053614 */   // Label 15589: @1053614
     /* 1053614 */   GIM_Try, /*On fail goto*//*Label 15590*/ GIMT_Encode4(1053691), // Rule ID 20912 //
     /* 1053619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1053622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1053630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1053633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1053636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053658 */     // MIs[0] policy
     /* 1053658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053687 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053690 */     // GIR_Coverage, 20912,
     /* 1053690 */     GIR_EraseRootFromParent_Done,
     /* 1053691 */   // Label 15590: @1053691
     /* 1053691 */   GIM_Try, /*On fail goto*//*Label 15591*/ GIMT_Encode4(1053768), // Rule ID 20913 //
     /* 1053696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1053699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1053707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1053710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1053713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053735 */     // MIs[0] policy
     /* 1053735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053745 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053754 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053764 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053767 */     // GIR_Coverage, 20913,
     /* 1053767 */     GIR_EraseRootFromParent_Done,
     /* 1053768 */   // Label 15591: @1053768
     /* 1053768 */   GIM_Try, /*On fail goto*//*Label 15592*/ GIMT_Encode4(1053845), // Rule ID 20916 //
     /* 1053773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1053776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1053784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1053787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1053790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053812 */     // MIs[0] policy
     /* 1053812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053841 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053844 */     // GIR_Coverage, 20916,
     /* 1053844 */     GIR_EraseRootFromParent_Done,
     /* 1053845 */   // Label 15592: @1053845
     /* 1053845 */   GIM_Try, /*On fail goto*//*Label 15593*/ GIMT_Encode4(1053922), // Rule ID 20917 //
     /* 1053850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1053853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1053861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1053864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1053867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053889 */     // MIs[0] policy
     /* 1053889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053899 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053921 */     // GIR_Coverage, 20917,
     /* 1053921 */     GIR_EraseRootFromParent_Done,
     /* 1053922 */   // Label 15593: @1053922
     /* 1053922 */   GIM_Try, /*On fail goto*//*Label 15594*/ GIMT_Encode4(1053999), // Rule ID 20920 //
     /* 1053927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1053930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1053938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1053941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1053944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053966 */     // MIs[0] policy
     /* 1053966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053976 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1053979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053998 */     // GIR_Coverage, 20920,
     /* 1053998 */     GIR_EraseRootFromParent_Done,
     /* 1053999 */   // Label 15594: @1053999
     /* 1053999 */   GIM_Try, /*On fail goto*//*Label 15595*/ GIMT_Encode4(1054076), // Rule ID 20921 //
     /* 1054004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1054015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1054018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1054021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1054024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054043 */     // MIs[0] policy
     /* 1054043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054053 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054062 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054075 */     // GIR_Coverage, 20921,
     /* 1054075 */     GIR_EraseRootFromParent_Done,
     /* 1054076 */   // Label 15595: @1054076
     /* 1054076 */   GIM_Try, /*On fail goto*//*Label 15596*/ GIMT_Encode4(1054153), // Rule ID 20924 //
     /* 1054081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1054092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1054095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1054098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054120 */     // MIs[0] policy
     /* 1054120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1054133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054152 */     // GIR_Coverage, 20924,
     /* 1054152 */     GIR_EraseRootFromParent_Done,
     /* 1054153 */   // Label 15596: @1054153
     /* 1054153 */   GIM_Try, /*On fail goto*//*Label 15597*/ GIMT_Encode4(1054230), // Rule ID 20925 //
     /* 1054158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1054169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1054172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1054175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054197 */     // MIs[0] policy
     /* 1054197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054207 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1054210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054229 */     // GIR_Coverage, 20925,
     /* 1054229 */     GIR_EraseRootFromParent_Done,
     /* 1054230 */   // Label 15597: @1054230
     /* 1054230 */   GIM_Try, /*On fail goto*//*Label 15598*/ GIMT_Encode4(1054307), // Rule ID 20928 //
     /* 1054235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1054246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1054249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1054252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054274 */     // MIs[0] policy
     /* 1054274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054284 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1054287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054306 */     // GIR_Coverage, 20928,
     /* 1054306 */     GIR_EraseRootFromParent_Done,
     /* 1054307 */   // Label 15598: @1054307
     /* 1054307 */   GIM_Try, /*On fail goto*//*Label 15599*/ GIMT_Encode4(1054384), // Rule ID 20929 //
     /* 1054312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1054323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1054326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1054329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054351 */     // MIs[0] policy
     /* 1054351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054361 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1054364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054370 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054380 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054383 */     // GIR_Coverage, 20929,
     /* 1054383 */     GIR_EraseRootFromParent_Done,
     /* 1054384 */   // Label 15599: @1054384
     /* 1054384 */   GIM_Try, /*On fail goto*//*Label 15600*/ GIMT_Encode4(1054461), // Rule ID 20932 //
     /* 1054389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1054400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1054403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1054406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054428 */     // MIs[0] policy
     /* 1054428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054438 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054457 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054460 */     // GIR_Coverage, 20932,
     /* 1054460 */     GIR_EraseRootFromParent_Done,
     /* 1054461 */   // Label 15600: @1054461
     /* 1054461 */   GIM_Try, /*On fail goto*//*Label 15601*/ GIMT_Encode4(1054538), // Rule ID 20933 //
     /* 1054466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1054477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1054480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1054483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054505 */     // MIs[0] policy
     /* 1054505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054515 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054537 */     // GIR_Coverage, 20933,
     /* 1054537 */     GIR_EraseRootFromParent_Done,
     /* 1054538 */   // Label 15601: @1054538
     /* 1054538 */   GIM_Try, /*On fail goto*//*Label 15602*/ GIMT_Encode4(1054615), // Rule ID 20936 //
     /* 1054543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1054554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1054557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1054560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054582 */     // MIs[0] policy
     /* 1054582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054592 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1054595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054614 */     // GIR_Coverage, 20936,
     /* 1054614 */     GIR_EraseRootFromParent_Done,
     /* 1054615 */   // Label 15602: @1054615
     /* 1054615 */   GIM_Try, /*On fail goto*//*Label 15603*/ GIMT_Encode4(1054692), // Rule ID 20937 //
     /* 1054620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1054631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1054634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1054637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054659 */     // MIs[0] policy
     /* 1054659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054669 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1054672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054678 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054691 */     // GIR_Coverage, 20937,
     /* 1054691 */     GIR_EraseRootFromParent_Done,
     /* 1054692 */   // Label 15603: @1054692
     /* 1054692 */   GIM_Try, /*On fail goto*//*Label 15604*/ GIMT_Encode4(1054769), // Rule ID 20940 //
     /* 1054697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1054708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1054711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1054714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054736 */     // MIs[0] policy
     /* 1054736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054746 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1054749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054765 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054768 */     // GIR_Coverage, 20940,
     /* 1054768 */     GIR_EraseRootFromParent_Done,
     /* 1054769 */   // Label 15604: @1054769
     /* 1054769 */   GIM_Try, /*On fail goto*//*Label 15605*/ GIMT_Encode4(1054846), // Rule ID 20941 //
     /* 1054774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1054785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1054788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1054791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054813 */     // MIs[0] policy
     /* 1054813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054823 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1054826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054832 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054842 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054845 */     // GIR_Coverage, 20941,
     /* 1054845 */     GIR_EraseRootFromParent_Done,
     /* 1054846 */   // Label 15605: @1054846
     /* 1054846 */   GIM_Try, /*On fail goto*//*Label 15606*/ GIMT_Encode4(1054923), // Rule ID 20944 //
     /* 1054851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1054862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1054865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1054868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054890 */     // MIs[0] policy
     /* 1054890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054900 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1054903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054919 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054922 */     // GIR_Coverage, 20944,
     /* 1054922 */     GIR_EraseRootFromParent_Done,
     /* 1054923 */   // Label 15606: @1054923
     /* 1054923 */   GIM_Try, /*On fail goto*//*Label 15607*/ GIMT_Encode4(1055000), // Rule ID 20945 //
     /* 1054928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1054939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1054942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1054945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054967 */     // MIs[0] policy
     /* 1054967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054977 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1054980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054986 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054996 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054999 */     // GIR_Coverage, 20945,
     /* 1054999 */     GIR_EraseRootFromParent_Done,
     /* 1055000 */   // Label 15607: @1055000
     /* 1055000 */   GIM_Try, /*On fail goto*//*Label 15608*/ GIMT_Encode4(1055077), // Rule ID 20948 //
     /* 1055005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1055016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1055019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1055022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055044 */     // MIs[0] policy
     /* 1055044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055054 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055073 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055076 */     // GIR_Coverage, 20948,
     /* 1055076 */     GIR_EraseRootFromParent_Done,
     /* 1055077 */   // Label 15608: @1055077
     /* 1055077 */   GIM_Try, /*On fail goto*//*Label 15609*/ GIMT_Encode4(1055154), // Rule ID 20949 //
     /* 1055082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1055093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1055096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1055099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055121 */     // MIs[0] policy
     /* 1055121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055131 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055153 */     // GIR_Coverage, 20949,
     /* 1055153 */     GIR_EraseRootFromParent_Done,
     /* 1055154 */   // Label 15609: @1055154
     /* 1055154 */   GIM_Try, /*On fail goto*//*Label 15610*/ GIMT_Encode4(1055231), // Rule ID 20952 //
     /* 1055159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1055170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1055173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1055176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055198 */     // MIs[0] policy
     /* 1055198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055208 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055230 */     // GIR_Coverage, 20952,
     /* 1055230 */     GIR_EraseRootFromParent_Done,
     /* 1055231 */   // Label 15610: @1055231
     /* 1055231 */   GIM_Try, /*On fail goto*//*Label 15611*/ GIMT_Encode4(1055308), // Rule ID 20953 //
     /* 1055236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1055247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1055250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1055253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055275 */     // MIs[0] policy
     /* 1055275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055285 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055294 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055307 */     // GIR_Coverage, 20953,
     /* 1055307 */     GIR_EraseRootFromParent_Done,
     /* 1055308 */   // Label 15611: @1055308
     /* 1055308 */   GIM_Try, /*On fail goto*//*Label 15612*/ GIMT_Encode4(1055385), // Rule ID 20956 //
     /* 1055313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1055316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1055324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1055327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1055330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055352 */     // MIs[0] policy
     /* 1055352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055362 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055381 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055384 */     // GIR_Coverage, 20956,
     /* 1055384 */     GIR_EraseRootFromParent_Done,
     /* 1055385 */   // Label 15612: @1055385
     /* 1055385 */   GIM_Try, /*On fail goto*//*Label 15613*/ GIMT_Encode4(1055462), // Rule ID 20957 //
     /* 1055390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1055393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1055401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1055404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1055407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055429 */     // MIs[0] policy
     /* 1055429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055439 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055448 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055458 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055461 */     // GIR_Coverage, 20957,
     /* 1055461 */     GIR_EraseRootFromParent_Done,
     /* 1055462 */   // Label 15613: @1055462
     /* 1055462 */   GIM_Try, /*On fail goto*//*Label 15614*/ GIMT_Encode4(1055539), // Rule ID 20960 //
     /* 1055467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1055478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1055481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1055484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055506 */     // MIs[0] policy
     /* 1055506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1055519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055535 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055538 */     // GIR_Coverage, 20960,
     /* 1055538 */     GIR_EraseRootFromParent_Done,
     /* 1055539 */   // Label 15614: @1055539
     /* 1055539 */   GIM_Try, /*On fail goto*//*Label 15615*/ GIMT_Encode4(1055616), // Rule ID 20961 //
     /* 1055544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1055555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1055558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1055561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055583 */     // MIs[0] policy
     /* 1055583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055593 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1055596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055602 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055615 */     // GIR_Coverage, 20961,
     /* 1055615 */     GIR_EraseRootFromParent_Done,
     /* 1055616 */   // Label 15615: @1055616
     /* 1055616 */   GIM_Try, /*On fail goto*//*Label 15616*/ GIMT_Encode4(1055693), // Rule ID 20964 //
     /* 1055621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1055632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1055635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1055638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1055641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055660 */     // MIs[0] policy
     /* 1055660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055670 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1055673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055692 */     // GIR_Coverage, 20964,
     /* 1055692 */     GIR_EraseRootFromParent_Done,
     /* 1055693 */   // Label 15616: @1055693
     /* 1055693 */   GIM_Try, /*On fail goto*//*Label 15617*/ GIMT_Encode4(1055770), // Rule ID 20965 //
     /* 1055698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1055709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1055712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1055715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1055718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055737 */     // MIs[0] policy
     /* 1055737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055747 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1055750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055756 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055769 */     // GIR_Coverage, 20965,
     /* 1055769 */     GIR_EraseRootFromParent_Done,
     /* 1055770 */   // Label 15617: @1055770
     /* 1055770 */   GIM_Try, /*On fail goto*//*Label 15618*/ GIMT_Encode4(1055847), // Rule ID 20968 //
     /* 1055775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1055786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1055789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1055792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1055795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055814 */     // MIs[0] policy
     /* 1055814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055824 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1055827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055846 */     // GIR_Coverage, 20968,
     /* 1055846 */     GIR_EraseRootFromParent_Done,
     /* 1055847 */   // Label 15618: @1055847
     /* 1055847 */   GIM_Try, /*On fail goto*//*Label 15619*/ GIMT_Encode4(1055924), // Rule ID 20969 //
     /* 1055852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1055863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1055866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1055869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1055872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055891 */     // MIs[0] policy
     /* 1055891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055901 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1055904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055910 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055923 */     // GIR_Coverage, 20969,
     /* 1055923 */     GIR_EraseRootFromParent_Done,
     /* 1055924 */   // Label 15619: @1055924
     /* 1055924 */   GIM_Try, /*On fail goto*//*Label 15620*/ GIMT_Encode4(1056001), // Rule ID 20972 //
     /* 1055929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1055940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1055943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1055946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055968 */     // MIs[0] policy
     /* 1055968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055978 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1055981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056000 */     // GIR_Coverage, 20972,
     /* 1056000 */     GIR_EraseRootFromParent_Done,
     /* 1056001 */   // Label 15620: @1056001
     /* 1056001 */   GIM_Try, /*On fail goto*//*Label 15621*/ GIMT_Encode4(1056078), // Rule ID 20973 //
     /* 1056006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1056017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1056020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1056023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056045 */     // MIs[0] policy
     /* 1056045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056064 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056077 */     // GIR_Coverage, 20973,
     /* 1056077 */     GIR_EraseRootFromParent_Done,
     /* 1056078 */   // Label 15621: @1056078
     /* 1056078 */   GIM_Try, /*On fail goto*//*Label 15622*/ GIMT_Encode4(1056155), // Rule ID 20976 //
     /* 1056083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1056094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1056097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1056100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056122 */     // MIs[0] policy
     /* 1056122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056132 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056151 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056154 */     // GIR_Coverage, 20976,
     /* 1056154 */     GIR_EraseRootFromParent_Done,
     /* 1056155 */   // Label 15622: @1056155
     /* 1056155 */   GIM_Try, /*On fail goto*//*Label 15623*/ GIMT_Encode4(1056232), // Rule ID 20977 //
     /* 1056160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1056171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1056174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1056177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056199 */     // MIs[0] policy
     /* 1056199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056209 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056218 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056228 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056231 */     // GIR_Coverage, 20977,
     /* 1056231 */     GIR_EraseRootFromParent_Done,
     /* 1056232 */   // Label 15623: @1056232
     /* 1056232 */   GIM_Try, /*On fail goto*//*Label 15624*/ GIMT_Encode4(1056309), // Rule ID 20980 //
     /* 1056237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1056248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1056251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1056254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1056257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056276 */     // MIs[0] policy
     /* 1056276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056286 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056305 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056308 */     // GIR_Coverage, 20980,
     /* 1056308 */     GIR_EraseRootFromParent_Done,
     /* 1056309 */   // Label 15624: @1056309
     /* 1056309 */   GIM_Try, /*On fail goto*//*Label 15625*/ GIMT_Encode4(1056386), // Rule ID 20981 //
     /* 1056314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1056325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1056328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1056331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1056334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056353 */     // MIs[0] policy
     /* 1056353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056363 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056372 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056385 */     // GIR_Coverage, 20981,
     /* 1056385 */     GIR_EraseRootFromParent_Done,
     /* 1056386 */   // Label 15625: @1056386
     /* 1056386 */   GIM_Try, /*On fail goto*//*Label 15626*/ GIMT_Encode4(1056463), // Rule ID 20984 //
     /* 1056391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1056394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1056402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1056405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1056408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056430 */     // MIs[0] policy
     /* 1056430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056440 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056459 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056462 */     // GIR_Coverage, 20984,
     /* 1056462 */     GIR_EraseRootFromParent_Done,
     /* 1056463 */   // Label 15626: @1056463
     /* 1056463 */   GIM_Try, /*On fail goto*//*Label 15627*/ GIMT_Encode4(1056540), // Rule ID 20985 //
     /* 1056468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1056471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1056479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1056482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1056485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056507 */     // MIs[0] policy
     /* 1056507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056517 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056526 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056539 */     // GIR_Coverage, 20985,
     /* 1056539 */     GIR_EraseRootFromParent_Done,
     /* 1056540 */   // Label 15627: @1056540
     /* 1056540 */   GIM_Try, /*On fail goto*//*Label 15628*/ GIMT_Encode4(1056617), // Rule ID 20988 //
     /* 1056545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1056548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1056556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1056559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1056562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056584 */     // MIs[0] policy
     /* 1056584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056594 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056613 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056616 */     // GIR_Coverage, 20988,
     /* 1056616 */     GIR_EraseRootFromParent_Done,
     /* 1056617 */   // Label 15628: @1056617
     /* 1056617 */   GIM_Try, /*On fail goto*//*Label 15629*/ GIMT_Encode4(1056694), // Rule ID 20989 //
     /* 1056622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1056625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1056633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1056636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1056639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056661 */     // MIs[0] policy
     /* 1056661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056671 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056680 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056693 */     // GIR_Coverage, 20989,
     /* 1056693 */     GIR_EraseRootFromParent_Done,
     /* 1056694 */   // Label 15629: @1056694
     /* 1056694 */   GIM_Try, /*On fail goto*//*Label 15630*/ GIMT_Encode4(1056771), // Rule ID 20992 //
     /* 1056699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1056702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1056710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1056713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1056716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056738 */     // MIs[0] policy
     /* 1056738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056748 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056767 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056770 */     // GIR_Coverage, 20992,
     /* 1056770 */     GIR_EraseRootFromParent_Done,
     /* 1056771 */   // Label 15630: @1056771
     /* 1056771 */   GIM_Try, /*On fail goto*//*Label 15631*/ GIMT_Encode4(1056848), // Rule ID 20993 //
     /* 1056776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1056779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1056787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1056790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1056793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056815 */     // MIs[0] policy
     /* 1056815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056825 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056834 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056847 */     // GIR_Coverage, 20993,
     /* 1056847 */     GIR_EraseRootFromParent_Done,
     /* 1056848 */   // Label 15631: @1056848
     /* 1056848 */   GIM_Try, /*On fail goto*//*Label 15632*/ GIMT_Encode4(1056925), // Rule ID 21260 //
     /* 1056853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1056861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1056864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1056867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1056870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056892 */     // MIs[0] policy
     /* 1056892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056902 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1056905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056924 */     // GIR_Coverage, 21260,
     /* 1056924 */     GIR_EraseRootFromParent_Done,
     /* 1056925 */   // Label 15632: @1056925
     /* 1056925 */   GIM_Try, /*On fail goto*//*Label 15633*/ GIMT_Encode4(1057002), // Rule ID 21261 //
     /* 1056930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1056938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1056941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1056944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1056947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056969 */     // MIs[0] policy
     /* 1056969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056979 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1056982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057001 */     // GIR_Coverage, 21261,
     /* 1057001 */     GIR_EraseRootFromParent_Done,
     /* 1057002 */   // Label 15633: @1057002
     /* 1057002 */   GIM_Try, /*On fail goto*//*Label 15634*/ GIMT_Encode4(1057079), // Rule ID 21264 //
     /* 1057007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1057018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1057021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1057024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057046 */     // MIs[0] policy
     /* 1057046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057056 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057078 */     // GIR_Coverage, 21264,
     /* 1057078 */     GIR_EraseRootFromParent_Done,
     /* 1057079 */   // Label 15634: @1057079
     /* 1057079 */   GIM_Try, /*On fail goto*//*Label 15635*/ GIMT_Encode4(1057156), // Rule ID 21265 //
     /* 1057084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1057095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1057098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1057101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057123 */     // MIs[0] policy
     /* 1057123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057133 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057142 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057155 */     // GIR_Coverage, 21265,
     /* 1057155 */     GIR_EraseRootFromParent_Done,
     /* 1057156 */   // Label 15635: @1057156
     /* 1057156 */   GIM_Try, /*On fail goto*//*Label 15636*/ GIMT_Encode4(1057233), // Rule ID 21268 //
     /* 1057161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1057178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057200 */     // MIs[0] policy
     /* 1057200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057229 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057232 */     // GIR_Coverage, 21268,
     /* 1057232 */     GIR_EraseRootFromParent_Done,
     /* 1057233 */   // Label 15636: @1057233
     /* 1057233 */   GIM_Try, /*On fail goto*//*Label 15637*/ GIMT_Encode4(1057310), // Rule ID 21269 //
     /* 1057238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1057255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057277 */     // MIs[0] policy
     /* 1057277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057287 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057296 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057306 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057309 */     // GIR_Coverage, 21269,
     /* 1057309 */     GIR_EraseRootFromParent_Done,
     /* 1057310 */   // Label 15637: @1057310
     /* 1057310 */   GIM_Try, /*On fail goto*//*Label 15638*/ GIMT_Encode4(1057387), // Rule ID 21272 //
     /* 1057315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1057332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057354 */     // MIs[0] policy
     /* 1057354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057383 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057386 */     // GIR_Coverage, 21272,
     /* 1057386 */     GIR_EraseRootFromParent_Done,
     /* 1057387 */   // Label 15638: @1057387
     /* 1057387 */   GIM_Try, /*On fail goto*//*Label 15639*/ GIMT_Encode4(1057464), // Rule ID 21273 //
     /* 1057392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1057409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057431 */     // MIs[0] policy
     /* 1057431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057441 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057450 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057460 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057463 */     // GIR_Coverage, 21273,
     /* 1057463 */     GIR_EraseRootFromParent_Done,
     /* 1057464 */   // Label 15639: @1057464
     /* 1057464 */   GIM_Try, /*On fail goto*//*Label 15640*/ GIMT_Encode4(1057541), // Rule ID 21276 //
     /* 1057469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1057480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1057483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1057486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057508 */     // MIs[0] policy
     /* 1057508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057537 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057540 */     // GIR_Coverage, 21276,
     /* 1057540 */     GIR_EraseRootFromParent_Done,
     /* 1057541 */   // Label 15640: @1057541
     /* 1057541 */   GIM_Try, /*On fail goto*//*Label 15641*/ GIMT_Encode4(1057618), // Rule ID 21277 //
     /* 1057546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1057557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1057560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1057563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057585 */     // MIs[0] policy
     /* 1057585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057595 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057604 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057614 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057617 */     // GIR_Coverage, 21277,
     /* 1057617 */     GIR_EraseRootFromParent_Done,
     /* 1057618 */   // Label 15641: @1057618
     /* 1057618 */   GIM_Try, /*On fail goto*//*Label 15642*/ GIMT_Encode4(1057695), // Rule ID 21280 //
     /* 1057623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1057626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1057634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1057637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1057640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1057643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057662 */     // MIs[0] policy
     /* 1057662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057672 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057691 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057694 */     // GIR_Coverage, 21280,
     /* 1057694 */     GIR_EraseRootFromParent_Done,
     /* 1057695 */   // Label 15642: @1057695
     /* 1057695 */   GIM_Try, /*On fail goto*//*Label 15643*/ GIMT_Encode4(1057772), // Rule ID 21281 //
     /* 1057700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1057703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1057711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1057714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1057717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1057720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057739 */     // MIs[0] policy
     /* 1057739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057749 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057758 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057771 */     // GIR_Coverage, 21281,
     /* 1057771 */     GIR_EraseRootFromParent_Done,
     /* 1057772 */   // Label 15643: @1057772
     /* 1057772 */   GIM_Try, /*On fail goto*//*Label 15644*/ GIMT_Encode4(1057849), // Rule ID 21284 //
     /* 1057777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1057780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1057788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1057791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1057794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057816 */     // MIs[0] policy
     /* 1057816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057826 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057845 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057848 */     // GIR_Coverage, 21284,
     /* 1057848 */     GIR_EraseRootFromParent_Done,
     /* 1057849 */   // Label 15644: @1057849
     /* 1057849 */   GIM_Try, /*On fail goto*//*Label 15645*/ GIMT_Encode4(1057926), // Rule ID 21285 //
     /* 1057854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1057857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1057865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1057868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1057871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057893 */     // MIs[0] policy
     /* 1057893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057903 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057912 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057922 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057925 */     // GIR_Coverage, 21285,
     /* 1057925 */     GIR_EraseRootFromParent_Done,
     /* 1057926 */   // Label 15645: @1057926
     /* 1057926 */   GIM_Try, /*On fail goto*//*Label 15646*/ GIMT_Encode4(1058003), // Rule ID 21288 //
     /* 1057931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1057934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1057942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1057945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1057948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057970 */     // MIs[0] policy
     /* 1057970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057980 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058002 */     // GIR_Coverage, 21288,
     /* 1058002 */     GIR_EraseRootFromParent_Done,
     /* 1058003 */   // Label 15646: @1058003
     /* 1058003 */   GIM_Try, /*On fail goto*//*Label 15647*/ GIMT_Encode4(1058080), // Rule ID 21289 //
     /* 1058008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1058019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1058022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1058025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058047 */     // MIs[0] policy
     /* 1058047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058057 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1058060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058066 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058079 */     // GIR_Coverage, 21289,
     /* 1058079 */     GIR_EraseRootFromParent_Done,
     /* 1058080 */   // Label 15647: @1058080
     /* 1058080 */   GIM_Try, /*On fail goto*//*Label 15648*/ GIMT_Encode4(1058157), // Rule ID 21292 //
     /* 1058085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1058102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058124 */     // MIs[0] policy
     /* 1058124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058134 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058156 */     // GIR_Coverage, 21292,
     /* 1058156 */     GIR_EraseRootFromParent_Done,
     /* 1058157 */   // Label 15648: @1058157
     /* 1058157 */   GIM_Try, /*On fail goto*//*Label 15649*/ GIMT_Encode4(1058234), // Rule ID 21293 //
     /* 1058162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1058179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058201 */     // MIs[0] policy
     /* 1058201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058211 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058220 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058233 */     // GIR_Coverage, 21293,
     /* 1058233 */     GIR_EraseRootFromParent_Done,
     /* 1058234 */   // Label 15649: @1058234
     /* 1058234 */   GIM_Try, /*On fail goto*//*Label 15650*/ GIMT_Encode4(1058311), // Rule ID 21296 //
     /* 1058239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1058250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1058253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058278 */     // MIs[0] policy
     /* 1058278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058288 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1058291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058307 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058310 */     // GIR_Coverage, 21296,
     /* 1058310 */     GIR_EraseRootFromParent_Done,
     /* 1058311 */   // Label 15650: @1058311
     /* 1058311 */   GIM_Try, /*On fail goto*//*Label 15651*/ GIMT_Encode4(1058388), // Rule ID 21297 //
     /* 1058316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1058327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1058330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058355 */     // MIs[0] policy
     /* 1058355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058365 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1058368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058374 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058387 */     // GIR_Coverage, 21297,
     /* 1058387 */     GIR_EraseRootFromParent_Done,
     /* 1058388 */   // Label 15651: @1058388
     /* 1058388 */   GIM_Try, /*On fail goto*//*Label 15652*/ GIMT_Encode4(1058465), // Rule ID 21300 //
     /* 1058393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1058404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1058407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058432 */     // MIs[0] policy
     /* 1058432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058442 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058461 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058464 */     // GIR_Coverage, 21300,
     /* 1058464 */     GIR_EraseRootFromParent_Done,
     /* 1058465 */   // Label 15652: @1058465
     /* 1058465 */   GIM_Try, /*On fail goto*//*Label 15653*/ GIMT_Encode4(1058542), // Rule ID 21301 //
     /* 1058470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1058481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1058484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058509 */     // MIs[0] policy
     /* 1058509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058519 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058541 */     // GIR_Coverage, 21301,
     /* 1058541 */     GIR_EraseRootFromParent_Done,
     /* 1058542 */   // Label 15653: @1058542
     /* 1058542 */   GIM_Try, /*On fail goto*//*Label 15654*/ GIMT_Encode4(1058619), // Rule ID 21304 //
     /* 1058547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1058558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1058561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1058564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058586 */     // MIs[0] policy
     /* 1058586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1058599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058618 */     // GIR_Coverage, 21304,
     /* 1058618 */     GIR_EraseRootFromParent_Done,
     /* 1058619 */   // Label 15654: @1058619
     /* 1058619 */   GIM_Try, /*On fail goto*//*Label 15655*/ GIMT_Encode4(1058696), // Rule ID 21305 //
     /* 1058624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1058635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1058638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1058641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058663 */     // MIs[0] policy
     /* 1058663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058673 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1058676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058695 */     // GIR_Coverage, 21305,
     /* 1058695 */     GIR_EraseRootFromParent_Done,
     /* 1058696 */   // Label 15655: @1058696
     /* 1058696 */   GIM_Try, /*On fail goto*//*Label 15656*/ GIMT_Encode4(1058773), // Rule ID 21308 //
     /* 1058701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1058712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1058715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1058718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058740 */     // MIs[0] policy
     /* 1058740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058750 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1058753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058769 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058772 */     // GIR_Coverage, 21308,
     /* 1058772 */     GIR_EraseRootFromParent_Done,
     /* 1058773 */   // Label 15656: @1058773
     /* 1058773 */   GIM_Try, /*On fail goto*//*Label 15657*/ GIMT_Encode4(1058850), // Rule ID 21309 //
     /* 1058778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1058789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1058792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1058795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058817 */     // MIs[0] policy
     /* 1058817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058827 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1058830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058849 */     // GIR_Coverage, 21309,
     /* 1058849 */     GIR_EraseRootFromParent_Done,
     /* 1058850 */   // Label 15657: @1058850
     /* 1058850 */   GIM_Try, /*On fail goto*//*Label 15658*/ GIMT_Encode4(1058927), // Rule ID 21312 //
     /* 1058855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1058866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1058869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1058872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1058875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058894 */     // MIs[0] policy
     /* 1058894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058904 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1058907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058926 */     // GIR_Coverage, 21312,
     /* 1058926 */     GIR_EraseRootFromParent_Done,
     /* 1058927 */   // Label 15658: @1058927
     /* 1058927 */   GIM_Try, /*On fail goto*//*Label 15659*/ GIMT_Encode4(1059004), // Rule ID 21313 //
     /* 1058932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1058943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1058946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1058949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1058952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058971 */     // MIs[0] policy
     /* 1058971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058981 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1058984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058990 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059003 */     // GIR_Coverage, 21313,
     /* 1059003 */     GIR_EraseRootFromParent_Done,
     /* 1059004 */   // Label 15659: @1059004
     /* 1059004 */   GIM_Try, /*On fail goto*//*Label 15660*/ GIMT_Encode4(1059081), // Rule ID 21316 //
     /* 1059009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1059020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1059023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1059026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059048 */     // MIs[0] policy
     /* 1059048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059058 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1059061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059080 */     // GIR_Coverage, 21316,
     /* 1059080 */     GIR_EraseRootFromParent_Done,
     /* 1059081 */   // Label 15660: @1059081
     /* 1059081 */   GIM_Try, /*On fail goto*//*Label 15661*/ GIMT_Encode4(1059158), // Rule ID 21317 //
     /* 1059086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1059097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1059100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1059103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059125 */     // MIs[0] policy
     /* 1059125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059135 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1059138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059144 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059157 */     // GIR_Coverage, 21317,
     /* 1059157 */     GIR_EraseRootFromParent_Done,
     /* 1059158 */   // Label 15661: @1059158
     /* 1059158 */   GIM_Try, /*On fail goto*//*Label 15662*/ GIMT_Encode4(1059235), // Rule ID 21320 //
     /* 1059163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1059174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1059177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059202 */     // MIs[0] policy
     /* 1059202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059212 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1059215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059231 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059234 */     // GIR_Coverage, 21320,
     /* 1059234 */     GIR_EraseRootFromParent_Done,
     /* 1059235 */   // Label 15662: @1059235
     /* 1059235 */   GIM_Try, /*On fail goto*//*Label 15663*/ GIMT_Encode4(1059312), // Rule ID 21321 //
     /* 1059240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1059251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1059254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059279 */     // MIs[0] policy
     /* 1059279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1059292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059298 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059311 */     // GIR_Coverage, 21321,
     /* 1059311 */     GIR_EraseRootFromParent_Done,
     /* 1059312 */   // Label 15663: @1059312
     /* 1059312 */   GIM_Try, /*On fail goto*//*Label 15664*/ GIMT_Encode4(1059389), // Rule ID 21324 //
     /* 1059317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1059328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1059331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1059334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059356 */     // MIs[0] policy
     /* 1059356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059366 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1059369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059388 */     // GIR_Coverage, 21324,
     /* 1059388 */     GIR_EraseRootFromParent_Done,
     /* 1059389 */   // Label 15664: @1059389
     /* 1059389 */   GIM_Try, /*On fail goto*//*Label 15665*/ GIMT_Encode4(1059466), // Rule ID 21325 //
     /* 1059394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1059405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1059408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1059411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059433 */     // MIs[0] policy
     /* 1059433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059443 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1059446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059465 */     // GIR_Coverage, 21325,
     /* 1059465 */     GIR_EraseRootFromParent_Done,
     /* 1059466 */   // Label 15665: @1059466
     /* 1059466 */   GIM_Try, /*On fail goto*//*Label 15666*/ GIMT_Encode4(1059543), // Rule ID 21328 //
     /* 1059471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1059482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1059485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1059488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059510 */     // MIs[0] policy
     /* 1059510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059520 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1059523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059542 */     // GIR_Coverage, 21328,
     /* 1059542 */     GIR_EraseRootFromParent_Done,
     /* 1059543 */   // Label 15666: @1059543
     /* 1059543 */   GIM_Try, /*On fail goto*//*Label 15667*/ GIMT_Encode4(1059620), // Rule ID 21329 //
     /* 1059548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1059559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1059562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1059565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059587 */     // MIs[0] policy
     /* 1059587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059597 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1059600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059606 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059619 */     // GIR_Coverage, 21329,
     /* 1059619 */     GIR_EraseRootFromParent_Done,
     /* 1059620 */   // Label 15667: @1059620
     /* 1059620 */   GIM_Try, /*On fail goto*//*Label 15668*/ GIMT_Encode4(1059697), // Rule ID 21332 //
     /* 1059625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1059636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1059639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1059642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059664 */     // MIs[0] policy
     /* 1059664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059674 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1059677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059696 */     // GIR_Coverage, 21332,
     /* 1059696 */     GIR_EraseRootFromParent_Done,
     /* 1059697 */   // Label 15668: @1059697
     /* 1059697 */   GIM_Try, /*On fail goto*//*Label 15669*/ GIMT_Encode4(1059774), // Rule ID 21333 //
     /* 1059702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1059713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1059716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1059719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059741 */     // MIs[0] policy
     /* 1059741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059751 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1059754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059760 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059773 */     // GIR_Coverage, 21333,
     /* 1059773 */     GIR_EraseRootFromParent_Done,
     /* 1059774 */   // Label 15669: @1059774
     /* 1059774 */   GIM_Try, /*On fail goto*//*Label 15670*/ GIMT_Encode4(1059851), // Rule ID 21336 //
     /* 1059779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1059790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1059793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1059796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059818 */     // MIs[0] policy
     /* 1059818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059828 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1059831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059847 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059850 */     // GIR_Coverage, 21336,
     /* 1059850 */     GIR_EraseRootFromParent_Done,
     /* 1059851 */   // Label 15670: @1059851
     /* 1059851 */   GIM_Try, /*On fail goto*//*Label 15671*/ GIMT_Encode4(1059928), // Rule ID 21337 //
     /* 1059856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1059867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1059870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1059873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059895 */     // MIs[0] policy
     /* 1059895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059905 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1059908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059914 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059927 */     // GIR_Coverage, 21337,
     /* 1059927 */     GIR_EraseRootFromParent_Done,
     /* 1059928 */   // Label 15671: @1059928
     /* 1059928 */   GIM_Try, /*On fail goto*//*Label 15672*/ GIMT_Encode4(1060005), // Rule ID 21340 //
     /* 1059933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1059944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1059947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1059950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059972 */     // MIs[0] policy
     /* 1059972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059982 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1059985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060004 */     // GIR_Coverage, 21340,
     /* 1060004 */     GIR_EraseRootFromParent_Done,
     /* 1060005 */   // Label 15672: @1060005
     /* 1060005 */   GIM_Try, /*On fail goto*//*Label 15673*/ GIMT_Encode4(1060082), // Rule ID 21341 //
     /* 1060010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1060021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1060024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1060027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060049 */     // MIs[0] policy
     /* 1060049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060059 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1060062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060081 */     // GIR_Coverage, 21341,
     /* 1060081 */     GIR_EraseRootFromParent_Done,
     /* 1060082 */   // Label 15673: @1060082
     /* 1060082 */   GIM_Try, /*On fail goto*//*Label 15674*/ GIMT_Encode4(1060159), // Rule ID 21344 //
     /* 1060087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1060098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1060101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1060104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060126 */     // MIs[0] policy
     /* 1060126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060136 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1060139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060158 */     // GIR_Coverage, 21344,
     /* 1060158 */     GIR_EraseRootFromParent_Done,
     /* 1060159 */   // Label 15674: @1060159
     /* 1060159 */   GIM_Try, /*On fail goto*//*Label 15675*/ GIMT_Encode4(1060236), // Rule ID 21345 //
     /* 1060164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1060175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1060178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1060181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060203 */     // MIs[0] policy
     /* 1060203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060213 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1060216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060222 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060235 */     // GIR_Coverage, 21345,
     /* 1060235 */     GIR_EraseRootFromParent_Done,
     /* 1060236 */   // Label 15675: @1060236
     /* 1060236 */   GIM_Try, /*On fail goto*//*Label 15676*/ GIMT_Encode4(1060313), // Rule ID 21348 //
     /* 1060241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1060252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1060255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1060258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060280 */     // MIs[0] policy
     /* 1060280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060290 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1060293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060312 */     // GIR_Coverage, 21348,
     /* 1060312 */     GIR_EraseRootFromParent_Done,
     /* 1060313 */   // Label 15676: @1060313
     /* 1060313 */   GIM_Try, /*On fail goto*//*Label 15677*/ GIMT_Encode4(1060390), // Rule ID 21349 //
     /* 1060318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1060329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1060332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1060335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060357 */     // MIs[0] policy
     /* 1060357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060367 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1060370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060376 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060389 */     // GIR_Coverage, 21349,
     /* 1060389 */     GIR_EraseRootFromParent_Done,
     /* 1060390 */   // Label 15677: @1060390
     /* 1060390 */   GIM_Try, /*On fail goto*//*Label 15678*/ GIMT_Encode4(1060467), // Rule ID 21352 //
     /* 1060395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1060406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1060409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1060412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1060415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060434 */     // MIs[0] policy
     /* 1060434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060444 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1060447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060466 */     // GIR_Coverage, 21352,
     /* 1060466 */     GIR_EraseRootFromParent_Done,
     /* 1060467 */   // Label 15678: @1060467
     /* 1060467 */   GIM_Try, /*On fail goto*//*Label 15679*/ GIMT_Encode4(1060544), // Rule ID 21353 //
     /* 1060472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1060483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1060486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1060489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1060492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060511 */     // MIs[0] policy
     /* 1060511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060521 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1060524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060543 */     // GIR_Coverage, 21353,
     /* 1060543 */     GIR_EraseRootFromParent_Done,
     /* 1060544 */   // Label 15679: @1060544
     /* 1060544 */   GIM_Try, /*On fail goto*//*Label 15680*/ GIMT_Encode4(1060621), // Rule ID 21356 //
     /* 1060549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1060552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1060560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1060563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1060566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060588 */     // MIs[0] policy
     /* 1060588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060598 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1060601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060620 */     // GIR_Coverage, 21356,
     /* 1060620 */     GIR_EraseRootFromParent_Done,
     /* 1060621 */   // Label 15680: @1060621
     /* 1060621 */   GIM_Try, /*On fail goto*//*Label 15681*/ GIMT_Encode4(1060698), // Rule ID 21357 //
     /* 1060626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1060629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1060637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1060640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1060643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060665 */     // MIs[0] policy
     /* 1060665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060675 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1060678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060697 */     // GIR_Coverage, 21357,
     /* 1060697 */     GIR_EraseRootFromParent_Done,
     /* 1060698 */   // Label 15681: @1060698
     /* 1060698 */   GIM_Try, /*On fail goto*//*Label 15682*/ GIMT_Encode4(1060775), // Rule ID 21360 //
     /* 1060703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1060706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1060714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1060717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1060720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060742 */     // MIs[0] policy
     /* 1060742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060752 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1060755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060774 */     // GIR_Coverage, 21360,
     /* 1060774 */     GIR_EraseRootFromParent_Done,
     /* 1060775 */   // Label 15682: @1060775
     /* 1060775 */   GIM_Try, /*On fail goto*//*Label 15683*/ GIMT_Encode4(1060852), // Rule ID 21361 //
     /* 1060780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1060783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1060791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1060794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1060797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060819 */     // MIs[0] policy
     /* 1060819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060829 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1060832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060838 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060851 */     // GIR_Coverage, 21361,
     /* 1060851 */     GIR_EraseRootFromParent_Done,
     /* 1060852 */   // Label 15683: @1060852
     /* 1060852 */   GIM_Try, /*On fail goto*//*Label 15684*/ GIMT_Encode4(1060929), // Rule ID 21364 //
     /* 1060857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1060860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1060868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1060871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1060874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060896 */     // MIs[0] policy
     /* 1060896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060906 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1060909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060928 */     // GIR_Coverage, 21364,
     /* 1060928 */     GIR_EraseRootFromParent_Done,
     /* 1060929 */   // Label 15684: @1060929
     /* 1060929 */   GIM_Try, /*On fail goto*//*Label 15685*/ GIMT_Encode4(1061006), // Rule ID 21365 //
     /* 1060934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1060937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1060945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1060948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1060951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060973 */     // MIs[0] policy
     /* 1060973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060983 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1060986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061005 */     // GIR_Coverage, 21365,
     /* 1061005 */     GIR_EraseRootFromParent_Done,
     /* 1061006 */   // Label 15685: @1061006
     /* 1061006 */   GIM_Try, /*On fail goto*//*Label 15686*/ GIMT_Encode4(1061083), // Rule ID 21368 //
     /* 1061011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1061022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1061025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1061028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061050 */     // MIs[0] policy
     /* 1061050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061060 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1061063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061082 */     // GIR_Coverage, 21368,
     /* 1061082 */     GIR_EraseRootFromParent_Done,
     /* 1061083 */   // Label 15686: @1061083
     /* 1061083 */   GIM_Try, /*On fail goto*//*Label 15687*/ GIMT_Encode4(1061160), // Rule ID 21369 //
     /* 1061088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1061099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1061102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1061105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061127 */     // MIs[0] policy
     /* 1061127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061137 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1061140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061146 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061159 */     // GIR_Coverage, 21369,
     /* 1061159 */     GIR_EraseRootFromParent_Done,
     /* 1061160 */   // Label 15687: @1061160
     /* 1061160 */   GIM_Try, /*On fail goto*//*Label 15688*/ GIMT_Encode4(1061237), // Rule ID 21372 //
     /* 1061165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1061182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1061185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061204 */     // MIs[0] policy
     /* 1061204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061214 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1061217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061236 */     // GIR_Coverage, 21372,
     /* 1061236 */     GIR_EraseRootFromParent_Done,
     /* 1061237 */   // Label 15688: @1061237
     /* 1061237 */   GIM_Try, /*On fail goto*//*Label 15689*/ GIMT_Encode4(1061314), // Rule ID 21373 //
     /* 1061242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1061259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1061262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061281 */     // MIs[0] policy
     /* 1061281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061291 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1061294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061300 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061313 */     // GIR_Coverage, 21373,
     /* 1061313 */     GIR_EraseRootFromParent_Done,
     /* 1061314 */   // Label 15689: @1061314
     /* 1061314 */   GIM_Try, /*On fail goto*//*Label 15690*/ GIMT_Encode4(1061391), // Rule ID 21376 //
     /* 1061319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1061330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1061333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1061336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061358 */     // MIs[0] policy
     /* 1061358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061368 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1061371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061390 */     // GIR_Coverage, 21376,
     /* 1061390 */     GIR_EraseRootFromParent_Done,
     /* 1061391 */   // Label 15690: @1061391
     /* 1061391 */   GIM_Try, /*On fail goto*//*Label 15691*/ GIMT_Encode4(1061468), // Rule ID 21377 //
     /* 1061396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1061399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1061407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1061410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1061413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061435 */     // MIs[0] policy
     /* 1061435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061445 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1061448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061454 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061467 */     // GIR_Coverage, 21377,
     /* 1061467 */     GIR_EraseRootFromParent_Done,
     /* 1061468 */   // Label 15691: @1061468
     /* 1061468 */   GIM_Try, /*On fail goto*//*Label 15692*/ GIMT_Encode4(1061545), // Rule ID 21380 //
     /* 1061473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1061484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1061487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1061490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061512 */     // MIs[0] policy
     /* 1061512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061522 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1061525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061531 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061544 */     // GIR_Coverage, 21380,
     /* 1061544 */     GIR_EraseRootFromParent_Done,
     /* 1061545 */   // Label 15692: @1061545
     /* 1061545 */   GIM_Try, /*On fail goto*//*Label 15693*/ GIMT_Encode4(1061622), // Rule ID 21381 //
     /* 1061550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1061553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1061561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1061564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1061567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061589 */     // MIs[0] policy
     /* 1061589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061599 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1061602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061608 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061621 */     // GIR_Coverage, 21381,
     /* 1061621 */     GIR_EraseRootFromParent_Done,
     /* 1061622 */   // Label 15693: @1061622
     /* 1061622 */   GIM_Try, /*On fail goto*//*Label 15694*/ GIMT_Encode4(1061699), // Rule ID 21384 //
     /* 1061627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1061638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1061641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1061644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061666 */     // MIs[0] policy
     /* 1061666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061676 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1061679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061698 */     // GIR_Coverage, 21384,
     /* 1061698 */     GIR_EraseRootFromParent_Done,
     /* 1061699 */   // Label 15694: @1061699
     /* 1061699 */   GIM_Try, /*On fail goto*//*Label 15695*/ GIMT_Encode4(1061776), // Rule ID 21385 //
     /* 1061704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1061707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1061715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1061718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1061721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061743 */     // MIs[0] policy
     /* 1061743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061753 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1061756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061762 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061775 */     // GIR_Coverage, 21385,
     /* 1061775 */     GIR_EraseRootFromParent_Done,
     /* 1061776 */   // Label 15695: @1061776
     /* 1061776 */   GIM_Try, /*On fail goto*//*Label 15696*/ GIMT_Encode4(1061853), // Rule ID 21388 //
     /* 1061781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1061792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1061795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1061798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061820 */     // MIs[0] policy
     /* 1061820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061830 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1061833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061852 */     // GIR_Coverage, 21388,
     /* 1061852 */     GIR_EraseRootFromParent_Done,
     /* 1061853 */   // Label 15696: @1061853
     /* 1061853 */   GIM_Try, /*On fail goto*//*Label 15697*/ GIMT_Encode4(1061930), // Rule ID 21389 //
     /* 1061858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1061861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1061869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1061872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1061875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061897 */     // MIs[0] policy
     /* 1061897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061907 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1061910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061916 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061929 */     // GIR_Coverage, 21389,
     /* 1061929 */     GIR_EraseRootFromParent_Done,
     /* 1061930 */   // Label 15697: @1061930
     /* 1061930 */   GIM_Try, /*On fail goto*//*Label 15698*/ GIMT_Encode4(1062007), // Rule ID 21392 //
     /* 1061935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1061938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1061943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1061946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1061949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1061952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061974 */     // MIs[0] policy
     /* 1061974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061984 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1061987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062006 */     // GIR_Coverage, 21392,
     /* 1062006 */     GIR_EraseRootFromParent_Done,
     /* 1062007 */   // Label 15698: @1062007
     /* 1062007 */   GIM_Try, /*On fail goto*//*Label 15699*/ GIMT_Encode4(1062084), // Rule ID 21393 //
     /* 1062012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1062023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1062026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1062029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062051 */     // MIs[0] policy
     /* 1062051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062061 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1062064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062070 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062083 */     // GIR_Coverage, 21393,
     /* 1062083 */     GIR_EraseRootFromParent_Done,
     /* 1062084 */   // Label 15699: @1062084
     /* 1062084 */   GIM_Try, /*On fail goto*//*Label 15700*/ GIMT_Encode4(1062161), // Rule ID 21396 //
     /* 1062089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1062100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1062103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1062106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062128 */     // MIs[0] policy
     /* 1062128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062138 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1062141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062160 */     // GIR_Coverage, 21396,
     /* 1062160 */     GIR_EraseRootFromParent_Done,
     /* 1062161 */   // Label 15700: @1062161
     /* 1062161 */   GIM_Try, /*On fail goto*//*Label 15701*/ GIMT_Encode4(1062238), // Rule ID 21397 //
     /* 1062166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1062177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1062180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1062183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062205 */     // MIs[0] policy
     /* 1062205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062215 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1062218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062224 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062237 */     // GIR_Coverage, 21397,
     /* 1062237 */     GIR_EraseRootFromParent_Done,
     /* 1062238 */   // Label 15701: @1062238
     /* 1062238 */   GIM_Try, /*On fail goto*//*Label 15702*/ GIMT_Encode4(1062315), // Rule ID 21400 //
     /* 1062243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1062254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1062257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1062260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062282 */     // MIs[0] policy
     /* 1062282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062292 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1062295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062314 */     // GIR_Coverage, 21400,
     /* 1062314 */     GIR_EraseRootFromParent_Done,
     /* 1062315 */   // Label 15702: @1062315
     /* 1062315 */   GIM_Try, /*On fail goto*//*Label 15703*/ GIMT_Encode4(1062392), // Rule ID 21401 //
     /* 1062320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1062331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1062334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1062337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062359 */     // MIs[0] policy
     /* 1062359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062369 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1062372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062378 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062391 */     // GIR_Coverage, 21401,
     /* 1062391 */     GIR_EraseRootFromParent_Done,
     /* 1062392 */   // Label 15703: @1062392
     /* 1062392 */   GIM_Try, /*On fail goto*//*Label 15704*/ GIMT_Encode4(1062469), // Rule ID 21404 //
     /* 1062397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1062408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1062411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1062414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062436 */     // MIs[0] policy
     /* 1062436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062446 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1062449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062468 */     // GIR_Coverage, 21404,
     /* 1062468 */     GIR_EraseRootFromParent_Done,
     /* 1062469 */   // Label 15704: @1062469
     /* 1062469 */   GIM_Try, /*On fail goto*//*Label 15705*/ GIMT_Encode4(1062546), // Rule ID 21405 //
     /* 1062474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1062485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1062488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1062491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062513 */     // MIs[0] policy
     /* 1062513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062523 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1062526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062545 */     // GIR_Coverage, 21405,
     /* 1062545 */     GIR_EraseRootFromParent_Done,
     /* 1062546 */   // Label 15705: @1062546
     /* 1062546 */   GIM_Try, /*On fail goto*//*Label 15706*/ GIMT_Encode4(1062623), // Rule ID 21408 //
     /* 1062551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1062562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1062565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1062568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1062571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062590 */     // MIs[0] policy
     /* 1062590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062600 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1062603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062622 */     // GIR_Coverage, 21408,
     /* 1062622 */     GIR_EraseRootFromParent_Done,
     /* 1062623 */   // Label 15706: @1062623
     /* 1062623 */   GIM_Try, /*On fail goto*//*Label 15707*/ GIMT_Encode4(1062700), // Rule ID 21409 //
     /* 1062628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1062639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1062642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1062645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1062648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062667 */     // MIs[0] policy
     /* 1062667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062677 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1062680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062686 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062699 */     // GIR_Coverage, 21409,
     /* 1062699 */     GIR_EraseRootFromParent_Done,
     /* 1062700 */   // Label 15707: @1062700
     /* 1062700 */   GIM_Try, /*On fail goto*//*Label 15708*/ GIMT_Encode4(1062777), // Rule ID 21412 //
     /* 1062705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1062716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1062719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1062722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1062725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062744 */     // MIs[0] policy
     /* 1062744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062754 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1062757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062776 */     // GIR_Coverage, 21412,
     /* 1062776 */     GIR_EraseRootFromParent_Done,
     /* 1062777 */   // Label 15708: @1062777
     /* 1062777 */   GIM_Try, /*On fail goto*//*Label 15709*/ GIMT_Encode4(1062854), // Rule ID 21413 //
     /* 1062782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1062793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1062796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1062799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1062802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062821 */     // MIs[0] policy
     /* 1062821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062831 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1062834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062840 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062853 */     // GIR_Coverage, 21413,
     /* 1062853 */     GIR_EraseRootFromParent_Done,
     /* 1062854 */   // Label 15709: @1062854
     /* 1062854 */   GIM_Try, /*On fail goto*//*Label 15710*/ GIMT_Encode4(1062931), // Rule ID 21416 //
     /* 1062859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1062862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1062870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1062873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1062876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062898 */     // MIs[0] policy
     /* 1062898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062908 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1062911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062930 */     // GIR_Coverage, 21416,
     /* 1062930 */     GIR_EraseRootFromParent_Done,
     /* 1062931 */   // Label 15710: @1062931
     /* 1062931 */   GIM_Try, /*On fail goto*//*Label 15711*/ GIMT_Encode4(1063008), // Rule ID 21417 //
     /* 1062936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1062939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1062947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1062950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1062953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062975 */     // MIs[0] policy
     /* 1062975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062985 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1062988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062994 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063007 */     // GIR_Coverage, 21417,
     /* 1063007 */     GIR_EraseRootFromParent_Done,
     /* 1063008 */   // Label 15711: @1063008
     /* 1063008 */   GIM_Try, /*On fail goto*//*Label 15712*/ GIMT_Encode4(1063085), // Rule ID 21420 //
     /* 1063013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1063024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1063027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1063030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063052 */     // MIs[0] policy
     /* 1063052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063062 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1063065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063084 */     // GIR_Coverage, 21420,
     /* 1063084 */     GIR_EraseRootFromParent_Done,
     /* 1063085 */   // Label 15712: @1063085
     /* 1063085 */   GIM_Try, /*On fail goto*//*Label 15713*/ GIMT_Encode4(1063162), // Rule ID 21421 //
     /* 1063090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1063101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1063104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1063107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063129 */     // MIs[0] policy
     /* 1063129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063139 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1063142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063148 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063161 */     // GIR_Coverage, 21421,
     /* 1063161 */     GIR_EraseRootFromParent_Done,
     /* 1063162 */   // Label 15713: @1063162
     /* 1063162 */   GIM_Try, /*On fail goto*//*Label 15714*/ GIMT_Encode4(1063239), // Rule ID 21424 //
     /* 1063167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1063178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1063181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1063184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063206 */     // MIs[0] policy
     /* 1063206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063216 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1063219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063238 */     // GIR_Coverage, 21424,
     /* 1063238 */     GIR_EraseRootFromParent_Done,
     /* 1063239 */   // Label 15714: @1063239
     /* 1063239 */   GIM_Try, /*On fail goto*//*Label 15715*/ GIMT_Encode4(1063316), // Rule ID 21425 //
     /* 1063244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1063255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1063258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1063261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063283 */     // MIs[0] policy
     /* 1063283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063293 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1063296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063302 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063315 */     // GIR_Coverage, 21425,
     /* 1063315 */     GIR_EraseRootFromParent_Done,
     /* 1063316 */   // Label 15715: @1063316
     /* 1063316 */   GIM_Try, /*On fail goto*//*Label 15716*/ GIMT_Encode4(1063393), // Rule ID 21428 //
     /* 1063321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1063332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1063335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1063338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063360 */     // MIs[0] policy
     /* 1063360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063370 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1063373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063392 */     // GIR_Coverage, 21428,
     /* 1063392 */     GIR_EraseRootFromParent_Done,
     /* 1063393 */   // Label 15716: @1063393
     /* 1063393 */   GIM_Try, /*On fail goto*//*Label 15717*/ GIMT_Encode4(1063470), // Rule ID 21429 //
     /* 1063398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1063409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1063412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1063415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063437 */     // MIs[0] policy
     /* 1063437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063447 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1063450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063456 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063469 */     // GIR_Coverage, 21429,
     /* 1063469 */     GIR_EraseRootFromParent_Done,
     /* 1063470 */   // Label 15717: @1063470
     /* 1063470 */   GIM_Try, /*On fail goto*//*Label 15718*/ GIMT_Encode4(1063547), // Rule ID 21432 //
     /* 1063475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1063486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1063489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1063492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1063495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063514 */     // MIs[0] policy
     /* 1063514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063524 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1063527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063546 */     // GIR_Coverage, 21432,
     /* 1063546 */     GIR_EraseRootFromParent_Done,
     /* 1063547 */   // Label 15718: @1063547
     /* 1063547 */   GIM_Try, /*On fail goto*//*Label 15719*/ GIMT_Encode4(1063624), // Rule ID 21433 //
     /* 1063552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1063563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1063566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1063569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1063572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063591 */     // MIs[0] policy
     /* 1063591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063601 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1063604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063610 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063623 */     // GIR_Coverage, 21433,
     /* 1063623 */     GIR_EraseRootFromParent_Done,
     /* 1063624 */   // Label 15719: @1063624
     /* 1063624 */   GIM_Try, /*On fail goto*//*Label 15720*/ GIMT_Encode4(1063701), // Rule ID 21436 //
     /* 1063629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1063632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1063640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1063643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1063646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063668 */     // MIs[0] policy
     /* 1063668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063678 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1063681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063700 */     // GIR_Coverage, 21436,
     /* 1063700 */     GIR_EraseRootFromParent_Done,
     /* 1063701 */   // Label 15720: @1063701
     /* 1063701 */   GIM_Try, /*On fail goto*//*Label 15721*/ GIMT_Encode4(1063778), // Rule ID 21437 //
     /* 1063706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1063709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1063717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1063720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1063723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063745 */     // MIs[0] policy
     /* 1063745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063755 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1063758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063764 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063777 */     // GIR_Coverage, 21437,
     /* 1063777 */     GIR_EraseRootFromParent_Done,
     /* 1063778 */   // Label 15721: @1063778
     /* 1063778 */   GIM_Try, /*On fail goto*//*Label 15722*/ GIMT_Encode4(1063855), // Rule ID 21440 //
     /* 1063783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1063786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1063794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1063797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1063800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063822 */     // MIs[0] policy
     /* 1063822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063832 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1063835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063854 */     // GIR_Coverage, 21440,
     /* 1063854 */     GIR_EraseRootFromParent_Done,
     /* 1063855 */   // Label 15722: @1063855
     /* 1063855 */   GIM_Try, /*On fail goto*//*Label 15723*/ GIMT_Encode4(1063932), // Rule ID 21441 //
     /* 1063860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1063863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1063871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1063874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1063877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063899 */     // MIs[0] policy
     /* 1063899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063909 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1063912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063918 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063931 */     // GIR_Coverage, 21441,
     /* 1063931 */     GIR_EraseRootFromParent_Done,
     /* 1063932 */   // Label 15723: @1063932
     /* 1063932 */   GIM_Try, /*On fail goto*//*Label 15724*/ GIMT_Encode4(1064009), // Rule ID 21444 //
     /* 1063937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1063940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1063948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1063951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1063954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063976 */     // MIs[0] policy
     /* 1063976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063986 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1063989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064008 */     // GIR_Coverage, 21444,
     /* 1064008 */     GIR_EraseRootFromParent_Done,
     /* 1064009 */   // Label 15724: @1064009
     /* 1064009 */   GIM_Try, /*On fail goto*//*Label 15725*/ GIMT_Encode4(1064086), // Rule ID 21445 //
     /* 1064014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1064017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1064025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1064028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1064031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064053 */     // MIs[0] policy
     /* 1064053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064063 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1064066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064072 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064085 */     // GIR_Coverage, 21445,
     /* 1064085 */     GIR_EraseRootFromParent_Done,
     /* 1064086 */   // Label 15725: @1064086
     /* 1064086 */   GIM_Try, /*On fail goto*//*Label 15726*/ GIMT_Encode4(1064163), // Rule ID 21448 //
     /* 1064091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1064094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1064102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1064105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1064108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064130 */     // MIs[0] policy
     /* 1064130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064140 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1064143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064159 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064162 */     // GIR_Coverage, 21448,
     /* 1064162 */     GIR_EraseRootFromParent_Done,
     /* 1064163 */   // Label 15726: @1064163
     /* 1064163 */   GIM_Try, /*On fail goto*//*Label 15727*/ GIMT_Encode4(1064240), // Rule ID 21449 //
     /* 1064168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1064171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1064179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1064182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1064185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064207 */     // MIs[0] policy
     /* 1064207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064217 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1064220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064226 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064239 */     // GIR_Coverage, 21449,
     /* 1064239 */     GIR_EraseRootFromParent_Done,
     /* 1064240 */   // Label 15727: @1064240
     /* 1064240 */   GIM_Try, /*On fail goto*//*Label 15728*/ GIMT_Encode4(1064317), // Rule ID 21452 //
     /* 1064245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1064256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1064259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1064262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064284 */     // MIs[0] policy
     /* 1064284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064294 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1064297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064316 */     // GIR_Coverage, 21452,
     /* 1064316 */     GIR_EraseRootFromParent_Done,
     /* 1064317 */   // Label 15728: @1064317
     /* 1064317 */   GIM_Try, /*On fail goto*//*Label 15729*/ GIMT_Encode4(1064394), // Rule ID 21453 //
     /* 1064322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1064333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1064336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1064339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064361 */     // MIs[0] policy
     /* 1064361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064371 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1064374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064393 */     // GIR_Coverage, 21453,
     /* 1064393 */     GIR_EraseRootFromParent_Done,
     /* 1064394 */   // Label 15729: @1064394
     /* 1064394 */   GIM_Try, /*On fail goto*//*Label 15730*/ GIMT_Encode4(1064471), // Rule ID 21456 //
     /* 1064399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1064410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1064413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1064416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064438 */     // MIs[0] policy
     /* 1064438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064448 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1064451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064470 */     // GIR_Coverage, 21456,
     /* 1064470 */     GIR_EraseRootFromParent_Done,
     /* 1064471 */   // Label 15730: @1064471
     /* 1064471 */   GIM_Try, /*On fail goto*//*Label 15731*/ GIMT_Encode4(1064548), // Rule ID 21457 //
     /* 1064476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1064487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1064490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1064493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064515 */     // MIs[0] policy
     /* 1064515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064525 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1064528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064534 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064547 */     // GIR_Coverage, 21457,
     /* 1064547 */     GIR_EraseRootFromParent_Done,
     /* 1064548 */   // Label 15731: @1064548
     /* 1064548 */   GIM_Try, /*On fail goto*//*Label 15732*/ GIMT_Encode4(1064625), // Rule ID 21460 //
     /* 1064553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1064564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1064567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1064570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064592 */     // MIs[0] policy
     /* 1064592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064602 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1064605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064624 */     // GIR_Coverage, 21460,
     /* 1064624 */     GIR_EraseRootFromParent_Done,
     /* 1064625 */   // Label 15732: @1064625
     /* 1064625 */   GIM_Try, /*On fail goto*//*Label 15733*/ GIMT_Encode4(1064702), // Rule ID 21461 //
     /* 1064630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1064641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1064644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1064647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064669 */     // MIs[0] policy
     /* 1064669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064679 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1064682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064688 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064701 */     // GIR_Coverage, 21461,
     /* 1064701 */     GIR_EraseRootFromParent_Done,
     /* 1064702 */   // Label 15733: @1064702
     /* 1064702 */   GIM_Try, /*On fail goto*//*Label 15734*/ GIMT_Encode4(1064779), // Rule ID 21464 //
     /* 1064707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1064718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1064721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1064724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064746 */     // MIs[0] policy
     /* 1064746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064756 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1064759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064778 */     // GIR_Coverage, 21464,
     /* 1064778 */     GIR_EraseRootFromParent_Done,
     /* 1064779 */   // Label 15734: @1064779
     /* 1064779 */   GIM_Try, /*On fail goto*//*Label 15735*/ GIMT_Encode4(1064856), // Rule ID 21465 //
     /* 1064784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1064795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1064798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1064801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064823 */     // MIs[0] policy
     /* 1064823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064833 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1064836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064842 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064855 */     // GIR_Coverage, 21465,
     /* 1064855 */     GIR_EraseRootFromParent_Done,
     /* 1064856 */   // Label 15735: @1064856
     /* 1064856 */   GIM_Try, /*On fail goto*//*Label 15736*/ GIMT_Encode4(1064933), // Rule ID 21468 //
     /* 1064861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1064872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1064875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1064878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1064881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064900 */     // MIs[0] policy
     /* 1064900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064910 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1064913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064932 */     // GIR_Coverage, 21468,
     /* 1064932 */     GIR_EraseRootFromParent_Done,
     /* 1064933 */   // Label 15736: @1064933
     /* 1064933 */   GIM_Try, /*On fail goto*//*Label 15737*/ GIMT_Encode4(1065010), // Rule ID 21469 //
     /* 1064938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1064949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1064952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1064955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1064958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064977 */     // MIs[0] policy
     /* 1064977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064987 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1064990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064996 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065009 */     // GIR_Coverage, 21469,
     /* 1065009 */     GIR_EraseRootFromParent_Done,
     /* 1065010 */   // Label 15737: @1065010
     /* 1065010 */   GIM_Try, /*On fail goto*//*Label 15738*/ GIMT_Encode4(1065087), // Rule ID 21472 //
     /* 1065015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1065026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1065029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1065032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065054 */     // MIs[0] policy
     /* 1065054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065064 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1065067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065086 */     // GIR_Coverage, 21472,
     /* 1065086 */     GIR_EraseRootFromParent_Done,
     /* 1065087 */   // Label 15738: @1065087
     /* 1065087 */   GIM_Try, /*On fail goto*//*Label 15739*/ GIMT_Encode4(1065164), // Rule ID 21473 //
     /* 1065092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1065103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1065106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1065109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065131 */     // MIs[0] policy
     /* 1065131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065141 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1065144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065150 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065163 */     // GIR_Coverage, 21473,
     /* 1065163 */     GIR_EraseRootFromParent_Done,
     /* 1065164 */   // Label 15739: @1065164
     /* 1065164 */   GIM_Try, /*On fail goto*//*Label 15740*/ GIMT_Encode4(1065241), // Rule ID 21476 //
     /* 1065169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1065186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065208 */     // MIs[0] policy
     /* 1065208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065218 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1065221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065240 */     // GIR_Coverage, 21476,
     /* 1065240 */     GIR_EraseRootFromParent_Done,
     /* 1065241 */   // Label 15740: @1065241
     /* 1065241 */   GIM_Try, /*On fail goto*//*Label 15741*/ GIMT_Encode4(1065318), // Rule ID 21477 //
     /* 1065246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1065263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065285 */     // MIs[0] policy
     /* 1065285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065295 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1065298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065304 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065317 */     // GIR_Coverage, 21477,
     /* 1065317 */     GIR_EraseRootFromParent_Done,
     /* 1065318 */   // Label 15741: @1065318
     /* 1065318 */   GIM_Try, /*On fail goto*//*Label 15742*/ GIMT_Encode4(1065395), // Rule ID 21480 //
     /* 1065323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1065340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065362 */     // MIs[0] policy
     /* 1065362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065372 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1065375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065394 */     // GIR_Coverage, 21480,
     /* 1065394 */     GIR_EraseRootFromParent_Done,
     /* 1065395 */   // Label 15742: @1065395
     /* 1065395 */   GIM_Try, /*On fail goto*//*Label 15743*/ GIMT_Encode4(1065472), // Rule ID 21481 //
     /* 1065400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1065417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065439 */     // MIs[0] policy
     /* 1065439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065449 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1065452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065458 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065471 */     // GIR_Coverage, 21481,
     /* 1065471 */     GIR_EraseRootFromParent_Done,
     /* 1065472 */   // Label 15743: @1065472
     /* 1065472 */   GIM_Try, /*On fail goto*//*Label 15744*/ GIMT_Encode4(1065549), // Rule ID 21484 //
     /* 1065477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1065488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1065491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1065494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065516 */     // MIs[0] policy
     /* 1065516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065526 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1065529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065548 */     // GIR_Coverage, 21484,
     /* 1065548 */     GIR_EraseRootFromParent_Done,
     /* 1065549 */   // Label 15744: @1065549
     /* 1065549 */   GIM_Try, /*On fail goto*//*Label 15745*/ GIMT_Encode4(1065626), // Rule ID 21485 //
     /* 1065554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1065565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1065568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1065571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065593 */     // MIs[0] policy
     /* 1065593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065603 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1065606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065612 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065625 */     // GIR_Coverage, 21485,
     /* 1065625 */     GIR_EraseRootFromParent_Done,
     /* 1065626 */   // Label 15745: @1065626
     /* 1065626 */   GIM_Try, /*On fail goto*//*Label 15746*/ GIMT_Encode4(1065703), // Rule ID 21728 //
     /* 1065631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1065642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1065645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1065648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065670 */     // MIs[0] policy
     /* 1065670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065680 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1065683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065702 */     // GIR_Coverage, 21728,
     /* 1065702 */     GIR_EraseRootFromParent_Done,
     /* 1065703 */   // Label 15746: @1065703
     /* 1065703 */   GIM_Try, /*On fail goto*//*Label 15747*/ GIMT_Encode4(1065780), // Rule ID 21729 //
     /* 1065708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1065711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1065719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1065722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1065725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065747 */     // MIs[0] policy
     /* 1065747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065757 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1065760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065766 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065779 */     // GIR_Coverage, 21729,
     /* 1065779 */     GIR_EraseRootFromParent_Done,
     /* 1065780 */   // Label 15747: @1065780
     /* 1065780 */   GIM_Try, /*On fail goto*//*Label 15748*/ GIMT_Encode4(1065857), // Rule ID 21732 //
     /* 1065785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1065796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1065799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1065802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065824 */     // MIs[0] policy
     /* 1065824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065834 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1065837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065856 */     // GIR_Coverage, 21732,
     /* 1065856 */     GIR_EraseRootFromParent_Done,
     /* 1065857 */   // Label 15748: @1065857
     /* 1065857 */   GIM_Try, /*On fail goto*//*Label 15749*/ GIMT_Encode4(1065934), // Rule ID 21733 //
     /* 1065862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1065865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1065873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1065876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1065879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065901 */     // MIs[0] policy
     /* 1065901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065911 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1065914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065920 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065933 */     // GIR_Coverage, 21733,
     /* 1065933 */     GIR_EraseRootFromParent_Done,
     /* 1065934 */   // Label 15749: @1065934
     /* 1065934 */   GIM_Try, /*On fail goto*//*Label 15750*/ GIMT_Encode4(1066011), // Rule ID 21736 //
     /* 1065939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1065950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1065953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1065956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065978 */     // MIs[0] policy
     /* 1065978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065988 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1065991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066010 */     // GIR_Coverage, 21736,
     /* 1066010 */     GIR_EraseRootFromParent_Done,
     /* 1066011 */   // Label 15750: @1066011
     /* 1066011 */   GIM_Try, /*On fail goto*//*Label 15751*/ GIMT_Encode4(1066088), // Rule ID 21737 //
     /* 1066016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1066027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1066030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1066033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066055 */     // MIs[0] policy
     /* 1066055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066065 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066074 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066087 */     // GIR_Coverage, 21737,
     /* 1066087 */     GIR_EraseRootFromParent_Done,
     /* 1066088 */   // Label 15751: @1066088
     /* 1066088 */   GIM_Try, /*On fail goto*//*Label 15752*/ GIMT_Encode4(1066165), // Rule ID 21740 //
     /* 1066093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1066104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1066107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1066110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066132 */     // MIs[0] policy
     /* 1066132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066142 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11248:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066164 */     // GIR_Coverage, 21740,
     /* 1066164 */     GIR_EraseRootFromParent_Done,
     /* 1066165 */   // Label 15752: @1066165
     /* 1066165 */   GIM_Try, /*On fail goto*//*Label 15753*/ GIMT_Encode4(1066242), // Rule ID 21741 //
     /* 1066170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1066181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1066184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1066187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066209 */     // MIs[0] policy
     /* 1066209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066219 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11248:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066228 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066241 */     // GIR_Coverage, 21741,
     /* 1066241 */     GIR_EraseRootFromParent_Done,
     /* 1066242 */   // Label 15753: @1066242
     /* 1066242 */   GIM_Try, /*On fail goto*//*Label 15754*/ GIMT_Encode4(1066319), // Rule ID 21744 //
     /* 1066247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1066258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1066261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1066264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066286 */     // MIs[0] policy
     /* 1066286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066296 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1066299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066318 */     // GIR_Coverage, 21744,
     /* 1066318 */     GIR_EraseRootFromParent_Done,
     /* 1066319 */   // Label 15754: @1066319
     /* 1066319 */   GIM_Try, /*On fail goto*//*Label 15755*/ GIMT_Encode4(1066396), // Rule ID 21745 //
     /* 1066324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1066335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1066338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1066341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066363 */     // MIs[0] policy
     /* 1066363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066373 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1066376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066382 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066395 */     // GIR_Coverage, 21745,
     /* 1066395 */     GIR_EraseRootFromParent_Done,
     /* 1066396 */   // Label 15755: @1066396
     /* 1066396 */   GIM_Try, /*On fail goto*//*Label 15756*/ GIMT_Encode4(1066473), // Rule ID 21748 //
     /* 1066401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1066412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1066415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1066418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1066421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066440 */     // MIs[0] policy
     /* 1066440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066450 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1066453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066472 */     // GIR_Coverage, 21748,
     /* 1066472 */     GIR_EraseRootFromParent_Done,
     /* 1066473 */   // Label 15756: @1066473
     /* 1066473 */   GIM_Try, /*On fail goto*//*Label 15757*/ GIMT_Encode4(1066550), // Rule ID 21749 //
     /* 1066478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1066489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1066492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1066495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1066498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066517 */     // MIs[0] policy
     /* 1066517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066527 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1066530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066549 */     // GIR_Coverage, 21749,
     /* 1066549 */     GIR_EraseRootFromParent_Done,
     /* 1066550 */   // Label 15757: @1066550
     /* 1066550 */   GIM_Try, /*On fail goto*//*Label 15758*/ GIMT_Encode4(1066627), // Rule ID 21752 //
     /* 1066555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1066566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1066569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1066572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066594 */     // MIs[0] policy
     /* 1066594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066604 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1066607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066626 */     // GIR_Coverage, 21752,
     /* 1066626 */     GIR_EraseRootFromParent_Done,
     /* 1066627 */   // Label 15758: @1066627
     /* 1066627 */   GIM_Try, /*On fail goto*//*Label 15759*/ GIMT_Encode4(1066704), // Rule ID 21753 //
     /* 1066632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1066643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1066646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1066649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066671 */     // MIs[0] policy
     /* 1066671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066681 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1066684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066690 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066703 */     // GIR_Coverage, 21753,
     /* 1066703 */     GIR_EraseRootFromParent_Done,
     /* 1066704 */   // Label 15759: @1066704
     /* 1066704 */   GIM_Try, /*On fail goto*//*Label 15760*/ GIMT_Encode4(1066781), // Rule ID 21756 //
     /* 1066709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1066720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1066723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1066726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066748 */     // MIs[0] policy
     /* 1066748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066758 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066777 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066780 */     // GIR_Coverage, 21756,
     /* 1066780 */     GIR_EraseRootFromParent_Done,
     /* 1066781 */   // Label 15760: @1066781
     /* 1066781 */   GIM_Try, /*On fail goto*//*Label 15761*/ GIMT_Encode4(1066858), // Rule ID 21757 //
     /* 1066786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1066797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1066800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1066803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066825 */     // MIs[0] policy
     /* 1066825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066835 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066857 */     // GIR_Coverage, 21757,
     /* 1066857 */     GIR_EraseRootFromParent_Done,
     /* 1066858 */   // Label 15761: @1066858
     /* 1066858 */   GIM_Try, /*On fail goto*//*Label 15762*/ GIMT_Encode4(1066935), // Rule ID 21760 //
     /* 1066863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1066874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1066877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1066880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066902 */     // MIs[0] policy
     /* 1066902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066912 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066934 */     // GIR_Coverage, 21760,
     /* 1066934 */     GIR_EraseRootFromParent_Done,
     /* 1066935 */   // Label 15762: @1066935
     /* 1066935 */   GIM_Try, /*On fail goto*//*Label 15763*/ GIMT_Encode4(1067012), // Rule ID 21761 //
     /* 1066940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1066951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1066954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1066957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066979 */     // MIs[0] policy
     /* 1066979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066989 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066998 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067011 */     // GIR_Coverage, 21761,
     /* 1067011 */     GIR_EraseRootFromParent_Done,
     /* 1067012 */   // Label 15763: @1067012
     /* 1067012 */   GIM_Try, /*On fail goto*//*Label 15764*/ GIMT_Encode4(1067089), // Rule ID 21764 //
     /* 1067017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1067028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1067031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1067034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067056 */     // MIs[0] policy
     /* 1067056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067066 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067088 */     // GIR_Coverage, 21764,
     /* 1067088 */     GIR_EraseRootFromParent_Done,
     /* 1067089 */   // Label 15764: @1067089
     /* 1067089 */   GIM_Try, /*On fail goto*//*Label 15765*/ GIMT_Encode4(1067166), // Rule ID 21765 //
     /* 1067094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1067105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1067108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1067111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067133 */     // MIs[0] policy
     /* 1067133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067152 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067165 */     // GIR_Coverage, 21765,
     /* 1067165 */     GIR_EraseRootFromParent_Done,
     /* 1067166 */   // Label 15765: @1067166
     /* 1067166 */   GIM_Try, /*On fail goto*//*Label 15766*/ GIMT_Encode4(1067243), // Rule ID 21768 //
     /* 1067171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1067182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1067185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1067188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1067191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067210 */     // MIs[0] policy
     /* 1067210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067220 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067239 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067242 */     // GIR_Coverage, 21768,
     /* 1067242 */     GIR_EraseRootFromParent_Done,
     /* 1067243 */   // Label 15766: @1067243
     /* 1067243 */   GIM_Try, /*On fail goto*//*Label 15767*/ GIMT_Encode4(1067320), // Rule ID 21769 //
     /* 1067248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1067259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1067262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1067265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1067268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067287 */     // MIs[0] policy
     /* 1067287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067297 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067306 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067319 */     // GIR_Coverage, 21769,
     /* 1067319 */     GIR_EraseRootFromParent_Done,
     /* 1067320 */   // Label 15767: @1067320
     /* 1067320 */   GIM_Try, /*On fail goto*//*Label 15768*/ GIMT_Encode4(1067397), // Rule ID 21772 //
     /* 1067325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1067336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1067339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1067342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067364 */     // MIs[0] policy
     /* 1067364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067374 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1067377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067396 */     // GIR_Coverage, 21772,
     /* 1067396 */     GIR_EraseRootFromParent_Done,
     /* 1067397 */   // Label 15768: @1067397
     /* 1067397 */   GIM_Try, /*On fail goto*//*Label 15769*/ GIMT_Encode4(1067474), // Rule ID 21773 //
     /* 1067402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1067413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1067416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1067419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067441 */     // MIs[0] policy
     /* 1067441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067451 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1067454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067473 */     // GIR_Coverage, 21773,
     /* 1067473 */     GIR_EraseRootFromParent_Done,
     /* 1067474 */   // Label 15769: @1067474
     /* 1067474 */   GIM_Try, /*On fail goto*//*Label 15770*/ GIMT_Encode4(1067551), // Rule ID 21776 //
     /* 1067479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1067490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1067493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1067496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067518 */     // MIs[0] policy
     /* 1067518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1067531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067550 */     // GIR_Coverage, 21776,
     /* 1067550 */     GIR_EraseRootFromParent_Done,
     /* 1067551 */   // Label 15770: @1067551
     /* 1067551 */   GIM_Try, /*On fail goto*//*Label 15771*/ GIMT_Encode4(1067628), // Rule ID 21777 //
     /* 1067556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1067567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1067570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1067573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067595 */     // MIs[0] policy
     /* 1067595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067605 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1067608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067614 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067627 */     // GIR_Coverage, 21777,
     /* 1067627 */     GIR_EraseRootFromParent_Done,
     /* 1067628 */   // Label 15771: @1067628
     /* 1067628 */   GIM_Try, /*On fail goto*//*Label 15772*/ GIMT_Encode4(1067705), // Rule ID 21780 //
     /* 1067633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1067644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1067647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1067650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067672 */     // MIs[0] policy
     /* 1067672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067691 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067704 */     // GIR_Coverage, 21780,
     /* 1067704 */     GIR_EraseRootFromParent_Done,
     /* 1067705 */   // Label 15772: @1067705
     /* 1067705 */   GIM_Try, /*On fail goto*//*Label 15773*/ GIMT_Encode4(1067782), // Rule ID 21781 //
     /* 1067710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1067721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1067724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1067727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067749 */     // MIs[0] policy
     /* 1067749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067768 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067781 */     // GIR_Coverage, 21781,
     /* 1067781 */     GIR_EraseRootFromParent_Done,
     /* 1067782 */   // Label 15773: @1067782
     /* 1067782 */   GIM_Try, /*On fail goto*//*Label 15774*/ GIMT_Encode4(1067859), // Rule ID 21784 //
     /* 1067787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1067798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1067801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1067804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067826 */     // MIs[0] policy
     /* 1067826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067858 */     // GIR_Coverage, 21784,
     /* 1067858 */     GIR_EraseRootFromParent_Done,
     /* 1067859 */   // Label 15774: @1067859
     /* 1067859 */   GIM_Try, /*On fail goto*//*Label 15775*/ GIMT_Encode4(1067936), // Rule ID 21785 //
     /* 1067864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1067875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1067878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1067881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067903 */     // MIs[0] policy
     /* 1067903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067913 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067922 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067935 */     // GIR_Coverage, 21785,
     /* 1067935 */     GIR_EraseRootFromParent_Done,
     /* 1067936 */   // Label 15775: @1067936
     /* 1067936 */   GIM_Try, /*On fail goto*//*Label 15776*/ GIMT_Encode4(1068013), // Rule ID 21788 //
     /* 1067941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1067944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1067949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1067952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1067955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1067958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067980 */     // MIs[0] policy
     /* 1067980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067990 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1067993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068012 */     // GIR_Coverage, 21788,
     /* 1068012 */     GIR_EraseRootFromParent_Done,
     /* 1068013 */   // Label 15776: @1068013
     /* 1068013 */   GIM_Try, /*On fail goto*//*Label 15777*/ GIMT_Encode4(1068090), // Rule ID 21789 //
     /* 1068018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1068029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1068032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1068035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068057 */     // MIs[0] policy
     /* 1068057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068067 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1068070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068076 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068089 */     // GIR_Coverage, 21789,
     /* 1068089 */     GIR_EraseRootFromParent_Done,
     /* 1068090 */   // Label 15777: @1068090
     /* 1068090 */   GIM_Try, /*On fail goto*//*Label 15778*/ GIMT_Encode4(1068167), // Rule ID 21792 //
     /* 1068095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1068106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1068109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1068112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068134 */     // MIs[0] policy
     /* 1068134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068144 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068166 */     // GIR_Coverage, 21792,
     /* 1068166 */     GIR_EraseRootFromParent_Done,
     /* 1068167 */   // Label 15778: @1068167
     /* 1068167 */   GIM_Try, /*On fail goto*//*Label 15779*/ GIMT_Encode4(1068244), // Rule ID 21793 //
     /* 1068172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1068183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1068186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1068189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068211 */     // MIs[0] policy
     /* 1068211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068221 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068230 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068243 */     // GIR_Coverage, 21793,
     /* 1068243 */     GIR_EraseRootFromParent_Done,
     /* 1068244 */   // Label 15779: @1068244
     /* 1068244 */   GIM_Try, /*On fail goto*//*Label 15780*/ GIMT_Encode4(1068321), // Rule ID 21796 //
     /* 1068249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1068260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1068263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1068266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068288 */     // MIs[0] policy
     /* 1068288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068298 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1068301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068320 */     // GIR_Coverage, 21796,
     /* 1068320 */     GIR_EraseRootFromParent_Done,
     /* 1068321 */   // Label 15780: @1068321
     /* 1068321 */   GIM_Try, /*On fail goto*//*Label 15781*/ GIMT_Encode4(1068398), // Rule ID 21797 //
     /* 1068326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1068337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1068340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1068343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068365 */     // MIs[0] policy
     /* 1068365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068375 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1068378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068384 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068397 */     // GIR_Coverage, 21797,
     /* 1068397 */     GIR_EraseRootFromParent_Done,
     /* 1068398 */   // Label 15781: @1068398
     /* 1068398 */   GIM_Try, /*On fail goto*//*Label 15782*/ GIMT_Encode4(1068475), // Rule ID 21800 //
     /* 1068403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1068414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1068417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1068420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068442 */     // MIs[0] policy
     /* 1068442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11246:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1068455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068474 */     // GIR_Coverage, 21800,
     /* 1068474 */     GIR_EraseRootFromParent_Done,
     /* 1068475 */   // Label 15782: @1068475
     /* 1068475 */   GIM_Try, /*On fail goto*//*Label 15783*/ GIMT_Encode4(1068552), // Rule ID 21801 //
     /* 1068480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1068491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1068494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1068497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068519 */     // MIs[0] policy
     /* 1068519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068529 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11246:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1068532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068538 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068551 */     // GIR_Coverage, 21801,
     /* 1068551 */     GIR_EraseRootFromParent_Done,
     /* 1068552 */   // Label 15783: @1068552
     /* 1068552 */   GIM_Try, /*On fail goto*//*Label 15784*/ GIMT_Encode4(1068629), // Rule ID 21804 //
     /* 1068557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1068568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1068571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1068574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1068577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068596 */     // MIs[0] policy
     /* 1068596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068606 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1068609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068628 */     // GIR_Coverage, 21804,
     /* 1068628 */     GIR_EraseRootFromParent_Done,
     /* 1068629 */   // Label 15784: @1068629
     /* 1068629 */   GIM_Try, /*On fail goto*//*Label 15785*/ GIMT_Encode4(1068706), // Rule ID 21805 //
     /* 1068634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1068645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1068648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1068651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1068654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068673 */     // MIs[0] policy
     /* 1068673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068683 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1068686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068692 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068705 */     // GIR_Coverage, 21805,
     /* 1068705 */     GIR_EraseRootFromParent_Done,
     /* 1068706 */   // Label 15785: @1068706
     /* 1068706 */   GIM_Try, /*On fail goto*//*Label 15786*/ GIMT_Encode4(1068783), // Rule ID 21808 //
     /* 1068711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1068722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1068725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1068728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1068731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068750 */     // MIs[0] policy
     /* 1068750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068760 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1068763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068782 */     // GIR_Coverage, 21808,
     /* 1068782 */     GIR_EraseRootFromParent_Done,
     /* 1068783 */   // Label 15786: @1068783
     /* 1068783 */   GIM_Try, /*On fail goto*//*Label 15787*/ GIMT_Encode4(1068860), // Rule ID 21809 //
     /* 1068788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1068799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1068802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1068805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1068808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068827 */     // MIs[0] policy
     /* 1068827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068837 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1068840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068846 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068859 */     // GIR_Coverage, 21809,
     /* 1068859 */     GIR_EraseRootFromParent_Done,
     /* 1068860 */   // Label 15787: @1068860
     /* 1068860 */   GIM_Try, /*On fail goto*//*Label 15788*/ GIMT_Encode4(1068937), // Rule ID 21812 //
     /* 1068865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1068868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1068876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1068879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1068882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068904 */     // MIs[0] policy
     /* 1068904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068914 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068936 */     // GIR_Coverage, 21812,
     /* 1068936 */     GIR_EraseRootFromParent_Done,
     /* 1068937 */   // Label 15788: @1068937
     /* 1068937 */   GIM_Try, /*On fail goto*//*Label 15789*/ GIMT_Encode4(1069014), // Rule ID 21813 //
     /* 1068942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1068945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1068953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1068956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1068959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068981 */     // MIs[0] policy
     /* 1068981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068991 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069000 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069013 */     // GIR_Coverage, 21813,
     /* 1069013 */     GIR_EraseRootFromParent_Done,
     /* 1069014 */   // Label 15789: @1069014
     /* 1069014 */   GIM_Try, /*On fail goto*//*Label 15790*/ GIMT_Encode4(1069091), // Rule ID 21816 //
     /* 1069019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1069030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1069033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069058 */     // MIs[0] policy
     /* 1069058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069068 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069090 */     // GIR_Coverage, 21816,
     /* 1069090 */     GIR_EraseRootFromParent_Done,
     /* 1069091 */   // Label 15790: @1069091
     /* 1069091 */   GIM_Try, /*On fail goto*//*Label 15791*/ GIMT_Encode4(1069168), // Rule ID 21817 //
     /* 1069096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1069107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1069110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069135 */     // MIs[0] policy
     /* 1069135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069145 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069154 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069167 */     // GIR_Coverage, 21817,
     /* 1069167 */     GIR_EraseRootFromParent_Done,
     /* 1069168 */   // Label 15791: @1069168
     /* 1069168 */   GIM_Try, /*On fail goto*//*Label 15792*/ GIMT_Encode4(1069245), // Rule ID 21820 //
     /* 1069173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1069184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1069187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1069190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069212 */     // MIs[0] policy
     /* 1069212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069222 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069244 */     // GIR_Coverage, 21820,
     /* 1069244 */     GIR_EraseRootFromParent_Done,
     /* 1069245 */   // Label 15792: @1069245
     /* 1069245 */   GIM_Try, /*On fail goto*//*Label 15793*/ GIMT_Encode4(1069322), // Rule ID 21821 //
     /* 1069250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1069261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1069264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1069267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069289 */     // MIs[0] policy
     /* 1069289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069299 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069321 */     // GIR_Coverage, 21821,
     /* 1069321 */     GIR_EraseRootFromParent_Done,
     /* 1069322 */   // Label 15793: @1069322
     /* 1069322 */   GIM_Try, /*On fail goto*//*Label 15794*/ GIMT_Encode4(1069399), // Rule ID 21824 //
     /* 1069327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1069338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1069341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1069344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069366 */     // MIs[0] policy
     /* 1069366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069376 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069398 */     // GIR_Coverage, 21824,
     /* 1069398 */     GIR_EraseRootFromParent_Done,
     /* 1069399 */   // Label 15794: @1069399
     /* 1069399 */   GIM_Try, /*On fail goto*//*Label 15795*/ GIMT_Encode4(1069476), // Rule ID 21825 //
     /* 1069404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1069415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1069418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1069421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069443 */     // MIs[0] policy
     /* 1069443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069453 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069462 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069475 */     // GIR_Coverage, 21825,
     /* 1069475 */     GIR_EraseRootFromParent_Done,
     /* 1069476 */   // Label 15795: @1069476
     /* 1069476 */   GIM_Try, /*On fail goto*//*Label 15796*/ GIMT_Encode4(1069553), // Rule ID 21828 //
     /* 1069481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1069492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1069495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1069498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1069501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069520 */     // MIs[0] policy
     /* 1069520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069530 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069552 */     // GIR_Coverage, 21828,
     /* 1069552 */     GIR_EraseRootFromParent_Done,
     /* 1069553 */   // Label 15796: @1069553
     /* 1069553 */   GIM_Try, /*On fail goto*//*Label 15797*/ GIMT_Encode4(1069630), // Rule ID 21829 //
     /* 1069558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1069569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1069572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1069575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1069578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069597 */     // MIs[0] policy
     /* 1069597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069607 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069616 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069629 */     // GIR_Coverage, 21829,
     /* 1069629 */     GIR_EraseRootFromParent_Done,
     /* 1069630 */   // Label 15797: @1069630
     /* 1069630 */   GIM_Try, /*On fail goto*//*Label 15798*/ GIMT_Encode4(1069707), // Rule ID 21832 //
     /* 1069635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1069638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1069646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1069649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1069652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069674 */     // MIs[0] policy
     /* 1069674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069706 */     // GIR_Coverage, 21832,
     /* 1069706 */     GIR_EraseRootFromParent_Done,
     /* 1069707 */   // Label 15798: @1069707
     /* 1069707 */   GIM_Try, /*On fail goto*//*Label 15799*/ GIMT_Encode4(1069784), // Rule ID 21833 //
     /* 1069712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1069715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1069723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1069726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1069729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069751 */     // MIs[0] policy
     /* 1069751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069761 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069770 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069783 */     // GIR_Coverage, 21833,
     /* 1069783 */     GIR_EraseRootFromParent_Done,
     /* 1069784 */   // Label 15799: @1069784
     /* 1069784 */   GIM_Try, /*On fail goto*//*Label 15800*/ GIMT_Encode4(1069861), // Rule ID 21836 //
     /* 1069789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1069792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1069800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1069803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1069806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069828 */     // MIs[0] policy
     /* 1069828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069860 */     // GIR_Coverage, 21836,
     /* 1069860 */     GIR_EraseRootFromParent_Done,
     /* 1069861 */   // Label 15800: @1069861
     /* 1069861 */   GIM_Try, /*On fail goto*//*Label 15801*/ GIMT_Encode4(1069938), // Rule ID 21837 //
     /* 1069866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1069869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1069877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1069880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1069883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069905 */     // MIs[0] policy
     /* 1069905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069915 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069924 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069937 */     // GIR_Coverage, 21837,
     /* 1069937 */     GIR_EraseRootFromParent_Done,
     /* 1069938 */   // Label 15801: @1069938
     /* 1069938 */   GIM_Try, /*On fail goto*//*Label 15802*/ GIMT_Encode4(1070015), // Rule ID 21840 //
     /* 1069943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1069946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1069954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1069957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1069960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069982 */     // MIs[0] policy
     /* 1069982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070014 */     // GIR_Coverage, 21840,
     /* 1070014 */     GIR_EraseRootFromParent_Done,
     /* 1070015 */   // Label 15802: @1070015
     /* 1070015 */   GIM_Try, /*On fail goto*//*Label 15803*/ GIMT_Encode4(1070092), // Rule ID 21841 //
     /* 1070020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1070023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1070031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1070034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1070037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070059 */     // MIs[0] policy
     /* 1070059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070069 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1070072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070078 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070091 */     // GIR_Coverage, 21841,
     /* 1070091 */     GIR_EraseRootFromParent_Done,
     /* 1070092 */   // Label 15803: @1070092
     /* 1070092 */   GIM_Try, /*On fail goto*//*Label 15804*/ GIMT_Encode4(1070169), // Rule ID 21844 //
     /* 1070097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1070100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1070108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1070111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1070114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070136 */     // MIs[0] policy
     /* 1070136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1070149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070155 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070168 */     // GIR_Coverage, 21844,
     /* 1070168 */     GIR_EraseRootFromParent_Done,
     /* 1070169 */   // Label 15804: @1070169
     /* 1070169 */   GIM_Try, /*On fail goto*//*Label 15805*/ GIMT_Encode4(1070246), // Rule ID 21845 //
     /* 1070174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1070177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1070185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1070188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1070191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070213 */     // MIs[0] policy
     /* 1070213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070223 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1070226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070232 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070245 */     // GIR_Coverage, 21845,
     /* 1070245 */     GIR_EraseRootFromParent_Done,
     /* 1070246 */   // Label 15805: @1070246
     /* 1070246 */   GIM_Try, /*On fail goto*//*Label 15806*/ GIMT_Encode4(1070323), // Rule ID 21956 //
     /* 1070251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1070262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1070265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1070268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070290 */     // MIs[0] policy
     /* 1070290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070300 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1070303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070322 */     // GIR_Coverage, 21956,
     /* 1070322 */     GIR_EraseRootFromParent_Done,
     /* 1070323 */   // Label 15806: @1070323
     /* 1070323 */   GIM_Try, /*On fail goto*//*Label 15807*/ GIMT_Encode4(1070400), // Rule ID 21957 //
     /* 1070328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1070339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1070342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1070345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070367 */     // MIs[0] policy
     /* 1070367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070377 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1070380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070386 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070399 */     // GIR_Coverage, 21957,
     /* 1070399 */     GIR_EraseRootFromParent_Done,
     /* 1070400 */   // Label 15807: @1070400
     /* 1070400 */   GIM_Try, /*On fail goto*//*Label 15808*/ GIMT_Encode4(1070477), // Rule ID 21960 //
     /* 1070405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1070416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1070419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070444 */     // MIs[0] policy
     /* 1070444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070454 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1070457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070476 */     // GIR_Coverage, 21960,
     /* 1070476 */     GIR_EraseRootFromParent_Done,
     /* 1070477 */   // Label 15808: @1070477
     /* 1070477 */   GIM_Try, /*On fail goto*//*Label 15809*/ GIMT_Encode4(1070554), // Rule ID 21961 //
     /* 1070482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1070493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1070496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070521 */     // MIs[0] policy
     /* 1070521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070531 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1070534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070540 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070553 */     // GIR_Coverage, 21961,
     /* 1070553 */     GIR_EraseRootFromParent_Done,
     /* 1070554 */   // Label 15809: @1070554
     /* 1070554 */   GIM_Try, /*On fail goto*//*Label 15810*/ GIMT_Encode4(1070631), // Rule ID 21964 //
     /* 1070559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1070570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1070573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1070576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070598 */     // MIs[0] policy
     /* 1070598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070608 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1070611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070630 */     // GIR_Coverage, 21964,
     /* 1070630 */     GIR_EraseRootFromParent_Done,
     /* 1070631 */   // Label 15810: @1070631
     /* 1070631 */   GIM_Try, /*On fail goto*//*Label 15811*/ GIMT_Encode4(1070708), // Rule ID 21965 //
     /* 1070636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1070647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1070650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1070653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070675 */     // MIs[0] policy
     /* 1070675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070685 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1070688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070694 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070707 */     // GIR_Coverage, 21965,
     /* 1070707 */     GIR_EraseRootFromParent_Done,
     /* 1070708 */   // Label 15811: @1070708
     /* 1070708 */   GIM_Try, /*On fail goto*//*Label 15812*/ GIMT_Encode4(1070785), // Rule ID 21968 //
     /* 1070713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1070724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1070727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1070730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070752 */     // MIs[0] policy
     /* 1070752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070762 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1070765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070784 */     // GIR_Coverage, 21968,
     /* 1070784 */     GIR_EraseRootFromParent_Done,
     /* 1070785 */   // Label 15812: @1070785
     /* 1070785 */   GIM_Try, /*On fail goto*//*Label 15813*/ GIMT_Encode4(1070862), // Rule ID 21969 //
     /* 1070790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1070801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1070804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1070807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070829 */     // MIs[0] policy
     /* 1070829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070839 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1070842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070861 */     // GIR_Coverage, 21969,
     /* 1070861 */     GIR_EraseRootFromParent_Done,
     /* 1070862 */   // Label 15813: @1070862
     /* 1070862 */   GIM_Try, /*On fail goto*//*Label 15814*/ GIMT_Encode4(1070939), // Rule ID 21972 //
     /* 1070867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1070878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1070881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1070884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1070887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070906 */     // MIs[0] policy
     /* 1070906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070916 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1070919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070938 */     // GIR_Coverage, 21972,
     /* 1070938 */     GIR_EraseRootFromParent_Done,
     /* 1070939 */   // Label 15814: @1070939
     /* 1070939 */   GIM_Try, /*On fail goto*//*Label 15815*/ GIMT_Encode4(1071016), // Rule ID 21973 //
     /* 1070944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1070955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1070958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1070961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1070964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070983 */     // MIs[0] policy
     /* 1070983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070993 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1070996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071002 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071015 */     // GIR_Coverage, 21973,
     /* 1071015 */     GIR_EraseRootFromParent_Done,
     /* 1071016 */   // Label 15815: @1071016
     /* 1071016 */   GIM_Try, /*On fail goto*//*Label 15816*/ GIMT_Encode4(1071093), // Rule ID 21976 //
     /* 1071021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1071038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071060 */     // MIs[0] policy
     /* 1071060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071070 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1071073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071092 */     // GIR_Coverage, 21976,
     /* 1071092 */     GIR_EraseRootFromParent_Done,
     /* 1071093 */   // Label 15816: @1071093
     /* 1071093 */   GIM_Try, /*On fail goto*//*Label 15817*/ GIMT_Encode4(1071170), // Rule ID 21977 //
     /* 1071098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1071115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071137 */     // MIs[0] policy
     /* 1071137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071147 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1071150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071156 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071169 */     // GIR_Coverage, 21977,
     /* 1071169 */     GIR_EraseRootFromParent_Done,
     /* 1071170 */   // Label 15817: @1071170
     /* 1071170 */   GIM_Try, /*On fail goto*//*Label 15818*/ GIMT_Encode4(1071247), // Rule ID 21980 //
     /* 1071175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1071186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1071189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1071192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071214 */     // MIs[0] policy
     /* 1071214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071224 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1071227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071246 */     // GIR_Coverage, 21980,
     /* 1071246 */     GIR_EraseRootFromParent_Done,
     /* 1071247 */   // Label 15818: @1071247
     /* 1071247 */   GIM_Try, /*On fail goto*//*Label 15819*/ GIMT_Encode4(1071324), // Rule ID 21981 //
     /* 1071252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1071263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1071266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1071269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071291 */     // MIs[0] policy
     /* 1071291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071301 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1071304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071310 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071323 */     // GIR_Coverage, 21981,
     /* 1071323 */     GIR_EraseRootFromParent_Done,
     /* 1071324 */   // Label 15819: @1071324
     /* 1071324 */   GIM_Try, /*On fail goto*//*Label 15820*/ GIMT_Encode4(1071401), // Rule ID 21984 //
     /* 1071329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1071346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071368 */     // MIs[0] policy
     /* 1071368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071378 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1071381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071400 */     // GIR_Coverage, 21984,
     /* 1071400 */     GIR_EraseRootFromParent_Done,
     /* 1071401 */   // Label 15820: @1071401
     /* 1071401 */   GIM_Try, /*On fail goto*//*Label 15821*/ GIMT_Encode4(1071478), // Rule ID 21985 //
     /* 1071406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1071423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071445 */     // MIs[0] policy
     /* 1071445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071455 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1071458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071464 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071477 */     // GIR_Coverage, 21985,
     /* 1071477 */     GIR_EraseRootFromParent_Done,
     /* 1071478 */   // Label 15821: @1071478
     /* 1071478 */   GIM_Try, /*On fail goto*//*Label 15822*/ GIMT_Encode4(1071555), // Rule ID 21988 //
     /* 1071483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1071494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1071497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1071500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071522 */     // MIs[0] policy
     /* 1071522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071532 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1071535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071554 */     // GIR_Coverage, 21988,
     /* 1071554 */     GIR_EraseRootFromParent_Done,
     /* 1071555 */   // Label 15822: @1071555
     /* 1071555 */   GIM_Try, /*On fail goto*//*Label 15823*/ GIMT_Encode4(1071632), // Rule ID 21989 //
     /* 1071560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1071571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1071574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1071577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071599 */     // MIs[0] policy
     /* 1071599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071609 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1071612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071618 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071631 */     // GIR_Coverage, 21989,
     /* 1071631 */     GIR_EraseRootFromParent_Done,
     /* 1071632 */   // Label 15823: @1071632
     /* 1071632 */   GIM_Try, /*On fail goto*//*Label 15824*/ GIMT_Encode4(1071709), // Rule ID 23428 //
     /* 1071637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1071648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1071651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1071654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071676 */     // MIs[0] policy
     /* 1071676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071686 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1071689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071708 */     // GIR_Coverage, 23428,
     /* 1071708 */     GIR_EraseRootFromParent_Done,
     /* 1071709 */   // Label 15824: @1071709
     /* 1071709 */   GIM_Try, /*On fail goto*//*Label 15825*/ GIMT_Encode4(1071786), // Rule ID 23429 //
     /* 1071714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1071725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1071728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1071731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071753 */     // MIs[0] policy
     /* 1071753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071763 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1071766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071772 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071785 */     // GIR_Coverage, 23429,
     /* 1071785 */     GIR_EraseRootFromParent_Done,
     /* 1071786 */   // Label 15825: @1071786
     /* 1071786 */   GIM_Try, /*On fail goto*//*Label 15826*/ GIMT_Encode4(1071863), // Rule ID 23432 //
     /* 1071791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1071802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1071805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1071808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071830 */     // MIs[0] policy
     /* 1071830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071840 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1071843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071862 */     // GIR_Coverage, 23432,
     /* 1071862 */     GIR_EraseRootFromParent_Done,
     /* 1071863 */   // Label 15826: @1071863
     /* 1071863 */   GIM_Try, /*On fail goto*//*Label 15827*/ GIMT_Encode4(1071940), // Rule ID 23433 //
     /* 1071868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1071879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1071882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1071885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071907 */     // MIs[0] policy
     /* 1071907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071917 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1071920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071926 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071939 */     // GIR_Coverage, 23433,
     /* 1071939 */     GIR_EraseRootFromParent_Done,
     /* 1071940 */   // Label 15827: @1071940
     /* 1071940 */   GIM_Try, /*On fail goto*//*Label 15828*/ GIMT_Encode4(1072017), // Rule ID 23436 //
     /* 1071945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1071956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1071959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1071962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071984 */     // MIs[0] policy
     /* 1071984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1071997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072003 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072016 */     // GIR_Coverage, 23436,
     /* 1072016 */     GIR_EraseRootFromParent_Done,
     /* 1072017 */   // Label 15828: @1072017
     /* 1072017 */   GIM_Try, /*On fail goto*//*Label 15829*/ GIMT_Encode4(1072094), // Rule ID 23437 //
     /* 1072022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1072033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1072036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072061 */     // MIs[0] policy
     /* 1072061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072071 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1072074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072080 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072093 */     // GIR_Coverage, 23437,
     /* 1072093 */     GIR_EraseRootFromParent_Done,
     /* 1072094 */   // Label 15829: @1072094
     /* 1072094 */   GIM_Try, /*On fail goto*//*Label 15830*/ GIMT_Encode4(1072171), // Rule ID 23440 //
     /* 1072099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1072110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1072113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072138 */     // MIs[0] policy
     /* 1072138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072170 */     // GIR_Coverage, 23440,
     /* 1072170 */     GIR_EraseRootFromParent_Done,
     /* 1072171 */   // Label 15830: @1072171
     /* 1072171 */   GIM_Try, /*On fail goto*//*Label 15831*/ GIMT_Encode4(1072248), // Rule ID 23441 //
     /* 1072176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1072187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1072190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072215 */     // MIs[0] policy
     /* 1072215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072225 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072234 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072247 */     // GIR_Coverage, 23441,
     /* 1072247 */     GIR_EraseRootFromParent_Done,
     /* 1072248 */   // Label 15831: @1072248
     /* 1072248 */   GIM_Try, /*On fail goto*//*Label 15832*/ GIMT_Encode4(1072325), // Rule ID 23444 //
     /* 1072253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1072264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1072267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072292 */     // MIs[0] policy
     /* 1072292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072302 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072324 */     // GIR_Coverage, 23444,
     /* 1072324 */     GIR_EraseRootFromParent_Done,
     /* 1072325 */   // Label 15832: @1072325
     /* 1072325 */   GIM_Try, /*On fail goto*//*Label 15833*/ GIMT_Encode4(1072402), // Rule ID 23445 //
     /* 1072330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1072341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1072344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072369 */     // MIs[0] policy
     /* 1072369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072379 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072388 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072401 */     // GIR_Coverage, 23445,
     /* 1072401 */     GIR_EraseRootFromParent_Done,
     /* 1072402 */   // Label 15833: @1072402
     /* 1072402 */   GIM_Try, /*On fail goto*//*Label 15834*/ GIMT_Encode4(1072479), // Rule ID 23448 //
     /* 1072407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1072418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1072421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1072424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072446 */     // MIs[0] policy
     /* 1072446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072456 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072478 */     // GIR_Coverage, 23448,
     /* 1072478 */     GIR_EraseRootFromParent_Done,
     /* 1072479 */   // Label 15834: @1072479
     /* 1072479 */   GIM_Try, /*On fail goto*//*Label 15835*/ GIMT_Encode4(1072556), // Rule ID 23449 //
     /* 1072484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1072495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1072498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1072501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072523 */     // MIs[0] policy
     /* 1072523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072533 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072542 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072555 */     // GIR_Coverage, 23449,
     /* 1072555 */     GIR_EraseRootFromParent_Done,
     /* 1072556 */   // Label 15835: @1072556
     /* 1072556 */   GIM_Try, /*On fail goto*//*Label 15836*/ GIMT_Encode4(1072633), // Rule ID 23452 //
     /* 1072561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1072572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1072575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1072578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072600 */     // MIs[0] policy
     /* 1072600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072610 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072632 */     // GIR_Coverage, 23452,
     /* 1072632 */     GIR_EraseRootFromParent_Done,
     /* 1072633 */   // Label 15836: @1072633
     /* 1072633 */   GIM_Try, /*On fail goto*//*Label 15837*/ GIMT_Encode4(1072710), // Rule ID 23453 //
     /* 1072638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1072649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1072652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1072655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072677 */     // MIs[0] policy
     /* 1072677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072687 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072696 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072709 */     // GIR_Coverage, 23453,
     /* 1072709 */     GIR_EraseRootFromParent_Done,
     /* 1072710 */   // Label 15837: @1072710
     /* 1072710 */   GIM_Try, /*On fail goto*//*Label 15838*/ GIMT_Encode4(1072787), // Rule ID 23456 //
     /* 1072715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1072726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1072729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072754 */     // MIs[0] policy
     /* 1072754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072764 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072786 */     // GIR_Coverage, 23456,
     /* 1072786 */     GIR_EraseRootFromParent_Done,
     /* 1072787 */   // Label 15838: @1072787
     /* 1072787 */   GIM_Try, /*On fail goto*//*Label 15839*/ GIMT_Encode4(1072864), // Rule ID 23457 //
     /* 1072792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1072803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1072806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072831 */     // MIs[0] policy
     /* 1072831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072841 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072850 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072863 */     // GIR_Coverage, 23457,
     /* 1072863 */     GIR_EraseRootFromParent_Done,
     /* 1072864 */   // Label 15839: @1072864
     /* 1072864 */   GIM_Try, /*On fail goto*//*Label 15840*/ GIMT_Encode4(1072941), // Rule ID 23460 //
     /* 1072869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1072872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1072880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1072883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072908 */     // MIs[0] policy
     /* 1072908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072918 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1072937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072940 */     // GIR_Coverage, 23460,
     /* 1072940 */     GIR_EraseRootFromParent_Done,
     /* 1072941 */   // Label 15840: @1072941
     /* 1072941 */   GIM_Try, /*On fail goto*//*Label 15841*/ GIMT_Encode4(1073018), // Rule ID 23461 //
     /* 1072946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1072949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1072957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1072960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072985 */     // MIs[0] policy
     /* 1072985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072995 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1073014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073017 */     // GIR_Coverage, 23461,
     /* 1073017 */     GIR_EraseRootFromParent_Done,
     /* 1073018 */   // Label 15841: @1073018
     /* 1073018 */   GIM_Try, /*On fail goto*//*Label 15842*/ GIMT_Encode4(1073095), // Rule ID 23464 //
     /* 1073023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1073034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1073037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073062 */     // MIs[0] policy
     /* 1073062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073072 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073094 */     // GIR_Coverage, 23464,
     /* 1073094 */     GIR_EraseRootFromParent_Done,
     /* 1073095 */   // Label 15842: @1073095
     /* 1073095 */   GIM_Try, /*On fail goto*//*Label 15843*/ GIMT_Encode4(1073172), // Rule ID 23465 //
     /* 1073100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1073111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1073114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073139 */     // MIs[0] policy
     /* 1073139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073149 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073171 */     // GIR_Coverage, 23465,
     /* 1073171 */     GIR_EraseRootFromParent_Done,
     /* 1073172 */   // Label 15843: @1073172
     /* 1073172 */   GIM_Try, /*On fail goto*//*Label 15844*/ GIMT_Encode4(1073249), // Rule ID 23468 //
     /* 1073177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1073188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1073191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073216 */     // MIs[0] policy
     /* 1073216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073226 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073248 */     // GIR_Coverage, 23468,
     /* 1073248 */     GIR_EraseRootFromParent_Done,
     /* 1073249 */   // Label 15844: @1073249
     /* 1073249 */   GIM_Try, /*On fail goto*//*Label 15845*/ GIMT_Encode4(1073326), // Rule ID 23469 //
     /* 1073254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1073265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1073268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073293 */     // MIs[0] policy
     /* 1073293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073303 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073312 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073325 */     // GIR_Coverage, 23469,
     /* 1073325 */     GIR_EraseRootFromParent_Done,
     /* 1073326 */   // Label 15845: @1073326
     /* 1073326 */   GIM_Try, /*On fail goto*//*Label 15846*/ GIMT_Encode4(1073403), // Rule ID 23472 //
     /* 1073331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1073342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1073345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1073348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1073351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073370 */     // MIs[0] policy
     /* 1073370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073380 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073402 */     // GIR_Coverage, 23472,
     /* 1073402 */     GIR_EraseRootFromParent_Done,
     /* 1073403 */   // Label 15846: @1073403
     /* 1073403 */   GIM_Try, /*On fail goto*//*Label 15847*/ GIMT_Encode4(1073480), // Rule ID 23473 //
     /* 1073408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1073419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1073422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1073425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1073428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073447 */     // MIs[0] policy
     /* 1073447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073457 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073479 */     // GIR_Coverage, 23473,
     /* 1073479 */     GIR_EraseRootFromParent_Done,
     /* 1073480 */   // Label 15847: @1073480
     /* 1073480 */   GIM_Try, /*On fail goto*//*Label 15848*/ GIMT_Encode4(1073557), // Rule ID 23476 //
     /* 1073485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1073496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1073499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1073502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073524 */     // MIs[0] policy
     /* 1073524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073534 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073556 */     // GIR_Coverage, 23476,
     /* 1073556 */     GIR_EraseRootFromParent_Done,
     /* 1073557 */   // Label 15848: @1073557
     /* 1073557 */   GIM_Try, /*On fail goto*//*Label 15849*/ GIMT_Encode4(1073634), // Rule ID 23477 //
     /* 1073562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1073573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1073576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1073579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073601 */     // MIs[0] policy
     /* 1073601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073611 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073633 */     // GIR_Coverage, 23477,
     /* 1073633 */     GIR_EraseRootFromParent_Done,
     /* 1073634 */   // Label 15849: @1073634
     /* 1073634 */   GIM_Try, /*On fail goto*//*Label 15850*/ GIMT_Encode4(1073711), // Rule ID 23480 //
     /* 1073639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1073650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1073653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073678 */     // MIs[0] policy
     /* 1073678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073688 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073710 */     // GIR_Coverage, 23480,
     /* 1073710 */     GIR_EraseRootFromParent_Done,
     /* 1073711 */   // Label 15850: @1073711
     /* 1073711 */   GIM_Try, /*On fail goto*//*Label 15851*/ GIMT_Encode4(1073788), // Rule ID 23481 //
     /* 1073716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1073727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1073730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073755 */     // MIs[0] policy
     /* 1073755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073765 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073774 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073787 */     // GIR_Coverage, 23481,
     /* 1073787 */     GIR_EraseRootFromParent_Done,
     /* 1073788 */   // Label 15851: @1073788
     /* 1073788 */   GIM_Try, /*On fail goto*//*Label 15852*/ GIMT_Encode4(1073865), // Rule ID 23484 //
     /* 1073793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1073804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1073807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073832 */     // MIs[0] policy
     /* 1073832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073842 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073864 */     // GIR_Coverage, 23484,
     /* 1073864 */     GIR_EraseRootFromParent_Done,
     /* 1073865 */   // Label 15852: @1073865
     /* 1073865 */   GIM_Try, /*On fail goto*//*Label 15853*/ GIMT_Encode4(1073942), // Rule ID 23485 //
     /* 1073870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1073881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1073884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073909 */     // MIs[0] policy
     /* 1073909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073919 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073928 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073941 */     // GIR_Coverage, 23485,
     /* 1073941 */     GIR_EraseRootFromParent_Done,
     /* 1073942 */   // Label 15853: @1073942
     /* 1073942 */   GIM_Try, /*On fail goto*//*Label 15854*/ GIMT_Encode4(1074019), // Rule ID 23488 //
     /* 1073947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1073958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1073961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1073964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073986 */     // MIs[0] policy
     /* 1073986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074018 */     // GIR_Coverage, 23488,
     /* 1074018 */     GIR_EraseRootFromParent_Done,
     /* 1074019 */   // Label 15854: @1074019
     /* 1074019 */   GIM_Try, /*On fail goto*//*Label 15855*/ GIMT_Encode4(1074096), // Rule ID 23489 //
     /* 1074024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1074035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1074038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1074041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074063 */     // MIs[0] policy
     /* 1074063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074073 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074082 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074095 */     // GIR_Coverage, 23489,
     /* 1074095 */     GIR_EraseRootFromParent_Done,
     /* 1074096 */   // Label 15855: @1074096
     /* 1074096 */   GIM_Try, /*On fail goto*//*Label 15856*/ GIMT_Encode4(1074173), // Rule ID 23492 //
     /* 1074101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1074112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1074115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074140 */     // MIs[0] policy
     /* 1074140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074150 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074172 */     // GIR_Coverage, 23492,
     /* 1074172 */     GIR_EraseRootFromParent_Done,
     /* 1074173 */   // Label 15856: @1074173
     /* 1074173 */   GIM_Try, /*On fail goto*//*Label 15857*/ GIMT_Encode4(1074250), // Rule ID 23493 //
     /* 1074178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1074189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1074192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074217 */     // MIs[0] policy
     /* 1074217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074227 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074249 */     // GIR_Coverage, 23493,
     /* 1074249 */     GIR_EraseRootFromParent_Done,
     /* 1074250 */   // Label 15857: @1074250
     /* 1074250 */   GIM_Try, /*On fail goto*//*Label 15858*/ GIMT_Encode4(1074327), // Rule ID 23496 //
     /* 1074255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1074266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1074269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1074272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074294 */     // MIs[0] policy
     /* 1074294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074304 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074326 */     // GIR_Coverage, 23496,
     /* 1074326 */     GIR_EraseRootFromParent_Done,
     /* 1074327 */   // Label 15858: @1074327
     /* 1074327 */   GIM_Try, /*On fail goto*//*Label 15859*/ GIMT_Encode4(1074404), // Rule ID 23497 //
     /* 1074332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1074343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1074346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1074349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074371 */     // MIs[0] policy
     /* 1074371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074381 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074390 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074403 */     // GIR_Coverage, 23497,
     /* 1074403 */     GIR_EraseRootFromParent_Done,
     /* 1074404 */   // Label 15859: @1074404
     /* 1074404 */   GIM_Try, /*On fail goto*//*Label 15860*/ GIMT_Encode4(1074481), // Rule ID 23500 //
     /* 1074409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1074412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1074420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1074423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1074426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1074429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074448 */     // MIs[0] policy
     /* 1074448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074458 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074480 */     // GIR_Coverage, 23500,
     /* 1074480 */     GIR_EraseRootFromParent_Done,
     /* 1074481 */   // Label 15860: @1074481
     /* 1074481 */   GIM_Try, /*On fail goto*//*Label 15861*/ GIMT_Encode4(1074558), // Rule ID 23501 //
     /* 1074486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1074489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1074497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1074500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1074503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1074506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074525 */     // MIs[0] policy
     /* 1074525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074535 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074557 */     // GIR_Coverage, 23501,
     /* 1074557 */     GIR_EraseRootFromParent_Done,
     /* 1074558 */   // Label 15861: @1074558
     /* 1074558 */   GIM_Try, /*On fail goto*//*Label 15862*/ GIMT_Encode4(1074635), // Rule ID 23504 //
     /* 1074563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1074566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1074574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1074577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1074580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074602 */     // MIs[0] policy
     /* 1074602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074612 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074634 */     // GIR_Coverage, 23504,
     /* 1074634 */     GIR_EraseRootFromParent_Done,
     /* 1074635 */   // Label 15862: @1074635
     /* 1074635 */   GIM_Try, /*On fail goto*//*Label 15863*/ GIMT_Encode4(1074712), // Rule ID 23505 //
     /* 1074640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1074643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1074651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1074654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1074657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074679 */     // MIs[0] policy
     /* 1074679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074689 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074711 */     // GIR_Coverage, 23505,
     /* 1074711 */     GIR_EraseRootFromParent_Done,
     /* 1074712 */   // Label 15863: @1074712
     /* 1074712 */   GIM_Try, /*On fail goto*//*Label 15864*/ GIMT_Encode4(1074789), // Rule ID 23508 //
     /* 1074717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1074720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1074728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1074731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074756 */     // MIs[0] policy
     /* 1074756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074766 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074788 */     // GIR_Coverage, 23508,
     /* 1074788 */     GIR_EraseRootFromParent_Done,
     /* 1074789 */   // Label 15864: @1074789
     /* 1074789 */   GIM_Try, /*On fail goto*//*Label 15865*/ GIMT_Encode4(1074866), // Rule ID 23509 //
     /* 1074794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1074797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1074805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1074808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074833 */     // MIs[0] policy
     /* 1074833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074843 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074865 */     // GIR_Coverage, 23509,
     /* 1074865 */     GIR_EraseRootFromParent_Done,
     /* 1074866 */   // Label 15865: @1074866
     /* 1074866 */   GIM_Try, /*On fail goto*//*Label 15866*/ GIMT_Encode4(1074943), // Rule ID 23614 //
     /* 1074871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1074879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1074882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1074885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1074888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1074891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1074910 */     // MIs[0] policy
     /* 1074910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074920 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1074923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1074927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074942 */     // GIR_Coverage, 23614,
     /* 1074942 */     GIR_EraseRootFromParent_Done,
     /* 1074943 */   // Label 15866: @1074943
     /* 1074943 */   GIM_Try, /*On fail goto*//*Label 15867*/ GIMT_Encode4(1075020), // Rule ID 23615 //
     /* 1074948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1074956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1074959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1074962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1074965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1074968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1074987 */     // MIs[0] policy
     /* 1074987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074997 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1075000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075019 */     // GIR_Coverage, 23615,
     /* 1075019 */     GIR_EraseRootFromParent_Done,
     /* 1075020 */   // Label 15867: @1075020
     /* 1075020 */   GIM_Try, /*On fail goto*//*Label 15868*/ GIMT_Encode4(1075097), // Rule ID 23618 //
     /* 1075025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1075036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1075039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1075042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075064 */     // MIs[0] policy
     /* 1075064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075074 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075096 */     // GIR_Coverage, 23618,
     /* 1075096 */     GIR_EraseRootFromParent_Done,
     /* 1075097 */   // Label 15868: @1075097
     /* 1075097 */   GIM_Try, /*On fail goto*//*Label 15869*/ GIMT_Encode4(1075174), // Rule ID 23619 //
     /* 1075102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1075113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1075116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1075119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075141 */     // MIs[0] policy
     /* 1075141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075151 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075173 */     // GIR_Coverage, 23619,
     /* 1075173 */     GIR_EraseRootFromParent_Done,
     /* 1075174 */   // Label 15869: @1075174
     /* 1075174 */   GIM_Try, /*On fail goto*//*Label 15870*/ GIMT_Encode4(1075251), // Rule ID 23622 //
     /* 1075179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1075190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1075193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1075196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075218 */     // MIs[0] policy
     /* 1075218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075228 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075250 */     // GIR_Coverage, 23622,
     /* 1075250 */     GIR_EraseRootFromParent_Done,
     /* 1075251 */   // Label 15870: @1075251
     /* 1075251 */   GIM_Try, /*On fail goto*//*Label 15871*/ GIMT_Encode4(1075328), // Rule ID 23623 //
     /* 1075256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1075267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1075270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1075273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075295 */     // MIs[0] policy
     /* 1075295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075305 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075327 */     // GIR_Coverage, 23623,
     /* 1075327 */     GIR_EraseRootFromParent_Done,
     /* 1075328 */   // Label 15871: @1075328
     /* 1075328 */   GIM_Try, /*On fail goto*//*Label 15872*/ GIMT_Encode4(1075405), // Rule ID 23626 //
     /* 1075333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1075344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1075347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1075350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075372 */     // MIs[0] policy
     /* 1075372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075382 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075404 */     // GIR_Coverage, 23626,
     /* 1075404 */     GIR_EraseRootFromParent_Done,
     /* 1075405 */   // Label 15872: @1075405
     /* 1075405 */   GIM_Try, /*On fail goto*//*Label 15873*/ GIMT_Encode4(1075482), // Rule ID 23627 //
     /* 1075410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1075421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1075424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1075427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075449 */     // MIs[0] policy
     /* 1075449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075459 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075481 */     // GIR_Coverage, 23627,
     /* 1075481 */     GIR_EraseRootFromParent_Done,
     /* 1075482 */   // Label 15873: @1075482
     /* 1075482 */   GIM_Try, /*On fail goto*//*Label 15874*/ GIMT_Encode4(1075559), // Rule ID 23630 //
     /* 1075487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1075498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1075501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1075504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075526 */     // MIs[0] policy
     /* 1075526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075536 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075558 */     // GIR_Coverage, 23630,
     /* 1075558 */     GIR_EraseRootFromParent_Done,
     /* 1075559 */   // Label 15874: @1075559
     /* 1075559 */   GIM_Try, /*On fail goto*//*Label 15875*/ GIMT_Encode4(1075636), // Rule ID 23631 //
     /* 1075564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1075575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1075578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1075581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075603 */     // MIs[0] policy
     /* 1075603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075613 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075635 */     // GIR_Coverage, 23631,
     /* 1075635 */     GIR_EraseRootFromParent_Done,
     /* 1075636 */   // Label 15875: @1075636
     /* 1075636 */   GIM_Try, /*On fail goto*//*Label 15876*/ GIMT_Encode4(1075713), // Rule ID 23634 //
     /* 1075641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1075652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1075655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1075658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075680 */     // MIs[0] policy
     /* 1075680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075690 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075712 */     // GIR_Coverage, 23634,
     /* 1075712 */     GIR_EraseRootFromParent_Done,
     /* 1075713 */   // Label 15876: @1075713
     /* 1075713 */   GIM_Try, /*On fail goto*//*Label 15877*/ GIMT_Encode4(1075790), // Rule ID 23635 //
     /* 1075718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1075729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1075732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1075735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075757 */     // MIs[0] policy
     /* 1075757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075767 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075789 */     // GIR_Coverage, 23635,
     /* 1075789 */     GIR_EraseRootFromParent_Done,
     /* 1075790 */   // Label 15877: @1075790
     /* 1075790 */   GIM_Try, /*On fail goto*//*Label 15878*/ GIMT_Encode4(1075867), // Rule ID 23638 //
     /* 1075795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1075806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1075809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1075812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075834 */     // MIs[0] policy
     /* 1075834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1075847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075866 */     // GIR_Coverage, 23638,
     /* 1075866 */     GIR_EraseRootFromParent_Done,
     /* 1075867 */   // Label 15878: @1075867
     /* 1075867 */   GIM_Try, /*On fail goto*//*Label 15879*/ GIMT_Encode4(1075944), // Rule ID 23639 //
     /* 1075872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1075883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1075886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1075889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075911 */     // MIs[0] policy
     /* 1075911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075921 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1075924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075943 */     // GIR_Coverage, 23639,
     /* 1075943 */     GIR_EraseRootFromParent_Done,
     /* 1075944 */   // Label 15879: @1075944
     /* 1075944 */   GIM_Try, /*On fail goto*//*Label 15880*/ GIMT_Encode4(1076021), // Rule ID 23642 //
     /* 1075949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1075960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1075963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1075966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075988 */     // MIs[0] policy
     /* 1075988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075998 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076020 */     // GIR_Coverage, 23642,
     /* 1076020 */     GIR_EraseRootFromParent_Done,
     /* 1076021 */   // Label 15880: @1076021
     /* 1076021 */   GIM_Try, /*On fail goto*//*Label 15881*/ GIMT_Encode4(1076098), // Rule ID 23643 //
     /* 1076026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1076037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1076040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1076043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076065 */     // MIs[0] policy
     /* 1076065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076075 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076097 */     // GIR_Coverage, 23643,
     /* 1076097 */     GIR_EraseRootFromParent_Done,
     /* 1076098 */   // Label 15881: @1076098
     /* 1076098 */   GIM_Try, /*On fail goto*//*Label 15882*/ GIMT_Encode4(1076175), // Rule ID 23646 //
     /* 1076103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1076114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1076117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1076120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076142 */     // MIs[0] policy
     /* 1076142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076174 */     // GIR_Coverage, 23646,
     /* 1076174 */     GIR_EraseRootFromParent_Done,
     /* 1076175 */   // Label 15882: @1076175
     /* 1076175 */   GIM_Try, /*On fail goto*//*Label 15883*/ GIMT_Encode4(1076252), // Rule ID 23647 //
     /* 1076180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1076191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1076194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1076197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076219 */     // MIs[0] policy
     /* 1076219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076229 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076251 */     // GIR_Coverage, 23647,
     /* 1076251 */     GIR_EraseRootFromParent_Done,
     /* 1076252 */   // Label 15883: @1076252
     /* 1076252 */   GIM_Try, /*On fail goto*//*Label 15884*/ GIMT_Encode4(1076329), // Rule ID 23650 //
     /* 1076257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1076260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1076268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1076271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1076274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076296 */     // MIs[0] policy
     /* 1076296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076306 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076328 */     // GIR_Coverage, 23650,
     /* 1076328 */     GIR_EraseRootFromParent_Done,
     /* 1076329 */   // Label 15884: @1076329
     /* 1076329 */   GIM_Try, /*On fail goto*//*Label 15885*/ GIMT_Encode4(1076406), // Rule ID 23651 //
     /* 1076334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1076337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1076345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1076348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1076351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076373 */     // MIs[0] policy
     /* 1076373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076383 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076405 */     // GIR_Coverage, 23651,
     /* 1076405 */     GIR_EraseRootFromParent_Done,
     /* 1076406 */   // Label 15885: @1076406
     /* 1076406 */   GIM_Try, /*On fail goto*//*Label 15886*/ GIMT_Encode4(1076483), // Rule ID 23654 //
     /* 1076411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1076422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1076425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1076428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076450 */     // MIs[0] policy
     /* 1076450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076460 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076482 */     // GIR_Coverage, 23654,
     /* 1076482 */     GIR_EraseRootFromParent_Done,
     /* 1076483 */   // Label 15886: @1076483
     /* 1076483 */   GIM_Try, /*On fail goto*//*Label 15887*/ GIMT_Encode4(1076560), // Rule ID 23655 //
     /* 1076488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1076499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1076502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1076505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076527 */     // MIs[0] policy
     /* 1076527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076537 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076559 */     // GIR_Coverage, 23655,
     /* 1076559 */     GIR_EraseRootFromParent_Done,
     /* 1076560 */   // Label 15887: @1076560
     /* 1076560 */   GIM_Try, /*On fail goto*//*Label 15888*/ GIMT_Encode4(1076637), // Rule ID 23658 //
     /* 1076565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1076576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1076579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1076582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076604 */     // MIs[0] policy
     /* 1076604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076614 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1076617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076636 */     // GIR_Coverage, 23658,
     /* 1076636 */     GIR_EraseRootFromParent_Done,
     /* 1076637 */   // Label 15888: @1076637
     /* 1076637 */   GIM_Try, /*On fail goto*//*Label 15889*/ GIMT_Encode4(1076714), // Rule ID 23659 //
     /* 1076642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1076653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1076656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1076659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076681 */     // MIs[0] policy
     /* 1076681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076691 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1076694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076713 */     // GIR_Coverage, 23659,
     /* 1076713 */     GIR_EraseRootFromParent_Done,
     /* 1076714 */   // Label 15889: @1076714
     /* 1076714 */   GIM_Try, /*On fail goto*//*Label 15890*/ GIMT_Encode4(1076791), // Rule ID 23662 //
     /* 1076719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1076730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1076733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1076736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076758 */     // MIs[0] policy
     /* 1076758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076768 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1076771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076790 */     // GIR_Coverage, 23662,
     /* 1076790 */     GIR_EraseRootFromParent_Done,
     /* 1076791 */   // Label 15890: @1076791
     /* 1076791 */   GIM_Try, /*On fail goto*//*Label 15891*/ GIMT_Encode4(1076868), // Rule ID 23663 //
     /* 1076796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1076807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1076810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1076813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076835 */     // MIs[0] policy
     /* 1076835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076845 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1076848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076867 */     // GIR_Coverage, 23663,
     /* 1076867 */     GIR_EraseRootFromParent_Done,
     /* 1076868 */   // Label 15891: @1076868
     /* 1076868 */   GIM_Try, /*On fail goto*//*Label 15892*/ GIMT_Encode4(1076945), // Rule ID 23666 //
     /* 1076873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1076884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1076887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1076890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076912 */     // MIs[0] policy
     /* 1076912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076944 */     // GIR_Coverage, 23666,
     /* 1076944 */     GIR_EraseRootFromParent_Done,
     /* 1076945 */   // Label 15892: @1076945
     /* 1076945 */   GIM_Try, /*On fail goto*//*Label 15893*/ GIMT_Encode4(1077022), // Rule ID 23667 //
     /* 1076950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1076961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1076964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1076967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076989 */     // MIs[0] policy
     /* 1076989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076999 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077021 */     // GIR_Coverage, 23667,
     /* 1077021 */     GIR_EraseRootFromParent_Done,
     /* 1077022 */   // Label 15893: @1077022
     /* 1077022 */   GIM_Try, /*On fail goto*//*Label 15894*/ GIMT_Encode4(1077099), // Rule ID 23670 //
     /* 1077027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1077038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1077041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1077044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077066 */     // MIs[0] policy
     /* 1077066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077076 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077098 */     // GIR_Coverage, 23670,
     /* 1077098 */     GIR_EraseRootFromParent_Done,
     /* 1077099 */   // Label 15894: @1077099
     /* 1077099 */   GIM_Try, /*On fail goto*//*Label 15895*/ GIMT_Encode4(1077176), // Rule ID 23671 //
     /* 1077104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1077115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1077118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1077121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077143 */     // MIs[0] policy
     /* 1077143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077153 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077175 */     // GIR_Coverage, 23671,
     /* 1077175 */     GIR_EraseRootFromParent_Done,
     /* 1077176 */   // Label 15895: @1077176
     /* 1077176 */   GIM_Try, /*On fail goto*//*Label 15896*/ GIMT_Encode4(1077253), // Rule ID 23674 //
     /* 1077181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1077192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1077195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1077198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077220 */     // MIs[0] policy
     /* 1077220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077230 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077252 */     // GIR_Coverage, 23674,
     /* 1077252 */     GIR_EraseRootFromParent_Done,
     /* 1077253 */   // Label 15896: @1077253
     /* 1077253 */   GIM_Try, /*On fail goto*//*Label 15897*/ GIMT_Encode4(1077330), // Rule ID 23675 //
     /* 1077258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1077269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1077272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1077275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077297 */     // MIs[0] policy
     /* 1077297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077307 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077329 */     // GIR_Coverage, 23675,
     /* 1077329 */     GIR_EraseRootFromParent_Done,
     /* 1077330 */   // Label 15897: @1077330
     /* 1077330 */   GIM_Try, /*On fail goto*//*Label 15898*/ GIMT_Encode4(1077407), // Rule ID 23678 //
     /* 1077335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1077346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1077349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1077352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077374 */     // MIs[0] policy
     /* 1077374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077406 */     // GIR_Coverage, 23678,
     /* 1077406 */     GIR_EraseRootFromParent_Done,
     /* 1077407 */   // Label 15898: @1077407
     /* 1077407 */   GIM_Try, /*On fail goto*//*Label 15899*/ GIMT_Encode4(1077484), // Rule ID 23679 //
     /* 1077412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1077423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1077426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1077429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077451 */     // MIs[0] policy
     /* 1077451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077461 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077483 */     // GIR_Coverage, 23679,
     /* 1077483 */     GIR_EraseRootFromParent_Done,
     /* 1077484 */   // Label 15899: @1077484
     /* 1077484 */   GIM_Try, /*On fail goto*//*Label 15900*/ GIMT_Encode4(1077561), // Rule ID 23682 //
     /* 1077489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1077500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1077503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1077506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077528 */     // MIs[0] policy
     /* 1077528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077538 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077560 */     // GIR_Coverage, 23682,
     /* 1077560 */     GIR_EraseRootFromParent_Done,
     /* 1077561 */   // Label 15900: @1077561
     /* 1077561 */   GIM_Try, /*On fail goto*//*Label 15901*/ GIMT_Encode4(1077638), // Rule ID 23683 //
     /* 1077566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1077577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1077580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1077583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077605 */     // MIs[0] policy
     /* 1077605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077615 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077637 */     // GIR_Coverage, 23683,
     /* 1077637 */     GIR_EraseRootFromParent_Done,
     /* 1077638 */   // Label 15901: @1077638
     /* 1077638 */   GIM_Try, /*On fail goto*//*Label 15902*/ GIMT_Encode4(1077715), // Rule ID 23686 //
     /* 1077643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1077654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1077657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1077660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077682 */     // MIs[0] policy
     /* 1077682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077714 */     // GIR_Coverage, 23686,
     /* 1077714 */     GIR_EraseRootFromParent_Done,
     /* 1077715 */   // Label 15902: @1077715
     /* 1077715 */   GIM_Try, /*On fail goto*//*Label 15903*/ GIMT_Encode4(1077792), // Rule ID 23687 //
     /* 1077720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1077731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1077734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1077737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077759 */     // MIs[0] policy
     /* 1077759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077769 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077791 */     // GIR_Coverage, 23687,
     /* 1077791 */     GIR_EraseRootFromParent_Done,
     /* 1077792 */   // Label 15903: @1077792
     /* 1077792 */   GIM_Try, /*On fail goto*//*Label 15904*/ GIMT_Encode4(1077869), // Rule ID 23690 //
     /* 1077797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1077800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1077808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1077811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1077814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077836 */     // MIs[0] policy
     /* 1077836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1077865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077868 */     // GIR_Coverage, 23690,
     /* 1077868 */     GIR_EraseRootFromParent_Done,
     /* 1077869 */   // Label 15904: @1077869
     /* 1077869 */   GIM_Try, /*On fail goto*//*Label 15905*/ GIMT_Encode4(1077946), // Rule ID 23691 //
     /* 1077874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1077877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1077885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1077888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1077891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077913 */     // MIs[0] policy
     /* 1077913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077923 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1077942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077945 */     // GIR_Coverage, 23691,
     /* 1077945 */     GIR_EraseRootFromParent_Done,
     /* 1077946 */   // Label 15905: @1077946
     /* 1077946 */   GIM_Try, /*On fail goto*//*Label 15906*/ GIMT_Encode4(1078023), // Rule ID 23694 //
     /* 1077951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1077954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1077962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1077965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1077968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077990 */     // MIs[0] policy
     /* 1077990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078000 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1078003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078022 */     // GIR_Coverage, 23694,
     /* 1078022 */     GIR_EraseRootFromParent_Done,
     /* 1078023 */   // Label 15906: @1078023
     /* 1078023 */   GIM_Try, /*On fail goto*//*Label 15907*/ GIMT_Encode4(1078100), // Rule ID 23695 //
     /* 1078028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1078039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1078042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1078045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078067 */     // MIs[0] policy
     /* 1078067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078077 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1078080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078099 */     // GIR_Coverage, 23695,
     /* 1078099 */     GIR_EraseRootFromParent_Done,
     /* 1078100 */   // Label 15907: @1078100
     /* 1078100 */   GIM_Try, /*On fail goto*//*Label 15908*/ GIMT_Encode4(1078177), // Rule ID 23698 //
     /* 1078105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1078116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1078119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1078122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078144 */     // MIs[0] policy
     /* 1078144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078154 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1078157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078176 */     // GIR_Coverage, 23698,
     /* 1078176 */     GIR_EraseRootFromParent_Done,
     /* 1078177 */   // Label 15908: @1078177
     /* 1078177 */   GIM_Try, /*On fail goto*//*Label 15909*/ GIMT_Encode4(1078254), // Rule ID 23699 //
     /* 1078182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1078193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1078196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1078199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078221 */     // MIs[0] policy
     /* 1078221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078231 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1078234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078253 */     // GIR_Coverage, 23699,
     /* 1078253 */     GIR_EraseRootFromParent_Done,
     /* 1078254 */   // Label 15909: @1078254
     /* 1078254 */   GIM_Try, /*On fail goto*//*Label 15910*/ GIMT_Encode4(1078331), // Rule ID 23790 //
     /* 1078259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1078270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1078273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1078276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078298 */     // MIs[0] policy
     /* 1078298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078308 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1078311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078330 */     // GIR_Coverage, 23790,
     /* 1078330 */     GIR_EraseRootFromParent_Done,
     /* 1078331 */   // Label 15910: @1078331
     /* 1078331 */   GIM_Try, /*On fail goto*//*Label 15911*/ GIMT_Encode4(1078408), // Rule ID 23791 //
     /* 1078336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1078347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1078350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1078353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078375 */     // MIs[0] policy
     /* 1078375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078385 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1078388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078407 */     // GIR_Coverage, 23791,
     /* 1078407 */     GIR_EraseRootFromParent_Done,
     /* 1078408 */   // Label 15911: @1078408
     /* 1078408 */   GIM_Try, /*On fail goto*//*Label 15912*/ GIMT_Encode4(1078485), // Rule ID 23794 //
     /* 1078413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1078424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1078427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1078430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078452 */     // MIs[0] policy
     /* 1078452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078462 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078484 */     // GIR_Coverage, 23794,
     /* 1078484 */     GIR_EraseRootFromParent_Done,
     /* 1078485 */   // Label 15912: @1078485
     /* 1078485 */   GIM_Try, /*On fail goto*//*Label 15913*/ GIMT_Encode4(1078562), // Rule ID 23795 //
     /* 1078490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1078501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1078504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1078507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078529 */     // MIs[0] policy
     /* 1078529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078539 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078561 */     // GIR_Coverage, 23795,
     /* 1078561 */     GIR_EraseRootFromParent_Done,
     /* 1078562 */   // Label 15913: @1078562
     /* 1078562 */   GIM_Try, /*On fail goto*//*Label 15914*/ GIMT_Encode4(1078639), // Rule ID 23798 //
     /* 1078567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1078578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1078581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1078584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078606 */     // MIs[0] policy
     /* 1078606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078616 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1078619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078638 */     // GIR_Coverage, 23798,
     /* 1078638 */     GIR_EraseRootFromParent_Done,
     /* 1078639 */   // Label 15914: @1078639
     /* 1078639 */   GIM_Try, /*On fail goto*//*Label 15915*/ GIMT_Encode4(1078716), // Rule ID 23799 //
     /* 1078644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1078655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1078658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1078661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078683 */     // MIs[0] policy
     /* 1078683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078693 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1078696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078715 */     // GIR_Coverage, 23799,
     /* 1078715 */     GIR_EraseRootFromParent_Done,
     /* 1078716 */   // Label 15915: @1078716
     /* 1078716 */   GIM_Try, /*On fail goto*//*Label 15916*/ GIMT_Encode4(1078793), // Rule ID 23802 //
     /* 1078721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1078732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1078735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1078738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078760 */     // MIs[0] policy
     /* 1078760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078770 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078792 */     // GIR_Coverage, 23802,
     /* 1078792 */     GIR_EraseRootFromParent_Done,
     /* 1078793 */   // Label 15916: @1078793
     /* 1078793 */   GIM_Try, /*On fail goto*//*Label 15917*/ GIMT_Encode4(1078870), // Rule ID 23803 //
     /* 1078798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1078809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1078812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1078815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078837 */     // MIs[0] policy
     /* 1078837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078847 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078869 */     // GIR_Coverage, 23803,
     /* 1078869 */     GIR_EraseRootFromParent_Done,
     /* 1078870 */   // Label 15917: @1078870
     /* 1078870 */   GIM_Try, /*On fail goto*//*Label 15918*/ GIMT_Encode4(1078947), // Rule ID 23806 //
     /* 1078875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1078886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1078889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1078892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078914 */     // MIs[0] policy
     /* 1078914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078924 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1078927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078946 */     // GIR_Coverage, 23806,
     /* 1078946 */     GIR_EraseRootFromParent_Done,
     /* 1078947 */   // Label 15918: @1078947
     /* 1078947 */   GIM_Try, /*On fail goto*//*Label 15919*/ GIMT_Encode4(1079024), // Rule ID 23807 //
     /* 1078952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1078963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1078966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1078969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078991 */     // MIs[0] policy
     /* 1078991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079001 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079023 */     // GIR_Coverage, 23807,
     /* 1079023 */     GIR_EraseRootFromParent_Done,
     /* 1079024 */   // Label 15919: @1079024
     /* 1079024 */   GIM_Try, /*On fail goto*//*Label 15920*/ GIMT_Encode4(1079101), // Rule ID 23810 //
     /* 1079029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1079040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1079043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1079046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079068 */     // MIs[0] policy
     /* 1079068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079078 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079100 */     // GIR_Coverage, 23810,
     /* 1079100 */     GIR_EraseRootFromParent_Done,
     /* 1079101 */   // Label 15920: @1079101
     /* 1079101 */   GIM_Try, /*On fail goto*//*Label 15921*/ GIMT_Encode4(1079178), // Rule ID 23811 //
     /* 1079106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1079117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1079120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1079123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079145 */     // MIs[0] policy
     /* 1079145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079155 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079177 */     // GIR_Coverage, 23811,
     /* 1079177 */     GIR_EraseRootFromParent_Done,
     /* 1079178 */   // Label 15921: @1079178
     /* 1079178 */   GIM_Try, /*On fail goto*//*Label 15922*/ GIMT_Encode4(1079255), // Rule ID 23814 //
     /* 1079183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1079194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1079197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1079200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079222 */     // MIs[0] policy
     /* 1079222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079254 */     // GIR_Coverage, 23814,
     /* 1079254 */     GIR_EraseRootFromParent_Done,
     /* 1079255 */   // Label 15922: @1079255
     /* 1079255 */   GIM_Try, /*On fail goto*//*Label 15923*/ GIMT_Encode4(1079332), // Rule ID 23815 //
     /* 1079260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1079271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1079274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1079277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079299 */     // MIs[0] policy
     /* 1079299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079309 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079331 */     // GIR_Coverage, 23815,
     /* 1079331 */     GIR_EraseRootFromParent_Done,
     /* 1079332 */   // Label 15923: @1079332
     /* 1079332 */   GIM_Try, /*On fail goto*//*Label 15924*/ GIMT_Encode4(1079409), // Rule ID 23818 //
     /* 1079337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1079348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1079351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1079354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079376 */     // MIs[0] policy
     /* 1079376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079408 */     // GIR_Coverage, 23818,
     /* 1079408 */     GIR_EraseRootFromParent_Done,
     /* 1079409 */   // Label 15924: @1079409
     /* 1079409 */   GIM_Try, /*On fail goto*//*Label 15925*/ GIMT_Encode4(1079486), // Rule ID 23819 //
     /* 1079414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1079425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1079428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1079431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079453 */     // MIs[0] policy
     /* 1079453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079463 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079485 */     // GIR_Coverage, 23819,
     /* 1079485 */     GIR_EraseRootFromParent_Done,
     /* 1079486 */   // Label 15925: @1079486
     /* 1079486 */   GIM_Try, /*On fail goto*//*Label 15926*/ GIMT_Encode4(1079563), // Rule ID 23822 //
     /* 1079491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1079502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1079505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1079508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079530 */     // MIs[0] policy
     /* 1079530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079562 */     // GIR_Coverage, 23822,
     /* 1079562 */     GIR_EraseRootFromParent_Done,
     /* 1079563 */   // Label 15926: @1079563
     /* 1079563 */   GIM_Try, /*On fail goto*//*Label 15927*/ GIMT_Encode4(1079640), // Rule ID 23823 //
     /* 1079568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1079579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1079582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1079585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079607 */     // MIs[0] policy
     /* 1079607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079617 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079639 */     // GIR_Coverage, 23823,
     /* 1079639 */     GIR_EraseRootFromParent_Done,
     /* 1079640 */   // Label 15927: @1079640
     /* 1079640 */   GIM_Try, /*On fail goto*//*Label 15928*/ GIMT_Encode4(1079717), // Rule ID 23826 //
     /* 1079645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1079648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1079656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1079659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1079662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079684 */     // MIs[0] policy
     /* 1079684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079694 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1079713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079716 */     // GIR_Coverage, 23826,
     /* 1079716 */     GIR_EraseRootFromParent_Done,
     /* 1079717 */   // Label 15928: @1079717
     /* 1079717 */   GIM_Try, /*On fail goto*//*Label 15929*/ GIMT_Encode4(1079794), // Rule ID 23827 //
     /* 1079722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1079725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1079733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1079736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1079739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079761 */     // MIs[0] policy
     /* 1079761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079771 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1079790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079793 */     // GIR_Coverage, 23827,
     /* 1079793 */     GIR_EraseRootFromParent_Done,
     /* 1079794 */   // Label 15929: @1079794
     /* 1079794 */   GIM_Try, /*On fail goto*//*Label 15930*/ GIMT_Encode4(1079871), // Rule ID 23830 //
     /* 1079799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1079810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1079813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1079816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079838 */     // MIs[0] policy
     /* 1079838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079848 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1079851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079870 */     // GIR_Coverage, 23830,
     /* 1079870 */     GIR_EraseRootFromParent_Done,
     /* 1079871 */   // Label 15930: @1079871
     /* 1079871 */   GIM_Try, /*On fail goto*//*Label 15931*/ GIMT_Encode4(1079948), // Rule ID 23831 //
     /* 1079876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1079887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1079890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1079893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079915 */     // MIs[0] policy
     /* 1079915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079925 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1079928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079947 */     // GIR_Coverage, 23831,
     /* 1079947 */     GIR_EraseRootFromParent_Done,
     /* 1079948 */   // Label 15931: @1079948
     /* 1079948 */   GIM_Try, /*On fail goto*//*Label 15932*/ GIMT_Encode4(1080025), // Rule ID 23834 //
     /* 1079953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1079964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1079967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1079970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079992 */     // MIs[0] policy
     /* 1079992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080002 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080024 */     // GIR_Coverage, 23834,
     /* 1080024 */     GIR_EraseRootFromParent_Done,
     /* 1080025 */   // Label 15932: @1080025
     /* 1080025 */   GIM_Try, /*On fail goto*//*Label 15933*/ GIMT_Encode4(1080102), // Rule ID 23835 //
     /* 1080030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1080041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1080044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1080047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080069 */     // MIs[0] policy
     /* 1080069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080079 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080101 */     // GIR_Coverage, 23835,
     /* 1080101 */     GIR_EraseRootFromParent_Done,
     /* 1080102 */   // Label 15933: @1080102
     /* 1080102 */   GIM_Try, /*On fail goto*//*Label 15934*/ GIMT_Encode4(1080179), // Rule ID 23838 //
     /* 1080107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1080118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1080121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1080124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080146 */     // MIs[0] policy
     /* 1080146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080156 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080178 */     // GIR_Coverage, 23838,
     /* 1080178 */     GIR_EraseRootFromParent_Done,
     /* 1080179 */   // Label 15934: @1080179
     /* 1080179 */   GIM_Try, /*On fail goto*//*Label 15935*/ GIMT_Encode4(1080256), // Rule ID 23839 //
     /* 1080184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1080195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1080198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1080201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080223 */     // MIs[0] policy
     /* 1080223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080233 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080255 */     // GIR_Coverage, 23839,
     /* 1080255 */     GIR_EraseRootFromParent_Done,
     /* 1080256 */   // Label 15935: @1080256
     /* 1080256 */   GIM_Try, /*On fail goto*//*Label 15936*/ GIMT_Encode4(1080333), // Rule ID 23842 //
     /* 1080261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1080272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1080275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080300 */     // MIs[0] policy
     /* 1080300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080310 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080332 */     // GIR_Coverage, 23842,
     /* 1080332 */     GIR_EraseRootFromParent_Done,
     /* 1080333 */   // Label 15936: @1080333
     /* 1080333 */   GIM_Try, /*On fail goto*//*Label 15937*/ GIMT_Encode4(1080410), // Rule ID 23843 //
     /* 1080338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1080349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1080352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080377 */     // MIs[0] policy
     /* 1080377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080387 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080409 */     // GIR_Coverage, 23843,
     /* 1080409 */     GIR_EraseRootFromParent_Done,
     /* 1080410 */   // Label 15937: @1080410
     /* 1080410 */   GIM_Try, /*On fail goto*//*Label 15938*/ GIMT_Encode4(1080487), // Rule ID 23846 //
     /* 1080415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1080426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1080429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080454 */     // MIs[0] policy
     /* 1080454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080464 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080486 */     // GIR_Coverage, 23846,
     /* 1080486 */     GIR_EraseRootFromParent_Done,
     /* 1080487 */   // Label 15938: @1080487
     /* 1080487 */   GIM_Try, /*On fail goto*//*Label 15939*/ GIMT_Encode4(1080564), // Rule ID 23847 //
     /* 1080492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1080503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1080506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080531 */     // MIs[0] policy
     /* 1080531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080541 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080563 */     // GIR_Coverage, 23847,
     /* 1080563 */     GIR_EraseRootFromParent_Done,
     /* 1080564 */   // Label 15939: @1080564
     /* 1080564 */   GIM_Try, /*On fail goto*//*Label 15940*/ GIMT_Encode4(1080641), // Rule ID 23850 //
     /* 1080569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1080580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1080583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1080586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080608 */     // MIs[0] policy
     /* 1080608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080618 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080640 */     // GIR_Coverage, 23850,
     /* 1080640 */     GIR_EraseRootFromParent_Done,
     /* 1080641 */   // Label 15940: @1080641
     /* 1080641 */   GIM_Try, /*On fail goto*//*Label 15941*/ GIMT_Encode4(1080718), // Rule ID 23851 //
     /* 1080646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1080657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1080660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1080663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080685 */     // MIs[0] policy
     /* 1080685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080695 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080717 */     // GIR_Coverage, 23851,
     /* 1080717 */     GIR_EraseRootFromParent_Done,
     /* 1080718 */   // Label 15941: @1080718
     /* 1080718 */   GIM_Try, /*On fail goto*//*Label 15942*/ GIMT_Encode4(1080795), // Rule ID 23854 //
     /* 1080723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1080734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1080737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1080740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080762 */     // MIs[0] policy
     /* 1080762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080794 */     // GIR_Coverage, 23854,
     /* 1080794 */     GIR_EraseRootFromParent_Done,
     /* 1080795 */   // Label 15942: @1080795
     /* 1080795 */   GIM_Try, /*On fail goto*//*Label 15943*/ GIMT_Encode4(1080872), // Rule ID 23855 //
     /* 1080800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1080811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1080814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1080817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080839 */     // MIs[0] policy
     /* 1080839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080849 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080871 */     // GIR_Coverage, 23855,
     /* 1080871 */     GIR_EraseRootFromParent_Done,
     /* 1080872 */   // Label 15943: @1080872
     /* 1080872 */   GIM_Try, /*On fail goto*//*Label 15944*/ GIMT_Encode4(1080949), // Rule ID 23858 //
     /* 1080877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1080888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1080891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1080894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080916 */     // MIs[0] policy
     /* 1080916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080948 */     // GIR_Coverage, 23858,
     /* 1080948 */     GIR_EraseRootFromParent_Done,
     /* 1080949 */   // Label 15944: @1080949
     /* 1080949 */   GIM_Try, /*On fail goto*//*Label 15945*/ GIMT_Encode4(1081026), // Rule ID 23859 //
     /* 1080954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1080965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1080968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1080971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080993 */     // MIs[0] policy
     /* 1080993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081003 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081025 */     // GIR_Coverage, 23859,
     /* 1081025 */     GIR_EraseRootFromParent_Done,
     /* 1081026 */   // Label 15945: @1081026
     /* 1081026 */   GIM_Try, /*On fail goto*//*Label 15946*/ GIMT_Encode4(1081103), // Rule ID 23862 //
     /* 1081031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1081042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1081045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081070 */     // MIs[0] policy
     /* 1081070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081080 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081102 */     // GIR_Coverage, 23862,
     /* 1081102 */     GIR_EraseRootFromParent_Done,
     /* 1081103 */   // Label 15946: @1081103
     /* 1081103 */   GIM_Try, /*On fail goto*//*Label 15947*/ GIMT_Encode4(1081180), // Rule ID 23863 //
     /* 1081108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1081119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1081122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081147 */     // MIs[0] policy
     /* 1081147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081157 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081179 */     // GIR_Coverage, 23863,
     /* 1081179 */     GIR_EraseRootFromParent_Done,
     /* 1081180 */   // Label 15947: @1081180
     /* 1081180 */   GIM_Try, /*On fail goto*//*Label 15948*/ GIMT_Encode4(1081257), // Rule ID 23866 //
     /* 1081185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1081196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1081199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081224 */     // MIs[0] policy
     /* 1081224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1081237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081256 */     // GIR_Coverage, 23866,
     /* 1081256 */     GIR_EraseRootFromParent_Done,
     /* 1081257 */   // Label 15948: @1081257
     /* 1081257 */   GIM_Try, /*On fail goto*//*Label 15949*/ GIMT_Encode4(1081334), // Rule ID 23867 //
     /* 1081262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1081273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1081276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081301 */     // MIs[0] policy
     /* 1081301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1081314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081333 */     // GIR_Coverage, 23867,
     /* 1081333 */     GIR_EraseRootFromParent_Done,
     /* 1081334 */   // Label 15949: @1081334
     /* 1081334 */   GIM_Try, /*On fail goto*//*Label 15950*/ GIMT_Encode4(1081411), // Rule ID 23870 //
     /* 1081339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1081350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1081353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081378 */     // MIs[0] policy
     /* 1081378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081388 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081410 */     // GIR_Coverage, 23870,
     /* 1081410 */     GIR_EraseRootFromParent_Done,
     /* 1081411 */   // Label 15950: @1081411
     /* 1081411 */   GIM_Try, /*On fail goto*//*Label 15951*/ GIMT_Encode4(1081488), // Rule ID 23871 //
     /* 1081416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1081427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1081430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081455 */     // MIs[0] policy
     /* 1081455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081465 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081487 */     // GIR_Coverage, 23871,
     /* 1081487 */     GIR_EraseRootFromParent_Done,
     /* 1081488 */   // Label 15951: @1081488
     /* 1081488 */   GIM_Try, /*On fail goto*//*Label 15952*/ GIMT_Encode4(1081565), // Rule ID 23874 //
     /* 1081493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1081504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1081507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1081510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081532 */     // MIs[0] policy
     /* 1081532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081542 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081564 */     // GIR_Coverage, 23874,
     /* 1081564 */     GIR_EraseRootFromParent_Done,
     /* 1081565 */   // Label 15952: @1081565
     /* 1081565 */   GIM_Try, /*On fail goto*//*Label 15953*/ GIMT_Encode4(1081642), // Rule ID 23875 //
     /* 1081570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1081581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1081584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1081587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081609 */     // MIs[0] policy
     /* 1081609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081619 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081641 */     // GIR_Coverage, 23875,
     /* 1081641 */     GIR_EraseRootFromParent_Done,
     /* 1081642 */   // Label 15953: @1081642
     /* 1081642 */   GIM_Try, /*On fail goto*//*Label 15954*/ GIMT_Encode4(1081719), // Rule ID 24142 //
     /* 1081647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1081658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1081661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1081664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081686 */     // MIs[0] policy
     /* 1081686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081696 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1081699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081718 */     // GIR_Coverage, 24142,
     /* 1081718 */     GIR_EraseRootFromParent_Done,
     /* 1081719 */   // Label 15954: @1081719
     /* 1081719 */   GIM_Try, /*On fail goto*//*Label 15955*/ GIMT_Encode4(1081796), // Rule ID 24143 //
     /* 1081724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1081735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1081738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1081741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081763 */     // MIs[0] policy
     /* 1081763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081773 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1081776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081795 */     // GIR_Coverage, 24143,
     /* 1081795 */     GIR_EraseRootFromParent_Done,
     /* 1081796 */   // Label 15955: @1081796
     /* 1081796 */   GIM_Try, /*On fail goto*//*Label 15956*/ GIMT_Encode4(1081873), // Rule ID 24146 //
     /* 1081801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1081812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1081815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1081818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081840 */     // MIs[0] policy
     /* 1081840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081850 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1081853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081872 */     // GIR_Coverage, 24146,
     /* 1081872 */     GIR_EraseRootFromParent_Done,
     /* 1081873 */   // Label 15956: @1081873
     /* 1081873 */   GIM_Try, /*On fail goto*//*Label 15957*/ GIMT_Encode4(1081950), // Rule ID 24147 //
     /* 1081878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1081889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1081892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1081895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081917 */     // MIs[0] policy
     /* 1081917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081927 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1081930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081949 */     // GIR_Coverage, 24147,
     /* 1081949 */     GIR_EraseRootFromParent_Done,
     /* 1081950 */   // Label 15957: @1081950
     /* 1081950 */   GIM_Try, /*On fail goto*//*Label 15958*/ GIMT_Encode4(1082027), // Rule ID 24150 //
     /* 1081955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1081966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1081969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1081972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081994 */     // MIs[0] policy
     /* 1081994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082004 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1082007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082026 */     // GIR_Coverage, 24150,
     /* 1082026 */     GIR_EraseRootFromParent_Done,
     /* 1082027 */   // Label 15958: @1082027
     /* 1082027 */   GIM_Try, /*On fail goto*//*Label 15959*/ GIMT_Encode4(1082104), // Rule ID 24151 //
     /* 1082032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1082043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1082046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1082049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082071 */     // MIs[0] policy
     /* 1082071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082081 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1082084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082103 */     // GIR_Coverage, 24151,
     /* 1082103 */     GIR_EraseRootFromParent_Done,
     /* 1082104 */   // Label 15959: @1082104
     /* 1082104 */   GIM_Try, /*On fail goto*//*Label 15960*/ GIMT_Encode4(1082181), // Rule ID 24154 //
     /* 1082109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1082120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1082123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1082126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082148 */     // MIs[0] policy
     /* 1082148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082158 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082180 */     // GIR_Coverage, 24154,
     /* 1082180 */     GIR_EraseRootFromParent_Done,
     /* 1082181 */   // Label 15960: @1082181
     /* 1082181 */   GIM_Try, /*On fail goto*//*Label 15961*/ GIMT_Encode4(1082258), // Rule ID 24155 //
     /* 1082186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1082197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1082200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1082203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082225 */     // MIs[0] policy
     /* 1082225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082235 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082257 */     // GIR_Coverage, 24155,
     /* 1082257 */     GIR_EraseRootFromParent_Done,
     /* 1082258 */   // Label 15961: @1082258
     /* 1082258 */   GIM_Try, /*On fail goto*//*Label 15962*/ GIMT_Encode4(1082335), // Rule ID 24158 //
     /* 1082263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1082274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1082277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1082280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082302 */     // MIs[0] policy
     /* 1082302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082312 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082334 */     // GIR_Coverage, 24158,
     /* 1082334 */     GIR_EraseRootFromParent_Done,
     /* 1082335 */   // Label 15962: @1082335
     /* 1082335 */   GIM_Try, /*On fail goto*//*Label 15963*/ GIMT_Encode4(1082412), // Rule ID 24159 //
     /* 1082340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1082351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1082354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1082357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082379 */     // MIs[0] policy
     /* 1082379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082389 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082411 */     // GIR_Coverage, 24159,
     /* 1082411 */     GIR_EraseRootFromParent_Done,
     /* 1082412 */   // Label 15963: @1082412
     /* 1082412 */   GIM_Try, /*On fail goto*//*Label 15964*/ GIMT_Encode4(1082489), // Rule ID 24162 //
     /* 1082417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1082420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1082428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1082431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1082434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082456 */     // MIs[0] policy
     /* 1082456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082466 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082488 */     // GIR_Coverage, 24162,
     /* 1082488 */     GIR_EraseRootFromParent_Done,
     /* 1082489 */   // Label 15964: @1082489
     /* 1082489 */   GIM_Try, /*On fail goto*//*Label 15965*/ GIMT_Encode4(1082566), // Rule ID 24163 //
     /* 1082494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1082497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1082505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1082508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1082511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082533 */     // MIs[0] policy
     /* 1082533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082543 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082565 */     // GIR_Coverage, 24163,
     /* 1082565 */     GIR_EraseRootFromParent_Done,
     /* 1082566 */   // Label 15965: @1082566
     /* 1082566 */   GIM_Try, /*On fail goto*//*Label 15966*/ GIMT_Encode4(1082643), // Rule ID 24166 //
     /* 1082571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1082582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1082585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1082588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082610 */     // MIs[0] policy
     /* 1082610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082620 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1082623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082642 */     // GIR_Coverage, 24166,
     /* 1082642 */     GIR_EraseRootFromParent_Done,
     /* 1082643 */   // Label 15966: @1082643
     /* 1082643 */   GIM_Try, /*On fail goto*//*Label 15967*/ GIMT_Encode4(1082720), // Rule ID 24167 //
     /* 1082648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1082659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1082662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1082665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082687 */     // MIs[0] policy
     /* 1082687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082697 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1082700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082719 */     // GIR_Coverage, 24167,
     /* 1082719 */     GIR_EraseRootFromParent_Done,
     /* 1082720 */   // Label 15967: @1082720
     /* 1082720 */   GIM_Try, /*On fail goto*//*Label 15968*/ GIMT_Encode4(1082797), // Rule ID 24170 //
     /* 1082725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1082736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1082739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1082742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082764 */     // MIs[0] policy
     /* 1082764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082774 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1082777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082796 */     // GIR_Coverage, 24170,
     /* 1082796 */     GIR_EraseRootFromParent_Done,
     /* 1082797 */   // Label 15968: @1082797
     /* 1082797 */   GIM_Try, /*On fail goto*//*Label 15969*/ GIMT_Encode4(1082874), // Rule ID 24171 //
     /* 1082802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1082813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1082816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1082819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082841 */     // MIs[0] policy
     /* 1082841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082851 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1082854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082873 */     // GIR_Coverage, 24171,
     /* 1082873 */     GIR_EraseRootFromParent_Done,
     /* 1082874 */   // Label 15969: @1082874
     /* 1082874 */   GIM_Try, /*On fail goto*//*Label 15970*/ GIMT_Encode4(1082951), // Rule ID 24174 //
     /* 1082879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1082890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1082893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1082896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082918 */     // MIs[0] policy
     /* 1082918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082928 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1082931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082950 */     // GIR_Coverage, 24174,
     /* 1082950 */     GIR_EraseRootFromParent_Done,
     /* 1082951 */   // Label 15970: @1082951
     /* 1082951 */   GIM_Try, /*On fail goto*//*Label 15971*/ GIMT_Encode4(1083028), // Rule ID 24175 //
     /* 1082956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1082967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1082970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1082973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082995 */     // MIs[0] policy
     /* 1082995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083005 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083027 */     // GIR_Coverage, 24175,
     /* 1083027 */     GIR_EraseRootFromParent_Done,
     /* 1083028 */   // Label 15971: @1083028
     /* 1083028 */   GIM_Try, /*On fail goto*//*Label 15972*/ GIMT_Encode4(1083105), // Rule ID 24178 //
     /* 1083033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1083044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1083047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1083050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083072 */     // MIs[0] policy
     /* 1083072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083082 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083104 */     // GIR_Coverage, 24178,
     /* 1083104 */     GIR_EraseRootFromParent_Done,
     /* 1083105 */   // Label 15972: @1083105
     /* 1083105 */   GIM_Try, /*On fail goto*//*Label 15973*/ GIMT_Encode4(1083182), // Rule ID 24179 //
     /* 1083110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1083121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1083124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1083127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083149 */     // MIs[0] policy
     /* 1083149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083159 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083181 */     // GIR_Coverage, 24179,
     /* 1083181 */     GIR_EraseRootFromParent_Done,
     /* 1083182 */   // Label 15973: @1083182
     /* 1083182 */   GIM_Try, /*On fail goto*//*Label 15974*/ GIMT_Encode4(1083259), // Rule ID 24182 //
     /* 1083187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1083198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1083201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1083204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083226 */     // MIs[0] policy
     /* 1083226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083236 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083258 */     // GIR_Coverage, 24182,
     /* 1083258 */     GIR_EraseRootFromParent_Done,
     /* 1083259 */   // Label 15974: @1083259
     /* 1083259 */   GIM_Try, /*On fail goto*//*Label 15975*/ GIMT_Encode4(1083336), // Rule ID 24183 //
     /* 1083264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1083275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1083278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1083281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083303 */     // MIs[0] policy
     /* 1083303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083313 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083335 */     // GIR_Coverage, 24183,
     /* 1083335 */     GIR_EraseRootFromParent_Done,
     /* 1083336 */   // Label 15975: @1083336
     /* 1083336 */   GIM_Try, /*On fail goto*//*Label 15976*/ GIMT_Encode4(1083413), // Rule ID 24186 //
     /* 1083341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1083352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1083355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1083358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083380 */     // MIs[0] policy
     /* 1083380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083390 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083412 */     // GIR_Coverage, 24186,
     /* 1083412 */     GIR_EraseRootFromParent_Done,
     /* 1083413 */   // Label 15976: @1083413
     /* 1083413 */   GIM_Try, /*On fail goto*//*Label 15977*/ GIMT_Encode4(1083490), // Rule ID 24187 //
     /* 1083418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1083429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1083432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1083435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083457 */     // MIs[0] policy
     /* 1083457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083467 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083489 */     // GIR_Coverage, 24187,
     /* 1083489 */     GIR_EraseRootFromParent_Done,
     /* 1083490 */   // Label 15977: @1083490
     /* 1083490 */   GIM_Try, /*On fail goto*//*Label 15978*/ GIMT_Encode4(1083567), // Rule ID 24190 //
     /* 1083495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1083498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1083506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1083509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1083512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083534 */     // MIs[0] policy
     /* 1083534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083544 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083566 */     // GIR_Coverage, 24190,
     /* 1083566 */     GIR_EraseRootFromParent_Done,
     /* 1083567 */   // Label 15978: @1083567
     /* 1083567 */   GIM_Try, /*On fail goto*//*Label 15979*/ GIMT_Encode4(1083644), // Rule ID 24191 //
     /* 1083572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1083575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1083583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1083586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1083589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083611 */     // MIs[0] policy
     /* 1083611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083621 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11565:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083643 */     // GIR_Coverage, 24191,
     /* 1083643 */     GIR_EraseRootFromParent_Done,
     /* 1083644 */   // Label 15979: @1083644
     /* 1083644 */   GIM_Try, /*On fail goto*//*Label 15980*/ GIMT_Encode4(1083721), // Rule ID 24194 //
     /* 1083649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1083652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1083660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1083663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1083666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083688 */     // MIs[0] policy
     /* 1083688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083698 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083720 */     // GIR_Coverage, 24194,
     /* 1083720 */     GIR_EraseRootFromParent_Done,
     /* 1083721 */   // Label 15980: @1083721
     /* 1083721 */   GIM_Try, /*On fail goto*//*Label 15981*/ GIMT_Encode4(1083798), // Rule ID 24195 //
     /* 1083726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1083729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1083737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1083740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1083743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083765 */     // MIs[0] policy
     /* 1083765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083775 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11565:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083797 */     // GIR_Coverage, 24195,
     /* 1083797 */     GIR_EraseRootFromParent_Done,
     /* 1083798 */   // Label 15981: @1083798
     /* 1083798 */   GIM_Try, /*On fail goto*//*Label 15982*/ GIMT_Encode4(1083875), // Rule ID 24198 //
     /* 1083803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1083806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1083814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1083817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1083820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083842 */     // MIs[0] policy
     /* 1083842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083852 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083874 */     // GIR_Coverage, 24198,
     /* 1083874 */     GIR_EraseRootFromParent_Done,
     /* 1083875 */   // Label 15982: @1083875
     /* 1083875 */   GIM_Try, /*On fail goto*//*Label 15983*/ GIMT_Encode4(1083952), // Rule ID 24199 //
     /* 1083880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1083883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1083891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1083894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1083897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083919 */     // MIs[0] policy
     /* 1083919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083929 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11565:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083951 */     // GIR_Coverage, 24199,
     /* 1083951 */     GIR_EraseRootFromParent_Done,
     /* 1083952 */   // Label 15983: @1083952
     /* 1083952 */   GIM_Try, /*On fail goto*//*Label 15984*/ GIMT_Encode4(1084029), // Rule ID 24262 //
     /* 1083957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1083968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1083971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1083974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083996 */     // MIs[0] policy
     /* 1083996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084006 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1084009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084028 */     // GIR_Coverage, 24262,
     /* 1084028 */     GIR_EraseRootFromParent_Done,
     /* 1084029 */   // Label 15984: @1084029
     /* 1084029 */   GIM_Try, /*On fail goto*//*Label 15985*/ GIMT_Encode4(1084106), // Rule ID 24263 //
     /* 1084034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1084045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1084048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1084051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084073 */     // MIs[0] policy
     /* 1084073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084083 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1084086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084105 */     // GIR_Coverage, 24263,
     /* 1084105 */     GIR_EraseRootFromParent_Done,
     /* 1084106 */   // Label 15985: @1084106
     /* 1084106 */   GIM_Try, /*On fail goto*//*Label 15986*/ GIMT_Encode4(1084183), // Rule ID 24266 //
     /* 1084111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1084122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1084125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1084128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084150 */     // MIs[0] policy
     /* 1084150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084160 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084182 */     // GIR_Coverage, 24266,
     /* 1084182 */     GIR_EraseRootFromParent_Done,
     /* 1084183 */   // Label 15986: @1084183
     /* 1084183 */   GIM_Try, /*On fail goto*//*Label 15987*/ GIMT_Encode4(1084260), // Rule ID 24267 //
     /* 1084188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1084199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1084202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1084205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084227 */     // MIs[0] policy
     /* 1084227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084237 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084259 */     // GIR_Coverage, 24267,
     /* 1084259 */     GIR_EraseRootFromParent_Done,
     /* 1084260 */   // Label 15987: @1084260
     /* 1084260 */   GIM_Try, /*On fail goto*//*Label 15988*/ GIMT_Encode4(1084337), // Rule ID 24270 //
     /* 1084265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1084276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1084279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1084282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084304 */     // MIs[0] policy
     /* 1084304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084314 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084336 */     // GIR_Coverage, 24270,
     /* 1084336 */     GIR_EraseRootFromParent_Done,
     /* 1084337 */   // Label 15988: @1084337
     /* 1084337 */   GIM_Try, /*On fail goto*//*Label 15989*/ GIMT_Encode4(1084414), // Rule ID 24271 //
     /* 1084342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1084353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1084356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1084359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084381 */     // MIs[0] policy
     /* 1084381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084391 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084413 */     // GIR_Coverage, 24271,
     /* 1084413 */     GIR_EraseRootFromParent_Done,
     /* 1084414 */   // Label 15989: @1084414
     /* 1084414 */   GIM_Try, /*On fail goto*//*Label 15990*/ GIMT_Encode4(1084491), // Rule ID 24274 //
     /* 1084419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1084430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1084433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1084436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084458 */     // MIs[0] policy
     /* 1084458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084468 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084490 */     // GIR_Coverage, 24274,
     /* 1084490 */     GIR_EraseRootFromParent_Done,
     /* 1084491 */   // Label 15990: @1084491
     /* 1084491 */   GIM_Try, /*On fail goto*//*Label 15991*/ GIMT_Encode4(1084568), // Rule ID 24275 //
     /* 1084496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1084507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1084510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1084513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084535 */     // MIs[0] policy
     /* 1084535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084545 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084567 */     // GIR_Coverage, 24275,
     /* 1084567 */     GIR_EraseRootFromParent_Done,
     /* 1084568 */   // Label 15991: @1084568
     /* 1084568 */   GIM_Try, /*On fail goto*//*Label 15992*/ GIMT_Encode4(1084645), // Rule ID 24278 //
     /* 1084573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1084584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1084587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1084590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084612 */     // MIs[0] policy
     /* 1084612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084622 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084644 */     // GIR_Coverage, 24278,
     /* 1084644 */     GIR_EraseRootFromParent_Done,
     /* 1084645 */   // Label 15992: @1084645
     /* 1084645 */   GIM_Try, /*On fail goto*//*Label 15993*/ GIMT_Encode4(1084722), // Rule ID 24279 //
     /* 1084650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1084661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1084664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1084667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084689 */     // MIs[0] policy
     /* 1084689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084699 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084721 */     // GIR_Coverage, 24279,
     /* 1084721 */     GIR_EraseRootFromParent_Done,
     /* 1084722 */   // Label 15993: @1084722
     /* 1084722 */   GIM_Try, /*On fail goto*//*Label 15994*/ GIMT_Encode4(1084799), // Rule ID 24282 //
     /* 1084727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1084730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1084738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1084741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1084744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084766 */     // MIs[0] policy
     /* 1084766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084776 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084798 */     // GIR_Coverage, 24282,
     /* 1084798 */     GIR_EraseRootFromParent_Done,
     /* 1084799 */   // Label 15994: @1084799
     /* 1084799 */   GIM_Try, /*On fail goto*//*Label 15995*/ GIMT_Encode4(1084876), // Rule ID 24283 //
     /* 1084804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1084807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1084815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1084818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1084821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084843 */     // MIs[0] policy
     /* 1084843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084853 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084875 */     // GIR_Coverage, 24283,
     /* 1084875 */     GIR_EraseRootFromParent_Done,
     /* 1084876 */   // Label 15995: @1084876
     /* 1084876 */   GIM_Try, /*On fail goto*//*Label 15996*/ GIMT_Encode4(1084953), // Rule ID 24286 //
     /* 1084881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1084892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1084895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1084898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084920 */     // MIs[0] policy
     /* 1084920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084930 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084952 */     // GIR_Coverage, 24286,
     /* 1084952 */     GIR_EraseRootFromParent_Done,
     /* 1084953 */   // Label 15996: @1084953
     /* 1084953 */   GIM_Try, /*On fail goto*//*Label 15997*/ GIMT_Encode4(1085030), // Rule ID 24287 //
     /* 1084958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1084969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1084972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1084975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084997 */     // MIs[0] policy
     /* 1084997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085007 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085029 */     // GIR_Coverage, 24287,
     /* 1085029 */     GIR_EraseRootFromParent_Done,
     /* 1085030 */   // Label 15997: @1085030
     /* 1085030 */   GIM_Try, /*On fail goto*//*Label 15998*/ GIMT_Encode4(1085107), // Rule ID 24290 //
     /* 1085035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1085046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1085049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1085052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085074 */     // MIs[0] policy
     /* 1085074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085084 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085106 */     // GIR_Coverage, 24290,
     /* 1085106 */     GIR_EraseRootFromParent_Done,
     /* 1085107 */   // Label 15998: @1085107
     /* 1085107 */   GIM_Try, /*On fail goto*//*Label 15999*/ GIMT_Encode4(1085184), // Rule ID 24291 //
     /* 1085112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1085123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1085126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1085129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085151 */     // MIs[0] policy
     /* 1085151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085161 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085183 */     // GIR_Coverage, 24291,
     /* 1085183 */     GIR_EraseRootFromParent_Done,
     /* 1085184 */   // Label 15999: @1085184
     /* 1085184 */   GIM_Try, /*On fail goto*//*Label 16000*/ GIMT_Encode4(1085261), // Rule ID 24294 //
     /* 1085189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1085200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1085203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1085206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085228 */     // MIs[0] policy
     /* 1085228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085238 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085260 */     // GIR_Coverage, 24294,
     /* 1085260 */     GIR_EraseRootFromParent_Done,
     /* 1085261 */   // Label 16000: @1085261
     /* 1085261 */   GIM_Try, /*On fail goto*//*Label 16001*/ GIMT_Encode4(1085338), // Rule ID 24295 //
     /* 1085266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1085277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1085280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1085283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085305 */     // MIs[0] policy
     /* 1085305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085315 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085337 */     // GIR_Coverage, 24295,
     /* 1085337 */     GIR_EraseRootFromParent_Done,
     /* 1085338 */   // Label 16001: @1085338
     /* 1085338 */   GIM_Try, /*On fail goto*//*Label 16002*/ GIMT_Encode4(1085415), // Rule ID 24298 //
     /* 1085343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1085354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1085357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1085360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085382 */     // MIs[0] policy
     /* 1085382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085392 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085414 */     // GIR_Coverage, 24298,
     /* 1085414 */     GIR_EraseRootFromParent_Done,
     /* 1085415 */   // Label 16002: @1085415
     /* 1085415 */   GIM_Try, /*On fail goto*//*Label 16003*/ GIMT_Encode4(1085492), // Rule ID 24299 //
     /* 1085420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1085431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1085434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1085437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085459 */     // MIs[0] policy
     /* 1085459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085469 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085491 */     // GIR_Coverage, 24299,
     /* 1085491 */     GIR_EraseRootFromParent_Done,
     /* 1085492 */   // Label 16003: @1085492
     /* 1085492 */   GIM_Try, /*On fail goto*//*Label 16004*/ GIMT_Encode4(1085569), // Rule ID 24302 //
     /* 1085497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1085508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1085511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1085514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085536 */     // MIs[0] policy
     /* 1085536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085546 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085568 */     // GIR_Coverage, 24302,
     /* 1085568 */     GIR_EraseRootFromParent_Done,
     /* 1085569 */   // Label 16004: @1085569
     /* 1085569 */   GIM_Try, /*On fail goto*//*Label 16005*/ GIMT_Encode4(1085646), // Rule ID 24303 //
     /* 1085574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1085585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1085588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1085591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085613 */     // MIs[0] policy
     /* 1085613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085623 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085645 */     // GIR_Coverage, 24303,
     /* 1085645 */     GIR_EraseRootFromParent_Done,
     /* 1085646 */   // Label 16005: @1085646
     /* 1085646 */   GIM_Try, /*On fail goto*//*Label 16006*/ GIMT_Encode4(1085723), // Rule ID 24306 //
     /* 1085651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1085662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1085665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1085668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085690 */     // MIs[0] policy
     /* 1085690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085700 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085722 */     // GIR_Coverage, 24306,
     /* 1085722 */     GIR_EraseRootFromParent_Done,
     /* 1085723 */   // Label 16006: @1085723
     /* 1085723 */   GIM_Try, /*On fail goto*//*Label 16007*/ GIMT_Encode4(1085800), // Rule ID 24307 //
     /* 1085728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1085739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1085742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1085745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085767 */     // MIs[0] policy
     /* 1085767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085777 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085799 */     // GIR_Coverage, 24307,
     /* 1085799 */     GIR_EraseRootFromParent_Done,
     /* 1085800 */   // Label 16007: @1085800
     /* 1085800 */   GIM_Try, /*On fail goto*//*Label 16008*/ GIMT_Encode4(1085877), // Rule ID 24310 //
     /* 1085805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1085808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1085816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1085819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1085822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085844 */     // MIs[0] policy
     /* 1085844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085854 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085876 */     // GIR_Coverage, 24310,
     /* 1085876 */     GIR_EraseRootFromParent_Done,
     /* 1085877 */   // Label 16008: @1085877
     /* 1085877 */   GIM_Try, /*On fail goto*//*Label 16009*/ GIMT_Encode4(1085954), // Rule ID 24311 //
     /* 1085882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1085885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1085893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1085896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1085899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085921 */     // MIs[0] policy
     /* 1085921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085931 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11563:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085953 */     // GIR_Coverage, 24311,
     /* 1085953 */     GIR_EraseRootFromParent_Done,
     /* 1085954 */   // Label 16009: @1085954
     /* 1085954 */   GIM_Try, /*On fail goto*//*Label 16010*/ GIMT_Encode4(1086031), // Rule ID 24314 //
     /* 1085959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1085962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1085970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1085973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1085976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085998 */     // MIs[0] policy
     /* 1085998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086008 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1086011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086030 */     // GIR_Coverage, 24314,
     /* 1086030 */     GIR_EraseRootFromParent_Done,
     /* 1086031 */   // Label 16010: @1086031
     /* 1086031 */   GIM_Try, /*On fail goto*//*Label 16011*/ GIMT_Encode4(1086108), // Rule ID 24315 //
     /* 1086036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1086039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1086047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1086050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1086053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086075 */     // MIs[0] policy
     /* 1086075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086085 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11563:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1086088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086107 */     // GIR_Coverage, 24315,
     /* 1086107 */     GIR_EraseRootFromParent_Done,
     /* 1086108 */   // Label 16011: @1086108
     /* 1086108 */   GIM_Try, /*On fail goto*//*Label 16012*/ GIMT_Encode4(1086185), // Rule ID 24318 //
     /* 1086113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1086116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1086124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1086127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1086130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086152 */     // MIs[0] policy
     /* 1086152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086162 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1086165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086184 */     // GIR_Coverage, 24318,
     /* 1086184 */     GIR_EraseRootFromParent_Done,
     /* 1086185 */   // Label 16012: @1086185
     /* 1086185 */   GIM_Try, /*On fail goto*//*Label 16013*/ GIMT_Encode4(1086262), // Rule ID 24319 //
     /* 1086190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1086193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1086201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1086204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1086207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086229 */     // MIs[0] policy
     /* 1086229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086239 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11563:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1086242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086261 */     // GIR_Coverage, 24319,
     /* 1086261 */     GIR_EraseRootFromParent_Done,
     /* 1086262 */   // Label 16013: @1086262
     /* 1086262 */   GIM_Try, /*On fail goto*//*Label 16014*/ GIMT_Encode4(1086339), // Rule ID 60610 //
     /* 1086267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1086270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1086275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1086278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1086281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1086284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1086287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086306 */     // MIs[0] policy
     /* 1086306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086316 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1086319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1086321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086338 */     // GIR_Coverage, 60610,
     /* 1086338 */     GIR_EraseRootFromParent_Done,
     /* 1086339 */   // Label 16014: @1086339
     /* 1086339 */   GIM_Try, /*On fail goto*//*Label 16015*/ GIMT_Encode4(1086416), // Rule ID 60611 //
     /* 1086344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1086347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1086352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1086355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1086358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1086361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1086364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086383 */     // MIs[0] policy
     /* 1086383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086393 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1086396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1086398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086415 */     // GIR_Coverage, 60611,
     /* 1086415 */     GIR_EraseRootFromParent_Done,
     /* 1086416 */   // Label 16015: @1086416
     /* 1086416 */   GIM_Try, /*On fail goto*//*Label 16016*/ GIMT_Encode4(1086493), // Rule ID 60624 //
     /* 1086421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1086432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1086435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1086438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086460 */     // MIs[0] policy
     /* 1086460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086470 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1086473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086492 */     // GIR_Coverage, 60624,
     /* 1086492 */     GIR_EraseRootFromParent_Done,
     /* 1086493 */   // Label 16016: @1086493
     /* 1086493 */   GIM_Try, /*On fail goto*//*Label 16017*/ GIMT_Encode4(1086570), // Rule ID 60625 //
     /* 1086498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1086509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1086512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1086515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086537 */     // MIs[0] policy
     /* 1086537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086547 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1086550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086556 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086569 */     // GIR_Coverage, 60625,
     /* 1086569 */     GIR_EraseRootFromParent_Done,
     /* 1086570 */   // Label 16017: @1086570
     /* 1086570 */   GIM_Try, /*On fail goto*//*Label 16018*/ GIMT_Encode4(1086647), // Rule ID 60628 //
     /* 1086575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1086586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1086589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1086592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1086595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086614 */     // MIs[0] policy
     /* 1086614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086624 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1086627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086646 */     // GIR_Coverage, 60628,
     /* 1086646 */     GIR_EraseRootFromParent_Done,
     /* 1086647 */   // Label 16018: @1086647
     /* 1086647 */   GIM_Try, /*On fail goto*//*Label 16019*/ GIMT_Encode4(1086724), // Rule ID 60629 //
     /* 1086652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1086663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1086666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1086669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1086672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086691 */     // MIs[0] policy
     /* 1086691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086701 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1086704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086710 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086723 */     // GIR_Coverage, 60629,
     /* 1086723 */     GIR_EraseRootFromParent_Done,
     /* 1086724 */   // Label 16019: @1086724
     /* 1086724 */   GIM_Try, /*On fail goto*//*Label 16020*/ GIMT_Encode4(1086801), // Rule ID 60632 //
     /* 1086729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1086740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1086743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1086746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1086749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086768 */     // MIs[0] policy
     /* 1086768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086778 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1086781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086787 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086800 */     // GIR_Coverage, 60632,
     /* 1086800 */     GIR_EraseRootFromParent_Done,
     /* 1086801 */   // Label 16020: @1086801
     /* 1086801 */   GIM_Try, /*On fail goto*//*Label 16021*/ GIMT_Encode4(1086878), // Rule ID 60633 //
     /* 1086806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1086817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1086820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1086823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1086826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086845 */     // MIs[0] policy
     /* 1086845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086855 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1086858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086864 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086877 */     // GIR_Coverage, 60633,
     /* 1086877 */     GIR_EraseRootFromParent_Done,
     /* 1086878 */   // Label 16021: @1086878
     /* 1086878 */   GIM_Try, /*On fail goto*//*Label 16022*/ GIMT_Encode4(1086955), // Rule ID 60636 //
     /* 1086883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1086894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1086897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1086900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086922 */     // MIs[0] policy
     /* 1086922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086932 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1086935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086954 */     // GIR_Coverage, 60636,
     /* 1086954 */     GIR_EraseRootFromParent_Done,
     /* 1086955 */   // Label 16022: @1086955
     /* 1086955 */   GIM_Try, /*On fail goto*//*Label 16023*/ GIMT_Encode4(1087032), // Rule ID 60637 //
     /* 1086960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1086971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1086974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1086977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086999 */     // MIs[0] policy
     /* 1086999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087009 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1087012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087018 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087031 */     // GIR_Coverage, 60637,
     /* 1087031 */     GIR_EraseRootFromParent_Done,
     /* 1087032 */   // Label 16023: @1087032
     /* 1087032 */   GIM_Try, /*On fail goto*//*Label 16024*/ GIMT_Encode4(1087109), // Rule ID 60640 //
     /* 1087037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1087048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1087051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1087054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087076 */     // MIs[0] policy
     /* 1087076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087108 */     // GIR_Coverage, 60640,
     /* 1087108 */     GIR_EraseRootFromParent_Done,
     /* 1087109 */   // Label 16024: @1087109
     /* 1087109 */   GIM_Try, /*On fail goto*//*Label 16025*/ GIMT_Encode4(1087186), // Rule ID 60641 //
     /* 1087114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1087125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1087128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1087131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087153 */     // MIs[0] policy
     /* 1087153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087163 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087185 */     // GIR_Coverage, 60641,
     /* 1087185 */     GIR_EraseRootFromParent_Done,
     /* 1087186 */   // Label 16025: @1087186
     /* 1087186 */   GIM_Try, /*On fail goto*//*Label 16026*/ GIMT_Encode4(1087263), // Rule ID 60644 //
     /* 1087191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1087202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1087205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1087208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087230 */     // MIs[0] policy
     /* 1087230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087240 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087262 */     // GIR_Coverage, 60644,
     /* 1087262 */     GIR_EraseRootFromParent_Done,
     /* 1087263 */   // Label 16026: @1087263
     /* 1087263 */   GIM_Try, /*On fail goto*//*Label 16027*/ GIMT_Encode4(1087340), // Rule ID 60645 //
     /* 1087268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1087279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1087282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1087285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087307 */     // MIs[0] policy
     /* 1087307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087317 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087326 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087339 */     // GIR_Coverage, 60645,
     /* 1087339 */     GIR_EraseRootFromParent_Done,
     /* 1087340 */   // Label 16027: @1087340
     /* 1087340 */   GIM_Try, /*On fail goto*//*Label 16028*/ GIMT_Encode4(1087417), // Rule ID 60648 //
     /* 1087345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1087356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1087359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1087362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1087365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087384 */     // MIs[0] policy
     /* 1087384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087394 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087416 */     // GIR_Coverage, 60648,
     /* 1087416 */     GIR_EraseRootFromParent_Done,
     /* 1087417 */   // Label 16028: @1087417
     /* 1087417 */   GIM_Try, /*On fail goto*//*Label 16029*/ GIMT_Encode4(1087494), // Rule ID 60649 //
     /* 1087422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1087433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1087436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1087439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1087442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087461 */     // MIs[0] policy
     /* 1087461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087471 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087480 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087493 */     // GIR_Coverage, 60649,
     /* 1087493 */     GIR_EraseRootFromParent_Done,
     /* 1087494 */   // Label 16029: @1087494
     /* 1087494 */   GIM_Try, /*On fail goto*//*Label 16030*/ GIMT_Encode4(1087571), // Rule ID 60652 //
     /* 1087499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1087510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1087513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1087516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1087519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087538 */     // MIs[0] policy
     /* 1087538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087548 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087570 */     // GIR_Coverage, 60652,
     /* 1087570 */     GIR_EraseRootFromParent_Done,
     /* 1087571 */   // Label 16030: @1087571
     /* 1087571 */   GIM_Try, /*On fail goto*//*Label 16031*/ GIMT_Encode4(1087648), // Rule ID 60653 //
     /* 1087576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1087587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1087590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1087593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1087596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087615 */     // MIs[0] policy
     /* 1087615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087625 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087634 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087647 */     // GIR_Coverage, 60653,
     /* 1087647 */     GIR_EraseRootFromParent_Done,
     /* 1087648 */   // Label 16031: @1087648
     /* 1087648 */   GIM_Try, /*On fail goto*//*Label 16032*/ GIMT_Encode4(1087725), // Rule ID 60656 //
     /* 1087653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1087664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1087667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1087670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087692 */     // MIs[0] policy
     /* 1087692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087724 */     // GIR_Coverage, 60656,
     /* 1087724 */     GIR_EraseRootFromParent_Done,
     /* 1087725 */   // Label 16032: @1087725
     /* 1087725 */   GIM_Try, /*On fail goto*//*Label 16033*/ GIMT_Encode4(1087802), // Rule ID 60657 //
     /* 1087730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1087741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1087744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1087747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087769 */     // MIs[0] policy
     /* 1087769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087779 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087801 */     // GIR_Coverage, 60657,
     /* 1087801 */     GIR_EraseRootFromParent_Done,
     /* 1087802 */   // Label 16033: @1087802
     /* 1087802 */   GIM_Try, /*On fail goto*//*Label 16034*/ GIMT_Encode4(1087879), // Rule ID 60660 //
     /* 1087807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1087818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1087821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1087824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087846 */     // MIs[0] policy
     /* 1087846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087856 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087878 */     // GIR_Coverage, 60660,
     /* 1087878 */     GIR_EraseRootFromParent_Done,
     /* 1087879 */   // Label 16034: @1087879
     /* 1087879 */   GIM_Try, /*On fail goto*//*Label 16035*/ GIMT_Encode4(1087956), // Rule ID 60661 //
     /* 1087884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1087895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1087898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1087901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087923 */     // MIs[0] policy
     /* 1087923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087933 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087942 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087955 */     // GIR_Coverage, 60661,
     /* 1087955 */     GIR_EraseRootFromParent_Done,
     /* 1087956 */   // Label 16035: @1087956
     /* 1087956 */   GIM_Try, /*On fail goto*//*Label 16036*/ GIMT_Encode4(1088033), // Rule ID 60664 //
     /* 1087961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1087972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1087975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1087978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1087981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1087988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088000 */     // MIs[0] policy
     /* 1088000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088010 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088019 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088032 */     // GIR_Coverage, 60664,
     /* 1088032 */     GIR_EraseRootFromParent_Done,
     /* 1088033 */   // Label 16036: @1088033
     /* 1088033 */   GIM_Try, /*On fail goto*//*Label 16037*/ GIMT_Encode4(1088110), // Rule ID 60665 //
     /* 1088038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1088049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1088052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1088055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088077 */     // MIs[0] policy
     /* 1088077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088087 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088096 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088109 */     // GIR_Coverage, 60665,
     /* 1088109 */     GIR_EraseRootFromParent_Done,
     /* 1088110 */   // Label 16037: @1088110
     /* 1088110 */   GIM_Try, /*On fail goto*//*Label 16038*/ GIMT_Encode4(1088187), // Rule ID 60668 //
     /* 1088115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1088126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1088129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1088132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088154 */     // MIs[0] policy
     /* 1088154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088164 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088186 */     // GIR_Coverage, 60668,
     /* 1088186 */     GIR_EraseRootFromParent_Done,
     /* 1088187 */   // Label 16038: @1088187
     /* 1088187 */   GIM_Try, /*On fail goto*//*Label 16039*/ GIMT_Encode4(1088264), // Rule ID 60669 //
     /* 1088192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1088203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1088206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1088209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088231 */     // MIs[0] policy
     /* 1088231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088241 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088250 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088263 */     // GIR_Coverage, 60669,
     /* 1088263 */     GIR_EraseRootFromParent_Done,
     /* 1088264 */   // Label 16039: @1088264
     /* 1088264 */   GIM_Try, /*On fail goto*//*Label 16040*/ GIMT_Encode4(1088341), // Rule ID 60672 //
     /* 1088269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1088280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1088283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1088286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1088289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088308 */     // MIs[0] policy
     /* 1088308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088318 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088340 */     // GIR_Coverage, 60672,
     /* 1088340 */     GIR_EraseRootFromParent_Done,
     /* 1088341 */   // Label 16040: @1088341
     /* 1088341 */   GIM_Try, /*On fail goto*//*Label 16041*/ GIMT_Encode4(1088418), // Rule ID 60673 //
     /* 1088346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1088357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1088360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1088363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1088366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088385 */     // MIs[0] policy
     /* 1088385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088395 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088417 */     // GIR_Coverage, 60673,
     /* 1088417 */     GIR_EraseRootFromParent_Done,
     /* 1088418 */   // Label 16041: @1088418
     /* 1088418 */   GIM_Try, /*On fail goto*//*Label 16042*/ GIMT_Encode4(1088495), // Rule ID 60676 //
     /* 1088423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1088440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1088443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088462 */     // MIs[0] policy
     /* 1088462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088472 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088494 */     // GIR_Coverage, 60676,
     /* 1088494 */     GIR_EraseRootFromParent_Done,
     /* 1088495 */   // Label 16042: @1088495
     /* 1088495 */   GIM_Try, /*On fail goto*//*Label 16043*/ GIMT_Encode4(1088572), // Rule ID 60677 //
     /* 1088500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1088517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1088520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088539 */     // MIs[0] policy
     /* 1088539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088549 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088558 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088571 */     // GIR_Coverage, 60677,
     /* 1088571 */     GIR_EraseRootFromParent_Done,
     /* 1088572 */   // Label 16043: @1088572
     /* 1088572 */   GIM_Try, /*On fail goto*//*Label 16044*/ GIMT_Encode4(1088649), // Rule ID 60680 //
     /* 1088577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1088588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1088591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1088594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088616 */     // MIs[0] policy
     /* 1088616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088648 */     // GIR_Coverage, 60680,
     /* 1088648 */     GIR_EraseRootFromParent_Done,
     /* 1088649 */   // Label 16044: @1088649
     /* 1088649 */   GIM_Try, /*On fail goto*//*Label 16045*/ GIMT_Encode4(1088726), // Rule ID 60681 //
     /* 1088654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1088665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1088668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1088671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088693 */     // MIs[0] policy
     /* 1088693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088703 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088712 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088725 */     // GIR_Coverage, 60681,
     /* 1088725 */     GIR_EraseRootFromParent_Done,
     /* 1088726 */   // Label 16045: @1088726
     /* 1088726 */   GIM_Try, /*On fail goto*//*Label 16046*/ GIMT_Encode4(1088803), // Rule ID 60684 //
     /* 1088731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1088742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1088745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1088748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088770 */     // MIs[0] policy
     /* 1088770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088780 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088802 */     // GIR_Coverage, 60684,
     /* 1088802 */     GIR_EraseRootFromParent_Done,
     /* 1088803 */   // Label 16046: @1088803
     /* 1088803 */   GIM_Try, /*On fail goto*//*Label 16047*/ GIMT_Encode4(1088880), // Rule ID 60685 //
     /* 1088808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1088819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1088822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1088825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088847 */     // MIs[0] policy
     /* 1088847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088857 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088866 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088879 */     // GIR_Coverage, 60685,
     /* 1088879 */     GIR_EraseRootFromParent_Done,
     /* 1088880 */   // Label 16047: @1088880
     /* 1088880 */   GIM_Try, /*On fail goto*//*Label 16048*/ GIMT_Encode4(1088957), // Rule ID 60688 //
     /* 1088885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1088896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1088899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1088902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1088905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088924 */     // MIs[0] policy
     /* 1088924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088956 */     // GIR_Coverage, 60688,
     /* 1088956 */     GIR_EraseRootFromParent_Done,
     /* 1088957 */   // Label 16048: @1088957
     /* 1088957 */   GIM_Try, /*On fail goto*//*Label 16049*/ GIMT_Encode4(1089034), // Rule ID 60689 //
     /* 1088962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1088973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1088976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1088979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1088982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089001 */     // MIs[0] policy
     /* 1089001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089011 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089033 */     // GIR_Coverage, 60689,
     /* 1089033 */     GIR_EraseRootFromParent_Done,
     /* 1089034 */   // Label 16049: @1089034
     /* 1089034 */   GIM_Try, /*On fail goto*//*Label 16050*/ GIMT_Encode4(1089111), // Rule ID 60692 //
     /* 1089039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1089056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089078 */     // MIs[0] policy
     /* 1089078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089088 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089110 */     // GIR_Coverage, 60692,
     /* 1089110 */     GIR_EraseRootFromParent_Done,
     /* 1089111 */   // Label 16050: @1089111
     /* 1089111 */   GIM_Try, /*On fail goto*//*Label 16051*/ GIMT_Encode4(1089188), // Rule ID 60693 //
     /* 1089116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1089133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089155 */     // MIs[0] policy
     /* 1089155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089165 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089174 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089187 */     // GIR_Coverage, 60693,
     /* 1089187 */     GIR_EraseRootFromParent_Done,
     /* 1089188 */   // Label 16051: @1089188
     /* 1089188 */   GIM_Try, /*On fail goto*//*Label 16052*/ GIMT_Encode4(1089265), // Rule ID 60696 //
     /* 1089193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1089204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1089207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1089210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1089213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089232 */     // MIs[0] policy
     /* 1089232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089242 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089264 */     // GIR_Coverage, 60696,
     /* 1089264 */     GIR_EraseRootFromParent_Done,
     /* 1089265 */   // Label 16052: @1089265
     /* 1089265 */   GIM_Try, /*On fail goto*//*Label 16053*/ GIMT_Encode4(1089342), // Rule ID 60697 //
     /* 1089270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1089281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1089284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1089287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1089290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089309 */     // MIs[0] policy
     /* 1089309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089319 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089328 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089341 */     // GIR_Coverage, 60697,
     /* 1089341 */     GIR_EraseRootFromParent_Done,
     /* 1089342 */   // Label 16053: @1089342
     /* 1089342 */   GIM_Try, /*On fail goto*//*Label 16054*/ GIMT_Encode4(1089419), // Rule ID 60700 //
     /* 1089347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1089358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1089361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1089367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1089374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089386 */     // MIs[0] policy
     /* 1089386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089396 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089418 */     // GIR_Coverage, 60700,
     /* 1089418 */     GIR_EraseRootFromParent_Done,
     /* 1089419 */   // Label 16054: @1089419
     /* 1089419 */   GIM_Try, /*On fail goto*//*Label 16055*/ GIMT_Encode4(1089496), // Rule ID 60701 //
     /* 1089424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1089435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1089438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1089444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1089451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089463 */     // MIs[0] policy
     /* 1089463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089473 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089495 */     // GIR_Coverage, 60701,
     /* 1089495 */     GIR_EraseRootFromParent_Done,
     /* 1089496 */   // Label 16055: @1089496
     /* 1089496 */   GIM_Try, /*On fail goto*//*Label 16056*/ GIMT_Encode4(1089573), // Rule ID 60704 //
     /* 1089501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1089512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1089515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1089518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089540 */     // MIs[0] policy
     /* 1089540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089550 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089572 */     // GIR_Coverage, 60704,
     /* 1089572 */     GIR_EraseRootFromParent_Done,
     /* 1089573 */   // Label 16056: @1089573
     /* 1089573 */   GIM_Try, /*On fail goto*//*Label 16057*/ GIMT_Encode4(1089650), // Rule ID 60705 //
     /* 1089578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1089589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1089592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1089595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089617 */     // MIs[0] policy
     /* 1089617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089627 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089636 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089649 */     // GIR_Coverage, 60705,
     /* 1089649 */     GIR_EraseRootFromParent_Done,
     /* 1089650 */   // Label 16057: @1089650
     /* 1089650 */   GIM_Try, /*On fail goto*//*Label 16058*/ GIMT_Encode4(1089727), // Rule ID 60708 //
     /* 1089655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1089666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1089669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1089672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089694 */     // MIs[0] policy
     /* 1089694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089704 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089726 */     // GIR_Coverage, 60708,
     /* 1089726 */     GIR_EraseRootFromParent_Done,
     /* 1089727 */   // Label 16058: @1089727
     /* 1089727 */   GIM_Try, /*On fail goto*//*Label 16059*/ GIMT_Encode4(1089804), // Rule ID 60709 //
     /* 1089732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1089743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1089746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1089749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089771 */     // MIs[0] policy
     /* 1089771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089781 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089790 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089803 */     // GIR_Coverage, 60709,
     /* 1089803 */     GIR_EraseRootFromParent_Done,
     /* 1089804 */   // Label 16059: @1089804
     /* 1089804 */   GIM_Try, /*On fail goto*//*Label 16060*/ GIMT_Encode4(1089881), // Rule ID 60712 //
     /* 1089809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1089820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1089823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1089826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1089829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089848 */     // MIs[0] policy
     /* 1089848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089858 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1089861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1089877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089880 */     // GIR_Coverage, 60712,
     /* 1089880 */     GIR_EraseRootFromParent_Done,
     /* 1089881 */   // Label 16060: @1089881
     /* 1089881 */   GIM_Try, /*On fail goto*//*Label 16061*/ GIMT_Encode4(1089958), // Rule ID 60713 //
     /* 1089886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1089897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1089900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1089903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1089906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089925 */     // MIs[0] policy
     /* 1089925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089935 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1089938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089944 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1089954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089957 */     // GIR_Coverage, 60713,
     /* 1089957 */     GIR_EraseRootFromParent_Done,
     /* 1089958 */   // Label 16061: @1089958
     /* 1089958 */   GIM_Try, /*On fail goto*//*Label 16062*/ GIMT_Encode4(1090035), // Rule ID 60716 //
     /* 1089963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1089974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1089977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1089980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1089983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090002 */     // MIs[0] policy
     /* 1090002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090012 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090034 */     // GIR_Coverage, 60716,
     /* 1090034 */     GIR_EraseRootFromParent_Done,
     /* 1090035 */   // Label 16062: @1090035
     /* 1090035 */   GIM_Try, /*On fail goto*//*Label 16063*/ GIMT_Encode4(1090112), // Rule ID 60717 //
     /* 1090040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1090051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1090054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1090057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090079 */     // MIs[0] policy
     /* 1090079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090089 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090098 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090111 */     // GIR_Coverage, 60717,
     /* 1090111 */     GIR_EraseRootFromParent_Done,
     /* 1090112 */   // Label 16063: @1090112
     /* 1090112 */   GIM_Try, /*On fail goto*//*Label 16064*/ GIMT_Encode4(1090189), // Rule ID 60720 //
     /* 1090117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1090128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1090131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1090134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090156 */     // MIs[0] policy
     /* 1090156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090166 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090188 */     // GIR_Coverage, 60720,
     /* 1090188 */     GIR_EraseRootFromParent_Done,
     /* 1090189 */   // Label 16064: @1090189
     /* 1090189 */   GIM_Try, /*On fail goto*//*Label 16065*/ GIMT_Encode4(1090266), // Rule ID 60721 //
     /* 1090194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1090205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1090208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1090211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090233 */     // MIs[0] policy
     /* 1090233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090243 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090252 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090265 */     // GIR_Coverage, 60721,
     /* 1090265 */     GIR_EraseRootFromParent_Done,
     /* 1090266 */   // Label 16065: @1090266
     /* 1090266 */   GIM_Try, /*On fail goto*//*Label 16066*/ GIMT_Encode4(1090343), // Rule ID 60724 //
     /* 1090271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1090282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1090285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1090288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090310 */     // MIs[0] policy
     /* 1090310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090320 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090342 */     // GIR_Coverage, 60724,
     /* 1090342 */     GIR_EraseRootFromParent_Done,
     /* 1090343 */   // Label 16066: @1090343
     /* 1090343 */   GIM_Try, /*On fail goto*//*Label 16067*/ GIMT_Encode4(1090420), // Rule ID 60725 //
     /* 1090348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1090359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1090362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1090365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090387 */     // MIs[0] policy
     /* 1090387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090397 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090406 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090419 */     // GIR_Coverage, 60725,
     /* 1090419 */     GIR_EraseRootFromParent_Done,
     /* 1090420 */   // Label 16067: @1090420
     /* 1090420 */   GIM_Try, /*On fail goto*//*Label 16068*/ GIMT_Encode4(1090497), // Rule ID 60728 //
     /* 1090425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1090436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1090439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1090442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090464 */     // MIs[0] policy
     /* 1090464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090474 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090496 */     // GIR_Coverage, 60728,
     /* 1090496 */     GIR_EraseRootFromParent_Done,
     /* 1090497 */   // Label 16068: @1090497
     /* 1090497 */   GIM_Try, /*On fail goto*//*Label 16069*/ GIMT_Encode4(1090574), // Rule ID 60729 //
     /* 1090502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1090513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1090516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1090519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090541 */     // MIs[0] policy
     /* 1090541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090551 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090560 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090573 */     // GIR_Coverage, 60729,
     /* 1090573 */     GIR_EraseRootFromParent_Done,
     /* 1090574 */   // Label 16069: @1090574
     /* 1090574 */   GIM_Try, /*On fail goto*//*Label 16070*/ GIMT_Encode4(1090651), // Rule ID 60732 //
     /* 1090579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1090590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1090593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1090596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090618 */     // MIs[0] policy
     /* 1090618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090628 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090650 */     // GIR_Coverage, 60732,
     /* 1090650 */     GIR_EraseRootFromParent_Done,
     /* 1090651 */   // Label 16070: @1090651
     /* 1090651 */   GIM_Try, /*On fail goto*//*Label 16071*/ GIMT_Encode4(1090728), // Rule ID 60733 //
     /* 1090656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1090667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1090670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1090673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090695 */     // MIs[0] policy
     /* 1090695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090705 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090714 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090727 */     // GIR_Coverage, 60733,
     /* 1090727 */     GIR_EraseRootFromParent_Done,
     /* 1090728 */   // Label 16071: @1090728
     /* 1090728 */   GIM_Try, /*On fail goto*//*Label 16072*/ GIMT_Encode4(1090805), // Rule ID 60736 //
     /* 1090733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1090744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1090747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1090750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1090753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090772 */     // MIs[0] policy
     /* 1090772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090782 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090804 */     // GIR_Coverage, 60736,
     /* 1090804 */     GIR_EraseRootFromParent_Done,
     /* 1090805 */   // Label 16072: @1090805
     /* 1090805 */   GIM_Try, /*On fail goto*//*Label 16073*/ GIMT_Encode4(1090882), // Rule ID 60737 //
     /* 1090810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1090821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1090824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1090827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1090830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090849 */     // MIs[0] policy
     /* 1090849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090859 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090881 */     // GIR_Coverage, 60737,
     /* 1090881 */     GIR_EraseRootFromParent_Done,
     /* 1090882 */   // Label 16073: @1090882
     /* 1090882 */   GIM_Try, /*On fail goto*//*Label 16074*/ GIMT_Encode4(1090959), // Rule ID 60740 //
     /* 1090887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1090898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1090901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1090904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090926 */     // MIs[0] policy
     /* 1090926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090936 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090958 */     // GIR_Coverage, 60740,
     /* 1090958 */     GIR_EraseRootFromParent_Done,
     /* 1090959 */   // Label 16074: @1090959
     /* 1090959 */   GIM_Try, /*On fail goto*//*Label 16075*/ GIMT_Encode4(1091036), // Rule ID 60741 //
     /* 1090964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1090975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1090978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1090981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091003 */     // MIs[0] policy
     /* 1091003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091013 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091022 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091035 */     // GIR_Coverage, 60741,
     /* 1091035 */     GIR_EraseRootFromParent_Done,
     /* 1091036 */   // Label 16075: @1091036
     /* 1091036 */   GIM_Try, /*On fail goto*//*Label 16076*/ GIMT_Encode4(1091113), // Rule ID 60744 //
     /* 1091041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1091052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1091055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1091058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1091061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091080 */     // MIs[0] policy
     /* 1091080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091090 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091112 */     // GIR_Coverage, 60744,
     /* 1091112 */     GIR_EraseRootFromParent_Done,
     /* 1091113 */   // Label 16076: @1091113
     /* 1091113 */   GIM_Try, /*On fail goto*//*Label 16077*/ GIMT_Encode4(1091190), // Rule ID 60745 //
     /* 1091118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1091129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1091132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1091135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1091138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091157 */     // MIs[0] policy
     /* 1091157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091167 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091176 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091189 */     // GIR_Coverage, 60745,
     /* 1091189 */     GIR_EraseRootFromParent_Done,
     /* 1091190 */   // Label 16077: @1091190
     /* 1091190 */   GIM_Try, /*On fail goto*//*Label 16078*/ GIMT_Encode4(1091267), // Rule ID 60748 //
     /* 1091195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1091206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1091209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1091212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091234 */     // MIs[0] policy
     /* 1091234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091244 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091266 */     // GIR_Coverage, 60748,
     /* 1091266 */     GIR_EraseRootFromParent_Done,
     /* 1091267 */   // Label 16078: @1091267
     /* 1091267 */   GIM_Try, /*On fail goto*//*Label 16079*/ GIMT_Encode4(1091344), // Rule ID 60749 //
     /* 1091272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1091283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1091286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1091289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091311 */     // MIs[0] policy
     /* 1091311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091321 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091330 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091343 */     // GIR_Coverage, 60749,
     /* 1091343 */     GIR_EraseRootFromParent_Done,
     /* 1091344 */   // Label 16079: @1091344
     /* 1091344 */   GIM_Try, /*On fail goto*//*Label 16080*/ GIMT_Encode4(1091421), // Rule ID 60752 //
     /* 1091349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1091360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1091363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1091366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091388 */     // MIs[0] policy
     /* 1091388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091420 */     // GIR_Coverage, 60752,
     /* 1091420 */     GIR_EraseRootFromParent_Done,
     /* 1091421 */   // Label 16080: @1091421
     /* 1091421 */   GIM_Try, /*On fail goto*//*Label 16081*/ GIMT_Encode4(1091498), // Rule ID 60753 //
     /* 1091426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1091437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1091440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1091443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091465 */     // MIs[0] policy
     /* 1091465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091475 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091484 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091497 */     // GIR_Coverage, 60753,
     /* 1091497 */     GIR_EraseRootFromParent_Done,
     /* 1091498 */   // Label 16081: @1091498
     /* 1091498 */   GIM_Try, /*On fail goto*//*Label 16082*/ GIMT_Encode4(1091575), // Rule ID 60756 //
     /* 1091503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1091514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1091517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1091520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1091523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091542 */     // MIs[0] policy
     /* 1091542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091552 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1091555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091574 */     // GIR_Coverage, 60756,
     /* 1091574 */     GIR_EraseRootFromParent_Done,
     /* 1091575 */   // Label 16082: @1091575
     /* 1091575 */   GIM_Try, /*On fail goto*//*Label 16083*/ GIMT_Encode4(1091652), // Rule ID 60757 //
     /* 1091580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1091591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1091594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1091597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1091600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091619 */     // MIs[0] policy
     /* 1091619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091629 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1091632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091638 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091651 */     // GIR_Coverage, 60757,
     /* 1091651 */     GIR_EraseRootFromParent_Done,
     /* 1091652 */   // Label 16083: @1091652
     /* 1091652 */   GIM_Try, /*On fail goto*//*Label 16084*/ GIMT_Encode4(1091729), // Rule ID 60760 //
     /* 1091657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1091668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1091671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1091674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1091677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1091684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091696 */     // MIs[0] policy
     /* 1091696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091706 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1091709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091728 */     // GIR_Coverage, 60760,
     /* 1091728 */     GIR_EraseRootFromParent_Done,
     /* 1091729 */   // Label 16084: @1091729
     /* 1091729 */   GIM_Try, /*On fail goto*//*Label 16085*/ GIMT_Encode4(1091806), // Rule ID 60761 //
     /* 1091734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1091745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1091748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1091751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1091754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1091761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091773 */     // MIs[0] policy
     /* 1091773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091783 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1091786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091792 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091805 */     // GIR_Coverage, 60761,
     /* 1091805 */     GIR_EraseRootFromParent_Done,
     /* 1091806 */   // Label 16085: @1091806
     /* 1091806 */   GIM_Try, /*On fail goto*//*Label 16086*/ GIMT_Encode4(1091883), // Rule ID 60764 //
     /* 1091811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1091822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1091825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1091828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091850 */     // MIs[0] policy
     /* 1091850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091860 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091882 */     // GIR_Coverage, 60764,
     /* 1091882 */     GIR_EraseRootFromParent_Done,
     /* 1091883 */   // Label 16086: @1091883
     /* 1091883 */   GIM_Try, /*On fail goto*//*Label 16087*/ GIMT_Encode4(1091960), // Rule ID 60765 //
     /* 1091888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1091899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1091902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1091905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091927 */     // MIs[0] policy
     /* 1091927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091937 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091946 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091959 */     // GIR_Coverage, 60765,
     /* 1091959 */     GIR_EraseRootFromParent_Done,
     /* 1091960 */   // Label 16087: @1091960
     /* 1091960 */   GIM_Try, /*On fail goto*//*Label 16088*/ GIMT_Encode4(1092037), // Rule ID 60768 //
     /* 1091965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1091976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1091979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1091982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092004 */     // MIs[0] policy
     /* 1092004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092014 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092036 */     // GIR_Coverage, 60768,
     /* 1092036 */     GIR_EraseRootFromParent_Done,
     /* 1092037 */   // Label 16088: @1092037
     /* 1092037 */   GIM_Try, /*On fail goto*//*Label 16089*/ GIMT_Encode4(1092114), // Rule ID 60769 //
     /* 1092042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1092053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1092056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1092059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092081 */     // MIs[0] policy
     /* 1092081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092091 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092113 */     // GIR_Coverage, 60769,
     /* 1092113 */     GIR_EraseRootFromParent_Done,
     /* 1092114 */   // Label 16089: @1092114
     /* 1092114 */   GIM_Try, /*On fail goto*//*Label 16090*/ GIMT_Encode4(1092191), // Rule ID 60772 //
     /* 1092119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1092130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1092133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1092136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092158 */     // MIs[0] policy
     /* 1092158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092168 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092190 */     // GIR_Coverage, 60772,
     /* 1092190 */     GIR_EraseRootFromParent_Done,
     /* 1092191 */   // Label 16090: @1092191
     /* 1092191 */   GIM_Try, /*On fail goto*//*Label 16091*/ GIMT_Encode4(1092268), // Rule ID 60773 //
     /* 1092196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1092207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1092210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1092213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092235 */     // MIs[0] policy
     /* 1092235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092245 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092254 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092267 */     // GIR_Coverage, 60773,
     /* 1092267 */     GIR_EraseRootFromParent_Done,
     /* 1092268 */   // Label 16091: @1092268
     /* 1092268 */   GIM_Try, /*On fail goto*//*Label 16092*/ GIMT_Encode4(1092345), // Rule ID 60776 //
     /* 1092273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1092284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1092287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1092290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092312 */     // MIs[0] policy
     /* 1092312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092344 */     // GIR_Coverage, 60776,
     /* 1092344 */     GIR_EraseRootFromParent_Done,
     /* 1092345 */   // Label 16092: @1092345
     /* 1092345 */   GIM_Try, /*On fail goto*//*Label 16093*/ GIMT_Encode4(1092422), // Rule ID 60777 //
     /* 1092350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1092361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1092364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1092367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092389 */     // MIs[0] policy
     /* 1092389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092421 */     // GIR_Coverage, 60777,
     /* 1092421 */     GIR_EraseRootFromParent_Done,
     /* 1092422 */   // Label 16093: @1092422
     /* 1092422 */   GIM_Try, /*On fail goto*//*Label 16094*/ GIMT_Encode4(1092499), // Rule ID 60780 //
     /* 1092427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1092438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1092441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1092444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092466 */     // MIs[0] policy
     /* 1092466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092476 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092498 */     // GIR_Coverage, 60780,
     /* 1092498 */     GIR_EraseRootFromParent_Done,
     /* 1092499 */   // Label 16094: @1092499
     /* 1092499 */   GIM_Try, /*On fail goto*//*Label 16095*/ GIMT_Encode4(1092576), // Rule ID 60781 //
     /* 1092504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1092515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1092518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1092521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092543 */     // MIs[0] policy
     /* 1092543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092553 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092562 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092575 */     // GIR_Coverage, 60781,
     /* 1092575 */     GIR_EraseRootFromParent_Done,
     /* 1092576 */   // Label 16095: @1092576
     /* 1092576 */   GIM_Try, /*On fail goto*//*Label 16096*/ GIMT_Encode4(1092653), // Rule ID 60784 //
     /* 1092581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1092592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1092595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1092598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092620 */     // MIs[0] policy
     /* 1092620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092630 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092652 */     // GIR_Coverage, 60784,
     /* 1092652 */     GIR_EraseRootFromParent_Done,
     /* 1092653 */   // Label 16096: @1092653
     /* 1092653 */   GIM_Try, /*On fail goto*//*Label 16097*/ GIMT_Encode4(1092730), // Rule ID 60785 //
     /* 1092658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1092669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1092672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1092675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092697 */     // MIs[0] policy
     /* 1092697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092707 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092729 */     // GIR_Coverage, 60785,
     /* 1092729 */     GIR_EraseRootFromParent_Done,
     /* 1092730 */   // Label 16097: @1092730
     /* 1092730 */   GIM_Try, /*On fail goto*//*Label 16098*/ GIMT_Encode4(1092807), // Rule ID 60788 //
     /* 1092735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1092746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1092749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1092752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1092755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092774 */     // MIs[0] policy
     /* 1092774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092806 */     // GIR_Coverage, 60788,
     /* 1092806 */     GIR_EraseRootFromParent_Done,
     /* 1092807 */   // Label 16098: @1092807
     /* 1092807 */   GIM_Try, /*On fail goto*//*Label 16099*/ GIMT_Encode4(1092884), // Rule ID 60789 //
     /* 1092812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1092823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1092826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1092829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1092832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092851 */     // MIs[0] policy
     /* 1092851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092861 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092870 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092883 */     // GIR_Coverage, 60789,
     /* 1092883 */     GIR_EraseRootFromParent_Done,
     /* 1092884 */   // Label 16099: @1092884
     /* 1092884 */   GIM_Try, /*On fail goto*//*Label 16100*/ GIMT_Encode4(1092961), // Rule ID 60792 //
     /* 1092889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1092900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1092903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1092906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092928 */     // MIs[0] policy
     /* 1092928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092938 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092960 */     // GIR_Coverage, 60792,
     /* 1092960 */     GIR_EraseRootFromParent_Done,
     /* 1092961 */   // Label 16100: @1092961
     /* 1092961 */   GIM_Try, /*On fail goto*//*Label 16101*/ GIMT_Encode4(1093038), // Rule ID 60793 //
     /* 1092966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1092977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1092980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1092983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093005 */     // MIs[0] policy
     /* 1093005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093015 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1093018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093024 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093037 */     // GIR_Coverage, 60793,
     /* 1093037 */     GIR_EraseRootFromParent_Done,
     /* 1093038 */   // Label 16101: @1093038
     /* 1093038 */   GIM_Try, /*On fail goto*//*Label 16102*/ GIMT_Encode4(1093115), // Rule ID 60796 //
     /* 1093043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1093054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1093057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1093060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093082 */     // MIs[0] policy
     /* 1093082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093092 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1093095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093114 */     // GIR_Coverage, 60796,
     /* 1093114 */     GIR_EraseRootFromParent_Done,
     /* 1093115 */   // Label 16102: @1093115
     /* 1093115 */   GIM_Try, /*On fail goto*//*Label 16103*/ GIMT_Encode4(1093192), // Rule ID 60797 //
     /* 1093120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1093131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1093134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1093137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093159 */     // MIs[0] policy
     /* 1093159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093169 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1093172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093178 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093191 */     // GIR_Coverage, 60797,
     /* 1093191 */     GIR_EraseRootFromParent_Done,
     /* 1093192 */   // Label 16103: @1093192
     /* 1093192 */   GIM_Try, /*On fail goto*//*Label 16104*/ GIMT_Encode4(1093269), // Rule ID 60800 //
     /* 1093197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1093208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1093211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1093214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093236 */     // MIs[0] policy
     /* 1093236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093246 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1093249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093268 */     // GIR_Coverage, 60800,
     /* 1093268 */     GIR_EraseRootFromParent_Done,
     /* 1093269 */   // Label 16104: @1093269
     /* 1093269 */   GIM_Try, /*On fail goto*//*Label 16105*/ GIMT_Encode4(1093346), // Rule ID 60801 //
     /* 1093274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1093285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1093288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1093291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093313 */     // MIs[0] policy
     /* 1093313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093323 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1093326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093345 */     // GIR_Coverage, 60801,
     /* 1093345 */     GIR_EraseRootFromParent_Done,
     /* 1093346 */   // Label 16105: @1093346
     /* 1093346 */   GIM_Try, /*On fail goto*//*Label 16106*/ GIMT_Encode4(1093423), // Rule ID 60804 //
     /* 1093351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1093362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1093365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1093368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093390 */     // MIs[0] policy
     /* 1093390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093400 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093422 */     // GIR_Coverage, 60804,
     /* 1093422 */     GIR_EraseRootFromParent_Done,
     /* 1093423 */   // Label 16106: @1093423
     /* 1093423 */   GIM_Try, /*On fail goto*//*Label 16107*/ GIMT_Encode4(1093500), // Rule ID 60805 //
     /* 1093428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1093439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1093442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1093445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093467 */     // MIs[0] policy
     /* 1093467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093477 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093486 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093499 */     // GIR_Coverage, 60805,
     /* 1093499 */     GIR_EraseRootFromParent_Done,
     /* 1093500 */   // Label 16107: @1093500
     /* 1093500 */   GIM_Try, /*On fail goto*//*Label 16108*/ GIMT_Encode4(1093577), // Rule ID 60808 //
     /* 1093505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1093516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1093519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1093522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093544 */     // MIs[0] policy
     /* 1093544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093554 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093563 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093576 */     // GIR_Coverage, 60808,
     /* 1093576 */     GIR_EraseRootFromParent_Done,
     /* 1093577 */   // Label 16108: @1093577
     /* 1093577 */   GIM_Try, /*On fail goto*//*Label 16109*/ GIMT_Encode4(1093654), // Rule ID 60809 //
     /* 1093582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1093593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1093596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1093599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093621 */     // MIs[0] policy
     /* 1093621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093631 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093640 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093653 */     // GIR_Coverage, 60809,
     /* 1093653 */     GIR_EraseRootFromParent_Done,
     /* 1093654 */   // Label 16109: @1093654
     /* 1093654 */   GIM_Try, /*On fail goto*//*Label 16110*/ GIMT_Encode4(1093731), // Rule ID 60812 //
     /* 1093659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1093670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1093673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1093676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093698 */     // MIs[0] policy
     /* 1093698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093708 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093730 */     // GIR_Coverage, 60812,
     /* 1093730 */     GIR_EraseRootFromParent_Done,
     /* 1093731 */   // Label 16110: @1093731
     /* 1093731 */   GIM_Try, /*On fail goto*//*Label 16111*/ GIMT_Encode4(1093808), // Rule ID 60813 //
     /* 1093736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1093747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1093750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1093753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093775 */     // MIs[0] policy
     /* 1093775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093785 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093794 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093807 */     // GIR_Coverage, 60813,
     /* 1093807 */     GIR_EraseRootFromParent_Done,
     /* 1093808 */   // Label 16111: @1093808
     /* 1093808 */   GIM_Try, /*On fail goto*//*Label 16112*/ GIMT_Encode4(1093885), // Rule ID 60816 //
     /* 1093813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1093824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1093827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1093830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093852 */     // MIs[0] policy
     /* 1093852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093862 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093884 */     // GIR_Coverage, 60816,
     /* 1093884 */     GIR_EraseRootFromParent_Done,
     /* 1093885 */   // Label 16112: @1093885
     /* 1093885 */   GIM_Try, /*On fail goto*//*Label 16113*/ GIMT_Encode4(1093962), // Rule ID 60817 //
     /* 1093890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1093901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1093904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1093907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093929 */     // MIs[0] policy
     /* 1093929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093939 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093948 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093961 */     // GIR_Coverage, 60817,
     /* 1093961 */     GIR_EraseRootFromParent_Done,
     /* 1093962 */   // Label 16113: @1093962
     /* 1093962 */   GIM_Try, /*On fail goto*//*Label 16114*/ GIMT_Encode4(1094039), // Rule ID 60820 //
     /* 1093967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1093978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1093981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1093984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094006 */     // MIs[0] policy
     /* 1094006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094038 */     // GIR_Coverage, 60820,
     /* 1094038 */     GIR_EraseRootFromParent_Done,
     /* 1094039 */   // Label 16114: @1094039
     /* 1094039 */   GIM_Try, /*On fail goto*//*Label 16115*/ GIMT_Encode4(1094116), // Rule ID 60821 //
     /* 1094044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1094055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1094058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1094061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094083 */     // MIs[0] policy
     /* 1094083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094093 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094102 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094115 */     // GIR_Coverage, 60821,
     /* 1094115 */     GIR_EraseRootFromParent_Done,
     /* 1094116 */   // Label 16115: @1094116
     /* 1094116 */   GIM_Try, /*On fail goto*//*Label 16116*/ GIMT_Encode4(1094193), // Rule ID 60824 //
     /* 1094121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1094132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1094135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1094138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094160 */     // MIs[0] policy
     /* 1094160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094170 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094179 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094192 */     // GIR_Coverage, 60824,
     /* 1094192 */     GIR_EraseRootFromParent_Done,
     /* 1094193 */   // Label 16116: @1094193
     /* 1094193 */   GIM_Try, /*On fail goto*//*Label 16117*/ GIMT_Encode4(1094270), // Rule ID 60825 //
     /* 1094198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1094209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1094212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1094215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094237 */     // MIs[0] policy
     /* 1094237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094247 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094256 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094269 */     // GIR_Coverage, 60825,
     /* 1094269 */     GIR_EraseRootFromParent_Done,
     /* 1094270 */   // Label 16117: @1094270
     /* 1094270 */   GIM_Try, /*On fail goto*//*Label 16118*/ GIMT_Encode4(1094347), // Rule ID 60828 //
     /* 1094275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094314 */     // MIs[0] policy
     /* 1094314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094324 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094346 */     // GIR_Coverage, 60828,
     /* 1094346 */     GIR_EraseRootFromParent_Done,
     /* 1094347 */   // Label 16118: @1094347
     /* 1094347 */   GIM_Try, /*On fail goto*//*Label 16119*/ GIMT_Encode4(1094424), // Rule ID 60829 //
     /* 1094352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094391 */     // MIs[0] policy
     /* 1094391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094401 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094410 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094423 */     // GIR_Coverage, 60829,
     /* 1094423 */     GIR_EraseRootFromParent_Done,
     /* 1094424 */   // Label 16119: @1094424
     /* 1094424 */   GIM_Try, /*On fail goto*//*Label 16120*/ GIMT_Encode4(1094501), // Rule ID 60832 //
     /* 1094429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1094440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1094443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1094446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094468 */     // MIs[0] policy
     /* 1094468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094478 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094500 */     // GIR_Coverage, 60832,
     /* 1094500 */     GIR_EraseRootFromParent_Done,
     /* 1094501 */   // Label 16120: @1094501
     /* 1094501 */   GIM_Try, /*On fail goto*//*Label 16121*/ GIMT_Encode4(1094578), // Rule ID 60833 //
     /* 1094506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1094517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1094520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1094523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094545 */     // MIs[0] policy
     /* 1094545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094555 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094564 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094577 */     // GIR_Coverage, 60833,
     /* 1094577 */     GIR_EraseRootFromParent_Done,
     /* 1094578 */   // Label 16121: @1094578
     /* 1094578 */   GIM_Try, /*On fail goto*//*Label 16122*/ GIMT_Encode4(1094655), // Rule ID 60836 //
     /* 1094583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1094594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1094597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1094600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094622 */     // MIs[0] policy
     /* 1094622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094632 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1094651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094654 */     // GIR_Coverage, 60836,
     /* 1094654 */     GIR_EraseRootFromParent_Done,
     /* 1094655 */   // Label 16122: @1094655
     /* 1094655 */   GIM_Try, /*On fail goto*//*Label 16123*/ GIMT_Encode4(1094732), // Rule ID 60837 //
     /* 1094660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1094671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1094674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1094677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094699 */     // MIs[0] policy
     /* 1094699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094709 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094718 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1094728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094731 */     // GIR_Coverage, 60837,
     /* 1094731 */     GIR_EraseRootFromParent_Done,
     /* 1094732 */   // Label 16123: @1094732
     /* 1094732 */   GIM_Try, /*On fail goto*//*Label 16124*/ GIMT_Encode4(1094809), // Rule ID 60840 //
     /* 1094737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1094748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1094751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1094754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1094757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1094764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094776 */     // MIs[0] policy
     /* 1094776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094786 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1094789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094795 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094808 */     // GIR_Coverage, 60840,
     /* 1094808 */     GIR_EraseRootFromParent_Done,
     /* 1094809 */   // Label 16124: @1094809
     /* 1094809 */   GIM_Try, /*On fail goto*//*Label 16125*/ GIMT_Encode4(1094886), // Rule ID 60841 //
     /* 1094814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1094825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1094828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1094831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1094834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1094841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094853 */     // MIs[0] policy
     /* 1094853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094863 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1094866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094872 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094885 */     // GIR_Coverage, 60841,
     /* 1094885 */     GIR_EraseRootFromParent_Done,
     /* 1094886 */   // Label 16125: @1094886
     /* 1094886 */   GIM_Try, /*On fail goto*//*Label 16126*/ GIMT_Encode4(1094963), // Rule ID 60844 //
     /* 1094891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1094902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1094905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1094908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1094911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1094918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094930 */     // MIs[0] policy
     /* 1094930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094940 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1094943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094962 */     // GIR_Coverage, 60844,
     /* 1094962 */     GIR_EraseRootFromParent_Done,
     /* 1094963 */   // Label 16126: @1094963
     /* 1094963 */   GIM_Try, /*On fail goto*//*Label 16127*/ GIMT_Encode4(1095040), // Rule ID 60845 //
     /* 1094968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1094979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1094982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1094985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1094988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1094995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095007 */     // MIs[0] policy
     /* 1095007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095017 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095026 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095039 */     // GIR_Coverage, 60845,
     /* 1095039 */     GIR_EraseRootFromParent_Done,
     /* 1095040 */   // Label 16127: @1095040
     /* 1095040 */   GIM_Try, /*On fail goto*//*Label 16128*/ GIMT_Encode4(1095117), // Rule ID 60848 //
     /* 1095045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1095056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1095059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1095062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1095065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095084 */     // MIs[0] policy
     /* 1095084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095094 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095116 */     // GIR_Coverage, 60848,
     /* 1095116 */     GIR_EraseRootFromParent_Done,
     /* 1095117 */   // Label 16128: @1095117
     /* 1095117 */   GIM_Try, /*On fail goto*//*Label 16129*/ GIMT_Encode4(1095194), // Rule ID 60849 //
     /* 1095122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1095133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1095136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1095139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1095142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095161 */     // MIs[0] policy
     /* 1095161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095171 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095180 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095193 */     // GIR_Coverage, 60849,
     /* 1095193 */     GIR_EraseRootFromParent_Done,
     /* 1095194 */   // Label 16129: @1095194
     /* 1095194 */   GIM_Try, /*On fail goto*//*Label 16130*/ GIMT_Encode4(1095271), // Rule ID 60852 //
     /* 1095199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095238 */     // MIs[0] policy
     /* 1095238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095248 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095270 */     // GIR_Coverage, 60852,
     /* 1095270 */     GIR_EraseRootFromParent_Done,
     /* 1095271 */   // Label 16130: @1095271
     /* 1095271 */   GIM_Try, /*On fail goto*//*Label 16131*/ GIMT_Encode4(1095348), // Rule ID 60853 //
     /* 1095276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095315 */     // MIs[0] policy
     /* 1095315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095325 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095334 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095347 */     // GIR_Coverage, 60853,
     /* 1095347 */     GIR_EraseRootFromParent_Done,
     /* 1095348 */   // Label 16131: @1095348
     /* 1095348 */   GIM_Try, /*On fail goto*//*Label 16132*/ GIMT_Encode4(1095425), // Rule ID 60856 //
     /* 1095353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095392 */     // MIs[0] policy
     /* 1095392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095402 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095424 */     // GIR_Coverage, 60856,
     /* 1095424 */     GIR_EraseRootFromParent_Done,
     /* 1095425 */   // Label 16132: @1095425
     /* 1095425 */   GIM_Try, /*On fail goto*//*Label 16133*/ GIMT_Encode4(1095502), // Rule ID 60857 //
     /* 1095430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095469 */     // MIs[0] policy
     /* 1095469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095479 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095488 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095501 */     // GIR_Coverage, 60857,
     /* 1095501 */     GIR_EraseRootFromParent_Done,
     /* 1095502 */   // Label 16133: @1095502
     /* 1095502 */   GIM_Try, /*On fail goto*//*Label 16134*/ GIMT_Encode4(1095579), // Rule ID 60860 //
     /* 1095507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1095518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1095521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1095524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095546 */     // MIs[0] policy
     /* 1095546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095556 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095565 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095578 */     // GIR_Coverage, 60860,
     /* 1095578 */     GIR_EraseRootFromParent_Done,
     /* 1095579 */   // Label 16134: @1095579
     /* 1095579 */   GIM_Try, /*On fail goto*//*Label 16135*/ GIMT_Encode4(1095656), // Rule ID 60861 //
     /* 1095584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1095595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1095598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1095601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095623 */     // MIs[0] policy
     /* 1095623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095633 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095642 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095655 */     // GIR_Coverage, 60861,
     /* 1095655 */     GIR_EraseRootFromParent_Done,
     /* 1095656 */   // Label 16135: @1095656
     /* 1095656 */   GIM_Try, /*On fail goto*//*Label 16136*/ GIMT_Encode4(1095733), // Rule ID 60864 //
     /* 1095661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1095672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1095675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1095678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1095681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095700 */     // MIs[0] policy
     /* 1095700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095732 */     // GIR_Coverage, 60864,
     /* 1095732 */     GIR_EraseRootFromParent_Done,
     /* 1095733 */   // Label 16136: @1095733
     /* 1095733 */   GIM_Try, /*On fail goto*//*Label 16137*/ GIMT_Encode4(1095810), // Rule ID 60865 //
     /* 1095738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1095749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1095752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1095755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1095758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095777 */     // MIs[0] policy
     /* 1095777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095787 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095796 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095809 */     // GIR_Coverage, 60865,
     /* 1095809 */     GIR_EraseRootFromParent_Done,
     /* 1095810 */   // Label 16137: @1095810
     /* 1095810 */   GIM_Try, /*On fail goto*//*Label 16138*/ GIMT_Encode4(1095887), // Rule ID 60868 //
     /* 1095815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1095826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1095829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1095832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095854 */     // MIs[0] policy
     /* 1095854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095864 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095886 */     // GIR_Coverage, 60868,
     /* 1095886 */     GIR_EraseRootFromParent_Done,
     /* 1095887 */   // Label 16138: @1095887
     /* 1095887 */   GIM_Try, /*On fail goto*//*Label 16139*/ GIMT_Encode4(1095964), // Rule ID 60869 //
     /* 1095892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1095903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1095906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1095909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095931 */     // MIs[0] policy
     /* 1095931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095941 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095950 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095963 */     // GIR_Coverage, 60869,
     /* 1095963 */     GIR_EraseRootFromParent_Done,
     /* 1095964 */   // Label 16139: @1095964
     /* 1095964 */   GIM_Try, /*On fail goto*//*Label 16140*/ GIMT_Encode4(1096041), // Rule ID 60872 //
     /* 1095969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1095980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1095983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1095986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096008 */     // MIs[0] policy
     /* 1096008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096040 */     // GIR_Coverage, 60872,
     /* 1096040 */     GIR_EraseRootFromParent_Done,
     /* 1096041 */   // Label 16140: @1096041
     /* 1096041 */   GIM_Try, /*On fail goto*//*Label 16141*/ GIMT_Encode4(1096118), // Rule ID 60873 //
     /* 1096046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1096057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1096060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1096063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1096066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096085 */     // MIs[0] policy
     /* 1096085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096095 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096104 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096117 */     // GIR_Coverage, 60873,
     /* 1096117 */     GIR_EraseRootFromParent_Done,
     /* 1096118 */   // Label 16141: @1096118
     /* 1096118 */   GIM_Try, /*On fail goto*//*Label 16142*/ GIMT_Encode4(1096195), // Rule ID 60876 //
     /* 1096123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096162 */     // MIs[0] policy
     /* 1096162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1096175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096194 */     // GIR_Coverage, 60876,
     /* 1096194 */     GIR_EraseRootFromParent_Done,
     /* 1096195 */   // Label 16142: @1096195
     /* 1096195 */   GIM_Try, /*On fail goto*//*Label 16143*/ GIMT_Encode4(1096272), // Rule ID 60877 //
     /* 1096200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096239 */     // MIs[0] policy
     /* 1096239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096249 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1096252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096258 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096271 */     // GIR_Coverage, 60877,
     /* 1096271 */     GIR_EraseRootFromParent_Done,
     /* 1096272 */   // Label 16143: @1096272
     /* 1096272 */   GIM_Try, /*On fail goto*//*Label 16144*/ GIMT_Encode4(1096349), // Rule ID 60880 //
     /* 1096277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096316 */     // MIs[0] policy
     /* 1096316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096326 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1096329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096348 */     // GIR_Coverage, 60880,
     /* 1096348 */     GIR_EraseRootFromParent_Done,
     /* 1096349 */   // Label 16144: @1096349
     /* 1096349 */   GIM_Try, /*On fail goto*//*Label 16145*/ GIMT_Encode4(1096426), // Rule ID 60881 //
     /* 1096354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096393 */     // MIs[0] policy
     /* 1096393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096403 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1096406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096412 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096425 */     // GIR_Coverage, 60881,
     /* 1096425 */     GIR_EraseRootFromParent_Done,
     /* 1096426 */   // Label 16145: @1096426
     /* 1096426 */   GIM_Try, /*On fail goto*//*Label 16146*/ GIMT_Encode4(1096503), // Rule ID 60884 //
     /* 1096431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096470 */     // MIs[0] policy
     /* 1096470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096480 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096502 */     // GIR_Coverage, 60884,
     /* 1096502 */     GIR_EraseRootFromParent_Done,
     /* 1096503 */   // Label 16146: @1096503
     /* 1096503 */   GIM_Try, /*On fail goto*//*Label 16147*/ GIMT_Encode4(1096580), // Rule ID 60885 //
     /* 1096508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096547 */     // MIs[0] policy
     /* 1096547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096557 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096566 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096579 */     // GIR_Coverage, 60885,
     /* 1096579 */     GIR_EraseRootFromParent_Done,
     /* 1096580 */   // Label 16147: @1096580
     /* 1096580 */   GIM_Try, /*On fail goto*//*Label 16148*/ GIMT_Encode4(1096657), // Rule ID 60888 //
     /* 1096585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1096596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1096599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1096602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1096605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096624 */     // MIs[0] policy
     /* 1096624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096634 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1096637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096643 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096656 */     // GIR_Coverage, 60888,
     /* 1096656 */     GIR_EraseRootFromParent_Done,
     /* 1096657 */   // Label 16148: @1096657
     /* 1096657 */   GIM_Try, /*On fail goto*//*Label 16149*/ GIMT_Encode4(1096734), // Rule ID 60889 //
     /* 1096662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1096673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1096676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1096679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1096682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096701 */     // MIs[0] policy
     /* 1096701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096711 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1096714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096720 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096733 */     // GIR_Coverage, 60889,
     /* 1096733 */     GIR_EraseRootFromParent_Done,
     /* 1096734 */   // Label 16149: @1096734
     /* 1096734 */   GIM_Try, /*On fail goto*//*Label 16150*/ GIMT_Encode4(1096811), // Rule ID 60892 //
     /* 1096739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1096750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1096753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1096756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096778 */     // MIs[0] policy
     /* 1096778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096788 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1096791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096810 */     // GIR_Coverage, 60892,
     /* 1096810 */     GIR_EraseRootFromParent_Done,
     /* 1096811 */   // Label 16150: @1096811
     /* 1096811 */   GIM_Try, /*On fail goto*//*Label 16151*/ GIMT_Encode4(1096888), // Rule ID 60893 //
     /* 1096816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1096827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1096830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1096833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096855 */     // MIs[0] policy
     /* 1096855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096865 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1096868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096874 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096887 */     // GIR_Coverage, 60893,
     /* 1096887 */     GIR_EraseRootFromParent_Done,
     /* 1096888 */   // Label 16151: @1096888
     /* 1096888 */   GIM_Try, /*On fail goto*//*Label 16152*/ GIMT_Encode4(1096965), // Rule ID 60896 //
     /* 1096893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1096904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1096907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1096910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096932 */     // MIs[0] policy
     /* 1096932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096942 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1096945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096964 */     // GIR_Coverage, 60896,
     /* 1096964 */     GIR_EraseRootFromParent_Done,
     /* 1096965 */   // Label 16152: @1096965
     /* 1096965 */   GIM_Try, /*On fail goto*//*Label 16153*/ GIMT_Encode4(1097042), // Rule ID 60897 //
     /* 1096970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1096981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1096984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1096987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097009 */     // MIs[0] policy
     /* 1097009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097019 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097028 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097041 */     // GIR_Coverage, 60897,
     /* 1097041 */     GIR_EraseRootFromParent_Done,
     /* 1097042 */   // Label 16153: @1097042
     /* 1097042 */   GIM_Try, /*On fail goto*//*Label 16154*/ GIMT_Encode4(1097119), // Rule ID 60900 //
     /* 1097047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1097058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1097061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1097064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097086 */     // MIs[0] policy
     /* 1097086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097096 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1097099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097118 */     // GIR_Coverage, 60900,
     /* 1097118 */     GIR_EraseRootFromParent_Done,
     /* 1097119 */   // Label 16154: @1097119
     /* 1097119 */   GIM_Try, /*On fail goto*//*Label 16155*/ GIMT_Encode4(1097196), // Rule ID 60901 //
     /* 1097124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1097135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1097138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1097141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097163 */     // MIs[0] policy
     /* 1097163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097173 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1097176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097182 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097195 */     // GIR_Coverage, 60901,
     /* 1097195 */     GIR_EraseRootFromParent_Done,
     /* 1097196 */   // Label 16155: @1097196
     /* 1097196 */   GIM_Try, /*On fail goto*//*Label 16156*/ GIMT_Encode4(1097273), // Rule ID 60904 //
     /* 1097201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1097212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1097215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1097218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097240 */     // MIs[0] policy
     /* 1097240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097250 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097272 */     // GIR_Coverage, 60904,
     /* 1097272 */     GIR_EraseRootFromParent_Done,
     /* 1097273 */   // Label 16156: @1097273
     /* 1097273 */   GIM_Try, /*On fail goto*//*Label 16157*/ GIMT_Encode4(1097350), // Rule ID 60905 //
     /* 1097278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1097289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1097292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1097295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097317 */     // MIs[0] policy
     /* 1097317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097327 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097336 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097349 */     // GIR_Coverage, 60905,
     /* 1097349 */     GIR_EraseRootFromParent_Done,
     /* 1097350 */   // Label 16157: @1097350
     /* 1097350 */   GIM_Try, /*On fail goto*//*Label 16158*/ GIMT_Encode4(1097427), // Rule ID 60908 //
     /* 1097355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097394 */     // MIs[0] policy
     /* 1097394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097426 */     // GIR_Coverage, 60908,
     /* 1097426 */     GIR_EraseRootFromParent_Done,
     /* 1097427 */   // Label 16158: @1097427
     /* 1097427 */   GIM_Try, /*On fail goto*//*Label 16159*/ GIMT_Encode4(1097504), // Rule ID 60909 //
     /* 1097432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097471 */     // MIs[0] policy
     /* 1097471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097481 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097490 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097503 */     // GIR_Coverage, 60909,
     /* 1097503 */     GIR_EraseRootFromParent_Done,
     /* 1097504 */   // Label 16159: @1097504
     /* 1097504 */   GIM_Try, /*On fail goto*//*Label 16160*/ GIMT_Encode4(1097581), // Rule ID 60912 //
     /* 1097509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1097520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1097523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1097526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1097529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097548 */     // MIs[0] policy
     /* 1097548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097558 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097580 */     // GIR_Coverage, 60912,
     /* 1097580 */     GIR_EraseRootFromParent_Done,
     /* 1097581 */   // Label 16160: @1097581
     /* 1097581 */   GIM_Try, /*On fail goto*//*Label 16161*/ GIMT_Encode4(1097658), // Rule ID 60913 //
     /* 1097586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1097597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1097600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1097603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1097606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097625 */     // MIs[0] policy
     /* 1097625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097635 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097644 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097657 */     // GIR_Coverage, 60913,
     /* 1097657 */     GIR_EraseRootFromParent_Done,
     /* 1097658 */   // Label 16161: @1097658
     /* 1097658 */   GIM_Try, /*On fail goto*//*Label 16162*/ GIMT_Encode4(1097735), // Rule ID 60916 //
     /* 1097663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1097674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1097677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1097680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097702 */     // MIs[0] policy
     /* 1097702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097712 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097734 */     // GIR_Coverage, 60916,
     /* 1097734 */     GIR_EraseRootFromParent_Done,
     /* 1097735 */   // Label 16162: @1097735
     /* 1097735 */   GIM_Try, /*On fail goto*//*Label 16163*/ GIMT_Encode4(1097812), // Rule ID 60917 //
     /* 1097740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1097751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1097754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1097757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097779 */     // MIs[0] policy
     /* 1097779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097789 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097798 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097811 */     // GIR_Coverage, 60917,
     /* 1097811 */     GIR_EraseRootFromParent_Done,
     /* 1097812 */   // Label 16163: @1097812
     /* 1097812 */   GIM_Try, /*On fail goto*//*Label 16164*/ GIMT_Encode4(1097889), // Rule ID 60920 //
     /* 1097817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1097828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1097831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1097834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097856 */     // MIs[0] policy
     /* 1097856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097866 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097875 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097888 */     // GIR_Coverage, 60920,
     /* 1097888 */     GIR_EraseRootFromParent_Done,
     /* 1097889 */   // Label 16164: @1097889
     /* 1097889 */   GIM_Try, /*On fail goto*//*Label 16165*/ GIMT_Encode4(1097966), // Rule ID 60921 //
     /* 1097894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1097905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1097908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1097911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097933 */     // MIs[0] policy
     /* 1097933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097943 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097952 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097965 */     // GIR_Coverage, 60921,
     /* 1097965 */     GIR_EraseRootFromParent_Done,
     /* 1097966 */   // Label 16165: @1097966
     /* 1097966 */   GIM_Try, /*On fail goto*//*Label 16166*/ GIMT_Encode4(1098043), // Rule ID 60924 //
     /* 1097971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1097982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1097985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1097988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098010 */     // MIs[0] policy
     /* 1098010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098042 */     // GIR_Coverage, 60924,
     /* 1098042 */     GIR_EraseRootFromParent_Done,
     /* 1098043 */   // Label 16166: @1098043
     /* 1098043 */   GIM_Try, /*On fail goto*//*Label 16167*/ GIMT_Encode4(1098120), // Rule ID 60925 //
     /* 1098048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1098059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1098062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1098065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1098068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098087 */     // MIs[0] policy
     /* 1098087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098097 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098106 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098119 */     // GIR_Coverage, 60925,
     /* 1098119 */     GIR_EraseRootFromParent_Done,
     /* 1098120 */   // Label 16167: @1098120
     /* 1098120 */   GIM_Try, /*On fail goto*//*Label 16168*/ GIMT_Encode4(1098197), // Rule ID 60928 //
     /* 1098125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1098136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1098139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1098142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098164 */     // MIs[0] policy
     /* 1098164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098174 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098196 */     // GIR_Coverage, 60928,
     /* 1098196 */     GIR_EraseRootFromParent_Done,
     /* 1098197 */   // Label 16168: @1098197
     /* 1098197 */   GIM_Try, /*On fail goto*//*Label 16169*/ GIMT_Encode4(1098274), // Rule ID 60929 //
     /* 1098202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1098213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1098216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1098219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098241 */     // MIs[0] policy
     /* 1098241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098251 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098260 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098273 */     // GIR_Coverage, 60929,
     /* 1098273 */     GIR_EraseRootFromParent_Done,
     /* 1098274 */   // Label 16169: @1098274
     /* 1098274 */   GIM_Try, /*On fail goto*//*Label 16170*/ GIMT_Encode4(1098351), // Rule ID 60932 //
     /* 1098279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1098290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1098293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1098296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098318 */     // MIs[0] policy
     /* 1098318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098328 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098350 */     // GIR_Coverage, 60932,
     /* 1098350 */     GIR_EraseRootFromParent_Done,
     /* 1098351 */   // Label 16170: @1098351
     /* 1098351 */   GIM_Try, /*On fail goto*//*Label 16171*/ GIMT_Encode4(1098428), // Rule ID 60933 //
     /* 1098356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1098367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1098370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1098373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098395 */     // MIs[0] policy
     /* 1098395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098405 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098414 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098427 */     // GIR_Coverage, 60933,
     /* 1098427 */     GIR_EraseRootFromParent_Done,
     /* 1098428 */   // Label 16171: @1098428
     /* 1098428 */   GIM_Try, /*On fail goto*//*Label 16172*/ GIMT_Encode4(1098505), // Rule ID 60936 //
     /* 1098433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1098444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1098447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1098450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1098453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098472 */     // MIs[0] policy
     /* 1098472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098482 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1098485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098491 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098504 */     // GIR_Coverage, 60936,
     /* 1098504 */     GIR_EraseRootFromParent_Done,
     /* 1098505 */   // Label 16172: @1098505
     /* 1098505 */   GIM_Try, /*On fail goto*//*Label 16173*/ GIMT_Encode4(1098582), // Rule ID 60937 //
     /* 1098510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1098521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1098524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1098527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1098530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098549 */     // MIs[0] policy
     /* 1098549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098559 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1098562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098568 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098581 */     // GIR_Coverage, 60937,
     /* 1098581 */     GIR_EraseRootFromParent_Done,
     /* 1098582 */   // Label 16173: @1098582
     /* 1098582 */   GIM_Try, /*On fail goto*//*Label 16174*/ GIMT_Encode4(1098659), // Rule ID 60940 //
     /* 1098587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1098598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1098601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1098604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1098607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098626 */     // MIs[0] policy
     /* 1098626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098636 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098658 */     // GIR_Coverage, 60940,
     /* 1098658 */     GIR_EraseRootFromParent_Done,
     /* 1098659 */   // Label 16174: @1098659
     /* 1098659 */   GIM_Try, /*On fail goto*//*Label 16175*/ GIMT_Encode4(1098736), // Rule ID 60941 //
     /* 1098664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1098675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1098678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1098681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1098684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098703 */     // MIs[0] policy
     /* 1098703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098713 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098722 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098735 */     // GIR_Coverage, 60941,
     /* 1098735 */     GIR_EraseRootFromParent_Done,
     /* 1098736 */   // Label 16175: @1098736
     /* 1098736 */   GIM_Try, /*On fail goto*//*Label 16176*/ GIMT_Encode4(1098813), // Rule ID 60944 //
     /* 1098741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1098752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1098755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1098758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098780 */     // MIs[0] policy
     /* 1098780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098790 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098812 */     // GIR_Coverage, 60944,
     /* 1098812 */     GIR_EraseRootFromParent_Done,
     /* 1098813 */   // Label 16176: @1098813
     /* 1098813 */   GIM_Try, /*On fail goto*//*Label 16177*/ GIMT_Encode4(1098890), // Rule ID 60945 //
     /* 1098818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1098829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1098832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1098835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098857 */     // MIs[0] policy
     /* 1098857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098867 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098876 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098889 */     // GIR_Coverage, 60945,
     /* 1098889 */     GIR_EraseRootFromParent_Done,
     /* 1098890 */   // Label 16177: @1098890
     /* 1098890 */   GIM_Try, /*On fail goto*//*Label 16178*/ GIMT_Encode4(1098967), // Rule ID 60948 //
     /* 1098895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1098906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1098909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1098912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098934 */     // MIs[0] policy
     /* 1098934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098944 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1098947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098966 */     // GIR_Coverage, 60948,
     /* 1098966 */     GIR_EraseRootFromParent_Done,
     /* 1098967 */   // Label 16178: @1098967
     /* 1098967 */   GIM_Try, /*On fail goto*//*Label 16179*/ GIMT_Encode4(1099044), // Rule ID 60949 //
     /* 1098972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1098983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1098986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1098989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099011 */     // MIs[0] policy
     /* 1099011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099021 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099030 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099043 */     // GIR_Coverage, 60949,
     /* 1099043 */     GIR_EraseRootFromParent_Done,
     /* 1099044 */   // Label 16179: @1099044
     /* 1099044 */   GIM_Try, /*On fail goto*//*Label 16180*/ GIMT_Encode4(1099121), // Rule ID 60952 //
     /* 1099049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1099060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1099063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1099066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099088 */     // MIs[0] policy
     /* 1099088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099098 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099120 */     // GIR_Coverage, 60952,
     /* 1099120 */     GIR_EraseRootFromParent_Done,
     /* 1099121 */   // Label 16180: @1099121
     /* 1099121 */   GIM_Try, /*On fail goto*//*Label 16181*/ GIMT_Encode4(1099198), // Rule ID 60953 //
     /* 1099126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1099137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1099140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1099143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099165 */     // MIs[0] policy
     /* 1099165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099175 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099184 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099197 */     // GIR_Coverage, 60953,
     /* 1099197 */     GIR_EraseRootFromParent_Done,
     /* 1099198 */   // Label 16181: @1099198
     /* 1099198 */   GIM_Try, /*On fail goto*//*Label 16182*/ GIMT_Encode4(1099275), // Rule ID 60956 //
     /* 1099203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1099214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1099217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1099220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099242 */     // MIs[0] policy
     /* 1099242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099252 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099274 */     // GIR_Coverage, 60956,
     /* 1099274 */     GIR_EraseRootFromParent_Done,
     /* 1099275 */   // Label 16182: @1099275
     /* 1099275 */   GIM_Try, /*On fail goto*//*Label 16183*/ GIMT_Encode4(1099352), // Rule ID 60957 //
     /* 1099280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1099291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1099294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1099297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099319 */     // MIs[0] policy
     /* 1099319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099329 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099338 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099351 */     // GIR_Coverage, 60957,
     /* 1099351 */     GIR_EraseRootFromParent_Done,
     /* 1099352 */   // Label 16183: @1099352
     /* 1099352 */   GIM_Try, /*On fail goto*//*Label 16184*/ GIMT_Encode4(1099429), // Rule ID 60960 //
     /* 1099357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1099368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1099371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1099374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099396 */     // MIs[0] policy
     /* 1099396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099406 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099428 */     // GIR_Coverage, 60960,
     /* 1099428 */     GIR_EraseRootFromParent_Done,
     /* 1099429 */   // Label 16184: @1099429
     /* 1099429 */   GIM_Try, /*On fail goto*//*Label 16185*/ GIMT_Encode4(1099506), // Rule ID 60961 //
     /* 1099434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1099445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1099448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1099451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099473 */     // MIs[0] policy
     /* 1099473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099483 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099492 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099505 */     // GIR_Coverage, 60961,
     /* 1099505 */     GIR_EraseRootFromParent_Done,
     /* 1099506 */   // Label 16185: @1099506
     /* 1099506 */   GIM_Try, /*On fail goto*//*Label 16186*/ GIMT_Encode4(1099583), // Rule ID 60964 //
     /* 1099511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1099522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1099525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1099528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1099531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099550 */     // MIs[0] policy
     /* 1099550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099560 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099582 */     // GIR_Coverage, 60964,
     /* 1099582 */     GIR_EraseRootFromParent_Done,
     /* 1099583 */   // Label 16186: @1099583
     /* 1099583 */   GIM_Try, /*On fail goto*//*Label 16187*/ GIMT_Encode4(1099660), // Rule ID 60965 //
     /* 1099588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1099599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1099602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1099605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1099608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099627 */     // MIs[0] policy
     /* 1099627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099637 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099646 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099659 */     // GIR_Coverage, 60965,
     /* 1099659 */     GIR_EraseRootFromParent_Done,
     /* 1099660 */   // Label 16187: @1099660
     /* 1099660 */   GIM_Try, /*On fail goto*//*Label 16188*/ GIMT_Encode4(1099737), // Rule ID 60968 //
     /* 1099665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1099676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1099679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1099682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099704 */     // MIs[0] policy
     /* 1099704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099714 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099723 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099736 */     // GIR_Coverage, 60968,
     /* 1099736 */     GIR_EraseRootFromParent_Done,
     /* 1099737 */   // Label 16188: @1099737
     /* 1099737 */   GIM_Try, /*On fail goto*//*Label 16189*/ GIMT_Encode4(1099814), // Rule ID 60969 //
     /* 1099742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1099753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1099756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1099759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099781 */     // MIs[0] policy
     /* 1099781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099791 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099800 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099813 */     // GIR_Coverage, 60969,
     /* 1099813 */     GIR_EraseRootFromParent_Done,
     /* 1099814 */   // Label 16189: @1099814
     /* 1099814 */   GIM_Try, /*On fail goto*//*Label 16190*/ GIMT_Encode4(1099891), // Rule ID 60972 //
     /* 1099819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1099830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1099833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1099836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099858 */     // MIs[0] policy
     /* 1099858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099890 */     // GIR_Coverage, 60972,
     /* 1099890 */     GIR_EraseRootFromParent_Done,
     /* 1099891 */   // Label 16190: @1099891
     /* 1099891 */   GIM_Try, /*On fail goto*//*Label 16191*/ GIMT_Encode4(1099968), // Rule ID 60973 //
     /* 1099896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1099907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1099910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1099913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099935 */     // MIs[0] policy
     /* 1099935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099945 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099954 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099967 */     // GIR_Coverage, 60973,
     /* 1099967 */     GIR_EraseRootFromParent_Done,
     /* 1099968 */   // Label 16191: @1099968
     /* 1099968 */   GIM_Try, /*On fail goto*//*Label 16192*/ GIMT_Encode4(1100045), // Rule ID 61396 //
     /* 1099973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1099976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1099981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1099984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1099987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1099990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1099993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100012 */     // MIs[0] policy
     /* 1100012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100022 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1100025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100044 */     // GIR_Coverage, 61396,
     /* 1100044 */     GIR_EraseRootFromParent_Done,
     /* 1100045 */   // Label 16192: @1100045
     /* 1100045 */   GIM_Try, /*On fail goto*//*Label 16193*/ GIMT_Encode4(1100122), // Rule ID 61397 //
     /* 1100050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1100061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1100064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1100067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100089 */     // MIs[0] policy
     /* 1100089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100099 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1100102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100108 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100121 */     // GIR_Coverage, 61397,
     /* 1100121 */     GIR_EraseRootFromParent_Done,
     /* 1100122 */   // Label 16193: @1100122
     /* 1100122 */   GIM_Try, /*On fail goto*//*Label 16194*/ GIMT_Encode4(1100199), // Rule ID 61400 //
     /* 1100127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1100138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1100141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1100144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100166 */     // MIs[0] policy
     /* 1100166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100176 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100198 */     // GIR_Coverage, 61400,
     /* 1100198 */     GIR_EraseRootFromParent_Done,
     /* 1100199 */   // Label 16194: @1100199
     /* 1100199 */   GIM_Try, /*On fail goto*//*Label 16195*/ GIMT_Encode4(1100276), // Rule ID 61401 //
     /* 1100204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1100215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1100218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1100221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100243 */     // MIs[0] policy
     /* 1100243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100253 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100262 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100275 */     // GIR_Coverage, 61401,
     /* 1100275 */     GIR_EraseRootFromParent_Done,
     /* 1100276 */   // Label 16195: @1100276
     /* 1100276 */   GIM_Try, /*On fail goto*//*Label 16196*/ GIMT_Encode4(1100353), // Rule ID 61404 //
     /* 1100281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1100292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1100295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1100298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100320 */     // MIs[0] policy
     /* 1100320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100330 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100339 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100352 */     // GIR_Coverage, 61404,
     /* 1100352 */     GIR_EraseRootFromParent_Done,
     /* 1100353 */   // Label 16196: @1100353
     /* 1100353 */   GIM_Try, /*On fail goto*//*Label 16197*/ GIMT_Encode4(1100430), // Rule ID 61405 //
     /* 1100358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1100369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1100372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1100375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100397 */     // MIs[0] policy
     /* 1100397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100407 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100416 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100429 */     // GIR_Coverage, 61405,
     /* 1100429 */     GIR_EraseRootFromParent_Done,
     /* 1100430 */   // Label 16197: @1100430
     /* 1100430 */   GIM_Try, /*On fail goto*//*Label 16198*/ GIMT_Encode4(1100507), // Rule ID 61408 //
     /* 1100435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1100446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1100449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1100452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100474 */     // MIs[0] policy
     /* 1100474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100493 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100506 */     // GIR_Coverage, 61408,
     /* 1100506 */     GIR_EraseRootFromParent_Done,
     /* 1100507 */   // Label 16198: @1100507
     /* 1100507 */   GIM_Try, /*On fail goto*//*Label 16199*/ GIMT_Encode4(1100584), // Rule ID 61409 //
     /* 1100512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1100523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1100526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1100529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100551 */     // MIs[0] policy
     /* 1100551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100561 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100570 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100583 */     // GIR_Coverage, 61409,
     /* 1100583 */     GIR_EraseRootFromParent_Done,
     /* 1100584 */   // Label 16199: @1100584
     /* 1100584 */   GIM_Try, /*On fail goto*//*Label 16200*/ GIMT_Encode4(1100661), // Rule ID 61412 //
     /* 1100589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1100600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1100603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1100606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100628 */     // MIs[0] policy
     /* 1100628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100638 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100647 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100660 */     // GIR_Coverage, 61412,
     /* 1100660 */     GIR_EraseRootFromParent_Done,
     /* 1100661 */   // Label 16200: @1100661
     /* 1100661 */   GIM_Try, /*On fail goto*//*Label 16201*/ GIMT_Encode4(1100738), // Rule ID 61413 //
     /* 1100666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1100677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1100680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1100683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100705 */     // MIs[0] policy
     /* 1100705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100715 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100724 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100737 */     // GIR_Coverage, 61413,
     /* 1100737 */     GIR_EraseRootFromParent_Done,
     /* 1100738 */   // Label 16201: @1100738
     /* 1100738 */   GIM_Try, /*On fail goto*//*Label 16202*/ GIMT_Encode4(1100815), // Rule ID 61416 //
     /* 1100743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1100754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1100757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1100760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100782 */     // MIs[0] policy
     /* 1100782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100792 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1100811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100814 */     // GIR_Coverage, 61416,
     /* 1100814 */     GIR_EraseRootFromParent_Done,
     /* 1100815 */   // Label 16202: @1100815
     /* 1100815 */   GIM_Try, /*On fail goto*//*Label 16203*/ GIMT_Encode4(1100892), // Rule ID 61417 //
     /* 1100820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1100831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1100834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1100837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100859 */     // MIs[0] policy
     /* 1100859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100869 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100878 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1100888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100891 */     // GIR_Coverage, 61417,
     /* 1100891 */     GIR_EraseRootFromParent_Done,
     /* 1100892 */   // Label 16203: @1100892
     /* 1100892 */   GIM_Try, /*On fail goto*//*Label 16204*/ GIMT_Encode4(1100969), // Rule ID 61420 //
     /* 1100897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1100908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1100911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1100914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100936 */     // MIs[0] policy
     /* 1100936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100946 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1100949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100955 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100968 */     // GIR_Coverage, 61420,
     /* 1100968 */     GIR_EraseRootFromParent_Done,
     /* 1100969 */   // Label 16204: @1100969
     /* 1100969 */   GIM_Try, /*On fail goto*//*Label 16205*/ GIMT_Encode4(1101046), // Rule ID 61421 //
     /* 1100974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1100985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1100988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1100991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101013 */     // MIs[0] policy
     /* 1101013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101023 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101032 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101045 */     // GIR_Coverage, 61421,
     /* 1101045 */     GIR_EraseRootFromParent_Done,
     /* 1101046 */   // Label 16205: @1101046
     /* 1101046 */   GIM_Try, /*On fail goto*//*Label 16206*/ GIMT_Encode4(1101123), // Rule ID 61424 //
     /* 1101051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1101062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1101065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1101071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101090 */     // MIs[0] policy
     /* 1101090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101122 */     // GIR_Coverage, 61424,
     /* 1101122 */     GIR_EraseRootFromParent_Done,
     /* 1101123 */   // Label 16206: @1101123
     /* 1101123 */   GIM_Try, /*On fail goto*//*Label 16207*/ GIMT_Encode4(1101200), // Rule ID 61425 //
     /* 1101128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1101139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1101142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1101148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101167 */     // MIs[0] policy
     /* 1101167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101177 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101186 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101199 */     // GIR_Coverage, 61425,
     /* 1101199 */     GIR_EraseRootFromParent_Done,
     /* 1101200 */   // Label 16207: @1101200
     /* 1101200 */   GIM_Try, /*On fail goto*//*Label 16208*/ GIMT_Encode4(1101277), // Rule ID 61428 //
     /* 1101205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1101222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101244 */     // MIs[0] policy
     /* 1101244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101254 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101276 */     // GIR_Coverage, 61428,
     /* 1101276 */     GIR_EraseRootFromParent_Done,
     /* 1101277 */   // Label 16208: @1101277
     /* 1101277 */   GIM_Try, /*On fail goto*//*Label 16209*/ GIMT_Encode4(1101354), // Rule ID 61429 //
     /* 1101282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1101299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101321 */     // MIs[0] policy
     /* 1101321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101331 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101340 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101353 */     // GIR_Coverage, 61429,
     /* 1101353 */     GIR_EraseRootFromParent_Done,
     /* 1101354 */   // Label 16209: @1101354
     /* 1101354 */   GIM_Try, /*On fail goto*//*Label 16210*/ GIMT_Encode4(1101431), // Rule ID 61432 //
     /* 1101359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1101370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1101373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1101376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101398 */     // MIs[0] policy
     /* 1101398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101430 */     // GIR_Coverage, 61432,
     /* 1101430 */     GIR_EraseRootFromParent_Done,
     /* 1101431 */   // Label 16210: @1101431
     /* 1101431 */   GIM_Try, /*On fail goto*//*Label 16211*/ GIMT_Encode4(1101508), // Rule ID 61433 //
     /* 1101436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1101447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1101450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1101453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101475 */     // MIs[0] policy
     /* 1101475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101485 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101494 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101507 */     // GIR_Coverage, 61433,
     /* 1101507 */     GIR_EraseRootFromParent_Done,
     /* 1101508 */   // Label 16211: @1101508
     /* 1101508 */   GIM_Try, /*On fail goto*//*Label 16212*/ GIMT_Encode4(1101585), // Rule ID 61436 //
     /* 1101513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1101524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1101527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1101530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1101533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1101540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101552 */     // MIs[0] policy
     /* 1101552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101562 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1101565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101571 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101584 */     // GIR_Coverage, 61436,
     /* 1101584 */     GIR_EraseRootFromParent_Done,
     /* 1101585 */   // Label 16212: @1101585
     /* 1101585 */   GIM_Try, /*On fail goto*//*Label 16213*/ GIMT_Encode4(1101662), // Rule ID 61437 //
     /* 1101590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1101601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1101604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1101607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1101610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1101617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101629 */     // MIs[0] policy
     /* 1101629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101639 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1101642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101648 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101661 */     // GIR_Coverage, 61437,
     /* 1101661 */     GIR_EraseRootFromParent_Done,
     /* 1101662 */   // Label 16213: @1101662
     /* 1101662 */   GIM_Try, /*On fail goto*//*Label 16214*/ GIMT_Encode4(1101739), // Rule ID 61440 //
     /* 1101667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1101678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1101681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1101684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1101687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1101694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101706 */     // MIs[0] policy
     /* 1101706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101716 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1101719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101725 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101738 */     // GIR_Coverage, 61440,
     /* 1101738 */     GIR_EraseRootFromParent_Done,
     /* 1101739 */   // Label 16214: @1101739
     /* 1101739 */   GIM_Try, /*On fail goto*//*Label 16215*/ GIMT_Encode4(1101816), // Rule ID 61441 //
     /* 1101744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1101755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1101758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1101761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1101764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1101771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101783 */     // MIs[0] policy
     /* 1101783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101793 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1101796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101802 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101815 */     // GIR_Coverage, 61441,
     /* 1101815 */     GIR_EraseRootFromParent_Done,
     /* 1101816 */   // Label 16215: @1101816
     /* 1101816 */   GIM_Try, /*On fail goto*//*Label 16216*/ GIMT_Encode4(1101893), // Rule ID 61444 //
     /* 1101821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1101832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1101835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1101838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1101841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1101848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101860 */     // MIs[0] policy
     /* 1101860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101870 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1101873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101892 */     // GIR_Coverage, 61444,
     /* 1101892 */     GIR_EraseRootFromParent_Done,
     /* 1101893 */   // Label 16216: @1101893
     /* 1101893 */   GIM_Try, /*On fail goto*//*Label 16217*/ GIMT_Encode4(1101970), // Rule ID 61445 //
     /* 1101898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1101909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1101912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1101915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1101918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1101925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101937 */     // MIs[0] policy
     /* 1101937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101947 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1101950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101956 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101969 */     // GIR_Coverage, 61445,
     /* 1101969 */     GIR_EraseRootFromParent_Done,
     /* 1101970 */   // Label 16217: @1101970
     /* 1101970 */   GIM_Try, /*On fail goto*//*Label 16218*/ GIMT_Encode4(1102047), // Rule ID 61448 //
     /* 1101975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1101986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1101989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1101992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1101995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102014 */     // MIs[0] policy
     /* 1102014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102046 */     // GIR_Coverage, 61448,
     /* 1102046 */     GIR_EraseRootFromParent_Done,
     /* 1102047 */   // Label 16218: @1102047
     /* 1102047 */   GIM_Try, /*On fail goto*//*Label 16219*/ GIMT_Encode4(1102124), // Rule ID 61449 //
     /* 1102052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1102063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1102066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1102069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102091 */     // MIs[0] policy
     /* 1102091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102110 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102123 */     // GIR_Coverage, 61449,
     /* 1102123 */     GIR_EraseRootFromParent_Done,
     /* 1102124 */   // Label 16219: @1102124
     /* 1102124 */   GIM_Try, /*On fail goto*//*Label 16220*/ GIMT_Encode4(1102201), // Rule ID 61452 //
     /* 1102129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1102140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1102143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102168 */     // MIs[0] policy
     /* 1102168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102178 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102187 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102200 */     // GIR_Coverage, 61452,
     /* 1102200 */     GIR_EraseRootFromParent_Done,
     /* 1102201 */   // Label 16220: @1102201
     /* 1102201 */   GIM_Try, /*On fail goto*//*Label 16221*/ GIMT_Encode4(1102278), // Rule ID 61453 //
     /* 1102206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1102217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1102220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102245 */     // MIs[0] policy
     /* 1102245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102255 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102264 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102277 */     // GIR_Coverage, 61453,
     /* 1102277 */     GIR_EraseRootFromParent_Done,
     /* 1102278 */   // Label 16221: @1102278
     /* 1102278 */   GIM_Try, /*On fail goto*//*Label 16222*/ GIMT_Encode4(1102355), // Rule ID 61456 //
     /* 1102283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1102294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1102297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1102300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102322 */     // MIs[0] policy
     /* 1102322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102332 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102354 */     // GIR_Coverage, 61456,
     /* 1102354 */     GIR_EraseRootFromParent_Done,
     /* 1102355 */   // Label 16222: @1102355
     /* 1102355 */   GIM_Try, /*On fail goto*//*Label 16223*/ GIMT_Encode4(1102432), // Rule ID 61457 //
     /* 1102360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1102371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1102374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1102377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102399 */     // MIs[0] policy
     /* 1102399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102409 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102418 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102431 */     // GIR_Coverage, 61457,
     /* 1102431 */     GIR_EraseRootFromParent_Done,
     /* 1102432 */   // Label 16223: @1102432
     /* 1102432 */   GIM_Try, /*On fail goto*//*Label 16224*/ GIMT_Encode4(1102509), // Rule ID 61460 //
     /* 1102437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1102448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1102451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102476 */     // MIs[0] policy
     /* 1102476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102495 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102508 */     // GIR_Coverage, 61460,
     /* 1102508 */     GIR_EraseRootFromParent_Done,
     /* 1102509 */   // Label 16224: @1102509
     /* 1102509 */   GIM_Try, /*On fail goto*//*Label 16225*/ GIMT_Encode4(1102586), // Rule ID 61461 //
     /* 1102514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1102525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1102528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102553 */     // MIs[0] policy
     /* 1102553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102572 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102585 */     // GIR_Coverage, 61461,
     /* 1102585 */     GIR_EraseRootFromParent_Done,
     /* 1102586 */   // Label 16225: @1102586
     /* 1102586 */   GIM_Try, /*On fail goto*//*Label 16226*/ GIMT_Encode4(1102663), // Rule ID 61464 //
     /* 1102591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1102602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1102605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1102608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102630 */     // MIs[0] policy
     /* 1102630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102640 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102662 */     // GIR_Coverage, 61464,
     /* 1102662 */     GIR_EraseRootFromParent_Done,
     /* 1102663 */   // Label 16226: @1102663
     /* 1102663 */   GIM_Try, /*On fail goto*//*Label 16227*/ GIMT_Encode4(1102740), // Rule ID 61465 //
     /* 1102668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1102679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1102682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1102685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102707 */     // MIs[0] policy
     /* 1102707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102717 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102726 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102739 */     // GIR_Coverage, 61465,
     /* 1102739 */     GIR_EraseRootFromParent_Done,
     /* 1102740 */   // Label 16227: @1102740
     /* 1102740 */   GIM_Try, /*On fail goto*//*Label 16228*/ GIMT_Encode4(1102817), // Rule ID 61468 //
     /* 1102745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1102756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1102759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1102762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102784 */     // MIs[0] policy
     /* 1102784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102794 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102803 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102816 */     // GIR_Coverage, 61468,
     /* 1102816 */     GIR_EraseRootFromParent_Done,
     /* 1102817 */   // Label 16228: @1102817
     /* 1102817 */   GIM_Try, /*On fail goto*//*Label 16229*/ GIMT_Encode4(1102894), // Rule ID 61469 //
     /* 1102822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1102833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1102836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1102839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102861 */     // MIs[0] policy
     /* 1102861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102871 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102880 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102893 */     // GIR_Coverage, 61469,
     /* 1102893 */     GIR_EraseRootFromParent_Done,
     /* 1102894 */   // Label 16229: @1102894
     /* 1102894 */   GIM_Try, /*On fail goto*//*Label 16230*/ GIMT_Encode4(1102971), // Rule ID 61472 //
     /* 1102899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1102910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1102913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1102916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1102919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102938 */     // MIs[0] policy
     /* 1102938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102948 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102957 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1102967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102970 */     // GIR_Coverage, 61472,
     /* 1102970 */     GIR_EraseRootFromParent_Done,
     /* 1102971 */   // Label 16230: @1102971
     /* 1102971 */   GIM_Try, /*On fail goto*//*Label 16231*/ GIMT_Encode4(1103048), // Rule ID 61473 //
     /* 1102976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1102987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1102990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1102993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1102996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1103003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103015 */     // MIs[0] policy
     /* 1103015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103025 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1103028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103034 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103047 */     // GIR_Coverage, 61473,
     /* 1103047 */     GIR_EraseRootFromParent_Done,
     /* 1103048 */   // Label 16231: @1103048
     /* 1103048 */   GIM_Try, /*On fail goto*//*Label 16232*/ GIMT_Encode4(1103125), // Rule ID 61476 //
     /* 1103053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1103064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1103067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1103070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103092 */     // MIs[0] policy
     /* 1103092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103102 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1103105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103124 */     // GIR_Coverage, 61476,
     /* 1103124 */     GIR_EraseRootFromParent_Done,
     /* 1103125 */   // Label 16232: @1103125
     /* 1103125 */   GIM_Try, /*On fail goto*//*Label 16233*/ GIMT_Encode4(1103202), // Rule ID 61477 //
     /* 1103130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1103141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1103144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1103147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103169 */     // MIs[0] policy
     /* 1103169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103179 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1103182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103188 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103201 */     // GIR_Coverage, 61477,
     /* 1103201 */     GIR_EraseRootFromParent_Done,
     /* 1103202 */   // Label 16233: @1103202
     /* 1103202 */   GIM_Try, /*On fail goto*//*Label 16234*/ GIMT_Encode4(1103279), // Rule ID 61480 //
     /* 1103207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1103218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1103221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1103224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103246 */     // MIs[0] policy
     /* 1103246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103256 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1103259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103278 */     // GIR_Coverage, 61480,
     /* 1103278 */     GIR_EraseRootFromParent_Done,
     /* 1103279 */   // Label 16234: @1103279
     /* 1103279 */   GIM_Try, /*On fail goto*//*Label 16235*/ GIMT_Encode4(1103356), // Rule ID 61481 //
     /* 1103284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1103295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1103298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1103301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103323 */     // MIs[0] policy
     /* 1103323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103333 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1103336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103342 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103355 */     // GIR_Coverage, 61481,
     /* 1103355 */     GIR_EraseRootFromParent_Done,
     /* 1103356 */   // Label 16235: @1103356
     /* 1103356 */   GIM_Try, /*On fail goto*//*Label 16236*/ GIMT_Encode4(1103433), // Rule ID 61484 //
     /* 1103361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1103372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1103375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1103378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103400 */     // MIs[0] policy
     /* 1103400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103410 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1103413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103419 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103432 */     // GIR_Coverage, 61484,
     /* 1103432 */     GIR_EraseRootFromParent_Done,
     /* 1103433 */   // Label 16236: @1103433
     /* 1103433 */   GIM_Try, /*On fail goto*//*Label 16237*/ GIMT_Encode4(1103510), // Rule ID 61485 //
     /* 1103438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1103449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1103452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1103455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103477 */     // MIs[0] policy
     /* 1103477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103487 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1103490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103496 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103509 */     // GIR_Coverage, 61485,
     /* 1103509 */     GIR_EraseRootFromParent_Done,
     /* 1103510 */   // Label 16237: @1103510
     /* 1103510 */   GIM_Try, /*On fail goto*//*Label 16238*/ GIMT_Encode4(1103587), // Rule ID 61488 //
     /* 1103515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1103526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1103529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1103532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103554 */     // MIs[0] policy
     /* 1103554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103564 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1103567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103586 */     // GIR_Coverage, 61488,
     /* 1103586 */     GIR_EraseRootFromParent_Done,
     /* 1103587 */   // Label 16238: @1103587
     /* 1103587 */   GIM_Try, /*On fail goto*//*Label 16239*/ GIMT_Encode4(1103664), // Rule ID 61489 //
     /* 1103592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1103603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1103606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1103609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103631 */     // MIs[0] policy
     /* 1103631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103641 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1103644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103650 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103663 */     // GIR_Coverage, 61489,
     /* 1103663 */     GIR_EraseRootFromParent_Done,
     /* 1103664 */   // Label 16239: @1103664
     /* 1103664 */   GIM_Try, /*On fail goto*//*Label 16240*/ GIMT_Encode4(1103741), // Rule ID 61492 //
     /* 1103669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1103680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1103683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1103686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103708 */     // MIs[0] policy
     /* 1103708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103718 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1103721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103740 */     // GIR_Coverage, 61492,
     /* 1103740 */     GIR_EraseRootFromParent_Done,
     /* 1103741 */   // Label 16240: @1103741
     /* 1103741 */   GIM_Try, /*On fail goto*//*Label 16241*/ GIMT_Encode4(1103818), // Rule ID 61493 //
     /* 1103746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1103757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1103760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1103763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103785 */     // MIs[0] policy
     /* 1103785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103795 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1103798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103804 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103817 */     // GIR_Coverage, 61493,
     /* 1103817 */     GIR_EraseRootFromParent_Done,
     /* 1103818 */   // Label 16241: @1103818
     /* 1103818 */   GIM_Try, /*On fail goto*//*Label 16242*/ GIMT_Encode4(1103895), // Rule ID 61496 //
     /* 1103823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1103834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1103837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1103840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103862 */     // MIs[0] policy
     /* 1103862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103872 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1103875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103894 */     // GIR_Coverage, 61496,
     /* 1103894 */     GIR_EraseRootFromParent_Done,
     /* 1103895 */   // Label 16242: @1103895
     /* 1103895 */   GIM_Try, /*On fail goto*//*Label 16243*/ GIMT_Encode4(1103972), // Rule ID 61497 //
     /* 1103900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1103911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1103914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1103917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103939 */     // MIs[0] policy
     /* 1103939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103949 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1103952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103958 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103971 */     // GIR_Coverage, 61497,
     /* 1103971 */     GIR_EraseRootFromParent_Done,
     /* 1103972 */   // Label 16243: @1103972
     /* 1103972 */   GIM_Try, /*On fail goto*//*Label 16244*/ GIMT_Encode4(1104049), // Rule ID 61500 //
     /* 1103977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1103988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1103991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1103994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104016 */     // MIs[0] policy
     /* 1104016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104026 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104035 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104048 */     // GIR_Coverage, 61500,
     /* 1104048 */     GIR_EraseRootFromParent_Done,
     /* 1104049 */   // Label 16244: @1104049
     /* 1104049 */   GIM_Try, /*On fail goto*//*Label 16245*/ GIMT_Encode4(1104126), // Rule ID 61501 //
     /* 1104054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1104065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1104068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1104071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104093 */     // MIs[0] policy
     /* 1104093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104103 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104112 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104125 */     // GIR_Coverage, 61501,
     /* 1104125 */     GIR_EraseRootFromParent_Done,
     /* 1104126 */   // Label 16245: @1104126
     /* 1104126 */   GIM_Try, /*On fail goto*//*Label 16246*/ GIMT_Encode4(1104203), // Rule ID 61504 //
     /* 1104131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1104148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104170 */     // MIs[0] policy
     /* 1104170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104180 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104202 */     // GIR_Coverage, 61504,
     /* 1104202 */     GIR_EraseRootFromParent_Done,
     /* 1104203 */   // Label 16246: @1104203
     /* 1104203 */   GIM_Try, /*On fail goto*//*Label 16247*/ GIMT_Encode4(1104280), // Rule ID 61505 //
     /* 1104208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1104225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104247 */     // MIs[0] policy
     /* 1104247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104257 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104266 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104279 */     // GIR_Coverage, 61505,
     /* 1104279 */     GIR_EraseRootFromParent_Done,
     /* 1104280 */   // Label 16247: @1104280
     /* 1104280 */   GIM_Try, /*On fail goto*//*Label 16248*/ GIMT_Encode4(1104357), // Rule ID 61508 //
     /* 1104285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1104296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1104299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1104302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104324 */     // MIs[0] policy
     /* 1104324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104334 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104343 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104356 */     // GIR_Coverage, 61508,
     /* 1104356 */     GIR_EraseRootFromParent_Done,
     /* 1104357 */   // Label 16248: @1104357
     /* 1104357 */   GIM_Try, /*On fail goto*//*Label 16249*/ GIMT_Encode4(1104434), // Rule ID 61509 //
     /* 1104362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1104373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1104376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1104379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104401 */     // MIs[0] policy
     /* 1104401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104411 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104420 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104433 */     // GIR_Coverage, 61509,
     /* 1104433 */     GIR_EraseRootFromParent_Done,
     /* 1104434 */   // Label 16249: @1104434
     /* 1104434 */   GIM_Try, /*On fail goto*//*Label 16250*/ GIMT_Encode4(1104511), // Rule ID 61512 //
     /* 1104439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1104450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1104453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104478 */     // MIs[0] policy
     /* 1104478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104488 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104510 */     // GIR_Coverage, 61512,
     /* 1104510 */     GIR_EraseRootFromParent_Done,
     /* 1104511 */   // Label 16250: @1104511
     /* 1104511 */   GIM_Try, /*On fail goto*//*Label 16251*/ GIMT_Encode4(1104588), // Rule ID 61513 //
     /* 1104516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1104527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1104530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104555 */     // MIs[0] policy
     /* 1104555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104565 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104574 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104587 */     // GIR_Coverage, 61513,
     /* 1104587 */     GIR_EraseRootFromParent_Done,
     /* 1104588 */   // Label 16251: @1104588
     /* 1104588 */   GIM_Try, /*On fail goto*//*Label 16252*/ GIMT_Encode4(1104665), // Rule ID 61516 //
     /* 1104593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1104604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1104607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1104610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104632 */     // MIs[0] policy
     /* 1104632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104642 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104651 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104664 */     // GIR_Coverage, 61516,
     /* 1104664 */     GIR_EraseRootFromParent_Done,
     /* 1104665 */   // Label 16252: @1104665
     /* 1104665 */   GIM_Try, /*On fail goto*//*Label 16253*/ GIMT_Encode4(1104742), // Rule ID 61517 //
     /* 1104670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1104681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1104684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1104687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104709 */     // MIs[0] policy
     /* 1104709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104719 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104728 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104741 */     // GIR_Coverage, 61517,
     /* 1104741 */     GIR_EraseRootFromParent_Done,
     /* 1104742 */   // Label 16253: @1104742
     /* 1104742 */   GIM_Try, /*On fail goto*//*Label 16254*/ GIMT_Encode4(1104819), // Rule ID 61520 //
     /* 1104747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1104758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1104761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1104764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104786 */     // MIs[0] policy
     /* 1104786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104796 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1104815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104818 */     // GIR_Coverage, 61520,
     /* 1104818 */     GIR_EraseRootFromParent_Done,
     /* 1104819 */   // Label 16254: @1104819
     /* 1104819 */   GIM_Try, /*On fail goto*//*Label 16255*/ GIMT_Encode4(1104896), // Rule ID 61521 //
     /* 1104824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1104835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1104838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1104841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104863 */     // MIs[0] policy
     /* 1104863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104873 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104882 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1104892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104895 */     // GIR_Coverage, 61521,
     /* 1104895 */     GIR_EraseRootFromParent_Done,
     /* 1104896 */   // Label 16255: @1104896
     /* 1104896 */   GIM_Try, /*On fail goto*//*Label 16256*/ GIMT_Encode4(1104973), // Rule ID 61524 //
     /* 1104901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1104912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1104915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1104918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1104921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1104928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104940 */     // MIs[0] policy
     /* 1104940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104950 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1104953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104972 */     // GIR_Coverage, 61524,
     /* 1104972 */     GIR_EraseRootFromParent_Done,
     /* 1104973 */   // Label 16256: @1104973
     /* 1104973 */   GIM_Try, /*On fail goto*//*Label 16257*/ GIMT_Encode4(1105050), // Rule ID 61525 //
     /* 1104978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1104989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1104992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1104995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1104998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105017 */     // MIs[0] policy
     /* 1105017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105027 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105036 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105049 */     // GIR_Coverage, 61525,
     /* 1105049 */     GIR_EraseRootFromParent_Done,
     /* 1105050 */   // Label 16257: @1105050
     /* 1105050 */   GIM_Try, /*On fail goto*//*Label 16258*/ GIMT_Encode4(1105127), // Rule ID 61528 //
     /* 1105055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1105066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1105069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1105072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105094 */     // MIs[0] policy
     /* 1105094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105104 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105126 */     // GIR_Coverage, 61528,
     /* 1105126 */     GIR_EraseRootFromParent_Done,
     /* 1105127 */   // Label 16258: @1105127
     /* 1105127 */   GIM_Try, /*On fail goto*//*Label 16259*/ GIMT_Encode4(1105204), // Rule ID 61529 //
     /* 1105132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1105143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1105146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1105149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105171 */     // MIs[0] policy
     /* 1105171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105181 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105190 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105203 */     // GIR_Coverage, 61529,
     /* 1105203 */     GIR_EraseRootFromParent_Done,
     /* 1105204 */   // Label 16259: @1105204
     /* 1105204 */   GIM_Try, /*On fail goto*//*Label 16260*/ GIMT_Encode4(1105281), // Rule ID 61532 //
     /* 1105209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1105220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1105223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1105226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1105229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105248 */     // MIs[0] policy
     /* 1105248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105258 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105280 */     // GIR_Coverage, 61532,
     /* 1105280 */     GIR_EraseRootFromParent_Done,
     /* 1105281 */   // Label 16260: @1105281
     /* 1105281 */   GIM_Try, /*On fail goto*//*Label 16261*/ GIMT_Encode4(1105358), // Rule ID 61533 //
     /* 1105286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1105297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1105300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1105303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1105306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105325 */     // MIs[0] policy
     /* 1105325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105335 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105344 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105357 */     // GIR_Coverage, 61533,
     /* 1105357 */     GIR_EraseRootFromParent_Done,
     /* 1105358 */   // Label 16261: @1105358
     /* 1105358 */   GIM_Try, /*On fail goto*//*Label 16262*/ GIMT_Encode4(1105435), // Rule ID 61536 //
     /* 1105363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1105374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1105377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1105380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105402 */     // MIs[0] policy
     /* 1105402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105412 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105421 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105434 */     // GIR_Coverage, 61536,
     /* 1105434 */     GIR_EraseRootFromParent_Done,
     /* 1105435 */   // Label 16262: @1105435
     /* 1105435 */   GIM_Try, /*On fail goto*//*Label 16263*/ GIMT_Encode4(1105512), // Rule ID 61537 //
     /* 1105440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1105451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1105454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1105457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105479 */     // MIs[0] policy
     /* 1105479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105489 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105498 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105511 */     // GIR_Coverage, 61537,
     /* 1105511 */     GIR_EraseRootFromParent_Done,
     /* 1105512 */   // Label 16263: @1105512
     /* 1105512 */   GIM_Try, /*On fail goto*//*Label 16264*/ GIMT_Encode4(1105589), // Rule ID 61540 //
     /* 1105517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1105528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1105531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1105534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105556 */     // MIs[0] policy
     /* 1105556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105566 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105588 */     // GIR_Coverage, 61540,
     /* 1105588 */     GIR_EraseRootFromParent_Done,
     /* 1105589 */   // Label 16264: @1105589
     /* 1105589 */   GIM_Try, /*On fail goto*//*Label 16265*/ GIMT_Encode4(1105666), // Rule ID 61541 //
     /* 1105594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1105605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1105608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1105611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105633 */     // MIs[0] policy
     /* 1105633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105643 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105652 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105665 */     // GIR_Coverage, 61541,
     /* 1105665 */     GIR_EraseRootFromParent_Done,
     /* 1105666 */   // Label 16265: @1105666
     /* 1105666 */   GIM_Try, /*On fail goto*//*Label 16266*/ GIMT_Encode4(1105743), // Rule ID 61544 //
     /* 1105671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1105682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1105685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1105688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105710 */     // MIs[0] policy
     /* 1105710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105720 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105742 */     // GIR_Coverage, 61544,
     /* 1105742 */     GIR_EraseRootFromParent_Done,
     /* 1105743 */   // Label 16266: @1105743
     /* 1105743 */   GIM_Try, /*On fail goto*//*Label 16267*/ GIMT_Encode4(1105820), // Rule ID 61545 //
     /* 1105748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1105759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1105762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1105765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105787 */     // MIs[0] policy
     /* 1105787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105797 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105806 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105819 */     // GIR_Coverage, 61545,
     /* 1105819 */     GIR_EraseRootFromParent_Done,
     /* 1105820 */   // Label 16267: @1105820
     /* 1105820 */   GIM_Try, /*On fail goto*//*Label 16268*/ GIMT_Encode4(1105897), // Rule ID 61548 //
     /* 1105825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1105836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1105839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1105842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1105845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105864 */     // MIs[0] policy
     /* 1105864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105883 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105896 */     // GIR_Coverage, 61548,
     /* 1105896 */     GIR_EraseRootFromParent_Done,
     /* 1105897 */   // Label 16268: @1105897
     /* 1105897 */   GIM_Try, /*On fail goto*//*Label 16269*/ GIMT_Encode4(1105974), // Rule ID 61549 //
     /* 1105902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1105913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1105916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1105919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1105922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105941 */     // MIs[0] policy
     /* 1105941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105960 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105973 */     // GIR_Coverage, 61549,
     /* 1105973 */     GIR_EraseRootFromParent_Done,
     /* 1105974 */   // Label 16269: @1105974
     /* 1105974 */   GIM_Try, /*On fail goto*//*Label 16270*/ GIMT_Encode4(1106051), // Rule ID 61552 //
     /* 1105979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1105990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1105993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1105996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106018 */     // MIs[0] policy
     /* 1106018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106028 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106050 */     // GIR_Coverage, 61552,
     /* 1106050 */     GIR_EraseRootFromParent_Done,
     /* 1106051 */   // Label 16270: @1106051
     /* 1106051 */   GIM_Try, /*On fail goto*//*Label 16271*/ GIMT_Encode4(1106128), // Rule ID 61553 //
     /* 1106056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1106073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106095 */     // MIs[0] policy
     /* 1106095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106105 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106114 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106127 */     // GIR_Coverage, 61553,
     /* 1106127 */     GIR_EraseRootFromParent_Done,
     /* 1106128 */   // Label 16271: @1106128
     /* 1106128 */   GIM_Try, /*On fail goto*//*Label 16272*/ GIMT_Encode4(1106205), // Rule ID 61556 //
     /* 1106133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106172 */     // MIs[0] policy
     /* 1106172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106182 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106204 */     // GIR_Coverage, 61556,
     /* 1106204 */     GIR_EraseRootFromParent_Done,
     /* 1106205 */   // Label 16272: @1106205
     /* 1106205 */   GIM_Try, /*On fail goto*//*Label 16273*/ GIMT_Encode4(1106282), // Rule ID 61557 //
     /* 1106210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106249 */     // MIs[0] policy
     /* 1106249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106259 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106268 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106281 */     // GIR_Coverage, 61557,
     /* 1106281 */     GIR_EraseRootFromParent_Done,
     /* 1106282 */   // Label 16273: @1106282
     /* 1106282 */   GIM_Try, /*On fail goto*//*Label 16274*/ GIMT_Encode4(1106359), // Rule ID 61560 //
     /* 1106287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1106304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1106307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106326 */     // MIs[0] policy
     /* 1106326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106336 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1106339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106358 */     // GIR_Coverage, 61560,
     /* 1106358 */     GIR_EraseRootFromParent_Done,
     /* 1106359 */   // Label 16274: @1106359
     /* 1106359 */   GIM_Try, /*On fail goto*//*Label 16275*/ GIMT_Encode4(1106436), // Rule ID 61561 //
     /* 1106364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1106381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1106384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106403 */     // MIs[0] policy
     /* 1106403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106413 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1106416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106422 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106435 */     // GIR_Coverage, 61561,
     /* 1106435 */     GIR_EraseRootFromParent_Done,
     /* 1106436 */   // Label 16275: @1106436
     /* 1106436 */   GIM_Try, /*On fail goto*//*Label 16276*/ GIMT_Encode4(1106513), // Rule ID 61564 //
     /* 1106441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1106452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1106455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1106458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106480 */     // MIs[0] policy
     /* 1106480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106490 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106499 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106512 */     // GIR_Coverage, 61564,
     /* 1106512 */     GIR_EraseRootFromParent_Done,
     /* 1106513 */   // Label 16276: @1106513
     /* 1106513 */   GIM_Try, /*On fail goto*//*Label 16277*/ GIMT_Encode4(1106590), // Rule ID 61565 //
     /* 1106518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1106529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1106532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1106535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106557 */     // MIs[0] policy
     /* 1106557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106567 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106576 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106589 */     // GIR_Coverage, 61565,
     /* 1106589 */     GIR_EraseRootFromParent_Done,
     /* 1106590 */   // Label 16277: @1106590
     /* 1106590 */   GIM_Try, /*On fail goto*//*Label 16278*/ GIMT_Encode4(1106667), // Rule ID 61568 //
     /* 1106595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1106606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1106609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1106612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106634 */     // MIs[0] policy
     /* 1106634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106644 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106666 */     // GIR_Coverage, 61568,
     /* 1106666 */     GIR_EraseRootFromParent_Done,
     /* 1106667 */   // Label 16278: @1106667
     /* 1106667 */   GIM_Try, /*On fail goto*//*Label 16279*/ GIMT_Encode4(1106744), // Rule ID 61569 //
     /* 1106672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1106683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1106686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1106689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106711 */     // MIs[0] policy
     /* 1106711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106721 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106730 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106743 */     // GIR_Coverage, 61569,
     /* 1106743 */     GIR_EraseRootFromParent_Done,
     /* 1106744 */   // Label 16279: @1106744
     /* 1106744 */   GIM_Try, /*On fail goto*//*Label 16280*/ GIMT_Encode4(1106821), // Rule ID 62094 //
     /* 1106749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1106752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1106760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1106763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1106766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1106769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106788 */     // MIs[0] policy
     /* 1106788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106798 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1106801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106820 */     // GIR_Coverage, 62094,
     /* 1106820 */     GIR_EraseRootFromParent_Done,
     /* 1106821 */   // Label 16280: @1106821
     /* 1106821 */   GIM_Try, /*On fail goto*//*Label 16281*/ GIMT_Encode4(1106898), // Rule ID 62095 //
     /* 1106826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1106829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1106837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1106840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1106843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1106846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106865 */     // MIs[0] policy
     /* 1106865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106875 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1106878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106897 */     // GIR_Coverage, 62095,
     /* 1106897 */     GIR_EraseRootFromParent_Done,
     /* 1106898 */   // Label 16281: @1106898
     /* 1106898 */   GIM_Try, /*On fail goto*//*Label 16282*/ GIMT_Encode4(1106975), // Rule ID 62096 //
     /* 1106903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1106906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1106923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106942 */     // MIs[0] policy
     /* 1106942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106952 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1106955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106974 */     // GIR_Coverage, 62096,
     /* 1106974 */     GIR_EraseRootFromParent_Done,
     /* 1106975 */   // Label 16282: @1106975
     /* 1106975 */   GIM_Try, /*On fail goto*//*Label 16283*/ GIMT_Encode4(1107052), // Rule ID 62097 //
     /* 1106980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1106983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1107000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107019 */     // MIs[0] policy
     /* 1107019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107029 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1107032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107051 */     // GIR_Coverage, 62097,
     /* 1107051 */     GIR_EraseRootFromParent_Done,
     /* 1107052 */   // Label 16283: @1107052
     /* 1107052 */   GIM_Try, /*On fail goto*//*Label 16284*/ GIMT_Encode4(1107129), // Rule ID 62098 //
     /* 1107057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1107060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107096 */     // MIs[0] policy
     /* 1107096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107106 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1107109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107128 */     // GIR_Coverage, 62098,
     /* 1107128 */     GIR_EraseRootFromParent_Done,
     /* 1107129 */   // Label 16284: @1107129
     /* 1107129 */   GIM_Try, /*On fail goto*//*Label 16285*/ GIMT_Encode4(1107206), // Rule ID 62099 //
     /* 1107134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1107137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107173 */     // MIs[0] policy
     /* 1107173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107183 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1107186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107205 */     // GIR_Coverage, 62099,
     /* 1107205 */     GIR_EraseRootFromParent_Done,
     /* 1107206 */   // Label 16285: @1107206
     /* 1107206 */   GIM_Try, /*On fail goto*//*Label 16286*/ GIMT_Encode4(1107283), // Rule ID 62100 //
     /* 1107211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1107214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1107231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107250 */     // MIs[0] policy
     /* 1107250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107260 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1107263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107282 */     // GIR_Coverage, 62100,
     /* 1107282 */     GIR_EraseRootFromParent_Done,
     /* 1107283 */   // Label 16286: @1107283
     /* 1107283 */   GIM_Try, /*On fail goto*//*Label 16287*/ GIMT_Encode4(1107360), // Rule ID 62101 //
     /* 1107288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1107291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1107308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107327 */     // MIs[0] policy
     /* 1107327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107337 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1107340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107359 */     // GIR_Coverage, 62101,
     /* 1107359 */     GIR_EraseRootFromParent_Done,
     /* 1107360 */   // Label 16287: @1107360
     /* 1107360 */   GIM_Try, /*On fail goto*//*Label 16288*/ GIMT_Encode4(1107437), // Rule ID 62304 //
     /* 1107365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1107376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1107379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1107382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1107385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107404 */     // MIs[0] policy
     /* 1107404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107414 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1107417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107436 */     // GIR_Coverage, 62304,
     /* 1107436 */     GIR_EraseRootFromParent_Done,
     /* 1107437 */   // Label 16288: @1107437
     /* 1107437 */   GIM_Try, /*On fail goto*//*Label 16289*/ GIMT_Encode4(1107514), // Rule ID 62305 //
     /* 1107442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1107453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1107456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1107459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1107462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107481 */     // MIs[0] policy
     /* 1107481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107491 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1107494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107513 */     // GIR_Coverage, 62305,
     /* 1107513 */     GIR_EraseRootFromParent_Done,
     /* 1107514 */   // Label 16289: @1107514
     /* 1107514 */   GIM_Try, /*On fail goto*//*Label 16290*/ GIMT_Encode4(1107591), // Rule ID 62306 //
     /* 1107519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1107539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107558 */     // MIs[0] policy
     /* 1107558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107568 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1107571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107590 */     // GIR_Coverage, 62306,
     /* 1107590 */     GIR_EraseRootFromParent_Done,
     /* 1107591 */   // Label 16290: @1107591
     /* 1107591 */   GIM_Try, /*On fail goto*//*Label 16291*/ GIMT_Encode4(1107668), // Rule ID 62307 //
     /* 1107596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1107616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107635 */     // MIs[0] policy
     /* 1107635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107645 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1107648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107667 */     // GIR_Coverage, 62307,
     /* 1107667 */     GIR_EraseRootFromParent_Done,
     /* 1107668 */   // Label 16291: @1107668
     /* 1107668 */   GIM_Try, /*On fail goto*//*Label 16292*/ GIMT_Encode4(1107745), // Rule ID 62308 //
     /* 1107673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1107684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1107687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1107693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107712 */     // MIs[0] policy
     /* 1107712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1107725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107744 */     // GIR_Coverage, 62308,
     /* 1107744 */     GIR_EraseRootFromParent_Done,
     /* 1107745 */   // Label 16292: @1107745
     /* 1107745 */   GIM_Try, /*On fail goto*//*Label 16293*/ GIMT_Encode4(1107822), // Rule ID 62309 //
     /* 1107750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1107761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1107764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1107770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107789 */     // MIs[0] policy
     /* 1107789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1107802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107821 */     // GIR_Coverage, 62309,
     /* 1107821 */     GIR_EraseRootFromParent_Done,
     /* 1107822 */   // Label 16293: @1107822
     /* 1107822 */   GIM_Try, /*On fail goto*//*Label 16294*/ GIMT_Encode4(1107899), // Rule ID 62310 //
     /* 1107827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107866 */     // MIs[0] policy
     /* 1107866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107876 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1107879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107898 */     // GIR_Coverage, 62310,
     /* 1107898 */     GIR_EraseRootFromParent_Done,
     /* 1107899 */   // Label 16294: @1107899
     /* 1107899 */   GIM_Try, /*On fail goto*//*Label 16295*/ GIMT_Encode4(1107976), // Rule ID 62311 //
     /* 1107904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107943 */     // MIs[0] policy
     /* 1107943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107953 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1107956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107975 */     // GIR_Coverage, 62311,
     /* 1107975 */     GIR_EraseRootFromParent_Done,
     /* 1107976 */   // Label 16295: @1107976
     /* 1107976 */   GIM_Try, /*On fail goto*//*Label 16296*/ GIMT_Encode4(1108053), // Rule ID 62312 //
     /* 1107981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1108001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108020 */     // MIs[0] policy
     /* 1108020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108052 */     // GIR_Coverage, 62312,
     /* 1108052 */     GIR_EraseRootFromParent_Done,
     /* 1108053 */   // Label 16296: @1108053
     /* 1108053 */   GIM_Try, /*On fail goto*//*Label 16297*/ GIMT_Encode4(1108130), // Rule ID 62313 //
     /* 1108058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1108069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1108072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1108075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1108078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108097 */     // MIs[0] policy
     /* 1108097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108107 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108129 */     // GIR_Coverage, 62313,
     /* 1108129 */     GIR_EraseRootFromParent_Done,
     /* 1108130 */   // Label 16297: @1108130
     /* 1108130 */   GIM_Try, /*On fail goto*//*Label 16298*/ GIMT_Encode4(1108207), // Rule ID 62314 //
     /* 1108135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108174 */     // MIs[0] policy
     /* 1108174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108184 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1108187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108206 */     // GIR_Coverage, 62314,
     /* 1108206 */     GIR_EraseRootFromParent_Done,
     /* 1108207 */   // Label 16298: @1108207
     /* 1108207 */   GIM_Try, /*On fail goto*//*Label 16299*/ GIMT_Encode4(1108284), // Rule ID 62315 //
     /* 1108212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108251 */     // MIs[0] policy
     /* 1108251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108261 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1108264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108283 */     // GIR_Coverage, 62315,
     /* 1108283 */     GIR_EraseRootFromParent_Done,
     /* 1108284 */   // Label 16299: @1108284
     /* 1108284 */   GIM_Try, /*On fail goto*//*Label 16300*/ GIMT_Encode4(1108361), // Rule ID 62316 //
     /* 1108289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108328 */     // MIs[0] policy
     /* 1108328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108338 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1108341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108360 */     // GIR_Coverage, 62316,
     /* 1108360 */     GIR_EraseRootFromParent_Done,
     /* 1108361 */   // Label 16300: @1108361
     /* 1108361 */   GIM_Try, /*On fail goto*//*Label 16301*/ GIMT_Encode4(1108438), // Rule ID 62317 //
     /* 1108366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108405 */     // MIs[0] policy
     /* 1108405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108415 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1108418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108437 */     // GIR_Coverage, 62317,
     /* 1108437 */     GIR_EraseRootFromParent_Done,
     /* 1108438 */   // Label 16301: @1108438
     /* 1108438 */   GIM_Try, /*On fail goto*//*Label 16302*/ GIMT_Encode4(1108515), // Rule ID 62318 //
     /* 1108443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108482 */     // MIs[0] policy
     /* 1108482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1108495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108514 */     // GIR_Coverage, 62318,
     /* 1108514 */     GIR_EraseRootFromParent_Done,
     /* 1108515 */   // Label 16302: @1108515
     /* 1108515 */   GIM_Try, /*On fail goto*//*Label 16303*/ GIMT_Encode4(1108592), // Rule ID 62319 //
     /* 1108520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108559 */     // MIs[0] policy
     /* 1108559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108569 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1108572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108591 */     // GIR_Coverage, 62319,
     /* 1108591 */     GIR_EraseRootFromParent_Done,
     /* 1108592 */   // Label 16303: @1108592
     /* 1108592 */   GIM_Try, /*On fail goto*//*Label 16304*/ GIMT_Encode4(1108669), // Rule ID 62320 //
     /* 1108597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1108608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1108611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1108614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108636 */     // MIs[0] policy
     /* 1108636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108646 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1108649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108668 */     // GIR_Coverage, 62320,
     /* 1108668 */     GIR_EraseRootFromParent_Done,
     /* 1108669 */   // Label 16304: @1108669
     /* 1108669 */   GIM_Try, /*On fail goto*//*Label 16305*/ GIMT_Encode4(1108746), // Rule ID 62321 //
     /* 1108674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1108685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1108688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1108691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108713 */     // MIs[0] policy
     /* 1108713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108723 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1108726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108745 */     // GIR_Coverage, 62321,
     /* 1108745 */     GIR_EraseRootFromParent_Done,
     /* 1108746 */   // Label 16305: @1108746
     /* 1108746 */   GIM_Try, /*On fail goto*//*Label 16306*/ GIMT_Encode4(1108823), // Rule ID 62322 //
     /* 1108751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1108762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1108765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1108768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1108771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108790 */     // MIs[0] policy
     /* 1108790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108800 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108822 */     // GIR_Coverage, 62322,
     /* 1108822 */     GIR_EraseRootFromParent_Done,
     /* 1108823 */   // Label 16306: @1108823
     /* 1108823 */   GIM_Try, /*On fail goto*//*Label 16307*/ GIMT_Encode4(1108900), // Rule ID 62323 //
     /* 1108828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1108839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1108842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1108845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1108848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108867 */     // MIs[0] policy
     /* 1108867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108877 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108899 */     // GIR_Coverage, 62323,
     /* 1108899 */     GIR_EraseRootFromParent_Done,
     /* 1108900 */   // Label 16307: @1108900
     /* 1108900 */   GIM_Try, /*On fail goto*//*Label 16308*/ GIMT_Encode4(1108977), // Rule ID 62324 //
     /* 1108905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1108913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108944 */     // MIs[0] policy
     /* 1108944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108954 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1108957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108976 */     // GIR_Coverage, 62324,
     /* 1108976 */     GIR_EraseRootFromParent_Done,
     /* 1108977 */   // Label 16308: @1108977
     /* 1108977 */   GIM_Try, /*On fail goto*//*Label 16309*/ GIMT_Encode4(1109054), // Rule ID 62325 //
     /* 1108982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1108990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1109002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109021 */     // MIs[0] policy
     /* 1109021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109031 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1109034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109053 */     // GIR_Coverage, 62325,
     /* 1109053 */     GIR_EraseRootFromParent_Done,
     /* 1109054 */   // Label 16309: @1109054
     /* 1109054 */   GIM_Try, /*On fail goto*//*Label 16310*/ GIMT_Encode4(1109131), // Rule ID 62326 //
     /* 1109059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109098 */     // MIs[0] policy
     /* 1109098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109108 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1109111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109130 */     // GIR_Coverage, 62326,
     /* 1109130 */     GIR_EraseRootFromParent_Done,
     /* 1109131 */   // Label 16310: @1109131
     /* 1109131 */   GIM_Try, /*On fail goto*//*Label 16311*/ GIMT_Encode4(1109208), // Rule ID 62327 //
     /* 1109136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109175 */     // MIs[0] policy
     /* 1109175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109185 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1109188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109207 */     // GIR_Coverage, 62327,
     /* 1109207 */     GIR_EraseRootFromParent_Done,
     /* 1109208 */   // Label 16311: @1109208
     /* 1109208 */   GIM_Try, /*On fail goto*//*Label 16312*/ GIMT_Encode4(1109285), // Rule ID 62328 //
     /* 1109213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1109233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109252 */     // MIs[0] policy
     /* 1109252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1109265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109284 */     // GIR_Coverage, 62328,
     /* 1109284 */     GIR_EraseRootFromParent_Done,
     /* 1109285 */   // Label 16312: @1109285
     /* 1109285 */   GIM_Try, /*On fail goto*//*Label 16313*/ GIMT_Encode4(1109362), // Rule ID 62329 //
     /* 1109290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1109310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109329 */     // MIs[0] policy
     /* 1109329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109339 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1109342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109361 */     // GIR_Coverage, 62329,
     /* 1109361 */     GIR_EraseRootFromParent_Done,
     /* 1109362 */   // Label 16313: @1109362
     /* 1109362 */   GIM_Try, /*On fail goto*//*Label 16314*/ GIMT_Encode4(1109439), // Rule ID 62330 //
     /* 1109367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109406 */     // MIs[0] policy
     /* 1109406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1109419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109438 */     // GIR_Coverage, 62330,
     /* 1109438 */     GIR_EraseRootFromParent_Done,
     /* 1109439 */   // Label 16314: @1109439
     /* 1109439 */   GIM_Try, /*On fail goto*//*Label 16315*/ GIMT_Encode4(1109516), // Rule ID 62331 //
     /* 1109444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109483 */     // MIs[0] policy
     /* 1109483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109493 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1109496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109515 */     // GIR_Coverage, 62331,
     /* 1109515 */     GIR_EraseRootFromParent_Done,
     /* 1109516 */   // Label 16315: @1109516
     /* 1109516 */   GIM_Try, /*On fail goto*//*Label 16316*/ GIMT_Encode4(1109593), // Rule ID 62332 //
     /* 1109521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1109541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109560 */     // MIs[0] policy
     /* 1109560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109570 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1109573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109592 */     // GIR_Coverage, 62332,
     /* 1109592 */     GIR_EraseRootFromParent_Done,
     /* 1109593 */   // Label 16316: @1109593
     /* 1109593 */   GIM_Try, /*On fail goto*//*Label 16317*/ GIMT_Encode4(1109670), // Rule ID 62333 //
     /* 1109598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1109618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109637 */     // MIs[0] policy
     /* 1109637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109647 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1109650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109669 */     // GIR_Coverage, 62333,
     /* 1109669 */     GIR_EraseRootFromParent_Done,
     /* 1109670 */   // Label 16317: @1109670
     /* 1109670 */   GIM_Try, /*On fail goto*//*Label 16318*/ GIMT_Encode4(1109747), // Rule ID 62334 //
     /* 1109675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1109678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1109686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1109689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1109692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1109695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109714 */     // MIs[0] policy
     /* 1109714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1109727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109746 */     // GIR_Coverage, 62334,
     /* 1109746 */     GIR_EraseRootFromParent_Done,
     /* 1109747 */   // Label 16318: @1109747
     /* 1109747 */   GIM_Try, /*On fail goto*//*Label 16319*/ GIMT_Encode4(1109824), // Rule ID 62335 //
     /* 1109752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1109755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1109763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1109766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1109769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1109772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109791 */     // MIs[0] policy
     /* 1109791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109801 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1109804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109823 */     // GIR_Coverage, 62335,
     /* 1109823 */     GIR_EraseRootFromParent_Done,
     /* 1109824 */   // Label 16319: @1109824
     /* 1109824 */   GIM_Try, /*On fail goto*//*Label 16320*/ GIMT_Encode4(1109901), // Rule ID 62336 //
     /* 1109829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1109832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109868 */     // MIs[0] policy
     /* 1109868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109878 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1109881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109900 */     // GIR_Coverage, 62336,
     /* 1109900 */     GIR_EraseRootFromParent_Done,
     /* 1109901 */   // Label 16320: @1109901
     /* 1109901 */   GIM_Try, /*On fail goto*//*Label 16321*/ GIMT_Encode4(1109978), // Rule ID 62337 //
     /* 1109906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1109909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109945 */     // MIs[0] policy
     /* 1109945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109955 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1109958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109977 */     // GIR_Coverage, 62337,
     /* 1109977 */     GIR_EraseRootFromParent_Done,
     /* 1109978 */   // Label 16321: @1109978
     /* 1109978 */   GIM_Try, /*On fail goto*//*Label 16322*/ GIMT_Encode4(1110055), // Rule ID 62338 //
     /* 1109983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1109986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1109994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1109997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1110000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1110003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110022 */     // MIs[0] policy
     /* 1110022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110032 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110054 */     // GIR_Coverage, 62338,
     /* 1110054 */     GIR_EraseRootFromParent_Done,
     /* 1110055 */   // Label 16322: @1110055
     /* 1110055 */   GIM_Try, /*On fail goto*//*Label 16323*/ GIMT_Encode4(1110132), // Rule ID 62339 //
     /* 1110060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1110071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1110074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1110077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1110080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110099 */     // MIs[0] policy
     /* 1110099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110109 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110131 */     // GIR_Coverage, 62339,
     /* 1110131 */     GIR_EraseRootFromParent_Done,
     /* 1110132 */   // Label 16323: @1110132
     /* 1110132 */   GIM_Try, /*On fail goto*//*Label 16324*/ GIMT_Encode4(1110209), // Rule ID 62340 //
     /* 1110137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1110157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110176 */     // MIs[0] policy
     /* 1110176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110186 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110208 */     // GIR_Coverage, 62340,
     /* 1110208 */     GIR_EraseRootFromParent_Done,
     /* 1110209 */   // Label 16324: @1110209
     /* 1110209 */   GIM_Try, /*On fail goto*//*Label 16325*/ GIMT_Encode4(1110286), // Rule ID 62341 //
     /* 1110214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1110234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110253 */     // MIs[0] policy
     /* 1110253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110285 */     // GIR_Coverage, 62341,
     /* 1110285 */     GIR_EraseRootFromParent_Done,
     /* 1110286 */   // Label 16325: @1110286
     /* 1110286 */   GIM_Try, /*On fail goto*//*Label 16326*/ GIMT_Encode4(1110363), // Rule ID 62342 //
     /* 1110291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1110311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110330 */     // MIs[0] policy
     /* 1110330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110340 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110362 */     // GIR_Coverage, 62342,
     /* 1110362 */     GIR_EraseRootFromParent_Done,
     /* 1110363 */   // Label 16326: @1110363
     /* 1110363 */   GIM_Try, /*On fail goto*//*Label 16327*/ GIMT_Encode4(1110440), // Rule ID 62343 //
     /* 1110368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1110388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110407 */     // MIs[0] policy
     /* 1110407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110417 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110439 */     // GIR_Coverage, 62343,
     /* 1110439 */     GIR_EraseRootFromParent_Done,
     /* 1110440 */   // Label 16327: @1110440
     /* 1110440 */   GIM_Try, /*On fail goto*//*Label 16328*/ GIMT_Encode4(1110517), // Rule ID 62344 //
     /* 1110445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1110465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110484 */     // MIs[0] policy
     /* 1110484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110494 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1110497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110516 */     // GIR_Coverage, 62344,
     /* 1110516 */     GIR_EraseRootFromParent_Done,
     /* 1110517 */   // Label 16328: @1110517
     /* 1110517 */   GIM_Try, /*On fail goto*//*Label 16329*/ GIMT_Encode4(1110594), // Rule ID 62345 //
     /* 1110522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1110542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110561 */     // MIs[0] policy
     /* 1110561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110571 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1110574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110593 */     // GIR_Coverage, 62345,
     /* 1110593 */     GIR_EraseRootFromParent_Done,
     /* 1110594 */   // Label 16329: @1110594
     /* 1110594 */   GIM_Try, /*On fail goto*//*Label 16330*/ GIMT_Encode4(1110671), // Rule ID 62346 //
     /* 1110599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1110610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1110613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1110616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1110619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110638 */     // MIs[0] policy
     /* 1110638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110648 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110670 */     // GIR_Coverage, 62346,
     /* 1110670 */     GIR_EraseRootFromParent_Done,
     /* 1110671 */   // Label 16330: @1110671
     /* 1110671 */   GIM_Try, /*On fail goto*//*Label 16331*/ GIMT_Encode4(1110748), // Rule ID 62347 //
     /* 1110676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1110687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1110690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1110693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1110696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110715 */     // MIs[0] policy
     /* 1110715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110725 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110747 */     // GIR_Coverage, 62347,
     /* 1110747 */     GIR_EraseRootFromParent_Done,
     /* 1110748 */   // Label 16331: @1110748
     /* 1110748 */   GIM_Try, /*On fail goto*//*Label 16332*/ GIMT_Encode4(1110825), // Rule ID 62348 //
     /* 1110753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1110764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1110767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1110770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1110773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110792 */     // MIs[0] policy
     /* 1110792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110802 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110824 */     // GIR_Coverage, 62348,
     /* 1110824 */     GIR_EraseRootFromParent_Done,
     /* 1110825 */   // Label 16332: @1110825
     /* 1110825 */   GIM_Try, /*On fail goto*//*Label 16333*/ GIMT_Encode4(1110902), // Rule ID 62349 //
     /* 1110830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1110841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1110844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1110847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1110850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110869 */     // MIs[0] policy
     /* 1110869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110879 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110901 */     // GIR_Coverage, 62349,
     /* 1110901 */     GIR_EraseRootFromParent_Done,
     /* 1110902 */   // Label 16333: @1110902
     /* 1110902 */   GIM_Try, /*On fail goto*//*Label 16334*/ GIMT_Encode4(1110979), // Rule ID 62350 //
     /* 1110907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1110918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1110921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1110924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1110927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110946 */     // MIs[0] policy
     /* 1110946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110956 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1110959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110978 */     // GIR_Coverage, 62350,
     /* 1110978 */     GIR_EraseRootFromParent_Done,
     /* 1110979 */   // Label 16334: @1110979
     /* 1110979 */   GIM_Try, /*On fail goto*//*Label 16335*/ GIMT_Encode4(1111056), // Rule ID 62351 //
     /* 1110984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1110995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1110998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1111001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1111004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111023 */     // MIs[0] policy
     /* 1111023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111033 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111055 */     // GIR_Coverage, 62351,
     /* 1111055 */     GIR_EraseRootFromParent_Done,
     /* 1111056 */   // Label 16335: @1111056
     /* 1111056 */   GIM_Try, /*On fail goto*//*Label 16336*/ GIMT_Encode4(1111133), // Rule ID 62352 //
     /* 1111061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111100 */     // MIs[0] policy
     /* 1111100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111110 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1111113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111132 */     // GIR_Coverage, 62352,
     /* 1111132 */     GIR_EraseRootFromParent_Done,
     /* 1111133 */   // Label 16336: @1111133
     /* 1111133 */   GIM_Try, /*On fail goto*//*Label 16337*/ GIMT_Encode4(1111210), // Rule ID 62353 //
     /* 1111138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111177 */     // MIs[0] policy
     /* 1111177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111187 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1111190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111209 */     // GIR_Coverage, 62353,
     /* 1111209 */     GIR_EraseRootFromParent_Done,
     /* 1111210 */   // Label 16337: @1111210
     /* 1111210 */   GIM_Try, /*On fail goto*//*Label 16338*/ GIMT_Encode4(1111287), // Rule ID 62354 //
     /* 1111215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111254 */     // MIs[0] policy
     /* 1111254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111286 */     // GIR_Coverage, 62354,
     /* 1111286 */     GIR_EraseRootFromParent_Done,
     /* 1111287 */   // Label 16338: @1111287
     /* 1111287 */   GIM_Try, /*On fail goto*//*Label 16339*/ GIMT_Encode4(1111364), // Rule ID 62355 //
     /* 1111292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111331 */     // MIs[0] policy
     /* 1111331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111341 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111363 */     // GIR_Coverage, 62355,
     /* 1111363 */     GIR_EraseRootFromParent_Done,
     /* 1111364 */   // Label 16339: @1111364
     /* 1111364 */   GIM_Try, /*On fail goto*//*Label 16340*/ GIMT_Encode4(1111441), // Rule ID 62356 //
     /* 1111369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1111380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1111383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1111386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1111389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111408 */     // MIs[0] policy
     /* 1111408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111418 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111440 */     // GIR_Coverage, 62356,
     /* 1111440 */     GIR_EraseRootFromParent_Done,
     /* 1111441 */   // Label 16340: @1111441
     /* 1111441 */   GIM_Try, /*On fail goto*//*Label 16341*/ GIMT_Encode4(1111518), // Rule ID 62357 //
     /* 1111446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1111457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1111460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1111463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1111466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111485 */     // MIs[0] policy
     /* 1111485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111495 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111517 */     // GIR_Coverage, 62357,
     /* 1111517 */     GIR_EraseRootFromParent_Done,
     /* 1111518 */   // Label 16341: @1111518
     /* 1111518 */   GIM_Try, /*On fail goto*//*Label 16342*/ GIMT_Encode4(1111595), // Rule ID 62358 //
     /* 1111523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1111540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1111543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111562 */     // MIs[0] policy
     /* 1111562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111594 */     // GIR_Coverage, 62358,
     /* 1111594 */     GIR_EraseRootFromParent_Done,
     /* 1111595 */   // Label 16342: @1111595
     /* 1111595 */   GIM_Try, /*On fail goto*//*Label 16343*/ GIMT_Encode4(1111672), // Rule ID 62359 //
     /* 1111600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1111617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1111620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111639 */     // MIs[0] policy
     /* 1111639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111649 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111671 */     // GIR_Coverage, 62359,
     /* 1111671 */     GIR_EraseRootFromParent_Done,
     /* 1111672 */   // Label 16343: @1111672
     /* 1111672 */   GIM_Try, /*On fail goto*//*Label 16344*/ GIMT_Encode4(1111749), // Rule ID 62360 //
     /* 1111677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1111688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1111691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1111694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1111697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111716 */     // MIs[0] policy
     /* 1111716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111726 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111748 */     // GIR_Coverage, 62360,
     /* 1111748 */     GIR_EraseRootFromParent_Done,
     /* 1111749 */   // Label 16344: @1111749
     /* 1111749 */   GIM_Try, /*On fail goto*//*Label 16345*/ GIMT_Encode4(1111826), // Rule ID 62361 //
     /* 1111754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1111765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1111768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1111771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1111774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111793 */     // MIs[0] policy
     /* 1111793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111803 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111825 */     // GIR_Coverage, 62361,
     /* 1111825 */     GIR_EraseRootFromParent_Done,
     /* 1111826 */   // Label 16345: @1111826
     /* 1111826 */   GIM_Try, /*On fail goto*//*Label 16346*/ GIMT_Encode4(1111903), // Rule ID 62362 //
     /* 1111831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111870 */     // MIs[0] policy
     /* 1111870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111880 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111902 */     // GIR_Coverage, 62362,
     /* 1111902 */     GIR_EraseRootFromParent_Done,
     /* 1111903 */   // Label 16346: @1111903
     /* 1111903 */   GIM_Try, /*On fail goto*//*Label 16347*/ GIMT_Encode4(1111980), // Rule ID 62363 //
     /* 1111908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111947 */     // MIs[0] policy
     /* 1111947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111957 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111979 */     // GIR_Coverage, 62363,
     /* 1111979 */     GIR_EraseRootFromParent_Done,
     /* 1111980 */   // Label 16347: @1111980
     /* 1111980 */   GIM_Try, /*On fail goto*//*Label 16348*/ GIMT_Encode4(1112057), // Rule ID 62364 //
     /* 1111985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1111996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1111999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1112002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1112005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112024 */     // MIs[0] policy
     /* 1112024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112034 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112056 */     // GIR_Coverage, 62364,
     /* 1112056 */     GIR_EraseRootFromParent_Done,
     /* 1112057 */   // Label 16348: @1112057
     /* 1112057 */   GIM_Try, /*On fail goto*//*Label 16349*/ GIMT_Encode4(1112134), // Rule ID 62365 //
     /* 1112062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1112073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1112076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1112079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1112082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112101 */     // MIs[0] policy
     /* 1112101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112111 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112133 */     // GIR_Coverage, 62365,
     /* 1112133 */     GIR_EraseRootFromParent_Done,
     /* 1112134 */   // Label 16349: @1112134
     /* 1112134 */   GIM_Try, /*On fail goto*//*Label 16350*/ GIMT_Encode4(1112211), // Rule ID 62366 //
     /* 1112139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1112150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1112153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1112156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1112159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112178 */     // MIs[0] policy
     /* 1112178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112188 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112210 */     // GIR_Coverage, 62366,
     /* 1112210 */     GIR_EraseRootFromParent_Done,
     /* 1112211 */   // Label 16350: @1112211
     /* 1112211 */   GIM_Try, /*On fail goto*//*Label 16351*/ GIMT_Encode4(1112288), // Rule ID 62367 //
     /* 1112216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1112227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1112230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1112233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1112236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112255 */     // MIs[0] policy
     /* 1112255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112265 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112287 */     // GIR_Coverage, 62367,
     /* 1112287 */     GIR_EraseRootFromParent_Done,
     /* 1112288 */   // Label 16351: @1112288
     /* 1112288 */   GIM_Try, /*On fail goto*//*Label 16352*/ GIMT_Encode4(1112365), // Rule ID 62368 //
     /* 1112293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1112304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1112307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1112310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1112313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112332 */     // MIs[0] policy
     /* 1112332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112342 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112364 */     // GIR_Coverage, 62368,
     /* 1112364 */     GIR_EraseRootFromParent_Done,
     /* 1112365 */   // Label 16352: @1112365
     /* 1112365 */   GIM_Try, /*On fail goto*//*Label 16353*/ GIMT_Encode4(1112442), // Rule ID 62369 //
     /* 1112370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1112381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1112384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1112387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1112390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112409 */     // MIs[0] policy
     /* 1112409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112419 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112441 */     // GIR_Coverage, 62369,
     /* 1112441 */     GIR_EraseRootFromParent_Done,
     /* 1112442 */   // Label 16353: @1112442
     /* 1112442 */   GIM_Try, /*On fail goto*//*Label 16354*/ GIMT_Encode4(1112519), // Rule ID 62370 //
     /* 1112447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112486 */     // MIs[0] policy
     /* 1112486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112496 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1112499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112518 */     // GIR_Coverage, 62370,
     /* 1112518 */     GIR_EraseRootFromParent_Done,
     /* 1112519 */   // Label 16354: @1112519
     /* 1112519 */   GIM_Try, /*On fail goto*//*Label 16355*/ GIMT_Encode4(1112596), // Rule ID 62371 //
     /* 1112524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112563 */     // MIs[0] policy
     /* 1112563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112573 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1112576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112595 */     // GIR_Coverage, 62371,
     /* 1112595 */     GIR_EraseRootFromParent_Done,
     /* 1112596 */   // Label 16355: @1112596
     /* 1112596 */   GIM_Try, /*On fail goto*//*Label 16356*/ GIMT_Encode4(1112673), // Rule ID 62372 //
     /* 1112601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112640 */     // MIs[0] policy
     /* 1112640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1112653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112672 */     // GIR_Coverage, 62372,
     /* 1112672 */     GIR_EraseRootFromParent_Done,
     /* 1112673 */   // Label 16356: @1112673
     /* 1112673 */   GIM_Try, /*On fail goto*//*Label 16357*/ GIMT_Encode4(1112750), // Rule ID 62373 //
     /* 1112678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112717 */     // MIs[0] policy
     /* 1112717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112727 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1112730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112749 */     // GIR_Coverage, 62373,
     /* 1112749 */     GIR_EraseRootFromParent_Done,
     /* 1112750 */   // Label 16357: @1112750
     /* 1112750 */   GIM_Try, /*On fail goto*//*Label 16358*/ GIMT_Encode4(1112827), // Rule ID 62374 //
     /* 1112755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1112766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1112769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1112772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1112775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112794 */     // MIs[0] policy
     /* 1112794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112804 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1112807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112826 */     // GIR_Coverage, 62374,
     /* 1112826 */     GIR_EraseRootFromParent_Done,
     /* 1112827 */   // Label 16358: @1112827
     /* 1112827 */   GIM_Try, /*On fail goto*//*Label 16359*/ GIMT_Encode4(1112904), // Rule ID 62375 //
     /* 1112832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1112843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1112846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1112849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1112852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112871 */     // MIs[0] policy
     /* 1112871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112881 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1112884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112903 */     // GIR_Coverage, 62375,
     /* 1112903 */     GIR_EraseRootFromParent_Done,
     /* 1112904 */   // Label 16359: @1112904
     /* 1112904 */   GIM_Try, /*On fail goto*//*Label 16360*/ GIMT_Encode4(1112981), // Rule ID 62376 //
     /* 1112909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1112920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1112923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1112926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1112929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112948 */     // MIs[0] policy
     /* 1112948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1112961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112980 */     // GIR_Coverage, 62376,
     /* 1112980 */     GIR_EraseRootFromParent_Done,
     /* 1112981 */   // Label 16360: @1112981
     /* 1112981 */   GIM_Try, /*On fail goto*//*Label 16361*/ GIMT_Encode4(1113058), // Rule ID 62377 //
     /* 1112986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1112997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1113000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1113003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1113006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113025 */     // MIs[0] policy
     /* 1113025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113035 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1113038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113057 */     // GIR_Coverage, 62377,
     /* 1113057 */     GIR_EraseRootFromParent_Done,
     /* 1113058 */   // Label 16361: @1113058
     /* 1113058 */   GIM_Try, /*On fail goto*//*Label 16362*/ GIMT_Encode4(1113135), // Rule ID 62378 //
     /* 1113063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1113080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1113083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113102 */     // MIs[0] policy
     /* 1113102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1113115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113134 */     // GIR_Coverage, 62378,
     /* 1113134 */     GIR_EraseRootFromParent_Done,
     /* 1113135 */   // Label 16362: @1113135
     /* 1113135 */   GIM_Try, /*On fail goto*//*Label 16363*/ GIMT_Encode4(1113212), // Rule ID 62379 //
     /* 1113140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1113157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1113160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113179 */     // MIs[0] policy
     /* 1113179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113189 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1113192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113211 */     // GIR_Coverage, 62379,
     /* 1113211 */     GIR_EraseRootFromParent_Done,
     /* 1113212 */   // Label 16363: @1113212
     /* 1113212 */   GIM_Try, /*On fail goto*//*Label 16364*/ GIMT_Encode4(1113289), // Rule ID 62380 //
     /* 1113217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1113228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1113231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1113234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1113237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113256 */     // MIs[0] policy
     /* 1113256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113266 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1113269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113288 */     // GIR_Coverage, 62380,
     /* 1113288 */     GIR_EraseRootFromParent_Done,
     /* 1113289 */   // Label 16364: @1113289
     /* 1113289 */   GIM_Try, /*On fail goto*//*Label 16365*/ GIMT_Encode4(1113366), // Rule ID 62381 //
     /* 1113294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1113305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1113308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1113311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1113314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113333 */     // MIs[0] policy
     /* 1113333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113343 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1113346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113365 */     // GIR_Coverage, 62381,
     /* 1113365 */     GIR_EraseRootFromParent_Done,
     /* 1113366 */   // Label 16365: @1113366
     /* 1113366 */   GIM_Try, /*On fail goto*//*Label 16366*/ GIMT_Encode4(1113443), // Rule ID 62382 //
     /* 1113371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1113382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1113385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1113388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1113391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113410 */     // MIs[0] policy
     /* 1113410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113420 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1113423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113442 */     // GIR_Coverage, 62382,
     /* 1113442 */     GIR_EraseRootFromParent_Done,
     /* 1113443 */   // Label 16366: @1113443
     /* 1113443 */   GIM_Try, /*On fail goto*//*Label 16367*/ GIMT_Encode4(1113520), // Rule ID 62383 //
     /* 1113448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1113459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1113462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1113465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1113468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113487 */     // MIs[0] policy
     /* 1113487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113497 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1113500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113519 */     // GIR_Coverage, 62383,
     /* 1113519 */     GIR_EraseRootFromParent_Done,
     /* 1113520 */   // Label 16367: @1113520
     /* 1113520 */   GIM_Try, /*On fail goto*//*Label 16368*/ GIMT_Encode4(1113597), // Rule ID 62384 //
     /* 1113525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1113536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1113539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1113542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1113545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113564 */     // MIs[0] policy
     /* 1113564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113574 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1113577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113596 */     // GIR_Coverage, 62384,
     /* 1113596 */     GIR_EraseRootFromParent_Done,
     /* 1113597 */   // Label 16368: @1113597
     /* 1113597 */   GIM_Try, /*On fail goto*//*Label 16369*/ GIMT_Encode4(1113674), // Rule ID 62385 //
     /* 1113602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1113613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1113616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1113619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1113622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113641 */     // MIs[0] policy
     /* 1113641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113651 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1113654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113673 */     // GIR_Coverage, 62385,
     /* 1113673 */     GIR_EraseRootFromParent_Done,
     /* 1113674 */   // Label 16369: @1113674
     /* 1113674 */   GIM_Try, /*On fail goto*//*Label 16370*/ GIMT_Encode4(1113751), // Rule ID 62386 //
     /* 1113679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1113690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1113693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1113696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1113699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113718 */     // MIs[0] policy
     /* 1113718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113728 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1113731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113750 */     // GIR_Coverage, 62386,
     /* 1113750 */     GIR_EraseRootFromParent_Done,
     /* 1113751 */   // Label 16370: @1113751
     /* 1113751 */   GIM_Try, /*On fail goto*//*Label 16371*/ GIMT_Encode4(1113828), // Rule ID 62387 //
     /* 1113756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1113767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1113770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1113773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1113776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113795 */     // MIs[0] policy
     /* 1113795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113805 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1113808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113827 */     // GIR_Coverage, 62387,
     /* 1113827 */     GIR_EraseRootFromParent_Done,
     /* 1113828 */   // Label 16371: @1113828
     /* 1113828 */   GIM_Try, /*On fail goto*//*Label 16372*/ GIMT_Encode4(1113905), // Rule ID 62608 //
     /* 1113833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1113836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1113844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1113847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1113850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1113853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113872 */     // MIs[0] policy
     /* 1113872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113882 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_MF2),
     /* 1113885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113904 */     // GIR_Coverage, 62608,
     /* 1113904 */     GIR_EraseRootFromParent_Done,
     /* 1113905 */   // Label 16372: @1113905
     /* 1113905 */   GIM_Try, /*On fail goto*//*Label 16373*/ GIMT_Encode4(1113982), // Rule ID 62609 //
     /* 1113910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1113913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1113921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1113924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1113927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1113930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113949 */     // MIs[0] policy
     /* 1113949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113959 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_MF2),
     /* 1113962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113981 */     // GIR_Coverage, 62609,
     /* 1113981 */     GIR_EraseRootFromParent_Done,
     /* 1113982 */   // Label 16373: @1113982
     /* 1113982 */   GIM_Try, /*On fail goto*//*Label 16374*/ GIMT_Encode4(1114059), // Rule ID 62612 //
     /* 1113987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1113990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1114001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1114004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1114007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114026 */     // MIs[0] policy
     /* 1114026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114036 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M1),
     /* 1114039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114058 */     // GIR_Coverage, 62612,
     /* 1114058 */     GIR_EraseRootFromParent_Done,
     /* 1114059 */   // Label 16374: @1114059
     /* 1114059 */   GIM_Try, /*On fail goto*//*Label 16375*/ GIMT_Encode4(1114136), // Rule ID 62613 //
     /* 1114064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1114075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1114078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1114081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1114084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114103 */     // MIs[0] policy
     /* 1114103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114113 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M1),
     /* 1114116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114135 */     // GIR_Coverage, 62613,
     /* 1114135 */     GIR_EraseRootFromParent_Done,
     /* 1114136 */   // Label 16375: @1114136
     /* 1114136 */   GIM_Try, /*On fail goto*//*Label 16376*/ GIMT_Encode4(1114213), // Rule ID 62616 //
     /* 1114141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1114158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1114161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114180 */     // MIs[0] policy
     /* 1114180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M2),
     /* 1114193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114212 */     // GIR_Coverage, 62616,
     /* 1114212 */     GIR_EraseRootFromParent_Done,
     /* 1114213 */   // Label 16376: @1114213
     /* 1114213 */   GIM_Try, /*On fail goto*//*Label 16377*/ GIMT_Encode4(1114290), // Rule ID 62617 //
     /* 1114218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1114235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1114238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114257 */     // MIs[0] policy
     /* 1114257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114267 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M2),
     /* 1114270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114289 */     // GIR_Coverage, 62617,
     /* 1114289 */     GIR_EraseRootFromParent_Done,
     /* 1114290 */   // Label 16377: @1114290
     /* 1114290 */   GIM_Try, /*On fail goto*//*Label 16378*/ GIMT_Encode4(1114367), // Rule ID 62620 //
     /* 1114295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1114312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1114315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114334 */     // MIs[0] policy
     /* 1114334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114344 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M4),
     /* 1114347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114366 */     // GIR_Coverage, 62620,
     /* 1114366 */     GIR_EraseRootFromParent_Done,
     /* 1114367 */   // Label 16378: @1114367
     /* 1114367 */   GIM_Try, /*On fail goto*//*Label 16379*/ GIMT_Encode4(1114444), // Rule ID 62621 //
     /* 1114372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1114389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1114392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114411 */     // MIs[0] policy
     /* 1114411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M4),
     /* 1114424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114443 */     // GIR_Coverage, 62621,
     /* 1114443 */     GIR_EraseRootFromParent_Done,
     /* 1114444 */   // Label 16379: @1114444
     /* 1114444 */   GIM_Try, /*On fail goto*//*Label 16380*/ GIMT_Encode4(1114521), // Rule ID 62624 //
     /* 1114449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1114466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1114469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114488 */     // MIs[0] policy
     /* 1114488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114498 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M8),
     /* 1114501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114520 */     // GIR_Coverage, 62624,
     /* 1114520 */     GIR_EraseRootFromParent_Done,
     /* 1114521 */   // Label 16380: @1114521
     /* 1114521 */   GIM_Try, /*On fail goto*//*Label 16381*/ GIMT_Encode4(1114598), // Rule ID 62625 //
     /* 1114526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1114543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1114546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114565 */     // MIs[0] policy
     /* 1114565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114575 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M8),
     /* 1114578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114597 */     // GIR_Coverage, 62625,
     /* 1114597 */     GIR_EraseRootFromParent_Done,
     /* 1114598 */   // Label 16381: @1114598
     /* 1114598 */   GIM_Try, /*On fail goto*//*Label 16382*/ GIMT_Encode4(1114675), // Rule ID 62628 //
     /* 1114603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1114620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1114623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114642 */     // MIs[0] policy
     /* 1114642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_MF2),
     /* 1114655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114674 */     // GIR_Coverage, 62628,
     /* 1114674 */     GIR_EraseRootFromParent_Done,
     /* 1114675 */   // Label 16382: @1114675
     /* 1114675 */   GIM_Try, /*On fail goto*//*Label 16383*/ GIMT_Encode4(1114752), // Rule ID 62629 //
     /* 1114680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1114697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1114700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114719 */     // MIs[0] policy
     /* 1114719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114729 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_MF2),
     /* 1114732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114751 */     // GIR_Coverage, 62629,
     /* 1114751 */     GIR_EraseRootFromParent_Done,
     /* 1114752 */   // Label 16383: @1114752
     /* 1114752 */   GIM_Try, /*On fail goto*//*Label 16384*/ GIMT_Encode4(1114829), // Rule ID 62632 //
     /* 1114757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1114768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1114771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1114774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1114777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114796 */     // MIs[0] policy
     /* 1114796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114806 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M1),
     /* 1114809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114828 */     // GIR_Coverage, 62632,
     /* 1114828 */     GIR_EraseRootFromParent_Done,
     /* 1114829 */   // Label 16384: @1114829
     /* 1114829 */   GIM_Try, /*On fail goto*//*Label 16385*/ GIMT_Encode4(1114906), // Rule ID 62633 //
     /* 1114834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1114845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1114848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1114851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1114854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114873 */     // MIs[0] policy
     /* 1114873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114883 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M1),
     /* 1114886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114905 */     // GIR_Coverage, 62633,
     /* 1114905 */     GIR_EraseRootFromParent_Done,
     /* 1114906 */   // Label 16385: @1114906
     /* 1114906 */   GIM_Try, /*On fail goto*//*Label 16386*/ GIMT_Encode4(1114983), // Rule ID 62636 //
     /* 1114911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1114928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1114931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114950 */     // MIs[0] policy
     /* 1114950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114960 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M2),
     /* 1114963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114982 */     // GIR_Coverage, 62636,
     /* 1114982 */     GIR_EraseRootFromParent_Done,
     /* 1114983 */   // Label 16386: @1114983
     /* 1114983 */   GIM_Try, /*On fail goto*//*Label 16387*/ GIMT_Encode4(1115060), // Rule ID 62637 //
     /* 1114988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1115008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115027 */     // MIs[0] policy
     /* 1115027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115037 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M2),
     /* 1115040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115059 */     // GIR_Coverage, 62637,
     /* 1115059 */     GIR_EraseRootFromParent_Done,
     /* 1115060 */   // Label 16387: @1115060
     /* 1115060 */   GIM_Try, /*On fail goto*//*Label 16388*/ GIMT_Encode4(1115137), // Rule ID 62640 //
     /* 1115065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115104 */     // MIs[0] policy
     /* 1115104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115114 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M4),
     /* 1115117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115136 */     // GIR_Coverage, 62640,
     /* 1115136 */     GIR_EraseRootFromParent_Done,
     /* 1115137 */   // Label 16388: @1115137
     /* 1115137 */   GIM_Try, /*On fail goto*//*Label 16389*/ GIMT_Encode4(1115214), // Rule ID 62641 //
     /* 1115142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115181 */     // MIs[0] policy
     /* 1115181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115191 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M4),
     /* 1115194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115213 */     // GIR_Coverage, 62641,
     /* 1115213 */     GIR_EraseRootFromParent_Done,
     /* 1115214 */   // Label 16389: @1115214
     /* 1115214 */   GIM_Try, /*On fail goto*//*Label 16390*/ GIMT_Encode4(1115291), // Rule ID 62644 //
     /* 1115219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1115239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115258 */     // MIs[0] policy
     /* 1115258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115268 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M8),
     /* 1115271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115290 */     // GIR_Coverage, 62644,
     /* 1115290 */     GIR_EraseRootFromParent_Done,
     /* 1115291 */   // Label 16390: @1115291
     /* 1115291 */   GIM_Try, /*On fail goto*//*Label 16391*/ GIMT_Encode4(1115368), // Rule ID 62645 //
     /* 1115296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1115316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115335 */     // MIs[0] policy
     /* 1115335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115345 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M8),
     /* 1115348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115367 */     // GIR_Coverage, 62645,
     /* 1115367 */     GIR_EraseRootFromParent_Done,
     /* 1115368 */   // Label 16391: @1115368
     /* 1115368 */   GIM_Try, /*On fail goto*//*Label 16392*/ GIMT_Encode4(1115445), // Rule ID 62648 //
     /* 1115373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1115390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115412 */     // MIs[0] policy
     /* 1115412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115422 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_MF2),
     /* 1115425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115444 */     // GIR_Coverage, 62648,
     /* 1115444 */     GIR_EraseRootFromParent_Done,
     /* 1115445 */   // Label 16392: @1115445
     /* 1115445 */   GIM_Try, /*On fail goto*//*Label 16393*/ GIMT_Encode4(1115522), // Rule ID 62649 //
     /* 1115450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1115467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115489 */     // MIs[0] policy
     /* 1115489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115499 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_MF2),
     /* 1115502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115521 */     // GIR_Coverage, 62649,
     /* 1115521 */     GIR_EraseRootFromParent_Done,
     /* 1115522 */   // Label 16393: @1115522
     /* 1115522 */   GIM_Try, /*On fail goto*//*Label 16394*/ GIMT_Encode4(1115599), // Rule ID 62652 //
     /* 1115527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1115544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1115547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115566 */     // MIs[0] policy
     /* 1115566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M1),
     /* 1115579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115598 */     // GIR_Coverage, 62652,
     /* 1115598 */     GIR_EraseRootFromParent_Done,
     /* 1115599 */   // Label 16394: @1115599
     /* 1115599 */   GIM_Try, /*On fail goto*//*Label 16395*/ GIMT_Encode4(1115676), // Rule ID 62653 //
     /* 1115604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1115621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1115624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115643 */     // MIs[0] policy
     /* 1115643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115653 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M1),
     /* 1115656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115675 */     // GIR_Coverage, 62653,
     /* 1115675 */     GIR_EraseRootFromParent_Done,
     /* 1115676 */   // Label 16395: @1115676
     /* 1115676 */   GIM_Try, /*On fail goto*//*Label 16396*/ GIMT_Encode4(1115753), // Rule ID 62656 //
     /* 1115681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1115698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1115701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115720 */     // MIs[0] policy
     /* 1115720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M2),
     /* 1115733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115752 */     // GIR_Coverage, 62656,
     /* 1115752 */     GIR_EraseRootFromParent_Done,
     /* 1115753 */   // Label 16396: @1115753
     /* 1115753 */   GIM_Try, /*On fail goto*//*Label 16397*/ GIMT_Encode4(1115830), // Rule ID 62657 //
     /* 1115758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1115775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1115778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115797 */     // MIs[0] policy
     /* 1115797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115807 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M2),
     /* 1115810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115829 */     // GIR_Coverage, 62657,
     /* 1115829 */     GIR_EraseRootFromParent_Done,
     /* 1115830 */   // Label 16397: @1115830
     /* 1115830 */   GIM_Try, /*On fail goto*//*Label 16398*/ GIMT_Encode4(1115907), // Rule ID 62660 //
     /* 1115835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1115852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115874 */     // MIs[0] policy
     /* 1115874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M4),
     /* 1115887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115906 */     // GIR_Coverage, 62660,
     /* 1115906 */     GIR_EraseRootFromParent_Done,
     /* 1115907 */   // Label 16398: @1115907
     /* 1115907 */   GIM_Try, /*On fail goto*//*Label 16399*/ GIMT_Encode4(1115984), // Rule ID 62661 //
     /* 1115912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1115929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115951 */     // MIs[0] policy
     /* 1115951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115961 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M4),
     /* 1115964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115983 */     // GIR_Coverage, 62661,
     /* 1115983 */     GIR_EraseRootFromParent_Done,
     /* 1115984 */   // Label 16399: @1115984
     /* 1115984 */   GIM_Try, /*On fail goto*//*Label 16400*/ GIMT_Encode4(1116061), // Rule ID 62664 //
     /* 1115989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1116000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1116003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1116006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1116009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116028 */     // MIs[0] policy
     /* 1116028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M8),
     /* 1116041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116060 */     // GIR_Coverage, 62664,
     /* 1116060 */     GIR_EraseRootFromParent_Done,
     /* 1116061 */   // Label 16400: @1116061
     /* 1116061 */   GIM_Try, /*On fail goto*//*Label 16401*/ GIMT_Encode4(1116138), // Rule ID 62665 //
     /* 1116066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1116077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1116080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1116083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1116086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116105 */     // MIs[0] policy
     /* 1116105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116115 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M8),
     /* 1116118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116137 */     // GIR_Coverage, 62665,
     /* 1116137 */     GIR_EraseRootFromParent_Done,
     /* 1116138 */   // Label 16401: @1116138
     /* 1116138 */   GIM_Try, /*On fail goto*//*Label 16402*/ GIMT_Encode4(1116215), // Rule ID 62668 //
     /* 1116143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1116163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116182 */     // MIs[0] policy
     /* 1116182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116192 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_MF2),
     /* 1116195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116214 */     // GIR_Coverage, 62668,
     /* 1116214 */     GIR_EraseRootFromParent_Done,
     /* 1116215 */   // Label 16402: @1116215
     /* 1116215 */   GIM_Try, /*On fail goto*//*Label 16403*/ GIMT_Encode4(1116292), // Rule ID 62669 //
     /* 1116220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1116240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116259 */     // MIs[0] policy
     /* 1116259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116269 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_MF2),
     /* 1116272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116291 */     // GIR_Coverage, 62669,
     /* 1116291 */     GIR_EraseRootFromParent_Done,
     /* 1116292 */   // Label 16403: @1116292
     /* 1116292 */   GIM_Try, /*On fail goto*//*Label 16404*/ GIMT_Encode4(1116369), // Rule ID 62672 //
     /* 1116297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116336 */     // MIs[0] policy
     /* 1116336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116346 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M1),
     /* 1116349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116368 */     // GIR_Coverage, 62672,
     /* 1116368 */     GIR_EraseRootFromParent_Done,
     /* 1116369 */   // Label 16404: @1116369
     /* 1116369 */   GIM_Try, /*On fail goto*//*Label 16405*/ GIMT_Encode4(1116446), // Rule ID 62673 //
     /* 1116374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116413 */     // MIs[0] policy
     /* 1116413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116423 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M1),
     /* 1116426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116445 */     // GIR_Coverage, 62673,
     /* 1116445 */     GIR_EraseRootFromParent_Done,
     /* 1116446 */   // Label 16405: @1116446
     /* 1116446 */   GIM_Try, /*On fail goto*//*Label 16406*/ GIMT_Encode4(1116523), // Rule ID 62676 //
     /* 1116451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1116471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116490 */     // MIs[0] policy
     /* 1116490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M2),
     /* 1116503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116522 */     // GIR_Coverage, 62676,
     /* 1116522 */     GIR_EraseRootFromParent_Done,
     /* 1116523 */   // Label 16406: @1116523
     /* 1116523 */   GIM_Try, /*On fail goto*//*Label 16407*/ GIMT_Encode4(1116600), // Rule ID 62677 //
     /* 1116528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1116548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116567 */     // MIs[0] policy
     /* 1116567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116577 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M2),
     /* 1116580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116599 */     // GIR_Coverage, 62677,
     /* 1116599 */     GIR_EraseRootFromParent_Done,
     /* 1116600 */   // Label 16407: @1116600
     /* 1116600 */   GIM_Try, /*On fail goto*//*Label 16408*/ GIMT_Encode4(1116677), // Rule ID 62680 //
     /* 1116605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1116625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116644 */     // MIs[0] policy
     /* 1116644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116654 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M4),
     /* 1116657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116676 */     // GIR_Coverage, 62680,
     /* 1116676 */     GIR_EraseRootFromParent_Done,
     /* 1116677 */   // Label 16408: @1116677
     /* 1116677 */   GIM_Try, /*On fail goto*//*Label 16409*/ GIMT_Encode4(1116754), // Rule ID 62681 //
     /* 1116682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1116702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116721 */     // MIs[0] policy
     /* 1116721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116731 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M4),
     /* 1116734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116753 */     // GIR_Coverage, 62681,
     /* 1116753 */     GIR_EraseRootFromParent_Done,
     /* 1116754 */   // Label 16409: @1116754
     /* 1116754 */   GIM_Try, /*On fail goto*//*Label 16410*/ GIMT_Encode4(1116831), // Rule ID 62684 //
     /* 1116759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1116770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1116773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1116779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116798 */     // MIs[0] policy
     /* 1116798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116808 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M8),
     /* 1116811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116830 */     // GIR_Coverage, 62684,
     /* 1116830 */     GIR_EraseRootFromParent_Done,
     /* 1116831 */   // Label 16410: @1116831
     /* 1116831 */   GIM_Try, /*On fail goto*//*Label 16411*/ GIMT_Encode4(1116908), // Rule ID 62685 //
     /* 1116836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1116847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1116850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1116856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116875 */     // MIs[0] policy
     /* 1116875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116885 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M8),
     /* 1116888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116907 */     // GIR_Coverage, 62685,
     /* 1116907 */     GIR_EraseRootFromParent_Done,
     /* 1116908 */   // Label 16411: @1116908
     /* 1116908 */   GIM_Try, /*On fail goto*//*Label 16412*/ GIMT_Encode4(1116985), // Rule ID 62688 //
     /* 1116913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1116921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1116930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1116933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116952 */     // MIs[0] policy
     /* 1116952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116962 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_MF2),
     /* 1116965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116984 */     // GIR_Coverage, 62688,
     /* 1116984 */     GIR_EraseRootFromParent_Done,
     /* 1116985 */   // Label 16412: @1116985
     /* 1116985 */   GIM_Try, /*On fail goto*//*Label 16413*/ GIMT_Encode4(1117062), // Rule ID 62689 //
     /* 1116990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1116998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1117007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117029 */     // MIs[0] policy
     /* 1117029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117039 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_MF2),
     /* 1117042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117058 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117061 */     // GIR_Coverage, 62689,
     /* 1117061 */     GIR_EraseRootFromParent_Done,
     /* 1117062 */   // Label 16413: @1117062
     /* 1117062 */   GIM_Try, /*On fail goto*//*Label 16414*/ GIMT_Encode4(1117139), // Rule ID 62692 //
     /* 1117067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1117084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117106 */     // MIs[0] policy
     /* 1117106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117116 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M1),
     /* 1117119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117138 */     // GIR_Coverage, 62692,
     /* 1117138 */     GIR_EraseRootFromParent_Done,
     /* 1117139 */   // Label 16414: @1117139
     /* 1117139 */   GIM_Try, /*On fail goto*//*Label 16415*/ GIMT_Encode4(1117216), // Rule ID 62693 //
     /* 1117144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1117161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117183 */     // MIs[0] policy
     /* 1117183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117193 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M1),
     /* 1117196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117215 */     // GIR_Coverage, 62693,
     /* 1117215 */     GIR_EraseRootFromParent_Done,
     /* 1117216 */   // Label 16415: @1117216
     /* 1117216 */   GIM_Try, /*On fail goto*//*Label 16416*/ GIMT_Encode4(1117293), // Rule ID 62696 //
     /* 1117221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1117238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117260 */     // MIs[0] policy
     /* 1117260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M2),
     /* 1117273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117289 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117292 */     // GIR_Coverage, 62696,
     /* 1117292 */     GIR_EraseRootFromParent_Done,
     /* 1117293 */   // Label 16416: @1117293
     /* 1117293 */   GIM_Try, /*On fail goto*//*Label 16417*/ GIMT_Encode4(1117370), // Rule ID 62697 //
     /* 1117298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1117315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117337 */     // MIs[0] policy
     /* 1117337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117347 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M2),
     /* 1117350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117369 */     // GIR_Coverage, 62697,
     /* 1117369 */     GIR_EraseRootFromParent_Done,
     /* 1117370 */   // Label 16417: @1117370
     /* 1117370 */   GIM_Try, /*On fail goto*//*Label 16418*/ GIMT_Encode4(1117447), // Rule ID 62700 //
     /* 1117375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1117392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117414 */     // MIs[0] policy
     /* 1117414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117424 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M4),
     /* 1117427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117446 */     // GIR_Coverage, 62700,
     /* 1117446 */     GIR_EraseRootFromParent_Done,
     /* 1117447 */   // Label 16418: @1117447
     /* 1117447 */   GIM_Try, /*On fail goto*//*Label 16419*/ GIMT_Encode4(1117524), // Rule ID 62701 //
     /* 1117452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1117469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117491 */     // MIs[0] policy
     /* 1117491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117501 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M4),
     /* 1117504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117523 */     // GIR_Coverage, 62701,
     /* 1117523 */     GIR_EraseRootFromParent_Done,
     /* 1117524 */   // Label 16419: @1117524
     /* 1117524 */   GIM_Try, /*On fail goto*//*Label 16420*/ GIMT_Encode4(1117601), // Rule ID 62704 //
     /* 1117529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1117546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1117549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117568 */     // MIs[0] policy
     /* 1117568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117578 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M8),
     /* 1117581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117600 */     // GIR_Coverage, 62704,
     /* 1117600 */     GIR_EraseRootFromParent_Done,
     /* 1117601 */   // Label 16420: @1117601
     /* 1117601 */   GIM_Try, /*On fail goto*//*Label 16421*/ GIMT_Encode4(1117678), // Rule ID 62705 //
     /* 1117606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1117623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1117626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117645 */     // MIs[0] policy
     /* 1117645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117655 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M8),
     /* 1117658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117674 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117677 */     // GIR_Coverage, 62705,
     /* 1117677 */     GIR_EraseRootFromParent_Done,
     /* 1117678 */   // Label 16421: @1117678
     /* 1117678 */   GIM_Try, /*On fail goto*//*Label 16422*/ GIMT_Encode4(1117755), // Rule ID 62708 //
     /* 1117683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117722 */     // MIs[0] policy
     /* 1117722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_MF2),
     /* 1117735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117751 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117754 */     // GIR_Coverage, 62708,
     /* 1117754 */     GIR_EraseRootFromParent_Done,
     /* 1117755 */   // Label 16422: @1117755
     /* 1117755 */   GIM_Try, /*On fail goto*//*Label 16423*/ GIMT_Encode4(1117832), // Rule ID 62709 //
     /* 1117760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117799 */     // MIs[0] policy
     /* 1117799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117809 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_MF2),
     /* 1117812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117831 */     // GIR_Coverage, 62709,
     /* 1117831 */     GIR_EraseRootFromParent_Done,
     /* 1117832 */   // Label 16423: @1117832
     /* 1117832 */   GIM_Try, /*On fail goto*//*Label 16424*/ GIMT_Encode4(1117909), // Rule ID 62712 //
     /* 1117837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117876 */     // MIs[0] policy
     /* 1117876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M1),
     /* 1117889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117905 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117908 */     // GIR_Coverage, 62712,
     /* 1117908 */     GIR_EraseRootFromParent_Done,
     /* 1117909 */   // Label 16424: @1117909
     /* 1117909 */   GIM_Try, /*On fail goto*//*Label 16425*/ GIMT_Encode4(1117986), // Rule ID 62713 //
     /* 1117914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117953 */     // MIs[0] policy
     /* 1117953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117963 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M1),
     /* 1117966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117985 */     // GIR_Coverage, 62713,
     /* 1117985 */     GIR_EraseRootFromParent_Done,
     /* 1117986 */   // Label 16425: @1117986
     /* 1117986 */   GIM_Try, /*On fail goto*//*Label 16426*/ GIMT_Encode4(1118063), // Rule ID 62716 //
     /* 1117991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118030 */     // MIs[0] policy
     /* 1118030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M2),
     /* 1118043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118062 */     // GIR_Coverage, 62716,
     /* 1118062 */     GIR_EraseRootFromParent_Done,
     /* 1118063 */   // Label 16426: @1118063
     /* 1118063 */   GIM_Try, /*On fail goto*//*Label 16427*/ GIMT_Encode4(1118140), // Rule ID 62717 //
     /* 1118068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118107 */     // MIs[0] policy
     /* 1118107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118117 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M2),
     /* 1118120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118139 */     // GIR_Coverage, 62717,
     /* 1118139 */     GIR_EraseRootFromParent_Done,
     /* 1118140 */   // Label 16427: @1118140
     /* 1118140 */   GIM_Try, /*On fail goto*//*Label 16428*/ GIMT_Encode4(1118217), // Rule ID 62720 //
     /* 1118145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118184 */     // MIs[0] policy
     /* 1118184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118194 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M4),
     /* 1118197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118213 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118216 */     // GIR_Coverage, 62720,
     /* 1118216 */     GIR_EraseRootFromParent_Done,
     /* 1118217 */   // Label 16428: @1118217
     /* 1118217 */   GIM_Try, /*On fail goto*//*Label 16429*/ GIMT_Encode4(1118294), // Rule ID 62721 //
     /* 1118222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118261 */     // MIs[0] policy
     /* 1118261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118271 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M4),
     /* 1118274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118293 */     // GIR_Coverage, 62721,
     /* 1118293 */     GIR_EraseRootFromParent_Done,
     /* 1118294 */   // Label 16429: @1118294
     /* 1118294 */   GIM_Try, /*On fail goto*//*Label 16430*/ GIMT_Encode4(1118371), // Rule ID 62724 //
     /* 1118299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118338 */     // MIs[0] policy
     /* 1118338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118348 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M8),
     /* 1118351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118370 */     // GIR_Coverage, 62724,
     /* 1118370 */     GIR_EraseRootFromParent_Done,
     /* 1118371 */   // Label 16430: @1118371
     /* 1118371 */   GIM_Try, /*On fail goto*//*Label 16431*/ GIMT_Encode4(1118448), // Rule ID 62725 //
     /* 1118376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118415 */     // MIs[0] policy
     /* 1118415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118425 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M8),
     /* 1118428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118447 */     // GIR_Coverage, 62725,
     /* 1118447 */     GIR_EraseRootFromParent_Done,
     /* 1118448 */   // Label 16431: @1118448
     /* 1118448 */   GIM_Try, /*On fail goto*//*Label 16432*/ GIMT_Encode4(1118525), // Rule ID 62728 //
     /* 1118453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118492 */     // MIs[0] policy
     /* 1118492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_MF2),
     /* 1118505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118524 */     // GIR_Coverage, 62728,
     /* 1118524 */     GIR_EraseRootFromParent_Done,
     /* 1118525 */   // Label 16432: @1118525
     /* 1118525 */   GIM_Try, /*On fail goto*//*Label 16433*/ GIMT_Encode4(1118602), // Rule ID 62729 //
     /* 1118530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118569 */     // MIs[0] policy
     /* 1118569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118579 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_MF2),
     /* 1118582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118601 */     // GIR_Coverage, 62729,
     /* 1118601 */     GIR_EraseRootFromParent_Done,
     /* 1118602 */   // Label 16433: @1118602
     /* 1118602 */   GIM_Try, /*On fail goto*//*Label 16434*/ GIMT_Encode4(1118679), // Rule ID 62732 //
     /* 1118607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118646 */     // MIs[0] policy
     /* 1118646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M1),
     /* 1118659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118675 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118678 */     // GIR_Coverage, 62732,
     /* 1118678 */     GIR_EraseRootFromParent_Done,
     /* 1118679 */   // Label 16434: @1118679
     /* 1118679 */   GIM_Try, /*On fail goto*//*Label 16435*/ GIMT_Encode4(1118756), // Rule ID 62733 //
     /* 1118684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118723 */     // MIs[0] policy
     /* 1118723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118733 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M1),
     /* 1118736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118755 */     // GIR_Coverage, 62733,
     /* 1118755 */     GIR_EraseRootFromParent_Done,
     /* 1118756 */   // Label 16435: @1118756
     /* 1118756 */   GIM_Try, /*On fail goto*//*Label 16436*/ GIMT_Encode4(1118833), // Rule ID 62736 //
     /* 1118761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118800 */     // MIs[0] policy
     /* 1118800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118810 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M2),
     /* 1118813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118832 */     // GIR_Coverage, 62736,
     /* 1118832 */     GIR_EraseRootFromParent_Done,
     /* 1118833 */   // Label 16436: @1118833
     /* 1118833 */   GIM_Try, /*On fail goto*//*Label 16437*/ GIMT_Encode4(1118910), // Rule ID 62737 //
     /* 1118838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118877 */     // MIs[0] policy
     /* 1118877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M2),
     /* 1118890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118909 */     // GIR_Coverage, 62737,
     /* 1118909 */     GIR_EraseRootFromParent_Done,
     /* 1118910 */   // Label 16437: @1118910
     /* 1118910 */   GIM_Try, /*On fail goto*//*Label 16438*/ GIMT_Encode4(1118987), // Rule ID 62740 //
     /* 1118915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118954 */     // MIs[0] policy
     /* 1118954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118964 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M4),
     /* 1118967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118986 */     // GIR_Coverage, 62740,
     /* 1118986 */     GIR_EraseRootFromParent_Done,
     /* 1118987 */   // Label 16438: @1118987
     /* 1118987 */   GIM_Try, /*On fail goto*//*Label 16439*/ GIMT_Encode4(1119064), // Rule ID 62741 //
     /* 1118992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119031 */     // MIs[0] policy
     /* 1119031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119041 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M4),
     /* 1119044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119063 */     // GIR_Coverage, 62741,
     /* 1119063 */     GIR_EraseRootFromParent_Done,
     /* 1119064 */   // Label 16439: @1119064
     /* 1119064 */   GIM_Try, /*On fail goto*//*Label 16440*/ GIMT_Encode4(1119141), // Rule ID 62744 //
     /* 1119069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119108 */     // MIs[0] policy
     /* 1119108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M8),
     /* 1119121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119140 */     // GIR_Coverage, 62744,
     /* 1119140 */     GIR_EraseRootFromParent_Done,
     /* 1119141 */   // Label 16440: @1119141
     /* 1119141 */   GIM_Try, /*On fail goto*//*Label 16441*/ GIMT_Encode4(1119218), // Rule ID 62745 //
     /* 1119146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119185 */     // MIs[0] policy
     /* 1119185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119195 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M8),
     /* 1119198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119217 */     // GIR_Coverage, 62745,
     /* 1119217 */     GIR_EraseRootFromParent_Done,
     /* 1119218 */   // Label 16441: @1119218
     /* 1119218 */   GIM_Try, /*On fail goto*//*Label 16442*/ GIMT_Encode4(1119295), // Rule ID 62839 //
     /* 1119223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119262 */     // MIs[0] policy
     /* 1119262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119272 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M1),
     /* 1119275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119294 */     // GIR_Coverage, 62839,
     /* 1119294 */     GIR_EraseRootFromParent_Done,
     /* 1119295 */   // Label 16442: @1119295
     /* 1119295 */   GIM_Try, /*On fail goto*//*Label 16443*/ GIMT_Encode4(1119372), // Rule ID 62840 //
     /* 1119300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119339 */     // MIs[0] policy
     /* 1119339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119349 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M1),
     /* 1119352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119371 */     // GIR_Coverage, 62840,
     /* 1119371 */     GIR_EraseRootFromParent_Done,
     /* 1119372 */   // Label 16443: @1119372
     /* 1119372 */   GIM_Try, /*On fail goto*//*Label 16444*/ GIMT_Encode4(1119449), // Rule ID 64297 //
     /* 1119377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119416 */     // MIs[0] policy
     /* 1119416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M2),
     /* 1119429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119448 */     // GIR_Coverage, 64297,
     /* 1119448 */     GIR_EraseRootFromParent_Done,
     /* 1119449 */   // Label 16444: @1119449
     /* 1119449 */   GIM_Try, /*On fail goto*//*Label 16445*/ GIMT_Encode4(1119526), // Rule ID 64298 //
     /* 1119454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119493 */     // MIs[0] policy
     /* 1119493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119503 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M2),
     /* 1119506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119525 */     // GIR_Coverage, 64298,
     /* 1119525 */     GIR_EraseRootFromParent_Done,
     /* 1119526 */   // Label 16445: @1119526
     /* 1119526 */   GIM_Try, /*On fail goto*//*Label 16446*/ GIMT_Encode4(1119603), // Rule ID 64299 //
     /* 1119531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119570 */     // MIs[0] policy
     /* 1119570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119580 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M4),
     /* 1119583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119602 */     // GIR_Coverage, 64299,
     /* 1119602 */     GIR_EraseRootFromParent_Done,
     /* 1119603 */   // Label 16446: @1119603
     /* 1119603 */   GIM_Try, /*On fail goto*//*Label 16447*/ GIMT_Encode4(1119680), // Rule ID 64300 //
     /* 1119608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119647 */     // MIs[0] policy
     /* 1119647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119657 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M4),
     /* 1119660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119679 */     // GIR_Coverage, 64300,
     /* 1119679 */     GIR_EraseRootFromParent_Done,
     /* 1119680 */   // Label 16447: @1119680
     /* 1119680 */   GIM_Try, /*On fail goto*//*Label 16448*/ GIMT_Encode4(1119757), // Rule ID 64301 //
     /* 1119685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119724 */     // MIs[0] policy
     /* 1119724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119734 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M8),
     /* 1119737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119756 */     // GIR_Coverage, 64301,
     /* 1119756 */     GIR_EraseRootFromParent_Done,
     /* 1119757 */   // Label 16448: @1119757
     /* 1119757 */   GIM_Try, /*On fail goto*//*Label 16449*/ GIMT_Encode4(1119834), // Rule ID 64302 //
     /* 1119762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119801 */     // MIs[0] policy
     /* 1119801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119811 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M8),
     /* 1119814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119833 */     // GIR_Coverage, 64302,
     /* 1119833 */     GIR_EraseRootFromParent_Done,
     /* 1119834 */   // Label 16449: @1119834
     /* 1119834 */   GIM_Try, /*On fail goto*//*Label 16450*/ GIMT_Encode4(1119911), // Rule ID 64303 //
     /* 1119839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1119847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119878 */     // MIs[0] policy
     /* 1119878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M1),
     /* 1119891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119910 */     // GIR_Coverage, 64303,
     /* 1119910 */     GIR_EraseRootFromParent_Done,
     /* 1119911 */   // Label 16450: @1119911
     /* 1119911 */   GIM_Try, /*On fail goto*//*Label 16451*/ GIMT_Encode4(1119988), // Rule ID 64304 //
     /* 1119916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1119924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119955 */     // MIs[0] policy
     /* 1119955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119965 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M1),
     /* 1119968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119987 */     // GIR_Coverage, 64304,
     /* 1119987 */     GIR_EraseRootFromParent_Done,
     /* 1119988 */   // Label 16451: @1119988
     /* 1119988 */   GIM_Try, /*On fail goto*//*Label 16452*/ GIMT_Encode4(1120065), // Rule ID 64305 //
     /* 1119993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120032 */     // MIs[0] policy
     /* 1120032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M2),
     /* 1120045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120064 */     // GIR_Coverage, 64305,
     /* 1120064 */     GIR_EraseRootFromParent_Done,
     /* 1120065 */   // Label 16452: @1120065
     /* 1120065 */   GIM_Try, /*On fail goto*//*Label 16453*/ GIMT_Encode4(1120142), // Rule ID 64306 //
     /* 1120070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120109 */     // MIs[0] policy
     /* 1120109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M2),
     /* 1120122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120138 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120141 */     // GIR_Coverage, 64306,
     /* 1120141 */     GIR_EraseRootFromParent_Done,
     /* 1120142 */   // Label 16453: @1120142
     /* 1120142 */   GIM_Try, /*On fail goto*//*Label 16454*/ GIMT_Encode4(1120219), // Rule ID 64307 //
     /* 1120147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120186 */     // MIs[0] policy
     /* 1120186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120196 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M4),
     /* 1120199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120218 */     // GIR_Coverage, 64307,
     /* 1120218 */     GIR_EraseRootFromParent_Done,
     /* 1120219 */   // Label 16454: @1120219
     /* 1120219 */   GIM_Try, /*On fail goto*//*Label 16455*/ GIMT_Encode4(1120296), // Rule ID 64308 //
     /* 1120224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120263 */     // MIs[0] policy
     /* 1120263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120273 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M4),
     /* 1120276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120295 */     // GIR_Coverage, 64308,
     /* 1120295 */     GIR_EraseRootFromParent_Done,
     /* 1120296 */   // Label 16455: @1120296
     /* 1120296 */   GIM_Try, /*On fail goto*//*Label 16456*/ GIMT_Encode4(1120373), // Rule ID 64309 //
     /* 1120301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120340 */     // MIs[0] policy
     /* 1120340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120350 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M8),
     /* 1120353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120372 */     // GIR_Coverage, 64309,
     /* 1120372 */     GIR_EraseRootFromParent_Done,
     /* 1120373 */   // Label 16456: @1120373
     /* 1120373 */   GIM_Try, /*On fail goto*//*Label 16457*/ GIMT_Encode4(1120450), // Rule ID 64310 //
     /* 1120378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120417 */     // MIs[0] policy
     /* 1120417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120427 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M8),
     /* 1120430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120449 */     // GIR_Coverage, 64310,
     /* 1120449 */     GIR_EraseRootFromParent_Done,
     /* 1120450 */   // Label 16457: @1120450
     /* 1120450 */   GIM_Try, /*On fail goto*//*Label 16458*/ GIMT_Encode4(1120527), // Rule ID 64311 //
     /* 1120455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120494 */     // MIs[0] policy
     /* 1120494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120504 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M1),
     /* 1120507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120526 */     // GIR_Coverage, 64311,
     /* 1120526 */     GIR_EraseRootFromParent_Done,
     /* 1120527 */   // Label 16458: @1120527
     /* 1120527 */   GIM_Try, /*On fail goto*//*Label 16459*/ GIMT_Encode4(1120604), // Rule ID 64312 //
     /* 1120532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120571 */     // MIs[0] policy
     /* 1120571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120581 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M1),
     /* 1120584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120603 */     // GIR_Coverage, 64312,
     /* 1120603 */     GIR_EraseRootFromParent_Done,
     /* 1120604 */   // Label 16459: @1120604
     /* 1120604 */   GIM_Try, /*On fail goto*//*Label 16460*/ GIMT_Encode4(1120681), // Rule ID 64313 //
     /* 1120609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120648 */     // MIs[0] policy
     /* 1120648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120658 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M2),
     /* 1120661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120677 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120680 */     // GIR_Coverage, 64313,
     /* 1120680 */     GIR_EraseRootFromParent_Done,
     /* 1120681 */   // Label 16460: @1120681
     /* 1120681 */   GIM_Try, /*On fail goto*//*Label 16461*/ GIMT_Encode4(1120758), // Rule ID 64314 //
     /* 1120686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120725 */     // MIs[0] policy
     /* 1120725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120735 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M2),
     /* 1120738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120757 */     // GIR_Coverage, 64314,
     /* 1120757 */     GIR_EraseRootFromParent_Done,
     /* 1120758 */   // Label 16461: @1120758
     /* 1120758 */   GIM_Try, /*On fail goto*//*Label 16462*/ GIMT_Encode4(1120835), // Rule ID 64315 //
     /* 1120763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120802 */     // MIs[0] policy
     /* 1120802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120812 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M4),
     /* 1120815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120834 */     // GIR_Coverage, 64315,
     /* 1120834 */     GIR_EraseRootFromParent_Done,
     /* 1120835 */   // Label 16462: @1120835
     /* 1120835 */   GIM_Try, /*On fail goto*//*Label 16463*/ GIMT_Encode4(1120912), // Rule ID 64316 //
     /* 1120840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120879 */     // MIs[0] policy
     /* 1120879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120889 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M4),
     /* 1120892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120911 */     // GIR_Coverage, 64316,
     /* 1120911 */     GIR_EraseRootFromParent_Done,
     /* 1120912 */   // Label 16463: @1120912
     /* 1120912 */   GIM_Try, /*On fail goto*//*Label 16464*/ GIMT_Encode4(1120989), // Rule ID 64317 //
     /* 1120917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120956 */     // MIs[0] policy
     /* 1120956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120966 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M8),
     /* 1120969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120988 */     // GIR_Coverage, 64317,
     /* 1120988 */     GIR_EraseRootFromParent_Done,
     /* 1120989 */   // Label 16464: @1120989
     /* 1120989 */   GIM_Try, /*On fail goto*//*Label 16465*/ GIMT_Encode4(1121066), // Rule ID 64318 //
     /* 1120994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121033 */     // MIs[0] policy
     /* 1121033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121043 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M8),
     /* 1121046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121065 */     // GIR_Coverage, 64318,
     /* 1121065 */     GIR_EraseRootFromParent_Done,
     /* 1121066 */   // Label 16465: @1121066
     /* 1121066 */   GIM_Try, /*On fail goto*//*Label 16466*/ GIMT_Encode4(1121143), // Rule ID 64319 //
     /* 1121071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121110 */     // MIs[0] policy
     /* 1121110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121120 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M1),
     /* 1121123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121142 */     // GIR_Coverage, 64319,
     /* 1121142 */     GIR_EraseRootFromParent_Done,
     /* 1121143 */   // Label 16466: @1121143
     /* 1121143 */   GIM_Try, /*On fail goto*//*Label 16467*/ GIMT_Encode4(1121220), // Rule ID 64320 //
     /* 1121148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121187 */     // MIs[0] policy
     /* 1121187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121197 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M1),
     /* 1121200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121219 */     // GIR_Coverage, 64320,
     /* 1121219 */     GIR_EraseRootFromParent_Done,
     /* 1121220 */   // Label 16467: @1121220
     /* 1121220 */   GIM_Try, /*On fail goto*//*Label 16468*/ GIMT_Encode4(1121297), // Rule ID 64321 //
     /* 1121225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121264 */     // MIs[0] policy
     /* 1121264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M2),
     /* 1121277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121293 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121296 */     // GIR_Coverage, 64321,
     /* 1121296 */     GIR_EraseRootFromParent_Done,
     /* 1121297 */   // Label 16468: @1121297
     /* 1121297 */   GIM_Try, /*On fail goto*//*Label 16469*/ GIMT_Encode4(1121374), // Rule ID 64322 //
     /* 1121302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121341 */     // MIs[0] policy
     /* 1121341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121351 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M2),
     /* 1121354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121373 */     // GIR_Coverage, 64322,
     /* 1121373 */     GIR_EraseRootFromParent_Done,
     /* 1121374 */   // Label 16469: @1121374
     /* 1121374 */   GIM_Try, /*On fail goto*//*Label 16470*/ GIMT_Encode4(1121451), // Rule ID 64323 //
     /* 1121379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121418 */     // MIs[0] policy
     /* 1121418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M4),
     /* 1121431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121450 */     // GIR_Coverage, 64323,
     /* 1121450 */     GIR_EraseRootFromParent_Done,
     /* 1121451 */   // Label 16470: @1121451
     /* 1121451 */   GIM_Try, /*On fail goto*//*Label 16471*/ GIMT_Encode4(1121528), // Rule ID 64324 //
     /* 1121456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121495 */     // MIs[0] policy
     /* 1121495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121505 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M4),
     /* 1121508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121527 */     // GIR_Coverage, 64324,
     /* 1121527 */     GIR_EraseRootFromParent_Done,
     /* 1121528 */   // Label 16471: @1121528
     /* 1121528 */   GIM_Try, /*On fail goto*//*Label 16472*/ GIMT_Encode4(1121605), // Rule ID 64325 //
     /* 1121533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121572 */     // MIs[0] policy
     /* 1121572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121582 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M8),
     /* 1121585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121601 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121604 */     // GIR_Coverage, 64325,
     /* 1121604 */     GIR_EraseRootFromParent_Done,
     /* 1121605 */   // Label 16472: @1121605
     /* 1121605 */   GIM_Try, /*On fail goto*//*Label 16473*/ GIMT_Encode4(1121682), // Rule ID 64326 //
     /* 1121610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121649 */     // MIs[0] policy
     /* 1121649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121659 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M8),
     /* 1121662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121681 */     // GIR_Coverage, 64326,
     /* 1121681 */     GIR_EraseRootFromParent_Done,
     /* 1121682 */   // Label 16473: @1121682
     /* 1121682 */   GIM_Try, /*On fail goto*//*Label 16474*/ GIMT_Encode4(1121759), // Rule ID 64327 //
     /* 1121687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1121690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1121707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121726 */     // MIs[0] policy
     /* 1121726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_MF2),
     /* 1121739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121755 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121758 */     // GIR_Coverage, 64327,
     /* 1121758 */     GIR_EraseRootFromParent_Done,
     /* 1121759 */   // Label 16474: @1121759
     /* 1121759 */   GIM_Try, /*On fail goto*//*Label 16475*/ GIMT_Encode4(1121836), // Rule ID 64328 //
     /* 1121764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1121767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1121784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121803 */     // MIs[0] policy
     /* 1121803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121813 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_MF2),
     /* 1121816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121835 */     // GIR_Coverage, 64328,
     /* 1121835 */     GIR_EraseRootFromParent_Done,
     /* 1121836 */   // Label 16475: @1121836
     /* 1121836 */   GIM_Try, /*On fail goto*//*Label 16476*/ GIMT_Encode4(1121913), // Rule ID 64329 //
     /* 1121841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1121844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121880 */     // MIs[0] policy
     /* 1121880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M1),
     /* 1121893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121909 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121912 */     // GIR_Coverage, 64329,
     /* 1121912 */     GIR_EraseRootFromParent_Done,
     /* 1121913 */   // Label 16476: @1121913
     /* 1121913 */   GIM_Try, /*On fail goto*//*Label 16477*/ GIMT_Encode4(1121990), // Rule ID 64330 //
     /* 1121918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1121921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121957 */     // MIs[0] policy
     /* 1121957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121967 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M1),
     /* 1121970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121986 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121989 */     // GIR_Coverage, 64330,
     /* 1121989 */     GIR_EraseRootFromParent_Done,
     /* 1121990 */   // Label 16477: @1121990
     /* 1121990 */   GIM_Try, /*On fail goto*//*Label 16478*/ GIMT_Encode4(1122067), // Rule ID 64331 //
     /* 1121995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1121998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122034 */     // MIs[0] policy
     /* 1122034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122044 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M2),
     /* 1122047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122063 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122066 */     // GIR_Coverage, 64331,
     /* 1122066 */     GIR_EraseRootFromParent_Done,
     /* 1122067 */   // Label 16478: @1122067
     /* 1122067 */   GIM_Try, /*On fail goto*//*Label 16479*/ GIMT_Encode4(1122144), // Rule ID 64332 //
     /* 1122072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122111 */     // MIs[0] policy
     /* 1122111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M2),
     /* 1122124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122143 */     // GIR_Coverage, 64332,
     /* 1122143 */     GIR_EraseRootFromParent_Done,
     /* 1122144 */   // Label 16479: @1122144
     /* 1122144 */   GIM_Try, /*On fail goto*//*Label 16480*/ GIMT_Encode4(1122221), // Rule ID 64333 //
     /* 1122149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122188 */     // MIs[0] policy
     /* 1122188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M4),
     /* 1122201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122217 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122220 */     // GIR_Coverage, 64333,
     /* 1122220 */     GIR_EraseRootFromParent_Done,
     /* 1122221 */   // Label 16480: @1122221
     /* 1122221 */   GIM_Try, /*On fail goto*//*Label 16481*/ GIMT_Encode4(1122298), // Rule ID 64334 //
     /* 1122226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122265 */     // MIs[0] policy
     /* 1122265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122275 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M4),
     /* 1122278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122297 */     // GIR_Coverage, 64334,
     /* 1122297 */     GIR_EraseRootFromParent_Done,
     /* 1122298 */   // Label 16481: @1122298
     /* 1122298 */   GIM_Try, /*On fail goto*//*Label 16482*/ GIMT_Encode4(1122375), // Rule ID 64335 //
     /* 1122303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122342 */     // MIs[0] policy
     /* 1122342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_MF2),
     /* 1122355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122374 */     // GIR_Coverage, 64335,
     /* 1122374 */     GIR_EraseRootFromParent_Done,
     /* 1122375 */   // Label 16482: @1122375
     /* 1122375 */   GIM_Try, /*On fail goto*//*Label 16483*/ GIMT_Encode4(1122452), // Rule ID 64336 //
     /* 1122380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122419 */     // MIs[0] policy
     /* 1122419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122429 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_MF2),
     /* 1122432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122451 */     // GIR_Coverage, 64336,
     /* 1122451 */     GIR_EraseRootFromParent_Done,
     /* 1122452 */   // Label 16483: @1122452
     /* 1122452 */   GIM_Try, /*On fail goto*//*Label 16484*/ GIMT_Encode4(1122529), // Rule ID 64337 //
     /* 1122457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122496 */     // MIs[0] policy
     /* 1122496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122506 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M1),
     /* 1122509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122528 */     // GIR_Coverage, 64337,
     /* 1122528 */     GIR_EraseRootFromParent_Done,
     /* 1122529 */   // Label 16484: @1122529
     /* 1122529 */   GIM_Try, /*On fail goto*//*Label 16485*/ GIMT_Encode4(1122606), // Rule ID 64338 //
     /* 1122534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122573 */     // MIs[0] policy
     /* 1122573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122583 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M1),
     /* 1122586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122602 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122605 */     // GIR_Coverage, 64338,
     /* 1122605 */     GIR_EraseRootFromParent_Done,
     /* 1122606 */   // Label 16485: @1122606
     /* 1122606 */   GIM_Try, /*On fail goto*//*Label 16486*/ GIMT_Encode4(1122683), // Rule ID 64339 //
     /* 1122611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122650 */     // MIs[0] policy
     /* 1122650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122660 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M2),
     /* 1122663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122682 */     // GIR_Coverage, 64339,
     /* 1122682 */     GIR_EraseRootFromParent_Done,
     /* 1122683 */   // Label 16486: @1122683
     /* 1122683 */   GIM_Try, /*On fail goto*//*Label 16487*/ GIMT_Encode4(1122760), // Rule ID 64340 //
     /* 1122688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122727 */     // MIs[0] policy
     /* 1122727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122737 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M2),
     /* 1122740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122759 */     // GIR_Coverage, 64340,
     /* 1122759 */     GIR_EraseRootFromParent_Done,
     /* 1122760 */   // Label 16487: @1122760
     /* 1122760 */   GIM_Try, /*On fail goto*//*Label 16488*/ GIMT_Encode4(1122837), // Rule ID 64341 //
     /* 1122765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122804 */     // MIs[0] policy
     /* 1122804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122814 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M4),
     /* 1122817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122833 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122836 */     // GIR_Coverage, 64341,
     /* 1122836 */     GIR_EraseRootFromParent_Done,
     /* 1122837 */   // Label 16488: @1122837
     /* 1122837 */   GIM_Try, /*On fail goto*//*Label 16489*/ GIMT_Encode4(1122914), // Rule ID 64342 //
     /* 1122842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122881 */     // MIs[0] policy
     /* 1122881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122891 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M4),
     /* 1122894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122913 */     // GIR_Coverage, 64342,
     /* 1122913 */     GIR_EraseRootFromParent_Done,
     /* 1122914 */   // Label 16489: @1122914
     /* 1122914 */   GIM_Try, /*On fail goto*//*Label 16490*/ GIMT_Encode4(1122991), // Rule ID 64343 //
     /* 1122919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1122927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122958 */     // MIs[0] policy
     /* 1122958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122968 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_MF2),
     /* 1122971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122987 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122990 */     // GIR_Coverage, 64343,
     /* 1122990 */     GIR_EraseRootFromParent_Done,
     /* 1122991 */   // Label 16490: @1122991
     /* 1122991 */   GIM_Try, /*On fail goto*//*Label 16491*/ GIMT_Encode4(1123068), // Rule ID 64344 //
     /* 1122996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1123016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123035 */     // MIs[0] policy
     /* 1123035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123045 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_MF2),
     /* 1123048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123067 */     // GIR_Coverage, 64344,
     /* 1123067 */     GIR_EraseRootFromParent_Done,
     /* 1123068 */   // Label 16491: @1123068
     /* 1123068 */   GIM_Try, /*On fail goto*//*Label 16492*/ GIMT_Encode4(1123145), // Rule ID 64345 //
     /* 1123073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123112 */     // MIs[0] policy
     /* 1123112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123122 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M1),
     /* 1123125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123141 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123144 */     // GIR_Coverage, 64345,
     /* 1123144 */     GIR_EraseRootFromParent_Done,
     /* 1123145 */   // Label 16492: @1123145
     /* 1123145 */   GIM_Try, /*On fail goto*//*Label 16493*/ GIMT_Encode4(1123222), // Rule ID 64346 //
     /* 1123150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123189 */     // MIs[0] policy
     /* 1123189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123199 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M1),
     /* 1123202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123218 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123221 */     // GIR_Coverage, 64346,
     /* 1123221 */     GIR_EraseRootFromParent_Done,
     /* 1123222 */   // Label 16493: @1123222
     /* 1123222 */   GIM_Try, /*On fail goto*//*Label 16494*/ GIMT_Encode4(1123299), // Rule ID 64347 //
     /* 1123227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123266 */     // MIs[0] policy
     /* 1123266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123276 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M2),
     /* 1123279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123295 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123298 */     // GIR_Coverage, 64347,
     /* 1123298 */     GIR_EraseRootFromParent_Done,
     /* 1123299 */   // Label 16494: @1123299
     /* 1123299 */   GIM_Try, /*On fail goto*//*Label 16495*/ GIMT_Encode4(1123376), // Rule ID 64348 //
     /* 1123304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123343 */     // MIs[0] policy
     /* 1123343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123353 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M2),
     /* 1123356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123375 */     // GIR_Coverage, 64348,
     /* 1123375 */     GIR_EraseRootFromParent_Done,
     /* 1123376 */   // Label 16495: @1123376
     /* 1123376 */   GIM_Try, /*On fail goto*//*Label 16496*/ GIMT_Encode4(1123453), // Rule ID 64349 //
     /* 1123381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123420 */     // MIs[0] policy
     /* 1123420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123430 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M4),
     /* 1123433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123452 */     // GIR_Coverage, 64349,
     /* 1123452 */     GIR_EraseRootFromParent_Done,
     /* 1123453 */   // Label 16496: @1123453
     /* 1123453 */   GIM_Try, /*On fail goto*//*Label 16497*/ GIMT_Encode4(1123530), // Rule ID 64350 //
     /* 1123458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123497 */     // MIs[0] policy
     /* 1123497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123507 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M4),
     /* 1123510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123529 */     // GIR_Coverage, 64350,
     /* 1123529 */     GIR_EraseRootFromParent_Done,
     /* 1123530 */   // Label 16497: @1123530
     /* 1123530 */   GIM_Try, /*On fail goto*//*Label 16498*/ GIMT_Encode4(1123607), // Rule ID 64351 //
     /* 1123535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1123555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123574 */     // MIs[0] policy
     /* 1123574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_MF2),
     /* 1123587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123606 */     // GIR_Coverage, 64351,
     /* 1123606 */     GIR_EraseRootFromParent_Done,
     /* 1123607 */   // Label 16498: @1123607
     /* 1123607 */   GIM_Try, /*On fail goto*//*Label 16499*/ GIMT_Encode4(1123684), // Rule ID 64352 //
     /* 1123612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1123632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123651 */     // MIs[0] policy
     /* 1123651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123661 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_MF2),
     /* 1123664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123683 */     // GIR_Coverage, 64352,
     /* 1123683 */     GIR_EraseRootFromParent_Done,
     /* 1123684 */   // Label 16499: @1123684
     /* 1123684 */   GIM_Try, /*On fail goto*//*Label 16500*/ GIMT_Encode4(1123761), // Rule ID 64353 //
     /* 1123689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123728 */     // MIs[0] policy
     /* 1123728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123738 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M1),
     /* 1123741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123760 */     // GIR_Coverage, 64353,
     /* 1123760 */     GIR_EraseRootFromParent_Done,
     /* 1123761 */   // Label 16500: @1123761
     /* 1123761 */   GIM_Try, /*On fail goto*//*Label 16501*/ GIMT_Encode4(1123838), // Rule ID 64354 //
     /* 1123766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123805 */     // MIs[0] policy
     /* 1123805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123815 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M1),
     /* 1123818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123837 */     // GIR_Coverage, 64354,
     /* 1123837 */     GIR_EraseRootFromParent_Done,
     /* 1123838 */   // Label 16501: @1123838
     /* 1123838 */   GIM_Try, /*On fail goto*//*Label 16502*/ GIMT_Encode4(1123915), // Rule ID 64355 //
     /* 1123843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123882 */     // MIs[0] policy
     /* 1123882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123892 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M2),
     /* 1123895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123914 */     // GIR_Coverage, 64355,
     /* 1123914 */     GIR_EraseRootFromParent_Done,
     /* 1123915 */   // Label 16502: @1123915
     /* 1123915 */   GIM_Try, /*On fail goto*//*Label 16503*/ GIMT_Encode4(1123992), // Rule ID 64356 //
     /* 1123920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123959 */     // MIs[0] policy
     /* 1123959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123969 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M2),
     /* 1123972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123988 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123991 */     // GIR_Coverage, 64356,
     /* 1123991 */     GIR_EraseRootFromParent_Done,
     /* 1123992 */   // Label 16503: @1123992
     /* 1123992 */   GIM_Try, /*On fail goto*//*Label 16504*/ GIMT_Encode4(1124069), // Rule ID 64357 //
     /* 1123997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1124000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124036 */     // MIs[0] policy
     /* 1124036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M4),
     /* 1124049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124068 */     // GIR_Coverage, 64357,
     /* 1124068 */     GIR_EraseRootFromParent_Done,
     /* 1124069 */   // Label 16504: @1124069
     /* 1124069 */   GIM_Try, /*On fail goto*//*Label 16505*/ GIMT_Encode4(1124146), // Rule ID 64358 //
     /* 1124074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1124077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124113 */     // MIs[0] policy
     /* 1124113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124123 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M4),
     /* 1124126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124145 */     // GIR_Coverage, 64358,
     /* 1124145 */     GIR_EraseRootFromParent_Done,
     /* 1124146 */   // Label 16505: @1124146
     /* 1124146 */   GIM_Try, /*On fail goto*//*Label 16506*/ GIMT_Encode4(1124223), // Rule ID 65177 //
     /* 1124151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1124162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1124165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1124168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124190 */     // MIs[0] policy
     /* 1124190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124200 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2),
     /* 1124203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124222 */     // GIR_Coverage, 65177,
     /* 1124222 */     GIR_EraseRootFromParent_Done,
     /* 1124223 */   // Label 16506: @1124223
     /* 1124223 */   GIM_Try, /*On fail goto*//*Label 16507*/ GIMT_Encode4(1124300), // Rule ID 65178 //
     /* 1124228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1124239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1124242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1124245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124267 */     // MIs[0] policy
     /* 1124267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124277 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2),
     /* 1124280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124299 */     // GIR_Coverage, 65178,
     /* 1124299 */     GIR_EraseRootFromParent_Done,
     /* 1124300 */   // Label 16507: @1124300
     /* 1124300 */   GIM_Try, /*On fail goto*//*Label 16508*/ GIMT_Encode4(1124377), // Rule ID 65181 //
     /* 1124305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124344 */     // MIs[0] policy
     /* 1124344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1124357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124373 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124376 */     // GIR_Coverage, 65181,
     /* 1124376 */     GIR_EraseRootFromParent_Done,
     /* 1124377 */   // Label 16508: @1124377
     /* 1124377 */   GIM_Try, /*On fail goto*//*Label 16509*/ GIMT_Encode4(1124454), // Rule ID 65182 //
     /* 1124382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124421 */     // MIs[0] policy
     /* 1124421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124431 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1124434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124450 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124453 */     // GIR_Coverage, 65182,
     /* 1124453 */     GIR_EraseRootFromParent_Done,
     /* 1124454 */   // Label 16509: @1124454
     /* 1124454 */   GIM_Try, /*On fail goto*//*Label 16510*/ GIMT_Encode4(1124531), // Rule ID 65185 //
     /* 1124459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1124476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124498 */     // MIs[0] policy
     /* 1124498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124508 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11036:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1124511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124527 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124530 */     // GIR_Coverage, 65185,
     /* 1124530 */     GIR_EraseRootFromParent_Done,
     /* 1124531 */   // Label 16510: @1124531
     /* 1124531 */   GIM_Try, /*On fail goto*//*Label 16511*/ GIMT_Encode4(1124608), // Rule ID 65186 //
     /* 1124536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1124553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124575 */     // MIs[0] policy
     /* 1124575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124585 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11036:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1124588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124604 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124607 */     // GIR_Coverage, 65186,
     /* 1124607 */     GIR_EraseRootFromParent_Done,
     /* 1124608 */   // Label 16511: @1124608
     /* 1124608 */   GIM_Try, /*On fail goto*//*Label 16512*/ GIMT_Encode4(1124685), // Rule ID 65189 //
     /* 1124613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1124630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124652 */     // MIs[0] policy
     /* 1124652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124662 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11036:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1124665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124681 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124684 */     // GIR_Coverage, 65189,
     /* 1124684 */     GIR_EraseRootFromParent_Done,
     /* 1124685 */   // Label 16512: @1124685
     /* 1124685 */   GIM_Try, /*On fail goto*//*Label 16513*/ GIMT_Encode4(1124762), // Rule ID 65190 //
     /* 1124690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1124707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124729 */     // MIs[0] policy
     /* 1124729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124739 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11036:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1124742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124761 */     // GIR_Coverage, 65190,
     /* 1124761 */     GIR_EraseRootFromParent_Done,
     /* 1124762 */   // Label 16513: @1124762
     /* 1124762 */   GIM_Try, /*On fail goto*//*Label 16514*/ GIMT_Encode4(1124839), // Rule ID 65193 //
     /* 1124767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1124784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1124787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124806 */     // MIs[0] policy
     /* 1124806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124816 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11036:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1124819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124838 */     // GIR_Coverage, 65193,
     /* 1124838 */     GIR_EraseRootFromParent_Done,
     /* 1124839 */   // Label 16514: @1124839
     /* 1124839 */   GIM_Try, /*On fail goto*//*Label 16515*/ GIMT_Encode4(1124916), // Rule ID 65194 //
     /* 1124844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1124861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1124864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124883 */     // MIs[0] policy
     /* 1124883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124893 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11036:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1124896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124915 */     // GIR_Coverage, 65194,
     /* 1124915 */     GIR_EraseRootFromParent_Done,
     /* 1124916 */   // Label 16515: @1124916
     /* 1124916 */   GIM_Try, /*On fail goto*//*Label 16516*/ GIMT_Encode4(1124993), // Rule ID 65197 //
     /* 1124921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1124924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1124932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1124935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1124938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1124941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124960 */     // MIs[0] policy
     /* 1124960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124970 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1124973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1124989 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124992 */     // GIR_Coverage, 65197,
     /* 1124992 */     GIR_EraseRootFromParent_Done,
     /* 1124993 */   // Label 16516: @1124993
     /* 1124993 */   GIM_Try, /*On fail goto*//*Label 16517*/ GIMT_Encode4(1125070), // Rule ID 65198 //
     /* 1124998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1125009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1125012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1125015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1125018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125037 */     // MIs[0] policy
     /* 1125037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125047 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1125050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125069 */     // GIR_Coverage, 65198,
     /* 1125069 */     GIR_EraseRootFromParent_Done,
     /* 1125070 */   // Label 16517: @1125070
     /* 1125070 */   GIM_Try, /*On fail goto*//*Label 16518*/ GIMT_Encode4(1125147), // Rule ID 65201 //
     /* 1125075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1125086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1125089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1125092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1125095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125114 */     // MIs[0] policy
     /* 1125114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11036:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1125127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125146 */     // GIR_Coverage, 65201,
     /* 1125146 */     GIR_EraseRootFromParent_Done,
     /* 1125147 */   // Label 16518: @1125147
     /* 1125147 */   GIM_Try, /*On fail goto*//*Label 16519*/ GIMT_Encode4(1125224), // Rule ID 65202 //
     /* 1125152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1125163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1125166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1125169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1125172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125191 */     // MIs[0] policy
     /* 1125191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125201 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11036:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1125204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125223 */     // GIR_Coverage, 65202,
     /* 1125223 */     GIR_EraseRootFromParent_Done,
     /* 1125224 */   // Label 16519: @1125224
     /* 1125224 */   GIM_Try, /*On fail goto*//*Label 16520*/ GIMT_Encode4(1125301), // Rule ID 65205 //
     /* 1125229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1125240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1125243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1125246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1125249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125268 */     // MIs[0] policy
     /* 1125268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125278 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11036:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1125281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125300 */     // GIR_Coverage, 65205,
     /* 1125300 */     GIR_EraseRootFromParent_Done,
     /* 1125301 */   // Label 16520: @1125301
     /* 1125301 */   GIM_Try, /*On fail goto*//*Label 16521*/ GIMT_Encode4(1125378), // Rule ID 65206 //
     /* 1125306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1125317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1125320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1125323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1125326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125345 */     // MIs[0] policy
     /* 1125345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125355 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11036:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1125358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125377 */     // GIR_Coverage, 65206,
     /* 1125377 */     GIR_EraseRootFromParent_Done,
     /* 1125378 */   // Label 16521: @1125378
     /* 1125378 */   GIM_Try, /*On fail goto*//*Label 16522*/ GIMT_Encode4(1125455), // Rule ID 65209 //
     /* 1125383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1125394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1125397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1125400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1125403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125422 */     // MIs[0] policy
     /* 1125422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125432 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11036:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1125435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125454 */     // GIR_Coverage, 65209,
     /* 1125454 */     GIR_EraseRootFromParent_Done,
     /* 1125455 */   // Label 16522: @1125455
     /* 1125455 */   GIM_Try, /*On fail goto*//*Label 16523*/ GIMT_Encode4(1125532), // Rule ID 65210 //
     /* 1125460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1125471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1125474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1125477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1125480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125499 */     // MIs[0] policy
     /* 1125499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125509 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11036:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1125512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125531 */     // GIR_Coverage, 65210,
     /* 1125531 */     GIR_EraseRootFromParent_Done,
     /* 1125532 */   // Label 16523: @1125532
     /* 1125532 */   GIM_Try, /*On fail goto*//*Label 16524*/ GIMT_Encode4(1125609), // Rule ID 65213 //
     /* 1125537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1125548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1125551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1125554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1125557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125576 */     // MIs[0] policy
     /* 1125576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2),
     /* 1125589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125605 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125608 */     // GIR_Coverage, 65213,
     /* 1125608 */     GIR_EraseRootFromParent_Done,
     /* 1125609 */   // Label 16524: @1125609
     /* 1125609 */   GIM_Try, /*On fail goto*//*Label 16525*/ GIMT_Encode4(1125686), // Rule ID 65214 //
     /* 1125614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1125625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1125628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1125631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1125634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125653 */     // MIs[0] policy
     /* 1125653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125663 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2),
     /* 1125666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125682 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125685 */     // GIR_Coverage, 65214,
     /* 1125685 */     GIR_EraseRootFromParent_Done,
     /* 1125686 */   // Label 16525: @1125686
     /* 1125686 */   GIM_Try, /*On fail goto*//*Label 16526*/ GIMT_Encode4(1125763), // Rule ID 65217 //
     /* 1125691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1125702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1125705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1125711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125730 */     // MIs[0] policy
     /* 1125730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1125743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125759 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125762 */     // GIR_Coverage, 65217,
     /* 1125762 */     GIR_EraseRootFromParent_Done,
     /* 1125763 */   // Label 16526: @1125763
     /* 1125763 */   GIM_Try, /*On fail goto*//*Label 16527*/ GIMT_Encode4(1125840), // Rule ID 65218 //
     /* 1125768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1125779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1125782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1125788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125807 */     // MIs[0] policy
     /* 1125807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125817 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1125820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125836 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125839 */     // GIR_Coverage, 65218,
     /* 1125839 */     GIR_EraseRootFromParent_Done,
     /* 1125840 */   // Label 16527: @1125840
     /* 1125840 */   GIM_Try, /*On fail goto*//*Label 16528*/ GIMT_Encode4(1125917), // Rule ID 65221 //
     /* 1125845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1125862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125884 */     // MIs[0] policy
     /* 1125884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125894 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1125897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125916 */     // GIR_Coverage, 65221,
     /* 1125916 */     GIR_EraseRootFromParent_Done,
     /* 1125917 */   // Label 16528: @1125917
     /* 1125917 */   GIM_Try, /*On fail goto*//*Label 16529*/ GIMT_Encode4(1125994), // Rule ID 65222 //
     /* 1125922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1125939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125961 */     // MIs[0] policy
     /* 1125961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1125974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125993 */     // GIR_Coverage, 65222,
     /* 1125993 */     GIR_EraseRootFromParent_Done,
     /* 1125994 */   // Label 16529: @1125994
     /* 1125994 */   GIM_Try, /*On fail goto*//*Label 16530*/ GIMT_Encode4(1126071), // Rule ID 65225 //
     /* 1125999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1126016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126038 */     // MIs[0] policy
     /* 1126038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126048 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1126051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126070 */     // GIR_Coverage, 65225,
     /* 1126070 */     GIR_EraseRootFromParent_Done,
     /* 1126071 */   // Label 16530: @1126071
     /* 1126071 */   GIM_Try, /*On fail goto*//*Label 16531*/ GIMT_Encode4(1126148), // Rule ID 65226 //
     /* 1126076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1126093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126115 */     // MIs[0] policy
     /* 1126115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126125 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1126128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126147 */     // GIR_Coverage, 65226,
     /* 1126147 */     GIR_EraseRootFromParent_Done,
     /* 1126148 */   // Label 16531: @1126148
     /* 1126148 */   GIM_Try, /*On fail goto*//*Label 16532*/ GIMT_Encode4(1126225), // Rule ID 65229 //
     /* 1126153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1126170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1126173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126192 */     // MIs[0] policy
     /* 1126192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126202 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1126205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126221 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126224 */     // GIR_Coverage, 65229,
     /* 1126224 */     GIR_EraseRootFromParent_Done,
     /* 1126225 */   // Label 16532: @1126225
     /* 1126225 */   GIM_Try, /*On fail goto*//*Label 16533*/ GIMT_Encode4(1126302), // Rule ID 65230 //
     /* 1126230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1126247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1126250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126269 */     // MIs[0] policy
     /* 1126269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126279 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1126282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126301 */     // GIR_Coverage, 65230,
     /* 1126301 */     GIR_EraseRootFromParent_Done,
     /* 1126302 */   // Label 16533: @1126302
     /* 1126302 */   GIM_Try, /*On fail goto*//*Label 16534*/ GIMT_Encode4(1126379), // Rule ID 65233 //
     /* 1126307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1126310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1126318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1126321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1126324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1126327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126346 */     // MIs[0] policy
     /* 1126346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1126359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126378 */     // GIR_Coverage, 65233,
     /* 1126378 */     GIR_EraseRootFromParent_Done,
     /* 1126379 */   // Label 16534: @1126379
     /* 1126379 */   GIM_Try, /*On fail goto*//*Label 16535*/ GIMT_Encode4(1126456), // Rule ID 65234 //
     /* 1126384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1126387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1126395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1126398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1126401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1126404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126423 */     // MIs[0] policy
     /* 1126423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126433 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1126436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126455 */     // GIR_Coverage, 65234,
     /* 1126455 */     GIR_EraseRootFromParent_Done,
     /* 1126456 */   // Label 16535: @1126456
     /* 1126456 */   GIM_Try, /*On fail goto*//*Label 16536*/ GIMT_Encode4(1126533), // Rule ID 65237 //
     /* 1126461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1126464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1126472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1126475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1126478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1126481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126500 */     // MIs[0] policy
     /* 1126500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126510 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1126513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126529 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126532 */     // GIR_Coverage, 65237,
     /* 1126532 */     GIR_EraseRootFromParent_Done,
     /* 1126533 */   // Label 16536: @1126533
     /* 1126533 */   GIM_Try, /*On fail goto*//*Label 16537*/ GIMT_Encode4(1126610), // Rule ID 65238 //
     /* 1126538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1126541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1126549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1126552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1126555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1126558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126577 */     // MIs[0] policy
     /* 1126577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126587 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1126590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126609 */     // GIR_Coverage, 65238,
     /* 1126609 */     GIR_EraseRootFromParent_Done,
     /* 1126610 */   // Label 16537: @1126610
     /* 1126610 */   GIM_Try, /*On fail goto*//*Label 16538*/ GIMT_Encode4(1126687), // Rule ID 65241 //
     /* 1126615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1126618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1126626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1126629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1126632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1126635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126654 */     // MIs[0] policy
     /* 1126654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126664 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1126667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126683 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126686 */     // GIR_Coverage, 65241,
     /* 1126686 */     GIR_EraseRootFromParent_Done,
     /* 1126687 */   // Label 16538: @1126687
     /* 1126687 */   GIM_Try, /*On fail goto*//*Label 16539*/ GIMT_Encode4(1126764), // Rule ID 65242 //
     /* 1126692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1126695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1126703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1126706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1126709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1126712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126731 */     // MIs[0] policy
     /* 1126731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126741 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1126744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126763 */     // GIR_Coverage, 65242,
     /* 1126763 */     GIR_EraseRootFromParent_Done,
     /* 1126764 */   // Label 16539: @1126764
     /* 1126764 */   GIM_Try, /*On fail goto*//*Label 16540*/ GIMT_Encode4(1126841), // Rule ID 65245 //
     /* 1126769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1126772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1126780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1126783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1126786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1126789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126808 */     // MIs[0] policy
     /* 1126808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126818 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1126821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126840 */     // GIR_Coverage, 65245,
     /* 1126840 */     GIR_EraseRootFromParent_Done,
     /* 1126841 */   // Label 16540: @1126841
     /* 1126841 */   GIM_Try, /*On fail goto*//*Label 16541*/ GIMT_Encode4(1126918), // Rule ID 65246 //
     /* 1126846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1126849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1126857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1126860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1126863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1126866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126885 */     // MIs[0] policy
     /* 1126885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126895 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1126898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126917 */     // GIR_Coverage, 65246,
     /* 1126917 */     GIR_EraseRootFromParent_Done,
     /* 1126918 */   // Label 16541: @1126918
     /* 1126918 */   GIM_Try, /*On fail goto*//*Label 16542*/ GIMT_Encode4(1126995), // Rule ID 65249 //
     /* 1126923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1126931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1126934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1126937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1126940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126962 */     // MIs[0] policy
     /* 1126962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126972 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2),
     /* 1126975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126991 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126994 */     // GIR_Coverage, 65249,
     /* 1126994 */     GIR_EraseRootFromParent_Done,
     /* 1126995 */   // Label 16542: @1126995
     /* 1126995 */   GIM_Try, /*On fail goto*//*Label 16543*/ GIMT_Encode4(1127072), // Rule ID 65250 //
     /* 1127000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1127011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1127014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1127017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1127020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127039 */     // MIs[0] policy
     /* 1127039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127049 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2),
     /* 1127052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127068 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127071 */     // GIR_Coverage, 65250,
     /* 1127071 */     GIR_EraseRootFromParent_Done,
     /* 1127072 */   // Label 16543: @1127072
     /* 1127072 */   GIM_Try, /*On fail goto*//*Label 16544*/ GIMT_Encode4(1127149), // Rule ID 65253 //
     /* 1127077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1127088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1127091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127116 */     // MIs[0] policy
     /* 1127116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127126 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1127129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127145 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127148 */     // GIR_Coverage, 65253,
     /* 1127148 */     GIR_EraseRootFromParent_Done,
     /* 1127149 */   // Label 16544: @1127149
     /* 1127149 */   GIM_Try, /*On fail goto*//*Label 16545*/ GIMT_Encode4(1127226), // Rule ID 65254 //
     /* 1127154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1127165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1127168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127193 */     // MIs[0] policy
     /* 1127193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127203 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1127206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127225 */     // GIR_Coverage, 65254,
     /* 1127225 */     GIR_EraseRootFromParent_Done,
     /* 1127226 */   // Label 16545: @1127226
     /* 1127226 */   GIM_Try, /*On fail goto*//*Label 16546*/ GIMT_Encode4(1127303), // Rule ID 65257 //
     /* 1127231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1127242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1127245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1127248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127270 */     // MIs[0] policy
     /* 1127270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11038:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1127283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127302 */     // GIR_Coverage, 65257,
     /* 1127302 */     GIR_EraseRootFromParent_Done,
     /* 1127303 */   // Label 16546: @1127303
     /* 1127303 */   GIM_Try, /*On fail goto*//*Label 16547*/ GIMT_Encode4(1127380), // Rule ID 65258 //
     /* 1127308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1127319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1127322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1127325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127347 */     // MIs[0] policy
     /* 1127347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11038:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1127360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127379 */     // GIR_Coverage, 65258,
     /* 1127379 */     GIR_EraseRootFromParent_Done,
     /* 1127380 */   // Label 16547: @1127380
     /* 1127380 */   GIM_Try, /*On fail goto*//*Label 16548*/ GIMT_Encode4(1127457), // Rule ID 65261 //
     /* 1127385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1127402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127424 */     // MIs[0] policy
     /* 1127424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11038:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1127437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127456 */     // GIR_Coverage, 65261,
     /* 1127456 */     GIR_EraseRootFromParent_Done,
     /* 1127457 */   // Label 16548: @1127457
     /* 1127457 */   GIM_Try, /*On fail goto*//*Label 16549*/ GIMT_Encode4(1127534), // Rule ID 65262 //
     /* 1127462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1127479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127501 */     // MIs[0] policy
     /* 1127501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127511 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11038:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1127514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127530 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127533 */     // GIR_Coverage, 65262,
     /* 1127533 */     GIR_EraseRootFromParent_Done,
     /* 1127534 */   // Label 16549: @1127534
     /* 1127534 */   GIM_Try, /*On fail goto*//*Label 16550*/ GIMT_Encode4(1127611), // Rule ID 65265 //
     /* 1127539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1127556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1127559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127578 */     // MIs[0] policy
     /* 1127578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127588 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11038:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1127591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127610 */     // GIR_Coverage, 65265,
     /* 1127610 */     GIR_EraseRootFromParent_Done,
     /* 1127611 */   // Label 16550: @1127611
     /* 1127611 */   GIM_Try, /*On fail goto*//*Label 16551*/ GIMT_Encode4(1127688), // Rule ID 65266 //
     /* 1127616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1127633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1127636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127655 */     // MIs[0] policy
     /* 1127655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127665 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11038:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1127668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127687 */     // GIR_Coverage, 65266,
     /* 1127687 */     GIR_EraseRootFromParent_Done,
     /* 1127688 */   // Label 16551: @1127688
     /* 1127688 */   GIM_Try, /*On fail goto*//*Label 16552*/ GIMT_Encode4(1127765), // Rule ID 65269 //
     /* 1127693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1127696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1127704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1127707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1127710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1127713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127732 */     // MIs[0] policy
     /* 1127732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127742 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1127745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127764 */     // GIR_Coverage, 65269,
     /* 1127764 */     GIR_EraseRootFromParent_Done,
     /* 1127765 */   // Label 16552: @1127765
     /* 1127765 */   GIM_Try, /*On fail goto*//*Label 16553*/ GIMT_Encode4(1127842), // Rule ID 65270 //
     /* 1127770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1127773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1127781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1127784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1127787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1127790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127809 */     // MIs[0] policy
     /* 1127809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127819 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1127822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127841 */     // GIR_Coverage, 65270,
     /* 1127841 */     GIR_EraseRootFromParent_Done,
     /* 1127842 */   // Label 16553: @1127842
     /* 1127842 */   GIM_Try, /*On fail goto*//*Label 16554*/ GIMT_Encode4(1127919), // Rule ID 65273 //
     /* 1127847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1127850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1127858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1127861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1127864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1127867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127886 */     // MIs[0] policy
     /* 1127886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127896 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11038:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1127899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127918 */     // GIR_Coverage, 65273,
     /* 1127918 */     GIR_EraseRootFromParent_Done,
     /* 1127919 */   // Label 16554: @1127919
     /* 1127919 */   GIM_Try, /*On fail goto*//*Label 16555*/ GIMT_Encode4(1127996), // Rule ID 65274 //
     /* 1127924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1127927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1127935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1127938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1127941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1127944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127963 */     // MIs[0] policy
     /* 1127963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127973 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11038:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1127976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127995 */     // GIR_Coverage, 65274,
     /* 1127995 */     GIR_EraseRootFromParent_Done,
     /* 1127996 */   // Label 16555: @1127996
     /* 1127996 */   GIM_Try, /*On fail goto*//*Label 16556*/ GIMT_Encode4(1128073), // Rule ID 65277 //
     /* 1128001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1128012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1128015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1128018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1128021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128040 */     // MIs[0] policy
     /* 1128040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128050 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11038:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1128053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128069 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128072 */     // GIR_Coverage, 65277,
     /* 1128072 */     GIR_EraseRootFromParent_Done,
     /* 1128073 */   // Label 16556: @1128073
     /* 1128073 */   GIM_Try, /*On fail goto*//*Label 16557*/ GIMT_Encode4(1128150), // Rule ID 65278 //
     /* 1128078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1128089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1128092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1128095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1128098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128117 */     // MIs[0] policy
     /* 1128117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128127 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11038:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1128130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128146 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128149 */     // GIR_Coverage, 65278,
     /* 1128149 */     GIR_EraseRootFromParent_Done,
     /* 1128150 */   // Label 16557: @1128150
     /* 1128150 */   GIM_Try, /*On fail goto*//*Label 16558*/ GIMT_Encode4(1128227), // Rule ID 65281 //
     /* 1128155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1128166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1128169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1128172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1128175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128194 */     // MIs[0] policy
     /* 1128194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128204 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11038:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1128207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128223 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128226 */     // GIR_Coverage, 65281,
     /* 1128226 */     GIR_EraseRootFromParent_Done,
     /* 1128227 */   // Label 16558: @1128227
     /* 1128227 */   GIM_Try, /*On fail goto*//*Label 16559*/ GIMT_Encode4(1128304), // Rule ID 65282 //
     /* 1128232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1128243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1128246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1128249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1128252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128271 */     // MIs[0] policy
     /* 1128271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128281 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11038:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1128284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128303 */     // GIR_Coverage, 65282,
     /* 1128303 */     GIR_EraseRootFromParent_Done,
     /* 1128304 */   // Label 16559: @1128304
     /* 1128304 */   GIM_Try, /*On fail goto*//*Label 16560*/ GIMT_Encode4(1128384), // Rule ID 2728 //
     /* 1128309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1128320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1128323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1128326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1128329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128348 */     // MIs[0] round
     /* 1128348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128358 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1128361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128383 */     // GIR_Coverage, 2728,
     /* 1128383 */     GIR_EraseRootFromParent_Done,
     /* 1128384 */   // Label 16560: @1128384
     /* 1128384 */   GIM_Try, /*On fail goto*//*Label 16561*/ GIMT_Encode4(1128464), // Rule ID 2729 //
     /* 1128389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1128400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1128403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1128406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1128409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128428 */     // MIs[0] round
     /* 1128428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128438 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1128441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128463 */     // GIR_Coverage, 2729,
     /* 1128463 */     GIR_EraseRootFromParent_Done,
     /* 1128464 */   // Label 16561: @1128464
     /* 1128464 */   GIM_Try, /*On fail goto*//*Label 16562*/ GIMT_Encode4(1128544), // Rule ID 2768 //
     /* 1128469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1128472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1128477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1128480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1128483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1128486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1128489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128508 */     // MIs[0] round
     /* 1128508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128518 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1128521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128543 */     // GIR_Coverage, 2768,
     /* 1128543 */     GIR_EraseRootFromParent_Done,
     /* 1128544 */   // Label 16562: @1128544
     /* 1128544 */   GIM_Try, /*On fail goto*//*Label 16563*/ GIMT_Encode4(1128624), // Rule ID 2769 //
     /* 1128549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1128552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1128557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1128560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1128563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1128566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1128569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128588 */     // MIs[0] round
     /* 1128588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128598 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1128601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128623 */     // GIR_Coverage, 2769,
     /* 1128623 */     GIR_EraseRootFromParent_Done,
     /* 1128624 */   // Label 16563: @1128624
     /* 1128624 */   GIM_Try, /*On fail goto*//*Label 16564*/ GIMT_Encode4(1128704), // Rule ID 2788 //
     /* 1128629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1128632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1128646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128668 */     // MIs[0] round
     /* 1128668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128678 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1128681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128703 */     // GIR_Coverage, 2788,
     /* 1128703 */     GIR_EraseRootFromParent_Done,
     /* 1128704 */   // Label 16564: @1128704
     /* 1128704 */   GIM_Try, /*On fail goto*//*Label 16565*/ GIMT_Encode4(1128784), // Rule ID 2789 //
     /* 1128709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1128712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1128726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128748 */     // MIs[0] round
     /* 1128748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128758 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1128761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128783 */     // GIR_Coverage, 2789,
     /* 1128783 */     GIR_EraseRootFromParent_Done,
     /* 1128784 */   // Label 16565: @1128784
     /* 1128784 */   GIM_Try, /*On fail goto*//*Label 16566*/ GIMT_Encode4(1128864), // Rule ID 14938 //
     /* 1128789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1128800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1128803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1128806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1128809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128828 */     // MIs[0] round
     /* 1128828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128838 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1128841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128863 */     // GIR_Coverage, 14938,
     /* 1128863 */     GIR_EraseRootFromParent_Done,
     /* 1128864 */   // Label 16566: @1128864
     /* 1128864 */   GIM_Try, /*On fail goto*//*Label 16567*/ GIMT_Encode4(1128944), // Rule ID 14939 //
     /* 1128869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1128880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1128883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1128886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1128889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128908 */     // MIs[0] round
     /* 1128908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128918 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1128921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128943 */     // GIR_Coverage, 14939,
     /* 1128943 */     GIR_EraseRootFromParent_Done,
     /* 1128944 */   // Label 16567: @1128944
     /* 1128944 */   GIM_Try, /*On fail goto*//*Label 16568*/ GIMT_Encode4(1129024), // Rule ID 14942 //
     /* 1128949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1128960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1128963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1128966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1128969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128988 */     // MIs[0] round
     /* 1128988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128998 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129023 */     // GIR_Coverage, 14942,
     /* 1129023 */     GIR_EraseRootFromParent_Done,
     /* 1129024 */   // Label 16568: @1129024
     /* 1129024 */   GIM_Try, /*On fail goto*//*Label 16569*/ GIMT_Encode4(1129104), // Rule ID 14943 //
     /* 1129029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1129040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1129043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1129046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1129049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129068 */     // MIs[0] round
     /* 1129068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129078 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129103 */     // GIR_Coverage, 14943,
     /* 1129103 */     GIR_EraseRootFromParent_Done,
     /* 1129104 */   // Label 16569: @1129104
     /* 1129104 */   GIM_Try, /*On fail goto*//*Label 16570*/ GIMT_Encode4(1129184), // Rule ID 14946 //
     /* 1129109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1129120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1129123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1129126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1129129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129148 */     // MIs[0] round
     /* 1129148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129158 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1129161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129183 */     // GIR_Coverage, 14946,
     /* 1129183 */     GIR_EraseRootFromParent_Done,
     /* 1129184 */   // Label 16570: @1129184
     /* 1129184 */   GIM_Try, /*On fail goto*//*Label 16571*/ GIMT_Encode4(1129264), // Rule ID 14947 //
     /* 1129189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1129200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1129203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1129206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1129209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129228 */     // MIs[0] round
     /* 1129228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129238 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1129241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129263 */     // GIR_Coverage, 14947,
     /* 1129263 */     GIR_EraseRootFromParent_Done,
     /* 1129264 */   // Label 16571: @1129264
     /* 1129264 */   GIM_Try, /*On fail goto*//*Label 16572*/ GIMT_Encode4(1129344), // Rule ID 14950 //
     /* 1129269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1129280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1129283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1129286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1129289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129308 */     // MIs[0] round
     /* 1129308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129318 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129343 */     // GIR_Coverage, 14950,
     /* 1129343 */     GIR_EraseRootFromParent_Done,
     /* 1129344 */   // Label 16572: @1129344
     /* 1129344 */   GIM_Try, /*On fail goto*//*Label 16573*/ GIMT_Encode4(1129424), // Rule ID 14951 //
     /* 1129349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1129360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1129363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1129366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1129369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129388 */     // MIs[0] round
     /* 1129388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129398 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129423 */     // GIR_Coverage, 14951,
     /* 1129423 */     GIR_EraseRootFromParent_Done,
     /* 1129424 */   // Label 16573: @1129424
     /* 1129424 */   GIM_Try, /*On fail goto*//*Label 16574*/ GIMT_Encode4(1129504), // Rule ID 14954 //
     /* 1129429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1129446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1129449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129468 */     // MIs[0] round
     /* 1129468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129503 */     // GIR_Coverage, 14954,
     /* 1129503 */     GIR_EraseRootFromParent_Done,
     /* 1129504 */   // Label 16574: @1129504
     /* 1129504 */   GIM_Try, /*On fail goto*//*Label 16575*/ GIMT_Encode4(1129584), // Rule ID 14955 //
     /* 1129509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1129526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1129529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129548 */     // MIs[0] round
     /* 1129548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129558 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129583 */     // GIR_Coverage, 14955,
     /* 1129583 */     GIR_EraseRootFromParent_Done,
     /* 1129584 */   // Label 16575: @1129584
     /* 1129584 */   GIM_Try, /*On fail goto*//*Label 16576*/ GIMT_Encode4(1129664), // Rule ID 14958 //
     /* 1129589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1129600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1129603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1129606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1129609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129628 */     // MIs[0] round
     /* 1129628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129638 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129663 */     // GIR_Coverage, 14958,
     /* 1129663 */     GIR_EraseRootFromParent_Done,
     /* 1129664 */   // Label 16576: @1129664
     /* 1129664 */   GIM_Try, /*On fail goto*//*Label 16577*/ GIMT_Encode4(1129744), // Rule ID 14959 //
     /* 1129669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1129680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1129683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1129686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1129689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129708 */     // MIs[0] round
     /* 1129708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129743 */     // GIR_Coverage, 14959,
     /* 1129743 */     GIR_EraseRootFromParent_Done,
     /* 1129744 */   // Label 16577: @1129744
     /* 1129744 */   GIM_Try, /*On fail goto*//*Label 16578*/ GIMT_Encode4(1129824), // Rule ID 14962 //
     /* 1129749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1129760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1129763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1129766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1129769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129788 */     // MIs[0] round
     /* 1129788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129798 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129823 */     // GIR_Coverage, 14962,
     /* 1129823 */     GIR_EraseRootFromParent_Done,
     /* 1129824 */   // Label 16578: @1129824
     /* 1129824 */   GIM_Try, /*On fail goto*//*Label 16579*/ GIMT_Encode4(1129904), // Rule ID 14963 //
     /* 1129829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1129840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1129843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1129846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1129849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129868 */     // MIs[0] round
     /* 1129868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129878 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129903 */     // GIR_Coverage, 14963,
     /* 1129903 */     GIR_EraseRootFromParent_Done,
     /* 1129904 */   // Label 16579: @1129904
     /* 1129904 */   GIM_Try, /*On fail goto*//*Label 16580*/ GIMT_Encode4(1129984), // Rule ID 14966 //
     /* 1129909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1129920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1129923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1129926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1129929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129948 */     // MIs[0] round
     /* 1129948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129983 */     // GIR_Coverage, 14966,
     /* 1129983 */     GIR_EraseRootFromParent_Done,
     /* 1129984 */   // Label 16580: @1129984
     /* 1129984 */   GIM_Try, /*On fail goto*//*Label 16581*/ GIMT_Encode4(1130064), // Rule ID 14967 //
     /* 1129989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1130000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1130003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1130006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1130009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130028 */     // MIs[0] round
     /* 1130028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130038 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130063 */     // GIR_Coverage, 14967,
     /* 1130063 */     GIR_EraseRootFromParent_Done,
     /* 1130064 */   // Label 16581: @1130064
     /* 1130064 */   GIM_Try, /*On fail goto*//*Label 16582*/ GIMT_Encode4(1130144), // Rule ID 14970 //
     /* 1130069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1130072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1130080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1130083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1130086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1130089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130108 */     // MIs[0] round
     /* 1130108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130118 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130143 */     // GIR_Coverage, 14970,
     /* 1130143 */     GIR_EraseRootFromParent_Done,
     /* 1130144 */   // Label 16582: @1130144
     /* 1130144 */   GIM_Try, /*On fail goto*//*Label 16583*/ GIMT_Encode4(1130224), // Rule ID 14971 //
     /* 1130149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1130152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1130160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1130163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1130166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1130169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130188 */     // MIs[0] round
     /* 1130188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130198 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130223 */     // GIR_Coverage, 14971,
     /* 1130223 */     GIR_EraseRootFromParent_Done,
     /* 1130224 */   // Label 16583: @1130224
     /* 1130224 */   GIM_Try, /*On fail goto*//*Label 16584*/ GIMT_Encode4(1130304), // Rule ID 14974 //
     /* 1130229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1130240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1130243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1130246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1130249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130268 */     // MIs[0] round
     /* 1130268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130278 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130303 */     // GIR_Coverage, 14974,
     /* 1130303 */     GIR_EraseRootFromParent_Done,
     /* 1130304 */   // Label 16584: @1130304
     /* 1130304 */   GIM_Try, /*On fail goto*//*Label 16585*/ GIMT_Encode4(1130384), // Rule ID 14975 //
     /* 1130309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1130320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1130323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1130326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1130329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130348 */     // MIs[0] round
     /* 1130348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130358 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130383 */     // GIR_Coverage, 14975,
     /* 1130383 */     GIR_EraseRootFromParent_Done,
     /* 1130384 */   // Label 16585: @1130384
     /* 1130384 */   GIM_Try, /*On fail goto*//*Label 16586*/ GIMT_Encode4(1130464), // Rule ID 14978 //
     /* 1130389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1130400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1130403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1130406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1130409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130428 */     // MIs[0] round
     /* 1130428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130438 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130463 */     // GIR_Coverage, 14978,
     /* 1130463 */     GIR_EraseRootFromParent_Done,
     /* 1130464 */   // Label 16586: @1130464
     /* 1130464 */   GIM_Try, /*On fail goto*//*Label 16587*/ GIMT_Encode4(1130544), // Rule ID 14979 //
     /* 1130469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1130480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1130483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1130486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1130489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130508 */     // MIs[0] round
     /* 1130508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130518 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130543 */     // GIR_Coverage, 14979,
     /* 1130543 */     GIR_EraseRootFromParent_Done,
     /* 1130544 */   // Label 16587: @1130544
     /* 1130544 */   GIM_Try, /*On fail goto*//*Label 16588*/ GIMT_Encode4(1130624), // Rule ID 14982 //
     /* 1130549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1130560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1130563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1130566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1130569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130588 */     // MIs[0] round
     /* 1130588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130598 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1130601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130623 */     // GIR_Coverage, 14982,
     /* 1130623 */     GIR_EraseRootFromParent_Done,
     /* 1130624 */   // Label 16588: @1130624
     /* 1130624 */   GIM_Try, /*On fail goto*//*Label 16589*/ GIMT_Encode4(1130704), // Rule ID 14983 //
     /* 1130629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1130640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1130643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1130646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1130649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130668 */     // MIs[0] round
     /* 1130668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130678 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1130681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130703 */     // GIR_Coverage, 14983,
     /* 1130703 */     GIR_EraseRootFromParent_Done,
     /* 1130704 */   // Label 16589: @1130704
     /* 1130704 */   GIM_Try, /*On fail goto*//*Label 16590*/ GIMT_Encode4(1130784), // Rule ID 14986 //
     /* 1130709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1130720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1130723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1130726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1130729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130748 */     // MIs[0] round
     /* 1130748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130758 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130783 */     // GIR_Coverage, 14986,
     /* 1130783 */     GIR_EraseRootFromParent_Done,
     /* 1130784 */   // Label 16590: @1130784
     /* 1130784 */   GIM_Try, /*On fail goto*//*Label 16591*/ GIMT_Encode4(1130864), // Rule ID 14987 //
     /* 1130789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1130800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1130803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1130806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1130809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130828 */     // MIs[0] round
     /* 1130828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130863 */     // GIR_Coverage, 14987,
     /* 1130863 */     GIR_EraseRootFromParent_Done,
     /* 1130864 */   // Label 16591: @1130864
     /* 1130864 */   GIM_Try, /*On fail goto*//*Label 16592*/ GIMT_Encode4(1130944), // Rule ID 14990 //
     /* 1130869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1130880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1130883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1130886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1130889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130908 */     // MIs[0] round
     /* 1130908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130943 */     // GIR_Coverage, 14990,
     /* 1130943 */     GIR_EraseRootFromParent_Done,
     /* 1130944 */   // Label 16592: @1130944
     /* 1130944 */   GIM_Try, /*On fail goto*//*Label 16593*/ GIMT_Encode4(1131024), // Rule ID 14991 //
     /* 1130949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1130960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1130963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1130966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1130969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130988 */     // MIs[0] round
     /* 1130988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130998 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131023 */     // GIR_Coverage, 14991,
     /* 1131023 */     GIR_EraseRootFromParent_Done,
     /* 1131024 */   // Label 16593: @1131024
     /* 1131024 */   GIM_Try, /*On fail goto*//*Label 16594*/ GIMT_Encode4(1131104), // Rule ID 14994 //
     /* 1131029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1131040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1131043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1131046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1131049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131068 */     // MIs[0] round
     /* 1131068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131078 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131103 */     // GIR_Coverage, 14994,
     /* 1131103 */     GIR_EraseRootFromParent_Done,
     /* 1131104 */   // Label 16594: @1131104
     /* 1131104 */   GIM_Try, /*On fail goto*//*Label 16595*/ GIMT_Encode4(1131184), // Rule ID 14995 //
     /* 1131109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1131120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1131123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1131126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1131129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131148 */     // MIs[0] round
     /* 1131148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131158 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131183 */     // GIR_Coverage, 14995,
     /* 1131183 */     GIR_EraseRootFromParent_Done,
     /* 1131184 */   // Label 16595: @1131184
     /* 1131184 */   GIM_Try, /*On fail goto*//*Label 16596*/ GIMT_Encode4(1131264), // Rule ID 14998 //
     /* 1131189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1131200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1131203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1131206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1131209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131228 */     // MIs[0] round
     /* 1131228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131238 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131263 */     // GIR_Coverage, 14998,
     /* 1131263 */     GIR_EraseRootFromParent_Done,
     /* 1131264 */   // Label 16596: @1131264
     /* 1131264 */   GIM_Try, /*On fail goto*//*Label 16597*/ GIMT_Encode4(1131344), // Rule ID 14999 //
     /* 1131269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1131280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1131283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1131286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1131289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131308 */     // MIs[0] round
     /* 1131308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131343 */     // GIR_Coverage, 14999,
     /* 1131343 */     GIR_EraseRootFromParent_Done,
     /* 1131344 */   // Label 16597: @1131344
     /* 1131344 */   GIM_Try, /*On fail goto*//*Label 16598*/ GIMT_Encode4(1131424), // Rule ID 15002 //
     /* 1131349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1131360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1131363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1131366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1131369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131388 */     // MIs[0] round
     /* 1131388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131398 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131423 */     // GIR_Coverage, 15002,
     /* 1131423 */     GIR_EraseRootFromParent_Done,
     /* 1131424 */   // Label 16598: @1131424
     /* 1131424 */   GIM_Try, /*On fail goto*//*Label 16599*/ GIMT_Encode4(1131504), // Rule ID 15003 //
     /* 1131429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1131440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1131443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1131446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1131449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131468 */     // MIs[0] round
     /* 1131468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131503 */     // GIR_Coverage, 15003,
     /* 1131503 */     GIR_EraseRootFromParent_Done,
     /* 1131504 */   // Label 16599: @1131504
     /* 1131504 */   GIM_Try, /*On fail goto*//*Label 16600*/ GIMT_Encode4(1131584), // Rule ID 15006 //
     /* 1131509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1131520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1131523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1131526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1131529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131548 */     // MIs[0] round
     /* 1131548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131558 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131583 */     // GIR_Coverage, 15006,
     /* 1131583 */     GIR_EraseRootFromParent_Done,
     /* 1131584 */   // Label 16600: @1131584
     /* 1131584 */   GIM_Try, /*On fail goto*//*Label 16601*/ GIMT_Encode4(1131664), // Rule ID 15007 //
     /* 1131589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1131600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1131603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1131606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1131609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131628 */     // MIs[0] round
     /* 1131628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131638 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131663 */     // GIR_Coverage, 15007,
     /* 1131663 */     GIR_EraseRootFromParent_Done,
     /* 1131664 */   // Label 16601: @1131664
     /* 1131664 */   GIM_Try, /*On fail goto*//*Label 16602*/ GIMT_Encode4(1131744), // Rule ID 15010 //
     /* 1131669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1131672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1131680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1131683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1131686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1131689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131708 */     // MIs[0] round
     /* 1131708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131718 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131743 */     // GIR_Coverage, 15010,
     /* 1131743 */     GIR_EraseRootFromParent_Done,
     /* 1131744 */   // Label 16602: @1131744
     /* 1131744 */   GIM_Try, /*On fail goto*//*Label 16603*/ GIMT_Encode4(1131824), // Rule ID 15011 //
     /* 1131749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1131752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1131760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1131763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1131766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1131769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131788 */     // MIs[0] round
     /* 1131788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131823 */     // GIR_Coverage, 15011,
     /* 1131823 */     GIR_EraseRootFromParent_Done,
     /* 1131824 */   // Label 16603: @1131824
     /* 1131824 */   GIM_Try, /*On fail goto*//*Label 16604*/ GIMT_Encode4(1131904), // Rule ID 15014 //
     /* 1131829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1131832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1131840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1131843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1131846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1131849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131868 */     // MIs[0] round
     /* 1131868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131878 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131903 */     // GIR_Coverage, 15014,
     /* 1131903 */     GIR_EraseRootFromParent_Done,
     /* 1131904 */   // Label 16604: @1131904
     /* 1131904 */   GIM_Try, /*On fail goto*//*Label 16605*/ GIMT_Encode4(1131984), // Rule ID 15015 //
     /* 1131909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1131912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1131920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1131923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1131926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1131929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131948 */     // MIs[0] round
     /* 1131948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131958 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131983 */     // GIR_Coverage, 15015,
     /* 1131983 */     GIR_EraseRootFromParent_Done,
     /* 1131984 */   // Label 16605: @1131984
     /* 1131984 */   GIM_Try, /*On fail goto*//*Label 16606*/ GIMT_Encode4(1132064), // Rule ID 15018 //
     /* 1131989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1131992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1132000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1132003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1132006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1132009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132028 */     // MIs[0] round
     /* 1132028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132038 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1132041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132063 */     // GIR_Coverage, 15018,
     /* 1132063 */     GIR_EraseRootFromParent_Done,
     /* 1132064 */   // Label 16606: @1132064
     /* 1132064 */   GIM_Try, /*On fail goto*//*Label 16607*/ GIMT_Encode4(1132144), // Rule ID 15019 //
     /* 1132069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1132072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1132080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1132083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1132086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1132089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132108 */     // MIs[0] round
     /* 1132108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132118 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1132121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132143 */     // GIR_Coverage, 15019,
     /* 1132143 */     GIR_EraseRootFromParent_Done,
     /* 1132144 */   // Label 16607: @1132144
     /* 1132144 */   GIM_Try, /*On fail goto*//*Label 16608*/ GIMT_Encode4(1132224), // Rule ID 15022 //
     /* 1132149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1132160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1132163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1132166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132188 */     // MIs[0] round
     /* 1132188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132198 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1132201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132223 */     // GIR_Coverage, 15022,
     /* 1132223 */     GIR_EraseRootFromParent_Done,
     /* 1132224 */   // Label 16608: @1132224
     /* 1132224 */   GIM_Try, /*On fail goto*//*Label 16609*/ GIMT_Encode4(1132304), // Rule ID 15023 //
     /* 1132229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1132240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1132243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1132246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132268 */     // MIs[0] round
     /* 1132268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132278 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1132281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132303 */     // GIR_Coverage, 15023,
     /* 1132303 */     GIR_EraseRootFromParent_Done,
     /* 1132304 */   // Label 16609: @1132304
     /* 1132304 */   GIM_Try, /*On fail goto*//*Label 16610*/ GIMT_Encode4(1132384), // Rule ID 15026 //
     /* 1132309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1132320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1132323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1132326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132348 */     // MIs[0] round
     /* 1132348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132358 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132383 */     // GIR_Coverage, 15026,
     /* 1132383 */     GIR_EraseRootFromParent_Done,
     /* 1132384 */   // Label 16610: @1132384
     /* 1132384 */   GIM_Try, /*On fail goto*//*Label 16611*/ GIMT_Encode4(1132464), // Rule ID 15027 //
     /* 1132389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1132400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1132403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1132406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132428 */     // MIs[0] round
     /* 1132428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132438 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132463 */     // GIR_Coverage, 15027,
     /* 1132463 */     GIR_EraseRootFromParent_Done,
     /* 1132464 */   // Label 16611: @1132464
     /* 1132464 */   GIM_Try, /*On fail goto*//*Label 16612*/ GIMT_Encode4(1132544), // Rule ID 15030 //
     /* 1132469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1132480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1132483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1132486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132508 */     // MIs[0] round
     /* 1132508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132518 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132543 */     // GIR_Coverage, 15030,
     /* 1132543 */     GIR_EraseRootFromParent_Done,
     /* 1132544 */   // Label 16612: @1132544
     /* 1132544 */   GIM_Try, /*On fail goto*//*Label 16613*/ GIMT_Encode4(1132624), // Rule ID 15031 //
     /* 1132549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1132560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1132563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1132566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132588 */     // MIs[0] round
     /* 1132588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132598 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132623 */     // GIR_Coverage, 15031,
     /* 1132623 */     GIR_EraseRootFromParent_Done,
     /* 1132624 */   // Label 16613: @1132624
     /* 1132624 */   GIM_Try, /*On fail goto*//*Label 16614*/ GIMT_Encode4(1132704), // Rule ID 15034 //
     /* 1132629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1132640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1132643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1132646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132668 */     // MIs[0] round
     /* 1132668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132678 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132703 */     // GIR_Coverage, 15034,
     /* 1132703 */     GIR_EraseRootFromParent_Done,
     /* 1132704 */   // Label 16614: @1132704
     /* 1132704 */   GIM_Try, /*On fail goto*//*Label 16615*/ GIMT_Encode4(1132784), // Rule ID 15035 //
     /* 1132709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1132720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1132723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1132726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132748 */     // MIs[0] round
     /* 1132748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132758 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132783 */     // GIR_Coverage, 15035,
     /* 1132783 */     GIR_EraseRootFromParent_Done,
     /* 1132784 */   // Label 16615: @1132784
     /* 1132784 */   GIM_Try, /*On fail goto*//*Label 16616*/ GIMT_Encode4(1132864), // Rule ID 15038 //
     /* 1132789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1132800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1132803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1132806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132828 */     // MIs[0] round
     /* 1132828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132838 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132863 */     // GIR_Coverage, 15038,
     /* 1132863 */     GIR_EraseRootFromParent_Done,
     /* 1132864 */   // Label 16616: @1132864
     /* 1132864 */   GIM_Try, /*On fail goto*//*Label 16617*/ GIMT_Encode4(1132944), // Rule ID 15039 //
     /* 1132869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1132880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1132883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1132886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132908 */     // MIs[0] round
     /* 1132908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132943 */     // GIR_Coverage, 15039,
     /* 1132943 */     GIR_EraseRootFromParent_Done,
     /* 1132944 */   // Label 16617: @1132944
     /* 1132944 */   GIM_Try, /*On fail goto*//*Label 16618*/ GIMT_Encode4(1133024), // Rule ID 15042 //
     /* 1132949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1132960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1132963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1132966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132988 */     // MIs[0] round
     /* 1132988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1133001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133023 */     // GIR_Coverage, 15042,
     /* 1133023 */     GIR_EraseRootFromParent_Done,
     /* 1133024 */   // Label 16618: @1133024
     /* 1133024 */   GIM_Try, /*On fail goto*//*Label 16619*/ GIMT_Encode4(1133104), // Rule ID 15043 //
     /* 1133029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1133040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1133043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1133046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133068 */     // MIs[0] round
     /* 1133068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133078 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1133081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133103 */     // GIR_Coverage, 15043,
     /* 1133103 */     GIR_EraseRootFromParent_Done,
     /* 1133104 */   // Label 16619: @1133104
     /* 1133104 */   GIM_Try, /*On fail goto*//*Label 16620*/ GIMT_Encode4(1133184), // Rule ID 15046 //
     /* 1133109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1133120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1133123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1133126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133148 */     // MIs[0] round
     /* 1133148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133158 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133183 */     // GIR_Coverage, 15046,
     /* 1133183 */     GIR_EraseRootFromParent_Done,
     /* 1133184 */   // Label 16620: @1133184
     /* 1133184 */   GIM_Try, /*On fail goto*//*Label 16621*/ GIMT_Encode4(1133264), // Rule ID 15047 //
     /* 1133189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1133200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1133203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1133206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133228 */     // MIs[0] round
     /* 1133228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133238 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133263 */     // GIR_Coverage, 15047,
     /* 1133263 */     GIR_EraseRootFromParent_Done,
     /* 1133264 */   // Label 16621: @1133264
     /* 1133264 */   GIM_Try, /*On fail goto*//*Label 16622*/ GIMT_Encode4(1133344), // Rule ID 15050 //
     /* 1133269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1133280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1133283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1133286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133308 */     // MIs[0] round
     /* 1133308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133343 */     // GIR_Coverage, 15050,
     /* 1133343 */     GIR_EraseRootFromParent_Done,
     /* 1133344 */   // Label 16622: @1133344
     /* 1133344 */   GIM_Try, /*On fail goto*//*Label 16623*/ GIMT_Encode4(1133424), // Rule ID 15051 //
     /* 1133349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1133360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1133363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1133366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133388 */     // MIs[0] round
     /* 1133388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133423 */     // GIR_Coverage, 15051,
     /* 1133423 */     GIR_EraseRootFromParent_Done,
     /* 1133424 */   // Label 16623: @1133424
     /* 1133424 */   GIM_Try, /*On fail goto*//*Label 16624*/ GIMT_Encode4(1133504), // Rule ID 15054 //
     /* 1133429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133468 */     // MIs[0] round
     /* 1133468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133478 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133503 */     // GIR_Coverage, 15054,
     /* 1133503 */     GIR_EraseRootFromParent_Done,
     /* 1133504 */   // Label 16624: @1133504
     /* 1133504 */   GIM_Try, /*On fail goto*//*Label 16625*/ GIMT_Encode4(1133584), // Rule ID 15055 //
     /* 1133509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133548 */     // MIs[0] round
     /* 1133548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133583 */     // GIR_Coverage, 15055,
     /* 1133583 */     GIR_EraseRootFromParent_Done,
     /* 1133584 */   // Label 16625: @1133584
     /* 1133584 */   GIM_Try, /*On fail goto*//*Label 16626*/ GIMT_Encode4(1133664), // Rule ID 15058 //
     /* 1133589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1133592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1133606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133628 */     // MIs[0] round
     /* 1133628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133638 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1133659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133663 */     // GIR_Coverage, 15058,
     /* 1133663 */     GIR_EraseRootFromParent_Done,
     /* 1133664 */   // Label 16626: @1133664
     /* 1133664 */   GIM_Try, /*On fail goto*//*Label 16627*/ GIMT_Encode4(1133744), // Rule ID 15059 //
     /* 1133669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1133672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1133686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133708 */     // MIs[0] round
     /* 1133708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133718 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1133739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133743 */     // GIR_Coverage, 15059,
     /* 1133743 */     GIR_EraseRootFromParent_Done,
     /* 1133744 */   // Label 16627: @1133744
     /* 1133744 */   GIM_Try, /*On fail goto*//*Label 16628*/ GIMT_Encode4(1133824), // Rule ID 15062 //
     /* 1133749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1133760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1133763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1133766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133788 */     // MIs[0] round
     /* 1133788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133798 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1133801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133823 */     // GIR_Coverage, 15062,
     /* 1133823 */     GIR_EraseRootFromParent_Done,
     /* 1133824 */   // Label 16628: @1133824
     /* 1133824 */   GIM_Try, /*On fail goto*//*Label 16629*/ GIMT_Encode4(1133904), // Rule ID 15063 //
     /* 1133829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1133840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1133843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1133846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133868 */     // MIs[0] round
     /* 1133868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133878 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1133881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133903 */     // GIR_Coverage, 15063,
     /* 1133903 */     GIR_EraseRootFromParent_Done,
     /* 1133904 */   // Label 16629: @1133904
     /* 1133904 */   GIM_Try, /*On fail goto*//*Label 16630*/ GIMT_Encode4(1133984), // Rule ID 15066 //
     /* 1133909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1133920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1133923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1133926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133948 */     // MIs[0] round
     /* 1133948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133958 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1133961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133983 */     // GIR_Coverage, 15066,
     /* 1133983 */     GIR_EraseRootFromParent_Done,
     /* 1133984 */   // Label 16630: @1133984
     /* 1133984 */   GIM_Try, /*On fail goto*//*Label 16631*/ GIMT_Encode4(1134064), // Rule ID 15067 //
     /* 1133989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1134000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1134003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1134006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134028 */     // MIs[0] round
     /* 1134028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134038 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134063 */     // GIR_Coverage, 15067,
     /* 1134063 */     GIR_EraseRootFromParent_Done,
     /* 1134064 */   // Label 16631: @1134064
     /* 1134064 */   GIM_Try, /*On fail goto*//*Label 16632*/ GIMT_Encode4(1134144), // Rule ID 15070 //
     /* 1134069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1134080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1134083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1134086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134108 */     // MIs[0] round
     /* 1134108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134118 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134143 */     // GIR_Coverage, 15070,
     /* 1134143 */     GIR_EraseRootFromParent_Done,
     /* 1134144 */   // Label 16632: @1134144
     /* 1134144 */   GIM_Try, /*On fail goto*//*Label 16633*/ GIMT_Encode4(1134224), // Rule ID 15071 //
     /* 1134149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1134160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1134163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1134166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134188 */     // MIs[0] round
     /* 1134188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134198 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134223 */     // GIR_Coverage, 15071,
     /* 1134223 */     GIR_EraseRootFromParent_Done,
     /* 1134224 */   // Label 16633: @1134224
     /* 1134224 */   GIM_Try, /*On fail goto*//*Label 16634*/ GIMT_Encode4(1134304), // Rule ID 15074 //
     /* 1134229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1134240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1134243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1134246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134268 */     // MIs[0] round
     /* 1134268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134278 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134303 */     // GIR_Coverage, 15074,
     /* 1134303 */     GIR_EraseRootFromParent_Done,
     /* 1134304 */   // Label 16634: @1134304
     /* 1134304 */   GIM_Try, /*On fail goto*//*Label 16635*/ GIMT_Encode4(1134384), // Rule ID 15075 //
     /* 1134309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1134320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1134323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1134326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134348 */     // MIs[0] round
     /* 1134348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134358 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134383 */     // GIR_Coverage, 15075,
     /* 1134383 */     GIR_EraseRootFromParent_Done,
     /* 1134384 */   // Label 16635: @1134384
     /* 1134384 */   GIM_Try, /*On fail goto*//*Label 16636*/ GIMT_Encode4(1134464), // Rule ID 15078 //
     /* 1134389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1134400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1134403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1134406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134428 */     // MIs[0] round
     /* 1134428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134438 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134463 */     // GIR_Coverage, 15078,
     /* 1134463 */     GIR_EraseRootFromParent_Done,
     /* 1134464 */   // Label 16636: @1134464
     /* 1134464 */   GIM_Try, /*On fail goto*//*Label 16637*/ GIMT_Encode4(1134544), // Rule ID 15079 //
     /* 1134469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1134480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1134483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1134486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134508 */     // MIs[0] round
     /* 1134508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134518 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134543 */     // GIR_Coverage, 15079,
     /* 1134543 */     GIR_EraseRootFromParent_Done,
     /* 1134544 */   // Label 16637: @1134544
     /* 1134544 */   GIM_Try, /*On fail goto*//*Label 16638*/ GIMT_Encode4(1134624), // Rule ID 15082 //
     /* 1134549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1134560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1134563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1134566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134588 */     // MIs[0] round
     /* 1134588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134598 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134623 */     // GIR_Coverage, 15082,
     /* 1134623 */     GIR_EraseRootFromParent_Done,
     /* 1134624 */   // Label 16638: @1134624
     /* 1134624 */   GIM_Try, /*On fail goto*//*Label 16639*/ GIMT_Encode4(1134704), // Rule ID 15083 //
     /* 1134629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1134640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1134643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1134646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134668 */     // MIs[0] round
     /* 1134668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134678 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134703 */     // GIR_Coverage, 15083,
     /* 1134703 */     GIR_EraseRootFromParent_Done,
     /* 1134704 */   // Label 16639: @1134704
     /* 1134704 */   GIM_Try, /*On fail goto*//*Label 16640*/ GIMT_Encode4(1134784), // Rule ID 15086 //
     /* 1134709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1134720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1134723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1134726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134748 */     // MIs[0] round
     /* 1134748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134758 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134783 */     // GIR_Coverage, 15086,
     /* 1134783 */     GIR_EraseRootFromParent_Done,
     /* 1134784 */   // Label 16640: @1134784
     /* 1134784 */   GIM_Try, /*On fail goto*//*Label 16641*/ GIMT_Encode4(1134864), // Rule ID 15087 //
     /* 1134789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1134800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1134803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1134806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134828 */     // MIs[0] round
     /* 1134828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134863 */     // GIR_Coverage, 15087,
     /* 1134863 */     GIR_EraseRootFromParent_Done,
     /* 1134864 */   // Label 16641: @1134864
     /* 1134864 */   GIM_Try, /*On fail goto*//*Label 16642*/ GIMT_Encode4(1134944), // Rule ID 15090 //
     /* 1134869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1134880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1134883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1134886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134908 */     // MIs[0] round
     /* 1134908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134918 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134943 */     // GIR_Coverage, 15090,
     /* 1134943 */     GIR_EraseRootFromParent_Done,
     /* 1134944 */   // Label 16642: @1134944
     /* 1134944 */   GIM_Try, /*On fail goto*//*Label 16643*/ GIMT_Encode4(1135024), // Rule ID 15091 //
     /* 1134949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1134960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1134963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1134966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134988 */     // MIs[0] round
     /* 1134988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134998 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135023 */     // GIR_Coverage, 15091,
     /* 1135023 */     GIR_EraseRootFromParent_Done,
     /* 1135024 */   // Label 16643: @1135024
     /* 1135024 */   GIM_Try, /*On fail goto*//*Label 16644*/ GIMT_Encode4(1135104), // Rule ID 15094 //
     /* 1135029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1135040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1135043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1135046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135068 */     // MIs[0] round
     /* 1135068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135078 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135103 */     // GIR_Coverage, 15094,
     /* 1135103 */     GIR_EraseRootFromParent_Done,
     /* 1135104 */   // Label 16644: @1135104
     /* 1135104 */   GIM_Try, /*On fail goto*//*Label 16645*/ GIMT_Encode4(1135184), // Rule ID 15095 //
     /* 1135109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1135120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1135123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1135126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135148 */     // MIs[0] round
     /* 1135148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135158 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135183 */     // GIR_Coverage, 15095,
     /* 1135183 */     GIR_EraseRootFromParent_Done,
     /* 1135184 */   // Label 16645: @1135184
     /* 1135184 */   GIM_Try, /*On fail goto*//*Label 16646*/ GIMT_Encode4(1135264), // Rule ID 15098 //
     /* 1135189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1135200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1135203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1135206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135228 */     // MIs[0] round
     /* 1135228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1135241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135263 */     // GIR_Coverage, 15098,
     /* 1135263 */     GIR_EraseRootFromParent_Done,
     /* 1135264 */   // Label 16646: @1135264
     /* 1135264 */   GIM_Try, /*On fail goto*//*Label 16647*/ GIMT_Encode4(1135344), // Rule ID 15099 //
     /* 1135269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1135280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1135283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1135286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135308 */     // MIs[0] round
     /* 1135308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1135321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135343 */     // GIR_Coverage, 15099,
     /* 1135343 */     GIR_EraseRootFromParent_Done,
     /* 1135344 */   // Label 16647: @1135344
     /* 1135344 */   GIM_Try, /*On fail goto*//*Label 16648*/ GIMT_Encode4(1135424), // Rule ID 15102 //
     /* 1135349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1135360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1135363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1135366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135388 */     // MIs[0] round
     /* 1135388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135398 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135423 */     // GIR_Coverage, 15102,
     /* 1135423 */     GIR_EraseRootFromParent_Done,
     /* 1135424 */   // Label 16648: @1135424
     /* 1135424 */   GIM_Try, /*On fail goto*//*Label 16649*/ GIMT_Encode4(1135504), // Rule ID 15103 //
     /* 1135429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1135440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1135443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1135446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135468 */     // MIs[0] round
     /* 1135468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135478 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135503 */     // GIR_Coverage, 15103,
     /* 1135503 */     GIR_EraseRootFromParent_Done,
     /* 1135504 */   // Label 16649: @1135504
     /* 1135504 */   GIM_Try, /*On fail goto*//*Label 16650*/ GIMT_Encode4(1135584), // Rule ID 15106 //
     /* 1135509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1135520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1135523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1135526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135548 */     // MIs[0] round
     /* 1135548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135558 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135583 */     // GIR_Coverage, 15106,
     /* 1135583 */     GIR_EraseRootFromParent_Done,
     /* 1135584 */   // Label 16650: @1135584
     /* 1135584 */   GIM_Try, /*On fail goto*//*Label 16651*/ GIMT_Encode4(1135664), // Rule ID 15107 //
     /* 1135589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1135600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1135603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1135606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135628 */     // MIs[0] round
     /* 1135628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135638 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135663 */     // GIR_Coverage, 15107,
     /* 1135663 */     GIR_EraseRootFromParent_Done,
     /* 1135664 */   // Label 16651: @1135664
     /* 1135664 */   GIM_Try, /*On fail goto*//*Label 16652*/ GIMT_Encode4(1135744), // Rule ID 15110 //
     /* 1135669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1135680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1135683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1135686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1135689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135708 */     // MIs[0] round
     /* 1135708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135718 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1135721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135743 */     // GIR_Coverage, 15110,
     /* 1135743 */     GIR_EraseRootFromParent_Done,
     /* 1135744 */   // Label 16652: @1135744
     /* 1135744 */   GIM_Try, /*On fail goto*//*Label 16653*/ GIMT_Encode4(1135824), // Rule ID 15111 //
     /* 1135749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1135760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1135763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1135766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1135769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135788 */     // MIs[0] round
     /* 1135788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135798 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1135801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135823 */     // GIR_Coverage, 15111,
     /* 1135823 */     GIR_EraseRootFromParent_Done,
     /* 1135824 */   // Label 16653: @1135824
     /* 1135824 */   GIM_Try, /*On fail goto*//*Label 16654*/ GIMT_Encode4(1135904), // Rule ID 15114 //
     /* 1135829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1135840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1135843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1135846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1135849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135868 */     // MIs[0] round
     /* 1135868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135878 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1135881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135903 */     // GIR_Coverage, 15114,
     /* 1135903 */     GIR_EraseRootFromParent_Done,
     /* 1135904 */   // Label 16654: @1135904
     /* 1135904 */   GIM_Try, /*On fail goto*//*Label 16655*/ GIMT_Encode4(1135984), // Rule ID 15115 //
     /* 1135909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1135920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1135923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1135926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1135929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135948 */     // MIs[0] round
     /* 1135948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135958 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1135961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135983 */     // GIR_Coverage, 15115,
     /* 1135983 */     GIR_EraseRootFromParent_Done,
     /* 1135984 */   // Label 16655: @1135984
     /* 1135984 */   GIM_Try, /*On fail goto*//*Label 16656*/ GIMT_Encode4(1136064), // Rule ID 15118 //
     /* 1135989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1136000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1136003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1136006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1136009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136028 */     // MIs[0] round
     /* 1136028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136038 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136063 */     // GIR_Coverage, 15118,
     /* 1136063 */     GIR_EraseRootFromParent_Done,
     /* 1136064 */   // Label 16656: @1136064
     /* 1136064 */   GIM_Try, /*On fail goto*//*Label 16657*/ GIMT_Encode4(1136144), // Rule ID 15119 //
     /* 1136069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1136080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1136083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1136086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1136089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136108 */     // MIs[0] round
     /* 1136108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136143 */     // GIR_Coverage, 15119,
     /* 1136143 */     GIR_EraseRootFromParent_Done,
     /* 1136144 */   // Label 16657: @1136144
     /* 1136144 */   GIM_Try, /*On fail goto*//*Label 16658*/ GIMT_Encode4(1136224), // Rule ID 15122 //
     /* 1136149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1136160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1136163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1136166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1136169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136188 */     // MIs[0] round
     /* 1136188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136198 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1136201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136223 */     // GIR_Coverage, 15122,
     /* 1136223 */     GIR_EraseRootFromParent_Done,
     /* 1136224 */   // Label 16658: @1136224
     /* 1136224 */   GIM_Try, /*On fail goto*//*Label 16659*/ GIMT_Encode4(1136304), // Rule ID 15123 //
     /* 1136229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1136240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1136243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1136246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1136249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136268 */     // MIs[0] round
     /* 1136268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136278 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1136281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136303 */     // GIR_Coverage, 15123,
     /* 1136303 */     GIR_EraseRootFromParent_Done,
     /* 1136304 */   // Label 16659: @1136304
     /* 1136304 */   GIM_Try, /*On fail goto*//*Label 16660*/ GIMT_Encode4(1136384), // Rule ID 15126 //
     /* 1136309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1136320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1136323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1136326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1136329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136348 */     // MIs[0] round
     /* 1136348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136358 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136383 */     // GIR_Coverage, 15126,
     /* 1136383 */     GIR_EraseRootFromParent_Done,
     /* 1136384 */   // Label 16660: @1136384
     /* 1136384 */   GIM_Try, /*On fail goto*//*Label 16661*/ GIMT_Encode4(1136464), // Rule ID 15127 //
     /* 1136389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1136400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1136403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1136406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1136409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136428 */     // MIs[0] round
     /* 1136428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136438 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136463 */     // GIR_Coverage, 15127,
     /* 1136463 */     GIR_EraseRootFromParent_Done,
     /* 1136464 */   // Label 16661: @1136464
     /* 1136464 */   GIM_Try, /*On fail goto*//*Label 16662*/ GIMT_Encode4(1136544), // Rule ID 15130 //
     /* 1136469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1136480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1136483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1136486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1136489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136508 */     // MIs[0] round
     /* 1136508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136518 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1136539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136543 */     // GIR_Coverage, 15130,
     /* 1136543 */     GIR_EraseRootFromParent_Done,
     /* 1136544 */   // Label 16662: @1136544
     /* 1136544 */   GIM_Try, /*On fail goto*//*Label 16663*/ GIMT_Encode4(1136624), // Rule ID 15131 //
     /* 1136549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1136560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1136563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1136566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1136569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136588 */     // MIs[0] round
     /* 1136588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136598 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1136619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136623 */     // GIR_Coverage, 15131,
     /* 1136623 */     GIR_EraseRootFromParent_Done,
     /* 1136624 */   // Label 16663: @1136624
     /* 1136624 */   GIM_Try, /*On fail goto*//*Label 16664*/ GIMT_Encode4(1136704), // Rule ID 15134 //
     /* 1136629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1136640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1136643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1136646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1136649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136668 */     // MIs[0] round
     /* 1136668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136678 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136703 */     // GIR_Coverage, 15134,
     /* 1136703 */     GIR_EraseRootFromParent_Done,
     /* 1136704 */   // Label 16664: @1136704
     /* 1136704 */   GIM_Try, /*On fail goto*//*Label 16665*/ GIMT_Encode4(1136784), // Rule ID 15135 //
     /* 1136709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1136720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1136723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1136726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1136729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136748 */     // MIs[0] round
     /* 1136748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136783 */     // GIR_Coverage, 15135,
     /* 1136783 */     GIR_EraseRootFromParent_Done,
     /* 1136784 */   // Label 16665: @1136784
     /* 1136784 */   GIM_Try, /*On fail goto*//*Label 16666*/ GIMT_Encode4(1136864), // Rule ID 15138 //
     /* 1136789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1136800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1136803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1136806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1136809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136828 */     // MIs[0] round
     /* 1136828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136838 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136863 */     // GIR_Coverage, 15138,
     /* 1136863 */     GIR_EraseRootFromParent_Done,
     /* 1136864 */   // Label 16666: @1136864
     /* 1136864 */   GIM_Try, /*On fail goto*//*Label 16667*/ GIMT_Encode4(1136944), // Rule ID 15139 //
     /* 1136869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1136880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1136883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1136886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1136889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136908 */     // MIs[0] round
     /* 1136908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136943 */     // GIR_Coverage, 15139,
     /* 1136943 */     GIR_EraseRootFromParent_Done,
     /* 1136944 */   // Label 16667: @1136944
     /* 1136944 */   GIM_Try, /*On fail goto*//*Label 16668*/ GIMT_Encode4(1137024), // Rule ID 15142 //
     /* 1136949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1136960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1136963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1136966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1136969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136988 */     // MIs[0] round
     /* 1136988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136998 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137023 */     // GIR_Coverage, 15142,
     /* 1137023 */     GIR_EraseRootFromParent_Done,
     /* 1137024 */   // Label 16668: @1137024
     /* 1137024 */   GIM_Try, /*On fail goto*//*Label 16669*/ GIMT_Encode4(1137104), // Rule ID 15143 //
     /* 1137029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1137040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1137043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1137046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1137049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137068 */     // MIs[0] round
     /* 1137068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137078 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137103 */     // GIR_Coverage, 15143,
     /* 1137103 */     GIR_EraseRootFromParent_Done,
     /* 1137104 */   // Label 16669: @1137104
     /* 1137104 */   GIM_Try, /*On fail goto*//*Label 16670*/ GIMT_Encode4(1137184), // Rule ID 15146 //
     /* 1137109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1137112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1137120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1137123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1137126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1137129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137148 */     // MIs[0] round
     /* 1137148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137158 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137183 */     // GIR_Coverage, 15146,
     /* 1137183 */     GIR_EraseRootFromParent_Done,
     /* 1137184 */   // Label 16670: @1137184
     /* 1137184 */   GIM_Try, /*On fail goto*//*Label 16671*/ GIMT_Encode4(1137264), // Rule ID 15147 //
     /* 1137189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1137192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1137200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1137203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1137206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1137209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137228 */     // MIs[0] round
     /* 1137228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137238 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137263 */     // GIR_Coverage, 15147,
     /* 1137263 */     GIR_EraseRootFromParent_Done,
     /* 1137264 */   // Label 16671: @1137264
     /* 1137264 */   GIM_Try, /*On fail goto*//*Label 16672*/ GIMT_Encode4(1137344), // Rule ID 15150 //
     /* 1137269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1137280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1137283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1137286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1137289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137308 */     // MIs[0] round
     /* 1137308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137343 */     // GIR_Coverage, 15150,
     /* 1137343 */     GIR_EraseRootFromParent_Done,
     /* 1137344 */   // Label 16672: @1137344
     /* 1137344 */   GIM_Try, /*On fail goto*//*Label 16673*/ GIMT_Encode4(1137424), // Rule ID 15151 //
     /* 1137349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1137360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1137363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1137366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1137369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137388 */     // MIs[0] round
     /* 1137388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137423 */     // GIR_Coverage, 15151,
     /* 1137423 */     GIR_EraseRootFromParent_Done,
     /* 1137424 */   // Label 16673: @1137424
     /* 1137424 */   GIM_Try, /*On fail goto*//*Label 16674*/ GIMT_Encode4(1137504), // Rule ID 15154 //
     /* 1137429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1137440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1137443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1137446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1137449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137468 */     // MIs[0] round
     /* 1137468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137478 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1137481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137503 */     // GIR_Coverage, 15154,
     /* 1137503 */     GIR_EraseRootFromParent_Done,
     /* 1137504 */   // Label 16674: @1137504
     /* 1137504 */   GIM_Try, /*On fail goto*//*Label 16675*/ GIMT_Encode4(1137584), // Rule ID 15155 //
     /* 1137509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1137520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1137523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1137526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1137529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137548 */     // MIs[0] round
     /* 1137548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137558 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1137561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137583 */     // GIR_Coverage, 15155,
     /* 1137583 */     GIR_EraseRootFromParent_Done,
     /* 1137584 */   // Label 16675: @1137584
     /* 1137584 */   GIM_Try, /*On fail goto*//*Label 16676*/ GIMT_Encode4(1137664), // Rule ID 15158 //
     /* 1137589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1137600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1137603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1137606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1137609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137628 */     // MIs[0] round
     /* 1137628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137638 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1137641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137663 */     // GIR_Coverage, 15158,
     /* 1137663 */     GIR_EraseRootFromParent_Done,
     /* 1137664 */   // Label 16676: @1137664
     /* 1137664 */   GIM_Try, /*On fail goto*//*Label 16677*/ GIMT_Encode4(1137744), // Rule ID 15159 //
     /* 1137669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1137680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1137683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1137686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1137689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137708 */     // MIs[0] round
     /* 1137708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137718 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1137721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137743 */     // GIR_Coverage, 15159,
     /* 1137743 */     GIR_EraseRootFromParent_Done,
     /* 1137744 */   // Label 16677: @1137744
     /* 1137744 */   GIM_Try, /*On fail goto*//*Label 16678*/ GIMT_Encode4(1137824), // Rule ID 15162 //
     /* 1137749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1137760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1137763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1137766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1137769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137788 */     // MIs[0] round
     /* 1137788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137823 */     // GIR_Coverage, 15162,
     /* 1137823 */     GIR_EraseRootFromParent_Done,
     /* 1137824 */   // Label 16678: @1137824
     /* 1137824 */   GIM_Try, /*On fail goto*//*Label 16679*/ GIMT_Encode4(1137904), // Rule ID 15163 //
     /* 1137829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1137840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1137843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1137846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1137849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137868 */     // MIs[0] round
     /* 1137868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137878 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137903 */     // GIR_Coverage, 15163,
     /* 1137903 */     GIR_EraseRootFromParent_Done,
     /* 1137904 */   // Label 16679: @1137904
     /* 1137904 */   GIM_Try, /*On fail goto*//*Label 16680*/ GIMT_Encode4(1137984), // Rule ID 15166 //
     /* 1137909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1137920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1137923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1137926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1137929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137948 */     // MIs[0] round
     /* 1137948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137958 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1137961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137983 */     // GIR_Coverage, 15166,
     /* 1137983 */     GIR_EraseRootFromParent_Done,
     /* 1137984 */   // Label 16680: @1137984
     /* 1137984 */   GIM_Try, /*On fail goto*//*Label 16681*/ GIMT_Encode4(1138064), // Rule ID 15167 //
     /* 1137989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1138000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1138003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1138006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1138009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138028 */     // MIs[0] round
     /* 1138028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138038 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138063 */     // GIR_Coverage, 15167,
     /* 1138063 */     GIR_EraseRootFromParent_Done,
     /* 1138064 */   // Label 16681: @1138064
     /* 1138064 */   GIM_Try, /*On fail goto*//*Label 16682*/ GIMT_Encode4(1138144), // Rule ID 15170 //
     /* 1138069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1138080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1138083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1138086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1138089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138108 */     // MIs[0] round
     /* 1138108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138118 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138143 */     // GIR_Coverage, 15170,
     /* 1138143 */     GIR_EraseRootFromParent_Done,
     /* 1138144 */   // Label 16682: @1138144
     /* 1138144 */   GIM_Try, /*On fail goto*//*Label 16683*/ GIMT_Encode4(1138224), // Rule ID 15171 //
     /* 1138149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1138160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1138163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1138166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1138169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138188 */     // MIs[0] round
     /* 1138188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138198 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138223 */     // GIR_Coverage, 15171,
     /* 1138223 */     GIR_EraseRootFromParent_Done,
     /* 1138224 */   // Label 16683: @1138224
     /* 1138224 */   GIM_Try, /*On fail goto*//*Label 16684*/ GIMT_Encode4(1138304), // Rule ID 15174 //
     /* 1138229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1138240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1138243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1138246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1138249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138268 */     // MIs[0] round
     /* 1138268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138303 */     // GIR_Coverage, 15174,
     /* 1138303 */     GIR_EraseRootFromParent_Done,
     /* 1138304 */   // Label 16684: @1138304
     /* 1138304 */   GIM_Try, /*On fail goto*//*Label 16685*/ GIMT_Encode4(1138384), // Rule ID 15175 //
     /* 1138309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1138320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1138323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1138326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1138329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138348 */     // MIs[0] round
     /* 1138348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138383 */     // GIR_Coverage, 15175,
     /* 1138383 */     GIR_EraseRootFromParent_Done,
     /* 1138384 */   // Label 16685: @1138384
     /* 1138384 */   GIM_Try, /*On fail goto*//*Label 16686*/ GIMT_Encode4(1138464), // Rule ID 15178 //
     /* 1138389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1138400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1138403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1138406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1138409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138428 */     // MIs[0] round
     /* 1138428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138438 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138463 */     // GIR_Coverage, 15178,
     /* 1138463 */     GIR_EraseRootFromParent_Done,
     /* 1138464 */   // Label 16686: @1138464
     /* 1138464 */   GIM_Try, /*On fail goto*//*Label 16687*/ GIMT_Encode4(1138544), // Rule ID 15179 //
     /* 1138469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1138480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1138483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1138486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1138489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138508 */     // MIs[0] round
     /* 1138508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138543 */     // GIR_Coverage, 15179,
     /* 1138543 */     GIR_EraseRootFromParent_Done,
     /* 1138544 */   // Label 16687: @1138544
     /* 1138544 */   GIM_Try, /*On fail goto*//*Label 16688*/ GIMT_Encode4(1138624), // Rule ID 15182 //
     /* 1138549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1138560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1138563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1138566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1138569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138588 */     // MIs[0] round
     /* 1138588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138598 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138623 */     // GIR_Coverage, 15182,
     /* 1138623 */     GIR_EraseRootFromParent_Done,
     /* 1138624 */   // Label 16688: @1138624
     /* 1138624 */   GIM_Try, /*On fail goto*//*Label 16689*/ GIMT_Encode4(1138704), // Rule ID 15183 //
     /* 1138629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1138640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1138643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1138646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1138649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138668 */     // MIs[0] round
     /* 1138668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138678 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138703 */     // GIR_Coverage, 15183,
     /* 1138703 */     GIR_EraseRootFromParent_Done,
     /* 1138704 */   // Label 16689: @1138704
     /* 1138704 */   GIM_Try, /*On fail goto*//*Label 16690*/ GIMT_Encode4(1138784), // Rule ID 15186 //
     /* 1138709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1138712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1138720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1138723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1138726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1138729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138748 */     // MIs[0] round
     /* 1138748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138758 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1138779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138783 */     // GIR_Coverage, 15186,
     /* 1138783 */     GIR_EraseRootFromParent_Done,
     /* 1138784 */   // Label 16690: @1138784
     /* 1138784 */   GIM_Try, /*On fail goto*//*Label 16691*/ GIMT_Encode4(1138864), // Rule ID 15187 //
     /* 1138789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1138792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1138800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1138803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1138806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1138809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138828 */     // MIs[0] round
     /* 1138828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138838 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1138859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138863 */     // GIR_Coverage, 15187,
     /* 1138863 */     GIR_EraseRootFromParent_Done,
     /* 1138864 */   // Label 16691: @1138864
     /* 1138864 */   GIM_Try, /*On fail goto*//*Label 16692*/ GIMT_Encode4(1138944), // Rule ID 15190 //
     /* 1138869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1138872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1138880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1138883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1138886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1138889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138908 */     // MIs[0] round
     /* 1138908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138918 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1138939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138943 */     // GIR_Coverage, 15190,
     /* 1138943 */     GIR_EraseRootFromParent_Done,
     /* 1138944 */   // Label 16692: @1138944
     /* 1138944 */   GIM_Try, /*On fail goto*//*Label 16693*/ GIMT_Encode4(1139024), // Rule ID 15191 //
     /* 1138949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1138952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1138960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1138963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1138966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1138969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138988 */     // MIs[0] round
     /* 1138988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138998 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1139001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139023 */     // GIR_Coverage, 15191,
     /* 1139023 */     GIR_EraseRootFromParent_Done,
     /* 1139024 */   // Label 16693: @1139024
     /* 1139024 */   GIM_Try, /*On fail goto*//*Label 16694*/ GIMT_Encode4(1139104), // Rule ID 15194 //
     /* 1139029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1139032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1139040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1139043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1139046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1139049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139068 */     // MIs[0] round
     /* 1139068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139078 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1139081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139103 */     // GIR_Coverage, 15194,
     /* 1139103 */     GIR_EraseRootFromParent_Done,
     /* 1139104 */   // Label 16694: @1139104
     /* 1139104 */   GIM_Try, /*On fail goto*//*Label 16695*/ GIMT_Encode4(1139184), // Rule ID 15195 //
     /* 1139109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1139112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1139120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1139123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1139126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1139129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139148 */     // MIs[0] round
     /* 1139148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1139161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139183 */     // GIR_Coverage, 15195,
     /* 1139183 */     GIR_EraseRootFromParent_Done,
     /* 1139184 */   // Label 16695: @1139184
     /* 1139184 */   GIM_Try, /*On fail goto*//*Label 16696*/ GIMT_Encode4(1139264), // Rule ID 15198 //
     /* 1139189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1139200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1139203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1139206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139228 */     // MIs[0] round
     /* 1139228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139238 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1139241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139263 */     // GIR_Coverage, 15198,
     /* 1139263 */     GIR_EraseRootFromParent_Done,
     /* 1139264 */   // Label 16696: @1139264
     /* 1139264 */   GIM_Try, /*On fail goto*//*Label 16697*/ GIMT_Encode4(1139344), // Rule ID 15199 //
     /* 1139269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1139280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1139283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1139286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139308 */     // MIs[0] round
     /* 1139308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139318 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1139321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139343 */     // GIR_Coverage, 15199,
     /* 1139343 */     GIR_EraseRootFromParent_Done,
     /* 1139344 */   // Label 16697: @1139344
     /* 1139344 */   GIM_Try, /*On fail goto*//*Label 16698*/ GIMT_Encode4(1139424), // Rule ID 15202 //
     /* 1139349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1139360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1139363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1139366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139388 */     // MIs[0] round
     /* 1139388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139398 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139423 */     // GIR_Coverage, 15202,
     /* 1139423 */     GIR_EraseRootFromParent_Done,
     /* 1139424 */   // Label 16698: @1139424
     /* 1139424 */   GIM_Try, /*On fail goto*//*Label 16699*/ GIMT_Encode4(1139504), // Rule ID 15203 //
     /* 1139429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1139440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1139443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1139446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139468 */     // MIs[0] round
     /* 1139468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139478 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139503 */     // GIR_Coverage, 15203,
     /* 1139503 */     GIR_EraseRootFromParent_Done,
     /* 1139504 */   // Label 16699: @1139504
     /* 1139504 */   GIM_Try, /*On fail goto*//*Label 16700*/ GIMT_Encode4(1139584), // Rule ID 15206 //
     /* 1139509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1139520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1139523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1139526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139548 */     // MIs[0] round
     /* 1139548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139558 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139583 */     // GIR_Coverage, 15206,
     /* 1139583 */     GIR_EraseRootFromParent_Done,
     /* 1139584 */   // Label 16700: @1139584
     /* 1139584 */   GIM_Try, /*On fail goto*//*Label 16701*/ GIMT_Encode4(1139664), // Rule ID 15207 //
     /* 1139589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1139600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1139603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1139606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139628 */     // MIs[0] round
     /* 1139628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139638 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139663 */     // GIR_Coverage, 15207,
     /* 1139663 */     GIR_EraseRootFromParent_Done,
     /* 1139664 */   // Label 16701: @1139664
     /* 1139664 */   GIM_Try, /*On fail goto*//*Label 16702*/ GIMT_Encode4(1139744), // Rule ID 15210 //
     /* 1139669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1139680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1139683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1139686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139708 */     // MIs[0] round
     /* 1139708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139718 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139743 */     // GIR_Coverage, 15210,
     /* 1139743 */     GIR_EraseRootFromParent_Done,
     /* 1139744 */   // Label 16702: @1139744
     /* 1139744 */   GIM_Try, /*On fail goto*//*Label 16703*/ GIMT_Encode4(1139824), // Rule ID 15211 //
     /* 1139749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1139760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1139763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1139766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139788 */     // MIs[0] round
     /* 1139788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139798 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139823 */     // GIR_Coverage, 15211,
     /* 1139823 */     GIR_EraseRootFromParent_Done,
     /* 1139824 */   // Label 16703: @1139824
     /* 1139824 */   GIM_Try, /*On fail goto*//*Label 16704*/ GIMT_Encode4(1139904), // Rule ID 15214 //
     /* 1139829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1139840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1139843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1139846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139868 */     // MIs[0] round
     /* 1139868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139878 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139903 */     // GIR_Coverage, 15214,
     /* 1139903 */     GIR_EraseRootFromParent_Done,
     /* 1139904 */   // Label 16704: @1139904
     /* 1139904 */   GIM_Try, /*On fail goto*//*Label 16705*/ GIMT_Encode4(1139984), // Rule ID 15215 //
     /* 1139909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1139920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1139923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1139926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139948 */     // MIs[0] round
     /* 1139948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139983 */     // GIR_Coverage, 15215,
     /* 1139983 */     GIR_EraseRootFromParent_Done,
     /* 1139984 */   // Label 16705: @1139984
     /* 1139984 */   GIM_Try, /*On fail goto*//*Label 16706*/ GIMT_Encode4(1140064), // Rule ID 15218 //
     /* 1139989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1140000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1140003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1140006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140028 */     // MIs[0] round
     /* 1140028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140038 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140063 */     // GIR_Coverage, 15218,
     /* 1140063 */     GIR_EraseRootFromParent_Done,
     /* 1140064 */   // Label 16706: @1140064
     /* 1140064 */   GIM_Try, /*On fail goto*//*Label 16707*/ GIMT_Encode4(1140144), // Rule ID 15219 //
     /* 1140069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1140080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1140083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1140086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140108 */     // MIs[0] round
     /* 1140108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140118 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140143 */     // GIR_Coverage, 15219,
     /* 1140143 */     GIR_EraseRootFromParent_Done,
     /* 1140144 */   // Label 16707: @1140144
     /* 1140144 */   GIM_Try, /*On fail goto*//*Label 16708*/ GIMT_Encode4(1140224), // Rule ID 15222 //
     /* 1140149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1140160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1140163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1140166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140188 */     // MIs[0] round
     /* 1140188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140198 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140223 */     // GIR_Coverage, 15222,
     /* 1140223 */     GIR_EraseRootFromParent_Done,
     /* 1140224 */   // Label 16708: @1140224
     /* 1140224 */   GIM_Try, /*On fail goto*//*Label 16709*/ GIMT_Encode4(1140304), // Rule ID 15223 //
     /* 1140229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1140240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1140243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1140246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140268 */     // MIs[0] round
     /* 1140268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140278 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140303 */     // GIR_Coverage, 15223,
     /* 1140303 */     GIR_EraseRootFromParent_Done,
     /* 1140304 */   // Label 16709: @1140304
     /* 1140304 */   GIM_Try, /*On fail goto*//*Label 16710*/ GIMT_Encode4(1140384), // Rule ID 15226 //
     /* 1140309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1140320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1140323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1140326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140348 */     // MIs[0] round
     /* 1140348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140358 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140383 */     // GIR_Coverage, 15226,
     /* 1140383 */     GIR_EraseRootFromParent_Done,
     /* 1140384 */   // Label 16710: @1140384
     /* 1140384 */   GIM_Try, /*On fail goto*//*Label 16711*/ GIMT_Encode4(1140464), // Rule ID 15227 //
     /* 1140389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1140400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1140403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1140406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140428 */     // MIs[0] round
     /* 1140428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140438 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140463 */     // GIR_Coverage, 15227,
     /* 1140463 */     GIR_EraseRootFromParent_Done,
     /* 1140464 */   // Label 16711: @1140464
     /* 1140464 */   GIM_Try, /*On fail goto*//*Label 16712*/ GIMT_Encode4(1140544), // Rule ID 15230 //
     /* 1140469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1140480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1140483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1140486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140508 */     // MIs[0] round
     /* 1140508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140518 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140543 */     // GIR_Coverage, 15230,
     /* 1140543 */     GIR_EraseRootFromParent_Done,
     /* 1140544 */   // Label 16712: @1140544
     /* 1140544 */   GIM_Try, /*On fail goto*//*Label 16713*/ GIMT_Encode4(1140624), // Rule ID 15231 //
     /* 1140549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1140560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1140563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1140566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140588 */     // MIs[0] round
     /* 1140588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140598 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140623 */     // GIR_Coverage, 15231,
     /* 1140623 */     GIR_EraseRootFromParent_Done,
     /* 1140624 */   // Label 16713: @1140624
     /* 1140624 */   GIM_Try, /*On fail goto*//*Label 16714*/ GIMT_Encode4(1140704), // Rule ID 15234 //
     /* 1140629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1140632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1140640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1140643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1140646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140668 */     // MIs[0] round
     /* 1140668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140678 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1140699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140703 */     // GIR_Coverage, 15234,
     /* 1140703 */     GIR_EraseRootFromParent_Done,
     /* 1140704 */   // Label 16714: @1140704
     /* 1140704 */   GIM_Try, /*On fail goto*//*Label 16715*/ GIMT_Encode4(1140784), // Rule ID 15235 //
     /* 1140709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1140712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1140720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1140723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1140726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140748 */     // MIs[0] round
     /* 1140748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140758 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1140779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140783 */     // GIR_Coverage, 15235,
     /* 1140783 */     GIR_EraseRootFromParent_Done,
     /* 1140784 */   // Label 16715: @1140784
     /* 1140784 */   GIM_Try, /*On fail goto*//*Label 16716*/ GIMT_Encode4(1140864), // Rule ID 15238 //
     /* 1140789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1140800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1140803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1140806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140828 */     // MIs[0] round
     /* 1140828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140838 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1140841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140863 */     // GIR_Coverage, 15238,
     /* 1140863 */     GIR_EraseRootFromParent_Done,
     /* 1140864 */   // Label 16716: @1140864
     /* 1140864 */   GIM_Try, /*On fail goto*//*Label 16717*/ GIMT_Encode4(1140944), // Rule ID 15239 //
     /* 1140869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1140880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1140883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1140886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140908 */     // MIs[0] round
     /* 1140908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140918 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1140921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140943 */     // GIR_Coverage, 15239,
     /* 1140943 */     GIR_EraseRootFromParent_Done,
     /* 1140944 */   // Label 16717: @1140944
     /* 1140944 */   GIM_Try, /*On fail goto*//*Label 16718*/ GIMT_Encode4(1141024), // Rule ID 15242 //
     /* 1140949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1140960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1140963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1140966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140988 */     // MIs[0] round
     /* 1140988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140998 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141023 */     // GIR_Coverage, 15242,
     /* 1141023 */     GIR_EraseRootFromParent_Done,
     /* 1141024 */   // Label 16718: @1141024
     /* 1141024 */   GIM_Try, /*On fail goto*//*Label 16719*/ GIMT_Encode4(1141104), // Rule ID 15243 //
     /* 1141029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1141040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1141043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1141046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141068 */     // MIs[0] round
     /* 1141068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141078 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141103 */     // GIR_Coverage, 15243,
     /* 1141103 */     GIR_EraseRootFromParent_Done,
     /* 1141104 */   // Label 16719: @1141104
     /* 1141104 */   GIM_Try, /*On fail goto*//*Label 16720*/ GIMT_Encode4(1141184), // Rule ID 15246 //
     /* 1141109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1141120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1141123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1141126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141148 */     // MIs[0] round
     /* 1141148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141158 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141183 */     // GIR_Coverage, 15246,
     /* 1141183 */     GIR_EraseRootFromParent_Done,
     /* 1141184 */   // Label 16720: @1141184
     /* 1141184 */   GIM_Try, /*On fail goto*//*Label 16721*/ GIMT_Encode4(1141264), // Rule ID 15247 //
     /* 1141189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1141200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1141203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1141206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141228 */     // MIs[0] round
     /* 1141228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141238 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141263 */     // GIR_Coverage, 15247,
     /* 1141263 */     GIR_EraseRootFromParent_Done,
     /* 1141264 */   // Label 16721: @1141264
     /* 1141264 */   GIM_Try, /*On fail goto*//*Label 16722*/ GIMT_Encode4(1141344), // Rule ID 15250 //
     /* 1141269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1141280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1141283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1141286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141308 */     // MIs[0] round
     /* 1141308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141343 */     // GIR_Coverage, 15250,
     /* 1141343 */     GIR_EraseRootFromParent_Done,
     /* 1141344 */   // Label 16722: @1141344
     /* 1141344 */   GIM_Try, /*On fail goto*//*Label 16723*/ GIMT_Encode4(1141424), // Rule ID 15251 //
     /* 1141349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1141360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1141363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1141366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141388 */     // MIs[0] round
     /* 1141388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141398 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141423 */     // GIR_Coverage, 15251,
     /* 1141423 */     GIR_EraseRootFromParent_Done,
     /* 1141424 */   // Label 16723: @1141424
     /* 1141424 */   GIM_Try, /*On fail goto*//*Label 16724*/ GIMT_Encode4(1141504), // Rule ID 15254 //
     /* 1141429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1141440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1141443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1141446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141468 */     // MIs[0] round
     /* 1141468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141478 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141503 */     // GIR_Coverage, 15254,
     /* 1141503 */     GIR_EraseRootFromParent_Done,
     /* 1141504 */   // Label 16724: @1141504
     /* 1141504 */   GIM_Try, /*On fail goto*//*Label 16725*/ GIMT_Encode4(1141584), // Rule ID 15255 //
     /* 1141509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1141520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1141523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1141526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141548 */     // MIs[0] round
     /* 1141548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141558 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141583 */     // GIR_Coverage, 15255,
     /* 1141583 */     GIR_EraseRootFromParent_Done,
     /* 1141584 */   // Label 16725: @1141584
     /* 1141584 */   GIM_Try, /*On fail goto*//*Label 16726*/ GIMT_Encode4(1141664), // Rule ID 15258 //
     /* 1141589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1141600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1141603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1141606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141628 */     // MIs[0] round
     /* 1141628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141638 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141663 */     // GIR_Coverage, 15258,
     /* 1141663 */     GIR_EraseRootFromParent_Done,
     /* 1141664 */   // Label 16726: @1141664
     /* 1141664 */   GIM_Try, /*On fail goto*//*Label 16727*/ GIMT_Encode4(1141744), // Rule ID 15259 //
     /* 1141669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1141680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1141683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1141686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141708 */     // MIs[0] round
     /* 1141708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141718 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141743 */     // GIR_Coverage, 15259,
     /* 1141743 */     GIR_EraseRootFromParent_Done,
     /* 1141744 */   // Label 16727: @1141744
     /* 1141744 */   GIM_Try, /*On fail goto*//*Label 16728*/ GIMT_Encode4(1141824), // Rule ID 15262 //
     /* 1141749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1141760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1141763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1141766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141788 */     // MIs[0] round
     /* 1141788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141823 */     // GIR_Coverage, 15262,
     /* 1141823 */     GIR_EraseRootFromParent_Done,
     /* 1141824 */   // Label 16728: @1141824
     /* 1141824 */   GIM_Try, /*On fail goto*//*Label 16729*/ GIMT_Encode4(1141904), // Rule ID 15263 //
     /* 1141829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1141840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1141843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1141846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141868 */     // MIs[0] round
     /* 1141868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141903 */     // GIR_Coverage, 15263,
     /* 1141903 */     GIR_EraseRootFromParent_Done,
     /* 1141904 */   // Label 16729: @1141904
     /* 1141904 */   GIM_Try, /*On fail goto*//*Label 16730*/ GIMT_Encode4(1141984), // Rule ID 15266 //
     /* 1141909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1141920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1141923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1141926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141948 */     // MIs[0] round
     /* 1141948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141958 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141983 */     // GIR_Coverage, 15266,
     /* 1141983 */     GIR_EraseRootFromParent_Done,
     /* 1141984 */   // Label 16730: @1141984
     /* 1141984 */   GIM_Try, /*On fail goto*//*Label 16731*/ GIMT_Encode4(1142064), // Rule ID 15267 //
     /* 1141989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1142000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1142003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1142006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142028 */     // MIs[0] round
     /* 1142028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142038 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142063 */     // GIR_Coverage, 15267,
     /* 1142063 */     GIR_EraseRootFromParent_Done,
     /* 1142064 */   // Label 16731: @1142064
     /* 1142064 */   GIM_Try, /*On fail goto*//*Label 16732*/ GIMT_Encode4(1142144), // Rule ID 15270 //
     /* 1142069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1142080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1142083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1142086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142108 */     // MIs[0] round
     /* 1142108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142143 */     // GIR_Coverage, 15270,
     /* 1142143 */     GIR_EraseRootFromParent_Done,
     /* 1142144 */   // Label 16732: @1142144
     /* 1142144 */   GIM_Try, /*On fail goto*//*Label 16733*/ GIMT_Encode4(1142224), // Rule ID 15271 //
     /* 1142149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1142160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1142163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1142166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142188 */     // MIs[0] round
     /* 1142188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142223 */     // GIR_Coverage, 15271,
     /* 1142223 */     GIR_EraseRootFromParent_Done,
     /* 1142224 */   // Label 16733: @1142224
     /* 1142224 */   GIM_Try, /*On fail goto*//*Label 16734*/ GIMT_Encode4(1142304), // Rule ID 15274 //
     /* 1142229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1142240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1142243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1142246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142268 */     // MIs[0] round
     /* 1142268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142278 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1142281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142303 */     // GIR_Coverage, 15274,
     /* 1142303 */     GIR_EraseRootFromParent_Done,
     /* 1142304 */   // Label 16734: @1142304
     /* 1142304 */   GIM_Try, /*On fail goto*//*Label 16735*/ GIMT_Encode4(1142384), // Rule ID 15275 //
     /* 1142309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1142320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1142323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1142326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142348 */     // MIs[0] round
     /* 1142348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1142361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142383 */     // GIR_Coverage, 15275,
     /* 1142383 */     GIR_EraseRootFromParent_Done,
     /* 1142384 */   // Label 16735: @1142384
     /* 1142384 */   GIM_Try, /*On fail goto*//*Label 16736*/ GIMT_Encode4(1142464), // Rule ID 15278 //
     /* 1142389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1142400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1142403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1142406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142428 */     // MIs[0] round
     /* 1142428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142438 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142463 */     // GIR_Coverage, 15278,
     /* 1142463 */     GIR_EraseRootFromParent_Done,
     /* 1142464 */   // Label 16736: @1142464
     /* 1142464 */   GIM_Try, /*On fail goto*//*Label 16737*/ GIMT_Encode4(1142544), // Rule ID 15279 //
     /* 1142469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1142480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1142483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1142486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142508 */     // MIs[0] round
     /* 1142508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142543 */     // GIR_Coverage, 15279,
     /* 1142543 */     GIR_EraseRootFromParent_Done,
     /* 1142544 */   // Label 16737: @1142544
     /* 1142544 */   GIM_Try, /*On fail goto*//*Label 16738*/ GIMT_Encode4(1142624), // Rule ID 15282 //
     /* 1142549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1142560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1142563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1142566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142588 */     // MIs[0] round
     /* 1142588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142598 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142623 */     // GIR_Coverage, 15282,
     /* 1142623 */     GIR_EraseRootFromParent_Done,
     /* 1142624 */   // Label 16738: @1142624
     /* 1142624 */   GIM_Try, /*On fail goto*//*Label 16739*/ GIMT_Encode4(1142704), // Rule ID 15283 //
     /* 1142629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1142640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1142643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1142646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142668 */     // MIs[0] round
     /* 1142668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142678 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142703 */     // GIR_Coverage, 15283,
     /* 1142703 */     GIR_EraseRootFromParent_Done,
     /* 1142704 */   // Label 16739: @1142704
     /* 1142704 */   GIM_Try, /*On fail goto*//*Label 16740*/ GIMT_Encode4(1142784), // Rule ID 15286 //
     /* 1142709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1142720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1142723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1142726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1142729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142748 */     // MIs[0] round
     /* 1142748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142758 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1142761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142783 */     // GIR_Coverage, 15286,
     /* 1142783 */     GIR_EraseRootFromParent_Done,
     /* 1142784 */   // Label 16740: @1142784
     /* 1142784 */   GIM_Try, /*On fail goto*//*Label 16741*/ GIMT_Encode4(1142864), // Rule ID 15287 //
     /* 1142789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1142800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1142803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1142806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1142809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142828 */     // MIs[0] round
     /* 1142828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142838 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1142841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142863 */     // GIR_Coverage, 15287,
     /* 1142863 */     GIR_EraseRootFromParent_Done,
     /* 1142864 */   // Label 16741: @1142864
     /* 1142864 */   GIM_Try, /*On fail goto*//*Label 16742*/ GIMT_Encode4(1142944), // Rule ID 15290 //
     /* 1142869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1142880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1142883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1142886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1142889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142908 */     // MIs[0] round
     /* 1142908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142918 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1142921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142943 */     // GIR_Coverage, 15290,
     /* 1142943 */     GIR_EraseRootFromParent_Done,
     /* 1142944 */   // Label 16742: @1142944
     /* 1142944 */   GIM_Try, /*On fail goto*//*Label 16743*/ GIMT_Encode4(1143024), // Rule ID 15291 //
     /* 1142949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1142960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1142963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1142966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1142969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142988 */     // MIs[0] round
     /* 1142988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142998 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1143001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143023 */     // GIR_Coverage, 15291,
     /* 1143023 */     GIR_EraseRootFromParent_Done,
     /* 1143024 */   // Label 16743: @1143024
     /* 1143024 */   GIM_Try, /*On fail goto*//*Label 16744*/ GIMT_Encode4(1143104), // Rule ID 15294 //
     /* 1143029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1143040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1143043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1143046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1143049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143068 */     // MIs[0] round
     /* 1143068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143078 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143103 */     // GIR_Coverage, 15294,
     /* 1143103 */     GIR_EraseRootFromParent_Done,
     /* 1143104 */   // Label 16744: @1143104
     /* 1143104 */   GIM_Try, /*On fail goto*//*Label 16745*/ GIMT_Encode4(1143184), // Rule ID 15295 //
     /* 1143109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1143120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1143123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1143126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1143129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143148 */     // MIs[0] round
     /* 1143148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143158 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143183 */     // GIR_Coverage, 15295,
     /* 1143183 */     GIR_EraseRootFromParent_Done,
     /* 1143184 */   // Label 16745: @1143184
     /* 1143184 */   GIM_Try, /*On fail goto*//*Label 16746*/ GIMT_Encode4(1143264), // Rule ID 15298 //
     /* 1143189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1143200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1143203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1143206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1143209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143228 */     // MIs[0] round
     /* 1143228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143238 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1143241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143263 */     // GIR_Coverage, 15298,
     /* 1143263 */     GIR_EraseRootFromParent_Done,
     /* 1143264 */   // Label 16746: @1143264
     /* 1143264 */   GIM_Try, /*On fail goto*//*Label 16747*/ GIMT_Encode4(1143344), // Rule ID 15299 //
     /* 1143269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1143280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1143283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1143286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1143289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143308 */     // MIs[0] round
     /* 1143308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143318 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1143321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143343 */     // GIR_Coverage, 15299,
     /* 1143343 */     GIR_EraseRootFromParent_Done,
     /* 1143344 */   // Label 16747: @1143344
     /* 1143344 */   GIM_Try, /*On fail goto*//*Label 16748*/ GIMT_Encode4(1143424), // Rule ID 15302 //
     /* 1143349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1143360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1143363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1143366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1143369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143388 */     // MIs[0] round
     /* 1143388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143398 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143423 */     // GIR_Coverage, 15302,
     /* 1143423 */     GIR_EraseRootFromParent_Done,
     /* 1143424 */   // Label 16748: @1143424
     /* 1143424 */   GIM_Try, /*On fail goto*//*Label 16749*/ GIMT_Encode4(1143504), // Rule ID 15303 //
     /* 1143429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1143440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1143443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1143446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1143449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143468 */     // MIs[0] round
     /* 1143468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143478 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143503 */     // GIR_Coverage, 15303,
     /* 1143503 */     GIR_EraseRootFromParent_Done,
     /* 1143504 */   // Label 16749: @1143504
     /* 1143504 */   GIM_Try, /*On fail goto*//*Label 16750*/ GIMT_Encode4(1143584), // Rule ID 15306 //
     /* 1143509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1143520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1143523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1143526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1143529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143548 */     // MIs[0] round
     /* 1143548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143558 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1143579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143583 */     // GIR_Coverage, 15306,
     /* 1143583 */     GIR_EraseRootFromParent_Done,
     /* 1143584 */   // Label 16750: @1143584
     /* 1143584 */   GIM_Try, /*On fail goto*//*Label 16751*/ GIMT_Encode4(1143664), // Rule ID 15307 //
     /* 1143589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1143600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1143603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1143606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1143609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143628 */     // MIs[0] round
     /* 1143628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143638 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1143659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143663 */     // GIR_Coverage, 15307,
     /* 1143663 */     GIR_EraseRootFromParent_Done,
     /* 1143664 */   // Label 16751: @1143664
     /* 1143664 */   GIM_Try, /*On fail goto*//*Label 16752*/ GIMT_Encode4(1143744), // Rule ID 15310 //
     /* 1143669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1143680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1143683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1143686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1143689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143708 */     // MIs[0] round
     /* 1143708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143743 */     // GIR_Coverage, 15310,
     /* 1143743 */     GIR_EraseRootFromParent_Done,
     /* 1143744 */   // Label 16752: @1143744
     /* 1143744 */   GIM_Try, /*On fail goto*//*Label 16753*/ GIMT_Encode4(1143824), // Rule ID 15311 //
     /* 1143749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1143760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1143763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1143766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1143769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143788 */     // MIs[0] round
     /* 1143788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143798 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143823 */     // GIR_Coverage, 15311,
     /* 1143823 */     GIR_EraseRootFromParent_Done,
     /* 1143824 */   // Label 16753: @1143824
     /* 1143824 */   GIM_Try, /*On fail goto*//*Label 16754*/ GIMT_Encode4(1143904), // Rule ID 15314 //
     /* 1143829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1143840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1143843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1143846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1143849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143868 */     // MIs[0] round
     /* 1143868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143878 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143903 */     // GIR_Coverage, 15314,
     /* 1143903 */     GIR_EraseRootFromParent_Done,
     /* 1143904 */   // Label 16754: @1143904
     /* 1143904 */   GIM_Try, /*On fail goto*//*Label 16755*/ GIMT_Encode4(1143984), // Rule ID 15315 //
     /* 1143909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1143920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1143923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1143926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1143929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143948 */     // MIs[0] round
     /* 1143948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143958 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143983 */     // GIR_Coverage, 15315,
     /* 1143983 */     GIR_EraseRootFromParent_Done,
     /* 1143984 */   // Label 16755: @1143984
     /* 1143984 */   GIM_Try, /*On fail goto*//*Label 16756*/ GIMT_Encode4(1144064), // Rule ID 15318 //
     /* 1143989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1144000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1144003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1144006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1144009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144028 */     // MIs[0] round
     /* 1144028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144038 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144063 */     // GIR_Coverage, 15318,
     /* 1144063 */     GIR_EraseRootFromParent_Done,
     /* 1144064 */   // Label 16756: @1144064
     /* 1144064 */   GIM_Try, /*On fail goto*//*Label 16757*/ GIMT_Encode4(1144144), // Rule ID 15319 //
     /* 1144069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1144080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1144083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1144086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1144089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144108 */     // MIs[0] round
     /* 1144108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144143 */     // GIR_Coverage, 15319,
     /* 1144143 */     GIR_EraseRootFromParent_Done,
     /* 1144144 */   // Label 16757: @1144144
     /* 1144144 */   GIM_Try, /*On fail goto*//*Label 16758*/ GIMT_Encode4(1144224), // Rule ID 15322 //
     /* 1144149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1144152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1144160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1144163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1144166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1144169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144188 */     // MIs[0] round
     /* 1144188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144198 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144223 */     // GIR_Coverage, 15322,
     /* 1144223 */     GIR_EraseRootFromParent_Done,
     /* 1144224 */   // Label 16758: @1144224
     /* 1144224 */   GIM_Try, /*On fail goto*//*Label 16759*/ GIMT_Encode4(1144304), // Rule ID 15323 //
     /* 1144229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1144232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1144240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1144243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1144246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1144249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144268 */     // MIs[0] round
     /* 1144268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144278 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144303 */     // GIR_Coverage, 15323,
     /* 1144303 */     GIR_EraseRootFromParent_Done,
     /* 1144304 */   // Label 16759: @1144304
     /* 1144304 */   GIM_Try, /*On fail goto*//*Label 16760*/ GIMT_Encode4(1144384), // Rule ID 15326 //
     /* 1144309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1144320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1144323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1144326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1144329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144348 */     // MIs[0] round
     /* 1144348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144358 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144383 */     // GIR_Coverage, 15326,
     /* 1144383 */     GIR_EraseRootFromParent_Done,
     /* 1144384 */   // Label 16760: @1144384
     /* 1144384 */   GIM_Try, /*On fail goto*//*Label 16761*/ GIMT_Encode4(1144464), // Rule ID 15327 //
     /* 1144389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1144400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1144403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1144406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1144409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144428 */     // MIs[0] round
     /* 1144428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144438 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144463 */     // GIR_Coverage, 15327,
     /* 1144463 */     GIR_EraseRootFromParent_Done,
     /* 1144464 */   // Label 16761: @1144464
     /* 1144464 */   GIM_Try, /*On fail goto*//*Label 16762*/ GIMT_Encode4(1144544), // Rule ID 15330 //
     /* 1144469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1144480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1144483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1144486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1144489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144508 */     // MIs[0] round
     /* 1144508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144518 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1144521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144543 */     // GIR_Coverage, 15330,
     /* 1144543 */     GIR_EraseRootFromParent_Done,
     /* 1144544 */   // Label 16762: @1144544
     /* 1144544 */   GIM_Try, /*On fail goto*//*Label 16763*/ GIMT_Encode4(1144624), // Rule ID 15331 //
     /* 1144549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1144560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1144563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1144566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1144569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144588 */     // MIs[0] round
     /* 1144588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144598 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1144601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144623 */     // GIR_Coverage, 15331,
     /* 1144623 */     GIR_EraseRootFromParent_Done,
     /* 1144624 */   // Label 16763: @1144624
     /* 1144624 */   GIM_Try, /*On fail goto*//*Label 16764*/ GIMT_Encode4(1144704), // Rule ID 15334 //
     /* 1144629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1144640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1144643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1144646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1144649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144668 */     // MIs[0] round
     /* 1144668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144678 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1144681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144703 */     // GIR_Coverage, 15334,
     /* 1144703 */     GIR_EraseRootFromParent_Done,
     /* 1144704 */   // Label 16764: @1144704
     /* 1144704 */   GIM_Try, /*On fail goto*//*Label 16765*/ GIMT_Encode4(1144784), // Rule ID 15335 //
     /* 1144709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1144720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1144723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1144726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1144729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144748 */     // MIs[0] round
     /* 1144748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144758 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1144761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144783 */     // GIR_Coverage, 15335,
     /* 1144783 */     GIR_EraseRootFromParent_Done,
     /* 1144784 */   // Label 16765: @1144784
     /* 1144784 */   GIM_Try, /*On fail goto*//*Label 16766*/ GIMT_Encode4(1144864), // Rule ID 15338 //
     /* 1144789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1144800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1144803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1144806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1144809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144828 */     // MIs[0] round
     /* 1144828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144863 */     // GIR_Coverage, 15338,
     /* 1144863 */     GIR_EraseRootFromParent_Done,
     /* 1144864 */   // Label 16766: @1144864
     /* 1144864 */   GIM_Try, /*On fail goto*//*Label 16767*/ GIMT_Encode4(1144944), // Rule ID 15339 //
     /* 1144869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1144880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1144883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1144886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1144889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144908 */     // MIs[0] round
     /* 1144908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144943 */     // GIR_Coverage, 15339,
     /* 1144943 */     GIR_EraseRootFromParent_Done,
     /* 1144944 */   // Label 16767: @1144944
     /* 1144944 */   GIM_Try, /*On fail goto*//*Label 16768*/ GIMT_Encode4(1145024), // Rule ID 15342 //
     /* 1144949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1144960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1144963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1144966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1144969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144988 */     // MIs[0] round
     /* 1144988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144998 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145023 */     // GIR_Coverage, 15342,
     /* 1145023 */     GIR_EraseRootFromParent_Done,
     /* 1145024 */   // Label 16768: @1145024
     /* 1145024 */   GIM_Try, /*On fail goto*//*Label 16769*/ GIMT_Encode4(1145104), // Rule ID 15343 //
     /* 1145029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1145040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1145043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1145046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1145049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145068 */     // MIs[0] round
     /* 1145068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145078 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145103 */     // GIR_Coverage, 15343,
     /* 1145103 */     GIR_EraseRootFromParent_Done,
     /* 1145104 */   // Label 16769: @1145104
     /* 1145104 */   GIM_Try, /*On fail goto*//*Label 16770*/ GIMT_Encode4(1145184), // Rule ID 15346 //
     /* 1145109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1145120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1145123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1145126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1145129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145148 */     // MIs[0] round
     /* 1145148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145158 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145183 */     // GIR_Coverage, 15346,
     /* 1145183 */     GIR_EraseRootFromParent_Done,
     /* 1145184 */   // Label 16770: @1145184
     /* 1145184 */   GIM_Try, /*On fail goto*//*Label 16771*/ GIMT_Encode4(1145264), // Rule ID 15347 //
     /* 1145189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1145200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1145203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1145206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1145209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145228 */     // MIs[0] round
     /* 1145228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145238 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145263 */     // GIR_Coverage, 15347,
     /* 1145263 */     GIR_EraseRootFromParent_Done,
     /* 1145264 */   // Label 16771: @1145264
     /* 1145264 */   GIM_Try, /*On fail goto*//*Label 16772*/ GIMT_Encode4(1145344), // Rule ID 15350 //
     /* 1145269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1145280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1145283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1145286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1145289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145308 */     // MIs[0] round
     /* 1145308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145343 */     // GIR_Coverage, 15350,
     /* 1145343 */     GIR_EraseRootFromParent_Done,
     /* 1145344 */   // Label 16772: @1145344
     /* 1145344 */   GIM_Try, /*On fail goto*//*Label 16773*/ GIMT_Encode4(1145424), // Rule ID 15351 //
     /* 1145349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1145360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1145363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1145366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1145369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145388 */     // MIs[0] round
     /* 1145388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145398 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145423 */     // GIR_Coverage, 15351,
     /* 1145423 */     GIR_EraseRootFromParent_Done,
     /* 1145424 */   // Label 16773: @1145424
     /* 1145424 */   GIM_Try, /*On fail goto*//*Label 16774*/ GIMT_Encode4(1145504), // Rule ID 15354 //
     /* 1145429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1145440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1145443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1145446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1145449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145468 */     // MIs[0] round
     /* 1145468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145503 */     // GIR_Coverage, 15354,
     /* 1145503 */     GIR_EraseRootFromParent_Done,
     /* 1145504 */   // Label 16774: @1145504
     /* 1145504 */   GIM_Try, /*On fail goto*//*Label 16775*/ GIMT_Encode4(1145584), // Rule ID 15355 //
     /* 1145509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1145520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1145523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1145526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1145529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145548 */     // MIs[0] round
     /* 1145548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145558 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145583 */     // GIR_Coverage, 15355,
     /* 1145583 */     GIR_EraseRootFromParent_Done,
     /* 1145584 */   // Label 16775: @1145584
     /* 1145584 */   GIM_Try, /*On fail goto*//*Label 16776*/ GIMT_Encode4(1145664), // Rule ID 15358 //
     /* 1145589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1145600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1145603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1145606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1145609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145628 */     // MIs[0] round
     /* 1145628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145638 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145663 */     // GIR_Coverage, 15358,
     /* 1145663 */     GIR_EraseRootFromParent_Done,
     /* 1145664 */   // Label 16776: @1145664
     /* 1145664 */   GIM_Try, /*On fail goto*//*Label 16777*/ GIMT_Encode4(1145744), // Rule ID 15359 //
     /* 1145669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1145680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1145683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1145686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1145689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145708 */     // MIs[0] round
     /* 1145708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145743 */     // GIR_Coverage, 15359,
     /* 1145743 */     GIR_EraseRootFromParent_Done,
     /* 1145744 */   // Label 16777: @1145744
     /* 1145744 */   GIM_Try, /*On fail goto*//*Label 16778*/ GIMT_Encode4(1145824), // Rule ID 15362 //
     /* 1145749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1145752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1145760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1145763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1145766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1145769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145788 */     // MIs[0] round
     /* 1145788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145823 */     // GIR_Coverage, 15362,
     /* 1145823 */     GIR_EraseRootFromParent_Done,
     /* 1145824 */   // Label 16778: @1145824
     /* 1145824 */   GIM_Try, /*On fail goto*//*Label 16779*/ GIMT_Encode4(1145904), // Rule ID 15363 //
     /* 1145829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1145832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1145840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1145843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1145846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1145849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145868 */     // MIs[0] round
     /* 1145868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145878 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145903 */     // GIR_Coverage, 15363,
     /* 1145903 */     GIR_EraseRootFromParent_Done,
     /* 1145904 */   // Label 16779: @1145904
     /* 1145904 */   GIM_Try, /*On fail goto*//*Label 16780*/ GIMT_Encode4(1145984), // Rule ID 15366 //
     /* 1145909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1145912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1145920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1145923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1145926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1145929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145948 */     // MIs[0] round
     /* 1145948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145958 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145983 */     // GIR_Coverage, 15366,
     /* 1145983 */     GIR_EraseRootFromParent_Done,
     /* 1145984 */   // Label 16780: @1145984
     /* 1145984 */   GIM_Try, /*On fail goto*//*Label 16781*/ GIMT_Encode4(1146064), // Rule ID 15367 //
     /* 1145989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1145992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1146000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1146003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1146006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1146009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146028 */     // MIs[0] round
     /* 1146028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146038 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1146041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146063 */     // GIR_Coverage, 15367,
     /* 1146063 */     GIR_EraseRootFromParent_Done,
     /* 1146064 */   // Label 16781: @1146064
     /* 1146064 */   GIM_Try, /*On fail goto*//*Label 16782*/ GIMT_Encode4(1146144), // Rule ID 15370 //
     /* 1146069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1146072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1146080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1146083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1146086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1146089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146108 */     // MIs[0] round
     /* 1146108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146118 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1146121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146143 */     // GIR_Coverage, 15370,
     /* 1146143 */     GIR_EraseRootFromParent_Done,
     /* 1146144 */   // Label 16782: @1146144
     /* 1146144 */   GIM_Try, /*On fail goto*//*Label 16783*/ GIMT_Encode4(1146224), // Rule ID 15371 //
     /* 1146149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1146152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1146160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1146163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1146166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1146169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146188 */     // MIs[0] round
     /* 1146188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146198 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1146201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146223 */     // GIR_Coverage, 15371,
     /* 1146223 */     GIR_EraseRootFromParent_Done,
     /* 1146224 */   // Label 16783: @1146224
     /* 1146224 */   GIM_Try, /*On fail goto*//*Label 16784*/ GIMT_Encode4(1146304), // Rule ID 15374 //
     /* 1146229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1146240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1146243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1146246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146268 */     // MIs[0] round
     /* 1146268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146278 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1146281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146303 */     // GIR_Coverage, 15374,
     /* 1146303 */     GIR_EraseRootFromParent_Done,
     /* 1146304 */   // Label 16784: @1146304
     /* 1146304 */   GIM_Try, /*On fail goto*//*Label 16785*/ GIMT_Encode4(1146384), // Rule ID 15375 //
     /* 1146309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1146320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1146323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1146326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146348 */     // MIs[0] round
     /* 1146348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146358 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1146361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146383 */     // GIR_Coverage, 15375,
     /* 1146383 */     GIR_EraseRootFromParent_Done,
     /* 1146384 */   // Label 16785: @1146384
     /* 1146384 */   GIM_Try, /*On fail goto*//*Label 16786*/ GIMT_Encode4(1146464), // Rule ID 15378 //
     /* 1146389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1146400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1146403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1146406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146428 */     // MIs[0] round
     /* 1146428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146438 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146463 */     // GIR_Coverage, 15378,
     /* 1146463 */     GIR_EraseRootFromParent_Done,
     /* 1146464 */   // Label 16786: @1146464
     /* 1146464 */   GIM_Try, /*On fail goto*//*Label 16787*/ GIMT_Encode4(1146544), // Rule ID 15379 //
     /* 1146469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1146480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1146483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1146486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146508 */     // MIs[0] round
     /* 1146508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146518 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146543 */     // GIR_Coverage, 15379,
     /* 1146543 */     GIR_EraseRootFromParent_Done,
     /* 1146544 */   // Label 16787: @1146544
     /* 1146544 */   GIM_Try, /*On fail goto*//*Label 16788*/ GIMT_Encode4(1146624), // Rule ID 15382 //
     /* 1146549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1146560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1146563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1146566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146588 */     // MIs[0] round
     /* 1146588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146598 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1146601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146623 */     // GIR_Coverage, 15382,
     /* 1146623 */     GIR_EraseRootFromParent_Done,
     /* 1146624 */   // Label 16788: @1146624
     /* 1146624 */   GIM_Try, /*On fail goto*//*Label 16789*/ GIMT_Encode4(1146704), // Rule ID 15383 //
     /* 1146629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1146640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1146643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1146646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146668 */     // MIs[0] round
     /* 1146668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146678 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1146681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146703 */     // GIR_Coverage, 15383,
     /* 1146703 */     GIR_EraseRootFromParent_Done,
     /* 1146704 */   // Label 16789: @1146704
     /* 1146704 */   GIM_Try, /*On fail goto*//*Label 16790*/ GIMT_Encode4(1146784), // Rule ID 15386 //
     /* 1146709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1146720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1146723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1146726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146748 */     // MIs[0] round
     /* 1146748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146758 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146783 */     // GIR_Coverage, 15386,
     /* 1146783 */     GIR_EraseRootFromParent_Done,
     /* 1146784 */   // Label 16790: @1146784
     /* 1146784 */   GIM_Try, /*On fail goto*//*Label 16791*/ GIMT_Encode4(1146864), // Rule ID 15387 //
     /* 1146789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1146800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1146803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1146806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146828 */     // MIs[0] round
     /* 1146828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146838 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146863 */     // GIR_Coverage, 15387,
     /* 1146863 */     GIR_EraseRootFromParent_Done,
     /* 1146864 */   // Label 16791: @1146864
     /* 1146864 */   GIM_Try, /*On fail goto*//*Label 16792*/ GIMT_Encode4(1146944), // Rule ID 15390 //
     /* 1146869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1146880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1146883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1146886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146908 */     // MIs[0] round
     /* 1146908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1146921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146943 */     // GIR_Coverage, 15390,
     /* 1146943 */     GIR_EraseRootFromParent_Done,
     /* 1146944 */   // Label 16792: @1146944
     /* 1146944 */   GIM_Try, /*On fail goto*//*Label 16793*/ GIMT_Encode4(1147024), // Rule ID 15391 //
     /* 1146949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1146960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1146963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1146966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146988 */     // MIs[0] round
     /* 1146988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146998 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147023 */     // GIR_Coverage, 15391,
     /* 1147023 */     GIR_EraseRootFromParent_Done,
     /* 1147024 */   // Label 16793: @1147024
     /* 1147024 */   GIM_Try, /*On fail goto*//*Label 16794*/ GIMT_Encode4(1147104), // Rule ID 15394 //
     /* 1147029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1147040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1147043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1147046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147068 */     // MIs[0] round
     /* 1147068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147078 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147103 */     // GIR_Coverage, 15394,
     /* 1147103 */     GIR_EraseRootFromParent_Done,
     /* 1147104 */   // Label 16794: @1147104
     /* 1147104 */   GIM_Try, /*On fail goto*//*Label 16795*/ GIMT_Encode4(1147184), // Rule ID 15395 //
     /* 1147109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1147120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1147123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1147126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147148 */     // MIs[0] round
     /* 1147148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147158 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147183 */     // GIR_Coverage, 15395,
     /* 1147183 */     GIR_EraseRootFromParent_Done,
     /* 1147184 */   // Label 16795: @1147184
     /* 1147184 */   GIM_Try, /*On fail goto*//*Label 16796*/ GIMT_Encode4(1147264), // Rule ID 15398 //
     /* 1147189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1147200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1147203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1147206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147228 */     // MIs[0] round
     /* 1147228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147238 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147263 */     // GIR_Coverage, 15398,
     /* 1147263 */     GIR_EraseRootFromParent_Done,
     /* 1147264 */   // Label 16796: @1147264
     /* 1147264 */   GIM_Try, /*On fail goto*//*Label 16797*/ GIMT_Encode4(1147344), // Rule ID 15399 //
     /* 1147269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1147280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1147283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1147286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147308 */     // MIs[0] round
     /* 1147308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147318 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147343 */     // GIR_Coverage, 15399,
     /* 1147343 */     GIR_EraseRootFromParent_Done,
     /* 1147344 */   // Label 16797: @1147344
     /* 1147344 */   GIM_Try, /*On fail goto*//*Label 16798*/ GIMT_Encode4(1147424), // Rule ID 15402 //
     /* 1147349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1147360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1147363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1147366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147388 */     // MIs[0] round
     /* 1147388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147423 */     // GIR_Coverage, 15402,
     /* 1147423 */     GIR_EraseRootFromParent_Done,
     /* 1147424 */   // Label 16798: @1147424
     /* 1147424 */   GIM_Try, /*On fail goto*//*Label 16799*/ GIMT_Encode4(1147504), // Rule ID 15403 //
     /* 1147429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1147440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1147443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1147446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147468 */     // MIs[0] round
     /* 1147468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147478 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147503 */     // GIR_Coverage, 15403,
     /* 1147503 */     GIR_EraseRootFromParent_Done,
     /* 1147504 */   // Label 16799: @1147504
     /* 1147504 */   GIM_Try, /*On fail goto*//*Label 16800*/ GIMT_Encode4(1147584), // Rule ID 15406 //
     /* 1147509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1147520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1147523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1147526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147548 */     // MIs[0] round
     /* 1147548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147583 */     // GIR_Coverage, 15406,
     /* 1147583 */     GIR_EraseRootFromParent_Done,
     /* 1147584 */   // Label 16800: @1147584
     /* 1147584 */   GIM_Try, /*On fail goto*//*Label 16801*/ GIMT_Encode4(1147664), // Rule ID 15407 //
     /* 1147589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1147600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1147603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1147606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147628 */     // MIs[0] round
     /* 1147628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147663 */     // GIR_Coverage, 15407,
     /* 1147663 */     GIR_EraseRootFromParent_Done,
     /* 1147664 */   // Label 16801: @1147664
     /* 1147664 */   GIM_Try, /*On fail goto*//*Label 16802*/ GIMT_Encode4(1147744), // Rule ID 15410 //
     /* 1147669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1147672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1147680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1147683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1147686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147708 */     // MIs[0] round
     /* 1147708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147718 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1147739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147743 */     // GIR_Coverage, 15410,
     /* 1147743 */     GIR_EraseRootFromParent_Done,
     /* 1147744 */   // Label 16802: @1147744
     /* 1147744 */   GIM_Try, /*On fail goto*//*Label 16803*/ GIMT_Encode4(1147824), // Rule ID 15411 //
     /* 1147749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1147752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1147760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1147763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1147766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147788 */     // MIs[0] round
     /* 1147788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147798 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1147819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147823 */     // GIR_Coverage, 15411,
     /* 1147823 */     GIR_EraseRootFromParent_Done,
     /* 1147824 */   // Label 16803: @1147824
     /* 1147824 */   GIM_Try, /*On fail goto*//*Label 16804*/ GIMT_Encode4(1147904), // Rule ID 15414 //
     /* 1147829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1147840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1147843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1147846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147868 */     // MIs[0] round
     /* 1147868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147878 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1147881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147903 */     // GIR_Coverage, 15414,
     /* 1147903 */     GIR_EraseRootFromParent_Done,
     /* 1147904 */   // Label 16804: @1147904
     /* 1147904 */   GIM_Try, /*On fail goto*//*Label 16805*/ GIMT_Encode4(1147984), // Rule ID 15415 //
     /* 1147909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1147920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1147923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1147926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147948 */     // MIs[0] round
     /* 1147948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147958 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1147961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147983 */     // GIR_Coverage, 15415,
     /* 1147983 */     GIR_EraseRootFromParent_Done,
     /* 1147984 */   // Label 16805: @1147984
     /* 1147984 */   GIM_Try, /*On fail goto*//*Label 16806*/ GIMT_Encode4(1148064), // Rule ID 15418 //
     /* 1147989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1148000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1148003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1148006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148028 */     // MIs[0] round
     /* 1148028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148038 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148063 */     // GIR_Coverage, 15418,
     /* 1148063 */     GIR_EraseRootFromParent_Done,
     /* 1148064 */   // Label 16806: @1148064
     /* 1148064 */   GIM_Try, /*On fail goto*//*Label 16807*/ GIMT_Encode4(1148144), // Rule ID 15419 //
     /* 1148069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1148080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1148083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1148086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148108 */     // MIs[0] round
     /* 1148108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148118 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148143 */     // GIR_Coverage, 15419,
     /* 1148143 */     GIR_EraseRootFromParent_Done,
     /* 1148144 */   // Label 16807: @1148144
     /* 1148144 */   GIM_Try, /*On fail goto*//*Label 16808*/ GIMT_Encode4(1148224), // Rule ID 15422 //
     /* 1148149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1148160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1148163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1148166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148188 */     // MIs[0] round
     /* 1148188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148198 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148223 */     // GIR_Coverage, 15422,
     /* 1148223 */     GIR_EraseRootFromParent_Done,
     /* 1148224 */   // Label 16808: @1148224
     /* 1148224 */   GIM_Try, /*On fail goto*//*Label 16809*/ GIMT_Encode4(1148304), // Rule ID 15423 //
     /* 1148229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1148240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1148243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1148246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148268 */     // MIs[0] round
     /* 1148268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148278 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148303 */     // GIR_Coverage, 15423,
     /* 1148303 */     GIR_EraseRootFromParent_Done,
     /* 1148304 */   // Label 16809: @1148304
     /* 1148304 */   GIM_Try, /*On fail goto*//*Label 16810*/ GIMT_Encode4(1148384), // Rule ID 15426 //
     /* 1148309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1148320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1148323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1148326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148348 */     // MIs[0] round
     /* 1148348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148358 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148383 */     // GIR_Coverage, 15426,
     /* 1148383 */     GIR_EraseRootFromParent_Done,
     /* 1148384 */   // Label 16810: @1148384
     /* 1148384 */   GIM_Try, /*On fail goto*//*Label 16811*/ GIMT_Encode4(1148464), // Rule ID 15427 //
     /* 1148389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1148400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1148403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1148406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148428 */     // MIs[0] round
     /* 1148428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148438 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148463 */     // GIR_Coverage, 15427,
     /* 1148463 */     GIR_EraseRootFromParent_Done,
     /* 1148464 */   // Label 16811: @1148464
     /* 1148464 */   GIM_Try, /*On fail goto*//*Label 16812*/ GIMT_Encode4(1148544), // Rule ID 15430 //
     /* 1148469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1148480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1148483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1148486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148508 */     // MIs[0] round
     /* 1148508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148518 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148543 */     // GIR_Coverage, 15430,
     /* 1148543 */     GIR_EraseRootFromParent_Done,
     /* 1148544 */   // Label 16812: @1148544
     /* 1148544 */   GIM_Try, /*On fail goto*//*Label 16813*/ GIMT_Encode4(1148624), // Rule ID 15431 //
     /* 1148549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1148560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1148563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1148566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148588 */     // MIs[0] round
     /* 1148588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148598 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148623 */     // GIR_Coverage, 15431,
     /* 1148623 */     GIR_EraseRootFromParent_Done,
     /* 1148624 */   // Label 16813: @1148624
     /* 1148624 */   GIM_Try, /*On fail goto*//*Label 16814*/ GIMT_Encode4(1148704), // Rule ID 15434 //
     /* 1148629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1148640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1148643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1148646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148668 */     // MIs[0] round
     /* 1148668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148678 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148703 */     // GIR_Coverage, 15434,
     /* 1148703 */     GIR_EraseRootFromParent_Done,
     /* 1148704 */   // Label 16814: @1148704
     /* 1148704 */   GIM_Try, /*On fail goto*//*Label 16815*/ GIMT_Encode4(1148784), // Rule ID 15435 //
     /* 1148709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1148720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1148723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1148726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148748 */     // MIs[0] round
     /* 1148748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148758 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148783 */     // GIR_Coverage, 15435,
     /* 1148783 */     GIR_EraseRootFromParent_Done,
     /* 1148784 */   // Label 16815: @1148784
     /* 1148784 */   GIM_Try, /*On fail goto*//*Label 16816*/ GIMT_Encode4(1148864), // Rule ID 15438 //
     /* 1148789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1148800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1148803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1148806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148828 */     // MIs[0] round
     /* 1148828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148863 */     // GIR_Coverage, 15438,
     /* 1148863 */     GIR_EraseRootFromParent_Done,
     /* 1148864 */   // Label 16816: @1148864
     /* 1148864 */   GIM_Try, /*On fail goto*//*Label 16817*/ GIMT_Encode4(1148944), // Rule ID 15439 //
     /* 1148869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1148880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1148883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1148886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148908 */     // MIs[0] round
     /* 1148908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148943 */     // GIR_Coverage, 15439,
     /* 1148943 */     GIR_EraseRootFromParent_Done,
     /* 1148944 */   // Label 16817: @1148944
     /* 1148944 */   GIM_Try, /*On fail goto*//*Label 16818*/ GIMT_Encode4(1149024), // Rule ID 15442 //
     /* 1148949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1148960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1148963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1148966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148988 */     // MIs[0] round
     /* 1148988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148998 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149023 */     // GIR_Coverage, 15442,
     /* 1149023 */     GIR_EraseRootFromParent_Done,
     /* 1149024 */   // Label 16818: @1149024
     /* 1149024 */   GIM_Try, /*On fail goto*//*Label 16819*/ GIMT_Encode4(1149104), // Rule ID 15443 //
     /* 1149029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1149040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1149043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1149046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149068 */     // MIs[0] round
     /* 1149068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149078 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149103 */     // GIR_Coverage, 15443,
     /* 1149103 */     GIR_EraseRootFromParent_Done,
     /* 1149104 */   // Label 16819: @1149104
     /* 1149104 */   GIM_Try, /*On fail goto*//*Label 16820*/ GIMT_Encode4(1149184), // Rule ID 15446 //
     /* 1149109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1149120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1149123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1149126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149148 */     // MIs[0] round
     /* 1149148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149158 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149183 */     // GIR_Coverage, 15446,
     /* 1149183 */     GIR_EraseRootFromParent_Done,
     /* 1149184 */   // Label 16820: @1149184
     /* 1149184 */   GIM_Try, /*On fail goto*//*Label 16821*/ GIMT_Encode4(1149264), // Rule ID 15447 //
     /* 1149189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1149200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1149203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1149206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149228 */     // MIs[0] round
     /* 1149228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149238 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149263 */     // GIR_Coverage, 15447,
     /* 1149263 */     GIR_EraseRootFromParent_Done,
     /* 1149264 */   // Label 16821: @1149264
     /* 1149264 */   GIM_Try, /*On fail goto*//*Label 16822*/ GIMT_Encode4(1149344), // Rule ID 15450 //
     /* 1149269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1149280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1149283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1149286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149308 */     // MIs[0] round
     /* 1149308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1149321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149343 */     // GIR_Coverage, 15450,
     /* 1149343 */     GIR_EraseRootFromParent_Done,
     /* 1149344 */   // Label 16822: @1149344
     /* 1149344 */   GIM_Try, /*On fail goto*//*Label 16823*/ GIMT_Encode4(1149424), // Rule ID 15451 //
     /* 1149349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1149360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1149363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1149366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149388 */     // MIs[0] round
     /* 1149388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1149401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149423 */     // GIR_Coverage, 15451,
     /* 1149423 */     GIR_EraseRootFromParent_Done,
     /* 1149424 */   // Label 16823: @1149424
     /* 1149424 */   GIM_Try, /*On fail goto*//*Label 16824*/ GIMT_Encode4(1149504), // Rule ID 15454 //
     /* 1149429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1149440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1149443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1149446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149468 */     // MIs[0] round
     /* 1149468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149478 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149503 */     // GIR_Coverage, 15454,
     /* 1149503 */     GIR_EraseRootFromParent_Done,
     /* 1149504 */   // Label 16824: @1149504
     /* 1149504 */   GIM_Try, /*On fail goto*//*Label 16825*/ GIMT_Encode4(1149584), // Rule ID 15455 //
     /* 1149509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1149520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1149523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1149526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149548 */     // MIs[0] round
     /* 1149548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149558 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149583 */     // GIR_Coverage, 15455,
     /* 1149583 */     GIR_EraseRootFromParent_Done,
     /* 1149584 */   // Label 16825: @1149584
     /* 1149584 */   GIM_Try, /*On fail goto*//*Label 16826*/ GIMT_Encode4(1149664), // Rule ID 15458 //
     /* 1149589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1149600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1149603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1149606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149628 */     // MIs[0] round
     /* 1149628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149638 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149663 */     // GIR_Coverage, 15458,
     /* 1149663 */     GIR_EraseRootFromParent_Done,
     /* 1149664 */   // Label 16826: @1149664
     /* 1149664 */   GIM_Try, /*On fail goto*//*Label 16827*/ GIMT_Encode4(1149744), // Rule ID 15459 //
     /* 1149669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1149680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1149683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1149686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149708 */     // MIs[0] round
     /* 1149708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149743 */     // GIR_Coverage, 15459,
     /* 1149743 */     GIR_EraseRootFromParent_Done,
     /* 1149744 */   // Label 16827: @1149744
     /* 1149744 */   GIM_Try, /*On fail goto*//*Label 16828*/ GIMT_Encode4(1149824), // Rule ID 15462 //
     /* 1149749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1149760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1149763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1149766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1149769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149788 */     // MIs[0] round
     /* 1149788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149798 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1149801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149823 */     // GIR_Coverage, 15462,
     /* 1149823 */     GIR_EraseRootFromParent_Done,
     /* 1149824 */   // Label 16828: @1149824
     /* 1149824 */   GIM_Try, /*On fail goto*//*Label 16829*/ GIMT_Encode4(1149904), // Rule ID 15463 //
     /* 1149829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1149840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1149843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1149846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1149849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149868 */     // MIs[0] round
     /* 1149868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149878 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1149881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149903 */     // GIR_Coverage, 15463,
     /* 1149903 */     GIR_EraseRootFromParent_Done,
     /* 1149904 */   // Label 16829: @1149904
     /* 1149904 */   GIM_Try, /*On fail goto*//*Label 16830*/ GIMT_Encode4(1149984), // Rule ID 15466 //
     /* 1149909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1149920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1149923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1149926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1149929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149948 */     // MIs[0] round
     /* 1149948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149958 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1149961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149983 */     // GIR_Coverage, 15466,
     /* 1149983 */     GIR_EraseRootFromParent_Done,
     /* 1149984 */   // Label 16830: @1149984
     /* 1149984 */   GIM_Try, /*On fail goto*//*Label 16831*/ GIMT_Encode4(1150064), // Rule ID 15467 //
     /* 1149989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1150000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1150003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1150006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1150009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150028 */     // MIs[0] round
     /* 1150028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150038 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150063 */     // GIR_Coverage, 15467,
     /* 1150063 */     GIR_EraseRootFromParent_Done,
     /* 1150064 */   // Label 16831: @1150064
     /* 1150064 */   GIM_Try, /*On fail goto*//*Label 16832*/ GIMT_Encode4(1150144), // Rule ID 15470 //
     /* 1150069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1150080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1150083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1150086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1150089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150108 */     // MIs[0] round
     /* 1150108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150143 */     // GIR_Coverage, 15470,
     /* 1150143 */     GIR_EraseRootFromParent_Done,
     /* 1150144 */   // Label 16832: @1150144
     /* 1150144 */   GIM_Try, /*On fail goto*//*Label 16833*/ GIMT_Encode4(1150224), // Rule ID 15471 //
     /* 1150149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1150160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1150163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1150166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1150169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150188 */     // MIs[0] round
     /* 1150188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150198 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150223 */     // GIR_Coverage, 15471,
     /* 1150223 */     GIR_EraseRootFromParent_Done,
     /* 1150224 */   // Label 16833: @1150224
     /* 1150224 */   GIM_Try, /*On fail goto*//*Label 16834*/ GIMT_Encode4(1150304), // Rule ID 15474 //
     /* 1150229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1150240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1150243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1150246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1150249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150268 */     // MIs[0] round
     /* 1150268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150278 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150303 */     // GIR_Coverage, 15474,
     /* 1150303 */     GIR_EraseRootFromParent_Done,
     /* 1150304 */   // Label 16834: @1150304
     /* 1150304 */   GIM_Try, /*On fail goto*//*Label 16835*/ GIMT_Encode4(1150384), // Rule ID 15475 //
     /* 1150309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1150320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1150323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1150326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1150329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150348 */     // MIs[0] round
     /* 1150348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150358 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150383 */     // GIR_Coverage, 15475,
     /* 1150383 */     GIR_EraseRootFromParent_Done,
     /* 1150384 */   // Label 16835: @1150384
     /* 1150384 */   GIM_Try, /*On fail goto*//*Label 16836*/ GIMT_Encode4(1150464), // Rule ID 15478 //
     /* 1150389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1150400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1150403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1150406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1150409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150428 */     // MIs[0] round
     /* 1150428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150438 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150463 */     // GIR_Coverage, 15478,
     /* 1150463 */     GIR_EraseRootFromParent_Done,
     /* 1150464 */   // Label 16836: @1150464
     /* 1150464 */   GIM_Try, /*On fail goto*//*Label 16837*/ GIMT_Encode4(1150544), // Rule ID 15479 //
     /* 1150469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1150480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1150483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1150486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1150489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150508 */     // MIs[0] round
     /* 1150508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150543 */     // GIR_Coverage, 15479,
     /* 1150543 */     GIR_EraseRootFromParent_Done,
     /* 1150544 */   // Label 16837: @1150544
     /* 1150544 */   GIM_Try, /*On fail goto*//*Label 16838*/ GIMT_Encode4(1150624), // Rule ID 15482 //
     /* 1150549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1150560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1150563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1150566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1150569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150588 */     // MIs[0] round
     /* 1150588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150598 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1150619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150623 */     // GIR_Coverage, 15482,
     /* 1150623 */     GIR_EraseRootFromParent_Done,
     /* 1150624 */   // Label 16838: @1150624
     /* 1150624 */   GIM_Try, /*On fail goto*//*Label 16839*/ GIMT_Encode4(1150704), // Rule ID 15483 //
     /* 1150629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1150640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1150643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1150646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1150649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150668 */     // MIs[0] round
     /* 1150668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150678 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1150699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150703 */     // GIR_Coverage, 15483,
     /* 1150703 */     GIR_EraseRootFromParent_Done,
     /* 1150704 */   // Label 16839: @1150704
     /* 1150704 */   GIM_Try, /*On fail goto*//*Label 16840*/ GIMT_Encode4(1150784), // Rule ID 15486 //
     /* 1150709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1150720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1150723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1150726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1150729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150748 */     // MIs[0] round
     /* 1150748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150783 */     // GIR_Coverage, 15486,
     /* 1150783 */     GIR_EraseRootFromParent_Done,
     /* 1150784 */   // Label 16840: @1150784
     /* 1150784 */   GIM_Try, /*On fail goto*//*Label 16841*/ GIMT_Encode4(1150864), // Rule ID 15487 //
     /* 1150789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1150800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1150803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1150806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1150809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150828 */     // MIs[0] round
     /* 1150828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150838 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150863 */     // GIR_Coverage, 15487,
     /* 1150863 */     GIR_EraseRootFromParent_Done,
     /* 1150864 */   // Label 16841: @1150864
     /* 1150864 */   GIM_Try, /*On fail goto*//*Label 16842*/ GIMT_Encode4(1150944), // Rule ID 15490 //
     /* 1150869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1150880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1150883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1150886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1150889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150908 */     // MIs[0] round
     /* 1150908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150943 */     // GIR_Coverage, 15490,
     /* 1150943 */     GIR_EraseRootFromParent_Done,
     /* 1150944 */   // Label 16842: @1150944
     /* 1150944 */   GIM_Try, /*On fail goto*//*Label 16843*/ GIMT_Encode4(1151024), // Rule ID 15491 //
     /* 1150949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1150960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1150963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1150966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1150969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150988 */     // MIs[0] round
     /* 1150988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150998 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151023 */     // GIR_Coverage, 15491,
     /* 1151023 */     GIR_EraseRootFromParent_Done,
     /* 1151024 */   // Label 16843: @1151024
     /* 1151024 */   GIM_Try, /*On fail goto*//*Label 16844*/ GIMT_Encode4(1151104), // Rule ID 15494 //
     /* 1151029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1151040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1151043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1151046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1151049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151068 */     // MIs[0] round
     /* 1151068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151078 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151103 */     // GIR_Coverage, 15494,
     /* 1151103 */     GIR_EraseRootFromParent_Done,
     /* 1151104 */   // Label 16844: @1151104
     /* 1151104 */   GIM_Try, /*On fail goto*//*Label 16845*/ GIMT_Encode4(1151184), // Rule ID 15495 //
     /* 1151109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1151120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1151123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1151126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1151129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151148 */     // MIs[0] round
     /* 1151148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151183 */     // GIR_Coverage, 15495,
     /* 1151183 */     GIR_EraseRootFromParent_Done,
     /* 1151184 */   // Label 16845: @1151184
     /* 1151184 */   GIM_Try, /*On fail goto*//*Label 16846*/ GIMT_Encode4(1151264), // Rule ID 15498 //
     /* 1151189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1151192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1151200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1151203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1151206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1151209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151228 */     // MIs[0] round
     /* 1151228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151238 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151263 */     // GIR_Coverage, 15498,
     /* 1151263 */     GIR_EraseRootFromParent_Done,
     /* 1151264 */   // Label 16846: @1151264
     /* 1151264 */   GIM_Try, /*On fail goto*//*Label 16847*/ GIMT_Encode4(1151344), // Rule ID 15499 //
     /* 1151269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1151272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1151280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1151283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1151286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1151289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151308 */     // MIs[0] round
     /* 1151308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151318 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151343 */     // GIR_Coverage, 15499,
     /* 1151343 */     GIR_EraseRootFromParent_Done,
     /* 1151344 */   // Label 16847: @1151344
     /* 1151344 */   GIM_Try, /*On fail goto*//*Label 16848*/ GIMT_Encode4(1151424), // Rule ID 15502 //
     /* 1151349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1151360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1151363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1151366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1151369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151388 */     // MIs[0] round
     /* 1151388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151423 */     // GIR_Coverage, 15502,
     /* 1151423 */     GIR_EraseRootFromParent_Done,
     /* 1151424 */   // Label 16848: @1151424
     /* 1151424 */   GIM_Try, /*On fail goto*//*Label 16849*/ GIMT_Encode4(1151504), // Rule ID 15503 //
     /* 1151429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1151440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1151443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1151446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1151449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151468 */     // MIs[0] round
     /* 1151468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151478 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151503 */     // GIR_Coverage, 15503,
     /* 1151503 */     GIR_EraseRootFromParent_Done,
     /* 1151504 */   // Label 16849: @1151504
     /* 1151504 */   GIM_Try, /*On fail goto*//*Label 16850*/ GIMT_Encode4(1151584), // Rule ID 15506 //
     /* 1151509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1151520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1151523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1151526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1151529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151548 */     // MIs[0] round
     /* 1151548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151558 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1151561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151583 */     // GIR_Coverage, 15506,
     /* 1151583 */     GIR_EraseRootFromParent_Done,
     /* 1151584 */   // Label 16850: @1151584
     /* 1151584 */   GIM_Try, /*On fail goto*//*Label 16851*/ GIMT_Encode4(1151664), // Rule ID 15507 //
     /* 1151589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1151600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1151603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1151606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1151609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151628 */     // MIs[0] round
     /* 1151628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151638 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1151641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151663 */     // GIR_Coverage, 15507,
     /* 1151663 */     GIR_EraseRootFromParent_Done,
     /* 1151664 */   // Label 16851: @1151664
     /* 1151664 */   GIM_Try, /*On fail goto*//*Label 16852*/ GIMT_Encode4(1151744), // Rule ID 15510 //
     /* 1151669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1151680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1151683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1151686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1151689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151708 */     // MIs[0] round
     /* 1151708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151718 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1151721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151743 */     // GIR_Coverage, 15510,
     /* 1151743 */     GIR_EraseRootFromParent_Done,
     /* 1151744 */   // Label 16852: @1151744
     /* 1151744 */   GIM_Try, /*On fail goto*//*Label 16853*/ GIMT_Encode4(1151824), // Rule ID 15511 //
     /* 1151749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1151760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1151763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1151766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1151769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151788 */     // MIs[0] round
     /* 1151788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151798 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1151801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151823 */     // GIR_Coverage, 15511,
     /* 1151823 */     GIR_EraseRootFromParent_Done,
     /* 1151824 */   // Label 16853: @1151824
     /* 1151824 */   GIM_Try, /*On fail goto*//*Label 16854*/ GIMT_Encode4(1151904), // Rule ID 15514 //
     /* 1151829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1151840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1151843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1151846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1151849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151868 */     // MIs[0] round
     /* 1151868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151878 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151903 */     // GIR_Coverage, 15514,
     /* 1151903 */     GIR_EraseRootFromParent_Done,
     /* 1151904 */   // Label 16854: @1151904
     /* 1151904 */   GIM_Try, /*On fail goto*//*Label 16855*/ GIMT_Encode4(1151984), // Rule ID 15515 //
     /* 1151909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1151920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1151923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1151926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1151929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151948 */     // MIs[0] round
     /* 1151948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151958 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151983 */     // GIR_Coverage, 15515,
     /* 1151983 */     GIR_EraseRootFromParent_Done,
     /* 1151984 */   // Label 16855: @1151984
     /* 1151984 */   GIM_Try, /*On fail goto*//*Label 16856*/ GIMT_Encode4(1152064), // Rule ID 15518 //
     /* 1151989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1152000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1152003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1152006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1152009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152028 */     // MIs[0] round
     /* 1152028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152038 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152063 */     // GIR_Coverage, 15518,
     /* 1152063 */     GIR_EraseRootFromParent_Done,
     /* 1152064 */   // Label 16856: @1152064
     /* 1152064 */   GIM_Try, /*On fail goto*//*Label 16857*/ GIMT_Encode4(1152144), // Rule ID 15519 //
     /* 1152069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1152080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1152083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1152086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1152089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152108 */     // MIs[0] round
     /* 1152108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152143 */     // GIR_Coverage, 15519,
     /* 1152143 */     GIR_EraseRootFromParent_Done,
     /* 1152144 */   // Label 16857: @1152144
     /* 1152144 */   GIM_Try, /*On fail goto*//*Label 16858*/ GIMT_Encode4(1152224), // Rule ID 15522 //
     /* 1152149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1152160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1152163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1152166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1152169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152188 */     // MIs[0] round
     /* 1152188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152198 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152223 */     // GIR_Coverage, 15522,
     /* 1152223 */     GIR_EraseRootFromParent_Done,
     /* 1152224 */   // Label 16858: @1152224
     /* 1152224 */   GIM_Try, /*On fail goto*//*Label 16859*/ GIMT_Encode4(1152304), // Rule ID 15523 //
     /* 1152229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1152240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1152243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1152246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1152249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152268 */     // MIs[0] round
     /* 1152268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152278 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152303 */     // GIR_Coverage, 15523,
     /* 1152303 */     GIR_EraseRootFromParent_Done,
     /* 1152304 */   // Label 16859: @1152304
     /* 1152304 */   GIM_Try, /*On fail goto*//*Label 16860*/ GIMT_Encode4(1152384), // Rule ID 15526 //
     /* 1152309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1152320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1152323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1152326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1152329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152348 */     // MIs[0] round
     /* 1152348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152383 */     // GIR_Coverage, 15526,
     /* 1152383 */     GIR_EraseRootFromParent_Done,
     /* 1152384 */   // Label 16860: @1152384
     /* 1152384 */   GIM_Try, /*On fail goto*//*Label 16861*/ GIMT_Encode4(1152464), // Rule ID 15527 //
     /* 1152389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1152400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1152403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1152406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1152409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152428 */     // MIs[0] round
     /* 1152428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152463 */     // GIR_Coverage, 15527,
     /* 1152463 */     GIR_EraseRootFromParent_Done,
     /* 1152464 */   // Label 16861: @1152464
     /* 1152464 */   GIM_Try, /*On fail goto*//*Label 16862*/ GIMT_Encode4(1152544), // Rule ID 15530 //
     /* 1152469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1152480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1152483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1152486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1152489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152508 */     // MIs[0] round
     /* 1152508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152543 */     // GIR_Coverage, 15530,
     /* 1152543 */     GIR_EraseRootFromParent_Done,
     /* 1152544 */   // Label 16862: @1152544
     /* 1152544 */   GIM_Try, /*On fail goto*//*Label 16863*/ GIMT_Encode4(1152624), // Rule ID 15531 //
     /* 1152549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1152560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1152563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1152566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1152569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152588 */     // MIs[0] round
     /* 1152588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152623 */     // GIR_Coverage, 15531,
     /* 1152623 */     GIR_EraseRootFromParent_Done,
     /* 1152624 */   // Label 16863: @1152624
     /* 1152624 */   GIM_Try, /*On fail goto*//*Label 16864*/ GIMT_Encode4(1152704), // Rule ID 15534 //
     /* 1152629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1152640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1152643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1152646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1152649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152668 */     // MIs[0] round
     /* 1152668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152678 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152703 */     // GIR_Coverage, 15534,
     /* 1152703 */     GIR_EraseRootFromParent_Done,
     /* 1152704 */   // Label 16864: @1152704
     /* 1152704 */   GIM_Try, /*On fail goto*//*Label 16865*/ GIMT_Encode4(1152784), // Rule ID 15535 //
     /* 1152709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1152720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1152723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1152726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1152729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152748 */     // MIs[0] round
     /* 1152748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152758 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152783 */     // GIR_Coverage, 15535,
     /* 1152783 */     GIR_EraseRootFromParent_Done,
     /* 1152784 */   // Label 16865: @1152784
     /* 1152784 */   GIM_Try, /*On fail goto*//*Label 16866*/ GIMT_Encode4(1152864), // Rule ID 15538 //
     /* 1152789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1152792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1152800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1152803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1152806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1152809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152828 */     // MIs[0] round
     /* 1152828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152838 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152863 */     // GIR_Coverage, 15538,
     /* 1152863 */     GIR_EraseRootFromParent_Done,
     /* 1152864 */   // Label 16866: @1152864
     /* 1152864 */   GIM_Try, /*On fail goto*//*Label 16867*/ GIMT_Encode4(1152944), // Rule ID 15539 //
     /* 1152869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1152872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1152880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1152883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1152886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1152889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152908 */     // MIs[0] round
     /* 1152908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152918 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152943 */     // GIR_Coverage, 15539,
     /* 1152943 */     GIR_EraseRootFromParent_Done,
     /* 1152944 */   // Label 16867: @1152944
     /* 1152944 */   GIM_Try, /*On fail goto*//*Label 16868*/ GIMT_Encode4(1153024), // Rule ID 15542 //
     /* 1152949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1152952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1152960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1152963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1152966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1152969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152988 */     // MIs[0] round
     /* 1152988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152998 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1153001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153023 */     // GIR_Coverage, 15542,
     /* 1153023 */     GIR_EraseRootFromParent_Done,
     /* 1153024 */   // Label 16868: @1153024
     /* 1153024 */   GIM_Try, /*On fail goto*//*Label 16869*/ GIMT_Encode4(1153104), // Rule ID 15543 //
     /* 1153029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1153040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1153043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1153046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1153049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153068 */     // MIs[0] round
     /* 1153068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153078 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1153081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153103 */     // GIR_Coverage, 15543,
     /* 1153103 */     GIR_EraseRootFromParent_Done,
     /* 1153104 */   // Label 16869: @1153104
     /* 1153104 */   GIM_Try, /*On fail goto*//*Label 16870*/ GIMT_Encode4(1153184), // Rule ID 15546 //
     /* 1153109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1153112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1153120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1153123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1153126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1153129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153148 */     // MIs[0] round
     /* 1153148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1153161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153183 */     // GIR_Coverage, 15546,
     /* 1153183 */     GIR_EraseRootFromParent_Done,
     /* 1153184 */   // Label 16870: @1153184
     /* 1153184 */   GIM_Try, /*On fail goto*//*Label 16871*/ GIMT_Encode4(1153264), // Rule ID 15547 //
     /* 1153189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1153200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1153203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1153206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1153209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153228 */     // MIs[0] round
     /* 1153228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153238 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1153241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153263 */     // GIR_Coverage, 15547,
     /* 1153263 */     GIR_EraseRootFromParent_Done,
     /* 1153264 */   // Label 16871: @1153264
     /* 1153264 */   GIM_Try, /*On fail goto*//*Label 16872*/ GIMT_Encode4(1153344), // Rule ID 15550 //
     /* 1153269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1153280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1153283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1153286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153308 */     // MIs[0] round
     /* 1153308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153318 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1153321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153343 */     // GIR_Coverage, 15550,
     /* 1153343 */     GIR_EraseRootFromParent_Done,
     /* 1153344 */   // Label 16872: @1153344
     /* 1153344 */   GIM_Try, /*On fail goto*//*Label 16873*/ GIMT_Encode4(1153424), // Rule ID 15551 //
     /* 1153349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1153360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1153363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1153366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153388 */     // MIs[0] round
     /* 1153388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153398 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1153401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153423 */     // GIR_Coverage, 15551,
     /* 1153423 */     GIR_EraseRootFromParent_Done,
     /* 1153424 */   // Label 16873: @1153424
     /* 1153424 */   GIM_Try, /*On fail goto*//*Label 16874*/ GIMT_Encode4(1153504), // Rule ID 15554 //
     /* 1153429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1153440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1153443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1153446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153468 */     // MIs[0] round
     /* 1153468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153478 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153503 */     // GIR_Coverage, 15554,
     /* 1153503 */     GIR_EraseRootFromParent_Done,
     /* 1153504 */   // Label 16874: @1153504
     /* 1153504 */   GIM_Try, /*On fail goto*//*Label 16875*/ GIMT_Encode4(1153584), // Rule ID 15555 //
     /* 1153509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1153520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1153523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1153526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153548 */     // MIs[0] round
     /* 1153548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153558 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153583 */     // GIR_Coverage, 15555,
     /* 1153583 */     GIR_EraseRootFromParent_Done,
     /* 1153584 */   // Label 16875: @1153584
     /* 1153584 */   GIM_Try, /*On fail goto*//*Label 16876*/ GIMT_Encode4(1153664), // Rule ID 15558 //
     /* 1153589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1153600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1153603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1153606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153628 */     // MIs[0] round
     /* 1153628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153638 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1153641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153663 */     // GIR_Coverage, 15558,
     /* 1153663 */     GIR_EraseRootFromParent_Done,
     /* 1153664 */   // Label 16876: @1153664
     /* 1153664 */   GIM_Try, /*On fail goto*//*Label 16877*/ GIMT_Encode4(1153744), // Rule ID 15559 //
     /* 1153669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1153680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1153683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1153686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153708 */     // MIs[0] round
     /* 1153708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153718 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1153721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153743 */     // GIR_Coverage, 15559,
     /* 1153743 */     GIR_EraseRootFromParent_Done,
     /* 1153744 */   // Label 16877: @1153744
     /* 1153744 */   GIM_Try, /*On fail goto*//*Label 16878*/ GIMT_Encode4(1153824), // Rule ID 15562 //
     /* 1153749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1153760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1153763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1153766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153788 */     // MIs[0] round
     /* 1153788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153798 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153823 */     // GIR_Coverage, 15562,
     /* 1153823 */     GIR_EraseRootFromParent_Done,
     /* 1153824 */   // Label 16878: @1153824
     /* 1153824 */   GIM_Try, /*On fail goto*//*Label 16879*/ GIMT_Encode4(1153904), // Rule ID 15563 //
     /* 1153829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1153840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1153843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1153846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153868 */     // MIs[0] round
     /* 1153868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153878 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153903 */     // GIR_Coverage, 15563,
     /* 1153903 */     GIR_EraseRootFromParent_Done,
     /* 1153904 */   // Label 16879: @1153904
     /* 1153904 */   GIM_Try, /*On fail goto*//*Label 16880*/ GIMT_Encode4(1153984), // Rule ID 15566 //
     /* 1153909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1153920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1153923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1153926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153948 */     // MIs[0] round
     /* 1153948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1153961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153983 */     // GIR_Coverage, 15566,
     /* 1153983 */     GIR_EraseRootFromParent_Done,
     /* 1153984 */   // Label 16880: @1153984
     /* 1153984 */   GIM_Try, /*On fail goto*//*Label 16881*/ GIMT_Encode4(1154064), // Rule ID 15567 //
     /* 1153989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1154000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1154003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1154006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154028 */     // MIs[0] round
     /* 1154028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154038 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154063 */     // GIR_Coverage, 15567,
     /* 1154063 */     GIR_EraseRootFromParent_Done,
     /* 1154064 */   // Label 16881: @1154064
     /* 1154064 */   GIM_Try, /*On fail goto*//*Label 16882*/ GIMT_Encode4(1154144), // Rule ID 15570 //
     /* 1154069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1154080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1154083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1154086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154108 */     // MIs[0] round
     /* 1154108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154118 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154143 */     // GIR_Coverage, 15570,
     /* 1154143 */     GIR_EraseRootFromParent_Done,
     /* 1154144 */   // Label 16882: @1154144
     /* 1154144 */   GIM_Try, /*On fail goto*//*Label 16883*/ GIMT_Encode4(1154224), // Rule ID 15571 //
     /* 1154149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1154160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1154163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1154166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154188 */     // MIs[0] round
     /* 1154188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154198 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154223 */     // GIR_Coverage, 15571,
     /* 1154223 */     GIR_EraseRootFromParent_Done,
     /* 1154224 */   // Label 16883: @1154224
     /* 1154224 */   GIM_Try, /*On fail goto*//*Label 16884*/ GIMT_Encode4(1154304), // Rule ID 15574 //
     /* 1154229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1154240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1154243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1154246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154268 */     // MIs[0] round
     /* 1154268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154278 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154303 */     // GIR_Coverage, 15574,
     /* 1154303 */     GIR_EraseRootFromParent_Done,
     /* 1154304 */   // Label 16884: @1154304
     /* 1154304 */   GIM_Try, /*On fail goto*//*Label 16885*/ GIMT_Encode4(1154384), // Rule ID 15575 //
     /* 1154309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1154320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1154323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1154326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154348 */     // MIs[0] round
     /* 1154348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154383 */     // GIR_Coverage, 15575,
     /* 1154383 */     GIR_EraseRootFromParent_Done,
     /* 1154384 */   // Label 16885: @1154384
     /* 1154384 */   GIM_Try, /*On fail goto*//*Label 16886*/ GIMT_Encode4(1154464), // Rule ID 15578 //
     /* 1154389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1154400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1154403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1154406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154428 */     // MIs[0] round
     /* 1154428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154438 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154463 */     // GIR_Coverage, 15578,
     /* 1154463 */     GIR_EraseRootFromParent_Done,
     /* 1154464 */   // Label 16886: @1154464
     /* 1154464 */   GIM_Try, /*On fail goto*//*Label 16887*/ GIMT_Encode4(1154544), // Rule ID 15579 //
     /* 1154469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1154480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1154483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1154486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154508 */     // MIs[0] round
     /* 1154508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154543 */     // GIR_Coverage, 15579,
     /* 1154543 */     GIR_EraseRootFromParent_Done,
     /* 1154544 */   // Label 16887: @1154544
     /* 1154544 */   GIM_Try, /*On fail goto*//*Label 16888*/ GIMT_Encode4(1154624), // Rule ID 15582 //
     /* 1154549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1154560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1154563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1154566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154588 */     // MIs[0] round
     /* 1154588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154598 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154623 */     // GIR_Coverage, 15582,
     /* 1154623 */     GIR_EraseRootFromParent_Done,
     /* 1154624 */   // Label 16888: @1154624
     /* 1154624 */   GIM_Try, /*On fail goto*//*Label 16889*/ GIMT_Encode4(1154704), // Rule ID 15583 //
     /* 1154629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1154640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1154643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1154646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154668 */     // MIs[0] round
     /* 1154668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154703 */     // GIR_Coverage, 15583,
     /* 1154703 */     GIR_EraseRootFromParent_Done,
     /* 1154704 */   // Label 16889: @1154704
     /* 1154704 */   GIM_Try, /*On fail goto*//*Label 16890*/ GIMT_Encode4(1154784), // Rule ID 15586 //
     /* 1154709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1154712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1154720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1154723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1154726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154748 */     // MIs[0] round
     /* 1154748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154758 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1154779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154783 */     // GIR_Coverage, 15586,
     /* 1154783 */     GIR_EraseRootFromParent_Done,
     /* 1154784 */   // Label 16890: @1154784
     /* 1154784 */   GIM_Try, /*On fail goto*//*Label 16891*/ GIMT_Encode4(1154864), // Rule ID 15587 //
     /* 1154789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1154792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1154800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1154803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1154806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154828 */     // MIs[0] round
     /* 1154828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154838 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1154859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154863 */     // GIR_Coverage, 15587,
     /* 1154863 */     GIR_EraseRootFromParent_Done,
     /* 1154864 */   // Label 16891: @1154864
     /* 1154864 */   GIM_Try, /*On fail goto*//*Label 16892*/ GIMT_Encode4(1154944), // Rule ID 15590 //
     /* 1154869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1154880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1154883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1154886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154908 */     // MIs[0] round
     /* 1154908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154918 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1154921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154943 */     // GIR_Coverage, 15590,
     /* 1154943 */     GIR_EraseRootFromParent_Done,
     /* 1154944 */   // Label 16892: @1154944
     /* 1154944 */   GIM_Try, /*On fail goto*//*Label 16893*/ GIMT_Encode4(1155024), // Rule ID 15591 //
     /* 1154949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1154960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1154963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1154966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154988 */     // MIs[0] round
     /* 1154988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154998 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155023 */     // GIR_Coverage, 15591,
     /* 1155023 */     GIR_EraseRootFromParent_Done,
     /* 1155024 */   // Label 16893: @1155024
     /* 1155024 */   GIM_Try, /*On fail goto*//*Label 16894*/ GIMT_Encode4(1155104), // Rule ID 15594 //
     /* 1155029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1155040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1155043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1155046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155068 */     // MIs[0] round
     /* 1155068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155078 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155103 */     // GIR_Coverage, 15594,
     /* 1155103 */     GIR_EraseRootFromParent_Done,
     /* 1155104 */   // Label 16894: @1155104
     /* 1155104 */   GIM_Try, /*On fail goto*//*Label 16895*/ GIMT_Encode4(1155184), // Rule ID 15595 //
     /* 1155109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1155120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1155123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1155126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155148 */     // MIs[0] round
     /* 1155148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155158 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155183 */     // GIR_Coverage, 15595,
     /* 1155183 */     GIR_EraseRootFromParent_Done,
     /* 1155184 */   // Label 16895: @1155184
     /* 1155184 */   GIM_Try, /*On fail goto*//*Label 16896*/ GIMT_Encode4(1155264), // Rule ID 15598 //
     /* 1155189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1155200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1155203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1155206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155228 */     // MIs[0] round
     /* 1155228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155238 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155263 */     // GIR_Coverage, 15598,
     /* 1155263 */     GIR_EraseRootFromParent_Done,
     /* 1155264 */   // Label 16896: @1155264
     /* 1155264 */   GIM_Try, /*On fail goto*//*Label 16897*/ GIMT_Encode4(1155344), // Rule ID 15599 //
     /* 1155269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1155280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1155283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1155286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155308 */     // MIs[0] round
     /* 1155308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155318 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155343 */     // GIR_Coverage, 15599,
     /* 1155343 */     GIR_EraseRootFromParent_Done,
     /* 1155344 */   // Label 16897: @1155344
     /* 1155344 */   GIM_Try, /*On fail goto*//*Label 16898*/ GIMT_Encode4(1155424), // Rule ID 15602 //
     /* 1155349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1155360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1155363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1155366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155388 */     // MIs[0] round
     /* 1155388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155398 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155423 */     // GIR_Coverage, 15602,
     /* 1155423 */     GIR_EraseRootFromParent_Done,
     /* 1155424 */   // Label 16898: @1155424
     /* 1155424 */   GIM_Try, /*On fail goto*//*Label 16899*/ GIMT_Encode4(1155504), // Rule ID 15603 //
     /* 1155429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1155440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1155443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1155446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155468 */     // MIs[0] round
     /* 1155468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155478 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155503 */     // GIR_Coverage, 15603,
     /* 1155503 */     GIR_EraseRootFromParent_Done,
     /* 1155504 */   // Label 16899: @1155504
     /* 1155504 */   GIM_Try, /*On fail goto*//*Label 16900*/ GIMT_Encode4(1155584), // Rule ID 15606 //
     /* 1155509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1155520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1155523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1155526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155548 */     // MIs[0] round
     /* 1155548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155558 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155583 */     // GIR_Coverage, 15606,
     /* 1155583 */     GIR_EraseRootFromParent_Done,
     /* 1155584 */   // Label 16900: @1155584
     /* 1155584 */   GIM_Try, /*On fail goto*//*Label 16901*/ GIMT_Encode4(1155664), // Rule ID 15607 //
     /* 1155589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1155600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1155603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1155606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155628 */     // MIs[0] round
     /* 1155628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155638 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155663 */     // GIR_Coverage, 15607,
     /* 1155663 */     GIR_EraseRootFromParent_Done,
     /* 1155664 */   // Label 16901: @1155664
     /* 1155664 */   GIM_Try, /*On fail goto*//*Label 16902*/ GIMT_Encode4(1155744), // Rule ID 15610 //
     /* 1155669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1155680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1155683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1155686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155708 */     // MIs[0] round
     /* 1155708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155718 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155743 */     // GIR_Coverage, 15610,
     /* 1155743 */     GIR_EraseRootFromParent_Done,
     /* 1155744 */   // Label 16902: @1155744
     /* 1155744 */   GIM_Try, /*On fail goto*//*Label 16903*/ GIMT_Encode4(1155824), // Rule ID 15611 //
     /* 1155749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1155760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1155763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1155766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155788 */     // MIs[0] round
     /* 1155788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155798 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155823 */     // GIR_Coverage, 15611,
     /* 1155823 */     GIR_EraseRootFromParent_Done,
     /* 1155824 */   // Label 16903: @1155824
     /* 1155824 */   GIM_Try, /*On fail goto*//*Label 16904*/ GIMT_Encode4(1155904), // Rule ID 15614 //
     /* 1155829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1155840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1155843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1155846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155868 */     // MIs[0] round
     /* 1155868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155903 */     // GIR_Coverage, 15614,
     /* 1155903 */     GIR_EraseRootFromParent_Done,
     /* 1155904 */   // Label 16904: @1155904
     /* 1155904 */   GIM_Try, /*On fail goto*//*Label 16905*/ GIMT_Encode4(1155984), // Rule ID 15615 //
     /* 1155909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1155920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1155923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1155926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155948 */     // MIs[0] round
     /* 1155948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155983 */     // GIR_Coverage, 15615,
     /* 1155983 */     GIR_EraseRootFromParent_Done,
     /* 1155984 */   // Label 16905: @1155984
     /* 1155984 */   GIM_Try, /*On fail goto*//*Label 16906*/ GIMT_Encode4(1156064), // Rule ID 15618 //
     /* 1155989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1156000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1156003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1156006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156028 */     // MIs[0] round
     /* 1156028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156038 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156063 */     // GIR_Coverage, 15618,
     /* 1156063 */     GIR_EraseRootFromParent_Done,
     /* 1156064 */   // Label 16906: @1156064
     /* 1156064 */   GIM_Try, /*On fail goto*//*Label 16907*/ GIMT_Encode4(1156144), // Rule ID 15619 //
     /* 1156069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1156080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1156083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1156086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156108 */     // MIs[0] round
     /* 1156108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156143 */     // GIR_Coverage, 15619,
     /* 1156143 */     GIR_EraseRootFromParent_Done,
     /* 1156144 */   // Label 16907: @1156144
     /* 1156144 */   GIM_Try, /*On fail goto*//*Label 16908*/ GIMT_Encode4(1156224), // Rule ID 15622 //
     /* 1156149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1156160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1156163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1156166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156188 */     // MIs[0] round
     /* 1156188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156223 */     // GIR_Coverage, 15622,
     /* 1156223 */     GIR_EraseRootFromParent_Done,
     /* 1156224 */   // Label 16908: @1156224
     /* 1156224 */   GIM_Try, /*On fail goto*//*Label 16909*/ GIMT_Encode4(1156304), // Rule ID 15623 //
     /* 1156229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1156240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1156243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1156246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156268 */     // MIs[0] round
     /* 1156268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156278 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156303 */     // GIR_Coverage, 15623,
     /* 1156303 */     GIR_EraseRootFromParent_Done,
     /* 1156304 */   // Label 16909: @1156304
     /* 1156304 */   GIM_Try, /*On fail goto*//*Label 16910*/ GIMT_Encode4(1156384), // Rule ID 15626 //
     /* 1156309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1156320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1156323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1156326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156348 */     // MIs[0] round
     /* 1156348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156383 */     // GIR_Coverage, 15626,
     /* 1156383 */     GIR_EraseRootFromParent_Done,
     /* 1156384 */   // Label 16910: @1156384
     /* 1156384 */   GIM_Try, /*On fail goto*//*Label 16911*/ GIMT_Encode4(1156464), // Rule ID 15627 //
     /* 1156389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1156392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1156400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1156403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1156406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156428 */     // MIs[0] round
     /* 1156428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156438 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156463 */     // GIR_Coverage, 15627,
     /* 1156463 */     GIR_EraseRootFromParent_Done,
     /* 1156464 */   // Label 16911: @1156464
     /* 1156464 */   GIM_Try, /*On fail goto*//*Label 16912*/ GIMT_Encode4(1156544), // Rule ID 15630 //
     /* 1156469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1156480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1156483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1156486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156508 */     // MIs[0] round
     /* 1156508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156543 */     // GIR_Coverage, 15630,
     /* 1156543 */     GIR_EraseRootFromParent_Done,
     /* 1156544 */   // Label 16912: @1156544
     /* 1156544 */   GIM_Try, /*On fail goto*//*Label 16913*/ GIMT_Encode4(1156624), // Rule ID 15631 //
     /* 1156549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1156552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1156560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1156563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1156566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156588 */     // MIs[0] round
     /* 1156588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156598 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156623 */     // GIR_Coverage, 15631,
     /* 1156623 */     GIR_EraseRootFromParent_Done,
     /* 1156624 */   // Label 16913: @1156624
     /* 1156624 */   GIM_Try, /*On fail goto*//*Label 16914*/ GIMT_Encode4(1156704), // Rule ID 15634 //
     /* 1156629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1156640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1156643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1156646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156668 */     // MIs[0] round
     /* 1156668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156678 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156703 */     // GIR_Coverage, 15634,
     /* 1156703 */     GIR_EraseRootFromParent_Done,
     /* 1156704 */   // Label 16914: @1156704
     /* 1156704 */   GIM_Try, /*On fail goto*//*Label 16915*/ GIMT_Encode4(1156784), // Rule ID 15635 //
     /* 1156709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1156712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1156720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1156723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1156726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156748 */     // MIs[0] round
     /* 1156748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156758 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156783 */     // GIR_Coverage, 15635,
     /* 1156783 */     GIR_EraseRootFromParent_Done,
     /* 1156784 */   // Label 16915: @1156784
     /* 1156784 */   GIM_Try, /*On fail goto*//*Label 16916*/ GIMT_Encode4(1156867), // Rule ID 15638 //
     /* 1156789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1156800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1156803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1156806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1156809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156828 */     // MIs[0] round
     /* 1156828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156838 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1156841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156866 */     // GIR_Coverage, 15638,
     /* 1156866 */     GIR_EraseRootFromParent_Done,
     /* 1156867 */   // Label 16916: @1156867
     /* 1156867 */   GIM_Try, /*On fail goto*//*Label 16917*/ GIMT_Encode4(1156950), // Rule ID 15639 //
     /* 1156872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1156883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1156886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1156889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1156892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156911 */     // MIs[0] round
     /* 1156911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156921 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1156924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156932 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156949 */     // GIR_Coverage, 15639,
     /* 1156949 */     GIR_EraseRootFromParent_Done,
     /* 1156950 */   // Label 16917: @1156950
     /* 1156950 */   GIM_Try, /*On fail goto*//*Label 16918*/ GIMT_Encode4(1157033), // Rule ID 15642 //
     /* 1156955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1156966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1156969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1156972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1156975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156994 */     // MIs[0] round
     /* 1156994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157004 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157032 */     // GIR_Coverage, 15642,
     /* 1157032 */     GIR_EraseRootFromParent_Done,
     /* 1157033 */   // Label 16918: @1157033
     /* 1157033 */   GIM_Try, /*On fail goto*//*Label 16919*/ GIMT_Encode4(1157116), // Rule ID 15643 //
     /* 1157038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1157049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1157052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1157055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1157058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157077 */     // MIs[0] round
     /* 1157077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157087 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157098 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157115 */     // GIR_Coverage, 15643,
     /* 1157115 */     GIR_EraseRootFromParent_Done,
     /* 1157116 */   // Label 16919: @1157116
     /* 1157116 */   GIM_Try, /*On fail goto*//*Label 16920*/ GIMT_Encode4(1157199), // Rule ID 15646 //
     /* 1157121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1157132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1157135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1157138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1157141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157160 */     // MIs[0] round
     /* 1157160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157170 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157198 */     // GIR_Coverage, 15646,
     /* 1157198 */     GIR_EraseRootFromParent_Done,
     /* 1157199 */   // Label 16920: @1157199
     /* 1157199 */   GIM_Try, /*On fail goto*//*Label 16921*/ GIMT_Encode4(1157282), // Rule ID 15647 //
     /* 1157204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1157215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1157218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1157221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1157224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157243 */     // MIs[0] round
     /* 1157243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157253 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157264 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157281 */     // GIR_Coverage, 15647,
     /* 1157281 */     GIR_EraseRootFromParent_Done,
     /* 1157282 */   // Label 16921: @1157282
     /* 1157282 */   GIM_Try, /*On fail goto*//*Label 16922*/ GIMT_Encode4(1157365), // Rule ID 15650 //
     /* 1157287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1157298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1157301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1157304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1157307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157326 */     // MIs[0] round
     /* 1157326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157336 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157364 */     // GIR_Coverage, 15650,
     /* 1157364 */     GIR_EraseRootFromParent_Done,
     /* 1157365 */   // Label 16922: @1157365
     /* 1157365 */   GIM_Try, /*On fail goto*//*Label 16923*/ GIMT_Encode4(1157448), // Rule ID 15651 //
     /* 1157370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1157381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1157384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1157387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1157390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157409 */     // MIs[0] round
     /* 1157409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157419 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157447 */     // GIR_Coverage, 15651,
     /* 1157447 */     GIR_EraseRootFromParent_Done,
     /* 1157448 */   // Label 16923: @1157448
     /* 1157448 */   GIM_Try, /*On fail goto*//*Label 16924*/ GIMT_Encode4(1157531), // Rule ID 15654 //
     /* 1157453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1157464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1157467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1157470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1157473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157492 */     // MIs[0] round
     /* 1157492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157502 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157530 */     // GIR_Coverage, 15654,
     /* 1157530 */     GIR_EraseRootFromParent_Done,
     /* 1157531 */   // Label 16924: @1157531
     /* 1157531 */   GIM_Try, /*On fail goto*//*Label 16925*/ GIMT_Encode4(1157614), // Rule ID 15655 //
     /* 1157536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1157547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1157550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1157553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1157556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157575 */     // MIs[0] round
     /* 1157575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157585 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157596 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157609 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157613 */     // GIR_Coverage, 15655,
     /* 1157613 */     GIR_EraseRootFromParent_Done,
     /* 1157614 */   // Label 16925: @1157614
     /* 1157614 */   GIM_Try, /*On fail goto*//*Label 16926*/ GIMT_Encode4(1157697), // Rule ID 15658 //
     /* 1157619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1157630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1157633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1157636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1157639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157658 */     // MIs[0] round
     /* 1157658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157696 */     // GIR_Coverage, 15658,
     /* 1157696 */     GIR_EraseRootFromParent_Done,
     /* 1157697 */   // Label 16926: @1157697
     /* 1157697 */   GIM_Try, /*On fail goto*//*Label 16927*/ GIMT_Encode4(1157780), // Rule ID 15659 //
     /* 1157702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1157713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1157716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1157719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1157722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157741 */     // MIs[0] round
     /* 1157741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157751 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157762 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157779 */     // GIR_Coverage, 15659,
     /* 1157779 */     GIR_EraseRootFromParent_Done,
     /* 1157780 */   // Label 16927: @1157780
     /* 1157780 */   GIM_Try, /*On fail goto*//*Label 16928*/ GIMT_Encode4(1157863), // Rule ID 15662 //
     /* 1157785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1157796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1157799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1157802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1157805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157824 */     // MIs[0] round
     /* 1157824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157834 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1157837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157862 */     // GIR_Coverage, 15662,
     /* 1157862 */     GIR_EraseRootFromParent_Done,
     /* 1157863 */   // Label 16928: @1157863
     /* 1157863 */   GIM_Try, /*On fail goto*//*Label 16929*/ GIMT_Encode4(1157946), // Rule ID 15663 //
     /* 1157868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1157879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1157882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1157885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1157888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157907 */     // MIs[0] round
     /* 1157907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157917 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1157920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157928 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157945 */     // GIR_Coverage, 15663,
     /* 1157945 */     GIR_EraseRootFromParent_Done,
     /* 1157946 */   // Label 16929: @1157946
     /* 1157946 */   GIM_Try, /*On fail goto*//*Label 16930*/ GIMT_Encode4(1158029), // Rule ID 15666 //
     /* 1157951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1157962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1157965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1157968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1157971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157990 */     // MIs[0] round
     /* 1157990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158000 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158028 */     // GIR_Coverage, 15666,
     /* 1158028 */     GIR_EraseRootFromParent_Done,
     /* 1158029 */   // Label 16930: @1158029
     /* 1158029 */   GIM_Try, /*On fail goto*//*Label 16931*/ GIMT_Encode4(1158112), // Rule ID 15667 //
     /* 1158034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1158045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1158048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1158051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1158054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158073 */     // MIs[0] round
     /* 1158073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158083 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158094 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158111 */     // GIR_Coverage, 15667,
     /* 1158111 */     GIR_EraseRootFromParent_Done,
     /* 1158112 */   // Label 16931: @1158112
     /* 1158112 */   GIM_Try, /*On fail goto*//*Label 16932*/ GIMT_Encode4(1158195), // Rule ID 15670 //
     /* 1158117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1158128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1158131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1158134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1158137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158156 */     // MIs[0] round
     /* 1158156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158194 */     // GIR_Coverage, 15670,
     /* 1158194 */     GIR_EraseRootFromParent_Done,
     /* 1158195 */   // Label 16932: @1158195
     /* 1158195 */   GIM_Try, /*On fail goto*//*Label 16933*/ GIMT_Encode4(1158278), // Rule ID 15671 //
     /* 1158200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1158211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1158214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1158217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1158220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158239 */     // MIs[0] round
     /* 1158239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158249 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158260 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158277 */     // GIR_Coverage, 15671,
     /* 1158277 */     GIR_EraseRootFromParent_Done,
     /* 1158278 */   // Label 16933: @1158278
     /* 1158278 */   GIM_Try, /*On fail goto*//*Label 16934*/ GIMT_Encode4(1158361), // Rule ID 15674 //
     /* 1158283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1158294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1158297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1158300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1158303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158322 */     // MIs[0] round
     /* 1158322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158332 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158360 */     // GIR_Coverage, 15674,
     /* 1158360 */     GIR_EraseRootFromParent_Done,
     /* 1158361 */   // Label 16934: @1158361
     /* 1158361 */   GIM_Try, /*On fail goto*//*Label 16935*/ GIMT_Encode4(1158444), // Rule ID 15675 //
     /* 1158366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1158377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1158380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1158383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1158386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158405 */     // MIs[0] round
     /* 1158405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158415 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158426 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158443 */     // GIR_Coverage, 15675,
     /* 1158443 */     GIR_EraseRootFromParent_Done,
     /* 1158444 */   // Label 16935: @1158444
     /* 1158444 */   GIM_Try, /*On fail goto*//*Label 16936*/ GIMT_Encode4(1158527), // Rule ID 15678 //
     /* 1158449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1158460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1158463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1158466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1158469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158488 */     // MIs[0] round
     /* 1158488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158498 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158526 */     // GIR_Coverage, 15678,
     /* 1158526 */     GIR_EraseRootFromParent_Done,
     /* 1158527 */   // Label 16936: @1158527
     /* 1158527 */   GIM_Try, /*On fail goto*//*Label 16937*/ GIMT_Encode4(1158610), // Rule ID 15679 //
     /* 1158532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1158543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1158546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1158549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1158552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158571 */     // MIs[0] round
     /* 1158571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158581 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158592 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158609 */     // GIR_Coverage, 15679,
     /* 1158609 */     GIR_EraseRootFromParent_Done,
     /* 1158610 */   // Label 16937: @1158610
     /* 1158610 */   GIM_Try, /*On fail goto*//*Label 16938*/ GIMT_Encode4(1158693), // Rule ID 15682 //
     /* 1158615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1158626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1158629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1158632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1158635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158654 */     // MIs[0] round
     /* 1158654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158664 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1158667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158692 */     // GIR_Coverage, 15682,
     /* 1158692 */     GIR_EraseRootFromParent_Done,
     /* 1158693 */   // Label 16938: @1158693
     /* 1158693 */   GIM_Try, /*On fail goto*//*Label 16939*/ GIMT_Encode4(1158776), // Rule ID 15683 //
     /* 1158698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1158709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1158712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1158715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1158718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158737 */     // MIs[0] round
     /* 1158737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158747 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1158750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158758 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158775 */     // GIR_Coverage, 15683,
     /* 1158775 */     GIR_EraseRootFromParent_Done,
     /* 1158776 */   // Label 16939: @1158776
     /* 1158776 */   GIM_Try, /*On fail goto*//*Label 16940*/ GIMT_Encode4(1158859), // Rule ID 15686 //
     /* 1158781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1158792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1158795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1158798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1158801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158820 */     // MIs[0] round
     /* 1158820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158830 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158858 */     // GIR_Coverage, 15686,
     /* 1158858 */     GIR_EraseRootFromParent_Done,
     /* 1158859 */   // Label 16940: @1158859
     /* 1158859 */   GIM_Try, /*On fail goto*//*Label 16941*/ GIMT_Encode4(1158942), // Rule ID 15687 //
     /* 1158864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1158875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1158878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1158881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1158884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158903 */     // MIs[0] round
     /* 1158903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158913 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158924 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158941 */     // GIR_Coverage, 15687,
     /* 1158941 */     GIR_EraseRootFromParent_Done,
     /* 1158942 */   // Label 16941: @1158942
     /* 1158942 */   GIM_Try, /*On fail goto*//*Label 16942*/ GIMT_Encode4(1159025), // Rule ID 15690 //
     /* 1158947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1158958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1158961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1158964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1158967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158986 */     // MIs[0] round
     /* 1158986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159024 */     // GIR_Coverage, 15690,
     /* 1159024 */     GIR_EraseRootFromParent_Done,
     /* 1159025 */   // Label 16942: @1159025
     /* 1159025 */   GIM_Try, /*On fail goto*//*Label 16943*/ GIMT_Encode4(1159108), // Rule ID 15691 //
     /* 1159030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1159041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1159044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1159047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1159050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159069 */     // MIs[0] round
     /* 1159069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159079 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159090 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159107 */     // GIR_Coverage, 15691,
     /* 1159107 */     GIR_EraseRootFromParent_Done,
     /* 1159108 */   // Label 16943: @1159108
     /* 1159108 */   GIM_Try, /*On fail goto*//*Label 16944*/ GIMT_Encode4(1159191), // Rule ID 15694 //
     /* 1159113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1159124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1159127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1159130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1159133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159152 */     // MIs[0] round
     /* 1159152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159162 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159190 */     // GIR_Coverage, 15694,
     /* 1159190 */     GIR_EraseRootFromParent_Done,
     /* 1159191 */   // Label 16944: @1159191
     /* 1159191 */   GIM_Try, /*On fail goto*//*Label 16945*/ GIMT_Encode4(1159274), // Rule ID 15695 //
     /* 1159196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1159207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1159210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1159213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1159216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159235 */     // MIs[0] round
     /* 1159235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159245 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159256 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159273 */     // GIR_Coverage, 15695,
     /* 1159273 */     GIR_EraseRootFromParent_Done,
     /* 1159274 */   // Label 16945: @1159274
     /* 1159274 */   GIM_Try, /*On fail goto*//*Label 16946*/ GIMT_Encode4(1159357), // Rule ID 15698 //
     /* 1159279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1159290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1159293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1159296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1159299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159318 */     // MIs[0] round
     /* 1159318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159356 */     // GIR_Coverage, 15698,
     /* 1159356 */     GIR_EraseRootFromParent_Done,
     /* 1159357 */   // Label 16946: @1159357
     /* 1159357 */   GIM_Try, /*On fail goto*//*Label 16947*/ GIMT_Encode4(1159440), // Rule ID 15699 //
     /* 1159362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1159373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1159376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1159379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1159382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159401 */     // MIs[0] round
     /* 1159401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159411 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159422 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159439 */     // GIR_Coverage, 15699,
     /* 1159439 */     GIR_EraseRootFromParent_Done,
     /* 1159440 */   // Label 16947: @1159440
     /* 1159440 */   GIM_Try, /*On fail goto*//*Label 16948*/ GIMT_Encode4(1159523), // Rule ID 15702 //
     /* 1159445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1159456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1159459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1159462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1159465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159484 */     // MIs[0] round
     /* 1159484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159522 */     // GIR_Coverage, 15702,
     /* 1159522 */     GIR_EraseRootFromParent_Done,
     /* 1159523 */   // Label 16948: @1159523
     /* 1159523 */   GIM_Try, /*On fail goto*//*Label 16949*/ GIMT_Encode4(1159606), // Rule ID 15703 //
     /* 1159528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1159539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1159542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1159545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1159548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159567 */     // MIs[0] round
     /* 1159567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159577 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159588 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159605 */     // GIR_Coverage, 15703,
     /* 1159605 */     GIR_EraseRootFromParent_Done,
     /* 1159606 */   // Label 16949: @1159606
     /* 1159606 */   GIM_Try, /*On fail goto*//*Label 16950*/ GIMT_Encode4(1159689), // Rule ID 15706 //
     /* 1159611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1159622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1159625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1159628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1159631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159650 */     // MIs[0] round
     /* 1159650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159660 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159688 */     // GIR_Coverage, 15706,
     /* 1159688 */     GIR_EraseRootFromParent_Done,
     /* 1159689 */   // Label 16950: @1159689
     /* 1159689 */   GIM_Try, /*On fail goto*//*Label 16951*/ GIMT_Encode4(1159772), // Rule ID 15707 //
     /* 1159694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1159705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1159708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1159711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1159714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159733 */     // MIs[0] round
     /* 1159733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159743 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159754 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159771 */     // GIR_Coverage, 15707,
     /* 1159771 */     GIR_EraseRootFromParent_Done,
     /* 1159772 */   // Label 16951: @1159772
     /* 1159772 */   GIM_Try, /*On fail goto*//*Label 16952*/ GIMT_Encode4(1159855), // Rule ID 15710 //
     /* 1159777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1159788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1159791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1159794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159816 */     // MIs[0] round
     /* 1159816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159826 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1159829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159854 */     // GIR_Coverage, 15710,
     /* 1159854 */     GIR_EraseRootFromParent_Done,
     /* 1159855 */   // Label 16952: @1159855
     /* 1159855 */   GIM_Try, /*On fail goto*//*Label 16953*/ GIMT_Encode4(1159938), // Rule ID 15711 //
     /* 1159860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1159871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1159874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1159877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159899 */     // MIs[0] round
     /* 1159899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159909 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1159912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159920 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159937 */     // GIR_Coverage, 15711,
     /* 1159937 */     GIR_EraseRootFromParent_Done,
     /* 1159938 */   // Label 16953: @1159938
     /* 1159938 */   GIM_Try, /*On fail goto*//*Label 16954*/ GIMT_Encode4(1160021), // Rule ID 15714 //
     /* 1159943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1159954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1159957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1159960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159982 */     // MIs[0] round
     /* 1159982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159992 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1159995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160020 */     // GIR_Coverage, 15714,
     /* 1160020 */     GIR_EraseRootFromParent_Done,
     /* 1160021 */   // Label 16954: @1160021
     /* 1160021 */   GIM_Try, /*On fail goto*//*Label 16955*/ GIMT_Encode4(1160104), // Rule ID 15715 //
     /* 1160026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1160037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1160040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1160043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160065 */     // MIs[0] round
     /* 1160065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160075 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160103 */     // GIR_Coverage, 15715,
     /* 1160103 */     GIR_EraseRootFromParent_Done,
     /* 1160104 */   // Label 16955: @1160104
     /* 1160104 */   GIM_Try, /*On fail goto*//*Label 16956*/ GIMT_Encode4(1160187), // Rule ID 15718 //
     /* 1160109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1160120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1160123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1160126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160148 */     // MIs[0] round
     /* 1160148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160158 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160186 */     // GIR_Coverage, 15718,
     /* 1160186 */     GIR_EraseRootFromParent_Done,
     /* 1160187 */   // Label 16956: @1160187
     /* 1160187 */   GIM_Try, /*On fail goto*//*Label 16957*/ GIMT_Encode4(1160270), // Rule ID 15719 //
     /* 1160192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1160203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1160206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1160209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160231 */     // MIs[0] round
     /* 1160231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160241 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160252 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160269 */     // GIR_Coverage, 15719,
     /* 1160269 */     GIR_EraseRootFromParent_Done,
     /* 1160270 */   // Label 16957: @1160270
     /* 1160270 */   GIM_Try, /*On fail goto*//*Label 16958*/ GIMT_Encode4(1160353), // Rule ID 15722 //
     /* 1160275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1160286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1160289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1160292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160314 */     // MIs[0] round
     /* 1160314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160324 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160352 */     // GIR_Coverage, 15722,
     /* 1160352 */     GIR_EraseRootFromParent_Done,
     /* 1160353 */   // Label 16958: @1160353
     /* 1160353 */   GIM_Try, /*On fail goto*//*Label 16959*/ GIMT_Encode4(1160436), // Rule ID 15723 //
     /* 1160358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1160369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1160372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1160375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160397 */     // MIs[0] round
     /* 1160397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160407 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160418 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160435 */     // GIR_Coverage, 15723,
     /* 1160435 */     GIR_EraseRootFromParent_Done,
     /* 1160436 */   // Label 16959: @1160436
     /* 1160436 */   GIM_Try, /*On fail goto*//*Label 16960*/ GIMT_Encode4(1160519), // Rule ID 15726 //
     /* 1160441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1160452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1160455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1160458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160480 */     // MIs[0] round
     /* 1160480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160490 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160518 */     // GIR_Coverage, 15726,
     /* 1160518 */     GIR_EraseRootFromParent_Done,
     /* 1160519 */   // Label 16960: @1160519
     /* 1160519 */   GIM_Try, /*On fail goto*//*Label 16961*/ GIMT_Encode4(1160602), // Rule ID 15727 //
     /* 1160524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1160535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1160538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1160541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160563 */     // MIs[0] round
     /* 1160563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160573 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160584 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160601 */     // GIR_Coverage, 15727,
     /* 1160601 */     GIR_EraseRootFromParent_Done,
     /* 1160602 */   // Label 16961: @1160602
     /* 1160602 */   GIM_Try, /*On fail goto*//*Label 16962*/ GIMT_Encode4(1160685), // Rule ID 15730 //
     /* 1160607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1160618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1160621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1160624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160646 */     // MIs[0] round
     /* 1160646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160656 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160684 */     // GIR_Coverage, 15730,
     /* 1160684 */     GIR_EraseRootFromParent_Done,
     /* 1160685 */   // Label 16962: @1160685
     /* 1160685 */   GIM_Try, /*On fail goto*//*Label 16963*/ GIMT_Encode4(1160768), // Rule ID 15731 //
     /* 1160690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1160701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1160704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1160707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160729 */     // MIs[0] round
     /* 1160729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160739 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160767 */     // GIR_Coverage, 15731,
     /* 1160767 */     GIR_EraseRootFromParent_Done,
     /* 1160768 */   // Label 16963: @1160768
     /* 1160768 */   GIM_Try, /*On fail goto*//*Label 16964*/ GIMT_Encode4(1160851), // Rule ID 15734 //
     /* 1160773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1160784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1160787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1160790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160812 */     // MIs[0] round
     /* 1160812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160822 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1160825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160850 */     // GIR_Coverage, 15734,
     /* 1160850 */     GIR_EraseRootFromParent_Done,
     /* 1160851 */   // Label 16964: @1160851
     /* 1160851 */   GIM_Try, /*On fail goto*//*Label 16965*/ GIMT_Encode4(1160934), // Rule ID 15735 //
     /* 1160856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1160867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1160870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1160873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160895 */     // MIs[0] round
     /* 1160895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160905 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1160908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160916 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160933 */     // GIR_Coverage, 15735,
     /* 1160933 */     GIR_EraseRootFromParent_Done,
     /* 1160934 */   // Label 16965: @1160934
     /* 1160934 */   GIM_Try, /*On fail goto*//*Label 16966*/ GIMT_Encode4(1161017), // Rule ID 15738 //
     /* 1160939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1160950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1160953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1160956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160978 */     // MIs[0] round
     /* 1160978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160988 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1160991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161016 */     // GIR_Coverage, 15738,
     /* 1161016 */     GIR_EraseRootFromParent_Done,
     /* 1161017 */   // Label 16966: @1161017
     /* 1161017 */   GIM_Try, /*On fail goto*//*Label 16967*/ GIMT_Encode4(1161100), // Rule ID 15739 //
     /* 1161022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1161033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1161036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1161039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161061 */     // MIs[0] round
     /* 1161061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161071 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161082 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161099 */     // GIR_Coverage, 15739,
     /* 1161099 */     GIR_EraseRootFromParent_Done,
     /* 1161100 */   // Label 16967: @1161100
     /* 1161100 */   GIM_Try, /*On fail goto*//*Label 16968*/ GIMT_Encode4(1161183), // Rule ID 15742 //
     /* 1161105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1161116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1161119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1161122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161144 */     // MIs[0] round
     /* 1161144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161154 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161182 */     // GIR_Coverage, 15742,
     /* 1161182 */     GIR_EraseRootFromParent_Done,
     /* 1161183 */   // Label 16968: @1161183
     /* 1161183 */   GIM_Try, /*On fail goto*//*Label 16969*/ GIMT_Encode4(1161266), // Rule ID 15743 //
     /* 1161188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1161199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1161202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1161205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161227 */     // MIs[0] round
     /* 1161227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161237 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161248 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161265 */     // GIR_Coverage, 15743,
     /* 1161265 */     GIR_EraseRootFromParent_Done,
     /* 1161266 */   // Label 16969: @1161266
     /* 1161266 */   GIM_Try, /*On fail goto*//*Label 16970*/ GIMT_Encode4(1161349), // Rule ID 15746 //
     /* 1161271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1161282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1161285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1161288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161310 */     // MIs[0] round
     /* 1161310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161348 */     // GIR_Coverage, 15746,
     /* 1161348 */     GIR_EraseRootFromParent_Done,
     /* 1161349 */   // Label 16970: @1161349
     /* 1161349 */   GIM_Try, /*On fail goto*//*Label 16971*/ GIMT_Encode4(1161432), // Rule ID 15747 //
     /* 1161354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1161365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1161368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1161371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161393 */     // MIs[0] round
     /* 1161393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161403 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161414 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161431 */     // GIR_Coverage, 15747,
     /* 1161431 */     GIR_EraseRootFromParent_Done,
     /* 1161432 */   // Label 16971: @1161432
     /* 1161432 */   GIM_Try, /*On fail goto*//*Label 16972*/ GIMT_Encode4(1161515), // Rule ID 15750 //
     /* 1161437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1161448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1161451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161476 */     // MIs[0] round
     /* 1161476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161486 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1161489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161514 */     // GIR_Coverage, 15750,
     /* 1161514 */     GIR_EraseRootFromParent_Done,
     /* 1161515 */   // Label 16972: @1161515
     /* 1161515 */   GIM_Try, /*On fail goto*//*Label 16973*/ GIMT_Encode4(1161598), // Rule ID 15751 //
     /* 1161520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1161531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1161534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161559 */     // MIs[0] round
     /* 1161559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161569 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1161572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161580 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161597 */     // GIR_Coverage, 15751,
     /* 1161597 */     GIR_EraseRootFromParent_Done,
     /* 1161598 */   // Label 16973: @1161598
     /* 1161598 */   GIM_Try, /*On fail goto*//*Label 16974*/ GIMT_Encode4(1161681), // Rule ID 15754 //
     /* 1161603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1161614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1161617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1161620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161642 */     // MIs[0] round
     /* 1161642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161652 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1161655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161680 */     // GIR_Coverage, 15754,
     /* 1161680 */     GIR_EraseRootFromParent_Done,
     /* 1161681 */   // Label 16974: @1161681
     /* 1161681 */   GIM_Try, /*On fail goto*//*Label 16975*/ GIMT_Encode4(1161764), // Rule ID 15755 //
     /* 1161686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1161697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1161700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1161703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161725 */     // MIs[0] round
     /* 1161725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161735 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1161738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161746 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161763 */     // GIR_Coverage, 15755,
     /* 1161763 */     GIR_EraseRootFromParent_Done,
     /* 1161764 */   // Label 16975: @1161764
     /* 1161764 */   GIM_Try, /*On fail goto*//*Label 16976*/ GIMT_Encode4(1161847), // Rule ID 15758 //
     /* 1161769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1161780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1161783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1161786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161808 */     // MIs[0] round
     /* 1161808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161846 */     // GIR_Coverage, 15758,
     /* 1161846 */     GIR_EraseRootFromParent_Done,
     /* 1161847 */   // Label 16976: @1161847
     /* 1161847 */   GIM_Try, /*On fail goto*//*Label 16977*/ GIMT_Encode4(1161930), // Rule ID 15759 //
     /* 1161852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1161863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1161866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1161869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161891 */     // MIs[0] round
     /* 1161891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161901 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161912 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161929 */     // GIR_Coverage, 15759,
     /* 1161929 */     GIR_EraseRootFromParent_Done,
     /* 1161930 */   // Label 16977: @1161930
     /* 1161930 */   GIM_Try, /*On fail goto*//*Label 16978*/ GIMT_Encode4(1162013), // Rule ID 15762 //
     /* 1161935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1161946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1161949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1161952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161974 */     // MIs[0] round
     /* 1161974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161984 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1161987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162012 */     // GIR_Coverage, 15762,
     /* 1162012 */     GIR_EraseRootFromParent_Done,
     /* 1162013 */   // Label 16978: @1162013
     /* 1162013 */   GIM_Try, /*On fail goto*//*Label 16979*/ GIMT_Encode4(1162096), // Rule ID 15763 //
     /* 1162018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1162029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1162032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1162035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162057 */     // MIs[0] round
     /* 1162057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162067 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162078 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162095 */     // GIR_Coverage, 15763,
     /* 1162095 */     GIR_EraseRootFromParent_Done,
     /* 1162096 */   // Label 16979: @1162096
     /* 1162096 */   GIM_Try, /*On fail goto*//*Label 16980*/ GIMT_Encode4(1162179), // Rule ID 15766 //
     /* 1162101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1162112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1162115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1162118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162140 */     // MIs[0] round
     /* 1162140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162150 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162178 */     // GIR_Coverage, 15766,
     /* 1162178 */     GIR_EraseRootFromParent_Done,
     /* 1162179 */   // Label 16980: @1162179
     /* 1162179 */   GIM_Try, /*On fail goto*//*Label 16981*/ GIMT_Encode4(1162262), // Rule ID 15767 //
     /* 1162184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1162195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1162198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1162201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162223 */     // MIs[0] round
     /* 1162223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162233 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162244 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162261 */     // GIR_Coverage, 15767,
     /* 1162261 */     GIR_EraseRootFromParent_Done,
     /* 1162262 */   // Label 16981: @1162262
     /* 1162262 */   GIM_Try, /*On fail goto*//*Label 16982*/ GIMT_Encode4(1162345), // Rule ID 15770 //
     /* 1162267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1162278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1162281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1162284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162306 */     // MIs[0] round
     /* 1162306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1162319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162344 */     // GIR_Coverage, 15770,
     /* 1162344 */     GIR_EraseRootFromParent_Done,
     /* 1162345 */   // Label 16982: @1162345
     /* 1162345 */   GIM_Try, /*On fail goto*//*Label 16983*/ GIMT_Encode4(1162428), // Rule ID 15771 //
     /* 1162350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1162361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1162364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1162367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162389 */     // MIs[0] round
     /* 1162389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1162402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162410 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162427 */     // GIR_Coverage, 15771,
     /* 1162427 */     GIR_EraseRootFromParent_Done,
     /* 1162428 */   // Label 16983: @1162428
     /* 1162428 */   GIM_Try, /*On fail goto*//*Label 16984*/ GIMT_Encode4(1162511), // Rule ID 15774 //
     /* 1162433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1162444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1162447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162472 */     // MIs[0] round
     /* 1162472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162510 */     // GIR_Coverage, 15774,
     /* 1162510 */     GIR_EraseRootFromParent_Done,
     /* 1162511 */   // Label 16984: @1162511
     /* 1162511 */   GIM_Try, /*On fail goto*//*Label 16985*/ GIMT_Encode4(1162594), // Rule ID 15775 //
     /* 1162516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1162527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1162530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162555 */     // MIs[0] round
     /* 1162555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162565 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162576 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162593 */     // GIR_Coverage, 15775,
     /* 1162593 */     GIR_EraseRootFromParent_Done,
     /* 1162594 */   // Label 16985: @1162594
     /* 1162594 */   GIM_Try, /*On fail goto*//*Label 16986*/ GIMT_Encode4(1162677), // Rule ID 15778 //
     /* 1162599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1162610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1162613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1162616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162638 */     // MIs[0] round
     /* 1162638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162648 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162676 */     // GIR_Coverage, 15778,
     /* 1162676 */     GIR_EraseRootFromParent_Done,
     /* 1162677 */   // Label 16986: @1162677
     /* 1162677 */   GIM_Try, /*On fail goto*//*Label 16987*/ GIMT_Encode4(1162760), // Rule ID 15779 //
     /* 1162682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1162693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1162696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1162699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162721 */     // MIs[0] round
     /* 1162721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162731 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162742 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162759 */     // GIR_Coverage, 15779,
     /* 1162759 */     GIR_EraseRootFromParent_Done,
     /* 1162760 */   // Label 16987: @1162760
     /* 1162760 */   GIM_Try, /*On fail goto*//*Label 16988*/ GIMT_Encode4(1162843), // Rule ID 15782 //
     /* 1162765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1162768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1162776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1162779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1162782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1162785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162804 */     // MIs[0] round
     /* 1162804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162814 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1162817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162842 */     // GIR_Coverage, 15782,
     /* 1162842 */     GIR_EraseRootFromParent_Done,
     /* 1162843 */   // Label 16988: @1162843
     /* 1162843 */   GIM_Try, /*On fail goto*//*Label 16989*/ GIMT_Encode4(1162926), // Rule ID 15783 //
     /* 1162848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1162851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1162859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1162862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1162865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1162868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162887 */     // MIs[0] round
     /* 1162887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162897 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1162900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162908 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162925 */     // GIR_Coverage, 15783,
     /* 1162925 */     GIR_EraseRootFromParent_Done,
     /* 1162926 */   // Label 16989: @1162926
     /* 1162926 */   GIM_Try, /*On fail goto*//*Label 16990*/ GIMT_Encode4(1163009), // Rule ID 15786 //
     /* 1162931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1162934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1162942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1162945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1162948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1162951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162970 */     // MIs[0] round
     /* 1162970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162980 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1162983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163008 */     // GIR_Coverage, 15786,
     /* 1163008 */     GIR_EraseRootFromParent_Done,
     /* 1163009 */   // Label 16990: @1163009
     /* 1163009 */   GIM_Try, /*On fail goto*//*Label 16991*/ GIMT_Encode4(1163092), // Rule ID 15787 //
     /* 1163014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1163025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1163028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1163031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1163034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163053 */     // MIs[0] round
     /* 1163053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163063 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1163066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163074 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163091 */     // GIR_Coverage, 15787,
     /* 1163091 */     GIR_EraseRootFromParent_Done,
     /* 1163092 */   // Label 16991: @1163092
     /* 1163092 */   GIM_Try, /*On fail goto*//*Label 16992*/ GIMT_Encode4(1163175), // Rule ID 15790 //
     /* 1163097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1163117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163136 */     // MIs[0] round
     /* 1163136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163146 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1163149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163174 */     // GIR_Coverage, 15790,
     /* 1163174 */     GIR_EraseRootFromParent_Done,
     /* 1163175 */   // Label 16992: @1163175
     /* 1163175 */   GIM_Try, /*On fail goto*//*Label 16993*/ GIMT_Encode4(1163258), // Rule ID 15791 //
     /* 1163180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1163200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163219 */     // MIs[0] round
     /* 1163219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163229 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1163232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163240 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163257 */     // GIR_Coverage, 15791,
     /* 1163257 */     GIR_EraseRootFromParent_Done,
     /* 1163258 */   // Label 16993: @1163258
     /* 1163258 */   GIM_Try, /*On fail goto*//*Label 16994*/ GIMT_Encode4(1163341), // Rule ID 15794 //
     /* 1163263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1163274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1163277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1163283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163302 */     // MIs[0] round
     /* 1163302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163312 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1163315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163340 */     // GIR_Coverage, 15794,
     /* 1163340 */     GIR_EraseRootFromParent_Done,
     /* 1163341 */   // Label 16994: @1163341
     /* 1163341 */   GIM_Try, /*On fail goto*//*Label 16995*/ GIMT_Encode4(1163424), // Rule ID 15795 //
     /* 1163346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1163357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1163360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1163366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163385 */     // MIs[0] round
     /* 1163385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163395 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1163398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163423 */     // GIR_Coverage, 15795,
     /* 1163423 */     GIR_EraseRootFromParent_Done,
     /* 1163424 */   // Label 16995: @1163424
     /* 1163424 */   GIM_Try, /*On fail goto*//*Label 16996*/ GIMT_Encode4(1163507), // Rule ID 15798 //
     /* 1163429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163468 */     // MIs[0] round
     /* 1163468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163478 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1163481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163506 */     // GIR_Coverage, 15798,
     /* 1163506 */     GIR_EraseRootFromParent_Done,
     /* 1163507 */   // Label 16996: @1163507
     /* 1163507 */   GIM_Try, /*On fail goto*//*Label 16997*/ GIMT_Encode4(1163590), // Rule ID 15799 //
     /* 1163512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163551 */     // MIs[0] round
     /* 1163551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163561 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1163564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163572 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163589 */     // GIR_Coverage, 15799,
     /* 1163589 */     GIR_EraseRootFromParent_Done,
     /* 1163590 */   // Label 16997: @1163590
     /* 1163590 */   GIM_Try, /*On fail goto*//*Label 16998*/ GIMT_Encode4(1163673), // Rule ID 15802 //
     /* 1163595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1163606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1163609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1163612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163634 */     // MIs[0] round
     /* 1163634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163644 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1163647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163672 */     // GIR_Coverage, 15802,
     /* 1163672 */     GIR_EraseRootFromParent_Done,
     /* 1163673 */   // Label 16998: @1163673
     /* 1163673 */   GIM_Try, /*On fail goto*//*Label 16999*/ GIMT_Encode4(1163756), // Rule ID 15803 //
     /* 1163678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1163689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1163692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1163695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163717 */     // MIs[0] round
     /* 1163717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163727 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1163730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163738 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163755 */     // GIR_Coverage, 15803,
     /* 1163755 */     GIR_EraseRootFromParent_Done,
     /* 1163756 */   // Label 16999: @1163756
     /* 1163756 */   GIM_Try, /*On fail goto*//*Label 17000*/ GIMT_Encode4(1163839), // Rule ID 15806 //
     /* 1163761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163800 */     // MIs[0] round
     /* 1163800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163810 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1163813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163834 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163838 */     // GIR_Coverage, 15806,
     /* 1163838 */     GIR_EraseRootFromParent_Done,
     /* 1163839 */   // Label 17000: @1163839
     /* 1163839 */   GIM_Try, /*On fail goto*//*Label 17001*/ GIMT_Encode4(1163922), // Rule ID 15807 //
     /* 1163844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163883 */     // MIs[0] round
     /* 1163883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163893 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1163896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163904 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163921 */     // GIR_Coverage, 15807,
     /* 1163921 */     GIR_EraseRootFromParent_Done,
     /* 1163922 */   // Label 17001: @1163922
     /* 1163922 */   GIM_Try, /*On fail goto*//*Label 17002*/ GIMT_Encode4(1164005), // Rule ID 15810 //
     /* 1163927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1163938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1163941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163966 */     // MIs[0] round
     /* 1163966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163976 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1163979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164004 */     // GIR_Coverage, 15810,
     /* 1164004 */     GIR_EraseRootFromParent_Done,
     /* 1164005 */   // Label 17002: @1164005
     /* 1164005 */   GIM_Try, /*On fail goto*//*Label 17003*/ GIMT_Encode4(1164088), // Rule ID 15811 //
     /* 1164010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1164013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1164021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1164024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1164027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164049 */     // MIs[0] round
     /* 1164049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164059 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1164062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164087 */     // GIR_Coverage, 15811,
     /* 1164087 */     GIR_EraseRootFromParent_Done,
     /* 1164088 */   // Label 17003: @1164088
     /* 1164088 */   GIM_Try, /*On fail goto*//*Label 17004*/ GIMT_Encode4(1164168), // Rule ID 15814 //
     /* 1164093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1164104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1164107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1164110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1164113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164132 */     // MIs[0] round
     /* 1164132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164142 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1164145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164167 */     // GIR_Coverage, 15814,
     /* 1164167 */     GIR_EraseRootFromParent_Done,
     /* 1164168 */   // Label 17004: @1164168
     /* 1164168 */   GIM_Try, /*On fail goto*//*Label 17005*/ GIMT_Encode4(1164248), // Rule ID 15815 //
     /* 1164173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1164184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1164187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1164190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1164193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164212 */     // MIs[0] round
     /* 1164212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164222 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1164225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164247 */     // GIR_Coverage, 15815,
     /* 1164247 */     GIR_EraseRootFromParent_Done,
     /* 1164248 */   // Label 17005: @1164248
     /* 1164248 */   GIM_Try, /*On fail goto*//*Label 17006*/ GIMT_Encode4(1164328), // Rule ID 15818 //
     /* 1164253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1164264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1164267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1164270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1164273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164292 */     // MIs[0] round
     /* 1164292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164302 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164327 */     // GIR_Coverage, 15818,
     /* 1164327 */     GIR_EraseRootFromParent_Done,
     /* 1164328 */   // Label 17006: @1164328
     /* 1164328 */   GIM_Try, /*On fail goto*//*Label 17007*/ GIMT_Encode4(1164408), // Rule ID 15819 //
     /* 1164333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1164344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1164347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1164350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1164353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164372 */     // MIs[0] round
     /* 1164372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164382 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164407 */     // GIR_Coverage, 15819,
     /* 1164407 */     GIR_EraseRootFromParent_Done,
     /* 1164408 */   // Label 17007: @1164408
     /* 1164408 */   GIM_Try, /*On fail goto*//*Label 17008*/ GIMT_Encode4(1164488), // Rule ID 15822 //
     /* 1164413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1164424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1164427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1164430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1164433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164452 */     // MIs[0] round
     /* 1164452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164462 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164487 */     // GIR_Coverage, 15822,
     /* 1164487 */     GIR_EraseRootFromParent_Done,
     /* 1164488 */   // Label 17008: @1164488
     /* 1164488 */   GIM_Try, /*On fail goto*//*Label 17009*/ GIMT_Encode4(1164568), // Rule ID 15823 //
     /* 1164493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1164504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1164507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1164510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1164513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164532 */     // MIs[0] round
     /* 1164532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164542 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164567 */     // GIR_Coverage, 15823,
     /* 1164567 */     GIR_EraseRootFromParent_Done,
     /* 1164568 */   // Label 17009: @1164568
     /* 1164568 */   GIM_Try, /*On fail goto*//*Label 17010*/ GIMT_Encode4(1164648), // Rule ID 15826 //
     /* 1164573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1164584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1164587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1164590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1164593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164612 */     // MIs[0] round
     /* 1164612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164622 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164647 */     // GIR_Coverage, 15826,
     /* 1164647 */     GIR_EraseRootFromParent_Done,
     /* 1164648 */   // Label 17010: @1164648
     /* 1164648 */   GIM_Try, /*On fail goto*//*Label 17011*/ GIMT_Encode4(1164728), // Rule ID 15827 //
     /* 1164653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1164664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1164667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1164670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1164673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164692 */     // MIs[0] round
     /* 1164692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164702 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164727 */     // GIR_Coverage, 15827,
     /* 1164727 */     GIR_EraseRootFromParent_Done,
     /* 1164728 */   // Label 17011: @1164728
     /* 1164728 */   GIM_Try, /*On fail goto*//*Label 17012*/ GIMT_Encode4(1164808), // Rule ID 15830 //
     /* 1164733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1164744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1164747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1164750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1164753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164772 */     // MIs[0] round
     /* 1164772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164782 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164807 */     // GIR_Coverage, 15830,
     /* 1164807 */     GIR_EraseRootFromParent_Done,
     /* 1164808 */   // Label 17012: @1164808
     /* 1164808 */   GIM_Try, /*On fail goto*//*Label 17013*/ GIMT_Encode4(1164888), // Rule ID 15831 //
     /* 1164813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1164824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1164827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1164830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1164833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164852 */     // MIs[0] round
     /* 1164852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164862 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164887 */     // GIR_Coverage, 15831,
     /* 1164887 */     GIR_EraseRootFromParent_Done,
     /* 1164888 */   // Label 17013: @1164888
     /* 1164888 */   GIM_Try, /*On fail goto*//*Label 17014*/ GIMT_Encode4(1164968), // Rule ID 15834 //
     /* 1164893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1164904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1164907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1164910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1164913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164932 */     // MIs[0] round
     /* 1164932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164942 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1164963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164967 */     // GIR_Coverage, 15834,
     /* 1164967 */     GIR_EraseRootFromParent_Done,
     /* 1164968 */   // Label 17014: @1164968
     /* 1164968 */   GIM_Try, /*On fail goto*//*Label 17015*/ GIMT_Encode4(1165048), // Rule ID 15835 //
     /* 1164973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1164984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1164987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1164990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1164993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165012 */     // MIs[0] round
     /* 1165012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165022 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1165025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165047 */     // GIR_Coverage, 15835,
     /* 1165047 */     GIR_EraseRootFromParent_Done,
     /* 1165048 */   // Label 17015: @1165048
     /* 1165048 */   GIM_Try, /*On fail goto*//*Label 17016*/ GIMT_Encode4(1165128), // Rule ID 15838 //
     /* 1165053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1165064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1165067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1165070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1165073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165092 */     // MIs[0] round
     /* 1165092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165127 */     // GIR_Coverage, 15838,
     /* 1165127 */     GIR_EraseRootFromParent_Done,
     /* 1165128 */   // Label 17016: @1165128
     /* 1165128 */   GIM_Try, /*On fail goto*//*Label 17017*/ GIMT_Encode4(1165208), // Rule ID 15839 //
     /* 1165133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1165144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1165147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1165150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1165153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165172 */     // MIs[0] round
     /* 1165172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165182 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165207 */     // GIR_Coverage, 15839,
     /* 1165207 */     GIR_EraseRootFromParent_Done,
     /* 1165208 */   // Label 17017: @1165208
     /* 1165208 */   GIM_Try, /*On fail goto*//*Label 17018*/ GIMT_Encode4(1165288), // Rule ID 15842 //
     /* 1165213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1165224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1165227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1165230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1165233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165252 */     // MIs[0] round
     /* 1165252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165262 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165287 */     // GIR_Coverage, 15842,
     /* 1165287 */     GIR_EraseRootFromParent_Done,
     /* 1165288 */   // Label 17018: @1165288
     /* 1165288 */   GIM_Try, /*On fail goto*//*Label 17019*/ GIMT_Encode4(1165368), // Rule ID 15843 //
     /* 1165293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1165304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1165307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1165310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1165313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165332 */     // MIs[0] round
     /* 1165332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165367 */     // GIR_Coverage, 15843,
     /* 1165367 */     GIR_EraseRootFromParent_Done,
     /* 1165368 */   // Label 17019: @1165368
     /* 1165368 */   GIM_Try, /*On fail goto*//*Label 17020*/ GIMT_Encode4(1165448), // Rule ID 15846 //
     /* 1165373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1165384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1165387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1165390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1165393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165412 */     // MIs[0] round
     /* 1165412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165447 */     // GIR_Coverage, 15846,
     /* 1165447 */     GIR_EraseRootFromParent_Done,
     /* 1165448 */   // Label 17020: @1165448
     /* 1165448 */   GIM_Try, /*On fail goto*//*Label 17021*/ GIMT_Encode4(1165528), // Rule ID 15847 //
     /* 1165453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1165464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1165467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1165470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1165473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165492 */     // MIs[0] round
     /* 1165492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165527 */     // GIR_Coverage, 15847,
     /* 1165527 */     GIR_EraseRootFromParent_Done,
     /* 1165528 */   // Label 17021: @1165528
     /* 1165528 */   GIM_Try, /*On fail goto*//*Label 17022*/ GIMT_Encode4(1165608), // Rule ID 15850 //
     /* 1165533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1165536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1165544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1165547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1165550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1165553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165572 */     // MIs[0] round
     /* 1165572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165582 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1165603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165607 */     // GIR_Coverage, 15850,
     /* 1165607 */     GIR_EraseRootFromParent_Done,
     /* 1165608 */   // Label 17022: @1165608
     /* 1165608 */   GIM_Try, /*On fail goto*//*Label 17023*/ GIMT_Encode4(1165688), // Rule ID 15851 //
     /* 1165613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1165616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1165624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1165627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1165630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1165633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165652 */     // MIs[0] round
     /* 1165652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165662 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1165683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165687 */     // GIR_Coverage, 15851,
     /* 1165687 */     GIR_EraseRootFromParent_Done,
     /* 1165688 */   // Label 17023: @1165688
     /* 1165688 */   GIM_Try, /*On fail goto*//*Label 17024*/ GIMT_Encode4(1165768), // Rule ID 15854 //
     /* 1165693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1165704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1165707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1165710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1165713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165732 */     // MIs[0] round
     /* 1165732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165742 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1165745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165767 */     // GIR_Coverage, 15854,
     /* 1165767 */     GIR_EraseRootFromParent_Done,
     /* 1165768 */   // Label 17024: @1165768
     /* 1165768 */   GIM_Try, /*On fail goto*//*Label 17025*/ GIMT_Encode4(1165848), // Rule ID 15855 //
     /* 1165773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1165784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1165787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1165790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1165793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165812 */     // MIs[0] round
     /* 1165812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165822 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1165825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165847 */     // GIR_Coverage, 15855,
     /* 1165847 */     GIR_EraseRootFromParent_Done,
     /* 1165848 */   // Label 17025: @1165848
     /* 1165848 */   GIM_Try, /*On fail goto*//*Label 17026*/ GIMT_Encode4(1165928), // Rule ID 15858 //
     /* 1165853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1165864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1165867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1165870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1165873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165892 */     // MIs[0] round
     /* 1165892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165902 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1165905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165927 */     // GIR_Coverage, 15858,
     /* 1165927 */     GIR_EraseRootFromParent_Done,
     /* 1165928 */   // Label 17026: @1165928
     /* 1165928 */   GIM_Try, /*On fail goto*//*Label 17027*/ GIMT_Encode4(1166008), // Rule ID 15859 //
     /* 1165933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1165944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1165947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1165950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1165953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165972 */     // MIs[0] round
     /* 1165972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165982 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1165985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166007 */     // GIR_Coverage, 15859,
     /* 1166007 */     GIR_EraseRootFromParent_Done,
     /* 1166008 */   // Label 17027: @1166008
     /* 1166008 */   GIM_Try, /*On fail goto*//*Label 17028*/ GIMT_Encode4(1166088), // Rule ID 15862 //
     /* 1166013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1166024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1166027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1166030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1166033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166052 */     // MIs[0] round
     /* 1166052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166062 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166087 */     // GIR_Coverage, 15862,
     /* 1166087 */     GIR_EraseRootFromParent_Done,
     /* 1166088 */   // Label 17028: @1166088
     /* 1166088 */   GIM_Try, /*On fail goto*//*Label 17029*/ GIMT_Encode4(1166168), // Rule ID 15863 //
     /* 1166093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1166104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1166107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1166110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1166113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166132 */     // MIs[0] round
     /* 1166132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166142 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166167 */     // GIR_Coverage, 15863,
     /* 1166167 */     GIR_EraseRootFromParent_Done,
     /* 1166168 */   // Label 17029: @1166168
     /* 1166168 */   GIM_Try, /*On fail goto*//*Label 17030*/ GIMT_Encode4(1166248), // Rule ID 15866 //
     /* 1166173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1166184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1166187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1166190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1166193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166212 */     // MIs[0] round
     /* 1166212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166247 */     // GIR_Coverage, 15866,
     /* 1166247 */     GIR_EraseRootFromParent_Done,
     /* 1166248 */   // Label 17030: @1166248
     /* 1166248 */   GIM_Try, /*On fail goto*//*Label 17031*/ GIMT_Encode4(1166328), // Rule ID 15867 //
     /* 1166253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1166264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1166267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1166270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1166273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166292 */     // MIs[0] round
     /* 1166292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166327 */     // GIR_Coverage, 15867,
     /* 1166327 */     GIR_EraseRootFromParent_Done,
     /* 1166328 */   // Label 17031: @1166328
     /* 1166328 */   GIM_Try, /*On fail goto*//*Label 17032*/ GIMT_Encode4(1166408), // Rule ID 15870 //
     /* 1166333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1166344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1166347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1166350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1166353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166372 */     // MIs[0] round
     /* 1166372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166382 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166407 */     // GIR_Coverage, 15870,
     /* 1166407 */     GIR_EraseRootFromParent_Done,
     /* 1166408 */   // Label 17032: @1166408
     /* 1166408 */   GIM_Try, /*On fail goto*//*Label 17033*/ GIMT_Encode4(1166488), // Rule ID 15871 //
     /* 1166413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1166424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1166427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1166430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1166433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166452 */     // MIs[0] round
     /* 1166452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166462 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166487 */     // GIR_Coverage, 15871,
     /* 1166487 */     GIR_EraseRootFromParent_Done,
     /* 1166488 */   // Label 17033: @1166488
     /* 1166488 */   GIM_Try, /*On fail goto*//*Label 17034*/ GIMT_Encode4(1166568), // Rule ID 15874 //
     /* 1166493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1166504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1166507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1166510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1166513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166532 */     // MIs[0] round
     /* 1166532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166542 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166567 */     // GIR_Coverage, 15874,
     /* 1166567 */     GIR_EraseRootFromParent_Done,
     /* 1166568 */   // Label 17034: @1166568
     /* 1166568 */   GIM_Try, /*On fail goto*//*Label 17035*/ GIMT_Encode4(1166648), // Rule ID 15875 //
     /* 1166573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1166584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1166587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1166590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1166593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166612 */     // MIs[0] round
     /* 1166612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166622 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166647 */     // GIR_Coverage, 15875,
     /* 1166647 */     GIR_EraseRootFromParent_Done,
     /* 1166648 */   // Label 17035: @1166648
     /* 1166648 */   GIM_Try, /*On fail goto*//*Label 17036*/ GIMT_Encode4(1166728), // Rule ID 15878 //
     /* 1166653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1166664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1166667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1166670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1166673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166692 */     // MIs[0] round
     /* 1166692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166727 */     // GIR_Coverage, 15878,
     /* 1166727 */     GIR_EraseRootFromParent_Done,
     /* 1166728 */   // Label 17036: @1166728
     /* 1166728 */   GIM_Try, /*On fail goto*//*Label 17037*/ GIMT_Encode4(1166808), // Rule ID 15879 //
     /* 1166733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1166744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1166747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1166750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1166753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166772 */     // MIs[0] round
     /* 1166772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166807 */     // GIR_Coverage, 15879,
     /* 1166807 */     GIR_EraseRootFromParent_Done,
     /* 1166808 */   // Label 17037: @1166808
     /* 1166808 */   GIM_Try, /*On fail goto*//*Label 17038*/ GIMT_Encode4(1166888), // Rule ID 15882 //
     /* 1166813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1166824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1166827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1166830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1166833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166852 */     // MIs[0] round
     /* 1166852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166862 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166887 */     // GIR_Coverage, 15882,
     /* 1166887 */     GIR_EraseRootFromParent_Done,
     /* 1166888 */   // Label 17038: @1166888
     /* 1166888 */   GIM_Try, /*On fail goto*//*Label 17039*/ GIMT_Encode4(1166968), // Rule ID 15883 //
     /* 1166893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1166904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1166907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1166910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1166913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166932 */     // MIs[0] round
     /* 1166932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166942 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166967 */     // GIR_Coverage, 15883,
     /* 1166967 */     GIR_EraseRootFromParent_Done,
     /* 1166968 */   // Label 17039: @1166968
     /* 1166968 */   GIM_Try, /*On fail goto*//*Label 17040*/ GIMT_Encode4(1167048), // Rule ID 15886 //
     /* 1166973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1166984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1166987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1166990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1166993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167012 */     // MIs[0] round
     /* 1167012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167022 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167047 */     // GIR_Coverage, 15886,
     /* 1167047 */     GIR_EraseRootFromParent_Done,
     /* 1167048 */   // Label 17040: @1167048
     /* 1167048 */   GIM_Try, /*On fail goto*//*Label 17041*/ GIMT_Encode4(1167128), // Rule ID 15887 //
     /* 1167053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1167064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1167067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1167070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1167073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167092 */     // MIs[0] round
     /* 1167092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167127 */     // GIR_Coverage, 15887,
     /* 1167127 */     GIR_EraseRootFromParent_Done,
     /* 1167128 */   // Label 17041: @1167128
     /* 1167128 */   GIM_Try, /*On fail goto*//*Label 17042*/ GIMT_Encode4(1167208), // Rule ID 15890 //
     /* 1167133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1167144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1167147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1167150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1167153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167172 */     // MIs[0] round
     /* 1167172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1167185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167207 */     // GIR_Coverage, 15890,
     /* 1167207 */     GIR_EraseRootFromParent_Done,
     /* 1167208 */   // Label 17042: @1167208
     /* 1167208 */   GIM_Try, /*On fail goto*//*Label 17043*/ GIMT_Encode4(1167288), // Rule ID 15891 //
     /* 1167213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1167224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1167227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1167230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1167233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167252 */     // MIs[0] round
     /* 1167252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167262 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1167265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167287 */     // GIR_Coverage, 15891,
     /* 1167287 */     GIR_EraseRootFromParent_Done,
     /* 1167288 */   // Label 17043: @1167288
     /* 1167288 */   GIM_Try, /*On fail goto*//*Label 17044*/ GIMT_Encode4(1167368), // Rule ID 15894 //
     /* 1167293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1167304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1167307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1167310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1167313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167332 */     // MIs[0] round
     /* 1167332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167342 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167367 */     // GIR_Coverage, 15894,
     /* 1167367 */     GIR_EraseRootFromParent_Done,
     /* 1167368 */   // Label 17044: @1167368
     /* 1167368 */   GIM_Try, /*On fail goto*//*Label 17045*/ GIMT_Encode4(1167448), // Rule ID 15895 //
     /* 1167373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1167384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1167387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1167390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1167393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167412 */     // MIs[0] round
     /* 1167412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167422 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167447 */     // GIR_Coverage, 15895,
     /* 1167447 */     GIR_EraseRootFromParent_Done,
     /* 1167448 */   // Label 17045: @1167448
     /* 1167448 */   GIM_Try, /*On fail goto*//*Label 17046*/ GIMT_Encode4(1167528), // Rule ID 15898 //
     /* 1167453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1167464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1167467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1167470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1167473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167492 */     // MIs[0] round
     /* 1167492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167527 */     // GIR_Coverage, 15898,
     /* 1167527 */     GIR_EraseRootFromParent_Done,
     /* 1167528 */   // Label 17046: @1167528
     /* 1167528 */   GIM_Try, /*On fail goto*//*Label 17047*/ GIMT_Encode4(1167608), // Rule ID 15899 //
     /* 1167533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1167544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1167547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1167550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1167553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167572 */     // MIs[0] round
     /* 1167572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167582 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167607 */     // GIR_Coverage, 15899,
     /* 1167607 */     GIR_EraseRootFromParent_Done,
     /* 1167608 */   // Label 17047: @1167608
     /* 1167608 */   GIM_Try, /*On fail goto*//*Label 17048*/ GIMT_Encode4(1167688), // Rule ID 15902 //
     /* 1167613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1167624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1167627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1167630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167652 */     // MIs[0] round
     /* 1167652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167662 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1167665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167687 */     // GIR_Coverage, 15902,
     /* 1167687 */     GIR_EraseRootFromParent_Done,
     /* 1167688 */   // Label 17048: @1167688
     /* 1167688 */   GIM_Try, /*On fail goto*//*Label 17049*/ GIMT_Encode4(1167768), // Rule ID 15903 //
     /* 1167693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1167704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1167707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1167710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1167713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167732 */     // MIs[0] round
     /* 1167732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167742 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1167745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167767 */     // GIR_Coverage, 15903,
     /* 1167767 */     GIR_EraseRootFromParent_Done,
     /* 1167768 */   // Label 17049: @1167768
     /* 1167768 */   GIM_Try, /*On fail goto*//*Label 17050*/ GIMT_Encode4(1167848), // Rule ID 15906 //
     /* 1167773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1167784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1167787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1167790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167812 */     // MIs[0] round
     /* 1167812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167822 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1167825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167847 */     // GIR_Coverage, 15906,
     /* 1167847 */     GIR_EraseRootFromParent_Done,
     /* 1167848 */   // Label 17050: @1167848
     /* 1167848 */   GIM_Try, /*On fail goto*//*Label 17051*/ GIMT_Encode4(1167928), // Rule ID 15907 //
     /* 1167853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1167864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1167867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1167870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1167873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167892 */     // MIs[0] round
     /* 1167892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167902 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1167905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167927 */     // GIR_Coverage, 15907,
     /* 1167927 */     GIR_EraseRootFromParent_Done,
     /* 1167928 */   // Label 17051: @1167928
     /* 1167928 */   GIM_Try, /*On fail goto*//*Label 17052*/ GIMT_Encode4(1168008), // Rule ID 15910 //
     /* 1167933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1167944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1167947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1167950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167972 */     // MIs[0] round
     /* 1167972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167982 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1167985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168007 */     // GIR_Coverage, 15910,
     /* 1168007 */     GIR_EraseRootFromParent_Done,
     /* 1168008 */   // Label 17052: @1168008
     /* 1168008 */   GIM_Try, /*On fail goto*//*Label 17053*/ GIMT_Encode4(1168088), // Rule ID 15911 //
     /* 1168013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1168024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1168027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1168030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168052 */     // MIs[0] round
     /* 1168052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168062 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168087 */     // GIR_Coverage, 15911,
     /* 1168087 */     GIR_EraseRootFromParent_Done,
     /* 1168088 */   // Label 17053: @1168088
     /* 1168088 */   GIM_Try, /*On fail goto*//*Label 17054*/ GIMT_Encode4(1168168), // Rule ID 15914 //
     /* 1168093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1168104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1168107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1168110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168132 */     // MIs[0] round
     /* 1168132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168142 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1168145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168167 */     // GIR_Coverage, 15914,
     /* 1168167 */     GIR_EraseRootFromParent_Done,
     /* 1168168 */   // Label 17054: @1168168
     /* 1168168 */   GIM_Try, /*On fail goto*//*Label 17055*/ GIMT_Encode4(1168248), // Rule ID 15915 //
     /* 1168173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1168184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1168187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1168190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168212 */     // MIs[0] round
     /* 1168212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168222 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1168225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168247 */     // GIR_Coverage, 15915,
     /* 1168247 */     GIR_EraseRootFromParent_Done,
     /* 1168248 */   // Label 17055: @1168248
     /* 1168248 */   GIM_Try, /*On fail goto*//*Label 17056*/ GIMT_Encode4(1168328), // Rule ID 15918 //
     /* 1168253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1168264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1168267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1168270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168292 */     // MIs[0] round
     /* 1168292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168302 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168327 */     // GIR_Coverage, 15918,
     /* 1168327 */     GIR_EraseRootFromParent_Done,
     /* 1168328 */   // Label 17056: @1168328
     /* 1168328 */   GIM_Try, /*On fail goto*//*Label 17057*/ GIMT_Encode4(1168408), // Rule ID 15919 //
     /* 1168333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1168344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1168347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1168350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168372 */     // MIs[0] round
     /* 1168372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168407 */     // GIR_Coverage, 15919,
     /* 1168407 */     GIR_EraseRootFromParent_Done,
     /* 1168408 */   // Label 17057: @1168408
     /* 1168408 */   GIM_Try, /*On fail goto*//*Label 17058*/ GIMT_Encode4(1168488), // Rule ID 15922 //
     /* 1168413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1168424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1168427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1168430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168452 */     // MIs[0] round
     /* 1168452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168462 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168487 */     // GIR_Coverage, 15922,
     /* 1168487 */     GIR_EraseRootFromParent_Done,
     /* 1168488 */   // Label 17058: @1168488
     /* 1168488 */   GIM_Try, /*On fail goto*//*Label 17059*/ GIMT_Encode4(1168568), // Rule ID 15923 //
     /* 1168493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1168504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1168507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1168510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168532 */     // MIs[0] round
     /* 1168532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168542 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168567 */     // GIR_Coverage, 15923,
     /* 1168567 */     GIR_EraseRootFromParent_Done,
     /* 1168568 */   // Label 17059: @1168568
     /* 1168568 */   GIM_Try, /*On fail goto*//*Label 17060*/ GIMT_Encode4(1168648), // Rule ID 15926 //
     /* 1168573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1168584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1168587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1168590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168612 */     // MIs[0] round
     /* 1168612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168622 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168647 */     // GIR_Coverage, 15926,
     /* 1168647 */     GIR_EraseRootFromParent_Done,
     /* 1168648 */   // Label 17060: @1168648
     /* 1168648 */   GIM_Try, /*On fail goto*//*Label 17061*/ GIMT_Encode4(1168728), // Rule ID 15927 //
     /* 1168653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1168664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1168667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1168670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168692 */     // MIs[0] round
     /* 1168692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168702 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168727 */     // GIR_Coverage, 15927,
     /* 1168727 */     GIR_EraseRootFromParent_Done,
     /* 1168728 */   // Label 17061: @1168728
     /* 1168728 */   GIM_Try, /*On fail goto*//*Label 17062*/ GIMT_Encode4(1168808), // Rule ID 15930 //
     /* 1168733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1168744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1168747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1168750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168772 */     // MIs[0] round
     /* 1168772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168807 */     // GIR_Coverage, 15930,
     /* 1168807 */     GIR_EraseRootFromParent_Done,
     /* 1168808 */   // Label 17062: @1168808
     /* 1168808 */   GIM_Try, /*On fail goto*//*Label 17063*/ GIMT_Encode4(1168888), // Rule ID 15931 //
     /* 1168813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1168824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1168827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1168830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168852 */     // MIs[0] round
     /* 1168852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168862 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168887 */     // GIR_Coverage, 15931,
     /* 1168887 */     GIR_EraseRootFromParent_Done,
     /* 1168888 */   // Label 17063: @1168888
     /* 1168888 */   GIM_Try, /*On fail goto*//*Label 17064*/ GIMT_Encode4(1168968), // Rule ID 15934 //
     /* 1168893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1168904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1168907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1168910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168932 */     // MIs[0] round
     /* 1168932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168942 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168967 */     // GIR_Coverage, 15934,
     /* 1168967 */     GIR_EraseRootFromParent_Done,
     /* 1168968 */   // Label 17064: @1168968
     /* 1168968 */   GIM_Try, /*On fail goto*//*Label 17065*/ GIMT_Encode4(1169048), // Rule ID 15935 //
     /* 1168973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1168984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1168987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1168990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169012 */     // MIs[0] round
     /* 1169012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169022 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169047 */     // GIR_Coverage, 15935,
     /* 1169047 */     GIR_EraseRootFromParent_Done,
     /* 1169048 */   // Label 17065: @1169048
     /* 1169048 */   GIM_Try, /*On fail goto*//*Label 17066*/ GIMT_Encode4(1169128), // Rule ID 15938 //
     /* 1169053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1169056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1169064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1169067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1169070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169092 */     // MIs[0] round
     /* 1169092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169102 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169127 */     // GIR_Coverage, 15938,
     /* 1169127 */     GIR_EraseRootFromParent_Done,
     /* 1169128 */   // Label 17066: @1169128
     /* 1169128 */   GIM_Try, /*On fail goto*//*Label 17067*/ GIMT_Encode4(1169208), // Rule ID 15939 //
     /* 1169133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1169136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1169144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1169147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1169150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169172 */     // MIs[0] round
     /* 1169172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169182 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169207 */     // GIR_Coverage, 15939,
     /* 1169207 */     GIR_EraseRootFromParent_Done,
     /* 1169208 */   // Label 17067: @1169208
     /* 1169208 */   GIM_Try, /*On fail goto*//*Label 17068*/ GIMT_Encode4(1169288), // Rule ID 15942 //
     /* 1169213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1169224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1169227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1169230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169252 */     // MIs[0] round
     /* 1169252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169262 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169287 */     // GIR_Coverage, 15942,
     /* 1169287 */     GIR_EraseRootFromParent_Done,
     /* 1169288 */   // Label 17068: @1169288
     /* 1169288 */   GIM_Try, /*On fail goto*//*Label 17069*/ GIMT_Encode4(1169368), // Rule ID 15943 //
     /* 1169293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1169304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1169307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1169310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169332 */     // MIs[0] round
     /* 1169332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169342 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169367 */     // GIR_Coverage, 15943,
     /* 1169367 */     GIR_EraseRootFromParent_Done,
     /* 1169368 */   // Label 17069: @1169368
     /* 1169368 */   GIM_Try, /*On fail goto*//*Label 17070*/ GIMT_Encode4(1169448), // Rule ID 15946 //
     /* 1169373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1169384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1169387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1169390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169412 */     // MIs[0] round
     /* 1169412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169422 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169447 */     // GIR_Coverage, 15946,
     /* 1169447 */     GIR_EraseRootFromParent_Done,
     /* 1169448 */   // Label 17070: @1169448
     /* 1169448 */   GIM_Try, /*On fail goto*//*Label 17071*/ GIMT_Encode4(1169528), // Rule ID 15947 //
     /* 1169453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1169464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1169467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1169470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169492 */     // MIs[0] round
     /* 1169492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169502 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169527 */     // GIR_Coverage, 15947,
     /* 1169527 */     GIR_EraseRootFromParent_Done,
     /* 1169528 */   // Label 17071: @1169528
     /* 1169528 */   GIM_Try, /*On fail goto*//*Label 17072*/ GIMT_Encode4(1169608), // Rule ID 15950 //
     /* 1169533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1169544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1169547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1169550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169572 */     // MIs[0] round
     /* 1169572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169582 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1169585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169607 */     // GIR_Coverage, 15950,
     /* 1169607 */     GIR_EraseRootFromParent_Done,
     /* 1169608 */   // Label 17072: @1169608
     /* 1169608 */   GIM_Try, /*On fail goto*//*Label 17073*/ GIMT_Encode4(1169688), // Rule ID 15951 //
     /* 1169613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1169624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1169627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1169630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169652 */     // MIs[0] round
     /* 1169652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169662 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1169665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169687 */     // GIR_Coverage, 15951,
     /* 1169687 */     GIR_EraseRootFromParent_Done,
     /* 1169688 */   // Label 17073: @1169688
     /* 1169688 */   GIM_Try, /*On fail goto*//*Label 17074*/ GIMT_Encode4(1169768), // Rule ID 15954 //
     /* 1169693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1169704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1169707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1169710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169732 */     // MIs[0] round
     /* 1169732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169742 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169767 */     // GIR_Coverage, 15954,
     /* 1169767 */     GIR_EraseRootFromParent_Done,
     /* 1169768 */   // Label 17074: @1169768
     /* 1169768 */   GIM_Try, /*On fail goto*//*Label 17075*/ GIMT_Encode4(1169848), // Rule ID 15955 //
     /* 1169773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1169784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1169787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1169790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169812 */     // MIs[0] round
     /* 1169812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169822 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169847 */     // GIR_Coverage, 15955,
     /* 1169847 */     GIR_EraseRootFromParent_Done,
     /* 1169848 */   // Label 17075: @1169848
     /* 1169848 */   GIM_Try, /*On fail goto*//*Label 17076*/ GIMT_Encode4(1169928), // Rule ID 15958 //
     /* 1169853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1169864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1169867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1169870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169892 */     // MIs[0] round
     /* 1169892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169902 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169927 */     // GIR_Coverage, 15958,
     /* 1169927 */     GIR_EraseRootFromParent_Done,
     /* 1169928 */   // Label 17076: @1169928
     /* 1169928 */   GIM_Try, /*On fail goto*//*Label 17077*/ GIMT_Encode4(1170008), // Rule ID 15959 //
     /* 1169933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1169944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1169947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1169950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169972 */     // MIs[0] round
     /* 1169972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169982 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170007 */     // GIR_Coverage, 15959,
     /* 1170007 */     GIR_EraseRootFromParent_Done,
     /* 1170008 */   // Label 17077: @1170008
     /* 1170008 */   GIM_Try, /*On fail goto*//*Label 17078*/ GIMT_Encode4(1170088), // Rule ID 15962 //
     /* 1170013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1170024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1170027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1170030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170052 */     // MIs[0] round
     /* 1170052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170062 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170087 */     // GIR_Coverage, 15962,
     /* 1170087 */     GIR_EraseRootFromParent_Done,
     /* 1170088 */   // Label 17078: @1170088
     /* 1170088 */   GIM_Try, /*On fail goto*//*Label 17079*/ GIMT_Encode4(1170168), // Rule ID 15963 //
     /* 1170093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1170104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1170107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1170110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170132 */     // MIs[0] round
     /* 1170132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170142 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170167 */     // GIR_Coverage, 15963,
     /* 1170167 */     GIR_EraseRootFromParent_Done,
     /* 1170168 */   // Label 17079: @1170168
     /* 1170168 */   GIM_Try, /*On fail goto*//*Label 17080*/ GIMT_Encode4(1170248), // Rule ID 15966 //
     /* 1170173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1170184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1170187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1170190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170212 */     // MIs[0] round
     /* 1170212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170222 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170247 */     // GIR_Coverage, 15966,
     /* 1170247 */     GIR_EraseRootFromParent_Done,
     /* 1170248 */   // Label 17080: @1170248
     /* 1170248 */   GIM_Try, /*On fail goto*//*Label 17081*/ GIMT_Encode4(1170328), // Rule ID 15967 //
     /* 1170253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1170264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1170267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1170270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170292 */     // MIs[0] round
     /* 1170292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170327 */     // GIR_Coverage, 15967,
     /* 1170327 */     GIR_EraseRootFromParent_Done,
     /* 1170328 */   // Label 17081: @1170328
     /* 1170328 */   GIM_Try, /*On fail goto*//*Label 17082*/ GIMT_Encode4(1170408), // Rule ID 15970 //
     /* 1170333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1170344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1170347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1170350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170372 */     // MIs[0] round
     /* 1170372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170382 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170407 */     // GIR_Coverage, 15970,
     /* 1170407 */     GIR_EraseRootFromParent_Done,
     /* 1170408 */   // Label 17082: @1170408
     /* 1170408 */   GIM_Try, /*On fail goto*//*Label 17083*/ GIMT_Encode4(1170488), // Rule ID 15971 //
     /* 1170413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1170424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1170427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1170430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170452 */     // MIs[0] round
     /* 1170452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170462 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170487 */     // GIR_Coverage, 15971,
     /* 1170487 */     GIR_EraseRootFromParent_Done,
     /* 1170488 */   // Label 17083: @1170488
     /* 1170488 */   GIM_Try, /*On fail goto*//*Label 17084*/ GIMT_Encode4(1170568), // Rule ID 15974 //
     /* 1170493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1170504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1170507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1170510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170532 */     // MIs[0] round
     /* 1170532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170542 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170567 */     // GIR_Coverage, 15974,
     /* 1170567 */     GIR_EraseRootFromParent_Done,
     /* 1170568 */   // Label 17084: @1170568
     /* 1170568 */   GIM_Try, /*On fail goto*//*Label 17085*/ GIMT_Encode4(1170648), // Rule ID 15975 //
     /* 1170573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1170584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1170587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1170590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170612 */     // MIs[0] round
     /* 1170612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170622 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170647 */     // GIR_Coverage, 15975,
     /* 1170647 */     GIR_EraseRootFromParent_Done,
     /* 1170648 */   // Label 17085: @1170648
     /* 1170648 */   GIM_Try, /*On fail goto*//*Label 17086*/ GIMT_Encode4(1170728), // Rule ID 15978 //
     /* 1170653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1170656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1170664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1170667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1170670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170692 */     // MIs[0] round
     /* 1170692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170727 */     // GIR_Coverage, 15978,
     /* 1170727 */     GIR_EraseRootFromParent_Done,
     /* 1170728 */   // Label 17086: @1170728
     /* 1170728 */   GIM_Try, /*On fail goto*//*Label 17087*/ GIMT_Encode4(1170808), // Rule ID 15979 //
     /* 1170733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1170736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1170744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1170747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1170750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170772 */     // MIs[0] round
     /* 1170772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170782 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170807 */     // GIR_Coverage, 15979,
     /* 1170807 */     GIR_EraseRootFromParent_Done,
     /* 1170808 */   // Label 17087: @1170808
     /* 1170808 */   GIM_Try, /*On fail goto*//*Label 17088*/ GIMT_Encode4(1170888), // Rule ID 15982 //
     /* 1170813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1170816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1170824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1170827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1170830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170852 */     // MIs[0] round
     /* 1170852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170862 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170887 */     // GIR_Coverage, 15982,
     /* 1170887 */     GIR_EraseRootFromParent_Done,
     /* 1170888 */   // Label 17088: @1170888
     /* 1170888 */   GIM_Try, /*On fail goto*//*Label 17089*/ GIMT_Encode4(1170968), // Rule ID 15983 //
     /* 1170893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1170896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1170904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1170907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1170910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170932 */     // MIs[0] round
     /* 1170932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170942 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170967 */     // GIR_Coverage, 15983,
     /* 1170967 */     GIR_EraseRootFromParent_Done,
     /* 1170968 */   // Label 17089: @1170968
     /* 1170968 */   GIM_Try, /*On fail goto*//*Label 17090*/ GIMT_Encode4(1171048), // Rule ID 15986 //
     /* 1170973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1170976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1170984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1170987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1170990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171012 */     // MIs[0] round
     /* 1171012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171022 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1171025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171047 */     // GIR_Coverage, 15986,
     /* 1171047 */     GIR_EraseRootFromParent_Done,
     /* 1171048 */   // Label 17090: @1171048
     /* 1171048 */   GIM_Try, /*On fail goto*//*Label 17091*/ GIMT_Encode4(1171128), // Rule ID 15987 //
     /* 1171053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1171056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1171064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1171067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1171070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171092 */     // MIs[0] round
     /* 1171092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1171105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171127 */     // GIR_Coverage, 15987,
     /* 1171127 */     GIR_EraseRootFromParent_Done,
     /* 1171128 */   // Label 17091: @1171128
     /* 1171128 */   GIM_Try, /*On fail goto*//*Label 17092*/ GIMT_Encode4(1171208), // Rule ID 16078 //
     /* 1171133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1171144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1171147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1171150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1171153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171172 */     // MIs[0] round
     /* 1171172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171182 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1171185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171207 */     // GIR_Coverage, 16078,
     /* 1171207 */     GIR_EraseRootFromParent_Done,
     /* 1171208 */   // Label 17092: @1171208
     /* 1171208 */   GIM_Try, /*On fail goto*//*Label 17093*/ GIMT_Encode4(1171288), // Rule ID 16079 //
     /* 1171213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1171224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1171227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1171230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1171233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171252 */     // MIs[0] round
     /* 1171252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171262 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1171265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171287 */     // GIR_Coverage, 16079,
     /* 1171287 */     GIR_EraseRootFromParent_Done,
     /* 1171288 */   // Label 17093: @1171288
     /* 1171288 */   GIM_Try, /*On fail goto*//*Label 17094*/ GIMT_Encode4(1171368), // Rule ID 16082 //
     /* 1171293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1171304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1171307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1171310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1171313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171332 */     // MIs[0] round
     /* 1171332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171342 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171367 */     // GIR_Coverage, 16082,
     /* 1171367 */     GIR_EraseRootFromParent_Done,
     /* 1171368 */   // Label 17094: @1171368
     /* 1171368 */   GIM_Try, /*On fail goto*//*Label 17095*/ GIMT_Encode4(1171448), // Rule ID 16083 //
     /* 1171373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1171384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1171387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1171390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1171393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171412 */     // MIs[0] round
     /* 1171412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171422 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171447 */     // GIR_Coverage, 16083,
     /* 1171447 */     GIR_EraseRootFromParent_Done,
     /* 1171448 */   // Label 17095: @1171448
     /* 1171448 */   GIM_Try, /*On fail goto*//*Label 17096*/ GIMT_Encode4(1171528), // Rule ID 16086 //
     /* 1171453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1171464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1171467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1171470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1171473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171492 */     // MIs[0] round
     /* 1171492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171502 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171527 */     // GIR_Coverage, 16086,
     /* 1171527 */     GIR_EraseRootFromParent_Done,
     /* 1171528 */   // Label 17096: @1171528
     /* 1171528 */   GIM_Try, /*On fail goto*//*Label 17097*/ GIMT_Encode4(1171608), // Rule ID 16087 //
     /* 1171533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1171544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1171547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1171550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1171553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171572 */     // MIs[0] round
     /* 1171572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171582 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171607 */     // GIR_Coverage, 16087,
     /* 1171607 */     GIR_EraseRootFromParent_Done,
     /* 1171608 */   // Label 17097: @1171608
     /* 1171608 */   GIM_Try, /*On fail goto*//*Label 17098*/ GIMT_Encode4(1171688), // Rule ID 16090 //
     /* 1171613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1171624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1171627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1171630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1171633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171652 */     // MIs[0] round
     /* 1171652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171662 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171687 */     // GIR_Coverage, 16090,
     /* 1171687 */     GIR_EraseRootFromParent_Done,
     /* 1171688 */   // Label 17098: @1171688
     /* 1171688 */   GIM_Try, /*On fail goto*//*Label 17099*/ GIMT_Encode4(1171768), // Rule ID 16091 //
     /* 1171693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1171704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1171707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1171710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1171713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171732 */     // MIs[0] round
     /* 1171732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171742 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171767 */     // GIR_Coverage, 16091,
     /* 1171767 */     GIR_EraseRootFromParent_Done,
     /* 1171768 */   // Label 17099: @1171768
     /* 1171768 */   GIM_Try, /*On fail goto*//*Label 17100*/ GIMT_Encode4(1171848), // Rule ID 16094 //
     /* 1171773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1171784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1171787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1171790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1171793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171812 */     // MIs[0] round
     /* 1171812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171822 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171847 */     // GIR_Coverage, 16094,
     /* 1171847 */     GIR_EraseRootFromParent_Done,
     /* 1171848 */   // Label 17100: @1171848
     /* 1171848 */   GIM_Try, /*On fail goto*//*Label 17101*/ GIMT_Encode4(1171928), // Rule ID 16095 //
     /* 1171853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1171864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1171867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1171870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1171873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171892 */     // MIs[0] round
     /* 1171892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171902 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171927 */     // GIR_Coverage, 16095,
     /* 1171927 */     GIR_EraseRootFromParent_Done,
     /* 1171928 */   // Label 17101: @1171928
     /* 1171928 */   GIM_Try, /*On fail goto*//*Label 17102*/ GIMT_Encode4(1172008), // Rule ID 16098 //
     /* 1171933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1171944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1171947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1171950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1171953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171972 */     // MIs[0] round
     /* 1171972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171982 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172007 */     // GIR_Coverage, 16098,
     /* 1172007 */     GIR_EraseRootFromParent_Done,
     /* 1172008 */   // Label 17102: @1172008
     /* 1172008 */   GIM_Try, /*On fail goto*//*Label 17103*/ GIMT_Encode4(1172088), // Rule ID 16099 //
     /* 1172013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1172024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1172027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1172030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1172033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172052 */     // MIs[0] round
     /* 1172052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172062 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1172065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172087 */     // GIR_Coverage, 16099,
     /* 1172087 */     GIR_EraseRootFromParent_Done,
     /* 1172088 */   // Label 17103: @1172088
     /* 1172088 */   GIM_Try, /*On fail goto*//*Label 17104*/ GIMT_Encode4(1172168), // Rule ID 16102 //
     /* 1172093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1172104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1172107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1172110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1172113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172132 */     // MIs[0] round
     /* 1172132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172142 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172167 */     // GIR_Coverage, 16102,
     /* 1172167 */     GIR_EraseRootFromParent_Done,
     /* 1172168 */   // Label 17104: @1172168
     /* 1172168 */   GIM_Try, /*On fail goto*//*Label 17105*/ GIMT_Encode4(1172248), // Rule ID 16103 //
     /* 1172173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1172184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1172187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1172190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1172193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172212 */     // MIs[0] round
     /* 1172212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172222 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172247 */     // GIR_Coverage, 16103,
     /* 1172247 */     GIR_EraseRootFromParent_Done,
     /* 1172248 */   // Label 17105: @1172248
     /* 1172248 */   GIM_Try, /*On fail goto*//*Label 17106*/ GIMT_Encode4(1172328), // Rule ID 16106 //
     /* 1172253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1172264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1172267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1172270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1172273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172292 */     // MIs[0] round
     /* 1172292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172327 */     // GIR_Coverage, 16106,
     /* 1172327 */     GIR_EraseRootFromParent_Done,
     /* 1172328 */   // Label 17106: @1172328
     /* 1172328 */   GIM_Try, /*On fail goto*//*Label 17107*/ GIMT_Encode4(1172408), // Rule ID 16107 //
     /* 1172333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1172344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1172347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1172350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1172353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172372 */     // MIs[0] round
     /* 1172372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172382 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172407 */     // GIR_Coverage, 16107,
     /* 1172407 */     GIR_EraseRootFromParent_Done,
     /* 1172408 */   // Label 17107: @1172408
     /* 1172408 */   GIM_Try, /*On fail goto*//*Label 17108*/ GIMT_Encode4(1172488), // Rule ID 16110 //
     /* 1172413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1172424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1172427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1172433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172452 */     // MIs[0] round
     /* 1172452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172462 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172487 */     // GIR_Coverage, 16110,
     /* 1172487 */     GIR_EraseRootFromParent_Done,
     /* 1172488 */   // Label 17108: @1172488
     /* 1172488 */   GIM_Try, /*On fail goto*//*Label 17109*/ GIMT_Encode4(1172568), // Rule ID 16111 //
     /* 1172493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1172504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1172507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1172513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172532 */     // MIs[0] round
     /* 1172532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172542 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172567 */     // GIR_Coverage, 16111,
     /* 1172567 */     GIR_EraseRootFromParent_Done,
     /* 1172568 */   // Label 17109: @1172568
     /* 1172568 */   GIM_Try, /*On fail goto*//*Label 17110*/ GIMT_Encode4(1172648), // Rule ID 16114 //
     /* 1172573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1172576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1172584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1172587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1172590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1172593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172612 */     // MIs[0] round
     /* 1172612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172622 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1172643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172647 */     // GIR_Coverage, 16114,
     /* 1172647 */     GIR_EraseRootFromParent_Done,
     /* 1172648 */   // Label 17110: @1172648
     /* 1172648 */   GIM_Try, /*On fail goto*//*Label 17111*/ GIMT_Encode4(1172728), // Rule ID 16115 //
     /* 1172653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1172656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1172664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1172667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1172670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1172673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172692 */     // MIs[0] round
     /* 1172692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1172723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172727 */     // GIR_Coverage, 16115,
     /* 1172727 */     GIR_EraseRootFromParent_Done,
     /* 1172728 */   // Label 17111: @1172728
     /* 1172728 */   GIM_Try, /*On fail goto*//*Label 17112*/ GIMT_Encode4(1172808), // Rule ID 16118 //
     /* 1172733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1172744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1172747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1172750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1172753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172772 */     // MIs[0] round
     /* 1172772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172782 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1172785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172807 */     // GIR_Coverage, 16118,
     /* 1172807 */     GIR_EraseRootFromParent_Done,
     /* 1172808 */   // Label 17112: @1172808
     /* 1172808 */   GIM_Try, /*On fail goto*//*Label 17113*/ GIMT_Encode4(1172888), // Rule ID 16119 //
     /* 1172813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1172824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1172827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1172830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1172833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172852 */     // MIs[0] round
     /* 1172852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172862 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1172865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172887 */     // GIR_Coverage, 16119,
     /* 1172887 */     GIR_EraseRootFromParent_Done,
     /* 1172888 */   // Label 17113: @1172888
     /* 1172888 */   GIM_Try, /*On fail goto*//*Label 17114*/ GIMT_Encode4(1172968), // Rule ID 16122 //
     /* 1172893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1172904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1172907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1172910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1172913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172932 */     // MIs[0] round
     /* 1172932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172942 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1172945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172967 */     // GIR_Coverage, 16122,
     /* 1172967 */     GIR_EraseRootFromParent_Done,
     /* 1172968 */   // Label 17114: @1172968
     /* 1172968 */   GIM_Try, /*On fail goto*//*Label 17115*/ GIMT_Encode4(1173048), // Rule ID 16123 //
     /* 1172973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1172984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1172987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1172990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1172993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173012 */     // MIs[0] round
     /* 1173012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173022 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173047 */     // GIR_Coverage, 16123,
     /* 1173047 */     GIR_EraseRootFromParent_Done,
     /* 1173048 */   // Label 17115: @1173048
     /* 1173048 */   GIM_Try, /*On fail goto*//*Label 17116*/ GIMT_Encode4(1173128), // Rule ID 16126 //
     /* 1173053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1173064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1173067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1173070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1173073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173092 */     // MIs[0] round
     /* 1173092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173102 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173127 */     // GIR_Coverage, 16126,
     /* 1173127 */     GIR_EraseRootFromParent_Done,
     /* 1173128 */   // Label 17116: @1173128
     /* 1173128 */   GIM_Try, /*On fail goto*//*Label 17117*/ GIMT_Encode4(1173208), // Rule ID 16127 //
     /* 1173133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1173144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1173147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1173150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1173153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173172 */     // MIs[0] round
     /* 1173172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173182 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173207 */     // GIR_Coverage, 16127,
     /* 1173207 */     GIR_EraseRootFromParent_Done,
     /* 1173208 */   // Label 17117: @1173208
     /* 1173208 */   GIM_Try, /*On fail goto*//*Label 17118*/ GIMT_Encode4(1173288), // Rule ID 16130 //
     /* 1173213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1173224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1173227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1173230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1173233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173252 */     // MIs[0] round
     /* 1173252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173262 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173287 */     // GIR_Coverage, 16130,
     /* 1173287 */     GIR_EraseRootFromParent_Done,
     /* 1173288 */   // Label 17118: @1173288
     /* 1173288 */   GIM_Try, /*On fail goto*//*Label 17119*/ GIMT_Encode4(1173368), // Rule ID 16131 //
     /* 1173293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1173304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1173307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1173310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1173313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173332 */     // MIs[0] round
     /* 1173332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173342 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173367 */     // GIR_Coverage, 16131,
     /* 1173367 */     GIR_EraseRootFromParent_Done,
     /* 1173368 */   // Label 17119: @1173368
     /* 1173368 */   GIM_Try, /*On fail goto*//*Label 17120*/ GIMT_Encode4(1173448), // Rule ID 16134 //
     /* 1173373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1173384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1173387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1173393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173412 */     // MIs[0] round
     /* 1173412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173422 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173447 */     // GIR_Coverage, 16134,
     /* 1173447 */     GIR_EraseRootFromParent_Done,
     /* 1173448 */   // Label 17120: @1173448
     /* 1173448 */   GIM_Try, /*On fail goto*//*Label 17121*/ GIMT_Encode4(1173528), // Rule ID 16135 //
     /* 1173453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1173464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1173467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1173473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173492 */     // MIs[0] round
     /* 1173492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173502 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173527 */     // GIR_Coverage, 16135,
     /* 1173527 */     GIR_EraseRootFromParent_Done,
     /* 1173528 */   // Label 17121: @1173528
     /* 1173528 */   GIM_Try, /*On fail goto*//*Label 17122*/ GIMT_Encode4(1173608), // Rule ID 16138 //
     /* 1173533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1173544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1173547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1173550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1173553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173572 */     // MIs[0] round
     /* 1173572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173582 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173607 */     // GIR_Coverage, 16138,
     /* 1173607 */     GIR_EraseRootFromParent_Done,
     /* 1173608 */   // Label 17122: @1173608
     /* 1173608 */   GIM_Try, /*On fail goto*//*Label 17123*/ GIMT_Encode4(1173688), // Rule ID 16139 //
     /* 1173613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1173624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1173627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1173630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1173633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173652 */     // MIs[0] round
     /* 1173652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173662 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173687 */     // GIR_Coverage, 16139,
     /* 1173687 */     GIR_EraseRootFromParent_Done,
     /* 1173688 */   // Label 17123: @1173688
     /* 1173688 */   GIM_Try, /*On fail goto*//*Label 17124*/ GIMT_Encode4(1173768), // Rule ID 16142 //
     /* 1173693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1173704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1173707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1173710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1173713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173732 */     // MIs[0] round
     /* 1173732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173742 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173767 */     // GIR_Coverage, 16142,
     /* 1173767 */     GIR_EraseRootFromParent_Done,
     /* 1173768 */   // Label 17124: @1173768
     /* 1173768 */   GIM_Try, /*On fail goto*//*Label 17125*/ GIMT_Encode4(1173848), // Rule ID 16143 //
     /* 1173773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1173784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1173787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1173790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1173793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173812 */     // MIs[0] round
     /* 1173812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173847 */     // GIR_Coverage, 16143,
     /* 1173847 */     GIR_EraseRootFromParent_Done,
     /* 1173848 */   // Label 17125: @1173848
     /* 1173848 */   GIM_Try, /*On fail goto*//*Label 17126*/ GIMT_Encode4(1173928), // Rule ID 16146 //
     /* 1173853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1173864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1173867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1173870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1173873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173892 */     // MIs[0] round
     /* 1173892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173927 */     // GIR_Coverage, 16146,
     /* 1173927 */     GIR_EraseRootFromParent_Done,
     /* 1173928 */   // Label 17126: @1173928
     /* 1173928 */   GIM_Try, /*On fail goto*//*Label 17127*/ GIMT_Encode4(1174008), // Rule ID 16147 //
     /* 1173933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1173944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1173947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1173950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1173953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173972 */     // MIs[0] round
     /* 1173972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173982 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174007 */     // GIR_Coverage, 16147,
     /* 1174007 */     GIR_EraseRootFromParent_Done,
     /* 1174008 */   // Label 17127: @1174008
     /* 1174008 */   GIM_Try, /*On fail goto*//*Label 17128*/ GIMT_Encode4(1174088), // Rule ID 16150 //
     /* 1174013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1174024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1174027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1174030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1174033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174052 */     // MIs[0] round
     /* 1174052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174062 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174087 */     // GIR_Coverage, 16150,
     /* 1174087 */     GIR_EraseRootFromParent_Done,
     /* 1174088 */   // Label 17128: @1174088
     /* 1174088 */   GIM_Try, /*On fail goto*//*Label 17129*/ GIMT_Encode4(1174168), // Rule ID 16151 //
     /* 1174093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1174104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1174107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1174110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1174113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174132 */     // MIs[0] round
     /* 1174132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174142 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174167 */     // GIR_Coverage, 16151,
     /* 1174167 */     GIR_EraseRootFromParent_Done,
     /* 1174168 */   // Label 17129: @1174168
     /* 1174168 */   GIM_Try, /*On fail goto*//*Label 17130*/ GIMT_Encode4(1174248), // Rule ID 16154 //
     /* 1174173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1174184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1174187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1174190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1174193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174212 */     // MIs[0] round
     /* 1174212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174222 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1174225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174247 */     // GIR_Coverage, 16154,
     /* 1174247 */     GIR_EraseRootFromParent_Done,
     /* 1174248 */   // Label 17130: @1174248
     /* 1174248 */   GIM_Try, /*On fail goto*//*Label 17131*/ GIMT_Encode4(1174328), // Rule ID 16155 //
     /* 1174253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1174264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1174267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1174270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1174273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174292 */     // MIs[0] round
     /* 1174292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1174305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174327 */     // GIR_Coverage, 16155,
     /* 1174327 */     GIR_EraseRootFromParent_Done,
     /* 1174328 */   // Label 17131: @1174328
     /* 1174328 */   GIM_Try, /*On fail goto*//*Label 17132*/ GIMT_Encode4(1174408), // Rule ID 16158 //
     /* 1174333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1174344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1174347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1174353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174372 */     // MIs[0] round
     /* 1174372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174382 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174407 */     // GIR_Coverage, 16158,
     /* 1174407 */     GIR_EraseRootFromParent_Done,
     /* 1174408 */   // Label 17132: @1174408
     /* 1174408 */   GIM_Try, /*On fail goto*//*Label 17133*/ GIMT_Encode4(1174488), // Rule ID 16159 //
     /* 1174413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1174424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1174427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1174433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174452 */     // MIs[0] round
     /* 1174452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174462 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174487 */     // GIR_Coverage, 16159,
     /* 1174487 */     GIR_EraseRootFromParent_Done,
     /* 1174488 */   // Label 17133: @1174488
     /* 1174488 */   GIM_Try, /*On fail goto*//*Label 17134*/ GIMT_Encode4(1174568), // Rule ID 16162 //
     /* 1174493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1174504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1174507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1174510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1174513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174532 */     // MIs[0] round
     /* 1174532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174542 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174567 */     // GIR_Coverage, 16162,
     /* 1174567 */     GIR_EraseRootFromParent_Done,
     /* 1174568 */   // Label 17134: @1174568
     /* 1174568 */   GIM_Try, /*On fail goto*//*Label 17135*/ GIMT_Encode4(1174648), // Rule ID 16163 //
     /* 1174573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1174584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1174587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1174590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1174593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174612 */     // MIs[0] round
     /* 1174612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174622 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174647 */     // GIR_Coverage, 16163,
     /* 1174647 */     GIR_EraseRootFromParent_Done,
     /* 1174648 */   // Label 17135: @1174648
     /* 1174648 */   GIM_Try, /*On fail goto*//*Label 17136*/ GIMT_Encode4(1174728), // Rule ID 16166 //
     /* 1174653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1174664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1174667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1174670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174692 */     // MIs[0] round
     /* 1174692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174702 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1174705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174727 */     // GIR_Coverage, 16166,
     /* 1174727 */     GIR_EraseRootFromParent_Done,
     /* 1174728 */   // Label 17136: @1174728
     /* 1174728 */   GIM_Try, /*On fail goto*//*Label 17137*/ GIMT_Encode4(1174808), // Rule ID 16167 //
     /* 1174733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1174744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1174747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1174750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174772 */     // MIs[0] round
     /* 1174772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174782 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1174785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174807 */     // GIR_Coverage, 16167,
     /* 1174807 */     GIR_EraseRootFromParent_Done,
     /* 1174808 */   // Label 17137: @1174808
     /* 1174808 */   GIM_Try, /*On fail goto*//*Label 17138*/ GIMT_Encode4(1174888), // Rule ID 16170 //
     /* 1174813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1174824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1174827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1174830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174852 */     // MIs[0] round
     /* 1174852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174862 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1174865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174887 */     // GIR_Coverage, 16170,
     /* 1174887 */     GIR_EraseRootFromParent_Done,
     /* 1174888 */   // Label 17138: @1174888
     /* 1174888 */   GIM_Try, /*On fail goto*//*Label 17139*/ GIMT_Encode4(1174968), // Rule ID 16171 //
     /* 1174893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1174904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1174907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1174910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174932 */     // MIs[0] round
     /* 1174932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174942 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1174945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174967 */     // GIR_Coverage, 16171,
     /* 1174967 */     GIR_EraseRootFromParent_Done,
     /* 1174968 */   // Label 17139: @1174968
     /* 1174968 */   GIM_Try, /*On fail goto*//*Label 17140*/ GIMT_Encode4(1175048), // Rule ID 16174 //
     /* 1174973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1174984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1174987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1174990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175012 */     // MIs[0] round
     /* 1175012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175022 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175047 */     // GIR_Coverage, 16174,
     /* 1175047 */     GIR_EraseRootFromParent_Done,
     /* 1175048 */   // Label 17140: @1175048
     /* 1175048 */   GIM_Try, /*On fail goto*//*Label 17141*/ GIMT_Encode4(1175128), // Rule ID 16175 //
     /* 1175053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1175064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1175067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1175070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175092 */     // MIs[0] round
     /* 1175092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175102 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175127 */     // GIR_Coverage, 16175,
     /* 1175127 */     GIR_EraseRootFromParent_Done,
     /* 1175128 */   // Label 17141: @1175128
     /* 1175128 */   GIM_Try, /*On fail goto*//*Label 17142*/ GIMT_Encode4(1175208), // Rule ID 16178 //
     /* 1175133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1175144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1175147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1175150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175172 */     // MIs[0] round
     /* 1175172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175182 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1175185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175207 */     // GIR_Coverage, 16178,
     /* 1175207 */     GIR_EraseRootFromParent_Done,
     /* 1175208 */   // Label 17142: @1175208
     /* 1175208 */   GIM_Try, /*On fail goto*//*Label 17143*/ GIMT_Encode4(1175288), // Rule ID 16179 //
     /* 1175213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1175224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1175227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1175230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175252 */     // MIs[0] round
     /* 1175252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175262 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1175265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175287 */     // GIR_Coverage, 16179,
     /* 1175287 */     GIR_EraseRootFromParent_Done,
     /* 1175288 */   // Label 17143: @1175288
     /* 1175288 */   GIM_Try, /*On fail goto*//*Label 17144*/ GIMT_Encode4(1175368), // Rule ID 16182 //
     /* 1175293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1175304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1175307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1175310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175332 */     // MIs[0] round
     /* 1175332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175342 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175367 */     // GIR_Coverage, 16182,
     /* 1175367 */     GIR_EraseRootFromParent_Done,
     /* 1175368 */   // Label 17144: @1175368
     /* 1175368 */   GIM_Try, /*On fail goto*//*Label 17145*/ GIMT_Encode4(1175448), // Rule ID 16183 //
     /* 1175373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1175384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1175387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1175390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175412 */     // MIs[0] round
     /* 1175412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175422 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175447 */     // GIR_Coverage, 16183,
     /* 1175447 */     GIR_EraseRootFromParent_Done,
     /* 1175448 */   // Label 17145: @1175448
     /* 1175448 */   GIM_Try, /*On fail goto*//*Label 17146*/ GIMT_Encode4(1175528), // Rule ID 16186 //
     /* 1175453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1175464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1175467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1175470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175492 */     // MIs[0] round
     /* 1175492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175527 */     // GIR_Coverage, 16186,
     /* 1175527 */     GIR_EraseRootFromParent_Done,
     /* 1175528 */   // Label 17146: @1175528
     /* 1175528 */   GIM_Try, /*On fail goto*//*Label 17147*/ GIMT_Encode4(1175608), // Rule ID 16187 //
     /* 1175533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1175544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1175547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1175550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175572 */     // MIs[0] round
     /* 1175572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175582 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175607 */     // GIR_Coverage, 16187,
     /* 1175607 */     GIR_EraseRootFromParent_Done,
     /* 1175608 */   // Label 17147: @1175608
     /* 1175608 */   GIM_Try, /*On fail goto*//*Label 17148*/ GIMT_Encode4(1175688), // Rule ID 16190 //
     /* 1175613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1175624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1175627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1175630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175652 */     // MIs[0] round
     /* 1175652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175662 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175687 */     // GIR_Coverage, 16190,
     /* 1175687 */     GIR_EraseRootFromParent_Done,
     /* 1175688 */   // Label 17148: @1175688
     /* 1175688 */   GIM_Try, /*On fail goto*//*Label 17149*/ GIMT_Encode4(1175768), // Rule ID 16191 //
     /* 1175693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1175704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1175707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1175710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175732 */     // MIs[0] round
     /* 1175732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175742 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11613:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175767 */     // GIR_Coverage, 16191,
     /* 1175767 */     GIR_EraseRootFromParent_Done,
     /* 1175768 */   // Label 17149: @1175768
     /* 1175768 */   GIM_Try, /*On fail goto*//*Label 17150*/ GIMT_Encode4(1175848), // Rule ID 16194 //
     /* 1175773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1175784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1175787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1175790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175812 */     // MIs[0] round
     /* 1175812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175822 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175847 */     // GIR_Coverage, 16194,
     /* 1175847 */     GIR_EraseRootFromParent_Done,
     /* 1175848 */   // Label 17150: @1175848
     /* 1175848 */   GIM_Try, /*On fail goto*//*Label 17151*/ GIMT_Encode4(1175928), // Rule ID 16195 //
     /* 1175853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1175864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1175867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1175870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175892 */     // MIs[0] round
     /* 1175892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175927 */     // GIR_Coverage, 16195,
     /* 1175927 */     GIR_EraseRootFromParent_Done,
     /* 1175928 */   // Label 17151: @1175928
     /* 1175928 */   GIM_Try, /*On fail goto*//*Label 17152*/ GIMT_Encode4(1176008), // Rule ID 16198 //
     /* 1175933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1175944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1175947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1175950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175972 */     // MIs[0] round
     /* 1175972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175982 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1176003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176007 */     // GIR_Coverage, 16198,
     /* 1176007 */     GIR_EraseRootFromParent_Done,
     /* 1176008 */   // Label 17152: @1176008
     /* 1176008 */   GIM_Try, /*On fail goto*//*Label 17153*/ GIMT_Encode4(1176088), // Rule ID 16199 //
     /* 1176013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1176024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1176027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1176030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176052 */     // MIs[0] round
     /* 1176052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176062 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1176083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176087 */     // GIR_Coverage, 16199,
     /* 1176087 */     GIR_EraseRootFromParent_Done,
     /* 1176088 */   // Label 17153: @1176088
     /* 1176088 */   GIM_Try, /*On fail goto*//*Label 17154*/ GIMT_Encode4(1176168), // Rule ID 16202 //
     /* 1176093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1176096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1176104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1176107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1176110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176132 */     // MIs[0] round
     /* 1176132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176142 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1176163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176167 */     // GIR_Coverage, 16202,
     /* 1176167 */     GIR_EraseRootFromParent_Done,
     /* 1176168 */   // Label 17154: @1176168
     /* 1176168 */   GIM_Try, /*On fail goto*//*Label 17155*/ GIMT_Encode4(1176248), // Rule ID 16203 //
     /* 1176173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1176176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1176184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1176187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1176190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176212 */     // MIs[0] round
     /* 1176212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176222 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1176243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176247 */     // GIR_Coverage, 16203,
     /* 1176247 */     GIR_EraseRootFromParent_Done,
     /* 1176248 */   // Label 17155: @1176248
     /* 1176248 */   GIM_Try, /*On fail goto*//*Label 17156*/ GIMT_Encode4(1176328), // Rule ID 16206 //
     /* 1176253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1176264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1176267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1176270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176292 */     // MIs[0] round
     /* 1176292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176302 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176327 */     // GIR_Coverage, 16206,
     /* 1176327 */     GIR_EraseRootFromParent_Done,
     /* 1176328 */   // Label 17156: @1176328
     /* 1176328 */   GIM_Try, /*On fail goto*//*Label 17157*/ GIMT_Encode4(1176408), // Rule ID 16207 //
     /* 1176333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1176344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1176347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1176350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176372 */     // MIs[0] round
     /* 1176372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176382 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176407 */     // GIR_Coverage, 16207,
     /* 1176407 */     GIR_EraseRootFromParent_Done,
     /* 1176408 */   // Label 17157: @1176408
     /* 1176408 */   GIM_Try, /*On fail goto*//*Label 17158*/ GIMT_Encode4(1176488), // Rule ID 16210 //
     /* 1176413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176452 */     // MIs[0] round
     /* 1176452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176462 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1176465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176487 */     // GIR_Coverage, 16210,
     /* 1176487 */     GIR_EraseRootFromParent_Done,
     /* 1176488 */   // Label 17158: @1176488
     /* 1176488 */   GIM_Try, /*On fail goto*//*Label 17159*/ GIMT_Encode4(1176568), // Rule ID 16211 //
     /* 1176493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176532 */     // MIs[0] round
     /* 1176532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176542 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1176545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176567 */     // GIR_Coverage, 16211,
     /* 1176567 */     GIR_EraseRootFromParent_Done,
     /* 1176568 */   // Label 17159: @1176568
     /* 1176568 */   GIM_Try, /*On fail goto*//*Label 17160*/ GIMT_Encode4(1176648), // Rule ID 16214 //
     /* 1176573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1176584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1176587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1176590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176612 */     // MIs[0] round
     /* 1176612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176622 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1176625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176647 */     // GIR_Coverage, 16214,
     /* 1176647 */     GIR_EraseRootFromParent_Done,
     /* 1176648 */   // Label 17160: @1176648
     /* 1176648 */   GIM_Try, /*On fail goto*//*Label 17161*/ GIMT_Encode4(1176728), // Rule ID 16215 //
     /* 1176653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1176664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1176667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1176670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176692 */     // MIs[0] round
     /* 1176692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176702 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1176705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176727 */     // GIR_Coverage, 16215,
     /* 1176727 */     GIR_EraseRootFromParent_Done,
     /* 1176728 */   // Label 17161: @1176728
     /* 1176728 */   GIM_Try, /*On fail goto*//*Label 17162*/ GIMT_Encode4(1176808), // Rule ID 16218 //
     /* 1176733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1176744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1176747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1176750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176772 */     // MIs[0] round
     /* 1176772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176807 */     // GIR_Coverage, 16218,
     /* 1176807 */     GIR_EraseRootFromParent_Done,
     /* 1176808 */   // Label 17162: @1176808
     /* 1176808 */   GIM_Try, /*On fail goto*//*Label 17163*/ GIMT_Encode4(1176888), // Rule ID 16219 //
     /* 1176813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1176824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1176827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1176830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176852 */     // MIs[0] round
     /* 1176852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176862 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176887 */     // GIR_Coverage, 16219,
     /* 1176887 */     GIR_EraseRootFromParent_Done,
     /* 1176888 */   // Label 17163: @1176888
     /* 1176888 */   GIM_Try, /*On fail goto*//*Label 17164*/ GIMT_Encode4(1176968), // Rule ID 16222 //
     /* 1176893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1176904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1176907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1176910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176932 */     // MIs[0] round
     /* 1176932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176942 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1176945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176967 */     // GIR_Coverage, 16222,
     /* 1176967 */     GIR_EraseRootFromParent_Done,
     /* 1176968 */   // Label 17164: @1176968
     /* 1176968 */   GIM_Try, /*On fail goto*//*Label 17165*/ GIMT_Encode4(1177048), // Rule ID 16223 //
     /* 1176973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1176984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1176987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1176990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177012 */     // MIs[0] round
     /* 1177012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177022 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177047 */     // GIR_Coverage, 16223,
     /* 1177047 */     GIR_EraseRootFromParent_Done,
     /* 1177048 */   // Label 17165: @1177048
     /* 1177048 */   GIM_Try, /*On fail goto*//*Label 17166*/ GIMT_Encode4(1177128), // Rule ID 16226 //
     /* 1177053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1177064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1177067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1177070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177092 */     // MIs[0] round
     /* 1177092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177102 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177127 */     // GIR_Coverage, 16226,
     /* 1177127 */     GIR_EraseRootFromParent_Done,
     /* 1177128 */   // Label 17166: @1177128
     /* 1177128 */   GIM_Try, /*On fail goto*//*Label 17167*/ GIMT_Encode4(1177208), // Rule ID 16227 //
     /* 1177133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1177144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1177147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1177150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177172 */     // MIs[0] round
     /* 1177172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177182 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177207 */     // GIR_Coverage, 16227,
     /* 1177207 */     GIR_EraseRootFromParent_Done,
     /* 1177208 */   // Label 17167: @1177208
     /* 1177208 */   GIM_Try, /*On fail goto*//*Label 17168*/ GIMT_Encode4(1177288), // Rule ID 16230 //
     /* 1177213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1177224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1177227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177252 */     // MIs[0] round
     /* 1177252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177287 */     // GIR_Coverage, 16230,
     /* 1177287 */     GIR_EraseRootFromParent_Done,
     /* 1177288 */   // Label 17168: @1177288
     /* 1177288 */   GIM_Try, /*On fail goto*//*Label 17169*/ GIMT_Encode4(1177368), // Rule ID 16231 //
     /* 1177293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1177304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1177307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177332 */     // MIs[0] round
     /* 1177332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177367 */     // GIR_Coverage, 16231,
     /* 1177367 */     GIR_EraseRootFromParent_Done,
     /* 1177368 */   // Label 17169: @1177368
     /* 1177368 */   GIM_Try, /*On fail goto*//*Label 17170*/ GIMT_Encode4(1177448), // Rule ID 16234 //
     /* 1177373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1177384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1177387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177412 */     // MIs[0] round
     /* 1177412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177447 */     // GIR_Coverage, 16234,
     /* 1177447 */     GIR_EraseRootFromParent_Done,
     /* 1177448 */   // Label 17170: @1177448
     /* 1177448 */   GIM_Try, /*On fail goto*//*Label 17171*/ GIMT_Encode4(1177528), // Rule ID 16235 //
     /* 1177453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1177464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1177467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177492 */     // MIs[0] round
     /* 1177492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177527 */     // GIR_Coverage, 16235,
     /* 1177527 */     GIR_EraseRootFromParent_Done,
     /* 1177528 */   // Label 17171: @1177528
     /* 1177528 */   GIM_Try, /*On fail goto*//*Label 17172*/ GIMT_Encode4(1177608), // Rule ID 16238 //
     /* 1177533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1177544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1177547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1177550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177572 */     // MIs[0] round
     /* 1177572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177582 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177607 */     // GIR_Coverage, 16238,
     /* 1177607 */     GIR_EraseRootFromParent_Done,
     /* 1177608 */   // Label 17172: @1177608
     /* 1177608 */   GIM_Try, /*On fail goto*//*Label 17173*/ GIMT_Encode4(1177688), // Rule ID 16239 //
     /* 1177613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1177624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1177627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1177630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177652 */     // MIs[0] round
     /* 1177652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177662 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177687 */     // GIR_Coverage, 16239,
     /* 1177687 */     GIR_EraseRootFromParent_Done,
     /* 1177688 */   // Label 17173: @1177688
     /* 1177688 */   GIM_Try, /*On fail goto*//*Label 17174*/ GIMT_Encode4(1177768), // Rule ID 16242 //
     /* 1177693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1177696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1177704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1177707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1177710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177732 */     // MIs[0] round
     /* 1177732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177742 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177767 */     // GIR_Coverage, 16242,
     /* 1177767 */     GIR_EraseRootFromParent_Done,
     /* 1177768 */   // Label 17174: @1177768
     /* 1177768 */   GIM_Try, /*On fail goto*//*Label 17175*/ GIMT_Encode4(1177848), // Rule ID 16243 //
     /* 1177773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1177776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1177784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1177787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1177790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177812 */     // MIs[0] round
     /* 1177812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177822 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177847 */     // GIR_Coverage, 16243,
     /* 1177847 */     GIR_EraseRootFromParent_Done,
     /* 1177848 */   // Label 17175: @1177848
     /* 1177848 */   GIM_Try, /*On fail goto*//*Label 17176*/ GIMT_Encode4(1177928), // Rule ID 16246 //
     /* 1177853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1177856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1177864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1177867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1177870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177892 */     // MIs[0] round
     /* 1177892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177902 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177927 */     // GIR_Coverage, 16246,
     /* 1177927 */     GIR_EraseRootFromParent_Done,
     /* 1177928 */   // Label 17176: @1177928
     /* 1177928 */   GIM_Try, /*On fail goto*//*Label 17177*/ GIMT_Encode4(1178008), // Rule ID 16247 //
     /* 1177933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1177936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1177944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1177947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1177950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177972 */     // MIs[0] round
     /* 1177972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177982 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178007 */     // GIR_Coverage, 16247,
     /* 1178007 */     GIR_EraseRootFromParent_Done,
     /* 1178008 */   // Label 17177: @1178008
     /* 1178008 */   GIM_Try, /*On fail goto*//*Label 17178*/ GIMT_Encode4(1178088), // Rule ID 16250 //
     /* 1178013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1178016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1178024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1178027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1178030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178052 */     // MIs[0] round
     /* 1178052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178062 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1178065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178087 */     // GIR_Coverage, 16250,
     /* 1178087 */     GIR_EraseRootFromParent_Done,
     /* 1178088 */   // Label 17178: @1178088
     /* 1178088 */   GIM_Try, /*On fail goto*//*Label 17179*/ GIMT_Encode4(1178168), // Rule ID 16251 //
     /* 1178093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1178096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1178104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1178107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1178110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178132 */     // MIs[0] round
     /* 1178132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178142 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1178145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178167 */     // GIR_Coverage, 16251,
     /* 1178167 */     GIR_EraseRootFromParent_Done,
     /* 1178168 */   // Label 17179: @1178168
     /* 1178168 */   GIM_Try, /*On fail goto*//*Label 17180*/ GIMT_Encode4(1178251), // Rule ID 16342 //
     /* 1178173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1178184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1178187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1178190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1178193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178212 */     // MIs[0] round
     /* 1178212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178222 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1178225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178250 */     // GIR_Coverage, 16342,
     /* 1178250 */     GIR_EraseRootFromParent_Done,
     /* 1178251 */   // Label 17180: @1178251
     /* 1178251 */   GIM_Try, /*On fail goto*//*Label 17181*/ GIMT_Encode4(1178334), // Rule ID 16343 //
     /* 1178256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1178267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1178270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1178273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1178276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178295 */     // MIs[0] round
     /* 1178295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178305 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1178308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178316 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178333 */     // GIR_Coverage, 16343,
     /* 1178333 */     GIR_EraseRootFromParent_Done,
     /* 1178334 */   // Label 17181: @1178334
     /* 1178334 */   GIM_Try, /*On fail goto*//*Label 17182*/ GIMT_Encode4(1178417), // Rule ID 16346 //
     /* 1178339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1178359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178378 */     // MIs[0] round
     /* 1178378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178388 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1178391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178416 */     // GIR_Coverage, 16346,
     /* 1178416 */     GIR_EraseRootFromParent_Done,
     /* 1178417 */   // Label 17182: @1178417
     /* 1178417 */   GIM_Try, /*On fail goto*//*Label 17183*/ GIMT_Encode4(1178500), // Rule ID 16347 //
     /* 1178422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1178442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178461 */     // MIs[0] round
     /* 1178461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178471 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1178474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178482 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178499 */     // GIR_Coverage, 16347,
     /* 1178499 */     GIR_EraseRootFromParent_Done,
     /* 1178500 */   // Label 17183: @1178500
     /* 1178500 */   GIM_Try, /*On fail goto*//*Label 17184*/ GIMT_Encode4(1178583), // Rule ID 16350 //
     /* 1178505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1178516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1178519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1178522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1178525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178544 */     // MIs[0] round
     /* 1178544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178554 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1178557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178582 */     // GIR_Coverage, 16350,
     /* 1178582 */     GIR_EraseRootFromParent_Done,
     /* 1178583 */   // Label 17184: @1178583
     /* 1178583 */   GIM_Try, /*On fail goto*//*Label 17185*/ GIMT_Encode4(1178666), // Rule ID 16351 //
     /* 1178588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1178599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1178602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1178605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1178608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178627 */     // MIs[0] round
     /* 1178627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178637 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1178640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178648 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178661 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178665 */     // GIR_Coverage, 16351,
     /* 1178665 */     GIR_EraseRootFromParent_Done,
     /* 1178666 */   // Label 17185: @1178666
     /* 1178666 */   GIM_Try, /*On fail goto*//*Label 17186*/ GIMT_Encode4(1178749), // Rule ID 16354 //
     /* 1178671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1178682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1178685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1178688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1178691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178710 */     // MIs[0] round
     /* 1178710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178720 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1178723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178748 */     // GIR_Coverage, 16354,
     /* 1178748 */     GIR_EraseRootFromParent_Done,
     /* 1178749 */   // Label 17186: @1178749
     /* 1178749 */   GIM_Try, /*On fail goto*//*Label 17187*/ GIMT_Encode4(1178832), // Rule ID 16355 //
     /* 1178754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1178765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1178768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1178771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1178774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178793 */     // MIs[0] round
     /* 1178793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178803 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1178806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178814 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178831 */     // GIR_Coverage, 16355,
     /* 1178831 */     GIR_EraseRootFromParent_Done,
     /* 1178832 */   // Label 17187: @1178832
     /* 1178832 */   GIM_Try, /*On fail goto*//*Label 17188*/ GIMT_Encode4(1178915), // Rule ID 16358 //
     /* 1178837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1178848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1178851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1178854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1178857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178876 */     // MIs[0] round
     /* 1178876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178886 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1178889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178914 */     // GIR_Coverage, 16358,
     /* 1178914 */     GIR_EraseRootFromParent_Done,
     /* 1178915 */   // Label 17188: @1178915
     /* 1178915 */   GIM_Try, /*On fail goto*//*Label 17189*/ GIMT_Encode4(1178998), // Rule ID 16359 //
     /* 1178920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1178931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1178934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1178937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1178940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178959 */     // MIs[0] round
     /* 1178959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178969 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1178972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178980 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178997 */     // GIR_Coverage, 16359,
     /* 1178997 */     GIR_EraseRootFromParent_Done,
     /* 1178998 */   // Label 17189: @1178998
     /* 1178998 */   GIM_Try, /*On fail goto*//*Label 17190*/ GIMT_Encode4(1179081), // Rule ID 16362 //
     /* 1179003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1179014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1179017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1179020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1179023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179042 */     // MIs[0] round
     /* 1179042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179052 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179076 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179080 */     // GIR_Coverage, 16362,
     /* 1179080 */     GIR_EraseRootFromParent_Done,
     /* 1179081 */   // Label 17190: @1179081
     /* 1179081 */   GIM_Try, /*On fail goto*//*Label 17191*/ GIMT_Encode4(1179164), // Rule ID 16363 //
     /* 1179086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1179097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1179100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1179103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1179106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179125 */     // MIs[0] round
     /* 1179125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179135 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179146 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179163 */     // GIR_Coverage, 16363,
     /* 1179163 */     GIR_EraseRootFromParent_Done,
     /* 1179164 */   // Label 17191: @1179164
     /* 1179164 */   GIM_Try, /*On fail goto*//*Label 17192*/ GIMT_Encode4(1179247), // Rule ID 16366 //
     /* 1179169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1179180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1179183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1179186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1179189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179208 */     // MIs[0] round
     /* 1179208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179218 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1179221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179246 */     // GIR_Coverage, 16366,
     /* 1179246 */     GIR_EraseRootFromParent_Done,
     /* 1179247 */   // Label 17192: @1179247
     /* 1179247 */   GIM_Try, /*On fail goto*//*Label 17193*/ GIMT_Encode4(1179330), // Rule ID 16367 //
     /* 1179252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1179263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1179266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1179269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1179272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179291 */     // MIs[0] round
     /* 1179291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179301 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1179304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179312 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179329 */     // GIR_Coverage, 16367,
     /* 1179329 */     GIR_EraseRootFromParent_Done,
     /* 1179330 */   // Label 17193: @1179330
     /* 1179330 */   GIM_Try, /*On fail goto*//*Label 17194*/ GIMT_Encode4(1179413), // Rule ID 16370 //
     /* 1179335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1179355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179374 */     // MIs[0] round
     /* 1179374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179384 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179412 */     // GIR_Coverage, 16370,
     /* 1179412 */     GIR_EraseRootFromParent_Done,
     /* 1179413 */   // Label 17194: @1179413
     /* 1179413 */   GIM_Try, /*On fail goto*//*Label 17195*/ GIMT_Encode4(1179496), // Rule ID 16371 //
     /* 1179418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1179438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179457 */     // MIs[0] round
     /* 1179457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179467 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179478 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179495 */     // GIR_Coverage, 16371,
     /* 1179495 */     GIR_EraseRootFromParent_Done,
     /* 1179496 */   // Label 17195: @1179496
     /* 1179496 */   GIM_Try, /*On fail goto*//*Label 17196*/ GIMT_Encode4(1179579), // Rule ID 16374 //
     /* 1179501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1179512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1179515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1179518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1179521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179540 */     // MIs[0] round
     /* 1179540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179550 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1179553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179578 */     // GIR_Coverage, 16374,
     /* 1179578 */     GIR_EraseRootFromParent_Done,
     /* 1179579 */   // Label 17196: @1179579
     /* 1179579 */   GIM_Try, /*On fail goto*//*Label 17197*/ GIMT_Encode4(1179662), // Rule ID 16375 //
     /* 1179584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1179595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1179598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1179601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1179604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179623 */     // MIs[0] round
     /* 1179623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179633 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1179636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179644 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179657 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179661 */     // GIR_Coverage, 16375,
     /* 1179661 */     GIR_EraseRootFromParent_Done,
     /* 1179662 */   // Label 17197: @1179662
     /* 1179662 */   GIM_Try, /*On fail goto*//*Label 17198*/ GIMT_Encode4(1179745), // Rule ID 16378 //
     /* 1179667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1179678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1179681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1179684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1179687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179706 */     // MIs[0] round
     /* 1179706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1179719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179744 */     // GIR_Coverage, 16378,
     /* 1179744 */     GIR_EraseRootFromParent_Done,
     /* 1179745 */   // Label 17198: @1179745
     /* 1179745 */   GIM_Try, /*On fail goto*//*Label 17199*/ GIMT_Encode4(1179828), // Rule ID 16379 //
     /* 1179750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1179761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1179764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1179767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1179770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179789 */     // MIs[0] round
     /* 1179789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179799 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1179802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179810 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179827 */     // GIR_Coverage, 16379,
     /* 1179827 */     GIR_EraseRootFromParent_Done,
     /* 1179828 */   // Label 17199: @1179828
     /* 1179828 */   GIM_Try, /*On fail goto*//*Label 17200*/ GIMT_Encode4(1179911), // Rule ID 16382 //
     /* 1179833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1179844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1179847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1179850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1179853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179872 */     // MIs[0] round
     /* 1179872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179882 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179910 */     // GIR_Coverage, 16382,
     /* 1179910 */     GIR_EraseRootFromParent_Done,
     /* 1179911 */   // Label 17200: @1179911
     /* 1179911 */   GIM_Try, /*On fail goto*//*Label 17201*/ GIMT_Encode4(1179994), // Rule ID 16383 //
     /* 1179916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1179927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1179930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1179933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1179936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179955 */     // MIs[0] round
     /* 1179955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179965 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179976 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179993 */     // GIR_Coverage, 16383,
     /* 1179993 */     GIR_EraseRootFromParent_Done,
     /* 1179994 */   // Label 17201: @1179994
     /* 1179994 */   GIM_Try, /*On fail goto*//*Label 17202*/ GIMT_Encode4(1180077), // Rule ID 16386 //
     /* 1179999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1180010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1180013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1180016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1180019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180038 */     // MIs[0] round
     /* 1180038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180048 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1180051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180076 */     // GIR_Coverage, 16386,
     /* 1180076 */     GIR_EraseRootFromParent_Done,
     /* 1180077 */   // Label 17202: @1180077
     /* 1180077 */   GIM_Try, /*On fail goto*//*Label 17203*/ GIMT_Encode4(1180160), // Rule ID 16387 //
     /* 1180082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1180093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1180096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1180099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1180102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180121 */     // MIs[0] round
     /* 1180121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180131 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1180134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180142 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180159 */     // GIR_Coverage, 16387,
     /* 1180159 */     GIR_EraseRootFromParent_Done,
     /* 1180160 */   // Label 17203: @1180160
     /* 1180160 */   GIM_Try, /*On fail goto*//*Label 17204*/ GIMT_Encode4(1180243), // Rule ID 16390 //
     /* 1180165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1180176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1180179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1180182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1180185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180204 */     // MIs[0] round
     /* 1180204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180214 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1180217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180242 */     // GIR_Coverage, 16390,
     /* 1180242 */     GIR_EraseRootFromParent_Done,
     /* 1180243 */   // Label 17204: @1180243
     /* 1180243 */   GIM_Try, /*On fail goto*//*Label 17205*/ GIMT_Encode4(1180326), // Rule ID 16391 //
     /* 1180248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1180259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1180262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1180265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1180268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180287 */     // MIs[0] round
     /* 1180287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180297 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1180300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180308 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180325 */     // GIR_Coverage, 16391,
     /* 1180325 */     GIR_EraseRootFromParent_Done,
     /* 1180326 */   // Label 17205: @1180326
     /* 1180326 */   GIM_Try, /*On fail goto*//*Label 17206*/ GIMT_Encode4(1180409), // Rule ID 16394 //
     /* 1180331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1180342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1180345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1180348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1180351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180370 */     // MIs[0] round
     /* 1180370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180380 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180408 */     // GIR_Coverage, 16394,
     /* 1180408 */     GIR_EraseRootFromParent_Done,
     /* 1180409 */   // Label 17206: @1180409
     /* 1180409 */   GIM_Try, /*On fail goto*//*Label 17207*/ GIMT_Encode4(1180492), // Rule ID 16395 //
     /* 1180414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1180425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1180428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1180431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1180434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180453 */     // MIs[0] round
     /* 1180453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180474 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180491 */     // GIR_Coverage, 16395,
     /* 1180491 */     GIR_EraseRootFromParent_Done,
     /* 1180492 */   // Label 17207: @1180492
     /* 1180492 */   GIM_Try, /*On fail goto*//*Label 17208*/ GIMT_Encode4(1180575), // Rule ID 16398 //
     /* 1180497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1180508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1180511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1180514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1180517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180536 */     // MIs[0] round
     /* 1180536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1180549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180574 */     // GIR_Coverage, 16398,
     /* 1180574 */     GIR_EraseRootFromParent_Done,
     /* 1180575 */   // Label 17208: @1180575
     /* 1180575 */   GIM_Try, /*On fail goto*//*Label 17209*/ GIMT_Encode4(1180658), // Rule ID 16399 //
     /* 1180580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1180591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1180594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1180597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1180600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180619 */     // MIs[0] round
     /* 1180619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180629 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1180632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180640 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180657 */     // GIR_Coverage, 16399,
     /* 1180657 */     GIR_EraseRootFromParent_Done,
     /* 1180658 */   // Label 17209: @1180658
     /* 1180658 */   GIM_Try, /*On fail goto*//*Label 17210*/ GIMT_Encode4(1180741), // Rule ID 16402 //
     /* 1180663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1180674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1180677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1180680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180702 */     // MIs[0] round
     /* 1180702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180712 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1180715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180740 */     // GIR_Coverage, 16402,
     /* 1180740 */     GIR_EraseRootFromParent_Done,
     /* 1180741 */   // Label 17210: @1180741
     /* 1180741 */   GIM_Try, /*On fail goto*//*Label 17211*/ GIMT_Encode4(1180824), // Rule ID 16403 //
     /* 1180746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1180757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1180760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1180763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180785 */     // MIs[0] round
     /* 1180785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180795 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1180798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180823 */     // GIR_Coverage, 16403,
     /* 1180823 */     GIR_EraseRootFromParent_Done,
     /* 1180824 */   // Label 17211: @1180824
     /* 1180824 */   GIM_Try, /*On fail goto*//*Label 17212*/ GIMT_Encode4(1180907), // Rule ID 16406 //
     /* 1180829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1180840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1180843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1180846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180868 */     // MIs[0] round
     /* 1180868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180878 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1180881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180902 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180906 */     // GIR_Coverage, 16406,
     /* 1180906 */     GIR_EraseRootFromParent_Done,
     /* 1180907 */   // Label 17212: @1180907
     /* 1180907 */   GIM_Try, /*On fail goto*//*Label 17213*/ GIMT_Encode4(1180990), // Rule ID 16407 //
     /* 1180912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1180923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1180926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1180929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180951 */     // MIs[0] round
     /* 1180951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180961 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1180964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180972 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180989 */     // GIR_Coverage, 16407,
     /* 1180989 */     GIR_EraseRootFromParent_Done,
     /* 1180990 */   // Label 17213: @1180990
     /* 1180990 */   GIM_Try, /*On fail goto*//*Label 17214*/ GIMT_Encode4(1181073), // Rule ID 16410 //
     /* 1180995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1181006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1181009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1181012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181034 */     // MIs[0] round
     /* 1181034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181044 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181068 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181072 */     // GIR_Coverage, 16410,
     /* 1181072 */     GIR_EraseRootFromParent_Done,
     /* 1181073 */   // Label 17214: @1181073
     /* 1181073 */   GIM_Try, /*On fail goto*//*Label 17215*/ GIMT_Encode4(1181156), // Rule ID 16411 //
     /* 1181078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1181089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1181092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1181095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181117 */     // MIs[0] round
     /* 1181117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181127 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181138 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181155 */     // GIR_Coverage, 16411,
     /* 1181155 */     GIR_EraseRootFromParent_Done,
     /* 1181156 */   // Label 17215: @1181156
     /* 1181156 */   GIM_Try, /*On fail goto*//*Label 17216*/ GIMT_Encode4(1181239), // Rule ID 16414 //
     /* 1181161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1181172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1181175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1181178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181200 */     // MIs[0] round
     /* 1181200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181210 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1181213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181238 */     // GIR_Coverage, 16414,
     /* 1181238 */     GIR_EraseRootFromParent_Done,
     /* 1181239 */   // Label 17216: @1181239
     /* 1181239 */   GIM_Try, /*On fail goto*//*Label 17217*/ GIMT_Encode4(1181322), // Rule ID 16415 //
     /* 1181244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1181255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1181258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1181261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181283 */     // MIs[0] round
     /* 1181283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181293 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1181296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181304 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181317 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181321 */     // GIR_Coverage, 16415,
     /* 1181321 */     GIR_EraseRootFromParent_Done,
     /* 1181322 */   // Label 17217: @1181322
     /* 1181322 */   GIM_Try, /*On fail goto*//*Label 17218*/ GIMT_Encode4(1181405), // Rule ID 16418 //
     /* 1181327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1181338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1181341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1181344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181366 */     // MIs[0] round
     /* 1181366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181376 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1181379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181404 */     // GIR_Coverage, 16418,
     /* 1181404 */     GIR_EraseRootFromParent_Done,
     /* 1181405 */   // Label 17218: @1181405
     /* 1181405 */   GIM_Try, /*On fail goto*//*Label 17219*/ GIMT_Encode4(1181488), // Rule ID 16419 //
     /* 1181410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1181421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1181424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1181427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181449 */     // MIs[0] round
     /* 1181449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1181462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181487 */     // GIR_Coverage, 16419,
     /* 1181487 */     GIR_EraseRootFromParent_Done,
     /* 1181488 */   // Label 17219: @1181488
     /* 1181488 */   GIM_Try, /*On fail goto*//*Label 17220*/ GIMT_Encode4(1181571), // Rule ID 16422 //
     /* 1181493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1181504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1181507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1181510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181532 */     // MIs[0] round
     /* 1181532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181542 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1181545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181570 */     // GIR_Coverage, 16422,
     /* 1181570 */     GIR_EraseRootFromParent_Done,
     /* 1181571 */   // Label 17220: @1181571
     /* 1181571 */   GIM_Try, /*On fail goto*//*Label 17221*/ GIMT_Encode4(1181654), // Rule ID 16423 //
     /* 1181576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1181587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1181590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1181593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181615 */     // MIs[0] round
     /* 1181615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181625 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1181628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181636 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181653 */     // GIR_Coverage, 16423,
     /* 1181653 */     GIR_EraseRootFromParent_Done,
     /* 1181654 */   // Label 17221: @1181654
     /* 1181654 */   GIM_Try, /*On fail goto*//*Label 17222*/ GIMT_Encode4(1181737), // Rule ID 16426 //
     /* 1181659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1181670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1181673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1181676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181698 */     // MIs[0] round
     /* 1181698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181708 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1181711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181736 */     // GIR_Coverage, 16426,
     /* 1181736 */     GIR_EraseRootFromParent_Done,
     /* 1181737 */   // Label 17222: @1181737
     /* 1181737 */   GIM_Try, /*On fail goto*//*Label 17223*/ GIMT_Encode4(1181820), // Rule ID 16427 //
     /* 1181742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1181753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1181756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1181759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181781 */     // MIs[0] round
     /* 1181781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181791 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1181794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181802 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181819 */     // GIR_Coverage, 16427,
     /* 1181819 */     GIR_EraseRootFromParent_Done,
     /* 1181820 */   // Label 17223: @1181820
     /* 1181820 */   GIM_Try, /*On fail goto*//*Label 17224*/ GIMT_Encode4(1181903), // Rule ID 16430 //
     /* 1181825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1181836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1181839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1181842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181864 */     // MIs[0] round
     /* 1181864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181874 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181902 */     // GIR_Coverage, 16430,
     /* 1181902 */     GIR_EraseRootFromParent_Done,
     /* 1181903 */   // Label 17224: @1181903
     /* 1181903 */   GIM_Try, /*On fail goto*//*Label 17225*/ GIMT_Encode4(1181986), // Rule ID 16431 //
     /* 1181908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1181919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1181922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1181925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181947 */     // MIs[0] round
     /* 1181947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181957 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181968 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181985 */     // GIR_Coverage, 16431,
     /* 1181985 */     GIR_EraseRootFromParent_Done,
     /* 1181986 */   // Label 17225: @1181986
     /* 1181986 */   GIM_Try, /*On fail goto*//*Label 17226*/ GIMT_Encode4(1182069), // Rule ID 16434 //
     /* 1181991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1182002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1182005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1182008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182030 */     // MIs[0] round
     /* 1182030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182068 */     // GIR_Coverage, 16434,
     /* 1182068 */     GIR_EraseRootFromParent_Done,
     /* 1182069 */   // Label 17226: @1182069
     /* 1182069 */   GIM_Try, /*On fail goto*//*Label 17227*/ GIMT_Encode4(1182152), // Rule ID 16435 //
     /* 1182074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1182085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1182088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1182091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182113 */     // MIs[0] round
     /* 1182113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182123 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182134 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182151 */     // GIR_Coverage, 16435,
     /* 1182151 */     GIR_EraseRootFromParent_Done,
     /* 1182152 */   // Label 17227: @1182152
     /* 1182152 */   GIM_Try, /*On fail goto*//*Label 17228*/ GIMT_Encode4(1182235), // Rule ID 16438 //
     /* 1182157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1182168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1182171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1182174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182196 */     // MIs[0] round
     /* 1182196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182234 */     // GIR_Coverage, 16438,
     /* 1182234 */     GIR_EraseRootFromParent_Done,
     /* 1182235 */   // Label 17228: @1182235
     /* 1182235 */   GIM_Try, /*On fail goto*//*Label 17229*/ GIMT_Encode4(1182318), // Rule ID 16439 //
     /* 1182240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1182251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1182254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1182257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182279 */     // MIs[0] round
     /* 1182279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182289 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182300 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182317 */     // GIR_Coverage, 16439,
     /* 1182317 */     GIR_EraseRootFromParent_Done,
     /* 1182318 */   // Label 17229: @1182318
     /* 1182318 */   GIM_Try, /*On fail goto*//*Label 17230*/ GIMT_Encode4(1182401), // Rule ID 16442 //
     /* 1182323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1182334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1182337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1182340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182362 */     // MIs[0] round
     /* 1182362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182372 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182400 */     // GIR_Coverage, 16442,
     /* 1182400 */     GIR_EraseRootFromParent_Done,
     /* 1182401 */   // Label 17230: @1182401
     /* 1182401 */   GIM_Try, /*On fail goto*//*Label 17231*/ GIMT_Encode4(1182484), // Rule ID 16443 //
     /* 1182406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1182417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1182420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1182423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182445 */     // MIs[0] round
     /* 1182445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182455 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182466 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182479 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182483 */     // GIR_Coverage, 16443,
     /* 1182483 */     GIR_EraseRootFromParent_Done,
     /* 1182484 */   // Label 17231: @1182484
     /* 1182484 */   GIM_Try, /*On fail goto*//*Label 17232*/ GIMT_Encode4(1182567), // Rule ID 16446 //
     /* 1182489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1182500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1182503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1182506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182528 */     // MIs[0] round
     /* 1182528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1182541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182566 */     // GIR_Coverage, 16446,
     /* 1182566 */     GIR_EraseRootFromParent_Done,
     /* 1182567 */   // Label 17232: @1182567
     /* 1182567 */   GIM_Try, /*On fail goto*//*Label 17233*/ GIMT_Encode4(1182650), // Rule ID 16447 //
     /* 1182572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1182575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1182583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1182586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1182589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182611 */     // MIs[0] round
     /* 1182611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182621 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1182624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182632 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182649 */     // GIR_Coverage, 16447,
     /* 1182649 */     GIR_EraseRootFromParent_Done,
     /* 1182650 */   // Label 17233: @1182650
     /* 1182650 */   GIM_Try, /*On fail goto*//*Label 17234*/ GIMT_Encode4(1182733), // Rule ID 16450 //
     /* 1182655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1182666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1182669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1182672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182694 */     // MIs[0] round
     /* 1182694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182704 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182732 */     // GIR_Coverage, 16450,
     /* 1182732 */     GIR_EraseRootFromParent_Done,
     /* 1182733 */   // Label 17234: @1182733
     /* 1182733 */   GIM_Try, /*On fail goto*//*Label 17235*/ GIMT_Encode4(1182816), // Rule ID 16451 //
     /* 1182738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1182741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1182749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1182752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1182755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182777 */     // MIs[0] round
     /* 1182777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182787 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182798 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182815 */     // GIR_Coverage, 16451,
     /* 1182815 */     GIR_EraseRootFromParent_Done,
     /* 1182816 */   // Label 17235: @1182816
     /* 1182816 */   GIM_Try, /*On fail goto*//*Label 17236*/ GIMT_Encode4(1182899), // Rule ID 16454 //
     /* 1182821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1182832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1182835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1182838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182860 */     // MIs[0] round
     /* 1182860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182898 */     // GIR_Coverage, 16454,
     /* 1182898 */     GIR_EraseRootFromParent_Done,
     /* 1182899 */   // Label 17236: @1182899
     /* 1182899 */   GIM_Try, /*On fail goto*//*Label 17237*/ GIMT_Encode4(1182982), // Rule ID 16455 //
     /* 1182904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1182907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1182915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1182918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1182921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182943 */     // MIs[0] round
     /* 1182943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182953 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182964 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182981 */     // GIR_Coverage, 16455,
     /* 1182981 */     GIR_EraseRootFromParent_Done,
     /* 1182982 */   // Label 17237: @1182982
     /* 1182982 */   GIM_Try, /*On fail goto*//*Label 17238*/ GIMT_Encode4(1183065), // Rule ID 16458 //
     /* 1182987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1182998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1183001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1183004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1183007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183026 */     // MIs[0] round
     /* 1183026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1183039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183064 */     // GIR_Coverage, 16458,
     /* 1183064 */     GIR_EraseRootFromParent_Done,
     /* 1183065 */   // Label 17238: @1183065
     /* 1183065 */   GIM_Try, /*On fail goto*//*Label 17239*/ GIMT_Encode4(1183148), // Rule ID 16459 //
     /* 1183070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1183081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1183084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1183087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1183090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183109 */     // MIs[0] round
     /* 1183109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183119 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1183122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183130 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183147 */     // GIR_Coverage, 16459,
     /* 1183147 */     GIR_EraseRootFromParent_Done,
     /* 1183148 */   // Label 17239: @1183148
     /* 1183148 */   GIM_Try, /*On fail goto*//*Label 17240*/ GIMT_Encode4(1183231), // Rule ID 16522 //
     /* 1183153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1183164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1183167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1183170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1183173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183192 */     // MIs[0] round
     /* 1183192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183202 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1183205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183230 */     // GIR_Coverage, 16522,
     /* 1183230 */     GIR_EraseRootFromParent_Done,
     /* 1183231 */   // Label 17240: @1183231
     /* 1183231 */   GIM_Try, /*On fail goto*//*Label 17241*/ GIMT_Encode4(1183314), // Rule ID 16523 //
     /* 1183236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1183247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1183250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1183253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1183256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183275 */     // MIs[0] round
     /* 1183275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183285 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1183288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183296 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183313 */     // GIR_Coverage, 16523,
     /* 1183313 */     GIR_EraseRootFromParent_Done,
     /* 1183314 */   // Label 17241: @1183314
     /* 1183314 */   GIM_Try, /*On fail goto*//*Label 17242*/ GIMT_Encode4(1183397), // Rule ID 16526 //
     /* 1183319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1183330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1183333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1183336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1183339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183358 */     // MIs[0] round
     /* 1183358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183368 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1183371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183396 */     // GIR_Coverage, 16526,
     /* 1183396 */     GIR_EraseRootFromParent_Done,
     /* 1183397 */   // Label 17242: @1183397
     /* 1183397 */   GIM_Try, /*On fail goto*//*Label 17243*/ GIMT_Encode4(1183480), // Rule ID 16527 //
     /* 1183402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1183413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1183416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1183419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1183422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183441 */     // MIs[0] round
     /* 1183441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183451 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1183454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183462 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183479 */     // GIR_Coverage, 16527,
     /* 1183479 */     GIR_EraseRootFromParent_Done,
     /* 1183480 */   // Label 17243: @1183480
     /* 1183480 */   GIM_Try, /*On fail goto*//*Label 17244*/ GIMT_Encode4(1183563), // Rule ID 16530 //
     /* 1183485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1183496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1183499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1183502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1183505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183524 */     // MIs[0] round
     /* 1183524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183534 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1183537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183562 */     // GIR_Coverage, 16530,
     /* 1183562 */     GIR_EraseRootFromParent_Done,
     /* 1183563 */   // Label 17244: @1183563
     /* 1183563 */   GIM_Try, /*On fail goto*//*Label 17245*/ GIMT_Encode4(1183646), // Rule ID 16531 //
     /* 1183568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1183579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1183582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1183585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1183588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183607 */     // MIs[0] round
     /* 1183607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183617 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1183620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183628 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183645 */     // GIR_Coverage, 16531,
     /* 1183645 */     GIR_EraseRootFromParent_Done,
     /* 1183646 */   // Label 17245: @1183646
     /* 1183646 */   GIM_Try, /*On fail goto*//*Label 17246*/ GIMT_Encode4(1183729), // Rule ID 16534 //
     /* 1183651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1183662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1183665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1183668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1183671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183690 */     // MIs[0] round
     /* 1183690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183700 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1183703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183728 */     // GIR_Coverage, 16534,
     /* 1183728 */     GIR_EraseRootFromParent_Done,
     /* 1183729 */   // Label 17246: @1183729
     /* 1183729 */   GIM_Try, /*On fail goto*//*Label 17247*/ GIMT_Encode4(1183812), // Rule ID 16535 //
     /* 1183734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1183745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1183748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1183751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1183754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183773 */     // MIs[0] round
     /* 1183773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183783 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1183786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183794 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183811 */     // GIR_Coverage, 16535,
     /* 1183811 */     GIR_EraseRootFromParent_Done,
     /* 1183812 */   // Label 17247: @1183812
     /* 1183812 */   GIM_Try, /*On fail goto*//*Label 17248*/ GIMT_Encode4(1183895), // Rule ID 16538 //
     /* 1183817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1183828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1183831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1183834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1183837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183856 */     // MIs[0] round
     /* 1183856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183866 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1183869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183894 */     // GIR_Coverage, 16538,
     /* 1183894 */     GIR_EraseRootFromParent_Done,
     /* 1183895 */   // Label 17248: @1183895
     /* 1183895 */   GIM_Try, /*On fail goto*//*Label 17249*/ GIMT_Encode4(1183978), // Rule ID 16539 //
     /* 1183900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1183911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1183914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1183917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1183920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183939 */     // MIs[0] round
     /* 1183939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183949 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1183952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183960 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183977 */     // GIR_Coverage, 16539,
     /* 1183977 */     GIR_EraseRootFromParent_Done,
     /* 1183978 */   // Label 17249: @1183978
     /* 1183978 */   GIM_Try, /*On fail goto*//*Label 17250*/ GIMT_Encode4(1184061), // Rule ID 16542 //
     /* 1183983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1183994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1183997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1184000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1184003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184022 */     // MIs[0] round
     /* 1184022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184032 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184060 */     // GIR_Coverage, 16542,
     /* 1184060 */     GIR_EraseRootFromParent_Done,
     /* 1184061 */   // Label 17250: @1184061
     /* 1184061 */   GIM_Try, /*On fail goto*//*Label 17251*/ GIMT_Encode4(1184144), // Rule ID 16543 //
     /* 1184066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1184077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1184080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1184083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1184086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184105 */     // MIs[0] round
     /* 1184105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184115 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184143 */     // GIR_Coverage, 16543,
     /* 1184143 */     GIR_EraseRootFromParent_Done,
     /* 1184144 */   // Label 17251: @1184144
     /* 1184144 */   GIM_Try, /*On fail goto*//*Label 17252*/ GIMT_Encode4(1184227), // Rule ID 16546 //
     /* 1184149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1184160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1184163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1184166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1184169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184188 */     // MIs[0] round
     /* 1184188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184198 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1184201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184226 */     // GIR_Coverage, 16546,
     /* 1184226 */     GIR_EraseRootFromParent_Done,
     /* 1184227 */   // Label 17252: @1184227
     /* 1184227 */   GIM_Try, /*On fail goto*//*Label 17253*/ GIMT_Encode4(1184310), // Rule ID 16547 //
     /* 1184232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1184243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1184246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1184249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1184252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184271 */     // MIs[0] round
     /* 1184271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184281 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1184284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184292 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184309 */     // GIR_Coverage, 16547,
     /* 1184309 */     GIR_EraseRootFromParent_Done,
     /* 1184310 */   // Label 17253: @1184310
     /* 1184310 */   GIM_Try, /*On fail goto*//*Label 17254*/ GIMT_Encode4(1184393), // Rule ID 16550 //
     /* 1184315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1184326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1184329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1184332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1184335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184354 */     // MIs[0] round
     /* 1184354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184364 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184392 */     // GIR_Coverage, 16550,
     /* 1184392 */     GIR_EraseRootFromParent_Done,
     /* 1184393 */   // Label 17254: @1184393
     /* 1184393 */   GIM_Try, /*On fail goto*//*Label 17255*/ GIMT_Encode4(1184476), // Rule ID 16551 //
     /* 1184398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1184409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1184412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1184415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1184418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184437 */     // MIs[0] round
     /* 1184437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184447 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184458 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184475 */     // GIR_Coverage, 16551,
     /* 1184475 */     GIR_EraseRootFromParent_Done,
     /* 1184476 */   // Label 17255: @1184476
     /* 1184476 */   GIM_Try, /*On fail goto*//*Label 17256*/ GIMT_Encode4(1184559), // Rule ID 16554 //
     /* 1184481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1184492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1184495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1184498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1184501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184520 */     // MIs[0] round
     /* 1184520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184530 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184558 */     // GIR_Coverage, 16554,
     /* 1184558 */     GIR_EraseRootFromParent_Done,
     /* 1184559 */   // Label 17256: @1184559
     /* 1184559 */   GIM_Try, /*On fail goto*//*Label 17257*/ GIMT_Encode4(1184642), // Rule ID 16555 //
     /* 1184564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1184575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1184578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1184581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1184584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184603 */     // MIs[0] round
     /* 1184603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184613 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184624 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184641 */     // GIR_Coverage, 16555,
     /* 1184641 */     GIR_EraseRootFromParent_Done,
     /* 1184642 */   // Label 17257: @1184642
     /* 1184642 */   GIM_Try, /*On fail goto*//*Label 17258*/ GIMT_Encode4(1184725), // Rule ID 16558 //
     /* 1184647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1184658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1184661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1184664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1184667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184686 */     // MIs[0] round
     /* 1184686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184696 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1184699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184724 */     // GIR_Coverage, 16558,
     /* 1184724 */     GIR_EraseRootFromParent_Done,
     /* 1184725 */   // Label 17258: @1184725
     /* 1184725 */   GIM_Try, /*On fail goto*//*Label 17259*/ GIMT_Encode4(1184808), // Rule ID 16559 //
     /* 1184730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1184741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1184744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1184747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1184750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184769 */     // MIs[0] round
     /* 1184769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184779 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1184782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184807 */     // GIR_Coverage, 16559,
     /* 1184807 */     GIR_EraseRootFromParent_Done,
     /* 1184808 */   // Label 17259: @1184808
     /* 1184808 */   GIM_Try, /*On fail goto*//*Label 17260*/ GIMT_Encode4(1184891), // Rule ID 16562 //
     /* 1184813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1184824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1184827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1184830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1184833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184852 */     // MIs[0] round
     /* 1184852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184862 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184890 */     // GIR_Coverage, 16562,
     /* 1184890 */     GIR_EraseRootFromParent_Done,
     /* 1184891 */   // Label 17260: @1184891
     /* 1184891 */   GIM_Try, /*On fail goto*//*Label 17261*/ GIMT_Encode4(1184974), // Rule ID 16563 //
     /* 1184896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1184907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1184910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1184913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1184916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184935 */     // MIs[0] round
     /* 1184935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184945 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184956 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184973 */     // GIR_Coverage, 16563,
     /* 1184973 */     GIR_EraseRootFromParent_Done,
     /* 1184974 */   // Label 17261: @1184974
     /* 1184974 */   GIM_Try, /*On fail goto*//*Label 17262*/ GIMT_Encode4(1185057), // Rule ID 16566 //
     /* 1184979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1184982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1184990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1184993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1184996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1184999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185018 */     // MIs[0] round
     /* 1185018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185028 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1185031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185056 */     // GIR_Coverage, 16566,
     /* 1185056 */     GIR_EraseRootFromParent_Done,
     /* 1185057 */   // Label 17262: @1185057
     /* 1185057 */   GIM_Try, /*On fail goto*//*Label 17263*/ GIMT_Encode4(1185140), // Rule ID 16567 //
     /* 1185062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1185073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1185076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1185079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1185082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185101 */     // MIs[0] round
     /* 1185101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185111 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1185114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185122 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185139 */     // GIR_Coverage, 16567,
     /* 1185139 */     GIR_EraseRootFromParent_Done,
     /* 1185140 */   // Label 17263: @1185140
     /* 1185140 */   GIM_Try, /*On fail goto*//*Label 17264*/ GIMT_Encode4(1185223), // Rule ID 16570 //
     /* 1185145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1185156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1185159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1185162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1185165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185184 */     // MIs[0] round
     /* 1185184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185194 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1185197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185222 */     // GIR_Coverage, 16570,
     /* 1185222 */     GIR_EraseRootFromParent_Done,
     /* 1185223 */   // Label 17264: @1185223
     /* 1185223 */   GIM_Try, /*On fail goto*//*Label 17265*/ GIMT_Encode4(1185306), // Rule ID 16571 //
     /* 1185228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1185239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1185242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1185245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1185248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185267 */     // MIs[0] round
     /* 1185267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1185280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185288 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185305 */     // GIR_Coverage, 16571,
     /* 1185305 */     GIR_EraseRootFromParent_Done,
     /* 1185306 */   // Label 17265: @1185306
     /* 1185306 */   GIM_Try, /*On fail goto*//*Label 17266*/ GIMT_Encode4(1185389), // Rule ID 16574 //
     /* 1185311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1185322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1185325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1185331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185350 */     // MIs[0] round
     /* 1185350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185360 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185388 */     // GIR_Coverage, 16574,
     /* 1185388 */     GIR_EraseRootFromParent_Done,
     /* 1185389 */   // Label 17266: @1185389
     /* 1185389 */   GIM_Try, /*On fail goto*//*Label 17267*/ GIMT_Encode4(1185472), // Rule ID 16575 //
     /* 1185394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1185405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1185408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1185414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185433 */     // MIs[0] round
     /* 1185433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185443 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185454 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185471 */     // GIR_Coverage, 16575,
     /* 1185471 */     GIR_EraseRootFromParent_Done,
     /* 1185472 */   // Label 17267: @1185472
     /* 1185472 */   GIM_Try, /*On fail goto*//*Label 17268*/ GIMT_Encode4(1185555), // Rule ID 16578 //
     /* 1185477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1185488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1185491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1185494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1185497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185516 */     // MIs[0] round
     /* 1185516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185526 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1185529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185554 */     // GIR_Coverage, 16578,
     /* 1185554 */     GIR_EraseRootFromParent_Done,
     /* 1185555 */   // Label 17268: @1185555
     /* 1185555 */   GIM_Try, /*On fail goto*//*Label 17269*/ GIMT_Encode4(1185638), // Rule ID 16579 //
     /* 1185560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1185571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1185574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1185577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1185580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185599 */     // MIs[0] round
     /* 1185599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185609 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1185612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185620 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185637 */     // GIR_Coverage, 16579,
     /* 1185637 */     GIR_EraseRootFromParent_Done,
     /* 1185638 */   // Label 17269: @1185638
     /* 1185638 */   GIM_Try, /*On fail goto*//*Label 17270*/ GIMT_Encode4(1185721), // Rule ID 16582 //
     /* 1185643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1185654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1185657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1185660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185682 */     // MIs[0] round
     /* 1185682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185692 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1185695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185720 */     // GIR_Coverage, 16582,
     /* 1185720 */     GIR_EraseRootFromParent_Done,
     /* 1185721 */   // Label 17270: @1185721
     /* 1185721 */   GIM_Try, /*On fail goto*//*Label 17271*/ GIMT_Encode4(1185804), // Rule ID 16583 //
     /* 1185726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1185737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1185740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1185743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185765 */     // MIs[0] round
     /* 1185765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185775 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1185778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185786 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185803 */     // GIR_Coverage, 16583,
     /* 1185803 */     GIR_EraseRootFromParent_Done,
     /* 1185804 */   // Label 17271: @1185804
     /* 1185804 */   GIM_Try, /*On fail goto*//*Label 17272*/ GIMT_Encode4(1185887), // Rule ID 16586 //
     /* 1185809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1185820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1185823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1185826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185848 */     // MIs[0] round
     /* 1185848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185858 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1185861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185886 */     // GIR_Coverage, 16586,
     /* 1185886 */     GIR_EraseRootFromParent_Done,
     /* 1185887 */   // Label 17272: @1185887
     /* 1185887 */   GIM_Try, /*On fail goto*//*Label 17273*/ GIMT_Encode4(1185970), // Rule ID 16587 //
     /* 1185892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1185903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1185906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1185909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185931 */     // MIs[0] round
     /* 1185931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185941 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1185944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185952 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185969 */     // GIR_Coverage, 16587,
     /* 1185969 */     GIR_EraseRootFromParent_Done,
     /* 1185970 */   // Label 17273: @1185970
     /* 1185970 */   GIM_Try, /*On fail goto*//*Label 17274*/ GIMT_Encode4(1186053), // Rule ID 16590 //
     /* 1185975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1185986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1185989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1185992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186014 */     // MIs[0] round
     /* 1186014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186024 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186048 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186052 */     // GIR_Coverage, 16590,
     /* 1186052 */     GIR_EraseRootFromParent_Done,
     /* 1186053 */   // Label 17274: @1186053
     /* 1186053 */   GIM_Try, /*On fail goto*//*Label 17275*/ GIMT_Encode4(1186136), // Rule ID 16591 //
     /* 1186058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1186069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1186072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1186075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186097 */     // MIs[0] round
     /* 1186097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186107 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186118 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186131 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186135 */     // GIR_Coverage, 16591,
     /* 1186135 */     GIR_EraseRootFromParent_Done,
     /* 1186136 */   // Label 17275: @1186136
     /* 1186136 */   GIM_Try, /*On fail goto*//*Label 17276*/ GIMT_Encode4(1186219), // Rule ID 16594 //
     /* 1186141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1186152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1186155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1186158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186180 */     // MIs[0] round
     /* 1186180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186190 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1186193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186218 */     // GIR_Coverage, 16594,
     /* 1186218 */     GIR_EraseRootFromParent_Done,
     /* 1186219 */   // Label 17276: @1186219
     /* 1186219 */   GIM_Try, /*On fail goto*//*Label 17277*/ GIMT_Encode4(1186302), // Rule ID 16595 //
     /* 1186224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1186235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1186238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1186241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186263 */     // MIs[0] round
     /* 1186263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186273 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1186276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186284 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186301 */     // GIR_Coverage, 16595,
     /* 1186301 */     GIR_EraseRootFromParent_Done,
     /* 1186302 */   // Label 17277: @1186302
     /* 1186302 */   GIM_Try, /*On fail goto*//*Label 17278*/ GIMT_Encode4(1186385), // Rule ID 16598 //
     /* 1186307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1186318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1186321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1186324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186346 */     // MIs[0] round
     /* 1186346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186356 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1186359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186384 */     // GIR_Coverage, 16598,
     /* 1186384 */     GIR_EraseRootFromParent_Done,
     /* 1186385 */   // Label 17278: @1186385
     /* 1186385 */   GIM_Try, /*On fail goto*//*Label 17279*/ GIMT_Encode4(1186468), // Rule ID 16599 //
     /* 1186390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1186401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1186404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1186407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186429 */     // MIs[0] round
     /* 1186429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186439 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1186442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186450 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186463 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186467 */     // GIR_Coverage, 16599,
     /* 1186467 */     GIR_EraseRootFromParent_Done,
     /* 1186468 */   // Label 17279: @1186468
     /* 1186468 */   GIM_Try, /*On fail goto*//*Label 17280*/ GIMT_Encode4(1186551), // Rule ID 16602 //
     /* 1186473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1186484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1186487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1186490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186512 */     // MIs[0] round
     /* 1186512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186522 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1186525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186550 */     // GIR_Coverage, 16602,
     /* 1186550 */     GIR_EraseRootFromParent_Done,
     /* 1186551 */   // Label 17280: @1186551
     /* 1186551 */   GIM_Try, /*On fail goto*//*Label 17281*/ GIMT_Encode4(1186634), // Rule ID 16603 //
     /* 1186556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1186567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1186570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1186573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186595 */     // MIs[0] round
     /* 1186595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186605 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1186608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186616 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186633 */     // GIR_Coverage, 16603,
     /* 1186633 */     GIR_EraseRootFromParent_Done,
     /* 1186634 */   // Label 17281: @1186634
     /* 1186634 */   GIM_Try, /*On fail goto*//*Label 17282*/ GIMT_Encode4(1186717), // Rule ID 16606 //
     /* 1186639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1186650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1186653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1186656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186678 */     // MIs[0] round
     /* 1186678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186688 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1186691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186716 */     // GIR_Coverage, 16606,
     /* 1186716 */     GIR_EraseRootFromParent_Done,
     /* 1186717 */   // Label 17282: @1186717
     /* 1186717 */   GIM_Try, /*On fail goto*//*Label 17283*/ GIMT_Encode4(1186800), // Rule ID 16607 //
     /* 1186722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1186733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1186736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1186739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186761 */     // MIs[0] round
     /* 1186761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186771 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1186774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186782 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186799 */     // GIR_Coverage, 16607,
     /* 1186799 */     GIR_EraseRootFromParent_Done,
     /* 1186800 */   // Label 17283: @1186800
     /* 1186800 */   GIM_Try, /*On fail goto*//*Label 17284*/ GIMT_Encode4(1186883), // Rule ID 16610 //
     /* 1186805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1186816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1186819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1186822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186844 */     // MIs[0] round
     /* 1186844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186854 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186882 */     // GIR_Coverage, 16610,
     /* 1186882 */     GIR_EraseRootFromParent_Done,
     /* 1186883 */   // Label 17284: @1186883
     /* 1186883 */   GIM_Try, /*On fail goto*//*Label 17285*/ GIMT_Encode4(1186966), // Rule ID 16611 //
     /* 1186888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1186899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1186902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1186905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186927 */     // MIs[0] round
     /* 1186927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186937 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186948 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186965 */     // GIR_Coverage, 16611,
     /* 1186965 */     GIR_EraseRootFromParent_Done,
     /* 1186966 */   // Label 17285: @1186966
     /* 1186966 */   GIM_Try, /*On fail goto*//*Label 17286*/ GIMT_Encode4(1187049), // Rule ID 16614 //
     /* 1186971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1186982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1186985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1186988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187010 */     // MIs[0] round
     /* 1187010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187048 */     // GIR_Coverage, 16614,
     /* 1187048 */     GIR_EraseRootFromParent_Done,
     /* 1187049 */   // Label 17286: @1187049
     /* 1187049 */   GIM_Try, /*On fail goto*//*Label 17287*/ GIMT_Encode4(1187132), // Rule ID 16615 //
     /* 1187054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1187065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1187068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1187071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187093 */     // MIs[0] round
     /* 1187093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187103 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187114 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187131 */     // GIR_Coverage, 16615,
     /* 1187131 */     GIR_EraseRootFromParent_Done,
     /* 1187132 */   // Label 17287: @1187132
     /* 1187132 */   GIM_Try, /*On fail goto*//*Label 17288*/ GIMT_Encode4(1187215), // Rule ID 16618 //
     /* 1187137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1187148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1187151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1187154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187176 */     // MIs[0] round
     /* 1187176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187186 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187214 */     // GIR_Coverage, 16618,
     /* 1187214 */     GIR_EraseRootFromParent_Done,
     /* 1187215 */   // Label 17288: @1187215
     /* 1187215 */   GIM_Try, /*On fail goto*//*Label 17289*/ GIMT_Encode4(1187298), // Rule ID 16619 //
     /* 1187220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1187231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1187234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1187237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187259 */     // MIs[0] round
     /* 1187259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187280 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187297 */     // GIR_Coverage, 16619,
     /* 1187297 */     GIR_EraseRootFromParent_Done,
     /* 1187298 */   // Label 17289: @1187298
     /* 1187298 */   GIM_Try, /*On fail goto*//*Label 17290*/ GIMT_Encode4(1187381), // Rule ID 16622 //
     /* 1187303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1187314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1187317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1187320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187342 */     // MIs[0] round
     /* 1187342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187352 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187380 */     // GIR_Coverage, 16622,
     /* 1187380 */     GIR_EraseRootFromParent_Done,
     /* 1187381 */   // Label 17290: @1187381
     /* 1187381 */   GIM_Try, /*On fail goto*//*Label 17291*/ GIMT_Encode4(1187464), // Rule ID 16623 //
     /* 1187386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1187397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1187400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1187403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187425 */     // MIs[0] round
     /* 1187425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187435 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187463 */     // GIR_Coverage, 16623,
     /* 1187463 */     GIR_EraseRootFromParent_Done,
     /* 1187464 */   // Label 17291: @1187464
     /* 1187464 */   GIM_Try, /*On fail goto*//*Label 17292*/ GIMT_Encode4(1187547), // Rule ID 16626 //
     /* 1187469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1187480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1187483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1187486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187508 */     // MIs[0] round
     /* 1187508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187518 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1187521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187546 */     // GIR_Coverage, 16626,
     /* 1187546 */     GIR_EraseRootFromParent_Done,
     /* 1187547 */   // Label 17292: @1187547
     /* 1187547 */   GIM_Try, /*On fail goto*//*Label 17293*/ GIMT_Encode4(1187630), // Rule ID 16627 //
     /* 1187552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1187555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1187563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1187566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1187569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187591 */     // MIs[0] round
     /* 1187591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187601 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1187604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187612 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187629 */     // GIR_Coverage, 16627,
     /* 1187629 */     GIR_EraseRootFromParent_Done,
     /* 1187630 */   // Label 17293: @1187630
     /* 1187630 */   GIM_Try, /*On fail goto*//*Label 17294*/ GIMT_Encode4(1187713), // Rule ID 16630 //
     /* 1187635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1187646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1187649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1187652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187674 */     // MIs[0] round
     /* 1187674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187684 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187712 */     // GIR_Coverage, 16630,
     /* 1187712 */     GIR_EraseRootFromParent_Done,
     /* 1187713 */   // Label 17294: @1187713
     /* 1187713 */   GIM_Try, /*On fail goto*//*Label 17295*/ GIMT_Encode4(1187796), // Rule ID 16631 //
     /* 1187718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1187721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1187729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1187732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1187735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187757 */     // MIs[0] round
     /* 1187757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187767 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187778 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187795 */     // GIR_Coverage, 16631,
     /* 1187795 */     GIR_EraseRootFromParent_Done,
     /* 1187796 */   // Label 17295: @1187796
     /* 1187796 */   GIM_Try, /*On fail goto*//*Label 17296*/ GIMT_Encode4(1187879), // Rule ID 16634 //
     /* 1187801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1187812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1187815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1187818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187840 */     // MIs[0] round
     /* 1187840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187878 */     // GIR_Coverage, 16634,
     /* 1187878 */     GIR_EraseRootFromParent_Done,
     /* 1187879 */   // Label 17296: @1187879
     /* 1187879 */   GIM_Try, /*On fail goto*//*Label 17297*/ GIMT_Encode4(1187962), // Rule ID 16635 //
     /* 1187884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1187887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1187895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1187898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1187901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187923 */     // MIs[0] round
     /* 1187923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187933 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187944 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187961 */     // GIR_Coverage, 16635,
     /* 1187961 */     GIR_EraseRootFromParent_Done,
     /* 1187962 */   // Label 17297: @1187962
     /* 1187962 */   GIM_Try, /*On fail goto*//*Label 17298*/ GIMT_Encode4(1188045), // Rule ID 16638 //
     /* 1187967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1187978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1187981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1187984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188006 */     // MIs[0] round
     /* 1188006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188016 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1188019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188044 */     // GIR_Coverage, 16638,
     /* 1188044 */     GIR_EraseRootFromParent_Done,
     /* 1188045 */   // Label 17298: @1188045
     /* 1188045 */   GIM_Try, /*On fail goto*//*Label 17299*/ GIMT_Encode4(1188128), // Rule ID 16639 //
     /* 1188050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1188053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1188061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1188064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1188067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188089 */     // MIs[0] round
     /* 1188089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188099 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1188102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188127 */     // GIR_Coverage, 16639,
     /* 1188127 */     GIR_EraseRootFromParent_Done,
     /* 1188128 */   // Label 17299: @1188128
     /* 1188128 */   GIM_Try, /*On fail goto*//*Label 17300*/ GIMT_Encode4(1188208), // Rule ID 16702 //
     /* 1188133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1188144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1188147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1188150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1188153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188172 */     // MIs[0] round
     /* 1188172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188182 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1188185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188207 */     // GIR_Coverage, 16702,
     /* 1188207 */     GIR_EraseRootFromParent_Done,
     /* 1188208 */   // Label 17300: @1188208
     /* 1188208 */   GIM_Try, /*On fail goto*//*Label 17301*/ GIMT_Encode4(1188288), // Rule ID 16703 //
     /* 1188213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1188224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1188227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1188230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1188233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188252 */     // MIs[0] round
     /* 1188252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188262 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1188265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188287 */     // GIR_Coverage, 16703,
     /* 1188287 */     GIR_EraseRootFromParent_Done,
     /* 1188288 */   // Label 17301: @1188288
     /* 1188288 */   GIM_Try, /*On fail goto*//*Label 17302*/ GIMT_Encode4(1188368), // Rule ID 16706 //
     /* 1188293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1188304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1188307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1188310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1188313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188332 */     // MIs[0] round
     /* 1188332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188342 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1188345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188367 */     // GIR_Coverage, 16706,
     /* 1188367 */     GIR_EraseRootFromParent_Done,
     /* 1188368 */   // Label 17302: @1188368
     /* 1188368 */   GIM_Try, /*On fail goto*//*Label 17303*/ GIMT_Encode4(1188448), // Rule ID 16707 //
     /* 1188373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1188384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1188387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1188390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1188393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188412 */     // MIs[0] round
     /* 1188412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188422 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1188425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188447 */     // GIR_Coverage, 16707,
     /* 1188447 */     GIR_EraseRootFromParent_Done,
     /* 1188448 */   // Label 17303: @1188448
     /* 1188448 */   GIM_Try, /*On fail goto*//*Label 17304*/ GIMT_Encode4(1188528), // Rule ID 16710 //
     /* 1188453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1188456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1188470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1188473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188492 */     // MIs[0] round
     /* 1188492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188502 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1188505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188527 */     // GIR_Coverage, 16710,
     /* 1188527 */     GIR_EraseRootFromParent_Done,
     /* 1188528 */   // Label 17304: @1188528
     /* 1188528 */   GIM_Try, /*On fail goto*//*Label 17305*/ GIMT_Encode4(1188608), // Rule ID 16711 //
     /* 1188533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1188536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1188550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1188553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188572 */     // MIs[0] round
     /* 1188572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188582 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1188585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188607 */     // GIR_Coverage, 16711,
     /* 1188607 */     GIR_EraseRootFromParent_Done,
     /* 1188608 */   // Label 17305: @1188608
     /* 1188608 */   GIM_Try, /*On fail goto*//*Label 17306*/ GIMT_Encode4(1188688), // Rule ID 16714 //
     /* 1188613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1188624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1188627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1188630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1188633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188652 */     // MIs[0] round
     /* 1188652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188662 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1188665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188687 */     // GIR_Coverage, 16714,
     /* 1188687 */     GIR_EraseRootFromParent_Done,
     /* 1188688 */   // Label 17306: @1188688
     /* 1188688 */   GIM_Try, /*On fail goto*//*Label 17307*/ GIMT_Encode4(1188768), // Rule ID 16715 //
     /* 1188693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1188704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1188707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1188710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1188713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188732 */     // MIs[0] round
     /* 1188732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188742 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1188745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188767 */     // GIR_Coverage, 16715,
     /* 1188767 */     GIR_EraseRootFromParent_Done,
     /* 1188768 */   // Label 17307: @1188768
     /* 1188768 */   GIM_Try, /*On fail goto*//*Label 17308*/ GIMT_Encode4(1188848), // Rule ID 16718 //
     /* 1188773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1188776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1188784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1188787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1188790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1188793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188812 */     // MIs[0] round
     /* 1188812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188822 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1188825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188847 */     // GIR_Coverage, 16718,
     /* 1188847 */     GIR_EraseRootFromParent_Done,
     /* 1188848 */   // Label 17308: @1188848
     /* 1188848 */   GIM_Try, /*On fail goto*//*Label 17309*/ GIMT_Encode4(1188928), // Rule ID 16719 //
     /* 1188853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1188856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1188864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1188867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1188870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1188873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188892 */     // MIs[0] round
     /* 1188892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188902 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1188905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188927 */     // GIR_Coverage, 16719,
     /* 1188927 */     GIR_EraseRootFromParent_Done,
     /* 1188928 */   // Label 17309: @1188928
     /* 1188928 */   GIM_Try, /*On fail goto*//*Label 17310*/ GIMT_Encode4(1189008), // Rule ID 16722 //
     /* 1188933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1188936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1188944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1188947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1188950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1188953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188972 */     // MIs[0] round
     /* 1188972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188982 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1188985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189007 */     // GIR_Coverage, 16722,
     /* 1189007 */     GIR_EraseRootFromParent_Done,
     /* 1189008 */   // Label 17310: @1189008
     /* 1189008 */   GIM_Try, /*On fail goto*//*Label 17311*/ GIMT_Encode4(1189088), // Rule ID 16723 //
     /* 1189013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1189016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1189024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1189027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1189030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1189033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189052 */     // MIs[0] round
     /* 1189052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189062 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1189065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189087 */     // GIR_Coverage, 16723,
     /* 1189087 */     GIR_EraseRootFromParent_Done,
     /* 1189088 */   // Label 17311: @1189088
     /* 1189088 */   GIM_Try, /*On fail goto*//*Label 17312*/ GIMT_Encode4(1189168), // Rule ID 16726 //
     /* 1189093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1189104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1189107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1189110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1189113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189132 */     // MIs[0] round
     /* 1189132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189142 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1189145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189167 */     // GIR_Coverage, 16726,
     /* 1189167 */     GIR_EraseRootFromParent_Done,
     /* 1189168 */   // Label 17312: @1189168
     /* 1189168 */   GIM_Try, /*On fail goto*//*Label 17313*/ GIMT_Encode4(1189248), // Rule ID 16727 //
     /* 1189173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1189184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1189187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1189190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1189193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189212 */     // MIs[0] round
     /* 1189212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189222 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1189225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189247 */     // GIR_Coverage, 16727,
     /* 1189247 */     GIR_EraseRootFromParent_Done,
     /* 1189248 */   // Label 17313: @1189248
     /* 1189248 */   GIM_Try, /*On fail goto*//*Label 17314*/ GIMT_Encode4(1189328), // Rule ID 16730 //
     /* 1189253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1189264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1189267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1189270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1189273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189292 */     // MIs[0] round
     /* 1189292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189302 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1189305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189327 */     // GIR_Coverage, 16730,
     /* 1189327 */     GIR_EraseRootFromParent_Done,
     /* 1189328 */   // Label 17314: @1189328
     /* 1189328 */   GIM_Try, /*On fail goto*//*Label 17315*/ GIMT_Encode4(1189408), // Rule ID 16731 //
     /* 1189333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1189344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1189347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1189350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1189353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189372 */     // MIs[0] round
     /* 1189372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189382 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1189385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189407 */     // GIR_Coverage, 16731,
     /* 1189407 */     GIR_EraseRootFromParent_Done,
     /* 1189408 */   // Label 17315: @1189408
     /* 1189408 */   GIM_Try, /*On fail goto*//*Label 17316*/ GIMT_Encode4(1189488), // Rule ID 16734 //
     /* 1189413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1189424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1189427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1189430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1189433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189452 */     // MIs[0] round
     /* 1189452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189462 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1189465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189487 */     // GIR_Coverage, 16734,
     /* 1189487 */     GIR_EraseRootFromParent_Done,
     /* 1189488 */   // Label 17316: @1189488
     /* 1189488 */   GIM_Try, /*On fail goto*//*Label 17317*/ GIMT_Encode4(1189568), // Rule ID 16735 //
     /* 1189493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1189504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1189507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1189510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1189513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189532 */     // MIs[0] round
     /* 1189532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189542 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1189545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189567 */     // GIR_Coverage, 16735,
     /* 1189567 */     GIR_EraseRootFromParent_Done,
     /* 1189568 */   // Label 17317: @1189568
     /* 1189568 */   GIM_Try, /*On fail goto*//*Label 17318*/ GIMT_Encode4(1189648), // Rule ID 16738 //
     /* 1189573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1189576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1189584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1189587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1189590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1189593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189612 */     // MIs[0] round
     /* 1189612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189622 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1189625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189647 */     // GIR_Coverage, 16738,
     /* 1189647 */     GIR_EraseRootFromParent_Done,
     /* 1189648 */   // Label 17318: @1189648
     /* 1189648 */   GIM_Try, /*On fail goto*//*Label 17319*/ GIMT_Encode4(1189728), // Rule ID 16739 //
     /* 1189653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1189656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1189664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1189667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1189670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1189673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189692 */     // MIs[0] round
     /* 1189692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189702 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1189705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189727 */     // GIR_Coverage, 16739,
     /* 1189727 */     GIR_EraseRootFromParent_Done,
     /* 1189728 */   // Label 17319: @1189728
     /* 1189728 */   GIM_Try, /*On fail goto*//*Label 17320*/ GIMT_Encode4(1189808), // Rule ID 16742 //
     /* 1189733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1189736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1189744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1189747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1189750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1189753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189772 */     // MIs[0] round
     /* 1189772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189782 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1189785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189807 */     // GIR_Coverage, 16742,
     /* 1189807 */     GIR_EraseRootFromParent_Done,
     /* 1189808 */   // Label 17320: @1189808
     /* 1189808 */   GIM_Try, /*On fail goto*//*Label 17321*/ GIMT_Encode4(1189888), // Rule ID 16743 //
     /* 1189813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1189816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1189824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1189827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1189830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1189833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189852 */     // MIs[0] round
     /* 1189852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189862 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1189865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189887 */     // GIR_Coverage, 16743,
     /* 1189887 */     GIR_EraseRootFromParent_Done,
     /* 1189888 */   // Label 17321: @1189888
     /* 1189888 */   GIM_Try, /*On fail goto*//*Label 17322*/ GIMT_Encode4(1189968), // Rule ID 16746 //
     /* 1189893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1189896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1189904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1189907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1189910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1189913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189932 */     // MIs[0] round
     /* 1189932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189942 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1189945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189967 */     // GIR_Coverage, 16746,
     /* 1189967 */     GIR_EraseRootFromParent_Done,
     /* 1189968 */   // Label 17322: @1189968
     /* 1189968 */   GIM_Try, /*On fail goto*//*Label 17323*/ GIMT_Encode4(1190048), // Rule ID 16747 //
     /* 1189973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1189976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1189984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1189987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1189990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1189993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190012 */     // MIs[0] round
     /* 1190012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190022 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1190025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190047 */     // GIR_Coverage, 16747,
     /* 1190047 */     GIR_EraseRootFromParent_Done,
     /* 1190048 */   // Label 17323: @1190048
     /* 1190048 */   GIM_Try, /*On fail goto*//*Label 17324*/ GIMT_Encode4(1190128), // Rule ID 16750 //
     /* 1190053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1190064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1190067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1190070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1190073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190092 */     // MIs[0] round
     /* 1190092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190102 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1190105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190127 */     // GIR_Coverage, 16750,
     /* 1190127 */     GIR_EraseRootFromParent_Done,
     /* 1190128 */   // Label 17324: @1190128
     /* 1190128 */   GIM_Try, /*On fail goto*//*Label 17325*/ GIMT_Encode4(1190208), // Rule ID 16751 //
     /* 1190133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1190144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1190147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1190150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1190153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190172 */     // MIs[0] round
     /* 1190172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190182 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1190185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190207 */     // GIR_Coverage, 16751,
     /* 1190207 */     GIR_EraseRootFromParent_Done,
     /* 1190208 */   // Label 17325: @1190208
     /* 1190208 */   GIM_Try, /*On fail goto*//*Label 17326*/ GIMT_Encode4(1190288), // Rule ID 16754 //
     /* 1190213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1190224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1190227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1190230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1190233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190252 */     // MIs[0] round
     /* 1190252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190262 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1190265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190287 */     // GIR_Coverage, 16754,
     /* 1190287 */     GIR_EraseRootFromParent_Done,
     /* 1190288 */   // Label 17326: @1190288
     /* 1190288 */   GIM_Try, /*On fail goto*//*Label 17327*/ GIMT_Encode4(1190368), // Rule ID 16755 //
     /* 1190293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1190304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1190307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1190310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1190313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190332 */     // MIs[0] round
     /* 1190332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190342 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1190345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190367 */     // GIR_Coverage, 16755,
     /* 1190367 */     GIR_EraseRootFromParent_Done,
     /* 1190368 */   // Label 17327: @1190368
     /* 1190368 */   GIM_Try, /*On fail goto*//*Label 17328*/ GIMT_Encode4(1190448), // Rule ID 16758 //
     /* 1190373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1190384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1190387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1190390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1190393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190412 */     // MIs[0] round
     /* 1190412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190422 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1190425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190447 */     // GIR_Coverage, 16758,
     /* 1190447 */     GIR_EraseRootFromParent_Done,
     /* 1190448 */   // Label 17328: @1190448
     /* 1190448 */   GIM_Try, /*On fail goto*//*Label 17329*/ GIMT_Encode4(1190528), // Rule ID 16759 //
     /* 1190453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1190464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1190467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1190470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1190473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190492 */     // MIs[0] round
     /* 1190492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190502 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1190505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190527 */     // GIR_Coverage, 16759,
     /* 1190527 */     GIR_EraseRootFromParent_Done,
     /* 1190528 */   // Label 17329: @1190528
     /* 1190528 */   GIM_Try, /*On fail goto*//*Label 17330*/ GIMT_Encode4(1190608), // Rule ID 16762 //
     /* 1190533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1190536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1190544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1190547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1190550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190572 */     // MIs[0] round
     /* 1190572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190582 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1190585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190607 */     // GIR_Coverage, 16762,
     /* 1190607 */     GIR_EraseRootFromParent_Done,
     /* 1190608 */   // Label 17330: @1190608
     /* 1190608 */   GIM_Try, /*On fail goto*//*Label 17331*/ GIMT_Encode4(1190688), // Rule ID 16763 //
     /* 1190613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1190616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1190624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1190627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1190630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190652 */     // MIs[0] round
     /* 1190652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190662 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1190665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190687 */     // GIR_Coverage, 16763,
     /* 1190687 */     GIR_EraseRootFromParent_Done,
     /* 1190688 */   // Label 17331: @1190688
     /* 1190688 */   GIM_Try, /*On fail goto*//*Label 17332*/ GIMT_Encode4(1190768), // Rule ID 16766 //
     /* 1190693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1190696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1190704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1190707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1190710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190732 */     // MIs[0] round
     /* 1190732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190742 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1190745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190767 */     // GIR_Coverage, 16766,
     /* 1190767 */     GIR_EraseRootFromParent_Done,
     /* 1190768 */   // Label 17332: @1190768
     /* 1190768 */   GIM_Try, /*On fail goto*//*Label 17333*/ GIMT_Encode4(1190848), // Rule ID 16767 //
     /* 1190773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1190776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1190784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1190787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1190790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190812 */     // MIs[0] round
     /* 1190812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190822 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1190825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190847 */     // GIR_Coverage, 16767,
     /* 1190847 */     GIR_EraseRootFromParent_Done,
     /* 1190848 */   // Label 17333: @1190848
     /* 1190848 */   GIM_Try, /*On fail goto*//*Label 17334*/ GIMT_Encode4(1190928), // Rule ID 16770 //
     /* 1190853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1190856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1190864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1190867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1190870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1190892 */     // MIs[0] round
     /* 1190892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190902 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1190905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190927 */     // GIR_Coverage, 16770,
     /* 1190927 */     GIR_EraseRootFromParent_Done,
     /* 1190928 */   // Label 17334: @1190928
     /* 1190928 */   GIM_Try, /*On fail goto*//*Label 17335*/ GIMT_Encode4(1191008), // Rule ID 16771 //
     /* 1190933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1190936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1190944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1190947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1190950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1190972 */     // MIs[0] round
     /* 1190972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190982 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1190985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191007 */     // GIR_Coverage, 16771,
     /* 1191007 */     GIR_EraseRootFromParent_Done,
     /* 1191008 */   // Label 17335: @1191008
     /* 1191008 */   GIM_Try, /*On fail goto*//*Label 17336*/ GIMT_Encode4(1191088), // Rule ID 16774 //
     /* 1191013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1191024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1191027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1191030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191052 */     // MIs[0] round
     /* 1191052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191062 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1191065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191087 */     // GIR_Coverage, 16774,
     /* 1191087 */     GIR_EraseRootFromParent_Done,
     /* 1191088 */   // Label 17336: @1191088
     /* 1191088 */   GIM_Try, /*On fail goto*//*Label 17337*/ GIMT_Encode4(1191168), // Rule ID 16775 //
     /* 1191093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1191104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1191107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1191110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191132 */     // MIs[0] round
     /* 1191132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191142 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1191145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191167 */     // GIR_Coverage, 16775,
     /* 1191167 */     GIR_EraseRootFromParent_Done,
     /* 1191168 */   // Label 17337: @1191168
     /* 1191168 */   GIM_Try, /*On fail goto*//*Label 17338*/ GIMT_Encode4(1191248), // Rule ID 16778 //
     /* 1191173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1191176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1191184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1191187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1191190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191212 */     // MIs[0] round
     /* 1191212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191222 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1191225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191247 */     // GIR_Coverage, 16778,
     /* 1191247 */     GIR_EraseRootFromParent_Done,
     /* 1191248 */   // Label 17338: @1191248
     /* 1191248 */   GIM_Try, /*On fail goto*//*Label 17339*/ GIMT_Encode4(1191328), // Rule ID 16779 //
     /* 1191253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1191256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1191264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1191267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1191270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191292 */     // MIs[0] round
     /* 1191292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191302 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1191305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191327 */     // GIR_Coverage, 16779,
     /* 1191327 */     GIR_EraseRootFromParent_Done,
     /* 1191328 */   // Label 17339: @1191328
     /* 1191328 */   GIM_Try, /*On fail goto*//*Label 17340*/ GIMT_Encode4(1191408), // Rule ID 16782 //
     /* 1191333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1191336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1191344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1191347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1191372 */     // MIs[0] round
     /* 1191372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191382 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1191385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1191403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191407 */     // GIR_Coverage, 16782,
     /* 1191407 */     GIR_EraseRootFromParent_Done,
     /* 1191408 */   // Label 17340: @1191408
     /* 1191408 */   GIM_Try, /*On fail goto*//*Label 17341*/ GIMT_Encode4(1191488), // Rule ID 16783 //
     /* 1191413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1191416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1191424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1191427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1191452 */     // MIs[0] round
     /* 1191452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191462 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1191465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1191483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191487 */     // GIR_Coverage, 16783,
     /* 1191487 */     GIR_EraseRootFromParent_Done,
     /* 1191488 */   // Label 17341: @1191488
     /* 1191488 */   GIM_Try, /*On fail goto*//*Label 17342*/ GIMT_Encode4(1191568), // Rule ID 16786 //
     /* 1191493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1191504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1191507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1191510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191532 */     // MIs[0] round
     /* 1191532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191542 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1191545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191567 */     // GIR_Coverage, 16786,
     /* 1191567 */     GIR_EraseRootFromParent_Done,
     /* 1191568 */   // Label 17342: @1191568
     /* 1191568 */   GIM_Try, /*On fail goto*//*Label 17343*/ GIMT_Encode4(1191648), // Rule ID 16787 //
     /* 1191573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1191584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1191587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1191590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191612 */     // MIs[0] round
     /* 1191612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191622 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1191625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191647 */     // GIR_Coverage, 16787,
     /* 1191647 */     GIR_EraseRootFromParent_Done,
     /* 1191648 */   // Label 17343: @1191648
     /* 1191648 */   GIM_Try, /*On fail goto*//*Label 17344*/ GIMT_Encode4(1191728), // Rule ID 16790 //
     /* 1191653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1191664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1191667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1191670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191692 */     // MIs[0] round
     /* 1191692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191702 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1191705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191727 */     // GIR_Coverage, 16790,
     /* 1191727 */     GIR_EraseRootFromParent_Done,
     /* 1191728 */   // Label 17344: @1191728
     /* 1191728 */   GIM_Try, /*On fail goto*//*Label 17345*/ GIMT_Encode4(1191808), // Rule ID 16791 //
     /* 1191733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1191744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1191747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1191750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191772 */     // MIs[0] round
     /* 1191772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191782 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1191785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191807 */     // GIR_Coverage, 16791,
     /* 1191807 */     GIR_EraseRootFromParent_Done,
     /* 1191808 */   // Label 17345: @1191808
     /* 1191808 */   GIM_Try, /*On fail goto*//*Label 17346*/ GIMT_Encode4(1191888), // Rule ID 16794 //
     /* 1191813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1191824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1191827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1191830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191852 */     // MIs[0] round
     /* 1191852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191862 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1191865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191887 */     // GIR_Coverage, 16794,
     /* 1191887 */     GIR_EraseRootFromParent_Done,
     /* 1191888 */   // Label 17346: @1191888
     /* 1191888 */   GIM_Try, /*On fail goto*//*Label 17347*/ GIMT_Encode4(1191968), // Rule ID 16795 //
     /* 1191893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1191904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1191907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1191910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191932 */     // MIs[0] round
     /* 1191932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191942 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1191945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191967 */     // GIR_Coverage, 16795,
     /* 1191967 */     GIR_EraseRootFromParent_Done,
     /* 1191968 */   // Label 17347: @1191968
     /* 1191968 */   GIM_Try, /*On fail goto*//*Label 17348*/ GIMT_Encode4(1192048), // Rule ID 16798 //
     /* 1191973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1191976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1191984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1191987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1191990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192012 */     // MIs[0] round
     /* 1192012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192022 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1192025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192047 */     // GIR_Coverage, 16798,
     /* 1192047 */     GIR_EraseRootFromParent_Done,
     /* 1192048 */   // Label 17348: @1192048
     /* 1192048 */   GIM_Try, /*On fail goto*//*Label 17349*/ GIMT_Encode4(1192128), // Rule ID 16799 //
     /* 1192053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1192064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1192067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1192070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192092 */     // MIs[0] round
     /* 1192092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192102 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1192105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192127 */     // GIR_Coverage, 16799,
     /* 1192127 */     GIR_EraseRootFromParent_Done,
     /* 1192128 */   // Label 17349: @1192128
     /* 1192128 */   GIM_Try, /*On fail goto*//*Label 17350*/ GIMT_Encode4(1192208), // Rule ID 16802 //
     /* 1192133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1192144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1192147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1192150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192172 */     // MIs[0] round
     /* 1192172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192182 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1192185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192207 */     // GIR_Coverage, 16802,
     /* 1192207 */     GIR_EraseRootFromParent_Done,
     /* 1192208 */   // Label 17350: @1192208
     /* 1192208 */   GIM_Try, /*On fail goto*//*Label 17351*/ GIMT_Encode4(1192288), // Rule ID 16803 //
     /* 1192213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1192224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1192227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1192230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192252 */     // MIs[0] round
     /* 1192252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192262 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1192265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192287 */     // GIR_Coverage, 16803,
     /* 1192287 */     GIR_EraseRootFromParent_Done,
     /* 1192288 */   // Label 17351: @1192288
     /* 1192288 */   GIM_Try, /*On fail goto*//*Label 17352*/ GIMT_Encode4(1192368), // Rule ID 16806 //
     /* 1192293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1192304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1192307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1192310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192332 */     // MIs[0] round
     /* 1192332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192342 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1192345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192367 */     // GIR_Coverage, 16806,
     /* 1192367 */     GIR_EraseRootFromParent_Done,
     /* 1192368 */   // Label 17352: @1192368
     /* 1192368 */   GIM_Try, /*On fail goto*//*Label 17353*/ GIMT_Encode4(1192448), // Rule ID 16807 //
     /* 1192373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1192384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1192387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1192390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192412 */     // MIs[0] round
     /* 1192412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192422 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1192425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192447 */     // GIR_Coverage, 16807,
     /* 1192447 */     GIR_EraseRootFromParent_Done,
     /* 1192448 */   // Label 17353: @1192448
     /* 1192448 */   GIM_Try, /*On fail goto*//*Label 17354*/ GIMT_Encode4(1192528), // Rule ID 16810 //
     /* 1192453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1192464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1192467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1192470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192492 */     // MIs[0] round
     /* 1192492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192502 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1192505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192527 */     // GIR_Coverage, 16810,
     /* 1192527 */     GIR_EraseRootFromParent_Done,
     /* 1192528 */   // Label 17354: @1192528
     /* 1192528 */   GIM_Try, /*On fail goto*//*Label 17355*/ GIMT_Encode4(1192608), // Rule ID 16811 //
     /* 1192533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1192544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1192547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1192550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192572 */     // MIs[0] round
     /* 1192572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192582 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1192585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192607 */     // GIR_Coverage, 16811,
     /* 1192607 */     GIR_EraseRootFromParent_Done,
     /* 1192608 */   // Label 17355: @1192608
     /* 1192608 */   GIM_Try, /*On fail goto*//*Label 17356*/ GIMT_Encode4(1192688), // Rule ID 16814 //
     /* 1192613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1192624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1192627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1192630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192652 */     // MIs[0] round
     /* 1192652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192662 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1192665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192687 */     // GIR_Coverage, 16814,
     /* 1192687 */     GIR_EraseRootFromParent_Done,
     /* 1192688 */   // Label 17356: @1192688
     /* 1192688 */   GIM_Try, /*On fail goto*//*Label 17357*/ GIMT_Encode4(1192768), // Rule ID 16815 //
     /* 1192693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1192704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1192707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1192710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192732 */     // MIs[0] round
     /* 1192732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192742 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1192745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192767 */     // GIR_Coverage, 16815,
     /* 1192767 */     GIR_EraseRootFromParent_Done,
     /* 1192768 */   // Label 17357: @1192768
     /* 1192768 */   GIM_Try, /*On fail goto*//*Label 17358*/ GIMT_Encode4(1192848), // Rule ID 16818 //
     /* 1192773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1192784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1192787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1192790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192812 */     // MIs[0] round
     /* 1192812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192822 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1192825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192847 */     // GIR_Coverage, 16818,
     /* 1192847 */     GIR_EraseRootFromParent_Done,
     /* 1192848 */   // Label 17358: @1192848
     /* 1192848 */   GIM_Try, /*On fail goto*//*Label 17359*/ GIMT_Encode4(1192928), // Rule ID 16819 //
     /* 1192853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1192864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1192867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1192870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192892 */     // MIs[0] round
     /* 1192892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192902 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1192905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192927 */     // GIR_Coverage, 16819,
     /* 1192927 */     GIR_EraseRootFromParent_Done,
     /* 1192928 */   // Label 17359: @1192928
     /* 1192928 */   GIM_Try, /*On fail goto*//*Label 17360*/ GIMT_Encode4(1193008), // Rule ID 16822 //
     /* 1192933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1192936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1192944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1192947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1192950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1192953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192972 */     // MIs[0] round
     /* 1192972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192982 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1192985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193007 */     // GIR_Coverage, 16822,
     /* 1193007 */     GIR_EraseRootFromParent_Done,
     /* 1193008 */   // Label 17360: @1193008
     /* 1193008 */   GIM_Try, /*On fail goto*//*Label 17361*/ GIMT_Encode4(1193088), // Rule ID 16823 //
     /* 1193013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1193024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1193027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1193030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1193033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193052 */     // MIs[0] round
     /* 1193052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193062 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1193065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193087 */     // GIR_Coverage, 16823,
     /* 1193087 */     GIR_EraseRootFromParent_Done,
     /* 1193088 */   // Label 17361: @1193088
     /* 1193088 */   GIM_Try, /*On fail goto*//*Label 17362*/ GIMT_Encode4(1193168), // Rule ID 16826 //
     /* 1193093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1193104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1193107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1193110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1193113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193132 */     // MIs[0] round
     /* 1193132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193142 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1193145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193167 */     // GIR_Coverage, 16826,
     /* 1193167 */     GIR_EraseRootFromParent_Done,
     /* 1193168 */   // Label 17362: @1193168
     /* 1193168 */   GIM_Try, /*On fail goto*//*Label 17363*/ GIMT_Encode4(1193248), // Rule ID 16827 //
     /* 1193173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1193184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1193187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1193190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1193193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193212 */     // MIs[0] round
     /* 1193212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193222 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1193225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193247 */     // GIR_Coverage, 16827,
     /* 1193247 */     GIR_EraseRootFromParent_Done,
     /* 1193248 */   // Label 17363: @1193248
     /* 1193248 */   GIM_Try, /*On fail goto*//*Label 17364*/ GIMT_Encode4(1193328), // Rule ID 16830 //
     /* 1193253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1193256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1193264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1193267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1193270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1193273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193292 */     // MIs[0] round
     /* 1193292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193302 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1193305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193327 */     // GIR_Coverage, 16830,
     /* 1193327 */     GIR_EraseRootFromParent_Done,
     /* 1193328 */   // Label 17364: @1193328
     /* 1193328 */   GIM_Try, /*On fail goto*//*Label 17365*/ GIMT_Encode4(1193408), // Rule ID 16831 //
     /* 1193333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1193336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1193344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1193347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1193350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1193353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193372 */     // MIs[0] round
     /* 1193372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193382 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1193385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193407 */     // GIR_Coverage, 16831,
     /* 1193407 */     GIR_EraseRootFromParent_Done,
     /* 1193408 */   // Label 17365: @1193408
     /* 1193408 */   GIM_Try, /*On fail goto*//*Label 17366*/ GIMT_Encode4(1193488), // Rule ID 16834 //
     /* 1193413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1193424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1193427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1193430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1193433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193452 */     // MIs[0] round
     /* 1193452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193462 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1193465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193487 */     // GIR_Coverage, 16834,
     /* 1193487 */     GIR_EraseRootFromParent_Done,
     /* 1193488 */   // Label 17366: @1193488
     /* 1193488 */   GIM_Try, /*On fail goto*//*Label 17367*/ GIMT_Encode4(1193568), // Rule ID 16835 //
     /* 1193493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1193504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1193507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1193510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1193513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193532 */     // MIs[0] round
     /* 1193532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193542 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1193545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193567 */     // GIR_Coverage, 16835,
     /* 1193567 */     GIR_EraseRootFromParent_Done,
     /* 1193568 */   // Label 17367: @1193568
     /* 1193568 */   GIM_Try, /*On fail goto*//*Label 17368*/ GIMT_Encode4(1193648), // Rule ID 16838 //
     /* 1193573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1193576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1193584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1193587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1193590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1193593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193612 */     // MIs[0] round
     /* 1193612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193622 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1193625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193647 */     // GIR_Coverage, 16838,
     /* 1193647 */     GIR_EraseRootFromParent_Done,
     /* 1193648 */   // Label 17368: @1193648
     /* 1193648 */   GIM_Try, /*On fail goto*//*Label 17369*/ GIMT_Encode4(1193728), // Rule ID 16839 //
     /* 1193653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1193656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1193664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1193667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1193670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1193673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193692 */     // MIs[0] round
     /* 1193692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193702 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1193705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193727 */     // GIR_Coverage, 16839,
     /* 1193727 */     GIR_EraseRootFromParent_Done,
     /* 1193728 */   // Label 17369: @1193728
     /* 1193728 */   GIM_Try, /*On fail goto*//*Label 17370*/ GIMT_Encode4(1193808), // Rule ID 16842 //
     /* 1193733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1193736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1193744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1193747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1193750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1193753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193772 */     // MIs[0] round
     /* 1193772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193782 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1193785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193807 */     // GIR_Coverage, 16842,
     /* 1193807 */     GIR_EraseRootFromParent_Done,
     /* 1193808 */   // Label 17370: @1193808
     /* 1193808 */   GIM_Try, /*On fail goto*//*Label 17371*/ GIMT_Encode4(1193888), // Rule ID 16843 //
     /* 1193813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1193816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1193824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1193827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1193830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1193833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193852 */     // MIs[0] round
     /* 1193852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193862 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1193865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193887 */     // GIR_Coverage, 16843,
     /* 1193887 */     GIR_EraseRootFromParent_Done,
     /* 1193888 */   // Label 17371: @1193888
     /* 1193888 */   GIM_Try, /*On fail goto*//*Label 17372*/ GIMT_Encode4(1193968), // Rule ID 16846 //
     /* 1193893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1193904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1193907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1193910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1193913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193932 */     // MIs[0] round
     /* 1193932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193942 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1193945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193967 */     // GIR_Coverage, 16846,
     /* 1193967 */     GIR_EraseRootFromParent_Done,
     /* 1193968 */   // Label 17372: @1193968
     /* 1193968 */   GIM_Try, /*On fail goto*//*Label 17373*/ GIMT_Encode4(1194048), // Rule ID 16847 //
     /* 1193973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1193984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1193987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1193990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1193993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194012 */     // MIs[0] round
     /* 1194012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194022 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1194025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194047 */     // GIR_Coverage, 16847,
     /* 1194047 */     GIR_EraseRootFromParent_Done,
     /* 1194048 */   // Label 17373: @1194048
     /* 1194048 */   GIM_Try, /*On fail goto*//*Label 17374*/ GIMT_Encode4(1194128), // Rule ID 16850 //
     /* 1194053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1194064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1194067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1194070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1194073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194092 */     // MIs[0] round
     /* 1194092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194102 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1194105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194127 */     // GIR_Coverage, 16850,
     /* 1194127 */     GIR_EraseRootFromParent_Done,
     /* 1194128 */   // Label 17374: @1194128
     /* 1194128 */   GIM_Try, /*On fail goto*//*Label 17375*/ GIMT_Encode4(1194208), // Rule ID 16851 //
     /* 1194133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1194144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1194147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1194150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1194153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194172 */     // MIs[0] round
     /* 1194172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194182 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1194185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194207 */     // GIR_Coverage, 16851,
     /* 1194207 */     GIR_EraseRootFromParent_Done,
     /* 1194208 */   // Label 17375: @1194208
     /* 1194208 */   GIM_Try, /*On fail goto*//*Label 17376*/ GIMT_Encode4(1194288), // Rule ID 16854 //
     /* 1194213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1194224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1194227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1194230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1194233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194252 */     // MIs[0] round
     /* 1194252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194262 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1194265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194287 */     // GIR_Coverage, 16854,
     /* 1194287 */     GIR_EraseRootFromParent_Done,
     /* 1194288 */   // Label 17376: @1194288
     /* 1194288 */   GIM_Try, /*On fail goto*//*Label 17377*/ GIMT_Encode4(1194368), // Rule ID 16855 //
     /* 1194293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1194304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1194307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1194310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1194313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194332 */     // MIs[0] round
     /* 1194332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194342 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1194345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194367 */     // GIR_Coverage, 16855,
     /* 1194367 */     GIR_EraseRootFromParent_Done,
     /* 1194368 */   // Label 17377: @1194368
     /* 1194368 */   GIM_Try, /*On fail goto*//*Label 17378*/ GIMT_Encode4(1194448), // Rule ID 16858 //
     /* 1194373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1194384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1194387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1194390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1194393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194412 */     // MIs[0] round
     /* 1194412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194422 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1194425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194447 */     // GIR_Coverage, 16858,
     /* 1194447 */     GIR_EraseRootFromParent_Done,
     /* 1194448 */   // Label 17378: @1194448
     /* 1194448 */   GIM_Try, /*On fail goto*//*Label 17379*/ GIMT_Encode4(1194528), // Rule ID 16859 //
     /* 1194453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1194464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1194467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1194470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1194473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194492 */     // MIs[0] round
     /* 1194492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194502 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1194505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194527 */     // GIR_Coverage, 16859,
     /* 1194527 */     GIR_EraseRootFromParent_Done,
     /* 1194528 */   // Label 17379: @1194528
     /* 1194528 */   GIM_Try, /*On fail goto*//*Label 17380*/ GIMT_Encode4(1194608), // Rule ID 16862 //
     /* 1194533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1194544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1194547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1194550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1194553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194572 */     // MIs[0] round
     /* 1194572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194582 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1194585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194607 */     // GIR_Coverage, 16862,
     /* 1194607 */     GIR_EraseRootFromParent_Done,
     /* 1194608 */   // Label 17380: @1194608
     /* 1194608 */   GIM_Try, /*On fail goto*//*Label 17381*/ GIMT_Encode4(1194688), // Rule ID 16863 //
     /* 1194613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1194624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1194627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1194630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1194633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194652 */     // MIs[0] round
     /* 1194652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194662 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1194665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194687 */     // GIR_Coverage, 16863,
     /* 1194687 */     GIR_EraseRootFromParent_Done,
     /* 1194688 */   // Label 17381: @1194688
     /* 1194688 */   GIM_Try, /*On fail goto*//*Label 17382*/ GIMT_Encode4(1194768), // Rule ID 16866 //
     /* 1194693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1194704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1194707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1194710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1194713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194732 */     // MIs[0] round
     /* 1194732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194742 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1194745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194767 */     // GIR_Coverage, 16866,
     /* 1194767 */     GIR_EraseRootFromParent_Done,
     /* 1194768 */   // Label 17382: @1194768
     /* 1194768 */   GIM_Try, /*On fail goto*//*Label 17383*/ GIMT_Encode4(1194848), // Rule ID 16867 //
     /* 1194773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1194784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1194787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1194790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1194793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194812 */     // MIs[0] round
     /* 1194812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194822 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1194825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194847 */     // GIR_Coverage, 16867,
     /* 1194847 */     GIR_EraseRootFromParent_Done,
     /* 1194848 */   // Label 17383: @1194848
     /* 1194848 */   GIM_Try, /*On fail goto*//*Label 17384*/ GIMT_Encode4(1194928), // Rule ID 16870 //
     /* 1194853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1194856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1194864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1194867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1194870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1194873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194892 */     // MIs[0] round
     /* 1194892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194902 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1194905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194927 */     // GIR_Coverage, 16870,
     /* 1194927 */     GIR_EraseRootFromParent_Done,
     /* 1194928 */   // Label 17384: @1194928
     /* 1194928 */   GIM_Try, /*On fail goto*//*Label 17385*/ GIMT_Encode4(1195008), // Rule ID 16871 //
     /* 1194933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1194936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1194944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1194947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1194950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1194953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194972 */     // MIs[0] round
     /* 1194972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194982 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1194985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195007 */     // GIR_Coverage, 16871,
     /* 1195007 */     GIR_EraseRootFromParent_Done,
     /* 1195008 */   // Label 17385: @1195008
     /* 1195008 */   GIM_Try, /*On fail goto*//*Label 17386*/ GIMT_Encode4(1195088), // Rule ID 16874 //
     /* 1195013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1195024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1195027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1195030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1195033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195052 */     // MIs[0] round
     /* 1195052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195062 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1195065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195087 */     // GIR_Coverage, 16874,
     /* 1195087 */     GIR_EraseRootFromParent_Done,
     /* 1195088 */   // Label 17386: @1195088
     /* 1195088 */   GIM_Try, /*On fail goto*//*Label 17387*/ GIMT_Encode4(1195168), // Rule ID 16875 //
     /* 1195093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1195104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1195107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1195110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1195113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195132 */     // MIs[0] round
     /* 1195132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195142 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1195145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195167 */     // GIR_Coverage, 16875,
     /* 1195167 */     GIR_EraseRootFromParent_Done,
     /* 1195168 */   // Label 17387: @1195168
     /* 1195168 */   GIM_Try, /*On fail goto*//*Label 17388*/ GIMT_Encode4(1195248), // Rule ID 16878 //
     /* 1195173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1195184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1195187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1195190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1195193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195212 */     // MIs[0] round
     /* 1195212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195222 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1195225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195247 */     // GIR_Coverage, 16878,
     /* 1195247 */     GIR_EraseRootFromParent_Done,
     /* 1195248 */   // Label 17388: @1195248
     /* 1195248 */   GIM_Try, /*On fail goto*//*Label 17389*/ GIMT_Encode4(1195328), // Rule ID 16879 //
     /* 1195253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1195264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1195267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1195270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1195273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195292 */     // MIs[0] round
     /* 1195292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195302 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1195305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195327 */     // GIR_Coverage, 16879,
     /* 1195327 */     GIR_EraseRootFromParent_Done,
     /* 1195328 */   // Label 17389: @1195328
     /* 1195328 */   GIM_Try, /*On fail goto*//*Label 17390*/ GIMT_Encode4(1195408), // Rule ID 16882 //
     /* 1195333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1195344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1195347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1195350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195372 */     // MIs[0] round
     /* 1195372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195382 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1195385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195407 */     // GIR_Coverage, 16882,
     /* 1195407 */     GIR_EraseRootFromParent_Done,
     /* 1195408 */   // Label 17390: @1195408
     /* 1195408 */   GIM_Try, /*On fail goto*//*Label 17391*/ GIMT_Encode4(1195488), // Rule ID 16883 //
     /* 1195413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1195424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1195427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1195430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195452 */     // MIs[0] round
     /* 1195452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195462 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1195465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195487 */     // GIR_Coverage, 16883,
     /* 1195487 */     GIR_EraseRootFromParent_Done,
     /* 1195488 */   // Label 17391: @1195488
     /* 1195488 */   GIM_Try, /*On fail goto*//*Label 17392*/ GIMT_Encode4(1195568), // Rule ID 16886 //
     /* 1195493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1195504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1195507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1195510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195532 */     // MIs[0] round
     /* 1195532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195542 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1195545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195567 */     // GIR_Coverage, 16886,
     /* 1195567 */     GIR_EraseRootFromParent_Done,
     /* 1195568 */   // Label 17392: @1195568
     /* 1195568 */   GIM_Try, /*On fail goto*//*Label 17393*/ GIMT_Encode4(1195648), // Rule ID 16887 //
     /* 1195573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1195584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1195587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1195590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195612 */     // MIs[0] round
     /* 1195612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195622 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1195625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195647 */     // GIR_Coverage, 16887,
     /* 1195647 */     GIR_EraseRootFromParent_Done,
     /* 1195648 */   // Label 17393: @1195648
     /* 1195648 */   GIM_Try, /*On fail goto*//*Label 17394*/ GIMT_Encode4(1195728), // Rule ID 16890 //
     /* 1195653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1195656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1195664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1195667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1195670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1195692 */     // MIs[0] round
     /* 1195692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195702 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1195705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195727 */     // GIR_Coverage, 16890,
     /* 1195727 */     GIR_EraseRootFromParent_Done,
     /* 1195728 */   // Label 17394: @1195728
     /* 1195728 */   GIM_Try, /*On fail goto*//*Label 17395*/ GIMT_Encode4(1195808), // Rule ID 16891 //
     /* 1195733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1195736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1195744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1195747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1195750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1195772 */     // MIs[0] round
     /* 1195772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195782 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1195785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195807 */     // GIR_Coverage, 16891,
     /* 1195807 */     GIR_EraseRootFromParent_Done,
     /* 1195808 */   // Label 17395: @1195808
     /* 1195808 */   GIM_Try, /*On fail goto*//*Label 17396*/ GIMT_Encode4(1195888), // Rule ID 16894 //
     /* 1195813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1195824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1195827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1195830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195852 */     // MIs[0] round
     /* 1195852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195862 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1195865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195887 */     // GIR_Coverage, 16894,
     /* 1195887 */     GIR_EraseRootFromParent_Done,
     /* 1195888 */   // Label 17396: @1195888
     /* 1195888 */   GIM_Try, /*On fail goto*//*Label 17397*/ GIMT_Encode4(1195968), // Rule ID 16895 //
     /* 1195893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1195904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1195907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1195910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195932 */     // MIs[0] round
     /* 1195932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195942 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1195945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195967 */     // GIR_Coverage, 16895,
     /* 1195967 */     GIR_EraseRootFromParent_Done,
     /* 1195968 */   // Label 17397: @1195968
     /* 1195968 */   GIM_Try, /*On fail goto*//*Label 17398*/ GIMT_Encode4(1196048), // Rule ID 16898 //
     /* 1195973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1195976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1195984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1195987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1195990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196012 */     // MIs[0] round
     /* 1196012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196022 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1196025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196047 */     // GIR_Coverage, 16898,
     /* 1196047 */     GIR_EraseRootFromParent_Done,
     /* 1196048 */   // Label 17398: @1196048
     /* 1196048 */   GIM_Try, /*On fail goto*//*Label 17399*/ GIMT_Encode4(1196128), // Rule ID 16899 //
     /* 1196053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1196056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1196064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1196067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1196070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196092 */     // MIs[0] round
     /* 1196092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196102 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1196105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196127 */     // GIR_Coverage, 16899,
     /* 1196127 */     GIR_EraseRootFromParent_Done,
     /* 1196128 */   // Label 17399: @1196128
     /* 1196128 */   GIM_Try, /*On fail goto*//*Label 17400*/ GIMT_Encode4(1196208), // Rule ID 16902 //
     /* 1196133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1196136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1196144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1196147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1196150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196172 */     // MIs[0] round
     /* 1196172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196182 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1196185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196207 */     // GIR_Coverage, 16902,
     /* 1196207 */     GIR_EraseRootFromParent_Done,
     /* 1196208 */   // Label 17400: @1196208
     /* 1196208 */   GIM_Try, /*On fail goto*//*Label 17401*/ GIMT_Encode4(1196288), // Rule ID 16903 //
     /* 1196213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1196216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1196224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1196227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1196230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196252 */     // MIs[0] round
     /* 1196252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196262 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1196265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196287 */     // GIR_Coverage, 16903,
     /* 1196287 */     GIR_EraseRootFromParent_Done,
     /* 1196288 */   // Label 17401: @1196288
     /* 1196288 */   GIM_Try, /*On fail goto*//*Label 17402*/ GIMT_Encode4(1196368), // Rule ID 16906 //
     /* 1196293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1196304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1196307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1196310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196332 */     // MIs[0] round
     /* 1196332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196342 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1196345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196367 */     // GIR_Coverage, 16906,
     /* 1196367 */     GIR_EraseRootFromParent_Done,
     /* 1196368 */   // Label 17402: @1196368
     /* 1196368 */   GIM_Try, /*On fail goto*//*Label 17403*/ GIMT_Encode4(1196448), // Rule ID 16907 //
     /* 1196373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1196384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1196387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1196390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196412 */     // MIs[0] round
     /* 1196412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196422 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1196425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196447 */     // GIR_Coverage, 16907,
     /* 1196447 */     GIR_EraseRootFromParent_Done,
     /* 1196448 */   // Label 17403: @1196448
     /* 1196448 */   GIM_Try, /*On fail goto*//*Label 17404*/ GIMT_Encode4(1196528), // Rule ID 16910 //
     /* 1196453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1196464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1196467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1196470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196492 */     // MIs[0] round
     /* 1196492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196502 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1196505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196527 */     // GIR_Coverage, 16910,
     /* 1196527 */     GIR_EraseRootFromParent_Done,
     /* 1196528 */   // Label 17404: @1196528
     /* 1196528 */   GIM_Try, /*On fail goto*//*Label 17405*/ GIMT_Encode4(1196608), // Rule ID 16911 //
     /* 1196533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1196544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1196547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1196550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196572 */     // MIs[0] round
     /* 1196572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196582 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1196585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196607 */     // GIR_Coverage, 16911,
     /* 1196607 */     GIR_EraseRootFromParent_Done,
     /* 1196608 */   // Label 17405: @1196608
     /* 1196608 */   GIM_Try, /*On fail goto*//*Label 17406*/ GIMT_Encode4(1196688), // Rule ID 16914 //
     /* 1196613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1196624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1196627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1196630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196652 */     // MIs[0] round
     /* 1196652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196662 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1196665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196687 */     // GIR_Coverage, 16914,
     /* 1196687 */     GIR_EraseRootFromParent_Done,
     /* 1196688 */   // Label 17406: @1196688
     /* 1196688 */   GIM_Try, /*On fail goto*//*Label 17407*/ GIMT_Encode4(1196768), // Rule ID 16915 //
     /* 1196693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1196704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1196707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1196710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196732 */     // MIs[0] round
     /* 1196732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196742 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1196745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196767 */     // GIR_Coverage, 16915,
     /* 1196767 */     GIR_EraseRootFromParent_Done,
     /* 1196768 */   // Label 17407: @1196768
     /* 1196768 */   GIM_Try, /*On fail goto*//*Label 17408*/ GIMT_Encode4(1196848), // Rule ID 16918 //
     /* 1196773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1196776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1196784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1196787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1196790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196812 */     // MIs[0] round
     /* 1196812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196822 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1196825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196847 */     // GIR_Coverage, 16918,
     /* 1196847 */     GIR_EraseRootFromParent_Done,
     /* 1196848 */   // Label 17408: @1196848
     /* 1196848 */   GIM_Try, /*On fail goto*//*Label 17409*/ GIMT_Encode4(1196928), // Rule ID 16919 //
     /* 1196853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1196856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1196864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1196867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1196870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196892 */     // MIs[0] round
     /* 1196892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196902 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1196905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196927 */     // GIR_Coverage, 16919,
     /* 1196927 */     GIR_EraseRootFromParent_Done,
     /* 1196928 */   // Label 17409: @1196928
     /* 1196928 */   GIM_Try, /*On fail goto*//*Label 17410*/ GIMT_Encode4(1197008), // Rule ID 16922 //
     /* 1196933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1196936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1196944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1196947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1196950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196972 */     // MIs[0] round
     /* 1196972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196982 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1196985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197007 */     // GIR_Coverage, 16922,
     /* 1197007 */     GIR_EraseRootFromParent_Done,
     /* 1197008 */   // Label 17410: @1197008
     /* 1197008 */   GIM_Try, /*On fail goto*//*Label 17411*/ GIMT_Encode4(1197088), // Rule ID 16923 //
     /* 1197013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1197016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1197024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1197027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1197030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197052 */     // MIs[0] round
     /* 1197052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197062 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1197065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197087 */     // GIR_Coverage, 16923,
     /* 1197087 */     GIR_EraseRootFromParent_Done,
     /* 1197088 */   // Label 17411: @1197088
     /* 1197088 */   GIM_Try, /*On fail goto*//*Label 17412*/ GIMT_Encode4(1197168), // Rule ID 16926 //
     /* 1197093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1197096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1197104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1197107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1197110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197132 */     // MIs[0] round
     /* 1197132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197142 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1197145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197167 */     // GIR_Coverage, 16926,
     /* 1197167 */     GIR_EraseRootFromParent_Done,
     /* 1197168 */   // Label 17412: @1197168
     /* 1197168 */   GIM_Try, /*On fail goto*//*Label 17413*/ GIMT_Encode4(1197248), // Rule ID 16927 //
     /* 1197173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1197176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1197184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1197187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1197190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197212 */     // MIs[0] round
     /* 1197212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197222 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1197225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197247 */     // GIR_Coverage, 16927,
     /* 1197247 */     GIR_EraseRootFromParent_Done,
     /* 1197248 */   // Label 17413: @1197248
     /* 1197248 */   GIM_Try, /*On fail goto*//*Label 17414*/ GIMT_Encode4(1197328), // Rule ID 16930 //
     /* 1197253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1197256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1197264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1197267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1197270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197292 */     // MIs[0] round
     /* 1197292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197302 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1197305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197327 */     // GIR_Coverage, 16930,
     /* 1197327 */     GIR_EraseRootFromParent_Done,
     /* 1197328 */   // Label 17414: @1197328
     /* 1197328 */   GIM_Try, /*On fail goto*//*Label 17415*/ GIMT_Encode4(1197408), // Rule ID 16931 //
     /* 1197333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1197344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1197347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1197350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197372 */     // MIs[0] round
     /* 1197372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197382 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1197385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197407 */     // GIR_Coverage, 16931,
     /* 1197407 */     GIR_EraseRootFromParent_Done,
     /* 1197408 */   // Label 17415: @1197408
     /* 1197408 */   GIM_Try, /*On fail goto*//*Label 17416*/ GIMT_Encode4(1197488), // Rule ID 16934 //
     /* 1197413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1197416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1197424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1197427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1197430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197452 */     // MIs[0] round
     /* 1197452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197462 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1197465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197487 */     // GIR_Coverage, 16934,
     /* 1197487 */     GIR_EraseRootFromParent_Done,
     /* 1197488 */   // Label 17416: @1197488
     /* 1197488 */   GIM_Try, /*On fail goto*//*Label 17417*/ GIMT_Encode4(1197568), // Rule ID 16935 //
     /* 1197493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1197504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1197507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1197510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197532 */     // MIs[0] round
     /* 1197532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197542 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1197545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197567 */     // GIR_Coverage, 16935,
     /* 1197567 */     GIR_EraseRootFromParent_Done,
     /* 1197568 */   // Label 17417: @1197568
     /* 1197568 */   GIM_Try, /*On fail goto*//*Label 17418*/ GIMT_Encode4(1197648), // Rule ID 16938 //
     /* 1197573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1197576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1197584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1197587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1197590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197612 */     // MIs[0] round
     /* 1197612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197622 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1197625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197647 */     // GIR_Coverage, 16938,
     /* 1197647 */     GIR_EraseRootFromParent_Done,
     /* 1197648 */   // Label 17418: @1197648
     /* 1197648 */   GIM_Try, /*On fail goto*//*Label 17419*/ GIMT_Encode4(1197728), // Rule ID 16939 //
     /* 1197653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1197664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1197667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1197670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197692 */     // MIs[0] round
     /* 1197692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197702 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1197705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197727 */     // GIR_Coverage, 16939,
     /* 1197727 */     GIR_EraseRootFromParent_Done,
     /* 1197728 */   // Label 17419: @1197728
     /* 1197728 */   GIM_Try, /*On fail goto*//*Label 17420*/ GIMT_Encode4(1197808), // Rule ID 16942 //
     /* 1197733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1197736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1197744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1197747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1197750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197772 */     // MIs[0] round
     /* 1197772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197782 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1197785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197807 */     // GIR_Coverage, 16942,
     /* 1197807 */     GIR_EraseRootFromParent_Done,
     /* 1197808 */   // Label 17420: @1197808
     /* 1197808 */   GIM_Try, /*On fail goto*//*Label 17421*/ GIMT_Encode4(1197888), // Rule ID 16943 //
     /* 1197813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1197816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1197824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1197827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1197830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197852 */     // MIs[0] round
     /* 1197852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197862 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1197865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197887 */     // GIR_Coverage, 16943,
     /* 1197887 */     GIR_EraseRootFromParent_Done,
     /* 1197888 */   // Label 17421: @1197888
     /* 1197888 */   GIM_Try, /*On fail goto*//*Label 17422*/ GIMT_Encode4(1197968), // Rule ID 16946 //
     /* 1197893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1197896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1197904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1197907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1197910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197932 */     // MIs[0] round
     /* 1197932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197942 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1197945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197967 */     // GIR_Coverage, 16946,
     /* 1197967 */     GIR_EraseRootFromParent_Done,
     /* 1197968 */   // Label 17422: @1197968
     /* 1197968 */   GIM_Try, /*On fail goto*//*Label 17423*/ GIMT_Encode4(1198048), // Rule ID 16947 //
     /* 1197973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1197976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1197984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1197987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1197990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198012 */     // MIs[0] round
     /* 1198012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198022 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1198025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198047 */     // GIR_Coverage, 16947,
     /* 1198047 */     GIR_EraseRootFromParent_Done,
     /* 1198048 */   // Label 17423: @1198048
     /* 1198048 */   GIM_Try, /*On fail goto*//*Label 17424*/ GIMT_Encode4(1198128), // Rule ID 16950 //
     /* 1198053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1198056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1198064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1198067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1198070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198092 */     // MIs[0] round
     /* 1198092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198102 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1198105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198127 */     // GIR_Coverage, 16950,
     /* 1198127 */     GIR_EraseRootFromParent_Done,
     /* 1198128 */   // Label 17424: @1198128
     /* 1198128 */   GIM_Try, /*On fail goto*//*Label 17425*/ GIMT_Encode4(1198208), // Rule ID 16951 //
     /* 1198133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1198136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1198144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1198147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1198150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198172 */     // MIs[0] round
     /* 1198172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198182 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1198185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198207 */     // GIR_Coverage, 16951,
     /* 1198207 */     GIR_EraseRootFromParent_Done,
     /* 1198208 */   // Label 17425: @1198208
     /* 1198208 */   GIM_Try, /*On fail goto*//*Label 17426*/ GIMT_Encode4(1198288), // Rule ID 16954 //
     /* 1198213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1198224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1198227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1198230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198252 */     // MIs[0] round
     /* 1198252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198262 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1198265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198287 */     // GIR_Coverage, 16954,
     /* 1198287 */     GIR_EraseRootFromParent_Done,
     /* 1198288 */   // Label 17426: @1198288
     /* 1198288 */   GIM_Try, /*On fail goto*//*Label 17427*/ GIMT_Encode4(1198368), // Rule ID 16955 //
     /* 1198293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1198304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1198307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1198310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198332 */     // MIs[0] round
     /* 1198332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198342 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1198345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198367 */     // GIR_Coverage, 16955,
     /* 1198367 */     GIR_EraseRootFromParent_Done,
     /* 1198368 */   // Label 17427: @1198368
     /* 1198368 */   GIM_Try, /*On fail goto*//*Label 17428*/ GIMT_Encode4(1198448), // Rule ID 16958 //
     /* 1198373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1198376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1198384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1198387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1198390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198412 */     // MIs[0] round
     /* 1198412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198422 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1198425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198447 */     // GIR_Coverage, 16958,
     /* 1198447 */     GIR_EraseRootFromParent_Done,
     /* 1198448 */   // Label 17428: @1198448
     /* 1198448 */   GIM_Try, /*On fail goto*//*Label 17429*/ GIMT_Encode4(1198528), // Rule ID 16959 //
     /* 1198453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1198456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1198464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1198467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1198470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198492 */     // MIs[0] round
     /* 1198492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198502 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1198505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198527 */     // GIR_Coverage, 16959,
     /* 1198527 */     GIR_EraseRootFromParent_Done,
     /* 1198528 */   // Label 17429: @1198528
     /* 1198528 */   GIM_Try, /*On fail goto*//*Label 17430*/ GIMT_Encode4(1198608), // Rule ID 16962 //
     /* 1198533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1198536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1198544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1198547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1198550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1198572 */     // MIs[0] round
     /* 1198572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198582 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1198585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198607 */     // GIR_Coverage, 16962,
     /* 1198607 */     GIR_EraseRootFromParent_Done,
     /* 1198608 */   // Label 17430: @1198608
     /* 1198608 */   GIM_Try, /*On fail goto*//*Label 17431*/ GIMT_Encode4(1198688), // Rule ID 16963 //
     /* 1198613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1198616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1198624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1198627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1198630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1198652 */     // MIs[0] round
     /* 1198652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198662 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1198665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198687 */     // GIR_Coverage, 16963,
     /* 1198687 */     GIR_EraseRootFromParent_Done,
     /* 1198688 */   // Label 17431: @1198688
     /* 1198688 */   GIM_Try, /*On fail goto*//*Label 17432*/ GIMT_Encode4(1198768), // Rule ID 16966 //
     /* 1198693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1198704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1198707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1198710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198732 */     // MIs[0] round
     /* 1198732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198742 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1198745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198767 */     // GIR_Coverage, 16966,
     /* 1198767 */     GIR_EraseRootFromParent_Done,
     /* 1198768 */   // Label 17432: @1198768
     /* 1198768 */   GIM_Try, /*On fail goto*//*Label 17433*/ GIMT_Encode4(1198848), // Rule ID 16967 //
     /* 1198773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1198784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1198787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1198790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198812 */     // MIs[0] round
     /* 1198812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198822 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1198825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198847 */     // GIR_Coverage, 16967,
     /* 1198847 */     GIR_EraseRootFromParent_Done,
     /* 1198848 */   // Label 17433: @1198848
     /* 1198848 */   GIM_Try, /*On fail goto*//*Label 17434*/ GIMT_Encode4(1198928), // Rule ID 16970 //
     /* 1198853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1198864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1198867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1198870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198892 */     // MIs[0] round
     /* 1198892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198902 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1198905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198927 */     // GIR_Coverage, 16970,
     /* 1198927 */     GIR_EraseRootFromParent_Done,
     /* 1198928 */   // Label 17434: @1198928
     /* 1198928 */   GIM_Try, /*On fail goto*//*Label 17435*/ GIMT_Encode4(1199008), // Rule ID 16971 //
     /* 1198933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1198944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1198947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1198950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198972 */     // MIs[0] round
     /* 1198972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198982 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1198985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199007 */     // GIR_Coverage, 16971,
     /* 1199007 */     GIR_EraseRootFromParent_Done,
     /* 1199008 */   // Label 17435: @1199008
     /* 1199008 */   GIM_Try, /*On fail goto*//*Label 17436*/ GIMT_Encode4(1199088), // Rule ID 16974 //
     /* 1199013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1199016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1199024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1199027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1199030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199052 */     // MIs[0] round
     /* 1199052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199062 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1199065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199087 */     // GIR_Coverage, 16974,
     /* 1199087 */     GIR_EraseRootFromParent_Done,
     /* 1199088 */   // Label 17436: @1199088
     /* 1199088 */   GIM_Try, /*On fail goto*//*Label 17437*/ GIMT_Encode4(1199168), // Rule ID 16975 //
     /* 1199093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1199096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1199104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1199107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1199110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199132 */     // MIs[0] round
     /* 1199132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199142 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1199145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199167 */     // GIR_Coverage, 16975,
     /* 1199167 */     GIR_EraseRootFromParent_Done,
     /* 1199168 */   // Label 17437: @1199168
     /* 1199168 */   GIM_Try, /*On fail goto*//*Label 17438*/ GIMT_Encode4(1199248), // Rule ID 16978 //
     /* 1199173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1199184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1199187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1199190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199212 */     // MIs[0] round
     /* 1199212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199222 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1199225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199247 */     // GIR_Coverage, 16978,
     /* 1199247 */     GIR_EraseRootFromParent_Done,
     /* 1199248 */   // Label 17438: @1199248
     /* 1199248 */   GIM_Try, /*On fail goto*//*Label 17439*/ GIMT_Encode4(1199328), // Rule ID 16979 //
     /* 1199253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1199264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1199267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1199270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199292 */     // MIs[0] round
     /* 1199292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199302 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1199305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199327 */     // GIR_Coverage, 16979,
     /* 1199327 */     GIR_EraseRootFromParent_Done,
     /* 1199328 */   // Label 17439: @1199328
     /* 1199328 */   GIM_Try, /*On fail goto*//*Label 17440*/ GIMT_Encode4(1199408), // Rule ID 16982 //
     /* 1199333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1199344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1199347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199372 */     // MIs[0] round
     /* 1199372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199382 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1199385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199407 */     // GIR_Coverage, 16982,
     /* 1199407 */     GIR_EraseRootFromParent_Done,
     /* 1199408 */   // Label 17440: @1199408
     /* 1199408 */   GIM_Try, /*On fail goto*//*Label 17441*/ GIMT_Encode4(1199488), // Rule ID 16983 //
     /* 1199413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1199424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1199427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199452 */     // MIs[0] round
     /* 1199452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199462 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1199465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199487 */     // GIR_Coverage, 16983,
     /* 1199487 */     GIR_EraseRootFromParent_Done,
     /* 1199488 */   // Label 17441: @1199488
     /* 1199488 */   GIM_Try, /*On fail goto*//*Label 17442*/ GIMT_Encode4(1199568), // Rule ID 16986 //
     /* 1199493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1199504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1199507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1199510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199532 */     // MIs[0] round
     /* 1199532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199542 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1199545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199567 */     // GIR_Coverage, 16986,
     /* 1199567 */     GIR_EraseRootFromParent_Done,
     /* 1199568 */   // Label 17442: @1199568
     /* 1199568 */   GIM_Try, /*On fail goto*//*Label 17443*/ GIMT_Encode4(1199648), // Rule ID 16987 //
     /* 1199573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1199584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1199587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1199590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199612 */     // MIs[0] round
     /* 1199612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199622 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1199625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199647 */     // GIR_Coverage, 16987,
     /* 1199647 */     GIR_EraseRootFromParent_Done,
     /* 1199648 */   // Label 17443: @1199648
     /* 1199648 */   GIM_Try, /*On fail goto*//*Label 17444*/ GIMT_Encode4(1199728), // Rule ID 16990 //
     /* 1199653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1199656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1199664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1199667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1199670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199692 */     // MIs[0] round
     /* 1199692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199702 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1199705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199727 */     // GIR_Coverage, 16990,
     /* 1199727 */     GIR_EraseRootFromParent_Done,
     /* 1199728 */   // Label 17444: @1199728
     /* 1199728 */   GIM_Try, /*On fail goto*//*Label 17445*/ GIMT_Encode4(1199808), // Rule ID 16991 //
     /* 1199733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1199736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1199744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1199747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1199750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199772 */     // MIs[0] round
     /* 1199772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199782 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1199785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199807 */     // GIR_Coverage, 16991,
     /* 1199807 */     GIR_EraseRootFromParent_Done,
     /* 1199808 */   // Label 17445: @1199808
     /* 1199808 */   GIM_Try, /*On fail goto*//*Label 17446*/ GIMT_Encode4(1199888), // Rule ID 16994 //
     /* 1199813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1199816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1199824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1199827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1199830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199852 */     // MIs[0] round
     /* 1199852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199862 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1199865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199887 */     // GIR_Coverage, 16994,
     /* 1199887 */     GIR_EraseRootFromParent_Done,
     /* 1199888 */   // Label 17446: @1199888
     /* 1199888 */   GIM_Try, /*On fail goto*//*Label 17447*/ GIMT_Encode4(1199968), // Rule ID 16995 //
     /* 1199893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1199896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1199904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1199907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1199910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199932 */     // MIs[0] round
     /* 1199932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199942 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1199945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199967 */     // GIR_Coverage, 16995,
     /* 1199967 */     GIR_EraseRootFromParent_Done,
     /* 1199968 */   // Label 17447: @1199968
     /* 1199968 */   GIM_Try, /*On fail goto*//*Label 17448*/ GIMT_Encode4(1200048), // Rule ID 16998 //
     /* 1199973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1199976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1199984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1199987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1199990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200012 */     // MIs[0] round
     /* 1200012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200022 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1200025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200047 */     // GIR_Coverage, 16998,
     /* 1200047 */     GIR_EraseRootFromParent_Done,
     /* 1200048 */   // Label 17448: @1200048
     /* 1200048 */   GIM_Try, /*On fail goto*//*Label 17449*/ GIMT_Encode4(1200128), // Rule ID 16999 //
     /* 1200053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1200056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1200064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1200067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1200070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200092 */     // MIs[0] round
     /* 1200092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200102 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1200105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200127 */     // GIR_Coverage, 16999,
     /* 1200127 */     GIR_EraseRootFromParent_Done,
     /* 1200128 */   // Label 17449: @1200128
     /* 1200128 */   GIM_Try, /*On fail goto*//*Label 17450*/ GIMT_Encode4(1200208), // Rule ID 17002 //
     /* 1200133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1200144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1200147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1200150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1200153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200172 */     // MIs[0] round
     /* 1200172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200182 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1200185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200207 */     // GIR_Coverage, 17002,
     /* 1200207 */     GIR_EraseRootFromParent_Done,
     /* 1200208 */   // Label 17450: @1200208
     /* 1200208 */   GIM_Try, /*On fail goto*//*Label 17451*/ GIMT_Encode4(1200288), // Rule ID 17003 //
     /* 1200213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1200224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1200227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1200230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1200233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200252 */     // MIs[0] round
     /* 1200252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200262 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1200265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200287 */     // GIR_Coverage, 17003,
     /* 1200287 */     GIR_EraseRootFromParent_Done,
     /* 1200288 */   // Label 17451: @1200288
     /* 1200288 */   GIM_Try, /*On fail goto*//*Label 17452*/ GIMT_Encode4(1200368), // Rule ID 17006 //
     /* 1200293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1200304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1200307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1200310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1200313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200332 */     // MIs[0] round
     /* 1200332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200342 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1200345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200367 */     // GIR_Coverage, 17006,
     /* 1200367 */     GIR_EraseRootFromParent_Done,
     /* 1200368 */   // Label 17452: @1200368
     /* 1200368 */   GIM_Try, /*On fail goto*//*Label 17453*/ GIMT_Encode4(1200448), // Rule ID 17007 //
     /* 1200373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1200384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1200387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1200390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1200393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200412 */     // MIs[0] round
     /* 1200412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200422 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1200425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200447 */     // GIR_Coverage, 17007,
     /* 1200447 */     GIR_EraseRootFromParent_Done,
     /* 1200448 */   // Label 17453: @1200448
     /* 1200448 */   GIM_Try, /*On fail goto*//*Label 17454*/ GIMT_Encode4(1200528), // Rule ID 17010 //
     /* 1200453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1200464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1200467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1200470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1200473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200492 */     // MIs[0] round
     /* 1200492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200502 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1200505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200527 */     // GIR_Coverage, 17010,
     /* 1200527 */     GIR_EraseRootFromParent_Done,
     /* 1200528 */   // Label 17454: @1200528
     /* 1200528 */   GIM_Try, /*On fail goto*//*Label 17455*/ GIMT_Encode4(1200608), // Rule ID 17011 //
     /* 1200533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1200544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1200547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1200550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1200553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200572 */     // MIs[0] round
     /* 1200572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200582 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1200585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200607 */     // GIR_Coverage, 17011,
     /* 1200607 */     GIR_EraseRootFromParent_Done,
     /* 1200608 */   // Label 17455: @1200608
     /* 1200608 */   GIM_Try, /*On fail goto*//*Label 17456*/ GIMT_Encode4(1200688), // Rule ID 17014 //
     /* 1200613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1200624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1200627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1200630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1200633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200652 */     // MIs[0] round
     /* 1200652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200662 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1200665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200687 */     // GIR_Coverage, 17014,
     /* 1200687 */     GIR_EraseRootFromParent_Done,
     /* 1200688 */   // Label 17456: @1200688
     /* 1200688 */   GIM_Try, /*On fail goto*//*Label 17457*/ GIMT_Encode4(1200768), // Rule ID 17015 //
     /* 1200693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1200704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1200707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1200710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1200713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200732 */     // MIs[0] round
     /* 1200732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200742 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1200745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200767 */     // GIR_Coverage, 17015,
     /* 1200767 */     GIR_EraseRootFromParent_Done,
     /* 1200768 */   // Label 17457: @1200768
     /* 1200768 */   GIM_Try, /*On fail goto*//*Label 17458*/ GIMT_Encode4(1200848), // Rule ID 17018 //
     /* 1200773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1200784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1200787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1200790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1200793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200812 */     // MIs[0] round
     /* 1200812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200822 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1200825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200847 */     // GIR_Coverage, 17018,
     /* 1200847 */     GIR_EraseRootFromParent_Done,
     /* 1200848 */   // Label 17458: @1200848
     /* 1200848 */   GIM_Try, /*On fail goto*//*Label 17459*/ GIMT_Encode4(1200928), // Rule ID 17019 //
     /* 1200853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1200864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1200867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1200870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1200873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200892 */     // MIs[0] round
     /* 1200892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200902 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1200905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200927 */     // GIR_Coverage, 17019,
     /* 1200927 */     GIR_EraseRootFromParent_Done,
     /* 1200928 */   // Label 17459: @1200928
     /* 1200928 */   GIM_Try, /*On fail goto*//*Label 17460*/ GIMT_Encode4(1201008), // Rule ID 17022 //
     /* 1200933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1200936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1200944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1200947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1200950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1200953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200972 */     // MIs[0] round
     /* 1200972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200982 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1200985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201007 */     // GIR_Coverage, 17022,
     /* 1201007 */     GIR_EraseRootFromParent_Done,
     /* 1201008 */   // Label 17460: @1201008
     /* 1201008 */   GIM_Try, /*On fail goto*//*Label 17461*/ GIMT_Encode4(1201088), // Rule ID 17023 //
     /* 1201013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1201024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1201027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1201030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1201033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201052 */     // MIs[0] round
     /* 1201052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201062 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1201065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201087 */     // GIR_Coverage, 17023,
     /* 1201087 */     GIR_EraseRootFromParent_Done,
     /* 1201088 */   // Label 17461: @1201088
     /* 1201088 */   GIM_Try, /*On fail goto*//*Label 17462*/ GIMT_Encode4(1201168), // Rule ID 17026 //
     /* 1201093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1201104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1201107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1201110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1201113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201132 */     // MIs[0] round
     /* 1201132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201142 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1201145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201167 */     // GIR_Coverage, 17026,
     /* 1201167 */     GIR_EraseRootFromParent_Done,
     /* 1201168 */   // Label 17462: @1201168
     /* 1201168 */   GIM_Try, /*On fail goto*//*Label 17463*/ GIMT_Encode4(1201248), // Rule ID 17027 //
     /* 1201173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1201184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1201187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1201190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1201193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201212 */     // MIs[0] round
     /* 1201212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201222 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1201225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201247 */     // GIR_Coverage, 17027,
     /* 1201247 */     GIR_EraseRootFromParent_Done,
     /* 1201248 */   // Label 17463: @1201248
     /* 1201248 */   GIM_Try, /*On fail goto*//*Label 17464*/ GIMT_Encode4(1201328), // Rule ID 17030 //
     /* 1201253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1201264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1201267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1201270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1201273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201292 */     // MIs[0] round
     /* 1201292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201302 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1201305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201327 */     // GIR_Coverage, 17030,
     /* 1201327 */     GIR_EraseRootFromParent_Done,
     /* 1201328 */   // Label 17464: @1201328
     /* 1201328 */   GIM_Try, /*On fail goto*//*Label 17465*/ GIMT_Encode4(1201408), // Rule ID 17031 //
     /* 1201333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1201344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1201347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1201350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1201353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201372 */     // MIs[0] round
     /* 1201372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201382 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1201385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201407 */     // GIR_Coverage, 17031,
     /* 1201407 */     GIR_EraseRootFromParent_Done,
     /* 1201408 */   // Label 17465: @1201408
     /* 1201408 */   GIM_Try, /*On fail goto*//*Label 17466*/ GIMT_Encode4(1201488), // Rule ID 17034 //
     /* 1201413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1201433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201452 */     // MIs[0] round
     /* 1201452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201462 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1201465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201487 */     // GIR_Coverage, 17034,
     /* 1201487 */     GIR_EraseRootFromParent_Done,
     /* 1201488 */   // Label 17466: @1201488
     /* 1201488 */   GIM_Try, /*On fail goto*//*Label 17467*/ GIMT_Encode4(1201568), // Rule ID 17035 //
     /* 1201493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1201513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201532 */     // MIs[0] round
     /* 1201532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201542 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1201545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201567 */     // GIR_Coverage, 17035,
     /* 1201567 */     GIR_EraseRootFromParent_Done,
     /* 1201568 */   // Label 17467: @1201568
     /* 1201568 */   GIM_Try, /*On fail goto*//*Label 17468*/ GIMT_Encode4(1201648), // Rule ID 17038 //
     /* 1201573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1201584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1201587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1201590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201612 */     // MIs[0] round
     /* 1201612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201622 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1201625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201647 */     // GIR_Coverage, 17038,
     /* 1201647 */     GIR_EraseRootFromParent_Done,
     /* 1201648 */   // Label 17468: @1201648
     /* 1201648 */   GIM_Try, /*On fail goto*//*Label 17469*/ GIMT_Encode4(1201728), // Rule ID 17039 //
     /* 1201653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1201664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1201667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1201670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201692 */     // MIs[0] round
     /* 1201692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201702 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1201705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201727 */     // GIR_Coverage, 17039,
     /* 1201727 */     GIR_EraseRootFromParent_Done,
     /* 1201728 */   // Label 17469: @1201728
     /* 1201728 */   GIM_Try, /*On fail goto*//*Label 17470*/ GIMT_Encode4(1201808), // Rule ID 17042 //
     /* 1201733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1201744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1201747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1201750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201772 */     // MIs[0] round
     /* 1201772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201782 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1201785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201807 */     // GIR_Coverage, 17042,
     /* 1201807 */     GIR_EraseRootFromParent_Done,
     /* 1201808 */   // Label 17470: @1201808
     /* 1201808 */   GIM_Try, /*On fail goto*//*Label 17471*/ GIMT_Encode4(1201888), // Rule ID 17043 //
     /* 1201813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1201824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1201827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1201830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201852 */     // MIs[0] round
     /* 1201852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201862 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1201865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201887 */     // GIR_Coverage, 17043,
     /* 1201887 */     GIR_EraseRootFromParent_Done,
     /* 1201888 */   // Label 17471: @1201888
     /* 1201888 */   GIM_Try, /*On fail goto*//*Label 17472*/ GIMT_Encode4(1201968), // Rule ID 17046 //
     /* 1201893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1201904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1201907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1201910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201932 */     // MIs[0] round
     /* 1201932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201942 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1201945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201967 */     // GIR_Coverage, 17046,
     /* 1201967 */     GIR_EraseRootFromParent_Done,
     /* 1201968 */   // Label 17472: @1201968
     /* 1201968 */   GIM_Try, /*On fail goto*//*Label 17473*/ GIMT_Encode4(1202048), // Rule ID 17047 //
     /* 1201973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1201984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1201987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1201990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202012 */     // MIs[0] round
     /* 1202012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202022 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1202025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202047 */     // GIR_Coverage, 17047,
     /* 1202047 */     GIR_EraseRootFromParent_Done,
     /* 1202048 */   // Label 17473: @1202048
     /* 1202048 */   GIM_Try, /*On fail goto*//*Label 17474*/ GIMT_Encode4(1202128), // Rule ID 17050 //
     /* 1202053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1202064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1202067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1202070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202092 */     // MIs[0] round
     /* 1202092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202102 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1202105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202127 */     // GIR_Coverage, 17050,
     /* 1202127 */     GIR_EraseRootFromParent_Done,
     /* 1202128 */   // Label 17474: @1202128
     /* 1202128 */   GIM_Try, /*On fail goto*//*Label 17475*/ GIMT_Encode4(1202208), // Rule ID 17051 //
     /* 1202133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1202144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1202147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1202150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202172 */     // MIs[0] round
     /* 1202172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202182 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1202185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202207 */     // GIR_Coverage, 17051,
     /* 1202207 */     GIR_EraseRootFromParent_Done,
     /* 1202208 */   // Label 17475: @1202208
     /* 1202208 */   GIM_Try, /*On fail goto*//*Label 17476*/ GIMT_Encode4(1202288), // Rule ID 17054 //
     /* 1202213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1202224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1202227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1202230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202252 */     // MIs[0] round
     /* 1202252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202262 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1202265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202287 */     // GIR_Coverage, 17054,
     /* 1202287 */     GIR_EraseRootFromParent_Done,
     /* 1202288 */   // Label 17476: @1202288
     /* 1202288 */   GIM_Try, /*On fail goto*//*Label 17477*/ GIMT_Encode4(1202368), // Rule ID 17055 //
     /* 1202293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1202304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1202307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1202310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202332 */     // MIs[0] round
     /* 1202332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202342 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1202345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202367 */     // GIR_Coverage, 17055,
     /* 1202367 */     GIR_EraseRootFromParent_Done,
     /* 1202368 */   // Label 17477: @1202368
     /* 1202368 */   GIM_Try, /*On fail goto*//*Label 17478*/ GIMT_Encode4(1202448), // Rule ID 17058 //
     /* 1202373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1202384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1202387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1202390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202412 */     // MIs[0] round
     /* 1202412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202422 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1202425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202447 */     // GIR_Coverage, 17058,
     /* 1202447 */     GIR_EraseRootFromParent_Done,
     /* 1202448 */   // Label 17478: @1202448
     /* 1202448 */   GIM_Try, /*On fail goto*//*Label 17479*/ GIMT_Encode4(1202528), // Rule ID 17059 //
     /* 1202453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1202464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1202467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1202470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202492 */     // MIs[0] round
     /* 1202492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202502 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1202505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202527 */     // GIR_Coverage, 17059,
     /* 1202527 */     GIR_EraseRootFromParent_Done,
     /* 1202528 */   // Label 17479: @1202528
     /* 1202528 */   GIM_Try, /*On fail goto*//*Label 17480*/ GIMT_Encode4(1202608), // Rule ID 17062 //
     /* 1202533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1202544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1202547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1202550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202572 */     // MIs[0] round
     /* 1202572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202582 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1202585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202607 */     // GIR_Coverage, 17062,
     /* 1202607 */     GIR_EraseRootFromParent_Done,
     /* 1202608 */   // Label 17480: @1202608
     /* 1202608 */   GIM_Try, /*On fail goto*//*Label 17481*/ GIMT_Encode4(1202688), // Rule ID 17063 //
     /* 1202613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1202624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1202627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1202630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202652 */     // MIs[0] round
     /* 1202652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202662 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1202665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202687 */     // GIR_Coverage, 17063,
     /* 1202687 */     GIR_EraseRootFromParent_Done,
     /* 1202688 */   // Label 17481: @1202688
     /* 1202688 */   GIM_Try, /*On fail goto*//*Label 17482*/ GIMT_Encode4(1202768), // Rule ID 17066 //
     /* 1202693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1202704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1202707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1202710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202732 */     // MIs[0] round
     /* 1202732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202742 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1202745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202767 */     // GIR_Coverage, 17066,
     /* 1202767 */     GIR_EraseRootFromParent_Done,
     /* 1202768 */   // Label 17482: @1202768
     /* 1202768 */   GIM_Try, /*On fail goto*//*Label 17483*/ GIMT_Encode4(1202848), // Rule ID 17067 //
     /* 1202773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1202784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1202787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1202790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202812 */     // MIs[0] round
     /* 1202812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202822 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1202825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202847 */     // GIR_Coverage, 17067,
     /* 1202847 */     GIR_EraseRootFromParent_Done,
     /* 1202848 */   // Label 17483: @1202848
     /* 1202848 */   GIM_Try, /*On fail goto*//*Label 17484*/ GIMT_Encode4(1202928), // Rule ID 17070 //
     /* 1202853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1202864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1202867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1202870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202892 */     // MIs[0] round
     /* 1202892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202902 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1202905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202927 */     // GIR_Coverage, 17070,
     /* 1202927 */     GIR_EraseRootFromParent_Done,
     /* 1202928 */   // Label 17484: @1202928
     /* 1202928 */   GIM_Try, /*On fail goto*//*Label 17485*/ GIMT_Encode4(1203008), // Rule ID 17071 //
     /* 1202933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1202944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1202947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1202950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202972 */     // MIs[0] round
     /* 1202972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202982 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1202985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203007 */     // GIR_Coverage, 17071,
     /* 1203007 */     GIR_EraseRootFromParent_Done,
     /* 1203008 */   // Label 17485: @1203008
     /* 1203008 */   GIM_Try, /*On fail goto*//*Label 17486*/ GIMT_Encode4(1203088), // Rule ID 17074 //
     /* 1203013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1203024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1203027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1203030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1203033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203052 */     // MIs[0] round
     /* 1203052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203062 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1203065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203087 */     // GIR_Coverage, 17074,
     /* 1203087 */     GIR_EraseRootFromParent_Done,
     /* 1203088 */   // Label 17486: @1203088
     /* 1203088 */   GIM_Try, /*On fail goto*//*Label 17487*/ GIMT_Encode4(1203168), // Rule ID 17075 //
     /* 1203093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1203104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1203107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1203110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1203113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203132 */     // MIs[0] round
     /* 1203132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203142 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1203145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203167 */     // GIR_Coverage, 17075,
     /* 1203167 */     GIR_EraseRootFromParent_Done,
     /* 1203168 */   // Label 17487: @1203168
     /* 1203168 */   GIM_Try, /*On fail goto*//*Label 17488*/ GIMT_Encode4(1203248), // Rule ID 17078 //
     /* 1203173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1203184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1203187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1203190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1203193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203212 */     // MIs[0] round
     /* 1203212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203222 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1203225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203247 */     // GIR_Coverage, 17078,
     /* 1203247 */     GIR_EraseRootFromParent_Done,
     /* 1203248 */   // Label 17488: @1203248
     /* 1203248 */   GIM_Try, /*On fail goto*//*Label 17489*/ GIMT_Encode4(1203328), // Rule ID 17079 //
     /* 1203253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1203264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1203267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1203270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1203273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203292 */     // MIs[0] round
     /* 1203292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203302 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1203305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203327 */     // GIR_Coverage, 17079,
     /* 1203327 */     GIR_EraseRootFromParent_Done,
     /* 1203328 */   // Label 17489: @1203328
     /* 1203328 */   GIM_Try, /*On fail goto*//*Label 17490*/ GIMT_Encode4(1203408), // Rule ID 17082 //
     /* 1203333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1203344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1203347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1203350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1203353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203372 */     // MIs[0] round
     /* 1203372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203382 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1203385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203407 */     // GIR_Coverage, 17082,
     /* 1203407 */     GIR_EraseRootFromParent_Done,
     /* 1203408 */   // Label 17490: @1203408
     /* 1203408 */   GIM_Try, /*On fail goto*//*Label 17491*/ GIMT_Encode4(1203488), // Rule ID 17083 //
     /* 1203413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1203424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1203427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1203430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1203433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203452 */     // MIs[0] round
     /* 1203452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203462 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1203465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203487 */     // GIR_Coverage, 17083,
     /* 1203487 */     GIR_EraseRootFromParent_Done,
     /* 1203488 */   // Label 17491: @1203488
     /* 1203488 */   GIM_Try, /*On fail goto*//*Label 17492*/ GIMT_Encode4(1203568), // Rule ID 17086 //
     /* 1203493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1203504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1203507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1203510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1203513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203532 */     // MIs[0] round
     /* 1203532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203542 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1203545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203567 */     // GIR_Coverage, 17086,
     /* 1203567 */     GIR_EraseRootFromParent_Done,
     /* 1203568 */   // Label 17492: @1203568
     /* 1203568 */   GIM_Try, /*On fail goto*//*Label 17493*/ GIMT_Encode4(1203648), // Rule ID 17087 //
     /* 1203573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1203584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1203587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1203590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1203593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203612 */     // MIs[0] round
     /* 1203612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203622 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1203625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203647 */     // GIR_Coverage, 17087,
     /* 1203647 */     GIR_EraseRootFromParent_Done,
     /* 1203648 */   // Label 17493: @1203648
     /* 1203648 */   GIM_Try, /*On fail goto*//*Label 17494*/ GIMT_Encode4(1203728), // Rule ID 17090 //
     /* 1203653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1203664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1203667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1203670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1203673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203692 */     // MIs[0] round
     /* 1203692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203702 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1203705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203727 */     // GIR_Coverage, 17090,
     /* 1203727 */     GIR_EraseRootFromParent_Done,
     /* 1203728 */   // Label 17494: @1203728
     /* 1203728 */   GIM_Try, /*On fail goto*//*Label 17495*/ GIMT_Encode4(1203808), // Rule ID 17091 //
     /* 1203733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1203744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1203747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1203750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1203753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203772 */     // MIs[0] round
     /* 1203772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203782 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1203785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203807 */     // GIR_Coverage, 17091,
     /* 1203807 */     GIR_EraseRootFromParent_Done,
     /* 1203808 */   // Label 17495: @1203808
     /* 1203808 */   GIM_Try, /*On fail goto*//*Label 17496*/ GIMT_Encode4(1203888), // Rule ID 17094 //
     /* 1203813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1203824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1203827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1203830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1203833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203852 */     // MIs[0] round
     /* 1203852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203862 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1203865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203887 */     // GIR_Coverage, 17094,
     /* 1203887 */     GIR_EraseRootFromParent_Done,
     /* 1203888 */   // Label 17496: @1203888
     /* 1203888 */   GIM_Try, /*On fail goto*//*Label 17497*/ GIMT_Encode4(1203968), // Rule ID 17095 //
     /* 1203893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1203904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1203907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1203910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1203913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203932 */     // MIs[0] round
     /* 1203932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203942 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1203945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203967 */     // GIR_Coverage, 17095,
     /* 1203967 */     GIR_EraseRootFromParent_Done,
     /* 1203968 */   // Label 17497: @1203968
     /* 1203968 */   GIM_Try, /*On fail goto*//*Label 17498*/ GIMT_Encode4(1204048), // Rule ID 17098 //
     /* 1203973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1203984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1203987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1203990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1203993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204012 */     // MIs[0] round
     /* 1204012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204022 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1204025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204047 */     // GIR_Coverage, 17098,
     /* 1204047 */     GIR_EraseRootFromParent_Done,
     /* 1204048 */   // Label 17498: @1204048
     /* 1204048 */   GIM_Try, /*On fail goto*//*Label 17499*/ GIMT_Encode4(1204128), // Rule ID 17099 //
     /* 1204053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1204064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1204067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1204070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1204073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204092 */     // MIs[0] round
     /* 1204092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204102 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1204105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204127 */     // GIR_Coverage, 17099,
     /* 1204127 */     GIR_EraseRootFromParent_Done,
     /* 1204128 */   // Label 17499: @1204128
     /* 1204128 */   GIM_Try, /*On fail goto*//*Label 17500*/ GIMT_Encode4(1204208), // Rule ID 17102 //
     /* 1204133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1204144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1204147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1204150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1204153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204172 */     // MIs[0] round
     /* 1204172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204182 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1204185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204207 */     // GIR_Coverage, 17102,
     /* 1204207 */     GIR_EraseRootFromParent_Done,
     /* 1204208 */   // Label 17500: @1204208
     /* 1204208 */   GIM_Try, /*On fail goto*//*Label 17501*/ GIMT_Encode4(1204288), // Rule ID 17103 //
     /* 1204213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1204224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1204227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1204230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1204233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204252 */     // MIs[0] round
     /* 1204252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204262 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1204265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204287 */     // GIR_Coverage, 17103,
     /* 1204287 */     GIR_EraseRootFromParent_Done,
     /* 1204288 */   // Label 17501: @1204288
     /* 1204288 */   GIM_Try, /*On fail goto*//*Label 17502*/ GIMT_Encode4(1204368), // Rule ID 17106 //
     /* 1204293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1204304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1204307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1204310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1204313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204332 */     // MIs[0] round
     /* 1204332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204342 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1204345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204367 */     // GIR_Coverage, 17106,
     /* 1204367 */     GIR_EraseRootFromParent_Done,
     /* 1204368 */   // Label 17502: @1204368
     /* 1204368 */   GIM_Try, /*On fail goto*//*Label 17503*/ GIMT_Encode4(1204448), // Rule ID 17107 //
     /* 1204373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1204384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1204387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1204390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1204393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204412 */     // MIs[0] round
     /* 1204412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204422 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1204425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204447 */     // GIR_Coverage, 17107,
     /* 1204447 */     GIR_EraseRootFromParent_Done,
     /* 1204448 */   // Label 17503: @1204448
     /* 1204448 */   GIM_Try, /*On fail goto*//*Label 17504*/ GIMT_Encode4(1204528), // Rule ID 17110 //
     /* 1204453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1204464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1204467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1204470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204492 */     // MIs[0] round
     /* 1204492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204502 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1204505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204527 */     // GIR_Coverage, 17110,
     /* 1204527 */     GIR_EraseRootFromParent_Done,
     /* 1204528 */   // Label 17504: @1204528
     /* 1204528 */   GIM_Try, /*On fail goto*//*Label 17505*/ GIMT_Encode4(1204608), // Rule ID 17111 //
     /* 1204533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1204544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1204547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1204550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204572 */     // MIs[0] round
     /* 1204572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204582 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1204585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204607 */     // GIR_Coverage, 17111,
     /* 1204607 */     GIR_EraseRootFromParent_Done,
     /* 1204608 */   // Label 17505: @1204608
     /* 1204608 */   GIM_Try, /*On fail goto*//*Label 17506*/ GIMT_Encode4(1204688), // Rule ID 17114 //
     /* 1204613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1204624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1204627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1204630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204652 */     // MIs[0] round
     /* 1204652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204662 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1204665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204687 */     // GIR_Coverage, 17114,
     /* 1204687 */     GIR_EraseRootFromParent_Done,
     /* 1204688 */   // Label 17506: @1204688
     /* 1204688 */   GIM_Try, /*On fail goto*//*Label 17507*/ GIMT_Encode4(1204768), // Rule ID 17115 //
     /* 1204693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1204704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1204707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1204710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204732 */     // MIs[0] round
     /* 1204732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204742 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1204745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204767 */     // GIR_Coverage, 17115,
     /* 1204767 */     GIR_EraseRootFromParent_Done,
     /* 1204768 */   // Label 17507: @1204768
     /* 1204768 */   GIM_Try, /*On fail goto*//*Label 17508*/ GIMT_Encode4(1204848), // Rule ID 17118 //
     /* 1204773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1204784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1204787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1204790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204812 */     // MIs[0] round
     /* 1204812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204822 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1204825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204847 */     // GIR_Coverage, 17118,
     /* 1204847 */     GIR_EraseRootFromParent_Done,
     /* 1204848 */   // Label 17508: @1204848
     /* 1204848 */   GIM_Try, /*On fail goto*//*Label 17509*/ GIMT_Encode4(1204928), // Rule ID 17119 //
     /* 1204853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1204864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1204867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1204870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204892 */     // MIs[0] round
     /* 1204892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204902 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1204905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204927 */     // GIR_Coverage, 17119,
     /* 1204927 */     GIR_EraseRootFromParent_Done,
     /* 1204928 */   // Label 17509: @1204928
     /* 1204928 */   GIM_Try, /*On fail goto*//*Label 17510*/ GIMT_Encode4(1205008), // Rule ID 17122 //
     /* 1204933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1204944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1204947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1204950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204972 */     // MIs[0] round
     /* 1204972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204982 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1204985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205007 */     // GIR_Coverage, 17122,
     /* 1205007 */     GIR_EraseRootFromParent_Done,
     /* 1205008 */   // Label 17510: @1205008
     /* 1205008 */   GIM_Try, /*On fail goto*//*Label 17511*/ GIMT_Encode4(1205088), // Rule ID 17123 //
     /* 1205013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1205024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1205027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1205030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205052 */     // MIs[0] round
     /* 1205052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205062 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1205065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205087 */     // GIR_Coverage, 17123,
     /* 1205087 */     GIR_EraseRootFromParent_Done,
     /* 1205088 */   // Label 17511: @1205088
     /* 1205088 */   GIM_Try, /*On fail goto*//*Label 17512*/ GIMT_Encode4(1205168), // Rule ID 17126 //
     /* 1205093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1205104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1205107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1205110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205132 */     // MIs[0] round
     /* 1205132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205142 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1205145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205167 */     // GIR_Coverage, 17126,
     /* 1205167 */     GIR_EraseRootFromParent_Done,
     /* 1205168 */   // Label 17512: @1205168
     /* 1205168 */   GIM_Try, /*On fail goto*//*Label 17513*/ GIMT_Encode4(1205248), // Rule ID 17127 //
     /* 1205173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1205184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1205187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1205190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205212 */     // MIs[0] round
     /* 1205212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205222 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1205225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205247 */     // GIR_Coverage, 17127,
     /* 1205247 */     GIR_EraseRootFromParent_Done,
     /* 1205248 */   // Label 17513: @1205248
     /* 1205248 */   GIM_Try, /*On fail goto*//*Label 17514*/ GIMT_Encode4(1205328), // Rule ID 17130 //
     /* 1205253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1205264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1205267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1205270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205292 */     // MIs[0] round
     /* 1205292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205302 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1205305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205327 */     // GIR_Coverage, 17130,
     /* 1205327 */     GIR_EraseRootFromParent_Done,
     /* 1205328 */   // Label 17514: @1205328
     /* 1205328 */   GIM_Try, /*On fail goto*//*Label 17515*/ GIMT_Encode4(1205408), // Rule ID 17131 //
     /* 1205333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1205344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1205347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1205350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205372 */     // MIs[0] round
     /* 1205372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205382 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1205385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205407 */     // GIR_Coverage, 17131,
     /* 1205407 */     GIR_EraseRootFromParent_Done,
     /* 1205408 */   // Label 17515: @1205408
     /* 1205408 */   GIM_Try, /*On fail goto*//*Label 17516*/ GIMT_Encode4(1205488), // Rule ID 17134 //
     /* 1205413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1205424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1205427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205452 */     // MIs[0] round
     /* 1205452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205462 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1205465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205487 */     // GIR_Coverage, 17134,
     /* 1205487 */     GIR_EraseRootFromParent_Done,
     /* 1205488 */   // Label 17516: @1205488
     /* 1205488 */   GIM_Try, /*On fail goto*//*Label 17517*/ GIMT_Encode4(1205568), // Rule ID 17135 //
     /* 1205493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1205504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1205507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205532 */     // MIs[0] round
     /* 1205532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205542 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1205545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205567 */     // GIR_Coverage, 17135,
     /* 1205567 */     GIR_EraseRootFromParent_Done,
     /* 1205568 */   // Label 17517: @1205568
     /* 1205568 */   GIM_Try, /*On fail goto*//*Label 17518*/ GIMT_Encode4(1205648), // Rule ID 17138 //
     /* 1205573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1205584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1205587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1205590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205612 */     // MIs[0] round
     /* 1205612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205622 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1205625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205647 */     // GIR_Coverage, 17138,
     /* 1205647 */     GIR_EraseRootFromParent_Done,
     /* 1205648 */   // Label 17518: @1205648
     /* 1205648 */   GIM_Try, /*On fail goto*//*Label 17519*/ GIMT_Encode4(1205728), // Rule ID 17139 //
     /* 1205653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1205664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1205667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1205670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205692 */     // MIs[0] round
     /* 1205692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205702 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1205705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205727 */     // GIR_Coverage, 17139,
     /* 1205727 */     GIR_EraseRootFromParent_Done,
     /* 1205728 */   // Label 17519: @1205728
     /* 1205728 */   GIM_Try, /*On fail goto*//*Label 17520*/ GIMT_Encode4(1205808), // Rule ID 17142 //
     /* 1205733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1205744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1205747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1205750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205772 */     // MIs[0] round
     /* 1205772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205782 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1205785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205807 */     // GIR_Coverage, 17142,
     /* 1205807 */     GIR_EraseRootFromParent_Done,
     /* 1205808 */   // Label 17520: @1205808
     /* 1205808 */   GIM_Try, /*On fail goto*//*Label 17521*/ GIMT_Encode4(1205888), // Rule ID 17143 //
     /* 1205813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1205824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1205827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1205830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205852 */     // MIs[0] round
     /* 1205852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205862 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1205865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205887 */     // GIR_Coverage, 17143,
     /* 1205887 */     GIR_EraseRootFromParent_Done,
     /* 1205888 */   // Label 17521: @1205888
     /* 1205888 */   GIM_Try, /*On fail goto*//*Label 17522*/ GIMT_Encode4(1205968), // Rule ID 17148 //
     /* 1205893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1205901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1205913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205932 */     // MIs[0] round
     /* 1205932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205942 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1205945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205967 */     // GIR_Coverage, 17148,
     /* 1205967 */     GIR_EraseRootFromParent_Done,
     /* 1205968 */   // Label 17522: @1205968
     /* 1205968 */   GIM_Try, /*On fail goto*//*Label 17523*/ GIMT_Encode4(1206048), // Rule ID 17149 //
     /* 1205973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1205981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1205993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206012 */     // MIs[0] round
     /* 1206012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206022 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1206025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206047 */     // GIR_Coverage, 17149,
     /* 1206047 */     GIR_EraseRootFromParent_Done,
     /* 1206048 */   // Label 17523: @1206048
     /* 1206048 */   GIM_Try, /*On fail goto*//*Label 17524*/ GIMT_Encode4(1206128), // Rule ID 17158 //
     /* 1206053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1206064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1206067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1206073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206092 */     // MIs[0] round
     /* 1206092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206102 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1206105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206127 */     // GIR_Coverage, 17158,
     /* 1206127 */     GIR_EraseRootFromParent_Done,
     /* 1206128 */   // Label 17524: @1206128
     /* 1206128 */   GIM_Try, /*On fail goto*//*Label 17525*/ GIMT_Encode4(1206208), // Rule ID 17159 //
     /* 1206133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1206144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1206147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1206153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206172 */     // MIs[0] round
     /* 1206172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206182 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1206185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206207 */     // GIR_Coverage, 17159,
     /* 1206207 */     GIR_EraseRootFromParent_Done,
     /* 1206208 */   // Label 17525: @1206208
     /* 1206208 */   GIM_Try, /*On fail goto*//*Label 17526*/ GIMT_Encode4(1206288), // Rule ID 17168 //
     /* 1206213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1206224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1206227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1206233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206252 */     // MIs[0] round
     /* 1206252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206262 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1206265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206287 */     // GIR_Coverage, 17168,
     /* 1206287 */     GIR_EraseRootFromParent_Done,
     /* 1206288 */   // Label 17526: @1206288
     /* 1206288 */   GIM_Try, /*On fail goto*//*Label 17527*/ GIMT_Encode4(1206368), // Rule ID 17169 //
     /* 1206293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1206304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1206307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1206313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206332 */     // MIs[0] round
     /* 1206332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206342 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1206345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206367 */     // GIR_Coverage, 17169,
     /* 1206367 */     GIR_EraseRootFromParent_Done,
     /* 1206368 */   // Label 17527: @1206368
     /* 1206368 */   GIM_Try, /*On fail goto*//*Label 17528*/ GIMT_Encode4(1206448), // Rule ID 17178 //
     /* 1206373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1206393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206412 */     // MIs[0] round
     /* 1206412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206422 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1206425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206447 */     // GIR_Coverage, 17178,
     /* 1206447 */     GIR_EraseRootFromParent_Done,
     /* 1206448 */   // Label 17528: @1206448
     /* 1206448 */   GIM_Try, /*On fail goto*//*Label 17529*/ GIMT_Encode4(1206528), // Rule ID 17179 //
     /* 1206453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1206473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206492 */     // MIs[0] round
     /* 1206492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206502 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1206505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206527 */     // GIR_Coverage, 17179,
     /* 1206527 */     GIR_EraseRootFromParent_Done,
     /* 1206528 */   // Label 17529: @1206528
     /* 1206528 */   GIM_Try, /*On fail goto*//*Label 17530*/ GIMT_Encode4(1206608), // Rule ID 17188 //
     /* 1206533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1206544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1206547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1206550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1206553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206572 */     // MIs[0] round
     /* 1206572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206582 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1206585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206607 */     // GIR_Coverage, 17188,
     /* 1206607 */     GIR_EraseRootFromParent_Done,
     /* 1206608 */   // Label 17530: @1206608
     /* 1206608 */   GIM_Try, /*On fail goto*//*Label 17531*/ GIMT_Encode4(1206688), // Rule ID 17189 //
     /* 1206613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1206624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1206627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1206630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1206633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206652 */     // MIs[0] round
     /* 1206652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206662 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1206665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206687 */     // GIR_Coverage, 17189,
     /* 1206687 */     GIR_EraseRootFromParent_Done,
     /* 1206688 */   // Label 17531: @1206688
     /* 1206688 */   GIM_Try, /*On fail goto*//*Label 17532*/ GIMT_Encode4(1206768), // Rule ID 17198 //
     /* 1206693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1206704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1206707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1206710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1206713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206732 */     // MIs[0] round
     /* 1206732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206742 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1206745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206767 */     // GIR_Coverage, 17198,
     /* 1206767 */     GIR_EraseRootFromParent_Done,
     /* 1206768 */   // Label 17532: @1206768
     /* 1206768 */   GIM_Try, /*On fail goto*//*Label 17533*/ GIMT_Encode4(1206848), // Rule ID 17199 //
     /* 1206773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1206784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1206787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1206790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1206793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206812 */     // MIs[0] round
     /* 1206812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206822 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1206825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206847 */     // GIR_Coverage, 17199,
     /* 1206847 */     GIR_EraseRootFromParent_Done,
     /* 1206848 */   // Label 17533: @1206848
     /* 1206848 */   GIM_Try, /*On fail goto*//*Label 17534*/ GIMT_Encode4(1206928), // Rule ID 17208 //
     /* 1206853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1206870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1206873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206892 */     // MIs[0] round
     /* 1206892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206902 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1206905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206927 */     // GIR_Coverage, 17208,
     /* 1206927 */     GIR_EraseRootFromParent_Done,
     /* 1206928 */   // Label 17534: @1206928
     /* 1206928 */   GIM_Try, /*On fail goto*//*Label 17535*/ GIMT_Encode4(1207008), // Rule ID 17209 //
     /* 1206933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1206950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1206953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206972 */     // MIs[0] round
     /* 1206972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206982 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1206985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207007 */     // GIR_Coverage, 17209,
     /* 1207007 */     GIR_EraseRootFromParent_Done,
     /* 1207008 */   // Label 17535: @1207008
     /* 1207008 */   GIM_Try, /*On fail goto*//*Label 17536*/ GIMT_Encode4(1207088), // Rule ID 17218 //
     /* 1207013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1207024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1207027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1207030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1207033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207052 */     // MIs[0] round
     /* 1207052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207062 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1207065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207087 */     // GIR_Coverage, 17218,
     /* 1207087 */     GIR_EraseRootFromParent_Done,
     /* 1207088 */   // Label 17536: @1207088
     /* 1207088 */   GIM_Try, /*On fail goto*//*Label 17537*/ GIMT_Encode4(1207168), // Rule ID 17219 //
     /* 1207093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1207104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1207107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1207110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1207113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207132 */     // MIs[0] round
     /* 1207132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207142 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1207145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207167 */     // GIR_Coverage, 17219,
     /* 1207167 */     GIR_EraseRootFromParent_Done,
     /* 1207168 */   // Label 17537: @1207168
     /* 1207168 */   GIM_Try, /*On fail goto*//*Label 17538*/ GIMT_Encode4(1207248), // Rule ID 17226 //
     /* 1207173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1207184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1207187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1207190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207212 */     // MIs[0] round
     /* 1207212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207222 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1207225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207247 */     // GIR_Coverage, 17226,
     /* 1207247 */     GIR_EraseRootFromParent_Done,
     /* 1207248 */   // Label 17538: @1207248
     /* 1207248 */   GIM_Try, /*On fail goto*//*Label 17539*/ GIMT_Encode4(1207328), // Rule ID 17227 //
     /* 1207253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1207264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1207267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1207270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207292 */     // MIs[0] round
     /* 1207292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207302 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1207305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207327 */     // GIR_Coverage, 17227,
     /* 1207327 */     GIR_EraseRootFromParent_Done,
     /* 1207328 */   // Label 17539: @1207328
     /* 1207328 */   GIM_Try, /*On fail goto*//*Label 17540*/ GIMT_Encode4(1207408), // Rule ID 17230 //
     /* 1207333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207372 */     // MIs[0] round
     /* 1207372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207382 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1207385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207407 */     // GIR_Coverage, 17230,
     /* 1207407 */     GIR_EraseRootFromParent_Done,
     /* 1207408 */   // Label 17540: @1207408
     /* 1207408 */   GIM_Try, /*On fail goto*//*Label 17541*/ GIMT_Encode4(1207488), // Rule ID 17231 //
     /* 1207413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207452 */     // MIs[0] round
     /* 1207452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207462 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1207465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207487 */     // GIR_Coverage, 17231,
     /* 1207487 */     GIR_EraseRootFromParent_Done,
     /* 1207488 */   // Label 17541: @1207488
     /* 1207488 */   GIM_Try, /*On fail goto*//*Label 17542*/ GIMT_Encode4(1207568), // Rule ID 17234 //
     /* 1207493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1207504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1207507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1207510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207532 */     // MIs[0] round
     /* 1207532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207542 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1207545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207567 */     // GIR_Coverage, 17234,
     /* 1207567 */     GIR_EraseRootFromParent_Done,
     /* 1207568 */   // Label 17542: @1207568
     /* 1207568 */   GIM_Try, /*On fail goto*//*Label 17543*/ GIMT_Encode4(1207648), // Rule ID 17235 //
     /* 1207573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1207584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1207587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1207590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207612 */     // MIs[0] round
     /* 1207612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207622 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1207625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207647 */     // GIR_Coverage, 17235,
     /* 1207647 */     GIR_EraseRootFromParent_Done,
     /* 1207648 */   // Label 17543: @1207648
     /* 1207648 */   GIM_Try, /*On fail goto*//*Label 17544*/ GIMT_Encode4(1207728), // Rule ID 17238 //
     /* 1207653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1207664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1207667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1207670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207692 */     // MIs[0] round
     /* 1207692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207702 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1207705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207727 */     // GIR_Coverage, 17238,
     /* 1207727 */     GIR_EraseRootFromParent_Done,
     /* 1207728 */   // Label 17544: @1207728
     /* 1207728 */   GIM_Try, /*On fail goto*//*Label 17545*/ GIMT_Encode4(1207808), // Rule ID 17239 //
     /* 1207733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1207744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1207747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1207750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207772 */     // MIs[0] round
     /* 1207772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207782 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1207785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207807 */     // GIR_Coverage, 17239,
     /* 1207807 */     GIR_EraseRootFromParent_Done,
     /* 1207808 */   // Label 17545: @1207808
     /* 1207808 */   GIM_Try, /*On fail goto*//*Label 17546*/ GIMT_Encode4(1207888), // Rule ID 17242 //
     /* 1207813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1207824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1207827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1207830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207852 */     // MIs[0] round
     /* 1207852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207862 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1207865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207887 */     // GIR_Coverage, 17242,
     /* 1207887 */     GIR_EraseRootFromParent_Done,
     /* 1207888 */   // Label 17546: @1207888
     /* 1207888 */   GIM_Try, /*On fail goto*//*Label 17547*/ GIMT_Encode4(1207968), // Rule ID 17243 //
     /* 1207893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1207904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1207907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1207910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207932 */     // MIs[0] round
     /* 1207932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207942 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1207945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207967 */     // GIR_Coverage, 17243,
     /* 1207967 */     GIR_EraseRootFromParent_Done,
     /* 1207968 */   // Label 17547: @1207968
     /* 1207968 */   GIM_Try, /*On fail goto*//*Label 17548*/ GIMT_Encode4(1208048), // Rule ID 17246 //
     /* 1207973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1207984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1207987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1207990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1207993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208012 */     // MIs[0] round
     /* 1208012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208022 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1208025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208047 */     // GIR_Coverage, 17246,
     /* 1208047 */     GIR_EraseRootFromParent_Done,
     /* 1208048 */   // Label 17548: @1208048
     /* 1208048 */   GIM_Try, /*On fail goto*//*Label 17549*/ GIMT_Encode4(1208128), // Rule ID 17247 //
     /* 1208053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1208064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1208067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1208070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208092 */     // MIs[0] round
     /* 1208092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208102 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1208105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208127 */     // GIR_Coverage, 17247,
     /* 1208127 */     GIR_EraseRootFromParent_Done,
     /* 1208128 */   // Label 17549: @1208128
     /* 1208128 */   GIM_Try, /*On fail goto*//*Label 17550*/ GIMT_Encode4(1208208), // Rule ID 17250 //
     /* 1208133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1208144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1208147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1208150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208172 */     // MIs[0] round
     /* 1208172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208182 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1208185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208207 */     // GIR_Coverage, 17250,
     /* 1208207 */     GIR_EraseRootFromParent_Done,
     /* 1208208 */   // Label 17550: @1208208
     /* 1208208 */   GIM_Try, /*On fail goto*//*Label 17551*/ GIMT_Encode4(1208288), // Rule ID 17251 //
     /* 1208213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1208224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1208227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1208230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208252 */     // MIs[0] round
     /* 1208252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208262 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1208265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208287 */     // GIR_Coverage, 17251,
     /* 1208287 */     GIR_EraseRootFromParent_Done,
     /* 1208288 */   // Label 17551: @1208288
     /* 1208288 */   GIM_Try, /*On fail goto*//*Label 17552*/ GIMT_Encode4(1208368), // Rule ID 17254 //
     /* 1208293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1208304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1208307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1208310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208332 */     // MIs[0] round
     /* 1208332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208342 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1208345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208367 */     // GIR_Coverage, 17254,
     /* 1208367 */     GIR_EraseRootFromParent_Done,
     /* 1208368 */   // Label 17552: @1208368
     /* 1208368 */   GIM_Try, /*On fail goto*//*Label 17553*/ GIMT_Encode4(1208448), // Rule ID 17255 //
     /* 1208373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1208384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1208387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1208390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208412 */     // MIs[0] round
     /* 1208412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208422 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1208425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208447 */     // GIR_Coverage, 17255,
     /* 1208447 */     GIR_EraseRootFromParent_Done,
     /* 1208448 */   // Label 17553: @1208448
     /* 1208448 */   GIM_Try, /*On fail goto*//*Label 17554*/ GIMT_Encode4(1208528), // Rule ID 17258 //
     /* 1208453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1208464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1208467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1208470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208492 */     // MIs[0] round
     /* 1208492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208502 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1208505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208527 */     // GIR_Coverage, 17258,
     /* 1208527 */     GIR_EraseRootFromParent_Done,
     /* 1208528 */   // Label 17554: @1208528
     /* 1208528 */   GIM_Try, /*On fail goto*//*Label 17555*/ GIMT_Encode4(1208608), // Rule ID 17259 //
     /* 1208533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1208544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1208547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1208550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208572 */     // MIs[0] round
     /* 1208572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208582 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1208585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208607 */     // GIR_Coverage, 17259,
     /* 1208607 */     GIR_EraseRootFromParent_Done,
     /* 1208608 */   // Label 17555: @1208608
     /* 1208608 */   GIM_Try, /*On fail goto*//*Label 17556*/ GIMT_Encode4(1208688), // Rule ID 17264 //
     /* 1208613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1208624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1208627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1208630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1208633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208652 */     // MIs[0] round
     /* 1208652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208662 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1208665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208687 */     // GIR_Coverage, 17264,
     /* 1208687 */     GIR_EraseRootFromParent_Done,
     /* 1208688 */   // Label 17556: @1208688
     /* 1208688 */   GIM_Try, /*On fail goto*//*Label 17557*/ GIMT_Encode4(1208768), // Rule ID 17265 //
     /* 1208693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1208704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1208707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1208710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1208713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208732 */     // MIs[0] round
     /* 1208732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208742 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1208745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208767 */     // GIR_Coverage, 17265,
     /* 1208767 */     GIR_EraseRootFromParent_Done,
     /* 1208768 */   // Label 17557: @1208768
     /* 1208768 */   GIM_Try, /*On fail goto*//*Label 17558*/ GIMT_Encode4(1208848), // Rule ID 17274 //
     /* 1208773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1208784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1208787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1208790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1208793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208812 */     // MIs[0] round
     /* 1208812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208822 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1208825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208847 */     // GIR_Coverage, 17274,
     /* 1208847 */     GIR_EraseRootFromParent_Done,
     /* 1208848 */   // Label 17558: @1208848
     /* 1208848 */   GIM_Try, /*On fail goto*//*Label 17559*/ GIMT_Encode4(1208928), // Rule ID 17275 //
     /* 1208853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1208864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1208867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1208870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1208873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208892 */     // MIs[0] round
     /* 1208892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208902 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1208905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208927 */     // GIR_Coverage, 17275,
     /* 1208927 */     GIR_EraseRootFromParent_Done,
     /* 1208928 */   // Label 17559: @1208928
     /* 1208928 */   GIM_Try, /*On fail goto*//*Label 17560*/ GIMT_Encode4(1209008), // Rule ID 17284 //
     /* 1208933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1208944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1208947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1208950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1208953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208972 */     // MIs[0] round
     /* 1208972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208982 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1208985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209007 */     // GIR_Coverage, 17284,
     /* 1209007 */     GIR_EraseRootFromParent_Done,
     /* 1209008 */   // Label 17560: @1209008
     /* 1209008 */   GIM_Try, /*On fail goto*//*Label 17561*/ GIMT_Encode4(1209088), // Rule ID 17285 //
     /* 1209013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1209024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1209027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1209030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1209033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209052 */     // MIs[0] round
     /* 1209052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209062 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1209065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209087 */     // GIR_Coverage, 17285,
     /* 1209087 */     GIR_EraseRootFromParent_Done,
     /* 1209088 */   // Label 17561: @1209088
     /* 1209088 */   GIM_Try, /*On fail goto*//*Label 17562*/ GIMT_Encode4(1209168), // Rule ID 17294 //
     /* 1209093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1209104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1209107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1209110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1209113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209132 */     // MIs[0] round
     /* 1209132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209142 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1209145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209167 */     // GIR_Coverage, 17294,
     /* 1209167 */     GIR_EraseRootFromParent_Done,
     /* 1209168 */   // Label 17562: @1209168
     /* 1209168 */   GIM_Try, /*On fail goto*//*Label 17563*/ GIMT_Encode4(1209248), // Rule ID 17295 //
     /* 1209173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1209184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1209187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1209190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1209193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209212 */     // MIs[0] round
     /* 1209212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209222 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1209225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209247 */     // GIR_Coverage, 17295,
     /* 1209247 */     GIR_EraseRootFromParent_Done,
     /* 1209248 */   // Label 17563: @1209248
     /* 1209248 */   GIM_Try, /*On fail goto*//*Label 17564*/ GIMT_Encode4(1209328), // Rule ID 17304 //
     /* 1209253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1209264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1209267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1209270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1209273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209292 */     // MIs[0] round
     /* 1209292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209302 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1209305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209327 */     // GIR_Coverage, 17304,
     /* 1209327 */     GIR_EraseRootFromParent_Done,
     /* 1209328 */   // Label 17564: @1209328
     /* 1209328 */   GIM_Try, /*On fail goto*//*Label 17565*/ GIMT_Encode4(1209408), // Rule ID 17305 //
     /* 1209333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1209344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1209347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1209350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1209353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209372 */     // MIs[0] round
     /* 1209372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209382 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1209385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209407 */     // GIR_Coverage, 17305,
     /* 1209407 */     GIR_EraseRootFromParent_Done,
     /* 1209408 */   // Label 17565: @1209408
     /* 1209408 */   GIM_Try, /*On fail goto*//*Label 17566*/ GIMT_Encode4(1209488), // Rule ID 17314 //
     /* 1209413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1209424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1209427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1209430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1209433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209452 */     // MIs[0] round
     /* 1209452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209462 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1209465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209487 */     // GIR_Coverage, 17314,
     /* 1209487 */     GIR_EraseRootFromParent_Done,
     /* 1209488 */   // Label 17566: @1209488
     /* 1209488 */   GIM_Try, /*On fail goto*//*Label 17567*/ GIMT_Encode4(1209568), // Rule ID 17315 //
     /* 1209493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1209504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1209507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1209510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1209513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209532 */     // MIs[0] round
     /* 1209532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209542 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1209545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209567 */     // GIR_Coverage, 17315,
     /* 1209567 */     GIR_EraseRootFromParent_Done,
     /* 1209568 */   // Label 17567: @1209568
     /* 1209568 */   GIM_Try, /*On fail goto*//*Label 17568*/ GIMT_Encode4(1209648), // Rule ID 17324 //
     /* 1209573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1209584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1209587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1209590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1209593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209612 */     // MIs[0] round
     /* 1209612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209622 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1209625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209647 */     // GIR_Coverage, 17324,
     /* 1209647 */     GIR_EraseRootFromParent_Done,
     /* 1209648 */   // Label 17568: @1209648
     /* 1209648 */   GIM_Try, /*On fail goto*//*Label 17569*/ GIMT_Encode4(1209728), // Rule ID 17325 //
     /* 1209653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1209664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1209667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1209670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1209673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209692 */     // MIs[0] round
     /* 1209692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209702 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1209705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209727 */     // GIR_Coverage, 17325,
     /* 1209727 */     GIR_EraseRootFromParent_Done,
     /* 1209728 */   // Label 17569: @1209728
     /* 1209728 */   GIM_Try, /*On fail goto*//*Label 17570*/ GIMT_Encode4(1209808), // Rule ID 17334 //
     /* 1209733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1209744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1209747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1209750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1209753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209772 */     // MIs[0] round
     /* 1209772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209782 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1209785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209807 */     // GIR_Coverage, 17334,
     /* 1209807 */     GIR_EraseRootFromParent_Done,
     /* 1209808 */   // Label 17570: @1209808
     /* 1209808 */   GIM_Try, /*On fail goto*//*Label 17571*/ GIMT_Encode4(1209888), // Rule ID 17335 //
     /* 1209813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1209824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1209827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1209830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1209833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209852 */     // MIs[0] round
     /* 1209852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209862 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1209865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209887 */     // GIR_Coverage, 17335,
     /* 1209887 */     GIR_EraseRootFromParent_Done,
     /* 1209888 */   // Label 17571: @1209888
     /* 1209888 */   GIM_Try, /*On fail goto*//*Label 17572*/ GIMT_Encode4(1209968), // Rule ID 17344 //
     /* 1209893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1209904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1209907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1209910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1209913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209932 */     // MIs[0] round
     /* 1209932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209942 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1209945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209967 */     // GIR_Coverage, 17344,
     /* 1209967 */     GIR_EraseRootFromParent_Done,
     /* 1209968 */   // Label 17572: @1209968
     /* 1209968 */   GIM_Try, /*On fail goto*//*Label 17573*/ GIMT_Encode4(1210048), // Rule ID 17345 //
     /* 1209973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1209984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1209987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1209990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1209993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210012 */     // MIs[0] round
     /* 1210012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210022 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1210025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210047 */     // GIR_Coverage, 17345,
     /* 1210047 */     GIR_EraseRootFromParent_Done,
     /* 1210048 */   // Label 17573: @1210048
     /* 1210048 */   GIM_Try, /*On fail goto*//*Label 17574*/ GIMT_Encode4(1210128), // Rule ID 17352 //
     /* 1210053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1210064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1210067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1210070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210092 */     // MIs[0] round
     /* 1210092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210102 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1210105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210127 */     // GIR_Coverage, 17352,
     /* 1210127 */     GIR_EraseRootFromParent_Done,
     /* 1210128 */   // Label 17574: @1210128
     /* 1210128 */   GIM_Try, /*On fail goto*//*Label 17575*/ GIMT_Encode4(1210208), // Rule ID 17353 //
     /* 1210133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1210144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1210147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1210150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210172 */     // MIs[0] round
     /* 1210172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210182 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1210185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210207 */     // GIR_Coverage, 17353,
     /* 1210207 */     GIR_EraseRootFromParent_Done,
     /* 1210208 */   // Label 17575: @1210208
     /* 1210208 */   GIM_Try, /*On fail goto*//*Label 17576*/ GIMT_Encode4(1210288), // Rule ID 17356 //
     /* 1210213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1210224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1210227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1210230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210252 */     // MIs[0] round
     /* 1210252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210262 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1210265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210287 */     // GIR_Coverage, 17356,
     /* 1210287 */     GIR_EraseRootFromParent_Done,
     /* 1210288 */   // Label 17576: @1210288
     /* 1210288 */   GIM_Try, /*On fail goto*//*Label 17577*/ GIMT_Encode4(1210368), // Rule ID 17357 //
     /* 1210293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1210304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1210307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1210310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210332 */     // MIs[0] round
     /* 1210332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210342 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1210345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210367 */     // GIR_Coverage, 17357,
     /* 1210367 */     GIR_EraseRootFromParent_Done,
     /* 1210368 */   // Label 17577: @1210368
     /* 1210368 */   GIM_Try, /*On fail goto*//*Label 17578*/ GIMT_Encode4(1210448), // Rule ID 17360 //
     /* 1210373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1210384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1210387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210412 */     // MIs[0] round
     /* 1210412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210422 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1210425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210447 */     // GIR_Coverage, 17360,
     /* 1210447 */     GIR_EraseRootFromParent_Done,
     /* 1210448 */   // Label 17578: @1210448
     /* 1210448 */   GIM_Try, /*On fail goto*//*Label 17579*/ GIMT_Encode4(1210528), // Rule ID 17361 //
     /* 1210453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1210464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1210467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210492 */     // MIs[0] round
     /* 1210492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210502 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1210505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210527 */     // GIR_Coverage, 17361,
     /* 1210527 */     GIR_EraseRootFromParent_Done,
     /* 1210528 */   // Label 17579: @1210528
     /* 1210528 */   GIM_Try, /*On fail goto*//*Label 17580*/ GIMT_Encode4(1210608), // Rule ID 17364 //
     /* 1210533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1210544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1210547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1210550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210572 */     // MIs[0] round
     /* 1210572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210582 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1210585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210607 */     // GIR_Coverage, 17364,
     /* 1210607 */     GIR_EraseRootFromParent_Done,
     /* 1210608 */   // Label 17580: @1210608
     /* 1210608 */   GIM_Try, /*On fail goto*//*Label 17581*/ GIMT_Encode4(1210688), // Rule ID 17365 //
     /* 1210613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1210624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1210627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1210630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210652 */     // MIs[0] round
     /* 1210652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210662 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1210665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210687 */     // GIR_Coverage, 17365,
     /* 1210687 */     GIR_EraseRootFromParent_Done,
     /* 1210688 */   // Label 17581: @1210688
     /* 1210688 */   GIM_Try, /*On fail goto*//*Label 17582*/ GIMT_Encode4(1210768), // Rule ID 17368 //
     /* 1210693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1210704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1210707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1210710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210732 */     // MIs[0] round
     /* 1210732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210742 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1210745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210767 */     // GIR_Coverage, 17368,
     /* 1210767 */     GIR_EraseRootFromParent_Done,
     /* 1210768 */   // Label 17582: @1210768
     /* 1210768 */   GIM_Try, /*On fail goto*//*Label 17583*/ GIMT_Encode4(1210848), // Rule ID 17369 //
     /* 1210773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1210784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1210787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1210790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210812 */     // MIs[0] round
     /* 1210812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210822 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1210825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210847 */     // GIR_Coverage, 17369,
     /* 1210847 */     GIR_EraseRootFromParent_Done,
     /* 1210848 */   // Label 17583: @1210848
     /* 1210848 */   GIM_Try, /*On fail goto*//*Label 17584*/ GIMT_Encode4(1210928), // Rule ID 17372 //
     /* 1210853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1210864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1210867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1210870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210892 */     // MIs[0] round
     /* 1210892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210902 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1210905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210927 */     // GIR_Coverage, 17372,
     /* 1210927 */     GIR_EraseRootFromParent_Done,
     /* 1210928 */   // Label 17584: @1210928
     /* 1210928 */   GIM_Try, /*On fail goto*//*Label 17585*/ GIMT_Encode4(1211008), // Rule ID 17373 //
     /* 1210933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1210944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1210947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1210950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210972 */     // MIs[0] round
     /* 1210972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210982 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1210985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211007 */     // GIR_Coverage, 17373,
     /* 1211007 */     GIR_EraseRootFromParent_Done,
     /* 1211008 */   // Label 17585: @1211008
     /* 1211008 */   GIM_Try, /*On fail goto*//*Label 17586*/ GIMT_Encode4(1211088), // Rule ID 17376 //
     /* 1211013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1211024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1211027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1211030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211052 */     // MIs[0] round
     /* 1211052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211062 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1211065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211087 */     // GIR_Coverage, 17376,
     /* 1211087 */     GIR_EraseRootFromParent_Done,
     /* 1211088 */   // Label 17586: @1211088
     /* 1211088 */   GIM_Try, /*On fail goto*//*Label 17587*/ GIMT_Encode4(1211168), // Rule ID 17377 //
     /* 1211093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1211104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1211107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1211110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211132 */     // MIs[0] round
     /* 1211132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211142 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1211145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211167 */     // GIR_Coverage, 17377,
     /* 1211167 */     GIR_EraseRootFromParent_Done,
     /* 1211168 */   // Label 17587: @1211168
     /* 1211168 */   GIM_Try, /*On fail goto*//*Label 17588*/ GIMT_Encode4(1211248), // Rule ID 17380 //
     /* 1211173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1211184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1211187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1211190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211212 */     // MIs[0] round
     /* 1211212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211222 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1211225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211247 */     // GIR_Coverage, 17380,
     /* 1211247 */     GIR_EraseRootFromParent_Done,
     /* 1211248 */   // Label 17588: @1211248
     /* 1211248 */   GIM_Try, /*On fail goto*//*Label 17589*/ GIMT_Encode4(1211328), // Rule ID 17381 //
     /* 1211253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1211264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1211267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1211270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211292 */     // MIs[0] round
     /* 1211292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211302 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1211305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211327 */     // GIR_Coverage, 17381,
     /* 1211327 */     GIR_EraseRootFromParent_Done,
     /* 1211328 */   // Label 17589: @1211328
     /* 1211328 */   GIM_Try, /*On fail goto*//*Label 17590*/ GIMT_Encode4(1211408), // Rule ID 17384 //
     /* 1211333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1211344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1211347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1211350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211372 */     // MIs[0] round
     /* 1211372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211382 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1211385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211407 */     // GIR_Coverage, 17384,
     /* 1211407 */     GIR_EraseRootFromParent_Done,
     /* 1211408 */   // Label 17590: @1211408
     /* 1211408 */   GIM_Try, /*On fail goto*//*Label 17591*/ GIMT_Encode4(1211488), // Rule ID 17385 //
     /* 1211413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1211424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1211427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1211430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211452 */     // MIs[0] round
     /* 1211452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211462 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1211465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211487 */     // GIR_Coverage, 17385,
     /* 1211487 */     GIR_EraseRootFromParent_Done,
     /* 1211488 */   // Label 17591: @1211488
     /* 1211488 */   GIM_Try, /*On fail goto*//*Label 17592*/ GIMT_Encode4(1211568), // Rule ID 17388 //
     /* 1211493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1211496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1211504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1211507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1211510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1211513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211532 */     // MIs[0] round
     /* 1211532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211542 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1211545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211567 */     // GIR_Coverage, 17388,
     /* 1211567 */     GIR_EraseRootFromParent_Done,
     /* 1211568 */   // Label 17592: @1211568
     /* 1211568 */   GIM_Try, /*On fail goto*//*Label 17593*/ GIMT_Encode4(1211648), // Rule ID 17389 //
     /* 1211573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1211576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1211584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1211587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1211590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1211593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211612 */     // MIs[0] round
     /* 1211612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211622 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1211625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211647 */     // GIR_Coverage, 17389,
     /* 1211647 */     GIR_EraseRootFromParent_Done,
     /* 1211648 */   // Label 17593: @1211648
     /* 1211648 */   GIM_Try, /*On fail goto*//*Label 17594*/ GIMT_Encode4(1211728), // Rule ID 17392 //
     /* 1211653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1211656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1211664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1211667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1211670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1211673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211692 */     // MIs[0] round
     /* 1211692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211702 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1211705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211727 */     // GIR_Coverage, 17392,
     /* 1211727 */     GIR_EraseRootFromParent_Done,
     /* 1211728 */   // Label 17594: @1211728
     /* 1211728 */   GIM_Try, /*On fail goto*//*Label 17595*/ GIMT_Encode4(1211808), // Rule ID 17393 //
     /* 1211733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1211736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1211744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1211747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1211750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1211753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211772 */     // MIs[0] round
     /* 1211772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211782 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1211785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211807 */     // GIR_Coverage, 17393,
     /* 1211807 */     GIR_EraseRootFromParent_Done,
     /* 1211808 */   // Label 17595: @1211808
     /* 1211808 */   GIM_Try, /*On fail goto*//*Label 17596*/ GIMT_Encode4(1211888), // Rule ID 17396 //
     /* 1211813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1211816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1211824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1211827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1211830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1211833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211852 */     // MIs[0] round
     /* 1211852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211862 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1211865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211887 */     // GIR_Coverage, 17396,
     /* 1211887 */     GIR_EraseRootFromParent_Done,
     /* 1211888 */   // Label 17596: @1211888
     /* 1211888 */   GIM_Try, /*On fail goto*//*Label 17597*/ GIMT_Encode4(1211968), // Rule ID 17397 //
     /* 1211893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1211896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1211904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1211907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1211910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1211913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211932 */     // MIs[0] round
     /* 1211932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211942 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1211945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211967 */     // GIR_Coverage, 17397,
     /* 1211967 */     GIR_EraseRootFromParent_Done,
     /* 1211968 */   // Label 17597: @1211968
     /* 1211968 */   GIM_Try, /*On fail goto*//*Label 17598*/ GIMT_Encode4(1212048), // Rule ID 17400 //
     /* 1211973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1211976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1211984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1211987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1211990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1211993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212012 */     // MIs[0] round
     /* 1212012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212022 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1212025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212047 */     // GIR_Coverage, 17400,
     /* 1212047 */     GIR_EraseRootFromParent_Done,
     /* 1212048 */   // Label 17598: @1212048
     /* 1212048 */   GIM_Try, /*On fail goto*//*Label 17599*/ GIMT_Encode4(1212128), // Rule ID 17401 //
     /* 1212053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1212064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1212067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1212070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1212073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212092 */     // MIs[0] round
     /* 1212092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1212105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212127 */     // GIR_Coverage, 17401,
     /* 1212127 */     GIR_EraseRootFromParent_Done,
     /* 1212128 */   // Label 17599: @1212128
     /* 1212128 */   GIM_Try, /*On fail goto*//*Label 17600*/ GIMT_Encode4(1212208), // Rule ID 17404 //
     /* 1212133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1212136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1212144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1212147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1212153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212172 */     // MIs[0] round
     /* 1212172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212182 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1212185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212207 */     // GIR_Coverage, 17404,
     /* 1212207 */     GIR_EraseRootFromParent_Done,
     /* 1212208 */   // Label 17600: @1212208
     /* 1212208 */   GIM_Try, /*On fail goto*//*Label 17601*/ GIMT_Encode4(1212288), // Rule ID 17405 //
     /* 1212213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1212216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1212224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1212227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1212233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212252 */     // MIs[0] round
     /* 1212252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212262 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1212265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212287 */     // GIR_Coverage, 17405,
     /* 1212287 */     GIR_EraseRootFromParent_Done,
     /* 1212288 */   // Label 17601: @1212288
     /* 1212288 */   GIM_Try, /*On fail goto*//*Label 17602*/ GIMT_Encode4(1212368), // Rule ID 17408 //
     /* 1212293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1212296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1212304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1212307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1212310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1212313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212332 */     // MIs[0] round
     /* 1212332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212342 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1212345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212367 */     // GIR_Coverage, 17408,
     /* 1212367 */     GIR_EraseRootFromParent_Done,
     /* 1212368 */   // Label 17602: @1212368
     /* 1212368 */   GIM_Try, /*On fail goto*//*Label 17603*/ GIMT_Encode4(1212448), // Rule ID 17409 //
     /* 1212373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1212376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1212384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1212387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1212390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1212393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212412 */     // MIs[0] round
     /* 1212412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212422 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1212425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212447 */     // GIR_Coverage, 17409,
     /* 1212447 */     GIR_EraseRootFromParent_Done,
     /* 1212448 */   // Label 17603: @1212448
     /* 1212448 */   GIM_Try, /*On fail goto*//*Label 17604*/ GIMT_Encode4(1212528), // Rule ID 17412 //
     /* 1212453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1212464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1212467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1212470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1212473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212492 */     // MIs[0] round
     /* 1212492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212502 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1212505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212527 */     // GIR_Coverage, 17412,
     /* 1212527 */     GIR_EraseRootFromParent_Done,
     /* 1212528 */   // Label 17604: @1212528
     /* 1212528 */   GIM_Try, /*On fail goto*//*Label 17605*/ GIMT_Encode4(1212608), // Rule ID 17413 //
     /* 1212533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1212544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1212547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1212550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1212553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212572 */     // MIs[0] round
     /* 1212572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212582 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1212585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212607 */     // GIR_Coverage, 17413,
     /* 1212607 */     GIR_EraseRootFromParent_Done,
     /* 1212608 */   // Label 17605: @1212608
     /* 1212608 */   GIM_Try, /*On fail goto*//*Label 17606*/ GIMT_Encode4(1212688), // Rule ID 17416 //
     /* 1212613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1212624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1212627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1212630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1212633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212652 */     // MIs[0] round
     /* 1212652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212662 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1212665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212687 */     // GIR_Coverage, 17416,
     /* 1212687 */     GIR_EraseRootFromParent_Done,
     /* 1212688 */   // Label 17606: @1212688
     /* 1212688 */   GIM_Try, /*On fail goto*//*Label 17607*/ GIMT_Encode4(1212768), // Rule ID 17417 //
     /* 1212693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1212704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1212707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1212710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1212713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212732 */     // MIs[0] round
     /* 1212732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212742 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1212745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212767 */     // GIR_Coverage, 17417,
     /* 1212767 */     GIR_EraseRootFromParent_Done,
     /* 1212768 */   // Label 17607: @1212768
     /* 1212768 */   GIM_Try, /*On fail goto*//*Label 17608*/ GIMT_Encode4(1212848), // Rule ID 17420 //
     /* 1212773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1212784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1212787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1212790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1212793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212812 */     // MIs[0] round
     /* 1212812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212822 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1212825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212847 */     // GIR_Coverage, 17420,
     /* 1212847 */     GIR_EraseRootFromParent_Done,
     /* 1212848 */   // Label 17608: @1212848
     /* 1212848 */   GIM_Try, /*On fail goto*//*Label 17609*/ GIMT_Encode4(1212928), // Rule ID 17421 //
     /* 1212853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1212864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1212867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1212870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1212873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212892 */     // MIs[0] round
     /* 1212892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212902 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1212905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212927 */     // GIR_Coverage, 17421,
     /* 1212927 */     GIR_EraseRootFromParent_Done,
     /* 1212928 */   // Label 17609: @1212928
     /* 1212928 */   GIM_Try, /*On fail goto*//*Label 17610*/ GIMT_Encode4(1213008), // Rule ID 17424 //
     /* 1212933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1212936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1212944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1212947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1212950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1212953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212972 */     // MIs[0] round
     /* 1212972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212982 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1212985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213007 */     // GIR_Coverage, 17424,
     /* 1213007 */     GIR_EraseRootFromParent_Done,
     /* 1213008 */   // Label 17610: @1213008
     /* 1213008 */   GIM_Try, /*On fail goto*//*Label 17611*/ GIMT_Encode4(1213088), // Rule ID 17425 //
     /* 1213013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1213024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1213027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1213030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1213033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213052 */     // MIs[0] round
     /* 1213052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213062 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1213065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213087 */     // GIR_Coverage, 17425,
     /* 1213087 */     GIR_EraseRootFromParent_Done,
     /* 1213088 */   // Label 17611: @1213088
     /* 1213088 */   GIM_Try, /*On fail goto*//*Label 17612*/ GIMT_Encode4(1213168), // Rule ID 17428 //
     /* 1213093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1213104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1213107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1213110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1213113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213132 */     // MIs[0] round
     /* 1213132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213142 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1213145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213167 */     // GIR_Coverage, 17428,
     /* 1213167 */     GIR_EraseRootFromParent_Done,
     /* 1213168 */   // Label 17612: @1213168
     /* 1213168 */   GIM_Try, /*On fail goto*//*Label 17613*/ GIMT_Encode4(1213248), // Rule ID 17429 //
     /* 1213173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1213184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1213187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1213190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1213193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213212 */     // MIs[0] round
     /* 1213212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213222 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1213225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213247 */     // GIR_Coverage, 17429,
     /* 1213247 */     GIR_EraseRootFromParent_Done,
     /* 1213248 */   // Label 17613: @1213248
     /* 1213248 */   GIM_Try, /*On fail goto*//*Label 17614*/ GIMT_Encode4(1213328), // Rule ID 17432 //
     /* 1213253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1213264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1213267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1213270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1213273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213292 */     // MIs[0] round
     /* 1213292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213302 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1213305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213327 */     // GIR_Coverage, 17432,
     /* 1213327 */     GIR_EraseRootFromParent_Done,
     /* 1213328 */   // Label 17614: @1213328
     /* 1213328 */   GIM_Try, /*On fail goto*//*Label 17615*/ GIMT_Encode4(1213408), // Rule ID 17433 //
     /* 1213333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1213344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1213347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1213350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1213353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213372 */     // MIs[0] round
     /* 1213372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213382 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1213385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213407 */     // GIR_Coverage, 17433,
     /* 1213407 */     GIR_EraseRootFromParent_Done,
     /* 1213408 */   // Label 17615: @1213408
     /* 1213408 */   GIM_Try, /*On fail goto*//*Label 17616*/ GIMT_Encode4(1213488), // Rule ID 17436 //
     /* 1213413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1213433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213452 */     // MIs[0] round
     /* 1213452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213462 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1213465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213487 */     // GIR_Coverage, 17436,
     /* 1213487 */     GIR_EraseRootFromParent_Done,
     /* 1213488 */   // Label 17616: @1213488
     /* 1213488 */   GIM_Try, /*On fail goto*//*Label 17617*/ GIMT_Encode4(1213568), // Rule ID 17437 //
     /* 1213493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1213513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213532 */     // MIs[0] round
     /* 1213532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213542 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1213545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213567 */     // GIR_Coverage, 17437,
     /* 1213567 */     GIR_EraseRootFromParent_Done,
     /* 1213568 */   // Label 17617: @1213568
     /* 1213568 */   GIM_Try, /*On fail goto*//*Label 17618*/ GIMT_Encode4(1213648), // Rule ID 17440 //
     /* 1213573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1213584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1213587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1213590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1213593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213612 */     // MIs[0] round
     /* 1213612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213622 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1213625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213647 */     // GIR_Coverage, 17440,
     /* 1213647 */     GIR_EraseRootFromParent_Done,
     /* 1213648 */   // Label 17618: @1213648
     /* 1213648 */   GIM_Try, /*On fail goto*//*Label 17619*/ GIMT_Encode4(1213728), // Rule ID 17441 //
     /* 1213653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1213664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1213667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1213670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1213673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213692 */     // MIs[0] round
     /* 1213692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213702 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1213705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213727 */     // GIR_Coverage, 17441,
     /* 1213727 */     GIR_EraseRootFromParent_Done,
     /* 1213728 */   // Label 17619: @1213728
     /* 1213728 */   GIM_Try, /*On fail goto*//*Label 17620*/ GIMT_Encode4(1213808), // Rule ID 17444 //
     /* 1213733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1213744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1213747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1213750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1213753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213772 */     // MIs[0] round
     /* 1213772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213782 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1213785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213807 */     // GIR_Coverage, 17444,
     /* 1213807 */     GIR_EraseRootFromParent_Done,
     /* 1213808 */   // Label 17620: @1213808
     /* 1213808 */   GIM_Try, /*On fail goto*//*Label 17621*/ GIMT_Encode4(1213888), // Rule ID 17445 //
     /* 1213813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1213824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1213827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1213830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1213833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213852 */     // MIs[0] round
     /* 1213852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213862 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1213865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213887 */     // GIR_Coverage, 17445,
     /* 1213887 */     GIR_EraseRootFromParent_Done,
     /* 1213888 */   // Label 17621: @1213888
     /* 1213888 */   GIM_Try, /*On fail goto*//*Label 17622*/ GIMT_Encode4(1213968), // Rule ID 17448 //
     /* 1213893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1213896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1213904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1213907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1213910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1213913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1213932 */     // MIs[0] round
     /* 1213932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213942 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1213945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213967 */     // GIR_Coverage, 17448,
     /* 1213967 */     GIR_EraseRootFromParent_Done,
     /* 1213968 */   // Label 17622: @1213968
     /* 1213968 */   GIM_Try, /*On fail goto*//*Label 17623*/ GIMT_Encode4(1214048), // Rule ID 17449 //
     /* 1213973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1213976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1213984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1213987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1213990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1213993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214012 */     // MIs[0] round
     /* 1214012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214022 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1214025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214047 */     // GIR_Coverage, 17449,
     /* 1214047 */     GIR_EraseRootFromParent_Done,
     /* 1214048 */   // Label 17623: @1214048
     /* 1214048 */   GIM_Try, /*On fail goto*//*Label 17624*/ GIMT_Encode4(1214128), // Rule ID 17452 //
     /* 1214053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1214064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1214067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1214070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214092 */     // MIs[0] round
     /* 1214092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214102 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1214105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214127 */     // GIR_Coverage, 17452,
     /* 1214127 */     GIR_EraseRootFromParent_Done,
     /* 1214128 */   // Label 17624: @1214128
     /* 1214128 */   GIM_Try, /*On fail goto*//*Label 17625*/ GIMT_Encode4(1214208), // Rule ID 17453 //
     /* 1214133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1214144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1214147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1214150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214172 */     // MIs[0] round
     /* 1214172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214182 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1214185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214207 */     // GIR_Coverage, 17453,
     /* 1214207 */     GIR_EraseRootFromParent_Done,
     /* 1214208 */   // Label 17625: @1214208
     /* 1214208 */   GIM_Try, /*On fail goto*//*Label 17626*/ GIMT_Encode4(1214288), // Rule ID 17456 //
     /* 1214213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1214216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1214224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1214227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1214230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214252 */     // MIs[0] round
     /* 1214252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214262 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1214265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214287 */     // GIR_Coverage, 17456,
     /* 1214287 */     GIR_EraseRootFromParent_Done,
     /* 1214288 */   // Label 17626: @1214288
     /* 1214288 */   GIM_Try, /*On fail goto*//*Label 17627*/ GIMT_Encode4(1214368), // Rule ID 17457 //
     /* 1214293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1214296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1214304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1214307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1214310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214332 */     // MIs[0] round
     /* 1214332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214342 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1214345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214367 */     // GIR_Coverage, 17457,
     /* 1214367 */     GIR_EraseRootFromParent_Done,
     /* 1214368 */   // Label 17627: @1214368
     /* 1214368 */   GIM_Try, /*On fail goto*//*Label 17628*/ GIMT_Encode4(1214448), // Rule ID 17460 //
     /* 1214373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1214384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1214387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1214390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214412 */     // MIs[0] round
     /* 1214412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214422 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1214425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214447 */     // GIR_Coverage, 17460,
     /* 1214447 */     GIR_EraseRootFromParent_Done,
     /* 1214448 */   // Label 17628: @1214448
     /* 1214448 */   GIM_Try, /*On fail goto*//*Label 17629*/ GIMT_Encode4(1214528), // Rule ID 17461 //
     /* 1214453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1214464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1214467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1214470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214492 */     // MIs[0] round
     /* 1214492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214502 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1214505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214527 */     // GIR_Coverage, 17461,
     /* 1214527 */     GIR_EraseRootFromParent_Done,
     /* 1214528 */   // Label 17629: @1214528
     /* 1214528 */   GIM_Try, /*On fail goto*//*Label 17630*/ GIMT_Encode4(1214608), // Rule ID 17464 //
     /* 1214533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1214536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1214544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1214547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1214550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214572 */     // MIs[0] round
     /* 1214572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214582 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1214585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214607 */     // GIR_Coverage, 17464,
     /* 1214607 */     GIR_EraseRootFromParent_Done,
     /* 1214608 */   // Label 17630: @1214608
     /* 1214608 */   GIM_Try, /*On fail goto*//*Label 17631*/ GIMT_Encode4(1214688), // Rule ID 17465 //
     /* 1214613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1214616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1214624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1214627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1214630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214652 */     // MIs[0] round
     /* 1214652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214662 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1214665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214687 */     // GIR_Coverage, 17465,
     /* 1214687 */     GIR_EraseRootFromParent_Done,
     /* 1214688 */   // Label 17631: @1214688
     /* 1214688 */   GIM_Try, /*On fail goto*//*Label 17632*/ GIMT_Encode4(1214768), // Rule ID 17468 //
     /* 1214693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1214696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1214704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1214707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1214710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1214713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1214732 */     // MIs[0] round
     /* 1214732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214742 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1214745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214767 */     // GIR_Coverage, 17468,
     /* 1214767 */     GIR_EraseRootFromParent_Done,
     /* 1214768 */   // Label 17632: @1214768
     /* 1214768 */   GIM_Try, /*On fail goto*//*Label 17633*/ GIMT_Encode4(1214848), // Rule ID 17469 //
     /* 1214773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1214776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1214784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1214787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1214790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1214793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1214812 */     // MIs[0] round
     /* 1214812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214822 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1214825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214847 */     // GIR_Coverage, 17469,
     /* 1214847 */     GIR_EraseRootFromParent_Done,
     /* 1214848 */   // Label 17633: @1214848
     /* 1214848 */   GIM_Try, /*On fail goto*//*Label 17634*/ GIMT_Encode4(1214928), // Rule ID 17472 //
     /* 1214853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1214864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1214867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1214870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214892 */     // MIs[0] round
     /* 1214892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214902 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1214905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214927 */     // GIR_Coverage, 17472,
     /* 1214927 */     GIR_EraseRootFromParent_Done,
     /* 1214928 */   // Label 17634: @1214928
     /* 1214928 */   GIM_Try, /*On fail goto*//*Label 17635*/ GIMT_Encode4(1215008), // Rule ID 17473 //
     /* 1214933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1214944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1214947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1214950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214972 */     // MIs[0] round
     /* 1214972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214982 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1214985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215007 */     // GIR_Coverage, 17473,
     /* 1215007 */     GIR_EraseRootFromParent_Done,
     /* 1215008 */   // Label 17635: @1215008
     /* 1215008 */   GIM_Try, /*On fail goto*//*Label 17636*/ GIMT_Encode4(1215088), // Rule ID 17476 //
     /* 1215013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1215024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1215027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1215030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215052 */     // MIs[0] round
     /* 1215052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215062 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1215065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215087 */     // GIR_Coverage, 17476,
     /* 1215087 */     GIR_EraseRootFromParent_Done,
     /* 1215088 */   // Label 17636: @1215088
     /* 1215088 */   GIM_Try, /*On fail goto*//*Label 17637*/ GIMT_Encode4(1215168), // Rule ID 17477 //
     /* 1215093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1215104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1215107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1215110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215132 */     // MIs[0] round
     /* 1215132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215142 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1215145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215167 */     // GIR_Coverage, 17477,
     /* 1215167 */     GIR_EraseRootFromParent_Done,
     /* 1215168 */   // Label 17637: @1215168
     /* 1215168 */   GIM_Try, /*On fail goto*//*Label 17638*/ GIMT_Encode4(1215248), // Rule ID 17480 //
     /* 1215173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1215184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1215187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1215190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215212 */     // MIs[0] round
     /* 1215212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215222 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1215225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215247 */     // GIR_Coverage, 17480,
     /* 1215247 */     GIR_EraseRootFromParent_Done,
     /* 1215248 */   // Label 17638: @1215248
     /* 1215248 */   GIM_Try, /*On fail goto*//*Label 17639*/ GIMT_Encode4(1215328), // Rule ID 17481 //
     /* 1215253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1215264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1215267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1215270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215292 */     // MIs[0] round
     /* 1215292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215302 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1215305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215327 */     // GIR_Coverage, 17481,
     /* 1215327 */     GIR_EraseRootFromParent_Done,
     /* 1215328 */   // Label 17639: @1215328
     /* 1215328 */   GIM_Try, /*On fail goto*//*Label 17640*/ GIMT_Encode4(1215408), // Rule ID 17484 //
     /* 1215333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1215344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1215347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1215350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215372 */     // MIs[0] round
     /* 1215372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215382 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1215385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215407 */     // GIR_Coverage, 17484,
     /* 1215407 */     GIR_EraseRootFromParent_Done,
     /* 1215408 */   // Label 17640: @1215408
     /* 1215408 */   GIM_Try, /*On fail goto*//*Label 17641*/ GIMT_Encode4(1215488), // Rule ID 17485 //
     /* 1215413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1215424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1215427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1215430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215452 */     // MIs[0] round
     /* 1215452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215462 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1215465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215487 */     // GIR_Coverage, 17485,
     /* 1215487 */     GIR_EraseRootFromParent_Done,
     /* 1215488 */   // Label 17641: @1215488
     /* 1215488 */   GIM_Try, /*On fail goto*//*Label 17642*/ GIMT_Encode4(1215568), // Rule ID 17488 //
     /* 1215493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1215504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1215507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1215510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215532 */     // MIs[0] round
     /* 1215532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215542 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1215545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215567 */     // GIR_Coverage, 17488,
     /* 1215567 */     GIR_EraseRootFromParent_Done,
     /* 1215568 */   // Label 17642: @1215568
     /* 1215568 */   GIM_Try, /*On fail goto*//*Label 17643*/ GIMT_Encode4(1215648), // Rule ID 17489 //
     /* 1215573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1215584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1215587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1215590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215612 */     // MIs[0] round
     /* 1215612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215622 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1215625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215647 */     // GIR_Coverage, 17489,
     /* 1215647 */     GIR_EraseRootFromParent_Done,
     /* 1215648 */   // Label 17643: @1215648
     /* 1215648 */   GIM_Try, /*On fail goto*//*Label 17644*/ GIMT_Encode4(1215728), // Rule ID 17492 //
     /* 1215653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1215664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1215667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1215670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215692 */     // MIs[0] round
     /* 1215692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215702 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1215705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215727 */     // GIR_Coverage, 17492,
     /* 1215727 */     GIR_EraseRootFromParent_Done,
     /* 1215728 */   // Label 17644: @1215728
     /* 1215728 */   GIM_Try, /*On fail goto*//*Label 17645*/ GIMT_Encode4(1215808), // Rule ID 17493 //
     /* 1215733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1215744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1215747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1215750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215772 */     // MIs[0] round
     /* 1215772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215782 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1215785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215807 */     // GIR_Coverage, 17493,
     /* 1215807 */     GIR_EraseRootFromParent_Done,
     /* 1215808 */   // Label 17645: @1215808
     /* 1215808 */   GIM_Try, /*On fail goto*//*Label 17646*/ GIMT_Encode4(1215888), // Rule ID 17496 //
     /* 1215813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1215816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1215824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1215827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1215830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215852 */     // MIs[0] round
     /* 1215852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215862 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1215865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215887 */     // GIR_Coverage, 17496,
     /* 1215887 */     GIR_EraseRootFromParent_Done,
     /* 1215888 */   // Label 17646: @1215888
     /* 1215888 */   GIM_Try, /*On fail goto*//*Label 17647*/ GIMT_Encode4(1215968), // Rule ID 17497 //
     /* 1215893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1215896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1215904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1215907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1215910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215932 */     // MIs[0] round
     /* 1215932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215942 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1215945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215967 */     // GIR_Coverage, 17497,
     /* 1215967 */     GIR_EraseRootFromParent_Done,
     /* 1215968 */   // Label 17647: @1215968
     /* 1215968 */   GIM_Try, /*On fail goto*//*Label 17648*/ GIMT_Encode4(1216048), // Rule ID 17500 //
     /* 1215973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1215976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1215984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1215987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1215990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216012 */     // MIs[0] round
     /* 1216012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216022 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1216025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216047 */     // GIR_Coverage, 17500,
     /* 1216047 */     GIR_EraseRootFromParent_Done,
     /* 1216048 */   // Label 17648: @1216048
     /* 1216048 */   GIM_Try, /*On fail goto*//*Label 17649*/ GIMT_Encode4(1216128), // Rule ID 17501 //
     /* 1216053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1216064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1216067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1216070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216092 */     // MIs[0] round
     /* 1216092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1216105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216127 */     // GIR_Coverage, 17501,
     /* 1216127 */     GIR_EraseRootFromParent_Done,
     /* 1216128 */   // Label 17649: @1216128
     /* 1216128 */   GIM_Try, /*On fail goto*//*Label 17650*/ GIMT_Encode4(1216208), // Rule ID 17504 //
     /* 1216133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1216136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1216144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1216147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1216150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216172 */     // MIs[0] round
     /* 1216172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216182 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1216185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216207 */     // GIR_Coverage, 17504,
     /* 1216207 */     GIR_EraseRootFromParent_Done,
     /* 1216208 */   // Label 17650: @1216208
     /* 1216208 */   GIM_Try, /*On fail goto*//*Label 17651*/ GIMT_Encode4(1216288), // Rule ID 17505 //
     /* 1216213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1216224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1216227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1216230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216252 */     // MIs[0] round
     /* 1216252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216262 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1216265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216287 */     // GIR_Coverage, 17505,
     /* 1216287 */     GIR_EraseRootFromParent_Done,
     /* 1216288 */   // Label 17651: @1216288
     /* 1216288 */   GIM_Try, /*On fail goto*//*Label 17652*/ GIMT_Encode4(1216368), // Rule ID 17508 //
     /* 1216293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1216304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1216307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1216310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1216313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216332 */     // MIs[0] round
     /* 1216332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216342 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1216345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216367 */     // GIR_Coverage, 17508,
     /* 1216367 */     GIR_EraseRootFromParent_Done,
     /* 1216368 */   // Label 17652: @1216368
     /* 1216368 */   GIM_Try, /*On fail goto*//*Label 17653*/ GIMT_Encode4(1216448), // Rule ID 17509 //
     /* 1216373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1216384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1216387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1216390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1216393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216412 */     // MIs[0] round
     /* 1216412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216422 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1216425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216447 */     // GIR_Coverage, 17509,
     /* 1216447 */     GIR_EraseRootFromParent_Done,
     /* 1216448 */   // Label 17653: @1216448
     /* 1216448 */   GIM_Try, /*On fail goto*//*Label 17654*/ GIMT_Encode4(1216528), // Rule ID 17512 //
     /* 1216453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1216464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1216467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1216470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1216473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216492 */     // MIs[0] round
     /* 1216492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216502 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1216505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216527 */     // GIR_Coverage, 17512,
     /* 1216527 */     GIR_EraseRootFromParent_Done,
     /* 1216528 */   // Label 17654: @1216528
     /* 1216528 */   GIM_Try, /*On fail goto*//*Label 17655*/ GIMT_Encode4(1216608), // Rule ID 17513 //
     /* 1216533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1216544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1216547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1216550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1216553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216572 */     // MIs[0] round
     /* 1216572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216582 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1216585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216607 */     // GIR_Coverage, 17513,
     /* 1216607 */     GIR_EraseRootFromParent_Done,
     /* 1216608 */   // Label 17655: @1216608
     /* 1216608 */   GIM_Try, /*On fail goto*//*Label 17656*/ GIMT_Encode4(1216688), // Rule ID 17516 //
     /* 1216613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1216616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1216624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1216627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1216630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1216633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216652 */     // MIs[0] round
     /* 1216652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216662 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1216665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216687 */     // GIR_Coverage, 17516,
     /* 1216687 */     GIR_EraseRootFromParent_Done,
     /* 1216688 */   // Label 17656: @1216688
     /* 1216688 */   GIM_Try, /*On fail goto*//*Label 17657*/ GIMT_Encode4(1216768), // Rule ID 17517 //
     /* 1216693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1216696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1216704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1216707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1216710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1216713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216732 */     // MIs[0] round
     /* 1216732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216742 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1216745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216767 */     // GIR_Coverage, 17517,
     /* 1216767 */     GIR_EraseRootFromParent_Done,
     /* 1216768 */   // Label 17657: @1216768
     /* 1216768 */   GIM_Try, /*On fail goto*//*Label 17658*/ GIMT_Encode4(1216848), // Rule ID 17520 //
     /* 1216773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1216784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1216787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1216790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1216793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216812 */     // MIs[0] round
     /* 1216812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216822 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1216825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216847 */     // GIR_Coverage, 17520,
     /* 1216847 */     GIR_EraseRootFromParent_Done,
     /* 1216848 */   // Label 17658: @1216848
     /* 1216848 */   GIM_Try, /*On fail goto*//*Label 17659*/ GIMT_Encode4(1216928), // Rule ID 17521 //
     /* 1216853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1216864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1216867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1216870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1216873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216892 */     // MIs[0] round
     /* 1216892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216902 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1216905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216927 */     // GIR_Coverage, 17521,
     /* 1216927 */     GIR_EraseRootFromParent_Done,
     /* 1216928 */   // Label 17659: @1216928
     /* 1216928 */   GIM_Try, /*On fail goto*//*Label 17660*/ GIMT_Encode4(1217008), // Rule ID 17524 //
     /* 1216933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1216936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1216944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1216947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1216950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1216953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216972 */     // MIs[0] round
     /* 1216972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216982 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1216985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217007 */     // GIR_Coverage, 17524,
     /* 1217007 */     GIR_EraseRootFromParent_Done,
     /* 1217008 */   // Label 17660: @1217008
     /* 1217008 */   GIM_Try, /*On fail goto*//*Label 17661*/ GIMT_Encode4(1217088), // Rule ID 17525 //
     /* 1217013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1217024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1217027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1217030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1217033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217052 */     // MIs[0] round
     /* 1217052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217062 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1217065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217087 */     // GIR_Coverage, 17525,
     /* 1217087 */     GIR_EraseRootFromParent_Done,
     /* 1217088 */   // Label 17661: @1217088
     /* 1217088 */   GIM_Try, /*On fail goto*//*Label 17662*/ GIMT_Encode4(1217168), // Rule ID 17528 //
     /* 1217093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1217096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1217104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1217107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1217110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1217113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217132 */     // MIs[0] round
     /* 1217132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217142 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1217145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217167 */     // GIR_Coverage, 17528,
     /* 1217167 */     GIR_EraseRootFromParent_Done,
     /* 1217168 */   // Label 17662: @1217168
     /* 1217168 */   GIM_Try, /*On fail goto*//*Label 17663*/ GIMT_Encode4(1217248), // Rule ID 17529 //
     /* 1217173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1217176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1217184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1217187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1217190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1217193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217212 */     // MIs[0] round
     /* 1217212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217222 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1217225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217247 */     // GIR_Coverage, 17529,
     /* 1217247 */     GIR_EraseRootFromParent_Done,
     /* 1217248 */   // Label 17663: @1217248
     /* 1217248 */   GIM_Try, /*On fail goto*//*Label 17664*/ GIMT_Encode4(1217328), // Rule ID 17532 //
     /* 1217253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1217264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1217267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1217270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1217273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217292 */     // MIs[0] round
     /* 1217292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217302 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1217305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217327 */     // GIR_Coverage, 17532,
     /* 1217327 */     GIR_EraseRootFromParent_Done,
     /* 1217328 */   // Label 17664: @1217328
     /* 1217328 */   GIM_Try, /*On fail goto*//*Label 17665*/ GIMT_Encode4(1217408), // Rule ID 17533 //
     /* 1217333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1217344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1217347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1217350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1217353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217372 */     // MIs[0] round
     /* 1217372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217382 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1217385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217407 */     // GIR_Coverage, 17533,
     /* 1217407 */     GIR_EraseRootFromParent_Done,
     /* 1217408 */   // Label 17665: @1217408
     /* 1217408 */   GIM_Try, /*On fail goto*//*Label 17666*/ GIMT_Encode4(1217488), // Rule ID 17536 //
     /* 1217413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1217424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1217427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1217433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217452 */     // MIs[0] round
     /* 1217452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217462 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1217465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217487 */     // GIR_Coverage, 17536,
     /* 1217487 */     GIR_EraseRootFromParent_Done,
     /* 1217488 */   // Label 17666: @1217488
     /* 1217488 */   GIM_Try, /*On fail goto*//*Label 17667*/ GIMT_Encode4(1217568), // Rule ID 17537 //
     /* 1217493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1217504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1217507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1217513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217532 */     // MIs[0] round
     /* 1217532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217542 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1217545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217567 */     // GIR_Coverage, 17537,
     /* 1217567 */     GIR_EraseRootFromParent_Done,
     /* 1217568 */   // Label 17667: @1217568
     /* 1217568 */   GIM_Try, /*On fail goto*//*Label 17668*/ GIMT_Encode4(1217648), // Rule ID 17540 //
     /* 1217573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1217584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1217587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1217590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1217593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217612 */     // MIs[0] round
     /* 1217612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217622 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1217625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217647 */     // GIR_Coverage, 17540,
     /* 1217647 */     GIR_EraseRootFromParent_Done,
     /* 1217648 */   // Label 17668: @1217648
     /* 1217648 */   GIM_Try, /*On fail goto*//*Label 17669*/ GIMT_Encode4(1217728), // Rule ID 17541 //
     /* 1217653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1217664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1217667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1217670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1217673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217692 */     // MIs[0] round
     /* 1217692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217702 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1217705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217727 */     // GIR_Coverage, 17541,
     /* 1217727 */     GIR_EraseRootFromParent_Done,
     /* 1217728 */   // Label 17669: @1217728
     /* 1217728 */   GIM_Try, /*On fail goto*//*Label 17670*/ GIMT_Encode4(1217808), // Rule ID 17544 //
     /* 1217733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1217744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1217747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1217750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1217753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217772 */     // MIs[0] round
     /* 1217772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217782 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1217785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217807 */     // GIR_Coverage, 17544,
     /* 1217807 */     GIR_EraseRootFromParent_Done,
     /* 1217808 */   // Label 17670: @1217808
     /* 1217808 */   GIM_Try, /*On fail goto*//*Label 17671*/ GIMT_Encode4(1217888), // Rule ID 17545 //
     /* 1217813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1217824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1217827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1217830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1217833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217852 */     // MIs[0] round
     /* 1217852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217862 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1217865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217887 */     // GIR_Coverage, 17545,
     /* 1217887 */     GIR_EraseRootFromParent_Done,
     /* 1217888 */   // Label 17671: @1217888
     /* 1217888 */   GIM_Try, /*On fail goto*//*Label 17672*/ GIMT_Encode4(1217968), // Rule ID 17548 //
     /* 1217893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1217904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1217907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1217910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1217913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217932 */     // MIs[0] round
     /* 1217932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217942 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1217945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217967 */     // GIR_Coverage, 17548,
     /* 1217967 */     GIR_EraseRootFromParent_Done,
     /* 1217968 */   // Label 17672: @1217968
     /* 1217968 */   GIM_Try, /*On fail goto*//*Label 17673*/ GIMT_Encode4(1218048), // Rule ID 17549 //
     /* 1217973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1217984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1217987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1217990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1217993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218012 */     // MIs[0] round
     /* 1218012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218022 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1218025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218047 */     // GIR_Coverage, 17549,
     /* 1218047 */     GIR_EraseRootFromParent_Done,
     /* 1218048 */   // Label 17673: @1218048
     /* 1218048 */   GIM_Try, /*On fail goto*//*Label 17674*/ GIMT_Encode4(1218128), // Rule ID 17552 //
     /* 1218053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1218056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1218064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1218067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1218070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1218073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218092 */     // MIs[0] round
     /* 1218092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218102 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1218105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218127 */     // GIR_Coverage, 17552,
     /* 1218127 */     GIR_EraseRootFromParent_Done,
     /* 1218128 */   // Label 17674: @1218128
     /* 1218128 */   GIM_Try, /*On fail goto*//*Label 17675*/ GIMT_Encode4(1218208), // Rule ID 17553 //
     /* 1218133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1218136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1218144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1218147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1218150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1218153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218172 */     // MIs[0] round
     /* 1218172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218182 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1218185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218207 */     // GIR_Coverage, 17553,
     /* 1218207 */     GIR_EraseRootFromParent_Done,
     /* 1218208 */   // Label 17675: @1218208
     /* 1218208 */   GIM_Try, /*On fail goto*//*Label 17676*/ GIMT_Encode4(1218288), // Rule ID 17556 //
     /* 1218213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1218224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1218227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1218230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1218233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218252 */     // MIs[0] round
     /* 1218252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218262 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1218265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218287 */     // GIR_Coverage, 17556,
     /* 1218287 */     GIR_EraseRootFromParent_Done,
     /* 1218288 */   // Label 17676: @1218288
     /* 1218288 */   GIM_Try, /*On fail goto*//*Label 17677*/ GIMT_Encode4(1218368), // Rule ID 17557 //
     /* 1218293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1218304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1218307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1218310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1218313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218332 */     // MIs[0] round
     /* 1218332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218342 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1218345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218367 */     // GIR_Coverage, 17557,
     /* 1218367 */     GIR_EraseRootFromParent_Done,
     /* 1218368 */   // Label 17677: @1218368
     /* 1218368 */   GIM_Try, /*On fail goto*//*Label 17678*/ GIMT_Encode4(1218448), // Rule ID 17560 //
     /* 1218373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1218384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1218387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1218393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218412 */     // MIs[0] round
     /* 1218412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218422 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1218425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218447 */     // GIR_Coverage, 17560,
     /* 1218447 */     GIR_EraseRootFromParent_Done,
     /* 1218448 */   // Label 17678: @1218448
     /* 1218448 */   GIM_Try, /*On fail goto*//*Label 17679*/ GIMT_Encode4(1218528), // Rule ID 17561 //
     /* 1218453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1218464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1218467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1218473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218492 */     // MIs[0] round
     /* 1218492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218502 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1218505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218527 */     // GIR_Coverage, 17561,
     /* 1218527 */     GIR_EraseRootFromParent_Done,
     /* 1218528 */   // Label 17679: @1218528
     /* 1218528 */   GIM_Try, /*On fail goto*//*Label 17680*/ GIMT_Encode4(1218608), // Rule ID 17564 //
     /* 1218533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1218544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1218547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1218550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1218553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218572 */     // MIs[0] round
     /* 1218572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218582 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1218585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218607 */     // GIR_Coverage, 17564,
     /* 1218607 */     GIR_EraseRootFromParent_Done,
     /* 1218608 */   // Label 17680: @1218608
     /* 1218608 */   GIM_Try, /*On fail goto*//*Label 17681*/ GIMT_Encode4(1218688), // Rule ID 17565 //
     /* 1218613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1218624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1218627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1218630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1218633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218652 */     // MIs[0] round
     /* 1218652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218662 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1218665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218687 */     // GIR_Coverage, 17565,
     /* 1218687 */     GIR_EraseRootFromParent_Done,
     /* 1218688 */   // Label 17681: @1218688
     /* 1218688 */   GIM_Try, /*On fail goto*//*Label 17682*/ GIMT_Encode4(1218768), // Rule ID 17568 //
     /* 1218693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1218696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1218704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1218707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1218710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218732 */     // MIs[0] round
     /* 1218732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218742 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1218745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218767 */     // GIR_Coverage, 17568,
     /* 1218767 */     GIR_EraseRootFromParent_Done,
     /* 1218768 */   // Label 17682: @1218768
     /* 1218768 */   GIM_Try, /*On fail goto*//*Label 17683*/ GIMT_Encode4(1218848), // Rule ID 17569 //
     /* 1218773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1218776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1218784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1218787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1218790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218812 */     // MIs[0] round
     /* 1218812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218822 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1218825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218847 */     // GIR_Coverage, 17569,
     /* 1218847 */     GIR_EraseRootFromParent_Done,
     /* 1218848 */   // Label 17683: @1218848
     /* 1218848 */   GIM_Try, /*On fail goto*//*Label 17684*/ GIMT_Encode4(1218928), // Rule ID 17572 //
     /* 1218853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1218856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1218864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1218867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1218870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218892 */     // MIs[0] round
     /* 1218892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218902 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1218905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218927 */     // GIR_Coverage, 17572,
     /* 1218927 */     GIR_EraseRootFromParent_Done,
     /* 1218928 */   // Label 17684: @1218928
     /* 1218928 */   GIM_Try, /*On fail goto*//*Label 17685*/ GIMT_Encode4(1219008), // Rule ID 17573 //
     /* 1218933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1218936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1218944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1218947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1218950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218972 */     // MIs[0] round
     /* 1218972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218982 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1218985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219007 */     // GIR_Coverage, 17573,
     /* 1219007 */     GIR_EraseRootFromParent_Done,
     /* 1219008 */   // Label 17685: @1219008
     /* 1219008 */   GIM_Try, /*On fail goto*//*Label 17686*/ GIMT_Encode4(1219088), // Rule ID 17576 //
     /* 1219013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1219024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1219027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1219030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219052 */     // MIs[0] round
     /* 1219052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219062 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1219065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219087 */     // GIR_Coverage, 17576,
     /* 1219087 */     GIR_EraseRootFromParent_Done,
     /* 1219088 */   // Label 17686: @1219088
     /* 1219088 */   GIM_Try, /*On fail goto*//*Label 17687*/ GIMT_Encode4(1219168), // Rule ID 17577 //
     /* 1219093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1219096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1219104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1219107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1219110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219132 */     // MIs[0] round
     /* 1219132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219142 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1219145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219167 */     // GIR_Coverage, 17577,
     /* 1219167 */     GIR_EraseRootFromParent_Done,
     /* 1219168 */   // Label 17687: @1219168
     /* 1219168 */   GIM_Try, /*On fail goto*//*Label 17688*/ GIMT_Encode4(1219248), // Rule ID 17580 //
     /* 1219173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1219184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1219187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1219190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219212 */     // MIs[0] round
     /* 1219212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219222 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1219225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219247 */     // GIR_Coverage, 17580,
     /* 1219247 */     GIR_EraseRootFromParent_Done,
     /* 1219248 */   // Label 17688: @1219248
     /* 1219248 */   GIM_Try, /*On fail goto*//*Label 17689*/ GIMT_Encode4(1219328), // Rule ID 17581 //
     /* 1219253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1219264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1219267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1219270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219292 */     // MIs[0] round
     /* 1219292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219302 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1219305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219327 */     // GIR_Coverage, 17581,
     /* 1219327 */     GIR_EraseRootFromParent_Done,
     /* 1219328 */   // Label 17689: @1219328
     /* 1219328 */   GIM_Try, /*On fail goto*//*Label 17690*/ GIMT_Encode4(1219408), // Rule ID 17584 //
     /* 1219333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1219344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1219347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219372 */     // MIs[0] round
     /* 1219372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219382 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1219385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219407 */     // GIR_Coverage, 17584,
     /* 1219407 */     GIR_EraseRootFromParent_Done,
     /* 1219408 */   // Label 17690: @1219408
     /* 1219408 */   GIM_Try, /*On fail goto*//*Label 17691*/ GIMT_Encode4(1219488), // Rule ID 17585 //
     /* 1219413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1219416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1219424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1219427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219452 */     // MIs[0] round
     /* 1219452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219462 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1219465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219487 */     // GIR_Coverage, 17585,
     /* 1219487 */     GIR_EraseRootFromParent_Done,
     /* 1219488 */   // Label 17691: @1219488
     /* 1219488 */   GIM_Try, /*On fail goto*//*Label 17692*/ GIMT_Encode4(1219568), // Rule ID 17588 //
     /* 1219493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1219496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1219504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1219507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1219510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1219513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1219532 */     // MIs[0] round
     /* 1219532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219542 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1219545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219567 */     // GIR_Coverage, 17588,
     /* 1219567 */     GIR_EraseRootFromParent_Done,
     /* 1219568 */   // Label 17692: @1219568
     /* 1219568 */   GIM_Try, /*On fail goto*//*Label 17693*/ GIMT_Encode4(1219648), // Rule ID 17589 //
     /* 1219573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1219576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1219584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1219587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1219590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1219593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1219612 */     // MIs[0] round
     /* 1219612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219622 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1219625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219647 */     // GIR_Coverage, 17589,
     /* 1219647 */     GIR_EraseRootFromParent_Done,
     /* 1219648 */   // Label 17693: @1219648
     /* 1219648 */   GIM_Try, /*On fail goto*//*Label 17694*/ GIMT_Encode4(1219728), // Rule ID 17592 //
     /* 1219653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1219664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1219667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1219670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219692 */     // MIs[0] round
     /* 1219692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219702 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1219705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219727 */     // GIR_Coverage, 17592,
     /* 1219727 */     GIR_EraseRootFromParent_Done,
     /* 1219728 */   // Label 17694: @1219728
     /* 1219728 */   GIM_Try, /*On fail goto*//*Label 17695*/ GIMT_Encode4(1219808), // Rule ID 17593 //
     /* 1219733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1219744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1219747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1219750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219772 */     // MIs[0] round
     /* 1219772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219782 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1219785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219807 */     // GIR_Coverage, 17593,
     /* 1219807 */     GIR_EraseRootFromParent_Done,
     /* 1219808 */   // Label 17695: @1219808
     /* 1219808 */   GIM_Try, /*On fail goto*//*Label 17696*/ GIMT_Encode4(1219888), // Rule ID 17596 //
     /* 1219813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1219824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1219827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1219830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219852 */     // MIs[0] round
     /* 1219852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219862 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1219865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219887 */     // GIR_Coverage, 17596,
     /* 1219887 */     GIR_EraseRootFromParent_Done,
     /* 1219888 */   // Label 17696: @1219888
     /* 1219888 */   GIM_Try, /*On fail goto*//*Label 17697*/ GIMT_Encode4(1219968), // Rule ID 17597 //
     /* 1219893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1219904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1219907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1219910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219932 */     // MIs[0] round
     /* 1219932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219942 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1219945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219967 */     // GIR_Coverage, 17597,
     /* 1219967 */     GIR_EraseRootFromParent_Done,
     /* 1219968 */   // Label 17697: @1219968
     /* 1219968 */   GIM_Try, /*On fail goto*//*Label 17698*/ GIMT_Encode4(1220048), // Rule ID 17600 //
     /* 1219973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1219984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1219987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1219990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220012 */     // MIs[0] round
     /* 1220012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220022 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1220025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220047 */     // GIR_Coverage, 17600,
     /* 1220047 */     GIR_EraseRootFromParent_Done,
     /* 1220048 */   // Label 17698: @1220048
     /* 1220048 */   GIM_Try, /*On fail goto*//*Label 17699*/ GIMT_Encode4(1220128), // Rule ID 17601 //
     /* 1220053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1220056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1220064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1220067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1220070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220092 */     // MIs[0] round
     /* 1220092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220102 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1220105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220127 */     // GIR_Coverage, 17601,
     /* 1220127 */     GIR_EraseRootFromParent_Done,
     /* 1220128 */   // Label 17699: @1220128
     /* 1220128 */   GIM_Try, /*On fail goto*//*Label 17700*/ GIMT_Encode4(1220208), // Rule ID 17604 //
     /* 1220133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1220144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1220147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1220150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220172 */     // MIs[0] round
     /* 1220172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220182 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1220185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220207 */     // GIR_Coverage, 17604,
     /* 1220207 */     GIR_EraseRootFromParent_Done,
     /* 1220208 */   // Label 17700: @1220208
     /* 1220208 */   GIM_Try, /*On fail goto*//*Label 17701*/ GIMT_Encode4(1220288), // Rule ID 17605 //
     /* 1220213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1220224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1220227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1220230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220252 */     // MIs[0] round
     /* 1220252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220262 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1220265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220287 */     // GIR_Coverage, 17605,
     /* 1220287 */     GIR_EraseRootFromParent_Done,
     /* 1220288 */   // Label 17701: @1220288
     /* 1220288 */   GIM_Try, /*On fail goto*//*Label 17702*/ GIMT_Encode4(1220368), // Rule ID 17608 //
     /* 1220293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1220304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1220307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1220310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220332 */     // MIs[0] round
     /* 1220332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220342 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1220345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220367 */     // GIR_Coverage, 17608,
     /* 1220367 */     GIR_EraseRootFromParent_Done,
     /* 1220368 */   // Label 17702: @1220368
     /* 1220368 */   GIM_Try, /*On fail goto*//*Label 17703*/ GIMT_Encode4(1220448), // Rule ID 17609 //
     /* 1220373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1220384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1220387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1220390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220412 */     // MIs[0] round
     /* 1220412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220422 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1220425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220447 */     // GIR_Coverage, 17609,
     /* 1220447 */     GIR_EraseRootFromParent_Done,
     /* 1220448 */   // Label 17703: @1220448
     /* 1220448 */   GIM_Try, /*On fail goto*//*Label 17704*/ GIMT_Encode4(1220528), // Rule ID 17612 //
     /* 1220453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1220464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1220467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1220470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220492 */     // MIs[0] round
     /* 1220492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220502 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1220505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220527 */     // GIR_Coverage, 17612,
     /* 1220527 */     GIR_EraseRootFromParent_Done,
     /* 1220528 */   // Label 17704: @1220528
     /* 1220528 */   GIM_Try, /*On fail goto*//*Label 17705*/ GIMT_Encode4(1220608), // Rule ID 17613 //
     /* 1220533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1220544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1220547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1220550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220572 */     // MIs[0] round
     /* 1220572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220582 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1220585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220607 */     // GIR_Coverage, 17613,
     /* 1220607 */     GIR_EraseRootFromParent_Done,
     /* 1220608 */   // Label 17705: @1220608
     /* 1220608 */   GIM_Try, /*On fail goto*//*Label 17706*/ GIMT_Encode4(1220688), // Rule ID 17616 //
     /* 1220613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1220616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1220624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1220627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1220630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220652 */     // MIs[0] round
     /* 1220652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220662 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1220665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220687 */     // GIR_Coverage, 17616,
     /* 1220687 */     GIR_EraseRootFromParent_Done,
     /* 1220688 */   // Label 17706: @1220688
     /* 1220688 */   GIM_Try, /*On fail goto*//*Label 17707*/ GIMT_Encode4(1220768), // Rule ID 17617 //
     /* 1220693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1220696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1220704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1220707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1220710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220732 */     // MIs[0] round
     /* 1220732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220742 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1220745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220767 */     // GIR_Coverage, 17617,
     /* 1220767 */     GIR_EraseRootFromParent_Done,
     /* 1220768 */   // Label 17707: @1220768
     /* 1220768 */   GIM_Try, /*On fail goto*//*Label 17708*/ GIMT_Encode4(1220848), // Rule ID 17620 //
     /* 1220773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1220776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1220784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1220787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1220790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220812 */     // MIs[0] round
     /* 1220812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220822 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1220825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220847 */     // GIR_Coverage, 17620,
     /* 1220847 */     GIR_EraseRootFromParent_Done,
     /* 1220848 */   // Label 17708: @1220848
     /* 1220848 */   GIM_Try, /*On fail goto*//*Label 17709*/ GIMT_Encode4(1220928), // Rule ID 17621 //
     /* 1220853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1220856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1220864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1220867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1220870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220892 */     // MIs[0] round
     /* 1220892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220902 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1220905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220927 */     // GIR_Coverage, 17621,
     /* 1220927 */     GIR_EraseRootFromParent_Done,
     /* 1220928 */   // Label 17709: @1220928
     /* 1220928 */   GIM_Try, /*On fail goto*//*Label 17710*/ GIMT_Encode4(1221008), // Rule ID 17624 //
     /* 1220933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1220936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1220944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1220947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1220950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220972 */     // MIs[0] round
     /* 1220972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220982 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1220985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221007 */     // GIR_Coverage, 17624,
     /* 1221007 */     GIR_EraseRootFromParent_Done,
     /* 1221008 */   // Label 17710: @1221008
     /* 1221008 */   GIM_Try, /*On fail goto*//*Label 17711*/ GIMT_Encode4(1221088), // Rule ID 17625 //
     /* 1221013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1221016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1221024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1221027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1221030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221052 */     // MIs[0] round
     /* 1221052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221062 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1221065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221087 */     // GIR_Coverage, 17625,
     /* 1221087 */     GIR_EraseRootFromParent_Done,
     /* 1221088 */   // Label 17711: @1221088
     /* 1221088 */   GIM_Try, /*On fail goto*//*Label 17712*/ GIMT_Encode4(1221168), // Rule ID 17628 //
     /* 1221093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1221104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1221107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1221110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221132 */     // MIs[0] round
     /* 1221132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221142 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1221145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221167 */     // GIR_Coverage, 17628,
     /* 1221167 */     GIR_EraseRootFromParent_Done,
     /* 1221168 */   // Label 17712: @1221168
     /* 1221168 */   GIM_Try, /*On fail goto*//*Label 17713*/ GIMT_Encode4(1221248), // Rule ID 17629 //
     /* 1221173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1221184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1221187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1221190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221212 */     // MIs[0] round
     /* 1221212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221222 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1221225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221247 */     // GIR_Coverage, 17629,
     /* 1221247 */     GIR_EraseRootFromParent_Done,
     /* 1221248 */   // Label 17713: @1221248
     /* 1221248 */   GIM_Try, /*On fail goto*//*Label 17714*/ GIMT_Encode4(1221328), // Rule ID 17632 //
     /* 1221253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1221264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1221267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1221270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221292 */     // MIs[0] round
     /* 1221292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221302 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1221305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221327 */     // GIR_Coverage, 17632,
     /* 1221327 */     GIR_EraseRootFromParent_Done,
     /* 1221328 */   // Label 17714: @1221328
     /* 1221328 */   GIM_Try, /*On fail goto*//*Label 17715*/ GIMT_Encode4(1221408), // Rule ID 17633 //
     /* 1221333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1221344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1221347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1221350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221372 */     // MIs[0] round
     /* 1221372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221382 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1221385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221407 */     // GIR_Coverage, 17633,
     /* 1221407 */     GIR_EraseRootFromParent_Done,
     /* 1221408 */   // Label 17715: @1221408
     /* 1221408 */   GIM_Try, /*On fail goto*//*Label 17716*/ GIMT_Encode4(1221488), // Rule ID 17636 //
     /* 1221413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1221416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1221424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1221427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221452 */     // MIs[0] round
     /* 1221452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221462 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1221465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221487 */     // GIR_Coverage, 17636,
     /* 1221487 */     GIR_EraseRootFromParent_Done,
     /* 1221488 */   // Label 17716: @1221488
     /* 1221488 */   GIM_Try, /*On fail goto*//*Label 17717*/ GIMT_Encode4(1221568), // Rule ID 17637 //
     /* 1221493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1221496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1221504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1221507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221532 */     // MIs[0] round
     /* 1221532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221542 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1221545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221567 */     // GIR_Coverage, 17637,
     /* 1221567 */     GIR_EraseRootFromParent_Done,
     /* 1221568 */   // Label 17717: @1221568
     /* 1221568 */   GIM_Try, /*On fail goto*//*Label 17718*/ GIMT_Encode4(1221648), // Rule ID 17640 //
     /* 1221573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1221584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1221587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1221590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221612 */     // MIs[0] round
     /* 1221612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221622 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1221625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221647 */     // GIR_Coverage, 17640,
     /* 1221647 */     GIR_EraseRootFromParent_Done,
     /* 1221648 */   // Label 17718: @1221648
     /* 1221648 */   GIM_Try, /*On fail goto*//*Label 17719*/ GIMT_Encode4(1221728), // Rule ID 17641 //
     /* 1221653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1221664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1221667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1221670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221692 */     // MIs[0] round
     /* 1221692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221702 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1221705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221727 */     // GIR_Coverage, 17641,
     /* 1221727 */     GIR_EraseRootFromParent_Done,
     /* 1221728 */   // Label 17719: @1221728
     /* 1221728 */   GIM_Try, /*On fail goto*//*Label 17720*/ GIMT_Encode4(1221808), // Rule ID 17644 //
     /* 1221733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1221736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1221744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1221747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1221750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221772 */     // MIs[0] round
     /* 1221772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221782 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1221785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221807 */     // GIR_Coverage, 17644,
     /* 1221807 */     GIR_EraseRootFromParent_Done,
     /* 1221808 */   // Label 17720: @1221808
     /* 1221808 */   GIM_Try, /*On fail goto*//*Label 17721*/ GIMT_Encode4(1221888), // Rule ID 17645 //
     /* 1221813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1221816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1221824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1221827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1221830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221852 */     // MIs[0] round
     /* 1221852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221862 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1221865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221887 */     // GIR_Coverage, 17645,
     /* 1221887 */     GIR_EraseRootFromParent_Done,
     /* 1221888 */   // Label 17721: @1221888
     /* 1221888 */   GIM_Try, /*On fail goto*//*Label 17722*/ GIMT_Encode4(1221968), // Rule ID 17648 //
     /* 1221893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1221896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1221904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1221907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1221910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221932 */     // MIs[0] round
     /* 1221932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221942 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1221945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221967 */     // GIR_Coverage, 17648,
     /* 1221967 */     GIR_EraseRootFromParent_Done,
     /* 1221968 */   // Label 17722: @1221968
     /* 1221968 */   GIM_Try, /*On fail goto*//*Label 17723*/ GIMT_Encode4(1222048), // Rule ID 17649 //
     /* 1221973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1221976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1221984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1221987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1221990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1222012 */     // MIs[0] round
     /* 1222012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222022 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1222025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222047 */     // GIR_Coverage, 17649,
     /* 1222047 */     GIR_EraseRootFromParent_Done,
     /* 1222048 */   // Label 17723: @1222048
     /* 1222048 */   GIM_Try, /*On fail goto*//*Label 17724*/ GIMT_Encode4(1222128), // Rule ID 17652 //
     /* 1222053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1222064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1222067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1222070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222092 */     // MIs[0] round
     /* 1222092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222102 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1222105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222127 */     // GIR_Coverage, 17652,
     /* 1222127 */     GIR_EraseRootFromParent_Done,
     /* 1222128 */   // Label 17724: @1222128
     /* 1222128 */   GIM_Try, /*On fail goto*//*Label 17725*/ GIMT_Encode4(1222208), // Rule ID 17653 //
     /* 1222133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1222144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1222147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1222150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222172 */     // MIs[0] round
     /* 1222172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222182 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1222185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222207 */     // GIR_Coverage, 17653,
     /* 1222207 */     GIR_EraseRootFromParent_Done,
     /* 1222208 */   // Label 17725: @1222208
     /* 1222208 */   GIM_Try, /*On fail goto*//*Label 17726*/ GIMT_Encode4(1222288), // Rule ID 17656 //
     /* 1222213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1222224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1222227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1222230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222252 */     // MIs[0] round
     /* 1222252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222262 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1222265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222287 */     // GIR_Coverage, 17656,
     /* 1222287 */     GIR_EraseRootFromParent_Done,
     /* 1222288 */   // Label 17726: @1222288
     /* 1222288 */   GIM_Try, /*On fail goto*//*Label 17727*/ GIMT_Encode4(1222368), // Rule ID 17657 //
     /* 1222293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1222304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1222307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1222310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222332 */     // MIs[0] round
     /* 1222332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222342 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1222345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222367 */     // GIR_Coverage, 17657,
     /* 1222367 */     GIR_EraseRootFromParent_Done,
     /* 1222368 */   // Label 17727: @1222368
     /* 1222368 */   GIM_Try, /*On fail goto*//*Label 17728*/ GIMT_Encode4(1222448), // Rule ID 17660 //
     /* 1222373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1222384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1222387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1222390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222412 */     // MIs[0] round
     /* 1222412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222422 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1222425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222447 */     // GIR_Coverage, 17660,
     /* 1222447 */     GIR_EraseRootFromParent_Done,
     /* 1222448 */   // Label 17728: @1222448
     /* 1222448 */   GIM_Try, /*On fail goto*//*Label 17729*/ GIMT_Encode4(1222528), // Rule ID 17661 //
     /* 1222453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1222464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1222467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1222470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222492 */     // MIs[0] round
     /* 1222492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222502 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1222505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222527 */     // GIR_Coverage, 17661,
     /* 1222527 */     GIR_EraseRootFromParent_Done,
     /* 1222528 */   // Label 17729: @1222528
     /* 1222528 */   GIM_Try, /*On fail goto*//*Label 17730*/ GIMT_Encode4(1222608), // Rule ID 17664 //
     /* 1222533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1222544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1222547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1222550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222572 */     // MIs[0] round
     /* 1222572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222582 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1222585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222607 */     // GIR_Coverage, 17664,
     /* 1222607 */     GIR_EraseRootFromParent_Done,
     /* 1222608 */   // Label 17730: @1222608
     /* 1222608 */   GIM_Try, /*On fail goto*//*Label 17731*/ GIMT_Encode4(1222688), // Rule ID 17665 //
     /* 1222613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1222616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1222624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1222627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1222630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222652 */     // MIs[0] round
     /* 1222652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222662 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1222665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222687 */     // GIR_Coverage, 17665,
     /* 1222687 */     GIR_EraseRootFromParent_Done,
     /* 1222688 */   // Label 17731: @1222688
     /* 1222688 */   GIM_Try, /*On fail goto*//*Label 17732*/ GIMT_Encode4(1222768), // Rule ID 17668 //
     /* 1222693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1222704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1222707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1222710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222732 */     // MIs[0] round
     /* 1222732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222742 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1222745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222767 */     // GIR_Coverage, 17668,
     /* 1222767 */     GIR_EraseRootFromParent_Done,
     /* 1222768 */   // Label 17732: @1222768
     /* 1222768 */   GIM_Try, /*On fail goto*//*Label 17733*/ GIMT_Encode4(1222848), // Rule ID 17669 //
     /* 1222773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1222776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1222784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1222787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1222790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222812 */     // MIs[0] round
     /* 1222812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222822 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1222825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222847 */     // GIR_Coverage, 17669,
     /* 1222847 */     GIR_EraseRootFromParent_Done,
     /* 1222848 */   // Label 17733: @1222848
     /* 1222848 */   GIM_Try, /*On fail goto*//*Label 17734*/ GIMT_Encode4(1222928), // Rule ID 17672 //
     /* 1222853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1222864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1222867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1222870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222892 */     // MIs[0] round
     /* 1222892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222902 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1222905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222927 */     // GIR_Coverage, 17672,
     /* 1222927 */     GIR_EraseRootFromParent_Done,
     /* 1222928 */   // Label 17734: @1222928
     /* 1222928 */   GIM_Try, /*On fail goto*//*Label 17735*/ GIMT_Encode4(1223008), // Rule ID 17673 //
     /* 1222933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1222936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1222944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1222947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1222950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222972 */     // MIs[0] round
     /* 1222972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222982 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1222985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223007 */     // GIR_Coverage, 17673,
     /* 1223007 */     GIR_EraseRootFromParent_Done,
     /* 1223008 */   // Label 17735: @1223008
     /* 1223008 */   GIM_Try, /*On fail goto*//*Label 17736*/ GIMT_Encode4(1223088), // Rule ID 17676 //
     /* 1223013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1223024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1223027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1223030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223052 */     // MIs[0] round
     /* 1223052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223062 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1223065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223087 */     // GIR_Coverage, 17676,
     /* 1223087 */     GIR_EraseRootFromParent_Done,
     /* 1223088 */   // Label 17736: @1223088
     /* 1223088 */   GIM_Try, /*On fail goto*//*Label 17737*/ GIMT_Encode4(1223168), // Rule ID 17677 //
     /* 1223093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1223104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1223107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1223110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223132 */     // MIs[0] round
     /* 1223132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223142 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1223145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223167 */     // GIR_Coverage, 17677,
     /* 1223167 */     GIR_EraseRootFromParent_Done,
     /* 1223168 */   // Label 17737: @1223168
     /* 1223168 */   GIM_Try, /*On fail goto*//*Label 17738*/ GIMT_Encode4(1223248), // Rule ID 17680 //
     /* 1223173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1223184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1223187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1223190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223212 */     // MIs[0] round
     /* 1223212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223222 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1223225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223247 */     // GIR_Coverage, 17680,
     /* 1223247 */     GIR_EraseRootFromParent_Done,
     /* 1223248 */   // Label 17738: @1223248
     /* 1223248 */   GIM_Try, /*On fail goto*//*Label 17739*/ GIMT_Encode4(1223328), // Rule ID 17681 //
     /* 1223253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1223264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1223267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1223270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223292 */     // MIs[0] round
     /* 1223292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223302 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1223305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223327 */     // GIR_Coverage, 17681,
     /* 1223327 */     GIR_EraseRootFromParent_Done,
     /* 1223328 */   // Label 17739: @1223328
     /* 1223328 */   GIM_Try, /*On fail goto*//*Label 17740*/ GIMT_Encode4(1223408), // Rule ID 17684 //
     /* 1223333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1223344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1223347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1223350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223372 */     // MIs[0] round
     /* 1223372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223382 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1223385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223407 */     // GIR_Coverage, 17684,
     /* 1223407 */     GIR_EraseRootFromParent_Done,
     /* 1223408 */   // Label 17740: @1223408
     /* 1223408 */   GIM_Try, /*On fail goto*//*Label 17741*/ GIMT_Encode4(1223488), // Rule ID 17685 //
     /* 1223413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1223424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1223427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1223430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223452 */     // MIs[0] round
     /* 1223452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223462 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1223465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223487 */     // GIR_Coverage, 17685,
     /* 1223487 */     GIR_EraseRootFromParent_Done,
     /* 1223488 */   // Label 17741: @1223488
     /* 1223488 */   GIM_Try, /*On fail goto*//*Label 17742*/ GIMT_Encode4(1223568), // Rule ID 17688 //
     /* 1223493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1223504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1223507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1223510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1223513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223532 */     // MIs[0] round
     /* 1223532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223542 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1223545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223567 */     // GIR_Coverage, 17688,
     /* 1223567 */     GIR_EraseRootFromParent_Done,
     /* 1223568 */   // Label 17742: @1223568
     /* 1223568 */   GIM_Try, /*On fail goto*//*Label 17743*/ GIMT_Encode4(1223648), // Rule ID 17689 //
     /* 1223573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1223576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1223584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1223587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1223590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1223593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223612 */     // MIs[0] round
     /* 1223612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223622 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1223625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223647 */     // GIR_Coverage, 17689,
     /* 1223647 */     GIR_EraseRootFromParent_Done,
     /* 1223648 */   // Label 17743: @1223648
     /* 1223648 */   GIM_Try, /*On fail goto*//*Label 17744*/ GIMT_Encode4(1223728), // Rule ID 17692 //
     /* 1223653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1223670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1223673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223692 */     // MIs[0] round
     /* 1223692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223702 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1223705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223727 */     // GIR_Coverage, 17692,
     /* 1223727 */     GIR_EraseRootFromParent_Done,
     /* 1223728 */   // Label 17744: @1223728
     /* 1223728 */   GIM_Try, /*On fail goto*//*Label 17745*/ GIMT_Encode4(1223808), // Rule ID 17693 //
     /* 1223733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1223736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1223750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1223753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223772 */     // MIs[0] round
     /* 1223772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223782 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1223785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223807 */     // GIR_Coverage, 17693,
     /* 1223807 */     GIR_EraseRootFromParent_Done,
     /* 1223808 */   // Label 17745: @1223808
     /* 1223808 */   GIM_Try, /*On fail goto*//*Label 17746*/ GIMT_Encode4(1223888), // Rule ID 17696 //
     /* 1223813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1223824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1223827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1223830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1223833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223852 */     // MIs[0] round
     /* 1223852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223862 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1223865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223887 */     // GIR_Coverage, 17696,
     /* 1223887 */     GIR_EraseRootFromParent_Done,
     /* 1223888 */   // Label 17746: @1223888
     /* 1223888 */   GIM_Try, /*On fail goto*//*Label 17747*/ GIMT_Encode4(1223968), // Rule ID 17697 //
     /* 1223893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1223896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1223904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1223907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1223910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1223913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223932 */     // MIs[0] round
     /* 1223932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223942 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1223945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223967 */     // GIR_Coverage, 17697,
     /* 1223967 */     GIR_EraseRootFromParent_Done,
     /* 1223968 */   // Label 17747: @1223968
     /* 1223968 */   GIM_Try, /*On fail goto*//*Label 17748*/ GIMT_Encode4(1224048), // Rule ID 17700 //
     /* 1223973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1223984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1223987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1223990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1223993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224012 */     // MIs[0] round
     /* 1224012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224022 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1224025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224047 */     // GIR_Coverage, 17700,
     /* 1224047 */     GIR_EraseRootFromParent_Done,
     /* 1224048 */   // Label 17748: @1224048
     /* 1224048 */   GIM_Try, /*On fail goto*//*Label 17749*/ GIMT_Encode4(1224128), // Rule ID 17701 //
     /* 1224053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1224064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1224067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1224070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1224073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224092 */     // MIs[0] round
     /* 1224092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224102 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1224105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224127 */     // GIR_Coverage, 17701,
     /* 1224127 */     GIR_EraseRootFromParent_Done,
     /* 1224128 */   // Label 17749: @1224128
     /* 1224128 */   GIM_Try, /*On fail goto*//*Label 17750*/ GIMT_Encode4(1224208), // Rule ID 17704 //
     /* 1224133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1224144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1224147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1224150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1224153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224172 */     // MIs[0] round
     /* 1224172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224182 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1224185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224207 */     // GIR_Coverage, 17704,
     /* 1224207 */     GIR_EraseRootFromParent_Done,
     /* 1224208 */   // Label 17750: @1224208
     /* 1224208 */   GIM_Try, /*On fail goto*//*Label 17751*/ GIMT_Encode4(1224288), // Rule ID 17705 //
     /* 1224213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1224224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1224227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1224230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1224233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224252 */     // MIs[0] round
     /* 1224252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224262 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1224265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224287 */     // GIR_Coverage, 17705,
     /* 1224287 */     GIR_EraseRootFromParent_Done,
     /* 1224288 */   // Label 17751: @1224288
     /* 1224288 */   GIM_Try, /*On fail goto*//*Label 17752*/ GIMT_Encode4(1224368), // Rule ID 17708 //
     /* 1224293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1224304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1224307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1224310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1224313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224332 */     // MIs[0] round
     /* 1224332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224342 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1224345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224367 */     // GIR_Coverage, 17708,
     /* 1224367 */     GIR_EraseRootFromParent_Done,
     /* 1224368 */   // Label 17752: @1224368
     /* 1224368 */   GIM_Try, /*On fail goto*//*Label 17753*/ GIMT_Encode4(1224448), // Rule ID 17709 //
     /* 1224373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1224384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1224387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1224390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1224393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224412 */     // MIs[0] round
     /* 1224412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224422 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1224425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224447 */     // GIR_Coverage, 17709,
     /* 1224447 */     GIR_EraseRootFromParent_Done,
     /* 1224448 */   // Label 17753: @1224448
     /* 1224448 */   GIM_Try, /*On fail goto*//*Label 17754*/ GIMT_Encode4(1224528), // Rule ID 17712 //
     /* 1224453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1224464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1224467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1224470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1224473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224492 */     // MIs[0] round
     /* 1224492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224502 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1224505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224527 */     // GIR_Coverage, 17712,
     /* 1224527 */     GIR_EraseRootFromParent_Done,
     /* 1224528 */   // Label 17754: @1224528
     /* 1224528 */   GIM_Try, /*On fail goto*//*Label 17755*/ GIMT_Encode4(1224608), // Rule ID 17713 //
     /* 1224533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1224544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1224547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1224550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1224553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224572 */     // MIs[0] round
     /* 1224572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224582 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1224585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224607 */     // GIR_Coverage, 17713,
     /* 1224607 */     GIR_EraseRootFromParent_Done,
     /* 1224608 */   // Label 17755: @1224608
     /* 1224608 */   GIM_Try, /*On fail goto*//*Label 17756*/ GIMT_Encode4(1224688), // Rule ID 17716 //
     /* 1224613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1224624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1224627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1224630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1224633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224652 */     // MIs[0] round
     /* 1224652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224662 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1224665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224687 */     // GIR_Coverage, 17716,
     /* 1224687 */     GIR_EraseRootFromParent_Done,
     /* 1224688 */   // Label 17756: @1224688
     /* 1224688 */   GIM_Try, /*On fail goto*//*Label 17757*/ GIMT_Encode4(1224768), // Rule ID 17717 //
     /* 1224693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1224704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1224707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1224710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1224713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224732 */     // MIs[0] round
     /* 1224732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224742 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1224745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224767 */     // GIR_Coverage, 17717,
     /* 1224767 */     GIR_EraseRootFromParent_Done,
     /* 1224768 */   // Label 17757: @1224768
     /* 1224768 */   GIM_Try, /*On fail goto*//*Label 17758*/ GIMT_Encode4(1224848), // Rule ID 17720 //
     /* 1224773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1224784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1224787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1224790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1224793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224812 */     // MIs[0] round
     /* 1224812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224822 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1224825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224847 */     // GIR_Coverage, 17720,
     /* 1224847 */     GIR_EraseRootFromParent_Done,
     /* 1224848 */   // Label 17758: @1224848
     /* 1224848 */   GIM_Try, /*On fail goto*//*Label 17759*/ GIMT_Encode4(1224928), // Rule ID 17721 //
     /* 1224853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1224864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1224867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1224870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1224873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224892 */     // MIs[0] round
     /* 1224892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224902 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1224905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224927 */     // GIR_Coverage, 17721,
     /* 1224927 */     GIR_EraseRootFromParent_Done,
     /* 1224928 */   // Label 17759: @1224928
     /* 1224928 */   GIM_Try, /*On fail goto*//*Label 17760*/ GIMT_Encode4(1225008), // Rule ID 17724 //
     /* 1224933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1224944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1224947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1224950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1224953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1224972 */     // MIs[0] round
     /* 1224972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224982 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1224985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225007 */     // GIR_Coverage, 17724,
     /* 1225007 */     GIR_EraseRootFromParent_Done,
     /* 1225008 */   // Label 17760: @1225008
     /* 1225008 */   GIM_Try, /*On fail goto*//*Label 17761*/ GIMT_Encode4(1225088), // Rule ID 17725 //
     /* 1225013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1225024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1225027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1225030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225052 */     // MIs[0] round
     /* 1225052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225062 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1225065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225087 */     // GIR_Coverage, 17725,
     /* 1225087 */     GIR_EraseRootFromParent_Done,
     /* 1225088 */   // Label 17761: @1225088
     /* 1225088 */   GIM_Try, /*On fail goto*//*Label 17762*/ GIMT_Encode4(1225168), // Rule ID 17728 //
     /* 1225093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1225110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225132 */     // MIs[0] round
     /* 1225132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225142 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1225145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225167 */     // GIR_Coverage, 17728,
     /* 1225167 */     GIR_EraseRootFromParent_Done,
     /* 1225168 */   // Label 17762: @1225168
     /* 1225168 */   GIM_Try, /*On fail goto*//*Label 17763*/ GIMT_Encode4(1225248), // Rule ID 17729 //
     /* 1225173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1225190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225212 */     // MIs[0] round
     /* 1225212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225222 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1225225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225247 */     // GIR_Coverage, 17729,
     /* 1225247 */     GIR_EraseRootFromParent_Done,
     /* 1225248 */   // Label 17763: @1225248
     /* 1225248 */   GIM_Try, /*On fail goto*//*Label 17764*/ GIMT_Encode4(1225328), // Rule ID 17732 //
     /* 1225253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1225264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1225267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1225270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225292 */     // MIs[0] round
     /* 1225292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225302 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1225305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225327 */     // GIR_Coverage, 17732,
     /* 1225327 */     GIR_EraseRootFromParent_Done,
     /* 1225328 */   // Label 17764: @1225328
     /* 1225328 */   GIM_Try, /*On fail goto*//*Label 17765*/ GIMT_Encode4(1225408), // Rule ID 17733 //
     /* 1225333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1225344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1225347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1225350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225372 */     // MIs[0] round
     /* 1225372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225382 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1225385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225407 */     // GIR_Coverage, 17733,
     /* 1225407 */     GIR_EraseRootFromParent_Done,
     /* 1225408 */   // Label 17765: @1225408
     /* 1225408 */   GIM_Try, /*On fail goto*//*Label 17766*/ GIMT_Encode4(1225488), // Rule ID 17736 //
     /* 1225413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1225424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1225427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1225430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225452 */     // MIs[0] round
     /* 1225452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225462 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1225465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225487 */     // GIR_Coverage, 17736,
     /* 1225487 */     GIR_EraseRootFromParent_Done,
     /* 1225488 */   // Label 17766: @1225488
     /* 1225488 */   GIM_Try, /*On fail goto*//*Label 17767*/ GIMT_Encode4(1225568), // Rule ID 17737 //
     /* 1225493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1225504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1225507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1225510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225532 */     // MIs[0] round
     /* 1225532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225542 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1225545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225567 */     // GIR_Coverage, 17737,
     /* 1225567 */     GIR_EraseRootFromParent_Done,
     /* 1225568 */   // Label 17767: @1225568
     /* 1225568 */   GIM_Try, /*On fail goto*//*Label 17768*/ GIMT_Encode4(1225648), // Rule ID 17740 //
     /* 1225573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1225584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1225587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1225590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225612 */     // MIs[0] round
     /* 1225612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225622 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1225625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225647 */     // GIR_Coverage, 17740,
     /* 1225647 */     GIR_EraseRootFromParent_Done,
     /* 1225648 */   // Label 17768: @1225648
     /* 1225648 */   GIM_Try, /*On fail goto*//*Label 17769*/ GIMT_Encode4(1225728), // Rule ID 17741 //
     /* 1225653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1225664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1225667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1225670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225692 */     // MIs[0] round
     /* 1225692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225702 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1225705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225727 */     // GIR_Coverage, 17741,
     /* 1225727 */     GIR_EraseRootFromParent_Done,
     /* 1225728 */   // Label 17769: @1225728
     /* 1225728 */   GIM_Try, /*On fail goto*//*Label 17770*/ GIMT_Encode4(1225808), // Rule ID 17744 //
     /* 1225733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1225736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1225744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1225747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1225750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225772 */     // MIs[0] round
     /* 1225772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225782 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1225785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225807 */     // GIR_Coverage, 17744,
     /* 1225807 */     GIR_EraseRootFromParent_Done,
     /* 1225808 */   // Label 17770: @1225808
     /* 1225808 */   GIM_Try, /*On fail goto*//*Label 17771*/ GIMT_Encode4(1225888), // Rule ID 17745 //
     /* 1225813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1225816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1225824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1225827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1225830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225852 */     // MIs[0] round
     /* 1225852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225862 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1225865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225887 */     // GIR_Coverage, 17745,
     /* 1225887 */     GIR_EraseRootFromParent_Done,
     /* 1225888 */   // Label 17771: @1225888
     /* 1225888 */   GIM_Try, /*On fail goto*//*Label 17772*/ GIMT_Encode4(1225968), // Rule ID 17748 //
     /* 1225893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1225896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1225904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1225907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1225910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225932 */     // MIs[0] round
     /* 1225932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225942 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1225945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225967 */     // GIR_Coverage, 17748,
     /* 1225967 */     GIR_EraseRootFromParent_Done,
     /* 1225968 */   // Label 17772: @1225968
     /* 1225968 */   GIM_Try, /*On fail goto*//*Label 17773*/ GIMT_Encode4(1226048), // Rule ID 17749 //
     /* 1225973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1225976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1225984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1225987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1225990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226012 */     // MIs[0] round
     /* 1226012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226022 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1226025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226047 */     // GIR_Coverage, 17749,
     /* 1226047 */     GIR_EraseRootFromParent_Done,
     /* 1226048 */   // Label 17773: @1226048
     /* 1226048 */   GIM_Try, /*On fail goto*//*Label 17774*/ GIMT_Encode4(1226128), // Rule ID 17752 //
     /* 1226053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1226056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1226064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1226067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1226070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226092 */     // MIs[0] round
     /* 1226092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1226105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226127 */     // GIR_Coverage, 17752,
     /* 1226127 */     GIR_EraseRootFromParent_Done,
     /* 1226128 */   // Label 17774: @1226128
     /* 1226128 */   GIM_Try, /*On fail goto*//*Label 17775*/ GIMT_Encode4(1226208), // Rule ID 17753 //
     /* 1226133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1226136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1226144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1226147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1226150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226172 */     // MIs[0] round
     /* 1226172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226182 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1226185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226207 */     // GIR_Coverage, 17753,
     /* 1226207 */     GIR_EraseRootFromParent_Done,
     /* 1226208 */   // Label 17775: @1226208
     /* 1226208 */   GIM_Try, /*On fail goto*//*Label 17776*/ GIMT_Encode4(1226288), // Rule ID 17756 //
     /* 1226213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1226216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1226224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1226227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1226230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226252 */     // MIs[0] round
     /* 1226252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226262 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1226265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226287 */     // GIR_Coverage, 17756,
     /* 1226287 */     GIR_EraseRootFromParent_Done,
     /* 1226288 */   // Label 17776: @1226288
     /* 1226288 */   GIM_Try, /*On fail goto*//*Label 17777*/ GIMT_Encode4(1226368), // Rule ID 17757 //
     /* 1226293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1226296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1226304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1226307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1226310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226332 */     // MIs[0] round
     /* 1226332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226342 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1226345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226367 */     // GIR_Coverage, 17757,
     /* 1226367 */     GIR_EraseRootFromParent_Done,
     /* 1226368 */   // Label 17777: @1226368
     /* 1226368 */   GIM_Try, /*On fail goto*//*Label 17778*/ GIMT_Encode4(1226448), // Rule ID 22834 //
     /* 1226373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1226390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226412 */     // MIs[0] round
     /* 1226412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226422 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1226425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226447 */     // GIR_Coverage, 22834,
     /* 1226447 */     GIR_EraseRootFromParent_Done,
     /* 1226448 */   // Label 17778: @1226448
     /* 1226448 */   GIM_Try, /*On fail goto*//*Label 17779*/ GIMT_Encode4(1226528), // Rule ID 22835 //
     /* 1226453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1226470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226492 */     // MIs[0] round
     /* 1226492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226502 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1226505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226527 */     // GIR_Coverage, 22835,
     /* 1226527 */     GIR_EraseRootFromParent_Done,
     /* 1226528 */   // Label 17779: @1226528
     /* 1226528 */   GIM_Try, /*On fail goto*//*Label 17780*/ GIMT_Encode4(1226608), // Rule ID 22838 //
     /* 1226533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226572 */     // MIs[0] round
     /* 1226572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226582 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1226585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226607 */     // GIR_Coverage, 22838,
     /* 1226607 */     GIR_EraseRootFromParent_Done,
     /* 1226608 */   // Label 17780: @1226608
     /* 1226608 */   GIM_Try, /*On fail goto*//*Label 17781*/ GIMT_Encode4(1226688), // Rule ID 22839 //
     /* 1226613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1226616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226652 */     // MIs[0] round
     /* 1226652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226662 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1226665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226687 */     // GIR_Coverage, 22839,
     /* 1226687 */     GIR_EraseRootFromParent_Done,
     /* 1226688 */   // Label 17781: @1226688
     /* 1226688 */   GIM_Try, /*On fail goto*//*Label 17782*/ GIMT_Encode4(1226768), // Rule ID 22842 //
     /* 1226693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1226710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226732 */     // MIs[0] round
     /* 1226732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226742 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1226745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226767 */     // GIR_Coverage, 22842,
     /* 1226767 */     GIR_EraseRootFromParent_Done,
     /* 1226768 */   // Label 17782: @1226768
     /* 1226768 */   GIM_Try, /*On fail goto*//*Label 17783*/ GIMT_Encode4(1226848), // Rule ID 22843 //
     /* 1226773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1226790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226812 */     // MIs[0] round
     /* 1226812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226822 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1226825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226847 */     // GIR_Coverage, 22843,
     /* 1226847 */     GIR_EraseRootFromParent_Done,
     /* 1226848 */   // Label 17783: @1226848
     /* 1226848 */   GIM_Try, /*On fail goto*//*Label 17784*/ GIMT_Encode4(1226928), // Rule ID 22846 //
     /* 1226853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1226870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226892 */     // MIs[0] round
     /* 1226892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226902 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1226905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226927 */     // GIR_Coverage, 22846,
     /* 1226927 */     GIR_EraseRootFromParent_Done,
     /* 1226928 */   // Label 17784: @1226928
     /* 1226928 */   GIM_Try, /*On fail goto*//*Label 17785*/ GIMT_Encode4(1227008), // Rule ID 22847 //
     /* 1226933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1226936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1226950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226972 */     // MIs[0] round
     /* 1226972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226982 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1226985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227007 */     // GIR_Coverage, 22847,
     /* 1227007 */     GIR_EraseRootFromParent_Done,
     /* 1227008 */   // Label 17785: @1227008
     /* 1227008 */   GIM_Try, /*On fail goto*//*Label 17786*/ GIMT_Encode4(1227088), // Rule ID 22850 //
     /* 1227013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1227016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1227030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227052 */     // MIs[0] round
     /* 1227052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227062 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1227065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227087 */     // GIR_Coverage, 22850,
     /* 1227087 */     GIR_EraseRootFromParent_Done,
     /* 1227088 */   // Label 17786: @1227088
     /* 1227088 */   GIM_Try, /*On fail goto*//*Label 17787*/ GIMT_Encode4(1227168), // Rule ID 22851 //
     /* 1227093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1227096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1227110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227132 */     // MIs[0] round
     /* 1227132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227142 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1227145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227167 */     // GIR_Coverage, 22851,
     /* 1227167 */     GIR_EraseRootFromParent_Done,
     /* 1227168 */   // Label 17787: @1227168
     /* 1227168 */   GIM_Try, /*On fail goto*//*Label 17788*/ GIMT_Encode4(1227248), // Rule ID 22854 //
     /* 1227173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1227190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227212 */     // MIs[0] round
     /* 1227212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227222 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1227225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227247 */     // GIR_Coverage, 22854,
     /* 1227247 */     GIR_EraseRootFromParent_Done,
     /* 1227248 */   // Label 17788: @1227248
     /* 1227248 */   GIM_Try, /*On fail goto*//*Label 17789*/ GIMT_Encode4(1227328), // Rule ID 22855 //
     /* 1227253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1227270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227292 */     // MIs[0] round
     /* 1227292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227302 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1227305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227327 */     // GIR_Coverage, 22855,
     /* 1227327 */     GIR_EraseRootFromParent_Done,
     /* 1227328 */   // Label 17789: @1227328
     /* 1227328 */   GIM_Try, /*On fail goto*//*Label 17790*/ GIMT_Encode4(1227408), // Rule ID 22858 //
     /* 1227333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1227350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227372 */     // MIs[0] round
     /* 1227372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227382 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1227385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227407 */     // GIR_Coverage, 22858,
     /* 1227407 */     GIR_EraseRootFromParent_Done,
     /* 1227408 */   // Label 17790: @1227408
     /* 1227408 */   GIM_Try, /*On fail goto*//*Label 17791*/ GIMT_Encode4(1227488), // Rule ID 22859 //
     /* 1227413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1227430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227452 */     // MIs[0] round
     /* 1227452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227462 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1227465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227487 */     // GIR_Coverage, 22859,
     /* 1227487 */     GIR_EraseRootFromParent_Done,
     /* 1227488 */   // Label 17791: @1227488
     /* 1227488 */   GIM_Try, /*On fail goto*//*Label 17792*/ GIMT_Encode4(1227568), // Rule ID 22862 //
     /* 1227493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1227510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227532 */     // MIs[0] round
     /* 1227532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227542 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1227545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227567 */     // GIR_Coverage, 22862,
     /* 1227567 */     GIR_EraseRootFromParent_Done,
     /* 1227568 */   // Label 17792: @1227568
     /* 1227568 */   GIM_Try, /*On fail goto*//*Label 17793*/ GIMT_Encode4(1227648), // Rule ID 22863 //
     /* 1227573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1227590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227612 */     // MIs[0] round
     /* 1227612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227622 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1227625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227647 */     // GIR_Coverage, 22863,
     /* 1227647 */     GIR_EraseRootFromParent_Done,
     /* 1227648 */   // Label 17793: @1227648
     /* 1227648 */   GIM_Try, /*On fail goto*//*Label 17794*/ GIMT_Encode4(1227728), // Rule ID 22866 //
     /* 1227653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1227670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227692 */     // MIs[0] round
     /* 1227692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227702 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1227705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227727 */     // GIR_Coverage, 22866,
     /* 1227727 */     GIR_EraseRootFromParent_Done,
     /* 1227728 */   // Label 17794: @1227728
     /* 1227728 */   GIM_Try, /*On fail goto*//*Label 17795*/ GIMT_Encode4(1227808), // Rule ID 22867 //
     /* 1227733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1227750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227772 */     // MIs[0] round
     /* 1227772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227782 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1227785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227807 */     // GIR_Coverage, 22867,
     /* 1227807 */     GIR_EraseRootFromParent_Done,
     /* 1227808 */   // Label 17795: @1227808
     /* 1227808 */   GIM_Try, /*On fail goto*//*Label 17796*/ GIMT_Encode4(1227888), // Rule ID 22870 //
     /* 1227813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1227830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227852 */     // MIs[0] round
     /* 1227852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227862 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1227865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227887 */     // GIR_Coverage, 22870,
     /* 1227887 */     GIR_EraseRootFromParent_Done,
     /* 1227888 */   // Label 17796: @1227888
     /* 1227888 */   GIM_Try, /*On fail goto*//*Label 17797*/ GIMT_Encode4(1227968), // Rule ID 22871 //
     /* 1227893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1227910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227932 */     // MIs[0] round
     /* 1227932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227942 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1227945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227967 */     // GIR_Coverage, 22871,
     /* 1227967 */     GIR_EraseRootFromParent_Done,
     /* 1227968 */   // Label 17797: @1227968
     /* 1227968 */   GIM_Try, /*On fail goto*//*Label 17798*/ GIMT_Encode4(1228048), // Rule ID 22874 //
     /* 1227973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1227990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228012 */     // MIs[0] round
     /* 1228012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228022 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1228025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228047 */     // GIR_Coverage, 22874,
     /* 1228047 */     GIR_EraseRootFromParent_Done,
     /* 1228048 */   // Label 17798: @1228048
     /* 1228048 */   GIM_Try, /*On fail goto*//*Label 17799*/ GIMT_Encode4(1228128), // Rule ID 22875 //
     /* 1228053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1228070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228092 */     // MIs[0] round
     /* 1228092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228102 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1228105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228127 */     // GIR_Coverage, 22875,
     /* 1228127 */     GIR_EraseRootFromParent_Done,
     /* 1228128 */   // Label 17799: @1228128
     /* 1228128 */   GIM_Try, /*On fail goto*//*Label 17800*/ GIMT_Encode4(1228208), // Rule ID 22878 //
     /* 1228133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1228150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228172 */     // MIs[0] round
     /* 1228172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228182 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1228185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228207 */     // GIR_Coverage, 22878,
     /* 1228207 */     GIR_EraseRootFromParent_Done,
     /* 1228208 */   // Label 17800: @1228208
     /* 1228208 */   GIM_Try, /*On fail goto*//*Label 17801*/ GIMT_Encode4(1228288), // Rule ID 22879 //
     /* 1228213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1228230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228252 */     // MIs[0] round
     /* 1228252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228262 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1228265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228287 */     // GIR_Coverage, 22879,
     /* 1228287 */     GIR_EraseRootFromParent_Done,
     /* 1228288 */   // Label 17801: @1228288
     /* 1228288 */   GIM_Try, /*On fail goto*//*Label 17802*/ GIMT_Encode4(1228368), // Rule ID 22882 //
     /* 1228293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1228310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228332 */     // MIs[0] round
     /* 1228332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228342 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1228345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228367 */     // GIR_Coverage, 22882,
     /* 1228367 */     GIR_EraseRootFromParent_Done,
     /* 1228368 */   // Label 17802: @1228368
     /* 1228368 */   GIM_Try, /*On fail goto*//*Label 17803*/ GIMT_Encode4(1228448), // Rule ID 22883 //
     /* 1228373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1228390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228412 */     // MIs[0] round
     /* 1228412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228422 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1228425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228447 */     // GIR_Coverage, 22883,
     /* 1228447 */     GIR_EraseRootFromParent_Done,
     /* 1228448 */   // Label 17803: @1228448
     /* 1228448 */   GIM_Try, /*On fail goto*//*Label 17804*/ GIMT_Encode4(1228528), // Rule ID 22886 //
     /* 1228453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1228470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228492 */     // MIs[0] round
     /* 1228492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228502 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1228505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228527 */     // GIR_Coverage, 22886,
     /* 1228527 */     GIR_EraseRootFromParent_Done,
     /* 1228528 */   // Label 17804: @1228528
     /* 1228528 */   GIM_Try, /*On fail goto*//*Label 17805*/ GIMT_Encode4(1228608), // Rule ID 22887 //
     /* 1228533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1228550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228572 */     // MIs[0] round
     /* 1228572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228582 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1228585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228607 */     // GIR_Coverage, 22887,
     /* 1228607 */     GIR_EraseRootFromParent_Done,
     /* 1228608 */   // Label 17805: @1228608
     /* 1228608 */   GIM_Try, /*On fail goto*//*Label 17806*/ GIMT_Encode4(1228688), // Rule ID 22890 //
     /* 1228613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1228630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228652 */     // MIs[0] round
     /* 1228652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228662 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1228665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228687 */     // GIR_Coverage, 22890,
     /* 1228687 */     GIR_EraseRootFromParent_Done,
     /* 1228688 */   // Label 17806: @1228688
     /* 1228688 */   GIM_Try, /*On fail goto*//*Label 17807*/ GIMT_Encode4(1228768), // Rule ID 22891 //
     /* 1228693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1228710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228732 */     // MIs[0] round
     /* 1228732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228742 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1228745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228767 */     // GIR_Coverage, 22891,
     /* 1228767 */     GIR_EraseRootFromParent_Done,
     /* 1228768 */   // Label 17807: @1228768
     /* 1228768 */   GIM_Try, /*On fail goto*//*Label 17808*/ GIMT_Encode4(1228848), // Rule ID 22894 //
     /* 1228773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1228790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228812 */     // MIs[0] round
     /* 1228812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228822 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1228825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228847 */     // GIR_Coverage, 22894,
     /* 1228847 */     GIR_EraseRootFromParent_Done,
     /* 1228848 */   // Label 17808: @1228848
     /* 1228848 */   GIM_Try, /*On fail goto*//*Label 17809*/ GIMT_Encode4(1228928), // Rule ID 22895 //
     /* 1228853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1228870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228892 */     // MIs[0] round
     /* 1228892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228902 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1228905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228927 */     // GIR_Coverage, 22895,
     /* 1228927 */     GIR_EraseRootFromParent_Done,
     /* 1228928 */   // Label 17809: @1228928
     /* 1228928 */   GIM_Try, /*On fail goto*//*Label 17810*/ GIMT_Encode4(1229008), // Rule ID 22898 //
     /* 1228933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1228950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228972 */     // MIs[0] round
     /* 1228972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228982 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1228985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229007 */     // GIR_Coverage, 22898,
     /* 1229007 */     GIR_EraseRootFromParent_Done,
     /* 1229008 */   // Label 17810: @1229008
     /* 1229008 */   GIM_Try, /*On fail goto*//*Label 17811*/ GIMT_Encode4(1229088), // Rule ID 22899 //
     /* 1229013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1229030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229052 */     // MIs[0] round
     /* 1229052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229062 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1229065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229087 */     // GIR_Coverage, 22899,
     /* 1229087 */     GIR_EraseRootFromParent_Done,
     /* 1229088 */   // Label 17811: @1229088
     /* 1229088 */   GIM_Try, /*On fail goto*//*Label 17812*/ GIMT_Encode4(1229168), // Rule ID 22902 //
     /* 1229093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1229110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229132 */     // MIs[0] round
     /* 1229132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229142 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1229145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229167 */     // GIR_Coverage, 22902,
     /* 1229167 */     GIR_EraseRootFromParent_Done,
     /* 1229168 */   // Label 17812: @1229168
     /* 1229168 */   GIM_Try, /*On fail goto*//*Label 17813*/ GIMT_Encode4(1229248), // Rule ID 22903 //
     /* 1229173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1229190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229212 */     // MIs[0] round
     /* 1229212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229222 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1229225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229247 */     // GIR_Coverage, 22903,
     /* 1229247 */     GIR_EraseRootFromParent_Done,
     /* 1229248 */   // Label 17813: @1229248
     /* 1229248 */   GIM_Try, /*On fail goto*//*Label 17814*/ GIMT_Encode4(1229328), // Rule ID 22906 //
     /* 1229253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1229256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1229270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229292 */     // MIs[0] round
     /* 1229292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229302 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1229305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229327 */     // GIR_Coverage, 22906,
     /* 1229327 */     GIR_EraseRootFromParent_Done,
     /* 1229328 */   // Label 17814: @1229328
     /* 1229328 */   GIM_Try, /*On fail goto*//*Label 17815*/ GIMT_Encode4(1229408), // Rule ID 22907 //
     /* 1229333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1229350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229372 */     // MIs[0] round
     /* 1229372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229382 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1229385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229407 */     // GIR_Coverage, 22907,
     /* 1229407 */     GIR_EraseRootFromParent_Done,
     /* 1229408 */   // Label 17815: @1229408
     /* 1229408 */   GIM_Try, /*On fail goto*//*Label 17816*/ GIMT_Encode4(1229488), // Rule ID 22910 //
     /* 1229413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1229416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1229430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229452 */     // MIs[0] round
     /* 1229452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229462 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1229465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1229483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229487 */     // GIR_Coverage, 22910,
     /* 1229487 */     GIR_EraseRootFromParent_Done,
     /* 1229488 */   // Label 17816: @1229488
     /* 1229488 */   GIM_Try, /*On fail goto*//*Label 17817*/ GIMT_Encode4(1229568), // Rule ID 22911 //
     /* 1229493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1229496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1229510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229532 */     // MIs[0] round
     /* 1229532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229542 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1229545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1229563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229567 */     // GIR_Coverage, 22911,
     /* 1229567 */     GIR_EraseRootFromParent_Done,
     /* 1229568 */   // Label 17817: @1229568
     /* 1229568 */   GIM_Try, /*On fail goto*//*Label 17818*/ GIMT_Encode4(1229648), // Rule ID 22914 //
     /* 1229573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1229590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229612 */     // MIs[0] round
     /* 1229612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229622 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1229625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229647 */     // GIR_Coverage, 22914,
     /* 1229647 */     GIR_EraseRootFromParent_Done,
     /* 1229648 */   // Label 17818: @1229648
     /* 1229648 */   GIM_Try, /*On fail goto*//*Label 17819*/ GIMT_Encode4(1229728), // Rule ID 22915 //
     /* 1229653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1229670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229692 */     // MIs[0] round
     /* 1229692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229702 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1229705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229727 */     // GIR_Coverage, 22915,
     /* 1229727 */     GIR_EraseRootFromParent_Done,
     /* 1229728 */   // Label 17819: @1229728
     /* 1229728 */   GIM_Try, /*On fail goto*//*Label 17820*/ GIMT_Encode4(1229808), // Rule ID 22918 //
     /* 1229733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1229750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229772 */     // MIs[0] round
     /* 1229772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229782 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1229785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229807 */     // GIR_Coverage, 22918,
     /* 1229807 */     GIR_EraseRootFromParent_Done,
     /* 1229808 */   // Label 17820: @1229808
     /* 1229808 */   GIM_Try, /*On fail goto*//*Label 17821*/ GIMT_Encode4(1229888), // Rule ID 22919 //
     /* 1229813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1229830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229852 */     // MIs[0] round
     /* 1229852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229862 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1229865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229887 */     // GIR_Coverage, 22919,
     /* 1229887 */     GIR_EraseRootFromParent_Done,
     /* 1229888 */   // Label 17821: @1229888
     /* 1229888 */   GIM_Try, /*On fail goto*//*Label 17822*/ GIMT_Encode4(1229968), // Rule ID 22922 //
     /* 1229893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1229910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229932 */     // MIs[0] round
     /* 1229932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229942 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1229945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229967 */     // GIR_Coverage, 22922,
     /* 1229967 */     GIR_EraseRootFromParent_Done,
     /* 1229968 */   // Label 17822: @1229968
     /* 1229968 */   GIM_Try, /*On fail goto*//*Label 17823*/ GIMT_Encode4(1230048), // Rule ID 22923 //
     /* 1229973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1229990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230012 */     // MIs[0] round
     /* 1230012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230022 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1230025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230047 */     // GIR_Coverage, 22923,
     /* 1230047 */     GIR_EraseRootFromParent_Done,
     /* 1230048 */   // Label 17823: @1230048
     /* 1230048 */   GIM_Try, /*On fail goto*//*Label 17824*/ GIMT_Encode4(1230128), // Rule ID 22926 //
     /* 1230053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1230070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230092 */     // MIs[0] round
     /* 1230092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230102 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1230105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230127 */     // GIR_Coverage, 22926,
     /* 1230127 */     GIR_EraseRootFromParent_Done,
     /* 1230128 */   // Label 17824: @1230128
     /* 1230128 */   GIM_Try, /*On fail goto*//*Label 17825*/ GIMT_Encode4(1230208), // Rule ID 22927 //
     /* 1230133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1230150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230172 */     // MIs[0] round
     /* 1230172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230182 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1230185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230207 */     // GIR_Coverage, 22927,
     /* 1230207 */     GIR_EraseRootFromParent_Done,
     /* 1230208 */   // Label 17825: @1230208
     /* 1230208 */   GIM_Try, /*On fail goto*//*Label 17826*/ GIMT_Encode4(1230288), // Rule ID 22930 //
     /* 1230213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1230230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230252 */     // MIs[0] round
     /* 1230252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230262 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1230265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230287 */     // GIR_Coverage, 22930,
     /* 1230287 */     GIR_EraseRootFromParent_Done,
     /* 1230288 */   // Label 17826: @1230288
     /* 1230288 */   GIM_Try, /*On fail goto*//*Label 17827*/ GIMT_Encode4(1230368), // Rule ID 22931 //
     /* 1230293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1230310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230332 */     // MIs[0] round
     /* 1230332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230342 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1230345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230367 */     // GIR_Coverage, 22931,
     /* 1230367 */     GIR_EraseRootFromParent_Done,
     /* 1230368 */   // Label 17827: @1230368
     /* 1230368 */   GIM_Try, /*On fail goto*//*Label 17828*/ GIMT_Encode4(1230448), // Rule ID 22934 //
     /* 1230373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230412 */     // MIs[0] round
     /* 1230412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230422 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1230425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230447 */     // GIR_Coverage, 22934,
     /* 1230447 */     GIR_EraseRootFromParent_Done,
     /* 1230448 */   // Label 17828: @1230448
     /* 1230448 */   GIM_Try, /*On fail goto*//*Label 17829*/ GIMT_Encode4(1230528), // Rule ID 22935 //
     /* 1230453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230492 */     // MIs[0] round
     /* 1230492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230502 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1230505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230527 */     // GIR_Coverage, 22935,
     /* 1230527 */     GIR_EraseRootFromParent_Done,
     /* 1230528 */   // Label 17829: @1230528
     /* 1230528 */   GIM_Try, /*On fail goto*//*Label 17830*/ GIMT_Encode4(1230608), // Rule ID 22938 //
     /* 1230533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1230550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230572 */     // MIs[0] round
     /* 1230572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230582 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1230585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230607 */     // GIR_Coverage, 22938,
     /* 1230607 */     GIR_EraseRootFromParent_Done,
     /* 1230608 */   // Label 17830: @1230608
     /* 1230608 */   GIM_Try, /*On fail goto*//*Label 17831*/ GIMT_Encode4(1230688), // Rule ID 22939 //
     /* 1230613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1230616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1230630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230652 */     // MIs[0] round
     /* 1230652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230662 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1230665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230687 */     // GIR_Coverage, 22939,
     /* 1230687 */     GIR_EraseRootFromParent_Done,
     /* 1230688 */   // Label 17831: @1230688
     /* 1230688 */   GIM_Try, /*On fail goto*//*Label 17832*/ GIMT_Encode4(1230768), // Rule ID 22942 //
     /* 1230693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1230710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230732 */     // MIs[0] round
     /* 1230732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230742 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1230745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230767 */     // GIR_Coverage, 22942,
     /* 1230767 */     GIR_EraseRootFromParent_Done,
     /* 1230768 */   // Label 17832: @1230768
     /* 1230768 */   GIM_Try, /*On fail goto*//*Label 17833*/ GIMT_Encode4(1230848), // Rule ID 22943 //
     /* 1230773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1230776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1230790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230812 */     // MIs[0] round
     /* 1230812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230822 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1230825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230847 */     // GIR_Coverage, 22943,
     /* 1230847 */     GIR_EraseRootFromParent_Done,
     /* 1230848 */   // Label 17833: @1230848
     /* 1230848 */   GIM_Try, /*On fail goto*//*Label 17834*/ GIMT_Encode4(1230928), // Rule ID 22946 //
     /* 1230853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1230870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230892 */     // MIs[0] round
     /* 1230892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230902 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1230905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230927 */     // GIR_Coverage, 22946,
     /* 1230927 */     GIR_EraseRootFromParent_Done,
     /* 1230928 */   // Label 17834: @1230928
     /* 1230928 */   GIM_Try, /*On fail goto*//*Label 17835*/ GIMT_Encode4(1231008), // Rule ID 22947 //
     /* 1230933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1230936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1230950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230972 */     // MIs[0] round
     /* 1230972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230982 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1230985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231007 */     // GIR_Coverage, 22947,
     /* 1231007 */     GIR_EraseRootFromParent_Done,
     /* 1231008 */   // Label 17835: @1231008
     /* 1231008 */   GIM_Try, /*On fail goto*//*Label 17836*/ GIMT_Encode4(1231088), // Rule ID 23070 //
     /* 1231013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1231030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231052 */     // MIs[0] round
     /* 1231052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231062 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1231065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231087 */     // GIR_Coverage, 23070,
     /* 1231087 */     GIR_EraseRootFromParent_Done,
     /* 1231088 */   // Label 17836: @1231088
     /* 1231088 */   GIM_Try, /*On fail goto*//*Label 17837*/ GIMT_Encode4(1231168), // Rule ID 23071 //
     /* 1231093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1231110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231132 */     // MIs[0] round
     /* 1231132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231142 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1231145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231167 */     // GIR_Coverage, 23071,
     /* 1231167 */     GIR_EraseRootFromParent_Done,
     /* 1231168 */   // Label 17837: @1231168
     /* 1231168 */   GIM_Try, /*On fail goto*//*Label 17838*/ GIMT_Encode4(1231248), // Rule ID 23074 //
     /* 1231173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1231190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231212 */     // MIs[0] round
     /* 1231212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231222 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1231225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231247 */     // GIR_Coverage, 23074,
     /* 1231247 */     GIR_EraseRootFromParent_Done,
     /* 1231248 */   // Label 17838: @1231248
     /* 1231248 */   GIM_Try, /*On fail goto*//*Label 17839*/ GIMT_Encode4(1231328), // Rule ID 23075 //
     /* 1231253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1231270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231292 */     // MIs[0] round
     /* 1231292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231302 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1231305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231327 */     // GIR_Coverage, 23075,
     /* 1231327 */     GIR_EraseRootFromParent_Done,
     /* 1231328 */   // Label 17839: @1231328
     /* 1231328 */   GIM_Try, /*On fail goto*//*Label 17840*/ GIMT_Encode4(1231408), // Rule ID 23078 //
     /* 1231333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1231350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231372 */     // MIs[0] round
     /* 1231372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231382 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1231385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231407 */     // GIR_Coverage, 23078,
     /* 1231407 */     GIR_EraseRootFromParent_Done,
     /* 1231408 */   // Label 17840: @1231408
     /* 1231408 */   GIM_Try, /*On fail goto*//*Label 17841*/ GIMT_Encode4(1231488), // Rule ID 23079 //
     /* 1231413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1231416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1231430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231452 */     // MIs[0] round
     /* 1231452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231462 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1231465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231487 */     // GIR_Coverage, 23079,
     /* 1231487 */     GIR_EraseRootFromParent_Done,
     /* 1231488 */   // Label 17841: @1231488
     /* 1231488 */   GIM_Try, /*On fail goto*//*Label 17842*/ GIMT_Encode4(1231568), // Rule ID 23082 //
     /* 1231493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1231510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231532 */     // MIs[0] round
     /* 1231532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231542 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1231545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231567 */     // GIR_Coverage, 23082,
     /* 1231567 */     GIR_EraseRootFromParent_Done,
     /* 1231568 */   // Label 17842: @1231568
     /* 1231568 */   GIM_Try, /*On fail goto*//*Label 17843*/ GIMT_Encode4(1231648), // Rule ID 23083 //
     /* 1231573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1231590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231612 */     // MIs[0] round
     /* 1231612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231622 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1231625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231647 */     // GIR_Coverage, 23083,
     /* 1231647 */     GIR_EraseRootFromParent_Done,
     /* 1231648 */   // Label 17843: @1231648
     /* 1231648 */   GIM_Try, /*On fail goto*//*Label 17844*/ GIMT_Encode4(1231728), // Rule ID 23086 //
     /* 1231653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1231670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231692 */     // MIs[0] round
     /* 1231692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231702 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1231705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231727 */     // GIR_Coverage, 23086,
     /* 1231727 */     GIR_EraseRootFromParent_Done,
     /* 1231728 */   // Label 17844: @1231728
     /* 1231728 */   GIM_Try, /*On fail goto*//*Label 17845*/ GIMT_Encode4(1231808), // Rule ID 23087 //
     /* 1231733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1231736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1231750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231772 */     // MIs[0] round
     /* 1231772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231782 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1231785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231807 */     // GIR_Coverage, 23087,
     /* 1231807 */     GIR_EraseRootFromParent_Done,
     /* 1231808 */   // Label 17845: @1231808
     /* 1231808 */   GIM_Try, /*On fail goto*//*Label 17846*/ GIMT_Encode4(1231888), // Rule ID 23090 //
     /* 1231813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1231830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231852 */     // MIs[0] round
     /* 1231852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231862 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1231865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231887 */     // GIR_Coverage, 23090,
     /* 1231887 */     GIR_EraseRootFromParent_Done,
     /* 1231888 */   // Label 17846: @1231888
     /* 1231888 */   GIM_Try, /*On fail goto*//*Label 17847*/ GIMT_Encode4(1231968), // Rule ID 23091 //
     /* 1231893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1231910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231932 */     // MIs[0] round
     /* 1231932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231942 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1231945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231967 */     // GIR_Coverage, 23091,
     /* 1231967 */     GIR_EraseRootFromParent_Done,
     /* 1231968 */   // Label 17847: @1231968
     /* 1231968 */   GIM_Try, /*On fail goto*//*Label 17848*/ GIMT_Encode4(1232048), // Rule ID 23094 //
     /* 1231973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1231990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232012 */     // MIs[0] round
     /* 1232012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232022 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1232025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232047 */     // GIR_Coverage, 23094,
     /* 1232047 */     GIR_EraseRootFromParent_Done,
     /* 1232048 */   // Label 17848: @1232048
     /* 1232048 */   GIM_Try, /*On fail goto*//*Label 17849*/ GIMT_Encode4(1232128), // Rule ID 23095 //
     /* 1232053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1232070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232092 */     // MIs[0] round
     /* 1232092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232102 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1232105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232127 */     // GIR_Coverage, 23095,
     /* 1232127 */     GIR_EraseRootFromParent_Done,
     /* 1232128 */   // Label 17849: @1232128
     /* 1232128 */   GIM_Try, /*On fail goto*//*Label 17850*/ GIMT_Encode4(1232208), // Rule ID 23098 //
     /* 1232133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1232150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232172 */     // MIs[0] round
     /* 1232172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232182 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1232185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232207 */     // GIR_Coverage, 23098,
     /* 1232207 */     GIR_EraseRootFromParent_Done,
     /* 1232208 */   // Label 17850: @1232208
     /* 1232208 */   GIM_Try, /*On fail goto*//*Label 17851*/ GIMT_Encode4(1232288), // Rule ID 23099 //
     /* 1232213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1232230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232252 */     // MIs[0] round
     /* 1232252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232262 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1232265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232287 */     // GIR_Coverage, 23099,
     /* 1232287 */     GIR_EraseRootFromParent_Done,
     /* 1232288 */   // Label 17851: @1232288
     /* 1232288 */   GIM_Try, /*On fail goto*//*Label 17852*/ GIMT_Encode4(1232368), // Rule ID 23102 //
     /* 1232293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1232310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232332 */     // MIs[0] round
     /* 1232332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232342 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1232345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232367 */     // GIR_Coverage, 23102,
     /* 1232367 */     GIR_EraseRootFromParent_Done,
     /* 1232368 */   // Label 17852: @1232368
     /* 1232368 */   GIM_Try, /*On fail goto*//*Label 17853*/ GIMT_Encode4(1232448), // Rule ID 23103 //
     /* 1232373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1232390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232412 */     // MIs[0] round
     /* 1232412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232422 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1232425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232447 */     // GIR_Coverage, 23103,
     /* 1232447 */     GIR_EraseRootFromParent_Done,
     /* 1232448 */   // Label 17853: @1232448
     /* 1232448 */   GIM_Try, /*On fail goto*//*Label 17854*/ GIMT_Encode4(1232528), // Rule ID 23106 //
     /* 1232453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1232470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232492 */     // MIs[0] round
     /* 1232492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232502 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1232505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232527 */     // GIR_Coverage, 23106,
     /* 1232527 */     GIR_EraseRootFromParent_Done,
     /* 1232528 */   // Label 17854: @1232528
     /* 1232528 */   GIM_Try, /*On fail goto*//*Label 17855*/ GIMT_Encode4(1232608), // Rule ID 23107 //
     /* 1232533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1232550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232572 */     // MIs[0] round
     /* 1232572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232582 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1232585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232607 */     // GIR_Coverage, 23107,
     /* 1232607 */     GIR_EraseRootFromParent_Done,
     /* 1232608 */   // Label 17855: @1232608
     /* 1232608 */   GIM_Try, /*On fail goto*//*Label 17856*/ GIMT_Encode4(1232688), // Rule ID 23110 //
     /* 1232613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1232630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232652 */     // MIs[0] round
     /* 1232652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232662 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1232665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232687 */     // GIR_Coverage, 23110,
     /* 1232687 */     GIR_EraseRootFromParent_Done,
     /* 1232688 */   // Label 17856: @1232688
     /* 1232688 */   GIM_Try, /*On fail goto*//*Label 17857*/ GIMT_Encode4(1232768), // Rule ID 23111 //
     /* 1232693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1232710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232732 */     // MIs[0] round
     /* 1232732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232742 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1232745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232767 */     // GIR_Coverage, 23111,
     /* 1232767 */     GIR_EraseRootFromParent_Done,
     /* 1232768 */   // Label 17857: @1232768
     /* 1232768 */   GIM_Try, /*On fail goto*//*Label 17858*/ GIMT_Encode4(1232848), // Rule ID 23114 //
     /* 1232773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1232781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1232790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232812 */     // MIs[0] round
     /* 1232812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232822 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1232825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232847 */     // GIR_Coverage, 23114,
     /* 1232847 */     GIR_EraseRootFromParent_Done,
     /* 1232848 */   // Label 17858: @1232848
     /* 1232848 */   GIM_Try, /*On fail goto*//*Label 17859*/ GIMT_Encode4(1232928), // Rule ID 23115 //
     /* 1232853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1232861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1232870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232892 */     // MIs[0] round
     /* 1232892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232902 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1232905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232927 */     // GIR_Coverage, 23115,
     /* 1232927 */     GIR_EraseRootFromParent_Done,
     /* 1232928 */   // Label 17859: @1232928
     /* 1232928 */   GIM_Try, /*On fail goto*//*Label 17860*/ GIMT_Encode4(1233008), // Rule ID 23118 //
     /* 1232933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1232941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1232950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232972 */     // MIs[0] round
     /* 1232972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232982 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1232985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233007 */     // GIR_Coverage, 23118,
     /* 1233007 */     GIR_EraseRootFromParent_Done,
     /* 1233008 */   // Label 17860: @1233008
     /* 1233008 */   GIM_Try, /*On fail goto*//*Label 17861*/ GIMT_Encode4(1233088), // Rule ID 23119 //
     /* 1233013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1233030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233052 */     // MIs[0] round
     /* 1233052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233062 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1233065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233087 */     // GIR_Coverage, 23119,
     /* 1233087 */     GIR_EraseRootFromParent_Done,
     /* 1233088 */   // Label 17861: @1233088
     /* 1233088 */   GIM_Try, /*On fail goto*//*Label 17862*/ GIMT_Encode4(1233168), // Rule ID 23122 //
     /* 1233093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1233110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233132 */     // MIs[0] round
     /* 1233132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233142 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1233145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233167 */     // GIR_Coverage, 23122,
     /* 1233167 */     GIR_EraseRootFromParent_Done,
     /* 1233168 */   // Label 17862: @1233168
     /* 1233168 */   GIM_Try, /*On fail goto*//*Label 17863*/ GIMT_Encode4(1233248), // Rule ID 23123 //
     /* 1233173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1233190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233212 */     // MIs[0] round
     /* 1233212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233222 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1233225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233247 */     // GIR_Coverage, 23123,
     /* 1233247 */     GIR_EraseRootFromParent_Done,
     /* 1233248 */   // Label 17863: @1233248
     /* 1233248 */   GIM_Try, /*On fail goto*//*Label 17864*/ GIMT_Encode4(1233328), // Rule ID 23126 //
     /* 1233253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233292 */     // MIs[0] round
     /* 1233292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233302 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1233305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233327 */     // GIR_Coverage, 23126,
     /* 1233327 */     GIR_EraseRootFromParent_Done,
     /* 1233328 */   // Label 17864: @1233328
     /* 1233328 */   GIM_Try, /*On fail goto*//*Label 17865*/ GIMT_Encode4(1233408), // Rule ID 23127 //
     /* 1233333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233372 */     // MIs[0] round
     /* 1233372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233382 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1233385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233407 */     // GIR_Coverage, 23127,
     /* 1233407 */     GIR_EraseRootFromParent_Done,
     /* 1233408 */   // Label 17865: @1233408
     /* 1233408 */   GIM_Try, /*On fail goto*//*Label 17866*/ GIMT_Encode4(1233488), // Rule ID 23130 //
     /* 1233413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233452 */     // MIs[0] round
     /* 1233452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233462 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1233465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233487 */     // GIR_Coverage, 23130,
     /* 1233487 */     GIR_EraseRootFromParent_Done,
     /* 1233488 */   // Label 17866: @1233488
     /* 1233488 */   GIM_Try, /*On fail goto*//*Label 17867*/ GIMT_Encode4(1233568), // Rule ID 23131 //
     /* 1233493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233532 */     // MIs[0] round
     /* 1233532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233542 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1233545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233567 */     // GIR_Coverage, 23131,
     /* 1233567 */     GIR_EraseRootFromParent_Done,
     /* 1233568 */   // Label 17867: @1233568
     /* 1233568 */   GIM_Try, /*On fail goto*//*Label 17868*/ GIMT_Encode4(1233648), // Rule ID 23134 //
     /* 1233573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1233590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233612 */     // MIs[0] round
     /* 1233612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233622 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1233625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233647 */     // GIR_Coverage, 23134,
     /* 1233647 */     GIR_EraseRootFromParent_Done,
     /* 1233648 */   // Label 17868: @1233648
     /* 1233648 */   GIM_Try, /*On fail goto*//*Label 17869*/ GIMT_Encode4(1233728), // Rule ID 23135 //
     /* 1233653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1233670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233692 */     // MIs[0] round
     /* 1233692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233702 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1233705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233727 */     // GIR_Coverage, 23135,
     /* 1233727 */     GIR_EraseRootFromParent_Done,
     /* 1233728 */   // Label 17869: @1233728
     /* 1233728 */   GIM_Try, /*On fail goto*//*Label 17870*/ GIMT_Encode4(1233808), // Rule ID 23138 //
     /* 1233733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1233750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233772 */     // MIs[0] round
     /* 1233772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233782 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1233785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233807 */     // GIR_Coverage, 23138,
     /* 1233807 */     GIR_EraseRootFromParent_Done,
     /* 1233808 */   // Label 17870: @1233808
     /* 1233808 */   GIM_Try, /*On fail goto*//*Label 17871*/ GIMT_Encode4(1233888), // Rule ID 23139 //
     /* 1233813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1233830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233852 */     // MIs[0] round
     /* 1233852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233862 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1233865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233887 */     // GIR_Coverage, 23139,
     /* 1233887 */     GIR_EraseRootFromParent_Done,
     /* 1233888 */   // Label 17871: @1233888
     /* 1233888 */   GIM_Try, /*On fail goto*//*Label 17872*/ GIMT_Encode4(1233968), // Rule ID 23142 //
     /* 1233893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1233910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233932 */     // MIs[0] round
     /* 1233932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233942 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1233945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233967 */     // GIR_Coverage, 23142,
     /* 1233967 */     GIR_EraseRootFromParent_Done,
     /* 1233968 */   // Label 17872: @1233968
     /* 1233968 */   GIM_Try, /*On fail goto*//*Label 17873*/ GIMT_Encode4(1234048), // Rule ID 23143 //
     /* 1233973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1233990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234012 */     // MIs[0] round
     /* 1234012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234022 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1234025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234047 */     // GIR_Coverage, 23143,
     /* 1234047 */     GIR_EraseRootFromParent_Done,
     /* 1234048 */   // Label 17873: @1234048
     /* 1234048 */   GIM_Try, /*On fail goto*//*Label 17874*/ GIMT_Encode4(1234128), // Rule ID 23146 //
     /* 1234053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234092 */     // MIs[0] round
     /* 1234092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234102 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1234105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234127 */     // GIR_Coverage, 23146,
     /* 1234127 */     GIR_EraseRootFromParent_Done,
     /* 1234128 */   // Label 17874: @1234128
     /* 1234128 */   GIM_Try, /*On fail goto*//*Label 17875*/ GIMT_Encode4(1234208), // Rule ID 23147 //
     /* 1234133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234172 */     // MIs[0] round
     /* 1234172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234182 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1234185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234207 */     // GIR_Coverage, 23147,
     /* 1234207 */     GIR_EraseRootFromParent_Done,
     /* 1234208 */   // Label 17875: @1234208
     /* 1234208 */   GIM_Try, /*On fail goto*//*Label 17876*/ GIMT_Encode4(1234288), // Rule ID 23150 //
     /* 1234213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234252 */     // MIs[0] round
     /* 1234252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234262 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1234265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234287 */     // GIR_Coverage, 23150,
     /* 1234287 */     GIR_EraseRootFromParent_Done,
     /* 1234288 */   // Label 17876: @1234288
     /* 1234288 */   GIM_Try, /*On fail goto*//*Label 17877*/ GIMT_Encode4(1234368), // Rule ID 23151 //
     /* 1234293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234332 */     // MIs[0] round
     /* 1234332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234342 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1234345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234367 */     // GIR_Coverage, 23151,
     /* 1234367 */     GIR_EraseRootFromParent_Done,
     /* 1234368 */   // Label 17877: @1234368
     /* 1234368 */   GIM_Try, /*On fail goto*//*Label 17878*/ GIMT_Encode4(1234448), // Rule ID 23154 //
     /* 1234373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234412 */     // MIs[0] round
     /* 1234412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234422 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1234425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234447 */     // GIR_Coverage, 23154,
     /* 1234447 */     GIR_EraseRootFromParent_Done,
     /* 1234448 */   // Label 17878: @1234448
     /* 1234448 */   GIM_Try, /*On fail goto*//*Label 17879*/ GIMT_Encode4(1234528), // Rule ID 23155 //
     /* 1234453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234492 */     // MIs[0] round
     /* 1234492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234502 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1234505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234527 */     // GIR_Coverage, 23155,
     /* 1234527 */     GIR_EraseRootFromParent_Done,
     /* 1234528 */   // Label 17879: @1234528
     /* 1234528 */   GIM_Try, /*On fail goto*//*Label 17880*/ GIMT_Encode4(1234608), // Rule ID 64359 //
     /* 1234533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1234536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1234544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1234547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1234550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234572 */     // MIs[0] round
     /* 1234572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234582 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF8),
     /* 1234585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234607 */     // GIR_Coverage, 64359,
     /* 1234607 */     GIR_EraseRootFromParent_Done,
     /* 1234608 */   // Label 17880: @1234608
     /* 1234608 */   GIM_Try, /*On fail goto*//*Label 17881*/ GIMT_Encode4(1234688), // Rule ID 64360 //
     /* 1234613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1234616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1234624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1234627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1234630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234652 */     // MIs[0] round
     /* 1234652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234662 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF8),
     /* 1234665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234687 */     // GIR_Coverage, 64360,
     /* 1234687 */     GIR_EraseRootFromParent_Done,
     /* 1234688 */   // Label 17881: @1234688
     /* 1234688 */   GIM_Try, /*On fail goto*//*Label 17882*/ GIMT_Encode4(1234768), // Rule ID 64363 //
     /* 1234693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1234696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1234704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1234707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1234710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234732 */     // MIs[0] round
     /* 1234732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234742 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF4),
     /* 1234745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234767 */     // GIR_Coverage, 64363,
     /* 1234767 */     GIR_EraseRootFromParent_Done,
     /* 1234768 */   // Label 17882: @1234768
     /* 1234768 */   GIM_Try, /*On fail goto*//*Label 17883*/ GIMT_Encode4(1234848), // Rule ID 64364 //
     /* 1234773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1234776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1234784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1234787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1234790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234812 */     // MIs[0] round
     /* 1234812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234822 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF4),
     /* 1234825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234847 */     // GIR_Coverage, 64364,
     /* 1234847 */     GIR_EraseRootFromParent_Done,
     /* 1234848 */   // Label 17883: @1234848
     /* 1234848 */   GIM_Try, /*On fail goto*//*Label 17884*/ GIMT_Encode4(1234928), // Rule ID 64367 //
     /* 1234853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1234856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1234864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1234867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234892 */     // MIs[0] round
     /* 1234892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234902 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF2),
     /* 1234905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234927 */     // GIR_Coverage, 64367,
     /* 1234927 */     GIR_EraseRootFromParent_Done,
     /* 1234928 */   // Label 17884: @1234928
     /* 1234928 */   GIM_Try, /*On fail goto*//*Label 17885*/ GIMT_Encode4(1235008), // Rule ID 64368 //
     /* 1234933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1234936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1234944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1234947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234972 */     // MIs[0] round
     /* 1234972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234982 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF2),
     /* 1234985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235007 */     // GIR_Coverage, 64368,
     /* 1235007 */     GIR_EraseRootFromParent_Done,
     /* 1235008 */   // Label 17885: @1235008
     /* 1235008 */   GIM_Try, /*On fail goto*//*Label 17886*/ GIMT_Encode4(1235088), // Rule ID 64371 //
     /* 1235013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235052 */     // MIs[0] round
     /* 1235052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235062 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M1),
     /* 1235065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235087 */     // GIR_Coverage, 64371,
     /* 1235087 */     GIR_EraseRootFromParent_Done,
     /* 1235088 */   // Label 17886: @1235088
     /* 1235088 */   GIM_Try, /*On fail goto*//*Label 17887*/ GIMT_Encode4(1235168), // Rule ID 64372 //
     /* 1235093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235132 */     // MIs[0] round
     /* 1235132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235142 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M1),
     /* 1235145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235167 */     // GIR_Coverage, 64372,
     /* 1235167 */     GIR_EraseRootFromParent_Done,
     /* 1235168 */   // Label 17887: @1235168
     /* 1235168 */   GIM_Try, /*On fail goto*//*Label 17888*/ GIMT_Encode4(1235248), // Rule ID 64375 //
     /* 1235173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1235184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1235187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235212 */     // MIs[0] round
     /* 1235212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235222 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M2),
     /* 1235225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235247 */     // GIR_Coverage, 64375,
     /* 1235247 */     GIR_EraseRootFromParent_Done,
     /* 1235248 */   // Label 17888: @1235248
     /* 1235248 */   GIM_Try, /*On fail goto*//*Label 17889*/ GIMT_Encode4(1235328), // Rule ID 64376 //
     /* 1235253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1235264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1235267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235292 */     // MIs[0] round
     /* 1235292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235302 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M2),
     /* 1235305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235327 */     // GIR_Coverage, 64376,
     /* 1235327 */     GIR_EraseRootFromParent_Done,
     /* 1235328 */   // Label 17889: @1235328
     /* 1235328 */   GIM_Try, /*On fail goto*//*Label 17890*/ GIMT_Encode4(1235408), // Rule ID 64379 //
     /* 1235333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235372 */     // MIs[0] round
     /* 1235372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235382 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF8),
     /* 1235385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235407 */     // GIR_Coverage, 64379,
     /* 1235407 */     GIR_EraseRootFromParent_Done,
     /* 1235408 */   // Label 17890: @1235408
     /* 1235408 */   GIM_Try, /*On fail goto*//*Label 17891*/ GIMT_Encode4(1235488), // Rule ID 64380 //
     /* 1235413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235452 */     // MIs[0] round
     /* 1235452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235462 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF8),
     /* 1235465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235487 */     // GIR_Coverage, 64380,
     /* 1235487 */     GIR_EraseRootFromParent_Done,
     /* 1235488 */   // Label 17891: @1235488
     /* 1235488 */   GIM_Try, /*On fail goto*//*Label 17892*/ GIMT_Encode4(1235568), // Rule ID 64383 //
     /* 1235493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235532 */     // MIs[0] round
     /* 1235532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235542 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF4),
     /* 1235545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235567 */     // GIR_Coverage, 64383,
     /* 1235567 */     GIR_EraseRootFromParent_Done,
     /* 1235568 */   // Label 17892: @1235568
     /* 1235568 */   GIM_Try, /*On fail goto*//*Label 17893*/ GIMT_Encode4(1235648), // Rule ID 64384 //
     /* 1235573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235612 */     // MIs[0] round
     /* 1235612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235622 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF4),
     /* 1235625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235647 */     // GIR_Coverage, 64384,
     /* 1235647 */     GIR_EraseRootFromParent_Done,
     /* 1235648 */   // Label 17893: @1235648
     /* 1235648 */   GIM_Try, /*On fail goto*//*Label 17894*/ GIMT_Encode4(1235728), // Rule ID 64387 //
     /* 1235653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1235664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1235667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1235670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235692 */     // MIs[0] round
     /* 1235692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235702 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF2),
     /* 1235705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235727 */     // GIR_Coverage, 64387,
     /* 1235727 */     GIR_EraseRootFromParent_Done,
     /* 1235728 */   // Label 17894: @1235728
     /* 1235728 */   GIM_Try, /*On fail goto*//*Label 17895*/ GIMT_Encode4(1235808), // Rule ID 64388 //
     /* 1235733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1235744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1235747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1235750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235772 */     // MIs[0] round
     /* 1235772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235782 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF2),
     /* 1235785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235807 */     // GIR_Coverage, 64388,
     /* 1235807 */     GIR_EraseRootFromParent_Done,
     /* 1235808 */   // Label 17895: @1235808
     /* 1235808 */   GIM_Try, /*On fail goto*//*Label 17896*/ GIMT_Encode4(1235888), // Rule ID 64391 //
     /* 1235813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235852 */     // MIs[0] round
     /* 1235852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235862 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M1),
     /* 1235865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235887 */     // GIR_Coverage, 64391,
     /* 1235887 */     GIR_EraseRootFromParent_Done,
     /* 1235888 */   // Label 17896: @1235888
     /* 1235888 */   GIM_Try, /*On fail goto*//*Label 17897*/ GIMT_Encode4(1235968), // Rule ID 64392 //
     /* 1235893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235932 */     // MIs[0] round
     /* 1235932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235942 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M1),
     /* 1235945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235967 */     // GIR_Coverage, 64392,
     /* 1235967 */     GIR_EraseRootFromParent_Done,
     /* 1235968 */   // Label 17897: @1235968
     /* 1235968 */   GIM_Try, /*On fail goto*//*Label 17898*/ GIMT_Encode4(1236048), // Rule ID 64395 //
     /* 1235973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1235984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1235987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236012 */     // MIs[0] round
     /* 1236012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236022 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M2),
     /* 1236025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236047 */     // GIR_Coverage, 64395,
     /* 1236047 */     GIR_EraseRootFromParent_Done,
     /* 1236048 */   // Label 17898: @1236048
     /* 1236048 */   GIM_Try, /*On fail goto*//*Label 17899*/ GIMT_Encode4(1236128), // Rule ID 64396 //
     /* 1236053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1236056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1236064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1236067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1236070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236092 */     // MIs[0] round
     /* 1236092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236102 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M2),
     /* 1236105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236127 */     // GIR_Coverage, 64396,
     /* 1236127 */     GIR_EraseRootFromParent_Done,
     /* 1236128 */   // Label 17899: @1236128
     /* 1236128 */   GIM_Try, /*On fail goto*//*Label 17900*/ GIMT_Encode4(1236208), // Rule ID 65129 //
     /* 1236133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1236144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1236147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236172 */     // MIs[0] round
     /* 1236172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236182 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11045:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4),
     /* 1236185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236207 */     // GIR_Coverage, 65129,
     /* 1236207 */     GIR_EraseRootFromParent_Done,
     /* 1236208 */   // Label 17900: @1236208
     /* 1236208 */   GIM_Try, /*On fail goto*//*Label 17901*/ GIMT_Encode4(1236288), // Rule ID 65130 //
     /* 1236213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1236224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1236227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236252 */     // MIs[0] round
     /* 1236252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236262 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11045:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4),
     /* 1236265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236287 */     // GIR_Coverage, 65130,
     /* 1236287 */     GIR_EraseRootFromParent_Done,
     /* 1236288 */   // Label 17901: @1236288
     /* 1236288 */   GIM_Try, /*On fail goto*//*Label 17902*/ GIMT_Encode4(1236368), // Rule ID 65133 //
     /* 1236293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1236304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1236307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1236310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236332 */     // MIs[0] round
     /* 1236332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236342 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11045:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2),
     /* 1236345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236367 */     // GIR_Coverage, 65133,
     /* 1236367 */     GIR_EraseRootFromParent_Done,
     /* 1236368 */   // Label 17902: @1236368
     /* 1236368 */   GIM_Try, /*On fail goto*//*Label 17903*/ GIMT_Encode4(1236448), // Rule ID 65134 //
     /* 1236373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1236384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1236387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1236390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236412 */     // MIs[0] round
     /* 1236412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236422 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11045:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2),
     /* 1236425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236447 */     // GIR_Coverage, 65134,
     /* 1236447 */     GIR_EraseRootFromParent_Done,
     /* 1236448 */   // Label 17903: @1236448
     /* 1236448 */   GIM_Try, /*On fail goto*//*Label 17904*/ GIMT_Encode4(1236528), // Rule ID 65137 //
     /* 1236453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1236464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1236467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1236470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236492 */     // MIs[0] round
     /* 1236492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236502 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11045:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1),
     /* 1236505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236527 */     // GIR_Coverage, 65137,
     /* 1236527 */     GIR_EraseRootFromParent_Done,
     /* 1236528 */   // Label 17904: @1236528
     /* 1236528 */   GIM_Try, /*On fail goto*//*Label 17905*/ GIMT_Encode4(1236608), // Rule ID 65138 //
     /* 1236533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1236544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1236547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1236550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236572 */     // MIs[0] round
     /* 1236572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236582 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11045:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1),
     /* 1236585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236607 */     // GIR_Coverage, 65138,
     /* 1236607 */     GIR_EraseRootFromParent_Done,
     /* 1236608 */   // Label 17905: @1236608
     /* 1236608 */   GIM_Try, /*On fail goto*//*Label 17906*/ GIMT_Encode4(1236688), // Rule ID 65141 //
     /* 1236613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1236624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1236627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1236630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236652 */     // MIs[0] round
     /* 1236652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236662 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11045:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2),
     /* 1236665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236687 */     // GIR_Coverage, 65141,
     /* 1236687 */     GIR_EraseRootFromParent_Done,
     /* 1236688 */   // Label 17906: @1236688
     /* 1236688 */   GIM_Try, /*On fail goto*//*Label 17907*/ GIMT_Encode4(1236768), // Rule ID 65142 //
     /* 1236693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1236704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1236707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1236710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236732 */     // MIs[0] round
     /* 1236732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236742 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11045:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2),
     /* 1236745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236767 */     // GIR_Coverage, 65142,
     /* 1236767 */     GIR_EraseRootFromParent_Done,
     /* 1236768 */   // Label 17907: @1236768
     /* 1236768 */   GIM_Try, /*On fail goto*//*Label 17908*/ GIMT_Encode4(1236848), // Rule ID 65145 //
     /* 1236773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1236784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1236787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1236790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236812 */     // MIs[0] round
     /* 1236812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236822 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11045:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4),
     /* 1236825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236847 */     // GIR_Coverage, 65145,
     /* 1236847 */     GIR_EraseRootFromParent_Done,
     /* 1236848 */   // Label 17908: @1236848
     /* 1236848 */   GIM_Try, /*On fail goto*//*Label 17909*/ GIMT_Encode4(1236928), // Rule ID 65146 //
     /* 1236853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1236864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1236867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1236870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236892 */     // MIs[0] round
     /* 1236892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236902 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11045:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4),
     /* 1236905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236927 */     // GIR_Coverage, 65146,
     /* 1236927 */     GIR_EraseRootFromParent_Done,
     /* 1236928 */   // Label 17909: @1236928
     /* 1236928 */   GIM_Try, /*On fail goto*//*Label 17910*/ GIMT_Encode4(1237008), // Rule ID 65149 //
     /* 1236933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1236944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1236947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1236950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236972 */     // MIs[0] round
     /* 1236972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236982 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11045:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8),
     /* 1236985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237007 */     // GIR_Coverage, 65149,
     /* 1237007 */     GIR_EraseRootFromParent_Done,
     /* 1237008 */   // Label 17910: @1237008
     /* 1237008 */   GIM_Try, /*On fail goto*//*Label 17911*/ GIMT_Encode4(1237088), // Rule ID 65150 //
     /* 1237013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1237024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1237027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237052 */     // MIs[0] round
     /* 1237052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237062 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11045:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8),
     /* 1237065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237087 */     // GIR_Coverage, 65150,
     /* 1237087 */     GIR_EraseRootFromParent_Done,
     /* 1237088 */   // Label 17911: @1237088
     /* 1237088 */   GIM_Try, /*On fail goto*//*Label 17912*/ GIMT_Encode4(1237168), // Rule ID 65153 //
     /* 1237093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1237104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1237107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1237110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237132 */     // MIs[0] round
     /* 1237132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237142 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11043:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4),
     /* 1237145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237167 */     // GIR_Coverage, 65153,
     /* 1237167 */     GIR_EraseRootFromParent_Done,
     /* 1237168 */   // Label 17912: @1237168
     /* 1237168 */   GIM_Try, /*On fail goto*//*Label 17913*/ GIMT_Encode4(1237248), // Rule ID 65154 //
     /* 1237173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1237184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1237187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1237190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237212 */     // MIs[0] round
     /* 1237212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237222 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11043:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4),
     /* 1237225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237247 */     // GIR_Coverage, 65154,
     /* 1237247 */     GIR_EraseRootFromParent_Done,
     /* 1237248 */   // Label 17913: @1237248
     /* 1237248 */   GIM_Try, /*On fail goto*//*Label 17914*/ GIMT_Encode4(1237328), // Rule ID 65157 //
     /* 1237253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1237264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1237267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1237270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237292 */     // MIs[0] round
     /* 1237292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237302 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11043:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2),
     /* 1237305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237327 */     // GIR_Coverage, 65157,
     /* 1237327 */     GIR_EraseRootFromParent_Done,
     /* 1237328 */   // Label 17914: @1237328
     /* 1237328 */   GIM_Try, /*On fail goto*//*Label 17915*/ GIMT_Encode4(1237408), // Rule ID 65158 //
     /* 1237333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1237344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1237347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1237350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237372 */     // MIs[0] round
     /* 1237372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237382 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11043:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2),
     /* 1237385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237407 */     // GIR_Coverage, 65158,
     /* 1237407 */     GIR_EraseRootFromParent_Done,
     /* 1237408 */   // Label 17915: @1237408
     /* 1237408 */   GIM_Try, /*On fail goto*//*Label 17916*/ GIMT_Encode4(1237488), // Rule ID 65161 //
     /* 1237413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1237424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1237427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237452 */     // MIs[0] round
     /* 1237452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237462 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11043:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1),
     /* 1237465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237487 */     // GIR_Coverage, 65161,
     /* 1237487 */     GIR_EraseRootFromParent_Done,
     /* 1237488 */   // Label 17916: @1237488
     /* 1237488 */   GIM_Try, /*On fail goto*//*Label 17917*/ GIMT_Encode4(1237568), // Rule ID 65162 //
     /* 1237493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1237504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1237507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237532 */     // MIs[0] round
     /* 1237532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237542 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11043:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1),
     /* 1237545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237567 */     // GIR_Coverage, 65162,
     /* 1237567 */     GIR_EraseRootFromParent_Done,
     /* 1237568 */   // Label 17917: @1237568
     /* 1237568 */   GIM_Try, /*On fail goto*//*Label 17918*/ GIMT_Encode4(1237648), // Rule ID 65165 //
     /* 1237573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1237584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1237587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1237590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237612 */     // MIs[0] round
     /* 1237612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237622 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11043:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2),
     /* 1237625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237647 */     // GIR_Coverage, 65165,
     /* 1237647 */     GIR_EraseRootFromParent_Done,
     /* 1237648 */   // Label 17918: @1237648
     /* 1237648 */   GIM_Try, /*On fail goto*//*Label 17919*/ GIMT_Encode4(1237728), // Rule ID 65166 //
     /* 1237653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1237664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1237667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1237670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237692 */     // MIs[0] round
     /* 1237692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237702 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11043:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2),
     /* 1237705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237727 */     // GIR_Coverage, 65166,
     /* 1237727 */     GIR_EraseRootFromParent_Done,
     /* 1237728 */   // Label 17919: @1237728
     /* 1237728 */   GIM_Try, /*On fail goto*//*Label 17920*/ GIMT_Encode4(1237808), // Rule ID 65169 //
     /* 1237733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1237744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1237747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1237750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237772 */     // MIs[0] round
     /* 1237772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237782 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11043:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4),
     /* 1237785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237807 */     // GIR_Coverage, 65169,
     /* 1237807 */     GIR_EraseRootFromParent_Done,
     /* 1237808 */   // Label 17920: @1237808
     /* 1237808 */   GIM_Try, /*On fail goto*//*Label 17921*/ GIMT_Encode4(1237888), // Rule ID 65170 //
     /* 1237813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1237824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1237827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1237830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237852 */     // MIs[0] round
     /* 1237852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237862 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11043:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4),
     /* 1237865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237887 */     // GIR_Coverage, 65170,
     /* 1237887 */     GIR_EraseRootFromParent_Done,
     /* 1237888 */   // Label 17921: @1237888
     /* 1237888 */   GIM_Try, /*On fail goto*//*Label 17922*/ GIMT_Encode4(1237968), // Rule ID 65173 //
     /* 1237893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1237904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1237907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237932 */     // MIs[0] round
     /* 1237932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237942 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11043:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8),
     /* 1237945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237967 */     // GIR_Coverage, 65173,
     /* 1237967 */     GIR_EraseRootFromParent_Done,
     /* 1237968 */   // Label 17922: @1237968
     /* 1237968 */   GIM_Try, /*On fail goto*//*Label 17923*/ GIMT_Encode4(1238048), // Rule ID 65174 //
     /* 1237973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1237984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1237987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238012 */     // MIs[0] round
     /* 1238012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238022 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11043:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8),
     /* 1238025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238047 */     // GIR_Coverage, 65174,
     /* 1238047 */     GIR_EraseRootFromParent_Done,
     /* 1238048 */   // Label 17923: @1238048
     /* 1238048 */   GIM_Try, /*On fail goto*//*Label 17924*/ GIMT_Encode4(1238132), // Rule ID 2722 //
     /* 1238053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1238061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238106 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1238109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238131 */     // GIR_Coverage, 2722,
     /* 1238131 */     GIR_EraseRootFromParent_Done,
     /* 1238132 */   // Label 17924: @1238132
     /* 1238132 */   GIM_Try, /*On fail goto*//*Label 17925*/ GIMT_Encode4(1238216), // Rule ID 2723 //
     /* 1238137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1238145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1238193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238215 */     // GIR_Coverage, 2723,
     /* 1238215 */     GIR_EraseRootFromParent_Done,
     /* 1238216 */   // Label 17925: @1238216
     /* 1238216 */   GIM_Try, /*On fail goto*//*Label 17926*/ GIMT_Encode4(1238300), // Rule ID 2734 //
     /* 1238221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1238229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238274 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1238277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1238283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1238285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238299 */     // GIR_Coverage, 2734,
     /* 1238299 */     GIR_EraseRootFromParent_Done,
     /* 1238300 */   // Label 17926: @1238300
     /* 1238300 */   GIM_Try, /*On fail goto*//*Label 17927*/ GIMT_Encode4(1238384), // Rule ID 2735 //
     /* 1238305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1238313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238358 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1238361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1238367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1238369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238383 */     // GIR_Coverage, 2735,
     /* 1238383 */     GIR_EraseRootFromParent_Done,
     /* 1238384 */   // Label 17927: @1238384
     /* 1238384 */   GIM_Try, /*On fail goto*//*Label 17928*/ GIMT_Encode4(1238465), // Rule ID 2736 //
     /* 1238389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1238400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1238403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238442 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1238442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1238445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238464 */     // GIR_Coverage, 2736,
     /* 1238464 */     GIR_EraseRootFromParent_Done,
     /* 1238465 */   // Label 17928: @1238465
     /* 1238465 */   GIM_Try, /*On fail goto*//*Label 17929*/ GIMT_Encode4(1238546), // Rule ID 2737 //
     /* 1238470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1238481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1238484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238523 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1238523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1238526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238545 */     // GIR_Coverage, 2737,
     /* 1238545 */     GIR_EraseRootFromParent_Done,
     /* 1238546 */   // Label 17929: @1238546
     /* 1238546 */   GIM_Try, /*On fail goto*//*Label 17930*/ GIMT_Encode4(1238630), // Rule ID 2786 //
     /* 1238551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1238559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1238562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1238565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1238571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238604 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1238607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1238611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238629 */     // GIR_Coverage, 2786,
     /* 1238629 */     GIR_EraseRootFromParent_Done,
     /* 1238630 */   // Label 17930: @1238630
     /* 1238630 */   GIM_Try, /*On fail goto*//*Label 17931*/ GIMT_Encode4(1238714), // Rule ID 2787 //
     /* 1238635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1238643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1238646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1238649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1238655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238688 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1238691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1238695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238713 */     // GIR_Coverage, 2787,
     /* 1238713 */     GIR_EraseRootFromParent_Done,
     /* 1238714 */   // Label 17931: @1238714
     /* 1238714 */   GIM_Try, /*On fail goto*//*Label 17932*/ GIMT_Encode4(1238795), // Rule ID 5122 //
     /* 1238719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1238730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1238733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1238736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1238739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1238742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238772 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1238772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1238775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238794 */     // GIR_Coverage, 5122,
     /* 1238794 */     GIR_EraseRootFromParent_Done,
     /* 1238795 */   // Label 17932: @1238795
     /* 1238795 */   GIM_Try, /*On fail goto*//*Label 17933*/ GIMT_Encode4(1238876), // Rule ID 5123 //
     /* 1238800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1238811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1238814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1238817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1238820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1238823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238853 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1238853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1238856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238875 */     // GIR_Coverage, 5123,
     /* 1238875 */     GIR_EraseRootFromParent_Done,
     /* 1238876 */   // Label 17933: @1238876
     /* 1238876 */   GIM_Try, /*On fail goto*//*Label 17934*/ GIMT_Encode4(1238957), // Rule ID 5124 //
     /* 1238881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1238892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1238895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1238898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1238901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1238904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238934 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1238934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1238937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238956 */     // GIR_Coverage, 5124,
     /* 1238956 */     GIR_EraseRootFromParent_Done,
     /* 1238957 */   // Label 17934: @1238957
     /* 1238957 */   GIM_Try, /*On fail goto*//*Label 17935*/ GIMT_Encode4(1239038), // Rule ID 5125 //
     /* 1238962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1238973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1238976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1238979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1238982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1238985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239015 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1239015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239037 */     // GIR_Coverage, 5125,
     /* 1239037 */     GIR_EraseRootFromParent_Done,
     /* 1239038 */   // Label 17935: @1239038
     /* 1239038 */   GIM_Try, /*On fail goto*//*Label 17936*/ GIMT_Encode4(1239119), // Rule ID 5126 //
     /* 1239043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1239054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1239057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1239060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1239063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239096 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1239096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1239099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239118 */     // GIR_Coverage, 5126,
     /* 1239118 */     GIR_EraseRootFromParent_Done,
     /* 1239119 */   // Label 17936: @1239119
     /* 1239119 */   GIM_Try, /*On fail goto*//*Label 17937*/ GIMT_Encode4(1239200), // Rule ID 5127 //
     /* 1239124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1239135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1239138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1239141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1239144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239177 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1239177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1239180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239199 */     // GIR_Coverage, 5127,
     /* 1239199 */     GIR_EraseRootFromParent_Done,
     /* 1239200 */   // Label 17937: @1239200
     /* 1239200 */   GIM_Try, /*On fail goto*//*Label 17938*/ GIMT_Encode4(1239281), // Rule ID 5128 //
     /* 1239205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1239216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1239219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1239222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1239225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239258 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1239258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239280 */     // GIR_Coverage, 5128,
     /* 1239280 */     GIR_EraseRootFromParent_Done,
     /* 1239281 */   // Label 17938: @1239281
     /* 1239281 */   GIM_Try, /*On fail goto*//*Label 17939*/ GIMT_Encode4(1239362), // Rule ID 5129 //
     /* 1239286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1239297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1239300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1239303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1239306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239339 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1239339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239361 */     // GIR_Coverage, 5129,
     /* 1239361 */     GIR_EraseRootFromParent_Done,
     /* 1239362 */   // Label 17939: @1239362
     /* 1239362 */   GIM_Try, /*On fail goto*//*Label 17940*/ GIMT_Encode4(1239443), // Rule ID 5130 //
     /* 1239367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1239378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1239381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1239384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1239387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239420 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1239420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239442 */     // GIR_Coverage, 5130,
     /* 1239442 */     GIR_EraseRootFromParent_Done,
     /* 1239443 */   // Label 17940: @1239443
     /* 1239443 */   GIM_Try, /*On fail goto*//*Label 17941*/ GIMT_Encode4(1239524), // Rule ID 5131 //
     /* 1239448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1239459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1239462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1239465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1239468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239501 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1239501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239523 */     // GIR_Coverage, 5131,
     /* 1239523 */     GIR_EraseRootFromParent_Done,
     /* 1239524 */   // Label 17941: @1239524
     /* 1239524 */   GIM_Try, /*On fail goto*//*Label 17942*/ GIMT_Encode4(1239605), // Rule ID 5132 //
     /* 1239529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1239540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1239543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1239546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1239549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1239552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1239582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1239585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239604 */     // GIR_Coverage, 5132,
     /* 1239604 */     GIR_EraseRootFromParent_Done,
     /* 1239605 */   // Label 17942: @1239605
     /* 1239605 */   GIM_Try, /*On fail goto*//*Label 17943*/ GIMT_Encode4(1239686), // Rule ID 5133 //
     /* 1239610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1239621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1239624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1239627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1239630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1239633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239663 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1239663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1239666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239685 */     // GIR_Coverage, 5133,
     /* 1239685 */     GIR_EraseRootFromParent_Done,
     /* 1239686 */   // Label 17943: @1239686
     /* 1239686 */   GIM_Try, /*On fail goto*//*Label 17944*/ GIMT_Encode4(1239767), // Rule ID 5134 //
     /* 1239691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1239702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1239705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1239708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1239711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239744 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1239744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1239747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239766 */     // GIR_Coverage, 5134,
     /* 1239766 */     GIR_EraseRootFromParent_Done,
     /* 1239767 */   // Label 17944: @1239767
     /* 1239767 */   GIM_Try, /*On fail goto*//*Label 17945*/ GIMT_Encode4(1239848), // Rule ID 5135 //
     /* 1239772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1239783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1239786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1239789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1239792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239825 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1239825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1239828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239847 */     // GIR_Coverage, 5135,
     /* 1239847 */     GIR_EraseRootFromParent_Done,
     /* 1239848 */   // Label 17945: @1239848
     /* 1239848 */   GIM_Try, /*On fail goto*//*Label 17946*/ GIMT_Encode4(1239929), // Rule ID 5136 //
     /* 1239853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1239864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1239867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1239870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1239873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1239906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1239909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239928 */     // GIR_Coverage, 5136,
     /* 1239928 */     GIR_EraseRootFromParent_Done,
     /* 1239929 */   // Label 17946: @1239929
     /* 1239929 */   GIM_Try, /*On fail goto*//*Label 17947*/ GIMT_Encode4(1240010), // Rule ID 5137 //
     /* 1239934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1239945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1239948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1239951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1239954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239987 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1239987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1239990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240009 */     // GIR_Coverage, 5137,
     /* 1240009 */     GIR_EraseRootFromParent_Done,
     /* 1240010 */   // Label 17947: @1240010
     /* 1240010 */   GIM_Try, /*On fail goto*//*Label 17948*/ GIMT_Encode4(1240091), // Rule ID 5138 //
     /* 1240015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1240018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1240026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1240029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1240032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1240035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1240068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240090 */     // GIR_Coverage, 5138,
     /* 1240090 */     GIR_EraseRootFromParent_Done,
     /* 1240091 */   // Label 17948: @1240091
     /* 1240091 */   GIM_Try, /*On fail goto*//*Label 17949*/ GIMT_Encode4(1240172), // Rule ID 5139 //
     /* 1240096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1240099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1240107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1240110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1240113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1240116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240149 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1240149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240171 */     // GIR_Coverage, 5139,
     /* 1240171 */     GIR_EraseRootFromParent_Done,
     /* 1240172 */   // Label 17949: @1240172
     /* 1240172 */   GIM_Try, /*On fail goto*//*Label 17950*/ GIMT_Encode4(1240253), // Rule ID 5140 //
     /* 1240177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1240188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1240191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1240194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1240197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1240233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240252 */     // GIR_Coverage, 5140,
     /* 1240252 */     GIR_EraseRootFromParent_Done,
     /* 1240253 */   // Label 17950: @1240253
     /* 1240253 */   GIM_Try, /*On fail goto*//*Label 17951*/ GIMT_Encode4(1240334), // Rule ID 5141 //
     /* 1240258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1240269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1240272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1240275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1240278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240311 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1240314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240333 */     // GIR_Coverage, 5141,
     /* 1240333 */     GIR_EraseRootFromParent_Done,
     /* 1240334 */   // Label 17951: @1240334
     /* 1240334 */   GIM_Try, /*On fail goto*//*Label 17952*/ GIMT_Encode4(1240415), // Rule ID 5142 //
     /* 1240339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1240350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1240353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1240356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1240359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1240362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240392 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1240395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240414 */     // GIR_Coverage, 5142,
     /* 1240414 */     GIR_EraseRootFromParent_Done,
     /* 1240415 */   // Label 17952: @1240415
     /* 1240415 */   GIM_Try, /*On fail goto*//*Label 17953*/ GIMT_Encode4(1240496), // Rule ID 5143 //
     /* 1240420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1240431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1240434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1240437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1240440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1240443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240473 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1240476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240495 */     // GIR_Coverage, 5143,
     /* 1240495 */     GIR_EraseRootFromParent_Done,
     /* 1240496 */   // Label 17953: @1240496
     /* 1240496 */   GIM_Try, /*On fail goto*//*Label 17954*/ GIMT_Encode4(1240577), // Rule ID 5144 //
     /* 1240501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1240512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1240515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1240518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1240521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1240524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1240531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240554 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1240557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240576 */     // GIR_Coverage, 5144,
     /* 1240576 */     GIR_EraseRootFromParent_Done,
     /* 1240577 */   // Label 17954: @1240577
     /* 1240577 */   GIM_Try, /*On fail goto*//*Label 17955*/ GIMT_Encode4(1240658), // Rule ID 5145 //
     /* 1240582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1240593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1240596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1240599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1240602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1240605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1240612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240635 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1240638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240657 */     // GIR_Coverage, 5145,
     /* 1240657 */     GIR_EraseRootFromParent_Done,
     /* 1240658 */   // Label 17955: @1240658
     /* 1240658 */   GIM_Try, /*On fail goto*//*Label 17956*/ GIMT_Encode4(1240739), // Rule ID 5146 //
     /* 1240663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1240674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1240677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1240680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1240683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1240716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1240719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240738 */     // GIR_Coverage, 5146,
     /* 1240738 */     GIR_EraseRootFromParent_Done,
     /* 1240739 */   // Label 17956: @1240739
     /* 1240739 */   GIM_Try, /*On fail goto*//*Label 17957*/ GIMT_Encode4(1240820), // Rule ID 5147 //
     /* 1240744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1240755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1240758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1240761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1240764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240797 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1240797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1240800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240819 */     // GIR_Coverage, 5147,
     /* 1240819 */     GIR_EraseRootFromParent_Done,
     /* 1240820 */   // Label 17957: @1240820
     /* 1240820 */   GIM_Try, /*On fail goto*//*Label 17958*/ GIMT_Encode4(1240901), // Rule ID 5148 //
     /* 1240825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1240836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1240839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1240842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1240845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240878 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1240878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1240881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240900 */     // GIR_Coverage, 5148,
     /* 1240900 */     GIR_EraseRootFromParent_Done,
     /* 1240901 */   // Label 17958: @1240901
     /* 1240901 */   GIM_Try, /*On fail goto*//*Label 17959*/ GIMT_Encode4(1240982), // Rule ID 5149 //
     /* 1240906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1240917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1240920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1240923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1240926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240959 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1240959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1240962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240981 */     // GIR_Coverage, 5149,
     /* 1240981 */     GIR_EraseRootFromParent_Done,
     /* 1240982 */   // Label 17959: @1240982
     /* 1240982 */   GIM_Try, /*On fail goto*//*Label 17960*/ GIMT_Encode4(1241063), // Rule ID 5150 //
     /* 1240987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1240998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1241001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1241004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1241007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1241010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241040 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1241040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241062 */     // GIR_Coverage, 5150,
     /* 1241062 */     GIR_EraseRootFromParent_Done,
     /* 1241063 */   // Label 17960: @1241063
     /* 1241063 */   GIM_Try, /*On fail goto*//*Label 17961*/ GIMT_Encode4(1241144), // Rule ID 5151 //
     /* 1241068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1241079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1241082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1241085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1241088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1241091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241121 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1241121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241143 */     // GIR_Coverage, 5151,
     /* 1241143 */     GIR_EraseRootFromParent_Done,
     /* 1241144 */   // Label 17961: @1241144
     /* 1241144 */   GIM_Try, /*On fail goto*//*Label 17962*/ GIMT_Encode4(1241225), // Rule ID 5152 //
     /* 1241149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1241160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1241163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1241166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1241169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241224 */     // GIR_Coverage, 5152,
     /* 1241224 */     GIR_EraseRootFromParent_Done,
     /* 1241225 */   // Label 17962: @1241225
     /* 1241225 */   GIM_Try, /*On fail goto*//*Label 17963*/ GIMT_Encode4(1241306), // Rule ID 5153 //
     /* 1241230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1241241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1241244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1241247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1241250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241283 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1241283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241305 */     // GIR_Coverage, 5153,
     /* 1241305 */     GIR_EraseRootFromParent_Done,
     /* 1241306 */   // Label 17963: @1241306
     /* 1241306 */   GIM_Try, /*On fail goto*//*Label 17964*/ GIMT_Encode4(1241387), // Rule ID 5154 //
     /* 1241311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1241322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1241325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1241328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1241331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241386 */     // GIR_Coverage, 5154,
     /* 1241386 */     GIR_EraseRootFromParent_Done,
     /* 1241387 */   // Label 17964: @1241387
     /* 1241387 */   GIM_Try, /*On fail goto*//*Label 17965*/ GIMT_Encode4(1241468), // Rule ID 5155 //
     /* 1241392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1241403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1241406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1241409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1241412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241445 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1241445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241467 */     // GIR_Coverage, 5155,
     /* 1241467 */     GIR_EraseRootFromParent_Done,
     /* 1241468 */   // Label 17965: @1241468
     /* 1241468 */   GIM_Try, /*On fail goto*//*Label 17966*/ GIMT_Encode4(1241549), // Rule ID 5156 //
     /* 1241473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1241484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1241487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1241490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1241493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241526 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241548 */     // GIR_Coverage, 5156,
     /* 1241548 */     GIR_EraseRootFromParent_Done,
     /* 1241549 */   // Label 17966: @1241549
     /* 1241549 */   GIM_Try, /*On fail goto*//*Label 17967*/ GIMT_Encode4(1241630), // Rule ID 5157 //
     /* 1241554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1241565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1241568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1241571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1241574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241607 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1241607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241629 */     // GIR_Coverage, 5157,
     /* 1241629 */     GIR_EraseRootFromParent_Done,
     /* 1241630 */   // Label 17967: @1241630
     /* 1241630 */   GIM_Try, /*On fail goto*//*Label 17968*/ GIMT_Encode4(1241711), // Rule ID 5158 //
     /* 1241635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1241638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1241646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1241649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1241652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1241655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1241658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241688 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1241688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1241709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241710 */     // GIR_Coverage, 5158,
     /* 1241710 */     GIR_EraseRootFromParent_Done,
     /* 1241711 */   // Label 17968: @1241711
     /* 1241711 */   GIM_Try, /*On fail goto*//*Label 17969*/ GIMT_Encode4(1241792), // Rule ID 5159 //
     /* 1241716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1241719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1241727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1241730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1241733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1241736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1241739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241769 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1241769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1241790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241791 */     // GIR_Coverage, 5159,
     /* 1241791 */     GIR_EraseRootFromParent_Done,
     /* 1241792 */   // Label 17969: @1241792
     /* 1241792 */   GIM_Try, /*On fail goto*//*Label 17970*/ GIMT_Encode4(1241873), // Rule ID 5160 //
     /* 1241797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1241800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1241808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1241811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1241814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1241817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241850 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1241850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1241871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241872 */     // GIR_Coverage, 5160,
     /* 1241872 */     GIR_EraseRootFromParent_Done,
     /* 1241873 */   // Label 17970: @1241873
     /* 1241873 */   GIM_Try, /*On fail goto*//*Label 17971*/ GIMT_Encode4(1241954), // Rule ID 5161 //
     /* 1241878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1241881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1241889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1241892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1241895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1241898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241931 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1241931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1241952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241953 */     // GIR_Coverage, 5161,
     /* 1241953 */     GIR_EraseRootFromParent_Done,
     /* 1241954 */   // Label 17971: @1241954
     /* 1241954 */   GIM_Try, /*On fail goto*//*Label 17972*/ GIMT_Encode4(1242035), // Rule ID 5162 //
     /* 1241959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1241962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1241970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1241973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1241976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1241979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242012 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1242012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1242015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242034 */     // GIR_Coverage, 5162,
     /* 1242034 */     GIR_EraseRootFromParent_Done,
     /* 1242035 */   // Label 17972: @1242035
     /* 1242035 */   GIM_Try, /*On fail goto*//*Label 17973*/ GIMT_Encode4(1242116), // Rule ID 5163 //
     /* 1242040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1242043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1242051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1242054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1242057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1242060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242093 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1242093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1242096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242115 */     // GIR_Coverage, 5163,
     /* 1242115 */     GIR_EraseRootFromParent_Done,
     /* 1242116 */   // Label 17973: @1242116
     /* 1242116 */   GIM_Try, /*On fail goto*//*Label 17974*/ GIMT_Encode4(1242197), // Rule ID 5164 //
     /* 1242121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1242132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1242135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242174 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1242177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242196 */     // GIR_Coverage, 5164,
     /* 1242196 */     GIR_EraseRootFromParent_Done,
     /* 1242197 */   // Label 17974: @1242197
     /* 1242197 */   GIM_Try, /*On fail goto*//*Label 17975*/ GIMT_Encode4(1242278), // Rule ID 5165 //
     /* 1242202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1242213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1242216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242255 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1242258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242277 */     // GIR_Coverage, 5165,
     /* 1242277 */     GIR_EraseRootFromParent_Done,
     /* 1242278 */   // Label 17975: @1242278
     /* 1242278 */   GIM_Try, /*On fail goto*//*Label 17976*/ GIMT_Encode4(1242359), // Rule ID 5166 //
     /* 1242283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1242294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1242297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1242300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242336 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1242339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242358 */     // GIR_Coverage, 5166,
     /* 1242358 */     GIR_EraseRootFromParent_Done,
     /* 1242359 */   // Label 17976: @1242359
     /* 1242359 */   GIM_Try, /*On fail goto*//*Label 17977*/ GIMT_Encode4(1242440), // Rule ID 5167 //
     /* 1242364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1242375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1242378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1242381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242417 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1242420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242439 */     // GIR_Coverage, 5167,
     /* 1242439 */     GIR_EraseRootFromParent_Done,
     /* 1242440 */   // Label 17977: @1242440
     /* 1242440 */   GIM_Try, /*On fail goto*//*Label 17978*/ GIMT_Encode4(1242521), // Rule ID 5168 //
     /* 1242445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1242456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1242459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1242462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242498 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1242501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242520 */     // GIR_Coverage, 5168,
     /* 1242520 */     GIR_EraseRootFromParent_Done,
     /* 1242521 */   // Label 17978: @1242521
     /* 1242521 */   GIM_Try, /*On fail goto*//*Label 17979*/ GIMT_Encode4(1242602), // Rule ID 5169 //
     /* 1242526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1242537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1242540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1242543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242579 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1242582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242601 */     // GIR_Coverage, 5169,
     /* 1242601 */     GIR_EraseRootFromParent_Done,
     /* 1242602 */   // Label 17979: @1242602
     /* 1242602 */   GIM_Try, /*On fail goto*//*Label 17980*/ GIMT_Encode4(1242683), // Rule ID 5170 //
     /* 1242607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1242618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1242621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1242624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242660 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1242660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1242663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242682 */     // GIR_Coverage, 5170,
     /* 1242682 */     GIR_EraseRootFromParent_Done,
     /* 1242683 */   // Label 17980: @1242683
     /* 1242683 */   GIM_Try, /*On fail goto*//*Label 17981*/ GIMT_Encode4(1242764), // Rule ID 5171 //
     /* 1242688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1242699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1242702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1242705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242741 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1242741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1242744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242763 */     // GIR_Coverage, 5171,
     /* 1242763 */     GIR_EraseRootFromParent_Done,
     /* 1242764 */   // Label 17981: @1242764
     /* 1242764 */   GIM_Try, /*On fail goto*//*Label 17982*/ GIMT_Encode4(1242845), // Rule ID 5172 //
     /* 1242769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1242780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1242783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1242786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242822 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1242822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1242825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242844 */     // GIR_Coverage, 5172,
     /* 1242844 */     GIR_EraseRootFromParent_Done,
     /* 1242845 */   // Label 17982: @1242845
     /* 1242845 */   GIM_Try, /*On fail goto*//*Label 17983*/ GIMT_Encode4(1242926), // Rule ID 5173 //
     /* 1242850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1242861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1242864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1242867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242903 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1242903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1242906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242925 */     // GIR_Coverage, 5173,
     /* 1242925 */     GIR_EraseRootFromParent_Done,
     /* 1242926 */   // Label 17983: @1242926
     /* 1242926 */   GIM_Try, /*On fail goto*//*Label 17984*/ GIMT_Encode4(1243007), // Rule ID 5174 //
     /* 1242931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1242942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1242945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1242948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242984 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1242984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1242987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243006 */     // GIR_Coverage, 5174,
     /* 1243006 */     GIR_EraseRootFromParent_Done,
     /* 1243007 */   // Label 17984: @1243007
     /* 1243007 */   GIM_Try, /*On fail goto*//*Label 17985*/ GIMT_Encode4(1243088), // Rule ID 5175 //
     /* 1243012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1243023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1243026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1243029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243065 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1243065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1243068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243087 */     // GIR_Coverage, 5175,
     /* 1243087 */     GIR_EraseRootFromParent_Done,
     /* 1243088 */   // Label 17985: @1243088
     /* 1243088 */   GIM_Try, /*On fail goto*//*Label 17986*/ GIMT_Encode4(1243169), // Rule ID 5176 //
     /* 1243093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1243104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1243107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1243110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243146 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243168 */     // GIR_Coverage, 5176,
     /* 1243168 */     GIR_EraseRootFromParent_Done,
     /* 1243169 */   // Label 17986: @1243169
     /* 1243169 */   GIM_Try, /*On fail goto*//*Label 17987*/ GIMT_Encode4(1243250), // Rule ID 5177 //
     /* 1243174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1243185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1243188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1243191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243227 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243249 */     // GIR_Coverage, 5177,
     /* 1243249 */     GIR_EraseRootFromParent_Done,
     /* 1243250 */   // Label 17987: @1243250
     /* 1243250 */   GIM_Try, /*On fail goto*//*Label 17988*/ GIMT_Encode4(1243331), // Rule ID 5178 //
     /* 1243255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1243266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1243269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243330 */     // GIR_Coverage, 5178,
     /* 1243330 */     GIR_EraseRootFromParent_Done,
     /* 1243331 */   // Label 17988: @1243331
     /* 1243331 */   GIM_Try, /*On fail goto*//*Label 17989*/ GIMT_Encode4(1243412), // Rule ID 5179 //
     /* 1243336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1243347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1243350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243389 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243411 */     // GIR_Coverage, 5179,
     /* 1243411 */     GIR_EraseRootFromParent_Done,
     /* 1243412 */   // Label 17989: @1243412
     /* 1243412 */   GIM_Try, /*On fail goto*//*Label 17990*/ GIMT_Encode4(1243493), // Rule ID 5180 //
     /* 1243417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1243428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1243431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1243434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243470 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1243470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243492 */     // GIR_Coverage, 5180,
     /* 1243492 */     GIR_EraseRootFromParent_Done,
     /* 1243493 */   // Label 17990: @1243493
     /* 1243493 */   GIM_Try, /*On fail goto*//*Label 17991*/ GIMT_Encode4(1243574), // Rule ID 5181 //
     /* 1243498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1243509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1243512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1243515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243551 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1243551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243573 */     // GIR_Coverage, 5181,
     /* 1243573 */     GIR_EraseRootFromParent_Done,
     /* 1243574 */   // Label 17991: @1243574
     /* 1243574 */   GIM_Try, /*On fail goto*//*Label 17992*/ GIMT_Encode4(1243655), // Rule ID 5182 //
     /* 1243579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1243582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1243590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1243593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1243596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243632 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1243632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243654 */     // GIR_Coverage, 5182,
     /* 1243654 */     GIR_EraseRootFromParent_Done,
     /* 1243655 */   // Label 17992: @1243655
     /* 1243655 */   GIM_Try, /*On fail goto*//*Label 17993*/ GIMT_Encode4(1243736), // Rule ID 5183 //
     /* 1243660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1243663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1243671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1243674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1243677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243713 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1243713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243735 */     // GIR_Coverage, 5183,
     /* 1243735 */     GIR_EraseRootFromParent_Done,
     /* 1243736 */   // Label 17993: @1243736
     /* 1243736 */   GIM_Try, /*On fail goto*//*Label 17994*/ GIMT_Encode4(1243817), // Rule ID 5184 //
     /* 1243741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1243752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1243755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1243758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1243764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1243771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1243775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1243779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243794 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1243797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243816 */     // GIR_Coverage, 5184,
     /* 1243816 */     GIR_EraseRootFromParent_Done,
     /* 1243817 */   // Label 17994: @1243817
     /* 1243817 */   GIM_Try, /*On fail goto*//*Label 17995*/ GIMT_Encode4(1243898), // Rule ID 5185 //
     /* 1243822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1243833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1243836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1243839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1243845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1243852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1243856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1243860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243875 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1243878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243897 */     // GIR_Coverage, 5185,
     /* 1243897 */     GIR_EraseRootFromParent_Done,
     /* 1243898 */   // Label 17995: @1243898
     /* 1243898 */   GIM_Try, /*On fail goto*//*Label 17996*/ GIMT_Encode4(1243979), // Rule ID 5186 //
     /* 1243903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1243914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1243917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1243920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1243926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1243933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1243937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1243941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243956 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1243959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243978 */     // GIR_Coverage, 5186,
     /* 1243978 */     GIR_EraseRootFromParent_Done,
     /* 1243979 */   // Label 17996: @1243979
     /* 1243979 */   GIM_Try, /*On fail goto*//*Label 17997*/ GIMT_Encode4(1244060), // Rule ID 5187 //
     /* 1243984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1243995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1243998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1244001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244037 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244059 */     // GIR_Coverage, 5187,
     /* 1244059 */     GIR_EraseRootFromParent_Done,
     /* 1244060 */   // Label 17997: @1244060
     /* 1244060 */   GIM_Try, /*On fail goto*//*Label 17998*/ GIMT_Encode4(1244141), // Rule ID 5188 //
     /* 1244065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1244076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1244079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1244082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1244088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244118 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1244121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244140 */     // GIR_Coverage, 5188,
     /* 1244140 */     GIR_EraseRootFromParent_Done,
     /* 1244141 */   // Label 17998: @1244141
     /* 1244141 */   GIM_Try, /*On fail goto*//*Label 17999*/ GIMT_Encode4(1244222), // Rule ID 5189 //
     /* 1244146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1244157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1244160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1244163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1244169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244199 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1244202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244221 */     // GIR_Coverage, 5189,
     /* 1244221 */     GIR_EraseRootFromParent_Done,
     /* 1244222 */   // Label 17999: @1244222
     /* 1244222 */   GIM_Try, /*On fail goto*//*Label 18000*/ GIMT_Encode4(1244303), // Rule ID 5190 //
     /* 1244227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1244238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1244241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244280 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244302 */     // GIR_Coverage, 5190,
     /* 1244302 */     GIR_EraseRootFromParent_Done,
     /* 1244303 */   // Label 18000: @1244303
     /* 1244303 */   GIM_Try, /*On fail goto*//*Label 18001*/ GIMT_Encode4(1244384), // Rule ID 5191 //
     /* 1244308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1244319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1244322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244361 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244383 */     // GIR_Coverage, 5191,
     /* 1244383 */     GIR_EraseRootFromParent_Done,
     /* 1244384 */   // Label 18001: @1244384
     /* 1244384 */   GIM_Try, /*On fail goto*//*Label 18002*/ GIMT_Encode4(1244465), // Rule ID 5192 //
     /* 1244389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1244400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1244403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1244406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244442 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244464 */     // GIR_Coverage, 5192,
     /* 1244464 */     GIR_EraseRootFromParent_Done,
     /* 1244465 */   // Label 18002: @1244465
     /* 1244465 */   GIM_Try, /*On fail goto*//*Label 18003*/ GIMT_Encode4(1244546), // Rule ID 5193 //
     /* 1244470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1244481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1244484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1244487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244523 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244545 */     // GIR_Coverage, 5193,
     /* 1244545 */     GIR_EraseRootFromParent_Done,
     /* 1244546 */   // Label 18003: @1244546
     /* 1244546 */   GIM_Try, /*On fail goto*//*Label 18004*/ GIMT_Encode4(1244627), // Rule ID 5194 //
     /* 1244551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1244562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1244565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1244568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244604 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1244607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244626 */     // GIR_Coverage, 5194,
     /* 1244626 */     GIR_EraseRootFromParent_Done,
     /* 1244627 */   // Label 18004: @1244627
     /* 1244627 */   GIM_Try, /*On fail goto*//*Label 18005*/ GIMT_Encode4(1244708), // Rule ID 5195 //
     /* 1244632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1244643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1244646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1244649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244685 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1244688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244707 */     // GIR_Coverage, 5195,
     /* 1244707 */     GIR_EraseRootFromParent_Done,
     /* 1244708 */   // Label 18005: @1244708
     /* 1244708 */   GIM_Try, /*On fail goto*//*Label 18006*/ GIMT_Encode4(1244789), // Rule ID 5196 //
     /* 1244713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1244724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1244727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1244730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1244736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1244766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244788 */     // GIR_Coverage, 5196,
     /* 1244788 */     GIR_EraseRootFromParent_Done,
     /* 1244789 */   // Label 18006: @1244789
     /* 1244789 */   GIM_Try, /*On fail goto*//*Label 18007*/ GIMT_Encode4(1244870), // Rule ID 5197 //
     /* 1244794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1244805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1244808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1244811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1244817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244847 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1244847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244869 */     // GIR_Coverage, 5197,
     /* 1244869 */     GIR_EraseRootFromParent_Done,
     /* 1244870 */   // Label 18007: @1244870
     /* 1244870 */   GIM_Try, /*On fail goto*//*Label 18008*/ GIMT_Encode4(1244951), // Rule ID 5198 //
     /* 1244875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1244886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1244889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1244892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244928 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1244928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244950 */     // GIR_Coverage, 5198,
     /* 1244950 */     GIR_EraseRootFromParent_Done,
     /* 1244951 */   // Label 18008: @1244951
     /* 1244951 */   GIM_Try, /*On fail goto*//*Label 18009*/ GIMT_Encode4(1245032), // Rule ID 5199 //
     /* 1244956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1244967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1244970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1244973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245009 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245031 */     // GIR_Coverage, 5199,
     /* 1245031 */     GIR_EraseRootFromParent_Done,
     /* 1245032 */   // Label 18009: @1245032
     /* 1245032 */   GIM_Try, /*On fail goto*//*Label 18010*/ GIMT_Encode4(1245113), // Rule ID 5200 //
     /* 1245037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1245048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1245051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245090 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245112 */     // GIR_Coverage, 5200,
     /* 1245112 */     GIR_EraseRootFromParent_Done,
     /* 1245113 */   // Label 18010: @1245113
     /* 1245113 */   GIM_Try, /*On fail goto*//*Label 18011*/ GIMT_Encode4(1245194), // Rule ID 5201 //
     /* 1245118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1245129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1245132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245171 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245193 */     // GIR_Coverage, 5201,
     /* 1245193 */     GIR_EraseRootFromParent_Done,
     /* 1245194 */   // Label 18011: @1245194
     /* 1245194 */   GIM_Try, /*On fail goto*//*Label 18012*/ GIMT_Encode4(1245275), // Rule ID 5202 //
     /* 1245199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1245210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1245213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1245255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245274 */     // GIR_Coverage, 5202,
     /* 1245274 */     GIR_EraseRootFromParent_Done,
     /* 1245275 */   // Label 18012: @1245275
     /* 1245275 */   GIM_Try, /*On fail goto*//*Label 18013*/ GIMT_Encode4(1245356), // Rule ID 5203 //
     /* 1245280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1245291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1245294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245333 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1245336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245355 */     // GIR_Coverage, 5203,
     /* 1245355 */     GIR_EraseRootFromParent_Done,
     /* 1245356 */   // Label 18013: @1245356
     /* 1245356 */   GIM_Try, /*On fail goto*//*Label 18014*/ GIMT_Encode4(1245437), // Rule ID 5204 //
     /* 1245361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1245372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1245375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245414 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245436 */     // GIR_Coverage, 5204,
     /* 1245436 */     GIR_EraseRootFromParent_Done,
     /* 1245437 */   // Label 18014: @1245437
     /* 1245437 */   GIM_Try, /*On fail goto*//*Label 18015*/ GIMT_Encode4(1245518), // Rule ID 5205 //
     /* 1245442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1245453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1245456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245495 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245517 */     // GIR_Coverage, 5205,
     /* 1245517 */     GIR_EraseRootFromParent_Done,
     /* 1245518 */   // Label 18015: @1245518
     /* 1245518 */   GIM_Try, /*On fail goto*//*Label 18016*/ GIMT_Encode4(1245599), // Rule ID 5206 //
     /* 1245523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1245534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1245537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1245540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245576 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245598 */     // GIR_Coverage, 5206,
     /* 1245598 */     GIR_EraseRootFromParent_Done,
     /* 1245599 */   // Label 18016: @1245599
     /* 1245599 */   GIM_Try, /*On fail goto*//*Label 18017*/ GIMT_Encode4(1245680), // Rule ID 5207 //
     /* 1245604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1245615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1245618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1245621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245657 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245679 */     // GIR_Coverage, 5207,
     /* 1245679 */     GIR_EraseRootFromParent_Done,
     /* 1245680 */   // Label 18017: @1245680
     /* 1245680 */   GIM_Try, /*On fail goto*//*Label 18018*/ GIMT_Encode4(1245761), // Rule ID 5512 //
     /* 1245685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1245696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1245699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1245702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1245705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1245708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1245715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245738 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1245738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1245741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1245759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245760 */     // GIR_Coverage, 5512,
     /* 1245760 */     GIR_EraseRootFromParent_Done,
     /* 1245761 */   // Label 18018: @1245761
     /* 1245761 */   GIM_Try, /*On fail goto*//*Label 18019*/ GIMT_Encode4(1245842), // Rule ID 5513 //
     /* 1245766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1245777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1245780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1245783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1245786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1245789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1245796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245819 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1245819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1245822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1245840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245841 */     // GIR_Coverage, 5513,
     /* 1245841 */     GIR_EraseRootFromParent_Done,
     /* 1245842 */   // Label 18019: @1245842
     /* 1245842 */   GIM_Try, /*On fail goto*//*Label 18020*/ GIMT_Encode4(1245923), // Rule ID 5514 //
     /* 1245847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1245858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1245861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1245864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1245867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1245877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245900 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1245900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1245903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1245921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245922 */     // GIR_Coverage, 5514,
     /* 1245922 */     GIR_EraseRootFromParent_Done,
     /* 1245923 */   // Label 18020: @1245923
     /* 1245923 */   GIM_Try, /*On fail goto*//*Label 18021*/ GIMT_Encode4(1246004), // Rule ID 5515 //
     /* 1245928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1245939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1245942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1245945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1245948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1245958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245981 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1245981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1245984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246003 */     // GIR_Coverage, 5515,
     /* 1246003 */     GIR_EraseRootFromParent_Done,
     /* 1246004 */   // Label 18021: @1246004
     /* 1246004 */   GIM_Try, /*On fail goto*//*Label 18022*/ GIMT_Encode4(1246085), // Rule ID 5516 //
     /* 1246009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1246020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1246023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1246026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1246029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246062 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246084 */     // GIR_Coverage, 5516,
     /* 1246084 */     GIR_EraseRootFromParent_Done,
     /* 1246085 */   // Label 18022: @1246085
     /* 1246085 */   GIM_Try, /*On fail goto*//*Label 18023*/ GIMT_Encode4(1246166), // Rule ID 5517 //
     /* 1246090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1246101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1246104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1246107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1246110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246143 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1246143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246165 */     // GIR_Coverage, 5517,
     /* 1246165 */     GIR_EraseRootFromParent_Done,
     /* 1246166 */   // Label 18023: @1246166
     /* 1246166 */   GIM_Try, /*On fail goto*//*Label 18024*/ GIMT_Encode4(1246247), // Rule ID 5518 //
     /* 1246171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1246182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1246185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1246188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1246191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246224 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1246224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1246227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246246 */     // GIR_Coverage, 5518,
     /* 1246246 */     GIR_EraseRootFromParent_Done,
     /* 1246247 */   // Label 18024: @1246247
     /* 1246247 */   GIM_Try, /*On fail goto*//*Label 18025*/ GIMT_Encode4(1246328), // Rule ID 5519 //
     /* 1246252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1246263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1246266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1246269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1246272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246305 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1246305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1246308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246327 */     // GIR_Coverage, 5519,
     /* 1246327 */     GIR_EraseRootFromParent_Done,
     /* 1246328 */   // Label 18025: @1246328
     /* 1246328 */   GIM_Try, /*On fail goto*//*Label 18026*/ GIMT_Encode4(1246409), // Rule ID 5520 //
     /* 1246333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1246344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1246347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1246350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1246353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246386 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1246386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246408 */     // GIR_Coverage, 5520,
     /* 1246408 */     GIR_EraseRootFromParent_Done,
     /* 1246409 */   // Label 18026: @1246409
     /* 1246409 */   GIM_Try, /*On fail goto*//*Label 18027*/ GIMT_Encode4(1246490), // Rule ID 5521 //
     /* 1246414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1246425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1246428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1246431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1246434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246467 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1246467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246489 */     // GIR_Coverage, 5521,
     /* 1246489 */     GIR_EraseRootFromParent_Done,
     /* 1246490 */   // Label 18027: @1246490
     /* 1246490 */   GIM_Try, /*On fail goto*//*Label 18028*/ GIMT_Encode4(1246571), // Rule ID 5522 //
     /* 1246495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1246506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1246509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1246512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1246515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246548 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1246548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246570 */     // GIR_Coverage, 5522,
     /* 1246570 */     GIR_EraseRootFromParent_Done,
     /* 1246571 */   // Label 18028: @1246571
     /* 1246571 */   GIM_Try, /*On fail goto*//*Label 18029*/ GIMT_Encode4(1246652), // Rule ID 5523 //
     /* 1246576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1246587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1246590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1246593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1246596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246629 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1246629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246651 */     // GIR_Coverage, 5523,
     /* 1246651 */     GIR_EraseRootFromParent_Done,
     /* 1246652 */   // Label 18029: @1246652
     /* 1246652 */   GIM_Try, /*On fail goto*//*Label 18030*/ GIMT_Encode4(1246733), // Rule ID 5524 //
     /* 1246657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1246668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1246671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1246674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1246677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246710 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1246713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246732 */     // GIR_Coverage, 5524,
     /* 1246732 */     GIR_EraseRootFromParent_Done,
     /* 1246733 */   // Label 18030: @1246733
     /* 1246733 */   GIM_Try, /*On fail goto*//*Label 18031*/ GIMT_Encode4(1246814), // Rule ID 5525 //
     /* 1246738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1246749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1246752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1246755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1246758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246791 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1246791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1246794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246813 */     // GIR_Coverage, 5525,
     /* 1246813 */     GIR_EraseRootFromParent_Done,
     /* 1246814 */   // Label 18031: @1246814
     /* 1246814 */   GIM_Try, /*On fail goto*//*Label 18032*/ GIMT_Encode4(1246895), // Rule ID 5526 //
     /* 1246819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1246830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1246833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1246836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1246839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246872 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1246872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1246875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246894 */     // GIR_Coverage, 5526,
     /* 1246894 */     GIR_EraseRootFromParent_Done,
     /* 1246895 */   // Label 18032: @1246895
     /* 1246895 */   GIM_Try, /*On fail goto*//*Label 18033*/ GIMT_Encode4(1246976), // Rule ID 5527 //
     /* 1246900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1246911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1246914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1246917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1246920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246953 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1246953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1246956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246975 */     // GIR_Coverage, 5527,
     /* 1246975 */     GIR_EraseRootFromParent_Done,
     /* 1246976 */   // Label 18033: @1246976
     /* 1246976 */   GIM_Try, /*On fail goto*//*Label 18034*/ GIMT_Encode4(1247057), // Rule ID 5528 //
     /* 1246981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1246992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1246995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1246998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1247001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247034 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1247034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247056 */     // GIR_Coverage, 5528,
     /* 1247056 */     GIR_EraseRootFromParent_Done,
     /* 1247057 */   // Label 18034: @1247057
     /* 1247057 */   GIM_Try, /*On fail goto*//*Label 18035*/ GIMT_Encode4(1247138), // Rule ID 5529 //
     /* 1247062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1247073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1247076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1247079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1247082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247115 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1247115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247137 */     // GIR_Coverage, 5529,
     /* 1247137 */     GIR_EraseRootFromParent_Done,
     /* 1247138 */   // Label 18035: @1247138
     /* 1247138 */   GIM_Try, /*On fail goto*//*Label 18036*/ GIMT_Encode4(1247219), // Rule ID 5530 //
     /* 1247143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1247146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1247154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1247157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1247160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1247163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247196 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1247196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247218 */     // GIR_Coverage, 5530,
     /* 1247218 */     GIR_EraseRootFromParent_Done,
     /* 1247219 */   // Label 18036: @1247219
     /* 1247219 */   GIM_Try, /*On fail goto*//*Label 18037*/ GIMT_Encode4(1247300), // Rule ID 5531 //
     /* 1247224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1247227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1247235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1247238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1247241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1247244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247277 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1247277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247299 */     // GIR_Coverage, 5531,
     /* 1247299 */     GIR_EraseRootFromParent_Done,
     /* 1247300 */   // Label 18037: @1247300
     /* 1247300 */   GIM_Try, /*On fail goto*//*Label 18038*/ GIMT_Encode4(1247381), // Rule ID 5532 //
     /* 1247305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1247316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1247319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1247322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1247325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247358 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1247361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247380 */     // GIR_Coverage, 5532,
     /* 1247380 */     GIR_EraseRootFromParent_Done,
     /* 1247381 */   // Label 18038: @1247381
     /* 1247381 */   GIM_Try, /*On fail goto*//*Label 18039*/ GIMT_Encode4(1247462), // Rule ID 5533 //
     /* 1247386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1247397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1247400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1247403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1247406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247439 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1247442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247461 */     // GIR_Coverage, 5533,
     /* 1247461 */     GIR_EraseRootFromParent_Done,
     /* 1247462 */   // Label 18039: @1247462
     /* 1247462 */   GIM_Try, /*On fail goto*//*Label 18040*/ GIMT_Encode4(1247543), // Rule ID 5534 //
     /* 1247467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1247478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1247481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1247484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1247487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1247490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1247497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247520 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1247523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247542 */     // GIR_Coverage, 5534,
     /* 1247542 */     GIR_EraseRootFromParent_Done,
     /* 1247543 */   // Label 18040: @1247543
     /* 1247543 */   GIM_Try, /*On fail goto*//*Label 18041*/ GIMT_Encode4(1247624), // Rule ID 5535 //
     /* 1247548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1247559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1247562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1247565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1247568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1247571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1247578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247601 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1247604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247623 */     // GIR_Coverage, 5535,
     /* 1247623 */     GIR_EraseRootFromParent_Done,
     /* 1247624 */   // Label 18041: @1247624
     /* 1247624 */   GIM_Try, /*On fail goto*//*Label 18042*/ GIMT_Encode4(1247705), // Rule ID 5536 //
     /* 1247629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1247640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1247643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1247646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1247649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1247652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1247659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247682 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1247685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247704 */     // GIR_Coverage, 5536,
     /* 1247704 */     GIR_EraseRootFromParent_Done,
     /* 1247705 */   // Label 18042: @1247705
     /* 1247705 */   GIM_Try, /*On fail goto*//*Label 18043*/ GIMT_Encode4(1247786), // Rule ID 5537 //
     /* 1247710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1247721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1247724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1247727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1247730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1247733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1247740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247763 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1247766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247785 */     // GIR_Coverage, 5537,
     /* 1247785 */     GIR_EraseRootFromParent_Done,
     /* 1247786 */   // Label 18043: @1247786
     /* 1247786 */   GIM_Try, /*On fail goto*//*Label 18044*/ GIMT_Encode4(1247867), // Rule ID 5538 //
     /* 1247791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1247802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1247805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1247808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1247811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247844 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1247844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1247847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247866 */     // GIR_Coverage, 5538,
     /* 1247866 */     GIR_EraseRootFromParent_Done,
     /* 1247867 */   // Label 18044: @1247867
     /* 1247867 */   GIM_Try, /*On fail goto*//*Label 18045*/ GIMT_Encode4(1247948), // Rule ID 5539 //
     /* 1247872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1247883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1247886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1247889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1247892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247925 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1247925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1247928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247947 */     // GIR_Coverage, 5539,
     /* 1247947 */     GIR_EraseRootFromParent_Done,
     /* 1247948 */   // Label 18045: @1247948
     /* 1247948 */   GIM_Try, /*On fail goto*//*Label 18046*/ GIMT_Encode4(1248029), // Rule ID 5540 //
     /* 1247953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1247964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1247967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1247970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1247973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1247983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248006 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1248006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248028 */     // GIR_Coverage, 5540,
     /* 1248028 */     GIR_EraseRootFromParent_Done,
     /* 1248029 */   // Label 18046: @1248029
     /* 1248029 */   GIM_Try, /*On fail goto*//*Label 18047*/ GIMT_Encode4(1248110), // Rule ID 5541 //
     /* 1248034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1248045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1248048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1248051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1248054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248087 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248109 */     // GIR_Coverage, 5541,
     /* 1248109 */     GIR_EraseRootFromParent_Done,
     /* 1248110 */   // Label 18047: @1248110
     /* 1248110 */   GIM_Try, /*On fail goto*//*Label 18048*/ GIMT_Encode4(1248191), // Rule ID 5542 //
     /* 1248115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1248126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1248129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1248132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1248135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248168 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1248168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248190 */     // GIR_Coverage, 5542,
     /* 1248190 */     GIR_EraseRootFromParent_Done,
     /* 1248191 */   // Label 18048: @1248191
     /* 1248191 */   GIM_Try, /*On fail goto*//*Label 18049*/ GIMT_Encode4(1248272), // Rule ID 5543 //
     /* 1248196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1248207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1248210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1248213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1248216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248249 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248271 */     // GIR_Coverage, 5543,
     /* 1248271 */     GIR_EraseRootFromParent_Done,
     /* 1248272 */   // Label 18049: @1248272
     /* 1248272 */   GIM_Try, /*On fail goto*//*Label 18050*/ GIMT_Encode4(1248353), // Rule ID 5544 //
     /* 1248277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1248288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1248291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1248294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1248297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248352 */     // GIR_Coverage, 5544,
     /* 1248352 */     GIR_EraseRootFromParent_Done,
     /* 1248353 */   // Label 18050: @1248353
     /* 1248353 */   GIM_Try, /*On fail goto*//*Label 18051*/ GIMT_Encode4(1248434), // Rule ID 5545 //
     /* 1248358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1248369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1248372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1248375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1248378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248411 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1248411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248433 */     // GIR_Coverage, 5545,
     /* 1248433 */     GIR_EraseRootFromParent_Done,
     /* 1248434 */   // Label 18051: @1248434
     /* 1248434 */   GIM_Try, /*On fail goto*//*Label 18052*/ GIMT_Encode4(1248515), // Rule ID 5546 //
     /* 1248439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1248450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1248453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1248456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1248459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248492 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248514 */     // GIR_Coverage, 5546,
     /* 1248514 */     GIR_EraseRootFromParent_Done,
     /* 1248515 */   // Label 18052: @1248515
     /* 1248515 */   GIM_Try, /*On fail goto*//*Label 18053*/ GIMT_Encode4(1248596), // Rule ID 5547 //
     /* 1248520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1248531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1248534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1248537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1248540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248573 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1248573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248595 */     // GIR_Coverage, 5547,
     /* 1248595 */     GIR_EraseRootFromParent_Done,
     /* 1248596 */   // Label 18053: @1248596
     /* 1248596 */   GIM_Try, /*On fail goto*//*Label 18054*/ GIMT_Encode4(1248677), // Rule ID 5548 //
     /* 1248601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1248612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1248615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1248618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1248621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248654 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248676 */     // GIR_Coverage, 5548,
     /* 1248676 */     GIR_EraseRootFromParent_Done,
     /* 1248677 */   // Label 18054: @1248677
     /* 1248677 */   GIM_Try, /*On fail goto*//*Label 18055*/ GIMT_Encode4(1248758), // Rule ID 5549 //
     /* 1248682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1248693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1248696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1248699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1248702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248735 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1248735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248757 */     // GIR_Coverage, 5549,
     /* 1248757 */     GIR_EraseRootFromParent_Done,
     /* 1248758 */   // Label 18055: @1248758
     /* 1248758 */   GIM_Try, /*On fail goto*//*Label 18056*/ GIMT_Encode4(1248839), // Rule ID 5550 //
     /* 1248763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1248766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1248774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1248777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1248780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1248783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1248786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1248816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1248837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248838 */     // GIR_Coverage, 5550,
     /* 1248838 */     GIR_EraseRootFromParent_Done,
     /* 1248839 */   // Label 18056: @1248839
     /* 1248839 */   GIM_Try, /*On fail goto*//*Label 18057*/ GIMT_Encode4(1248920), // Rule ID 5551 //
     /* 1248844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1248847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1248855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1248858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1248861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1248864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1248867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248897 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1248897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1248918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248919 */     // GIR_Coverage, 5551,
     /* 1248919 */     GIR_EraseRootFromParent_Done,
     /* 1248920 */   // Label 18057: @1248920
     /* 1248920 */   GIM_Try, /*On fail goto*//*Label 18058*/ GIMT_Encode4(1249001), // Rule ID 5552 //
     /* 1248925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1248928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1248936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1248939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1248942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1248945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248978 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1248978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1248999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249000 */     // GIR_Coverage, 5552,
     /* 1249000 */     GIR_EraseRootFromParent_Done,
     /* 1249001 */   // Label 18058: @1249001
     /* 1249001 */   GIM_Try, /*On fail goto*//*Label 18059*/ GIMT_Encode4(1249082), // Rule ID 5553 //
     /* 1249006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1249017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1249020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1249023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1249026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249059 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1249059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1249062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249081 */     // GIR_Coverage, 5553,
     /* 1249081 */     GIR_EraseRootFromParent_Done,
     /* 1249082 */   // Label 18059: @1249082
     /* 1249082 */   GIM_Try, /*On fail goto*//*Label 18060*/ GIMT_Encode4(1249163), // Rule ID 5554 //
     /* 1249087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1249098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1249101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1249104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1249107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249140 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1249140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1249143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249162 */     // GIR_Coverage, 5554,
     /* 1249162 */     GIR_EraseRootFromParent_Done,
     /* 1249163 */   // Label 18060: @1249163
     /* 1249163 */   GIM_Try, /*On fail goto*//*Label 18061*/ GIMT_Encode4(1249244), // Rule ID 5555 //
     /* 1249168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1249179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1249182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1249185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1249188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249221 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1249221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1249224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249243 */     // GIR_Coverage, 5555,
     /* 1249243 */     GIR_EraseRootFromParent_Done,
     /* 1249244 */   // Label 18061: @1249244
     /* 1249244 */   GIM_Try, /*On fail goto*//*Label 18062*/ GIMT_Encode4(1249325), // Rule ID 5556 //
     /* 1249249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1249260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1249263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1249266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249302 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1249305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249324 */     // GIR_Coverage, 5556,
     /* 1249324 */     GIR_EraseRootFromParent_Done,
     /* 1249325 */   // Label 18062: @1249325
     /* 1249325 */   GIM_Try, /*On fail goto*//*Label 18063*/ GIMT_Encode4(1249406), // Rule ID 5557 //
     /* 1249330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1249341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1249344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1249347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249383 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1249383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1249386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249405 */     // GIR_Coverage, 5557,
     /* 1249405 */     GIR_EraseRootFromParent_Done,
     /* 1249406 */   // Label 18063: @1249406
     /* 1249406 */   GIM_Try, /*On fail goto*//*Label 18064*/ GIMT_Encode4(1249487), // Rule ID 5558 //
     /* 1249411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1249422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1249425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1249428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249464 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1249467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249486 */     // GIR_Coverage, 5558,
     /* 1249486 */     GIR_EraseRootFromParent_Done,
     /* 1249487 */   // Label 18064: @1249487
     /* 1249487 */   GIM_Try, /*On fail goto*//*Label 18065*/ GIMT_Encode4(1249568), // Rule ID 5559 //
     /* 1249492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1249503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1249506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1249509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249545 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1249545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1249548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249567 */     // GIR_Coverage, 5559,
     /* 1249567 */     GIR_EraseRootFromParent_Done,
     /* 1249568 */   // Label 18065: @1249568
     /* 1249568 */   GIM_Try, /*On fail goto*//*Label 18066*/ GIMT_Encode4(1249649), // Rule ID 5560 //
     /* 1249573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1249584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1249587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1249590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249626 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1249629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249648 */     // GIR_Coverage, 5560,
     /* 1249648 */     GIR_EraseRootFromParent_Done,
     /* 1249649 */   // Label 18066: @1249649
     /* 1249649 */   GIM_Try, /*On fail goto*//*Label 18067*/ GIMT_Encode4(1249730), // Rule ID 5561 //
     /* 1249654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1249665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1249668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1249671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249707 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1249707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1249710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249729 */     // GIR_Coverage, 5561,
     /* 1249729 */     GIR_EraseRootFromParent_Done,
     /* 1249730 */   // Label 18067: @1249730
     /* 1249730 */   GIM_Try, /*On fail goto*//*Label 18068*/ GIMT_Encode4(1249811), // Rule ID 5562 //
     /* 1249735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1249746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1249749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1249752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249788 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1249788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1249791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249810 */     // GIR_Coverage, 5562,
     /* 1249810 */     GIR_EraseRootFromParent_Done,
     /* 1249811 */   // Label 18068: @1249811
     /* 1249811 */   GIM_Try, /*On fail goto*//*Label 18069*/ GIMT_Encode4(1249892), // Rule ID 5563 //
     /* 1249816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1249827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1249830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1249833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249869 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1249869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1249872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249891 */     // GIR_Coverage, 5563,
     /* 1249891 */     GIR_EraseRootFromParent_Done,
     /* 1249892 */   // Label 18069: @1249892
     /* 1249892 */   GIM_Try, /*On fail goto*//*Label 18070*/ GIMT_Encode4(1249973), // Rule ID 5564 //
     /* 1249897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1249908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1249911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1249914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249950 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1249950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1249953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249972 */     // GIR_Coverage, 5564,
     /* 1249972 */     GIR_EraseRootFromParent_Done,
     /* 1249973 */   // Label 18070: @1249973
     /* 1249973 */   GIM_Try, /*On fail goto*//*Label 18071*/ GIMT_Encode4(1250054), // Rule ID 5565 //
     /* 1249978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1249989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1249992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1249995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250031 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1250031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250053 */     // GIR_Coverage, 5565,
     /* 1250053 */     GIR_EraseRootFromParent_Done,
     /* 1250054 */   // Label 18071: @1250054
     /* 1250054 */   GIM_Try, /*On fail goto*//*Label 18072*/ GIMT_Encode4(1250135), // Rule ID 5566 //
     /* 1250059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1250070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1250073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1250076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250112 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1250112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250134 */     // GIR_Coverage, 5566,
     /* 1250134 */     GIR_EraseRootFromParent_Done,
     /* 1250135 */   // Label 18072: @1250135
     /* 1250135 */   GIM_Try, /*On fail goto*//*Label 18073*/ GIMT_Encode4(1250216), // Rule ID 5567 //
     /* 1250140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1250151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1250154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1250157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250193 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1250193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250215 */     // GIR_Coverage, 5567,
     /* 1250215 */     GIR_EraseRootFromParent_Done,
     /* 1250216 */   // Label 18073: @1250216
     /* 1250216 */   GIM_Try, /*On fail goto*//*Label 18074*/ GIMT_Encode4(1250297), // Rule ID 5568 //
     /* 1250221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1250232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1250235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1250238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250274 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1250274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250296 */     // GIR_Coverage, 5568,
     /* 1250296 */     GIR_EraseRootFromParent_Done,
     /* 1250297 */   // Label 18074: @1250297
     /* 1250297 */   GIM_Try, /*On fail goto*//*Label 18075*/ GIMT_Encode4(1250378), // Rule ID 5569 //
     /* 1250302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1250313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1250316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1250319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250355 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1250355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250377 */     // GIR_Coverage, 5569,
     /* 1250377 */     GIR_EraseRootFromParent_Done,
     /* 1250378 */   // Label 18075: @1250378
     /* 1250378 */   GIM_Try, /*On fail goto*//*Label 18076*/ GIMT_Encode4(1250459), // Rule ID 5570 //
     /* 1250383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1250394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1250397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1250400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250436 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1250436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250458 */     // GIR_Coverage, 5570,
     /* 1250458 */     GIR_EraseRootFromParent_Done,
     /* 1250459 */   // Label 18076: @1250459
     /* 1250459 */   GIM_Try, /*On fail goto*//*Label 18077*/ GIMT_Encode4(1250540), // Rule ID 5571 //
     /* 1250464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1250475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1250478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1250481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250517 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1250517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250539 */     // GIR_Coverage, 5571,
     /* 1250539 */     GIR_EraseRootFromParent_Done,
     /* 1250540 */   // Label 18077: @1250540
     /* 1250540 */   GIM_Try, /*On fail goto*//*Label 18078*/ GIMT_Encode4(1250621), // Rule ID 5572 //
     /* 1250545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1250556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1250559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1250562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250598 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1250598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250620 */     // GIR_Coverage, 5572,
     /* 1250620 */     GIR_EraseRootFromParent_Done,
     /* 1250621 */   // Label 18078: @1250621
     /* 1250621 */   GIM_Try, /*On fail goto*//*Label 18079*/ GIMT_Encode4(1250702), // Rule ID 5573 //
     /* 1250626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1250637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1250640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1250643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250679 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1250679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250701 */     // GIR_Coverage, 5573,
     /* 1250701 */     GIR_EraseRootFromParent_Done,
     /* 1250702 */   // Label 18079: @1250702
     /* 1250702 */   GIM_Try, /*On fail goto*//*Label 18080*/ GIMT_Encode4(1250783), // Rule ID 5574 //
     /* 1250707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1250710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1250718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1250721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1250724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1250760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250782 */     // GIR_Coverage, 5574,
     /* 1250782 */     GIR_EraseRootFromParent_Done,
     /* 1250783 */   // Label 18080: @1250783
     /* 1250783 */   GIM_Try, /*On fail goto*//*Label 18081*/ GIMT_Encode4(1250864), // Rule ID 5575 //
     /* 1250788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1250791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1250799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1250802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1250805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250841 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1250841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250863 */     // GIR_Coverage, 5575,
     /* 1250863 */     GIR_EraseRootFromParent_Done,
     /* 1250864 */   // Label 18081: @1250864
     /* 1250864 */   GIM_Try, /*On fail goto*//*Label 18082*/ GIMT_Encode4(1250945), // Rule ID 5576 //
     /* 1250869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1250880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1250883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1250886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1250892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1250899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250922 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1250922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1250925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250944 */     // GIR_Coverage, 5576,
     /* 1250944 */     GIR_EraseRootFromParent_Done,
     /* 1250945 */   // Label 18082: @1250945
     /* 1250945 */   GIM_Try, /*On fail goto*//*Label 18083*/ GIMT_Encode4(1251026), // Rule ID 5577 //
     /* 1250950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1250961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1250964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1250967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1250973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1250980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251003 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251025 */     // GIR_Coverage, 5577,
     /* 1251025 */     GIR_EraseRootFromParent_Done,
     /* 1251026 */   // Label 18083: @1251026
     /* 1251026 */   GIM_Try, /*On fail goto*//*Label 18084*/ GIMT_Encode4(1251107), // Rule ID 5578 //
     /* 1251031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1251042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1251045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1251048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251084 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1251084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1251087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251106 */     // GIR_Coverage, 5578,
     /* 1251106 */     GIR_EraseRootFromParent_Done,
     /* 1251107 */   // Label 18084: @1251107
     /* 1251107 */   GIM_Try, /*On fail goto*//*Label 18085*/ GIMT_Encode4(1251188), // Rule ID 5579 //
     /* 1251112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1251123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1251126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1251129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251165 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1251168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251187 */     // GIR_Coverage, 5579,
     /* 1251187 */     GIR_EraseRootFromParent_Done,
     /* 1251188 */   // Label 18085: @1251188
     /* 1251188 */   GIM_Try, /*On fail goto*//*Label 18086*/ GIMT_Encode4(1251269), // Rule ID 5580 //
     /* 1251193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1251204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1251207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1251210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1251216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251246 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1251246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1251249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251268 */     // GIR_Coverage, 5580,
     /* 1251268 */     GIR_EraseRootFromParent_Done,
     /* 1251269 */   // Label 18086: @1251269
     /* 1251269 */   GIM_Try, /*On fail goto*//*Label 18087*/ GIMT_Encode4(1251350), // Rule ID 5581 //
     /* 1251274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1251285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1251288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1251291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1251297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251327 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1251330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251349 */     // GIR_Coverage, 5581,
     /* 1251349 */     GIR_EraseRootFromParent_Done,
     /* 1251350 */   // Label 18087: @1251350
     /* 1251350 */   GIM_Try, /*On fail goto*//*Label 18088*/ GIMT_Encode4(1251431), // Rule ID 5582 //
     /* 1251355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1251366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1251369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1251372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251408 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1251408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251430 */     // GIR_Coverage, 5582,
     /* 1251430 */     GIR_EraseRootFromParent_Done,
     /* 1251431 */   // Label 18088: @1251431
     /* 1251431 */   GIM_Try, /*On fail goto*//*Label 18089*/ GIMT_Encode4(1251512), // Rule ID 5583 //
     /* 1251436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1251447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1251450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1251453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251489 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1251489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251511 */     // GIR_Coverage, 5583,
     /* 1251511 */     GIR_EraseRootFromParent_Done,
     /* 1251512 */   // Label 18089: @1251512
     /* 1251512 */   GIM_Try, /*On fail goto*//*Label 18090*/ GIMT_Encode4(1251593), // Rule ID 5584 //
     /* 1251517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1251528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1251531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1251534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251570 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1251570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1251573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251592 */     // GIR_Coverage, 5584,
     /* 1251592 */     GIR_EraseRootFromParent_Done,
     /* 1251593 */   // Label 18090: @1251593
     /* 1251593 */   GIM_Try, /*On fail goto*//*Label 18091*/ GIMT_Encode4(1251674), // Rule ID 5585 //
     /* 1251598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1251609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1251612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1251615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251651 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1251651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1251654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251673 */     // GIR_Coverage, 5585,
     /* 1251673 */     GIR_EraseRootFromParent_Done,
     /* 1251674 */   // Label 18091: @1251674
     /* 1251674 */   GIM_Try, /*On fail goto*//*Label 18092*/ GIMT_Encode4(1251755), // Rule ID 5586 //
     /* 1251679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1251690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1251693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1251696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251732 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1251732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1251735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251754 */     // GIR_Coverage, 5586,
     /* 1251754 */     GIR_EraseRootFromParent_Done,
     /* 1251755 */   // Label 18092: @1251755
     /* 1251755 */   GIM_Try, /*On fail goto*//*Label 18093*/ GIMT_Encode4(1251836), // Rule ID 5587 //
     /* 1251760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1251771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1251774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1251777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251813 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1251813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1251816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251835 */     // GIR_Coverage, 5587,
     /* 1251835 */     GIR_EraseRootFromParent_Done,
     /* 1251836 */   // Label 18093: @1251836
     /* 1251836 */   GIM_Try, /*On fail goto*//*Label 18094*/ GIMT_Encode4(1251917), // Rule ID 5588 //
     /* 1251841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1251852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1251855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1251858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1251864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251894 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1251894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251916 */     // GIR_Coverage, 5588,
     /* 1251916 */     GIR_EraseRootFromParent_Done,
     /* 1251917 */   // Label 18094: @1251917
     /* 1251917 */   GIM_Try, /*On fail goto*//*Label 18095*/ GIMT_Encode4(1251998), // Rule ID 5589 //
     /* 1251922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1251933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1251936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1251939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1251945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251975 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1251975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251997 */     // GIR_Coverage, 5589,
     /* 1251997 */     GIR_EraseRootFromParent_Done,
     /* 1251998 */   // Label 18095: @1251998
     /* 1251998 */   GIM_Try, /*On fail goto*//*Label 18096*/ GIMT_Encode4(1252079), // Rule ID 5590 //
     /* 1252003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1252014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1252017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252056 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1252056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252078 */     // GIR_Coverage, 5590,
     /* 1252078 */     GIR_EraseRootFromParent_Done,
     /* 1252079 */   // Label 18096: @1252079
     /* 1252079 */   GIM_Try, /*On fail goto*//*Label 18097*/ GIMT_Encode4(1252160), // Rule ID 5591 //
     /* 1252084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1252095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1252098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252137 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1252137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252159 */     // GIR_Coverage, 5591,
     /* 1252159 */     GIR_EraseRootFromParent_Done,
     /* 1252160 */   // Label 18097: @1252160
     /* 1252160 */   GIM_Try, /*On fail goto*//*Label 18098*/ GIMT_Encode4(1252241), // Rule ID 5592 //
     /* 1252165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1252176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1252179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252218 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1252218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252240 */     // GIR_Coverage, 5592,
     /* 1252240 */     GIR_EraseRootFromParent_Done,
     /* 1252241 */   // Label 18098: @1252241
     /* 1252241 */   GIM_Try, /*On fail goto*//*Label 18099*/ GIMT_Encode4(1252322), // Rule ID 5593 //
     /* 1252246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1252257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1252260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252299 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1252299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252321 */     // GIR_Coverage, 5593,
     /* 1252321 */     GIR_EraseRootFromParent_Done,
     /* 1252322 */   // Label 18099: @1252322
     /* 1252322 */   GIM_Try, /*On fail goto*//*Label 18100*/ GIMT_Encode4(1252403), // Rule ID 5594 //
     /* 1252327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1252338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1252341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1252344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252380 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1252380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1252383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252402 */     // GIR_Coverage, 5594,
     /* 1252402 */     GIR_EraseRootFromParent_Done,
     /* 1252403 */   // Label 18100: @1252403
     /* 1252403 */   GIM_Try, /*On fail goto*//*Label 18101*/ GIMT_Encode4(1252484), // Rule ID 5595 //
     /* 1252408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1252411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1252419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1252422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1252425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252461 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1252461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1252464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252483 */     // GIR_Coverage, 5595,
     /* 1252483 */     GIR_EraseRootFromParent_Done,
     /* 1252484 */   // Label 18101: @1252484
     /* 1252484 */   GIM_Try, /*On fail goto*//*Label 18102*/ GIMT_Encode4(1252565), // Rule ID 5596 //
     /* 1252489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1252500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1252503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1252506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252542 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1252542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252564 */     // GIR_Coverage, 5596,
     /* 1252564 */     GIR_EraseRootFromParent_Done,
     /* 1252565 */   // Label 18102: @1252565
     /* 1252565 */   GIM_Try, /*On fail goto*//*Label 18103*/ GIMT_Encode4(1252646), // Rule ID 5597 //
     /* 1252570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1252573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1252581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1252584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1252587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252623 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1252623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252645 */     // GIR_Coverage, 5597,
     /* 1252645 */     GIR_EraseRootFromParent_Done,
     /* 1252646 */   // Label 18103: @1252646
     /* 1252646 */   GIM_Try, /*On fail goto*//*Label 18104*/ GIMT_Encode4(1252727), // Rule ID 5598 //
     /* 1252651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1252662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1252665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1252668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252704 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1252704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252726 */     // GIR_Coverage, 5598,
     /* 1252726 */     GIR_EraseRootFromParent_Done,
     /* 1252727 */   // Label 18104: @1252727
     /* 1252727 */   GIM_Try, /*On fail goto*//*Label 18105*/ GIMT_Encode4(1252808), // Rule ID 5599 //
     /* 1252732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1252735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1252743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1252746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1252749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252785 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1252785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252807 */     // GIR_Coverage, 5599,
     /* 1252807 */     GIR_EraseRootFromParent_Done,
     /* 1252808 */   // Label 18105: @1252808
     /* 1252808 */   GIM_Try, /*On fail goto*//*Label 18106*/ GIMT_Encode4(1252892), // Rule ID 7810 //
     /* 1252813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1252824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1252827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1252830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1252833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252866 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1252869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1252887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252891 */     // GIR_Coverage, 7810,
     /* 1252891 */     GIR_EraseRootFromParent_Done,
     /* 1252892 */   // Label 18106: @1252892
     /* 1252892 */   GIM_Try, /*On fail goto*//*Label 18107*/ GIMT_Encode4(1252976), // Rule ID 7811 //
     /* 1252897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1252908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1252911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1252914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1252917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252950 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1252953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1252971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252975 */     // GIR_Coverage, 7811,
     /* 1252975 */     GIR_EraseRootFromParent_Done,
     /* 1252976 */   // Label 18107: @1252976
     /* 1252976 */   GIM_Try, /*On fail goto*//*Label 18108*/ GIMT_Encode4(1253060), // Rule ID 7814 //
     /* 1252981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1252992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1252995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1252998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1253001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253034 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253059 */     // GIR_Coverage, 7814,
     /* 1253059 */     GIR_EraseRootFromParent_Done,
     /* 1253060 */   // Label 18108: @1253060
     /* 1253060 */   GIM_Try, /*On fail goto*//*Label 18109*/ GIMT_Encode4(1253144), // Rule ID 7815 //
     /* 1253065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1253082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1253085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253118 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253143 */     // GIR_Coverage, 7815,
     /* 1253143 */     GIR_EraseRootFromParent_Done,
     /* 1253144 */   // Label 18109: @1253144
     /* 1253144 */   GIM_Try, /*On fail goto*//*Label 18110*/ GIMT_Encode4(1253228), // Rule ID 7818 //
     /* 1253149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1253166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1253169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253202 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1253205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253227 */     // GIR_Coverage, 7818,
     /* 1253227 */     GIR_EraseRootFromParent_Done,
     /* 1253228 */   // Label 18110: @1253228
     /* 1253228 */   GIM_Try, /*On fail goto*//*Label 18111*/ GIMT_Encode4(1253312), // Rule ID 7819 //
     /* 1253233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1253250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1253253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253286 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1253289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253311 */     // GIR_Coverage, 7819,
     /* 1253311 */     GIR_EraseRootFromParent_Done,
     /* 1253312 */   // Label 18111: @1253312
     /* 1253312 */   GIM_Try, /*On fail goto*//*Label 18112*/ GIMT_Encode4(1253396), // Rule ID 7822 //
     /* 1253317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1253334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1253337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253370 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253395 */     // GIR_Coverage, 7822,
     /* 1253395 */     GIR_EraseRootFromParent_Done,
     /* 1253396 */   // Label 18112: @1253396
     /* 1253396 */   GIM_Try, /*On fail goto*//*Label 18113*/ GIMT_Encode4(1253480), // Rule ID 7823 //
     /* 1253401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1253418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1253421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253454 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253479 */     // GIR_Coverage, 7823,
     /* 1253479 */     GIR_EraseRootFromParent_Done,
     /* 1253480 */   // Label 18113: @1253480
     /* 1253480 */   GIM_Try, /*On fail goto*//*Label 18114*/ GIMT_Encode4(1253564), // Rule ID 7826 //
     /* 1253485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1253502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1253505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253538 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1253559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253563 */     // GIR_Coverage, 7826,
     /* 1253563 */     GIR_EraseRootFromParent_Done,
     /* 1253564 */   // Label 18114: @1253564
     /* 1253564 */   GIM_Try, /*On fail goto*//*Label 18115*/ GIMT_Encode4(1253648), // Rule ID 7827 //
     /* 1253569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1253586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1253589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253622 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1253643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253647 */     // GIR_Coverage, 7827,
     /* 1253647 */     GIR_EraseRootFromParent_Done,
     /* 1253648 */   // Label 18115: @1253648
     /* 1253648 */   GIM_Try, /*On fail goto*//*Label 18116*/ GIMT_Encode4(1253732), // Rule ID 7830 //
     /* 1253653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1253664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1253667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1253670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1253673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253706 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1253709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253731 */     // GIR_Coverage, 7830,
     /* 1253731 */     GIR_EraseRootFromParent_Done,
     /* 1253732 */   // Label 18116: @1253732
     /* 1253732 */   GIM_Try, /*On fail goto*//*Label 18117*/ GIMT_Encode4(1253816), // Rule ID 7831 //
     /* 1253737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1253748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1253751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1253754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1253757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253790 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1253793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253815 */     // GIR_Coverage, 7831,
     /* 1253815 */     GIR_EraseRootFromParent_Done,
     /* 1253816 */   // Label 18117: @1253816
     /* 1253816 */   GIM_Try, /*On fail goto*//*Label 18118*/ GIMT_Encode4(1253900), // Rule ID 7834 //
     /* 1253821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1253838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1253841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253874 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1253877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253899 */     // GIR_Coverage, 7834,
     /* 1253899 */     GIR_EraseRootFromParent_Done,
     /* 1253900 */   // Label 18118: @1253900
     /* 1253900 */   GIM_Try, /*On fail goto*//*Label 18119*/ GIMT_Encode4(1253984), // Rule ID 7835 //
     /* 1253905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1253922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1253925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253958 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1253961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253983 */     // GIR_Coverage, 7835,
     /* 1253983 */     GIR_EraseRootFromParent_Done,
     /* 1253984 */   // Label 18119: @1253984
     /* 1253984 */   GIM_Try, /*On fail goto*//*Label 18120*/ GIMT_Encode4(1254068), // Rule ID 7838 //
     /* 1253989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1254006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1254009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254042 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254067 */     // GIR_Coverage, 7838,
     /* 1254067 */     GIR_EraseRootFromParent_Done,
     /* 1254068 */   // Label 18120: @1254068
     /* 1254068 */   GIM_Try, /*On fail goto*//*Label 18121*/ GIMT_Encode4(1254152), // Rule ID 7839 //
     /* 1254073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1254090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1254093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254126 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254151 */     // GIR_Coverage, 7839,
     /* 1254151 */     GIR_EraseRootFromParent_Done,
     /* 1254152 */   // Label 18121: @1254152
     /* 1254152 */   GIM_Try, /*On fail goto*//*Label 18122*/ GIMT_Encode4(1254236), // Rule ID 7842 //
     /* 1254157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1254160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1254174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1254177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254210 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254235 */     // GIR_Coverage, 7842,
     /* 1254235 */     GIR_EraseRootFromParent_Done,
     /* 1254236 */   // Label 18122: @1254236
     /* 1254236 */   GIM_Try, /*On fail goto*//*Label 18123*/ GIMT_Encode4(1254320), // Rule ID 7843 //
     /* 1254241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1254244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1254258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1254261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254294 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254319 */     // GIR_Coverage, 7843,
     /* 1254319 */     GIR_EraseRootFromParent_Done,
     /* 1254320 */   // Label 18123: @1254320
     /* 1254320 */   GIM_Try, /*On fail goto*//*Label 18124*/ GIMT_Encode4(1254404), // Rule ID 7846 //
     /* 1254325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1254336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1254339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1254342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1254345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1254348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254378 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1254381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254403 */     // GIR_Coverage, 7846,
     /* 1254403 */     GIR_EraseRootFromParent_Done,
     /* 1254404 */   // Label 18124: @1254404
     /* 1254404 */   GIM_Try, /*On fail goto*//*Label 18125*/ GIMT_Encode4(1254488), // Rule ID 7847 //
     /* 1254409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1254420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1254423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1254426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1254429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1254432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254462 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1254465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254487 */     // GIR_Coverage, 7847,
     /* 1254487 */     GIR_EraseRootFromParent_Done,
     /* 1254488 */   // Label 18125: @1254488
     /* 1254488 */   GIM_Try, /*On fail goto*//*Label 18126*/ GIMT_Encode4(1254572), // Rule ID 7850 //
     /* 1254493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1254504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1254507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1254510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1254513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1254516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254546 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1254549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254571 */     // GIR_Coverage, 7850,
     /* 1254571 */     GIR_EraseRootFromParent_Done,
     /* 1254572 */   // Label 18126: @1254572
     /* 1254572 */   GIM_Try, /*On fail goto*//*Label 18127*/ GIMT_Encode4(1254656), // Rule ID 7851 //
     /* 1254577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1254588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1254591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1254594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1254597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1254600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254630 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1254633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254655 */     // GIR_Coverage, 7851,
     /* 1254655 */     GIR_EraseRootFromParent_Done,
     /* 1254656 */   // Label 18127: @1254656
     /* 1254656 */   GIM_Try, /*On fail goto*//*Label 18128*/ GIMT_Encode4(1254740), // Rule ID 7854 //
     /* 1254661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1254672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1254675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1254678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1254681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1254684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254714 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1254717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254739 */     // GIR_Coverage, 7854,
     /* 1254739 */     GIR_EraseRootFromParent_Done,
     /* 1254740 */   // Label 18128: @1254740
     /* 1254740 */   GIM_Try, /*On fail goto*//*Label 18129*/ GIMT_Encode4(1254824), // Rule ID 7855 //
     /* 1254745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1254756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1254759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1254762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1254765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1254768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254798 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1254801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254823 */     // GIR_Coverage, 7855,
     /* 1254823 */     GIR_EraseRootFromParent_Done,
     /* 1254824 */   // Label 18129: @1254824
     /* 1254824 */   GIM_Try, /*On fail goto*//*Label 18130*/ GIMT_Encode4(1254908), // Rule ID 7858 //
     /* 1254829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1254840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1254843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1254846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1254849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254882 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1254885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254907 */     // GIR_Coverage, 7858,
     /* 1254907 */     GIR_EraseRootFromParent_Done,
     /* 1254908 */   // Label 18130: @1254908
     /* 1254908 */   GIM_Try, /*On fail goto*//*Label 18131*/ GIMT_Encode4(1254992), // Rule ID 7859 //
     /* 1254913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1254924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1254927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1254930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1254933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254966 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1254969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254991 */     // GIR_Coverage, 7859,
     /* 1254991 */     GIR_EraseRootFromParent_Done,
     /* 1254992 */   // Label 18131: @1254992
     /* 1254992 */   GIM_Try, /*On fail goto*//*Label 18132*/ GIMT_Encode4(1255076), // Rule ID 7862 //
     /* 1254997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1255014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1255017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255050 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255075 */     // GIR_Coverage, 7862,
     /* 1255075 */     GIR_EraseRootFromParent_Done,
     /* 1255076 */   // Label 18132: @1255076
     /* 1255076 */   GIM_Try, /*On fail goto*//*Label 18133*/ GIMT_Encode4(1255160), // Rule ID 7863 //
     /* 1255081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1255098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1255101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255134 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255159 */     // GIR_Coverage, 7863,
     /* 1255159 */     GIR_EraseRootFromParent_Done,
     /* 1255160 */   // Label 18133: @1255160
     /* 1255160 */   GIM_Try, /*On fail goto*//*Label 18134*/ GIMT_Encode4(1255244), // Rule ID 7866 //
     /* 1255165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1255182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1255185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255218 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255243 */     // GIR_Coverage, 7866,
     /* 1255243 */     GIR_EraseRootFromParent_Done,
     /* 1255244 */   // Label 18134: @1255244
     /* 1255244 */   GIM_Try, /*On fail goto*//*Label 18135*/ GIMT_Encode4(1255328), // Rule ID 7867 //
     /* 1255249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1255266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1255269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255302 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255327 */     // GIR_Coverage, 7867,
     /* 1255327 */     GIR_EraseRootFromParent_Done,
     /* 1255328 */   // Label 18135: @1255328
     /* 1255328 */   GIM_Try, /*On fail goto*//*Label 18136*/ GIMT_Encode4(1255412), // Rule ID 7870 //
     /* 1255333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1255344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1255347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1255350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1255353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255386 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255411 */     // GIR_Coverage, 7870,
     /* 1255411 */     GIR_EraseRootFromParent_Done,
     /* 1255412 */   // Label 18136: @1255412
     /* 1255412 */   GIM_Try, /*On fail goto*//*Label 18137*/ GIMT_Encode4(1255496), // Rule ID 7871 //
     /* 1255417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1255428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1255431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1255434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1255437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255470 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255495 */     // GIR_Coverage, 7871,
     /* 1255495 */     GIR_EraseRootFromParent_Done,
     /* 1255496 */   // Label 18137: @1255496
     /* 1255496 */   GIM_Try, /*On fail goto*//*Label 18138*/ GIMT_Encode4(1255580), // Rule ID 7874 //
     /* 1255501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1255518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1255521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255554 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255579 */     // GIR_Coverage, 7874,
     /* 1255579 */     GIR_EraseRootFromParent_Done,
     /* 1255580 */   // Label 18138: @1255580
     /* 1255580 */   GIM_Try, /*On fail goto*//*Label 18139*/ GIMT_Encode4(1255664), // Rule ID 7875 //
     /* 1255585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1255602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1255605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255638 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255663 */     // GIR_Coverage, 7875,
     /* 1255663 */     GIR_EraseRootFromParent_Done,
     /* 1255664 */   // Label 18139: @1255664
     /* 1255664 */   GIM_Try, /*On fail goto*//*Label 18140*/ GIMT_Encode4(1255748), // Rule ID 7878 //
     /* 1255669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1255686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1255689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255722 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255747 */     // GIR_Coverage, 7878,
     /* 1255747 */     GIR_EraseRootFromParent_Done,
     /* 1255748 */   // Label 18140: @1255748
     /* 1255748 */   GIM_Try, /*On fail goto*//*Label 18141*/ GIMT_Encode4(1255832), // Rule ID 7879 //
     /* 1255753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1255770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1255773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255806 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255831 */     // GIR_Coverage, 7879,
     /* 1255831 */     GIR_EraseRootFromParent_Done,
     /* 1255832 */   // Label 18141: @1255832
     /* 1255832 */   GIM_Try, /*On fail goto*//*Label 18142*/ GIMT_Encode4(1255916), // Rule ID 7882 //
     /* 1255837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1255840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1255848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1255851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1255854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1255857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1255860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255890 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255915 */     // GIR_Coverage, 7882,
     /* 1255915 */     GIR_EraseRootFromParent_Done,
     /* 1255916 */   // Label 18142: @1255916
     /* 1255916 */   GIM_Try, /*On fail goto*//*Label 18143*/ GIMT_Encode4(1256000), // Rule ID 7883 //
     /* 1255921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1255924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1255932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1255935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1255938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1255941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1255944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255974 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255999 */     // GIR_Coverage, 7883,
     /* 1255999 */     GIR_EraseRootFromParent_Done,
     /* 1256000 */   // Label 18143: @1256000
     /* 1256000 */   GIM_Try, /*On fail goto*//*Label 18144*/ GIMT_Encode4(1256084), // Rule ID 7886 //
     /* 1256005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1256022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1256025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256058 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1256061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256083 */     // GIR_Coverage, 7886,
     /* 1256083 */     GIR_EraseRootFromParent_Done,
     /* 1256084 */   // Label 18144: @1256084
     /* 1256084 */   GIM_Try, /*On fail goto*//*Label 18145*/ GIMT_Encode4(1256168), // Rule ID 7887 //
     /* 1256089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1256106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1256109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256142 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1256145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256167 */     // GIR_Coverage, 7887,
     /* 1256167 */     GIR_EraseRootFromParent_Done,
     /* 1256168 */   // Label 18145: @1256168
     /* 1256168 */   GIM_Try, /*On fail goto*//*Label 18146*/ GIMT_Encode4(1256252), // Rule ID 7890 //
     /* 1256173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1256190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1256193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256226 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1256229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256251 */     // GIR_Coverage, 7890,
     /* 1256251 */     GIR_EraseRootFromParent_Done,
     /* 1256252 */   // Label 18146: @1256252
     /* 1256252 */   GIM_Try, /*On fail goto*//*Label 18147*/ GIMT_Encode4(1256336), // Rule ID 7891 //
     /* 1256257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1256274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1256277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256310 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1256313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256335 */     // GIR_Coverage, 7891,
     /* 1256335 */     GIR_EraseRootFromParent_Done,
     /* 1256336 */   // Label 18147: @1256336
     /* 1256336 */   GIM_Try, /*On fail goto*//*Label 18148*/ GIMT_Encode4(1256420), // Rule ID 7894 //
     /* 1256341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1256352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1256355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1256358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256394 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1256397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256419 */     // GIR_Coverage, 7894,
     /* 1256419 */     GIR_EraseRootFromParent_Done,
     /* 1256420 */   // Label 18148: @1256420
     /* 1256420 */   GIM_Try, /*On fail goto*//*Label 18149*/ GIMT_Encode4(1256504), // Rule ID 7895 //
     /* 1256425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1256436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1256439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1256442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256478 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1256481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256503 */     // GIR_Coverage, 7895,
     /* 1256503 */     GIR_EraseRootFromParent_Done,
     /* 1256504 */   // Label 18149: @1256504
     /* 1256504 */   GIM_Try, /*On fail goto*//*Label 18150*/ GIMT_Encode4(1256588), // Rule ID 7898 //
     /* 1256509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1256526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256562 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1256565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256587 */     // GIR_Coverage, 7898,
     /* 1256587 */     GIR_EraseRootFromParent_Done,
     /* 1256588 */   // Label 18150: @1256588
     /* 1256588 */   GIM_Try, /*On fail goto*//*Label 18151*/ GIMT_Encode4(1256672), // Rule ID 7899 //
     /* 1256593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1256610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256646 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1256649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256671 */     // GIR_Coverage, 7899,
     /* 1256671 */     GIR_EraseRootFromParent_Done,
     /* 1256672 */   // Label 18151: @1256672
     /* 1256672 */   GIM_Try, /*On fail goto*//*Label 18152*/ GIMT_Encode4(1256756), // Rule ID 7902 //
     /* 1256677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1256694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256730 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1256733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256755 */     // GIR_Coverage, 7902,
     /* 1256755 */     GIR_EraseRootFromParent_Done,
     /* 1256756 */   // Label 18152: @1256756
     /* 1256756 */   GIM_Try, /*On fail goto*//*Label 18153*/ GIMT_Encode4(1256840), // Rule ID 7903 //
     /* 1256761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1256778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256814 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1256817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256839 */     // GIR_Coverage, 7903,
     /* 1256839 */     GIR_EraseRootFromParent_Done,
     /* 1256840 */   // Label 18153: @1256840
     /* 1256840 */   GIM_Try, /*On fail goto*//*Label 18154*/ GIMT_Encode4(1256924), // Rule ID 7906 //
     /* 1256845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1256856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1256859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1256862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256898 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1256901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256923 */     // GIR_Coverage, 7906,
     /* 1256923 */     GIR_EraseRootFromParent_Done,
     /* 1256924 */   // Label 18154: @1256924
     /* 1256924 */   GIM_Try, /*On fail goto*//*Label 18155*/ GIMT_Encode4(1257008), // Rule ID 7907 //
     /* 1256929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1256940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1256943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1256946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256982 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1256985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257007 */     // GIR_Coverage, 7907,
     /* 1257007 */     GIR_EraseRootFromParent_Done,
     /* 1257008 */   // Label 18155: @1257008
     /* 1257008 */   GIM_Try, /*On fail goto*//*Label 18156*/ GIMT_Encode4(1257092), // Rule ID 7910 //
     /* 1257013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1257030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257066 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257091 */     // GIR_Coverage, 7910,
     /* 1257091 */     GIR_EraseRootFromParent_Done,
     /* 1257092 */   // Label 18156: @1257092
     /* 1257092 */   GIM_Try, /*On fail goto*//*Label 18157*/ GIMT_Encode4(1257176), // Rule ID 7911 //
     /* 1257097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1257114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257150 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257175 */     // GIR_Coverage, 7911,
     /* 1257175 */     GIR_EraseRootFromParent_Done,
     /* 1257176 */   // Label 18157: @1257176
     /* 1257176 */   GIM_Try, /*On fail goto*//*Label 18158*/ GIMT_Encode4(1257260), // Rule ID 7914 //
     /* 1257181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1257198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257234 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257259 */     // GIR_Coverage, 7914,
     /* 1257259 */     GIR_EraseRootFromParent_Done,
     /* 1257260 */   // Label 18158: @1257260
     /* 1257260 */   GIM_Try, /*On fail goto*//*Label 18159*/ GIMT_Encode4(1257344), // Rule ID 7915 //
     /* 1257265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1257282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257318 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257343 */     // GIR_Coverage, 7915,
     /* 1257343 */     GIR_EraseRootFromParent_Done,
     /* 1257344 */   // Label 18159: @1257344
     /* 1257344 */   GIM_Try, /*On fail goto*//*Label 18160*/ GIMT_Encode4(1257428), // Rule ID 7918 //
     /* 1257349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1257366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257402 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257427 */     // GIR_Coverage, 7918,
     /* 1257427 */     GIR_EraseRootFromParent_Done,
     /* 1257428 */   // Label 18160: @1257428
     /* 1257428 */   GIM_Try, /*On fail goto*//*Label 18161*/ GIMT_Encode4(1257512), // Rule ID 7919 //
     /* 1257433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1257450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257486 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257511 */     // GIR_Coverage, 7919,
     /* 1257511 */     GIR_EraseRootFromParent_Done,
     /* 1257512 */   // Label 18161: @1257512
     /* 1257512 */   GIM_Try, /*On fail goto*//*Label 18162*/ GIMT_Encode4(1257596), // Rule ID 7922 //
     /* 1257517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1257534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257570 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257595 */     // GIR_Coverage, 7922,
     /* 1257595 */     GIR_EraseRootFromParent_Done,
     /* 1257596 */   // Label 18162: @1257596
     /* 1257596 */   GIM_Try, /*On fail goto*//*Label 18163*/ GIMT_Encode4(1257680), // Rule ID 7923 //
     /* 1257601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1257618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257654 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257679 */     // GIR_Coverage, 7923,
     /* 1257679 */     GIR_EraseRootFromParent_Done,
     /* 1257680 */   // Label 18163: @1257680
     /* 1257680 */   GIM_Try, /*On fail goto*//*Label 18164*/ GIMT_Encode4(1257764), // Rule ID 7926 //
     /* 1257685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1257702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257738 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257763 */     // GIR_Coverage, 7926,
     /* 1257763 */     GIR_EraseRootFromParent_Done,
     /* 1257764 */   // Label 18164: @1257764
     /* 1257764 */   GIM_Try, /*On fail goto*//*Label 18165*/ GIMT_Encode4(1257848), // Rule ID 7927 //
     /* 1257769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1257786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257822 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257847 */     // GIR_Coverage, 7927,
     /* 1257847 */     GIR_EraseRootFromParent_Done,
     /* 1257848 */   // Label 18165: @1257848
     /* 1257848 */   GIM_Try, /*On fail goto*//*Label 18166*/ GIMT_Encode4(1257932), // Rule ID 7930 //
     /* 1257853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1257856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1257870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257906 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257931 */     // GIR_Coverage, 7930,
     /* 1257931 */     GIR_EraseRootFromParent_Done,
     /* 1257932 */   // Label 18166: @1257932
     /* 1257932 */   GIM_Try, /*On fail goto*//*Label 18167*/ GIMT_Encode4(1258016), // Rule ID 7931 //
     /* 1257937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1257940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1257954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257990 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1258011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258015 */     // GIR_Coverage, 7931,
     /* 1258015 */     GIR_EraseRootFromParent_Done,
     /* 1258016 */   // Label 18167: @1258016
     /* 1258016 */   GIM_Try, /*On fail goto*//*Label 18168*/ GIMT_Encode4(1258100), // Rule ID 7934 //
     /* 1258021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1258038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258074 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1258077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258099 */     // GIR_Coverage, 7934,
     /* 1258099 */     GIR_EraseRootFromParent_Done,
     /* 1258100 */   // Label 18168: @1258100
     /* 1258100 */   GIM_Try, /*On fail goto*//*Label 18169*/ GIMT_Encode4(1258184), // Rule ID 7935 //
     /* 1258105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1258122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258158 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1258161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258183 */     // GIR_Coverage, 7935,
     /* 1258183 */     GIR_EraseRootFromParent_Done,
     /* 1258184 */   // Label 18169: @1258184
     /* 1258184 */   GIM_Try, /*On fail goto*//*Label 18170*/ GIMT_Encode4(1258268), // Rule ID 7938 //
     /* 1258189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1258206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258242 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1258245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258267 */     // GIR_Coverage, 7938,
     /* 1258267 */     GIR_EraseRootFromParent_Done,
     /* 1258268 */   // Label 18170: @1258268
     /* 1258268 */   GIM_Try, /*On fail goto*//*Label 18171*/ GIMT_Encode4(1258352), // Rule ID 7939 //
     /* 1258273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1258290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258326 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1258329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258351 */     // GIR_Coverage, 7939,
     /* 1258351 */     GIR_EraseRootFromParent_Done,
     /* 1258352 */   // Label 18171: @1258352
     /* 1258352 */   GIM_Try, /*On fail goto*//*Label 18172*/ GIMT_Encode4(1258436), // Rule ID 7942 //
     /* 1258357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1258368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1258371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1258374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1258380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258410 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1258413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258435 */     // GIR_Coverage, 7942,
     /* 1258435 */     GIR_EraseRootFromParent_Done,
     /* 1258436 */   // Label 18172: @1258436
     /* 1258436 */   GIM_Try, /*On fail goto*//*Label 18173*/ GIMT_Encode4(1258520), // Rule ID 7943 //
     /* 1258441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1258452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1258455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1258458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1258464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258494 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1258497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258519 */     // GIR_Coverage, 7943,
     /* 1258519 */     GIR_EraseRootFromParent_Done,
     /* 1258520 */   // Label 18173: @1258520
     /* 1258520 */   GIM_Try, /*On fail goto*//*Label 18174*/ GIMT_Encode4(1258604), // Rule ID 7946 //
     /* 1258525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1258536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1258539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1258542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1258548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258578 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1258581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258603 */     // GIR_Coverage, 7946,
     /* 1258603 */     GIR_EraseRootFromParent_Done,
     /* 1258604 */   // Label 18174: @1258604
     /* 1258604 */   GIM_Try, /*On fail goto*//*Label 18175*/ GIMT_Encode4(1258688), // Rule ID 7947 //
     /* 1258609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1258620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1258623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1258626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1258632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258662 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1258665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258687 */     // GIR_Coverage, 7947,
     /* 1258687 */     GIR_EraseRootFromParent_Done,
     /* 1258688 */   // Label 18175: @1258688
     /* 1258688 */   GIM_Try, /*On fail goto*//*Label 18176*/ GIMT_Encode4(1258772), // Rule ID 7950 //
     /* 1258693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1258710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258746 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1258749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258771 */     // GIR_Coverage, 7950,
     /* 1258771 */     GIR_EraseRootFromParent_Done,
     /* 1258772 */   // Label 18176: @1258772
     /* 1258772 */   GIM_Try, /*On fail goto*//*Label 18177*/ GIMT_Encode4(1258856), // Rule ID 7951 //
     /* 1258777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1258794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258830 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1258833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258855 */     // GIR_Coverage, 7951,
     /* 1258855 */     GIR_EraseRootFromParent_Done,
     /* 1258856 */   // Label 18177: @1258856
     /* 1258856 */   GIM_Try, /*On fail goto*//*Label 18178*/ GIMT_Encode4(1258940), // Rule ID 7954 //
     /* 1258861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1258878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258914 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1258917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258939 */     // GIR_Coverage, 7954,
     /* 1258939 */     GIR_EraseRootFromParent_Done,
     /* 1258940 */   // Label 18178: @1258940
     /* 1258940 */   GIM_Try, /*On fail goto*//*Label 18179*/ GIMT_Encode4(1259024), // Rule ID 7955 //
     /* 1258945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1258962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258998 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259023 */     // GIR_Coverage, 7955,
     /* 1259023 */     GIR_EraseRootFromParent_Done,
     /* 1259024 */   // Label 18179: @1259024
     /* 1259024 */   GIM_Try, /*On fail goto*//*Label 18180*/ GIMT_Encode4(1259108), // Rule ID 7958 //
     /* 1259029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1259046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259082 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259107 */     // GIR_Coverage, 7958,
     /* 1259107 */     GIR_EraseRootFromParent_Done,
     /* 1259108 */   // Label 18180: @1259108
     /* 1259108 */   GIM_Try, /*On fail goto*//*Label 18181*/ GIMT_Encode4(1259192), // Rule ID 7959 //
     /* 1259113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1259130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259166 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259191 */     // GIR_Coverage, 7959,
     /* 1259191 */     GIR_EraseRootFromParent_Done,
     /* 1259192 */   // Label 18181: @1259192
     /* 1259192 */   GIM_Try, /*On fail goto*//*Label 18182*/ GIMT_Encode4(1259276), // Rule ID 7962 //
     /* 1259197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259250 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259275 */     // GIR_Coverage, 7962,
     /* 1259275 */     GIR_EraseRootFromParent_Done,
     /* 1259276 */   // Label 18182: @1259276
     /* 1259276 */   GIM_Try, /*On fail goto*//*Label 18183*/ GIMT_Encode4(1259360), // Rule ID 7963 //
     /* 1259281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259334 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259359 */     // GIR_Coverage, 7963,
     /* 1259359 */     GIR_EraseRootFromParent_Done,
     /* 1259360 */   // Label 18183: @1259360
     /* 1259360 */   GIM_Try, /*On fail goto*//*Label 18184*/ GIMT_Encode4(1259444), // Rule ID 7966 //
     /* 1259365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259418 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259443 */     // GIR_Coverage, 7966,
     /* 1259443 */     GIR_EraseRootFromParent_Done,
     /* 1259444 */   // Label 18184: @1259444
     /* 1259444 */   GIM_Try, /*On fail goto*//*Label 18185*/ GIMT_Encode4(1259528), // Rule ID 7967 //
     /* 1259449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259502 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259527 */     // GIR_Coverage, 7967,
     /* 1259527 */     GIR_EraseRootFromParent_Done,
     /* 1259528 */   // Label 18185: @1259528
     /* 1259528 */   GIM_Try, /*On fail goto*//*Label 18186*/ GIMT_Encode4(1259612), // Rule ID 7970 //
     /* 1259533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1259536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1259544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1259547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1259550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1259556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259586 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259611 */     // GIR_Coverage, 7970,
     /* 1259611 */     GIR_EraseRootFromParent_Done,
     /* 1259612 */   // Label 18186: @1259612
     /* 1259612 */   GIM_Try, /*On fail goto*//*Label 18187*/ GIMT_Encode4(1259696), // Rule ID 7971 //
     /* 1259617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1259620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1259628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1259631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1259634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1259640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259670 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259695 */     // GIR_Coverage, 7971,
     /* 1259695 */     GIR_EraseRootFromParent_Done,
     /* 1259696 */   // Label 18187: @1259696
     /* 1259696 */   GIM_Try, /*On fail goto*//*Label 18188*/ GIMT_Encode4(1259780), // Rule ID 7974 //
     /* 1259701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1259704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1259718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259754 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259779 */     // GIR_Coverage, 7974,
     /* 1259779 */     GIR_EraseRootFromParent_Done,
     /* 1259780 */   // Label 18188: @1259780
     /* 1259780 */   GIM_Try, /*On fail goto*//*Label 18189*/ GIMT_Encode4(1259864), // Rule ID 7975 //
     /* 1259785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1259788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1259802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259838 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259863 */     // GIR_Coverage, 7975,
     /* 1259863 */     GIR_EraseRootFromParent_Done,
     /* 1259864 */   // Label 18189: @1259864
     /* 1259864 */   GIM_Try, /*On fail goto*//*Label 18190*/ GIMT_Encode4(1259948), // Rule ID 7978 //
     /* 1259869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1259872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1259886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259922 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259947 */     // GIR_Coverage, 7978,
     /* 1259947 */     GIR_EraseRootFromParent_Done,
     /* 1259948 */   // Label 18190: @1259948
     /* 1259948 */   GIM_Try, /*On fail goto*//*Label 18191*/ GIMT_Encode4(1260032), // Rule ID 7979 //
     /* 1259953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1259956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1259970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260006 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1260009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260031 */     // GIR_Coverage, 7979,
     /* 1260031 */     GIR_EraseRootFromParent_Done,
     /* 1260032 */   // Label 18191: @1260032
     /* 1260032 */   GIM_Try, /*On fail goto*//*Label 18192*/ GIMT_Encode4(1260116), // Rule ID 8070 //
     /* 1260037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1260054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1260057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260090 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1260093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260115 */     // GIR_Coverage, 8070,
     /* 1260115 */     GIR_EraseRootFromParent_Done,
     /* 1260116 */   // Label 18192: @1260116
     /* 1260116 */   GIM_Try, /*On fail goto*//*Label 18193*/ GIMT_Encode4(1260200), // Rule ID 8071 //
     /* 1260121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1260138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1260141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260174 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1260177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260199 */     // GIR_Coverage, 8071,
     /* 1260199 */     GIR_EraseRootFromParent_Done,
     /* 1260200 */   // Label 18193: @1260200
     /* 1260200 */   GIM_Try, /*On fail goto*//*Label 18194*/ GIMT_Encode4(1260284), // Rule ID 8074 //
     /* 1260205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1260222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1260225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260258 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1260261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260283 */     // GIR_Coverage, 8074,
     /* 1260283 */     GIR_EraseRootFromParent_Done,
     /* 1260284 */   // Label 18194: @1260284
     /* 1260284 */   GIM_Try, /*On fail goto*//*Label 18195*/ GIMT_Encode4(1260368), // Rule ID 8075 //
     /* 1260289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1260306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1260309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260342 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1260345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260367 */     // GIR_Coverage, 8075,
     /* 1260367 */     GIR_EraseRootFromParent_Done,
     /* 1260368 */   // Label 18195: @1260368
     /* 1260368 */   GIM_Try, /*On fail goto*//*Label 18196*/ GIMT_Encode4(1260452), // Rule ID 8078 //
     /* 1260373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1260390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1260393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260426 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260451 */     // GIR_Coverage, 8078,
     /* 1260451 */     GIR_EraseRootFromParent_Done,
     /* 1260452 */   // Label 18196: @1260452
     /* 1260452 */   GIM_Try, /*On fail goto*//*Label 18197*/ GIMT_Encode4(1260536), // Rule ID 8079 //
     /* 1260457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1260474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1260477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260510 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260535 */     // GIR_Coverage, 8079,
     /* 1260535 */     GIR_EraseRootFromParent_Done,
     /* 1260536 */   // Label 18197: @1260536
     /* 1260536 */   GIM_Try, /*On fail goto*//*Label 18198*/ GIMT_Encode4(1260620), // Rule ID 8082 //
     /* 1260541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1260558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1260561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260594 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1260597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260619 */     // GIR_Coverage, 8082,
     /* 1260619 */     GIR_EraseRootFromParent_Done,
     /* 1260620 */   // Label 18198: @1260620
     /* 1260620 */   GIM_Try, /*On fail goto*//*Label 18199*/ GIMT_Encode4(1260704), // Rule ID 8083 //
     /* 1260625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1260642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1260645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260678 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1260681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260703 */     // GIR_Coverage, 8083,
     /* 1260703 */     GIR_EraseRootFromParent_Done,
     /* 1260704 */   // Label 18199: @1260704
     /* 1260704 */   GIM_Try, /*On fail goto*//*Label 18200*/ GIMT_Encode4(1260788), // Rule ID 8086 //
     /* 1260709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1260726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1260729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260762 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260787 */     // GIR_Coverage, 8086,
     /* 1260787 */     GIR_EraseRootFromParent_Done,
     /* 1260788 */   // Label 18200: @1260788
     /* 1260788 */   GIM_Try, /*On fail goto*//*Label 18201*/ GIMT_Encode4(1260872), // Rule ID 8087 //
     /* 1260793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1260810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1260813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260846 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260871 */     // GIR_Coverage, 8087,
     /* 1260871 */     GIR_EraseRootFromParent_Done,
     /* 1260872 */   // Label 18201: @1260872
     /* 1260872 */   GIM_Try, /*On fail goto*//*Label 18202*/ GIMT_Encode4(1260956), // Rule ID 8090 //
     /* 1260877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1260894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1260897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260930 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1260951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260955 */     // GIR_Coverage, 8090,
     /* 1260955 */     GIR_EraseRootFromParent_Done,
     /* 1260956 */   // Label 18202: @1260956
     /* 1260956 */   GIM_Try, /*On fail goto*//*Label 18203*/ GIMT_Encode4(1261040), // Rule ID 8091 //
     /* 1260961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1260978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1260981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1261017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261039 */     // GIR_Coverage, 8091,
     /* 1261039 */     GIR_EraseRootFromParent_Done,
     /* 1261040 */   // Label 18203: @1261040
     /* 1261040 */   GIM_Try, /*On fail goto*//*Label 18204*/ GIMT_Encode4(1261124), // Rule ID 8094 //
     /* 1261045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1261065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261098 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261123 */     // GIR_Coverage, 8094,
     /* 1261123 */     GIR_EraseRootFromParent_Done,
     /* 1261124 */   // Label 18204: @1261124
     /* 1261124 */   GIM_Try, /*On fail goto*//*Label 18205*/ GIMT_Encode4(1261208), // Rule ID 8095 //
     /* 1261129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1261149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261182 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261207 */     // GIR_Coverage, 8095,
     /* 1261207 */     GIR_EraseRootFromParent_Done,
     /* 1261208 */   // Label 18205: @1261208
     /* 1261208 */   GIM_Try, /*On fail goto*//*Label 18206*/ GIMT_Encode4(1261292), // Rule ID 8098 //
     /* 1261213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1261230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261266 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261291 */     // GIR_Coverage, 8098,
     /* 1261291 */     GIR_EraseRootFromParent_Done,
     /* 1261292 */   // Label 18206: @1261292
     /* 1261292 */   GIM_Try, /*On fail goto*//*Label 18207*/ GIMT_Encode4(1261376), // Rule ID 8099 //
     /* 1261297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1261314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261350 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261375 */     // GIR_Coverage, 8099,
     /* 1261375 */     GIR_EraseRootFromParent_Done,
     /* 1261376 */   // Label 18207: @1261376
     /* 1261376 */   GIM_Try, /*On fail goto*//*Label 18208*/ GIMT_Encode4(1261460), // Rule ID 8102 //
     /* 1261381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1261398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1261401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261434 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261459 */     // GIR_Coverage, 8102,
     /* 1261459 */     GIR_EraseRootFromParent_Done,
     /* 1261460 */   // Label 18208: @1261460
     /* 1261460 */   GIM_Try, /*On fail goto*//*Label 18209*/ GIMT_Encode4(1261544), // Rule ID 8103 //
     /* 1261465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1261482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1261485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261518 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261543 */     // GIR_Coverage, 8103,
     /* 1261543 */     GIR_EraseRootFromParent_Done,
     /* 1261544 */   // Label 18209: @1261544
     /* 1261544 */   GIM_Try, /*On fail goto*//*Label 18210*/ GIMT_Encode4(1261628), // Rule ID 8106 //
     /* 1261549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1261552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1261566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1261569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261602 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1261623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261627 */     // GIR_Coverage, 8106,
     /* 1261627 */     GIR_EraseRootFromParent_Done,
     /* 1261628 */   // Label 18210: @1261628
     /* 1261628 */   GIM_Try, /*On fail goto*//*Label 18211*/ GIMT_Encode4(1261712), // Rule ID 8107 //
     /* 1261633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1261636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1261650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1261653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261686 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1261707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261711 */     // GIR_Coverage, 8107,
     /* 1261711 */     GIR_EraseRootFromParent_Done,
     /* 1261712 */   // Label 18211: @1261712
     /* 1261712 */   GIM_Try, /*On fail goto*//*Label 18212*/ GIMT_Encode4(1261796), // Rule ID 8110 //
     /* 1261717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1261728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1261731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1261734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1261737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1261740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261770 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1261773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261795 */     // GIR_Coverage, 8110,
     /* 1261795 */     GIR_EraseRootFromParent_Done,
     /* 1261796 */   // Label 18212: @1261796
     /* 1261796 */   GIM_Try, /*On fail goto*//*Label 18213*/ GIMT_Encode4(1261880), // Rule ID 8111 //
     /* 1261801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1261812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1261815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1261818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1261821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1261824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261854 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1261857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261879 */     // GIR_Coverage, 8111,
     /* 1261879 */     GIR_EraseRootFromParent_Done,
     /* 1261880 */   // Label 18213: @1261880
     /* 1261880 */   GIM_Try, /*On fail goto*//*Label 18214*/ GIMT_Encode4(1261964), // Rule ID 8114 //
     /* 1261885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1261896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1261899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1261902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1261905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1261908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1261923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1261927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261938 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1261941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261963 */     // GIR_Coverage, 8114,
     /* 1261963 */     GIR_EraseRootFromParent_Done,
     /* 1261964 */   // Label 18214: @1261964
     /* 1261964 */   GIM_Try, /*On fail goto*//*Label 18215*/ GIMT_Encode4(1262048), // Rule ID 8115 //
     /* 1261969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1261980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1261983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1261986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1261989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1261992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262022 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262047 */     // GIR_Coverage, 8115,
     /* 1262047 */     GIR_EraseRootFromParent_Done,
     /* 1262048 */   // Label 18215: @1262048
     /* 1262048 */   GIM_Try, /*On fail goto*//*Label 18216*/ GIMT_Encode4(1262132), // Rule ID 8118 //
     /* 1262053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1262064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1262067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1262073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262106 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1262109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262131 */     // GIR_Coverage, 8118,
     /* 1262131 */     GIR_EraseRootFromParent_Done,
     /* 1262132 */   // Label 18216: @1262132
     /* 1262132 */   GIM_Try, /*On fail goto*//*Label 18217*/ GIMT_Encode4(1262216), // Rule ID 8119 //
     /* 1262137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1262148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1262151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1262157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262190 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1262193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262215 */     // GIR_Coverage, 8119,
     /* 1262215 */     GIR_EraseRootFromParent_Done,
     /* 1262216 */   // Label 18217: @1262216
     /* 1262216 */   GIM_Try, /*On fail goto*//*Label 18218*/ GIMT_Encode4(1262300), // Rule ID 8122 //
     /* 1262221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1262238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1262241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262274 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262299 */     // GIR_Coverage, 8122,
     /* 1262299 */     GIR_EraseRootFromParent_Done,
     /* 1262300 */   // Label 18218: @1262300
     /* 1262300 */   GIM_Try, /*On fail goto*//*Label 18219*/ GIMT_Encode4(1262384), // Rule ID 8123 //
     /* 1262305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1262322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1262325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262358 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262383 */     // GIR_Coverage, 8123,
     /* 1262383 */     GIR_EraseRootFromParent_Done,
     /* 1262384 */   // Label 18219: @1262384
     /* 1262384 */   GIM_Try, /*On fail goto*//*Label 18220*/ GIMT_Encode4(1262468), // Rule ID 8126 //
     /* 1262389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1262406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1262409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262442 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262467 */     // GIR_Coverage, 8126,
     /* 1262467 */     GIR_EraseRootFromParent_Done,
     /* 1262468 */   // Label 18220: @1262468
     /* 1262468 */   GIM_Try, /*On fail goto*//*Label 18221*/ GIMT_Encode4(1262552), // Rule ID 8127 //
     /* 1262473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1262490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1262493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262526 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262551 */     // GIR_Coverage, 8127,
     /* 1262551 */     GIR_EraseRootFromParent_Done,
     /* 1262552 */   // Label 18221: @1262552
     /* 1262552 */   GIM_Try, /*On fail goto*//*Label 18222*/ GIMT_Encode4(1262636), // Rule ID 8130 //
     /* 1262557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1262574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1262577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262610 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1262613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262635 */     // GIR_Coverage, 8130,
     /* 1262635 */     GIR_EraseRootFromParent_Done,
     /* 1262636 */   // Label 18222: @1262636
     /* 1262636 */   GIM_Try, /*On fail goto*//*Label 18223*/ GIMT_Encode4(1262720), // Rule ID 8131 //
     /* 1262641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1262658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1262661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262694 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1262697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262719 */     // GIR_Coverage, 8131,
     /* 1262719 */     GIR_EraseRootFromParent_Done,
     /* 1262720 */   // Label 18223: @1262720
     /* 1262720 */   GIM_Try, /*On fail goto*//*Label 18224*/ GIMT_Encode4(1262804), // Rule ID 8134 //
     /* 1262725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1262736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1262739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1262742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1262745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1262748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262778 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262803 */     // GIR_Coverage, 8134,
     /* 1262803 */     GIR_EraseRootFromParent_Done,
     /* 1262804 */   // Label 18224: @1262804
     /* 1262804 */   GIM_Try, /*On fail goto*//*Label 18225*/ GIMT_Encode4(1262888), // Rule ID 8135 //
     /* 1262809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1262820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1262823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1262826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1262829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1262832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262862 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262887 */     // GIR_Coverage, 8135,
     /* 1262887 */     GIR_EraseRootFromParent_Done,
     /* 1262888 */   // Label 18225: @1262888
     /* 1262888 */   GIM_Try, /*On fail goto*//*Label 18226*/ GIMT_Encode4(1262972), // Rule ID 8138 //
     /* 1262893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1262910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1262913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262946 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262971 */     // GIR_Coverage, 8138,
     /* 1262971 */     GIR_EraseRootFromParent_Done,
     /* 1262972 */   // Label 18226: @1262972
     /* 1262972 */   GIM_Try, /*On fail goto*//*Label 18227*/ GIMT_Encode4(1263056), // Rule ID 8139 //
     /* 1262977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1262994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1262997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263030 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263055 */     // GIR_Coverage, 8139,
     /* 1263055 */     GIR_EraseRootFromParent_Done,
     /* 1263056 */   // Label 18227: @1263056
     /* 1263056 */   GIM_Try, /*On fail goto*//*Label 18228*/ GIMT_Encode4(1263140), // Rule ID 8142 //
     /* 1263061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1263081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263114 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263139 */     // GIR_Coverage, 8142,
     /* 1263139 */     GIR_EraseRootFromParent_Done,
     /* 1263140 */   // Label 18228: @1263140
     /* 1263140 */   GIM_Try, /*On fail goto*//*Label 18229*/ GIMT_Encode4(1263224), // Rule ID 8143 //
     /* 1263145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1263165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263198 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263223 */     // GIR_Coverage, 8143,
     /* 1263223 */     GIR_EraseRootFromParent_Done,
     /* 1263224 */   // Label 18229: @1263224
     /* 1263224 */   GIM_Try, /*On fail goto*//*Label 18230*/ GIMT_Encode4(1263308), // Rule ID 8146 //
     /* 1263229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1263246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1263249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263282 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1263285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263307 */     // GIR_Coverage, 8146,
     /* 1263307 */     GIR_EraseRootFromParent_Done,
     /* 1263308 */   // Label 18230: @1263308
     /* 1263308 */   GIM_Try, /*On fail goto*//*Label 18231*/ GIMT_Encode4(1263392), // Rule ID 8147 //
     /* 1263313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1263330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1263333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263366 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1263369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263391 */     // GIR_Coverage, 8147,
     /* 1263391 */     GIR_EraseRootFromParent_Done,
     /* 1263392 */   // Label 18231: @1263392
     /* 1263392 */   GIM_Try, /*On fail goto*//*Label 18232*/ GIMT_Encode4(1263476), // Rule ID 8150 //
     /* 1263397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1263414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1263417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263450 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263475 */     // GIR_Coverage, 8150,
     /* 1263475 */     GIR_EraseRootFromParent_Done,
     /* 1263476 */   // Label 18232: @1263476
     /* 1263476 */   GIM_Try, /*On fail goto*//*Label 18233*/ GIMT_Encode4(1263560), // Rule ID 8151 //
     /* 1263481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1263498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1263501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263534 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263559 */     // GIR_Coverage, 8151,
     /* 1263559 */     GIR_EraseRootFromParent_Done,
     /* 1263560 */   // Label 18233: @1263560
     /* 1263560 */   GIM_Try, /*On fail goto*//*Label 18234*/ GIMT_Encode4(1263644), // Rule ID 8154 //
     /* 1263565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1263582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1263585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263618 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263643 */     // GIR_Coverage, 8154,
     /* 1263643 */     GIR_EraseRootFromParent_Done,
     /* 1263644 */   // Label 18234: @1263644
     /* 1263644 */   GIM_Try, /*On fail goto*//*Label 18235*/ GIMT_Encode4(1263728), // Rule ID 8155 //
     /* 1263649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1263666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1263669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263702 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263727 */     // GIR_Coverage, 8155,
     /* 1263727 */     GIR_EraseRootFromParent_Done,
     /* 1263728 */   // Label 18235: @1263728
     /* 1263728 */   GIM_Try, /*On fail goto*//*Label 18236*/ GIMT_Encode4(1263812), // Rule ID 8158 //
     /* 1263733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1263744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1263747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1263750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1263756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263786 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1263789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263811 */     // GIR_Coverage, 8158,
     /* 1263811 */     GIR_EraseRootFromParent_Done,
     /* 1263812 */   // Label 18236: @1263812
     /* 1263812 */   GIM_Try, /*On fail goto*//*Label 18237*/ GIMT_Encode4(1263896), // Rule ID 8159 //
     /* 1263817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1263828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1263831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1263834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1263840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263870 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1263873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263895 */     // GIR_Coverage, 8159,
     /* 1263895 */     GIR_EraseRootFromParent_Done,
     /* 1263896 */   // Label 18237: @1263896
     /* 1263896 */   GIM_Try, /*On fail goto*//*Label 18238*/ GIMT_Encode4(1263980), // Rule ID 8162 //
     /* 1263901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1263918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263954 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1263957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263979 */     // GIR_Coverage, 8162,
     /* 1263979 */     GIR_EraseRootFromParent_Done,
     /* 1263980 */   // Label 18238: @1263980
     /* 1263980 */   GIM_Try, /*On fail goto*//*Label 18239*/ GIMT_Encode4(1264064), // Rule ID 8163 //
     /* 1263985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1264002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264038 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264063 */     // GIR_Coverage, 8163,
     /* 1264063 */     GIR_EraseRootFromParent_Done,
     /* 1264064 */   // Label 18239: @1264064
     /* 1264064 */   GIM_Try, /*On fail goto*//*Label 18240*/ GIMT_Encode4(1264148), // Rule ID 8166 //
     /* 1264069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264122 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264147 */     // GIR_Coverage, 8166,
     /* 1264147 */     GIR_EraseRootFromParent_Done,
     /* 1264148 */   // Label 18240: @1264148
     /* 1264148 */   GIM_Try, /*On fail goto*//*Label 18241*/ GIMT_Encode4(1264232), // Rule ID 8167 //
     /* 1264153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264206 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264231 */     // GIR_Coverage, 8167,
     /* 1264231 */     GIR_EraseRootFromParent_Done,
     /* 1264232 */   // Label 18241: @1264232
     /* 1264232 */   GIM_Try, /*On fail goto*//*Label 18242*/ GIMT_Encode4(1264316), // Rule ID 8170 //
     /* 1264237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1264254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264290 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264315 */     // GIR_Coverage, 8170,
     /* 1264315 */     GIR_EraseRootFromParent_Done,
     /* 1264316 */   // Label 18242: @1264316
     /* 1264316 */   GIM_Try, /*On fail goto*//*Label 18243*/ GIMT_Encode4(1264400), // Rule ID 8171 //
     /* 1264321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1264338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264374 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264399 */     // GIR_Coverage, 8171,
     /* 1264399 */     GIR_EraseRootFromParent_Done,
     /* 1264400 */   // Label 18243: @1264400
     /* 1264400 */   GIM_Try, /*On fail goto*//*Label 18244*/ GIMT_Encode4(1264484), // Rule ID 8174 //
     /* 1264405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1264422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264458 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264483 */     // GIR_Coverage, 8174,
     /* 1264483 */     GIR_EraseRootFromParent_Done,
     /* 1264484 */   // Label 18244: @1264484
     /* 1264484 */   GIM_Try, /*On fail goto*//*Label 18245*/ GIMT_Encode4(1264568), // Rule ID 8175 //
     /* 1264489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1264506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264542 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264567 */     // GIR_Coverage, 8175,
     /* 1264567 */     GIR_EraseRootFromParent_Done,
     /* 1264568 */   // Label 18245: @1264568
     /* 1264568 */   GIM_Try, /*On fail goto*//*Label 18246*/ GIMT_Encode4(1264652), // Rule ID 8178 //
     /* 1264573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1264590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264626 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1264647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264651 */     // GIR_Coverage, 8178,
     /* 1264651 */     GIR_EraseRootFromParent_Done,
     /* 1264652 */   // Label 18246: @1264652
     /* 1264652 */   GIM_Try, /*On fail goto*//*Label 18247*/ GIMT_Encode4(1264736), // Rule ID 8179 //
     /* 1264657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1264674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264710 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1264731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264735 */     // GIR_Coverage, 8179,
     /* 1264735 */     GIR_EraseRootFromParent_Done,
     /* 1264736 */   // Label 18247: @1264736
     /* 1264736 */   GIM_Try, /*On fail goto*//*Label 18248*/ GIMT_Encode4(1264820), // Rule ID 8182 //
     /* 1264741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1264758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264794 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1264797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264819 */     // GIR_Coverage, 8182,
     /* 1264819 */     GIR_EraseRootFromParent_Done,
     /* 1264820 */   // Label 18248: @1264820
     /* 1264820 */   GIM_Try, /*On fail goto*//*Label 18249*/ GIMT_Encode4(1264904), // Rule ID 8183 //
     /* 1264825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1264842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264878 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1264881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264903 */     // GIR_Coverage, 8183,
     /* 1264903 */     GIR_EraseRootFromParent_Done,
     /* 1264904 */   // Label 18249: @1264904
     /* 1264904 */   GIM_Try, /*On fail goto*//*Label 18250*/ GIMT_Encode4(1264988), // Rule ID 8186 //
     /* 1264909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1264926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264962 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1264965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264987 */     // GIR_Coverage, 8186,
     /* 1264987 */     GIR_EraseRootFromParent_Done,
     /* 1264988 */   // Label 18250: @1264988
     /* 1264988 */   GIM_Try, /*On fail goto*//*Label 18251*/ GIMT_Encode4(1265072), // Rule ID 8187 //
     /* 1264993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1265004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1265007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1265010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265046 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265071 */     // GIR_Coverage, 8187,
     /* 1265071 */     GIR_EraseRootFromParent_Done,
     /* 1265072 */   // Label 18251: @1265072
     /* 1265072 */   GIM_Try, /*On fail goto*//*Label 18252*/ GIMT_Encode4(1265156), // Rule ID 8190 //
     /* 1265077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265130 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265155 */     // GIR_Coverage, 8190,
     /* 1265155 */     GIR_EraseRootFromParent_Done,
     /* 1265156 */   // Label 18252: @1265156
     /* 1265156 */   GIM_Try, /*On fail goto*//*Label 18253*/ GIMT_Encode4(1265240), // Rule ID 8191 //
     /* 1265161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265214 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265239 */     // GIR_Coverage, 8191,
     /* 1265239 */     GIR_EraseRootFromParent_Done,
     /* 1265240 */   // Label 18253: @1265240
     /* 1265240 */   GIM_Try, /*On fail goto*//*Label 18254*/ GIMT_Encode4(1265324), // Rule ID 8194 //
     /* 1265245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1265248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1265262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265298 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265323 */     // GIR_Coverage, 8194,
     /* 1265323 */     GIR_EraseRootFromParent_Done,
     /* 1265324 */   // Label 18254: @1265324
     /* 1265324 */   GIM_Try, /*On fail goto*//*Label 18255*/ GIMT_Encode4(1265408), // Rule ID 8195 //
     /* 1265329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1265332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1265346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265382 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265407 */     // GIR_Coverage, 8195,
     /* 1265407 */     GIR_EraseRootFromParent_Done,
     /* 1265408 */   // Label 18255: @1265408
     /* 1265408 */   GIM_Try, /*On fail goto*//*Label 18256*/ GIMT_Encode4(1265492), // Rule ID 8198 //
     /* 1265413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1265424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1265427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1265430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1265436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265466 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1265469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265491 */     // GIR_Coverage, 8198,
     /* 1265491 */     GIR_EraseRootFromParent_Done,
     /* 1265492 */   // Label 18256: @1265492
     /* 1265492 */   GIM_Try, /*On fail goto*//*Label 18257*/ GIMT_Encode4(1265576), // Rule ID 8199 //
     /* 1265497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1265508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1265511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1265514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1265520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265550 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1265553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265575 */     // GIR_Coverage, 8199,
     /* 1265575 */     GIR_EraseRootFromParent_Done,
     /* 1265576 */   // Label 18257: @1265576
     /* 1265576 */   GIM_Try, /*On fail goto*//*Label 18258*/ GIMT_Encode4(1265660), // Rule ID 8202 //
     /* 1265581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1265592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1265595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1265598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1265604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1265619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265634 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1265637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265659 */     // GIR_Coverage, 8202,
     /* 1265659 */     GIR_EraseRootFromParent_Done,
     /* 1265660 */   // Label 18258: @1265660
     /* 1265660 */   GIM_Try, /*On fail goto*//*Label 18259*/ GIMT_Encode4(1265744), // Rule ID 8203 //
     /* 1265665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1265676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1265679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1265682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1265688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1265703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265718 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1265721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265743 */     // GIR_Coverage, 8203,
     /* 1265743 */     GIR_EraseRootFromParent_Done,
     /* 1265744 */   // Label 18259: @1265744
     /* 1265744 */   GIM_Try, /*On fail goto*//*Label 18260*/ GIMT_Encode4(1265828), // Rule ID 8206 //
     /* 1265749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1265760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1265763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1265766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1265772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1265787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265802 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1265805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265827 */     // GIR_Coverage, 8206,
     /* 1265827 */     GIR_EraseRootFromParent_Done,
     /* 1265828 */   // Label 18260: @1265828
     /* 1265828 */   GIM_Try, /*On fail goto*//*Label 18261*/ GIMT_Encode4(1265912), // Rule ID 8207 //
     /* 1265833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1265844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1265847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1265850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1265856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1265871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265886 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1265889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265911 */     // GIR_Coverage, 8207,
     /* 1265911 */     GIR_EraseRootFromParent_Done,
     /* 1265912 */   // Label 18261: @1265912
     /* 1265912 */   GIM_Try, /*On fail goto*//*Label 18262*/ GIMT_Encode4(1265996), // Rule ID 8210 //
     /* 1265917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1265928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1265931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1265934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1265940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265970 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1265973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265995 */     // GIR_Coverage, 8210,
     /* 1265995 */     GIR_EraseRootFromParent_Done,
     /* 1265996 */   // Label 18262: @1265996
     /* 1265996 */   GIM_Try, /*On fail goto*//*Label 18263*/ GIMT_Encode4(1266080), // Rule ID 8211 //
     /* 1266001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1266018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266054 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266079 */     // GIR_Coverage, 8211,
     /* 1266079 */     GIR_EraseRootFromParent_Done,
     /* 1266080 */   // Label 18263: @1266080
     /* 1266080 */   GIM_Try, /*On fail goto*//*Label 18264*/ GIMT_Encode4(1266164), // Rule ID 8214 //
     /* 1266085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266138 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266163 */     // GIR_Coverage, 8214,
     /* 1266163 */     GIR_EraseRootFromParent_Done,
     /* 1266164 */   // Label 18264: @1266164
     /* 1266164 */   GIM_Try, /*On fail goto*//*Label 18265*/ GIMT_Encode4(1266248), // Rule ID 8215 //
     /* 1266169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266222 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266247 */     // GIR_Coverage, 8215,
     /* 1266247 */     GIR_EraseRootFromParent_Done,
     /* 1266248 */   // Label 18265: @1266248
     /* 1266248 */   GIM_Try, /*On fail goto*//*Label 18266*/ GIMT_Encode4(1266332), // Rule ID 8218 //
     /* 1266253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1266270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266306 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266331 */     // GIR_Coverage, 8218,
     /* 1266331 */     GIR_EraseRootFromParent_Done,
     /* 1266332 */   // Label 18266: @1266332
     /* 1266332 */   GIM_Try, /*On fail goto*//*Label 18267*/ GIMT_Encode4(1266416), // Rule ID 8219 //
     /* 1266337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1266354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266390 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266415 */     // GIR_Coverage, 8219,
     /* 1266415 */     GIR_EraseRootFromParent_Done,
     /* 1266416 */   // Label 18267: @1266416
     /* 1266416 */   GIM_Try, /*On fail goto*//*Label 18268*/ GIMT_Encode4(1266500), // Rule ID 8222 //
     /* 1266421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1266432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1266435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1266438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1266444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266474 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266499 */     // GIR_Coverage, 8222,
     /* 1266499 */     GIR_EraseRootFromParent_Done,
     /* 1266500 */   // Label 18268: @1266500
     /* 1266500 */   GIM_Try, /*On fail goto*//*Label 18269*/ GIMT_Encode4(1266584), // Rule ID 8223 //
     /* 1266505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1266516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1266519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1266522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1266528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266558 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266583 */     // GIR_Coverage, 8223,
     /* 1266583 */     GIR_EraseRootFromParent_Done,
     /* 1266584 */   // Label 18269: @1266584
     /* 1266584 */   GIM_Try, /*On fail goto*//*Label 18270*/ GIMT_Encode4(1266668), // Rule ID 8226 //
     /* 1266589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1266606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266642 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266667 */     // GIR_Coverage, 8226,
     /* 1266667 */     GIR_EraseRootFromParent_Done,
     /* 1266668 */   // Label 18270: @1266668
     /* 1266668 */   GIM_Try, /*On fail goto*//*Label 18271*/ GIMT_Encode4(1266752), // Rule ID 8227 //
     /* 1266673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1266690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266726 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266751 */     // GIR_Coverage, 8227,
     /* 1266751 */     GIR_EraseRootFromParent_Done,
     /* 1266752 */   // Label 18271: @1266752
     /* 1266752 */   GIM_Try, /*On fail goto*//*Label 18272*/ GIMT_Encode4(1266836), // Rule ID 8230 //
     /* 1266757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1266774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266810 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266835 */     // GIR_Coverage, 8230,
     /* 1266835 */     GIR_EraseRootFromParent_Done,
     /* 1266836 */   // Label 18272: @1266836
     /* 1266836 */   GIM_Try, /*On fail goto*//*Label 18273*/ GIMT_Encode4(1266920), // Rule ID 8231 //
     /* 1266841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1266858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266894 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266919 */     // GIR_Coverage, 8231,
     /* 1266919 */     GIR_EraseRootFromParent_Done,
     /* 1266920 */   // Label 18273: @1266920
     /* 1266920 */   GIM_Try, /*On fail goto*//*Label 18274*/ GIMT_Encode4(1267004), // Rule ID 8234 //
     /* 1266925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1266928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1266936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1266939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1266942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1266948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266978 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1266999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267003 */     // GIR_Coverage, 8234,
     /* 1267003 */     GIR_EraseRootFromParent_Done,
     /* 1267004 */   // Label 18274: @1267004
     /* 1267004 */   GIM_Try, /*On fail goto*//*Label 18275*/ GIMT_Encode4(1267088), // Rule ID 8235 //
     /* 1267009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1267026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267062 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1267065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267087 */     // GIR_Coverage, 8235,
     /* 1267087 */     GIR_EraseRootFromParent_Done,
     /* 1267088 */   // Label 18275: @1267088
     /* 1267088 */   GIM_Try, /*On fail goto*//*Label 18276*/ GIMT_Encode4(1267172), // Rule ID 8238 //
     /* 1267093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267146 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1267149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267171 */     // GIR_Coverage, 8238,
     /* 1267171 */     GIR_EraseRootFromParent_Done,
     /* 1267172 */   // Label 18276: @1267172
     /* 1267172 */   GIM_Try, /*On fail goto*//*Label 18277*/ GIMT_Encode4(1267256), // Rule ID 8239 //
     /* 1267177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267230 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1267233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267255 */     // GIR_Coverage, 8239,
     /* 1267255 */     GIR_EraseRootFromParent_Done,
     /* 1267256 */   // Label 18277: @1267256
     /* 1267256 */   GIM_Try, /*On fail goto*//*Label 18278*/ GIMT_Encode4(1267340), // Rule ID 8242 //
     /* 1267261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1267278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267314 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1267317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267339 */     // GIR_Coverage, 8242,
     /* 1267339 */     GIR_EraseRootFromParent_Done,
     /* 1267340 */   // Label 18278: @1267340
     /* 1267340 */   GIM_Try, /*On fail goto*//*Label 18279*/ GIMT_Encode4(1267424), // Rule ID 8243 //
     /* 1267345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1267362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267398 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1267401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267423 */     // GIR_Coverage, 8243,
     /* 1267423 */     GIR_EraseRootFromParent_Done,
     /* 1267424 */   // Label 18279: @1267424
     /* 1267424 */   GIM_Try, /*On fail goto*//*Label 18280*/ GIMT_Encode4(1267508), // Rule ID 8334 //
     /* 1267429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1267440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1267443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1267446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1267449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1267452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267482 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1267485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267507 */     // GIR_Coverage, 8334,
     /* 1267507 */     GIR_EraseRootFromParent_Done,
     /* 1267508 */   // Label 18280: @1267508
     /* 1267508 */   GIM_Try, /*On fail goto*//*Label 18281*/ GIMT_Encode4(1267592), // Rule ID 8335 //
     /* 1267513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1267524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1267527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1267530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1267533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1267536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267566 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1267569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267591 */     // GIR_Coverage, 8335,
     /* 1267591 */     GIR_EraseRootFromParent_Done,
     /* 1267592 */   // Label 18281: @1267592
     /* 1267592 */   GIM_Try, /*On fail goto*//*Label 18282*/ GIMT_Encode4(1267676), // Rule ID 8338 //
     /* 1267597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1267614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1267617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267650 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1267653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267675 */     // GIR_Coverage, 8338,
     /* 1267675 */     GIR_EraseRootFromParent_Done,
     /* 1267676 */   // Label 18282: @1267676
     /* 1267676 */   GIM_Try, /*On fail goto*//*Label 18283*/ GIMT_Encode4(1267760), // Rule ID 8339 //
     /* 1267681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1267698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1267701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267734 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1267737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267759 */     // GIR_Coverage, 8339,
     /* 1267759 */     GIR_EraseRootFromParent_Done,
     /* 1267760 */   // Label 18283: @1267760
     /* 1267760 */   GIM_Try, /*On fail goto*//*Label 18284*/ GIMT_Encode4(1267844), // Rule ID 8342 //
     /* 1267765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1267782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1267785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267818 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1267821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267843 */     // GIR_Coverage, 8342,
     /* 1267843 */     GIR_EraseRootFromParent_Done,
     /* 1267844 */   // Label 18284: @1267844
     /* 1267844 */   GIM_Try, /*On fail goto*//*Label 18285*/ GIMT_Encode4(1267928), // Rule ID 8343 //
     /* 1267849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1267866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1267869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267902 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1267905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267927 */     // GIR_Coverage, 8343,
     /* 1267927 */     GIR_EraseRootFromParent_Done,
     /* 1267928 */   // Label 18285: @1267928
     /* 1267928 */   GIM_Try, /*On fail goto*//*Label 18286*/ GIMT_Encode4(1268012), // Rule ID 8346 //
     /* 1267933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1267944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1267947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1267950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1267953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1267956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267986 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1267989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268011 */     // GIR_Coverage, 8346,
     /* 1268011 */     GIR_EraseRootFromParent_Done,
     /* 1268012 */   // Label 18286: @1268012
     /* 1268012 */   GIM_Try, /*On fail goto*//*Label 18287*/ GIMT_Encode4(1268096), // Rule ID 8347 //
     /* 1268017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1268034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1268037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268070 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1268073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268095 */     // GIR_Coverage, 8347,
     /* 1268095 */     GIR_EraseRootFromParent_Done,
     /* 1268096 */   // Label 18287: @1268096
     /* 1268096 */   GIM_Try, /*On fail goto*//*Label 18288*/ GIMT_Encode4(1268180), // Rule ID 8350 //
     /* 1268101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1268121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268154 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268179 */     // GIR_Coverage, 8350,
     /* 1268179 */     GIR_EraseRootFromParent_Done,
     /* 1268180 */   // Label 18288: @1268180
     /* 1268180 */   GIM_Try, /*On fail goto*//*Label 18289*/ GIMT_Encode4(1268264), // Rule ID 8351 //
     /* 1268185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1268205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268238 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268263 */     // GIR_Coverage, 8351,
     /* 1268263 */     GIR_EraseRootFromParent_Done,
     /* 1268264 */   // Label 18289: @1268264
     /* 1268264 */   GIM_Try, /*On fail goto*//*Label 18290*/ GIMT_Encode4(1268348), // Rule ID 8354 //
     /* 1268269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1268286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1268289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268322 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268347 */     // GIR_Coverage, 8354,
     /* 1268347 */     GIR_EraseRootFromParent_Done,
     /* 1268348 */   // Label 18290: @1268348
     /* 1268348 */   GIM_Try, /*On fail goto*//*Label 18291*/ GIMT_Encode4(1268432), // Rule ID 8355 //
     /* 1268353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1268370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1268373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268406 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268431 */     // GIR_Coverage, 8355,
     /* 1268431 */     GIR_EraseRootFromParent_Done,
     /* 1268432 */   // Label 18291: @1268432
     /* 1268432 */   GIM_Try, /*On fail goto*//*Label 18292*/ GIMT_Encode4(1268516), // Rule ID 8358 //
     /* 1268437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1268454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1268457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268490 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268515 */     // GIR_Coverage, 8358,
     /* 1268515 */     GIR_EraseRootFromParent_Done,
     /* 1268516 */   // Label 18292: @1268516
     /* 1268516 */   GIM_Try, /*On fail goto*//*Label 18293*/ GIMT_Encode4(1268600), // Rule ID 8359 //
     /* 1268521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1268538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1268541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268574 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268599 */     // GIR_Coverage, 8359,
     /* 1268599 */     GIR_EraseRootFromParent_Done,
     /* 1268600 */   // Label 18293: @1268600
     /* 1268600 */   GIM_Try, /*On fail goto*//*Label 18294*/ GIMT_Encode4(1268684), // Rule ID 8362 //
     /* 1268605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1268622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1268625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268658 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268683 */     // GIR_Coverage, 8362,
     /* 1268683 */     GIR_EraseRootFromParent_Done,
     /* 1268684 */   // Label 18294: @1268684
     /* 1268684 */   GIM_Try, /*On fail goto*//*Label 18295*/ GIMT_Encode4(1268768), // Rule ID 8363 //
     /* 1268689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1268706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1268709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268742 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268767 */     // GIR_Coverage, 8363,
     /* 1268767 */     GIR_EraseRootFromParent_Done,
     /* 1268768 */   // Label 18295: @1268768
     /* 1268768 */   GIM_Try, /*On fail goto*//*Label 18296*/ GIMT_Encode4(1268852), // Rule ID 8366 //
     /* 1268773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1268790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1268793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268826 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268851 */     // GIR_Coverage, 8366,
     /* 1268851 */     GIR_EraseRootFromParent_Done,
     /* 1268852 */   // Label 18296: @1268852
     /* 1268852 */   GIM_Try, /*On fail goto*//*Label 18297*/ GIMT_Encode4(1268936), // Rule ID 8367 //
     /* 1268857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1268874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1268877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268910 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268935 */     // GIR_Coverage, 8367,
     /* 1268935 */     GIR_EraseRootFromParent_Done,
     /* 1268936 */   // Label 18297: @1268936
     /* 1268936 */   GIM_Try, /*On fail goto*//*Label 18298*/ GIMT_Encode4(1269020), // Rule ID 8370 //
     /* 1268941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1268944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1268958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1268961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268994 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269019 */     // GIR_Coverage, 8370,
     /* 1269019 */     GIR_EraseRootFromParent_Done,
     /* 1269020 */   // Label 18298: @1269020
     /* 1269020 */   GIM_Try, /*On fail goto*//*Label 18299*/ GIMT_Encode4(1269104), // Rule ID 8371 //
     /* 1269025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1269028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1269042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1269045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269078 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269103 */     // GIR_Coverage, 8371,
     /* 1269103 */     GIR_EraseRootFromParent_Done,
     /* 1269104 */   // Label 18299: @1269104
     /* 1269104 */   GIM_Try, /*On fail goto*//*Label 18300*/ GIMT_Encode4(1269188), // Rule ID 8374 //
     /* 1269109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1269126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1269129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269162 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1269165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269187 */     // GIR_Coverage, 8374,
     /* 1269187 */     GIR_EraseRootFromParent_Done,
     /* 1269188 */   // Label 18300: @1269188
     /* 1269188 */   GIM_Try, /*On fail goto*//*Label 18301*/ GIMT_Encode4(1269272), // Rule ID 8375 //
     /* 1269193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1269210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1269213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269246 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1269249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269271 */     // GIR_Coverage, 8375,
     /* 1269271 */     GIR_EraseRootFromParent_Done,
     /* 1269272 */   // Label 18301: @1269272
     /* 1269272 */   GIM_Try, /*On fail goto*//*Label 18302*/ GIMT_Encode4(1269356), // Rule ID 8378 //
     /* 1269277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1269288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1269291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1269294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1269297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269330 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1269333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269355 */     // GIR_Coverage, 8378,
     /* 1269355 */     GIR_EraseRootFromParent_Done,
     /* 1269356 */   // Label 18302: @1269356
     /* 1269356 */   GIM_Try, /*On fail goto*//*Label 18303*/ GIMT_Encode4(1269440), // Rule ID 8379 //
     /* 1269361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1269372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1269375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1269378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1269381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269414 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1269417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269439 */     // GIR_Coverage, 8379,
     /* 1269439 */     GIR_EraseRootFromParent_Done,
     /* 1269440 */   // Label 18303: @1269440
     /* 1269440 */   GIM_Try, /*On fail goto*//*Label 18304*/ GIMT_Encode4(1269524), // Rule ID 8382 //
     /* 1269445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1269456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1269459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1269462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1269465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1269468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269498 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1269501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269523 */     // GIR_Coverage, 8382,
     /* 1269523 */     GIR_EraseRootFromParent_Done,
     /* 1269524 */   // Label 18304: @1269524
     /* 1269524 */   GIM_Try, /*On fail goto*//*Label 18305*/ GIMT_Encode4(1269608), // Rule ID 8383 //
     /* 1269529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1269540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1269543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1269546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1269549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1269552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269582 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1269585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269607 */     // GIR_Coverage, 8383,
     /* 1269607 */     GIR_EraseRootFromParent_Done,
     /* 1269608 */   // Label 18305: @1269608
     /* 1269608 */   GIM_Try, /*On fail goto*//*Label 18306*/ GIMT_Encode4(1269692), // Rule ID 8386 //
     /* 1269613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1269624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1269627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1269630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1269633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1269636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269666 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1269669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269691 */     // GIR_Coverage, 8386,
     /* 1269691 */     GIR_EraseRootFromParent_Done,
     /* 1269692 */   // Label 18306: @1269692
     /* 1269692 */   GIM_Try, /*On fail goto*//*Label 18307*/ GIMT_Encode4(1269776), // Rule ID 8387 //
     /* 1269697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1269708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1269711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1269714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1269717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1269720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269750 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1269753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269775 */     // GIR_Coverage, 8387,
     /* 1269775 */     GIR_EraseRootFromParent_Done,
     /* 1269776 */   // Label 18307: @1269776
     /* 1269776 */   GIM_Try, /*On fail goto*//*Label 18308*/ GIMT_Encode4(1269860), // Rule ID 8390 //
     /* 1269781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1269798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1269801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269834 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1269837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269859 */     // GIR_Coverage, 8390,
     /* 1269859 */     GIR_EraseRootFromParent_Done,
     /* 1269860 */   // Label 18308: @1269860
     /* 1269860 */   GIM_Try, /*On fail goto*//*Label 18309*/ GIMT_Encode4(1269944), // Rule ID 8391 //
     /* 1269865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1269882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1269885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269918 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1269921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269943 */     // GIR_Coverage, 8391,
     /* 1269943 */     GIR_EraseRootFromParent_Done,
     /* 1269944 */   // Label 18309: @1269944
     /* 1269944 */   GIM_Try, /*On fail goto*//*Label 18310*/ GIMT_Encode4(1270028), // Rule ID 8394 //
     /* 1269949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1269960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1269963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1269966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1269969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270002 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270027 */     // GIR_Coverage, 8394,
     /* 1270027 */     GIR_EraseRootFromParent_Done,
     /* 1270028 */   // Label 18310: @1270028
     /* 1270028 */   GIM_Try, /*On fail goto*//*Label 18311*/ GIMT_Encode4(1270112), // Rule ID 8395 //
     /* 1270033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1270050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1270053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270086 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270111 */     // GIR_Coverage, 8395,
     /* 1270111 */     GIR_EraseRootFromParent_Done,
     /* 1270112 */   // Label 18311: @1270112
     /* 1270112 */   GIM_Try, /*On fail goto*//*Label 18312*/ GIMT_Encode4(1270196), // Rule ID 8398 //
     /* 1270117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1270134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1270137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270170 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270195 */     // GIR_Coverage, 8398,
     /* 1270195 */     GIR_EraseRootFromParent_Done,
     /* 1270196 */   // Label 18312: @1270196
     /* 1270196 */   GIM_Try, /*On fail goto*//*Label 18313*/ GIMT_Encode4(1270280), // Rule ID 8399 //
     /* 1270201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1270218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1270221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270254 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270279 */     // GIR_Coverage, 8399,
     /* 1270279 */     GIR_EraseRootFromParent_Done,
     /* 1270280 */   // Label 18313: @1270280
     /* 1270280 */   GIM_Try, /*On fail goto*//*Label 18314*/ GIMT_Encode4(1270364), // Rule ID 8402 //
     /* 1270285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1270302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1270305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270338 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270363 */     // GIR_Coverage, 8402,
     /* 1270363 */     GIR_EraseRootFromParent_Done,
     /* 1270364 */   // Label 18314: @1270364
     /* 1270364 */   GIM_Try, /*On fail goto*//*Label 18315*/ GIMT_Encode4(1270448), // Rule ID 8403 //
     /* 1270369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1270386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1270389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270422 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270447 */     // GIR_Coverage, 8403,
     /* 1270447 */     GIR_EraseRootFromParent_Done,
     /* 1270448 */   // Label 18315: @1270448
     /* 1270448 */   GIM_Try, /*On fail goto*//*Label 18316*/ GIMT_Encode4(1270532), // Rule ID 8406 //
     /* 1270453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1270470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1270473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270506 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270531 */     // GIR_Coverage, 8406,
     /* 1270531 */     GIR_EraseRootFromParent_Done,
     /* 1270532 */   // Label 18316: @1270532
     /* 1270532 */   GIM_Try, /*On fail goto*//*Label 18317*/ GIMT_Encode4(1270616), // Rule ID 8407 //
     /* 1270537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1270554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1270557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270590 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270615 */     // GIR_Coverage, 8407,
     /* 1270615 */     GIR_EraseRootFromParent_Done,
     /* 1270616 */   // Label 18317: @1270616
     /* 1270616 */   GIM_Try, /*On fail goto*//*Label 18318*/ GIMT_Encode4(1270700), // Rule ID 8410 //
     /* 1270621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1270624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1270632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1270635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1270638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1270641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1270644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270674 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1270695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270699 */     // GIR_Coverage, 8410,
     /* 1270699 */     GIR_EraseRootFromParent_Done,
     /* 1270700 */   // Label 18318: @1270700
     /* 1270700 */   GIM_Try, /*On fail goto*//*Label 18319*/ GIMT_Encode4(1270784), // Rule ID 8411 //
     /* 1270705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1270708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1270716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1270719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1270722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1270725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1270728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270758 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1270779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270783 */     // GIR_Coverage, 8411,
     /* 1270783 */     GIR_EraseRootFromParent_Done,
     /* 1270784 */   // Label 18319: @1270784
     /* 1270784 */   GIM_Try, /*On fail goto*//*Label 18320*/ GIMT_Encode4(1270868), // Rule ID 8414 //
     /* 1270789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1270792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1270806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1270809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270842 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1270863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270867 */     // GIR_Coverage, 8414,
     /* 1270867 */     GIR_EraseRootFromParent_Done,
     /* 1270868 */   // Label 18320: @1270868
     /* 1270868 */   GIM_Try, /*On fail goto*//*Label 18321*/ GIMT_Encode4(1270952), // Rule ID 8415 //
     /* 1270873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1270876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1270890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1270893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270926 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1270947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270951 */     // GIR_Coverage, 8415,
     /* 1270951 */     GIR_EraseRootFromParent_Done,
     /* 1270952 */   // Label 18321: @1270952
     /* 1270952 */   GIM_Try, /*On fail goto*//*Label 18322*/ GIMT_Encode4(1271036), // Rule ID 8418 //
     /* 1270957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1270960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1270974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1270977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271010 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1271013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271035 */     // GIR_Coverage, 8418,
     /* 1271035 */     GIR_EraseRootFromParent_Done,
     /* 1271036 */   // Label 18322: @1271036
     /* 1271036 */   GIM_Try, /*On fail goto*//*Label 18323*/ GIMT_Encode4(1271120), // Rule ID 8419 //
     /* 1271041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1271058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1271061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271094 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1271097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271119 */     // GIR_Coverage, 8419,
     /* 1271119 */     GIR_EraseRootFromParent_Done,
     /* 1271120 */   // Label 18323: @1271120
     /* 1271120 */   GIM_Try, /*On fail goto*//*Label 18324*/ GIMT_Encode4(1271204), // Rule ID 8422 //
     /* 1271125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1271142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271178 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1271181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271203 */     // GIR_Coverage, 8422,
     /* 1271203 */     GIR_EraseRootFromParent_Done,
     /* 1271204 */   // Label 18324: @1271204
     /* 1271204 */   GIM_Try, /*On fail goto*//*Label 18325*/ GIMT_Encode4(1271288), // Rule ID 8423 //
     /* 1271209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1271226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271262 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1271265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271287 */     // GIR_Coverage, 8423,
     /* 1271287 */     GIR_EraseRootFromParent_Done,
     /* 1271288 */   // Label 18325: @1271288
     /* 1271288 */   GIM_Try, /*On fail goto*//*Label 18326*/ GIMT_Encode4(1271372), // Rule ID 8426 //
     /* 1271293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1271310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271346 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1271349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271371 */     // GIR_Coverage, 8426,
     /* 1271371 */     GIR_EraseRootFromParent_Done,
     /* 1271372 */   // Label 18326: @1271372
     /* 1271372 */   GIM_Try, /*On fail goto*//*Label 18327*/ GIMT_Encode4(1271456), // Rule ID 8427 //
     /* 1271377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1271394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271430 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1271433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271455 */     // GIR_Coverage, 8427,
     /* 1271455 */     GIR_EraseRootFromParent_Done,
     /* 1271456 */   // Label 18327: @1271456
     /* 1271456 */   GIM_Try, /*On fail goto*//*Label 18328*/ GIMT_Encode4(1271540), // Rule ID 8430 //
     /* 1271461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1271478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271514 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1271517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271539 */     // GIR_Coverage, 8430,
     /* 1271539 */     GIR_EraseRootFromParent_Done,
     /* 1271540 */   // Label 18328: @1271540
     /* 1271540 */   GIM_Try, /*On fail goto*//*Label 18329*/ GIMT_Encode4(1271624), // Rule ID 8431 //
     /* 1271545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1271562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271598 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1271601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271623 */     // GIR_Coverage, 8431,
     /* 1271623 */     GIR_EraseRootFromParent_Done,
     /* 1271624 */   // Label 18329: @1271624
     /* 1271624 */   GIM_Try, /*On fail goto*//*Label 18330*/ GIMT_Encode4(1271708), // Rule ID 8434 //
     /* 1271629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1271646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271682 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1271685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271707 */     // GIR_Coverage, 8434,
     /* 1271707 */     GIR_EraseRootFromParent_Done,
     /* 1271708 */   // Label 18330: @1271708
     /* 1271708 */   GIM_Try, /*On fail goto*//*Label 18331*/ GIMT_Encode4(1271792), // Rule ID 8435 //
     /* 1271713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1271730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271766 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1271769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271791 */     // GIR_Coverage, 8435,
     /* 1271791 */     GIR_EraseRootFromParent_Done,
     /* 1271792 */   // Label 18331: @1271792
     /* 1271792 */   GIM_Try, /*On fail goto*//*Label 18332*/ GIMT_Encode4(1271876), // Rule ID 8438 //
     /* 1271797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1271814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271850 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1271853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271875 */     // GIR_Coverage, 8438,
     /* 1271875 */     GIR_EraseRootFromParent_Done,
     /* 1271876 */   // Label 18332: @1271876
     /* 1271876 */   GIM_Try, /*On fail goto*//*Label 18333*/ GIMT_Encode4(1271960), // Rule ID 8439 //
     /* 1271881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1271898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271934 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1271937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271959 */     // GIR_Coverage, 8439,
     /* 1271959 */     GIR_EraseRootFromParent_Done,
     /* 1271960 */   // Label 18333: @1271960
     /* 1271960 */   GIM_Try, /*On fail goto*//*Label 18334*/ GIMT_Encode4(1272044), // Rule ID 8442 //
     /* 1271965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1271982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272018 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272043 */     // GIR_Coverage, 8442,
     /* 1272043 */     GIR_EraseRootFromParent_Done,
     /* 1272044 */   // Label 18334: @1272044
     /* 1272044 */   GIM_Try, /*On fail goto*//*Label 18335*/ GIMT_Encode4(1272128), // Rule ID 8443 //
     /* 1272049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1272066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272102 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272127 */     // GIR_Coverage, 8443,
     /* 1272127 */     GIR_EraseRootFromParent_Done,
     /* 1272128 */   // Label 18335: @1272128
     /* 1272128 */   GIM_Try, /*On fail goto*//*Label 18336*/ GIMT_Encode4(1272212), // Rule ID 8446 //
     /* 1272133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1272144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1272147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1272150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272186 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272211 */     // GIR_Coverage, 8446,
     /* 1272211 */     GIR_EraseRootFromParent_Done,
     /* 1272212 */   // Label 18336: @1272212
     /* 1272212 */   GIM_Try, /*On fail goto*//*Label 18337*/ GIMT_Encode4(1272296), // Rule ID 8447 //
     /* 1272217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1272228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1272231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1272234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272270 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272295 */     // GIR_Coverage, 8447,
     /* 1272295 */     GIR_EraseRootFromParent_Done,
     /* 1272296 */   // Label 18337: @1272296
     /* 1272296 */   GIM_Try, /*On fail goto*//*Label 18338*/ GIMT_Encode4(1272380), // Rule ID 8450 //
     /* 1272301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1272318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272354 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272379 */     // GIR_Coverage, 8450,
     /* 1272379 */     GIR_EraseRootFromParent_Done,
     /* 1272380 */   // Label 18338: @1272380
     /* 1272380 */   GIM_Try, /*On fail goto*//*Label 18339*/ GIMT_Encode4(1272464), // Rule ID 8451 //
     /* 1272385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1272402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272438 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272463 */     // GIR_Coverage, 8451,
     /* 1272463 */     GIR_EraseRootFromParent_Done,
     /* 1272464 */   // Label 18339: @1272464
     /* 1272464 */   GIM_Try, /*On fail goto*//*Label 18340*/ GIMT_Encode4(1272548), // Rule ID 8454 //
     /* 1272469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1272486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272522 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272547 */     // GIR_Coverage, 8454,
     /* 1272547 */     GIR_EraseRootFromParent_Done,
     /* 1272548 */   // Label 18340: @1272548
     /* 1272548 */   GIM_Try, /*On fail goto*//*Label 18341*/ GIMT_Encode4(1272632), // Rule ID 8455 //
     /* 1272553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1272570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272606 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272631 */     // GIR_Coverage, 8455,
     /* 1272631 */     GIR_EraseRootFromParent_Done,
     /* 1272632 */   // Label 18341: @1272632
     /* 1272632 */   GIM_Try, /*On fail goto*//*Label 18342*/ GIMT_Encode4(1272716), // Rule ID 8458 //
     /* 1272637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1272640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1272654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272690 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1272711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272715 */     // GIR_Coverage, 8458,
     /* 1272715 */     GIR_EraseRootFromParent_Done,
     /* 1272716 */   // Label 18342: @1272716
     /* 1272716 */   GIM_Try, /*On fail goto*//*Label 18343*/ GIMT_Encode4(1272800), // Rule ID 8459 //
     /* 1272721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1272724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1272738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272774 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1272795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272799 */     // GIR_Coverage, 8459,
     /* 1272799 */     GIR_EraseRootFromParent_Done,
     /* 1272800 */   // Label 18343: @1272800
     /* 1272800 */   GIM_Try, /*On fail goto*//*Label 18344*/ GIMT_Encode4(1272884), // Rule ID 8462 //
     /* 1272805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1272816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1272819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1272822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1272828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1272843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272858 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1272861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272883 */     // GIR_Coverage, 8462,
     /* 1272883 */     GIR_EraseRootFromParent_Done,
     /* 1272884 */   // Label 18344: @1272884
     /* 1272884 */   GIM_Try, /*On fail goto*//*Label 18345*/ GIMT_Encode4(1272968), // Rule ID 8463 //
     /* 1272889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1272900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1272903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1272906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1272912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1272927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272942 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1272945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272967 */     // GIR_Coverage, 8463,
     /* 1272967 */     GIR_EraseRootFromParent_Done,
     /* 1272968 */   // Label 18345: @1272968
     /* 1272968 */   GIM_Try, /*On fail goto*//*Label 18346*/ GIMT_Encode4(1273052), // Rule ID 8466 //
     /* 1272973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1272984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1272987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1272990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1272996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273026 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273051 */     // GIR_Coverage, 8466,
     /* 1273051 */     GIR_EraseRootFromParent_Done,
     /* 1273052 */   // Label 18346: @1273052
     /* 1273052 */   GIM_Try, /*On fail goto*//*Label 18347*/ GIMT_Encode4(1273136), // Rule ID 8467 //
     /* 1273057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1273074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273110 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273135 */     // GIR_Coverage, 8467,
     /* 1273135 */     GIR_EraseRootFromParent_Done,
     /* 1273136 */   // Label 18347: @1273136
     /* 1273136 */   GIM_Try, /*On fail goto*//*Label 18348*/ GIMT_Encode4(1273220), // Rule ID 8470 //
     /* 1273141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1273152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1273155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1273158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1273164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273194 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1273197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273219 */     // GIR_Coverage, 8470,
     /* 1273219 */     GIR_EraseRootFromParent_Done,
     /* 1273220 */   // Label 18348: @1273220
     /* 1273220 */   GIM_Try, /*On fail goto*//*Label 18349*/ GIMT_Encode4(1273304), // Rule ID 8471 //
     /* 1273225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1273236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1273239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1273242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1273248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273278 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1273281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273303 */     // GIR_Coverage, 8471,
     /* 1273303 */     GIR_EraseRootFromParent_Done,
     /* 1273304 */   // Label 18349: @1273304
     /* 1273304 */   GIM_Try, /*On fail goto*//*Label 18350*/ GIMT_Encode4(1273388), // Rule ID 8474 //
     /* 1273309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1273326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273362 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273387 */     // GIR_Coverage, 8474,
     /* 1273387 */     GIR_EraseRootFromParent_Done,
     /* 1273388 */   // Label 18350: @1273388
     /* 1273388 */   GIM_Try, /*On fail goto*//*Label 18351*/ GIMT_Encode4(1273472), // Rule ID 8475 //
     /* 1273393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1273410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273446 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273471 */     // GIR_Coverage, 8475,
     /* 1273471 */     GIR_EraseRootFromParent_Done,
     /* 1273472 */   // Label 18351: @1273472
     /* 1273472 */   GIM_Try, /*On fail goto*//*Label 18352*/ GIMT_Encode4(1273556), // Rule ID 8478 //
     /* 1273477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1273494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273530 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273555 */     // GIR_Coverage, 8478,
     /* 1273555 */     GIR_EraseRootFromParent_Done,
     /* 1273556 */   // Label 18352: @1273556
     /* 1273556 */   GIM_Try, /*On fail goto*//*Label 18353*/ GIMT_Encode4(1273640), // Rule ID 8479 //
     /* 1273561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1273578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273614 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273639 */     // GIR_Coverage, 8479,
     /* 1273639 */     GIR_EraseRootFromParent_Done,
     /* 1273640 */   // Label 18353: @1273640
     /* 1273640 */   GIM_Try, /*On fail goto*//*Label 18354*/ GIMT_Encode4(1273724), // Rule ID 8482 //
     /* 1273645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1273662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273698 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1273701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273723 */     // GIR_Coverage, 8482,
     /* 1273723 */     GIR_EraseRootFromParent_Done,
     /* 1273724 */   // Label 18354: @1273724
     /* 1273724 */   GIM_Try, /*On fail goto*//*Label 18355*/ GIMT_Encode4(1273808), // Rule ID 8483 //
     /* 1273729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1273746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273782 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1273785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273807 */     // GIR_Coverage, 8483,
     /* 1273807 */     GIR_EraseRootFromParent_Done,
     /* 1273808 */   // Label 18355: @1273808
     /* 1273808 */   GIM_Try, /*On fail goto*//*Label 18356*/ GIMT_Encode4(1273892), // Rule ID 8486 //
     /* 1273813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1273824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1273827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1273830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1273836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273866 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273891 */     // GIR_Coverage, 8486,
     /* 1273891 */     GIR_EraseRootFromParent_Done,
     /* 1273892 */   // Label 18356: @1273892
     /* 1273892 */   GIM_Try, /*On fail goto*//*Label 18357*/ GIMT_Encode4(1273976), // Rule ID 8487 //
     /* 1273897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1273908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1273911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1273914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1273920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273950 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273975 */     // GIR_Coverage, 8487,
     /* 1273975 */     GIR_EraseRootFromParent_Done,
     /* 1273976 */   // Label 18357: @1273976
     /* 1273976 */   GIM_Try, /*On fail goto*//*Label 18358*/ GIMT_Encode4(1274060), // Rule ID 8490 //
     /* 1273981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1273998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274034 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274059 */     // GIR_Coverage, 8490,
     /* 1274059 */     GIR_EraseRootFromParent_Done,
     /* 1274060 */   // Label 18358: @1274060
     /* 1274060 */   GIM_Try, /*On fail goto*//*Label 18359*/ GIMT_Encode4(1274144), // Rule ID 8491 //
     /* 1274065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1274082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274118 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274143 */     // GIR_Coverage, 8491,
     /* 1274143 */     GIR_EraseRootFromParent_Done,
     /* 1274144 */   // Label 18359: @1274144
     /* 1274144 */   GIM_Try, /*On fail goto*//*Label 18360*/ GIMT_Encode4(1274228), // Rule ID 8494 //
     /* 1274149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1274166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274202 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274227 */     // GIR_Coverage, 8494,
     /* 1274227 */     GIR_EraseRootFromParent_Done,
     /* 1274228 */   // Label 18360: @1274228
     /* 1274228 */   GIM_Try, /*On fail goto*//*Label 18361*/ GIMT_Encode4(1274312), // Rule ID 8495 //
     /* 1274233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1274250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274286 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274311 */     // GIR_Coverage, 8495,
     /* 1274311 */     GIR_EraseRootFromParent_Done,
     /* 1274312 */   // Label 18361: @1274312
     /* 1274312 */   GIM_Try, /*On fail goto*//*Label 18362*/ GIMT_Encode4(1274396), // Rule ID 8498 //
     /* 1274317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1274328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1274331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1274334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1274340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274370 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1274373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274395 */     // GIR_Coverage, 8498,
     /* 1274395 */     GIR_EraseRootFromParent_Done,
     /* 1274396 */   // Label 18362: @1274396
     /* 1274396 */   GIM_Try, /*On fail goto*//*Label 18363*/ GIMT_Encode4(1274480), // Rule ID 8499 //
     /* 1274401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1274404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1274412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1274415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1274418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1274424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274454 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1274457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274479 */     // GIR_Coverage, 8499,
     /* 1274479 */     GIR_EraseRootFromParent_Done,
     /* 1274480 */   // Label 18363: @1274480
     /* 1274480 */   GIM_Try, /*On fail goto*//*Label 18364*/ GIMT_Encode4(1274564), // Rule ID 8502 //
     /* 1274485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1274502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274538 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274563 */     // GIR_Coverage, 8502,
     /* 1274563 */     GIR_EraseRootFromParent_Done,
     /* 1274564 */   // Label 18364: @1274564
     /* 1274564 */   GIM_Try, /*On fail goto*//*Label 18365*/ GIMT_Encode4(1274648), // Rule ID 8503 //
     /* 1274569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1274572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1274586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274622 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274647 */     // GIR_Coverage, 8503,
     /* 1274647 */     GIR_EraseRootFromParent_Done,
     /* 1274648 */   // Label 18365: @1274648
     /* 1274648 */   GIM_Try, /*On fail goto*//*Label 18366*/ GIMT_Encode4(1274732), // Rule ID 8506 //
     /* 1274653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1274670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274706 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274731 */     // GIR_Coverage, 8506,
     /* 1274731 */     GIR_EraseRootFromParent_Done,
     /* 1274732 */   // Label 18366: @1274732
     /* 1274732 */   GIM_Try, /*On fail goto*//*Label 18367*/ GIMT_Encode4(1274816), // Rule ID 8507 //
     /* 1274737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1274740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1274754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274790 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274815 */     // GIR_Coverage, 8507,
     /* 1274815 */     GIR_EraseRootFromParent_Done,
     /* 1274816 */   // Label 18367: @1274816
     /* 1274816 */   GIM_Try, /*On fail goto*//*Label 18368*/ GIMT_Encode4(1274900), // Rule ID 8510 //
     /* 1274821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1274832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1274835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1274838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1274841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1274844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274874 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1274877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1274895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274899 */     // GIR_Coverage, 8510,
     /* 1274899 */     GIR_EraseRootFromParent_Done,
     /* 1274900 */   // Label 18368: @1274900
     /* 1274900 */   GIM_Try, /*On fail goto*//*Label 18369*/ GIMT_Encode4(1274984), // Rule ID 8511 //
     /* 1274905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1274916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1274919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1274922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1274925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1274928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274958 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1274961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1274979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274983 */     // GIR_Coverage, 8511,
     /* 1274983 */     GIR_EraseRootFromParent_Done,
     /* 1274984 */   // Label 18369: @1274984
     /* 1274984 */   GIM_Try, /*On fail goto*//*Label 18370*/ GIMT_Encode4(1275068), // Rule ID 8514 //
     /* 1274989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1275006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1275009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275042 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275067 */     // GIR_Coverage, 8514,
     /* 1275067 */     GIR_EraseRootFromParent_Done,
     /* 1275068 */   // Label 18370: @1275068
     /* 1275068 */   GIM_Try, /*On fail goto*//*Label 18371*/ GIMT_Encode4(1275152), // Rule ID 8515 //
     /* 1275073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1275090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1275093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275126 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275151 */     // GIR_Coverage, 8515,
     /* 1275151 */     GIR_EraseRootFromParent_Done,
     /* 1275152 */   // Label 18371: @1275152
     /* 1275152 */   GIM_Try, /*On fail goto*//*Label 18372*/ GIMT_Encode4(1275236), // Rule ID 8518 //
     /* 1275157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1275174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1275177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275210 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275235 */     // GIR_Coverage, 8518,
     /* 1275235 */     GIR_EraseRootFromParent_Done,
     /* 1275236 */   // Label 18372: @1275236
     /* 1275236 */   GIM_Try, /*On fail goto*//*Label 18373*/ GIMT_Encode4(1275320), // Rule ID 8519 //
     /* 1275241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1275258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1275261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275294 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275319 */     // GIR_Coverage, 8519,
     /* 1275319 */     GIR_EraseRootFromParent_Done,
     /* 1275320 */   // Label 18373: @1275320
     /* 1275320 */   GIM_Try, /*On fail goto*//*Label 18374*/ GIMT_Encode4(1275404), // Rule ID 8522 //
     /* 1275325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1275342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1275345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275378 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275403 */     // GIR_Coverage, 8522,
     /* 1275403 */     GIR_EraseRootFromParent_Done,
     /* 1275404 */   // Label 18374: @1275404
     /* 1275404 */   GIM_Try, /*On fail goto*//*Label 18375*/ GIMT_Encode4(1275488), // Rule ID 8523 //
     /* 1275409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1275426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1275429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275462 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275487 */     // GIR_Coverage, 8523,
     /* 1275487 */     GIR_EraseRootFromParent_Done,
     /* 1275488 */   // Label 18375: @1275488
     /* 1275488 */   GIM_Try, /*On fail goto*//*Label 18376*/ GIMT_Encode4(1275572), // Rule ID 8526 //
     /* 1275493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1275510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1275513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275546 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275571 */     // GIR_Coverage, 8526,
     /* 1275571 */     GIR_EraseRootFromParent_Done,
     /* 1275572 */   // Label 18376: @1275572
     /* 1275572 */   GIM_Try, /*On fail goto*//*Label 18377*/ GIMT_Encode4(1275656), // Rule ID 8527 //
     /* 1275577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1275594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1275597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275630 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275655 */     // GIR_Coverage, 8527,
     /* 1275655 */     GIR_EraseRootFromParent_Done,
     /* 1275656 */   // Label 18377: @1275656
     /* 1275656 */   GIM_Try, /*On fail goto*//*Label 18378*/ GIMT_Encode4(1275740), // Rule ID 8530 //
     /* 1275661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1275678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1275681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275714 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275739 */     // GIR_Coverage, 8530,
     /* 1275739 */     GIR_EraseRootFromParent_Done,
     /* 1275740 */   // Label 18378: @1275740
     /* 1275740 */   GIM_Try, /*On fail goto*//*Label 18379*/ GIMT_Encode4(1275824), // Rule ID 8531 //
     /* 1275745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1275762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1275765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275798 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275823 */     // GIR_Coverage, 8531,
     /* 1275823 */     GIR_EraseRootFromParent_Done,
     /* 1275824 */   // Label 18379: @1275824
     /* 1275824 */   GIM_Try, /*On fail goto*//*Label 18380*/ GIMT_Encode4(1275908), // Rule ID 8534 //
     /* 1275829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1275840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1275843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1275846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1275849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275882 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1275885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275907 */     // GIR_Coverage, 8534,
     /* 1275907 */     GIR_EraseRootFromParent_Done,
     /* 1275908 */   // Label 18380: @1275908
     /* 1275908 */   GIM_Try, /*On fail goto*//*Label 18381*/ GIMT_Encode4(1275992), // Rule ID 8535 //
     /* 1275913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1275924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1275927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1275930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1275933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275966 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1275969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275991 */     // GIR_Coverage, 8535,
     /* 1275991 */     GIR_EraseRootFromParent_Done,
     /* 1275992 */   // Label 18381: @1275992
     /* 1275992 */   GIM_Try, /*On fail goto*//*Label 18382*/ GIMT_Encode4(1276076), // Rule ID 8538 //
     /* 1275997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276050 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276075 */     // GIR_Coverage, 8538,
     /* 1276075 */     GIR_EraseRootFromParent_Done,
     /* 1276076 */   // Label 18382: @1276076
     /* 1276076 */   GIM_Try, /*On fail goto*//*Label 18383*/ GIMT_Encode4(1276160), // Rule ID 8539 //
     /* 1276081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276134 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276159 */     // GIR_Coverage, 8539,
     /* 1276159 */     GIR_EraseRootFromParent_Done,
     /* 1276160 */   // Label 18383: @1276160
     /* 1276160 */   GIM_Try, /*On fail goto*//*Label 18384*/ GIMT_Encode4(1276244), // Rule ID 8542 //
     /* 1276165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1276182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1276185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276218 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276243 */     // GIR_Coverage, 8542,
     /* 1276243 */     GIR_EraseRootFromParent_Done,
     /* 1276244 */   // Label 18384: @1276244
     /* 1276244 */   GIM_Try, /*On fail goto*//*Label 18385*/ GIMT_Encode4(1276328), // Rule ID 8543 //
     /* 1276249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1276266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1276269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276302 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276327 */     // GIR_Coverage, 8543,
     /* 1276327 */     GIR_EraseRootFromParent_Done,
     /* 1276328 */   // Label 18385: @1276328
     /* 1276328 */   GIM_Try, /*On fail goto*//*Label 18386*/ GIMT_Encode4(1276412), // Rule ID 8546 //
     /* 1276333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1276336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1276350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1276353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276386 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276411 */     // GIR_Coverage, 8546,
     /* 1276411 */     GIR_EraseRootFromParent_Done,
     /* 1276412 */   // Label 18386: @1276412
     /* 1276412 */   GIM_Try, /*On fail goto*//*Label 18387*/ GIMT_Encode4(1276496), // Rule ID 8547 //
     /* 1276417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1276420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1276434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1276437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276470 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276495 */     // GIR_Coverage, 8547,
     /* 1276495 */     GIR_EraseRootFromParent_Done,
     /* 1276496 */   // Label 18387: @1276496
     /* 1276496 */   GIM_Try, /*On fail goto*//*Label 18388*/ GIMT_Encode4(1276580), // Rule ID 8550 //
     /* 1276501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1276512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1276515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1276518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1276521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1276524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1276539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1276543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276554 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1276557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276579 */     // GIR_Coverage, 8550,
     /* 1276579 */     GIR_EraseRootFromParent_Done,
     /* 1276580 */   // Label 18388: @1276580
     /* 1276580 */   GIM_Try, /*On fail goto*//*Label 18389*/ GIMT_Encode4(1276664), // Rule ID 8551 //
     /* 1276585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1276596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1276599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1276602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1276605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1276608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1276623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1276627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276638 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1276641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276663 */     // GIR_Coverage, 8551,
     /* 1276663 */     GIR_EraseRootFromParent_Done,
     /* 1276664 */   // Label 18389: @1276664
     /* 1276664 */   GIM_Try, /*On fail goto*//*Label 18390*/ GIMT_Encode4(1276748), // Rule ID 8554 //
     /* 1276669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1276680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1276683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1276686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1276689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1276692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1276707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1276711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276722 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1276725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276747 */     // GIR_Coverage, 8554,
     /* 1276747 */     GIR_EraseRootFromParent_Done,
     /* 1276748 */   // Label 18390: @1276748
     /* 1276748 */   GIM_Try, /*On fail goto*//*Label 18391*/ GIMT_Encode4(1276832), // Rule ID 8555 //
     /* 1276753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1276764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1276767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1276770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1276773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1276776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1276791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1276795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276806 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1276809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276831 */     // GIR_Coverage, 8555,
     /* 1276831 */     GIR_EraseRootFromParent_Done,
     /* 1276832 */   // Label 18391: @1276832
     /* 1276832 */   GIM_Try, /*On fail goto*//*Label 18392*/ GIMT_Encode4(1276916), // Rule ID 8558 //
     /* 1276837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1276848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1276851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1276854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1276857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1276860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1276875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1276879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276890 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1276893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276915 */     // GIR_Coverage, 8558,
     /* 1276915 */     GIR_EraseRootFromParent_Done,
     /* 1276916 */   // Label 18392: @1276916
     /* 1276916 */   GIM_Try, /*On fail goto*//*Label 18393*/ GIMT_Encode4(1277000), // Rule ID 8559 //
     /* 1276921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1276932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1276935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1276938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1276941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1276944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1276959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1276963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276974 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1276977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276999 */     // GIR_Coverage, 8559,
     /* 1276999 */     GIR_EraseRootFromParent_Done,
     /* 1277000 */   // Label 18393: @1277000
     /* 1277000 */   GIM_Try, /*On fail goto*//*Label 18394*/ GIMT_Encode4(1277084), // Rule ID 8562 //
     /* 1277005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1277025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277058 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277083 */     // GIR_Coverage, 8562,
     /* 1277083 */     GIR_EraseRootFromParent_Done,
     /* 1277084 */   // Label 18394: @1277084
     /* 1277084 */   GIM_Try, /*On fail goto*//*Label 18395*/ GIMT_Encode4(1277168), // Rule ID 8563 //
     /* 1277089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1277109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277142 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277167 */     // GIR_Coverage, 8563,
     /* 1277167 */     GIR_EraseRootFromParent_Done,
     /* 1277168 */   // Label 18395: @1277168
     /* 1277168 */   GIM_Try, /*On fail goto*//*Label 18396*/ GIMT_Encode4(1277252), // Rule ID 8566 //
     /* 1277173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1277190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1277193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277226 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277251 */     // GIR_Coverage, 8566,
     /* 1277251 */     GIR_EraseRootFromParent_Done,
     /* 1277252 */   // Label 18396: @1277252
     /* 1277252 */   GIM_Try, /*On fail goto*//*Label 18397*/ GIMT_Encode4(1277336), // Rule ID 8567 //
     /* 1277257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1277274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1277277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277310 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277335 */     // GIR_Coverage, 8567,
     /* 1277335 */     GIR_EraseRootFromParent_Done,
     /* 1277336 */   // Label 18397: @1277336
     /* 1277336 */   GIM_Try, /*On fail goto*//*Label 18398*/ GIMT_Encode4(1277420), // Rule ID 8570 //
     /* 1277341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1277358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1277361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277394 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277419 */     // GIR_Coverage, 8570,
     /* 1277419 */     GIR_EraseRootFromParent_Done,
     /* 1277420 */   // Label 18398: @1277420
     /* 1277420 */   GIM_Try, /*On fail goto*//*Label 18399*/ GIMT_Encode4(1277504), // Rule ID 8571 //
     /* 1277425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1277442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1277445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277478 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277503 */     // GIR_Coverage, 8571,
     /* 1277503 */     GIR_EraseRootFromParent_Done,
     /* 1277504 */   // Label 18399: @1277504
     /* 1277504 */   GIM_Try, /*On fail goto*//*Label 18400*/ GIMT_Encode4(1277588), // Rule ID 8574 //
     /* 1277509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1277520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1277523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1277526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1277529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1277532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277562 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277587 */     // GIR_Coverage, 8574,
     /* 1277587 */     GIR_EraseRootFromParent_Done,
     /* 1277588 */   // Label 18400: @1277588
     /* 1277588 */   GIM_Try, /*On fail goto*//*Label 18401*/ GIMT_Encode4(1277672), // Rule ID 8575 //
     /* 1277593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1277604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1277607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1277610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1277613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1277616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277646 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277671 */     // GIR_Coverage, 8575,
     /* 1277671 */     GIR_EraseRootFromParent_Done,
     /* 1277672 */   // Label 18401: @1277672
     /* 1277672 */   GIM_Try, /*On fail goto*//*Label 18402*/ GIMT_Encode4(1277756), // Rule ID 8578 //
     /* 1277677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1277694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1277697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277730 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277755 */     // GIR_Coverage, 8578,
     /* 1277755 */     GIR_EraseRootFromParent_Done,
     /* 1277756 */   // Label 18402: @1277756
     /* 1277756 */   GIM_Try, /*On fail goto*//*Label 18403*/ GIMT_Encode4(1277840), // Rule ID 8579 //
     /* 1277761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1277778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1277781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277814 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277839 */     // GIR_Coverage, 8579,
     /* 1277839 */     GIR_EraseRootFromParent_Done,
     /* 1277840 */   // Label 18403: @1277840
     /* 1277840 */   GIM_Try, /*On fail goto*//*Label 18404*/ GIMT_Encode4(1277924), // Rule ID 8582 //
     /* 1277845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1277862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1277865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277898 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277923 */     // GIR_Coverage, 8582,
     /* 1277923 */     GIR_EraseRootFromParent_Done,
     /* 1277924 */   // Label 18404: @1277924
     /* 1277924 */   GIM_Try, /*On fail goto*//*Label 18405*/ GIMT_Encode4(1278008), // Rule ID 8583 //
     /* 1277929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1277946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1277949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277982 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278007 */     // GIR_Coverage, 8583,
     /* 1278007 */     GIR_EraseRootFromParent_Done,
     /* 1278008 */   // Label 18405: @1278008
     /* 1278008 */   GIM_Try, /*On fail goto*//*Label 18406*/ GIMT_Encode4(1278092), // Rule ID 8586 //
     /* 1278013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1278033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278066 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1278069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278091 */     // GIR_Coverage, 8586,
     /* 1278091 */     GIR_EraseRootFromParent_Done,
     /* 1278092 */   // Label 18406: @1278092
     /* 1278092 */   GIM_Try, /*On fail goto*//*Label 18407*/ GIMT_Encode4(1278176), // Rule ID 8587 //
     /* 1278097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1278117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278150 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1278153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278175 */     // GIR_Coverage, 8587,
     /* 1278175 */     GIR_EraseRootFromParent_Done,
     /* 1278176 */   // Label 18407: @1278176
     /* 1278176 */   GIM_Try, /*On fail goto*//*Label 18408*/ GIMT_Encode4(1278260), // Rule ID 8590 //
     /* 1278181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1278198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1278201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278234 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1278237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278259 */     // GIR_Coverage, 8590,
     /* 1278259 */     GIR_EraseRootFromParent_Done,
     /* 1278260 */   // Label 18408: @1278260
     /* 1278260 */   GIM_Try, /*On fail goto*//*Label 18409*/ GIMT_Encode4(1278344), // Rule ID 8591 //
     /* 1278265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1278282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1278285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278318 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1278321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278343 */     // GIR_Coverage, 8591,
     /* 1278343 */     GIR_EraseRootFromParent_Done,
     /* 1278344 */   // Label 18409: @1278344
     /* 1278344 */   GIM_Try, /*On fail goto*//*Label 18410*/ GIMT_Encode4(1278428), // Rule ID 8594 //
     /* 1278349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1278366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1278369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278402 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1278405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278427 */     // GIR_Coverage, 8594,
     /* 1278427 */     GIR_EraseRootFromParent_Done,
     /* 1278428 */   // Label 18410: @1278428
     /* 1278428 */   GIM_Try, /*On fail goto*//*Label 18411*/ GIMT_Encode4(1278512), // Rule ID 8595 //
     /* 1278433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1278450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1278453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278486 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1278489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278511 */     // GIR_Coverage, 8595,
     /* 1278511 */     GIR_EraseRootFromParent_Done,
     /* 1278512 */   // Label 18411: @1278512
     /* 1278512 */   GIM_Try, /*On fail goto*//*Label 18412*/ GIMT_Encode4(1278596), // Rule ID 8598 //
     /* 1278517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1278528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1278531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1278534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1278540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278570 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1278573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278595 */     // GIR_Coverage, 8598,
     /* 1278595 */     GIR_EraseRootFromParent_Done,
     /* 1278596 */   // Label 18412: @1278596
     /* 1278596 */   GIM_Try, /*On fail goto*//*Label 18413*/ GIMT_Encode4(1278680), // Rule ID 8599 //
     /* 1278601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1278612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1278615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1278618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1278624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278654 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1278657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278679 */     // GIR_Coverage, 8599,
     /* 1278679 */     GIR_EraseRootFromParent_Done,
     /* 1278680 */   // Label 18413: @1278680
     /* 1278680 */   GIM_Try, /*On fail goto*//*Label 18414*/ GIMT_Encode4(1278764), // Rule ID 8602 //
     /* 1278685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1278702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278738 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1278741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278763 */     // GIR_Coverage, 8602,
     /* 1278763 */     GIR_EraseRootFromParent_Done,
     /* 1278764 */   // Label 18414: @1278764
     /* 1278764 */   GIM_Try, /*On fail goto*//*Label 18415*/ GIMT_Encode4(1278848), // Rule ID 8603 //
     /* 1278769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1278786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278822 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1278825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278847 */     // GIR_Coverage, 8603,
     /* 1278847 */     GIR_EraseRootFromParent_Done,
     /* 1278848 */   // Label 18415: @1278848
     /* 1278848 */   GIM_Try, /*On fail goto*//*Label 18416*/ GIMT_Encode4(1278932), // Rule ID 8606 //
     /* 1278853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1278870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278906 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1278909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278931 */     // GIR_Coverage, 8606,
     /* 1278931 */     GIR_EraseRootFromParent_Done,
     /* 1278932 */   // Label 18416: @1278932
     /* 1278932 */   GIM_Try, /*On fail goto*//*Label 18417*/ GIMT_Encode4(1279016), // Rule ID 8607 //
     /* 1278937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1278954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278990 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1278993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279015 */     // GIR_Coverage, 8607,
     /* 1279015 */     GIR_EraseRootFromParent_Done,
     /* 1279016 */   // Label 18417: @1279016
     /* 1279016 */   GIM_Try, /*On fail goto*//*Label 18418*/ GIMT_Encode4(1279100), // Rule ID 8610 //
     /* 1279021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279074 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1279077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279099 */     // GIR_Coverage, 8610,
     /* 1279099 */     GIR_EraseRootFromParent_Done,
     /* 1279100 */   // Label 18418: @1279100
     /* 1279100 */   GIM_Try, /*On fail goto*//*Label 18419*/ GIMT_Encode4(1279184), // Rule ID 8611 //
     /* 1279105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279158 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1279161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279183 */     // GIR_Coverage, 8611,
     /* 1279183 */     GIR_EraseRootFromParent_Done,
     /* 1279184 */   // Label 18419: @1279184
     /* 1279184 */   GIM_Try, /*On fail goto*//*Label 18420*/ GIMT_Encode4(1279268), // Rule ID 8614 //
     /* 1279189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1279206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279242 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279267 */     // GIR_Coverage, 8614,
     /* 1279267 */     GIR_EraseRootFromParent_Done,
     /* 1279268 */   // Label 18420: @1279268
     /* 1279268 */   GIM_Try, /*On fail goto*//*Label 18421*/ GIMT_Encode4(1279352), // Rule ID 8615 //
     /* 1279273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1279290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279326 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279351 */     // GIR_Coverage, 8615,
     /* 1279351 */     GIR_EraseRootFromParent_Done,
     /* 1279352 */   // Label 18421: @1279352
     /* 1279352 */   GIM_Try, /*On fail goto*//*Label 18422*/ GIMT_Encode4(1279436), // Rule ID 8618 //
     /* 1279357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1279374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279410 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279435 */     // GIR_Coverage, 8618,
     /* 1279435 */     GIR_EraseRootFromParent_Done,
     /* 1279436 */   // Label 18422: @1279436
     /* 1279436 */   GIM_Try, /*On fail goto*//*Label 18423*/ GIMT_Encode4(1279520), // Rule ID 8619 //
     /* 1279441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1279458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279494 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279519 */     // GIR_Coverage, 8619,
     /* 1279519 */     GIR_EraseRootFromParent_Done,
     /* 1279520 */   // Label 18423: @1279520
     /* 1279520 */   GIM_Try, /*On fail goto*//*Label 18424*/ GIMT_Encode4(1279604), // Rule ID 8622 //
     /* 1279525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1279539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1279542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1279548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279578 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1279581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279603 */     // GIR_Coverage, 8622,
     /* 1279603 */     GIR_EraseRootFromParent_Done,
     /* 1279604 */   // Label 18424: @1279604
     /* 1279604 */   GIM_Try, /*On fail goto*//*Label 18425*/ GIMT_Encode4(1279688), // Rule ID 8623 //
     /* 1279609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1279623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1279626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1279632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279662 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1279665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279687 */     // GIR_Coverage, 8623,
     /* 1279687 */     GIR_EraseRootFromParent_Done,
     /* 1279688 */   // Label 18425: @1279688
     /* 1279688 */   GIM_Try, /*On fail goto*//*Label 18426*/ GIMT_Encode4(1279772), // Rule ID 8626 //
     /* 1279693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1279710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279746 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1279749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279771 */     // GIR_Coverage, 8626,
     /* 1279771 */     GIR_EraseRootFromParent_Done,
     /* 1279772 */   // Label 18426: @1279772
     /* 1279772 */   GIM_Try, /*On fail goto*//*Label 18427*/ GIMT_Encode4(1279856), // Rule ID 8627 //
     /* 1279777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1279794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279830 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1279833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279855 */     // GIR_Coverage, 8627,
     /* 1279855 */     GIR_EraseRootFromParent_Done,
     /* 1279856 */   // Label 18427: @1279856
     /* 1279856 */   GIM_Try, /*On fail goto*//*Label 18428*/ GIMT_Encode4(1279940), // Rule ID 8630 //
     /* 1279861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1279878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279914 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1279917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279939 */     // GIR_Coverage, 8630,
     /* 1279939 */     GIR_EraseRootFromParent_Done,
     /* 1279940 */   // Label 18428: @1279940
     /* 1279940 */   GIM_Try, /*On fail goto*//*Label 18429*/ GIMT_Encode4(1280024), // Rule ID 8631 //
     /* 1279945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1279962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280023 */     // GIR_Coverage, 8631,
     /* 1280023 */     GIR_EraseRootFromParent_Done,
     /* 1280024 */   // Label 18429: @1280024
     /* 1280024 */   GIM_Try, /*On fail goto*//*Label 18430*/ GIMT_Encode4(1280108), // Rule ID 8634 //
     /* 1280029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1280032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280082 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280107 */     // GIR_Coverage, 8634,
     /* 1280107 */     GIR_EraseRootFromParent_Done,
     /* 1280108 */   // Label 18430: @1280108
     /* 1280108 */   GIM_Try, /*On fail goto*//*Label 18431*/ GIMT_Encode4(1280192), // Rule ID 8635 //
     /* 1280113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1280116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280166 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280191 */     // GIR_Coverage, 8635,
     /* 1280191 */     GIR_EraseRootFromParent_Done,
     /* 1280192 */   // Label 18431: @1280192
     /* 1280192 */   GIM_Try, /*On fail goto*//*Label 18432*/ GIMT_Encode4(1280276), // Rule ID 8638 //
     /* 1280197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1280214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280250 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1280253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280275 */     // GIR_Coverage, 8638,
     /* 1280275 */     GIR_EraseRootFromParent_Done,
     /* 1280276 */   // Label 18432: @1280276
     /* 1280276 */   GIM_Try, /*On fail goto*//*Label 18433*/ GIMT_Encode4(1280360), // Rule ID 8639 //
     /* 1280281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1280298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280334 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1280337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280359 */     // GIR_Coverage, 8639,
     /* 1280359 */     GIR_EraseRootFromParent_Done,
     /* 1280360 */   // Label 18433: @1280360
     /* 1280360 */   GIM_Try, /*On fail goto*//*Label 18434*/ GIMT_Encode4(1280444), // Rule ID 8642 //
     /* 1280365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1280376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1280379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1280382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1280388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280418 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1280421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280443 */     // GIR_Coverage, 8642,
     /* 1280443 */     GIR_EraseRootFromParent_Done,
     /* 1280444 */   // Label 18434: @1280444
     /* 1280444 */   GIM_Try, /*On fail goto*//*Label 18435*/ GIMT_Encode4(1280528), // Rule ID 8643 //
     /* 1280449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1280460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1280463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1280466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1280472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280502 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1280505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280527 */     // GIR_Coverage, 8643,
     /* 1280527 */     GIR_EraseRootFromParent_Done,
     /* 1280528 */   // Label 18435: @1280528
     /* 1280528 */   GIM_Try, /*On fail goto*//*Label 18436*/ GIMT_Encode4(1280612), // Rule ID 8646 //
     /* 1280533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1280544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1280547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1280550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1280556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1280571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280586 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1280589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280611 */     // GIR_Coverage, 8646,
     /* 1280611 */     GIR_EraseRootFromParent_Done,
     /* 1280612 */   // Label 18436: @1280612
     /* 1280612 */   GIM_Try, /*On fail goto*//*Label 18437*/ GIMT_Encode4(1280696), // Rule ID 8647 //
     /* 1280617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1280628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1280631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1280634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1280640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1280655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280670 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1280673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280695 */     // GIR_Coverage, 8647,
     /* 1280695 */     GIR_EraseRootFromParent_Done,
     /* 1280696 */   // Label 18437: @1280696
     /* 1280696 */   GIM_Try, /*On fail goto*//*Label 18438*/ GIMT_Encode4(1280780), // Rule ID 8650 //
     /* 1280701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1280712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1280715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1280718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280754 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1280757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280779 */     // GIR_Coverage, 8650,
     /* 1280779 */     GIR_EraseRootFromParent_Done,
     /* 1280780 */   // Label 18438: @1280780
     /* 1280780 */   GIM_Try, /*On fail goto*//*Label 18439*/ GIMT_Encode4(1280864), // Rule ID 8651 //
     /* 1280785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1280796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1280799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1280802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280838 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1280841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280863 */     // GIR_Coverage, 8651,
     /* 1280863 */     GIR_EraseRootFromParent_Done,
     /* 1280864 */   // Label 18439: @1280864
     /* 1280864 */   GIM_Try, /*On fail goto*//*Label 18440*/ GIMT_Encode4(1280948), // Rule ID 8654 //
     /* 1280869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1280886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280922 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1280925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280947 */     // GIR_Coverage, 8654,
     /* 1280947 */     GIR_EraseRootFromParent_Done,
     /* 1280948 */   // Label 18440: @1280948
     /* 1280948 */   GIM_Try, /*On fail goto*//*Label 18441*/ GIMT_Encode4(1281032), // Rule ID 8655 //
     /* 1280953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1280970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281006 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281031 */     // GIR_Coverage, 8655,
     /* 1281031 */     GIR_EraseRootFromParent_Done,
     /* 1281032 */   // Label 18441: @1281032
     /* 1281032 */   GIM_Try, /*On fail goto*//*Label 18442*/ GIMT_Encode4(1281116), // Rule ID 8658 //
     /* 1281037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281090 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281115 */     // GIR_Coverage, 8658,
     /* 1281115 */     GIR_EraseRootFromParent_Done,
     /* 1281116 */   // Label 18442: @1281116
     /* 1281116 */   GIM_Try, /*On fail goto*//*Label 18443*/ GIMT_Encode4(1281200), // Rule ID 8659 //
     /* 1281121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281174 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281199 */     // GIR_Coverage, 8659,
     /* 1281199 */     GIR_EraseRootFromParent_Done,
     /* 1281200 */   // Label 18443: @1281200
     /* 1281200 */   GIM_Try, /*On fail goto*//*Label 18444*/ GIMT_Encode4(1281284), // Rule ID 8662 //
     /* 1281205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1281222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281258 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281283 */     // GIR_Coverage, 8662,
     /* 1281283 */     GIR_EraseRootFromParent_Done,
     /* 1281284 */   // Label 18444: @1281284
     /* 1281284 */   GIM_Try, /*On fail goto*//*Label 18445*/ GIMT_Encode4(1281368), // Rule ID 8663 //
     /* 1281289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1281306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281342 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281367 */     // GIR_Coverage, 8663,
     /* 1281367 */     GIR_EraseRootFromParent_Done,
     /* 1281368 */   // Label 18445: @1281368
     /* 1281368 */   GIM_Try, /*On fail goto*//*Label 18446*/ GIMT_Encode4(1281452), // Rule ID 8666 //
     /* 1281373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1281390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281426 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281451 */     // GIR_Coverage, 8666,
     /* 1281451 */     GIR_EraseRootFromParent_Done,
     /* 1281452 */   // Label 18446: @1281452
     /* 1281452 */   GIM_Try, /*On fail goto*//*Label 18447*/ GIMT_Encode4(1281536), // Rule ID 8667 //
     /* 1281457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1281474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281510 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281535 */     // GIR_Coverage, 8667,
     /* 1281535 */     GIR_EraseRootFromParent_Done,
     /* 1281536 */   // Label 18447: @1281536
     /* 1281536 */   GIM_Try, /*On fail goto*//*Label 18448*/ GIMT_Encode4(1281620), // Rule ID 8670 //
     /* 1281541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1281558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281594 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281619 */     // GIR_Coverage, 8670,
     /* 1281619 */     GIR_EraseRootFromParent_Done,
     /* 1281620 */   // Label 18448: @1281620
     /* 1281620 */   GIM_Try, /*On fail goto*//*Label 18449*/ GIMT_Encode4(1281704), // Rule ID 8671 //
     /* 1281625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1281642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281678 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281703 */     // GIR_Coverage, 8671,
     /* 1281703 */     GIR_EraseRootFromParent_Done,
     /* 1281704 */   // Label 18449: @1281704
     /* 1281704 */   GIM_Try, /*On fail goto*//*Label 18450*/ GIMT_Encode4(1281788), // Rule ID 8674 //
     /* 1281709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1281712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1281720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1281723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1281726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1281732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281762 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1281783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281787 */     // GIR_Coverage, 8674,
     /* 1281787 */     GIR_EraseRootFromParent_Done,
     /* 1281788 */   // Label 18450: @1281788
     /* 1281788 */   GIM_Try, /*On fail goto*//*Label 18451*/ GIMT_Encode4(1281872), // Rule ID 8675 //
     /* 1281793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1281796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1281804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1281807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1281810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1281816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281846 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1281867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281871 */     // GIR_Coverage, 8675,
     /* 1281871 */     GIR_EraseRootFromParent_Done,
     /* 1281872 */   // Label 18451: @1281872
     /* 1281872 */   GIM_Try, /*On fail goto*//*Label 18452*/ GIMT_Encode4(1281956), // Rule ID 8678 //
     /* 1281877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1281880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1281894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281930 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1281951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281955 */     // GIR_Coverage, 8678,
     /* 1281955 */     GIR_EraseRootFromParent_Done,
     /* 1281956 */   // Label 18452: @1281956
     /* 1281956 */   GIM_Try, /*On fail goto*//*Label 18453*/ GIMT_Encode4(1282040), // Rule ID 8679 //
     /* 1281961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1281964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1281978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282014 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1282017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282039 */     // GIR_Coverage, 8679,
     /* 1282039 */     GIR_EraseRootFromParent_Done,
     /* 1282040 */   // Label 18453: @1282040
     /* 1282040 */   GIM_Try, /*On fail goto*//*Label 18454*/ GIMT_Encode4(1282124), // Rule ID 8682 //
     /* 1282045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282098 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1282101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282123 */     // GIR_Coverage, 8682,
     /* 1282123 */     GIR_EraseRootFromParent_Done,
     /* 1282124 */   // Label 18454: @1282124
     /* 1282124 */   GIM_Try, /*On fail goto*//*Label 18455*/ GIMT_Encode4(1282208), // Rule ID 8683 //
     /* 1282129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282182 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1282185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282207 */     // GIR_Coverage, 8683,
     /* 1282207 */     GIR_EraseRootFromParent_Done,
     /* 1282208 */   // Label 18455: @1282208
     /* 1282208 */   GIM_Try, /*On fail goto*//*Label 18456*/ GIMT_Encode4(1282292), // Rule ID 8686 //
     /* 1282213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1282230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1282233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282266 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1282269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282291 */     // GIR_Coverage, 8686,
     /* 1282291 */     GIR_EraseRootFromParent_Done,
     /* 1282292 */   // Label 18456: @1282292
     /* 1282292 */   GIM_Try, /*On fail goto*//*Label 18457*/ GIMT_Encode4(1282376), // Rule ID 8687 //
     /* 1282297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1282314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1282317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282350 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1282353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282375 */     // GIR_Coverage, 8687,
     /* 1282375 */     GIR_EraseRootFromParent_Done,
     /* 1282376 */   // Label 18457: @1282376
     /* 1282376 */   GIM_Try, /*On fail goto*//*Label 18458*/ GIMT_Encode4(1282460), // Rule ID 8690 //
     /* 1282381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1282398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1282401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282434 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1282437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282459 */     // GIR_Coverage, 8690,
     /* 1282459 */     GIR_EraseRootFromParent_Done,
     /* 1282460 */   // Label 18458: @1282460
     /* 1282460 */   GIM_Try, /*On fail goto*//*Label 18459*/ GIMT_Encode4(1282544), // Rule ID 8691 //
     /* 1282465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1282482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1282485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282518 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1282521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282543 */     // GIR_Coverage, 8691,
     /* 1282543 */     GIR_EraseRootFromParent_Done,
     /* 1282544 */   // Label 18459: @1282544
     /* 1282544 */   GIM_Try, /*On fail goto*//*Label 18460*/ GIMT_Encode4(1282628), // Rule ID 8694 //
     /* 1282549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1282566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1282569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282602 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1282605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282627 */     // GIR_Coverage, 8694,
     /* 1282627 */     GIR_EraseRootFromParent_Done,
     /* 1282628 */   // Label 18460: @1282628
     /* 1282628 */   GIM_Try, /*On fail goto*//*Label 18461*/ GIMT_Encode4(1282712), // Rule ID 8695 //
     /* 1282633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1282650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1282653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282686 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1282689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282711 */     // GIR_Coverage, 8695,
     /* 1282711 */     GIR_EraseRootFromParent_Done,
     /* 1282712 */   // Label 18461: @1282712
     /* 1282712 */   GIM_Try, /*On fail goto*//*Label 18462*/ GIMT_Encode4(1282796), // Rule ID 8698 //
     /* 1282717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1282734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1282737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282770 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1282773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1282791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282795 */     // GIR_Coverage, 8698,
     /* 1282795 */     GIR_EraseRootFromParent_Done,
     /* 1282796 */   // Label 18462: @1282796
     /* 1282796 */   GIM_Try, /*On fail goto*//*Label 18463*/ GIMT_Encode4(1282880), // Rule ID 8699 //
     /* 1282801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1282818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1282821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282854 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1282857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1282875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282879 */     // GIR_Coverage, 8699,
     /* 1282879 */     GIR_EraseRootFromParent_Done,
     /* 1282880 */   // Label 18463: @1282880
     /* 1282880 */   GIM_Try, /*On fail goto*//*Label 18464*/ GIMT_Encode4(1282964), // Rule ID 8702 //
     /* 1282885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1282902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1282905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282938 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1282941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1282959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282963 */     // GIR_Coverage, 8702,
     /* 1282963 */     GIR_EraseRootFromParent_Done,
     /* 1282964 */   // Label 18464: @1282964
     /* 1282964 */   GIM_Try, /*On fail goto*//*Label 18465*/ GIMT_Encode4(1283048), // Rule ID 8703 //
     /* 1282969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1282986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1282989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283022 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283047 */     // GIR_Coverage, 8703,
     /* 1283047 */     GIR_EraseRootFromParent_Done,
     /* 1283048 */   // Label 18465: @1283048
     /* 1283048 */   GIM_Try, /*On fail goto*//*Label 18466*/ GIMT_Encode4(1283132), // Rule ID 8706 //
     /* 1283053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1283073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283106 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283131 */     // GIR_Coverage, 8706,
     /* 1283131 */     GIR_EraseRootFromParent_Done,
     /* 1283132 */   // Label 18466: @1283132
     /* 1283132 */   GIM_Try, /*On fail goto*//*Label 18467*/ GIMT_Encode4(1283216), // Rule ID 8707 //
     /* 1283137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1283157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283215 */     // GIR_Coverage, 8707,
     /* 1283215 */     GIR_EraseRootFromParent_Done,
     /* 1283216 */   // Label 18467: @1283216
     /* 1283216 */   GIM_Try, /*On fail goto*//*Label 18468*/ GIMT_Encode4(1283300), // Rule ID 8710 //
     /* 1283221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1283232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1283235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1283238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1283241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283274 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283299 */     // GIR_Coverage, 8710,
     /* 1283299 */     GIR_EraseRootFromParent_Done,
     /* 1283300 */   // Label 18468: @1283300
     /* 1283300 */   GIM_Try, /*On fail goto*//*Label 18469*/ GIMT_Encode4(1283384), // Rule ID 8711 //
     /* 1283305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1283316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1283319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1283322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1283325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283358 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283383 */     // GIR_Coverage, 8711,
     /* 1283383 */     GIR_EraseRootFromParent_Done,
     /* 1283384 */   // Label 18469: @1283384
     /* 1283384 */   GIM_Try, /*On fail goto*//*Label 18470*/ GIMT_Encode4(1283468), // Rule ID 8714 //
     /* 1283389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1283406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1283409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283442 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283467 */     // GIR_Coverage, 8714,
     /* 1283467 */     GIR_EraseRootFromParent_Done,
     /* 1283468 */   // Label 18470: @1283468
     /* 1283468 */   GIM_Try, /*On fail goto*//*Label 18471*/ GIMT_Encode4(1283552), // Rule ID 8715 //
     /* 1283473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1283490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1283493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283526 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283551 */     // GIR_Coverage, 8715,
     /* 1283551 */     GIR_EraseRootFromParent_Done,
     /* 1283552 */   // Label 18471: @1283552
     /* 1283552 */   GIM_Try, /*On fail goto*//*Label 18472*/ GIMT_Encode4(1283636), // Rule ID 8718 //
     /* 1283557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1283574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1283577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283610 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283635 */     // GIR_Coverage, 8718,
     /* 1283635 */     GIR_EraseRootFromParent_Done,
     /* 1283636 */   // Label 18472: @1283636
     /* 1283636 */   GIM_Try, /*On fail goto*//*Label 18473*/ GIMT_Encode4(1283720), // Rule ID 8719 //
     /* 1283641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1283658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1283661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283694 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283719 */     // GIR_Coverage, 8719,
     /* 1283719 */     GIR_EraseRootFromParent_Done,
     /* 1283720 */   // Label 18473: @1283720
     /* 1283720 */   GIM_Try, /*On fail goto*//*Label 18474*/ GIMT_Encode4(1283804), // Rule ID 8722 //
     /* 1283725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1283728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1283742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1283745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283778 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1283799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283803 */     // GIR_Coverage, 8722,
     /* 1283803 */     GIR_EraseRootFromParent_Done,
     /* 1283804 */   // Label 18474: @1283804
     /* 1283804 */   GIM_Try, /*On fail goto*//*Label 18475*/ GIMT_Encode4(1283888), // Rule ID 8723 //
     /* 1283809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1283812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1283826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1283829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283862 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1283883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283887 */     // GIR_Coverage, 8723,
     /* 1283887 */     GIR_EraseRootFromParent_Done,
     /* 1283888 */   // Label 18475: @1283888
     /* 1283888 */   GIM_Try, /*On fail goto*//*Label 18476*/ GIMT_Encode4(1283972), // Rule ID 8726 //
     /* 1283893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1283904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1283907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1283910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1283913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1283916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1283931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1283935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283946 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1283949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283971 */     // GIR_Coverage, 8726,
     /* 1283971 */     GIR_EraseRootFromParent_Done,
     /* 1283972 */   // Label 18476: @1283972
     /* 1283972 */   GIM_Try, /*On fail goto*//*Label 18477*/ GIMT_Encode4(1284056), // Rule ID 8727 //
     /* 1283977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1283988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1283991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1283994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1283997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284030 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284055 */     // GIR_Coverage, 8727,
     /* 1284055 */     GIR_EraseRootFromParent_Done,
     /* 1284056 */   // Label 18477: @1284056
     /* 1284056 */   GIM_Try, /*On fail goto*//*Label 18478*/ GIMT_Encode4(1284140), // Rule ID 8730 //
     /* 1284061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1284081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284114 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1284117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284139 */     // GIR_Coverage, 8730,
     /* 1284139 */     GIR_EraseRootFromParent_Done,
     /* 1284140 */   // Label 18478: @1284140
     /* 1284140 */   GIM_Try, /*On fail goto*//*Label 18479*/ GIMT_Encode4(1284224), // Rule ID 8731 //
     /* 1284145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1284165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284198 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1284201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284223 */     // GIR_Coverage, 8731,
     /* 1284223 */     GIR_EraseRootFromParent_Done,
     /* 1284224 */   // Label 18479: @1284224
     /* 1284224 */   GIM_Try, /*On fail goto*//*Label 18480*/ GIMT_Encode4(1284308), // Rule ID 8734 //
     /* 1284229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1284240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1284243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1284246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1284249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1284252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284282 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1284285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284307 */     // GIR_Coverage, 8734,
     /* 1284307 */     GIR_EraseRootFromParent_Done,
     /* 1284308 */   // Label 18480: @1284308
     /* 1284308 */   GIM_Try, /*On fail goto*//*Label 18481*/ GIMT_Encode4(1284392), // Rule ID 8735 //
     /* 1284313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1284324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1284327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1284330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1284333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1284336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284366 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1284369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284391 */     // GIR_Coverage, 8735,
     /* 1284391 */     GIR_EraseRootFromParent_Done,
     /* 1284392 */   // Label 18481: @1284392
     /* 1284392 */   GIM_Try, /*On fail goto*//*Label 18482*/ GIMT_Encode4(1284476), // Rule ID 8738 //
     /* 1284397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1284414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1284417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284450 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284475 */     // GIR_Coverage, 8738,
     /* 1284475 */     GIR_EraseRootFromParent_Done,
     /* 1284476 */   // Label 18482: @1284476
     /* 1284476 */   GIM_Try, /*On fail goto*//*Label 18483*/ GIMT_Encode4(1284560), // Rule ID 8739 //
     /* 1284481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1284498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1284501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284534 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284559 */     // GIR_Coverage, 8739,
     /* 1284559 */     GIR_EraseRootFromParent_Done,
     /* 1284560 */   // Label 18483: @1284560
     /* 1284560 */   GIM_Try, /*On fail goto*//*Label 18484*/ GIMT_Encode4(1284644), // Rule ID 8742 //
     /* 1284565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1284582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1284585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284618 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1284621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284643 */     // GIR_Coverage, 8742,
     /* 1284643 */     GIR_EraseRootFromParent_Done,
     /* 1284644 */   // Label 18484: @1284644
     /* 1284644 */   GIM_Try, /*On fail goto*//*Label 18485*/ GIMT_Encode4(1284728), // Rule ID 8743 //
     /* 1284649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1284666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1284669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284702 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1284705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284727 */     // GIR_Coverage, 8743,
     /* 1284727 */     GIR_EraseRootFromParent_Done,
     /* 1284728 */   // Label 18485: @1284728
     /* 1284728 */   GIM_Try, /*On fail goto*//*Label 18486*/ GIMT_Encode4(1284812), // Rule ID 8746 //
     /* 1284733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1284750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1284753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284786 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1284789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284811 */     // GIR_Coverage, 8746,
     /* 1284811 */     GIR_EraseRootFromParent_Done,
     /* 1284812 */   // Label 18486: @1284812
     /* 1284812 */   GIM_Try, /*On fail goto*//*Label 18487*/ GIMT_Encode4(1284896), // Rule ID 8747 //
     /* 1284817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1284834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1284837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284870 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1284873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284895 */     // GIR_Coverage, 8747,
     /* 1284895 */     GIR_EraseRootFromParent_Done,
     /* 1284896 */   // Label 18487: @1284896
     /* 1284896 */   GIM_Try, /*On fail goto*//*Label 18488*/ GIMT_Encode4(1284980), // Rule ID 8750 //
     /* 1284901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1284912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1284915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1284918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1284921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1284924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284954 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1284975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284979 */     // GIR_Coverage, 8750,
     /* 1284979 */     GIR_EraseRootFromParent_Done,
     /* 1284980 */   // Label 18488: @1284980
     /* 1284980 */   GIM_Try, /*On fail goto*//*Label 18489*/ GIMT_Encode4(1285064), // Rule ID 8751 //
     /* 1284985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1284996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1284999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1285002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1285005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285038 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1285041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285063 */     // GIR_Coverage, 8751,
     /* 1285063 */     GIR_EraseRootFromParent_Done,
     /* 1285064 */   // Label 18489: @1285064
     /* 1285064 */   GIM_Try, /*On fail goto*//*Label 18490*/ GIMT_Encode4(1285148), // Rule ID 8754 //
     /* 1285069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1285089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285122 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285147 */     // GIR_Coverage, 8754,
     /* 1285147 */     GIR_EraseRootFromParent_Done,
     /* 1285148 */   // Label 18490: @1285148
     /* 1285148 */   GIM_Try, /*On fail goto*//*Label 18491*/ GIMT_Encode4(1285232), // Rule ID 8755 //
     /* 1285153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1285173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285206 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285231 */     // GIR_Coverage, 8755,
     /* 1285231 */     GIR_EraseRootFromParent_Done,
     /* 1285232 */   // Label 18491: @1285232
     /* 1285232 */   GIM_Try, /*On fail goto*//*Label 18492*/ GIMT_Encode4(1285316), // Rule ID 8758 //
     /* 1285237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1285254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1285257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285290 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285315 */     // GIR_Coverage, 8758,
     /* 1285315 */     GIR_EraseRootFromParent_Done,
     /* 1285316 */   // Label 18492: @1285316
     /* 1285316 */   GIM_Try, /*On fail goto*//*Label 18493*/ GIMT_Encode4(1285400), // Rule ID 8759 //
     /* 1285321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1285338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1285341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285374 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285399 */     // GIR_Coverage, 8759,
     /* 1285399 */     GIR_EraseRootFromParent_Done,
     /* 1285400 */   // Label 18493: @1285400
     /* 1285400 */   GIM_Try, /*On fail goto*//*Label 18494*/ GIMT_Encode4(1285484), // Rule ID 8762 //
     /* 1285405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1285408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1285416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1285419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1285422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1285425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1285428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285458 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1285461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285483 */     // GIR_Coverage, 8762,
     /* 1285483 */     GIR_EraseRootFromParent_Done,
     /* 1285484 */   // Label 18494: @1285484
     /* 1285484 */   GIM_Try, /*On fail goto*//*Label 18495*/ GIMT_Encode4(1285568), // Rule ID 8763 //
     /* 1285489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1285492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1285500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1285503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1285506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1285509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1285512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285542 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1285545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285567 */     // GIR_Coverage, 8763,
     /* 1285567 */     GIR_EraseRootFromParent_Done,
     /* 1285568 */   // Label 18495: @1285568
     /* 1285568 */   GIM_Try, /*On fail goto*//*Label 18496*/ GIMT_Encode4(1285652), // Rule ID 8766 //
     /* 1285573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1285576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1285590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1285593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285626 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285651 */     // GIR_Coverage, 8766,
     /* 1285651 */     GIR_EraseRootFromParent_Done,
     /* 1285652 */   // Label 18496: @1285652
     /* 1285652 */   GIM_Try, /*On fail goto*//*Label 18497*/ GIMT_Encode4(1285736), // Rule ID 8767 //
     /* 1285657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1285660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1285674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1285677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285710 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285735 */     // GIR_Coverage, 8767,
     /* 1285735 */     GIR_EraseRootFromParent_Done,
     /* 1285736 */   // Label 18497: @1285736
     /* 1285736 */   GIM_Try, /*On fail goto*//*Label 18498*/ GIMT_Encode4(1285820), // Rule ID 8770 //
     /* 1285741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1285744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1285758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1285761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285794 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285819 */     // GIR_Coverage, 8770,
     /* 1285819 */     GIR_EraseRootFromParent_Done,
     /* 1285820 */   // Label 18498: @1285820
     /* 1285820 */   GIM_Try, /*On fail goto*//*Label 18499*/ GIMT_Encode4(1285904), // Rule ID 8771 //
     /* 1285825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1285828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1285842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1285845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285878 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285903 */     // GIR_Coverage, 8771,
     /* 1285903 */     GIR_EraseRootFromParent_Done,
     /* 1285904 */   // Label 18499: @1285904
     /* 1285904 */   GIM_Try, /*On fail goto*//*Label 18500*/ GIMT_Encode4(1285988), // Rule ID 8774 //
     /* 1285909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1285920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1285923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1285926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1285932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285962 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1285965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1285983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285987 */     // GIR_Coverage, 8774,
     /* 1285987 */     GIR_EraseRootFromParent_Done,
     /* 1285988 */   // Label 18500: @1285988
     /* 1285988 */   GIM_Try, /*On fail goto*//*Label 18501*/ GIMT_Encode4(1286072), // Rule ID 8775 //
     /* 1285993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1286010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286046 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1286049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286071 */     // GIR_Coverage, 8775,
     /* 1286071 */     GIR_EraseRootFromParent_Done,
     /* 1286072 */   // Label 18501: @1286072
     /* 1286072 */   GIM_Try, /*On fail goto*//*Label 18502*/ GIMT_Encode4(1286156), // Rule ID 8778 //
     /* 1286077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286130 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286155 */     // GIR_Coverage, 8778,
     /* 1286155 */     GIR_EraseRootFromParent_Done,
     /* 1286156 */   // Label 18502: @1286156
     /* 1286156 */   GIM_Try, /*On fail goto*//*Label 18503*/ GIMT_Encode4(1286240), // Rule ID 8779 //
     /* 1286161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286214 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286239 */     // GIR_Coverage, 8779,
     /* 1286239 */     GIR_EraseRootFromParent_Done,
     /* 1286240 */   // Label 18503: @1286240
     /* 1286240 */   GIM_Try, /*On fail goto*//*Label 18504*/ GIMT_Encode4(1286324), // Rule ID 8782 //
     /* 1286245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1286262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286298 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286323 */     // GIR_Coverage, 8782,
     /* 1286323 */     GIR_EraseRootFromParent_Done,
     /* 1286324 */   // Label 18504: @1286324
     /* 1286324 */   GIM_Try, /*On fail goto*//*Label 18505*/ GIMT_Encode4(1286408), // Rule ID 8783 //
     /* 1286329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1286346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286382 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286407 */     // GIR_Coverage, 8783,
     /* 1286407 */     GIR_EraseRootFromParent_Done,
     /* 1286408 */   // Label 18505: @1286408
     /* 1286408 */   GIM_Try, /*On fail goto*//*Label 18506*/ GIMT_Encode4(1286492), // Rule ID 8786 //
     /* 1286413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1286430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286466 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286491 */     // GIR_Coverage, 8786,
     /* 1286491 */     GIR_EraseRootFromParent_Done,
     /* 1286492 */   // Label 18506: @1286492
     /* 1286492 */   GIM_Try, /*On fail goto*//*Label 18507*/ GIMT_Encode4(1286576), // Rule ID 8787 //
     /* 1286497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1286514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286550 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286575 */     // GIR_Coverage, 8787,
     /* 1286575 */     GIR_EraseRootFromParent_Done,
     /* 1286576 */   // Label 18507: @1286576
     /* 1286576 */   GIM_Try, /*On fail goto*//*Label 18508*/ GIMT_Encode4(1286660), // Rule ID 8790 //
     /* 1286581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1286598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286634 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286659 */     // GIR_Coverage, 8790,
     /* 1286659 */     GIR_EraseRootFromParent_Done,
     /* 1286660 */   // Label 18508: @1286660
     /* 1286660 */   GIM_Try, /*On fail goto*//*Label 18509*/ GIMT_Encode4(1286744), // Rule ID 8791 //
     /* 1286665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1286682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286718 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286743 */     // GIR_Coverage, 8791,
     /* 1286743 */     GIR_EraseRootFromParent_Done,
     /* 1286744 */   // Label 18509: @1286744
     /* 1286744 */   GIM_Try, /*On fail goto*//*Label 18510*/ GIMT_Encode4(1286828), // Rule ID 8794 //
     /* 1286749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1286766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286802 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286827 */     // GIR_Coverage, 8794,
     /* 1286827 */     GIR_EraseRootFromParent_Done,
     /* 1286828 */   // Label 18510: @1286828
     /* 1286828 */   GIM_Try, /*On fail goto*//*Label 18511*/ GIMT_Encode4(1286912), // Rule ID 8795 //
     /* 1286833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1286850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286886 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286911 */     // GIR_Coverage, 8795,
     /* 1286911 */     GIR_EraseRootFromParent_Done,
     /* 1286912 */   // Label 18511: @1286912
     /* 1286912 */   GIM_Try, /*On fail goto*//*Label 18512*/ GIMT_Encode4(1286996), // Rule ID 8798 //
     /* 1286917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1286928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1286931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1286934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1286940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286970 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1286973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286995 */     // GIR_Coverage, 8798,
     /* 1286995 */     GIR_EraseRootFromParent_Done,
     /* 1286996 */   // Label 18512: @1286996
     /* 1286996 */   GIM_Try, /*On fail goto*//*Label 18513*/ GIMT_Encode4(1287080), // Rule ID 8799 //
     /* 1287001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1287012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1287015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1287018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287054 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287079 */     // GIR_Coverage, 8799,
     /* 1287079 */     GIR_EraseRootFromParent_Done,
     /* 1287080 */   // Label 18513: @1287080
     /* 1287080 */   GIM_Try, /*On fail goto*//*Label 18514*/ GIMT_Encode4(1287164), // Rule ID 8802 //
     /* 1287085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287138 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287163 */     // GIR_Coverage, 8802,
     /* 1287163 */     GIR_EraseRootFromParent_Done,
     /* 1287164 */   // Label 18514: @1287164
     /* 1287164 */   GIM_Try, /*On fail goto*//*Label 18515*/ GIMT_Encode4(1287248), // Rule ID 8803 //
     /* 1287169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287222 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287247 */     // GIR_Coverage, 8803,
     /* 1287247 */     GIR_EraseRootFromParent_Done,
     /* 1287248 */   // Label 18515: @1287248
     /* 1287248 */   GIM_Try, /*On fail goto*//*Label 18516*/ GIMT_Encode4(1287332), // Rule ID 8806 //
     /* 1287253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1287270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287306 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287331 */     // GIR_Coverage, 8806,
     /* 1287331 */     GIR_EraseRootFromParent_Done,
     /* 1287332 */   // Label 18516: @1287332
     /* 1287332 */   GIM_Try, /*On fail goto*//*Label 18517*/ GIMT_Encode4(1287416), // Rule ID 8807 //
     /* 1287337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1287354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287390 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287415 */     // GIR_Coverage, 8807,
     /* 1287415 */     GIR_EraseRootFromParent_Done,
     /* 1287416 */   // Label 18517: @1287416
     /* 1287416 */   GIM_Try, /*On fail goto*//*Label 18518*/ GIMT_Encode4(1287500), // Rule ID 8810 //
     /* 1287421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1287424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1287438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287474 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1287495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287499 */     // GIR_Coverage, 8810,
     /* 1287499 */     GIR_EraseRootFromParent_Done,
     /* 1287500 */   // Label 18518: @1287500
     /* 1287500 */   GIM_Try, /*On fail goto*//*Label 18519*/ GIMT_Encode4(1287584), // Rule ID 8811 //
     /* 1287505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1287508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1287522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287558 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1287579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287583 */     // GIR_Coverage, 8811,
     /* 1287583 */     GIR_EraseRootFromParent_Done,
     /* 1287584 */   // Label 18519: @1287584
     /* 1287584 */   GIM_Try, /*On fail goto*//*Label 18520*/ GIMT_Encode4(1287668), // Rule ID 8814 //
     /* 1287589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1287600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1287603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1287606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1287612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1287627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287642 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1287645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287667 */     // GIR_Coverage, 8814,
     /* 1287667 */     GIR_EraseRootFromParent_Done,
     /* 1287668 */   // Label 18520: @1287668
     /* 1287668 */   GIM_Try, /*On fail goto*//*Label 18521*/ GIMT_Encode4(1287752), // Rule ID 8815 //
     /* 1287673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1287684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1287687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1287690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1287696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1287711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287726 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1287729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287751 */     // GIR_Coverage, 8815,
     /* 1287751 */     GIR_EraseRootFromParent_Done,
     /* 1287752 */   // Label 18521: @1287752
     /* 1287752 */   GIM_Try, /*On fail goto*//*Label 18522*/ GIMT_Encode4(1287836), // Rule ID 8818 //
     /* 1287757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1287768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1287771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1287774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1287780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1287795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287810 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1287813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287835 */     // GIR_Coverage, 8818,
     /* 1287835 */     GIR_EraseRootFromParent_Done,
     /* 1287836 */   // Label 18522: @1287836
     /* 1287836 */   GIM_Try, /*On fail goto*//*Label 18523*/ GIMT_Encode4(1287920), // Rule ID 8819 //
     /* 1287841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1287852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1287855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1287858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1287864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1287879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287894 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1287897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287919 */     // GIR_Coverage, 8819,
     /* 1287919 */     GIR_EraseRootFromParent_Done,
     /* 1287920 */   // Label 18523: @1287920
     /* 1287920 */   GIM_Try, /*On fail goto*//*Label 18524*/ GIMT_Encode4(1288004), // Rule ID 8822 //
     /* 1287925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1287936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1287939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1287942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1287948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1287963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287978 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1287981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288003 */     // GIR_Coverage, 8822,
     /* 1288003 */     GIR_EraseRootFromParent_Done,
     /* 1288004 */   // Label 18524: @1288004
     /* 1288004 */   GIM_Try, /*On fail goto*//*Label 18525*/ GIMT_Encode4(1288088), // Rule ID 8823 //
     /* 1288009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1288020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1288023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1288026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1288032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288062 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288087 */     // GIR_Coverage, 8823,
     /* 1288087 */     GIR_EraseRootFromParent_Done,
     /* 1288088 */   // Label 18525: @1288088
     /* 1288088 */   GIM_Try, /*On fail goto*//*Label 18526*/ GIMT_Encode4(1288172), // Rule ID 8826 //
     /* 1288093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288146 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288171 */     // GIR_Coverage, 8826,
     /* 1288171 */     GIR_EraseRootFromParent_Done,
     /* 1288172 */   // Label 18526: @1288172
     /* 1288172 */   GIM_Try, /*On fail goto*//*Label 18527*/ GIMT_Encode4(1288256), // Rule ID 8827 //
     /* 1288177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288230 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288255 */     // GIR_Coverage, 8827,
     /* 1288255 */     GIR_EraseRootFromParent_Done,
     /* 1288256 */   // Label 18527: @1288256
     /* 1288256 */   GIM_Try, /*On fail goto*//*Label 18528*/ GIMT_Encode4(1288340), // Rule ID 8830 //
     /* 1288261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1288278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288314 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288339 */     // GIR_Coverage, 8830,
     /* 1288339 */     GIR_EraseRootFromParent_Done,
     /* 1288340 */   // Label 18528: @1288340
     /* 1288340 */   GIM_Try, /*On fail goto*//*Label 18529*/ GIMT_Encode4(1288424), // Rule ID 8831 //
     /* 1288345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1288362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288398 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288423 */     // GIR_Coverage, 8831,
     /* 1288423 */     GIR_EraseRootFromParent_Done,
     /* 1288424 */   // Label 18529: @1288424
     /* 1288424 */   GIM_Try, /*On fail goto*//*Label 18530*/ GIMT_Encode4(1288508), // Rule ID 8834 //
     /* 1288429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1288446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288482 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288507 */     // GIR_Coverage, 8834,
     /* 1288507 */     GIR_EraseRootFromParent_Done,
     /* 1288508 */   // Label 18530: @1288508
     /* 1288508 */   GIM_Try, /*On fail goto*//*Label 18531*/ GIMT_Encode4(1288592), // Rule ID 8835 //
     /* 1288513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1288530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288566 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288591 */     // GIR_Coverage, 8835,
     /* 1288591 */     GIR_EraseRootFromParent_Done,
     /* 1288592 */   // Label 18531: @1288592
     /* 1288592 */   GIM_Try, /*On fail goto*//*Label 18532*/ GIMT_Encode4(1288676), // Rule ID 8838 //
     /* 1288597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1288608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1288611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1288614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1288620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288650 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288675 */     // GIR_Coverage, 8838,
     /* 1288675 */     GIR_EraseRootFromParent_Done,
     /* 1288676 */   // Label 18532: @1288676
     /* 1288676 */   GIM_Try, /*On fail goto*//*Label 18533*/ GIMT_Encode4(1288760), // Rule ID 8839 //
     /* 1288681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1288692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1288695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1288698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1288704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288734 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288759 */     // GIR_Coverage, 8839,
     /* 1288759 */     GIR_EraseRootFromParent_Done,
     /* 1288760 */   // Label 18533: @1288760
     /* 1288760 */   GIM_Try, /*On fail goto*//*Label 18534*/ GIMT_Encode4(1288844), // Rule ID 8842 //
     /* 1288765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1288782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288818 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288843 */     // GIR_Coverage, 8842,
     /* 1288843 */     GIR_EraseRootFromParent_Done,
     /* 1288844 */   // Label 18534: @1288844
     /* 1288844 */   GIM_Try, /*On fail goto*//*Label 18535*/ GIMT_Encode4(1288928), // Rule ID 8843 //
     /* 1288849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1288866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288902 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288927 */     // GIR_Coverage, 8843,
     /* 1288927 */     GIR_EraseRootFromParent_Done,
     /* 1288928 */   // Label 18535: @1288928
     /* 1288928 */   GIM_Try, /*On fail goto*//*Label 18536*/ GIMT_Encode4(1289012), // Rule ID 8846 //
     /* 1288933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1288950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288986 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289011 */     // GIR_Coverage, 8846,
     /* 1289011 */     GIR_EraseRootFromParent_Done,
     /* 1289012 */   // Label 18536: @1289012
     /* 1289012 */   GIM_Try, /*On fail goto*//*Label 18537*/ GIMT_Encode4(1289096), // Rule ID 8847 //
     /* 1289017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1289034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289070 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289095 */     // GIR_Coverage, 8847,
     /* 1289095 */     GIR_EraseRootFromParent_Done,
     /* 1289096 */   // Label 18537: @1289096
     /* 1289096 */   GIM_Try, /*On fail goto*//*Label 18538*/ GIMT_Encode4(1289180), // Rule ID 8850 //
     /* 1289101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289154 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1289157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289179 */     // GIR_Coverage, 8850,
     /* 1289179 */     GIR_EraseRootFromParent_Done,
     /* 1289180 */   // Label 18538: @1289180
     /* 1289180 */   GIM_Try, /*On fail goto*//*Label 18539*/ GIMT_Encode4(1289264), // Rule ID 8851 //
     /* 1289185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289238 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1289241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289263 */     // GIR_Coverage, 8851,
     /* 1289263 */     GIR_EraseRootFromParent_Done,
     /* 1289264 */   // Label 18539: @1289264
     /* 1289264 */   GIM_Try, /*On fail goto*//*Label 18540*/ GIMT_Encode4(1289348), // Rule ID 8854 //
     /* 1289269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1289286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289322 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1289325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289347 */     // GIR_Coverage, 8854,
     /* 1289347 */     GIR_EraseRootFromParent_Done,
     /* 1289348 */   // Label 18540: @1289348
     /* 1289348 */   GIM_Try, /*On fail goto*//*Label 18541*/ GIMT_Encode4(1289432), // Rule ID 8855 //
     /* 1289353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1289370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289406 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1289409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289431 */     // GIR_Coverage, 8855,
     /* 1289431 */     GIR_EraseRootFromParent_Done,
     /* 1289432 */   // Label 18541: @1289432
     /* 1289432 */   GIM_Try, /*On fail goto*//*Label 18542*/ GIMT_Encode4(1289516), // Rule ID 8858 //
     /* 1289437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1289454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289490 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289515 */     // GIR_Coverage, 8858,
     /* 1289515 */     GIR_EraseRootFromParent_Done,
     /* 1289516 */   // Label 18542: @1289516
     /* 1289516 */   GIM_Try, /*On fail goto*//*Label 18543*/ GIMT_Encode4(1289600), // Rule ID 8859 //
     /* 1289521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1289538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289574 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289599 */     // GIR_Coverage, 8859,
     /* 1289599 */     GIR_EraseRootFromParent_Done,
     /* 1289600 */   // Label 18543: @1289600
     /* 1289600 */   GIM_Try, /*On fail goto*//*Label 18544*/ GIMT_Encode4(1289684), // Rule ID 8950 //
     /* 1289605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1289616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1289619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1289622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1289625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1289628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289658 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1289661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289683 */     // GIR_Coverage, 8950,
     /* 1289683 */     GIR_EraseRootFromParent_Done,
     /* 1289684 */   // Label 18544: @1289684
     /* 1289684 */   GIM_Try, /*On fail goto*//*Label 18545*/ GIMT_Encode4(1289768), // Rule ID 8951 //
     /* 1289689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1289700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1289703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1289706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1289709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1289712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289742 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1289745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289767 */     // GIR_Coverage, 8951,
     /* 1289767 */     GIR_EraseRootFromParent_Done,
     /* 1289768 */   // Label 18545: @1289768
     /* 1289768 */   GIM_Try, /*On fail goto*//*Label 18546*/ GIMT_Encode4(1289852), // Rule ID 8954 //
     /* 1289773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1289790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1289793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289826 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1289829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289851 */     // GIR_Coverage, 8954,
     /* 1289851 */     GIR_EraseRootFromParent_Done,
     /* 1289852 */   // Label 18546: @1289852
     /* 1289852 */   GIM_Try, /*On fail goto*//*Label 18547*/ GIMT_Encode4(1289936), // Rule ID 8955 //
     /* 1289857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1289874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1289877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289910 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1289913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289935 */     // GIR_Coverage, 8955,
     /* 1289935 */     GIR_EraseRootFromParent_Done,
     /* 1289936 */   // Label 18547: @1289936
     /* 1289936 */   GIM_Try, /*On fail goto*//*Label 18548*/ GIMT_Encode4(1290020), // Rule ID 8958 //
     /* 1289941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1289958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1289961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289994 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1289997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290019 */     // GIR_Coverage, 8958,
     /* 1290019 */     GIR_EraseRootFromParent_Done,
     /* 1290020 */   // Label 18548: @1290020
     /* 1290020 */   GIM_Try, /*On fail goto*//*Label 18549*/ GIMT_Encode4(1290104), // Rule ID 8959 //
     /* 1290025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1290042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1290045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290078 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290103 */     // GIR_Coverage, 8959,
     /* 1290103 */     GIR_EraseRootFromParent_Done,
     /* 1290104 */   // Label 18549: @1290104
     /* 1290104 */   GIM_Try, /*On fail goto*//*Label 18550*/ GIMT_Encode4(1290188), // Rule ID 8962 //
     /* 1290109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1290126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1290129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290162 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1290165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290187 */     // GIR_Coverage, 8962,
     /* 1290187 */     GIR_EraseRootFromParent_Done,
     /* 1290188 */   // Label 18550: @1290188
     /* 1290188 */   GIM_Try, /*On fail goto*//*Label 18551*/ GIMT_Encode4(1290272), // Rule ID 8963 //
     /* 1290193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1290210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1290213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290246 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1290249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290271 */     // GIR_Coverage, 8963,
     /* 1290271 */     GIR_EraseRootFromParent_Done,
     /* 1290272 */   // Label 18551: @1290272
     /* 1290272 */   GIM_Try, /*On fail goto*//*Label 18552*/ GIMT_Encode4(1290356), // Rule ID 8966 //
     /* 1290277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1290294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1290297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290330 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290355 */     // GIR_Coverage, 8966,
     /* 1290355 */     GIR_EraseRootFromParent_Done,
     /* 1290356 */   // Label 18552: @1290356
     /* 1290356 */   GIM_Try, /*On fail goto*//*Label 18553*/ GIMT_Encode4(1290440), // Rule ID 8967 //
     /* 1290361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1290378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1290381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290414 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290439 */     // GIR_Coverage, 8967,
     /* 1290439 */     GIR_EraseRootFromParent_Done,
     /* 1290440 */   // Label 18553: @1290440
     /* 1290440 */   GIM_Try, /*On fail goto*//*Label 18554*/ GIMT_Encode4(1290524), // Rule ID 8970 //
     /* 1290445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1290462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1290465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290498 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290523 */     // GIR_Coverage, 8970,
     /* 1290523 */     GIR_EraseRootFromParent_Done,
     /* 1290524 */   // Label 18554: @1290524
     /* 1290524 */   GIM_Try, /*On fail goto*//*Label 18555*/ GIMT_Encode4(1290608), // Rule ID 8971 //
     /* 1290529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1290546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1290549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290582 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290607 */     // GIR_Coverage, 8971,
     /* 1290607 */     GIR_EraseRootFromParent_Done,
     /* 1290608 */   // Label 18555: @1290608
     /* 1290608 */   GIM_Try, /*On fail goto*//*Label 18556*/ GIMT_Encode4(1290692), // Rule ID 8974 //
     /* 1290613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1290624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1290627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1290630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1290633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290666 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1290669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290691 */     // GIR_Coverage, 8974,
     /* 1290691 */     GIR_EraseRootFromParent_Done,
     /* 1290692 */   // Label 18556: @1290692
     /* 1290692 */   GIM_Try, /*On fail goto*//*Label 18557*/ GIMT_Encode4(1290776), // Rule ID 8975 //
     /* 1290697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1290708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1290711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1290714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1290717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290750 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1290753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290775 */     // GIR_Coverage, 8975,
     /* 1290775 */     GIR_EraseRootFromParent_Done,
     /* 1290776 */   // Label 18557: @1290776
     /* 1290776 */   GIM_Try, /*On fail goto*//*Label 18558*/ GIMT_Encode4(1290860), // Rule ID 8978 //
     /* 1290781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1290798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1290801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290834 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1290837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290859 */     // GIR_Coverage, 8978,
     /* 1290859 */     GIR_EraseRootFromParent_Done,
     /* 1290860 */   // Label 18558: @1290860
     /* 1290860 */   GIM_Try, /*On fail goto*//*Label 18559*/ GIMT_Encode4(1290944), // Rule ID 8979 //
     /* 1290865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1290882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1290885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290918 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1290921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290943 */     // GIR_Coverage, 8979,
     /* 1290943 */     GIR_EraseRootFromParent_Done,
     /* 1290944 */   // Label 18559: @1290944
     /* 1290944 */   GIM_Try, /*On fail goto*//*Label 18560*/ GIMT_Encode4(1291028), // Rule ID 8982 //
     /* 1290949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1290966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1290969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291002 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291027 */     // GIR_Coverage, 8982,
     /* 1291027 */     GIR_EraseRootFromParent_Done,
     /* 1291028 */   // Label 18560: @1291028
     /* 1291028 */   GIM_Try, /*On fail goto*//*Label 18561*/ GIMT_Encode4(1291112), // Rule ID 8983 //
     /* 1291033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1291050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1291053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291086 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291111 */     // GIR_Coverage, 8983,
     /* 1291111 */     GIR_EraseRootFromParent_Done,
     /* 1291112 */   // Label 18561: @1291112
     /* 1291112 */   GIM_Try, /*On fail goto*//*Label 18562*/ GIMT_Encode4(1291196), // Rule ID 8986 //
     /* 1291117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1291120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1291134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1291137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291170 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1291191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291195 */     // GIR_Coverage, 8986,
     /* 1291195 */     GIR_EraseRootFromParent_Done,
     /* 1291196 */   // Label 18562: @1291196
     /* 1291196 */   GIM_Try, /*On fail goto*//*Label 18563*/ GIMT_Encode4(1291280), // Rule ID 8987 //
     /* 1291201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1291204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1291218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1291221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291254 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1291275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291279 */     // GIR_Coverage, 8987,
     /* 1291279 */     GIR_EraseRootFromParent_Done,
     /* 1291280 */   // Label 18563: @1291280
     /* 1291280 */   GIM_Try, /*On fail goto*//*Label 18564*/ GIMT_Encode4(1291364), // Rule ID 8990 //
     /* 1291285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1291296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1291299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1291302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1291305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291338 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1291341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291363 */     // GIR_Coverage, 8990,
     /* 1291363 */     GIR_EraseRootFromParent_Done,
     /* 1291364 */   // Label 18564: @1291364
     /* 1291364 */   GIM_Try, /*On fail goto*//*Label 18565*/ GIMT_Encode4(1291448), // Rule ID 8991 //
     /* 1291369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1291380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1291383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1291386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1291389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291422 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1291425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291447 */     // GIR_Coverage, 8991,
     /* 1291447 */     GIR_EraseRootFromParent_Done,
     /* 1291448 */   // Label 18565: @1291448
     /* 1291448 */   GIM_Try, /*On fail goto*//*Label 18566*/ GIMT_Encode4(1291532), // Rule ID 8994 //
     /* 1291453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1291464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1291467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1291470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1291473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1291476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291506 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1291509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291531 */     // GIR_Coverage, 8994,
     /* 1291531 */     GIR_EraseRootFromParent_Done,
     /* 1291532 */   // Label 18566: @1291532
     /* 1291532 */   GIM_Try, /*On fail goto*//*Label 18567*/ GIMT_Encode4(1291616), // Rule ID 8995 //
     /* 1291537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1291548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1291551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1291554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1291557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1291560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291590 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1291593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291615 */     // GIR_Coverage, 8995,
     /* 1291615 */     GIR_EraseRootFromParent_Done,
     /* 1291616 */   // Label 18567: @1291616
     /* 1291616 */   GIM_Try, /*On fail goto*//*Label 18568*/ GIMT_Encode4(1291700), // Rule ID 8998 //
     /* 1291621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1291632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1291635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1291638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1291641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1291644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1291659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1291663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291674 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1291677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291699 */     // GIR_Coverage, 8998,
     /* 1291699 */     GIR_EraseRootFromParent_Done,
     /* 1291700 */   // Label 18568: @1291700
     /* 1291700 */   GIM_Try, /*On fail goto*//*Label 18569*/ GIMT_Encode4(1291784), // Rule ID 8999 //
     /* 1291705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1291716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1291719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1291722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1291725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1291728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1291743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1291747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291758 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1291761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291783 */     // GIR_Coverage, 8999,
     /* 1291783 */     GIR_EraseRootFromParent_Done,
     /* 1291784 */   // Label 18569: @1291784
     /* 1291784 */   GIM_Try, /*On fail goto*//*Label 18570*/ GIMT_Encode4(1291868), // Rule ID 9002 //
     /* 1291789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1291800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1291803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1291806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1291809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1291812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291842 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1291845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291867 */     // GIR_Coverage, 9002,
     /* 1291867 */     GIR_EraseRootFromParent_Done,
     /* 1291868 */   // Label 18570: @1291868
     /* 1291868 */   GIM_Try, /*On fail goto*//*Label 18571*/ GIMT_Encode4(1291952), // Rule ID 9003 //
     /* 1291873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1291884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1291887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1291890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1291893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1291896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291926 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1291929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291951 */     // GIR_Coverage, 9003,
     /* 1291951 */     GIR_EraseRootFromParent_Done,
     /* 1291952 */   // Label 18571: @1291952
     /* 1291952 */   GIM_Try, /*On fail goto*//*Label 18572*/ GIMT_Encode4(1292036), // Rule ID 9006 //
     /* 1291957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1291968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1291971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1291974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1291977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292010 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292035 */     // GIR_Coverage, 9006,
     /* 1292035 */     GIR_EraseRootFromParent_Done,
     /* 1292036 */   // Label 18572: @1292036
     /* 1292036 */   GIM_Try, /*On fail goto*//*Label 18573*/ GIMT_Encode4(1292120), // Rule ID 9007 //
     /* 1292041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1292058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1292061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292094 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292119 */     // GIR_Coverage, 9007,
     /* 1292119 */     GIR_EraseRootFromParent_Done,
     /* 1292120 */   // Label 18573: @1292120
     /* 1292120 */   GIM_Try, /*On fail goto*//*Label 18574*/ GIMT_Encode4(1292204), // Rule ID 9010 //
     /* 1292125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1292142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1292145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292178 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292203 */     // GIR_Coverage, 9010,
     /* 1292203 */     GIR_EraseRootFromParent_Done,
     /* 1292204 */   // Label 18574: @1292204
     /* 1292204 */   GIM_Try, /*On fail goto*//*Label 18575*/ GIMT_Encode4(1292288), // Rule ID 9011 //
     /* 1292209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1292226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1292229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292262 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292287 */     // GIR_Coverage, 9011,
     /* 1292287 */     GIR_EraseRootFromParent_Done,
     /* 1292288 */   // Label 18575: @1292288
     /* 1292288 */   GIM_Try, /*On fail goto*//*Label 18576*/ GIMT_Encode4(1292372), // Rule ID 9014 //
     /* 1292293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1292310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1292313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292346 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292371 */     // GIR_Coverage, 9014,
     /* 1292371 */     GIR_EraseRootFromParent_Done,
     /* 1292372 */   // Label 18576: @1292372
     /* 1292372 */   GIM_Try, /*On fail goto*//*Label 18577*/ GIMT_Encode4(1292456), // Rule ID 9015 //
     /* 1292377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1292394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1292397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292430 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292455 */     // GIR_Coverage, 9015,
     /* 1292455 */     GIR_EraseRootFromParent_Done,
     /* 1292456 */   // Label 18577: @1292456
     /* 1292456 */   GIM_Try, /*On fail goto*//*Label 18578*/ GIMT_Encode4(1292540), // Rule ID 9018 //
     /* 1292461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1292478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1292481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292514 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292539 */     // GIR_Coverage, 9018,
     /* 1292539 */     GIR_EraseRootFromParent_Done,
     /* 1292540 */   // Label 18578: @1292540
     /* 1292540 */   GIM_Try, /*On fail goto*//*Label 18579*/ GIMT_Encode4(1292624), // Rule ID 9019 //
     /* 1292545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1292562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1292565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292598 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292623 */     // GIR_Coverage, 9019,
     /* 1292623 */     GIR_EraseRootFromParent_Done,
     /* 1292624 */   // Label 18579: @1292624
     /* 1292624 */   GIM_Try, /*On fail goto*//*Label 18580*/ GIMT_Encode4(1292708), // Rule ID 9022 //
     /* 1292629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1292646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1292649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292682 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292707 */     // GIR_Coverage, 9022,
     /* 1292707 */     GIR_EraseRootFromParent_Done,
     /* 1292708 */   // Label 18580: @1292708
     /* 1292708 */   GIM_Try, /*On fail goto*//*Label 18581*/ GIMT_Encode4(1292792), // Rule ID 9023 //
     /* 1292713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1292730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1292733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292766 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292791 */     // GIR_Coverage, 9023,
     /* 1292791 */     GIR_EraseRootFromParent_Done,
     /* 1292792 */   // Label 18581: @1292792
     /* 1292792 */   GIM_Try, /*On fail goto*//*Label 18582*/ GIMT_Encode4(1292876), // Rule ID 9026 //
     /* 1292797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1292800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1292808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1292811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1292814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1292817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1292820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292850 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1292871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292875 */     // GIR_Coverage, 9026,
     /* 1292875 */     GIR_EraseRootFromParent_Done,
     /* 1292876 */   // Label 18582: @1292876
     /* 1292876 */   GIM_Try, /*On fail goto*//*Label 18583*/ GIMT_Encode4(1292960), // Rule ID 9027 //
     /* 1292881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1292884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1292892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1292895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1292898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1292901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1292904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292934 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1292955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292959 */     // GIR_Coverage, 9027,
     /* 1292959 */     GIR_EraseRootFromParent_Done,
     /* 1292960 */   // Label 18583: @1292960
     /* 1292960 */   GIM_Try, /*On fail goto*//*Label 18584*/ GIMT_Encode4(1293044), // Rule ID 9030 //
     /* 1292965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1292968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1292982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1292985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293018 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1293021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293043 */     // GIR_Coverage, 9030,
     /* 1293043 */     GIR_EraseRootFromParent_Done,
     /* 1293044 */   // Label 18584: @1293044
     /* 1293044 */   GIM_Try, /*On fail goto*//*Label 18585*/ GIMT_Encode4(1293128), // Rule ID 9031 //
     /* 1293049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1293066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1293069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293102 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1293105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293127 */     // GIR_Coverage, 9031,
     /* 1293127 */     GIR_EraseRootFromParent_Done,
     /* 1293128 */   // Label 18585: @1293128
     /* 1293128 */   GIM_Try, /*On fail goto*//*Label 18586*/ GIMT_Encode4(1293212), // Rule ID 9034 //
     /* 1293133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1293136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1293150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1293153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293186 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1293189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293211 */     // GIR_Coverage, 9034,
     /* 1293211 */     GIR_EraseRootFromParent_Done,
     /* 1293212 */   // Label 18586: @1293212
     /* 1293212 */   GIM_Try, /*On fail goto*//*Label 18587*/ GIMT_Encode4(1293296), // Rule ID 9035 //
     /* 1293217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1293234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1293237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293270 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1293273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293295 */     // GIR_Coverage, 9035,
     /* 1293295 */     GIR_EraseRootFromParent_Done,
     /* 1293296 */   // Label 18587: @1293296
     /* 1293296 */   GIM_Try, /*On fail goto*//*Label 18588*/ GIMT_Encode4(1293380), // Rule ID 9038 //
     /* 1293301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1293318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293354 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1293357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293379 */     // GIR_Coverage, 9038,
     /* 1293379 */     GIR_EraseRootFromParent_Done,
     /* 1293380 */   // Label 18588: @1293380
     /* 1293380 */   GIM_Try, /*On fail goto*//*Label 18589*/ GIMT_Encode4(1293464), // Rule ID 9039 //
     /* 1293385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1293402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293438 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1293441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293463 */     // GIR_Coverage, 9039,
     /* 1293463 */     GIR_EraseRootFromParent_Done,
     /* 1293464 */   // Label 18589: @1293464
     /* 1293464 */   GIM_Try, /*On fail goto*//*Label 18590*/ GIMT_Encode4(1293548), // Rule ID 9042 //
     /* 1293469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1293486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293522 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1293525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293547 */     // GIR_Coverage, 9042,
     /* 1293547 */     GIR_EraseRootFromParent_Done,
     /* 1293548 */   // Label 18590: @1293548
     /* 1293548 */   GIM_Try, /*On fail goto*//*Label 18591*/ GIMT_Encode4(1293632), // Rule ID 9043 //
     /* 1293553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1293570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293606 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1293609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293631 */     // GIR_Coverage, 9043,
     /* 1293631 */     GIR_EraseRootFromParent_Done,
     /* 1293632 */   // Label 18591: @1293632
     /* 1293632 */   GIM_Try, /*On fail goto*//*Label 18592*/ GIMT_Encode4(1293716), // Rule ID 9046 //
     /* 1293637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1293654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293690 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1293693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293715 */     // GIR_Coverage, 9046,
     /* 1293715 */     GIR_EraseRootFromParent_Done,
     /* 1293716 */   // Label 18592: @1293716
     /* 1293716 */   GIM_Try, /*On fail goto*//*Label 18593*/ GIMT_Encode4(1293800), // Rule ID 9047 //
     /* 1293721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1293738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293774 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1293777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293799 */     // GIR_Coverage, 9047,
     /* 1293799 */     GIR_EraseRootFromParent_Done,
     /* 1293800 */   // Label 18593: @1293800
     /* 1293800 */   GIM_Try, /*On fail goto*//*Label 18594*/ GIMT_Encode4(1293884), // Rule ID 9050 //
     /* 1293805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1293822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293858 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1293861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293883 */     // GIR_Coverage, 9050,
     /* 1293883 */     GIR_EraseRootFromParent_Done,
     /* 1293884 */   // Label 18594: @1293884
     /* 1293884 */   GIM_Try, /*On fail goto*//*Label 18595*/ GIMT_Encode4(1293968), // Rule ID 9051 //
     /* 1293889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1293906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293942 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1293945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293967 */     // GIR_Coverage, 9051,
     /* 1293967 */     GIR_EraseRootFromParent_Done,
     /* 1293968 */   // Label 18595: @1293968
     /* 1293968 */   GIM_Try, /*On fail goto*//*Label 18596*/ GIMT_Encode4(1294052), // Rule ID 9054 //
     /* 1293973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1293990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294026 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294051 */     // GIR_Coverage, 9054,
     /* 1294051 */     GIR_EraseRootFromParent_Done,
     /* 1294052 */   // Label 18596: @1294052
     /* 1294052 */   GIM_Try, /*On fail goto*//*Label 18597*/ GIMT_Encode4(1294136), // Rule ID 9055 //
     /* 1294057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1294074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294110 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294135 */     // GIR_Coverage, 9055,
     /* 1294135 */     GIR_EraseRootFromParent_Done,
     /* 1294136 */   // Label 18597: @1294136
     /* 1294136 */   GIM_Try, /*On fail goto*//*Label 18598*/ GIMT_Encode4(1294220), // Rule ID 9058 //
     /* 1294141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1294158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294194 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294219 */     // GIR_Coverage, 9058,
     /* 1294219 */     GIR_EraseRootFromParent_Done,
     /* 1294220 */   // Label 18598: @1294220
     /* 1294220 */   GIM_Try, /*On fail goto*//*Label 18599*/ GIMT_Encode4(1294304), // Rule ID 9059 //
     /* 1294225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1294242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294278 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294303 */     // GIR_Coverage, 9059,
     /* 1294303 */     GIR_EraseRootFromParent_Done,
     /* 1294304 */   // Label 18599: @1294304
     /* 1294304 */   GIM_Try, /*On fail goto*//*Label 18600*/ GIMT_Encode4(1294388), // Rule ID 9062 //
     /* 1294309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1294326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294362 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294387 */     // GIR_Coverage, 9062,
     /* 1294387 */     GIR_EraseRootFromParent_Done,
     /* 1294388 */   // Label 18600: @1294388
     /* 1294388 */   GIM_Try, /*On fail goto*//*Label 18601*/ GIMT_Encode4(1294472), // Rule ID 9063 //
     /* 1294393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1294410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294446 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294471 */     // GIR_Coverage, 9063,
     /* 1294471 */     GIR_EraseRootFromParent_Done,
     /* 1294472 */   // Label 18601: @1294472
     /* 1294472 */   GIM_Try, /*On fail goto*//*Label 18602*/ GIMT_Encode4(1294556), // Rule ID 9066 //
     /* 1294477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1294494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294530 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294555 */     // GIR_Coverage, 9066,
     /* 1294555 */     GIR_EraseRootFromParent_Done,
     /* 1294556 */   // Label 18602: @1294556
     /* 1294556 */   GIM_Try, /*On fail goto*//*Label 18603*/ GIMT_Encode4(1294640), // Rule ID 9067 //
     /* 1294561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1294578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294614 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294639 */     // GIR_Coverage, 9067,
     /* 1294639 */     GIR_EraseRootFromParent_Done,
     /* 1294640 */   // Label 18603: @1294640
     /* 1294640 */   GIM_Try, /*On fail goto*//*Label 18604*/ GIMT_Encode4(1294724), // Rule ID 9070 //
     /* 1294645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1294662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294698 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294723 */     // GIR_Coverage, 9070,
     /* 1294723 */     GIR_EraseRootFromParent_Done,
     /* 1294724 */   // Label 18604: @1294724
     /* 1294724 */   GIM_Try, /*On fail goto*//*Label 18605*/ GIMT_Encode4(1294808), // Rule ID 9071 //
     /* 1294729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1294746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294782 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294807 */     // GIR_Coverage, 9071,
     /* 1294807 */     GIR_EraseRootFromParent_Done,
     /* 1294808 */   // Label 18605: @1294808
     /* 1294808 */   GIM_Try, /*On fail goto*//*Label 18606*/ GIMT_Encode4(1294892), // Rule ID 9074 //
     /* 1294813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1294816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1294830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294866 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1294887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294891 */     // GIR_Coverage, 9074,
     /* 1294891 */     GIR_EraseRootFromParent_Done,
     /* 1294892 */   // Label 18606: @1294892
     /* 1294892 */   GIM_Try, /*On fail goto*//*Label 18607*/ GIMT_Encode4(1294976), // Rule ID 9075 //
     /* 1294897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1294900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1294914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294950 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1294971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294975 */     // GIR_Coverage, 9075,
     /* 1294975 */     GIR_EraseRootFromParent_Done,
     /* 1294976 */   // Label 18607: @1294976
     /* 1294976 */   GIM_Try, /*On fail goto*//*Label 18608*/ GIMT_Encode4(1295060), // Rule ID 9078 //
     /* 1294981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1294992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1294995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1294998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295034 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1295037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295059 */     // GIR_Coverage, 9078,
     /* 1295059 */     GIR_EraseRootFromParent_Done,
     /* 1295060 */   // Label 18608: @1295060
     /* 1295060 */   GIM_Try, /*On fail goto*//*Label 18609*/ GIMT_Encode4(1295144), // Rule ID 9079 //
     /* 1295065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1295082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295118 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1295121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295143 */     // GIR_Coverage, 9079,
     /* 1295143 */     GIR_EraseRootFromParent_Done,
     /* 1295144 */   // Label 18609: @1295144
     /* 1295144 */   GIM_Try, /*On fail goto*//*Label 18610*/ GIMT_Encode4(1295228), // Rule ID 9082 //
     /* 1295149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1295166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295202 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1295205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295227 */     // GIR_Coverage, 9082,
     /* 1295227 */     GIR_EraseRootFromParent_Done,
     /* 1295228 */   // Label 18610: @1295228
     /* 1295228 */   GIM_Try, /*On fail goto*//*Label 18611*/ GIMT_Encode4(1295312), // Rule ID 9083 //
     /* 1295233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1295250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295286 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1295289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295311 */     // GIR_Coverage, 9083,
     /* 1295311 */     GIR_EraseRootFromParent_Done,
     /* 1295312 */   // Label 18611: @1295312
     /* 1295312 */   GIM_Try, /*On fail goto*//*Label 18612*/ GIMT_Encode4(1295396), // Rule ID 9086 //
     /* 1295317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1295328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1295331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1295334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1295340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295370 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1295373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295395 */     // GIR_Coverage, 9086,
     /* 1295395 */     GIR_EraseRootFromParent_Done,
     /* 1295396 */   // Label 18612: @1295396
     /* 1295396 */   GIM_Try, /*On fail goto*//*Label 18613*/ GIMT_Encode4(1295480), // Rule ID 9087 //
     /* 1295401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1295412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1295415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1295418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1295424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295454 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1295457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295479 */     // GIR_Coverage, 9087,
     /* 1295479 */     GIR_EraseRootFromParent_Done,
     /* 1295480 */   // Label 18613: @1295480
     /* 1295480 */   GIM_Try, /*On fail goto*//*Label 18614*/ GIMT_Encode4(1295564), // Rule ID 9090 //
     /* 1295485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1295496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1295499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1295502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295538 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1295541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295563 */     // GIR_Coverage, 9090,
     /* 1295563 */     GIR_EraseRootFromParent_Done,
     /* 1295564 */   // Label 18614: @1295564
     /* 1295564 */   GIM_Try, /*On fail goto*//*Label 18615*/ GIMT_Encode4(1295648), // Rule ID 9091 //
     /* 1295569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1295580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1295583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1295586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295622 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1295625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295647 */     // GIR_Coverage, 9091,
     /* 1295647 */     GIR_EraseRootFromParent_Done,
     /* 1295648 */   // Label 18615: @1295648
     /* 1295648 */   GIM_Try, /*On fail goto*//*Label 18616*/ GIMT_Encode4(1295732), // Rule ID 9094 //
     /* 1295653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1295670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295706 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1295709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295731 */     // GIR_Coverage, 9094,
     /* 1295731 */     GIR_EraseRootFromParent_Done,
     /* 1295732 */   // Label 18616: @1295732
     /* 1295732 */   GIM_Try, /*On fail goto*//*Label 18617*/ GIMT_Encode4(1295816), // Rule ID 9095 //
     /* 1295737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1295754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295790 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1295793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295815 */     // GIR_Coverage, 9095,
     /* 1295815 */     GIR_EraseRootFromParent_Done,
     /* 1295816 */   // Label 18617: @1295816
     /* 1295816 */   GIM_Try, /*On fail goto*//*Label 18618*/ GIMT_Encode4(1295900), // Rule ID 9098 //
     /* 1295821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1295838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295874 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1295877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295899 */     // GIR_Coverage, 9098,
     /* 1295899 */     GIR_EraseRootFromParent_Done,
     /* 1295900 */   // Label 18618: @1295900
     /* 1295900 */   GIM_Try, /*On fail goto*//*Label 18619*/ GIMT_Encode4(1295984), // Rule ID 9099 //
     /* 1295905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1295922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295958 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1295961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295983 */     // GIR_Coverage, 9099,
     /* 1295983 */     GIR_EraseRootFromParent_Done,
     /* 1295984 */   // Label 18619: @1295984
     /* 1295984 */   GIM_Try, /*On fail goto*//*Label 18620*/ GIMT_Encode4(1296068), // Rule ID 9102 //
     /* 1295989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1296006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296042 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296067 */     // GIR_Coverage, 9102,
     /* 1296067 */     GIR_EraseRootFromParent_Done,
     /* 1296068 */   // Label 18620: @1296068
     /* 1296068 */   GIM_Try, /*On fail goto*//*Label 18621*/ GIMT_Encode4(1296152), // Rule ID 9103 //
     /* 1296073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1296090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296126 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296151 */     // GIR_Coverage, 9103,
     /* 1296151 */     GIR_EraseRootFromParent_Done,
     /* 1296152 */   // Label 18621: @1296152
     /* 1296152 */   GIM_Try, /*On fail goto*//*Label 18622*/ GIMT_Encode4(1296236), // Rule ID 9106 //
     /* 1296157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1296174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296210 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296235 */     // GIR_Coverage, 9106,
     /* 1296235 */     GIR_EraseRootFromParent_Done,
     /* 1296236 */   // Label 18622: @1296236
     /* 1296236 */   GIM_Try, /*On fail goto*//*Label 18623*/ GIMT_Encode4(1296320), // Rule ID 9107 //
     /* 1296241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1296258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296294 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296319 */     // GIR_Coverage, 9107,
     /* 1296319 */     GIR_EraseRootFromParent_Done,
     /* 1296320 */   // Label 18623: @1296320
     /* 1296320 */   GIM_Try, /*On fail goto*//*Label 18624*/ GIMT_Encode4(1296404), // Rule ID 9110 //
     /* 1296325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1296342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296378 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296403 */     // GIR_Coverage, 9110,
     /* 1296403 */     GIR_EraseRootFromParent_Done,
     /* 1296404 */   // Label 18624: @1296404
     /* 1296404 */   GIM_Try, /*On fail goto*//*Label 18625*/ GIMT_Encode4(1296488), // Rule ID 9111 //
     /* 1296409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1296426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296462 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296487 */     // GIR_Coverage, 9111,
     /* 1296487 */     GIR_EraseRootFromParent_Done,
     /* 1296488 */   // Label 18625: @1296488
     /* 1296488 */   GIM_Try, /*On fail goto*//*Label 18626*/ GIMT_Encode4(1296572), // Rule ID 9114 //
     /* 1296493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1296496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1296504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1296507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1296510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296546 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296571 */     // GIR_Coverage, 9114,
     /* 1296571 */     GIR_EraseRootFromParent_Done,
     /* 1296572 */   // Label 18626: @1296572
     /* 1296572 */   GIM_Try, /*On fail goto*//*Label 18627*/ GIMT_Encode4(1296656), // Rule ID 9115 //
     /* 1296577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1296580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1296588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1296591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1296594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296630 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296655 */     // GIR_Coverage, 9115,
     /* 1296655 */     GIR_EraseRootFromParent_Done,
     /* 1296656 */   // Label 18627: @1296656
     /* 1296656 */   GIM_Try, /*On fail goto*//*Label 18628*/ GIMT_Encode4(1296740), // Rule ID 9118 //
     /* 1296661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1296664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1296678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296714 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296739 */     // GIR_Coverage, 9118,
     /* 1296739 */     GIR_EraseRootFromParent_Done,
     /* 1296740 */   // Label 18628: @1296740
     /* 1296740 */   GIM_Try, /*On fail goto*//*Label 18629*/ GIMT_Encode4(1296824), // Rule ID 9119 //
     /* 1296745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1296748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1296762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296798 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296823 */     // GIR_Coverage, 9119,
     /* 1296823 */     GIR_EraseRootFromParent_Done,
     /* 1296824 */   // Label 18629: @1296824
     /* 1296824 */   GIM_Try, /*On fail goto*//*Label 18630*/ GIMT_Encode4(1296908), // Rule ID 9122 //
     /* 1296829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1296832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1296846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296882 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296907 */     // GIR_Coverage, 9122,
     /* 1296907 */     GIR_EraseRootFromParent_Done,
     /* 1296908 */   // Label 18630: @1296908
     /* 1296908 */   GIM_Try, /*On fail goto*//*Label 18631*/ GIMT_Encode4(1296992), // Rule ID 9123 //
     /* 1296913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1296916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1296930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296966 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296991 */     // GIR_Coverage, 9123,
     /* 1296991 */     GIR_EraseRootFromParent_Done,
     /* 1296992 */   // Label 18631: @1296992
     /* 1296992 */   GIM_Try, /*On fail goto*//*Label 18632*/ GIMT_Encode4(1297076), // Rule ID 9214 //
     /* 1296997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1297014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297050 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1297053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297075 */     // GIR_Coverage, 9214,
     /* 1297075 */     GIR_EraseRootFromParent_Done,
     /* 1297076 */   // Label 18632: @1297076
     /* 1297076 */   GIM_Try, /*On fail goto*//*Label 18633*/ GIMT_Encode4(1297160), // Rule ID 9215 //
     /* 1297081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1297098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297134 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1297137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297159 */     // GIR_Coverage, 9215,
     /* 1297159 */     GIR_EraseRootFromParent_Done,
     /* 1297160 */   // Label 18633: @1297160
     /* 1297160 */   GIM_Try, /*On fail goto*//*Label 18634*/ GIMT_Encode4(1297244), // Rule ID 9218 //
     /* 1297165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1297182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297218 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1297221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297243 */     // GIR_Coverage, 9218,
     /* 1297243 */     GIR_EraseRootFromParent_Done,
     /* 1297244 */   // Label 18634: @1297244
     /* 1297244 */   GIM_Try, /*On fail goto*//*Label 18635*/ GIMT_Encode4(1297328), // Rule ID 9219 //
     /* 1297249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1297266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297302 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1297305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297327 */     // GIR_Coverage, 9219,
     /* 1297327 */     GIR_EraseRootFromParent_Done,
     /* 1297328 */   // Label 18635: @1297328
     /* 1297328 */   GIM_Try, /*On fail goto*//*Label 18636*/ GIMT_Encode4(1297412), // Rule ID 9222 //
     /* 1297333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1297350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297386 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297411 */     // GIR_Coverage, 9222,
     /* 1297411 */     GIR_EraseRootFromParent_Done,
     /* 1297412 */   // Label 18636: @1297412
     /* 1297412 */   GIM_Try, /*On fail goto*//*Label 18637*/ GIMT_Encode4(1297496), // Rule ID 9223 //
     /* 1297417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1297434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297470 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297495 */     // GIR_Coverage, 9223,
     /* 1297495 */     GIR_EraseRootFromParent_Done,
     /* 1297496 */   // Label 18637: @1297496
     /* 1297496 */   GIM_Try, /*On fail goto*//*Label 18638*/ GIMT_Encode4(1297580), // Rule ID 9226 //
     /* 1297501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1297518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297554 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1297557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297579 */     // GIR_Coverage, 9226,
     /* 1297579 */     GIR_EraseRootFromParent_Done,
     /* 1297580 */   // Label 18638: @1297580
     /* 1297580 */   GIM_Try, /*On fail goto*//*Label 18639*/ GIMT_Encode4(1297664), // Rule ID 9227 //
     /* 1297585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1297602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297638 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1297641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297663 */     // GIR_Coverage, 9227,
     /* 1297663 */     GIR_EraseRootFromParent_Done,
     /* 1297664 */   // Label 18639: @1297664
     /* 1297664 */   GIM_Try, /*On fail goto*//*Label 18640*/ GIMT_Encode4(1297748), // Rule ID 9230 //
     /* 1297669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1297686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297722 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297747 */     // GIR_Coverage, 9230,
     /* 1297747 */     GIR_EraseRootFromParent_Done,
     /* 1297748 */   // Label 18640: @1297748
     /* 1297748 */   GIM_Try, /*On fail goto*//*Label 18641*/ GIMT_Encode4(1297832), // Rule ID 9231 //
     /* 1297753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1297770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297806 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297831 */     // GIR_Coverage, 9231,
     /* 1297831 */     GIR_EraseRootFromParent_Done,
     /* 1297832 */   // Label 18641: @1297832
     /* 1297832 */   GIM_Try, /*On fail goto*//*Label 18642*/ GIMT_Encode4(1297916), // Rule ID 9234 //
     /* 1297837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1297854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297890 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297915 */     // GIR_Coverage, 9234,
     /* 1297915 */     GIR_EraseRootFromParent_Done,
     /* 1297916 */   // Label 18642: @1297916
     /* 1297916 */   GIM_Try, /*On fail goto*//*Label 18643*/ GIMT_Encode4(1298000), // Rule ID 9235 //
     /* 1297921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1297938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297974 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297999 */     // GIR_Coverage, 9235,
     /* 1297999 */     GIR_EraseRootFromParent_Done,
     /* 1298000 */   // Label 18643: @1298000
     /* 1298000 */   GIM_Try, /*On fail goto*//*Label 18644*/ GIMT_Encode4(1298084), // Rule ID 9238 //
     /* 1298005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1298022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298058 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298083 */     // GIR_Coverage, 9238,
     /* 1298083 */     GIR_EraseRootFromParent_Done,
     /* 1298084 */   // Label 18644: @1298084
     /* 1298084 */   GIM_Try, /*On fail goto*//*Label 18645*/ GIMT_Encode4(1298168), // Rule ID 9239 //
     /* 1298089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1298106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298142 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298167 */     // GIR_Coverage, 9239,
     /* 1298167 */     GIR_EraseRootFromParent_Done,
     /* 1298168 */   // Label 18645: @1298168
     /* 1298168 */   GIM_Try, /*On fail goto*//*Label 18646*/ GIMT_Encode4(1298252), // Rule ID 9242 //
     /* 1298173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1298190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298226 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298251 */     // GIR_Coverage, 9242,
     /* 1298251 */     GIR_EraseRootFromParent_Done,
     /* 1298252 */   // Label 18646: @1298252
     /* 1298252 */   GIM_Try, /*On fail goto*//*Label 18647*/ GIMT_Encode4(1298336), // Rule ID 9243 //
     /* 1298257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1298274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298310 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298335 */     // GIR_Coverage, 9243,
     /* 1298335 */     GIR_EraseRootFromParent_Done,
     /* 1298336 */   // Label 18647: @1298336
     /* 1298336 */   GIM_Try, /*On fail goto*//*Label 18648*/ GIMT_Encode4(1298420), // Rule ID 9246 //
     /* 1298341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1298358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298394 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298419 */     // GIR_Coverage, 9246,
     /* 1298419 */     GIR_EraseRootFromParent_Done,
     /* 1298420 */   // Label 18648: @1298420
     /* 1298420 */   GIM_Try, /*On fail goto*//*Label 18649*/ GIMT_Encode4(1298504), // Rule ID 9247 //
     /* 1298425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1298442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298478 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298503 */     // GIR_Coverage, 9247,
     /* 1298503 */     GIR_EraseRootFromParent_Done,
     /* 1298504 */   // Label 18649: @1298504
     /* 1298504 */   GIM_Try, /*On fail goto*//*Label 18650*/ GIMT_Encode4(1298588), // Rule ID 9250 //
     /* 1298509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1298512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1298526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298562 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298587 */     // GIR_Coverage, 9250,
     /* 1298587 */     GIR_EraseRootFromParent_Done,
     /* 1298588 */   // Label 18650: @1298588
     /* 1298588 */   GIM_Try, /*On fail goto*//*Label 18651*/ GIMT_Encode4(1298672), // Rule ID 9251 //
     /* 1298593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1298596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1298610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298646 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298671 */     // GIR_Coverage, 9251,
     /* 1298671 */     GIR_EraseRootFromParent_Done,
     /* 1298672 */   // Label 18651: @1298672
     /* 1298672 */   GIM_Try, /*On fail goto*//*Label 18652*/ GIMT_Encode4(1298756), // Rule ID 9254 //
     /* 1298677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1298688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1298691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1298694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1298700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1298715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298730 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1298733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298755 */     // GIR_Coverage, 9254,
     /* 1298755 */     GIR_EraseRootFromParent_Done,
     /* 1298756 */   // Label 18652: @1298756
     /* 1298756 */   GIM_Try, /*On fail goto*//*Label 18653*/ GIMT_Encode4(1298840), // Rule ID 9255 //
     /* 1298761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1298772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1298775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1298778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1298784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1298799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298814 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1298817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298839 */     // GIR_Coverage, 9255,
     /* 1298839 */     GIR_EraseRootFromParent_Done,
     /* 1298840 */   // Label 18653: @1298840
     /* 1298840 */   GIM_Try, /*On fail goto*//*Label 18654*/ GIMT_Encode4(1298924), // Rule ID 9258 //
     /* 1298845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1298856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1298859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1298862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1298868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1298883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298898 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1298901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298923 */     // GIR_Coverage, 9258,
     /* 1298923 */     GIR_EraseRootFromParent_Done,
     /* 1298924 */   // Label 18654: @1298924
     /* 1298924 */   GIM_Try, /*On fail goto*//*Label 18655*/ GIMT_Encode4(1299008), // Rule ID 9259 //
     /* 1298929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1298940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1298943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1298946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1298952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1298967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298982 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1298985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299007 */     // GIR_Coverage, 9259,
     /* 1299007 */     GIR_EraseRootFromParent_Done,
     /* 1299008 */   // Label 18655: @1299008
     /* 1299008 */   GIM_Try, /*On fail goto*//*Label 18656*/ GIMT_Encode4(1299092), // Rule ID 9262 //
     /* 1299013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1299024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1299027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1299030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1299036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299066 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1299069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299091 */     // GIR_Coverage, 9262,
     /* 1299091 */     GIR_EraseRootFromParent_Done,
     /* 1299092 */   // Label 18656: @1299092
     /* 1299092 */   GIM_Try, /*On fail goto*//*Label 18657*/ GIMT_Encode4(1299176), // Rule ID 9263 //
     /* 1299097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1299108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1299111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1299114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1299120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299150 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1299153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299175 */     // GIR_Coverage, 9263,
     /* 1299175 */     GIR_EraseRootFromParent_Done,
     /* 1299176 */   // Label 18657: @1299176
     /* 1299176 */   GIM_Try, /*On fail goto*//*Label 18658*/ GIMT_Encode4(1299260), // Rule ID 9266 //
     /* 1299181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299234 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299259 */     // GIR_Coverage, 9266,
     /* 1299259 */     GIR_EraseRootFromParent_Done,
     /* 1299260 */   // Label 18658: @1299260
     /* 1299260 */   GIM_Try, /*On fail goto*//*Label 18659*/ GIMT_Encode4(1299344), // Rule ID 9267 //
     /* 1299265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299318 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299343 */     // GIR_Coverage, 9267,
     /* 1299343 */     GIR_EraseRootFromParent_Done,
     /* 1299344 */   // Label 18659: @1299344
     /* 1299344 */   GIM_Try, /*On fail goto*//*Label 18660*/ GIMT_Encode4(1299428), // Rule ID 9270 //
     /* 1299349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1299366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299402 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299427 */     // GIR_Coverage, 9270,
     /* 1299427 */     GIR_EraseRootFromParent_Done,
     /* 1299428 */   // Label 18660: @1299428
     /* 1299428 */   GIM_Try, /*On fail goto*//*Label 18661*/ GIMT_Encode4(1299512), // Rule ID 9271 //
     /* 1299433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1299450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299486 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299511 */     // GIR_Coverage, 9271,
     /* 1299511 */     GIR_EraseRootFromParent_Done,
     /* 1299512 */   // Label 18661: @1299512
     /* 1299512 */   GIM_Try, /*On fail goto*//*Label 18662*/ GIMT_Encode4(1299596), // Rule ID 9274 //
     /* 1299517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1299534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299570 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1299573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299595 */     // GIR_Coverage, 9274,
     /* 1299595 */     GIR_EraseRootFromParent_Done,
     /* 1299596 */   // Label 18662: @1299596
     /* 1299596 */   GIM_Try, /*On fail goto*//*Label 18663*/ GIMT_Encode4(1299680), // Rule ID 9275 //
     /* 1299601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1299618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299654 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1299657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299679 */     // GIR_Coverage, 9275,
     /* 1299679 */     GIR_EraseRootFromParent_Done,
     /* 1299680 */   // Label 18663: @1299680
     /* 1299680 */   GIM_Try, /*On fail goto*//*Label 18664*/ GIMT_Encode4(1299764), // Rule ID 9278 //
     /* 1299685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1299696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1299699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1299702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1299708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299738 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299763 */     // GIR_Coverage, 9278,
     /* 1299763 */     GIR_EraseRootFromParent_Done,
     /* 1299764 */   // Label 18664: @1299764
     /* 1299764 */   GIM_Try, /*On fail goto*//*Label 18665*/ GIMT_Encode4(1299848), // Rule ID 9279 //
     /* 1299769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1299780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1299783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1299786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1299792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299822 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299847 */     // GIR_Coverage, 9279,
     /* 1299847 */     GIR_EraseRootFromParent_Done,
     /* 1299848 */   // Label 18665: @1299848
     /* 1299848 */   GIM_Try, /*On fail goto*//*Label 18666*/ GIMT_Encode4(1299932), // Rule ID 9282 //
     /* 1299853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1299870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299906 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299931 */     // GIR_Coverage, 9282,
     /* 1299931 */     GIR_EraseRootFromParent_Done,
     /* 1299932 */   // Label 18666: @1299932
     /* 1299932 */   GIM_Try, /*On fail goto*//*Label 18667*/ GIMT_Encode4(1300016), // Rule ID 9283 //
     /* 1299937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1299954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299990 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300015 */     // GIR_Coverage, 9283,
     /* 1300015 */     GIR_EraseRootFromParent_Done,
     /* 1300016 */   // Label 18667: @1300016
     /* 1300016 */   GIM_Try, /*On fail goto*//*Label 18668*/ GIMT_Encode4(1300100), // Rule ID 9286 //
     /* 1300021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300074 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300099 */     // GIR_Coverage, 9286,
     /* 1300099 */     GIR_EraseRootFromParent_Done,
     /* 1300100 */   // Label 18668: @1300100
     /* 1300100 */   GIM_Try, /*On fail goto*//*Label 18669*/ GIMT_Encode4(1300184), // Rule ID 9287 //
     /* 1300105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300158 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300183 */     // GIR_Coverage, 9287,
     /* 1300183 */     GIR_EraseRootFromParent_Done,
     /* 1300184 */   // Label 18669: @1300184
     /* 1300184 */   GIM_Try, /*On fail goto*//*Label 18670*/ GIMT_Encode4(1300268), // Rule ID 9290 //
     /* 1300189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300242 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1300245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300267 */     // GIR_Coverage, 9290,
     /* 1300267 */     GIR_EraseRootFromParent_Done,
     /* 1300268 */   // Label 18670: @1300268
     /* 1300268 */   GIM_Try, /*On fail goto*//*Label 18671*/ GIMT_Encode4(1300352), // Rule ID 9291 //
     /* 1300273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300326 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1300329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300351 */     // GIR_Coverage, 9291,
     /* 1300351 */     GIR_EraseRootFromParent_Done,
     /* 1300352 */   // Label 18671: @1300352
     /* 1300352 */   GIM_Try, /*On fail goto*//*Label 18672*/ GIMT_Encode4(1300436), // Rule ID 9294 //
     /* 1300357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1300374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300410 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1300413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300435 */     // GIR_Coverage, 9294,
     /* 1300435 */     GIR_EraseRootFromParent_Done,
     /* 1300436 */   // Label 18672: @1300436
     /* 1300436 */   GIM_Try, /*On fail goto*//*Label 18673*/ GIMT_Encode4(1300520), // Rule ID 9295 //
     /* 1300441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1300458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300494 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1300497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300519 */     // GIR_Coverage, 9295,
     /* 1300519 */     GIR_EraseRootFromParent_Done,
     /* 1300520 */   // Label 18673: @1300520
     /* 1300520 */   GIM_Try, /*On fail goto*//*Label 18674*/ GIMT_Encode4(1300604), // Rule ID 9298 //
     /* 1300525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1300542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300578 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300603 */     // GIR_Coverage, 9298,
     /* 1300603 */     GIR_EraseRootFromParent_Done,
     /* 1300604 */   // Label 18674: @1300604
     /* 1300604 */   GIM_Try, /*On fail goto*//*Label 18675*/ GIMT_Encode4(1300688), // Rule ID 9299 //
     /* 1300609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1300626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300662 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300687 */     // GIR_Coverage, 9299,
     /* 1300687 */     GIR_EraseRootFromParent_Done,
     /* 1300688 */   // Label 18675: @1300688
     /* 1300688 */   GIM_Try, /*On fail goto*//*Label 18676*/ GIMT_Encode4(1300772), // Rule ID 9390 //
     /* 1300693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1300704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1300707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1300710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1300716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300746 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1300749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300771 */     // GIR_Coverage, 9390,
     /* 1300771 */     GIR_EraseRootFromParent_Done,
     /* 1300772 */   // Label 18676: @1300772
     /* 1300772 */   GIM_Try, /*On fail goto*//*Label 18677*/ GIMT_Encode4(1300856), // Rule ID 9391 //
     /* 1300777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1300788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1300791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1300794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1300800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300830 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1300833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300855 */     // GIR_Coverage, 9391,
     /* 1300855 */     GIR_EraseRootFromParent_Done,
     /* 1300856 */   // Label 18677: @1300856
     /* 1300856 */   GIM_Try, /*On fail goto*//*Label 18678*/ GIMT_Encode4(1300940), // Rule ID 9394 //
     /* 1300861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1300878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300914 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1300917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300939 */     // GIR_Coverage, 9394,
     /* 1300939 */     GIR_EraseRootFromParent_Done,
     /* 1300940 */   // Label 18678: @1300940
     /* 1300940 */   GIM_Try, /*On fail goto*//*Label 18679*/ GIMT_Encode4(1301024), // Rule ID 9395 //
     /* 1300945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1300962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1301001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301023 */     // GIR_Coverage, 9395,
     /* 1301023 */     GIR_EraseRootFromParent_Done,
     /* 1301024 */   // Label 18679: @1301024
     /* 1301024 */   GIM_Try, /*On fail goto*//*Label 18680*/ GIMT_Encode4(1301108), // Rule ID 9398 //
     /* 1301029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301082 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301107 */     // GIR_Coverage, 9398,
     /* 1301107 */     GIR_EraseRootFromParent_Done,
     /* 1301108 */   // Label 18680: @1301108
     /* 1301108 */   GIM_Try, /*On fail goto*//*Label 18681*/ GIMT_Encode4(1301192), // Rule ID 9399 //
     /* 1301113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301166 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301191 */     // GIR_Coverage, 9399,
     /* 1301191 */     GIR_EraseRootFromParent_Done,
     /* 1301192 */   // Label 18681: @1301192
     /* 1301192 */   GIM_Try, /*On fail goto*//*Label 18682*/ GIMT_Encode4(1301276), // Rule ID 9402 //
     /* 1301197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301250 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1301253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301275 */     // GIR_Coverage, 9402,
     /* 1301275 */     GIR_EraseRootFromParent_Done,
     /* 1301276 */   // Label 18682: @1301276
     /* 1301276 */   GIM_Try, /*On fail goto*//*Label 18683*/ GIMT_Encode4(1301360), // Rule ID 9403 //
     /* 1301281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301334 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1301337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301359 */     // GIR_Coverage, 9403,
     /* 1301359 */     GIR_EraseRootFromParent_Done,
     /* 1301360 */   // Label 18683: @1301360
     /* 1301360 */   GIM_Try, /*On fail goto*//*Label 18684*/ GIMT_Encode4(1301444), // Rule ID 9406 //
     /* 1301365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1301382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301418 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301443 */     // GIR_Coverage, 9406,
     /* 1301443 */     GIR_EraseRootFromParent_Done,
     /* 1301444 */   // Label 18684: @1301444
     /* 1301444 */   GIM_Try, /*On fail goto*//*Label 18685*/ GIMT_Encode4(1301528), // Rule ID 9407 //
     /* 1301449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1301466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301502 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301527 */     // GIR_Coverage, 9407,
     /* 1301527 */     GIR_EraseRootFromParent_Done,
     /* 1301528 */   // Label 18685: @1301528
     /* 1301528 */   GIM_Try, /*On fail goto*//*Label 18686*/ GIMT_Encode4(1301612), // Rule ID 9410 //
     /* 1301533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1301550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301586 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1301607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301611 */     // GIR_Coverage, 9410,
     /* 1301611 */     GIR_EraseRootFromParent_Done,
     /* 1301612 */   // Label 18686: @1301612
     /* 1301612 */   GIM_Try, /*On fail goto*//*Label 18687*/ GIMT_Encode4(1301696), // Rule ID 9411 //
     /* 1301617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1301634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301670 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1301691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301695 */     // GIR_Coverage, 9411,
     /* 1301695 */     GIR_EraseRootFromParent_Done,
     /* 1301696 */   // Label 18687: @1301696
     /* 1301696 */   GIM_Try, /*On fail goto*//*Label 18688*/ GIMT_Encode4(1301780), // Rule ID 9414 //
     /* 1301701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1301712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1301718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301754 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1301757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301779 */     // GIR_Coverage, 9414,
     /* 1301779 */     GIR_EraseRootFromParent_Done,
     /* 1301780 */   // Label 18688: @1301780
     /* 1301780 */   GIM_Try, /*On fail goto*//*Label 18689*/ GIMT_Encode4(1301864), // Rule ID 9415 //
     /* 1301785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1301796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1301802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301838 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1301841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301863 */     // GIR_Coverage, 9415,
     /* 1301863 */     GIR_EraseRootFromParent_Done,
     /* 1301864 */   // Label 18689: @1301864
     /* 1301864 */   GIM_Try, /*On fail goto*//*Label 18690*/ GIMT_Encode4(1301948), // Rule ID 9418 //
     /* 1301869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1301886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301922 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1301925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301947 */     // GIR_Coverage, 9418,
     /* 1301947 */     GIR_EraseRootFromParent_Done,
     /* 1301948 */   // Label 18690: @1301948
     /* 1301948 */   GIM_Try, /*On fail goto*//*Label 18691*/ GIMT_Encode4(1302032), // Rule ID 9419 //
     /* 1301953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1301970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302006 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302031 */     // GIR_Coverage, 9419,
     /* 1302031 */     GIR_EraseRootFromParent_Done,
     /* 1302032 */   // Label 18691: @1302032
     /* 1302032 */   GIM_Try, /*On fail goto*//*Label 18692*/ GIMT_Encode4(1302116), // Rule ID 9422 //
     /* 1302037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302090 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302115 */     // GIR_Coverage, 9422,
     /* 1302115 */     GIR_EraseRootFromParent_Done,
     /* 1302116 */   // Label 18692: @1302116
     /* 1302116 */   GIM_Try, /*On fail goto*//*Label 18693*/ GIMT_Encode4(1302200), // Rule ID 9423 //
     /* 1302121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302174 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302199 */     // GIR_Coverage, 9423,
     /* 1302199 */     GIR_EraseRootFromParent_Done,
     /* 1302200 */   // Label 18693: @1302200
     /* 1302200 */   GIM_Try, /*On fail goto*//*Label 18694*/ GIMT_Encode4(1302284), // Rule ID 9426 //
     /* 1302205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1302208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302258 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302283 */     // GIR_Coverage, 9426,
     /* 1302283 */     GIR_EraseRootFromParent_Done,
     /* 1302284 */   // Label 18694: @1302284
     /* 1302284 */   GIM_Try, /*On fail goto*//*Label 18695*/ GIMT_Encode4(1302368), // Rule ID 9427 //
     /* 1302289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1302292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302342 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302367 */     // GIR_Coverage, 9427,
     /* 1302367 */     GIR_EraseRootFromParent_Done,
     /* 1302368 */   // Label 18695: @1302368
     /* 1302368 */   GIM_Try, /*On fail goto*//*Label 18696*/ GIMT_Encode4(1302452), // Rule ID 9430 //
     /* 1302373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1302384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1302387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1302390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1302396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302426 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1302429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302451 */     // GIR_Coverage, 9430,
     /* 1302451 */     GIR_EraseRootFromParent_Done,
     /* 1302452 */   // Label 18696: @1302452
     /* 1302452 */   GIM_Try, /*On fail goto*//*Label 18697*/ GIMT_Encode4(1302536), // Rule ID 9431 //
     /* 1302457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1302468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1302471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1302474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1302480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302510 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1302513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302535 */     // GIR_Coverage, 9431,
     /* 1302535 */     GIR_EraseRootFromParent_Done,
     /* 1302536 */   // Label 18697: @1302536
     /* 1302536 */   GIM_Try, /*On fail goto*//*Label 18698*/ GIMT_Encode4(1302620), // Rule ID 9434 //
     /* 1302541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1302552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1302555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1302558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1302564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1302579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302594 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1302597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302619 */     // GIR_Coverage, 9434,
     /* 1302619 */     GIR_EraseRootFromParent_Done,
     /* 1302620 */   // Label 18698: @1302620
     /* 1302620 */   GIM_Try, /*On fail goto*//*Label 18699*/ GIMT_Encode4(1302704), // Rule ID 9435 //
     /* 1302625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1302636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1302639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1302642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1302648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1302663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302678 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1302681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302703 */     // GIR_Coverage, 9435,
     /* 1302703 */     GIR_EraseRootFromParent_Done,
     /* 1302704 */   // Label 18699: @1302704
     /* 1302704 */   GIM_Try, /*On fail goto*//*Label 18700*/ GIMT_Encode4(1302788), // Rule ID 9438 //
     /* 1302709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1302720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1302723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1302726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1302732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1302747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302762 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1302765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302787 */     // GIR_Coverage, 9438,
     /* 1302787 */     GIR_EraseRootFromParent_Done,
     /* 1302788 */   // Label 18700: @1302788
     /* 1302788 */   GIM_Try, /*On fail goto*//*Label 18701*/ GIMT_Encode4(1302872), // Rule ID 9439 //
     /* 1302793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1302804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1302807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1302810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1302816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1302831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302846 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1302849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302871 */     // GIR_Coverage, 9439,
     /* 1302871 */     GIR_EraseRootFromParent_Done,
     /* 1302872 */   // Label 18701: @1302872
     /* 1302872 */   GIM_Try, /*On fail goto*//*Label 18702*/ GIMT_Encode4(1302956), // Rule ID 9442 //
     /* 1302877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1302888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1302891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1302894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1302900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302930 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1302933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302955 */     // GIR_Coverage, 9442,
     /* 1302955 */     GIR_EraseRootFromParent_Done,
     /* 1302956 */   // Label 18702: @1302956
     /* 1302956 */   GIM_Try, /*On fail goto*//*Label 18703*/ GIMT_Encode4(1303040), // Rule ID 9443 //
     /* 1302961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1302972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1302975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1302978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1302984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303014 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303039 */     // GIR_Coverage, 9443,
     /* 1303039 */     GIR_EraseRootFromParent_Done,
     /* 1303040 */   // Label 18703: @1303040
     /* 1303040 */   GIM_Try, /*On fail goto*//*Label 18704*/ GIMT_Encode4(1303124), // Rule ID 9446 //
     /* 1303045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303098 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303123 */     // GIR_Coverage, 9446,
     /* 1303123 */     GIR_EraseRootFromParent_Done,
     /* 1303124 */   // Label 18704: @1303124
     /* 1303124 */   GIM_Try, /*On fail goto*//*Label 18705*/ GIMT_Encode4(1303208), // Rule ID 9447 //
     /* 1303129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303182 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303207 */     // GIR_Coverage, 9447,
     /* 1303207 */     GIR_EraseRootFromParent_Done,
     /* 1303208 */   // Label 18705: @1303208
     /* 1303208 */   GIM_Try, /*On fail goto*//*Label 18706*/ GIMT_Encode4(1303292), // Rule ID 9450 //
     /* 1303213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303266 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303291 */     // GIR_Coverage, 9450,
     /* 1303291 */     GIR_EraseRootFromParent_Done,
     /* 1303292 */   // Label 18706: @1303292
     /* 1303292 */   GIM_Try, /*On fail goto*//*Label 18707*/ GIMT_Encode4(1303376), // Rule ID 9451 //
     /* 1303297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303350 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303375 */     // GIR_Coverage, 9451,
     /* 1303375 */     GIR_EraseRootFromParent_Done,
     /* 1303376 */   // Label 18707: @1303376
     /* 1303376 */   GIM_Try, /*On fail goto*//*Label 18708*/ GIMT_Encode4(1303460), // Rule ID 9454 //
     /* 1303381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1303392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1303395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1303398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1303404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303434 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303459 */     // GIR_Coverage, 9454,
     /* 1303459 */     GIR_EraseRootFromParent_Done,
     /* 1303460 */   // Label 18708: @1303460
     /* 1303460 */   GIM_Try, /*On fail goto*//*Label 18709*/ GIMT_Encode4(1303544), // Rule ID 9455 //
     /* 1303465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1303476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1303479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1303482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1303488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303518 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303543 */     // GIR_Coverage, 9455,
     /* 1303543 */     GIR_EraseRootFromParent_Done,
     /* 1303544 */   // Label 18709: @1303544
     /* 1303544 */   GIM_Try, /*On fail goto*//*Label 18710*/ GIMT_Encode4(1303628), // Rule ID 9458 //
     /* 1303549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1303566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303602 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303627 */     // GIR_Coverage, 9458,
     /* 1303627 */     GIR_EraseRootFromParent_Done,
     /* 1303628 */   // Label 18710: @1303628
     /* 1303628 */   GIM_Try, /*On fail goto*//*Label 18711*/ GIMT_Encode4(1303712), // Rule ID 9459 //
     /* 1303633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1303650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303686 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303711 */     // GIR_Coverage, 9459,
     /* 1303711 */     GIR_EraseRootFromParent_Done,
     /* 1303712 */   // Label 18711: @1303712
     /* 1303712 */   GIM_Try, /*On fail goto*//*Label 18712*/ GIMT_Encode4(1303796), // Rule ID 9462 //
     /* 1303717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1303734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303770 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303795 */     // GIR_Coverage, 9462,
     /* 1303795 */     GIR_EraseRootFromParent_Done,
     /* 1303796 */   // Label 18712: @1303796
     /* 1303796 */   GIM_Try, /*On fail goto*//*Label 18713*/ GIMT_Encode4(1303880), // Rule ID 9463 //
     /* 1303801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1303818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303854 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303879 */     // GIR_Coverage, 9463,
     /* 1303879 */     GIR_EraseRootFromParent_Done,
     /* 1303880 */   // Label 18713: @1303880
     /* 1303880 */   GIM_Try, /*On fail goto*//*Label 18714*/ GIMT_Encode4(1303964), // Rule ID 9466 //
     /* 1303885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1303888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1303896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1303899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1303902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1303908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303938 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1303959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303963 */     // GIR_Coverage, 9466,
     /* 1303963 */     GIR_EraseRootFromParent_Done,
     /* 1303964 */   // Label 18714: @1303964
     /* 1303964 */   GIM_Try, /*On fail goto*//*Label 18715*/ GIMT_Encode4(1304048), // Rule ID 9467 //
     /* 1303969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1303972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1303980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1303983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1303986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1303992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304022 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1304025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304047 */     // GIR_Coverage, 9467,
     /* 1304047 */     GIR_EraseRootFromParent_Done,
     /* 1304048 */   // Label 18715: @1304048
     /* 1304048 */   GIM_Try, /*On fail goto*//*Label 18716*/ GIMT_Encode4(1304132), // Rule ID 9470 //
     /* 1304053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304106 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1304109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304131 */     // GIR_Coverage, 9470,
     /* 1304131 */     GIR_EraseRootFromParent_Done,
     /* 1304132 */   // Label 18716: @1304132
     /* 1304132 */   GIM_Try, /*On fail goto*//*Label 18717*/ GIMT_Encode4(1304216), // Rule ID 9471 //
     /* 1304137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304190 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1304193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304215 */     // GIR_Coverage, 9471,
     /* 1304215 */     GIR_EraseRootFromParent_Done,
     /* 1304216 */   // Label 18717: @1304216
     /* 1304216 */   GIM_Try, /*On fail goto*//*Label 18718*/ GIMT_Encode4(1304300), // Rule ID 9474 //
     /* 1304221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304274 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1304277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304299 */     // GIR_Coverage, 9474,
     /* 1304299 */     GIR_EraseRootFromParent_Done,
     /* 1304300 */   // Label 18718: @1304300
     /* 1304300 */   GIM_Try, /*On fail goto*//*Label 18719*/ GIMT_Encode4(1304384), // Rule ID 9475 //
     /* 1304305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304358 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1304361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304383 */     // GIR_Coverage, 9475,
     /* 1304383 */     GIR_EraseRootFromParent_Done,
     /* 1304384 */   // Label 18719: @1304384
     /* 1304384 */   GIM_Try, /*On fail goto*//*Label 18720*/ GIMT_Encode4(1304468), // Rule ID 9566 //
     /* 1304389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1304406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1304409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304442 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1304445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304467 */     // GIR_Coverage, 9566,
     /* 1304467 */     GIR_EraseRootFromParent_Done,
     /* 1304468 */   // Label 18720: @1304468
     /* 1304468 */   GIM_Try, /*On fail goto*//*Label 18721*/ GIMT_Encode4(1304552), // Rule ID 9567 //
     /* 1304473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1304490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1304493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304526 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1304529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304551 */     // GIR_Coverage, 9567,
     /* 1304551 */     GIR_EraseRootFromParent_Done,
     /* 1304552 */   // Label 18721: @1304552
     /* 1304552 */   GIM_Try, /*On fail goto*//*Label 18722*/ GIMT_Encode4(1304636), // Rule ID 9570 //
     /* 1304557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1304574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1304577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1304613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304635 */     // GIR_Coverage, 9570,
     /* 1304635 */     GIR_EraseRootFromParent_Done,
     /* 1304636 */   // Label 18722: @1304636
     /* 1304636 */   GIM_Try, /*On fail goto*//*Label 18723*/ GIMT_Encode4(1304720), // Rule ID 9571 //
     /* 1304641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1304658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1304661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304694 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1304697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304719 */     // GIR_Coverage, 9571,
     /* 1304719 */     GIR_EraseRootFromParent_Done,
     /* 1304720 */   // Label 18723: @1304720
     /* 1304720 */   GIM_Try, /*On fail goto*//*Label 18724*/ GIMT_Encode4(1304804), // Rule ID 9574 //
     /* 1304725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1304736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1304739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1304742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1304745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1304748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304778 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1304781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1304799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304803 */     // GIR_Coverage, 9574,
     /* 1304803 */     GIR_EraseRootFromParent_Done,
     /* 1304804 */   // Label 18724: @1304804
     /* 1304804 */   GIM_Try, /*On fail goto*//*Label 18725*/ GIMT_Encode4(1304888), // Rule ID 9575 //
     /* 1304809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1304820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1304823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1304826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1304829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1304832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304862 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1304865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1304883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304887 */     // GIR_Coverage, 9575,
     /* 1304887 */     GIR_EraseRootFromParent_Done,
     /* 1304888 */   // Label 18725: @1304888
     /* 1304888 */   GIM_Try, /*On fail goto*//*Label 18726*/ GIMT_Encode4(1304972), // Rule ID 9578 //
     /* 1304893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1304910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1304913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304946 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1304949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1304967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304971 */     // GIR_Coverage, 9578,
     /* 1304971 */     GIR_EraseRootFromParent_Done,
     /* 1304972 */   // Label 18726: @1304972
     /* 1304972 */   GIM_Try, /*On fail goto*//*Label 18727*/ GIMT_Encode4(1305056), // Rule ID 9579 //
     /* 1304977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1304994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1304997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305030 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305055 */     // GIR_Coverage, 9579,
     /* 1305055 */     GIR_EraseRootFromParent_Done,
     /* 1305056 */   // Label 18727: @1305056
     /* 1305056 */   GIM_Try, /*On fail goto*//*Label 18728*/ GIMT_Encode4(1305140), // Rule ID 9582 //
     /* 1305061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1305081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305114 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305139 */     // GIR_Coverage, 9582,
     /* 1305139 */     GIR_EraseRootFromParent_Done,
     /* 1305140 */   // Label 18728: @1305140
     /* 1305140 */   GIM_Try, /*On fail goto*//*Label 18729*/ GIMT_Encode4(1305224), // Rule ID 9583 //
     /* 1305145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1305165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305198 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305223 */     // GIR_Coverage, 9583,
     /* 1305223 */     GIR_EraseRootFromParent_Done,
     /* 1305224 */   // Label 18729: @1305224
     /* 1305224 */   GIM_Try, /*On fail goto*//*Label 18730*/ GIMT_Encode4(1305308), // Rule ID 9586 //
     /* 1305229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1305240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1305243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1305246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1305249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1305252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305282 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305307 */     // GIR_Coverage, 9586,
     /* 1305307 */     GIR_EraseRootFromParent_Done,
     /* 1305308 */   // Label 18730: @1305308
     /* 1305308 */   GIM_Try, /*On fail goto*//*Label 18731*/ GIMT_Encode4(1305392), // Rule ID 9587 //
     /* 1305313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1305324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1305327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1305330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1305333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1305336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305366 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305391 */     // GIR_Coverage, 9587,
     /* 1305391 */     GIR_EraseRootFromParent_Done,
     /* 1305392 */   // Label 18731: @1305392
     /* 1305392 */   GIM_Try, /*On fail goto*//*Label 18732*/ GIMT_Encode4(1305476), // Rule ID 9590 //
     /* 1305397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1305414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1305417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305450 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305475 */     // GIR_Coverage, 9590,
     /* 1305475 */     GIR_EraseRootFromParent_Done,
     /* 1305476 */   // Label 18732: @1305476
     /* 1305476 */   GIM_Try, /*On fail goto*//*Label 18733*/ GIMT_Encode4(1305560), // Rule ID 9591 //
     /* 1305481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1305498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1305501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305534 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305559 */     // GIR_Coverage, 9591,
     /* 1305559 */     GIR_EraseRootFromParent_Done,
     /* 1305560 */   // Label 18733: @1305560
     /* 1305560 */   GIM_Try, /*On fail goto*//*Label 18734*/ GIMT_Encode4(1305644), // Rule ID 9594 //
     /* 1305565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1305582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1305585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305618 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305643 */     // GIR_Coverage, 9594,
     /* 1305643 */     GIR_EraseRootFromParent_Done,
     /* 1305644 */   // Label 18734: @1305644
     /* 1305644 */   GIM_Try, /*On fail goto*//*Label 18735*/ GIMT_Encode4(1305728), // Rule ID 9595 //
     /* 1305649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1305666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1305669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305702 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305727 */     // GIR_Coverage, 9595,
     /* 1305727 */     GIR_EraseRootFromParent_Done,
     /* 1305728 */   // Label 18735: @1305728
     /* 1305728 */   GIM_Try, /*On fail goto*//*Label 18736*/ GIMT_Encode4(1305812), // Rule ID 9598 //
     /* 1305733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1305736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1305750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1305753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305786 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1305807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305811 */     // GIR_Coverage, 9598,
     /* 1305811 */     GIR_EraseRootFromParent_Done,
     /* 1305812 */   // Label 18736: @1305812
     /* 1305812 */   GIM_Try, /*On fail goto*//*Label 18737*/ GIMT_Encode4(1305896), // Rule ID 9599 //
     /* 1305817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1305820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1305834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1305837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305870 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1305891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305895 */     // GIR_Coverage, 9599,
     /* 1305895 */     GIR_EraseRootFromParent_Done,
     /* 1305896 */   // Label 18737: @1305896
     /* 1305896 */   GIM_Try, /*On fail goto*//*Label 18738*/ GIMT_Encode4(1305980), // Rule ID 9602 //
     /* 1305901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1305912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1305915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1305918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1305921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1305924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1305939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1305943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305954 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1305957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305979 */     // GIR_Coverage, 9602,
     /* 1305979 */     GIR_EraseRootFromParent_Done,
     /* 1305980 */   // Label 18738: @1305980
     /* 1305980 */   GIM_Try, /*On fail goto*//*Label 18739*/ GIMT_Encode4(1306064), // Rule ID 9603 //
     /* 1305985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1305996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1305999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1306002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1306005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306038 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306063 */     // GIR_Coverage, 9603,
     /* 1306063 */     GIR_EraseRootFromParent_Done,
     /* 1306064 */   // Label 18739: @1306064
     /* 1306064 */   GIM_Try, /*On fail goto*//*Label 18740*/ GIMT_Encode4(1306148), // Rule ID 9606 //
     /* 1306069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1306086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1306089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306122 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1306125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306147 */     // GIR_Coverage, 9606,
     /* 1306147 */     GIR_EraseRootFromParent_Done,
     /* 1306148 */   // Label 18740: @1306148
     /* 1306148 */   GIM_Try, /*On fail goto*//*Label 18741*/ GIMT_Encode4(1306232), // Rule ID 9607 //
     /* 1306153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1306170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1306173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306206 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1306209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306231 */     // GIR_Coverage, 9607,
     /* 1306231 */     GIR_EraseRootFromParent_Done,
     /* 1306232 */   // Label 18741: @1306232
     /* 1306232 */   GIM_Try, /*On fail goto*//*Label 18742*/ GIMT_Encode4(1306316), // Rule ID 9610 //
     /* 1306237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1306248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1306251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1306254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1306257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1306260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306290 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1306293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306315 */     // GIR_Coverage, 9610,
     /* 1306315 */     GIR_EraseRootFromParent_Done,
     /* 1306316 */   // Label 18742: @1306316
     /* 1306316 */   GIM_Try, /*On fail goto*//*Label 18743*/ GIMT_Encode4(1306400), // Rule ID 9611 //
     /* 1306321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1306332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1306335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1306338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1306341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1306344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306374 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1306377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306399 */     // GIR_Coverage, 9611,
     /* 1306399 */     GIR_EraseRootFromParent_Done,
     /* 1306400 */   // Label 18743: @1306400
     /* 1306400 */   GIM_Try, /*On fail goto*//*Label 18744*/ GIMT_Encode4(1306484), // Rule ID 9614 //
     /* 1306405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1306422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1306425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306458 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306483 */     // GIR_Coverage, 9614,
     /* 1306483 */     GIR_EraseRootFromParent_Done,
     /* 1306484 */   // Label 18744: @1306484
     /* 1306484 */   GIM_Try, /*On fail goto*//*Label 18745*/ GIMT_Encode4(1306568), // Rule ID 9615 //
     /* 1306489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1306506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1306509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306542 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306567 */     // GIR_Coverage, 9615,
     /* 1306567 */     GIR_EraseRootFromParent_Done,
     /* 1306568 */   // Label 18745: @1306568
     /* 1306568 */   GIM_Try, /*On fail goto*//*Label 18746*/ GIMT_Encode4(1306652), // Rule ID 9618 //
     /* 1306573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1306590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1306593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306626 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1306629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306651 */     // GIR_Coverage, 9618,
     /* 1306651 */     GIR_EraseRootFromParent_Done,
     /* 1306652 */   // Label 18746: @1306652
     /* 1306652 */   GIM_Try, /*On fail goto*//*Label 18747*/ GIMT_Encode4(1306736), // Rule ID 9619 //
     /* 1306657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1306674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1306677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306710 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1306713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306735 */     // GIR_Coverage, 9619,
     /* 1306735 */     GIR_EraseRootFromParent_Done,
     /* 1306736 */   // Label 18747: @1306736
     /* 1306736 */   GIM_Try, /*On fail goto*//*Label 18748*/ GIMT_Encode4(1306820), // Rule ID 9622 //
     /* 1306741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1306758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1306761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306794 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1306797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306819 */     // GIR_Coverage, 9622,
     /* 1306819 */     GIR_EraseRootFromParent_Done,
     /* 1306820 */   // Label 18748: @1306820
     /* 1306820 */   GIM_Try, /*On fail goto*//*Label 18749*/ GIMT_Encode4(1306904), // Rule ID 9623 //
     /* 1306825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1306842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1306845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306878 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1306881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306903 */     // GIR_Coverage, 9623,
     /* 1306903 */     GIR_EraseRootFromParent_Done,
     /* 1306904 */   // Label 18749: @1306904
     /* 1306904 */   GIM_Try, /*On fail goto*//*Label 18750*/ GIMT_Encode4(1306988), // Rule ID 9626 //
     /* 1306909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1306920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1306923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1306926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1306929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1306932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306962 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306987 */     // GIR_Coverage, 9626,
     /* 1306987 */     GIR_EraseRootFromParent_Done,
     /* 1306988 */   // Label 18750: @1306988
     /* 1306988 */   GIM_Try, /*On fail goto*//*Label 18751*/ GIMT_Encode4(1307072), // Rule ID 9627 //
     /* 1306993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1307010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1307013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307046 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1307049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307071 */     // GIR_Coverage, 9627,
     /* 1307071 */     GIR_EraseRootFromParent_Done,
     /* 1307072 */   // Label 18751: @1307072
     /* 1307072 */   GIM_Try, /*On fail goto*//*Label 18752*/ GIMT_Encode4(1307156), // Rule ID 9630 //
     /* 1307077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1307094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1307097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307130 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307155 */     // GIR_Coverage, 9630,
     /* 1307155 */     GIR_EraseRootFromParent_Done,
     /* 1307156 */   // Label 18752: @1307156
     /* 1307156 */   GIM_Try, /*On fail goto*//*Label 18753*/ GIMT_Encode4(1307240), // Rule ID 9631 //
     /* 1307161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1307178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1307181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307214 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307239 */     // GIR_Coverage, 9631,
     /* 1307239 */     GIR_EraseRootFromParent_Done,
     /* 1307240 */   // Label 18753: @1307240
     /* 1307240 */   GIM_Try, /*On fail goto*//*Label 18754*/ GIMT_Encode4(1307324), // Rule ID 9634 //
     /* 1307245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1307262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1307265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307298 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307323 */     // GIR_Coverage, 9634,
     /* 1307323 */     GIR_EraseRootFromParent_Done,
     /* 1307324 */   // Label 18754: @1307324
     /* 1307324 */   GIM_Try, /*On fail goto*//*Label 18755*/ GIMT_Encode4(1307408), // Rule ID 9635 //
     /* 1307329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1307346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1307349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307382 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307407 */     // GIR_Coverage, 9635,
     /* 1307407 */     GIR_EraseRootFromParent_Done,
     /* 1307408 */   // Label 18755: @1307408
     /* 1307408 */   GIM_Try, /*On fail goto*//*Label 18756*/ GIMT_Encode4(1307492), // Rule ID 9638 //
     /* 1307413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1307416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1307424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1307427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1307430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1307433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1307436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307466 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1307469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307491 */     // GIR_Coverage, 9638,
     /* 1307491 */     GIR_EraseRootFromParent_Done,
     /* 1307492 */   // Label 18756: @1307492
     /* 1307492 */   GIM_Try, /*On fail goto*//*Label 18757*/ GIMT_Encode4(1307576), // Rule ID 9639 //
     /* 1307497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1307500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1307508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1307511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1307514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1307517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1307520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307550 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1307553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307575 */     // GIR_Coverage, 9639,
     /* 1307575 */     GIR_EraseRootFromParent_Done,
     /* 1307576 */   // Label 18757: @1307576
     /* 1307576 */   GIM_Try, /*On fail goto*//*Label 18758*/ GIMT_Encode4(1307660), // Rule ID 9642 //
     /* 1307581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1307584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1307598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1307601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307634 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307659 */     // GIR_Coverage, 9642,
     /* 1307659 */     GIR_EraseRootFromParent_Done,
     /* 1307660 */   // Label 18758: @1307660
     /* 1307660 */   GIM_Try, /*On fail goto*//*Label 18759*/ GIMT_Encode4(1307744), // Rule ID 9643 //
     /* 1307665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1307668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1307682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1307685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307718 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307743 */     // GIR_Coverage, 9643,
     /* 1307743 */     GIR_EraseRootFromParent_Done,
     /* 1307744 */   // Label 18759: @1307744
     /* 1307744 */   GIM_Try, /*On fail goto*//*Label 18760*/ GIMT_Encode4(1307828), // Rule ID 9646 //
     /* 1307749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1307752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1307766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1307769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307802 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307827 */     // GIR_Coverage, 9646,
     /* 1307827 */     GIR_EraseRootFromParent_Done,
     /* 1307828 */   // Label 18760: @1307828
     /* 1307828 */   GIM_Try, /*On fail goto*//*Label 18761*/ GIMT_Encode4(1307912), // Rule ID 9647 //
     /* 1307833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1307836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1307850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1307853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307886 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307911 */     // GIR_Coverage, 9647,
     /* 1307911 */     GIR_EraseRootFromParent_Done,
     /* 1307912 */   // Label 18761: @1307912
     /* 1307912 */   GIM_Try, /*On fail goto*//*Label 18762*/ GIMT_Encode4(1307996), // Rule ID 9650 //
     /* 1307917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1307928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1307931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1307934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1307937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1307940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307970 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1307973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1307991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307995 */     // GIR_Coverage, 9650,
     /* 1307995 */     GIR_EraseRootFromParent_Done,
     /* 1307996 */   // Label 18762: @1307996
     /* 1307996 */   GIM_Try, /*On fail goto*//*Label 18763*/ GIMT_Encode4(1308080), // Rule ID 9651 //
     /* 1308001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1308018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1308021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308054 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1308057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308079 */     // GIR_Coverage, 9651,
     /* 1308079 */     GIR_EraseRootFromParent_Done,
     /* 1308080 */   // Label 18763: @1308080
     /* 1308080 */   GIM_Try, /*On fail goto*//*Label 18764*/ GIMT_Encode4(1308164), // Rule ID 9654 //
     /* 1308085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1308102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1308105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308138 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308163 */     // GIR_Coverage, 9654,
     /* 1308163 */     GIR_EraseRootFromParent_Done,
     /* 1308164 */   // Label 18764: @1308164
     /* 1308164 */   GIM_Try, /*On fail goto*//*Label 18765*/ GIMT_Encode4(1308248), // Rule ID 9655 //
     /* 1308169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1308186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1308189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308222 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308247 */     // GIR_Coverage, 9655,
     /* 1308247 */     GIR_EraseRootFromParent_Done,
     /* 1308248 */   // Label 18765: @1308248
     /* 1308248 */   GIM_Try, /*On fail goto*//*Label 18766*/ GIMT_Encode4(1308332), // Rule ID 9658 //
     /* 1308253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1308270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1308273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308306 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308331 */     // GIR_Coverage, 9658,
     /* 1308331 */     GIR_EraseRootFromParent_Done,
     /* 1308332 */   // Label 18766: @1308332
     /* 1308332 */   GIM_Try, /*On fail goto*//*Label 18767*/ GIMT_Encode4(1308416), // Rule ID 9659 //
     /* 1308337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1308354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1308357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308390 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308415 */     // GIR_Coverage, 9659,
     /* 1308415 */     GIR_EraseRootFromParent_Done,
     /* 1308416 */   // Label 18767: @1308416
     /* 1308416 */   GIM_Try, /*On fail goto*//*Label 18768*/ GIMT_Encode4(1308500), // Rule ID 9662 //
     /* 1308421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1308438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1308441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308474 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308499 */     // GIR_Coverage, 9662,
     /* 1308499 */     GIR_EraseRootFromParent_Done,
     /* 1308500 */   // Label 18768: @1308500
     /* 1308500 */   GIM_Try, /*On fail goto*//*Label 18769*/ GIMT_Encode4(1308584), // Rule ID 9663 //
     /* 1308505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1308522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1308525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308558 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308583 */     // GIR_Coverage, 9663,
     /* 1308583 */     GIR_EraseRootFromParent_Done,
     /* 1308584 */   // Label 18769: @1308584
     /* 1308584 */   GIM_Try, /*On fail goto*//*Label 18770*/ GIMT_Encode4(1308668), // Rule ID 9666 //
     /* 1308589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1308606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1308609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308642 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308667 */     // GIR_Coverage, 9666,
     /* 1308667 */     GIR_EraseRootFromParent_Done,
     /* 1308668 */   // Label 18770: @1308668
     /* 1308668 */   GIM_Try, /*On fail goto*//*Label 18771*/ GIMT_Encode4(1308752), // Rule ID 9667 //
     /* 1308673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1308690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1308693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308726 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308751 */     // GIR_Coverage, 9667,
     /* 1308751 */     GIR_EraseRootFromParent_Done,
     /* 1308752 */   // Label 18771: @1308752
     /* 1308752 */   GIM_Try, /*On fail goto*//*Label 18772*/ GIMT_Encode4(1308836), // Rule ID 9670 //
     /* 1308757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1308774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1308777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308810 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308835 */     // GIR_Coverage, 9670,
     /* 1308835 */     GIR_EraseRootFromParent_Done,
     /* 1308836 */   // Label 18772: @1308836
     /* 1308836 */   GIM_Try, /*On fail goto*//*Label 18773*/ GIMT_Encode4(1308920), // Rule ID 9671 //
     /* 1308841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1308858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1308861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308894 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308919 */     // GIR_Coverage, 9671,
     /* 1308919 */     GIR_EraseRootFromParent_Done,
     /* 1308920 */   // Label 18773: @1308920
     /* 1308920 */   GIM_Try, /*On fail goto*//*Label 18774*/ GIMT_Encode4(1309004), // Rule ID 9674 //
     /* 1308925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1308936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1308939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1308942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1308945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1308948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308978 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1308981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309003 */     // GIR_Coverage, 9674,
     /* 1309003 */     GIR_EraseRootFromParent_Done,
     /* 1309004 */   // Label 18774: @1309004
     /* 1309004 */   GIM_Try, /*On fail goto*//*Label 18775*/ GIMT_Encode4(1309088), // Rule ID 9675 //
     /* 1309009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1309020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1309023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1309026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1309029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1309032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309062 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309087 */     // GIR_Coverage, 9675,
     /* 1309087 */     GIR_EraseRootFromParent_Done,
     /* 1309088 */   // Label 18775: @1309088
     /* 1309088 */   GIM_Try, /*On fail goto*//*Label 18776*/ GIMT_Encode4(1309172), // Rule ID 9678 //
     /* 1309093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1309110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1309113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309146 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309171 */     // GIR_Coverage, 9678,
     /* 1309171 */     GIR_EraseRootFromParent_Done,
     /* 1309172 */   // Label 18776: @1309172
     /* 1309172 */   GIM_Try, /*On fail goto*//*Label 18777*/ GIMT_Encode4(1309256), // Rule ID 9679 //
     /* 1309177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1309194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1309197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309230 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309255 */     // GIR_Coverage, 9679,
     /* 1309255 */     GIR_EraseRootFromParent_Done,
     /* 1309256 */   // Label 18777: @1309256
     /* 1309256 */   GIM_Try, /*On fail goto*//*Label 18778*/ GIMT_Encode4(1309340), // Rule ID 9682 //
     /* 1309261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1309278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1309281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309314 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309339 */     // GIR_Coverage, 9682,
     /* 1309339 */     GIR_EraseRootFromParent_Done,
     /* 1309340 */   // Label 18778: @1309340
     /* 1309340 */   GIM_Try, /*On fail goto*//*Label 18779*/ GIMT_Encode4(1309424), // Rule ID 9683 //
     /* 1309345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1309362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1309365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309398 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309423 */     // GIR_Coverage, 9683,
     /* 1309423 */     GIR_EraseRootFromParent_Done,
     /* 1309424 */   // Label 18779: @1309424
     /* 1309424 */   GIM_Try, /*On fail goto*//*Label 18780*/ GIMT_Encode4(1309508), // Rule ID 9686 //
     /* 1309429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1309432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1309446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1309449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309482 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309507 */     // GIR_Coverage, 9686,
     /* 1309507 */     GIR_EraseRootFromParent_Done,
     /* 1309508 */   // Label 18780: @1309508
     /* 1309508 */   GIM_Try, /*On fail goto*//*Label 18781*/ GIMT_Encode4(1309592), // Rule ID 9687 //
     /* 1309513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1309516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1309530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1309533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309566 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309591 */     // GIR_Coverage, 9687,
     /* 1309591 */     GIR_EraseRootFromParent_Done,
     /* 1309592 */   // Label 18781: @1309592
     /* 1309592 */   GIM_Try, /*On fail goto*//*Label 18782*/ GIMT_Encode4(1309676), // Rule ID 9690 //
     /* 1309597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1309608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1309611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1309614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1309617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1309620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309650 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1309653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309675 */     // GIR_Coverage, 9690,
     /* 1309675 */     GIR_EraseRootFromParent_Done,
     /* 1309676 */   // Label 18782: @1309676
     /* 1309676 */   GIM_Try, /*On fail goto*//*Label 18783*/ GIMT_Encode4(1309760), // Rule ID 9691 //
     /* 1309681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1309692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1309695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1309698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1309701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1309704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309734 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1309737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309759 */     // GIR_Coverage, 9691,
     /* 1309759 */     GIR_EraseRootFromParent_Done,
     /* 1309760 */   // Label 18783: @1309760
     /* 1309760 */   GIM_Try, /*On fail goto*//*Label 18784*/ GIMT_Encode4(1309844), // Rule ID 9694 //
     /* 1309765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1309776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1309779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1309782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1309785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1309788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309818 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1309821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309843 */     // GIR_Coverage, 9694,
     /* 1309843 */     GIR_EraseRootFromParent_Done,
     /* 1309844 */   // Label 18784: @1309844
     /* 1309844 */   GIM_Try, /*On fail goto*//*Label 18785*/ GIMT_Encode4(1309928), // Rule ID 9695 //
     /* 1309849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1309860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1309863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1309866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1309869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1309872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309902 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1309905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309927 */     // GIR_Coverage, 9695,
     /* 1309927 */     GIR_EraseRootFromParent_Done,
     /* 1309928 */   // Label 18785: @1309928
     /* 1309928 */   GIM_Try, /*On fail goto*//*Label 18786*/ GIMT_Encode4(1310012), // Rule ID 9698 //
     /* 1309933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1309944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1309947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1309950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1309953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1309956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309986 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1309989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310011 */     // GIR_Coverage, 9698,
     /* 1310011 */     GIR_EraseRootFromParent_Done,
     /* 1310012 */   // Label 18786: @1310012
     /* 1310012 */   GIM_Try, /*On fail goto*//*Label 18787*/ GIMT_Encode4(1310096), // Rule ID 9699 //
     /* 1310017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1310028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1310031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1310034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1310037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1310040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310070 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310095 */     // GIR_Coverage, 9699,
     /* 1310095 */     GIR_EraseRootFromParent_Done,
     /* 1310096 */   // Label 18787: @1310096
     /* 1310096 */   GIM_Try, /*On fail goto*//*Label 18788*/ GIMT_Encode4(1310180), // Rule ID 9702 //
     /* 1310101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1310121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310154 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310179 */     // GIR_Coverage, 9702,
     /* 1310179 */     GIR_EraseRootFromParent_Done,
     /* 1310180 */   // Label 18788: @1310180
     /* 1310180 */   GIM_Try, /*On fail goto*//*Label 18789*/ GIMT_Encode4(1310264), // Rule ID 9703 //
     /* 1310185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1310205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310238 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310263 */     // GIR_Coverage, 9703,
     /* 1310263 */     GIR_EraseRootFromParent_Done,
     /* 1310264 */   // Label 18789: @1310264
     /* 1310264 */   GIM_Try, /*On fail goto*//*Label 18790*/ GIMT_Encode4(1310348), // Rule ID 9706 //
     /* 1310269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1310286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1310289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310322 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310347 */     // GIR_Coverage, 9706,
     /* 1310347 */     GIR_EraseRootFromParent_Done,
     /* 1310348 */   // Label 18790: @1310348
     /* 1310348 */   GIM_Try, /*On fail goto*//*Label 18791*/ GIMT_Encode4(1310432), // Rule ID 9707 //
     /* 1310353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1310370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1310373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310406 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310431 */     // GIR_Coverage, 9707,
     /* 1310431 */     GIR_EraseRootFromParent_Done,
     /* 1310432 */   // Label 18791: @1310432
     /* 1310432 */   GIM_Try, /*On fail goto*//*Label 18792*/ GIMT_Encode4(1310516), // Rule ID 9710 //
     /* 1310437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1310454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1310457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310490 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310515 */     // GIR_Coverage, 9710,
     /* 1310515 */     GIR_EraseRootFromParent_Done,
     /* 1310516 */   // Label 18792: @1310516
     /* 1310516 */   GIM_Try, /*On fail goto*//*Label 18793*/ GIMT_Encode4(1310600), // Rule ID 9711 //
     /* 1310521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1310538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1310541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310574 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310599 */     // GIR_Coverage, 9711,
     /* 1310599 */     GIR_EraseRootFromParent_Done,
     /* 1310600 */   // Label 18793: @1310600
     /* 1310600 */   GIM_Try, /*On fail goto*//*Label 18794*/ GIMT_Encode4(1310684), // Rule ID 9714 //
     /* 1310605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1310616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1310619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1310622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1310625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1310628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310658 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310683 */     // GIR_Coverage, 9714,
     /* 1310683 */     GIR_EraseRootFromParent_Done,
     /* 1310684 */   // Label 18794: @1310684
     /* 1310684 */   GIM_Try, /*On fail goto*//*Label 18795*/ GIMT_Encode4(1310768), // Rule ID 9715 //
     /* 1310689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1310700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1310703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1310706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1310709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1310712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310742 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310767 */     // GIR_Coverage, 9715,
     /* 1310767 */     GIR_EraseRootFromParent_Done,
     /* 1310768 */   // Label 18795: @1310768
     /* 1310768 */   GIM_Try, /*On fail goto*//*Label 18796*/ GIMT_Encode4(1310852), // Rule ID 9718 //
     /* 1310773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1310790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1310793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310826 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310851 */     // GIR_Coverage, 9718,
     /* 1310851 */     GIR_EraseRootFromParent_Done,
     /* 1310852 */   // Label 18796: @1310852
     /* 1310852 */   GIM_Try, /*On fail goto*//*Label 18797*/ GIMT_Encode4(1310936), // Rule ID 9719 //
     /* 1310857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1310874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1310877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310910 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310935 */     // GIR_Coverage, 9719,
     /* 1310935 */     GIR_EraseRootFromParent_Done,
     /* 1310936 */   // Label 18797: @1310936
     /* 1310936 */   GIM_Try, /*On fail goto*//*Label 18798*/ GIMT_Encode4(1311020), // Rule ID 9722 //
     /* 1310941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1310958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1310961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310994 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311019 */     // GIR_Coverage, 9722,
     /* 1311019 */     GIR_EraseRootFromParent_Done,
     /* 1311020 */   // Label 18798: @1311020
     /* 1311020 */   GIM_Try, /*On fail goto*//*Label 18799*/ GIMT_Encode4(1311104), // Rule ID 9723 //
     /* 1311025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1311042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1311045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311078 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311103 */     // GIR_Coverage, 9723,
     /* 1311103 */     GIR_EraseRootFromParent_Done,
     /* 1311104 */   // Label 18799: @1311104
     /* 1311104 */   GIM_Try, /*On fail goto*//*Label 18800*/ GIMT_Encode4(1311188), // Rule ID 9726 //
     /* 1311109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1311126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1311129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311162 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1311165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311187 */     // GIR_Coverage, 9726,
     /* 1311187 */     GIR_EraseRootFromParent_Done,
     /* 1311188 */   // Label 18800: @1311188
     /* 1311188 */   GIM_Try, /*On fail goto*//*Label 18801*/ GIMT_Encode4(1311272), // Rule ID 9727 //
     /* 1311193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1311210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1311213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311246 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1311249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311271 */     // GIR_Coverage, 9727,
     /* 1311271 */     GIR_EraseRootFromParent_Done,
     /* 1311272 */   // Label 18801: @1311272
     /* 1311272 */   GIM_Try, /*On fail goto*//*Label 18802*/ GIMT_Encode4(1311356), // Rule ID 9730 //
     /* 1311277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1311294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1311297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311330 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1311333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311355 */     // GIR_Coverage, 9730,
     /* 1311355 */     GIR_EraseRootFromParent_Done,
     /* 1311356 */   // Label 18802: @1311356
     /* 1311356 */   GIM_Try, /*On fail goto*//*Label 18803*/ GIMT_Encode4(1311440), // Rule ID 9731 //
     /* 1311361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1311378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1311381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311414 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1311417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311439 */     // GIR_Coverage, 9731,
     /* 1311439 */     GIR_EraseRootFromParent_Done,
     /* 1311440 */   // Label 18803: @1311440
     /* 1311440 */   GIM_Try, /*On fail goto*//*Label 18804*/ GIMT_Encode4(1311524), // Rule ID 9734 //
     /* 1311445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1311462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1311465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311498 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311523 */     // GIR_Coverage, 9734,
     /* 1311523 */     GIR_EraseRootFromParent_Done,
     /* 1311524 */   // Label 18804: @1311524
     /* 1311524 */   GIM_Try, /*On fail goto*//*Label 18805*/ GIMT_Encode4(1311608), // Rule ID 9735 //
     /* 1311529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1311546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1311549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311582 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311607 */     // GIR_Coverage, 9735,
     /* 1311607 */     GIR_EraseRootFromParent_Done,
     /* 1311608 */   // Label 18805: @1311608
     /* 1311608 */   GIM_Try, /*On fail goto*//*Label 18806*/ GIMT_Encode4(1311692), // Rule ID 9738 //
     /* 1311613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1311624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1311627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1311630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1311633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1311636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311666 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1311669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311691 */     // GIR_Coverage, 9738,
     /* 1311691 */     GIR_EraseRootFromParent_Done,
     /* 1311692 */   // Label 18806: @1311692
     /* 1311692 */   GIM_Try, /*On fail goto*//*Label 18807*/ GIMT_Encode4(1311776), // Rule ID 9739 //
     /* 1311697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1311708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1311711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1311714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1311717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1311720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311750 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1311753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311775 */     // GIR_Coverage, 9739,
     /* 1311775 */     GIR_EraseRootFromParent_Done,
     /* 1311776 */   // Label 18807: @1311776
     /* 1311776 */   GIM_Try, /*On fail goto*//*Label 18808*/ GIMT_Encode4(1311860), // Rule ID 9742 //
     /* 1311781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1311798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1311801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311834 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1311837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311859 */     // GIR_Coverage, 9742,
     /* 1311859 */     GIR_EraseRootFromParent_Done,
     /* 1311860 */   // Label 18808: @1311860
     /* 1311860 */   GIM_Try, /*On fail goto*//*Label 18809*/ GIMT_Encode4(1311944), // Rule ID 9743 //
     /* 1311865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1311882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1311885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311918 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1311921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311943 */     // GIR_Coverage, 9743,
     /* 1311943 */     GIR_EraseRootFromParent_Done,
     /* 1311944 */   // Label 18809: @1311944
     /* 1311944 */   GIM_Try, /*On fail goto*//*Label 18810*/ GIMT_Encode4(1312028), // Rule ID 9746 //
     /* 1311949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1311966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1311969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312002 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312027 */     // GIR_Coverage, 9746,
     /* 1312027 */     GIR_EraseRootFromParent_Done,
     /* 1312028 */   // Label 18810: @1312028
     /* 1312028 */   GIM_Try, /*On fail goto*//*Label 18811*/ GIMT_Encode4(1312112), // Rule ID 9747 //
     /* 1312033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1312050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1312053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312086 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312111 */     // GIR_Coverage, 9747,
     /* 1312111 */     GIR_EraseRootFromParent_Done,
     /* 1312112 */   // Label 18811: @1312112
     /* 1312112 */   GIM_Try, /*On fail goto*//*Label 18812*/ GIMT_Encode4(1312196), // Rule ID 9750 //
     /* 1312117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1312134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1312137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312170 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1312173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312195 */     // GIR_Coverage, 9750,
     /* 1312195 */     GIR_EraseRootFromParent_Done,
     /* 1312196 */   // Label 18812: @1312196
     /* 1312196 */   GIM_Try, /*On fail goto*//*Label 18813*/ GIMT_Encode4(1312280), // Rule ID 9751 //
     /* 1312201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1312218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1312221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312254 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1312257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312279 */     // GIR_Coverage, 9751,
     /* 1312279 */     GIR_EraseRootFromParent_Done,
     /* 1312280 */   // Label 18813: @1312280
     /* 1312280 */   GIM_Try, /*On fail goto*//*Label 18814*/ GIMT_Encode4(1312364), // Rule ID 9754 //
     /* 1312285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1312302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1312305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312338 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312363 */     // GIR_Coverage, 9754,
     /* 1312363 */     GIR_EraseRootFromParent_Done,
     /* 1312364 */   // Label 18814: @1312364
     /* 1312364 */   GIM_Try, /*On fail goto*//*Label 18815*/ GIMT_Encode4(1312448), // Rule ID 9755 //
     /* 1312369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1312386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1312389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312422 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312447 */     // GIR_Coverage, 9755,
     /* 1312447 */     GIR_EraseRootFromParent_Done,
     /* 1312448 */   // Label 18815: @1312448
     /* 1312448 */   GIM_Try, /*On fail goto*//*Label 18816*/ GIMT_Encode4(1312532), // Rule ID 9758 //
     /* 1312453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1312470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1312473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312506 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312531 */     // GIR_Coverage, 9758,
     /* 1312531 */     GIR_EraseRootFromParent_Done,
     /* 1312532 */   // Label 18816: @1312532
     /* 1312532 */   GIM_Try, /*On fail goto*//*Label 18817*/ GIMT_Encode4(1312616), // Rule ID 9759 //
     /* 1312537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1312554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1312557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312590 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312615 */     // GIR_Coverage, 9759,
     /* 1312615 */     GIR_EraseRootFromParent_Done,
     /* 1312616 */   // Label 18817: @1312616
     /* 1312616 */   GIM_Try, /*On fail goto*//*Label 18818*/ GIMT_Encode4(1312700), // Rule ID 9762 //
     /* 1312621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1312632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1312635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1312638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1312641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1312644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312674 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1312677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312699 */     // GIR_Coverage, 9762,
     /* 1312699 */     GIR_EraseRootFromParent_Done,
     /* 1312700 */   // Label 18818: @1312700
     /* 1312700 */   GIM_Try, /*On fail goto*//*Label 18819*/ GIMT_Encode4(1312784), // Rule ID 9763 //
     /* 1312705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1312716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1312719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1312722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1312725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1312728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312758 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1312761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312783 */     // GIR_Coverage, 9763,
     /* 1312783 */     GIR_EraseRootFromParent_Done,
     /* 1312784 */   // Label 18819: @1312784
     /* 1312784 */   GIM_Try, /*On fail goto*//*Label 18820*/ GIMT_Encode4(1312868), // Rule ID 9766 //
     /* 1312789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1312806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1312809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312842 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1312845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312867 */     // GIR_Coverage, 9766,
     /* 1312867 */     GIR_EraseRootFromParent_Done,
     /* 1312868 */   // Label 18820: @1312868
     /* 1312868 */   GIM_Try, /*On fail goto*//*Label 18821*/ GIMT_Encode4(1312952), // Rule ID 9767 //
     /* 1312873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1312890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1312893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312926 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1312929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312951 */     // GIR_Coverage, 9767,
     /* 1312951 */     GIR_EraseRootFromParent_Done,
     /* 1312952 */   // Label 18821: @1312952
     /* 1312952 */   GIM_Try, /*On fail goto*//*Label 18822*/ GIMT_Encode4(1313036), // Rule ID 9770 //
     /* 1312957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1312974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1312977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313010 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313035 */     // GIR_Coverage, 9770,
     /* 1313035 */     GIR_EraseRootFromParent_Done,
     /* 1313036 */   // Label 18822: @1313036
     /* 1313036 */   GIM_Try, /*On fail goto*//*Label 18823*/ GIMT_Encode4(1313120), // Rule ID 9771 //
     /* 1313041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1313052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1313055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1313058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1313061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313094 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313119 */     // GIR_Coverage, 9771,
     /* 1313119 */     GIR_EraseRootFromParent_Done,
     /* 1313120 */   // Label 18823: @1313120
     /* 1313120 */   GIM_Try, /*On fail goto*//*Label 18824*/ GIMT_Encode4(1313204), // Rule ID 9774 //
     /* 1313125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1313128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1313142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1313145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313178 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1313199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313203 */     // GIR_Coverage, 9774,
     /* 1313203 */     GIR_EraseRootFromParent_Done,
     /* 1313204 */   // Label 18824: @1313204
     /* 1313204 */   GIM_Try, /*On fail goto*//*Label 18825*/ GIMT_Encode4(1313288), // Rule ID 9775 //
     /* 1313209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1313212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1313226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1313229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313262 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1313283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313287 */     // GIR_Coverage, 9775,
     /* 1313287 */     GIR_EraseRootFromParent_Done,
     /* 1313288 */   // Label 18825: @1313288
     /* 1313288 */   GIM_Try, /*On fail goto*//*Label 18826*/ GIMT_Encode4(1313372), // Rule ID 9778 //
     /* 1313293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1313304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1313307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1313310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1313313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1313316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313346 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1313349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313371 */     // GIR_Coverage, 9778,
     /* 1313371 */     GIR_EraseRootFromParent_Done,
     /* 1313372 */   // Label 18826: @1313372
     /* 1313372 */   GIM_Try, /*On fail goto*//*Label 18827*/ GIMT_Encode4(1313456), // Rule ID 9779 //
     /* 1313377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1313388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1313391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1313394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1313397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1313400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313430 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1313433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313455 */     // GIR_Coverage, 9779,
     /* 1313455 */     GIR_EraseRootFromParent_Done,
     /* 1313456 */   // Label 18827: @1313456
     /* 1313456 */   GIM_Try, /*On fail goto*//*Label 18828*/ GIMT_Encode4(1313540), // Rule ID 9782 //
     /* 1313461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1313472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1313475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1313478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1313481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1313484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313514 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1313517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313539 */     // GIR_Coverage, 9782,
     /* 1313539 */     GIR_EraseRootFromParent_Done,
     /* 1313540 */   // Label 18828: @1313540
     /* 1313540 */   GIM_Try, /*On fail goto*//*Label 18829*/ GIMT_Encode4(1313624), // Rule ID 9783 //
     /* 1313545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1313556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1313559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1313562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1313565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1313568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313598 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1313601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313623 */     // GIR_Coverage, 9783,
     /* 1313623 */     GIR_EraseRootFromParent_Done,
     /* 1313624 */   // Label 18829: @1313624
     /* 1313624 */   GIM_Try, /*On fail goto*//*Label 18830*/ GIMT_Encode4(1313708), // Rule ID 9786 //
     /* 1313629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1313640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1313643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1313646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1313649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1313652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313682 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1313685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313707 */     // GIR_Coverage, 9786,
     /* 1313707 */     GIR_EraseRootFromParent_Done,
     /* 1313708 */   // Label 18830: @1313708
     /* 1313708 */   GIM_Try, /*On fail goto*//*Label 18831*/ GIMT_Encode4(1313792), // Rule ID 9787 //
     /* 1313713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1313724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1313727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1313730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1313733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1313736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313766 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1313769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313791 */     // GIR_Coverage, 9787,
     /* 1313791 */     GIR_EraseRootFromParent_Done,
     /* 1313792 */   // Label 18831: @1313792
     /* 1313792 */   GIM_Try, /*On fail goto*//*Label 18832*/ GIMT_Encode4(1313876), // Rule ID 9790 //
     /* 1313797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1313808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1313811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1313814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1313817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1313820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313850 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1313853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313875 */     // GIR_Coverage, 9790,
     /* 1313875 */     GIR_EraseRootFromParent_Done,
     /* 1313876 */   // Label 18832: @1313876
     /* 1313876 */   GIM_Try, /*On fail goto*//*Label 18833*/ GIMT_Encode4(1313960), // Rule ID 9791 //
     /* 1313881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1313892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1313895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1313898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1313901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1313904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313934 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1313937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313959 */     // GIR_Coverage, 9791,
     /* 1313959 */     GIR_EraseRootFromParent_Done,
     /* 1313960 */   // Label 18833: @1313960
     /* 1313960 */   GIM_Try, /*On fail goto*//*Label 18834*/ GIMT_Encode4(1314044), // Rule ID 9794 //
     /* 1313965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1313976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1313979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1313982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1313985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1313988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314018 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314043 */     // GIR_Coverage, 9794,
     /* 1314043 */     GIR_EraseRootFromParent_Done,
     /* 1314044 */   // Label 18834: @1314044
     /* 1314044 */   GIM_Try, /*On fail goto*//*Label 18835*/ GIMT_Encode4(1314128), // Rule ID 9795 //
     /* 1314049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1314066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1314069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314102 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314127 */     // GIR_Coverage, 9795,
     /* 1314127 */     GIR_EraseRootFromParent_Done,
     /* 1314128 */   // Label 18835: @1314128
     /* 1314128 */   GIM_Try, /*On fail goto*//*Label 18836*/ GIMT_Encode4(1314212), // Rule ID 9798 //
     /* 1314133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1314144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1314147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1314153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314186 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314211 */     // GIR_Coverage, 9798,
     /* 1314211 */     GIR_EraseRootFromParent_Done,
     /* 1314212 */   // Label 18836: @1314212
     /* 1314212 */   GIM_Try, /*On fail goto*//*Label 18837*/ GIMT_Encode4(1314296), // Rule ID 9799 //
     /* 1314217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1314228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1314231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1314237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314270 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314295 */     // GIR_Coverage, 9799,
     /* 1314295 */     GIR_EraseRootFromParent_Done,
     /* 1314296 */   // Label 18837: @1314296
     /* 1314296 */   GIM_Try, /*On fail goto*//*Label 18838*/ GIMT_Encode4(1314380), // Rule ID 9802 //
     /* 1314301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1314318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1314321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314354 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314379 */     // GIR_Coverage, 9802,
     /* 1314379 */     GIR_EraseRootFromParent_Done,
     /* 1314380 */   // Label 18838: @1314380
     /* 1314380 */   GIM_Try, /*On fail goto*//*Label 18839*/ GIMT_Encode4(1314464), // Rule ID 9803 //
     /* 1314385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1314402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1314405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314438 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314463 */     // GIR_Coverage, 9803,
     /* 1314463 */     GIR_EraseRootFromParent_Done,
     /* 1314464 */   // Label 18839: @1314464
     /* 1314464 */   GIM_Try, /*On fail goto*//*Label 18840*/ GIMT_Encode4(1314548), // Rule ID 9806 //
     /* 1314469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1314486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1314489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314522 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314547 */     // GIR_Coverage, 9806,
     /* 1314547 */     GIR_EraseRootFromParent_Done,
     /* 1314548 */   // Label 18840: @1314548
     /* 1314548 */   GIM_Try, /*On fail goto*//*Label 18841*/ GIMT_Encode4(1314632), // Rule ID 9807 //
     /* 1314553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1314570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1314573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314606 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314631 */     // GIR_Coverage, 9807,
     /* 1314631 */     GIR_EraseRootFromParent_Done,
     /* 1314632 */   // Label 18841: @1314632
     /* 1314632 */   GIM_Try, /*On fail goto*//*Label 18842*/ GIMT_Encode4(1314716), // Rule ID 9810 //
     /* 1314637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1314654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1314657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314690 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314715 */     // GIR_Coverage, 9810,
     /* 1314715 */     GIR_EraseRootFromParent_Done,
     /* 1314716 */   // Label 18842: @1314716
     /* 1314716 */   GIM_Try, /*On fail goto*//*Label 18843*/ GIMT_Encode4(1314800), // Rule ID 9811 //
     /* 1314721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1314738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1314741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314774 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314799 */     // GIR_Coverage, 9811,
     /* 1314799 */     GIR_EraseRootFromParent_Done,
     /* 1314800 */   // Label 18843: @1314800
     /* 1314800 */   GIM_Try, /*On fail goto*//*Label 18844*/ GIMT_Encode4(1314884), // Rule ID 9814 //
     /* 1314805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1314808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1314816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1314819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1314822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1314825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1314828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314858 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1314879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314883 */     // GIR_Coverage, 9814,
     /* 1314883 */     GIR_EraseRootFromParent_Done,
     /* 1314884 */   // Label 18844: @1314884
     /* 1314884 */   GIM_Try, /*On fail goto*//*Label 18845*/ GIMT_Encode4(1314968), // Rule ID 9815 //
     /* 1314889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1314892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1314900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1314903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1314906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1314909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1314912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314942 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1314963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314967 */     // GIR_Coverage, 9815,
     /* 1314967 */     GIR_EraseRootFromParent_Done,
     /* 1314968 */   // Label 18845: @1314968
     /* 1314968 */   GIM_Try, /*On fail goto*//*Label 18846*/ GIMT_Encode4(1315052), // Rule ID 9818 //
     /* 1314973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1314976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1314990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1314993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315026 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1315029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315051 */     // GIR_Coverage, 9818,
     /* 1315051 */     GIR_EraseRootFromParent_Done,
     /* 1315052 */   // Label 18846: @1315052
     /* 1315052 */   GIM_Try, /*On fail goto*//*Label 18847*/ GIMT_Encode4(1315136), // Rule ID 9819 //
     /* 1315057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1315074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1315077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315110 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1315113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315135 */     // GIR_Coverage, 9819,
     /* 1315135 */     GIR_EraseRootFromParent_Done,
     /* 1315136 */   // Label 18847: @1315136
     /* 1315136 */   GIM_Try, /*On fail goto*//*Label 18848*/ GIMT_Encode4(1315220), // Rule ID 9822 //
     /* 1315141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1315144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1315158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1315161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315194 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1315197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315219 */     // GIR_Coverage, 9822,
     /* 1315219 */     GIR_EraseRootFromParent_Done,
     /* 1315220 */   // Label 18848: @1315220
     /* 1315220 */   GIM_Try, /*On fail goto*//*Label 18849*/ GIMT_Encode4(1315304), // Rule ID 9823 //
     /* 1315225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1315242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1315245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315278 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1315281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315303 */     // GIR_Coverage, 9823,
     /* 1315303 */     GIR_EraseRootFromParent_Done,
     /* 1315304 */   // Label 18849: @1315304
     /* 1315304 */   GIM_Try, /*On fail goto*//*Label 18850*/ GIMT_Encode4(1315388), // Rule ID 9826 //
     /* 1315309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1315326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1315329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315362 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1315365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315387 */     // GIR_Coverage, 9826,
     /* 1315387 */     GIR_EraseRootFromParent_Done,
     /* 1315388 */   // Label 18850: @1315388
     /* 1315388 */   GIM_Try, /*On fail goto*//*Label 18851*/ GIMT_Encode4(1315472), // Rule ID 9827 //
     /* 1315393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1315410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1315413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315446 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1315449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315471 */     // GIR_Coverage, 9827,
     /* 1315471 */     GIR_EraseRootFromParent_Done,
     /* 1315472 */   // Label 18851: @1315472
     /* 1315472 */   GIM_Try, /*On fail goto*//*Label 18852*/ GIMT_Encode4(1315556), // Rule ID 9830 //
     /* 1315477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1315494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1315497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315530 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1315533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315555 */     // GIR_Coverage, 9830,
     /* 1315555 */     GIR_EraseRootFromParent_Done,
     /* 1315556 */   // Label 18852: @1315556
     /* 1315556 */   GIM_Try, /*On fail goto*//*Label 18853*/ GIMT_Encode4(1315640), // Rule ID 9831 //
     /* 1315561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1315578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1315581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315614 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1315617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315639 */     // GIR_Coverage, 9831,
     /* 1315639 */     GIR_EraseRootFromParent_Done,
     /* 1315640 */   // Label 18853: @1315640
     /* 1315640 */   GIM_Try, /*On fail goto*//*Label 18854*/ GIMT_Encode4(1315724), // Rule ID 9834 //
     /* 1315645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1315662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1315665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315698 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1315701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315723 */     // GIR_Coverage, 9834,
     /* 1315723 */     GIR_EraseRootFromParent_Done,
     /* 1315724 */   // Label 18854: @1315724
     /* 1315724 */   GIM_Try, /*On fail goto*//*Label 18855*/ GIMT_Encode4(1315808), // Rule ID 9835 //
     /* 1315729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1315746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1315749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315782 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1315785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315807 */     // GIR_Coverage, 9835,
     /* 1315807 */     GIR_EraseRootFromParent_Done,
     /* 1315808 */   // Label 18855: @1315808
     /* 1315808 */   GIM_Try, /*On fail goto*//*Label 18856*/ GIMT_Encode4(1315892), // Rule ID 9838 //
     /* 1315813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1315830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1315833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315866 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1315869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315891 */     // GIR_Coverage, 9838,
     /* 1315891 */     GIR_EraseRootFromParent_Done,
     /* 1315892 */   // Label 18856: @1315892
     /* 1315892 */   GIM_Try, /*On fail goto*//*Label 18857*/ GIMT_Encode4(1315976), // Rule ID 9839 //
     /* 1315897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1315914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1315917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315950 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1315953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315975 */     // GIR_Coverage, 9839,
     /* 1315975 */     GIR_EraseRootFromParent_Done,
     /* 1315976 */   // Label 18857: @1315976
     /* 1315976 */   GIM_Try, /*On fail goto*//*Label 18858*/ GIMT_Encode4(1316060), // Rule ID 9842 //
     /* 1315981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1315998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1316001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316034 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316059 */     // GIR_Coverage, 9842,
     /* 1316059 */     GIR_EraseRootFromParent_Done,
     /* 1316060 */   // Label 18858: @1316060
     /* 1316060 */   GIM_Try, /*On fail goto*//*Label 18859*/ GIMT_Encode4(1316144), // Rule ID 9843 //
     /* 1316065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1316082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1316085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316118 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316143 */     // GIR_Coverage, 9843,
     /* 1316143 */     GIR_EraseRootFromParent_Done,
     /* 1316144 */   // Label 18859: @1316144
     /* 1316144 */   GIM_Try, /*On fail goto*//*Label 18860*/ GIMT_Encode4(1316228), // Rule ID 9846 //
     /* 1316149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1316166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1316169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316202 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316227 */     // GIR_Coverage, 9846,
     /* 1316227 */     GIR_EraseRootFromParent_Done,
     /* 1316228 */   // Label 18860: @1316228
     /* 1316228 */   GIM_Try, /*On fail goto*//*Label 18861*/ GIMT_Encode4(1316312), // Rule ID 9847 //
     /* 1316233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1316250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1316253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316286 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316311 */     // GIR_Coverage, 9847,
     /* 1316311 */     GIR_EraseRootFromParent_Done,
     /* 1316312 */   // Label 18861: @1316312
     /* 1316312 */   GIM_Try, /*On fail goto*//*Label 18862*/ GIMT_Encode4(1316396), // Rule ID 9850 //
     /* 1316317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1316328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1316331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1316334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1316337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316370 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316395 */     // GIR_Coverage, 9850,
     /* 1316395 */     GIR_EraseRootFromParent_Done,
     /* 1316396 */   // Label 18862: @1316396
     /* 1316396 */   GIM_Try, /*On fail goto*//*Label 18863*/ GIMT_Encode4(1316480), // Rule ID 9851 //
     /* 1316401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1316412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1316415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1316418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1316421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316454 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316479 */     // GIR_Coverage, 9851,
     /* 1316479 */     GIR_EraseRootFromParent_Done,
     /* 1316480 */   // Label 18863: @1316480
     /* 1316480 */   GIM_Try, /*On fail goto*//*Label 18864*/ GIMT_Encode4(1316564), // Rule ID 9854 //
     /* 1316485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1316502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1316505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316538 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316563 */     // GIR_Coverage, 9854,
     /* 1316563 */     GIR_EraseRootFromParent_Done,
     /* 1316564 */   // Label 18864: @1316564
     /* 1316564 */   GIM_Try, /*On fail goto*//*Label 18865*/ GIMT_Encode4(1316648), // Rule ID 9855 //
     /* 1316569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1316586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1316589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316622 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316647 */     // GIR_Coverage, 9855,
     /* 1316647 */     GIR_EraseRootFromParent_Done,
     /* 1316648 */   // Label 18865: @1316648
     /* 1316648 */   GIM_Try, /*On fail goto*//*Label 18866*/ GIMT_Encode4(1316732), // Rule ID 9858 //
     /* 1316653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1316670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1316673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316706 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316731 */     // GIR_Coverage, 9858,
     /* 1316731 */     GIR_EraseRootFromParent_Done,
     /* 1316732 */   // Label 18866: @1316732
     /* 1316732 */   GIM_Try, /*On fail goto*//*Label 18867*/ GIMT_Encode4(1316816), // Rule ID 9859 //
     /* 1316737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1316754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1316757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316790 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316815 */     // GIR_Coverage, 9859,
     /* 1316815 */     GIR_EraseRootFromParent_Done,
     /* 1316816 */   // Label 18867: @1316816
     /* 1316816 */   GIM_Try, /*On fail goto*//*Label 18868*/ GIMT_Encode4(1316900), // Rule ID 9862 //
     /* 1316821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1316824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1316838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1316841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316874 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1316895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316899 */     // GIR_Coverage, 9862,
     /* 1316899 */     GIR_EraseRootFromParent_Done,
     /* 1316900 */   // Label 18868: @1316900
     /* 1316900 */   GIM_Try, /*On fail goto*//*Label 18869*/ GIMT_Encode4(1316984), // Rule ID 9863 //
     /* 1316905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1316908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1316922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1316925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316958 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1316979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316983 */     // GIR_Coverage, 9863,
     /* 1316983 */     GIR_EraseRootFromParent_Done,
     /* 1316984 */   // Label 18869: @1316984
     /* 1316984 */   GIM_Try, /*On fail goto*//*Label 18870*/ GIMT_Encode4(1317068), // Rule ID 9866 //
     /* 1316989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1317006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1317009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317042 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1317045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317067 */     // GIR_Coverage, 9866,
     /* 1317067 */     GIR_EraseRootFromParent_Done,
     /* 1317068 */   // Label 18870: @1317068
     /* 1317068 */   GIM_Try, /*On fail goto*//*Label 18871*/ GIMT_Encode4(1317152), // Rule ID 9867 //
     /* 1317073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1317090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1317093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317126 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1317129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317151 */     // GIR_Coverage, 9867,
     /* 1317151 */     GIR_EraseRootFromParent_Done,
     /* 1317152 */   // Label 18871: @1317152
     /* 1317152 */   GIM_Try, /*On fail goto*//*Label 18872*/ GIMT_Encode4(1317236), // Rule ID 9870 //
     /* 1317157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1317174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1317177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317210 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1317213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317235 */     // GIR_Coverage, 9870,
     /* 1317235 */     GIR_EraseRootFromParent_Done,
     /* 1317236 */   // Label 18872: @1317236
     /* 1317236 */   GIM_Try, /*On fail goto*//*Label 18873*/ GIMT_Encode4(1317320), // Rule ID 9871 //
     /* 1317241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1317258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1317261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317294 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1317297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317319 */     // GIR_Coverage, 9871,
     /* 1317319 */     GIR_EraseRootFromParent_Done,
     /* 1317320 */   // Label 18873: @1317320
     /* 1317320 */   GIM_Try, /*On fail goto*//*Label 18874*/ GIMT_Encode4(1317404), // Rule ID 9874 //
     /* 1317325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1317336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1317339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1317342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1317345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1317348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317378 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1317381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317403 */     // GIR_Coverage, 9874,
     /* 1317403 */     GIR_EraseRootFromParent_Done,
     /* 1317404 */   // Label 18874: @1317404
     /* 1317404 */   GIM_Try, /*On fail goto*//*Label 18875*/ GIMT_Encode4(1317488), // Rule ID 9875 //
     /* 1317409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1317420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1317423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1317426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1317429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1317432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317462 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1317465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317487 */     // GIR_Coverage, 9875,
     /* 1317487 */     GIR_EraseRootFromParent_Done,
     /* 1317488 */   // Label 18875: @1317488
     /* 1317488 */   GIM_Try, /*On fail goto*//*Label 18876*/ GIMT_Encode4(1317572), // Rule ID 9878 //
     /* 1317493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1317504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1317507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1317510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1317513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1317516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317546 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1317549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317571 */     // GIR_Coverage, 9878,
     /* 1317571 */     GIR_EraseRootFromParent_Done,
     /* 1317572 */   // Label 18876: @1317572
     /* 1317572 */   GIM_Try, /*On fail goto*//*Label 18877*/ GIMT_Encode4(1317656), // Rule ID 9879 //
     /* 1317577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1317588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1317591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1317594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1317597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1317600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317630 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1317633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317655 */     // GIR_Coverage, 9879,
     /* 1317655 */     GIR_EraseRootFromParent_Done,
     /* 1317656 */   // Label 18877: @1317656
     /* 1317656 */   GIM_Try, /*On fail goto*//*Label 18878*/ GIMT_Encode4(1317740), // Rule ID 9882 //
     /* 1317661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1317678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1317681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317714 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1317717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317739 */     // GIR_Coverage, 9882,
     /* 1317739 */     GIR_EraseRootFromParent_Done,
     /* 1317740 */   // Label 18878: @1317740
     /* 1317740 */   GIM_Try, /*On fail goto*//*Label 18879*/ GIMT_Encode4(1317824), // Rule ID 9883 //
     /* 1317745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1317762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1317765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317798 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1317801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317823 */     // GIR_Coverage, 9883,
     /* 1317823 */     GIR_EraseRootFromParent_Done,
     /* 1317824 */   // Label 18879: @1317824
     /* 1317824 */   GIM_Try, /*On fail goto*//*Label 18880*/ GIMT_Encode4(1317908), // Rule ID 9886 //
     /* 1317829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1317846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1317849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317882 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1317885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317907 */     // GIR_Coverage, 9886,
     /* 1317907 */     GIR_EraseRootFromParent_Done,
     /* 1317908 */   // Label 18880: @1317908
     /* 1317908 */   GIM_Try, /*On fail goto*//*Label 18881*/ GIMT_Encode4(1317992), // Rule ID 9887 //
     /* 1317913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1317930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1317933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317966 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1317969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317991 */     // GIR_Coverage, 9887,
     /* 1317991 */     GIR_EraseRootFromParent_Done,
     /* 1317992 */   // Label 18881: @1317992
     /* 1317992 */   GIM_Try, /*On fail goto*//*Label 18882*/ GIMT_Encode4(1318076), // Rule ID 9890 //
     /* 1317997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1318014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1318017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318050 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318075 */     // GIR_Coverage, 9890,
     /* 1318075 */     GIR_EraseRootFromParent_Done,
     /* 1318076 */   // Label 18882: @1318076
     /* 1318076 */   GIM_Try, /*On fail goto*//*Label 18883*/ GIMT_Encode4(1318160), // Rule ID 9891 //
     /* 1318081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1318098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1318101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318134 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318159 */     // GIR_Coverage, 9891,
     /* 1318159 */     GIR_EraseRootFromParent_Done,
     /* 1318160 */   // Label 18883: @1318160
     /* 1318160 */   GIM_Try, /*On fail goto*//*Label 18884*/ GIMT_Encode4(1318244), // Rule ID 9894 //
     /* 1318165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1318182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1318185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318218 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318243 */     // GIR_Coverage, 9894,
     /* 1318243 */     GIR_EraseRootFromParent_Done,
     /* 1318244 */   // Label 18884: @1318244
     /* 1318244 */   GIM_Try, /*On fail goto*//*Label 18885*/ GIMT_Encode4(1318328), // Rule ID 9895 //
     /* 1318249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1318266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1318269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318302 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318327 */     // GIR_Coverage, 9895,
     /* 1318327 */     GIR_EraseRootFromParent_Done,
     /* 1318328 */   // Label 18885: @1318328
     /* 1318328 */   GIM_Try, /*On fail goto*//*Label 18886*/ GIMT_Encode4(1318412), // Rule ID 9898 //
     /* 1318333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1318350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1318353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318386 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318411 */     // GIR_Coverage, 9898,
     /* 1318411 */     GIR_EraseRootFromParent_Done,
     /* 1318412 */   // Label 18886: @1318412
     /* 1318412 */   GIM_Try, /*On fail goto*//*Label 18887*/ GIMT_Encode4(1318496), // Rule ID 9899 //
     /* 1318417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1318434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1318437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318470 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318495 */     // GIR_Coverage, 9899,
     /* 1318495 */     GIR_EraseRootFromParent_Done,
     /* 1318496 */   // Label 18887: @1318496
     /* 1318496 */   GIM_Try, /*On fail goto*//*Label 18888*/ GIMT_Encode4(1318580), // Rule ID 9902 //
     /* 1318501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1318504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1318512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1318515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1318518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1318521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1318524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318554 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318579 */     // GIR_Coverage, 9902,
     /* 1318579 */     GIR_EraseRootFromParent_Done,
     /* 1318580 */   // Label 18888: @1318580
     /* 1318580 */   GIM_Try, /*On fail goto*//*Label 18889*/ GIMT_Encode4(1318664), // Rule ID 9903 //
     /* 1318585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1318588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1318596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1318599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1318602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1318605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1318608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318638 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318663 */     // GIR_Coverage, 9903,
     /* 1318663 */     GIR_EraseRootFromParent_Done,
     /* 1318664 */   // Label 18889: @1318664
     /* 1318664 */   GIM_Try, /*On fail goto*//*Label 18890*/ GIMT_Encode4(1318748), // Rule ID 9906 //
     /* 1318669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1318672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1318686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1318689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318722 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318747 */     // GIR_Coverage, 9906,
     /* 1318747 */     GIR_EraseRootFromParent_Done,
     /* 1318748 */   // Label 18890: @1318748
     /* 1318748 */   GIM_Try, /*On fail goto*//*Label 18891*/ GIMT_Encode4(1318832), // Rule ID 9907 //
     /* 1318753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1318756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1318770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1318773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318806 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318831 */     // GIR_Coverage, 9907,
     /* 1318831 */     GIR_EraseRootFromParent_Done,
     /* 1318832 */   // Label 18891: @1318832
     /* 1318832 */   GIM_Try, /*On fail goto*//*Label 18892*/ GIMT_Encode4(1318916), // Rule ID 9910 //
     /* 1318837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1318840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1318854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1318857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318890 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318915 */     // GIR_Coverage, 9910,
     /* 1318915 */     GIR_EraseRootFromParent_Done,
     /* 1318916 */   // Label 18892: @1318916
     /* 1318916 */   GIM_Try, /*On fail goto*//*Label 18893*/ GIMT_Encode4(1319000), // Rule ID 9911 //
     /* 1318921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1318924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1318938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1318941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318974 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318999 */     // GIR_Coverage, 9911,
     /* 1318999 */     GIR_EraseRootFromParent_Done,
     /* 1319000 */   // Label 18893: @1319000
     /* 1319000 */   GIM_Try, /*On fail goto*//*Label 18894*/ GIMT_Encode4(1319081), // Rule ID 13852 //
     /* 1319005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1319016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1319019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1319022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1319025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319058 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1319058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1319061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319080 */     // GIR_Coverage, 13852,
     /* 1319080 */     GIR_EraseRootFromParent_Done,
     /* 1319081 */   // Label 18894: @1319081
     /* 1319081 */   GIM_Try, /*On fail goto*//*Label 18895*/ GIMT_Encode4(1319162), // Rule ID 13853 //
     /* 1319086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1319097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1319100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1319103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1319106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319139 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1319139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1319142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319161 */     // GIR_Coverage, 13853,
     /* 1319161 */     GIR_EraseRootFromParent_Done,
     /* 1319162 */   // Label 18895: @1319162
     /* 1319162 */   GIM_Try, /*On fail goto*//*Label 18896*/ GIMT_Encode4(1319243), // Rule ID 13854 //
     /* 1319167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1319178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1319181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1319184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1319187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319220 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1319220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1319223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319242 */     // GIR_Coverage, 13854,
     /* 1319242 */     GIR_EraseRootFromParent_Done,
     /* 1319243 */   // Label 18896: @1319243
     /* 1319243 */   GIM_Try, /*On fail goto*//*Label 18897*/ GIMT_Encode4(1319324), // Rule ID 13855 //
     /* 1319248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1319259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1319262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1319265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1319268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319301 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1319301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1319304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319323 */     // GIR_Coverage, 13855,
     /* 1319323 */     GIR_EraseRootFromParent_Done,
     /* 1319324 */   // Label 18897: @1319324
     /* 1319324 */   GIM_Try, /*On fail goto*//*Label 18898*/ GIMT_Encode4(1319405), // Rule ID 13856 //
     /* 1319329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1319340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1319343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1319346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1319349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319382 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1319382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319404 */     // GIR_Coverage, 13856,
     /* 1319404 */     GIR_EraseRootFromParent_Done,
     /* 1319405 */   // Label 18898: @1319405
     /* 1319405 */   GIM_Try, /*On fail goto*//*Label 18899*/ GIMT_Encode4(1319486), // Rule ID 13857 //
     /* 1319410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1319421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1319424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1319427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1319430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319463 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1319463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319485 */     // GIR_Coverage, 13857,
     /* 1319485 */     GIR_EraseRootFromParent_Done,
     /* 1319486 */   // Label 18899: @1319486
     /* 1319486 */   GIM_Try, /*On fail goto*//*Label 18900*/ GIMT_Encode4(1319567), // Rule ID 13858 //
     /* 1319491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1319502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1319505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1319508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1319511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319544 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1319544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1319547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319566 */     // GIR_Coverage, 13858,
     /* 1319566 */     GIR_EraseRootFromParent_Done,
     /* 1319567 */   // Label 18900: @1319567
     /* 1319567 */   GIM_Try, /*On fail goto*//*Label 18901*/ GIMT_Encode4(1319648), // Rule ID 13859 //
     /* 1319572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1319583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1319586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1319589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1319592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319625 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1319625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1319628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319647 */     // GIR_Coverage, 13859,
     /* 1319647 */     GIR_EraseRootFromParent_Done,
     /* 1319648 */   // Label 18901: @1319648
     /* 1319648 */   GIM_Try, /*On fail goto*//*Label 18902*/ GIMT_Encode4(1319729), // Rule ID 13860 //
     /* 1319653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1319664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1319667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1319670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1319673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1319706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319728 */     // GIR_Coverage, 13860,
     /* 1319728 */     GIR_EraseRootFromParent_Done,
     /* 1319729 */   // Label 18902: @1319729
     /* 1319729 */   GIM_Try, /*On fail goto*//*Label 18903*/ GIMT_Encode4(1319810), // Rule ID 13861 //
     /* 1319734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1319745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1319748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1319751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1319754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319787 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1319787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319809 */     // GIR_Coverage, 13861,
     /* 1319809 */     GIR_EraseRootFromParent_Done,
     /* 1319810 */   // Label 18903: @1319810
     /* 1319810 */   GIM_Try, /*On fail goto*//*Label 18904*/ GIMT_Encode4(1319891), // Rule ID 13862 //
     /* 1319815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1319826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1319829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1319832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1319835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1319868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319890 */     // GIR_Coverage, 13862,
     /* 1319890 */     GIR_EraseRootFromParent_Done,
     /* 1319891 */   // Label 18904: @1319891
     /* 1319891 */   GIM_Try, /*On fail goto*//*Label 18905*/ GIMT_Encode4(1319972), // Rule ID 13863 //
     /* 1319896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1319907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1319910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1319913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1319916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319949 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1319949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319971 */     // GIR_Coverage, 13863,
     /* 1319971 */     GIR_EraseRootFromParent_Done,
     /* 1319972 */   // Label 18905: @1319972
     /* 1319972 */   GIM_Try, /*On fail goto*//*Label 18906*/ GIMT_Encode4(1320053), // Rule ID 13864 //
     /* 1319977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1319988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1319991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1319994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1319997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320030 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1320030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320052 */     // GIR_Coverage, 13864,
     /* 1320052 */     GIR_EraseRootFromParent_Done,
     /* 1320053 */   // Label 18906: @1320053
     /* 1320053 */   GIM_Try, /*On fail goto*//*Label 18907*/ GIMT_Encode4(1320134), // Rule ID 13865 //
     /* 1320058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1320069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1320072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1320075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1320078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320111 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1320111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320133 */     // GIR_Coverage, 13865,
     /* 1320133 */     GIR_EraseRootFromParent_Done,
     /* 1320134 */   // Label 18907: @1320134
     /* 1320134 */   GIM_Try, /*On fail goto*//*Label 18908*/ GIMT_Encode4(1320215), // Rule ID 13866 //
     /* 1320139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1320150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1320153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1320159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320192 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1320192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320214 */     // GIR_Coverage, 13866,
     /* 1320214 */     GIR_EraseRootFromParent_Done,
     /* 1320215 */   // Label 18908: @1320215
     /* 1320215 */   GIM_Try, /*On fail goto*//*Label 18909*/ GIMT_Encode4(1320296), // Rule ID 13867 //
     /* 1320220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1320231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1320234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1320240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320273 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1320273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320295 */     // GIR_Coverage, 13867,
     /* 1320295 */     GIR_EraseRootFromParent_Done,
     /* 1320296 */   // Label 18909: @1320296
     /* 1320296 */   GIM_Try, /*On fail goto*//*Label 18910*/ GIMT_Encode4(1320377), // Rule ID 13868 //
     /* 1320301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1320312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1320315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1320321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1320354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320376 */     // GIR_Coverage, 13868,
     /* 1320376 */     GIR_EraseRootFromParent_Done,
     /* 1320377 */   // Label 18910: @1320377
     /* 1320377 */   GIM_Try, /*On fail goto*//*Label 18911*/ GIMT_Encode4(1320458), // Rule ID 13869 //
     /* 1320382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1320393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1320396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1320402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320435 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1320435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320457 */     // GIR_Coverage, 13869,
     /* 1320457 */     GIR_EraseRootFromParent_Done,
     /* 1320458 */   // Label 18911: @1320458
     /* 1320458 */   GIM_Try, /*On fail goto*//*Label 18912*/ GIMT_Encode4(1320539), // Rule ID 13870 //
     /* 1320463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1320466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1320474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1320477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1320480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1320483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320516 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1320516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320538 */     // GIR_Coverage, 13870,
     /* 1320538 */     GIR_EraseRootFromParent_Done,
     /* 1320539 */   // Label 18912: @1320539
     /* 1320539 */   GIM_Try, /*On fail goto*//*Label 18913*/ GIMT_Encode4(1320620), // Rule ID 13871 //
     /* 1320544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1320547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1320555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1320558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1320561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1320564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320597 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1320597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320619 */     // GIR_Coverage, 13871,
     /* 1320619 */     GIR_EraseRootFromParent_Done,
     /* 1320620 */   // Label 18913: @1320620
     /* 1320620 */   GIM_Try, /*On fail goto*//*Label 18914*/ GIMT_Encode4(1320701), // Rule ID 13872 //
     /* 1320625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1320636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1320639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1320642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1320645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1320648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1320655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320678 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1320678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1320681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320700 */     // GIR_Coverage, 13872,
     /* 1320700 */     GIR_EraseRootFromParent_Done,
     /* 1320701 */   // Label 18914: @1320701
     /* 1320701 */   GIM_Try, /*On fail goto*//*Label 18915*/ GIMT_Encode4(1320782), // Rule ID 13873 //
     /* 1320706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1320717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1320720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1320723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1320726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1320729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1320736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320759 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1320759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1320762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320781 */     // GIR_Coverage, 13873,
     /* 1320781 */     GIR_EraseRootFromParent_Done,
     /* 1320782 */   // Label 18915: @1320782
     /* 1320782 */   GIM_Try, /*On fail goto*//*Label 18916*/ GIMT_Encode4(1320863), // Rule ID 13874 //
     /* 1320787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1320798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1320801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1320804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1320807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1320810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1320817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320840 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1320840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1320843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320862 */     // GIR_Coverage, 13874,
     /* 1320862 */     GIR_EraseRootFromParent_Done,
     /* 1320863 */   // Label 18916: @1320863
     /* 1320863 */   GIM_Try, /*On fail goto*//*Label 18917*/ GIMT_Encode4(1320944), // Rule ID 13875 //
     /* 1320868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1320879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1320882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1320885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1320888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1320891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1320898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1320921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1320924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320943 */     // GIR_Coverage, 13875,
     /* 1320943 */     GIR_EraseRootFromParent_Done,
     /* 1320944 */   // Label 18917: @1320944
     /* 1320944 */   GIM_Try, /*On fail goto*//*Label 18918*/ GIMT_Encode4(1321025), // Rule ID 13876 //
     /* 1320949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1320960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1320963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1320966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1320969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1320972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1320979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321002 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1321002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321024 */     // GIR_Coverage, 13876,
     /* 1321024 */     GIR_EraseRootFromParent_Done,
     /* 1321025 */   // Label 18918: @1321025
     /* 1321025 */   GIM_Try, /*On fail goto*//*Label 18919*/ GIMT_Encode4(1321106), // Rule ID 13877 //
     /* 1321030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1321041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1321044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1321047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1321050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1321053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321083 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1321083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321105 */     // GIR_Coverage, 13877,
     /* 1321105 */     GIR_EraseRootFromParent_Done,
     /* 1321106 */   // Label 18919: @1321106
     /* 1321106 */   GIM_Try, /*On fail goto*//*Label 18920*/ GIMT_Encode4(1321187), // Rule ID 13878 //
     /* 1321111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1321122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1321125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1321128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1321131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321164 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321186 */     // GIR_Coverage, 13878,
     /* 1321186 */     GIR_EraseRootFromParent_Done,
     /* 1321187 */   // Label 18920: @1321187
     /* 1321187 */   GIM_Try, /*On fail goto*//*Label 18921*/ GIMT_Encode4(1321268), // Rule ID 13879 //
     /* 1321192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1321203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1321206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1321209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1321212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1321245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321267 */     // GIR_Coverage, 13879,
     /* 1321267 */     GIR_EraseRootFromParent_Done,
     /* 1321268 */   // Label 18921: @1321268
     /* 1321268 */   GIM_Try, /*On fail goto*//*Label 18922*/ GIMT_Encode4(1321349), // Rule ID 13880 //
     /* 1321273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1321284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1321287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1321290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1321293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321326 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321348 */     // GIR_Coverage, 13880,
     /* 1321348 */     GIR_EraseRootFromParent_Done,
     /* 1321349 */   // Label 18922: @1321349
     /* 1321349 */   GIM_Try, /*On fail goto*//*Label 18923*/ GIMT_Encode4(1321430), // Rule ID 13881 //
     /* 1321354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1321365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1321368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1321371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1321374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321407 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1321407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321429 */     // GIR_Coverage, 13881,
     /* 1321429 */     GIR_EraseRootFromParent_Done,
     /* 1321430 */   // Label 18923: @1321430
     /* 1321430 */   GIM_Try, /*On fail goto*//*Label 18924*/ GIMT_Encode4(1321511), // Rule ID 13882 //
     /* 1321435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1321446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1321449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1321452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1321455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321488 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321510 */     // GIR_Coverage, 13882,
     /* 1321510 */     GIR_EraseRootFromParent_Done,
     /* 1321511 */   // Label 18924: @1321511
     /* 1321511 */   GIM_Try, /*On fail goto*//*Label 18925*/ GIMT_Encode4(1321592), // Rule ID 13883 //
     /* 1321516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1321527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1321530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1321533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1321536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321569 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1321569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321591 */     // GIR_Coverage, 13883,
     /* 1321591 */     GIR_EraseRootFromParent_Done,
     /* 1321592 */   // Label 18925: @1321592
     /* 1321592 */   GIM_Try, /*On fail goto*//*Label 18926*/ GIMT_Encode4(1321673), // Rule ID 13884 //
     /* 1321597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1321608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1321611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1321614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1321617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1321620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1321650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321672 */     // GIR_Coverage, 13884,
     /* 1321672 */     GIR_EraseRootFromParent_Done,
     /* 1321673 */   // Label 18926: @1321673
     /* 1321673 */   GIM_Try, /*On fail goto*//*Label 18927*/ GIMT_Encode4(1321754), // Rule ID 13885 //
     /* 1321678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1321689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1321692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1321695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1321698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1321701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321731 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1321731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321753 */     // GIR_Coverage, 13885,
     /* 1321753 */     GIR_EraseRootFromParent_Done,
     /* 1321754 */   // Label 18927: @1321754
     /* 1321754 */   GIM_Try, /*On fail goto*//*Label 18928*/ GIMT_Encode4(1321835), // Rule ID 13886 //
     /* 1321759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1321770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1321773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1321776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1321779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321812 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1321812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321834 */     // GIR_Coverage, 13886,
     /* 1321834 */     GIR_EraseRootFromParent_Done,
     /* 1321835 */   // Label 18928: @1321835
     /* 1321835 */   GIM_Try, /*On fail goto*//*Label 18929*/ GIMT_Encode4(1321916), // Rule ID 13887 //
     /* 1321840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1321851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1321854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1321857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1321860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321893 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1321893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321915 */     // GIR_Coverage, 13887,
     /* 1321915 */     GIR_EraseRootFromParent_Done,
     /* 1321916 */   // Label 18929: @1321916
     /* 1321916 */   GIM_Try, /*On fail goto*//*Label 18930*/ GIMT_Encode4(1321997), // Rule ID 13888 //
     /* 1321921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1321932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1321935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1321938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1321941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321974 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1321974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321996 */     // GIR_Coverage, 13888,
     /* 1321996 */     GIR_EraseRootFromParent_Done,
     /* 1321997 */   // Label 18930: @1321997
     /* 1321997 */   GIM_Try, /*On fail goto*//*Label 18931*/ GIMT_Encode4(1322078), // Rule ID 13889 //
     /* 1322002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1322013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1322016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1322019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1322022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1322025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322055 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1322055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322077 */     // GIR_Coverage, 13889,
     /* 1322077 */     GIR_EraseRootFromParent_Done,
     /* 1322078 */   // Label 18931: @1322078
     /* 1322078 */   GIM_Try, /*On fail goto*//*Label 18932*/ GIMT_Encode4(1322159), // Rule ID 13890 //
     /* 1322083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1322094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1322097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1322100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1322103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322136 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1322136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1322139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322158 */     // GIR_Coverage, 13890,
     /* 1322158 */     GIR_EraseRootFromParent_Done,
     /* 1322159 */   // Label 18932: @1322159
     /* 1322159 */   GIM_Try, /*On fail goto*//*Label 18933*/ GIMT_Encode4(1322240), // Rule ID 13891 //
     /* 1322164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1322175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1322178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1322181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1322184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322217 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1322217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1322220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322239 */     // GIR_Coverage, 13891,
     /* 1322239 */     GIR_EraseRootFromParent_Done,
     /* 1322240 */   // Label 18933: @1322240
     /* 1322240 */   GIM_Try, /*On fail goto*//*Label 18934*/ GIMT_Encode4(1322321), // Rule ID 13892 //
     /* 1322245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1322256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1322259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1322262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1322265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322298 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1322298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1322301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322320 */     // GIR_Coverage, 13892,
     /* 1322320 */     GIR_EraseRootFromParent_Done,
     /* 1322321 */   // Label 18934: @1322321
     /* 1322321 */   GIM_Try, /*On fail goto*//*Label 18935*/ GIMT_Encode4(1322402), // Rule ID 13893 //
     /* 1322326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1322337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1322340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1322343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1322346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322379 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1322379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1322382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322401 */     // GIR_Coverage, 13893,
     /* 1322401 */     GIR_EraseRootFromParent_Done,
     /* 1322402 */   // Label 18935: @1322402
     /* 1322402 */   GIM_Try, /*On fail goto*//*Label 18936*/ GIMT_Encode4(1322483), // Rule ID 13894 //
     /* 1322407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1322418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1322421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1322424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1322427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322460 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1322460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322482 */     // GIR_Coverage, 13894,
     /* 1322482 */     GIR_EraseRootFromParent_Done,
     /* 1322483 */   // Label 18936: @1322483
     /* 1322483 */   GIM_Try, /*On fail goto*//*Label 18937*/ GIMT_Encode4(1322564), // Rule ID 13895 //
     /* 1322488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1322499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1322502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1322505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1322508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322541 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1322541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322563 */     // GIR_Coverage, 13895,
     /* 1322563 */     GIR_EraseRootFromParent_Done,
     /* 1322564 */   // Label 18937: @1322564
     /* 1322564 */   GIM_Try, /*On fail goto*//*Label 18938*/ GIMT_Encode4(1322645), // Rule ID 13896 //
     /* 1322569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1322580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1322583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1322586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1322592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1322599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322622 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1322622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1322625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322644 */     // GIR_Coverage, 13896,
     /* 1322644 */     GIR_EraseRootFromParent_Done,
     /* 1322645 */   // Label 18938: @1322645
     /* 1322645 */   GIM_Try, /*On fail goto*//*Label 18939*/ GIMT_Encode4(1322726), // Rule ID 13897 //
     /* 1322650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1322661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1322664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1322667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1322673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1322680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322703 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1322703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1322706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322725 */     // GIR_Coverage, 13897,
     /* 1322725 */     GIR_EraseRootFromParent_Done,
     /* 1322726 */   // Label 18939: @1322726
     /* 1322726 */   GIM_Try, /*On fail goto*//*Label 18940*/ GIMT_Encode4(1322807), // Rule ID 13898 //
     /* 1322731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1322742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1322745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1322748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1322761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322784 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1322784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1322787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322806 */     // GIR_Coverage, 13898,
     /* 1322806 */     GIR_EraseRootFromParent_Done,
     /* 1322807 */   // Label 18940: @1322807
     /* 1322807 */   GIM_Try, /*On fail goto*//*Label 18941*/ GIMT_Encode4(1322888), // Rule ID 13899 //
     /* 1322812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1322823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1322826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1322829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1322842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322865 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1322865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1322868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322887 */     // GIR_Coverage, 13899,
     /* 1322887 */     GIR_EraseRootFromParent_Done,
     /* 1322888 */   // Label 18941: @1322888
     /* 1322888 */   GIM_Try, /*On fail goto*//*Label 18942*/ GIMT_Encode4(1322969), // Rule ID 13900 //
     /* 1322893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1322904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1322907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1322910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1322923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322946 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1322946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1322949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322968 */     // GIR_Coverage, 13900,
     /* 1322968 */     GIR_EraseRootFromParent_Done,
     /* 1322969 */   // Label 18942: @1322969
     /* 1322969 */   GIM_Try, /*On fail goto*//*Label 18943*/ GIMT_Encode4(1323050), // Rule ID 13901 //
     /* 1322974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1322985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1322988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1322991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323027 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1323027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323049 */     // GIR_Coverage, 13901,
     /* 1323049 */     GIR_EraseRootFromParent_Done,
     /* 1323050 */   // Label 18943: @1323050
     /* 1323050 */   GIM_Try, /*On fail goto*//*Label 18944*/ GIMT_Encode4(1323131), // Rule ID 13902 //
     /* 1323055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1323066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1323069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323108 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1323108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1323111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323130 */     // GIR_Coverage, 13902,
     /* 1323130 */     GIR_EraseRootFromParent_Done,
     /* 1323131 */   // Label 18944: @1323131
     /* 1323131 */   GIM_Try, /*On fail goto*//*Label 18945*/ GIMT_Encode4(1323212), // Rule ID 13903 //
     /* 1323136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1323147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1323150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323189 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1323189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1323192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323211 */     // GIR_Coverage, 13903,
     /* 1323211 */     GIR_EraseRootFromParent_Done,
     /* 1323212 */   // Label 18945: @1323212
     /* 1323212 */   GIM_Try, /*On fail goto*//*Label 18946*/ GIMT_Encode4(1323293), // Rule ID 13904 //
     /* 1323217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1323228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1323231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1323234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323270 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1323270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323292 */     // GIR_Coverage, 13904,
     /* 1323292 */     GIR_EraseRootFromParent_Done,
     /* 1323293 */   // Label 18946: @1323293
     /* 1323293 */   GIM_Try, /*On fail goto*//*Label 18947*/ GIMT_Encode4(1323374), // Rule ID 13905 //
     /* 1323298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1323309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1323312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1323315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323351 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1323351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323373 */     // GIR_Coverage, 13905,
     /* 1323373 */     GIR_EraseRootFromParent_Done,
     /* 1323374 */   // Label 18947: @1323374
     /* 1323374 */   GIM_Try, /*On fail goto*//*Label 18948*/ GIMT_Encode4(1323455), // Rule ID 13906 //
     /* 1323379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1323390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1323393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1323396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323432 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1323432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323454 */     // GIR_Coverage, 13906,
     /* 1323454 */     GIR_EraseRootFromParent_Done,
     /* 1323455 */   // Label 18948: @1323455
     /* 1323455 */   GIM_Try, /*On fail goto*//*Label 18949*/ GIMT_Encode4(1323536), // Rule ID 13907 //
     /* 1323460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1323471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1323474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1323477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323513 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1323513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323535 */     // GIR_Coverage, 13907,
     /* 1323535 */     GIR_EraseRootFromParent_Done,
     /* 1323536 */   // Label 18949: @1323536
     /* 1323536 */   GIM_Try, /*On fail goto*//*Label 18950*/ GIMT_Encode4(1323617), // Rule ID 13908 //
     /* 1323541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1323552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1323555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1323558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323594 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1323594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1323597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323616 */     // GIR_Coverage, 13908,
     /* 1323616 */     GIR_EraseRootFromParent_Done,
     /* 1323617 */   // Label 18950: @1323617
     /* 1323617 */   GIM_Try, /*On fail goto*//*Label 18951*/ GIMT_Encode4(1323698), // Rule ID 13909 //
     /* 1323622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1323633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1323636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1323639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323675 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1323675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1323678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323697 */     // GIR_Coverage, 13909,
     /* 1323697 */     GIR_EraseRootFromParent_Done,
     /* 1323698 */   // Label 18951: @1323698
     /* 1323698 */   GIM_Try, /*On fail goto*//*Label 18952*/ GIMT_Encode4(1323779), // Rule ID 13910 //
     /* 1323703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1323714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1323717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1323720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323756 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1323756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1323759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323778 */     // GIR_Coverage, 13910,
     /* 1323778 */     GIR_EraseRootFromParent_Done,
     /* 1323779 */   // Label 18952: @1323779
     /* 1323779 */   GIM_Try, /*On fail goto*//*Label 18953*/ GIMT_Encode4(1323860), // Rule ID 13911 //
     /* 1323784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1323795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1323798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1323801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323837 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1323837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1323840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323859 */     // GIR_Coverage, 13911,
     /* 1323859 */     GIR_EraseRootFromParent_Done,
     /* 1323860 */   // Label 18953: @1323860
     /* 1323860 */   GIM_Try, /*On fail goto*//*Label 18954*/ GIMT_Encode4(1323941), // Rule ID 13912 //
     /* 1323865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1323876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1323879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1323882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1323918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1323921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323940 */     // GIR_Coverage, 13912,
     /* 1323940 */     GIR_EraseRootFromParent_Done,
     /* 1323941 */   // Label 18954: @1323941
     /* 1323941 */   GIM_Try, /*On fail goto*//*Label 18955*/ GIMT_Encode4(1324022), // Rule ID 13913 //
     /* 1323946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1323957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1323960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1323963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323999 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1323999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324021 */     // GIR_Coverage, 13913,
     /* 1324021 */     GIR_EraseRootFromParent_Done,
     /* 1324022 */   // Label 18955: @1324022
     /* 1324022 */   GIM_Try, /*On fail goto*//*Label 18956*/ GIMT_Encode4(1324103), // Rule ID 13914 //
     /* 1324027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1324030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1324038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1324041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324080 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1324080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324102 */     // GIR_Coverage, 13914,
     /* 1324102 */     GIR_EraseRootFromParent_Done,
     /* 1324103 */   // Label 18956: @1324103
     /* 1324103 */   GIM_Try, /*On fail goto*//*Label 18957*/ GIMT_Encode4(1324184), // Rule ID 13915 //
     /* 1324108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1324111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1324119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1324122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324161 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1324161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324183 */     // GIR_Coverage, 13915,
     /* 1324183 */     GIR_EraseRootFromParent_Done,
     /* 1324184 */   // Label 18957: @1324184
     /* 1324184 */   GIM_Try, /*On fail goto*//*Label 18958*/ GIMT_Encode4(1324265), // Rule ID 13916 //
     /* 1324189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1324200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1324203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1324206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324242 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1324245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324264 */     // GIR_Coverage, 13916,
     /* 1324264 */     GIR_EraseRootFromParent_Done,
     /* 1324265 */   // Label 18958: @1324265
     /* 1324265 */   GIM_Try, /*On fail goto*//*Label 18959*/ GIMT_Encode4(1324346), // Rule ID 13917 //
     /* 1324270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1324281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1324284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1324287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324323 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1324326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324345 */     // GIR_Coverage, 13917,
     /* 1324345 */     GIR_EraseRootFromParent_Done,
     /* 1324346 */   // Label 18959: @1324346
     /* 1324346 */   GIM_Try, /*On fail goto*//*Label 18960*/ GIMT_Encode4(1324427), // Rule ID 13918 //
     /* 1324351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1324362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1324365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1324368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1324374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324404 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1324407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324426 */     // GIR_Coverage, 13918,
     /* 1324426 */     GIR_EraseRootFromParent_Done,
     /* 1324427 */   // Label 18960: @1324427
     /* 1324427 */   GIM_Try, /*On fail goto*//*Label 18961*/ GIMT_Encode4(1324508), // Rule ID 13919 //
     /* 1324432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1324443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1324446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1324449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1324455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324485 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1324488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324507 */     // GIR_Coverage, 13919,
     /* 1324507 */     GIR_EraseRootFromParent_Done,
     /* 1324508 */   // Label 18961: @1324508
     /* 1324508 */   GIM_Try, /*On fail goto*//*Label 18962*/ GIMT_Encode4(1324589), // Rule ID 13920 //
     /* 1324513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1324524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1324527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1324530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1324536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1324543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324566 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1324569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324588 */     // GIR_Coverage, 13920,
     /* 1324588 */     GIR_EraseRootFromParent_Done,
     /* 1324589 */   // Label 18962: @1324589
     /* 1324589 */   GIM_Try, /*On fail goto*//*Label 18963*/ GIMT_Encode4(1324670), // Rule ID 13921 //
     /* 1324594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1324605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1324608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1324611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1324617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1324624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324647 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1324650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324669 */     // GIR_Coverage, 13921,
     /* 1324669 */     GIR_EraseRootFromParent_Done,
     /* 1324670 */   // Label 18963: @1324670
     /* 1324670 */   GIM_Try, /*On fail goto*//*Label 18964*/ GIMT_Encode4(1324751), // Rule ID 13922 //
     /* 1324675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1324686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1324689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1324692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1324728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1324731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324750 */     // GIR_Coverage, 13922,
     /* 1324750 */     GIR_EraseRootFromParent_Done,
     /* 1324751 */   // Label 18964: @1324751
     /* 1324751 */   GIM_Try, /*On fail goto*//*Label 18965*/ GIMT_Encode4(1324832), // Rule ID 13923 //
     /* 1324756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1324767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1324770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1324773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324809 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1324809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1324812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324831 */     // GIR_Coverage, 13923,
     /* 1324831 */     GIR_EraseRootFromParent_Done,
     /* 1324832 */   // Label 18965: @1324832
     /* 1324832 */   GIM_Try, /*On fail goto*//*Label 18966*/ GIMT_Encode4(1324913), // Rule ID 13924 //
     /* 1324837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1324848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1324851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1324854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324890 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1324890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1324893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324912 */     // GIR_Coverage, 13924,
     /* 1324912 */     GIR_EraseRootFromParent_Done,
     /* 1324913 */   // Label 18966: @1324913
     /* 1324913 */   GIM_Try, /*On fail goto*//*Label 18967*/ GIMT_Encode4(1324994), // Rule ID 13925 //
     /* 1324918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1324929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1324932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1324935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324971 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1324971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1324974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324993 */     // GIR_Coverage, 13925,
     /* 1324993 */     GIR_EraseRootFromParent_Done,
     /* 1324994 */   // Label 18967: @1324994
     /* 1324994 */   GIM_Try, /*On fail goto*//*Label 18968*/ GIMT_Encode4(1325075), // Rule ID 13926 //
     /* 1324999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1325010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1325013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1325016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325052 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1325052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325074 */     // GIR_Coverage, 13926,
     /* 1325074 */     GIR_EraseRootFromParent_Done,
     /* 1325075 */   // Label 18968: @1325075
     /* 1325075 */   GIM_Try, /*On fail goto*//*Label 18969*/ GIMT_Encode4(1325156), // Rule ID 13927 //
     /* 1325080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1325091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1325094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1325097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325133 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1325133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325155 */     // GIR_Coverage, 13927,
     /* 1325155 */     GIR_EraseRootFromParent_Done,
     /* 1325156 */   // Label 18969: @1325156
     /* 1325156 */   GIM_Try, /*On fail goto*//*Label 18970*/ GIMT_Encode4(1325237), // Rule ID 13928 //
     /* 1325161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1325172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1325175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1325178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325236 */     // GIR_Coverage, 13928,
     /* 1325236 */     GIR_EraseRootFromParent_Done,
     /* 1325237 */   // Label 18970: @1325237
     /* 1325237 */   GIM_Try, /*On fail goto*//*Label 18971*/ GIMT_Encode4(1325318), // Rule ID 13929 //
     /* 1325242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1325253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1325256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1325259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325295 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1325295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325317 */     // GIR_Coverage, 13929,
     /* 1325317 */     GIR_EraseRootFromParent_Done,
     /* 1325318 */   // Label 18971: @1325318
     /* 1325318 */   GIM_Try, /*On fail goto*//*Label 18972*/ GIMT_Encode4(1325399), // Rule ID 13930 //
     /* 1325323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1325334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1325337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1325340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325376 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325398 */     // GIR_Coverage, 13930,
     /* 1325398 */     GIR_EraseRootFromParent_Done,
     /* 1325399 */   // Label 18972: @1325399
     /* 1325399 */   GIM_Try, /*On fail goto*//*Label 18973*/ GIMT_Encode4(1325480), // Rule ID 13931 //
     /* 1325404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1325415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1325418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1325421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325457 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1325457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325479 */     // GIR_Coverage, 13931,
     /* 1325479 */     GIR_EraseRootFromParent_Done,
     /* 1325480 */   // Label 18973: @1325480
     /* 1325480 */   GIM_Try, /*On fail goto*//*Label 18974*/ GIMT_Encode4(1325561), // Rule ID 13932 //
     /* 1325485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1325496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1325499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1325502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325538 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325560 */     // GIR_Coverage, 13932,
     /* 1325560 */     GIR_EraseRootFromParent_Done,
     /* 1325561 */   // Label 18974: @1325561
     /* 1325561 */   GIM_Try, /*On fail goto*//*Label 18975*/ GIMT_Encode4(1325642), // Rule ID 13933 //
     /* 1325566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1325577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1325580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1325583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325619 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1325619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325641 */     // GIR_Coverage, 13933,
     /* 1325641 */     GIR_EraseRootFromParent_Done,
     /* 1325642 */   // Label 18975: @1325642
     /* 1325642 */   GIM_Try, /*On fail goto*//*Label 18976*/ GIMT_Encode4(1325723), // Rule ID 13934 //
     /* 1325647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1325650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1325658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1325661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1325664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1325670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325700 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1325700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1325721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325722 */     // GIR_Coverage, 13934,
     /* 1325722 */     GIR_EraseRootFromParent_Done,
     /* 1325723 */   // Label 18976: @1325723
     /* 1325723 */   GIM_Try, /*On fail goto*//*Label 18977*/ GIMT_Encode4(1325804), // Rule ID 13935 //
     /* 1325728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1325731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1325739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1325742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1325745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1325751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325781 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1325781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1325802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325803 */     // GIR_Coverage, 13935,
     /* 1325803 */     GIR_EraseRootFromParent_Done,
     /* 1325804 */   // Label 18977: @1325804
     /* 1325804 */   GIM_Try, /*On fail goto*//*Label 18978*/ GIMT_Encode4(1325885), // Rule ID 13936 //
     /* 1325809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1325812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1325820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1325823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1325826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325862 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1325862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1325883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325884 */     // GIR_Coverage, 13936,
     /* 1325884 */     GIR_EraseRootFromParent_Done,
     /* 1325885 */   // Label 18978: @1325885
     /* 1325885 */   GIM_Try, /*On fail goto*//*Label 18979*/ GIMT_Encode4(1325966), // Rule ID 13937 //
     /* 1325890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1325893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1325901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1325904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1325907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325943 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1325943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1325964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325965 */     // GIR_Coverage, 13937,
     /* 1325965 */     GIR_EraseRootFromParent_Done,
     /* 1325966 */   // Label 18979: @1325966
     /* 1325966 */   GIM_Try, /*On fail goto*//*Label 18980*/ GIMT_Encode4(1326047), // Rule ID 13938 //
     /* 1325971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1325974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1325982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1325985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1325988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326024 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1326024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1326027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326046 */     // GIR_Coverage, 13938,
     /* 1326046 */     GIR_EraseRootFromParent_Done,
     /* 1326047 */   // Label 18980: @1326047
     /* 1326047 */   GIM_Try, /*On fail goto*//*Label 18981*/ GIMT_Encode4(1326128), // Rule ID 13939 //
     /* 1326052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1326055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1326063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1326066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1326069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326105 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1326105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1326108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326127 */     // GIR_Coverage, 13939,
     /* 1326127 */     GIR_EraseRootFromParent_Done,
     /* 1326128 */   // Label 18981: @1326128
     /* 1326128 */   GIM_Try, /*On fail goto*//*Label 18982*/ GIMT_Encode4(1326212), // Rule ID 19778 //
     /* 1326133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1326136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1326150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1326153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326186 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1326189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326211 */     // GIR_Coverage, 19778,
     /* 1326211 */     GIR_EraseRootFromParent_Done,
     /* 1326212 */   // Label 18982: @1326212
     /* 1326212 */   GIM_Try, /*On fail goto*//*Label 18983*/ GIMT_Encode4(1326296), // Rule ID 19779 //
     /* 1326217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1326234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1326237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326270 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1326273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326295 */     // GIR_Coverage, 19779,
     /* 1326295 */     GIR_EraseRootFromParent_Done,
     /* 1326296 */   // Label 18983: @1326296
     /* 1326296 */   GIM_Try, /*On fail goto*//*Label 18984*/ GIMT_Encode4(1326380), // Rule ID 19782 //
     /* 1326301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1326304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1326318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1326321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326354 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326379 */     // GIR_Coverage, 19782,
     /* 1326379 */     GIR_EraseRootFromParent_Done,
     /* 1326380 */   // Label 18984: @1326380
     /* 1326380 */   GIM_Try, /*On fail goto*//*Label 18985*/ GIMT_Encode4(1326464), // Rule ID 19783 //
     /* 1326385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1326402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1326405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326438 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326463 */     // GIR_Coverage, 19783,
     /* 1326463 */     GIR_EraseRootFromParent_Done,
     /* 1326464 */   // Label 18985: @1326464
     /* 1326464 */   GIM_Try, /*On fail goto*//*Label 18986*/ GIMT_Encode4(1326548), // Rule ID 19786 //
     /* 1326469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1326472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1326486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1326489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326522 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326547 */     // GIR_Coverage, 19786,
     /* 1326547 */     GIR_EraseRootFromParent_Done,
     /* 1326548 */   // Label 18986: @1326548
     /* 1326548 */   GIM_Try, /*On fail goto*//*Label 18987*/ GIMT_Encode4(1326632), // Rule ID 19787 //
     /* 1326553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1326556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1326570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1326573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326606 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326631 */     // GIR_Coverage, 19787,
     /* 1326631 */     GIR_EraseRootFromParent_Done,
     /* 1326632 */   // Label 18987: @1326632
     /* 1326632 */   GIM_Try, /*On fail goto*//*Label 18988*/ GIMT_Encode4(1326716), // Rule ID 19790 //
     /* 1326637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1326640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1326648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1326651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1326654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1326657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326690 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1326693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326715 */     // GIR_Coverage, 19790,
     /* 1326715 */     GIR_EraseRootFromParent_Done,
     /* 1326716 */   // Label 18988: @1326716
     /* 1326716 */   GIM_Try, /*On fail goto*//*Label 18989*/ GIMT_Encode4(1326800), // Rule ID 19791 //
     /* 1326721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1326732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1326735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1326738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1326741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326774 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1326777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326799 */     // GIR_Coverage, 19791,
     /* 1326799 */     GIR_EraseRootFromParent_Done,
     /* 1326800 */   // Label 18989: @1326800
     /* 1326800 */   GIM_Try, /*On fail goto*//*Label 18990*/ GIMT_Encode4(1326884), // Rule ID 19794 //
     /* 1326805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1326808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1326822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1326825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326858 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1326861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326883 */     // GIR_Coverage, 19794,
     /* 1326883 */     GIR_EraseRootFromParent_Done,
     /* 1326884 */   // Label 18990: @1326884
     /* 1326884 */   GIM_Try, /*On fail goto*//*Label 18991*/ GIMT_Encode4(1326968), // Rule ID 19795 //
     /* 1326889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1326892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1326906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1326909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326942 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1326945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326967 */     // GIR_Coverage, 19795,
     /* 1326967 */     GIR_EraseRootFromParent_Done,
     /* 1326968 */   // Label 18991: @1326968
     /* 1326968 */   GIM_Try, /*On fail goto*//*Label 18992*/ GIMT_Encode4(1327052), // Rule ID 19798 //
     /* 1326973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1326976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1326990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1326993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327026 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327051 */     // GIR_Coverage, 19798,
     /* 1327051 */     GIR_EraseRootFromParent_Done,
     /* 1327052 */   // Label 18992: @1327052
     /* 1327052 */   GIM_Try, /*On fail goto*//*Label 18993*/ GIMT_Encode4(1327136), // Rule ID 19799 //
     /* 1327057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1327060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1327074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1327077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327110 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327135 */     // GIR_Coverage, 19799,
     /* 1327135 */     GIR_EraseRootFromParent_Done,
     /* 1327136 */   // Label 18993: @1327136
     /* 1327136 */   GIM_Try, /*On fail goto*//*Label 18994*/ GIMT_Encode4(1327220), // Rule ID 19802 //
     /* 1327141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1327158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1327161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327194 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1327197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327219 */     // GIR_Coverage, 19802,
     /* 1327219 */     GIR_EraseRootFromParent_Done,
     /* 1327220 */   // Label 18994: @1327220
     /* 1327220 */   GIM_Try, /*On fail goto*//*Label 18995*/ GIMT_Encode4(1327304), // Rule ID 19803 //
     /* 1327225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1327242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1327245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327278 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1327281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327303 */     // GIR_Coverage, 19803,
     /* 1327303 */     GIR_EraseRootFromParent_Done,
     /* 1327304 */   // Label 18995: @1327304
     /* 1327304 */   GIM_Try, /*On fail goto*//*Label 18996*/ GIMT_Encode4(1327388), // Rule ID 19806 //
     /* 1327309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1327320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1327323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1327326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1327329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1327332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327362 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1327365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327387 */     // GIR_Coverage, 19806,
     /* 1327387 */     GIR_EraseRootFromParent_Done,
     /* 1327388 */   // Label 18996: @1327388
     /* 1327388 */   GIM_Try, /*On fail goto*//*Label 18997*/ GIMT_Encode4(1327472), // Rule ID 19807 //
     /* 1327393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1327404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1327407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1327410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1327413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1327416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327446 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1327449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327471 */     // GIR_Coverage, 19807,
     /* 1327471 */     GIR_EraseRootFromParent_Done,
     /* 1327472 */   // Label 18997: @1327472
     /* 1327472 */   GIM_Try, /*On fail goto*//*Label 18998*/ GIMT_Encode4(1327556), // Rule ID 19810 //
     /* 1327477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1327488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1327491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1327494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1327497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1327500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327530 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1327533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327555 */     // GIR_Coverage, 19810,
     /* 1327555 */     GIR_EraseRootFromParent_Done,
     /* 1327556 */   // Label 18998: @1327556
     /* 1327556 */   GIM_Try, /*On fail goto*//*Label 18999*/ GIMT_Encode4(1327640), // Rule ID 19811 //
     /* 1327561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1327572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1327575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1327578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1327581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1327584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327614 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1327617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327639 */     // GIR_Coverage, 19811,
     /* 1327639 */     GIR_EraseRootFromParent_Done,
     /* 1327640 */   // Label 18999: @1327640
     /* 1327640 */   GIM_Try, /*On fail goto*//*Label 19000*/ GIMT_Encode4(1327724), // Rule ID 19814 //
     /* 1327645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1327648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1327656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1327659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1327662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1327665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327698 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1327701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327723 */     // GIR_Coverage, 19814,
     /* 1327723 */     GIR_EraseRootFromParent_Done,
     /* 1327724 */   // Label 19000: @1327724
     /* 1327724 */   GIM_Try, /*On fail goto*//*Label 19001*/ GIMT_Encode4(1327808), // Rule ID 19815 //
     /* 1327729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1327732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1327740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1327743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1327746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1327749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327782 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1327785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327807 */     // GIR_Coverage, 19815,
     /* 1327807 */     GIR_EraseRootFromParent_Done,
     /* 1327808 */   // Label 19001: @1327808
     /* 1327808 */   GIM_Try, /*On fail goto*//*Label 19002*/ GIMT_Encode4(1327892), // Rule ID 19818 //
     /* 1327813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1327816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1327830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1327833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327866 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1327869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327891 */     // GIR_Coverage, 19818,
     /* 1327891 */     GIR_EraseRootFromParent_Done,
     /* 1327892 */   // Label 19002: @1327892
     /* 1327892 */   GIM_Try, /*On fail goto*//*Label 19003*/ GIMT_Encode4(1327976), // Rule ID 19819 //
     /* 1327897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1327900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1327914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1327917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327950 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1327953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327975 */     // GIR_Coverage, 19819,
     /* 1327975 */     GIR_EraseRootFromParent_Done,
     /* 1327976 */   // Label 19003: @1327976
     /* 1327976 */   GIM_Try, /*On fail goto*//*Label 19004*/ GIMT_Encode4(1328060), // Rule ID 19822 //
     /* 1327981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1327984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1327992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1327995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1327998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1328001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328034 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328059 */     // GIR_Coverage, 19822,
     /* 1328059 */     GIR_EraseRootFromParent_Done,
     /* 1328060 */   // Label 19004: @1328060
     /* 1328060 */   GIM_Try, /*On fail goto*//*Label 19005*/ GIMT_Encode4(1328144), // Rule ID 19823 //
     /* 1328065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1328068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1328076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1328079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1328082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1328085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328118 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328143 */     // GIR_Coverage, 19823,
     /* 1328143 */     GIR_EraseRootFromParent_Done,
     /* 1328144 */   // Label 19005: @1328144
     /* 1328144 */   GIM_Try, /*On fail goto*//*Label 19006*/ GIMT_Encode4(1328228), // Rule ID 19826 //
     /* 1328149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1328166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1328169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328202 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1328205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328227 */     // GIR_Coverage, 19826,
     /* 1328227 */     GIR_EraseRootFromParent_Done,
     /* 1328228 */   // Label 19006: @1328228
     /* 1328228 */   GIM_Try, /*On fail goto*//*Label 19007*/ GIMT_Encode4(1328312), // Rule ID 19827 //
     /* 1328233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1328250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1328253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328286 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1328289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328311 */     // GIR_Coverage, 19827,
     /* 1328311 */     GIR_EraseRootFromParent_Done,
     /* 1328312 */   // Label 19007: @1328312
     /* 1328312 */   GIM_Try, /*On fail goto*//*Label 19008*/ GIMT_Encode4(1328396), // Rule ID 19830 //
     /* 1328317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1328334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1328337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328370 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1328373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328395 */     // GIR_Coverage, 19830,
     /* 1328395 */     GIR_EraseRootFromParent_Done,
     /* 1328396 */   // Label 19008: @1328396
     /* 1328396 */   GIM_Try, /*On fail goto*//*Label 19009*/ GIMT_Encode4(1328480), // Rule ID 19831 //
     /* 1328401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1328418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1328421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328454 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1328457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328479 */     // GIR_Coverage, 19831,
     /* 1328479 */     GIR_EraseRootFromParent_Done,
     /* 1328480 */   // Label 19009: @1328480
     /* 1328480 */   GIM_Try, /*On fail goto*//*Label 19010*/ GIMT_Encode4(1328564), // Rule ID 19834 //
     /* 1328485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1328502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1328505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328538 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328563 */     // GIR_Coverage, 19834,
     /* 1328563 */     GIR_EraseRootFromParent_Done,
     /* 1328564 */   // Label 19010: @1328564
     /* 1328564 */   GIM_Try, /*On fail goto*//*Label 19011*/ GIMT_Encode4(1328648), // Rule ID 19835 //
     /* 1328569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1328586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1328589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328622 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328647 */     // GIR_Coverage, 19835,
     /* 1328647 */     GIR_EraseRootFromParent_Done,
     /* 1328648 */   // Label 19011: @1328648
     /* 1328648 */   GIM_Try, /*On fail goto*//*Label 19012*/ GIMT_Encode4(1328732), // Rule ID 19838 //
     /* 1328653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1328656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1328664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1328667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1328670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1328676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328706 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1328709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328731 */     // GIR_Coverage, 19838,
     /* 1328731 */     GIR_EraseRootFromParent_Done,
     /* 1328732 */   // Label 19012: @1328732
     /* 1328732 */   GIM_Try, /*On fail goto*//*Label 19013*/ GIMT_Encode4(1328816), // Rule ID 19839 //
     /* 1328737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1328740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1328748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1328751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1328754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1328760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328790 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1328793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328815 */     // GIR_Coverage, 19839,
     /* 1328815 */     GIR_EraseRootFromParent_Done,
     /* 1328816 */   // Label 19013: @1328816
     /* 1328816 */   GIM_Try, /*On fail goto*//*Label 19014*/ GIMT_Encode4(1328900), // Rule ID 19842 //
     /* 1328821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1328824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1328838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328874 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1328877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328899 */     // GIR_Coverage, 19842,
     /* 1328899 */     GIR_EraseRootFromParent_Done,
     /* 1328900 */   // Label 19014: @1328900
     /* 1328900 */   GIM_Try, /*On fail goto*//*Label 19015*/ GIMT_Encode4(1328984), // Rule ID 19843 //
     /* 1328905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1328908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1328922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328958 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1328961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328983 */     // GIR_Coverage, 19843,
     /* 1328983 */     GIR_EraseRootFromParent_Done,
     /* 1328984 */   // Label 19015: @1328984
     /* 1328984 */   GIM_Try, /*On fail goto*//*Label 19016*/ GIMT_Encode4(1329068), // Rule ID 19846 //
     /* 1328989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1328992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1329006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329042 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1329045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329067 */     // GIR_Coverage, 19846,
     /* 1329067 */     GIR_EraseRootFromParent_Done,
     /* 1329068 */   // Label 19016: @1329068
     /* 1329068 */   GIM_Try, /*On fail goto*//*Label 19017*/ GIMT_Encode4(1329152), // Rule ID 19847 //
     /* 1329073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1329076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1329090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329126 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1329129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329151 */     // GIR_Coverage, 19847,
     /* 1329151 */     GIR_EraseRootFromParent_Done,
     /* 1329152 */   // Label 19017: @1329152
     /* 1329152 */   GIM_Try, /*On fail goto*//*Label 19018*/ GIMT_Encode4(1329236), // Rule ID 19850 //
     /* 1329157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1329168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1329171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1329174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329210 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1329213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329235 */     // GIR_Coverage, 19850,
     /* 1329235 */     GIR_EraseRootFromParent_Done,
     /* 1329236 */   // Label 19018: @1329236
     /* 1329236 */   GIM_Try, /*On fail goto*//*Label 19019*/ GIMT_Encode4(1329320), // Rule ID 19851 //
     /* 1329241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1329252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1329255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1329258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329294 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1329297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329319 */     // GIR_Coverage, 19851,
     /* 1329319 */     GIR_EraseRootFromParent_Done,
     /* 1329320 */   // Label 19019: @1329320
     /* 1329320 */   GIM_Try, /*On fail goto*//*Label 19020*/ GIMT_Encode4(1329404), // Rule ID 19854 //
     /* 1329325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1329328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1329342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329378 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1329381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329403 */     // GIR_Coverage, 19854,
     /* 1329403 */     GIR_EraseRootFromParent_Done,
     /* 1329404 */   // Label 19020: @1329404
     /* 1329404 */   GIM_Try, /*On fail goto*//*Label 19021*/ GIMT_Encode4(1329488), // Rule ID 19855 //
     /* 1329409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1329412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1329426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329462 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1329465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329487 */     // GIR_Coverage, 19855,
     /* 1329487 */     GIR_EraseRootFromParent_Done,
     /* 1329488 */   // Label 19021: @1329488
     /* 1329488 */   GIM_Try, /*On fail goto*//*Label 19022*/ GIMT_Encode4(1329572), // Rule ID 19858 //
     /* 1329493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1329496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1329510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1329535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329546 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1329549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329571 */     // GIR_Coverage, 19858,
     /* 1329571 */     GIR_EraseRootFromParent_Done,
     /* 1329572 */   // Label 19022: @1329572
     /* 1329572 */   GIM_Try, /*On fail goto*//*Label 19023*/ GIMT_Encode4(1329656), // Rule ID 19859 //
     /* 1329577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1329580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1329594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1329619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329630 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1329633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329655 */     // GIR_Coverage, 19859,
     /* 1329655 */     GIR_EraseRootFromParent_Done,
     /* 1329656 */   // Label 19023: @1329656
     /* 1329656 */   GIM_Try, /*On fail goto*//*Label 19024*/ GIMT_Encode4(1329740), // Rule ID 19862 //
     /* 1329661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1329672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1329675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1329678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329714 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1329717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329739 */     // GIR_Coverage, 19862,
     /* 1329739 */     GIR_EraseRootFromParent_Done,
     /* 1329740 */   // Label 19024: @1329740
     /* 1329740 */   GIM_Try, /*On fail goto*//*Label 19025*/ GIMT_Encode4(1329824), // Rule ID 19863 //
     /* 1329745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1329756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1329759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1329762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329798 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1329801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329823 */     // GIR_Coverage, 19863,
     /* 1329823 */     GIR_EraseRootFromParent_Done,
     /* 1329824 */   // Label 19025: @1329824
     /* 1329824 */   GIM_Try, /*On fail goto*//*Label 19026*/ GIMT_Encode4(1329908), // Rule ID 19866 //
     /* 1329829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1329840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1329843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1329846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1329852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329882 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1329885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329907 */     // GIR_Coverage, 19866,
     /* 1329907 */     GIR_EraseRootFromParent_Done,
     /* 1329908 */   // Label 19026: @1329908
     /* 1329908 */   GIM_Try, /*On fail goto*//*Label 19027*/ GIMT_Encode4(1329992), // Rule ID 19867 //
     /* 1329913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1329924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1329927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1329930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1329936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329966 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1329969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329991 */     // GIR_Coverage, 19867,
     /* 1329991 */     GIR_EraseRootFromParent_Done,
     /* 1329992 */   // Label 19027: @1329992
     /* 1329992 */   GIM_Try, /*On fail goto*//*Label 19028*/ GIMT_Encode4(1330076), // Rule ID 19870 //
     /* 1329997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1330008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1330011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1330014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1330020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330050 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1330053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330075 */     // GIR_Coverage, 19870,
     /* 1330075 */     GIR_EraseRootFromParent_Done,
     /* 1330076 */   // Label 19028: @1330076
     /* 1330076 */   GIM_Try, /*On fail goto*//*Label 19029*/ GIMT_Encode4(1330160), // Rule ID 19871 //
     /* 1330081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1330092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1330095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1330098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1330104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330134 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1330137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330159 */     // GIR_Coverage, 19871,
     /* 1330159 */     GIR_EraseRootFromParent_Done,
     /* 1330160 */   // Label 19029: @1330160
     /* 1330160 */   GIM_Try, /*On fail goto*//*Label 19030*/ GIMT_Encode4(1330244), // Rule ID 19874 //
     /* 1330165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1330182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330218 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1330221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330243 */     // GIR_Coverage, 19874,
     /* 1330243 */     GIR_EraseRootFromParent_Done,
     /* 1330244 */   // Label 19030: @1330244
     /* 1330244 */   GIM_Try, /*On fail goto*//*Label 19031*/ GIMT_Encode4(1330328), // Rule ID 19875 //
     /* 1330249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1330266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330302 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1330305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330327 */     // GIR_Coverage, 19875,
     /* 1330327 */     GIR_EraseRootFromParent_Done,
     /* 1330328 */   // Label 19031: @1330328
     /* 1330328 */   GIM_Try, /*On fail goto*//*Label 19032*/ GIMT_Encode4(1330412), // Rule ID 19878 //
     /* 1330333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1330350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330386 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1330389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330411 */     // GIR_Coverage, 19878,
     /* 1330411 */     GIR_EraseRootFromParent_Done,
     /* 1330412 */   // Label 19032: @1330412
     /* 1330412 */   GIM_Try, /*On fail goto*//*Label 19033*/ GIMT_Encode4(1330496), // Rule ID 19879 //
     /* 1330417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1330434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330470 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1330473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330495 */     // GIR_Coverage, 19879,
     /* 1330495 */     GIR_EraseRootFromParent_Done,
     /* 1330496 */   // Label 19033: @1330496
     /* 1330496 */   GIM_Try, /*On fail goto*//*Label 19034*/ GIMT_Encode4(1330580), // Rule ID 19882 //
     /* 1330501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1330518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330554 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1330557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330579 */     // GIR_Coverage, 19882,
     /* 1330579 */     GIR_EraseRootFromParent_Done,
     /* 1330580 */   // Label 19034: @1330580
     /* 1330580 */   GIM_Try, /*On fail goto*//*Label 19035*/ GIMT_Encode4(1330664), // Rule ID 19883 //
     /* 1330585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1330602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330638 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1330641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330663 */     // GIR_Coverage, 19883,
     /* 1330663 */     GIR_EraseRootFromParent_Done,
     /* 1330664 */   // Label 19035: @1330664
     /* 1330664 */   GIM_Try, /*On fail goto*//*Label 19036*/ GIMT_Encode4(1330748), // Rule ID 19886 //
     /* 1330669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1330672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1330680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1330683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1330686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1330692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1330711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330722 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1330725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330747 */     // GIR_Coverage, 19886,
     /* 1330747 */     GIR_EraseRootFromParent_Done,
     /* 1330748 */   // Label 19036: @1330748
     /* 1330748 */   GIM_Try, /*On fail goto*//*Label 19037*/ GIMT_Encode4(1330832), // Rule ID 19887 //
     /* 1330753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1330756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1330764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1330767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1330770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1330776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1330795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330806 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1330809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330831 */     // GIR_Coverage, 19887,
     /* 1330831 */     GIR_EraseRootFromParent_Done,
     /* 1330832 */   // Label 19037: @1330832
     /* 1330832 */   GIM_Try, /*On fail goto*//*Label 19038*/ GIMT_Encode4(1330916), // Rule ID 19890 //
     /* 1330837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1330840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1330854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1330879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330890 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1330893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330915 */     // GIR_Coverage, 19890,
     /* 1330915 */     GIR_EraseRootFromParent_Done,
     /* 1330916 */   // Label 19038: @1330916
     /* 1330916 */   GIM_Try, /*On fail goto*//*Label 19039*/ GIMT_Encode4(1331000), // Rule ID 19891 //
     /* 1330921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1330924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1330938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1330963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330974 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1330977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330999 */     // GIR_Coverage, 19891,
     /* 1330999 */     GIR_EraseRootFromParent_Done,
     /* 1331000 */   // Label 19039: @1331000
     /* 1331000 */   GIM_Try, /*On fail goto*//*Label 19040*/ GIMT_Encode4(1331084), // Rule ID 19894 //
     /* 1331005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1331008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1331022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331058 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1331061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331083 */     // GIR_Coverage, 19894,
     /* 1331083 */     GIR_EraseRootFromParent_Done,
     /* 1331084 */   // Label 19040: @1331084
     /* 1331084 */   GIM_Try, /*On fail goto*//*Label 19041*/ GIMT_Encode4(1331168), // Rule ID 19895 //
     /* 1331089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1331092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1331106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331142 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1331145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331167 */     // GIR_Coverage, 19895,
     /* 1331167 */     GIR_EraseRootFromParent_Done,
     /* 1331168 */   // Label 19041: @1331168
     /* 1331168 */   GIM_Try, /*On fail goto*//*Label 19042*/ GIMT_Encode4(1331252), // Rule ID 19898 //
     /* 1331173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1331190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1331193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331226 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1331229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331251 */     // GIR_Coverage, 19898,
     /* 1331251 */     GIR_EraseRootFromParent_Done,
     /* 1331252 */   // Label 19042: @1331252
     /* 1331252 */   GIM_Try, /*On fail goto*//*Label 19043*/ GIMT_Encode4(1331336), // Rule ID 19899 //
     /* 1331257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1331274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1331277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331310 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1331313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331335 */     // GIR_Coverage, 19899,
     /* 1331335 */     GIR_EraseRootFromParent_Done,
     /* 1331336 */   // Label 19043: @1331336
     /* 1331336 */   GIM_Try, /*On fail goto*//*Label 19044*/ GIMT_Encode4(1331420), // Rule ID 19902 //
     /* 1331341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1331358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1331361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331394 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1331397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331419 */     // GIR_Coverage, 19902,
     /* 1331419 */     GIR_EraseRootFromParent_Done,
     /* 1331420 */   // Label 19044: @1331420
     /* 1331420 */   GIM_Try, /*On fail goto*//*Label 19045*/ GIMT_Encode4(1331504), // Rule ID 19903 //
     /* 1331425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1331442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1331445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331478 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1331481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331503 */     // GIR_Coverage, 19903,
     /* 1331503 */     GIR_EraseRootFromParent_Done,
     /* 1331504 */   // Label 19045: @1331504
     /* 1331504 */   GIM_Try, /*On fail goto*//*Label 19046*/ GIMT_Encode4(1331588), // Rule ID 19906 //
     /* 1331509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1331512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1331526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1331529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331562 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1331565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331587 */     // GIR_Coverage, 19906,
     /* 1331587 */     GIR_EraseRootFromParent_Done,
     /* 1331588 */   // Label 19046: @1331588
     /* 1331588 */   GIM_Try, /*On fail goto*//*Label 19047*/ GIMT_Encode4(1331672), // Rule ID 19907 //
     /* 1331593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1331596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1331610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1331613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331646 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1331649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331671 */     // GIR_Coverage, 19907,
     /* 1331671 */     GIR_EraseRootFromParent_Done,
     /* 1331672 */   // Label 19047: @1331672
     /* 1331672 */   GIM_Try, /*On fail goto*//*Label 19048*/ GIMT_Encode4(1331756), // Rule ID 19910 //
     /* 1331677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1331694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1331697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331730 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1331733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331755 */     // GIR_Coverage, 19910,
     /* 1331755 */     GIR_EraseRootFromParent_Done,
     /* 1331756 */   // Label 19048: @1331756
     /* 1331756 */   GIM_Try, /*On fail goto*//*Label 19049*/ GIMT_Encode4(1331840), // Rule ID 19911 //
     /* 1331761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1331778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1331781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331814 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1331817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331839 */     // GIR_Coverage, 19911,
     /* 1331839 */     GIR_EraseRootFromParent_Done,
     /* 1331840 */   // Label 19049: @1331840
     /* 1331840 */   GIM_Try, /*On fail goto*//*Label 19050*/ GIMT_Encode4(1331924), // Rule ID 19914 //
     /* 1331845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1331848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1331862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1331865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331898 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1331901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331923 */     // GIR_Coverage, 19914,
     /* 1331923 */     GIR_EraseRootFromParent_Done,
     /* 1331924 */   // Label 19050: @1331924
     /* 1331924 */   GIM_Try, /*On fail goto*//*Label 19051*/ GIMT_Encode4(1332008), // Rule ID 19915 //
     /* 1331929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1331932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1331946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1331949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331982 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1331985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332007 */     // GIR_Coverage, 19915,
     /* 1332007 */     GIR_EraseRootFromParent_Done,
     /* 1332008 */   // Label 19051: @1332008
     /* 1332008 */   GIM_Try, /*On fail goto*//*Label 19052*/ GIMT_Encode4(1332092), // Rule ID 19918 //
     /* 1332013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1332016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1332030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1332033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332066 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332091 */     // GIR_Coverage, 19918,
     /* 1332091 */     GIR_EraseRootFromParent_Done,
     /* 1332092 */   // Label 19052: @1332092
     /* 1332092 */   GIM_Try, /*On fail goto*//*Label 19053*/ GIMT_Encode4(1332176), // Rule ID 19919 //
     /* 1332097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1332100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1332114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1332117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332150 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332175 */     // GIR_Coverage, 19919,
     /* 1332175 */     GIR_EraseRootFromParent_Done,
     /* 1332176 */   // Label 19053: @1332176
     /* 1332176 */   GIM_Try, /*On fail goto*//*Label 19054*/ GIMT_Encode4(1332260), // Rule ID 19922 //
     /* 1332181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1332198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1332201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332234 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1332237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332259 */     // GIR_Coverage, 19922,
     /* 1332259 */     GIR_EraseRootFromParent_Done,
     /* 1332260 */   // Label 19054: @1332260
     /* 1332260 */   GIM_Try, /*On fail goto*//*Label 19055*/ GIMT_Encode4(1332344), // Rule ID 19923 //
     /* 1332265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1332282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1332285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332318 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1332321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332343 */     // GIR_Coverage, 19923,
     /* 1332343 */     GIR_EraseRootFromParent_Done,
     /* 1332344 */   // Label 19055: @1332344
     /* 1332344 */   GIM_Try, /*On fail goto*//*Label 19056*/ GIMT_Encode4(1332428), // Rule ID 19926 //
     /* 1332349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1332360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1332363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1332366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1332369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1332372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332402 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1332405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332427 */     // GIR_Coverage, 19926,
     /* 1332427 */     GIR_EraseRootFromParent_Done,
     /* 1332428 */   // Label 19056: @1332428
     /* 1332428 */   GIM_Try, /*On fail goto*//*Label 19057*/ GIMT_Encode4(1332512), // Rule ID 19927 //
     /* 1332433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1332444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1332447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1332450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1332453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1332456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332486 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1332489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332511 */     // GIR_Coverage, 19927,
     /* 1332511 */     GIR_EraseRootFromParent_Done,
     /* 1332512 */   // Label 19057: @1332512
     /* 1332512 */   GIM_Try, /*On fail goto*//*Label 19058*/ GIMT_Encode4(1332596), // Rule ID 19930 //
     /* 1332517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1332528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1332531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1332534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1332537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1332540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332570 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1332573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332595 */     // GIR_Coverage, 19930,
     /* 1332595 */     GIR_EraseRootFromParent_Done,
     /* 1332596 */   // Label 19058: @1332596
     /* 1332596 */   GIM_Try, /*On fail goto*//*Label 19059*/ GIMT_Encode4(1332680), // Rule ID 19931 //
     /* 1332601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1332612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1332615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1332618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1332621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1332624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332654 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1332657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332679 */     // GIR_Coverage, 19931,
     /* 1332679 */     GIR_EraseRootFromParent_Done,
     /* 1332680 */   // Label 19059: @1332680
     /* 1332680 */   GIM_Try, /*On fail goto*//*Label 19060*/ GIMT_Encode4(1332764), // Rule ID 19934 //
     /* 1332685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1332688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1332702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1332705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332738 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1332741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332763 */     // GIR_Coverage, 19934,
     /* 1332763 */     GIR_EraseRootFromParent_Done,
     /* 1332764 */   // Label 19060: @1332764
     /* 1332764 */   GIM_Try, /*On fail goto*//*Label 19061*/ GIMT_Encode4(1332848), // Rule ID 19935 //
     /* 1332769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1332772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1332786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1332789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332822 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1332825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332847 */     // GIR_Coverage, 19935,
     /* 1332847 */     GIR_EraseRootFromParent_Done,
     /* 1332848 */   // Label 19061: @1332848
     /* 1332848 */   GIM_Try, /*On fail goto*//*Label 19062*/ GIMT_Encode4(1332932), // Rule ID 19938 //
     /* 1332853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1332856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1332870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1332873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332906 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1332909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332931 */     // GIR_Coverage, 19938,
     /* 1332931 */     GIR_EraseRootFromParent_Done,
     /* 1332932 */   // Label 19062: @1332932
     /* 1332932 */   GIM_Try, /*On fail goto*//*Label 19063*/ GIMT_Encode4(1333016), // Rule ID 19939 //
     /* 1332937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1332940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1332954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1332957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332990 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1332993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333015 */     // GIR_Coverage, 19939,
     /* 1333015 */     GIR_EraseRootFromParent_Done,
     /* 1333016 */   // Label 19063: @1333016
     /* 1333016 */   GIM_Try, /*On fail goto*//*Label 19064*/ GIMT_Encode4(1333100), // Rule ID 19942 //
     /* 1333021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1333038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1333041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333074 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333099 */     // GIR_Coverage, 19942,
     /* 1333099 */     GIR_EraseRootFromParent_Done,
     /* 1333100 */   // Label 19064: @1333100
     /* 1333100 */   GIM_Try, /*On fail goto*//*Label 19065*/ GIMT_Encode4(1333184), // Rule ID 19943 //
     /* 1333105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1333122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1333125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333158 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333183 */     // GIR_Coverage, 19943,
     /* 1333183 */     GIR_EraseRootFromParent_Done,
     /* 1333184 */   // Label 19065: @1333184
     /* 1333184 */   GIM_Try, /*On fail goto*//*Label 19066*/ GIMT_Encode4(1333268), // Rule ID 19946 //
     /* 1333189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1333206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1333209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333242 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1333245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333267 */     // GIR_Coverage, 19946,
     /* 1333267 */     GIR_EraseRootFromParent_Done,
     /* 1333268 */   // Label 19066: @1333268
     /* 1333268 */   GIM_Try, /*On fail goto*//*Label 19067*/ GIMT_Encode4(1333352), // Rule ID 19947 //
     /* 1333273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1333290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1333293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333326 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1333329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333351 */     // GIR_Coverage, 19947,
     /* 1333351 */     GIR_EraseRootFromParent_Done,
     /* 1333352 */   // Label 19067: @1333352
     /* 1333352 */   GIM_Try, /*On fail goto*//*Label 19068*/ GIMT_Encode4(1333436), // Rule ID 19950 //
     /* 1333357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1333374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1333377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333410 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1333413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333435 */     // GIR_Coverage, 19950,
     /* 1333435 */     GIR_EraseRootFromParent_Done,
     /* 1333436 */   // Label 19068: @1333436
     /* 1333436 */   GIM_Try, /*On fail goto*//*Label 19069*/ GIMT_Encode4(1333520), // Rule ID 19951 //
     /* 1333441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1333458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1333461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333494 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1333497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333519 */     // GIR_Coverage, 19951,
     /* 1333519 */     GIR_EraseRootFromParent_Done,
     /* 1333520 */   // Label 19069: @1333520
     /* 1333520 */   GIM_Try, /*On fail goto*//*Label 19070*/ GIMT_Encode4(1333604), // Rule ID 19954 //
     /* 1333525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1333542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1333545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333578 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333603 */     // GIR_Coverage, 19954,
     /* 1333603 */     GIR_EraseRootFromParent_Done,
     /* 1333604 */   // Label 19070: @1333604
     /* 1333604 */   GIM_Try, /*On fail goto*//*Label 19071*/ GIMT_Encode4(1333688), // Rule ID 19955 //
     /* 1333609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1333626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1333629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333662 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333687 */     // GIR_Coverage, 19955,
     /* 1333687 */     GIR_EraseRootFromParent_Done,
     /* 1333688 */   // Label 19071: @1333688
     /* 1333688 */   GIM_Try, /*On fail goto*//*Label 19072*/ GIMT_Encode4(1333772), // Rule ID 19958 //
     /* 1333693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1333696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1333704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1333707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1333710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1333716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333746 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1333749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333771 */     // GIR_Coverage, 19958,
     /* 1333771 */     GIR_EraseRootFromParent_Done,
     /* 1333772 */   // Label 19072: @1333772
     /* 1333772 */   GIM_Try, /*On fail goto*//*Label 19073*/ GIMT_Encode4(1333856), // Rule ID 19959 //
     /* 1333777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1333780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1333788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1333791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1333794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1333800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333830 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1333833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333855 */     // GIR_Coverage, 19959,
     /* 1333855 */     GIR_EraseRootFromParent_Done,
     /* 1333856 */   // Label 19073: @1333856
     /* 1333856 */   GIM_Try, /*On fail goto*//*Label 19074*/ GIMT_Encode4(1333940), // Rule ID 19962 //
     /* 1333861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1333864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1333878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333914 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1333917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333939 */     // GIR_Coverage, 19962,
     /* 1333939 */     GIR_EraseRootFromParent_Done,
     /* 1333940 */   // Label 19074: @1333940
     /* 1333940 */   GIM_Try, /*On fail goto*//*Label 19075*/ GIMT_Encode4(1334024), // Rule ID 19963 //
     /* 1333945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1333948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1333962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1334001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334023 */     // GIR_Coverage, 19963,
     /* 1334023 */     GIR_EraseRootFromParent_Done,
     /* 1334024 */   // Label 19075: @1334024
     /* 1334024 */   GIM_Try, /*On fail goto*//*Label 19076*/ GIMT_Encode4(1334108), // Rule ID 19966 //
     /* 1334029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1334046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334082 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1334085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334107 */     // GIR_Coverage, 19966,
     /* 1334107 */     GIR_EraseRootFromParent_Done,
     /* 1334108 */   // Label 19076: @1334108
     /* 1334108 */   GIM_Try, /*On fail goto*//*Label 19077*/ GIMT_Encode4(1334192), // Rule ID 19967 //
     /* 1334113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1334130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334166 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1334169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334191 */     // GIR_Coverage, 19967,
     /* 1334191 */     GIR_EraseRootFromParent_Done,
     /* 1334192 */   // Label 19077: @1334192
     /* 1334192 */   GIM_Try, /*On fail goto*//*Label 19078*/ GIMT_Encode4(1334276), // Rule ID 19970 //
     /* 1334197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1334214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334250 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1334253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334275 */     // GIR_Coverage, 19970,
     /* 1334275 */     GIR_EraseRootFromParent_Done,
     /* 1334276 */   // Label 19078: @1334276
     /* 1334276 */   GIM_Try, /*On fail goto*//*Label 19079*/ GIMT_Encode4(1334360), // Rule ID 19971 //
     /* 1334281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1334298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334334 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1334337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334359 */     // GIR_Coverage, 19971,
     /* 1334359 */     GIR_EraseRootFromParent_Done,
     /* 1334360 */   // Label 19079: @1334360
     /* 1334360 */   GIM_Try, /*On fail goto*//*Label 19080*/ GIMT_Encode4(1334444), // Rule ID 19974 //
     /* 1334365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1334382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334418 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1334421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334443 */     // GIR_Coverage, 19974,
     /* 1334443 */     GIR_EraseRootFromParent_Done,
     /* 1334444 */   // Label 19080: @1334444
     /* 1334444 */   GIM_Try, /*On fail goto*//*Label 19081*/ GIMT_Encode4(1334528), // Rule ID 19975 //
     /* 1334449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1334466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334502 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1334505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334527 */     // GIR_Coverage, 19975,
     /* 1334527 */     GIR_EraseRootFromParent_Done,
     /* 1334528 */   // Label 19081: @1334528
     /* 1334528 */   GIM_Try, /*On fail goto*//*Label 19082*/ GIMT_Encode4(1334612), // Rule ID 19978 //
     /* 1334533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1334536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1334550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334586 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1334589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334611 */     // GIR_Coverage, 19978,
     /* 1334611 */     GIR_EraseRootFromParent_Done,
     /* 1334612 */   // Label 19082: @1334612
     /* 1334612 */   GIM_Try, /*On fail goto*//*Label 19083*/ GIMT_Encode4(1334696), // Rule ID 19979 //
     /* 1334617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1334620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1334634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334670 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1334673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334695 */     // GIR_Coverage, 19979,
     /* 1334695 */     GIR_EraseRootFromParent_Done,
     /* 1334696 */   // Label 19083: @1334696
     /* 1334696 */   GIM_Try, /*On fail goto*//*Label 19084*/ GIMT_Encode4(1334780), // Rule ID 19982 //
     /* 1334701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1334712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1334718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334754 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1334757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334779 */     // GIR_Coverage, 19982,
     /* 1334779 */     GIR_EraseRootFromParent_Done,
     /* 1334780 */   // Label 19084: @1334780
     /* 1334780 */   GIM_Try, /*On fail goto*//*Label 19085*/ GIMT_Encode4(1334864), // Rule ID 19983 //
     /* 1334785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1334796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1334802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334838 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1334841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334863 */     // GIR_Coverage, 19983,
     /* 1334863 */     GIR_EraseRootFromParent_Done,
     /* 1334864 */   // Label 19085: @1334864
     /* 1334864 */   GIM_Try, /*On fail goto*//*Label 19086*/ GIMT_Encode4(1334948), // Rule ID 19986 //
     /* 1334869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1334880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1334883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1334886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1334892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334922 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1334925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334947 */     // GIR_Coverage, 19986,
     /* 1334947 */     GIR_EraseRootFromParent_Done,
     /* 1334948 */   // Label 19086: @1334948
     /* 1334948 */   GIM_Try, /*On fail goto*//*Label 19087*/ GIMT_Encode4(1335032), // Rule ID 19987 //
     /* 1334953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1334964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1334967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1334970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1334976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335006 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1335009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335031 */     // GIR_Coverage, 19987,
     /* 1335031 */     GIR_EraseRootFromParent_Done,
     /* 1335032 */   // Label 19087: @1335032
     /* 1335032 */   GIM_Try, /*On fail goto*//*Label 19088*/ GIMT_Encode4(1335116), // Rule ID 19990 //
     /* 1335037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1335048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1335051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1335054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1335060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335090 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1335093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335115 */     // GIR_Coverage, 19990,
     /* 1335115 */     GIR_EraseRootFromParent_Done,
     /* 1335116 */   // Label 19088: @1335116
     /* 1335116 */   GIM_Try, /*On fail goto*//*Label 19089*/ GIMT_Encode4(1335200), // Rule ID 19991 //
     /* 1335121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1335132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1335135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1335138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1335144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335174 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1335177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335199 */     // GIR_Coverage, 19991,
     /* 1335199 */     GIR_EraseRootFromParent_Done,
     /* 1335200 */   // Label 19089: @1335200
     /* 1335200 */   GIM_Try, /*On fail goto*//*Label 19090*/ GIMT_Encode4(1335284), // Rule ID 19994 //
     /* 1335205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1335222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335258 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1335261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335283 */     // GIR_Coverage, 19994,
     /* 1335283 */     GIR_EraseRootFromParent_Done,
     /* 1335284 */   // Label 19090: @1335284
     /* 1335284 */   GIM_Try, /*On fail goto*//*Label 19091*/ GIMT_Encode4(1335368), // Rule ID 19995 //
     /* 1335289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1335306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335342 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1335345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335367 */     // GIR_Coverage, 19995,
     /* 1335367 */     GIR_EraseRootFromParent_Done,
     /* 1335368 */   // Label 19091: @1335368
     /* 1335368 */   GIM_Try, /*On fail goto*//*Label 19092*/ GIMT_Encode4(1335452), // Rule ID 19998 //
     /* 1335373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1335390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335426 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1335429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335451 */     // GIR_Coverage, 19998,
     /* 1335451 */     GIR_EraseRootFromParent_Done,
     /* 1335452 */   // Label 19092: @1335452
     /* 1335452 */   GIM_Try, /*On fail goto*//*Label 19093*/ GIMT_Encode4(1335536), // Rule ID 19999 //
     /* 1335457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1335474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335510 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1335513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335535 */     // GIR_Coverage, 19999,
     /* 1335535 */     GIR_EraseRootFromParent_Done,
     /* 1335536 */   // Label 19093: @1335536
     /* 1335536 */   GIM_Try, /*On fail goto*//*Label 19094*/ GIMT_Encode4(1335620), // Rule ID 20002 //
     /* 1335541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1335558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335594 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1335597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335619 */     // GIR_Coverage, 20002,
     /* 1335619 */     GIR_EraseRootFromParent_Done,
     /* 1335620 */   // Label 19094: @1335620
     /* 1335620 */   GIM_Try, /*On fail goto*//*Label 19095*/ GIMT_Encode4(1335704), // Rule ID 20003 //
     /* 1335625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1335642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335678 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1335681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335703 */     // GIR_Coverage, 20003,
     /* 1335703 */     GIR_EraseRootFromParent_Done,
     /* 1335704 */   // Label 19095: @1335704
     /* 1335704 */   GIM_Try, /*On fail goto*//*Label 19096*/ GIMT_Encode4(1335788), // Rule ID 20006 //
     /* 1335709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1335712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1335720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1335723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1335726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1335732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1335751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335762 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1335765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335787 */     // GIR_Coverage, 20006,
     /* 1335787 */     GIR_EraseRootFromParent_Done,
     /* 1335788 */   // Label 19096: @1335788
     /* 1335788 */   GIM_Try, /*On fail goto*//*Label 19097*/ GIMT_Encode4(1335872), // Rule ID 20007 //
     /* 1335793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1335796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1335804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1335807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1335810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1335816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1335835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335846 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1335849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335871 */     // GIR_Coverage, 20007,
     /* 1335871 */     GIR_EraseRootFromParent_Done,
     /* 1335872 */   // Label 19097: @1335872
     /* 1335872 */   GIM_Try, /*On fail goto*//*Label 19098*/ GIMT_Encode4(1335956), // Rule ID 20010 //
     /* 1335877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1335880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1335894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1335919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335930 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1335933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335955 */     // GIR_Coverage, 20010,
     /* 1335955 */     GIR_EraseRootFromParent_Done,
     /* 1335956 */   // Label 19098: @1335956
     /* 1335956 */   GIM_Try, /*On fail goto*//*Label 19099*/ GIMT_Encode4(1336040), // Rule ID 20011 //
     /* 1335961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1335964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1335978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336014 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1336017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336039 */     // GIR_Coverage, 20011,
     /* 1336039 */     GIR_EraseRootFromParent_Done,
     /* 1336040 */   // Label 19099: @1336040
     /* 1336040 */   GIM_Try, /*On fail goto*//*Label 19100*/ GIMT_Encode4(1336124), // Rule ID 20014 //
     /* 1336045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1336048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1336062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336098 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1336101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336123 */     // GIR_Coverage, 20014,
     /* 1336123 */     GIR_EraseRootFromParent_Done,
     /* 1336124 */   // Label 19100: @1336124
     /* 1336124 */   GIM_Try, /*On fail goto*//*Label 19101*/ GIMT_Encode4(1336208), // Rule ID 20015 //
     /* 1336129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1336132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1336146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336182 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1336185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336207 */     // GIR_Coverage, 20015,
     /* 1336207 */     GIR_EraseRootFromParent_Done,
     /* 1336208 */   // Label 19101: @1336208
     /* 1336208 */   GIM_Try, /*On fail goto*//*Label 19102*/ GIMT_Encode4(1336292), // Rule ID 20018 //
     /* 1336213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1336230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1336233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336266 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1336269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336291 */     // GIR_Coverage, 20018,
     /* 1336291 */     GIR_EraseRootFromParent_Done,
     /* 1336292 */   // Label 19102: @1336292
     /* 1336292 */   GIM_Try, /*On fail goto*//*Label 19103*/ GIMT_Encode4(1336376), // Rule ID 20019 //
     /* 1336297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1336314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1336317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336350 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1336353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336375 */     // GIR_Coverage, 20019,
     /* 1336375 */     GIR_EraseRootFromParent_Done,
     /* 1336376 */   // Label 19103: @1336376
     /* 1336376 */   GIM_Try, /*On fail goto*//*Label 19104*/ GIMT_Encode4(1336460), // Rule ID 20022 //
     /* 1336381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1336398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1336401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336434 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1336437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336459 */     // GIR_Coverage, 20022,
     /* 1336459 */     GIR_EraseRootFromParent_Done,
     /* 1336460 */   // Label 19104: @1336460
     /* 1336460 */   GIM_Try, /*On fail goto*//*Label 19105*/ GIMT_Encode4(1336544), // Rule ID 20023 //
     /* 1336465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1336482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1336485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336518 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1336521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336543 */     // GIR_Coverage, 20023,
     /* 1336543 */     GIR_EraseRootFromParent_Done,
     /* 1336544 */   // Label 19105: @1336544
     /* 1336544 */   GIM_Try, /*On fail goto*//*Label 19106*/ GIMT_Encode4(1336628), // Rule ID 20026 //
     /* 1336549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1336552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1336566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1336569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336602 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1336605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336627 */     // GIR_Coverage, 20026,
     /* 1336627 */     GIR_EraseRootFromParent_Done,
     /* 1336628 */   // Label 19106: @1336628
     /* 1336628 */   GIM_Try, /*On fail goto*//*Label 19107*/ GIMT_Encode4(1336712), // Rule ID 20027 //
     /* 1336633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1336636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1336650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1336653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336686 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1336689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336711 */     // GIR_Coverage, 20027,
     /* 1336711 */     GIR_EraseRootFromParent_Done,
     /* 1336712 */   // Label 19107: @1336712
     /* 1336712 */   GIM_Try, /*On fail goto*//*Label 19108*/ GIMT_Encode4(1336796), // Rule ID 20030 //
     /* 1336717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1336734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1336737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336770 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1336773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336795 */     // GIR_Coverage, 20030,
     /* 1336795 */     GIR_EraseRootFromParent_Done,
     /* 1336796 */   // Label 19108: @1336796
     /* 1336796 */   GIM_Try, /*On fail goto*//*Label 19109*/ GIMT_Encode4(1336880), // Rule ID 20031 //
     /* 1336801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1336818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1336821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336854 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1336857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336879 */     // GIR_Coverage, 20031,
     /* 1336879 */     GIR_EraseRootFromParent_Done,
     /* 1336880 */   // Label 19109: @1336880
     /* 1336880 */   GIM_Try, /*On fail goto*//*Label 19110*/ GIMT_Encode4(1336964), // Rule ID 20034 //
     /* 1336885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1336888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1336902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1336905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336938 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1336941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336963 */     // GIR_Coverage, 20034,
     /* 1336963 */     GIR_EraseRootFromParent_Done,
     /* 1336964 */   // Label 19110: @1336964
     /* 1336964 */   GIM_Try, /*On fail goto*//*Label 19111*/ GIMT_Encode4(1337048), // Rule ID 20035 //
     /* 1336969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1336972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1336986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1336989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337022 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337047 */     // GIR_Coverage, 20035,
     /* 1337047 */     GIR_EraseRootFromParent_Done,
     /* 1337048 */   // Label 19111: @1337048
     /* 1337048 */   GIM_Try, /*On fail goto*//*Label 19112*/ GIMT_Encode4(1337132), // Rule ID 20038 //
     /* 1337053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1337056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1337070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1337073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337106 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337131 */     // GIR_Coverage, 20038,
     /* 1337131 */     GIR_EraseRootFromParent_Done,
     /* 1337132 */   // Label 19112: @1337132
     /* 1337132 */   GIM_Try, /*On fail goto*//*Label 19113*/ GIMT_Encode4(1337216), // Rule ID 20039 //
     /* 1337137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1337140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1337154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1337157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337215 */     // GIR_Coverage, 20039,
     /* 1337215 */     GIR_EraseRootFromParent_Done,
     /* 1337216 */   // Label 19113: @1337216
     /* 1337216 */   GIM_Try, /*On fail goto*//*Label 19114*/ GIMT_Encode4(1337300), // Rule ID 20042 //
     /* 1337221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1337238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1337241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337274 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1337277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337299 */     // GIR_Coverage, 20042,
     /* 1337299 */     GIR_EraseRootFromParent_Done,
     /* 1337300 */   // Label 19114: @1337300
     /* 1337300 */   GIM_Try, /*On fail goto*//*Label 19115*/ GIMT_Encode4(1337384), // Rule ID 20043 //
     /* 1337305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1337322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1337325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337358 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1337361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337383 */     // GIR_Coverage, 20043,
     /* 1337383 */     GIR_EraseRootFromParent_Done,
     /* 1337384 */   // Label 19115: @1337384
     /* 1337384 */   GIM_Try, /*On fail goto*//*Label 19116*/ GIMT_Encode4(1337468), // Rule ID 20046 //
     /* 1337389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1337400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1337403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1337406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1337409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1337412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337442 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1337445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337467 */     // GIR_Coverage, 20046,
     /* 1337467 */     GIR_EraseRootFromParent_Done,
     /* 1337468 */   // Label 19116: @1337468
     /* 1337468 */   GIM_Try, /*On fail goto*//*Label 19117*/ GIMT_Encode4(1337552), // Rule ID 20047 //
     /* 1337473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1337484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1337487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1337490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1337493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1337496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337526 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1337529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337551 */     // GIR_Coverage, 20047,
     /* 1337551 */     GIR_EraseRootFromParent_Done,
     /* 1337552 */   // Label 19117: @1337552
     /* 1337552 */   GIM_Try, /*On fail goto*//*Label 19118*/ GIMT_Encode4(1337636), // Rule ID 20050 //
     /* 1337557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1337568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1337571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1337574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1337577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1337580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337610 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1337613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337635 */     // GIR_Coverage, 20050,
     /* 1337635 */     GIR_EraseRootFromParent_Done,
     /* 1337636 */   // Label 19118: @1337636
     /* 1337636 */   GIM_Try, /*On fail goto*//*Label 19119*/ GIMT_Encode4(1337720), // Rule ID 20051 //
     /* 1337641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1337652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1337655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1337658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1337661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1337664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337694 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1337697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337719 */     // GIR_Coverage, 20051,
     /* 1337719 */     GIR_EraseRootFromParent_Done,
     /* 1337720 */   // Label 19119: @1337720
     /* 1337720 */   GIM_Try, /*On fail goto*//*Label 19120*/ GIMT_Encode4(1337804), // Rule ID 20054 //
     /* 1337725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1337728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1337742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1337745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337778 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1337781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337803 */     // GIR_Coverage, 20054,
     /* 1337803 */     GIR_EraseRootFromParent_Done,
     /* 1337804 */   // Label 19120: @1337804
     /* 1337804 */   GIM_Try, /*On fail goto*//*Label 19121*/ GIMT_Encode4(1337888), // Rule ID 20055 //
     /* 1337809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1337812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1337826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1337829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337862 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1337865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337887 */     // GIR_Coverage, 20055,
     /* 1337887 */     GIR_EraseRootFromParent_Done,
     /* 1337888 */   // Label 19121: @1337888
     /* 1337888 */   GIM_Try, /*On fail goto*//*Label 19122*/ GIMT_Encode4(1337972), // Rule ID 20058 //
     /* 1337893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1337896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1337910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1337913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337946 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1337949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337971 */     // GIR_Coverage, 20058,
     /* 1337971 */     GIR_EraseRootFromParent_Done,
     /* 1337972 */   // Label 19122: @1337972
     /* 1337972 */   GIM_Try, /*On fail goto*//*Label 19123*/ GIMT_Encode4(1338056), // Rule ID 20059 //
     /* 1337977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1337980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1337994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1337997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338030 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338055 */     // GIR_Coverage, 20059,
     /* 1338055 */     GIR_EraseRootFromParent_Done,
     /* 1338056 */   // Label 19123: @1338056
     /* 1338056 */   GIM_Try, /*On fail goto*//*Label 19124*/ GIMT_Encode4(1338140), // Rule ID 20062 //
     /* 1338061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1338078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1338081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338114 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338139 */     // GIR_Coverage, 20062,
     /* 1338139 */     GIR_EraseRootFromParent_Done,
     /* 1338140 */   // Label 19124: @1338140
     /* 1338140 */   GIM_Try, /*On fail goto*//*Label 19125*/ GIMT_Encode4(1338224), // Rule ID 20063 //
     /* 1338145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1338162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1338165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338198 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338223 */     // GIR_Coverage, 20063,
     /* 1338223 */     GIR_EraseRootFromParent_Done,
     /* 1338224 */   // Label 19125: @1338224
     /* 1338224 */   GIM_Try, /*On fail goto*//*Label 19126*/ GIMT_Encode4(1338308), // Rule ID 20066 //
     /* 1338229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1338246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1338249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338282 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1338285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338307 */     // GIR_Coverage, 20066,
     /* 1338307 */     GIR_EraseRootFromParent_Done,
     /* 1338308 */   // Label 19126: @1338308
     /* 1338308 */   GIM_Try, /*On fail goto*//*Label 19127*/ GIMT_Encode4(1338392), // Rule ID 20067 //
     /* 1338313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1338330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1338333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338366 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1338369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338391 */     // GIR_Coverage, 20067,
     /* 1338391 */     GIR_EraseRootFromParent_Done,
     /* 1338392 */   // Label 19127: @1338392
     /* 1338392 */   GIM_Try, /*On fail goto*//*Label 19128*/ GIMT_Encode4(1338476), // Rule ID 20070 //
     /* 1338397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1338414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1338417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338450 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338475 */     // GIR_Coverage, 20070,
     /* 1338475 */     GIR_EraseRootFromParent_Done,
     /* 1338476 */   // Label 19128: @1338476
     /* 1338476 */   GIM_Try, /*On fail goto*//*Label 19129*/ GIMT_Encode4(1338560), // Rule ID 20071 //
     /* 1338481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1338498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1338501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338534 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338559 */     // GIR_Coverage, 20071,
     /* 1338559 */     GIR_EraseRootFromParent_Done,
     /* 1338560 */   // Label 19129: @1338560
     /* 1338560 */   GIM_Try, /*On fail goto*//*Label 19130*/ GIMT_Encode4(1338644), // Rule ID 20074 //
     /* 1338565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1338582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1338585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338618 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338643 */     // GIR_Coverage, 20074,
     /* 1338643 */     GIR_EraseRootFromParent_Done,
     /* 1338644 */   // Label 19130: @1338644
     /* 1338644 */   GIM_Try, /*On fail goto*//*Label 19131*/ GIMT_Encode4(1338728), // Rule ID 20075 //
     /* 1338649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1338666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1338669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338702 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338727 */     // GIR_Coverage, 20075,
     /* 1338727 */     GIR_EraseRootFromParent_Done,
     /* 1338728 */   // Label 19131: @1338728
     /* 1338728 */   GIM_Try, /*On fail goto*//*Label 19132*/ GIMT_Encode4(1338812), // Rule ID 20078 //
     /* 1338733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1338736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1338744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1338747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1338750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1338756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338786 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1338789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338811 */     // GIR_Coverage, 20078,
     /* 1338811 */     GIR_EraseRootFromParent_Done,
     /* 1338812 */   // Label 19132: @1338812
     /* 1338812 */   GIM_Try, /*On fail goto*//*Label 19133*/ GIMT_Encode4(1338896), // Rule ID 20079 //
     /* 1338817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1338820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1338828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1338831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1338834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1338840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338870 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1338873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338895 */     // GIR_Coverage, 20079,
     /* 1338895 */     GIR_EraseRootFromParent_Done,
     /* 1338896 */   // Label 19133: @1338896
     /* 1338896 */   GIM_Try, /*On fail goto*//*Label 19134*/ GIMT_Encode4(1338980), // Rule ID 20082 //
     /* 1338901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1338904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1338918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338954 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1338957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338979 */     // GIR_Coverage, 20082,
     /* 1338979 */     GIR_EraseRootFromParent_Done,
     /* 1338980 */   // Label 19134: @1338980
     /* 1338980 */   GIM_Try, /*On fail goto*//*Label 19135*/ GIMT_Encode4(1339064), // Rule ID 20083 //
     /* 1338985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1338988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1339002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339038 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1339041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339063 */     // GIR_Coverage, 20083,
     /* 1339063 */     GIR_EraseRootFromParent_Done,
     /* 1339064 */   // Label 19135: @1339064
     /* 1339064 */   GIM_Try, /*On fail goto*//*Label 19136*/ GIMT_Encode4(1339148), // Rule ID 20086 //
     /* 1339069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1339086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339122 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1339125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339147 */     // GIR_Coverage, 20086,
     /* 1339147 */     GIR_EraseRootFromParent_Done,
     /* 1339148 */   // Label 19136: @1339148
     /* 1339148 */   GIM_Try, /*On fail goto*//*Label 19137*/ GIMT_Encode4(1339232), // Rule ID 20087 //
     /* 1339153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1339170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339206 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1339209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339231 */     // GIR_Coverage, 20087,
     /* 1339231 */     GIR_EraseRootFromParent_Done,
     /* 1339232 */   // Label 19137: @1339232
     /* 1339232 */   GIM_Try, /*On fail goto*//*Label 19138*/ GIMT_Encode4(1339316), // Rule ID 20090 //
     /* 1339237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1339254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339290 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1339293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339315 */     // GIR_Coverage, 20090,
     /* 1339315 */     GIR_EraseRootFromParent_Done,
     /* 1339316 */   // Label 19138: @1339316
     /* 1339316 */   GIM_Try, /*On fail goto*//*Label 19139*/ GIMT_Encode4(1339400), // Rule ID 20091 //
     /* 1339321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1339338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339374 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1339377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339399 */     // GIR_Coverage, 20091,
     /* 1339399 */     GIR_EraseRootFromParent_Done,
     /* 1339400 */   // Label 19139: @1339400
     /* 1339400 */   GIM_Try, /*On fail goto*//*Label 19140*/ GIMT_Encode4(1339484), // Rule ID 20094 //
     /* 1339405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1339422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339458 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1339461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339483 */     // GIR_Coverage, 20094,
     /* 1339483 */     GIR_EraseRootFromParent_Done,
     /* 1339484 */   // Label 19140: @1339484
     /* 1339484 */   GIM_Try, /*On fail goto*//*Label 19141*/ GIMT_Encode4(1339568), // Rule ID 20095 //
     /* 1339489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1339506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339542 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1339545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339567 */     // GIR_Coverage, 20095,
     /* 1339567 */     GIR_EraseRootFromParent_Done,
     /* 1339568 */   // Label 19141: @1339568
     /* 1339568 */   GIM_Try, /*On fail goto*//*Label 19142*/ GIMT_Encode4(1339652), // Rule ID 20098 //
     /* 1339573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1339576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1339590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339626 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1339629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339651 */     // GIR_Coverage, 20098,
     /* 1339651 */     GIR_EraseRootFromParent_Done,
     /* 1339652 */   // Label 19142: @1339652
     /* 1339652 */   GIM_Try, /*On fail goto*//*Label 19143*/ GIMT_Encode4(1339736), // Rule ID 20099 //
     /* 1339657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1339660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1339674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339710 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1339713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339735 */     // GIR_Coverage, 20099,
     /* 1339735 */     GIR_EraseRootFromParent_Done,
     /* 1339736 */   // Label 19143: @1339736
     /* 1339736 */   GIM_Try, /*On fail goto*//*Label 19144*/ GIMT_Encode4(1339820), // Rule ID 20102 //
     /* 1339741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1339758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339794 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1339797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339819 */     // GIR_Coverage, 20102,
     /* 1339819 */     GIR_EraseRootFromParent_Done,
     /* 1339820 */   // Label 19144: @1339820
     /* 1339820 */   GIM_Try, /*On fail goto*//*Label 19145*/ GIMT_Encode4(1339904), // Rule ID 20103 //
     /* 1339825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1339842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339878 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1339881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339903 */     // GIR_Coverage, 20103,
     /* 1339903 */     GIR_EraseRootFromParent_Done,
     /* 1339904 */   // Label 19145: @1339904
     /* 1339904 */   GIM_Try, /*On fail goto*//*Label 19146*/ GIMT_Encode4(1339988), // Rule ID 20106 //
     /* 1339909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1339920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1339923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1339926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1339932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339962 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1339965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339987 */     // GIR_Coverage, 20106,
     /* 1339987 */     GIR_EraseRootFromParent_Done,
     /* 1339988 */   // Label 19146: @1339988
     /* 1339988 */   GIM_Try, /*On fail goto*//*Label 19147*/ GIMT_Encode4(1340072), // Rule ID 20107 //
     /* 1339993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1340010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340046 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1340049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340071 */     // GIR_Coverage, 20107,
     /* 1340071 */     GIR_EraseRootFromParent_Done,
     /* 1340072 */   // Label 19147: @1340072
     /* 1340072 */   GIM_Try, /*On fail goto*//*Label 19148*/ GIMT_Encode4(1340156), // Rule ID 20110 //
     /* 1340077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1340088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1340091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1340094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1340100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340130 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1340133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340155 */     // GIR_Coverage, 20110,
     /* 1340155 */     GIR_EraseRootFromParent_Done,
     /* 1340156 */   // Label 19148: @1340156
     /* 1340156 */   GIM_Try, /*On fail goto*//*Label 19149*/ GIMT_Encode4(1340240), // Rule ID 20111 //
     /* 1340161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1340172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1340175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1340178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1340184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340214 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1340217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340239 */     // GIR_Coverage, 20111,
     /* 1340239 */     GIR_EraseRootFromParent_Done,
     /* 1340240 */   // Label 19149: @1340240
     /* 1340240 */   GIM_Try, /*On fail goto*//*Label 19150*/ GIMT_Encode4(1340324), // Rule ID 20114 //
     /* 1340245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1340262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340298 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1340301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340323 */     // GIR_Coverage, 20114,
     /* 1340323 */     GIR_EraseRootFromParent_Done,
     /* 1340324 */   // Label 19150: @1340324
     /* 1340324 */   GIM_Try, /*On fail goto*//*Label 19151*/ GIMT_Encode4(1340408), // Rule ID 20115 //
     /* 1340329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1340346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340382 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1340385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340407 */     // GIR_Coverage, 20115,
     /* 1340407 */     GIR_EraseRootFromParent_Done,
     /* 1340408 */   // Label 19151: @1340408
     /* 1340408 */   GIM_Try, /*On fail goto*//*Label 19152*/ GIMT_Encode4(1340492), // Rule ID 20118 //
     /* 1340413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1340430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340466 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1340469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340491 */     // GIR_Coverage, 20118,
     /* 1340491 */     GIR_EraseRootFromParent_Done,
     /* 1340492 */   // Label 19152: @1340492
     /* 1340492 */   GIM_Try, /*On fail goto*//*Label 19153*/ GIMT_Encode4(1340576), // Rule ID 20119 //
     /* 1340497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1340514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340550 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1340553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340575 */     // GIR_Coverage, 20119,
     /* 1340575 */     GIR_EraseRootFromParent_Done,
     /* 1340576 */   // Label 19153: @1340576
     /* 1340576 */   GIM_Try, /*On fail goto*//*Label 19154*/ GIMT_Encode4(1340660), // Rule ID 20122 //
     /* 1340581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1340598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340634 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1340637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340659 */     // GIR_Coverage, 20122,
     /* 1340659 */     GIR_EraseRootFromParent_Done,
     /* 1340660 */   // Label 19154: @1340660
     /* 1340660 */   GIM_Try, /*On fail goto*//*Label 19155*/ GIMT_Encode4(1340744), // Rule ID 20123 //
     /* 1340665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1340682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340718 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1340721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340743 */     // GIR_Coverage, 20123,
     /* 1340743 */     GIR_EraseRootFromParent_Done,
     /* 1340744 */   // Label 19155: @1340744
     /* 1340744 */   GIM_Try, /*On fail goto*//*Label 19156*/ GIMT_Encode4(1340828), // Rule ID 20126 //
     /* 1340749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1340752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1340760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1340763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1340766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1340772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1340791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340802 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1340805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340827 */     // GIR_Coverage, 20126,
     /* 1340827 */     GIR_EraseRootFromParent_Done,
     /* 1340828 */   // Label 19156: @1340828
     /* 1340828 */   GIM_Try, /*On fail goto*//*Label 19157*/ GIMT_Encode4(1340912), // Rule ID 20127 //
     /* 1340833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1340836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1340844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1340847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1340850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1340856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1340875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340886 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1340889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340911 */     // GIR_Coverage, 20127,
     /* 1340911 */     GIR_EraseRootFromParent_Done,
     /* 1340912 */   // Label 19157: @1340912
     /* 1340912 */   GIM_Try, /*On fail goto*//*Label 19158*/ GIMT_Encode4(1340996), // Rule ID 20130 //
     /* 1340917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1340920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1340934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1340959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340970 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1340973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340995 */     // GIR_Coverage, 20130,
     /* 1340995 */     GIR_EraseRootFromParent_Done,
     /* 1340996 */   // Label 19158: @1340996
     /* 1340996 */   GIM_Try, /*On fail goto*//*Label 19159*/ GIMT_Encode4(1341080), // Rule ID 20131 //
     /* 1341001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1341018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341054 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1341057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341079 */     // GIR_Coverage, 20131,
     /* 1341079 */     GIR_EraseRootFromParent_Done,
     /* 1341080 */   // Label 19159: @1341080
     /* 1341080 */   GIM_Try, /*On fail goto*//*Label 19160*/ GIMT_Encode4(1341164), // Rule ID 20134 //
     /* 1341085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1341088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1341102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341138 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1341141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341163 */     // GIR_Coverage, 20134,
     /* 1341163 */     GIR_EraseRootFromParent_Done,
     /* 1341164 */   // Label 19160: @1341164
     /* 1341164 */   GIM_Try, /*On fail goto*//*Label 19161*/ GIMT_Encode4(1341248), // Rule ID 20135 //
     /* 1341169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1341186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341222 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1341225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341247 */     // GIR_Coverage, 20135,
     /* 1341247 */     GIR_EraseRootFromParent_Done,
     /* 1341248 */   // Label 19161: @1341248
     /* 1341248 */   GIM_Try, /*On fail goto*//*Label 19162*/ GIMT_Encode4(1341332), // Rule ID 20138 //
     /* 1341253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1341270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1341273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341306 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1341309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341331 */     // GIR_Coverage, 20138,
     /* 1341331 */     GIR_EraseRootFromParent_Done,
     /* 1341332 */   // Label 19162: @1341332
     /* 1341332 */   GIM_Try, /*On fail goto*//*Label 19163*/ GIMT_Encode4(1341416), // Rule ID 20139 //
     /* 1341337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1341354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1341357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341390 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1341393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341415 */     // GIR_Coverage, 20139,
     /* 1341415 */     GIR_EraseRootFromParent_Done,
     /* 1341416 */   // Label 19163: @1341416
     /* 1341416 */   GIM_Try, /*On fail goto*//*Label 19164*/ GIMT_Encode4(1341500), // Rule ID 20142 //
     /* 1341421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1341438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1341441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341474 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1341477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341499 */     // GIR_Coverage, 20142,
     /* 1341499 */     GIR_EraseRootFromParent_Done,
     /* 1341500 */   // Label 19164: @1341500
     /* 1341500 */   GIM_Try, /*On fail goto*//*Label 19165*/ GIMT_Encode4(1341584), // Rule ID 20143 //
     /* 1341505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1341522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1341525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341558 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1341561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341583 */     // GIR_Coverage, 20143,
     /* 1341583 */     GIR_EraseRootFromParent_Done,
     /* 1341584 */   // Label 19165: @1341584
     /* 1341584 */   GIM_Try, /*On fail goto*//*Label 19166*/ GIMT_Encode4(1341668), // Rule ID 20146 //
     /* 1341589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1341592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1341606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1341609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341642 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1341645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341667 */     // GIR_Coverage, 20146,
     /* 1341667 */     GIR_EraseRootFromParent_Done,
     /* 1341668 */   // Label 19166: @1341668
     /* 1341668 */   GIM_Try, /*On fail goto*//*Label 19167*/ GIMT_Encode4(1341752), // Rule ID 20147 //
     /* 1341673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1341676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1341690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1341693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341726 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1341729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341751 */     // GIR_Coverage, 20147,
     /* 1341751 */     GIR_EraseRootFromParent_Done,
     /* 1341752 */   // Label 19167: @1341752
     /* 1341752 */   GIM_Try, /*On fail goto*//*Label 19168*/ GIMT_Encode4(1341836), // Rule ID 20150 //
     /* 1341757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1341774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1341777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341810 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1341813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341835 */     // GIR_Coverage, 20150,
     /* 1341835 */     GIR_EraseRootFromParent_Done,
     /* 1341836 */   // Label 19168: @1341836
     /* 1341836 */   GIM_Try, /*On fail goto*//*Label 19169*/ GIMT_Encode4(1341920), // Rule ID 20151 //
     /* 1341841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1341858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1341861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341894 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1341897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341919 */     // GIR_Coverage, 20151,
     /* 1341919 */     GIR_EraseRootFromParent_Done,
     /* 1341920 */   // Label 19169: @1341920
     /* 1341920 */   GIM_Try, /*On fail goto*//*Label 19170*/ GIMT_Encode4(1342004), // Rule ID 20154 //
     /* 1341925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1341928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1341942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1341945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341978 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1341981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342003 */     // GIR_Coverage, 20154,
     /* 1342003 */     GIR_EraseRootFromParent_Done,
     /* 1342004 */   // Label 19170: @1342004
     /* 1342004 */   GIM_Try, /*On fail goto*//*Label 19171*/ GIMT_Encode4(1342088), // Rule ID 20155 //
     /* 1342009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1342012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1342026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1342029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342062 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342087 */     // GIR_Coverage, 20155,
     /* 1342087 */     GIR_EraseRootFromParent_Done,
     /* 1342088 */   // Label 19171: @1342088
     /* 1342088 */   GIM_Try, /*On fail goto*//*Label 19172*/ GIMT_Encode4(1342172), // Rule ID 20158 //
     /* 1342093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1342096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1342110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1342113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342146 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342171 */     // GIR_Coverage, 20158,
     /* 1342171 */     GIR_EraseRootFromParent_Done,
     /* 1342172 */   // Label 19172: @1342172
     /* 1342172 */   GIM_Try, /*On fail goto*//*Label 19173*/ GIMT_Encode4(1342256), // Rule ID 20159 //
     /* 1342177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1342180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1342194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1342197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342230 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342255 */     // GIR_Coverage, 20159,
     /* 1342255 */     GIR_EraseRootFromParent_Done,
     /* 1342256 */   // Label 19173: @1342256
     /* 1342256 */   GIM_Try, /*On fail goto*//*Label 19174*/ GIMT_Encode4(1342340), // Rule ID 20162 //
     /* 1342261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1342278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1342281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342314 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1342317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342339 */     // GIR_Coverage, 20162,
     /* 1342339 */     GIR_EraseRootFromParent_Done,
     /* 1342340 */   // Label 19174: @1342340
     /* 1342340 */   GIM_Try, /*On fail goto*//*Label 19175*/ GIMT_Encode4(1342424), // Rule ID 20163 //
     /* 1342345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1342362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1342365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342398 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1342401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342423 */     // GIR_Coverage, 20163,
     /* 1342423 */     GIR_EraseRootFromParent_Done,
     /* 1342424 */   // Label 19175: @1342424
     /* 1342424 */   GIM_Try, /*On fail goto*//*Label 19176*/ GIMT_Encode4(1342508), // Rule ID 20166 //
     /* 1342429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1342440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1342443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1342446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1342449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342482 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1342485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342507 */     // GIR_Coverage, 20166,
     /* 1342507 */     GIR_EraseRootFromParent_Done,
     /* 1342508 */   // Label 19176: @1342508
     /* 1342508 */   GIM_Try, /*On fail goto*//*Label 19177*/ GIMT_Encode4(1342592), // Rule ID 20167 //
     /* 1342513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1342524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1342527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1342530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1342533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342566 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1342569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342591 */     // GIR_Coverage, 20167,
     /* 1342591 */     GIR_EraseRootFromParent_Done,
     /* 1342592 */   // Label 19177: @1342592
     /* 1342592 */   GIM_Try, /*On fail goto*//*Label 19178*/ GIMT_Encode4(1342676), // Rule ID 20170 //
     /* 1342597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1342608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1342611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1342614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1342617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1342620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342650 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1342653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342675 */     // GIR_Coverage, 20170,
     /* 1342675 */     GIR_EraseRootFromParent_Done,
     /* 1342676 */   // Label 19178: @1342676
     /* 1342676 */   GIM_Try, /*On fail goto*//*Label 19179*/ GIMT_Encode4(1342760), // Rule ID 20171 //
     /* 1342681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1342692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1342695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1342698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1342701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1342704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342734 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1342737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342759 */     // GIR_Coverage, 20171,
     /* 1342759 */     GIR_EraseRootFromParent_Done,
     /* 1342760 */   // Label 19179: @1342760
     /* 1342760 */   GIM_Try, /*On fail goto*//*Label 19180*/ GIMT_Encode4(1342844), // Rule ID 20174 //
     /* 1342765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1342768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1342782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1342785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342818 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1342821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342843 */     // GIR_Coverage, 20174,
     /* 1342843 */     GIR_EraseRootFromParent_Done,
     /* 1342844 */   // Label 19180: @1342844
     /* 1342844 */   GIM_Try, /*On fail goto*//*Label 19181*/ GIMT_Encode4(1342928), // Rule ID 20175 //
     /* 1342849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1342852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1342866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1342869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342902 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1342905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342927 */     // GIR_Coverage, 20175,
     /* 1342927 */     GIR_EraseRootFromParent_Done,
     /* 1342928 */   // Label 19181: @1342928
     /* 1342928 */   GIM_Try, /*On fail goto*//*Label 19182*/ GIMT_Encode4(1343012), // Rule ID 20178 //
     /* 1342933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1342936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1342950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1342953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342986 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1342989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343011 */     // GIR_Coverage, 20178,
     /* 1343011 */     GIR_EraseRootFromParent_Done,
     /* 1343012 */   // Label 19182: @1343012
     /* 1343012 */   GIM_Try, /*On fail goto*//*Label 19183*/ GIMT_Encode4(1343096), // Rule ID 20179 //
     /* 1343017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1343034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1343037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343070 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343095 */     // GIR_Coverage, 20179,
     /* 1343095 */     GIR_EraseRootFromParent_Done,
     /* 1343096 */   // Label 19183: @1343096
     /* 1343096 */   GIM_Try, /*On fail goto*//*Label 19184*/ GIMT_Encode4(1343180), // Rule ID 20182 //
     /* 1343101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1343118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1343121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343154 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343179 */     // GIR_Coverage, 20182,
     /* 1343179 */     GIR_EraseRootFromParent_Done,
     /* 1343180 */   // Label 19184: @1343180
     /* 1343180 */   GIM_Try, /*On fail goto*//*Label 19185*/ GIMT_Encode4(1343264), // Rule ID 20183 //
     /* 1343185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1343202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1343205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343238 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343263 */     // GIR_Coverage, 20183,
     /* 1343263 */     GIR_EraseRootFromParent_Done,
     /* 1343264 */   // Label 19185: @1343264
     /* 1343264 */   GIM_Try, /*On fail goto*//*Label 19186*/ GIMT_Encode4(1343348), // Rule ID 20186 //
     /* 1343269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1343286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1343289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343322 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1343325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343347 */     // GIR_Coverage, 20186,
     /* 1343347 */     GIR_EraseRootFromParent_Done,
     /* 1343348 */   // Label 19186: @1343348
     /* 1343348 */   GIM_Try, /*On fail goto*//*Label 19187*/ GIMT_Encode4(1343432), // Rule ID 20187 //
     /* 1343353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1343370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1343373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343406 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1343409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343431 */     // GIR_Coverage, 20187,
     /* 1343431 */     GIR_EraseRootFromParent_Done,
     /* 1343432 */   // Label 19187: @1343432
     /* 1343432 */   GIM_Try, /*On fail goto*//*Label 19188*/ GIMT_Encode4(1343516), // Rule ID 20190 //
     /* 1343437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1343454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1343457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343490 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343515 */     // GIR_Coverage, 20190,
     /* 1343515 */     GIR_EraseRootFromParent_Done,
     /* 1343516 */   // Label 19188: @1343516
     /* 1343516 */   GIM_Try, /*On fail goto*//*Label 19189*/ GIMT_Encode4(1343600), // Rule ID 20191 //
     /* 1343521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1343538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1343541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343574 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343599 */     // GIR_Coverage, 20191,
     /* 1343599 */     GIR_EraseRootFromParent_Done,
     /* 1343600 */   // Label 19189: @1343600
     /* 1343600 */   GIM_Try, /*On fail goto*//*Label 19190*/ GIMT_Encode4(1343684), // Rule ID 20194 //
     /* 1343605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1343622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1343625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343658 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343683 */     // GIR_Coverage, 20194,
     /* 1343683 */     GIR_EraseRootFromParent_Done,
     /* 1343684 */   // Label 19190: @1343684
     /* 1343684 */   GIM_Try, /*On fail goto*//*Label 19191*/ GIMT_Encode4(1343768), // Rule ID 20195 //
     /* 1343689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1343706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1343709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343742 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343767 */     // GIR_Coverage, 20195,
     /* 1343767 */     GIR_EraseRootFromParent_Done,
     /* 1343768 */   // Label 19191: @1343768
     /* 1343768 */   GIM_Try, /*On fail goto*//*Label 19192*/ GIMT_Encode4(1343852), // Rule ID 20198 //
     /* 1343773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1343776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1343784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1343787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1343790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1343796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343826 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1343829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343851 */     // GIR_Coverage, 20198,
     /* 1343851 */     GIR_EraseRootFromParent_Done,
     /* 1343852 */   // Label 19192: @1343852
     /* 1343852 */   GIM_Try, /*On fail goto*//*Label 19193*/ GIMT_Encode4(1343936), // Rule ID 20199 //
     /* 1343857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1343860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1343868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1343871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1343874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1343880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343910 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1343913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343935 */     // GIR_Coverage, 20199,
     /* 1343935 */     GIR_EraseRootFromParent_Done,
     /* 1343936 */   // Label 19193: @1343936
     /* 1343936 */   GIM_Try, /*On fail goto*//*Label 19194*/ GIMT_Encode4(1344020), // Rule ID 20202 //
     /* 1343941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1343944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1343958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343994 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1343997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344019 */     // GIR_Coverage, 20202,
     /* 1344019 */     GIR_EraseRootFromParent_Done,
     /* 1344020 */   // Label 19194: @1344020
     /* 1344020 */   GIM_Try, /*On fail goto*//*Label 19195*/ GIMT_Encode4(1344104), // Rule ID 20203 //
     /* 1344025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1344042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344078 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1344081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344103 */     // GIR_Coverage, 20203,
     /* 1344103 */     GIR_EraseRootFromParent_Done,
     /* 1344104 */   // Label 19195: @1344104
     /* 1344104 */   GIM_Try, /*On fail goto*//*Label 19196*/ GIMT_Encode4(1344188), // Rule ID 20206 //
     /* 1344109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1344126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344162 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1344165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344187 */     // GIR_Coverage, 20206,
     /* 1344187 */     GIR_EraseRootFromParent_Done,
     /* 1344188 */   // Label 19196: @1344188
     /* 1344188 */   GIM_Try, /*On fail goto*//*Label 19197*/ GIMT_Encode4(1344272), // Rule ID 20207 //
     /* 1344193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1344210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344246 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1344249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344271 */     // GIR_Coverage, 20207,
     /* 1344271 */     GIR_EraseRootFromParent_Done,
     /* 1344272 */   // Label 19197: @1344272
     /* 1344272 */   GIM_Try, /*On fail goto*//*Label 19198*/ GIMT_Encode4(1344356), // Rule ID 20210 //
     /* 1344277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1344294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344330 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1344333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344355 */     // GIR_Coverage, 20210,
     /* 1344355 */     GIR_EraseRootFromParent_Done,
     /* 1344356 */   // Label 19198: @1344356
     /* 1344356 */   GIM_Try, /*On fail goto*//*Label 19199*/ GIMT_Encode4(1344440), // Rule ID 20211 //
     /* 1344361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1344378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344414 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1344417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344439 */     // GIR_Coverage, 20211,
     /* 1344439 */     GIR_EraseRootFromParent_Done,
     /* 1344440 */   // Label 19199: @1344440
     /* 1344440 */   GIM_Try, /*On fail goto*//*Label 19200*/ GIMT_Encode4(1344524), // Rule ID 20214 //
     /* 1344445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1344462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344498 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1344501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344523 */     // GIR_Coverage, 20214,
     /* 1344523 */     GIR_EraseRootFromParent_Done,
     /* 1344524 */   // Label 19200: @1344524
     /* 1344524 */   GIM_Try, /*On fail goto*//*Label 19201*/ GIMT_Encode4(1344608), // Rule ID 20215 //
     /* 1344529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1344546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344582 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1344585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344607 */     // GIR_Coverage, 20215,
     /* 1344607 */     GIR_EraseRootFromParent_Done,
     /* 1344608 */   // Label 19201: @1344608
     /* 1344608 */   GIM_Try, /*On fail goto*//*Label 19202*/ GIMT_Encode4(1344692), // Rule ID 20218 //
     /* 1344613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1344616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1344630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344666 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1344669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344691 */     // GIR_Coverage, 20218,
     /* 1344691 */     GIR_EraseRootFromParent_Done,
     /* 1344692 */   // Label 19202: @1344692
     /* 1344692 */   GIM_Try, /*On fail goto*//*Label 19203*/ GIMT_Encode4(1344776), // Rule ID 20219 //
     /* 1344697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1344700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1344714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344750 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1344753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344775 */     // GIR_Coverage, 20219,
     /* 1344775 */     GIR_EraseRootFromParent_Done,
     /* 1344776 */   // Label 19203: @1344776
     /* 1344776 */   GIM_Try, /*On fail goto*//*Label 19204*/ GIMT_Encode4(1344860), // Rule ID 20222 //
     /* 1344781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1344792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1344795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1344798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1344819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344834 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1344837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344859 */     // GIR_Coverage, 20222,
     /* 1344859 */     GIR_EraseRootFromParent_Done,
     /* 1344860 */   // Label 19204: @1344860
     /* 1344860 */   GIM_Try, /*On fail goto*//*Label 19205*/ GIMT_Encode4(1344944), // Rule ID 20223 //
     /* 1344865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1344876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1344879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1344882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1344903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344918 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1344921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344943 */     // GIR_Coverage, 20223,
     /* 1344943 */     GIR_EraseRootFromParent_Done,
     /* 1344944 */   // Label 19205: @1344944
     /* 1344944 */   GIM_Try, /*On fail goto*//*Label 19206*/ GIMT_Encode4(1345028), // Rule ID 20226 //
     /* 1344949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1344960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1344963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1344966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1344972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345002 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1345005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345027 */     // GIR_Coverage, 20226,
     /* 1345027 */     GIR_EraseRootFromParent_Done,
     /* 1345028 */   // Label 19206: @1345028
     /* 1345028 */   GIM_Try, /*On fail goto*//*Label 19207*/ GIMT_Encode4(1345112), // Rule ID 20227 //
     /* 1345033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1345050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345086 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1345089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345111 */     // GIR_Coverage, 20227,
     /* 1345111 */     GIR_EraseRootFromParent_Done,
     /* 1345112 */   // Label 19207: @1345112
     /* 1345112 */   GIM_Try, /*On fail goto*//*Label 19208*/ GIMT_Encode4(1345196), // Rule ID 20230 //
     /* 1345117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1345128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1345131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1345134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1345140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345170 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1345173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345195 */     // GIR_Coverage, 20230,
     /* 1345195 */     GIR_EraseRootFromParent_Done,
     /* 1345196 */   // Label 19208: @1345196
     /* 1345196 */   GIM_Try, /*On fail goto*//*Label 19209*/ GIMT_Encode4(1345280), // Rule ID 20231 //
     /* 1345201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1345212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1345215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1345218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1345224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345254 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1345257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345279 */     // GIR_Coverage, 20231,
     /* 1345279 */     GIR_EraseRootFromParent_Done,
     /* 1345280 */   // Label 19209: @1345280
     /* 1345280 */   GIM_Try, /*On fail goto*//*Label 19210*/ GIMT_Encode4(1345364), // Rule ID 20234 //
     /* 1345285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1345302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345338 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1345341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345363 */     // GIR_Coverage, 20234,
     /* 1345363 */     GIR_EraseRootFromParent_Done,
     /* 1345364 */   // Label 19210: @1345364
     /* 1345364 */   GIM_Try, /*On fail goto*//*Label 19211*/ GIMT_Encode4(1345448), // Rule ID 20235 //
     /* 1345369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1345386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345422 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1345425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345447 */     // GIR_Coverage, 20235,
     /* 1345447 */     GIR_EraseRootFromParent_Done,
     /* 1345448 */   // Label 19211: @1345448
     /* 1345448 */   GIM_Try, /*On fail goto*//*Label 19212*/ GIMT_Encode4(1345532), // Rule ID 20238 //
     /* 1345453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1345470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345506 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1345509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345531 */     // GIR_Coverage, 20238,
     /* 1345531 */     GIR_EraseRootFromParent_Done,
     /* 1345532 */   // Label 19212: @1345532
     /* 1345532 */   GIM_Try, /*On fail goto*//*Label 19213*/ GIMT_Encode4(1345616), // Rule ID 20239 //
     /* 1345537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1345554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345590 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1345593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345615 */     // GIR_Coverage, 20239,
     /* 1345615 */     GIR_EraseRootFromParent_Done,
     /* 1345616 */   // Label 19213: @1345616
     /* 1345616 */   GIM_Try, /*On fail goto*//*Label 19214*/ GIMT_Encode4(1345700), // Rule ID 20242 //
     /* 1345621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1345638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345674 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1345677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345699 */     // GIR_Coverage, 20242,
     /* 1345699 */     GIR_EraseRootFromParent_Done,
     /* 1345700 */   // Label 19214: @1345700
     /* 1345700 */   GIM_Try, /*On fail goto*//*Label 19215*/ GIMT_Encode4(1345784), // Rule ID 20243 //
     /* 1345705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1345722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345758 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1345761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345783 */     // GIR_Coverage, 20243,
     /* 1345783 */     GIR_EraseRootFromParent_Done,
     /* 1345784 */   // Label 19215: @1345784
     /* 1345784 */   GIM_Try, /*On fail goto*//*Label 19216*/ GIMT_Encode4(1345868), // Rule ID 20246 //
     /* 1345789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1345792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1345800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1345803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1345806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1345831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345842 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1345845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1345863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345867 */     // GIR_Coverage, 20246,
     /* 1345867 */     GIR_EraseRootFromParent_Done,
     /* 1345868 */   // Label 19216: @1345868
     /* 1345868 */   GIM_Try, /*On fail goto*//*Label 19217*/ GIMT_Encode4(1345952), // Rule ID 20247 //
     /* 1345873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1345876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1345884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1345887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1345890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1345915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345926 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1345929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1345947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345951 */     // GIR_Coverage, 20247,
     /* 1345951 */     GIR_EraseRootFromParent_Done,
     /* 1345952 */   // Label 19217: @1345952
     /* 1345952 */   GIM_Try, /*On fail goto*//*Label 19218*/ GIMT_Encode4(1346036), // Rule ID 20250 //
     /* 1345957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1345960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1345974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1345999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346010 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1346013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346035 */     // GIR_Coverage, 20250,
     /* 1346035 */     GIR_EraseRootFromParent_Done,
     /* 1346036 */   // Label 19218: @1346036
     /* 1346036 */   GIM_Try, /*On fail goto*//*Label 19219*/ GIMT_Encode4(1346120), // Rule ID 20251 //
     /* 1346041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1346058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346094 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1346097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346119 */     // GIR_Coverage, 20251,
     /* 1346119 */     GIR_EraseRootFromParent_Done,
     /* 1346120 */   // Label 19219: @1346120
     /* 1346120 */   GIM_Try, /*On fail goto*//*Label 19220*/ GIMT_Encode4(1346204), // Rule ID 20254 //
     /* 1346125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1346128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1346142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346178 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1346181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346203 */     // GIR_Coverage, 20254,
     /* 1346203 */     GIR_EraseRootFromParent_Done,
     /* 1346204 */   // Label 19220: @1346204
     /* 1346204 */   GIM_Try, /*On fail goto*//*Label 19221*/ GIMT_Encode4(1346288), // Rule ID 20255 //
     /* 1346209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1346226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346262 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1346265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346287 */     // GIR_Coverage, 20255,
     /* 1346287 */     GIR_EraseRootFromParent_Done,
     /* 1346288 */   // Label 19221: @1346288
     /* 1346288 */   GIM_Try, /*On fail goto*//*Label 19222*/ GIMT_Encode4(1346372), // Rule ID 20258 //
     /* 1346293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1346310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346346 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1346349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346371 */     // GIR_Coverage, 20258,
     /* 1346371 */     GIR_EraseRootFromParent_Done,
     /* 1346372 */   // Label 19222: @1346372
     /* 1346372 */   GIM_Try, /*On fail goto*//*Label 19223*/ GIMT_Encode4(1346456), // Rule ID 20259 //
     /* 1346377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1346394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346430 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1346433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346455 */     // GIR_Coverage, 20259,
     /* 1346455 */     GIR_EraseRootFromParent_Done,
     /* 1346456 */   // Label 19223: @1346456
     /* 1346456 */   GIM_Try, /*On fail goto*//*Label 19224*/ GIMT_Encode4(1346540), // Rule ID 20262 //
     /* 1346461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1346478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346514 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1346517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346539 */     // GIR_Coverage, 20262,
     /* 1346539 */     GIR_EraseRootFromParent_Done,
     /* 1346540 */   // Label 19224: @1346540
     /* 1346540 */   GIM_Try, /*On fail goto*//*Label 19225*/ GIMT_Encode4(1346624), // Rule ID 20263 //
     /* 1346545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1346562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346598 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1346601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346623 */     // GIR_Coverage, 20263,
     /* 1346623 */     GIR_EraseRootFromParent_Done,
     /* 1346624 */   // Label 19225: @1346624
     /* 1346624 */   GIM_Try, /*On fail goto*//*Label 19226*/ GIMT_Encode4(1346708), // Rule ID 20266 //
     /* 1346629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1346632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1346646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1346671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346682 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1346685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346707 */     // GIR_Coverage, 20266,
     /* 1346707 */     GIR_EraseRootFromParent_Done,
     /* 1346708 */   // Label 19226: @1346708
     /* 1346708 */   GIM_Try, /*On fail goto*//*Label 19227*/ GIMT_Encode4(1346792), // Rule ID 20267 //
     /* 1346713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1346716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1346730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1346755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346766 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1346769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346791 */     // GIR_Coverage, 20267,
     /* 1346791 */     GIR_EraseRootFromParent_Done,
     /* 1346792 */   // Label 19227: @1346792
     /* 1346792 */   GIM_Try, /*On fail goto*//*Label 19228*/ GIMT_Encode4(1346876), // Rule ID 20270 //
     /* 1346797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1346814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346850 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1346853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346875 */     // GIR_Coverage, 20270,
     /* 1346875 */     GIR_EraseRootFromParent_Done,
     /* 1346876 */   // Label 19228: @1346876
     /* 1346876 */   GIM_Try, /*On fail goto*//*Label 19229*/ GIMT_Encode4(1346960), // Rule ID 20271 //
     /* 1346881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1346898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346934 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1346937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346959 */     // GIR_Coverage, 20271,
     /* 1346959 */     GIR_EraseRootFromParent_Done,
     /* 1346960 */   // Label 19229: @1346960
     /* 1346960 */   GIM_Try, /*On fail goto*//*Label 19230*/ GIMT_Encode4(1347044), // Rule ID 20274 //
     /* 1346965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1346968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1346982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347018 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1347021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347043 */     // GIR_Coverage, 20274,
     /* 1347043 */     GIR_EraseRootFromParent_Done,
     /* 1347044 */   // Label 19230: @1347044
     /* 1347044 */   GIM_Try, /*On fail goto*//*Label 19231*/ GIMT_Encode4(1347128), // Rule ID 20275 //
     /* 1347049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1347052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1347066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347102 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1347105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347127 */     // GIR_Coverage, 20275,
     /* 1347127 */     GIR_EraseRootFromParent_Done,
     /* 1347128 */   // Label 19231: @1347128
     /* 1347128 */   GIM_Try, /*On fail goto*//*Label 19232*/ GIMT_Encode4(1347212), // Rule ID 20278 //
     /* 1347133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1347136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1347150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1347175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347186 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1347189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347211 */     // GIR_Coverage, 20278,
     /* 1347211 */     GIR_EraseRootFromParent_Done,
     /* 1347212 */   // Label 19232: @1347212
     /* 1347212 */   GIM_Try, /*On fail goto*//*Label 19233*/ GIMT_Encode4(1347296), // Rule ID 20279 //
     /* 1347217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1347220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1347234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1347259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347270 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1347273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347295 */     // GIR_Coverage, 20279,
     /* 1347295 */     GIR_EraseRootFromParent_Done,
     /* 1347296 */   // Label 19233: @1347296
     /* 1347296 */   GIM_Try, /*On fail goto*//*Label 19234*/ GIMT_Encode4(1347380), // Rule ID 20282 //
     /* 1347301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1347318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347354 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1347357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347379 */     // GIR_Coverage, 20282,
     /* 1347379 */     GIR_EraseRootFromParent_Done,
     /* 1347380 */   // Label 19234: @1347380
     /* 1347380 */   GIM_Try, /*On fail goto*//*Label 19235*/ GIMT_Encode4(1347464), // Rule ID 20283 //
     /* 1347385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1347402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347438 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1347441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347463 */     // GIR_Coverage, 20283,
     /* 1347463 */     GIR_EraseRootFromParent_Done,
     /* 1347464 */   // Label 19235: @1347464
     /* 1347464 */   GIM_Try, /*On fail goto*//*Label 19236*/ GIMT_Encode4(1347548), // Rule ID 20286 //
     /* 1347469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1347480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1347483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1347486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1347492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347522 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1347525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347547 */     // GIR_Coverage, 20286,
     /* 1347547 */     GIR_EraseRootFromParent_Done,
     /* 1347548 */   // Label 19236: @1347548
     /* 1347548 */   GIM_Try, /*On fail goto*//*Label 19237*/ GIMT_Encode4(1347632), // Rule ID 20287 //
     /* 1347553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1347564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1347567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1347570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1347576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347606 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1347609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347631 */     // GIR_Coverage, 20287,
     /* 1347631 */     GIR_EraseRootFromParent_Done,
     /* 1347632 */   // Label 19237: @1347632
     /* 1347632 */   GIM_Try, /*On fail goto*//*Label 19238*/ GIMT_Encode4(1347716), // Rule ID 20290 //
     /* 1347637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1347648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1347651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1347654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1347660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347690 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1347693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347715 */     // GIR_Coverage, 20290,
     /* 1347715 */     GIR_EraseRootFromParent_Done,
     /* 1347716 */   // Label 19238: @1347716
     /* 1347716 */   GIM_Try, /*On fail goto*//*Label 19239*/ GIMT_Encode4(1347800), // Rule ID 20291 //
     /* 1347721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1347732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1347735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1347738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1347744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347774 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1347777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347799 */     // GIR_Coverage, 20291,
     /* 1347799 */     GIR_EraseRootFromParent_Done,
     /* 1347800 */   // Label 19239: @1347800
     /* 1347800 */   GIM_Try, /*On fail goto*//*Label 19240*/ GIMT_Encode4(1347884), // Rule ID 20294 //
     /* 1347805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1347808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1347822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347858 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1347861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347883 */     // GIR_Coverage, 20294,
     /* 1347883 */     GIR_EraseRootFromParent_Done,
     /* 1347884 */   // Label 19240: @1347884
     /* 1347884 */   GIM_Try, /*On fail goto*//*Label 19241*/ GIMT_Encode4(1347968), // Rule ID 20295 //
     /* 1347889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1347892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1347906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347942 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1347945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347967 */     // GIR_Coverage, 20295,
     /* 1347967 */     GIR_EraseRootFromParent_Done,
     /* 1347968 */   // Label 19241: @1347968
     /* 1347968 */   GIM_Try, /*On fail goto*//*Label 19242*/ GIMT_Encode4(1348052), // Rule ID 20298 //
     /* 1347973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1347976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1347990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348026 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1348029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348051 */     // GIR_Coverage, 20298,
     /* 1348051 */     GIR_EraseRootFromParent_Done,
     /* 1348052 */   // Label 19242: @1348052
     /* 1348052 */   GIM_Try, /*On fail goto*//*Label 19243*/ GIMT_Encode4(1348136), // Rule ID 20299 //
     /* 1348057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1348074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348110 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1348113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348135 */     // GIR_Coverage, 20299,
     /* 1348135 */     GIR_EraseRootFromParent_Done,
     /* 1348136 */   // Label 19243: @1348136
     /* 1348136 */   GIM_Try, /*On fail goto*//*Label 19244*/ GIMT_Encode4(1348220), // Rule ID 20302 //
     /* 1348141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1348158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348194 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1348197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348219 */     // GIR_Coverage, 20302,
     /* 1348219 */     GIR_EraseRootFromParent_Done,
     /* 1348220 */   // Label 19244: @1348220
     /* 1348220 */   GIM_Try, /*On fail goto*//*Label 19245*/ GIMT_Encode4(1348304), // Rule ID 20303 //
     /* 1348225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1348242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348278 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1348281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348303 */     // GIR_Coverage, 20303,
     /* 1348303 */     GIR_EraseRootFromParent_Done,
     /* 1348304 */   // Label 19245: @1348304
     /* 1348304 */   GIM_Try, /*On fail goto*//*Label 19246*/ GIMT_Encode4(1348388), // Rule ID 20306 //
     /* 1348309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1348326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348362 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1348365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348387 */     // GIR_Coverage, 20306,
     /* 1348387 */     GIR_EraseRootFromParent_Done,
     /* 1348388 */   // Label 19246: @1348388
     /* 1348388 */   GIM_Try, /*On fail goto*//*Label 19247*/ GIMT_Encode4(1348472), // Rule ID 20307 //
     /* 1348393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1348396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1348410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1348449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348471 */     // GIR_Coverage, 20307,
     /* 1348471 */     GIR_EraseRootFromParent_Done,
     /* 1348472 */   // Label 19247: @1348472
     /* 1348472 */   GIM_Try, /*On fail goto*//*Label 19248*/ GIMT_Encode4(1348556), // Rule ID 20310 //
     /* 1348477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1348494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348530 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1348533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348555 */     // GIR_Coverage, 20310,
     /* 1348555 */     GIR_EraseRootFromParent_Done,
     /* 1348556 */   // Label 19248: @1348556
     /* 1348556 */   GIM_Try, /*On fail goto*//*Label 19249*/ GIMT_Encode4(1348640), // Rule ID 20311 //
     /* 1348561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1348564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1348578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348614 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1348617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348639 */     // GIR_Coverage, 20311,
     /* 1348639 */     GIR_EraseRootFromParent_Done,
     /* 1348640 */   // Label 19249: @1348640
     /* 1348640 */   GIM_Try, /*On fail goto*//*Label 19250*/ GIMT_Encode4(1348724), // Rule ID 20314 //
     /* 1348645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1348662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348698 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1348701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348723 */     // GIR_Coverage, 20314,
     /* 1348723 */     GIR_EraseRootFromParent_Done,
     /* 1348724 */   // Label 19250: @1348724
     /* 1348724 */   GIM_Try, /*On fail goto*//*Label 19251*/ GIMT_Encode4(1348808), // Rule ID 20315 //
     /* 1348729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1348732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1348746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1348785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348807 */     // GIR_Coverage, 20315,
     /* 1348807 */     GIR_EraseRootFromParent_Done,
     /* 1348808 */   // Label 19251: @1348808
     /* 1348808 */   GIM_Try, /*On fail goto*//*Label 19252*/ GIMT_Encode4(1348892), // Rule ID 20318 //
     /* 1348813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1348816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1348824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1348827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1348830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1348836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348866 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1348869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348891 */     // GIR_Coverage, 20318,
     /* 1348891 */     GIR_EraseRootFromParent_Done,
     /* 1348892 */   // Label 19252: @1348892
     /* 1348892 */   GIM_Try, /*On fail goto*//*Label 19253*/ GIMT_Encode4(1348976), // Rule ID 20319 //
     /* 1348897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1348900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1348908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1348911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1348914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1348920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348950 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1348953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348975 */     // GIR_Coverage, 20319,
     /* 1348975 */     GIR_EraseRootFromParent_Done,
     /* 1348976 */   // Label 19253: @1348976
     /* 1348976 */   GIM_Try, /*On fail goto*//*Label 19254*/ GIMT_Encode4(1349060), // Rule ID 20322 //
     /* 1348981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1348984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1348998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349034 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1349037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349059 */     // GIR_Coverage, 20322,
     /* 1349059 */     GIR_EraseRootFromParent_Done,
     /* 1349060 */   // Label 19254: @1349060
     /* 1349060 */   GIM_Try, /*On fail goto*//*Label 19255*/ GIMT_Encode4(1349144), // Rule ID 20323 //
     /* 1349065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1349082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349118 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1349121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349143 */     // GIR_Coverage, 20323,
     /* 1349143 */     GIR_EraseRootFromParent_Done,
     /* 1349144 */   // Label 19255: @1349144
     /* 1349144 */   GIM_Try, /*On fail goto*//*Label 19256*/ GIMT_Encode4(1349228), // Rule ID 20326 //
     /* 1349149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1349166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349202 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1349205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349227 */     // GIR_Coverage, 20326,
     /* 1349227 */     GIR_EraseRootFromParent_Done,
     /* 1349228 */   // Label 19256: @1349228
     /* 1349228 */   GIM_Try, /*On fail goto*//*Label 19257*/ GIMT_Encode4(1349312), // Rule ID 20327 //
     /* 1349233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1349236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1349250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349286 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1349289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349311 */     // GIR_Coverage, 20327,
     /* 1349311 */     GIR_EraseRootFromParent_Done,
     /* 1349312 */   // Label 19257: @1349312
     /* 1349312 */   GIM_Try, /*On fail goto*//*Label 19258*/ GIMT_Encode4(1349396), // Rule ID 20330 //
     /* 1349317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1349334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349370 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1349373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349395 */     // GIR_Coverage, 20330,
     /* 1349395 */     GIR_EraseRootFromParent_Done,
     /* 1349396 */   // Label 19258: @1349396
     /* 1349396 */   GIM_Try, /*On fail goto*//*Label 19259*/ GIMT_Encode4(1349480), // Rule ID 20331 //
     /* 1349401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1349418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349454 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1349457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349479 */     // GIR_Coverage, 20331,
     /* 1349479 */     GIR_EraseRootFromParent_Done,
     /* 1349480 */   // Label 19259: @1349480
     /* 1349480 */   GIM_Try, /*On fail goto*//*Label 19260*/ GIMT_Encode4(1349564), // Rule ID 20334 //
     /* 1349485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1349502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349538 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1349541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349563 */     // GIR_Coverage, 20334,
     /* 1349563 */     GIR_EraseRootFromParent_Done,
     /* 1349564 */   // Label 19260: @1349564
     /* 1349564 */   GIM_Try, /*On fail goto*//*Label 19261*/ GIMT_Encode4(1349648), // Rule ID 20335 //
     /* 1349569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1349572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1349586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349622 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1349625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349647 */     // GIR_Coverage, 20335,
     /* 1349647 */     GIR_EraseRootFromParent_Done,
     /* 1349648 */   // Label 19261: @1349648
     /* 1349648 */   GIM_Try, /*On fail goto*//*Label 19262*/ GIMT_Encode4(1349732), // Rule ID 20338 //
     /* 1349653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1349656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1349670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349706 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1349709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349731 */     // GIR_Coverage, 20338,
     /* 1349731 */     GIR_EraseRootFromParent_Done,
     /* 1349732 */   // Label 19262: @1349732
     /* 1349732 */   GIM_Try, /*On fail goto*//*Label 19263*/ GIMT_Encode4(1349816), // Rule ID 20339 //
     /* 1349737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1349740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1349754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349790 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1349793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349815 */     // GIR_Coverage, 20339,
     /* 1349815 */     GIR_EraseRootFromParent_Done,
     /* 1349816 */   // Label 19263: @1349816
     /* 1349816 */   GIM_Try, /*On fail goto*//*Label 19264*/ GIMT_Encode4(1349900), // Rule ID 20342 //
     /* 1349821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1349838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1349859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349874 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1349877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349899 */     // GIR_Coverage, 20342,
     /* 1349899 */     GIR_EraseRootFromParent_Done,
     /* 1349900 */   // Label 19264: @1349900
     /* 1349900 */   GIM_Try, /*On fail goto*//*Label 19265*/ GIMT_Encode4(1349984), // Rule ID 20343 //
     /* 1349905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1349922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1349943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349958 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1349961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349983 */     // GIR_Coverage, 20343,
     /* 1349983 */     GIR_EraseRootFromParent_Done,
     /* 1349984 */   // Label 19265: @1349984
     /* 1349984 */   GIM_Try, /*On fail goto*//*Label 19266*/ GIMT_Encode4(1350068), // Rule ID 20346 //
     /* 1349989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1350006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350042 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1350045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350067 */     // GIR_Coverage, 20346,
     /* 1350067 */     GIR_EraseRootFromParent_Done,
     /* 1350068 */   // Label 19266: @1350068
     /* 1350068 */   GIM_Try, /*On fail goto*//*Label 19267*/ GIMT_Encode4(1350152), // Rule ID 20347 //
     /* 1350073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1350090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350126 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1350129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350151 */     // GIR_Coverage, 20347,
     /* 1350151 */     GIR_EraseRootFromParent_Done,
     /* 1350152 */   // Label 19267: @1350152
     /* 1350152 */   GIM_Try, /*On fail goto*//*Label 19268*/ GIMT_Encode4(1350236), // Rule ID 20350 //
     /* 1350157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1350168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1350171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1350174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1350180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350210 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1350213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350235 */     // GIR_Coverage, 20350,
     /* 1350235 */     GIR_EraseRootFromParent_Done,
     /* 1350236 */   // Label 19268: @1350236
     /* 1350236 */   GIM_Try, /*On fail goto*//*Label 19269*/ GIMT_Encode4(1350320), // Rule ID 20351 //
     /* 1350241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1350252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1350255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1350258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1350264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350294 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1350297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350319 */     // GIR_Coverage, 20351,
     /* 1350319 */     GIR_EraseRootFromParent_Done,
     /* 1350320 */   // Label 19269: @1350320
     /* 1350320 */   GIM_Try, /*On fail goto*//*Label 19270*/ GIMT_Encode4(1350404), // Rule ID 20354 //
     /* 1350325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1350336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1350339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1350342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350378 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1350381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350403 */     // GIR_Coverage, 20354,
     /* 1350403 */     GIR_EraseRootFromParent_Done,
     /* 1350404 */   // Label 19270: @1350404
     /* 1350404 */   GIM_Try, /*On fail goto*//*Label 19271*/ GIMT_Encode4(1350488), // Rule ID 20355 //
     /* 1350409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1350420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1350423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1350426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350462 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1350465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350487 */     // GIR_Coverage, 20355,
     /* 1350487 */     GIR_EraseRootFromParent_Done,
     /* 1350488 */   // Label 19271: @1350488
     /* 1350488 */   GIM_Try, /*On fail goto*//*Label 19272*/ GIMT_Encode4(1350572), // Rule ID 20358 //
     /* 1350493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1350510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350546 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1350549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350571 */     // GIR_Coverage, 20358,
     /* 1350571 */     GIR_EraseRootFromParent_Done,
     /* 1350572 */   // Label 19272: @1350572
     /* 1350572 */   GIM_Try, /*On fail goto*//*Label 19273*/ GIMT_Encode4(1350656), // Rule ID 20359 //
     /* 1350577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1350594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350630 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1350633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350655 */     // GIR_Coverage, 20359,
     /* 1350655 */     GIR_EraseRootFromParent_Done,
     /* 1350656 */   // Label 19273: @1350656
     /* 1350656 */   GIM_Try, /*On fail goto*//*Label 19274*/ GIMT_Encode4(1350740), // Rule ID 20362 //
     /* 1350661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1350678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350714 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1350717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350739 */     // GIR_Coverage, 20362,
     /* 1350739 */     GIR_EraseRootFromParent_Done,
     /* 1350740 */   // Label 19274: @1350740
     /* 1350740 */   GIM_Try, /*On fail goto*//*Label 19275*/ GIMT_Encode4(1350824), // Rule ID 20363 //
     /* 1350745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1350762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350798 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1350801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350823 */     // GIR_Coverage, 20363,
     /* 1350823 */     GIR_EraseRootFromParent_Done,
     /* 1350824 */   // Label 19275: @1350824
     /* 1350824 */   GIM_Try, /*On fail goto*//*Label 19276*/ GIMT_Encode4(1350908), // Rule ID 20366 //
     /* 1350829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1350832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1350840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1350843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1350846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1350871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350882 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1350885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350907 */     // GIR_Coverage, 20366,
     /* 1350907 */     GIR_EraseRootFromParent_Done,
     /* 1350908 */   // Label 19276: @1350908
     /* 1350908 */   GIM_Try, /*On fail goto*//*Label 19277*/ GIMT_Encode4(1350992), // Rule ID 20367 //
     /* 1350913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1350916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1350924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1350927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1350930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1350955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350966 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1350969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350991 */     // GIR_Coverage, 20367,
     /* 1350991 */     GIR_EraseRootFromParent_Done,
     /* 1350992 */   // Label 19277: @1350992
     /* 1350992 */   GIM_Try, /*On fail goto*//*Label 19278*/ GIMT_Encode4(1351076), // Rule ID 20370 //
     /* 1350997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1351014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351050 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1351053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351075 */     // GIR_Coverage, 20370,
     /* 1351075 */     GIR_EraseRootFromParent_Done,
     /* 1351076 */   // Label 19278: @1351076
     /* 1351076 */   GIM_Try, /*On fail goto*//*Label 19279*/ GIMT_Encode4(1351160), // Rule ID 20371 //
     /* 1351081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1351098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351134 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1351137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351159 */     // GIR_Coverage, 20371,
     /* 1351159 */     GIR_EraseRootFromParent_Done,
     /* 1351160 */   // Label 19279: @1351160
     /* 1351160 */   GIM_Try, /*On fail goto*//*Label 19280*/ GIMT_Encode4(1351244), // Rule ID 20374 //
     /* 1351165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1351182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351218 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1351221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351243 */     // GIR_Coverage, 20374,
     /* 1351243 */     GIR_EraseRootFromParent_Done,
     /* 1351244 */   // Label 19280: @1351244
     /* 1351244 */   GIM_Try, /*On fail goto*//*Label 19281*/ GIMT_Encode4(1351328), // Rule ID 20375 //
     /* 1351249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1351266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351302 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1351305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351327 */     // GIR_Coverage, 20375,
     /* 1351327 */     GIR_EraseRootFromParent_Done,
     /* 1351328 */   // Label 19281: @1351328
     /* 1351328 */   GIM_Try, /*On fail goto*//*Label 19282*/ GIMT_Encode4(1351412), // Rule ID 20378 //
     /* 1351333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1351350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1351353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351386 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1351389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351411 */     // GIR_Coverage, 20378,
     /* 1351411 */     GIR_EraseRootFromParent_Done,
     /* 1351412 */   // Label 19282: @1351412
     /* 1351412 */   GIM_Try, /*On fail goto*//*Label 19283*/ GIMT_Encode4(1351496), // Rule ID 20379 //
     /* 1351417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1351434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1351437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351470 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1351473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351495 */     // GIR_Coverage, 20379,
     /* 1351495 */     GIR_EraseRootFromParent_Done,
     /* 1351496 */   // Label 19283: @1351496
     /* 1351496 */   GIM_Try, /*On fail goto*//*Label 19284*/ GIMT_Encode4(1351580), // Rule ID 20382 //
     /* 1351501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1351518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1351521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351554 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1351557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351579 */     // GIR_Coverage, 20382,
     /* 1351579 */     GIR_EraseRootFromParent_Done,
     /* 1351580 */   // Label 19284: @1351580
     /* 1351580 */   GIM_Try, /*On fail goto*//*Label 19285*/ GIMT_Encode4(1351664), // Rule ID 20383 //
     /* 1351585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1351602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1351605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351638 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1351641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351663 */     // GIR_Coverage, 20383,
     /* 1351663 */     GIR_EraseRootFromParent_Done,
     /* 1351664 */   // Label 19285: @1351664
     /* 1351664 */   GIM_Try, /*On fail goto*//*Label 19286*/ GIMT_Encode4(1351748), // Rule ID 20386 //
     /* 1351669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1351672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1351686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1351689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351722 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1351725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351747 */     // GIR_Coverage, 20386,
     /* 1351747 */     GIR_EraseRootFromParent_Done,
     /* 1351748 */   // Label 19286: @1351748
     /* 1351748 */   GIM_Try, /*On fail goto*//*Label 19287*/ GIMT_Encode4(1351832), // Rule ID 20387 //
     /* 1351753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1351756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1351770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1351773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351806 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1351809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351831 */     // GIR_Coverage, 20387,
     /* 1351831 */     GIR_EraseRootFromParent_Done,
     /* 1351832 */   // Label 19287: @1351832
     /* 1351832 */   GIM_Try, /*On fail goto*//*Label 19288*/ GIMT_Encode4(1351916), // Rule ID 20390 //
     /* 1351837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1351854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1351857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351890 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1351893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351915 */     // GIR_Coverage, 20390,
     /* 1351915 */     GIR_EraseRootFromParent_Done,
     /* 1351916 */   // Label 19288: @1351916
     /* 1351916 */   GIM_Try, /*On fail goto*//*Label 19289*/ GIMT_Encode4(1352000), // Rule ID 20391 //
     /* 1351921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1351938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1351941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351974 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1351977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351999 */     // GIR_Coverage, 20391,
     /* 1351999 */     GIR_EraseRootFromParent_Done,
     /* 1352000 */   // Label 19289: @1352000
     /* 1352000 */   GIM_Try, /*On fail goto*//*Label 19290*/ GIMT_Encode4(1352084), // Rule ID 20394 //
     /* 1352005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1352008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1352022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1352025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352058 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352083 */     // GIR_Coverage, 20394,
     /* 1352083 */     GIR_EraseRootFromParent_Done,
     /* 1352084 */   // Label 19290: @1352084
     /* 1352084 */   GIM_Try, /*On fail goto*//*Label 19291*/ GIMT_Encode4(1352168), // Rule ID 20395 //
     /* 1352089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1352092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1352106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1352109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352142 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352167 */     // GIR_Coverage, 20395,
     /* 1352167 */     GIR_EraseRootFromParent_Done,
     /* 1352168 */   // Label 19291: @1352168
     /* 1352168 */   GIM_Try, /*On fail goto*//*Label 19292*/ GIMT_Encode4(1352252), // Rule ID 20398 //
     /* 1352173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1352176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1352190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1352193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352226 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352251 */     // GIR_Coverage, 20398,
     /* 1352251 */     GIR_EraseRootFromParent_Done,
     /* 1352252 */   // Label 19292: @1352252
     /* 1352252 */   GIM_Try, /*On fail goto*//*Label 19293*/ GIMT_Encode4(1352336), // Rule ID 20399 //
     /* 1352257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1352260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1352274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1352277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352310 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352335 */     // GIR_Coverage, 20399,
     /* 1352335 */     GIR_EraseRootFromParent_Done,
     /* 1352336 */   // Label 19293: @1352336
     /* 1352336 */   GIM_Try, /*On fail goto*//*Label 19294*/ GIMT_Encode4(1352420), // Rule ID 20402 //
     /* 1352341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1352352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1352355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1352358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1352361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352394 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1352397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352419 */     // GIR_Coverage, 20402,
     /* 1352419 */     GIR_EraseRootFromParent_Done,
     /* 1352420 */   // Label 19294: @1352420
     /* 1352420 */   GIM_Try, /*On fail goto*//*Label 19295*/ GIMT_Encode4(1352504), // Rule ID 20403 //
     /* 1352425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1352436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1352439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1352442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1352445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352478 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1352481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352503 */     // GIR_Coverage, 20403,
     /* 1352503 */     GIR_EraseRootFromParent_Done,
     /* 1352504 */   // Label 19295: @1352504
     /* 1352504 */   GIM_Try, /*On fail goto*//*Label 19296*/ GIMT_Encode4(1352588), // Rule ID 20406 //
     /* 1352509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1352520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1352523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1352526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1352529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352562 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1352565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352587 */     // GIR_Coverage, 20406,
     /* 1352587 */     GIR_EraseRootFromParent_Done,
     /* 1352588 */   // Label 19296: @1352588
     /* 1352588 */   GIM_Try, /*On fail goto*//*Label 19297*/ GIMT_Encode4(1352672), // Rule ID 20407 //
     /* 1352593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1352604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1352607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1352610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1352613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352646 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1352649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352671 */     // GIR_Coverage, 20407,
     /* 1352671 */     GIR_EraseRootFromParent_Done,
     /* 1352672 */   // Label 19297: @1352672
     /* 1352672 */   GIM_Try, /*On fail goto*//*Label 19298*/ GIMT_Encode4(1352756), // Rule ID 20410 //
     /* 1352677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1352688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1352691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1352694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1352697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1352700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352730 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1352733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352755 */     // GIR_Coverage, 20410,
     /* 1352755 */     GIR_EraseRootFromParent_Done,
     /* 1352756 */   // Label 19298: @1352756
     /* 1352756 */   GIM_Try, /*On fail goto*//*Label 19299*/ GIMT_Encode4(1352840), // Rule ID 20411 //
     /* 1352761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1352772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1352775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1352778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1352781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1352784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352814 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1352817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352839 */     // GIR_Coverage, 20411,
     /* 1352839 */     GIR_EraseRootFromParent_Done,
     /* 1352840 */   // Label 19299: @1352840
     /* 1352840 */   GIM_Try, /*On fail goto*//*Label 19300*/ GIMT_Encode4(1352924), // Rule ID 20414 //
     /* 1352845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1352848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1352856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1352859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1352862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1352865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352898 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1352901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352923 */     // GIR_Coverage, 20414,
     /* 1352923 */     GIR_EraseRootFromParent_Done,
     /* 1352924 */   // Label 19300: @1352924
     /* 1352924 */   GIM_Try, /*On fail goto*//*Label 19301*/ GIMT_Encode4(1353008), // Rule ID 20415 //
     /* 1352929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1352932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1352940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1352943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1352946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1352949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352982 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1352985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353007 */     // GIR_Coverage, 20415,
     /* 1353007 */     GIR_EraseRootFromParent_Done,
     /* 1353008 */   // Label 19301: @1353008
     /* 1353008 */   GIM_Try, /*On fail goto*//*Label 19302*/ GIMT_Encode4(1353092), // Rule ID 20418 //
     /* 1353013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1353033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353066 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353091 */     // GIR_Coverage, 20418,
     /* 1353091 */     GIR_EraseRootFromParent_Done,
     /* 1353092 */   // Label 19302: @1353092
     /* 1353092 */   GIM_Try, /*On fail goto*//*Label 19303*/ GIMT_Encode4(1353176), // Rule ID 20419 //
     /* 1353097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1353117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353150 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353175 */     // GIR_Coverage, 20419,
     /* 1353175 */     GIR_EraseRootFromParent_Done,
     /* 1353176 */   // Label 19303: @1353176
     /* 1353176 */   GIM_Try, /*On fail goto*//*Label 19304*/ GIMT_Encode4(1353260), // Rule ID 20422 //
     /* 1353181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1353201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353234 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353259 */     // GIR_Coverage, 20422,
     /* 1353259 */     GIR_EraseRootFromParent_Done,
     /* 1353260 */   // Label 19304: @1353260
     /* 1353260 */   GIM_Try, /*On fail goto*//*Label 19305*/ GIMT_Encode4(1353344), // Rule ID 20423 //
     /* 1353265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1353285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353318 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353343 */     // GIR_Coverage, 20423,
     /* 1353343 */     GIR_EraseRootFromParent_Done,
     /* 1353344 */   // Label 19305: @1353344
     /* 1353344 */   GIM_Try, /*On fail goto*//*Label 19306*/ GIMT_Encode4(1353428), // Rule ID 20426 //
     /* 1353349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1353360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1353363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1353369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353402 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1353405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353427 */     // GIR_Coverage, 20426,
     /* 1353427 */     GIR_EraseRootFromParent_Done,
     /* 1353428 */   // Label 19306: @1353428
     /* 1353428 */   GIM_Try, /*On fail goto*//*Label 19307*/ GIMT_Encode4(1353512), // Rule ID 20427 //
     /* 1353433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1353436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1353444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1353447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1353453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353486 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1353489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353511 */     // GIR_Coverage, 20427,
     /* 1353511 */     GIR_EraseRootFromParent_Done,
     /* 1353512 */   // Label 19307: @1353512
     /* 1353512 */   GIM_Try, /*On fail goto*//*Label 19308*/ GIMT_Encode4(1353596), // Rule ID 20430 //
     /* 1353517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1353534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1353537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353570 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353595 */     // GIR_Coverage, 20430,
     /* 1353595 */     GIR_EraseRootFromParent_Done,
     /* 1353596 */   // Label 19308: @1353596
     /* 1353596 */   GIM_Try, /*On fail goto*//*Label 19309*/ GIMT_Encode4(1353680), // Rule ID 20431 //
     /* 1353601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1353604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1353618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1353621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353654 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353679 */     // GIR_Coverage, 20431,
     /* 1353679 */     GIR_EraseRootFromParent_Done,
     /* 1353680 */   // Label 19309: @1353680
     /* 1353680 */   GIM_Try, /*On fail goto*//*Label 19310*/ GIMT_Encode4(1353764), // Rule ID 20434 //
     /* 1353685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1353702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1353705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353763 */     // GIR_Coverage, 20434,
     /* 1353763 */     GIR_EraseRootFromParent_Done,
     /* 1353764 */   // Label 19310: @1353764
     /* 1353764 */   GIM_Try, /*On fail goto*//*Label 19311*/ GIMT_Encode4(1353848), // Rule ID 20435 //
     /* 1353769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1353772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1353786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1353789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353822 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353847 */     // GIR_Coverage, 20435,
     /* 1353847 */     GIR_EraseRootFromParent_Done,
     /* 1353848 */   // Label 19311: @1353848
     /* 1353848 */   GIM_Try, /*On fail goto*//*Label 19312*/ GIMT_Encode4(1353932), // Rule ID 20438 //
     /* 1353853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1353856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1353864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1353867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1353870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1353873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1353876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353906 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1353909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353931 */     // GIR_Coverage, 20438,
     /* 1353931 */     GIR_EraseRootFromParent_Done,
     /* 1353932 */   // Label 19312: @1353932
     /* 1353932 */   GIM_Try, /*On fail goto*//*Label 19313*/ GIMT_Encode4(1354016), // Rule ID 20439 //
     /* 1353937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1353940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1353948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1353951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1353954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1353957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1353960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353990 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1353993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354015 */     // GIR_Coverage, 20439,
     /* 1354015 */     GIR_EraseRootFromParent_Done,
     /* 1354016 */   // Label 19313: @1354016
     /* 1354016 */   GIM_Try, /*On fail goto*//*Label 19314*/ GIMT_Encode4(1354100), // Rule ID 20442 //
     /* 1354021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1354038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1354041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354074 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354099 */     // GIR_Coverage, 20442,
     /* 1354099 */     GIR_EraseRootFromParent_Done,
     /* 1354100 */   // Label 19314: @1354100
     /* 1354100 */   GIM_Try, /*On fail goto*//*Label 19315*/ GIMT_Encode4(1354184), // Rule ID 20443 //
     /* 1354105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1354122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1354125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354158 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354183 */     // GIR_Coverage, 20443,
     /* 1354183 */     GIR_EraseRootFromParent_Done,
     /* 1354184 */   // Label 19315: @1354184
     /* 1354184 */   GIM_Try, /*On fail goto*//*Label 19316*/ GIMT_Encode4(1354268), // Rule ID 20446 //
     /* 1354189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1354192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1354206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1354209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354242 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354267 */     // GIR_Coverage, 20446,
     /* 1354267 */     GIR_EraseRootFromParent_Done,
     /* 1354268 */   // Label 19316: @1354268
     /* 1354268 */   GIM_Try, /*On fail goto*//*Label 19317*/ GIMT_Encode4(1354352), // Rule ID 20447 //
     /* 1354273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1354276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1354290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1354293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354326 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354351 */     // GIR_Coverage, 20447,
     /* 1354351 */     GIR_EraseRootFromParent_Done,
     /* 1354352 */   // Label 19317: @1354352
     /* 1354352 */   GIM_Try, /*On fail goto*//*Label 19318*/ GIMT_Encode4(1354436), // Rule ID 20450 //
     /* 1354357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1354374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1354377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354410 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354435 */     // GIR_Coverage, 20450,
     /* 1354435 */     GIR_EraseRootFromParent_Done,
     /* 1354436 */   // Label 19318: @1354436
     /* 1354436 */   GIM_Try, /*On fail goto*//*Label 19319*/ GIMT_Encode4(1354520), // Rule ID 20451 //
     /* 1354441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1354458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1354461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354494 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354519 */     // GIR_Coverage, 20451,
     /* 1354519 */     GIR_EraseRootFromParent_Done,
     /* 1354520 */   // Label 19319: @1354520
     /* 1354520 */   GIM_Try, /*On fail goto*//*Label 19320*/ GIMT_Encode4(1354604), // Rule ID 20454 //
     /* 1354525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1354528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1354542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1354545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354578 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354603 */     // GIR_Coverage, 20454,
     /* 1354603 */     GIR_EraseRootFromParent_Done,
     /* 1354604 */   // Label 19320: @1354604
     /* 1354604 */   GIM_Try, /*On fail goto*//*Label 19321*/ GIMT_Encode4(1354688), // Rule ID 20455 //
     /* 1354609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1354612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1354626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1354629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354662 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354687 */     // GIR_Coverage, 20455,
     /* 1354687 */     GIR_EraseRootFromParent_Done,
     /* 1354688 */   // Label 19321: @1354688
     /* 1354688 */   GIM_Try, /*On fail goto*//*Label 19322*/ GIMT_Encode4(1354772), // Rule ID 20458 //
     /* 1354693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1354696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1354710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1354713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354746 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354771 */     // GIR_Coverage, 20458,
     /* 1354771 */     GIR_EraseRootFromParent_Done,
     /* 1354772 */   // Label 19322: @1354772
     /* 1354772 */   GIM_Try, /*On fail goto*//*Label 19323*/ GIMT_Encode4(1354856), // Rule ID 20459 //
     /* 1354777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1354780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1354794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1354797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354830 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354855 */     // GIR_Coverage, 20459,
     /* 1354855 */     GIR_EraseRootFromParent_Done,
     /* 1354856 */   // Label 19323: @1354856
     /* 1354856 */   GIM_Try, /*On fail goto*//*Label 19324*/ GIMT_Encode4(1354940), // Rule ID 20462 //
     /* 1354861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1354872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1354875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1354878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1354881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354914 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1354917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354939 */     // GIR_Coverage, 20462,
     /* 1354939 */     GIR_EraseRootFromParent_Done,
     /* 1354940 */   // Label 19324: @1354940
     /* 1354940 */   GIM_Try, /*On fail goto*//*Label 19325*/ GIMT_Encode4(1355024), // Rule ID 20463 //
     /* 1354945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1354956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1354959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1354962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1354965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354998 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355023 */     // GIR_Coverage, 20463,
     /* 1355023 */     GIR_EraseRootFromParent_Done,
     /* 1355024 */   // Label 19325: @1355024
     /* 1355024 */   GIM_Try, /*On fail goto*//*Label 19326*/ GIMT_Encode4(1355108), // Rule ID 20466 //
     /* 1355029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1355040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1355043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1355046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1355049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355082 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1355085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355107 */     // GIR_Coverage, 20466,
     /* 1355107 */     GIR_EraseRootFromParent_Done,
     /* 1355108 */   // Label 19326: @1355108
     /* 1355108 */   GIM_Try, /*On fail goto*//*Label 19327*/ GIMT_Encode4(1355192), // Rule ID 20467 //
     /* 1355113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1355124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1355127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1355130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1355133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355166 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1355169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355191 */     // GIR_Coverage, 20467,
     /* 1355191 */     GIR_EraseRootFromParent_Done,
     /* 1355192 */   // Label 19327: @1355192
     /* 1355192 */   GIM_Try, /*On fail goto*//*Label 19328*/ GIMT_Encode4(1355276), // Rule ID 20470 //
     /* 1355197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1355208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1355211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1355214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1355217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1355220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355250 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1355253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355275 */     // GIR_Coverage, 20470,
     /* 1355275 */     GIR_EraseRootFromParent_Done,
     /* 1355276 */   // Label 19328: @1355276
     /* 1355276 */   GIM_Try, /*On fail goto*//*Label 19329*/ GIMT_Encode4(1355360), // Rule ID 20471 //
     /* 1355281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1355292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1355295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1355298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1355301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1355304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355334 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1355337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355359 */     // GIR_Coverage, 20471,
     /* 1355359 */     GIR_EraseRootFromParent_Done,
     /* 1355360 */   // Label 19329: @1355360
     /* 1355360 */   GIM_Try, /*On fail goto*//*Label 19330*/ GIMT_Encode4(1355444), // Rule ID 20474 //
     /* 1355365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1355376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1355379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1355382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1355385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355418 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355443 */     // GIR_Coverage, 20474,
     /* 1355443 */     GIR_EraseRootFromParent_Done,
     /* 1355444 */   // Label 19330: @1355444
     /* 1355444 */   GIM_Try, /*On fail goto*//*Label 19331*/ GIMT_Encode4(1355528), // Rule ID 20475 //
     /* 1355449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1355460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1355463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1355466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1355469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355502 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355527 */     // GIR_Coverage, 20475,
     /* 1355527 */     GIR_EraseRootFromParent_Done,
     /* 1355528 */   // Label 19331: @1355528
     /* 1355528 */   GIM_Try, /*On fail goto*//*Label 19332*/ GIMT_Encode4(1355612), // Rule ID 20478 //
     /* 1355533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1355544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1355547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1355550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1355553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355586 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1355589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355611 */     // GIR_Coverage, 20478,
     /* 1355611 */     GIR_EraseRootFromParent_Done,
     /* 1355612 */   // Label 19332: @1355612
     /* 1355612 */   GIM_Try, /*On fail goto*//*Label 19333*/ GIMT_Encode4(1355696), // Rule ID 20479 //
     /* 1355617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1355628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1355631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1355634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1355637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355670 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1355673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355695 */     // GIR_Coverage, 20479,
     /* 1355695 */     GIR_EraseRootFromParent_Done,
     /* 1355696 */   // Label 19333: @1355696
     /* 1355696 */   GIM_Try, /*On fail goto*//*Label 19334*/ GIMT_Encode4(1355780), // Rule ID 20482 //
     /* 1355701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1355712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1355715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1355718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1355721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355754 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1355757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355779 */     // GIR_Coverage, 20482,
     /* 1355779 */     GIR_EraseRootFromParent_Done,
     /* 1355780 */   // Label 19334: @1355780
     /* 1355780 */   GIM_Try, /*On fail goto*//*Label 19335*/ GIMT_Encode4(1355864), // Rule ID 20483 //
     /* 1355785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1355796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1355799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1355802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1355805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355838 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1355841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355863 */     // GIR_Coverage, 20483,
     /* 1355863 */     GIR_EraseRootFromParent_Done,
     /* 1355864 */   // Label 19335: @1355864
     /* 1355864 */   GIM_Try, /*On fail goto*//*Label 19336*/ GIMT_Encode4(1355948), // Rule ID 20486 //
     /* 1355869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1355872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1355880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1355883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1355886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1355889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355922 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1355943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355947 */     // GIR_Coverage, 20486,
     /* 1355947 */     GIR_EraseRootFromParent_Done,
     /* 1355948 */   // Label 19336: @1355948
     /* 1355948 */   GIM_Try, /*On fail goto*//*Label 19337*/ GIMT_Encode4(1356032), // Rule ID 20487 //
     /* 1355953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1355956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1355964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1355967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1355970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1355973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356006 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1356009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356031 */     // GIR_Coverage, 20487,
     /* 1356031 */     GIR_EraseRootFromParent_Done,
     /* 1356032 */   // Label 19337: @1356032
     /* 1356032 */   GIM_Try, /*On fail goto*//*Label 19338*/ GIMT_Encode4(1356116), // Rule ID 20490 //
     /* 1356037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1356040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1356048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1356051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1356054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1356057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356090 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1356093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356115 */     // GIR_Coverage, 20490,
     /* 1356115 */     GIR_EraseRootFromParent_Done,
     /* 1356116 */   // Label 19338: @1356116
     /* 1356116 */   GIM_Try, /*On fail goto*//*Label 19339*/ GIMT_Encode4(1356200), // Rule ID 20491 //
     /* 1356121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1356124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1356132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1356135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1356138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1356141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356174 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1356177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356199 */     // GIR_Coverage, 20491,
     /* 1356199 */     GIR_EraseRootFromParent_Done,
     /* 1356200 */   // Label 19339: @1356200
     /* 1356200 */   GIM_Try, /*On fail goto*//*Label 19340*/ GIMT_Encode4(1356284), // Rule ID 20494 //
     /* 1356205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1356208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1356222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1356225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356258 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1356261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356283 */     // GIR_Coverage, 20494,
     /* 1356283 */     GIR_EraseRootFromParent_Done,
     /* 1356284 */   // Label 19340: @1356284
     /* 1356284 */   GIM_Try, /*On fail goto*//*Label 19341*/ GIMT_Encode4(1356368), // Rule ID 20495 //
     /* 1356289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1356292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1356306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1356309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356342 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1356345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356367 */     // GIR_Coverage, 20495,
     /* 1356367 */     GIR_EraseRootFromParent_Done,
     /* 1356368 */   // Label 19341: @1356368
     /* 1356368 */   GIM_Try, /*On fail goto*//*Label 19342*/ GIMT_Encode4(1356449), // Rule ID 20552 //
     /* 1356373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1356376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1356384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1356387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1356390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1356393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356426 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1356429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356448 */     // GIR_Coverage, 20552,
     /* 1356448 */     GIR_EraseRootFromParent_Done,
     /* 1356449 */   // Label 19342: @1356449
     /* 1356449 */   GIM_Try, /*On fail goto*//*Label 19343*/ GIMT_Encode4(1356530), // Rule ID 20553 //
     /* 1356454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1356457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1356465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1356468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1356471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1356474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356507 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1356510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356529 */     // GIR_Coverage, 20553,
     /* 1356529 */     GIR_EraseRootFromParent_Done,
     /* 1356530 */   // Label 19343: @1356530
     /* 1356530 */   GIM_Try, /*On fail goto*//*Label 19344*/ GIMT_Encode4(1356611), // Rule ID 20554 //
     /* 1356535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1356538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1356546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1356549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1356552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1356577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356588 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1356591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356610 */     // GIR_Coverage, 20554,
     /* 1356610 */     GIR_EraseRootFromParent_Done,
     /* 1356611 */   // Label 19344: @1356611
     /* 1356611 */   GIM_Try, /*On fail goto*//*Label 19345*/ GIMT_Encode4(1356692), // Rule ID 20555 //
     /* 1356616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1356619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1356627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1356630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1356633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1356658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356669 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1356672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356691 */     // GIR_Coverage, 20555,
     /* 1356691 */     GIR_EraseRootFromParent_Done,
     /* 1356692 */   // Label 19345: @1356692
     /* 1356692 */   GIM_Try, /*On fail goto*//*Label 19346*/ GIMT_Encode4(1356773), // Rule ID 20556 //
     /* 1356697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1356700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1356708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1356711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1356714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1356717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356750 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1356753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356772 */     // GIR_Coverage, 20556,
     /* 1356772 */     GIR_EraseRootFromParent_Done,
     /* 1356773 */   // Label 19346: @1356773
     /* 1356773 */   GIM_Try, /*On fail goto*//*Label 19347*/ GIMT_Encode4(1356854), // Rule ID 20557 //
     /* 1356778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1356781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1356789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1356792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1356795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1356798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356831 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1356834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356853 */     // GIR_Coverage, 20557,
     /* 1356853 */     GIR_EraseRootFromParent_Done,
     /* 1356854 */   // Label 19347: @1356854
     /* 1356854 */   GIM_Try, /*On fail goto*//*Label 19348*/ GIMT_Encode4(1356935), // Rule ID 20558 //
     /* 1356859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1356862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1356870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1356873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1356876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1356901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356912 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1356915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356934 */     // GIR_Coverage, 20558,
     /* 1356934 */     GIR_EraseRootFromParent_Done,
     /* 1356935 */   // Label 19348: @1356935
     /* 1356935 */   GIM_Try, /*On fail goto*//*Label 19349*/ GIMT_Encode4(1357016), // Rule ID 20559 //
     /* 1356940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1356943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1356951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1356954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1356957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1356982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356993 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1356996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357015 */     // GIR_Coverage, 20559,
     /* 1357015 */     GIR_EraseRootFromParent_Done,
     /* 1357016 */   // Label 19349: @1357016
     /* 1357016 */   GIM_Try, /*On fail goto*//*Label 19350*/ GIMT_Encode4(1357097), // Rule ID 20560 //
     /* 1357021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1357041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357074 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1357077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357096 */     // GIR_Coverage, 20560,
     /* 1357096 */     GIR_EraseRootFromParent_Done,
     /* 1357097 */   // Label 19350: @1357097
     /* 1357097 */   GIM_Try, /*On fail goto*//*Label 19351*/ GIMT_Encode4(1357178), // Rule ID 20561 //
     /* 1357102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1357122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357155 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1357158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357177 */     // GIR_Coverage, 20561,
     /* 1357177 */     GIR_EraseRootFromParent_Done,
     /* 1357178 */   // Label 19351: @1357178
     /* 1357178 */   GIM_Try, /*On fail goto*//*Label 19352*/ GIMT_Encode4(1357259), // Rule ID 20562 //
     /* 1357183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357236 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1357239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357258 */     // GIR_Coverage, 20562,
     /* 1357258 */     GIR_EraseRootFromParent_Done,
     /* 1357259 */   // Label 19352: @1357259
     /* 1357259 */   GIM_Try, /*On fail goto*//*Label 19353*/ GIMT_Encode4(1357340), // Rule ID 20563 //
     /* 1357264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357317 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1357320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357339 */     // GIR_Coverage, 20563,
     /* 1357339 */     GIR_EraseRootFromParent_Done,
     /* 1357340 */   // Label 19353: @1357340
     /* 1357340 */   GIM_Try, /*On fail goto*//*Label 19354*/ GIMT_Encode4(1357421), // Rule ID 20564 //
     /* 1357345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1357348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1357365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357398 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1357398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1357401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357420 */     // GIR_Coverage, 20564,
     /* 1357420 */     GIR_EraseRootFromParent_Done,
     /* 1357421 */   // Label 19354: @1357421
     /* 1357421 */   GIM_Try, /*On fail goto*//*Label 19355*/ GIMT_Encode4(1357502), // Rule ID 20565 //
     /* 1357426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1357429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1357446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357479 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1357479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1357482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357501 */     // GIR_Coverage, 20565,
     /* 1357501 */     GIR_EraseRootFromParent_Done,
     /* 1357502 */   // Label 19355: @1357502
     /* 1357502 */   GIM_Try, /*On fail goto*//*Label 19356*/ GIMT_Encode4(1357583), // Rule ID 20566 //
     /* 1357507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1357510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1357549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357560 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1357560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1357563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357582 */     // GIR_Coverage, 20566,
     /* 1357582 */     GIR_EraseRootFromParent_Done,
     /* 1357583 */   // Label 19356: @1357583
     /* 1357583 */   GIM_Try, /*On fail goto*//*Label 19357*/ GIMT_Encode4(1357664), // Rule ID 20567 //
     /* 1357588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1357591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1357630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357641 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1357641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1357644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357663 */     // GIR_Coverage, 20567,
     /* 1357663 */     GIR_EraseRootFromParent_Done,
     /* 1357664 */   // Label 19357: @1357664
     /* 1357664 */   GIM_Try, /*On fail goto*//*Label 19358*/ GIMT_Encode4(1357745), // Rule ID 20568 //
     /* 1357669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1357686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1357689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357722 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1357725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357744 */     // GIR_Coverage, 20568,
     /* 1357744 */     GIR_EraseRootFromParent_Done,
     /* 1357745 */   // Label 19358: @1357745
     /* 1357745 */   GIM_Try, /*On fail goto*//*Label 19359*/ GIMT_Encode4(1357826), // Rule ID 20569 //
     /* 1357750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1357767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1357770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357803 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1357806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357825 */     // GIR_Coverage, 20569,
     /* 1357825 */     GIR_EraseRootFromParent_Done,
     /* 1357826 */   // Label 19359: @1357826
     /* 1357826 */   GIM_Try, /*On fail goto*//*Label 19360*/ GIMT_Encode4(1357907), // Rule ID 20570 //
     /* 1357831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1357848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357884 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1357887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357906 */     // GIR_Coverage, 20570,
     /* 1357906 */     GIR_EraseRootFromParent_Done,
     /* 1357907 */   // Label 19360: @1357907
     /* 1357907 */   GIM_Try, /*On fail goto*//*Label 19361*/ GIMT_Encode4(1357988), // Rule ID 20571 //
     /* 1357912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1357929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357965 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1357968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357987 */     // GIR_Coverage, 20571,
     /* 1357987 */     GIR_EraseRootFromParent_Done,
     /* 1357988 */   // Label 19361: @1357988
     /* 1357988 */   GIM_Try, /*On fail goto*//*Label 19362*/ GIMT_Encode4(1358069), // Rule ID 20572 //
     /* 1357993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1357996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1358013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358046 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1358049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358068 */     // GIR_Coverage, 20572,
     /* 1358068 */     GIR_EraseRootFromParent_Done,
     /* 1358069 */   // Label 19362: @1358069
     /* 1358069 */   GIM_Try, /*On fail goto*//*Label 19363*/ GIMT_Encode4(1358150), // Rule ID 20573 //
     /* 1358074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1358094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358127 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1358130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358149 */     // GIR_Coverage, 20573,
     /* 1358149 */     GIR_EraseRootFromParent_Done,
     /* 1358150 */   // Label 19363: @1358150
     /* 1358150 */   GIM_Try, /*On fail goto*//*Label 19364*/ GIMT_Encode4(1358231), // Rule ID 20574 //
     /* 1358155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1358158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358208 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1358211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358230 */     // GIR_Coverage, 20574,
     /* 1358230 */     GIR_EraseRootFromParent_Done,
     /* 1358231 */   // Label 19364: @1358231
     /* 1358231 */   GIM_Try, /*On fail goto*//*Label 19365*/ GIMT_Encode4(1358312), // Rule ID 20575 //
     /* 1358236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358289 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1358292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358311 */     // GIR_Coverage, 20575,
     /* 1358311 */     GIR_EraseRootFromParent_Done,
     /* 1358312 */   // Label 19365: @1358312
     /* 1358312 */   GIM_Try, /*On fail goto*//*Label 19366*/ GIMT_Encode4(1358393), // Rule ID 20576 //
     /* 1358317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1358320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1358337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358370 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1358373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358392 */     // GIR_Coverage, 20576,
     /* 1358392 */     GIR_EraseRootFromParent_Done,
     /* 1358393 */   // Label 19366: @1358393
     /* 1358393 */   GIM_Try, /*On fail goto*//*Label 19367*/ GIMT_Encode4(1358474), // Rule ID 20577 //
     /* 1358398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1358401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1358418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358451 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1358451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1358454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358473 */     // GIR_Coverage, 20577,
     /* 1358473 */     GIR_EraseRootFromParent_Done,
     /* 1358474 */   // Label 19367: @1358474
     /* 1358474 */   GIM_Try, /*On fail goto*//*Label 19368*/ GIMT_Encode4(1358555), // Rule ID 20578 //
     /* 1358479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1358482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1358499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358532 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1358535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358554 */     // GIR_Coverage, 20578,
     /* 1358554 */     GIR_EraseRootFromParent_Done,
     /* 1358555 */   // Label 19368: @1358555
     /* 1358555 */   GIM_Try, /*On fail goto*//*Label 19369*/ GIMT_Encode4(1358636), // Rule ID 20579 //
     /* 1358560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1358563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1358580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358613 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1358613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1358616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358635 */     // GIR_Coverage, 20579,
     /* 1358635 */     GIR_EraseRootFromParent_Done,
     /* 1358636 */   // Label 19369: @1358636
     /* 1358636 */   GIM_Try, /*On fail goto*//*Label 19370*/ GIMT_Encode4(1358717), // Rule ID 20580 //
     /* 1358641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1358644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1358652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1358655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1358658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1358661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1358664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358694 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1358697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358716 */     // GIR_Coverage, 20580,
     /* 1358716 */     GIR_EraseRootFromParent_Done,
     /* 1358717 */   // Label 19370: @1358717
     /* 1358717 */   GIM_Try, /*On fail goto*//*Label 19371*/ GIMT_Encode4(1358798), // Rule ID 20581 //
     /* 1358722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1358725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1358733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1358736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1358739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1358742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1358745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358775 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1358775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1358778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358797 */     // GIR_Coverage, 20581,
     /* 1358797 */     GIR_EraseRootFromParent_Done,
     /* 1358798 */   // Label 19371: @1358798
     /* 1358798 */   GIM_Try, /*On fail goto*//*Label 19372*/ GIMT_Encode4(1358879), // Rule ID 20582 //
     /* 1358803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1358806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1358814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1358817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1358820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1358823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1358826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358856 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1358859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358878 */     // GIR_Coverage, 20582,
     /* 1358878 */     GIR_EraseRootFromParent_Done,
     /* 1358879 */   // Label 19372: @1358879
     /* 1358879 */   GIM_Try, /*On fail goto*//*Label 19373*/ GIMT_Encode4(1358960), // Rule ID 20583 //
     /* 1358884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1358887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1358895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1358898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1358901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1358904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1358907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358937 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1358937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1358940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358959 */     // GIR_Coverage, 20583,
     /* 1358959 */     GIR_EraseRootFromParent_Done,
     /* 1358960 */   // Label 19373: @1358960
     /* 1358960 */   GIM_Try, /*On fail goto*//*Label 19374*/ GIMT_Encode4(1359041), // Rule ID 20584 //
     /* 1358965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1358968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1358976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1358979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1358982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1358985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1358988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1358995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359018 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1359018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1359021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359040 */     // GIR_Coverage, 20584,
     /* 1359040 */     GIR_EraseRootFromParent_Done,
     /* 1359041 */   // Label 19374: @1359041
     /* 1359041 */   GIM_Try, /*On fail goto*//*Label 19375*/ GIMT_Encode4(1359122), // Rule ID 20585 //
     /* 1359046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1359049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1359066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359099 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1359102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359121 */     // GIR_Coverage, 20585,
     /* 1359121 */     GIR_EraseRootFromParent_Done,
     /* 1359122 */   // Label 19375: @1359122
     /* 1359122 */   GIM_Try, /*On fail goto*//*Label 19376*/ GIMT_Encode4(1359203), // Rule ID 20586 //
     /* 1359127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1359130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359180 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1359180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1359183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359202 */     // GIR_Coverage, 20586,
     /* 1359202 */     GIR_EraseRootFromParent_Done,
     /* 1359203 */   // Label 19376: @1359203
     /* 1359203 */   GIM_Try, /*On fail goto*//*Label 19377*/ GIMT_Encode4(1359284), // Rule ID 20587 //
     /* 1359208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1359211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359261 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1359264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359283 */     // GIR_Coverage, 20587,
     /* 1359283 */     GIR_EraseRootFromParent_Done,
     /* 1359284 */   // Label 19377: @1359284
     /* 1359284 */   GIM_Try, /*On fail goto*//*Label 19378*/ GIMT_Encode4(1359365), // Rule ID 20588 //
     /* 1359289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1359309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359342 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1359345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359364 */     // GIR_Coverage, 20588,
     /* 1359364 */     GIR_EraseRootFromParent_Done,
     /* 1359365 */   // Label 19378: @1359365
     /* 1359365 */   GIM_Try, /*On fail goto*//*Label 19379*/ GIMT_Encode4(1359446), // Rule ID 20589 //
     /* 1359370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1359390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359423 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1359423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1359426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359445 */     // GIR_Coverage, 20589,
     /* 1359445 */     GIR_EraseRootFromParent_Done,
     /* 1359446 */   // Label 19379: @1359446
     /* 1359446 */   GIM_Try, /*On fail goto*//*Label 19380*/ GIMT_Encode4(1359527), // Rule ID 20590 //
     /* 1359451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1359493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359504 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1359507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359526 */     // GIR_Coverage, 20590,
     /* 1359526 */     GIR_EraseRootFromParent_Done,
     /* 1359527 */   // Label 19380: @1359527
     /* 1359527 */   GIM_Try, /*On fail goto*//*Label 19381*/ GIMT_Encode4(1359608), // Rule ID 20591 //
     /* 1359532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1359574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359585 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1359585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1359588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359607 */     // GIR_Coverage, 20591,
     /* 1359607 */     GIR_EraseRootFromParent_Done,
     /* 1359608 */   // Label 19381: @1359608
     /* 1359608 */   GIM_Try, /*On fail goto*//*Label 19382*/ GIMT_Encode4(1359689), // Rule ID 20592 //
     /* 1359613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1359624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1359627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1359630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1359633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359666 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1359669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359688 */     // GIR_Coverage, 20592,
     /* 1359688 */     GIR_EraseRootFromParent_Done,
     /* 1359689 */   // Label 19382: @1359689
     /* 1359689 */   GIM_Try, /*On fail goto*//*Label 19383*/ GIMT_Encode4(1359770), // Rule ID 20593 //
     /* 1359694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1359705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1359708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1359711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1359714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359747 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1359747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1359750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359769 */     // GIR_Coverage, 20593,
     /* 1359769 */     GIR_EraseRootFromParent_Done,
     /* 1359770 */   // Label 19383: @1359770
     /* 1359770 */   GIM_Try, /*On fail goto*//*Label 19384*/ GIMT_Encode4(1359851), // Rule ID 20594 //
     /* 1359775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1359786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1359789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1359792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1359817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359828 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1359831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359850 */     // GIR_Coverage, 20594,
     /* 1359850 */     GIR_EraseRootFromParent_Done,
     /* 1359851 */   // Label 19384: @1359851
     /* 1359851 */   GIM_Try, /*On fail goto*//*Label 19385*/ GIMT_Encode4(1359932), // Rule ID 20595 //
     /* 1359856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1359867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1359870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1359873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1359898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359909 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1359909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1359912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359931 */     // GIR_Coverage, 20595,
     /* 1359931 */     GIR_EraseRootFromParent_Done,
     /* 1359932 */   // Label 19385: @1359932
     /* 1359932 */   GIM_Try, /*On fail goto*//*Label 19386*/ GIMT_Encode4(1360013), // Rule ID 20596 //
     /* 1359937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1359948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1359951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1359954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1359957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359990 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1359993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360012 */     // GIR_Coverage, 20596,
     /* 1360012 */     GIR_EraseRootFromParent_Done,
     /* 1360013 */   // Label 19386: @1360013
     /* 1360013 */   GIM_Try, /*On fail goto*//*Label 19387*/ GIMT_Encode4(1360094), // Rule ID 20597 //
     /* 1360018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1360021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1360038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360071 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1360074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360093 */     // GIR_Coverage, 20597,
     /* 1360093 */     GIR_EraseRootFromParent_Done,
     /* 1360094 */   // Label 19387: @1360094
     /* 1360094 */   GIM_Try, /*On fail goto*//*Label 19388*/ GIMT_Encode4(1360175), // Rule ID 20598 //
     /* 1360099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1360102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360152 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1360152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1360155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360174 */     // GIR_Coverage, 20598,
     /* 1360174 */     GIR_EraseRootFromParent_Done,
     /* 1360175 */   // Label 19388: @1360175
     /* 1360175 */   GIM_Try, /*On fail goto*//*Label 19389*/ GIMT_Encode4(1360256), // Rule ID 20599 //
     /* 1360180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1360183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360233 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1360236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360255 */     // GIR_Coverage, 20599,
     /* 1360255 */     GIR_EraseRootFromParent_Done,
     /* 1360256 */   // Label 19389: @1360256
     /* 1360256 */   GIM_Try, /*On fail goto*//*Label 19390*/ GIMT_Encode4(1360337), // Rule ID 20600 //
     /* 1360261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1360281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360314 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1360317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360336 */     // GIR_Coverage, 20600,
     /* 1360336 */     GIR_EraseRootFromParent_Done,
     /* 1360337 */   // Label 19390: @1360337
     /* 1360337 */   GIM_Try, /*On fail goto*//*Label 19391*/ GIMT_Encode4(1360418), // Rule ID 20601 //
     /* 1360342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1360362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360395 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1360395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1360398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360417 */     // GIR_Coverage, 20601,
     /* 1360417 */     GIR_EraseRootFromParent_Done,
     /* 1360418 */   // Label 19391: @1360418
     /* 1360418 */   GIM_Try, /*On fail goto*//*Label 19392*/ GIMT_Encode4(1360499), // Rule ID 20602 //
     /* 1360423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1360465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360476 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1360479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360498 */     // GIR_Coverage, 20602,
     /* 1360498 */     GIR_EraseRootFromParent_Done,
     /* 1360499 */   // Label 19392: @1360499
     /* 1360499 */   GIM_Try, /*On fail goto*//*Label 19393*/ GIMT_Encode4(1360580), // Rule ID 20603 //
     /* 1360504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1360546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360557 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1360557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1360560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360579 */     // GIR_Coverage, 20603,
     /* 1360579 */     GIR_EraseRootFromParent_Done,
     /* 1360580 */   // Label 19393: @1360580
     /* 1360580 */   GIM_Try, /*On fail goto*//*Label 19394*/ GIMT_Encode4(1360661), // Rule ID 20604 //
     /* 1360585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1360596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1360599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1360602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1360605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360638 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1360641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360660 */     // GIR_Coverage, 20604,
     /* 1360660 */     GIR_EraseRootFromParent_Done,
     /* 1360661 */   // Label 19394: @1360661
     /* 1360661 */   GIM_Try, /*On fail goto*//*Label 19395*/ GIMT_Encode4(1360742), // Rule ID 20605 //
     /* 1360666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1360677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1360680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1360683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1360686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360719 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1360719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1360722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360741 */     // GIR_Coverage, 20605,
     /* 1360741 */     GIR_EraseRootFromParent_Done,
     /* 1360742 */   // Label 19395: @1360742
     /* 1360742 */   GIM_Try, /*On fail goto*//*Label 19396*/ GIMT_Encode4(1360823), // Rule ID 20606 //
     /* 1360747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1360758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1360761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1360764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1360789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360800 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1360803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360822 */     // GIR_Coverage, 20606,
     /* 1360822 */     GIR_EraseRootFromParent_Done,
     /* 1360823 */   // Label 19396: @1360823
     /* 1360823 */   GIM_Try, /*On fail goto*//*Label 19397*/ GIMT_Encode4(1360904), // Rule ID 20607 //
     /* 1360828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1360839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1360842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1360845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1360870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360881 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1360881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1360884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360903 */     // GIR_Coverage, 20607,
     /* 1360903 */     GIR_EraseRootFromParent_Done,
     /* 1360904 */   // Label 19397: @1360904
     /* 1360904 */   GIM_Try, /*On fail goto*//*Label 19398*/ GIMT_Encode4(1360985), // Rule ID 20608 //
     /* 1360909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1360920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1360923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1360926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1360929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360962 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1360965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360984 */     // GIR_Coverage, 20608,
     /* 1360984 */     GIR_EraseRootFromParent_Done,
     /* 1360985 */   // Label 19398: @1360985
     /* 1360985 */   GIM_Try, /*On fail goto*//*Label 19399*/ GIMT_Encode4(1361066), // Rule ID 20609 //
     /* 1360990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1361001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1361004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1361010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361043 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1361046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361065 */     // GIR_Coverage, 20609,
     /* 1361065 */     GIR_EraseRootFromParent_Done,
     /* 1361066 */   // Label 19399: @1361066
     /* 1361066 */   GIM_Try, /*On fail goto*//*Label 19400*/ GIMT_Encode4(1361147), // Rule ID 20610 //
     /* 1361071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1361074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1361082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1361085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361124 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1361124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1361127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361146 */     // GIR_Coverage, 20610,
     /* 1361146 */     GIR_EraseRootFromParent_Done,
     /* 1361147 */   // Label 19400: @1361147
     /* 1361147 */   GIM_Try, /*On fail goto*//*Label 19401*/ GIMT_Encode4(1361228), // Rule ID 20611 //
     /* 1361152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1361155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1361163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1361166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361205 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1361208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361227 */     // GIR_Coverage, 20611,
     /* 1361227 */     GIR_EraseRootFromParent_Done,
     /* 1361228 */   // Label 19401: @1361228
     /* 1361228 */   GIM_Try, /*On fail goto*//*Label 19402*/ GIMT_Encode4(1361312), // Rule ID 21992 //
     /* 1361233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1361250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361286 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1361289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361311 */     // GIR_Coverage, 21992,
     /* 1361311 */     GIR_EraseRootFromParent_Done,
     /* 1361312 */   // Label 19402: @1361312
     /* 1361312 */   GIM_Try, /*On fail goto*//*Label 19403*/ GIMT_Encode4(1361396), // Rule ID 21993 //
     /* 1361317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1361334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361370 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1361373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361395 */     // GIR_Coverage, 21993,
     /* 1361395 */     GIR_EraseRootFromParent_Done,
     /* 1361396 */   // Label 19403: @1361396
     /* 1361396 */   GIM_Try, /*On fail goto*//*Label 19404*/ GIMT_Encode4(1361480), // Rule ID 21996 //
     /* 1361401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1361418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361454 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1361457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361479 */     // GIR_Coverage, 21996,
     /* 1361479 */     GIR_EraseRootFromParent_Done,
     /* 1361480 */   // Label 19404: @1361480
     /* 1361480 */   GIM_Try, /*On fail goto*//*Label 19405*/ GIMT_Encode4(1361564), // Rule ID 21997 //
     /* 1361485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1361502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361538 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1361541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361563 */     // GIR_Coverage, 21997,
     /* 1361563 */     GIR_EraseRootFromParent_Done,
     /* 1361564 */   // Label 19405: @1361564
     /* 1361564 */   GIM_Try, /*On fail goto*//*Label 19406*/ GIMT_Encode4(1361648), // Rule ID 22000 //
     /* 1361569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1361586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361622 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1361625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361647 */     // GIR_Coverage, 22000,
     /* 1361647 */     GIR_EraseRootFromParent_Done,
     /* 1361648 */   // Label 19406: @1361648
     /* 1361648 */   GIM_Try, /*On fail goto*//*Label 19407*/ GIMT_Encode4(1361732), // Rule ID 22001 //
     /* 1361653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1361670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361706 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1361709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361731 */     // GIR_Coverage, 22001,
     /* 1361731 */     GIR_EraseRootFromParent_Done,
     /* 1361732 */   // Label 19407: @1361732
     /* 1361732 */   GIM_Try, /*On fail goto*//*Label 19408*/ GIMT_Encode4(1361816), // Rule ID 22004 //
     /* 1361737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1361754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1361793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361815 */     // GIR_Coverage, 22004,
     /* 1361815 */     GIR_EraseRootFromParent_Done,
     /* 1361816 */   // Label 19408: @1361816
     /* 1361816 */   GIM_Try, /*On fail goto*//*Label 19409*/ GIMT_Encode4(1361900), // Rule ID 22005 //
     /* 1361821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1361838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361874 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1361877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361899 */     // GIR_Coverage, 22005,
     /* 1361899 */     GIR_EraseRootFromParent_Done,
     /* 1361900 */   // Label 19409: @1361900
     /* 1361900 */   GIM_Try, /*On fail goto*//*Label 19410*/ GIMT_Encode4(1361984), // Rule ID 22008 //
     /* 1361905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1361922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1361961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361983 */     // GIR_Coverage, 22008,
     /* 1361983 */     GIR_EraseRootFromParent_Done,
     /* 1361984 */   // Label 19410: @1361984
     /* 1361984 */   GIM_Try, /*On fail goto*//*Label 19411*/ GIMT_Encode4(1362068), // Rule ID 22009 //
     /* 1361989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1362006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362042 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1362045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362067 */     // GIR_Coverage, 22009,
     /* 1362067 */     GIR_EraseRootFromParent_Done,
     /* 1362068 */   // Label 19411: @1362068
     /* 1362068 */   GIM_Try, /*On fail goto*//*Label 19412*/ GIMT_Encode4(1362152), // Rule ID 22012 //
     /* 1362073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1362090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362126 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1362129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362151 */     // GIR_Coverage, 22012,
     /* 1362151 */     GIR_EraseRootFromParent_Done,
     /* 1362152 */   // Label 19412: @1362152
     /* 1362152 */   GIM_Try, /*On fail goto*//*Label 19413*/ GIMT_Encode4(1362236), // Rule ID 22013 //
     /* 1362157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1362174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362210 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1362213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362235 */     // GIR_Coverage, 22013,
     /* 1362235 */     GIR_EraseRootFromParent_Done,
     /* 1362236 */   // Label 19413: @1362236
     /* 1362236 */   GIM_Try, /*On fail goto*//*Label 19414*/ GIMT_Encode4(1362320), // Rule ID 22016 //
     /* 1362241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1362258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362294 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1362297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362319 */     // GIR_Coverage, 22016,
     /* 1362319 */     GIR_EraseRootFromParent_Done,
     /* 1362320 */   // Label 19414: @1362320
     /* 1362320 */   GIM_Try, /*On fail goto*//*Label 19415*/ GIMT_Encode4(1362404), // Rule ID 22017 //
     /* 1362325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1362342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362378 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1362381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362403 */     // GIR_Coverage, 22017,
     /* 1362403 */     GIR_EraseRootFromParent_Done,
     /* 1362404 */   // Label 19415: @1362404
     /* 1362404 */   GIM_Try, /*On fail goto*//*Label 19416*/ GIMT_Encode4(1362488), // Rule ID 22020 //
     /* 1362409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1362426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362462 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1362465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362487 */     // GIR_Coverage, 22020,
     /* 1362487 */     GIR_EraseRootFromParent_Done,
     /* 1362488 */   // Label 19416: @1362488
     /* 1362488 */   GIM_Try, /*On fail goto*//*Label 19417*/ GIMT_Encode4(1362572), // Rule ID 22021 //
     /* 1362493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1362510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362546 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1362549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362571 */     // GIR_Coverage, 22021,
     /* 1362571 */     GIR_EraseRootFromParent_Done,
     /* 1362572 */   // Label 19417: @1362572
     /* 1362572 */   GIM_Try, /*On fail goto*//*Label 19418*/ GIMT_Encode4(1362656), // Rule ID 22024 //
     /* 1362577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1362580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1362588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1362591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1362594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1362597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362630 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1362633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1362651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362655 */     // GIR_Coverage, 22024,
     /* 1362655 */     GIR_EraseRootFromParent_Done,
     /* 1362656 */   // Label 19418: @1362656
     /* 1362656 */   GIM_Try, /*On fail goto*//*Label 19419*/ GIMT_Encode4(1362740), // Rule ID 22025 //
     /* 1362661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1362664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1362672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1362675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1362678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1362681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362714 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1362717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1362735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362739 */     // GIR_Coverage, 22025,
     /* 1362739 */     GIR_EraseRootFromParent_Done,
     /* 1362740 */   // Label 19419: @1362740
     /* 1362740 */   GIM_Try, /*On fail goto*//*Label 19420*/ GIMT_Encode4(1362824), // Rule ID 22028 //
     /* 1362745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1362762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1362768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362798 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1362801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362823 */     // GIR_Coverage, 22028,
     /* 1362823 */     GIR_EraseRootFromParent_Done,
     /* 1362824 */   // Label 19420: @1362824
     /* 1362824 */   GIM_Try, /*On fail goto*//*Label 19421*/ GIMT_Encode4(1362908), // Rule ID 22029 //
     /* 1362829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1362846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1362852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362882 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1362885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362907 */     // GIR_Coverage, 22029,
     /* 1362907 */     GIR_EraseRootFromParent_Done,
     /* 1362908 */   // Label 19421: @1362908
     /* 1362908 */   GIM_Try, /*On fail goto*//*Label 19422*/ GIMT_Encode4(1362992), // Rule ID 22032 //
     /* 1362913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1362930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1362936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362966 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1362969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362991 */     // GIR_Coverage, 22032,
     /* 1362991 */     GIR_EraseRootFromParent_Done,
     /* 1362992 */   // Label 19422: @1362992
     /* 1362992 */   GIM_Try, /*On fail goto*//*Label 19423*/ GIMT_Encode4(1363076), // Rule ID 22033 //
     /* 1362997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1363014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1363020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363050 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1363053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363075 */     // GIR_Coverage, 22033,
     /* 1363075 */     GIR_EraseRootFromParent_Done,
     /* 1363076 */   // Label 19423: @1363076
     /* 1363076 */   GIM_Try, /*On fail goto*//*Label 19424*/ GIMT_Encode4(1363160), // Rule ID 22036 //
     /* 1363081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1363098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1363104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363134 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1363137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363159 */     // GIR_Coverage, 22036,
     /* 1363159 */     GIR_EraseRootFromParent_Done,
     /* 1363160 */   // Label 19424: @1363160
     /* 1363160 */   GIM_Try, /*On fail goto*//*Label 19425*/ GIMT_Encode4(1363244), // Rule ID 22037 //
     /* 1363165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1363182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1363188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363218 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1363221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363243 */     // GIR_Coverage, 22037,
     /* 1363243 */     GIR_EraseRootFromParent_Done,
     /* 1363244 */   // Label 19425: @1363244
     /* 1363244 */   GIM_Try, /*On fail goto*//*Label 19426*/ GIMT_Encode4(1363328), // Rule ID 22040 //
     /* 1363249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1363266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1363305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363327 */     // GIR_Coverage, 22040,
     /* 1363327 */     GIR_EraseRootFromParent_Done,
     /* 1363328 */   // Label 19426: @1363328
     /* 1363328 */   GIM_Try, /*On fail goto*//*Label 19427*/ GIMT_Encode4(1363412), // Rule ID 22041 //
     /* 1363333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1363350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1363389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363411 */     // GIR_Coverage, 22041,
     /* 1363411 */     GIR_EraseRootFromParent_Done,
     /* 1363412 */   // Label 19427: @1363412
     /* 1363412 */   GIM_Try, /*On fail goto*//*Label 19428*/ GIMT_Encode4(1363496), // Rule ID 22044 //
     /* 1363417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1363434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363470 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1363473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363495 */     // GIR_Coverage, 22044,
     /* 1363495 */     GIR_EraseRootFromParent_Done,
     /* 1363496 */   // Label 19428: @1363496
     /* 1363496 */   GIM_Try, /*On fail goto*//*Label 19429*/ GIMT_Encode4(1363580), // Rule ID 22045 //
     /* 1363501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1363518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363554 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1363557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363579 */     // GIR_Coverage, 22045,
     /* 1363579 */     GIR_EraseRootFromParent_Done,
     /* 1363580 */   // Label 19429: @1363580
     /* 1363580 */   GIM_Try, /*On fail goto*//*Label 19430*/ GIMT_Encode4(1363664), // Rule ID 22048 //
     /* 1363585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1363602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1363608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363638 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1363641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363663 */     // GIR_Coverage, 22048,
     /* 1363663 */     GIR_EraseRootFromParent_Done,
     /* 1363664 */   // Label 19430: @1363664
     /* 1363664 */   GIM_Try, /*On fail goto*//*Label 19431*/ GIMT_Encode4(1363748), // Rule ID 22049 //
     /* 1363669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1363686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1363692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363722 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1363725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363747 */     // GIR_Coverage, 22049,
     /* 1363747 */     GIR_EraseRootFromParent_Done,
     /* 1363748 */   // Label 19431: @1363748
     /* 1363748 */   GIM_Try, /*On fail goto*//*Label 19432*/ GIMT_Encode4(1363832), // Rule ID 22052 //
     /* 1363753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1363764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1363767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1363770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1363773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363806 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1363809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363831 */     // GIR_Coverage, 22052,
     /* 1363831 */     GIR_EraseRootFromParent_Done,
     /* 1363832 */   // Label 19432: @1363832
     /* 1363832 */   GIM_Try, /*On fail goto*//*Label 19433*/ GIMT_Encode4(1363916), // Rule ID 22053 //
     /* 1363837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1363848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1363851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1363854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1363857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363890 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1363893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363915 */     // GIR_Coverage, 22053,
     /* 1363915 */     GIR_EraseRootFromParent_Done,
     /* 1363916 */   // Label 19433: @1363916
     /* 1363916 */   GIM_Try, /*On fail goto*//*Label 19434*/ GIMT_Encode4(1364000), // Rule ID 22056 //
     /* 1363921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1363932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1363935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1363938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1363941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1363977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363999 */     // GIR_Coverage, 22056,
     /* 1363999 */     GIR_EraseRootFromParent_Done,
     /* 1364000 */   // Label 19434: @1364000
     /* 1364000 */   GIM_Try, /*On fail goto*//*Label 19435*/ GIMT_Encode4(1364084), // Rule ID 22057 //
     /* 1364005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1364022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364058 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1364061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364083 */     // GIR_Coverage, 22057,
     /* 1364083 */     GIR_EraseRootFromParent_Done,
     /* 1364084 */   // Label 19435: @1364084
     /* 1364084 */   GIM_Try, /*On fail goto*//*Label 19436*/ GIMT_Encode4(1364168), // Rule ID 22060 //
     /* 1364089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1364106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364142 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1364145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364167 */     // GIR_Coverage, 22060,
     /* 1364167 */     GIR_EraseRootFromParent_Done,
     /* 1364168 */   // Label 19436: @1364168
     /* 1364168 */   GIM_Try, /*On fail goto*//*Label 19437*/ GIMT_Encode4(1364252), // Rule ID 22061 //
     /* 1364173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1364190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364226 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1364229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364251 */     // GIR_Coverage, 22061,
     /* 1364251 */     GIR_EraseRootFromParent_Done,
     /* 1364252 */   // Label 19437: @1364252
     /* 1364252 */   GIM_Try, /*On fail goto*//*Label 19438*/ GIMT_Encode4(1364336), // Rule ID 22064 //
     /* 1364257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1364260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1364274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364310 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1364313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364335 */     // GIR_Coverage, 22064,
     /* 1364335 */     GIR_EraseRootFromParent_Done,
     /* 1364336 */   // Label 19438: @1364336
     /* 1364336 */   GIM_Try, /*On fail goto*//*Label 19439*/ GIMT_Encode4(1364420), // Rule ID 22065 //
     /* 1364341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1364344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1364358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364394 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1364397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364419 */     // GIR_Coverage, 22065,
     /* 1364419 */     GIR_EraseRootFromParent_Done,
     /* 1364420 */   // Label 19439: @1364420
     /* 1364420 */   GIM_Try, /*On fail goto*//*Label 19440*/ GIMT_Encode4(1364504), // Rule ID 22068 //
     /* 1364425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1364428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1364442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364478 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1364481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364503 */     // GIR_Coverage, 22068,
     /* 1364503 */     GIR_EraseRootFromParent_Done,
     /* 1364504 */   // Label 19440: @1364504
     /* 1364504 */   GIM_Try, /*On fail goto*//*Label 19441*/ GIMT_Encode4(1364588), // Rule ID 22069 //
     /* 1364509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1364512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1364526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364562 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1364565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364587 */     // GIR_Coverage, 22069,
     /* 1364587 */     GIR_EraseRootFromParent_Done,
     /* 1364588 */   // Label 19441: @1364588
     /* 1364588 */   GIM_Try, /*On fail goto*//*Label 19442*/ GIMT_Encode4(1364672), // Rule ID 22072 //
     /* 1364593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1364596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1364610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364646 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1364649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364671 */     // GIR_Coverage, 22072,
     /* 1364671 */     GIR_EraseRootFromParent_Done,
     /* 1364672 */   // Label 19442: @1364672
     /* 1364672 */   GIM_Try, /*On fail goto*//*Label 19443*/ GIMT_Encode4(1364756), // Rule ID 22073 //
     /* 1364677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1364680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1364694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364730 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1364733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364755 */     // GIR_Coverage, 22073,
     /* 1364755 */     GIR_EraseRootFromParent_Done,
     /* 1364756 */   // Label 19443: @1364756
     /* 1364756 */   GIM_Try, /*On fail goto*//*Label 19444*/ GIMT_Encode4(1364840), // Rule ID 22076 //
     /* 1364761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1364778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1364781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1364784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364814 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1364817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364839 */     // GIR_Coverage, 22076,
     /* 1364839 */     GIR_EraseRootFromParent_Done,
     /* 1364840 */   // Label 19444: @1364840
     /* 1364840 */   GIM_Try, /*On fail goto*//*Label 19445*/ GIMT_Encode4(1364924), // Rule ID 22077 //
     /* 1364845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1364862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1364865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1364868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364898 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1364901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364923 */     // GIR_Coverage, 22077,
     /* 1364923 */     GIR_EraseRootFromParent_Done,
     /* 1364924 */   // Label 19445: @1364924
     /* 1364924 */   GIM_Try, /*On fail goto*//*Label 19446*/ GIMT_Encode4(1365008), // Rule ID 22080 //
     /* 1364929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1364946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1364949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1364985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365007 */     // GIR_Coverage, 22080,
     /* 1365007 */     GIR_EraseRootFromParent_Done,
     /* 1365008 */   // Label 19446: @1365008
     /* 1365008 */   GIM_Try, /*On fail goto*//*Label 19447*/ GIMT_Encode4(1365092), // Rule ID 22081 //
     /* 1365013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1365030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365066 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1365069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365091 */     // GIR_Coverage, 22081,
     /* 1365091 */     GIR_EraseRootFromParent_Done,
     /* 1365092 */   // Label 19447: @1365092
     /* 1365092 */   GIM_Try, /*On fail goto*//*Label 19448*/ GIMT_Encode4(1365176), // Rule ID 22084 //
     /* 1365097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1365114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365150 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1365153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365175 */     // GIR_Coverage, 22084,
     /* 1365175 */     GIR_EraseRootFromParent_Done,
     /* 1365176 */   // Label 19448: @1365176
     /* 1365176 */   GIM_Try, /*On fail goto*//*Label 19449*/ GIMT_Encode4(1365260), // Rule ID 22085 //
     /* 1365181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1365198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365234 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1365237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365259 */     // GIR_Coverage, 22085,
     /* 1365259 */     GIR_EraseRootFromParent_Done,
     /* 1365260 */   // Label 19449: @1365260
     /* 1365260 */   GIM_Try, /*On fail goto*//*Label 19450*/ GIMT_Encode4(1365344), // Rule ID 22088 //
     /* 1365265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1365282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1365321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365343 */     // GIR_Coverage, 22088,
     /* 1365343 */     GIR_EraseRootFromParent_Done,
     /* 1365344 */   // Label 19450: @1365344
     /* 1365344 */   GIM_Try, /*On fail goto*//*Label 19451*/ GIMT_Encode4(1365428), // Rule ID 22089 //
     /* 1365349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1365366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1365405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365427 */     // GIR_Coverage, 22089,
     /* 1365427 */     GIR_EraseRootFromParent_Done,
     /* 1365428 */   // Label 19451: @1365428
     /* 1365428 */   GIM_Try, /*On fail goto*//*Label 19452*/ GIMT_Encode4(1365512), // Rule ID 22092 //
     /* 1365433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1365450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365486 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1365489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365511 */     // GIR_Coverage, 22092,
     /* 1365511 */     GIR_EraseRootFromParent_Done,
     /* 1365512 */   // Label 19452: @1365512
     /* 1365512 */   GIM_Try, /*On fail goto*//*Label 19453*/ GIMT_Encode4(1365596), // Rule ID 22093 //
     /* 1365517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1365534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365570 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1365573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365595 */     // GIR_Coverage, 22093,
     /* 1365595 */     GIR_EraseRootFromParent_Done,
     /* 1365596 */   // Label 19453: @1365596
     /* 1365596 */   GIM_Try, /*On fail goto*//*Label 19454*/ GIMT_Encode4(1365680), // Rule ID 22096 //
     /* 1365601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1365612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1365615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1365618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1365621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365654 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1365657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1365675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365679 */     // GIR_Coverage, 22096,
     /* 1365679 */     GIR_EraseRootFromParent_Done,
     /* 1365680 */   // Label 19454: @1365680
     /* 1365680 */   GIM_Try, /*On fail goto*//*Label 19455*/ GIMT_Encode4(1365764), // Rule ID 22097 //
     /* 1365685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1365696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1365699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1365702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1365705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365738 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1365741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1365759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365763 */     // GIR_Coverage, 22097,
     /* 1365763 */     GIR_EraseRootFromParent_Done,
     /* 1365764 */   // Label 19455: @1365764
     /* 1365764 */   GIM_Try, /*On fail goto*//*Label 19456*/ GIMT_Encode4(1365848), // Rule ID 22100 //
     /* 1365769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1365786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365822 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1365825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365847 */     // GIR_Coverage, 22100,
     /* 1365847 */     GIR_EraseRootFromParent_Done,
     /* 1365848 */   // Label 19456: @1365848
     /* 1365848 */   GIM_Try, /*On fail goto*//*Label 19457*/ GIMT_Encode4(1365932), // Rule ID 22101 //
     /* 1365853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1365870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365906 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1365909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365931 */     // GIR_Coverage, 22101,
     /* 1365931 */     GIR_EraseRootFromParent_Done,
     /* 1365932 */   // Label 19457: @1365932
     /* 1365932 */   GIM_Try, /*On fail goto*//*Label 19458*/ GIMT_Encode4(1366016), // Rule ID 22104 //
     /* 1365937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1365954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365990 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1365993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366015 */     // GIR_Coverage, 22104,
     /* 1366015 */     GIR_EraseRootFromParent_Done,
     /* 1366016 */   // Label 19458: @1366016
     /* 1366016 */   GIM_Try, /*On fail goto*//*Label 19459*/ GIMT_Encode4(1366100), // Rule ID 22105 //
     /* 1366021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1366038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1366077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366099 */     // GIR_Coverage, 22105,
     /* 1366099 */     GIR_EraseRootFromParent_Done,
     /* 1366100 */   // Label 19459: @1366100
     /* 1366100 */   GIM_Try, /*On fail goto*//*Label 19460*/ GIMT_Encode4(1366184), // Rule ID 22108 //
     /* 1366105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1366122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1366161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366183 */     // GIR_Coverage, 22108,
     /* 1366183 */     GIR_EraseRootFromParent_Done,
     /* 1366184 */   // Label 19460: @1366184
     /* 1366184 */   GIM_Try, /*On fail goto*//*Label 19461*/ GIMT_Encode4(1366268), // Rule ID 22109 //
     /* 1366189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1366206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366242 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1366245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366267 */     // GIR_Coverage, 22109,
     /* 1366267 */     GIR_EraseRootFromParent_Done,
     /* 1366268 */   // Label 19461: @1366268
     /* 1366268 */   GIM_Try, /*On fail goto*//*Label 19462*/ GIMT_Encode4(1366352), // Rule ID 22112 //
     /* 1366273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1366276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1366284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1366287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1366290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1366293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366326 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1366329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366351 */     // GIR_Coverage, 22112,
     /* 1366351 */     GIR_EraseRootFromParent_Done,
     /* 1366352 */   // Label 19462: @1366352
     /* 1366352 */   GIM_Try, /*On fail goto*//*Label 19463*/ GIMT_Encode4(1366436), // Rule ID 22113 //
     /* 1366357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1366360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1366368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1366371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1366374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1366377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366410 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1366413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366435 */     // GIR_Coverage, 22113,
     /* 1366435 */     GIR_EraseRootFromParent_Done,
     /* 1366436 */   // Label 19463: @1366436
     /* 1366436 */   GIM_Try, /*On fail goto*//*Label 19464*/ GIMT_Encode4(1366520), // Rule ID 22116 //
     /* 1366441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1366458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1366464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366494 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1366497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366519 */     // GIR_Coverage, 22116,
     /* 1366519 */     GIR_EraseRootFromParent_Done,
     /* 1366520 */   // Label 19464: @1366520
     /* 1366520 */   GIM_Try, /*On fail goto*//*Label 19465*/ GIMT_Encode4(1366604), // Rule ID 22117 //
     /* 1366525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1366542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1366548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366578 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1366581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366603 */     // GIR_Coverage, 22117,
     /* 1366603 */     GIR_EraseRootFromParent_Done,
     /* 1366604 */   // Label 19465: @1366604
     /* 1366604 */   GIM_Try, /*On fail goto*//*Label 19466*/ GIMT_Encode4(1366688), // Rule ID 22120 //
     /* 1366609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1366626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1366632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1366647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366662 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1366665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366687 */     // GIR_Coverage, 22120,
     /* 1366687 */     GIR_EraseRootFromParent_Done,
     /* 1366688 */   // Label 19466: @1366688
     /* 1366688 */   GIM_Try, /*On fail goto*//*Label 19467*/ GIMT_Encode4(1366772), // Rule ID 22121 //
     /* 1366693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1366710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1366716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1366731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366746 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1366749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366771 */     // GIR_Coverage, 22121,
     /* 1366771 */     GIR_EraseRootFromParent_Done,
     /* 1366772 */   // Label 19467: @1366772
     /* 1366772 */   GIM_Try, /*On fail goto*//*Label 19468*/ GIMT_Encode4(1366856), // Rule ID 22124 //
     /* 1366777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1366794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1366800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366830 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1366833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366855 */     // GIR_Coverage, 22124,
     /* 1366855 */     GIR_EraseRootFromParent_Done,
     /* 1366856 */   // Label 19468: @1366856
     /* 1366856 */   GIM_Try, /*On fail goto*//*Label 19469*/ GIMT_Encode4(1366940), // Rule ID 22125 //
     /* 1366861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1366878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1366884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366914 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1366917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366939 */     // GIR_Coverage, 22125,
     /* 1366939 */     GIR_EraseRootFromParent_Done,
     /* 1366940 */   // Label 19469: @1366940
     /* 1366940 */   GIM_Try, /*On fail goto*//*Label 19470*/ GIMT_Encode4(1367024), // Rule ID 22128 //
     /* 1366945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1366962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1366968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366998 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1367001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367023 */     // GIR_Coverage, 22128,
     /* 1367023 */     GIR_EraseRootFromParent_Done,
     /* 1367024 */   // Label 19470: @1367024
     /* 1367024 */   GIM_Try, /*On fail goto*//*Label 19471*/ GIMT_Encode4(1367108), // Rule ID 22129 //
     /* 1367029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1367046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367082 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1367085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367107 */     // GIR_Coverage, 22129,
     /* 1367107 */     GIR_EraseRootFromParent_Done,
     /* 1367108 */   // Label 19471: @1367108
     /* 1367108 */   GIM_Try, /*On fail goto*//*Label 19472*/ GIMT_Encode4(1367192), // Rule ID 22132 //
     /* 1367113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1367130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367166 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1367169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367191 */     // GIR_Coverage, 22132,
     /* 1367191 */     GIR_EraseRootFromParent_Done,
     /* 1367192 */   // Label 19472: @1367192
     /* 1367192 */   GIM_Try, /*On fail goto*//*Label 19473*/ GIMT_Encode4(1367276), // Rule ID 22133 //
     /* 1367197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1367214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1367253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367275 */     // GIR_Coverage, 22133,
     /* 1367275 */     GIR_EraseRootFromParent_Done,
     /* 1367276 */   // Label 19473: @1367276
     /* 1367276 */   GIM_Try, /*On fail goto*//*Label 19474*/ GIMT_Encode4(1367360), // Rule ID 22136 //
     /* 1367281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1367298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367334 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1367337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367359 */     // GIR_Coverage, 22136,
     /* 1367359 */     GIR_EraseRootFromParent_Done,
     /* 1367360 */   // Label 19474: @1367360
     /* 1367360 */   GIM_Try, /*On fail goto*//*Label 19475*/ GIMT_Encode4(1367444), // Rule ID 22137 //
     /* 1367365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1367382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367418 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1367421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367443 */     // GIR_Coverage, 22137,
     /* 1367443 */     GIR_EraseRootFromParent_Done,
     /* 1367444 */   // Label 19475: @1367444
     /* 1367444 */   GIM_Try, /*On fail goto*//*Label 19476*/ GIMT_Encode4(1367528), // Rule ID 22140 //
     /* 1367449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1367466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1367472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1367505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367527 */     // GIR_Coverage, 22140,
     /* 1367527 */     GIR_EraseRootFromParent_Done,
     /* 1367528 */   // Label 19476: @1367528
     /* 1367528 */   GIM_Try, /*On fail goto*//*Label 19477*/ GIMT_Encode4(1367612), // Rule ID 22141 //
     /* 1367533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1367550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1367556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367586 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1367589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367611 */     // GIR_Coverage, 22141,
     /* 1367611 */     GIR_EraseRootFromParent_Done,
     /* 1367612 */   // Label 19477: @1367612
     /* 1367612 */   GIM_Try, /*On fail goto*//*Label 19478*/ GIMT_Encode4(1367696), // Rule ID 22144 //
     /* 1367617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1367634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1367673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367695 */     // GIR_Coverage, 22144,
     /* 1367695 */     GIR_EraseRootFromParent_Done,
     /* 1367696 */   // Label 19478: @1367696
     /* 1367696 */   GIM_Try, /*On fail goto*//*Label 19479*/ GIMT_Encode4(1367780), // Rule ID 22145 //
     /* 1367701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1367718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367754 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1367757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367779 */     // GIR_Coverage, 22145,
     /* 1367779 */     GIR_EraseRootFromParent_Done,
     /* 1367780 */   // Label 19479: @1367780
     /* 1367780 */   GIM_Try, /*On fail goto*//*Label 19480*/ GIMT_Encode4(1367864), // Rule ID 22148 //
     /* 1367785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1367802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1367841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367863 */     // GIR_Coverage, 22148,
     /* 1367863 */     GIR_EraseRootFromParent_Done,
     /* 1367864 */   // Label 19480: @1367864
     /* 1367864 */   GIM_Try, /*On fail goto*//*Label 19481*/ GIMT_Encode4(1367948), // Rule ID 22149 //
     /* 1367869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1367886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367922 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1367925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367947 */     // GIR_Coverage, 22149,
     /* 1367947 */     GIR_EraseRootFromParent_Done,
     /* 1367948 */   // Label 19481: @1367948
     /* 1367948 */   GIM_Try, /*On fail goto*//*Label 19482*/ GIMT_Encode4(1368032), // Rule ID 22152 //
     /* 1367953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1367956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1367964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1367967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1367970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1367973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1367976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368006 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1368009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368031 */     // GIR_Coverage, 22152,
     /* 1368031 */     GIR_EraseRootFromParent_Done,
     /* 1368032 */   // Label 19482: @1368032
     /* 1368032 */   GIM_Try, /*On fail goto*//*Label 19483*/ GIMT_Encode4(1368116), // Rule ID 22153 //
     /* 1368037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1368054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368090 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1368093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368115 */     // GIR_Coverage, 22153,
     /* 1368115 */     GIR_EraseRootFromParent_Done,
     /* 1368116 */   // Label 19483: @1368116
     /* 1368116 */   GIM_Try, /*On fail goto*//*Label 19484*/ GIMT_Encode4(1368200), // Rule ID 22156 //
     /* 1368121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1368138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1368177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368199 */     // GIR_Coverage, 22156,
     /* 1368199 */     GIR_EraseRootFromParent_Done,
     /* 1368200 */   // Label 19484: @1368200
     /* 1368200 */   GIM_Try, /*On fail goto*//*Label 19485*/ GIMT_Encode4(1368284), // Rule ID 22157 //
     /* 1368205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1368222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368258 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1368261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368283 */     // GIR_Coverage, 22157,
     /* 1368283 */     GIR_EraseRootFromParent_Done,
     /* 1368284 */   // Label 19485: @1368284
     /* 1368284 */   GIM_Try, /*On fail goto*//*Label 19486*/ GIMT_Encode4(1368368), // Rule ID 22160 //
     /* 1368289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1368306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368342 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1368345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368367 */     // GIR_Coverage, 22160,
     /* 1368367 */     GIR_EraseRootFromParent_Done,
     /* 1368368 */   // Label 19486: @1368368
     /* 1368368 */   GIM_Try, /*On fail goto*//*Label 19487*/ GIMT_Encode4(1368452), // Rule ID 22161 //
     /* 1368373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1368390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368426 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1368429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368451 */     // GIR_Coverage, 22161,
     /* 1368451 */     GIR_EraseRootFromParent_Done,
     /* 1368452 */   // Label 19487: @1368452
     /* 1368452 */   GIM_Try, /*On fail goto*//*Label 19488*/ GIMT_Encode4(1368536), // Rule ID 22164 //
     /* 1368457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1368474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368510 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1368513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368535 */     // GIR_Coverage, 22164,
     /* 1368535 */     GIR_EraseRootFromParent_Done,
     /* 1368536 */   // Label 19488: @1368536
     /* 1368536 */   GIM_Try, /*On fail goto*//*Label 19489*/ GIMT_Encode4(1368620), // Rule ID 22165 //
     /* 1368541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1368558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368594 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1368597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368619 */     // GIR_Coverage, 22165,
     /* 1368619 */     GIR_EraseRootFromParent_Done,
     /* 1368620 */   // Label 19489: @1368620
     /* 1368620 */   GIM_Try, /*On fail goto*//*Label 19490*/ GIMT_Encode4(1368704), // Rule ID 22168 //
     /* 1368625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1368642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368678 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1368681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368703 */     // GIR_Coverage, 22168,
     /* 1368703 */     GIR_EraseRootFromParent_Done,
     /* 1368704 */   // Label 19490: @1368704
     /* 1368704 */   GIM_Try, /*On fail goto*//*Label 19491*/ GIMT_Encode4(1368788), // Rule ID 22169 //
     /* 1368709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1368726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368762 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1368765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368787 */     // GIR_Coverage, 22169,
     /* 1368787 */     GIR_EraseRootFromParent_Done,
     /* 1368788 */   // Label 19491: @1368788
     /* 1368788 */   GIM_Try, /*On fail goto*//*Label 19492*/ GIMT_Encode4(1368872), // Rule ID 22172 //
     /* 1368793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1368810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368846 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1368849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368871 */     // GIR_Coverage, 22172,
     /* 1368871 */     GIR_EraseRootFromParent_Done,
     /* 1368872 */   // Label 19492: @1368872
     /* 1368872 */   GIM_Try, /*On fail goto*//*Label 19493*/ GIMT_Encode4(1368956), // Rule ID 22173 //
     /* 1368877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1368894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368930 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1368933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368955 */     // GIR_Coverage, 22173,
     /* 1368955 */     GIR_EraseRootFromParent_Done,
     /* 1368956 */   // Label 19493: @1368956
     /* 1368956 */   GIM_Try, /*On fail goto*//*Label 19494*/ GIMT_Encode4(1369040), // Rule ID 22176 //
     /* 1368961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1368972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1368975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1368978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1368981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369014 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1369017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369039 */     // GIR_Coverage, 22176,
     /* 1369039 */     GIR_EraseRootFromParent_Done,
     /* 1369040 */   // Label 19494: @1369040
     /* 1369040 */   GIM_Try, /*On fail goto*//*Label 19495*/ GIMT_Encode4(1369124), // Rule ID 22177 //
     /* 1369045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1369062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369098 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1369101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369123 */     // GIR_Coverage, 22177,
     /* 1369123 */     GIR_EraseRootFromParent_Done,
     /* 1369124 */   // Label 19495: @1369124
     /* 1369124 */   GIM_Try, /*On fail goto*//*Label 19496*/ GIMT_Encode4(1369208), // Rule ID 22180 //
     /* 1369129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1369146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1369185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369207 */     // GIR_Coverage, 22180,
     /* 1369207 */     GIR_EraseRootFromParent_Done,
     /* 1369208 */   // Label 19496: @1369208
     /* 1369208 */   GIM_Try, /*On fail goto*//*Label 19497*/ GIMT_Encode4(1369292), // Rule ID 22181 //
     /* 1369213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1369230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369266 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1369269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369291 */     // GIR_Coverage, 22181,
     /* 1369291 */     GIR_EraseRootFromParent_Done,
     /* 1369292 */   // Label 19497: @1369292
     /* 1369292 */   GIM_Try, /*On fail goto*//*Label 19498*/ GIMT_Encode4(1369376), // Rule ID 22184 //
     /* 1369297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1369314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369350 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1369353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369375 */     // GIR_Coverage, 22184,
     /* 1369375 */     GIR_EraseRootFromParent_Done,
     /* 1369376 */   // Label 19498: @1369376
     /* 1369376 */   GIM_Try, /*On fail goto*//*Label 19499*/ GIMT_Encode4(1369460), // Rule ID 22185 //
     /* 1369381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1369398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369434 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1369437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369459 */     // GIR_Coverage, 22185,
     /* 1369459 */     GIR_EraseRootFromParent_Done,
     /* 1369460 */   // Label 19499: @1369460
     /* 1369460 */   GIM_Try, /*On fail goto*//*Label 19500*/ GIMT_Encode4(1369544), // Rule ID 22188 //
     /* 1369465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1369482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369518 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1369521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369543 */     // GIR_Coverage, 22188,
     /* 1369543 */     GIR_EraseRootFromParent_Done,
     /* 1369544 */   // Label 19500: @1369544
     /* 1369544 */   GIM_Try, /*On fail goto*//*Label 19501*/ GIMT_Encode4(1369628), // Rule ID 22189 //
     /* 1369549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1369566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1369605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369627 */     // GIR_Coverage, 22189,
     /* 1369627 */     GIR_EraseRootFromParent_Done,
     /* 1369628 */   // Label 19501: @1369628
     /* 1369628 */   GIM_Try, /*On fail goto*//*Label 19502*/ GIMT_Encode4(1369712), // Rule ID 22192 //
     /* 1369633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1369650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369686 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1369689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369711 */     // GIR_Coverage, 22192,
     /* 1369711 */     GIR_EraseRootFromParent_Done,
     /* 1369712 */   // Label 19502: @1369712
     /* 1369712 */   GIM_Try, /*On fail goto*//*Label 19503*/ GIMT_Encode4(1369796), // Rule ID 22193 //
     /* 1369717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1369734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1369773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369795 */     // GIR_Coverage, 22193,
     /* 1369795 */     GIR_EraseRootFromParent_Done,
     /* 1369796 */   // Label 19503: @1369796
     /* 1369796 */   GIM_Try, /*On fail goto*//*Label 19504*/ GIMT_Encode4(1369880), // Rule ID 22196 //
     /* 1369801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1369818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369854 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1369857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369879 */     // GIR_Coverage, 22196,
     /* 1369879 */     GIR_EraseRootFromParent_Done,
     /* 1369880 */   // Label 19504: @1369880
     /* 1369880 */   GIM_Try, /*On fail goto*//*Label 19505*/ GIMT_Encode4(1369964), // Rule ID 22197 //
     /* 1369885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1369902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369938 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1369941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369963 */     // GIR_Coverage, 22197,
     /* 1369963 */     GIR_EraseRootFromParent_Done,
     /* 1369964 */   // Label 19505: @1369964
     /* 1369964 */   GIM_Try, /*On fail goto*//*Label 19506*/ GIMT_Encode4(1370048), // Rule ID 22200 //
     /* 1369969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1369972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1369980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1369983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1369986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1369989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370022 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1370025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1370043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370047 */     // GIR_Coverage, 22200,
     /* 1370047 */     GIR_EraseRootFromParent_Done,
     /* 1370048 */   // Label 19506: @1370048
     /* 1370048 */   GIM_Try, /*On fail goto*//*Label 19507*/ GIMT_Encode4(1370132), // Rule ID 22201 //
     /* 1370053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1370056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1370064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1370067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1370070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1370073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1370109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1370127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370131 */     // GIR_Coverage, 22201,
     /* 1370131 */     GIR_EraseRootFromParent_Done,
     /* 1370132 */   // Label 19507: @1370132
     /* 1370132 */   GIM_Try, /*On fail goto*//*Label 19508*/ GIMT_Encode4(1370216), // Rule ID 22204 //
     /* 1370137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1370154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370190 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1370193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370215 */     // GIR_Coverage, 22204,
     /* 1370215 */     GIR_EraseRootFromParent_Done,
     /* 1370216 */   // Label 19508: @1370216
     /* 1370216 */   GIM_Try, /*On fail goto*//*Label 19509*/ GIMT_Encode4(1370300), // Rule ID 22205 //
     /* 1370221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1370238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370274 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1370277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370299 */     // GIR_Coverage, 22205,
     /* 1370299 */     GIR_EraseRootFromParent_Done,
     /* 1370300 */   // Label 19509: @1370300
     /* 1370300 */   GIM_Try, /*On fail goto*//*Label 19510*/ GIMT_Encode4(1370384), // Rule ID 22208 //
     /* 1370305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1370322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1370328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1370361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370383 */     // GIR_Coverage, 22208,
     /* 1370383 */     GIR_EraseRootFromParent_Done,
     /* 1370384 */   // Label 19510: @1370384
     /* 1370384 */   GIM_Try, /*On fail goto*//*Label 19511*/ GIMT_Encode4(1370468), // Rule ID 22209 //
     /* 1370389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1370406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1370412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1370445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370467 */     // GIR_Coverage, 22209,
     /* 1370467 */     GIR_EraseRootFromParent_Done,
     /* 1370468 */   // Label 19511: @1370468
     /* 1370468 */   GIM_Try, /*On fail goto*//*Label 19512*/ GIMT_Encode4(1370552), // Rule ID 22212 //
     /* 1370473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1370490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1370496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370526 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1370529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370551 */     // GIR_Coverage, 22212,
     /* 1370551 */     GIR_EraseRootFromParent_Done,
     /* 1370552 */   // Label 19512: @1370552
     /* 1370552 */   GIM_Try, /*On fail goto*//*Label 19513*/ GIMT_Encode4(1370636), // Rule ID 22213 //
     /* 1370557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1370574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1370580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370610 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1370613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370635 */     // GIR_Coverage, 22213,
     /* 1370635 */     GIR_EraseRootFromParent_Done,
     /* 1370636 */   // Label 19513: @1370636
     /* 1370636 */   GIM_Try, /*On fail goto*//*Label 19514*/ GIMT_Encode4(1370720), // Rule ID 22216 //
     /* 1370641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1370658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1370697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370719 */     // GIR_Coverage, 22216,
     /* 1370719 */     GIR_EraseRootFromParent_Done,
     /* 1370720 */   // Label 19514: @1370720
     /* 1370720 */   GIM_Try, /*On fail goto*//*Label 19515*/ GIMT_Encode4(1370804), // Rule ID 22217 //
     /* 1370725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1370742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370778 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1370781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370803 */     // GIR_Coverage, 22217,
     /* 1370803 */     GIR_EraseRootFromParent_Done,
     /* 1370804 */   // Label 19515: @1370804
     /* 1370804 */   GIM_Try, /*On fail goto*//*Label 19516*/ GIMT_Encode4(1370888), // Rule ID 22220 //
     /* 1370809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1370826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370862 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1370865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370887 */     // GIR_Coverage, 22220,
     /* 1370887 */     GIR_EraseRootFromParent_Done,
     /* 1370888 */   // Label 19516: @1370888
     /* 1370888 */   GIM_Try, /*On fail goto*//*Label 19517*/ GIMT_Encode4(1370972), // Rule ID 22221 //
     /* 1370893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1370910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1370949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370971 */     // GIR_Coverage, 22221,
     /* 1370971 */     GIR_EraseRootFromParent_Done,
     /* 1370972 */   // Label 19517: @1370972
     /* 1370972 */   GIM_Try, /*On fail goto*//*Label 19518*/ GIMT_Encode4(1371056), // Rule ID 22224 //
     /* 1370977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1370994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371030 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1371033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371055 */     // GIR_Coverage, 22224,
     /* 1371055 */     GIR_EraseRootFromParent_Done,
     /* 1371056 */   // Label 19518: @1371056
     /* 1371056 */   GIM_Try, /*On fail goto*//*Label 19519*/ GIMT_Encode4(1371140), // Rule ID 22225 //
     /* 1371061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1371078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1371117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371139 */     // GIR_Coverage, 22225,
     /* 1371139 */     GIR_EraseRootFromParent_Done,
     /* 1371140 */   // Label 19519: @1371140
     /* 1371140 */   GIM_Try, /*On fail goto*//*Label 19520*/ GIMT_Encode4(1371224), // Rule ID 22228 //
     /* 1371145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1371162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371198 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1371201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371223 */     // GIR_Coverage, 22228,
     /* 1371223 */     GIR_EraseRootFromParent_Done,
     /* 1371224 */   // Label 19520: @1371224
     /* 1371224 */   GIM_Try, /*On fail goto*//*Label 19521*/ GIMT_Encode4(1371308), // Rule ID 22229 //
     /* 1371229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1371246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371282 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1371285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371307 */     // GIR_Coverage, 22229,
     /* 1371307 */     GIR_EraseRootFromParent_Done,
     /* 1371308 */   // Label 19521: @1371308
     /* 1371308 */   GIM_Try, /*On fail goto*//*Label 19522*/ GIMT_Encode4(1371392), // Rule ID 22232 //
     /* 1371313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1371330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371366 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1371369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371391 */     // GIR_Coverage, 22232,
     /* 1371391 */     GIR_EraseRootFromParent_Done,
     /* 1371392 */   // Label 19522: @1371392
     /* 1371392 */   GIM_Try, /*On fail goto*//*Label 19523*/ GIMT_Encode4(1371476), // Rule ID 22233 //
     /* 1371397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1371414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371450 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1371453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371475 */     // GIR_Coverage, 22233,
     /* 1371475 */     GIR_EraseRootFromParent_Done,
     /* 1371476 */   // Label 19523: @1371476
     /* 1371476 */   GIM_Try, /*On fail goto*//*Label 19524*/ GIMT_Encode4(1371560), // Rule ID 22236 //
     /* 1371481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1371498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1371537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371559 */     // GIR_Coverage, 22236,
     /* 1371559 */     GIR_EraseRootFromParent_Done,
     /* 1371560 */   // Label 19524: @1371560
     /* 1371560 */   GIM_Try, /*On fail goto*//*Label 19525*/ GIMT_Encode4(1371644), // Rule ID 22237 //
     /* 1371565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1371582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1371621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371643 */     // GIR_Coverage, 22237,
     /* 1371643 */     GIR_EraseRootFromParent_Done,
     /* 1371644 */   // Label 19525: @1371644
     /* 1371644 */   GIM_Try, /*On fail goto*//*Label 19526*/ GIMT_Encode4(1371728), // Rule ID 22240 //
     /* 1371649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1371652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1371666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1371672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1371705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371727 */     // GIR_Coverage, 22240,
     /* 1371727 */     GIR_EraseRootFromParent_Done,
     /* 1371728 */   // Label 19526: @1371728
     /* 1371728 */   GIM_Try, /*On fail goto*//*Label 19527*/ GIMT_Encode4(1371812), // Rule ID 22241 //
     /* 1371733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1371736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1371750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1371756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1371789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371811 */     // GIR_Coverage, 22241,
     /* 1371811 */     GIR_EraseRootFromParent_Done,
     /* 1371812 */   // Label 19527: @1371812
     /* 1371812 */   GIM_Try, /*On fail goto*//*Label 19528*/ GIMT_Encode4(1371896), // Rule ID 22244 //
     /* 1371817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1371820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1371834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371870 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1371873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371895 */     // GIR_Coverage, 22244,
     /* 1371895 */     GIR_EraseRootFromParent_Done,
     /* 1371896 */   // Label 19528: @1371896
     /* 1371896 */   GIM_Try, /*On fail goto*//*Label 19529*/ GIMT_Encode4(1371980), // Rule ID 22245 //
     /* 1371901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1371904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1371918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371954 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1371957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371979 */     // GIR_Coverage, 22245,
     /* 1371979 */     GIR_EraseRootFromParent_Done,
     /* 1371980 */   // Label 19529: @1371980
     /* 1371980 */   GIM_Try, /*On fail goto*//*Label 19530*/ GIMT_Encode4(1372064), // Rule ID 22248 //
     /* 1371985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1371988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1372002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372038 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1372041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372063 */     // GIR_Coverage, 22248,
     /* 1372063 */     GIR_EraseRootFromParent_Done,
     /* 1372064 */   // Label 19530: @1372064
     /* 1372064 */   GIM_Try, /*On fail goto*//*Label 19531*/ GIMT_Encode4(1372148), // Rule ID 22249 //
     /* 1372069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1372072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1372086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372122 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1372125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372147 */     // GIR_Coverage, 22249,
     /* 1372147 */     GIR_EraseRootFromParent_Done,
     /* 1372148 */   // Label 19531: @1372148
     /* 1372148 */   GIM_Try, /*On fail goto*//*Label 19532*/ GIMT_Encode4(1372232), // Rule ID 22252 //
     /* 1372153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1372170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372206 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1372209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372231 */     // GIR_Coverage, 22252,
     /* 1372231 */     GIR_EraseRootFromParent_Done,
     /* 1372232 */   // Label 19532: @1372232
     /* 1372232 */   GIM_Try, /*On fail goto*//*Label 19533*/ GIMT_Encode4(1372316), // Rule ID 22253 //
     /* 1372237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1372254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372290 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1372293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372315 */     // GIR_Coverage, 22253,
     /* 1372315 */     GIR_EraseRootFromParent_Done,
     /* 1372316 */   // Label 19533: @1372316
     /* 1372316 */   GIM_Try, /*On fail goto*//*Label 19534*/ GIMT_Encode4(1372400), // Rule ID 22256 //
     /* 1372321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1372338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372374 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1372377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372399 */     // GIR_Coverage, 22256,
     /* 1372399 */     GIR_EraseRootFromParent_Done,
     /* 1372400 */   // Label 19534: @1372400
     /* 1372400 */   GIM_Try, /*On fail goto*//*Label 19535*/ GIMT_Encode4(1372484), // Rule ID 22257 //
     /* 1372405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1372422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372458 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1372461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372483 */     // GIR_Coverage, 22257,
     /* 1372483 */     GIR_EraseRootFromParent_Done,
     /* 1372484 */   // Label 19535: @1372484
     /* 1372484 */   GIM_Try, /*On fail goto*//*Label 19536*/ GIMT_Encode4(1372568), // Rule ID 22260 //
     /* 1372489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1372506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372542 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1372545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372567 */     // GIR_Coverage, 22260,
     /* 1372567 */     GIR_EraseRootFromParent_Done,
     /* 1372568 */   // Label 19536: @1372568
     /* 1372568 */   GIM_Try, /*On fail goto*//*Label 19537*/ GIMT_Encode4(1372652), // Rule ID 22261 //
     /* 1372573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1372590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372626 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1372629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372651 */     // GIR_Coverage, 22261,
     /* 1372651 */     GIR_EraseRootFromParent_Done,
     /* 1372652 */   // Label 19537: @1372652
     /* 1372652 */   GIM_Try, /*On fail goto*//*Label 19538*/ GIMT_Encode4(1372736), // Rule ID 22264 //
     /* 1372657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1372674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1372713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372735 */     // GIR_Coverage, 22264,
     /* 1372735 */     GIR_EraseRootFromParent_Done,
     /* 1372736 */   // Label 19538: @1372736
     /* 1372736 */   GIM_Try, /*On fail goto*//*Label 19539*/ GIMT_Encode4(1372820), // Rule ID 22265 //
     /* 1372741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1372758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372794 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1372797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372819 */     // GIR_Coverage, 22265,
     /* 1372819 */     GIR_EraseRootFromParent_Done,
     /* 1372820 */   // Label 19539: @1372820
     /* 1372820 */   GIM_Try, /*On fail goto*//*Label 19540*/ GIMT_Encode4(1372904), // Rule ID 22268 //
     /* 1372825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1372842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372878 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1372881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372903 */     // GIR_Coverage, 22268,
     /* 1372903 */     GIR_EraseRootFromParent_Done,
     /* 1372904 */   // Label 19540: @1372904
     /* 1372904 */   GIM_Try, /*On fail goto*//*Label 19541*/ GIMT_Encode4(1372988), // Rule ID 22269 //
     /* 1372909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1372926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372962 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1372965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372987 */     // GIR_Coverage, 22269,
     /* 1372987 */     GIR_EraseRootFromParent_Done,
     /* 1372988 */   // Label 19541: @1372988
     /* 1372988 */   GIM_Try, /*On fail goto*//*Label 19542*/ GIMT_Encode4(1373072), // Rule ID 22272 //
     /* 1372993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1373010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373046 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1373049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373071 */     // GIR_Coverage, 22272,
     /* 1373071 */     GIR_EraseRootFromParent_Done,
     /* 1373072 */   // Label 19542: @1373072
     /* 1373072 */   GIM_Try, /*On fail goto*//*Label 19543*/ GIMT_Encode4(1373156), // Rule ID 22273 //
     /* 1373077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1373094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1373133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373155 */     // GIR_Coverage, 22273,
     /* 1373155 */     GIR_EraseRootFromParent_Done,
     /* 1373156 */   // Label 19543: @1373156
     /* 1373156 */   GIM_Try, /*On fail goto*//*Label 19544*/ GIMT_Encode4(1373240), // Rule ID 22276 //
     /* 1373161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1373178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373214 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1373217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373239 */     // GIR_Coverage, 22276,
     /* 1373239 */     GIR_EraseRootFromParent_Done,
     /* 1373240 */   // Label 19544: @1373240
     /* 1373240 */   GIM_Try, /*On fail goto*//*Label 19545*/ GIMT_Encode4(1373324), // Rule ID 22277 //
     /* 1373245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1373262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373298 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1373301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373323 */     // GIR_Coverage, 22277,
     /* 1373323 */     GIR_EraseRootFromParent_Done,
     /* 1373324 */   // Label 19545: @1373324
     /* 1373324 */   GIM_Try, /*On fail goto*//*Label 19546*/ GIMT_Encode4(1373408), // Rule ID 22280 //
     /* 1373329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1373346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373382 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1373385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373407 */     // GIR_Coverage, 22280,
     /* 1373407 */     GIR_EraseRootFromParent_Done,
     /* 1373408 */   // Label 19546: @1373408
     /* 1373408 */   GIM_Try, /*On fail goto*//*Label 19547*/ GIMT_Encode4(1373492), // Rule ID 22281 //
     /* 1373413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1373430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373466 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1373469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373491 */     // GIR_Coverage, 22281,
     /* 1373491 */     GIR_EraseRootFromParent_Done,
     /* 1373492 */   // Label 19547: @1373492
     /* 1373492 */   GIM_Try, /*On fail goto*//*Label 19548*/ GIMT_Encode4(1373576), // Rule ID 22284 //
     /* 1373497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1373514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1373553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373575 */     // GIR_Coverage, 22284,
     /* 1373575 */     GIR_EraseRootFromParent_Done,
     /* 1373576 */   // Label 19548: @1373576
     /* 1373576 */   GIM_Try, /*On fail goto*//*Label 19549*/ GIMT_Encode4(1373660), // Rule ID 22285 //
     /* 1373581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1373598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373634 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1373637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373659 */     // GIR_Coverage, 22285,
     /* 1373659 */     GIR_EraseRootFromParent_Done,
     /* 1373660 */   // Label 19549: @1373660
     /* 1373660 */   GIM_Try, /*On fail goto*//*Label 19550*/ GIMT_Encode4(1373744), // Rule ID 22288 //
     /* 1373665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1373668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1373682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1373685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373718 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1373721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373743 */     // GIR_Coverage, 22288,
     /* 1373743 */     GIR_EraseRootFromParent_Done,
     /* 1373744 */   // Label 19550: @1373744
     /* 1373744 */   GIM_Try, /*On fail goto*//*Label 19551*/ GIMT_Encode4(1373828), // Rule ID 22289 //
     /* 1373749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1373752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1373766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1373769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1373805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373827 */     // GIR_Coverage, 22289,
     /* 1373827 */     GIR_EraseRootFromParent_Done,
     /* 1373828 */   // Label 19551: @1373828
     /* 1373828 */   GIM_Try, /*On fail goto*//*Label 19552*/ GIMT_Encode4(1373912), // Rule ID 22292 //
     /* 1373833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1373850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1373856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1373871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373886 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1373889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373911 */     // GIR_Coverage, 22292,
     /* 1373911 */     GIR_EraseRootFromParent_Done,
     /* 1373912 */   // Label 19552: @1373912
     /* 1373912 */   GIM_Try, /*On fail goto*//*Label 19553*/ GIMT_Encode4(1373996), // Rule ID 22293 //
     /* 1373917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1373934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1373940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1373955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373970 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1373973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373995 */     // GIR_Coverage, 22293,
     /* 1373995 */     GIR_EraseRootFromParent_Done,
     /* 1373996 */   // Label 19553: @1373996
     /* 1373996 */   GIM_Try, /*On fail goto*//*Label 19554*/ GIMT_Encode4(1374080), // Rule ID 22296 //
     /* 1374001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374054 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1374057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374079 */     // GIR_Coverage, 22296,
     /* 1374079 */     GIR_EraseRootFromParent_Done,
     /* 1374080 */   // Label 19554: @1374080
     /* 1374080 */   GIM_Try, /*On fail goto*//*Label 19555*/ GIMT_Encode4(1374164), // Rule ID 22297 //
     /* 1374085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374138 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1374141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374163 */     // GIR_Coverage, 22297,
     /* 1374163 */     GIR_EraseRootFromParent_Done,
     /* 1374164 */   // Label 19555: @1374164
     /* 1374164 */   GIM_Try, /*On fail goto*//*Label 19556*/ GIMT_Encode4(1374248), // Rule ID 22300 //
     /* 1374169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1374186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1374192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374222 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1374225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374247 */     // GIR_Coverage, 22300,
     /* 1374247 */     GIR_EraseRootFromParent_Done,
     /* 1374248 */   // Label 19556: @1374248
     /* 1374248 */   GIM_Try, /*On fail goto*//*Label 19557*/ GIMT_Encode4(1374332), // Rule ID 22301 //
     /* 1374253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1374270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1374276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374306 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1374309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374331 */     // GIR_Coverage, 22301,
     /* 1374331 */     GIR_EraseRootFromParent_Done,
     /* 1374332 */   // Label 19557: @1374332
     /* 1374332 */   GIM_Try, /*On fail goto*//*Label 19558*/ GIMT_Encode4(1374416), // Rule ID 22304 //
     /* 1374337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1374354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1374393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374415 */     // GIR_Coverage, 22304,
     /* 1374415 */     GIR_EraseRootFromParent_Done,
     /* 1374416 */   // Label 19558: @1374416
     /* 1374416 */   GIM_Try, /*On fail goto*//*Label 19559*/ GIMT_Encode4(1374500), // Rule ID 22305 //
     /* 1374421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1374438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374474 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1374477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374499 */     // GIR_Coverage, 22305,
     /* 1374499 */     GIR_EraseRootFromParent_Done,
     /* 1374500 */   // Label 19559: @1374500
     /* 1374500 */   GIM_Try, /*On fail goto*//*Label 19560*/ GIMT_Encode4(1374584), // Rule ID 22308 //
     /* 1374505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1374522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1374561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374583 */     // GIR_Coverage, 22308,
     /* 1374583 */     GIR_EraseRootFromParent_Done,
     /* 1374584 */   // Label 19560: @1374584
     /* 1374584 */   GIM_Try, /*On fail goto*//*Label 19561*/ GIMT_Encode4(1374668), // Rule ID 22309 //
     /* 1374589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1374606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374642 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1374645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374667 */     // GIR_Coverage, 22309,
     /* 1374667 */     GIR_EraseRootFromParent_Done,
     /* 1374668 */   // Label 19561: @1374668
     /* 1374668 */   GIM_Try, /*On fail goto*//*Label 19562*/ GIMT_Encode4(1374752), // Rule ID 22312 //
     /* 1374673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1374690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374726 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1374729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374751 */     // GIR_Coverage, 22312,
     /* 1374751 */     GIR_EraseRootFromParent_Done,
     /* 1374752 */   // Label 19562: @1374752
     /* 1374752 */   GIM_Try, /*On fail goto*//*Label 19563*/ GIMT_Encode4(1374836), // Rule ID 22313 //
     /* 1374757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1374774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374810 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1374813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374835 */     // GIR_Coverage, 22313,
     /* 1374835 */     GIR_EraseRootFromParent_Done,
     /* 1374836 */   // Label 19563: @1374836
     /* 1374836 */   GIM_Try, /*On fail goto*//*Label 19564*/ GIMT_Encode4(1374920), // Rule ID 22316 //
     /* 1374841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1374852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1374855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1374858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1374861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1374864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374894 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1374897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1374915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374919 */     // GIR_Coverage, 22316,
     /* 1374919 */     GIR_EraseRootFromParent_Done,
     /* 1374920 */   // Label 19564: @1374920
     /* 1374920 */   GIM_Try, /*On fail goto*//*Label 19565*/ GIMT_Encode4(1375004), // Rule ID 22317 //
     /* 1374925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1374936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1374939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1374942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1374945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1374948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374978 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1374981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1374999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375003 */     // GIR_Coverage, 22317,
     /* 1375003 */     GIR_EraseRootFromParent_Done,
     /* 1375004 */   // Label 19565: @1375004
     /* 1375004 */   GIM_Try, /*On fail goto*//*Label 19566*/ GIMT_Encode4(1375088), // Rule ID 22320 //
     /* 1375009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375062 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1375065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375087 */     // GIR_Coverage, 22320,
     /* 1375087 */     GIR_EraseRootFromParent_Done,
     /* 1375088 */   // Label 19566: @1375088
     /* 1375088 */   GIM_Try, /*On fail goto*//*Label 19567*/ GIMT_Encode4(1375172), // Rule ID 22321 //
     /* 1375093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375146 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1375149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375171 */     // GIR_Coverage, 22321,
     /* 1375171 */     GIR_EraseRootFromParent_Done,
     /* 1375172 */   // Label 19567: @1375172
     /* 1375172 */   GIM_Try, /*On fail goto*//*Label 19568*/ GIMT_Encode4(1375256), // Rule ID 22324 //
     /* 1375177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1375194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1375233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375255 */     // GIR_Coverage, 22324,
     /* 1375255 */     GIR_EraseRootFromParent_Done,
     /* 1375256 */   // Label 19568: @1375256
     /* 1375256 */   GIM_Try, /*On fail goto*//*Label 19569*/ GIMT_Encode4(1375340), // Rule ID 22325 //
     /* 1375261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1375278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375314 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1375317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375339 */     // GIR_Coverage, 22325,
     /* 1375339 */     GIR_EraseRootFromParent_Done,
     /* 1375340 */   // Label 19569: @1375340
     /* 1375340 */   GIM_Try, /*On fail goto*//*Label 19570*/ GIMT_Encode4(1375424), // Rule ID 22328 //
     /* 1375345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1375362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1375368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375398 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1375401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375423 */     // GIR_Coverage, 22328,
     /* 1375423 */     GIR_EraseRootFromParent_Done,
     /* 1375424 */   // Label 19570: @1375424
     /* 1375424 */   GIM_Try, /*On fail goto*//*Label 19571*/ GIMT_Encode4(1375508), // Rule ID 22329 //
     /* 1375429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1375446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1375452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1375485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375507 */     // GIR_Coverage, 22329,
     /* 1375507 */     GIR_EraseRootFromParent_Done,
     /* 1375508 */   // Label 19571: @1375508
     /* 1375508 */   GIM_Try, /*On fail goto*//*Label 19572*/ GIMT_Encode4(1375592), // Rule ID 22332 //
     /* 1375513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1375530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1375569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375591 */     // GIR_Coverage, 22332,
     /* 1375591 */     GIR_EraseRootFromParent_Done,
     /* 1375592 */   // Label 19572: @1375592
     /* 1375592 */   GIM_Try, /*On fail goto*//*Label 19573*/ GIMT_Encode4(1375676), // Rule ID 22333 //
     /* 1375597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1375614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375650 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1375653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375675 */     // GIR_Coverage, 22333,
     /* 1375675 */     GIR_EraseRootFromParent_Done,
     /* 1375676 */   // Label 19573: @1375676
     /* 1375676 */   GIM_Try, /*On fail goto*//*Label 19574*/ GIMT_Encode4(1375760), // Rule ID 22336 //
     /* 1375681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1375698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375734 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1375737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375759 */     // GIR_Coverage, 22336,
     /* 1375759 */     GIR_EraseRootFromParent_Done,
     /* 1375760 */   // Label 19574: @1375760
     /* 1375760 */   GIM_Try, /*On fail goto*//*Label 19575*/ GIMT_Encode4(1375844), // Rule ID 22337 //
     /* 1375765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1375782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375818 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1375821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375843 */     // GIR_Coverage, 22337,
     /* 1375843 */     GIR_EraseRootFromParent_Done,
     /* 1375844 */   // Label 19575: @1375844
     /* 1375844 */   GIM_Try, /*On fail goto*//*Label 19576*/ GIMT_Encode4(1375928), // Rule ID 22340 //
     /* 1375849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1375860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1375863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1375866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1375869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1375872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1375905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1375923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375927 */     // GIR_Coverage, 22340,
     /* 1375927 */     GIR_EraseRootFromParent_Done,
     /* 1375928 */   // Label 19576: @1375928
     /* 1375928 */   GIM_Try, /*On fail goto*//*Label 19577*/ GIMT_Encode4(1376012), // Rule ID 22341 //
     /* 1375933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1375944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1375947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1375950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1375953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1375956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375986 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1375989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376011 */     // GIR_Coverage, 22341,
     /* 1376011 */     GIR_EraseRootFromParent_Done,
     /* 1376012 */   // Label 19577: @1376012
     /* 1376012 */   GIM_Try, /*On fail goto*//*Label 19578*/ GIMT_Encode4(1376096), // Rule ID 22344 //
     /* 1376017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1376073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376095 */     // GIR_Coverage, 22344,
     /* 1376095 */     GIR_EraseRootFromParent_Done,
     /* 1376096 */   // Label 19578: @1376096
     /* 1376096 */   GIM_Try, /*On fail goto*//*Label 19579*/ GIMT_Encode4(1376180), // Rule ID 22345 //
     /* 1376101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376154 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1376157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376179 */     // GIR_Coverage, 22345,
     /* 1376179 */     GIR_EraseRootFromParent_Done,
     /* 1376180 */   // Label 19579: @1376180
     /* 1376180 */   GIM_Try, /*On fail goto*//*Label 19580*/ GIMT_Encode4(1376264), // Rule ID 22348 //
     /* 1376185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1376202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376238 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1376241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376263 */     // GIR_Coverage, 22348,
     /* 1376263 */     GIR_EraseRootFromParent_Done,
     /* 1376264 */   // Label 19580: @1376264
     /* 1376264 */   GIM_Try, /*On fail goto*//*Label 19581*/ GIMT_Encode4(1376348), // Rule ID 22349 //
     /* 1376269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1376286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376322 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1376325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376347 */     // GIR_Coverage, 22349,
     /* 1376347 */     GIR_EraseRootFromParent_Done,
     /* 1376348 */   // Label 19581: @1376348
     /* 1376348 */   GIM_Try, /*On fail goto*//*Label 19582*/ GIMT_Encode4(1376432), // Rule ID 22352 //
     /* 1376353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1376370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376406 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1376409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376431 */     // GIR_Coverage, 22352,
     /* 1376431 */     GIR_EraseRootFromParent_Done,
     /* 1376432 */   // Label 19582: @1376432
     /* 1376432 */   GIM_Try, /*On fail goto*//*Label 19583*/ GIMT_Encode4(1376516), // Rule ID 22353 //
     /* 1376437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1376454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1376493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376515 */     // GIR_Coverage, 22353,
     /* 1376515 */     GIR_EraseRootFromParent_Done,
     /* 1376516 */   // Label 19583: @1376516
     /* 1376516 */   GIM_Try, /*On fail goto*//*Label 19584*/ GIMT_Encode4(1376600), // Rule ID 22356 //
     /* 1376521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1376538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376574 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1376577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376599 */     // GIR_Coverage, 22356,
     /* 1376599 */     GIR_EraseRootFromParent_Done,
     /* 1376600 */   // Label 19584: @1376600
     /* 1376600 */   GIM_Try, /*On fail goto*//*Label 19585*/ GIMT_Encode4(1376684), // Rule ID 22357 //
     /* 1376605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1376622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376658 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1376661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376683 */     // GIR_Coverage, 22357,
     /* 1376683 */     GIR_EraseRootFromParent_Done,
     /* 1376684 */   // Label 19585: @1376684
     /* 1376684 */   GIM_Try, /*On fail goto*//*Label 19586*/ GIMT_Encode4(1376768), // Rule ID 22360 //
     /* 1376689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1376700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1376703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1376706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1376709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376742 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1376745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376767 */     // GIR_Coverage, 22360,
     /* 1376767 */     GIR_EraseRootFromParent_Done,
     /* 1376768 */   // Label 19586: @1376768
     /* 1376768 */   GIM_Try, /*On fail goto*//*Label 19587*/ GIMT_Encode4(1376852), // Rule ID 22361 //
     /* 1376773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1376784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1376787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1376790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1376793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1376829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376851 */     // GIR_Coverage, 22361,
     /* 1376851 */     GIR_EraseRootFromParent_Done,
     /* 1376852 */   // Label 19587: @1376852
     /* 1376852 */   GIM_Try, /*On fail goto*//*Label 19588*/ GIMT_Encode4(1376936), // Rule ID 22364 //
     /* 1376857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1376874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1376880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376910 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1376913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376935 */     // GIR_Coverage, 22364,
     /* 1376935 */     GIR_EraseRootFromParent_Done,
     /* 1376936 */   // Label 19588: @1376936
     /* 1376936 */   GIM_Try, /*On fail goto*//*Label 19589*/ GIMT_Encode4(1377020), // Rule ID 22365 //
     /* 1376941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1376958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1376964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376994 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1376997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377019 */     // GIR_Coverage, 22365,
     /* 1377019 */     GIR_EraseRootFromParent_Done,
     /* 1377020 */   // Label 19589: @1377020
     /* 1377020 */   GIM_Try, /*On fail goto*//*Label 19590*/ GIMT_Encode4(1377104), // Rule ID 22368 //
     /* 1377025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377078 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1377081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377103 */     // GIR_Coverage, 22368,
     /* 1377103 */     GIR_EraseRootFromParent_Done,
     /* 1377104 */   // Label 19590: @1377104
     /* 1377104 */   GIM_Try, /*On fail goto*//*Label 19591*/ GIMT_Encode4(1377188), // Rule ID 22369 //
     /* 1377109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377162 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1377165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377187 */     // GIR_Coverage, 22369,
     /* 1377187 */     GIR_EraseRootFromParent_Done,
     /* 1377188 */   // Label 19591: @1377188
     /* 1377188 */   GIM_Try, /*On fail goto*//*Label 19592*/ GIMT_Encode4(1377272), // Rule ID 22372 //
     /* 1377193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1377210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377246 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1377249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377271 */     // GIR_Coverage, 22372,
     /* 1377271 */     GIR_EraseRootFromParent_Done,
     /* 1377272 */   // Label 19592: @1377272
     /* 1377272 */   GIM_Try, /*On fail goto*//*Label 19593*/ GIMT_Encode4(1377356), // Rule ID 22373 //
     /* 1377277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1377294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377330 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1377333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377355 */     // GIR_Coverage, 22373,
     /* 1377355 */     GIR_EraseRootFromParent_Done,
     /* 1377356 */   // Label 19593: @1377356
     /* 1377356 */   GIM_Try, /*On fail goto*//*Label 19594*/ GIMT_Encode4(1377440), // Rule ID 22376 //
     /* 1377361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1377364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1377378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1377381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1377417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377439 */     // GIR_Coverage, 22376,
     /* 1377439 */     GIR_EraseRootFromParent_Done,
     /* 1377440 */   // Label 19594: @1377440
     /* 1377440 */   GIM_Try, /*On fail goto*//*Label 19595*/ GIMT_Encode4(1377524), // Rule ID 22377 //
     /* 1377445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1377448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1377462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1377465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377498 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1377501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377523 */     // GIR_Coverage, 22377,
     /* 1377523 */     GIR_EraseRootFromParent_Done,
     /* 1377524 */   // Label 19595: @1377524
     /* 1377524 */   GIM_Try, /*On fail goto*//*Label 19596*/ GIMT_Encode4(1377608), // Rule ID 22380 //
     /* 1377529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1377546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1377552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1377567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1377585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377607 */     // GIR_Coverage, 22380,
     /* 1377607 */     GIR_EraseRootFromParent_Done,
     /* 1377608 */   // Label 19596: @1377608
     /* 1377608 */   GIM_Try, /*On fail goto*//*Label 19597*/ GIMT_Encode4(1377692), // Rule ID 22381 //
     /* 1377613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1377630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1377636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1377651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377666 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1377669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377691 */     // GIR_Coverage, 22381,
     /* 1377691 */     GIR_EraseRootFromParent_Done,
     /* 1377692 */   // Label 19597: @1377692
     /* 1377692 */   GIM_Try, /*On fail goto*//*Label 19598*/ GIMT_Encode4(1377776), // Rule ID 22384 //
     /* 1377697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1377714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1377720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1377735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377750 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1377753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377775 */     // GIR_Coverage, 22384,
     /* 1377775 */     GIR_EraseRootFromParent_Done,
     /* 1377776 */   // Label 19598: @1377776
     /* 1377776 */   GIM_Try, /*On fail goto*//*Label 19599*/ GIMT_Encode4(1377860), // Rule ID 22385 //
     /* 1377781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1377798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1377804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1377819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377834 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1377837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377859 */     // GIR_Coverage, 22385,
     /* 1377859 */     GIR_EraseRootFromParent_Done,
     /* 1377860 */   // Label 19599: @1377860
     /* 1377860 */   GIM_Try, /*On fail goto*//*Label 19600*/ GIMT_Encode4(1377944), // Rule ID 22388 //
     /* 1377865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1377882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1377888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1377903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377918 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1377921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377943 */     // GIR_Coverage, 22388,
     /* 1377943 */     GIR_EraseRootFromParent_Done,
     /* 1377944 */   // Label 19600: @1377944
     /* 1377944 */   GIM_Try, /*On fail goto*//*Label 19601*/ GIMT_Encode4(1378028), // Rule ID 22389 //
     /* 1377949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1377966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1377972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1377987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378002 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1378005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378027 */     // GIR_Coverage, 22389,
     /* 1378027 */     GIR_EraseRootFromParent_Done,
     /* 1378028 */   // Label 19601: @1378028
     /* 1378028 */   GIM_Try, /*On fail goto*//*Label 19602*/ GIMT_Encode4(1378112), // Rule ID 22392 //
     /* 1378033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1378089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378111 */     // GIR_Coverage, 22392,
     /* 1378111 */     GIR_EraseRootFromParent_Done,
     /* 1378112 */   // Label 19602: @1378112
     /* 1378112 */   GIM_Try, /*On fail goto*//*Label 19603*/ GIMT_Encode4(1378196), // Rule ID 22393 //
     /* 1378117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378170 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1378173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378195 */     // GIR_Coverage, 22393,
     /* 1378195 */     GIR_EraseRootFromParent_Done,
     /* 1378196 */   // Label 19603: @1378196
     /* 1378196 */   GIM_Try, /*On fail goto*//*Label 19604*/ GIMT_Encode4(1378280), // Rule ID 22396 //
     /* 1378201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1378218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378254 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1378257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378279 */     // GIR_Coverage, 22396,
     /* 1378279 */     GIR_EraseRootFromParent_Done,
     /* 1378280 */   // Label 19604: @1378280
     /* 1378280 */   GIM_Try, /*On fail goto*//*Label 19605*/ GIMT_Encode4(1378364), // Rule ID 22397 //
     /* 1378285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1378302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378338 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1378341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378363 */     // GIR_Coverage, 22397,
     /* 1378363 */     GIR_EraseRootFromParent_Done,
     /* 1378364 */   // Label 19605: @1378364
     /* 1378364 */   GIM_Try, /*On fail goto*//*Label 19606*/ GIMT_Encode4(1378448), // Rule ID 22400 //
     /* 1378369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1378386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378422 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1378425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378447 */     // GIR_Coverage, 22400,
     /* 1378447 */     GIR_EraseRootFromParent_Done,
     /* 1378448 */   // Label 19606: @1378448
     /* 1378448 */   GIM_Try, /*On fail goto*//*Label 19607*/ GIMT_Encode4(1378532), // Rule ID 22401 //
     /* 1378453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1378470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1378509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378531 */     // GIR_Coverage, 22401,
     /* 1378531 */     GIR_EraseRootFromParent_Done,
     /* 1378532 */   // Label 19607: @1378532
     /* 1378532 */   GIM_Try, /*On fail goto*//*Label 19608*/ GIMT_Encode4(1378616), // Rule ID 22404 //
     /* 1378537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1378554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1378560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378590 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1378593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378615 */     // GIR_Coverage, 22404,
     /* 1378615 */     GIR_EraseRootFromParent_Done,
     /* 1378616 */   // Label 19608: @1378616
     /* 1378616 */   GIM_Try, /*On fail goto*//*Label 19609*/ GIMT_Encode4(1378700), // Rule ID 22405 //
     /* 1378621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1378638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1378644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1378677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378699 */     // GIR_Coverage, 22405,
     /* 1378699 */     GIR_EraseRootFromParent_Done,
     /* 1378700 */   // Label 19609: @1378700
     /* 1378700 */   GIM_Try, /*On fail goto*//*Label 19610*/ GIMT_Encode4(1378784), // Rule ID 22408 //
     /* 1378705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1378722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378758 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1378761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378783 */     // GIR_Coverage, 22408,
     /* 1378783 */     GIR_EraseRootFromParent_Done,
     /* 1378784 */   // Label 19610: @1378784
     /* 1378784 */   GIM_Try, /*On fail goto*//*Label 19611*/ GIMT_Encode4(1378868), // Rule ID 22409 //
     /* 1378789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1378806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1378845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378867 */     // GIR_Coverage, 22409,
     /* 1378867 */     GIR_EraseRootFromParent_Done,
     /* 1378868 */   // Label 19611: @1378868
     /* 1378868 */   GIM_Try, /*On fail goto*//*Label 19612*/ GIMT_Encode4(1378952), // Rule ID 22412 //
     /* 1378873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1378890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378926 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1378929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378951 */     // GIR_Coverage, 22412,
     /* 1378951 */     GIR_EraseRootFromParent_Done,
     /* 1378952 */   // Label 19612: @1378952
     /* 1378952 */   GIM_Try, /*On fail goto*//*Label 19613*/ GIMT_Encode4(1379036), // Rule ID 22413 //
     /* 1378957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1378974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379010 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1379013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379035 */     // GIR_Coverage, 22413,
     /* 1379035 */     GIR_EraseRootFromParent_Done,
     /* 1379036 */   // Label 19613: @1379036
     /* 1379036 */   GIM_Try, /*On fail goto*//*Label 19614*/ GIMT_Encode4(1379120), // Rule ID 22416 //
     /* 1379041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1379097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379119 */     // GIR_Coverage, 22416,
     /* 1379119 */     GIR_EraseRootFromParent_Done,
     /* 1379120 */   // Label 19614: @1379120
     /* 1379120 */   GIM_Try, /*On fail goto*//*Label 19615*/ GIMT_Encode4(1379204), // Rule ID 22417 //
     /* 1379125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379178 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1379181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379203 */     // GIR_Coverage, 22417,
     /* 1379203 */     GIR_EraseRootFromParent_Done,
     /* 1379204 */   // Label 19615: @1379204
     /* 1379204 */   GIM_Try, /*On fail goto*//*Label 19616*/ GIMT_Encode4(1379288), // Rule ID 22420 //
     /* 1379209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1379226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379262 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1379265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379287 */     // GIR_Coverage, 22420,
     /* 1379287 */     GIR_EraseRootFromParent_Done,
     /* 1379288 */   // Label 19616: @1379288
     /* 1379288 */   GIM_Try, /*On fail goto*//*Label 19617*/ GIMT_Encode4(1379372), // Rule ID 22421 //
     /* 1379293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1379310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379346 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1379349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379371 */     // GIR_Coverage, 22421,
     /* 1379371 */     GIR_EraseRootFromParent_Done,
     /* 1379372 */   // Label 19617: @1379372
     /* 1379372 */   GIM_Try, /*On fail goto*//*Label 19618*/ GIMT_Encode4(1379456), // Rule ID 22424 //
     /* 1379377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1379394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379430 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1379433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379455 */     // GIR_Coverage, 22424,
     /* 1379455 */     GIR_EraseRootFromParent_Done,
     /* 1379456 */   // Label 19618: @1379456
     /* 1379456 */   GIM_Try, /*On fail goto*//*Label 19619*/ GIMT_Encode4(1379540), // Rule ID 22425 //
     /* 1379461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1379478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379514 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1379517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379539 */     // GIR_Coverage, 22425,
     /* 1379539 */     GIR_EraseRootFromParent_Done,
     /* 1379540 */   // Label 19619: @1379540
     /* 1379540 */   GIM_Try, /*On fail goto*//*Label 19620*/ GIMT_Encode4(1379624), // Rule ID 22428 //
     /* 1379545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1379562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1379568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379598 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1379601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379623 */     // GIR_Coverage, 22428,
     /* 1379623 */     GIR_EraseRootFromParent_Done,
     /* 1379624 */   // Label 19620: @1379624
     /* 1379624 */   GIM_Try, /*On fail goto*//*Label 19621*/ GIMT_Encode4(1379708), // Rule ID 22429 //
     /* 1379629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1379646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1379652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379682 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1379685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379707 */     // GIR_Coverage, 22429,
     /* 1379707 */     GIR_EraseRootFromParent_Done,
     /* 1379708 */   // Label 19621: @1379708
     /* 1379708 */   GIM_Try, /*On fail goto*//*Label 19622*/ GIMT_Encode4(1379792), // Rule ID 22432 //
     /* 1379713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1379730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379766 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1379769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379791 */     // GIR_Coverage, 22432,
     /* 1379791 */     GIR_EraseRootFromParent_Done,
     /* 1379792 */   // Label 19622: @1379792
     /* 1379792 */   GIM_Try, /*On fail goto*//*Label 19623*/ GIMT_Encode4(1379876), // Rule ID 22433 //
     /* 1379797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1379814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1379853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379875 */     // GIR_Coverage, 22433,
     /* 1379875 */     GIR_EraseRootFromParent_Done,
     /* 1379876 */   // Label 19623: @1379876
     /* 1379876 */   GIM_Try, /*On fail goto*//*Label 19624*/ GIMT_Encode4(1379960), // Rule ID 22436 //
     /* 1379881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1379898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379934 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1379937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379959 */     // GIR_Coverage, 22436,
     /* 1379959 */     GIR_EraseRootFromParent_Done,
     /* 1379960 */   // Label 19624: @1379960
     /* 1379960 */   GIM_Try, /*On fail goto*//*Label 19625*/ GIMT_Encode4(1380044), // Rule ID 22437 //
     /* 1379965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1379982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380018 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1380021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380043 */     // GIR_Coverage, 22437,
     /* 1380043 */     GIR_EraseRootFromParent_Done,
     /* 1380044 */   // Label 19625: @1380044
     /* 1380044 */   GIM_Try, /*On fail goto*//*Label 19626*/ GIMT_Encode4(1380128), // Rule ID 22440 //
     /* 1380049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1380105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380127 */     // GIR_Coverage, 22440,
     /* 1380127 */     GIR_EraseRootFromParent_Done,
     /* 1380128 */   // Label 19626: @1380128
     /* 1380128 */   GIM_Try, /*On fail goto*//*Label 19627*/ GIMT_Encode4(1380212), // Rule ID 22441 //
     /* 1380133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380186 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1380189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380211 */     // GIR_Coverage, 22441,
     /* 1380211 */     GIR_EraseRootFromParent_Done,
     /* 1380212 */   // Label 19627: @1380212
     /* 1380212 */   GIM_Try, /*On fail goto*//*Label 19628*/ GIMT_Encode4(1380296), // Rule ID 22444 //
     /* 1380217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1380234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380270 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1380273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380295 */     // GIR_Coverage, 22444,
     /* 1380295 */     GIR_EraseRootFromParent_Done,
     /* 1380296 */   // Label 19628: @1380296
     /* 1380296 */   GIM_Try, /*On fail goto*//*Label 19629*/ GIMT_Encode4(1380380), // Rule ID 22445 //
     /* 1380301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1380318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380354 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1380357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380379 */     // GIR_Coverage, 22445,
     /* 1380379 */     GIR_EraseRootFromParent_Done,
     /* 1380380 */   // Label 19629: @1380380
     /* 1380380 */   GIM_Try, /*On fail goto*//*Label 19630*/ GIMT_Encode4(1380464), // Rule ID 22448 //
     /* 1380385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1380402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380438 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1380441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380463 */     // GIR_Coverage, 22448,
     /* 1380463 */     GIR_EraseRootFromParent_Done,
     /* 1380464 */   // Label 19630: @1380464
     /* 1380464 */   GIM_Try, /*On fail goto*//*Label 19631*/ GIMT_Encode4(1380548), // Rule ID 22449 //
     /* 1380469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1380486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380522 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1380525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380547 */     // GIR_Coverage, 22449,
     /* 1380547 */     GIR_EraseRootFromParent_Done,
     /* 1380548 */   // Label 19631: @1380548
     /* 1380548 */   GIM_Try, /*On fail goto*//*Label 19632*/ GIMT_Encode4(1380632), // Rule ID 22452 //
     /* 1380553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1380570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380606 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1380609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380631 */     // GIR_Coverage, 22452,
     /* 1380631 */     GIR_EraseRootFromParent_Done,
     /* 1380632 */   // Label 19632: @1380632
     /* 1380632 */   GIM_Try, /*On fail goto*//*Label 19633*/ GIMT_Encode4(1380716), // Rule ID 22453 //
     /* 1380637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1380654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380690 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1380693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380715 */     // GIR_Coverage, 22453,
     /* 1380715 */     GIR_EraseRootFromParent_Done,
     /* 1380716 */   // Label 19633: @1380716
     /* 1380716 */   GIM_Try, /*On fail goto*//*Label 19634*/ GIMT_Encode4(1380800), // Rule ID 22456 //
     /* 1380721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1380738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380774 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1380777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380799 */     // GIR_Coverage, 22456,
     /* 1380799 */     GIR_EraseRootFromParent_Done,
     /* 1380800 */   // Label 19634: @1380800
     /* 1380800 */   GIM_Try, /*On fail goto*//*Label 19635*/ GIMT_Encode4(1380884), // Rule ID 22457 //
     /* 1380805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1380822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380858 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1380861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380883 */     // GIR_Coverage, 22457,
     /* 1380883 */     GIR_EraseRootFromParent_Done,
     /* 1380884 */   // Label 19635: @1380884
     /* 1380884 */   GIM_Try, /*On fail goto*//*Label 19636*/ GIMT_Encode4(1380968), // Rule ID 22460 //
     /* 1380889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1380906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380942 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1380945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380967 */     // GIR_Coverage, 22460,
     /* 1380967 */     GIR_EraseRootFromParent_Done,
     /* 1380968 */   // Label 19636: @1380968
     /* 1380968 */   GIM_Try, /*On fail goto*//*Label 19637*/ GIMT_Encode4(1381052), // Rule ID 22461 //
     /* 1380973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1380990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381026 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1381029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381051 */     // GIR_Coverage, 22461,
     /* 1381051 */     GIR_EraseRootFromParent_Done,
     /* 1381052 */   // Label 19637: @1381052
     /* 1381052 */   GIM_Try, /*On fail goto*//*Label 19638*/ GIMT_Encode4(1381136), // Rule ID 22464 //
     /* 1381057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1381060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1381077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381110 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1381113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1381131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381135 */     // GIR_Coverage, 22464,
     /* 1381135 */     GIR_EraseRootFromParent_Done,
     /* 1381136 */   // Label 19638: @1381136
     /* 1381136 */   GIM_Try, /*On fail goto*//*Label 19639*/ GIMT_Encode4(1381220), // Rule ID 22465 //
     /* 1381141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1381144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1381161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381194 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1381197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1381215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381219 */     // GIR_Coverage, 22465,
     /* 1381219 */     GIR_EraseRootFromParent_Done,
     /* 1381220 */   // Label 19639: @1381220
     /* 1381220 */   GIM_Try, /*On fail goto*//*Label 19640*/ GIMT_Encode4(1381304), // Rule ID 22468 //
     /* 1381225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1381242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381278 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1381281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381303 */     // GIR_Coverage, 22468,
     /* 1381303 */     GIR_EraseRootFromParent_Done,
     /* 1381304 */   // Label 19640: @1381304
     /* 1381304 */   GIM_Try, /*On fail goto*//*Label 19641*/ GIMT_Encode4(1381388), // Rule ID 22469 //
     /* 1381309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1381326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381362 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1381365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381387 */     // GIR_Coverage, 22469,
     /* 1381387 */     GIR_EraseRootFromParent_Done,
     /* 1381388 */   // Label 19641: @1381388
     /* 1381388 */   GIM_Try, /*On fail goto*//*Label 19642*/ GIMT_Encode4(1381472), // Rule ID 22472 //
     /* 1381393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1381410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1381416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381446 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1381449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381471 */     // GIR_Coverage, 22472,
     /* 1381471 */     GIR_EraseRootFromParent_Done,
     /* 1381472 */   // Label 19642: @1381472
     /* 1381472 */   GIM_Try, /*On fail goto*//*Label 19643*/ GIMT_Encode4(1381556), // Rule ID 22473 //
     /* 1381477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1381494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1381500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381530 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1381533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381555 */     // GIR_Coverage, 22473,
     /* 1381555 */     GIR_EraseRootFromParent_Done,
     /* 1381556 */   // Label 19643: @1381556
     /* 1381556 */   GIM_Try, /*On fail goto*//*Label 19644*/ GIMT_Encode4(1381640), // Rule ID 22476 //
     /* 1381561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1381578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1381584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1381599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381614 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1381617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381639 */     // GIR_Coverage, 22476,
     /* 1381639 */     GIR_EraseRootFromParent_Done,
     /* 1381640 */   // Label 19644: @1381640
     /* 1381640 */   GIM_Try, /*On fail goto*//*Label 19645*/ GIMT_Encode4(1381724), // Rule ID 22477 //
     /* 1381645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1381662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1381668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1381683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381698 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1381701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381723 */     // GIR_Coverage, 22477,
     /* 1381723 */     GIR_EraseRootFromParent_Done,
     /* 1381724 */   // Label 19645: @1381724
     /* 1381724 */   GIM_Try, /*On fail goto*//*Label 19646*/ GIMT_Encode4(1381808), // Rule ID 22480 //
     /* 1381729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1381746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1381785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381807 */     // GIR_Coverage, 22480,
     /* 1381807 */     GIR_EraseRootFromParent_Done,
     /* 1381808 */   // Label 19646: @1381808
     /* 1381808 */   GIM_Try, /*On fail goto*//*Label 19647*/ GIMT_Encode4(1381892), // Rule ID 22481 //
     /* 1381813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1381830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381866 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1381869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381891 */     // GIR_Coverage, 22481,
     /* 1381891 */     GIR_EraseRootFromParent_Done,
     /* 1381892 */   // Label 19647: @1381892
     /* 1381892 */   GIM_Try, /*On fail goto*//*Label 19648*/ GIMT_Encode4(1381976), // Rule ID 22484 //
     /* 1381897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1381914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381950 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1381953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381975 */     // GIR_Coverage, 22484,
     /* 1381975 */     GIR_EraseRootFromParent_Done,
     /* 1381976 */   // Label 19648: @1381976
     /* 1381976 */   GIM_Try, /*On fail goto*//*Label 19649*/ GIMT_Encode4(1382060), // Rule ID 22485 //
     /* 1381981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1381998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382034 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1382037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382059 */     // GIR_Coverage, 22485,
     /* 1382059 */     GIR_EraseRootFromParent_Done,
     /* 1382060 */   // Label 19649: @1382060
     /* 1382060 */   GIM_Try, /*On fail goto*//*Label 19650*/ GIMT_Encode4(1382144), // Rule ID 22488 //
     /* 1382065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1382082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382118 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1382121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382143 */     // GIR_Coverage, 22488,
     /* 1382143 */     GIR_EraseRootFromParent_Done,
     /* 1382144 */   // Label 19650: @1382144
     /* 1382144 */   GIM_Try, /*On fail goto*//*Label 19651*/ GIMT_Encode4(1382228), // Rule ID 22489 //
     /* 1382149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1382166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1382205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382227 */     // GIR_Coverage, 22489,
     /* 1382227 */     GIR_EraseRootFromParent_Done,
     /* 1382228 */   // Label 19651: @1382228
     /* 1382228 */   GIM_Try, /*On fail goto*//*Label 19652*/ GIMT_Encode4(1382312), // Rule ID 22492 //
     /* 1382233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1382250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1382289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382311 */     // GIR_Coverage, 22492,
     /* 1382311 */     GIR_EraseRootFromParent_Done,
     /* 1382312 */   // Label 19652: @1382312
     /* 1382312 */   GIM_Try, /*On fail goto*//*Label 19653*/ GIMT_Encode4(1382396), // Rule ID 22493 //
     /* 1382317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1382334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382370 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1382373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382395 */     // GIR_Coverage, 22493,
     /* 1382395 */     GIR_EraseRootFromParent_Done,
     /* 1382396 */   // Label 19653: @1382396
     /* 1382396 */   GIM_Try, /*On fail goto*//*Label 19654*/ GIMT_Encode4(1382480), // Rule ID 22496 //
     /* 1382401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1382418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382454 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1382457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382479 */     // GIR_Coverage, 22496,
     /* 1382479 */     GIR_EraseRootFromParent_Done,
     /* 1382480 */   // Label 19654: @1382480
     /* 1382480 */   GIM_Try, /*On fail goto*//*Label 19655*/ GIMT_Encode4(1382564), // Rule ID 22497 //
     /* 1382485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1382502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382538 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1382541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382563 */     // GIR_Coverage, 22497,
     /* 1382563 */     GIR_EraseRootFromParent_Done,
     /* 1382564 */   // Label 19655: @1382564
     /* 1382564 */   GIM_Try, /*On fail goto*//*Label 19656*/ GIMT_Encode4(1382648), // Rule ID 22500 //
     /* 1382569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1382586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382622 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1382625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382647 */     // GIR_Coverage, 22500,
     /* 1382647 */     GIR_EraseRootFromParent_Done,
     /* 1382648 */   // Label 19656: @1382648
     /* 1382648 */   GIM_Try, /*On fail goto*//*Label 19657*/ GIMT_Encode4(1382732), // Rule ID 22501 //
     /* 1382653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1382670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382706 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1382709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382731 */     // GIR_Coverage, 22501,
     /* 1382731 */     GIR_EraseRootFromParent_Done,
     /* 1382732 */   // Label 19657: @1382732
     /* 1382732 */   GIM_Try, /*On fail goto*//*Label 19658*/ GIMT_Encode4(1382816), // Rule ID 22504 //
     /* 1382737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1382740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1382748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1382751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1382754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1382757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1382760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1382793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1382811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382815 */     // GIR_Coverage, 22504,
     /* 1382815 */     GIR_EraseRootFromParent_Done,
     /* 1382816 */   // Label 19658: @1382816
     /* 1382816 */   GIM_Try, /*On fail goto*//*Label 19659*/ GIMT_Encode4(1382900), // Rule ID 22505 //
     /* 1382821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1382824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1382832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1382835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1382838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1382841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1382844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382874 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1382877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1382895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382899 */     // GIR_Coverage, 22505,
     /* 1382899 */     GIR_EraseRootFromParent_Done,
     /* 1382900 */   // Label 19659: @1382900
     /* 1382900 */   GIM_Try, /*On fail goto*//*Label 19660*/ GIMT_Encode4(1382984), // Rule ID 22508 //
     /* 1382905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1382908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1382916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1382919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1382922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1382925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382958 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1382961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1382979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382983 */     // GIR_Coverage, 22508,
     /* 1382983 */     GIR_EraseRootFromParent_Done,
     /* 1382984 */   // Label 19660: @1382984
     /* 1382984 */   GIM_Try, /*On fail goto*//*Label 19661*/ GIMT_Encode4(1383068), // Rule ID 22509 //
     /* 1382989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1382992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1383006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383042 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1383045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383067 */     // GIR_Coverage, 22509,
     /* 1383067 */     GIR_EraseRootFromParent_Done,
     /* 1383068 */   // Label 19661: @1383068
     /* 1383068 */   GIM_Try, /*On fail goto*//*Label 19662*/ GIMT_Encode4(1383152), // Rule ID 22512 //
     /* 1383073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1383076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1383129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383151 */     // GIR_Coverage, 22512,
     /* 1383151 */     GIR_EraseRootFromParent_Done,
     /* 1383152 */   // Label 19662: @1383152
     /* 1383152 */   GIM_Try, /*On fail goto*//*Label 19663*/ GIMT_Encode4(1383236), // Rule ID 22513 //
     /* 1383157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1383160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383210 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1383213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383235 */     // GIR_Coverage, 22513,
     /* 1383235 */     GIR_EraseRootFromParent_Done,
     /* 1383236 */   // Label 19663: @1383236
     /* 1383236 */   GIM_Try, /*On fail goto*//*Label 19664*/ GIMT_Encode4(1383320), // Rule ID 22516 //
     /* 1383241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1383258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383294 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1383297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383319 */     // GIR_Coverage, 22516,
     /* 1383319 */     GIR_EraseRootFromParent_Done,
     /* 1383320 */   // Label 19664: @1383320
     /* 1383320 */   GIM_Try, /*On fail goto*//*Label 19665*/ GIMT_Encode4(1383404), // Rule ID 22517 //
     /* 1383325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1383342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383378 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1383381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383403 */     // GIR_Coverage, 22517,
     /* 1383403 */     GIR_EraseRootFromParent_Done,
     /* 1383404 */   // Label 19665: @1383404
     /* 1383404 */   GIM_Try, /*On fail goto*//*Label 19666*/ GIMT_Encode4(1383488), // Rule ID 22520 //
     /* 1383409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1383426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383462 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1383465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383487 */     // GIR_Coverage, 22520,
     /* 1383487 */     GIR_EraseRootFromParent_Done,
     /* 1383488 */   // Label 19666: @1383488
     /* 1383488 */   GIM_Try, /*On fail goto*//*Label 19667*/ GIMT_Encode4(1383572), // Rule ID 22521 //
     /* 1383493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1383510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383546 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1383549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383571 */     // GIR_Coverage, 22521,
     /* 1383571 */     GIR_EraseRootFromParent_Done,
     /* 1383572 */   // Label 19667: @1383572
     /* 1383572 */   GIM_Try, /*On fail goto*//*Label 19668*/ GIMT_Encode4(1383656), // Rule ID 22524 //
     /* 1383577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1383594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383630 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1383633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383655 */     // GIR_Coverage, 22524,
     /* 1383655 */     GIR_EraseRootFromParent_Done,
     /* 1383656 */   // Label 19668: @1383656
     /* 1383656 */   GIM_Try, /*On fail goto*//*Label 19669*/ GIMT_Encode4(1383740), // Rule ID 22525 //
     /* 1383661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1383678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383714 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1383717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383739 */     // GIR_Coverage, 22525,
     /* 1383739 */     GIR_EraseRootFromParent_Done,
     /* 1383740 */   // Label 19669: @1383740
     /* 1383740 */   GIM_Try, /*On fail goto*//*Label 19670*/ GIMT_Encode4(1383824), // Rule ID 22528 //
     /* 1383745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1383762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383798 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1383801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383823 */     // GIR_Coverage, 22528,
     /* 1383823 */     GIR_EraseRootFromParent_Done,
     /* 1383824 */   // Label 19670: @1383824
     /* 1383824 */   GIM_Try, /*On fail goto*//*Label 19671*/ GIMT_Encode4(1383908), // Rule ID 22529 //
     /* 1383829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1383846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1383885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383907 */     // GIR_Coverage, 22529,
     /* 1383907 */     GIR_EraseRootFromParent_Done,
     /* 1383908 */   // Label 19671: @1383908
     /* 1383908 */   GIM_Try, /*On fail goto*//*Label 19672*/ GIMT_Encode4(1383992), // Rule ID 22532 //
     /* 1383913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1383930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383966 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1383969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383991 */     // GIR_Coverage, 22532,
     /* 1383991 */     GIR_EraseRootFromParent_Done,
     /* 1383992 */   // Label 19672: @1383992
     /* 1383992 */   GIM_Try, /*On fail goto*//*Label 19673*/ GIMT_Encode4(1384076), // Rule ID 22533 //
     /* 1383997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1384014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1384053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384075 */     // GIR_Coverage, 22533,
     /* 1384075 */     GIR_EraseRootFromParent_Done,
     /* 1384076 */   // Label 19673: @1384076
     /* 1384076 */   GIM_Try, /*On fail goto*//*Label 19674*/ GIMT_Encode4(1384160), // Rule ID 22536 //
     /* 1384081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1384098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384134 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1384137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384159 */     // GIR_Coverage, 22536,
     /* 1384159 */     GIR_EraseRootFromParent_Done,
     /* 1384160 */   // Label 19674: @1384160
     /* 1384160 */   GIM_Try, /*On fail goto*//*Label 19675*/ GIMT_Encode4(1384244), // Rule ID 22537 //
     /* 1384165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1384182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1384221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384243 */     // GIR_Coverage, 22537,
     /* 1384243 */     GIR_EraseRootFromParent_Done,
     /* 1384244 */   // Label 19675: @1384244
     /* 1384244 */   GIM_Try, /*On fail goto*//*Label 19676*/ GIMT_Encode4(1384328), // Rule ID 22540 //
     /* 1384249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1384266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1384305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384327 */     // GIR_Coverage, 22540,
     /* 1384327 */     GIR_EraseRootFromParent_Done,
     /* 1384328 */   // Label 19676: @1384328
     /* 1384328 */   GIM_Try, /*On fail goto*//*Label 19677*/ GIMT_Encode4(1384412), // Rule ID 22541 //
     /* 1384333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1384350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384386 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1384389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384411 */     // GIR_Coverage, 22541,
     /* 1384411 */     GIR_EraseRootFromParent_Done,
     /* 1384412 */   // Label 19677: @1384412
     /* 1384412 */   GIM_Try, /*On fail goto*//*Label 19678*/ GIMT_Encode4(1384496), // Rule ID 22544 //
     /* 1384417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1384434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384470 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1384473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384495 */     // GIR_Coverage, 22544,
     /* 1384495 */     GIR_EraseRootFromParent_Done,
     /* 1384496 */   // Label 19678: @1384496
     /* 1384496 */   GIM_Try, /*On fail goto*//*Label 19679*/ GIMT_Encode4(1384580), // Rule ID 22545 //
     /* 1384501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1384518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384554 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1384557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384579 */     // GIR_Coverage, 22545,
     /* 1384579 */     GIR_EraseRootFromParent_Done,
     /* 1384580 */   // Label 19679: @1384580
     /* 1384580 */   GIM_Try, /*On fail goto*//*Label 19680*/ GIMT_Encode4(1384664), // Rule ID 22548 //
     /* 1384585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1384602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1384641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384663 */     // GIR_Coverage, 22548,
     /* 1384663 */     GIR_EraseRootFromParent_Done,
     /* 1384664 */   // Label 19680: @1384664
     /* 1384664 */   GIM_Try, /*On fail goto*//*Label 19681*/ GIMT_Encode4(1384748), // Rule ID 22549 //
     /* 1384669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1384686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384722 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1384725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384747 */     // GIR_Coverage, 22549,
     /* 1384747 */     GIR_EraseRootFromParent_Done,
     /* 1384748 */   // Label 19681: @1384748
     /* 1384748 */   GIM_Try, /*On fail goto*//*Label 19682*/ GIMT_Encode4(1384832), // Rule ID 22552 //
     /* 1384753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1384756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1384770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384806 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1384809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384831 */     // GIR_Coverage, 22552,
     /* 1384831 */     GIR_EraseRootFromParent_Done,
     /* 1384832 */   // Label 19682: @1384832
     /* 1384832 */   GIM_Try, /*On fail goto*//*Label 19683*/ GIMT_Encode4(1384916), // Rule ID 22553 //
     /* 1384837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1384840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1384854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1384893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384915 */     // GIR_Coverage, 22553,
     /* 1384915 */     GIR_EraseRootFromParent_Done,
     /* 1384916 */   // Label 19683: @1384916
     /* 1384916 */   GIM_Try, /*On fail goto*//*Label 19684*/ GIMT_Encode4(1385000), // Rule ID 22556 //
     /* 1384921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1384938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1384944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1384959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1384977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384999 */     // GIR_Coverage, 22556,
     /* 1384999 */     GIR_EraseRootFromParent_Done,
     /* 1385000 */   // Label 19684: @1385000
     /* 1385000 */   GIM_Try, /*On fail goto*//*Label 19685*/ GIMT_Encode4(1385084), // Rule ID 22557 //
     /* 1385005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1385022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385058 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1385061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385083 */     // GIR_Coverage, 22557,
     /* 1385083 */     GIR_EraseRootFromParent_Done,
     /* 1385084 */   // Label 19685: @1385084
     /* 1385084 */   GIM_Try, /*On fail goto*//*Label 19686*/ GIMT_Encode4(1385168), // Rule ID 22560 //
     /* 1385089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1385106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385142 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1385145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385167 */     // GIR_Coverage, 22560,
     /* 1385167 */     GIR_EraseRootFromParent_Done,
     /* 1385168 */   // Label 19686: @1385168
     /* 1385168 */   GIM_Try, /*On fail goto*//*Label 19687*/ GIMT_Encode4(1385252), // Rule ID 22561 //
     /* 1385173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1385190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1385229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385251 */     // GIR_Coverage, 22561,
     /* 1385251 */     GIR_EraseRootFromParent_Done,
     /* 1385252 */   // Label 19687: @1385252
     /* 1385252 */   GIM_Try, /*On fail goto*//*Label 19688*/ GIMT_Encode4(1385336), // Rule ID 22564 //
     /* 1385257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1385274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1385280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385310 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1385313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385335 */     // GIR_Coverage, 22564,
     /* 1385335 */     GIR_EraseRootFromParent_Done,
     /* 1385336 */   // Label 19688: @1385336
     /* 1385336 */   GIM_Try, /*On fail goto*//*Label 19689*/ GIMT_Encode4(1385420), // Rule ID 22565 //
     /* 1385341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1385358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1385364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385394 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1385397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385419 */     // GIR_Coverage, 22565,
     /* 1385419 */     GIR_EraseRootFromParent_Done,
     /* 1385420 */   // Label 19689: @1385420
     /* 1385420 */   GIM_Try, /*On fail goto*//*Label 19690*/ GIMT_Encode4(1385504), // Rule ID 22568 //
     /* 1385425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1385442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385478 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1385481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385503 */     // GIR_Coverage, 22568,
     /* 1385503 */     GIR_EraseRootFromParent_Done,
     /* 1385504 */   // Label 19690: @1385504
     /* 1385504 */   GIM_Try, /*On fail goto*//*Label 19691*/ GIMT_Encode4(1385588), // Rule ID 22569 //
     /* 1385509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1385526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385562 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1385565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385587 */     // GIR_Coverage, 22569,
     /* 1385587 */     GIR_EraseRootFromParent_Done,
     /* 1385588 */   // Label 19691: @1385588
     /* 1385588 */   GIM_Try, /*On fail goto*//*Label 19692*/ GIMT_Encode4(1385672), // Rule ID 22572 //
     /* 1385593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1385610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1385649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385671 */     // GIR_Coverage, 22572,
     /* 1385671 */     GIR_EraseRootFromParent_Done,
     /* 1385672 */   // Label 19692: @1385672
     /* 1385672 */   GIM_Try, /*On fail goto*//*Label 19693*/ GIMT_Encode4(1385756), // Rule ID 22573 //
     /* 1385677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1385694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385730 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1385733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385755 */     // GIR_Coverage, 22573,
     /* 1385755 */     GIR_EraseRootFromParent_Done,
     /* 1385756 */   // Label 19693: @1385756
     /* 1385756 */   GIM_Try, /*On fail goto*//*Label 19694*/ GIMT_Encode4(1385840), // Rule ID 22576 //
     /* 1385761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1385778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385814 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1385817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385839 */     // GIR_Coverage, 22576,
     /* 1385839 */     GIR_EraseRootFromParent_Done,
     /* 1385840 */   // Label 19694: @1385840
     /* 1385840 */   GIM_Try, /*On fail goto*//*Label 19695*/ GIMT_Encode4(1385924), // Rule ID 22577 //
     /* 1385845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1385862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1385901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385923 */     // GIR_Coverage, 22577,
     /* 1385923 */     GIR_EraseRootFromParent_Done,
     /* 1385924 */   // Label 19695: @1385924
     /* 1385924 */   GIM_Try, /*On fail goto*//*Label 19696*/ GIMT_Encode4(1386008), // Rule ID 22580 //
     /* 1385929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1385940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1385943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1385946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1385949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1385952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385982 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1385985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386007 */     // GIR_Coverage, 22580,
     /* 1386007 */     GIR_EraseRootFromParent_Done,
     /* 1386008 */   // Label 19696: @1386008
     /* 1386008 */   GIM_Try, /*On fail goto*//*Label 19697*/ GIMT_Encode4(1386092), // Rule ID 22581 //
     /* 1386013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1386030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386066 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1386069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386091 */     // GIR_Coverage, 22581,
     /* 1386091 */     GIR_EraseRootFromParent_Done,
     /* 1386092 */   // Label 19697: @1386092
     /* 1386092 */   GIM_Try, /*On fail goto*//*Label 19698*/ GIMT_Encode4(1386176), // Rule ID 22584 //
     /* 1386097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1386114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1386153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386175 */     // GIR_Coverage, 22584,
     /* 1386175 */     GIR_EraseRootFromParent_Done,
     /* 1386176 */   // Label 19698: @1386176
     /* 1386176 */   GIM_Try, /*On fail goto*//*Label 19699*/ GIMT_Encode4(1386260), // Rule ID 22585 //
     /* 1386181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1386198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1386237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386259 */     // GIR_Coverage, 22585,
     /* 1386259 */     GIR_EraseRootFromParent_Done,
     /* 1386260 */   // Label 19699: @1386260
     /* 1386260 */   GIM_Try, /*On fail goto*//*Label 19700*/ GIMT_Encode4(1386344), // Rule ID 22588 //
     /* 1386265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1386282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1386321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386343 */     // GIR_Coverage, 22588,
     /* 1386343 */     GIR_EraseRootFromParent_Done,
     /* 1386344 */   // Label 19700: @1386344
     /* 1386344 */   GIM_Try, /*On fail goto*//*Label 19701*/ GIMT_Encode4(1386428), // Rule ID 22589 //
     /* 1386349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1386366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386402 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1386405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386427 */     // GIR_Coverage, 22589,
     /* 1386427 */     GIR_EraseRootFromParent_Done,
     /* 1386428 */   // Label 19701: @1386428
     /* 1386428 */   GIM_Try, /*On fail goto*//*Label 19702*/ GIMT_Encode4(1386512), // Rule ID 22592 //
     /* 1386433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1386436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1386450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1386456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386486 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1386489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386511 */     // GIR_Coverage, 22592,
     /* 1386511 */     GIR_EraseRootFromParent_Done,
     /* 1386512 */   // Label 19702: @1386512
     /* 1386512 */   GIM_Try, /*On fail goto*//*Label 19703*/ GIMT_Encode4(1386596), // Rule ID 22593 //
     /* 1386517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1386520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1386534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1386540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386570 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1386573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386595 */     // GIR_Coverage, 22593,
     /* 1386595 */     GIR_EraseRootFromParent_Done,
     /* 1386596 */   // Label 19703: @1386596
     /* 1386596 */   GIM_Try, /*On fail goto*//*Label 19704*/ GIMT_Encode4(1386680), // Rule ID 22596 //
     /* 1386601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1386604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1386618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386654 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1386657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386679 */     // GIR_Coverage, 22596,
     /* 1386679 */     GIR_EraseRootFromParent_Done,
     /* 1386680 */   // Label 19704: @1386680
     /* 1386680 */   GIM_Try, /*On fail goto*//*Label 19705*/ GIMT_Encode4(1386764), // Rule ID 22597 //
     /* 1386685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1386688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1386702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386738 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1386741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386763 */     // GIR_Coverage, 22597,
     /* 1386763 */     GIR_EraseRootFromParent_Done,
     /* 1386764 */   // Label 19705: @1386764
     /* 1386764 */   GIM_Try, /*On fail goto*//*Label 19706*/ GIMT_Encode4(1386848), // Rule ID 22600 //
     /* 1386769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1386772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1386786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386822 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1386825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386847 */     // GIR_Coverage, 22600,
     /* 1386847 */     GIR_EraseRootFromParent_Done,
     /* 1386848 */   // Label 19706: @1386848
     /* 1386848 */   GIM_Try, /*On fail goto*//*Label 19707*/ GIMT_Encode4(1386932), // Rule ID 22601 //
     /* 1386853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1386856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1386870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386906 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1386909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386931 */     // GIR_Coverage, 22601,
     /* 1386931 */     GIR_EraseRootFromParent_Done,
     /* 1386932 */   // Label 19707: @1386932
     /* 1386932 */   GIM_Try, /*On fail goto*//*Label 19708*/ GIMT_Encode4(1387016), // Rule ID 22604 //
     /* 1386937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1386948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1386951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1386954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1386957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1386960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386990 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1386993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387015 */     // GIR_Coverage, 22604,
     /* 1387015 */     GIR_EraseRootFromParent_Done,
     /* 1387016 */   // Label 19708: @1387016
     /* 1387016 */   GIM_Try, /*On fail goto*//*Label 19709*/ GIMT_Encode4(1387100), // Rule ID 22605 //
     /* 1387021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1387038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387074 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1387077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387099 */     // GIR_Coverage, 22605,
     /* 1387099 */     GIR_EraseRootFromParent_Done,
     /* 1387100 */   // Label 19709: @1387100
     /* 1387100 */   GIM_Try, /*On fail goto*//*Label 19710*/ GIMT_Encode4(1387184), // Rule ID 22608 //
     /* 1387105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1387122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387158 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1387161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387183 */     // GIR_Coverage, 22608,
     /* 1387183 */     GIR_EraseRootFromParent_Done,
     /* 1387184 */   // Label 19710: @1387184
     /* 1387184 */   GIM_Try, /*On fail goto*//*Label 19711*/ GIMT_Encode4(1387268), // Rule ID 22609 //
     /* 1387189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1387206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387242 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1387245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387267 */     // GIR_Coverage, 22609,
     /* 1387267 */     GIR_EraseRootFromParent_Done,
     /* 1387268 */   // Label 19711: @1387268
     /* 1387268 */   GIM_Try, /*On fail goto*//*Label 19712*/ GIMT_Encode4(1387352), // Rule ID 22612 //
     /* 1387273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1387290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387326 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1387329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387351 */     // GIR_Coverage, 22612,
     /* 1387351 */     GIR_EraseRootFromParent_Done,
     /* 1387352 */   // Label 19712: @1387352
     /* 1387352 */   GIM_Try, /*On fail goto*//*Label 19713*/ GIMT_Encode4(1387436), // Rule ID 22613 //
     /* 1387357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1387374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387410 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1387413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387435 */     // GIR_Coverage, 22613,
     /* 1387435 */     GIR_EraseRootFromParent_Done,
     /* 1387436 */   // Label 19713: @1387436
     /* 1387436 */   GIM_Try, /*On fail goto*//*Label 19714*/ GIMT_Encode4(1387520), // Rule ID 22616 //
     /* 1387441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1387458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387494 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1387497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387519 */     // GIR_Coverage, 22616,
     /* 1387519 */     GIR_EraseRootFromParent_Done,
     /* 1387520 */   // Label 19714: @1387520
     /* 1387520 */   GIM_Try, /*On fail goto*//*Label 19715*/ GIMT_Encode4(1387604), // Rule ID 22617 //
     /* 1387525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1387542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387578 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1387581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387603 */     // GIR_Coverage, 22617,
     /* 1387603 */     GIR_EraseRootFromParent_Done,
     /* 1387604 */   // Label 19715: @1387604
     /* 1387604 */   GIM_Try, /*On fail goto*//*Label 19716*/ GIMT_Encode4(1387688), // Rule ID 22620 //
     /* 1387609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1387626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387662 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1387665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387687 */     // GIR_Coverage, 22620,
     /* 1387687 */     GIR_EraseRootFromParent_Done,
     /* 1387688 */   // Label 19716: @1387688
     /* 1387688 */   GIM_Try, /*On fail goto*//*Label 19717*/ GIMT_Encode4(1387772), // Rule ID 22621 //
     /* 1387693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1387710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387746 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1387749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387771 */     // GIR_Coverage, 22621,
     /* 1387771 */     GIR_EraseRootFromParent_Done,
     /* 1387772 */   // Label 19717: @1387772
     /* 1387772 */   GIM_Try, /*On fail goto*//*Label 19718*/ GIMT_Encode4(1387856), // Rule ID 22624 //
     /* 1387777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1387794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1387833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387855 */     // GIR_Coverage, 22624,
     /* 1387855 */     GIR_EraseRootFromParent_Done,
     /* 1387856 */   // Label 19718: @1387856
     /* 1387856 */   GIM_Try, /*On fail goto*//*Label 19719*/ GIMT_Encode4(1387940), // Rule ID 22625 //
     /* 1387861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1387878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387914 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1387917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387939 */     // GIR_Coverage, 22625,
     /* 1387939 */     GIR_EraseRootFromParent_Done,
     /* 1387940 */   // Label 19719: @1387940
     /* 1387940 */   GIM_Try, /*On fail goto*//*Label 19720*/ GIMT_Encode4(1388024), // Rule ID 22628 //
     /* 1387945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1387962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1387968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387998 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1388001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388023 */     // GIR_Coverage, 22628,
     /* 1388023 */     GIR_EraseRootFromParent_Done,
     /* 1388024 */   // Label 19720: @1388024
     /* 1388024 */   GIM_Try, /*On fail goto*//*Label 19721*/ GIMT_Encode4(1388108), // Rule ID 22629 //
     /* 1388029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1388046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388082 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1388085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388107 */     // GIR_Coverage, 22629,
     /* 1388107 */     GIR_EraseRootFromParent_Done,
     /* 1388108 */   // Label 19721: @1388108
     /* 1388108 */   GIM_Try, /*On fail goto*//*Label 19722*/ GIMT_Encode4(1388192), // Rule ID 22632 //
     /* 1388113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1388130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388166 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1388169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388191 */     // GIR_Coverage, 22632,
     /* 1388191 */     GIR_EraseRootFromParent_Done,
     /* 1388192 */   // Label 19722: @1388192
     /* 1388192 */   GIM_Try, /*On fail goto*//*Label 19723*/ GIMT_Encode4(1388276), // Rule ID 22633 //
     /* 1388197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1388214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1388253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388275 */     // GIR_Coverage, 22633,
     /* 1388275 */     GIR_EraseRootFromParent_Done,
     /* 1388276 */   // Label 19723: @1388276
     /* 1388276 */   GIM_Try, /*On fail goto*//*Label 19724*/ GIMT_Encode4(1388360), // Rule ID 22636 //
     /* 1388281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1388298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1388337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388359 */     // GIR_Coverage, 22636,
     /* 1388359 */     GIR_EraseRootFromParent_Done,
     /* 1388360 */   // Label 19724: @1388360
     /* 1388360 */   GIM_Try, /*On fail goto*//*Label 19725*/ GIMT_Encode4(1388444), // Rule ID 22637 //
     /* 1388365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1388382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1388421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388443 */     // GIR_Coverage, 22637,
     /* 1388443 */     GIR_EraseRootFromParent_Done,
     /* 1388444 */   // Label 19725: @1388444
     /* 1388444 */   GIM_Try, /*On fail goto*//*Label 19726*/ GIMT_Encode4(1388528), // Rule ID 22640 //
     /* 1388449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1388452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1388466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1388505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388527 */     // GIR_Coverage, 22640,
     /* 1388527 */     GIR_EraseRootFromParent_Done,
     /* 1388528 */   // Label 19726: @1388528
     /* 1388528 */   GIM_Try, /*On fail goto*//*Label 19727*/ GIMT_Encode4(1388612), // Rule ID 22641 //
     /* 1388533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1388536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1388550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388586 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1388589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388611 */     // GIR_Coverage, 22641,
     /* 1388611 */     GIR_EraseRootFromParent_Done,
     /* 1388612 */   // Label 19727: @1388612
     /* 1388612 */   GIM_Try, /*On fail goto*//*Label 19728*/ GIMT_Encode4(1388696), // Rule ID 22644 //
     /* 1388617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1388634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1388640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388670 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1388673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388695 */     // GIR_Coverage, 22644,
     /* 1388695 */     GIR_EraseRootFromParent_Done,
     /* 1388696 */   // Label 19728: @1388696
     /* 1388696 */   GIM_Try, /*On fail goto*//*Label 19729*/ GIMT_Encode4(1388780), // Rule ID 22645 //
     /* 1388701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1388718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1388724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388754 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1388757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388779 */     // GIR_Coverage, 22645,
     /* 1388779 */     GIR_EraseRootFromParent_Done,
     /* 1388780 */   // Label 19729: @1388780
     /* 1388780 */   GIM_Try, /*On fail goto*//*Label 19730*/ GIMT_Encode4(1388864), // Rule ID 22648 //
     /* 1388785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1388802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1388808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388838 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1388841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388863 */     // GIR_Coverage, 22648,
     /* 1388863 */     GIR_EraseRootFromParent_Done,
     /* 1388864 */   // Label 19730: @1388864
     /* 1388864 */   GIM_Try, /*On fail goto*//*Label 19731*/ GIMT_Encode4(1388948), // Rule ID 22649 //
     /* 1388869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1388886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1388892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388922 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1388925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388947 */     // GIR_Coverage, 22649,
     /* 1388947 */     GIR_EraseRootFromParent_Done,
     /* 1388948 */   // Label 19731: @1388948
     /* 1388948 */   GIM_Try, /*On fail goto*//*Label 19732*/ GIMT_Encode4(1389032), // Rule ID 22652 //
     /* 1388953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1388970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1388976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1388991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389006 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1389009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389031 */     // GIR_Coverage, 22652,
     /* 1389031 */     GIR_EraseRootFromParent_Done,
     /* 1389032 */   // Label 19732: @1389032
     /* 1389032 */   GIM_Try, /*On fail goto*//*Label 19733*/ GIMT_Encode4(1389116), // Rule ID 22653 //
     /* 1389037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1389054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1389060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389090 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1389093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389115 */     // GIR_Coverage, 22653,
     /* 1389115 */     GIR_EraseRootFromParent_Done,
     /* 1389116 */   // Label 19733: @1389116
     /* 1389116 */   GIM_Try, /*On fail goto*//*Label 19734*/ GIMT_Encode4(1389200), // Rule ID 22656 //
     /* 1389121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1389138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1389177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389199 */     // GIR_Coverage, 22656,
     /* 1389199 */     GIR_EraseRootFromParent_Done,
     /* 1389200 */   // Label 19734: @1389200
     /* 1389200 */   GIM_Try, /*On fail goto*//*Label 19735*/ GIMT_Encode4(1389284), // Rule ID 22657 //
     /* 1389205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1389222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389258 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1389261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389283 */     // GIR_Coverage, 22657,
     /* 1389283 */     GIR_EraseRootFromParent_Done,
     /* 1389284 */   // Label 19735: @1389284
     /* 1389284 */   GIM_Try, /*On fail goto*//*Label 19736*/ GIMT_Encode4(1389368), // Rule ID 22660 //
     /* 1389289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1389306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1389345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389367 */     // GIR_Coverage, 22660,
     /* 1389367 */     GIR_EraseRootFromParent_Done,
     /* 1389368 */   // Label 19736: @1389368
     /* 1389368 */   GIM_Try, /*On fail goto*//*Label 19737*/ GIMT_Encode4(1389452), // Rule ID 22661 //
     /* 1389373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1389390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389426 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1389429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389451 */     // GIR_Coverage, 22661,
     /* 1389451 */     GIR_EraseRootFromParent_Done,
     /* 1389452 */   // Label 19737: @1389452
     /* 1389452 */   GIM_Try, /*On fail goto*//*Label 19738*/ GIMT_Encode4(1389536), // Rule ID 22664 //
     /* 1389457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1389474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389510 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1389513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389535 */     // GIR_Coverage, 22664,
     /* 1389535 */     GIR_EraseRootFromParent_Done,
     /* 1389536 */   // Label 19738: @1389536
     /* 1389536 */   GIM_Try, /*On fail goto*//*Label 19739*/ GIMT_Encode4(1389620), // Rule ID 22665 //
     /* 1389541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1389558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389594 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1389597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389619 */     // GIR_Coverage, 22665,
     /* 1389619 */     GIR_EraseRootFromParent_Done,
     /* 1389620 */   // Label 19739: @1389620
     /* 1389620 */   GIM_Try, /*On fail goto*//*Label 19740*/ GIMT_Encode4(1389704), // Rule ID 22668 //
     /* 1389625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1389642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1389648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1389681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389703 */     // GIR_Coverage, 22668,
     /* 1389703 */     GIR_EraseRootFromParent_Done,
     /* 1389704 */   // Label 19740: @1389704
     /* 1389704 */   GIM_Try, /*On fail goto*//*Label 19741*/ GIMT_Encode4(1389788), // Rule ID 22669 //
     /* 1389709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1389726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1389732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389762 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1389765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389787 */     // GIR_Coverage, 22669,
     /* 1389787 */     GIR_EraseRootFromParent_Done,
     /* 1389788 */   // Label 19741: @1389788
     /* 1389788 */   GIM_Try, /*On fail goto*//*Label 19742*/ GIMT_Encode4(1389872), // Rule ID 22672 //
     /* 1389793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1389810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389846 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1389849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389871 */     // GIR_Coverage, 22672,
     /* 1389871 */     GIR_EraseRootFromParent_Done,
     /* 1389872 */   // Label 19742: @1389872
     /* 1389872 */   GIM_Try, /*On fail goto*//*Label 19743*/ GIMT_Encode4(1389956), // Rule ID 22673 //
     /* 1389877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1389894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389930 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1389933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389955 */     // GIR_Coverage, 22673,
     /* 1389955 */     GIR_EraseRootFromParent_Done,
     /* 1389956 */   // Label 19743: @1389956
     /* 1389956 */   GIM_Try, /*On fail goto*//*Label 19744*/ GIMT_Encode4(1390040), // Rule ID 22676 //
     /* 1389961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1389978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390014 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1390017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390039 */     // GIR_Coverage, 22676,
     /* 1390039 */     GIR_EraseRootFromParent_Done,
     /* 1390040 */   // Label 19744: @1390040
     /* 1390040 */   GIM_Try, /*On fail goto*//*Label 19745*/ GIMT_Encode4(1390124), // Rule ID 22677 //
     /* 1390045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1390062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1390068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390098 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1390101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390123 */     // GIR_Coverage, 22677,
     /* 1390123 */     GIR_EraseRootFromParent_Done,
     /* 1390124 */   // Label 19745: @1390124
     /* 1390124 */   GIM_Try, /*On fail goto*//*Label 19746*/ GIMT_Encode4(1390208), // Rule ID 22680 //
     /* 1390129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1390146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390182 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1390185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390207 */     // GIR_Coverage, 22680,
     /* 1390207 */     GIR_EraseRootFromParent_Done,
     /* 1390208 */   // Label 19746: @1390208
     /* 1390208 */   GIM_Try, /*On fail goto*//*Label 19747*/ GIMT_Encode4(1390292), // Rule ID 22681 //
     /* 1390213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1390230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390266 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1390269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390291 */     // GIR_Coverage, 22681,
     /* 1390291 */     GIR_EraseRootFromParent_Done,
     /* 1390292 */   // Label 19747: @1390292
     /* 1390292 */   GIM_Try, /*On fail goto*//*Label 19748*/ GIMT_Encode4(1390376), // Rule ID 22684 //
     /* 1390297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1390314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390350 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1390353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390375 */     // GIR_Coverage, 22684,
     /* 1390375 */     GIR_EraseRootFromParent_Done,
     /* 1390376 */   // Label 19748: @1390376
     /* 1390376 */   GIM_Try, /*On fail goto*//*Label 19749*/ GIMT_Encode4(1390460), // Rule ID 22685 //
     /* 1390381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1390398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390434 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1390437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390459 */     // GIR_Coverage, 22685,
     /* 1390459 */     GIR_EraseRootFromParent_Done,
     /* 1390460 */   // Label 19749: @1390460
     /* 1390460 */   GIM_Try, /*On fail goto*//*Label 19750*/ GIMT_Encode4(1390544), // Rule ID 22688 //
     /* 1390465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1390482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1390521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390543 */     // GIR_Coverage, 22688,
     /* 1390543 */     GIR_EraseRootFromParent_Done,
     /* 1390544 */   // Label 19750: @1390544
     /* 1390544 */   GIM_Try, /*On fail goto*//*Label 19751*/ GIMT_Encode4(1390628), // Rule ID 22689 //
     /* 1390549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1390566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390602 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1390605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390627 */     // GIR_Coverage, 22689,
     /* 1390627 */     GIR_EraseRootFromParent_Done,
     /* 1390628 */   // Label 19751: @1390628
     /* 1390628 */   GIM_Try, /*On fail goto*//*Label 19752*/ GIMT_Encode4(1390712), // Rule ID 22692 //
     /* 1390633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1390650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390686 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1390689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390711 */     // GIR_Coverage, 22692,
     /* 1390711 */     GIR_EraseRootFromParent_Done,
     /* 1390712 */   // Label 19752: @1390712
     /* 1390712 */   GIM_Try, /*On fail goto*//*Label 19753*/ GIMT_Encode4(1390796), // Rule ID 22693 //
     /* 1390717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1390734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1390773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390795 */     // GIR_Coverage, 22693,
     /* 1390795 */     GIR_EraseRootFromParent_Done,
     /* 1390796 */   // Label 19753: @1390796
     /* 1390796 */   GIM_Try, /*On fail goto*//*Label 19754*/ GIMT_Encode4(1390880), // Rule ID 22696 //
     /* 1390801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1390818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390854 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1390857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390879 */     // GIR_Coverage, 22696,
     /* 1390879 */     GIR_EraseRootFromParent_Done,
     /* 1390880 */   // Label 19754: @1390880
     /* 1390880 */   GIM_Try, /*On fail goto*//*Label 19755*/ GIMT_Encode4(1390964), // Rule ID 22697 //
     /* 1390885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1390902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390938 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1390941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390963 */     // GIR_Coverage, 22697,
     /* 1390963 */     GIR_EraseRootFromParent_Done,
     /* 1390964 */   // Label 19755: @1390964
     /* 1390964 */   GIM_Try, /*On fail goto*//*Label 19756*/ GIMT_Encode4(1391048), // Rule ID 22700 //
     /* 1390969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1390986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391022 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1391025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391047 */     // GIR_Coverage, 22700,
     /* 1391047 */     GIR_EraseRootFromParent_Done,
     /* 1391048 */   // Label 19756: @1391048
     /* 1391048 */   GIM_Try, /*On fail goto*//*Label 19757*/ GIMT_Encode4(1391132), // Rule ID 22701 //
     /* 1391053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1391070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1391109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391131 */     // GIR_Coverage, 22701,
     /* 1391131 */     GIR_EraseRootFromParent_Done,
     /* 1391132 */   // Label 19757: @1391132
     /* 1391132 */   GIM_Try, /*On fail goto*//*Label 19758*/ GIMT_Encode4(1391216), // Rule ID 22704 //
     /* 1391137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1391154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1391193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391215 */     // GIR_Coverage, 22704,
     /* 1391215 */     GIR_EraseRootFromParent_Done,
     /* 1391216 */   // Label 19758: @1391216
     /* 1391216 */   GIM_Try, /*On fail goto*//*Label 19759*/ GIMT_Encode4(1391300), // Rule ID 22705 //
     /* 1391221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1391238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391274 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1391277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391299 */     // GIR_Coverage, 22705,
     /* 1391299 */     GIR_EraseRootFromParent_Done,
     /* 1391300 */   // Label 19759: @1391300
     /* 1391300 */   GIM_Try, /*On fail goto*//*Label 19760*/ GIMT_Encode4(1391384), // Rule ID 22708 //
     /* 1391305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1391322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391358 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1391361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391383 */     // GIR_Coverage, 22708,
     /* 1391383 */     GIR_EraseRootFromParent_Done,
     /* 1391384 */   // Label 19760: @1391384
     /* 1391384 */   GIM_Try, /*On fail goto*//*Label 19761*/ GIMT_Encode4(1391468), // Rule ID 22709 //
     /* 1391389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1391406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391442 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1391445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391467 */     // GIR_Coverage, 22709,
     /* 1391467 */     GIR_EraseRootFromParent_Done,
     /* 1391468 */   // Label 19761: @1391468
     /* 1391468 */   GIM_Try, /*On fail goto*//*Label 19762*/ GIMT_Encode4(1391552), // Rule ID 22712 //
     /* 1391473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1391490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1391529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391551 */     // GIR_Coverage, 22712,
     /* 1391551 */     GIR_EraseRootFromParent_Done,
     /* 1391552 */   // Label 19762: @1391552
     /* 1391552 */   GIM_Try, /*On fail goto*//*Label 19763*/ GIMT_Encode4(1391636), // Rule ID 22713 //
     /* 1391557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1391574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391610 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1391613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391635 */     // GIR_Coverage, 22713,
     /* 1391635 */     GIR_EraseRootFromParent_Done,
     /* 1391636 */   // Label 19763: @1391636
     /* 1391636 */   GIM_Try, /*On fail goto*//*Label 19764*/ GIMT_Encode4(1391720), // Rule ID 22716 //
     /* 1391641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1391658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1391697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391719 */     // GIR_Coverage, 22716,
     /* 1391719 */     GIR_EraseRootFromParent_Done,
     /* 1391720 */   // Label 19764: @1391720
     /* 1391720 */   GIM_Try, /*On fail goto*//*Label 19765*/ GIMT_Encode4(1391804), // Rule ID 22717 //
     /* 1391725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1391742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391778 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1391781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391803 */     // GIR_Coverage, 22717,
     /* 1391803 */     GIR_EraseRootFromParent_Done,
     /* 1391804 */   // Label 19765: @1391804
     /* 1391804 */   GIM_Try, /*On fail goto*//*Label 19766*/ GIMT_Encode4(1391888), // Rule ID 22720 //
     /* 1391809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1391826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391862 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1391865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391887 */     // GIR_Coverage, 22720,
     /* 1391887 */     GIR_EraseRootFromParent_Done,
     /* 1391888 */   // Label 19766: @1391888
     /* 1391888 */   GIM_Try, /*On fail goto*//*Label 19767*/ GIMT_Encode4(1391972), // Rule ID 22721 //
     /* 1391893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1391910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1391949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391971 */     // GIR_Coverage, 22721,
     /* 1391971 */     GIR_EraseRootFromParent_Done,
     /* 1391972 */   // Label 19767: @1391972
     /* 1391972 */   GIM_Try, /*On fail goto*//*Label 19768*/ GIMT_Encode4(1392056), // Rule ID 22724 //
     /* 1391977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1391994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392030 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1392033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392055 */     // GIR_Coverage, 22724,
     /* 1392055 */     GIR_EraseRootFromParent_Done,
     /* 1392056 */   // Label 19768: @1392056
     /* 1392056 */   GIM_Try, /*On fail goto*//*Label 19769*/ GIMT_Encode4(1392140), // Rule ID 22725 //
     /* 1392061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1392078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392114 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1392117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392139 */     // GIR_Coverage, 22725,
     /* 1392139 */     GIR_EraseRootFromParent_Done,
     /* 1392140 */   // Label 19769: @1392140
     /* 1392140 */   GIM_Try, /*On fail goto*//*Label 19770*/ GIMT_Encode4(1392224), // Rule ID 22728 //
     /* 1392145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1392162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392198 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1392201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392223 */     // GIR_Coverage, 22728,
     /* 1392223 */     GIR_EraseRootFromParent_Done,
     /* 1392224 */   // Label 19770: @1392224
     /* 1392224 */   GIM_Try, /*On fail goto*//*Label 19771*/ GIMT_Encode4(1392308), // Rule ID 22729 //
     /* 1392229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1392246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392282 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1392285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392307 */     // GIR_Coverage, 22729,
     /* 1392307 */     GIR_EraseRootFromParent_Done,
     /* 1392308 */   // Label 19771: @1392308
     /* 1392308 */   GIM_Try, /*On fail goto*//*Label 19772*/ GIMT_Encode4(1392392), // Rule ID 22732 //
     /* 1392313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1392330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1392336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1392369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392391 */     // GIR_Coverage, 22732,
     /* 1392391 */     GIR_EraseRootFromParent_Done,
     /* 1392392 */   // Label 19772: @1392392
     /* 1392392 */   GIM_Try, /*On fail goto*//*Label 19773*/ GIMT_Encode4(1392476), // Rule ID 22733 //
     /* 1392397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1392414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1392420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392450 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1392453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392475 */     // GIR_Coverage, 22733,
     /* 1392475 */     GIR_EraseRootFromParent_Done,
     /* 1392476 */   // Label 19773: @1392476
     /* 1392476 */   GIM_Try, /*On fail goto*//*Label 19774*/ GIMT_Encode4(1392560), // Rule ID 22736 //
     /* 1392481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1392498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1392504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392534 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1392537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392559 */     // GIR_Coverage, 22736,
     /* 1392559 */     GIR_EraseRootFromParent_Done,
     /* 1392560 */   // Label 19774: @1392560
     /* 1392560 */   GIM_Try, /*On fail goto*//*Label 19775*/ GIMT_Encode4(1392644), // Rule ID 22737 //
     /* 1392565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1392582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1392588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392618 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1392621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392643 */     // GIR_Coverage, 22737,
     /* 1392643 */     GIR_EraseRootFromParent_Done,
     /* 1392644 */   // Label 19775: @1392644
     /* 1392644 */   GIM_Try, /*On fail goto*//*Label 19776*/ GIMT_Encode4(1392728), // Rule ID 22740 //
     /* 1392649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1392666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1392705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392727 */     // GIR_Coverage, 22740,
     /* 1392727 */     GIR_EraseRootFromParent_Done,
     /* 1392728 */   // Label 19776: @1392728
     /* 1392728 */   GIM_Try, /*On fail goto*//*Label 19777*/ GIMT_Encode4(1392812), // Rule ID 22741 //
     /* 1392733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1392750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392786 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1392789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392811 */     // GIR_Coverage, 22741,
     /* 1392811 */     GIR_EraseRootFromParent_Done,
     /* 1392812 */   // Label 19777: @1392812
     /* 1392812 */   GIM_Try, /*On fail goto*//*Label 19778*/ GIMT_Encode4(1392896), // Rule ID 22744 //
     /* 1392817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1392834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392870 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1392873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392895 */     // GIR_Coverage, 22744,
     /* 1392895 */     GIR_EraseRootFromParent_Done,
     /* 1392896 */   // Label 19778: @1392896
     /* 1392896 */   GIM_Try, /*On fail goto*//*Label 19779*/ GIMT_Encode4(1392980), // Rule ID 22745 //
     /* 1392901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1392918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392954 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1392957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392979 */     // GIR_Coverage, 22745,
     /* 1392979 */     GIR_EraseRootFromParent_Done,
     /* 1392980 */   // Label 19779: @1392980
     /* 1392980 */   GIM_Try, /*On fail goto*//*Label 19780*/ GIMT_Encode4(1393064), // Rule ID 22748 //
     /* 1392985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393038 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1393041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393063 */     // GIR_Coverage, 22748,
     /* 1393063 */     GIR_EraseRootFromParent_Done,
     /* 1393064 */   // Label 19780: @1393064
     /* 1393064 */   GIM_Try, /*On fail goto*//*Label 19781*/ GIMT_Encode4(1393148), // Rule ID 22749 //
     /* 1393069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393122 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1393125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393147 */     // GIR_Coverage, 22749,
     /* 1393147 */     GIR_EraseRootFromParent_Done,
     /* 1393148 */   // Label 19781: @1393148
     /* 1393148 */   GIM_Try, /*On fail goto*//*Label 19782*/ GIMT_Encode4(1393232), // Rule ID 22752 //
     /* 1393153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1393170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393206 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1393209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393231 */     // GIR_Coverage, 22752,
     /* 1393231 */     GIR_EraseRootFromParent_Done,
     /* 1393232 */   // Label 19782: @1393232
     /* 1393232 */   GIM_Try, /*On fail goto*//*Label 19783*/ GIMT_Encode4(1393316), // Rule ID 22753 //
     /* 1393237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1393254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1393293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393315 */     // GIR_Coverage, 22753,
     /* 1393315 */     GIR_EraseRootFromParent_Done,
     /* 1393316 */   // Label 19783: @1393316
     /* 1393316 */   GIM_Try, /*On fail goto*//*Label 19784*/ GIMT_Encode4(1393400), // Rule ID 22756 //
     /* 1393321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1393338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1393377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393399 */     // GIR_Coverage, 22756,
     /* 1393399 */     GIR_EraseRootFromParent_Done,
     /* 1393400 */   // Label 19784: @1393400
     /* 1393400 */   GIM_Try, /*On fail goto*//*Label 19785*/ GIMT_Encode4(1393484), // Rule ID 22757 //
     /* 1393405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1393422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393458 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1393461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393483 */     // GIR_Coverage, 22757,
     /* 1393483 */     GIR_EraseRootFromParent_Done,
     /* 1393484 */   // Label 19785: @1393484
     /* 1393484 */   GIM_Try, /*On fail goto*//*Label 19786*/ GIMT_Encode4(1393568), // Rule ID 22760 //
     /* 1393489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1393506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393542 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1393545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393567 */     // GIR_Coverage, 22760,
     /* 1393567 */     GIR_EraseRootFromParent_Done,
     /* 1393568 */   // Label 19786: @1393568
     /* 1393568 */   GIM_Try, /*On fail goto*//*Label 19787*/ GIMT_Encode4(1393652), // Rule ID 22761 //
     /* 1393573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1393590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393626 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1393629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393651 */     // GIR_Coverage, 22761,
     /* 1393651 */     GIR_EraseRootFromParent_Done,
     /* 1393652 */   // Label 19787: @1393652
     /* 1393652 */   GIM_Try, /*On fail goto*//*Label 19788*/ GIMT_Encode4(1393736), // Rule ID 22764 //
     /* 1393657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1393674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1393680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1393713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393735 */     // GIR_Coverage, 22764,
     /* 1393735 */     GIR_EraseRootFromParent_Done,
     /* 1393736 */   // Label 19788: @1393736
     /* 1393736 */   GIM_Try, /*On fail goto*//*Label 19789*/ GIMT_Encode4(1393820), // Rule ID 22765 //
     /* 1393741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1393758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1393764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393794 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1393797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393819 */     // GIR_Coverage, 22765,
     /* 1393819 */     GIR_EraseRootFromParent_Done,
     /* 1393820 */   // Label 19789: @1393820
     /* 1393820 */   GIM_Try, /*On fail goto*//*Label 19790*/ GIMT_Encode4(1393904), // Rule ID 22768 //
     /* 1393825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1393842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1393848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393878 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1393881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393903 */     // GIR_Coverage, 22768,
     /* 1393903 */     GIR_EraseRootFromParent_Done,
     /* 1393904 */   // Label 19790: @1393904
     /* 1393904 */   GIM_Try, /*On fail goto*//*Label 19791*/ GIMT_Encode4(1393988), // Rule ID 22769 //
     /* 1393909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1393926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1393932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393962 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1393965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393987 */     // GIR_Coverage, 22769,
     /* 1393987 */     GIR_EraseRootFromParent_Done,
     /* 1393988 */   // Label 19791: @1393988
     /* 1393988 */   GIM_Try, /*On fail goto*//*Label 19792*/ GIMT_Encode4(1394072), // Rule ID 22772 //
     /* 1393993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1394010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394046 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1394049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394071 */     // GIR_Coverage, 22772,
     /* 1394071 */     GIR_EraseRootFromParent_Done,
     /* 1394072 */   // Label 19792: @1394072
     /* 1394072 */   GIM_Try, /*On fail goto*//*Label 19793*/ GIMT_Encode4(1394156), // Rule ID 22773 //
     /* 1394077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1394094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394130 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1394133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394155 */     // GIR_Coverage, 22773,
     /* 1394155 */     GIR_EraseRootFromParent_Done,
     /* 1394156 */   // Label 19793: @1394156
     /* 1394156 */   GIM_Try, /*On fail goto*//*Label 19794*/ GIMT_Encode4(1394240), // Rule ID 22776 //
     /* 1394161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1394178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394214 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1394217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394239 */     // GIR_Coverage, 22776,
     /* 1394239 */     GIR_EraseRootFromParent_Done,
     /* 1394240 */   // Label 19794: @1394240
     /* 1394240 */   GIM_Try, /*On fail goto*//*Label 19795*/ GIMT_Encode4(1394324), // Rule ID 22777 //
     /* 1394245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1394262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394298 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1394301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394323 */     // GIR_Coverage, 22777,
     /* 1394323 */     GIR_EraseRootFromParent_Done,
     /* 1394324 */   // Label 19795: @1394324
     /* 1394324 */   GIM_Try, /*On fail goto*//*Label 19796*/ GIMT_Encode4(1394408), // Rule ID 22780 //
     /* 1394329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1394346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394382 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1394385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394407 */     // GIR_Coverage, 22780,
     /* 1394407 */     GIR_EraseRootFromParent_Done,
     /* 1394408 */   // Label 19796: @1394408
     /* 1394408 */   GIM_Try, /*On fail goto*//*Label 19797*/ GIMT_Encode4(1394492), // Rule ID 22781 //
     /* 1394413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1394430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394466 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1394469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394491 */     // GIR_Coverage, 22781,
     /* 1394491 */     GIR_EraseRootFromParent_Done,
     /* 1394492 */   // Label 19797: @1394492
     /* 1394492 */   GIM_Try, /*On fail goto*//*Label 19798*/ GIMT_Encode4(1394576), // Rule ID 22784 //
     /* 1394497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1394514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394550 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1394553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394575 */     // GIR_Coverage, 22784,
     /* 1394575 */     GIR_EraseRootFromParent_Done,
     /* 1394576 */   // Label 19798: @1394576
     /* 1394576 */   GIM_Try, /*On fail goto*//*Label 19799*/ GIMT_Encode4(1394660), // Rule ID 22785 //
     /* 1394581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1394598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394634 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1394637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394659 */     // GIR_Coverage, 22785,
     /* 1394659 */     GIR_EraseRootFromParent_Done,
     /* 1394660 */   // Label 19799: @1394660
     /* 1394660 */   GIM_Try, /*On fail goto*//*Label 19800*/ GIMT_Encode4(1394744), // Rule ID 22788 //
     /* 1394665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1394682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1394688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394718 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1394721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394743 */     // GIR_Coverage, 22788,
     /* 1394743 */     GIR_EraseRootFromParent_Done,
     /* 1394744 */   // Label 19800: @1394744
     /* 1394744 */   GIM_Try, /*On fail goto*//*Label 19801*/ GIMT_Encode4(1394828), // Rule ID 22789 //
     /* 1394749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1394766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1394772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394802 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1394805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394827 */     // GIR_Coverage, 22789,
     /* 1394827 */     GIR_EraseRootFromParent_Done,
     /* 1394828 */   // Label 19801: @1394828
     /* 1394828 */   GIM_Try, /*On fail goto*//*Label 19802*/ GIMT_Encode4(1394912), // Rule ID 22792 //
     /* 1394833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1394850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1394889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394911 */     // GIR_Coverage, 22792,
     /* 1394911 */     GIR_EraseRootFromParent_Done,
     /* 1394912 */   // Label 19802: @1394912
     /* 1394912 */   GIM_Try, /*On fail goto*//*Label 19803*/ GIMT_Encode4(1394996), // Rule ID 22793 //
     /* 1394917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1394934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1394973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394995 */     // GIR_Coverage, 22793,
     /* 1394995 */     GIR_EraseRootFromParent_Done,
     /* 1394996 */   // Label 19803: @1394996
     /* 1394996 */   GIM_Try, /*On fail goto*//*Label 19804*/ GIMT_Encode4(1395080), // Rule ID 22796 //
     /* 1395001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395054 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1395057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395079 */     // GIR_Coverage, 22796,
     /* 1395079 */     GIR_EraseRootFromParent_Done,
     /* 1395080 */   // Label 19804: @1395080
     /* 1395080 */   GIM_Try, /*On fail goto*//*Label 19805*/ GIMT_Encode4(1395164), // Rule ID 22797 //
     /* 1395085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395138 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1395141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395163 */     // GIR_Coverage, 22797,
     /* 1395163 */     GIR_EraseRootFromParent_Done,
     /* 1395164 */   // Label 19805: @1395164
     /* 1395164 */   GIM_Try, /*On fail goto*//*Label 19806*/ GIMT_Encode4(1395248), // Rule ID 22800 //
     /* 1395169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1395186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395222 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1395225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395247 */     // GIR_Coverage, 22800,
     /* 1395247 */     GIR_EraseRootFromParent_Done,
     /* 1395248 */   // Label 19806: @1395248
     /* 1395248 */   GIM_Try, /*On fail goto*//*Label 19807*/ GIMT_Encode4(1395332), // Rule ID 22801 //
     /* 1395253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1395270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395306 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1395309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395331 */     // GIR_Coverage, 22801,
     /* 1395331 */     GIR_EraseRootFromParent_Done,
     /* 1395332 */   // Label 19807: @1395332
     /* 1395332 */   GIM_Try, /*On fail goto*//*Label 19808*/ GIMT_Encode4(1395416), // Rule ID 22804 //
     /* 1395337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1395354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1395360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1395393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395415 */     // GIR_Coverage, 22804,
     /* 1395415 */     GIR_EraseRootFromParent_Done,
     /* 1395416 */   // Label 19808: @1395416
     /* 1395416 */   GIM_Try, /*On fail goto*//*Label 19809*/ GIMT_Encode4(1395500), // Rule ID 22805 //
     /* 1395421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1395438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1395444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395474 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1395477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395499 */     // GIR_Coverage, 22805,
     /* 1395499 */     GIR_EraseRootFromParent_Done,
     /* 1395500 */   // Label 19809: @1395500
     /* 1395500 */   GIM_Try, /*On fail goto*//*Label 19810*/ GIMT_Encode4(1395584), // Rule ID 22808 //
     /* 1395505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1395522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1395528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1395543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1395561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395583 */     // GIR_Coverage, 22808,
     /* 1395583 */     GIR_EraseRootFromParent_Done,
     /* 1395584 */   // Label 19810: @1395584
     /* 1395584 */   GIM_Try, /*On fail goto*//*Label 19811*/ GIMT_Encode4(1395668), // Rule ID 22809 //
     /* 1395589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1395606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1395612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1395627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395642 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1395645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395667 */     // GIR_Coverage, 22809,
     /* 1395667 */     GIR_EraseRootFromParent_Done,
     /* 1395668 */   // Label 19811: @1395668
     /* 1395668 */   GIM_Try, /*On fail goto*//*Label 19812*/ GIMT_Encode4(1395752), // Rule ID 22812 //
     /* 1395673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1395690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1395729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395751 */     // GIR_Coverage, 22812,
     /* 1395751 */     GIR_EraseRootFromParent_Done,
     /* 1395752 */   // Label 19812: @1395752
     /* 1395752 */   GIM_Try, /*On fail goto*//*Label 19813*/ GIMT_Encode4(1395836), // Rule ID 22813 //
     /* 1395757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1395774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1395813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395835 */     // GIR_Coverage, 22813,
     /* 1395835 */     GIR_EraseRootFromParent_Done,
     /* 1395836 */   // Label 19813: @1395836
     /* 1395836 */   GIM_Try, /*On fail goto*//*Label 19814*/ GIMT_Encode4(1395920), // Rule ID 22816 //
     /* 1395841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1395858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395894 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1395897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395919 */     // GIR_Coverage, 22816,
     /* 1395919 */     GIR_EraseRootFromParent_Done,
     /* 1395920 */   // Label 19814: @1395920
     /* 1395920 */   GIM_Try, /*On fail goto*//*Label 19815*/ GIMT_Encode4(1396004), // Rule ID 22817 //
     /* 1395925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1395942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395978 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1395981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396003 */     // GIR_Coverage, 22817,
     /* 1396003 */     GIR_EraseRootFromParent_Done,
     /* 1396004 */   // Label 19815: @1396004
     /* 1396004 */   GIM_Try, /*On fail goto*//*Label 19816*/ GIMT_Encode4(1396088), // Rule ID 22820 //
     /* 1396009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1396026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1396032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396062 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1396065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396087 */     // GIR_Coverage, 22820,
     /* 1396087 */     GIR_EraseRootFromParent_Done,
     /* 1396088 */   // Label 19816: @1396088
     /* 1396088 */   GIM_Try, /*On fail goto*//*Label 19817*/ GIMT_Encode4(1396172), // Rule ID 22821 //
     /* 1396093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1396110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1396116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396146 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1396149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396171 */     // GIR_Coverage, 22821,
     /* 1396171 */     GIR_EraseRootFromParent_Done,
     /* 1396172 */   // Label 19817: @1396172
     /* 1396172 */   GIM_Try, /*On fail goto*//*Label 19818*/ GIMT_Encode4(1396256), // Rule ID 22824 //
     /* 1396177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1396194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396230 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1396233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396255 */     // GIR_Coverage, 22824,
     /* 1396255 */     GIR_EraseRootFromParent_Done,
     /* 1396256 */   // Label 19818: @1396256
     /* 1396256 */   GIM_Try, /*On fail goto*//*Label 19819*/ GIMT_Encode4(1396340), // Rule ID 22825 //
     /* 1396261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1396278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396314 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1396317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396339 */     // GIR_Coverage, 22825,
     /* 1396339 */     GIR_EraseRootFromParent_Done,
     /* 1396340 */   // Label 19819: @1396340
     /* 1396340 */   GIM_Try, /*On fail goto*//*Label 19820*/ GIMT_Encode4(1396424), // Rule ID 22828 //
     /* 1396345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1396362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396398 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1396401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396423 */     // GIR_Coverage, 22828,
     /* 1396423 */     GIR_EraseRootFromParent_Done,
     /* 1396424 */   // Label 19820: @1396424
     /* 1396424 */   GIM_Try, /*On fail goto*//*Label 19821*/ GIMT_Encode4(1396508), // Rule ID 22829 //
     /* 1396429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1396446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1396485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396507 */     // GIR_Coverage, 22829,
     /* 1396507 */     GIR_EraseRootFromParent_Done,
     /* 1396508 */   // Label 19821: @1396508
     /* 1396508 */   GIM_Try, /*On fail goto*//*Label 19822*/ GIMT_Encode4(1396592), // Rule ID 22832 //
     /* 1396513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1396530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1396569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396591 */     // GIR_Coverage, 22832,
     /* 1396591 */     GIR_EraseRootFromParent_Done,
     /* 1396592 */   // Label 19822: @1396592
     /* 1396592 */   GIM_Try, /*On fail goto*//*Label 19823*/ GIMT_Encode4(1396676), // Rule ID 22833 //
     /* 1396597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1396614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396650 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1396653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396675 */     // GIR_Coverage, 22833,
     /* 1396675 */     GIR_EraseRootFromParent_Done,
     /* 1396676 */   // Label 19823: @1396676
     /* 1396676 */   GIM_Try, /*On fail goto*//*Label 19824*/ GIMT_Encode4(1396760), // Rule ID 22952 //
     /* 1396681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1396684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1396698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1396704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396734 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1396737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396759 */     // GIR_Coverage, 22952,
     /* 1396759 */     GIR_EraseRootFromParent_Done,
     /* 1396760 */   // Label 19824: @1396760
     /* 1396760 */   GIM_Try, /*On fail goto*//*Label 19825*/ GIMT_Encode4(1396844), // Rule ID 22953 //
     /* 1396765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1396768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1396782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1396788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396818 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1396821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396843 */     // GIR_Coverage, 22953,
     /* 1396843 */     GIR_EraseRootFromParent_Done,
     /* 1396844 */   // Label 19825: @1396844
     /* 1396844 */   GIM_Try, /*On fail goto*//*Label 19826*/ GIMT_Encode4(1396928), // Rule ID 22956 //
     /* 1396849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1396852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1396866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1396872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396902 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1396905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396927 */     // GIR_Coverage, 22956,
     /* 1396927 */     GIR_EraseRootFromParent_Done,
     /* 1396928 */   // Label 19826: @1396928
     /* 1396928 */   GIM_Try, /*On fail goto*//*Label 19827*/ GIMT_Encode4(1397012), // Rule ID 22957 //
     /* 1396933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1396936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1396950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1396956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396986 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1396989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397011 */     // GIR_Coverage, 22957,
     /* 1397011 */     GIR_EraseRootFromParent_Done,
     /* 1397012 */   // Label 19827: @1397012
     /* 1397012 */   GIM_Try, /*On fail goto*//*Label 19828*/ GIMT_Encode4(1397096), // Rule ID 22960 //
     /* 1397017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1397020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1397034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397070 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1397073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397095 */     // GIR_Coverage, 22960,
     /* 1397095 */     GIR_EraseRootFromParent_Done,
     /* 1397096 */   // Label 19828: @1397096
     /* 1397096 */   GIM_Try, /*On fail goto*//*Label 19829*/ GIMT_Encode4(1397180), // Rule ID 22961 //
     /* 1397101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1397104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1397118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397154 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1397157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397179 */     // GIR_Coverage, 22961,
     /* 1397179 */     GIR_EraseRootFromParent_Done,
     /* 1397180 */   // Label 19829: @1397180
     /* 1397180 */   GIM_Try, /*On fail goto*//*Label 19830*/ GIMT_Encode4(1397264), // Rule ID 22964 //
     /* 1397185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1397202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397238 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1397241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397263 */     // GIR_Coverage, 22964,
     /* 1397263 */     GIR_EraseRootFromParent_Done,
     /* 1397264 */   // Label 19830: @1397264
     /* 1397264 */   GIM_Try, /*On fail goto*//*Label 19831*/ GIMT_Encode4(1397348), // Rule ID 22965 //
     /* 1397269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1397286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397322 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1397325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397347 */     // GIR_Coverage, 22965,
     /* 1397347 */     GIR_EraseRootFromParent_Done,
     /* 1397348 */   // Label 19831: @1397348
     /* 1397348 */   GIM_Try, /*On fail goto*//*Label 19832*/ GIMT_Encode4(1397432), // Rule ID 22968 //
     /* 1397353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1397356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1397370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397406 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1397409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397431 */     // GIR_Coverage, 22968,
     /* 1397431 */     GIR_EraseRootFromParent_Done,
     /* 1397432 */   // Label 19832: @1397432
     /* 1397432 */   GIM_Try, /*On fail goto*//*Label 19833*/ GIMT_Encode4(1397516), // Rule ID 22969 //
     /* 1397437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1397440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1397454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397490 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1397493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397515 */     // GIR_Coverage, 22969,
     /* 1397515 */     GIR_EraseRootFromParent_Done,
     /* 1397516 */   // Label 19833: @1397516
     /* 1397516 */   GIM_Try, /*On fail goto*//*Label 19834*/ GIMT_Encode4(1397600), // Rule ID 22972 //
     /* 1397521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1397524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1397538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397574 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1397577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1397595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397599 */     // GIR_Coverage, 22972,
     /* 1397599 */     GIR_EraseRootFromParent_Done,
     /* 1397600 */   // Label 19834: @1397600
     /* 1397600 */   GIM_Try, /*On fail goto*//*Label 19835*/ GIMT_Encode4(1397684), // Rule ID 22973 //
     /* 1397605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1397608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1397622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397658 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1397661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1397679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397683 */     // GIR_Coverage, 22973,
     /* 1397683 */     GIR_EraseRootFromParent_Done,
     /* 1397684 */   // Label 19835: @1397684
     /* 1397684 */   GIM_Try, /*On fail goto*//*Label 19836*/ GIMT_Encode4(1397768), // Rule ID 22976 //
     /* 1397689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1397706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1397712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1397727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397742 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1397745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397767 */     // GIR_Coverage, 22976,
     /* 1397767 */     GIR_EraseRootFromParent_Done,
     /* 1397768 */   // Label 19836: @1397768
     /* 1397768 */   GIM_Try, /*On fail goto*//*Label 19837*/ GIMT_Encode4(1397852), // Rule ID 22977 //
     /* 1397773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1397790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1397796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1397811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397826 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1397829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397851 */     // GIR_Coverage, 22977,
     /* 1397851 */     GIR_EraseRootFromParent_Done,
     /* 1397852 */   // Label 19837: @1397852
     /* 1397852 */   GIM_Try, /*On fail goto*//*Label 19838*/ GIMT_Encode4(1397936), // Rule ID 22980 //
     /* 1397857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1397874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1397880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397910 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1397913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397935 */     // GIR_Coverage, 22980,
     /* 1397935 */     GIR_EraseRootFromParent_Done,
     /* 1397936 */   // Label 19838: @1397936
     /* 1397936 */   GIM_Try, /*On fail goto*//*Label 19839*/ GIMT_Encode4(1398020), // Rule ID 22981 //
     /* 1397941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1397958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1397964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397994 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1397997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398019 */     // GIR_Coverage, 22981,
     /* 1398019 */     GIR_EraseRootFromParent_Done,
     /* 1398020 */   // Label 19839: @1398020
     /* 1398020 */   GIM_Try, /*On fail goto*//*Label 19840*/ GIMT_Encode4(1398104), // Rule ID 22984 //
     /* 1398025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1398028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1398042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1398048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398078 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1398081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398103 */     // GIR_Coverage, 22984,
     /* 1398103 */     GIR_EraseRootFromParent_Done,
     /* 1398104 */   // Label 19840: @1398104
     /* 1398104 */   GIM_Try, /*On fail goto*//*Label 19841*/ GIMT_Encode4(1398188), // Rule ID 22985 //
     /* 1398109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1398112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1398126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1398132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398162 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1398165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398187 */     // GIR_Coverage, 22985,
     /* 1398187 */     GIR_EraseRootFromParent_Done,
     /* 1398188 */   // Label 19841: @1398188
     /* 1398188 */   GIM_Try, /*On fail goto*//*Label 19842*/ GIMT_Encode4(1398272), // Rule ID 22988 //
     /* 1398193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1398210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398246 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1398249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398271 */     // GIR_Coverage, 22988,
     /* 1398271 */     GIR_EraseRootFromParent_Done,
     /* 1398272 */   // Label 19842: @1398272
     /* 1398272 */   GIM_Try, /*On fail goto*//*Label 19843*/ GIMT_Encode4(1398356), // Rule ID 22989 //
     /* 1398277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1398280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1398294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398330 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1398333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398355 */     // GIR_Coverage, 22989,
     /* 1398355 */     GIR_EraseRootFromParent_Done,
     /* 1398356 */   // Label 19843: @1398356
     /* 1398356 */   GIM_Try, /*On fail goto*//*Label 19844*/ GIMT_Encode4(1398440), // Rule ID 22992 //
     /* 1398361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1398378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398414 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1398417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398439 */     // GIR_Coverage, 22992,
     /* 1398439 */     GIR_EraseRootFromParent_Done,
     /* 1398440 */   // Label 19844: @1398440
     /* 1398440 */   GIM_Try, /*On fail goto*//*Label 19845*/ GIMT_Encode4(1398524), // Rule ID 22993 //
     /* 1398445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1398448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1398462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398498 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1398501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398523 */     // GIR_Coverage, 22993,
     /* 1398523 */     GIR_EraseRootFromParent_Done,
     /* 1398524 */   // Label 19845: @1398524
     /* 1398524 */   GIM_Try, /*On fail goto*//*Label 19846*/ GIMT_Encode4(1398608), // Rule ID 22996 //
     /* 1398529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1398546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398582 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1398585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398607 */     // GIR_Coverage, 22996,
     /* 1398607 */     GIR_EraseRootFromParent_Done,
     /* 1398608 */   // Label 19846: @1398608
     /* 1398608 */   GIM_Try, /*On fail goto*//*Label 19847*/ GIMT_Encode4(1398692), // Rule ID 22997 //
     /* 1398613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1398616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1398630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398666 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1398669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398691 */     // GIR_Coverage, 22997,
     /* 1398691 */     GIR_EraseRootFromParent_Done,
     /* 1398692 */   // Label 19847: @1398692
     /* 1398692 */   GIM_Try, /*On fail goto*//*Label 19848*/ GIMT_Encode4(1398776), // Rule ID 23000 //
     /* 1398697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1398700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1398714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1398720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398750 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1398753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398775 */     // GIR_Coverage, 23000,
     /* 1398775 */     GIR_EraseRootFromParent_Done,
     /* 1398776 */   // Label 19848: @1398776
     /* 1398776 */   GIM_Try, /*On fail goto*//*Label 19849*/ GIMT_Encode4(1398860), // Rule ID 23001 //
     /* 1398781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1398784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1398798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1398804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398834 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1398837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398859 */     // GIR_Coverage, 23001,
     /* 1398859 */     GIR_EraseRootFromParent_Done,
     /* 1398860 */   // Label 19849: @1398860
     /* 1398860 */   GIM_Try, /*On fail goto*//*Label 19850*/ GIMT_Encode4(1398944), // Rule ID 23004 //
     /* 1398865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1398868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1398882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398918 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1398921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398943 */     // GIR_Coverage, 23004,
     /* 1398943 */     GIR_EraseRootFromParent_Done,
     /* 1398944 */   // Label 19850: @1398944
     /* 1398944 */   GIM_Try, /*On fail goto*//*Label 19851*/ GIMT_Encode4(1399028), // Rule ID 23005 //
     /* 1398949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1398952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1398966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399002 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1399005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399027 */     // GIR_Coverage, 23005,
     /* 1399027 */     GIR_EraseRootFromParent_Done,
     /* 1399028 */   // Label 19851: @1399028
     /* 1399028 */   GIM_Try, /*On fail goto*//*Label 19852*/ GIMT_Encode4(1399112), // Rule ID 23008 //
     /* 1399033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1399036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1399050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399086 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1399089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399111 */     // GIR_Coverage, 23008,
     /* 1399111 */     GIR_EraseRootFromParent_Done,
     /* 1399112 */   // Label 19852: @1399112
     /* 1399112 */   GIM_Try, /*On fail goto*//*Label 19853*/ GIMT_Encode4(1399196), // Rule ID 23009 //
     /* 1399117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1399120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1399134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399170 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1399173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399195 */     // GIR_Coverage, 23009,
     /* 1399195 */     GIR_EraseRootFromParent_Done,
     /* 1399196 */   // Label 19853: @1399196
     /* 1399196 */   GIM_Try, /*On fail goto*//*Label 19854*/ GIMT_Encode4(1399280), // Rule ID 23012 //
     /* 1399201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1399204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1399218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399254 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1399257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399279 */     // GIR_Coverage, 23012,
     /* 1399279 */     GIR_EraseRootFromParent_Done,
     /* 1399280 */   // Label 19854: @1399280
     /* 1399280 */   GIM_Try, /*On fail goto*//*Label 19855*/ GIMT_Encode4(1399364), // Rule ID 23013 //
     /* 1399285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1399288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1399302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399338 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1399341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399363 */     // GIR_Coverage, 23013,
     /* 1399363 */     GIR_EraseRootFromParent_Done,
     /* 1399364 */   // Label 19855: @1399364
     /* 1399364 */   GIM_Try, /*On fail goto*//*Label 19856*/ GIMT_Encode4(1399448), // Rule ID 23016 //
     /* 1399369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1399372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1399386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399422 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1399425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399447 */     // GIR_Coverage, 23016,
     /* 1399447 */     GIR_EraseRootFromParent_Done,
     /* 1399448 */   // Label 19856: @1399448
     /* 1399448 */   GIM_Try, /*On fail goto*//*Label 19857*/ GIMT_Encode4(1399532), // Rule ID 23017 //
     /* 1399453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1399456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1399470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399506 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1399509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399531 */     // GIR_Coverage, 23017,
     /* 1399531 */     GIR_EraseRootFromParent_Done,
     /* 1399532 */   // Label 19857: @1399532
     /* 1399532 */   GIM_Try, /*On fail goto*//*Label 19858*/ GIMT_Encode4(1399616), // Rule ID 23020 //
     /* 1399537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1399540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1399554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399590 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1399593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399615 */     // GIR_Coverage, 23020,
     /* 1399615 */     GIR_EraseRootFromParent_Done,
     /* 1399616 */   // Label 19858: @1399616
     /* 1399616 */   GIM_Try, /*On fail goto*//*Label 19859*/ GIMT_Encode4(1399700), // Rule ID 23021 //
     /* 1399621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1399624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1399638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399674 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1399677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399699 */     // GIR_Coverage, 23021,
     /* 1399699 */     GIR_EraseRootFromParent_Done,
     /* 1399700 */   // Label 19859: @1399700
     /* 1399700 */   GIM_Try, /*On fail goto*//*Label 19860*/ GIMT_Encode4(1399784), // Rule ID 23024 //
     /* 1399705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1399708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1399722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399758 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1399761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399783 */     // GIR_Coverage, 23024,
     /* 1399783 */     GIR_EraseRootFromParent_Done,
     /* 1399784 */   // Label 19860: @1399784
     /* 1399784 */   GIM_Try, /*On fail goto*//*Label 19861*/ GIMT_Encode4(1399868), // Rule ID 23025 //
     /* 1399789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1399792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1399806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399842 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1399845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399867 */     // GIR_Coverage, 23025,
     /* 1399867 */     GIR_EraseRootFromParent_Done,
     /* 1399868 */   // Label 19861: @1399868
     /* 1399868 */   GIM_Try, /*On fail goto*//*Label 19862*/ GIMT_Encode4(1399952), // Rule ID 23028 //
     /* 1399873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1399876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1399890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399926 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1399929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399951 */     // GIR_Coverage, 23028,
     /* 1399951 */     GIR_EraseRootFromParent_Done,
     /* 1399952 */   // Label 19862: @1399952
     /* 1399952 */   GIM_Try, /*On fail goto*//*Label 19863*/ GIMT_Encode4(1400036), // Rule ID 23029 //
     /* 1399957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1399960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1399974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400010 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1400013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400035 */     // GIR_Coverage, 23029,
     /* 1400035 */     GIR_EraseRootFromParent_Done,
     /* 1400036 */   // Label 19863: @1400036
     /* 1400036 */   GIM_Try, /*On fail goto*//*Label 19864*/ GIMT_Encode4(1400120), // Rule ID 23032 //
     /* 1400041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1400044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1400058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400094 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1400097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400119 */     // GIR_Coverage, 23032,
     /* 1400119 */     GIR_EraseRootFromParent_Done,
     /* 1400120 */   // Label 19864: @1400120
     /* 1400120 */   GIM_Try, /*On fail goto*//*Label 19865*/ GIMT_Encode4(1400204), // Rule ID 23033 //
     /* 1400125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1400128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1400142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400178 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1400181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400203 */     // GIR_Coverage, 23033,
     /* 1400203 */     GIR_EraseRootFromParent_Done,
     /* 1400204 */   // Label 19865: @1400204
     /* 1400204 */   GIM_Try, /*On fail goto*//*Label 19866*/ GIMT_Encode4(1400288), // Rule ID 23036 //
     /* 1400209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1400226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400262 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1400265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400287 */     // GIR_Coverage, 23036,
     /* 1400287 */     GIR_EraseRootFromParent_Done,
     /* 1400288 */   // Label 19866: @1400288
     /* 1400288 */   GIM_Try, /*On fail goto*//*Label 19867*/ GIMT_Encode4(1400372), // Rule ID 23037 //
     /* 1400293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1400310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400346 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1400349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400371 */     // GIR_Coverage, 23037,
     /* 1400371 */     GIR_EraseRootFromParent_Done,
     /* 1400372 */   // Label 19867: @1400372
     /* 1400372 */   GIM_Try, /*On fail goto*//*Label 19868*/ GIMT_Encode4(1400456), // Rule ID 23040 //
     /* 1400377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1400394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1400400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400430 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1400433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400455 */     // GIR_Coverage, 23040,
     /* 1400455 */     GIR_EraseRootFromParent_Done,
     /* 1400456 */   // Label 19868: @1400456
     /* 1400456 */   GIM_Try, /*On fail goto*//*Label 19869*/ GIMT_Encode4(1400540), // Rule ID 23041 //
     /* 1400461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1400478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1400484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400514 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1400517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400539 */     // GIR_Coverage, 23041,
     /* 1400539 */     GIR_EraseRootFromParent_Done,
     /* 1400540 */   // Label 19869: @1400540
     /* 1400540 */   GIM_Try, /*On fail goto*//*Label 19870*/ GIMT_Encode4(1400624), // Rule ID 23044 //
     /* 1400545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1400562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1400568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400598 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1400601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400623 */     // GIR_Coverage, 23044,
     /* 1400623 */     GIR_EraseRootFromParent_Done,
     /* 1400624 */   // Label 19870: @1400624
     /* 1400624 */   GIM_Try, /*On fail goto*//*Label 19871*/ GIMT_Encode4(1400708), // Rule ID 23045 //
     /* 1400629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1400646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1400652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400682 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1400685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400707 */     // GIR_Coverage, 23045,
     /* 1400707 */     GIR_EraseRootFromParent_Done,
     /* 1400708 */   // Label 19871: @1400708
     /* 1400708 */   GIM_Try, /*On fail goto*//*Label 19872*/ GIMT_Encode4(1400792), // Rule ID 23048 //
     /* 1400713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1400716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1400730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400766 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1400769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400791 */     // GIR_Coverage, 23048,
     /* 1400791 */     GIR_EraseRootFromParent_Done,
     /* 1400792 */   // Label 19872: @1400792
     /* 1400792 */   GIM_Try, /*On fail goto*//*Label 19873*/ GIMT_Encode4(1400876), // Rule ID 23049 //
     /* 1400797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1400800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1400814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400850 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1400853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400875 */     // GIR_Coverage, 23049,
     /* 1400875 */     GIR_EraseRootFromParent_Done,
     /* 1400876 */   // Label 19873: @1400876
     /* 1400876 */   GIM_Try, /*On fail goto*//*Label 19874*/ GIMT_Encode4(1400960), // Rule ID 23052 //
     /* 1400881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1400884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1400898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400934 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1400937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400959 */     // GIR_Coverage, 23052,
     /* 1400959 */     GIR_EraseRootFromParent_Done,
     /* 1400960 */   // Label 19874: @1400960
     /* 1400960 */   GIM_Try, /*On fail goto*//*Label 19875*/ GIMT_Encode4(1401044), // Rule ID 23053 //
     /* 1400965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1400968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1400982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401018 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1401021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401043 */     // GIR_Coverage, 23053,
     /* 1401043 */     GIR_EraseRootFromParent_Done,
     /* 1401044 */   // Label 19875: @1401044
     /* 1401044 */   GIM_Try, /*On fail goto*//*Label 19876*/ GIMT_Encode4(1401128), // Rule ID 23056 //
     /* 1401049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1401052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1401066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1401072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401102 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1401105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401127 */     // GIR_Coverage, 23056,
     /* 1401127 */     GIR_EraseRootFromParent_Done,
     /* 1401128 */   // Label 19876: @1401128
     /* 1401128 */   GIM_Try, /*On fail goto*//*Label 19877*/ GIMT_Encode4(1401212), // Rule ID 23057 //
     /* 1401133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1401136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1401150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1401156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401186 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1401189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401211 */     // GIR_Coverage, 23057,
     /* 1401211 */     GIR_EraseRootFromParent_Done,
     /* 1401212 */   // Label 19877: @1401212
     /* 1401212 */   GIM_Try, /*On fail goto*//*Label 19878*/ GIMT_Encode4(1401296), // Rule ID 23060 //
     /* 1401217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1401220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1401234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1401240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401270 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1401273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401295 */     // GIR_Coverage, 23060,
     /* 1401295 */     GIR_EraseRootFromParent_Done,
     /* 1401296 */   // Label 19878: @1401296
     /* 1401296 */   GIM_Try, /*On fail goto*//*Label 19879*/ GIMT_Encode4(1401380), // Rule ID 23061 //
     /* 1401301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1401304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1401318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1401324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401354 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1401357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401379 */     // GIR_Coverage, 23061,
     /* 1401379 */     GIR_EraseRootFromParent_Done,
     /* 1401380 */   // Label 19879: @1401380
     /* 1401380 */   GIM_Try, /*On fail goto*//*Label 19880*/ GIMT_Encode4(1401464), // Rule ID 23064 //
     /* 1401385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1401388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1401402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401438 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1401441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401463 */     // GIR_Coverage, 23064,
     /* 1401463 */     GIR_EraseRootFromParent_Done,
     /* 1401464 */   // Label 19880: @1401464
     /* 1401464 */   GIM_Try, /*On fail goto*//*Label 19881*/ GIMT_Encode4(1401548), // Rule ID 23065 //
     /* 1401469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1401472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1401486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401522 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1401525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401547 */     // GIR_Coverage, 23065,
     /* 1401547 */     GIR_EraseRootFromParent_Done,
     /* 1401548 */   // Label 19881: @1401548
     /* 1401548 */   GIM_Try, /*On fail goto*//*Label 19882*/ GIMT_Encode4(1401632), // Rule ID 23068 //
     /* 1401553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1401556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1401570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1401576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401606 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1401609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401631 */     // GIR_Coverage, 23068,
     /* 1401631 */     GIR_EraseRootFromParent_Done,
     /* 1401632 */   // Label 19882: @1401632
     /* 1401632 */   GIM_Try, /*On fail goto*//*Label 19883*/ GIMT_Encode4(1401716), // Rule ID 23069 //
     /* 1401637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1401640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1401654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1401660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401690 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1401693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401715 */     // GIR_Coverage, 23069,
     /* 1401715 */     GIR_EraseRootFromParent_Done,
     /* 1401716 */   // Label 19883: @1401716
     /* 1401716 */   GIM_Reject,
     /* 1401717 */ // Label 13825: @1401717
     /* 1401717 */ GIM_Try, /*On fail goto*//*Label 19884*/ GIMT_Encode4(2015518),
     /* 1401722 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 1401725 */   GIM_Try, /*On fail goto*//*Label 19885*/ GIMT_Encode4(1401811), // Rule ID 7362 //
     /* 1401730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1401733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1401741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1401744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1401747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1401750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1401753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401776 */     // MIs[0] policy
     /* 1401776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401786 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1401789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1401807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401810 */     // GIR_Coverage, 7362,
     /* 1401810 */     GIR_EraseRootFromParent_Done,
     /* 1401811 */   // Label 19885: @1401811
     /* 1401811 */   GIM_Try, /*On fail goto*//*Label 19886*/ GIMT_Encode4(1401897), // Rule ID 7363 //
     /* 1401816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1401819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1401827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1401830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1401833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1401836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1401839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401862 */     // MIs[0] policy
     /* 1401862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401872 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1401875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1401893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401896 */     // GIR_Coverage, 7363,
     /* 1401896 */     GIR_EraseRootFromParent_Done,
     /* 1401897 */   // Label 19886: @1401897
     /* 1401897 */   GIM_Try, /*On fail goto*//*Label 19887*/ GIMT_Encode4(1401983), // Rule ID 7366 //
     /* 1401902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1401905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1401913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1401916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1401919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1401922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1401925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401948 */     // MIs[0] policy
     /* 1401948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401958 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1401961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1401979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401982 */     // GIR_Coverage, 7366,
     /* 1401982 */     GIR_EraseRootFromParent_Done,
     /* 1401983 */   // Label 19887: @1401983
     /* 1401983 */   GIM_Try, /*On fail goto*//*Label 19888*/ GIMT_Encode4(1402069), // Rule ID 7367 //
     /* 1401988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1401991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1401999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1402002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1402005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402034 */     // MIs[0] policy
     /* 1402034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402044 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402068 */     // GIR_Coverage, 7367,
     /* 1402068 */     GIR_EraseRootFromParent_Done,
     /* 1402069 */   // Label 19888: @1402069
     /* 1402069 */   GIM_Try, /*On fail goto*//*Label 19889*/ GIMT_Encode4(1402155), // Rule ID 7370 //
     /* 1402074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1402085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1402088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1402091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402120 */     // MIs[0] policy
     /* 1402120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402130 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402154 */     // GIR_Coverage, 7370,
     /* 1402154 */     GIR_EraseRootFromParent_Done,
     /* 1402155 */   // Label 19889: @1402155
     /* 1402155 */   GIM_Try, /*On fail goto*//*Label 19890*/ GIMT_Encode4(1402241), // Rule ID 7371 //
     /* 1402160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1402171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1402174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1402177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402206 */     // MIs[0] policy
     /* 1402206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402216 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402240 */     // GIR_Coverage, 7371,
     /* 1402240 */     GIR_EraseRootFromParent_Done,
     /* 1402241 */   // Label 19890: @1402241
     /* 1402241 */   GIM_Try, /*On fail goto*//*Label 19891*/ GIMT_Encode4(1402327), // Rule ID 7374 //
     /* 1402246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1402257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1402260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1402263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402292 */     // MIs[0] policy
     /* 1402292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402302 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402326 */     // GIR_Coverage, 7374,
     /* 1402326 */     GIR_EraseRootFromParent_Done,
     /* 1402327 */   // Label 19891: @1402327
     /* 1402327 */   GIM_Try, /*On fail goto*//*Label 19892*/ GIMT_Encode4(1402413), // Rule ID 7375 //
     /* 1402332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1402343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1402346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1402349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402378 */     // MIs[0] policy
     /* 1402378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402388 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402412 */     // GIR_Coverage, 7375,
     /* 1402412 */     GIR_EraseRootFromParent_Done,
     /* 1402413 */   // Label 19892: @1402413
     /* 1402413 */   GIM_Try, /*On fail goto*//*Label 19893*/ GIMT_Encode4(1402499), // Rule ID 7378 //
     /* 1402418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1402429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1402432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1402435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402464 */     // MIs[0] policy
     /* 1402464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402474 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402498 */     // GIR_Coverage, 7378,
     /* 1402498 */     GIR_EraseRootFromParent_Done,
     /* 1402499 */   // Label 19893: @1402499
     /* 1402499 */   GIM_Try, /*On fail goto*//*Label 19894*/ GIMT_Encode4(1402585), // Rule ID 7379 //
     /* 1402504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1402515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1402518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1402521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402550 */     // MIs[0] policy
     /* 1402550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402560 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402584 */     // GIR_Coverage, 7379,
     /* 1402584 */     GIR_EraseRootFromParent_Done,
     /* 1402585 */   // Label 19894: @1402585
     /* 1402585 */   GIM_Try, /*On fail goto*//*Label 19895*/ GIMT_Encode4(1402671), // Rule ID 7382 //
     /* 1402590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1402601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1402604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1402607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402636 */     // MIs[0] policy
     /* 1402636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402670 */     // GIR_Coverage, 7382,
     /* 1402670 */     GIR_EraseRootFromParent_Done,
     /* 1402671 */   // Label 19895: @1402671
     /* 1402671 */   GIM_Try, /*On fail goto*//*Label 19896*/ GIMT_Encode4(1402757), // Rule ID 7383 //
     /* 1402676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1402687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1402690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1402693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402722 */     // MIs[0] policy
     /* 1402722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402756 */     // GIR_Coverage, 7383,
     /* 1402756 */     GIR_EraseRootFromParent_Done,
     /* 1402757 */   // Label 19896: @1402757
     /* 1402757 */   GIM_Try, /*On fail goto*//*Label 19897*/ GIMT_Encode4(1402843), // Rule ID 7386 //
     /* 1402762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1402773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1402776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1402779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402808 */     // MIs[0] policy
     /* 1402808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1402821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402842 */     // GIR_Coverage, 7386,
     /* 1402842 */     GIR_EraseRootFromParent_Done,
     /* 1402843 */   // Label 19897: @1402843
     /* 1402843 */   GIM_Try, /*On fail goto*//*Label 19898*/ GIMT_Encode4(1402929), // Rule ID 7387 //
     /* 1402848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1402859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1402862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1402865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402894 */     // MIs[0] policy
     /* 1402894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402904 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1402907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402928 */     // GIR_Coverage, 7387,
     /* 1402928 */     GIR_EraseRootFromParent_Done,
     /* 1402929 */   // Label 19898: @1402929
     /* 1402929 */   GIM_Try, /*On fail goto*//*Label 19899*/ GIMT_Encode4(1403015), // Rule ID 7390 //
     /* 1402934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1402945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1402948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1402951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402980 */     // MIs[0] policy
     /* 1402980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402990 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1402993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403014 */     // GIR_Coverage, 7390,
     /* 1403014 */     GIR_EraseRootFromParent_Done,
     /* 1403015 */   // Label 19899: @1403015
     /* 1403015 */   GIM_Try, /*On fail goto*//*Label 19900*/ GIMT_Encode4(1403101), // Rule ID 7391 //
     /* 1403020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1403037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1403043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403066 */     // MIs[0] policy
     /* 1403066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403076 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403100 */     // GIR_Coverage, 7391,
     /* 1403100 */     GIR_EraseRootFromParent_Done,
     /* 1403101 */   // Label 19900: @1403101
     /* 1403101 */   GIM_Try, /*On fail goto*//*Label 19901*/ GIMT_Encode4(1403187), // Rule ID 7394 //
     /* 1403106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1403117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1403120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1403123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1403129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403152 */     // MIs[0] policy
     /* 1403152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403162 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403186 */     // GIR_Coverage, 7394,
     /* 1403186 */     GIR_EraseRootFromParent_Done,
     /* 1403187 */   // Label 19901: @1403187
     /* 1403187 */   GIM_Try, /*On fail goto*//*Label 19902*/ GIMT_Encode4(1403273), // Rule ID 7395 //
     /* 1403192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1403203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1403206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1403209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1403215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403238 */     // MIs[0] policy
     /* 1403238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403248 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403272 */     // GIR_Coverage, 7395,
     /* 1403272 */     GIR_EraseRootFromParent_Done,
     /* 1403273 */   // Label 19902: @1403273
     /* 1403273 */   GIM_Try, /*On fail goto*//*Label 19903*/ GIMT_Encode4(1403359), // Rule ID 7398 //
     /* 1403278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1403281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1403289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1403292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1403295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403324 */     // MIs[0] policy
     /* 1403324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403334 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403358 */     // GIR_Coverage, 7398,
     /* 1403358 */     GIR_EraseRootFromParent_Done,
     /* 1403359 */   // Label 19903: @1403359
     /* 1403359 */   GIM_Try, /*On fail goto*//*Label 19904*/ GIMT_Encode4(1403445), // Rule ID 7399 //
     /* 1403364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1403367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1403375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1403378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1403381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403410 */     // MIs[0] policy
     /* 1403410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403444 */     // GIR_Coverage, 7399,
     /* 1403444 */     GIR_EraseRootFromParent_Done,
     /* 1403445 */   // Label 19904: @1403445
     /* 1403445 */   GIM_Try, /*On fail goto*//*Label 19905*/ GIMT_Encode4(1403531), // Rule ID 7402 //
     /* 1403450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1403461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1403464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1403467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1403473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1403480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403496 */     // MIs[0] policy
     /* 1403496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403506 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1403509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403530 */     // GIR_Coverage, 7402,
     /* 1403530 */     GIR_EraseRootFromParent_Done,
     /* 1403531 */   // Label 19905: @1403531
     /* 1403531 */   GIM_Try, /*On fail goto*//*Label 19906*/ GIMT_Encode4(1403617), // Rule ID 7403 //
     /* 1403536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1403547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1403550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1403553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1403559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1403566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403582 */     // MIs[0] policy
     /* 1403582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1403595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403616 */     // GIR_Coverage, 7403,
     /* 1403616 */     GIR_EraseRootFromParent_Done,
     /* 1403617 */   // Label 19906: @1403617
     /* 1403617 */   GIM_Try, /*On fail goto*//*Label 19907*/ GIMT_Encode4(1403703), // Rule ID 7406 //
     /* 1403622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1403633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1403636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1403639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1403645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1403652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403668 */     // MIs[0] policy
     /* 1403668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403678 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1403681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403702 */     // GIR_Coverage, 7406,
     /* 1403702 */     GIR_EraseRootFromParent_Done,
     /* 1403703 */   // Label 19907: @1403703
     /* 1403703 */   GIM_Try, /*On fail goto*//*Label 19908*/ GIMT_Encode4(1403789), // Rule ID 7407 //
     /* 1403708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1403719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1403722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1403725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1403731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1403738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403754 */     // MIs[0] policy
     /* 1403754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403764 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1403767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403788 */     // GIR_Coverage, 7407,
     /* 1403788 */     GIR_EraseRootFromParent_Done,
     /* 1403789 */   // Label 19908: @1403789
     /* 1403789 */   GIM_Try, /*On fail goto*//*Label 19909*/ GIMT_Encode4(1403875), // Rule ID 7410 //
     /* 1403794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1403805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1403808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1403811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1403817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1403824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403840 */     // MIs[0] policy
     /* 1403840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403850 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1403853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403874 */     // GIR_Coverage, 7410,
     /* 1403874 */     GIR_EraseRootFromParent_Done,
     /* 1403875 */   // Label 19909: @1403875
     /* 1403875 */   GIM_Try, /*On fail goto*//*Label 19910*/ GIMT_Encode4(1403961), // Rule ID 7411 //
     /* 1403880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1403891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1403894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1403897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1403903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1403910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403926 */     // MIs[0] policy
     /* 1403926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403936 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1403939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403960 */     // GIR_Coverage, 7411,
     /* 1403960 */     GIR_EraseRootFromParent_Done,
     /* 1403961 */   // Label 19910: @1403961
     /* 1403961 */   GIM_Try, /*On fail goto*//*Label 19911*/ GIMT_Encode4(1404047), // Rule ID 7414 //
     /* 1403966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1403977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1403980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1403983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1403989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1403996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404012 */     // MIs[0] policy
     /* 1404012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404046 */     // GIR_Coverage, 7414,
     /* 1404046 */     GIR_EraseRootFromParent_Done,
     /* 1404047 */   // Label 19911: @1404047
     /* 1404047 */   GIM_Try, /*On fail goto*//*Label 19912*/ GIMT_Encode4(1404133), // Rule ID 7415 //
     /* 1404052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1404063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1404066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1404069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404098 */     // MIs[0] policy
     /* 1404098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404108 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404132 */     // GIR_Coverage, 7415,
     /* 1404132 */     GIR_EraseRootFromParent_Done,
     /* 1404133 */   // Label 19912: @1404133
     /* 1404133 */   GIM_Try, /*On fail goto*//*Label 19913*/ GIMT_Encode4(1404219), // Rule ID 7418 //
     /* 1404138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1404149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1404152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1404155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404184 */     // MIs[0] policy
     /* 1404184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404194 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404218 */     // GIR_Coverage, 7418,
     /* 1404218 */     GIR_EraseRootFromParent_Done,
     /* 1404219 */   // Label 19913: @1404219
     /* 1404219 */   GIM_Try, /*On fail goto*//*Label 19914*/ GIMT_Encode4(1404305), // Rule ID 7419 //
     /* 1404224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1404235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1404238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1404241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404270 */     // MIs[0] policy
     /* 1404270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404280 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404304 */     // GIR_Coverage, 7419,
     /* 1404304 */     GIR_EraseRootFromParent_Done,
     /* 1404305 */   // Label 19914: @1404305
     /* 1404305 */   GIM_Try, /*On fail goto*//*Label 19915*/ GIMT_Encode4(1404391), // Rule ID 7422 //
     /* 1404310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1404321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1404324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1404327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404356 */     // MIs[0] policy
     /* 1404356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404366 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404390 */     // GIR_Coverage, 7422,
     /* 1404390 */     GIR_EraseRootFromParent_Done,
     /* 1404391 */   // Label 19915: @1404391
     /* 1404391 */   GIM_Try, /*On fail goto*//*Label 19916*/ GIMT_Encode4(1404477), // Rule ID 7423 //
     /* 1404396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1404407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1404410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1404413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404442 */     // MIs[0] policy
     /* 1404442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404452 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404476 */     // GIR_Coverage, 7423,
     /* 1404476 */     GIR_EraseRootFromParent_Done,
     /* 1404477 */   // Label 19916: @1404477
     /* 1404477 */   GIM_Try, /*On fail goto*//*Label 19917*/ GIMT_Encode4(1404563), // Rule ID 7426 //
     /* 1404482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1404493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1404496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1404499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1404505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404528 */     // MIs[0] policy
     /* 1404528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404538 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404562 */     // GIR_Coverage, 7426,
     /* 1404562 */     GIR_EraseRootFromParent_Done,
     /* 1404563 */   // Label 19917: @1404563
     /* 1404563 */   GIM_Try, /*On fail goto*//*Label 19918*/ GIMT_Encode4(1404649), // Rule ID 7427 //
     /* 1404568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1404579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1404582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1404585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1404591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404614 */     // MIs[0] policy
     /* 1404614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404648 */     // GIR_Coverage, 7427,
     /* 1404648 */     GIR_EraseRootFromParent_Done,
     /* 1404649 */   // Label 19918: @1404649
     /* 1404649 */   GIM_Try, /*On fail goto*//*Label 19919*/ GIMT_Encode4(1404735), // Rule ID 7430 //
     /* 1404654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1404665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1404668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1404671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404700 */     // MIs[0] policy
     /* 1404700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404710 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404734 */     // GIR_Coverage, 7430,
     /* 1404734 */     GIR_EraseRootFromParent_Done,
     /* 1404735 */   // Label 19919: @1404735
     /* 1404735 */   GIM_Try, /*On fail goto*//*Label 19920*/ GIMT_Encode4(1404821), // Rule ID 7431 //
     /* 1404740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1404751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1404754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1404757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404786 */     // MIs[0] policy
     /* 1404786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404796 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404820 */     // GIR_Coverage, 7431,
     /* 1404820 */     GIR_EraseRootFromParent_Done,
     /* 1404821 */   // Label 19920: @1404821
     /* 1404821 */   GIM_Try, /*On fail goto*//*Label 19921*/ GIMT_Encode4(1404907), // Rule ID 7434 //
     /* 1404826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1404837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1404840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1404843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404872 */     // MIs[0] policy
     /* 1404872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404882 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404906 */     // GIR_Coverage, 7434,
     /* 1404906 */     GIR_EraseRootFromParent_Done,
     /* 1404907 */   // Label 19921: @1404907
     /* 1404907 */   GIM_Try, /*On fail goto*//*Label 19922*/ GIMT_Encode4(1404993), // Rule ID 7435 //
     /* 1404912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1404923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1404926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1404929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404958 */     // MIs[0] policy
     /* 1404958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404968 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404992 */     // GIR_Coverage, 7435,
     /* 1404992 */     GIR_EraseRootFromParent_Done,
     /* 1404993 */   // Label 19922: @1404993
     /* 1404993 */   GIM_Try, /*On fail goto*//*Label 19923*/ GIMT_Encode4(1405079), // Rule ID 7438 //
     /* 1404998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1405001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1405009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1405015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1405021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405044 */     // MIs[0] policy
     /* 1405044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405054 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1405057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405078 */     // GIR_Coverage, 7438,
     /* 1405078 */     GIR_EraseRootFromParent_Done,
     /* 1405079 */   // Label 19923: @1405079
     /* 1405079 */   GIM_Try, /*On fail goto*//*Label 19924*/ GIMT_Encode4(1405165), // Rule ID 7439 //
     /* 1405084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1405087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1405095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1405101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1405107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405130 */     // MIs[0] policy
     /* 1405130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405140 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1405143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405164 */     // GIR_Coverage, 7439,
     /* 1405164 */     GIR_EraseRootFromParent_Done,
     /* 1405165 */   // Label 19924: @1405165
     /* 1405165 */   GIM_Try, /*On fail goto*//*Label 19925*/ GIMT_Encode4(1405251), // Rule ID 7442 //
     /* 1405170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1405173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1405187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1405193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405216 */     // MIs[0] policy
     /* 1405216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405226 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1405229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405250 */     // GIR_Coverage, 7442,
     /* 1405250 */     GIR_EraseRootFromParent_Done,
     /* 1405251 */   // Label 19925: @1405251
     /* 1405251 */   GIM_Try, /*On fail goto*//*Label 19926*/ GIMT_Encode4(1405337), // Rule ID 7443 //
     /* 1405256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1405259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1405273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1405279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405302 */     // MIs[0] policy
     /* 1405302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405312 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1405315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405336 */     // GIR_Coverage, 7443,
     /* 1405336 */     GIR_EraseRootFromParent_Done,
     /* 1405337 */   // Label 19926: @1405337
     /* 1405337 */   GIM_Try, /*On fail goto*//*Label 19927*/ GIMT_Encode4(1405423), // Rule ID 7446 //
     /* 1405342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1405345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1405359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405388 */     // MIs[0] policy
     /* 1405388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405398 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1405401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405422 */     // GIR_Coverage, 7446,
     /* 1405422 */     GIR_EraseRootFromParent_Done,
     /* 1405423 */   // Label 19927: @1405423
     /* 1405423 */   GIM_Try, /*On fail goto*//*Label 19928*/ GIMT_Encode4(1405509), // Rule ID 7447 //
     /* 1405428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1405431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1405445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405474 */     // MIs[0] policy
     /* 1405474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1405487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405508 */     // GIR_Coverage, 7447,
     /* 1405508 */     GIR_EraseRootFromParent_Done,
     /* 1405509 */   // Label 19928: @1405509
     /* 1405509 */   GIM_Try, /*On fail goto*//*Label 19929*/ GIMT_Encode4(1405597), // Rule ID 2752 //
     /* 1405514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1405517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1405525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1405528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1405531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405553 */     // MIs[0] Operand 5
     /* 1405553 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405564 */     // MIs[0] policy
     /* 1405564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405574 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1405577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405596 */     // GIR_Coverage, 2752,
     /* 1405596 */     GIR_EraseRootFromParent_Done,
     /* 1405597 */   // Label 19929: @1405597
     /* 1405597 */   GIM_Try, /*On fail goto*//*Label 19930*/ GIMT_Encode4(1405685), // Rule ID 2753 //
     /* 1405602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1405605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1405613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1405616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1405619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405641 */     // MIs[0] Operand 5
     /* 1405641 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405652 */     // MIs[0] policy
     /* 1405652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405662 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1405665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405684 */     // GIR_Coverage, 2753,
     /* 1405684 */     GIR_EraseRootFromParent_Done,
     /* 1405685 */   // Label 19930: @1405685
     /* 1405685 */   GIM_Try, /*On fail goto*//*Label 19931*/ GIMT_Encode4(1405773), // Rule ID 20644 //
     /* 1405690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1405693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1405701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1405704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1405707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1405710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405729 */     // MIs[0] Operand 5
     /* 1405729 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405740 */     // MIs[0] policy
     /* 1405740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405750 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1405753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405772 */     // GIR_Coverage, 20644,
     /* 1405772 */     GIR_EraseRootFromParent_Done,
     /* 1405773 */   // Label 19931: @1405773
     /* 1405773 */   GIM_Try, /*On fail goto*//*Label 19932*/ GIMT_Encode4(1405861), // Rule ID 20645 //
     /* 1405778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1405781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1405789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1405792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1405795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1405798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405817 */     // MIs[0] Operand 5
     /* 1405817 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405828 */     // MIs[0] policy
     /* 1405828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405838 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1405841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405860 */     // GIR_Coverage, 20645,
     /* 1405860 */     GIR_EraseRootFromParent_Done,
     /* 1405861 */   // Label 19932: @1405861
     /* 1405861 */   GIM_Try, /*On fail goto*//*Label 19933*/ GIMT_Encode4(1405949), // Rule ID 20648 //
     /* 1405866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1405869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1405877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1405880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1405883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405905 */     // MIs[0] Operand 5
     /* 1405905 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405916 */     // MIs[0] policy
     /* 1405916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405926 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1405929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405948 */     // GIR_Coverage, 20648,
     /* 1405948 */     GIR_EraseRootFromParent_Done,
     /* 1405949 */   // Label 19933: @1405949
     /* 1405949 */   GIM_Try, /*On fail goto*//*Label 19934*/ GIMT_Encode4(1406037), // Rule ID 20649 //
     /* 1405954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1405957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1405965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1405968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1405971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405993 */     // MIs[0] Operand 5
     /* 1405993 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406004 */     // MIs[0] policy
     /* 1406004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406036 */     // GIR_Coverage, 20649,
     /* 1406036 */     GIR_EraseRootFromParent_Done,
     /* 1406037 */   // Label 19934: @1406037
     /* 1406037 */   GIM_Try, /*On fail goto*//*Label 19935*/ GIMT_Encode4(1406125), // Rule ID 20652 //
     /* 1406042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1406062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406081 */     // MIs[0] Operand 5
     /* 1406081 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406092 */     // MIs[0] policy
     /* 1406092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406124 */     // GIR_Coverage, 20652,
     /* 1406124 */     GIR_EraseRootFromParent_Done,
     /* 1406125 */   // Label 19935: @1406125
     /* 1406125 */   GIM_Try, /*On fail goto*//*Label 19936*/ GIMT_Encode4(1406213), // Rule ID 20653 //
     /* 1406130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1406150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406169 */     // MIs[0] Operand 5
     /* 1406169 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406180 */     // MIs[0] policy
     /* 1406180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406190 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406212 */     // GIR_Coverage, 20653,
     /* 1406212 */     GIR_EraseRootFromParent_Done,
     /* 1406213 */   // Label 19936: @1406213
     /* 1406213 */   GIM_Try, /*On fail goto*//*Label 19937*/ GIMT_Encode4(1406301), // Rule ID 20656 //
     /* 1406218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1406221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406257 */     // MIs[0] Operand 5
     /* 1406257 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406268 */     // MIs[0] policy
     /* 1406268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406278 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406300 */     // GIR_Coverage, 20656,
     /* 1406300 */     GIR_EraseRootFromParent_Done,
     /* 1406301 */   // Label 19937: @1406301
     /* 1406301 */   GIM_Try, /*On fail goto*//*Label 19938*/ GIMT_Encode4(1406389), // Rule ID 20657 //
     /* 1406306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1406309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406345 */     // MIs[0] Operand 5
     /* 1406345 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406356 */     // MIs[0] policy
     /* 1406356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406366 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406388 */     // GIR_Coverage, 20657,
     /* 1406388 */     GIR_EraseRootFromParent_Done,
     /* 1406389 */   // Label 19938: @1406389
     /* 1406389 */   GIM_Try, /*On fail goto*//*Label 19939*/ GIMT_Encode4(1406477), // Rule ID 20660 //
     /* 1406394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1406397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1406411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406433 */     // MIs[0] Operand 5
     /* 1406433 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406444 */     // MIs[0] policy
     /* 1406444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406454 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1406473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406476 */     // GIR_Coverage, 20660,
     /* 1406476 */     GIR_EraseRootFromParent_Done,
     /* 1406477 */   // Label 19939: @1406477
     /* 1406477 */   GIM_Try, /*On fail goto*//*Label 19940*/ GIMT_Encode4(1406565), // Rule ID 20661 //
     /* 1406482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1406485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1406499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406521 */     // MIs[0] Operand 5
     /* 1406521 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406532 */     // MIs[0] policy
     /* 1406532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406542 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1406561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406564 */     // GIR_Coverage, 20661,
     /* 1406564 */     GIR_EraseRootFromParent_Done,
     /* 1406565 */   // Label 19940: @1406565
     /* 1406565 */   GIM_Try, /*On fail goto*//*Label 19941*/ GIMT_Encode4(1406653), // Rule ID 20664 //
     /* 1406570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1406581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1406584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1406587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1406590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1406597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406609 */     // MIs[0] Operand 5
     /* 1406609 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406620 */     // MIs[0] policy
     /* 1406620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1406633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406652 */     // GIR_Coverage, 20664,
     /* 1406652 */     GIR_EraseRootFromParent_Done,
     /* 1406653 */   // Label 19941: @1406653
     /* 1406653 */   GIM_Try, /*On fail goto*//*Label 19942*/ GIMT_Encode4(1406741), // Rule ID 20665 //
     /* 1406658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1406669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1406672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1406675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1406678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1406685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406697 */     // MIs[0] Operand 5
     /* 1406697 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406708 */     // MIs[0] policy
     /* 1406708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1406721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406740 */     // GIR_Coverage, 20665,
     /* 1406740 */     GIR_EraseRootFromParent_Done,
     /* 1406741 */   // Label 19942: @1406741
     /* 1406741 */   GIM_Try, /*On fail goto*//*Label 19943*/ GIMT_Encode4(1406829), // Rule ID 20668 //
     /* 1406746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1406757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1406760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1406763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1406766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1406773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1406777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1406781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406785 */     // MIs[0] Operand 5
     /* 1406785 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406796 */     // MIs[0] policy
     /* 1406796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406806 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1406809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406828 */     // GIR_Coverage, 20668,
     /* 1406828 */     GIR_EraseRootFromParent_Done,
     /* 1406829 */   // Label 19943: @1406829
     /* 1406829 */   GIM_Try, /*On fail goto*//*Label 19944*/ GIMT_Encode4(1406917), // Rule ID 20669 //
     /* 1406834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1406845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1406848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1406851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1406854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1406861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1406865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1406869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406873 */     // MIs[0] Operand 5
     /* 1406873 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406884 */     // MIs[0] policy
     /* 1406884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406894 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1406897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406916 */     // GIR_Coverage, 20669,
     /* 1406916 */     GIR_EraseRootFromParent_Done,
     /* 1406917 */   // Label 19944: @1406917
     /* 1406917 */   GIM_Try, /*On fail goto*//*Label 19945*/ GIMT_Encode4(1407005), // Rule ID 20672 //
     /* 1406922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1406933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1406936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1406939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1406942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1406949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1406953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1406957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406961 */     // MIs[0] Operand 5
     /* 1406961 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406972 */     // MIs[0] policy
     /* 1406972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406982 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1406985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407004 */     // GIR_Coverage, 20672,
     /* 1407004 */     GIR_EraseRootFromParent_Done,
     /* 1407005 */   // Label 19945: @1407005
     /* 1407005 */   GIM_Try, /*On fail goto*//*Label 19946*/ GIMT_Encode4(1407093), // Rule ID 20673 //
     /* 1407010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1407021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1407024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1407027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1407030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407049 */     // MIs[0] Operand 5
     /* 1407049 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407060 */     // MIs[0] policy
     /* 1407060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407070 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1407073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407092 */     // GIR_Coverage, 20673,
     /* 1407092 */     GIR_EraseRootFromParent_Done,
     /* 1407093 */   // Label 19946: @1407093
     /* 1407093 */   GIM_Try, /*On fail goto*//*Label 19947*/ GIMT_Encode4(1407181), // Rule ID 20676 //
     /* 1407098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1407109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1407112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407137 */     // MIs[0] Operand 5
     /* 1407137 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407148 */     // MIs[0] policy
     /* 1407148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407158 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407180 */     // GIR_Coverage, 20676,
     /* 1407180 */     GIR_EraseRootFromParent_Done,
     /* 1407181 */   // Label 19947: @1407181
     /* 1407181 */   GIM_Try, /*On fail goto*//*Label 19948*/ GIMT_Encode4(1407269), // Rule ID 20677 //
     /* 1407186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1407197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1407200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407225 */     // MIs[0] Operand 5
     /* 1407225 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407236 */     // MIs[0] policy
     /* 1407236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407268 */     // GIR_Coverage, 20677,
     /* 1407268 */     GIR_EraseRootFromParent_Done,
     /* 1407269 */   // Label 19948: @1407269
     /* 1407269 */   GIM_Try, /*On fail goto*//*Label 19949*/ GIMT_Encode4(1407357), // Rule ID 20680 //
     /* 1407274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1407285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1407288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407313 */     // MIs[0] Operand 5
     /* 1407313 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407324 */     // MIs[0] policy
     /* 1407324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407343 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407356 */     // GIR_Coverage, 20680,
     /* 1407356 */     GIR_EraseRootFromParent_Done,
     /* 1407357 */   // Label 19949: @1407357
     /* 1407357 */   GIM_Try, /*On fail goto*//*Label 19950*/ GIMT_Encode4(1407445), // Rule ID 20681 //
     /* 1407362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1407373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1407376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407401 */     // MIs[0] Operand 5
     /* 1407401 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407412 */     // MIs[0] policy
     /* 1407412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407444 */     // GIR_Coverage, 20681,
     /* 1407444 */     GIR_EraseRootFromParent_Done,
     /* 1407445 */   // Label 19950: @1407445
     /* 1407445 */   GIM_Try, /*On fail goto*//*Label 19951*/ GIMT_Encode4(1407533), // Rule ID 20684 //
     /* 1407450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1407461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1407464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1407467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407489 */     // MIs[0] Operand 5
     /* 1407489 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407500 */     // MIs[0] policy
     /* 1407500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407510 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1407513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407532 */     // GIR_Coverage, 20684,
     /* 1407532 */     GIR_EraseRootFromParent_Done,
     /* 1407533 */   // Label 19951: @1407533
     /* 1407533 */   GIM_Try, /*On fail goto*//*Label 19952*/ GIMT_Encode4(1407621), // Rule ID 20685 //
     /* 1407538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1407549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1407552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1407555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407577 */     // MIs[0] Operand 5
     /* 1407577 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407588 */     // MIs[0] policy
     /* 1407588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407598 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1407601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407620 */     // GIR_Coverage, 20685,
     /* 1407620 */     GIR_EraseRootFromParent_Done,
     /* 1407621 */   // Label 19952: @1407621
     /* 1407621 */   GIM_Try, /*On fail goto*//*Label 19953*/ GIMT_Encode4(1407709), // Rule ID 20688 //
     /* 1407626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1407629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1407637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1407640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1407643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1407646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407665 */     // MIs[0] Operand 5
     /* 1407665 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407676 */     // MIs[0] policy
     /* 1407676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407686 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407708 */     // GIR_Coverage, 20688,
     /* 1407708 */     GIR_EraseRootFromParent_Done,
     /* 1407709 */   // Label 19953: @1407709
     /* 1407709 */   GIM_Try, /*On fail goto*//*Label 19954*/ GIMT_Encode4(1407797), // Rule ID 20689 //
     /* 1407714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1407717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1407725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1407728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1407731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1407734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407753 */     // MIs[0] Operand 5
     /* 1407753 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407764 */     // MIs[0] policy
     /* 1407764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407774 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407796 */     // GIR_Coverage, 20689,
     /* 1407796 */     GIR_EraseRootFromParent_Done,
     /* 1407797 */   // Label 19954: @1407797
     /* 1407797 */   GIM_Try, /*On fail goto*//*Label 19955*/ GIMT_Encode4(1407885), // Rule ID 20692 //
     /* 1407802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1407805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1407813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1407816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1407819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407841 */     // MIs[0] Operand 5
     /* 1407841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407852 */     // MIs[0] policy
     /* 1407852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407862 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407884 */     // GIR_Coverage, 20692,
     /* 1407884 */     GIR_EraseRootFromParent_Done,
     /* 1407885 */   // Label 19955: @1407885
     /* 1407885 */   GIM_Try, /*On fail goto*//*Label 19956*/ GIMT_Encode4(1407973), // Rule ID 20693 //
     /* 1407890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1407893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1407901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1407904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1407907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407929 */     // MIs[0] Operand 5
     /* 1407929 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407940 */     // MIs[0] policy
     /* 1407940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407972 */     // GIR_Coverage, 20693,
     /* 1407972 */     GIR_EraseRootFromParent_Done,
     /* 1407973 */   // Label 19956: @1407973
     /* 1407973 */   GIM_Try, /*On fail goto*//*Label 19957*/ GIMT_Encode4(1408061), // Rule ID 20696 //
     /* 1407978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1407981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1407989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1407992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1407995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408017 */     // MIs[0] Operand 5
     /* 1408017 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408028 */     // MIs[0] policy
     /* 1408028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408038 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1408041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408060 */     // GIR_Coverage, 20696,
     /* 1408060 */     GIR_EraseRootFromParent_Done,
     /* 1408061 */   // Label 19957: @1408061
     /* 1408061 */   GIM_Try, /*On fail goto*//*Label 19958*/ GIMT_Encode4(1408149), // Rule ID 20697 //
     /* 1408066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1408069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1408077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1408080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1408083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1408086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408105 */     // MIs[0] Operand 5
     /* 1408105 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408116 */     // MIs[0] policy
     /* 1408116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408126 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1408129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408148 */     // GIR_Coverage, 20697,
     /* 1408148 */     GIR_EraseRootFromParent_Done,
     /* 1408149 */   // Label 19958: @1408149
     /* 1408149 */   GIM_Try, /*On fail goto*//*Label 19959*/ GIMT_Encode4(1408237), // Rule ID 20700 //
     /* 1408154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1408165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1408168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1408171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408193 */     // MIs[0] Operand 5
     /* 1408193 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408204 */     // MIs[0] policy
     /* 1408204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1408217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408236 */     // GIR_Coverage, 20700,
     /* 1408236 */     GIR_EraseRootFromParent_Done,
     /* 1408237 */   // Label 19959: @1408237
     /* 1408237 */   GIM_Try, /*On fail goto*//*Label 19960*/ GIMT_Encode4(1408325), // Rule ID 20701 //
     /* 1408242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1408253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1408256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1408259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408281 */     // MIs[0] Operand 5
     /* 1408281 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408292 */     // MIs[0] policy
     /* 1408292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408302 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1408305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408324 */     // GIR_Coverage, 20701,
     /* 1408324 */     GIR_EraseRootFromParent_Done,
     /* 1408325 */   // Label 19960: @1408325
     /* 1408325 */   GIM_Try, /*On fail goto*//*Label 19961*/ GIMT_Encode4(1408413), // Rule ID 20704 //
     /* 1408330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1408341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1408344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1408347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408369 */     // MIs[0] Operand 5
     /* 1408369 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408380 */     // MIs[0] policy
     /* 1408380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408390 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408412 */     // GIR_Coverage, 20704,
     /* 1408412 */     GIR_EraseRootFromParent_Done,
     /* 1408413 */   // Label 19961: @1408413
     /* 1408413 */   GIM_Try, /*On fail goto*//*Label 19962*/ GIMT_Encode4(1408501), // Rule ID 20705 //
     /* 1408418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1408429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1408432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1408435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408457 */     // MIs[0] Operand 5
     /* 1408457 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408468 */     // MIs[0] policy
     /* 1408468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408478 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408500 */     // GIR_Coverage, 20705,
     /* 1408500 */     GIR_EraseRootFromParent_Done,
     /* 1408501 */   // Label 19962: @1408501
     /* 1408501 */   GIM_Try, /*On fail goto*//*Label 19963*/ GIMT_Encode4(1408589), // Rule ID 20708 //
     /* 1408506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1408509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1408517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1408520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1408523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408545 */     // MIs[0] Operand 5
     /* 1408545 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408556 */     // MIs[0] policy
     /* 1408556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408566 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408588 */     // GIR_Coverage, 20708,
     /* 1408588 */     GIR_EraseRootFromParent_Done,
     /* 1408589 */   // Label 19963: @1408589
     /* 1408589 */   GIM_Try, /*On fail goto*//*Label 19964*/ GIMT_Encode4(1408677), // Rule ID 20709 //
     /* 1408594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1408597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1408605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1408608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1408611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408633 */     // MIs[0] Operand 5
     /* 1408633 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408644 */     // MIs[0] policy
     /* 1408644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408676 */     // GIR_Coverage, 20709,
     /* 1408676 */     GIR_EraseRootFromParent_Done,
     /* 1408677 */   // Label 19964: @1408677
     /* 1408677 */   GIM_Try, /*On fail goto*//*Label 19965*/ GIMT_Encode4(1408765), // Rule ID 20712 //
     /* 1408682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1408693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1408696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1408699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1408702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408721 */     // MIs[0] Operand 5
     /* 1408721 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408732 */     // MIs[0] policy
     /* 1408732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408742 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1408745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408764 */     // GIR_Coverage, 20712,
     /* 1408764 */     GIR_EraseRootFromParent_Done,
     /* 1408765 */   // Label 19965: @1408765
     /* 1408765 */   GIM_Try, /*On fail goto*//*Label 19966*/ GIMT_Encode4(1408853), // Rule ID 20713 //
     /* 1408770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1408781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1408784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1408787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1408790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408809 */     // MIs[0] Operand 5
     /* 1408809 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408820 */     // MIs[0] policy
     /* 1408820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408830 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1408833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408852 */     // GIR_Coverage, 20713,
     /* 1408852 */     GIR_EraseRootFromParent_Done,
     /* 1408853 */   // Label 19966: @1408853
     /* 1408853 */   GIM_Try, /*On fail goto*//*Label 19967*/ GIMT_Encode4(1408941), // Rule ID 20716 //
     /* 1408858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1408861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1408869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1408872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1408875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408897 */     // MIs[0] Operand 5
     /* 1408897 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408908 */     // MIs[0] policy
     /* 1408908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1408921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408940 */     // GIR_Coverage, 20716,
     /* 1408940 */     GIR_EraseRootFromParent_Done,
     /* 1408941 */   // Label 19967: @1408941
     /* 1408941 */   GIM_Try, /*On fail goto*//*Label 19968*/ GIMT_Encode4(1409029), // Rule ID 20717 //
     /* 1408946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1408949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1408957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1408960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1408963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408985 */     // MIs[0] Operand 5
     /* 1408985 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408996 */     // MIs[0] policy
     /* 1408996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409006 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409028 */     // GIR_Coverage, 20717,
     /* 1409028 */     GIR_EraseRootFromParent_Done,
     /* 1409029 */   // Label 19968: @1409029
     /* 1409029 */   GIM_Try, /*On fail goto*//*Label 19969*/ GIMT_Encode4(1409117), // Rule ID 20720 //
     /* 1409034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1409037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1409045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1409048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1409051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409073 */     // MIs[0] Operand 5
     /* 1409073 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409084 */     // MIs[0] policy
     /* 1409084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409116 */     // GIR_Coverage, 20720,
     /* 1409116 */     GIR_EraseRootFromParent_Done,
     /* 1409117 */   // Label 19969: @1409117
     /* 1409117 */   GIM_Try, /*On fail goto*//*Label 19970*/ GIMT_Encode4(1409205), // Rule ID 20721 //
     /* 1409122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1409125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1409133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1409136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1409139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409161 */     // MIs[0] Operand 5
     /* 1409161 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409172 */     // MIs[0] policy
     /* 1409172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409182 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409204 */     // GIR_Coverage, 20721,
     /* 1409204 */     GIR_EraseRootFromParent_Done,
     /* 1409205 */   // Label 19970: @1409205
     /* 1409205 */   GIM_Try, /*On fail goto*//*Label 19971*/ GIMT_Encode4(1409293), // Rule ID 20724 //
     /* 1409210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1409221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1409224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1409227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409249 */     // MIs[0] Operand 5
     /* 1409249 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409260 */     // MIs[0] policy
     /* 1409260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409270 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409292 */     // GIR_Coverage, 20724,
     /* 1409292 */     GIR_EraseRootFromParent_Done,
     /* 1409293 */   // Label 19971: @1409293
     /* 1409293 */   GIM_Try, /*On fail goto*//*Label 19972*/ GIMT_Encode4(1409381), // Rule ID 20725 //
     /* 1409298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1409309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1409312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1409315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409337 */     // MIs[0] Operand 5
     /* 1409337 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409348 */     // MIs[0] policy
     /* 1409348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409358 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409380 */     // GIR_Coverage, 20725,
     /* 1409380 */     GIR_EraseRootFromParent_Done,
     /* 1409381 */   // Label 19972: @1409381
     /* 1409381 */   GIM_Try, /*On fail goto*//*Label 19973*/ GIMT_Encode4(1409469), // Rule ID 20728 //
     /* 1409386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1409397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1409400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1409403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1409406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409425 */     // MIs[0] Operand 5
     /* 1409425 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409436 */     // MIs[0] policy
     /* 1409436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409446 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1409449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409468 */     // GIR_Coverage, 20728,
     /* 1409468 */     GIR_EraseRootFromParent_Done,
     /* 1409469 */   // Label 19973: @1409469
     /* 1409469 */   GIM_Try, /*On fail goto*//*Label 19974*/ GIMT_Encode4(1409557), // Rule ID 20729 //
     /* 1409474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1409485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1409488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1409491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1409494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409513 */     // MIs[0] Operand 5
     /* 1409513 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409524 */     // MIs[0] policy
     /* 1409524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409534 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1409537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409556 */     // GIR_Coverage, 20729,
     /* 1409556 */     GIR_EraseRootFromParent_Done,
     /* 1409557 */   // Label 19974: @1409557
     /* 1409557 */   GIM_Try, /*On fail goto*//*Label 19975*/ GIMT_Encode4(1409645), // Rule ID 20732 //
     /* 1409562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1409573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1409576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1409579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1409582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1409589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409601 */     // MIs[0] Operand 5
     /* 1409601 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409612 */     // MIs[0] policy
     /* 1409612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409622 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1409625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409644 */     // GIR_Coverage, 20732,
     /* 1409644 */     GIR_EraseRootFromParent_Done,
     /* 1409645 */   // Label 19975: @1409645
     /* 1409645 */   GIM_Try, /*On fail goto*//*Label 19976*/ GIMT_Encode4(1409733), // Rule ID 20733 //
     /* 1409650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1409661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1409664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1409667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1409670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1409677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409689 */     // MIs[0] Operand 5
     /* 1409689 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409700 */     // MIs[0] policy
     /* 1409700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409710 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1409713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409732 */     // GIR_Coverage, 20733,
     /* 1409732 */     GIR_EraseRootFromParent_Done,
     /* 1409733 */   // Label 19976: @1409733
     /* 1409733 */   GIM_Try, /*On fail goto*//*Label 19977*/ GIMT_Encode4(1409821), // Rule ID 20736 //
     /* 1409738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1409741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1409749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1409752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1409755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409777 */     // MIs[0] Operand 5
     /* 1409777 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409788 */     // MIs[0] policy
     /* 1409788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409820 */     // GIR_Coverage, 20736,
     /* 1409820 */     GIR_EraseRootFromParent_Done,
     /* 1409821 */   // Label 19977: @1409821
     /* 1409821 */   GIM_Try, /*On fail goto*//*Label 19978*/ GIMT_Encode4(1409909), // Rule ID 20737 //
     /* 1409826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1409829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1409837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1409840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1409843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409865 */     // MIs[0] Operand 5
     /* 1409865 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409876 */     // MIs[0] policy
     /* 1409876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409886 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409908 */     // GIR_Coverage, 20737,
     /* 1409908 */     GIR_EraseRootFromParent_Done,
     /* 1409909 */   // Label 19978: @1409909
     /* 1409909 */   GIM_Try, /*On fail goto*//*Label 19979*/ GIMT_Encode4(1409997), // Rule ID 20740 //
     /* 1409914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1409917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1409925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1409928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1409931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409953 */     // MIs[0] Operand 5
     /* 1409953 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409964 */     // MIs[0] policy
     /* 1409964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409974 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1409977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409996 */     // GIR_Coverage, 20740,
     /* 1409996 */     GIR_EraseRootFromParent_Done,
     /* 1409997 */   // Label 19979: @1409997
     /* 1409997 */   GIM_Try, /*On fail goto*//*Label 19980*/ GIMT_Encode4(1410085), // Rule ID 20741 //
     /* 1410002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1410005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1410013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1410016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1410019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410041 */     // MIs[0] Operand 5
     /* 1410041 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410052 */     // MIs[0] policy
     /* 1410052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410062 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410084 */     // GIR_Coverage, 20741,
     /* 1410084 */     GIR_EraseRootFromParent_Done,
     /* 1410085 */   // Label 19980: @1410085
     /* 1410085 */   GIM_Try, /*On fail goto*//*Label 19981*/ GIMT_Encode4(1410173), // Rule ID 20744 //
     /* 1410090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1410093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1410101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1410104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1410107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410129 */     // MIs[0] Operand 5
     /* 1410129 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410140 */     // MIs[0] policy
     /* 1410140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410150 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410172 */     // GIR_Coverage, 20744,
     /* 1410172 */     GIR_EraseRootFromParent_Done,
     /* 1410173 */   // Label 19981: @1410173
     /* 1410173 */   GIM_Try, /*On fail goto*//*Label 19982*/ GIMT_Encode4(1410261), // Rule ID 20745 //
     /* 1410178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1410181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1410189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1410192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1410195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410217 */     // MIs[0] Operand 5
     /* 1410217 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410228 */     // MIs[0] policy
     /* 1410228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410238 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410260 */     // GIR_Coverage, 20745,
     /* 1410260 */     GIR_EraseRootFromParent_Done,
     /* 1410261 */   // Label 19982: @1410261
     /* 1410261 */   GIM_Try, /*On fail goto*//*Label 19983*/ GIMT_Encode4(1410349), // Rule ID 20748 //
     /* 1410266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1410269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1410277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1410280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1410283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410305 */     // MIs[0] Operand 5
     /* 1410305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410316 */     // MIs[0] policy
     /* 1410316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1410329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410348 */     // GIR_Coverage, 20748,
     /* 1410348 */     GIR_EraseRootFromParent_Done,
     /* 1410349 */   // Label 19983: @1410349
     /* 1410349 */   GIM_Try, /*On fail goto*//*Label 19984*/ GIMT_Encode4(1410437), // Rule ID 20749 //
     /* 1410354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1410357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1410365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1410368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1410371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410393 */     // MIs[0] Operand 5
     /* 1410393 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410404 */     // MIs[0] policy
     /* 1410404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1410417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410436 */     // GIR_Coverage, 20749,
     /* 1410436 */     GIR_EraseRootFromParent_Done,
     /* 1410437 */   // Label 19984: @1410437
     /* 1410437 */   GIM_Try, /*On fail goto*//*Label 19985*/ GIMT_Encode4(1410525), // Rule ID 20752 //
     /* 1410442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1410445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1410453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1410456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1410459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410481 */     // MIs[0] Operand 5
     /* 1410481 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410492 */     // MIs[0] policy
     /* 1410492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410502 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410524 */     // GIR_Coverage, 20752,
     /* 1410524 */     GIR_EraseRootFromParent_Done,
     /* 1410525 */   // Label 19985: @1410525
     /* 1410525 */   GIM_Try, /*On fail goto*//*Label 19986*/ GIMT_Encode4(1410613), // Rule ID 20753 //
     /* 1410530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1410533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1410541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1410544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1410547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410569 */     // MIs[0] Operand 5
     /* 1410569 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410580 */     // MIs[0] policy
     /* 1410580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410590 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410612 */     // GIR_Coverage, 20753,
     /* 1410612 */     GIR_EraseRootFromParent_Done,
     /* 1410613 */   // Label 19986: @1410613
     /* 1410613 */   GIM_Try, /*On fail goto*//*Label 19987*/ GIMT_Encode4(1410701), // Rule ID 20756 //
     /* 1410618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1410621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1410629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1410632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1410635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410657 */     // MIs[0] Operand 5
     /* 1410657 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410668 */     // MIs[0] policy
     /* 1410668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410678 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410700 */     // GIR_Coverage, 20756,
     /* 1410700 */     GIR_EraseRootFromParent_Done,
     /* 1410701 */   // Label 19987: @1410701
     /* 1410701 */   GIM_Try, /*On fail goto*//*Label 19988*/ GIMT_Encode4(1410789), // Rule ID 20757 //
     /* 1410706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1410709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1410717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1410720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1410723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410745 */     // MIs[0] Operand 5
     /* 1410745 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410756 */     // MIs[0] policy
     /* 1410756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410766 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410788 */     // GIR_Coverage, 20757,
     /* 1410788 */     GIR_EraseRootFromParent_Done,
     /* 1410789 */   // Label 19988: @1410789
     /* 1410789 */   GIM_Try, /*On fail goto*//*Label 19989*/ GIMT_Encode4(1410877), // Rule ID 21116 //
     /* 1410794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1410802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1410805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1410808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1410811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1410814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410833 */     // MIs[0] Operand 5
     /* 1410833 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410844 */     // MIs[0] policy
     /* 1410844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410854 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1410857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410876 */     // GIR_Coverage, 21116,
     /* 1410876 */     GIR_EraseRootFromParent_Done,
     /* 1410877 */   // Label 19989: @1410877
     /* 1410877 */   GIM_Try, /*On fail goto*//*Label 19990*/ GIMT_Encode4(1410965), // Rule ID 21117 //
     /* 1410882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1410890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1410893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1410896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1410899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1410902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410921 */     // MIs[0] Operand 5
     /* 1410921 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410932 */     // MIs[0] policy
     /* 1410932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410942 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1410945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410964 */     // GIR_Coverage, 21117,
     /* 1410964 */     GIR_EraseRootFromParent_Done,
     /* 1410965 */   // Label 19990: @1410965
     /* 1410965 */   GIM_Try, /*On fail goto*//*Label 19991*/ GIMT_Encode4(1411053), // Rule ID 21120 //
     /* 1410970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1410978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1410981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1410984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1410987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411009 */     // MIs[0] Operand 5
     /* 1411009 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411020 */     // MIs[0] policy
     /* 1411020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1411033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411039 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411052 */     // GIR_Coverage, 21120,
     /* 1411052 */     GIR_EraseRootFromParent_Done,
     /* 1411053 */   // Label 19991: @1411053
     /* 1411053 */   GIM_Try, /*On fail goto*//*Label 19992*/ GIMT_Encode4(1411141), // Rule ID 21121 //
     /* 1411058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1411069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1411072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1411075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411097 */     // MIs[0] Operand 5
     /* 1411097 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411108 */     // MIs[0] policy
     /* 1411108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1411121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411140 */     // GIR_Coverage, 21121,
     /* 1411140 */     GIR_EraseRootFromParent_Done,
     /* 1411141 */   // Label 19992: @1411141
     /* 1411141 */   GIM_Try, /*On fail goto*//*Label 19993*/ GIMT_Encode4(1411229), // Rule ID 21124 //
     /* 1411146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1411157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1411160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1411163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411185 */     // MIs[0] Operand 5
     /* 1411185 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411196 */     // MIs[0] policy
     /* 1411196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1411209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411228 */     // GIR_Coverage, 21124,
     /* 1411228 */     GIR_EraseRootFromParent_Done,
     /* 1411229 */   // Label 19993: @1411229
     /* 1411229 */   GIM_Try, /*On fail goto*//*Label 19994*/ GIMT_Encode4(1411317), // Rule ID 21125 //
     /* 1411234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1411245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1411248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1411251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411273 */     // MIs[0] Operand 5
     /* 1411273 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411284 */     // MIs[0] policy
     /* 1411284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411294 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1411297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411316 */     // GIR_Coverage, 21125,
     /* 1411316 */     GIR_EraseRootFromParent_Done,
     /* 1411317 */   // Label 19994: @1411317
     /* 1411317 */   GIM_Try, /*On fail goto*//*Label 19995*/ GIMT_Encode4(1411405), // Rule ID 21128 //
     /* 1411322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1411333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1411336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1411339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411361 */     // MIs[0] Operand 5
     /* 1411361 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411372 */     // MIs[0] policy
     /* 1411372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411382 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1411385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411404 */     // GIR_Coverage, 21128,
     /* 1411404 */     GIR_EraseRootFromParent_Done,
     /* 1411405 */   // Label 19995: @1411405
     /* 1411405 */   GIM_Try, /*On fail goto*//*Label 19996*/ GIMT_Encode4(1411493), // Rule ID 21129 //
     /* 1411410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1411421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1411424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1411427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411449 */     // MIs[0] Operand 5
     /* 1411449 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411460 */     // MIs[0] policy
     /* 1411460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411470 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1411473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411492 */     // GIR_Coverage, 21129,
     /* 1411492 */     GIR_EraseRootFromParent_Done,
     /* 1411493 */   // Label 19996: @1411493
     /* 1411493 */   GIM_Try, /*On fail goto*//*Label 19997*/ GIMT_Encode4(1411581), // Rule ID 21132 //
     /* 1411498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1411509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1411512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1411515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1411518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411537 */     // MIs[0] Operand 5
     /* 1411537 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411548 */     // MIs[0] policy
     /* 1411548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411558 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1411561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411580 */     // GIR_Coverage, 21132,
     /* 1411580 */     GIR_EraseRootFromParent_Done,
     /* 1411581 */   // Label 19997: @1411581
     /* 1411581 */   GIM_Try, /*On fail goto*//*Label 19998*/ GIMT_Encode4(1411669), // Rule ID 21133 //
     /* 1411586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1411597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1411600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1411603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1411606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411625 */     // MIs[0] Operand 5
     /* 1411625 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411636 */     // MIs[0] policy
     /* 1411636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411646 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1411649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411668 */     // GIR_Coverage, 21133,
     /* 1411668 */     GIR_EraseRootFromParent_Done,
     /* 1411669 */   // Label 19998: @1411669
     /* 1411669 */   GIM_Try, /*On fail goto*//*Label 19999*/ GIMT_Encode4(1411757), // Rule ID 21136 //
     /* 1411674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1411677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1411685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1411688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1411691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411713 */     // MIs[0] Operand 5
     /* 1411713 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411724 */     // MIs[0] policy
     /* 1411724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411734 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1411737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411756 */     // GIR_Coverage, 21136,
     /* 1411756 */     GIR_EraseRootFromParent_Done,
     /* 1411757 */   // Label 19999: @1411757
     /* 1411757 */   GIM_Try, /*On fail goto*//*Label 20000*/ GIMT_Encode4(1411845), // Rule ID 21137 //
     /* 1411762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1411765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1411773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1411776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1411779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411801 */     // MIs[0] Operand 5
     /* 1411801 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411812 */     // MIs[0] policy
     /* 1411812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411822 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1411825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411844 */     // GIR_Coverage, 21137,
     /* 1411844 */     GIR_EraseRootFromParent_Done,
     /* 1411845 */   // Label 20000: @1411845
     /* 1411845 */   GIM_Try, /*On fail goto*//*Label 20001*/ GIMT_Encode4(1411933), // Rule ID 21140 //
     /* 1411850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1411853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1411861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1411864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1411867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411889 */     // MIs[0] Operand 5
     /* 1411889 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411900 */     // MIs[0] policy
     /* 1411900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411910 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1411913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411932 */     // GIR_Coverage, 21140,
     /* 1411932 */     GIR_EraseRootFromParent_Done,
     /* 1411933 */   // Label 20001: @1411933
     /* 1411933 */   GIM_Try, /*On fail goto*//*Label 20002*/ GIMT_Encode4(1412021), // Rule ID 21141 //
     /* 1411938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1411941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1411949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1411952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1411955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411977 */     // MIs[0] Operand 5
     /* 1411977 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411988 */     // MIs[0] policy
     /* 1411988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411998 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1412001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412020 */     // GIR_Coverage, 21141,
     /* 1412020 */     GIR_EraseRootFromParent_Done,
     /* 1412021 */   // Label 20002: @1412021
     /* 1412021 */   GIM_Try, /*On fail goto*//*Label 20003*/ GIMT_Encode4(1412109), // Rule ID 21144 //
     /* 1412026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1412029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1412037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1412040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1412043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412065 */     // MIs[0] Operand 5
     /* 1412065 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412076 */     // MIs[0] policy
     /* 1412076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412086 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1412089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412108 */     // GIR_Coverage, 21144,
     /* 1412108 */     GIR_EraseRootFromParent_Done,
     /* 1412109 */   // Label 20003: @1412109
     /* 1412109 */   GIM_Try, /*On fail goto*//*Label 20004*/ GIMT_Encode4(1412197), // Rule ID 21145 //
     /* 1412114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1412117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1412125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1412128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1412131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412153 */     // MIs[0] Operand 5
     /* 1412153 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412164 */     // MIs[0] policy
     /* 1412164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412174 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1412177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412196 */     // GIR_Coverage, 21145,
     /* 1412196 */     GIR_EraseRootFromParent_Done,
     /* 1412197 */   // Label 20004: @1412197
     /* 1412197 */   GIM_Try, /*On fail goto*//*Label 20005*/ GIMT_Encode4(1412285), // Rule ID 21148 //
     /* 1412202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1412205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1412213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1412216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1412219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1412229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412241 */     // MIs[0] Operand 5
     /* 1412241 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412252 */     // MIs[0] policy
     /* 1412252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412262 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1412265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412271 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412284 */     // GIR_Coverage, 21148,
     /* 1412284 */     GIR_EraseRootFromParent_Done,
     /* 1412285 */   // Label 20005: @1412285
     /* 1412285 */   GIM_Try, /*On fail goto*//*Label 20006*/ GIMT_Encode4(1412373), // Rule ID 21149 //
     /* 1412290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1412293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1412301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1412304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1412307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1412317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412329 */     // MIs[0] Operand 5
     /* 1412329 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412340 */     // MIs[0] policy
     /* 1412340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412350 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1412353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412372 */     // GIR_Coverage, 21149,
     /* 1412372 */     GIR_EraseRootFromParent_Done,
     /* 1412373 */   // Label 20006: @1412373
     /* 1412373 */   GIM_Try, /*On fail goto*//*Label 20007*/ GIMT_Encode4(1412461), // Rule ID 21152 //
     /* 1412378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1412389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1412392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1412395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412417 */     // MIs[0] Operand 5
     /* 1412417 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412428 */     // MIs[0] policy
     /* 1412428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412438 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1412441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412460 */     // GIR_Coverage, 21152,
     /* 1412460 */     GIR_EraseRootFromParent_Done,
     /* 1412461 */   // Label 20007: @1412461
     /* 1412461 */   GIM_Try, /*On fail goto*//*Label 20008*/ GIMT_Encode4(1412549), // Rule ID 21153 //
     /* 1412466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1412477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1412480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1412483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412505 */     // MIs[0] Operand 5
     /* 1412505 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412516 */     // MIs[0] policy
     /* 1412516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412526 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1412529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412548 */     // GIR_Coverage, 21153,
     /* 1412548 */     GIR_EraseRootFromParent_Done,
     /* 1412549 */   // Label 20008: @1412549
     /* 1412549 */   GIM_Try, /*On fail goto*//*Label 20009*/ GIMT_Encode4(1412637), // Rule ID 21156 //
     /* 1412554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1412565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1412568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1412571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412593 */     // MIs[0] Operand 5
     /* 1412593 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412604 */     // MIs[0] policy
     /* 1412604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412614 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1412617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412636 */     // GIR_Coverage, 21156,
     /* 1412636 */     GIR_EraseRootFromParent_Done,
     /* 1412637 */   // Label 20009: @1412637
     /* 1412637 */   GIM_Try, /*On fail goto*//*Label 20010*/ GIMT_Encode4(1412725), // Rule ID 21157 //
     /* 1412642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1412653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1412656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1412659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412681 */     // MIs[0] Operand 5
     /* 1412681 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412692 */     // MIs[0] policy
     /* 1412692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1412705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412724 */     // GIR_Coverage, 21157,
     /* 1412724 */     GIR_EraseRootFromParent_Done,
     /* 1412725 */   // Label 20010: @1412725
     /* 1412725 */   GIM_Try, /*On fail goto*//*Label 20011*/ GIMT_Encode4(1412813), // Rule ID 21160 //
     /* 1412730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1412741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1412744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1412747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1412757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412769 */     // MIs[0] Operand 5
     /* 1412769 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412780 */     // MIs[0] policy
     /* 1412780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1412793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412812 */     // GIR_Coverage, 21160,
     /* 1412812 */     GIR_EraseRootFromParent_Done,
     /* 1412813 */   // Label 20011: @1412813
     /* 1412813 */   GIM_Try, /*On fail goto*//*Label 20012*/ GIMT_Encode4(1412901), // Rule ID 21161 //
     /* 1412818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1412829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1412832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1412835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1412845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412857 */     // MIs[0] Operand 5
     /* 1412857 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412868 */     // MIs[0] policy
     /* 1412868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1412881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412887 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412900 */     // GIR_Coverage, 21161,
     /* 1412900 */     GIR_EraseRootFromParent_Done,
     /* 1412901 */   // Label 20012: @1412901
     /* 1412901 */   GIM_Try, /*On fail goto*//*Label 20013*/ GIMT_Encode4(1412989), // Rule ID 21164 //
     /* 1412906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1412917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1412920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1412923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412945 */     // MIs[0] Operand 5
     /* 1412945 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412956 */     // MIs[0] policy
     /* 1412956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412966 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1412969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412988 */     // GIR_Coverage, 21164,
     /* 1412988 */     GIR_EraseRootFromParent_Done,
     /* 1412989 */   // Label 20013: @1412989
     /* 1412989 */   GIM_Try, /*On fail goto*//*Label 20014*/ GIMT_Encode4(1413077), // Rule ID 21165 //
     /* 1412994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1413005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1413008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1413011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413033 */     // MIs[0] Operand 5
     /* 1413033 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413044 */     // MIs[0] policy
     /* 1413044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413054 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1413057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413076 */     // GIR_Coverage, 21165,
     /* 1413076 */     GIR_EraseRootFromParent_Done,
     /* 1413077 */   // Label 20014: @1413077
     /* 1413077 */   GIM_Try, /*On fail goto*//*Label 20015*/ GIMT_Encode4(1413165), // Rule ID 21168 //
     /* 1413082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1413093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1413096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1413099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1413102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413121 */     // MIs[0] Operand 5
     /* 1413121 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413132 */     // MIs[0] policy
     /* 1413132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413142 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1413145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413164 */     // GIR_Coverage, 21168,
     /* 1413164 */     GIR_EraseRootFromParent_Done,
     /* 1413165 */   // Label 20015: @1413165
     /* 1413165 */   GIM_Try, /*On fail goto*//*Label 20016*/ GIMT_Encode4(1413253), // Rule ID 21169 //
     /* 1413170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1413173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1413181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1413184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1413187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1413190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413209 */     // MIs[0] Operand 5
     /* 1413209 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413220 */     // MIs[0] policy
     /* 1413220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413230 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1413233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413252 */     // GIR_Coverage, 21169,
     /* 1413252 */     GIR_EraseRootFromParent_Done,
     /* 1413253 */   // Label 20016: @1413253
     /* 1413253 */   GIM_Try, /*On fail goto*//*Label 20017*/ GIMT_Encode4(1413341), // Rule ID 21172 //
     /* 1413258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1413261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1413269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1413272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1413275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1413278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413297 */     // MIs[0] Operand 5
     /* 1413297 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413308 */     // MIs[0] policy
     /* 1413308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413318 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1413321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413340 */     // GIR_Coverage, 21172,
     /* 1413340 */     GIR_EraseRootFromParent_Done,
     /* 1413341 */   // Label 20017: @1413341
     /* 1413341 */   GIM_Try, /*On fail goto*//*Label 20018*/ GIMT_Encode4(1413429), // Rule ID 21173 //
     /* 1413346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1413349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1413357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1413360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1413363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1413366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413385 */     // MIs[0] Operand 5
     /* 1413385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413396 */     // MIs[0] policy
     /* 1413396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413406 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1413409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413428 */     // GIR_Coverage, 21173,
     /* 1413428 */     GIR_EraseRootFromParent_Done,
     /* 1413429 */   // Label 20018: @1413429
     /* 1413429 */   GIM_Try, /*On fail goto*//*Label 20019*/ GIMT_Encode4(1413517), // Rule ID 21176 //
     /* 1413434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1413437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1413445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1413448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1413451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413473 */     // MIs[0] Operand 5
     /* 1413473 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413484 */     // MIs[0] policy
     /* 1413484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1413497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413516 */     // GIR_Coverage, 21176,
     /* 1413516 */     GIR_EraseRootFromParent_Done,
     /* 1413517 */   // Label 20019: @1413517
     /* 1413517 */   GIM_Try, /*On fail goto*//*Label 20020*/ GIMT_Encode4(1413605), // Rule ID 21177 //
     /* 1413522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1413525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1413533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1413536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1413539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413561 */     // MIs[0] Operand 5
     /* 1413561 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413572 */     // MIs[0] policy
     /* 1413572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413582 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1413585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413604 */     // GIR_Coverage, 21177,
     /* 1413604 */     GIR_EraseRootFromParent_Done,
     /* 1413605 */   // Label 20020: @1413605
     /* 1413605 */   GIM_Try, /*On fail goto*//*Label 20021*/ GIMT_Encode4(1413693), // Rule ID 21180 //
     /* 1413610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1413613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1413621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1413624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1413627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1413630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413649 */     // MIs[0] Operand 5
     /* 1413649 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413660 */     // MIs[0] policy
     /* 1413660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413670 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1413673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413692 */     // GIR_Coverage, 21180,
     /* 1413692 */     GIR_EraseRootFromParent_Done,
     /* 1413693 */   // Label 20021: @1413693
     /* 1413693 */   GIM_Try, /*On fail goto*//*Label 20022*/ GIMT_Encode4(1413781), // Rule ID 21181 //
     /* 1413698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1413701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1413709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1413712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1413715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1413718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413737 */     // MIs[0] Operand 5
     /* 1413737 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413748 */     // MIs[0] policy
     /* 1413748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413758 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1413761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413780 */     // GIR_Coverage, 21181,
     /* 1413780 */     GIR_EraseRootFromParent_Done,
     /* 1413781 */   // Label 20022: @1413781
     /* 1413781 */   GIM_Try, /*On fail goto*//*Label 20023*/ GIMT_Encode4(1413869), // Rule ID 21184 //
     /* 1413786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1413789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1413797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1413800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1413803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413825 */     // MIs[0] Operand 5
     /* 1413825 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413836 */     // MIs[0] policy
     /* 1413836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1413849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413868 */     // GIR_Coverage, 21184,
     /* 1413868 */     GIR_EraseRootFromParent_Done,
     /* 1413869 */   // Label 20023: @1413869
     /* 1413869 */   GIM_Try, /*On fail goto*//*Label 20024*/ GIMT_Encode4(1413957), // Rule ID 21185 //
     /* 1413874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1413877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1413885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1413888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1413891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413913 */     // MIs[0] Operand 5
     /* 1413913 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413924 */     // MIs[0] policy
     /* 1413924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413934 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1413937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413956 */     // GIR_Coverage, 21185,
     /* 1413956 */     GIR_EraseRootFromParent_Done,
     /* 1413957 */   // Label 20024: @1413957
     /* 1413957 */   GIM_Try, /*On fail goto*//*Label 20025*/ GIMT_Encode4(1414045), // Rule ID 21488 //
     /* 1413962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1413970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1413973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1413976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1413979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1413982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414001 */     // MIs[0] Operand 5
     /* 1414001 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414012 */     // MIs[0] policy
     /* 1414012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414022 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1414025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414044 */     // GIR_Coverage, 21488,
     /* 1414044 */     GIR_EraseRootFromParent_Done,
     /* 1414045 */   // Label 20025: @1414045
     /* 1414045 */   GIM_Try, /*On fail goto*//*Label 20026*/ GIMT_Encode4(1414133), // Rule ID 21489 //
     /* 1414050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1414061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1414064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1414067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1414070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414089 */     // MIs[0] Operand 5
     /* 1414089 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414100 */     // MIs[0] policy
     /* 1414100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414110 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1414113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414132 */     // GIR_Coverage, 21489,
     /* 1414132 */     GIR_EraseRootFromParent_Done,
     /* 1414133 */   // Label 20026: @1414133
     /* 1414133 */   GIM_Try, /*On fail goto*//*Label 20027*/ GIMT_Encode4(1414221), // Rule ID 21492 //
     /* 1414138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1414149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1414152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1414155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414177 */     // MIs[0] Operand 5
     /* 1414177 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414188 */     // MIs[0] policy
     /* 1414188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414198 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1414201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414220 */     // GIR_Coverage, 21492,
     /* 1414220 */     GIR_EraseRootFromParent_Done,
     /* 1414221 */   // Label 20027: @1414221
     /* 1414221 */   GIM_Try, /*On fail goto*//*Label 20028*/ GIMT_Encode4(1414309), // Rule ID 21493 //
     /* 1414226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1414237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1414240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1414243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414265 */     // MIs[0] Operand 5
     /* 1414265 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414276 */     // MIs[0] policy
     /* 1414276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414286 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1414289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414308 */     // GIR_Coverage, 21493,
     /* 1414308 */     GIR_EraseRootFromParent_Done,
     /* 1414309 */   // Label 20028: @1414309
     /* 1414309 */   GIM_Try, /*On fail goto*//*Label 20029*/ GIMT_Encode4(1414397), // Rule ID 21496 //
     /* 1414314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1414325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1414328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1414331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414353 */     // MIs[0] Operand 5
     /* 1414353 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414364 */     // MIs[0] policy
     /* 1414364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414374 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1414377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414396 */     // GIR_Coverage, 21496,
     /* 1414396 */     GIR_EraseRootFromParent_Done,
     /* 1414397 */   // Label 20029: @1414397
     /* 1414397 */   GIM_Try, /*On fail goto*//*Label 20030*/ GIMT_Encode4(1414485), // Rule ID 21497 //
     /* 1414402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1414413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1414416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1414419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414441 */     // MIs[0] Operand 5
     /* 1414441 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414452 */     // MIs[0] policy
     /* 1414452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414462 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1414465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414484 */     // GIR_Coverage, 21497,
     /* 1414484 */     GIR_EraseRootFromParent_Done,
     /* 1414485 */   // Label 20030: @1414485
     /* 1414485 */   GIM_Try, /*On fail goto*//*Label 20031*/ GIMT_Encode4(1414573), // Rule ID 21500 //
     /* 1414490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1414501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1414504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1414507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414529 */     // MIs[0] Operand 5
     /* 1414529 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414540 */     // MIs[0] policy
     /* 1414540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414550 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1414553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414572 */     // GIR_Coverage, 21500,
     /* 1414572 */     GIR_EraseRootFromParent_Done,
     /* 1414573 */   // Label 20031: @1414573
     /* 1414573 */   GIM_Try, /*On fail goto*//*Label 20032*/ GIMT_Encode4(1414661), // Rule ID 21501 //
     /* 1414578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1414589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1414592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1414595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414617 */     // MIs[0] Operand 5
     /* 1414617 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414628 */     // MIs[0] policy
     /* 1414628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414638 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1414641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414647 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414660 */     // GIR_Coverage, 21501,
     /* 1414660 */     GIR_EraseRootFromParent_Done,
     /* 1414661 */   // Label 20032: @1414661
     /* 1414661 */   GIM_Try, /*On fail goto*//*Label 20033*/ GIMT_Encode4(1414749), // Rule ID 21504 //
     /* 1414666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1414677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1414680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1414683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1414686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1414693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414705 */     // MIs[0] Operand 5
     /* 1414705 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414716 */     // MIs[0] policy
     /* 1414716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414726 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1414729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414748 */     // GIR_Coverage, 21504,
     /* 1414748 */     GIR_EraseRootFromParent_Done,
     /* 1414749 */   // Label 20033: @1414749
     /* 1414749 */   GIM_Try, /*On fail goto*//*Label 20034*/ GIMT_Encode4(1414837), // Rule ID 21505 //
     /* 1414754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1414765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1414768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1414771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1414774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1414781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414793 */     // MIs[0] Operand 5
     /* 1414793 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414804 */     // MIs[0] policy
     /* 1414804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414814 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1414817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414836 */     // GIR_Coverage, 21505,
     /* 1414836 */     GIR_EraseRootFromParent_Done,
     /* 1414837 */   // Label 20034: @1414837
     /* 1414837 */   GIM_Try, /*On fail goto*//*Label 20035*/ GIMT_Encode4(1414925), // Rule ID 21508 //
     /* 1414842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1414853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1414856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1414859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1414862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414881 */     // MIs[0] Operand 5
     /* 1414881 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414892 */     // MIs[0] policy
     /* 1414892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414902 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1414905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414924 */     // GIR_Coverage, 21508,
     /* 1414924 */     GIR_EraseRootFromParent_Done,
     /* 1414925 */   // Label 20035: @1414925
     /* 1414925 */   GIM_Try, /*On fail goto*//*Label 20036*/ GIMT_Encode4(1415013), // Rule ID 21509 //
     /* 1414930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1414941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1414944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1414947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1414950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414969 */     // MIs[0] Operand 5
     /* 1414969 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414980 */     // MIs[0] policy
     /* 1414980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414990 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1414993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415012 */     // GIR_Coverage, 21509,
     /* 1415012 */     GIR_EraseRootFromParent_Done,
     /* 1415013 */   // Label 20036: @1415013
     /* 1415013 */   GIM_Try, /*On fail goto*//*Label 20037*/ GIMT_Encode4(1415101), // Rule ID 21512 //
     /* 1415018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1415029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1415032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1415035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415057 */     // MIs[0] Operand 5
     /* 1415057 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415068 */     // MIs[0] policy
     /* 1415068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415078 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1415081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415100 */     // GIR_Coverage, 21512,
     /* 1415100 */     GIR_EraseRootFromParent_Done,
     /* 1415101 */   // Label 20037: @1415101
     /* 1415101 */   GIM_Try, /*On fail goto*//*Label 20038*/ GIMT_Encode4(1415189), // Rule ID 21513 //
     /* 1415106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1415117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1415120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1415123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415145 */     // MIs[0] Operand 5
     /* 1415145 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415156 */     // MIs[0] policy
     /* 1415156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415166 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1415169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415188 */     // GIR_Coverage, 21513,
     /* 1415188 */     GIR_EraseRootFromParent_Done,
     /* 1415189 */   // Label 20038: @1415189
     /* 1415189 */   GIM_Try, /*On fail goto*//*Label 20039*/ GIMT_Encode4(1415277), // Rule ID 21516 //
     /* 1415194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1415205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1415208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1415211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1415214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415233 */     // MIs[0] Operand 5
     /* 1415233 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415244 */     // MIs[0] policy
     /* 1415244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415254 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1415257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415276 */     // GIR_Coverage, 21516,
     /* 1415276 */     GIR_EraseRootFromParent_Done,
     /* 1415277 */   // Label 20039: @1415277
     /* 1415277 */   GIM_Try, /*On fail goto*//*Label 20040*/ GIMT_Encode4(1415365), // Rule ID 21517 //
     /* 1415282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1415293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1415296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1415299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1415302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415321 */     // MIs[0] Operand 5
     /* 1415321 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415332 */     // MIs[0] policy
     /* 1415332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415342 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1415345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415364 */     // GIR_Coverage, 21517,
     /* 1415364 */     GIR_EraseRootFromParent_Done,
     /* 1415365 */   // Label 20040: @1415365
     /* 1415365 */   GIM_Try, /*On fail goto*//*Label 20041*/ GIMT_Encode4(1415453), // Rule ID 21520 //
     /* 1415370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1415381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1415384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1415390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415409 */     // MIs[0] Operand 5
     /* 1415409 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415420 */     // MIs[0] policy
     /* 1415420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415430 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1415433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415452 */     // GIR_Coverage, 21520,
     /* 1415452 */     GIR_EraseRootFromParent_Done,
     /* 1415453 */   // Label 20041: @1415453
     /* 1415453 */   GIM_Try, /*On fail goto*//*Label 20042*/ GIMT_Encode4(1415541), // Rule ID 21521 //
     /* 1415458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1415469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1415472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1415478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415497 */     // MIs[0] Operand 5
     /* 1415497 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415508 */     // MIs[0] policy
     /* 1415508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1415521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415540 */     // GIR_Coverage, 21521,
     /* 1415540 */     GIR_EraseRootFromParent_Done,
     /* 1415541 */   // Label 20042: @1415541
     /* 1415541 */   GIM_Try, /*On fail goto*//*Label 20043*/ GIMT_Encode4(1415629), // Rule ID 21524 //
     /* 1415546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1415557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1415560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1415563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1415566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415585 */     // MIs[0] Operand 5
     /* 1415585 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415596 */     // MIs[0] policy
     /* 1415596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415606 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1415609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415628 */     // GIR_Coverage, 21524,
     /* 1415628 */     GIR_EraseRootFromParent_Done,
     /* 1415629 */   // Label 20043: @1415629
     /* 1415629 */   GIM_Try, /*On fail goto*//*Label 20044*/ GIMT_Encode4(1415717), // Rule ID 21525 //
     /* 1415634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1415645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1415648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1415651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1415654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415673 */     // MIs[0] Operand 5
     /* 1415673 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415684 */     // MIs[0] policy
     /* 1415684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1415697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415716 */     // GIR_Coverage, 21525,
     /* 1415716 */     GIR_EraseRootFromParent_Done,
     /* 1415717 */   // Label 20044: @1415717
     /* 1415717 */   GIM_Try, /*On fail goto*//*Label 20045*/ GIMT_Encode4(1415805), // Rule ID 21528 //
     /* 1415722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1415733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1415736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1415739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1415742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415761 */     // MIs[0] Operand 5
     /* 1415761 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415772 */     // MIs[0] policy
     /* 1415772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415782 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1415785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415804 */     // GIR_Coverage, 21528,
     /* 1415804 */     GIR_EraseRootFromParent_Done,
     /* 1415805 */   // Label 20045: @1415805
     /* 1415805 */   GIM_Try, /*On fail goto*//*Label 20046*/ GIMT_Encode4(1415893), // Rule ID 21529 //
     /* 1415810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1415821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1415824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1415827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1415830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415849 */     // MIs[0] Operand 5
     /* 1415849 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415860 */     // MIs[0] policy
     /* 1415860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415870 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1415873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415892 */     // GIR_Coverage, 21529,
     /* 1415892 */     GIR_EraseRootFromParent_Done,
     /* 1415893 */   // Label 20046: @1415893
     /* 1415893 */   GIM_Try, /*On fail goto*//*Label 20047*/ GIMT_Encode4(1415981), // Rule ID 21532 //
     /* 1415898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1415901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1415909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1415912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1415915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415937 */     // MIs[0] Operand 5
     /* 1415937 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415948 */     // MIs[0] policy
     /* 1415948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415958 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1415961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1415977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415980 */     // GIR_Coverage, 21532,
     /* 1415980 */     GIR_EraseRootFromParent_Done,
     /* 1415981 */   // Label 20047: @1415981
     /* 1415981 */   GIM_Try, /*On fail goto*//*Label 20048*/ GIMT_Encode4(1416069), // Rule ID 21533 //
     /* 1415986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1415989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1415997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1416000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1416003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1416006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416025 */     // MIs[0] Operand 5
     /* 1416025 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416036 */     // MIs[0] policy
     /* 1416036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1416049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416068 */     // GIR_Coverage, 21533,
     /* 1416068 */     GIR_EraseRootFromParent_Done,
     /* 1416069 */   // Label 20048: @1416069
     /* 1416069 */   GIM_Try, /*On fail goto*//*Label 20049*/ GIMT_Encode4(1416157), // Rule ID 21536 //
     /* 1416074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1416091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416113 */     // MIs[0] Operand 5
     /* 1416113 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416124 */     // MIs[0] policy
     /* 1416124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416134 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1416137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416156 */     // GIR_Coverage, 21536,
     /* 1416156 */     GIR_EraseRootFromParent_Done,
     /* 1416157 */   // Label 20049: @1416157
     /* 1416157 */   GIM_Try, /*On fail goto*//*Label 20050*/ GIMT_Encode4(1416245), // Rule ID 21537 //
     /* 1416162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1416179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416201 */     // MIs[0] Operand 5
     /* 1416201 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416212 */     // MIs[0] policy
     /* 1416212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416222 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1416225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416244 */     // GIR_Coverage, 21537,
     /* 1416244 */     GIR_EraseRootFromParent_Done,
     /* 1416245 */   // Label 20050: @1416245
     /* 1416245 */   GIM_Try, /*On fail goto*//*Label 20051*/ GIMT_Encode4(1416333), // Rule ID 21540 //
     /* 1416250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1416261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1416264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1416267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416289 */     // MIs[0] Operand 5
     /* 1416289 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416300 */     // MIs[0] policy
     /* 1416300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416310 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1416313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416332 */     // GIR_Coverage, 21540,
     /* 1416332 */     GIR_EraseRootFromParent_Done,
     /* 1416333 */   // Label 20051: @1416333
     /* 1416333 */   GIM_Try, /*On fail goto*//*Label 20052*/ GIMT_Encode4(1416421), // Rule ID 21541 //
     /* 1416338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1416349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1416352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1416355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416377 */     // MIs[0] Operand 5
     /* 1416377 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416388 */     // MIs[0] policy
     /* 1416388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416398 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1416401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416420 */     // GIR_Coverage, 21541,
     /* 1416420 */     GIR_EraseRootFromParent_Done,
     /* 1416421 */   // Label 20052: @1416421
     /* 1416421 */   GIM_Try, /*On fail goto*//*Label 20053*/ GIMT_Encode4(1416509), // Rule ID 21544 //
     /* 1416426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1416443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416465 */     // MIs[0] Operand 5
     /* 1416465 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416476 */     // MIs[0] policy
     /* 1416476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416486 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1416489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416495 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416508 */     // GIR_Coverage, 21544,
     /* 1416508 */     GIR_EraseRootFromParent_Done,
     /* 1416509 */   // Label 20053: @1416509
     /* 1416509 */   GIM_Try, /*On fail goto*//*Label 20054*/ GIMT_Encode4(1416597), // Rule ID 21545 //
     /* 1416514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1416531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416553 */     // MIs[0] Operand 5
     /* 1416553 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416564 */     // MIs[0] policy
     /* 1416564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1416577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416596 */     // GIR_Coverage, 21545,
     /* 1416596 */     GIR_EraseRootFromParent_Done,
     /* 1416597 */   // Label 20054: @1416597
     /* 1416597 */   GIM_Try, /*On fail goto*//*Label 20055*/ GIMT_Encode4(1416685), // Rule ID 21548 //
     /* 1416602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1416605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1416613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1416616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1416619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1416622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416641 */     // MIs[0] Operand 5
     /* 1416641 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416652 */     // MIs[0] policy
     /* 1416652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416662 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1416665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1416681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416684 */     // GIR_Coverage, 21548,
     /* 1416684 */     GIR_EraseRootFromParent_Done,
     /* 1416685 */   // Label 20055: @1416685
     /* 1416685 */   GIM_Try, /*On fail goto*//*Label 20056*/ GIMT_Encode4(1416773), // Rule ID 21549 //
     /* 1416690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1416693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1416701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1416704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1416707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1416710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416729 */     // MIs[0] Operand 5
     /* 1416729 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416740 */     // MIs[0] policy
     /* 1416740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416750 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1416753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1416769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416772 */     // GIR_Coverage, 21549,
     /* 1416772 */     GIR_EraseRootFromParent_Done,
     /* 1416773 */   // Label 20056: @1416773
     /* 1416773 */   GIM_Try, /*On fail goto*//*Label 20057*/ GIMT_Encode4(1416861), // Rule ID 21552 //
     /* 1416778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1416781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1416789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1416792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1416795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416817 */     // MIs[0] Operand 5
     /* 1416817 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416828 */     // MIs[0] policy
     /* 1416828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416838 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1416841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1416857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416860 */     // GIR_Coverage, 21552,
     /* 1416860 */     GIR_EraseRootFromParent_Done,
     /* 1416861 */   // Label 20057: @1416861
     /* 1416861 */   GIM_Try, /*On fail goto*//*Label 20058*/ GIMT_Encode4(1416949), // Rule ID 21553 //
     /* 1416866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1416869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1416877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1416880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1416883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416905 */     // MIs[0] Operand 5
     /* 1416905 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416916 */     // MIs[0] policy
     /* 1416916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416926 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1416929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1416945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416948 */     // GIR_Coverage, 21553,
     /* 1416948 */     GIR_EraseRootFromParent_Done,
     /* 1416949 */   // Label 20058: @1416949
     /* 1416949 */   GIM_Try, /*On fail goto*//*Label 20059*/ GIMT_Encode4(1417037), // Rule ID 21556 //
     /* 1416954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1416957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1416965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1416968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1416971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416993 */     // MIs[0] Operand 5
     /* 1416993 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417004 */     // MIs[0] policy
     /* 1417004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417014 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1417017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417036 */     // GIR_Coverage, 21556,
     /* 1417036 */     GIR_EraseRootFromParent_Done,
     /* 1417037 */   // Label 20059: @1417037
     /* 1417037 */   GIM_Try, /*On fail goto*//*Label 20060*/ GIMT_Encode4(1417125), // Rule ID 21557 //
     /* 1417042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1417053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1417056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1417059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1417062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417081 */     // MIs[0] Operand 5
     /* 1417081 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417092 */     // MIs[0] policy
     /* 1417092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417102 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1417105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417124 */     // GIR_Coverage, 21557,
     /* 1417124 */     GIR_EraseRootFromParent_Done,
     /* 1417125 */   // Label 20060: @1417125
     /* 1417125 */   GIM_Try, /*On fail goto*//*Label 20061*/ GIMT_Encode4(1417213), // Rule ID 21560 //
     /* 1417130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1417141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1417144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1417147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1417150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417169 */     // MIs[0] Operand 5
     /* 1417169 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417180 */     // MIs[0] policy
     /* 1417180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417190 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1417193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417212 */     // GIR_Coverage, 21560,
     /* 1417212 */     GIR_EraseRootFromParent_Done,
     /* 1417213 */   // Label 20061: @1417213
     /* 1417213 */   GIM_Try, /*On fail goto*//*Label 20062*/ GIMT_Encode4(1417301), // Rule ID 21561 //
     /* 1417218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1417229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1417232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1417235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1417238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417257 */     // MIs[0] Operand 5
     /* 1417257 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417268 */     // MIs[0] policy
     /* 1417268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417278 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1417281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417300 */     // GIR_Coverage, 21561,
     /* 1417300 */     GIR_EraseRootFromParent_Done,
     /* 1417301 */   // Label 20062: @1417301
     /* 1417301 */   GIM_Try, /*On fail goto*//*Label 20063*/ GIMT_Encode4(1417389), // Rule ID 21564 //
     /* 1417306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1417317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1417320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1417323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1417326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1417333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417345 */     // MIs[0] Operand 5
     /* 1417345 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417356 */     // MIs[0] policy
     /* 1417356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417366 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1417369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417388 */     // GIR_Coverage, 21564,
     /* 1417388 */     GIR_EraseRootFromParent_Done,
     /* 1417389 */   // Label 20063: @1417389
     /* 1417389 */   GIM_Try, /*On fail goto*//*Label 20064*/ GIMT_Encode4(1417477), // Rule ID 21565 //
     /* 1417394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1417405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1417408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1417411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1417414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1417421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417433 */     // MIs[0] Operand 5
     /* 1417433 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417444 */     // MIs[0] policy
     /* 1417444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417454 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1417457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417476 */     // GIR_Coverage, 21565,
     /* 1417476 */     GIR_EraseRootFromParent_Done,
     /* 1417477 */   // Label 20064: @1417477
     /* 1417477 */   GIM_Try, /*On fail goto*//*Label 20065*/ GIMT_Encode4(1417565), // Rule ID 21568 //
     /* 1417482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1417493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1417496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1417499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1417502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1417509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417521 */     // MIs[0] Operand 5
     /* 1417521 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417532 */     // MIs[0] policy
     /* 1417532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417542 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1417545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417564 */     // GIR_Coverage, 21568,
     /* 1417564 */     GIR_EraseRootFromParent_Done,
     /* 1417565 */   // Label 20065: @1417565
     /* 1417565 */   GIM_Try, /*On fail goto*//*Label 20066*/ GIMT_Encode4(1417653), // Rule ID 21569 //
     /* 1417570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1417581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1417584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1417587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1417590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1417597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417609 */     // MIs[0] Operand 5
     /* 1417609 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417620 */     // MIs[0] policy
     /* 1417620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417630 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1417633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417652 */     // GIR_Coverage, 21569,
     /* 1417652 */     GIR_EraseRootFromParent_Done,
     /* 1417653 */   // Label 20066: @1417653
     /* 1417653 */   GIM_Try, /*On fail goto*//*Label 20067*/ GIMT_Encode4(1417741), // Rule ID 21572 //
     /* 1417658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1417661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1417669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1417672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1417675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1417678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417697 */     // MIs[0] Operand 5
     /* 1417697 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417708 */     // MIs[0] policy
     /* 1417708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417718 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1417721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417740 */     // GIR_Coverage, 21572,
     /* 1417740 */     GIR_EraseRootFromParent_Done,
     /* 1417741 */   // Label 20067: @1417741
     /* 1417741 */   GIM_Try, /*On fail goto*//*Label 20068*/ GIMT_Encode4(1417829), // Rule ID 21573 //
     /* 1417746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1417749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1417757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1417760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1417763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1417766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417785 */     // MIs[0] Operand 5
     /* 1417785 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417796 */     // MIs[0] policy
     /* 1417796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417806 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1417809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417828 */     // GIR_Coverage, 21573,
     /* 1417828 */     GIR_EraseRootFromParent_Done,
     /* 1417829 */   // Label 20068: @1417829
     /* 1417829 */   GIM_Try, /*On fail goto*//*Label 20069*/ GIMT_Encode4(1417917), // Rule ID 21576 //
     /* 1417834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1417837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1417845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1417848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1417851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1417854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417873 */     // MIs[0] Operand 5
     /* 1417873 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417884 */     // MIs[0] policy
     /* 1417884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417894 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1417897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417916 */     // GIR_Coverage, 21576,
     /* 1417916 */     GIR_EraseRootFromParent_Done,
     /* 1417917 */   // Label 20069: @1417917
     /* 1417917 */   GIM_Try, /*On fail goto*//*Label 20070*/ GIMT_Encode4(1418005), // Rule ID 21577 //
     /* 1417922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1417925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1417933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1417936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1417939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1417942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417961 */     // MIs[0] Operand 5
     /* 1417961 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417972 */     // MIs[0] policy
     /* 1417972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417982 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1417985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418004 */     // GIR_Coverage, 21577,
     /* 1418004 */     GIR_EraseRootFromParent_Done,
     /* 1418005 */   // Label 20070: @1418005
     /* 1418005 */   GIM_Try, /*On fail goto*//*Label 20071*/ GIMT_Encode4(1418093), // Rule ID 21580 //
     /* 1418010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1418027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418049 */     // MIs[0] Operand 5
     /* 1418049 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418060 */     // MIs[0] policy
     /* 1418060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418070 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1418073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418092 */     // GIR_Coverage, 21580,
     /* 1418092 */     GIR_EraseRootFromParent_Done,
     /* 1418093 */   // Label 20071: @1418093
     /* 1418093 */   GIM_Try, /*On fail goto*//*Label 20072*/ GIMT_Encode4(1418181), // Rule ID 21581 //
     /* 1418098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1418115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418137 */     // MIs[0] Operand 5
     /* 1418137 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418148 */     // MIs[0] policy
     /* 1418148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1418161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418180 */     // GIR_Coverage, 21581,
     /* 1418180 */     GIR_EraseRootFromParent_Done,
     /* 1418181 */   // Label 20072: @1418181
     /* 1418181 */   GIM_Try, /*On fail goto*//*Label 20073*/ GIMT_Encode4(1418269), // Rule ID 21584 //
     /* 1418186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1418197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1418200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1418203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1418206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418225 */     // MIs[0] Operand 5
     /* 1418225 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418236 */     // MIs[0] policy
     /* 1418236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1418249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418268 */     // GIR_Coverage, 21584,
     /* 1418268 */     GIR_EraseRootFromParent_Done,
     /* 1418269 */   // Label 20073: @1418269
     /* 1418269 */   GIM_Try, /*On fail goto*//*Label 20074*/ GIMT_Encode4(1418357), // Rule ID 21585 //
     /* 1418274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1418285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1418288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1418291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1418294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418313 */     // MIs[0] Operand 5
     /* 1418313 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418324 */     // MIs[0] policy
     /* 1418324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1418337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418343 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418356 */     // GIR_Coverage, 21585,
     /* 1418356 */     GIR_EraseRootFromParent_Done,
     /* 1418357 */   // Label 20074: @1418357
     /* 1418357 */   GIM_Try, /*On fail goto*//*Label 20075*/ GIMT_Encode4(1418445), // Rule ID 21588 //
     /* 1418362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1418373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1418376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1418379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1418382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1418389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418401 */     // MIs[0] Operand 5
     /* 1418401 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418412 */     // MIs[0] policy
     /* 1418412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418422 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1418425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418444 */     // GIR_Coverage, 21588,
     /* 1418444 */     GIR_EraseRootFromParent_Done,
     /* 1418445 */   // Label 20075: @1418445
     /* 1418445 */   GIM_Try, /*On fail goto*//*Label 20076*/ GIMT_Encode4(1418533), // Rule ID 21589 //
     /* 1418450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1418461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1418464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1418467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1418470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1418477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418489 */     // MIs[0] Operand 5
     /* 1418489 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418500 */     // MIs[0] policy
     /* 1418500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418510 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1418513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418532 */     // GIR_Coverage, 21589,
     /* 1418532 */     GIR_EraseRootFromParent_Done,
     /* 1418533 */   // Label 20076: @1418533
     /* 1418533 */   GIM_Try, /*On fail goto*//*Label 20077*/ GIMT_Encode4(1418621), // Rule ID 21592 //
     /* 1418538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1418541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1418549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1418552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1418555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1418558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418577 */     // MIs[0] Operand 5
     /* 1418577 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418588 */     // MIs[0] policy
     /* 1418588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418598 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1418601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418620 */     // GIR_Coverage, 21592,
     /* 1418620 */     GIR_EraseRootFromParent_Done,
     /* 1418621 */   // Label 20077: @1418621
     /* 1418621 */   GIM_Try, /*On fail goto*//*Label 20078*/ GIMT_Encode4(1418709), // Rule ID 21593 //
     /* 1418626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1418629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1418637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1418640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1418643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1418646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418665 */     // MIs[0] Operand 5
     /* 1418665 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418676 */     // MIs[0] policy
     /* 1418676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418686 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1418689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418708 */     // GIR_Coverage, 21593,
     /* 1418708 */     GIR_EraseRootFromParent_Done,
     /* 1418709 */   // Label 20078: @1418709
     /* 1418709 */   GIM_Try, /*On fail goto*//*Label 20079*/ GIMT_Encode4(1418797), // Rule ID 21596 //
     /* 1418714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1418717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1418725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1418728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1418731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1418734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418753 */     // MIs[0] Operand 5
     /* 1418753 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418764 */     // MIs[0] policy
     /* 1418764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1418777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418796 */     // GIR_Coverage, 21596,
     /* 1418796 */     GIR_EraseRootFromParent_Done,
     /* 1418797 */   // Label 20079: @1418797
     /* 1418797 */   GIM_Try, /*On fail goto*//*Label 20080*/ GIMT_Encode4(1418885), // Rule ID 21597 //
     /* 1418802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1418805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1418813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1418816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1418819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1418822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418841 */     // MIs[0] Operand 5
     /* 1418841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418852 */     // MIs[0] policy
     /* 1418852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418862 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1418865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418884 */     // GIR_Coverage, 21597,
     /* 1418884 */     GIR_EraseRootFromParent_Done,
     /* 1418885 */   // Label 20080: @1418885
     /* 1418885 */   GIM_Try, /*On fail goto*//*Label 20081*/ GIMT_Encode4(1418973), // Rule ID 21600 //
     /* 1418890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1418893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1418901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1418904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1418907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418929 */     // MIs[0] Operand 5
     /* 1418929 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418940 */     // MIs[0] policy
     /* 1418940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1418953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418972 */     // GIR_Coverage, 21600,
     /* 1418972 */     GIR_EraseRootFromParent_Done,
     /* 1418973 */   // Label 20081: @1418973
     /* 1418973 */   GIM_Try, /*On fail goto*//*Label 20082*/ GIMT_Encode4(1419061), // Rule ID 21601 //
     /* 1418978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1418981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1418989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1418992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1418995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419017 */     // MIs[0] Operand 5
     /* 1419017 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419028 */     // MIs[0] policy
     /* 1419028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419038 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1419041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419060 */     // GIR_Coverage, 21601,
     /* 1419060 */     GIR_EraseRootFromParent_Done,
     /* 1419061 */   // Label 20082: @1419061
     /* 1419061 */   GIM_Try, /*On fail goto*//*Label 20083*/ GIMT_Encode4(1419149), // Rule ID 21604 //
     /* 1419066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1419069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1419077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1419080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1419083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1419086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419105 */     // MIs[0] Operand 5
     /* 1419105 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419116 */     // MIs[0] policy
     /* 1419116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419126 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1419129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419148 */     // GIR_Coverage, 21604,
     /* 1419148 */     GIR_EraseRootFromParent_Done,
     /* 1419149 */   // Label 20083: @1419149
     /* 1419149 */   GIM_Try, /*On fail goto*//*Label 20084*/ GIMT_Encode4(1419237), // Rule ID 21605 //
     /* 1419154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1419157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1419165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1419168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1419171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1419174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419193 */     // MIs[0] Operand 5
     /* 1419193 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419204 */     // MIs[0] policy
     /* 1419204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1419217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419236 */     // GIR_Coverage, 21605,
     /* 1419236 */     GIR_EraseRootFromParent_Done,
     /* 1419237 */   // Label 20084: @1419237
     /* 1419237 */   GIM_Try, /*On fail goto*//*Label 20085*/ GIMT_Encode4(1419336), // Rule ID 2802 //
     /* 1419242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1419253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1419256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1419259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1419265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419292 */     // MIs[1] Operand 1
     /* 1419292 */     // No operand predicates
     /* 1419292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419296 */     // MIs[0] policy
     /* 1419296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419308 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1419311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419317 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419335 */     // GIR_Coverage, 2802,
     /* 1419335 */     GIR_EraseRootFromParent_Done,
     /* 1419336 */   // Label 20085: @1419336
     /* 1419336 */   GIM_Try, /*On fail goto*//*Label 20086*/ GIMT_Encode4(1419435), // Rule ID 2803 //
     /* 1419341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1419352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1419355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1419358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1419364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419391 */     // MIs[1] Operand 1
     /* 1419391 */     // No operand predicates
     /* 1419391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419395 */     // MIs[0] policy
     /* 1419395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419407 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1419410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419416 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419434 */     // GIR_Coverage, 2803,
     /* 1419434 */     GIR_EraseRootFromParent_Done,
     /* 1419435 */   // Label 20086: @1419435
     /* 1419435 */   GIM_Try, /*On fail goto*//*Label 20087*/ GIMT_Encode4(1419534), // Rule ID 2810 //
     /* 1419440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1419451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1419454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1419457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1419463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419490 */     // MIs[1] Operand 1
     /* 1419490 */     // No operand predicates
     /* 1419490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419494 */     // MIs[0] policy
     /* 1419494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419506 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1419509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419515 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419533 */     // GIR_Coverage, 2810,
     /* 1419533 */     GIR_EraseRootFromParent_Done,
     /* 1419534 */   // Label 20087: @1419534
     /* 1419534 */   GIM_Try, /*On fail goto*//*Label 20088*/ GIMT_Encode4(1419633), // Rule ID 2811 //
     /* 1419539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1419550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1419553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1419556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1419562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419589 */     // MIs[1] Operand 1
     /* 1419589 */     // No operand predicates
     /* 1419589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419593 */     // MIs[0] policy
     /* 1419593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419605 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1419608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419614 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419632 */     // GIR_Coverage, 2811,
     /* 1419632 */     GIR_EraseRootFromParent_Done,
     /* 1419633 */   // Label 20088: @1419633
     /* 1419633 */   GIM_Try, /*On fail goto*//*Label 20089*/ GIMT_Encode4(1419732), // Rule ID 2818 //
     /* 1419638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1419649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1419652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1419655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1419661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419688 */     // MIs[1] Operand 1
     /* 1419688 */     // No operand predicates
     /* 1419688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419692 */     // MIs[0] policy
     /* 1419692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419704 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1419707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419713 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419731 */     // GIR_Coverage, 2818,
     /* 1419731 */     GIR_EraseRootFromParent_Done,
     /* 1419732 */   // Label 20089: @1419732
     /* 1419732 */   GIM_Try, /*On fail goto*//*Label 20090*/ GIMT_Encode4(1419831), // Rule ID 2819 //
     /* 1419737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1419748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1419751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1419754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1419760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419787 */     // MIs[1] Operand 1
     /* 1419787 */     // No operand predicates
     /* 1419787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419791 */     // MIs[0] policy
     /* 1419791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419803 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1419806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419812 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419830 */     // GIR_Coverage, 2819,
     /* 1419830 */     GIR_EraseRootFromParent_Done,
     /* 1419831 */   // Label 20090: @1419831
     /* 1419831 */   GIM_Try, /*On fail goto*//*Label 20091*/ GIMT_Encode4(1419930), // Rule ID 2826 //
     /* 1419836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1419847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1419850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1419853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1419859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419886 */     // MIs[1] Operand 1
     /* 1419886 */     // No operand predicates
     /* 1419886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419890 */     // MIs[0] policy
     /* 1419890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419902 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1419905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419911 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419929 */     // GIR_Coverage, 2826,
     /* 1419929 */     GIR_EraseRootFromParent_Done,
     /* 1419930 */   // Label 20091: @1419930
     /* 1419930 */   GIM_Try, /*On fail goto*//*Label 20092*/ GIMT_Encode4(1420029), // Rule ID 2827 //
     /* 1419935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1419946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1419949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1419952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1419958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419985 */     // MIs[1] Operand 1
     /* 1419985 */     // No operand predicates
     /* 1419985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419989 */     // MIs[0] policy
     /* 1419989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420001 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1420004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420010 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420028 */     // GIR_Coverage, 2827,
     /* 1420028 */     GIR_EraseRootFromParent_Done,
     /* 1420029 */   // Label 20092: @1420029
     /* 1420029 */   GIM_Try, /*On fail goto*//*Label 20093*/ GIMT_Encode4(1420128), // Rule ID 2834 //
     /* 1420034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1420045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1420048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1420051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420084 */     // MIs[1] Operand 1
     /* 1420084 */     // No operand predicates
     /* 1420084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420088 */     // MIs[0] policy
     /* 1420088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420100 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420109 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420127 */     // GIR_Coverage, 2834,
     /* 1420127 */     GIR_EraseRootFromParent_Done,
     /* 1420128 */   // Label 20093: @1420128
     /* 1420128 */   GIM_Try, /*On fail goto*//*Label 20094*/ GIMT_Encode4(1420227), // Rule ID 2835 //
     /* 1420133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1420144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1420147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1420150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420183 */     // MIs[1] Operand 1
     /* 1420183 */     // No operand predicates
     /* 1420183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420187 */     // MIs[0] policy
     /* 1420187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420199 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420208 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420226 */     // GIR_Coverage, 2835,
     /* 1420226 */     GIR_EraseRootFromParent_Done,
     /* 1420227 */   // Label 20094: @1420227
     /* 1420227 */   GIM_Try, /*On fail goto*//*Label 20095*/ GIMT_Encode4(1420326), // Rule ID 2842 //
     /* 1420232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1420243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1420246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1420249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1420255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420282 */     // MIs[1] Operand 1
     /* 1420282 */     // No operand predicates
     /* 1420282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420286 */     // MIs[0] policy
     /* 1420286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420298 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420307 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420325 */     // GIR_Coverage, 2842,
     /* 1420325 */     GIR_EraseRootFromParent_Done,
     /* 1420326 */   // Label 20095: @1420326
     /* 1420326 */   GIM_Try, /*On fail goto*//*Label 20096*/ GIMT_Encode4(1420425), // Rule ID 2843 //
     /* 1420331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1420342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1420345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1420348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1420354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420381 */     // MIs[1] Operand 1
     /* 1420381 */     // No operand predicates
     /* 1420381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420385 */     // MIs[0] policy
     /* 1420385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420397 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420406 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420424 */     // GIR_Coverage, 2843,
     /* 1420424 */     GIR_EraseRootFromParent_Done,
     /* 1420425 */   // Label 20096: @1420425
     /* 1420425 */   GIM_Try, /*On fail goto*//*Label 20097*/ GIMT_Encode4(1420524), // Rule ID 2850 //
     /* 1420430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1420441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1420444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1420447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1420453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420480 */     // MIs[1] Operand 1
     /* 1420480 */     // No operand predicates
     /* 1420480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420484 */     // MIs[0] policy
     /* 1420484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420496 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420505 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420523 */     // GIR_Coverage, 2850,
     /* 1420523 */     GIR_EraseRootFromParent_Done,
     /* 1420524 */   // Label 20097: @1420524
     /* 1420524 */   GIM_Try, /*On fail goto*//*Label 20098*/ GIMT_Encode4(1420623), // Rule ID 2851 //
     /* 1420529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1420540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1420543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1420546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1420552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420579 */     // MIs[1] Operand 1
     /* 1420579 */     // No operand predicates
     /* 1420579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420583 */     // MIs[0] policy
     /* 1420583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420595 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420604 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420622 */     // GIR_Coverage, 2851,
     /* 1420622 */     GIR_EraseRootFromParent_Done,
     /* 1420623 */   // Label 20098: @1420623
     /* 1420623 */   GIM_Try, /*On fail goto*//*Label 20099*/ GIMT_Encode4(1420722), // Rule ID 2858 //
     /* 1420628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1420639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1420642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1420645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420678 */     // MIs[1] Operand 1
     /* 1420678 */     // No operand predicates
     /* 1420678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420682 */     // MIs[0] policy
     /* 1420682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420703 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420721 */     // GIR_Coverage, 2858,
     /* 1420721 */     GIR_EraseRootFromParent_Done,
     /* 1420722 */   // Label 20099: @1420722
     /* 1420722 */   GIM_Try, /*On fail goto*//*Label 20100*/ GIMT_Encode4(1420821), // Rule ID 2859 //
     /* 1420727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1420738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1420741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1420744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420777 */     // MIs[1] Operand 1
     /* 1420777 */     // No operand predicates
     /* 1420777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420781 */     // MIs[0] policy
     /* 1420781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420793 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420802 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420820 */     // GIR_Coverage, 2859,
     /* 1420820 */     GIR_EraseRootFromParent_Done,
     /* 1420821 */   // Label 20100: @1420821
     /* 1420821 */   GIM_Try, /*On fail goto*//*Label 20101*/ GIMT_Encode4(1420920), // Rule ID 2866 //
     /* 1420826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1420837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1420840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1420843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420876 */     // MIs[1] Operand 1
     /* 1420876 */     // No operand predicates
     /* 1420876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420880 */     // MIs[0] policy
     /* 1420880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420892 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420901 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420919 */     // GIR_Coverage, 2866,
     /* 1420919 */     GIR_EraseRootFromParent_Done,
     /* 1420920 */   // Label 20101: @1420920
     /* 1420920 */   GIM_Try, /*On fail goto*//*Label 20102*/ GIMT_Encode4(1421019), // Rule ID 2867 //
     /* 1420925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1420936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1420939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1420942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420975 */     // MIs[1] Operand 1
     /* 1420975 */     // No operand predicates
     /* 1420975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420979 */     // MIs[0] policy
     /* 1420979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420991 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421000 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1421015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421018 */     // GIR_Coverage, 2867,
     /* 1421018 */     GIR_EraseRootFromParent_Done,
     /* 1421019 */   // Label 20102: @1421019
     /* 1421019 */   GIM_Try, /*On fail goto*//*Label 20103*/ GIMT_Encode4(1421118), // Rule ID 2874 //
     /* 1421024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1421027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1421035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1421038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1421041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421074 */     // MIs[1] Operand 1
     /* 1421074 */     // No operand predicates
     /* 1421074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421078 */     // MIs[0] policy
     /* 1421078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421090 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421099 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421117 */     // GIR_Coverage, 2874,
     /* 1421117 */     GIR_EraseRootFromParent_Done,
     /* 1421118 */   // Label 20103: @1421118
     /* 1421118 */   GIM_Try, /*On fail goto*//*Label 20104*/ GIMT_Encode4(1421217), // Rule ID 2875 //
     /* 1421123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1421126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1421134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1421137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1421140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421173 */     // MIs[1] Operand 1
     /* 1421173 */     // No operand predicates
     /* 1421173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421177 */     // MIs[0] policy
     /* 1421177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421189 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421198 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421216 */     // GIR_Coverage, 2875,
     /* 1421216 */     GIR_EraseRootFromParent_Done,
     /* 1421217 */   // Label 20104: @1421217
     /* 1421217 */   GIM_Try, /*On fail goto*//*Label 20105*/ GIMT_Encode4(1421316), // Rule ID 2882 //
     /* 1421222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1421233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1421236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1421239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1421245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421272 */     // MIs[1] Operand 1
     /* 1421272 */     // No operand predicates
     /* 1421272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421276 */     // MIs[0] policy
     /* 1421276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421288 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1421291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421297 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421315 */     // GIR_Coverage, 2882,
     /* 1421315 */     GIR_EraseRootFromParent_Done,
     /* 1421316 */   // Label 20105: @1421316
     /* 1421316 */   GIM_Try, /*On fail goto*//*Label 20106*/ GIMT_Encode4(1421415), // Rule ID 2883 //
     /* 1421321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1421332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1421335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1421338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1421344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421371 */     // MIs[1] Operand 1
     /* 1421371 */     // No operand predicates
     /* 1421371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421375 */     // MIs[0] policy
     /* 1421375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421387 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1421390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421396 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421414 */     // GIR_Coverage, 2883,
     /* 1421414 */     GIR_EraseRootFromParent_Done,
     /* 1421415 */   // Label 20106: @1421415
     /* 1421415 */   GIM_Try, /*On fail goto*//*Label 20107*/ GIMT_Encode4(1421514), // Rule ID 2890 //
     /* 1421420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1421431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1421434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1421437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1421443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1421450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421470 */     // MIs[1] Operand 1
     /* 1421470 */     // No operand predicates
     /* 1421470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421474 */     // MIs[0] policy
     /* 1421474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421486 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1421489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421495 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421513 */     // GIR_Coverage, 2890,
     /* 1421513 */     GIR_EraseRootFromParent_Done,
     /* 1421514 */   // Label 20107: @1421514
     /* 1421514 */   GIM_Try, /*On fail goto*//*Label 20108*/ GIMT_Encode4(1421613), // Rule ID 2891 //
     /* 1421519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1421530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1421533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1421536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1421542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1421549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421569 */     // MIs[1] Operand 1
     /* 1421569 */     // No operand predicates
     /* 1421569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421573 */     // MIs[0] policy
     /* 1421573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421585 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1421588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421594 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421612 */     // GIR_Coverage, 2891,
     /* 1421612 */     GIR_EraseRootFromParent_Done,
     /* 1421613 */   // Label 20108: @1421613
     /* 1421613 */   GIM_Try, /*On fail goto*//*Label 20109*/ GIMT_Encode4(1421712), // Rule ID 2898 //
     /* 1421618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1421629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1421632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1421635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1421641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1421648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421668 */     // MIs[1] Operand 1
     /* 1421668 */     // No operand predicates
     /* 1421668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421672 */     // MIs[0] policy
     /* 1421672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421684 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1421687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421693 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421711 */     // GIR_Coverage, 2898,
     /* 1421711 */     GIR_EraseRootFromParent_Done,
     /* 1421712 */   // Label 20109: @1421712
     /* 1421712 */   GIM_Try, /*On fail goto*//*Label 20110*/ GIMT_Encode4(1421811), // Rule ID 2899 //
     /* 1421717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1421728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1421731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1421734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1421740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1421747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421767 */     // MIs[1] Operand 1
     /* 1421767 */     // No operand predicates
     /* 1421767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421771 */     // MIs[0] policy
     /* 1421771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421783 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1421786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421792 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421810 */     // GIR_Coverage, 2899,
     /* 1421810 */     GIR_EraseRootFromParent_Done,
     /* 1421811 */   // Label 20110: @1421811
     /* 1421811 */   GIM_Try, /*On fail goto*//*Label 20111*/ GIMT_Encode4(1421910), // Rule ID 2906 //
     /* 1421816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1421827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1421830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1421833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1421839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421866 */     // MIs[1] Operand 1
     /* 1421866 */     // No operand predicates
     /* 1421866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421870 */     // MIs[0] policy
     /* 1421870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421882 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1421885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421891 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421909 */     // GIR_Coverage, 2906,
     /* 1421909 */     GIR_EraseRootFromParent_Done,
     /* 1421910 */   // Label 20111: @1421910
     /* 1421910 */   GIM_Try, /*On fail goto*//*Label 20112*/ GIMT_Encode4(1422009), // Rule ID 2907 //
     /* 1421915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1421926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1421929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1421932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1421938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421965 */     // MIs[1] Operand 1
     /* 1421965 */     // No operand predicates
     /* 1421965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421969 */     // MIs[0] policy
     /* 1421969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421981 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1421984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421990 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422008 */     // GIR_Coverage, 2907,
     /* 1422008 */     GIR_EraseRootFromParent_Done,
     /* 1422009 */   // Label 20112: @1422009
     /* 1422009 */   GIM_Try, /*On fail goto*//*Label 20113*/ GIMT_Encode4(1422108), // Rule ID 2914 //
     /* 1422014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1422025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1422028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1422031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1422037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422064 */     // MIs[1] Operand 1
     /* 1422064 */     // No operand predicates
     /* 1422064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422068 */     // MIs[0] policy
     /* 1422068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422080 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422089 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422107 */     // GIR_Coverage, 2914,
     /* 1422107 */     GIR_EraseRootFromParent_Done,
     /* 1422108 */   // Label 20113: @1422108
     /* 1422108 */   GIM_Try, /*On fail goto*//*Label 20114*/ GIMT_Encode4(1422207), // Rule ID 2915 //
     /* 1422113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1422124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1422127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1422130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1422136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422163 */     // MIs[1] Operand 1
     /* 1422163 */     // No operand predicates
     /* 1422163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422167 */     // MIs[0] policy
     /* 1422167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422179 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422188 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422206 */     // GIR_Coverage, 2915,
     /* 1422206 */     GIR_EraseRootFromParent_Done,
     /* 1422207 */   // Label 20114: @1422207
     /* 1422207 */   GIM_Try, /*On fail goto*//*Label 20115*/ GIMT_Encode4(1422306), // Rule ID 2922 //
     /* 1422212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1422223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1422226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1422229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1422235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422262 */     // MIs[1] Operand 1
     /* 1422262 */     // No operand predicates
     /* 1422262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422266 */     // MIs[0] policy
     /* 1422266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422278 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422287 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422305 */     // GIR_Coverage, 2922,
     /* 1422305 */     GIR_EraseRootFromParent_Done,
     /* 1422306 */   // Label 20115: @1422306
     /* 1422306 */   GIM_Try, /*On fail goto*//*Label 20116*/ GIMT_Encode4(1422405), // Rule ID 2923 //
     /* 1422311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1422322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1422325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1422328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1422334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422361 */     // MIs[1] Operand 1
     /* 1422361 */     // No operand predicates
     /* 1422361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422365 */     // MIs[0] policy
     /* 1422365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422377 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422386 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422404 */     // GIR_Coverage, 2923,
     /* 1422404 */     GIR_EraseRootFromParent_Done,
     /* 1422405 */   // Label 20116: @1422405
     /* 1422405 */   GIM_Try, /*On fail goto*//*Label 20117*/ GIMT_Encode4(1422504), // Rule ID 2930 //
     /* 1422410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1422421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1422424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1422427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1422433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422460 */     // MIs[1] Operand 1
     /* 1422460 */     // No operand predicates
     /* 1422460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422464 */     // MIs[0] policy
     /* 1422464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1422479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422485 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422503 */     // GIR_Coverage, 2930,
     /* 1422503 */     GIR_EraseRootFromParent_Done,
     /* 1422504 */   // Label 20117: @1422504
     /* 1422504 */   GIM_Try, /*On fail goto*//*Label 20118*/ GIMT_Encode4(1422603), // Rule ID 2931 //
     /* 1422509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1422520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1422523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1422526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1422532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422559 */     // MIs[1] Operand 1
     /* 1422559 */     // No operand predicates
     /* 1422559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422563 */     // MIs[0] policy
     /* 1422563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422575 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1422578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422584 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422602 */     // GIR_Coverage, 2931,
     /* 1422602 */     GIR_EraseRootFromParent_Done,
     /* 1422603 */   // Label 20118: @1422603
     /* 1422603 */   GIM_Try, /*On fail goto*//*Label 20119*/ GIMT_Encode4(1422702), // Rule ID 2938 //
     /* 1422608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1422619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1422622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1422625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1422631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422658 */     // MIs[1] Operand 1
     /* 1422658 */     // No operand predicates
     /* 1422658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422662 */     // MIs[0] policy
     /* 1422662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422683 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422701 */     // GIR_Coverage, 2938,
     /* 1422701 */     GIR_EraseRootFromParent_Done,
     /* 1422702 */   // Label 20119: @1422702
     /* 1422702 */   GIM_Try, /*On fail goto*//*Label 20120*/ GIMT_Encode4(1422801), // Rule ID 2939 //
     /* 1422707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1422718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1422721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1422724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1422730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422757 */     // MIs[1] Operand 1
     /* 1422757 */     // No operand predicates
     /* 1422757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422761 */     // MIs[0] policy
     /* 1422761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422773 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422782 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422800 */     // GIR_Coverage, 2939,
     /* 1422800 */     GIR_EraseRootFromParent_Done,
     /* 1422801 */   // Label 20120: @1422801
     /* 1422801 */   GIM_Try, /*On fail goto*//*Label 20121*/ GIMT_Encode4(1422900), // Rule ID 2946 //
     /* 1422806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1422817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1422820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1422823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1422829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422856 */     // MIs[1] Operand 1
     /* 1422856 */     // No operand predicates
     /* 1422856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422860 */     // MIs[0] policy
     /* 1422860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422872 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422881 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422899 */     // GIR_Coverage, 2946,
     /* 1422899 */     GIR_EraseRootFromParent_Done,
     /* 1422900 */   // Label 20121: @1422900
     /* 1422900 */   GIM_Try, /*On fail goto*//*Label 20122*/ GIMT_Encode4(1422999), // Rule ID 2947 //
     /* 1422905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1422916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1422919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1422922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1422928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422955 */     // MIs[1] Operand 1
     /* 1422955 */     // No operand predicates
     /* 1422955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422959 */     // MIs[0] policy
     /* 1422959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422971 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422980 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422998 */     // GIR_Coverage, 2947,
     /* 1422998 */     GIR_EraseRootFromParent_Done,
     /* 1422999 */   // Label 20122: @1422999
     /* 1422999 */   GIM_Try, /*On fail goto*//*Label 20123*/ GIMT_Encode4(1423098), // Rule ID 2954 //
     /* 1423004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1423007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1423015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1423018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1423021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423054 */     // MIs[1] Operand 1
     /* 1423054 */     // No operand predicates
     /* 1423054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423058 */     // MIs[0] policy
     /* 1423058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423070 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1423073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423079 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423097 */     // GIR_Coverage, 2954,
     /* 1423097 */     GIR_EraseRootFromParent_Done,
     /* 1423098 */   // Label 20123: @1423098
     /* 1423098 */   GIM_Try, /*On fail goto*//*Label 20124*/ GIMT_Encode4(1423197), // Rule ID 2955 //
     /* 1423103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1423114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1423117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1423120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423153 */     // MIs[1] Operand 1
     /* 1423153 */     // No operand predicates
     /* 1423153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423157 */     // MIs[0] policy
     /* 1423157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423169 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1423172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423178 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423196 */     // GIR_Coverage, 2955,
     /* 1423196 */     GIR_EraseRootFromParent_Done,
     /* 1423197 */   // Label 20124: @1423197
     /* 1423197 */   GIM_Try, /*On fail goto*//*Label 20125*/ GIMT_Encode4(1423296), // Rule ID 2962 //
     /* 1423202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1423205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1423213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1423216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1423219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1423225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423252 */     // MIs[1] Operand 1
     /* 1423252 */     // No operand predicates
     /* 1423252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423256 */     // MIs[0] policy
     /* 1423256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423268 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423277 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423295 */     // GIR_Coverage, 2962,
     /* 1423295 */     GIR_EraseRootFromParent_Done,
     /* 1423296 */   // Label 20125: @1423296
     /* 1423296 */   GIM_Try, /*On fail goto*//*Label 20126*/ GIMT_Encode4(1423395), // Rule ID 2963 //
     /* 1423301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1423312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1423315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1423318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1423324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423351 */     // MIs[1] Operand 1
     /* 1423351 */     // No operand predicates
     /* 1423351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423355 */     // MIs[0] policy
     /* 1423355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423367 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423376 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423394 */     // GIR_Coverage, 2963,
     /* 1423394 */     GIR_EraseRootFromParent_Done,
     /* 1423395 */   // Label 20126: @1423395
     /* 1423395 */   GIM_Try, /*On fail goto*//*Label 20127*/ GIMT_Encode4(1423494), // Rule ID 2970 //
     /* 1423400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1423403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1423411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1423414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1423417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423450 */     // MIs[1] Operand 1
     /* 1423450 */     // No operand predicates
     /* 1423450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423454 */     // MIs[0] policy
     /* 1423454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423466 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1423469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423475 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423493 */     // GIR_Coverage, 2970,
     /* 1423493 */     GIR_EraseRootFromParent_Done,
     /* 1423494 */   // Label 20127: @1423494
     /* 1423494 */   GIM_Try, /*On fail goto*//*Label 20128*/ GIMT_Encode4(1423593), // Rule ID 2971 //
     /* 1423499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1423510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1423513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1423516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423549 */     // MIs[1] Operand 1
     /* 1423549 */     // No operand predicates
     /* 1423549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423553 */     // MIs[0] policy
     /* 1423553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423565 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1423568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423574 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423592 */     // GIR_Coverage, 2971,
     /* 1423592 */     GIR_EraseRootFromParent_Done,
     /* 1423593 */   // Label 20128: @1423593
     /* 1423593 */   GIM_Try, /*On fail goto*//*Label 20129*/ GIMT_Encode4(1423690), // Rule ID 3154 //
     /* 1423598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1423609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1423612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1423615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1423621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423648 */     // MIs[1] Operand 1
     /* 1423648 */     // No operand predicates
     /* 1423648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423652 */     // MIs[0] policy
     /* 1423652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423664 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1423667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423689 */     // GIR_Coverage, 3154,
     /* 1423689 */     GIR_EraseRootFromParent_Done,
     /* 1423690 */   // Label 20129: @1423690
     /* 1423690 */   GIM_Try, /*On fail goto*//*Label 20130*/ GIMT_Encode4(1423787), // Rule ID 3155 //
     /* 1423695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1423706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1423709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1423712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1423718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423745 */     // MIs[1] Operand 1
     /* 1423745 */     // No operand predicates
     /* 1423745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423749 */     // MIs[0] policy
     /* 1423749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423761 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1423764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423786 */     // GIR_Coverage, 3155,
     /* 1423786 */     GIR_EraseRootFromParent_Done,
     /* 1423787 */   // Label 20130: @1423787
     /* 1423787 */   GIM_Try, /*On fail goto*//*Label 20131*/ GIMT_Encode4(1423884), // Rule ID 3158 //
     /* 1423792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1423803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1423806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1423809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423842 */     // MIs[1] Operand 1
     /* 1423842 */     // No operand predicates
     /* 1423842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423846 */     // MIs[0] policy
     /* 1423846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423858 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1423861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423883 */     // GIR_Coverage, 3158,
     /* 1423883 */     GIR_EraseRootFromParent_Done,
     /* 1423884 */   // Label 20131: @1423884
     /* 1423884 */   GIM_Try, /*On fail goto*//*Label 20132*/ GIMT_Encode4(1423981), // Rule ID 3159 //
     /* 1423889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1423900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1423903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1423906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423939 */     // MIs[1] Operand 1
     /* 1423939 */     // No operand predicates
     /* 1423939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423943 */     // MIs[0] policy
     /* 1423943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423955 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1423958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423980 */     // GIR_Coverage, 3159,
     /* 1423980 */     GIR_EraseRootFromParent_Done,
     /* 1423981 */   // Label 20132: @1423981
     /* 1423981 */   GIM_Try, /*On fail goto*//*Label 20133*/ GIMT_Encode4(1424078), // Rule ID 3162 //
     /* 1423986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1423997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1424000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1424003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424036 */     // MIs[1] Operand 1
     /* 1424036 */     // No operand predicates
     /* 1424036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424040 */     // MIs[0] policy
     /* 1424040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424052 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424077 */     // GIR_Coverage, 3162,
     /* 1424077 */     GIR_EraseRootFromParent_Done,
     /* 1424078 */   // Label 20133: @1424078
     /* 1424078 */   GIM_Try, /*On fail goto*//*Label 20134*/ GIMT_Encode4(1424175), // Rule ID 3163 //
     /* 1424083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1424094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1424097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1424100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424133 */     // MIs[1] Operand 1
     /* 1424133 */     // No operand predicates
     /* 1424133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424137 */     // MIs[0] policy
     /* 1424137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424149 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424174 */     // GIR_Coverage, 3163,
     /* 1424174 */     GIR_EraseRootFromParent_Done,
     /* 1424175 */   // Label 20134: @1424175
     /* 1424175 */   GIM_Try, /*On fail goto*//*Label 20135*/ GIMT_Encode4(1424272), // Rule ID 3166 //
     /* 1424180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1424191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1424194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1424197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424230 */     // MIs[1] Operand 1
     /* 1424230 */     // No operand predicates
     /* 1424230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424234 */     // MIs[0] policy
     /* 1424234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424246 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1424249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424271 */     // GIR_Coverage, 3166,
     /* 1424271 */     GIR_EraseRootFromParent_Done,
     /* 1424272 */   // Label 20135: @1424272
     /* 1424272 */   GIM_Try, /*On fail goto*//*Label 20136*/ GIMT_Encode4(1424369), // Rule ID 3167 //
     /* 1424277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1424288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1424291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1424294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424327 */     // MIs[1] Operand 1
     /* 1424327 */     // No operand predicates
     /* 1424327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424331 */     // MIs[0] policy
     /* 1424331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424343 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1424346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424368 */     // GIR_Coverage, 3167,
     /* 1424368 */     GIR_EraseRootFromParent_Done,
     /* 1424369 */   // Label 20136: @1424369
     /* 1424369 */   GIM_Try, /*On fail goto*//*Label 20137*/ GIMT_Encode4(1424466), // Rule ID 3170 //
     /* 1424374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1424385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1424388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1424391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424424 */     // MIs[1] Operand 1
     /* 1424424 */     // No operand predicates
     /* 1424424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424428 */     // MIs[0] policy
     /* 1424428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424440 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424465 */     // GIR_Coverage, 3170,
     /* 1424465 */     GIR_EraseRootFromParent_Done,
     /* 1424466 */   // Label 20137: @1424466
     /* 1424466 */   GIM_Try, /*On fail goto*//*Label 20138*/ GIMT_Encode4(1424563), // Rule ID 3171 //
     /* 1424471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1424482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1424485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1424488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424521 */     // MIs[1] Operand 1
     /* 1424521 */     // No operand predicates
     /* 1424521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424525 */     // MIs[0] policy
     /* 1424525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424537 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424562 */     // GIR_Coverage, 3171,
     /* 1424562 */     GIR_EraseRootFromParent_Done,
     /* 1424563 */   // Label 20138: @1424563
     /* 1424563 */   GIM_Try, /*On fail goto*//*Label 20139*/ GIMT_Encode4(1424660), // Rule ID 3174 //
     /* 1424568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1424579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1424582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1424585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424618 */     // MIs[1] Operand 1
     /* 1424618 */     // No operand predicates
     /* 1424618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424622 */     // MIs[0] policy
     /* 1424622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424634 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424659 */     // GIR_Coverage, 3174,
     /* 1424659 */     GIR_EraseRootFromParent_Done,
     /* 1424660 */   // Label 20139: @1424660
     /* 1424660 */   GIM_Try, /*On fail goto*//*Label 20140*/ GIMT_Encode4(1424757), // Rule ID 3175 //
     /* 1424665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1424676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1424679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1424682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424715 */     // MIs[1] Operand 1
     /* 1424715 */     // No operand predicates
     /* 1424715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424719 */     // MIs[0] policy
     /* 1424719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424731 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424756 */     // GIR_Coverage, 3175,
     /* 1424756 */     GIR_EraseRootFromParent_Done,
     /* 1424757 */   // Label 20140: @1424757
     /* 1424757 */   GIM_Try, /*On fail goto*//*Label 20141*/ GIMT_Encode4(1424854), // Rule ID 3178 //
     /* 1424762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1424773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1424776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1424779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1424785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424812 */     // MIs[1] Operand 1
     /* 1424812 */     // No operand predicates
     /* 1424812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424816 */     // MIs[0] policy
     /* 1424816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424828 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1424831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424853 */     // GIR_Coverage, 3178,
     /* 1424853 */     GIR_EraseRootFromParent_Done,
     /* 1424854 */   // Label 20141: @1424854
     /* 1424854 */   GIM_Try, /*On fail goto*//*Label 20142*/ GIMT_Encode4(1424951), // Rule ID 3179 //
     /* 1424859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1424870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1424873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1424876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1424882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424909 */     // MIs[1] Operand 1
     /* 1424909 */     // No operand predicates
     /* 1424909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424913 */     // MIs[0] policy
     /* 1424913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424925 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1424928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424950 */     // GIR_Coverage, 3179,
     /* 1424950 */     GIR_EraseRootFromParent_Done,
     /* 1424951 */   // Label 20142: @1424951
     /* 1424951 */   GIM_Try, /*On fail goto*//*Label 20143*/ GIMT_Encode4(1425048), // Rule ID 3182 //
     /* 1424956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1424967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1424970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1424973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425006 */     // MIs[1] Operand 1
     /* 1425006 */     // No operand predicates
     /* 1425006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425010 */     // MIs[0] policy
     /* 1425010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425022 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425047 */     // GIR_Coverage, 3182,
     /* 1425047 */     GIR_EraseRootFromParent_Done,
     /* 1425048 */   // Label 20143: @1425048
     /* 1425048 */   GIM_Try, /*On fail goto*//*Label 20144*/ GIMT_Encode4(1425145), // Rule ID 3183 //
     /* 1425053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1425064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1425067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1425070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1425076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425103 */     // MIs[1] Operand 1
     /* 1425103 */     // No operand predicates
     /* 1425103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425107 */     // MIs[0] policy
     /* 1425107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425119 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425144 */     // GIR_Coverage, 3183,
     /* 1425144 */     GIR_EraseRootFromParent_Done,
     /* 1425145 */   // Label 20144: @1425145
     /* 1425145 */   GIM_Try, /*On fail goto*//*Label 20145*/ GIMT_Encode4(1425242), // Rule ID 3186 //
     /* 1425150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1425161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1425164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1425167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425200 */     // MIs[1] Operand 1
     /* 1425200 */     // No operand predicates
     /* 1425200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425204 */     // MIs[0] policy
     /* 1425204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425241 */     // GIR_Coverage, 3186,
     /* 1425241 */     GIR_EraseRootFromParent_Done,
     /* 1425242 */   // Label 20145: @1425242
     /* 1425242 */   GIM_Try, /*On fail goto*//*Label 20146*/ GIMT_Encode4(1425339), // Rule ID 3187 //
     /* 1425247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1425258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1425261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1425264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425297 */     // MIs[1] Operand 1
     /* 1425297 */     // No operand predicates
     /* 1425297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425301 */     // MIs[0] policy
     /* 1425301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425313 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425338 */     // GIR_Coverage, 3187,
     /* 1425338 */     GIR_EraseRootFromParent_Done,
     /* 1425339 */   // Label 20146: @1425339
     /* 1425339 */   GIM_Try, /*On fail goto*//*Label 20147*/ GIMT_Encode4(1425436), // Rule ID 3190 //
     /* 1425344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1425347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1425355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1425358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1425361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425394 */     // MIs[1] Operand 1
     /* 1425394 */     // No operand predicates
     /* 1425394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425398 */     // MIs[0] policy
     /* 1425398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425410 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425435 */     // GIR_Coverage, 3190,
     /* 1425435 */     GIR_EraseRootFromParent_Done,
     /* 1425436 */   // Label 20147: @1425436
     /* 1425436 */   GIM_Try, /*On fail goto*//*Label 20148*/ GIMT_Encode4(1425533), // Rule ID 3191 //
     /* 1425441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1425444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1425452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1425455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1425458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425491 */     // MIs[1] Operand 1
     /* 1425491 */     // No operand predicates
     /* 1425491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425495 */     // MIs[0] policy
     /* 1425495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425507 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425532 */     // GIR_Coverage, 3191,
     /* 1425532 */     GIR_EraseRootFromParent_Done,
     /* 1425533 */   // Label 20148: @1425533
     /* 1425533 */   GIM_Try, /*On fail goto*//*Label 20149*/ GIMT_Encode4(1425630), // Rule ID 3194 //
     /* 1425538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1425549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1425552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1425555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1425561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1425568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425588 */     // MIs[1] Operand 1
     /* 1425588 */     // No operand predicates
     /* 1425588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425592 */     // MIs[0] policy
     /* 1425592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425604 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1425607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425629 */     // GIR_Coverage, 3194,
     /* 1425629 */     GIR_EraseRootFromParent_Done,
     /* 1425630 */   // Label 20149: @1425630
     /* 1425630 */   GIM_Try, /*On fail goto*//*Label 20150*/ GIMT_Encode4(1425727), // Rule ID 3195 //
     /* 1425635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1425646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1425649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1425652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1425658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1425665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425685 */     // MIs[1] Operand 1
     /* 1425685 */     // No operand predicates
     /* 1425685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425689 */     // MIs[0] policy
     /* 1425689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425701 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1425704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425726 */     // GIR_Coverage, 3195,
     /* 1425726 */     GIR_EraseRootFromParent_Done,
     /* 1425727 */   // Label 20150: @1425727
     /* 1425727 */   GIM_Try, /*On fail goto*//*Label 20151*/ GIMT_Encode4(1425824), // Rule ID 3198 //
     /* 1425732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1425743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1425746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1425749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1425755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1425762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425782 */     // MIs[1] Operand 1
     /* 1425782 */     // No operand predicates
     /* 1425782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425786 */     // MIs[0] policy
     /* 1425786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425798 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1425801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425823 */     // GIR_Coverage, 3198,
     /* 1425823 */     GIR_EraseRootFromParent_Done,
     /* 1425824 */   // Label 20151: @1425824
     /* 1425824 */   GIM_Try, /*On fail goto*//*Label 20152*/ GIMT_Encode4(1425921), // Rule ID 3199 //
     /* 1425829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1425840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1425843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1425846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1425852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1425859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425879 */     // MIs[1] Operand 1
     /* 1425879 */     // No operand predicates
     /* 1425879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425883 */     // MIs[0] policy
     /* 1425883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425895 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1425898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425920 */     // GIR_Coverage, 3199,
     /* 1425920 */     GIR_EraseRootFromParent_Done,
     /* 1425921 */   // Label 20152: @1425921
     /* 1425921 */   GIM_Try, /*On fail goto*//*Label 20153*/ GIMT_Encode4(1426018), // Rule ID 3202 //
     /* 1425926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1425937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1425940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1425943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1425949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1425956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425976 */     // MIs[1] Operand 1
     /* 1425976 */     // No operand predicates
     /* 1425976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425980 */     // MIs[0] policy
     /* 1425980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425992 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1425995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426017 */     // GIR_Coverage, 3202,
     /* 1426017 */     GIR_EraseRootFromParent_Done,
     /* 1426018 */   // Label 20153: @1426018
     /* 1426018 */   GIM_Try, /*On fail goto*//*Label 20154*/ GIMT_Encode4(1426115), // Rule ID 3203 //
     /* 1426023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1426034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1426037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1426040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1426046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426073 */     // MIs[1] Operand 1
     /* 1426073 */     // No operand predicates
     /* 1426073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426077 */     // MIs[0] policy
     /* 1426077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426089 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426114 */     // GIR_Coverage, 3203,
     /* 1426114 */     GIR_EraseRootFromParent_Done,
     /* 1426115 */   // Label 20154: @1426115
     /* 1426115 */   GIM_Try, /*On fail goto*//*Label 20155*/ GIMT_Encode4(1426212), // Rule ID 3206 //
     /* 1426120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1426131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1426134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1426137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426170 */     // MIs[1] Operand 1
     /* 1426170 */     // No operand predicates
     /* 1426170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426174 */     // MIs[0] policy
     /* 1426174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426186 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426211 */     // GIR_Coverage, 3206,
     /* 1426211 */     GIR_EraseRootFromParent_Done,
     /* 1426212 */   // Label 20155: @1426212
     /* 1426212 */   GIM_Try, /*On fail goto*//*Label 20156*/ GIMT_Encode4(1426309), // Rule ID 3207 //
     /* 1426217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1426228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1426231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1426234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426267 */     // MIs[1] Operand 1
     /* 1426267 */     // No operand predicates
     /* 1426267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426271 */     // MIs[0] policy
     /* 1426271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426283 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426308 */     // GIR_Coverage, 3207,
     /* 1426308 */     GIR_EraseRootFromParent_Done,
     /* 1426309 */   // Label 20156: @1426309
     /* 1426309 */   GIM_Try, /*On fail goto*//*Label 20157*/ GIMT_Encode4(1426406), // Rule ID 3210 //
     /* 1426314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1426325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1426328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1426331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426364 */     // MIs[1] Operand 1
     /* 1426364 */     // No operand predicates
     /* 1426364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426368 */     // MIs[0] policy
     /* 1426368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426380 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426405 */     // GIR_Coverage, 3210,
     /* 1426405 */     GIR_EraseRootFromParent_Done,
     /* 1426406 */   // Label 20157: @1426406
     /* 1426406 */   GIM_Try, /*On fail goto*//*Label 20158*/ GIMT_Encode4(1426503), // Rule ID 3211 //
     /* 1426411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1426422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1426425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1426428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426461 */     // MIs[1] Operand 1
     /* 1426461 */     // No operand predicates
     /* 1426461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426465 */     // MIs[0] policy
     /* 1426465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426477 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426502 */     // GIR_Coverage, 3211,
     /* 1426502 */     GIR_EraseRootFromParent_Done,
     /* 1426503 */   // Label 20158: @1426503
     /* 1426503 */   GIM_Try, /*On fail goto*//*Label 20159*/ GIMT_Encode4(1426600), // Rule ID 3214 //
     /* 1426508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1426519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1426522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1426525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1426531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426558 */     // MIs[1] Operand 1
     /* 1426558 */     // No operand predicates
     /* 1426558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426562 */     // MIs[0] policy
     /* 1426562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426574 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426599 */     // GIR_Coverage, 3214,
     /* 1426599 */     GIR_EraseRootFromParent_Done,
     /* 1426600 */   // Label 20159: @1426600
     /* 1426600 */   GIM_Try, /*On fail goto*//*Label 20160*/ GIMT_Encode4(1426697), // Rule ID 3215 //
     /* 1426605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1426616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1426619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1426622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1426628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426655 */     // MIs[1] Operand 1
     /* 1426655 */     // No operand predicates
     /* 1426655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426659 */     // MIs[0] policy
     /* 1426659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426671 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426696 */     // GIR_Coverage, 3215,
     /* 1426696 */     GIR_EraseRootFromParent_Done,
     /* 1426697 */   // Label 20160: @1426697
     /* 1426697 */   GIM_Try, /*On fail goto*//*Label 20161*/ GIMT_Encode4(1426794), // Rule ID 3218 //
     /* 1426702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1426713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1426716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1426719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1426725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426752 */     // MIs[1] Operand 1
     /* 1426752 */     // No operand predicates
     /* 1426752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426756 */     // MIs[0] policy
     /* 1426756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426793 */     // GIR_Coverage, 3218,
     /* 1426793 */     GIR_EraseRootFromParent_Done,
     /* 1426794 */   // Label 20161: @1426794
     /* 1426794 */   GIM_Try, /*On fail goto*//*Label 20162*/ GIMT_Encode4(1426891), // Rule ID 3219 //
     /* 1426799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1426810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1426813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1426816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1426822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426849 */     // MIs[1] Operand 1
     /* 1426849 */     // No operand predicates
     /* 1426849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426853 */     // MIs[0] policy
     /* 1426853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426865 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426890 */     // GIR_Coverage, 3219,
     /* 1426890 */     GIR_EraseRootFromParent_Done,
     /* 1426891 */   // Label 20162: @1426891
     /* 1426891 */   GIM_Try, /*On fail goto*//*Label 20163*/ GIMT_Encode4(1426988), // Rule ID 3222 //
     /* 1426896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1426907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1426910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1426913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426946 */     // MIs[1] Operand 1
     /* 1426946 */     // No operand predicates
     /* 1426946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426950 */     // MIs[0] policy
     /* 1426950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426962 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426987 */     // GIR_Coverage, 3222,
     /* 1426987 */     GIR_EraseRootFromParent_Done,
     /* 1426988 */   // Label 20163: @1426988
     /* 1426988 */   GIM_Try, /*On fail goto*//*Label 20164*/ GIMT_Encode4(1427085), // Rule ID 3223 //
     /* 1426993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1427004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1427007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1427010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1427016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427043 */     // MIs[1] Operand 1
     /* 1427043 */     // No operand predicates
     /* 1427043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427047 */     // MIs[0] policy
     /* 1427047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427059 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1427062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427084 */     // GIR_Coverage, 3223,
     /* 1427084 */     GIR_EraseRootFromParent_Done,
     /* 1427085 */   // Label 20164: @1427085
     /* 1427085 */   GIM_Try, /*On fail goto*//*Label 20165*/ GIMT_Encode4(1427182), // Rule ID 3226 //
     /* 1427090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1427101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1427104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1427107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1427113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427140 */     // MIs[1] Operand 1
     /* 1427140 */     // No operand predicates
     /* 1427140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427144 */     // MIs[0] policy
     /* 1427144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427156 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427181 */     // GIR_Coverage, 3226,
     /* 1427181 */     GIR_EraseRootFromParent_Done,
     /* 1427182 */   // Label 20165: @1427182
     /* 1427182 */   GIM_Try, /*On fail goto*//*Label 20166*/ GIMT_Encode4(1427279), // Rule ID 3227 //
     /* 1427187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1427198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1427201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1427204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1427210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427237 */     // MIs[1] Operand 1
     /* 1427237 */     // No operand predicates
     /* 1427237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427241 */     // MIs[0] policy
     /* 1427241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427253 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427278 */     // GIR_Coverage, 3227,
     /* 1427278 */     GIR_EraseRootFromParent_Done,
     /* 1427279 */   // Label 20166: @1427279
     /* 1427279 */   GIM_Try, /*On fail goto*//*Label 20167*/ GIMT_Encode4(1427376), // Rule ID 3230 //
     /* 1427284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1427295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1427298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1427301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427334 */     // MIs[1] Operand 1
     /* 1427334 */     // No operand predicates
     /* 1427334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427338 */     // MIs[0] policy
     /* 1427338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427350 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1427353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427375 */     // GIR_Coverage, 3230,
     /* 1427375 */     GIR_EraseRootFromParent_Done,
     /* 1427376 */   // Label 20167: @1427376
     /* 1427376 */   GIM_Try, /*On fail goto*//*Label 20168*/ GIMT_Encode4(1427473), // Rule ID 3231 //
     /* 1427381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1427384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1427392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1427395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1427398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427431 */     // MIs[1] Operand 1
     /* 1427431 */     // No operand predicates
     /* 1427431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427435 */     // MIs[0] policy
     /* 1427435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427447 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1427450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427472 */     // GIR_Coverage, 3231,
     /* 1427472 */     GIR_EraseRootFromParent_Done,
     /* 1427473 */   // Label 20168: @1427473
     /* 1427473 */   GIM_Try, /*On fail goto*//*Label 20169*/ GIMT_Encode4(1427570), // Rule ID 3234 //
     /* 1427478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1427489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1427492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1427495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427528 */     // MIs[1] Operand 1
     /* 1427528 */     // No operand predicates
     /* 1427528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427532 */     // MIs[0] policy
     /* 1427532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427544 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1427547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427569 */     // GIR_Coverage, 3234,
     /* 1427569 */     GIR_EraseRootFromParent_Done,
     /* 1427570 */   // Label 20169: @1427570
     /* 1427570 */   GIM_Try, /*On fail goto*//*Label 20170*/ GIMT_Encode4(1427667), // Rule ID 3235 //
     /* 1427575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1427578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1427586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1427589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1427592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427625 */     // MIs[1] Operand 1
     /* 1427625 */     // No operand predicates
     /* 1427625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427629 */     // MIs[0] policy
     /* 1427629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427641 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1427644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427666 */     // GIR_Coverage, 3235,
     /* 1427666 */     GIR_EraseRootFromParent_Done,
     /* 1427667 */   // Label 20170: @1427667
     /* 1427667 */   GIM_Try, /*On fail goto*//*Label 20171*/ GIMT_Encode4(1427764), // Rule ID 3238 //
     /* 1427672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1427683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1427686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1427689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1427695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427722 */     // MIs[1] Operand 1
     /* 1427722 */     // No operand predicates
     /* 1427722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427726 */     // MIs[0] policy
     /* 1427726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427738 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427763 */     // GIR_Coverage, 3238,
     /* 1427763 */     GIR_EraseRootFromParent_Done,
     /* 1427764 */   // Label 20171: @1427764
     /* 1427764 */   GIM_Try, /*On fail goto*//*Label 20172*/ GIMT_Encode4(1427861), // Rule ID 3239 //
     /* 1427769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1427772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1427780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1427783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1427786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1427792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427819 */     // MIs[1] Operand 1
     /* 1427819 */     // No operand predicates
     /* 1427819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427823 */     // MIs[0] policy
     /* 1427823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427835 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427860 */     // GIR_Coverage, 3239,
     /* 1427860 */     GIR_EraseRootFromParent_Done,
     /* 1427861 */   // Label 20172: @1427861
     /* 1427861 */   GIM_Try, /*On fail goto*//*Label 20173*/ GIMT_Encode4(1427958), // Rule ID 3506 //
     /* 1427866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1427877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1427880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1427883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1427889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427916 */     // MIs[1] Operand 1
     /* 1427916 */     // No operand predicates
     /* 1427916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427920 */     // MIs[0] policy
     /* 1427920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427932 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1427935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427957 */     // GIR_Coverage, 3506,
     /* 1427957 */     GIR_EraseRootFromParent_Done,
     /* 1427958 */   // Label 20173: @1427958
     /* 1427958 */   GIM_Try, /*On fail goto*//*Label 20174*/ GIMT_Encode4(1428055), // Rule ID 3507 //
     /* 1427963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1427974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1427977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1427980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1427986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428013 */     // MIs[1] Operand 1
     /* 1428013 */     // No operand predicates
     /* 1428013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428017 */     // MIs[0] policy
     /* 1428017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428029 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1428032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428054 */     // GIR_Coverage, 3507,
     /* 1428054 */     GIR_EraseRootFromParent_Done,
     /* 1428055 */   // Label 20174: @1428055
     /* 1428055 */   GIM_Try, /*On fail goto*//*Label 20175*/ GIMT_Encode4(1428152), // Rule ID 3510 //
     /* 1428060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1428071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1428074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1428077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428110 */     // MIs[1] Operand 1
     /* 1428110 */     // No operand predicates
     /* 1428110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428114 */     // MIs[0] policy
     /* 1428114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428126 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428151 */     // GIR_Coverage, 3510,
     /* 1428151 */     GIR_EraseRootFromParent_Done,
     /* 1428152 */   // Label 20175: @1428152
     /* 1428152 */   GIM_Try, /*On fail goto*//*Label 20176*/ GIMT_Encode4(1428249), // Rule ID 3511 //
     /* 1428157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1428168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1428171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1428174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428207 */     // MIs[1] Operand 1
     /* 1428207 */     // No operand predicates
     /* 1428207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428211 */     // MIs[0] policy
     /* 1428211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428223 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428248 */     // GIR_Coverage, 3511,
     /* 1428248 */     GIR_EraseRootFromParent_Done,
     /* 1428249 */   // Label 20176: @1428249
     /* 1428249 */   GIM_Try, /*On fail goto*//*Label 20177*/ GIMT_Encode4(1428346), // Rule ID 3514 //
     /* 1428254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1428265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1428268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1428271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428304 */     // MIs[1] Operand 1
     /* 1428304 */     // No operand predicates
     /* 1428304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428308 */     // MIs[0] policy
     /* 1428308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428320 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428345 */     // GIR_Coverage, 3514,
     /* 1428345 */     GIR_EraseRootFromParent_Done,
     /* 1428346 */   // Label 20177: @1428346
     /* 1428346 */   GIM_Try, /*On fail goto*//*Label 20178*/ GIMT_Encode4(1428443), // Rule ID 3515 //
     /* 1428351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1428362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1428365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1428368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428401 */     // MIs[1] Operand 1
     /* 1428401 */     // No operand predicates
     /* 1428401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428405 */     // MIs[0] policy
     /* 1428405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428417 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428442 */     // GIR_Coverage, 3515,
     /* 1428442 */     GIR_EraseRootFromParent_Done,
     /* 1428443 */   // Label 20178: @1428443
     /* 1428443 */   GIM_Try, /*On fail goto*//*Label 20179*/ GIMT_Encode4(1428540), // Rule ID 3518 //
     /* 1428448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1428459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1428462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1428465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428498 */     // MIs[1] Operand 1
     /* 1428498 */     // No operand predicates
     /* 1428498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428502 */     // MIs[0] policy
     /* 1428502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428514 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428539 */     // GIR_Coverage, 3518,
     /* 1428539 */     GIR_EraseRootFromParent_Done,
     /* 1428540 */   // Label 20179: @1428540
     /* 1428540 */   GIM_Try, /*On fail goto*//*Label 20180*/ GIMT_Encode4(1428637), // Rule ID 3519 //
     /* 1428545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1428556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1428559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1428562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428595 */     // MIs[1] Operand 1
     /* 1428595 */     // No operand predicates
     /* 1428595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428599 */     // MIs[0] policy
     /* 1428599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428611 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428636 */     // GIR_Coverage, 3519,
     /* 1428636 */     GIR_EraseRootFromParent_Done,
     /* 1428637 */   // Label 20180: @1428637
     /* 1428637 */   GIM_Try, /*On fail goto*//*Label 20181*/ GIMT_Encode4(1428734), // Rule ID 3522 //
     /* 1428642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1428653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1428656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1428659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428692 */     // MIs[1] Operand 1
     /* 1428692 */     // No operand predicates
     /* 1428692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428696 */     // MIs[0] policy
     /* 1428696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428708 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428733 */     // GIR_Coverage, 3522,
     /* 1428733 */     GIR_EraseRootFromParent_Done,
     /* 1428734 */   // Label 20181: @1428734
     /* 1428734 */   GIM_Try, /*On fail goto*//*Label 20182*/ GIMT_Encode4(1428831), // Rule ID 3523 //
     /* 1428739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1428750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1428753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1428756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428789 */     // MIs[1] Operand 1
     /* 1428789 */     // No operand predicates
     /* 1428789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428793 */     // MIs[0] policy
     /* 1428793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428805 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428830 */     // GIR_Coverage, 3523,
     /* 1428830 */     GIR_EraseRootFromParent_Done,
     /* 1428831 */   // Label 20182: @1428831
     /* 1428831 */   GIM_Try, /*On fail goto*//*Label 20183*/ GIMT_Encode4(1428928), // Rule ID 3526 //
     /* 1428836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1428847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1428850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1428853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428886 */     // MIs[1] Operand 1
     /* 1428886 */     // No operand predicates
     /* 1428886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428890 */     // MIs[0] policy
     /* 1428890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428902 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1428924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428927 */     // GIR_Coverage, 3526,
     /* 1428927 */     GIR_EraseRootFromParent_Done,
     /* 1428928 */   // Label 20183: @1428928
     /* 1428928 */   GIM_Try, /*On fail goto*//*Label 20184*/ GIMT_Encode4(1429025), // Rule ID 3527 //
     /* 1428933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1428944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1428947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1428950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428983 */     // MIs[1] Operand 1
     /* 1428983 */     // No operand predicates
     /* 1428983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428987 */     // MIs[0] policy
     /* 1428987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428999 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1429002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429024 */     // GIR_Coverage, 3527,
     /* 1429024 */     GIR_EraseRootFromParent_Done,
     /* 1429025 */   // Label 20184: @1429025
     /* 1429025 */   GIM_Try, /*On fail goto*//*Label 20185*/ GIMT_Encode4(1429122), // Rule ID 3530 //
     /* 1429030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1429041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1429044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1429047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429080 */     // MIs[1] Operand 1
     /* 1429080 */     // No operand predicates
     /* 1429080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429084 */     // MIs[0] policy
     /* 1429084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429121 */     // GIR_Coverage, 3530,
     /* 1429121 */     GIR_EraseRootFromParent_Done,
     /* 1429122 */   // Label 20185: @1429122
     /* 1429122 */   GIM_Try, /*On fail goto*//*Label 20186*/ GIMT_Encode4(1429219), // Rule ID 3531 //
     /* 1429127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1429138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1429141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1429144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429177 */     // MIs[1] Operand 1
     /* 1429177 */     // No operand predicates
     /* 1429177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429181 */     // MIs[0] policy
     /* 1429181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429193 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429218 */     // GIR_Coverage, 3531,
     /* 1429218 */     GIR_EraseRootFromParent_Done,
     /* 1429219 */   // Label 20186: @1429219
     /* 1429219 */   GIM_Try, /*On fail goto*//*Label 20187*/ GIMT_Encode4(1429316), // Rule ID 3534 //
     /* 1429224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1429235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1429238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1429241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1429247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429274 */     // MIs[1] Operand 1
     /* 1429274 */     // No operand predicates
     /* 1429274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429278 */     // MIs[0] policy
     /* 1429278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429315 */     // GIR_Coverage, 3534,
     /* 1429315 */     GIR_EraseRootFromParent_Done,
     /* 1429316 */   // Label 20187: @1429316
     /* 1429316 */   GIM_Try, /*On fail goto*//*Label 20188*/ GIMT_Encode4(1429413), // Rule ID 3535 //
     /* 1429321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1429332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1429335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1429338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1429344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429371 */     // MIs[1] Operand 1
     /* 1429371 */     // No operand predicates
     /* 1429371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429375 */     // MIs[0] policy
     /* 1429375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429387 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429412 */     // GIR_Coverage, 3535,
     /* 1429412 */     GIR_EraseRootFromParent_Done,
     /* 1429413 */   // Label 20188: @1429413
     /* 1429413 */   GIM_Try, /*On fail goto*//*Label 20189*/ GIMT_Encode4(1429510), // Rule ID 3538 //
     /* 1429418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1429429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1429432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1429435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429464 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429468 */     // MIs[1] Operand 1
     /* 1429468 */     // No operand predicates
     /* 1429468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429472 */     // MIs[0] policy
     /* 1429472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429509 */     // GIR_Coverage, 3538,
     /* 1429509 */     GIR_EraseRootFromParent_Done,
     /* 1429510 */   // Label 20189: @1429510
     /* 1429510 */   GIM_Try, /*On fail goto*//*Label 20190*/ GIMT_Encode4(1429607), // Rule ID 3539 //
     /* 1429515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1429526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1429529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1429532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429565 */     // MIs[1] Operand 1
     /* 1429565 */     // No operand predicates
     /* 1429565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429569 */     // MIs[0] policy
     /* 1429569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429581 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429606 */     // GIR_Coverage, 3539,
     /* 1429606 */     GIR_EraseRootFromParent_Done,
     /* 1429607 */   // Label 20190: @1429607
     /* 1429607 */   GIM_Try, /*On fail goto*//*Label 20191*/ GIMT_Encode4(1429704), // Rule ID 3542 //
     /* 1429612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1429615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1429623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1429626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1429629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429662 */     // MIs[1] Operand 1
     /* 1429662 */     // No operand predicates
     /* 1429662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429666 */     // MIs[0] policy
     /* 1429666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429678 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429703 */     // GIR_Coverage, 3542,
     /* 1429703 */     GIR_EraseRootFromParent_Done,
     /* 1429704 */   // Label 20191: @1429704
     /* 1429704 */   GIM_Try, /*On fail goto*//*Label 20192*/ GIMT_Encode4(1429801), // Rule ID 3543 //
     /* 1429709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1429712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1429720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1429723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1429726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429759 */     // MIs[1] Operand 1
     /* 1429759 */     // No operand predicates
     /* 1429759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429763 */     // MIs[0] policy
     /* 1429763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429775 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429800 */     // GIR_Coverage, 3543,
     /* 1429800 */     GIR_EraseRootFromParent_Done,
     /* 1429801 */   // Label 20192: @1429801
     /* 1429801 */   GIM_Try, /*On fail goto*//*Label 20193*/ GIMT_Encode4(1429898), // Rule ID 3546 //
     /* 1429806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1429817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1429820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1429823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1429829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1429836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429856 */     // MIs[1] Operand 1
     /* 1429856 */     // No operand predicates
     /* 1429856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429860 */     // MIs[0] policy
     /* 1429860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429872 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1429875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429897 */     // GIR_Coverage, 3546,
     /* 1429897 */     GIR_EraseRootFromParent_Done,
     /* 1429898 */   // Label 20193: @1429898
     /* 1429898 */   GIM_Try, /*On fail goto*//*Label 20194*/ GIMT_Encode4(1429995), // Rule ID 3547 //
     /* 1429903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1429914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1429917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1429920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1429926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1429933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429953 */     // MIs[1] Operand 1
     /* 1429953 */     // No operand predicates
     /* 1429953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429957 */     // MIs[0] policy
     /* 1429957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429969 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1429972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429994 */     // GIR_Coverage, 3547,
     /* 1429994 */     GIR_EraseRootFromParent_Done,
     /* 1429995 */   // Label 20194: @1429995
     /* 1429995 */   GIM_Try, /*On fail goto*//*Label 20195*/ GIMT_Encode4(1430092), // Rule ID 3550 //
     /* 1430000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1430011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1430014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1430017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430050 */     // MIs[1] Operand 1
     /* 1430050 */     // No operand predicates
     /* 1430050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430054 */     // MIs[0] policy
     /* 1430054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430066 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1430069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430091 */     // GIR_Coverage, 3550,
     /* 1430091 */     GIR_EraseRootFromParent_Done,
     /* 1430092 */   // Label 20195: @1430092
     /* 1430092 */   GIM_Try, /*On fail goto*//*Label 20196*/ GIMT_Encode4(1430189), // Rule ID 3551 //
     /* 1430097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1430108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1430111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1430114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430147 */     // MIs[1] Operand 1
     /* 1430147 */     // No operand predicates
     /* 1430147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430151 */     // MIs[0] policy
     /* 1430151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430163 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1430166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430188 */     // GIR_Coverage, 3551,
     /* 1430188 */     GIR_EraseRootFromParent_Done,
     /* 1430189 */   // Label 20196: @1430189
     /* 1430189 */   GIM_Try, /*On fail goto*//*Label 20197*/ GIMT_Encode4(1430286), // Rule ID 3554 //
     /* 1430194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1430205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1430208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1430211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1430217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430244 */     // MIs[1] Operand 1
     /* 1430244 */     // No operand predicates
     /* 1430244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430248 */     // MIs[0] policy
     /* 1430248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430260 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1430263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430285 */     // GIR_Coverage, 3554,
     /* 1430285 */     GIR_EraseRootFromParent_Done,
     /* 1430286 */   // Label 20197: @1430286
     /* 1430286 */   GIM_Try, /*On fail goto*//*Label 20198*/ GIMT_Encode4(1430383), // Rule ID 3555 //
     /* 1430291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1430302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1430305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1430308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1430314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430341 */     // MIs[1] Operand 1
     /* 1430341 */     // No operand predicates
     /* 1430341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430345 */     // MIs[0] policy
     /* 1430345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430357 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1430360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430382 */     // GIR_Coverage, 3555,
     /* 1430382 */     GIR_EraseRootFromParent_Done,
     /* 1430383 */   // Label 20198: @1430383
     /* 1430383 */   GIM_Try, /*On fail goto*//*Label 20199*/ GIMT_Encode4(1430480), // Rule ID 3558 //
     /* 1430388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1430399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1430402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1430405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1430411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430438 */     // MIs[1] Operand 1
     /* 1430438 */     // No operand predicates
     /* 1430438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430442 */     // MIs[0] policy
     /* 1430442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430454 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1430457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430479 */     // GIR_Coverage, 3558,
     /* 1430479 */     GIR_EraseRootFromParent_Done,
     /* 1430480 */   // Label 20199: @1430480
     /* 1430480 */   GIM_Try, /*On fail goto*//*Label 20200*/ GIMT_Encode4(1430577), // Rule ID 3559 //
     /* 1430485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1430496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1430499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1430502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1430508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430535 */     // MIs[1] Operand 1
     /* 1430535 */     // No operand predicates
     /* 1430535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430539 */     // MIs[0] policy
     /* 1430539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430551 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1430554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430576 */     // GIR_Coverage, 3559,
     /* 1430576 */     GIR_EraseRootFromParent_Done,
     /* 1430577 */   // Label 20200: @1430577
     /* 1430577 */   GIM_Try, /*On fail goto*//*Label 20201*/ GIMT_Encode4(1430674), // Rule ID 3562 //
     /* 1430582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1430593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1430596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1430599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1430605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430632 */     // MIs[1] Operand 1
     /* 1430632 */     // No operand predicates
     /* 1430632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430636 */     // MIs[0] policy
     /* 1430636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430648 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1430651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430673 */     // GIR_Coverage, 3562,
     /* 1430673 */     GIR_EraseRootFromParent_Done,
     /* 1430674 */   // Label 20201: @1430674
     /* 1430674 */   GIM_Try, /*On fail goto*//*Label 20202*/ GIMT_Encode4(1430771), // Rule ID 3563 //
     /* 1430679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1430690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1430693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1430696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1430702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430729 */     // MIs[1] Operand 1
     /* 1430729 */     // No operand predicates
     /* 1430729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430733 */     // MIs[0] policy
     /* 1430733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430745 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1430748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430770 */     // GIR_Coverage, 3563,
     /* 1430770 */     GIR_EraseRootFromParent_Done,
     /* 1430771 */   // Label 20202: @1430771
     /* 1430771 */   GIM_Try, /*On fail goto*//*Label 20203*/ GIMT_Encode4(1430868), // Rule ID 3566 //
     /* 1430776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1430787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1430790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1430793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430826 */     // MIs[1] Operand 1
     /* 1430826 */     // No operand predicates
     /* 1430826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430830 */     // MIs[0] policy
     /* 1430830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430842 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1430845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430867 */     // GIR_Coverage, 3566,
     /* 1430867 */     GIR_EraseRootFromParent_Done,
     /* 1430868 */   // Label 20203: @1430868
     /* 1430868 */   GIM_Try, /*On fail goto*//*Label 20204*/ GIMT_Encode4(1430965), // Rule ID 3567 //
     /* 1430873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1430884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1430887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1430890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430923 */     // MIs[1] Operand 1
     /* 1430923 */     // No operand predicates
     /* 1430923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430927 */     // MIs[0] policy
     /* 1430927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430939 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1430942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430964 */     // GIR_Coverage, 3567,
     /* 1430964 */     GIR_EraseRootFromParent_Done,
     /* 1430965 */   // Label 20204: @1430965
     /* 1430965 */   GIM_Try, /*On fail goto*//*Label 20205*/ GIMT_Encode4(1431062), // Rule ID 3570 //
     /* 1430970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1430981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1430984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1430987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1430993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431020 */     // MIs[1] Operand 1
     /* 1431020 */     // No operand predicates
     /* 1431020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431024 */     // MIs[0] policy
     /* 1431024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431036 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431061 */     // GIR_Coverage, 3570,
     /* 1431061 */     GIR_EraseRootFromParent_Done,
     /* 1431062 */   // Label 20205: @1431062
     /* 1431062 */   GIM_Try, /*On fail goto*//*Label 20206*/ GIMT_Encode4(1431159), // Rule ID 3571 //
     /* 1431067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1431078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1431081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1431084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431117 */     // MIs[1] Operand 1
     /* 1431117 */     // No operand predicates
     /* 1431117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431121 */     // MIs[0] policy
     /* 1431121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431133 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431158 */     // GIR_Coverage, 3571,
     /* 1431158 */     GIR_EraseRootFromParent_Done,
     /* 1431159 */   // Label 20206: @1431159
     /* 1431159 */   GIM_Try, /*On fail goto*//*Label 20207*/ GIMT_Encode4(1431256), // Rule ID 3574 //
     /* 1431164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1431175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1431178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1431181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431214 */     // MIs[1] Operand 1
     /* 1431214 */     // No operand predicates
     /* 1431214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431218 */     // MIs[0] policy
     /* 1431218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431230 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431255 */     // GIR_Coverage, 3574,
     /* 1431255 */     GIR_EraseRootFromParent_Done,
     /* 1431256 */   // Label 20207: @1431256
     /* 1431256 */   GIM_Try, /*On fail goto*//*Label 20208*/ GIMT_Encode4(1431353), // Rule ID 3575 //
     /* 1431261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1431272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1431275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1431278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431311 */     // MIs[1] Operand 1
     /* 1431311 */     // No operand predicates
     /* 1431311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431315 */     // MIs[0] policy
     /* 1431315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431327 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431352 */     // GIR_Coverage, 3575,
     /* 1431352 */     GIR_EraseRootFromParent_Done,
     /* 1431353 */   // Label 20208: @1431353
     /* 1431353 */   GIM_Try, /*On fail goto*//*Label 20209*/ GIMT_Encode4(1431450), // Rule ID 3578 //
     /* 1431358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1431369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1431372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1431375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431408 */     // MIs[1] Operand 1
     /* 1431408 */     // No operand predicates
     /* 1431408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431412 */     // MIs[0] policy
     /* 1431412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431424 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1431427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431449 */     // GIR_Coverage, 3578,
     /* 1431449 */     GIR_EraseRootFromParent_Done,
     /* 1431450 */   // Label 20209: @1431450
     /* 1431450 */   GIM_Try, /*On fail goto*//*Label 20210*/ GIMT_Encode4(1431547), // Rule ID 3579 //
     /* 1431455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1431466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1431469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1431472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431505 */     // MIs[1] Operand 1
     /* 1431505 */     // No operand predicates
     /* 1431505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431509 */     // MIs[0] policy
     /* 1431509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431521 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1431524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431546 */     // GIR_Coverage, 3579,
     /* 1431546 */     GIR_EraseRootFromParent_Done,
     /* 1431547 */   // Label 20210: @1431547
     /* 1431547 */   GIM_Try, /*On fail goto*//*Label 20211*/ GIMT_Encode4(1431644), // Rule ID 3582 //
     /* 1431552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1431555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1431563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1431566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1431569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1431575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431602 */     // MIs[1] Operand 1
     /* 1431602 */     // No operand predicates
     /* 1431602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431606 */     // MIs[0] policy
     /* 1431606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431643 */     // GIR_Coverage, 3582,
     /* 1431643 */     GIR_EraseRootFromParent_Done,
     /* 1431644 */   // Label 20211: @1431644
     /* 1431644 */   GIM_Try, /*On fail goto*//*Label 20212*/ GIMT_Encode4(1431741), // Rule ID 3583 //
     /* 1431649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1431652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1431660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1431663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1431666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1431672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431699 */     // MIs[1] Operand 1
     /* 1431699 */     // No operand predicates
     /* 1431699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431703 */     // MIs[0] policy
     /* 1431703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431715 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431740 */     // GIR_Coverage, 3583,
     /* 1431740 */     GIR_EraseRootFromParent_Done,
     /* 1431741 */   // Label 20212: @1431741
     /* 1431741 */   GIM_Try, /*On fail goto*//*Label 20213*/ GIMT_Encode4(1431838), // Rule ID 3586 //
     /* 1431746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1431749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1431757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1431760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1431763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431796 */     // MIs[1] Operand 1
     /* 1431796 */     // No operand predicates
     /* 1431796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431800 */     // MIs[0] policy
     /* 1431800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431812 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431837 */     // GIR_Coverage, 3586,
     /* 1431837 */     GIR_EraseRootFromParent_Done,
     /* 1431838 */   // Label 20213: @1431838
     /* 1431838 */   GIM_Try, /*On fail goto*//*Label 20214*/ GIMT_Encode4(1431935), // Rule ID 3587 //
     /* 1431843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1431846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1431854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1431857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1431860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431893 */     // MIs[1] Operand 1
     /* 1431893 */     // No operand predicates
     /* 1431893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431897 */     // MIs[0] policy
     /* 1431897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431909 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431934 */     // GIR_Coverage, 3587,
     /* 1431934 */     GIR_EraseRootFromParent_Done,
     /* 1431935 */   // Label 20214: @1431935
     /* 1431935 */   GIM_Try, /*On fail goto*//*Label 20215*/ GIMT_Encode4(1432032), // Rule ID 3590 //
     /* 1431940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1431943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1431951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1431954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1431957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431990 */     // MIs[1] Operand 1
     /* 1431990 */     // No operand predicates
     /* 1431990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431994 */     // MIs[0] policy
     /* 1431994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432006 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1432009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432031 */     // GIR_Coverage, 3590,
     /* 1432031 */     GIR_EraseRootFromParent_Done,
     /* 1432032 */   // Label 20215: @1432032
     /* 1432032 */   GIM_Try, /*On fail goto*//*Label 20216*/ GIMT_Encode4(1432129), // Rule ID 3591 //
     /* 1432037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1432040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1432048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1432051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1432054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1432060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432087 */     // MIs[1] Operand 1
     /* 1432087 */     // No operand predicates
     /* 1432087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432091 */     // MIs[0] policy
     /* 1432091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432103 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1432106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432128 */     // GIR_Coverage, 3591,
     /* 1432128 */     GIR_EraseRootFromParent_Done,
     /* 1432129 */   // Label 20216: @1432129
     /* 1432129 */   GIM_Try, /*On fail goto*//*Label 20217*/ GIMT_Encode4(1432226), // Rule ID 5954 //
     /* 1432134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1432145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1432148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1432151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432184 */     // MIs[1] Operand 1
     /* 1432184 */     // No operand predicates
     /* 1432184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432188 */     // MIs[0] policy
     /* 1432188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432200 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1432203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432225 */     // GIR_Coverage, 5954,
     /* 1432225 */     GIR_EraseRootFromParent_Done,
     /* 1432226 */   // Label 20217: @1432226
     /* 1432226 */   GIM_Try, /*On fail goto*//*Label 20218*/ GIMT_Encode4(1432323), // Rule ID 5955 //
     /* 1432231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1432242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1432245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1432248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432281 */     // MIs[1] Operand 1
     /* 1432281 */     // No operand predicates
     /* 1432281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432285 */     // MIs[0] policy
     /* 1432285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432297 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1432300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432322 */     // GIR_Coverage, 5955,
     /* 1432322 */     GIR_EraseRootFromParent_Done,
     /* 1432323 */   // Label 20218: @1432323
     /* 1432323 */   GIM_Try, /*On fail goto*//*Label 20219*/ GIMT_Encode4(1432420), // Rule ID 5958 //
     /* 1432328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1432339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1432342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1432345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432378 */     // MIs[1] Operand 1
     /* 1432378 */     // No operand predicates
     /* 1432378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432382 */     // MIs[0] policy
     /* 1432382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432394 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1432397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432419 */     // GIR_Coverage, 5958,
     /* 1432419 */     GIR_EraseRootFromParent_Done,
     /* 1432420 */   // Label 20219: @1432420
     /* 1432420 */   GIM_Try, /*On fail goto*//*Label 20220*/ GIMT_Encode4(1432517), // Rule ID 5959 //
     /* 1432425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1432436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1432439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1432442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432475 */     // MIs[1] Operand 1
     /* 1432475 */     // No operand predicates
     /* 1432475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432479 */     // MIs[0] policy
     /* 1432479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432491 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1432494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432516 */     // GIR_Coverage, 5959,
     /* 1432516 */     GIR_EraseRootFromParent_Done,
     /* 1432517 */   // Label 20220: @1432517
     /* 1432517 */   GIM_Try, /*On fail goto*//*Label 20221*/ GIMT_Encode4(1432614), // Rule ID 5962 //
     /* 1432522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1432533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1432536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1432539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1432545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432572 */     // MIs[1] Operand 1
     /* 1432572 */     // No operand predicates
     /* 1432572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432576 */     // MIs[0] policy
     /* 1432576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432588 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1432591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432613 */     // GIR_Coverage, 5962,
     /* 1432613 */     GIR_EraseRootFromParent_Done,
     /* 1432614 */   // Label 20221: @1432614
     /* 1432614 */   GIM_Try, /*On fail goto*//*Label 20222*/ GIMT_Encode4(1432711), // Rule ID 5963 //
     /* 1432619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1432630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1432633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1432636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1432642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432669 */     // MIs[1] Operand 1
     /* 1432669 */     // No operand predicates
     /* 1432669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432673 */     // MIs[0] policy
     /* 1432673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432685 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1432688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432710 */     // GIR_Coverage, 5963,
     /* 1432710 */     GIR_EraseRootFromParent_Done,
     /* 1432711 */   // Label 20222: @1432711
     /* 1432711 */   GIM_Try, /*On fail goto*//*Label 20223*/ GIMT_Encode4(1432808), // Rule ID 5966 //
     /* 1432716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1432727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1432730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1432733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432766 */     // MIs[1] Operand 1
     /* 1432766 */     // No operand predicates
     /* 1432766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432770 */     // MIs[0] policy
     /* 1432770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432782 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1432785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432807 */     // GIR_Coverage, 5966,
     /* 1432807 */     GIR_EraseRootFromParent_Done,
     /* 1432808 */   // Label 20223: @1432808
     /* 1432808 */   GIM_Try, /*On fail goto*//*Label 20224*/ GIMT_Encode4(1432905), // Rule ID 5967 //
     /* 1432813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1432824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1432827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1432830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432863 */     // MIs[1] Operand 1
     /* 1432863 */     // No operand predicates
     /* 1432863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432867 */     // MIs[0] policy
     /* 1432867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432879 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1432882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432904 */     // GIR_Coverage, 5967,
     /* 1432904 */     GIR_EraseRootFromParent_Done,
     /* 1432905 */   // Label 20224: @1432905
     /* 1432905 */   GIM_Try, /*On fail goto*//*Label 20225*/ GIMT_Encode4(1433002), // Rule ID 5970 //
     /* 1432910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1432921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1432924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1432927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432960 */     // MIs[1] Operand 1
     /* 1432960 */     // No operand predicates
     /* 1432960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432964 */     // MIs[0] policy
     /* 1432964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432976 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1432979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433001 */     // GIR_Coverage, 5970,
     /* 1433001 */     GIR_EraseRootFromParent_Done,
     /* 1433002 */   // Label 20225: @1433002
     /* 1433002 */   GIM_Try, /*On fail goto*//*Label 20226*/ GIMT_Encode4(1433099), // Rule ID 5971 //
     /* 1433007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1433018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1433021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1433024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433057 */     // MIs[1] Operand 1
     /* 1433057 */     // No operand predicates
     /* 1433057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433061 */     // MIs[0] policy
     /* 1433061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433073 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433098 */     // GIR_Coverage, 5971,
     /* 1433098 */     GIR_EraseRootFromParent_Done,
     /* 1433099 */   // Label 20226: @1433099
     /* 1433099 */   GIM_Try, /*On fail goto*//*Label 20227*/ GIMT_Encode4(1433196), // Rule ID 5974 //
     /* 1433104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1433115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1433118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1433121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433154 */     // MIs[1] Operand 1
     /* 1433154 */     // No operand predicates
     /* 1433154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433158 */     // MIs[0] policy
     /* 1433158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433170 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433195 */     // GIR_Coverage, 5974,
     /* 1433195 */     GIR_EraseRootFromParent_Done,
     /* 1433196 */   // Label 20227: @1433196
     /* 1433196 */   GIM_Try, /*On fail goto*//*Label 20228*/ GIMT_Encode4(1433293), // Rule ID 5975 //
     /* 1433201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1433212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1433215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1433218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433251 */     // MIs[1] Operand 1
     /* 1433251 */     // No operand predicates
     /* 1433251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433255 */     // MIs[0] policy
     /* 1433255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433267 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433292 */     // GIR_Coverage, 5975,
     /* 1433292 */     GIR_EraseRootFromParent_Done,
     /* 1433293 */   // Label 20228: @1433293
     /* 1433293 */   GIM_Try, /*On fail goto*//*Label 20229*/ GIMT_Encode4(1433390), // Rule ID 5978 //
     /* 1433298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1433309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1433312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1433315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433348 */     // MIs[1] Operand 1
     /* 1433348 */     // No operand predicates
     /* 1433348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433352 */     // MIs[0] policy
     /* 1433352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433364 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433389 */     // GIR_Coverage, 5978,
     /* 1433389 */     GIR_EraseRootFromParent_Done,
     /* 1433390 */   // Label 20229: @1433390
     /* 1433390 */   GIM_Try, /*On fail goto*//*Label 20230*/ GIMT_Encode4(1433487), // Rule ID 5979 //
     /* 1433395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1433406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1433409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1433412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433445 */     // MIs[1] Operand 1
     /* 1433445 */     // No operand predicates
     /* 1433445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433449 */     // MIs[0] policy
     /* 1433449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433461 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433486 */     // GIR_Coverage, 5979,
     /* 1433486 */     GIR_EraseRootFromParent_Done,
     /* 1433487 */   // Label 20230: @1433487
     /* 1433487 */   GIM_Try, /*On fail goto*//*Label 20231*/ GIMT_Encode4(1433584), // Rule ID 5982 //
     /* 1433492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1433503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1433506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1433509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433542 */     // MIs[1] Operand 1
     /* 1433542 */     // No operand predicates
     /* 1433542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433546 */     // MIs[0] policy
     /* 1433546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433583 */     // GIR_Coverage, 5982,
     /* 1433583 */     GIR_EraseRootFromParent_Done,
     /* 1433584 */   // Label 20231: @1433584
     /* 1433584 */   GIM_Try, /*On fail goto*//*Label 20232*/ GIMT_Encode4(1433681), // Rule ID 5983 //
     /* 1433589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1433600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1433603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1433606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433639 */     // MIs[1] Operand 1
     /* 1433639 */     // No operand predicates
     /* 1433639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433643 */     // MIs[0] policy
     /* 1433643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433655 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433680 */     // GIR_Coverage, 5983,
     /* 1433680 */     GIR_EraseRootFromParent_Done,
     /* 1433681 */   // Label 20232: @1433681
     /* 1433681 */   GIM_Try, /*On fail goto*//*Label 20233*/ GIMT_Encode4(1433778), // Rule ID 5986 //
     /* 1433686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1433697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1433700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1433703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433736 */     // MIs[1] Operand 1
     /* 1433736 */     // No operand predicates
     /* 1433736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433740 */     // MIs[0] policy
     /* 1433740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433777 */     // GIR_Coverage, 5986,
     /* 1433777 */     GIR_EraseRootFromParent_Done,
     /* 1433778 */   // Label 20233: @1433778
     /* 1433778 */   GIM_Try, /*On fail goto*//*Label 20234*/ GIMT_Encode4(1433875), // Rule ID 5987 //
     /* 1433783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1433794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1433797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1433800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433833 */     // MIs[1] Operand 1
     /* 1433833 */     // No operand predicates
     /* 1433833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433837 */     // MIs[0] policy
     /* 1433837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433849 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433874 */     // GIR_Coverage, 5987,
     /* 1433874 */     GIR_EraseRootFromParent_Done,
     /* 1433875 */   // Label 20234: @1433875
     /* 1433875 */   GIM_Try, /*On fail goto*//*Label 20235*/ GIMT_Encode4(1433972), // Rule ID 5990 //
     /* 1433880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1433883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1433891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1433894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1433897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433930 */     // MIs[1] Operand 1
     /* 1433930 */     // No operand predicates
     /* 1433930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433934 */     // MIs[0] policy
     /* 1433934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433971 */     // GIR_Coverage, 5990,
     /* 1433971 */     GIR_EraseRootFromParent_Done,
     /* 1433972 */   // Label 20235: @1433972
     /* 1433972 */   GIM_Try, /*On fail goto*//*Label 20236*/ GIMT_Encode4(1434069), // Rule ID 5991 //
     /* 1433977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1433980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1433988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1433991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1433994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1434000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434027 */     // MIs[1] Operand 1
     /* 1434027 */     // No operand predicates
     /* 1434027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434031 */     // MIs[0] policy
     /* 1434031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434043 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1434065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434068 */     // GIR_Coverage, 5991,
     /* 1434068 */     GIR_EraseRootFromParent_Done,
     /* 1434069 */   // Label 20236: @1434069
     /* 1434069 */   GIM_Try, /*On fail goto*//*Label 20237*/ GIMT_Encode4(1434166), // Rule ID 5994 //
     /* 1434074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1434085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1434088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1434091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434124 */     // MIs[1] Operand 1
     /* 1434124 */     // No operand predicates
     /* 1434124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434128 */     // MIs[0] policy
     /* 1434128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434140 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1434143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434165 */     // GIR_Coverage, 5994,
     /* 1434165 */     GIR_EraseRootFromParent_Done,
     /* 1434166 */   // Label 20237: @1434166
     /* 1434166 */   GIM_Try, /*On fail goto*//*Label 20238*/ GIMT_Encode4(1434263), // Rule ID 5995 //
     /* 1434171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1434182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1434185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1434188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434221 */     // MIs[1] Operand 1
     /* 1434221 */     // No operand predicates
     /* 1434221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434225 */     // MIs[0] policy
     /* 1434225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434237 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1434240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434262 */     // GIR_Coverage, 5995,
     /* 1434262 */     GIR_EraseRootFromParent_Done,
     /* 1434263 */   // Label 20238: @1434263
     /* 1434263 */   GIM_Try, /*On fail goto*//*Label 20239*/ GIMT_Encode4(1434360), // Rule ID 5998 //
     /* 1434268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1434279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1434282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1434285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1434291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434318 */     // MIs[1] Operand 1
     /* 1434318 */     // No operand predicates
     /* 1434318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434322 */     // MIs[0] policy
     /* 1434322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434334 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1434337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434359 */     // GIR_Coverage, 5998,
     /* 1434359 */     GIR_EraseRootFromParent_Done,
     /* 1434360 */   // Label 20239: @1434360
     /* 1434360 */   GIM_Try, /*On fail goto*//*Label 20240*/ GIMT_Encode4(1434457), // Rule ID 5999 //
     /* 1434365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1434376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1434379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1434382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1434388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434415 */     // MIs[1] Operand 1
     /* 1434415 */     // No operand predicates
     /* 1434415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434419 */     // MIs[0] policy
     /* 1434419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434431 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1434434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434456 */     // GIR_Coverage, 5999,
     /* 1434456 */     GIR_EraseRootFromParent_Done,
     /* 1434457 */   // Label 20240: @1434457
     /* 1434457 */   GIM_Try, /*On fail goto*//*Label 20241*/ GIMT_Encode4(1434554), // Rule ID 6002 //
     /* 1434462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1434473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1434476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1434479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1434485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1434492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434512 */     // MIs[1] Operand 1
     /* 1434512 */     // No operand predicates
     /* 1434512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434516 */     // MIs[0] policy
     /* 1434516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434528 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1434531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434553 */     // GIR_Coverage, 6002,
     /* 1434553 */     GIR_EraseRootFromParent_Done,
     /* 1434554 */   // Label 20241: @1434554
     /* 1434554 */   GIM_Try, /*On fail goto*//*Label 20242*/ GIMT_Encode4(1434651), // Rule ID 6003 //
     /* 1434559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1434570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1434573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1434576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1434582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1434589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434609 */     // MIs[1] Operand 1
     /* 1434609 */     // No operand predicates
     /* 1434609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434613 */     // MIs[0] policy
     /* 1434613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434625 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1434628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434650 */     // GIR_Coverage, 6003,
     /* 1434650 */     GIR_EraseRootFromParent_Done,
     /* 1434651 */   // Label 20242: @1434651
     /* 1434651 */   GIM_Try, /*On fail goto*//*Label 20243*/ GIMT_Encode4(1434748), // Rule ID 6006 //
     /* 1434656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1434667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1434670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1434673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1434679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434706 */     // MIs[1] Operand 1
     /* 1434706 */     // No operand predicates
     /* 1434706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434710 */     // MIs[0] policy
     /* 1434710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434722 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1434725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434747 */     // GIR_Coverage, 6006,
     /* 1434747 */     GIR_EraseRootFromParent_Done,
     /* 1434748 */   // Label 20243: @1434748
     /* 1434748 */   GIM_Try, /*On fail goto*//*Label 20244*/ GIMT_Encode4(1434845), // Rule ID 6007 //
     /* 1434753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1434764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1434767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1434770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1434776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434803 */     // MIs[1] Operand 1
     /* 1434803 */     // No operand predicates
     /* 1434803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434807 */     // MIs[0] policy
     /* 1434807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434819 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1434822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434844 */     // GIR_Coverage, 6007,
     /* 1434844 */     GIR_EraseRootFromParent_Done,
     /* 1434845 */   // Label 20244: @1434845
     /* 1434845 */   GIM_Try, /*On fail goto*//*Label 20245*/ GIMT_Encode4(1434942), // Rule ID 6010 //
     /* 1434850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1434861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1434864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1434867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434900 */     // MIs[1] Operand 1
     /* 1434900 */     // No operand predicates
     /* 1434900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434904 */     // MIs[0] policy
     /* 1434904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434916 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1434919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434941 */     // GIR_Coverage, 6010,
     /* 1434941 */     GIR_EraseRootFromParent_Done,
     /* 1434942 */   // Label 20245: @1434942
     /* 1434942 */   GIM_Try, /*On fail goto*//*Label 20246*/ GIMT_Encode4(1435039), // Rule ID 6011 //
     /* 1434947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1434958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1434961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1434964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434997 */     // MIs[1] Operand 1
     /* 1434997 */     // No operand predicates
     /* 1434997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435001 */     // MIs[0] policy
     /* 1435001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435013 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1435016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435038 */     // GIR_Coverage, 6011,
     /* 1435038 */     GIR_EraseRootFromParent_Done,
     /* 1435039 */   // Label 20246: @1435039
     /* 1435039 */   GIM_Try, /*On fail goto*//*Label 20247*/ GIMT_Encode4(1435136), // Rule ID 6014 //
     /* 1435044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1435055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1435058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1435061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1435067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435094 */     // MIs[1] Operand 1
     /* 1435094 */     // No operand predicates
     /* 1435094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435098 */     // MIs[0] policy
     /* 1435098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435110 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435135 */     // GIR_Coverage, 6014,
     /* 1435135 */     GIR_EraseRootFromParent_Done,
     /* 1435136 */   // Label 20247: @1435136
     /* 1435136 */   GIM_Try, /*On fail goto*//*Label 20248*/ GIMT_Encode4(1435233), // Rule ID 6015 //
     /* 1435141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1435152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1435155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1435158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1435164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435191 */     // MIs[1] Operand 1
     /* 1435191 */     // No operand predicates
     /* 1435191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435195 */     // MIs[0] policy
     /* 1435195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435207 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435232 */     // GIR_Coverage, 6015,
     /* 1435232 */     GIR_EraseRootFromParent_Done,
     /* 1435233 */   // Label 20248: @1435233
     /* 1435233 */   GIM_Try, /*On fail goto*//*Label 20249*/ GIMT_Encode4(1435330), // Rule ID 6018 //
     /* 1435238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1435249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1435252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1435255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435288 */     // MIs[1] Operand 1
     /* 1435288 */     // No operand predicates
     /* 1435288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435292 */     // MIs[0] policy
     /* 1435292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435304 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435329 */     // GIR_Coverage, 6018,
     /* 1435329 */     GIR_EraseRootFromParent_Done,
     /* 1435330 */   // Label 20249: @1435330
     /* 1435330 */   GIM_Try, /*On fail goto*//*Label 20250*/ GIMT_Encode4(1435427), // Rule ID 6019 //
     /* 1435335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1435346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1435349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1435352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435385 */     // MIs[1] Operand 1
     /* 1435385 */     // No operand predicates
     /* 1435385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435389 */     // MIs[0] policy
     /* 1435389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435426 */     // GIR_Coverage, 6019,
     /* 1435426 */     GIR_EraseRootFromParent_Done,
     /* 1435427 */   // Label 20250: @1435427
     /* 1435427 */   GIM_Try, /*On fail goto*//*Label 20251*/ GIMT_Encode4(1435524), // Rule ID 6022 //
     /* 1435432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1435443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1435446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1435449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435482 */     // MIs[1] Operand 1
     /* 1435482 */     // No operand predicates
     /* 1435482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435486 */     // MIs[0] policy
     /* 1435486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435498 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1435501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435523 */     // GIR_Coverage, 6022,
     /* 1435523 */     GIR_EraseRootFromParent_Done,
     /* 1435524 */   // Label 20251: @1435524
     /* 1435524 */   GIM_Try, /*On fail goto*//*Label 20252*/ GIMT_Encode4(1435621), // Rule ID 6023 //
     /* 1435529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1435540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1435543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1435546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435579 */     // MIs[1] Operand 1
     /* 1435579 */     // No operand predicates
     /* 1435579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435583 */     // MIs[0] policy
     /* 1435583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435595 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1435598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435620 */     // GIR_Coverage, 6023,
     /* 1435620 */     GIR_EraseRootFromParent_Done,
     /* 1435621 */   // Label 20252: @1435621
     /* 1435621 */   GIM_Try, /*On fail goto*//*Label 20253*/ GIMT_Encode4(1435718), // Rule ID 6026 //
     /* 1435626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1435637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1435640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1435643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1435649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435676 */     // MIs[1] Operand 1
     /* 1435676 */     // No operand predicates
     /* 1435676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435680 */     // MIs[0] policy
     /* 1435680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435717 */     // GIR_Coverage, 6026,
     /* 1435717 */     GIR_EraseRootFromParent_Done,
     /* 1435718 */   // Label 20253: @1435718
     /* 1435718 */   GIM_Try, /*On fail goto*//*Label 20254*/ GIMT_Encode4(1435815), // Rule ID 6027 //
     /* 1435723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1435734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1435737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1435740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1435746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435773 */     // MIs[1] Operand 1
     /* 1435773 */     // No operand predicates
     /* 1435773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435777 */     // MIs[0] policy
     /* 1435777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435789 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435814 */     // GIR_Coverage, 6027,
     /* 1435814 */     GIR_EraseRootFromParent_Done,
     /* 1435815 */   // Label 20254: @1435815
     /* 1435815 */   GIM_Try, /*On fail goto*//*Label 20255*/ GIMT_Encode4(1435912), // Rule ID 6030 //
     /* 1435820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1435823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1435831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1435834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1435837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1435843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435870 */     // MIs[1] Operand 1
     /* 1435870 */     // No operand predicates
     /* 1435870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435874 */     // MIs[0] policy
     /* 1435874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435911 */     // GIR_Coverage, 6030,
     /* 1435911 */     GIR_EraseRootFromParent_Done,
     /* 1435912 */   // Label 20255: @1435912
     /* 1435912 */   GIM_Try, /*On fail goto*//*Label 20256*/ GIMT_Encode4(1436009), // Rule ID 6031 //
     /* 1435917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1435920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1435928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1435931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1435934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1435940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435967 */     // MIs[1] Operand 1
     /* 1435967 */     // No operand predicates
     /* 1435967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435971 */     // MIs[0] policy
     /* 1435971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435983 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436008 */     // GIR_Coverage, 6031,
     /* 1436008 */     GIR_EraseRootFromParent_Done,
     /* 1436009 */   // Label 20256: @1436009
     /* 1436009 */   GIM_Try, /*On fail goto*//*Label 20257*/ GIMT_Encode4(1436106), // Rule ID 6034 //
     /* 1436014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1436017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1436025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1436028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1436031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436064 */     // MIs[1] Operand 1
     /* 1436064 */     // No operand predicates
     /* 1436064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436068 */     // MIs[0] policy
     /* 1436068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436080 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1436083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436105 */     // GIR_Coverage, 6034,
     /* 1436105 */     GIR_EraseRootFromParent_Done,
     /* 1436106 */   // Label 20257: @1436106
     /* 1436106 */   GIM_Try, /*On fail goto*//*Label 20258*/ GIMT_Encode4(1436203), // Rule ID 6035 //
     /* 1436111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1436114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1436122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1436125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1436128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436161 */     // MIs[1] Operand 1
     /* 1436161 */     // No operand predicates
     /* 1436161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436165 */     // MIs[0] policy
     /* 1436165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436177 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1436180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436202 */     // GIR_Coverage, 6035,
     /* 1436202 */     GIR_EraseRootFromParent_Done,
     /* 1436203 */   // Label 20258: @1436203
     /* 1436203 */   GIM_Try, /*On fail goto*//*Label 20259*/ GIMT_Encode4(1436300), // Rule ID 6038 //
     /* 1436208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1436211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1436219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1436222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1436225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436258 */     // MIs[1] Operand 1
     /* 1436258 */     // No operand predicates
     /* 1436258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436262 */     // MIs[0] policy
     /* 1436262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436274 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1436277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436299 */     // GIR_Coverage, 6038,
     /* 1436299 */     GIR_EraseRootFromParent_Done,
     /* 1436300 */   // Label 20259: @1436300
     /* 1436300 */   GIM_Try, /*On fail goto*//*Label 20260*/ GIMT_Encode4(1436397), // Rule ID 6039 //
     /* 1436305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1436308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1436316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1436319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1436322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436355 */     // MIs[1] Operand 1
     /* 1436355 */     // No operand predicates
     /* 1436355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436359 */     // MIs[0] policy
     /* 1436359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436371 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1436374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436396 */     // GIR_Coverage, 6039,
     /* 1436396 */     GIR_EraseRootFromParent_Done,
     /* 1436397 */   // Label 20260: @1436397
     /* 1436397 */   GIM_Try, /*On fail goto*//*Label 20261*/ GIMT_Encode4(1436494), // Rule ID 6218 //
     /* 1436402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1436413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1436416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1436419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436452 */     // MIs[1] Operand 1
     /* 1436452 */     // No operand predicates
     /* 1436452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436456 */     // MIs[0] policy
     /* 1436456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436468 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1436471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436493 */     // GIR_Coverage, 6218,
     /* 1436493 */     GIR_EraseRootFromParent_Done,
     /* 1436494 */   // Label 20261: @1436494
     /* 1436494 */   GIM_Try, /*On fail goto*//*Label 20262*/ GIMT_Encode4(1436591), // Rule ID 6219 //
     /* 1436499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1436510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1436513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1436516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436549 */     // MIs[1] Operand 1
     /* 1436549 */     // No operand predicates
     /* 1436549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436553 */     // MIs[0] policy
     /* 1436553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436565 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1436568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436590 */     // GIR_Coverage, 6219,
     /* 1436590 */     GIR_EraseRootFromParent_Done,
     /* 1436591 */   // Label 20262: @1436591
     /* 1436591 */   GIM_Try, /*On fail goto*//*Label 20263*/ GIMT_Encode4(1436688), // Rule ID 6222 //
     /* 1436596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1436607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1436610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1436613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1436619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436646 */     // MIs[1] Operand 1
     /* 1436646 */     // No operand predicates
     /* 1436646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436650 */     // MIs[0] policy
     /* 1436650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436662 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1436665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436687 */     // GIR_Coverage, 6222,
     /* 1436687 */     GIR_EraseRootFromParent_Done,
     /* 1436688 */   // Label 20263: @1436688
     /* 1436688 */   GIM_Try, /*On fail goto*//*Label 20264*/ GIMT_Encode4(1436785), // Rule ID 6223 //
     /* 1436693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1436704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1436707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1436710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1436716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436743 */     // MIs[1] Operand 1
     /* 1436743 */     // No operand predicates
     /* 1436743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436747 */     // MIs[0] policy
     /* 1436747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436759 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1436762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436784 */     // GIR_Coverage, 6223,
     /* 1436784 */     GIR_EraseRootFromParent_Done,
     /* 1436785 */   // Label 20264: @1436785
     /* 1436785 */   GIM_Try, /*On fail goto*//*Label 20265*/ GIMT_Encode4(1436882), // Rule ID 6226 //
     /* 1436790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1436801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1436804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1436807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436840 */     // MIs[1] Operand 1
     /* 1436840 */     // No operand predicates
     /* 1436840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436844 */     // MIs[0] policy
     /* 1436844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436856 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1436859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436881 */     // GIR_Coverage, 6226,
     /* 1436881 */     GIR_EraseRootFromParent_Done,
     /* 1436882 */   // Label 20265: @1436882
     /* 1436882 */   GIM_Try, /*On fail goto*//*Label 20266*/ GIMT_Encode4(1436979), // Rule ID 6227 //
     /* 1436887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1436898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1436901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1436904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436937 */     // MIs[1] Operand 1
     /* 1436937 */     // No operand predicates
     /* 1436937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436941 */     // MIs[0] policy
     /* 1436941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436953 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1436956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436978 */     // GIR_Coverage, 6227,
     /* 1436978 */     GIR_EraseRootFromParent_Done,
     /* 1436979 */   // Label 20266: @1436979
     /* 1436979 */   GIM_Try, /*On fail goto*//*Label 20267*/ GIMT_Encode4(1437076), // Rule ID 6230 //
     /* 1436984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1436995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1436998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1437001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437034 */     // MIs[1] Operand 1
     /* 1437034 */     // No operand predicates
     /* 1437034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437038 */     // MIs[0] policy
     /* 1437038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437050 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1437053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437075 */     // GIR_Coverage, 6230,
     /* 1437075 */     GIR_EraseRootFromParent_Done,
     /* 1437076 */   // Label 20267: @1437076
     /* 1437076 */   GIM_Try, /*On fail goto*//*Label 20268*/ GIMT_Encode4(1437173), // Rule ID 6231 //
     /* 1437081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1437092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1437095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1437098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437131 */     // MIs[1] Operand 1
     /* 1437131 */     // No operand predicates
     /* 1437131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437135 */     // MIs[0] policy
     /* 1437135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437147 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1437150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437172 */     // GIR_Coverage, 6231,
     /* 1437172 */     GIR_EraseRootFromParent_Done,
     /* 1437173 */   // Label 20268: @1437173
     /* 1437173 */   GIM_Try, /*On fail goto*//*Label 20269*/ GIMT_Encode4(1437270), // Rule ID 6234 //
     /* 1437178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1437189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1437192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1437195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437228 */     // MIs[1] Operand 1
     /* 1437228 */     // No operand predicates
     /* 1437228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437232 */     // MIs[0] policy
     /* 1437232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437244 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437269 */     // GIR_Coverage, 6234,
     /* 1437269 */     GIR_EraseRootFromParent_Done,
     /* 1437270 */   // Label 20269: @1437270
     /* 1437270 */   GIM_Try, /*On fail goto*//*Label 20270*/ GIMT_Encode4(1437367), // Rule ID 6235 //
     /* 1437275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1437286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1437289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1437292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437325 */     // MIs[1] Operand 1
     /* 1437325 */     // No operand predicates
     /* 1437325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437329 */     // MIs[0] policy
     /* 1437329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437341 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437366 */     // GIR_Coverage, 6235,
     /* 1437366 */     GIR_EraseRootFromParent_Done,
     /* 1437367 */   // Label 20270: @1437367
     /* 1437367 */   GIM_Try, /*On fail goto*//*Label 20271*/ GIMT_Encode4(1437464), // Rule ID 6238 //
     /* 1437372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1437383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1437386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1437389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437422 */     // MIs[1] Operand 1
     /* 1437422 */     // No operand predicates
     /* 1437422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437426 */     // MIs[0] policy
     /* 1437426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437438 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437463 */     // GIR_Coverage, 6238,
     /* 1437463 */     GIR_EraseRootFromParent_Done,
     /* 1437464 */   // Label 20271: @1437464
     /* 1437464 */   GIM_Try, /*On fail goto*//*Label 20272*/ GIMT_Encode4(1437561), // Rule ID 6239 //
     /* 1437469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1437480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1437483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1437486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437519 */     // MIs[1] Operand 1
     /* 1437519 */     // No operand predicates
     /* 1437519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437523 */     // MIs[0] policy
     /* 1437523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437535 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437560 */     // GIR_Coverage, 6239,
     /* 1437560 */     GIR_EraseRootFromParent_Done,
     /* 1437561 */   // Label 20272: @1437561
     /* 1437561 */   GIM_Try, /*On fail goto*//*Label 20273*/ GIMT_Encode4(1437658), // Rule ID 6242 //
     /* 1437566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1437577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1437580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1437583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1437589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437616 */     // MIs[1] Operand 1
     /* 1437616 */     // No operand predicates
     /* 1437616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437620 */     // MIs[0] policy
     /* 1437620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437632 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1437635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437657 */     // GIR_Coverage, 6242,
     /* 1437657 */     GIR_EraseRootFromParent_Done,
     /* 1437658 */   // Label 20273: @1437658
     /* 1437658 */   GIM_Try, /*On fail goto*//*Label 20274*/ GIMT_Encode4(1437755), // Rule ID 6243 //
     /* 1437663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1437674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1437677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1437680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1437686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437713 */     // MIs[1] Operand 1
     /* 1437713 */     // No operand predicates
     /* 1437713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437717 */     // MIs[0] policy
     /* 1437717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437729 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1437732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437754 */     // GIR_Coverage, 6243,
     /* 1437754 */     GIR_EraseRootFromParent_Done,
     /* 1437755 */   // Label 20274: @1437755
     /* 1437755 */   GIM_Try, /*On fail goto*//*Label 20275*/ GIMT_Encode4(1437852), // Rule ID 6246 //
     /* 1437760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1437771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1437774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1437777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437810 */     // MIs[1] Operand 1
     /* 1437810 */     // No operand predicates
     /* 1437810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437814 */     // MIs[0] policy
     /* 1437814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437826 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1437829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437851 */     // GIR_Coverage, 6246,
     /* 1437851 */     GIR_EraseRootFromParent_Done,
     /* 1437852 */   // Label 20275: @1437852
     /* 1437852 */   GIM_Try, /*On fail goto*//*Label 20276*/ GIMT_Encode4(1437949), // Rule ID 6247 //
     /* 1437857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1437868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1437871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1437874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437907 */     // MIs[1] Operand 1
     /* 1437907 */     // No operand predicates
     /* 1437907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437911 */     // MIs[0] policy
     /* 1437911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437923 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1437926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437948 */     // GIR_Coverage, 6247,
     /* 1437948 */     GIR_EraseRootFromParent_Done,
     /* 1437949 */   // Label 20276: @1437949
     /* 1437949 */   GIM_Try, /*On fail goto*//*Label 20277*/ GIMT_Encode4(1438046), // Rule ID 6250 //
     /* 1437954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1437965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1437968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1437971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438004 */     // MIs[1] Operand 1
     /* 1438004 */     // No operand predicates
     /* 1438004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438008 */     // MIs[0] policy
     /* 1438008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438045 */     // GIR_Coverage, 6250,
     /* 1438045 */     GIR_EraseRootFromParent_Done,
     /* 1438046 */   // Label 20277: @1438046
     /* 1438046 */   GIM_Try, /*On fail goto*//*Label 20278*/ GIMT_Encode4(1438143), // Rule ID 6251 //
     /* 1438051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1438062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1438065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1438068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1438074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438101 */     // MIs[1] Operand 1
     /* 1438101 */     // No operand predicates
     /* 1438101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438105 */     // MIs[0] policy
     /* 1438105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438117 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438142 */     // GIR_Coverage, 6251,
     /* 1438142 */     GIR_EraseRootFromParent_Done,
     /* 1438143 */   // Label 20278: @1438143
     /* 1438143 */   GIM_Try, /*On fail goto*//*Label 20279*/ GIMT_Encode4(1438240), // Rule ID 6254 //
     /* 1438148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1438151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1438159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1438162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1438165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1438171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438198 */     // MIs[1] Operand 1
     /* 1438198 */     // No operand predicates
     /* 1438198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438202 */     // MIs[0] policy
     /* 1438202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438214 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438239 */     // GIR_Coverage, 6254,
     /* 1438239 */     GIR_EraseRootFromParent_Done,
     /* 1438240 */   // Label 20279: @1438240
     /* 1438240 */   GIM_Try, /*On fail goto*//*Label 20280*/ GIMT_Encode4(1438337), // Rule ID 6255 //
     /* 1438245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1438248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1438256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1438259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1438262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1438268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438295 */     // MIs[1] Operand 1
     /* 1438295 */     // No operand predicates
     /* 1438295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438299 */     // MIs[0] policy
     /* 1438299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438311 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438336 */     // GIR_Coverage, 6255,
     /* 1438336 */     GIR_EraseRootFromParent_Done,
     /* 1438337 */   // Label 20280: @1438337
     /* 1438337 */   GIM_Try, /*On fail goto*//*Label 20281*/ GIMT_Encode4(1438434), // Rule ID 6258 //
     /* 1438342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1438353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1438356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1438359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1438365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1438372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438392 */     // MIs[1] Operand 1
     /* 1438392 */     // No operand predicates
     /* 1438392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438396 */     // MIs[0] policy
     /* 1438396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438408 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1438411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438433 */     // GIR_Coverage, 6258,
     /* 1438433 */     GIR_EraseRootFromParent_Done,
     /* 1438434 */   // Label 20281: @1438434
     /* 1438434 */   GIM_Try, /*On fail goto*//*Label 20282*/ GIMT_Encode4(1438531), // Rule ID 6259 //
     /* 1438439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1438450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1438453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1438456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1438462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1438469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438489 */     // MIs[1] Operand 1
     /* 1438489 */     // No operand predicates
     /* 1438489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438493 */     // MIs[0] policy
     /* 1438493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438505 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1438508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438530 */     // GIR_Coverage, 6259,
     /* 1438530 */     GIR_EraseRootFromParent_Done,
     /* 1438531 */   // Label 20282: @1438531
     /* 1438531 */   GIM_Try, /*On fail goto*//*Label 20283*/ GIMT_Encode4(1438628), // Rule ID 6262 //
     /* 1438536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1438547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1438550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1438553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1438559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1438566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438586 */     // MIs[1] Operand 1
     /* 1438586 */     // No operand predicates
     /* 1438586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438590 */     // MIs[0] policy
     /* 1438590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438602 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1438605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438627 */     // GIR_Coverage, 6262,
     /* 1438627 */     GIR_EraseRootFromParent_Done,
     /* 1438628 */   // Label 20283: @1438628
     /* 1438628 */   GIM_Try, /*On fail goto*//*Label 20284*/ GIMT_Encode4(1438725), // Rule ID 6263 //
     /* 1438633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1438644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1438647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1438650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1438656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1438663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438683 */     // MIs[1] Operand 1
     /* 1438683 */     // No operand predicates
     /* 1438683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438687 */     // MIs[0] policy
     /* 1438687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438699 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1438702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438724 */     // GIR_Coverage, 6263,
     /* 1438724 */     GIR_EraseRootFromParent_Done,
     /* 1438725 */   // Label 20284: @1438725
     /* 1438725 */   GIM_Try, /*On fail goto*//*Label 20285*/ GIMT_Encode4(1438822), // Rule ID 6266 //
     /* 1438730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1438741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1438744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1438747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1438753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1438760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438780 */     // MIs[1] Operand 1
     /* 1438780 */     // No operand predicates
     /* 1438780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438784 */     // MIs[0] policy
     /* 1438784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438796 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1438799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438821 */     // GIR_Coverage, 6266,
     /* 1438821 */     GIR_EraseRootFromParent_Done,
     /* 1438822 */   // Label 20285: @1438822
     /* 1438822 */   GIM_Try, /*On fail goto*//*Label 20286*/ GIMT_Encode4(1438919), // Rule ID 6267 //
     /* 1438827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1438838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1438841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1438844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1438850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1438857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438877 */     // MIs[1] Operand 1
     /* 1438877 */     // No operand predicates
     /* 1438877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438881 */     // MIs[0] policy
     /* 1438881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438893 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1438896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438918 */     // GIR_Coverage, 6267,
     /* 1438918 */     GIR_EraseRootFromParent_Done,
     /* 1438919 */   // Label 20286: @1438919
     /* 1438919 */   GIM_Try, /*On fail goto*//*Label 20287*/ GIMT_Encode4(1439016), // Rule ID 6270 //
     /* 1438924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1438935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1438938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1438941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1438947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1438954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438974 */     // MIs[1] Operand 1
     /* 1438974 */     // No operand predicates
     /* 1438974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438978 */     // MIs[0] policy
     /* 1438978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438990 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1438993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439015 */     // GIR_Coverage, 6270,
     /* 1439015 */     GIR_EraseRootFromParent_Done,
     /* 1439016 */   // Label 20287: @1439016
     /* 1439016 */   GIM_Try, /*On fail goto*//*Label 20288*/ GIMT_Encode4(1439113), // Rule ID 6271 //
     /* 1439021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1439032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1439035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1439038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439071 */     // MIs[1] Operand 1
     /* 1439071 */     // No operand predicates
     /* 1439071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439075 */     // MIs[0] policy
     /* 1439075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439087 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1439090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439112 */     // GIR_Coverage, 6271,
     /* 1439112 */     GIR_EraseRootFromParent_Done,
     /* 1439113 */   // Label 20288: @1439113
     /* 1439113 */   GIM_Try, /*On fail goto*//*Label 20289*/ GIMT_Encode4(1439210), // Rule ID 6274 //
     /* 1439118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1439129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1439132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1439135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1439141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439168 */     // MIs[1] Operand 1
     /* 1439168 */     // No operand predicates
     /* 1439168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439172 */     // MIs[0] policy
     /* 1439172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439184 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439209 */     // GIR_Coverage, 6274,
     /* 1439209 */     GIR_EraseRootFromParent_Done,
     /* 1439210 */   // Label 20289: @1439210
     /* 1439210 */   GIM_Try, /*On fail goto*//*Label 20290*/ GIMT_Encode4(1439307), // Rule ID 6275 //
     /* 1439215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1439226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1439229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1439232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1439238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439265 */     // MIs[1] Operand 1
     /* 1439265 */     // No operand predicates
     /* 1439265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439269 */     // MIs[0] policy
     /* 1439269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439281 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439306 */     // GIR_Coverage, 6275,
     /* 1439306 */     GIR_EraseRootFromParent_Done,
     /* 1439307 */   // Label 20290: @1439307
     /* 1439307 */   GIM_Try, /*On fail goto*//*Label 20291*/ GIMT_Encode4(1439404), // Rule ID 6278 //
     /* 1439312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1439323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1439326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1439329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1439335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439362 */     // MIs[1] Operand 1
     /* 1439362 */     // No operand predicates
     /* 1439362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439366 */     // MIs[0] policy
     /* 1439366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439378 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439403 */     // GIR_Coverage, 6278,
     /* 1439403 */     GIR_EraseRootFromParent_Done,
     /* 1439404 */   // Label 20291: @1439404
     /* 1439404 */   GIM_Try, /*On fail goto*//*Label 20292*/ GIMT_Encode4(1439501), // Rule ID 6279 //
     /* 1439409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1439420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1439423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1439426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1439432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439459 */     // MIs[1] Operand 1
     /* 1439459 */     // No operand predicates
     /* 1439459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439463 */     // MIs[0] policy
     /* 1439463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439475 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439500 */     // GIR_Coverage, 6279,
     /* 1439500 */     GIR_EraseRootFromParent_Done,
     /* 1439501 */   // Label 20292: @1439501
     /* 1439501 */   GIM_Try, /*On fail goto*//*Label 20293*/ GIMT_Encode4(1439598), // Rule ID 6282 //
     /* 1439506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1439517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1439520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1439523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439556 */     // MIs[1] Operand 1
     /* 1439556 */     // No operand predicates
     /* 1439556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439560 */     // MIs[0] policy
     /* 1439560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1439575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439597 */     // GIR_Coverage, 6282,
     /* 1439597 */     GIR_EraseRootFromParent_Done,
     /* 1439598 */   // Label 20293: @1439598
     /* 1439598 */   GIM_Try, /*On fail goto*//*Label 20294*/ GIMT_Encode4(1439695), // Rule ID 6283 //
     /* 1439603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1439614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1439617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1439620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439653 */     // MIs[1] Operand 1
     /* 1439653 */     // No operand predicates
     /* 1439653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439657 */     // MIs[0] policy
     /* 1439657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439669 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1439672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439694 */     // GIR_Coverage, 6283,
     /* 1439694 */     GIR_EraseRootFromParent_Done,
     /* 1439695 */   // Label 20294: @1439695
     /* 1439695 */   GIM_Try, /*On fail goto*//*Label 20295*/ GIMT_Encode4(1439792), // Rule ID 6286 //
     /* 1439700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1439711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1439714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1439717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439750 */     // MIs[1] Operand 1
     /* 1439750 */     // No operand predicates
     /* 1439750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439754 */     // MIs[0] policy
     /* 1439754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439791 */     // GIR_Coverage, 6286,
     /* 1439791 */     GIR_EraseRootFromParent_Done,
     /* 1439792 */   // Label 20295: @1439792
     /* 1439792 */   GIM_Try, /*On fail goto*//*Label 20296*/ GIMT_Encode4(1439889), // Rule ID 6287 //
     /* 1439797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1439808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1439811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1439814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439847 */     // MIs[1] Operand 1
     /* 1439847 */     // No operand predicates
     /* 1439847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439851 */     // MIs[0] policy
     /* 1439851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439863 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439888 */     // GIR_Coverage, 6287,
     /* 1439888 */     GIR_EraseRootFromParent_Done,
     /* 1439889 */   // Label 20296: @1439889
     /* 1439889 */   GIM_Try, /*On fail goto*//*Label 20297*/ GIMT_Encode4(1439986), // Rule ID 6290 //
     /* 1439894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1439905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1439908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1439911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1439917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439944 */     // MIs[1] Operand 1
     /* 1439944 */     // No operand predicates
     /* 1439944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439948 */     // MIs[0] policy
     /* 1439948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439985 */     // GIR_Coverage, 6290,
     /* 1439985 */     GIR_EraseRootFromParent_Done,
     /* 1439986 */   // Label 20297: @1439986
     /* 1439986 */   GIM_Try, /*On fail goto*//*Label 20298*/ GIMT_Encode4(1440083), // Rule ID 6291 //
     /* 1439991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1440002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1440005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1440008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1440014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440041 */     // MIs[1] Operand 1
     /* 1440041 */     // No operand predicates
     /* 1440041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440045 */     // MIs[0] policy
     /* 1440045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440057 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1440060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440082 */     // GIR_Coverage, 6291,
     /* 1440082 */     GIR_EraseRootFromParent_Done,
     /* 1440083 */   // Label 20298: @1440083
     /* 1440083 */   GIM_Try, /*On fail goto*//*Label 20299*/ GIMT_Encode4(1440180), // Rule ID 6294 //
     /* 1440088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1440099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1440102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1440105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440138 */     // MIs[1] Operand 1
     /* 1440138 */     // No operand predicates
     /* 1440138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440142 */     // MIs[0] policy
     /* 1440142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440154 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1440157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440179 */     // GIR_Coverage, 6294,
     /* 1440179 */     GIR_EraseRootFromParent_Done,
     /* 1440180 */   // Label 20299: @1440180
     /* 1440180 */   GIM_Try, /*On fail goto*//*Label 20300*/ GIMT_Encode4(1440277), // Rule ID 6295 //
     /* 1440185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1440188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1440196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1440199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1440202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440235 */     // MIs[1] Operand 1
     /* 1440235 */     // No operand predicates
     /* 1440235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440239 */     // MIs[0] policy
     /* 1440239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440251 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1440254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440276 */     // GIR_Coverage, 6295,
     /* 1440276 */     GIR_EraseRootFromParent_Done,
     /* 1440277 */   // Label 20300: @1440277
     /* 1440277 */   GIM_Try, /*On fail goto*//*Label 20301*/ GIMT_Encode4(1440374), // Rule ID 6298 //
     /* 1440282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1440293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1440296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1440299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1440305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440332 */     // MIs[1] Operand 1
     /* 1440332 */     // No operand predicates
     /* 1440332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440336 */     // MIs[0] policy
     /* 1440336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440348 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1440351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440373 */     // GIR_Coverage, 6298,
     /* 1440373 */     GIR_EraseRootFromParent_Done,
     /* 1440374 */   // Label 20301: @1440374
     /* 1440374 */   GIM_Try, /*On fail goto*//*Label 20302*/ GIMT_Encode4(1440471), // Rule ID 6299 //
     /* 1440379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1440382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1440390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1440393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1440396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1440402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440429 */     // MIs[1] Operand 1
     /* 1440429 */     // No operand predicates
     /* 1440429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440433 */     // MIs[0] policy
     /* 1440433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440445 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1440448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440470 */     // GIR_Coverage, 6299,
     /* 1440470 */     GIR_EraseRootFromParent_Done,
     /* 1440471 */   // Label 20302: @1440471
     /* 1440471 */   GIM_Try, /*On fail goto*//*Label 20303*/ GIMT_Encode4(1440568), // Rule ID 6302 //
     /* 1440476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1440487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1440490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1440493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440526 */     // MIs[1] Operand 1
     /* 1440526 */     // No operand predicates
     /* 1440526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440530 */     // MIs[0] policy
     /* 1440530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440542 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1440545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440567 */     // GIR_Coverage, 6302,
     /* 1440567 */     GIR_EraseRootFromParent_Done,
     /* 1440568 */   // Label 20303: @1440568
     /* 1440568 */   GIM_Try, /*On fail goto*//*Label 20304*/ GIMT_Encode4(1440665), // Rule ID 6303 //
     /* 1440573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1440576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1440584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1440587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1440590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440623 */     // MIs[1] Operand 1
     /* 1440623 */     // No operand predicates
     /* 1440623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440627 */     // MIs[0] policy
     /* 1440627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440639 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1440642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440664 */     // GIR_Coverage, 6303,
     /* 1440664 */     GIR_EraseRootFromParent_Done,
     /* 1440665 */   // Label 20304: @1440665
     /* 1440665 */   GIM_Try, /*On fail goto*//*Label 20305*/ GIMT_Encode4(1440762), // Rule ID 6482 //
     /* 1440670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1440681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1440684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1440687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1440693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440720 */     // MIs[1] Operand 1
     /* 1440720 */     // No operand predicates
     /* 1440720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440724 */     // MIs[0] policy
     /* 1440724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440736 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1440739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440761 */     // GIR_Coverage, 6482,
     /* 1440761 */     GIR_EraseRootFromParent_Done,
     /* 1440762 */   // Label 20305: @1440762
     /* 1440762 */   GIM_Try, /*On fail goto*//*Label 20306*/ GIMT_Encode4(1440859), // Rule ID 6483 //
     /* 1440767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1440778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1440781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1440784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1440790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440817 */     // MIs[1] Operand 1
     /* 1440817 */     // No operand predicates
     /* 1440817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440821 */     // MIs[0] policy
     /* 1440821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440833 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1440836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440858 */     // GIR_Coverage, 6483,
     /* 1440858 */     GIR_EraseRootFromParent_Done,
     /* 1440859 */   // Label 20306: @1440859
     /* 1440859 */   GIM_Try, /*On fail goto*//*Label 20307*/ GIMT_Encode4(1440956), // Rule ID 6486 //
     /* 1440864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1440875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1440878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1440881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440914 */     // MIs[1] Operand 1
     /* 1440914 */     // No operand predicates
     /* 1440914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440918 */     // MIs[0] policy
     /* 1440918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440930 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1440933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440955 */     // GIR_Coverage, 6486,
     /* 1440955 */     GIR_EraseRootFromParent_Done,
     /* 1440956 */   // Label 20307: @1440956
     /* 1440956 */   GIM_Try, /*On fail goto*//*Label 20308*/ GIMT_Encode4(1441053), // Rule ID 6487 //
     /* 1440961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1440972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1440975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1440978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441011 */     // MIs[1] Operand 1
     /* 1441011 */     // No operand predicates
     /* 1441011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441015 */     // MIs[0] policy
     /* 1441015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441027 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441052 */     // GIR_Coverage, 6487,
     /* 1441052 */     GIR_EraseRootFromParent_Done,
     /* 1441053 */   // Label 20308: @1441053
     /* 1441053 */   GIM_Try, /*On fail goto*//*Label 20309*/ GIMT_Encode4(1441150), // Rule ID 6490 //
     /* 1441058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1441069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1441072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1441075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441108 */     // MIs[1] Operand 1
     /* 1441108 */     // No operand predicates
     /* 1441108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441112 */     // MIs[0] policy
     /* 1441112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441124 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441149 */     // GIR_Coverage, 6490,
     /* 1441149 */     GIR_EraseRootFromParent_Done,
     /* 1441150 */   // Label 20309: @1441150
     /* 1441150 */   GIM_Try, /*On fail goto*//*Label 20310*/ GIMT_Encode4(1441247), // Rule ID 6491 //
     /* 1441155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1441166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1441169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1441172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441205 */     // MIs[1] Operand 1
     /* 1441205 */     // No operand predicates
     /* 1441205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441209 */     // MIs[0] policy
     /* 1441209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441221 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441246 */     // GIR_Coverage, 6491,
     /* 1441246 */     GIR_EraseRootFromParent_Done,
     /* 1441247 */   // Label 20310: @1441247
     /* 1441247 */   GIM_Try, /*On fail goto*//*Label 20311*/ GIMT_Encode4(1441344), // Rule ID 6494 //
     /* 1441252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1441263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1441266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1441269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441302 */     // MIs[1] Operand 1
     /* 1441302 */     // No operand predicates
     /* 1441302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441306 */     // MIs[0] policy
     /* 1441306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441318 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441343 */     // GIR_Coverage, 6494,
     /* 1441343 */     GIR_EraseRootFromParent_Done,
     /* 1441344 */   // Label 20311: @1441344
     /* 1441344 */   GIM_Try, /*On fail goto*//*Label 20312*/ GIMT_Encode4(1441441), // Rule ID 6495 //
     /* 1441349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1441360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1441363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1441366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441399 */     // MIs[1] Operand 1
     /* 1441399 */     // No operand predicates
     /* 1441399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441403 */     // MIs[0] policy
     /* 1441403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441415 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441440 */     // GIR_Coverage, 6495,
     /* 1441440 */     GIR_EraseRootFromParent_Done,
     /* 1441441 */   // Label 20312: @1441441
     /* 1441441 */   GIM_Try, /*On fail goto*//*Label 20313*/ GIMT_Encode4(1441538), // Rule ID 6498 //
     /* 1441446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1441457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1441460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1441463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441496 */     // MIs[1] Operand 1
     /* 1441496 */     // No operand predicates
     /* 1441496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441500 */     // MIs[0] policy
     /* 1441500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441512 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441537 */     // GIR_Coverage, 6498,
     /* 1441537 */     GIR_EraseRootFromParent_Done,
     /* 1441538 */   // Label 20313: @1441538
     /* 1441538 */   GIM_Try, /*On fail goto*//*Label 20314*/ GIMT_Encode4(1441635), // Rule ID 6499 //
     /* 1441543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1441554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1441557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1441560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441593 */     // MIs[1] Operand 1
     /* 1441593 */     // No operand predicates
     /* 1441593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441597 */     // MIs[0] policy
     /* 1441597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441609 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441634 */     // GIR_Coverage, 6499,
     /* 1441634 */     GIR_EraseRootFromParent_Done,
     /* 1441635 */   // Label 20314: @1441635
     /* 1441635 */   GIM_Try, /*On fail goto*//*Label 20315*/ GIMT_Encode4(1441732), // Rule ID 6502 //
     /* 1441640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1441651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1441654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1441657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441690 */     // MIs[1] Operand 1
     /* 1441690 */     // No operand predicates
     /* 1441690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441694 */     // MIs[0] policy
     /* 1441694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441706 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441731 */     // GIR_Coverage, 6502,
     /* 1441731 */     GIR_EraseRootFromParent_Done,
     /* 1441732 */   // Label 20315: @1441732
     /* 1441732 */   GIM_Try, /*On fail goto*//*Label 20316*/ GIMT_Encode4(1441829), // Rule ID 6503 //
     /* 1441737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1441748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1441751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1441754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441787 */     // MIs[1] Operand 1
     /* 1441787 */     // No operand predicates
     /* 1441787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441791 */     // MIs[0] policy
     /* 1441791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441803 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441828 */     // GIR_Coverage, 6503,
     /* 1441828 */     GIR_EraseRootFromParent_Done,
     /* 1441829 */   // Label 20316: @1441829
     /* 1441829 */   GIM_Try, /*On fail goto*//*Label 20317*/ GIMT_Encode4(1441926), // Rule ID 6506 //
     /* 1441834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1441845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1441848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1441851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1441857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441884 */     // MIs[1] Operand 1
     /* 1441884 */     // No operand predicates
     /* 1441884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441888 */     // MIs[0] policy
     /* 1441888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441900 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1441903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441925 */     // GIR_Coverage, 6506,
     /* 1441925 */     GIR_EraseRootFromParent_Done,
     /* 1441926 */   // Label 20317: @1441926
     /* 1441926 */   GIM_Try, /*On fail goto*//*Label 20318*/ GIMT_Encode4(1442023), // Rule ID 6507 //
     /* 1441931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1441942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1441945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1441948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1441954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441981 */     // MIs[1] Operand 1
     /* 1441981 */     // No operand predicates
     /* 1441981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441985 */     // MIs[0] policy
     /* 1441985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441997 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442022 */     // GIR_Coverage, 6507,
     /* 1442022 */     GIR_EraseRootFromParent_Done,
     /* 1442023 */   // Label 20318: @1442023
     /* 1442023 */   GIM_Try, /*On fail goto*//*Label 20319*/ GIMT_Encode4(1442120), // Rule ID 6510 //
     /* 1442028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1442039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1442042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1442045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1442051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442078 */     // MIs[1] Operand 1
     /* 1442078 */     // No operand predicates
     /* 1442078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442082 */     // MIs[0] policy
     /* 1442082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442119 */     // GIR_Coverage, 6510,
     /* 1442119 */     GIR_EraseRootFromParent_Done,
     /* 1442120 */   // Label 20319: @1442120
     /* 1442120 */   GIM_Try, /*On fail goto*//*Label 20320*/ GIMT_Encode4(1442217), // Rule ID 6511 //
     /* 1442125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1442136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1442139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1442142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1442148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442175 */     // MIs[1] Operand 1
     /* 1442175 */     // No operand predicates
     /* 1442175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442179 */     // MIs[0] policy
     /* 1442179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442191 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442216 */     // GIR_Coverage, 6511,
     /* 1442216 */     GIR_EraseRootFromParent_Done,
     /* 1442217 */   // Label 20320: @1442217
     /* 1442217 */   GIM_Try, /*On fail goto*//*Label 20321*/ GIMT_Encode4(1442314), // Rule ID 6514 //
     /* 1442222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1442233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1442236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1442239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442272 */     // MIs[1] Operand 1
     /* 1442272 */     // No operand predicates
     /* 1442272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442276 */     // MIs[0] policy
     /* 1442276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442288 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442313 */     // GIR_Coverage, 6514,
     /* 1442313 */     GIR_EraseRootFromParent_Done,
     /* 1442314 */   // Label 20321: @1442314
     /* 1442314 */   GIM_Try, /*On fail goto*//*Label 20322*/ GIMT_Encode4(1442411), // Rule ID 6515 //
     /* 1442319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1442330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1442333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1442336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442369 */     // MIs[1] Operand 1
     /* 1442369 */     // No operand predicates
     /* 1442369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442373 */     // MIs[0] policy
     /* 1442373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442385 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442410 */     // GIR_Coverage, 6515,
     /* 1442410 */     GIR_EraseRootFromParent_Done,
     /* 1442411 */   // Label 20322: @1442411
     /* 1442411 */   GIM_Try, /*On fail goto*//*Label 20323*/ GIMT_Encode4(1442508), // Rule ID 6518 //
     /* 1442416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1442419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1442427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1442430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1442433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442466 */     // MIs[1] Operand 1
     /* 1442466 */     // No operand predicates
     /* 1442466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442470 */     // MIs[0] policy
     /* 1442470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442507 */     // GIR_Coverage, 6518,
     /* 1442507 */     GIR_EraseRootFromParent_Done,
     /* 1442508 */   // Label 20323: @1442508
     /* 1442508 */   GIM_Try, /*On fail goto*//*Label 20324*/ GIMT_Encode4(1442605), // Rule ID 6519 //
     /* 1442513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1442516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1442524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1442527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1442530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442563 */     // MIs[1] Operand 1
     /* 1442563 */     // No operand predicates
     /* 1442563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442567 */     // MIs[0] policy
     /* 1442567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442579 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442604 */     // GIR_Coverage, 6519,
     /* 1442604 */     GIR_EraseRootFromParent_Done,
     /* 1442605 */   // Label 20324: @1442605
     /* 1442605 */   GIM_Try, /*On fail goto*//*Label 20325*/ GIMT_Encode4(1442702), // Rule ID 6522 //
     /* 1442610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1442621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1442624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1442627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1442633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1442640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442660 */     // MIs[1] Operand 1
     /* 1442660 */     // No operand predicates
     /* 1442660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442664 */     // MIs[0] policy
     /* 1442664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442676 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1442679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442701 */     // GIR_Coverage, 6522,
     /* 1442701 */     GIR_EraseRootFromParent_Done,
     /* 1442702 */   // Label 20325: @1442702
     /* 1442702 */   GIM_Try, /*On fail goto*//*Label 20326*/ GIMT_Encode4(1442799), // Rule ID 6523 //
     /* 1442707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1442718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1442721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1442724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1442730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1442737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442757 */     // MIs[1] Operand 1
     /* 1442757 */     // No operand predicates
     /* 1442757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442761 */     // MIs[0] policy
     /* 1442761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442773 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1442776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442798 */     // GIR_Coverage, 6523,
     /* 1442798 */     GIR_EraseRootFromParent_Done,
     /* 1442799 */   // Label 20326: @1442799
     /* 1442799 */   GIM_Try, /*On fail goto*//*Label 20327*/ GIMT_Encode4(1442896), // Rule ID 6526 //
     /* 1442804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1442815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1442818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1442821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1442827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1442834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442854 */     // MIs[1] Operand 1
     /* 1442854 */     // No operand predicates
     /* 1442854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442858 */     // MIs[0] policy
     /* 1442858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1442873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442895 */     // GIR_Coverage, 6526,
     /* 1442895 */     GIR_EraseRootFromParent_Done,
     /* 1442896 */   // Label 20327: @1442896
     /* 1442896 */   GIM_Try, /*On fail goto*//*Label 20328*/ GIMT_Encode4(1442993), // Rule ID 6527 //
     /* 1442901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1442912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1442915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1442918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1442924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1442931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442951 */     // MIs[1] Operand 1
     /* 1442951 */     // No operand predicates
     /* 1442951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442955 */     // MIs[0] policy
     /* 1442955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442967 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1442970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442992 */     // GIR_Coverage, 6527,
     /* 1442992 */     GIR_EraseRootFromParent_Done,
     /* 1442993 */   // Label 20328: @1442993
     /* 1442993 */   GIM_Try, /*On fail goto*//*Label 20329*/ GIMT_Encode4(1443090), // Rule ID 6530 //
     /* 1442998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1443009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1443012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1443015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1443021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443048 */     // MIs[1] Operand 1
     /* 1443048 */     // No operand predicates
     /* 1443048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443052 */     // MIs[0] policy
     /* 1443052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443064 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1443067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443089 */     // GIR_Coverage, 6530,
     /* 1443089 */     GIR_EraseRootFromParent_Done,
     /* 1443090 */   // Label 20329: @1443090
     /* 1443090 */   GIM_Try, /*On fail goto*//*Label 20330*/ GIMT_Encode4(1443187), // Rule ID 6531 //
     /* 1443095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1443106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1443109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1443112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1443118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443145 */     // MIs[1] Operand 1
     /* 1443145 */     // No operand predicates
     /* 1443145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443149 */     // MIs[0] policy
     /* 1443149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443161 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1443164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443186 */     // GIR_Coverage, 6531,
     /* 1443186 */     GIR_EraseRootFromParent_Done,
     /* 1443187 */   // Label 20330: @1443187
     /* 1443187 */   GIM_Try, /*On fail goto*//*Label 20331*/ GIMT_Encode4(1443284), // Rule ID 6534 //
     /* 1443192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1443203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1443206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1443209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443242 */     // MIs[1] Operand 1
     /* 1443242 */     // No operand predicates
     /* 1443242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443246 */     // MIs[0] policy
     /* 1443246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443258 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443283 */     // GIR_Coverage, 6534,
     /* 1443283 */     GIR_EraseRootFromParent_Done,
     /* 1443284 */   // Label 20331: @1443284
     /* 1443284 */   GIM_Try, /*On fail goto*//*Label 20332*/ GIMT_Encode4(1443381), // Rule ID 6535 //
     /* 1443289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1443300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1443303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1443306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443339 */     // MIs[1] Operand 1
     /* 1443339 */     // No operand predicates
     /* 1443339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443343 */     // MIs[0] policy
     /* 1443343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443355 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443380 */     // GIR_Coverage, 6535,
     /* 1443380 */     GIR_EraseRootFromParent_Done,
     /* 1443381 */   // Label 20332: @1443381
     /* 1443381 */   GIM_Try, /*On fail goto*//*Label 20333*/ GIMT_Encode4(1443478), // Rule ID 6538 //
     /* 1443386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1443397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1443400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1443403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443436 */     // MIs[1] Operand 1
     /* 1443436 */     // No operand predicates
     /* 1443436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443440 */     // MIs[0] policy
     /* 1443440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443452 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1443455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443477 */     // GIR_Coverage, 6538,
     /* 1443477 */     GIR_EraseRootFromParent_Done,
     /* 1443478 */   // Label 20333: @1443478
     /* 1443478 */   GIM_Try, /*On fail goto*//*Label 20334*/ GIMT_Encode4(1443575), // Rule ID 6539 //
     /* 1443483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1443494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1443497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1443500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443533 */     // MIs[1] Operand 1
     /* 1443533 */     // No operand predicates
     /* 1443533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443537 */     // MIs[0] policy
     /* 1443537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443549 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1443552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443574 */     // GIR_Coverage, 6539,
     /* 1443574 */     GIR_EraseRootFromParent_Done,
     /* 1443575 */   // Label 20334: @1443575
     /* 1443575 */   GIM_Try, /*On fail goto*//*Label 20335*/ GIMT_Encode4(1443672), // Rule ID 6542 //
     /* 1443580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1443591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1443594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1443597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1443603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443630 */     // MIs[1] Operand 1
     /* 1443630 */     // No operand predicates
     /* 1443630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443634 */     // MIs[0] policy
     /* 1443634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1443649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443671 */     // GIR_Coverage, 6542,
     /* 1443671 */     GIR_EraseRootFromParent_Done,
     /* 1443672 */   // Label 20335: @1443672
     /* 1443672 */   GIM_Try, /*On fail goto*//*Label 20336*/ GIMT_Encode4(1443769), // Rule ID 6543 //
     /* 1443677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1443688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1443691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1443694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1443700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443727 */     // MIs[1] Operand 1
     /* 1443727 */     // No operand predicates
     /* 1443727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443731 */     // MIs[0] policy
     /* 1443731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443743 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1443746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443768 */     // GIR_Coverage, 6543,
     /* 1443768 */     GIR_EraseRootFromParent_Done,
     /* 1443769 */   // Label 20336: @1443769
     /* 1443769 */   GIM_Try, /*On fail goto*//*Label 20337*/ GIMT_Encode4(1443866), // Rule ID 6546 //
     /* 1443774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1443785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1443788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1443791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1443797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443824 */     // MIs[1] Operand 1
     /* 1443824 */     // No operand predicates
     /* 1443824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443828 */     // MIs[0] policy
     /* 1443828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443865 */     // GIR_Coverage, 6546,
     /* 1443865 */     GIR_EraseRootFromParent_Done,
     /* 1443866 */   // Label 20337: @1443866
     /* 1443866 */   GIM_Try, /*On fail goto*//*Label 20338*/ GIMT_Encode4(1443963), // Rule ID 6547 //
     /* 1443871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1443882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1443885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1443888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1443894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443921 */     // MIs[1] Operand 1
     /* 1443921 */     // No operand predicates
     /* 1443921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443925 */     // MIs[0] policy
     /* 1443925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443937 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443962 */     // GIR_Coverage, 6547,
     /* 1443962 */     GIR_EraseRootFromParent_Done,
     /* 1443963 */   // Label 20338: @1443963
     /* 1443963 */   GIM_Try, /*On fail goto*//*Label 20339*/ GIMT_Encode4(1444060), // Rule ID 6550 //
     /* 1443968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1443979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1443982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1443985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444018 */     // MIs[1] Operand 1
     /* 1444018 */     // No operand predicates
     /* 1444018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444022 */     // MIs[0] policy
     /* 1444022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444034 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444059 */     // GIR_Coverage, 6550,
     /* 1444059 */     GIR_EraseRootFromParent_Done,
     /* 1444060 */   // Label 20339: @1444060
     /* 1444060 */   GIM_Try, /*On fail goto*//*Label 20340*/ GIMT_Encode4(1444157), // Rule ID 6551 //
     /* 1444065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1444076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1444079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1444082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1444088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444115 */     // MIs[1] Operand 1
     /* 1444115 */     // No operand predicates
     /* 1444115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444119 */     // MIs[0] policy
     /* 1444119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444131 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444156 */     // GIR_Coverage, 6551,
     /* 1444156 */     GIR_EraseRootFromParent_Done,
     /* 1444157 */   // Label 20340: @1444157
     /* 1444157 */   GIM_Try, /*On fail goto*//*Label 20341*/ GIMT_Encode4(1444254), // Rule ID 6554 //
     /* 1444162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1444173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1444176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1444179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1444185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444212 */     // MIs[1] Operand 1
     /* 1444212 */     // No operand predicates
     /* 1444212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444216 */     // MIs[0] policy
     /* 1444216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444228 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444253 */     // GIR_Coverage, 6554,
     /* 1444253 */     GIR_EraseRootFromParent_Done,
     /* 1444254 */   // Label 20341: @1444254
     /* 1444254 */   GIM_Try, /*On fail goto*//*Label 20342*/ GIMT_Encode4(1444351), // Rule ID 6555 //
     /* 1444259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1444270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1444273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1444276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1444282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444309 */     // MIs[1] Operand 1
     /* 1444309 */     // No operand predicates
     /* 1444309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444313 */     // MIs[0] policy
     /* 1444313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444325 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444350 */     // GIR_Coverage, 6555,
     /* 1444350 */     GIR_EraseRootFromParent_Done,
     /* 1444351 */   // Label 20342: @1444351
     /* 1444351 */   GIM_Try, /*On fail goto*//*Label 20343*/ GIMT_Encode4(1444448), // Rule ID 6558 //
     /* 1444356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1444359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1444367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1444370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1444373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444406 */     // MIs[1] Operand 1
     /* 1444406 */     // No operand predicates
     /* 1444406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444410 */     // MIs[0] policy
     /* 1444410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444422 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1444425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444447 */     // GIR_Coverage, 6558,
     /* 1444447 */     GIR_EraseRootFromParent_Done,
     /* 1444448 */   // Label 20343: @1444448
     /* 1444448 */   GIM_Try, /*On fail goto*//*Label 20344*/ GIMT_Encode4(1444545), // Rule ID 6559 //
     /* 1444453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1444456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1444464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1444467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1444470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444503 */     // MIs[1] Operand 1
     /* 1444503 */     // No operand predicates
     /* 1444503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444507 */     // MIs[0] policy
     /* 1444507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444519 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1444522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444544 */     // GIR_Coverage, 6559,
     /* 1444544 */     GIR_EraseRootFromParent_Done,
     /* 1444545 */   // Label 20344: @1444545
     /* 1444545 */   GIM_Try, /*On fail goto*//*Label 20345*/ GIMT_Encode4(1444642), // Rule ID 6562 //
     /* 1444550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1444553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1444561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1444564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1444567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444600 */     // MIs[1] Operand 1
     /* 1444600 */     // No operand predicates
     /* 1444600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444604 */     // MIs[0] policy
     /* 1444604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444641 */     // GIR_Coverage, 6562,
     /* 1444641 */     GIR_EraseRootFromParent_Done,
     /* 1444642 */   // Label 20345: @1444642
     /* 1444642 */   GIM_Try, /*On fail goto*//*Label 20346*/ GIMT_Encode4(1444739), // Rule ID 6563 //
     /* 1444647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1444650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1444658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1444661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1444664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444697 */     // MIs[1] Operand 1
     /* 1444697 */     // No operand predicates
     /* 1444697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444701 */     // MIs[0] policy
     /* 1444701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444713 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444738 */     // GIR_Coverage, 6563,
     /* 1444738 */     GIR_EraseRootFromParent_Done,
     /* 1444739 */   // Label 20346: @1444739
     /* 1444739 */   GIM_Try, /*On fail goto*//*Label 20347*/ GIMT_Encode4(1444836), // Rule ID 6566 //
     /* 1444744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1444747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1444755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1444758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1444761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1444767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444794 */     // MIs[1] Operand 1
     /* 1444794 */     // No operand predicates
     /* 1444794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444798 */     // MIs[0] policy
     /* 1444798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444810 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444835 */     // GIR_Coverage, 6566,
     /* 1444835 */     GIR_EraseRootFromParent_Done,
     /* 1444836 */   // Label 20347: @1444836
     /* 1444836 */   GIM_Try, /*On fail goto*//*Label 20348*/ GIMT_Encode4(1444933), // Rule ID 6567 //
     /* 1444841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1444844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1444852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1444855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1444858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1444864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444891 */     // MIs[1] Operand 1
     /* 1444891 */     // No operand predicates
     /* 1444891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444895 */     // MIs[0] policy
     /* 1444895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444907 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444932 */     // GIR_Coverage, 6567,
     /* 1444932 */     GIR_EraseRootFromParent_Done,
     /* 1444933 */   // Label 20348: @1444933
     /* 1444933 */   GIM_Try, /*On fail goto*//*Label 20349*/ GIMT_Encode4(1445030), // Rule ID 6746 //
     /* 1444938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1444946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1444949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1444952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1444955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1444961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444988 */     // MIs[1] Operand 1
     /* 1444988 */     // No operand predicates
     /* 1444988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444992 */     // MIs[0] policy
     /* 1444992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445004 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1445007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445029 */     // GIR_Coverage, 6746,
     /* 1445029 */     GIR_EraseRootFromParent_Done,
     /* 1445030 */   // Label 20349: @1445030
     /* 1445030 */   GIM_Try, /*On fail goto*//*Label 20350*/ GIMT_Encode4(1445127), // Rule ID 6747 //
     /* 1445035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1445046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1445049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1445052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445085 */     // MIs[1] Operand 1
     /* 1445085 */     // No operand predicates
     /* 1445085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445089 */     // MIs[0] policy
     /* 1445089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445101 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1445104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445126 */     // GIR_Coverage, 6747,
     /* 1445126 */     GIR_EraseRootFromParent_Done,
     /* 1445127 */   // Label 20350: @1445127
     /* 1445127 */   GIM_Try, /*On fail goto*//*Label 20351*/ GIMT_Encode4(1445224), // Rule ID 6750 //
     /* 1445132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1445143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1445146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1445149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445182 */     // MIs[1] Operand 1
     /* 1445182 */     // No operand predicates
     /* 1445182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445186 */     // MIs[0] policy
     /* 1445186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445198 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1445201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445223 */     // GIR_Coverage, 6750,
     /* 1445223 */     GIR_EraseRootFromParent_Done,
     /* 1445224 */   // Label 20351: @1445224
     /* 1445224 */   GIM_Try, /*On fail goto*//*Label 20352*/ GIMT_Encode4(1445321), // Rule ID 6751 //
     /* 1445229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1445240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1445243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1445246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445279 */     // MIs[1] Operand 1
     /* 1445279 */     // No operand predicates
     /* 1445279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445283 */     // MIs[0] policy
     /* 1445283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445295 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1445298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445320 */     // GIR_Coverage, 6751,
     /* 1445320 */     GIR_EraseRootFromParent_Done,
     /* 1445321 */   // Label 20352: @1445321
     /* 1445321 */   GIM_Try, /*On fail goto*//*Label 20353*/ GIMT_Encode4(1445418), // Rule ID 6754 //
     /* 1445326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1445337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1445340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1445343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445376 */     // MIs[1] Operand 1
     /* 1445376 */     // No operand predicates
     /* 1445376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445380 */     // MIs[0] policy
     /* 1445380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445392 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445417 */     // GIR_Coverage, 6754,
     /* 1445417 */     GIR_EraseRootFromParent_Done,
     /* 1445418 */   // Label 20353: @1445418
     /* 1445418 */   GIM_Try, /*On fail goto*//*Label 20354*/ GIMT_Encode4(1445515), // Rule ID 6755 //
     /* 1445423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1445434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1445437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1445440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445473 */     // MIs[1] Operand 1
     /* 1445473 */     // No operand predicates
     /* 1445473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445477 */     // MIs[0] policy
     /* 1445477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445489 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445514 */     // GIR_Coverage, 6755,
     /* 1445514 */     GIR_EraseRootFromParent_Done,
     /* 1445515 */   // Label 20354: @1445515
     /* 1445515 */   GIM_Try, /*On fail goto*//*Label 20355*/ GIMT_Encode4(1445612), // Rule ID 6758 //
     /* 1445520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1445531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1445534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1445537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445570 */     // MIs[1] Operand 1
     /* 1445570 */     // No operand predicates
     /* 1445570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445574 */     // MIs[0] policy
     /* 1445574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445586 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1445589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445611 */     // GIR_Coverage, 6758,
     /* 1445611 */     GIR_EraseRootFromParent_Done,
     /* 1445612 */   // Label 20355: @1445612
     /* 1445612 */   GIM_Try, /*On fail goto*//*Label 20356*/ GIMT_Encode4(1445709), // Rule ID 6759 //
     /* 1445617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1445628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1445631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1445634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445667 */     // MIs[1] Operand 1
     /* 1445667 */     // No operand predicates
     /* 1445667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445671 */     // MIs[0] policy
     /* 1445671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445683 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1445686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445708 */     // GIR_Coverage, 6759,
     /* 1445708 */     GIR_EraseRootFromParent_Done,
     /* 1445709 */   // Label 20356: @1445709
     /* 1445709 */   GIM_Try, /*On fail goto*//*Label 20357*/ GIMT_Encode4(1445806), // Rule ID 6762 //
     /* 1445714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1445725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1445728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1445731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445764 */     // MIs[1] Operand 1
     /* 1445764 */     // No operand predicates
     /* 1445764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445768 */     // MIs[0] policy
     /* 1445768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445780 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445805 */     // GIR_Coverage, 6762,
     /* 1445805 */     GIR_EraseRootFromParent_Done,
     /* 1445806 */   // Label 20357: @1445806
     /* 1445806 */   GIM_Try, /*On fail goto*//*Label 20358*/ GIMT_Encode4(1445903), // Rule ID 6763 //
     /* 1445811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1445822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1445825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1445828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445861 */     // MIs[1] Operand 1
     /* 1445861 */     // No operand predicates
     /* 1445861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445865 */     // MIs[0] policy
     /* 1445865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445877 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445902 */     // GIR_Coverage, 6763,
     /* 1445902 */     GIR_EraseRootFromParent_Done,
     /* 1445903 */   // Label 20358: @1445903
     /* 1445903 */   GIM_Try, /*On fail goto*//*Label 20359*/ GIMT_Encode4(1446000), // Rule ID 6766 //
     /* 1445908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1445919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1445922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1445925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445958 */     // MIs[1] Operand 1
     /* 1445958 */     // No operand predicates
     /* 1445958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445962 */     // MIs[0] policy
     /* 1445962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445974 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445999 */     // GIR_Coverage, 6766,
     /* 1445999 */     GIR_EraseRootFromParent_Done,
     /* 1446000 */   // Label 20359: @1446000
     /* 1446000 */   GIM_Try, /*On fail goto*//*Label 20360*/ GIMT_Encode4(1446097), // Rule ID 6767 //
     /* 1446005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1446016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1446019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1446022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446055 */     // MIs[1] Operand 1
     /* 1446055 */     // No operand predicates
     /* 1446055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446059 */     // MIs[0] policy
     /* 1446059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446071 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1446074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446096 */     // GIR_Coverage, 6767,
     /* 1446096 */     GIR_EraseRootFromParent_Done,
     /* 1446097 */   // Label 20360: @1446097
     /* 1446097 */   GIM_Try, /*On fail goto*//*Label 20361*/ GIMT_Encode4(1446194), // Rule ID 6770 //
     /* 1446102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1446113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1446116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1446119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446152 */     // MIs[1] Operand 1
     /* 1446152 */     // No operand predicates
     /* 1446152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446156 */     // MIs[0] policy
     /* 1446156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446168 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446193 */     // GIR_Coverage, 6770,
     /* 1446193 */     GIR_EraseRootFromParent_Done,
     /* 1446194 */   // Label 20361: @1446194
     /* 1446194 */   GIM_Try, /*On fail goto*//*Label 20362*/ GIMT_Encode4(1446291), // Rule ID 6771 //
     /* 1446199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1446210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1446213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1446216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446249 */     // MIs[1] Operand 1
     /* 1446249 */     // No operand predicates
     /* 1446249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446253 */     // MIs[0] policy
     /* 1446253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446265 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446290 */     // GIR_Coverage, 6771,
     /* 1446290 */     GIR_EraseRootFromParent_Done,
     /* 1446291 */   // Label 20362: @1446291
     /* 1446291 */   GIM_Try, /*On fail goto*//*Label 20363*/ GIMT_Encode4(1446388), // Rule ID 6774 //
     /* 1446296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1446307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1446310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1446313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1446319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446342 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446346 */     // MIs[1] Operand 1
     /* 1446346 */     // No operand predicates
     /* 1446346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446350 */     // MIs[0] policy
     /* 1446350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446362 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446387 */     // GIR_Coverage, 6774,
     /* 1446387 */     GIR_EraseRootFromParent_Done,
     /* 1446388 */   // Label 20363: @1446388
     /* 1446388 */   GIM_Try, /*On fail goto*//*Label 20364*/ GIMT_Encode4(1446485), // Rule ID 6775 //
     /* 1446393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1446404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1446407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1446410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1446416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446443 */     // MIs[1] Operand 1
     /* 1446443 */     // No operand predicates
     /* 1446443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446447 */     // MIs[0] policy
     /* 1446447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446459 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446484 */     // GIR_Coverage, 6775,
     /* 1446484 */     GIR_EraseRootFromParent_Done,
     /* 1446485 */   // Label 20364: @1446485
     /* 1446485 */   GIM_Try, /*On fail goto*//*Label 20365*/ GIMT_Encode4(1446582), // Rule ID 6778 //
     /* 1446490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1446501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1446504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1446507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446540 */     // MIs[1] Operand 1
     /* 1446540 */     // No operand predicates
     /* 1446540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446544 */     // MIs[0] policy
     /* 1446544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446556 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446581 */     // GIR_Coverage, 6778,
     /* 1446581 */     GIR_EraseRootFromParent_Done,
     /* 1446582 */   // Label 20365: @1446582
     /* 1446582 */   GIM_Try, /*On fail goto*//*Label 20366*/ GIMT_Encode4(1446679), // Rule ID 6779 //
     /* 1446587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1446598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1446601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1446604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446637 */     // MIs[1] Operand 1
     /* 1446637 */     // No operand predicates
     /* 1446637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446641 */     // MIs[0] policy
     /* 1446641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446653 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446678 */     // GIR_Coverage, 6779,
     /* 1446678 */     GIR_EraseRootFromParent_Done,
     /* 1446679 */   // Label 20366: @1446679
     /* 1446679 */   GIM_Try, /*On fail goto*//*Label 20367*/ GIMT_Encode4(1446776), // Rule ID 6782 //
     /* 1446684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1446687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1446695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1446698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1446701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446734 */     // MIs[1] Operand 1
     /* 1446734 */     // No operand predicates
     /* 1446734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446738 */     // MIs[0] policy
     /* 1446738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446750 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446775 */     // GIR_Coverage, 6782,
     /* 1446775 */     GIR_EraseRootFromParent_Done,
     /* 1446776 */   // Label 20367: @1446776
     /* 1446776 */   GIM_Try, /*On fail goto*//*Label 20368*/ GIMT_Encode4(1446873), // Rule ID 6783 //
     /* 1446781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1446784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1446792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1446795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1446798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446831 */     // MIs[1] Operand 1
     /* 1446831 */     // No operand predicates
     /* 1446831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446835 */     // MIs[0] policy
     /* 1446835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446847 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446872 */     // GIR_Coverage, 6783,
     /* 1446872 */     GIR_EraseRootFromParent_Done,
     /* 1446873 */   // Label 20368: @1446873
     /* 1446873 */   GIM_Try, /*On fail goto*//*Label 20369*/ GIMT_Encode4(1446970), // Rule ID 6786 //
     /* 1446878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1446889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1446892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1446895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1446901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1446908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446928 */     // MIs[1] Operand 1
     /* 1446928 */     // No operand predicates
     /* 1446928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446932 */     // MIs[0] policy
     /* 1446932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446944 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1446947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446969 */     // GIR_Coverage, 6786,
     /* 1446969 */     GIR_EraseRootFromParent_Done,
     /* 1446970 */   // Label 20369: @1446970
     /* 1446970 */   GIM_Try, /*On fail goto*//*Label 20370*/ GIMT_Encode4(1447067), // Rule ID 6787 //
     /* 1446975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1446986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1446989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1446992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1446998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447025 */     // MIs[1] Operand 1
     /* 1447025 */     // No operand predicates
     /* 1447025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447029 */     // MIs[0] policy
     /* 1447029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447041 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1447044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447066 */     // GIR_Coverage, 6787,
     /* 1447066 */     GIR_EraseRootFromParent_Done,
     /* 1447067 */   // Label 20370: @1447067
     /* 1447067 */   GIM_Try, /*On fail goto*//*Label 20371*/ GIMT_Encode4(1447164), // Rule ID 6790 //
     /* 1447072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1447083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1447086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1447089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447122 */     // MIs[1] Operand 1
     /* 1447122 */     // No operand predicates
     /* 1447122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447126 */     // MIs[0] policy
     /* 1447126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447138 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1447141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447163 */     // GIR_Coverage, 6790,
     /* 1447163 */     GIR_EraseRootFromParent_Done,
     /* 1447164 */   // Label 20371: @1447164
     /* 1447164 */   GIM_Try, /*On fail goto*//*Label 20372*/ GIMT_Encode4(1447261), // Rule ID 6791 //
     /* 1447169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1447180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1447183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1447186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447219 */     // MIs[1] Operand 1
     /* 1447219 */     // No operand predicates
     /* 1447219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447223 */     // MIs[0] policy
     /* 1447223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447235 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1447238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447260 */     // GIR_Coverage, 6791,
     /* 1447260 */     GIR_EraseRootFromParent_Done,
     /* 1447261 */   // Label 20372: @1447261
     /* 1447261 */   GIM_Try, /*On fail goto*//*Label 20373*/ GIMT_Encode4(1447358), // Rule ID 6794 //
     /* 1447266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1447277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1447280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1447283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1447289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447316 */     // MIs[1] Operand 1
     /* 1447316 */     // No operand predicates
     /* 1447316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447320 */     // MIs[0] policy
     /* 1447320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447332 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1447335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447357 */     // GIR_Coverage, 6794,
     /* 1447357 */     GIR_EraseRootFromParent_Done,
     /* 1447358 */   // Label 20373: @1447358
     /* 1447358 */   GIM_Try, /*On fail goto*//*Label 20374*/ GIMT_Encode4(1447455), // Rule ID 6795 //
     /* 1447363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1447374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1447377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1447380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1447386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447413 */     // MIs[1] Operand 1
     /* 1447413 */     // No operand predicates
     /* 1447413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447417 */     // MIs[0] policy
     /* 1447417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447429 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1447432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447454 */     // GIR_Coverage, 6795,
     /* 1447454 */     GIR_EraseRootFromParent_Done,
     /* 1447455 */   // Label 20374: @1447455
     /* 1447455 */   GIM_Try, /*On fail goto*//*Label 20375*/ GIMT_Encode4(1447552), // Rule ID 6798 //
     /* 1447460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1447471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1447474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1447477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1447483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447510 */     // MIs[1] Operand 1
     /* 1447510 */     // No operand predicates
     /* 1447510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447514 */     // MIs[0] policy
     /* 1447514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447526 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1447529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447551 */     // GIR_Coverage, 6798,
     /* 1447551 */     GIR_EraseRootFromParent_Done,
     /* 1447552 */   // Label 20375: @1447552
     /* 1447552 */   GIM_Try, /*On fail goto*//*Label 20376*/ GIMT_Encode4(1447649), // Rule ID 6799 //
     /* 1447557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1447568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1447571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1447574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1447580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447607 */     // MIs[1] Operand 1
     /* 1447607 */     // No operand predicates
     /* 1447607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447611 */     // MIs[0] policy
     /* 1447611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447623 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1447626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447648 */     // GIR_Coverage, 6799,
     /* 1447648 */     GIR_EraseRootFromParent_Done,
     /* 1447649 */   // Label 20376: @1447649
     /* 1447649 */   GIM_Try, /*On fail goto*//*Label 20377*/ GIMT_Encode4(1447746), // Rule ID 6802 //
     /* 1447654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1447665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1447668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1447671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1447677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447704 */     // MIs[1] Operand 1
     /* 1447704 */     // No operand predicates
     /* 1447704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447708 */     // MIs[0] policy
     /* 1447708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447720 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1447723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447745 */     // GIR_Coverage, 6802,
     /* 1447745 */     GIR_EraseRootFromParent_Done,
     /* 1447746 */   // Label 20377: @1447746
     /* 1447746 */   GIM_Try, /*On fail goto*//*Label 20378*/ GIMT_Encode4(1447843), // Rule ID 6803 //
     /* 1447751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1447762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1447765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1447768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1447774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447801 */     // MIs[1] Operand 1
     /* 1447801 */     // No operand predicates
     /* 1447801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447805 */     // MIs[0] policy
     /* 1447805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447817 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1447820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447842 */     // GIR_Coverage, 6803,
     /* 1447842 */     GIR_EraseRootFromParent_Done,
     /* 1447843 */   // Label 20378: @1447843
     /* 1447843 */   GIM_Try, /*On fail goto*//*Label 20379*/ GIMT_Encode4(1447940), // Rule ID 6806 //
     /* 1447848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1447859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1447862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1447865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447898 */     // MIs[1] Operand 1
     /* 1447898 */     // No operand predicates
     /* 1447898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447902 */     // MIs[0] policy
     /* 1447902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447914 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1447917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447939 */     // GIR_Coverage, 6806,
     /* 1447939 */     GIR_EraseRootFromParent_Done,
     /* 1447940 */   // Label 20379: @1447940
     /* 1447940 */   GIM_Try, /*On fail goto*//*Label 20380*/ GIMT_Encode4(1448037), // Rule ID 6807 //
     /* 1447945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1447956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1447959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1447962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447995 */     // MIs[1] Operand 1
     /* 1447995 */     // No operand predicates
     /* 1447995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447999 */     // MIs[0] policy
     /* 1447999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448011 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1448014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448036 */     // GIR_Coverage, 6807,
     /* 1448036 */     GIR_EraseRootFromParent_Done,
     /* 1448037 */   // Label 20380: @1448037
     /* 1448037 */   GIM_Try, /*On fail goto*//*Label 20381*/ GIMT_Encode4(1448134), // Rule ID 6810 //
     /* 1448042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1448053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1448056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1448059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448092 */     // MIs[1] Operand 1
     /* 1448092 */     // No operand predicates
     /* 1448092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448096 */     // MIs[0] policy
     /* 1448096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448108 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448133 */     // GIR_Coverage, 6810,
     /* 1448133 */     GIR_EraseRootFromParent_Done,
     /* 1448134 */   // Label 20381: @1448134
     /* 1448134 */   GIM_Try, /*On fail goto*//*Label 20382*/ GIMT_Encode4(1448231), // Rule ID 6811 //
     /* 1448139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1448150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1448153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1448156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448189 */     // MIs[1] Operand 1
     /* 1448189 */     // No operand predicates
     /* 1448189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448193 */     // MIs[0] policy
     /* 1448193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448205 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448230 */     // GIR_Coverage, 6811,
     /* 1448230 */     GIR_EraseRootFromParent_Done,
     /* 1448231 */   // Label 20382: @1448231
     /* 1448231 */   GIM_Try, /*On fail goto*//*Label 20383*/ GIMT_Encode4(1448328), // Rule ID 6814 //
     /* 1448236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1448247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1448250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1448253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448286 */     // MIs[1] Operand 1
     /* 1448286 */     // No operand predicates
     /* 1448286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448290 */     // MIs[0] policy
     /* 1448290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448327 */     // GIR_Coverage, 6814,
     /* 1448327 */     GIR_EraseRootFromParent_Done,
     /* 1448328 */   // Label 20383: @1448328
     /* 1448328 */   GIM_Try, /*On fail goto*//*Label 20384*/ GIMT_Encode4(1448425), // Rule ID 6815 //
     /* 1448333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1448344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1448347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1448350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448383 */     // MIs[1] Operand 1
     /* 1448383 */     // No operand predicates
     /* 1448383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448387 */     // MIs[0] policy
     /* 1448387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448399 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448424 */     // GIR_Coverage, 6815,
     /* 1448424 */     GIR_EraseRootFromParent_Done,
     /* 1448425 */   // Label 20384: @1448425
     /* 1448425 */   GIM_Try, /*On fail goto*//*Label 20385*/ GIMT_Encode4(1448522), // Rule ID 6818 //
     /* 1448430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1448441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1448444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1448447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448480 */     // MIs[1] Operand 1
     /* 1448480 */     // No operand predicates
     /* 1448480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448484 */     // MIs[0] policy
     /* 1448484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448496 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1448499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448521 */     // GIR_Coverage, 6818,
     /* 1448521 */     GIR_EraseRootFromParent_Done,
     /* 1448522 */   // Label 20385: @1448522
     /* 1448522 */   GIM_Try, /*On fail goto*//*Label 20386*/ GIMT_Encode4(1448619), // Rule ID 6819 //
     /* 1448527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1448538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1448541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1448544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448577 */     // MIs[1] Operand 1
     /* 1448577 */     // No operand predicates
     /* 1448577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448581 */     // MIs[0] policy
     /* 1448581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448593 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1448596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448618 */     // GIR_Coverage, 6819,
     /* 1448618 */     GIR_EraseRootFromParent_Done,
     /* 1448619 */   // Label 20386: @1448619
     /* 1448619 */   GIM_Try, /*On fail goto*//*Label 20387*/ GIMT_Encode4(1448716), // Rule ID 6822 //
     /* 1448624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1448627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1448635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1448638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1448641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1448647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448674 */     // MIs[1] Operand 1
     /* 1448674 */     // No operand predicates
     /* 1448674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448678 */     // MIs[0] policy
     /* 1448678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448715 */     // GIR_Coverage, 6822,
     /* 1448715 */     GIR_EraseRootFromParent_Done,
     /* 1448716 */   // Label 20387: @1448716
     /* 1448716 */   GIM_Try, /*On fail goto*//*Label 20388*/ GIMT_Encode4(1448813), // Rule ID 6823 //
     /* 1448721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1448724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1448732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1448735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1448738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1448744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448771 */     // MIs[1] Operand 1
     /* 1448771 */     // No operand predicates
     /* 1448771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448775 */     // MIs[0] policy
     /* 1448775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448787 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448812 */     // GIR_Coverage, 6823,
     /* 1448812 */     GIR_EraseRootFromParent_Done,
     /* 1448813 */   // Label 20388: @1448813
     /* 1448813 */   GIM_Try, /*On fail goto*//*Label 20389*/ GIMT_Encode4(1448910), // Rule ID 6826 //
     /* 1448818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1448821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1448829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1448832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1448835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448868 */     // MIs[1] Operand 1
     /* 1448868 */     // No operand predicates
     /* 1448868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448872 */     // MIs[0] policy
     /* 1448872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448884 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448909 */     // GIR_Coverage, 6826,
     /* 1448909 */     GIR_EraseRootFromParent_Done,
     /* 1448910 */   // Label 20389: @1448910
     /* 1448910 */   GIM_Try, /*On fail goto*//*Label 20390*/ GIMT_Encode4(1449007), // Rule ID 6827 //
     /* 1448915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1448918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1448926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1448929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1448932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448965 */     // MIs[1] Operand 1
     /* 1448965 */     // No operand predicates
     /* 1448965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448969 */     // MIs[0] policy
     /* 1448969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448981 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449006 */     // GIR_Coverage, 6827,
     /* 1449006 */     GIR_EraseRootFromParent_Done,
     /* 1449007 */   // Label 20390: @1449007
     /* 1449007 */   GIM_Try, /*On fail goto*//*Label 20391*/ GIMT_Encode4(1449104), // Rule ID 6830 //
     /* 1449012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1449015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1449023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1449026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1449029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1449035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449062 */     // MIs[1] Operand 1
     /* 1449062 */     // No operand predicates
     /* 1449062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449066 */     // MIs[0] policy
     /* 1449066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449078 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1449081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449103 */     // GIR_Coverage, 6830,
     /* 1449103 */     GIR_EraseRootFromParent_Done,
     /* 1449104 */   // Label 20391: @1449104
     /* 1449104 */   GIM_Try, /*On fail goto*//*Label 20392*/ GIMT_Encode4(1449201), // Rule ID 6831 //
     /* 1449109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1449112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1449120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1449123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1449126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1449132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449159 */     // MIs[1] Operand 1
     /* 1449159 */     // No operand predicates
     /* 1449159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449163 */     // MIs[0] policy
     /* 1449163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449175 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1449178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449200 */     // GIR_Coverage, 6831,
     /* 1449200 */     GIR_EraseRootFromParent_Done,
     /* 1449201 */   // Label 20392: @1449201
     /* 1449201 */   GIM_Try, /*On fail goto*//*Label 20393*/ GIMT_Encode4(1449298), // Rule ID 7010 //
     /* 1449206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1449217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1449220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1449223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449256 */     // MIs[1] Operand 1
     /* 1449256 */     // No operand predicates
     /* 1449256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449260 */     // MIs[0] policy
     /* 1449260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449272 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1449275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449297 */     // GIR_Coverage, 7010,
     /* 1449297 */     GIR_EraseRootFromParent_Done,
     /* 1449298 */   // Label 20393: @1449298
     /* 1449298 */   GIM_Try, /*On fail goto*//*Label 20394*/ GIMT_Encode4(1449395), // Rule ID 7011 //
     /* 1449303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1449314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1449317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1449320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449353 */     // MIs[1] Operand 1
     /* 1449353 */     // No operand predicates
     /* 1449353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449357 */     // MIs[0] policy
     /* 1449357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449369 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1449372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449394 */     // GIR_Coverage, 7011,
     /* 1449394 */     GIR_EraseRootFromParent_Done,
     /* 1449395 */   // Label 20394: @1449395
     /* 1449395 */   GIM_Try, /*On fail goto*//*Label 20395*/ GIMT_Encode4(1449492), // Rule ID 7014 //
     /* 1449400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1449411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1449414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1449417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449450 */     // MIs[1] Operand 1
     /* 1449450 */     // No operand predicates
     /* 1449450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449454 */     // MIs[0] policy
     /* 1449454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449466 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1449469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449491 */     // GIR_Coverage, 7014,
     /* 1449491 */     GIR_EraseRootFromParent_Done,
     /* 1449492 */   // Label 20395: @1449492
     /* 1449492 */   GIM_Try, /*On fail goto*//*Label 20396*/ GIMT_Encode4(1449589), // Rule ID 7015 //
     /* 1449497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1449508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1449511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1449514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449547 */     // MIs[1] Operand 1
     /* 1449547 */     // No operand predicates
     /* 1449547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449551 */     // MIs[0] policy
     /* 1449551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449563 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1449566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449588 */     // GIR_Coverage, 7015,
     /* 1449588 */     GIR_EraseRootFromParent_Done,
     /* 1449589 */   // Label 20396: @1449589
     /* 1449589 */   GIM_Try, /*On fail goto*//*Label 20397*/ GIMT_Encode4(1449686), // Rule ID 7018 //
     /* 1449594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1449605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1449608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1449611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1449617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449644 */     // MIs[1] Operand 1
     /* 1449644 */     // No operand predicates
     /* 1449644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449648 */     // MIs[0] policy
     /* 1449648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449660 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1449663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449685 */     // GIR_Coverage, 7018,
     /* 1449685 */     GIR_EraseRootFromParent_Done,
     /* 1449686 */   // Label 20397: @1449686
     /* 1449686 */   GIM_Try, /*On fail goto*//*Label 20398*/ GIMT_Encode4(1449783), // Rule ID 7019 //
     /* 1449691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1449702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1449705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1449708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1449714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449741 */     // MIs[1] Operand 1
     /* 1449741 */     // No operand predicates
     /* 1449741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449745 */     // MIs[0] policy
     /* 1449745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449757 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1449760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449782 */     // GIR_Coverage, 7019,
     /* 1449782 */     GIR_EraseRootFromParent_Done,
     /* 1449783 */   // Label 20398: @1449783
     /* 1449783 */   GIM_Try, /*On fail goto*//*Label 20399*/ GIMT_Encode4(1449880), // Rule ID 7022 //
     /* 1449788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1449799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1449802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1449805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449838 */     // MIs[1] Operand 1
     /* 1449838 */     // No operand predicates
     /* 1449838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449842 */     // MIs[0] policy
     /* 1449842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449854 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1449857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449879 */     // GIR_Coverage, 7022,
     /* 1449879 */     GIR_EraseRootFromParent_Done,
     /* 1449880 */   // Label 20399: @1449880
     /* 1449880 */   GIM_Try, /*On fail goto*//*Label 20400*/ GIMT_Encode4(1449977), // Rule ID 7023 //
     /* 1449885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1449896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1449899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1449902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449935 */     // MIs[1] Operand 1
     /* 1449935 */     // No operand predicates
     /* 1449935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449939 */     // MIs[0] policy
     /* 1449939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449951 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1449954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449976 */     // GIR_Coverage, 7023,
     /* 1449976 */     GIR_EraseRootFromParent_Done,
     /* 1449977 */   // Label 20400: @1449977
     /* 1449977 */   GIM_Try, /*On fail goto*//*Label 20401*/ GIMT_Encode4(1450074), // Rule ID 7026 //
     /* 1449982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1449993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1449996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1449999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450032 */     // MIs[1] Operand 1
     /* 1450032 */     // No operand predicates
     /* 1450032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450036 */     // MIs[0] policy
     /* 1450036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450048 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450073 */     // GIR_Coverage, 7026,
     /* 1450073 */     GIR_EraseRootFromParent_Done,
     /* 1450074 */   // Label 20401: @1450074
     /* 1450074 */   GIM_Try, /*On fail goto*//*Label 20402*/ GIMT_Encode4(1450171), // Rule ID 7027 //
     /* 1450079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1450090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1450093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1450096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450129 */     // MIs[1] Operand 1
     /* 1450129 */     // No operand predicates
     /* 1450129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450133 */     // MIs[0] policy
     /* 1450133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450145 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450170 */     // GIR_Coverage, 7027,
     /* 1450170 */     GIR_EraseRootFromParent_Done,
     /* 1450171 */   // Label 20402: @1450171
     /* 1450171 */   GIM_Try, /*On fail goto*//*Label 20403*/ GIMT_Encode4(1450268), // Rule ID 7030 //
     /* 1450176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1450187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1450190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1450193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450226 */     // MIs[1] Operand 1
     /* 1450226 */     // No operand predicates
     /* 1450226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450230 */     // MIs[0] policy
     /* 1450230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450242 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450267 */     // GIR_Coverage, 7030,
     /* 1450267 */     GIR_EraseRootFromParent_Done,
     /* 1450268 */   // Label 20403: @1450268
     /* 1450268 */   GIM_Try, /*On fail goto*//*Label 20404*/ GIMT_Encode4(1450365), // Rule ID 7031 //
     /* 1450273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1450284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1450287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1450290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450323 */     // MIs[1] Operand 1
     /* 1450323 */     // No operand predicates
     /* 1450323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450327 */     // MIs[0] policy
     /* 1450327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450339 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450364 */     // GIR_Coverage, 7031,
     /* 1450364 */     GIR_EraseRootFromParent_Done,
     /* 1450365 */   // Label 20404: @1450365
     /* 1450365 */   GIM_Try, /*On fail goto*//*Label 20405*/ GIMT_Encode4(1450462), // Rule ID 7034 //
     /* 1450370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1450381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1450384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1450387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450420 */     // MIs[1] Operand 1
     /* 1450420 */     // No operand predicates
     /* 1450420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450424 */     // MIs[0] policy
     /* 1450424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450436 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450461 */     // GIR_Coverage, 7034,
     /* 1450461 */     GIR_EraseRootFromParent_Done,
     /* 1450462 */   // Label 20405: @1450462
     /* 1450462 */   GIM_Try, /*On fail goto*//*Label 20406*/ GIMT_Encode4(1450559), // Rule ID 7035 //
     /* 1450467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1450478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1450481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1450484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450517 */     // MIs[1] Operand 1
     /* 1450517 */     // No operand predicates
     /* 1450517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450521 */     // MIs[0] policy
     /* 1450521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450533 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450558 */     // GIR_Coverage, 7035,
     /* 1450558 */     GIR_EraseRootFromParent_Done,
     /* 1450559 */   // Label 20406: @1450559
     /* 1450559 */   GIM_Try, /*On fail goto*//*Label 20407*/ GIMT_Encode4(1450656), // Rule ID 7038 //
     /* 1450564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1450575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1450578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1450581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450614 */     // MIs[1] Operand 1
     /* 1450614 */     // No operand predicates
     /* 1450614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450618 */     // MIs[0] policy
     /* 1450618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450630 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450655 */     // GIR_Coverage, 7038,
     /* 1450655 */     GIR_EraseRootFromParent_Done,
     /* 1450656 */   // Label 20407: @1450656
     /* 1450656 */   GIM_Try, /*On fail goto*//*Label 20408*/ GIMT_Encode4(1450753), // Rule ID 7039 //
     /* 1450661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1450672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1450675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1450678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450711 */     // MIs[1] Operand 1
     /* 1450711 */     // No operand predicates
     /* 1450711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450715 */     // MIs[0] policy
     /* 1450715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450727 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450752 */     // GIR_Coverage, 7039,
     /* 1450752 */     GIR_EraseRootFromParent_Done,
     /* 1450753 */   // Label 20408: @1450753
     /* 1450753 */   GIM_Try, /*On fail goto*//*Label 20409*/ GIMT_Encode4(1450850), // Rule ID 7042 //
     /* 1450758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1450769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1450772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1450775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450808 */     // MIs[1] Operand 1
     /* 1450808 */     // No operand predicates
     /* 1450808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450812 */     // MIs[0] policy
     /* 1450812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450849 */     // GIR_Coverage, 7042,
     /* 1450849 */     GIR_EraseRootFromParent_Done,
     /* 1450850 */   // Label 20409: @1450850
     /* 1450850 */   GIM_Try, /*On fail goto*//*Label 20410*/ GIMT_Encode4(1450947), // Rule ID 7043 //
     /* 1450855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1450866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1450869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1450872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450905 */     // MIs[1] Operand 1
     /* 1450905 */     // No operand predicates
     /* 1450905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450909 */     // MIs[0] policy
     /* 1450909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450921 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450946 */     // GIR_Coverage, 7043,
     /* 1450946 */     GIR_EraseRootFromParent_Done,
     /* 1450947 */   // Label 20410: @1450947
     /* 1450947 */   GIM_Try, /*On fail goto*//*Label 20411*/ GIMT_Encode4(1451044), // Rule ID 7046 //
     /* 1450952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1450955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1450963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1450966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1450969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451002 */     // MIs[1] Operand 1
     /* 1451002 */     // No operand predicates
     /* 1451002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451006 */     // MIs[0] policy
     /* 1451006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451018 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1451040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451043 */     // GIR_Coverage, 7046,
     /* 1451043 */     GIR_EraseRootFromParent_Done,
     /* 1451044 */   // Label 20411: @1451044
     /* 1451044 */   GIM_Try, /*On fail goto*//*Label 20412*/ GIMT_Encode4(1451141), // Rule ID 7047 //
     /* 1451049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1451052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1451060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1451063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1451066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1451072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451099 */     // MIs[1] Operand 1
     /* 1451099 */     // No operand predicates
     /* 1451099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451103 */     // MIs[0] policy
     /* 1451103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451115 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1451137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451140 */     // GIR_Coverage, 7047,
     /* 1451140 */     GIR_EraseRootFromParent_Done,
     /* 1451141 */   // Label 20412: @1451141
     /* 1451141 */   GIM_Try, /*On fail goto*//*Label 20413*/ GIMT_Encode4(1451238), // Rule ID 7050 //
     /* 1451146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1451157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1451160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1451163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1451169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451192 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451196 */     // MIs[1] Operand 1
     /* 1451196 */     // No operand predicates
     /* 1451196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451200 */     // MIs[0] policy
     /* 1451200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451212 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1451215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451237 */     // GIR_Coverage, 7050,
     /* 1451237 */     GIR_EraseRootFromParent_Done,
     /* 1451238 */   // Label 20413: @1451238
     /* 1451238 */   GIM_Try, /*On fail goto*//*Label 20414*/ GIMT_Encode4(1451335), // Rule ID 7051 //
     /* 1451243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1451254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1451257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1451260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1451266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451293 */     // MIs[1] Operand 1
     /* 1451293 */     // No operand predicates
     /* 1451293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451297 */     // MIs[0] policy
     /* 1451297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451309 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1451312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451334 */     // GIR_Coverage, 7051,
     /* 1451334 */     GIR_EraseRootFromParent_Done,
     /* 1451335 */   // Label 20414: @1451335
     /* 1451335 */   GIM_Try, /*On fail goto*//*Label 20415*/ GIMT_Encode4(1451432), // Rule ID 7054 //
     /* 1451340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1451351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1451354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1451357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1451363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1451370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451390 */     // MIs[1] Operand 1
     /* 1451390 */     // No operand predicates
     /* 1451390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451394 */     // MIs[0] policy
     /* 1451394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451406 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1451409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451431 */     // GIR_Coverage, 7054,
     /* 1451431 */     GIR_EraseRootFromParent_Done,
     /* 1451432 */   // Label 20415: @1451432
     /* 1451432 */   GIM_Try, /*On fail goto*//*Label 20416*/ GIMT_Encode4(1451529), // Rule ID 7055 //
     /* 1451437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1451448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1451451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1451454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1451460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1451467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451487 */     // MIs[1] Operand 1
     /* 1451487 */     // No operand predicates
     /* 1451487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451491 */     // MIs[0] policy
     /* 1451491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451503 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1451506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451528 */     // GIR_Coverage, 7055,
     /* 1451528 */     GIR_EraseRootFromParent_Done,
     /* 1451529 */   // Label 20416: @1451529
     /* 1451529 */   GIM_Try, /*On fail goto*//*Label 20417*/ GIMT_Encode4(1451626), // Rule ID 7058 //
     /* 1451534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1451545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1451548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1451551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1451557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1451564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451584 */     // MIs[1] Operand 1
     /* 1451584 */     // No operand predicates
     /* 1451584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451588 */     // MIs[0] policy
     /* 1451588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451600 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1451603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451625 */     // GIR_Coverage, 7058,
     /* 1451625 */     GIR_EraseRootFromParent_Done,
     /* 1451626 */   // Label 20417: @1451626
     /* 1451626 */   GIM_Try, /*On fail goto*//*Label 20418*/ GIMT_Encode4(1451723), // Rule ID 7059 //
     /* 1451631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1451642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1451645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1451648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1451654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1451661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451681 */     // MIs[1] Operand 1
     /* 1451681 */     // No operand predicates
     /* 1451681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451685 */     // MIs[0] policy
     /* 1451685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451697 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1451700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451722 */     // GIR_Coverage, 7059,
     /* 1451722 */     GIR_EraseRootFromParent_Done,
     /* 1451723 */   // Label 20418: @1451723
     /* 1451723 */   GIM_Try, /*On fail goto*//*Label 20419*/ GIMT_Encode4(1451820), // Rule ID 7062 //
     /* 1451728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1451739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1451742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1451745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1451751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451778 */     // MIs[1] Operand 1
     /* 1451778 */     // No operand predicates
     /* 1451778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451782 */     // MIs[0] policy
     /* 1451782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1451797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451819 */     // GIR_Coverage, 7062,
     /* 1451819 */     GIR_EraseRootFromParent_Done,
     /* 1451820 */   // Label 20419: @1451820
     /* 1451820 */   GIM_Try, /*On fail goto*//*Label 20420*/ GIMT_Encode4(1451917), // Rule ID 7063 //
     /* 1451825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1451836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1451839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1451842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1451848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451875 */     // MIs[1] Operand 1
     /* 1451875 */     // No operand predicates
     /* 1451875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451879 */     // MIs[0] policy
     /* 1451879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451891 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1451894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451916 */     // GIR_Coverage, 7063,
     /* 1451916 */     GIR_EraseRootFromParent_Done,
     /* 1451917 */   // Label 20420: @1451917
     /* 1451917 */   GIM_Try, /*On fail goto*//*Label 20421*/ GIMT_Encode4(1452014), // Rule ID 7066 //
     /* 1451922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1451933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1451936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1451939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1451945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1451952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451972 */     // MIs[1] Operand 1
     /* 1451972 */     // No operand predicates
     /* 1451972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451976 */     // MIs[0] policy
     /* 1451976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451988 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1451991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452013 */     // GIR_Coverage, 7066,
     /* 1452013 */     GIR_EraseRootFromParent_Done,
     /* 1452014 */   // Label 20421: @1452014
     /* 1452014 */   GIM_Try, /*On fail goto*//*Label 20422*/ GIMT_Encode4(1452111), // Rule ID 7067 //
     /* 1452019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1452030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1452033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1452036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1452042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452069 */     // MIs[1] Operand 1
     /* 1452069 */     // No operand predicates
     /* 1452069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452073 */     // MIs[0] policy
     /* 1452073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452085 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1452088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452110 */     // GIR_Coverage, 7067,
     /* 1452110 */     GIR_EraseRootFromParent_Done,
     /* 1452111 */   // Label 20422: @1452111
     /* 1452111 */   GIM_Try, /*On fail goto*//*Label 20423*/ GIMT_Encode4(1452208), // Rule ID 7070 //
     /* 1452116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1452127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1452130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1452133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1452139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452166 */     // MIs[1] Operand 1
     /* 1452166 */     // No operand predicates
     /* 1452166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452170 */     // MIs[0] policy
     /* 1452170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452182 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452207 */     // GIR_Coverage, 7070,
     /* 1452207 */     GIR_EraseRootFromParent_Done,
     /* 1452208 */   // Label 20423: @1452208
     /* 1452208 */   GIM_Try, /*On fail goto*//*Label 20424*/ GIMT_Encode4(1452305), // Rule ID 7071 //
     /* 1452213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1452224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1452227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1452230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1452236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452263 */     // MIs[1] Operand 1
     /* 1452263 */     // No operand predicates
     /* 1452263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452267 */     // MIs[0] policy
     /* 1452267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452279 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452304 */     // GIR_Coverage, 7071,
     /* 1452304 */     GIR_EraseRootFromParent_Done,
     /* 1452305 */   // Label 20424: @1452305
     /* 1452305 */   GIM_Try, /*On fail goto*//*Label 20425*/ GIMT_Encode4(1452402), // Rule ID 7074 //
     /* 1452310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1452321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1452324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1452327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452360 */     // MIs[1] Operand 1
     /* 1452360 */     // No operand predicates
     /* 1452360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452364 */     // MIs[0] policy
     /* 1452364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452401 */     // GIR_Coverage, 7074,
     /* 1452401 */     GIR_EraseRootFromParent_Done,
     /* 1452402 */   // Label 20425: @1452402
     /* 1452402 */   GIM_Try, /*On fail goto*//*Label 20426*/ GIMT_Encode4(1452499), // Rule ID 7075 //
     /* 1452407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1452418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1452421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1452424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452457 */     // MIs[1] Operand 1
     /* 1452457 */     // No operand predicates
     /* 1452457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452461 */     // MIs[0] policy
     /* 1452461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452473 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452498 */     // GIR_Coverage, 7075,
     /* 1452498 */     GIR_EraseRootFromParent_Done,
     /* 1452499 */   // Label 20426: @1452499
     /* 1452499 */   GIM_Try, /*On fail goto*//*Label 20427*/ GIMT_Encode4(1452596), // Rule ID 7078 //
     /* 1452504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1452515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1452518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1452521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452554 */     // MIs[1] Operand 1
     /* 1452554 */     // No operand predicates
     /* 1452554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452558 */     // MIs[0] policy
     /* 1452558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452570 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1452573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452595 */     // GIR_Coverage, 7078,
     /* 1452595 */     GIR_EraseRootFromParent_Done,
     /* 1452596 */   // Label 20427: @1452596
     /* 1452596 */   GIM_Try, /*On fail goto*//*Label 20428*/ GIMT_Encode4(1452693), // Rule ID 7079 //
     /* 1452601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1452612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1452615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1452618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452651 */     // MIs[1] Operand 1
     /* 1452651 */     // No operand predicates
     /* 1452651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452655 */     // MIs[0] policy
     /* 1452655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452667 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1452670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452692 */     // GIR_Coverage, 7079,
     /* 1452692 */     GIR_EraseRootFromParent_Done,
     /* 1452693 */   // Label 20428: @1452693
     /* 1452693 */   GIM_Try, /*On fail goto*//*Label 20429*/ GIMT_Encode4(1452790), // Rule ID 7082 //
     /* 1452698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1452709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1452712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1452715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1452721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452744 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452748 */     // MIs[1] Operand 1
     /* 1452748 */     // No operand predicates
     /* 1452748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452752 */     // MIs[0] policy
     /* 1452752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452764 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452789 */     // GIR_Coverage, 7082,
     /* 1452789 */     GIR_EraseRootFromParent_Done,
     /* 1452790 */   // Label 20429: @1452790
     /* 1452790 */   GIM_Try, /*On fail goto*//*Label 20430*/ GIMT_Encode4(1452887), // Rule ID 7083 //
     /* 1452795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1452806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1452809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1452812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1452818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452845 */     // MIs[1] Operand 1
     /* 1452845 */     // No operand predicates
     /* 1452845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452849 */     // MIs[0] policy
     /* 1452849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452861 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452886 */     // GIR_Coverage, 7083,
     /* 1452886 */     GIR_EraseRootFromParent_Done,
     /* 1452887 */   // Label 20430: @1452887
     /* 1452887 */   GIM_Try, /*On fail goto*//*Label 20431*/ GIMT_Encode4(1452984), // Rule ID 7086 //
     /* 1452892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1452895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1452903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1452906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1452909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1452915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452942 */     // MIs[1] Operand 1
     /* 1452942 */     // No operand predicates
     /* 1452942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452946 */     // MIs[0] policy
     /* 1452946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452958 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1452980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452983 */     // GIR_Coverage, 7086,
     /* 1452983 */     GIR_EraseRootFromParent_Done,
     /* 1452984 */   // Label 20431: @1452984
     /* 1452984 */   GIM_Try, /*On fail goto*//*Label 20432*/ GIMT_Encode4(1453081), // Rule ID 7087 //
     /* 1452989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1452992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1453000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1453003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1453006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453039 */     // MIs[1] Operand 1
     /* 1453039 */     // No operand predicates
     /* 1453039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453043 */     // MIs[0] policy
     /* 1453043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453055 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1453058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453080 */     // GIR_Coverage, 7087,
     /* 1453080 */     GIR_EraseRootFromParent_Done,
     /* 1453081 */   // Label 20432: @1453081
     /* 1453081 */   GIM_Try, /*On fail goto*//*Label 20433*/ GIMT_Encode4(1453178), // Rule ID 7090 //
     /* 1453086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1453089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1453097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1453100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1453103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453136 */     // MIs[1] Operand 1
     /* 1453136 */     // No operand predicates
     /* 1453136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453140 */     // MIs[0] policy
     /* 1453140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453152 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1453155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453177 */     // GIR_Coverage, 7090,
     /* 1453177 */     GIR_EraseRootFromParent_Done,
     /* 1453178 */   // Label 20433: @1453178
     /* 1453178 */   GIM_Try, /*On fail goto*//*Label 20434*/ GIMT_Encode4(1453275), // Rule ID 7091 //
     /* 1453183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1453186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1453194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1453197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1453200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453233 */     // MIs[1] Operand 1
     /* 1453233 */     // No operand predicates
     /* 1453233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453237 */     // MIs[0] policy
     /* 1453237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453249 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1453252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453274 */     // GIR_Coverage, 7091,
     /* 1453274 */     GIR_EraseRootFromParent_Done,
     /* 1453275 */   // Label 20434: @1453275
     /* 1453275 */   GIM_Try, /*On fail goto*//*Label 20435*/ GIMT_Encode4(1453372), // Rule ID 7094 //
     /* 1453280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1453283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1453291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1453294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1453297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453330 */     // MIs[1] Operand 1
     /* 1453330 */     // No operand predicates
     /* 1453330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453334 */     // MIs[0] policy
     /* 1453334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1453349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453371 */     // GIR_Coverage, 7094,
     /* 1453371 */     GIR_EraseRootFromParent_Done,
     /* 1453372 */   // Label 20435: @1453372
     /* 1453372 */   GIM_Try, /*On fail goto*//*Label 20436*/ GIMT_Encode4(1453469), // Rule ID 7095 //
     /* 1453377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1453380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1453388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1453391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1453394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453427 */     // MIs[1] Operand 1
     /* 1453427 */     // No operand predicates
     /* 1453427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453431 */     // MIs[0] policy
     /* 1453431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453443 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1453446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453468 */     // GIR_Coverage, 7095,
     /* 1453468 */     GIR_EraseRootFromParent_Done,
     /* 1453469 */   // Label 20436: @1453469
     /* 1453469 */   GIM_Try, /*On fail goto*//*Label 20437*/ GIMT_Encode4(1453566), // Rule ID 7274 //
     /* 1453474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1453485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1453488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1453491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1453497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453524 */     // MIs[1] Operand 1
     /* 1453524 */     // No operand predicates
     /* 1453524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453528 */     // MIs[0] policy
     /* 1453528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453540 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1453543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453565 */     // GIR_Coverage, 7274,
     /* 1453565 */     GIR_EraseRootFromParent_Done,
     /* 1453566 */   // Label 20437: @1453566
     /* 1453566 */   GIM_Try, /*On fail goto*//*Label 20438*/ GIMT_Encode4(1453663), // Rule ID 7275 //
     /* 1453571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1453582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1453585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1453588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1453594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453621 */     // MIs[1] Operand 1
     /* 1453621 */     // No operand predicates
     /* 1453621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453625 */     // MIs[0] policy
     /* 1453625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453637 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1453640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453662 */     // GIR_Coverage, 7275,
     /* 1453662 */     GIR_EraseRootFromParent_Done,
     /* 1453663 */   // Label 20438: @1453663
     /* 1453663 */   GIM_Try, /*On fail goto*//*Label 20439*/ GIMT_Encode4(1453760), // Rule ID 7278 //
     /* 1453668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1453679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1453682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1453685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453718 */     // MIs[1] Operand 1
     /* 1453718 */     // No operand predicates
     /* 1453718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453722 */     // MIs[0] policy
     /* 1453722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453734 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1453737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453759 */     // GIR_Coverage, 7278,
     /* 1453759 */     GIR_EraseRootFromParent_Done,
     /* 1453760 */   // Label 20439: @1453760
     /* 1453760 */   GIM_Try, /*On fail goto*//*Label 20440*/ GIMT_Encode4(1453857), // Rule ID 7279 //
     /* 1453765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1453776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1453779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1453782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453815 */     // MIs[1] Operand 1
     /* 1453815 */     // No operand predicates
     /* 1453815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453819 */     // MIs[0] policy
     /* 1453819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453831 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1453834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453856 */     // GIR_Coverage, 7279,
     /* 1453856 */     GIR_EraseRootFromParent_Done,
     /* 1453857 */   // Label 20440: @1453857
     /* 1453857 */   GIM_Try, /*On fail goto*//*Label 20441*/ GIMT_Encode4(1453954), // Rule ID 7282 //
     /* 1453862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1453873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1453876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1453879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453912 */     // MIs[1] Operand 1
     /* 1453912 */     // No operand predicates
     /* 1453912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453916 */     // MIs[0] policy
     /* 1453916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453928 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1453931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453953 */     // GIR_Coverage, 7282,
     /* 1453953 */     GIR_EraseRootFromParent_Done,
     /* 1453954 */   // Label 20441: @1453954
     /* 1453954 */   GIM_Try, /*On fail goto*//*Label 20442*/ GIMT_Encode4(1454051), // Rule ID 7283 //
     /* 1453959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1453970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1453973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1453976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454009 */     // MIs[1] Operand 1
     /* 1454009 */     // No operand predicates
     /* 1454009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454013 */     // MIs[0] policy
     /* 1454013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454025 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454050 */     // GIR_Coverage, 7283,
     /* 1454050 */     GIR_EraseRootFromParent_Done,
     /* 1454051 */   // Label 20442: @1454051
     /* 1454051 */   GIM_Try, /*On fail goto*//*Label 20443*/ GIMT_Encode4(1454148), // Rule ID 7286 //
     /* 1454056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1454067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1454070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1454073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454106 */     // MIs[1] Operand 1
     /* 1454106 */     // No operand predicates
     /* 1454106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454110 */     // MIs[0] policy
     /* 1454110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454122 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1454125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454147 */     // GIR_Coverage, 7286,
     /* 1454147 */     GIR_EraseRootFromParent_Done,
     /* 1454148 */   // Label 20443: @1454148
     /* 1454148 */   GIM_Try, /*On fail goto*//*Label 20444*/ GIMT_Encode4(1454245), // Rule ID 7287 //
     /* 1454153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1454164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1454167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1454170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454203 */     // MIs[1] Operand 1
     /* 1454203 */     // No operand predicates
     /* 1454203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454207 */     // MIs[0] policy
     /* 1454207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454219 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1454222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454244 */     // GIR_Coverage, 7287,
     /* 1454244 */     GIR_EraseRootFromParent_Done,
     /* 1454245 */   // Label 20444: @1454245
     /* 1454245 */   GIM_Try, /*On fail goto*//*Label 20445*/ GIMT_Encode4(1454342), // Rule ID 7290 //
     /* 1454250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1454261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1454264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1454267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454300 */     // MIs[1] Operand 1
     /* 1454300 */     // No operand predicates
     /* 1454300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454304 */     // MIs[0] policy
     /* 1454304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454316 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454341 */     // GIR_Coverage, 7290,
     /* 1454341 */     GIR_EraseRootFromParent_Done,
     /* 1454342 */   // Label 20445: @1454342
     /* 1454342 */   GIM_Try, /*On fail goto*//*Label 20446*/ GIMT_Encode4(1454439), // Rule ID 7291 //
     /* 1454347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1454358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1454361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1454364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454397 */     // MIs[1] Operand 1
     /* 1454397 */     // No operand predicates
     /* 1454397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454401 */     // MIs[0] policy
     /* 1454401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454413 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454438 */     // GIR_Coverage, 7291,
     /* 1454438 */     GIR_EraseRootFromParent_Done,
     /* 1454439 */   // Label 20446: @1454439
     /* 1454439 */   GIM_Try, /*On fail goto*//*Label 20447*/ GIMT_Encode4(1454536), // Rule ID 7294 //
     /* 1454444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1454455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1454458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1454461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454494 */     // MIs[1] Operand 1
     /* 1454494 */     // No operand predicates
     /* 1454494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454498 */     // MIs[0] policy
     /* 1454498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454510 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454535 */     // GIR_Coverage, 7294,
     /* 1454535 */     GIR_EraseRootFromParent_Done,
     /* 1454536 */   // Label 20447: @1454536
     /* 1454536 */   GIM_Try, /*On fail goto*//*Label 20448*/ GIMT_Encode4(1454633), // Rule ID 7295 //
     /* 1454541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1454552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1454555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1454558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454591 */     // MIs[1] Operand 1
     /* 1454591 */     // No operand predicates
     /* 1454591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454595 */     // MIs[0] policy
     /* 1454595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454607 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454632 */     // GIR_Coverage, 7295,
     /* 1454632 */     GIR_EraseRootFromParent_Done,
     /* 1454633 */   // Label 20448: @1454633
     /* 1454633 */   GIM_Try, /*On fail goto*//*Label 20449*/ GIMT_Encode4(1454730), // Rule ID 7298 //
     /* 1454638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1454649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1454652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1454655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1454661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454688 */     // MIs[1] Operand 1
     /* 1454688 */     // No operand predicates
     /* 1454688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454692 */     // MIs[0] policy
     /* 1454692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454704 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1454707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454729 */     // GIR_Coverage, 7298,
     /* 1454729 */     GIR_EraseRootFromParent_Done,
     /* 1454730 */   // Label 20449: @1454730
     /* 1454730 */   GIM_Try, /*On fail goto*//*Label 20450*/ GIMT_Encode4(1454827), // Rule ID 7299 //
     /* 1454735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1454746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1454749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1454752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1454758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454785 */     // MIs[1] Operand 1
     /* 1454785 */     // No operand predicates
     /* 1454785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454789 */     // MIs[0] policy
     /* 1454789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454801 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1454804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454826 */     // GIR_Coverage, 7299,
     /* 1454826 */     GIR_EraseRootFromParent_Done,
     /* 1454827 */   // Label 20450: @1454827
     /* 1454827 */   GIM_Try, /*On fail goto*//*Label 20451*/ GIMT_Encode4(1454924), // Rule ID 7302 //
     /* 1454832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1454843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1454846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1454849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454882 */     // MIs[1] Operand 1
     /* 1454882 */     // No operand predicates
     /* 1454882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454886 */     // MIs[0] policy
     /* 1454886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1454901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454923 */     // GIR_Coverage, 7302,
     /* 1454923 */     GIR_EraseRootFromParent_Done,
     /* 1454924 */   // Label 20451: @1454924
     /* 1454924 */   GIM_Try, /*On fail goto*//*Label 20452*/ GIMT_Encode4(1455021), // Rule ID 7303 //
     /* 1454929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1454940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1454943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1454946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454979 */     // MIs[1] Operand 1
     /* 1454979 */     // No operand predicates
     /* 1454979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454983 */     // MIs[0] policy
     /* 1454983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454995 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1454998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455020 */     // GIR_Coverage, 7303,
     /* 1455020 */     GIR_EraseRootFromParent_Done,
     /* 1455021 */   // Label 20452: @1455021
     /* 1455021 */   GIM_Try, /*On fail goto*//*Label 20453*/ GIMT_Encode4(1455118), // Rule ID 7306 //
     /* 1455026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1455037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1455040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1455043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1455049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455076 */     // MIs[1] Operand 1
     /* 1455076 */     // No operand predicates
     /* 1455076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455080 */     // MIs[0] policy
     /* 1455080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455092 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1455114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455117 */     // GIR_Coverage, 7306,
     /* 1455117 */     GIR_EraseRootFromParent_Done,
     /* 1455118 */   // Label 20453: @1455118
     /* 1455118 */   GIM_Try, /*On fail goto*//*Label 20454*/ GIMT_Encode4(1455215), // Rule ID 7307 //
     /* 1455123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1455134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1455137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1455140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1455146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455173 */     // MIs[1] Operand 1
     /* 1455173 */     // No operand predicates
     /* 1455173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455177 */     // MIs[0] policy
     /* 1455177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455189 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1455211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455214 */     // GIR_Coverage, 7307,
     /* 1455214 */     GIR_EraseRootFromParent_Done,
     /* 1455215 */   // Label 20454: @1455215
     /* 1455215 */   GIM_Try, /*On fail goto*//*Label 20455*/ GIMT_Encode4(1455312), // Rule ID 7310 //
     /* 1455220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1455223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1455231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1455234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1455237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455270 */     // MIs[1] Operand 1
     /* 1455270 */     // No operand predicates
     /* 1455270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455274 */     // MIs[0] policy
     /* 1455274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455286 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455311 */     // GIR_Coverage, 7310,
     /* 1455311 */     GIR_EraseRootFromParent_Done,
     /* 1455312 */   // Label 20455: @1455312
     /* 1455312 */   GIM_Try, /*On fail goto*//*Label 20456*/ GIMT_Encode4(1455409), // Rule ID 7311 //
     /* 1455317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1455320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1455328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1455331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1455334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455367 */     // MIs[1] Operand 1
     /* 1455367 */     // No operand predicates
     /* 1455367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455371 */     // MIs[0] policy
     /* 1455371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455383 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455408 */     // GIR_Coverage, 7311,
     /* 1455408 */     GIR_EraseRootFromParent_Done,
     /* 1455409 */   // Label 20456: @1455409
     /* 1455409 */   GIM_Try, /*On fail goto*//*Label 20457*/ GIMT_Encode4(1455506), // Rule ID 7314 //
     /* 1455414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1455425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1455428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1455431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1455437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455464 */     // MIs[1] Operand 1
     /* 1455464 */     // No operand predicates
     /* 1455464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455468 */     // MIs[0] policy
     /* 1455468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455480 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1455483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455505 */     // GIR_Coverage, 7314,
     /* 1455505 */     GIR_EraseRootFromParent_Done,
     /* 1455506 */   // Label 20457: @1455506
     /* 1455506 */   GIM_Try, /*On fail goto*//*Label 20458*/ GIMT_Encode4(1455603), // Rule ID 7315 //
     /* 1455511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1455522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1455525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1455528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1455534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455561 */     // MIs[1] Operand 1
     /* 1455561 */     // No operand predicates
     /* 1455561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455565 */     // MIs[0] policy
     /* 1455565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455577 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1455580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455602 */     // GIR_Coverage, 7315,
     /* 1455602 */     GIR_EraseRootFromParent_Done,
     /* 1455603 */   // Label 20458: @1455603
     /* 1455603 */   GIM_Try, /*On fail goto*//*Label 20459*/ GIMT_Encode4(1455700), // Rule ID 7318 //
     /* 1455608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1455619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1455622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1455625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1455631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455658 */     // MIs[1] Operand 1
     /* 1455658 */     // No operand predicates
     /* 1455658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455662 */     // MIs[0] policy
     /* 1455662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455674 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1455677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455699 */     // GIR_Coverage, 7318,
     /* 1455699 */     GIR_EraseRootFromParent_Done,
     /* 1455700 */   // Label 20459: @1455700
     /* 1455700 */   GIM_Try, /*On fail goto*//*Label 20460*/ GIMT_Encode4(1455797), // Rule ID 7319 //
     /* 1455705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1455716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1455719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1455722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1455728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455755 */     // MIs[1] Operand 1
     /* 1455755 */     // No operand predicates
     /* 1455755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455759 */     // MIs[0] policy
     /* 1455759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455771 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1455774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455796 */     // GIR_Coverage, 7319,
     /* 1455796 */     GIR_EraseRootFromParent_Done,
     /* 1455797 */   // Label 20460: @1455797
     /* 1455797 */   GIM_Try, /*On fail goto*//*Label 20461*/ GIMT_Encode4(1455894), // Rule ID 7322 //
     /* 1455802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1455813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1455816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1455819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1455825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1455832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455852 */     // MIs[1] Operand 1
     /* 1455852 */     // No operand predicates
     /* 1455852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455856 */     // MIs[0] policy
     /* 1455856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455868 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1455871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455893 */     // GIR_Coverage, 7322,
     /* 1455893 */     GIR_EraseRootFromParent_Done,
     /* 1455894 */   // Label 20461: @1455894
     /* 1455894 */   GIM_Try, /*On fail goto*//*Label 20462*/ GIMT_Encode4(1455991), // Rule ID 7323 //
     /* 1455899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1455910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1455913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1455916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1455922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1455929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455949 */     // MIs[1] Operand 1
     /* 1455949 */     // No operand predicates
     /* 1455949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455953 */     // MIs[0] policy
     /* 1455953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455965 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1455968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455990 */     // GIR_Coverage, 7323,
     /* 1455990 */     GIR_EraseRootFromParent_Done,
     /* 1455991 */   // Label 20462: @1455991
     /* 1455991 */   GIM_Try, /*On fail goto*//*Label 20463*/ GIMT_Encode4(1456088), // Rule ID 7326 //
     /* 1455996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1456007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1456010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1456013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456046 */     // MIs[1] Operand 1
     /* 1456046 */     // No operand predicates
     /* 1456046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456050 */     // MIs[0] policy
     /* 1456050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456062 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456087 */     // GIR_Coverage, 7326,
     /* 1456087 */     GIR_EraseRootFromParent_Done,
     /* 1456088 */   // Label 20463: @1456088
     /* 1456088 */   GIM_Try, /*On fail goto*//*Label 20464*/ GIMT_Encode4(1456185), // Rule ID 7327 //
     /* 1456093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1456104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1456107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1456110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456143 */     // MIs[1] Operand 1
     /* 1456143 */     // No operand predicates
     /* 1456143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456147 */     // MIs[0] policy
     /* 1456147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456159 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456184 */     // GIR_Coverage, 7327,
     /* 1456184 */     GIR_EraseRootFromParent_Done,
     /* 1456185 */   // Label 20464: @1456185
     /* 1456185 */   GIM_Try, /*On fail goto*//*Label 20465*/ GIMT_Encode4(1456282), // Rule ID 7330 //
     /* 1456190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1456201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1456204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1456207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456240 */     // MIs[1] Operand 1
     /* 1456240 */     // No operand predicates
     /* 1456240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456244 */     // MIs[0] policy
     /* 1456244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456256 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456281 */     // GIR_Coverage, 7330,
     /* 1456281 */     GIR_EraseRootFromParent_Done,
     /* 1456282 */   // Label 20465: @1456282
     /* 1456282 */   GIM_Try, /*On fail goto*//*Label 20466*/ GIMT_Encode4(1456379), // Rule ID 7331 //
     /* 1456287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1456298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1456301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1456304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456337 */     // MIs[1] Operand 1
     /* 1456337 */     // No operand predicates
     /* 1456337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456341 */     // MIs[0] policy
     /* 1456341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456353 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456378 */     // GIR_Coverage, 7331,
     /* 1456378 */     GIR_EraseRootFromParent_Done,
     /* 1456379 */   // Label 20466: @1456379
     /* 1456379 */   GIM_Try, /*On fail goto*//*Label 20467*/ GIMT_Encode4(1456476), // Rule ID 7334 //
     /* 1456384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1456395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1456398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1456401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456434 */     // MIs[1] Operand 1
     /* 1456434 */     // No operand predicates
     /* 1456434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456438 */     // MIs[0] policy
     /* 1456438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456450 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1456453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456475 */     // GIR_Coverage, 7334,
     /* 1456475 */     GIR_EraseRootFromParent_Done,
     /* 1456476 */   // Label 20467: @1456476
     /* 1456476 */   GIM_Try, /*On fail goto*//*Label 20468*/ GIMT_Encode4(1456573), // Rule ID 7335 //
     /* 1456481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1456492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1456495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1456498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456531 */     // MIs[1] Operand 1
     /* 1456531 */     // No operand predicates
     /* 1456531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456535 */     // MIs[0] policy
     /* 1456535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456547 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1456550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456572 */     // GIR_Coverage, 7335,
     /* 1456572 */     GIR_EraseRootFromParent_Done,
     /* 1456573 */   // Label 20468: @1456573
     /* 1456573 */   GIM_Try, /*On fail goto*//*Label 20469*/ GIMT_Encode4(1456670), // Rule ID 7338 //
     /* 1456578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1456589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1456592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1456595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1456601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456628 */     // MIs[1] Operand 1
     /* 1456628 */     // No operand predicates
     /* 1456628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456632 */     // MIs[0] policy
     /* 1456632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456669 */     // GIR_Coverage, 7338,
     /* 1456669 */     GIR_EraseRootFromParent_Done,
     /* 1456670 */   // Label 20469: @1456670
     /* 1456670 */   GIM_Try, /*On fail goto*//*Label 20470*/ GIMT_Encode4(1456767), // Rule ID 7339 //
     /* 1456675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1456686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1456689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1456692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1456698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456725 */     // MIs[1] Operand 1
     /* 1456725 */     // No operand predicates
     /* 1456725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456729 */     // MIs[0] policy
     /* 1456729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456741 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456766 */     // GIR_Coverage, 7339,
     /* 1456766 */     GIR_EraseRootFromParent_Done,
     /* 1456767 */   // Label 20470: @1456767
     /* 1456767 */   GIM_Try, /*On fail goto*//*Label 20471*/ GIMT_Encode4(1456864), // Rule ID 7342 //
     /* 1456772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1456783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1456786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1456789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456822 */     // MIs[1] Operand 1
     /* 1456822 */     // No operand predicates
     /* 1456822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456826 */     // MIs[0] policy
     /* 1456826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456838 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456863 */     // GIR_Coverage, 7342,
     /* 1456863 */     GIR_EraseRootFromParent_Done,
     /* 1456864 */   // Label 20471: @1456864
     /* 1456864 */   GIM_Try, /*On fail goto*//*Label 20472*/ GIMT_Encode4(1456961), // Rule ID 7343 //
     /* 1456869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1456880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1456883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1456886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456919 */     // MIs[1] Operand 1
     /* 1456919 */     // No operand predicates
     /* 1456919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456923 */     // MIs[0] policy
     /* 1456923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456935 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456960 */     // GIR_Coverage, 7343,
     /* 1456960 */     GIR_EraseRootFromParent_Done,
     /* 1456961 */   // Label 20472: @1456961
     /* 1456961 */   GIM_Try, /*On fail goto*//*Label 20473*/ GIMT_Encode4(1457058), // Rule ID 7346 //
     /* 1456966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1456977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1456980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1456983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457016 */     // MIs[1] Operand 1
     /* 1457016 */     // No operand predicates
     /* 1457016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457020 */     // MIs[0] policy
     /* 1457020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457032 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457057 */     // GIR_Coverage, 7346,
     /* 1457057 */     GIR_EraseRootFromParent_Done,
     /* 1457058 */   // Label 20473: @1457058
     /* 1457058 */   GIM_Try, /*On fail goto*//*Label 20474*/ GIMT_Encode4(1457155), // Rule ID 7347 //
     /* 1457063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1457074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1457077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1457080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1457086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1457093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457113 */     // MIs[1] Operand 1
     /* 1457113 */     // No operand predicates
     /* 1457113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457117 */     // MIs[0] policy
     /* 1457117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457129 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457154 */     // GIR_Coverage, 7347,
     /* 1457154 */     GIR_EraseRootFromParent_Done,
     /* 1457155 */   // Label 20474: @1457155
     /* 1457155 */   GIM_Try, /*On fail goto*//*Label 20475*/ GIMT_Encode4(1457252), // Rule ID 7350 //
     /* 1457160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1457163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1457171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1457174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1457177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457210 */     // MIs[1] Operand 1
     /* 1457210 */     // No operand predicates
     /* 1457210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457214 */     // MIs[0] policy
     /* 1457214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1457229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457251 */     // GIR_Coverage, 7350,
     /* 1457251 */     GIR_EraseRootFromParent_Done,
     /* 1457252 */   // Label 20475: @1457252
     /* 1457252 */   GIM_Try, /*On fail goto*//*Label 20476*/ GIMT_Encode4(1457349), // Rule ID 7351 //
     /* 1457257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1457260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1457268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1457271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1457274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457307 */     // MIs[1] Operand 1
     /* 1457307 */     // No operand predicates
     /* 1457307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457311 */     // MIs[0] policy
     /* 1457311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457323 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1457326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457348 */     // GIR_Coverage, 7351,
     /* 1457348 */     GIR_EraseRootFromParent_Done,
     /* 1457349 */   // Label 20476: @1457349
     /* 1457349 */   GIM_Try, /*On fail goto*//*Label 20477*/ GIMT_Encode4(1457446), // Rule ID 7354 //
     /* 1457354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1457357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1457365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1457368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1457371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457404 */     // MIs[1] Operand 1
     /* 1457404 */     // No operand predicates
     /* 1457404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457408 */     // MIs[0] policy
     /* 1457408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457420 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1457423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457445 */     // GIR_Coverage, 7354,
     /* 1457445 */     GIR_EraseRootFromParent_Done,
     /* 1457446 */   // Label 20477: @1457446
     /* 1457446 */   GIM_Try, /*On fail goto*//*Label 20478*/ GIMT_Encode4(1457543), // Rule ID 7355 //
     /* 1457451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1457454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1457462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1457465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1457468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457501 */     // MIs[1] Operand 1
     /* 1457501 */     // No operand predicates
     /* 1457501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457505 */     // MIs[0] policy
     /* 1457505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457517 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1457520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457542 */     // GIR_Coverage, 7355,
     /* 1457542 */     GIR_EraseRootFromParent_Done,
     /* 1457543 */   // Label 20478: @1457543
     /* 1457543 */   GIM_Try, /*On fail goto*//*Label 20479*/ GIMT_Encode4(1457640), // Rule ID 7358 //
     /* 1457548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1457551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1457559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1457562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1457565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1457571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1457578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457598 */     // MIs[1] Operand 1
     /* 1457598 */     // No operand predicates
     /* 1457598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457602 */     // MIs[0] policy
     /* 1457602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457614 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457639 */     // GIR_Coverage, 7358,
     /* 1457639 */     GIR_EraseRootFromParent_Done,
     /* 1457640 */   // Label 20479: @1457640
     /* 1457640 */   GIM_Try, /*On fail goto*//*Label 20480*/ GIMT_Encode4(1457737), // Rule ID 7359 //
     /* 1457645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1457648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1457656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1457659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1457662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1457668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1457675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457695 */     // MIs[1] Operand 1
     /* 1457695 */     // No operand predicates
     /* 1457695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457699 */     // MIs[0] policy
     /* 1457699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457711 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457736 */     // GIR_Coverage, 7359,
     /* 1457736 */     GIR_EraseRootFromParent_Done,
     /* 1457737 */   // Label 20480: @1457737
     /* 1457737 */   GIM_Try, /*On fail goto*//*Label 20481*/ GIMT_Encode4(1457834), // Rule ID 7570 //
     /* 1457742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1457753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1457756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1457759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1457765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457792 */     // MIs[1] Operand 1
     /* 1457792 */     // No operand predicates
     /* 1457792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457796 */     // MIs[0] policy
     /* 1457796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457808 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1457811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457833 */     // GIR_Coverage, 7570,
     /* 1457833 */     GIR_EraseRootFromParent_Done,
     /* 1457834 */   // Label 20481: @1457834
     /* 1457834 */   GIM_Try, /*On fail goto*//*Label 20482*/ GIMT_Encode4(1457931), // Rule ID 7571 //
     /* 1457839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1457850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1457853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1457856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1457862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457889 */     // MIs[1] Operand 1
     /* 1457889 */     // No operand predicates
     /* 1457889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457893 */     // MIs[0] policy
     /* 1457893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457905 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1457908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457930 */     // GIR_Coverage, 7571,
     /* 1457930 */     GIR_EraseRootFromParent_Done,
     /* 1457931 */   // Label 20482: @1457931
     /* 1457931 */   GIM_Try, /*On fail goto*//*Label 20483*/ GIMT_Encode4(1458028), // Rule ID 7574 //
     /* 1457936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1457947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1457950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1457953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457986 */     // MIs[1] Operand 1
     /* 1457986 */     // No operand predicates
     /* 1457986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457990 */     // MIs[0] policy
     /* 1457990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1458005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458027 */     // GIR_Coverage, 7574,
     /* 1458027 */     GIR_EraseRootFromParent_Done,
     /* 1458028 */   // Label 20483: @1458028
     /* 1458028 */   GIM_Try, /*On fail goto*//*Label 20484*/ GIMT_Encode4(1458125), // Rule ID 7575 //
     /* 1458033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1458044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1458047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1458050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458083 */     // MIs[1] Operand 1
     /* 1458083 */     // No operand predicates
     /* 1458083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458087 */     // MIs[0] policy
     /* 1458087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458099 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1458102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458124 */     // GIR_Coverage, 7575,
     /* 1458124 */     GIR_EraseRootFromParent_Done,
     /* 1458125 */   // Label 20484: @1458125
     /* 1458125 */   GIM_Try, /*On fail goto*//*Label 20485*/ GIMT_Encode4(1458222), // Rule ID 7578 //
     /* 1458130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1458141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1458144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458176 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458180 */     // MIs[1] Operand 1
     /* 1458180 */     // No operand predicates
     /* 1458180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458184 */     // MIs[0] policy
     /* 1458184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1458199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458221 */     // GIR_Coverage, 7578,
     /* 1458221 */     GIR_EraseRootFromParent_Done,
     /* 1458222 */   // Label 20485: @1458222
     /* 1458222 */   GIM_Try, /*On fail goto*//*Label 20486*/ GIMT_Encode4(1458319), // Rule ID 7579 //
     /* 1458227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1458238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1458241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458277 */     // MIs[1] Operand 1
     /* 1458277 */     // No operand predicates
     /* 1458277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458281 */     // MIs[0] policy
     /* 1458281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458293 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1458296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458318 */     // GIR_Coverage, 7579,
     /* 1458318 */     GIR_EraseRootFromParent_Done,
     /* 1458319 */   // Label 20486: @1458319
     /* 1458319 */   GIM_Try, /*On fail goto*//*Label 20487*/ GIMT_Encode4(1458416), // Rule ID 7582 //
     /* 1458324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1458335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1458338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1458341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458374 */     // MIs[1] Operand 1
     /* 1458374 */     // No operand predicates
     /* 1458374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458378 */     // MIs[0] policy
     /* 1458378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458390 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1458393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458415 */     // GIR_Coverage, 7582,
     /* 1458415 */     GIR_EraseRootFromParent_Done,
     /* 1458416 */   // Label 20487: @1458416
     /* 1458416 */   GIM_Try, /*On fail goto*//*Label 20488*/ GIMT_Encode4(1458513), // Rule ID 7583 //
     /* 1458421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1458432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1458435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1458438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458471 */     // MIs[1] Operand 1
     /* 1458471 */     // No operand predicates
     /* 1458471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458475 */     // MIs[0] policy
     /* 1458475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458487 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1458490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458512 */     // GIR_Coverage, 7583,
     /* 1458512 */     GIR_EraseRootFromParent_Done,
     /* 1458513 */   // Label 20488: @1458513
     /* 1458513 */   GIM_Try, /*On fail goto*//*Label 20489*/ GIMT_Encode4(1458610), // Rule ID 7586 //
     /* 1458518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1458529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1458532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1458535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1458541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1458548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458568 */     // MIs[1] Operand 1
     /* 1458568 */     // No operand predicates
     /* 1458568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458572 */     // MIs[0] policy
     /* 1458572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1458587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458609 */     // GIR_Coverage, 7586,
     /* 1458609 */     GIR_EraseRootFromParent_Done,
     /* 1458610 */   // Label 20489: @1458610
     /* 1458610 */   GIM_Try, /*On fail goto*//*Label 20490*/ GIMT_Encode4(1458707), // Rule ID 7587 //
     /* 1458615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1458626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1458629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1458632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1458638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1458645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458665 */     // MIs[1] Operand 1
     /* 1458665 */     // No operand predicates
     /* 1458665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458669 */     // MIs[0] policy
     /* 1458669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458681 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1458684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458706 */     // GIR_Coverage, 7587,
     /* 1458706 */     GIR_EraseRootFromParent_Done,
     /* 1458707 */   // Label 20490: @1458707
     /* 1458707 */   GIM_Try, /*On fail goto*//*Label 20491*/ GIMT_Encode4(1458804), // Rule ID 7590 //
     /* 1458712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1458723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1458726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1458729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1458735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1458742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458762 */     // MIs[1] Operand 1
     /* 1458762 */     // No operand predicates
     /* 1458762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458766 */     // MIs[0] policy
     /* 1458766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458778 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1458781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458803 */     // GIR_Coverage, 7590,
     /* 1458803 */     GIR_EraseRootFromParent_Done,
     /* 1458804 */   // Label 20491: @1458804
     /* 1458804 */   GIM_Try, /*On fail goto*//*Label 20492*/ GIMT_Encode4(1458901), // Rule ID 7591 //
     /* 1458809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1458820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1458823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1458826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1458832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1458839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458859 */     // MIs[1] Operand 1
     /* 1458859 */     // No operand predicates
     /* 1458859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458863 */     // MIs[0] policy
     /* 1458863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458875 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1458878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458900 */     // GIR_Coverage, 7591,
     /* 1458900 */     GIR_EraseRootFromParent_Done,
     /* 1458901 */   // Label 20492: @1458901
     /* 1458901 */   GIM_Try, /*On fail goto*//*Label 20493*/ GIMT_Encode4(1458998), // Rule ID 7594 //
     /* 1458906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1458917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1458920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1458923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458956 */     // MIs[1] Operand 1
     /* 1458956 */     // No operand predicates
     /* 1458956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458960 */     // MIs[0] policy
     /* 1458960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458972 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1458975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1458994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458997 */     // GIR_Coverage, 7594,
     /* 1458997 */     GIR_EraseRootFromParent_Done,
     /* 1458998 */   // Label 20493: @1458998
     /* 1458998 */   GIM_Try, /*On fail goto*//*Label 20494*/ GIMT_Encode4(1459095), // Rule ID 7595 //
     /* 1459003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1459014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1459017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1459020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459053 */     // MIs[1] Operand 1
     /* 1459053 */     // No operand predicates
     /* 1459053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459057 */     // MIs[0] policy
     /* 1459057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459069 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1459072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459094 */     // GIR_Coverage, 7595,
     /* 1459094 */     GIR_EraseRootFromParent_Done,
     /* 1459095 */   // Label 20494: @1459095
     /* 1459095 */   GIM_Try, /*On fail goto*//*Label 20495*/ GIMT_Encode4(1459192), // Rule ID 7598 //
     /* 1459100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1459111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1459114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1459117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1459123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459150 */     // MIs[1] Operand 1
     /* 1459150 */     // No operand predicates
     /* 1459150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459154 */     // MIs[0] policy
     /* 1459154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459166 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1459169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459191 */     // GIR_Coverage, 7598,
     /* 1459191 */     GIR_EraseRootFromParent_Done,
     /* 1459192 */   // Label 20495: @1459192
     /* 1459192 */   GIM_Try, /*On fail goto*//*Label 20496*/ GIMT_Encode4(1459289), // Rule ID 7599 //
     /* 1459197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1459208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1459211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1459214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1459220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459247 */     // MIs[1] Operand 1
     /* 1459247 */     // No operand predicates
     /* 1459247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459251 */     // MIs[0] policy
     /* 1459251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459263 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1459266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459288 */     // GIR_Coverage, 7599,
     /* 1459288 */     GIR_EraseRootFromParent_Done,
     /* 1459289 */   // Label 20496: @1459289
     /* 1459289 */   GIM_Try, /*On fail goto*//*Label 20497*/ GIMT_Encode4(1459386), // Rule ID 7602 //
     /* 1459294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1459305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1459308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1459311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1459317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459344 */     // MIs[1] Operand 1
     /* 1459344 */     // No operand predicates
     /* 1459344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459348 */     // MIs[0] policy
     /* 1459348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459360 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1459363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459385 */     // GIR_Coverage, 7602,
     /* 1459385 */     GIR_EraseRootFromParent_Done,
     /* 1459386 */   // Label 20497: @1459386
     /* 1459386 */   GIM_Try, /*On fail goto*//*Label 20498*/ GIMT_Encode4(1459483), // Rule ID 7603 //
     /* 1459391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1459402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1459405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1459408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1459414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459441 */     // MIs[1] Operand 1
     /* 1459441 */     // No operand predicates
     /* 1459441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459445 */     // MIs[0] policy
     /* 1459445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459457 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1459460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459482 */     // GIR_Coverage, 7603,
     /* 1459482 */     GIR_EraseRootFromParent_Done,
     /* 1459483 */   // Label 20498: @1459483
     /* 1459483 */   GIM_Try, /*On fail goto*//*Label 20499*/ GIMT_Encode4(1459580), // Rule ID 7606 //
     /* 1459488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1459499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1459502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1459505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1459511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459538 */     // MIs[1] Operand 1
     /* 1459538 */     // No operand predicates
     /* 1459538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459542 */     // MIs[0] policy
     /* 1459542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459554 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1459557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459579 */     // GIR_Coverage, 7606,
     /* 1459579 */     GIR_EraseRootFromParent_Done,
     /* 1459580 */   // Label 20499: @1459580
     /* 1459580 */   GIM_Try, /*On fail goto*//*Label 20500*/ GIMT_Encode4(1459677), // Rule ID 7607 //
     /* 1459585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1459596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1459599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1459602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1459608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459635 */     // MIs[1] Operand 1
     /* 1459635 */     // No operand predicates
     /* 1459635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459639 */     // MIs[0] policy
     /* 1459639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459651 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1459654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459676 */     // GIR_Coverage, 7607,
     /* 1459676 */     GIR_EraseRootFromParent_Done,
     /* 1459677 */   // Label 20500: @1459677
     /* 1459677 */   GIM_Try, /*On fail goto*//*Label 20501*/ GIMT_Encode4(1459774), // Rule ID 7610 //
     /* 1459682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1459693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1459696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1459699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459732 */     // MIs[1] Operand 1
     /* 1459732 */     // No operand predicates
     /* 1459732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459736 */     // MIs[0] policy
     /* 1459736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459748 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1459751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459773 */     // GIR_Coverage, 7610,
     /* 1459773 */     GIR_EraseRootFromParent_Done,
     /* 1459774 */   // Label 20501: @1459774
     /* 1459774 */   GIM_Try, /*On fail goto*//*Label 20502*/ GIMT_Encode4(1459871), // Rule ID 7611 //
     /* 1459779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1459790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1459793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1459796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459829 */     // MIs[1] Operand 1
     /* 1459829 */     // No operand predicates
     /* 1459829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459833 */     // MIs[0] policy
     /* 1459833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459845 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1459848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459870 */     // GIR_Coverage, 7611,
     /* 1459870 */     GIR_EraseRootFromParent_Done,
     /* 1459871 */   // Label 20502: @1459871
     /* 1459871 */   GIM_Try, /*On fail goto*//*Label 20503*/ GIMT_Encode4(1459968), // Rule ID 7614 //
     /* 1459876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1459879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1459887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1459890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1459893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459926 */     // MIs[1] Operand 1
     /* 1459926 */     // No operand predicates
     /* 1459926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459930 */     // MIs[0] policy
     /* 1459930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459942 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1459945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1459964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459967 */     // GIR_Coverage, 7614,
     /* 1459967 */     GIR_EraseRootFromParent_Done,
     /* 1459968 */   // Label 20503: @1459968
     /* 1459968 */   GIM_Try, /*On fail goto*//*Label 20504*/ GIMT_Encode4(1460065), // Rule ID 7615 //
     /* 1459973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1459976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1459984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1459987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1459990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460023 */     // MIs[1] Operand 1
     /* 1460023 */     // No operand predicates
     /* 1460023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460027 */     // MIs[0] policy
     /* 1460027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460039 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1460042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460064 */     // GIR_Coverage, 7615,
     /* 1460064 */     GIR_EraseRootFromParent_Done,
     /* 1460065 */   // Label 20504: @1460065
     /* 1460065 */   GIM_Try, /*On fail goto*//*Label 20505*/ GIMT_Encode4(1460162), // Rule ID 7618 //
     /* 1460070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1460081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1460084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1460087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460120 */     // MIs[1] Operand 1
     /* 1460120 */     // No operand predicates
     /* 1460120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460124 */     // MIs[0] policy
     /* 1460124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460136 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1460139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460161 */     // GIR_Coverage, 7618,
     /* 1460161 */     GIR_EraseRootFromParent_Done,
     /* 1460162 */   // Label 20505: @1460162
     /* 1460162 */   GIM_Try, /*On fail goto*//*Label 20506*/ GIMT_Encode4(1460259), // Rule ID 7619 //
     /* 1460167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1460178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1460181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1460184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460217 */     // MIs[1] Operand 1
     /* 1460217 */     // No operand predicates
     /* 1460217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460221 */     // MIs[0] policy
     /* 1460221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460233 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1460236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460258 */     // GIR_Coverage, 7619,
     /* 1460258 */     GIR_EraseRootFromParent_Done,
     /* 1460259 */   // Label 20506: @1460259
     /* 1460259 */   GIM_Try, /*On fail goto*//*Label 20507*/ GIMT_Encode4(1460356), // Rule ID 7622 //
     /* 1460264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1460281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460314 */     // MIs[1] Operand 1
     /* 1460314 */     // No operand predicates
     /* 1460314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460318 */     // MIs[0] policy
     /* 1460318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1460333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460355 */     // GIR_Coverage, 7622,
     /* 1460355 */     GIR_EraseRootFromParent_Done,
     /* 1460356 */   // Label 20507: @1460356
     /* 1460356 */   GIM_Try, /*On fail goto*//*Label 20508*/ GIMT_Encode4(1460453), // Rule ID 7623 //
     /* 1460361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1460378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460411 */     // MIs[1] Operand 1
     /* 1460411 */     // No operand predicates
     /* 1460411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460415 */     // MIs[0] policy
     /* 1460415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460427 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1460430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460452 */     // GIR_Coverage, 7623,
     /* 1460452 */     GIR_EraseRootFromParent_Done,
     /* 1460453 */   // Label 20508: @1460453
     /* 1460453 */   GIM_Try, /*On fail goto*//*Label 20509*/ GIMT_Encode4(1460550), // Rule ID 7626 //
     /* 1460458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1460469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1460472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1460475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460508 */     // MIs[1] Operand 1
     /* 1460508 */     // No operand predicates
     /* 1460508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460512 */     // MIs[0] policy
     /* 1460512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1460527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460549 */     // GIR_Coverage, 7626,
     /* 1460549 */     GIR_EraseRootFromParent_Done,
     /* 1460550 */   // Label 20509: @1460550
     /* 1460550 */   GIM_Try, /*On fail goto*//*Label 20510*/ GIMT_Encode4(1460647), // Rule ID 7627 //
     /* 1460555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1460566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1460569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1460572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460605 */     // MIs[1] Operand 1
     /* 1460605 */     // No operand predicates
     /* 1460605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460609 */     // MIs[0] policy
     /* 1460609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460621 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1460624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460646 */     // GIR_Coverage, 7627,
     /* 1460646 */     GIR_EraseRootFromParent_Done,
     /* 1460647 */   // Label 20510: @1460647
     /* 1460647 */   GIM_Try, /*On fail goto*//*Label 20511*/ GIMT_Encode4(1460744), // Rule ID 7750 //
     /* 1460652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1460663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1460666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1460669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1460675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460702 */     // MIs[1] Operand 1
     /* 1460702 */     // No operand predicates
     /* 1460702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460706 */     // MIs[0] policy
     /* 1460706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460718 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1460721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1460740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460743 */     // GIR_Coverage, 7750,
     /* 1460743 */     GIR_EraseRootFromParent_Done,
     /* 1460744 */   // Label 20511: @1460744
     /* 1460744 */   GIM_Try, /*On fail goto*//*Label 20512*/ GIMT_Encode4(1460841), // Rule ID 7751 //
     /* 1460749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1460760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1460763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1460766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1460772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460799 */     // MIs[1] Operand 1
     /* 1460799 */     // No operand predicates
     /* 1460799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460803 */     // MIs[0] policy
     /* 1460803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460815 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1460818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1460837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460840 */     // GIR_Coverage, 7751,
     /* 1460840 */     GIR_EraseRootFromParent_Done,
     /* 1460841 */   // Label 20512: @1460841
     /* 1460841 */   GIM_Try, /*On fail goto*//*Label 20513*/ GIMT_Encode4(1460938), // Rule ID 7754 //
     /* 1460846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1460857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1460860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1460863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460896 */     // MIs[1] Operand 1
     /* 1460896 */     // No operand predicates
     /* 1460896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460900 */     // MIs[0] policy
     /* 1460900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460912 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1460915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1460934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460937 */     // GIR_Coverage, 7754,
     /* 1460937 */     GIR_EraseRootFromParent_Done,
     /* 1460938 */   // Label 20513: @1460938
     /* 1460938 */   GIM_Try, /*On fail goto*//*Label 20514*/ GIMT_Encode4(1461035), // Rule ID 7755 //
     /* 1460943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1460954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1460957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1460960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460993 */     // MIs[1] Operand 1
     /* 1460993 */     // No operand predicates
     /* 1460993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460997 */     // MIs[0] policy
     /* 1460997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461009 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1461012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461034 */     // GIR_Coverage, 7755,
     /* 1461034 */     GIR_EraseRootFromParent_Done,
     /* 1461035 */   // Label 20514: @1461035
     /* 1461035 */   GIM_Try, /*On fail goto*//*Label 20515*/ GIMT_Encode4(1461132), // Rule ID 7758 //
     /* 1461040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1461051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1461054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1461057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461090 */     // MIs[1] Operand 1
     /* 1461090 */     // No operand predicates
     /* 1461090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461094 */     // MIs[0] policy
     /* 1461094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461106 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1461109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461131 */     // GIR_Coverage, 7758,
     /* 1461131 */     GIR_EraseRootFromParent_Done,
     /* 1461132 */   // Label 20515: @1461132
     /* 1461132 */   GIM_Try, /*On fail goto*//*Label 20516*/ GIMT_Encode4(1461229), // Rule ID 7759 //
     /* 1461137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1461148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1461151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1461154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461187 */     // MIs[1] Operand 1
     /* 1461187 */     // No operand predicates
     /* 1461187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461191 */     // MIs[0] policy
     /* 1461191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461203 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1461206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461228 */     // GIR_Coverage, 7759,
     /* 1461228 */     GIR_EraseRootFromParent_Done,
     /* 1461229 */   // Label 20516: @1461229
     /* 1461229 */   GIM_Try, /*On fail goto*//*Label 20517*/ GIMT_Encode4(1461326), // Rule ID 7762 //
     /* 1461234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1461245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1461248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1461251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461284 */     // MIs[1] Operand 1
     /* 1461284 */     // No operand predicates
     /* 1461284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461288 */     // MIs[0] policy
     /* 1461288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1461303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461325 */     // GIR_Coverage, 7762,
     /* 1461325 */     GIR_EraseRootFromParent_Done,
     /* 1461326 */   // Label 20517: @1461326
     /* 1461326 */   GIM_Try, /*On fail goto*//*Label 20518*/ GIMT_Encode4(1461423), // Rule ID 7763 //
     /* 1461331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1461342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1461345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1461348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461381 */     // MIs[1] Operand 1
     /* 1461381 */     // No operand predicates
     /* 1461381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461385 */     // MIs[0] policy
     /* 1461385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461397 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1461400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461422 */     // GIR_Coverage, 7763,
     /* 1461422 */     GIR_EraseRootFromParent_Done,
     /* 1461423 */   // Label 20518: @1461423
     /* 1461423 */   GIM_Try, /*On fail goto*//*Label 20519*/ GIMT_Encode4(1461520), // Rule ID 7766 //
     /* 1461428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1461439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1461442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1461445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1461451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1461458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461478 */     // MIs[1] Operand 1
     /* 1461478 */     // No operand predicates
     /* 1461478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461482 */     // MIs[0] policy
     /* 1461482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461494 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1461497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461519 */     // GIR_Coverage, 7766,
     /* 1461519 */     GIR_EraseRootFromParent_Done,
     /* 1461520 */   // Label 20519: @1461520
     /* 1461520 */   GIM_Try, /*On fail goto*//*Label 20520*/ GIMT_Encode4(1461617), // Rule ID 7767 //
     /* 1461525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1461536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1461539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1461542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1461548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1461555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461575 */     // MIs[1] Operand 1
     /* 1461575 */     // No operand predicates
     /* 1461575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461579 */     // MIs[0] policy
     /* 1461579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461591 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1461594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461616 */     // GIR_Coverage, 7767,
     /* 1461616 */     GIR_EraseRootFromParent_Done,
     /* 1461617 */   // Label 20520: @1461617
     /* 1461617 */   GIM_Try, /*On fail goto*//*Label 20521*/ GIMT_Encode4(1461714), // Rule ID 7770 //
     /* 1461622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1461633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1461636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1461639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1461645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1461652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461672 */     // MIs[1] Operand 1
     /* 1461672 */     // No operand predicates
     /* 1461672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461676 */     // MIs[0] policy
     /* 1461676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461688 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1461691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461713 */     // GIR_Coverage, 7770,
     /* 1461713 */     GIR_EraseRootFromParent_Done,
     /* 1461714 */   // Label 20521: @1461714
     /* 1461714 */   GIM_Try, /*On fail goto*//*Label 20522*/ GIMT_Encode4(1461811), // Rule ID 7771 //
     /* 1461719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1461730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1461733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1461736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1461742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1461749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461769 */     // MIs[1] Operand 1
     /* 1461769 */     // No operand predicates
     /* 1461769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461773 */     // MIs[0] policy
     /* 1461773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461785 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1461788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461810 */     // GIR_Coverage, 7771,
     /* 1461810 */     GIR_EraseRootFromParent_Done,
     /* 1461811 */   // Label 20522: @1461811
     /* 1461811 */   GIM_Try, /*On fail goto*//*Label 20523*/ GIMT_Encode4(1461908), // Rule ID 7774 //
     /* 1461816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1461827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1461830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1461833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461866 */     // MIs[1] Operand 1
     /* 1461866 */     // No operand predicates
     /* 1461866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461870 */     // MIs[0] policy
     /* 1461870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461882 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1461885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1461904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461907 */     // GIR_Coverage, 7774,
     /* 1461907 */     GIR_EraseRootFromParent_Done,
     /* 1461908 */   // Label 20523: @1461908
     /* 1461908 */   GIM_Try, /*On fail goto*//*Label 20524*/ GIMT_Encode4(1462005), // Rule ID 7775 //
     /* 1461913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1461924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1461927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1461930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461963 */     // MIs[1] Operand 1
     /* 1461963 */     // No operand predicates
     /* 1461963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461967 */     // MIs[0] policy
     /* 1461967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461979 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1461982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462004 */     // GIR_Coverage, 7775,
     /* 1462004 */     GIR_EraseRootFromParent_Done,
     /* 1462005 */   // Label 20524: @1462005
     /* 1462005 */   GIM_Try, /*On fail goto*//*Label 20525*/ GIMT_Encode4(1462102), // Rule ID 7778 //
     /* 1462010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1462021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1462024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1462027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462060 */     // MIs[1] Operand 1
     /* 1462060 */     // No operand predicates
     /* 1462060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462064 */     // MIs[0] policy
     /* 1462064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462076 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1462079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462101 */     // GIR_Coverage, 7778,
     /* 1462101 */     GIR_EraseRootFromParent_Done,
     /* 1462102 */   // Label 20525: @1462102
     /* 1462102 */   GIM_Try, /*On fail goto*//*Label 20526*/ GIMT_Encode4(1462199), // Rule ID 7779 //
     /* 1462107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1462118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1462121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1462124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462157 */     // MIs[1] Operand 1
     /* 1462157 */     // No operand predicates
     /* 1462157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462161 */     // MIs[0] policy
     /* 1462161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462173 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1462176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462198 */     // GIR_Coverage, 7779,
     /* 1462198 */     GIR_EraseRootFromParent_Done,
     /* 1462199 */   // Label 20526: @1462199
     /* 1462199 */   GIM_Try, /*On fail goto*//*Label 20527*/ GIMT_Encode4(1462296), // Rule ID 7782 //
     /* 1462204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1462221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1462227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462254 */     // MIs[1] Operand 1
     /* 1462254 */     // No operand predicates
     /* 1462254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462258 */     // MIs[0] policy
     /* 1462258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462270 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1462273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462295 */     // GIR_Coverage, 7782,
     /* 1462295 */     GIR_EraseRootFromParent_Done,
     /* 1462296 */   // Label 20527: @1462296
     /* 1462296 */   GIM_Try, /*On fail goto*//*Label 20528*/ GIMT_Encode4(1462393), // Rule ID 7783 //
     /* 1462301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1462318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1462324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462351 */     // MIs[1] Operand 1
     /* 1462351 */     // No operand predicates
     /* 1462351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462355 */     // MIs[0] policy
     /* 1462355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462367 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1462370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462392 */     // GIR_Coverage, 7783,
     /* 1462392 */     GIR_EraseRootFromParent_Done,
     /* 1462393 */   // Label 20528: @1462393
     /* 1462393 */   GIM_Try, /*On fail goto*//*Label 20529*/ GIMT_Encode4(1462490), // Rule ID 7786 //
     /* 1462398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1462409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1462412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1462415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462448 */     // MIs[1] Operand 1
     /* 1462448 */     // No operand predicates
     /* 1462448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462452 */     // MIs[0] policy
     /* 1462452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1462467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462489 */     // GIR_Coverage, 7786,
     /* 1462489 */     GIR_EraseRootFromParent_Done,
     /* 1462490 */   // Label 20529: @1462490
     /* 1462490 */   GIM_Try, /*On fail goto*//*Label 20530*/ GIMT_Encode4(1462587), // Rule ID 7787 //
     /* 1462495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1462506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1462509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1462512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462545 */     // MIs[1] Operand 1
     /* 1462545 */     // No operand predicates
     /* 1462545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462549 */     // MIs[0] policy
     /* 1462549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462561 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1462564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462586 */     // GIR_Coverage, 7787,
     /* 1462586 */     GIR_EraseRootFromParent_Done,
     /* 1462587 */   // Label 20530: @1462587
     /* 1462587 */   GIM_Try, /*On fail goto*//*Label 20531*/ GIMT_Encode4(1462684), // Rule ID 7790 //
     /* 1462592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1462603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1462606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1462609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1462615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1462622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1462630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462642 */     // MIs[1] Operand 1
     /* 1462642 */     // No operand predicates
     /* 1462642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462646 */     // MIs[0] policy
     /* 1462646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462658 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1462661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462683 */     // GIR_Coverage, 7790,
     /* 1462683 */     GIR_EraseRootFromParent_Done,
     /* 1462684 */   // Label 20531: @1462684
     /* 1462684 */   GIM_Try, /*On fail goto*//*Label 20532*/ GIMT_Encode4(1462781), // Rule ID 7791 //
     /* 1462689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1462700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1462703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1462706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1462712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1462719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1462727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462739 */     // MIs[1] Operand 1
     /* 1462739 */     // No operand predicates
     /* 1462739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462743 */     // MIs[0] policy
     /* 1462743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462755 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1462758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462780 */     // GIR_Coverage, 7791,
     /* 1462780 */     GIR_EraseRootFromParent_Done,
     /* 1462781 */   // Label 20532: @1462781
     /* 1462781 */   GIM_Try, /*On fail goto*//*Label 20533*/ GIMT_Encode4(1462878), // Rule ID 7794 //
     /* 1462786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1462789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1462797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1462800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1462803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462836 */     // MIs[1] Operand 1
     /* 1462836 */     // No operand predicates
     /* 1462836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462840 */     // MIs[0] policy
     /* 1462840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462852 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1462855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1462874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462877 */     // GIR_Coverage, 7794,
     /* 1462877 */     GIR_EraseRootFromParent_Done,
     /* 1462878 */   // Label 20533: @1462878
     /* 1462878 */   GIM_Try, /*On fail goto*//*Label 20534*/ GIMT_Encode4(1462975), // Rule ID 7795 //
     /* 1462883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1462886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1462894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1462897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1462900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462933 */     // MIs[1] Operand 1
     /* 1462933 */     // No operand predicates
     /* 1462933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462937 */     // MIs[0] policy
     /* 1462937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462949 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1462952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1462971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462974 */     // GIR_Coverage, 7795,
     /* 1462974 */     GIR_EraseRootFromParent_Done,
     /* 1462975 */   // Label 20534: @1462975
     /* 1462975 */   GIM_Try, /*On fail goto*//*Label 20535*/ GIMT_Encode4(1463072), // Rule ID 7798 //
     /* 1462980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1462983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1462991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1462994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1462997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463030 */     // MIs[1] Operand 1
     /* 1463030 */     // No operand predicates
     /* 1463030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463034 */     // MIs[0] policy
     /* 1463034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463046 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1463049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463071 */     // GIR_Coverage, 7798,
     /* 1463071 */     GIR_EraseRootFromParent_Done,
     /* 1463072 */   // Label 20535: @1463072
     /* 1463072 */   GIM_Try, /*On fail goto*//*Label 20536*/ GIMT_Encode4(1463169), // Rule ID 7799 //
     /* 1463077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1463088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1463091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1463094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463127 */     // MIs[1] Operand 1
     /* 1463127 */     // No operand predicates
     /* 1463127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463131 */     // MIs[0] policy
     /* 1463131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463143 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1463146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463168 */     // GIR_Coverage, 7799,
     /* 1463168 */     GIR_EraseRootFromParent_Done,
     /* 1463169 */   // Label 20536: @1463169
     /* 1463169 */   GIM_Try, /*On fail goto*//*Label 20537*/ GIMT_Encode4(1463266), // Rule ID 7802 //
     /* 1463174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1463185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1463188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1463191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1463197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463224 */     // MIs[1] Operand 1
     /* 1463224 */     // No operand predicates
     /* 1463224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463228 */     // MIs[0] policy
     /* 1463228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463240 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1463243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463265 */     // GIR_Coverage, 7802,
     /* 1463265 */     GIR_EraseRootFromParent_Done,
     /* 1463266 */   // Label 20537: @1463266
     /* 1463266 */   GIM_Try, /*On fail goto*//*Label 20538*/ GIMT_Encode4(1463363), // Rule ID 7803 //
     /* 1463271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1463282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1463285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1463288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1463294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463321 */     // MIs[1] Operand 1
     /* 1463321 */     // No operand predicates
     /* 1463321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463325 */     // MIs[0] policy
     /* 1463325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463337 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1463340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463362 */     // GIR_Coverage, 7803,
     /* 1463362 */     GIR_EraseRootFromParent_Done,
     /* 1463363 */   // Label 20538: @1463363
     /* 1463363 */   GIM_Try, /*On fail goto*//*Label 20539*/ GIMT_Encode4(1463460), // Rule ID 7806 //
     /* 1463368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1463379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1463382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1463385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1463391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463418 */     // MIs[1] Operand 1
     /* 1463418 */     // No operand predicates
     /* 1463418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463422 */     // MIs[0] policy
     /* 1463422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1463437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463459 */     // GIR_Coverage, 7806,
     /* 1463459 */     GIR_EraseRootFromParent_Done,
     /* 1463460 */   // Label 20539: @1463460
     /* 1463460 */   GIM_Try, /*On fail goto*//*Label 20540*/ GIMT_Encode4(1463557), // Rule ID 7807 //
     /* 1463465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1463476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1463479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1463482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1463488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463515 */     // MIs[1] Operand 1
     /* 1463515 */     // No operand predicates
     /* 1463515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463519 */     // MIs[0] policy
     /* 1463519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463531 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1463534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463556 */     // GIR_Coverage, 7807,
     /* 1463556 */     GIR_EraseRootFromParent_Done,
     /* 1463557 */   // Label 20540: @1463557
     /* 1463557 */   GIM_Try, /*On fail goto*//*Label 20541*/ GIMT_Encode4(1463657), // Rule ID 14236 //
     /* 1463562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1463573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1463576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1463579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463612 */     // MIs[1] Operand 1
     /* 1463612 */     // No operand predicates
     /* 1463612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463616 */     // MIs[0] policy
     /* 1463616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463628 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1463631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463656 */     // GIR_Coverage, 14236,
     /* 1463656 */     GIR_EraseRootFromParent_Done,
     /* 1463657 */   // Label 20541: @1463657
     /* 1463657 */   GIM_Try, /*On fail goto*//*Label 20542*/ GIMT_Encode4(1463757), // Rule ID 14237 //
     /* 1463662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1463673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1463676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1463679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463712 */     // MIs[1] Operand 1
     /* 1463712 */     // No operand predicates
     /* 1463712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463716 */     // MIs[0] policy
     /* 1463716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463728 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1463731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463756 */     // GIR_Coverage, 14237,
     /* 1463756 */     GIR_EraseRootFromParent_Done,
     /* 1463757 */   // Label 20542: @1463757
     /* 1463757 */   GIM_Try, /*On fail goto*//*Label 20543*/ GIMT_Encode4(1463857), // Rule ID 14240 //
     /* 1463762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1463773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1463776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1463779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463812 */     // MIs[1] Operand 1
     /* 1463812 */     // No operand predicates
     /* 1463812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463816 */     // MIs[0] policy
     /* 1463816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463828 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1463831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463856 */     // GIR_Coverage, 14240,
     /* 1463856 */     GIR_EraseRootFromParent_Done,
     /* 1463857 */   // Label 20543: @1463857
     /* 1463857 */   GIM_Try, /*On fail goto*//*Label 20544*/ GIMT_Encode4(1463957), // Rule ID 14241 //
     /* 1463862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1463873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1463876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1463879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463912 */     // MIs[1] Operand 1
     /* 1463912 */     // No operand predicates
     /* 1463912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463916 */     // MIs[0] policy
     /* 1463916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463928 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1463931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463956 */     // GIR_Coverage, 14241,
     /* 1463956 */     GIR_EraseRootFromParent_Done,
     /* 1463957 */   // Label 20544: @1463957
     /* 1463957 */   GIM_Try, /*On fail goto*//*Label 20545*/ GIMT_Encode4(1464057), // Rule ID 14244 //
     /* 1463962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1463973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1463976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1463979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1463985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464012 */     // MIs[1] Operand 1
     /* 1464012 */     // No operand predicates
     /* 1464012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464016 */     // MIs[0] policy
     /* 1464016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464028 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464056 */     // GIR_Coverage, 14244,
     /* 1464056 */     GIR_EraseRootFromParent_Done,
     /* 1464057 */   // Label 20545: @1464057
     /* 1464057 */   GIM_Try, /*On fail goto*//*Label 20546*/ GIMT_Encode4(1464157), // Rule ID 14245 //
     /* 1464062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1464073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1464076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1464079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464112 */     // MIs[1] Operand 1
     /* 1464112 */     // No operand predicates
     /* 1464112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464116 */     // MIs[0] policy
     /* 1464116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464128 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464156 */     // GIR_Coverage, 14245,
     /* 1464156 */     GIR_EraseRootFromParent_Done,
     /* 1464157 */   // Label 20546: @1464157
     /* 1464157 */   GIM_Try, /*On fail goto*//*Label 20547*/ GIMT_Encode4(1464257), // Rule ID 14248 //
     /* 1464162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1464173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1464176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1464179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464212 */     // MIs[1] Operand 1
     /* 1464212 */     // No operand predicates
     /* 1464212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464216 */     // MIs[0] policy
     /* 1464216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464228 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1464231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464256 */     // GIR_Coverage, 14248,
     /* 1464256 */     GIR_EraseRootFromParent_Done,
     /* 1464257 */   // Label 20547: @1464257
     /* 1464257 */   GIM_Try, /*On fail goto*//*Label 20548*/ GIMT_Encode4(1464357), // Rule ID 14249 //
     /* 1464262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1464273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1464276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1464279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464312 */     // MIs[1] Operand 1
     /* 1464312 */     // No operand predicates
     /* 1464312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464316 */     // MIs[0] policy
     /* 1464316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464328 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1464331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464356 */     // GIR_Coverage, 14249,
     /* 1464356 */     GIR_EraseRootFromParent_Done,
     /* 1464357 */   // Label 20548: @1464357
     /* 1464357 */   GIM_Try, /*On fail goto*//*Label 20549*/ GIMT_Encode4(1464457), // Rule ID 14252 //
     /* 1464362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1464373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1464376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1464379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464412 */     // MIs[1] Operand 1
     /* 1464412 */     // No operand predicates
     /* 1464412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464416 */     // MIs[0] policy
     /* 1464416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464428 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464456 */     // GIR_Coverage, 14252,
     /* 1464456 */     GIR_EraseRootFromParent_Done,
     /* 1464457 */   // Label 20549: @1464457
     /* 1464457 */   GIM_Try, /*On fail goto*//*Label 20550*/ GIMT_Encode4(1464557), // Rule ID 14253 //
     /* 1464462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1464473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1464476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1464479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464512 */     // MIs[1] Operand 1
     /* 1464512 */     // No operand predicates
     /* 1464512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464516 */     // MIs[0] policy
     /* 1464516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464528 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464556 */     // GIR_Coverage, 14253,
     /* 1464556 */     GIR_EraseRootFromParent_Done,
     /* 1464557 */   // Label 20550: @1464557
     /* 1464557 */   GIM_Try, /*On fail goto*//*Label 20551*/ GIMT_Encode4(1464657), // Rule ID 14256 //
     /* 1464562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1464573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1464576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1464579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464612 */     // MIs[1] Operand 1
     /* 1464612 */     // No operand predicates
     /* 1464612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464616 */     // MIs[0] policy
     /* 1464616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464628 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464656 */     // GIR_Coverage, 14256,
     /* 1464656 */     GIR_EraseRootFromParent_Done,
     /* 1464657 */   // Label 20551: @1464657
     /* 1464657 */   GIM_Try, /*On fail goto*//*Label 20552*/ GIMT_Encode4(1464757), // Rule ID 14257 //
     /* 1464662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1464673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1464676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1464679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464712 */     // MIs[1] Operand 1
     /* 1464712 */     // No operand predicates
     /* 1464712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464716 */     // MIs[0] policy
     /* 1464716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464728 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464756 */     // GIR_Coverage, 14257,
     /* 1464756 */     GIR_EraseRootFromParent_Done,
     /* 1464757 */   // Label 20552: @1464757
     /* 1464757 */   GIM_Try, /*On fail goto*//*Label 20553*/ GIMT_Encode4(1464857), // Rule ID 14260 //
     /* 1464762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1464773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1464776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1464779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1464785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464812 */     // MIs[1] Operand 1
     /* 1464812 */     // No operand predicates
     /* 1464812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464816 */     // MIs[0] policy
     /* 1464816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464828 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1464831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464856 */     // GIR_Coverage, 14260,
     /* 1464856 */     GIR_EraseRootFromParent_Done,
     /* 1464857 */   // Label 20553: @1464857
     /* 1464857 */   GIM_Try, /*On fail goto*//*Label 20554*/ GIMT_Encode4(1464957), // Rule ID 14261 //
     /* 1464862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1464873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1464876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1464879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1464885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464912 */     // MIs[1] Operand 1
     /* 1464912 */     // No operand predicates
     /* 1464912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464916 */     // MIs[0] policy
     /* 1464916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464928 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1464931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464956 */     // GIR_Coverage, 14261,
     /* 1464956 */     GIR_EraseRootFromParent_Done,
     /* 1464957 */   // Label 20554: @1464957
     /* 1464957 */   GIM_Try, /*On fail goto*//*Label 20555*/ GIMT_Encode4(1465057), // Rule ID 14264 //
     /* 1464962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1464973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1464976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1464979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465012 */     // MIs[1] Operand 1
     /* 1465012 */     // No operand predicates
     /* 1465012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465016 */     // MIs[0] policy
     /* 1465016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465028 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465056 */     // GIR_Coverage, 14264,
     /* 1465056 */     GIR_EraseRootFromParent_Done,
     /* 1465057 */   // Label 20555: @1465057
     /* 1465057 */   GIM_Try, /*On fail goto*//*Label 20556*/ GIMT_Encode4(1465157), // Rule ID 14265 //
     /* 1465062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1465073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1465076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1465079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1465085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465112 */     // MIs[1] Operand 1
     /* 1465112 */     // No operand predicates
     /* 1465112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465116 */     // MIs[0] policy
     /* 1465116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465128 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465156 */     // GIR_Coverage, 14265,
     /* 1465156 */     GIR_EraseRootFromParent_Done,
     /* 1465157 */   // Label 20556: @1465157
     /* 1465157 */   GIM_Try, /*On fail goto*//*Label 20557*/ GIMT_Encode4(1465257), // Rule ID 14268 //
     /* 1465162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1465173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1465176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1465179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465212 */     // MIs[1] Operand 1
     /* 1465212 */     // No operand predicates
     /* 1465212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465216 */     // MIs[0] policy
     /* 1465216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465228 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465256 */     // GIR_Coverage, 14268,
     /* 1465256 */     GIR_EraseRootFromParent_Done,
     /* 1465257 */   // Label 20557: @1465257
     /* 1465257 */   GIM_Try, /*On fail goto*//*Label 20558*/ GIMT_Encode4(1465357), // Rule ID 14269 //
     /* 1465262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1465273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1465276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1465279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465312 */     // MIs[1] Operand 1
     /* 1465312 */     // No operand predicates
     /* 1465312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465316 */     // MIs[0] policy
     /* 1465316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465328 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465356 */     // GIR_Coverage, 14269,
     /* 1465356 */     GIR_EraseRootFromParent_Done,
     /* 1465357 */   // Label 20558: @1465357
     /* 1465357 */   GIM_Try, /*On fail goto*//*Label 20559*/ GIMT_Encode4(1465457), // Rule ID 14272 //
     /* 1465362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1465365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1465373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1465376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1465379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465412 */     // MIs[1] Operand 1
     /* 1465412 */     // No operand predicates
     /* 1465412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465416 */     // MIs[0] policy
     /* 1465416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465428 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465456 */     // GIR_Coverage, 14272,
     /* 1465456 */     GIR_EraseRootFromParent_Done,
     /* 1465457 */   // Label 20559: @1465457
     /* 1465457 */   GIM_Try, /*On fail goto*//*Label 20560*/ GIMT_Encode4(1465557), // Rule ID 14273 //
     /* 1465462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1465465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1465473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1465476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1465479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465512 */     // MIs[1] Operand 1
     /* 1465512 */     // No operand predicates
     /* 1465512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465516 */     // MIs[0] policy
     /* 1465516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465528 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465556 */     // GIR_Coverage, 14273,
     /* 1465556 */     GIR_EraseRootFromParent_Done,
     /* 1465557 */   // Label 20560: @1465557
     /* 1465557 */   GIM_Try, /*On fail goto*//*Label 20561*/ GIMT_Encode4(1465657), // Rule ID 14276 //
     /* 1465562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1465573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1465576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1465579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1465585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465612 */     // MIs[1] Operand 1
     /* 1465612 */     // No operand predicates
     /* 1465612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465616 */     // MIs[0] policy
     /* 1465616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465628 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1465631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465656 */     // GIR_Coverage, 14276,
     /* 1465656 */     GIR_EraseRootFromParent_Done,
     /* 1465657 */   // Label 20561: @1465657
     /* 1465657 */   GIM_Try, /*On fail goto*//*Label 20562*/ GIMT_Encode4(1465757), // Rule ID 14277 //
     /* 1465662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1465673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1465676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1465679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1465685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465712 */     // MIs[1] Operand 1
     /* 1465712 */     // No operand predicates
     /* 1465712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465716 */     // MIs[0] policy
     /* 1465716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465728 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1465731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465756 */     // GIR_Coverage, 14277,
     /* 1465756 */     GIR_EraseRootFromParent_Done,
     /* 1465757 */   // Label 20562: @1465757
     /* 1465757 */   GIM_Try, /*On fail goto*//*Label 20563*/ GIMT_Encode4(1465857), // Rule ID 14280 //
     /* 1465762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1465773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1465776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1465779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1465785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465812 */     // MIs[1] Operand 1
     /* 1465812 */     // No operand predicates
     /* 1465812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465816 */     // MIs[0] policy
     /* 1465816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465828 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1465831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465856 */     // GIR_Coverage, 14280,
     /* 1465856 */     GIR_EraseRootFromParent_Done,
     /* 1465857 */   // Label 20563: @1465857
     /* 1465857 */   GIM_Try, /*On fail goto*//*Label 20564*/ GIMT_Encode4(1465957), // Rule ID 14281 //
     /* 1465862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1465873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1465876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1465879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1465885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465912 */     // MIs[1] Operand 1
     /* 1465912 */     // No operand predicates
     /* 1465912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465916 */     // MIs[0] policy
     /* 1465916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465928 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1465931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465956 */     // GIR_Coverage, 14281,
     /* 1465956 */     GIR_EraseRootFromParent_Done,
     /* 1465957 */   // Label 20564: @1465957
     /* 1465957 */   GIM_Try, /*On fail goto*//*Label 20565*/ GIMT_Encode4(1466057), // Rule ID 14284 //
     /* 1465962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1465973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1465976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1465979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1465985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1465992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466012 */     // MIs[1] Operand 1
     /* 1466012 */     // No operand predicates
     /* 1466012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466016 */     // MIs[0] policy
     /* 1466016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466028 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1466031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466056 */     // GIR_Coverage, 14284,
     /* 1466056 */     GIR_EraseRootFromParent_Done,
     /* 1466057 */   // Label 20565: @1466057
     /* 1466057 */   GIM_Try, /*On fail goto*//*Label 20566*/ GIMT_Encode4(1466157), // Rule ID 14285 //
     /* 1466062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1466073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1466076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1466079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1466085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1466092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466112 */     // MIs[1] Operand 1
     /* 1466112 */     // No operand predicates
     /* 1466112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466116 */     // MIs[0] policy
     /* 1466116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466128 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1466131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466156 */     // GIR_Coverage, 14285,
     /* 1466156 */     GIR_EraseRootFromParent_Done,
     /* 1466157 */   // Label 20566: @1466157
     /* 1466157 */   GIM_Try, /*On fail goto*//*Label 20567*/ GIMT_Encode4(1466257), // Rule ID 14288 //
     /* 1466162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1466173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1466176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1466179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466212 */     // MIs[1] Operand 1
     /* 1466212 */     // No operand predicates
     /* 1466212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466216 */     // MIs[0] policy
     /* 1466216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466256 */     // GIR_Coverage, 14288,
     /* 1466256 */     GIR_EraseRootFromParent_Done,
     /* 1466257 */   // Label 20567: @1466257
     /* 1466257 */   GIM_Try, /*On fail goto*//*Label 20568*/ GIMT_Encode4(1466357), // Rule ID 14289 //
     /* 1466262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1466273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1466276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1466279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466312 */     // MIs[1] Operand 1
     /* 1466312 */     // No operand predicates
     /* 1466312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466316 */     // MIs[0] policy
     /* 1466316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466328 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466356 */     // GIR_Coverage, 14289,
     /* 1466356 */     GIR_EraseRootFromParent_Done,
     /* 1466357 */   // Label 20568: @1466357
     /* 1466357 */   GIM_Try, /*On fail goto*//*Label 20569*/ GIMT_Encode4(1466457), // Rule ID 14292 //
     /* 1466362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1466373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1466376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1466379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466412 */     // MIs[1] Operand 1
     /* 1466412 */     // No operand predicates
     /* 1466412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466416 */     // MIs[0] policy
     /* 1466416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466428 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1466431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466456 */     // GIR_Coverage, 14292,
     /* 1466456 */     GIR_EraseRootFromParent_Done,
     /* 1466457 */   // Label 20569: @1466457
     /* 1466457 */   GIM_Try, /*On fail goto*//*Label 20570*/ GIMT_Encode4(1466557), // Rule ID 14293 //
     /* 1466462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1466473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1466476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1466479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466512 */     // MIs[1] Operand 1
     /* 1466512 */     // No operand predicates
     /* 1466512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466516 */     // MIs[0] policy
     /* 1466516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466528 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1466531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466556 */     // GIR_Coverage, 14293,
     /* 1466556 */     GIR_EraseRootFromParent_Done,
     /* 1466557 */   // Label 20570: @1466557
     /* 1466557 */   GIM_Try, /*On fail goto*//*Label 20571*/ GIMT_Encode4(1466657), // Rule ID 14296 //
     /* 1466562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1466573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1466576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1466579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1466585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1466592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466612 */     // MIs[1] Operand 1
     /* 1466612 */     // No operand predicates
     /* 1466612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466616 */     // MIs[0] policy
     /* 1466616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466628 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1466631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466656 */     // GIR_Coverage, 14296,
     /* 1466656 */     GIR_EraseRootFromParent_Done,
     /* 1466657 */   // Label 20571: @1466657
     /* 1466657 */   GIM_Try, /*On fail goto*//*Label 20572*/ GIMT_Encode4(1466757), // Rule ID 14297 //
     /* 1466662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1466673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1466676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1466679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1466685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1466692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466712 */     // MIs[1] Operand 1
     /* 1466712 */     // No operand predicates
     /* 1466712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466716 */     // MIs[0] policy
     /* 1466716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466728 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1466731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466756 */     // GIR_Coverage, 14297,
     /* 1466756 */     GIR_EraseRootFromParent_Done,
     /* 1466757 */   // Label 20572: @1466757
     /* 1466757 */   GIM_Try, /*On fail goto*//*Label 20573*/ GIMT_Encode4(1466857), // Rule ID 14300 //
     /* 1466762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1466773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1466776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1466779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1466785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466812 */     // MIs[1] Operand 1
     /* 1466812 */     // No operand predicates
     /* 1466812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466816 */     // MIs[0] policy
     /* 1466816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1466850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466856 */     // GIR_Coverage, 14300,
     /* 1466856 */     GIR_EraseRootFromParent_Done,
     /* 1466857 */   // Label 20573: @1466857
     /* 1466857 */   GIM_Try, /*On fail goto*//*Label 20574*/ GIMT_Encode4(1466957), // Rule ID 14301 //
     /* 1466862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1466873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1466876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1466879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1466885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466912 */     // MIs[1] Operand 1
     /* 1466912 */     // No operand predicates
     /* 1466912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466916 */     // MIs[0] policy
     /* 1466916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1466950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466956 */     // GIR_Coverage, 14301,
     /* 1466956 */     GIR_EraseRootFromParent_Done,
     /* 1466957 */   // Label 20574: @1466957
     /* 1466957 */   GIM_Try, /*On fail goto*//*Label 20575*/ GIMT_Encode4(1467057), // Rule ID 14304 //
     /* 1466962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1466973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1466976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1466979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467012 */     // MIs[1] Operand 1
     /* 1467012 */     // No operand predicates
     /* 1467012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467016 */     // MIs[0] policy
     /* 1467016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467028 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1467031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467056 */     // GIR_Coverage, 14304,
     /* 1467056 */     GIR_EraseRootFromParent_Done,
     /* 1467057 */   // Label 20575: @1467057
     /* 1467057 */   GIM_Try, /*On fail goto*//*Label 20576*/ GIMT_Encode4(1467157), // Rule ID 14305 //
     /* 1467062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1467073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1467076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1467079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467112 */     // MIs[1] Operand 1
     /* 1467112 */     // No operand predicates
     /* 1467112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467116 */     // MIs[0] policy
     /* 1467116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467128 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1467131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467156 */     // GIR_Coverage, 14305,
     /* 1467156 */     GIR_EraseRootFromParent_Done,
     /* 1467157 */   // Label 20576: @1467157
     /* 1467157 */   GIM_Try, /*On fail goto*//*Label 20577*/ GIMT_Encode4(1467257), // Rule ID 14308 //
     /* 1467162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1467173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1467176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1467179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1467185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467212 */     // MIs[1] Operand 1
     /* 1467212 */     // No operand predicates
     /* 1467212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467216 */     // MIs[0] policy
     /* 1467216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467228 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467256 */     // GIR_Coverage, 14308,
     /* 1467256 */     GIR_EraseRootFromParent_Done,
     /* 1467257 */   // Label 20577: @1467257
     /* 1467257 */   GIM_Try, /*On fail goto*//*Label 20578*/ GIMT_Encode4(1467357), // Rule ID 14309 //
     /* 1467262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1467273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1467276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1467279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1467285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467312 */     // MIs[1] Operand 1
     /* 1467312 */     // No operand predicates
     /* 1467312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467316 */     // MIs[0] policy
     /* 1467316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467328 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467356 */     // GIR_Coverage, 14309,
     /* 1467356 */     GIR_EraseRootFromParent_Done,
     /* 1467357 */   // Label 20578: @1467357
     /* 1467357 */   GIM_Try, /*On fail goto*//*Label 20579*/ GIMT_Encode4(1467457), // Rule ID 14312 //
     /* 1467362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1467365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1467373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1467376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1467379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467412 */     // MIs[1] Operand 1
     /* 1467412 */     // No operand predicates
     /* 1467412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467416 */     // MIs[0] policy
     /* 1467416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467428 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1467431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467456 */     // GIR_Coverage, 14312,
     /* 1467456 */     GIR_EraseRootFromParent_Done,
     /* 1467457 */   // Label 20579: @1467457
     /* 1467457 */   GIM_Try, /*On fail goto*//*Label 20580*/ GIMT_Encode4(1467557), // Rule ID 14313 //
     /* 1467462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1467465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1467473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1467476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1467479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467512 */     // MIs[1] Operand 1
     /* 1467512 */     // No operand predicates
     /* 1467512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467516 */     // MIs[0] policy
     /* 1467516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467528 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1467531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467556 */     // GIR_Coverage, 14313,
     /* 1467556 */     GIR_EraseRootFromParent_Done,
     /* 1467557 */   // Label 20580: @1467557
     /* 1467557 */   GIM_Try, /*On fail goto*//*Label 20581*/ GIMT_Encode4(1467657), // Rule ID 14316 //
     /* 1467562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1467565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1467573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1467576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1467579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467612 */     // MIs[1] Operand 1
     /* 1467612 */     // No operand predicates
     /* 1467612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467616 */     // MIs[0] policy
     /* 1467616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467628 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1467631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467656 */     // GIR_Coverage, 14316,
     /* 1467656 */     GIR_EraseRootFromParent_Done,
     /* 1467657 */   // Label 20581: @1467657
     /* 1467657 */   GIM_Try, /*On fail goto*//*Label 20582*/ GIMT_Encode4(1467757), // Rule ID 14317 //
     /* 1467662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1467665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1467673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1467676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1467679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467712 */     // MIs[1] Operand 1
     /* 1467712 */     // No operand predicates
     /* 1467712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467716 */     // MIs[0] policy
     /* 1467716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467728 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1467731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467756 */     // GIR_Coverage, 14317,
     /* 1467756 */     GIR_EraseRootFromParent_Done,
     /* 1467757 */   // Label 20582: @1467757
     /* 1467757 */   GIM_Try, /*On fail goto*//*Label 20583*/ GIMT_Encode4(1467857), // Rule ID 14320 //
     /* 1467762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1467765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1467773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1467776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1467779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467812 */     // MIs[1] Operand 1
     /* 1467812 */     // No operand predicates
     /* 1467812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467816 */     // MIs[0] policy
     /* 1467816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467828 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467856 */     // GIR_Coverage, 14320,
     /* 1467856 */     GIR_EraseRootFromParent_Done,
     /* 1467857 */   // Label 20583: @1467857
     /* 1467857 */   GIM_Try, /*On fail goto*//*Label 20584*/ GIMT_Encode4(1467957), // Rule ID 14321 //
     /* 1467862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1467865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1467873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1467876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1467879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467912 */     // MIs[1] Operand 1
     /* 1467912 */     // No operand predicates
     /* 1467912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467916 */     // MIs[0] policy
     /* 1467916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467928 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467956 */     // GIR_Coverage, 14321,
     /* 1467956 */     GIR_EraseRootFromParent_Done,
     /* 1467957 */   // Label 20584: @1467957
     /* 1467957 */   GIM_Try, /*On fail goto*//*Label 20585*/ GIMT_Encode4(1468057), // Rule ID 14500 //
     /* 1467962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1467970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1467973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1467976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1467979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1467985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468012 */     // MIs[1] Operand 1
     /* 1468012 */     // No operand predicates
     /* 1468012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468016 */     // MIs[0] policy
     /* 1468016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468028 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1468031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468056 */     // GIR_Coverage, 14500,
     /* 1468056 */     GIR_EraseRootFromParent_Done,
     /* 1468057 */   // Label 20585: @1468057
     /* 1468057 */   GIM_Try, /*On fail goto*//*Label 20586*/ GIMT_Encode4(1468157), // Rule ID 14501 //
     /* 1468062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1468073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1468076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1468079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468112 */     // MIs[1] Operand 1
     /* 1468112 */     // No operand predicates
     /* 1468112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468116 */     // MIs[0] policy
     /* 1468116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468128 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1468131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468156 */     // GIR_Coverage, 14501,
     /* 1468156 */     GIR_EraseRootFromParent_Done,
     /* 1468157 */   // Label 20586: @1468157
     /* 1468157 */   GIM_Try, /*On fail goto*//*Label 20587*/ GIMT_Encode4(1468257), // Rule ID 14504 //
     /* 1468162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1468173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1468176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1468179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468212 */     // MIs[1] Operand 1
     /* 1468212 */     // No operand predicates
     /* 1468212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468216 */     // MIs[0] policy
     /* 1468216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468228 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1468231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468256 */     // GIR_Coverage, 14504,
     /* 1468256 */     GIR_EraseRootFromParent_Done,
     /* 1468257 */   // Label 20587: @1468257
     /* 1468257 */   GIM_Try, /*On fail goto*//*Label 20588*/ GIMT_Encode4(1468357), // Rule ID 14505 //
     /* 1468262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1468273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1468276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1468279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468312 */     // MIs[1] Operand 1
     /* 1468312 */     // No operand predicates
     /* 1468312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468316 */     // MIs[0] policy
     /* 1468316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468328 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1468331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468356 */     // GIR_Coverage, 14505,
     /* 1468356 */     GIR_EraseRootFromParent_Done,
     /* 1468357 */   // Label 20588: @1468357
     /* 1468357 */   GIM_Try, /*On fail goto*//*Label 20589*/ GIMT_Encode4(1468457), // Rule ID 14508 //
     /* 1468362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1468373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1468376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1468379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468412 */     // MIs[1] Operand 1
     /* 1468412 */     // No operand predicates
     /* 1468412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468416 */     // MIs[0] policy
     /* 1468416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468428 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1468431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468456 */     // GIR_Coverage, 14508,
     /* 1468456 */     GIR_EraseRootFromParent_Done,
     /* 1468457 */   // Label 20589: @1468457
     /* 1468457 */   GIM_Try, /*On fail goto*//*Label 20590*/ GIMT_Encode4(1468557), // Rule ID 14509 //
     /* 1468462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1468473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1468476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1468479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468512 */     // MIs[1] Operand 1
     /* 1468512 */     // No operand predicates
     /* 1468512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468516 */     // MIs[0] policy
     /* 1468516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468528 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1468531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468556 */     // GIR_Coverage, 14509,
     /* 1468556 */     GIR_EraseRootFromParent_Done,
     /* 1468557 */   // Label 20590: @1468557
     /* 1468557 */   GIM_Try, /*On fail goto*//*Label 20591*/ GIMT_Encode4(1468657), // Rule ID 14512 //
     /* 1468562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1468573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1468576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1468579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468612 */     // MIs[1] Operand 1
     /* 1468612 */     // No operand predicates
     /* 1468612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468616 */     // MIs[0] policy
     /* 1468616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468628 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1468631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468656 */     // GIR_Coverage, 14512,
     /* 1468656 */     GIR_EraseRootFromParent_Done,
     /* 1468657 */   // Label 20591: @1468657
     /* 1468657 */   GIM_Try, /*On fail goto*//*Label 20592*/ GIMT_Encode4(1468757), // Rule ID 14513 //
     /* 1468662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1468673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1468676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1468679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468712 */     // MIs[1] Operand 1
     /* 1468712 */     // No operand predicates
     /* 1468712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468716 */     // MIs[0] policy
     /* 1468716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468728 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1468731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468756 */     // GIR_Coverage, 14513,
     /* 1468756 */     GIR_EraseRootFromParent_Done,
     /* 1468757 */   // Label 20592: @1468757
     /* 1468757 */   GIM_Try, /*On fail goto*//*Label 20593*/ GIMT_Encode4(1468857), // Rule ID 14516 //
     /* 1468762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1468773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1468776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1468779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468812 */     // MIs[1] Operand 1
     /* 1468812 */     // No operand predicates
     /* 1468812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468816 */     // MIs[0] policy
     /* 1468816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468828 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1468831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468856 */     // GIR_Coverage, 14516,
     /* 1468856 */     GIR_EraseRootFromParent_Done,
     /* 1468857 */   // Label 20593: @1468857
     /* 1468857 */   GIM_Try, /*On fail goto*//*Label 20594*/ GIMT_Encode4(1468957), // Rule ID 14517 //
     /* 1468862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1468873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1468876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1468879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468912 */     // MIs[1] Operand 1
     /* 1468912 */     // No operand predicates
     /* 1468912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468916 */     // MIs[0] policy
     /* 1468916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468928 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1468931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468956 */     // GIR_Coverage, 14517,
     /* 1468956 */     GIR_EraseRootFromParent_Done,
     /* 1468957 */   // Label 20594: @1468957
     /* 1468957 */   GIM_Try, /*On fail goto*//*Label 20595*/ GIMT_Encode4(1469057), // Rule ID 14520 //
     /* 1468962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1468973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1468976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1468979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469012 */     // MIs[1] Operand 1
     /* 1469012 */     // No operand predicates
     /* 1469012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469016 */     // MIs[0] policy
     /* 1469016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469028 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1469031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469056 */     // GIR_Coverage, 14520,
     /* 1469056 */     GIR_EraseRootFromParent_Done,
     /* 1469057 */   // Label 20595: @1469057
     /* 1469057 */   GIM_Try, /*On fail goto*//*Label 20596*/ GIMT_Encode4(1469157), // Rule ID 14521 //
     /* 1469062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1469073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1469076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1469079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469112 */     // MIs[1] Operand 1
     /* 1469112 */     // No operand predicates
     /* 1469112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469116 */     // MIs[0] policy
     /* 1469116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469128 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1469131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469156 */     // GIR_Coverage, 14521,
     /* 1469156 */     GIR_EraseRootFromParent_Done,
     /* 1469157 */   // Label 20596: @1469157
     /* 1469157 */   GIM_Try, /*On fail goto*//*Label 20597*/ GIMT_Encode4(1469257), // Rule ID 14524 //
     /* 1469162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1469173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1469176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1469179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469212 */     // MIs[1] Operand 1
     /* 1469212 */     // No operand predicates
     /* 1469212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469216 */     // MIs[0] policy
     /* 1469216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469228 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469256 */     // GIR_Coverage, 14524,
     /* 1469256 */     GIR_EraseRootFromParent_Done,
     /* 1469257 */   // Label 20597: @1469257
     /* 1469257 */   GIM_Try, /*On fail goto*//*Label 20598*/ GIMT_Encode4(1469357), // Rule ID 14525 //
     /* 1469262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1469273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1469276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1469279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469312 */     // MIs[1] Operand 1
     /* 1469312 */     // No operand predicates
     /* 1469312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469316 */     // MIs[0] policy
     /* 1469316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469328 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469356 */     // GIR_Coverage, 14525,
     /* 1469356 */     GIR_EraseRootFromParent_Done,
     /* 1469357 */   // Label 20598: @1469357
     /* 1469357 */   GIM_Try, /*On fail goto*//*Label 20599*/ GIMT_Encode4(1469457), // Rule ID 14528 //
     /* 1469362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1469373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1469376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1469379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1469385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469412 */     // MIs[1] Operand 1
     /* 1469412 */     // No operand predicates
     /* 1469412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469416 */     // MIs[0] policy
     /* 1469416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469428 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469456 */     // GIR_Coverage, 14528,
     /* 1469456 */     GIR_EraseRootFromParent_Done,
     /* 1469457 */   // Label 20599: @1469457
     /* 1469457 */   GIM_Try, /*On fail goto*//*Label 20600*/ GIMT_Encode4(1469557), // Rule ID 14529 //
     /* 1469462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1469473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1469476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1469479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1469485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469512 */     // MIs[1] Operand 1
     /* 1469512 */     // No operand predicates
     /* 1469512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469516 */     // MIs[0] policy
     /* 1469516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469528 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469556 */     // GIR_Coverage, 14529,
     /* 1469556 */     GIR_EraseRootFromParent_Done,
     /* 1469557 */   // Label 20600: @1469557
     /* 1469557 */   GIM_Try, /*On fail goto*//*Label 20601*/ GIMT_Encode4(1469657), // Rule ID 14532 //
     /* 1469562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1469573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1469576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1469579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469612 */     // MIs[1] Operand 1
     /* 1469612 */     // No operand predicates
     /* 1469612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469616 */     // MIs[0] policy
     /* 1469616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469628 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469656 */     // GIR_Coverage, 14532,
     /* 1469656 */     GIR_EraseRootFromParent_Done,
     /* 1469657 */   // Label 20601: @1469657
     /* 1469657 */   GIM_Try, /*On fail goto*//*Label 20602*/ GIMT_Encode4(1469757), // Rule ID 14533 //
     /* 1469662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1469673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1469676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1469679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469712 */     // MIs[1] Operand 1
     /* 1469712 */     // No operand predicates
     /* 1469712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469716 */     // MIs[0] policy
     /* 1469716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469728 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469756 */     // GIR_Coverage, 14533,
     /* 1469756 */     GIR_EraseRootFromParent_Done,
     /* 1469757 */   // Label 20602: @1469757
     /* 1469757 */   GIM_Try, /*On fail goto*//*Label 20603*/ GIMT_Encode4(1469857), // Rule ID 14536 //
     /* 1469762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1469765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1469773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1469776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1469779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469812 */     // MIs[1] Operand 1
     /* 1469812 */     // No operand predicates
     /* 1469812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469816 */     // MIs[0] policy
     /* 1469816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469828 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469856 */     // GIR_Coverage, 14536,
     /* 1469856 */     GIR_EraseRootFromParent_Done,
     /* 1469857 */   // Label 20603: @1469857
     /* 1469857 */   GIM_Try, /*On fail goto*//*Label 20604*/ GIMT_Encode4(1469957), // Rule ID 14537 //
     /* 1469862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1469865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1469873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1469876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1469879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469912 */     // MIs[1] Operand 1
     /* 1469912 */     // No operand predicates
     /* 1469912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469916 */     // MIs[0] policy
     /* 1469916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469956 */     // GIR_Coverage, 14537,
     /* 1469956 */     GIR_EraseRootFromParent_Done,
     /* 1469957 */   // Label 20604: @1469957
     /* 1469957 */   GIM_Try, /*On fail goto*//*Label 20605*/ GIMT_Encode4(1470057), // Rule ID 14540 //
     /* 1469962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1469973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1469976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1469979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1469985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1469992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470012 */     // MIs[1] Operand 1
     /* 1470012 */     // No operand predicates
     /* 1470012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470016 */     // MIs[0] policy
     /* 1470016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470028 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1470031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470056 */     // GIR_Coverage, 14540,
     /* 1470056 */     GIR_EraseRootFromParent_Done,
     /* 1470057 */   // Label 20605: @1470057
     /* 1470057 */   GIM_Try, /*On fail goto*//*Label 20606*/ GIMT_Encode4(1470157), // Rule ID 14541 //
     /* 1470062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1470073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1470076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1470079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1470085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470112 */     // MIs[1] Operand 1
     /* 1470112 */     // No operand predicates
     /* 1470112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470116 */     // MIs[0] policy
     /* 1470116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470128 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1470131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470156 */     // GIR_Coverage, 14541,
     /* 1470156 */     GIR_EraseRootFromParent_Done,
     /* 1470157 */   // Label 20606: @1470157
     /* 1470157 */   GIM_Try, /*On fail goto*//*Label 20607*/ GIMT_Encode4(1470257), // Rule ID 14544 //
     /* 1470162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1470173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1470176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1470179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1470185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470212 */     // MIs[1] Operand 1
     /* 1470212 */     // No operand predicates
     /* 1470212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470216 */     // MIs[0] policy
     /* 1470216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470228 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1470231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470256 */     // GIR_Coverage, 14544,
     /* 1470256 */     GIR_EraseRootFromParent_Done,
     /* 1470257 */   // Label 20607: @1470257
     /* 1470257 */   GIM_Try, /*On fail goto*//*Label 20608*/ GIMT_Encode4(1470357), // Rule ID 14545 //
     /* 1470262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1470273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1470276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1470279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1470285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470312 */     // MIs[1] Operand 1
     /* 1470312 */     // No operand predicates
     /* 1470312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470316 */     // MIs[0] policy
     /* 1470316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470328 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1470331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470356 */     // GIR_Coverage, 14545,
     /* 1470356 */     GIR_EraseRootFromParent_Done,
     /* 1470357 */   // Label 20608: @1470357
     /* 1470357 */   GIM_Try, /*On fail goto*//*Label 20609*/ GIMT_Encode4(1470457), // Rule ID 14548 //
     /* 1470362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1470373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1470376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1470379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1470385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1470392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470412 */     // MIs[1] Operand 1
     /* 1470412 */     // No operand predicates
     /* 1470412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470416 */     // MIs[0] policy
     /* 1470416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470428 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1470431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470456 */     // GIR_Coverage, 14548,
     /* 1470456 */     GIR_EraseRootFromParent_Done,
     /* 1470457 */   // Label 20609: @1470457
     /* 1470457 */   GIM_Try, /*On fail goto*//*Label 20610*/ GIMT_Encode4(1470557), // Rule ID 14549 //
     /* 1470462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1470473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1470476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1470479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1470485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1470492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470512 */     // MIs[1] Operand 1
     /* 1470512 */     // No operand predicates
     /* 1470512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470516 */     // MIs[0] policy
     /* 1470516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470528 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1470531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470556 */     // GIR_Coverage, 14549,
     /* 1470556 */     GIR_EraseRootFromParent_Done,
     /* 1470557 */   // Label 20610: @1470557
     /* 1470557 */   GIM_Try, /*On fail goto*//*Label 20611*/ GIMT_Encode4(1470657), // Rule ID 14552 //
     /* 1470562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1470573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1470576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1470579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1470585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470612 */     // MIs[1] Operand 1
     /* 1470612 */     // No operand predicates
     /* 1470612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470616 */     // MIs[0] policy
     /* 1470616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470628 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1470631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470656 */     // GIR_Coverage, 14552,
     /* 1470656 */     GIR_EraseRootFromParent_Done,
     /* 1470657 */   // Label 20611: @1470657
     /* 1470657 */   GIM_Try, /*On fail goto*//*Label 20612*/ GIMT_Encode4(1470757), // Rule ID 14553 //
     /* 1470662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1470673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1470676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1470679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1470685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470712 */     // MIs[1] Operand 1
     /* 1470712 */     // No operand predicates
     /* 1470712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470716 */     // MIs[0] policy
     /* 1470716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1470731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470756 */     // GIR_Coverage, 14553,
     /* 1470756 */     GIR_EraseRootFromParent_Done,
     /* 1470757 */   // Label 20612: @1470757
     /* 1470757 */   GIM_Try, /*On fail goto*//*Label 20613*/ GIMT_Encode4(1470857), // Rule ID 14556 //
     /* 1470762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1470773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1470776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1470779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1470785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470812 */     // MIs[1] Operand 1
     /* 1470812 */     // No operand predicates
     /* 1470812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470816 */     // MIs[0] policy
     /* 1470816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470828 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1470831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470856 */     // GIR_Coverage, 14556,
     /* 1470856 */     GIR_EraseRootFromParent_Done,
     /* 1470857 */   // Label 20613: @1470857
     /* 1470857 */   GIM_Try, /*On fail goto*//*Label 20614*/ GIMT_Encode4(1470957), // Rule ID 14557 //
     /* 1470862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1470873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1470876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1470879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1470885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470912 */     // MIs[1] Operand 1
     /* 1470912 */     // No operand predicates
     /* 1470912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470916 */     // MIs[0] policy
     /* 1470916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470928 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1470931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470956 */     // GIR_Coverage, 14557,
     /* 1470956 */     GIR_EraseRootFromParent_Done,
     /* 1470957 */   // Label 20614: @1470957
     /* 1470957 */   GIM_Try, /*On fail goto*//*Label 20615*/ GIMT_Encode4(1471057), // Rule ID 14560 //
     /* 1470962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1470973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1470976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1470979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1470985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1470992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471012 */     // MIs[1] Operand 1
     /* 1471012 */     // No operand predicates
     /* 1471012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471016 */     // MIs[0] policy
     /* 1471016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471028 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1471031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471056 */     // GIR_Coverage, 14560,
     /* 1471056 */     GIR_EraseRootFromParent_Done,
     /* 1471057 */   // Label 20615: @1471057
     /* 1471057 */   GIM_Try, /*On fail goto*//*Label 20616*/ GIMT_Encode4(1471157), // Rule ID 14561 //
     /* 1471062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1471073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1471076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1471079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1471085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471112 */     // MIs[1] Operand 1
     /* 1471112 */     // No operand predicates
     /* 1471112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471116 */     // MIs[0] policy
     /* 1471116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471128 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1471131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471156 */     // GIR_Coverage, 14561,
     /* 1471156 */     GIR_EraseRootFromParent_Done,
     /* 1471157 */   // Label 20616: @1471157
     /* 1471157 */   GIM_Try, /*On fail goto*//*Label 20617*/ GIMT_Encode4(1471257), // Rule ID 14564 //
     /* 1471162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1471173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1471176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1471179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471212 */     // MIs[1] Operand 1
     /* 1471212 */     // No operand predicates
     /* 1471212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471216 */     // MIs[0] policy
     /* 1471216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471256 */     // GIR_Coverage, 14564,
     /* 1471256 */     GIR_EraseRootFromParent_Done,
     /* 1471257 */   // Label 20617: @1471257
     /* 1471257 */   GIM_Try, /*On fail goto*//*Label 20618*/ GIMT_Encode4(1471357), // Rule ID 14565 //
     /* 1471262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1471273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1471276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1471279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471312 */     // MIs[1] Operand 1
     /* 1471312 */     // No operand predicates
     /* 1471312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471316 */     // MIs[0] policy
     /* 1471316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471356 */     // GIR_Coverage, 14565,
     /* 1471356 */     GIR_EraseRootFromParent_Done,
     /* 1471357 */   // Label 20618: @1471357
     /* 1471357 */   GIM_Try, /*On fail goto*//*Label 20619*/ GIMT_Encode4(1471457), // Rule ID 14568 //
     /* 1471362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1471373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1471376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1471379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471412 */     // MIs[1] Operand 1
     /* 1471412 */     // No operand predicates
     /* 1471412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471416 */     // MIs[0] policy
     /* 1471416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1471431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471456 */     // GIR_Coverage, 14568,
     /* 1471456 */     GIR_EraseRootFromParent_Done,
     /* 1471457 */   // Label 20619: @1471457
     /* 1471457 */   GIM_Try, /*On fail goto*//*Label 20620*/ GIMT_Encode4(1471557), // Rule ID 14569 //
     /* 1471462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1471473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1471476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1471479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471512 */     // MIs[1] Operand 1
     /* 1471512 */     // No operand predicates
     /* 1471512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471516 */     // MIs[0] policy
     /* 1471516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471528 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1471531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471556 */     // GIR_Coverage, 14569,
     /* 1471556 */     GIR_EraseRootFromParent_Done,
     /* 1471557 */   // Label 20620: @1471557
     /* 1471557 */   GIM_Try, /*On fail goto*//*Label 20621*/ GIMT_Encode4(1471657), // Rule ID 14572 //
     /* 1471562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1471573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1471576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1471579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1471585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471612 */     // MIs[1] Operand 1
     /* 1471612 */     // No operand predicates
     /* 1471612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471616 */     // MIs[0] policy
     /* 1471616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471628 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1471631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471656 */     // GIR_Coverage, 14572,
     /* 1471656 */     GIR_EraseRootFromParent_Done,
     /* 1471657 */   // Label 20621: @1471657
     /* 1471657 */   GIM_Try, /*On fail goto*//*Label 20622*/ GIMT_Encode4(1471757), // Rule ID 14573 //
     /* 1471662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1471673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1471676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1471679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1471685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471712 */     // MIs[1] Operand 1
     /* 1471712 */     // No operand predicates
     /* 1471712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471716 */     // MIs[0] policy
     /* 1471716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471728 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1471731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471756 */     // GIR_Coverage, 14573,
     /* 1471756 */     GIR_EraseRootFromParent_Done,
     /* 1471757 */   // Label 20622: @1471757
     /* 1471757 */   GIM_Try, /*On fail goto*//*Label 20623*/ GIMT_Encode4(1471857), // Rule ID 14576 //
     /* 1471762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1471765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1471773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1471776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1471779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1471785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471812 */     // MIs[1] Operand 1
     /* 1471812 */     // No operand predicates
     /* 1471812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471816 */     // MIs[0] policy
     /* 1471816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471828 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1471850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471856 */     // GIR_Coverage, 14576,
     /* 1471856 */     GIR_EraseRootFromParent_Done,
     /* 1471857 */   // Label 20623: @1471857
     /* 1471857 */   GIM_Try, /*On fail goto*//*Label 20624*/ GIMT_Encode4(1471957), // Rule ID 14577 //
     /* 1471862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1471865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1471873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1471876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1471879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1471885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471912 */     // MIs[1] Operand 1
     /* 1471912 */     // No operand predicates
     /* 1471912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471916 */     // MIs[0] policy
     /* 1471916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471928 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1471950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471956 */     // GIR_Coverage, 14577,
     /* 1471956 */     GIR_EraseRootFromParent_Done,
     /* 1471957 */   // Label 20624: @1471957
     /* 1471957 */   GIM_Try, /*On fail goto*//*Label 20625*/ GIMT_Encode4(1472057), // Rule ID 14580 //
     /* 1471962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1471965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1471973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1471976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1471979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472012 */     // MIs[1] Operand 1
     /* 1472012 */     // No operand predicates
     /* 1472012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472016 */     // MIs[0] policy
     /* 1472016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472028 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1472031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472056 */     // GIR_Coverage, 14580,
     /* 1472056 */     GIR_EraseRootFromParent_Done,
     /* 1472057 */   // Label 20625: @1472057
     /* 1472057 */   GIM_Try, /*On fail goto*//*Label 20626*/ GIMT_Encode4(1472157), // Rule ID 14581 //
     /* 1472062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1472065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1472073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1472076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1472079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1472085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472112 */     // MIs[1] Operand 1
     /* 1472112 */     // No operand predicates
     /* 1472112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472116 */     // MIs[0] policy
     /* 1472116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472128 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1472131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472156 */     // GIR_Coverage, 14581,
     /* 1472156 */     GIR_EraseRootFromParent_Done,
     /* 1472157 */   // Label 20626: @1472157
     /* 1472157 */   GIM_Try, /*On fail goto*//*Label 20627*/ GIMT_Encode4(1472257), // Rule ID 14584 //
     /* 1472162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1472165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1472173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1472176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1472179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1472185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472212 */     // MIs[1] Operand 1
     /* 1472212 */     // No operand predicates
     /* 1472212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472216 */     // MIs[0] policy
     /* 1472216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472228 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1472231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472256 */     // GIR_Coverage, 14584,
     /* 1472256 */     GIR_EraseRootFromParent_Done,
     /* 1472257 */   // Label 20627: @1472257
     /* 1472257 */   GIM_Try, /*On fail goto*//*Label 20628*/ GIMT_Encode4(1472357), // Rule ID 14585 //
     /* 1472262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1472265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1472273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1472276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1472279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1472285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472312 */     // MIs[1] Operand 1
     /* 1472312 */     // No operand predicates
     /* 1472312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472316 */     // MIs[0] policy
     /* 1472316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472328 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1472331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472356 */     // GIR_Coverage, 14585,
     /* 1472356 */     GIR_EraseRootFromParent_Done,
     /* 1472357 */   // Label 20628: @1472357
     /* 1472357 */   GIM_Try, /*On fail goto*//*Label 20629*/ GIMT_Encode4(1472454), // Rule ID 23704 //
     /* 1472362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1472373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1472376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1472379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472412 */     // MIs[1] Operand 1
     /* 1472412 */     // No operand predicates
     /* 1472412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472416 */     // MIs[0] policy
     /* 1472416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472428 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1472431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472453 */     // GIR_Coverage, 23704,
     /* 1472453 */     GIR_EraseRootFromParent_Done,
     /* 1472454 */   // Label 20629: @1472454
     /* 1472454 */   GIM_Try, /*On fail goto*//*Label 20630*/ GIMT_Encode4(1472551), // Rule ID 23705 //
     /* 1472459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1472470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1472473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1472476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472509 */     // MIs[1] Operand 1
     /* 1472509 */     // No operand predicates
     /* 1472509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472513 */     // MIs[0] policy
     /* 1472513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472525 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1472528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472550 */     // GIR_Coverage, 23705,
     /* 1472550 */     GIR_EraseRootFromParent_Done,
     /* 1472551 */   // Label 20630: @1472551
     /* 1472551 */   GIM_Try, /*On fail goto*//*Label 20631*/ GIMT_Encode4(1472648), // Rule ID 23708 //
     /* 1472556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1472567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1472570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1472573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1472579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472606 */     // MIs[1] Operand 1
     /* 1472606 */     // No operand predicates
     /* 1472606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472610 */     // MIs[0] policy
     /* 1472610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472622 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1472625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472647 */     // GIR_Coverage, 23708,
     /* 1472647 */     GIR_EraseRootFromParent_Done,
     /* 1472648 */   // Label 20631: @1472648
     /* 1472648 */   GIM_Try, /*On fail goto*//*Label 20632*/ GIMT_Encode4(1472745), // Rule ID 23709 //
     /* 1472653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1472664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1472667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1472670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1472676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472703 */     // MIs[1] Operand 1
     /* 1472703 */     // No operand predicates
     /* 1472703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472707 */     // MIs[0] policy
     /* 1472707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472719 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1472722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472744 */     // GIR_Coverage, 23709,
     /* 1472744 */     GIR_EraseRootFromParent_Done,
     /* 1472745 */   // Label 20632: @1472745
     /* 1472745 */   GIM_Try, /*On fail goto*//*Label 20633*/ GIMT_Encode4(1472842), // Rule ID 23712 //
     /* 1472750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1472761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1472764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1472767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1472773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472800 */     // MIs[1] Operand 1
     /* 1472800 */     // No operand predicates
     /* 1472800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472804 */     // MIs[0] policy
     /* 1472804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472816 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1472819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472841 */     // GIR_Coverage, 23712,
     /* 1472841 */     GIR_EraseRootFromParent_Done,
     /* 1472842 */   // Label 20633: @1472842
     /* 1472842 */   GIM_Try, /*On fail goto*//*Label 20634*/ GIMT_Encode4(1472939), // Rule ID 23713 //
     /* 1472847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1472858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1472861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1472864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1472870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472897 */     // MIs[1] Operand 1
     /* 1472897 */     // No operand predicates
     /* 1472897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472901 */     // MIs[0] policy
     /* 1472901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472913 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1472916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472938 */     // GIR_Coverage, 23713,
     /* 1472938 */     GIR_EraseRootFromParent_Done,
     /* 1472939 */   // Label 20634: @1472939
     /* 1472939 */   GIM_Try, /*On fail goto*//*Label 20635*/ GIMT_Encode4(1473036), // Rule ID 23716 //
     /* 1472944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1472955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1472958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1472961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472994 */     // MIs[1] Operand 1
     /* 1472994 */     // No operand predicates
     /* 1472994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472998 */     // MIs[0] policy
     /* 1472998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473010 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1473013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473035 */     // GIR_Coverage, 23716,
     /* 1473035 */     GIR_EraseRootFromParent_Done,
     /* 1473036 */   // Label 20635: @1473036
     /* 1473036 */   GIM_Try, /*On fail goto*//*Label 20636*/ GIMT_Encode4(1473133), // Rule ID 23717 //
     /* 1473041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1473052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1473055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1473058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473091 */     // MIs[1] Operand 1
     /* 1473091 */     // No operand predicates
     /* 1473091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473095 */     // MIs[0] policy
     /* 1473095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473107 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1473110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473132 */     // GIR_Coverage, 23717,
     /* 1473132 */     GIR_EraseRootFromParent_Done,
     /* 1473133 */   // Label 20636: @1473133
     /* 1473133 */   GIM_Try, /*On fail goto*//*Label 20637*/ GIMT_Encode4(1473230), // Rule ID 23720 //
     /* 1473138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1473149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1473152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1473155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473188 */     // MIs[1] Operand 1
     /* 1473188 */     // No operand predicates
     /* 1473188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473192 */     // MIs[0] policy
     /* 1473192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473204 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473229 */     // GIR_Coverage, 23720,
     /* 1473229 */     GIR_EraseRootFromParent_Done,
     /* 1473230 */   // Label 20637: @1473230
     /* 1473230 */   GIM_Try, /*On fail goto*//*Label 20638*/ GIMT_Encode4(1473327), // Rule ID 23721 //
     /* 1473235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1473246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1473249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1473252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473285 */     // MIs[1] Operand 1
     /* 1473285 */     // No operand predicates
     /* 1473285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473289 */     // MIs[0] policy
     /* 1473289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473301 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473326 */     // GIR_Coverage, 23721,
     /* 1473326 */     GIR_EraseRootFromParent_Done,
     /* 1473327 */   // Label 20638: @1473327
     /* 1473327 */   GIM_Try, /*On fail goto*//*Label 20639*/ GIMT_Encode4(1473424), // Rule ID 23724 //
     /* 1473332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1473343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1473346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1473349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473382 */     // MIs[1] Operand 1
     /* 1473382 */     // No operand predicates
     /* 1473382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473386 */     // MIs[0] policy
     /* 1473386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473398 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473423 */     // GIR_Coverage, 23724,
     /* 1473423 */     GIR_EraseRootFromParent_Done,
     /* 1473424 */   // Label 20639: @1473424
     /* 1473424 */   GIM_Try, /*On fail goto*//*Label 20640*/ GIMT_Encode4(1473521), // Rule ID 23725 //
     /* 1473429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1473440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1473443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1473446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473479 */     // MIs[1] Operand 1
     /* 1473479 */     // No operand predicates
     /* 1473479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473483 */     // MIs[0] policy
     /* 1473483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473495 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473520 */     // GIR_Coverage, 23725,
     /* 1473520 */     GIR_EraseRootFromParent_Done,
     /* 1473521 */   // Label 20640: @1473521
     /* 1473521 */   GIM_Try, /*On fail goto*//*Label 20641*/ GIMT_Encode4(1473618), // Rule ID 23728 //
     /* 1473526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1473537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1473540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1473543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1473549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473576 */     // MIs[1] Operand 1
     /* 1473576 */     // No operand predicates
     /* 1473576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473580 */     // MIs[0] policy
     /* 1473580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473592 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1473595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473617 */     // GIR_Coverage, 23728,
     /* 1473617 */     GIR_EraseRootFromParent_Done,
     /* 1473618 */   // Label 20641: @1473618
     /* 1473618 */   GIM_Try, /*On fail goto*//*Label 20642*/ GIMT_Encode4(1473715), // Rule ID 23729 //
     /* 1473623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1473634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1473637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1473640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1473646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473673 */     // MIs[1] Operand 1
     /* 1473673 */     // No operand predicates
     /* 1473673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473677 */     // MIs[0] policy
     /* 1473677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473689 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1473692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473714 */     // GIR_Coverage, 23729,
     /* 1473714 */     GIR_EraseRootFromParent_Done,
     /* 1473715 */   // Label 20642: @1473715
     /* 1473715 */   GIM_Try, /*On fail goto*//*Label 20643*/ GIMT_Encode4(1473812), // Rule ID 23732 //
     /* 1473720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1473731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1473734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1473737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473770 */     // MIs[1] Operand 1
     /* 1473770 */     // No operand predicates
     /* 1473770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473774 */     // MIs[0] policy
     /* 1473774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473786 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1473789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473811 */     // GIR_Coverage, 23732,
     /* 1473811 */     GIR_EraseRootFromParent_Done,
     /* 1473812 */   // Label 20643: @1473812
     /* 1473812 */   GIM_Try, /*On fail goto*//*Label 20644*/ GIMT_Encode4(1473909), // Rule ID 23733 //
     /* 1473817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1473828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1473831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1473834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473867 */     // MIs[1] Operand 1
     /* 1473867 */     // No operand predicates
     /* 1473867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473871 */     // MIs[0] policy
     /* 1473871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473883 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1473886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473908 */     // GIR_Coverage, 23733,
     /* 1473908 */     GIR_EraseRootFromParent_Done,
     /* 1473909 */   // Label 20644: @1473909
     /* 1473909 */   GIM_Try, /*On fail goto*//*Label 20645*/ GIMT_Encode4(1474006), // Rule ID 23736 //
     /* 1473914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1473925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1473928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1473931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473964 */     // MIs[1] Operand 1
     /* 1473964 */     // No operand predicates
     /* 1473964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473968 */     // MIs[0] policy
     /* 1473968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473980 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1473983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474005 */     // GIR_Coverage, 23736,
     /* 1474005 */     GIR_EraseRootFromParent_Done,
     /* 1474006 */   // Label 20645: @1474006
     /* 1474006 */   GIM_Try, /*On fail goto*//*Label 20646*/ GIMT_Encode4(1474103), // Rule ID 23737 //
     /* 1474011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1474022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1474025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1474028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1474034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474061 */     // MIs[1] Operand 1
     /* 1474061 */     // No operand predicates
     /* 1474061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474065 */     // MIs[0] policy
     /* 1474065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474077 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474102 */     // GIR_Coverage, 23737,
     /* 1474102 */     GIR_EraseRootFromParent_Done,
     /* 1474103 */   // Label 20646: @1474103
     /* 1474103 */   GIM_Try, /*On fail goto*//*Label 20647*/ GIMT_Encode4(1474200), // Rule ID 23740 //
     /* 1474108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1474111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1474119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1474122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1474125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474158 */     // MIs[1] Operand 1
     /* 1474158 */     // No operand predicates
     /* 1474158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474162 */     // MIs[0] policy
     /* 1474162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474199 */     // GIR_Coverage, 23740,
     /* 1474199 */     GIR_EraseRootFromParent_Done,
     /* 1474200 */   // Label 20647: @1474200
     /* 1474200 */   GIM_Try, /*On fail goto*//*Label 20648*/ GIMT_Encode4(1474297), // Rule ID 23741 //
     /* 1474205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1474208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1474216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1474219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1474222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474255 */     // MIs[1] Operand 1
     /* 1474255 */     // No operand predicates
     /* 1474255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474259 */     // MIs[0] policy
     /* 1474259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474271 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474296 */     // GIR_Coverage, 23741,
     /* 1474296 */     GIR_EraseRootFromParent_Done,
     /* 1474297 */   // Label 20648: @1474297
     /* 1474297 */   GIM_Try, /*On fail goto*//*Label 20649*/ GIMT_Encode4(1474394), // Rule ID 23744 //
     /* 1474302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1474313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1474316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1474319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1474325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474352 */     // MIs[1] Operand 1
     /* 1474352 */     // No operand predicates
     /* 1474352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474356 */     // MIs[0] policy
     /* 1474356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474368 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1474371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474393 */     // GIR_Coverage, 23744,
     /* 1474393 */     GIR_EraseRootFromParent_Done,
     /* 1474394 */   // Label 20649: @1474394
     /* 1474394 */   GIM_Try, /*On fail goto*//*Label 20650*/ GIMT_Encode4(1474491), // Rule ID 23745 //
     /* 1474399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1474410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1474413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1474416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1474422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474449 */     // MIs[1] Operand 1
     /* 1474449 */     // No operand predicates
     /* 1474449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474453 */     // MIs[0] policy
     /* 1474453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474465 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1474468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474490 */     // GIR_Coverage, 23745,
     /* 1474490 */     GIR_EraseRootFromParent_Done,
     /* 1474491 */   // Label 20650: @1474491
     /* 1474491 */   GIM_Try, /*On fail goto*//*Label 20651*/ GIMT_Encode4(1474588), // Rule ID 23748 //
     /* 1474496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1474507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1474510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1474513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1474519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474546 */     // MIs[1] Operand 1
     /* 1474546 */     // No operand predicates
     /* 1474546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474550 */     // MIs[0] policy
     /* 1474550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474562 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1474565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474587 */     // GIR_Coverage, 23748,
     /* 1474587 */     GIR_EraseRootFromParent_Done,
     /* 1474588 */   // Label 20651: @1474588
     /* 1474588 */   GIM_Try, /*On fail goto*//*Label 20652*/ GIMT_Encode4(1474685), // Rule ID 23749 //
     /* 1474593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1474604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1474607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1474610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1474616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474643 */     // MIs[1] Operand 1
     /* 1474643 */     // No operand predicates
     /* 1474643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474647 */     // MIs[0] policy
     /* 1474647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474659 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1474662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474684 */     // GIR_Coverage, 23749,
     /* 1474684 */     GIR_EraseRootFromParent_Done,
     /* 1474685 */   // Label 20652: @1474685
     /* 1474685 */   GIM_Try, /*On fail goto*//*Label 20653*/ GIMT_Encode4(1474782), // Rule ID 23752 //
     /* 1474690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1474701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1474704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1474707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1474713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1474720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474740 */     // MIs[1] Operand 1
     /* 1474740 */     // No operand predicates
     /* 1474740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474744 */     // MIs[0] policy
     /* 1474744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474756 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1474759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474781 */     // GIR_Coverage, 23752,
     /* 1474781 */     GIR_EraseRootFromParent_Done,
     /* 1474782 */   // Label 20653: @1474782
     /* 1474782 */   GIM_Try, /*On fail goto*//*Label 20654*/ GIMT_Encode4(1474879), // Rule ID 23753 //
     /* 1474787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1474798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1474801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1474804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1474810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1474817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474837 */     // MIs[1] Operand 1
     /* 1474837 */     // No operand predicates
     /* 1474837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474841 */     // MIs[0] policy
     /* 1474841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474853 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1474856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474878 */     // GIR_Coverage, 23753,
     /* 1474878 */     GIR_EraseRootFromParent_Done,
     /* 1474879 */   // Label 20654: @1474879
     /* 1474879 */   GIM_Try, /*On fail goto*//*Label 20655*/ GIMT_Encode4(1474976), // Rule ID 23756 //
     /* 1474884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1474895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1474898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1474901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1474907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474934 */     // MIs[1] Operand 1
     /* 1474934 */     // No operand predicates
     /* 1474934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474938 */     // MIs[0] policy
     /* 1474938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474950 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1474953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474975 */     // GIR_Coverage, 23756,
     /* 1474975 */     GIR_EraseRootFromParent_Done,
     /* 1474976 */   // Label 20655: @1474976
     /* 1474976 */   GIM_Try, /*On fail goto*//*Label 20656*/ GIMT_Encode4(1475073), // Rule ID 23757 //
     /* 1474981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1474992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1474995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1474998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475031 */     // MIs[1] Operand 1
     /* 1475031 */     // No operand predicates
     /* 1475031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475035 */     // MIs[0] policy
     /* 1475035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475047 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475072 */     // GIR_Coverage, 23757,
     /* 1475072 */     GIR_EraseRootFromParent_Done,
     /* 1475073 */   // Label 20656: @1475073
     /* 1475073 */   GIM_Try, /*On fail goto*//*Label 20657*/ GIMT_Encode4(1475170), // Rule ID 23760 //
     /* 1475078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1475089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1475092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1475095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475128 */     // MIs[1] Operand 1
     /* 1475128 */     // No operand predicates
     /* 1475128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475132 */     // MIs[0] policy
     /* 1475132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475144 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475169 */     // GIR_Coverage, 23760,
     /* 1475169 */     GIR_EraseRootFromParent_Done,
     /* 1475170 */   // Label 20657: @1475170
     /* 1475170 */   GIM_Try, /*On fail goto*//*Label 20658*/ GIMT_Encode4(1475267), // Rule ID 23761 //
     /* 1475175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1475186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1475189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1475192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475225 */     // MIs[1] Operand 1
     /* 1475225 */     // No operand predicates
     /* 1475225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475229 */     // MIs[0] policy
     /* 1475229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475241 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475266 */     // GIR_Coverage, 23761,
     /* 1475266 */     GIR_EraseRootFromParent_Done,
     /* 1475267 */   // Label 20658: @1475267
     /* 1475267 */   GIM_Try, /*On fail goto*//*Label 20659*/ GIMT_Encode4(1475364), // Rule ID 23764 //
     /* 1475272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1475283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1475286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1475289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1475295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475322 */     // MIs[1] Operand 1
     /* 1475322 */     // No operand predicates
     /* 1475322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475326 */     // MIs[0] policy
     /* 1475326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475338 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475363 */     // GIR_Coverage, 23764,
     /* 1475363 */     GIR_EraseRootFromParent_Done,
     /* 1475364 */   // Label 20659: @1475364
     /* 1475364 */   GIM_Try, /*On fail goto*//*Label 20660*/ GIMT_Encode4(1475461), // Rule ID 23765 //
     /* 1475369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1475380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1475383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1475386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1475392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475419 */     // MIs[1] Operand 1
     /* 1475419 */     // No operand predicates
     /* 1475419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475423 */     // MIs[0] policy
     /* 1475423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475435 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475460 */     // GIR_Coverage, 23765,
     /* 1475460 */     GIR_EraseRootFromParent_Done,
     /* 1475461 */   // Label 20660: @1475461
     /* 1475461 */   GIM_Try, /*On fail goto*//*Label 20661*/ GIMT_Encode4(1475558), // Rule ID 23768 //
     /* 1475466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1475477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1475480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1475483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1475489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475516 */     // MIs[1] Operand 1
     /* 1475516 */     // No operand predicates
     /* 1475516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475520 */     // MIs[0] policy
     /* 1475520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475532 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475557 */     // GIR_Coverage, 23768,
     /* 1475557 */     GIR_EraseRootFromParent_Done,
     /* 1475558 */   // Label 20661: @1475558
     /* 1475558 */   GIM_Try, /*On fail goto*//*Label 20662*/ GIMT_Encode4(1475655), // Rule ID 23769 //
     /* 1475563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1475574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1475577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1475580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1475586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475613 */     // MIs[1] Operand 1
     /* 1475613 */     // No operand predicates
     /* 1475613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475617 */     // MIs[0] policy
     /* 1475617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475629 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475654 */     // GIR_Coverage, 23769,
     /* 1475654 */     GIR_EraseRootFromParent_Done,
     /* 1475655 */   // Label 20662: @1475655
     /* 1475655 */   GIM_Try, /*On fail goto*//*Label 20663*/ GIMT_Encode4(1475752), // Rule ID 23772 //
     /* 1475660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1475671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1475674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1475677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475710 */     // MIs[1] Operand 1
     /* 1475710 */     // No operand predicates
     /* 1475710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475714 */     // MIs[0] policy
     /* 1475714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475726 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475751 */     // GIR_Coverage, 23772,
     /* 1475751 */     GIR_EraseRootFromParent_Done,
     /* 1475752 */   // Label 20663: @1475752
     /* 1475752 */   GIM_Try, /*On fail goto*//*Label 20664*/ GIMT_Encode4(1475849), // Rule ID 23773 //
     /* 1475757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1475768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1475771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1475774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475807 */     // MIs[1] Operand 1
     /* 1475807 */     // No operand predicates
     /* 1475807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475811 */     // MIs[0] policy
     /* 1475811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475823 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475848 */     // GIR_Coverage, 23773,
     /* 1475848 */     GIR_EraseRootFromParent_Done,
     /* 1475849 */   // Label 20664: @1475849
     /* 1475849 */   GIM_Try, /*On fail goto*//*Label 20665*/ GIMT_Encode4(1475946), // Rule ID 23776 //
     /* 1475854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1475865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1475868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1475871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475904 */     // MIs[1] Operand 1
     /* 1475904 */     // No operand predicates
     /* 1475904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475908 */     // MIs[0] policy
     /* 1475908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475920 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475945 */     // GIR_Coverage, 23776,
     /* 1475945 */     GIR_EraseRootFromParent_Done,
     /* 1475946 */   // Label 20665: @1475946
     /* 1475946 */   GIM_Try, /*On fail goto*//*Label 20666*/ GIMT_Encode4(1476043), // Rule ID 23777 //
     /* 1475951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1475962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1475965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1475968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476001 */     // MIs[1] Operand 1
     /* 1476001 */     // No operand predicates
     /* 1476001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476005 */     // MIs[0] policy
     /* 1476005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476017 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476042 */     // GIR_Coverage, 23777,
     /* 1476042 */     GIR_EraseRootFromParent_Done,
     /* 1476043 */   // Label 20666: @1476043
     /* 1476043 */   GIM_Try, /*On fail goto*//*Label 20667*/ GIMT_Encode4(1476140), // Rule ID 23780 //
     /* 1476048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1476051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1476059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1476062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1476065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476098 */     // MIs[1] Operand 1
     /* 1476098 */     // No operand predicates
     /* 1476098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476102 */     // MIs[0] policy
     /* 1476102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476139 */     // GIR_Coverage, 23780,
     /* 1476139 */     GIR_EraseRootFromParent_Done,
     /* 1476140 */   // Label 20667: @1476140
     /* 1476140 */   GIM_Try, /*On fail goto*//*Label 20668*/ GIMT_Encode4(1476237), // Rule ID 23781 //
     /* 1476145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1476156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1476159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1476162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476195 */     // MIs[1] Operand 1
     /* 1476195 */     // No operand predicates
     /* 1476195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476199 */     // MIs[0] policy
     /* 1476199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476211 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476236 */     // GIR_Coverage, 23781,
     /* 1476236 */     GIR_EraseRootFromParent_Done,
     /* 1476237 */   // Label 20668: @1476237
     /* 1476237 */   GIM_Try, /*On fail goto*//*Label 20669*/ GIMT_Encode4(1476334), // Rule ID 23784 //
     /* 1476242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1476245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1476253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1476256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1476259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476292 */     // MIs[1] Operand 1
     /* 1476292 */     // No operand predicates
     /* 1476292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476296 */     // MIs[0] policy
     /* 1476296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476308 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476333 */     // GIR_Coverage, 23784,
     /* 1476333 */     GIR_EraseRootFromParent_Done,
     /* 1476334 */   // Label 20669: @1476334
     /* 1476334 */   GIM_Try, /*On fail goto*//*Label 20670*/ GIMT_Encode4(1476431), // Rule ID 23785 //
     /* 1476339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1476350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1476353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1476356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476389 */     // MIs[1] Operand 1
     /* 1476389 */     // No operand predicates
     /* 1476389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476393 */     // MIs[0] policy
     /* 1476393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476405 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476430 */     // GIR_Coverage, 23785,
     /* 1476430 */     GIR_EraseRootFromParent_Done,
     /* 1476431 */   // Label 20670: @1476431
     /* 1476431 */   GIM_Try, /*On fail goto*//*Label 20671*/ GIMT_Encode4(1476528), // Rule ID 23788 //
     /* 1476436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1476439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1476447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1476450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1476453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476486 */     // MIs[1] Operand 1
     /* 1476486 */     // No operand predicates
     /* 1476486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476490 */     // MIs[0] policy
     /* 1476490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476527 */     // GIR_Coverage, 23788,
     /* 1476527 */     GIR_EraseRootFromParent_Done,
     /* 1476528 */   // Label 20671: @1476528
     /* 1476528 */   GIM_Try, /*On fail goto*//*Label 20672*/ GIMT_Encode4(1476625), // Rule ID 23789 //
     /* 1476533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1476544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1476547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1476550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476583 */     // MIs[1] Operand 1
     /* 1476583 */     // No operand predicates
     /* 1476583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476587 */     // MIs[0] policy
     /* 1476587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476599 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476624 */     // GIR_Coverage, 23789,
     /* 1476624 */     GIR_EraseRootFromParent_Done,
     /* 1476625 */   // Label 20672: @1476625
     /* 1476625 */   GIM_Try, /*On fail goto*//*Label 20673*/ GIMT_Encode4(1476722), // Rule ID 23880 //
     /* 1476630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1476641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1476644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1476647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1476653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476680 */     // MIs[1] Operand 1
     /* 1476680 */     // No operand predicates
     /* 1476680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476684 */     // MIs[0] policy
     /* 1476684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476696 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1476699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476721 */     // GIR_Coverage, 23880,
     /* 1476721 */     GIR_EraseRootFromParent_Done,
     /* 1476722 */   // Label 20673: @1476722
     /* 1476722 */   GIM_Try, /*On fail goto*//*Label 20674*/ GIMT_Encode4(1476819), // Rule ID 23881 //
     /* 1476727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1476738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1476741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1476744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1476750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476777 */     // MIs[1] Operand 1
     /* 1476777 */     // No operand predicates
     /* 1476777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476781 */     // MIs[0] policy
     /* 1476781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476793 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1476796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476818 */     // GIR_Coverage, 23881,
     /* 1476818 */     GIR_EraseRootFromParent_Done,
     /* 1476819 */   // Label 20674: @1476819
     /* 1476819 */   GIM_Try, /*On fail goto*//*Label 20675*/ GIMT_Encode4(1476916), // Rule ID 23884 //
     /* 1476824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1476835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1476838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1476841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476874 */     // MIs[1] Operand 1
     /* 1476874 */     // No operand predicates
     /* 1476874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476878 */     // MIs[0] policy
     /* 1476878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476890 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1476893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476915 */     // GIR_Coverage, 23884,
     /* 1476915 */     GIR_EraseRootFromParent_Done,
     /* 1476916 */   // Label 20675: @1476916
     /* 1476916 */   GIM_Try, /*On fail goto*//*Label 20676*/ GIMT_Encode4(1477013), // Rule ID 23885 //
     /* 1476921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1476932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1476935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1476938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476971 */     // MIs[1] Operand 1
     /* 1476971 */     // No operand predicates
     /* 1476971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476975 */     // MIs[0] policy
     /* 1476975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476987 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1476990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477012 */     // GIR_Coverage, 23885,
     /* 1477012 */     GIR_EraseRootFromParent_Done,
     /* 1477013 */   // Label 20676: @1477013
     /* 1477013 */   GIM_Try, /*On fail goto*//*Label 20677*/ GIMT_Encode4(1477110), // Rule ID 23888 //
     /* 1477018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1477029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1477032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1477035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477064 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477068 */     // MIs[1] Operand 1
     /* 1477068 */     // No operand predicates
     /* 1477068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477072 */     // MIs[0] policy
     /* 1477072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477084 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477109 */     // GIR_Coverage, 23888,
     /* 1477109 */     GIR_EraseRootFromParent_Done,
     /* 1477110 */   // Label 20677: @1477110
     /* 1477110 */   GIM_Try, /*On fail goto*//*Label 20678*/ GIMT_Encode4(1477207), // Rule ID 23889 //
     /* 1477115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1477126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1477129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1477132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477165 */     // MIs[1] Operand 1
     /* 1477165 */     // No operand predicates
     /* 1477165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477169 */     // MIs[0] policy
     /* 1477169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477181 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477206 */     // GIR_Coverage, 23889,
     /* 1477206 */     GIR_EraseRootFromParent_Done,
     /* 1477207 */   // Label 20678: @1477207
     /* 1477207 */   GIM_Try, /*On fail goto*//*Label 20679*/ GIMT_Encode4(1477304), // Rule ID 23892 //
     /* 1477212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1477223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1477226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1477229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477262 */     // MIs[1] Operand 1
     /* 1477262 */     // No operand predicates
     /* 1477262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477266 */     // MIs[0] policy
     /* 1477266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477278 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477303 */     // GIR_Coverage, 23892,
     /* 1477303 */     GIR_EraseRootFromParent_Done,
     /* 1477304 */   // Label 20679: @1477304
     /* 1477304 */   GIM_Try, /*On fail goto*//*Label 20680*/ GIMT_Encode4(1477401), // Rule ID 23893 //
     /* 1477309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1477320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1477323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1477326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477359 */     // MIs[1] Operand 1
     /* 1477359 */     // No operand predicates
     /* 1477359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477363 */     // MIs[0] policy
     /* 1477363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477375 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477400 */     // GIR_Coverage, 23893,
     /* 1477400 */     GIR_EraseRootFromParent_Done,
     /* 1477401 */   // Label 20680: @1477401
     /* 1477401 */   GIM_Try, /*On fail goto*//*Label 20681*/ GIMT_Encode4(1477498), // Rule ID 23896 //
     /* 1477406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1477417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1477420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1477423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477456 */     // MIs[1] Operand 1
     /* 1477456 */     // No operand predicates
     /* 1477456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477460 */     // MIs[0] policy
     /* 1477460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477472 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477497 */     // GIR_Coverage, 23896,
     /* 1477497 */     GIR_EraseRootFromParent_Done,
     /* 1477498 */   // Label 20681: @1477498
     /* 1477498 */   GIM_Try, /*On fail goto*//*Label 20682*/ GIMT_Encode4(1477595), // Rule ID 23897 //
     /* 1477503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1477514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1477517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1477520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477553 */     // MIs[1] Operand 1
     /* 1477553 */     // No operand predicates
     /* 1477553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477557 */     // MIs[0] policy
     /* 1477557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477569 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477594 */     // GIR_Coverage, 23897,
     /* 1477594 */     GIR_EraseRootFromParent_Done,
     /* 1477595 */   // Label 20682: @1477595
     /* 1477595 */   GIM_Try, /*On fail goto*//*Label 20683*/ GIMT_Encode4(1477692), // Rule ID 23900 //
     /* 1477600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1477611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1477614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1477617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477650 */     // MIs[1] Operand 1
     /* 1477650 */     // No operand predicates
     /* 1477650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477654 */     // MIs[0] policy
     /* 1477654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477666 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477691 */     // GIR_Coverage, 23900,
     /* 1477691 */     GIR_EraseRootFromParent_Done,
     /* 1477692 */   // Label 20683: @1477692
     /* 1477692 */   GIM_Try, /*On fail goto*//*Label 20684*/ GIMT_Encode4(1477789), // Rule ID 23901 //
     /* 1477697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1477708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1477711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1477714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477747 */     // MIs[1] Operand 1
     /* 1477747 */     // No operand predicates
     /* 1477747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477751 */     // MIs[0] policy
     /* 1477751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477763 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477788 */     // GIR_Coverage, 23901,
     /* 1477788 */     GIR_EraseRootFromParent_Done,
     /* 1477789 */   // Label 20684: @1477789
     /* 1477789 */   GIM_Try, /*On fail goto*//*Label 20685*/ GIMT_Encode4(1477886), // Rule ID 23904 //
     /* 1477794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1477805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1477808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1477811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1477817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477844 */     // MIs[1] Operand 1
     /* 1477844 */     // No operand predicates
     /* 1477844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477848 */     // MIs[0] policy
     /* 1477848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477860 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1477863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477885 */     // GIR_Coverage, 23904,
     /* 1477885 */     GIR_EraseRootFromParent_Done,
     /* 1477886 */   // Label 20685: @1477886
     /* 1477886 */   GIM_Try, /*On fail goto*//*Label 20686*/ GIMT_Encode4(1477983), // Rule ID 23905 //
     /* 1477891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1477902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1477905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1477908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1477914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477941 */     // MIs[1] Operand 1
     /* 1477941 */     // No operand predicates
     /* 1477941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477945 */     // MIs[0] policy
     /* 1477945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477957 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1477960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477982 */     // GIR_Coverage, 23905,
     /* 1477982 */     GIR_EraseRootFromParent_Done,
     /* 1477983 */   // Label 20686: @1477983
     /* 1477983 */   GIM_Try, /*On fail goto*//*Label 20687*/ GIMT_Encode4(1478080), // Rule ID 23908 //
     /* 1477988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1477999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1478002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1478005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1478011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478038 */     // MIs[1] Operand 1
     /* 1478038 */     // No operand predicates
     /* 1478038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478042 */     // MIs[0] policy
     /* 1478042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478054 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478079 */     // GIR_Coverage, 23908,
     /* 1478079 */     GIR_EraseRootFromParent_Done,
     /* 1478080 */   // Label 20687: @1478080
     /* 1478080 */   GIM_Try, /*On fail goto*//*Label 20688*/ GIMT_Encode4(1478177), // Rule ID 23909 //
     /* 1478085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1478096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1478099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1478102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1478108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478135 */     // MIs[1] Operand 1
     /* 1478135 */     // No operand predicates
     /* 1478135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478139 */     // MIs[0] policy
     /* 1478139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478151 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478176 */     // GIR_Coverage, 23909,
     /* 1478176 */     GIR_EraseRootFromParent_Done,
     /* 1478177 */   // Label 20688: @1478177
     /* 1478177 */   GIM_Try, /*On fail goto*//*Label 20689*/ GIMT_Encode4(1478274), // Rule ID 23912 //
     /* 1478182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1478193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1478196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1478199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478232 */     // MIs[1] Operand 1
     /* 1478232 */     // No operand predicates
     /* 1478232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478236 */     // MIs[0] policy
     /* 1478236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478248 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478273 */     // GIR_Coverage, 23912,
     /* 1478273 */     GIR_EraseRootFromParent_Done,
     /* 1478274 */   // Label 20689: @1478274
     /* 1478274 */   GIM_Try, /*On fail goto*//*Label 20690*/ GIMT_Encode4(1478371), // Rule ID 23913 //
     /* 1478279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1478290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1478293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1478296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478329 */     // MIs[1] Operand 1
     /* 1478329 */     // No operand predicates
     /* 1478329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478333 */     // MIs[0] policy
     /* 1478333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478345 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478370 */     // GIR_Coverage, 23913,
     /* 1478370 */     GIR_EraseRootFromParent_Done,
     /* 1478371 */   // Label 20690: @1478371
     /* 1478371 */   GIM_Try, /*On fail goto*//*Label 20691*/ GIMT_Encode4(1478468), // Rule ID 23916 //
     /* 1478376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1478379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1478387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1478390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1478393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478426 */     // MIs[1] Operand 1
     /* 1478426 */     // No operand predicates
     /* 1478426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478430 */     // MIs[0] policy
     /* 1478430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478442 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478467 */     // GIR_Coverage, 23916,
     /* 1478467 */     GIR_EraseRootFromParent_Done,
     /* 1478468 */   // Label 20691: @1478468
     /* 1478468 */   GIM_Try, /*On fail goto*//*Label 20692*/ GIMT_Encode4(1478565), // Rule ID 23917 //
     /* 1478473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1478476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1478484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1478487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1478490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478523 */     // MIs[1] Operand 1
     /* 1478523 */     // No operand predicates
     /* 1478523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478527 */     // MIs[0] policy
     /* 1478527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478539 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478564 */     // GIR_Coverage, 23917,
     /* 1478564 */     GIR_EraseRootFromParent_Done,
     /* 1478565 */   // Label 20692: @1478565
     /* 1478565 */   GIM_Try, /*On fail goto*//*Label 20693*/ GIMT_Encode4(1478662), // Rule ID 23920 //
     /* 1478570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1478581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1478584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1478587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1478593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478620 */     // MIs[1] Operand 1
     /* 1478620 */     // No operand predicates
     /* 1478620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478624 */     // MIs[0] policy
     /* 1478624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478636 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1478639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478661 */     // GIR_Coverage, 23920,
     /* 1478661 */     GIR_EraseRootFromParent_Done,
     /* 1478662 */   // Label 20693: @1478662
     /* 1478662 */   GIM_Try, /*On fail goto*//*Label 20694*/ GIMT_Encode4(1478759), // Rule ID 23921 //
     /* 1478667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1478678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1478681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1478684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1478690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478717 */     // MIs[1] Operand 1
     /* 1478717 */     // No operand predicates
     /* 1478717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478721 */     // MIs[0] policy
     /* 1478721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478733 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1478736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478758 */     // GIR_Coverage, 23921,
     /* 1478758 */     GIR_EraseRootFromParent_Done,
     /* 1478759 */   // Label 20694: @1478759
     /* 1478759 */   GIM_Try, /*On fail goto*//*Label 20695*/ GIMT_Encode4(1478856), // Rule ID 23924 //
     /* 1478764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1478775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1478778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1478781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1478787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1478794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478814 */     // MIs[1] Operand 1
     /* 1478814 */     // No operand predicates
     /* 1478814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478818 */     // MIs[0] policy
     /* 1478818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478830 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1478833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478855 */     // GIR_Coverage, 23924,
     /* 1478855 */     GIR_EraseRootFromParent_Done,
     /* 1478856 */   // Label 20695: @1478856
     /* 1478856 */   GIM_Try, /*On fail goto*//*Label 20696*/ GIMT_Encode4(1478953), // Rule ID 23925 //
     /* 1478861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1478872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1478875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1478878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1478884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1478891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478911 */     // MIs[1] Operand 1
     /* 1478911 */     // No operand predicates
     /* 1478911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478915 */     // MIs[0] policy
     /* 1478915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478927 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1478930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478952 */     // GIR_Coverage, 23925,
     /* 1478952 */     GIR_EraseRootFromParent_Done,
     /* 1478953 */   // Label 20696: @1478953
     /* 1478953 */   GIM_Try, /*On fail goto*//*Label 20697*/ GIMT_Encode4(1479050), // Rule ID 23928 //
     /* 1478958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1478969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1478972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1478975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1478981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1478988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479008 */     // MIs[1] Operand 1
     /* 1479008 */     // No operand predicates
     /* 1479008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479012 */     // MIs[0] policy
     /* 1479012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479024 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479049 */     // GIR_Coverage, 23928,
     /* 1479049 */     GIR_EraseRootFromParent_Done,
     /* 1479050 */   // Label 20697: @1479050
     /* 1479050 */   GIM_Try, /*On fail goto*//*Label 20698*/ GIMT_Encode4(1479147), // Rule ID 23929 //
     /* 1479055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1479066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1479069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1479072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1479078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479105 */     // MIs[1] Operand 1
     /* 1479105 */     // No operand predicates
     /* 1479105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479109 */     // MIs[0] policy
     /* 1479109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479121 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479146 */     // GIR_Coverage, 23929,
     /* 1479146 */     GIR_EraseRootFromParent_Done,
     /* 1479147 */   // Label 20698: @1479147
     /* 1479147 */   GIM_Try, /*On fail goto*//*Label 20699*/ GIMT_Encode4(1479244), // Rule ID 23932 //
     /* 1479152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1479163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1479166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1479169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479202 */     // MIs[1] Operand 1
     /* 1479202 */     // No operand predicates
     /* 1479202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479206 */     // MIs[0] policy
     /* 1479206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479243 */     // GIR_Coverage, 23932,
     /* 1479243 */     GIR_EraseRootFromParent_Done,
     /* 1479244 */   // Label 20699: @1479244
     /* 1479244 */   GIM_Try, /*On fail goto*//*Label 20700*/ GIMT_Encode4(1479341), // Rule ID 23933 //
     /* 1479249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1479260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1479263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1479266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479299 */     // MIs[1] Operand 1
     /* 1479299 */     // No operand predicates
     /* 1479299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479303 */     // MIs[0] policy
     /* 1479303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479315 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479340 */     // GIR_Coverage, 23933,
     /* 1479340 */     GIR_EraseRootFromParent_Done,
     /* 1479341 */   // Label 20700: @1479341
     /* 1479341 */   GIM_Try, /*On fail goto*//*Label 20701*/ GIMT_Encode4(1479438), // Rule ID 23936 //
     /* 1479346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1479357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1479360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1479363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479396 */     // MIs[1] Operand 1
     /* 1479396 */     // No operand predicates
     /* 1479396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479400 */     // MIs[0] policy
     /* 1479400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479412 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479437 */     // GIR_Coverage, 23936,
     /* 1479437 */     GIR_EraseRootFromParent_Done,
     /* 1479438 */   // Label 20701: @1479438
     /* 1479438 */   GIM_Try, /*On fail goto*//*Label 20702*/ GIMT_Encode4(1479535), // Rule ID 23937 //
     /* 1479443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1479454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1479457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1479460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479493 */     // MIs[1] Operand 1
     /* 1479493 */     // No operand predicates
     /* 1479493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479497 */     // MIs[0] policy
     /* 1479497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479509 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479534 */     // GIR_Coverage, 23937,
     /* 1479534 */     GIR_EraseRootFromParent_Done,
     /* 1479535 */   // Label 20702: @1479535
     /* 1479535 */   GIM_Try, /*On fail goto*//*Label 20703*/ GIMT_Encode4(1479632), // Rule ID 23940 //
     /* 1479540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1479551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1479554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1479557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1479563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479590 */     // MIs[1] Operand 1
     /* 1479590 */     // No operand predicates
     /* 1479590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479594 */     // MIs[0] policy
     /* 1479594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479606 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479631 */     // GIR_Coverage, 23940,
     /* 1479631 */     GIR_EraseRootFromParent_Done,
     /* 1479632 */   // Label 20703: @1479632
     /* 1479632 */   GIM_Try, /*On fail goto*//*Label 20704*/ GIMT_Encode4(1479729), // Rule ID 23941 //
     /* 1479637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1479648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1479651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1479654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1479660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479687 */     // MIs[1] Operand 1
     /* 1479687 */     // No operand predicates
     /* 1479687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479691 */     // MIs[0] policy
     /* 1479691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479703 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479728 */     // GIR_Coverage, 23941,
     /* 1479728 */     GIR_EraseRootFromParent_Done,
     /* 1479729 */   // Label 20704: @1479729
     /* 1479729 */   GIM_Try, /*On fail goto*//*Label 20705*/ GIMT_Encode4(1479826), // Rule ID 23944 //
     /* 1479734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1479745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1479748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1479751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1479757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479784 */     // MIs[1] Operand 1
     /* 1479784 */     // No operand predicates
     /* 1479784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479788 */     // MIs[0] policy
     /* 1479788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479800 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479825 */     // GIR_Coverage, 23944,
     /* 1479825 */     GIR_EraseRootFromParent_Done,
     /* 1479826 */   // Label 20705: @1479826
     /* 1479826 */   GIM_Try, /*On fail goto*//*Label 20706*/ GIMT_Encode4(1479923), // Rule ID 23945 //
     /* 1479831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1479842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1479845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1479848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1479854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479881 */     // MIs[1] Operand 1
     /* 1479881 */     // No operand predicates
     /* 1479881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479885 */     // MIs[0] policy
     /* 1479885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479897 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479922 */     // GIR_Coverage, 23945,
     /* 1479922 */     GIR_EraseRootFromParent_Done,
     /* 1479923 */   // Label 20706: @1479923
     /* 1479923 */   GIM_Try, /*On fail goto*//*Label 20707*/ GIMT_Encode4(1480020), // Rule ID 23948 //
     /* 1479928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1479939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1479942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1479945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479978 */     // MIs[1] Operand 1
     /* 1479978 */     // No operand predicates
     /* 1479978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479982 */     // MIs[0] policy
     /* 1479982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480019 */     // GIR_Coverage, 23948,
     /* 1480019 */     GIR_EraseRootFromParent_Done,
     /* 1480020 */   // Label 20707: @1480020
     /* 1480020 */   GIM_Try, /*On fail goto*//*Label 20708*/ GIMT_Encode4(1480117), // Rule ID 23949 //
     /* 1480025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1480036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1480039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1480042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480075 */     // MIs[1] Operand 1
     /* 1480075 */     // No operand predicates
     /* 1480075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480079 */     // MIs[0] policy
     /* 1480079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480091 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1480094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480116 */     // GIR_Coverage, 23949,
     /* 1480116 */     GIR_EraseRootFromParent_Done,
     /* 1480117 */   // Label 20708: @1480117
     /* 1480117 */   GIM_Try, /*On fail goto*//*Label 20709*/ GIMT_Encode4(1480214), // Rule ID 23952 //
     /* 1480122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1480133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1480136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1480139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480172 */     // MIs[1] Operand 1
     /* 1480172 */     // No operand predicates
     /* 1480172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480176 */     // MIs[0] policy
     /* 1480176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480188 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480213 */     // GIR_Coverage, 23952,
     /* 1480213 */     GIR_EraseRootFromParent_Done,
     /* 1480214 */   // Label 20709: @1480214
     /* 1480214 */   GIM_Try, /*On fail goto*//*Label 20710*/ GIMT_Encode4(1480311), // Rule ID 23953 //
     /* 1480219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1480230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1480233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1480236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480269 */     // MIs[1] Operand 1
     /* 1480269 */     // No operand predicates
     /* 1480269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480273 */     // MIs[0] policy
     /* 1480273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480285 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480310 */     // GIR_Coverage, 23953,
     /* 1480310 */     GIR_EraseRootFromParent_Done,
     /* 1480311 */   // Label 20710: @1480311
     /* 1480311 */   GIM_Try, /*On fail goto*//*Label 20711*/ GIMT_Encode4(1480408), // Rule ID 23956 //
     /* 1480316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1480319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1480327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1480330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1480333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480366 */     // MIs[1] Operand 1
     /* 1480366 */     // No operand predicates
     /* 1480366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480370 */     // MIs[0] policy
     /* 1480370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1480385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480407 */     // GIR_Coverage, 23956,
     /* 1480407 */     GIR_EraseRootFromParent_Done,
     /* 1480408 */   // Label 20711: @1480408
     /* 1480408 */   GIM_Try, /*On fail goto*//*Label 20712*/ GIMT_Encode4(1480505), // Rule ID 23957 //
     /* 1480413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1480416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1480424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1480427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1480430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480463 */     // MIs[1] Operand 1
     /* 1480463 */     // No operand predicates
     /* 1480463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480467 */     // MIs[0] policy
     /* 1480467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480479 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1480482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480504 */     // GIR_Coverage, 23957,
     /* 1480504 */     GIR_EraseRootFromParent_Done,
     /* 1480505 */   // Label 20712: @1480505
     /* 1480505 */   GIM_Try, /*On fail goto*//*Label 20713*/ GIMT_Encode4(1480602), // Rule ID 23960 //
     /* 1480510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1480513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1480521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1480524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1480527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480560 */     // MIs[1] Operand 1
     /* 1480560 */     // No operand predicates
     /* 1480560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480564 */     // MIs[0] policy
     /* 1480564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480576 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1480579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480601 */     // GIR_Coverage, 23960,
     /* 1480601 */     GIR_EraseRootFromParent_Done,
     /* 1480602 */   // Label 20713: @1480602
     /* 1480602 */   GIM_Try, /*On fail goto*//*Label 20714*/ GIMT_Encode4(1480699), // Rule ID 23961 //
     /* 1480607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1480610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1480618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1480621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1480624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480657 */     // MIs[1] Operand 1
     /* 1480657 */     // No operand predicates
     /* 1480657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480661 */     // MIs[0] policy
     /* 1480661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480673 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1480676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480698 */     // GIR_Coverage, 23961,
     /* 1480698 */     GIR_EraseRootFromParent_Done,
     /* 1480699 */   // Label 20714: @1480699
     /* 1480699 */   GIM_Try, /*On fail goto*//*Label 20715*/ GIMT_Encode4(1480796), // Rule ID 23964 //
     /* 1480704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1480707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1480715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1480718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1480721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480754 */     // MIs[1] Operand 1
     /* 1480754 */     // No operand predicates
     /* 1480754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480758 */     // MIs[0] policy
     /* 1480758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480770 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480795 */     // GIR_Coverage, 23964,
     /* 1480795 */     GIR_EraseRootFromParent_Done,
     /* 1480796 */   // Label 20715: @1480796
     /* 1480796 */   GIM_Try, /*On fail goto*//*Label 20716*/ GIMT_Encode4(1480893), // Rule ID 23965 //
     /* 1480801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1480804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1480812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1480815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1480818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480851 */     // MIs[1] Operand 1
     /* 1480851 */     // No operand predicates
     /* 1480851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480855 */     // MIs[0] policy
     /* 1480855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480867 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480892 */     // GIR_Coverage, 23965,
     /* 1480892 */     GIR_EraseRootFromParent_Done,
     /* 1480893 */   // Label 20716: @1480893
     /* 1480893 */   GIM_Try, /*On fail goto*//*Label 20717*/ GIMT_Encode4(1480990), // Rule ID 24204 //
     /* 1480898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1480909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1480912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1480915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1480921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480948 */     // MIs[1] Operand 1
     /* 1480948 */     // No operand predicates
     /* 1480948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480952 */     // MIs[0] policy
     /* 1480952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480964 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1480967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480989 */     // GIR_Coverage, 24204,
     /* 1480989 */     GIR_EraseRootFromParent_Done,
     /* 1480990 */   // Label 20717: @1480990
     /* 1480990 */   GIM_Try, /*On fail goto*//*Label 20718*/ GIMT_Encode4(1481087), // Rule ID 24205 //
     /* 1480995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1481006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1481009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1481012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481045 */     // MIs[1] Operand 1
     /* 1481045 */     // No operand predicates
     /* 1481045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481049 */     // MIs[0] policy
     /* 1481049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481061 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1481064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481086 */     // GIR_Coverage, 24205,
     /* 1481086 */     GIR_EraseRootFromParent_Done,
     /* 1481087 */   // Label 20718: @1481087
     /* 1481087 */   GIM_Try, /*On fail goto*//*Label 20719*/ GIMT_Encode4(1481184), // Rule ID 24208 //
     /* 1481092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1481109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481142 */     // MIs[1] Operand 1
     /* 1481142 */     // No operand predicates
     /* 1481142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481146 */     // MIs[0] policy
     /* 1481146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481158 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481183 */     // GIR_Coverage, 24208,
     /* 1481183 */     GIR_EraseRootFromParent_Done,
     /* 1481184 */   // Label 20719: @1481184
     /* 1481184 */   GIM_Try, /*On fail goto*//*Label 20720*/ GIMT_Encode4(1481281), // Rule ID 24209 //
     /* 1481189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1481206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481239 */     // MIs[1] Operand 1
     /* 1481239 */     // No operand predicates
     /* 1481239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481243 */     // MIs[0] policy
     /* 1481243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481255 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481280 */     // GIR_Coverage, 24209,
     /* 1481280 */     GIR_EraseRootFromParent_Done,
     /* 1481281 */   // Label 20720: @1481281
     /* 1481281 */   GIM_Try, /*On fail goto*//*Label 20721*/ GIMT_Encode4(1481378), // Rule ID 24212 //
     /* 1481286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1481297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1481300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1481303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481336 */     // MIs[1] Operand 1
     /* 1481336 */     // No operand predicates
     /* 1481336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481340 */     // MIs[0] policy
     /* 1481340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481352 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481377 */     // GIR_Coverage, 24212,
     /* 1481377 */     GIR_EraseRootFromParent_Done,
     /* 1481378 */   // Label 20721: @1481378
     /* 1481378 */   GIM_Try, /*On fail goto*//*Label 20722*/ GIMT_Encode4(1481475), // Rule ID 24213 //
     /* 1481383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1481394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1481397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1481400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481433 */     // MIs[1] Operand 1
     /* 1481433 */     // No operand predicates
     /* 1481433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481437 */     // MIs[0] policy
     /* 1481437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481449 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481474 */     // GIR_Coverage, 24213,
     /* 1481474 */     GIR_EraseRootFromParent_Done,
     /* 1481475 */   // Label 20722: @1481475
     /* 1481475 */   GIM_Try, /*On fail goto*//*Label 20723*/ GIMT_Encode4(1481572), // Rule ID 24216 //
     /* 1481480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1481491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1481494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1481497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481530 */     // MIs[1] Operand 1
     /* 1481530 */     // No operand predicates
     /* 1481530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481534 */     // MIs[0] policy
     /* 1481534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481546 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1481549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481571 */     // GIR_Coverage, 24216,
     /* 1481571 */     GIR_EraseRootFromParent_Done,
     /* 1481572 */   // Label 20723: @1481572
     /* 1481572 */   GIM_Try, /*On fail goto*//*Label 20724*/ GIMT_Encode4(1481669), // Rule ID 24217 //
     /* 1481577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1481588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1481591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1481594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481627 */     // MIs[1] Operand 1
     /* 1481627 */     // No operand predicates
     /* 1481627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481631 */     // MIs[0] policy
     /* 1481631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481643 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1481646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481668 */     // GIR_Coverage, 24217,
     /* 1481668 */     GIR_EraseRootFromParent_Done,
     /* 1481669 */   // Label 20724: @1481669
     /* 1481669 */   GIM_Try, /*On fail goto*//*Label 20725*/ GIMT_Encode4(1481766), // Rule ID 24220 //
     /* 1481674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1481685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1481688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1481691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481724 */     // MIs[1] Operand 1
     /* 1481724 */     // No operand predicates
     /* 1481724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481728 */     // MIs[0] policy
     /* 1481728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481740 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1481743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481765 */     // GIR_Coverage, 24220,
     /* 1481765 */     GIR_EraseRootFromParent_Done,
     /* 1481766 */   // Label 20725: @1481766
     /* 1481766 */   GIM_Try, /*On fail goto*//*Label 20726*/ GIMT_Encode4(1481863), // Rule ID 24221 //
     /* 1481771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1481782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1481785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1481788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481821 */     // MIs[1] Operand 1
     /* 1481821 */     // No operand predicates
     /* 1481821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481825 */     // MIs[0] policy
     /* 1481825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481837 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1481840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481862 */     // GIR_Coverage, 24221,
     /* 1481862 */     GIR_EraseRootFromParent_Done,
     /* 1481863 */   // Label 20726: @1481863
     /* 1481863 */   GIM_Try, /*On fail goto*//*Label 20727*/ GIMT_Encode4(1481960), // Rule ID 24224 //
     /* 1481868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1481871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1481879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1481882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1481885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481918 */     // MIs[1] Operand 1
     /* 1481918 */     // No operand predicates
     /* 1481918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481922 */     // MIs[0] policy
     /* 1481922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481934 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1481937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481959 */     // GIR_Coverage, 24224,
     /* 1481959 */     GIR_EraseRootFromParent_Done,
     /* 1481960 */   // Label 20727: @1481960
     /* 1481960 */   GIM_Try, /*On fail goto*//*Label 20728*/ GIMT_Encode4(1482057), // Rule ID 24225 //
     /* 1481965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1481968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1481976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1481979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1481982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482015 */     // MIs[1] Operand 1
     /* 1482015 */     // No operand predicates
     /* 1482015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482019 */     // MIs[0] policy
     /* 1482019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482031 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1482053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482056 */     // GIR_Coverage, 24225,
     /* 1482056 */     GIR_EraseRootFromParent_Done,
     /* 1482057 */   // Label 20728: @1482057
     /* 1482057 */   GIM_Try, /*On fail goto*//*Label 20729*/ GIMT_Encode4(1482154), // Rule ID 24228 //
     /* 1482062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1482073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1482076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1482079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482112 */     // MIs[1] Operand 1
     /* 1482112 */     // No operand predicates
     /* 1482112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482116 */     // MIs[0] policy
     /* 1482116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482128 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1482131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482153 */     // GIR_Coverage, 24228,
     /* 1482153 */     GIR_EraseRootFromParent_Done,
     /* 1482154 */   // Label 20729: @1482154
     /* 1482154 */   GIM_Try, /*On fail goto*//*Label 20730*/ GIMT_Encode4(1482251), // Rule ID 24229 //
     /* 1482159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1482170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1482173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1482176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482209 */     // MIs[1] Operand 1
     /* 1482209 */     // No operand predicates
     /* 1482209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482213 */     // MIs[0] policy
     /* 1482213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482225 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1482228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482250 */     // GIR_Coverage, 24229,
     /* 1482250 */     GIR_EraseRootFromParent_Done,
     /* 1482251 */   // Label 20730: @1482251
     /* 1482251 */   GIM_Try, /*On fail goto*//*Label 20731*/ GIMT_Encode4(1482348), // Rule ID 24232 //
     /* 1482256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1482267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1482270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1482273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482306 */     // MIs[1] Operand 1
     /* 1482306 */     // No operand predicates
     /* 1482306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482310 */     // MIs[0] policy
     /* 1482310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482322 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1482325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482347 */     // GIR_Coverage, 24232,
     /* 1482347 */     GIR_EraseRootFromParent_Done,
     /* 1482348 */   // Label 20731: @1482348
     /* 1482348 */   GIM_Try, /*On fail goto*//*Label 20732*/ GIMT_Encode4(1482445), // Rule ID 24233 //
     /* 1482353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1482364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1482367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1482370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482403 */     // MIs[1] Operand 1
     /* 1482403 */     // No operand predicates
     /* 1482403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482407 */     // MIs[0] policy
     /* 1482407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482419 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1482422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482444 */     // GIR_Coverage, 24233,
     /* 1482444 */     GIR_EraseRootFromParent_Done,
     /* 1482445 */   // Label 20732: @1482445
     /* 1482445 */   GIM_Try, /*On fail goto*//*Label 20733*/ GIMT_Encode4(1482542), // Rule ID 24236 //
     /* 1482450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1482461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1482464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1482467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1482473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1482480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482500 */     // MIs[1] Operand 1
     /* 1482500 */     // No operand predicates
     /* 1482500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482504 */     // MIs[0] policy
     /* 1482504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482516 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1482519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482541 */     // GIR_Coverage, 24236,
     /* 1482541 */     GIR_EraseRootFromParent_Done,
     /* 1482542 */   // Label 20733: @1482542
     /* 1482542 */   GIM_Try, /*On fail goto*//*Label 20734*/ GIMT_Encode4(1482639), // Rule ID 24237 //
     /* 1482547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1482558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1482561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1482564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1482570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1482577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482597 */     // MIs[1] Operand 1
     /* 1482597 */     // No operand predicates
     /* 1482597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482601 */     // MIs[0] policy
     /* 1482601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482613 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1482616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482638 */     // GIR_Coverage, 24237,
     /* 1482638 */     GIR_EraseRootFromParent_Done,
     /* 1482639 */   // Label 20734: @1482639
     /* 1482639 */   GIM_Try, /*On fail goto*//*Label 20735*/ GIMT_Encode4(1482736), // Rule ID 24240 //
     /* 1482644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1482655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1482658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1482661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1482667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482694 */     // MIs[1] Operand 1
     /* 1482694 */     // No operand predicates
     /* 1482694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482698 */     // MIs[0] policy
     /* 1482698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482710 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1482713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482735 */     // GIR_Coverage, 24240,
     /* 1482735 */     GIR_EraseRootFromParent_Done,
     /* 1482736 */   // Label 20735: @1482736
     /* 1482736 */   GIM_Try, /*On fail goto*//*Label 20736*/ GIMT_Encode4(1482833), // Rule ID 24241 //
     /* 1482741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1482752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1482755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1482758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1482764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482791 */     // MIs[1] Operand 1
     /* 1482791 */     // No operand predicates
     /* 1482791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482795 */     // MIs[0] policy
     /* 1482795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482807 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1482810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482832 */     // GIR_Coverage, 24241,
     /* 1482832 */     GIR_EraseRootFromParent_Done,
     /* 1482833 */   // Label 20736: @1482833
     /* 1482833 */   GIM_Try, /*On fail goto*//*Label 20737*/ GIMT_Encode4(1482930), // Rule ID 24244 //
     /* 1482838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1482849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1482852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1482855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482888 */     // MIs[1] Operand 1
     /* 1482888 */     // No operand predicates
     /* 1482888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482892 */     // MIs[0] policy
     /* 1482892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482904 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1482907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482929 */     // GIR_Coverage, 24244,
     /* 1482929 */     GIR_EraseRootFromParent_Done,
     /* 1482930 */   // Label 20737: @1482930
     /* 1482930 */   GIM_Try, /*On fail goto*//*Label 20738*/ GIMT_Encode4(1483027), // Rule ID 24245 //
     /* 1482935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1482946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1482949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1482952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482985 */     // MIs[1] Operand 1
     /* 1482985 */     // No operand predicates
     /* 1482985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482989 */     // MIs[0] policy
     /* 1482989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483001 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1483004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483026 */     // GIR_Coverage, 24245,
     /* 1483026 */     GIR_EraseRootFromParent_Done,
     /* 1483027 */   // Label 20738: @1483027
     /* 1483027 */   GIM_Try, /*On fail goto*//*Label 20739*/ GIMT_Encode4(1483124), // Rule ID 24248 //
     /* 1483032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1483049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483082 */     // MIs[1] Operand 1
     /* 1483082 */     // No operand predicates
     /* 1483082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483086 */     // MIs[0] policy
     /* 1483086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483098 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483123 */     // GIR_Coverage, 24248,
     /* 1483123 */     GIR_EraseRootFromParent_Done,
     /* 1483124 */   // Label 20739: @1483124
     /* 1483124 */   GIM_Try, /*On fail goto*//*Label 20740*/ GIMT_Encode4(1483221), // Rule ID 24249 //
     /* 1483129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1483146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483179 */     // MIs[1] Operand 1
     /* 1483179 */     // No operand predicates
     /* 1483179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483183 */     // MIs[0] policy
     /* 1483183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483195 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483220 */     // GIR_Coverage, 24249,
     /* 1483220 */     GIR_EraseRootFromParent_Done,
     /* 1483221 */   // Label 20740: @1483221
     /* 1483221 */   GIM_Try, /*On fail goto*//*Label 20741*/ GIMT_Encode4(1483318), // Rule ID 24252 //
     /* 1483226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1483229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1483240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1483243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483276 */     // MIs[1] Operand 1
     /* 1483276 */     // No operand predicates
     /* 1483276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483280 */     // MIs[0] policy
     /* 1483280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483292 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1483295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483317 */     // GIR_Coverage, 24252,
     /* 1483317 */     GIR_EraseRootFromParent_Done,
     /* 1483318 */   // Label 20741: @1483318
     /* 1483318 */   GIM_Try, /*On fail goto*//*Label 20742*/ GIMT_Encode4(1483415), // Rule ID 24253 //
     /* 1483323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1483326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1483337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1483340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483373 */     // MIs[1] Operand 1
     /* 1483373 */     // No operand predicates
     /* 1483373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483377 */     // MIs[0] policy
     /* 1483377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483389 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1483392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483414 */     // GIR_Coverage, 24253,
     /* 1483414 */     GIR_EraseRootFromParent_Done,
     /* 1483415 */   // Label 20742: @1483415
     /* 1483415 */   GIM_Try, /*On fail goto*//*Label 20743*/ GIMT_Encode4(1483512), // Rule ID 24256 //
     /* 1483420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1483423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1483431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1483434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1483437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483470 */     // MIs[1] Operand 1
     /* 1483470 */     // No operand predicates
     /* 1483470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483474 */     // MIs[0] policy
     /* 1483474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483486 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1483489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483511 */     // GIR_Coverage, 24256,
     /* 1483511 */     GIR_EraseRootFromParent_Done,
     /* 1483512 */   // Label 20743: @1483512
     /* 1483512 */   GIM_Try, /*On fail goto*//*Label 20744*/ GIMT_Encode4(1483609), // Rule ID 24257 //
     /* 1483517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1483520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1483528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1483531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1483534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483567 */     // MIs[1] Operand 1
     /* 1483567 */     // No operand predicates
     /* 1483567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483571 */     // MIs[0] policy
     /* 1483571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483583 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1483586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483608 */     // GIR_Coverage, 24257,
     /* 1483608 */     GIR_EraseRootFromParent_Done,
     /* 1483609 */   // Label 20744: @1483609
     /* 1483609 */   GIM_Try, /*On fail goto*//*Label 20745*/ GIMT_Encode4(1483706), // Rule ID 24260 //
     /* 1483614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1483617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1483625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1483628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1483631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483664 */     // MIs[1] Operand 1
     /* 1483664 */     // No operand predicates
     /* 1483664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483668 */     // MIs[0] policy
     /* 1483668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483680 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483705 */     // GIR_Coverage, 24260,
     /* 1483705 */     GIR_EraseRootFromParent_Done,
     /* 1483706 */   // Label 20745: @1483706
     /* 1483706 */   GIM_Try, /*On fail goto*//*Label 20746*/ GIMT_Encode4(1483803), // Rule ID 24261 //
     /* 1483711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1483714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1483722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1483725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1483728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483761 */     // MIs[1] Operand 1
     /* 1483761 */     // No operand predicates
     /* 1483761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483765 */     // MIs[0] policy
     /* 1483765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483777 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483802 */     // GIR_Coverage, 24261,
     /* 1483802 */     GIR_EraseRootFromParent_Done,
     /* 1483803 */   // Label 20746: @1483803
     /* 1483803 */   GIM_Try, /*On fail goto*//*Label 20747*/ GIMT_Encode4(1483900), // Rule ID 24324 //
     /* 1483808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1483819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1483822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1483825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1483831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1483838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483858 */     // MIs[1] Operand 1
     /* 1483858 */     // No operand predicates
     /* 1483858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483862 */     // MIs[0] policy
     /* 1483862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483874 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1483877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483899 */     // GIR_Coverage, 24324,
     /* 1483899 */     GIR_EraseRootFromParent_Done,
     /* 1483900 */   // Label 20747: @1483900
     /* 1483900 */   GIM_Try, /*On fail goto*//*Label 20748*/ GIMT_Encode4(1483997), // Rule ID 24325 //
     /* 1483905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1483916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1483919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1483922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1483928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1483935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483955 */     // MIs[1] Operand 1
     /* 1483955 */     // No operand predicates
     /* 1483955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483959 */     // MIs[0] policy
     /* 1483959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483971 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1483974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483996 */     // GIR_Coverage, 24325,
     /* 1483996 */     GIR_EraseRootFromParent_Done,
     /* 1483997 */   // Label 20748: @1483997
     /* 1483997 */   GIM_Try, /*On fail goto*//*Label 20749*/ GIMT_Encode4(1484094), // Rule ID 24328 //
     /* 1484002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1484013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1484016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1484019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484052 */     // MIs[1] Operand 1
     /* 1484052 */     // No operand predicates
     /* 1484052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484056 */     // MIs[0] policy
     /* 1484056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484068 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484093 */     // GIR_Coverage, 24328,
     /* 1484093 */     GIR_EraseRootFromParent_Done,
     /* 1484094 */   // Label 20749: @1484094
     /* 1484094 */   GIM_Try, /*On fail goto*//*Label 20750*/ GIMT_Encode4(1484191), // Rule ID 24329 //
     /* 1484099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1484110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1484113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1484116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484149 */     // MIs[1] Operand 1
     /* 1484149 */     // No operand predicates
     /* 1484149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484153 */     // MIs[0] policy
     /* 1484153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484165 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484190 */     // GIR_Coverage, 24329,
     /* 1484190 */     GIR_EraseRootFromParent_Done,
     /* 1484191 */   // Label 20750: @1484191
     /* 1484191 */   GIM_Try, /*On fail goto*//*Label 20751*/ GIMT_Encode4(1484288), // Rule ID 24332 //
     /* 1484196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1484207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1484210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1484213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484246 */     // MIs[1] Operand 1
     /* 1484246 */     // No operand predicates
     /* 1484246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484250 */     // MIs[0] policy
     /* 1484250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484262 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484287 */     // GIR_Coverage, 24332,
     /* 1484287 */     GIR_EraseRootFromParent_Done,
     /* 1484288 */   // Label 20751: @1484288
     /* 1484288 */   GIM_Try, /*On fail goto*//*Label 20752*/ GIMT_Encode4(1484385), // Rule ID 24333 //
     /* 1484293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1484304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1484307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1484310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484343 */     // MIs[1] Operand 1
     /* 1484343 */     // No operand predicates
     /* 1484343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484347 */     // MIs[0] policy
     /* 1484347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484359 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484384 */     // GIR_Coverage, 24333,
     /* 1484384 */     GIR_EraseRootFromParent_Done,
     /* 1484385 */   // Label 20752: @1484385
     /* 1484385 */   GIM_Try, /*On fail goto*//*Label 20753*/ GIMT_Encode4(1484482), // Rule ID 24336 //
     /* 1484390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1484401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1484404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1484407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484440 */     // MIs[1] Operand 1
     /* 1484440 */     // No operand predicates
     /* 1484440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484444 */     // MIs[0] policy
     /* 1484444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484456 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484481 */     // GIR_Coverage, 24336,
     /* 1484481 */     GIR_EraseRootFromParent_Done,
     /* 1484482 */   // Label 20753: @1484482
     /* 1484482 */   GIM_Try, /*On fail goto*//*Label 20754*/ GIMT_Encode4(1484579), // Rule ID 24337 //
     /* 1484487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1484498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1484501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1484504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484537 */     // MIs[1] Operand 1
     /* 1484537 */     // No operand predicates
     /* 1484537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484541 */     // MIs[0] policy
     /* 1484541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484553 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484578 */     // GIR_Coverage, 24337,
     /* 1484578 */     GIR_EraseRootFromParent_Done,
     /* 1484579 */   // Label 20754: @1484579
     /* 1484579 */   GIM_Try, /*On fail goto*//*Label 20755*/ GIMT_Encode4(1484676), // Rule ID 24340 //
     /* 1484584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1484595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1484598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1484601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484634 */     // MIs[1] Operand 1
     /* 1484634 */     // No operand predicates
     /* 1484634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484638 */     // MIs[0] policy
     /* 1484638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484650 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484675 */     // GIR_Coverage, 24340,
     /* 1484675 */     GIR_EraseRootFromParent_Done,
     /* 1484676 */   // Label 20755: @1484676
     /* 1484676 */   GIM_Try, /*On fail goto*//*Label 20756*/ GIMT_Encode4(1484773), // Rule ID 24341 //
     /* 1484681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1484692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1484695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1484698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484731 */     // MIs[1] Operand 1
     /* 1484731 */     // No operand predicates
     /* 1484731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484735 */     // MIs[0] policy
     /* 1484735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484747 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484772 */     // GIR_Coverage, 24341,
     /* 1484772 */     GIR_EraseRootFromParent_Done,
     /* 1484773 */   // Label 20756: @1484773
     /* 1484773 */   GIM_Try, /*On fail goto*//*Label 20757*/ GIMT_Encode4(1484870), // Rule ID 24344 //
     /* 1484778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1484781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1484789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1484792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1484795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484828 */     // MIs[1] Operand 1
     /* 1484828 */     // No operand predicates
     /* 1484828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484832 */     // MIs[0] policy
     /* 1484832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484844 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484869 */     // GIR_Coverage, 24344,
     /* 1484869 */     GIR_EraseRootFromParent_Done,
     /* 1484870 */   // Label 20757: @1484870
     /* 1484870 */   GIM_Try, /*On fail goto*//*Label 20758*/ GIMT_Encode4(1484967), // Rule ID 24345 //
     /* 1484875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1484878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1484886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1484889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1484892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484925 */     // MIs[1] Operand 1
     /* 1484925 */     // No operand predicates
     /* 1484925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484929 */     // MIs[0] policy
     /* 1484929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484941 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484966 */     // GIR_Coverage, 24345,
     /* 1484966 */     GIR_EraseRootFromParent_Done,
     /* 1484967 */   // Label 20758: @1484967
     /* 1484967 */   GIM_Try, /*On fail goto*//*Label 20759*/ GIMT_Encode4(1485064), // Rule ID 24348 //
     /* 1484972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1484983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1484986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1484989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485022 */     // MIs[1] Operand 1
     /* 1485022 */     // No operand predicates
     /* 1485022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485026 */     // MIs[0] policy
     /* 1485026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485038 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1485041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485063 */     // GIR_Coverage, 24348,
     /* 1485063 */     GIR_EraseRootFromParent_Done,
     /* 1485064 */   // Label 20759: @1485064
     /* 1485064 */   GIM_Try, /*On fail goto*//*Label 20760*/ GIMT_Encode4(1485161), // Rule ID 24349 //
     /* 1485069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1485080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1485083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1485086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485119 */     // MIs[1] Operand 1
     /* 1485119 */     // No operand predicates
     /* 1485119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485123 */     // MIs[0] policy
     /* 1485123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485135 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1485138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485160 */     // GIR_Coverage, 24349,
     /* 1485160 */     GIR_EraseRootFromParent_Done,
     /* 1485161 */   // Label 20760: @1485161
     /* 1485161 */   GIM_Try, /*On fail goto*//*Label 20761*/ GIMT_Encode4(1485258), // Rule ID 24352 //
     /* 1485166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1485177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1485180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1485183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485216 */     // MIs[1] Operand 1
     /* 1485216 */     // No operand predicates
     /* 1485216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485220 */     // MIs[0] policy
     /* 1485220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485232 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1485235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485257 */     // GIR_Coverage, 24352,
     /* 1485257 */     GIR_EraseRootFromParent_Done,
     /* 1485258 */   // Label 20761: @1485258
     /* 1485258 */   GIM_Try, /*On fail goto*//*Label 20762*/ GIMT_Encode4(1485355), // Rule ID 24353 //
     /* 1485263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1485274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1485277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1485280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485313 */     // MIs[1] Operand 1
     /* 1485313 */     // No operand predicates
     /* 1485313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485317 */     // MIs[0] policy
     /* 1485317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485329 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1485332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485354 */     // GIR_Coverage, 24353,
     /* 1485354 */     GIR_EraseRootFromParent_Done,
     /* 1485355 */   // Label 20762: @1485355
     /* 1485355 */   GIM_Try, /*On fail goto*//*Label 20763*/ GIMT_Encode4(1485452), // Rule ID 24356 //
     /* 1485360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1485371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1485374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1485377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1485383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485410 */     // MIs[1] Operand 1
     /* 1485410 */     // No operand predicates
     /* 1485410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485414 */     // MIs[0] policy
     /* 1485414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485426 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1485429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485451 */     // GIR_Coverage, 24356,
     /* 1485451 */     GIR_EraseRootFromParent_Done,
     /* 1485452 */   // Label 20763: @1485452
     /* 1485452 */   GIM_Try, /*On fail goto*//*Label 20764*/ GIMT_Encode4(1485549), // Rule ID 24357 //
     /* 1485457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1485468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1485471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1485474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1485480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485507 */     // MIs[1] Operand 1
     /* 1485507 */     // No operand predicates
     /* 1485507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485511 */     // MIs[0] policy
     /* 1485511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485523 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1485526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485548 */     // GIR_Coverage, 24357,
     /* 1485548 */     GIR_EraseRootFromParent_Done,
     /* 1485549 */   // Label 20764: @1485549
     /* 1485549 */   GIM_Try, /*On fail goto*//*Label 20765*/ GIMT_Encode4(1485646), // Rule ID 24360 //
     /* 1485554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1485565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1485568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1485571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485604 */     // MIs[1] Operand 1
     /* 1485604 */     // No operand predicates
     /* 1485604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485608 */     // MIs[0] policy
     /* 1485608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485620 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1485623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485645 */     // GIR_Coverage, 24360,
     /* 1485645 */     GIR_EraseRootFromParent_Done,
     /* 1485646 */   // Label 20765: @1485646
     /* 1485646 */   GIM_Try, /*On fail goto*//*Label 20766*/ GIMT_Encode4(1485743), // Rule ID 24361 //
     /* 1485651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1485662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1485665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1485668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485701 */     // MIs[1] Operand 1
     /* 1485701 */     // No operand predicates
     /* 1485701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485705 */     // MIs[0] policy
     /* 1485705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485717 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1485720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485742 */     // GIR_Coverage, 24361,
     /* 1485742 */     GIR_EraseRootFromParent_Done,
     /* 1485743 */   // Label 20766: @1485743
     /* 1485743 */   GIM_Try, /*On fail goto*//*Label 20767*/ GIMT_Encode4(1485840), // Rule ID 24364 //
     /* 1485748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1485759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1485762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1485765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485798 */     // MIs[1] Operand 1
     /* 1485798 */     // No operand predicates
     /* 1485798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485802 */     // MIs[0] policy
     /* 1485802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485814 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1485817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485839 */     // GIR_Coverage, 24364,
     /* 1485839 */     GIR_EraseRootFromParent_Done,
     /* 1485840 */   // Label 20767: @1485840
     /* 1485840 */   GIM_Try, /*On fail goto*//*Label 20768*/ GIMT_Encode4(1485937), // Rule ID 24365 //
     /* 1485845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1485856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1485859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1485862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485895 */     // MIs[1] Operand 1
     /* 1485895 */     // No operand predicates
     /* 1485895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485899 */     // MIs[0] policy
     /* 1485899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485911 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1485914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485936 */     // GIR_Coverage, 24365,
     /* 1485936 */     GIR_EraseRootFromParent_Done,
     /* 1485937 */   // Label 20768: @1485937
     /* 1485937 */   GIM_Try, /*On fail goto*//*Label 20769*/ GIMT_Encode4(1486034), // Rule ID 24368 //
     /* 1485942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1485953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1485956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1485959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485992 */     // MIs[1] Operand 1
     /* 1485992 */     // No operand predicates
     /* 1485992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485996 */     // MIs[0] policy
     /* 1485996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486008 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1486011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486033 */     // GIR_Coverage, 24368,
     /* 1486033 */     GIR_EraseRootFromParent_Done,
     /* 1486034 */   // Label 20769: @1486034
     /* 1486034 */   GIM_Try, /*On fail goto*//*Label 20770*/ GIMT_Encode4(1486131), // Rule ID 24369 //
     /* 1486039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1486050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1486053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1486056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486089 */     // MIs[1] Operand 1
     /* 1486089 */     // No operand predicates
     /* 1486089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486093 */     // MIs[0] policy
     /* 1486093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486105 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1486108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486130 */     // GIR_Coverage, 24369,
     /* 1486130 */     GIR_EraseRootFromParent_Done,
     /* 1486131 */   // Label 20770: @1486131
     /* 1486131 */   GIM_Try, /*On fail goto*//*Label 20771*/ GIMT_Encode4(1486228), // Rule ID 24372 //
     /* 1486136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1486139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1486147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1486150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1486153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486186 */     // MIs[1] Operand 1
     /* 1486186 */     // No operand predicates
     /* 1486186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486190 */     // MIs[0] policy
     /* 1486190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486202 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1486205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486227 */     // GIR_Coverage, 24372,
     /* 1486227 */     GIR_EraseRootFromParent_Done,
     /* 1486228 */   // Label 20771: @1486228
     /* 1486228 */   GIM_Try, /*On fail goto*//*Label 20772*/ GIMT_Encode4(1486325), // Rule ID 24373 //
     /* 1486233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1486236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1486244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1486247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1486250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486283 */     // MIs[1] Operand 1
     /* 1486283 */     // No operand predicates
     /* 1486283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486287 */     // MIs[0] policy
     /* 1486287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486299 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1486302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486324 */     // GIR_Coverage, 24373,
     /* 1486324 */     GIR_EraseRootFromParent_Done,
     /* 1486325 */   // Label 20772: @1486325
     /* 1486325 */   GIM_Try, /*On fail goto*//*Label 20773*/ GIMT_Encode4(1486422), // Rule ID 24376 //
     /* 1486330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1486333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1486341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1486344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1486347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486380 */     // MIs[1] Operand 1
     /* 1486380 */     // No operand predicates
     /* 1486380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486384 */     // MIs[0] policy
     /* 1486384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486396 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1486399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486421 */     // GIR_Coverage, 24376,
     /* 1486421 */     GIR_EraseRootFromParent_Done,
     /* 1486422 */   // Label 20773: @1486422
     /* 1486422 */   GIM_Try, /*On fail goto*//*Label 20774*/ GIMT_Encode4(1486519), // Rule ID 24377 //
     /* 1486427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1486430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1486438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1486441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1486444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486477 */     // MIs[1] Operand 1
     /* 1486477 */     // No operand predicates
     /* 1486477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486481 */     // MIs[0] policy
     /* 1486481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486493 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1486496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486518 */     // GIR_Coverage, 24377,
     /* 1486518 */     GIR_EraseRootFromParent_Done,
     /* 1486519 */   // Label 20774: @1486519
     /* 1486519 */   GIM_Try, /*On fail goto*//*Label 20775*/ GIMT_Encode4(1486616), // Rule ID 24380 //
     /* 1486524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1486527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1486535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1486538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1486541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486574 */     // MIs[1] Operand 1
     /* 1486574 */     // No operand predicates
     /* 1486574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486578 */     // MIs[0] policy
     /* 1486578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486590 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1486593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486615 */     // GIR_Coverage, 24380,
     /* 1486615 */     GIR_EraseRootFromParent_Done,
     /* 1486616 */   // Label 20775: @1486616
     /* 1486616 */   GIM_Try, /*On fail goto*//*Label 20776*/ GIMT_Encode4(1486713), // Rule ID 24381 //
     /* 1486621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1486624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1486632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1486635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1486638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486671 */     // MIs[1] Operand 1
     /* 1486671 */     // No operand predicates
     /* 1486671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486675 */     // MIs[0] policy
     /* 1486675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486687 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1486690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486712 */     // GIR_Coverage, 24381,
     /* 1486712 */     GIR_EraseRootFromParent_Done,
     /* 1486713 */   // Label 20776: @1486713
     /* 1486713 */   GIM_Try, /*On fail goto*//*Label 20777*/ GIMT_Encode4(1486810), // Rule ID 24680 //
     /* 1486718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1486729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1486732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1486735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1486741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486768 */     // MIs[1] Operand 1
     /* 1486768 */     // No operand predicates
     /* 1486768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486772 */     // MIs[0] policy
     /* 1486772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486784 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1486787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486809 */     // GIR_Coverage, 24680,
     /* 1486809 */     GIR_EraseRootFromParent_Done,
     /* 1486810 */   // Label 20777: @1486810
     /* 1486810 */   GIM_Try, /*On fail goto*//*Label 20778*/ GIMT_Encode4(1486907), // Rule ID 24681 //
     /* 1486815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1486826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1486829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1486832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1486838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486865 */     // MIs[1] Operand 1
     /* 1486865 */     // No operand predicates
     /* 1486865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486869 */     // MIs[0] policy
     /* 1486869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486881 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1486884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486906 */     // GIR_Coverage, 24681,
     /* 1486906 */     GIR_EraseRootFromParent_Done,
     /* 1486907 */   // Label 20778: @1486907
     /* 1486907 */   GIM_Try, /*On fail goto*//*Label 20779*/ GIMT_Encode4(1487004), // Rule ID 24684 //
     /* 1486912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1486923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1486926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1486929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486962 */     // MIs[1] Operand 1
     /* 1486962 */     // No operand predicates
     /* 1486962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486966 */     // MIs[0] policy
     /* 1486966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486978 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1486981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487003 */     // GIR_Coverage, 24684,
     /* 1487003 */     GIR_EraseRootFromParent_Done,
     /* 1487004 */   // Label 20779: @1487004
     /* 1487004 */   GIM_Try, /*On fail goto*//*Label 20780*/ GIMT_Encode4(1487101), // Rule ID 24685 //
     /* 1487009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1487020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1487023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1487026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487059 */     // MIs[1] Operand 1
     /* 1487059 */     // No operand predicates
     /* 1487059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487063 */     // MIs[0] policy
     /* 1487063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487075 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487100 */     // GIR_Coverage, 24685,
     /* 1487100 */     GIR_EraseRootFromParent_Done,
     /* 1487101 */   // Label 20780: @1487101
     /* 1487101 */   GIM_Try, /*On fail goto*//*Label 20781*/ GIMT_Encode4(1487198), // Rule ID 24688 //
     /* 1487106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1487117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1487120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1487123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487156 */     // MIs[1] Operand 1
     /* 1487156 */     // No operand predicates
     /* 1487156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487160 */     // MIs[0] policy
     /* 1487160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487172 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487197 */     // GIR_Coverage, 24688,
     /* 1487197 */     GIR_EraseRootFromParent_Done,
     /* 1487198 */   // Label 20781: @1487198
     /* 1487198 */   GIM_Try, /*On fail goto*//*Label 20782*/ GIMT_Encode4(1487295), // Rule ID 24689 //
     /* 1487203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1487214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1487217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1487220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487253 */     // MIs[1] Operand 1
     /* 1487253 */     // No operand predicates
     /* 1487253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487257 */     // MIs[0] policy
     /* 1487257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487269 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487294 */     // GIR_Coverage, 24689,
     /* 1487294 */     GIR_EraseRootFromParent_Done,
     /* 1487295 */   // Label 20782: @1487295
     /* 1487295 */   GIM_Try, /*On fail goto*//*Label 20783*/ GIMT_Encode4(1487392), // Rule ID 24692 //
     /* 1487300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1487311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1487314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1487317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487350 */     // MIs[1] Operand 1
     /* 1487350 */     // No operand predicates
     /* 1487350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487354 */     // MIs[0] policy
     /* 1487354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487366 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487391 */     // GIR_Coverage, 24692,
     /* 1487391 */     GIR_EraseRootFromParent_Done,
     /* 1487392 */   // Label 20783: @1487392
     /* 1487392 */   GIM_Try, /*On fail goto*//*Label 20784*/ GIMT_Encode4(1487489), // Rule ID 24693 //
     /* 1487397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1487408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1487411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1487414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487447 */     // MIs[1] Operand 1
     /* 1487447 */     // No operand predicates
     /* 1487447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487451 */     // MIs[0] policy
     /* 1487451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487463 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487488 */     // GIR_Coverage, 24693,
     /* 1487488 */     GIR_EraseRootFromParent_Done,
     /* 1487489 */   // Label 20784: @1487489
     /* 1487489 */   GIM_Try, /*On fail goto*//*Label 20785*/ GIMT_Encode4(1487586), // Rule ID 24696 //
     /* 1487494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1487505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1487508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1487511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487544 */     // MIs[1] Operand 1
     /* 1487544 */     // No operand predicates
     /* 1487544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487548 */     // MIs[0] policy
     /* 1487548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487560 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487585 */     // GIR_Coverage, 24696,
     /* 1487585 */     GIR_EraseRootFromParent_Done,
     /* 1487586 */   // Label 20785: @1487586
     /* 1487586 */   GIM_Try, /*On fail goto*//*Label 20786*/ GIMT_Encode4(1487683), // Rule ID 24697 //
     /* 1487591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1487602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1487605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1487608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487641 */     // MIs[1] Operand 1
     /* 1487641 */     // No operand predicates
     /* 1487641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487645 */     // MIs[0] policy
     /* 1487645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487657 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487682 */     // GIR_Coverage, 24697,
     /* 1487682 */     GIR_EraseRootFromParent_Done,
     /* 1487683 */   // Label 20786: @1487683
     /* 1487683 */   GIM_Try, /*On fail goto*//*Label 20787*/ GIMT_Encode4(1487780), // Rule ID 24700 //
     /* 1487688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1487699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1487702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1487705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487738 */     // MIs[1] Operand 1
     /* 1487738 */     // No operand predicates
     /* 1487738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487742 */     // MIs[0] policy
     /* 1487742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487754 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1487776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487779 */     // GIR_Coverage, 24700,
     /* 1487779 */     GIR_EraseRootFromParent_Done,
     /* 1487780 */   // Label 20787: @1487780
     /* 1487780 */   GIM_Try, /*On fail goto*//*Label 20788*/ GIMT_Encode4(1487877), // Rule ID 24701 //
     /* 1487785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1487796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1487799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1487802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487835 */     // MIs[1] Operand 1
     /* 1487835 */     // No operand predicates
     /* 1487835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487839 */     // MIs[0] policy
     /* 1487839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487851 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1487873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487876 */     // GIR_Coverage, 24701,
     /* 1487876 */     GIR_EraseRootFromParent_Done,
     /* 1487877 */   // Label 20788: @1487877
     /* 1487877 */   GIM_Try, /*On fail goto*//*Label 20789*/ GIMT_Encode4(1487974), // Rule ID 24704 //
     /* 1487882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1487893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1487896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1487899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487932 */     // MIs[1] Operand 1
     /* 1487932 */     // No operand predicates
     /* 1487932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487936 */     // MIs[0] policy
     /* 1487936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487948 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1487951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487973 */     // GIR_Coverage, 24704,
     /* 1487973 */     GIR_EraseRootFromParent_Done,
     /* 1487974 */   // Label 20789: @1487974
     /* 1487974 */   GIM_Try, /*On fail goto*//*Label 20790*/ GIMT_Encode4(1488071), // Rule ID 24705 //
     /* 1487979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1487990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1487993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1487996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1488002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488029 */     // MIs[1] Operand 1
     /* 1488029 */     // No operand predicates
     /* 1488029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488033 */     // MIs[0] policy
     /* 1488033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488045 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488070 */     // GIR_Coverage, 24705,
     /* 1488070 */     GIR_EraseRootFromParent_Done,
     /* 1488071 */   // Label 20790: @1488071
     /* 1488071 */   GIM_Try, /*On fail goto*//*Label 20791*/ GIMT_Encode4(1488168), // Rule ID 24708 //
     /* 1488076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1488087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1488090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1488093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488126 */     // MIs[1] Operand 1
     /* 1488126 */     // No operand predicates
     /* 1488126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488130 */     // MIs[0] policy
     /* 1488130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488142 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488167 */     // GIR_Coverage, 24708,
     /* 1488167 */     GIR_EraseRootFromParent_Done,
     /* 1488168 */   // Label 20791: @1488168
     /* 1488168 */   GIM_Try, /*On fail goto*//*Label 20792*/ GIMT_Encode4(1488265), // Rule ID 24709 //
     /* 1488173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1488184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1488187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1488190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488223 */     // MIs[1] Operand 1
     /* 1488223 */     // No operand predicates
     /* 1488223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488227 */     // MIs[0] policy
     /* 1488227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488239 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488264 */     // GIR_Coverage, 24709,
     /* 1488264 */     GIR_EraseRootFromParent_Done,
     /* 1488265 */   // Label 20792: @1488265
     /* 1488265 */   GIM_Try, /*On fail goto*//*Label 20793*/ GIMT_Encode4(1488362), // Rule ID 24712 //
     /* 1488270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1488281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1488284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1488287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488320 */     // MIs[1] Operand 1
     /* 1488320 */     // No operand predicates
     /* 1488320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488324 */     // MIs[0] policy
     /* 1488324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488361 */     // GIR_Coverage, 24712,
     /* 1488361 */     GIR_EraseRootFromParent_Done,
     /* 1488362 */   // Label 20793: @1488362
     /* 1488362 */   GIM_Try, /*On fail goto*//*Label 20794*/ GIMT_Encode4(1488459), // Rule ID 24713 //
     /* 1488367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1488378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1488381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1488384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488417 */     // MIs[1] Operand 1
     /* 1488417 */     // No operand predicates
     /* 1488417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488421 */     // MIs[0] policy
     /* 1488421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488433 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488458 */     // GIR_Coverage, 24713,
     /* 1488458 */     GIR_EraseRootFromParent_Done,
     /* 1488459 */   // Label 20794: @1488459
     /* 1488459 */   GIM_Try, /*On fail goto*//*Label 20795*/ GIMT_Encode4(1488556), // Rule ID 24716 //
     /* 1488464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1488467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1488475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1488478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1488481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488514 */     // MIs[1] Operand 1
     /* 1488514 */     // No operand predicates
     /* 1488514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488518 */     // MIs[0] policy
     /* 1488518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488530 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1488552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488555 */     // GIR_Coverage, 24716,
     /* 1488555 */     GIR_EraseRootFromParent_Done,
     /* 1488556 */   // Label 20795: @1488556
     /* 1488556 */   GIM_Try, /*On fail goto*//*Label 20796*/ GIMT_Encode4(1488653), // Rule ID 24717 //
     /* 1488561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1488564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1488572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1488575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1488578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488611 */     // MIs[1] Operand 1
     /* 1488611 */     // No operand predicates
     /* 1488611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488615 */     // MIs[0] policy
     /* 1488615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488627 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1488649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488652 */     // GIR_Coverage, 24717,
     /* 1488652 */     GIR_EraseRootFromParent_Done,
     /* 1488653 */   // Label 20796: @1488653
     /* 1488653 */   GIM_Try, /*On fail goto*//*Label 20797*/ GIMT_Encode4(1488750), // Rule ID 24720 //
     /* 1488658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1488669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1488672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1488675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1488681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1488688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488708 */     // MIs[1] Operand 1
     /* 1488708 */     // No operand predicates
     /* 1488708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488712 */     // MIs[0] policy
     /* 1488712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488724 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1488727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488749 */     // GIR_Coverage, 24720,
     /* 1488749 */     GIR_EraseRootFromParent_Done,
     /* 1488750 */   // Label 20797: @1488750
     /* 1488750 */   GIM_Try, /*On fail goto*//*Label 20798*/ GIMT_Encode4(1488847), // Rule ID 24721 //
     /* 1488755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1488766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1488769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1488772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1488778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1488785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488805 */     // MIs[1] Operand 1
     /* 1488805 */     // No operand predicates
     /* 1488805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488809 */     // MIs[0] policy
     /* 1488809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488821 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1488824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488846 */     // GIR_Coverage, 24721,
     /* 1488846 */     GIR_EraseRootFromParent_Done,
     /* 1488847 */   // Label 20798: @1488847
     /* 1488847 */   GIM_Try, /*On fail goto*//*Label 20799*/ GIMT_Encode4(1488944), // Rule ID 24724 //
     /* 1488852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1488863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1488866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1488869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1488875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1488882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488902 */     // MIs[1] Operand 1
     /* 1488902 */     // No operand predicates
     /* 1488902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488906 */     // MIs[0] policy
     /* 1488906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488918 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1488921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488943 */     // GIR_Coverage, 24724,
     /* 1488943 */     GIR_EraseRootFromParent_Done,
     /* 1488944 */   // Label 20799: @1488944
     /* 1488944 */   GIM_Try, /*On fail goto*//*Label 20800*/ GIMT_Encode4(1489041), // Rule ID 24725 //
     /* 1488949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1488960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1488963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1488966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1488972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1488979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488999 */     // MIs[1] Operand 1
     /* 1488999 */     // No operand predicates
     /* 1488999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489003 */     // MIs[0] policy
     /* 1489003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489015 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489040 */     // GIR_Coverage, 24725,
     /* 1489040 */     GIR_EraseRootFromParent_Done,
     /* 1489041 */   // Label 20800: @1489041
     /* 1489041 */   GIM_Try, /*On fail goto*//*Label 20801*/ GIMT_Encode4(1489138), // Rule ID 24728 //
     /* 1489046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1489057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1489060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1489063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1489069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489096 */     // MIs[1] Operand 1
     /* 1489096 */     // No operand predicates
     /* 1489096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489100 */     // MIs[0] policy
     /* 1489100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489112 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489137 */     // GIR_Coverage, 24728,
     /* 1489137 */     GIR_EraseRootFromParent_Done,
     /* 1489138 */   // Label 20801: @1489138
     /* 1489138 */   GIM_Try, /*On fail goto*//*Label 20802*/ GIMT_Encode4(1489235), // Rule ID 24729 //
     /* 1489143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1489154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1489157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1489160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1489166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489193 */     // MIs[1] Operand 1
     /* 1489193 */     // No operand predicates
     /* 1489193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489197 */     // MIs[0] policy
     /* 1489197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489209 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489234 */     // GIR_Coverage, 24729,
     /* 1489234 */     GIR_EraseRootFromParent_Done,
     /* 1489235 */   // Label 20802: @1489235
     /* 1489235 */   GIM_Try, /*On fail goto*//*Label 20803*/ GIMT_Encode4(1489332), // Rule ID 24732 //
     /* 1489240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1489251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1489254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1489257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489286 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489290 */     // MIs[1] Operand 1
     /* 1489290 */     // No operand predicates
     /* 1489290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489294 */     // MIs[0] policy
     /* 1489294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489331 */     // GIR_Coverage, 24732,
     /* 1489331 */     GIR_EraseRootFromParent_Done,
     /* 1489332 */   // Label 20803: @1489332
     /* 1489332 */   GIM_Try, /*On fail goto*//*Label 20804*/ GIMT_Encode4(1489429), // Rule ID 24733 //
     /* 1489337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1489348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1489351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1489354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489387 */     // MIs[1] Operand 1
     /* 1489387 */     // No operand predicates
     /* 1489387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489391 */     // MIs[0] policy
     /* 1489391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489403 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489428 */     // GIR_Coverage, 24733,
     /* 1489428 */     GIR_EraseRootFromParent_Done,
     /* 1489429 */   // Label 20804: @1489429
     /* 1489429 */   GIM_Try, /*On fail goto*//*Label 20805*/ GIMT_Encode4(1489526), // Rule ID 24736 //
     /* 1489434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1489445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1489448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1489451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489484 */     // MIs[1] Operand 1
     /* 1489484 */     // No operand predicates
     /* 1489484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489488 */     // MIs[0] policy
     /* 1489488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489500 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489525 */     // GIR_Coverage, 24736,
     /* 1489525 */     GIR_EraseRootFromParent_Done,
     /* 1489526 */   // Label 20805: @1489526
     /* 1489526 */   GIM_Try, /*On fail goto*//*Label 20806*/ GIMT_Encode4(1489623), // Rule ID 24737 //
     /* 1489531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1489542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1489545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1489548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489581 */     // MIs[1] Operand 1
     /* 1489581 */     // No operand predicates
     /* 1489581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489585 */     // MIs[0] policy
     /* 1489585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489597 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489622 */     // GIR_Coverage, 24737,
     /* 1489622 */     GIR_EraseRootFromParent_Done,
     /* 1489623 */   // Label 20806: @1489623
     /* 1489623 */   GIM_Try, /*On fail goto*//*Label 20807*/ GIMT_Encode4(1489720), // Rule ID 24740 //
     /* 1489628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1489639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1489642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1489645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1489651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489678 */     // MIs[1] Operand 1
     /* 1489678 */     // No operand predicates
     /* 1489678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489682 */     // MIs[0] policy
     /* 1489682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489694 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489719 */     // GIR_Coverage, 24740,
     /* 1489719 */     GIR_EraseRootFromParent_Done,
     /* 1489720 */   // Label 20807: @1489720
     /* 1489720 */   GIM_Try, /*On fail goto*//*Label 20808*/ GIMT_Encode4(1489817), // Rule ID 24741 //
     /* 1489725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1489736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1489739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1489742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1489748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489775 */     // MIs[1] Operand 1
     /* 1489775 */     // No operand predicates
     /* 1489775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489779 */     // MIs[0] policy
     /* 1489779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489791 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489816 */     // GIR_Coverage, 24741,
     /* 1489816 */     GIR_EraseRootFromParent_Done,
     /* 1489817 */   // Label 20808: @1489817
     /* 1489817 */   GIM_Try, /*On fail goto*//*Label 20809*/ GIMT_Encode4(1489914), // Rule ID 24744 //
     /* 1489822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1489833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1489836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1489839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1489845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489872 */     // MIs[1] Operand 1
     /* 1489872 */     // No operand predicates
     /* 1489872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489876 */     // MIs[0] policy
     /* 1489876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489888 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489913 */     // GIR_Coverage, 24744,
     /* 1489913 */     GIR_EraseRootFromParent_Done,
     /* 1489914 */   // Label 20809: @1489914
     /* 1489914 */   GIM_Try, /*On fail goto*//*Label 20810*/ GIMT_Encode4(1490011), // Rule ID 24745 //
     /* 1489919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1489930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1489933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1489936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1489942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489969 */     // MIs[1] Operand 1
     /* 1489969 */     // No operand predicates
     /* 1489969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489973 */     // MIs[0] policy
     /* 1489973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489985 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490010 */     // GIR_Coverage, 24745,
     /* 1490010 */     GIR_EraseRootFromParent_Done,
     /* 1490011 */   // Label 20810: @1490011
     /* 1490011 */   GIM_Try, /*On fail goto*//*Label 20811*/ GIMT_Encode4(1490108), // Rule ID 24748 //
     /* 1490016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1490027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1490030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1490033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490066 */     // MIs[1] Operand 1
     /* 1490066 */     // No operand predicates
     /* 1490066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490070 */     // MIs[0] policy
     /* 1490070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490082 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490107 */     // GIR_Coverage, 24748,
     /* 1490107 */     GIR_EraseRootFromParent_Done,
     /* 1490108 */   // Label 20811: @1490108
     /* 1490108 */   GIM_Try, /*On fail goto*//*Label 20812*/ GIMT_Encode4(1490205), // Rule ID 24749 //
     /* 1490113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1490124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1490127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1490130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490163 */     // MIs[1] Operand 1
     /* 1490163 */     // No operand predicates
     /* 1490163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490167 */     // MIs[0] policy
     /* 1490167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490179 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490204 */     // GIR_Coverage, 24749,
     /* 1490204 */     GIR_EraseRootFromParent_Done,
     /* 1490205 */   // Label 20812: @1490205
     /* 1490205 */   GIM_Try, /*On fail goto*//*Label 20813*/ GIMT_Encode4(1490302), // Rule ID 24752 //
     /* 1490210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1490221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1490224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1490227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1490233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490260 */     // MIs[1] Operand 1
     /* 1490260 */     // No operand predicates
     /* 1490260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490264 */     // MIs[0] policy
     /* 1490264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490276 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490301 */     // GIR_Coverage, 24752,
     /* 1490301 */     GIR_EraseRootFromParent_Done,
     /* 1490302 */   // Label 20813: @1490302
     /* 1490302 */   GIM_Try, /*On fail goto*//*Label 20814*/ GIMT_Encode4(1490399), // Rule ID 24753 //
     /* 1490307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1490318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1490321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1490324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1490330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490357 */     // MIs[1] Operand 1
     /* 1490357 */     // No operand predicates
     /* 1490357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490361 */     // MIs[0] policy
     /* 1490361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490373 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490398 */     // GIR_Coverage, 24753,
     /* 1490398 */     GIR_EraseRootFromParent_Done,
     /* 1490399 */   // Label 20814: @1490399
     /* 1490399 */   GIM_Try, /*On fail goto*//*Label 20815*/ GIMT_Encode4(1490496), // Rule ID 24756 //
     /* 1490404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1490407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1490415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1490418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1490421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490454 */     // MIs[1] Operand 1
     /* 1490454 */     // No operand predicates
     /* 1490454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490458 */     // MIs[0] policy
     /* 1490458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490470 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1490473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490495 */     // GIR_Coverage, 24756,
     /* 1490495 */     GIR_EraseRootFromParent_Done,
     /* 1490496 */   // Label 20815: @1490496
     /* 1490496 */   GIM_Try, /*On fail goto*//*Label 20816*/ GIMT_Encode4(1490593), // Rule ID 24757 //
     /* 1490501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1490504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1490512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1490515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1490518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490551 */     // MIs[1] Operand 1
     /* 1490551 */     // No operand predicates
     /* 1490551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490555 */     // MIs[0] policy
     /* 1490555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490567 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1490570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490592 */     // GIR_Coverage, 24757,
     /* 1490592 */     GIR_EraseRootFromParent_Done,
     /* 1490593 */   // Label 20816: @1490593
     /* 1490593 */   GIM_Try, /*On fail goto*//*Label 20817*/ GIMT_Encode4(1490690), // Rule ID 24760 //
     /* 1490598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1490601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1490609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1490612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1490615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490648 */     // MIs[1] Operand 1
     /* 1490648 */     // No operand predicates
     /* 1490648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490652 */     // MIs[0] policy
     /* 1490652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490664 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490689 */     // GIR_Coverage, 24760,
     /* 1490689 */     GIR_EraseRootFromParent_Done,
     /* 1490690 */   // Label 20817: @1490690
     /* 1490690 */   GIM_Try, /*On fail goto*//*Label 20818*/ GIMT_Encode4(1490787), // Rule ID 24761 //
     /* 1490695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1490698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1490706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1490709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1490712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490745 */     // MIs[1] Operand 1
     /* 1490745 */     // No operand predicates
     /* 1490745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490749 */     // MIs[0] policy
     /* 1490749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490761 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490786 */     // GIR_Coverage, 24761,
     /* 1490786 */     GIR_EraseRootFromParent_Done,
     /* 1490787 */   // Label 20818: @1490787
     /* 1490787 */   GIM_Try, /*On fail goto*//*Label 20819*/ GIMT_Encode4(1490884), // Rule ID 24764 //
     /* 1490792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1490795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1490803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1490806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1490809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490842 */     // MIs[1] Operand 1
     /* 1490842 */     // No operand predicates
     /* 1490842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490846 */     // MIs[0] policy
     /* 1490846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490858 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490883 */     // GIR_Coverage, 24764,
     /* 1490883 */     GIR_EraseRootFromParent_Done,
     /* 1490884 */   // Label 20819: @1490884
     /* 1490884 */   GIM_Try, /*On fail goto*//*Label 20820*/ GIMT_Encode4(1490981), // Rule ID 24765 //
     /* 1490889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1490892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1490900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1490903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1490906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490939 */     // MIs[1] Operand 1
     /* 1490939 */     // No operand predicates
     /* 1490939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490943 */     // MIs[0] policy
     /* 1490943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490955 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490980 */     // GIR_Coverage, 24765,
     /* 1490980 */     GIR_EraseRootFromParent_Done,
     /* 1490981 */   // Label 20820: @1490981
     /* 1490981 */   GIM_Try, /*On fail goto*//*Label 20821*/ GIMT_Encode4(1491078), // Rule ID 24972 //
     /* 1490986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1490997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1491000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1491003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491036 */     // MIs[1] Operand 1
     /* 1491036 */     // No operand predicates
     /* 1491036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491040 */     // MIs[0] policy
     /* 1491040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491052 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1491055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491077 */     // GIR_Coverage, 24972,
     /* 1491077 */     GIR_EraseRootFromParent_Done,
     /* 1491078 */   // Label 20821: @1491078
     /* 1491078 */   GIM_Try, /*On fail goto*//*Label 20822*/ GIMT_Encode4(1491175), // Rule ID 24973 //
     /* 1491083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1491094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1491097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1491100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491133 */     // MIs[1] Operand 1
     /* 1491133 */     // No operand predicates
     /* 1491133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491137 */     // MIs[0] policy
     /* 1491137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491149 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1491152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491174 */     // GIR_Coverage, 24973,
     /* 1491174 */     GIR_EraseRootFromParent_Done,
     /* 1491175 */   // Label 20822: @1491175
     /* 1491175 */   GIM_Try, /*On fail goto*//*Label 20823*/ GIMT_Encode4(1491272), // Rule ID 24976 //
     /* 1491180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1491191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1491194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1491197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491230 */     // MIs[1] Operand 1
     /* 1491230 */     // No operand predicates
     /* 1491230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491234 */     // MIs[0] policy
     /* 1491234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491246 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491271 */     // GIR_Coverage, 24976,
     /* 1491271 */     GIR_EraseRootFromParent_Done,
     /* 1491272 */   // Label 20823: @1491272
     /* 1491272 */   GIM_Try, /*On fail goto*//*Label 20824*/ GIMT_Encode4(1491369), // Rule ID 24977 //
     /* 1491277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1491288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1491291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1491294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491327 */     // MIs[1] Operand 1
     /* 1491327 */     // No operand predicates
     /* 1491327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491331 */     // MIs[0] policy
     /* 1491331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491343 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491368 */     // GIR_Coverage, 24977,
     /* 1491368 */     GIR_EraseRootFromParent_Done,
     /* 1491369 */   // Label 20824: @1491369
     /* 1491369 */   GIM_Try, /*On fail goto*//*Label 20825*/ GIMT_Encode4(1491466), // Rule ID 24980 //
     /* 1491374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1491385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1491388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1491391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491424 */     // MIs[1] Operand 1
     /* 1491424 */     // No operand predicates
     /* 1491424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491428 */     // MIs[0] policy
     /* 1491428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491440 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491465 */     // GIR_Coverage, 24980,
     /* 1491465 */     GIR_EraseRootFromParent_Done,
     /* 1491466 */   // Label 20825: @1491466
     /* 1491466 */   GIM_Try, /*On fail goto*//*Label 20826*/ GIMT_Encode4(1491563), // Rule ID 24981 //
     /* 1491471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1491482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1491485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1491488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491521 */     // MIs[1] Operand 1
     /* 1491521 */     // No operand predicates
     /* 1491521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491525 */     // MIs[0] policy
     /* 1491525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491537 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491562 */     // GIR_Coverage, 24981,
     /* 1491562 */     GIR_EraseRootFromParent_Done,
     /* 1491563 */   // Label 20826: @1491563
     /* 1491563 */   GIM_Try, /*On fail goto*//*Label 20827*/ GIMT_Encode4(1491660), // Rule ID 24984 //
     /* 1491568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1491579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1491582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1491585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1491591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491618 */     // MIs[1] Operand 1
     /* 1491618 */     // No operand predicates
     /* 1491618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491622 */     // MIs[0] policy
     /* 1491622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491634 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1491637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491659 */     // GIR_Coverage, 24984,
     /* 1491659 */     GIR_EraseRootFromParent_Done,
     /* 1491660 */   // Label 20827: @1491660
     /* 1491660 */   GIM_Try, /*On fail goto*//*Label 20828*/ GIMT_Encode4(1491757), // Rule ID 24985 //
     /* 1491665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1491676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1491679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1491682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1491688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491715 */     // MIs[1] Operand 1
     /* 1491715 */     // No operand predicates
     /* 1491715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491719 */     // MIs[0] policy
     /* 1491719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491731 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1491734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491756 */     // GIR_Coverage, 24985,
     /* 1491756 */     GIR_EraseRootFromParent_Done,
     /* 1491757 */   // Label 20828: @1491757
     /* 1491757 */   GIM_Try, /*On fail goto*//*Label 20829*/ GIMT_Encode4(1491854), // Rule ID 24988 //
     /* 1491762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1491773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1491776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1491779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491812 */     // MIs[1] Operand 1
     /* 1491812 */     // No operand predicates
     /* 1491812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491816 */     // MIs[0] policy
     /* 1491816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491828 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1491831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491853 */     // GIR_Coverage, 24988,
     /* 1491853 */     GIR_EraseRootFromParent_Done,
     /* 1491854 */   // Label 20829: @1491854
     /* 1491854 */   GIM_Try, /*On fail goto*//*Label 20830*/ GIMT_Encode4(1491951), // Rule ID 24989 //
     /* 1491859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1491870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1491873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1491876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491909 */     // MIs[1] Operand 1
     /* 1491909 */     // No operand predicates
     /* 1491909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491913 */     // MIs[0] policy
     /* 1491913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491925 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1491928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491950 */     // GIR_Coverage, 24989,
     /* 1491950 */     GIR_EraseRootFromParent_Done,
     /* 1491951 */   // Label 20830: @1491951
     /* 1491951 */   GIM_Try, /*On fail goto*//*Label 20831*/ GIMT_Encode4(1492048), // Rule ID 24992 //
     /* 1491956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1491959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1491967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1491970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1491973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492006 */     // MIs[1] Operand 1
     /* 1492006 */     // No operand predicates
     /* 1492006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492010 */     // MIs[0] policy
     /* 1492010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492022 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492047 */     // GIR_Coverage, 24992,
     /* 1492047 */     GIR_EraseRootFromParent_Done,
     /* 1492048 */   // Label 20831: @1492048
     /* 1492048 */   GIM_Try, /*On fail goto*//*Label 20832*/ GIMT_Encode4(1492145), // Rule ID 24993 //
     /* 1492053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1492056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1492064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1492067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1492070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1492076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492103 */     // MIs[1] Operand 1
     /* 1492103 */     // No operand predicates
     /* 1492103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492107 */     // MIs[0] policy
     /* 1492107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492119 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492144 */     // GIR_Coverage, 24993,
     /* 1492144 */     GIR_EraseRootFromParent_Done,
     /* 1492145 */   // Label 20832: @1492145
     /* 1492145 */   GIM_Try, /*On fail goto*//*Label 20833*/ GIMT_Encode4(1492242), // Rule ID 24996 //
     /* 1492150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1492161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1492164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1492167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492200 */     // MIs[1] Operand 1
     /* 1492200 */     // No operand predicates
     /* 1492200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492204 */     // MIs[0] policy
     /* 1492204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492216 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492241 */     // GIR_Coverage, 24996,
     /* 1492241 */     GIR_EraseRootFromParent_Done,
     /* 1492242 */   // Label 20833: @1492242
     /* 1492242 */   GIM_Try, /*On fail goto*//*Label 20834*/ GIMT_Encode4(1492339), // Rule ID 24997 //
     /* 1492247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1492258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1492261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1492264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492297 */     // MIs[1] Operand 1
     /* 1492297 */     // No operand predicates
     /* 1492297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492301 */     // MIs[0] policy
     /* 1492301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492313 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492338 */     // GIR_Coverage, 24997,
     /* 1492338 */     GIR_EraseRootFromParent_Done,
     /* 1492339 */   // Label 20834: @1492339
     /* 1492339 */   GIM_Try, /*On fail goto*//*Label 20835*/ GIMT_Encode4(1492436), // Rule ID 25000 //
     /* 1492344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1492355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1492358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1492361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492394 */     // MIs[1] Operand 1
     /* 1492394 */     // No operand predicates
     /* 1492394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492398 */     // MIs[0] policy
     /* 1492398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492410 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1492413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492435 */     // GIR_Coverage, 25000,
     /* 1492435 */     GIR_EraseRootFromParent_Done,
     /* 1492436 */   // Label 20835: @1492436
     /* 1492436 */   GIM_Try, /*On fail goto*//*Label 20836*/ GIMT_Encode4(1492533), // Rule ID 25001 //
     /* 1492441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1492452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1492455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1492458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492491 */     // MIs[1] Operand 1
     /* 1492491 */     // No operand predicates
     /* 1492491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492495 */     // MIs[0] policy
     /* 1492495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492507 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1492510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492532 */     // GIR_Coverage, 25001,
     /* 1492532 */     GIR_EraseRootFromParent_Done,
     /* 1492533 */   // Label 20836: @1492533
     /* 1492533 */   GIM_Try, /*On fail goto*//*Label 20837*/ GIMT_Encode4(1492630), // Rule ID 25004 //
     /* 1492538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1492549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1492552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1492555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1492561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1492568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492588 */     // MIs[1] Operand 1
     /* 1492588 */     // No operand predicates
     /* 1492588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492592 */     // MIs[0] policy
     /* 1492592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492604 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1492607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492629 */     // GIR_Coverage, 25004,
     /* 1492629 */     GIR_EraseRootFromParent_Done,
     /* 1492630 */   // Label 20837: @1492630
     /* 1492630 */   GIM_Try, /*On fail goto*//*Label 20838*/ GIMT_Encode4(1492727), // Rule ID 25005 //
     /* 1492635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1492646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1492649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1492652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1492658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1492665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492685 */     // MIs[1] Operand 1
     /* 1492685 */     // No operand predicates
     /* 1492685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492689 */     // MIs[0] policy
     /* 1492689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492701 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1492704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492726 */     // GIR_Coverage, 25005,
     /* 1492726 */     GIR_EraseRootFromParent_Done,
     /* 1492727 */   // Label 20838: @1492727
     /* 1492727 */   GIM_Try, /*On fail goto*//*Label 20839*/ GIMT_Encode4(1492824), // Rule ID 25008 //
     /* 1492732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1492743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1492746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1492749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492782 */     // MIs[1] Operand 1
     /* 1492782 */     // No operand predicates
     /* 1492782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492786 */     // MIs[0] policy
     /* 1492786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492798 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492823 */     // GIR_Coverage, 25008,
     /* 1492823 */     GIR_EraseRootFromParent_Done,
     /* 1492824 */   // Label 20839: @1492824
     /* 1492824 */   GIM_Try, /*On fail goto*//*Label 20840*/ GIMT_Encode4(1492921), // Rule ID 25009 //
     /* 1492829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1492840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1492843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1492846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492879 */     // MIs[1] Operand 1
     /* 1492879 */     // No operand predicates
     /* 1492879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492883 */     // MIs[0] policy
     /* 1492883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492895 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492920 */     // GIR_Coverage, 25009,
     /* 1492920 */     GIR_EraseRootFromParent_Done,
     /* 1492921 */   // Label 20840: @1492921
     /* 1492921 */   GIM_Try, /*On fail goto*//*Label 20841*/ GIMT_Encode4(1493018), // Rule ID 25012 //
     /* 1492926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1492937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1492940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1492943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492976 */     // MIs[1] Operand 1
     /* 1492976 */     // No operand predicates
     /* 1492976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492980 */     // MIs[0] policy
     /* 1492980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492992 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1492995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493017 */     // GIR_Coverage, 25012,
     /* 1493017 */     GIR_EraseRootFromParent_Done,
     /* 1493018 */   // Label 20841: @1493018
     /* 1493018 */   GIM_Try, /*On fail goto*//*Label 20842*/ GIMT_Encode4(1493115), // Rule ID 25013 //
     /* 1493023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1493034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1493037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1493040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493073 */     // MIs[1] Operand 1
     /* 1493073 */     // No operand predicates
     /* 1493073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493077 */     // MIs[0] policy
     /* 1493077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493089 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1493092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493114 */     // GIR_Coverage, 25013,
     /* 1493114 */     GIR_EraseRootFromParent_Done,
     /* 1493115 */   // Label 20842: @1493115
     /* 1493115 */   GIM_Try, /*On fail goto*//*Label 20843*/ GIMT_Encode4(1493212), // Rule ID 25016 //
     /* 1493120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1493131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1493134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1493137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493170 */     // MIs[1] Operand 1
     /* 1493170 */     // No operand predicates
     /* 1493170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493174 */     // MIs[0] policy
     /* 1493174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493186 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493211 */     // GIR_Coverage, 25016,
     /* 1493211 */     GIR_EraseRootFromParent_Done,
     /* 1493212 */   // Label 20843: @1493212
     /* 1493212 */   GIM_Try, /*On fail goto*//*Label 20844*/ GIMT_Encode4(1493309), // Rule ID 25017 //
     /* 1493217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1493228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1493231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1493234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493267 */     // MIs[1] Operand 1
     /* 1493267 */     // No operand predicates
     /* 1493267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493271 */     // MIs[0] policy
     /* 1493271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493283 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493308 */     // GIR_Coverage, 25017,
     /* 1493308 */     GIR_EraseRootFromParent_Done,
     /* 1493309 */   // Label 20844: @1493309
     /* 1493309 */   GIM_Try, /*On fail goto*//*Label 20845*/ GIMT_Encode4(1493406), // Rule ID 25020 //
     /* 1493314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1493317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1493325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1493328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1493331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493364 */     // MIs[1] Operand 1
     /* 1493364 */     // No operand predicates
     /* 1493364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493368 */     // MIs[0] policy
     /* 1493368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493380 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493405 */     // GIR_Coverage, 25020,
     /* 1493405 */     GIR_EraseRootFromParent_Done,
     /* 1493406 */   // Label 20845: @1493406
     /* 1493406 */   GIM_Try, /*On fail goto*//*Label 20846*/ GIMT_Encode4(1493503), // Rule ID 25021 //
     /* 1493411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1493414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1493422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1493425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1493428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493461 */     // MIs[1] Operand 1
     /* 1493461 */     // No operand predicates
     /* 1493461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493465 */     // MIs[0] policy
     /* 1493465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493477 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493502 */     // GIR_Coverage, 25021,
     /* 1493502 */     GIR_EraseRootFromParent_Done,
     /* 1493503 */   // Label 20846: @1493503
     /* 1493503 */   GIM_Try, /*On fail goto*//*Label 20847*/ GIMT_Encode4(1493600), // Rule ID 25024 //
     /* 1493508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1493511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1493519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1493522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1493525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493558 */     // MIs[1] Operand 1
     /* 1493558 */     // No operand predicates
     /* 1493558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493562 */     // MIs[0] policy
     /* 1493562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493574 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1493577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493599 */     // GIR_Coverage, 25024,
     /* 1493599 */     GIR_EraseRootFromParent_Done,
     /* 1493600 */   // Label 20847: @1493600
     /* 1493600 */   GIM_Try, /*On fail goto*//*Label 20848*/ GIMT_Encode4(1493697), // Rule ID 25025 //
     /* 1493605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1493608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1493616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1493619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1493622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493655 */     // MIs[1] Operand 1
     /* 1493655 */     // No operand predicates
     /* 1493655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493659 */     // MIs[0] policy
     /* 1493659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493671 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1493674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493696 */     // GIR_Coverage, 25025,
     /* 1493696 */     GIR_EraseRootFromParent_Done,
     /* 1493697 */   // Label 20848: @1493697
     /* 1493697 */   GIM_Try, /*On fail goto*//*Label 20849*/ GIMT_Encode4(1493794), // Rule ID 25028 //
     /* 1493702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1493705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1493713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1493716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1493719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493752 */     // MIs[1] Operand 1
     /* 1493752 */     // No operand predicates
     /* 1493752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493756 */     // MIs[0] policy
     /* 1493756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493768 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493793 */     // GIR_Coverage, 25028,
     /* 1493793 */     GIR_EraseRootFromParent_Done,
     /* 1493794 */   // Label 20849: @1493794
     /* 1493794 */   GIM_Try, /*On fail goto*//*Label 20850*/ GIMT_Encode4(1493891), // Rule ID 25029 //
     /* 1493799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1493802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1493810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1493813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1493816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493849 */     // MIs[1] Operand 1
     /* 1493849 */     // No operand predicates
     /* 1493849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493853 */     // MIs[0] policy
     /* 1493853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493865 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493890 */     // GIR_Coverage, 25029,
     /* 1493890 */     GIR_EraseRootFromParent_Done,
     /* 1493891 */   // Label 20850: @1493891
     /* 1493891 */   GIM_Try, /*On fail goto*//*Label 20851*/ GIMT_Encode4(1493988), // Rule ID 61040 //
     /* 1493896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1493899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1493907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1493910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1493913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1493919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493946 */     // MIs[1] Operand 1
     /* 1493946 */     // No operand predicates
     /* 1493946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493950 */     // MIs[0] policy
     /* 1493950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493962 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1493965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1493984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493987 */     // GIR_Coverage, 61040,
     /* 1493987 */     GIR_EraseRootFromParent_Done,
     /* 1493988 */   // Label 20851: @1493988
     /* 1493988 */   GIM_Try, /*On fail goto*//*Label 20852*/ GIMT_Encode4(1494085), // Rule ID 61041 //
     /* 1493993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1493996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1494004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1494007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1494010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1494016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494043 */     // MIs[1] Operand 1
     /* 1494043 */     // No operand predicates
     /* 1494043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494047 */     // MIs[0] policy
     /* 1494047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494059 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1494062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494084 */     // GIR_Coverage, 61041,
     /* 1494084 */     GIR_EraseRootFromParent_Done,
     /* 1494085 */   // Label 20852: @1494085
     /* 1494085 */   GIM_Try, /*On fail goto*//*Label 20853*/ GIMT_Encode4(1494182), // Rule ID 61048 //
     /* 1494090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1494101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1494104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1494107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494140 */     // MIs[1] Operand 1
     /* 1494140 */     // No operand predicates
     /* 1494140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494144 */     // MIs[0] policy
     /* 1494144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494156 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1494159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494181 */     // GIR_Coverage, 61048,
     /* 1494181 */     GIR_EraseRootFromParent_Done,
     /* 1494182 */   // Label 20853: @1494182
     /* 1494182 */   GIM_Try, /*On fail goto*//*Label 20854*/ GIMT_Encode4(1494279), // Rule ID 61049 //
     /* 1494187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1494198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1494201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1494204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494237 */     // MIs[1] Operand 1
     /* 1494237 */     // No operand predicates
     /* 1494237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494241 */     // MIs[0] policy
     /* 1494241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494253 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1494256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494278 */     // GIR_Coverage, 61049,
     /* 1494278 */     GIR_EraseRootFromParent_Done,
     /* 1494279 */   // Label 20854: @1494279
     /* 1494279 */   GIM_Try, /*On fail goto*//*Label 20855*/ GIMT_Encode4(1494376), // Rule ID 61056 //
     /* 1494284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1494295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1494298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1494301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494334 */     // MIs[1] Operand 1
     /* 1494334 */     // No operand predicates
     /* 1494334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494338 */     // MIs[0] policy
     /* 1494338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494350 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1494353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494375 */     // GIR_Coverage, 61056,
     /* 1494375 */     GIR_EraseRootFromParent_Done,
     /* 1494376 */   // Label 20855: @1494376
     /* 1494376 */   GIM_Try, /*On fail goto*//*Label 20856*/ GIMT_Encode4(1494473), // Rule ID 61057 //
     /* 1494381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1494392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1494395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1494398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494431 */     // MIs[1] Operand 1
     /* 1494431 */     // No operand predicates
     /* 1494431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494435 */     // MIs[0] policy
     /* 1494435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494447 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1494450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494472 */     // GIR_Coverage, 61057,
     /* 1494472 */     GIR_EraseRootFromParent_Done,
     /* 1494473 */   // Label 20856: @1494473
     /* 1494473 */   GIM_Try, /*On fail goto*//*Label 20857*/ GIMT_Encode4(1494570), // Rule ID 61064 //
     /* 1494478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1494489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1494492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1494495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1494508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494528 */     // MIs[1] Operand 1
     /* 1494528 */     // No operand predicates
     /* 1494528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494532 */     // MIs[0] policy
     /* 1494532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1494547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494569 */     // GIR_Coverage, 61064,
     /* 1494569 */     GIR_EraseRootFromParent_Done,
     /* 1494570 */   // Label 20857: @1494570
     /* 1494570 */   GIM_Try, /*On fail goto*//*Label 20858*/ GIMT_Encode4(1494667), // Rule ID 61065 //
     /* 1494575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1494586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1494589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1494592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1494605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494625 */     // MIs[1] Operand 1
     /* 1494625 */     // No operand predicates
     /* 1494625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494629 */     // MIs[0] policy
     /* 1494629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494641 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1494644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494666 */     // GIR_Coverage, 61065,
     /* 1494666 */     GIR_EraseRootFromParent_Done,
     /* 1494667 */   // Label 20858: @1494667
     /* 1494667 */   GIM_Try, /*On fail goto*//*Label 20859*/ GIMT_Encode4(1494764), // Rule ID 61072 //
     /* 1494672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1494683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1494686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1494689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1494695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494722 */     // MIs[1] Operand 1
     /* 1494722 */     // No operand predicates
     /* 1494722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494726 */     // MIs[0] policy
     /* 1494726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494738 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1494741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494763 */     // GIR_Coverage, 61072,
     /* 1494763 */     GIR_EraseRootFromParent_Done,
     /* 1494764 */   // Label 20859: @1494764
     /* 1494764 */   GIM_Try, /*On fail goto*//*Label 20860*/ GIMT_Encode4(1494861), // Rule ID 61073 //
     /* 1494769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1494780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1494783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1494786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1494792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494819 */     // MIs[1] Operand 1
     /* 1494819 */     // No operand predicates
     /* 1494819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494823 */     // MIs[0] policy
     /* 1494823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494835 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1494838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494860 */     // GIR_Coverage, 61073,
     /* 1494860 */     GIR_EraseRootFromParent_Done,
     /* 1494861 */   // Label 20860: @1494861
     /* 1494861 */   GIM_Try, /*On fail goto*//*Label 20861*/ GIMT_Encode4(1494958), // Rule ID 61080 //
     /* 1494866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1494877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1494880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1494883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1494889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494916 */     // MIs[1] Operand 1
     /* 1494916 */     // No operand predicates
     /* 1494916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494920 */     // MIs[0] policy
     /* 1494920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494932 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1494935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494957 */     // GIR_Coverage, 61080,
     /* 1494957 */     GIR_EraseRootFromParent_Done,
     /* 1494958 */   // Label 20861: @1494958
     /* 1494958 */   GIM_Try, /*On fail goto*//*Label 20862*/ GIMT_Encode4(1495055), // Rule ID 61081 //
     /* 1494963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1494974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1494977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1494980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1494986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495013 */     // MIs[1] Operand 1
     /* 1495013 */     // No operand predicates
     /* 1495013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495017 */     // MIs[0] policy
     /* 1495017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495029 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1495032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495054 */     // GIR_Coverage, 61081,
     /* 1495054 */     GIR_EraseRootFromParent_Done,
     /* 1495055 */   // Label 20862: @1495055
     /* 1495055 */   GIM_Try, /*On fail goto*//*Label 20863*/ GIMT_Encode4(1495152), // Rule ID 61088 //
     /* 1495060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1495071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1495074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1495077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495110 */     // MIs[1] Operand 1
     /* 1495110 */     // No operand predicates
     /* 1495110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495114 */     // MIs[0] policy
     /* 1495114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495126 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1495129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495151 */     // GIR_Coverage, 61088,
     /* 1495151 */     GIR_EraseRootFromParent_Done,
     /* 1495152 */   // Label 20863: @1495152
     /* 1495152 */   GIM_Try, /*On fail goto*//*Label 20864*/ GIMT_Encode4(1495249), // Rule ID 61089 //
     /* 1495157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1495168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1495171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1495174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495207 */     // MIs[1] Operand 1
     /* 1495207 */     // No operand predicates
     /* 1495207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495211 */     // MIs[0] policy
     /* 1495211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495223 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1495226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495248 */     // GIR_Coverage, 61089,
     /* 1495248 */     GIR_EraseRootFromParent_Done,
     /* 1495249 */   // Label 20864: @1495249
     /* 1495249 */   GIM_Try, /*On fail goto*//*Label 20865*/ GIMT_Encode4(1495346), // Rule ID 61096 //
     /* 1495254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1495265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1495268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1495271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1495277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495304 */     // MIs[1] Operand 1
     /* 1495304 */     // No operand predicates
     /* 1495304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495308 */     // MIs[0] policy
     /* 1495308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11680:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1495323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495345 */     // GIR_Coverage, 61096,
     /* 1495345 */     GIR_EraseRootFromParent_Done,
     /* 1495346 */   // Label 20865: @1495346
     /* 1495346 */   GIM_Try, /*On fail goto*//*Label 20866*/ GIMT_Encode4(1495443), // Rule ID 61097 //
     /* 1495351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1495362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1495365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1495368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1495374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495401 */     // MIs[1] Operand 1
     /* 1495401 */     // No operand predicates
     /* 1495401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495405 */     // MIs[0] policy
     /* 1495405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495417 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11680:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1495420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495442 */     // GIR_Coverage, 61097,
     /* 1495442 */     GIR_EraseRootFromParent_Done,
     /* 1495443 */   // Label 20866: @1495443
     /* 1495443 */   GIM_Try, /*On fail goto*//*Label 20867*/ GIMT_Encode4(1495540), // Rule ID 61104 //
     /* 1495448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1495459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1495462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1495465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1495471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495498 */     // MIs[1] Operand 1
     /* 1495498 */     // No operand predicates
     /* 1495498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495502 */     // MIs[0] policy
     /* 1495502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495514 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1495517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495539 */     // GIR_Coverage, 61104,
     /* 1495539 */     GIR_EraseRootFromParent_Done,
     /* 1495540 */   // Label 20867: @1495540
     /* 1495540 */   GIM_Try, /*On fail goto*//*Label 20868*/ GIMT_Encode4(1495637), // Rule ID 61105 //
     /* 1495545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1495556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1495559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1495562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1495568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495595 */     // MIs[1] Operand 1
     /* 1495595 */     // No operand predicates
     /* 1495595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495599 */     // MIs[0] policy
     /* 1495599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495611 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1495614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495636 */     // GIR_Coverage, 61105,
     /* 1495636 */     GIR_EraseRootFromParent_Done,
     /* 1495637 */   // Label 20868: @1495637
     /* 1495637 */   GIM_Try, /*On fail goto*//*Label 20869*/ GIMT_Encode4(1495734), // Rule ID 61112 //
     /* 1495642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1495653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1495656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1495659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495692 */     // MIs[1] Operand 1
     /* 1495692 */     // No operand predicates
     /* 1495692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495696 */     // MIs[0] policy
     /* 1495696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495708 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1495711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495733 */     // GIR_Coverage, 61112,
     /* 1495733 */     GIR_EraseRootFromParent_Done,
     /* 1495734 */   // Label 20869: @1495734
     /* 1495734 */   GIM_Try, /*On fail goto*//*Label 20870*/ GIMT_Encode4(1495831), // Rule ID 61113 //
     /* 1495739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1495750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1495753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1495756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495789 */     // MIs[1] Operand 1
     /* 1495789 */     // No operand predicates
     /* 1495789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495793 */     // MIs[0] policy
     /* 1495793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495805 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1495808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495830 */     // GIR_Coverage, 61113,
     /* 1495830 */     GIR_EraseRootFromParent_Done,
     /* 1495831 */   // Label 20870: @1495831
     /* 1495831 */   GIM_Try, /*On fail goto*//*Label 20871*/ GIMT_Encode4(1495928), // Rule ID 61120 //
     /* 1495836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1495847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1495850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1495853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495886 */     // MIs[1] Operand 1
     /* 1495886 */     // No operand predicates
     /* 1495886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495890 */     // MIs[0] policy
     /* 1495890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495902 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1495905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495927 */     // GIR_Coverage, 61120,
     /* 1495927 */     GIR_EraseRootFromParent_Done,
     /* 1495928 */   // Label 20871: @1495928
     /* 1495928 */   GIM_Try, /*On fail goto*//*Label 20872*/ GIMT_Encode4(1496025), // Rule ID 61121 //
     /* 1495933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1495944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1495947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1495950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495983 */     // MIs[1] Operand 1
     /* 1495983 */     // No operand predicates
     /* 1495983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495987 */     // MIs[0] policy
     /* 1495987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495999 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1496002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496024 */     // GIR_Coverage, 61121,
     /* 1496024 */     GIR_EraseRootFromParent_Done,
     /* 1496025 */   // Label 20872: @1496025
     /* 1496025 */   GIM_Try, /*On fail goto*//*Label 20873*/ GIMT_Encode4(1496122), // Rule ID 61128 //
     /* 1496030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1496041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1496044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1496047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496080 */     // MIs[1] Operand 1
     /* 1496080 */     // No operand predicates
     /* 1496080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496084 */     // MIs[0] policy
     /* 1496084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496096 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1496099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496121 */     // GIR_Coverage, 61128,
     /* 1496121 */     GIR_EraseRootFromParent_Done,
     /* 1496122 */   // Label 20873: @1496122
     /* 1496122 */   GIM_Try, /*On fail goto*//*Label 20874*/ GIMT_Encode4(1496219), // Rule ID 61129 //
     /* 1496127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1496138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1496141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1496144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496177 */     // MIs[1] Operand 1
     /* 1496177 */     // No operand predicates
     /* 1496177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496181 */     // MIs[0] policy
     /* 1496181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496193 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1496196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496218 */     // GIR_Coverage, 61129,
     /* 1496218 */     GIR_EraseRootFromParent_Done,
     /* 1496219 */   // Label 20874: @1496219
     /* 1496219 */   GIM_Try, /*On fail goto*//*Label 20875*/ GIMT_Encode4(1496316), // Rule ID 61136 //
     /* 1496224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1496235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1496238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1496241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496274 */     // MIs[1] Operand 1
     /* 1496274 */     // No operand predicates
     /* 1496274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496278 */     // MIs[0] policy
     /* 1496278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1496293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496315 */     // GIR_Coverage, 61136,
     /* 1496315 */     GIR_EraseRootFromParent_Done,
     /* 1496316 */   // Label 20875: @1496316
     /* 1496316 */   GIM_Try, /*On fail goto*//*Label 20876*/ GIMT_Encode4(1496413), // Rule ID 61137 //
     /* 1496321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1496332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1496335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1496338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496371 */     // MIs[1] Operand 1
     /* 1496371 */     // No operand predicates
     /* 1496371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496375 */     // MIs[0] policy
     /* 1496375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496387 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1496390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496412 */     // GIR_Coverage, 61137,
     /* 1496412 */     GIR_EraseRootFromParent_Done,
     /* 1496413 */   // Label 20876: @1496413
     /* 1496413 */   GIM_Try, /*On fail goto*//*Label 20877*/ GIMT_Encode4(1496510), // Rule ID 61144 //
     /* 1496418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1496429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1496432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1496435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496464 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496468 */     // MIs[1] Operand 1
     /* 1496468 */     // No operand predicates
     /* 1496468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496472 */     // MIs[0] policy
     /* 1496472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1496487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496509 */     // GIR_Coverage, 61144,
     /* 1496509 */     GIR_EraseRootFromParent_Done,
     /* 1496510 */   // Label 20877: @1496510
     /* 1496510 */   GIM_Try, /*On fail goto*//*Label 20878*/ GIMT_Encode4(1496607), // Rule ID 61145 //
     /* 1496515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1496526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1496529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1496532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496565 */     // MIs[1] Operand 1
     /* 1496565 */     // No operand predicates
     /* 1496565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496569 */     // MIs[0] policy
     /* 1496569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496581 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1496584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496606 */     // GIR_Coverage, 61145,
     /* 1496606 */     GIR_EraseRootFromParent_Done,
     /* 1496607 */   // Label 20878: @1496607
     /* 1496607 */   GIM_Try, /*On fail goto*//*Label 20879*/ GIMT_Encode4(1496704), // Rule ID 61152 //
     /* 1496612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1496623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1496626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1496629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1496635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1496642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496662 */     // MIs[1] Operand 1
     /* 1496662 */     // No operand predicates
     /* 1496662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496666 */     // MIs[0] policy
     /* 1496666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496678 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1496681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496703 */     // GIR_Coverage, 61152,
     /* 1496703 */     GIR_EraseRootFromParent_Done,
     /* 1496704 */   // Label 20879: @1496704
     /* 1496704 */   GIM_Try, /*On fail goto*//*Label 20880*/ GIMT_Encode4(1496801), // Rule ID 61153 //
     /* 1496709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1496720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1496723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1496726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1496732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1496739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496759 */     // MIs[1] Operand 1
     /* 1496759 */     // No operand predicates
     /* 1496759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496763 */     // MIs[0] policy
     /* 1496763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496775 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1496778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496800 */     // GIR_Coverage, 61153,
     /* 1496800 */     GIR_EraseRootFromParent_Done,
     /* 1496801 */   // Label 20880: @1496801
     /* 1496801 */   GIM_Try, /*On fail goto*//*Label 20881*/ GIMT_Encode4(1496898), // Rule ID 62008 //
     /* 1496806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1496809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1496817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1496820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1496823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496856 */     // MIs[1] Operand 1
     /* 1496856 */     // No operand predicates
     /* 1496856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496860 */     // MIs[0] policy
     /* 1496860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496872 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1496875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496897 */     // GIR_Coverage, 62008,
     /* 1496897 */     GIR_EraseRootFromParent_Done,
     /* 1496898 */   // Label 20881: @1496898
     /* 1496898 */   GIM_Try, /*On fail goto*//*Label 20882*/ GIMT_Encode4(1496995), // Rule ID 62009 //
     /* 1496903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1496906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1496914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1496917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1496920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496953 */     // MIs[1] Operand 1
     /* 1496953 */     // No operand predicates
     /* 1496953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496957 */     // MIs[0] policy
     /* 1496957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496969 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1496972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496994 */     // GIR_Coverage, 62009,
     /* 1496994 */     GIR_EraseRootFromParent_Done,
     /* 1496995 */   // Label 20882: @1496995
     /* 1496995 */   GIM_Try, /*On fail goto*//*Label 20883*/ GIMT_Encode4(1497092), // Rule ID 62012 //
     /* 1497000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1497011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1497014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1497017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497050 */     // MIs[1] Operand 1
     /* 1497050 */     // No operand predicates
     /* 1497050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497054 */     // MIs[0] policy
     /* 1497054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497066 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497091 */     // GIR_Coverage, 62012,
     /* 1497091 */     GIR_EraseRootFromParent_Done,
     /* 1497092 */   // Label 20883: @1497092
     /* 1497092 */   GIM_Try, /*On fail goto*//*Label 20884*/ GIMT_Encode4(1497189), // Rule ID 62013 //
     /* 1497097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1497108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1497111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1497114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497147 */     // MIs[1] Operand 1
     /* 1497147 */     // No operand predicates
     /* 1497147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497151 */     // MIs[0] policy
     /* 1497151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497163 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497188 */     // GIR_Coverage, 62013,
     /* 1497188 */     GIR_EraseRootFromParent_Done,
     /* 1497189 */   // Label 20884: @1497189
     /* 1497189 */   GIM_Try, /*On fail goto*//*Label 20885*/ GIMT_Encode4(1497286), // Rule ID 62016 //
     /* 1497194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1497205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1497208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1497211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497244 */     // MIs[1] Operand 1
     /* 1497244 */     // No operand predicates
     /* 1497244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497248 */     // MIs[0] policy
     /* 1497248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497260 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497285 */     // GIR_Coverage, 62016,
     /* 1497285 */     GIR_EraseRootFromParent_Done,
     /* 1497286 */   // Label 20885: @1497286
     /* 1497286 */   GIM_Try, /*On fail goto*//*Label 20886*/ GIMT_Encode4(1497383), // Rule ID 62017 //
     /* 1497291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1497302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1497305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1497308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497341 */     // MIs[1] Operand 1
     /* 1497341 */     // No operand predicates
     /* 1497341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497345 */     // MIs[0] policy
     /* 1497345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497357 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497382 */     // GIR_Coverage, 62017,
     /* 1497382 */     GIR_EraseRootFromParent_Done,
     /* 1497383 */   // Label 20886: @1497383
     /* 1497383 */   GIM_Try, /*On fail goto*//*Label 20887*/ GIMT_Encode4(1497480), // Rule ID 62020 //
     /* 1497388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1497405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497438 */     // MIs[1] Operand 1
     /* 1497438 */     // No operand predicates
     /* 1497438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497442 */     // MIs[0] policy
     /* 1497442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497454 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497479 */     // GIR_Coverage, 62020,
     /* 1497479 */     GIR_EraseRootFromParent_Done,
     /* 1497480 */   // Label 20887: @1497480
     /* 1497480 */   GIM_Try, /*On fail goto*//*Label 20888*/ GIMT_Encode4(1497577), // Rule ID 62021 //
     /* 1497485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1497502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497535 */     // MIs[1] Operand 1
     /* 1497535 */     // No operand predicates
     /* 1497535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497539 */     // MIs[0] policy
     /* 1497539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497551 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497576 */     // GIR_Coverage, 62021,
     /* 1497576 */     GIR_EraseRootFromParent_Done,
     /* 1497577 */   // Label 20888: @1497577
     /* 1497577 */   GIM_Try, /*On fail goto*//*Label 20889*/ GIMT_Encode4(1497674), // Rule ID 62024 //
     /* 1497582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1497593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1497596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1497599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497632 */     // MIs[1] Operand 1
     /* 1497632 */     // No operand predicates
     /* 1497632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497636 */     // MIs[0] policy
     /* 1497636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497648 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497673 */     // GIR_Coverage, 62024,
     /* 1497673 */     GIR_EraseRootFromParent_Done,
     /* 1497674 */   // Label 20889: @1497674
     /* 1497674 */   GIM_Try, /*On fail goto*//*Label 20890*/ GIMT_Encode4(1497771), // Rule ID 62025 //
     /* 1497679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1497690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1497693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1497696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497729 */     // MIs[1] Operand 1
     /* 1497729 */     // No operand predicates
     /* 1497729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497733 */     // MIs[0] policy
     /* 1497733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497745 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497770 */     // GIR_Coverage, 62025,
     /* 1497770 */     GIR_EraseRootFromParent_Done,
     /* 1497771 */   // Label 20890: @1497771
     /* 1497771 */   GIM_Try, /*On fail goto*//*Label 20891*/ GIMT_Encode4(1497868), // Rule ID 62028 //
     /* 1497776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1497787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1497790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1497793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497826 */     // MIs[1] Operand 1
     /* 1497826 */     // No operand predicates
     /* 1497826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497830 */     // MIs[0] policy
     /* 1497830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497842 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497867 */     // GIR_Coverage, 62028,
     /* 1497867 */     GIR_EraseRootFromParent_Done,
     /* 1497868 */   // Label 20891: @1497868
     /* 1497868 */   GIM_Try, /*On fail goto*//*Label 20892*/ GIMT_Encode4(1497965), // Rule ID 62029 //
     /* 1497873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1497884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1497887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1497890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497923 */     // MIs[1] Operand 1
     /* 1497923 */     // No operand predicates
     /* 1497923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497927 */     // MIs[0] policy
     /* 1497927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497939 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497964 */     // GIR_Coverage, 62029,
     /* 1497964 */     GIR_EraseRootFromParent_Done,
     /* 1497965 */   // Label 20892: @1497965
     /* 1497965 */   GIM_Try, /*On fail goto*//*Label 20893*/ GIMT_Encode4(1498062), // Rule ID 62032 //
     /* 1497970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1497981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1497984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1497987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498020 */     // MIs[1] Operand 1
     /* 1498020 */     // No operand predicates
     /* 1498020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498024 */     // MIs[0] policy
     /* 1498024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498036 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498061 */     // GIR_Coverage, 62032,
     /* 1498061 */     GIR_EraseRootFromParent_Done,
     /* 1498062 */   // Label 20893: @1498062
     /* 1498062 */   GIM_Try, /*On fail goto*//*Label 20894*/ GIMT_Encode4(1498159), // Rule ID 62033 //
     /* 1498067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1498078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1498081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1498084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1498090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498117 */     // MIs[1] Operand 1
     /* 1498117 */     // No operand predicates
     /* 1498117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498121 */     // MIs[0] policy
     /* 1498121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498133 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498158 */     // GIR_Coverage, 62033,
     /* 1498158 */     GIR_EraseRootFromParent_Done,
     /* 1498159 */   // Label 20894: @1498159
     /* 1498159 */   GIM_Try, /*On fail goto*//*Label 20895*/ GIMT_Encode4(1498256), // Rule ID 62036 //
     /* 1498164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1498175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1498178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1498181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1498187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498214 */     // MIs[1] Operand 1
     /* 1498214 */     // No operand predicates
     /* 1498214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498218 */     // MIs[0] policy
     /* 1498218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498230 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498255 */     // GIR_Coverage, 62036,
     /* 1498255 */     GIR_EraseRootFromParent_Done,
     /* 1498256 */   // Label 20895: @1498256
     /* 1498256 */   GIM_Try, /*On fail goto*//*Label 20896*/ GIMT_Encode4(1498353), // Rule ID 62037 //
     /* 1498261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1498272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1498275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1498278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1498284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498311 */     // MIs[1] Operand 1
     /* 1498311 */     // No operand predicates
     /* 1498311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498315 */     // MIs[0] policy
     /* 1498315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498352 */     // GIR_Coverage, 62037,
     /* 1498352 */     GIR_EraseRootFromParent_Done,
     /* 1498353 */   // Label 20896: @1498353
     /* 1498353 */   GIM_Try, /*On fail goto*//*Label 20897*/ GIMT_Encode4(1498450), // Rule ID 62040 //
     /* 1498358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1498369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1498372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1498375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498408 */     // MIs[1] Operand 1
     /* 1498408 */     // No operand predicates
     /* 1498408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498412 */     // MIs[0] policy
     /* 1498412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498424 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498449 */     // GIR_Coverage, 62040,
     /* 1498449 */     GIR_EraseRootFromParent_Done,
     /* 1498450 */   // Label 20897: @1498450
     /* 1498450 */   GIM_Try, /*On fail goto*//*Label 20898*/ GIMT_Encode4(1498547), // Rule ID 62041 //
     /* 1498455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1498466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1498469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1498472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498505 */     // MIs[1] Operand 1
     /* 1498505 */     // No operand predicates
     /* 1498505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498509 */     // MIs[0] policy
     /* 1498509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498521 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498546 */     // GIR_Coverage, 62041,
     /* 1498546 */     GIR_EraseRootFromParent_Done,
     /* 1498547 */   // Label 20898: @1498547
     /* 1498547 */   GIM_Try, /*On fail goto*//*Label 20899*/ GIMT_Encode4(1498644), // Rule ID 62044 //
     /* 1498552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1498563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1498566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1498569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1498575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498602 */     // MIs[1] Operand 1
     /* 1498602 */     // No operand predicates
     /* 1498602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498606 */     // MIs[0] policy
     /* 1498606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498618 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498643 */     // GIR_Coverage, 62044,
     /* 1498643 */     GIR_EraseRootFromParent_Done,
     /* 1498644 */   // Label 20899: @1498644
     /* 1498644 */   GIM_Try, /*On fail goto*//*Label 20900*/ GIMT_Encode4(1498741), // Rule ID 62045 //
     /* 1498649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1498660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1498663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1498666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1498672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498699 */     // MIs[1] Operand 1
     /* 1498699 */     // No operand predicates
     /* 1498699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498703 */     // MIs[0] policy
     /* 1498703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498715 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498740 */     // GIR_Coverage, 62045,
     /* 1498740 */     GIR_EraseRootFromParent_Done,
     /* 1498741 */   // Label 20900: @1498741
     /* 1498741 */   GIM_Try, /*On fail goto*//*Label 20901*/ GIMT_Encode4(1498838), // Rule ID 62048 //
     /* 1498746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1498757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1498760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1498763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1498769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1498776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498796 */     // MIs[1] Operand 1
     /* 1498796 */     // No operand predicates
     /* 1498796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498800 */     // MIs[0] policy
     /* 1498800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498812 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1498815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498837 */     // GIR_Coverage, 62048,
     /* 1498837 */     GIR_EraseRootFromParent_Done,
     /* 1498838 */   // Label 20901: @1498838
     /* 1498838 */   GIM_Try, /*On fail goto*//*Label 20902*/ GIMT_Encode4(1498935), // Rule ID 62049 //
     /* 1498843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1498854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1498857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1498860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1498866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1498873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498893 */     // MIs[1] Operand 1
     /* 1498893 */     // No operand predicates
     /* 1498893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498897 */     // MIs[0] policy
     /* 1498897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498909 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1498912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498934 */     // GIR_Coverage, 62049,
     /* 1498934 */     GIR_EraseRootFromParent_Done,
     /* 1498935 */   // Label 20902: @1498935
     /* 1498935 */   GIM_Try, /*On fail goto*//*Label 20903*/ GIMT_Encode4(1499032), // Rule ID 62052 //
     /* 1498940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1498951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1498954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1498957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1498963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1498970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498990 */     // MIs[1] Operand 1
     /* 1498990 */     // No operand predicates
     /* 1498990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498994 */     // MIs[0] policy
     /* 1498994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499006 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1499009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499031 */     // GIR_Coverage, 62052,
     /* 1499031 */     GIR_EraseRootFromParent_Done,
     /* 1499032 */   // Label 20903: @1499032
     /* 1499032 */   GIM_Try, /*On fail goto*//*Label 20904*/ GIMT_Encode4(1499129), // Rule ID 62053 //
     /* 1499037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1499048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1499051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1499054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1499060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499087 */     // MIs[1] Operand 1
     /* 1499087 */     // No operand predicates
     /* 1499087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499091 */     // MIs[0] policy
     /* 1499091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499103 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1499106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499128 */     // GIR_Coverage, 62053,
     /* 1499128 */     GIR_EraseRootFromParent_Done,
     /* 1499129 */   // Label 20904: @1499129
     /* 1499129 */   GIM_Try, /*On fail goto*//*Label 20905*/ GIMT_Encode4(1499226), // Rule ID 62056 //
     /* 1499134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1499145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1499148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1499151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1499157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499184 */     // MIs[1] Operand 1
     /* 1499184 */     // No operand predicates
     /* 1499184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499188 */     // MIs[0] policy
     /* 1499188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499200 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1499203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499225 */     // GIR_Coverage, 62056,
     /* 1499225 */     GIR_EraseRootFromParent_Done,
     /* 1499226 */   // Label 20905: @1499226
     /* 1499226 */   GIM_Try, /*On fail goto*//*Label 20906*/ GIMT_Encode4(1499323), // Rule ID 62057 //
     /* 1499231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1499242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1499245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1499248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1499254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499281 */     // MIs[1] Operand 1
     /* 1499281 */     // No operand predicates
     /* 1499281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499285 */     // MIs[0] policy
     /* 1499285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499297 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1499300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499322 */     // GIR_Coverage, 62057,
     /* 1499322 */     GIR_EraseRootFromParent_Done,
     /* 1499323 */   // Label 20906: @1499323
     /* 1499323 */   GIM_Try, /*On fail goto*//*Label 20907*/ GIMT_Encode4(1499420), // Rule ID 62060 //
     /* 1499328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1499339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1499342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1499345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1499351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499378 */     // MIs[1] Operand 1
     /* 1499378 */     // No operand predicates
     /* 1499378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499382 */     // MIs[0] policy
     /* 1499382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499394 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499419 */     // GIR_Coverage, 62060,
     /* 1499419 */     GIR_EraseRootFromParent_Done,
     /* 1499420 */   // Label 20907: @1499420
     /* 1499420 */   GIM_Try, /*On fail goto*//*Label 20908*/ GIMT_Encode4(1499517), // Rule ID 62061 //
     /* 1499425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1499436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1499439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1499442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1499448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499475 */     // MIs[1] Operand 1
     /* 1499475 */     // No operand predicates
     /* 1499475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499479 */     // MIs[0] policy
     /* 1499479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499491 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499516 */     // GIR_Coverage, 62061,
     /* 1499516 */     GIR_EraseRootFromParent_Done,
     /* 1499517 */   // Label 20908: @1499517
     /* 1499517 */   GIM_Try, /*On fail goto*//*Label 20909*/ GIMT_Encode4(1499614), // Rule ID 62064 //
     /* 1499522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1499533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1499536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1499539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499572 */     // MIs[1] Operand 1
     /* 1499572 */     // No operand predicates
     /* 1499572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499576 */     // MIs[0] policy
     /* 1499576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499588 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1499591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499613 */     // GIR_Coverage, 62064,
     /* 1499613 */     GIR_EraseRootFromParent_Done,
     /* 1499614 */   // Label 20909: @1499614
     /* 1499614 */   GIM_Try, /*On fail goto*//*Label 20910*/ GIMT_Encode4(1499711), // Rule ID 62065 //
     /* 1499619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1499630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1499633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1499636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499669 */     // MIs[1] Operand 1
     /* 1499669 */     // No operand predicates
     /* 1499669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499673 */     // MIs[0] policy
     /* 1499673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499685 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1499688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499710 */     // GIR_Coverage, 62065,
     /* 1499710 */     GIR_EraseRootFromParent_Done,
     /* 1499711 */   // Label 20910: @1499711
     /* 1499711 */   GIM_Try, /*On fail goto*//*Label 20911*/ GIMT_Encode4(1499808), // Rule ID 62068 //
     /* 1499716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1499727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1499730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1499733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1499739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499766 */     // MIs[1] Operand 1
     /* 1499766 */     // No operand predicates
     /* 1499766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499770 */     // MIs[0] policy
     /* 1499770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499782 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1499785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499807 */     // GIR_Coverage, 62068,
     /* 1499807 */     GIR_EraseRootFromParent_Done,
     /* 1499808 */   // Label 20911: @1499808
     /* 1499808 */   GIM_Try, /*On fail goto*//*Label 20912*/ GIMT_Encode4(1499905), // Rule ID 62069 //
     /* 1499813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1499824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1499827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1499830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1499836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499863 */     // MIs[1] Operand 1
     /* 1499863 */     // No operand predicates
     /* 1499863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499867 */     // MIs[0] policy
     /* 1499867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499879 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1499882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499904 */     // GIR_Coverage, 62069,
     /* 1499904 */     GIR_EraseRootFromParent_Done,
     /* 1499905 */   // Label 20912: @1499905
     /* 1499905 */   GIM_Try, /*On fail goto*//*Label 20913*/ GIMT_Encode4(1500002), // Rule ID 62072 //
     /* 1499910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1499921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1499924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1499927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1499933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499960 */     // MIs[1] Operand 1
     /* 1499960 */     // No operand predicates
     /* 1499960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499964 */     // MIs[0] policy
     /* 1499964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499976 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500001 */     // GIR_Coverage, 62072,
     /* 1500001 */     GIR_EraseRootFromParent_Done,
     /* 1500002 */   // Label 20913: @1500002
     /* 1500002 */   GIM_Try, /*On fail goto*//*Label 20914*/ GIMT_Encode4(1500099), // Rule ID 62073 //
     /* 1500007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1500018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1500021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1500024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500057 */     // MIs[1] Operand 1
     /* 1500057 */     // No operand predicates
     /* 1500057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500061 */     // MIs[0] policy
     /* 1500061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500073 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1500076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500098 */     // GIR_Coverage, 62073,
     /* 1500098 */     GIR_EraseRootFromParent_Done,
     /* 1500099 */   // Label 20914: @1500099
     /* 1500099 */   GIM_Try, /*On fail goto*//*Label 20915*/ GIMT_Encode4(1500196), // Rule ID 62076 //
     /* 1500104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1500115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1500118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1500121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500154 */     // MIs[1] Operand 1
     /* 1500154 */     // No operand predicates
     /* 1500154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500158 */     // MIs[0] policy
     /* 1500158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500170 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500195 */     // GIR_Coverage, 62076,
     /* 1500195 */     GIR_EraseRootFromParent_Done,
     /* 1500196 */   // Label 20915: @1500196
     /* 1500196 */   GIM_Try, /*On fail goto*//*Label 20916*/ GIMT_Encode4(1500293), // Rule ID 62077 //
     /* 1500201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1500212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1500215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1500218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500251 */     // MIs[1] Operand 1
     /* 1500251 */     // No operand predicates
     /* 1500251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500255 */     // MIs[0] policy
     /* 1500255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500267 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500292 */     // GIR_Coverage, 62077,
     /* 1500292 */     GIR_EraseRootFromParent_Done,
     /* 1500293 */   // Label 20916: @1500293
     /* 1500293 */   GIM_Try, /*On fail goto*//*Label 20917*/ GIMT_Encode4(1500390), // Rule ID 62080 //
     /* 1500298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1500309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1500312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1500315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1500321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500348 */     // MIs[1] Operand 1
     /* 1500348 */     // No operand predicates
     /* 1500348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500352 */     // MIs[0] policy
     /* 1500352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500389 */     // GIR_Coverage, 62080,
     /* 1500389 */     GIR_EraseRootFromParent_Done,
     /* 1500390 */   // Label 20917: @1500390
     /* 1500390 */   GIM_Try, /*On fail goto*//*Label 20918*/ GIMT_Encode4(1500487), // Rule ID 62081 //
     /* 1500395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1500406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1500409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1500412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1500418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500445 */     // MIs[1] Operand 1
     /* 1500445 */     // No operand predicates
     /* 1500445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500449 */     // MIs[0] policy
     /* 1500449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500461 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500486 */     // GIR_Coverage, 62081,
     /* 1500486 */     GIR_EraseRootFromParent_Done,
     /* 1500487 */   // Label 20918: @1500487
     /* 1500487 */   GIM_Try, /*On fail goto*//*Label 20919*/ GIMT_Encode4(1500584), // Rule ID 62084 //
     /* 1500492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1500503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1500506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1500509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1500515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500542 */     // MIs[1] Operand 1
     /* 1500542 */     // No operand predicates
     /* 1500542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500546 */     // MIs[0] policy
     /* 1500546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500558 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1500561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500583 */     // GIR_Coverage, 62084,
     /* 1500583 */     GIR_EraseRootFromParent_Done,
     /* 1500584 */   // Label 20919: @1500584
     /* 1500584 */   GIM_Try, /*On fail goto*//*Label 20920*/ GIMT_Encode4(1500681), // Rule ID 62085 //
     /* 1500589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1500600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1500603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1500606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1500612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500639 */     // MIs[1] Operand 1
     /* 1500639 */     // No operand predicates
     /* 1500639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500643 */     // MIs[0] policy
     /* 1500643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500655 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1500658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500680 */     // GIR_Coverage, 62085,
     /* 1500680 */     GIR_EraseRootFromParent_Done,
     /* 1500681 */   // Label 20920: @1500681
     /* 1500681 */   GIM_Try, /*On fail goto*//*Label 20921*/ GIMT_Encode4(1500778), // Rule ID 62088 //
     /* 1500686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1500697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1500700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1500703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500736 */     // MIs[1] Operand 1
     /* 1500736 */     // No operand predicates
     /* 1500736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500740 */     // MIs[0] policy
     /* 1500740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500752 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500777 */     // GIR_Coverage, 62088,
     /* 1500777 */     GIR_EraseRootFromParent_Done,
     /* 1500778 */   // Label 20921: @1500778
     /* 1500778 */   GIM_Try, /*On fail goto*//*Label 20922*/ GIMT_Encode4(1500875), // Rule ID 62089 //
     /* 1500783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1500794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1500797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1500800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500833 */     // MIs[1] Operand 1
     /* 1500833 */     // No operand predicates
     /* 1500833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500837 */     // MIs[0] policy
     /* 1500837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500849 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500874 */     // GIR_Coverage, 62089,
     /* 1500874 */     GIR_EraseRootFromParent_Done,
     /* 1500875 */   // Label 20922: @1500875
     /* 1500875 */   GIM_Try, /*On fail goto*//*Label 20923*/ GIMT_Encode4(1500972), // Rule ID 62092 //
     /* 1500880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1500891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1500894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1500897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500930 */     // MIs[1] Operand 1
     /* 1500930 */     // No operand predicates
     /* 1500930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500934 */     // MIs[0] policy
     /* 1500934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500971 */     // GIR_Coverage, 62092,
     /* 1500971 */     GIR_EraseRootFromParent_Done,
     /* 1500972 */   // Label 20923: @1500972
     /* 1500972 */   GIM_Try, /*On fail goto*//*Label 20924*/ GIMT_Encode4(1501069), // Rule ID 62093 //
     /* 1500977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1500988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1500991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1500994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1501000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1501007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501027 */     // MIs[1] Operand 1
     /* 1501027 */     // No operand predicates
     /* 1501027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501031 */     // MIs[0] policy
     /* 1501031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1501046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501068 */     // GIR_Coverage, 62093,
     /* 1501068 */     GIR_EraseRootFromParent_Done,
     /* 1501069 */   // Label 20924: @1501069
     /* 1501069 */   GIM_Try, /*On fail goto*//*Label 20925*/ GIMT_Encode4(1501151), // Rule ID 2712 //
     /* 1501074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1501082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501113 */     // MIs[0] round
     /* 1501113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501116 */     // MIs[0] policy
     /* 1501116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501126 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1501129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501150 */     // GIR_Coverage, 2712,
     /* 1501150 */     GIR_EraseRootFromParent_Done,
     /* 1501151 */   // Label 20925: @1501151
     /* 1501151 */   GIM_Try, /*On fail goto*//*Label 20926*/ GIMT_Encode4(1501233), // Rule ID 2713 //
     /* 1501156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1501164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501195 */     // MIs[0] round
     /* 1501195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501198 */     // MIs[0] policy
     /* 1501198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501208 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1501211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501232 */     // GIR_Coverage, 2713,
     /* 1501232 */     GIR_EraseRootFromParent_Done,
     /* 1501233 */   // Label 20926: @1501233
     /* 1501233 */   GIM_Try, /*On fail goto*//*Label 20927*/ GIMT_Encode4(1501315), // Rule ID 2748 //
     /* 1501238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1501241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1501246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501277 */     // MIs[0] round
     /* 1501277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501280 */     // MIs[0] policy
     /* 1501280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501290 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1501293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501314 */     // GIR_Coverage, 2748,
     /* 1501314 */     GIR_EraseRootFromParent_Done,
     /* 1501315 */   // Label 20927: @1501315
     /* 1501315 */   GIM_Try, /*On fail goto*//*Label 20928*/ GIMT_Encode4(1501397), // Rule ID 2749 //
     /* 1501320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1501323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1501328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501359 */     // MIs[0] round
     /* 1501359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501362 */     // MIs[0] policy
     /* 1501362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501372 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1501375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501396 */     // GIR_Coverage, 2749,
     /* 1501396 */     GIR_EraseRootFromParent_Done,
     /* 1501397 */   // Label 20928: @1501397
     /* 1501397 */   GIM_Try, /*On fail goto*//*Label 20929*/ GIMT_Encode4(1501479), // Rule ID 2780 //
     /* 1501402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1501422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501441 */     // MIs[0] round
     /* 1501441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501444 */     // MIs[0] policy
     /* 1501444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501454 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1501457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501478 */     // GIR_Coverage, 2780,
     /* 1501478 */     GIR_EraseRootFromParent_Done,
     /* 1501479 */   // Label 20929: @1501479
     /* 1501479 */   GIM_Try, /*On fail goto*//*Label 20930*/ GIMT_Encode4(1501561), // Rule ID 2781 //
     /* 1501484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1501504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501523 */     // MIs[0] round
     /* 1501523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501526 */     // MIs[0] policy
     /* 1501526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501536 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1501539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501560 */     // GIR_Coverage, 2781,
     /* 1501560 */     GIR_EraseRootFromParent_Done,
     /* 1501561 */   // Label 20930: @1501561
     /* 1501561 */   GIM_Try, /*On fail goto*//*Label 20931*/ GIMT_Encode4(1501643), // Rule ID 17760 //
     /* 1501566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1501577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1501580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1501583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1501586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501605 */     // MIs[0] round
     /* 1501605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501608 */     // MIs[0] policy
     /* 1501608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501618 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1501621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501642 */     // GIR_Coverage, 17760,
     /* 1501642 */     GIR_EraseRootFromParent_Done,
     /* 1501643 */   // Label 20931: @1501643
     /* 1501643 */   GIM_Try, /*On fail goto*//*Label 20932*/ GIMT_Encode4(1501725), // Rule ID 17761 //
     /* 1501648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1501659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1501662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1501665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1501668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501687 */     // MIs[0] round
     /* 1501687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501690 */     // MIs[0] policy
     /* 1501690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501700 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1501703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501724 */     // GIR_Coverage, 17761,
     /* 1501724 */     GIR_EraseRootFromParent_Done,
     /* 1501725 */   // Label 20932: @1501725
     /* 1501725 */   GIM_Try, /*On fail goto*//*Label 20933*/ GIMT_Encode4(1501807), // Rule ID 17764 //
     /* 1501730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1501733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1501741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1501744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1501747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1501750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501769 */     // MIs[0] round
     /* 1501769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501772 */     // MIs[0] policy
     /* 1501772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501782 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1501785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501806 */     // GIR_Coverage, 17764,
     /* 1501806 */     GIR_EraseRootFromParent_Done,
     /* 1501807 */   // Label 20933: @1501807
     /* 1501807 */   GIM_Try, /*On fail goto*//*Label 20934*/ GIMT_Encode4(1501889), // Rule ID 17765 //
     /* 1501812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1501815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1501823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1501826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1501829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1501832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501851 */     // MIs[0] round
     /* 1501851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501854 */     // MIs[0] policy
     /* 1501854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501864 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1501867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501888 */     // GIR_Coverage, 17765,
     /* 1501888 */     GIR_EraseRootFromParent_Done,
     /* 1501889 */   // Label 20934: @1501889
     /* 1501889 */   GIM_Try, /*On fail goto*//*Label 20935*/ GIMT_Encode4(1501971), // Rule ID 17768 //
     /* 1501894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1501905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1501908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1501911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1501914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501933 */     // MIs[0] round
     /* 1501933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501936 */     // MIs[0] policy
     /* 1501936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501946 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1501949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501970 */     // GIR_Coverage, 17768,
     /* 1501970 */     GIR_EraseRootFromParent_Done,
     /* 1501971 */   // Label 20935: @1501971
     /* 1501971 */   GIM_Try, /*On fail goto*//*Label 20936*/ GIMT_Encode4(1502053), // Rule ID 17769 //
     /* 1501976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1501987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1501990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1501993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1501996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502015 */     // MIs[0] round
     /* 1502015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502018 */     // MIs[0] policy
     /* 1502018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502028 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1502031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502052 */     // GIR_Coverage, 17769,
     /* 1502052 */     GIR_EraseRootFromParent_Done,
     /* 1502053 */   // Label 20936: @1502053
     /* 1502053 */   GIM_Try, /*On fail goto*//*Label 20937*/ GIMT_Encode4(1502135), // Rule ID 17772 //
     /* 1502058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1502061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1502075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1502078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502097 */     // MIs[0] round
     /* 1502097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502100 */     // MIs[0] policy
     /* 1502100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502110 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1502113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502134 */     // GIR_Coverage, 17772,
     /* 1502134 */     GIR_EraseRootFromParent_Done,
     /* 1502135 */   // Label 20937: @1502135
     /* 1502135 */   GIM_Try, /*On fail goto*//*Label 20938*/ GIMT_Encode4(1502217), // Rule ID 17773 //
     /* 1502140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1502143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1502157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1502160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502179 */     // MIs[0] round
     /* 1502179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502182 */     // MIs[0] policy
     /* 1502182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502192 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1502195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502216 */     // GIR_Coverage, 17773,
     /* 1502216 */     GIR_EraseRootFromParent_Done,
     /* 1502217 */   // Label 20938: @1502217
     /* 1502217 */   GIM_Try, /*On fail goto*//*Label 20939*/ GIMT_Encode4(1502299), // Rule ID 17776 //
     /* 1502222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1502225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1502233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1502236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1502239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1502242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502261 */     // MIs[0] round
     /* 1502261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502264 */     // MIs[0] policy
     /* 1502264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502274 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1502277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502298 */     // GIR_Coverage, 17776,
     /* 1502298 */     GIR_EraseRootFromParent_Done,
     /* 1502299 */   // Label 20939: @1502299
     /* 1502299 */   GIM_Try, /*On fail goto*//*Label 20940*/ GIMT_Encode4(1502381), // Rule ID 17777 //
     /* 1502304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1502307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1502315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1502318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1502321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1502324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502343 */     // MIs[0] round
     /* 1502343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502346 */     // MIs[0] policy
     /* 1502346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502356 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1502359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502380 */     // GIR_Coverage, 17777,
     /* 1502380 */     GIR_EraseRootFromParent_Done,
     /* 1502381 */   // Label 20940: @1502381
     /* 1502381 */   GIM_Try, /*On fail goto*//*Label 20941*/ GIMT_Encode4(1502463), // Rule ID 17780 //
     /* 1502386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1502397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1502400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1502403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1502406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502425 */     // MIs[0] round
     /* 1502425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502428 */     // MIs[0] policy
     /* 1502428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502438 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1502441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502462 */     // GIR_Coverage, 17780,
     /* 1502462 */     GIR_EraseRootFromParent_Done,
     /* 1502463 */   // Label 20941: @1502463
     /* 1502463 */   GIM_Try, /*On fail goto*//*Label 20942*/ GIMT_Encode4(1502545), // Rule ID 17781 //
     /* 1502468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1502479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1502482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1502485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1502488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502507 */     // MIs[0] round
     /* 1502507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502510 */     // MIs[0] policy
     /* 1502510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502520 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1502523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502544 */     // GIR_Coverage, 17781,
     /* 1502544 */     GIR_EraseRootFromParent_Done,
     /* 1502545 */   // Label 20942: @1502545
     /* 1502545 */   GIM_Try, /*On fail goto*//*Label 20943*/ GIMT_Encode4(1502627), // Rule ID 17784 //
     /* 1502550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1502561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1502564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1502567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1502570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502589 */     // MIs[0] round
     /* 1502589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502592 */     // MIs[0] policy
     /* 1502592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502602 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1502605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502626 */     // GIR_Coverage, 17784,
     /* 1502626 */     GIR_EraseRootFromParent_Done,
     /* 1502627 */   // Label 20943: @1502627
     /* 1502627 */   GIM_Try, /*On fail goto*//*Label 20944*/ GIMT_Encode4(1502709), // Rule ID 17785 //
     /* 1502632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1502643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1502646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1502649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1502652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502671 */     // MIs[0] round
     /* 1502671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502674 */     // MIs[0] policy
     /* 1502674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502684 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1502687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502708 */     // GIR_Coverage, 17785,
     /* 1502708 */     GIR_EraseRootFromParent_Done,
     /* 1502709 */   // Label 20944: @1502709
     /* 1502709 */   GIM_Try, /*On fail goto*//*Label 20945*/ GIMT_Encode4(1502791), // Rule ID 17788 //
     /* 1502714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1502725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1502728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1502731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1502734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502753 */     // MIs[0] round
     /* 1502753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502756 */     // MIs[0] policy
     /* 1502756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502766 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1502769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502790 */     // GIR_Coverage, 17788,
     /* 1502790 */     GIR_EraseRootFromParent_Done,
     /* 1502791 */   // Label 20945: @1502791
     /* 1502791 */   GIM_Try, /*On fail goto*//*Label 20946*/ GIMT_Encode4(1502873), // Rule ID 17789 //
     /* 1502796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1502807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1502810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1502813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1502816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502835 */     // MIs[0] round
     /* 1502835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502838 */     // MIs[0] policy
     /* 1502838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502848 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1502851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502872 */     // GIR_Coverage, 17789,
     /* 1502872 */     GIR_EraseRootFromParent_Done,
     /* 1502873 */   // Label 20946: @1502873
     /* 1502873 */   GIM_Try, /*On fail goto*//*Label 20947*/ GIMT_Encode4(1502955), // Rule ID 17792 //
     /* 1502878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1502881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1502889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1502892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1502895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1502898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502917 */     // MIs[0] round
     /* 1502917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502920 */     // MIs[0] policy
     /* 1502920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502930 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1502933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502954 */     // GIR_Coverage, 17792,
     /* 1502954 */     GIR_EraseRootFromParent_Done,
     /* 1502955 */   // Label 20947: @1502955
     /* 1502955 */   GIM_Try, /*On fail goto*//*Label 20948*/ GIMT_Encode4(1503037), // Rule ID 17793 //
     /* 1502960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1502963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1502971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1502974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1502977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1502980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502999 */     // MIs[0] round
     /* 1502999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503002 */     // MIs[0] policy
     /* 1503002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503012 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1503015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503036 */     // GIR_Coverage, 17793,
     /* 1503036 */     GIR_EraseRootFromParent_Done,
     /* 1503037 */   // Label 20948: @1503037
     /* 1503037 */   GIM_Try, /*On fail goto*//*Label 20949*/ GIMT_Encode4(1503119), // Rule ID 17796 //
     /* 1503042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1503059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503081 */     // MIs[0] round
     /* 1503081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503084 */     // MIs[0] policy
     /* 1503084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503094 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1503097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503118 */     // GIR_Coverage, 17796,
     /* 1503118 */     GIR_EraseRootFromParent_Done,
     /* 1503119 */   // Label 20949: @1503119
     /* 1503119 */   GIM_Try, /*On fail goto*//*Label 20950*/ GIMT_Encode4(1503201), // Rule ID 17797 //
     /* 1503124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1503141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503163 */     // MIs[0] round
     /* 1503163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503166 */     // MIs[0] policy
     /* 1503166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503176 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1503179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503200 */     // GIR_Coverage, 17797,
     /* 1503200 */     GIR_EraseRootFromParent_Done,
     /* 1503201 */   // Label 20950: @1503201
     /* 1503201 */   GIM_Try, /*On fail goto*//*Label 20951*/ GIMT_Encode4(1503283), // Rule ID 17800 //
     /* 1503206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1503217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1503220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1503223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1503226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503245 */     // MIs[0] round
     /* 1503245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503248 */     // MIs[0] policy
     /* 1503248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503258 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1503261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503282 */     // GIR_Coverage, 17800,
     /* 1503282 */     GIR_EraseRootFromParent_Done,
     /* 1503283 */   // Label 20951: @1503283
     /* 1503283 */   GIM_Try, /*On fail goto*//*Label 20952*/ GIMT_Encode4(1503365), // Rule ID 17801 //
     /* 1503288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1503299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1503302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1503305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1503308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503327 */     // MIs[0] round
     /* 1503327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503330 */     // MIs[0] policy
     /* 1503330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503340 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1503343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503364 */     // GIR_Coverage, 17801,
     /* 1503364 */     GIR_EraseRootFromParent_Done,
     /* 1503365 */   // Label 20952: @1503365
     /* 1503365 */   GIM_Try, /*On fail goto*//*Label 20953*/ GIMT_Encode4(1503447), // Rule ID 17804 //
     /* 1503370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1503381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1503384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1503387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1503390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503409 */     // MIs[0] round
     /* 1503409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503412 */     // MIs[0] policy
     /* 1503412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503422 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1503425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503446 */     // GIR_Coverage, 17804,
     /* 1503446 */     GIR_EraseRootFromParent_Done,
     /* 1503447 */   // Label 20953: @1503447
     /* 1503447 */   GIM_Try, /*On fail goto*//*Label 20954*/ GIMT_Encode4(1503529), // Rule ID 17805 //
     /* 1503452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1503455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1503463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1503466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1503469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1503472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503491 */     // MIs[0] round
     /* 1503491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503494 */     // MIs[0] policy
     /* 1503494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503504 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1503507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503528 */     // GIR_Coverage, 17805,
     /* 1503528 */     GIR_EraseRootFromParent_Done,
     /* 1503529 */   // Label 20954: @1503529
     /* 1503529 */   GIM_Try, /*On fail goto*//*Label 20955*/ GIMT_Encode4(1503611), // Rule ID 17808 //
     /* 1503534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1503545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1503548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1503551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1503554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503573 */     // MIs[0] round
     /* 1503573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503576 */     // MIs[0] policy
     /* 1503576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503586 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1503589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503610 */     // GIR_Coverage, 17808,
     /* 1503610 */     GIR_EraseRootFromParent_Done,
     /* 1503611 */   // Label 20955: @1503611
     /* 1503611 */   GIM_Try, /*On fail goto*//*Label 20956*/ GIMT_Encode4(1503693), // Rule ID 17809 //
     /* 1503616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1503619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1503627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1503630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1503633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1503636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503655 */     // MIs[0] round
     /* 1503655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503658 */     // MIs[0] policy
     /* 1503658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503668 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1503671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503692 */     // GIR_Coverage, 17809,
     /* 1503692 */     GIR_EraseRootFromParent_Done,
     /* 1503693 */   // Label 20956: @1503693
     /* 1503693 */   GIM_Try, /*On fail goto*//*Label 20957*/ GIMT_Encode4(1503775), // Rule ID 17812 //
     /* 1503698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1503709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1503712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1503715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1503718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503737 */     // MIs[0] round
     /* 1503737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503740 */     // MIs[0] policy
     /* 1503740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503750 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1503753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503774 */     // GIR_Coverage, 17812,
     /* 1503774 */     GIR_EraseRootFromParent_Done,
     /* 1503775 */   // Label 20957: @1503775
     /* 1503775 */   GIM_Try, /*On fail goto*//*Label 20958*/ GIMT_Encode4(1503857), // Rule ID 17813 //
     /* 1503780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1503783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1503791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1503794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1503797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1503800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503819 */     // MIs[0] round
     /* 1503819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503822 */     // MIs[0] policy
     /* 1503822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503832 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1503835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503856 */     // GIR_Coverage, 17813,
     /* 1503856 */     GIR_EraseRootFromParent_Done,
     /* 1503857 */   // Label 20958: @1503857
     /* 1503857 */   GIM_Try, /*On fail goto*//*Label 20959*/ GIMT_Encode4(1503939), // Rule ID 17816 //
     /* 1503862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1503865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1503873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1503876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1503879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1503882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1503897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503901 */     // MIs[0] round
     /* 1503901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503904 */     // MIs[0] policy
     /* 1503904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503914 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1503917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503938 */     // GIR_Coverage, 17816,
     /* 1503938 */     GIR_EraseRootFromParent_Done,
     /* 1503939 */   // Label 20959: @1503939
     /* 1503939 */   GIM_Try, /*On fail goto*//*Label 20960*/ GIMT_Encode4(1504021), // Rule ID 17817 //
     /* 1503944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1503947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1503955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1503958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1503961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1503964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1503979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503983 */     // MIs[0] round
     /* 1503983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503986 */     // MIs[0] policy
     /* 1503986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503996 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1503999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504020 */     // GIR_Coverage, 17817,
     /* 1504020 */     GIR_EraseRootFromParent_Done,
     /* 1504021 */   // Label 20960: @1504021
     /* 1504021 */   GIM_Try, /*On fail goto*//*Label 20961*/ GIMT_Encode4(1504103), // Rule ID 17820 //
     /* 1504026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1504046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504065 */     // MIs[0] round
     /* 1504065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504068 */     // MIs[0] policy
     /* 1504068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504078 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1504081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504102 */     // GIR_Coverage, 17820,
     /* 1504102 */     GIR_EraseRootFromParent_Done,
     /* 1504103 */   // Label 20961: @1504103
     /* 1504103 */   GIM_Try, /*On fail goto*//*Label 20962*/ GIMT_Encode4(1504185), // Rule ID 17821 //
     /* 1504108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1504128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504147 */     // MIs[0] round
     /* 1504147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504150 */     // MIs[0] policy
     /* 1504150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504160 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1504163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504184 */     // GIR_Coverage, 17821,
     /* 1504184 */     GIR_EraseRootFromParent_Done,
     /* 1504185 */   // Label 20962: @1504185
     /* 1504185 */   GIM_Try, /*On fail goto*//*Label 20963*/ GIMT_Encode4(1504267), // Rule ID 17824 //
     /* 1504190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1504193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1504201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1504204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1504210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504229 */     // MIs[0] round
     /* 1504229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504232 */     // MIs[0] policy
     /* 1504232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504242 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1504245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504266 */     // GIR_Coverage, 17824,
     /* 1504266 */     GIR_EraseRootFromParent_Done,
     /* 1504267 */   // Label 20963: @1504267
     /* 1504267 */   GIM_Try, /*On fail goto*//*Label 20964*/ GIMT_Encode4(1504349), // Rule ID 17825 //
     /* 1504272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1504275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1504283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1504286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1504292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504311 */     // MIs[0] round
     /* 1504311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504314 */     // MIs[0] policy
     /* 1504314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504324 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1504327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504348 */     // GIR_Coverage, 17825,
     /* 1504348 */     GIR_EraseRootFromParent_Done,
     /* 1504349 */   // Label 20964: @1504349
     /* 1504349 */   GIM_Try, /*On fail goto*//*Label 20965*/ GIMT_Encode4(1504431), // Rule ID 17828 //
     /* 1504354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1504365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1504368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1504374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504393 */     // MIs[0] round
     /* 1504393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504396 */     // MIs[0] policy
     /* 1504396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504406 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1504409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504430 */     // GIR_Coverage, 17828,
     /* 1504430 */     GIR_EraseRootFromParent_Done,
     /* 1504431 */   // Label 20965: @1504431
     /* 1504431 */   GIM_Try, /*On fail goto*//*Label 20966*/ GIMT_Encode4(1504513), // Rule ID 17829 //
     /* 1504436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1504447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1504450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1504456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504475 */     // MIs[0] round
     /* 1504475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504478 */     // MIs[0] policy
     /* 1504478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504488 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1504491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504512 */     // GIR_Coverage, 17829,
     /* 1504512 */     GIR_EraseRootFromParent_Done,
     /* 1504513 */   // Label 20966: @1504513
     /* 1504513 */   GIM_Try, /*On fail goto*//*Label 20967*/ GIMT_Encode4(1504595), // Rule ID 17832 //
     /* 1504518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1504521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1504529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1504532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1504538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504557 */     // MIs[0] round
     /* 1504557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504560 */     // MIs[0] policy
     /* 1504560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504570 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1504573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504594 */     // GIR_Coverage, 17832,
     /* 1504594 */     GIR_EraseRootFromParent_Done,
     /* 1504595 */   // Label 20967: @1504595
     /* 1504595 */   GIM_Try, /*On fail goto*//*Label 20968*/ GIMT_Encode4(1504677), // Rule ID 17833 //
     /* 1504600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1504603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1504611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1504614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1504620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504639 */     // MIs[0] round
     /* 1504639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504642 */     // MIs[0] policy
     /* 1504642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504652 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1504655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504676 */     // GIR_Coverage, 17833,
     /* 1504676 */     GIR_EraseRootFromParent_Done,
     /* 1504677 */   // Label 20968: @1504677
     /* 1504677 */   GIM_Try, /*On fail goto*//*Label 20969*/ GIMT_Encode4(1504759), // Rule ID 17836 //
     /* 1504682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1504685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1504693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1504696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1504699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1504702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1504717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504721 */     // MIs[0] round
     /* 1504721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504724 */     // MIs[0] policy
     /* 1504724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504734 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1504737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504758 */     // GIR_Coverage, 17836,
     /* 1504758 */     GIR_EraseRootFromParent_Done,
     /* 1504759 */   // Label 20969: @1504759
     /* 1504759 */   GIM_Try, /*On fail goto*//*Label 20970*/ GIMT_Encode4(1504841), // Rule ID 17837 //
     /* 1504764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1504767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1504775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1504778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1504781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1504784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1504799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504803 */     // MIs[0] round
     /* 1504803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504806 */     // MIs[0] policy
     /* 1504806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504816 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1504819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504840 */     // GIR_Coverage, 17837,
     /* 1504840 */     GIR_EraseRootFromParent_Done,
     /* 1504841 */   // Label 20970: @1504841
     /* 1504841 */   GIM_Try, /*On fail goto*//*Label 20971*/ GIMT_Encode4(1504923), // Rule ID 17840 //
     /* 1504846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1504857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1504860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1504866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504885 */     // MIs[0] round
     /* 1504885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504888 */     // MIs[0] policy
     /* 1504888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504898 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1504901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504909 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504922 */     // GIR_Coverage, 17840,
     /* 1504922 */     GIR_EraseRootFromParent_Done,
     /* 1504923 */   // Label 20971: @1504923
     /* 1504923 */   GIM_Try, /*On fail goto*//*Label 20972*/ GIMT_Encode4(1505005), // Rule ID 17841 //
     /* 1504928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1504939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1504942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1504948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504967 */     // MIs[0] round
     /* 1504967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504970 */     // MIs[0] policy
     /* 1504970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504980 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1504983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505004 */     // GIR_Coverage, 17841,
     /* 1505004 */     GIR_EraseRootFromParent_Done,
     /* 1505005 */   // Label 20972: @1505005
     /* 1505005 */   GIM_Try, /*On fail goto*//*Label 20973*/ GIMT_Encode4(1505087), // Rule ID 17844 //
     /* 1505010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1505021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1505024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1505030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505049 */     // MIs[0] round
     /* 1505049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505052 */     // MIs[0] policy
     /* 1505052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505062 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1505065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505086 */     // GIR_Coverage, 17844,
     /* 1505086 */     GIR_EraseRootFromParent_Done,
     /* 1505087 */   // Label 20973: @1505087
     /* 1505087 */   GIM_Try, /*On fail goto*//*Label 20974*/ GIMT_Encode4(1505169), // Rule ID 17845 //
     /* 1505092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1505103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1505106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1505112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505131 */     // MIs[0] round
     /* 1505131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505134 */     // MIs[0] policy
     /* 1505134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505144 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1505147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505168 */     // GIR_Coverage, 17845,
     /* 1505168 */     GIR_EraseRootFromParent_Done,
     /* 1505169 */   // Label 20974: @1505169
     /* 1505169 */   GIM_Try, /*On fail goto*//*Label 20975*/ GIMT_Encode4(1505251), // Rule ID 17848 //
     /* 1505174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1505185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1505188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1505194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505213 */     // MIs[0] round
     /* 1505213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505216 */     // MIs[0] policy
     /* 1505216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505226 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1505229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505250 */     // GIR_Coverage, 17848,
     /* 1505250 */     GIR_EraseRootFromParent_Done,
     /* 1505251 */   // Label 20975: @1505251
     /* 1505251 */   GIM_Try, /*On fail goto*//*Label 20976*/ GIMT_Encode4(1505333), // Rule ID 17849 //
     /* 1505256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1505267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1505270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1505276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505295 */     // MIs[0] round
     /* 1505295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505298 */     // MIs[0] policy
     /* 1505298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505308 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1505311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505332 */     // GIR_Coverage, 17849,
     /* 1505332 */     GIR_EraseRootFromParent_Done,
     /* 1505333 */   // Label 20976: @1505333
     /* 1505333 */   GIM_Try, /*On fail goto*//*Label 20977*/ GIMT_Encode4(1505415), // Rule ID 17852 //
     /* 1505338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1505349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1505352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1505358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505377 */     // MIs[0] round
     /* 1505377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505380 */     // MIs[0] policy
     /* 1505380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505390 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1505393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505414 */     // GIR_Coverage, 17852,
     /* 1505414 */     GIR_EraseRootFromParent_Done,
     /* 1505415 */   // Label 20977: @1505415
     /* 1505415 */   GIM_Try, /*On fail goto*//*Label 20978*/ GIMT_Encode4(1505497), // Rule ID 17853 //
     /* 1505420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1505431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1505434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1505440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505459 */     // MIs[0] round
     /* 1505459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505462 */     // MIs[0] policy
     /* 1505462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505472 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1505475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505496 */     // GIR_Coverage, 17853,
     /* 1505496 */     GIR_EraseRootFromParent_Done,
     /* 1505497 */   // Label 20978: @1505497
     /* 1505497 */   GIM_Try, /*On fail goto*//*Label 20979*/ GIMT_Encode4(1505579), // Rule ID 17856 //
     /* 1505502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1505513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1505516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1505522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505541 */     // MIs[0] round
     /* 1505541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505544 */     // MIs[0] policy
     /* 1505544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505554 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1505557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505578 */     // GIR_Coverage, 17856,
     /* 1505578 */     GIR_EraseRootFromParent_Done,
     /* 1505579 */   // Label 20979: @1505579
     /* 1505579 */   GIM_Try, /*On fail goto*//*Label 20980*/ GIMT_Encode4(1505661), // Rule ID 17857 //
     /* 1505584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1505595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1505598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1505604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505623 */     // MIs[0] round
     /* 1505623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505626 */     // MIs[0] policy
     /* 1505626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505636 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1505639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505660 */     // GIR_Coverage, 17857,
     /* 1505660 */     GIR_EraseRootFromParent_Done,
     /* 1505661 */   // Label 20980: @1505661
     /* 1505661 */   GIM_Try, /*On fail goto*//*Label 20981*/ GIMT_Encode4(1505743), // Rule ID 17860 //
     /* 1505666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1505677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1505680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1505686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505705 */     // MIs[0] round
     /* 1505705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505708 */     // MIs[0] policy
     /* 1505708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505718 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1505721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505742 */     // GIR_Coverage, 17860,
     /* 1505742 */     GIR_EraseRootFromParent_Done,
     /* 1505743 */   // Label 20981: @1505743
     /* 1505743 */   GIM_Try, /*On fail goto*//*Label 20982*/ GIMT_Encode4(1505825), // Rule ID 17861 //
     /* 1505748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1505759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1505762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1505768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505787 */     // MIs[0] round
     /* 1505787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505790 */     // MIs[0] policy
     /* 1505790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505800 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1505803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505824 */     // GIR_Coverage, 17861,
     /* 1505824 */     GIR_EraseRootFromParent_Done,
     /* 1505825 */   // Label 20982: @1505825
     /* 1505825 */   GIM_Try, /*On fail goto*//*Label 20983*/ GIMT_Encode4(1505907), // Rule ID 17864 //
     /* 1505830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1505833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1505841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1505844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1505847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1505850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1505865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505869 */     // MIs[0] round
     /* 1505869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505872 */     // MIs[0] policy
     /* 1505872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505882 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1505885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1505903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505906 */     // GIR_Coverage, 17864,
     /* 1505906 */     GIR_EraseRootFromParent_Done,
     /* 1505907 */   // Label 20983: @1505907
     /* 1505907 */   GIM_Try, /*On fail goto*//*Label 20984*/ GIMT_Encode4(1505989), // Rule ID 17865 //
     /* 1505912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1505915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1505923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1505926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1505929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1505932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1505947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505951 */     // MIs[0] round
     /* 1505951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505954 */     // MIs[0] policy
     /* 1505954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505964 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1505967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1505985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505988 */     // GIR_Coverage, 17865,
     /* 1505988 */     GIR_EraseRootFromParent_Done,
     /* 1505989 */   // Label 20984: @1505989
     /* 1505989 */   GIM_Try, /*On fail goto*//*Label 20985*/ GIMT_Encode4(1506071), // Rule ID 17868 //
     /* 1505994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1505997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1506005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1506008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1506014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506033 */     // MIs[0] round
     /* 1506033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506036 */     // MIs[0] policy
     /* 1506036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506046 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1506049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506070 */     // GIR_Coverage, 17868,
     /* 1506070 */     GIR_EraseRootFromParent_Done,
     /* 1506071 */   // Label 20985: @1506071
     /* 1506071 */   GIM_Try, /*On fail goto*//*Label 20986*/ GIMT_Encode4(1506153), // Rule ID 17869 //
     /* 1506076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1506087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1506090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1506096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506115 */     // MIs[0] round
     /* 1506115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506118 */     // MIs[0] policy
     /* 1506118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506128 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1506131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506139 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506152 */     // GIR_Coverage, 17869,
     /* 1506152 */     GIR_EraseRootFromParent_Done,
     /* 1506153 */   // Label 20986: @1506153
     /* 1506153 */   GIM_Try, /*On fail goto*//*Label 20987*/ GIMT_Encode4(1506235), // Rule ID 17872 //
     /* 1506158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1506169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1506172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1506178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506197 */     // MIs[0] round
     /* 1506197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506200 */     // MIs[0] policy
     /* 1506200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506210 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1506213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506234 */     // GIR_Coverage, 17872,
     /* 1506234 */     GIR_EraseRootFromParent_Done,
     /* 1506235 */   // Label 20987: @1506235
     /* 1506235 */   GIM_Try, /*On fail goto*//*Label 20988*/ GIMT_Encode4(1506317), // Rule ID 17873 //
     /* 1506240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1506251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1506254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1506260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506279 */     // MIs[0] round
     /* 1506279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506282 */     // MIs[0] policy
     /* 1506282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506292 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1506295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506316 */     // GIR_Coverage, 17873,
     /* 1506316 */     GIR_EraseRootFromParent_Done,
     /* 1506317 */   // Label 20988: @1506317
     /* 1506317 */   GIM_Try, /*On fail goto*//*Label 20989*/ GIMT_Encode4(1506399), // Rule ID 17876 //
     /* 1506322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1506333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1506336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1506339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1506342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506361 */     // MIs[0] round
     /* 1506361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506364 */     // MIs[0] policy
     /* 1506364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506374 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1506377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506398 */     // GIR_Coverage, 17876,
     /* 1506398 */     GIR_EraseRootFromParent_Done,
     /* 1506399 */   // Label 20989: @1506399
     /* 1506399 */   GIM_Try, /*On fail goto*//*Label 20990*/ GIMT_Encode4(1506481), // Rule ID 17877 //
     /* 1506404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1506415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1506418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1506421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1506424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506443 */     // MIs[0] round
     /* 1506443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506446 */     // MIs[0] policy
     /* 1506446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506456 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1506459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506480 */     // GIR_Coverage, 17877,
     /* 1506480 */     GIR_EraseRootFromParent_Done,
     /* 1506481 */   // Label 20990: @1506481
     /* 1506481 */   GIM_Try, /*On fail goto*//*Label 20991*/ GIMT_Encode4(1506563), // Rule ID 17880 //
     /* 1506486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1506497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1506500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1506503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1506506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506525 */     // MIs[0] round
     /* 1506525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506528 */     // MIs[0] policy
     /* 1506528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506538 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1506541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506562 */     // GIR_Coverage, 17880,
     /* 1506562 */     GIR_EraseRootFromParent_Done,
     /* 1506563 */   // Label 20991: @1506563
     /* 1506563 */   GIM_Try, /*On fail goto*//*Label 20992*/ GIMT_Encode4(1506645), // Rule ID 17881 //
     /* 1506568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1506579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1506582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1506585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1506588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506607 */     // MIs[0] round
     /* 1506607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506610 */     // MIs[0] policy
     /* 1506610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506620 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1506623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506644 */     // GIR_Coverage, 17881,
     /* 1506644 */     GIR_EraseRootFromParent_Done,
     /* 1506645 */   // Label 20992: @1506645
     /* 1506645 */   GIM_Try, /*On fail goto*//*Label 20993*/ GIMT_Encode4(1506727), // Rule ID 17884 //
     /* 1506650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1506653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1506661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1506664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1506667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1506670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506689 */     // MIs[0] round
     /* 1506689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506692 */     // MIs[0] policy
     /* 1506692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506702 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1506705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506726 */     // GIR_Coverage, 17884,
     /* 1506726 */     GIR_EraseRootFromParent_Done,
     /* 1506727 */   // Label 20993: @1506727
     /* 1506727 */   GIM_Try, /*On fail goto*//*Label 20994*/ GIMT_Encode4(1506809), // Rule ID 17885 //
     /* 1506732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1506735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1506743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1506746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1506749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1506752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506771 */     // MIs[0] round
     /* 1506771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506774 */     // MIs[0] policy
     /* 1506774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506784 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1506787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506808 */     // GIR_Coverage, 17885,
     /* 1506808 */     GIR_EraseRootFromParent_Done,
     /* 1506809 */   // Label 20994: @1506809
     /* 1506809 */   GIM_Try, /*On fail goto*//*Label 20995*/ GIMT_Encode4(1506891), // Rule ID 17888 //
     /* 1506814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1506825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1506828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1506831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1506834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506853 */     // MIs[0] round
     /* 1506853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506856 */     // MIs[0] policy
     /* 1506856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506866 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1506869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506890 */     // GIR_Coverage, 17888,
     /* 1506890 */     GIR_EraseRootFromParent_Done,
     /* 1506891 */   // Label 20995: @1506891
     /* 1506891 */   GIM_Try, /*On fail goto*//*Label 20996*/ GIMT_Encode4(1506973), // Rule ID 17889 //
     /* 1506896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1506907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1506910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1506913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1506916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506935 */     // MIs[0] round
     /* 1506935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506938 */     // MIs[0] policy
     /* 1506938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506948 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1506951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506972 */     // GIR_Coverage, 17889,
     /* 1506972 */     GIR_EraseRootFromParent_Done,
     /* 1506973 */   // Label 20996: @1506973
     /* 1506973 */   GIM_Try, /*On fail goto*//*Label 20997*/ GIMT_Encode4(1507055), // Rule ID 17892 //
     /* 1506978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1506981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1506989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1506992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1506995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1506998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507017 */     // MIs[0] round
     /* 1507017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507020 */     // MIs[0] policy
     /* 1507020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507030 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1507033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507054 */     // GIR_Coverage, 17892,
     /* 1507054 */     GIR_EraseRootFromParent_Done,
     /* 1507055 */   // Label 20997: @1507055
     /* 1507055 */   GIM_Try, /*On fail goto*//*Label 20998*/ GIMT_Encode4(1507137), // Rule ID 17893 //
     /* 1507060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1507063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1507071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1507074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1507077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1507080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507099 */     // MIs[0] round
     /* 1507099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507102 */     // MIs[0] policy
     /* 1507102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507112 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1507115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507136 */     // GIR_Coverage, 17893,
     /* 1507136 */     GIR_EraseRootFromParent_Done,
     /* 1507137 */   // Label 20998: @1507137
     /* 1507137 */   GIM_Try, /*On fail goto*//*Label 20999*/ GIMT_Encode4(1507219), // Rule ID 17896 //
     /* 1507142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1507145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1507153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1507156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1507159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1507162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507181 */     // MIs[0] round
     /* 1507181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507184 */     // MIs[0] policy
     /* 1507184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507194 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1507197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507218 */     // GIR_Coverage, 17896,
     /* 1507218 */     GIR_EraseRootFromParent_Done,
     /* 1507219 */   // Label 20999: @1507219
     /* 1507219 */   GIM_Try, /*On fail goto*//*Label 21000*/ GIMT_Encode4(1507301), // Rule ID 17897 //
     /* 1507224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1507227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1507235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1507238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1507241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1507244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507263 */     // MIs[0] round
     /* 1507263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507266 */     // MIs[0] policy
     /* 1507266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507276 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1507279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507300 */     // GIR_Coverage, 17897,
     /* 1507300 */     GIR_EraseRootFromParent_Done,
     /* 1507301 */   // Label 21000: @1507301
     /* 1507301 */   GIM_Try, /*On fail goto*//*Label 21001*/ GIMT_Encode4(1507383), // Rule ID 17900 //
     /* 1507306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1507317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1507320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1507323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1507326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507345 */     // MIs[0] round
     /* 1507345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507348 */     // MIs[0] policy
     /* 1507348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507358 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1507361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507382 */     // GIR_Coverage, 17900,
     /* 1507382 */     GIR_EraseRootFromParent_Done,
     /* 1507383 */   // Label 21001: @1507383
     /* 1507383 */   GIM_Try, /*On fail goto*//*Label 21002*/ GIMT_Encode4(1507465), // Rule ID 17901 //
     /* 1507388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1507399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1507402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1507405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1507408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507427 */     // MIs[0] round
     /* 1507427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507430 */     // MIs[0] policy
     /* 1507430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507440 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1507443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507464 */     // GIR_Coverage, 17901,
     /* 1507464 */     GIR_EraseRootFromParent_Done,
     /* 1507465 */   // Label 21002: @1507465
     /* 1507465 */   GIM_Try, /*On fail goto*//*Label 21003*/ GIMT_Encode4(1507547), // Rule ID 17904 //
     /* 1507470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1507481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1507484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1507487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1507490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507509 */     // MIs[0] round
     /* 1507509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507512 */     // MIs[0] policy
     /* 1507512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507522 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1507525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507546 */     // GIR_Coverage, 17904,
     /* 1507546 */     GIR_EraseRootFromParent_Done,
     /* 1507547 */   // Label 21003: @1507547
     /* 1507547 */   GIM_Try, /*On fail goto*//*Label 21004*/ GIMT_Encode4(1507629), // Rule ID 17905 //
     /* 1507552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1507563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1507566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1507569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1507572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507591 */     // MIs[0] round
     /* 1507591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507594 */     // MIs[0] policy
     /* 1507594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507604 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1507607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507628 */     // GIR_Coverage, 17905,
     /* 1507628 */     GIR_EraseRootFromParent_Done,
     /* 1507629 */   // Label 21004: @1507629
     /* 1507629 */   GIM_Try, /*On fail goto*//*Label 21005*/ GIMT_Encode4(1507711), // Rule ID 17908 //
     /* 1507634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1507645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1507648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1507651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1507654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507673 */     // MIs[0] round
     /* 1507673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507676 */     // MIs[0] policy
     /* 1507676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507686 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1507689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507710 */     // GIR_Coverage, 17908,
     /* 1507710 */     GIR_EraseRootFromParent_Done,
     /* 1507711 */   // Label 21005: @1507711
     /* 1507711 */   GIM_Try, /*On fail goto*//*Label 21006*/ GIMT_Encode4(1507793), // Rule ID 17909 //
     /* 1507716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1507727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1507730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1507733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1507736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507755 */     // MIs[0] round
     /* 1507755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507758 */     // MIs[0] policy
     /* 1507758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507768 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1507771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507792 */     // GIR_Coverage, 17909,
     /* 1507792 */     GIR_EraseRootFromParent_Done,
     /* 1507793 */   // Label 21006: @1507793
     /* 1507793 */   GIM_Try, /*On fail goto*//*Label 21007*/ GIMT_Encode4(1507875), // Rule ID 17912 //
     /* 1507798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1507801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1507809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1507812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1507815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1507818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507837 */     // MIs[0] round
     /* 1507837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507840 */     // MIs[0] policy
     /* 1507840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507850 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1507853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507874 */     // GIR_Coverage, 17912,
     /* 1507874 */     GIR_EraseRootFromParent_Done,
     /* 1507875 */   // Label 21007: @1507875
     /* 1507875 */   GIM_Try, /*On fail goto*//*Label 21008*/ GIMT_Encode4(1507957), // Rule ID 17913 //
     /* 1507880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1507883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1507891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1507894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1507897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1507900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507919 */     // MIs[0] round
     /* 1507919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507922 */     // MIs[0] policy
     /* 1507922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507932 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1507935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507956 */     // GIR_Coverage, 17913,
     /* 1507956 */     GIR_EraseRootFromParent_Done,
     /* 1507957 */   // Label 21008: @1507957
     /* 1507957 */   GIM_Try, /*On fail goto*//*Label 21009*/ GIMT_Encode4(1508039), // Rule ID 17916 //
     /* 1507962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1507965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1507973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1507976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1507979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1507982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508001 */     // MIs[0] round
     /* 1508001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508004 */     // MIs[0] policy
     /* 1508004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508014 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1508017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508038 */     // GIR_Coverage, 17916,
     /* 1508038 */     GIR_EraseRootFromParent_Done,
     /* 1508039 */   // Label 21009: @1508039
     /* 1508039 */   GIM_Try, /*On fail goto*//*Label 21010*/ GIMT_Encode4(1508121), // Rule ID 17917 //
     /* 1508044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1508055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1508058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1508061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1508064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508083 */     // MIs[0] round
     /* 1508083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508086 */     // MIs[0] policy
     /* 1508086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508096 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1508099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508120 */     // GIR_Coverage, 17917,
     /* 1508120 */     GIR_EraseRootFromParent_Done,
     /* 1508121 */   // Label 21010: @1508121
     /* 1508121 */   GIM_Try, /*On fail goto*//*Label 21011*/ GIMT_Encode4(1508203), // Rule ID 17920 //
     /* 1508126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1508137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1508140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1508143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1508146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508165 */     // MIs[0] round
     /* 1508165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508168 */     // MIs[0] policy
     /* 1508168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508178 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1508181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508202 */     // GIR_Coverage, 17920,
     /* 1508202 */     GIR_EraseRootFromParent_Done,
     /* 1508203 */   // Label 21011: @1508203
     /* 1508203 */   GIM_Try, /*On fail goto*//*Label 21012*/ GIMT_Encode4(1508285), // Rule ID 17921 //
     /* 1508208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1508219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1508222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1508225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1508228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508247 */     // MIs[0] round
     /* 1508247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508250 */     // MIs[0] policy
     /* 1508250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508260 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1508263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508284 */     // GIR_Coverage, 17921,
     /* 1508284 */     GIR_EraseRootFromParent_Done,
     /* 1508285 */   // Label 21012: @1508285
     /* 1508285 */   GIM_Try, /*On fail goto*//*Label 21013*/ GIMT_Encode4(1508367), // Rule ID 17924 //
     /* 1508290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1508301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1508304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1508307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1508310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508329 */     // MIs[0] round
     /* 1508329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508332 */     // MIs[0] policy
     /* 1508332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508342 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1508345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508366 */     // GIR_Coverage, 17924,
     /* 1508366 */     GIR_EraseRootFromParent_Done,
     /* 1508367 */   // Label 21013: @1508367
     /* 1508367 */   GIM_Try, /*On fail goto*//*Label 21014*/ GIMT_Encode4(1508449), // Rule ID 17925 //
     /* 1508372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1508383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1508386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1508389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1508392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508411 */     // MIs[0] round
     /* 1508411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508414 */     // MIs[0] policy
     /* 1508414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508424 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1508427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508448 */     // GIR_Coverage, 17925,
     /* 1508448 */     GIR_EraseRootFromParent_Done,
     /* 1508449 */   // Label 21014: @1508449
     /* 1508449 */   GIM_Try, /*On fail goto*//*Label 21015*/ GIMT_Encode4(1508531), // Rule ID 17928 //
     /* 1508454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1508465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1508468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1508471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1508474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508493 */     // MIs[0] round
     /* 1508493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508496 */     // MIs[0] policy
     /* 1508496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508506 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1508509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508530 */     // GIR_Coverage, 17928,
     /* 1508530 */     GIR_EraseRootFromParent_Done,
     /* 1508531 */   // Label 21015: @1508531
     /* 1508531 */   GIM_Try, /*On fail goto*//*Label 21016*/ GIMT_Encode4(1508613), // Rule ID 17929 //
     /* 1508536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1508547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1508550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1508553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1508556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508575 */     // MIs[0] round
     /* 1508575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508578 */     // MIs[0] policy
     /* 1508578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508588 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1508591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508612 */     // GIR_Coverage, 17929,
     /* 1508612 */     GIR_EraseRootFromParent_Done,
     /* 1508613 */   // Label 21016: @1508613
     /* 1508613 */   GIM_Try, /*On fail goto*//*Label 21017*/ GIMT_Encode4(1508695), // Rule ID 17932 //
     /* 1508618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1508629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1508632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1508635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1508638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508657 */     // MIs[0] round
     /* 1508657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508660 */     // MIs[0] policy
     /* 1508660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508670 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1508673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508694 */     // GIR_Coverage, 17932,
     /* 1508694 */     GIR_EraseRootFromParent_Done,
     /* 1508695 */   // Label 21017: @1508695
     /* 1508695 */   GIM_Try, /*On fail goto*//*Label 21018*/ GIMT_Encode4(1508777), // Rule ID 17933 //
     /* 1508700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1508711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1508714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1508717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1508720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508739 */     // MIs[0] round
     /* 1508739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508742 */     // MIs[0] policy
     /* 1508742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508752 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1508755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508776 */     // GIR_Coverage, 17933,
     /* 1508776 */     GIR_EraseRootFromParent_Done,
     /* 1508777 */   // Label 21018: @1508777
     /* 1508777 */   GIM_Try, /*On fail goto*//*Label 21019*/ GIMT_Encode4(1508859), // Rule ID 17936 //
     /* 1508782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1508785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1508793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1508796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1508802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508821 */     // MIs[0] round
     /* 1508821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508824 */     // MIs[0] policy
     /* 1508824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508834 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1508837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508858 */     // GIR_Coverage, 17936,
     /* 1508858 */     GIR_EraseRootFromParent_Done,
     /* 1508859 */   // Label 21019: @1508859
     /* 1508859 */   GIM_Try, /*On fail goto*//*Label 21020*/ GIMT_Encode4(1508941), // Rule ID 17937 //
     /* 1508864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1508867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1508875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1508878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1508884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508903 */     // MIs[0] round
     /* 1508903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508906 */     // MIs[0] policy
     /* 1508906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508916 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1508919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508940 */     // GIR_Coverage, 17937,
     /* 1508940 */     GIR_EraseRootFromParent_Done,
     /* 1508941 */   // Label 21020: @1508941
     /* 1508941 */   GIM_Try, /*On fail goto*//*Label 21021*/ GIMT_Encode4(1509023), // Rule ID 17940 //
     /* 1508946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1508949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1508957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1508960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1508966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508985 */     // MIs[0] round
     /* 1508985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508988 */     // MIs[0] policy
     /* 1508988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508998 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1509001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509022 */     // GIR_Coverage, 17940,
     /* 1509022 */     GIR_EraseRootFromParent_Done,
     /* 1509023 */   // Label 21021: @1509023
     /* 1509023 */   GIM_Try, /*On fail goto*//*Label 21022*/ GIMT_Encode4(1509105), // Rule ID 17941 //
     /* 1509028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1509039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1509042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1509048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509067 */     // MIs[0] round
     /* 1509067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509070 */     // MIs[0] policy
     /* 1509070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509080 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1509083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509104 */     // GIR_Coverage, 17941,
     /* 1509104 */     GIR_EraseRootFromParent_Done,
     /* 1509105 */   // Label 21022: @1509105
     /* 1509105 */   GIM_Try, /*On fail goto*//*Label 21023*/ GIMT_Encode4(1509187), // Rule ID 17944 //
     /* 1509110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1509121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1509124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1509130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509149 */     // MIs[0] round
     /* 1509149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509152 */     // MIs[0] policy
     /* 1509152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509162 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1509165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509186 */     // GIR_Coverage, 17944,
     /* 1509186 */     GIR_EraseRootFromParent_Done,
     /* 1509187 */   // Label 21023: @1509187
     /* 1509187 */   GIM_Try, /*On fail goto*//*Label 21024*/ GIMT_Encode4(1509269), // Rule ID 17945 //
     /* 1509192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1509203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1509206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1509212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509231 */     // MIs[0] round
     /* 1509231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509234 */     // MIs[0] policy
     /* 1509234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509244 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1509247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509268 */     // GIR_Coverage, 17945,
     /* 1509268 */     GIR_EraseRootFromParent_Done,
     /* 1509269 */   // Label 21024: @1509269
     /* 1509269 */   GIM_Try, /*On fail goto*//*Label 21025*/ GIMT_Encode4(1509351), // Rule ID 17948 //
     /* 1509274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1509285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1509288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1509294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509313 */     // MIs[0] round
     /* 1509313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509316 */     // MIs[0] policy
     /* 1509316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509326 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1509329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509350 */     // GIR_Coverage, 17948,
     /* 1509350 */     GIR_EraseRootFromParent_Done,
     /* 1509351 */   // Label 21025: @1509351
     /* 1509351 */   GIM_Try, /*On fail goto*//*Label 21026*/ GIMT_Encode4(1509433), // Rule ID 17949 //
     /* 1509356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1509367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1509370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1509376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509395 */     // MIs[0] round
     /* 1509395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509398 */     // MIs[0] policy
     /* 1509398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509408 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1509411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509432 */     // GIR_Coverage, 17949,
     /* 1509432 */     GIR_EraseRootFromParent_Done,
     /* 1509433 */   // Label 21026: @1509433
     /* 1509433 */   GIM_Try, /*On fail goto*//*Label 21027*/ GIMT_Encode4(1509515), // Rule ID 17952 //
     /* 1509438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1509449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1509452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1509458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509477 */     // MIs[0] round
     /* 1509477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509480 */     // MIs[0] policy
     /* 1509480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509490 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1509493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509514 */     // GIR_Coverage, 17952,
     /* 1509514 */     GIR_EraseRootFromParent_Done,
     /* 1509515 */   // Label 21027: @1509515
     /* 1509515 */   GIM_Try, /*On fail goto*//*Label 21028*/ GIMT_Encode4(1509597), // Rule ID 17953 //
     /* 1509520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1509531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1509534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1509540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509559 */     // MIs[0] round
     /* 1509559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509562 */     // MIs[0] policy
     /* 1509562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509572 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1509575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509596 */     // GIR_Coverage, 17953,
     /* 1509596 */     GIR_EraseRootFromParent_Done,
     /* 1509597 */   // Label 21028: @1509597
     /* 1509597 */   GIM_Try, /*On fail goto*//*Label 21029*/ GIMT_Encode4(1509679), // Rule ID 17956 //
     /* 1509602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1509605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1509613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1509616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1509622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509641 */     // MIs[0] round
     /* 1509641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509644 */     // MIs[0] policy
     /* 1509644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509654 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1509657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509678 */     // GIR_Coverage, 17956,
     /* 1509678 */     GIR_EraseRootFromParent_Done,
     /* 1509679 */   // Label 21029: @1509679
     /* 1509679 */   GIM_Try, /*On fail goto*//*Label 21030*/ GIMT_Encode4(1509761), // Rule ID 17957 //
     /* 1509684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1509687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1509695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1509698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1509704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509723 */     // MIs[0] round
     /* 1509723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509726 */     // MIs[0] policy
     /* 1509726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509736 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1509739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509760 */     // GIR_Coverage, 17957,
     /* 1509760 */     GIR_EraseRootFromParent_Done,
     /* 1509761 */   // Label 21030: @1509761
     /* 1509761 */   GIM_Try, /*On fail goto*//*Label 21031*/ GIMT_Encode4(1509843), // Rule ID 17960 //
     /* 1509766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1509777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1509780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1509786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509805 */     // MIs[0] round
     /* 1509805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509808 */     // MIs[0] policy
     /* 1509808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509818 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1509821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509842 */     // GIR_Coverage, 17960,
     /* 1509842 */     GIR_EraseRootFromParent_Done,
     /* 1509843 */   // Label 21031: @1509843
     /* 1509843 */   GIM_Try, /*On fail goto*//*Label 21032*/ GIMT_Encode4(1509925), // Rule ID 17961 //
     /* 1509848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1509859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1509862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1509868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509887 */     // MIs[0] round
     /* 1509887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509890 */     // MIs[0] policy
     /* 1509890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509900 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1509903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509924 */     // GIR_Coverage, 17961,
     /* 1509924 */     GIR_EraseRootFromParent_Done,
     /* 1509925 */   // Label 21032: @1509925
     /* 1509925 */   GIM_Try, /*On fail goto*//*Label 21033*/ GIMT_Encode4(1510007), // Rule ID 17964 //
     /* 1509930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1509941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1509944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1509950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509969 */     // MIs[0] round
     /* 1509969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509972 */     // MIs[0] policy
     /* 1509972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509982 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1509985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510006 */     // GIR_Coverage, 17964,
     /* 1510006 */     GIR_EraseRootFromParent_Done,
     /* 1510007 */   // Label 21033: @1510007
     /* 1510007 */   GIM_Try, /*On fail goto*//*Label 21034*/ GIMT_Encode4(1510089), // Rule ID 17965 //
     /* 1510012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1510023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1510026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1510032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510051 */     // MIs[0] round
     /* 1510051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510054 */     // MIs[0] policy
     /* 1510054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510064 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1510067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510088 */     // GIR_Coverage, 17965,
     /* 1510088 */     GIR_EraseRootFromParent_Done,
     /* 1510089 */   // Label 21034: @1510089
     /* 1510089 */   GIM_Try, /*On fail goto*//*Label 21035*/ GIMT_Encode4(1510171), // Rule ID 17968 //
     /* 1510094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1510114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510133 */     // MIs[0] round
     /* 1510133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510136 */     // MIs[0] policy
     /* 1510136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510146 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1510149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510170 */     // GIR_Coverage, 17968,
     /* 1510170 */     GIR_EraseRootFromParent_Done,
     /* 1510171 */   // Label 21035: @1510171
     /* 1510171 */   GIM_Try, /*On fail goto*//*Label 21036*/ GIMT_Encode4(1510253), // Rule ID 17969 //
     /* 1510176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1510196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510215 */     // MIs[0] round
     /* 1510215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510218 */     // MIs[0] policy
     /* 1510218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510228 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1510231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510252 */     // GIR_Coverage, 17969,
     /* 1510252 */     GIR_EraseRootFromParent_Done,
     /* 1510253 */   // Label 21036: @1510253
     /* 1510253 */   GIM_Try, /*On fail goto*//*Label 21037*/ GIMT_Encode4(1510335), // Rule ID 17972 //
     /* 1510258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1510269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1510272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1510278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510297 */     // MIs[0] round
     /* 1510297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510300 */     // MIs[0] policy
     /* 1510300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510310 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1510313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510334 */     // GIR_Coverage, 17972,
     /* 1510334 */     GIR_EraseRootFromParent_Done,
     /* 1510335 */   // Label 21037: @1510335
     /* 1510335 */   GIM_Try, /*On fail goto*//*Label 21038*/ GIMT_Encode4(1510417), // Rule ID 17973 //
     /* 1510340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1510351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1510354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1510360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510379 */     // MIs[0] round
     /* 1510379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510382 */     // MIs[0] policy
     /* 1510382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510392 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1510395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510416 */     // GIR_Coverage, 17973,
     /* 1510416 */     GIR_EraseRootFromParent_Done,
     /* 1510417 */   // Label 21038: @1510417
     /* 1510417 */   GIM_Try, /*On fail goto*//*Label 21039*/ GIMT_Encode4(1510499), // Rule ID 17976 //
     /* 1510422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1510433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1510436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1510442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510461 */     // MIs[0] round
     /* 1510461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510464 */     // MIs[0] policy
     /* 1510464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510474 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1510477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510498 */     // GIR_Coverage, 17976,
     /* 1510498 */     GIR_EraseRootFromParent_Done,
     /* 1510499 */   // Label 21039: @1510499
     /* 1510499 */   GIM_Try, /*On fail goto*//*Label 21040*/ GIMT_Encode4(1510581), // Rule ID 17977 //
     /* 1510504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1510515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1510518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1510524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510543 */     // MIs[0] round
     /* 1510543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510546 */     // MIs[0] policy
     /* 1510546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510556 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1510559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510580 */     // GIR_Coverage, 17977,
     /* 1510580 */     GIR_EraseRootFromParent_Done,
     /* 1510581 */   // Label 21040: @1510581
     /* 1510581 */   GIM_Try, /*On fail goto*//*Label 21041*/ GIMT_Encode4(1510663), // Rule ID 17980 //
     /* 1510586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1510597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1510600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1510606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510625 */     // MIs[0] round
     /* 1510625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510628 */     // MIs[0] policy
     /* 1510628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510638 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1510641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510662 */     // GIR_Coverage, 17980,
     /* 1510662 */     GIR_EraseRootFromParent_Done,
     /* 1510663 */   // Label 21041: @1510663
     /* 1510663 */   GIM_Try, /*On fail goto*//*Label 21042*/ GIMT_Encode4(1510745), // Rule ID 17981 //
     /* 1510668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1510679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1510682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1510688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510707 */     // MIs[0] round
     /* 1510707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510710 */     // MIs[0] policy
     /* 1510710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510720 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1510723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510744 */     // GIR_Coverage, 17981,
     /* 1510744 */     GIR_EraseRootFromParent_Done,
     /* 1510745 */   // Label 21042: @1510745
     /* 1510745 */   GIM_Try, /*On fail goto*//*Label 21043*/ GIMT_Encode4(1510827), // Rule ID 17984 //
     /* 1510750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1510753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1510761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1510764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1510767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1510770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1510785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510789 */     // MIs[0] round
     /* 1510789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510792 */     // MIs[0] policy
     /* 1510792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510802 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1510805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510826 */     // GIR_Coverage, 17984,
     /* 1510826 */     GIR_EraseRootFromParent_Done,
     /* 1510827 */   // Label 21043: @1510827
     /* 1510827 */   GIM_Try, /*On fail goto*//*Label 21044*/ GIMT_Encode4(1510909), // Rule ID 17985 //
     /* 1510832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1510835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1510843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1510846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1510849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1510852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1510867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510871 */     // MIs[0] round
     /* 1510871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510874 */     // MIs[0] policy
     /* 1510874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510884 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1510887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510908 */     // GIR_Coverage, 17985,
     /* 1510908 */     GIR_EraseRootFromParent_Done,
     /* 1510909 */   // Label 21044: @1510909
     /* 1510909 */   GIM_Try, /*On fail goto*//*Label 21045*/ GIMT_Encode4(1510991), // Rule ID 17988 //
     /* 1510914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1510917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1510925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1510928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1510931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1510934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1510949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510953 */     // MIs[0] round
     /* 1510953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510956 */     // MIs[0] policy
     /* 1510956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510966 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1510969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510990 */     // GIR_Coverage, 17988,
     /* 1510990 */     GIR_EraseRootFromParent_Done,
     /* 1510991 */   // Label 21045: @1510991
     /* 1510991 */   GIM_Try, /*On fail goto*//*Label 21046*/ GIMT_Encode4(1511073), // Rule ID 17989 //
     /* 1510996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1510999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1511007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1511010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1511016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511035 */     // MIs[0] round
     /* 1511035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511038 */     // MIs[0] policy
     /* 1511038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511048 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1511051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511072 */     // GIR_Coverage, 17989,
     /* 1511072 */     GIR_EraseRootFromParent_Done,
     /* 1511073 */   // Label 21046: @1511073
     /* 1511073 */   GIM_Try, /*On fail goto*//*Label 21047*/ GIMT_Encode4(1511155), // Rule ID 17992 //
     /* 1511078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1511081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1511098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511117 */     // MIs[0] round
     /* 1511117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511120 */     // MIs[0] policy
     /* 1511120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511130 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1511133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511154 */     // GIR_Coverage, 17992,
     /* 1511154 */     GIR_EraseRootFromParent_Done,
     /* 1511155 */   // Label 21047: @1511155
     /* 1511155 */   GIM_Try, /*On fail goto*//*Label 21048*/ GIMT_Encode4(1511237), // Rule ID 17993 //
     /* 1511160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1511180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511199 */     // MIs[0] round
     /* 1511199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511202 */     // MIs[0] policy
     /* 1511202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511212 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1511215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511236 */     // GIR_Coverage, 17993,
     /* 1511236 */     GIR_EraseRootFromParent_Done,
     /* 1511237 */   // Label 21048: @1511237
     /* 1511237 */   GIM_Try, /*On fail goto*//*Label 21049*/ GIMT_Encode4(1511319), // Rule ID 17996 //
     /* 1511242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1511253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1511256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1511259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1511262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511281 */     // MIs[0] round
     /* 1511281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511284 */     // MIs[0] policy
     /* 1511284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511294 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1511297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511318 */     // GIR_Coverage, 17996,
     /* 1511318 */     GIR_EraseRootFromParent_Done,
     /* 1511319 */   // Label 21049: @1511319
     /* 1511319 */   GIM_Try, /*On fail goto*//*Label 21050*/ GIMT_Encode4(1511401), // Rule ID 17997 //
     /* 1511324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1511335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1511338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1511341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1511344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511363 */     // MIs[0] round
     /* 1511363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511366 */     // MIs[0] policy
     /* 1511366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511376 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1511379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511400 */     // GIR_Coverage, 17997,
     /* 1511400 */     GIR_EraseRootFromParent_Done,
     /* 1511401 */   // Label 21050: @1511401
     /* 1511401 */   GIM_Try, /*On fail goto*//*Label 21051*/ GIMT_Encode4(1511483), // Rule ID 18000 //
     /* 1511406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1511417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1511420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1511423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1511426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511445 */     // MIs[0] round
     /* 1511445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511448 */     // MIs[0] policy
     /* 1511448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511458 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1511461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511482 */     // GIR_Coverage, 18000,
     /* 1511482 */     GIR_EraseRootFromParent_Done,
     /* 1511483 */   // Label 21051: @1511483
     /* 1511483 */   GIM_Try, /*On fail goto*//*Label 21052*/ GIMT_Encode4(1511565), // Rule ID 18001 //
     /* 1511488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1511499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1511502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1511505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1511508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511527 */     // MIs[0] round
     /* 1511527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511530 */     // MIs[0] policy
     /* 1511530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511540 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1511543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511564 */     // GIR_Coverage, 18001,
     /* 1511564 */     GIR_EraseRootFromParent_Done,
     /* 1511565 */   // Label 21052: @1511565
     /* 1511565 */   GIM_Try, /*On fail goto*//*Label 21053*/ GIMT_Encode4(1511647), // Rule ID 18004 //
     /* 1511570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1511573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1511581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1511584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1511587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1511590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511609 */     // MIs[0] round
     /* 1511609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511612 */     // MIs[0] policy
     /* 1511612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511622 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1511625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511646 */     // GIR_Coverage, 18004,
     /* 1511646 */     GIR_EraseRootFromParent_Done,
     /* 1511647 */   // Label 21053: @1511647
     /* 1511647 */   GIM_Try, /*On fail goto*//*Label 21054*/ GIMT_Encode4(1511729), // Rule ID 18005 //
     /* 1511652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1511655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1511663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1511666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1511669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1511672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511691 */     // MIs[0] round
     /* 1511691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511694 */     // MIs[0] policy
     /* 1511694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511704 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1511707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511728 */     // GIR_Coverage, 18005,
     /* 1511728 */     GIR_EraseRootFromParent_Done,
     /* 1511729 */   // Label 21054: @1511729
     /* 1511729 */   GIM_Try, /*On fail goto*//*Label 21055*/ GIMT_Encode4(1511811), // Rule ID 18008 //
     /* 1511734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1511745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1511748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1511751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1511754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511773 */     // MIs[0] round
     /* 1511773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511776 */     // MIs[0] policy
     /* 1511776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511786 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1511789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511810 */     // GIR_Coverage, 18008,
     /* 1511810 */     GIR_EraseRootFromParent_Done,
     /* 1511811 */   // Label 21055: @1511811
     /* 1511811 */   GIM_Try, /*On fail goto*//*Label 21056*/ GIMT_Encode4(1511893), // Rule ID 18009 //
     /* 1511816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1511827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1511830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1511833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1511836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511855 */     // MIs[0] round
     /* 1511855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511858 */     // MIs[0] policy
     /* 1511858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511868 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1511871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511892 */     // GIR_Coverage, 18009,
     /* 1511892 */     GIR_EraseRootFromParent_Done,
     /* 1511893 */   // Label 21056: @1511893
     /* 1511893 */   GIM_Try, /*On fail goto*//*Label 21057*/ GIMT_Encode4(1511975), // Rule ID 18012 //
     /* 1511898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1511901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1511909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1511912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1511915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1511918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511937 */     // MIs[0] round
     /* 1511937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511940 */     // MIs[0] policy
     /* 1511940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511950 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1511953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511974 */     // GIR_Coverage, 18012,
     /* 1511974 */     GIR_EraseRootFromParent_Done,
     /* 1511975 */   // Label 21057: @1511975
     /* 1511975 */   GIM_Try, /*On fail goto*//*Label 21058*/ GIMT_Encode4(1512057), // Rule ID 18013 //
     /* 1511980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1511983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1511991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1511994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1511997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1512000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512019 */     // MIs[0] round
     /* 1512019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512022 */     // MIs[0] policy
     /* 1512022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512032 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1512035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512056 */     // GIR_Coverage, 18013,
     /* 1512056 */     GIR_EraseRootFromParent_Done,
     /* 1512057 */   // Label 21058: @1512057
     /* 1512057 */   GIM_Try, /*On fail goto*//*Label 21059*/ GIMT_Encode4(1512139), // Rule ID 18016 //
     /* 1512062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1512065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1512073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1512076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1512079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1512082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512101 */     // MIs[0] round
     /* 1512101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512104 */     // MIs[0] policy
     /* 1512104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512114 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1512117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512138 */     // GIR_Coverage, 18016,
     /* 1512138 */     GIR_EraseRootFromParent_Done,
     /* 1512139 */   // Label 21059: @1512139
     /* 1512139 */   GIM_Try, /*On fail goto*//*Label 21060*/ GIMT_Encode4(1512221), // Rule ID 18017 //
     /* 1512144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1512147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1512155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1512158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1512161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1512164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512183 */     // MIs[0] round
     /* 1512183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512186 */     // MIs[0] policy
     /* 1512186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512196 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1512199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512220 */     // GIR_Coverage, 18017,
     /* 1512220 */     GIR_EraseRootFromParent_Done,
     /* 1512221 */   // Label 21060: @1512221
     /* 1512221 */   GIM_Try, /*On fail goto*//*Label 21061*/ GIMT_Encode4(1512303), // Rule ID 18020 //
     /* 1512226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1512237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1512240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1512243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1512246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512265 */     // MIs[0] round
     /* 1512265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512268 */     // MIs[0] policy
     /* 1512268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512278 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1512281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512302 */     // GIR_Coverage, 18020,
     /* 1512302 */     GIR_EraseRootFromParent_Done,
     /* 1512303 */   // Label 21061: @1512303
     /* 1512303 */   GIM_Try, /*On fail goto*//*Label 21062*/ GIMT_Encode4(1512385), // Rule ID 18021 //
     /* 1512308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1512319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1512322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1512325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1512328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512347 */     // MIs[0] round
     /* 1512347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512350 */     // MIs[0] policy
     /* 1512350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512360 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1512363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512384 */     // GIR_Coverage, 18021,
     /* 1512384 */     GIR_EraseRootFromParent_Done,
     /* 1512385 */   // Label 21062: @1512385
     /* 1512385 */   GIM_Try, /*On fail goto*//*Label 21063*/ GIMT_Encode4(1512467), // Rule ID 18024 //
     /* 1512390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1512401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1512404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1512407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1512410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512429 */     // MIs[0] round
     /* 1512429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512432 */     // MIs[0] policy
     /* 1512432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512442 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1512445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512466 */     // GIR_Coverage, 18024,
     /* 1512466 */     GIR_EraseRootFromParent_Done,
     /* 1512467 */   // Label 21063: @1512467
     /* 1512467 */   GIM_Try, /*On fail goto*//*Label 21064*/ GIMT_Encode4(1512549), // Rule ID 18025 //
     /* 1512472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1512483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1512486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1512489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1512492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512511 */     // MIs[0] round
     /* 1512511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512514 */     // MIs[0] policy
     /* 1512514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512524 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1512527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512548 */     // GIR_Coverage, 18025,
     /* 1512548 */     GIR_EraseRootFromParent_Done,
     /* 1512549 */   // Label 21064: @1512549
     /* 1512549 */   GIM_Try, /*On fail goto*//*Label 21065*/ GIMT_Encode4(1512631), // Rule ID 18028 //
     /* 1512554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1512565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1512568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1512571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1512574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512593 */     // MIs[0] round
     /* 1512593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512596 */     // MIs[0] policy
     /* 1512596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512606 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1512609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512630 */     // GIR_Coverage, 18028,
     /* 1512630 */     GIR_EraseRootFromParent_Done,
     /* 1512631 */   // Label 21065: @1512631
     /* 1512631 */   GIM_Try, /*On fail goto*//*Label 21066*/ GIMT_Encode4(1512713), // Rule ID 18029 //
     /* 1512636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1512647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1512650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1512653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1512656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512675 */     // MIs[0] round
     /* 1512675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512678 */     // MIs[0] policy
     /* 1512678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512688 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1512691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512712 */     // GIR_Coverage, 18029,
     /* 1512712 */     GIR_EraseRootFromParent_Done,
     /* 1512713 */   // Label 21066: @1512713
     /* 1512713 */   GIM_Try, /*On fail goto*//*Label 21067*/ GIMT_Encode4(1512795), // Rule ID 18032 //
     /* 1512718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1512721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1512729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1512732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1512735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1512738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512757 */     // MIs[0] round
     /* 1512757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512760 */     // MIs[0] policy
     /* 1512760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512770 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1512773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512794 */     // GIR_Coverage, 18032,
     /* 1512794 */     GIR_EraseRootFromParent_Done,
     /* 1512795 */   // Label 21067: @1512795
     /* 1512795 */   GIM_Try, /*On fail goto*//*Label 21068*/ GIMT_Encode4(1512877), // Rule ID 18033 //
     /* 1512800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1512803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1512811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1512814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1512817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1512820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512839 */     // MIs[0] round
     /* 1512839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512842 */     // MIs[0] policy
     /* 1512842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512852 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1512855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512876 */     // GIR_Coverage, 18033,
     /* 1512876 */     GIR_EraseRootFromParent_Done,
     /* 1512877 */   // Label 21068: @1512877
     /* 1512877 */   GIM_Try, /*On fail goto*//*Label 21069*/ GIMT_Encode4(1512959), // Rule ID 18036 //
     /* 1512882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1512885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1512893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1512896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1512899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1512902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512921 */     // MIs[0] round
     /* 1512921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512924 */     // MIs[0] policy
     /* 1512924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512934 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1512937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512958 */     // GIR_Coverage, 18036,
     /* 1512958 */     GIR_EraseRootFromParent_Done,
     /* 1512959 */   // Label 21069: @1512959
     /* 1512959 */   GIM_Try, /*On fail goto*//*Label 21070*/ GIMT_Encode4(1513041), // Rule ID 18037 //
     /* 1512964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1512967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1512975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1512978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1512981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1512984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513003 */     // MIs[0] round
     /* 1513003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513006 */     // MIs[0] policy
     /* 1513006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513016 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1513019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513040 */     // GIR_Coverage, 18037,
     /* 1513040 */     GIR_EraseRootFromParent_Done,
     /* 1513041 */   // Label 21070: @1513041
     /* 1513041 */   GIM_Try, /*On fail goto*//*Label 21071*/ GIMT_Encode4(1513123), // Rule ID 18040 //
     /* 1513046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1513063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1513066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513085 */     // MIs[0] round
     /* 1513085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513088 */     // MIs[0] policy
     /* 1513088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513098 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1513101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513122 */     // GIR_Coverage, 18040,
     /* 1513122 */     GIR_EraseRootFromParent_Done,
     /* 1513123 */   // Label 21071: @1513123
     /* 1513123 */   GIM_Try, /*On fail goto*//*Label 21072*/ GIMT_Encode4(1513205), // Rule ID 18041 //
     /* 1513128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1513145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1513148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513167 */     // MIs[0] round
     /* 1513167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513170 */     // MIs[0] policy
     /* 1513170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513180 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1513183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513204 */     // GIR_Coverage, 18041,
     /* 1513204 */     GIR_EraseRootFromParent_Done,
     /* 1513205 */   // Label 21072: @1513205
     /* 1513205 */   GIM_Try, /*On fail goto*//*Label 21073*/ GIMT_Encode4(1513287), // Rule ID 18044 //
     /* 1513210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1513221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1513224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1513227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1513230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513249 */     // MIs[0] round
     /* 1513249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513252 */     // MIs[0] policy
     /* 1513252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513262 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1513265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513286 */     // GIR_Coverage, 18044,
     /* 1513286 */     GIR_EraseRootFromParent_Done,
     /* 1513287 */   // Label 21073: @1513287
     /* 1513287 */   GIM_Try, /*On fail goto*//*Label 21074*/ GIMT_Encode4(1513369), // Rule ID 18045 //
     /* 1513292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1513303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1513306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1513309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1513312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513331 */     // MIs[0] round
     /* 1513331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513334 */     // MIs[0] policy
     /* 1513334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513344 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1513347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513368 */     // GIR_Coverage, 18045,
     /* 1513368 */     GIR_EraseRootFromParent_Done,
     /* 1513369 */   // Label 21074: @1513369
     /* 1513369 */   GIM_Try, /*On fail goto*//*Label 21075*/ GIMT_Encode4(1513451), // Rule ID 18048 //
     /* 1513374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1513385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1513388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1513391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1513394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513413 */     // MIs[0] round
     /* 1513413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513416 */     // MIs[0] policy
     /* 1513416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513426 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1513429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513450 */     // GIR_Coverage, 18048,
     /* 1513450 */     GIR_EraseRootFromParent_Done,
     /* 1513451 */   // Label 21075: @1513451
     /* 1513451 */   GIM_Try, /*On fail goto*//*Label 21076*/ GIMT_Encode4(1513533), // Rule ID 18049 //
     /* 1513456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1513467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1513470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1513473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1513476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513495 */     // MIs[0] round
     /* 1513495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513498 */     // MIs[0] policy
     /* 1513498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513508 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1513511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513532 */     // GIR_Coverage, 18049,
     /* 1513532 */     GIR_EraseRootFromParent_Done,
     /* 1513533 */   // Label 21076: @1513533
     /* 1513533 */   GIM_Try, /*On fail goto*//*Label 21077*/ GIMT_Encode4(1513615), // Rule ID 18052 //
     /* 1513538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1513549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1513552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1513555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1513558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513577 */     // MIs[0] round
     /* 1513577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513580 */     // MIs[0] policy
     /* 1513580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513590 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1513593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513614 */     // GIR_Coverage, 18052,
     /* 1513614 */     GIR_EraseRootFromParent_Done,
     /* 1513615 */   // Label 21077: @1513615
     /* 1513615 */   GIM_Try, /*On fail goto*//*Label 21078*/ GIMT_Encode4(1513697), // Rule ID 18053 //
     /* 1513620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1513631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1513634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1513637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1513640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513659 */     // MIs[0] round
     /* 1513659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513662 */     // MIs[0] policy
     /* 1513662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513672 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1513675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513696 */     // GIR_Coverage, 18053,
     /* 1513696 */     GIR_EraseRootFromParent_Done,
     /* 1513697 */   // Label 21078: @1513697
     /* 1513697 */   GIM_Try, /*On fail goto*//*Label 21079*/ GIMT_Encode4(1513779), // Rule ID 18056 //
     /* 1513702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1513713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1513716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1513722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513741 */     // MIs[0] round
     /* 1513741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513744 */     // MIs[0] policy
     /* 1513744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513754 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1513757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513778 */     // GIR_Coverage, 18056,
     /* 1513778 */     GIR_EraseRootFromParent_Done,
     /* 1513779 */   // Label 21079: @1513779
     /* 1513779 */   GIM_Try, /*On fail goto*//*Label 21080*/ GIMT_Encode4(1513861), // Rule ID 18057 //
     /* 1513784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1513787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1513795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1513798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1513804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513823 */     // MIs[0] round
     /* 1513823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513826 */     // MIs[0] policy
     /* 1513826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513836 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1513839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513860 */     // GIR_Coverage, 18057,
     /* 1513860 */     GIR_EraseRootFromParent_Done,
     /* 1513861 */   // Label 21080: @1513861
     /* 1513861 */   GIM_Try, /*On fail goto*//*Label 21081*/ GIMT_Encode4(1513943), // Rule ID 18060 //
     /* 1513866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1513877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1513880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1513886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513905 */     // MIs[0] round
     /* 1513905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513908 */     // MIs[0] policy
     /* 1513908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513918 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1513921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513942 */     // GIR_Coverage, 18060,
     /* 1513942 */     GIR_EraseRootFromParent_Done,
     /* 1513943 */   // Label 21081: @1513943
     /* 1513943 */   GIM_Try, /*On fail goto*//*Label 21082*/ GIMT_Encode4(1514025), // Rule ID 18061 //
     /* 1513948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1513951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1513959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1513962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1513968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513987 */     // MIs[0] round
     /* 1513987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513990 */     // MIs[0] policy
     /* 1513990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514000 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1514003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514024 */     // GIR_Coverage, 18061,
     /* 1514024 */     GIR_EraseRootFromParent_Done,
     /* 1514025 */   // Label 21082: @1514025
     /* 1514025 */   GIM_Try, /*On fail goto*//*Label 21083*/ GIMT_Encode4(1514107), // Rule ID 18064 //
     /* 1514030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1514041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1514044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1514050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514069 */     // MIs[0] round
     /* 1514069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514072 */     // MIs[0] policy
     /* 1514072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514082 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1514085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514106 */     // GIR_Coverage, 18064,
     /* 1514106 */     GIR_EraseRootFromParent_Done,
     /* 1514107 */   // Label 21083: @1514107
     /* 1514107 */   GIM_Try, /*On fail goto*//*Label 21084*/ GIMT_Encode4(1514189), // Rule ID 18065 //
     /* 1514112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1514123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1514126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1514132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514151 */     // MIs[0] round
     /* 1514151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514154 */     // MIs[0] policy
     /* 1514154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514164 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1514167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514188 */     // GIR_Coverage, 18065,
     /* 1514188 */     GIR_EraseRootFromParent_Done,
     /* 1514189 */   // Label 21084: @1514189
     /* 1514189 */   GIM_Try, /*On fail goto*//*Label 21085*/ GIMT_Encode4(1514271), // Rule ID 18068 //
     /* 1514194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1514205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1514208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1514214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514233 */     // MIs[0] round
     /* 1514233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514236 */     // MIs[0] policy
     /* 1514236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514246 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1514249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514270 */     // GIR_Coverage, 18068,
     /* 1514270 */     GIR_EraseRootFromParent_Done,
     /* 1514271 */   // Label 21085: @1514271
     /* 1514271 */   GIM_Try, /*On fail goto*//*Label 21086*/ GIMT_Encode4(1514353), // Rule ID 18069 //
     /* 1514276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1514287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1514290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1514296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514315 */     // MIs[0] round
     /* 1514315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514318 */     // MIs[0] policy
     /* 1514318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514328 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1514331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514352 */     // GIR_Coverage, 18069,
     /* 1514352 */     GIR_EraseRootFromParent_Done,
     /* 1514353 */   // Label 21086: @1514353
     /* 1514353 */   GIM_Try, /*On fail goto*//*Label 21087*/ GIMT_Encode4(1514435), // Rule ID 18072 //
     /* 1514358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1514369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1514372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1514378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514397 */     // MIs[0] round
     /* 1514397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514400 */     // MIs[0] policy
     /* 1514400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514410 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1514413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514434 */     // GIR_Coverage, 18072,
     /* 1514434 */     GIR_EraseRootFromParent_Done,
     /* 1514435 */   // Label 21087: @1514435
     /* 1514435 */   GIM_Try, /*On fail goto*//*Label 21088*/ GIMT_Encode4(1514517), // Rule ID 18073 //
     /* 1514440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1514451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1514454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1514460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514479 */     // MIs[0] round
     /* 1514479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514482 */     // MIs[0] policy
     /* 1514482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514492 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1514495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514516 */     // GIR_Coverage, 18073,
     /* 1514516 */     GIR_EraseRootFromParent_Done,
     /* 1514517 */   // Label 21088: @1514517
     /* 1514517 */   GIM_Try, /*On fail goto*//*Label 21089*/ GIMT_Encode4(1514599), // Rule ID 18076 //
     /* 1514522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1514525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1514533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1514536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1514542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514561 */     // MIs[0] round
     /* 1514561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514564 */     // MIs[0] policy
     /* 1514564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514574 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1514577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514598 */     // GIR_Coverage, 18076,
     /* 1514598 */     GIR_EraseRootFromParent_Done,
     /* 1514599 */   // Label 21089: @1514599
     /* 1514599 */   GIM_Try, /*On fail goto*//*Label 21090*/ GIMT_Encode4(1514681), // Rule ID 18077 //
     /* 1514604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1514607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1514615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1514618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1514624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514643 */     // MIs[0] round
     /* 1514643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514646 */     // MIs[0] policy
     /* 1514646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514656 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1514659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514680 */     // GIR_Coverage, 18077,
     /* 1514680 */     GIR_EraseRootFromParent_Done,
     /* 1514681 */   // Label 21090: @1514681
     /* 1514681 */   GIM_Try, /*On fail goto*//*Label 21091*/ GIMT_Encode4(1514763), // Rule ID 18080 //
     /* 1514686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1514697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1514700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1514706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514725 */     // MIs[0] round
     /* 1514725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514728 */     // MIs[0] policy
     /* 1514728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514738 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1514741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514762 */     // GIR_Coverage, 18080,
     /* 1514762 */     GIR_EraseRootFromParent_Done,
     /* 1514763 */   // Label 21091: @1514763
     /* 1514763 */   GIM_Try, /*On fail goto*//*Label 21092*/ GIMT_Encode4(1514845), // Rule ID 18081 //
     /* 1514768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1514779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1514782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1514788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514807 */     // MIs[0] round
     /* 1514807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514810 */     // MIs[0] policy
     /* 1514810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514820 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1514823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514844 */     // GIR_Coverage, 18081,
     /* 1514844 */     GIR_EraseRootFromParent_Done,
     /* 1514845 */   // Label 21092: @1514845
     /* 1514845 */   GIM_Try, /*On fail goto*//*Label 21093*/ GIMT_Encode4(1514927), // Rule ID 18084 //
     /* 1514850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1514861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1514864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1514870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514889 */     // MIs[0] round
     /* 1514889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514892 */     // MIs[0] policy
     /* 1514892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514902 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1514905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514926 */     // GIR_Coverage, 18084,
     /* 1514926 */     GIR_EraseRootFromParent_Done,
     /* 1514927 */   // Label 21093: @1514927
     /* 1514927 */   GIM_Try, /*On fail goto*//*Label 21094*/ GIMT_Encode4(1515009), // Rule ID 18085 //
     /* 1514932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1514943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1514946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1514952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514971 */     // MIs[0] round
     /* 1514971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514974 */     // MIs[0] policy
     /* 1514974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514984 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1514987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515008 */     // GIR_Coverage, 18085,
     /* 1515008 */     GIR_EraseRootFromParent_Done,
     /* 1515009 */   // Label 21094: @1515009
     /* 1515009 */   GIM_Try, /*On fail goto*//*Label 21095*/ GIMT_Encode4(1515091), // Rule ID 18088 //
     /* 1515014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1515034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515053 */     // MIs[0] round
     /* 1515053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515056 */     // MIs[0] policy
     /* 1515056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515066 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1515069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515090 */     // GIR_Coverage, 18088,
     /* 1515090 */     GIR_EraseRootFromParent_Done,
     /* 1515091 */   // Label 21095: @1515091
     /* 1515091 */   GIM_Try, /*On fail goto*//*Label 21096*/ GIMT_Encode4(1515173), // Rule ID 18089 //
     /* 1515096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1515116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515135 */     // MIs[0] round
     /* 1515135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515138 */     // MIs[0] policy
     /* 1515138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515148 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1515151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515172 */     // GIR_Coverage, 18089,
     /* 1515172 */     GIR_EraseRootFromParent_Done,
     /* 1515173 */   // Label 21096: @1515173
     /* 1515173 */   GIM_Try, /*On fail goto*//*Label 21097*/ GIMT_Encode4(1515255), // Rule ID 18092 //
     /* 1515178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1515189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1515192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1515198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515217 */     // MIs[0] round
     /* 1515217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515220 */     // MIs[0] policy
     /* 1515220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515230 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1515233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515254 */     // GIR_Coverage, 18092,
     /* 1515254 */     GIR_EraseRootFromParent_Done,
     /* 1515255 */   // Label 21097: @1515255
     /* 1515255 */   GIM_Try, /*On fail goto*//*Label 21098*/ GIMT_Encode4(1515337), // Rule ID 18093 //
     /* 1515260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1515271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1515274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1515280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515299 */     // MIs[0] round
     /* 1515299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515302 */     // MIs[0] policy
     /* 1515302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515312 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1515315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515336 */     // GIR_Coverage, 18093,
     /* 1515336 */     GIR_EraseRootFromParent_Done,
     /* 1515337 */   // Label 21098: @1515337
     /* 1515337 */   GIM_Try, /*On fail goto*//*Label 21099*/ GIMT_Encode4(1515419), // Rule ID 18096 //
     /* 1515342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1515353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1515356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1515362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515381 */     // MIs[0] round
     /* 1515381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515384 */     // MIs[0] policy
     /* 1515384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515394 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1515397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515418 */     // GIR_Coverage, 18096,
     /* 1515418 */     GIR_EraseRootFromParent_Done,
     /* 1515419 */   // Label 21099: @1515419
     /* 1515419 */   GIM_Try, /*On fail goto*//*Label 21100*/ GIMT_Encode4(1515501), // Rule ID 18097 //
     /* 1515424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1515435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1515438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1515444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515463 */     // MIs[0] round
     /* 1515463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515466 */     // MIs[0] policy
     /* 1515466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515476 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1515479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515500 */     // GIR_Coverage, 18097,
     /* 1515500 */     GIR_EraseRootFromParent_Done,
     /* 1515501 */   // Label 21100: @1515501
     /* 1515501 */   GIM_Try, /*On fail goto*//*Label 21101*/ GIMT_Encode4(1515583), // Rule ID 18100 //
     /* 1515506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1515517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1515520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1515526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515545 */     // MIs[0] round
     /* 1515545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515548 */     // MIs[0] policy
     /* 1515548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515558 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1515561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515582 */     // GIR_Coverage, 18100,
     /* 1515582 */     GIR_EraseRootFromParent_Done,
     /* 1515583 */   // Label 21101: @1515583
     /* 1515583 */   GIM_Try, /*On fail goto*//*Label 21102*/ GIMT_Encode4(1515665), // Rule ID 18101 //
     /* 1515588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1515599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1515602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1515608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515627 */     // MIs[0] round
     /* 1515627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515630 */     // MIs[0] policy
     /* 1515630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515640 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1515643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515664 */     // GIR_Coverage, 18101,
     /* 1515664 */     GIR_EraseRootFromParent_Done,
     /* 1515665 */   // Label 21102: @1515665
     /* 1515665 */   GIM_Try, /*On fail goto*//*Label 21103*/ GIMT_Encode4(1515747), // Rule ID 18104 //
     /* 1515670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1515673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1515681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1515684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1515687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1515690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1515705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515709 */     // MIs[0] round
     /* 1515709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515712 */     // MIs[0] policy
     /* 1515712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515722 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1515725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515746 */     // GIR_Coverage, 18104,
     /* 1515746 */     GIR_EraseRootFromParent_Done,
     /* 1515747 */   // Label 21103: @1515747
     /* 1515747 */   GIM_Try, /*On fail goto*//*Label 21104*/ GIMT_Encode4(1515829), // Rule ID 18105 //
     /* 1515752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1515755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1515763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1515766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1515769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1515772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1515787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515791 */     // MIs[0] round
     /* 1515791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515794 */     // MIs[0] policy
     /* 1515794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515804 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1515807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515828 */     // GIR_Coverage, 18105,
     /* 1515828 */     GIR_EraseRootFromParent_Done,
     /* 1515829 */   // Label 21104: @1515829
     /* 1515829 */   GIM_Try, /*On fail goto*//*Label 21105*/ GIMT_Encode4(1515911), // Rule ID 18108 //
     /* 1515834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1515837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1515845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1515848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1515851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1515854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1515869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515873 */     // MIs[0] round
     /* 1515873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515876 */     // MIs[0] policy
     /* 1515876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515886 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1515889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515910 */     // GIR_Coverage, 18108,
     /* 1515910 */     GIR_EraseRootFromParent_Done,
     /* 1515911 */   // Label 21105: @1515911
     /* 1515911 */   GIM_Try, /*On fail goto*//*Label 21106*/ GIMT_Encode4(1515993), // Rule ID 18109 //
     /* 1515916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1515919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1515927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1515930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1515933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1515936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1515951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515955 */     // MIs[0] round
     /* 1515955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515958 */     // MIs[0] policy
     /* 1515958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515968 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1515971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515992 */     // GIR_Coverage, 18109,
     /* 1515992 */     GIR_EraseRootFromParent_Done,
     /* 1515993 */   // Label 21106: @1515993
     /* 1515993 */   GIM_Try, /*On fail goto*//*Label 21107*/ GIMT_Encode4(1516075), // Rule ID 18112 //
     /* 1515998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1516009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1516018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516037 */     // MIs[0] round
     /* 1516037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516040 */     // MIs[0] policy
     /* 1516040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516050 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1516053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516074 */     // GIR_Coverage, 18112,
     /* 1516074 */     GIR_EraseRootFromParent_Done,
     /* 1516075 */   // Label 21107: @1516075
     /* 1516075 */   GIM_Try, /*On fail goto*//*Label 21108*/ GIMT_Encode4(1516157), // Rule ID 18113 //
     /* 1516080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1516083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1516091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1516100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516119 */     // MIs[0] round
     /* 1516119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516122 */     // MIs[0] policy
     /* 1516122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516132 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1516135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516156 */     // GIR_Coverage, 18113,
     /* 1516156 */     GIR_EraseRootFromParent_Done,
     /* 1516157 */   // Label 21108: @1516157
     /* 1516157 */   GIM_Try, /*On fail goto*//*Label 21109*/ GIMT_Encode4(1516239), // Rule ID 18116 //
     /* 1516162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1516173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1516176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1516179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1516182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516201 */     // MIs[0] round
     /* 1516201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516204 */     // MIs[0] policy
     /* 1516204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516214 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1516217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516238 */     // GIR_Coverage, 18116,
     /* 1516238 */     GIR_EraseRootFromParent_Done,
     /* 1516239 */   // Label 21109: @1516239
     /* 1516239 */   GIM_Try, /*On fail goto*//*Label 21110*/ GIMT_Encode4(1516321), // Rule ID 18117 //
     /* 1516244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1516255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1516258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1516261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1516264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516283 */     // MIs[0] round
     /* 1516283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516286 */     // MIs[0] policy
     /* 1516286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516296 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1516299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516320 */     // GIR_Coverage, 18117,
     /* 1516320 */     GIR_EraseRootFromParent_Done,
     /* 1516321 */   // Label 21110: @1516321
     /* 1516321 */   GIM_Try, /*On fail goto*//*Label 21111*/ GIMT_Encode4(1516403), // Rule ID 18120 //
     /* 1516326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1516337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1516340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1516343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1516346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516365 */     // MIs[0] round
     /* 1516365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516368 */     // MIs[0] policy
     /* 1516368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516378 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1516381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516402 */     // GIR_Coverage, 18120,
     /* 1516402 */     GIR_EraseRootFromParent_Done,
     /* 1516403 */   // Label 21111: @1516403
     /* 1516403 */   GIM_Try, /*On fail goto*//*Label 21112*/ GIMT_Encode4(1516485), // Rule ID 18121 //
     /* 1516408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1516419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1516422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1516425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1516428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516447 */     // MIs[0] round
     /* 1516447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516450 */     // MIs[0] policy
     /* 1516450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516460 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1516463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516484 */     // GIR_Coverage, 18121,
     /* 1516484 */     GIR_EraseRootFromParent_Done,
     /* 1516485 */   // Label 21112: @1516485
     /* 1516485 */   GIM_Try, /*On fail goto*//*Label 21113*/ GIMT_Encode4(1516567), // Rule ID 18124 //
     /* 1516490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1516493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1516501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1516504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1516507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1516510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516529 */     // MIs[0] round
     /* 1516529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516532 */     // MIs[0] policy
     /* 1516532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516542 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1516545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516566 */     // GIR_Coverage, 18124,
     /* 1516566 */     GIR_EraseRootFromParent_Done,
     /* 1516567 */   // Label 21113: @1516567
     /* 1516567 */   GIM_Try, /*On fail goto*//*Label 21114*/ GIMT_Encode4(1516649), // Rule ID 18125 //
     /* 1516572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1516575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1516583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1516586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1516589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1516592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516611 */     // MIs[0] round
     /* 1516611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516614 */     // MIs[0] policy
     /* 1516614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516624 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1516627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516648 */     // GIR_Coverage, 18125,
     /* 1516648 */     GIR_EraseRootFromParent_Done,
     /* 1516649 */   // Label 21114: @1516649
     /* 1516649 */   GIM_Try, /*On fail goto*//*Label 21115*/ GIMT_Encode4(1516731), // Rule ID 18128 //
     /* 1516654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1516665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1516668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1516671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1516674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516693 */     // MIs[0] round
     /* 1516693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516696 */     // MIs[0] policy
     /* 1516696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516706 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1516709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516730 */     // GIR_Coverage, 18128,
     /* 1516730 */     GIR_EraseRootFromParent_Done,
     /* 1516731 */   // Label 21115: @1516731
     /* 1516731 */   GIM_Try, /*On fail goto*//*Label 21116*/ GIMT_Encode4(1516813), // Rule ID 18129 //
     /* 1516736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1516747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1516750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1516753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1516756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516775 */     // MIs[0] round
     /* 1516775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516778 */     // MIs[0] policy
     /* 1516778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516788 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1516791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516812 */     // GIR_Coverage, 18129,
     /* 1516812 */     GIR_EraseRootFromParent_Done,
     /* 1516813 */   // Label 21116: @1516813
     /* 1516813 */   GIM_Try, /*On fail goto*//*Label 21117*/ GIMT_Encode4(1516895), // Rule ID 18132 //
     /* 1516818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1516821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1516829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1516832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1516835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1516838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516857 */     // MIs[0] round
     /* 1516857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516860 */     // MIs[0] policy
     /* 1516860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516870 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1516873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516894 */     // GIR_Coverage, 18132,
     /* 1516894 */     GIR_EraseRootFromParent_Done,
     /* 1516895 */   // Label 21117: @1516895
     /* 1516895 */   GIM_Try, /*On fail goto*//*Label 21118*/ GIMT_Encode4(1516977), // Rule ID 18133 //
     /* 1516900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1516903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1516911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1516914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1516917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1516920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516939 */     // MIs[0] round
     /* 1516939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516942 */     // MIs[0] policy
     /* 1516942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516952 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1516955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516976 */     // GIR_Coverage, 18133,
     /* 1516976 */     GIR_EraseRootFromParent_Done,
     /* 1516977 */   // Label 21118: @1516977
     /* 1516977 */   GIM_Try, /*On fail goto*//*Label 21119*/ GIMT_Encode4(1517059), // Rule ID 18136 //
     /* 1516982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1516993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1516996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1516999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1517002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517021 */     // MIs[0] round
     /* 1517021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517024 */     // MIs[0] policy
     /* 1517024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517034 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1517037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517058 */     // GIR_Coverage, 18136,
     /* 1517058 */     GIR_EraseRootFromParent_Done,
     /* 1517059 */   // Label 21119: @1517059
     /* 1517059 */   GIM_Try, /*On fail goto*//*Label 21120*/ GIMT_Encode4(1517141), // Rule ID 18137 //
     /* 1517064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1517067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1517075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1517078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1517081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1517084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517103 */     // MIs[0] round
     /* 1517103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517106 */     // MIs[0] policy
     /* 1517106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517116 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1517119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517140 */     // GIR_Coverage, 18137,
     /* 1517140 */     GIR_EraseRootFromParent_Done,
     /* 1517141 */   // Label 21120: @1517141
     /* 1517141 */   GIM_Try, /*On fail goto*//*Label 21121*/ GIMT_Encode4(1517223), // Rule ID 18140 //
     /* 1517146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1517157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1517160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1517163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1517166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517185 */     // MIs[0] round
     /* 1517185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517188 */     // MIs[0] policy
     /* 1517188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517198 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1517201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517222 */     // GIR_Coverage, 18140,
     /* 1517222 */     GIR_EraseRootFromParent_Done,
     /* 1517223 */   // Label 21121: @1517223
     /* 1517223 */   GIM_Try, /*On fail goto*//*Label 21122*/ GIMT_Encode4(1517305), // Rule ID 18141 //
     /* 1517228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1517239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1517242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1517245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1517248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517267 */     // MIs[0] round
     /* 1517267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517270 */     // MIs[0] policy
     /* 1517270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517280 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1517283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517304 */     // GIR_Coverage, 18141,
     /* 1517304 */     GIR_EraseRootFromParent_Done,
     /* 1517305 */   // Label 21122: @1517305
     /* 1517305 */   GIM_Try, /*On fail goto*//*Label 21123*/ GIMT_Encode4(1517387), // Rule ID 18144 //
     /* 1517310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1517321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1517324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1517327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1517330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517349 */     // MIs[0] round
     /* 1517349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517352 */     // MIs[0] policy
     /* 1517352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517362 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1517365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517386 */     // GIR_Coverage, 18144,
     /* 1517386 */     GIR_EraseRootFromParent_Done,
     /* 1517387 */   // Label 21123: @1517387
     /* 1517387 */   GIM_Try, /*On fail goto*//*Label 21124*/ GIMT_Encode4(1517469), // Rule ID 18145 //
     /* 1517392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1517403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1517406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1517409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1517412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517431 */     // MIs[0] round
     /* 1517431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517434 */     // MIs[0] policy
     /* 1517434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517444 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1517447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517468 */     // GIR_Coverage, 18145,
     /* 1517468 */     GIR_EraseRootFromParent_Done,
     /* 1517469 */   // Label 21124: @1517469
     /* 1517469 */   GIM_Try, /*On fail goto*//*Label 21125*/ GIMT_Encode4(1517551), // Rule ID 18148 //
     /* 1517474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1517485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1517488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1517491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1517494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517513 */     // MIs[0] round
     /* 1517513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517516 */     // MIs[0] policy
     /* 1517516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517526 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1517529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517550 */     // GIR_Coverage, 18148,
     /* 1517550 */     GIR_EraseRootFromParent_Done,
     /* 1517551 */   // Label 21125: @1517551
     /* 1517551 */   GIM_Try, /*On fail goto*//*Label 21126*/ GIMT_Encode4(1517633), // Rule ID 18149 //
     /* 1517556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1517567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1517570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1517573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1517576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517595 */     // MIs[0] round
     /* 1517595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517598 */     // MIs[0] policy
     /* 1517598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517608 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1517611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517632 */     // GIR_Coverage, 18149,
     /* 1517632 */     GIR_EraseRootFromParent_Done,
     /* 1517633 */   // Label 21126: @1517633
     /* 1517633 */   GIM_Try, /*On fail goto*//*Label 21127*/ GIMT_Encode4(1517715), // Rule ID 18152 //
     /* 1517638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1517641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1517649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1517652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1517655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1517658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517677 */     // MIs[0] round
     /* 1517677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517680 */     // MIs[0] policy
     /* 1517680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517690 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1517693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517714 */     // GIR_Coverage, 18152,
     /* 1517714 */     GIR_EraseRootFromParent_Done,
     /* 1517715 */   // Label 21127: @1517715
     /* 1517715 */   GIM_Try, /*On fail goto*//*Label 21128*/ GIMT_Encode4(1517797), // Rule ID 18153 //
     /* 1517720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1517723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1517731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1517734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1517737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1517740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517759 */     // MIs[0] round
     /* 1517759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517762 */     // MIs[0] policy
     /* 1517762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517772 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1517775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517796 */     // GIR_Coverage, 18153,
     /* 1517796 */     GIR_EraseRootFromParent_Done,
     /* 1517797 */   // Label 21128: @1517797
     /* 1517797 */   GIM_Try, /*On fail goto*//*Label 21129*/ GIMT_Encode4(1517879), // Rule ID 18156 //
     /* 1517802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1517805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1517813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1517816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1517819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1517822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517841 */     // MIs[0] round
     /* 1517841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517844 */     // MIs[0] policy
     /* 1517844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517854 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1517857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517878 */     // GIR_Coverage, 18156,
     /* 1517878 */     GIR_EraseRootFromParent_Done,
     /* 1517879 */   // Label 21129: @1517879
     /* 1517879 */   GIM_Try, /*On fail goto*//*Label 21130*/ GIMT_Encode4(1517961), // Rule ID 18157 //
     /* 1517884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1517887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1517895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1517898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1517901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1517904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517923 */     // MIs[0] round
     /* 1517923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517926 */     // MIs[0] policy
     /* 1517926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517936 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1517939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517960 */     // GIR_Coverage, 18157,
     /* 1517960 */     GIR_EraseRootFromParent_Done,
     /* 1517961 */   // Label 21130: @1517961
     /* 1517961 */   GIM_Try, /*On fail goto*//*Label 21131*/ GIMT_Encode4(1518043), // Rule ID 18160 //
     /* 1517966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1517969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1517977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1517980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1517983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1517986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518005 */     // MIs[0] round
     /* 1518005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518008 */     // MIs[0] policy
     /* 1518008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518018 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1518021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518042 */     // GIR_Coverage, 18160,
     /* 1518042 */     GIR_EraseRootFromParent_Done,
     /* 1518043 */   // Label 21131: @1518043
     /* 1518043 */   GIM_Try, /*On fail goto*//*Label 21132*/ GIMT_Encode4(1518125), // Rule ID 18161 //
     /* 1518048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1518059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1518062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1518065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1518068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518087 */     // MIs[0] round
     /* 1518087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518090 */     // MIs[0] policy
     /* 1518090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518100 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1518103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518124 */     // GIR_Coverage, 18161,
     /* 1518124 */     GIR_EraseRootFromParent_Done,
     /* 1518125 */   // Label 21132: @1518125
     /* 1518125 */   GIM_Try, /*On fail goto*//*Label 21133*/ GIMT_Encode4(1518207), // Rule ID 18164 //
     /* 1518130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1518141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1518144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1518147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1518150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518169 */     // MIs[0] round
     /* 1518169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518172 */     // MIs[0] policy
     /* 1518172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518182 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1518185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518206 */     // GIR_Coverage, 18164,
     /* 1518206 */     GIR_EraseRootFromParent_Done,
     /* 1518207 */   // Label 21133: @1518207
     /* 1518207 */   GIM_Try, /*On fail goto*//*Label 21134*/ GIMT_Encode4(1518289), // Rule ID 18165 //
     /* 1518212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1518223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1518226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1518229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1518232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518251 */     // MIs[0] round
     /* 1518251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518254 */     // MIs[0] policy
     /* 1518254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518264 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1518267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518288 */     // GIR_Coverage, 18165,
     /* 1518288 */     GIR_EraseRootFromParent_Done,
     /* 1518289 */   // Label 21134: @1518289
     /* 1518289 */   GIM_Try, /*On fail goto*//*Label 21135*/ GIMT_Encode4(1518371), // Rule ID 18168 //
     /* 1518294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1518305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1518308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1518311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1518314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518333 */     // MIs[0] round
     /* 1518333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518336 */     // MIs[0] policy
     /* 1518336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518346 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1518349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518370 */     // GIR_Coverage, 18168,
     /* 1518370 */     GIR_EraseRootFromParent_Done,
     /* 1518371 */   // Label 21135: @1518371
     /* 1518371 */   GIM_Try, /*On fail goto*//*Label 21136*/ GIMT_Encode4(1518453), // Rule ID 18169 //
     /* 1518376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1518387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1518390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1518393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1518396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518415 */     // MIs[0] round
     /* 1518415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518418 */     // MIs[0] policy
     /* 1518418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518428 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1518431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518452 */     // GIR_Coverage, 18169,
     /* 1518452 */     GIR_EraseRootFromParent_Done,
     /* 1518453 */   // Label 21136: @1518453
     /* 1518453 */   GIM_Try, /*On fail goto*//*Label 21137*/ GIMT_Encode4(1518535), // Rule ID 18172 //
     /* 1518458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1518469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1518472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1518475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1518478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518497 */     // MIs[0] round
     /* 1518497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518500 */     // MIs[0] policy
     /* 1518500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518510 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1518513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518534 */     // GIR_Coverage, 18172,
     /* 1518534 */     GIR_EraseRootFromParent_Done,
     /* 1518535 */   // Label 21137: @1518535
     /* 1518535 */   GIM_Try, /*On fail goto*//*Label 21138*/ GIMT_Encode4(1518617), // Rule ID 18173 //
     /* 1518540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1518551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1518554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1518557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1518560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518579 */     // MIs[0] round
     /* 1518579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518582 */     // MIs[0] policy
     /* 1518582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518592 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1518595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518616 */     // GIR_Coverage, 18173,
     /* 1518616 */     GIR_EraseRootFromParent_Done,
     /* 1518617 */   // Label 21138: @1518617
     /* 1518617 */   GIM_Try, /*On fail goto*//*Label 21139*/ GIMT_Encode4(1518699), // Rule ID 18176 //
     /* 1518622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1518625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1518633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1518636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1518642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518661 */     // MIs[0] round
     /* 1518661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518664 */     // MIs[0] policy
     /* 1518664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518674 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1518677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518698 */     // GIR_Coverage, 18176,
     /* 1518698 */     GIR_EraseRootFromParent_Done,
     /* 1518699 */   // Label 21139: @1518699
     /* 1518699 */   GIM_Try, /*On fail goto*//*Label 21140*/ GIMT_Encode4(1518781), // Rule ID 18177 //
     /* 1518704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1518715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1518718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1518724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518743 */     // MIs[0] round
     /* 1518743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518746 */     // MIs[0] policy
     /* 1518746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518756 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1518759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518780 */     // GIR_Coverage, 18177,
     /* 1518780 */     GIR_EraseRootFromParent_Done,
     /* 1518781 */   // Label 21140: @1518781
     /* 1518781 */   GIM_Try, /*On fail goto*//*Label 21141*/ GIMT_Encode4(1518863), // Rule ID 18180 //
     /* 1518786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1518789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1518797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1518800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1518806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518825 */     // MIs[0] round
     /* 1518825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518828 */     // MIs[0] policy
     /* 1518828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518838 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1518841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518862 */     // GIR_Coverage, 18180,
     /* 1518862 */     GIR_EraseRootFromParent_Done,
     /* 1518863 */   // Label 21141: @1518863
     /* 1518863 */   GIM_Try, /*On fail goto*//*Label 21142*/ GIMT_Encode4(1518945), // Rule ID 18181 //
     /* 1518868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1518879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1518882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1518888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518907 */     // MIs[0] round
     /* 1518907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518910 */     // MIs[0] policy
     /* 1518910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518920 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1518923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518944 */     // GIR_Coverage, 18181,
     /* 1518944 */     GIR_EraseRootFromParent_Done,
     /* 1518945 */   // Label 21142: @1518945
     /* 1518945 */   GIM_Try, /*On fail goto*//*Label 21143*/ GIMT_Encode4(1519027), // Rule ID 18184 //
     /* 1518950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1518961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1518964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1518970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518989 */     // MIs[0] round
     /* 1518989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518992 */     // MIs[0] policy
     /* 1518992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519002 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1519005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519026 */     // GIR_Coverage, 18184,
     /* 1519026 */     GIR_EraseRootFromParent_Done,
     /* 1519027 */   // Label 21143: @1519027
     /* 1519027 */   GIM_Try, /*On fail goto*//*Label 21144*/ GIMT_Encode4(1519109), // Rule ID 18185 //
     /* 1519032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1519043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1519046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1519052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519071 */     // MIs[0] round
     /* 1519071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519074 */     // MIs[0] policy
     /* 1519074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519084 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1519087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519108 */     // GIR_Coverage, 18185,
     /* 1519108 */     GIR_EraseRootFromParent_Done,
     /* 1519109 */   // Label 21144: @1519109
     /* 1519109 */   GIM_Try, /*On fail goto*//*Label 21145*/ GIMT_Encode4(1519191), // Rule ID 18188 //
     /* 1519114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1519134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519153 */     // MIs[0] round
     /* 1519153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519156 */     // MIs[0] policy
     /* 1519156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519166 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1519169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519190 */     // GIR_Coverage, 18188,
     /* 1519190 */     GIR_EraseRootFromParent_Done,
     /* 1519191 */   // Label 21145: @1519191
     /* 1519191 */   GIM_Try, /*On fail goto*//*Label 21146*/ GIMT_Encode4(1519273), // Rule ID 18189 //
     /* 1519196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1519216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519235 */     // MIs[0] round
     /* 1519235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519238 */     // MIs[0] policy
     /* 1519238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519248 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1519251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519272 */     // GIR_Coverage, 18189,
     /* 1519272 */     GIR_EraseRootFromParent_Done,
     /* 1519273 */   // Label 21146: @1519273
     /* 1519273 */   GIM_Try, /*On fail goto*//*Label 21147*/ GIMT_Encode4(1519355), // Rule ID 18192 //
     /* 1519278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1519281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1519289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1519292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1519298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519317 */     // MIs[0] round
     /* 1519317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519320 */     // MIs[0] policy
     /* 1519320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519330 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1519333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519354 */     // GIR_Coverage, 18192,
     /* 1519354 */     GIR_EraseRootFromParent_Done,
     /* 1519355 */   // Label 21147: @1519355
     /* 1519355 */   GIM_Try, /*On fail goto*//*Label 21148*/ GIMT_Encode4(1519437), // Rule ID 18193 //
     /* 1519360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1519371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1519374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1519380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519399 */     // MIs[0] round
     /* 1519399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519402 */     // MIs[0] policy
     /* 1519402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519412 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1519415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519436 */     // GIR_Coverage, 18193,
     /* 1519436 */     GIR_EraseRootFromParent_Done,
     /* 1519437 */   // Label 21148: @1519437
     /* 1519437 */   GIM_Try, /*On fail goto*//*Label 21149*/ GIMT_Encode4(1519519), // Rule ID 18196 //
     /* 1519442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1519445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1519453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1519456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1519462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519481 */     // MIs[0] round
     /* 1519481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519484 */     // MIs[0] policy
     /* 1519484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519494 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1519497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519518 */     // GIR_Coverage, 18196,
     /* 1519518 */     GIR_EraseRootFromParent_Done,
     /* 1519519 */   // Label 21149: @1519519
     /* 1519519 */   GIM_Try, /*On fail goto*//*Label 21150*/ GIMT_Encode4(1519601), // Rule ID 18197 //
     /* 1519524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1519527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1519535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1519538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1519544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519563 */     // MIs[0] round
     /* 1519563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519566 */     // MIs[0] policy
     /* 1519566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519576 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1519579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519600 */     // GIR_Coverage, 18197,
     /* 1519600 */     GIR_EraseRootFromParent_Done,
     /* 1519601 */   // Label 21150: @1519601
     /* 1519601 */   GIM_Try, /*On fail goto*//*Label 21151*/ GIMT_Encode4(1519683), // Rule ID 18200 //
     /* 1519606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1519617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1519620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1519626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519645 */     // MIs[0] round
     /* 1519645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519648 */     // MIs[0] policy
     /* 1519648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519658 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1519661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519682 */     // GIR_Coverage, 18200,
     /* 1519682 */     GIR_EraseRootFromParent_Done,
     /* 1519683 */   // Label 21151: @1519683
     /* 1519683 */   GIM_Try, /*On fail goto*//*Label 21152*/ GIMT_Encode4(1519765), // Rule ID 18201 //
     /* 1519688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1519699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1519702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1519708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519727 */     // MIs[0] round
     /* 1519727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519730 */     // MIs[0] policy
     /* 1519730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519740 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1519743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519764 */     // GIR_Coverage, 18201,
     /* 1519764 */     GIR_EraseRootFromParent_Done,
     /* 1519765 */   // Label 21152: @1519765
     /* 1519765 */   GIM_Try, /*On fail goto*//*Label 21153*/ GIMT_Encode4(1519847), // Rule ID 18204 //
     /* 1519770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1519781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1519784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1519790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519809 */     // MIs[0] round
     /* 1519809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519812 */     // MIs[0] policy
     /* 1519812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519822 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1519825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519846 */     // GIR_Coverage, 18204,
     /* 1519846 */     GIR_EraseRootFromParent_Done,
     /* 1519847 */   // Label 21153: @1519847
     /* 1519847 */   GIM_Try, /*On fail goto*//*Label 21154*/ GIMT_Encode4(1519929), // Rule ID 18205 //
     /* 1519852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1519863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1519866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1519872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519891 */     // MIs[0] round
     /* 1519891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519894 */     // MIs[0] policy
     /* 1519894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519904 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1519907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519928 */     // GIR_Coverage, 18205,
     /* 1519928 */     GIR_EraseRootFromParent_Done,
     /* 1519929 */   // Label 21154: @1519929
     /* 1519929 */   GIM_Try, /*On fail goto*//*Label 21155*/ GIMT_Encode4(1520011), // Rule ID 18208 //
     /* 1519934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1519945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1519948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1519954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519973 */     // MIs[0] round
     /* 1519973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519976 */     // MIs[0] policy
     /* 1519976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519986 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1519989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520010 */     // GIR_Coverage, 18208,
     /* 1520010 */     GIR_EraseRootFromParent_Done,
     /* 1520011 */   // Label 21155: @1520011
     /* 1520011 */   GIM_Try, /*On fail goto*//*Label 21156*/ GIMT_Encode4(1520093), // Rule ID 18209 //
     /* 1520016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1520027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1520030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1520036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520055 */     // MIs[0] round
     /* 1520055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520058 */     // MIs[0] policy
     /* 1520058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520068 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1520071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520092 */     // GIR_Coverage, 18209,
     /* 1520092 */     GIR_EraseRootFromParent_Done,
     /* 1520093 */   // Label 21156: @1520093
     /* 1520093 */   GIM_Try, /*On fail goto*//*Label 21157*/ GIMT_Encode4(1520175), // Rule ID 18212 //
     /* 1520098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1520118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520137 */     // MIs[0] round
     /* 1520137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520140 */     // MIs[0] policy
     /* 1520140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520150 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1520153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520174 */     // GIR_Coverage, 18212,
     /* 1520174 */     GIR_EraseRootFromParent_Done,
     /* 1520175 */   // Label 21157: @1520175
     /* 1520175 */   GIM_Try, /*On fail goto*//*Label 21158*/ GIMT_Encode4(1520257), // Rule ID 18213 //
     /* 1520180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1520200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520219 */     // MIs[0] round
     /* 1520219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520222 */     // MIs[0] policy
     /* 1520222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520232 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1520235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520256 */     // GIR_Coverage, 18213,
     /* 1520256 */     GIR_EraseRootFromParent_Done,
     /* 1520257 */   // Label 21158: @1520257
     /* 1520257 */   GIM_Try, /*On fail goto*//*Label 21159*/ GIMT_Encode4(1520339), // Rule ID 18216 //
     /* 1520262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1520273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1520276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1520282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520301 */     // MIs[0] round
     /* 1520301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520304 */     // MIs[0] policy
     /* 1520304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520314 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1520317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520338 */     // GIR_Coverage, 18216,
     /* 1520338 */     GIR_EraseRootFromParent_Done,
     /* 1520339 */   // Label 21159: @1520339
     /* 1520339 */   GIM_Try, /*On fail goto*//*Label 21160*/ GIMT_Encode4(1520421), // Rule ID 18217 //
     /* 1520344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1520355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1520358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1520364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520383 */     // MIs[0] round
     /* 1520383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520386 */     // MIs[0] policy
     /* 1520386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520396 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1520399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520420 */     // GIR_Coverage, 18217,
     /* 1520420 */     GIR_EraseRootFromParent_Done,
     /* 1520421 */   // Label 21160: @1520421
     /* 1520421 */   GIM_Try, /*On fail goto*//*Label 21161*/ GIMT_Encode4(1520503), // Rule ID 18220 //
     /* 1520426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1520437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1520440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1520446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520465 */     // MIs[0] round
     /* 1520465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520468 */     // MIs[0] policy
     /* 1520468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520478 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1520481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520502 */     // GIR_Coverage, 18220,
     /* 1520502 */     GIR_EraseRootFromParent_Done,
     /* 1520503 */   // Label 21161: @1520503
     /* 1520503 */   GIM_Try, /*On fail goto*//*Label 21162*/ GIMT_Encode4(1520585), // Rule ID 18221 //
     /* 1520508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1520519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1520522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1520528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520547 */     // MIs[0] round
     /* 1520547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520550 */     // MIs[0] policy
     /* 1520550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520560 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1520563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520584 */     // GIR_Coverage, 18221,
     /* 1520584 */     GIR_EraseRootFromParent_Done,
     /* 1520585 */   // Label 21162: @1520585
     /* 1520585 */   GIM_Try, /*On fail goto*//*Label 21163*/ GIMT_Encode4(1520667), // Rule ID 18224 //
     /* 1520590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1520593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1520601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1520604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1520607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1520610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1520625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520629 */     // MIs[0] round
     /* 1520629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520632 */     // MIs[0] policy
     /* 1520632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520642 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1520645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520666 */     // GIR_Coverage, 18224,
     /* 1520666 */     GIR_EraseRootFromParent_Done,
     /* 1520667 */   // Label 21163: @1520667
     /* 1520667 */   GIM_Try, /*On fail goto*//*Label 21164*/ GIMT_Encode4(1520749), // Rule ID 18225 //
     /* 1520672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1520675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1520683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1520686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1520689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1520692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1520707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520711 */     // MIs[0] round
     /* 1520711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520714 */     // MIs[0] policy
     /* 1520714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520724 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1520727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520748 */     // GIR_Coverage, 18225,
     /* 1520748 */     GIR_EraseRootFromParent_Done,
     /* 1520749 */   // Label 21164: @1520749
     /* 1520749 */   GIM_Try, /*On fail goto*//*Label 21165*/ GIMT_Encode4(1520831), // Rule ID 18228 //
     /* 1520754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1520757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1520765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1520768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1520771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1520774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1520789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520793 */     // MIs[0] round
     /* 1520793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520796 */     // MIs[0] policy
     /* 1520796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520806 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1520809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520830 */     // GIR_Coverage, 18228,
     /* 1520830 */     GIR_EraseRootFromParent_Done,
     /* 1520831 */   // Label 21165: @1520831
     /* 1520831 */   GIM_Try, /*On fail goto*//*Label 21166*/ GIMT_Encode4(1520913), // Rule ID 18229 //
     /* 1520836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1520839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1520847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1520850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1520853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1520856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1520871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520875 */     // MIs[0] round
     /* 1520875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520878 */     // MIs[0] policy
     /* 1520878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520888 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1520891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520912 */     // GIR_Coverage, 18229,
     /* 1520912 */     GIR_EraseRootFromParent_Done,
     /* 1520913 */   // Label 21166: @1520913
     /* 1520913 */   GIM_Try, /*On fail goto*//*Label 21167*/ GIMT_Encode4(1520995), // Rule ID 18232 //
     /* 1520918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1520921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1520929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1520932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1520935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1520938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1520953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520957 */     // MIs[0] round
     /* 1520957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520960 */     // MIs[0] policy
     /* 1520960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520970 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1520973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520994 */     // GIR_Coverage, 18232,
     /* 1520994 */     GIR_EraseRootFromParent_Done,
     /* 1520995 */   // Label 21167: @1520995
     /* 1520995 */   GIM_Try, /*On fail goto*//*Label 21168*/ GIMT_Encode4(1521077), // Rule ID 18233 //
     /* 1521000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1521011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1521014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1521020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521039 */     // MIs[0] round
     /* 1521039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521042 */     // MIs[0] policy
     /* 1521042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521052 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1521055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521076 */     // GIR_Coverage, 18233,
     /* 1521076 */     GIR_EraseRootFromParent_Done,
     /* 1521077 */   // Label 21168: @1521077
     /* 1521077 */   GIM_Try, /*On fail goto*//*Label 21169*/ GIMT_Encode4(1521159), // Rule ID 18236 //
     /* 1521082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1521093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1521096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1521099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1521102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521121 */     // MIs[0] round
     /* 1521121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521124 */     // MIs[0] policy
     /* 1521124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521134 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1521137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521158 */     // GIR_Coverage, 18236,
     /* 1521158 */     GIR_EraseRootFromParent_Done,
     /* 1521159 */   // Label 21169: @1521159
     /* 1521159 */   GIM_Try, /*On fail goto*//*Label 21170*/ GIMT_Encode4(1521241), // Rule ID 18237 //
     /* 1521164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1521175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1521178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1521181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1521184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521203 */     // MIs[0] round
     /* 1521203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521206 */     // MIs[0] policy
     /* 1521206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521216 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1521219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521240 */     // GIR_Coverage, 18237,
     /* 1521240 */     GIR_EraseRootFromParent_Done,
     /* 1521241 */   // Label 21170: @1521241
     /* 1521241 */   GIM_Try, /*On fail goto*//*Label 21171*/ GIMT_Encode4(1521323), // Rule ID 18240 //
     /* 1521246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1521257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1521260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1521263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1521266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521285 */     // MIs[0] round
     /* 1521285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521288 */     // MIs[0] policy
     /* 1521288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521298 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1521301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521322 */     // GIR_Coverage, 18240,
     /* 1521322 */     GIR_EraseRootFromParent_Done,
     /* 1521323 */   // Label 21171: @1521323
     /* 1521323 */   GIM_Try, /*On fail goto*//*Label 21172*/ GIMT_Encode4(1521405), // Rule ID 18241 //
     /* 1521328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1521339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1521342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1521345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1521348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521367 */     // MIs[0] round
     /* 1521367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521370 */     // MIs[0] policy
     /* 1521370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521380 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1521383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521404 */     // GIR_Coverage, 18241,
     /* 1521404 */     GIR_EraseRootFromParent_Done,
     /* 1521405 */   // Label 21172: @1521405
     /* 1521405 */   GIM_Try, /*On fail goto*//*Label 21173*/ GIMT_Encode4(1521487), // Rule ID 18244 //
     /* 1521410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1521413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1521421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1521424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1521427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1521430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521449 */     // MIs[0] round
     /* 1521449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521452 */     // MIs[0] policy
     /* 1521452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521462 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1521465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521486 */     // GIR_Coverage, 18244,
     /* 1521486 */     GIR_EraseRootFromParent_Done,
     /* 1521487 */   // Label 21173: @1521487
     /* 1521487 */   GIM_Try, /*On fail goto*//*Label 21174*/ GIMT_Encode4(1521569), // Rule ID 18245 //
     /* 1521492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1521495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1521503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1521506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1521509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1521512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521531 */     // MIs[0] round
     /* 1521531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521534 */     // MIs[0] policy
     /* 1521534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521544 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1521547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521568 */     // GIR_Coverage, 18245,
     /* 1521568 */     GIR_EraseRootFromParent_Done,
     /* 1521569 */   // Label 21174: @1521569
     /* 1521569 */   GIM_Try, /*On fail goto*//*Label 21175*/ GIMT_Encode4(1521651), // Rule ID 18248 //
     /* 1521574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1521585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1521588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1521591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1521594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521613 */     // MIs[0] round
     /* 1521613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521616 */     // MIs[0] policy
     /* 1521616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521626 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1521629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521650 */     // GIR_Coverage, 18248,
     /* 1521650 */     GIR_EraseRootFromParent_Done,
     /* 1521651 */   // Label 21175: @1521651
     /* 1521651 */   GIM_Try, /*On fail goto*//*Label 21176*/ GIMT_Encode4(1521733), // Rule ID 18249 //
     /* 1521656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1521667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1521670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1521673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1521676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521695 */     // MIs[0] round
     /* 1521695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521698 */     // MIs[0] policy
     /* 1521698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521708 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1521711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521732 */     // GIR_Coverage, 18249,
     /* 1521732 */     GIR_EraseRootFromParent_Done,
     /* 1521733 */   // Label 21176: @1521733
     /* 1521733 */   GIM_Try, /*On fail goto*//*Label 21177*/ GIMT_Encode4(1521815), // Rule ID 18252 //
     /* 1521738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1521741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1521749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1521752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1521755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1521758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521777 */     // MIs[0] round
     /* 1521777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521780 */     // MIs[0] policy
     /* 1521780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521790 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1521793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521814 */     // GIR_Coverage, 18252,
     /* 1521814 */     GIR_EraseRootFromParent_Done,
     /* 1521815 */   // Label 21177: @1521815
     /* 1521815 */   GIM_Try, /*On fail goto*//*Label 21178*/ GIMT_Encode4(1521897), // Rule ID 18253 //
     /* 1521820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1521823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1521831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1521834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1521837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1521840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521859 */     // MIs[0] round
     /* 1521859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521862 */     // MIs[0] policy
     /* 1521862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521872 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1521875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521896 */     // GIR_Coverage, 18253,
     /* 1521896 */     GIR_EraseRootFromParent_Done,
     /* 1521897 */   // Label 21178: @1521897
     /* 1521897 */   GIM_Try, /*On fail goto*//*Label 21179*/ GIMT_Encode4(1521979), // Rule ID 18256 //
     /* 1521902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1521905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1521913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1521916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1521919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1521922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521941 */     // MIs[0] round
     /* 1521941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521944 */     // MIs[0] policy
     /* 1521944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521954 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1521957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521978 */     // GIR_Coverage, 18256,
     /* 1521978 */     GIR_EraseRootFromParent_Done,
     /* 1521979 */   // Label 21179: @1521979
     /* 1521979 */   GIM_Try, /*On fail goto*//*Label 21180*/ GIMT_Encode4(1522061), // Rule ID 18257 //
     /* 1521984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1521995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1521998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1522001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1522004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522023 */     // MIs[0] round
     /* 1522023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522026 */     // MIs[0] policy
     /* 1522026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522036 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1522039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522060 */     // GIR_Coverage, 18257,
     /* 1522060 */     GIR_EraseRootFromParent_Done,
     /* 1522061 */   // Label 21180: @1522061
     /* 1522061 */   GIM_Try, /*On fail goto*//*Label 21181*/ GIMT_Encode4(1522143), // Rule ID 18260 //
     /* 1522066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1522083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1522086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522105 */     // MIs[0] round
     /* 1522105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522108 */     // MIs[0] policy
     /* 1522108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522118 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1522121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522142 */     // GIR_Coverage, 18260,
     /* 1522142 */     GIR_EraseRootFromParent_Done,
     /* 1522143 */   // Label 21181: @1522143
     /* 1522143 */   GIM_Try, /*On fail goto*//*Label 21182*/ GIMT_Encode4(1522225), // Rule ID 18261 //
     /* 1522148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1522165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1522168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522187 */     // MIs[0] round
     /* 1522187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522190 */     // MIs[0] policy
     /* 1522190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522200 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1522203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522224 */     // GIR_Coverage, 18261,
     /* 1522224 */     GIR_EraseRootFromParent_Done,
     /* 1522225 */   // Label 21182: @1522225
     /* 1522225 */   GIM_Try, /*On fail goto*//*Label 21183*/ GIMT_Encode4(1522307), // Rule ID 18264 //
     /* 1522230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1522241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1522244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1522247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1522250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522269 */     // MIs[0] round
     /* 1522269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522272 */     // MIs[0] policy
     /* 1522272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522282 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1522285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522306 */     // GIR_Coverage, 18264,
     /* 1522306 */     GIR_EraseRootFromParent_Done,
     /* 1522307 */   // Label 21183: @1522307
     /* 1522307 */   GIM_Try, /*On fail goto*//*Label 21184*/ GIMT_Encode4(1522389), // Rule ID 18265 //
     /* 1522312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1522323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1522326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1522329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1522332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522351 */     // MIs[0] round
     /* 1522351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522354 */     // MIs[0] policy
     /* 1522354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522364 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1522367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522388 */     // GIR_Coverage, 18265,
     /* 1522388 */     GIR_EraseRootFromParent_Done,
     /* 1522389 */   // Label 21184: @1522389
     /* 1522389 */   GIM_Try, /*On fail goto*//*Label 21185*/ GIMT_Encode4(1522471), // Rule ID 18268 //
     /* 1522394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1522405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1522408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1522411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1522414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522433 */     // MIs[0] round
     /* 1522433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522436 */     // MIs[0] policy
     /* 1522436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522446 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1522449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522470 */     // GIR_Coverage, 18268,
     /* 1522470 */     GIR_EraseRootFromParent_Done,
     /* 1522471 */   // Label 21185: @1522471
     /* 1522471 */   GIM_Try, /*On fail goto*//*Label 21186*/ GIMT_Encode4(1522553), // Rule ID 18269 //
     /* 1522476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1522487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1522490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1522493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1522496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522515 */     // MIs[0] round
     /* 1522515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522518 */     // MIs[0] policy
     /* 1522518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522528 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1522531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522552 */     // GIR_Coverage, 18269,
     /* 1522552 */     GIR_EraseRootFromParent_Done,
     /* 1522553 */   // Label 21186: @1522553
     /* 1522553 */   GIM_Try, /*On fail goto*//*Label 21187*/ GIMT_Encode4(1522635), // Rule ID 18272 //
     /* 1522558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1522561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1522569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1522572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1522575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1522578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522597 */     // MIs[0] round
     /* 1522597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522600 */     // MIs[0] policy
     /* 1522600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522610 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1522613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522634 */     // GIR_Coverage, 18272,
     /* 1522634 */     GIR_EraseRootFromParent_Done,
     /* 1522635 */   // Label 21187: @1522635
     /* 1522635 */   GIM_Try, /*On fail goto*//*Label 21188*/ GIMT_Encode4(1522717), // Rule ID 18273 //
     /* 1522640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1522643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1522651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1522654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1522657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1522660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522679 */     // MIs[0] round
     /* 1522679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522682 */     // MIs[0] policy
     /* 1522682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522692 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1522695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522716 */     // GIR_Coverage, 18273,
     /* 1522716 */     GIR_EraseRootFromParent_Done,
     /* 1522717 */   // Label 21188: @1522717
     /* 1522717 */   GIM_Try, /*On fail goto*//*Label 21189*/ GIMT_Encode4(1522799), // Rule ID 18276 //
     /* 1522722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1522725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1522733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1522736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1522739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1522742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522761 */     // MIs[0] round
     /* 1522761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522764 */     // MIs[0] policy
     /* 1522764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522774 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1522777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522798 */     // GIR_Coverage, 18276,
     /* 1522798 */     GIR_EraseRootFromParent_Done,
     /* 1522799 */   // Label 21189: @1522799
     /* 1522799 */   GIM_Try, /*On fail goto*//*Label 21190*/ GIMT_Encode4(1522881), // Rule ID 18277 //
     /* 1522804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1522807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1522815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1522818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1522821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1522824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522843 */     // MIs[0] round
     /* 1522843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522846 */     // MIs[0] policy
     /* 1522846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522856 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1522859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522880 */     // GIR_Coverage, 18277,
     /* 1522880 */     GIR_EraseRootFromParent_Done,
     /* 1522881 */   // Label 21190: @1522881
     /* 1522881 */   GIM_Try, /*On fail goto*//*Label 21191*/ GIMT_Encode4(1522963), // Rule ID 18280 //
     /* 1522886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1522889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1522897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1522900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1522903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1522906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522925 */     // MIs[0] round
     /* 1522925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522928 */     // MIs[0] policy
     /* 1522928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522938 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1522941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522962 */     // GIR_Coverage, 18280,
     /* 1522962 */     GIR_EraseRootFromParent_Done,
     /* 1522963 */   // Label 21191: @1522963
     /* 1522963 */   GIM_Try, /*On fail goto*//*Label 21192*/ GIMT_Encode4(1523045), // Rule ID 18281 //
     /* 1522968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1522971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1522979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1522982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1522985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1522988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523007 */     // MIs[0] round
     /* 1523007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523010 */     // MIs[0] policy
     /* 1523010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523020 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1523023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523044 */     // GIR_Coverage, 18281,
     /* 1523044 */     GIR_EraseRootFromParent_Done,
     /* 1523045 */   // Label 21192: @1523045
     /* 1523045 */   GIM_Try, /*On fail goto*//*Label 21193*/ GIMT_Encode4(1523127), // Rule ID 18284 //
     /* 1523050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1523061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1523064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1523067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1523070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523089 */     // MIs[0] round
     /* 1523089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523092 */     // MIs[0] policy
     /* 1523092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523102 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1523105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523126 */     // GIR_Coverage, 18284,
     /* 1523126 */     GIR_EraseRootFromParent_Done,
     /* 1523127 */   // Label 21193: @1523127
     /* 1523127 */   GIM_Try, /*On fail goto*//*Label 21194*/ GIMT_Encode4(1523209), // Rule ID 18285 //
     /* 1523132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1523143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1523146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1523149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1523152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523171 */     // MIs[0] round
     /* 1523171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523174 */     // MIs[0] policy
     /* 1523174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523184 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1523187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523208 */     // GIR_Coverage, 18285,
     /* 1523208 */     GIR_EraseRootFromParent_Done,
     /* 1523209 */   // Label 21194: @1523209
     /* 1523209 */   GIM_Try, /*On fail goto*//*Label 21195*/ GIMT_Encode4(1523291), // Rule ID 18288 //
     /* 1523214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1523225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1523228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1523231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1523234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523253 */     // MIs[0] round
     /* 1523253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523256 */     // MIs[0] policy
     /* 1523256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523266 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1523269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523290 */     // GIR_Coverage, 18288,
     /* 1523290 */     GIR_EraseRootFromParent_Done,
     /* 1523291 */   // Label 21195: @1523291
     /* 1523291 */   GIM_Try, /*On fail goto*//*Label 21196*/ GIMT_Encode4(1523373), // Rule ID 18289 //
     /* 1523296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1523307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1523310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1523313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1523316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523335 */     // MIs[0] round
     /* 1523335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523338 */     // MIs[0] policy
     /* 1523338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523348 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1523351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523372 */     // GIR_Coverage, 18289,
     /* 1523372 */     GIR_EraseRootFromParent_Done,
     /* 1523373 */   // Label 21196: @1523373
     /* 1523373 */   GIM_Try, /*On fail goto*//*Label 21197*/ GIMT_Encode4(1523455), // Rule ID 18292 //
     /* 1523378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1523389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1523392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1523395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1523398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523417 */     // MIs[0] round
     /* 1523417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523420 */     // MIs[0] policy
     /* 1523420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523430 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1523433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523454 */     // GIR_Coverage, 18292,
     /* 1523454 */     GIR_EraseRootFromParent_Done,
     /* 1523455 */   // Label 21197: @1523455
     /* 1523455 */   GIM_Try, /*On fail goto*//*Label 21198*/ GIMT_Encode4(1523537), // Rule ID 18293 //
     /* 1523460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1523471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1523474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1523477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1523480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523499 */     // MIs[0] round
     /* 1523499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523502 */     // MIs[0] policy
     /* 1523502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523512 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1523515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523536 */     // GIR_Coverage, 18293,
     /* 1523536 */     GIR_EraseRootFromParent_Done,
     /* 1523537 */   // Label 21198: @1523537
     /* 1523537 */   GIM_Try, /*On fail goto*//*Label 21199*/ GIMT_Encode4(1523619), // Rule ID 18296 //
     /* 1523542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1523545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1523553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1523556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1523562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523581 */     // MIs[0] round
     /* 1523581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523584 */     // MIs[0] policy
     /* 1523584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523594 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1523597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523618 */     // GIR_Coverage, 18296,
     /* 1523618 */     GIR_EraseRootFromParent_Done,
     /* 1523619 */   // Label 21199: @1523619
     /* 1523619 */   GIM_Try, /*On fail goto*//*Label 21200*/ GIMT_Encode4(1523701), // Rule ID 18297 //
     /* 1523624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1523627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1523635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1523638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1523644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523663 */     // MIs[0] round
     /* 1523663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523666 */     // MIs[0] policy
     /* 1523666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523676 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1523679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523700 */     // GIR_Coverage, 18297,
     /* 1523700 */     GIR_EraseRootFromParent_Done,
     /* 1523701 */   // Label 21200: @1523701
     /* 1523701 */   GIM_Try, /*On fail goto*//*Label 21201*/ GIMT_Encode4(1523783), // Rule ID 18300 //
     /* 1523706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1523709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1523717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1523720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1523726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523745 */     // MIs[0] round
     /* 1523745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523748 */     // MIs[0] policy
     /* 1523748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523758 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1523761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523782 */     // GIR_Coverage, 18300,
     /* 1523782 */     GIR_EraseRootFromParent_Done,
     /* 1523783 */   // Label 21201: @1523783
     /* 1523783 */   GIM_Try, /*On fail goto*//*Label 21202*/ GIMT_Encode4(1523865), // Rule ID 18301 //
     /* 1523788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1523791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1523799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1523802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1523808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523827 */     // MIs[0] round
     /* 1523827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523830 */     // MIs[0] policy
     /* 1523830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523840 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1523843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523864 */     // GIR_Coverage, 18301,
     /* 1523864 */     GIR_EraseRootFromParent_Done,
     /* 1523865 */   // Label 21202: @1523865
     /* 1523865 */   GIM_Try, /*On fail goto*//*Label 21203*/ GIMT_Encode4(1523947), // Rule ID 18304 //
     /* 1523870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1523881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1523884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1523890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523909 */     // MIs[0] round
     /* 1523909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523912 */     // MIs[0] policy
     /* 1523912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523922 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1523925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523946 */     // GIR_Coverage, 18304,
     /* 1523946 */     GIR_EraseRootFromParent_Done,
     /* 1523947 */   // Label 21203: @1523947
     /* 1523947 */   GIM_Try, /*On fail goto*//*Label 21204*/ GIMT_Encode4(1524029), // Rule ID 18305 //
     /* 1523952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1523963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1523966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1523972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523991 */     // MIs[0] round
     /* 1523991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523994 */     // MIs[0] policy
     /* 1523994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524004 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1524007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524028 */     // GIR_Coverage, 18305,
     /* 1524028 */     GIR_EraseRootFromParent_Done,
     /* 1524029 */   // Label 21204: @1524029
     /* 1524029 */   GIM_Try, /*On fail goto*//*Label 21205*/ GIMT_Encode4(1524111), // Rule ID 18308 //
     /* 1524034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1524045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1524048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1524054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524073 */     // MIs[0] round
     /* 1524073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524076 */     // MIs[0] policy
     /* 1524076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524086 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1524089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524110 */     // GIR_Coverage, 18308,
     /* 1524110 */     GIR_EraseRootFromParent_Done,
     /* 1524111 */   // Label 21205: @1524111
     /* 1524111 */   GIM_Try, /*On fail goto*//*Label 21206*/ GIMT_Encode4(1524193), // Rule ID 18309 //
     /* 1524116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1524127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1524130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1524136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524155 */     // MIs[0] round
     /* 1524155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524158 */     // MIs[0] policy
     /* 1524158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524168 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1524171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524192 */     // GIR_Coverage, 18309,
     /* 1524192 */     GIR_EraseRootFromParent_Done,
     /* 1524193 */   // Label 21206: @1524193
     /* 1524193 */   GIM_Try, /*On fail goto*//*Label 21207*/ GIMT_Encode4(1524275), // Rule ID 18312 //
     /* 1524198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1524201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1524209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1524212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1524218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524237 */     // MIs[0] round
     /* 1524237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524240 */     // MIs[0] policy
     /* 1524240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524250 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1524253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524274 */     // GIR_Coverage, 18312,
     /* 1524274 */     GIR_EraseRootFromParent_Done,
     /* 1524275 */   // Label 21207: @1524275
     /* 1524275 */   GIM_Try, /*On fail goto*//*Label 21208*/ GIMT_Encode4(1524357), // Rule ID 18313 //
     /* 1524280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1524283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1524291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1524294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1524300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524319 */     // MIs[0] round
     /* 1524319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524322 */     // MIs[0] policy
     /* 1524322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524332 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1524335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524356 */     // GIR_Coverage, 18313,
     /* 1524356 */     GIR_EraseRootFromParent_Done,
     /* 1524357 */   // Label 21208: @1524357
     /* 1524357 */   GIM_Try, /*On fail goto*//*Label 21209*/ GIMT_Encode4(1524439), // Rule ID 18316 //
     /* 1524362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1524365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1524373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1524376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1524382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524401 */     // MIs[0] round
     /* 1524401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524404 */     // MIs[0] policy
     /* 1524404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524414 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1524417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524438 */     // GIR_Coverage, 18316,
     /* 1524438 */     GIR_EraseRootFromParent_Done,
     /* 1524439 */   // Label 21209: @1524439
     /* 1524439 */   GIM_Try, /*On fail goto*//*Label 21210*/ GIMT_Encode4(1524521), // Rule ID 18317 //
     /* 1524444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1524447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1524455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1524458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1524464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524483 */     // MIs[0] round
     /* 1524483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524486 */     // MIs[0] policy
     /* 1524486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524496 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1524499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524520 */     // GIR_Coverage, 18317,
     /* 1524520 */     GIR_EraseRootFromParent_Done,
     /* 1524521 */   // Label 21210: @1524521
     /* 1524521 */   GIM_Try, /*On fail goto*//*Label 21211*/ GIMT_Encode4(1524603), // Rule ID 18320 //
     /* 1524526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1524537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1524540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1524546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524565 */     // MIs[0] round
     /* 1524565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524568 */     // MIs[0] policy
     /* 1524568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524578 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1524581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524602 */     // GIR_Coverage, 18320,
     /* 1524602 */     GIR_EraseRootFromParent_Done,
     /* 1524603 */   // Label 21211: @1524603
     /* 1524603 */   GIM_Try, /*On fail goto*//*Label 21212*/ GIMT_Encode4(1524685), // Rule ID 18321 //
     /* 1524608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1524619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1524622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1524628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524647 */     // MIs[0] round
     /* 1524647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524650 */     // MIs[0] policy
     /* 1524650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524660 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1524663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524684 */     // GIR_Coverage, 18321,
     /* 1524684 */     GIR_EraseRootFromParent_Done,
     /* 1524685 */   // Label 21212: @1524685
     /* 1524685 */   GIM_Try, /*On fail goto*//*Label 21213*/ GIMT_Encode4(1524767), // Rule ID 18324 //
     /* 1524690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1524701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1524704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1524710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524729 */     // MIs[0] round
     /* 1524729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524732 */     // MIs[0] policy
     /* 1524732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524742 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1524745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524766 */     // GIR_Coverage, 18324,
     /* 1524766 */     GIR_EraseRootFromParent_Done,
     /* 1524767 */   // Label 21213: @1524767
     /* 1524767 */   GIM_Try, /*On fail goto*//*Label 21214*/ GIMT_Encode4(1524849), // Rule ID 18325 //
     /* 1524772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1524783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1524786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1524792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524811 */     // MIs[0] round
     /* 1524811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524814 */     // MIs[0] policy
     /* 1524814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524824 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1524827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524848 */     // GIR_Coverage, 18325,
     /* 1524848 */     GIR_EraseRootFromParent_Done,
     /* 1524849 */   // Label 21214: @1524849
     /* 1524849 */   GIM_Try, /*On fail goto*//*Label 21215*/ GIMT_Encode4(1524931), // Rule ID 18328 //
     /* 1524854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1524865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1524868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1524874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524893 */     // MIs[0] round
     /* 1524893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524896 */     // MIs[0] policy
     /* 1524896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524906 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1524909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524930 */     // GIR_Coverage, 18328,
     /* 1524930 */     GIR_EraseRootFromParent_Done,
     /* 1524931 */   // Label 21215: @1524931
     /* 1524931 */   GIM_Try, /*On fail goto*//*Label 21216*/ GIMT_Encode4(1525013), // Rule ID 18329 //
     /* 1524936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1524947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1524950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1524956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524975 */     // MIs[0] round
     /* 1524975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524978 */     // MIs[0] policy
     /* 1524978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524988 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1524991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525012 */     // GIR_Coverage, 18329,
     /* 1525012 */     GIR_EraseRootFromParent_Done,
     /* 1525013 */   // Label 21216: @1525013
     /* 1525013 */   GIM_Try, /*On fail goto*//*Label 21217*/ GIMT_Encode4(1525095), // Rule ID 18332 //
     /* 1525018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1525029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1525032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1525038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525057 */     // MIs[0] round
     /* 1525057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525060 */     // MIs[0] policy
     /* 1525060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525070 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1525073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525094 */     // GIR_Coverage, 18332,
     /* 1525094 */     GIR_EraseRootFromParent_Done,
     /* 1525095 */   // Label 21217: @1525095
     /* 1525095 */   GIM_Try, /*On fail goto*//*Label 21218*/ GIMT_Encode4(1525177), // Rule ID 18333 //
     /* 1525100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1525111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1525114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1525120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525139 */     // MIs[0] round
     /* 1525139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525142 */     // MIs[0] policy
     /* 1525142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525152 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1525155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525176 */     // GIR_Coverage, 18333,
     /* 1525176 */     GIR_EraseRootFromParent_Done,
     /* 1525177 */   // Label 21218: @1525177
     /* 1525177 */   GIM_Try, /*On fail goto*//*Label 21219*/ GIMT_Encode4(1525259), // Rule ID 18336 //
     /* 1525182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1525193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1525196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1525202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525221 */     // MIs[0] round
     /* 1525221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525224 */     // MIs[0] policy
     /* 1525224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525234 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1525237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525258 */     // GIR_Coverage, 18336,
     /* 1525258 */     GIR_EraseRootFromParent_Done,
     /* 1525259 */   // Label 21219: @1525259
     /* 1525259 */   GIM_Try, /*On fail goto*//*Label 21220*/ GIMT_Encode4(1525341), // Rule ID 18337 //
     /* 1525264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1525275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1525278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1525284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525303 */     // MIs[0] round
     /* 1525303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525306 */     // MIs[0] policy
     /* 1525306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525316 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1525319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525340 */     // GIR_Coverage, 18337,
     /* 1525340 */     GIR_EraseRootFromParent_Done,
     /* 1525341 */   // Label 21220: @1525341
     /* 1525341 */   GIM_Try, /*On fail goto*//*Label 21221*/ GIMT_Encode4(1525423), // Rule ID 18340 //
     /* 1525346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1525357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1525360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1525366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525385 */     // MIs[0] round
     /* 1525385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525388 */     // MIs[0] policy
     /* 1525388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525398 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1525401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525422 */     // GIR_Coverage, 18340,
     /* 1525422 */     GIR_EraseRootFromParent_Done,
     /* 1525423 */   // Label 21221: @1525423
     /* 1525423 */   GIM_Try, /*On fail goto*//*Label 21222*/ GIMT_Encode4(1525505), // Rule ID 18341 //
     /* 1525428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1525439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1525442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1525448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525467 */     // MIs[0] round
     /* 1525467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525470 */     // MIs[0] policy
     /* 1525470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525480 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1525483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525504 */     // GIR_Coverage, 18341,
     /* 1525504 */     GIR_EraseRootFromParent_Done,
     /* 1525505 */   // Label 21222: @1525505
     /* 1525505 */   GIM_Try, /*On fail goto*//*Label 21223*/ GIMT_Encode4(1525587), // Rule ID 18344 //
     /* 1525510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1525513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1525521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1525524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1525530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1525545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525549 */     // MIs[0] round
     /* 1525549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525552 */     // MIs[0] policy
     /* 1525552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525562 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1525565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525586 */     // GIR_Coverage, 18344,
     /* 1525586 */     GIR_EraseRootFromParent_Done,
     /* 1525587 */   // Label 21223: @1525587
     /* 1525587 */   GIM_Try, /*On fail goto*//*Label 21224*/ GIMT_Encode4(1525669), // Rule ID 18345 //
     /* 1525592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1525595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1525603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1525606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1525612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1525627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525631 */     // MIs[0] round
     /* 1525631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525634 */     // MIs[0] policy
     /* 1525634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525644 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1525647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525668 */     // GIR_Coverage, 18345,
     /* 1525668 */     GIR_EraseRootFromParent_Done,
     /* 1525669 */   // Label 21224: @1525669
     /* 1525669 */   GIM_Try, /*On fail goto*//*Label 21225*/ GIMT_Encode4(1525751), // Rule ID 18348 //
     /* 1525674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1525677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1525685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1525688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1525694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1525709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525713 */     // MIs[0] round
     /* 1525713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525716 */     // MIs[0] policy
     /* 1525716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525726 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1525729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525750 */     // GIR_Coverage, 18348,
     /* 1525750 */     GIR_EraseRootFromParent_Done,
     /* 1525751 */   // Label 21225: @1525751
     /* 1525751 */   GIM_Try, /*On fail goto*//*Label 21226*/ GIMT_Encode4(1525833), // Rule ID 18349 //
     /* 1525756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1525759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1525767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1525770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1525776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1525791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525795 */     // MIs[0] round
     /* 1525795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525798 */     // MIs[0] policy
     /* 1525798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525808 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1525811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525832 */     // GIR_Coverage, 18349,
     /* 1525832 */     GIR_EraseRootFromParent_Done,
     /* 1525833 */   // Label 21226: @1525833
     /* 1525833 */   GIM_Try, /*On fail goto*//*Label 21227*/ GIMT_Encode4(1525915), // Rule ID 18352 //
     /* 1525838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1525841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1525849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1525852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1525858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1525873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525877 */     // MIs[0] round
     /* 1525877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525880 */     // MIs[0] policy
     /* 1525880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525890 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1525893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525914 */     // GIR_Coverage, 18352,
     /* 1525914 */     GIR_EraseRootFromParent_Done,
     /* 1525915 */   // Label 21227: @1525915
     /* 1525915 */   GIM_Try, /*On fail goto*//*Label 21228*/ GIMT_Encode4(1525997), // Rule ID 18353 //
     /* 1525920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1525923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1525931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1525934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1525940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1525955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525959 */     // MIs[0] round
     /* 1525959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525962 */     // MIs[0] policy
     /* 1525962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525972 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1525975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525996 */     // GIR_Coverage, 18353,
     /* 1525996 */     GIR_EraseRootFromParent_Done,
     /* 1525997 */   // Label 21228: @1525997
     /* 1525997 */   GIM_Try, /*On fail goto*//*Label 21229*/ GIMT_Encode4(1526079), // Rule ID 18356 //
     /* 1526002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1526013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1526016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1526019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1526022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526041 */     // MIs[0] round
     /* 1526041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526044 */     // MIs[0] policy
     /* 1526044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526054 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1526057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526078 */     // GIR_Coverage, 18356,
     /* 1526078 */     GIR_EraseRootFromParent_Done,
     /* 1526079 */   // Label 21229: @1526079
     /* 1526079 */   GIM_Try, /*On fail goto*//*Label 21230*/ GIMT_Encode4(1526161), // Rule ID 18357 //
     /* 1526084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1526095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1526098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1526101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1526104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526123 */     // MIs[0] round
     /* 1526123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526126 */     // MIs[0] policy
     /* 1526126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526136 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1526139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526160 */     // GIR_Coverage, 18357,
     /* 1526160 */     GIR_EraseRootFromParent_Done,
     /* 1526161 */   // Label 21230: @1526161
     /* 1526161 */   GIM_Try, /*On fail goto*//*Label 21231*/ GIMT_Encode4(1526243), // Rule ID 18360 //
     /* 1526166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1526177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1526180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1526183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1526186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526205 */     // MIs[0] round
     /* 1526205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526208 */     // MIs[0] policy
     /* 1526208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526218 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1526221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526242 */     // GIR_Coverage, 18360,
     /* 1526242 */     GIR_EraseRootFromParent_Done,
     /* 1526243 */   // Label 21231: @1526243
     /* 1526243 */   GIM_Try, /*On fail goto*//*Label 21232*/ GIMT_Encode4(1526325), // Rule ID 18361 //
     /* 1526248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1526259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1526262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1526265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1526268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526287 */     // MIs[0] round
     /* 1526287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526290 */     // MIs[0] policy
     /* 1526290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526300 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1526303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526324 */     // GIR_Coverage, 18361,
     /* 1526324 */     GIR_EraseRootFromParent_Done,
     /* 1526325 */   // Label 21232: @1526325
     /* 1526325 */   GIM_Try, /*On fail goto*//*Label 21233*/ GIMT_Encode4(1526407), // Rule ID 18364 //
     /* 1526330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1526333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1526341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1526344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1526347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1526350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526369 */     // MIs[0] round
     /* 1526369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526372 */     // MIs[0] policy
     /* 1526372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526382 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1526385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526406 */     // GIR_Coverage, 18364,
     /* 1526406 */     GIR_EraseRootFromParent_Done,
     /* 1526407 */   // Label 21233: @1526407
     /* 1526407 */   GIM_Try, /*On fail goto*//*Label 21234*/ GIMT_Encode4(1526489), // Rule ID 18365 //
     /* 1526412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1526415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1526423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1526426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1526429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1526432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526451 */     // MIs[0] round
     /* 1526451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526454 */     // MIs[0] policy
     /* 1526454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526464 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1526467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526488 */     // GIR_Coverage, 18365,
     /* 1526488 */     GIR_EraseRootFromParent_Done,
     /* 1526489 */   // Label 21234: @1526489
     /* 1526489 */   GIM_Try, /*On fail goto*//*Label 21235*/ GIMT_Encode4(1526571), // Rule ID 18368 //
     /* 1526494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1526505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1526508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1526511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1526514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526533 */     // MIs[0] round
     /* 1526533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526536 */     // MIs[0] policy
     /* 1526536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526546 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1526549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526570 */     // GIR_Coverage, 18368,
     /* 1526570 */     GIR_EraseRootFromParent_Done,
     /* 1526571 */   // Label 21235: @1526571
     /* 1526571 */   GIM_Try, /*On fail goto*//*Label 21236*/ GIMT_Encode4(1526653), // Rule ID 18369 //
     /* 1526576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1526587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1526590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1526593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1526596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526615 */     // MIs[0] round
     /* 1526615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526618 */     // MIs[0] policy
     /* 1526618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526628 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1526631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526652 */     // GIR_Coverage, 18369,
     /* 1526652 */     GIR_EraseRootFromParent_Done,
     /* 1526653 */   // Label 21236: @1526653
     /* 1526653 */   GIM_Try, /*On fail goto*//*Label 21237*/ GIMT_Encode4(1526735), // Rule ID 18372 //
     /* 1526658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1526661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1526669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1526672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1526675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1526678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526697 */     // MIs[0] round
     /* 1526697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526700 */     // MIs[0] policy
     /* 1526700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526710 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1526713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526734 */     // GIR_Coverage, 18372,
     /* 1526734 */     GIR_EraseRootFromParent_Done,
     /* 1526735 */   // Label 21237: @1526735
     /* 1526735 */   GIM_Try, /*On fail goto*//*Label 21238*/ GIMT_Encode4(1526817), // Rule ID 18373 //
     /* 1526740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1526743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1526751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1526754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1526757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1526760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526779 */     // MIs[0] round
     /* 1526779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526782 */     // MIs[0] policy
     /* 1526782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526792 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1526795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526816 */     // GIR_Coverage, 18373,
     /* 1526816 */     GIR_EraseRootFromParent_Done,
     /* 1526817 */   // Label 21238: @1526817
     /* 1526817 */   GIM_Try, /*On fail goto*//*Label 21239*/ GIMT_Encode4(1526899), // Rule ID 18376 //
     /* 1526822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1526825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1526833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1526836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1526839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1526842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526861 */     // MIs[0] round
     /* 1526861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526864 */     // MIs[0] policy
     /* 1526864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526874 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1526877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526898 */     // GIR_Coverage, 18376,
     /* 1526898 */     GIR_EraseRootFromParent_Done,
     /* 1526899 */   // Label 21239: @1526899
     /* 1526899 */   GIM_Try, /*On fail goto*//*Label 21240*/ GIMT_Encode4(1526981), // Rule ID 18377 //
     /* 1526904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1526907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1526915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1526918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1526921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1526924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526943 */     // MIs[0] round
     /* 1526943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526946 */     // MIs[0] policy
     /* 1526946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526956 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1526959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526980 */     // GIR_Coverage, 18377,
     /* 1526980 */     GIR_EraseRootFromParent_Done,
     /* 1526981 */   // Label 21240: @1526981
     /* 1526981 */   GIM_Try, /*On fail goto*//*Label 21241*/ GIMT_Encode4(1527063), // Rule ID 18380 //
     /* 1526986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1526997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1527000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1527003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1527006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527025 */     // MIs[0] round
     /* 1527025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527028 */     // MIs[0] policy
     /* 1527028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527038 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1527041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527062 */     // GIR_Coverage, 18380,
     /* 1527062 */     GIR_EraseRootFromParent_Done,
     /* 1527063 */   // Label 21241: @1527063
     /* 1527063 */   GIM_Try, /*On fail goto*//*Label 21242*/ GIMT_Encode4(1527145), // Rule ID 18381 //
     /* 1527068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1527079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1527082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1527085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1527088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527107 */     // MIs[0] round
     /* 1527107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527110 */     // MIs[0] policy
     /* 1527110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527120 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1527123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527144 */     // GIR_Coverage, 18381,
     /* 1527144 */     GIR_EraseRootFromParent_Done,
     /* 1527145 */   // Label 21242: @1527145
     /* 1527145 */   GIM_Try, /*On fail goto*//*Label 21243*/ GIMT_Encode4(1527227), // Rule ID 18384 //
     /* 1527150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1527161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1527164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1527167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1527170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527189 */     // MIs[0] round
     /* 1527189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527192 */     // MIs[0] policy
     /* 1527192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527202 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1527205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527226 */     // GIR_Coverage, 18384,
     /* 1527226 */     GIR_EraseRootFromParent_Done,
     /* 1527227 */   // Label 21243: @1527227
     /* 1527227 */   GIM_Try, /*On fail goto*//*Label 21244*/ GIMT_Encode4(1527309), // Rule ID 18385 //
     /* 1527232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1527243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1527246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1527249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1527252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527271 */     // MIs[0] round
     /* 1527271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527274 */     // MIs[0] policy
     /* 1527274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527284 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1527287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527308 */     // GIR_Coverage, 18385,
     /* 1527308 */     GIR_EraseRootFromParent_Done,
     /* 1527309 */   // Label 21244: @1527309
     /* 1527309 */   GIM_Try, /*On fail goto*//*Label 21245*/ GIMT_Encode4(1527391), // Rule ID 18388 //
     /* 1527314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1527325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1527328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1527331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1527334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527353 */     // MIs[0] round
     /* 1527353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527356 */     // MIs[0] policy
     /* 1527356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527366 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1527369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527390 */     // GIR_Coverage, 18388,
     /* 1527390 */     GIR_EraseRootFromParent_Done,
     /* 1527391 */   // Label 21245: @1527391
     /* 1527391 */   GIM_Try, /*On fail goto*//*Label 21246*/ GIMT_Encode4(1527473), // Rule ID 18389 //
     /* 1527396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1527407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1527410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1527413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1527416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527435 */     // MIs[0] round
     /* 1527435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527438 */     // MIs[0] policy
     /* 1527438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527448 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1527451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527472 */     // GIR_Coverage, 18389,
     /* 1527472 */     GIR_EraseRootFromParent_Done,
     /* 1527473 */   // Label 21246: @1527473
     /* 1527473 */   GIM_Try, /*On fail goto*//*Label 21247*/ GIMT_Encode4(1527555), // Rule ID 18392 //
     /* 1527478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1527489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1527492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1527495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1527498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527517 */     // MIs[0] round
     /* 1527517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527520 */     // MIs[0] policy
     /* 1527520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527530 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1527533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527554 */     // GIR_Coverage, 18392,
     /* 1527554 */     GIR_EraseRootFromParent_Done,
     /* 1527555 */   // Label 21247: @1527555
     /* 1527555 */   GIM_Try, /*On fail goto*//*Label 21248*/ GIMT_Encode4(1527637), // Rule ID 18393 //
     /* 1527560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1527563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1527571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1527574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1527577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1527580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527599 */     // MIs[0] round
     /* 1527599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527602 */     // MIs[0] policy
     /* 1527602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527612 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1527615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527636 */     // GIR_Coverage, 18393,
     /* 1527636 */     GIR_EraseRootFromParent_Done,
     /* 1527637 */   // Label 21248: @1527637
     /* 1527637 */   GIM_Try, /*On fail goto*//*Label 21249*/ GIMT_Encode4(1527719), // Rule ID 18396 //
     /* 1527642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1527653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1527656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1527659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1527662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527681 */     // MIs[0] round
     /* 1527681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527684 */     // MIs[0] policy
     /* 1527684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527694 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1527697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527718 */     // GIR_Coverage, 18396,
     /* 1527718 */     GIR_EraseRootFromParent_Done,
     /* 1527719 */   // Label 21249: @1527719
     /* 1527719 */   GIM_Try, /*On fail goto*//*Label 21250*/ GIMT_Encode4(1527801), // Rule ID 18397 //
     /* 1527724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1527727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1527735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1527738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1527741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1527744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527763 */     // MIs[0] round
     /* 1527763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527766 */     // MIs[0] policy
     /* 1527766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527776 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1527779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527800 */     // GIR_Coverage, 18397,
     /* 1527800 */     GIR_EraseRootFromParent_Done,
     /* 1527801 */   // Label 21250: @1527801
     /* 1527801 */   GIM_Try, /*On fail goto*//*Label 21251*/ GIMT_Encode4(1527883), // Rule ID 18400 //
     /* 1527806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1527817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1527820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1527823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1527826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527845 */     // MIs[0] round
     /* 1527845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527848 */     // MIs[0] policy
     /* 1527848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527858 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1527861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527882 */     // GIR_Coverage, 18400,
     /* 1527882 */     GIR_EraseRootFromParent_Done,
     /* 1527883 */   // Label 21251: @1527883
     /* 1527883 */   GIM_Try, /*On fail goto*//*Label 21252*/ GIMT_Encode4(1527965), // Rule ID 18401 //
     /* 1527888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1527891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1527899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1527902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1527905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1527908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527927 */     // MIs[0] round
     /* 1527927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527930 */     // MIs[0] policy
     /* 1527930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527940 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1527943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527964 */     // GIR_Coverage, 18401,
     /* 1527964 */     GIR_EraseRootFromParent_Done,
     /* 1527965 */   // Label 21252: @1527965
     /* 1527965 */   GIM_Try, /*On fail goto*//*Label 21253*/ GIMT_Encode4(1528047), // Rule ID 18404 //
     /* 1527970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1527973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1527981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1527984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1527987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1527990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528009 */     // MIs[0] round
     /* 1528009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528012 */     // MIs[0] policy
     /* 1528012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528022 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1528025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528046 */     // GIR_Coverage, 18404,
     /* 1528046 */     GIR_EraseRootFromParent_Done,
     /* 1528047 */   // Label 21253: @1528047
     /* 1528047 */   GIM_Try, /*On fail goto*//*Label 21254*/ GIMT_Encode4(1528129), // Rule ID 18405 //
     /* 1528052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1528063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1528066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1528069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1528072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528091 */     // MIs[0] round
     /* 1528091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528094 */     // MIs[0] policy
     /* 1528094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528104 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1528107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528128 */     // GIR_Coverage, 18405,
     /* 1528128 */     GIR_EraseRootFromParent_Done,
     /* 1528129 */   // Label 21254: @1528129
     /* 1528129 */   GIM_Try, /*On fail goto*//*Label 21255*/ GIMT_Encode4(1528211), // Rule ID 18408 //
     /* 1528134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1528145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1528148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1528151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1528154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528173 */     // MIs[0] round
     /* 1528173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528176 */     // MIs[0] policy
     /* 1528176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528186 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1528189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528210 */     // GIR_Coverage, 18408,
     /* 1528210 */     GIR_EraseRootFromParent_Done,
     /* 1528211 */   // Label 21255: @1528211
     /* 1528211 */   GIM_Try, /*On fail goto*//*Label 21256*/ GIMT_Encode4(1528293), // Rule ID 18409 //
     /* 1528216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1528227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1528230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1528233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1528236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528255 */     // MIs[0] round
     /* 1528255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528258 */     // MIs[0] policy
     /* 1528258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528268 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1528271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528292 */     // GIR_Coverage, 18409,
     /* 1528292 */     GIR_EraseRootFromParent_Done,
     /* 1528293 */   // Label 21256: @1528293
     /* 1528293 */   GIM_Try, /*On fail goto*//*Label 21257*/ GIMT_Encode4(1528375), // Rule ID 18412 //
     /* 1528298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1528309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1528312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1528315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1528318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528337 */     // MIs[0] round
     /* 1528337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528340 */     // MIs[0] policy
     /* 1528340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528350 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1528353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528374 */     // GIR_Coverage, 18412,
     /* 1528374 */     GIR_EraseRootFromParent_Done,
     /* 1528375 */   // Label 21257: @1528375
     /* 1528375 */   GIM_Try, /*On fail goto*//*Label 21258*/ GIMT_Encode4(1528457), // Rule ID 18413 //
     /* 1528380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1528391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1528394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1528397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1528400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528419 */     // MIs[0] round
     /* 1528419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528422 */     // MIs[0] policy
     /* 1528422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528432 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1528435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528456 */     // GIR_Coverage, 18413,
     /* 1528456 */     GIR_EraseRootFromParent_Done,
     /* 1528457 */   // Label 21258: @1528457
     /* 1528457 */   GIM_Try, /*On fail goto*//*Label 21259*/ GIMT_Encode4(1528539), // Rule ID 18416 //
     /* 1528462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1528473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1528476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1528482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528501 */     // MIs[0] round
     /* 1528501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528504 */     // MIs[0] policy
     /* 1528504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528514 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1528517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528538 */     // GIR_Coverage, 18416,
     /* 1528538 */     GIR_EraseRootFromParent_Done,
     /* 1528539 */   // Label 21259: @1528539
     /* 1528539 */   GIM_Try, /*On fail goto*//*Label 21260*/ GIMT_Encode4(1528621), // Rule ID 18417 //
     /* 1528544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1528547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1528555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1528558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1528564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528583 */     // MIs[0] round
     /* 1528583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528586 */     // MIs[0] policy
     /* 1528586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528596 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1528599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528620 */     // GIR_Coverage, 18417,
     /* 1528620 */     GIR_EraseRootFromParent_Done,
     /* 1528621 */   // Label 21260: @1528621
     /* 1528621 */   GIM_Try, /*On fail goto*//*Label 21261*/ GIMT_Encode4(1528703), // Rule ID 18420 //
     /* 1528626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1528637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1528640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1528646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528665 */     // MIs[0] round
     /* 1528665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528668 */     // MIs[0] policy
     /* 1528668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528678 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1528681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528702 */     // GIR_Coverage, 18420,
     /* 1528702 */     GIR_EraseRootFromParent_Done,
     /* 1528703 */   // Label 21261: @1528703
     /* 1528703 */   GIM_Try, /*On fail goto*//*Label 21262*/ GIMT_Encode4(1528785), // Rule ID 18421 //
     /* 1528708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1528711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1528719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1528722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1528728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528747 */     // MIs[0] round
     /* 1528747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528750 */     // MIs[0] policy
     /* 1528750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528760 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1528763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528784 */     // GIR_Coverage, 18421,
     /* 1528784 */     GIR_EraseRootFromParent_Done,
     /* 1528785 */   // Label 21262: @1528785
     /* 1528785 */   GIM_Try, /*On fail goto*//*Label 21263*/ GIMT_Encode4(1528867), // Rule ID 18424 //
     /* 1528790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1528793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1528801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1528804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1528810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528829 */     // MIs[0] round
     /* 1528829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528832 */     // MIs[0] policy
     /* 1528832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528842 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1528845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528866 */     // GIR_Coverage, 18424,
     /* 1528866 */     GIR_EraseRootFromParent_Done,
     /* 1528867 */   // Label 21263: @1528867
     /* 1528867 */   GIM_Try, /*On fail goto*//*Label 21264*/ GIMT_Encode4(1528949), // Rule ID 18425 //
     /* 1528872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1528883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1528886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1528892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528911 */     // MIs[0] round
     /* 1528911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528914 */     // MIs[0] policy
     /* 1528914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528924 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1528927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528948 */     // GIR_Coverage, 18425,
     /* 1528948 */     GIR_EraseRootFromParent_Done,
     /* 1528949 */   // Label 21264: @1528949
     /* 1528949 */   GIM_Try, /*On fail goto*//*Label 21265*/ GIMT_Encode4(1529031), // Rule ID 18428 //
     /* 1528954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1528965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1528968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1528974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528993 */     // MIs[0] round
     /* 1528993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528996 */     // MIs[0] policy
     /* 1528996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529006 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1529009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529030 */     // GIR_Coverage, 18428,
     /* 1529030 */     GIR_EraseRootFromParent_Done,
     /* 1529031 */   // Label 21265: @1529031
     /* 1529031 */   GIM_Try, /*On fail goto*//*Label 21266*/ GIMT_Encode4(1529113), // Rule ID 18429 //
     /* 1529036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1529047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1529050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1529056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529075 */     // MIs[0] round
     /* 1529075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529078 */     // MIs[0] policy
     /* 1529078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529088 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1529091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529099 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529112 */     // GIR_Coverage, 18429,
     /* 1529112 */     GIR_EraseRootFromParent_Done,
     /* 1529113 */   // Label 21266: @1529113
     /* 1529113 */   GIM_Try, /*On fail goto*//*Label 21267*/ GIMT_Encode4(1529195), // Rule ID 18432 //
     /* 1529118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1529129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1529132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1529138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529157 */     // MIs[0] round
     /* 1529157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529160 */     // MIs[0] policy
     /* 1529160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529170 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1529173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529194 */     // GIR_Coverage, 18432,
     /* 1529194 */     GIR_EraseRootFromParent_Done,
     /* 1529195 */   // Label 21267: @1529195
     /* 1529195 */   GIM_Try, /*On fail goto*//*Label 21268*/ GIMT_Encode4(1529277), // Rule ID 18433 //
     /* 1529200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1529203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1529211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1529214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1529220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529239 */     // MIs[0] round
     /* 1529239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529242 */     // MIs[0] policy
     /* 1529242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1529255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529276 */     // GIR_Coverage, 18433,
     /* 1529276 */     GIR_EraseRootFromParent_Done,
     /* 1529277 */   // Label 21268: @1529277
     /* 1529277 */   GIM_Try, /*On fail goto*//*Label 21269*/ GIMT_Encode4(1529359), // Rule ID 18436 //
     /* 1529282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1529285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1529293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1529296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1529302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529321 */     // MIs[0] round
     /* 1529321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529324 */     // MIs[0] policy
     /* 1529324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529334 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1529337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529358 */     // GIR_Coverage, 18436,
     /* 1529358 */     GIR_EraseRootFromParent_Done,
     /* 1529359 */   // Label 21269: @1529359
     /* 1529359 */   GIM_Try, /*On fail goto*//*Label 21270*/ GIMT_Encode4(1529441), // Rule ID 18437 //
     /* 1529364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1529367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1529375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1529378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1529384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529403 */     // MIs[0] round
     /* 1529403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529406 */     // MIs[0] policy
     /* 1529406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529416 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1529419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529440 */     // GIR_Coverage, 18437,
     /* 1529440 */     GIR_EraseRootFromParent_Done,
     /* 1529441 */   // Label 21270: @1529441
     /* 1529441 */   GIM_Try, /*On fail goto*//*Label 21271*/ GIMT_Encode4(1529523), // Rule ID 18440 //
     /* 1529446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1529457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1529460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1529466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529485 */     // MIs[0] round
     /* 1529485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529488 */     // MIs[0] policy
     /* 1529488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529498 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1529501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529522 */     // GIR_Coverage, 18440,
     /* 1529522 */     GIR_EraseRootFromParent_Done,
     /* 1529523 */   // Label 21271: @1529523
     /* 1529523 */   GIM_Try, /*On fail goto*//*Label 21272*/ GIMT_Encode4(1529605), // Rule ID 18441 //
     /* 1529528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1529539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1529542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1529548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529567 */     // MIs[0] round
     /* 1529567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529570 */     // MIs[0] policy
     /* 1529570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529580 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1529583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529604 */     // GIR_Coverage, 18441,
     /* 1529604 */     GIR_EraseRootFromParent_Done,
     /* 1529605 */   // Label 21272: @1529605
     /* 1529605 */   GIM_Try, /*On fail goto*//*Label 21273*/ GIMT_Encode4(1529687), // Rule ID 18444 //
     /* 1529610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1529621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1529624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1529630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529649 */     // MIs[0] round
     /* 1529649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529652 */     // MIs[0] policy
     /* 1529652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529662 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1529665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529686 */     // GIR_Coverage, 18444,
     /* 1529686 */     GIR_EraseRootFromParent_Done,
     /* 1529687 */   // Label 21273: @1529687
     /* 1529687 */   GIM_Try, /*On fail goto*//*Label 21274*/ GIMT_Encode4(1529769), // Rule ID 18445 //
     /* 1529692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1529703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1529706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1529712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529731 */     // MIs[0] round
     /* 1529731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529734 */     // MIs[0] policy
     /* 1529734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529744 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1529747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529768 */     // GIR_Coverage, 18445,
     /* 1529768 */     GIR_EraseRootFromParent_Done,
     /* 1529769 */   // Label 21274: @1529769
     /* 1529769 */   GIM_Try, /*On fail goto*//*Label 21275*/ GIMT_Encode4(1529851), // Rule ID 18448 //
     /* 1529774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1529785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1529788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1529794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529813 */     // MIs[0] round
     /* 1529813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529816 */     // MIs[0] policy
     /* 1529816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529826 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1529829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529850 */     // GIR_Coverage, 18448,
     /* 1529850 */     GIR_EraseRootFromParent_Done,
     /* 1529851 */   // Label 21275: @1529851
     /* 1529851 */   GIM_Try, /*On fail goto*//*Label 21276*/ GIMT_Encode4(1529933), // Rule ID 18449 //
     /* 1529856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1529867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1529870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1529876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529895 */     // MIs[0] round
     /* 1529895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529898 */     // MIs[0] policy
     /* 1529898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529908 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1529911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529932 */     // GIR_Coverage, 18449,
     /* 1529932 */     GIR_EraseRootFromParent_Done,
     /* 1529933 */   // Label 21276: @1529933
     /* 1529933 */   GIM_Try, /*On fail goto*//*Label 21277*/ GIMT_Encode4(1530015), // Rule ID 18452 //
     /* 1529938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1529949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1529952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1529958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529977 */     // MIs[0] round
     /* 1529977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529980 */     // MIs[0] policy
     /* 1529980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529990 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1529993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530014 */     // GIR_Coverage, 18452,
     /* 1530014 */     GIR_EraseRootFromParent_Done,
     /* 1530015 */   // Label 21277: @1530015
     /* 1530015 */   GIM_Try, /*On fail goto*//*Label 21278*/ GIMT_Encode4(1530097), // Rule ID 18453 //
     /* 1530020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1530031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1530034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1530040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530059 */     // MIs[0] round
     /* 1530059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530062 */     // MIs[0] policy
     /* 1530062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530072 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1530075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530096 */     // GIR_Coverage, 18453,
     /* 1530096 */     GIR_EraseRootFromParent_Done,
     /* 1530097 */   // Label 21278: @1530097
     /* 1530097 */   GIM_Try, /*On fail goto*//*Label 21279*/ GIMT_Encode4(1530179), // Rule ID 18456 //
     /* 1530102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1530113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1530116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1530122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530141 */     // MIs[0] round
     /* 1530141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530144 */     // MIs[0] policy
     /* 1530144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530154 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1530157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530178 */     // GIR_Coverage, 18456,
     /* 1530178 */     GIR_EraseRootFromParent_Done,
     /* 1530179 */   // Label 21279: @1530179
     /* 1530179 */   GIM_Try, /*On fail goto*//*Label 21280*/ GIMT_Encode4(1530261), // Rule ID 18457 //
     /* 1530184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1530195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1530198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1530204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530223 */     // MIs[0] round
     /* 1530223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530226 */     // MIs[0] policy
     /* 1530226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530236 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1530239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530260 */     // GIR_Coverage, 18457,
     /* 1530260 */     GIR_EraseRootFromParent_Done,
     /* 1530261 */   // Label 21280: @1530261
     /* 1530261 */   GIM_Try, /*On fail goto*//*Label 21281*/ GIMT_Encode4(1530343), // Rule ID 18460 //
     /* 1530266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1530277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1530280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1530286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530305 */     // MIs[0] round
     /* 1530305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530308 */     // MIs[0] policy
     /* 1530308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530318 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1530321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530342 */     // GIR_Coverage, 18460,
     /* 1530342 */     GIR_EraseRootFromParent_Done,
     /* 1530343 */   // Label 21281: @1530343
     /* 1530343 */   GIM_Try, /*On fail goto*//*Label 21282*/ GIMT_Encode4(1530425), // Rule ID 18461 //
     /* 1530348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1530359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1530362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1530368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530387 */     // MIs[0] round
     /* 1530387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530390 */     // MIs[0] policy
     /* 1530390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530400 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1530403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530424 */     // GIR_Coverage, 18461,
     /* 1530424 */     GIR_EraseRootFromParent_Done,
     /* 1530425 */   // Label 21282: @1530425
     /* 1530425 */   GIM_Try, /*On fail goto*//*Label 21283*/ GIMT_Encode4(1530507), // Rule ID 18464 //
     /* 1530430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1530433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1530441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1530444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1530450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530469 */     // MIs[0] round
     /* 1530469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530472 */     // MIs[0] policy
     /* 1530472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530482 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1530485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530506 */     // GIR_Coverage, 18464,
     /* 1530506 */     GIR_EraseRootFromParent_Done,
     /* 1530507 */   // Label 21283: @1530507
     /* 1530507 */   GIM_Try, /*On fail goto*//*Label 21284*/ GIMT_Encode4(1530589), // Rule ID 18465 //
     /* 1530512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1530515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1530523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1530526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1530532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530551 */     // MIs[0] round
     /* 1530551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530554 */     // MIs[0] policy
     /* 1530554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530564 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1530567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530588 */     // GIR_Coverage, 18465,
     /* 1530588 */     GIR_EraseRootFromParent_Done,
     /* 1530589 */   // Label 21284: @1530589
     /* 1530589 */   GIM_Try, /*On fail goto*//*Label 21285*/ GIMT_Encode4(1530671), // Rule ID 18468 //
     /* 1530594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1530597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1530605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1530608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1530614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530633 */     // MIs[0] round
     /* 1530633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530636 */     // MIs[0] policy
     /* 1530636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530646 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1530649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530670 */     // GIR_Coverage, 18468,
     /* 1530670 */     GIR_EraseRootFromParent_Done,
     /* 1530671 */   // Label 21285: @1530671
     /* 1530671 */   GIM_Try, /*On fail goto*//*Label 21286*/ GIMT_Encode4(1530753), // Rule ID 18469 //
     /* 1530676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1530679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1530687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1530690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1530696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530715 */     // MIs[0] round
     /* 1530715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530718 */     // MIs[0] policy
     /* 1530718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530728 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1530731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530739 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530752 */     // GIR_Coverage, 18469,
     /* 1530752 */     GIR_EraseRootFromParent_Done,
     /* 1530753 */   // Label 21286: @1530753
     /* 1530753 */   GIM_Try, /*On fail goto*//*Label 21287*/ GIMT_Encode4(1530835), // Rule ID 18472 //
     /* 1530758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1530761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1530769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1530772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1530778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530797 */     // MIs[0] round
     /* 1530797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530800 */     // MIs[0] policy
     /* 1530800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530810 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1530813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530834 */     // GIR_Coverage, 18472,
     /* 1530834 */     GIR_EraseRootFromParent_Done,
     /* 1530835 */   // Label 21287: @1530835
     /* 1530835 */   GIM_Try, /*On fail goto*//*Label 21288*/ GIMT_Encode4(1530917), // Rule ID 18473 //
     /* 1530840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1530843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1530851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1530854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1530860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530879 */     // MIs[0] round
     /* 1530879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530882 */     // MIs[0] policy
     /* 1530882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530892 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1530895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530916 */     // GIR_Coverage, 18473,
     /* 1530916 */     GIR_EraseRootFromParent_Done,
     /* 1530917 */   // Label 21288: @1530917
     /* 1530917 */   GIM_Try, /*On fail goto*//*Label 21289*/ GIMT_Encode4(1530999), // Rule ID 18476 //
     /* 1530922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1530925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1530933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1530936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1530939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1530942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530961 */     // MIs[0] round
     /* 1530961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530964 */     // MIs[0] policy
     /* 1530964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530974 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1530977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530998 */     // GIR_Coverage, 18476,
     /* 1530998 */     GIR_EraseRootFromParent_Done,
     /* 1530999 */   // Label 21289: @1530999
     /* 1530999 */   GIM_Try, /*On fail goto*//*Label 21290*/ GIMT_Encode4(1531081), // Rule ID 18477 //
     /* 1531004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1531015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1531018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1531021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1531024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531043 */     // MIs[0] round
     /* 1531043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531046 */     // MIs[0] policy
     /* 1531046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531056 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1531059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531080 */     // GIR_Coverage, 18477,
     /* 1531080 */     GIR_EraseRootFromParent_Done,
     /* 1531081 */   // Label 21290: @1531081
     /* 1531081 */   GIM_Try, /*On fail goto*//*Label 21291*/ GIMT_Encode4(1531163), // Rule ID 18480 //
     /* 1531086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1531097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1531100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1531103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1531106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531125 */     // MIs[0] round
     /* 1531125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531128 */     // MIs[0] policy
     /* 1531128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531138 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1531141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531162 */     // GIR_Coverage, 18480,
     /* 1531162 */     GIR_EraseRootFromParent_Done,
     /* 1531163 */   // Label 21291: @1531163
     /* 1531163 */   GIM_Try, /*On fail goto*//*Label 21292*/ GIMT_Encode4(1531245), // Rule ID 18481 //
     /* 1531168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1531179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1531182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1531185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1531188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531207 */     // MIs[0] round
     /* 1531207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531210 */     // MIs[0] policy
     /* 1531210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531220 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1531223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531244 */     // GIR_Coverage, 18481,
     /* 1531244 */     GIR_EraseRootFromParent_Done,
     /* 1531245 */   // Label 21292: @1531245
     /* 1531245 */   GIM_Try, /*On fail goto*//*Label 21293*/ GIMT_Encode4(1531327), // Rule ID 18484 //
     /* 1531250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1531253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1531261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1531264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1531267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1531270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531289 */     // MIs[0] round
     /* 1531289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531292 */     // MIs[0] policy
     /* 1531292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531302 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1531305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531326 */     // GIR_Coverage, 18484,
     /* 1531326 */     GIR_EraseRootFromParent_Done,
     /* 1531327 */   // Label 21293: @1531327
     /* 1531327 */   GIM_Try, /*On fail goto*//*Label 21294*/ GIMT_Encode4(1531409), // Rule ID 18485 //
     /* 1531332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1531335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1531343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1531346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1531349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1531352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531371 */     // MIs[0] round
     /* 1531371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531374 */     // MIs[0] policy
     /* 1531374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531384 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1531387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531408 */     // GIR_Coverage, 18485,
     /* 1531408 */     GIR_EraseRootFromParent_Done,
     /* 1531409 */   // Label 21294: @1531409
     /* 1531409 */   GIM_Try, /*On fail goto*//*Label 21295*/ GIMT_Encode4(1531491), // Rule ID 18488 //
     /* 1531414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1531425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1531428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1531431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1531434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531453 */     // MIs[0] round
     /* 1531453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531456 */     // MIs[0] policy
     /* 1531456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531466 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1531469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531490 */     // GIR_Coverage, 18488,
     /* 1531490 */     GIR_EraseRootFromParent_Done,
     /* 1531491 */   // Label 21295: @1531491
     /* 1531491 */   GIM_Try, /*On fail goto*//*Label 21296*/ GIMT_Encode4(1531573), // Rule ID 18489 //
     /* 1531496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1531507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1531510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1531513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1531516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531535 */     // MIs[0] round
     /* 1531535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531538 */     // MIs[0] policy
     /* 1531538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531548 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1531551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531572 */     // GIR_Coverage, 18489,
     /* 1531572 */     GIR_EraseRootFromParent_Done,
     /* 1531573 */   // Label 21296: @1531573
     /* 1531573 */   GIM_Try, /*On fail goto*//*Label 21297*/ GIMT_Encode4(1531655), // Rule ID 18492 //
     /* 1531578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1531581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1531589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1531592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1531595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1531598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531617 */     // MIs[0] round
     /* 1531617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531620 */     // MIs[0] policy
     /* 1531620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531630 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1531633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531654 */     // GIR_Coverage, 18492,
     /* 1531654 */     GIR_EraseRootFromParent_Done,
     /* 1531655 */   // Label 21297: @1531655
     /* 1531655 */   GIM_Try, /*On fail goto*//*Label 21298*/ GIMT_Encode4(1531737), // Rule ID 18493 //
     /* 1531660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1531663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1531671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1531674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1531677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1531680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531699 */     // MIs[0] round
     /* 1531699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531702 */     // MIs[0] policy
     /* 1531702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531712 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1531715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531736 */     // GIR_Coverage, 18493,
     /* 1531736 */     GIR_EraseRootFromParent_Done,
     /* 1531737 */   // Label 21298: @1531737
     /* 1531737 */   GIM_Try, /*On fail goto*//*Label 21299*/ GIMT_Encode4(1531819), // Rule ID 18496 //
     /* 1531742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1531745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1531753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1531756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1531759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1531762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531781 */     // MIs[0] round
     /* 1531781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531784 */     // MIs[0] policy
     /* 1531784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531794 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1531797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531818 */     // GIR_Coverage, 18496,
     /* 1531818 */     GIR_EraseRootFromParent_Done,
     /* 1531819 */   // Label 21299: @1531819
     /* 1531819 */   GIM_Try, /*On fail goto*//*Label 21300*/ GIMT_Encode4(1531901), // Rule ID 18497 //
     /* 1531824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1531827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1531835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1531838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1531841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1531844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531863 */     // MIs[0] round
     /* 1531863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531866 */     // MIs[0] policy
     /* 1531866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531876 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1531879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531900 */     // GIR_Coverage, 18497,
     /* 1531900 */     GIR_EraseRootFromParent_Done,
     /* 1531901 */   // Label 21300: @1531901
     /* 1531901 */   GIM_Try, /*On fail goto*//*Label 21301*/ GIMT_Encode4(1531983), // Rule ID 18500 //
     /* 1531906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1531917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1531920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1531923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1531926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531945 */     // MIs[0] round
     /* 1531945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531948 */     // MIs[0] policy
     /* 1531948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531958 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1531961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531982 */     // GIR_Coverage, 18500,
     /* 1531982 */     GIR_EraseRootFromParent_Done,
     /* 1531983 */   // Label 21301: @1531983
     /* 1531983 */   GIM_Try, /*On fail goto*//*Label 21302*/ GIMT_Encode4(1532065), // Rule ID 18501 //
     /* 1531988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1531999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1532002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1532005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1532008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532027 */     // MIs[0] round
     /* 1532027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532030 */     // MIs[0] policy
     /* 1532030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532040 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1532043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532064 */     // GIR_Coverage, 18501,
     /* 1532064 */     GIR_EraseRootFromParent_Done,
     /* 1532065 */   // Label 21302: @1532065
     /* 1532065 */   GIM_Try, /*On fail goto*//*Label 21303*/ GIMT_Encode4(1532147), // Rule ID 18504 //
     /* 1532070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1532087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1532090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532109 */     // MIs[0] round
     /* 1532109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532112 */     // MIs[0] policy
     /* 1532112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532122 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1532125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532146 */     // GIR_Coverage, 18504,
     /* 1532146 */     GIR_EraseRootFromParent_Done,
     /* 1532147 */   // Label 21303: @1532147
     /* 1532147 */   GIM_Try, /*On fail goto*//*Label 21304*/ GIMT_Encode4(1532229), // Rule ID 18505 //
     /* 1532152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1532169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1532172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532191 */     // MIs[0] round
     /* 1532191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532194 */     // MIs[0] policy
     /* 1532194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532204 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1532207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532228 */     // GIR_Coverage, 18505,
     /* 1532228 */     GIR_EraseRootFromParent_Done,
     /* 1532229 */   // Label 21304: @1532229
     /* 1532229 */   GIM_Try, /*On fail goto*//*Label 21305*/ GIMT_Encode4(1532311), // Rule ID 18508 //
     /* 1532234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1532245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1532248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1532251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1532254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532273 */     // MIs[0] round
     /* 1532273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532276 */     // MIs[0] policy
     /* 1532276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532286 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1532289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532310 */     // GIR_Coverage, 18508,
     /* 1532310 */     GIR_EraseRootFromParent_Done,
     /* 1532311 */   // Label 21305: @1532311
     /* 1532311 */   GIM_Try, /*On fail goto*//*Label 21306*/ GIMT_Encode4(1532393), // Rule ID 18509 //
     /* 1532316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1532327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1532330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1532333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1532336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532355 */     // MIs[0] round
     /* 1532355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532358 */     // MIs[0] policy
     /* 1532358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532368 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1532371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532392 */     // GIR_Coverage, 18509,
     /* 1532392 */     GIR_EraseRootFromParent_Done,
     /* 1532393 */   // Label 21306: @1532393
     /* 1532393 */   GIM_Try, /*On fail goto*//*Label 21307*/ GIMT_Encode4(1532475), // Rule ID 18512 //
     /* 1532398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1532409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1532412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1532415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1532418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532437 */     // MIs[0] round
     /* 1532437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532440 */     // MIs[0] policy
     /* 1532440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532450 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1532453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532474 */     // GIR_Coverage, 18512,
     /* 1532474 */     GIR_EraseRootFromParent_Done,
     /* 1532475 */   // Label 21307: @1532475
     /* 1532475 */   GIM_Try, /*On fail goto*//*Label 21308*/ GIMT_Encode4(1532557), // Rule ID 18513 //
     /* 1532480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1532491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1532494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1532497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1532500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532519 */     // MIs[0] round
     /* 1532519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532522 */     // MIs[0] policy
     /* 1532522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532532 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1532535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532556 */     // GIR_Coverage, 18513,
     /* 1532556 */     GIR_EraseRootFromParent_Done,
     /* 1532557 */   // Label 21308: @1532557
     /* 1532557 */   GIM_Try, /*On fail goto*//*Label 21309*/ GIMT_Encode4(1532639), // Rule ID 18516 //
     /* 1532562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1532573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1532576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1532579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1532582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532601 */     // MIs[0] round
     /* 1532601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532604 */     // MIs[0] policy
     /* 1532604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532614 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1532617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532638 */     // GIR_Coverage, 18516,
     /* 1532638 */     GIR_EraseRootFromParent_Done,
     /* 1532639 */   // Label 21309: @1532639
     /* 1532639 */   GIM_Try, /*On fail goto*//*Label 21310*/ GIMT_Encode4(1532721), // Rule ID 18517 //
     /* 1532644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1532655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1532658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1532661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1532664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532683 */     // MIs[0] round
     /* 1532683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532686 */     // MIs[0] policy
     /* 1532686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532696 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1532699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532720 */     // GIR_Coverage, 18517,
     /* 1532720 */     GIR_EraseRootFromParent_Done,
     /* 1532721 */   // Label 21310: @1532721
     /* 1532721 */   GIM_Try, /*On fail goto*//*Label 21311*/ GIMT_Encode4(1532803), // Rule ID 18520 //
     /* 1532726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1532737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1532740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1532743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1532746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532765 */     // MIs[0] round
     /* 1532765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532768 */     // MIs[0] policy
     /* 1532768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532778 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1532781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532802 */     // GIR_Coverage, 18520,
     /* 1532802 */     GIR_EraseRootFromParent_Done,
     /* 1532803 */   // Label 21311: @1532803
     /* 1532803 */   GIM_Try, /*On fail goto*//*Label 21312*/ GIMT_Encode4(1532885), // Rule ID 18521 //
     /* 1532808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1532819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1532822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1532825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1532828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532847 */     // MIs[0] round
     /* 1532847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532850 */     // MIs[0] policy
     /* 1532850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532860 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1532863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532884 */     // GIR_Coverage, 18521,
     /* 1532884 */     GIR_EraseRootFromParent_Done,
     /* 1532885 */   // Label 21312: @1532885
     /* 1532885 */   GIM_Try, /*On fail goto*//*Label 21313*/ GIMT_Encode4(1532967), // Rule ID 18524 //
     /* 1532890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1532893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1532901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1532904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1532907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1532910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532929 */     // MIs[0] round
     /* 1532929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532932 */     // MIs[0] policy
     /* 1532932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532942 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1532945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532966 */     // GIR_Coverage, 18524,
     /* 1532966 */     GIR_EraseRootFromParent_Done,
     /* 1532967 */   // Label 21313: @1532967
     /* 1532967 */   GIM_Try, /*On fail goto*//*Label 21314*/ GIMT_Encode4(1533049), // Rule ID 18525 //
     /* 1532972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1532975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1532983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1532986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1532989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1532992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533011 */     // MIs[0] round
     /* 1533011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533014 */     // MIs[0] policy
     /* 1533014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533024 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1533027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533048 */     // GIR_Coverage, 18525,
     /* 1533048 */     GIR_EraseRootFromParent_Done,
     /* 1533049 */   // Label 21314: @1533049
     /* 1533049 */   GIM_Try, /*On fail goto*//*Label 21315*/ GIMT_Encode4(1533131), // Rule ID 18528 //
     /* 1533054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1533065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1533068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1533071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1533074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533093 */     // MIs[0] round
     /* 1533093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533096 */     // MIs[0] policy
     /* 1533096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533106 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1533109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533130 */     // GIR_Coverage, 18528,
     /* 1533130 */     GIR_EraseRootFromParent_Done,
     /* 1533131 */   // Label 21315: @1533131
     /* 1533131 */   GIM_Try, /*On fail goto*//*Label 21316*/ GIMT_Encode4(1533213), // Rule ID 18529 //
     /* 1533136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1533147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1533150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1533153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1533156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533175 */     // MIs[0] round
     /* 1533175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533178 */     // MIs[0] policy
     /* 1533178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533188 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1533191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533212 */     // GIR_Coverage, 18529,
     /* 1533212 */     GIR_EraseRootFromParent_Done,
     /* 1533213 */   // Label 21316: @1533213
     /* 1533213 */   GIM_Try, /*On fail goto*//*Label 21317*/ GIMT_Encode4(1533295), // Rule ID 18532 //
     /* 1533218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1533229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1533232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1533235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1533238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533257 */     // MIs[0] round
     /* 1533257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533260 */     // MIs[0] policy
     /* 1533260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533270 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1533273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533294 */     // GIR_Coverage, 18532,
     /* 1533294 */     GIR_EraseRootFromParent_Done,
     /* 1533295 */   // Label 21317: @1533295
     /* 1533295 */   GIM_Try, /*On fail goto*//*Label 21318*/ GIMT_Encode4(1533377), // Rule ID 18533 //
     /* 1533300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1533311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1533314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1533317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1533320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533339 */     // MIs[0] round
     /* 1533339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533342 */     // MIs[0] policy
     /* 1533342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533352 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1533355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533376 */     // GIR_Coverage, 18533,
     /* 1533376 */     GIR_EraseRootFromParent_Done,
     /* 1533377 */   // Label 21318: @1533377
     /* 1533377 */   GIM_Try, /*On fail goto*//*Label 21319*/ GIMT_Encode4(1533459), // Rule ID 18536 //
     /* 1533382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1533393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1533396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1533402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533421 */     // MIs[0] round
     /* 1533421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533424 */     // MIs[0] policy
     /* 1533424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533434 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1533437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533458 */     // GIR_Coverage, 18536,
     /* 1533458 */     GIR_EraseRootFromParent_Done,
     /* 1533459 */   // Label 21319: @1533459
     /* 1533459 */   GIM_Try, /*On fail goto*//*Label 21320*/ GIMT_Encode4(1533541), // Rule ID 18537 //
     /* 1533464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1533475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1533478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1533484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533503 */     // MIs[0] round
     /* 1533503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533506 */     // MIs[0] policy
     /* 1533506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533516 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1533519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533540 */     // GIR_Coverage, 18537,
     /* 1533540 */     GIR_EraseRootFromParent_Done,
     /* 1533541 */   // Label 21320: @1533541
     /* 1533541 */   GIM_Try, /*On fail goto*//*Label 21321*/ GIMT_Encode4(1533623), // Rule ID 18540 //
     /* 1533546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1533557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1533560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1533566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533585 */     // MIs[0] round
     /* 1533585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533588 */     // MIs[0] policy
     /* 1533588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533598 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1533601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533622 */     // GIR_Coverage, 18540,
     /* 1533622 */     GIR_EraseRootFromParent_Done,
     /* 1533623 */   // Label 21321: @1533623
     /* 1533623 */   GIM_Try, /*On fail goto*//*Label 21322*/ GIMT_Encode4(1533705), // Rule ID 18541 //
     /* 1533628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1533639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1533642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1533648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533667 */     // MIs[0] round
     /* 1533667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533670 */     // MIs[0] policy
     /* 1533670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533680 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1533683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533704 */     // GIR_Coverage, 18541,
     /* 1533704 */     GIR_EraseRootFromParent_Done,
     /* 1533705 */   // Label 21322: @1533705
     /* 1533705 */   GIM_Try, /*On fail goto*//*Label 21323*/ GIMT_Encode4(1533787), // Rule ID 18544 //
     /* 1533710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1533713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1533721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1533724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1533730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533749 */     // MIs[0] round
     /* 1533749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533752 */     // MIs[0] policy
     /* 1533752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533762 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1533765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533786 */     // GIR_Coverage, 18544,
     /* 1533786 */     GIR_EraseRootFromParent_Done,
     /* 1533787 */   // Label 21323: @1533787
     /* 1533787 */   GIM_Try, /*On fail goto*//*Label 21324*/ GIMT_Encode4(1533869), // Rule ID 18545 //
     /* 1533792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1533795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1533803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1533806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1533812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533831 */     // MIs[0] round
     /* 1533831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533834 */     // MIs[0] policy
     /* 1533834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533844 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1533847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533868 */     // GIR_Coverage, 18545,
     /* 1533868 */     GIR_EraseRootFromParent_Done,
     /* 1533869 */   // Label 21324: @1533869
     /* 1533869 */   GIM_Try, /*On fail goto*//*Label 21325*/ GIMT_Encode4(1533951), // Rule ID 18548 //
     /* 1533874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1533885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1533888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1533894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533913 */     // MIs[0] round
     /* 1533913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533916 */     // MIs[0] policy
     /* 1533916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533926 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1533929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533950 */     // GIR_Coverage, 18548,
     /* 1533950 */     GIR_EraseRootFromParent_Done,
     /* 1533951 */   // Label 21325: @1533951
     /* 1533951 */   GIM_Try, /*On fail goto*//*Label 21326*/ GIMT_Encode4(1534033), // Rule ID 18549 //
     /* 1533956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1533967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1533970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1533976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533995 */     // MIs[0] round
     /* 1533995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533998 */     // MIs[0] policy
     /* 1533998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534008 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1534011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534032 */     // GIR_Coverage, 18549,
     /* 1534032 */     GIR_EraseRootFromParent_Done,
     /* 1534033 */   // Label 21326: @1534033
     /* 1534033 */   GIM_Try, /*On fail goto*//*Label 21327*/ GIMT_Encode4(1534115), // Rule ID 18552 //
     /* 1534038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1534041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1534049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1534052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1534058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534077 */     // MIs[0] round
     /* 1534077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534080 */     // MIs[0] policy
     /* 1534080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534090 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1534093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534114 */     // GIR_Coverage, 18552,
     /* 1534114 */     GIR_EraseRootFromParent_Done,
     /* 1534115 */   // Label 21327: @1534115
     /* 1534115 */   GIM_Try, /*On fail goto*//*Label 21328*/ GIMT_Encode4(1534197), // Rule ID 18553 //
     /* 1534120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1534123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1534131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1534134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1534140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534159 */     // MIs[0] round
     /* 1534159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534162 */     // MIs[0] policy
     /* 1534162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534172 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1534175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534196 */     // GIR_Coverage, 18553,
     /* 1534196 */     GIR_EraseRootFromParent_Done,
     /* 1534197 */   // Label 21328: @1534197
     /* 1534197 */   GIM_Try, /*On fail goto*//*Label 21329*/ GIMT_Encode4(1534279), // Rule ID 18556 //
     /* 1534202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1534205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1534213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1534216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1534222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534241 */     // MIs[0] round
     /* 1534241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534244 */     // MIs[0] policy
     /* 1534244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534254 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1534257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534278 */     // GIR_Coverage, 18556,
     /* 1534278 */     GIR_EraseRootFromParent_Done,
     /* 1534279 */   // Label 21329: @1534279
     /* 1534279 */   GIM_Try, /*On fail goto*//*Label 21330*/ GIMT_Encode4(1534361), // Rule ID 18557 //
     /* 1534284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1534287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1534295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1534298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1534304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534323 */     // MIs[0] round
     /* 1534323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534326 */     // MIs[0] policy
     /* 1534326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534336 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1534339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534360 */     // GIR_Coverage, 18557,
     /* 1534360 */     GIR_EraseRootFromParent_Done,
     /* 1534361 */   // Label 21330: @1534361
     /* 1534361 */   GIM_Try, /*On fail goto*//*Label 21331*/ GIMT_Encode4(1534443), // Rule ID 18560 //
     /* 1534366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1534377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1534380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1534386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534405 */     // MIs[0] round
     /* 1534405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534408 */     // MIs[0] policy
     /* 1534408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534418 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1534421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534442 */     // GIR_Coverage, 18560,
     /* 1534442 */     GIR_EraseRootFromParent_Done,
     /* 1534443 */   // Label 21331: @1534443
     /* 1534443 */   GIM_Try, /*On fail goto*//*Label 21332*/ GIMT_Encode4(1534525), // Rule ID 18561 //
     /* 1534448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1534459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1534462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1534468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534487 */     // MIs[0] round
     /* 1534487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534490 */     // MIs[0] policy
     /* 1534490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534500 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1534503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534524 */     // GIR_Coverage, 18561,
     /* 1534524 */     GIR_EraseRootFromParent_Done,
     /* 1534525 */   // Label 21332: @1534525
     /* 1534525 */   GIM_Try, /*On fail goto*//*Label 21333*/ GIMT_Encode4(1534607), // Rule ID 18564 //
     /* 1534530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1534541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1534544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1534550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534569 */     // MIs[0] round
     /* 1534569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534572 */     // MIs[0] policy
     /* 1534572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534582 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1534585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534606 */     // GIR_Coverage, 18564,
     /* 1534606 */     GIR_EraseRootFromParent_Done,
     /* 1534607 */   // Label 21333: @1534607
     /* 1534607 */   GIM_Try, /*On fail goto*//*Label 21334*/ GIMT_Encode4(1534689), // Rule ID 18565 //
     /* 1534612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1534623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1534626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1534632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534651 */     // MIs[0] round
     /* 1534651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534654 */     // MIs[0] policy
     /* 1534654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534664 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1534667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534688 */     // GIR_Coverage, 18565,
     /* 1534688 */     GIR_EraseRootFromParent_Done,
     /* 1534689 */   // Label 21334: @1534689
     /* 1534689 */   GIM_Try, /*On fail goto*//*Label 21335*/ GIMT_Encode4(1534771), // Rule ID 18568 //
     /* 1534694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1534705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1534708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1534714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534733 */     // MIs[0] round
     /* 1534733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534736 */     // MIs[0] policy
     /* 1534736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534746 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1534749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534770 */     // GIR_Coverage, 18568,
     /* 1534770 */     GIR_EraseRootFromParent_Done,
     /* 1534771 */   // Label 21335: @1534771
     /* 1534771 */   GIM_Try, /*On fail goto*//*Label 21336*/ GIMT_Encode4(1534853), // Rule ID 18569 //
     /* 1534776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1534787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1534790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1534796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534815 */     // MIs[0] round
     /* 1534815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534818 */     // MIs[0] policy
     /* 1534818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534828 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1534831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534852 */     // GIR_Coverage, 18569,
     /* 1534852 */     GIR_EraseRootFromParent_Done,
     /* 1534853 */   // Label 21336: @1534853
     /* 1534853 */   GIM_Try, /*On fail goto*//*Label 21337*/ GIMT_Encode4(1534935), // Rule ID 18572 //
     /* 1534858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1534861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1534869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1534872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1534878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534897 */     // MIs[0] round
     /* 1534897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534900 */     // MIs[0] policy
     /* 1534900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534910 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1534913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534934 */     // GIR_Coverage, 18572,
     /* 1534934 */     GIR_EraseRootFromParent_Done,
     /* 1534935 */   // Label 21337: @1534935
     /* 1534935 */   GIM_Try, /*On fail goto*//*Label 21338*/ GIMT_Encode4(1535017), // Rule ID 18573 //
     /* 1534940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1534943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1534951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1534954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1534960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534979 */     // MIs[0] round
     /* 1534979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534982 */     // MIs[0] policy
     /* 1534982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534992 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1534995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535016 */     // GIR_Coverage, 18573,
     /* 1535016 */     GIR_EraseRootFromParent_Done,
     /* 1535017 */   // Label 21338: @1535017
     /* 1535017 */   GIM_Try, /*On fail goto*//*Label 21339*/ GIMT_Encode4(1535099), // Rule ID 18576 //
     /* 1535022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1535033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1535036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1535042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535061 */     // MIs[0] round
     /* 1535061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535064 */     // MIs[0] policy
     /* 1535064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535074 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1535077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535098 */     // GIR_Coverage, 18576,
     /* 1535098 */     GIR_EraseRootFromParent_Done,
     /* 1535099 */   // Label 21339: @1535099
     /* 1535099 */   GIM_Try, /*On fail goto*//*Label 21340*/ GIMT_Encode4(1535181), // Rule ID 18577 //
     /* 1535104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1535115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1535118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1535124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535143 */     // MIs[0] round
     /* 1535143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535146 */     // MIs[0] policy
     /* 1535146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535156 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1535159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535180 */     // GIR_Coverage, 18577,
     /* 1535180 */     GIR_EraseRootFromParent_Done,
     /* 1535181 */   // Label 21340: @1535181
     /* 1535181 */   GIM_Try, /*On fail goto*//*Label 21341*/ GIMT_Encode4(1535263), // Rule ID 18580 //
     /* 1535186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1535197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1535200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1535206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535225 */     // MIs[0] round
     /* 1535225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535228 */     // MIs[0] policy
     /* 1535228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535238 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1535241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535262 */     // GIR_Coverage, 18580,
     /* 1535262 */     GIR_EraseRootFromParent_Done,
     /* 1535263 */   // Label 21341: @1535263
     /* 1535263 */   GIM_Try, /*On fail goto*//*Label 21342*/ GIMT_Encode4(1535345), // Rule ID 18581 //
     /* 1535268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1535279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1535282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1535288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535307 */     // MIs[0] round
     /* 1535307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535310 */     // MIs[0] policy
     /* 1535310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535320 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1535323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535344 */     // GIR_Coverage, 18581,
     /* 1535344 */     GIR_EraseRootFromParent_Done,
     /* 1535345 */   // Label 21342: @1535345
     /* 1535345 */   GIM_Try, /*On fail goto*//*Label 21343*/ GIMT_Encode4(1535427), // Rule ID 18584 //
     /* 1535350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1535361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1535364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1535370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535389 */     // MIs[0] round
     /* 1535389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535392 */     // MIs[0] policy
     /* 1535392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535402 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1535405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535426 */     // GIR_Coverage, 18584,
     /* 1535426 */     GIR_EraseRootFromParent_Done,
     /* 1535427 */   // Label 21343: @1535427
     /* 1535427 */   GIM_Try, /*On fail goto*//*Label 21344*/ GIMT_Encode4(1535509), // Rule ID 18585 //
     /* 1535432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1535435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1535443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1535446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1535452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535471 */     // MIs[0] round
     /* 1535471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535474 */     // MIs[0] policy
     /* 1535474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535484 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1535487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535508 */     // GIR_Coverage, 18585,
     /* 1535508 */     GIR_EraseRootFromParent_Done,
     /* 1535509 */   // Label 21344: @1535509
     /* 1535509 */   GIM_Try, /*On fail goto*//*Label 21345*/ GIMT_Encode4(1535591), // Rule ID 18588 //
     /* 1535514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1535525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1535528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1535534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535553 */     // MIs[0] round
     /* 1535553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535556 */     // MIs[0] policy
     /* 1535556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535566 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1535569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535590 */     // GIR_Coverage, 18588,
     /* 1535590 */     GIR_EraseRootFromParent_Done,
     /* 1535591 */   // Label 21345: @1535591
     /* 1535591 */   GIM_Try, /*On fail goto*//*Label 21346*/ GIMT_Encode4(1535673), // Rule ID 18589 //
     /* 1535596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1535599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1535607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1535610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1535616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535635 */     // MIs[0] round
     /* 1535635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535638 */     // MIs[0] policy
     /* 1535638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535648 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1535651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535672 */     // GIR_Coverage, 18589,
     /* 1535672 */     GIR_EraseRootFromParent_Done,
     /* 1535673 */   // Label 21346: @1535673
     /* 1535673 */   GIM_Try, /*On fail goto*//*Label 21347*/ GIMT_Encode4(1535755), // Rule ID 18592 //
     /* 1535678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1535689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1535692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1535698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535717 */     // MIs[0] round
     /* 1535717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535720 */     // MIs[0] policy
     /* 1535720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535730 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1535733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535754 */     // GIR_Coverage, 18592,
     /* 1535754 */     GIR_EraseRootFromParent_Done,
     /* 1535755 */   // Label 21347: @1535755
     /* 1535755 */   GIM_Try, /*On fail goto*//*Label 21348*/ GIMT_Encode4(1535837), // Rule ID 18593 //
     /* 1535760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1535763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1535771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1535774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1535780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535799 */     // MIs[0] round
     /* 1535799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535802 */     // MIs[0] policy
     /* 1535802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535812 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1535815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535836 */     // GIR_Coverage, 18593,
     /* 1535836 */     GIR_EraseRootFromParent_Done,
     /* 1535837 */   // Label 21348: @1535837
     /* 1535837 */   GIM_Try, /*On fail goto*//*Label 21349*/ GIMT_Encode4(1535919), // Rule ID 18596 //
     /* 1535842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1535845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1535853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1535856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1535859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1535862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535881 */     // MIs[0] round
     /* 1535881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535884 */     // MIs[0] policy
     /* 1535884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535894 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1535897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535918 */     // GIR_Coverage, 18596,
     /* 1535918 */     GIR_EraseRootFromParent_Done,
     /* 1535919 */   // Label 21349: @1535919
     /* 1535919 */   GIM_Try, /*On fail goto*//*Label 21350*/ GIMT_Encode4(1536001), // Rule ID 18597 //
     /* 1535924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1535927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1535935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1535938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1535941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1535944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535963 */     // MIs[0] round
     /* 1535963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535966 */     // MIs[0] policy
     /* 1535966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535976 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1535979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536000 */     // GIR_Coverage, 18597,
     /* 1536000 */     GIR_EraseRootFromParent_Done,
     /* 1536001 */   // Label 21350: @1536001
     /* 1536001 */   GIM_Try, /*On fail goto*//*Label 21351*/ GIMT_Encode4(1536083), // Rule ID 18600 //
     /* 1536006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1536017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1536020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1536023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1536026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536045 */     // MIs[0] round
     /* 1536045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536048 */     // MIs[0] policy
     /* 1536048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536058 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1536061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536082 */     // GIR_Coverage, 18600,
     /* 1536082 */     GIR_EraseRootFromParent_Done,
     /* 1536083 */   // Label 21351: @1536083
     /* 1536083 */   GIM_Try, /*On fail goto*//*Label 21352*/ GIMT_Encode4(1536165), // Rule ID 18601 //
     /* 1536088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1536099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1536102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1536105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1536108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536127 */     // MIs[0] round
     /* 1536127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536130 */     // MIs[0] policy
     /* 1536130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536140 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1536143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536164 */     // GIR_Coverage, 18601,
     /* 1536164 */     GIR_EraseRootFromParent_Done,
     /* 1536165 */   // Label 21352: @1536165
     /* 1536165 */   GIM_Try, /*On fail goto*//*Label 21353*/ GIMT_Encode4(1536247), // Rule ID 18604 //
     /* 1536170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1536173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1536181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1536184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1536187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1536190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536209 */     // MIs[0] round
     /* 1536209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536212 */     // MIs[0] policy
     /* 1536212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536222 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1536225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536246 */     // GIR_Coverage, 18604,
     /* 1536246 */     GIR_EraseRootFromParent_Done,
     /* 1536247 */   // Label 21353: @1536247
     /* 1536247 */   GIM_Try, /*On fail goto*//*Label 21354*/ GIMT_Encode4(1536329), // Rule ID 18605 //
     /* 1536252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1536255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1536263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1536266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1536269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1536272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536291 */     // MIs[0] round
     /* 1536291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536294 */     // MIs[0] policy
     /* 1536294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536304 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1536307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536328 */     // GIR_Coverage, 18605,
     /* 1536328 */     GIR_EraseRootFromParent_Done,
     /* 1536329 */   // Label 21354: @1536329
     /* 1536329 */   GIM_Try, /*On fail goto*//*Label 21355*/ GIMT_Encode4(1536411), // Rule ID 18608 //
     /* 1536334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1536345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1536348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1536351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1536354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536373 */     // MIs[0] round
     /* 1536373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536376 */     // MIs[0] policy
     /* 1536376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536386 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1536389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536410 */     // GIR_Coverage, 18608,
     /* 1536410 */     GIR_EraseRootFromParent_Done,
     /* 1536411 */   // Label 21355: @1536411
     /* 1536411 */   GIM_Try, /*On fail goto*//*Label 21356*/ GIMT_Encode4(1536493), // Rule ID 18609 //
     /* 1536416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1536427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1536430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1536433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1536436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536455 */     // MIs[0] round
     /* 1536455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536458 */     // MIs[0] policy
     /* 1536458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536468 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1536471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536492 */     // GIR_Coverage, 18609,
     /* 1536492 */     GIR_EraseRootFromParent_Done,
     /* 1536493 */   // Label 21356: @1536493
     /* 1536493 */   GIM_Try, /*On fail goto*//*Label 21357*/ GIMT_Encode4(1536575), // Rule ID 18612 //
     /* 1536498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1536501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1536509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1536512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1536515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1536518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536537 */     // MIs[0] round
     /* 1536537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536540 */     // MIs[0] policy
     /* 1536540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536550 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1536553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536574 */     // GIR_Coverage, 18612,
     /* 1536574 */     GIR_EraseRootFromParent_Done,
     /* 1536575 */   // Label 21357: @1536575
     /* 1536575 */   GIM_Try, /*On fail goto*//*Label 21358*/ GIMT_Encode4(1536657), // Rule ID 18613 //
     /* 1536580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1536583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1536591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1536594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1536597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1536600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536619 */     // MIs[0] round
     /* 1536619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536622 */     // MIs[0] policy
     /* 1536622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536632 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1536635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536656 */     // GIR_Coverage, 18613,
     /* 1536656 */     GIR_EraseRootFromParent_Done,
     /* 1536657 */   // Label 21358: @1536657
     /* 1536657 */   GIM_Try, /*On fail goto*//*Label 21359*/ GIMT_Encode4(1536739), // Rule ID 18616 //
     /* 1536662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1536665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1536673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1536676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1536679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1536682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536701 */     // MIs[0] round
     /* 1536701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536704 */     // MIs[0] policy
     /* 1536704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536714 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1536717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536738 */     // GIR_Coverage, 18616,
     /* 1536738 */     GIR_EraseRootFromParent_Done,
     /* 1536739 */   // Label 21359: @1536739
     /* 1536739 */   GIM_Try, /*On fail goto*//*Label 21360*/ GIMT_Encode4(1536821), // Rule ID 18617 //
     /* 1536744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1536747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1536755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1536758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1536761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1536764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536783 */     // MIs[0] round
     /* 1536783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536786 */     // MIs[0] policy
     /* 1536786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536796 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1536799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536820 */     // GIR_Coverage, 18617,
     /* 1536820 */     GIR_EraseRootFromParent_Done,
     /* 1536821 */   // Label 21360: @1536821
     /* 1536821 */   GIM_Try, /*On fail goto*//*Label 21361*/ GIMT_Encode4(1536903), // Rule ID 18620 //
     /* 1536826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1536837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1536840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1536843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1536846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536865 */     // MIs[0] round
     /* 1536865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536868 */     // MIs[0] policy
     /* 1536868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536878 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1536881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536902 */     // GIR_Coverage, 18620,
     /* 1536902 */     GIR_EraseRootFromParent_Done,
     /* 1536903 */   // Label 21361: @1536903
     /* 1536903 */   GIM_Try, /*On fail goto*//*Label 21362*/ GIMT_Encode4(1536985), // Rule ID 18621 //
     /* 1536908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1536919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1536922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1536925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1536928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536947 */     // MIs[0] round
     /* 1536947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536950 */     // MIs[0] policy
     /* 1536950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536960 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1536963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536984 */     // GIR_Coverage, 18621,
     /* 1536984 */     GIR_EraseRootFromParent_Done,
     /* 1536985 */   // Label 21362: @1536985
     /* 1536985 */   GIM_Try, /*On fail goto*//*Label 21363*/ GIMT_Encode4(1537067), // Rule ID 18624 //
     /* 1536990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1537001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1537004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1537007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1537010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537029 */     // MIs[0] round
     /* 1537029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537032 */     // MIs[0] policy
     /* 1537032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537042 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1537045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537066 */     // GIR_Coverage, 18624,
     /* 1537066 */     GIR_EraseRootFromParent_Done,
     /* 1537067 */   // Label 21363: @1537067
     /* 1537067 */   GIM_Try, /*On fail goto*//*Label 21364*/ GIMT_Encode4(1537149), // Rule ID 18625 //
     /* 1537072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1537083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1537086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1537089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1537092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537111 */     // MIs[0] round
     /* 1537111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537114 */     // MIs[0] policy
     /* 1537114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537124 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1537127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537148 */     // GIR_Coverage, 18625,
     /* 1537148 */     GIR_EraseRootFromParent_Done,
     /* 1537149 */   // Label 21364: @1537149
     /* 1537149 */   GIM_Try, /*On fail goto*//*Label 21365*/ GIMT_Encode4(1537231), // Rule ID 18628 //
     /* 1537154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1537165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1537168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1537171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1537174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537193 */     // MIs[0] round
     /* 1537193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537196 */     // MIs[0] policy
     /* 1537196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537206 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1537209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537230 */     // GIR_Coverage, 18628,
     /* 1537230 */     GIR_EraseRootFromParent_Done,
     /* 1537231 */   // Label 21365: @1537231
     /* 1537231 */   GIM_Try, /*On fail goto*//*Label 21366*/ GIMT_Encode4(1537313), // Rule ID 18629 //
     /* 1537236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1537247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1537250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1537253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1537256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537275 */     // MIs[0] round
     /* 1537275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537278 */     // MIs[0] policy
     /* 1537278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537288 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1537291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537312 */     // GIR_Coverage, 18629,
     /* 1537312 */     GIR_EraseRootFromParent_Done,
     /* 1537313 */   // Label 21366: @1537313
     /* 1537313 */   GIM_Try, /*On fail goto*//*Label 21367*/ GIMT_Encode4(1537395), // Rule ID 18632 //
     /* 1537318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1537329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1537332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1537335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1537338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537357 */     // MIs[0] round
     /* 1537357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537360 */     // MIs[0] policy
     /* 1537360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537370 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1537373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537394 */     // GIR_Coverage, 18632,
     /* 1537394 */     GIR_EraseRootFromParent_Done,
     /* 1537395 */   // Label 21367: @1537395
     /* 1537395 */   GIM_Try, /*On fail goto*//*Label 21368*/ GIMT_Encode4(1537477), // Rule ID 18633 //
     /* 1537400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1537411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1537414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1537417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1537420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537439 */     // MIs[0] round
     /* 1537439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537442 */     // MIs[0] policy
     /* 1537442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537452 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1537455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537476 */     // GIR_Coverage, 18633,
     /* 1537476 */     GIR_EraseRootFromParent_Done,
     /* 1537477 */   // Label 21368: @1537477
     /* 1537477 */   GIM_Try, /*On fail goto*//*Label 21369*/ GIMT_Encode4(1537559), // Rule ID 18636 //
     /* 1537482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1537493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1537496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1537499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1537502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537521 */     // MIs[0] round
     /* 1537521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537524 */     // MIs[0] policy
     /* 1537524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537534 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1537537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537558 */     // GIR_Coverage, 18636,
     /* 1537558 */     GIR_EraseRootFromParent_Done,
     /* 1537559 */   // Label 21369: @1537559
     /* 1537559 */   GIM_Try, /*On fail goto*//*Label 21370*/ GIMT_Encode4(1537641), // Rule ID 18637 //
     /* 1537564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1537575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1537578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1537581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1537584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537603 */     // MIs[0] round
     /* 1537603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537606 */     // MIs[0] policy
     /* 1537606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537616 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1537619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537640 */     // GIR_Coverage, 18637,
     /* 1537640 */     GIR_EraseRootFromParent_Done,
     /* 1537641 */   // Label 21370: @1537641
     /* 1537641 */   GIM_Try, /*On fail goto*//*Label 21371*/ GIMT_Encode4(1537723), // Rule ID 18640 //
     /* 1537646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1537657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1537660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1537663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1537666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537685 */     // MIs[0] round
     /* 1537685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537688 */     // MIs[0] policy
     /* 1537688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537698 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1537701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537722 */     // GIR_Coverage, 18640,
     /* 1537722 */     GIR_EraseRootFromParent_Done,
     /* 1537723 */   // Label 21371: @1537723
     /* 1537723 */   GIM_Try, /*On fail goto*//*Label 21372*/ GIMT_Encode4(1537805), // Rule ID 18641 //
     /* 1537728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1537739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1537742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1537745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1537748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537767 */     // MIs[0] round
     /* 1537767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537770 */     // MIs[0] policy
     /* 1537770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537780 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1537783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537804 */     // GIR_Coverage, 18641,
     /* 1537804 */     GIR_EraseRootFromParent_Done,
     /* 1537805 */   // Label 21372: @1537805
     /* 1537805 */   GIM_Try, /*On fail goto*//*Label 21373*/ GIMT_Encode4(1537887), // Rule ID 18644 //
     /* 1537810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1537813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1537821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1537824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1537827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1537830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537849 */     // MIs[0] round
     /* 1537849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537852 */     // MIs[0] policy
     /* 1537852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537862 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1537865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1537883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537886 */     // GIR_Coverage, 18644,
     /* 1537886 */     GIR_EraseRootFromParent_Done,
     /* 1537887 */   // Label 21373: @1537887
     /* 1537887 */   GIM_Try, /*On fail goto*//*Label 21374*/ GIMT_Encode4(1537969), // Rule ID 18645 //
     /* 1537892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1537895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1537903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1537906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1537909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1537912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537931 */     // MIs[0] round
     /* 1537931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537934 */     // MIs[0] policy
     /* 1537934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537944 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1537947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1537965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537968 */     // GIR_Coverage, 18645,
     /* 1537968 */     GIR_EraseRootFromParent_Done,
     /* 1537969 */   // Label 21374: @1537969
     /* 1537969 */   GIM_Try, /*On fail goto*//*Label 21375*/ GIMT_Encode4(1538051), // Rule ID 18648 //
     /* 1537974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1537977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1537985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1537988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1537991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1537994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538013 */     // MIs[0] round
     /* 1538013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538016 */     // MIs[0] policy
     /* 1538016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538026 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1538029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538050 */     // GIR_Coverage, 18648,
     /* 1538050 */     GIR_EraseRootFromParent_Done,
     /* 1538051 */   // Label 21375: @1538051
     /* 1538051 */   GIM_Try, /*On fail goto*//*Label 21376*/ GIMT_Encode4(1538133), // Rule ID 18649 //
     /* 1538056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1538067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1538070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1538073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1538076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538095 */     // MIs[0] round
     /* 1538095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538098 */     // MIs[0] policy
     /* 1538098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538108 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1538111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538132 */     // GIR_Coverage, 18649,
     /* 1538132 */     GIR_EraseRootFromParent_Done,
     /* 1538133 */   // Label 21376: @1538133
     /* 1538133 */   GIM_Try, /*On fail goto*//*Label 21377*/ GIMT_Encode4(1538215), // Rule ID 18652 //
     /* 1538138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1538141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1538149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1538152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1538155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1538158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538177 */     // MIs[0] round
     /* 1538177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538180 */     // MIs[0] policy
     /* 1538180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538190 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1538193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538214 */     // GIR_Coverage, 18652,
     /* 1538214 */     GIR_EraseRootFromParent_Done,
     /* 1538215 */   // Label 21377: @1538215
     /* 1538215 */   GIM_Try, /*On fail goto*//*Label 21378*/ GIMT_Encode4(1538297), // Rule ID 18653 //
     /* 1538220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1538231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1538234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1538237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1538240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538259 */     // MIs[0] round
     /* 1538259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538262 */     // MIs[0] policy
     /* 1538262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538272 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1538275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538296 */     // GIR_Coverage, 18653,
     /* 1538296 */     GIR_EraseRootFromParent_Done,
     /* 1538297 */   // Label 21378: @1538297
     /* 1538297 */   GIM_Try, /*On fail goto*//*Label 21379*/ GIMT_Encode4(1538379), // Rule ID 18656 //
     /* 1538302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1538305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1538313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1538316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538341 */     // MIs[0] round
     /* 1538341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538344 */     // MIs[0] policy
     /* 1538344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538354 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1538357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538378 */     // GIR_Coverage, 18656,
     /* 1538378 */     GIR_EraseRootFromParent_Done,
     /* 1538379 */   // Label 21379: @1538379
     /* 1538379 */   GIM_Try, /*On fail goto*//*Label 21380*/ GIMT_Encode4(1538461), // Rule ID 18657 //
     /* 1538384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1538387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1538395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1538398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538423 */     // MIs[0] round
     /* 1538423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538426 */     // MIs[0] policy
     /* 1538426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538436 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1538439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538460 */     // GIR_Coverage, 18657,
     /* 1538460 */     GIR_EraseRootFromParent_Done,
     /* 1538461 */   // Label 21380: @1538461
     /* 1538461 */   GIM_Try, /*On fail goto*//*Label 21381*/ GIMT_Encode4(1538543), // Rule ID 18660 //
     /* 1538466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1538469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1538477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1538480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1538486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538505 */     // MIs[0] round
     /* 1538505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538508 */     // MIs[0] policy
     /* 1538508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538518 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1538521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538542 */     // GIR_Coverage, 18660,
     /* 1538542 */     GIR_EraseRootFromParent_Done,
     /* 1538543 */   // Label 21381: @1538543
     /* 1538543 */   GIM_Try, /*On fail goto*//*Label 21382*/ GIMT_Encode4(1538625), // Rule ID 18661 //
     /* 1538548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1538551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1538559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1538562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1538568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538587 */     // MIs[0] round
     /* 1538587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538590 */     // MIs[0] policy
     /* 1538590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538600 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1538603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538624 */     // GIR_Coverage, 18661,
     /* 1538624 */     GIR_EraseRootFromParent_Done,
     /* 1538625 */   // Label 21382: @1538625
     /* 1538625 */   GIM_Try, /*On fail goto*//*Label 21383*/ GIMT_Encode4(1538707), // Rule ID 18664 //
     /* 1538630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1538633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1538641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1538644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1538647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1538650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1538665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538669 */     // MIs[0] round
     /* 1538669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538672 */     // MIs[0] policy
     /* 1538672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538682 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1538685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538706 */     // GIR_Coverage, 18664,
     /* 1538706 */     GIR_EraseRootFromParent_Done,
     /* 1538707 */   // Label 21383: @1538707
     /* 1538707 */   GIM_Try, /*On fail goto*//*Label 21384*/ GIMT_Encode4(1538789), // Rule ID 18665 //
     /* 1538712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1538715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1538723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1538726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1538729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1538732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1538747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538751 */     // MIs[0] round
     /* 1538751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538754 */     // MIs[0] policy
     /* 1538754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538764 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1538767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538788 */     // GIR_Coverage, 18665,
     /* 1538788 */     GIR_EraseRootFromParent_Done,
     /* 1538789 */   // Label 21384: @1538789
     /* 1538789 */   GIM_Try, /*On fail goto*//*Label 21385*/ GIMT_Encode4(1538871), // Rule ID 18668 //
     /* 1538794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1538797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1538805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1538808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1538814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538833 */     // MIs[0] round
     /* 1538833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538836 */     // MIs[0] policy
     /* 1538836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538846 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1538849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538870 */     // GIR_Coverage, 18668,
     /* 1538870 */     GIR_EraseRootFromParent_Done,
     /* 1538871 */   // Label 21385: @1538871
     /* 1538871 */   GIM_Try, /*On fail goto*//*Label 21386*/ GIMT_Encode4(1538953), // Rule ID 18669 //
     /* 1538876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1538879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1538887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1538890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1538896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538915 */     // MIs[0] round
     /* 1538915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538918 */     // MIs[0] policy
     /* 1538918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538928 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1538931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538952 */     // GIR_Coverage, 18669,
     /* 1538952 */     GIR_EraseRootFromParent_Done,
     /* 1538953 */   // Label 21386: @1538953
     /* 1538953 */   GIM_Try, /*On fail goto*//*Label 21387*/ GIMT_Encode4(1539035), // Rule ID 18672 //
     /* 1538958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1538961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1538969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1538972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1538975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1538978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1538993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538997 */     // MIs[0] round
     /* 1538997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539000 */     // MIs[0] policy
     /* 1539000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539010 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1539013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539034 */     // GIR_Coverage, 18672,
     /* 1539034 */     GIR_EraseRootFromParent_Done,
     /* 1539035 */   // Label 21387: @1539035
     /* 1539035 */   GIM_Try, /*On fail goto*//*Label 21388*/ GIMT_Encode4(1539117), // Rule ID 18673 //
     /* 1539040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1539043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1539051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1539054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1539060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539079 */     // MIs[0] round
     /* 1539079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539082 */     // MIs[0] policy
     /* 1539082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539092 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1539095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539116 */     // GIR_Coverage, 18673,
     /* 1539116 */     GIR_EraseRootFromParent_Done,
     /* 1539117 */   // Label 21388: @1539117
     /* 1539117 */   GIM_Try, /*On fail goto*//*Label 21389*/ GIMT_Encode4(1539199), // Rule ID 18676 //
     /* 1539122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1539125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1539142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539161 */     // MIs[0] round
     /* 1539161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539164 */     // MIs[0] policy
     /* 1539164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539174 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1539177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539198 */     // GIR_Coverage, 18676,
     /* 1539198 */     GIR_EraseRootFromParent_Done,
     /* 1539199 */   // Label 21389: @1539199
     /* 1539199 */   GIM_Try, /*On fail goto*//*Label 21390*/ GIMT_Encode4(1539281), // Rule ID 18677 //
     /* 1539204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1539207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1539224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539243 */     // MIs[0] round
     /* 1539243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539246 */     // MIs[0] policy
     /* 1539246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539256 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1539259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539280 */     // GIR_Coverage, 18677,
     /* 1539280 */     GIR_EraseRootFromParent_Done,
     /* 1539281 */   // Label 21390: @1539281
     /* 1539281 */   GIM_Try, /*On fail goto*//*Label 21391*/ GIMT_Encode4(1539363), // Rule ID 18680 //
     /* 1539286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1539297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1539300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1539306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539325 */     // MIs[0] round
     /* 1539325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539328 */     // MIs[0] policy
     /* 1539328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539338 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1539341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539362 */     // GIR_Coverage, 18680,
     /* 1539362 */     GIR_EraseRootFromParent_Done,
     /* 1539363 */   // Label 21391: @1539363
     /* 1539363 */   GIM_Try, /*On fail goto*//*Label 21392*/ GIMT_Encode4(1539445), // Rule ID 18681 //
     /* 1539368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1539379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1539382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1539388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539407 */     // MIs[0] round
     /* 1539407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539410 */     // MIs[0] policy
     /* 1539410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539420 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1539423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539444 */     // GIR_Coverage, 18681,
     /* 1539444 */     GIR_EraseRootFromParent_Done,
     /* 1539445 */   // Label 21392: @1539445
     /* 1539445 */   GIM_Try, /*On fail goto*//*Label 21393*/ GIMT_Encode4(1539527), // Rule ID 18684 //
     /* 1539450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1539461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1539464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1539470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539489 */     // MIs[0] round
     /* 1539489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539492 */     // MIs[0] policy
     /* 1539492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539502 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1539505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539526 */     // GIR_Coverage, 18684,
     /* 1539526 */     GIR_EraseRootFromParent_Done,
     /* 1539527 */   // Label 21393: @1539527
     /* 1539527 */   GIM_Try, /*On fail goto*//*Label 21394*/ GIMT_Encode4(1539609), // Rule ID 18685 //
     /* 1539532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1539543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1539546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1539552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539571 */     // MIs[0] round
     /* 1539571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539574 */     // MIs[0] policy
     /* 1539574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539584 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1539587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539608 */     // GIR_Coverage, 18685,
     /* 1539608 */     GIR_EraseRootFromParent_Done,
     /* 1539609 */   // Label 21394: @1539609
     /* 1539609 */   GIM_Try, /*On fail goto*//*Label 21395*/ GIMT_Encode4(1539691), // Rule ID 18688 //
     /* 1539614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1539625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1539628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1539634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539653 */     // MIs[0] round
     /* 1539653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539656 */     // MIs[0] policy
     /* 1539656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539666 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1539669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539690 */     // GIR_Coverage, 18688,
     /* 1539690 */     GIR_EraseRootFromParent_Done,
     /* 1539691 */   // Label 21395: @1539691
     /* 1539691 */   GIM_Try, /*On fail goto*//*Label 21396*/ GIMT_Encode4(1539773), // Rule ID 18689 //
     /* 1539696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1539707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1539710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1539716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539735 */     // MIs[0] round
     /* 1539735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539738 */     // MIs[0] policy
     /* 1539738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539748 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1539751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539772 */     // GIR_Coverage, 18689,
     /* 1539772 */     GIR_EraseRootFromParent_Done,
     /* 1539773 */   // Label 21396: @1539773
     /* 1539773 */   GIM_Try, /*On fail goto*//*Label 21397*/ GIMT_Encode4(1539855), // Rule ID 18692 //
     /* 1539778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1539781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1539789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1539792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1539798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539817 */     // MIs[0] round
     /* 1539817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539820 */     // MIs[0] policy
     /* 1539820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539830 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1539833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539854 */     // GIR_Coverage, 18692,
     /* 1539854 */     GIR_EraseRootFromParent_Done,
     /* 1539855 */   // Label 21397: @1539855
     /* 1539855 */   GIM_Try, /*On fail goto*//*Label 21398*/ GIMT_Encode4(1539937), // Rule ID 18693 //
     /* 1539860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1539863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1539871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1539874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1539880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539899 */     // MIs[0] round
     /* 1539899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539902 */     // MIs[0] policy
     /* 1539902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539912 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1539915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539936 */     // GIR_Coverage, 18693,
     /* 1539936 */     GIR_EraseRootFromParent_Done,
     /* 1539937 */   // Label 21398: @1539937
     /* 1539937 */   GIM_Try, /*On fail goto*//*Label 21399*/ GIMT_Encode4(1540019), // Rule ID 18696 //
     /* 1539942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1539945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1539953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1539956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1539962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539981 */     // MIs[0] round
     /* 1539981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539984 */     // MIs[0] policy
     /* 1539984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539994 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1539997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540018 */     // GIR_Coverage, 18696,
     /* 1540018 */     GIR_EraseRootFromParent_Done,
     /* 1540019 */   // Label 21399: @1540019
     /* 1540019 */   GIM_Try, /*On fail goto*//*Label 21400*/ GIMT_Encode4(1540101), // Rule ID 18697 //
     /* 1540024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1540027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1540035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1540038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1540044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540063 */     // MIs[0] round
     /* 1540063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540066 */     // MIs[0] policy
     /* 1540066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540076 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1540079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540100 */     // GIR_Coverage, 18697,
     /* 1540100 */     GIR_EraseRootFromParent_Done,
     /* 1540101 */   // Label 21400: @1540101
     /* 1540101 */   GIM_Try, /*On fail goto*//*Label 21401*/ GIMT_Encode4(1540183), // Rule ID 18700 //
     /* 1540106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1540109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1540117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1540120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1540126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540145 */     // MIs[0] round
     /* 1540145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540148 */     // MIs[0] policy
     /* 1540148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540158 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1540161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540182 */     // GIR_Coverage, 18700,
     /* 1540182 */     GIR_EraseRootFromParent_Done,
     /* 1540183 */   // Label 21401: @1540183
     /* 1540183 */   GIM_Try, /*On fail goto*//*Label 21402*/ GIMT_Encode4(1540265), // Rule ID 18701 //
     /* 1540188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1540191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1540199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1540202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1540208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540227 */     // MIs[0] round
     /* 1540227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540230 */     // MIs[0] policy
     /* 1540230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540240 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1540243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540264 */     // GIR_Coverage, 18701,
     /* 1540264 */     GIR_EraseRootFromParent_Done,
     /* 1540265 */   // Label 21402: @1540265
     /* 1540265 */   GIM_Try, /*On fail goto*//*Label 21403*/ GIMT_Encode4(1540347), // Rule ID 18704 //
     /* 1540270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1540273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1540281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1540284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1540290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540309 */     // MIs[0] round
     /* 1540309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540312 */     // MIs[0] policy
     /* 1540312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540322 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1540325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540346 */     // GIR_Coverage, 18704,
     /* 1540346 */     GIR_EraseRootFromParent_Done,
     /* 1540347 */   // Label 21403: @1540347
     /* 1540347 */   GIM_Try, /*On fail goto*//*Label 21404*/ GIMT_Encode4(1540429), // Rule ID 18705 //
     /* 1540352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1540355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1540363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1540366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1540372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540391 */     // MIs[0] round
     /* 1540391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540394 */     // MIs[0] policy
     /* 1540394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540404 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1540407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540428 */     // GIR_Coverage, 18705,
     /* 1540428 */     GIR_EraseRootFromParent_Done,
     /* 1540429 */   // Label 21404: @1540429
     /* 1540429 */   GIM_Try, /*On fail goto*//*Label 21405*/ GIMT_Encode4(1540511), // Rule ID 18708 //
     /* 1540434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1540437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1540445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1540448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1540454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540473 */     // MIs[0] round
     /* 1540473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540476 */     // MIs[0] policy
     /* 1540476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540486 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1540489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540510 */     // GIR_Coverage, 18708,
     /* 1540510 */     GIR_EraseRootFromParent_Done,
     /* 1540511 */   // Label 21405: @1540511
     /* 1540511 */   GIM_Try, /*On fail goto*//*Label 21406*/ GIMT_Encode4(1540593), // Rule ID 18709 //
     /* 1540516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1540519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1540527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1540530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1540536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540555 */     // MIs[0] round
     /* 1540555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540558 */     // MIs[0] policy
     /* 1540558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540568 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1540571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540592 */     // GIR_Coverage, 18709,
     /* 1540592 */     GIR_EraseRootFromParent_Done,
     /* 1540593 */   // Label 21406: @1540593
     /* 1540593 */   GIM_Try, /*On fail goto*//*Label 21407*/ GIMT_Encode4(1540675), // Rule ID 18712 //
     /* 1540598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1540601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1540609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1540612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1540618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540637 */     // MIs[0] round
     /* 1540637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540640 */     // MIs[0] policy
     /* 1540640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540650 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1540653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540674 */     // GIR_Coverage, 18712,
     /* 1540674 */     GIR_EraseRootFromParent_Done,
     /* 1540675 */   // Label 21407: @1540675
     /* 1540675 */   GIM_Try, /*On fail goto*//*Label 21408*/ GIMT_Encode4(1540757), // Rule ID 18713 //
     /* 1540680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1540683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1540691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1540694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1540700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540719 */     // MIs[0] round
     /* 1540719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540722 */     // MIs[0] policy
     /* 1540722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540732 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1540735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540756 */     // GIR_Coverage, 18713,
     /* 1540756 */     GIR_EraseRootFromParent_Done,
     /* 1540757 */   // Label 21408: @1540757
     /* 1540757 */   GIM_Try, /*On fail goto*//*Label 21409*/ GIMT_Encode4(1540839), // Rule ID 18716 //
     /* 1540762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1540765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1540773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1540776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1540779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1540782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540801 */     // MIs[0] round
     /* 1540801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540804 */     // MIs[0] policy
     /* 1540804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540814 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1540817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540838 */     // GIR_Coverage, 18716,
     /* 1540838 */     GIR_EraseRootFromParent_Done,
     /* 1540839 */   // Label 21409: @1540839
     /* 1540839 */   GIM_Try, /*On fail goto*//*Label 21410*/ GIMT_Encode4(1540921), // Rule ID 18717 //
     /* 1540844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1540847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1540855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1540858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1540861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1540864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540883 */     // MIs[0] round
     /* 1540883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540886 */     // MIs[0] policy
     /* 1540886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540896 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1540899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540920 */     // GIR_Coverage, 18717,
     /* 1540920 */     GIR_EraseRootFromParent_Done,
     /* 1540921 */   // Label 21410: @1540921
     /* 1540921 */   GIM_Try, /*On fail goto*//*Label 21411*/ GIMT_Encode4(1541003), // Rule ID 18720 //
     /* 1540926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1540929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1540937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1540940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1540943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1540946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540965 */     // MIs[0] round
     /* 1540965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540968 */     // MIs[0] policy
     /* 1540968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540978 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1540981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541002 */     // GIR_Coverage, 18720,
     /* 1541002 */     GIR_EraseRootFromParent_Done,
     /* 1541003 */   // Label 21411: @1541003
     /* 1541003 */   GIM_Try, /*On fail goto*//*Label 21412*/ GIMT_Encode4(1541085), // Rule ID 18721 //
     /* 1541008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1541019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1541022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1541025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1541028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541047 */     // MIs[0] round
     /* 1541047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541050 */     // MIs[0] policy
     /* 1541050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541060 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1541063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541084 */     // GIR_Coverage, 18721,
     /* 1541084 */     GIR_EraseRootFromParent_Done,
     /* 1541085 */   // Label 21412: @1541085
     /* 1541085 */   GIM_Try, /*On fail goto*//*Label 21413*/ GIMT_Encode4(1541167), // Rule ID 18724 //
     /* 1541090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1541107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1541110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541129 */     // MIs[0] round
     /* 1541129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541132 */     // MIs[0] policy
     /* 1541132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541142 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1541145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541166 */     // GIR_Coverage, 18724,
     /* 1541166 */     GIR_EraseRootFromParent_Done,
     /* 1541167 */   // Label 21413: @1541167
     /* 1541167 */   GIM_Try, /*On fail goto*//*Label 21414*/ GIMT_Encode4(1541249), // Rule ID 18725 //
     /* 1541172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1541189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1541192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541211 */     // MIs[0] round
     /* 1541211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541214 */     // MIs[0] policy
     /* 1541214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541224 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1541227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541248 */     // GIR_Coverage, 18725,
     /* 1541248 */     GIR_EraseRootFromParent_Done,
     /* 1541249 */   // Label 21414: @1541249
     /* 1541249 */   GIM_Try, /*On fail goto*//*Label 21415*/ GIMT_Encode4(1541331), // Rule ID 18728 //
     /* 1541254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1541265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1541268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1541271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1541274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541293 */     // MIs[0] round
     /* 1541293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541296 */     // MIs[0] policy
     /* 1541296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541306 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1541309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541330 */     // GIR_Coverage, 18728,
     /* 1541330 */     GIR_EraseRootFromParent_Done,
     /* 1541331 */   // Label 21415: @1541331
     /* 1541331 */   GIM_Try, /*On fail goto*//*Label 21416*/ GIMT_Encode4(1541413), // Rule ID 18729 //
     /* 1541336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1541347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1541350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1541353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1541356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541375 */     // MIs[0] round
     /* 1541375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541378 */     // MIs[0] policy
     /* 1541378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541388 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1541391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541412 */     // GIR_Coverage, 18729,
     /* 1541412 */     GIR_EraseRootFromParent_Done,
     /* 1541413 */   // Label 21416: @1541413
     /* 1541413 */   GIM_Try, /*On fail goto*//*Label 21417*/ GIMT_Encode4(1541495), // Rule ID 18732 //
     /* 1541418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1541429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1541432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1541435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1541438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541457 */     // MIs[0] round
     /* 1541457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541460 */     // MIs[0] policy
     /* 1541460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541470 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1541473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541494 */     // GIR_Coverage, 18732,
     /* 1541494 */     GIR_EraseRootFromParent_Done,
     /* 1541495 */   // Label 21417: @1541495
     /* 1541495 */   GIM_Try, /*On fail goto*//*Label 21418*/ GIMT_Encode4(1541577), // Rule ID 18733 //
     /* 1541500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1541511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1541514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1541517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1541520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541539 */     // MIs[0] round
     /* 1541539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541542 */     // MIs[0] policy
     /* 1541542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541552 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1541555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541576 */     // GIR_Coverage, 18733,
     /* 1541576 */     GIR_EraseRootFromParent_Done,
     /* 1541577 */   // Label 21418: @1541577
     /* 1541577 */   GIM_Try, /*On fail goto*//*Label 21419*/ GIMT_Encode4(1541659), // Rule ID 18736 //
     /* 1541582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1541585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1541593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1541596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1541599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1541602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541621 */     // MIs[0] round
     /* 1541621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541624 */     // MIs[0] policy
     /* 1541624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541634 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1541637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541658 */     // GIR_Coverage, 18736,
     /* 1541658 */     GIR_EraseRootFromParent_Done,
     /* 1541659 */   // Label 21419: @1541659
     /* 1541659 */   GIM_Try, /*On fail goto*//*Label 21420*/ GIMT_Encode4(1541741), // Rule ID 18737 //
     /* 1541664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1541667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1541675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1541678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1541681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1541684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541703 */     // MIs[0] round
     /* 1541703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541706 */     // MIs[0] policy
     /* 1541706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541716 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1541719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541740 */     // GIR_Coverage, 18737,
     /* 1541740 */     GIR_EraseRootFromParent_Done,
     /* 1541741 */   // Label 21420: @1541741
     /* 1541741 */   GIM_Try, /*On fail goto*//*Label 21421*/ GIMT_Encode4(1541823), // Rule ID 18740 //
     /* 1541746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1541749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1541757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1541760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1541763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1541766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541785 */     // MIs[0] round
     /* 1541785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541788 */     // MIs[0] policy
     /* 1541788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541798 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1541801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541822 */     // GIR_Coverage, 18740,
     /* 1541822 */     GIR_EraseRootFromParent_Done,
     /* 1541823 */   // Label 21421: @1541823
     /* 1541823 */   GIM_Try, /*On fail goto*//*Label 21422*/ GIMT_Encode4(1541905), // Rule ID 18741 //
     /* 1541828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1541831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1541839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1541842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1541845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1541848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541867 */     // MIs[0] round
     /* 1541867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541870 */     // MIs[0] policy
     /* 1541870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541880 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1541883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541904 */     // GIR_Coverage, 18741,
     /* 1541904 */     GIR_EraseRootFromParent_Done,
     /* 1541905 */   // Label 21422: @1541905
     /* 1541905 */   GIM_Try, /*On fail goto*//*Label 21423*/ GIMT_Encode4(1541987), // Rule ID 18744 //
     /* 1541910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1541913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1541921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1541924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1541927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1541930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541949 */     // MIs[0] round
     /* 1541949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541952 */     // MIs[0] policy
     /* 1541952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541962 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1541965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541973 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541986 */     // GIR_Coverage, 18744,
     /* 1541986 */     GIR_EraseRootFromParent_Done,
     /* 1541987 */   // Label 21423: @1541987
     /* 1541987 */   GIM_Try, /*On fail goto*//*Label 21424*/ GIMT_Encode4(1542069), // Rule ID 18745 //
     /* 1541992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1541995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1542003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1542006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1542009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1542012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542031 */     // MIs[0] round
     /* 1542031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542034 */     // MIs[0] policy
     /* 1542034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542044 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1542047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542068 */     // GIR_Coverage, 18745,
     /* 1542068 */     GIR_EraseRootFromParent_Done,
     /* 1542069 */   // Label 21424: @1542069
     /* 1542069 */   GIM_Try, /*On fail goto*//*Label 21425*/ GIMT_Encode4(1542151), // Rule ID 18748 //
     /* 1542074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1542091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1542094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542113 */     // MIs[0] round
     /* 1542113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542116 */     // MIs[0] policy
     /* 1542116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542126 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1542129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542150 */     // GIR_Coverage, 18748,
     /* 1542150 */     GIR_EraseRootFromParent_Done,
     /* 1542151 */   // Label 21425: @1542151
     /* 1542151 */   GIM_Try, /*On fail goto*//*Label 21426*/ GIMT_Encode4(1542233), // Rule ID 18749 //
     /* 1542156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1542173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1542176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542195 */     // MIs[0] round
     /* 1542195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542198 */     // MIs[0] policy
     /* 1542198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542208 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1542211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542232 */     // GIR_Coverage, 18749,
     /* 1542232 */     GIR_EraseRootFromParent_Done,
     /* 1542233 */   // Label 21426: @1542233
     /* 1542233 */   GIM_Try, /*On fail goto*//*Label 21427*/ GIMT_Encode4(1542315), // Rule ID 18752 //
     /* 1542238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1542249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1542252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1542258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542277 */     // MIs[0] round
     /* 1542277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542280 */     // MIs[0] policy
     /* 1542280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542290 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1542293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542314 */     // GIR_Coverage, 18752,
     /* 1542314 */     GIR_EraseRootFromParent_Done,
     /* 1542315 */   // Label 21427: @1542315
     /* 1542315 */   GIM_Try, /*On fail goto*//*Label 21428*/ GIMT_Encode4(1542397), // Rule ID 18753 //
     /* 1542320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1542331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1542334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1542340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542359 */     // MIs[0] round
     /* 1542359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542362 */     // MIs[0] policy
     /* 1542362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542372 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1542375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542396 */     // GIR_Coverage, 18753,
     /* 1542396 */     GIR_EraseRootFromParent_Done,
     /* 1542397 */   // Label 21428: @1542397
     /* 1542397 */   GIM_Try, /*On fail goto*//*Label 21429*/ GIMT_Encode4(1542479), // Rule ID 18756 //
     /* 1542402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1542413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1542416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1542422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542441 */     // MIs[0] round
     /* 1542441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542444 */     // MIs[0] policy
     /* 1542444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542454 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1542457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542478 */     // GIR_Coverage, 18756,
     /* 1542478 */     GIR_EraseRootFromParent_Done,
     /* 1542479 */   // Label 21429: @1542479
     /* 1542479 */   GIM_Try, /*On fail goto*//*Label 21430*/ GIMT_Encode4(1542561), // Rule ID 18757 //
     /* 1542484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1542495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1542498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1542504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542523 */     // MIs[0] round
     /* 1542523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542526 */     // MIs[0] policy
     /* 1542526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542536 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1542539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542560 */     // GIR_Coverage, 18757,
     /* 1542560 */     GIR_EraseRootFromParent_Done,
     /* 1542561 */   // Label 21430: @1542561
     /* 1542561 */   GIM_Try, /*On fail goto*//*Label 21431*/ GIMT_Encode4(1542643), // Rule ID 18760 //
     /* 1542566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1542577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1542580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1542586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542605 */     // MIs[0] round
     /* 1542605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542608 */     // MIs[0] policy
     /* 1542608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542618 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1542621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542642 */     // GIR_Coverage, 18760,
     /* 1542642 */     GIR_EraseRootFromParent_Done,
     /* 1542643 */   // Label 21431: @1542643
     /* 1542643 */   GIM_Try, /*On fail goto*//*Label 21432*/ GIMT_Encode4(1542725), // Rule ID 18761 //
     /* 1542648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1542659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1542662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1542668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542687 */     // MIs[0] round
     /* 1542687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542690 */     // MIs[0] policy
     /* 1542690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542700 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1542703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542724 */     // GIR_Coverage, 18761,
     /* 1542724 */     GIR_EraseRootFromParent_Done,
     /* 1542725 */   // Label 21432: @1542725
     /* 1542725 */   GIM_Try, /*On fail goto*//*Label 21433*/ GIMT_Encode4(1542807), // Rule ID 18764 //
     /* 1542730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1542741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1542744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1542750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542769 */     // MIs[0] round
     /* 1542769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542772 */     // MIs[0] policy
     /* 1542772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542782 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1542785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542806 */     // GIR_Coverage, 18764,
     /* 1542806 */     GIR_EraseRootFromParent_Done,
     /* 1542807 */   // Label 21433: @1542807
     /* 1542807 */   GIM_Try, /*On fail goto*//*Label 21434*/ GIMT_Encode4(1542889), // Rule ID 18765 //
     /* 1542812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1542823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1542826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1542832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542851 */     // MIs[0] round
     /* 1542851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542854 */     // MIs[0] policy
     /* 1542854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542864 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1542867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542888 */     // GIR_Coverage, 18765,
     /* 1542888 */     GIR_EraseRootFromParent_Done,
     /* 1542889 */   // Label 21434: @1542889
     /* 1542889 */   GIM_Try, /*On fail goto*//*Label 21435*/ GIMT_Encode4(1542971), // Rule ID 18768 //
     /* 1542894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1542905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1542908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1542914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542933 */     // MIs[0] round
     /* 1542933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542936 */     // MIs[0] policy
     /* 1542936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542946 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1542949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542970 */     // GIR_Coverage, 18768,
     /* 1542970 */     GIR_EraseRootFromParent_Done,
     /* 1542971 */   // Label 21435: @1542971
     /* 1542971 */   GIM_Try, /*On fail goto*//*Label 21436*/ GIMT_Encode4(1543053), // Rule ID 18769 //
     /* 1542976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1542987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1542990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1542996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543015 */     // MIs[0] round
     /* 1543015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543018 */     // MIs[0] policy
     /* 1543018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543028 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1543031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543052 */     // GIR_Coverage, 18769,
     /* 1543052 */     GIR_EraseRootFromParent_Done,
     /* 1543053 */   // Label 21436: @1543053
     /* 1543053 */   GIM_Try, /*On fail goto*//*Label 21437*/ GIMT_Encode4(1543135), // Rule ID 18772 //
     /* 1543058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1543069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1543072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1543078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543097 */     // MIs[0] round
     /* 1543097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543100 */     // MIs[0] policy
     /* 1543100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543110 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1543113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543134 */     // GIR_Coverage, 18772,
     /* 1543134 */     GIR_EraseRootFromParent_Done,
     /* 1543135 */   // Label 21437: @1543135
     /* 1543135 */   GIM_Try, /*On fail goto*//*Label 21438*/ GIMT_Encode4(1543217), // Rule ID 18773 //
     /* 1543140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1543151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1543154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1543160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543179 */     // MIs[0] round
     /* 1543179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543182 */     // MIs[0] policy
     /* 1543182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543192 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1543195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543216 */     // GIR_Coverage, 18773,
     /* 1543216 */     GIR_EraseRootFromParent_Done,
     /* 1543217 */   // Label 21438: @1543217
     /* 1543217 */   GIM_Try, /*On fail goto*//*Label 21439*/ GIMT_Encode4(1543299), // Rule ID 18776 //
     /* 1543222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1543233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1543236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1543242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543261 */     // MIs[0] round
     /* 1543261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543264 */     // MIs[0] policy
     /* 1543264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543274 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1543277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543298 */     // GIR_Coverage, 18776,
     /* 1543298 */     GIR_EraseRootFromParent_Done,
     /* 1543299 */   // Label 21439: @1543299
     /* 1543299 */   GIM_Try, /*On fail goto*//*Label 21440*/ GIMT_Encode4(1543381), // Rule ID 18777 //
     /* 1543304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1543315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1543318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1543324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543343 */     // MIs[0] round
     /* 1543343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543346 */     // MIs[0] policy
     /* 1543346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543356 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1543359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543380 */     // GIR_Coverage, 18777,
     /* 1543380 */     GIR_EraseRootFromParent_Done,
     /* 1543381 */   // Label 21440: @1543381
     /* 1543381 */   GIM_Try, /*On fail goto*//*Label 21441*/ GIMT_Encode4(1543463), // Rule ID 18780 //
     /* 1543386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1543397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1543400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1543406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543425 */     // MIs[0] round
     /* 1543425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543428 */     // MIs[0] policy
     /* 1543428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543438 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1543441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543462 */     // GIR_Coverage, 18780,
     /* 1543462 */     GIR_EraseRootFromParent_Done,
     /* 1543463 */   // Label 21441: @1543463
     /* 1543463 */   GIM_Try, /*On fail goto*//*Label 21442*/ GIMT_Encode4(1543545), // Rule ID 18781 //
     /* 1543468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1543479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1543482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1543488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543507 */     // MIs[0] round
     /* 1543507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543510 */     // MIs[0] policy
     /* 1543510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543520 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1543523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543544 */     // GIR_Coverage, 18781,
     /* 1543544 */     GIR_EraseRootFromParent_Done,
     /* 1543545 */   // Label 21442: @1543545
     /* 1543545 */   GIM_Try, /*On fail goto*//*Label 21443*/ GIMT_Encode4(1543627), // Rule ID 18784 //
     /* 1543550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1543561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1543564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1543570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543589 */     // MIs[0] round
     /* 1543589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543592 */     // MIs[0] policy
     /* 1543592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543602 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1543605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543626 */     // GIR_Coverage, 18784,
     /* 1543626 */     GIR_EraseRootFromParent_Done,
     /* 1543627 */   // Label 21443: @1543627
     /* 1543627 */   GIM_Try, /*On fail goto*//*Label 21444*/ GIMT_Encode4(1543709), // Rule ID 18785 //
     /* 1543632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1543643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1543646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1543652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543671 */     // MIs[0] round
     /* 1543671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543674 */     // MIs[0] policy
     /* 1543674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543684 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1543687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543708 */     // GIR_Coverage, 18785,
     /* 1543708 */     GIR_EraseRootFromParent_Done,
     /* 1543709 */   // Label 21444: @1543709
     /* 1543709 */   GIM_Try, /*On fail goto*//*Label 21445*/ GIMT_Encode4(1543791), // Rule ID 18788 //
     /* 1543714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1543725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1543728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1543731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1543734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543753 */     // MIs[0] round
     /* 1543753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543756 */     // MIs[0] policy
     /* 1543756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543766 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1543769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543790 */     // GIR_Coverage, 18788,
     /* 1543790 */     GIR_EraseRootFromParent_Done,
     /* 1543791 */   // Label 21445: @1543791
     /* 1543791 */   GIM_Try, /*On fail goto*//*Label 21446*/ GIMT_Encode4(1543873), // Rule ID 18789 //
     /* 1543796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1543807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1543810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1543813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1543816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543835 */     // MIs[0] round
     /* 1543835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543838 */     // MIs[0] policy
     /* 1543838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543848 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1543851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543872 */     // GIR_Coverage, 18789,
     /* 1543872 */     GIR_EraseRootFromParent_Done,
     /* 1543873 */   // Label 21446: @1543873
     /* 1543873 */   GIM_Try, /*On fail goto*//*Label 21447*/ GIMT_Encode4(1543955), // Rule ID 18792 //
     /* 1543878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1543889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1543892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1543895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1543898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543917 */     // MIs[0] round
     /* 1543917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543920 */     // MIs[0] policy
     /* 1543920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543930 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1543933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543954 */     // GIR_Coverage, 18792,
     /* 1543954 */     GIR_EraseRootFromParent_Done,
     /* 1543955 */   // Label 21447: @1543955
     /* 1543955 */   GIM_Try, /*On fail goto*//*Label 21448*/ GIMT_Encode4(1544037), // Rule ID 18793 //
     /* 1543960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1543971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1543974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1543977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1543980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543999 */     // MIs[0] round
     /* 1543999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544002 */     // MIs[0] policy
     /* 1544002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544012 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1544015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544036 */     // GIR_Coverage, 18793,
     /* 1544036 */     GIR_EraseRootFromParent_Done,
     /* 1544037 */   // Label 21448: @1544037
     /* 1544037 */   GIM_Try, /*On fail goto*//*Label 21449*/ GIMT_Encode4(1544119), // Rule ID 18796 //
     /* 1544042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1544053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1544056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1544059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1544062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544081 */     // MIs[0] round
     /* 1544081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544084 */     // MIs[0] policy
     /* 1544084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544094 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1544097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544118 */     // GIR_Coverage, 18796,
     /* 1544118 */     GIR_EraseRootFromParent_Done,
     /* 1544119 */   // Label 21449: @1544119
     /* 1544119 */   GIM_Try, /*On fail goto*//*Label 21450*/ GIMT_Encode4(1544201), // Rule ID 18797 //
     /* 1544124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1544135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1544138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1544141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1544144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544163 */     // MIs[0] round
     /* 1544163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544166 */     // MIs[0] policy
     /* 1544166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544176 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1544179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544200 */     // GIR_Coverage, 18797,
     /* 1544200 */     GIR_EraseRootFromParent_Done,
     /* 1544201 */   // Label 21450: @1544201
     /* 1544201 */   GIM_Try, /*On fail goto*//*Label 21451*/ GIMT_Encode4(1544283), // Rule ID 18800 //
     /* 1544206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1544217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1544220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1544223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1544226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544245 */     // MIs[0] round
     /* 1544245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544248 */     // MIs[0] policy
     /* 1544248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544258 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1544261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544282 */     // GIR_Coverage, 18800,
     /* 1544282 */     GIR_EraseRootFromParent_Done,
     /* 1544283 */   // Label 21451: @1544283
     /* 1544283 */   GIM_Try, /*On fail goto*//*Label 21452*/ GIMT_Encode4(1544365), // Rule ID 18801 //
     /* 1544288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1544299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1544302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1544305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1544308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544327 */     // MIs[0] round
     /* 1544327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544330 */     // MIs[0] policy
     /* 1544330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544340 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1544343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544364 */     // GIR_Coverage, 18801,
     /* 1544364 */     GIR_EraseRootFromParent_Done,
     /* 1544365 */   // Label 21452: @1544365
     /* 1544365 */   GIM_Try, /*On fail goto*//*Label 21453*/ GIMT_Encode4(1544447), // Rule ID 18804 //
     /* 1544370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1544381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1544384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1544387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1544390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544409 */     // MIs[0] round
     /* 1544409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544412 */     // MIs[0] policy
     /* 1544412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544422 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1544425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544446 */     // GIR_Coverage, 18804,
     /* 1544446 */     GIR_EraseRootFromParent_Done,
     /* 1544447 */   // Label 21453: @1544447
     /* 1544447 */   GIM_Try, /*On fail goto*//*Label 21454*/ GIMT_Encode4(1544529), // Rule ID 18805 //
     /* 1544452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1544463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1544466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1544469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1544472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544491 */     // MIs[0] round
     /* 1544491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544494 */     // MIs[0] policy
     /* 1544494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544504 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1544507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544528 */     // GIR_Coverage, 18805,
     /* 1544528 */     GIR_EraseRootFromParent_Done,
     /* 1544529 */   // Label 21454: @1544529
     /* 1544529 */   GIM_Try, /*On fail goto*//*Label 21455*/ GIMT_Encode4(1544611), // Rule ID 18808 //
     /* 1544534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1544545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1544548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1544551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1544554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544573 */     // MIs[0] round
     /* 1544573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544576 */     // MIs[0] policy
     /* 1544576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544586 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1544589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544610 */     // GIR_Coverage, 18808,
     /* 1544610 */     GIR_EraseRootFromParent_Done,
     /* 1544611 */   // Label 21455: @1544611
     /* 1544611 */   GIM_Try, /*On fail goto*//*Label 21456*/ GIMT_Encode4(1544693), // Rule ID 18809 //
     /* 1544616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1544627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1544630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1544633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1544636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544655 */     // MIs[0] round
     /* 1544655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544658 */     // MIs[0] policy
     /* 1544658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544668 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1544671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544692 */     // GIR_Coverage, 18809,
     /* 1544692 */     GIR_EraseRootFromParent_Done,
     /* 1544693 */   // Label 21456: @1544693
     /* 1544693 */   GIM_Try, /*On fail goto*//*Label 21457*/ GIMT_Encode4(1544775), // Rule ID 18812 //
     /* 1544698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1544709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1544712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1544715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1544718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544737 */     // MIs[0] round
     /* 1544737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544740 */     // MIs[0] policy
     /* 1544740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544750 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1544753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544774 */     // GIR_Coverage, 18812,
     /* 1544774 */     GIR_EraseRootFromParent_Done,
     /* 1544775 */   // Label 21457: @1544775
     /* 1544775 */   GIM_Try, /*On fail goto*//*Label 21458*/ GIMT_Encode4(1544857), // Rule ID 18813 //
     /* 1544780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1544791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1544794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1544797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1544800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544819 */     // MIs[0] round
     /* 1544819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544822 */     // MIs[0] policy
     /* 1544822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544832 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1544835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544856 */     // GIR_Coverage, 18813,
     /* 1544856 */     GIR_EraseRootFromParent_Done,
     /* 1544857 */   // Label 21458: @1544857
     /* 1544857 */   GIM_Try, /*On fail goto*//*Label 21459*/ GIMT_Encode4(1544939), // Rule ID 18816 //
     /* 1544862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1544873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1544876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1544879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1544882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544901 */     // MIs[0] round
     /* 1544901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544904 */     // MIs[0] policy
     /* 1544904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544914 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1544917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544938 */     // GIR_Coverage, 18816,
     /* 1544938 */     GIR_EraseRootFromParent_Done,
     /* 1544939 */   // Label 21459: @1544939
     /* 1544939 */   GIM_Try, /*On fail goto*//*Label 21460*/ GIMT_Encode4(1545021), // Rule ID 18817 //
     /* 1544944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1544955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1544958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1544961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1544964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544983 */     // MIs[0] round
     /* 1544983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544986 */     // MIs[0] policy
     /* 1544986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544996 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1544999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545020 */     // GIR_Coverage, 18817,
     /* 1545020 */     GIR_EraseRootFromParent_Done,
     /* 1545021 */   // Label 21460: @1545021
     /* 1545021 */   GIM_Try, /*On fail goto*//*Label 21461*/ GIMT_Encode4(1545103), // Rule ID 18820 //
     /* 1545026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1545043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545065 */     // MIs[0] round
     /* 1545065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545068 */     // MIs[0] policy
     /* 1545068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545078 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1545081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545102 */     // GIR_Coverage, 18820,
     /* 1545102 */     GIR_EraseRootFromParent_Done,
     /* 1545103 */   // Label 21461: @1545103
     /* 1545103 */   GIM_Try, /*On fail goto*//*Label 21462*/ GIMT_Encode4(1545185), // Rule ID 18821 //
     /* 1545108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1545125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545147 */     // MIs[0] round
     /* 1545147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545150 */     // MIs[0] policy
     /* 1545150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545160 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1545163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545184 */     // GIR_Coverage, 18821,
     /* 1545184 */     GIR_EraseRootFromParent_Done,
     /* 1545185 */   // Label 21462: @1545185
     /* 1545185 */   GIM_Try, /*On fail goto*//*Label 21463*/ GIMT_Encode4(1545267), // Rule ID 18824 //
     /* 1545190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1545201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1545204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1545210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545229 */     // MIs[0] round
     /* 1545229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545232 */     // MIs[0] policy
     /* 1545232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545242 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1545245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545266 */     // GIR_Coverage, 18824,
     /* 1545266 */     GIR_EraseRootFromParent_Done,
     /* 1545267 */   // Label 21463: @1545267
     /* 1545267 */   GIM_Try, /*On fail goto*//*Label 21464*/ GIMT_Encode4(1545349), // Rule ID 18825 //
     /* 1545272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1545283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1545286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1545292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545311 */     // MIs[0] round
     /* 1545311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545314 */     // MIs[0] policy
     /* 1545314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545324 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1545327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545348 */     // GIR_Coverage, 18825,
     /* 1545348 */     GIR_EraseRootFromParent_Done,
     /* 1545349 */   // Label 21464: @1545349
     /* 1545349 */   GIM_Try, /*On fail goto*//*Label 21465*/ GIMT_Encode4(1545431), // Rule ID 18828 //
     /* 1545354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1545365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1545368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1545374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545393 */     // MIs[0] round
     /* 1545393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545396 */     // MIs[0] policy
     /* 1545396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545406 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1545409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545430 */     // GIR_Coverage, 18828,
     /* 1545430 */     GIR_EraseRootFromParent_Done,
     /* 1545431 */   // Label 21465: @1545431
     /* 1545431 */   GIM_Try, /*On fail goto*//*Label 21466*/ GIMT_Encode4(1545513), // Rule ID 18829 //
     /* 1545436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1545447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1545450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1545456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545475 */     // MIs[0] round
     /* 1545475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545478 */     // MIs[0] policy
     /* 1545478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545488 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1545491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545512 */     // GIR_Coverage, 18829,
     /* 1545512 */     GIR_EraseRootFromParent_Done,
     /* 1545513 */   // Label 21466: @1545513
     /* 1545513 */   GIM_Try, /*On fail goto*//*Label 21467*/ GIMT_Encode4(1545595), // Rule ID 18832 //
     /* 1545518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1545529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1545532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1545538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545557 */     // MIs[0] round
     /* 1545557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545560 */     // MIs[0] policy
     /* 1545560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545570 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1545573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545594 */     // GIR_Coverage, 18832,
     /* 1545594 */     GIR_EraseRootFromParent_Done,
     /* 1545595 */   // Label 21467: @1545595
     /* 1545595 */   GIM_Try, /*On fail goto*//*Label 21468*/ GIMT_Encode4(1545677), // Rule ID 18833 //
     /* 1545600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1545611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1545614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1545620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545639 */     // MIs[0] round
     /* 1545639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545642 */     // MIs[0] policy
     /* 1545642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545652 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1545655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545676 */     // GIR_Coverage, 18833,
     /* 1545676 */     GIR_EraseRootFromParent_Done,
     /* 1545677 */   // Label 21468: @1545677
     /* 1545677 */   GIM_Try, /*On fail goto*//*Label 21469*/ GIMT_Encode4(1545759), // Rule ID 18836 //
     /* 1545682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1545693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1545696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1545702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545721 */     // MIs[0] round
     /* 1545721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545724 */     // MIs[0] policy
     /* 1545724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545734 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1545737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545758 */     // GIR_Coverage, 18836,
     /* 1545758 */     GIR_EraseRootFromParent_Done,
     /* 1545759 */   // Label 21469: @1545759
     /* 1545759 */   GIM_Try, /*On fail goto*//*Label 21470*/ GIMT_Encode4(1545841), // Rule ID 18837 //
     /* 1545764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1545775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1545778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1545784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545803 */     // MIs[0] round
     /* 1545803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545806 */     // MIs[0] policy
     /* 1545806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545816 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1545819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545840 */     // GIR_Coverage, 18837,
     /* 1545840 */     GIR_EraseRootFromParent_Done,
     /* 1545841 */   // Label 21470: @1545841
     /* 1545841 */   GIM_Try, /*On fail goto*//*Label 21471*/ GIMT_Encode4(1545923), // Rule ID 18840 //
     /* 1545846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1545857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1545860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1545866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545885 */     // MIs[0] round
     /* 1545885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545888 */     // MIs[0] policy
     /* 1545888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545898 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1545901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545909 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545922 */     // GIR_Coverage, 18840,
     /* 1545922 */     GIR_EraseRootFromParent_Done,
     /* 1545923 */   // Label 21471: @1545923
     /* 1545923 */   GIM_Try, /*On fail goto*//*Label 21472*/ GIMT_Encode4(1546005), // Rule ID 18841 //
     /* 1545928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1545939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1545942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1545948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545967 */     // MIs[0] round
     /* 1545967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545970 */     // MIs[0] policy
     /* 1545970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545980 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1545983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546004 */     // GIR_Coverage, 18841,
     /* 1546004 */     GIR_EraseRootFromParent_Done,
     /* 1546005 */   // Label 21472: @1546005
     /* 1546005 */   GIM_Try, /*On fail goto*//*Label 21473*/ GIMT_Encode4(1546087), // Rule ID 18844 //
     /* 1546010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1546030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546049 */     // MIs[0] round
     /* 1546049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546052 */     // MIs[0] policy
     /* 1546052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546062 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1546065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546086 */     // GIR_Coverage, 18844,
     /* 1546086 */     GIR_EraseRootFromParent_Done,
     /* 1546087 */   // Label 21473: @1546087
     /* 1546087 */   GIM_Try, /*On fail goto*//*Label 21474*/ GIMT_Encode4(1546169), // Rule ID 18845 //
     /* 1546092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1546112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546131 */     // MIs[0] round
     /* 1546131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546134 */     // MIs[0] policy
     /* 1546134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546144 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1546147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546168 */     // GIR_Coverage, 18845,
     /* 1546168 */     GIR_EraseRootFromParent_Done,
     /* 1546169 */   // Label 21474: @1546169
     /* 1546169 */   GIM_Try, /*On fail goto*//*Label 21475*/ GIMT_Encode4(1546251), // Rule ID 18848 //
     /* 1546174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1546185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1546188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1546194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546213 */     // MIs[0] round
     /* 1546213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546216 */     // MIs[0] policy
     /* 1546216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546226 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1546229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546250 */     // GIR_Coverage, 18848,
     /* 1546250 */     GIR_EraseRootFromParent_Done,
     /* 1546251 */   // Label 21475: @1546251
     /* 1546251 */   GIM_Try, /*On fail goto*//*Label 21476*/ GIMT_Encode4(1546333), // Rule ID 18849 //
     /* 1546256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1546267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1546270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1546276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546295 */     // MIs[0] round
     /* 1546295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546298 */     // MIs[0] policy
     /* 1546298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546308 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1546311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546332 */     // GIR_Coverage, 18849,
     /* 1546332 */     GIR_EraseRootFromParent_Done,
     /* 1546333 */   // Label 21476: @1546333
     /* 1546333 */   GIM_Try, /*On fail goto*//*Label 21477*/ GIMT_Encode4(1546415), // Rule ID 18852 //
     /* 1546338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1546349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1546352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1546358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546377 */     // MIs[0] round
     /* 1546377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546380 */     // MIs[0] policy
     /* 1546380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546390 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1546393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546414 */     // GIR_Coverage, 18852,
     /* 1546414 */     GIR_EraseRootFromParent_Done,
     /* 1546415 */   // Label 21477: @1546415
     /* 1546415 */   GIM_Try, /*On fail goto*//*Label 21478*/ GIMT_Encode4(1546497), // Rule ID 18853 //
     /* 1546420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1546431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1546434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1546440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546459 */     // MIs[0] round
     /* 1546459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546462 */     // MIs[0] policy
     /* 1546462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546472 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1546475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546496 */     // GIR_Coverage, 18853,
     /* 1546496 */     GIR_EraseRootFromParent_Done,
     /* 1546497 */   // Label 21478: @1546497
     /* 1546497 */   GIM_Try, /*On fail goto*//*Label 21479*/ GIMT_Encode4(1546579), // Rule ID 18856 //
     /* 1546502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1546513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1546516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1546522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546541 */     // MIs[0] round
     /* 1546541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546544 */     // MIs[0] policy
     /* 1546544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546554 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1546557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546578 */     // GIR_Coverage, 18856,
     /* 1546578 */     GIR_EraseRootFromParent_Done,
     /* 1546579 */   // Label 21479: @1546579
     /* 1546579 */   GIM_Try, /*On fail goto*//*Label 21480*/ GIMT_Encode4(1546661), // Rule ID 18857 //
     /* 1546584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1546595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1546598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1546604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546623 */     // MIs[0] round
     /* 1546623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546626 */     // MIs[0] policy
     /* 1546626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546636 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1546639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546660 */     // GIR_Coverage, 18857,
     /* 1546660 */     GIR_EraseRootFromParent_Done,
     /* 1546661 */   // Label 21480: @1546661
     /* 1546661 */   GIM_Try, /*On fail goto*//*Label 21481*/ GIMT_Encode4(1546743), // Rule ID 18860 //
     /* 1546666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1546677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1546680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1546683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1546686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546705 */     // MIs[0] round
     /* 1546705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546708 */     // MIs[0] policy
     /* 1546708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546718 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1546721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546742 */     // GIR_Coverage, 18860,
     /* 1546742 */     GIR_EraseRootFromParent_Done,
     /* 1546743 */   // Label 21481: @1546743
     /* 1546743 */   GIM_Try, /*On fail goto*//*Label 21482*/ GIMT_Encode4(1546825), // Rule ID 18861 //
     /* 1546748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1546759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1546762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1546765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1546768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546787 */     // MIs[0] round
     /* 1546787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546790 */     // MIs[0] policy
     /* 1546790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546800 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1546803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546824 */     // GIR_Coverage, 18861,
     /* 1546824 */     GIR_EraseRootFromParent_Done,
     /* 1546825 */   // Label 21482: @1546825
     /* 1546825 */   GIM_Try, /*On fail goto*//*Label 21483*/ GIMT_Encode4(1546907), // Rule ID 18864 //
     /* 1546830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1546841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1546844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1546847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1546850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546869 */     // MIs[0] round
     /* 1546869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546872 */     // MIs[0] policy
     /* 1546872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546882 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1546885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546906 */     // GIR_Coverage, 18864,
     /* 1546906 */     GIR_EraseRootFromParent_Done,
     /* 1546907 */   // Label 21483: @1546907
     /* 1546907 */   GIM_Try, /*On fail goto*//*Label 21484*/ GIMT_Encode4(1546989), // Rule ID 18865 //
     /* 1546912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1546923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1546926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1546929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1546932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546951 */     // MIs[0] round
     /* 1546951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546954 */     // MIs[0] policy
     /* 1546954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546964 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1546967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546988 */     // GIR_Coverage, 18865,
     /* 1546988 */     GIR_EraseRootFromParent_Done,
     /* 1546989 */   // Label 21484: @1546989
     /* 1546989 */   GIM_Try, /*On fail goto*//*Label 21485*/ GIMT_Encode4(1547071), // Rule ID 18868 //
     /* 1546994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1547005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1547008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1547011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1547014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547033 */     // MIs[0] round
     /* 1547033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547036 */     // MIs[0] policy
     /* 1547036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547046 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1547049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547070 */     // GIR_Coverage, 18868,
     /* 1547070 */     GIR_EraseRootFromParent_Done,
     /* 1547071 */   // Label 21485: @1547071
     /* 1547071 */   GIM_Try, /*On fail goto*//*Label 21486*/ GIMT_Encode4(1547153), // Rule ID 18869 //
     /* 1547076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1547087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1547090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1547093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1547096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547115 */     // MIs[0] round
     /* 1547115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547118 */     // MIs[0] policy
     /* 1547118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547128 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1547131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547139 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547152 */     // GIR_Coverage, 18869,
     /* 1547152 */     GIR_EraseRootFromParent_Done,
     /* 1547153 */   // Label 21486: @1547153
     /* 1547153 */   GIM_Try, /*On fail goto*//*Label 21487*/ GIMT_Encode4(1547235), // Rule ID 18872 //
     /* 1547158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1547169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1547172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1547175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1547178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547197 */     // MIs[0] round
     /* 1547197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547200 */     // MIs[0] policy
     /* 1547200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547210 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1547213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547234 */     // GIR_Coverage, 18872,
     /* 1547234 */     GIR_EraseRootFromParent_Done,
     /* 1547235 */   // Label 21487: @1547235
     /* 1547235 */   GIM_Try, /*On fail goto*//*Label 21488*/ GIMT_Encode4(1547317), // Rule ID 18873 //
     /* 1547240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1547251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1547254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1547257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1547260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547279 */     // MIs[0] round
     /* 1547279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547282 */     // MIs[0] policy
     /* 1547282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547292 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1547295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547316 */     // GIR_Coverage, 18873,
     /* 1547316 */     GIR_EraseRootFromParent_Done,
     /* 1547317 */   // Label 21488: @1547317
     /* 1547317 */   GIM_Try, /*On fail goto*//*Label 21489*/ GIMT_Encode4(1547399), // Rule ID 18876 //
     /* 1547322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1547333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1547336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1547339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1547342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547361 */     // MIs[0] round
     /* 1547361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547364 */     // MIs[0] policy
     /* 1547364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547374 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1547377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547398 */     // GIR_Coverage, 18876,
     /* 1547398 */     GIR_EraseRootFromParent_Done,
     /* 1547399 */   // Label 21489: @1547399
     /* 1547399 */   GIM_Try, /*On fail goto*//*Label 21490*/ GIMT_Encode4(1547481), // Rule ID 18877 //
     /* 1547404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1547415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1547418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1547421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1547424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547443 */     // MIs[0] round
     /* 1547443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547446 */     // MIs[0] policy
     /* 1547446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547456 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1547459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547480 */     // GIR_Coverage, 18877,
     /* 1547480 */     GIR_EraseRootFromParent_Done,
     /* 1547481 */   // Label 21490: @1547481
     /* 1547481 */   GIM_Try, /*On fail goto*//*Label 21491*/ GIMT_Encode4(1547563), // Rule ID 18880 //
     /* 1547486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1547497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1547500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1547503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1547506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547525 */     // MIs[0] round
     /* 1547525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547528 */     // MIs[0] policy
     /* 1547528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547538 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1547541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547562 */     // GIR_Coverage, 18880,
     /* 1547562 */     GIR_EraseRootFromParent_Done,
     /* 1547563 */   // Label 21491: @1547563
     /* 1547563 */   GIM_Try, /*On fail goto*//*Label 21492*/ GIMT_Encode4(1547645), // Rule ID 18881 //
     /* 1547568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1547571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1547579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1547582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1547585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1547588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547607 */     // MIs[0] round
     /* 1547607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547610 */     // MIs[0] policy
     /* 1547610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547620 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1547623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547644 */     // GIR_Coverage, 18881,
     /* 1547644 */     GIR_EraseRootFromParent_Done,
     /* 1547645 */   // Label 21492: @1547645
     /* 1547645 */   GIM_Try, /*On fail goto*//*Label 21493*/ GIMT_Encode4(1547727), // Rule ID 18884 //
     /* 1547650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1547661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1547664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1547667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1547670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547689 */     // MIs[0] round
     /* 1547689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547692 */     // MIs[0] policy
     /* 1547692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547702 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1547705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547726 */     // GIR_Coverage, 18884,
     /* 1547726 */     GIR_EraseRootFromParent_Done,
     /* 1547727 */   // Label 21493: @1547727
     /* 1547727 */   GIM_Try, /*On fail goto*//*Label 21494*/ GIMT_Encode4(1547809), // Rule ID 18885 //
     /* 1547732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1547735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1547743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1547746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1547749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1547752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547771 */     // MIs[0] round
     /* 1547771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547774 */     // MIs[0] policy
     /* 1547774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547784 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1547787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547808 */     // GIR_Coverage, 18885,
     /* 1547808 */     GIR_EraseRootFromParent_Done,
     /* 1547809 */   // Label 21494: @1547809
     /* 1547809 */   GIM_Try, /*On fail goto*//*Label 21495*/ GIMT_Encode4(1547891), // Rule ID 18888 //
     /* 1547814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1547825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1547828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1547831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1547834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547853 */     // MIs[0] round
     /* 1547853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547856 */     // MIs[0] policy
     /* 1547856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547866 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1547869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547890 */     // GIR_Coverage, 18888,
     /* 1547890 */     GIR_EraseRootFromParent_Done,
     /* 1547891 */   // Label 21495: @1547891
     /* 1547891 */   GIM_Try, /*On fail goto*//*Label 21496*/ GIMT_Encode4(1547973), // Rule ID 18889 //
     /* 1547896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1547899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1547907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1547910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1547913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1547916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547935 */     // MIs[0] round
     /* 1547935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547938 */     // MIs[0] policy
     /* 1547938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547948 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1547951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547972 */     // GIR_Coverage, 18889,
     /* 1547972 */     GIR_EraseRootFromParent_Done,
     /* 1547973 */   // Label 21496: @1547973
     /* 1547973 */   GIM_Try, /*On fail goto*//*Label 21497*/ GIMT_Encode4(1548055), // Rule ID 18892 //
     /* 1547978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1547989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1547992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1547995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1547998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548017 */     // MIs[0] round
     /* 1548017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548020 */     // MIs[0] policy
     /* 1548020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548030 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1548033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548054 */     // GIR_Coverage, 18892,
     /* 1548054 */     GIR_EraseRootFromParent_Done,
     /* 1548055 */   // Label 21497: @1548055
     /* 1548055 */   GIM_Try, /*On fail goto*//*Label 21498*/ GIMT_Encode4(1548137), // Rule ID 18893 //
     /* 1548060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1548071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1548074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1548077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1548080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548099 */     // MIs[0] round
     /* 1548099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548102 */     // MIs[0] policy
     /* 1548102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548112 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1548115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548136 */     // GIR_Coverage, 18893,
     /* 1548136 */     GIR_EraseRootFromParent_Done,
     /* 1548137 */   // Label 21498: @1548137
     /* 1548137 */   GIM_Try, /*On fail goto*//*Label 21499*/ GIMT_Encode4(1548219), // Rule ID 18896 //
     /* 1548142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1548162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548181 */     // MIs[0] round
     /* 1548181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548184 */     // MIs[0] policy
     /* 1548184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548194 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1548197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548218 */     // GIR_Coverage, 18896,
     /* 1548218 */     GIR_EraseRootFromParent_Done,
     /* 1548219 */   // Label 21499: @1548219
     /* 1548219 */   GIM_Try, /*On fail goto*//*Label 21500*/ GIMT_Encode4(1548301), // Rule ID 18897 //
     /* 1548224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1548244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548263 */     // MIs[0] round
     /* 1548263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548266 */     // MIs[0] policy
     /* 1548266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548276 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1548279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548300 */     // GIR_Coverage, 18897,
     /* 1548300 */     GIR_EraseRootFromParent_Done,
     /* 1548301 */   // Label 21500: @1548301
     /* 1548301 */   GIM_Try, /*On fail goto*//*Label 21501*/ GIMT_Encode4(1548383), // Rule ID 18900 //
     /* 1548306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1548317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1548320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1548326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548345 */     // MIs[0] round
     /* 1548345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548348 */     // MIs[0] policy
     /* 1548348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548358 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1548361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548382 */     // GIR_Coverage, 18900,
     /* 1548382 */     GIR_EraseRootFromParent_Done,
     /* 1548383 */   // Label 21501: @1548383
     /* 1548383 */   GIM_Try, /*On fail goto*//*Label 21502*/ GIMT_Encode4(1548465), // Rule ID 18901 //
     /* 1548388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1548399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1548402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1548408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548427 */     // MIs[0] round
     /* 1548427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548430 */     // MIs[0] policy
     /* 1548430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548440 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1548443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548464 */     // GIR_Coverage, 18901,
     /* 1548464 */     GIR_EraseRootFromParent_Done,
     /* 1548465 */   // Label 21502: @1548465
     /* 1548465 */   GIM_Try, /*On fail goto*//*Label 21503*/ GIMT_Encode4(1548547), // Rule ID 18904 //
     /* 1548470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1548481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1548484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1548490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548509 */     // MIs[0] round
     /* 1548509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548512 */     // MIs[0] policy
     /* 1548512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548522 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1548525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548546 */     // GIR_Coverage, 18904,
     /* 1548546 */     GIR_EraseRootFromParent_Done,
     /* 1548547 */   // Label 21503: @1548547
     /* 1548547 */   GIM_Try, /*On fail goto*//*Label 21504*/ GIMT_Encode4(1548629), // Rule ID 18905 //
     /* 1548552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1548563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1548566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1548572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548591 */     // MIs[0] round
     /* 1548591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548594 */     // MIs[0] policy
     /* 1548594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548604 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1548607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548628 */     // GIR_Coverage, 18905,
     /* 1548628 */     GIR_EraseRootFromParent_Done,
     /* 1548629 */   // Label 21504: @1548629
     /* 1548629 */   GIM_Try, /*On fail goto*//*Label 21505*/ GIMT_Encode4(1548711), // Rule ID 18908 //
     /* 1548634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1548645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1548648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1548654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548673 */     // MIs[0] round
     /* 1548673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548676 */     // MIs[0] policy
     /* 1548676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548686 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1548689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548710 */     // GIR_Coverage, 18908,
     /* 1548710 */     GIR_EraseRootFromParent_Done,
     /* 1548711 */   // Label 21505: @1548711
     /* 1548711 */   GIM_Try, /*On fail goto*//*Label 21506*/ GIMT_Encode4(1548793), // Rule ID 18909 //
     /* 1548716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1548727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1548730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1548736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548755 */     // MIs[0] round
     /* 1548755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548758 */     // MIs[0] policy
     /* 1548758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548768 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1548771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548792 */     // GIR_Coverage, 18909,
     /* 1548792 */     GIR_EraseRootFromParent_Done,
     /* 1548793 */   // Label 21506: @1548793
     /* 1548793 */   GIM_Try, /*On fail goto*//*Label 21507*/ GIMT_Encode4(1548875), // Rule ID 18912 //
     /* 1548798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1548809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1548812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1548818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548837 */     // MIs[0] round
     /* 1548837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548840 */     // MIs[0] policy
     /* 1548840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548850 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1548853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548874 */     // GIR_Coverage, 18912,
     /* 1548874 */     GIR_EraseRootFromParent_Done,
     /* 1548875 */   // Label 21507: @1548875
     /* 1548875 */   GIM_Try, /*On fail goto*//*Label 21508*/ GIMT_Encode4(1548957), // Rule ID 18913 //
     /* 1548880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1548891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1548894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1548900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548919 */     // MIs[0] round
     /* 1548919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548922 */     // MIs[0] policy
     /* 1548922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548932 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1548935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548956 */     // GIR_Coverage, 18913,
     /* 1548956 */     GIR_EraseRootFromParent_Done,
     /* 1548957 */   // Label 21508: @1548957
     /* 1548957 */   GIM_Try, /*On fail goto*//*Label 21509*/ GIMT_Encode4(1549039), // Rule ID 18916 //
     /* 1548962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1548973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1548976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1548979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1548982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1548997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549001 */     // MIs[0] round
     /* 1549001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549004 */     // MIs[0] policy
     /* 1549004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549014 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1549017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549038 */     // GIR_Coverage, 18916,
     /* 1549038 */     GIR_EraseRootFromParent_Done,
     /* 1549039 */   // Label 21509: @1549039
     /* 1549039 */   GIM_Try, /*On fail goto*//*Label 21510*/ GIMT_Encode4(1549121), // Rule ID 18917 //
     /* 1549044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1549064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549083 */     // MIs[0] round
     /* 1549083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549086 */     // MIs[0] policy
     /* 1549086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549096 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1549099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549120 */     // GIR_Coverage, 18917,
     /* 1549120 */     GIR_EraseRootFromParent_Done,
     /* 1549121 */   // Label 21510: @1549121
     /* 1549121 */   GIM_Try, /*On fail goto*//*Label 21511*/ GIMT_Encode4(1549203), // Rule ID 18920 //
     /* 1549126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1549137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1549140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1549146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549165 */     // MIs[0] round
     /* 1549165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549168 */     // MIs[0] policy
     /* 1549168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549178 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1549181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549202 */     // GIR_Coverage, 18920,
     /* 1549202 */     GIR_EraseRootFromParent_Done,
     /* 1549203 */   // Label 21511: @1549203
     /* 1549203 */   GIM_Try, /*On fail goto*//*Label 21512*/ GIMT_Encode4(1549285), // Rule ID 18921 //
     /* 1549208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1549219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1549222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1549228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549247 */     // MIs[0] round
     /* 1549247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549250 */     // MIs[0] policy
     /* 1549250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549260 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1549263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549284 */     // GIR_Coverage, 18921,
     /* 1549284 */     GIR_EraseRootFromParent_Done,
     /* 1549285 */   // Label 21512: @1549285
     /* 1549285 */   GIM_Try, /*On fail goto*//*Label 21513*/ GIMT_Encode4(1549367), // Rule ID 18924 //
     /* 1549290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1549301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1549304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1549310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549329 */     // MIs[0] round
     /* 1549329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549332 */     // MIs[0] policy
     /* 1549332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549342 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1549345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549366 */     // GIR_Coverage, 18924,
     /* 1549366 */     GIR_EraseRootFromParent_Done,
     /* 1549367 */   // Label 21513: @1549367
     /* 1549367 */   GIM_Try, /*On fail goto*//*Label 21514*/ GIMT_Encode4(1549449), // Rule ID 18925 //
     /* 1549372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1549383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1549386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1549392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549411 */     // MIs[0] round
     /* 1549411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549414 */     // MIs[0] policy
     /* 1549414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549424 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1549427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549448 */     // GIR_Coverage, 18925,
     /* 1549448 */     GIR_EraseRootFromParent_Done,
     /* 1549449 */   // Label 21514: @1549449
     /* 1549449 */   GIM_Try, /*On fail goto*//*Label 21515*/ GIMT_Encode4(1549531), // Rule ID 18928 //
     /* 1549454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1549465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1549468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1549474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549493 */     // MIs[0] round
     /* 1549493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549496 */     // MIs[0] policy
     /* 1549496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549506 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1549509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549530 */     // GIR_Coverage, 18928,
     /* 1549530 */     GIR_EraseRootFromParent_Done,
     /* 1549531 */   // Label 21515: @1549531
     /* 1549531 */   GIM_Try, /*On fail goto*//*Label 21516*/ GIMT_Encode4(1549613), // Rule ID 18929 //
     /* 1549536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1549547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1549550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1549556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549575 */     // MIs[0] round
     /* 1549575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549578 */     // MIs[0] policy
     /* 1549578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549588 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1549591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549612 */     // GIR_Coverage, 18929,
     /* 1549612 */     GIR_EraseRootFromParent_Done,
     /* 1549613 */   // Label 21516: @1549613
     /* 1549613 */   GIM_Try, /*On fail goto*//*Label 21517*/ GIMT_Encode4(1549695), // Rule ID 18932 //
     /* 1549618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1549629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1549632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1549635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1549638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549657 */     // MIs[0] round
     /* 1549657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549660 */     // MIs[0] policy
     /* 1549660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549670 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1549673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549694 */     // GIR_Coverage, 18932,
     /* 1549694 */     GIR_EraseRootFromParent_Done,
     /* 1549695 */   // Label 21517: @1549695
     /* 1549695 */   GIM_Try, /*On fail goto*//*Label 21518*/ GIMT_Encode4(1549777), // Rule ID 18933 //
     /* 1549700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1549711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1549714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1549717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1549720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549739 */     // MIs[0] round
     /* 1549739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549742 */     // MIs[0] policy
     /* 1549742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549752 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1549755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549776 */     // GIR_Coverage, 18933,
     /* 1549776 */     GIR_EraseRootFromParent_Done,
     /* 1549777 */   // Label 21518: @1549777
     /* 1549777 */   GIM_Try, /*On fail goto*//*Label 21519*/ GIMT_Encode4(1549859), // Rule ID 18936 //
     /* 1549782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1549793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1549796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1549799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1549802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549821 */     // MIs[0] round
     /* 1549821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549824 */     // MIs[0] policy
     /* 1549824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549834 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1549837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549858 */     // GIR_Coverage, 18936,
     /* 1549858 */     GIR_EraseRootFromParent_Done,
     /* 1549859 */   // Label 21519: @1549859
     /* 1549859 */   GIM_Try, /*On fail goto*//*Label 21520*/ GIMT_Encode4(1549941), // Rule ID 18937 //
     /* 1549864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1549875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1549878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1549881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1549884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549903 */     // MIs[0] round
     /* 1549903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549906 */     // MIs[0] policy
     /* 1549906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549916 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1549919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549940 */     // GIR_Coverage, 18937,
     /* 1549940 */     GIR_EraseRootFromParent_Done,
     /* 1549941 */   // Label 21520: @1549941
     /* 1549941 */   GIM_Try, /*On fail goto*//*Label 21521*/ GIMT_Encode4(1550023), // Rule ID 18940 //
     /* 1549946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1549957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1549960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1549963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1549966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549985 */     // MIs[0] round
     /* 1549985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549988 */     // MIs[0] policy
     /* 1549988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549998 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1550001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550022 */     // GIR_Coverage, 18940,
     /* 1550022 */     GIR_EraseRootFromParent_Done,
     /* 1550023 */   // Label 21521: @1550023
     /* 1550023 */   GIM_Try, /*On fail goto*//*Label 21522*/ GIMT_Encode4(1550105), // Rule ID 18941 //
     /* 1550028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1550039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1550042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1550045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1550048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550067 */     // MIs[0] round
     /* 1550067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550070 */     // MIs[0] policy
     /* 1550070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550080 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1550083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550104 */     // GIR_Coverage, 18941,
     /* 1550104 */     GIR_EraseRootFromParent_Done,
     /* 1550105 */   // Label 21522: @1550105
     /* 1550105 */   GIM_Try, /*On fail goto*//*Label 21523*/ GIMT_Encode4(1550187), // Rule ID 18944 //
     /* 1550110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1550121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1550124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1550127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1550130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550149 */     // MIs[0] round
     /* 1550149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550152 */     // MIs[0] policy
     /* 1550152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550162 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1550165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550186 */     // GIR_Coverage, 18944,
     /* 1550186 */     GIR_EraseRootFromParent_Done,
     /* 1550187 */   // Label 21523: @1550187
     /* 1550187 */   GIM_Try, /*On fail goto*//*Label 21524*/ GIMT_Encode4(1550269), // Rule ID 18945 //
     /* 1550192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1550203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1550206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1550209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1550212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550231 */     // MIs[0] round
     /* 1550231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550234 */     // MIs[0] policy
     /* 1550234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550244 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1550247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550268 */     // GIR_Coverage, 18945,
     /* 1550268 */     GIR_EraseRootFromParent_Done,
     /* 1550269 */   // Label 21524: @1550269
     /* 1550269 */   GIM_Try, /*On fail goto*//*Label 21525*/ GIMT_Encode4(1550351), // Rule ID 18948 //
     /* 1550274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1550285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1550288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1550291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1550294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550313 */     // MIs[0] round
     /* 1550313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550316 */     // MIs[0] policy
     /* 1550316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550326 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1550329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550350 */     // GIR_Coverage, 18948,
     /* 1550350 */     GIR_EraseRootFromParent_Done,
     /* 1550351 */   // Label 21525: @1550351
     /* 1550351 */   GIM_Try, /*On fail goto*//*Label 21526*/ GIMT_Encode4(1550433), // Rule ID 18949 //
     /* 1550356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1550367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1550370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1550373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1550376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550395 */     // MIs[0] round
     /* 1550395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550398 */     // MIs[0] policy
     /* 1550398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550408 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1550411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550432 */     // GIR_Coverage, 18949,
     /* 1550432 */     GIR_EraseRootFromParent_Done,
     /* 1550433 */   // Label 21526: @1550433
     /* 1550433 */   GIM_Try, /*On fail goto*//*Label 21527*/ GIMT_Encode4(1550515), // Rule ID 18952 //
     /* 1550438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1550449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1550452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1550455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1550458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550477 */     // MIs[0] round
     /* 1550477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550480 */     // MIs[0] policy
     /* 1550480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1550493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550514 */     // GIR_Coverage, 18952,
     /* 1550514 */     GIR_EraseRootFromParent_Done,
     /* 1550515 */   // Label 21527: @1550515
     /* 1550515 */   GIM_Try, /*On fail goto*//*Label 21528*/ GIMT_Encode4(1550597), // Rule ID 18953 //
     /* 1550520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1550531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1550534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1550537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1550540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550559 */     // MIs[0] round
     /* 1550559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550562 */     // MIs[0] policy
     /* 1550562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550572 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1550575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550596 */     // GIR_Coverage, 18953,
     /* 1550596 */     GIR_EraseRootFromParent_Done,
     /* 1550597 */   // Label 21528: @1550597
     /* 1550597 */   GIM_Try, /*On fail goto*//*Label 21529*/ GIMT_Encode4(1550679), // Rule ID 18956 //
     /* 1550602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1550613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1550616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1550619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1550622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550641 */     // MIs[0] round
     /* 1550641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550644 */     // MIs[0] policy
     /* 1550644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550654 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1550657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550678 */     // GIR_Coverage, 18956,
     /* 1550678 */     GIR_EraseRootFromParent_Done,
     /* 1550679 */   // Label 21529: @1550679
     /* 1550679 */   GIM_Try, /*On fail goto*//*Label 21530*/ GIMT_Encode4(1550761), // Rule ID 18957 //
     /* 1550684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1550695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1550698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1550701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1550704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550723 */     // MIs[0] round
     /* 1550723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550726 */     // MIs[0] policy
     /* 1550726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550736 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1550739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550760 */     // GIR_Coverage, 18957,
     /* 1550760 */     GIR_EraseRootFromParent_Done,
     /* 1550761 */   // Label 21530: @1550761
     /* 1550761 */   GIM_Try, /*On fail goto*//*Label 21531*/ GIMT_Encode4(1550843), // Rule ID 18960 //
     /* 1550766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1550777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1550780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1550783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1550786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550805 */     // MIs[0] round
     /* 1550805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550808 */     // MIs[0] policy
     /* 1550808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550818 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1550821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550842 */     // GIR_Coverage, 18960,
     /* 1550842 */     GIR_EraseRootFromParent_Done,
     /* 1550843 */   // Label 21531: @1550843
     /* 1550843 */   GIM_Try, /*On fail goto*//*Label 21532*/ GIMT_Encode4(1550925), // Rule ID 18961 //
     /* 1550848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1550859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1550862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1550865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1550868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550887 */     // MIs[0] round
     /* 1550887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550890 */     // MIs[0] policy
     /* 1550890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550900 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1550903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550924 */     // GIR_Coverage, 18961,
     /* 1550924 */     GIR_EraseRootFromParent_Done,
     /* 1550925 */   // Label 21532: @1550925
     /* 1550925 */   GIM_Try, /*On fail goto*//*Label 21533*/ GIMT_Encode4(1551007), // Rule ID 18964 //
     /* 1550930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1550941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1550944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1550947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1550950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550969 */     // MIs[0] round
     /* 1550969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550972 */     // MIs[0] policy
     /* 1550972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550982 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1550985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551006 */     // GIR_Coverage, 18964,
     /* 1551006 */     GIR_EraseRootFromParent_Done,
     /* 1551007 */   // Label 21533: @1551007
     /* 1551007 */   GIM_Try, /*On fail goto*//*Label 21534*/ GIMT_Encode4(1551089), // Rule ID 18965 //
     /* 1551012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1551023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1551026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1551029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1551032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551051 */     // MIs[0] round
     /* 1551051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551054 */     // MIs[0] policy
     /* 1551054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551064 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1551067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551088 */     // GIR_Coverage, 18965,
     /* 1551088 */     GIR_EraseRootFromParent_Done,
     /* 1551089 */   // Label 21534: @1551089
     /* 1551089 */   GIM_Try, /*On fail goto*//*Label 21535*/ GIMT_Encode4(1551171), // Rule ID 18968 //
     /* 1551094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1551105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1551108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1551114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551133 */     // MIs[0] round
     /* 1551133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551136 */     // MIs[0] policy
     /* 1551136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551146 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1551149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551170 */     // GIR_Coverage, 18968,
     /* 1551170 */     GIR_EraseRootFromParent_Done,
     /* 1551171 */   // Label 21535: @1551171
     /* 1551171 */   GIM_Try, /*On fail goto*//*Label 21536*/ GIMT_Encode4(1551253), // Rule ID 18969 //
     /* 1551176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1551187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1551190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1551196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551215 */     // MIs[0] round
     /* 1551215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551218 */     // MIs[0] policy
     /* 1551218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551228 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1551231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551252 */     // GIR_Coverage, 18969,
     /* 1551252 */     GIR_EraseRootFromParent_Done,
     /* 1551253 */   // Label 21536: @1551253
     /* 1551253 */   GIM_Try, /*On fail goto*//*Label 21537*/ GIMT_Encode4(1551335), // Rule ID 18972 //
     /* 1551258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1551269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1551272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1551278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551297 */     // MIs[0] round
     /* 1551297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551300 */     // MIs[0] policy
     /* 1551300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551310 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1551313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551334 */     // GIR_Coverage, 18972,
     /* 1551334 */     GIR_EraseRootFromParent_Done,
     /* 1551335 */   // Label 21537: @1551335
     /* 1551335 */   GIM_Try, /*On fail goto*//*Label 21538*/ GIMT_Encode4(1551417), // Rule ID 18973 //
     /* 1551340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1551351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1551354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1551360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551379 */     // MIs[0] round
     /* 1551379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551382 */     // MIs[0] policy
     /* 1551382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551392 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1551395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551416 */     // GIR_Coverage, 18973,
     /* 1551416 */     GIR_EraseRootFromParent_Done,
     /* 1551417 */   // Label 21538: @1551417
     /* 1551417 */   GIM_Try, /*On fail goto*//*Label 21539*/ GIMT_Encode4(1551499), // Rule ID 18976 //
     /* 1551422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1551433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1551436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1551442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551461 */     // MIs[0] round
     /* 1551461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551464 */     // MIs[0] policy
     /* 1551464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551474 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1551477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551498 */     // GIR_Coverage, 18976,
     /* 1551498 */     GIR_EraseRootFromParent_Done,
     /* 1551499 */   // Label 21539: @1551499
     /* 1551499 */   GIM_Try, /*On fail goto*//*Label 21540*/ GIMT_Encode4(1551581), // Rule ID 18977 //
     /* 1551504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1551515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1551518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1551524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551543 */     // MIs[0] round
     /* 1551543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551546 */     // MIs[0] policy
     /* 1551546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551556 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1551559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551580 */     // GIR_Coverage, 18977,
     /* 1551580 */     GIR_EraseRootFromParent_Done,
     /* 1551581 */   // Label 21540: @1551581
     /* 1551581 */   GIM_Try, /*On fail goto*//*Label 21541*/ GIMT_Encode4(1551663), // Rule ID 18980 //
     /* 1551586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1551597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1551600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1551606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551625 */     // MIs[0] round
     /* 1551625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551628 */     // MIs[0] policy
     /* 1551628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551638 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1551641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551662 */     // GIR_Coverage, 18980,
     /* 1551662 */     GIR_EraseRootFromParent_Done,
     /* 1551663 */   // Label 21541: @1551663
     /* 1551663 */   GIM_Try, /*On fail goto*//*Label 21542*/ GIMT_Encode4(1551745), // Rule ID 18981 //
     /* 1551668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1551679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1551682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1551688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551707 */     // MIs[0] round
     /* 1551707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551710 */     // MIs[0] policy
     /* 1551710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551720 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1551723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551744 */     // GIR_Coverage, 18981,
     /* 1551744 */     GIR_EraseRootFromParent_Done,
     /* 1551745 */   // Label 21542: @1551745
     /* 1551745 */   GIM_Try, /*On fail goto*//*Label 21543*/ GIMT_Encode4(1551827), // Rule ID 18984 //
     /* 1551750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1551761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1551764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1551770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551789 */     // MIs[0] round
     /* 1551789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551792 */     // MIs[0] policy
     /* 1551792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551802 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1551805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551826 */     // GIR_Coverage, 18984,
     /* 1551826 */     GIR_EraseRootFromParent_Done,
     /* 1551827 */   // Label 21543: @1551827
     /* 1551827 */   GIM_Try, /*On fail goto*//*Label 21544*/ GIMT_Encode4(1551909), // Rule ID 18985 //
     /* 1551832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1551843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1551846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1551852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551871 */     // MIs[0] round
     /* 1551871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551874 */     // MIs[0] policy
     /* 1551874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551884 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1551887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551908 */     // GIR_Coverage, 18985,
     /* 1551908 */     GIR_EraseRootFromParent_Done,
     /* 1551909 */   // Label 21544: @1551909
     /* 1551909 */   GIM_Try, /*On fail goto*//*Label 21545*/ GIMT_Encode4(1551991), // Rule ID 18988 //
     /* 1551914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1551917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1551925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1551928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1551931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1551934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1551949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551953 */     // MIs[0] round
     /* 1551953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551956 */     // MIs[0] policy
     /* 1551956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551966 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1551969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551990 */     // GIR_Coverage, 18988,
     /* 1551990 */     GIR_EraseRootFromParent_Done,
     /* 1551991 */   // Label 21545: @1551991
     /* 1551991 */   GIM_Try, /*On fail goto*//*Label 21546*/ GIMT_Encode4(1552073), // Rule ID 18989 //
     /* 1551996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1552007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1552010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1552016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552035 */     // MIs[0] round
     /* 1552035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552038 */     // MIs[0] policy
     /* 1552038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552048 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1552051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552072 */     // GIR_Coverage, 18989,
     /* 1552072 */     GIR_EraseRootFromParent_Done,
     /* 1552073 */   // Label 21546: @1552073
     /* 1552073 */   GIM_Try, /*On fail goto*//*Label 21547*/ GIMT_Encode4(1552155), // Rule ID 18992 //
     /* 1552078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1552098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552117 */     // MIs[0] round
     /* 1552117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552120 */     // MIs[0] policy
     /* 1552120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552130 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1552133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552154 */     // GIR_Coverage, 18992,
     /* 1552154 */     GIR_EraseRootFromParent_Done,
     /* 1552155 */   // Label 21547: @1552155
     /* 1552155 */   GIM_Try, /*On fail goto*//*Label 21548*/ GIMT_Encode4(1552237), // Rule ID 18993 //
     /* 1552160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1552180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552199 */     // MIs[0] round
     /* 1552199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552202 */     // MIs[0] policy
     /* 1552202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552212 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1552215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552236 */     // GIR_Coverage, 18993,
     /* 1552236 */     GIR_EraseRootFromParent_Done,
     /* 1552237 */   // Label 21548: @1552237
     /* 1552237 */   GIM_Try, /*On fail goto*//*Label 21549*/ GIMT_Encode4(1552319), // Rule ID 18996 //
     /* 1552242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1552262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552281 */     // MIs[0] round
     /* 1552281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552284 */     // MIs[0] policy
     /* 1552284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552294 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1552297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552318 */     // GIR_Coverage, 18996,
     /* 1552318 */     GIR_EraseRootFromParent_Done,
     /* 1552319 */   // Label 21549: @1552319
     /* 1552319 */   GIM_Try, /*On fail goto*//*Label 21550*/ GIMT_Encode4(1552401), // Rule ID 18997 //
     /* 1552324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1552344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552363 */     // MIs[0] round
     /* 1552363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552366 */     // MIs[0] policy
     /* 1552366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552376 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1552379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552400 */     // GIR_Coverage, 18997,
     /* 1552400 */     GIR_EraseRootFromParent_Done,
     /* 1552401 */   // Label 21550: @1552401
     /* 1552401 */   GIM_Try, /*On fail goto*//*Label 21551*/ GIMT_Encode4(1552483), // Rule ID 19000 //
     /* 1552406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1552426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552445 */     // MIs[0] round
     /* 1552445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552448 */     // MIs[0] policy
     /* 1552448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552458 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1552461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552482 */     // GIR_Coverage, 19000,
     /* 1552482 */     GIR_EraseRootFromParent_Done,
     /* 1552483 */   // Label 21551: @1552483
     /* 1552483 */   GIM_Try, /*On fail goto*//*Label 21552*/ GIMT_Encode4(1552565), // Rule ID 19001 //
     /* 1552488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1552508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552527 */     // MIs[0] round
     /* 1552527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552530 */     // MIs[0] policy
     /* 1552530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552540 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1552543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552564 */     // GIR_Coverage, 19001,
     /* 1552564 */     GIR_EraseRootFromParent_Done,
     /* 1552565 */   // Label 21552: @1552565
     /* 1552565 */   GIM_Try, /*On fail goto*//*Label 21553*/ GIMT_Encode4(1552647), // Rule ID 19006 //
     /* 1552570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1552573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1552581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1552584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1552587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1552590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552609 */     // MIs[0] round
     /* 1552609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552612 */     // MIs[0] policy
     /* 1552612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552622 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1552625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552646 */     // GIR_Coverage, 19006,
     /* 1552646 */     GIR_EraseRootFromParent_Done,
     /* 1552647 */   // Label 21553: @1552647
     /* 1552647 */   GIM_Try, /*On fail goto*//*Label 21554*/ GIMT_Encode4(1552729), // Rule ID 19007 //
     /* 1552652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1552655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1552663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1552666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1552669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1552672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552691 */     // MIs[0] round
     /* 1552691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552694 */     // MIs[0] policy
     /* 1552694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552704 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1552707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552728 */     // GIR_Coverage, 19007,
     /* 1552728 */     GIR_EraseRootFromParent_Done,
     /* 1552729 */   // Label 21554: @1552729
     /* 1552729 */   GIM_Try, /*On fail goto*//*Label 21555*/ GIMT_Encode4(1552811), // Rule ID 19010 //
     /* 1552734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1552737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1552745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1552748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1552751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1552754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552773 */     // MIs[0] round
     /* 1552773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552776 */     // MIs[0] policy
     /* 1552776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552786 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1552789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552795 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552810 */     // GIR_Coverage, 19010,
     /* 1552810 */     GIR_EraseRootFromParent_Done,
     /* 1552811 */   // Label 21555: @1552811
     /* 1552811 */   GIM_Try, /*On fail goto*//*Label 21556*/ GIMT_Encode4(1552893), // Rule ID 19011 //
     /* 1552816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1552819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1552827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1552830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1552833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1552836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552855 */     // MIs[0] round
     /* 1552855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552858 */     // MIs[0] policy
     /* 1552858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552868 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1552871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552892 */     // GIR_Coverage, 19011,
     /* 1552892 */     GIR_EraseRootFromParent_Done,
     /* 1552893 */   // Label 21556: @1552893
     /* 1552893 */   GIM_Try, /*On fail goto*//*Label 21557*/ GIMT_Encode4(1552975), // Rule ID 19014 //
     /* 1552898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1552901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1552909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1552912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1552915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1552918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552937 */     // MIs[0] round
     /* 1552937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552940 */     // MIs[0] policy
     /* 1552940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552950 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1552953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552974 */     // GIR_Coverage, 19014,
     /* 1552974 */     GIR_EraseRootFromParent_Done,
     /* 1552975 */   // Label 21557: @1552975
     /* 1552975 */   GIM_Try, /*On fail goto*//*Label 21558*/ GIMT_Encode4(1553057), // Rule ID 19015 //
     /* 1552980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1552983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1552991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1552994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1552997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1553000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553019 */     // MIs[0] round
     /* 1553019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553022 */     // MIs[0] policy
     /* 1553022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553032 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1553035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553056 */     // GIR_Coverage, 19015,
     /* 1553056 */     GIR_EraseRootFromParent_Done,
     /* 1553057 */   // Label 21558: @1553057
     /* 1553057 */   GIM_Try, /*On fail goto*//*Label 21559*/ GIMT_Encode4(1553139), // Rule ID 19018 //
     /* 1553062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1553065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1553079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553101 */     // MIs[0] round
     /* 1553101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553104 */     // MIs[0] policy
     /* 1553104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553114 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1553117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553138 */     // GIR_Coverage, 19018,
     /* 1553138 */     GIR_EraseRootFromParent_Done,
     /* 1553139 */   // Label 21559: @1553139
     /* 1553139 */   GIM_Try, /*On fail goto*//*Label 21560*/ GIMT_Encode4(1553221), // Rule ID 19019 //
     /* 1553144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1553147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1553161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553183 */     // MIs[0] round
     /* 1553183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553186 */     // MIs[0] policy
     /* 1553186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553196 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1553199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553220 */     // GIR_Coverage, 19019,
     /* 1553220 */     GIR_EraseRootFromParent_Done,
     /* 1553221 */   // Label 21560: @1553221
     /* 1553221 */   GIM_Try, /*On fail goto*//*Label 21561*/ GIMT_Encode4(1553303), // Rule ID 19022 //
     /* 1553226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1553229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1553237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1553240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1553243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553265 */     // MIs[0] round
     /* 1553265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553268 */     // MIs[0] policy
     /* 1553268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553278 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1553281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1553299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553302 */     // GIR_Coverage, 19022,
     /* 1553302 */     GIR_EraseRootFromParent_Done,
     /* 1553303 */   // Label 21561: @1553303
     /* 1553303 */   GIM_Try, /*On fail goto*//*Label 21562*/ GIMT_Encode4(1553385), // Rule ID 19023 //
     /* 1553308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1553311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1553319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1553322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1553325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553347 */     // MIs[0] round
     /* 1553347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553350 */     // MIs[0] policy
     /* 1553350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553360 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1553363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1553381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553384 */     // GIR_Coverage, 19023,
     /* 1553384 */     GIR_EraseRootFromParent_Done,
     /* 1553385 */   // Label 21562: @1553385
     /* 1553385 */   GIM_Try, /*On fail goto*//*Label 21563*/ GIMT_Encode4(1553467), // Rule ID 19026 //
     /* 1553390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1553401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1553404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1553407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1553410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553429 */     // MIs[0] round
     /* 1553429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553432 */     // MIs[0] policy
     /* 1553432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553442 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1553445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553466 */     // GIR_Coverage, 19026,
     /* 1553466 */     GIR_EraseRootFromParent_Done,
     /* 1553467 */   // Label 21563: @1553467
     /* 1553467 */   GIM_Try, /*On fail goto*//*Label 21564*/ GIMT_Encode4(1553549), // Rule ID 19027 //
     /* 1553472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1553483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1553486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1553489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1553492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553511 */     // MIs[0] round
     /* 1553511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553514 */     // MIs[0] policy
     /* 1553514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553524 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1553527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553548 */     // GIR_Coverage, 19027,
     /* 1553548 */     GIR_EraseRootFromParent_Done,
     /* 1553549 */   // Label 21564: @1553549
     /* 1553549 */   GIM_Try, /*On fail goto*//*Label 21565*/ GIMT_Encode4(1553631), // Rule ID 19030 //
     /* 1553554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1553565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1553568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1553571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1553574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1553581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553593 */     // MIs[0] round
     /* 1553593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553596 */     // MIs[0] policy
     /* 1553596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553606 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1553609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553630 */     // GIR_Coverage, 19030,
     /* 1553630 */     GIR_EraseRootFromParent_Done,
     /* 1553631 */   // Label 21565: @1553631
     /* 1553631 */   GIM_Try, /*On fail goto*//*Label 21566*/ GIMT_Encode4(1553713), // Rule ID 19031 //
     /* 1553636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1553647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1553650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1553653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1553656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1553663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553675 */     // MIs[0] round
     /* 1553675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553678 */     // MIs[0] policy
     /* 1553678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553688 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1553691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553712 */     // GIR_Coverage, 19031,
     /* 1553712 */     GIR_EraseRootFromParent_Done,
     /* 1553713 */   // Label 21566: @1553713
     /* 1553713 */   GIM_Try, /*On fail goto*//*Label 21567*/ GIMT_Encode4(1553795), // Rule ID 19034 //
     /* 1553718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1553729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1553732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1553735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1553738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1553745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553757 */     // MIs[0] round
     /* 1553757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553760 */     // MIs[0] policy
     /* 1553760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553770 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1553773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553794 */     // GIR_Coverage, 19034,
     /* 1553794 */     GIR_EraseRootFromParent_Done,
     /* 1553795 */   // Label 21567: @1553795
     /* 1553795 */   GIM_Try, /*On fail goto*//*Label 21568*/ GIMT_Encode4(1553877), // Rule ID 19035 //
     /* 1553800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1553811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1553814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1553817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1553820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1553827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553839 */     // MIs[0] round
     /* 1553839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553842 */     // MIs[0] policy
     /* 1553842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553852 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1553855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553876 */     // GIR_Coverage, 19035,
     /* 1553876 */     GIR_EraseRootFromParent_Done,
     /* 1553877 */   // Label 21568: @1553877
     /* 1553877 */   GIM_Try, /*On fail goto*//*Label 21569*/ GIMT_Encode4(1553959), // Rule ID 19038 //
     /* 1553882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1553885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1553893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1553896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1553899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1553902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553921 */     // MIs[0] round
     /* 1553921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553924 */     // MIs[0] policy
     /* 1553924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553934 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1553937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553958 */     // GIR_Coverage, 19038,
     /* 1553958 */     GIR_EraseRootFromParent_Done,
     /* 1553959 */   // Label 21569: @1553959
     /* 1553959 */   GIM_Try, /*On fail goto*//*Label 21570*/ GIMT_Encode4(1554041), // Rule ID 19039 //
     /* 1553964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1553967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1553975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1553978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1553981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1553984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554003 */     // MIs[0] round
     /* 1554003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554006 */     // MIs[0] policy
     /* 1554006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554016 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1554019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554040 */     // GIR_Coverage, 19039,
     /* 1554040 */     GIR_EraseRootFromParent_Done,
     /* 1554041 */   // Label 21570: @1554041
     /* 1554041 */   GIM_Try, /*On fail goto*//*Label 21571*/ GIMT_Encode4(1554123), // Rule ID 19042 //
     /* 1554046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1554049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1554057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1554060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554085 */     // MIs[0] round
     /* 1554085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554088 */     // MIs[0] policy
     /* 1554088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554098 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1554101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554122 */     // GIR_Coverage, 19042,
     /* 1554122 */     GIR_EraseRootFromParent_Done,
     /* 1554123 */   // Label 21571: @1554123
     /* 1554123 */   GIM_Try, /*On fail goto*//*Label 21572*/ GIMT_Encode4(1554205), // Rule ID 19043 //
     /* 1554128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1554131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1554139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1554142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554167 */     // MIs[0] round
     /* 1554167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554170 */     // MIs[0] policy
     /* 1554170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554180 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1554183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554204 */     // GIR_Coverage, 19043,
     /* 1554204 */     GIR_EraseRootFromParent_Done,
     /* 1554205 */   // Label 21572: @1554205
     /* 1554205 */   GIM_Try, /*On fail goto*//*Label 21573*/ GIMT_Encode4(1554287), // Rule ID 19046 //
     /* 1554210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1554213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1554227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554249 */     // MIs[0] round
     /* 1554249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554252 */     // MIs[0] policy
     /* 1554252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554262 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1554265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554271 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554286 */     // GIR_Coverage, 19046,
     /* 1554286 */     GIR_EraseRootFromParent_Done,
     /* 1554287 */   // Label 21573: @1554287
     /* 1554287 */   GIM_Try, /*On fail goto*//*Label 21574*/ GIMT_Encode4(1554369), // Rule ID 19047 //
     /* 1554292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1554295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1554309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554331 */     // MIs[0] round
     /* 1554331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554334 */     // MIs[0] policy
     /* 1554334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554344 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1554347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554368 */     // GIR_Coverage, 19047,
     /* 1554368 */     GIR_EraseRootFromParent_Done,
     /* 1554369 */   // Label 21574: @1554369
     /* 1554369 */   GIM_Try, /*On fail goto*//*Label 21575*/ GIMT_Encode4(1554451), // Rule ID 19050 //
     /* 1554374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1554377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1554385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1554388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1554391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1554394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554413 */     // MIs[0] round
     /* 1554413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554416 */     // MIs[0] policy
     /* 1554416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554426 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1554429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554450 */     // GIR_Coverage, 19050,
     /* 1554450 */     GIR_EraseRootFromParent_Done,
     /* 1554451 */   // Label 21575: @1554451
     /* 1554451 */   GIM_Try, /*On fail goto*//*Label 21576*/ GIMT_Encode4(1554533), // Rule ID 19051 //
     /* 1554456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1554459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1554467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1554470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1554473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1554476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554495 */     // MIs[0] round
     /* 1554495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554498 */     // MIs[0] policy
     /* 1554498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554508 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1554511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554532 */     // GIR_Coverage, 19051,
     /* 1554532 */     GIR_EraseRootFromParent_Done,
     /* 1554533 */   // Label 21576: @1554533
     /* 1554533 */   GIM_Try, /*On fail goto*//*Label 21577*/ GIMT_Encode4(1554615), // Rule ID 19054 //
     /* 1554538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1554541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1554549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1554552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1554555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554577 */     // MIs[0] round
     /* 1554577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554580 */     // MIs[0] policy
     /* 1554580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554590 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1554593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554614 */     // GIR_Coverage, 19054,
     /* 1554614 */     GIR_EraseRootFromParent_Done,
     /* 1554615 */   // Label 21577: @1554615
     /* 1554615 */   GIM_Try, /*On fail goto*//*Label 21578*/ GIMT_Encode4(1554697), // Rule ID 19055 //
     /* 1554620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1554623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1554631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1554634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1554637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554659 */     // MIs[0] round
     /* 1554659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554662 */     // MIs[0] policy
     /* 1554662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554672 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1554675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554696 */     // GIR_Coverage, 19055,
     /* 1554696 */     GIR_EraseRootFromParent_Done,
     /* 1554697 */   // Label 21578: @1554697
     /* 1554697 */   GIM_Try, /*On fail goto*//*Label 21579*/ GIMT_Encode4(1554779), // Rule ID 19058 //
     /* 1554702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1554705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1554713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1554716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1554719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554741 */     // MIs[0] round
     /* 1554741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554744 */     // MIs[0] policy
     /* 1554744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554754 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1554757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554778 */     // GIR_Coverage, 19058,
     /* 1554778 */     GIR_EraseRootFromParent_Done,
     /* 1554779 */   // Label 21579: @1554779
     /* 1554779 */   GIM_Try, /*On fail goto*//*Label 21580*/ GIMT_Encode4(1554861), // Rule ID 19059 //
     /* 1554784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1554787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1554795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1554798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1554801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554823 */     // MIs[0] round
     /* 1554823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554826 */     // MIs[0] policy
     /* 1554826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554836 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1554839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554860 */     // GIR_Coverage, 19059,
     /* 1554860 */     GIR_EraseRootFromParent_Done,
     /* 1554861 */   // Label 21580: @1554861
     /* 1554861 */   GIM_Try, /*On fail goto*//*Label 21581*/ GIMT_Encode4(1554943), // Rule ID 19118 //
     /* 1554866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1554869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1554877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1554880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1554883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1554886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1554893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554905 */     // MIs[0] round
     /* 1554905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554908 */     // MIs[0] policy
     /* 1554908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554918 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1554921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554942 */     // GIR_Coverage, 19118,
     /* 1554942 */     GIR_EraseRootFromParent_Done,
     /* 1554943 */   // Label 21581: @1554943
     /* 1554943 */   GIM_Try, /*On fail goto*//*Label 21582*/ GIMT_Encode4(1555025), // Rule ID 19119 //
     /* 1554948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1554951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1554959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1554962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1554965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1554968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1554975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554987 */     // MIs[0] round
     /* 1554987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554990 */     // MIs[0] policy
     /* 1554990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555000 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1555003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555024 */     // GIR_Coverage, 19119,
     /* 1555024 */     GIR_EraseRootFromParent_Done,
     /* 1555025 */   // Label 21582: @1555025
     /* 1555025 */   GIM_Try, /*On fail goto*//*Label 21583*/ GIMT_Encode4(1555107), // Rule ID 19122 //
     /* 1555030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1555033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1555041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1555044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1555047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555069 */     // MIs[0] round
     /* 1555069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555072 */     // MIs[0] policy
     /* 1555072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555082 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1555085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555106 */     // GIR_Coverage, 19122,
     /* 1555106 */     GIR_EraseRootFromParent_Done,
     /* 1555107 */   // Label 21583: @1555107
     /* 1555107 */   GIM_Try, /*On fail goto*//*Label 21584*/ GIMT_Encode4(1555189), // Rule ID 19123 //
     /* 1555112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1555115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1555123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1555126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1555129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555151 */     // MIs[0] round
     /* 1555151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555154 */     // MIs[0] policy
     /* 1555154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555164 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1555167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555188 */     // GIR_Coverage, 19123,
     /* 1555188 */     GIR_EraseRootFromParent_Done,
     /* 1555189 */   // Label 21584: @1555189
     /* 1555189 */   GIM_Try, /*On fail goto*//*Label 21585*/ GIMT_Encode4(1555271), // Rule ID 19126 //
     /* 1555194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1555197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1555205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1555208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1555211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555233 */     // MIs[0] round
     /* 1555233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555236 */     // MIs[0] policy
     /* 1555236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555246 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1555249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555270 */     // GIR_Coverage, 19126,
     /* 1555270 */     GIR_EraseRootFromParent_Done,
     /* 1555271 */   // Label 21585: @1555271
     /* 1555271 */   GIM_Try, /*On fail goto*//*Label 21586*/ GIMT_Encode4(1555353), // Rule ID 19127 //
     /* 1555276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1555279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1555287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1555290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1555293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555315 */     // MIs[0] round
     /* 1555315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555318 */     // MIs[0] policy
     /* 1555318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555328 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1555331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555352 */     // GIR_Coverage, 19127,
     /* 1555352 */     GIR_EraseRootFromParent_Done,
     /* 1555353 */   // Label 21586: @1555353
     /* 1555353 */   GIM_Try, /*On fail goto*//*Label 21587*/ GIMT_Encode4(1555435), // Rule ID 19130 //
     /* 1555358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1555361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1555369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1555372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1555375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555397 */     // MIs[0] round
     /* 1555397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555400 */     // MIs[0] policy
     /* 1555400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555410 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1555413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555419 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555434 */     // GIR_Coverage, 19130,
     /* 1555434 */     GIR_EraseRootFromParent_Done,
     /* 1555435 */   // Label 21587: @1555435
     /* 1555435 */   GIM_Try, /*On fail goto*//*Label 21588*/ GIMT_Encode4(1555517), // Rule ID 19131 //
     /* 1555440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1555443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1555451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1555454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1555457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555479 */     // MIs[0] round
     /* 1555479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555482 */     // MIs[0] policy
     /* 1555482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555492 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1555495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555501 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555516 */     // GIR_Coverage, 19131,
     /* 1555516 */     GIR_EraseRootFromParent_Done,
     /* 1555517 */   // Label 21588: @1555517
     /* 1555517 */   GIM_Try, /*On fail goto*//*Label 21589*/ GIMT_Encode4(1555599), // Rule ID 19134 //
     /* 1555522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1555525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1555533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1555536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1555539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555561 */     // MIs[0] round
     /* 1555561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555564 */     // MIs[0] policy
     /* 1555564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555574 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1555577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555598 */     // GIR_Coverage, 19134,
     /* 1555598 */     GIR_EraseRootFromParent_Done,
     /* 1555599 */   // Label 21589: @1555599
     /* 1555599 */   GIM_Try, /*On fail goto*//*Label 21590*/ GIMT_Encode4(1555681), // Rule ID 19135 //
     /* 1555604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1555607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1555615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1555618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1555621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555643 */     // MIs[0] round
     /* 1555643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555646 */     // MIs[0] policy
     /* 1555646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555656 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1555659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555680 */     // GIR_Coverage, 19135,
     /* 1555680 */     GIR_EraseRootFromParent_Done,
     /* 1555681 */   // Label 21590: @1555681
     /* 1555681 */   GIM_Try, /*On fail goto*//*Label 21591*/ GIMT_Encode4(1555763), // Rule ID 19138 //
     /* 1555686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1555689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1555697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1555700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1555703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555725 */     // MIs[0] round
     /* 1555725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555728 */     // MIs[0] policy
     /* 1555728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555738 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1555741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555762 */     // GIR_Coverage, 19138,
     /* 1555762 */     GIR_EraseRootFromParent_Done,
     /* 1555763 */   // Label 21591: @1555763
     /* 1555763 */   GIM_Try, /*On fail goto*//*Label 21592*/ GIMT_Encode4(1555845), // Rule ID 19139 //
     /* 1555768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1555771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1555779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1555782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1555785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555807 */     // MIs[0] round
     /* 1555807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555810 */     // MIs[0] policy
     /* 1555810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555820 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1555823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555844 */     // GIR_Coverage, 19139,
     /* 1555844 */     GIR_EraseRootFromParent_Done,
     /* 1555845 */   // Label 21592: @1555845
     /* 1555845 */   GIM_Try, /*On fail goto*//*Label 21593*/ GIMT_Encode4(1555927), // Rule ID 19142 //
     /* 1555850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1555853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1555861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1555864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1555867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1555870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1555877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555889 */     // MIs[0] round
     /* 1555889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555892 */     // MIs[0] policy
     /* 1555892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555902 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1555905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555926 */     // GIR_Coverage, 19142,
     /* 1555926 */     GIR_EraseRootFromParent_Done,
     /* 1555927 */   // Label 21593: @1555927
     /* 1555927 */   GIM_Try, /*On fail goto*//*Label 21594*/ GIMT_Encode4(1556009), // Rule ID 19143 //
     /* 1555932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1555935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1555943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1555946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1555949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1555952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1555959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555971 */     // MIs[0] round
     /* 1555971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555974 */     // MIs[0] policy
     /* 1555974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555984 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1555987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556008 */     // GIR_Coverage, 19143,
     /* 1556008 */     GIR_EraseRootFromParent_Done,
     /* 1556009 */   // Label 21594: @1556009
     /* 1556009 */   GIM_Try, /*On fail goto*//*Label 21595*/ GIMT_Encode4(1556091), // Rule ID 19146 //
     /* 1556014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1556017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1556025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1556028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1556031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556053 */     // MIs[0] round
     /* 1556053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556056 */     // MIs[0] policy
     /* 1556056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556066 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1556069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556090 */     // GIR_Coverage, 19146,
     /* 1556090 */     GIR_EraseRootFromParent_Done,
     /* 1556091 */   // Label 21595: @1556091
     /* 1556091 */   GIM_Try, /*On fail goto*//*Label 21596*/ GIMT_Encode4(1556173), // Rule ID 19147 //
     /* 1556096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1556099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1556107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1556110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1556113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556135 */     // MIs[0] round
     /* 1556135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556138 */     // MIs[0] policy
     /* 1556138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556148 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1556151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556172 */     // GIR_Coverage, 19147,
     /* 1556172 */     GIR_EraseRootFromParent_Done,
     /* 1556173 */   // Label 21596: @1556173
     /* 1556173 */   GIM_Try, /*On fail goto*//*Label 21597*/ GIMT_Encode4(1556255), // Rule ID 19150 //
     /* 1556178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1556181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1556189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1556192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1556195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1556198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556217 */     // MIs[0] round
     /* 1556217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556220 */     // MIs[0] policy
     /* 1556220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556230 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1556233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556254 */     // GIR_Coverage, 19150,
     /* 1556254 */     GIR_EraseRootFromParent_Done,
     /* 1556255 */   // Label 21597: @1556255
     /* 1556255 */   GIM_Try, /*On fail goto*//*Label 21598*/ GIMT_Encode4(1556337), // Rule ID 19151 //
     /* 1556260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1556263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1556271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1556274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1556277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1556280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556299 */     // MIs[0] round
     /* 1556299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556302 */     // MIs[0] policy
     /* 1556302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556312 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1556315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556336 */     // GIR_Coverage, 19151,
     /* 1556336 */     GIR_EraseRootFromParent_Done,
     /* 1556337 */   // Label 21598: @1556337
     /* 1556337 */   GIM_Try, /*On fail goto*//*Label 21599*/ GIMT_Encode4(1556419), // Rule ID 19154 //
     /* 1556342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1556345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1556353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1556356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1556359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556381 */     // MIs[0] round
     /* 1556381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556384 */     // MIs[0] policy
     /* 1556384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556394 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1556397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556418 */     // GIR_Coverage, 19154,
     /* 1556418 */     GIR_EraseRootFromParent_Done,
     /* 1556419 */   // Label 21599: @1556419
     /* 1556419 */   GIM_Try, /*On fail goto*//*Label 21600*/ GIMT_Encode4(1556501), // Rule ID 19155 //
     /* 1556424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1556427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1556435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1556438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1556441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556463 */     // MIs[0] round
     /* 1556463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556466 */     // MIs[0] policy
     /* 1556466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556476 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1556479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556500 */     // GIR_Coverage, 19155,
     /* 1556500 */     GIR_EraseRootFromParent_Done,
     /* 1556501 */   // Label 21600: @1556501
     /* 1556501 */   GIM_Try, /*On fail goto*//*Label 21601*/ GIMT_Encode4(1556583), // Rule ID 19158 //
     /* 1556506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1556509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1556517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1556520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1556523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556545 */     // MIs[0] round
     /* 1556545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556548 */     // MIs[0] policy
     /* 1556548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556558 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1556561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556582 */     // GIR_Coverage, 19158,
     /* 1556582 */     GIR_EraseRootFromParent_Done,
     /* 1556583 */   // Label 21601: @1556583
     /* 1556583 */   GIM_Try, /*On fail goto*//*Label 21602*/ GIMT_Encode4(1556665), // Rule ID 19159 //
     /* 1556588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1556591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1556599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1556602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1556605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556627 */     // MIs[0] round
     /* 1556627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556630 */     // MIs[0] policy
     /* 1556630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556640 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1556643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556664 */     // GIR_Coverage, 19159,
     /* 1556664 */     GIR_EraseRootFromParent_Done,
     /* 1556665 */   // Label 21602: @1556665
     /* 1556665 */   GIM_Try, /*On fail goto*//*Label 21603*/ GIMT_Encode4(1556747), // Rule ID 19162 //
     /* 1556670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1556673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1556681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1556684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1556687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556709 */     // MIs[0] round
     /* 1556709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556712 */     // MIs[0] policy
     /* 1556712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556722 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1556725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556731 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556746 */     // GIR_Coverage, 19162,
     /* 1556746 */     GIR_EraseRootFromParent_Done,
     /* 1556747 */   // Label 21603: @1556747
     /* 1556747 */   GIM_Try, /*On fail goto*//*Label 21604*/ GIMT_Encode4(1556829), // Rule ID 19163 //
     /* 1556752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1556755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1556763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1556766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1556769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556791 */     // MIs[0] round
     /* 1556791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556794 */     // MIs[0] policy
     /* 1556794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556804 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1556807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556813 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556828 */     // GIR_Coverage, 19163,
     /* 1556828 */     GIR_EraseRootFromParent_Done,
     /* 1556829 */   // Label 21604: @1556829
     /* 1556829 */   GIM_Try, /*On fail goto*//*Label 21605*/ GIMT_Encode4(1556911), // Rule ID 19166 //
     /* 1556834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1556837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1556845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1556848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1556851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556873 */     // MIs[0] round
     /* 1556873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556876 */     // MIs[0] policy
     /* 1556876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556886 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1556889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556910 */     // GIR_Coverage, 19166,
     /* 1556910 */     GIR_EraseRootFromParent_Done,
     /* 1556911 */   // Label 21605: @1556911
     /* 1556911 */   GIM_Try, /*On fail goto*//*Label 21606*/ GIMT_Encode4(1556993), // Rule ID 19167 //
     /* 1556916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1556919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1556927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1556930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1556933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556955 */     // MIs[0] round
     /* 1556955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556958 */     // MIs[0] policy
     /* 1556958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556968 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1556971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556992 */     // GIR_Coverage, 19167,
     /* 1556992 */     GIR_EraseRootFromParent_Done,
     /* 1556993 */   // Label 21606: @1556993
     /* 1556993 */   GIM_Try, /*On fail goto*//*Label 21607*/ GIMT_Encode4(1557075), // Rule ID 19170 //
     /* 1556998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1557001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1557009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1557012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1557015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557037 */     // MIs[0] round
     /* 1557037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557040 */     // MIs[0] policy
     /* 1557040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557050 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1557053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557074 */     // GIR_Coverage, 19170,
     /* 1557074 */     GIR_EraseRootFromParent_Done,
     /* 1557075 */   // Label 21607: @1557075
     /* 1557075 */   GIM_Try, /*On fail goto*//*Label 21608*/ GIMT_Encode4(1557157), // Rule ID 19171 //
     /* 1557080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1557083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1557091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1557094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1557097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557119 */     // MIs[0] round
     /* 1557119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557122 */     // MIs[0] policy
     /* 1557122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557132 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1557135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557156 */     // GIR_Coverage, 19171,
     /* 1557156 */     GIR_EraseRootFromParent_Done,
     /* 1557157 */   // Label 21608: @1557157
     /* 1557157 */   GIM_Try, /*On fail goto*//*Label 21609*/ GIMT_Encode4(1557239), // Rule ID 19174 //
     /* 1557162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1557165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1557173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1557176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1557179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557201 */     // MIs[0] round
     /* 1557201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557204 */     // MIs[0] policy
     /* 1557204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557214 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1557217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557238 */     // GIR_Coverage, 19174,
     /* 1557238 */     GIR_EraseRootFromParent_Done,
     /* 1557239 */   // Label 21609: @1557239
     /* 1557239 */   GIM_Try, /*On fail goto*//*Label 21610*/ GIMT_Encode4(1557321), // Rule ID 19175 //
     /* 1557244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1557247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1557255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1557258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1557261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557283 */     // MIs[0] round
     /* 1557283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557286 */     // MIs[0] policy
     /* 1557286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557296 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1557299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557320 */     // GIR_Coverage, 19175,
     /* 1557320 */     GIR_EraseRootFromParent_Done,
     /* 1557321 */   // Label 21610: @1557321
     /* 1557321 */   GIM_Try, /*On fail goto*//*Label 21611*/ GIMT_Encode4(1557403), // Rule ID 20760 //
     /* 1557326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1557329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1557337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1557340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1557343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557365 */     // MIs[0] round
     /* 1557365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557368 */     // MIs[0] policy
     /* 1557368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557378 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1557381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557402 */     // GIR_Coverage, 20760,
     /* 1557402 */     GIR_EraseRootFromParent_Done,
     /* 1557403 */   // Label 21611: @1557403
     /* 1557403 */   GIM_Try, /*On fail goto*//*Label 21612*/ GIMT_Encode4(1557485), // Rule ID 20761 //
     /* 1557408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1557411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1557419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1557422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1557425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557447 */     // MIs[0] round
     /* 1557447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557450 */     // MIs[0] policy
     /* 1557450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557460 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1557463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557484 */     // GIR_Coverage, 20761,
     /* 1557484 */     GIR_EraseRootFromParent_Done,
     /* 1557485 */   // Label 21612: @1557485
     /* 1557485 */   GIM_Try, /*On fail goto*//*Label 21613*/ GIMT_Encode4(1557567), // Rule ID 20764 //
     /* 1557490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1557493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1557501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1557504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1557507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557529 */     // MIs[0] round
     /* 1557529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557532 */     // MIs[0] policy
     /* 1557532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557542 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1557545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557566 */     // GIR_Coverage, 20764,
     /* 1557566 */     GIR_EraseRootFromParent_Done,
     /* 1557567 */   // Label 21613: @1557567
     /* 1557567 */   GIM_Try, /*On fail goto*//*Label 21614*/ GIMT_Encode4(1557649), // Rule ID 20765 //
     /* 1557572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1557575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1557583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1557586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1557589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557611 */     // MIs[0] round
     /* 1557611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557614 */     // MIs[0] policy
     /* 1557614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557624 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1557627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557648 */     // GIR_Coverage, 20765,
     /* 1557648 */     GIR_EraseRootFromParent_Done,
     /* 1557649 */   // Label 21614: @1557649
     /* 1557649 */   GIM_Try, /*On fail goto*//*Label 21615*/ GIMT_Encode4(1557731), // Rule ID 20768 //
     /* 1557654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1557657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1557665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1557668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1557671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557693 */     // MIs[0] round
     /* 1557693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557696 */     // MIs[0] policy
     /* 1557696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557706 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1557709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557730 */     // GIR_Coverage, 20768,
     /* 1557730 */     GIR_EraseRootFromParent_Done,
     /* 1557731 */   // Label 21615: @1557731
     /* 1557731 */   GIM_Try, /*On fail goto*//*Label 21616*/ GIMT_Encode4(1557813), // Rule ID 20769 //
     /* 1557736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1557739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1557747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1557750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1557753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557775 */     // MIs[0] round
     /* 1557775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557778 */     // MIs[0] policy
     /* 1557778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557788 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1557791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557812 */     // GIR_Coverage, 20769,
     /* 1557812 */     GIR_EraseRootFromParent_Done,
     /* 1557813 */   // Label 21616: @1557813
     /* 1557813 */   GIM_Try, /*On fail goto*//*Label 21617*/ GIMT_Encode4(1557895), // Rule ID 20772 //
     /* 1557818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1557821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1557829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1557832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1557835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557857 */     // MIs[0] round
     /* 1557857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557860 */     // MIs[0] policy
     /* 1557860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557870 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1557873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557894 */     // GIR_Coverage, 20772,
     /* 1557894 */     GIR_EraseRootFromParent_Done,
     /* 1557895 */   // Label 21617: @1557895
     /* 1557895 */   GIM_Try, /*On fail goto*//*Label 21618*/ GIMT_Encode4(1557977), // Rule ID 20773 //
     /* 1557900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1557903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1557911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1557914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1557917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557939 */     // MIs[0] round
     /* 1557939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557942 */     // MIs[0] policy
     /* 1557942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1557955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557976 */     // GIR_Coverage, 20773,
     /* 1557976 */     GIR_EraseRootFromParent_Done,
     /* 1557977 */   // Label 21618: @1557977
     /* 1557977 */   GIM_Try, /*On fail goto*//*Label 21619*/ GIMT_Encode4(1558059), // Rule ID 20776 //
     /* 1557982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1557985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1557993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1557996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1557999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558021 */     // MIs[0] round
     /* 1558021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558024 */     // MIs[0] policy
     /* 1558024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558034 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558058 */     // GIR_Coverage, 20776,
     /* 1558058 */     GIR_EraseRootFromParent_Done,
     /* 1558059 */   // Label 21619: @1558059
     /* 1558059 */   GIM_Try, /*On fail goto*//*Label 21620*/ GIMT_Encode4(1558141), // Rule ID 20777 //
     /* 1558064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1558067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1558075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1558078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1558081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558103 */     // MIs[0] round
     /* 1558103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558106 */     // MIs[0] policy
     /* 1558106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558116 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558140 */     // GIR_Coverage, 20777,
     /* 1558140 */     GIR_EraseRootFromParent_Done,
     /* 1558141 */   // Label 21620: @1558141
     /* 1558141 */   GIM_Try, /*On fail goto*//*Label 21621*/ GIMT_Encode4(1558223), // Rule ID 20780 //
     /* 1558146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1558157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1558160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1558163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558185 */     // MIs[0] round
     /* 1558185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558188 */     // MIs[0] policy
     /* 1558188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1558201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558222 */     // GIR_Coverage, 20780,
     /* 1558222 */     GIR_EraseRootFromParent_Done,
     /* 1558223 */   // Label 21621: @1558223
     /* 1558223 */   GIM_Try, /*On fail goto*//*Label 21622*/ GIMT_Encode4(1558305), // Rule ID 20781 //
     /* 1558228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1558239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1558242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1558245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558267 */     // MIs[0] round
     /* 1558267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558270 */     // MIs[0] policy
     /* 1558270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558280 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1558283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558304 */     // GIR_Coverage, 20781,
     /* 1558304 */     GIR_EraseRootFromParent_Done,
     /* 1558305 */   // Label 21622: @1558305
     /* 1558305 */   GIM_Try, /*On fail goto*//*Label 21623*/ GIMT_Encode4(1558387), // Rule ID 20784 //
     /* 1558310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1558321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1558324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1558327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558349 */     // MIs[0] round
     /* 1558349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558352 */     // MIs[0] policy
     /* 1558352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558362 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1558365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558386 */     // GIR_Coverage, 20784,
     /* 1558386 */     GIR_EraseRootFromParent_Done,
     /* 1558387 */   // Label 21623: @1558387
     /* 1558387 */   GIM_Try, /*On fail goto*//*Label 21624*/ GIMT_Encode4(1558469), // Rule ID 20785 //
     /* 1558392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1558403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1558406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1558409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558431 */     // MIs[0] round
     /* 1558431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558434 */     // MIs[0] policy
     /* 1558434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558444 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1558447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558468 */     // GIR_Coverage, 20785,
     /* 1558468 */     GIR_EraseRootFromParent_Done,
     /* 1558469 */   // Label 21624: @1558469
     /* 1558469 */   GIM_Try, /*On fail goto*//*Label 21625*/ GIMT_Encode4(1558551), // Rule ID 20788 //
     /* 1558474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1558485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1558488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1558491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1558494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558513 */     // MIs[0] round
     /* 1558513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558516 */     // MIs[0] policy
     /* 1558516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558526 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1558529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558550 */     // GIR_Coverage, 20788,
     /* 1558550 */     GIR_EraseRootFromParent_Done,
     /* 1558551 */   // Label 21625: @1558551
     /* 1558551 */   GIM_Try, /*On fail goto*//*Label 21626*/ GIMT_Encode4(1558633), // Rule ID 20789 //
     /* 1558556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1558567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1558570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1558573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1558576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558595 */     // MIs[0] round
     /* 1558595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558598 */     // MIs[0] policy
     /* 1558598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1558611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558632 */     // GIR_Coverage, 20789,
     /* 1558632 */     GIR_EraseRootFromParent_Done,
     /* 1558633 */   // Label 21626: @1558633
     /* 1558633 */   GIM_Try, /*On fail goto*//*Label 21627*/ GIMT_Encode4(1558715), // Rule ID 20792 //
     /* 1558638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1558641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1558649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1558652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1558655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558677 */     // MIs[0] round
     /* 1558677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558680 */     // MIs[0] policy
     /* 1558680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1558693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558714 */     // GIR_Coverage, 20792,
     /* 1558714 */     GIR_EraseRootFromParent_Done,
     /* 1558715 */   // Label 21627: @1558715
     /* 1558715 */   GIM_Try, /*On fail goto*//*Label 21628*/ GIMT_Encode4(1558797), // Rule ID 20793 //
     /* 1558720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1558723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1558731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1558734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1558737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558759 */     // MIs[0] round
     /* 1558759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558762 */     // MIs[0] policy
     /* 1558762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1558775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558796 */     // GIR_Coverage, 20793,
     /* 1558796 */     GIR_EraseRootFromParent_Done,
     /* 1558797 */   // Label 21628: @1558797
     /* 1558797 */   GIM_Try, /*On fail goto*//*Label 21629*/ GIMT_Encode4(1558879), // Rule ID 20796 //
     /* 1558802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1558805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1558813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1558816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1558819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558841 */     // MIs[0] round
     /* 1558841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558844 */     // MIs[0] policy
     /* 1558844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558854 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1558857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558878 */     // GIR_Coverage, 20796,
     /* 1558878 */     GIR_EraseRootFromParent_Done,
     /* 1558879 */   // Label 21629: @1558879
     /* 1558879 */   GIM_Try, /*On fail goto*//*Label 21630*/ GIMT_Encode4(1558961), // Rule ID 20797 //
     /* 1558884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1558887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1558895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1558898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1558901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558923 */     // MIs[0] round
     /* 1558923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558926 */     // MIs[0] policy
     /* 1558926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558936 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1558939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558960 */     // GIR_Coverage, 20797,
     /* 1558960 */     GIR_EraseRootFromParent_Done,
     /* 1558961 */   // Label 21630: @1558961
     /* 1558961 */   GIM_Try, /*On fail goto*//*Label 21631*/ GIMT_Encode4(1559043), // Rule ID 20800 //
     /* 1558966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1558969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1558977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1558980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1558983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559005 */     // MIs[0] round
     /* 1559005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559008 */     // MIs[0] policy
     /* 1559008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559042 */     // GIR_Coverage, 20800,
     /* 1559042 */     GIR_EraseRootFromParent_Done,
     /* 1559043 */   // Label 21631: @1559043
     /* 1559043 */   GIM_Try, /*On fail goto*//*Label 21632*/ GIMT_Encode4(1559125), // Rule ID 20801 //
     /* 1559048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1559051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1559059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1559062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1559065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559087 */     // MIs[0] round
     /* 1559087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559090 */     // MIs[0] policy
     /* 1559090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559124 */     // GIR_Coverage, 20801,
     /* 1559124 */     GIR_EraseRootFromParent_Done,
     /* 1559125 */   // Label 21632: @1559125
     /* 1559125 */   GIM_Try, /*On fail goto*//*Label 21633*/ GIMT_Encode4(1559207), // Rule ID 20804 //
     /* 1559130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1559141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1559144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1559147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559169 */     // MIs[0] round
     /* 1559169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559172 */     // MIs[0] policy
     /* 1559172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1559185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559206 */     // GIR_Coverage, 20804,
     /* 1559206 */     GIR_EraseRootFromParent_Done,
     /* 1559207 */   // Label 21633: @1559207
     /* 1559207 */   GIM_Try, /*On fail goto*//*Label 21634*/ GIMT_Encode4(1559289), // Rule ID 20805 //
     /* 1559212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1559223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1559226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1559229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559251 */     // MIs[0] round
     /* 1559251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559254 */     // MIs[0] policy
     /* 1559254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559264 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1559267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559288 */     // GIR_Coverage, 20805,
     /* 1559288 */     GIR_EraseRootFromParent_Done,
     /* 1559289 */   // Label 21634: @1559289
     /* 1559289 */   GIM_Try, /*On fail goto*//*Label 21635*/ GIMT_Encode4(1559371), // Rule ID 20808 //
     /* 1559294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1559305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1559308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1559311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559333 */     // MIs[0] round
     /* 1559333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559336 */     // MIs[0] policy
     /* 1559336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559346 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1559349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559370 */     // GIR_Coverage, 20808,
     /* 1559370 */     GIR_EraseRootFromParent_Done,
     /* 1559371 */   // Label 21635: @1559371
     /* 1559371 */   GIM_Try, /*On fail goto*//*Label 21636*/ GIMT_Encode4(1559453), // Rule ID 20809 //
     /* 1559376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1559387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1559390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1559393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559415 */     // MIs[0] round
     /* 1559415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559418 */     // MIs[0] policy
     /* 1559418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559428 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1559431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559452 */     // GIR_Coverage, 20809,
     /* 1559452 */     GIR_EraseRootFromParent_Done,
     /* 1559453 */   // Label 21636: @1559453
     /* 1559453 */   GIM_Try, /*On fail goto*//*Label 21637*/ GIMT_Encode4(1559535), // Rule ID 20812 //
     /* 1559458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1559469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1559472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1559475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559497 */     // MIs[0] round
     /* 1559497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559500 */     // MIs[0] policy
     /* 1559500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559510 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559534 */     // GIR_Coverage, 20812,
     /* 1559534 */     GIR_EraseRootFromParent_Done,
     /* 1559535 */   // Label 21637: @1559535
     /* 1559535 */   GIM_Try, /*On fail goto*//*Label 21638*/ GIMT_Encode4(1559617), // Rule ID 20813 //
     /* 1559540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1559551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1559554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1559557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559579 */     // MIs[0] round
     /* 1559579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559582 */     // MIs[0] policy
     /* 1559582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559592 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559616 */     // GIR_Coverage, 20813,
     /* 1559616 */     GIR_EraseRootFromParent_Done,
     /* 1559617 */   // Label 21638: @1559617
     /* 1559617 */   GIM_Try, /*On fail goto*//*Label 21639*/ GIMT_Encode4(1559699), // Rule ID 20816 //
     /* 1559622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1559625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1559633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1559636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1559639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1559642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559661 */     // MIs[0] round
     /* 1559661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559664 */     // MIs[0] policy
     /* 1559664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1559677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559698 */     // GIR_Coverage, 20816,
     /* 1559698 */     GIR_EraseRootFromParent_Done,
     /* 1559699 */   // Label 21639: @1559699
     /* 1559699 */   GIM_Try, /*On fail goto*//*Label 21640*/ GIMT_Encode4(1559781), // Rule ID 20817 //
     /* 1559704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1559707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1559715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1559718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1559721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1559724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559743 */     // MIs[0] round
     /* 1559743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559746 */     // MIs[0] policy
     /* 1559746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559756 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1559759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559780 */     // GIR_Coverage, 20817,
     /* 1559780 */     GIR_EraseRootFromParent_Done,
     /* 1559781 */   // Label 21640: @1559781
     /* 1559781 */   GIM_Try, /*On fail goto*//*Label 21641*/ GIMT_Encode4(1559863), // Rule ID 20820 //
     /* 1559786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1559789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1559797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1559800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1559803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559825 */     // MIs[0] round
     /* 1559825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559828 */     // MIs[0] policy
     /* 1559828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559838 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1559841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559862 */     // GIR_Coverage, 20820,
     /* 1559862 */     GIR_EraseRootFromParent_Done,
     /* 1559863 */   // Label 21641: @1559863
     /* 1559863 */   GIM_Try, /*On fail goto*//*Label 21642*/ GIMT_Encode4(1559945), // Rule ID 20821 //
     /* 1559868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1559871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1559879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1559882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1559885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559907 */     // MIs[0] round
     /* 1559907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559910 */     // MIs[0] policy
     /* 1559910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559920 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1559923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559944 */     // GIR_Coverage, 20821,
     /* 1559944 */     GIR_EraseRootFromParent_Done,
     /* 1559945 */   // Label 21642: @1559945
     /* 1559945 */   GIM_Try, /*On fail goto*//*Label 21643*/ GIMT_Encode4(1560027), // Rule ID 20824 //
     /* 1559950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1559953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1559961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1559964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1559967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1559970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559989 */     // MIs[0] round
     /* 1559989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559992 */     // MIs[0] policy
     /* 1559992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560002 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1560005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560026 */     // GIR_Coverage, 20824,
     /* 1560026 */     GIR_EraseRootFromParent_Done,
     /* 1560027 */   // Label 21643: @1560027
     /* 1560027 */   GIM_Try, /*On fail goto*//*Label 21644*/ GIMT_Encode4(1560109), // Rule ID 20825 //
     /* 1560032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1560035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1560043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1560046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1560049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560071 */     // MIs[0] round
     /* 1560071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560074 */     // MIs[0] policy
     /* 1560074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1560087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560108 */     // GIR_Coverage, 20825,
     /* 1560108 */     GIR_EraseRootFromParent_Done,
     /* 1560109 */   // Label 21644: @1560109
     /* 1560109 */   GIM_Try, /*On fail goto*//*Label 21645*/ GIMT_Encode4(1560191), // Rule ID 20828 //
     /* 1560114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1560125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1560128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1560131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560153 */     // MIs[0] round
     /* 1560153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560156 */     // MIs[0] policy
     /* 1560156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560166 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560190 */     // GIR_Coverage, 20828,
     /* 1560190 */     GIR_EraseRootFromParent_Done,
     /* 1560191 */   // Label 21645: @1560191
     /* 1560191 */   GIM_Try, /*On fail goto*//*Label 21646*/ GIMT_Encode4(1560273), // Rule ID 20829 //
     /* 1560196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1560207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1560210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1560213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560235 */     // MIs[0] round
     /* 1560235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560238 */     // MIs[0] policy
     /* 1560238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560248 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560272 */     // GIR_Coverage, 20829,
     /* 1560272 */     GIR_EraseRootFromParent_Done,
     /* 1560273 */   // Label 21646: @1560273
     /* 1560273 */   GIM_Try, /*On fail goto*//*Label 21647*/ GIMT_Encode4(1560355), // Rule ID 20832 //
     /* 1560278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1560281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1560289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1560292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1560295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560317 */     // MIs[0] round
     /* 1560317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560320 */     // MIs[0] policy
     /* 1560320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560330 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560339 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560354 */     // GIR_Coverage, 20832,
     /* 1560354 */     GIR_EraseRootFromParent_Done,
     /* 1560355 */   // Label 21647: @1560355
     /* 1560355 */   GIM_Try, /*On fail goto*//*Label 21648*/ GIMT_Encode4(1560437), // Rule ID 20833 //
     /* 1560360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1560363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1560371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1560374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1560377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560399 */     // MIs[0] round
     /* 1560399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560402 */     // MIs[0] policy
     /* 1560402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560412 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560421 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560436 */     // GIR_Coverage, 20833,
     /* 1560436 */     GIR_EraseRootFromParent_Done,
     /* 1560437 */   // Label 21648: @1560437
     /* 1560437 */   GIM_Try, /*On fail goto*//*Label 21649*/ GIMT_Encode4(1560519), // Rule ID 20836 //
     /* 1560442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1560445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1560453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1560456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1560459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560481 */     // MIs[0] round
     /* 1560481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560484 */     // MIs[0] policy
     /* 1560484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560518 */     // GIR_Coverage, 20836,
     /* 1560518 */     GIR_EraseRootFromParent_Done,
     /* 1560519 */   // Label 21649: @1560519
     /* 1560519 */   GIM_Try, /*On fail goto*//*Label 21650*/ GIMT_Encode4(1560601), // Rule ID 20837 //
     /* 1560524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1560527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1560535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1560538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1560541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560563 */     // MIs[0] round
     /* 1560563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560566 */     // MIs[0] policy
     /* 1560566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560600 */     // GIR_Coverage, 20837,
     /* 1560600 */     GIR_EraseRootFromParent_Done,
     /* 1560601 */   // Label 21650: @1560601
     /* 1560601 */   GIM_Try, /*On fail goto*//*Label 21651*/ GIMT_Encode4(1560683), // Rule ID 20840 //
     /* 1560606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1560617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1560620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1560623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1560633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560645 */     // MIs[0] round
     /* 1560645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560648 */     // MIs[0] policy
     /* 1560648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560658 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1560661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560682 */     // GIR_Coverage, 20840,
     /* 1560682 */     GIR_EraseRootFromParent_Done,
     /* 1560683 */   // Label 21651: @1560683
     /* 1560683 */   GIM_Try, /*On fail goto*//*Label 21652*/ GIMT_Encode4(1560765), // Rule ID 20841 //
     /* 1560688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1560699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1560702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1560705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1560715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560727 */     // MIs[0] round
     /* 1560727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560730 */     // MIs[0] policy
     /* 1560730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560740 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1560743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560764 */     // GIR_Coverage, 20841,
     /* 1560764 */     GIR_EraseRootFromParent_Done,
     /* 1560765 */   // Label 21652: @1560765
     /* 1560765 */   GIM_Try, /*On fail goto*//*Label 21653*/ GIMT_Encode4(1560847), // Rule ID 20844 //
     /* 1560770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1560781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1560784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1560787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1560790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1560797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560809 */     // MIs[0] round
     /* 1560809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560812 */     // MIs[0] policy
     /* 1560812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560822 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1560825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560846 */     // GIR_Coverage, 20844,
     /* 1560846 */     GIR_EraseRootFromParent_Done,
     /* 1560847 */   // Label 21653: @1560847
     /* 1560847 */   GIM_Try, /*On fail goto*//*Label 21654*/ GIMT_Encode4(1560929), // Rule ID 20845 //
     /* 1560852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1560863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1560866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1560869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1560872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1560879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560891 */     // MIs[0] round
     /* 1560891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560894 */     // MIs[0] policy
     /* 1560894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560904 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1560907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560928 */     // GIR_Coverage, 20845,
     /* 1560928 */     GIR_EraseRootFromParent_Done,
     /* 1560929 */   // Label 21654: @1560929
     /* 1560929 */   GIM_Try, /*On fail goto*//*Label 21655*/ GIMT_Encode4(1561011), // Rule ID 20848 //
     /* 1560934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1560945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1560948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1560951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1560954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1560961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560973 */     // MIs[0] round
     /* 1560973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560976 */     // MIs[0] policy
     /* 1560976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560986 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1560989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561010 */     // GIR_Coverage, 20848,
     /* 1561010 */     GIR_EraseRootFromParent_Done,
     /* 1561011 */   // Label 21655: @1561011
     /* 1561011 */   GIM_Try, /*On fail goto*//*Label 21656*/ GIMT_Encode4(1561093), // Rule ID 20849 //
     /* 1561016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1561027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1561030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1561033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1561036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561055 */     // MIs[0] round
     /* 1561055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561058 */     // MIs[0] policy
     /* 1561058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561068 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561092 */     // GIR_Coverage, 20849,
     /* 1561092 */     GIR_EraseRootFromParent_Done,
     /* 1561093 */   // Label 21656: @1561093
     /* 1561093 */   GIM_Try, /*On fail goto*//*Label 21657*/ GIMT_Encode4(1561175), // Rule ID 20852 //
     /* 1561098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1561109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1561112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1561115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561137 */     // MIs[0] round
     /* 1561137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561140 */     // MIs[0] policy
     /* 1561140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561174 */     // GIR_Coverage, 20852,
     /* 1561174 */     GIR_EraseRootFromParent_Done,
     /* 1561175 */   // Label 21657: @1561175
     /* 1561175 */   GIM_Try, /*On fail goto*//*Label 21658*/ GIMT_Encode4(1561257), // Rule ID 20853 //
     /* 1561180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1561191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1561194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1561197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561219 */     // MIs[0] round
     /* 1561219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561222 */     // MIs[0] policy
     /* 1561222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561256 */     // GIR_Coverage, 20853,
     /* 1561256 */     GIR_EraseRootFromParent_Done,
     /* 1561257 */   // Label 21658: @1561257
     /* 1561257 */   GIM_Try, /*On fail goto*//*Label 21659*/ GIMT_Encode4(1561339), // Rule ID 20856 //
     /* 1561262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1561273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1561276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1561279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561301 */     // MIs[0] round
     /* 1561301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561304 */     // MIs[0] policy
     /* 1561304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561323 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561338 */     // GIR_Coverage, 20856,
     /* 1561338 */     GIR_EraseRootFromParent_Done,
     /* 1561339 */   // Label 21659: @1561339
     /* 1561339 */   GIM_Try, /*On fail goto*//*Label 21660*/ GIMT_Encode4(1561421), // Rule ID 20857 //
     /* 1561344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1561355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1561358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1561361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561383 */     // MIs[0] round
     /* 1561383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561386 */     // MIs[0] policy
     /* 1561386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561396 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561420 */     // GIR_Coverage, 20857,
     /* 1561420 */     GIR_EraseRootFromParent_Done,
     /* 1561421 */   // Label 21660: @1561421
     /* 1561421 */   GIM_Try, /*On fail goto*//*Label 21661*/ GIMT_Encode4(1561503), // Rule ID 20860 //
     /* 1561426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1561437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1561440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1561443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561465 */     // MIs[0] round
     /* 1561465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561468 */     // MIs[0] policy
     /* 1561468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561502 */     // GIR_Coverage, 20860,
     /* 1561502 */     GIR_EraseRootFromParent_Done,
     /* 1561503 */   // Label 21661: @1561503
     /* 1561503 */   GIM_Try, /*On fail goto*//*Label 21662*/ GIMT_Encode4(1561585), // Rule ID 20861 //
     /* 1561508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1561519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1561522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1561525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561547 */     // MIs[0] round
     /* 1561547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561550 */     // MIs[0] policy
     /* 1561550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561560 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561584 */     // GIR_Coverage, 20861,
     /* 1561584 */     GIR_EraseRootFromParent_Done,
     /* 1561585 */   // Label 21662: @1561585
     /* 1561585 */   GIM_Try, /*On fail goto*//*Label 21663*/ GIMT_Encode4(1561667), // Rule ID 20864 //
     /* 1561590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1561593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1561601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1561604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1561607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1561610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561629 */     // MIs[0] round
     /* 1561629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561632 */     // MIs[0] policy
     /* 1561632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561642 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561651 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561666 */     // GIR_Coverage, 20864,
     /* 1561666 */     GIR_EraseRootFromParent_Done,
     /* 1561667 */   // Label 21663: @1561667
     /* 1561667 */   GIM_Try, /*On fail goto*//*Label 21664*/ GIMT_Encode4(1561749), // Rule ID 20865 //
     /* 1561672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1561675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1561683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1561686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1561689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1561692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561711 */     // MIs[0] round
     /* 1561711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561714 */     // MIs[0] policy
     /* 1561714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561733 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561748 */     // GIR_Coverage, 20865,
     /* 1561748 */     GIR_EraseRootFromParent_Done,
     /* 1561749 */   // Label 21664: @1561749
     /* 1561749 */   GIM_Try, /*On fail goto*//*Label 21665*/ GIMT_Encode4(1561831), // Rule ID 20868 //
     /* 1561754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1561757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1561765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1561768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1561771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561793 */     // MIs[0] round
     /* 1561793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561796 */     // MIs[0] policy
     /* 1561796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561806 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561830 */     // GIR_Coverage, 20868,
     /* 1561830 */     GIR_EraseRootFromParent_Done,
     /* 1561831 */   // Label 21665: @1561831
     /* 1561831 */   GIM_Try, /*On fail goto*//*Label 21666*/ GIMT_Encode4(1561913), // Rule ID 20869 //
     /* 1561836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1561839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1561847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1561850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1561853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561875 */     // MIs[0] round
     /* 1561875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561878 */     // MIs[0] policy
     /* 1561878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561888 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561912 */     // GIR_Coverage, 20869,
     /* 1561912 */     GIR_EraseRootFromParent_Done,
     /* 1561913 */   // Label 21666: @1561913
     /* 1561913 */   GIM_Try, /*On fail goto*//*Label 21667*/ GIMT_Encode4(1561995), // Rule ID 20872 //
     /* 1561918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1561921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1561929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1561932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1561935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561957 */     // MIs[0] round
     /* 1561957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561960 */     // MIs[0] policy
     /* 1561960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561970 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561994 */     // GIR_Coverage, 20872,
     /* 1561994 */     GIR_EraseRootFromParent_Done,
     /* 1561995 */   // Label 21667: @1561995
     /* 1561995 */   GIM_Try, /*On fail goto*//*Label 21668*/ GIMT_Encode4(1562077), // Rule ID 20873 //
     /* 1562000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1562003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1562008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1562011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1562014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1562017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1562020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562039 */     // MIs[0] round
     /* 1562039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562042 */     // MIs[0] policy
     /* 1562042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562052 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1562055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562076 */     // GIR_Coverage, 20873,
     /* 1562076 */     GIR_EraseRootFromParent_Done,
     /* 1562077 */   // Label 21668: @1562077
     /* 1562077 */   GIM_Try, /*On fail goto*//*Label 21669*/ GIMT_Encode4(1562159), // Rule ID 20996 //
     /* 1562082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1562093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1562096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1562099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562121 */     // MIs[0] round
     /* 1562121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562124 */     // MIs[0] policy
     /* 1562124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562134 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1562137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562158 */     // GIR_Coverage, 20996,
     /* 1562158 */     GIR_EraseRootFromParent_Done,
     /* 1562159 */   // Label 21669: @1562159
     /* 1562159 */   GIM_Try, /*On fail goto*//*Label 21670*/ GIMT_Encode4(1562241), // Rule ID 20997 //
     /* 1562164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1562175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1562178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1562181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562203 */     // MIs[0] round
     /* 1562203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562206 */     // MIs[0] policy
     /* 1562206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562216 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1562219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562240 */     // GIR_Coverage, 20997,
     /* 1562240 */     GIR_EraseRootFromParent_Done,
     /* 1562241 */   // Label 21670: @1562241
     /* 1562241 */   GIM_Try, /*On fail goto*//*Label 21671*/ GIMT_Encode4(1562323), // Rule ID 21000 //
     /* 1562246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1562257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1562260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1562263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562285 */     // MIs[0] round
     /* 1562285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562288 */     // MIs[0] policy
     /* 1562288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562298 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1562301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562322 */     // GIR_Coverage, 21000,
     /* 1562322 */     GIR_EraseRootFromParent_Done,
     /* 1562323 */   // Label 21671: @1562323
     /* 1562323 */   GIM_Try, /*On fail goto*//*Label 21672*/ GIMT_Encode4(1562405), // Rule ID 21001 //
     /* 1562328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1562339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1562342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1562345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562367 */     // MIs[0] round
     /* 1562367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562370 */     // MIs[0] policy
     /* 1562370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562380 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1562383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562404 */     // GIR_Coverage, 21001,
     /* 1562404 */     GIR_EraseRootFromParent_Done,
     /* 1562405 */   // Label 21672: @1562405
     /* 1562405 */   GIM_Try, /*On fail goto*//*Label 21673*/ GIMT_Encode4(1562487), // Rule ID 21004 //
     /* 1562410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1562413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1562421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1562424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1562427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562449 */     // MIs[0] round
     /* 1562449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562452 */     // MIs[0] policy
     /* 1562452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562462 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1562465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562486 */     // GIR_Coverage, 21004,
     /* 1562486 */     GIR_EraseRootFromParent_Done,
     /* 1562487 */   // Label 21673: @1562487
     /* 1562487 */   GIM_Try, /*On fail goto*//*Label 21674*/ GIMT_Encode4(1562569), // Rule ID 21005 //
     /* 1562492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1562495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1562503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1562506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1562509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562531 */     // MIs[0] round
     /* 1562531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562534 */     // MIs[0] policy
     /* 1562534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562544 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1562547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562568 */     // GIR_Coverage, 21005,
     /* 1562568 */     GIR_EraseRootFromParent_Done,
     /* 1562569 */   // Label 21674: @1562569
     /* 1562569 */   GIM_Try, /*On fail goto*//*Label 21675*/ GIMT_Encode4(1562651), // Rule ID 21008 //
     /* 1562574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1562585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1562588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1562591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562613 */     // MIs[0] round
     /* 1562613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562616 */     // MIs[0] policy
     /* 1562616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562626 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1562629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562650 */     // GIR_Coverage, 21008,
     /* 1562650 */     GIR_EraseRootFromParent_Done,
     /* 1562651 */   // Label 21675: @1562651
     /* 1562651 */   GIM_Try, /*On fail goto*//*Label 21676*/ GIMT_Encode4(1562733), // Rule ID 21009 //
     /* 1562656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1562667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1562670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1562673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562695 */     // MIs[0] round
     /* 1562695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562698 */     // MIs[0] policy
     /* 1562698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562708 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1562711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562732 */     // GIR_Coverage, 21009,
     /* 1562732 */     GIR_EraseRootFromParent_Done,
     /* 1562733 */   // Label 21676: @1562733
     /* 1562733 */   GIM_Try, /*On fail goto*//*Label 21677*/ GIMT_Encode4(1562815), // Rule ID 21012 //
     /* 1562738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1562741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1562749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1562752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1562755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562777 */     // MIs[0] round
     /* 1562777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562780 */     // MIs[0] policy
     /* 1562780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562790 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1562793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562814 */     // GIR_Coverage, 21012,
     /* 1562814 */     GIR_EraseRootFromParent_Done,
     /* 1562815 */   // Label 21677: @1562815
     /* 1562815 */   GIM_Try, /*On fail goto*//*Label 21678*/ GIMT_Encode4(1562897), // Rule ID 21013 //
     /* 1562820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1562823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1562831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1562834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1562837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562859 */     // MIs[0] round
     /* 1562859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562862 */     // MIs[0] policy
     /* 1562862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562872 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1562875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562896 */     // GIR_Coverage, 21013,
     /* 1562896 */     GIR_EraseRootFromParent_Done,
     /* 1562897 */   // Label 21678: @1562897
     /* 1562897 */   GIM_Try, /*On fail goto*//*Label 21679*/ GIMT_Encode4(1562979), // Rule ID 21016 //
     /* 1562902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1562905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1562913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1562916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1562919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562941 */     // MIs[0] round
     /* 1562941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562944 */     // MIs[0] policy
     /* 1562944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562954 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1562957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562963 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562978 */     // GIR_Coverage, 21016,
     /* 1562978 */     GIR_EraseRootFromParent_Done,
     /* 1562979 */   // Label 21679: @1562979
     /* 1562979 */   GIM_Try, /*On fail goto*//*Label 21680*/ GIMT_Encode4(1563061), // Rule ID 21017 //
     /* 1562984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1562987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1562995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1562998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1563001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1563004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563023 */     // MIs[0] round
     /* 1563023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563026 */     // MIs[0] policy
     /* 1563026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563036 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1563039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563060 */     // GIR_Coverage, 21017,
     /* 1563060 */     GIR_EraseRootFromParent_Done,
     /* 1563061 */   // Label 21680: @1563061
     /* 1563061 */   GIM_Try, /*On fail goto*//*Label 21681*/ GIMT_Encode4(1563143), // Rule ID 21020 //
     /* 1563066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1563077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1563080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1563083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563105 */     // MIs[0] round
     /* 1563105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563108 */     // MIs[0] policy
     /* 1563108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563118 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1563121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563142 */     // GIR_Coverage, 21020,
     /* 1563142 */     GIR_EraseRootFromParent_Done,
     /* 1563143 */   // Label 21681: @1563143
     /* 1563143 */   GIM_Try, /*On fail goto*//*Label 21682*/ GIMT_Encode4(1563225), // Rule ID 21021 //
     /* 1563148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1563159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1563162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1563165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563187 */     // MIs[0] round
     /* 1563187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563190 */     // MIs[0] policy
     /* 1563190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563200 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1563203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563224 */     // GIR_Coverage, 21021,
     /* 1563224 */     GIR_EraseRootFromParent_Done,
     /* 1563225 */   // Label 21682: @1563225
     /* 1563225 */   GIM_Try, /*On fail goto*//*Label 21683*/ GIMT_Encode4(1563307), // Rule ID 21024 //
     /* 1563230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1563241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1563244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1563247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563269 */     // MIs[0] round
     /* 1563269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563272 */     // MIs[0] policy
     /* 1563272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563282 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1563285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563306 */     // GIR_Coverage, 21024,
     /* 1563306 */     GIR_EraseRootFromParent_Done,
     /* 1563307 */   // Label 21683: @1563307
     /* 1563307 */   GIM_Try, /*On fail goto*//*Label 21684*/ GIMT_Encode4(1563389), // Rule ID 21025 //
     /* 1563312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1563323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1563326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1563329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563351 */     // MIs[0] round
     /* 1563351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563354 */     // MIs[0] policy
     /* 1563354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563364 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1563367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563388 */     // GIR_Coverage, 21025,
     /* 1563388 */     GIR_EraseRootFromParent_Done,
     /* 1563389 */   // Label 21684: @1563389
     /* 1563389 */   GIM_Try, /*On fail goto*//*Label 21685*/ GIMT_Encode4(1563471), // Rule ID 21028 //
     /* 1563394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1563405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1563408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1563411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1563414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563433 */     // MIs[0] round
     /* 1563433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563436 */     // MIs[0] policy
     /* 1563436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563446 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1563449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563470 */     // GIR_Coverage, 21028,
     /* 1563470 */     GIR_EraseRootFromParent_Done,
     /* 1563471 */   // Label 21685: @1563471
     /* 1563471 */   GIM_Try, /*On fail goto*//*Label 21686*/ GIMT_Encode4(1563553), // Rule ID 21029 //
     /* 1563476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1563487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1563490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1563493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1563496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563515 */     // MIs[0] round
     /* 1563515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563518 */     // MIs[0] policy
     /* 1563518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563528 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1563531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563552 */     // GIR_Coverage, 21029,
     /* 1563552 */     GIR_EraseRootFromParent_Done,
     /* 1563553 */   // Label 21686: @1563553
     /* 1563553 */   GIM_Try, /*On fail goto*//*Label 21687*/ GIMT_Encode4(1563635), // Rule ID 21032 //
     /* 1563558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1563561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1563569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1563572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1563575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563597 */     // MIs[0] round
     /* 1563597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563600 */     // MIs[0] policy
     /* 1563600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563610 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1563613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563634 */     // GIR_Coverage, 21032,
     /* 1563634 */     GIR_EraseRootFromParent_Done,
     /* 1563635 */   // Label 21687: @1563635
     /* 1563635 */   GIM_Try, /*On fail goto*//*Label 21688*/ GIMT_Encode4(1563717), // Rule ID 21033 //
     /* 1563640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1563643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1563651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1563654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1563657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563679 */     // MIs[0] round
     /* 1563679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563682 */     // MIs[0] policy
     /* 1563682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563692 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1563695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563716 */     // GIR_Coverage, 21033,
     /* 1563716 */     GIR_EraseRootFromParent_Done,
     /* 1563717 */   // Label 21688: @1563717
     /* 1563717 */   GIM_Try, /*On fail goto*//*Label 21689*/ GIMT_Encode4(1563799), // Rule ID 21036 //
     /* 1563722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1563725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1563733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1563736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1563739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563761 */     // MIs[0] round
     /* 1563761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563764 */     // MIs[0] policy
     /* 1563764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563774 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1563777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563798 */     // GIR_Coverage, 21036,
     /* 1563798 */     GIR_EraseRootFromParent_Done,
     /* 1563799 */   // Label 21689: @1563799
     /* 1563799 */   GIM_Try, /*On fail goto*//*Label 21690*/ GIMT_Encode4(1563881), // Rule ID 21037 //
     /* 1563804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1563807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1563815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1563818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1563821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563843 */     // MIs[0] round
     /* 1563843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563846 */     // MIs[0] policy
     /* 1563846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563856 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1563859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563880 */     // GIR_Coverage, 21037,
     /* 1563880 */     GIR_EraseRootFromParent_Done,
     /* 1563881 */   // Label 21690: @1563881
     /* 1563881 */   GIM_Try, /*On fail goto*//*Label 21691*/ GIMT_Encode4(1563963), // Rule ID 21040 //
     /* 1563886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1563889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1563897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1563900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1563903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563925 */     // MIs[0] round
     /* 1563925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563928 */     // MIs[0] policy
     /* 1563928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563938 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1563941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563962 */     // GIR_Coverage, 21040,
     /* 1563962 */     GIR_EraseRootFromParent_Done,
     /* 1563963 */   // Label 21691: @1563963
     /* 1563963 */   GIM_Try, /*On fail goto*//*Label 21692*/ GIMT_Encode4(1564045), // Rule ID 21041 //
     /* 1563968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1563971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1563979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1563982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1563985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564007 */     // MIs[0] round
     /* 1564007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564010 */     // MIs[0] policy
     /* 1564010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564020 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1564023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564044 */     // GIR_Coverage, 21041,
     /* 1564044 */     GIR_EraseRootFromParent_Done,
     /* 1564045 */   // Label 21692: @1564045
     /* 1564045 */   GIM_Try, /*On fail goto*//*Label 21693*/ GIMT_Encode4(1564127), // Rule ID 21044 //
     /* 1564050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1564061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1564064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1564067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564089 */     // MIs[0] round
     /* 1564089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564092 */     // MIs[0] policy
     /* 1564092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564102 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1564105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564126 */     // GIR_Coverage, 21044,
     /* 1564126 */     GIR_EraseRootFromParent_Done,
     /* 1564127 */   // Label 21693: @1564127
     /* 1564127 */   GIM_Try, /*On fail goto*//*Label 21694*/ GIMT_Encode4(1564209), // Rule ID 21045 //
     /* 1564132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1564143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1564146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1564149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564171 */     // MIs[0] round
     /* 1564171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564174 */     // MIs[0] policy
     /* 1564174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564184 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1564187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564208 */     // GIR_Coverage, 21045,
     /* 1564208 */     GIR_EraseRootFromParent_Done,
     /* 1564209 */   // Label 21694: @1564209
     /* 1564209 */   GIM_Try, /*On fail goto*//*Label 21695*/ GIMT_Encode4(1564291), // Rule ID 21048 //
     /* 1564214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1564225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1564228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1564231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564253 */     // MIs[0] round
     /* 1564253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564256 */     // MIs[0] policy
     /* 1564256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564266 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1564269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564290 */     // GIR_Coverage, 21048,
     /* 1564290 */     GIR_EraseRootFromParent_Done,
     /* 1564291 */   // Label 21695: @1564291
     /* 1564291 */   GIM_Try, /*On fail goto*//*Label 21696*/ GIMT_Encode4(1564373), // Rule ID 21049 //
     /* 1564296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1564307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1564310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1564313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564335 */     // MIs[0] round
     /* 1564335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564338 */     // MIs[0] policy
     /* 1564338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564348 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1564351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564372 */     // GIR_Coverage, 21049,
     /* 1564372 */     GIR_EraseRootFromParent_Done,
     /* 1564373 */   // Label 21696: @1564373
     /* 1564373 */   GIM_Try, /*On fail goto*//*Label 21697*/ GIMT_Encode4(1564455), // Rule ID 21052 //
     /* 1564378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1564389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1564392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1564395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564417 */     // MIs[0] round
     /* 1564417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564420 */     // MIs[0] policy
     /* 1564420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564430 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1564433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564454 */     // GIR_Coverage, 21052,
     /* 1564454 */     GIR_EraseRootFromParent_Done,
     /* 1564455 */   // Label 21697: @1564455
     /* 1564455 */   GIM_Try, /*On fail goto*//*Label 21698*/ GIMT_Encode4(1564537), // Rule ID 21053 //
     /* 1564460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1564471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1564474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1564477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564499 */     // MIs[0] round
     /* 1564499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564502 */     // MIs[0] policy
     /* 1564502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564512 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1564515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564536 */     // GIR_Coverage, 21053,
     /* 1564536 */     GIR_EraseRootFromParent_Done,
     /* 1564537 */   // Label 21698: @1564537
     /* 1564537 */   GIM_Try, /*On fail goto*//*Label 21699*/ GIMT_Encode4(1564619), // Rule ID 21056 //
     /* 1564542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1564545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1564553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1564556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1564559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564581 */     // MIs[0] round
     /* 1564581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564584 */     // MIs[0] policy
     /* 1564584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564594 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1564597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564618 */     // GIR_Coverage, 21056,
     /* 1564618 */     GIR_EraseRootFromParent_Done,
     /* 1564619 */   // Label 21699: @1564619
     /* 1564619 */   GIM_Try, /*On fail goto*//*Label 21700*/ GIMT_Encode4(1564701), // Rule ID 21057 //
     /* 1564624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1564627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1564635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1564638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1564641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564663 */     // MIs[0] round
     /* 1564663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564666 */     // MIs[0] policy
     /* 1564666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564676 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1564679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564700 */     // GIR_Coverage, 21057,
     /* 1564700 */     GIR_EraseRootFromParent_Done,
     /* 1564701 */   // Label 21700: @1564701
     /* 1564701 */   GIM_Try, /*On fail goto*//*Label 21701*/ GIMT_Encode4(1564783), // Rule ID 21060 //
     /* 1564706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1564709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1564717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1564720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1564723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564745 */     // MIs[0] round
     /* 1564745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564748 */     // MIs[0] policy
     /* 1564748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564758 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1564761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564782 */     // GIR_Coverage, 21060,
     /* 1564782 */     GIR_EraseRootFromParent_Done,
     /* 1564783 */   // Label 21701: @1564783
     /* 1564783 */   GIM_Try, /*On fail goto*//*Label 21702*/ GIMT_Encode4(1564865), // Rule ID 21061 //
     /* 1564788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1564791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1564799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1564802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1564805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564827 */     // MIs[0] round
     /* 1564827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564830 */     // MIs[0] policy
     /* 1564830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564840 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1564843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564864 */     // GIR_Coverage, 21061,
     /* 1564864 */     GIR_EraseRootFromParent_Done,
     /* 1564865 */   // Label 21702: @1564865
     /* 1564865 */   GIM_Try, /*On fail goto*//*Label 21703*/ GIMT_Encode4(1564947), // Rule ID 21064 //
     /* 1564870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1564881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1564884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1564887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564909 */     // MIs[0] round
     /* 1564909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564912 */     // MIs[0] policy
     /* 1564912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564922 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1564925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564946 */     // GIR_Coverage, 21064,
     /* 1564946 */     GIR_EraseRootFromParent_Done,
     /* 1564947 */   // Label 21703: @1564947
     /* 1564947 */   GIM_Try, /*On fail goto*//*Label 21704*/ GIMT_Encode4(1565029), // Rule ID 21065 //
     /* 1564952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1564963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1564966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1564969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564991 */     // MIs[0] round
     /* 1564991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564994 */     // MIs[0] policy
     /* 1564994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565004 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1565007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565028 */     // GIR_Coverage, 21065,
     /* 1565028 */     GIR_EraseRootFromParent_Done,
     /* 1565029 */   // Label 21704: @1565029
     /* 1565029 */   GIM_Try, /*On fail goto*//*Label 21705*/ GIMT_Encode4(1565111), // Rule ID 21068 //
     /* 1565034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1565045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1565048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1565051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565073 */     // MIs[0] round
     /* 1565073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565076 */     // MIs[0] policy
     /* 1565076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565086 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1565089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565110 */     // GIR_Coverage, 21068,
     /* 1565110 */     GIR_EraseRootFromParent_Done,
     /* 1565111 */   // Label 21705: @1565111
     /* 1565111 */   GIM_Try, /*On fail goto*//*Label 21706*/ GIMT_Encode4(1565193), // Rule ID 21069 //
     /* 1565116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1565127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1565130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1565133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565155 */     // MIs[0] round
     /* 1565155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565158 */     // MIs[0] policy
     /* 1565158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565168 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1565171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565192 */     // GIR_Coverage, 21069,
     /* 1565192 */     GIR_EraseRootFromParent_Done,
     /* 1565193 */   // Label 21706: @1565193
     /* 1565193 */   GIM_Try, /*On fail goto*//*Label 21707*/ GIMT_Encode4(1565275), // Rule ID 21072 //
     /* 1565198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1565201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1565209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1565212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1565215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565237 */     // MIs[0] round
     /* 1565237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565240 */     // MIs[0] policy
     /* 1565240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565250 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1565253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565274 */     // GIR_Coverage, 21072,
     /* 1565274 */     GIR_EraseRootFromParent_Done,
     /* 1565275 */   // Label 21707: @1565275
     /* 1565275 */   GIM_Try, /*On fail goto*//*Label 21708*/ GIMT_Encode4(1565357), // Rule ID 21073 //
     /* 1565280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1565283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1565291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1565294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1565297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565319 */     // MIs[0] round
     /* 1565319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565322 */     // MIs[0] policy
     /* 1565322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565332 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1565335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565356 */     // GIR_Coverage, 21073,
     /* 1565356 */     GIR_EraseRootFromParent_Done,
     /* 1565357 */   // Label 21708: @1565357
     /* 1565357 */   GIM_Try, /*On fail goto*//*Label 21709*/ GIMT_Encode4(1565439), // Rule ID 21076 //
     /* 1565362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1565365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1565373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1565376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1565379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565401 */     // MIs[0] round
     /* 1565401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565404 */     // MIs[0] policy
     /* 1565404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565414 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1565417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565438 */     // GIR_Coverage, 21076,
     /* 1565438 */     GIR_EraseRootFromParent_Done,
     /* 1565439 */   // Label 21709: @1565439
     /* 1565439 */   GIM_Try, /*On fail goto*//*Label 21710*/ GIMT_Encode4(1565521), // Rule ID 21077 //
     /* 1565444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1565447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1565455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1565458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1565461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565483 */     // MIs[0] round
     /* 1565483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565486 */     // MIs[0] policy
     /* 1565486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565496 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1565499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565520 */     // GIR_Coverage, 21077,
     /* 1565520 */     GIR_EraseRootFromParent_Done,
     /* 1565521 */   // Label 21710: @1565521
     /* 1565521 */   GIM_Try, /*On fail goto*//*Label 21711*/ GIMT_Encode4(1565603), // Rule ID 21080 //
     /* 1565526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1565537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1565540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1565543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1565546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565565 */     // MIs[0] round
     /* 1565565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565568 */     // MIs[0] policy
     /* 1565568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565578 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1565581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565602 */     // GIR_Coverage, 21080,
     /* 1565602 */     GIR_EraseRootFromParent_Done,
     /* 1565603 */   // Label 21711: @1565603
     /* 1565603 */   GIM_Try, /*On fail goto*//*Label 21712*/ GIMT_Encode4(1565685), // Rule ID 21081 //
     /* 1565608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1565619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1565622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1565625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1565628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565647 */     // MIs[0] round
     /* 1565647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565650 */     // MIs[0] policy
     /* 1565650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565660 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1565663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565684 */     // GIR_Coverage, 21081,
     /* 1565684 */     GIR_EraseRootFromParent_Done,
     /* 1565685 */   // Label 21712: @1565685
     /* 1565685 */   GIM_Try, /*On fail goto*//*Label 21713*/ GIMT_Encode4(1565767), // Rule ID 21084 //
     /* 1565690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1565701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1565704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1565707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1565710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565729 */     // MIs[0] round
     /* 1565729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565732 */     // MIs[0] policy
     /* 1565732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565742 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1565745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565766 */     // GIR_Coverage, 21084,
     /* 1565766 */     GIR_EraseRootFromParent_Done,
     /* 1565767 */   // Label 21713: @1565767
     /* 1565767 */   GIM_Try, /*On fail goto*//*Label 21714*/ GIMT_Encode4(1565849), // Rule ID 21085 //
     /* 1565772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1565783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1565786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1565789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1565792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565811 */     // MIs[0] round
     /* 1565811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565814 */     // MIs[0] policy
     /* 1565814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565824 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1565827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565848 */     // GIR_Coverage, 21085,
     /* 1565848 */     GIR_EraseRootFromParent_Done,
     /* 1565849 */   // Label 21714: @1565849
     /* 1565849 */   GIM_Try, /*On fail goto*//*Label 21715*/ GIMT_Encode4(1565931), // Rule ID 21088 //
     /* 1565854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1565865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1565868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1565871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1565874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1565881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565893 */     // MIs[0] round
     /* 1565893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565896 */     // MIs[0] policy
     /* 1565896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565906 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1565909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565930 */     // GIR_Coverage, 21088,
     /* 1565930 */     GIR_EraseRootFromParent_Done,
     /* 1565931 */   // Label 21715: @1565931
     /* 1565931 */   GIM_Try, /*On fail goto*//*Label 21716*/ GIMT_Encode4(1566013), // Rule ID 21089 //
     /* 1565936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1565947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1565950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1565953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1565956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1565963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565975 */     // MIs[0] round
     /* 1565975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565978 */     // MIs[0] policy
     /* 1565978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565988 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1565991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566012 */     // GIR_Coverage, 21089,
     /* 1566012 */     GIR_EraseRootFromParent_Done,
     /* 1566013 */   // Label 21716: @1566013
     /* 1566013 */   GIM_Try, /*On fail goto*//*Label 21717*/ GIMT_Encode4(1566095), // Rule ID 21092 //
     /* 1566018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1566029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1566032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1566035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566057 */     // MIs[0] round
     /* 1566057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566060 */     // MIs[0] policy
     /* 1566060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566070 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1566073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566094 */     // GIR_Coverage, 21092,
     /* 1566094 */     GIR_EraseRootFromParent_Done,
     /* 1566095 */   // Label 21717: @1566095
     /* 1566095 */   GIM_Try, /*On fail goto*//*Label 21718*/ GIMT_Encode4(1566177), // Rule ID 21093 //
     /* 1566100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1566111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1566114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1566117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566139 */     // MIs[0] round
     /* 1566139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566142 */     // MIs[0] policy
     /* 1566142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566152 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1566155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566176 */     // GIR_Coverage, 21093,
     /* 1566176 */     GIR_EraseRootFromParent_Done,
     /* 1566177 */   // Label 21718: @1566177
     /* 1566177 */   GIM_Try, /*On fail goto*//*Label 21719*/ GIMT_Encode4(1566259), // Rule ID 21096 //
     /* 1566182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1566193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1566196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1566199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566221 */     // MIs[0] round
     /* 1566221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566224 */     // MIs[0] policy
     /* 1566224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566234 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1566237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566258 */     // GIR_Coverage, 21096,
     /* 1566258 */     GIR_EraseRootFromParent_Done,
     /* 1566259 */   // Label 21719: @1566259
     /* 1566259 */   GIM_Try, /*On fail goto*//*Label 21720*/ GIMT_Encode4(1566341), // Rule ID 21097 //
     /* 1566264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1566275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1566278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1566281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566303 */     // MIs[0] round
     /* 1566303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566306 */     // MIs[0] policy
     /* 1566306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566316 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1566319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566340 */     // GIR_Coverage, 21097,
     /* 1566340 */     GIR_EraseRootFromParent_Done,
     /* 1566341 */   // Label 21720: @1566341
     /* 1566341 */   GIM_Try, /*On fail goto*//*Label 21721*/ GIMT_Encode4(1566423), // Rule ID 21100 //
     /* 1566346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1566357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1566360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1566363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566385 */     // MIs[0] round
     /* 1566385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566388 */     // MIs[0] policy
     /* 1566388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566398 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1566401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566422 */     // GIR_Coverage, 21100,
     /* 1566422 */     GIR_EraseRootFromParent_Done,
     /* 1566423 */   // Label 21721: @1566423
     /* 1566423 */   GIM_Try, /*On fail goto*//*Label 21722*/ GIMT_Encode4(1566505), // Rule ID 21101 //
     /* 1566428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1566439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1566442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1566445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566467 */     // MIs[0] round
     /* 1566467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566470 */     // MIs[0] policy
     /* 1566470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566480 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1566483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566504 */     // GIR_Coverage, 21101,
     /* 1566504 */     GIR_EraseRootFromParent_Done,
     /* 1566505 */   // Label 21722: @1566505
     /* 1566505 */   GIM_Try, /*On fail goto*//*Label 21723*/ GIMT_Encode4(1566587), // Rule ID 21104 //
     /* 1566510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1566513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1566521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1566524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1566527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566549 */     // MIs[0] round
     /* 1566549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566552 */     // MIs[0] policy
     /* 1566552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566562 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1566565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566571 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566586 */     // GIR_Coverage, 21104,
     /* 1566586 */     GIR_EraseRootFromParent_Done,
     /* 1566587 */   // Label 21723: @1566587
     /* 1566587 */   GIM_Try, /*On fail goto*//*Label 21724*/ GIMT_Encode4(1566669), // Rule ID 21105 //
     /* 1566592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1566595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1566603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1566606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1566609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566631 */     // MIs[0] round
     /* 1566631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566634 */     // MIs[0] policy
     /* 1566634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566644 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1566647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566668 */     // GIR_Coverage, 21105,
     /* 1566668 */     GIR_EraseRootFromParent_Done,
     /* 1566669 */   // Label 21724: @1566669
     /* 1566669 */   GIM_Try, /*On fail goto*//*Label 21725*/ GIMT_Encode4(1566751), // Rule ID 21108 //
     /* 1566674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1566677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1566685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1566688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1566691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566713 */     // MIs[0] round
     /* 1566713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566716 */     // MIs[0] policy
     /* 1566716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566726 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1566729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566750 */     // GIR_Coverage, 21108,
     /* 1566750 */     GIR_EraseRootFromParent_Done,
     /* 1566751 */   // Label 21725: @1566751
     /* 1566751 */   GIM_Try, /*On fail goto*//*Label 21726*/ GIMT_Encode4(1566833), // Rule ID 21109 //
     /* 1566756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1566759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1566767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1566770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1566773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566795 */     // MIs[0] round
     /* 1566795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566798 */     // MIs[0] policy
     /* 1566798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566808 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1566811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566832 */     // GIR_Coverage, 21109,
     /* 1566832 */     GIR_EraseRootFromParent_Done,
     /* 1566833 */   // Label 21726: @1566833
     /* 1566833 */   GIM_Try, /*On fail goto*//*Label 21727*/ GIMT_Encode4(1566915), // Rule ID 21112 //
     /* 1566838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1566841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1566849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1566852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1566855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566877 */     // MIs[0] round
     /* 1566877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566880 */     // MIs[0] policy
     /* 1566880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566890 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1566893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566914 */     // GIR_Coverage, 21112,
     /* 1566914 */     GIR_EraseRootFromParent_Done,
     /* 1566915 */   // Label 21727: @1566915
     /* 1566915 */   GIM_Try, /*On fail goto*//*Label 21728*/ GIMT_Encode4(1566997), // Rule ID 21113 //
     /* 1566920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1566923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1566931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1566934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1566937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566959 */     // MIs[0] round
     /* 1566959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566962 */     // MIs[0] policy
     /* 1566962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566972 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1566975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566996 */     // GIR_Coverage, 21113,
     /* 1566996 */     GIR_EraseRootFromParent_Done,
     /* 1566997 */   // Label 21728: @1566997
     /* 1566997 */   GIM_Try, /*On fail goto*//*Label 21729*/ GIMT_Encode4(1567079), // Rule ID 21188 //
     /* 1567002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1567013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1567016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1567019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567041 */     // MIs[0] round
     /* 1567041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567044 */     // MIs[0] policy
     /* 1567044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1567057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567078 */     // GIR_Coverage, 21188,
     /* 1567078 */     GIR_EraseRootFromParent_Done,
     /* 1567079 */   // Label 21729: @1567079
     /* 1567079 */   GIM_Try, /*On fail goto*//*Label 21730*/ GIMT_Encode4(1567161), // Rule ID 21189 //
     /* 1567084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1567095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1567098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1567101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567123 */     // MIs[0] round
     /* 1567123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567126 */     // MIs[0] policy
     /* 1567126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567136 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1567139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567160 */     // GIR_Coverage, 21189,
     /* 1567160 */     GIR_EraseRootFromParent_Done,
     /* 1567161 */   // Label 21730: @1567161
     /* 1567161 */   GIM_Try, /*On fail goto*//*Label 21731*/ GIMT_Encode4(1567243), // Rule ID 21192 //
     /* 1567166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1567177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1567180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1567183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567205 */     // MIs[0] round
     /* 1567205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567208 */     // MIs[0] policy
     /* 1567208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1567221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567242 */     // GIR_Coverage, 21192,
     /* 1567242 */     GIR_EraseRootFromParent_Done,
     /* 1567243 */   // Label 21731: @1567243
     /* 1567243 */   GIM_Try, /*On fail goto*//*Label 21732*/ GIMT_Encode4(1567325), // Rule ID 21193 //
     /* 1567248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1567259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1567262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1567265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567287 */     // MIs[0] round
     /* 1567287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567290 */     // MIs[0] policy
     /* 1567290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1567303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567324 */     // GIR_Coverage, 21193,
     /* 1567324 */     GIR_EraseRootFromParent_Done,
     /* 1567325 */   // Label 21732: @1567325
     /* 1567325 */   GIM_Try, /*On fail goto*//*Label 21733*/ GIMT_Encode4(1567407), // Rule ID 21196 //
     /* 1567330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1567341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1567344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1567347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567369 */     // MIs[0] round
     /* 1567369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567372 */     // MIs[0] policy
     /* 1567372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1567385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567406 */     // GIR_Coverage, 21196,
     /* 1567406 */     GIR_EraseRootFromParent_Done,
     /* 1567407 */   // Label 21733: @1567407
     /* 1567407 */   GIM_Try, /*On fail goto*//*Label 21734*/ GIMT_Encode4(1567489), // Rule ID 21197 //
     /* 1567412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1567423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1567426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1567429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567451 */     // MIs[0] round
     /* 1567451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567454 */     // MIs[0] policy
     /* 1567454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1567467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567488 */     // GIR_Coverage, 21197,
     /* 1567488 */     GIR_EraseRootFromParent_Done,
     /* 1567489 */   // Label 21734: @1567489
     /* 1567489 */   GIM_Try, /*On fail goto*//*Label 21735*/ GIMT_Encode4(1567571), // Rule ID 21200 //
     /* 1567494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1567505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1567508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1567511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567533 */     // MIs[0] round
     /* 1567533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567536 */     // MIs[0] policy
     /* 1567536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1567549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567570 */     // GIR_Coverage, 21200,
     /* 1567570 */     GIR_EraseRootFromParent_Done,
     /* 1567571 */   // Label 21735: @1567571
     /* 1567571 */   GIM_Try, /*On fail goto*//*Label 21736*/ GIMT_Encode4(1567653), // Rule ID 21201 //
     /* 1567576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1567587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1567590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1567593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567615 */     // MIs[0] round
     /* 1567615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567618 */     // MIs[0] policy
     /* 1567618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567628 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1567631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567652 */     // GIR_Coverage, 21201,
     /* 1567652 */     GIR_EraseRootFromParent_Done,
     /* 1567653 */   // Label 21736: @1567653
     /* 1567653 */   GIM_Try, /*On fail goto*//*Label 21737*/ GIMT_Encode4(1567735), // Rule ID 21204 //
     /* 1567658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1567669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1567672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1567675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1567678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567697 */     // MIs[0] round
     /* 1567697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567700 */     // MIs[0] policy
     /* 1567700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567710 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1567713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567734 */     // GIR_Coverage, 21204,
     /* 1567734 */     GIR_EraseRootFromParent_Done,
     /* 1567735 */   // Label 21737: @1567735
     /* 1567735 */   GIM_Try, /*On fail goto*//*Label 21738*/ GIMT_Encode4(1567817), // Rule ID 21205 //
     /* 1567740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1567751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1567754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1567757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1567760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567779 */     // MIs[0] round
     /* 1567779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567782 */     // MIs[0] policy
     /* 1567782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567792 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1567795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567816 */     // GIR_Coverage, 21205,
     /* 1567816 */     GIR_EraseRootFromParent_Done,
     /* 1567817 */   // Label 21738: @1567817
     /* 1567817 */   GIM_Try, /*On fail goto*//*Label 21739*/ GIMT_Encode4(1567899), // Rule ID 21208 //
     /* 1567822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1567825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1567833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1567836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1567839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567861 */     // MIs[0] round
     /* 1567861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567864 */     // MIs[0] policy
     /* 1567864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567874 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1567877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567883 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567898 */     // GIR_Coverage, 21208,
     /* 1567898 */     GIR_EraseRootFromParent_Done,
     /* 1567899 */   // Label 21739: @1567899
     /* 1567899 */   GIM_Try, /*On fail goto*//*Label 21740*/ GIMT_Encode4(1567981), // Rule ID 21209 //
     /* 1567904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1567907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1567915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1567918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1567921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567943 */     // MIs[0] round
     /* 1567943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567946 */     // MIs[0] policy
     /* 1567946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567956 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1567959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567980 */     // GIR_Coverage, 21209,
     /* 1567980 */     GIR_EraseRootFromParent_Done,
     /* 1567981 */   // Label 21740: @1567981
     /* 1567981 */   GIM_Try, /*On fail goto*//*Label 21741*/ GIMT_Encode4(1568063), // Rule ID 21212 //
     /* 1567986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1567989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1567997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1568000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1568003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568025 */     // MIs[0] round
     /* 1568025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568028 */     // MIs[0] policy
     /* 1568028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568038 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1568041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568062 */     // GIR_Coverage, 21212,
     /* 1568062 */     GIR_EraseRootFromParent_Done,
     /* 1568063 */   // Label 21741: @1568063
     /* 1568063 */   GIM_Try, /*On fail goto*//*Label 21742*/ GIMT_Encode4(1568145), // Rule ID 21213 //
     /* 1568068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1568079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1568082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1568085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568107 */     // MIs[0] round
     /* 1568107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568110 */     // MIs[0] policy
     /* 1568110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568120 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1568123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568144 */     // GIR_Coverage, 21213,
     /* 1568144 */     GIR_EraseRootFromParent_Done,
     /* 1568145 */   // Label 21742: @1568145
     /* 1568145 */   GIM_Try, /*On fail goto*//*Label 21743*/ GIMT_Encode4(1568227), // Rule ID 21216 //
     /* 1568150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1568153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1568161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1568164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1568167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568189 */     // MIs[0] round
     /* 1568189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568192 */     // MIs[0] policy
     /* 1568192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568202 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1568205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568226 */     // GIR_Coverage, 21216,
     /* 1568226 */     GIR_EraseRootFromParent_Done,
     /* 1568227 */   // Label 21743: @1568227
     /* 1568227 */   GIM_Try, /*On fail goto*//*Label 21744*/ GIMT_Encode4(1568309), // Rule ID 21217 //
     /* 1568232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1568243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1568246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1568249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568271 */     // MIs[0] round
     /* 1568271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568274 */     // MIs[0] policy
     /* 1568274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568284 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1568287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568308 */     // GIR_Coverage, 21217,
     /* 1568308 */     GIR_EraseRootFromParent_Done,
     /* 1568309 */   // Label 21744: @1568309
     /* 1568309 */   GIM_Try, /*On fail goto*//*Label 21745*/ GIMT_Encode4(1568391), // Rule ID 21220 //
     /* 1568314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1568317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1568325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1568328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1568331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568353 */     // MIs[0] round
     /* 1568353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568356 */     // MIs[0] policy
     /* 1568356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568366 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1568369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568390 */     // GIR_Coverage, 21220,
     /* 1568390 */     GIR_EraseRootFromParent_Done,
     /* 1568391 */   // Label 21745: @1568391
     /* 1568391 */   GIM_Try, /*On fail goto*//*Label 21746*/ GIMT_Encode4(1568473), // Rule ID 21221 //
     /* 1568396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1568407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1568410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1568413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568435 */     // MIs[0] round
     /* 1568435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568438 */     // MIs[0] policy
     /* 1568438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568448 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1568451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568472 */     // GIR_Coverage, 21221,
     /* 1568472 */     GIR_EraseRootFromParent_Done,
     /* 1568473 */   // Label 21746: @1568473
     /* 1568473 */   GIM_Try, /*On fail goto*//*Label 21747*/ GIMT_Encode4(1568555), // Rule ID 21224 //
     /* 1568478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1568489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1568492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1568495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568517 */     // MIs[0] round
     /* 1568517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568520 */     // MIs[0] policy
     /* 1568520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568530 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1568533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568554 */     // GIR_Coverage, 21224,
     /* 1568554 */     GIR_EraseRootFromParent_Done,
     /* 1568555 */   // Label 21747: @1568555
     /* 1568555 */   GIM_Try, /*On fail goto*//*Label 21748*/ GIMT_Encode4(1568637), // Rule ID 21225 //
     /* 1568560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1568571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1568574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1568577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568599 */     // MIs[0] round
     /* 1568599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568602 */     // MIs[0] policy
     /* 1568602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568612 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1568615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568636 */     // GIR_Coverage, 21225,
     /* 1568636 */     GIR_EraseRootFromParent_Done,
     /* 1568637 */   // Label 21748: @1568637
     /* 1568637 */   GIM_Try, /*On fail goto*//*Label 21749*/ GIMT_Encode4(1568719), // Rule ID 21228 //
     /* 1568642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1568653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1568656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1568659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568681 */     // MIs[0] round
     /* 1568681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568684 */     // MIs[0] policy
     /* 1568684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568694 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1568697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568718 */     // GIR_Coverage, 21228,
     /* 1568718 */     GIR_EraseRootFromParent_Done,
     /* 1568719 */   // Label 21749: @1568719
     /* 1568719 */   GIM_Try, /*On fail goto*//*Label 21750*/ GIMT_Encode4(1568801), // Rule ID 21229 //
     /* 1568724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1568735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1568738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1568741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568763 */     // MIs[0] round
     /* 1568763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568766 */     // MIs[0] policy
     /* 1568766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568776 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1568779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568800 */     // GIR_Coverage, 21229,
     /* 1568800 */     GIR_EraseRootFromParent_Done,
     /* 1568801 */   // Label 21750: @1568801
     /* 1568801 */   GIM_Try, /*On fail goto*//*Label 21751*/ GIMT_Encode4(1568883), // Rule ID 21232 //
     /* 1568806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1568817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1568820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1568823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568845 */     // MIs[0] round
     /* 1568845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568848 */     // MIs[0] policy
     /* 1568848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568858 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1568861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568882 */     // GIR_Coverage, 21232,
     /* 1568882 */     GIR_EraseRootFromParent_Done,
     /* 1568883 */   // Label 21751: @1568883
     /* 1568883 */   GIM_Try, /*On fail goto*//*Label 21752*/ GIMT_Encode4(1568965), // Rule ID 21233 //
     /* 1568888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1568899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1568902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1568905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568927 */     // MIs[0] round
     /* 1568927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568930 */     // MIs[0] policy
     /* 1568930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1568943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568964 */     // GIR_Coverage, 21233,
     /* 1568964 */     GIR_EraseRootFromParent_Done,
     /* 1568965 */   // Label 21752: @1568965
     /* 1568965 */   GIM_Try, /*On fail goto*//*Label 21753*/ GIMT_Encode4(1569047), // Rule ID 21236 //
     /* 1568970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1568981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1568984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1568987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569009 */     // MIs[0] round
     /* 1569009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569012 */     // MIs[0] policy
     /* 1569012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569022 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1569025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569046 */     // GIR_Coverage, 21236,
     /* 1569046 */     GIR_EraseRootFromParent_Done,
     /* 1569047 */   // Label 21753: @1569047
     /* 1569047 */   GIM_Try, /*On fail goto*//*Label 21754*/ GIMT_Encode4(1569129), // Rule ID 21237 //
     /* 1569052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1569063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1569066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1569069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569091 */     // MIs[0] round
     /* 1569091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569094 */     // MIs[0] policy
     /* 1569094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569104 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1569107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569128 */     // GIR_Coverage, 21237,
     /* 1569128 */     GIR_EraseRootFromParent_Done,
     /* 1569129 */   // Label 21754: @1569129
     /* 1569129 */   GIM_Try, /*On fail goto*//*Label 21755*/ GIMT_Encode4(1569211), // Rule ID 21240 //
     /* 1569134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1569145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1569148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1569151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1569154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569173 */     // MIs[0] round
     /* 1569173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569176 */     // MIs[0] policy
     /* 1569176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1569189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569195 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569210 */     // GIR_Coverage, 21240,
     /* 1569210 */     GIR_EraseRootFromParent_Done,
     /* 1569211 */   // Label 21755: @1569211
     /* 1569211 */   GIM_Try, /*On fail goto*//*Label 21756*/ GIMT_Encode4(1569293), // Rule ID 21241 //
     /* 1569216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1569227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1569230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1569233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1569236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569255 */     // MIs[0] round
     /* 1569255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569258 */     // MIs[0] policy
     /* 1569258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569268 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1569271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569292 */     // GIR_Coverage, 21241,
     /* 1569292 */     GIR_EraseRootFromParent_Done,
     /* 1569293 */   // Label 21756: @1569293
     /* 1569293 */   GIM_Try, /*On fail goto*//*Label 21757*/ GIMT_Encode4(1569375), // Rule ID 21244 //
     /* 1569298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1569309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1569312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1569315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569337 */     // MIs[0] round
     /* 1569337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569340 */     // MIs[0] policy
     /* 1569340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569350 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1569353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569374 */     // GIR_Coverage, 21244,
     /* 1569374 */     GIR_EraseRootFromParent_Done,
     /* 1569375 */   // Label 21757: @1569375
     /* 1569375 */   GIM_Try, /*On fail goto*//*Label 21758*/ GIMT_Encode4(1569457), // Rule ID 21245 //
     /* 1569380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1569391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1569394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1569397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569419 */     // MIs[0] round
     /* 1569419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569422 */     // MIs[0] policy
     /* 1569422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569432 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1569435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569456 */     // GIR_Coverage, 21245,
     /* 1569456 */     GIR_EraseRootFromParent_Done,
     /* 1569457 */   // Label 21758: @1569457
     /* 1569457 */   GIM_Try, /*On fail goto*//*Label 21759*/ GIMT_Encode4(1569539), // Rule ID 21248 //
     /* 1569462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1569473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1569476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1569479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569501 */     // MIs[0] round
     /* 1569501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569504 */     // MIs[0] policy
     /* 1569504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569514 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1569517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569538 */     // GIR_Coverage, 21248,
     /* 1569538 */     GIR_EraseRootFromParent_Done,
     /* 1569539 */   // Label 21759: @1569539
     /* 1569539 */   GIM_Try, /*On fail goto*//*Label 21760*/ GIMT_Encode4(1569621), // Rule ID 21249 //
     /* 1569544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1569555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1569558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1569561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569583 */     // MIs[0] round
     /* 1569583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569586 */     // MIs[0] policy
     /* 1569586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1569599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569620 */     // GIR_Coverage, 21249,
     /* 1569620 */     GIR_EraseRootFromParent_Done,
     /* 1569621 */   // Label 21760: @1569621
     /* 1569621 */   GIM_Try, /*On fail goto*//*Label 21761*/ GIMT_Encode4(1569703), // Rule ID 21252 //
     /* 1569626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1569637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1569640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1569643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569665 */     // MIs[0] round
     /* 1569665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569668 */     // MIs[0] policy
     /* 1569668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569678 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1569681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569702 */     // GIR_Coverage, 21252,
     /* 1569702 */     GIR_EraseRootFromParent_Done,
     /* 1569703 */   // Label 21761: @1569703
     /* 1569703 */   GIM_Try, /*On fail goto*//*Label 21762*/ GIMT_Encode4(1569785), // Rule ID 21253 //
     /* 1569708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1569719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1569722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1569725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569747 */     // MIs[0] round
     /* 1569747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569750 */     // MIs[0] policy
     /* 1569750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569760 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1569763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569784 */     // GIR_Coverage, 21253,
     /* 1569784 */     GIR_EraseRootFromParent_Done,
     /* 1569785 */   // Label 21762: @1569785
     /* 1569785 */   GIM_Try, /*On fail goto*//*Label 21763*/ GIMT_Encode4(1569867), // Rule ID 21256 //
     /* 1569790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1569801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1569804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1569807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569829 */     // MIs[0] round
     /* 1569829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569832 */     // MIs[0] policy
     /* 1569832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569842 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1569845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569866 */     // GIR_Coverage, 21256,
     /* 1569866 */     GIR_EraseRootFromParent_Done,
     /* 1569867 */   // Label 21763: @1569867
     /* 1569867 */   GIM_Try, /*On fail goto*//*Label 21764*/ GIMT_Encode4(1569949), // Rule ID 21257 //
     /* 1569872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1569883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1569886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1569889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569911 */     // MIs[0] round
     /* 1569911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569914 */     // MIs[0] policy
     /* 1569914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569924 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1569927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569948 */     // GIR_Coverage, 21257,
     /* 1569948 */     GIR_EraseRootFromParent_Done,
     /* 1569949 */   // Label 21764: @1569949
     /* 1569949 */   GIM_Try, /*On fail goto*//*Label 21765*/ GIMT_Encode4(1570031), // Rule ID 21608 //
     /* 1569954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1569965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1569968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1569971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569993 */     // MIs[0] round
     /* 1569993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569996 */     // MIs[0] policy
     /* 1569996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570006 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1570009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570030 */     // GIR_Coverage, 21608,
     /* 1570030 */     GIR_EraseRootFromParent_Done,
     /* 1570031 */   // Label 21765: @1570031
     /* 1570031 */   GIM_Try, /*On fail goto*//*Label 21766*/ GIMT_Encode4(1570113), // Rule ID 21609 //
     /* 1570036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1570047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1570050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1570053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570075 */     // MIs[0] round
     /* 1570075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570078 */     // MIs[0] policy
     /* 1570078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570088 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1570091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570099 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570112 */     // GIR_Coverage, 21609,
     /* 1570112 */     GIR_EraseRootFromParent_Done,
     /* 1570113 */   // Label 21766: @1570113
     /* 1570113 */   GIM_Try, /*On fail goto*//*Label 21767*/ GIMT_Encode4(1570195), // Rule ID 21612 //
     /* 1570118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1570129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1570132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1570135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570157 */     // MIs[0] round
     /* 1570157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570160 */     // MIs[0] policy
     /* 1570160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570170 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1570173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570179 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570194 */     // GIR_Coverage, 21612,
     /* 1570194 */     GIR_EraseRootFromParent_Done,
     /* 1570195 */   // Label 21767: @1570195
     /* 1570195 */   GIM_Try, /*On fail goto*//*Label 21768*/ GIMT_Encode4(1570277), // Rule ID 21613 //
     /* 1570200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1570211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1570214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1570217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570239 */     // MIs[0] round
     /* 1570239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570242 */     // MIs[0] policy
     /* 1570242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570252 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1570255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570276 */     // GIR_Coverage, 21613,
     /* 1570276 */     GIR_EraseRootFromParent_Done,
     /* 1570277 */   // Label 21768: @1570277
     /* 1570277 */   GIM_Try, /*On fail goto*//*Label 21769*/ GIMT_Encode4(1570359), // Rule ID 21616 //
     /* 1570282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1570293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1570296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1570299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570321 */     // MIs[0] round
     /* 1570321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570324 */     // MIs[0] policy
     /* 1570324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570334 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1570337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570343 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570358 */     // GIR_Coverage, 21616,
     /* 1570358 */     GIR_EraseRootFromParent_Done,
     /* 1570359 */   // Label 21769: @1570359
     /* 1570359 */   GIM_Try, /*On fail goto*//*Label 21770*/ GIMT_Encode4(1570441), // Rule ID 21617 //
     /* 1570364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1570375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1570378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1570381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570403 */     // MIs[0] round
     /* 1570403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570406 */     // MIs[0] policy
     /* 1570406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570416 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1570419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570440 */     // GIR_Coverage, 21617,
     /* 1570440 */     GIR_EraseRootFromParent_Done,
     /* 1570441 */   // Label 21770: @1570441
     /* 1570441 */   GIM_Try, /*On fail goto*//*Label 21771*/ GIMT_Encode4(1570523), // Rule ID 21620 //
     /* 1570446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1570457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1570460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1570463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570485 */     // MIs[0] round
     /* 1570485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570488 */     // MIs[0] policy
     /* 1570488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570498 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1570501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570522 */     // GIR_Coverage, 21620,
     /* 1570522 */     GIR_EraseRootFromParent_Done,
     /* 1570523 */   // Label 21771: @1570523
     /* 1570523 */   GIM_Try, /*On fail goto*//*Label 21772*/ GIMT_Encode4(1570605), // Rule ID 21621 //
     /* 1570528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1570539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1570542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1570545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570567 */     // MIs[0] round
     /* 1570567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570570 */     // MIs[0] policy
     /* 1570570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570580 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1570583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570604 */     // GIR_Coverage, 21621,
     /* 1570604 */     GIR_EraseRootFromParent_Done,
     /* 1570605 */   // Label 21772: @1570605
     /* 1570605 */   GIM_Try, /*On fail goto*//*Label 21773*/ GIMT_Encode4(1570687), // Rule ID 21624 //
     /* 1570610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1570621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1570624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1570627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1570630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570649 */     // MIs[0] round
     /* 1570649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570652 */     // MIs[0] policy
     /* 1570652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570662 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1570665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570686 */     // GIR_Coverage, 21624,
     /* 1570686 */     GIR_EraseRootFromParent_Done,
     /* 1570687 */   // Label 21773: @1570687
     /* 1570687 */   GIM_Try, /*On fail goto*//*Label 21774*/ GIMT_Encode4(1570769), // Rule ID 21625 //
     /* 1570692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1570703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1570706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1570709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1570712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570731 */     // MIs[0] round
     /* 1570731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570734 */     // MIs[0] policy
     /* 1570734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570744 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1570747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570768 */     // GIR_Coverage, 21625,
     /* 1570768 */     GIR_EraseRootFromParent_Done,
     /* 1570769 */   // Label 21774: @1570769
     /* 1570769 */   GIM_Try, /*On fail goto*//*Label 21775*/ GIMT_Encode4(1570851), // Rule ID 21628 //
     /* 1570774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1570785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1570788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1570791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1570794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570813 */     // MIs[0] round
     /* 1570813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570816 */     // MIs[0] policy
     /* 1570816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570826 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1570829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570850 */     // GIR_Coverage, 21628,
     /* 1570850 */     GIR_EraseRootFromParent_Done,
     /* 1570851 */   // Label 21775: @1570851
     /* 1570851 */   GIM_Try, /*On fail goto*//*Label 21776*/ GIMT_Encode4(1570933), // Rule ID 21629 //
     /* 1570856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1570867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1570870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1570873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1570876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570895 */     // MIs[0] round
     /* 1570895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570898 */     // MIs[0] policy
     /* 1570898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570908 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1570911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570932 */     // GIR_Coverage, 21629,
     /* 1570932 */     GIR_EraseRootFromParent_Done,
     /* 1570933 */   // Label 21776: @1570933
     /* 1570933 */   GIM_Try, /*On fail goto*//*Label 21777*/ GIMT_Encode4(1571015), // Rule ID 21632 //
     /* 1570938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1570941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1570949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1570952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1570955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570977 */     // MIs[0] round
     /* 1570977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570980 */     // MIs[0] policy
     /* 1570980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570990 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1570993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571014 */     // GIR_Coverage, 21632,
     /* 1571014 */     GIR_EraseRootFromParent_Done,
     /* 1571015 */   // Label 21777: @1571015
     /* 1571015 */   GIM_Try, /*On fail goto*//*Label 21778*/ GIMT_Encode4(1571097), // Rule ID 21633 //
     /* 1571020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1571031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1571034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1571037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571059 */     // MIs[0] round
     /* 1571059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571062 */     // MIs[0] policy
     /* 1571062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571072 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1571075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571096 */     // GIR_Coverage, 21633,
     /* 1571096 */     GIR_EraseRootFromParent_Done,
     /* 1571097 */   // Label 21778: @1571097
     /* 1571097 */   GIM_Try, /*On fail goto*//*Label 21779*/ GIMT_Encode4(1571179), // Rule ID 21636 //
     /* 1571102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1571113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1571116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1571119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571141 */     // MIs[0] round
     /* 1571141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571144 */     // MIs[0] policy
     /* 1571144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571154 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1571157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571178 */     // GIR_Coverage, 21636,
     /* 1571178 */     GIR_EraseRootFromParent_Done,
     /* 1571179 */   // Label 21779: @1571179
     /* 1571179 */   GIM_Try, /*On fail goto*//*Label 21780*/ GIMT_Encode4(1571261), // Rule ID 21637 //
     /* 1571184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1571195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1571198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1571201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571223 */     // MIs[0] round
     /* 1571223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571226 */     // MIs[0] policy
     /* 1571226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571236 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1571239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571260 */     // GIR_Coverage, 21637,
     /* 1571260 */     GIR_EraseRootFromParent_Done,
     /* 1571261 */   // Label 21780: @1571261
     /* 1571261 */   GIM_Try, /*On fail goto*//*Label 21781*/ GIMT_Encode4(1571343), // Rule ID 21640 //
     /* 1571266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1571277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1571280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1571283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571305 */     // MIs[0] round
     /* 1571305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571308 */     // MIs[0] policy
     /* 1571308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1571321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571342 */     // GIR_Coverage, 21640,
     /* 1571342 */     GIR_EraseRootFromParent_Done,
     /* 1571343 */   // Label 21781: @1571343
     /* 1571343 */   GIM_Try, /*On fail goto*//*Label 21782*/ GIMT_Encode4(1571425), // Rule ID 21641 //
     /* 1571348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1571359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1571362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1571365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571387 */     // MIs[0] round
     /* 1571387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571390 */     // MIs[0] policy
     /* 1571390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1571403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571424 */     // GIR_Coverage, 21641,
     /* 1571424 */     GIR_EraseRootFromParent_Done,
     /* 1571425 */   // Label 21782: @1571425
     /* 1571425 */   GIM_Try, /*On fail goto*//*Label 21783*/ GIMT_Encode4(1571507), // Rule ID 21644 //
     /* 1571430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1571441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1571444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1571447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571469 */     // MIs[0] round
     /* 1571469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571472 */     // MIs[0] policy
     /* 1571472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1571485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571491 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571506 */     // GIR_Coverage, 21644,
     /* 1571506 */     GIR_EraseRootFromParent_Done,
     /* 1571507 */   // Label 21783: @1571507
     /* 1571507 */   GIM_Try, /*On fail goto*//*Label 21784*/ GIMT_Encode4(1571589), // Rule ID 21645 //
     /* 1571512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1571523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1571526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1571529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571551 */     // MIs[0] round
     /* 1571551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571554 */     // MIs[0] policy
     /* 1571554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571564 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1571567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571588 */     // GIR_Coverage, 21645,
     /* 1571588 */     GIR_EraseRootFromParent_Done,
     /* 1571589 */   // Label 21784: @1571589
     /* 1571589 */   GIM_Try, /*On fail goto*//*Label 21785*/ GIMT_Encode4(1571671), // Rule ID 21648 //
     /* 1571594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1571605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1571608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1571611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1571614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571633 */     // MIs[0] round
     /* 1571633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571636 */     // MIs[0] policy
     /* 1571636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571646 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1571649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571670 */     // GIR_Coverage, 21648,
     /* 1571670 */     GIR_EraseRootFromParent_Done,
     /* 1571671 */   // Label 21785: @1571671
     /* 1571671 */   GIM_Try, /*On fail goto*//*Label 21786*/ GIMT_Encode4(1571753), // Rule ID 21649 //
     /* 1571676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1571687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1571690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1571693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1571696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571715 */     // MIs[0] round
     /* 1571715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571718 */     // MIs[0] policy
     /* 1571718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571728 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1571731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571739 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571752 */     // GIR_Coverage, 21649,
     /* 1571752 */     GIR_EraseRootFromParent_Done,
     /* 1571753 */   // Label 21786: @1571753
     /* 1571753 */   GIM_Try, /*On fail goto*//*Label 21787*/ GIMT_Encode4(1571835), // Rule ID 21652 //
     /* 1571758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1571761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1571769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1571772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1571775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571797 */     // MIs[0] round
     /* 1571797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571800 */     // MIs[0] policy
     /* 1571800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571810 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1571813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571834 */     // GIR_Coverage, 21652,
     /* 1571834 */     GIR_EraseRootFromParent_Done,
     /* 1571835 */   // Label 21787: @1571835
     /* 1571835 */   GIM_Try, /*On fail goto*//*Label 21788*/ GIMT_Encode4(1571917), // Rule ID 21653 //
     /* 1571840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1571843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1571851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1571854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1571857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571879 */     // MIs[0] round
     /* 1571879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571882 */     // MIs[0] policy
     /* 1571882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571892 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1571895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571916 */     // GIR_Coverage, 21653,
     /* 1571916 */     GIR_EraseRootFromParent_Done,
     /* 1571917 */   // Label 21788: @1571917
     /* 1571917 */   GIM_Try, /*On fail goto*//*Label 21789*/ GIMT_Encode4(1571999), // Rule ID 21656 //
     /* 1571922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1571925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1571933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1571936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1571939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571961 */     // MIs[0] round
     /* 1571961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571964 */     // MIs[0] policy
     /* 1571964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1571977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571998 */     // GIR_Coverage, 21656,
     /* 1571998 */     GIR_EraseRootFromParent_Done,
     /* 1571999 */   // Label 21789: @1571999
     /* 1571999 */   GIM_Try, /*On fail goto*//*Label 21790*/ GIMT_Encode4(1572081), // Rule ID 21657 //
     /* 1572004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1572015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1572018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1572021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572043 */     // MIs[0] round
     /* 1572043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572046 */     // MIs[0] policy
     /* 1572046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572056 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1572059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572080 */     // GIR_Coverage, 21657,
     /* 1572080 */     GIR_EraseRootFromParent_Done,
     /* 1572081 */   // Label 21790: @1572081
     /* 1572081 */   GIM_Try, /*On fail goto*//*Label 21791*/ GIMT_Encode4(1572163), // Rule ID 21660 //
     /* 1572086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1572097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1572100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1572103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572125 */     // MIs[0] round
     /* 1572125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572128 */     // MIs[0] policy
     /* 1572128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572138 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1572141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572162 */     // GIR_Coverage, 21660,
     /* 1572162 */     GIR_EraseRootFromParent_Done,
     /* 1572163 */   // Label 21791: @1572163
     /* 1572163 */   GIM_Try, /*On fail goto*//*Label 21792*/ GIMT_Encode4(1572245), // Rule ID 21661 //
     /* 1572168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1572179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1572182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1572185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572207 */     // MIs[0] round
     /* 1572207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572210 */     // MIs[0] policy
     /* 1572210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572220 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1572223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572244 */     // GIR_Coverage, 21661,
     /* 1572244 */     GIR_EraseRootFromParent_Done,
     /* 1572245 */   // Label 21792: @1572245
     /* 1572245 */   GIM_Try, /*On fail goto*//*Label 21793*/ GIMT_Encode4(1572327), // Rule ID 21664 //
     /* 1572250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1572261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1572264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1572267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572289 */     // MIs[0] round
     /* 1572289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572292 */     // MIs[0] policy
     /* 1572292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1572305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572326 */     // GIR_Coverage, 21664,
     /* 1572326 */     GIR_EraseRootFromParent_Done,
     /* 1572327 */   // Label 21793: @1572327
     /* 1572327 */   GIM_Try, /*On fail goto*//*Label 21794*/ GIMT_Encode4(1572409), // Rule ID 21665 //
     /* 1572332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1572343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1572346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1572349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572371 */     // MIs[0] round
     /* 1572371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572374 */     // MIs[0] policy
     /* 1572374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572384 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1572387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572408 */     // GIR_Coverage, 21665,
     /* 1572408 */     GIR_EraseRootFromParent_Done,
     /* 1572409 */   // Label 21794: @1572409
     /* 1572409 */   GIM_Try, /*On fail goto*//*Label 21795*/ GIMT_Encode4(1572491), // Rule ID 21668 //
     /* 1572414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1572425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1572428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1572431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572453 */     // MIs[0] round
     /* 1572453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572456 */     // MIs[0] policy
     /* 1572456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572466 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1572469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572490 */     // GIR_Coverage, 21668,
     /* 1572490 */     GIR_EraseRootFromParent_Done,
     /* 1572491 */   // Label 21795: @1572491
     /* 1572491 */   GIM_Try, /*On fail goto*//*Label 21796*/ GIMT_Encode4(1572573), // Rule ID 21669 //
     /* 1572496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1572507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1572510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1572513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572535 */     // MIs[0] round
     /* 1572535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572538 */     // MIs[0] policy
     /* 1572538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572548 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1572551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572572 */     // GIR_Coverage, 21669,
     /* 1572572 */     GIR_EraseRootFromParent_Done,
     /* 1572573 */   // Label 21796: @1572573
     /* 1572573 */   GIM_Try, /*On fail goto*//*Label 21797*/ GIMT_Encode4(1572655), // Rule ID 21672 //
     /* 1572578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1572589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1572592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1572595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572617 */     // MIs[0] round
     /* 1572617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572620 */     // MIs[0] policy
     /* 1572620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572630 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1572633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572654 */     // GIR_Coverage, 21672,
     /* 1572654 */     GIR_EraseRootFromParent_Done,
     /* 1572655 */   // Label 21797: @1572655
     /* 1572655 */   GIM_Try, /*On fail goto*//*Label 21798*/ GIMT_Encode4(1572737), // Rule ID 21673 //
     /* 1572660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1572671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1572674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1572677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572699 */     // MIs[0] round
     /* 1572699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572702 */     // MIs[0] policy
     /* 1572702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572712 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1572715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572736 */     // GIR_Coverage, 21673,
     /* 1572736 */     GIR_EraseRootFromParent_Done,
     /* 1572737 */   // Label 21798: @1572737
     /* 1572737 */   GIM_Try, /*On fail goto*//*Label 21799*/ GIMT_Encode4(1572819), // Rule ID 21676 //
     /* 1572742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1572753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1572756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1572759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572781 */     // MIs[0] round
     /* 1572781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572784 */     // MIs[0] policy
     /* 1572784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572794 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1572797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572803 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572818 */     // GIR_Coverage, 21676,
     /* 1572818 */     GIR_EraseRootFromParent_Done,
     /* 1572819 */   // Label 21799: @1572819
     /* 1572819 */   GIM_Try, /*On fail goto*//*Label 21800*/ GIMT_Encode4(1572901), // Rule ID 21677 //
     /* 1572824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1572835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1572838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1572841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572863 */     // MIs[0] round
     /* 1572863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572866 */     // MIs[0] policy
     /* 1572866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572876 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1572879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572885 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572900 */     // GIR_Coverage, 21677,
     /* 1572900 */     GIR_EraseRootFromParent_Done,
     /* 1572901 */   // Label 21800: @1572901
     /* 1572901 */   GIM_Try, /*On fail goto*//*Label 21801*/ GIMT_Encode4(1572983), // Rule ID 21680 //
     /* 1572906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1572917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1572920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1572923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572945 */     // MIs[0] round
     /* 1572945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572948 */     // MIs[0] policy
     /* 1572948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572958 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1572961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572982 */     // GIR_Coverage, 21680,
     /* 1572982 */     GIR_EraseRootFromParent_Done,
     /* 1572983 */   // Label 21801: @1572983
     /* 1572983 */   GIM_Try, /*On fail goto*//*Label 21802*/ GIMT_Encode4(1573065), // Rule ID 21681 //
     /* 1572988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1572999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1573002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1573005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573027 */     // MIs[0] round
     /* 1573027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573030 */     // MIs[0] policy
     /* 1573030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11250:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1573043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573064 */     // GIR_Coverage, 21681,
     /* 1573064 */     GIR_EraseRootFromParent_Done,
     /* 1573065 */   // Label 21802: @1573065
     /* 1573065 */   GIM_Try, /*On fail goto*//*Label 21803*/ GIMT_Encode4(1573147), // Rule ID 21684 //
     /* 1573070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1573081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1573084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1573087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1573090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573109 */     // MIs[0] round
     /* 1573109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573112 */     // MIs[0] policy
     /* 1573112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573122 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1573125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573131 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573146 */     // GIR_Coverage, 21684,
     /* 1573146 */     GIR_EraseRootFromParent_Done,
     /* 1573147 */   // Label 21803: @1573147
     /* 1573147 */   GIM_Try, /*On fail goto*//*Label 21804*/ GIMT_Encode4(1573229), // Rule ID 21685 //
     /* 1573152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1573163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1573166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1573169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1573172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573191 */     // MIs[0] round
     /* 1573191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573194 */     // MIs[0] policy
     /* 1573194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573204 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1573207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573228 */     // GIR_Coverage, 21685,
     /* 1573228 */     GIR_EraseRootFromParent_Done,
     /* 1573229 */   // Label 21804: @1573229
     /* 1573229 */   GIM_Try, /*On fail goto*//*Label 21805*/ GIMT_Encode4(1573311), // Rule ID 21688 //
     /* 1573234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1573245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1573248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1573251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1573254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573273 */     // MIs[0] round
     /* 1573273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573276 */     // MIs[0] policy
     /* 1573276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573286 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1573289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573310 */     // GIR_Coverage, 21688,
     /* 1573310 */     GIR_EraseRootFromParent_Done,
     /* 1573311 */   // Label 21805: @1573311
     /* 1573311 */   GIM_Try, /*On fail goto*//*Label 21806*/ GIMT_Encode4(1573393), // Rule ID 21689 //
     /* 1573316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1573327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1573330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1573333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1573336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573355 */     // MIs[0] round
     /* 1573355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573358 */     // MIs[0] policy
     /* 1573358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573368 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1573371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573392 */     // GIR_Coverage, 21689,
     /* 1573392 */     GIR_EraseRootFromParent_Done,
     /* 1573393 */   // Label 21806: @1573393
     /* 1573393 */   GIM_Try, /*On fail goto*//*Label 21807*/ GIMT_Encode4(1573475), // Rule ID 21692 //
     /* 1573398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1573401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1573409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1573412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1573415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573437 */     // MIs[0] round
     /* 1573437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573440 */     // MIs[0] policy
     /* 1573440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573450 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1573453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573474 */     // GIR_Coverage, 21692,
     /* 1573474 */     GIR_EraseRootFromParent_Done,
     /* 1573475 */   // Label 21807: @1573475
     /* 1573475 */   GIM_Try, /*On fail goto*//*Label 21808*/ GIMT_Encode4(1573557), // Rule ID 21693 //
     /* 1573480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1573483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1573491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1573494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1573497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573519 */     // MIs[0] round
     /* 1573519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573522 */     // MIs[0] policy
     /* 1573522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573532 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1573535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573556 */     // GIR_Coverage, 21693,
     /* 1573556 */     GIR_EraseRootFromParent_Done,
     /* 1573557 */   // Label 21808: @1573557
     /* 1573557 */   GIM_Try, /*On fail goto*//*Label 21809*/ GIMT_Encode4(1573639), // Rule ID 21696 //
     /* 1573562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1573565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1573573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1573576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1573579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1573582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573601 */     // MIs[0] round
     /* 1573601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573604 */     // MIs[0] policy
     /* 1573604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573614 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1573617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573638 */     // GIR_Coverage, 21696,
     /* 1573638 */     GIR_EraseRootFromParent_Done,
     /* 1573639 */   // Label 21809: @1573639
     /* 1573639 */   GIM_Try, /*On fail goto*//*Label 21810*/ GIMT_Encode4(1573721), // Rule ID 21697 //
     /* 1573644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1573647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1573655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1573658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1573661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1573664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573683 */     // MIs[0] round
     /* 1573683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573686 */     // MIs[0] policy
     /* 1573686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1573699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573720 */     // GIR_Coverage, 21697,
     /* 1573720 */     GIR_EraseRootFromParent_Done,
     /* 1573721 */   // Label 21810: @1573721
     /* 1573721 */   GIM_Try, /*On fail goto*//*Label 21811*/ GIMT_Encode4(1573803), // Rule ID 21700 //
     /* 1573726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1573729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1573737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1573740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1573743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1573746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573765 */     // MIs[0] round
     /* 1573765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573768 */     // MIs[0] policy
     /* 1573768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573778 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1573781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573787 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573802 */     // GIR_Coverage, 21700,
     /* 1573802 */     GIR_EraseRootFromParent_Done,
     /* 1573803 */   // Label 21811: @1573803
     /* 1573803 */   GIM_Try, /*On fail goto*//*Label 21812*/ GIMT_Encode4(1573885), // Rule ID 21701 //
     /* 1573808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1573811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1573819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1573822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1573825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1573828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573847 */     // MIs[0] round
     /* 1573847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573850 */     // MIs[0] policy
     /* 1573850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1573863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573884 */     // GIR_Coverage, 21701,
     /* 1573884 */     GIR_EraseRootFromParent_Done,
     /* 1573885 */   // Label 21812: @1573885
     /* 1573885 */   GIM_Try, /*On fail goto*//*Label 21813*/ GIMT_Encode4(1573967), // Rule ID 21704 //
     /* 1573890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1573893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1573901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1573904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1573907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573929 */     // MIs[0] round
     /* 1573929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573932 */     // MIs[0] policy
     /* 1573932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573942 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1573945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573966 */     // GIR_Coverage, 21704,
     /* 1573966 */     GIR_EraseRootFromParent_Done,
     /* 1573967 */   // Label 21813: @1573967
     /* 1573967 */   GIM_Try, /*On fail goto*//*Label 21814*/ GIMT_Encode4(1574049), // Rule ID 21705 //
     /* 1573972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1573975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1573983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1573986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1573989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574011 */     // MIs[0] round
     /* 1574011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574014 */     // MIs[0] policy
     /* 1574014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1574027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574048 */     // GIR_Coverage, 21705,
     /* 1574048 */     GIR_EraseRootFromParent_Done,
     /* 1574049 */   // Label 21814: @1574049
     /* 1574049 */   GIM_Try, /*On fail goto*//*Label 21815*/ GIMT_Encode4(1574131), // Rule ID 21708 //
     /* 1574054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1574057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1574065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1574068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1574071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1574074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574093 */     // MIs[0] round
     /* 1574093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574096 */     // MIs[0] policy
     /* 1574096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574106 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1574109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574115 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574130 */     // GIR_Coverage, 21708,
     /* 1574130 */     GIR_EraseRootFromParent_Done,
     /* 1574131 */   // Label 21815: @1574131
     /* 1574131 */   GIM_Try, /*On fail goto*//*Label 21816*/ GIMT_Encode4(1574213), // Rule ID 21709 //
     /* 1574136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1574139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1574147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1574150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1574153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1574156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574175 */     // MIs[0] round
     /* 1574175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574178 */     // MIs[0] policy
     /* 1574178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574188 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1574191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574212 */     // GIR_Coverage, 21709,
     /* 1574212 */     GIR_EraseRootFromParent_Done,
     /* 1574213 */   // Label 21816: @1574213
     /* 1574213 */   GIM_Try, /*On fail goto*//*Label 21817*/ GIMT_Encode4(1574295), // Rule ID 21712 //
     /* 1574218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1574221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1574229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1574232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1574235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574257 */     // MIs[0] round
     /* 1574257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574260 */     // MIs[0] policy
     /* 1574260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574270 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1574273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574294 */     // GIR_Coverage, 21712,
     /* 1574294 */     GIR_EraseRootFromParent_Done,
     /* 1574295 */   // Label 21817: @1574295
     /* 1574295 */   GIM_Try, /*On fail goto*//*Label 21818*/ GIMT_Encode4(1574377), // Rule ID 21713 //
     /* 1574300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1574303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1574311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1574314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1574317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574339 */     // MIs[0] round
     /* 1574339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574342 */     // MIs[0] policy
     /* 1574342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1574355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574376 */     // GIR_Coverage, 21713,
     /* 1574376 */     GIR_EraseRootFromParent_Done,
     /* 1574377 */   // Label 21818: @1574377
     /* 1574377 */   GIM_Try, /*On fail goto*//*Label 21819*/ GIMT_Encode4(1574459), // Rule ID 21716 //
     /* 1574382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1574385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1574393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1574396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1574399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574421 */     // MIs[0] round
     /* 1574421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574424 */     // MIs[0] policy
     /* 1574424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574434 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1574437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574458 */     // GIR_Coverage, 21716,
     /* 1574458 */     GIR_EraseRootFromParent_Done,
     /* 1574459 */   // Label 21819: @1574459
     /* 1574459 */   GIM_Try, /*On fail goto*//*Label 21820*/ GIMT_Encode4(1574541), // Rule ID 21717 //
     /* 1574464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1574467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1574475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1574478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1574481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574503 */     // MIs[0] round
     /* 1574503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574506 */     // MIs[0] policy
     /* 1574506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1574519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574540 */     // GIR_Coverage, 21717,
     /* 1574540 */     GIR_EraseRootFromParent_Done,
     /* 1574541 */   // Label 21820: @1574541
     /* 1574541 */   GIM_Try, /*On fail goto*//*Label 21821*/ GIMT_Encode4(1574623), // Rule ID 21720 //
     /* 1574546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1574549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1574557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1574560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1574563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1574566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574585 */     // MIs[0] round
     /* 1574585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574588 */     // MIs[0] policy
     /* 1574588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1574601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574622 */     // GIR_Coverage, 21720,
     /* 1574622 */     GIR_EraseRootFromParent_Done,
     /* 1574623 */   // Label 21821: @1574623
     /* 1574623 */   GIM_Try, /*On fail goto*//*Label 21822*/ GIMT_Encode4(1574705), // Rule ID 21721 //
     /* 1574628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1574631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1574639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1574642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1574645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1574648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574667 */     // MIs[0] round
     /* 1574667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574670 */     // MIs[0] policy
     /* 1574670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1574683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574704 */     // GIR_Coverage, 21721,
     /* 1574704 */     GIR_EraseRootFromParent_Done,
     /* 1574705 */   // Label 21822: @1574705
     /* 1574705 */   GIM_Try, /*On fail goto*//*Label 21823*/ GIMT_Encode4(1574787), // Rule ID 21724 //
     /* 1574710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1574713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1574721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1574724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1574727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1574730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574749 */     // MIs[0] round
     /* 1574749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574752 */     // MIs[0] policy
     /* 1574752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574762 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1574765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574786 */     // GIR_Coverage, 21724,
     /* 1574786 */     GIR_EraseRootFromParent_Done,
     /* 1574787 */   // Label 21823: @1574787
     /* 1574787 */   GIM_Try, /*On fail goto*//*Label 21824*/ GIMT_Encode4(1574869), // Rule ID 21725 //
     /* 1574792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1574795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1574803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1574806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1574809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1574812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574831 */     // MIs[0] round
     /* 1574831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574834 */     // MIs[0] policy
     /* 1574834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574844 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1574847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574868 */     // GIR_Coverage, 21725,
     /* 1574868 */     GIR_EraseRootFromParent_Done,
     /* 1574869 */   // Label 21824: @1574869
     /* 1574869 */   GIM_Try, /*On fail goto*//*Label 21825*/ GIMT_Encode4(1574951), // Rule ID 21848 //
     /* 1574874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1574877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1574882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1574885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1574888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1574891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574913 */     // MIs[0] round
     /* 1574913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574916 */     // MIs[0] policy
     /* 1574916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574926 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1574929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574950 */     // GIR_Coverage, 21848,
     /* 1574950 */     GIR_EraseRootFromParent_Done,
     /* 1574951 */   // Label 21825: @1574951
     /* 1574951 */   GIM_Try, /*On fail goto*//*Label 21826*/ GIMT_Encode4(1575033), // Rule ID 21849 //
     /* 1574956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1574959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1574964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1574967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1574970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1574973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574995 */     // MIs[0] round
     /* 1574995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574998 */     // MIs[0] policy
     /* 1574998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575008 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1575011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575032 */     // GIR_Coverage, 21849,
     /* 1575032 */     GIR_EraseRootFromParent_Done,
     /* 1575033 */   // Label 21826: @1575033
     /* 1575033 */   GIM_Try, /*On fail goto*//*Label 21827*/ GIMT_Encode4(1575115), // Rule ID 21852 //
     /* 1575038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1575049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1575052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1575055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575077 */     // MIs[0] round
     /* 1575077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575080 */     // MIs[0] policy
     /* 1575080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575090 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1575093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575114 */     // GIR_Coverage, 21852,
     /* 1575114 */     GIR_EraseRootFromParent_Done,
     /* 1575115 */   // Label 21827: @1575115
     /* 1575115 */   GIM_Try, /*On fail goto*//*Label 21828*/ GIMT_Encode4(1575197), // Rule ID 21853 //
     /* 1575120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1575131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1575134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1575137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575159 */     // MIs[0] round
     /* 1575159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575162 */     // MIs[0] policy
     /* 1575162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575172 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1575175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575196 */     // GIR_Coverage, 21853,
     /* 1575196 */     GIR_EraseRootFromParent_Done,
     /* 1575197 */   // Label 21828: @1575197
     /* 1575197 */   GIM_Try, /*On fail goto*//*Label 21829*/ GIMT_Encode4(1575279), // Rule ID 21856 //
     /* 1575202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1575213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1575216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1575219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575241 */     // MIs[0] round
     /* 1575241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575244 */     // MIs[0] policy
     /* 1575244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575254 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1575257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575278 */     // GIR_Coverage, 21856,
     /* 1575278 */     GIR_EraseRootFromParent_Done,
     /* 1575279 */   // Label 21829: @1575279
     /* 1575279 */   GIM_Try, /*On fail goto*//*Label 21830*/ GIMT_Encode4(1575361), // Rule ID 21857 //
     /* 1575284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1575295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1575298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1575301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575323 */     // MIs[0] round
     /* 1575323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575326 */     // MIs[0] policy
     /* 1575326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575336 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1575339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575360 */     // GIR_Coverage, 21857,
     /* 1575360 */     GIR_EraseRootFromParent_Done,
     /* 1575361 */   // Label 21830: @1575361
     /* 1575361 */   GIM_Try, /*On fail goto*//*Label 21831*/ GIMT_Encode4(1575443), // Rule ID 21860 //
     /* 1575366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1575377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1575380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1575383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575405 */     // MIs[0] round
     /* 1575405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575408 */     // MIs[0] policy
     /* 1575408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575418 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1575421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575427 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575442 */     // GIR_Coverage, 21860,
     /* 1575442 */     GIR_EraseRootFromParent_Done,
     /* 1575443 */   // Label 21831: @1575443
     /* 1575443 */   GIM_Try, /*On fail goto*//*Label 21832*/ GIMT_Encode4(1575525), // Rule ID 21861 //
     /* 1575448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1575459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1575462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1575465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575487 */     // MIs[0] round
     /* 1575487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575490 */     // MIs[0] policy
     /* 1575490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575500 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1575503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575524 */     // GIR_Coverage, 21861,
     /* 1575524 */     GIR_EraseRootFromParent_Done,
     /* 1575525 */   // Label 21832: @1575525
     /* 1575525 */   GIM_Try, /*On fail goto*//*Label 21833*/ GIMT_Encode4(1575607), // Rule ID 21864 //
     /* 1575530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1575541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1575544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1575547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1575550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575569 */     // MIs[0] round
     /* 1575569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575572 */     // MIs[0] policy
     /* 1575572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575582 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1575585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575606 */     // GIR_Coverage, 21864,
     /* 1575606 */     GIR_EraseRootFromParent_Done,
     /* 1575607 */   // Label 21833: @1575607
     /* 1575607 */   GIM_Try, /*On fail goto*//*Label 21834*/ GIMT_Encode4(1575689), // Rule ID 21865 //
     /* 1575612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1575623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1575626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1575629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1575632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575651 */     // MIs[0] round
     /* 1575651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575654 */     // MIs[0] policy
     /* 1575654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575664 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1575667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575688 */     // GIR_Coverage, 21865,
     /* 1575688 */     GIR_EraseRootFromParent_Done,
     /* 1575689 */   // Label 21834: @1575689
     /* 1575689 */   GIM_Try, /*On fail goto*//*Label 21835*/ GIMT_Encode4(1575771), // Rule ID 21868 //
     /* 1575694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1575697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1575705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1575708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1575711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1575714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575733 */     // MIs[0] round
     /* 1575733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575736 */     // MIs[0] policy
     /* 1575736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575746 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1575749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575770 */     // GIR_Coverage, 21868,
     /* 1575770 */     GIR_EraseRootFromParent_Done,
     /* 1575771 */   // Label 21835: @1575771
     /* 1575771 */   GIM_Try, /*On fail goto*//*Label 21836*/ GIMT_Encode4(1575853), // Rule ID 21869 //
     /* 1575776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1575779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1575787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1575790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1575793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1575796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575815 */     // MIs[0] round
     /* 1575815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575818 */     // MIs[0] policy
     /* 1575818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575828 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1575831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575852 */     // GIR_Coverage, 21869,
     /* 1575852 */     GIR_EraseRootFromParent_Done,
     /* 1575853 */   // Label 21836: @1575853
     /* 1575853 */   GIM_Try, /*On fail goto*//*Label 21837*/ GIMT_Encode4(1575935), // Rule ID 21872 //
     /* 1575858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1575861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1575869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1575872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1575875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575897 */     // MIs[0] round
     /* 1575897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575900 */     // MIs[0] policy
     /* 1575900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575910 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1575913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575934 */     // GIR_Coverage, 21872,
     /* 1575934 */     GIR_EraseRootFromParent_Done,
     /* 1575935 */   // Label 21837: @1575935
     /* 1575935 */   GIM_Try, /*On fail goto*//*Label 21838*/ GIMT_Encode4(1576017), // Rule ID 21873 //
     /* 1575940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1575943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1575951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1575954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1575957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575979 */     // MIs[0] round
     /* 1575979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575982 */     // MIs[0] policy
     /* 1575982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575992 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1575995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576016 */     // GIR_Coverage, 21873,
     /* 1576016 */     GIR_EraseRootFromParent_Done,
     /* 1576017 */   // Label 21838: @1576017
     /* 1576017 */   GIM_Try, /*On fail goto*//*Label 21839*/ GIMT_Encode4(1576099), // Rule ID 21876 //
     /* 1576022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1576025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1576033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1576036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1576039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576061 */     // MIs[0] round
     /* 1576061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576064 */     // MIs[0] policy
     /* 1576064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576074 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1576077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576098 */     // GIR_Coverage, 21876,
     /* 1576098 */     GIR_EraseRootFromParent_Done,
     /* 1576099 */   // Label 21839: @1576099
     /* 1576099 */   GIM_Try, /*On fail goto*//*Label 21840*/ GIMT_Encode4(1576181), // Rule ID 21877 //
     /* 1576104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1576107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1576115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1576118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1576121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576143 */     // MIs[0] round
     /* 1576143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576146 */     // MIs[0] policy
     /* 1576146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576156 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1576159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576180 */     // GIR_Coverage, 21877,
     /* 1576180 */     GIR_EraseRootFromParent_Done,
     /* 1576181 */   // Label 21840: @1576181
     /* 1576181 */   GIM_Try, /*On fail goto*//*Label 21841*/ GIMT_Encode4(1576263), // Rule ID 21880 //
     /* 1576186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1576189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1576203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576225 */     // MIs[0] round
     /* 1576225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576228 */     // MIs[0] policy
     /* 1576228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576238 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1576241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576262 */     // GIR_Coverage, 21880,
     /* 1576262 */     GIR_EraseRootFromParent_Done,
     /* 1576263 */   // Label 21841: @1576263
     /* 1576263 */   GIM_Try, /*On fail goto*//*Label 21842*/ GIMT_Encode4(1576345), // Rule ID 21881 //
     /* 1576268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1576271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1576285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576307 */     // MIs[0] round
     /* 1576307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576310 */     // MIs[0] policy
     /* 1576310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576320 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1576323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576344 */     // GIR_Coverage, 21881,
     /* 1576344 */     GIR_EraseRootFromParent_Done,
     /* 1576345 */   // Label 21842: @1576345
     /* 1576345 */   GIM_Try, /*On fail goto*//*Label 21843*/ GIMT_Encode4(1576427), // Rule ID 21884 //
     /* 1576350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1576361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1576364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1576367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576389 */     // MIs[0] round
     /* 1576389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576392 */     // MIs[0] policy
     /* 1576392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576402 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1576405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576426 */     // GIR_Coverage, 21884,
     /* 1576426 */     GIR_EraseRootFromParent_Done,
     /* 1576427 */   // Label 21843: @1576427
     /* 1576427 */   GIM_Try, /*On fail goto*//*Label 21844*/ GIMT_Encode4(1576509), // Rule ID 21885 //
     /* 1576432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1576443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1576446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1576449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576471 */     // MIs[0] round
     /* 1576471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576474 */     // MIs[0] policy
     /* 1576474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576484 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1576487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576493 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576508 */     // GIR_Coverage, 21885,
     /* 1576508 */     GIR_EraseRootFromParent_Done,
     /* 1576509 */   // Label 21844: @1576509
     /* 1576509 */   GIM_Try, /*On fail goto*//*Label 21845*/ GIMT_Encode4(1576591), // Rule ID 21888 //
     /* 1576514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1576525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1576528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1576531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576553 */     // MIs[0] round
     /* 1576553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576556 */     // MIs[0] policy
     /* 1576556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576566 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1576569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576590 */     // GIR_Coverage, 21888,
     /* 1576590 */     GIR_EraseRootFromParent_Done,
     /* 1576591 */   // Label 21845: @1576591
     /* 1576591 */   GIM_Try, /*On fail goto*//*Label 21846*/ GIMT_Encode4(1576673), // Rule ID 21889 //
     /* 1576596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1576607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1576610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1576613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576635 */     // MIs[0] round
     /* 1576635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576638 */     // MIs[0] policy
     /* 1576638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576648 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1576651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576672 */     // GIR_Coverage, 21889,
     /* 1576672 */     GIR_EraseRootFromParent_Done,
     /* 1576673 */   // Label 21846: @1576673
     /* 1576673 */   GIM_Try, /*On fail goto*//*Label 21847*/ GIMT_Encode4(1576755), // Rule ID 21892 //
     /* 1576678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1576689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1576692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1576695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576717 */     // MIs[0] round
     /* 1576717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576720 */     // MIs[0] policy
     /* 1576720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576730 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1576733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576754 */     // GIR_Coverage, 21892,
     /* 1576754 */     GIR_EraseRootFromParent_Done,
     /* 1576755 */   // Label 21847: @1576755
     /* 1576755 */   GIM_Try, /*On fail goto*//*Label 21848*/ GIMT_Encode4(1576837), // Rule ID 21893 //
     /* 1576760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1576771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1576774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1576777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576799 */     // MIs[0] round
     /* 1576799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576802 */     // MIs[0] policy
     /* 1576802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576812 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1576815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576836 */     // GIR_Coverage, 21893,
     /* 1576836 */     GIR_EraseRootFromParent_Done,
     /* 1576837 */   // Label 21848: @1576837
     /* 1576837 */   GIM_Try, /*On fail goto*//*Label 21849*/ GIMT_Encode4(1576919), // Rule ID 21896 //
     /* 1576842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1576853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1576856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1576859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576881 */     // MIs[0] round
     /* 1576881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576884 */     // MIs[0] policy
     /* 1576884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576894 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1576897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576918 */     // GIR_Coverage, 21896,
     /* 1576918 */     GIR_EraseRootFromParent_Done,
     /* 1576919 */   // Label 21849: @1576919
     /* 1576919 */   GIM_Try, /*On fail goto*//*Label 21850*/ GIMT_Encode4(1577001), // Rule ID 21897 //
     /* 1576924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1576935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1576938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1576941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576963 */     // MIs[0] round
     /* 1576963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576966 */     // MIs[0] policy
     /* 1576966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576976 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1576979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577000 */     // GIR_Coverage, 21897,
     /* 1577000 */     GIR_EraseRootFromParent_Done,
     /* 1577001 */   // Label 21850: @1577001
     /* 1577001 */   GIM_Try, /*On fail goto*//*Label 21851*/ GIMT_Encode4(1577083), // Rule ID 21900 //
     /* 1577006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1577009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1577017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1577020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1577023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1577026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577045 */     // MIs[0] round
     /* 1577045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577048 */     // MIs[0] policy
     /* 1577048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577058 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1577061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577082 */     // GIR_Coverage, 21900,
     /* 1577082 */     GIR_EraseRootFromParent_Done,
     /* 1577083 */   // Label 21851: @1577083
     /* 1577083 */   GIM_Try, /*On fail goto*//*Label 21852*/ GIMT_Encode4(1577165), // Rule ID 21901 //
     /* 1577088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1577091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1577099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1577102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1577105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1577108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577127 */     // MIs[0] round
     /* 1577127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577130 */     // MIs[0] policy
     /* 1577130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577140 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1577143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577164 */     // GIR_Coverage, 21901,
     /* 1577164 */     GIR_EraseRootFromParent_Done,
     /* 1577165 */   // Label 21852: @1577165
     /* 1577165 */   GIM_Try, /*On fail goto*//*Label 21853*/ GIMT_Encode4(1577247), // Rule ID 21904 //
     /* 1577170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1577181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1577184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1577187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577209 */     // MIs[0] round
     /* 1577209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577212 */     // MIs[0] policy
     /* 1577212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577222 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1577225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577246 */     // GIR_Coverage, 21904,
     /* 1577246 */     GIR_EraseRootFromParent_Done,
     /* 1577247 */   // Label 21853: @1577247
     /* 1577247 */   GIM_Try, /*On fail goto*//*Label 21854*/ GIMT_Encode4(1577329), // Rule ID 21905 //
     /* 1577252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1577255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1577263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1577266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1577269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577291 */     // MIs[0] round
     /* 1577291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577294 */     // MIs[0] policy
     /* 1577294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577304 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1577307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577328 */     // GIR_Coverage, 21905,
     /* 1577328 */     GIR_EraseRootFromParent_Done,
     /* 1577329 */   // Label 21854: @1577329
     /* 1577329 */   GIM_Try, /*On fail goto*//*Label 21855*/ GIMT_Encode4(1577411), // Rule ID 21908 //
     /* 1577334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1577345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1577348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1577351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1577354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577373 */     // MIs[0] round
     /* 1577373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577376 */     // MIs[0] policy
     /* 1577376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577386 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1577389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577410 */     // GIR_Coverage, 21908,
     /* 1577410 */     GIR_EraseRootFromParent_Done,
     /* 1577411 */   // Label 21855: @1577411
     /* 1577411 */   GIM_Try, /*On fail goto*//*Label 21856*/ GIMT_Encode4(1577493), // Rule ID 21909 //
     /* 1577416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1577419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1577427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1577430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1577433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1577436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577455 */     // MIs[0] round
     /* 1577455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577458 */     // MIs[0] policy
     /* 1577458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577468 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1577471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577492 */     // GIR_Coverage, 21909,
     /* 1577492 */     GIR_EraseRootFromParent_Done,
     /* 1577493 */   // Label 21856: @1577493
     /* 1577493 */   GIM_Try, /*On fail goto*//*Label 21857*/ GIMT_Encode4(1577575), // Rule ID 21912 //
     /* 1577498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1577509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1577512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1577515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1577518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577537 */     // MIs[0] round
     /* 1577537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577540 */     // MIs[0] policy
     /* 1577540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577550 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1577553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577574 */     // GIR_Coverage, 21912,
     /* 1577574 */     GIR_EraseRootFromParent_Done,
     /* 1577575 */   // Label 21857: @1577575
     /* 1577575 */   GIM_Try, /*On fail goto*//*Label 21858*/ GIMT_Encode4(1577657), // Rule ID 21913 //
     /* 1577580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1577583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1577591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1577594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1577597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1577600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577619 */     // MIs[0] round
     /* 1577619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577622 */     // MIs[0] policy
     /* 1577622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577632 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1577635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577656 */     // GIR_Coverage, 21913,
     /* 1577656 */     GIR_EraseRootFromParent_Done,
     /* 1577657 */   // Label 21858: @1577657
     /* 1577657 */   GIM_Try, /*On fail goto*//*Label 21859*/ GIMT_Encode4(1577739), // Rule ID 21916 //
     /* 1577662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1577673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1577676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1577679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1577682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577701 */     // MIs[0] round
     /* 1577701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577704 */     // MIs[0] policy
     /* 1577704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577714 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1577717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577723 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577738 */     // GIR_Coverage, 21916,
     /* 1577738 */     GIR_EraseRootFromParent_Done,
     /* 1577739 */   // Label 21859: @1577739
     /* 1577739 */   GIM_Try, /*On fail goto*//*Label 21860*/ GIMT_Encode4(1577821), // Rule ID 21917 //
     /* 1577744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1577747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1577755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1577758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1577761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1577764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577783 */     // MIs[0] round
     /* 1577783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577786 */     // MIs[0] policy
     /* 1577786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577796 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1577799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577820 */     // GIR_Coverage, 21917,
     /* 1577820 */     GIR_EraseRootFromParent_Done,
     /* 1577821 */   // Label 21860: @1577821
     /* 1577821 */   GIM_Try, /*On fail goto*//*Label 21861*/ GIMT_Encode4(1577903), // Rule ID 21920 //
     /* 1577826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1577829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1577834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1577837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1577840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1577843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577865 */     // MIs[0] round
     /* 1577865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577868 */     // MIs[0] policy
     /* 1577868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577878 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1577881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577887 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577902 */     // GIR_Coverage, 21920,
     /* 1577902 */     GIR_EraseRootFromParent_Done,
     /* 1577903 */   // Label 21861: @1577903
     /* 1577903 */   GIM_Try, /*On fail goto*//*Label 21862*/ GIMT_Encode4(1577985), // Rule ID 21921 //
     /* 1577908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1577911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1577916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1577919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1577922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1577925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577947 */     // MIs[0] round
     /* 1577947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577950 */     // MIs[0] policy
     /* 1577950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577960 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1577963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577984 */     // GIR_Coverage, 21921,
     /* 1577984 */     GIR_EraseRootFromParent_Done,
     /* 1577985 */   // Label 21862: @1577985
     /* 1577985 */   GIM_Try, /*On fail goto*//*Label 21863*/ GIMT_Encode4(1578067), // Rule ID 21924 //
     /* 1577990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1577993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1577998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1578001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1578004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1578007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578029 */     // MIs[0] round
     /* 1578029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578032 */     // MIs[0] policy
     /* 1578032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578042 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1578045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578066 */     // GIR_Coverage, 21924,
     /* 1578066 */     GIR_EraseRootFromParent_Done,
     /* 1578067 */   // Label 21863: @1578067
     /* 1578067 */   GIM_Try, /*On fail goto*//*Label 21864*/ GIMT_Encode4(1578149), // Rule ID 21925 //
     /* 1578072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1578083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1578086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1578089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578111 */     // MIs[0] round
     /* 1578111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578114 */     // MIs[0] policy
     /* 1578114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578124 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1578127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578148 */     // GIR_Coverage, 21925,
     /* 1578148 */     GIR_EraseRootFromParent_Done,
     /* 1578149 */   // Label 21864: @1578149
     /* 1578149 */   GIM_Try, /*On fail goto*//*Label 21865*/ GIMT_Encode4(1578231), // Rule ID 21928 //
     /* 1578154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1578165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1578168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1578171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578193 */     // MIs[0] round
     /* 1578193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578196 */     // MIs[0] policy
     /* 1578196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578206 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1578209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578230 */     // GIR_Coverage, 21928,
     /* 1578230 */     GIR_EraseRootFromParent_Done,
     /* 1578231 */   // Label 21865: @1578231
     /* 1578231 */   GIM_Try, /*On fail goto*//*Label 21866*/ GIMT_Encode4(1578313), // Rule ID 21929 //
     /* 1578236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1578247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1578250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1578253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578275 */     // MIs[0] round
     /* 1578275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578278 */     // MIs[0] policy
     /* 1578278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578288 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1578291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578312 */     // GIR_Coverage, 21929,
     /* 1578312 */     GIR_EraseRootFromParent_Done,
     /* 1578313 */   // Label 21866: @1578313
     /* 1578313 */   GIM_Try, /*On fail goto*//*Label 21867*/ GIMT_Encode4(1578395), // Rule ID 21932 //
     /* 1578318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1578329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1578332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1578335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578357 */     // MIs[0] round
     /* 1578357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578360 */     // MIs[0] policy
     /* 1578360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578370 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1578373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578394 */     // GIR_Coverage, 21932,
     /* 1578394 */     GIR_EraseRootFromParent_Done,
     /* 1578395 */   // Label 21867: @1578395
     /* 1578395 */   GIM_Try, /*On fail goto*//*Label 21868*/ GIMT_Encode4(1578477), // Rule ID 21933 //
     /* 1578400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1578411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1578414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1578417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578439 */     // MIs[0] round
     /* 1578439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578442 */     // MIs[0] policy
     /* 1578442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578452 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1578455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578476 */     // GIR_Coverage, 21933,
     /* 1578476 */     GIR_EraseRootFromParent_Done,
     /* 1578477 */   // Label 21868: @1578477
     /* 1578477 */   GIM_Try, /*On fail goto*//*Label 21869*/ GIMT_Encode4(1578559), // Rule ID 21936 //
     /* 1578482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1578493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1578496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1578499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1578502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578521 */     // MIs[0] round
     /* 1578521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578524 */     // MIs[0] policy
     /* 1578524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578534 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1578537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578558 */     // GIR_Coverage, 21936,
     /* 1578558 */     GIR_EraseRootFromParent_Done,
     /* 1578559 */   // Label 21869: @1578559
     /* 1578559 */   GIM_Try, /*On fail goto*//*Label 21870*/ GIMT_Encode4(1578641), // Rule ID 21937 //
     /* 1578564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1578575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1578578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1578581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1578584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578603 */     // MIs[0] round
     /* 1578603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578606 */     // MIs[0] policy
     /* 1578606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578616 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1578619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578640 */     // GIR_Coverage, 21937,
     /* 1578640 */     GIR_EraseRootFromParent_Done,
     /* 1578641 */   // Label 21870: @1578641
     /* 1578641 */   GIM_Try, /*On fail goto*//*Label 21871*/ GIMT_Encode4(1578723), // Rule ID 21940 //
     /* 1578646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1578649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1578657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1578660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1578663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1578666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578685 */     // MIs[0] round
     /* 1578685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578688 */     // MIs[0] policy
     /* 1578688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578698 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1578701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578722 */     // GIR_Coverage, 21940,
     /* 1578722 */     GIR_EraseRootFromParent_Done,
     /* 1578723 */   // Label 21871: @1578723
     /* 1578723 */   GIM_Try, /*On fail goto*//*Label 21872*/ GIMT_Encode4(1578805), // Rule ID 21941 //
     /* 1578728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1578731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1578739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1578742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1578745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1578748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578767 */     // MIs[0] round
     /* 1578767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578770 */     // MIs[0] policy
     /* 1578770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578780 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1578783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578804 */     // GIR_Coverage, 21941,
     /* 1578804 */     GIR_EraseRootFromParent_Done,
     /* 1578805 */   // Label 21872: @1578805
     /* 1578805 */   GIM_Try, /*On fail goto*//*Label 21873*/ GIMT_Encode4(1578887), // Rule ID 21944 //
     /* 1578810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1578813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1578821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1578824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1578827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578849 */     // MIs[0] round
     /* 1578849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578852 */     // MIs[0] policy
     /* 1578852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578862 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1578865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578886 */     // GIR_Coverage, 21944,
     /* 1578886 */     GIR_EraseRootFromParent_Done,
     /* 1578887 */   // Label 21873: @1578887
     /* 1578887 */   GIM_Try, /*On fail goto*//*Label 21874*/ GIMT_Encode4(1578969), // Rule ID 21945 //
     /* 1578892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1578895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1578903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1578906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1578909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578931 */     // MIs[0] round
     /* 1578931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578934 */     // MIs[0] policy
     /* 1578934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578944 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1578947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578968 */     // GIR_Coverage, 21945,
     /* 1578968 */     GIR_EraseRootFromParent_Done,
     /* 1578969 */   // Label 21874: @1578969
     /* 1578969 */   GIM_Try, /*On fail goto*//*Label 21875*/ GIMT_Encode4(1579051), // Rule ID 21948 //
     /* 1578974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1578977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1578985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1578988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1578991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579013 */     // MIs[0] round
     /* 1579013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579016 */     // MIs[0] policy
     /* 1579016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579026 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1579029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579035 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579050 */     // GIR_Coverage, 21948,
     /* 1579050 */     GIR_EraseRootFromParent_Done,
     /* 1579051 */   // Label 21875: @1579051
     /* 1579051 */   GIM_Try, /*On fail goto*//*Label 21876*/ GIMT_Encode4(1579133), // Rule ID 21949 //
     /* 1579056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1579059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1579067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1579070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1579073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1579076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579095 */     // MIs[0] round
     /* 1579095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579098 */     // MIs[0] policy
     /* 1579098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579108 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1579111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579117 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579132 */     // GIR_Coverage, 21949,
     /* 1579132 */     GIR_EraseRootFromParent_Done,
     /* 1579133 */   // Label 21876: @1579133
     /* 1579133 */   GIM_Try, /*On fail goto*//*Label 21877*/ GIMT_Encode4(1579215), // Rule ID 21952 //
     /* 1579138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1579141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1579149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1579152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1579155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1579158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579177 */     // MIs[0] round
     /* 1579177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579180 */     // MIs[0] policy
     /* 1579180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579190 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1579193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579214 */     // GIR_Coverage, 21952,
     /* 1579214 */     GIR_EraseRootFromParent_Done,
     /* 1579215 */   // Label 21877: @1579215
     /* 1579215 */   GIM_Try, /*On fail goto*//*Label 21878*/ GIMT_Encode4(1579297), // Rule ID 21953 //
     /* 1579220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1579223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1579231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1579234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1579237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1579240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579259 */     // MIs[0] round
     /* 1579259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579262 */     // MIs[0] policy
     /* 1579262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579272 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1579275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579296 */     // GIR_Coverage, 21953,
     /* 1579296 */     GIR_EraseRootFromParent_Done,
     /* 1579297 */   // Label 21878: @1579297
     /* 1579297 */   GIM_Try, /*On fail goto*//*Label 21879*/ GIMT_Encode4(1579379), // Rule ID 2762 //
     /* 1579302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1579313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1579316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1579319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579333 */     // MIs[0] passthru
     /* 1579333 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579346 */     // MIs[0] policy
     /* 1579346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579356 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1579359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579378 */     // GIR_Coverage, 2762,
     /* 1579378 */     GIR_EraseRootFromParent_Done,
     /* 1579379 */   // Label 21879: @1579379
     /* 1579379 */   GIM_Try, /*On fail goto*//*Label 21880*/ GIMT_Encode4(1579461), // Rule ID 2763 //
     /* 1579384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1579395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1579398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1579401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579415 */     // MIs[0] passthru
     /* 1579415 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579428 */     // MIs[0] policy
     /* 1579428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579438 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1579441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579460 */     // GIR_Coverage, 2763,
     /* 1579460 */     GIR_EraseRootFromParent_Done,
     /* 1579461 */   // Label 21880: @1579461
     /* 1579461 */   GIM_Try, /*On fail goto*//*Label 21881*/ GIMT_Encode4(1579543), // Rule ID 4078 //
     /* 1579466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1579477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1579480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1579483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579497 */     // MIs[0] passthru
     /* 1579497 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579510 */     // MIs[0] policy
     /* 1579510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579520 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1579523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579542 */     // GIR_Coverage, 4078,
     /* 1579542 */     GIR_EraseRootFromParent_Done,
     /* 1579543 */   // Label 21881: @1579543
     /* 1579543 */   GIM_Try, /*On fail goto*//*Label 21882*/ GIMT_Encode4(1579625), // Rule ID 4079 //
     /* 1579548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1579559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1579562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1579565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579579 */     // MIs[0] passthru
     /* 1579579 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579592 */     // MIs[0] policy
     /* 1579592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579602 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1579605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579624 */     // GIR_Coverage, 4079,
     /* 1579624 */     GIR_EraseRootFromParent_Done,
     /* 1579625 */   // Label 21882: @1579625
     /* 1579625 */   GIM_Try, /*On fail goto*//*Label 21883*/ GIMT_Encode4(1579707), // Rule ID 4088 //
     /* 1579630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1579641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1579644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1579647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579661 */     // MIs[0] passthru
     /* 1579661 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579674 */     // MIs[0] policy
     /* 1579674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579684 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1579687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579706 */     // GIR_Coverage, 4088,
     /* 1579706 */     GIR_EraseRootFromParent_Done,
     /* 1579707 */   // Label 21883: @1579707
     /* 1579707 */   GIM_Try, /*On fail goto*//*Label 21884*/ GIMT_Encode4(1579789), // Rule ID 4089 //
     /* 1579712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1579723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1579726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1579729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579743 */     // MIs[0] passthru
     /* 1579743 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579756 */     // MIs[0] policy
     /* 1579756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579766 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1579769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579788 */     // GIR_Coverage, 4089,
     /* 1579788 */     GIR_EraseRootFromParent_Done,
     /* 1579789 */   // Label 21884: @1579789
     /* 1579789 */   GIM_Try, /*On fail goto*//*Label 21885*/ GIMT_Encode4(1579871), // Rule ID 4098 //
     /* 1579794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1579805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1579808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1579811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1579814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579825 */     // MIs[0] passthru
     /* 1579825 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579838 */     // MIs[0] policy
     /* 1579838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1579851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579870 */     // GIR_Coverage, 4098,
     /* 1579870 */     GIR_EraseRootFromParent_Done,
     /* 1579871 */   // Label 21885: @1579871
     /* 1579871 */   GIM_Try, /*On fail goto*//*Label 21886*/ GIMT_Encode4(1579953), // Rule ID 4099 //
     /* 1579876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1579887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1579890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1579893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1579896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579907 */     // MIs[0] passthru
     /* 1579907 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579920 */     // MIs[0] policy
     /* 1579920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579930 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1579933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579952 */     // GIR_Coverage, 4099,
     /* 1579952 */     GIR_EraseRootFromParent_Done,
     /* 1579953 */   // Label 21886: @1579953
     /* 1579953 */   GIM_Try, /*On fail goto*//*Label 21887*/ GIMT_Encode4(1580035), // Rule ID 4108 //
     /* 1579958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1579969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1579972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1579975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1579978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579989 */     // MIs[0] passthru
     /* 1579989 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580002 */     // MIs[0] policy
     /* 1580002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580012 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1580015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580034 */     // GIR_Coverage, 4108,
     /* 1580034 */     GIR_EraseRootFromParent_Done,
     /* 1580035 */   // Label 21887: @1580035
     /* 1580035 */   GIM_Try, /*On fail goto*//*Label 21888*/ GIMT_Encode4(1580117), // Rule ID 4109 //
     /* 1580040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1580051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1580054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1580057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1580060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580071 */     // MIs[0] passthru
     /* 1580071 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580084 */     // MIs[0] policy
     /* 1580084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580094 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1580097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580116 */     // GIR_Coverage, 4109,
     /* 1580116 */     GIR_EraseRootFromParent_Done,
     /* 1580117 */   // Label 21888: @1580117
     /* 1580117 */   GIM_Try, /*On fail goto*//*Label 21889*/ GIMT_Encode4(1580199), // Rule ID 4118 //
     /* 1580122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1580133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1580136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1580139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1580142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580153 */     // MIs[0] passthru
     /* 1580153 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580166 */     // MIs[0] policy
     /* 1580166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580176 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1580179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580198 */     // GIR_Coverage, 4118,
     /* 1580198 */     GIR_EraseRootFromParent_Done,
     /* 1580199 */   // Label 21889: @1580199
     /* 1580199 */   GIM_Try, /*On fail goto*//*Label 21890*/ GIMT_Encode4(1580281), // Rule ID 4119 //
     /* 1580204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1580215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1580218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1580221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1580224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580235 */     // MIs[0] passthru
     /* 1580235 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580248 */     // MIs[0] policy
     /* 1580248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580258 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1580261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580280 */     // GIR_Coverage, 4119,
     /* 1580280 */     GIR_EraseRootFromParent_Done,
     /* 1580281 */   // Label 21890: @1580281
     /* 1580281 */   GIM_Try, /*On fail goto*//*Label 21891*/ GIMT_Encode4(1580363), // Rule ID 4128 //
     /* 1580286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1580297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1580300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1580303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580317 */     // MIs[0] passthru
     /* 1580317 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580330 */     // MIs[0] policy
     /* 1580330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580340 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1580343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580362 */     // GIR_Coverage, 4128,
     /* 1580362 */     GIR_EraseRootFromParent_Done,
     /* 1580363 */   // Label 21891: @1580363
     /* 1580363 */   GIM_Try, /*On fail goto*//*Label 21892*/ GIMT_Encode4(1580445), // Rule ID 4129 //
     /* 1580368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1580379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1580382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1580385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580399 */     // MIs[0] passthru
     /* 1580399 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580412 */     // MIs[0] policy
     /* 1580412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580422 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1580425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580444 */     // GIR_Coverage, 4129,
     /* 1580444 */     GIR_EraseRootFromParent_Done,
     /* 1580445 */   // Label 21892: @1580445
     /* 1580445 */   GIM_Try, /*On fail goto*//*Label 21893*/ GIMT_Encode4(1580527), // Rule ID 4138 //
     /* 1580450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1580461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1580464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1580467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580481 */     // MIs[0] passthru
     /* 1580481 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580494 */     // MIs[0] policy
     /* 1580494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580504 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1580507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580526 */     // GIR_Coverage, 4138,
     /* 1580526 */     GIR_EraseRootFromParent_Done,
     /* 1580527 */   // Label 21893: @1580527
     /* 1580527 */   GIM_Try, /*On fail goto*//*Label 21894*/ GIMT_Encode4(1580609), // Rule ID 4139 //
     /* 1580532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1580543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1580546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1580549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580563 */     // MIs[0] passthru
     /* 1580563 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580576 */     // MIs[0] policy
     /* 1580576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580586 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1580589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580608 */     // GIR_Coverage, 4139,
     /* 1580608 */     GIR_EraseRootFromParent_Done,
     /* 1580609 */   // Label 21894: @1580609
     /* 1580609 */   GIM_Try, /*On fail goto*//*Label 21895*/ GIMT_Encode4(1580691), // Rule ID 4148 //
     /* 1580614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1580625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1580628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1580631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580645 */     // MIs[0] passthru
     /* 1580645 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580658 */     // MIs[0] policy
     /* 1580658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1580671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580690 */     // GIR_Coverage, 4148,
     /* 1580690 */     GIR_EraseRootFromParent_Done,
     /* 1580691 */   // Label 21895: @1580691
     /* 1580691 */   GIM_Try, /*On fail goto*//*Label 21896*/ GIMT_Encode4(1580773), // Rule ID 4149 //
     /* 1580696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1580707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1580710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1580713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580727 */     // MIs[0] passthru
     /* 1580727 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580740 */     // MIs[0] policy
     /* 1580740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580750 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1580753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580772 */     // GIR_Coverage, 4149,
     /* 1580772 */     GIR_EraseRootFromParent_Done,
     /* 1580773 */   // Label 21896: @1580773
     /* 1580773 */   GIM_Try, /*On fail goto*//*Label 21897*/ GIMT_Encode4(1580855), // Rule ID 4158 //
     /* 1580778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1580789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1580792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1580795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580809 */     // MIs[0] passthru
     /* 1580809 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580822 */     // MIs[0] policy
     /* 1580822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580832 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1580835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580854 */     // GIR_Coverage, 4158,
     /* 1580854 */     GIR_EraseRootFromParent_Done,
     /* 1580855 */   // Label 21897: @1580855
     /* 1580855 */   GIM_Try, /*On fail goto*//*Label 21898*/ GIMT_Encode4(1580937), // Rule ID 4159 //
     /* 1580860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1580871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1580874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1580877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580891 */     // MIs[0] passthru
     /* 1580891 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580904 */     // MIs[0] policy
     /* 1580904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1580917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580936 */     // GIR_Coverage, 4159,
     /* 1580936 */     GIR_EraseRootFromParent_Done,
     /* 1580937 */   // Label 21898: @1580937
     /* 1580937 */   GIM_Try, /*On fail goto*//*Label 21899*/ GIMT_Encode4(1581019), // Rule ID 4168 //
     /* 1580942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1580953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1580956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1580959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1580962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580973 */     // MIs[0] passthru
     /* 1580973 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580986 */     // MIs[0] policy
     /* 1580986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580996 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1580999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581018 */     // GIR_Coverage, 4168,
     /* 1581018 */     GIR_EraseRootFromParent_Done,
     /* 1581019 */   // Label 21899: @1581019
     /* 1581019 */   GIM_Try, /*On fail goto*//*Label 21900*/ GIMT_Encode4(1581101), // Rule ID 4169 //
     /* 1581024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1581035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1581038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1581041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581055 */     // MIs[0] passthru
     /* 1581055 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581068 */     // MIs[0] policy
     /* 1581068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581078 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1581081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581100 */     // GIR_Coverage, 4169,
     /* 1581100 */     GIR_EraseRootFromParent_Done,
     /* 1581101 */   // Label 21900: @1581101
     /* 1581101 */   GIM_Try, /*On fail goto*//*Label 21901*/ GIMT_Encode4(1581183), // Rule ID 4178 //
     /* 1581106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1581117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1581120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1581123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581137 */     // MIs[0] passthru
     /* 1581137 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581150 */     // MIs[0] policy
     /* 1581150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581160 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1581163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581182 */     // GIR_Coverage, 4178,
     /* 1581182 */     GIR_EraseRootFromParent_Done,
     /* 1581183 */   // Label 21901: @1581183
     /* 1581183 */   GIM_Try, /*On fail goto*//*Label 21902*/ GIMT_Encode4(1581265), // Rule ID 4179 //
     /* 1581188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1581199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1581202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1581205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581219 */     // MIs[0] passthru
     /* 1581219 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581232 */     // MIs[0] policy
     /* 1581232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581242 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1581245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581264 */     // GIR_Coverage, 4179,
     /* 1581264 */     GIR_EraseRootFromParent_Done,
     /* 1581265 */   // Label 21902: @1581265
     /* 1581265 */   GIM_Try, /*On fail goto*//*Label 21903*/ GIMT_Encode4(1581347), // Rule ID 4188 //
     /* 1581270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1581281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1581284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1581287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581301 */     // MIs[0] passthru
     /* 1581301 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581314 */     // MIs[0] policy
     /* 1581314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1581327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581346 */     // GIR_Coverage, 4188,
     /* 1581346 */     GIR_EraseRootFromParent_Done,
     /* 1581347 */   // Label 21903: @1581347
     /* 1581347 */   GIM_Try, /*On fail goto*//*Label 21904*/ GIMT_Encode4(1581429), // Rule ID 4189 //
     /* 1581352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1581363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1581366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1581369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581383 */     // MIs[0] passthru
     /* 1581383 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581396 */     // MIs[0] policy
     /* 1581396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581406 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1581409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581428 */     // GIR_Coverage, 4189,
     /* 1581428 */     GIR_EraseRootFromParent_Done,
     /* 1581429 */   // Label 21904: @1581429
     /* 1581429 */   GIM_Try, /*On fail goto*//*Label 21905*/ GIMT_Encode4(1581511), // Rule ID 4198 //
     /* 1581434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1581445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1581448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1581451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581465 */     // MIs[0] passthru
     /* 1581465 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581478 */     // MIs[0] policy
     /* 1581478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581488 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1581491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581510 */     // GIR_Coverage, 4198,
     /* 1581510 */     GIR_EraseRootFromParent_Done,
     /* 1581511 */   // Label 21905: @1581511
     /* 1581511 */   GIM_Try, /*On fail goto*//*Label 21906*/ GIMT_Encode4(1581593), // Rule ID 4199 //
     /* 1581516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1581527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1581530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1581533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581547 */     // MIs[0] passthru
     /* 1581547 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581560 */     // MIs[0] policy
     /* 1581560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581570 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1581573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581592 */     // GIR_Coverage, 4199,
     /* 1581592 */     GIR_EraseRootFromParent_Done,
     /* 1581593 */   // Label 21906: @1581593
     /* 1581593 */   GIM_Try, /*On fail goto*//*Label 21907*/ GIMT_Encode4(1581675), // Rule ID 4208 //
     /* 1581598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1581609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1581612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1581615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581629 */     // MIs[0] passthru
     /* 1581629 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581642 */     // MIs[0] policy
     /* 1581642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581652 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1581655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581674 */     // GIR_Coverage, 4208,
     /* 1581674 */     GIR_EraseRootFromParent_Done,
     /* 1581675 */   // Label 21907: @1581675
     /* 1581675 */   GIM_Try, /*On fail goto*//*Label 21908*/ GIMT_Encode4(1581757), // Rule ID 4209 //
     /* 1581680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1581691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1581694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1581697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581711 */     // MIs[0] passthru
     /* 1581711 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581724 */     // MIs[0] policy
     /* 1581724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581734 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1581737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581756 */     // GIR_Coverage, 4209,
     /* 1581756 */     GIR_EraseRootFromParent_Done,
     /* 1581757 */   // Label 21908: @1581757
     /* 1581757 */   GIM_Try, /*On fail goto*//*Label 21909*/ GIMT_Encode4(1581839), // Rule ID 4278 //
     /* 1581762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1581773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1581776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1581779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581793 */     // MIs[0] passthru
     /* 1581793 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581806 */     // MIs[0] policy
     /* 1581806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581816 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1581819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1581835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581838 */     // GIR_Coverage, 4278,
     /* 1581838 */     GIR_EraseRootFromParent_Done,
     /* 1581839 */   // Label 21909: @1581839
     /* 1581839 */   GIM_Try, /*On fail goto*//*Label 21910*/ GIMT_Encode4(1581921), // Rule ID 4279 //
     /* 1581844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1581855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1581858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1581861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581875 */     // MIs[0] passthru
     /* 1581875 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581888 */     // MIs[0] policy
     /* 1581888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581898 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1581901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1581917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581920 */     // GIR_Coverage, 4279,
     /* 1581920 */     GIR_EraseRootFromParent_Done,
     /* 1581921 */   // Label 21910: @1581921
     /* 1581921 */   GIM_Try, /*On fail goto*//*Label 21911*/ GIMT_Encode4(1582003), // Rule ID 4288 //
     /* 1581926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1581937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1581940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1581943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581957 */     // MIs[0] passthru
     /* 1581957 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581970 */     // MIs[0] policy
     /* 1581970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581980 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1581983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1581999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582002 */     // GIR_Coverage, 4288,
     /* 1582002 */     GIR_EraseRootFromParent_Done,
     /* 1582003 */   // Label 21911: @1582003
     /* 1582003 */   GIM_Try, /*On fail goto*//*Label 21912*/ GIMT_Encode4(1582085), // Rule ID 4289 //
     /* 1582008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1582019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1582022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1582025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582039 */     // MIs[0] passthru
     /* 1582039 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582052 */     // MIs[0] policy
     /* 1582052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582062 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1582065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582084 */     // GIR_Coverage, 4289,
     /* 1582084 */     GIR_EraseRootFromParent_Done,
     /* 1582085 */   // Label 21912: @1582085
     /* 1582085 */   GIM_Try, /*On fail goto*//*Label 21913*/ GIMT_Encode4(1582167), // Rule ID 4298 //
     /* 1582090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1582101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1582104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1582107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582121 */     // MIs[0] passthru
     /* 1582121 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582134 */     // MIs[0] policy
     /* 1582134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582144 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1582147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582166 */     // GIR_Coverage, 4298,
     /* 1582166 */     GIR_EraseRootFromParent_Done,
     /* 1582167 */   // Label 21913: @1582167
     /* 1582167 */   GIM_Try, /*On fail goto*//*Label 21914*/ GIMT_Encode4(1582249), // Rule ID 4299 //
     /* 1582172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1582183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1582186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1582189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582203 */     // MIs[0] passthru
     /* 1582203 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582216 */     // MIs[0] policy
     /* 1582216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582226 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1582229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582248 */     // GIR_Coverage, 4299,
     /* 1582248 */     GIR_EraseRootFromParent_Done,
     /* 1582249 */   // Label 21914: @1582249
     /* 1582249 */   GIM_Try, /*On fail goto*//*Label 21915*/ GIMT_Encode4(1582331), // Rule ID 4308 //
     /* 1582254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1582265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1582268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1582271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582285 */     // MIs[0] passthru
     /* 1582285 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582298 */     // MIs[0] policy
     /* 1582298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1582311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582330 */     // GIR_Coverage, 4308,
     /* 1582330 */     GIR_EraseRootFromParent_Done,
     /* 1582331 */   // Label 21915: @1582331
     /* 1582331 */   GIM_Try, /*On fail goto*//*Label 21916*/ GIMT_Encode4(1582413), // Rule ID 4309 //
     /* 1582336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1582347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1582350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1582353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582367 */     // MIs[0] passthru
     /* 1582367 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582380 */     // MIs[0] policy
     /* 1582380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582390 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1582393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582412 */     // GIR_Coverage, 4309,
     /* 1582412 */     GIR_EraseRootFromParent_Done,
     /* 1582413 */   // Label 21916: @1582413
     /* 1582413 */   GIM_Try, /*On fail goto*//*Label 21917*/ GIMT_Encode4(1582495), // Rule ID 4318 //
     /* 1582418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1582429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1582432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1582435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1582438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582449 */     // MIs[0] passthru
     /* 1582449 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582462 */     // MIs[0] policy
     /* 1582462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582472 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1582475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582494 */     // GIR_Coverage, 4318,
     /* 1582494 */     GIR_EraseRootFromParent_Done,
     /* 1582495 */   // Label 21917: @1582495
     /* 1582495 */   GIM_Try, /*On fail goto*//*Label 21918*/ GIMT_Encode4(1582577), // Rule ID 4319 //
     /* 1582500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1582511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1582514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1582517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1582520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582531 */     // MIs[0] passthru
     /* 1582531 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582544 */     // MIs[0] policy
     /* 1582544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582554 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1582557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582576 */     // GIR_Coverage, 4319,
     /* 1582576 */     GIR_EraseRootFromParent_Done,
     /* 1582577 */   // Label 21918: @1582577
     /* 1582577 */   GIM_Try, /*On fail goto*//*Label 21919*/ GIMT_Encode4(1582659), // Rule ID 4328 //
     /* 1582582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1582593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1582596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1582599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1582602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582613 */     // MIs[0] passthru
     /* 1582613 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582626 */     // MIs[0] policy
     /* 1582626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582636 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1582639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582658 */     // GIR_Coverage, 4328,
     /* 1582658 */     GIR_EraseRootFromParent_Done,
     /* 1582659 */   // Label 21919: @1582659
     /* 1582659 */   GIM_Try, /*On fail goto*//*Label 21920*/ GIMT_Encode4(1582741), // Rule ID 4329 //
     /* 1582664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1582675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1582678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1582681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1582684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582695 */     // MIs[0] passthru
     /* 1582695 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582708 */     // MIs[0] policy
     /* 1582708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582718 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1582721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582740 */     // GIR_Coverage, 4329,
     /* 1582740 */     GIR_EraseRootFromParent_Done,
     /* 1582741 */   // Label 21920: @1582741
     /* 1582741 */   GIM_Try, /*On fail goto*//*Label 21921*/ GIMT_Encode4(1582823), // Rule ID 4338 //
     /* 1582746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1582757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1582760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1582763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582777 */     // MIs[0] passthru
     /* 1582777 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582790 */     // MIs[0] policy
     /* 1582790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582800 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1582803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582822 */     // GIR_Coverage, 4338,
     /* 1582822 */     GIR_EraseRootFromParent_Done,
     /* 1582823 */   // Label 21921: @1582823
     /* 1582823 */   GIM_Try, /*On fail goto*//*Label 21922*/ GIMT_Encode4(1582905), // Rule ID 4339 //
     /* 1582828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1582839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1582842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1582845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582859 */     // MIs[0] passthru
     /* 1582859 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582872 */     // MIs[0] policy
     /* 1582872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582882 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1582885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582904 */     // GIR_Coverage, 4339,
     /* 1582904 */     GIR_EraseRootFromParent_Done,
     /* 1582905 */   // Label 21922: @1582905
     /* 1582905 */   GIM_Try, /*On fail goto*//*Label 21923*/ GIMT_Encode4(1582987), // Rule ID 4348 //
     /* 1582910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1582921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1582924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1582927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582941 */     // MIs[0] passthru
     /* 1582941 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582954 */     // MIs[0] policy
     /* 1582954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582964 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11688:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1582967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582986 */     // GIR_Coverage, 4348,
     /* 1582986 */     GIR_EraseRootFromParent_Done,
     /* 1582987 */   // Label 21923: @1582987
     /* 1582987 */   GIM_Try, /*On fail goto*//*Label 21924*/ GIMT_Encode4(1583069), // Rule ID 4349 //
     /* 1582992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1583003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1583006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1583009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583023 */     // MIs[0] passthru
     /* 1583023 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583036 */     // MIs[0] policy
     /* 1583036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583046 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11688:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1583049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583068 */     // GIR_Coverage, 4349,
     /* 1583068 */     GIR_EraseRootFromParent_Done,
     /* 1583069 */   // Label 21924: @1583069
     /* 1583069 */   GIM_Try, /*On fail goto*//*Label 21925*/ GIMT_Encode4(1583151), // Rule ID 4358 //
     /* 1583074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1583085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1583088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1583091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583105 */     // MIs[0] passthru
     /* 1583105 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583118 */     // MIs[0] policy
     /* 1583118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583128 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1583131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583150 */     // GIR_Coverage, 4358,
     /* 1583150 */     GIR_EraseRootFromParent_Done,
     /* 1583151 */   // Label 21925: @1583151
     /* 1583151 */   GIM_Try, /*On fail goto*//*Label 21926*/ GIMT_Encode4(1583233), // Rule ID 4359 //
     /* 1583156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1583167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1583170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1583173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583187 */     // MIs[0] passthru
     /* 1583187 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583200 */     // MIs[0] policy
     /* 1583200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1583213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583232 */     // GIR_Coverage, 4359,
     /* 1583232 */     GIR_EraseRootFromParent_Done,
     /* 1583233 */   // Label 21926: @1583233
     /* 1583233 */   GIM_Try, /*On fail goto*//*Label 21927*/ GIMT_Encode4(1583315), // Rule ID 4368 //
     /* 1583238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1583249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1583252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1583255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1583258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583269 */     // MIs[0] passthru
     /* 1583269 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583282 */     // MIs[0] policy
     /* 1583282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583292 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1583295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583314 */     // GIR_Coverage, 4368,
     /* 1583314 */     GIR_EraseRootFromParent_Done,
     /* 1583315 */   // Label 21927: @1583315
     /* 1583315 */   GIM_Try, /*On fail goto*//*Label 21928*/ GIMT_Encode4(1583397), // Rule ID 4369 //
     /* 1583320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1583331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1583334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1583337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1583340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583351 */     // MIs[0] passthru
     /* 1583351 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583364 */     // MIs[0] policy
     /* 1583364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583374 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1583377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583396 */     // GIR_Coverage, 4369,
     /* 1583396 */     GIR_EraseRootFromParent_Done,
     /* 1583397 */   // Label 21928: @1583397
     /* 1583397 */   GIM_Try, /*On fail goto*//*Label 21929*/ GIMT_Encode4(1583479), // Rule ID 4378 //
     /* 1583402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1583413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1583416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1583419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1583422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583433 */     // MIs[0] passthru
     /* 1583433 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583446 */     // MIs[0] policy
     /* 1583446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583456 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1583459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583478 */     // GIR_Coverage, 4378,
     /* 1583478 */     GIR_EraseRootFromParent_Done,
     /* 1583479 */   // Label 21929: @1583479
     /* 1583479 */   GIM_Try, /*On fail goto*//*Label 21930*/ GIMT_Encode4(1583561), // Rule ID 4379 //
     /* 1583484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1583495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1583498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1583501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1583504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583515 */     // MIs[0] passthru
     /* 1583515 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583528 */     // MIs[0] policy
     /* 1583528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583538 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1583541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583560 */     // GIR_Coverage, 4379,
     /* 1583560 */     GIR_EraseRootFromParent_Done,
     /* 1583561 */   // Label 21930: @1583561
     /* 1583561 */   GIM_Try, /*On fail goto*//*Label 21931*/ GIMT_Encode4(1583643), // Rule ID 4388 //
     /* 1583566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1583569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1583577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1583580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1583583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583597 */     // MIs[0] passthru
     /* 1583597 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583610 */     // MIs[0] policy
     /* 1583610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583620 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1583623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1583639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583642 */     // GIR_Coverage, 4388,
     /* 1583642 */     GIR_EraseRootFromParent_Done,
     /* 1583643 */   // Label 21931: @1583643
     /* 1583643 */   GIM_Try, /*On fail goto*//*Label 21932*/ GIMT_Encode4(1583725), // Rule ID 4389 //
     /* 1583648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1583651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1583659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1583662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1583665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583679 */     // MIs[0] passthru
     /* 1583679 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583692 */     // MIs[0] policy
     /* 1583692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1583705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1583721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583724 */     // GIR_Coverage, 4389,
     /* 1583724 */     GIR_EraseRootFromParent_Done,
     /* 1583725 */   // Label 21932: @1583725
     /* 1583725 */   GIM_Try, /*On fail goto*//*Label 21933*/ GIMT_Encode4(1583807), // Rule ID 4398 //
     /* 1583730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1583733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1583741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1583744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1583747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583761 */     // MIs[0] passthru
     /* 1583761 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583774 */     // MIs[0] policy
     /* 1583774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1583787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1583803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583806 */     // GIR_Coverage, 4398,
     /* 1583806 */     GIR_EraseRootFromParent_Done,
     /* 1583807 */   // Label 21933: @1583807
     /* 1583807 */   GIM_Try, /*On fail goto*//*Label 21934*/ GIMT_Encode4(1583889), // Rule ID 4399 //
     /* 1583812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1583815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1583823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1583826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1583829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583843 */     // MIs[0] passthru
     /* 1583843 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583856 */     // MIs[0] policy
     /* 1583856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1583869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1583885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583888 */     // GIR_Coverage, 4399,
     /* 1583888 */     GIR_EraseRootFromParent_Done,
     /* 1583889 */   // Label 21934: @1583889
     /* 1583889 */   GIM_Try, /*On fail goto*//*Label 21935*/ GIMT_Encode4(1583971), // Rule ID 4408 //
     /* 1583894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1583897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1583905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1583908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1583911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583925 */     // MIs[0] passthru
     /* 1583925 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583938 */     // MIs[0] policy
     /* 1583938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583948 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1583951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1583967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583970 */     // GIR_Coverage, 4408,
     /* 1583970 */     GIR_EraseRootFromParent_Done,
     /* 1583971 */   // Label 21935: @1583971
     /* 1583971 */   GIM_Try, /*On fail goto*//*Label 21936*/ GIMT_Encode4(1584053), // Rule ID 4409 //
     /* 1583976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1583979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1583987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1583990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1583993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584007 */     // MIs[0] passthru
     /* 1584007 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584020 */     // MIs[0] policy
     /* 1584020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584030 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1584033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584052 */     // GIR_Coverage, 4409,
     /* 1584052 */     GIR_EraseRootFromParent_Done,
     /* 1584053 */   // Label 21936: @1584053
     /* 1584053 */   GIM_Try, /*On fail goto*//*Label 21937*/ GIMT_Encode4(1584135), // Rule ID 4418 //
     /* 1584058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1584061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1584069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1584072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1584075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1584085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1584089 */     // MIs[0] passthru
     /* 1584089 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584102 */     // MIs[0] policy
     /* 1584102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584112 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1584115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584134 */     // GIR_Coverage, 4418,
     /* 1584134 */     GIR_EraseRootFromParent_Done,
     /* 1584135 */   // Label 21937: @1584135
     /* 1584135 */   GIM_Try, /*On fail goto*//*Label 21938*/ GIMT_Encode4(1584217), // Rule ID 4419 //
     /* 1584140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1584143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1584151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1584154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1584157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1584167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1584171 */     // MIs[0] passthru
     /* 1584171 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584184 */     // MIs[0] policy
     /* 1584184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584194 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1584197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584216 */     // GIR_Coverage, 4419,
     /* 1584216 */     GIR_EraseRootFromParent_Done,
     /* 1584217 */   // Label 21938: @1584217
     /* 1584217 */   GIM_Try, /*On fail goto*//*Label 21939*/ GIMT_Encode4(1584299), // Rule ID 4488 //
     /* 1584222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1584233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1584236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1584239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584253 */     // MIs[0] passthru
     /* 1584253 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584266 */     // MIs[0] policy
     /* 1584266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1584279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584298 */     // GIR_Coverage, 4488,
     /* 1584298 */     GIR_EraseRootFromParent_Done,
     /* 1584299 */   // Label 21939: @1584299
     /* 1584299 */   GIM_Try, /*On fail goto*//*Label 21940*/ GIMT_Encode4(1584381), // Rule ID 4489 //
     /* 1584304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1584315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1584318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1584321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584335 */     // MIs[0] passthru
     /* 1584335 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584348 */     // MIs[0] policy
     /* 1584348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584358 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1584361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584380 */     // GIR_Coverage, 4489,
     /* 1584380 */     GIR_EraseRootFromParent_Done,
     /* 1584381 */   // Label 21940: @1584381
     /* 1584381 */   GIM_Try, /*On fail goto*//*Label 21941*/ GIMT_Encode4(1584463), // Rule ID 4498 //
     /* 1584386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1584397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1584400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1584403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584417 */     // MIs[0] passthru
     /* 1584417 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584430 */     // MIs[0] policy
     /* 1584430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584440 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1584443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584462 */     // GIR_Coverage, 4498,
     /* 1584462 */     GIR_EraseRootFromParent_Done,
     /* 1584463 */   // Label 21941: @1584463
     /* 1584463 */   GIM_Try, /*On fail goto*//*Label 21942*/ GIMT_Encode4(1584545), // Rule ID 4499 //
     /* 1584468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1584479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1584482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1584485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584499 */     // MIs[0] passthru
     /* 1584499 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584512 */     // MIs[0] policy
     /* 1584512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584522 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1584525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584544 */     // GIR_Coverage, 4499,
     /* 1584544 */     GIR_EraseRootFromParent_Done,
     /* 1584545 */   // Label 21942: @1584545
     /* 1584545 */   GIM_Try, /*On fail goto*//*Label 21943*/ GIMT_Encode4(1584627), // Rule ID 4508 //
     /* 1584550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1584561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1584564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1584567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584581 */     // MIs[0] passthru
     /* 1584581 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584594 */     // MIs[0] policy
     /* 1584594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584604 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1584607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584626 */     // GIR_Coverage, 4508,
     /* 1584626 */     GIR_EraseRootFromParent_Done,
     /* 1584627 */   // Label 21943: @1584627
     /* 1584627 */   GIM_Try, /*On fail goto*//*Label 21944*/ GIMT_Encode4(1584709), // Rule ID 4509 //
     /* 1584632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1584643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1584646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1584649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584663 */     // MIs[0] passthru
     /* 1584663 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584676 */     // MIs[0] policy
     /* 1584676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584686 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1584689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584708 */     // GIR_Coverage, 4509,
     /* 1584708 */     GIR_EraseRootFromParent_Done,
     /* 1584709 */   // Label 21944: @1584709
     /* 1584709 */   GIM_Try, /*On fail goto*//*Label 21945*/ GIMT_Encode4(1584791), // Rule ID 4518 //
     /* 1584714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1584725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1584728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1584731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584745 */     // MIs[0] passthru
     /* 1584745 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584758 */     // MIs[0] policy
     /* 1584758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1584771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584790 */     // GIR_Coverage, 4518,
     /* 1584790 */     GIR_EraseRootFromParent_Done,
     /* 1584791 */   // Label 21945: @1584791
     /* 1584791 */   GIM_Try, /*On fail goto*//*Label 21946*/ GIMT_Encode4(1584873), // Rule ID 4519 //
     /* 1584796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1584807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1584810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1584813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584827 */     // MIs[0] passthru
     /* 1584827 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584840 */     // MIs[0] policy
     /* 1584840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1584853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584872 */     // GIR_Coverage, 4519,
     /* 1584872 */     GIR_EraseRootFromParent_Done,
     /* 1584873 */   // Label 21946: @1584873
     /* 1584873 */   GIM_Try, /*On fail goto*//*Label 21947*/ GIMT_Encode4(1584955), // Rule ID 4528 //
     /* 1584878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1584889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1584892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1584895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1584898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584909 */     // MIs[0] passthru
     /* 1584909 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584922 */     // MIs[0] policy
     /* 1584922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584932 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1584935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584954 */     // GIR_Coverage, 4528,
     /* 1584954 */     GIR_EraseRootFromParent_Done,
     /* 1584955 */   // Label 21947: @1584955
     /* 1584955 */   GIM_Try, /*On fail goto*//*Label 21948*/ GIMT_Encode4(1585037), // Rule ID 4529 //
     /* 1584960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1584971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1584974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1584977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1584980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584991 */     // MIs[0] passthru
     /* 1584991 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585004 */     // MIs[0] policy
     /* 1585004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585014 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1585017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585036 */     // GIR_Coverage, 4529,
     /* 1585036 */     GIR_EraseRootFromParent_Done,
     /* 1585037 */   // Label 21948: @1585037
     /* 1585037 */   GIM_Try, /*On fail goto*//*Label 21949*/ GIMT_Encode4(1585119), // Rule ID 4538 //
     /* 1585042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1585059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585073 */     // MIs[0] passthru
     /* 1585073 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585086 */     // MIs[0] policy
     /* 1585086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585096 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1585099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585118 */     // GIR_Coverage, 4538,
     /* 1585118 */     GIR_EraseRootFromParent_Done,
     /* 1585119 */   // Label 21949: @1585119
     /* 1585119 */   GIM_Try, /*On fail goto*//*Label 21950*/ GIMT_Encode4(1585201), // Rule ID 4539 //
     /* 1585124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1585141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585155 */     // MIs[0] passthru
     /* 1585155 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585168 */     // MIs[0] policy
     /* 1585168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585178 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1585181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585200 */     // GIR_Coverage, 4539,
     /* 1585200 */     GIR_EraseRootFromParent_Done,
     /* 1585201 */   // Label 21950: @1585201
     /* 1585201 */   GIM_Try, /*On fail goto*//*Label 21951*/ GIMT_Encode4(1585283), // Rule ID 4548 //
     /* 1585206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1585217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1585220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1585223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1585226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585237 */     // MIs[0] passthru
     /* 1585237 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585250 */     // MIs[0] policy
     /* 1585250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585260 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1585263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585282 */     // GIR_Coverage, 4548,
     /* 1585282 */     GIR_EraseRootFromParent_Done,
     /* 1585283 */   // Label 21951: @1585283
     /* 1585283 */   GIM_Try, /*On fail goto*//*Label 21952*/ GIMT_Encode4(1585365), // Rule ID 4549 //
     /* 1585288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1585299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1585302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1585305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1585308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585319 */     // MIs[0] passthru
     /* 1585319 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585332 */     // MIs[0] policy
     /* 1585332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585342 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1585345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585364 */     // GIR_Coverage, 4549,
     /* 1585364 */     GIR_EraseRootFromParent_Done,
     /* 1585365 */   // Label 21952: @1585365
     /* 1585365 */   GIM_Try, /*On fail goto*//*Label 21953*/ GIMT_Encode4(1585447), // Rule ID 4558 //
     /* 1585370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1585381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1585384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1585387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585401 */     // MIs[0] passthru
     /* 1585401 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585414 */     // MIs[0] policy
     /* 1585414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585424 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1585427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585446 */     // GIR_Coverage, 4558,
     /* 1585446 */     GIR_EraseRootFromParent_Done,
     /* 1585447 */   // Label 21953: @1585447
     /* 1585447 */   GIM_Try, /*On fail goto*//*Label 21954*/ GIMT_Encode4(1585529), // Rule ID 4559 //
     /* 1585452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1585463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1585466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1585469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585483 */     // MIs[0] passthru
     /* 1585483 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585496 */     // MIs[0] policy
     /* 1585496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585506 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1585509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585528 */     // GIR_Coverage, 4559,
     /* 1585528 */     GIR_EraseRootFromParent_Done,
     /* 1585529 */   // Label 21954: @1585529
     /* 1585529 */   GIM_Try, /*On fail goto*//*Label 21955*/ GIMT_Encode4(1585611), // Rule ID 4568 //
     /* 1585534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1585545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1585548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1585551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585565 */     // MIs[0] passthru
     /* 1585565 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585578 */     // MIs[0] policy
     /* 1585578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1585591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585610 */     // GIR_Coverage, 4568,
     /* 1585610 */     GIR_EraseRootFromParent_Done,
     /* 1585611 */   // Label 21955: @1585611
     /* 1585611 */   GIM_Try, /*On fail goto*//*Label 21956*/ GIMT_Encode4(1585693), // Rule ID 4569 //
     /* 1585616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1585627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1585630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1585633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585647 */     // MIs[0] passthru
     /* 1585647 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585660 */     // MIs[0] policy
     /* 1585660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1585673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585692 */     // GIR_Coverage, 4569,
     /* 1585692 */     GIR_EraseRootFromParent_Done,
     /* 1585693 */   // Label 21956: @1585693
     /* 1585693 */   GIM_Try, /*On fail goto*//*Label 21957*/ GIMT_Encode4(1585775), // Rule ID 4578 //
     /* 1585698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1585709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1585712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1585715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585729 */     // MIs[0] passthru
     /* 1585729 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585742 */     // MIs[0] policy
     /* 1585742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585752 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1585755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585774 */     // GIR_Coverage, 4578,
     /* 1585774 */     GIR_EraseRootFromParent_Done,
     /* 1585775 */   // Label 21957: @1585775
     /* 1585775 */   GIM_Try, /*On fail goto*//*Label 21958*/ GIMT_Encode4(1585857), // Rule ID 4579 //
     /* 1585780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1585791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1585794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1585797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585811 */     // MIs[0] passthru
     /* 1585811 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585824 */     // MIs[0] policy
     /* 1585824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585834 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1585837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585856 */     // GIR_Coverage, 4579,
     /* 1585856 */     GIR_EraseRootFromParent_Done,
     /* 1585857 */   // Label 21958: @1585857
     /* 1585857 */   GIM_Try, /*On fail goto*//*Label 21959*/ GIMT_Encode4(1585939), // Rule ID 4588 //
     /* 1585862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1585873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1585876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1585879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585893 */     // MIs[0] passthru
     /* 1585893 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585906 */     // MIs[0] policy
     /* 1585906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585916 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1585919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585938 */     // GIR_Coverage, 4588,
     /* 1585938 */     GIR_EraseRootFromParent_Done,
     /* 1585939 */   // Label 21959: @1585939
     /* 1585939 */   GIM_Try, /*On fail goto*//*Label 21960*/ GIMT_Encode4(1586021), // Rule ID 4589 //
     /* 1585944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1585955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1585958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1585961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585975 */     // MIs[0] passthru
     /* 1585975 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585988 */     // MIs[0] policy
     /* 1585988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585998 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1586001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586020 */     // GIR_Coverage, 4589,
     /* 1586020 */     GIR_EraseRootFromParent_Done,
     /* 1586021 */   // Label 21960: @1586021
     /* 1586021 */   GIM_Try, /*On fail goto*//*Label 21961*/ GIMT_Encode4(1586103), // Rule ID 4598 //
     /* 1586026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1586037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1586040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1586043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586057 */     // MIs[0] passthru
     /* 1586057 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586070 */     // MIs[0] policy
     /* 1586070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586080 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1586083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586102 */     // GIR_Coverage, 4598,
     /* 1586102 */     GIR_EraseRootFromParent_Done,
     /* 1586103 */   // Label 21961: @1586103
     /* 1586103 */   GIM_Try, /*On fail goto*//*Label 21962*/ GIMT_Encode4(1586185), // Rule ID 4599 //
     /* 1586108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1586119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1586122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1586125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586139 */     // MIs[0] passthru
     /* 1586139 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586152 */     // MIs[0] policy
     /* 1586152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586162 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1586165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586184 */     // GIR_Coverage, 4599,
     /* 1586184 */     GIR_EraseRootFromParent_Done,
     /* 1586185 */   // Label 21962: @1586185
     /* 1586185 */   GIM_Try, /*On fail goto*//*Label 21963*/ GIMT_Encode4(1586267), // Rule ID 4608 //
     /* 1586190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1586207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586221 */     // MIs[0] passthru
     /* 1586221 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586234 */     // MIs[0] policy
     /* 1586234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1586247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586266 */     // GIR_Coverage, 4608,
     /* 1586266 */     GIR_EraseRootFromParent_Done,
     /* 1586267 */   // Label 21963: @1586267
     /* 1586267 */   GIM_Try, /*On fail goto*//*Label 21964*/ GIMT_Encode4(1586349), // Rule ID 4609 //
     /* 1586272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1586289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586303 */     // MIs[0] passthru
     /* 1586303 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586316 */     // MIs[0] policy
     /* 1586316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1586329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586348 */     // GIR_Coverage, 4609,
     /* 1586348 */     GIR_EraseRootFromParent_Done,
     /* 1586349 */   // Label 21964: @1586349
     /* 1586349 */   GIM_Try, /*On fail goto*//*Label 21965*/ GIMT_Encode4(1586431), // Rule ID 4618 //
     /* 1586354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1586371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586385 */     // MIs[0] passthru
     /* 1586385 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586398 */     // MIs[0] policy
     /* 1586398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586408 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1586411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586430 */     // GIR_Coverage, 4618,
     /* 1586430 */     GIR_EraseRootFromParent_Done,
     /* 1586431 */   // Label 21965: @1586431
     /* 1586431 */   GIM_Try, /*On fail goto*//*Label 21966*/ GIMT_Encode4(1586513), // Rule ID 4619 //
     /* 1586436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1586453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586467 */     // MIs[0] passthru
     /* 1586467 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586480 */     // MIs[0] policy
     /* 1586480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586490 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1586493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586512 */     // GIR_Coverage, 4619,
     /* 1586512 */     GIR_EraseRootFromParent_Done,
     /* 1586513 */   // Label 21966: @1586513
     /* 1586513 */   GIM_Try, /*On fail goto*//*Label 21967*/ GIMT_Encode4(1586595), // Rule ID 4628 //
     /* 1586518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1586529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1586532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1586535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586549 */     // MIs[0] passthru
     /* 1586549 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586562 */     // MIs[0] policy
     /* 1586562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586572 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1586575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586594 */     // GIR_Coverage, 4628,
     /* 1586594 */     GIR_EraseRootFromParent_Done,
     /* 1586595 */   // Label 21967: @1586595
     /* 1586595 */   GIM_Try, /*On fail goto*//*Label 21968*/ GIMT_Encode4(1586677), // Rule ID 4629 //
     /* 1586600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1586611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1586614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1586617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586631 */     // MIs[0] passthru
     /* 1586631 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586644 */     // MIs[0] policy
     /* 1586644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586654 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1586657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586676 */     // GIR_Coverage, 4629,
     /* 1586676 */     GIR_EraseRootFromParent_Done,
     /* 1586677 */   // Label 21968: @1586677
     /* 1586677 */   GIM_Try, /*On fail goto*//*Label 21969*/ GIMT_Encode4(1586759), // Rule ID 4698 //
     /* 1586682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1586693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1586696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1586699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586713 */     // MIs[0] passthru
     /* 1586713 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586726 */     // MIs[0] policy
     /* 1586726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586736 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1586739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586758 */     // GIR_Coverage, 4698,
     /* 1586758 */     GIR_EraseRootFromParent_Done,
     /* 1586759 */   // Label 21969: @1586759
     /* 1586759 */   GIM_Try, /*On fail goto*//*Label 21970*/ GIMT_Encode4(1586841), // Rule ID 4699 //
     /* 1586764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1586775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1586778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1586781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586795 */     // MIs[0] passthru
     /* 1586795 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586808 */     // MIs[0] policy
     /* 1586808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586818 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1586821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586840 */     // GIR_Coverage, 4699,
     /* 1586840 */     GIR_EraseRootFromParent_Done,
     /* 1586841 */   // Label 21970: @1586841
     /* 1586841 */   GIM_Try, /*On fail goto*//*Label 21971*/ GIMT_Encode4(1586923), // Rule ID 4708 //
     /* 1586846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1586857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1586860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1586863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586877 */     // MIs[0] passthru
     /* 1586877 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586890 */     // MIs[0] policy
     /* 1586890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586900 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1586903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586922 */     // GIR_Coverage, 4708,
     /* 1586922 */     GIR_EraseRootFromParent_Done,
     /* 1586923 */   // Label 21971: @1586923
     /* 1586923 */   GIM_Try, /*On fail goto*//*Label 21972*/ GIMT_Encode4(1587005), // Rule ID 4709 //
     /* 1586928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1586939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1586942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1586945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586959 */     // MIs[0] passthru
     /* 1586959 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586972 */     // MIs[0] policy
     /* 1586972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586982 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1586985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587004 */     // GIR_Coverage, 4709,
     /* 1587004 */     GIR_EraseRootFromParent_Done,
     /* 1587005 */   // Label 21972: @1587005
     /* 1587005 */   GIM_Try, /*On fail goto*//*Label 21973*/ GIMT_Encode4(1587087), // Rule ID 4718 //
     /* 1587010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1587021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1587024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1587027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587041 */     // MIs[0] passthru
     /* 1587041 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587054 */     // MIs[0] policy
     /* 1587054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587064 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1587067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587086 */     // GIR_Coverage, 4718,
     /* 1587086 */     GIR_EraseRootFromParent_Done,
     /* 1587087 */   // Label 21973: @1587087
     /* 1587087 */   GIM_Try, /*On fail goto*//*Label 21974*/ GIMT_Encode4(1587169), // Rule ID 4719 //
     /* 1587092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1587103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1587106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1587109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587123 */     // MIs[0] passthru
     /* 1587123 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587136 */     // MIs[0] policy
     /* 1587136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1587149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587168 */     // GIR_Coverage, 4719,
     /* 1587168 */     GIR_EraseRootFromParent_Done,
     /* 1587169 */   // Label 21974: @1587169
     /* 1587169 */   GIM_Try, /*On fail goto*//*Label 21975*/ GIMT_Encode4(1587251), // Rule ID 4728 //
     /* 1587174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1587185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1587188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1587191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1587201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587205 */     // MIs[0] passthru
     /* 1587205 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587218 */     // MIs[0] policy
     /* 1587218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1587231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587250 */     // GIR_Coverage, 4728,
     /* 1587250 */     GIR_EraseRootFromParent_Done,
     /* 1587251 */   // Label 21975: @1587251
     /* 1587251 */   GIM_Try, /*On fail goto*//*Label 21976*/ GIMT_Encode4(1587333), // Rule ID 4729 //
     /* 1587256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1587267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1587270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1587273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1587283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587287 */     // MIs[0] passthru
     /* 1587287 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587300 */     // MIs[0] policy
     /* 1587300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587310 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1587313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587332 */     // GIR_Coverage, 4729,
     /* 1587332 */     GIR_EraseRootFromParent_Done,
     /* 1587333 */   // Label 21976: @1587333
     /* 1587333 */   GIM_Try, /*On fail goto*//*Label 21977*/ GIMT_Encode4(1587415), // Rule ID 4738 //
     /* 1587338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1587349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1587352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1587355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1587358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1587365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587369 */     // MIs[0] passthru
     /* 1587369 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587382 */     // MIs[0] policy
     /* 1587382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587392 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1587395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587414 */     // GIR_Coverage, 4738,
     /* 1587414 */     GIR_EraseRootFromParent_Done,
     /* 1587415 */   // Label 21977: @1587415
     /* 1587415 */   GIM_Try, /*On fail goto*//*Label 21978*/ GIMT_Encode4(1587497), // Rule ID 4739 //
     /* 1587420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1587431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1587434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1587437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1587440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1587447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587451 */     // MIs[0] passthru
     /* 1587451 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587464 */     // MIs[0] policy
     /* 1587464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1587477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587496 */     // GIR_Coverage, 4739,
     /* 1587496 */     GIR_EraseRootFromParent_Done,
     /* 1587497 */   // Label 21978: @1587497
     /* 1587497 */   GIM_Try, /*On fail goto*//*Label 21979*/ GIMT_Encode4(1587579), // Rule ID 4748 //
     /* 1587502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1587513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1587516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1587519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1587522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1587529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1587533 */     // MIs[0] passthru
     /* 1587533 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587546 */     // MIs[0] policy
     /* 1587546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587556 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1587559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587578 */     // GIR_Coverage, 4748,
     /* 1587578 */     GIR_EraseRootFromParent_Done,
     /* 1587579 */   // Label 21979: @1587579
     /* 1587579 */   GIM_Try, /*On fail goto*//*Label 21980*/ GIMT_Encode4(1587661), // Rule ID 4749 //
     /* 1587584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1587595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1587598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1587601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1587604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1587611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1587615 */     // MIs[0] passthru
     /* 1587615 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587628 */     // MIs[0] policy
     /* 1587628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587638 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1587641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587660 */     // GIR_Coverage, 4749,
     /* 1587660 */     GIR_EraseRootFromParent_Done,
     /* 1587661 */   // Label 21980: @1587661
     /* 1587661 */   GIM_Try, /*On fail goto*//*Label 21981*/ GIMT_Encode4(1587743), // Rule ID 4758 //
     /* 1587666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1587677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1587680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1587683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587697 */     // MIs[0] passthru
     /* 1587697 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587710 */     // MIs[0] policy
     /* 1587710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587720 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1587723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587742 */     // GIR_Coverage, 4758,
     /* 1587742 */     GIR_EraseRootFromParent_Done,
     /* 1587743 */   // Label 21981: @1587743
     /* 1587743 */   GIM_Try, /*On fail goto*//*Label 21982*/ GIMT_Encode4(1587825), // Rule ID 4759 //
     /* 1587748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1587759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1587762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1587765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587779 */     // MIs[0] passthru
     /* 1587779 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587792 */     // MIs[0] policy
     /* 1587792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1587805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587824 */     // GIR_Coverage, 4759,
     /* 1587824 */     GIR_EraseRootFromParent_Done,
     /* 1587825 */   // Label 21982: @1587825
     /* 1587825 */   GIM_Try, /*On fail goto*//*Label 21983*/ GIMT_Encode4(1587907), // Rule ID 4768 //
     /* 1587830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1587841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1587844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1587847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587861 */     // MIs[0] passthru
     /* 1587861 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587874 */     // MIs[0] policy
     /* 1587874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587884 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11684:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1587887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587906 */     // GIR_Coverage, 4768,
     /* 1587906 */     GIR_EraseRootFromParent_Done,
     /* 1587907 */   // Label 21983: @1587907
     /* 1587907 */   GIM_Try, /*On fail goto*//*Label 21984*/ GIMT_Encode4(1587989), // Rule ID 4769 //
     /* 1587912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1587923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1587926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1587929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587943 */     // MIs[0] passthru
     /* 1587943 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587956 */     // MIs[0] policy
     /* 1587956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11684:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1587969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587988 */     // GIR_Coverage, 4769,
     /* 1587988 */     GIR_EraseRootFromParent_Done,
     /* 1587989 */   // Label 21984: @1587989
     /* 1587989 */   GIM_Try, /*On fail goto*//*Label 21985*/ GIMT_Encode4(1588071), // Rule ID 4778 //
     /* 1587994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1588005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1588008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1588011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588025 */     // MIs[0] passthru
     /* 1588025 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588038 */     // MIs[0] policy
     /* 1588038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1588051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588070 */     // GIR_Coverage, 4778,
     /* 1588070 */     GIR_EraseRootFromParent_Done,
     /* 1588071 */   // Label 21985: @1588071
     /* 1588071 */   GIM_Try, /*On fail goto*//*Label 21986*/ GIMT_Encode4(1588153), // Rule ID 4779 //
     /* 1588076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1588087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1588090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1588093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588107 */     // MIs[0] passthru
     /* 1588107 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588120 */     // MIs[0] policy
     /* 1588120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588130 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1588133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588152 */     // GIR_Coverage, 4779,
     /* 1588152 */     GIR_EraseRootFromParent_Done,
     /* 1588153 */   // Label 21986: @1588153
     /* 1588153 */   GIM_Try, /*On fail goto*//*Label 21987*/ GIMT_Encode4(1588235), // Rule ID 4788 //
     /* 1588158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1588169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1588172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1588175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588189 */     // MIs[0] passthru
     /* 1588189 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588202 */     // MIs[0] policy
     /* 1588202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588212 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1588215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588234 */     // GIR_Coverage, 4788,
     /* 1588234 */     GIR_EraseRootFromParent_Done,
     /* 1588235 */   // Label 21987: @1588235
     /* 1588235 */   GIM_Try, /*On fail goto*//*Label 21988*/ GIMT_Encode4(1588317), // Rule ID 4789 //
     /* 1588240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1588251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1588254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1588257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588271 */     // MIs[0] passthru
     /* 1588271 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588284 */     // MIs[0] policy
     /* 1588284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588294 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1588297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588316 */     // GIR_Coverage, 4789,
     /* 1588316 */     GIR_EraseRootFromParent_Done,
     /* 1588317 */   // Label 21988: @1588317
     /* 1588317 */   GIM_Try, /*On fail goto*//*Label 21989*/ GIMT_Encode4(1588399), // Rule ID 4798 //
     /* 1588322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1588333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1588336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1588339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588353 */     // MIs[0] passthru
     /* 1588353 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588366 */     // MIs[0] policy
     /* 1588366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588376 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1588379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588398 */     // GIR_Coverage, 4798,
     /* 1588398 */     GIR_EraseRootFromParent_Done,
     /* 1588399 */   // Label 21989: @1588399
     /* 1588399 */   GIM_Try, /*On fail goto*//*Label 21990*/ GIMT_Encode4(1588481), // Rule ID 4799 //
     /* 1588404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1588415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1588418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1588421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588435 */     // MIs[0] passthru
     /* 1588435 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588448 */     // MIs[0] policy
     /* 1588448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588458 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1588461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588480 */     // GIR_Coverage, 4799,
     /* 1588480 */     GIR_EraseRootFromParent_Done,
     /* 1588481 */   // Label 21990: @1588481
     /* 1588481 */   GIM_Try, /*On fail goto*//*Label 21991*/ GIMT_Encode4(1588563), // Rule ID 4808 //
     /* 1588486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1588489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1588497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1588500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1588503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588517 */     // MIs[0] passthru
     /* 1588517 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588530 */     // MIs[0] policy
     /* 1588530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588540 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1588543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588562 */     // GIR_Coverage, 4808,
     /* 1588562 */     GIR_EraseRootFromParent_Done,
     /* 1588563 */   // Label 21991: @1588563
     /* 1588563 */   GIM_Try, /*On fail goto*//*Label 21992*/ GIMT_Encode4(1588645), // Rule ID 4809 //
     /* 1588568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1588571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1588579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1588582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1588585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588599 */     // MIs[0] passthru
     /* 1588599 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588612 */     // MIs[0] policy
     /* 1588612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588622 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1588625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588644 */     // GIR_Coverage, 4809,
     /* 1588644 */     GIR_EraseRootFromParent_Done,
     /* 1588645 */   // Label 21992: @1588645
     /* 1588645 */   GIM_Try, /*On fail goto*//*Label 21993*/ GIMT_Encode4(1588727), // Rule ID 4818 //
     /* 1588650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1588653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1588661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1588664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1588667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588681 */     // MIs[0] passthru
     /* 1588681 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588694 */     // MIs[0] policy
     /* 1588694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588704 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1588707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588726 */     // GIR_Coverage, 4818,
     /* 1588726 */     GIR_EraseRootFromParent_Done,
     /* 1588727 */   // Label 21993: @1588727
     /* 1588727 */   GIM_Try, /*On fail goto*//*Label 21994*/ GIMT_Encode4(1588809), // Rule ID 4819 //
     /* 1588732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1588735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1588743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1588746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1588749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588763 */     // MIs[0] passthru
     /* 1588763 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588776 */     // MIs[0] policy
     /* 1588776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1588789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588808 */     // GIR_Coverage, 4819,
     /* 1588808 */     GIR_EraseRootFromParent_Done,
     /* 1588809 */   // Label 21994: @1588809
     /* 1588809 */   GIM_Try, /*On fail goto*//*Label 21995*/ GIMT_Encode4(1588891), // Rule ID 4828 //
     /* 1588814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1588817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1588825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1588828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1588831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588845 */     // MIs[0] passthru
     /* 1588845 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588858 */     // MIs[0] policy
     /* 1588858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588868 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1588871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588890 */     // GIR_Coverage, 4828,
     /* 1588890 */     GIR_EraseRootFromParent_Done,
     /* 1588891 */   // Label 21995: @1588891
     /* 1588891 */   GIM_Try, /*On fail goto*//*Label 21996*/ GIMT_Encode4(1588973), // Rule ID 4829 //
     /* 1588896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1588899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1588907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1588910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1588913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588927 */     // MIs[0] passthru
     /* 1588927 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588940 */     // MIs[0] policy
     /* 1588940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1588953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588972 */     // GIR_Coverage, 4829,
     /* 1588972 */     GIR_EraseRootFromParent_Done,
     /* 1588973 */   // Label 21996: @1588973
     /* 1588973 */   GIM_Try, /*On fail goto*//*Label 21997*/ GIMT_Encode4(1589055), // Rule ID 4838 //
     /* 1588978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1588981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1588989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1588992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1588995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589009 */     // MIs[0] passthru
     /* 1589009 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589022 */     // MIs[0] policy
     /* 1589022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589032 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1589035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589054 */     // GIR_Coverage, 4838,
     /* 1589054 */     GIR_EraseRootFromParent_Done,
     /* 1589055 */   // Label 21997: @1589055
     /* 1589055 */   GIM_Try, /*On fail goto*//*Label 21998*/ GIMT_Encode4(1589137), // Rule ID 4839 //
     /* 1589060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1589063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1589071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1589074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1589077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589091 */     // MIs[0] passthru
     /* 1589091 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589104 */     // MIs[0] policy
     /* 1589104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1589117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589136 */     // GIR_Coverage, 4839,
     /* 1589136 */     GIR_EraseRootFromParent_Done,
     /* 1589137 */   // Label 21998: @1589137
     /* 1589137 */   GIM_Try, /*On fail goto*//*Label 21999*/ GIMT_Encode4(1589223), // Rule ID 2726 //
     /* 1589142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589188 */     // MIs[0] policy
     /* 1589188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589198 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1589201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589222 */     // GIR_Coverage, 2726,
     /* 1589222 */     GIR_EraseRootFromParent_Done,
     /* 1589223 */   // Label 21999: @1589223
     /* 1589223 */   GIM_Try, /*On fail goto*//*Label 22000*/ GIMT_Encode4(1589309), // Rule ID 2727 //
     /* 1589228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589274 */     // MIs[0] policy
     /* 1589274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589284 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1589287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589308 */     // GIR_Coverage, 2727,
     /* 1589308 */     GIR_EraseRootFromParent_Done,
     /* 1589309 */   // Label 22000: @1589309
     /* 1589309 */   GIM_Try, /*On fail goto*//*Label 22001*/ GIMT_Encode4(1589395), // Rule ID 2764 //
     /* 1589314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1589322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1589325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1589328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1589331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589360 */     // MIs[0] policy
     /* 1589360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589370 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1589373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589394 */     // GIR_Coverage, 2764,
     /* 1589394 */     GIR_EraseRootFromParent_Done,
     /* 1589395 */   // Label 22001: @1589395
     /* 1589395 */   GIM_Try, /*On fail goto*//*Label 22002*/ GIMT_Encode4(1589481), // Rule ID 2765 //
     /* 1589400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1589408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1589411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1589414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1589417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589446 */     // MIs[0] policy
     /* 1589446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589456 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1589459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589480 */     // GIR_Coverage, 2765,
     /* 1589480 */     GIR_EraseRootFromParent_Done,
     /* 1589481 */   // Label 22002: @1589481
     /* 1589481 */   GIM_Try, /*On fail goto*//*Label 22003*/ GIMT_Encode4(1589567), // Rule ID 2778 //
     /* 1589486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1589494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589532 */     // MIs[0] policy
     /* 1589532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589542 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1589545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1589549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589566 */     // GIR_Coverage, 2778,
     /* 1589566 */     GIR_EraseRootFromParent_Done,
     /* 1589567 */   // Label 22003: @1589567
     /* 1589567 */   GIM_Try, /*On fail goto*//*Label 22004*/ GIMT_Encode4(1589653), // Rule ID 2779 //
     /* 1589572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1589580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589618 */     // MIs[0] policy
     /* 1589618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589628 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1589631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1589635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589652 */     // GIR_Coverage, 2779,
     /* 1589652 */     GIR_EraseRootFromParent_Done,
     /* 1589653 */   // Label 22004: @1589653
     /* 1589653 */   GIM_Try, /*On fail goto*//*Label 22005*/ GIMT_Encode4(1589739), // Rule ID 2798 //
     /* 1589658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589704 */     // MIs[0] policy
     /* 1589704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589714 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1589717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589738 */     // GIR_Coverage, 2798,
     /* 1589738 */     GIR_EraseRootFromParent_Done,
     /* 1589739 */   // Label 22005: @1589739
     /* 1589739 */   GIM_Try, /*On fail goto*//*Label 22006*/ GIMT_Encode4(1589825), // Rule ID 2799 //
     /* 1589744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589790 */     // MIs[0] policy
     /* 1589790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589800 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1589803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589824 */     // GIR_Coverage, 2799,
     /* 1589824 */     GIR_EraseRootFromParent_Done,
     /* 1589825 */   // Label 22006: @1589825
     /* 1589825 */   GIM_Try, /*On fail goto*//*Label 22007*/ GIMT_Encode4(1589911), // Rule ID 2806 //
     /* 1589830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1589841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1589844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1589847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1589850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1589853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589876 */     // MIs[0] policy
     /* 1589876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589886 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1589889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589910 */     // GIR_Coverage, 2806,
     /* 1589910 */     GIR_EraseRootFromParent_Done,
     /* 1589911 */   // Label 22007: @1589911
     /* 1589911 */   GIM_Try, /*On fail goto*//*Label 22008*/ GIMT_Encode4(1589997), // Rule ID 2807 //
     /* 1589916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1589927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1589930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1589933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1589936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1589939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589962 */     // MIs[0] policy
     /* 1589962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589972 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1589975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589996 */     // GIR_Coverage, 2807,
     /* 1589996 */     GIR_EraseRootFromParent_Done,
     /* 1589997 */   // Label 22008: @1589997
     /* 1589997 */   GIM_Try, /*On fail goto*//*Label 22009*/ GIMT_Encode4(1590083), // Rule ID 2814 //
     /* 1590002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1590013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1590016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1590019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1590022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590048 */     // MIs[0] policy
     /* 1590048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590058 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590082 */     // GIR_Coverage, 2814,
     /* 1590082 */     GIR_EraseRootFromParent_Done,
     /* 1590083 */   // Label 22009: @1590083
     /* 1590083 */   GIM_Try, /*On fail goto*//*Label 22010*/ GIMT_Encode4(1590169), // Rule ID 2815 //
     /* 1590088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1590099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1590102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1590105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1590108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590134 */     // MIs[0] policy
     /* 1590134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590144 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590168 */     // GIR_Coverage, 2815,
     /* 1590168 */     GIR_EraseRootFromParent_Done,
     /* 1590169 */   // Label 22010: @1590169
     /* 1590169 */   GIM_Try, /*On fail goto*//*Label 22011*/ GIMT_Encode4(1590255), // Rule ID 2822 //
     /* 1590174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1590185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1590188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1590191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1590194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590220 */     // MIs[0] policy
     /* 1590220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590230 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1590233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590254 */     // GIR_Coverage, 2822,
     /* 1590254 */     GIR_EraseRootFromParent_Done,
     /* 1590255 */   // Label 22011: @1590255
     /* 1590255 */   GIM_Try, /*On fail goto*//*Label 22012*/ GIMT_Encode4(1590341), // Rule ID 2823 //
     /* 1590260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1590271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1590274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1590277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1590280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590306 */     // MIs[0] policy
     /* 1590306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590316 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1590319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590340 */     // GIR_Coverage, 2823,
     /* 1590340 */     GIR_EraseRootFromParent_Done,
     /* 1590341 */   // Label 22012: @1590341
     /* 1590341 */   GIM_Try, /*On fail goto*//*Label 22013*/ GIMT_Encode4(1590427), // Rule ID 2830 //
     /* 1590346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1590357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1590360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1590363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1590366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590392 */     // MIs[0] policy
     /* 1590392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590402 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590426 */     // GIR_Coverage, 2830,
     /* 1590426 */     GIR_EraseRootFromParent_Done,
     /* 1590427 */   // Label 22013: @1590427
     /* 1590427 */   GIM_Try, /*On fail goto*//*Label 22014*/ GIMT_Encode4(1590513), // Rule ID 2831 //
     /* 1590432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1590443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1590446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1590449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1590452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590478 */     // MIs[0] policy
     /* 1590478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590488 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590512 */     // GIR_Coverage, 2831,
     /* 1590512 */     GIR_EraseRootFromParent_Done,
     /* 1590513 */   // Label 22014: @1590513
     /* 1590513 */   GIM_Try, /*On fail goto*//*Label 22015*/ GIMT_Encode4(1590599), // Rule ID 2838 //
     /* 1590518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1590529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1590532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1590535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1590538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590564 */     // MIs[0] policy
     /* 1590564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590574 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590598 */     // GIR_Coverage, 2838,
     /* 1590598 */     GIR_EraseRootFromParent_Done,
     /* 1590599 */   // Label 22015: @1590599
     /* 1590599 */   GIM_Try, /*On fail goto*//*Label 22016*/ GIMT_Encode4(1590685), // Rule ID 2839 //
     /* 1590604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1590615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1590618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1590621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1590624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590650 */     // MIs[0] policy
     /* 1590650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590660 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590684 */     // GIR_Coverage, 2839,
     /* 1590684 */     GIR_EraseRootFromParent_Done,
     /* 1590685 */   // Label 22016: @1590685
     /* 1590685 */   GIM_Try, /*On fail goto*//*Label 22017*/ GIMT_Encode4(1590771), // Rule ID 2846 //
     /* 1590690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1590701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1590704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1590707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1590710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1590713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590736 */     // MIs[0] policy
     /* 1590736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590746 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1590749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590770 */     // GIR_Coverage, 2846,
     /* 1590770 */     GIR_EraseRootFromParent_Done,
     /* 1590771 */   // Label 22017: @1590771
     /* 1590771 */   GIM_Try, /*On fail goto*//*Label 22018*/ GIMT_Encode4(1590857), // Rule ID 2847 //
     /* 1590776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1590787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1590790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1590793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1590796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1590799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590822 */     // MIs[0] policy
     /* 1590822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590832 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1590835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590856 */     // GIR_Coverage, 2847,
     /* 1590856 */     GIR_EraseRootFromParent_Done,
     /* 1590857 */   // Label 22018: @1590857
     /* 1590857 */   GIM_Try, /*On fail goto*//*Label 22019*/ GIMT_Encode4(1590943), // Rule ID 2854 //
     /* 1590862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1590873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1590876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1590879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1590882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590908 */     // MIs[0] policy
     /* 1590908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1590921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590942 */     // GIR_Coverage, 2854,
     /* 1590942 */     GIR_EraseRootFromParent_Done,
     /* 1590943 */   // Label 22019: @1590943
     /* 1590943 */   GIM_Try, /*On fail goto*//*Label 22020*/ GIMT_Encode4(1591029), // Rule ID 2855 //
     /* 1590948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1590959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1590962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1590965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1590968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590994 */     // MIs[0] policy
     /* 1590994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591004 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591028 */     // GIR_Coverage, 2855,
     /* 1591028 */     GIR_EraseRootFromParent_Done,
     /* 1591029 */   // Label 22020: @1591029
     /* 1591029 */   GIM_Try, /*On fail goto*//*Label 22021*/ GIMT_Encode4(1591115), // Rule ID 2862 //
     /* 1591034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1591045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1591048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1591051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1591054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591080 */     // MIs[0] policy
     /* 1591080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591090 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591114 */     // GIR_Coverage, 2862,
     /* 1591114 */     GIR_EraseRootFromParent_Done,
     /* 1591115 */   // Label 22021: @1591115
     /* 1591115 */   GIM_Try, /*On fail goto*//*Label 22022*/ GIMT_Encode4(1591201), // Rule ID 2863 //
     /* 1591120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1591131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1591134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1591137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1591140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591166 */     // MIs[0] policy
     /* 1591166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591176 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591200 */     // GIR_Coverage, 2863,
     /* 1591200 */     GIR_EraseRootFromParent_Done,
     /* 1591201 */   // Label 22022: @1591201
     /* 1591201 */   GIM_Try, /*On fail goto*//*Label 22023*/ GIMT_Encode4(1591287), // Rule ID 2870 //
     /* 1591206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1591209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1591217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1591220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1591223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1591226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591252 */     // MIs[0] policy
     /* 1591252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591262 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1591283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591286 */     // GIR_Coverage, 2870,
     /* 1591286 */     GIR_EraseRootFromParent_Done,
     /* 1591287 */   // Label 22023: @1591287
     /* 1591287 */   GIM_Try, /*On fail goto*//*Label 22024*/ GIMT_Encode4(1591373), // Rule ID 2871 //
     /* 1591292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1591295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1591303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1591306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1591309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1591312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591338 */     // MIs[0] policy
     /* 1591338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591348 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1591369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591372 */     // GIR_Coverage, 2871,
     /* 1591372 */     GIR_EraseRootFromParent_Done,
     /* 1591373 */   // Label 22024: @1591373
     /* 1591373 */   GIM_Try, /*On fail goto*//*Label 22025*/ GIMT_Encode4(1591459), // Rule ID 2878 //
     /* 1591378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1591389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1591392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1591395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1591398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1591401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591424 */     // MIs[0] policy
     /* 1591424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591434 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1591437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591458 */     // GIR_Coverage, 2878,
     /* 1591458 */     GIR_EraseRootFromParent_Done,
     /* 1591459 */   // Label 22025: @1591459
     /* 1591459 */   GIM_Try, /*On fail goto*//*Label 22026*/ GIMT_Encode4(1591545), // Rule ID 2879 //
     /* 1591464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1591475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1591478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1591481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1591484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1591487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591510 */     // MIs[0] policy
     /* 1591510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591520 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1591523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591544 */     // GIR_Coverage, 2879,
     /* 1591544 */     GIR_EraseRootFromParent_Done,
     /* 1591545 */   // Label 22026: @1591545
     /* 1591545 */   GIM_Try, /*On fail goto*//*Label 22027*/ GIMT_Encode4(1591631), // Rule ID 2886 //
     /* 1591550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1591561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1591564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1591567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1591570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1591573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1591580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591596 */     // MIs[0] policy
     /* 1591596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591606 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1591609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591630 */     // GIR_Coverage, 2886,
     /* 1591630 */     GIR_EraseRootFromParent_Done,
     /* 1591631 */   // Label 22027: @1591631
     /* 1591631 */   GIM_Try, /*On fail goto*//*Label 22028*/ GIMT_Encode4(1591717), // Rule ID 2887 //
     /* 1591636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1591647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1591650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1591653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1591656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1591659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1591666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591682 */     // MIs[0] policy
     /* 1591682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591692 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1591695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591716 */     // GIR_Coverage, 2887,
     /* 1591716 */     GIR_EraseRootFromParent_Done,
     /* 1591717 */   // Label 22028: @1591717
     /* 1591717 */   GIM_Try, /*On fail goto*//*Label 22029*/ GIMT_Encode4(1591803), // Rule ID 2894 //
     /* 1591722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1591733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1591736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1591739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1591742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1591745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1591752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591768 */     // MIs[0] policy
     /* 1591768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591778 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1591781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591802 */     // GIR_Coverage, 2894,
     /* 1591802 */     GIR_EraseRootFromParent_Done,
     /* 1591803 */   // Label 22029: @1591803
     /* 1591803 */   GIM_Try, /*On fail goto*//*Label 22030*/ GIMT_Encode4(1591889), // Rule ID 2895 //
     /* 1591808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1591819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1591822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1591825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1591828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1591831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1591838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591854 */     // MIs[0] policy
     /* 1591854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591864 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1591867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591888 */     // GIR_Coverage, 2895,
     /* 1591888 */     GIR_EraseRootFromParent_Done,
     /* 1591889 */   // Label 22030: @1591889
     /* 1591889 */   GIM_Try, /*On fail goto*//*Label 22031*/ GIMT_Encode4(1591975), // Rule ID 2902 //
     /* 1591894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1591905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1591908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1591911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1591914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591940 */     // MIs[0] policy
     /* 1591940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591950 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1591953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591974 */     // GIR_Coverage, 2902,
     /* 1591974 */     GIR_EraseRootFromParent_Done,
     /* 1591975 */   // Label 22031: @1591975
     /* 1591975 */   GIM_Try, /*On fail goto*//*Label 22032*/ GIMT_Encode4(1592061), // Rule ID 2903 //
     /* 1591980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1591991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1591994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1591997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1592000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592026 */     // MIs[0] policy
     /* 1592026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592036 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592060 */     // GIR_Coverage, 2903,
     /* 1592060 */     GIR_EraseRootFromParent_Done,
     /* 1592061 */   // Label 22032: @1592061
     /* 1592061 */   GIM_Try, /*On fail goto*//*Label 22033*/ GIMT_Encode4(1592147), // Rule ID 2910 //
     /* 1592066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1592077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1592080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1592083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1592086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592112 */     // MIs[0] policy
     /* 1592112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592122 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592146 */     // GIR_Coverage, 2910,
     /* 1592146 */     GIR_EraseRootFromParent_Done,
     /* 1592147 */   // Label 22033: @1592147
     /* 1592147 */   GIM_Try, /*On fail goto*//*Label 22034*/ GIMT_Encode4(1592233), // Rule ID 2911 //
     /* 1592152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1592163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1592166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1592169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1592172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592198 */     // MIs[0] policy
     /* 1592198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592208 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592232 */     // GIR_Coverage, 2911,
     /* 1592232 */     GIR_EraseRootFromParent_Done,
     /* 1592233 */   // Label 22034: @1592233
     /* 1592233 */   GIM_Try, /*On fail goto*//*Label 22035*/ GIMT_Encode4(1592319), // Rule ID 2918 //
     /* 1592238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1592249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1592252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1592255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1592258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592284 */     // MIs[0] policy
     /* 1592284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592294 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592318 */     // GIR_Coverage, 2918,
     /* 1592318 */     GIR_EraseRootFromParent_Done,
     /* 1592319 */   // Label 22035: @1592319
     /* 1592319 */   GIM_Try, /*On fail goto*//*Label 22036*/ GIMT_Encode4(1592405), // Rule ID 2919 //
     /* 1592324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1592335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1592338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1592341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1592344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592370 */     // MIs[0] policy
     /* 1592370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592380 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592404 */     // GIR_Coverage, 2919,
     /* 1592404 */     GIR_EraseRootFromParent_Done,
     /* 1592405 */   // Label 22036: @1592405
     /* 1592405 */   GIM_Try, /*On fail goto*//*Label 22037*/ GIMT_Encode4(1592491), // Rule ID 2926 //
     /* 1592410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1592421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1592424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1592427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1592430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1592433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592456 */     // MIs[0] policy
     /* 1592456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592466 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592490 */     // GIR_Coverage, 2926,
     /* 1592490 */     GIR_EraseRootFromParent_Done,
     /* 1592491 */   // Label 22037: @1592491
     /* 1592491 */   GIM_Try, /*On fail goto*//*Label 22038*/ GIMT_Encode4(1592577), // Rule ID 2927 //
     /* 1592496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1592507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1592510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1592513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1592516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1592519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592542 */     // MIs[0] policy
     /* 1592542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592576 */     // GIR_Coverage, 2927,
     /* 1592576 */     GIR_EraseRootFromParent_Done,
     /* 1592577 */   // Label 22038: @1592577
     /* 1592577 */   GIM_Try, /*On fail goto*//*Label 22039*/ GIMT_Encode4(1592663), // Rule ID 2934 //
     /* 1592582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1592593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1592596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1592599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1592602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592628 */     // MIs[0] policy
     /* 1592628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592638 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592662 */     // GIR_Coverage, 2934,
     /* 1592662 */     GIR_EraseRootFromParent_Done,
     /* 1592663 */   // Label 22039: @1592663
     /* 1592663 */   GIM_Try, /*On fail goto*//*Label 22040*/ GIMT_Encode4(1592749), // Rule ID 2935 //
     /* 1592668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1592679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1592682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1592685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1592688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592714 */     // MIs[0] policy
     /* 1592714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592724 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592748 */     // GIR_Coverage, 2935,
     /* 1592748 */     GIR_EraseRootFromParent_Done,
     /* 1592749 */   // Label 22040: @1592749
     /* 1592749 */   GIM_Try, /*On fail goto*//*Label 22041*/ GIMT_Encode4(1592835), // Rule ID 2942 //
     /* 1592754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1592765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1592768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1592771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1592774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592800 */     // MIs[0] policy
     /* 1592800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592810 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592834 */     // GIR_Coverage, 2942,
     /* 1592834 */     GIR_EraseRootFromParent_Done,
     /* 1592835 */   // Label 22041: @1592835
     /* 1592835 */   GIM_Try, /*On fail goto*//*Label 22042*/ GIMT_Encode4(1592921), // Rule ID 2943 //
     /* 1592840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1592851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1592854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1592857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1592860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592886 */     // MIs[0] policy
     /* 1592886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592896 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592920 */     // GIR_Coverage, 2943,
     /* 1592920 */     GIR_EraseRootFromParent_Done,
     /* 1592921 */   // Label 22042: @1592921
     /* 1592921 */   GIM_Try, /*On fail goto*//*Label 22043*/ GIMT_Encode4(1593007), // Rule ID 2950 //
     /* 1592926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1592929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1592937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1592940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1592943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1592946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1592949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592972 */     // MIs[0] policy
     /* 1592972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592982 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593006 */     // GIR_Coverage, 2950,
     /* 1593006 */     GIR_EraseRootFromParent_Done,
     /* 1593007 */   // Label 22043: @1593007
     /* 1593007 */   GIM_Try, /*On fail goto*//*Label 22044*/ GIMT_Encode4(1593093), // Rule ID 2951 //
     /* 1593012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1593023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1593026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1593029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1593032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593058 */     // MIs[0] policy
     /* 1593058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1593071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593092 */     // GIR_Coverage, 2951,
     /* 1593092 */     GIR_EraseRootFromParent_Done,
     /* 1593093 */   // Label 22044: @1593093
     /* 1593093 */   GIM_Try, /*On fail goto*//*Label 22045*/ GIMT_Encode4(1593179), // Rule ID 2958 //
     /* 1593098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1593101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1593109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1593112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1593115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1593118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593144 */     // MIs[0] policy
     /* 1593144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593154 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1593157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593178 */     // GIR_Coverage, 2958,
     /* 1593178 */     GIR_EraseRootFromParent_Done,
     /* 1593179 */   // Label 22045: @1593179
     /* 1593179 */   GIM_Try, /*On fail goto*//*Label 22046*/ GIMT_Encode4(1593265), // Rule ID 2959 //
     /* 1593184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1593195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1593198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1593201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1593204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593230 */     // MIs[0] policy
     /* 1593230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593240 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1593243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593264 */     // GIR_Coverage, 2959,
     /* 1593264 */     GIR_EraseRootFromParent_Done,
     /* 1593265 */   // Label 22046: @1593265
     /* 1593265 */   GIM_Try, /*On fail goto*//*Label 22047*/ GIMT_Encode4(1593351), // Rule ID 2966 //
     /* 1593270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1593273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1593281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1593284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1593287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1593290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593316 */     // MIs[0] policy
     /* 1593316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593326 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1593329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593350 */     // GIR_Coverage, 2966,
     /* 1593350 */     GIR_EraseRootFromParent_Done,
     /* 1593351 */   // Label 22047: @1593351
     /* 1593351 */   GIM_Try, /*On fail goto*//*Label 22048*/ GIMT_Encode4(1593437), // Rule ID 2967 //
     /* 1593356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1593367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1593370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1593373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1593376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593402 */     // MIs[0] policy
     /* 1593402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593412 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1593415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593436 */     // GIR_Coverage, 2967,
     /* 1593436 */     GIR_EraseRootFromParent_Done,
     /* 1593437 */   // Label 22048: @1593437
     /* 1593437 */   GIM_Try, /*On fail goto*//*Label 22049*/ GIMT_Encode4(1593523), // Rule ID 2982 //
     /* 1593442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1593453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1593456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1593459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1593462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593488 */     // MIs[0] policy
     /* 1593488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593498 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1593501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593522 */     // GIR_Coverage, 2982,
     /* 1593522 */     GIR_EraseRootFromParent_Done,
     /* 1593523 */   // Label 22049: @1593523
     /* 1593523 */   GIM_Try, /*On fail goto*//*Label 22050*/ GIMT_Encode4(1593609), // Rule ID 2983 //
     /* 1593528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1593539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1593542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1593545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1593548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593574 */     // MIs[0] policy
     /* 1593574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593584 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1593587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593608 */     // GIR_Coverage, 2983,
     /* 1593608 */     GIR_EraseRootFromParent_Done,
     /* 1593609 */   // Label 22050: @1593609
     /* 1593609 */   GIM_Try, /*On fail goto*//*Label 22051*/ GIMT_Encode4(1593695), // Rule ID 2986 //
     /* 1593614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1593625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1593628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1593631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1593634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593660 */     // MIs[0] policy
     /* 1593660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593670 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1593673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593694 */     // GIR_Coverage, 2986,
     /* 1593694 */     GIR_EraseRootFromParent_Done,
     /* 1593695 */   // Label 22051: @1593695
     /* 1593695 */   GIM_Try, /*On fail goto*//*Label 22052*/ GIMT_Encode4(1593781), // Rule ID 2987 //
     /* 1593700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1593711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1593714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1593717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1593720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593746 */     // MIs[0] policy
     /* 1593746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593756 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1593759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593780 */     // GIR_Coverage, 2987,
     /* 1593780 */     GIR_EraseRootFromParent_Done,
     /* 1593781 */   // Label 22052: @1593781
     /* 1593781 */   GIM_Try, /*On fail goto*//*Label 22053*/ GIMT_Encode4(1593867), // Rule ID 2990 //
     /* 1593786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1593797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1593800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1593803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1593806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1593809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593832 */     // MIs[0] policy
     /* 1593832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593842 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1593845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593866 */     // GIR_Coverage, 2990,
     /* 1593866 */     GIR_EraseRootFromParent_Done,
     /* 1593867 */   // Label 22053: @1593867
     /* 1593867 */   GIM_Try, /*On fail goto*//*Label 22054*/ GIMT_Encode4(1593953), // Rule ID 2991 //
     /* 1593872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1593883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1593886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1593889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1593892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1593895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593918 */     // MIs[0] policy
     /* 1593918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593928 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1593931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593952 */     // GIR_Coverage, 2991,
     /* 1593952 */     GIR_EraseRootFromParent_Done,
     /* 1593953 */   // Label 22054: @1593953
     /* 1593953 */   GIM_Try, /*On fail goto*//*Label 22055*/ GIMT_Encode4(1594039), // Rule ID 2994 //
     /* 1593958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1593969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1593972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1593975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1593978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594004 */     // MIs[0] policy
     /* 1594004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594014 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594038 */     // GIR_Coverage, 2994,
     /* 1594038 */     GIR_EraseRootFromParent_Done,
     /* 1594039 */   // Label 22055: @1594039
     /* 1594039 */   GIM_Try, /*On fail goto*//*Label 22056*/ GIMT_Encode4(1594125), // Rule ID 2995 //
     /* 1594044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1594055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1594058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1594061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1594064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594090 */     // MIs[0] policy
     /* 1594090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594100 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594124 */     // GIR_Coverage, 2995,
     /* 1594124 */     GIR_EraseRootFromParent_Done,
     /* 1594125 */   // Label 22056: @1594125
     /* 1594125 */   GIM_Try, /*On fail goto*//*Label 22057*/ GIMT_Encode4(1594211), // Rule ID 2998 //
     /* 1594130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1594141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1594144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1594147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1594150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594176 */     // MIs[0] policy
     /* 1594176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594210 */     // GIR_Coverage, 2998,
     /* 1594210 */     GIR_EraseRootFromParent_Done,
     /* 1594211 */   // Label 22057: @1594211
     /* 1594211 */   GIM_Try, /*On fail goto*//*Label 22058*/ GIMT_Encode4(1594297), // Rule ID 2999 //
     /* 1594216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1594227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1594230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1594233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1594236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594262 */     // MIs[0] policy
     /* 1594262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594272 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594296 */     // GIR_Coverage, 2999,
     /* 1594296 */     GIR_EraseRootFromParent_Done,
     /* 1594297 */   // Label 22058: @1594297
     /* 1594297 */   GIM_Try, /*On fail goto*//*Label 22059*/ GIMT_Encode4(1594383), // Rule ID 3002 //
     /* 1594302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1594313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1594316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1594319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1594322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594348 */     // MIs[0] policy
     /* 1594348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594382 */     // GIR_Coverage, 3002,
     /* 1594382 */     GIR_EraseRootFromParent_Done,
     /* 1594383 */   // Label 22059: @1594383
     /* 1594383 */   GIM_Try, /*On fail goto*//*Label 22060*/ GIMT_Encode4(1594469), // Rule ID 3003 //
     /* 1594388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1594399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1594402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1594405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1594408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594434 */     // MIs[0] policy
     /* 1594434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594444 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594468 */     // GIR_Coverage, 3003,
     /* 1594468 */     GIR_EraseRootFromParent_Done,
     /* 1594469 */   // Label 22060: @1594469
     /* 1594469 */   GIM_Try, /*On fail goto*//*Label 22061*/ GIMT_Encode4(1594555), // Rule ID 3006 //
     /* 1594474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1594485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1594488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1594491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1594494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594520 */     // MIs[0] policy
     /* 1594520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594530 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594554 */     // GIR_Coverage, 3006,
     /* 1594554 */     GIR_EraseRootFromParent_Done,
     /* 1594555 */   // Label 22061: @1594555
     /* 1594555 */   GIM_Try, /*On fail goto*//*Label 22062*/ GIMT_Encode4(1594641), // Rule ID 3007 //
     /* 1594560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1594571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1594574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1594577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1594580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594606 */     // MIs[0] policy
     /* 1594606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594616 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594640 */     // GIR_Coverage, 3007,
     /* 1594640 */     GIR_EraseRootFromParent_Done,
     /* 1594641 */   // Label 22062: @1594641
     /* 1594641 */   GIM_Try, /*On fail goto*//*Label 22063*/ GIMT_Encode4(1594727), // Rule ID 3010 //
     /* 1594646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1594657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1594660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1594663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1594666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594692 */     // MIs[0] policy
     /* 1594692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594726 */     // GIR_Coverage, 3010,
     /* 1594726 */     GIR_EraseRootFromParent_Done,
     /* 1594727 */   // Label 22063: @1594727
     /* 1594727 */   GIM_Try, /*On fail goto*//*Label 22064*/ GIMT_Encode4(1594813), // Rule ID 3011 //
     /* 1594732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1594743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1594746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1594749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1594752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594778 */     // MIs[0] policy
     /* 1594778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594788 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594812 */     // GIR_Coverage, 3011,
     /* 1594812 */     GIR_EraseRootFromParent_Done,
     /* 1594813 */   // Label 22064: @1594813
     /* 1594813 */   GIM_Try, /*On fail goto*//*Label 22065*/ GIMT_Encode4(1594899), // Rule ID 3014 //
     /* 1594818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1594821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1594829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1594832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1594835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1594838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594864 */     // MIs[0] policy
     /* 1594864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594874 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594898 */     // GIR_Coverage, 3014,
     /* 1594898 */     GIR_EraseRootFromParent_Done,
     /* 1594899 */   // Label 22065: @1594899
     /* 1594899 */   GIM_Try, /*On fail goto*//*Label 22066*/ GIMT_Encode4(1594985), // Rule ID 3015 //
     /* 1594904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1594907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1594915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1594918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1594921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1594924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594950 */     // MIs[0] policy
     /* 1594950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594960 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594984 */     // GIR_Coverage, 3015,
     /* 1594984 */     GIR_EraseRootFromParent_Done,
     /* 1594985 */   // Label 22066: @1594985
     /* 1594985 */   GIM_Try, /*On fail goto*//*Label 22067*/ GIMT_Encode4(1595071), // Rule ID 3018 //
     /* 1594990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1595001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1595004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1595007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1595010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595036 */     // MIs[0] policy
     /* 1595036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595046 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1595049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595070 */     // GIR_Coverage, 3018,
     /* 1595070 */     GIR_EraseRootFromParent_Done,
     /* 1595071 */   // Label 22067: @1595071
     /* 1595071 */   GIM_Try, /*On fail goto*//*Label 22068*/ GIMT_Encode4(1595157), // Rule ID 3019 //
     /* 1595076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1595087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1595090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1595093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1595096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595122 */     // MIs[0] policy
     /* 1595122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595132 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1595135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595156 */     // GIR_Coverage, 3019,
     /* 1595156 */     GIR_EraseRootFromParent_Done,
     /* 1595157 */   // Label 22068: @1595157
     /* 1595157 */   GIM_Try, /*On fail goto*//*Label 22069*/ GIMT_Encode4(1595243), // Rule ID 3022 //
     /* 1595162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1595173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1595176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1595179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1595182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595208 */     // MIs[0] policy
     /* 1595208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595218 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1595221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595242 */     // GIR_Coverage, 3022,
     /* 1595242 */     GIR_EraseRootFromParent_Done,
     /* 1595243 */   // Label 22069: @1595243
     /* 1595243 */   GIM_Try, /*On fail goto*//*Label 22070*/ GIMT_Encode4(1595329), // Rule ID 3023 //
     /* 1595248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1595259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1595262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1595265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1595268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595294 */     // MIs[0] policy
     /* 1595294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595304 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1595307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595328 */     // GIR_Coverage, 3023,
     /* 1595328 */     GIR_EraseRootFromParent_Done,
     /* 1595329 */   // Label 22070: @1595329
     /* 1595329 */   GIM_Try, /*On fail goto*//*Label 22071*/ GIMT_Encode4(1595415), // Rule ID 3026 //
     /* 1595334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1595345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1595348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1595351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1595354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1595357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595380 */     // MIs[0] policy
     /* 1595380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595390 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1595393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595414 */     // GIR_Coverage, 3026,
     /* 1595414 */     GIR_EraseRootFromParent_Done,
     /* 1595415 */   // Label 22071: @1595415
     /* 1595415 */   GIM_Try, /*On fail goto*//*Label 22072*/ GIMT_Encode4(1595501), // Rule ID 3027 //
     /* 1595420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1595431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1595434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1595437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1595440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1595443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595466 */     // MIs[0] policy
     /* 1595466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595476 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1595479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595500 */     // GIR_Coverage, 3027,
     /* 1595500 */     GIR_EraseRootFromParent_Done,
     /* 1595501 */   // Label 22072: @1595501
     /* 1595501 */   GIM_Try, /*On fail goto*//*Label 22073*/ GIMT_Encode4(1595587), // Rule ID 3030 //
     /* 1595506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1595517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1595520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1595523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1595526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595552 */     // MIs[0] policy
     /* 1595552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595562 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1595565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595586 */     // GIR_Coverage, 3030,
     /* 1595586 */     GIR_EraseRootFromParent_Done,
     /* 1595587 */   // Label 22073: @1595587
     /* 1595587 */   GIM_Try, /*On fail goto*//*Label 22074*/ GIMT_Encode4(1595673), // Rule ID 3031 //
     /* 1595592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1595603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1595606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1595609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1595612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595638 */     // MIs[0] policy
     /* 1595638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595648 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1595651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595672 */     // GIR_Coverage, 3031,
     /* 1595672 */     GIR_EraseRootFromParent_Done,
     /* 1595673 */   // Label 22074: @1595673
     /* 1595673 */   GIM_Try, /*On fail goto*//*Label 22075*/ GIMT_Encode4(1595759), // Rule ID 3034 //
     /* 1595678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1595689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1595692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1595695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1595698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595724 */     // MIs[0] policy
     /* 1595724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595734 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1595737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595758 */     // GIR_Coverage, 3034,
     /* 1595758 */     GIR_EraseRootFromParent_Done,
     /* 1595759 */   // Label 22075: @1595759
     /* 1595759 */   GIM_Try, /*On fail goto*//*Label 22076*/ GIMT_Encode4(1595845), // Rule ID 3035 //
     /* 1595764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1595775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1595778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1595781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1595784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595810 */     // MIs[0] policy
     /* 1595810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595820 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1595823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595844 */     // GIR_Coverage, 3035,
     /* 1595844 */     GIR_EraseRootFromParent_Done,
     /* 1595845 */   // Label 22076: @1595845
     /* 1595845 */   GIM_Try, /*On fail goto*//*Label 22077*/ GIMT_Encode4(1595931), // Rule ID 3038 //
     /* 1595850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1595861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1595864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1595867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1595870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595896 */     // MIs[0] policy
     /* 1595896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595906 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1595909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595930 */     // GIR_Coverage, 3038,
     /* 1595930 */     GIR_EraseRootFromParent_Done,
     /* 1595931 */   // Label 22077: @1595931
     /* 1595931 */   GIM_Try, /*On fail goto*//*Label 22078*/ GIMT_Encode4(1596017), // Rule ID 3039 //
     /* 1595936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1595947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1595950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1595953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1595956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595982 */     // MIs[0] policy
     /* 1595982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595992 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1595995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596016 */     // GIR_Coverage, 3039,
     /* 1596016 */     GIR_EraseRootFromParent_Done,
     /* 1596017 */   // Label 22078: @1596017
     /* 1596017 */   GIM_Try, /*On fail goto*//*Label 22079*/ GIMT_Encode4(1596103), // Rule ID 3042 //
     /* 1596022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1596033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1596036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1596039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1596042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596068 */     // MIs[0] policy
     /* 1596068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596078 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596102 */     // GIR_Coverage, 3042,
     /* 1596102 */     GIR_EraseRootFromParent_Done,
     /* 1596103 */   // Label 22079: @1596103
     /* 1596103 */   GIM_Try, /*On fail goto*//*Label 22080*/ GIMT_Encode4(1596189), // Rule ID 3043 //
     /* 1596108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1596119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1596122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1596125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1596128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596154 */     // MIs[0] policy
     /* 1596154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596188 */     // GIR_Coverage, 3043,
     /* 1596188 */     GIR_EraseRootFromParent_Done,
     /* 1596189 */   // Label 22080: @1596189
     /* 1596189 */   GIM_Try, /*On fail goto*//*Label 22081*/ GIMT_Encode4(1596275), // Rule ID 3046 //
     /* 1596194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1596205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1596208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1596211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1596214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596240 */     // MIs[0] policy
     /* 1596240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596250 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596274 */     // GIR_Coverage, 3046,
     /* 1596274 */     GIR_EraseRootFromParent_Done,
     /* 1596275 */   // Label 22081: @1596275
     /* 1596275 */   GIM_Try, /*On fail goto*//*Label 22082*/ GIMT_Encode4(1596361), // Rule ID 3047 //
     /* 1596280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1596291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1596294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1596297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1596300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596326 */     // MIs[0] policy
     /* 1596326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596336 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596360 */     // GIR_Coverage, 3047,
     /* 1596360 */     GIR_EraseRootFromParent_Done,
     /* 1596361 */   // Label 22082: @1596361
     /* 1596361 */   GIM_Try, /*On fail goto*//*Label 22083*/ GIMT_Encode4(1596447), // Rule ID 3050 //
     /* 1596366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1596377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1596380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1596383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1596386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596412 */     // MIs[0] policy
     /* 1596412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596422 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596446 */     // GIR_Coverage, 3050,
     /* 1596446 */     GIR_EraseRootFromParent_Done,
     /* 1596447 */   // Label 22083: @1596447
     /* 1596447 */   GIM_Try, /*On fail goto*//*Label 22084*/ GIMT_Encode4(1596533), // Rule ID 3051 //
     /* 1596452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1596463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1596466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1596469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1596472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596498 */     // MIs[0] policy
     /* 1596498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596508 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596532 */     // GIR_Coverage, 3051,
     /* 1596532 */     GIR_EraseRootFromParent_Done,
     /* 1596533 */   // Label 22084: @1596533
     /* 1596533 */   GIM_Try, /*On fail goto*//*Label 22085*/ GIMT_Encode4(1596619), // Rule ID 3054 //
     /* 1596538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1596541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1596549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1596552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1596555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1596558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1596561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596584 */     // MIs[0] policy
     /* 1596584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596618 */     // GIR_Coverage, 3054,
     /* 1596618 */     GIR_EraseRootFromParent_Done,
     /* 1596619 */   // Label 22085: @1596619
     /* 1596619 */   GIM_Try, /*On fail goto*//*Label 22086*/ GIMT_Encode4(1596705), // Rule ID 3055 //
     /* 1596624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1596627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1596635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1596638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1596641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1596644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1596647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596670 */     // MIs[0] policy
     /* 1596670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596680 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596704 */     // GIR_Coverage, 3055,
     /* 1596704 */     GIR_EraseRootFromParent_Done,
     /* 1596705 */   // Label 22086: @1596705
     /* 1596705 */   GIM_Try, /*On fail goto*//*Label 22087*/ GIMT_Encode4(1596791), // Rule ID 3058 //
     /* 1596710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1596713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1596721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1596724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1596727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1596730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596756 */     // MIs[0] policy
     /* 1596756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596766 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596790 */     // GIR_Coverage, 3058,
     /* 1596790 */     GIR_EraseRootFromParent_Done,
     /* 1596791 */   // Label 22087: @1596791
     /* 1596791 */   GIM_Try, /*On fail goto*//*Label 22088*/ GIMT_Encode4(1596877), // Rule ID 3059 //
     /* 1596796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1596799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1596807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1596810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1596813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1596816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596842 */     // MIs[0] policy
     /* 1596842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596852 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596876 */     // GIR_Coverage, 3059,
     /* 1596876 */     GIR_EraseRootFromParent_Done,
     /* 1596877 */   // Label 22088: @1596877
     /* 1596877 */   GIM_Try, /*On fail goto*//*Label 22089*/ GIMT_Encode4(1596963), // Rule ID 3062 //
     /* 1596882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1596885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1596893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1596896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1596899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1596902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596928 */     // MIs[0] policy
     /* 1596928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596938 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596962 */     // GIR_Coverage, 3062,
     /* 1596962 */     GIR_EraseRootFromParent_Done,
     /* 1596963 */   // Label 22089: @1596963
     /* 1596963 */   GIM_Try, /*On fail goto*//*Label 22090*/ GIMT_Encode4(1597049), // Rule ID 3063 //
     /* 1596968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1596971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1596979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1596982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1596985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1596988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597014 */     // MIs[0] policy
     /* 1597014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597024 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1597027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597048 */     // GIR_Coverage, 3063,
     /* 1597048 */     GIR_EraseRootFromParent_Done,
     /* 1597049 */   // Label 22090: @1597049
     /* 1597049 */   GIM_Try, /*On fail goto*//*Label 22091*/ GIMT_Encode4(1597135), // Rule ID 3066 //
     /* 1597054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1597065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1597068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1597071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597100 */     // MIs[0] policy
     /* 1597100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597110 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1597113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597134 */     // GIR_Coverage, 3066,
     /* 1597134 */     GIR_EraseRootFromParent_Done,
     /* 1597135 */   // Label 22091: @1597135
     /* 1597135 */   GIM_Try, /*On fail goto*//*Label 22092*/ GIMT_Encode4(1597221), // Rule ID 3067 //
     /* 1597140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1597151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1597154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1597157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597186 */     // MIs[0] policy
     /* 1597186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1597199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597220 */     // GIR_Coverage, 3067,
     /* 1597220 */     GIR_EraseRootFromParent_Done,
     /* 1597221 */   // Label 22092: @1597221
     /* 1597221 */   GIM_Try, /*On fail goto*//*Label 22093*/ GIMT_Encode4(1597307), // Rule ID 3070 //
     /* 1597226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1597237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1597240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1597243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597272 */     // MIs[0] policy
     /* 1597272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597282 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1597285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597306 */     // GIR_Coverage, 3070,
     /* 1597306 */     GIR_EraseRootFromParent_Done,
     /* 1597307 */   // Label 22093: @1597307
     /* 1597307 */   GIM_Try, /*On fail goto*//*Label 22094*/ GIMT_Encode4(1597393), // Rule ID 3071 //
     /* 1597312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1597323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1597326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1597329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597358 */     // MIs[0] policy
     /* 1597358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597368 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1597371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597392 */     // GIR_Coverage, 3071,
     /* 1597392 */     GIR_EraseRootFromParent_Done,
     /* 1597393 */   // Label 22094: @1597393
     /* 1597393 */   GIM_Try, /*On fail goto*//*Label 22095*/ GIMT_Encode4(1597479), // Rule ID 3074 //
     /* 1597398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1597409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1597412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1597415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597444 */     // MIs[0] policy
     /* 1597444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597454 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1597457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597478 */     // GIR_Coverage, 3074,
     /* 1597478 */     GIR_EraseRootFromParent_Done,
     /* 1597479 */   // Label 22095: @1597479
     /* 1597479 */   GIM_Try, /*On fail goto*//*Label 22096*/ GIMT_Encode4(1597565), // Rule ID 3075 //
     /* 1597484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1597495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1597498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1597501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597530 */     // MIs[0] policy
     /* 1597530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597540 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1597543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597564 */     // GIR_Coverage, 3075,
     /* 1597564 */     GIR_EraseRootFromParent_Done,
     /* 1597565 */   // Label 22096: @1597565
     /* 1597565 */   GIM_Try, /*On fail goto*//*Label 22097*/ GIMT_Encode4(1597651), // Rule ID 3078 //
     /* 1597570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1597581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1597584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1597587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597616 */     // MIs[0] policy
     /* 1597616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597626 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1597629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597650 */     // GIR_Coverage, 3078,
     /* 1597650 */     GIR_EraseRootFromParent_Done,
     /* 1597651 */   // Label 22097: @1597651
     /* 1597651 */   GIM_Try, /*On fail goto*//*Label 22098*/ GIMT_Encode4(1597737), // Rule ID 3079 //
     /* 1597656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1597667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1597670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1597673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597702 */     // MIs[0] policy
     /* 1597702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597712 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1597715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597736 */     // GIR_Coverage, 3079,
     /* 1597736 */     GIR_EraseRootFromParent_Done,
     /* 1597737 */   // Label 22098: @1597737
     /* 1597737 */   GIM_Try, /*On fail goto*//*Label 22099*/ GIMT_Encode4(1597823), // Rule ID 3082 //
     /* 1597742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1597753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1597756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1597759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597788 */     // MIs[0] policy
     /* 1597788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597798 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1597801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597822 */     // GIR_Coverage, 3082,
     /* 1597822 */     GIR_EraseRootFromParent_Done,
     /* 1597823 */   // Label 22099: @1597823
     /* 1597823 */   GIM_Try, /*On fail goto*//*Label 22100*/ GIMT_Encode4(1597909), // Rule ID 3083 //
     /* 1597828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1597839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1597842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1597845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597874 */     // MIs[0] policy
     /* 1597874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597884 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1597887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597908 */     // GIR_Coverage, 3083,
     /* 1597908 */     GIR_EraseRootFromParent_Done,
     /* 1597909 */   // Label 22100: @1597909
     /* 1597909 */   GIM_Try, /*On fail goto*//*Label 22101*/ GIMT_Encode4(1597995), // Rule ID 3086 //
     /* 1597914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1597925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1597928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1597931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597960 */     // MIs[0] policy
     /* 1597960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597970 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1597973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597994 */     // GIR_Coverage, 3086,
     /* 1597994 */     GIR_EraseRootFromParent_Done,
     /* 1597995 */   // Label 22101: @1597995
     /* 1597995 */   GIM_Try, /*On fail goto*//*Label 22102*/ GIMT_Encode4(1598081), // Rule ID 3087 //
     /* 1598000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1598011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1598014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1598017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598046 */     // MIs[0] policy
     /* 1598046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598056 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1598059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598080 */     // GIR_Coverage, 3087,
     /* 1598080 */     GIR_EraseRootFromParent_Done,
     /* 1598081 */   // Label 22102: @1598081
     /* 1598081 */   GIM_Try, /*On fail goto*//*Label 22103*/ GIMT_Encode4(1598167), // Rule ID 3090 //
     /* 1598086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1598097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1598100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1598103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598132 */     // MIs[0] policy
     /* 1598132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598142 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598166 */     // GIR_Coverage, 3090,
     /* 1598166 */     GIR_EraseRootFromParent_Done,
     /* 1598167 */   // Label 22103: @1598167
     /* 1598167 */   GIM_Try, /*On fail goto*//*Label 22104*/ GIMT_Encode4(1598253), // Rule ID 3091 //
     /* 1598172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1598183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1598186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1598189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598218 */     // MIs[0] policy
     /* 1598218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598228 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598252 */     // GIR_Coverage, 3091,
     /* 1598252 */     GIR_EraseRootFromParent_Done,
     /* 1598253 */   // Label 22104: @1598253
     /* 1598253 */   GIM_Try, /*On fail goto*//*Label 22105*/ GIMT_Encode4(1598339), // Rule ID 3094 //
     /* 1598258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1598269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1598272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1598275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598304 */     // MIs[0] policy
     /* 1598304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598314 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598338 */     // GIR_Coverage, 3094,
     /* 1598338 */     GIR_EraseRootFromParent_Done,
     /* 1598339 */   // Label 22105: @1598339
     /* 1598339 */   GIM_Try, /*On fail goto*//*Label 22106*/ GIMT_Encode4(1598425), // Rule ID 3095 //
     /* 1598344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1598355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1598358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1598361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598390 */     // MIs[0] policy
     /* 1598390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598424 */     // GIR_Coverage, 3095,
     /* 1598424 */     GIR_EraseRootFromParent_Done,
     /* 1598425 */   // Label 22106: @1598425
     /* 1598425 */   GIM_Try, /*On fail goto*//*Label 22107*/ GIMT_Encode4(1598511), // Rule ID 3098 //
     /* 1598430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1598441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1598444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1598447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598476 */     // MIs[0] policy
     /* 1598476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598486 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598510 */     // GIR_Coverage, 3098,
     /* 1598510 */     GIR_EraseRootFromParent_Done,
     /* 1598511 */   // Label 22107: @1598511
     /* 1598511 */   GIM_Try, /*On fail goto*//*Label 22108*/ GIMT_Encode4(1598597), // Rule ID 3099 //
     /* 1598516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1598527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1598530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1598533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598562 */     // MIs[0] policy
     /* 1598562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598572 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598596 */     // GIR_Coverage, 3099,
     /* 1598596 */     GIR_EraseRootFromParent_Done,
     /* 1598597 */   // Label 22108: @1598597
     /* 1598597 */   GIM_Try, /*On fail goto*//*Label 22109*/ GIMT_Encode4(1598683), // Rule ID 3102 //
     /* 1598602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1598605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1598613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1598616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1598619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598648 */     // MIs[0] policy
     /* 1598648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598658 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598682 */     // GIR_Coverage, 3102,
     /* 1598682 */     GIR_EraseRootFromParent_Done,
     /* 1598683 */   // Label 22109: @1598683
     /* 1598683 */   GIM_Try, /*On fail goto*//*Label 22110*/ GIMT_Encode4(1598769), // Rule ID 3103 //
     /* 1598688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1598691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1598699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1598702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1598705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598734 */     // MIs[0] policy
     /* 1598734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598744 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598768 */     // GIR_Coverage, 3103,
     /* 1598768 */     GIR_EraseRootFromParent_Done,
     /* 1598769 */   // Label 22110: @1598769
     /* 1598769 */   GIM_Try, /*On fail goto*//*Label 22111*/ GIMT_Encode4(1598855), // Rule ID 3106 //
     /* 1598774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1598785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1598788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1598791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1598797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1598804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598820 */     // MIs[0] policy
     /* 1598820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598830 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1598833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598854 */     // GIR_Coverage, 3106,
     /* 1598854 */     GIR_EraseRootFromParent_Done,
     /* 1598855 */   // Label 22111: @1598855
     /* 1598855 */   GIM_Try, /*On fail goto*//*Label 22112*/ GIMT_Encode4(1598941), // Rule ID 3107 //
     /* 1598860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1598871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1598874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1598877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1598883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1598890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598906 */     // MIs[0] policy
     /* 1598906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598916 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1598919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598940 */     // GIR_Coverage, 3107,
     /* 1598940 */     GIR_EraseRootFromParent_Done,
     /* 1598941 */   // Label 22112: @1598941
     /* 1598941 */   GIM_Try, /*On fail goto*//*Label 22113*/ GIMT_Encode4(1599027), // Rule ID 3110 //
     /* 1598946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1598957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1598960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1598963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1598969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1598976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1598980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1598984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598992 */     // MIs[0] policy
     /* 1598992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599002 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1599005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599026 */     // GIR_Coverage, 3110,
     /* 1599026 */     GIR_EraseRootFromParent_Done,
     /* 1599027 */   // Label 22113: @1599027
     /* 1599027 */   GIM_Try, /*On fail goto*//*Label 22114*/ GIMT_Encode4(1599113), // Rule ID 3111 //
     /* 1599032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1599043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1599046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1599049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599078 */     // MIs[0] policy
     /* 1599078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599088 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1599091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599112 */     // GIR_Coverage, 3111,
     /* 1599112 */     GIR_EraseRootFromParent_Done,
     /* 1599113 */   // Label 22114: @1599113
     /* 1599113 */   GIM_Try, /*On fail goto*//*Label 22115*/ GIMT_Encode4(1599199), // Rule ID 3114 //
     /* 1599118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1599129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1599132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1599135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1599141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599164 */     // MIs[0] policy
     /* 1599164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599174 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1599177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599198 */     // GIR_Coverage, 3114,
     /* 1599198 */     GIR_EraseRootFromParent_Done,
     /* 1599199 */   // Label 22115: @1599199
     /* 1599199 */   GIM_Try, /*On fail goto*//*Label 22116*/ GIMT_Encode4(1599285), // Rule ID 3115 //
     /* 1599204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1599215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1599218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1599221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1599227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599250 */     // MIs[0] policy
     /* 1599250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599260 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1599263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599284 */     // GIR_Coverage, 3115,
     /* 1599284 */     GIR_EraseRootFromParent_Done,
     /* 1599285 */   // Label 22116: @1599285
     /* 1599285 */   GIM_Try, /*On fail goto*//*Label 22117*/ GIMT_Encode4(1599371), // Rule ID 3118 //
     /* 1599290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1599301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1599304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1599307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599336 */     // MIs[0] policy
     /* 1599336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599370 */     // GIR_Coverage, 3118,
     /* 1599370 */     GIR_EraseRootFromParent_Done,
     /* 1599371 */   // Label 22117: @1599371
     /* 1599371 */   GIM_Try, /*On fail goto*//*Label 22118*/ GIMT_Encode4(1599457), // Rule ID 3119 //
     /* 1599376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1599387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1599390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1599393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599422 */     // MIs[0] policy
     /* 1599422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599432 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599456 */     // GIR_Coverage, 3119,
     /* 1599456 */     GIR_EraseRootFromParent_Done,
     /* 1599457 */   // Label 22118: @1599457
     /* 1599457 */   GIM_Try, /*On fail goto*//*Label 22119*/ GIMT_Encode4(1599543), // Rule ID 3122 //
     /* 1599462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1599473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1599476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1599479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599508 */     // MIs[0] policy
     /* 1599508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599518 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1599521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599542 */     // GIR_Coverage, 3122,
     /* 1599542 */     GIR_EraseRootFromParent_Done,
     /* 1599543 */   // Label 22119: @1599543
     /* 1599543 */   GIM_Try, /*On fail goto*//*Label 22120*/ GIMT_Encode4(1599629), // Rule ID 3123 //
     /* 1599548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1599559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1599562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1599565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599594 */     // MIs[0] policy
     /* 1599594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599604 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1599607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599628 */     // GIR_Coverage, 3123,
     /* 1599628 */     GIR_EraseRootFromParent_Done,
     /* 1599629 */   // Label 22120: @1599629
     /* 1599629 */   GIM_Try, /*On fail goto*//*Label 22121*/ GIMT_Encode4(1599715), // Rule ID 3126 //
     /* 1599634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1599645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1599648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1599651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599680 */     // MIs[0] policy
     /* 1599680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599690 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1599693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599714 */     // GIR_Coverage, 3126,
     /* 1599714 */     GIR_EraseRootFromParent_Done,
     /* 1599715 */   // Label 22121: @1599715
     /* 1599715 */   GIM_Try, /*On fail goto*//*Label 22122*/ GIMT_Encode4(1599801), // Rule ID 3127 //
     /* 1599720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1599731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1599734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1599737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599766 */     // MIs[0] policy
     /* 1599766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1599779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599800 */     // GIR_Coverage, 3127,
     /* 1599800 */     GIR_EraseRootFromParent_Done,
     /* 1599801 */   // Label 22122: @1599801
     /* 1599801 */   GIM_Try, /*On fail goto*//*Label 22123*/ GIMT_Encode4(1599887), // Rule ID 3130 //
     /* 1599806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1599817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1599820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1599823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1599829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599852 */     // MIs[0] policy
     /* 1599852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1599883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599886 */     // GIR_Coverage, 3130,
     /* 1599886 */     GIR_EraseRootFromParent_Done,
     /* 1599887 */   // Label 22123: @1599887
     /* 1599887 */   GIM_Try, /*On fail goto*//*Label 22124*/ GIMT_Encode4(1599973), // Rule ID 3131 //
     /* 1599892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1599903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1599906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1599909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1599915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599938 */     // MIs[0] policy
     /* 1599938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1599969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599972 */     // GIR_Coverage, 3131,
     /* 1599972 */     GIR_EraseRootFromParent_Done,
     /* 1599973 */   // Label 22124: @1599973
     /* 1599973 */   GIM_Try, /*On fail goto*//*Label 22125*/ GIMT_Encode4(1600059), // Rule ID 3134 //
     /* 1599978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1599989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1599992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1599995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600024 */     // MIs[0] policy
     /* 1600024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600034 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600058 */     // GIR_Coverage, 3134,
     /* 1600058 */     GIR_EraseRootFromParent_Done,
     /* 1600059 */   // Label 22125: @1600059
     /* 1600059 */   GIM_Try, /*On fail goto*//*Label 22126*/ GIMT_Encode4(1600145), // Rule ID 3135 //
     /* 1600064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1600075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1600078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1600081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600110 */     // MIs[0] policy
     /* 1600110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600120 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600144 */     // GIR_Coverage, 3135,
     /* 1600144 */     GIR_EraseRootFromParent_Done,
     /* 1600145 */   // Label 22126: @1600145
     /* 1600145 */   GIM_Try, /*On fail goto*//*Label 22127*/ GIMT_Encode4(1600231), // Rule ID 3138 //
     /* 1600150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1600161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1600164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1600167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600196 */     // MIs[0] policy
     /* 1600196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600206 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600230 */     // GIR_Coverage, 3138,
     /* 1600230 */     GIR_EraseRootFromParent_Done,
     /* 1600231 */   // Label 22127: @1600231
     /* 1600231 */   GIM_Try, /*On fail goto*//*Label 22128*/ GIMT_Encode4(1600317), // Rule ID 3139 //
     /* 1600236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1600247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1600250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1600253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600282 */     // MIs[0] policy
     /* 1600282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600292 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600316 */     // GIR_Coverage, 3139,
     /* 1600316 */     GIR_EraseRootFromParent_Done,
     /* 1600317 */   // Label 22128: @1600317
     /* 1600317 */   GIM_Try, /*On fail goto*//*Label 22129*/ GIMT_Encode4(1600403), // Rule ID 3142 //
     /* 1600322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1600333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1600336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1600339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600368 */     // MIs[0] policy
     /* 1600368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600378 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1600381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600402 */     // GIR_Coverage, 3142,
     /* 1600402 */     GIR_EraseRootFromParent_Done,
     /* 1600403 */   // Label 22129: @1600403
     /* 1600403 */   GIM_Try, /*On fail goto*//*Label 22130*/ GIMT_Encode4(1600489), // Rule ID 3143 //
     /* 1600408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1600411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1600419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1600422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1600425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600454 */     // MIs[0] policy
     /* 1600454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600464 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1600467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600488 */     // GIR_Coverage, 3143,
     /* 1600488 */     GIR_EraseRootFromParent_Done,
     /* 1600489 */   // Label 22130: @1600489
     /* 1600489 */   GIM_Try, /*On fail goto*//*Label 22131*/ GIMT_Encode4(1600575), // Rule ID 3146 //
     /* 1600494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1600505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1600508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1600511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600540 */     // MIs[0] policy
     /* 1600540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600550 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600574 */     // GIR_Coverage, 3146,
     /* 1600574 */     GIR_EraseRootFromParent_Done,
     /* 1600575 */   // Label 22131: @1600575
     /* 1600575 */   GIM_Try, /*On fail goto*//*Label 22132*/ GIMT_Encode4(1600661), // Rule ID 3147 //
     /* 1600580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1600583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1600591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1600594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1600597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600626 */     // MIs[0] policy
     /* 1600626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600636 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600660 */     // GIR_Coverage, 3147,
     /* 1600660 */     GIR_EraseRootFromParent_Done,
     /* 1600661 */   // Label 22132: @1600661
     /* 1600661 */   GIM_Try, /*On fail goto*//*Label 22133*/ GIMT_Encode4(1600747), // Rule ID 3150 //
     /* 1600666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1600677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1600680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1600683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600712 */     // MIs[0] policy
     /* 1600712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600722 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600746 */     // GIR_Coverage, 3150,
     /* 1600746 */     GIR_EraseRootFromParent_Done,
     /* 1600747 */   // Label 22133: @1600747
     /* 1600747 */   GIM_Try, /*On fail goto*//*Label 22134*/ GIMT_Encode4(1600833), // Rule ID 3151 //
     /* 1600752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1600755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1600763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1600766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1600769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600798 */     // MIs[0] policy
     /* 1600798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600808 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600832 */     // GIR_Coverage, 3151,
     /* 1600832 */     GIR_EraseRootFromParent_Done,
     /* 1600833 */   // Label 22134: @1600833
     /* 1600833 */   GIM_Try, /*On fail goto*//*Label 22135*/ GIMT_Encode4(1600919), // Rule ID 3242 //
     /* 1600838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1600849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1600852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1600855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1600858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1600861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600884 */     // MIs[0] policy
     /* 1600884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600894 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1600897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600918 */     // GIR_Coverage, 3242,
     /* 1600918 */     GIR_EraseRootFromParent_Done,
     /* 1600919 */   // Label 22135: @1600919
     /* 1600919 */   GIM_Try, /*On fail goto*//*Label 22136*/ GIMT_Encode4(1601005), // Rule ID 3243 //
     /* 1600924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1600935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1600938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1600941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1600944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1600947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600970 */     // MIs[0] policy
     /* 1600970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600980 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1600983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601004 */     // GIR_Coverage, 3243,
     /* 1601004 */     GIR_EraseRootFromParent_Done,
     /* 1601005 */   // Label 22136: @1601005
     /* 1601005 */   GIM_Try, /*On fail goto*//*Label 22137*/ GIMT_Encode4(1601091), // Rule ID 3246 //
     /* 1601010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1601021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1601024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1601027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1601030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601056 */     // MIs[0] policy
     /* 1601056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601066 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601090 */     // GIR_Coverage, 3246,
     /* 1601090 */     GIR_EraseRootFromParent_Done,
     /* 1601091 */   // Label 22137: @1601091
     /* 1601091 */   GIM_Try, /*On fail goto*//*Label 22138*/ GIMT_Encode4(1601177), // Rule ID 3247 //
     /* 1601096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1601107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1601110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1601113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1601116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601142 */     // MIs[0] policy
     /* 1601142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601152 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601176 */     // GIR_Coverage, 3247,
     /* 1601176 */     GIR_EraseRootFromParent_Done,
     /* 1601177 */   // Label 22138: @1601177
     /* 1601177 */   GIM_Try, /*On fail goto*//*Label 22139*/ GIMT_Encode4(1601263), // Rule ID 3250 //
     /* 1601182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1601193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1601196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1601199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1601202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601228 */     // MIs[0] policy
     /* 1601228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601238 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601262 */     // GIR_Coverage, 3250,
     /* 1601262 */     GIR_EraseRootFromParent_Done,
     /* 1601263 */   // Label 22139: @1601263
     /* 1601263 */   GIM_Try, /*On fail goto*//*Label 22140*/ GIMT_Encode4(1601349), // Rule ID 3251 //
     /* 1601268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1601279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1601282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1601285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1601288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601314 */     // MIs[0] policy
     /* 1601314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601324 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601348 */     // GIR_Coverage, 3251,
     /* 1601348 */     GIR_EraseRootFromParent_Done,
     /* 1601349 */   // Label 22140: @1601349
     /* 1601349 */   GIM_Try, /*On fail goto*//*Label 22141*/ GIMT_Encode4(1601435), // Rule ID 3254 //
     /* 1601354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1601365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1601368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1601371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1601374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601400 */     // MIs[0] policy
     /* 1601400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601410 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601434 */     // GIR_Coverage, 3254,
     /* 1601434 */     GIR_EraseRootFromParent_Done,
     /* 1601435 */   // Label 22141: @1601435
     /* 1601435 */   GIM_Try, /*On fail goto*//*Label 22142*/ GIMT_Encode4(1601521), // Rule ID 3255 //
     /* 1601440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1601451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1601454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1601457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1601460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601486 */     // MIs[0] policy
     /* 1601486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601496 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601520 */     // GIR_Coverage, 3255,
     /* 1601520 */     GIR_EraseRootFromParent_Done,
     /* 1601521 */   // Label 22142: @1601521
     /* 1601521 */   GIM_Try, /*On fail goto*//*Label 22143*/ GIMT_Encode4(1601607), // Rule ID 3258 //
     /* 1601526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1601537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1601540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1601543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1601546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601572 */     // MIs[0] policy
     /* 1601572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601582 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601606 */     // GIR_Coverage, 3258,
     /* 1601606 */     GIR_EraseRootFromParent_Done,
     /* 1601607 */   // Label 22143: @1601607
     /* 1601607 */   GIM_Try, /*On fail goto*//*Label 22144*/ GIMT_Encode4(1601693), // Rule ID 3259 //
     /* 1601612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1601623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1601626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1601629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1601632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601658 */     // MIs[0] policy
     /* 1601658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601668 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601692 */     // GIR_Coverage, 3259,
     /* 1601692 */     GIR_EraseRootFromParent_Done,
     /* 1601693 */   // Label 22144: @1601693
     /* 1601693 */   GIM_Try, /*On fail goto*//*Label 22145*/ GIMT_Encode4(1601779), // Rule ID 3262 //
     /* 1601698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1601709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1601712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1601715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1601718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601744 */     // MIs[0] policy
     /* 1601744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601754 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601778 */     // GIR_Coverage, 3262,
     /* 1601778 */     GIR_EraseRootFromParent_Done,
     /* 1601779 */   // Label 22145: @1601779
     /* 1601779 */   GIM_Try, /*On fail goto*//*Label 22146*/ GIMT_Encode4(1601865), // Rule ID 3263 //
     /* 1601784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1601795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1601798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1601801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1601804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601830 */     // MIs[0] policy
     /* 1601830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601864 */     // GIR_Coverage, 3263,
     /* 1601864 */     GIR_EraseRootFromParent_Done,
     /* 1601865 */   // Label 22146: @1601865
     /* 1601865 */   GIM_Try, /*On fail goto*//*Label 22147*/ GIMT_Encode4(1601951), // Rule ID 3266 //
     /* 1601870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1601881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1601884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1601887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1601890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601916 */     // MIs[0] policy
     /* 1601916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601926 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1601929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601950 */     // GIR_Coverage, 3266,
     /* 1601950 */     GIR_EraseRootFromParent_Done,
     /* 1601951 */   // Label 22147: @1601951
     /* 1601951 */   GIM_Try, /*On fail goto*//*Label 22148*/ GIMT_Encode4(1602037), // Rule ID 3267 //
     /* 1601956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1601967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1601970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1601973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1601976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602002 */     // MIs[0] policy
     /* 1602002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602012 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602036 */     // GIR_Coverage, 3267,
     /* 1602036 */     GIR_EraseRootFromParent_Done,
     /* 1602037 */   // Label 22148: @1602037
     /* 1602037 */   GIM_Try, /*On fail goto*//*Label 22149*/ GIMT_Encode4(1602123), // Rule ID 3270 //
     /* 1602042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1602053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1602056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1602059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1602062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602088 */     // MIs[0] policy
     /* 1602088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602098 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602122 */     // GIR_Coverage, 3270,
     /* 1602122 */     GIR_EraseRootFromParent_Done,
     /* 1602123 */   // Label 22149: @1602123
     /* 1602123 */   GIM_Try, /*On fail goto*//*Label 22150*/ GIMT_Encode4(1602209), // Rule ID 3271 //
     /* 1602128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1602139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1602142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1602145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1602148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602174 */     // MIs[0] policy
     /* 1602174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602208 */     // GIR_Coverage, 3271,
     /* 1602208 */     GIR_EraseRootFromParent_Done,
     /* 1602209 */   // Label 22150: @1602209
     /* 1602209 */   GIM_Try, /*On fail goto*//*Label 22151*/ GIMT_Encode4(1602295), // Rule ID 3274 //
     /* 1602214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1602225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1602228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1602231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1602234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602260 */     // MIs[0] policy
     /* 1602260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602294 */     // GIR_Coverage, 3274,
     /* 1602294 */     GIR_EraseRootFromParent_Done,
     /* 1602295 */   // Label 22151: @1602295
     /* 1602295 */   GIM_Try, /*On fail goto*//*Label 22152*/ GIMT_Encode4(1602381), // Rule ID 3275 //
     /* 1602300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1602311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1602314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1602317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1602320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602346 */     // MIs[0] policy
     /* 1602346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602356 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602380 */     // GIR_Coverage, 3275,
     /* 1602380 */     GIR_EraseRootFromParent_Done,
     /* 1602381 */   // Label 22152: @1602381
     /* 1602381 */   GIM_Try, /*On fail goto*//*Label 22153*/ GIMT_Encode4(1602467), // Rule ID 3278 //
     /* 1602386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1602389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1602397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1602400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1602403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1602406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602432 */     // MIs[0] policy
     /* 1602432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602442 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1602463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602466 */     // GIR_Coverage, 3278,
     /* 1602466 */     GIR_EraseRootFromParent_Done,
     /* 1602467 */   // Label 22153: @1602467
     /* 1602467 */   GIM_Try, /*On fail goto*//*Label 22154*/ GIMT_Encode4(1602553), // Rule ID 3279 //
     /* 1602472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1602475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1602483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1602486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1602489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1602492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602518 */     // MIs[0] policy
     /* 1602518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602528 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1602549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602552 */     // GIR_Coverage, 3279,
     /* 1602552 */     GIR_EraseRootFromParent_Done,
     /* 1602553 */   // Label 22154: @1602553
     /* 1602553 */   GIM_Try, /*On fail goto*//*Label 22155*/ GIMT_Encode4(1602639), // Rule ID 3282 //
     /* 1602558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1602569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1602572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1602575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1602578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1602581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1602588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602604 */     // MIs[0] policy
     /* 1602604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602614 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1602617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602638 */     // GIR_Coverage, 3282,
     /* 1602638 */     GIR_EraseRootFromParent_Done,
     /* 1602639 */   // Label 22155: @1602639
     /* 1602639 */   GIM_Try, /*On fail goto*//*Label 22156*/ GIMT_Encode4(1602725), // Rule ID 3283 //
     /* 1602644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1602655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1602658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1602661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1602664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1602667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1602674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602690 */     // MIs[0] policy
     /* 1602690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602700 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1602703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602724 */     // GIR_Coverage, 3283,
     /* 1602724 */     GIR_EraseRootFromParent_Done,
     /* 1602725 */   // Label 22156: @1602725
     /* 1602725 */   GIM_Try, /*On fail goto*//*Label 22157*/ GIMT_Encode4(1602811), // Rule ID 3286 //
     /* 1602730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1602741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1602744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1602747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1602750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1602753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1602760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602776 */     // MIs[0] policy
     /* 1602776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602786 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1602789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602810 */     // GIR_Coverage, 3286,
     /* 1602810 */     GIR_EraseRootFromParent_Done,
     /* 1602811 */   // Label 22157: @1602811
     /* 1602811 */   GIM_Try, /*On fail goto*//*Label 22158*/ GIMT_Encode4(1602897), // Rule ID 3287 //
     /* 1602816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1602827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1602830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1602833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1602836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1602839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1602846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602862 */     // MIs[0] policy
     /* 1602862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602872 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1602875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602896 */     // GIR_Coverage, 3287,
     /* 1602896 */     GIR_EraseRootFromParent_Done,
     /* 1602897 */   // Label 22158: @1602897
     /* 1602897 */   GIM_Try, /*On fail goto*//*Label 22159*/ GIMT_Encode4(1602983), // Rule ID 3290 //
     /* 1602902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1602913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1602916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1602919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1602922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1602925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1602932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602948 */     // MIs[0] policy
     /* 1602948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602958 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1602961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602982 */     // GIR_Coverage, 3290,
     /* 1602982 */     GIR_EraseRootFromParent_Done,
     /* 1602983 */   // Label 22159: @1602983
     /* 1602983 */   GIM_Try, /*On fail goto*//*Label 22160*/ GIMT_Encode4(1603069), // Rule ID 3291 //
     /* 1602988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1602999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1603002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1603005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1603008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1603011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603034 */     // MIs[0] policy
     /* 1603034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603044 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603068 */     // GIR_Coverage, 3291,
     /* 1603068 */     GIR_EraseRootFromParent_Done,
     /* 1603069 */   // Label 22160: @1603069
     /* 1603069 */   GIM_Try, /*On fail goto*//*Label 22161*/ GIMT_Encode4(1603155), // Rule ID 3294 //
     /* 1603074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1603085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1603088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1603091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1603094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603120 */     // MIs[0] policy
     /* 1603120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603154 */     // GIR_Coverage, 3294,
     /* 1603154 */     GIR_EraseRootFromParent_Done,
     /* 1603155 */   // Label 22161: @1603155
     /* 1603155 */   GIM_Try, /*On fail goto*//*Label 22162*/ GIMT_Encode4(1603241), // Rule ID 3295 //
     /* 1603160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1603171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1603174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1603177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1603180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603206 */     // MIs[0] policy
     /* 1603206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603240 */     // GIR_Coverage, 3295,
     /* 1603240 */     GIR_EraseRootFromParent_Done,
     /* 1603241 */   // Label 22162: @1603241
     /* 1603241 */   GIM_Try, /*On fail goto*//*Label 22163*/ GIMT_Encode4(1603327), // Rule ID 3298 //
     /* 1603246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1603257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1603260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1603263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1603266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603292 */     // MIs[0] policy
     /* 1603292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603302 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603326 */     // GIR_Coverage, 3298,
     /* 1603326 */     GIR_EraseRootFromParent_Done,
     /* 1603327 */   // Label 22163: @1603327
     /* 1603327 */   GIM_Try, /*On fail goto*//*Label 22164*/ GIMT_Encode4(1603413), // Rule ID 3299 //
     /* 1603332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1603343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1603346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1603349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1603352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603378 */     // MIs[0] policy
     /* 1603378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603388 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603412 */     // GIR_Coverage, 3299,
     /* 1603412 */     GIR_EraseRootFromParent_Done,
     /* 1603413 */   // Label 22164: @1603413
     /* 1603413 */   GIM_Try, /*On fail goto*//*Label 22165*/ GIMT_Encode4(1603499), // Rule ID 3302 //
     /* 1603418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1603429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1603432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1603435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1603438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603464 */     // MIs[0] policy
     /* 1603464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603474 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603498 */     // GIR_Coverage, 3302,
     /* 1603498 */     GIR_EraseRootFromParent_Done,
     /* 1603499 */   // Label 22165: @1603499
     /* 1603499 */   GIM_Try, /*On fail goto*//*Label 22166*/ GIMT_Encode4(1603585), // Rule ID 3303 //
     /* 1603504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1603515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1603518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1603521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1603524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603550 */     // MIs[0] policy
     /* 1603550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603560 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603584 */     // GIR_Coverage, 3303,
     /* 1603584 */     GIR_EraseRootFromParent_Done,
     /* 1603585 */   // Label 22166: @1603585
     /* 1603585 */   GIM_Try, /*On fail goto*//*Label 22167*/ GIMT_Encode4(1603671), // Rule ID 3306 //
     /* 1603590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1603601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1603604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1603607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1603610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603636 */     // MIs[0] policy
     /* 1603636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603670 */     // GIR_Coverage, 3306,
     /* 1603670 */     GIR_EraseRootFromParent_Done,
     /* 1603671 */   // Label 22167: @1603671
     /* 1603671 */   GIM_Try, /*On fail goto*//*Label 22168*/ GIMT_Encode4(1603757), // Rule ID 3307 //
     /* 1603676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1603687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1603690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1603693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1603696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603722 */     // MIs[0] policy
     /* 1603722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603756 */     // GIR_Coverage, 3307,
     /* 1603756 */     GIR_EraseRootFromParent_Done,
     /* 1603757 */   // Label 22168: @1603757
     /* 1603757 */   GIM_Try, /*On fail goto*//*Label 22169*/ GIMT_Encode4(1603843), // Rule ID 3310 //
     /* 1603762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1603773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1603776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1603779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1603782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603808 */     // MIs[0] policy
     /* 1603808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603818 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603842 */     // GIR_Coverage, 3310,
     /* 1603842 */     GIR_EraseRootFromParent_Done,
     /* 1603843 */   // Label 22169: @1603843
     /* 1603843 */   GIM_Try, /*On fail goto*//*Label 22170*/ GIMT_Encode4(1603929), // Rule ID 3311 //
     /* 1603848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1603859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1603862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1603865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1603868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603894 */     // MIs[0] policy
     /* 1603894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603904 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603928 */     // GIR_Coverage, 3311,
     /* 1603928 */     GIR_EraseRootFromParent_Done,
     /* 1603929 */   // Label 22170: @1603929
     /* 1603929 */   GIM_Try, /*On fail goto*//*Label 22171*/ GIMT_Encode4(1604015), // Rule ID 3314 //
     /* 1603934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1603945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1603948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1603951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1603954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603980 */     // MIs[0] policy
     /* 1603980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603990 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604014 */     // GIR_Coverage, 3314,
     /* 1604014 */     GIR_EraseRootFromParent_Done,
     /* 1604015 */   // Label 22171: @1604015
     /* 1604015 */   GIM_Try, /*On fail goto*//*Label 22172*/ GIMT_Encode4(1604101), // Rule ID 3315 //
     /* 1604020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1604031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1604034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1604037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1604040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604066 */     // MIs[0] policy
     /* 1604066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604100 */     // GIR_Coverage, 3315,
     /* 1604100 */     GIR_EraseRootFromParent_Done,
     /* 1604101 */   // Label 22172: @1604101
     /* 1604101 */   GIM_Try, /*On fail goto*//*Label 22173*/ GIMT_Encode4(1604187), // Rule ID 3318 //
     /* 1604106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1604117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1604120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1604123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1604126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604152 */     // MIs[0] policy
     /* 1604152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604162 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1604165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604186 */     // GIR_Coverage, 3318,
     /* 1604186 */     GIR_EraseRootFromParent_Done,
     /* 1604187 */   // Label 22173: @1604187
     /* 1604187 */   GIM_Try, /*On fail goto*//*Label 22174*/ GIMT_Encode4(1604273), // Rule ID 3319 //
     /* 1604192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1604203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1604206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1604209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1604212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604238 */     // MIs[0] policy
     /* 1604238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604248 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1604251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604272 */     // GIR_Coverage, 3319,
     /* 1604272 */     GIR_EraseRootFromParent_Done,
     /* 1604273 */   // Label 22174: @1604273
     /* 1604273 */   GIM_Try, /*On fail goto*//*Label 22175*/ GIMT_Encode4(1604359), // Rule ID 3322 //
     /* 1604278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1604289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1604292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1604295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1604298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604324 */     // MIs[0] policy
     /* 1604324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604334 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1604337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604358 */     // GIR_Coverage, 3322,
     /* 1604358 */     GIR_EraseRootFromParent_Done,
     /* 1604359 */   // Label 22175: @1604359
     /* 1604359 */   GIM_Try, /*On fail goto*//*Label 22176*/ GIMT_Encode4(1604445), // Rule ID 3323 //
     /* 1604364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1604375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1604378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1604381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1604384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604410 */     // MIs[0] policy
     /* 1604410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604420 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1604423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604444 */     // GIR_Coverage, 3323,
     /* 1604444 */     GIR_EraseRootFromParent_Done,
     /* 1604445 */   // Label 22176: @1604445
     /* 1604445 */   GIM_Try, /*On fail goto*//*Label 22177*/ GIMT_Encode4(1604531), // Rule ID 3326 //
     /* 1604450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1604461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1604464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1604467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1604470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604496 */     // MIs[0] policy
     /* 1604496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604506 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604530 */     // GIR_Coverage, 3326,
     /* 1604530 */     GIR_EraseRootFromParent_Done,
     /* 1604531 */   // Label 22177: @1604531
     /* 1604531 */   GIM_Try, /*On fail goto*//*Label 22178*/ GIMT_Encode4(1604617), // Rule ID 3327 //
     /* 1604536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1604547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1604550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1604553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1604556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604582 */     // MIs[0] policy
     /* 1604582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604592 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604616 */     // GIR_Coverage, 3327,
     /* 1604616 */     GIR_EraseRootFromParent_Done,
     /* 1604617 */   // Label 22178: @1604617
     /* 1604617 */   GIM_Try, /*On fail goto*//*Label 22179*/ GIMT_Encode4(1604703), // Rule ID 3330 //
     /* 1604622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1604633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1604636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1604639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1604645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604668 */     // MIs[0] policy
     /* 1604668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604678 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1604681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604702 */     // GIR_Coverage, 3330,
     /* 1604702 */     GIR_EraseRootFromParent_Done,
     /* 1604703 */   // Label 22179: @1604703
     /* 1604703 */   GIM_Try, /*On fail goto*//*Label 22180*/ GIMT_Encode4(1604789), // Rule ID 3331 //
     /* 1604708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1604719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1604722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1604725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1604731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604754 */     // MIs[0] policy
     /* 1604754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604764 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1604767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604788 */     // GIR_Coverage, 3331,
     /* 1604788 */     GIR_EraseRootFromParent_Done,
     /* 1604789 */   // Label 22180: @1604789
     /* 1604789 */   GIM_Try, /*On fail goto*//*Label 22181*/ GIMT_Encode4(1604875), // Rule ID 3334 //
     /* 1604794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1604805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1604808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1604811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604840 */     // MIs[0] policy
     /* 1604840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604850 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1604853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604874 */     // GIR_Coverage, 3334,
     /* 1604874 */     GIR_EraseRootFromParent_Done,
     /* 1604875 */   // Label 22181: @1604875
     /* 1604875 */   GIM_Try, /*On fail goto*//*Label 22182*/ GIMT_Encode4(1604961), // Rule ID 3335 //
     /* 1604880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1604891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1604894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1604897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604926 */     // MIs[0] policy
     /* 1604926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604936 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1604939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604960 */     // GIR_Coverage, 3335,
     /* 1604960 */     GIR_EraseRootFromParent_Done,
     /* 1604961 */   // Label 22182: @1604961
     /* 1604961 */   GIM_Try, /*On fail goto*//*Label 22183*/ GIMT_Encode4(1605047), // Rule ID 3338 //
     /* 1604966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1604977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1604980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1604983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605012 */     // MIs[0] policy
     /* 1605012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605022 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605046 */     // GIR_Coverage, 3338,
     /* 1605046 */     GIR_EraseRootFromParent_Done,
     /* 1605047 */   // Label 22183: @1605047
     /* 1605047 */   GIM_Try, /*On fail goto*//*Label 22184*/ GIMT_Encode4(1605133), // Rule ID 3339 //
     /* 1605052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1605063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1605066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1605069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605098 */     // MIs[0] policy
     /* 1605098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605108 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605132 */     // GIR_Coverage, 3339,
     /* 1605132 */     GIR_EraseRootFromParent_Done,
     /* 1605133 */   // Label 22184: @1605133
     /* 1605133 */   GIM_Try, /*On fail goto*//*Label 22185*/ GIMT_Encode4(1605219), // Rule ID 3342 //
     /* 1605138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1605149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1605152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1605155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605184 */     // MIs[0] policy
     /* 1605184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1605197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605218 */     // GIR_Coverage, 3342,
     /* 1605218 */     GIR_EraseRootFromParent_Done,
     /* 1605219 */   // Label 22185: @1605219
     /* 1605219 */   GIM_Try, /*On fail goto*//*Label 22186*/ GIMT_Encode4(1605305), // Rule ID 3343 //
     /* 1605224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1605235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1605238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1605241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605270 */     // MIs[0] policy
     /* 1605270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605280 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1605283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605304 */     // GIR_Coverage, 3343,
     /* 1605304 */     GIR_EraseRootFromParent_Done,
     /* 1605305 */   // Label 22186: @1605305
     /* 1605305 */   GIM_Try, /*On fail goto*//*Label 22187*/ GIMT_Encode4(1605391), // Rule ID 3346 //
     /* 1605310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1605321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1605324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1605327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605356 */     // MIs[0] policy
     /* 1605356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605390 */     // GIR_Coverage, 3346,
     /* 1605390 */     GIR_EraseRootFromParent_Done,
     /* 1605391 */   // Label 22187: @1605391
     /* 1605391 */   GIM_Try, /*On fail goto*//*Label 22188*/ GIMT_Encode4(1605477), // Rule ID 3347 //
     /* 1605396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1605407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1605410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1605413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605442 */     // MIs[0] policy
     /* 1605442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605452 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605476 */     // GIR_Coverage, 3347,
     /* 1605476 */     GIR_EraseRootFromParent_Done,
     /* 1605477 */   // Label 22188: @1605477
     /* 1605477 */   GIM_Try, /*On fail goto*//*Label 22189*/ GIMT_Encode4(1605563), // Rule ID 3350 //
     /* 1605482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1605493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1605496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1605499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605528 */     // MIs[0] policy
     /* 1605528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605562 */     // GIR_Coverage, 3350,
     /* 1605562 */     GIR_EraseRootFromParent_Done,
     /* 1605563 */   // Label 22189: @1605563
     /* 1605563 */   GIM_Try, /*On fail goto*//*Label 22190*/ GIMT_Encode4(1605649), // Rule ID 3351 //
     /* 1605568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1605579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1605582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1605585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605614 */     // MIs[0] policy
     /* 1605614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605624 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605648 */     // GIR_Coverage, 3351,
     /* 1605648 */     GIR_EraseRootFromParent_Done,
     /* 1605649 */   // Label 22190: @1605649
     /* 1605649 */   GIM_Try, /*On fail goto*//*Label 22191*/ GIMT_Encode4(1605735), // Rule ID 3354 //
     /* 1605654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1605665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1605668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1605671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605700 */     // MIs[0] policy
     /* 1605700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605710 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1605713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605734 */     // GIR_Coverage, 3354,
     /* 1605734 */     GIR_EraseRootFromParent_Done,
     /* 1605735 */   // Label 22191: @1605735
     /* 1605735 */   GIM_Try, /*On fail goto*//*Label 22192*/ GIMT_Encode4(1605821), // Rule ID 3355 //
     /* 1605740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1605751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1605754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1605757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605786 */     // MIs[0] policy
     /* 1605786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1605799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605820 */     // GIR_Coverage, 3355,
     /* 1605820 */     GIR_EraseRootFromParent_Done,
     /* 1605821 */   // Label 22192: @1605821
     /* 1605821 */   GIM_Try, /*On fail goto*//*Label 22193*/ GIMT_Encode4(1605907), // Rule ID 3358 //
     /* 1605826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1605837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1605840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1605843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605872 */     // MIs[0] policy
     /* 1605872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1605885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605906 */     // GIR_Coverage, 3358,
     /* 1605906 */     GIR_EraseRootFromParent_Done,
     /* 1605907 */   // Label 22193: @1605907
     /* 1605907 */   GIM_Try, /*On fail goto*//*Label 22194*/ GIMT_Encode4(1605993), // Rule ID 3359 //
     /* 1605912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1605923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1605926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1605929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605958 */     // MIs[0] policy
     /* 1605958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605968 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1605971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605992 */     // GIR_Coverage, 3359,
     /* 1605992 */     GIR_EraseRootFromParent_Done,
     /* 1605993 */   // Label 22194: @1605993
     /* 1605993 */   GIM_Try, /*On fail goto*//*Label 22195*/ GIMT_Encode4(1606079), // Rule ID 3362 //
     /* 1605998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1606009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1606012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1606015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606044 */     // MIs[0] policy
     /* 1606044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606054 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606078 */     // GIR_Coverage, 3362,
     /* 1606078 */     GIR_EraseRootFromParent_Done,
     /* 1606079 */   // Label 22195: @1606079
     /* 1606079 */   GIM_Try, /*On fail goto*//*Label 22196*/ GIMT_Encode4(1606165), // Rule ID 3363 //
     /* 1606084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1606095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1606098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1606101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606130 */     // MIs[0] policy
     /* 1606130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606140 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606164 */     // GIR_Coverage, 3363,
     /* 1606164 */     GIR_EraseRootFromParent_Done,
     /* 1606165 */   // Label 22196: @1606165
     /* 1606165 */   GIM_Try, /*On fail goto*//*Label 22197*/ GIMT_Encode4(1606251), // Rule ID 3366 //
     /* 1606170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1606173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1606181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1606184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1606187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606216 */     // MIs[0] policy
     /* 1606216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606226 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1606247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606250 */     // GIR_Coverage, 3366,
     /* 1606250 */     GIR_EraseRootFromParent_Done,
     /* 1606251 */   // Label 22197: @1606251
     /* 1606251 */   GIM_Try, /*On fail goto*//*Label 22198*/ GIMT_Encode4(1606337), // Rule ID 3367 //
     /* 1606256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1606259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1606267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1606270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1606273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606302 */     // MIs[0] policy
     /* 1606302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606312 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1606333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606336 */     // GIR_Coverage, 3367,
     /* 1606336 */     GIR_EraseRootFromParent_Done,
     /* 1606337 */   // Label 22198: @1606337
     /* 1606337 */   GIM_Try, /*On fail goto*//*Label 22199*/ GIMT_Encode4(1606423), // Rule ID 3370 //
     /* 1606342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1606353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1606356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1606359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606388 */     // MIs[0] policy
     /* 1606388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1606401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606422 */     // GIR_Coverage, 3370,
     /* 1606422 */     GIR_EraseRootFromParent_Done,
     /* 1606423 */   // Label 22199: @1606423
     /* 1606423 */   GIM_Try, /*On fail goto*//*Label 22200*/ GIMT_Encode4(1606509), // Rule ID 3371 //
     /* 1606428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1606439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1606442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1606445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606474 */     // MIs[0] policy
     /* 1606474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606484 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1606487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606508 */     // GIR_Coverage, 3371,
     /* 1606508 */     GIR_EraseRootFromParent_Done,
     /* 1606509 */   // Label 22200: @1606509
     /* 1606509 */   GIM_Try, /*On fail goto*//*Label 22201*/ GIMT_Encode4(1606595), // Rule ID 3374 //
     /* 1606514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1606525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1606528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1606531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1606537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1606544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606560 */     // MIs[0] policy
     /* 1606560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606570 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1606573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606594 */     // GIR_Coverage, 3374,
     /* 1606594 */     GIR_EraseRootFromParent_Done,
     /* 1606595 */   // Label 22201: @1606595
     /* 1606595 */   GIM_Try, /*On fail goto*//*Label 22202*/ GIMT_Encode4(1606681), // Rule ID 3375 //
     /* 1606600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1606611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1606614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1606617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1606623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1606630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606646 */     // MIs[0] policy
     /* 1606646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606656 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1606659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606680 */     // GIR_Coverage, 3375,
     /* 1606680 */     GIR_EraseRootFromParent_Done,
     /* 1606681 */   // Label 22202: @1606681
     /* 1606681 */   GIM_Try, /*On fail goto*//*Label 22203*/ GIMT_Encode4(1606767), // Rule ID 3378 //
     /* 1606686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1606697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1606700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1606703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1606709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1606716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606732 */     // MIs[0] policy
     /* 1606732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606742 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1606745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606766 */     // GIR_Coverage, 3378,
     /* 1606766 */     GIR_EraseRootFromParent_Done,
     /* 1606767 */   // Label 22203: @1606767
     /* 1606767 */   GIM_Try, /*On fail goto*//*Label 22204*/ GIMT_Encode4(1606853), // Rule ID 3379 //
     /* 1606772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1606783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1606786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1606789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1606795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1606802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606818 */     // MIs[0] policy
     /* 1606818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606828 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1606831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606852 */     // GIR_Coverage, 3379,
     /* 1606852 */     GIR_EraseRootFromParent_Done,
     /* 1606853 */   // Label 22204: @1606853
     /* 1606853 */   GIM_Try, /*On fail goto*//*Label 22205*/ GIMT_Encode4(1606939), // Rule ID 3382 //
     /* 1606858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1606869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1606872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1606875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606904 */     // MIs[0] policy
     /* 1606904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1606917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606938 */     // GIR_Coverage, 3382,
     /* 1606938 */     GIR_EraseRootFromParent_Done,
     /* 1606939 */   // Label 22205: @1606939
     /* 1606939 */   GIM_Try, /*On fail goto*//*Label 22206*/ GIMT_Encode4(1607025), // Rule ID 3383 //
     /* 1606944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1606955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1606958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1606961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606990 */     // MIs[0] policy
     /* 1606990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607000 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607024 */     // GIR_Coverage, 3383,
     /* 1607024 */     GIR_EraseRootFromParent_Done,
     /* 1607025 */   // Label 22206: @1607025
     /* 1607025 */   GIM_Try, /*On fail goto*//*Label 22207*/ GIMT_Encode4(1607111), // Rule ID 3386 //
     /* 1607030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1607041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1607044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1607047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607076 */     // MIs[0] policy
     /* 1607076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607086 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607110 */     // GIR_Coverage, 3386,
     /* 1607110 */     GIR_EraseRootFromParent_Done,
     /* 1607111 */   // Label 22207: @1607111
     /* 1607111 */   GIM_Try, /*On fail goto*//*Label 22208*/ GIMT_Encode4(1607197), // Rule ID 3387 //
     /* 1607116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1607127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1607130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1607133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607162 */     // MIs[0] policy
     /* 1607162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607172 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607196 */     // GIR_Coverage, 3387,
     /* 1607196 */     GIR_EraseRootFromParent_Done,
     /* 1607197 */   // Label 22208: @1607197
     /* 1607197 */   GIM_Try, /*On fail goto*//*Label 22209*/ GIMT_Encode4(1607283), // Rule ID 3390 //
     /* 1607202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1607213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1607216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1607219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1607225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607248 */     // MIs[0] policy
     /* 1607248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607258 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607282 */     // GIR_Coverage, 3390,
     /* 1607282 */     GIR_EraseRootFromParent_Done,
     /* 1607283 */   // Label 22209: @1607283
     /* 1607283 */   GIM_Try, /*On fail goto*//*Label 22210*/ GIMT_Encode4(1607369), // Rule ID 3391 //
     /* 1607288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1607299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1607302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1607305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1607311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607334 */     // MIs[0] policy
     /* 1607334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607344 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607368 */     // GIR_Coverage, 3391,
     /* 1607368 */     GIR_EraseRootFromParent_Done,
     /* 1607369 */   // Label 22210: @1607369
     /* 1607369 */   GIM_Try, /*On fail goto*//*Label 22211*/ GIMT_Encode4(1607455), // Rule ID 3394 //
     /* 1607374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1607385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1607388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607420 */     // MIs[0] policy
     /* 1607420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607454 */     // GIR_Coverage, 3394,
     /* 1607454 */     GIR_EraseRootFromParent_Done,
     /* 1607455 */   // Label 22211: @1607455
     /* 1607455 */   GIM_Try, /*On fail goto*//*Label 22212*/ GIMT_Encode4(1607541), // Rule ID 3395 //
     /* 1607460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1607471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1607474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607506 */     // MIs[0] policy
     /* 1607506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607516 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607540 */     // GIR_Coverage, 3395,
     /* 1607540 */     GIR_EraseRootFromParent_Done,
     /* 1607541 */   // Label 22212: @1607541
     /* 1607541 */   GIM_Try, /*On fail goto*//*Label 22213*/ GIMT_Encode4(1607627), // Rule ID 3398 //
     /* 1607546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1607557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1607560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1607563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607592 */     // MIs[0] policy
     /* 1607592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607602 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607626 */     // GIR_Coverage, 3398,
     /* 1607626 */     GIR_EraseRootFromParent_Done,
     /* 1607627 */   // Label 22213: @1607627
     /* 1607627 */   GIM_Try, /*On fail goto*//*Label 22214*/ GIMT_Encode4(1607713), // Rule ID 3399 //
     /* 1607632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1607643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1607646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1607649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607678 */     // MIs[0] policy
     /* 1607678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607688 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607712 */     // GIR_Coverage, 3399,
     /* 1607712 */     GIR_EraseRootFromParent_Done,
     /* 1607713 */   // Label 22214: @1607713
     /* 1607713 */   GIM_Try, /*On fail goto*//*Label 22215*/ GIMT_Encode4(1607799), // Rule ID 3402 //
     /* 1607718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1607729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1607732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1607735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607764 */     // MIs[0] policy
     /* 1607764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607774 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607798 */     // GIR_Coverage, 3402,
     /* 1607798 */     GIR_EraseRootFromParent_Done,
     /* 1607799 */   // Label 22215: @1607799
     /* 1607799 */   GIM_Try, /*On fail goto*//*Label 22216*/ GIMT_Encode4(1607885), // Rule ID 3403 //
     /* 1607804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1607815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1607818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1607821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607850 */     // MIs[0] policy
     /* 1607850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607860 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607884 */     // GIR_Coverage, 3403,
     /* 1607884 */     GIR_EraseRootFromParent_Done,
     /* 1607885 */   // Label 22216: @1607885
     /* 1607885 */   GIM_Try, /*On fail goto*//*Label 22217*/ GIMT_Encode4(1607971), // Rule ID 3406 //
     /* 1607890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1607893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1607901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1607904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1607907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1607913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607936 */     // MIs[0] policy
     /* 1607936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1607967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607970 */     // GIR_Coverage, 3406,
     /* 1607970 */     GIR_EraseRootFromParent_Done,
     /* 1607971 */   // Label 22217: @1607971
     /* 1607971 */   GIM_Try, /*On fail goto*//*Label 22218*/ GIMT_Encode4(1608057), // Rule ID 3407 //
     /* 1607976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1607979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1607987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1607990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1607993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1607999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1608006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608022 */     // MIs[0] policy
     /* 1608022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608032 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1608035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608056 */     // GIR_Coverage, 3407,
     /* 1608056 */     GIR_EraseRootFromParent_Done,
     /* 1608057 */   // Label 22218: @1608057
     /* 1608057 */   GIM_Try, /*On fail goto*//*Label 22219*/ GIMT_Encode4(1608143), // Rule ID 3410 //
     /* 1608062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1608065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1608073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1608076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1608079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608108 */     // MIs[0] policy
     /* 1608108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608118 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1608121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608142 */     // GIR_Coverage, 3410,
     /* 1608142 */     GIR_EraseRootFromParent_Done,
     /* 1608143 */   // Label 22219: @1608143
     /* 1608143 */   GIM_Try, /*On fail goto*//*Label 22220*/ GIMT_Encode4(1608229), // Rule ID 3411 //
     /* 1608148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1608151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1608159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1608162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1608165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608194 */     // MIs[0] policy
     /* 1608194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608204 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1608207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608228 */     // GIR_Coverage, 3411,
     /* 1608228 */     GIR_EraseRootFromParent_Done,
     /* 1608229 */   // Label 22220: @1608229
     /* 1608229 */   GIM_Try, /*On fail goto*//*Label 22221*/ GIMT_Encode4(1608315), // Rule ID 3414 //
     /* 1608234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1608237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1608245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1608248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1608251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608280 */     // MIs[0] policy
     /* 1608280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608290 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1608293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608314 */     // GIR_Coverage, 3414,
     /* 1608314 */     GIR_EraseRootFromParent_Done,
     /* 1608315 */   // Label 22221: @1608315
     /* 1608315 */   GIM_Try, /*On fail goto*//*Label 22222*/ GIMT_Encode4(1608401), // Rule ID 3415 //
     /* 1608320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1608323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1608331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1608334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1608337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608366 */     // MIs[0] policy
     /* 1608366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608376 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1608379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608400 */     // GIR_Coverage, 3415,
     /* 1608400 */     GIR_EraseRootFromParent_Done,
     /* 1608401 */   // Label 22222: @1608401
     /* 1608401 */   GIM_Try, /*On fail goto*//*Label 22223*/ GIMT_Encode4(1608487), // Rule ID 3418 //
     /* 1608406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1608417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1608420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608452 */     // MIs[0] policy
     /* 1608452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608462 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1608465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608486 */     // GIR_Coverage, 3418,
     /* 1608486 */     GIR_EraseRootFromParent_Done,
     /* 1608487 */   // Label 22223: @1608487
     /* 1608487 */   GIM_Try, /*On fail goto*//*Label 22224*/ GIMT_Encode4(1608573), // Rule ID 3419 //
     /* 1608492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1608503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1608506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608538 */     // MIs[0] policy
     /* 1608538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608548 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1608551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608572 */     // GIR_Coverage, 3419,
     /* 1608572 */     GIR_EraseRootFromParent_Done,
     /* 1608573 */   // Label 22224: @1608573
     /* 1608573 */   GIM_Try, /*On fail goto*//*Label 22225*/ GIMT_Encode4(1608659), // Rule ID 3422 //
     /* 1608578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1608589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1608592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1608595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608624 */     // MIs[0] policy
     /* 1608624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608634 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1608637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608658 */     // GIR_Coverage, 3422,
     /* 1608658 */     GIR_EraseRootFromParent_Done,
     /* 1608659 */   // Label 22225: @1608659
     /* 1608659 */   GIM_Try, /*On fail goto*//*Label 22226*/ GIMT_Encode4(1608745), // Rule ID 3423 //
     /* 1608664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1608675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1608678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1608681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608710 */     // MIs[0] policy
     /* 1608710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608720 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1608723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608744 */     // GIR_Coverage, 3423,
     /* 1608744 */     GIR_EraseRootFromParent_Done,
     /* 1608745 */   // Label 22226: @1608745
     /* 1608745 */   GIM_Try, /*On fail goto*//*Label 22227*/ GIMT_Encode4(1608831), // Rule ID 3426 //
     /* 1608750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1608761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1608764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1608767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608796 */     // MIs[0] policy
     /* 1608796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608806 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1608809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608830 */     // GIR_Coverage, 3426,
     /* 1608830 */     GIR_EraseRootFromParent_Done,
     /* 1608831 */   // Label 22227: @1608831
     /* 1608831 */   GIM_Try, /*On fail goto*//*Label 22228*/ GIMT_Encode4(1608917), // Rule ID 3427 //
     /* 1608836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1608847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1608850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1608853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608882 */     // MIs[0] policy
     /* 1608882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608892 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1608895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608916 */     // GIR_Coverage, 3427,
     /* 1608916 */     GIR_EraseRootFromParent_Done,
     /* 1608917 */   // Label 22228: @1608917
     /* 1608917 */   GIM_Try, /*On fail goto*//*Label 22229*/ GIMT_Encode4(1609003), // Rule ID 3430 //
     /* 1608922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1608933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1608936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1608939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608968 */     // MIs[0] policy
     /* 1608968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608978 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1608981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1608999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609002 */     // GIR_Coverage, 3430,
     /* 1609002 */     GIR_EraseRootFromParent_Done,
     /* 1609003 */   // Label 22229: @1609003
     /* 1609003 */   GIM_Try, /*On fail goto*//*Label 22230*/ GIMT_Encode4(1609089), // Rule ID 3431 //
     /* 1609008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1609019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1609022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1609025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609054 */     // MIs[0] policy
     /* 1609054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609064 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1609067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609088 */     // GIR_Coverage, 3431,
     /* 1609088 */     GIR_EraseRootFromParent_Done,
     /* 1609089 */   // Label 22230: @1609089
     /* 1609089 */   GIM_Try, /*On fail goto*//*Label 22231*/ GIMT_Encode4(1609175), // Rule ID 3434 //
     /* 1609094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1609105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1609108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609140 */     // MIs[0] policy
     /* 1609140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609150 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609174 */     // GIR_Coverage, 3434,
     /* 1609174 */     GIR_EraseRootFromParent_Done,
     /* 1609175 */   // Label 22231: @1609175
     /* 1609175 */   GIM_Try, /*On fail goto*//*Label 22232*/ GIMT_Encode4(1609261), // Rule ID 3435 //
     /* 1609180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1609191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1609194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609226 */     // MIs[0] policy
     /* 1609226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609236 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609260 */     // GIR_Coverage, 3435,
     /* 1609260 */     GIR_EraseRootFromParent_Done,
     /* 1609261 */   // Label 22232: @1609261
     /* 1609261 */   GIM_Try, /*On fail goto*//*Label 22233*/ GIMT_Encode4(1609347), // Rule ID 3438 //
     /* 1609266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1609283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609312 */     // MIs[0] policy
     /* 1609312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609346 */     // GIR_Coverage, 3438,
     /* 1609346 */     GIR_EraseRootFromParent_Done,
     /* 1609347 */   // Label 22233: @1609347
     /* 1609347 */   GIM_Try, /*On fail goto*//*Label 22234*/ GIMT_Encode4(1609433), // Rule ID 3439 //
     /* 1609352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1609369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609398 */     // MIs[0] policy
     /* 1609398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609408 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609432 */     // GIR_Coverage, 3439,
     /* 1609432 */     GIR_EraseRootFromParent_Done,
     /* 1609433 */   // Label 22234: @1609433
     /* 1609433 */   GIM_Try, /*On fail goto*//*Label 22235*/ GIMT_Encode4(1609519), // Rule ID 3442 //
     /* 1609438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1609449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1609452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1609455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609484 */     // MIs[0] policy
     /* 1609484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609494 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609518 */     // GIR_Coverage, 3442,
     /* 1609518 */     GIR_EraseRootFromParent_Done,
     /* 1609519 */   // Label 22235: @1609519
     /* 1609519 */   GIM_Try, /*On fail goto*//*Label 22236*/ GIMT_Encode4(1609605), // Rule ID 3443 //
     /* 1609524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1609535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1609538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1609541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609570 */     // MIs[0] policy
     /* 1609570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609580 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609604 */     // GIR_Coverage, 3443,
     /* 1609604 */     GIR_EraseRootFromParent_Done,
     /* 1609605 */   // Label 22236: @1609605
     /* 1609605 */   GIM_Try, /*On fail goto*//*Label 22237*/ GIMT_Encode4(1609691), // Rule ID 3446 //
     /* 1609610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1609621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1609624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1609627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609656 */     // MIs[0] policy
     /* 1609656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609666 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609690 */     // GIR_Coverage, 3446,
     /* 1609690 */     GIR_EraseRootFromParent_Done,
     /* 1609691 */   // Label 22237: @1609691
     /* 1609691 */   GIM_Try, /*On fail goto*//*Label 22238*/ GIMT_Encode4(1609777), // Rule ID 3447 //
     /* 1609696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1609707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1609710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1609713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609742 */     // MIs[0] policy
     /* 1609742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609776 */     // GIR_Coverage, 3447,
     /* 1609776 */     GIR_EraseRootFromParent_Done,
     /* 1609777 */   // Label 22238: @1609777
     /* 1609777 */   GIM_Try, /*On fail goto*//*Label 22239*/ GIMT_Encode4(1609863), // Rule ID 3450 //
     /* 1609782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1609793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1609796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1609799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609828 */     // MIs[0] policy
     /* 1609828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609862 */     // GIR_Coverage, 3450,
     /* 1609862 */     GIR_EraseRootFromParent_Done,
     /* 1609863 */   // Label 22239: @1609863
     /* 1609863 */   GIM_Try, /*On fail goto*//*Label 22240*/ GIMT_Encode4(1609949), // Rule ID 3451 //
     /* 1609868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1609879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1609882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1609885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609914 */     // MIs[0] policy
     /* 1609914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609924 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609948 */     // GIR_Coverage, 3451,
     /* 1609948 */     GIR_EraseRootFromParent_Done,
     /* 1609949 */   // Label 22240: @1609949
     /* 1609949 */   GIM_Try, /*On fail goto*//*Label 22241*/ GIMT_Encode4(1610035), // Rule ID 3454 //
     /* 1609954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1609957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1609965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1609968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1609971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610000 */     // MIs[0] policy
     /* 1610000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610010 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1610031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610034 */     // GIR_Coverage, 3454,
     /* 1610034 */     GIR_EraseRootFromParent_Done,
     /* 1610035 */   // Label 22241: @1610035
     /* 1610035 */   GIM_Try, /*On fail goto*//*Label 22242*/ GIMT_Encode4(1610121), // Rule ID 3455 //
     /* 1610040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1610043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1610051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1610054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1610057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610086 */     // MIs[0] policy
     /* 1610086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610096 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1610117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610120 */     // GIR_Coverage, 3455,
     /* 1610120 */     GIR_EraseRootFromParent_Done,
     /* 1610121 */   // Label 22242: @1610121
     /* 1610121 */   GIM_Try, /*On fail goto*//*Label 22243*/ GIMT_Encode4(1610207), // Rule ID 3458 //
     /* 1610126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1610137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1610140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610172 */     // MIs[0] policy
     /* 1610172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610182 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1610185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610206 */     // GIR_Coverage, 3458,
     /* 1610206 */     GIR_EraseRootFromParent_Done,
     /* 1610207 */   // Label 22243: @1610207
     /* 1610207 */   GIM_Try, /*On fail goto*//*Label 22244*/ GIMT_Encode4(1610293), // Rule ID 3459 //
     /* 1610212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1610223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1610226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610258 */     // MIs[0] policy
     /* 1610258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610268 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1610271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610292 */     // GIR_Coverage, 3459,
     /* 1610292 */     GIR_EraseRootFromParent_Done,
     /* 1610293 */   // Label 22244: @1610293
     /* 1610293 */   GIM_Try, /*On fail goto*//*Label 22245*/ GIMT_Encode4(1610379), // Rule ID 3462 //
     /* 1610298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1610309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1610312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610344 */     // MIs[0] policy
     /* 1610344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610354 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1610357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610378 */     // GIR_Coverage, 3462,
     /* 1610378 */     GIR_EraseRootFromParent_Done,
     /* 1610379 */   // Label 22245: @1610379
     /* 1610379 */   GIM_Try, /*On fail goto*//*Label 22246*/ GIMT_Encode4(1610465), // Rule ID 3463 //
     /* 1610384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1610395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1610398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610430 */     // MIs[0] policy
     /* 1610430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610440 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1610443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610464 */     // GIR_Coverage, 3463,
     /* 1610464 */     GIR_EraseRootFromParent_Done,
     /* 1610465 */   // Label 22246: @1610465
     /* 1610465 */   GIM_Try, /*On fail goto*//*Label 22247*/ GIMT_Encode4(1610551), // Rule ID 3466 //
     /* 1610470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1610481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1610484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1610487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1610493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610516 */     // MIs[0] policy
     /* 1610516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610526 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1610529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610550 */     // GIR_Coverage, 3466,
     /* 1610550 */     GIR_EraseRootFromParent_Done,
     /* 1610551 */   // Label 22247: @1610551
     /* 1610551 */   GIM_Try, /*On fail goto*//*Label 22248*/ GIMT_Encode4(1610637), // Rule ID 3467 //
     /* 1610556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1610567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1610570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1610573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1610579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610602 */     // MIs[0] policy
     /* 1610602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610612 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1610615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610636 */     // GIR_Coverage, 3467,
     /* 1610636 */     GIR_EraseRootFromParent_Done,
     /* 1610637 */   // Label 22248: @1610637
     /* 1610637 */   GIM_Try, /*On fail goto*//*Label 22249*/ GIMT_Encode4(1610723), // Rule ID 3470 //
     /* 1610642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1610653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1610656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1610659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610688 */     // MIs[0] policy
     /* 1610688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610698 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1610701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610722 */     // GIR_Coverage, 3470,
     /* 1610722 */     GIR_EraseRootFromParent_Done,
     /* 1610723 */   // Label 22249: @1610723
     /* 1610723 */   GIM_Try, /*On fail goto*//*Label 22250*/ GIMT_Encode4(1610809), // Rule ID 3471 //
     /* 1610728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1610739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1610742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1610745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610774 */     // MIs[0] policy
     /* 1610774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610784 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1610787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610808 */     // GIR_Coverage, 3471,
     /* 1610808 */     GIR_EraseRootFromParent_Done,
     /* 1610809 */   // Label 22250: @1610809
     /* 1610809 */   GIM_Try, /*On fail goto*//*Label 22251*/ GIMT_Encode4(1610895), // Rule ID 3474 //
     /* 1610814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1610825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1610828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1610831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610860 */     // MIs[0] policy
     /* 1610860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610870 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1610873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610894 */     // GIR_Coverage, 3474,
     /* 1610894 */     GIR_EraseRootFromParent_Done,
     /* 1610895 */   // Label 22251: @1610895
     /* 1610895 */   GIM_Try, /*On fail goto*//*Label 22252*/ GIMT_Encode4(1610981), // Rule ID 3475 //
     /* 1610900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1610911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1610914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1610917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610946 */     // MIs[0] policy
     /* 1610946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610956 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1610959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610980 */     // GIR_Coverage, 3475,
     /* 1610980 */     GIR_EraseRootFromParent_Done,
     /* 1610981 */   // Label 22252: @1610981
     /* 1610981 */   GIM_Try, /*On fail goto*//*Label 22253*/ GIMT_Encode4(1611067), // Rule ID 3478 //
     /* 1610986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1610997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1611000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1611003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1611009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611032 */     // MIs[0] policy
     /* 1611032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611042 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611066 */     // GIR_Coverage, 3478,
     /* 1611066 */     GIR_EraseRootFromParent_Done,
     /* 1611067 */   // Label 22253: @1611067
     /* 1611067 */   GIM_Try, /*On fail goto*//*Label 22254*/ GIMT_Encode4(1611153), // Rule ID 3479 //
     /* 1611072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1611083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1611086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1611089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1611095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611118 */     // MIs[0] policy
     /* 1611118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611128 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611152 */     // GIR_Coverage, 3479,
     /* 1611152 */     GIR_EraseRootFromParent_Done,
     /* 1611153 */   // Label 22254: @1611153
     /* 1611153 */   GIM_Try, /*On fail goto*//*Label 22255*/ GIMT_Encode4(1611239), // Rule ID 3482 //
     /* 1611158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1611175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611204 */     // MIs[0] policy
     /* 1611204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611238 */     // GIR_Coverage, 3482,
     /* 1611238 */     GIR_EraseRootFromParent_Done,
     /* 1611239 */   // Label 22255: @1611239
     /* 1611239 */   GIM_Try, /*On fail goto*//*Label 22256*/ GIMT_Encode4(1611325), // Rule ID 3483 //
     /* 1611244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1611261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611290 */     // MIs[0] policy
     /* 1611290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611300 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611324 */     // GIR_Coverage, 3483,
     /* 1611324 */     GIR_EraseRootFromParent_Done,
     /* 1611325 */   // Label 22256: @1611325
     /* 1611325 */   GIM_Try, /*On fail goto*//*Label 22257*/ GIMT_Encode4(1611411), // Rule ID 3486 //
     /* 1611330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1611347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611376 */     // MIs[0] policy
     /* 1611376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611386 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611410 */     // GIR_Coverage, 3486,
     /* 1611410 */     GIR_EraseRootFromParent_Done,
     /* 1611411 */   // Label 22257: @1611411
     /* 1611411 */   GIM_Try, /*On fail goto*//*Label 22258*/ GIMT_Encode4(1611497), // Rule ID 3487 //
     /* 1611416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1611433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611462 */     // MIs[0] policy
     /* 1611462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611472 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611496 */     // GIR_Coverage, 3487,
     /* 1611496 */     GIR_EraseRootFromParent_Done,
     /* 1611497 */   // Label 22258: @1611497
     /* 1611497 */   GIM_Try, /*On fail goto*//*Label 22259*/ GIMT_Encode4(1611583), // Rule ID 3490 //
     /* 1611502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1611513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1611516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1611519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611548 */     // MIs[0] policy
     /* 1611548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611558 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611582 */     // GIR_Coverage, 3490,
     /* 1611582 */     GIR_EraseRootFromParent_Done,
     /* 1611583 */   // Label 22259: @1611583
     /* 1611583 */   GIM_Try, /*On fail goto*//*Label 22260*/ GIMT_Encode4(1611669), // Rule ID 3491 //
     /* 1611588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1611599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1611602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1611605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611634 */     // MIs[0] policy
     /* 1611634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611644 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611668 */     // GIR_Coverage, 3491,
     /* 1611668 */     GIR_EraseRootFromParent_Done,
     /* 1611669 */   // Label 22260: @1611669
     /* 1611669 */   GIM_Try, /*On fail goto*//*Label 22261*/ GIMT_Encode4(1611755), // Rule ID 3494 //
     /* 1611674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1611677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1611685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1611688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1611691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1611697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611720 */     // MIs[0] policy
     /* 1611720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611730 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1611751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611754 */     // GIR_Coverage, 3494,
     /* 1611754 */     GIR_EraseRootFromParent_Done,
     /* 1611755 */   // Label 22261: @1611755
     /* 1611755 */   GIM_Try, /*On fail goto*//*Label 22262*/ GIMT_Encode4(1611841), // Rule ID 3495 //
     /* 1611760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1611763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1611771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1611774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1611777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1611783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611806 */     // MIs[0] policy
     /* 1611806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1611837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611840 */     // GIR_Coverage, 3495,
     /* 1611840 */     GIR_EraseRootFromParent_Done,
     /* 1611841 */   // Label 22262: @1611841
     /* 1611841 */   GIM_Try, /*On fail goto*//*Label 22263*/ GIMT_Encode4(1611927), // Rule ID 3498 //
     /* 1611846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1611849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1611857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1611860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1611863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611892 */     // MIs[0] policy
     /* 1611892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611902 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1611923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611926 */     // GIR_Coverage, 3498,
     /* 1611926 */     GIR_EraseRootFromParent_Done,
     /* 1611927 */   // Label 22263: @1611927
     /* 1611927 */   GIM_Try, /*On fail goto*//*Label 22264*/ GIMT_Encode4(1612013), // Rule ID 3499 //
     /* 1611932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1611935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1611943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1611946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1611949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611978 */     // MIs[0] policy
     /* 1611978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611988 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612012 */     // GIR_Coverage, 3499,
     /* 1612012 */     GIR_EraseRootFromParent_Done,
     /* 1612013 */   // Label 22264: @1612013
     /* 1612013 */   GIM_Try, /*On fail goto*//*Label 22265*/ GIMT_Encode4(1612099), // Rule ID 3502 //
     /* 1612018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1612021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1612035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612064 */     // MIs[0] policy
     /* 1612064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612074 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1612077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612098 */     // GIR_Coverage, 3502,
     /* 1612098 */     GIR_EraseRootFromParent_Done,
     /* 1612099 */   // Label 22265: @1612099
     /* 1612099 */   GIM_Try, /*On fail goto*//*Label 22266*/ GIMT_Encode4(1612185), // Rule ID 3503 //
     /* 1612104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1612107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1612121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612150 */     // MIs[0] policy
     /* 1612150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612160 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1612163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612184 */     // GIR_Coverage, 3503,
     /* 1612184 */     GIR_EraseRootFromParent_Done,
     /* 1612185 */   // Label 22266: @1612185
     /* 1612185 */   GIM_Try, /*On fail goto*//*Label 22267*/ GIMT_Encode4(1612271), // Rule ID 3594 //
     /* 1612190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1612210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612236 */     // MIs[0] policy
     /* 1612236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612246 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1612249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612270 */     // GIR_Coverage, 3594,
     /* 1612270 */     GIR_EraseRootFromParent_Done,
     /* 1612271 */   // Label 22267: @1612271
     /* 1612271 */   GIM_Try, /*On fail goto*//*Label 22268*/ GIMT_Encode4(1612357), // Rule ID 3595 //
     /* 1612276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1612296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612322 */     // MIs[0] policy
     /* 1612322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612332 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1612335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612356 */     // GIR_Coverage, 3595,
     /* 1612356 */     GIR_EraseRootFromParent_Done,
     /* 1612357 */   // Label 22268: @1612357
     /* 1612357 */   GIM_Try, /*On fail goto*//*Label 22269*/ GIMT_Encode4(1612443), // Rule ID 3598 //
     /* 1612362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1612373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1612376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1612382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612408 */     // MIs[0] policy
     /* 1612408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612418 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1612421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612442 */     // GIR_Coverage, 3598,
     /* 1612442 */     GIR_EraseRootFromParent_Done,
     /* 1612443 */   // Label 22269: @1612443
     /* 1612443 */   GIM_Try, /*On fail goto*//*Label 22270*/ GIMT_Encode4(1612529), // Rule ID 3599 //
     /* 1612448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1612459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1612462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1612468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612494 */     // MIs[0] policy
     /* 1612494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612504 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1612507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612528 */     // GIR_Coverage, 3599,
     /* 1612528 */     GIR_EraseRootFromParent_Done,
     /* 1612529 */   // Label 22270: @1612529
     /* 1612529 */   GIM_Try, /*On fail goto*//*Label 22271*/ GIMT_Encode4(1612615), // Rule ID 3602 //
     /* 1612534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1612545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1612548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1612551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1612554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612580 */     // MIs[0] policy
     /* 1612580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1612593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612614 */     // GIR_Coverage, 3602,
     /* 1612614 */     GIR_EraseRootFromParent_Done,
     /* 1612615 */   // Label 22271: @1612615
     /* 1612615 */   GIM_Try, /*On fail goto*//*Label 22272*/ GIMT_Encode4(1612701), // Rule ID 3603 //
     /* 1612620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1612631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1612634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1612637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1612640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612666 */     // MIs[0] policy
     /* 1612666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612676 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1612679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612700 */     // GIR_Coverage, 3603,
     /* 1612700 */     GIR_EraseRootFromParent_Done,
     /* 1612701 */   // Label 22272: @1612701
     /* 1612701 */   GIM_Try, /*On fail goto*//*Label 22273*/ GIMT_Encode4(1612787), // Rule ID 3606 //
     /* 1612706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1612717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1612720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1612723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1612726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612752 */     // MIs[0] policy
     /* 1612752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1612765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612786 */     // GIR_Coverage, 3606,
     /* 1612786 */     GIR_EraseRootFromParent_Done,
     /* 1612787 */   // Label 22273: @1612787
     /* 1612787 */   GIM_Try, /*On fail goto*//*Label 22274*/ GIMT_Encode4(1612873), // Rule ID 3607 //
     /* 1612792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1612803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1612806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1612809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1612812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612838 */     // MIs[0] policy
     /* 1612838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1612851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612872 */     // GIR_Coverage, 3607,
     /* 1612872 */     GIR_EraseRootFromParent_Done,
     /* 1612873 */   // Label 22274: @1612873
     /* 1612873 */   GIM_Try, /*On fail goto*//*Label 22275*/ GIMT_Encode4(1612959), // Rule ID 3610 //
     /* 1612878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1612889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1612892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1612895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1612898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1612901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612924 */     // MIs[0] policy
     /* 1612924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1612937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612958 */     // GIR_Coverage, 3610,
     /* 1612958 */     GIR_EraseRootFromParent_Done,
     /* 1612959 */   // Label 22275: @1612959
     /* 1612959 */   GIM_Try, /*On fail goto*//*Label 22276*/ GIMT_Encode4(1613045), // Rule ID 3611 //
     /* 1612964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1612975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1612978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1612981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1612984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1612987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613010 */     // MIs[0] policy
     /* 1613010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613020 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1613023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613044 */     // GIR_Coverage, 3611,
     /* 1613044 */     GIR_EraseRootFromParent_Done,
     /* 1613045 */   // Label 22276: @1613045
     /* 1613045 */   GIM_Try, /*On fail goto*//*Label 22277*/ GIMT_Encode4(1613131), // Rule ID 3614 //
     /* 1613050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1613061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1613064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1613067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1613070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1613073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613096 */     // MIs[0] policy
     /* 1613096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613106 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1613109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613130 */     // GIR_Coverage, 3614,
     /* 1613130 */     GIR_EraseRootFromParent_Done,
     /* 1613131 */   // Label 22277: @1613131
     /* 1613131 */   GIM_Try, /*On fail goto*//*Label 22278*/ GIMT_Encode4(1613217), // Rule ID 3615 //
     /* 1613136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1613147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1613150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1613153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1613156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1613159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613182 */     // MIs[0] policy
     /* 1613182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613192 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1613195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613216 */     // GIR_Coverage, 3615,
     /* 1613216 */     GIR_EraseRootFromParent_Done,
     /* 1613217 */   // Label 22278: @1613217
     /* 1613217 */   GIM_Try, /*On fail goto*//*Label 22279*/ GIMT_Encode4(1613303), // Rule ID 3618 //
     /* 1613222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1613239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1613242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613268 */     // MIs[0] policy
     /* 1613268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613278 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1613281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613302 */     // GIR_Coverage, 3618,
     /* 1613302 */     GIR_EraseRootFromParent_Done,
     /* 1613303 */   // Label 22279: @1613303
     /* 1613303 */   GIM_Try, /*On fail goto*//*Label 22280*/ GIMT_Encode4(1613389), // Rule ID 3619 //
     /* 1613308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1613325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1613328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613354 */     // MIs[0] policy
     /* 1613354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613364 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1613367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613388 */     // GIR_Coverage, 3619,
     /* 1613388 */     GIR_EraseRootFromParent_Done,
     /* 1613389 */   // Label 22280: @1613389
     /* 1613389 */   GIM_Try, /*On fail goto*//*Label 22281*/ GIMT_Encode4(1613475), // Rule ID 3622 //
     /* 1613394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1613411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1613414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613440 */     // MIs[0] policy
     /* 1613440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613450 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1613453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613474 */     // GIR_Coverage, 3622,
     /* 1613474 */     GIR_EraseRootFromParent_Done,
     /* 1613475 */   // Label 22281: @1613475
     /* 1613475 */   GIM_Try, /*On fail goto*//*Label 22282*/ GIMT_Encode4(1613561), // Rule ID 3623 //
     /* 1613480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1613497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1613500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613526 */     // MIs[0] policy
     /* 1613526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1613539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613560 */     // GIR_Coverage, 3623,
     /* 1613560 */     GIR_EraseRootFromParent_Done,
     /* 1613561 */   // Label 22282: @1613561
     /* 1613561 */   GIM_Try, /*On fail goto*//*Label 22283*/ GIMT_Encode4(1613647), // Rule ID 3626 //
     /* 1613566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1613577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1613580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1613583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1613586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613612 */     // MIs[0] policy
     /* 1613612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613622 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1613625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613646 */     // GIR_Coverage, 3626,
     /* 1613646 */     GIR_EraseRootFromParent_Done,
     /* 1613647 */   // Label 22283: @1613647
     /* 1613647 */   GIM_Try, /*On fail goto*//*Label 22284*/ GIMT_Encode4(1613733), // Rule ID 3627 //
     /* 1613652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1613663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1613666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1613669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1613672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613698 */     // MIs[0] policy
     /* 1613698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1613711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613732 */     // GIR_Coverage, 3627,
     /* 1613732 */     GIR_EraseRootFromParent_Done,
     /* 1613733 */   // Label 22284: @1613733
     /* 1613733 */   GIM_Try, /*On fail goto*//*Label 22285*/ GIMT_Encode4(1613819), // Rule ID 3630 //
     /* 1613738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1613749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1613752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1613755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1613758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1613768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613784 */     // MIs[0] policy
     /* 1613784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613794 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1613797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613818 */     // GIR_Coverage, 3630,
     /* 1613818 */     GIR_EraseRootFromParent_Done,
     /* 1613819 */   // Label 22285: @1613819
     /* 1613819 */   GIM_Try, /*On fail goto*//*Label 22286*/ GIMT_Encode4(1613905), // Rule ID 3631 //
     /* 1613824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1613835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1613838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1613841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1613844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1613854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613870 */     // MIs[0] policy
     /* 1613870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613880 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1613883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613904 */     // GIR_Coverage, 3631,
     /* 1613904 */     GIR_EraseRootFromParent_Done,
     /* 1613905 */   // Label 22286: @1613905
     /* 1613905 */   GIM_Try, /*On fail goto*//*Label 22287*/ GIMT_Encode4(1613991), // Rule ID 3634 //
     /* 1613910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1613921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1613924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1613927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1613930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1613933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613956 */     // MIs[0] policy
     /* 1613956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613966 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1613969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613990 */     // GIR_Coverage, 3634,
     /* 1613990 */     GIR_EraseRootFromParent_Done,
     /* 1613991 */   // Label 22287: @1613991
     /* 1613991 */   GIM_Try, /*On fail goto*//*Label 22288*/ GIMT_Encode4(1614077), // Rule ID 3635 //
     /* 1613996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1614007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1614010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1614013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1614016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614042 */     // MIs[0] policy
     /* 1614042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614052 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1614055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614076 */     // GIR_Coverage, 3635,
     /* 1614076 */     GIR_EraseRootFromParent_Done,
     /* 1614077 */   // Label 22288: @1614077
     /* 1614077 */   GIM_Try, /*On fail goto*//*Label 22289*/ GIMT_Encode4(1614163), // Rule ID 3638 //
     /* 1614082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1614093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1614096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1614099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1614102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614128 */     // MIs[0] policy
     /* 1614128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614138 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1614141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614162 */     // GIR_Coverage, 3638,
     /* 1614162 */     GIR_EraseRootFromParent_Done,
     /* 1614163 */   // Label 22289: @1614163
     /* 1614163 */   GIM_Try, /*On fail goto*//*Label 22290*/ GIMT_Encode4(1614249), // Rule ID 3639 //
     /* 1614168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1614179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1614182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1614185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1614188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614214 */     // MIs[0] policy
     /* 1614214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614224 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1614227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614248 */     // GIR_Coverage, 3639,
     /* 1614248 */     GIR_EraseRootFromParent_Done,
     /* 1614249 */   // Label 22290: @1614249
     /* 1614249 */   GIM_Try, /*On fail goto*//*Label 22291*/ GIMT_Encode4(1614335), // Rule ID 3642 //
     /* 1614254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1614265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1614268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1614271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1614274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614300 */     // MIs[0] policy
     /* 1614300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614310 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1614313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614334 */     // GIR_Coverage, 3642,
     /* 1614334 */     GIR_EraseRootFromParent_Done,
     /* 1614335 */   // Label 22291: @1614335
     /* 1614335 */   GIM_Try, /*On fail goto*//*Label 22292*/ GIMT_Encode4(1614421), // Rule ID 3643 //
     /* 1614340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1614351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1614354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1614357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1614360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614386 */     // MIs[0] policy
     /* 1614386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614396 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1614399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614420 */     // GIR_Coverage, 3643,
     /* 1614420 */     GIR_EraseRootFromParent_Done,
     /* 1614421 */   // Label 22292: @1614421
     /* 1614421 */   GIM_Try, /*On fail goto*//*Label 22293*/ GIMT_Encode4(1614507), // Rule ID 3646 //
     /* 1614426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1614437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1614440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1614443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1614446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614472 */     // MIs[0] policy
     /* 1614472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614482 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1614485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614506 */     // GIR_Coverage, 3646,
     /* 1614506 */     GIR_EraseRootFromParent_Done,
     /* 1614507 */   // Label 22293: @1614507
     /* 1614507 */   GIM_Try, /*On fail goto*//*Label 22294*/ GIMT_Encode4(1614593), // Rule ID 3647 //
     /* 1614512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1614523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1614526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1614529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1614532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614558 */     // MIs[0] policy
     /* 1614558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614568 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1614571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614592 */     // GIR_Coverage, 3647,
     /* 1614592 */     GIR_EraseRootFromParent_Done,
     /* 1614593 */   // Label 22294: @1614593
     /* 1614593 */   GIM_Try, /*On fail goto*//*Label 22295*/ GIMT_Encode4(1614679), // Rule ID 3650 //
     /* 1614598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1614609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1614612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1614615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1614618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614644 */     // MIs[0] policy
     /* 1614644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614654 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1614657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614678 */     // GIR_Coverage, 3650,
     /* 1614678 */     GIR_EraseRootFromParent_Done,
     /* 1614679 */   // Label 22295: @1614679
     /* 1614679 */   GIM_Try, /*On fail goto*//*Label 22296*/ GIMT_Encode4(1614765), // Rule ID 3651 //
     /* 1614684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1614695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1614698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1614701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1614704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614730 */     // MIs[0] policy
     /* 1614730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614740 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1614743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614764 */     // GIR_Coverage, 3651,
     /* 1614764 */     GIR_EraseRootFromParent_Done,
     /* 1614765 */   // Label 22296: @1614765
     /* 1614765 */   GIM_Try, /*On fail goto*//*Label 22297*/ GIMT_Encode4(1614851), // Rule ID 3654 //
     /* 1614770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1614781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1614784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1614787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614816 */     // MIs[0] policy
     /* 1614816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614826 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1614829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614850 */     // GIR_Coverage, 3654,
     /* 1614850 */     GIR_EraseRootFromParent_Done,
     /* 1614851 */   // Label 22297: @1614851
     /* 1614851 */   GIM_Try, /*On fail goto*//*Label 22298*/ GIMT_Encode4(1614937), // Rule ID 3655 //
     /* 1614856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1614867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1614870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1614873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614902 */     // MIs[0] policy
     /* 1614902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614912 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1614915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614936 */     // GIR_Coverage, 3655,
     /* 1614936 */     GIR_EraseRootFromParent_Done,
     /* 1614937 */   // Label 22298: @1614937
     /* 1614937 */   GIM_Try, /*On fail goto*//*Label 22299*/ GIMT_Encode4(1615023), // Rule ID 3658 //
     /* 1614942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1614953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1614956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1614959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614988 */     // MIs[0] policy
     /* 1614988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614998 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1615001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615022 */     // GIR_Coverage, 3658,
     /* 1615022 */     GIR_EraseRootFromParent_Done,
     /* 1615023 */   // Label 22299: @1615023
     /* 1615023 */   GIM_Try, /*On fail goto*//*Label 22300*/ GIMT_Encode4(1615109), // Rule ID 3659 //
     /* 1615028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1615039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1615042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1615045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615074 */     // MIs[0] policy
     /* 1615074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615084 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1615087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615108 */     // GIR_Coverage, 3659,
     /* 1615108 */     GIR_EraseRootFromParent_Done,
     /* 1615109 */   // Label 22300: @1615109
     /* 1615109 */   GIM_Try, /*On fail goto*//*Label 22301*/ GIMT_Encode4(1615195), // Rule ID 3662 //
     /* 1615114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1615125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1615128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1615131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615160 */     // MIs[0] policy
     /* 1615160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615170 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1615173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615194 */     // GIR_Coverage, 3662,
     /* 1615194 */     GIR_EraseRootFromParent_Done,
     /* 1615195 */   // Label 22301: @1615195
     /* 1615195 */   GIM_Try, /*On fail goto*//*Label 22302*/ GIMT_Encode4(1615281), // Rule ID 3663 //
     /* 1615200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1615211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1615214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1615217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615246 */     // MIs[0] policy
     /* 1615246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615256 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1615259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615280 */     // GIR_Coverage, 3663,
     /* 1615280 */     GIR_EraseRootFromParent_Done,
     /* 1615281 */   // Label 22302: @1615281
     /* 1615281 */   GIM_Try, /*On fail goto*//*Label 22303*/ GIMT_Encode4(1615367), // Rule ID 3666 //
     /* 1615286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1615297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1615300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1615303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615332 */     // MIs[0] policy
     /* 1615332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615342 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1615345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615366 */     // GIR_Coverage, 3666,
     /* 1615366 */     GIR_EraseRootFromParent_Done,
     /* 1615367 */   // Label 22303: @1615367
     /* 1615367 */   GIM_Try, /*On fail goto*//*Label 22304*/ GIMT_Encode4(1615453), // Rule ID 3667 //
     /* 1615372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1615383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1615386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1615389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615418 */     // MIs[0] policy
     /* 1615418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615428 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1615431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615452 */     // GIR_Coverage, 3667,
     /* 1615452 */     GIR_EraseRootFromParent_Done,
     /* 1615453 */   // Label 22304: @1615453
     /* 1615453 */   GIM_Try, /*On fail goto*//*Label 22305*/ GIMT_Encode4(1615539), // Rule ID 3670 //
     /* 1615458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1615469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1615472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1615475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615504 */     // MIs[0] policy
     /* 1615504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615514 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1615517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615538 */     // GIR_Coverage, 3670,
     /* 1615538 */     GIR_EraseRootFromParent_Done,
     /* 1615539 */   // Label 22305: @1615539
     /* 1615539 */   GIM_Try, /*On fail goto*//*Label 22306*/ GIMT_Encode4(1615625), // Rule ID 3671 //
     /* 1615544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1615555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1615558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1615561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615590 */     // MIs[0] policy
     /* 1615590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615600 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1615603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615624 */     // GIR_Coverage, 3671,
     /* 1615624 */     GIR_EraseRootFromParent_Done,
     /* 1615625 */   // Label 22306: @1615625
     /* 1615625 */   GIM_Try, /*On fail goto*//*Label 22307*/ GIMT_Encode4(1615711), // Rule ID 3674 //
     /* 1615630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1615641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1615644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1615647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1615653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615676 */     // MIs[0] policy
     /* 1615676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615686 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1615689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615710 */     // GIR_Coverage, 3674,
     /* 1615710 */     GIR_EraseRootFromParent_Done,
     /* 1615711 */   // Label 22307: @1615711
     /* 1615711 */   GIM_Try, /*On fail goto*//*Label 22308*/ GIMT_Encode4(1615797), // Rule ID 3675 //
     /* 1615716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1615727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1615730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1615733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1615739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615762 */     // MIs[0] policy
     /* 1615762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615772 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1615775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615796 */     // GIR_Coverage, 3675,
     /* 1615796 */     GIR_EraseRootFromParent_Done,
     /* 1615797 */   // Label 22308: @1615797
     /* 1615797 */   GIM_Try, /*On fail goto*//*Label 22309*/ GIMT_Encode4(1615883), // Rule ID 3678 //
     /* 1615802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1615813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1615816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1615819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1615825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615848 */     // MIs[0] policy
     /* 1615848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615858 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1615861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1615879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615882 */     // GIR_Coverage, 3678,
     /* 1615882 */     GIR_EraseRootFromParent_Done,
     /* 1615883 */   // Label 22309: @1615883
     /* 1615883 */   GIM_Try, /*On fail goto*//*Label 22310*/ GIMT_Encode4(1615969), // Rule ID 3679 //
     /* 1615888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1615899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1615902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1615905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1615911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615934 */     // MIs[0] policy
     /* 1615934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615944 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1615947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1615965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615968 */     // GIR_Coverage, 3679,
     /* 1615968 */     GIR_EraseRootFromParent_Done,
     /* 1615969 */   // Label 22310: @1615969
     /* 1615969 */   GIM_Try, /*On fail goto*//*Label 22311*/ GIMT_Encode4(1616055), // Rule ID 3682 //
     /* 1615974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1615985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1615988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1615991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616020 */     // MIs[0] policy
     /* 1616020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1616033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616054 */     // GIR_Coverage, 3682,
     /* 1616054 */     GIR_EraseRootFromParent_Done,
     /* 1616055 */   // Label 22311: @1616055
     /* 1616055 */   GIM_Try, /*On fail goto*//*Label 22312*/ GIMT_Encode4(1616141), // Rule ID 3683 //
     /* 1616060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1616071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1616074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1616077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616106 */     // MIs[0] policy
     /* 1616106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616116 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1616119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616140 */     // GIR_Coverage, 3683,
     /* 1616140 */     GIR_EraseRootFromParent_Done,
     /* 1616141 */   // Label 22312: @1616141
     /* 1616141 */   GIM_Try, /*On fail goto*//*Label 22313*/ GIMT_Encode4(1616227), // Rule ID 3686 //
     /* 1616146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1616157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1616160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1616163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616192 */     // MIs[0] policy
     /* 1616192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1616205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616226 */     // GIR_Coverage, 3686,
     /* 1616226 */     GIR_EraseRootFromParent_Done,
     /* 1616227 */   // Label 22313: @1616227
     /* 1616227 */   GIM_Try, /*On fail goto*//*Label 22314*/ GIMT_Encode4(1616313), // Rule ID 3687 //
     /* 1616232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1616243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1616246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1616249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616278 */     // MIs[0] policy
     /* 1616278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616288 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1616291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616312 */     // GIR_Coverage, 3687,
     /* 1616312 */     GIR_EraseRootFromParent_Done,
     /* 1616313 */   // Label 22314: @1616313
     /* 1616313 */   GIM_Try, /*On fail goto*//*Label 22315*/ GIMT_Encode4(1616399), // Rule ID 3690 //
     /* 1616318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1616329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1616332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1616335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616364 */     // MIs[0] policy
     /* 1616364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616374 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1616377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616398 */     // GIR_Coverage, 3690,
     /* 1616398 */     GIR_EraseRootFromParent_Done,
     /* 1616399 */   // Label 22315: @1616399
     /* 1616399 */   GIM_Try, /*On fail goto*//*Label 22316*/ GIMT_Encode4(1616485), // Rule ID 3691 //
     /* 1616404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1616415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1616418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1616421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616450 */     // MIs[0] policy
     /* 1616450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1616463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616484 */     // GIR_Coverage, 3691,
     /* 1616484 */     GIR_EraseRootFromParent_Done,
     /* 1616485 */   // Label 22316: @1616485
     /* 1616485 */   GIM_Try, /*On fail goto*//*Label 22317*/ GIMT_Encode4(1616571), // Rule ID 3694 //
     /* 1616490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1616501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1616504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1616507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616536 */     // MIs[0] policy
     /* 1616536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1616549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616570 */     // GIR_Coverage, 3694,
     /* 1616570 */     GIR_EraseRootFromParent_Done,
     /* 1616571 */   // Label 22317: @1616571
     /* 1616571 */   GIM_Try, /*On fail goto*//*Label 22318*/ GIMT_Encode4(1616657), // Rule ID 3695 //
     /* 1616576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1616587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1616590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1616593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616622 */     // MIs[0] policy
     /* 1616622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1616635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616656 */     // GIR_Coverage, 3695,
     /* 1616656 */     GIR_EraseRootFromParent_Done,
     /* 1616657 */   // Label 22318: @1616657
     /* 1616657 */   GIM_Try, /*On fail goto*//*Label 22319*/ GIMT_Encode4(1616743), // Rule ID 3698 //
     /* 1616662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1616665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1616673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1616676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1616679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616708 */     // MIs[0] policy
     /* 1616708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616718 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1616721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1616739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616742 */     // GIR_Coverage, 3698,
     /* 1616742 */     GIR_EraseRootFromParent_Done,
     /* 1616743 */   // Label 22319: @1616743
     /* 1616743 */   GIM_Try, /*On fail goto*//*Label 22320*/ GIMT_Encode4(1616829), // Rule ID 3699 //
     /* 1616748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1616751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1616759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1616762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1616765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616794 */     // MIs[0] policy
     /* 1616794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616804 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1616807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1616825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616828 */     // GIR_Coverage, 3699,
     /* 1616828 */     GIR_EraseRootFromParent_Done,
     /* 1616829 */   // Label 22320: @1616829
     /* 1616829 */   GIM_Try, /*On fail goto*//*Label 22321*/ GIMT_Encode4(1616915), // Rule ID 3702 //
     /* 1616834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1616837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1616845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1616848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1616851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616880 */     // MIs[0] policy
     /* 1616880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616890 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1616893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1616911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616914 */     // GIR_Coverage, 3702,
     /* 1616914 */     GIR_EraseRootFromParent_Done,
     /* 1616915 */   // Label 22321: @1616915
     /* 1616915 */   GIM_Try, /*On fail goto*//*Label 22322*/ GIMT_Encode4(1617001), // Rule ID 3703 //
     /* 1616920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1616923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1616931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1616934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1616937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616966 */     // MIs[0] policy
     /* 1616966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1616979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1616997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617000 */     // GIR_Coverage, 3703,
     /* 1617000 */     GIR_EraseRootFromParent_Done,
     /* 1617001 */   // Label 22322: @1617001
     /* 1617001 */   GIM_Try, /*On fail goto*//*Label 22323*/ GIMT_Encode4(1617087), // Rule ID 3706 //
     /* 1617006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1617017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1617020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1617023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617052 */     // MIs[0] policy
     /* 1617052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617062 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1617065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617086 */     // GIR_Coverage, 3706,
     /* 1617086 */     GIR_EraseRootFromParent_Done,
     /* 1617087 */   // Label 22323: @1617087
     /* 1617087 */   GIM_Try, /*On fail goto*//*Label 22324*/ GIMT_Encode4(1617173), // Rule ID 3707 //
     /* 1617092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1617103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1617106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1617109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617138 */     // MIs[0] policy
     /* 1617138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617148 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1617151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617172 */     // GIR_Coverage, 3707,
     /* 1617172 */     GIR_EraseRootFromParent_Done,
     /* 1617173 */   // Label 22324: @1617173
     /* 1617173 */   GIM_Try, /*On fail goto*//*Label 22325*/ GIMT_Encode4(1617259), // Rule ID 3710 //
     /* 1617178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1617189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1617192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1617195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617224 */     // MIs[0] policy
     /* 1617224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617234 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1617237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617258 */     // GIR_Coverage, 3710,
     /* 1617258 */     GIR_EraseRootFromParent_Done,
     /* 1617259 */   // Label 22325: @1617259
     /* 1617259 */   GIM_Try, /*On fail goto*//*Label 22326*/ GIMT_Encode4(1617345), // Rule ID 3711 //
     /* 1617264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1617275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1617278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1617281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617310 */     // MIs[0] policy
     /* 1617310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617320 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1617323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617344 */     // GIR_Coverage, 3711,
     /* 1617344 */     GIR_EraseRootFromParent_Done,
     /* 1617345 */   // Label 22326: @1617345
     /* 1617345 */   GIM_Try, /*On fail goto*//*Label 22327*/ GIMT_Encode4(1617431), // Rule ID 3714 //
     /* 1617350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1617361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1617364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1617367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1617370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617396 */     // MIs[0] policy
     /* 1617396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617406 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11686:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1617409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617430 */     // GIR_Coverage, 3714,
     /* 1617430 */     GIR_EraseRootFromParent_Done,
     /* 1617431 */   // Label 22327: @1617431
     /* 1617431 */   GIM_Try, /*On fail goto*//*Label 22328*/ GIMT_Encode4(1617517), // Rule ID 3715 //
     /* 1617436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1617447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1617450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1617453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1617456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617482 */     // MIs[0] policy
     /* 1617482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617492 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11686:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1617495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617516 */     // GIR_Coverage, 3715,
     /* 1617516 */     GIR_EraseRootFromParent_Done,
     /* 1617517 */   // Label 22328: @1617517
     /* 1617517 */   GIM_Try, /*On fail goto*//*Label 22329*/ GIMT_Encode4(1617603), // Rule ID 3718 //
     /* 1617522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1617533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1617536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1617539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1617542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617568 */     // MIs[0] policy
     /* 1617568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617578 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11686:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1617581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617602 */     // GIR_Coverage, 3718,
     /* 1617602 */     GIR_EraseRootFromParent_Done,
     /* 1617603 */   // Label 22329: @1617603
     /* 1617603 */   GIM_Try, /*On fail goto*//*Label 22330*/ GIMT_Encode4(1617689), // Rule ID 3719 //
     /* 1617608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1617619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1617622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1617625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1617628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617654 */     // MIs[0] policy
     /* 1617654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617664 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11686:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1617667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617688 */     // GIR_Coverage, 3719,
     /* 1617688 */     GIR_EraseRootFromParent_Done,
     /* 1617689 */   // Label 22330: @1617689
     /* 1617689 */   GIM_Try, /*On fail goto*//*Label 22331*/ GIMT_Encode4(1617775), // Rule ID 3722 //
     /* 1617694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1617705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1617708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1617711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1617714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617740 */     // MIs[0] policy
     /* 1617740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11686:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1617753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617774 */     // GIR_Coverage, 3722,
     /* 1617774 */     GIR_EraseRootFromParent_Done,
     /* 1617775 */   // Label 22331: @1617775
     /* 1617775 */   GIM_Try, /*On fail goto*//*Label 22332*/ GIMT_Encode4(1617861), // Rule ID 3723 //
     /* 1617780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1617791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1617794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1617797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1617800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617826 */     // MIs[0] policy
     /* 1617826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617836 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11686:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1617839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617860 */     // GIR_Coverage, 3723,
     /* 1617860 */     GIR_EraseRootFromParent_Done,
     /* 1617861 */   // Label 22332: @1617861
     /* 1617861 */   GIM_Try, /*On fail goto*//*Label 22333*/ GIMT_Encode4(1617947), // Rule ID 3726 //
     /* 1617866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1617877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1617880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1617883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1617886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617912 */     // MIs[0] policy
     /* 1617912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11686:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1617925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617946 */     // GIR_Coverage, 3726,
     /* 1617946 */     GIR_EraseRootFromParent_Done,
     /* 1617947 */   // Label 22333: @1617947
     /* 1617947 */   GIM_Try, /*On fail goto*//*Label 22334*/ GIMT_Encode4(1618033), // Rule ID 3727 //
     /* 1617952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1617963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1617966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1617969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1617972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617998 */     // MIs[0] policy
     /* 1617998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618008 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11686:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1618011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618032 */     // GIR_Coverage, 3727,
     /* 1618032 */     GIR_EraseRootFromParent_Done,
     /* 1618033 */   // Label 22334: @1618033
     /* 1618033 */   GIM_Try, /*On fail goto*//*Label 22335*/ GIMT_Encode4(1618119), // Rule ID 3730 //
     /* 1618038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1618049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1618052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1618055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1618058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1618061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618084 */     // MIs[0] policy
     /* 1618084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618094 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11686:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1618097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618118 */     // GIR_Coverage, 3730,
     /* 1618118 */     GIR_EraseRootFromParent_Done,
     /* 1618119 */   // Label 22335: @1618119
     /* 1618119 */   GIM_Try, /*On fail goto*//*Label 22336*/ GIMT_Encode4(1618205), // Rule ID 3731 //
     /* 1618124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1618135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1618138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1618141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1618144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1618147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618170 */     // MIs[0] policy
     /* 1618170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618180 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11686:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1618183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618204 */     // GIR_Coverage, 3731,
     /* 1618204 */     GIR_EraseRootFromParent_Done,
     /* 1618205 */   // Label 22336: @1618205
     /* 1618205 */   GIM_Try, /*On fail goto*//*Label 22337*/ GIMT_Encode4(1618291), // Rule ID 3734 //
     /* 1618210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1618221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1618224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1618227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1618230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618256 */     // MIs[0] policy
     /* 1618256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618266 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11686:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1618269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618290 */     // GIR_Coverage, 3734,
     /* 1618290 */     GIR_EraseRootFromParent_Done,
     /* 1618291 */   // Label 22337: @1618291
     /* 1618291 */   GIM_Try, /*On fail goto*//*Label 22338*/ GIMT_Encode4(1618377), // Rule ID 3735 //
     /* 1618296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1618307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1618310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1618313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1618316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618342 */     // MIs[0] policy
     /* 1618342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618352 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11686:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1618355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618376 */     // GIR_Coverage, 3735,
     /* 1618376 */     GIR_EraseRootFromParent_Done,
     /* 1618377 */   // Label 22338: @1618377
     /* 1618377 */   GIM_Try, /*On fail goto*//*Label 22339*/ GIMT_Encode4(1618463), // Rule ID 3738 //
     /* 1618382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1618393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1618396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1618399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1618402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618428 */     // MIs[0] policy
     /* 1618428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618438 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11686:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1618441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618462 */     // GIR_Coverage, 3738,
     /* 1618462 */     GIR_EraseRootFromParent_Done,
     /* 1618463 */   // Label 22339: @1618463
     /* 1618463 */   GIM_Try, /*On fail goto*//*Label 22340*/ GIMT_Encode4(1618549), // Rule ID 3739 //
     /* 1618468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1618479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1618482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1618485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1618488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618514 */     // MIs[0] policy
     /* 1618514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618524 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11686:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1618527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618548 */     // GIR_Coverage, 3739,
     /* 1618548 */     GIR_EraseRootFromParent_Done,
     /* 1618549 */   // Label 22340: @1618549
     /* 1618549 */   GIM_Try, /*On fail goto*//*Label 22341*/ GIMT_Encode4(1618635), // Rule ID 3742 //
     /* 1618554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1618565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1618568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1618571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1618574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618600 */     // MIs[0] policy
     /* 1618600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618610 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11686:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1618613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618634 */     // GIR_Coverage, 3742,
     /* 1618634 */     GIR_EraseRootFromParent_Done,
     /* 1618635 */   // Label 22341: @1618635
     /* 1618635 */   GIM_Try, /*On fail goto*//*Label 22342*/ GIMT_Encode4(1618721), // Rule ID 3743 //
     /* 1618640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1618651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1618654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1618657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1618660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618686 */     // MIs[0] policy
     /* 1618686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11686:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1618699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618720 */     // GIR_Coverage, 3743,
     /* 1618720 */     GIR_EraseRootFromParent_Done,
     /* 1618721 */   // Label 22342: @1618721
     /* 1618721 */   GIM_Try, /*On fail goto*//*Label 22343*/ GIMT_Encode4(1618807), // Rule ID 3746 //
     /* 1618726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1618737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1618740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1618743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1618746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618772 */     // MIs[0] policy
     /* 1618772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11686:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1618785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618806 */     // GIR_Coverage, 3746,
     /* 1618806 */     GIR_EraseRootFromParent_Done,
     /* 1618807 */   // Label 22343: @1618807
     /* 1618807 */   GIM_Try, /*On fail goto*//*Label 22344*/ GIMT_Encode4(1618893), // Rule ID 3747 //
     /* 1618812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1618823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1618826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1618829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1618832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618858 */     // MIs[0] policy
     /* 1618858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11686:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1618871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618892 */     // GIR_Coverage, 3747,
     /* 1618892 */     GIR_EraseRootFromParent_Done,
     /* 1618893 */   // Label 22344: @1618893
     /* 1618893 */   GIM_Try, /*On fail goto*//*Label 22345*/ GIMT_Encode4(1618979), // Rule ID 3750 //
     /* 1618898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1618909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1618912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1618915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1618918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618944 */     // MIs[0] policy
     /* 1618944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618954 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11686:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1618957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618978 */     // GIR_Coverage, 3750,
     /* 1618978 */     GIR_EraseRootFromParent_Done,
     /* 1618979 */   // Label 22345: @1618979
     /* 1618979 */   GIM_Try, /*On fail goto*//*Label 22346*/ GIMT_Encode4(1619065), // Rule ID 3751 //
     /* 1618984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1618995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1618998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1619001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1619004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619030 */     // MIs[0] policy
     /* 1619030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619040 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11686:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1619043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619064 */     // GIR_Coverage, 3751,
     /* 1619064 */     GIR_EraseRootFromParent_Done,
     /* 1619065 */   // Label 22346: @1619065
     /* 1619065 */   GIM_Try, /*On fail goto*//*Label 22347*/ GIMT_Encode4(1619151), // Rule ID 3754 //
     /* 1619070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1619081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1619084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1619087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1619090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619116 */     // MIs[0] policy
     /* 1619116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619126 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11686:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1619129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619150 */     // GIR_Coverage, 3754,
     /* 1619150 */     GIR_EraseRootFromParent_Done,
     /* 1619151 */   // Label 22347: @1619151
     /* 1619151 */   GIM_Try, /*On fail goto*//*Label 22348*/ GIMT_Encode4(1619237), // Rule ID 3755 //
     /* 1619156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1619167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1619170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1619173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1619176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619202 */     // MIs[0] policy
     /* 1619202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619212 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11686:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1619215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619236 */     // GIR_Coverage, 3755,
     /* 1619236 */     GIR_EraseRootFromParent_Done,
     /* 1619237 */   // Label 22348: @1619237
     /* 1619237 */   GIM_Try, /*On fail goto*//*Label 22349*/ GIMT_Encode4(1619323), // Rule ID 3758 //
     /* 1619242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1619253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1619256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1619259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1619262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619288 */     // MIs[0] policy
     /* 1619288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619298 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11686:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1619301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619322 */     // GIR_Coverage, 3758,
     /* 1619322 */     GIR_EraseRootFromParent_Done,
     /* 1619323 */   // Label 22349: @1619323
     /* 1619323 */   GIM_Try, /*On fail goto*//*Label 22350*/ GIMT_Encode4(1619409), // Rule ID 3759 //
     /* 1619328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1619339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1619342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1619345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1619348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619374 */     // MIs[0] policy
     /* 1619374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11686:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1619387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619408 */     // GIR_Coverage, 3759,
     /* 1619408 */     GIR_EraseRootFromParent_Done,
     /* 1619409 */   // Label 22350: @1619409
     /* 1619409 */   GIM_Try, /*On fail goto*//*Label 22351*/ GIMT_Encode4(1619495), // Rule ID 3762 //
     /* 1619414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1619425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1619428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1619431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1619434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619460 */     // MIs[0] policy
     /* 1619460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619470 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11686:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1619473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619494 */     // GIR_Coverage, 3762,
     /* 1619494 */     GIR_EraseRootFromParent_Done,
     /* 1619495 */   // Label 22351: @1619495
     /* 1619495 */   GIM_Try, /*On fail goto*//*Label 22352*/ GIMT_Encode4(1619581), // Rule ID 3763 //
     /* 1619500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1619511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1619514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1619517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1619520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619546 */     // MIs[0] policy
     /* 1619546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11686:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1619559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619580 */     // GIR_Coverage, 3763,
     /* 1619580 */     GIR_EraseRootFromParent_Done,
     /* 1619581 */   // Label 22352: @1619581
     /* 1619581 */   GIM_Try, /*On fail goto*//*Label 22353*/ GIMT_Encode4(1619667), // Rule ID 3766 //
     /* 1619586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1619597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1619600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1619603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1619606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619632 */     // MIs[0] policy
     /* 1619632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619642 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11686:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1619645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619666 */     // GIR_Coverage, 3766,
     /* 1619666 */     GIR_EraseRootFromParent_Done,
     /* 1619667 */   // Label 22353: @1619667
     /* 1619667 */   GIM_Try, /*On fail goto*//*Label 22354*/ GIMT_Encode4(1619753), // Rule ID 3767 //
     /* 1619672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1619683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1619686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1619689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1619692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619718 */     // MIs[0] policy
     /* 1619718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619728 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11686:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1619731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619752 */     // GIR_Coverage, 3767,
     /* 1619752 */     GIR_EraseRootFromParent_Done,
     /* 1619753 */   // Label 22354: @1619753
     /* 1619753 */   GIM_Try, /*On fail goto*//*Label 22355*/ GIMT_Encode4(1619839), // Rule ID 3770 //
     /* 1619758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1619769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1619772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1619775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1619778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619804 */     // MIs[0] policy
     /* 1619804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619814 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11686:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1619817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619838 */     // GIR_Coverage, 3770,
     /* 1619838 */     GIR_EraseRootFromParent_Done,
     /* 1619839 */   // Label 22355: @1619839
     /* 1619839 */   GIM_Try, /*On fail goto*//*Label 22356*/ GIMT_Encode4(1619925), // Rule ID 3771 //
     /* 1619844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1619855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1619858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1619861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1619864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619890 */     // MIs[0] policy
     /* 1619890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619900 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11686:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1619903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619924 */     // GIR_Coverage, 3771,
     /* 1619924 */     GIR_EraseRootFromParent_Done,
     /* 1619925 */   // Label 22356: @1619925
     /* 1619925 */   GIM_Try, /*On fail goto*//*Label 22357*/ GIMT_Encode4(1620011), // Rule ID 3774 //
     /* 1619930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1619941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1619944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1619947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619976 */     // MIs[0] policy
     /* 1619976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619986 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11686:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1619989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620010 */     // GIR_Coverage, 3774,
     /* 1620010 */     GIR_EraseRootFromParent_Done,
     /* 1620011 */   // Label 22357: @1620011
     /* 1620011 */   GIM_Try, /*On fail goto*//*Label 22358*/ GIMT_Encode4(1620097), // Rule ID 3775 //
     /* 1620016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1620027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1620030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1620033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620062 */     // MIs[0] policy
     /* 1620062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620072 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11686:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1620075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620096 */     // GIR_Coverage, 3775,
     /* 1620096 */     GIR_EraseRootFromParent_Done,
     /* 1620097 */   // Label 22358: @1620097
     /* 1620097 */   GIM_Try, /*On fail goto*//*Label 22359*/ GIMT_Encode4(1620183), // Rule ID 3778 //
     /* 1620102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1620113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1620116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1620119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620148 */     // MIs[0] policy
     /* 1620148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620158 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11686:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1620161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620182 */     // GIR_Coverage, 3778,
     /* 1620182 */     GIR_EraseRootFromParent_Done,
     /* 1620183 */   // Label 22359: @1620183
     /* 1620183 */   GIM_Try, /*On fail goto*//*Label 22360*/ GIMT_Encode4(1620269), // Rule ID 3779 //
     /* 1620188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1620199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1620202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1620205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620234 */     // MIs[0] policy
     /* 1620234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620244 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11686:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1620247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620268 */     // GIR_Coverage, 3779,
     /* 1620268 */     GIR_EraseRootFromParent_Done,
     /* 1620269 */   // Label 22360: @1620269
     /* 1620269 */   GIM_Try, /*On fail goto*//*Label 22361*/ GIMT_Encode4(1620355), // Rule ID 3782 //
     /* 1620274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1620285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1620288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1620291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620320 */     // MIs[0] policy
     /* 1620320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620330 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11686:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1620333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620354 */     // GIR_Coverage, 3782,
     /* 1620354 */     GIR_EraseRootFromParent_Done,
     /* 1620355 */   // Label 22361: @1620355
     /* 1620355 */   GIM_Try, /*On fail goto*//*Label 22362*/ GIMT_Encode4(1620441), // Rule ID 3783 //
     /* 1620360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1620371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1620374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1620377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620406 */     // MIs[0] policy
     /* 1620406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620416 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11686:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1620419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620440 */     // GIR_Coverage, 3783,
     /* 1620440 */     GIR_EraseRootFromParent_Done,
     /* 1620441 */   // Label 22362: @1620441
     /* 1620441 */   GIM_Try, /*On fail goto*//*Label 22363*/ GIMT_Encode4(1620527), // Rule ID 3786 //
     /* 1620446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1620457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1620460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1620463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620492 */     // MIs[0] policy
     /* 1620492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11686:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1620505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620526 */     // GIR_Coverage, 3786,
     /* 1620526 */     GIR_EraseRootFromParent_Done,
     /* 1620527 */   // Label 22363: @1620527
     /* 1620527 */   GIM_Try, /*On fail goto*//*Label 22364*/ GIMT_Encode4(1620613), // Rule ID 3787 //
     /* 1620532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1620543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1620546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1620549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620578 */     // MIs[0] policy
     /* 1620578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620588 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11686:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1620591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620612 */     // GIR_Coverage, 3787,
     /* 1620612 */     GIR_EraseRootFromParent_Done,
     /* 1620613 */   // Label 22364: @1620613
     /* 1620613 */   GIM_Try, /*On fail goto*//*Label 22365*/ GIMT_Encode4(1620699), // Rule ID 3790 //
     /* 1620618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1620629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1620632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1620635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1620641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620664 */     // MIs[0] policy
     /* 1620664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620674 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11686:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1620677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620698 */     // GIR_Coverage, 3790,
     /* 1620698 */     GIR_EraseRootFromParent_Done,
     /* 1620699 */   // Label 22365: @1620699
     /* 1620699 */   GIM_Try, /*On fail goto*//*Label 22366*/ GIMT_Encode4(1620785), // Rule ID 3791 //
     /* 1620704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1620715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1620718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1620721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1620727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620750 */     // MIs[0] policy
     /* 1620750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620760 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11686:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1620763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620784 */     // GIR_Coverage, 3791,
     /* 1620784 */     GIR_EraseRootFromParent_Done,
     /* 1620785 */   // Label 22366: @1620785
     /* 1620785 */   GIM_Try, /*On fail goto*//*Label 22367*/ GIMT_Encode4(1620871), // Rule ID 3794 //
     /* 1620790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1620801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1620804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1620807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1620813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620836 */     // MIs[0] policy
     /* 1620836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620846 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11686:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1620849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620870 */     // GIR_Coverage, 3794,
     /* 1620870 */     GIR_EraseRootFromParent_Done,
     /* 1620871 */   // Label 22367: @1620871
     /* 1620871 */   GIM_Try, /*On fail goto*//*Label 22368*/ GIMT_Encode4(1620957), // Rule ID 3795 //
     /* 1620876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1620887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1620890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1620893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1620899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620922 */     // MIs[0] policy
     /* 1620922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620932 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11686:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1620935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620956 */     // GIR_Coverage, 3795,
     /* 1620956 */     GIR_EraseRootFromParent_Done,
     /* 1620957 */   // Label 22368: @1620957
     /* 1620957 */   GIM_Try, /*On fail goto*//*Label 22369*/ GIMT_Encode4(1621043), // Rule ID 3798 //
     /* 1620962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1620973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1620976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1620979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621008 */     // MIs[0] policy
     /* 1621008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11686:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1621021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621042 */     // GIR_Coverage, 3798,
     /* 1621042 */     GIR_EraseRootFromParent_Done,
     /* 1621043 */   // Label 22369: @1621043
     /* 1621043 */   GIM_Try, /*On fail goto*//*Label 22370*/ GIMT_Encode4(1621129), // Rule ID 3799 //
     /* 1621048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1621059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1621062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1621065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621094 */     // MIs[0] policy
     /* 1621094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621104 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11686:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1621107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621128 */     // GIR_Coverage, 3799,
     /* 1621128 */     GIR_EraseRootFromParent_Done,
     /* 1621129 */   // Label 22370: @1621129
     /* 1621129 */   GIM_Try, /*On fail goto*//*Label 22371*/ GIMT_Encode4(1621215), // Rule ID 3802 //
     /* 1621134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1621145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1621148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1621151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621180 */     // MIs[0] policy
     /* 1621180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11686:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1621193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621214 */     // GIR_Coverage, 3802,
     /* 1621214 */     GIR_EraseRootFromParent_Done,
     /* 1621215 */   // Label 22371: @1621215
     /* 1621215 */   GIM_Try, /*On fail goto*//*Label 22372*/ GIMT_Encode4(1621301), // Rule ID 3803 //
     /* 1621220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1621231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1621234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1621237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621266 */     // MIs[0] policy
     /* 1621266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621276 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11686:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1621279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621300 */     // GIR_Coverage, 3803,
     /* 1621300 */     GIR_EraseRootFromParent_Done,
     /* 1621301 */   // Label 22372: @1621301
     /* 1621301 */   GIM_Try, /*On fail goto*//*Label 22373*/ GIMT_Encode4(1621387), // Rule ID 3806 //
     /* 1621306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1621317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1621320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1621323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621352 */     // MIs[0] policy
     /* 1621352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621362 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11686:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1621365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621386 */     // GIR_Coverage, 3806,
     /* 1621386 */     GIR_EraseRootFromParent_Done,
     /* 1621387 */   // Label 22373: @1621387
     /* 1621387 */   GIM_Try, /*On fail goto*//*Label 22374*/ GIMT_Encode4(1621473), // Rule ID 3807 //
     /* 1621392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1621403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1621406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1621409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621438 */     // MIs[0] policy
     /* 1621438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621448 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11686:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1621451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621472 */     // GIR_Coverage, 3807,
     /* 1621472 */     GIR_EraseRootFromParent_Done,
     /* 1621473 */   // Label 22374: @1621473
     /* 1621473 */   GIM_Try, /*On fail goto*//*Label 22375*/ GIMT_Encode4(1621559), // Rule ID 3810 //
     /* 1621478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1621489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1621492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1621495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621524 */     // MIs[0] policy
     /* 1621524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621534 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11686:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1621537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621558 */     // GIR_Coverage, 3810,
     /* 1621558 */     GIR_EraseRootFromParent_Done,
     /* 1621559 */   // Label 22375: @1621559
     /* 1621559 */   GIM_Try, /*On fail goto*//*Label 22376*/ GIMT_Encode4(1621645), // Rule ID 3811 //
     /* 1621564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1621575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1621578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1621581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621610 */     // MIs[0] policy
     /* 1621610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621620 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11686:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1621623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621644 */     // GIR_Coverage, 3811,
     /* 1621644 */     GIR_EraseRootFromParent_Done,
     /* 1621645 */   // Label 22376: @1621645
     /* 1621645 */   GIM_Try, /*On fail goto*//*Label 22377*/ GIMT_Encode4(1621731), // Rule ID 3814 //
     /* 1621650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1621661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1621664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1621667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621696 */     // MIs[0] policy
     /* 1621696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621706 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11686:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1621709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621730 */     // GIR_Coverage, 3814,
     /* 1621730 */     GIR_EraseRootFromParent_Done,
     /* 1621731 */   // Label 22377: @1621731
     /* 1621731 */   GIM_Try, /*On fail goto*//*Label 22378*/ GIMT_Encode4(1621817), // Rule ID 3815 //
     /* 1621736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1621747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1621750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1621753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621782 */     // MIs[0] policy
     /* 1621782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621792 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11686:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1621795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621816 */     // GIR_Coverage, 3815,
     /* 1621816 */     GIR_EraseRootFromParent_Done,
     /* 1621817 */   // Label 22378: @1621817
     /* 1621817 */   GIM_Try, /*On fail goto*//*Label 22379*/ GIMT_Encode4(1621903), // Rule ID 3818 //
     /* 1621822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1621825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1621833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1621836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1621839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621868 */     // MIs[0] policy
     /* 1621868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621878 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11686:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1621881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1621899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621902 */     // GIR_Coverage, 3818,
     /* 1621902 */     GIR_EraseRootFromParent_Done,
     /* 1621903 */   // Label 22379: @1621903
     /* 1621903 */   GIM_Try, /*On fail goto*//*Label 22380*/ GIMT_Encode4(1621989), // Rule ID 3819 //
     /* 1621908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1621911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1621919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1621922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1621925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621954 */     // MIs[0] policy
     /* 1621954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621964 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11686:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1621967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1621985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621988 */     // GIR_Coverage, 3819,
     /* 1621988 */     GIR_EraseRootFromParent_Done,
     /* 1621989 */   // Label 22380: @1621989
     /* 1621989 */   GIM_Try, /*On fail goto*//*Label 22381*/ GIMT_Encode4(1622075), // Rule ID 3822 //
     /* 1621994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1621997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1622005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1622008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1622011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622040 */     // MIs[0] policy
     /* 1622040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622050 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11686:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1622053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622074 */     // GIR_Coverage, 3822,
     /* 1622074 */     GIR_EraseRootFromParent_Done,
     /* 1622075 */   // Label 22381: @1622075
     /* 1622075 */   GIM_Try, /*On fail goto*//*Label 22382*/ GIMT_Encode4(1622161), // Rule ID 3823 //
     /* 1622080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1622091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1622094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1622097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622126 */     // MIs[0] policy
     /* 1622126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622136 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11686:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1622139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622160 */     // GIR_Coverage, 3823,
     /* 1622160 */     GIR_EraseRootFromParent_Done,
     /* 1622161 */   // Label 22382: @1622161
     /* 1622161 */   GIM_Try, /*On fail goto*//*Label 22383*/ GIMT_Encode4(1622247), // Rule ID 3826 //
     /* 1622166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1622177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1622180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1622183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622212 */     // MIs[0] policy
     /* 1622212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622222 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11686:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1622225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622246 */     // GIR_Coverage, 3826,
     /* 1622246 */     GIR_EraseRootFromParent_Done,
     /* 1622247 */   // Label 22383: @1622247
     /* 1622247 */   GIM_Try, /*On fail goto*//*Label 22384*/ GIMT_Encode4(1622333), // Rule ID 3827 //
     /* 1622252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1622263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1622266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1622269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622298 */     // MIs[0] policy
     /* 1622298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622308 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11686:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1622311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622332 */     // GIR_Coverage, 3827,
     /* 1622332 */     GIR_EraseRootFromParent_Done,
     /* 1622333 */   // Label 22384: @1622333
     /* 1622333 */   GIM_Try, /*On fail goto*//*Label 22385*/ GIMT_Encode4(1622419), // Rule ID 3830 //
     /* 1622338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1622349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1622352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1622355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622384 */     // MIs[0] policy
     /* 1622384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622394 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11686:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1622397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622418 */     // GIR_Coverage, 3830,
     /* 1622418 */     GIR_EraseRootFromParent_Done,
     /* 1622419 */   // Label 22385: @1622419
     /* 1622419 */   GIM_Try, /*On fail goto*//*Label 22386*/ GIMT_Encode4(1622505), // Rule ID 3831 //
     /* 1622424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1622435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1622438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1622441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622470 */     // MIs[0] policy
     /* 1622470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622480 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11686:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1622483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622504 */     // GIR_Coverage, 3831,
     /* 1622504 */     GIR_EraseRootFromParent_Done,
     /* 1622505 */   // Label 22386: @1622505
     /* 1622505 */   GIM_Try, /*On fail goto*//*Label 22387*/ GIMT_Encode4(1622591), // Rule ID 3834 //
     /* 1622510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1622521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1622524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1622527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1622530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622556 */     // MIs[0] policy
     /* 1622556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622566 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1622569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622590 */     // GIR_Coverage, 3834,
     /* 1622590 */     GIR_EraseRootFromParent_Done,
     /* 1622591 */   // Label 22387: @1622591
     /* 1622591 */   GIM_Try, /*On fail goto*//*Label 22388*/ GIMT_Encode4(1622677), // Rule ID 3835 //
     /* 1622596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1622607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1622610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1622613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1622616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622642 */     // MIs[0] policy
     /* 1622642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622652 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1622655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622676 */     // GIR_Coverage, 3835,
     /* 1622676 */     GIR_EraseRootFromParent_Done,
     /* 1622677 */   // Label 22388: @1622677
     /* 1622677 */   GIM_Try, /*On fail goto*//*Label 22389*/ GIMT_Encode4(1622763), // Rule ID 3838 //
     /* 1622682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1622693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1622696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1622699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1622702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622728 */     // MIs[0] policy
     /* 1622728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622738 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1622741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622762 */     // GIR_Coverage, 3838,
     /* 1622762 */     GIR_EraseRootFromParent_Done,
     /* 1622763 */   // Label 22389: @1622763
     /* 1622763 */   GIM_Try, /*On fail goto*//*Label 22390*/ GIMT_Encode4(1622849), // Rule ID 3839 //
     /* 1622768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1622779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1622782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1622785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1622788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622814 */     // MIs[0] policy
     /* 1622814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622824 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1622827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622848 */     // GIR_Coverage, 3839,
     /* 1622848 */     GIR_EraseRootFromParent_Done,
     /* 1622849 */   // Label 22390: @1622849
     /* 1622849 */   GIM_Try, /*On fail goto*//*Label 22391*/ GIMT_Encode4(1622935), // Rule ID 3842 //
     /* 1622854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1622865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1622868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1622871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1622874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622900 */     // MIs[0] policy
     /* 1622900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622910 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1622913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622934 */     // GIR_Coverage, 3842,
     /* 1622934 */     GIR_EraseRootFromParent_Done,
     /* 1622935 */   // Label 22391: @1622935
     /* 1622935 */   GIM_Try, /*On fail goto*//*Label 22392*/ GIMT_Encode4(1623021), // Rule ID 3843 //
     /* 1622940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1622951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1622954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1622957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1622960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622986 */     // MIs[0] policy
     /* 1622986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1622999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623020 */     // GIR_Coverage, 3843,
     /* 1623020 */     GIR_EraseRootFromParent_Done,
     /* 1623021 */   // Label 22392: @1623021
     /* 1623021 */   GIM_Try, /*On fail goto*//*Label 22393*/ GIMT_Encode4(1623107), // Rule ID 3846 //
     /* 1623026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1623037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1623040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1623043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1623046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623072 */     // MIs[0] policy
     /* 1623072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623082 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1623085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623106 */     // GIR_Coverage, 3846,
     /* 1623106 */     GIR_EraseRootFromParent_Done,
     /* 1623107 */   // Label 22393: @1623107
     /* 1623107 */   GIM_Try, /*On fail goto*//*Label 22394*/ GIMT_Encode4(1623193), // Rule ID 3847 //
     /* 1623112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1623123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1623126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1623129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1623132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623158 */     // MIs[0] policy
     /* 1623158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1623171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623192 */     // GIR_Coverage, 3847,
     /* 1623192 */     GIR_EraseRootFromParent_Done,
     /* 1623193 */   // Label 22394: @1623193
     /* 1623193 */   GIM_Try, /*On fail goto*//*Label 22395*/ GIMT_Encode4(1623279), // Rule ID 3850 //
     /* 1623198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1623209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1623212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1623215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1623218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1623221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623244 */     // MIs[0] policy
     /* 1623244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623254 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1623257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623278 */     // GIR_Coverage, 3850,
     /* 1623278 */     GIR_EraseRootFromParent_Done,
     /* 1623279 */   // Label 22395: @1623279
     /* 1623279 */   GIM_Try, /*On fail goto*//*Label 22396*/ GIMT_Encode4(1623365), // Rule ID 3851 //
     /* 1623284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1623295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1623298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1623301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1623304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1623307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623330 */     // MIs[0] policy
     /* 1623330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623340 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1623343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623364 */     // GIR_Coverage, 3851,
     /* 1623364 */     GIR_EraseRootFromParent_Done,
     /* 1623365 */   // Label 22396: @1623365
     /* 1623365 */   GIM_Try, /*On fail goto*//*Label 22397*/ GIMT_Encode4(1623451), // Rule ID 3854 //
     /* 1623370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1623381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1623384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1623387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1623390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1623393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623416 */     // MIs[0] policy
     /* 1623416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623426 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1623429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623450 */     // GIR_Coverage, 3854,
     /* 1623450 */     GIR_EraseRootFromParent_Done,
     /* 1623451 */   // Label 22397: @1623451
     /* 1623451 */   GIM_Try, /*On fail goto*//*Label 22398*/ GIMT_Encode4(1623537), // Rule ID 3855 //
     /* 1623456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1623467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1623470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1623473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1623476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1623479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623502 */     // MIs[0] policy
     /* 1623502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623512 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1623515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623536 */     // GIR_Coverage, 3855,
     /* 1623536 */     GIR_EraseRootFromParent_Done,
     /* 1623537 */   // Label 22398: @1623537
     /* 1623537 */   GIM_Try, /*On fail goto*//*Label 22399*/ GIMT_Encode4(1623623), // Rule ID 3858 //
     /* 1623542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1623553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1623556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1623559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1623562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623588 */     // MIs[0] policy
     /* 1623588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623598 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1623601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1623619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623622 */     // GIR_Coverage, 3858,
     /* 1623622 */     GIR_EraseRootFromParent_Done,
     /* 1623623 */   // Label 22399: @1623623
     /* 1623623 */   GIM_Try, /*On fail goto*//*Label 22400*/ GIMT_Encode4(1623709), // Rule ID 3859 //
     /* 1623628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1623639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1623642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1623645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1623648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623674 */     // MIs[0] policy
     /* 1623674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1623687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1623705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623708 */     // GIR_Coverage, 3859,
     /* 1623708 */     GIR_EraseRootFromParent_Done,
     /* 1623709 */   // Label 22400: @1623709
     /* 1623709 */   GIM_Try, /*On fail goto*//*Label 22401*/ GIMT_Encode4(1623795), // Rule ID 3862 //
     /* 1623714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1623725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1623728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1623731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1623734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623760 */     // MIs[0] policy
     /* 1623760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1623773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1623791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623794 */     // GIR_Coverage, 3862,
     /* 1623794 */     GIR_EraseRootFromParent_Done,
     /* 1623795 */   // Label 22401: @1623795
     /* 1623795 */   GIM_Try, /*On fail goto*//*Label 22402*/ GIMT_Encode4(1623881), // Rule ID 3863 //
     /* 1623800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1623811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1623814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1623817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1623820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623846 */     // MIs[0] policy
     /* 1623846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623856 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1623859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1623877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623880 */     // GIR_Coverage, 3863,
     /* 1623880 */     GIR_EraseRootFromParent_Done,
     /* 1623881 */   // Label 22402: @1623881
     /* 1623881 */   GIM_Try, /*On fail goto*//*Label 22403*/ GIMT_Encode4(1623967), // Rule ID 3866 //
     /* 1623886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1623897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1623900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1623903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1623906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623932 */     // MIs[0] policy
     /* 1623932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623942 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1623945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1623963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623966 */     // GIR_Coverage, 3866,
     /* 1623966 */     GIR_EraseRootFromParent_Done,
     /* 1623967 */   // Label 22403: @1623967
     /* 1623967 */   GIM_Try, /*On fail goto*//*Label 22404*/ GIMT_Encode4(1624053), // Rule ID 3867 //
     /* 1623972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1623983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1623986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1623989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1623992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624018 */     // MIs[0] policy
     /* 1624018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624028 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1624031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624052 */     // GIR_Coverage, 3867,
     /* 1624052 */     GIR_EraseRootFromParent_Done,
     /* 1624053 */   // Label 22404: @1624053
     /* 1624053 */   GIM_Try, /*On fail goto*//*Label 22405*/ GIMT_Encode4(1624139), // Rule ID 3870 //
     /* 1624058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1624069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1624072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1624075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1624078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624104 */     // MIs[0] policy
     /* 1624104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624114 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1624117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624138 */     // GIR_Coverage, 3870,
     /* 1624138 */     GIR_EraseRootFromParent_Done,
     /* 1624139 */   // Label 22405: @1624139
     /* 1624139 */   GIM_Try, /*On fail goto*//*Label 22406*/ GIMT_Encode4(1624225), // Rule ID 3871 //
     /* 1624144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1624155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1624158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1624161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1624164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624190 */     // MIs[0] policy
     /* 1624190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624200 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1624203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624224 */     // GIR_Coverage, 3871,
     /* 1624224 */     GIR_EraseRootFromParent_Done,
     /* 1624225 */   // Label 22406: @1624225
     /* 1624225 */   GIM_Try, /*On fail goto*//*Label 22407*/ GIMT_Encode4(1624311), // Rule ID 3874 //
     /* 1624230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1624241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1624244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1624247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1624250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624276 */     // MIs[0] policy
     /* 1624276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624286 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1624289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624310 */     // GIR_Coverage, 3874,
     /* 1624310 */     GIR_EraseRootFromParent_Done,
     /* 1624311 */   // Label 22407: @1624311
     /* 1624311 */   GIM_Try, /*On fail goto*//*Label 22408*/ GIMT_Encode4(1624397), // Rule ID 3875 //
     /* 1624316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1624327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1624330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1624333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1624336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624362 */     // MIs[0] policy
     /* 1624362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624372 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1624375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624396 */     // GIR_Coverage, 3875,
     /* 1624396 */     GIR_EraseRootFromParent_Done,
     /* 1624397 */   // Label 22408: @1624397
     /* 1624397 */   GIM_Try, /*On fail goto*//*Label 22409*/ GIMT_Encode4(1624483), // Rule ID 3878 //
     /* 1624402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1624405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1624413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1624416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1624419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1624422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624448 */     // MIs[0] policy
     /* 1624448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624458 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1624461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624482 */     // GIR_Coverage, 3878,
     /* 1624482 */     GIR_EraseRootFromParent_Done,
     /* 1624483 */   // Label 22409: @1624483
     /* 1624483 */   GIM_Try, /*On fail goto*//*Label 22410*/ GIMT_Encode4(1624569), // Rule ID 3879 //
     /* 1624488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1624491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1624499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1624502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1624505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1624508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624534 */     // MIs[0] policy
     /* 1624534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1624547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624568 */     // GIR_Coverage, 3879,
     /* 1624568 */     GIR_EraseRootFromParent_Done,
     /* 1624569 */   // Label 22410: @1624569
     /* 1624569 */   GIM_Try, /*On fail goto*//*Label 22411*/ GIMT_Encode4(1624655), // Rule ID 3882 //
     /* 1624574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1624577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1624585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1624588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1624591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1624594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624620 */     // MIs[0] policy
     /* 1624620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1624633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624654 */     // GIR_Coverage, 3882,
     /* 1624654 */     GIR_EraseRootFromParent_Done,
     /* 1624655 */   // Label 22411: @1624655
     /* 1624655 */   GIM_Try, /*On fail goto*//*Label 22412*/ GIMT_Encode4(1624741), // Rule ID 3883 //
     /* 1624660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1624663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1624671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1624674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1624677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1624680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624706 */     // MIs[0] policy
     /* 1624706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624716 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1624719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624740 */     // GIR_Coverage, 3883,
     /* 1624740 */     GIR_EraseRootFromParent_Done,
     /* 1624741 */   // Label 22412: @1624741
     /* 1624741 */   GIM_Try, /*On fail goto*//*Label 22413*/ GIMT_Encode4(1624827), // Rule ID 3886 //
     /* 1624746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1624749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1624757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1624760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1624763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1624766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624792 */     // MIs[0] policy
     /* 1624792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624802 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1624805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624826 */     // GIR_Coverage, 3886,
     /* 1624826 */     GIR_EraseRootFromParent_Done,
     /* 1624827 */   // Label 22413: @1624827
     /* 1624827 */   GIM_Try, /*On fail goto*//*Label 22414*/ GIMT_Encode4(1624913), // Rule ID 3887 //
     /* 1624832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1624835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1624843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1624846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1624849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1624852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624878 */     // MIs[0] policy
     /* 1624878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624888 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1624891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624912 */     // GIR_Coverage, 3887,
     /* 1624912 */     GIR_EraseRootFromParent_Done,
     /* 1624913 */   // Label 22414: @1624913
     /* 1624913 */   GIM_Try, /*On fail goto*//*Label 22415*/ GIMT_Encode4(1624999), // Rule ID 3890 //
     /* 1624918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1624921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1624929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1624932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1624935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1624938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624964 */     // MIs[0] policy
     /* 1624964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624974 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1624977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624998 */     // GIR_Coverage, 3890,
     /* 1624998 */     GIR_EraseRootFromParent_Done,
     /* 1624999 */   // Label 22415: @1624999
     /* 1624999 */   GIM_Try, /*On fail goto*//*Label 22416*/ GIMT_Encode4(1625085), // Rule ID 3891 //
     /* 1625004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1625015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1625018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1625021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1625024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625050 */     // MIs[0] policy
     /* 1625050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625060 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1625063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625084 */     // GIR_Coverage, 3891,
     /* 1625084 */     GIR_EraseRootFromParent_Done,
     /* 1625085 */   // Label 22416: @1625085
     /* 1625085 */   GIM_Try, /*On fail goto*//*Label 22417*/ GIMT_Encode4(1625171), // Rule ID 3894 //
     /* 1625090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1625101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1625104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1625107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625136 */     // MIs[0] policy
     /* 1625136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625146 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1625149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625170 */     // GIR_Coverage, 3894,
     /* 1625170 */     GIR_EraseRootFromParent_Done,
     /* 1625171 */   // Label 22417: @1625171
     /* 1625171 */   GIM_Try, /*On fail goto*//*Label 22418*/ GIMT_Encode4(1625257), // Rule ID 3895 //
     /* 1625176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1625187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1625190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1625193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625222 */     // MIs[0] policy
     /* 1625222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625232 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1625235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625256 */     // GIR_Coverage, 3895,
     /* 1625256 */     GIR_EraseRootFromParent_Done,
     /* 1625257 */   // Label 22418: @1625257
     /* 1625257 */   GIM_Try, /*On fail goto*//*Label 22419*/ GIMT_Encode4(1625343), // Rule ID 3898 //
     /* 1625262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1625273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1625276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1625279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625308 */     // MIs[0] policy
     /* 1625308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625318 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1625321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625342 */     // GIR_Coverage, 3898,
     /* 1625342 */     GIR_EraseRootFromParent_Done,
     /* 1625343 */   // Label 22419: @1625343
     /* 1625343 */   GIM_Try, /*On fail goto*//*Label 22420*/ GIMT_Encode4(1625429), // Rule ID 3899 //
     /* 1625348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1625359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1625362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1625365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625394 */     // MIs[0] policy
     /* 1625394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625404 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1625407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625428 */     // GIR_Coverage, 3899,
     /* 1625428 */     GIR_EraseRootFromParent_Done,
     /* 1625429 */   // Label 22420: @1625429
     /* 1625429 */   GIM_Try, /*On fail goto*//*Label 22421*/ GIMT_Encode4(1625515), // Rule ID 3902 //
     /* 1625434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1625445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1625448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1625451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625480 */     // MIs[0] policy
     /* 1625480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1625493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625514 */     // GIR_Coverage, 3902,
     /* 1625514 */     GIR_EraseRootFromParent_Done,
     /* 1625515 */   // Label 22421: @1625515
     /* 1625515 */   GIM_Try, /*On fail goto*//*Label 22422*/ GIMT_Encode4(1625601), // Rule ID 3903 //
     /* 1625520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1625531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1625534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1625537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625566 */     // MIs[0] policy
     /* 1625566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1625579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625600 */     // GIR_Coverage, 3903,
     /* 1625600 */     GIR_EraseRootFromParent_Done,
     /* 1625601 */   // Label 22422: @1625601
     /* 1625601 */   GIM_Try, /*On fail goto*//*Label 22423*/ GIMT_Encode4(1625687), // Rule ID 3906 //
     /* 1625606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1625617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1625620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1625623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625652 */     // MIs[0] policy
     /* 1625652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625662 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1625665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625686 */     // GIR_Coverage, 3906,
     /* 1625686 */     GIR_EraseRootFromParent_Done,
     /* 1625687 */   // Label 22423: @1625687
     /* 1625687 */   GIM_Try, /*On fail goto*//*Label 22424*/ GIMT_Encode4(1625773), // Rule ID 3907 //
     /* 1625692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1625703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1625706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1625709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625738 */     // MIs[0] policy
     /* 1625738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625748 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1625751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625772 */     // GIR_Coverage, 3907,
     /* 1625772 */     GIR_EraseRootFromParent_Done,
     /* 1625773 */   // Label 22424: @1625773
     /* 1625773 */   GIM_Try, /*On fail goto*//*Label 22425*/ GIMT_Encode4(1625859), // Rule ID 3910 //
     /* 1625778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1625789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1625792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1625795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1625801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625824 */     // MIs[0] policy
     /* 1625824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625834 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1625837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625858 */     // GIR_Coverage, 3910,
     /* 1625858 */     GIR_EraseRootFromParent_Done,
     /* 1625859 */   // Label 22425: @1625859
     /* 1625859 */   GIM_Try, /*On fail goto*//*Label 22426*/ GIMT_Encode4(1625945), // Rule ID 3911 //
     /* 1625864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1625875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1625878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1625881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1625887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625910 */     // MIs[0] policy
     /* 1625910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625920 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1625923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625944 */     // GIR_Coverage, 3911,
     /* 1625944 */     GIR_EraseRootFromParent_Done,
     /* 1625945 */   // Label 22426: @1625945
     /* 1625945 */   GIM_Try, /*On fail goto*//*Label 22427*/ GIMT_Encode4(1626031), // Rule ID 3914 //
     /* 1625950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1625961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1625964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1625967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1625973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625996 */     // MIs[0] policy
     /* 1625996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626006 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1626009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626030 */     // GIR_Coverage, 3914,
     /* 1626030 */     GIR_EraseRootFromParent_Done,
     /* 1626031 */   // Label 22427: @1626031
     /* 1626031 */   GIM_Try, /*On fail goto*//*Label 22428*/ GIMT_Encode4(1626117), // Rule ID 3915 //
     /* 1626036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1626047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1626050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1626053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1626059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626082 */     // MIs[0] policy
     /* 1626082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626092 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1626095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626116 */     // GIR_Coverage, 3915,
     /* 1626116 */     GIR_EraseRootFromParent_Done,
     /* 1626117 */   // Label 22428: @1626117
     /* 1626117 */   GIM_Try, /*On fail goto*//*Label 22429*/ GIMT_Encode4(1626203), // Rule ID 3918 //
     /* 1626122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1626133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1626136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1626139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1626145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626168 */     // MIs[0] policy
     /* 1626168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626178 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1626181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626202 */     // GIR_Coverage, 3918,
     /* 1626202 */     GIR_EraseRootFromParent_Done,
     /* 1626203 */   // Label 22429: @1626203
     /* 1626203 */   GIM_Try, /*On fail goto*//*Label 22430*/ GIMT_Encode4(1626289), // Rule ID 3919 //
     /* 1626208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1626219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1626222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1626225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1626231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626254 */     // MIs[0] policy
     /* 1626254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1626267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626288 */     // GIR_Coverage, 3919,
     /* 1626288 */     GIR_EraseRootFromParent_Done,
     /* 1626289 */   // Label 22430: @1626289
     /* 1626289 */   GIM_Try, /*On fail goto*//*Label 22431*/ GIMT_Encode4(1626375), // Rule ID 3922 //
     /* 1626294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1626305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1626308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1626311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626340 */     // MIs[0] policy
     /* 1626340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626350 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1626353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626374 */     // GIR_Coverage, 3922,
     /* 1626374 */     GIR_EraseRootFromParent_Done,
     /* 1626375 */   // Label 22431: @1626375
     /* 1626375 */   GIM_Try, /*On fail goto*//*Label 22432*/ GIMT_Encode4(1626461), // Rule ID 3923 //
     /* 1626380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1626391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1626394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1626397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626426 */     // MIs[0] policy
     /* 1626426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626436 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1626439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626460 */     // GIR_Coverage, 3923,
     /* 1626460 */     GIR_EraseRootFromParent_Done,
     /* 1626461 */   // Label 22432: @1626461
     /* 1626461 */   GIM_Try, /*On fail goto*//*Label 22433*/ GIMT_Encode4(1626547), // Rule ID 3926 //
     /* 1626466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1626477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1626480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1626483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626512 */     // MIs[0] policy
     /* 1626512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626522 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1626525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626546 */     // GIR_Coverage, 3926,
     /* 1626546 */     GIR_EraseRootFromParent_Done,
     /* 1626547 */   // Label 22433: @1626547
     /* 1626547 */   GIM_Try, /*On fail goto*//*Label 22434*/ GIMT_Encode4(1626633), // Rule ID 3927 //
     /* 1626552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1626563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1626566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1626569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626598 */     // MIs[0] policy
     /* 1626598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1626611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626632 */     // GIR_Coverage, 3927,
     /* 1626632 */     GIR_EraseRootFromParent_Done,
     /* 1626633 */   // Label 22434: @1626633
     /* 1626633 */   GIM_Try, /*On fail goto*//*Label 22435*/ GIMT_Encode4(1626719), // Rule ID 3930 //
     /* 1626638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1626649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1626652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1626655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626684 */     // MIs[0] policy
     /* 1626684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626694 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1626697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626718 */     // GIR_Coverage, 3930,
     /* 1626718 */     GIR_EraseRootFromParent_Done,
     /* 1626719 */   // Label 22435: @1626719
     /* 1626719 */   GIM_Try, /*On fail goto*//*Label 22436*/ GIMT_Encode4(1626805), // Rule ID 3931 //
     /* 1626724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1626735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1626738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1626741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626770 */     // MIs[0] policy
     /* 1626770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626780 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1626783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626804 */     // GIR_Coverage, 3931,
     /* 1626804 */     GIR_EraseRootFromParent_Done,
     /* 1626805 */   // Label 22436: @1626805
     /* 1626805 */   GIM_Try, /*On fail goto*//*Label 22437*/ GIMT_Encode4(1626891), // Rule ID 3934 //
     /* 1626810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1626821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1626824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1626827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626856 */     // MIs[0] policy
     /* 1626856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626866 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1626869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626890 */     // GIR_Coverage, 3934,
     /* 1626890 */     GIR_EraseRootFromParent_Done,
     /* 1626891 */   // Label 22437: @1626891
     /* 1626891 */   GIM_Try, /*On fail goto*//*Label 22438*/ GIMT_Encode4(1626977), // Rule ID 3935 //
     /* 1626896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1626907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1626910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1626913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626942 */     // MIs[0] policy
     /* 1626942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1626955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626976 */     // GIR_Coverage, 3935,
     /* 1626976 */     GIR_EraseRootFromParent_Done,
     /* 1626977 */   // Label 22438: @1626977
     /* 1626977 */   GIM_Try, /*On fail goto*//*Label 22439*/ GIMT_Encode4(1627063), // Rule ID 3938 //
     /* 1626982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1626985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1626993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1626996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1626999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627028 */     // MIs[0] policy
     /* 1627028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627038 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1627041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627062 */     // GIR_Coverage, 3938,
     /* 1627062 */     GIR_EraseRootFromParent_Done,
     /* 1627063 */   // Label 22439: @1627063
     /* 1627063 */   GIM_Try, /*On fail goto*//*Label 22440*/ GIMT_Encode4(1627149), // Rule ID 3939 //
     /* 1627068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1627079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1627082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1627085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627114 */     // MIs[0] policy
     /* 1627114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627124 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1627127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627148 */     // GIR_Coverage, 3939,
     /* 1627148 */     GIR_EraseRootFromParent_Done,
     /* 1627149 */   // Label 22440: @1627149
     /* 1627149 */   GIM_Try, /*On fail goto*//*Label 22441*/ GIMT_Encode4(1627235), // Rule ID 3942 //
     /* 1627154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1627165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1627168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1627171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627200 */     // MIs[0] policy
     /* 1627200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627210 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1627213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627234 */     // GIR_Coverage, 3942,
     /* 1627234 */     GIR_EraseRootFromParent_Done,
     /* 1627235 */   // Label 22441: @1627235
     /* 1627235 */   GIM_Try, /*On fail goto*//*Label 22442*/ GIMT_Encode4(1627321), // Rule ID 3943 //
     /* 1627240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1627251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1627254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1627257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627286 */     // MIs[0] policy
     /* 1627286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627296 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1627299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627320 */     // GIR_Coverage, 3943,
     /* 1627320 */     GIR_EraseRootFromParent_Done,
     /* 1627321 */   // Label 22442: @1627321
     /* 1627321 */   GIM_Try, /*On fail goto*//*Label 22443*/ GIMT_Encode4(1627407), // Rule ID 3946 //
     /* 1627326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1627337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1627340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1627343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627372 */     // MIs[0] policy
     /* 1627372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627382 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1627385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627406 */     // GIR_Coverage, 3946,
     /* 1627406 */     GIR_EraseRootFromParent_Done,
     /* 1627407 */   // Label 22443: @1627407
     /* 1627407 */   GIM_Try, /*On fail goto*//*Label 22444*/ GIMT_Encode4(1627493), // Rule ID 3947 //
     /* 1627412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1627423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1627426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1627429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627458 */     // MIs[0] policy
     /* 1627458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1627471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627492 */     // GIR_Coverage, 3947,
     /* 1627492 */     GIR_EraseRootFromParent_Done,
     /* 1627493 */   // Label 22444: @1627493
     /* 1627493 */   GIM_Try, /*On fail goto*//*Label 22445*/ GIMT_Encode4(1627579), // Rule ID 3950 //
     /* 1627498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1627509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1627512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1627515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627544 */     // MIs[0] policy
     /* 1627544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627554 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1627557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627578 */     // GIR_Coverage, 3950,
     /* 1627578 */     GIR_EraseRootFromParent_Done,
     /* 1627579 */   // Label 22445: @1627579
     /* 1627579 */   GIM_Try, /*On fail goto*//*Label 22446*/ GIMT_Encode4(1627665), // Rule ID 3951 //
     /* 1627584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1627595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1627598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1627601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627630 */     // MIs[0] policy
     /* 1627630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627640 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1627643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627664 */     // GIR_Coverage, 3951,
     /* 1627664 */     GIR_EraseRootFromParent_Done,
     /* 1627665 */   // Label 22446: @1627665
     /* 1627665 */   GIM_Try, /*On fail goto*//*Label 22447*/ GIMT_Encode4(1627751), // Rule ID 3954 //
     /* 1627670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1627681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1627684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1627687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1627690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627716 */     // MIs[0] policy
     /* 1627716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627726 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11682:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1627729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627750 */     // GIR_Coverage, 3954,
     /* 1627750 */     GIR_EraseRootFromParent_Done,
     /* 1627751 */   // Label 22447: @1627751
     /* 1627751 */   GIM_Try, /*On fail goto*//*Label 22448*/ GIMT_Encode4(1627837), // Rule ID 3955 //
     /* 1627756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1627767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1627770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1627773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1627776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627802 */     // MIs[0] policy
     /* 1627802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627812 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11682:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1627815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627836 */     // GIR_Coverage, 3955,
     /* 1627836 */     GIR_EraseRootFromParent_Done,
     /* 1627837 */   // Label 22448: @1627837
     /* 1627837 */   GIM_Try, /*On fail goto*//*Label 22449*/ GIMT_Encode4(1627923), // Rule ID 3958 //
     /* 1627842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1627853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1627856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1627859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1627862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627888 */     // MIs[0] policy
     /* 1627888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627898 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11682:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1627901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627922 */     // GIR_Coverage, 3958,
     /* 1627922 */     GIR_EraseRootFromParent_Done,
     /* 1627923 */   // Label 22449: @1627923
     /* 1627923 */   GIM_Try, /*On fail goto*//*Label 22450*/ GIMT_Encode4(1628009), // Rule ID 3959 //
     /* 1627928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1627939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1627942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1627945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1627948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627974 */     // MIs[0] policy
     /* 1627974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627984 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11682:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1627987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628008 */     // GIR_Coverage, 3959,
     /* 1628008 */     GIR_EraseRootFromParent_Done,
     /* 1628009 */   // Label 22450: @1628009
     /* 1628009 */   GIM_Try, /*On fail goto*//*Label 22451*/ GIMT_Encode4(1628095), // Rule ID 3962 //
     /* 1628014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1628025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1628028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1628031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1628034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628060 */     // MIs[0] policy
     /* 1628060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628070 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11682:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1628073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628094 */     // GIR_Coverage, 3962,
     /* 1628094 */     GIR_EraseRootFromParent_Done,
     /* 1628095 */   // Label 22451: @1628095
     /* 1628095 */   GIM_Try, /*On fail goto*//*Label 22452*/ GIMT_Encode4(1628181), // Rule ID 3963 //
     /* 1628100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1628111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1628114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1628117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1628120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628146 */     // MIs[0] policy
     /* 1628146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11682:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1628159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628180 */     // GIR_Coverage, 3963,
     /* 1628180 */     GIR_EraseRootFromParent_Done,
     /* 1628181 */   // Label 22452: @1628181
     /* 1628181 */   GIM_Try, /*On fail goto*//*Label 22453*/ GIMT_Encode4(1628267), // Rule ID 3966 //
     /* 1628186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1628197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1628200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1628203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1628206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628232 */     // MIs[0] policy
     /* 1628232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628242 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11682:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1628245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628266 */     // GIR_Coverage, 3966,
     /* 1628266 */     GIR_EraseRootFromParent_Done,
     /* 1628267 */   // Label 22453: @1628267
     /* 1628267 */   GIM_Try, /*On fail goto*//*Label 22454*/ GIMT_Encode4(1628353), // Rule ID 3967 //
     /* 1628272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1628283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1628286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1628289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1628292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628318 */     // MIs[0] policy
     /* 1628318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628328 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11682:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1628331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628352 */     // GIR_Coverage, 3967,
     /* 1628352 */     GIR_EraseRootFromParent_Done,
     /* 1628353 */   // Label 22454: @1628353
     /* 1628353 */   GIM_Try, /*On fail goto*//*Label 22455*/ GIMT_Encode4(1628439), // Rule ID 3970 //
     /* 1628358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1628369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1628372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1628375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1628378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1628381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628404 */     // MIs[0] policy
     /* 1628404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628414 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11682:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1628417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628438 */     // GIR_Coverage, 3970,
     /* 1628438 */     GIR_EraseRootFromParent_Done,
     /* 1628439 */   // Label 22455: @1628439
     /* 1628439 */   GIM_Try, /*On fail goto*//*Label 22456*/ GIMT_Encode4(1628525), // Rule ID 3971 //
     /* 1628444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1628455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1628458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1628461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1628464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1628467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628490 */     // MIs[0] policy
     /* 1628490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628500 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11682:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1628503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628524 */     // GIR_Coverage, 3971,
     /* 1628524 */     GIR_EraseRootFromParent_Done,
     /* 1628525 */   // Label 22456: @1628525
     /* 1628525 */   GIM_Try, /*On fail goto*//*Label 22457*/ GIMT_Encode4(1628611), // Rule ID 3974 //
     /* 1628530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1628541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1628544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1628547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1628550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1628553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628576 */     // MIs[0] policy
     /* 1628576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628586 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11682:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1628589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628610 */     // GIR_Coverage, 3974,
     /* 1628610 */     GIR_EraseRootFromParent_Done,
     /* 1628611 */   // Label 22457: @1628611
     /* 1628611 */   GIM_Try, /*On fail goto*//*Label 22458*/ GIMT_Encode4(1628697), // Rule ID 3975 //
     /* 1628616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1628627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1628630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1628633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1628636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1628639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628662 */     // MIs[0] policy
     /* 1628662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628672 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11682:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1628675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628696 */     // GIR_Coverage, 3975,
     /* 1628696 */     GIR_EraseRootFromParent_Done,
     /* 1628697 */   // Label 22458: @1628697
     /* 1628697 */   GIM_Try, /*On fail goto*//*Label 22459*/ GIMT_Encode4(1628783), // Rule ID 3978 //
     /* 1628702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1628713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1628716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1628719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1628722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628748 */     // MIs[0] policy
     /* 1628748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628758 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11682:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1628761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628782 */     // GIR_Coverage, 3978,
     /* 1628782 */     GIR_EraseRootFromParent_Done,
     /* 1628783 */   // Label 22459: @1628783
     /* 1628783 */   GIM_Try, /*On fail goto*//*Label 22460*/ GIMT_Encode4(1628869), // Rule ID 3979 //
     /* 1628788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1628799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1628802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1628805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1628808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628834 */     // MIs[0] policy
     /* 1628834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628844 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11682:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1628847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628868 */     // GIR_Coverage, 3979,
     /* 1628868 */     GIR_EraseRootFromParent_Done,
     /* 1628869 */   // Label 22460: @1628869
     /* 1628869 */   GIM_Try, /*On fail goto*//*Label 22461*/ GIMT_Encode4(1628955), // Rule ID 3982 //
     /* 1628874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1628885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1628888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1628891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1628894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628920 */     // MIs[0] policy
     /* 1628920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628930 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11682:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1628933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628954 */     // GIR_Coverage, 3982,
     /* 1628954 */     GIR_EraseRootFromParent_Done,
     /* 1628955 */   // Label 22461: @1628955
     /* 1628955 */   GIM_Try, /*On fail goto*//*Label 22462*/ GIMT_Encode4(1629041), // Rule ID 3983 //
     /* 1628960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1628971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1628974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1628977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1628980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629006 */     // MIs[0] policy
     /* 1629006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629016 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11682:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1629019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629040 */     // GIR_Coverage, 3983,
     /* 1629040 */     GIR_EraseRootFromParent_Done,
     /* 1629041 */   // Label 22462: @1629041
     /* 1629041 */   GIM_Try, /*On fail goto*//*Label 22463*/ GIMT_Encode4(1629127), // Rule ID 3986 //
     /* 1629046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1629057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1629060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1629063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1629066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629092 */     // MIs[0] policy
     /* 1629092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11682:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1629105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629126 */     // GIR_Coverage, 3986,
     /* 1629126 */     GIR_EraseRootFromParent_Done,
     /* 1629127 */   // Label 22463: @1629127
     /* 1629127 */   GIM_Try, /*On fail goto*//*Label 22464*/ GIMT_Encode4(1629213), // Rule ID 3987 //
     /* 1629132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1629143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1629146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1629149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1629152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629178 */     // MIs[0] policy
     /* 1629178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629188 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11682:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1629191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629212 */     // GIR_Coverage, 3987,
     /* 1629212 */     GIR_EraseRootFromParent_Done,
     /* 1629213 */   // Label 22464: @1629213
     /* 1629213 */   GIM_Try, /*On fail goto*//*Label 22465*/ GIMT_Encode4(1629299), // Rule ID 3990 //
     /* 1629218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1629229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1629232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1629238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629264 */     // MIs[0] policy
     /* 1629264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629274 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11682:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1629277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629298 */     // GIR_Coverage, 3990,
     /* 1629298 */     GIR_EraseRootFromParent_Done,
     /* 1629299 */   // Label 22465: @1629299
     /* 1629299 */   GIM_Try, /*On fail goto*//*Label 22466*/ GIMT_Encode4(1629385), // Rule ID 3991 //
     /* 1629304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1629315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1629318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1629324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629350 */     // MIs[0] policy
     /* 1629350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629360 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11682:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1629363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629384 */     // GIR_Coverage, 3991,
     /* 1629384 */     GIR_EraseRootFromParent_Done,
     /* 1629385 */   // Label 22466: @1629385
     /* 1629385 */   GIM_Try, /*On fail goto*//*Label 22467*/ GIMT_Encode4(1629471), // Rule ID 3994 //
     /* 1629390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1629401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1629404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1629410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629436 */     // MIs[0] policy
     /* 1629436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11682:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1629449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629470 */     // GIR_Coverage, 3994,
     /* 1629470 */     GIR_EraseRootFromParent_Done,
     /* 1629471 */   // Label 22467: @1629471
     /* 1629471 */   GIM_Try, /*On fail goto*//*Label 22468*/ GIMT_Encode4(1629557), // Rule ID 3995 //
     /* 1629476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1629487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1629490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1629496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629522 */     // MIs[0] policy
     /* 1629522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629532 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11682:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1629535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629556 */     // GIR_Coverage, 3995,
     /* 1629556 */     GIR_EraseRootFromParent_Done,
     /* 1629557 */   // Label 22468: @1629557
     /* 1629557 */   GIM_Try, /*On fail goto*//*Label 22469*/ GIMT_Encode4(1629643), // Rule ID 3998 //
     /* 1629562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1629565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1629573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1629576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1629579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1629582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629608 */     // MIs[0] policy
     /* 1629608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629618 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11682:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1629621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1629639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629642 */     // GIR_Coverage, 3998,
     /* 1629642 */     GIR_EraseRootFromParent_Done,
     /* 1629643 */   // Label 22469: @1629643
     /* 1629643 */   GIM_Try, /*On fail goto*//*Label 22470*/ GIMT_Encode4(1629729), // Rule ID 3999 //
     /* 1629648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1629651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1629659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1629662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1629665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1629668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629694 */     // MIs[0] policy
     /* 1629694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629704 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11682:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1629707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1629725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629728 */     // GIR_Coverage, 3999,
     /* 1629728 */     GIR_EraseRootFromParent_Done,
     /* 1629729 */   // Label 22470: @1629729
     /* 1629729 */   GIM_Try, /*On fail goto*//*Label 22471*/ GIMT_Encode4(1629815), // Rule ID 4002 //
     /* 1629734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1629737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1629745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1629748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1629751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1629754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629780 */     // MIs[0] policy
     /* 1629780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11682:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1629793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1629811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629814 */     // GIR_Coverage, 4002,
     /* 1629814 */     GIR_EraseRootFromParent_Done,
     /* 1629815 */   // Label 22471: @1629815
     /* 1629815 */   GIM_Try, /*On fail goto*//*Label 22472*/ GIMT_Encode4(1629901), // Rule ID 4003 //
     /* 1629820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1629823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1629831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1629834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1629837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1629840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629866 */     // MIs[0] policy
     /* 1629866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11682:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1629879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1629897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629900 */     // GIR_Coverage, 4003,
     /* 1629900 */     GIR_EraseRootFromParent_Done,
     /* 1629901 */   // Label 22472: @1629901
     /* 1629901 */   GIM_Try, /*On fail goto*//*Label 22473*/ GIMT_Encode4(1629987), // Rule ID 4006 //
     /* 1629906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1629909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1629917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1629920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1629923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1629926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629952 */     // MIs[0] policy
     /* 1629952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629962 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11682:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1629965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1629983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629986 */     // GIR_Coverage, 4006,
     /* 1629986 */     GIR_EraseRootFromParent_Done,
     /* 1629987 */   // Label 22473: @1629987
     /* 1629987 */   GIM_Try, /*On fail goto*//*Label 22474*/ GIMT_Encode4(1630073), // Rule ID 4007 //
     /* 1629992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1629995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1630003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1630006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1630009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1630012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630038 */     // MIs[0] policy
     /* 1630038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630048 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11682:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1630051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630072 */     // GIR_Coverage, 4007,
     /* 1630072 */     GIR_EraseRootFromParent_Done,
     /* 1630073 */   // Label 22474: @1630073
     /* 1630073 */   GIM_Try, /*On fail goto*//*Label 22475*/ GIMT_Encode4(1630159), // Rule ID 4010 //
     /* 1630078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1630089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1630092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1630098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630124 */     // MIs[0] policy
     /* 1630124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630134 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11682:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1630137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630158 */     // GIR_Coverage, 4010,
     /* 1630158 */     GIR_EraseRootFromParent_Done,
     /* 1630159 */   // Label 22475: @1630159
     /* 1630159 */   GIM_Try, /*On fail goto*//*Label 22476*/ GIMT_Encode4(1630245), // Rule ID 4011 //
     /* 1630164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1630175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1630178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1630184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630210 */     // MIs[0] policy
     /* 1630210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11682:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1630223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630244 */     // GIR_Coverage, 4011,
     /* 1630244 */     GIR_EraseRootFromParent_Done,
     /* 1630245 */   // Label 22476: @1630245
     /* 1630245 */   GIM_Try, /*On fail goto*//*Label 22477*/ GIMT_Encode4(1630331), // Rule ID 4014 //
     /* 1630250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1630261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1630264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1630267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630296 */     // MIs[0] policy
     /* 1630296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630306 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11682:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1630309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630330 */     // GIR_Coverage, 4014,
     /* 1630330 */     GIR_EraseRootFromParent_Done,
     /* 1630331 */   // Label 22477: @1630331
     /* 1630331 */   GIM_Try, /*On fail goto*//*Label 22478*/ GIMT_Encode4(1630417), // Rule ID 4015 //
     /* 1630336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1630347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1630350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1630353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630382 */     // MIs[0] policy
     /* 1630382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630392 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11682:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1630395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630416 */     // GIR_Coverage, 4015,
     /* 1630416 */     GIR_EraseRootFromParent_Done,
     /* 1630417 */   // Label 22478: @1630417
     /* 1630417 */   GIM_Try, /*On fail goto*//*Label 22479*/ GIMT_Encode4(1630503), // Rule ID 4018 //
     /* 1630422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1630433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1630436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1630439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630468 */     // MIs[0] policy
     /* 1630468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630478 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11682:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1630481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630502 */     // GIR_Coverage, 4018,
     /* 1630502 */     GIR_EraseRootFromParent_Done,
     /* 1630503 */   // Label 22479: @1630503
     /* 1630503 */   GIM_Try, /*On fail goto*//*Label 22480*/ GIMT_Encode4(1630589), // Rule ID 4019 //
     /* 1630508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1630519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1630522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1630525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630554 */     // MIs[0] policy
     /* 1630554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11682:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1630567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630588 */     // GIR_Coverage, 4019,
     /* 1630588 */     GIR_EraseRootFromParent_Done,
     /* 1630589 */   // Label 22480: @1630589
     /* 1630589 */   GIM_Try, /*On fail goto*//*Label 22481*/ GIMT_Encode4(1630675), // Rule ID 4022 //
     /* 1630594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1630605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1630608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1630611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630640 */     // MIs[0] policy
     /* 1630640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630650 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11682:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1630653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630674 */     // GIR_Coverage, 4022,
     /* 1630674 */     GIR_EraseRootFromParent_Done,
     /* 1630675 */   // Label 22481: @1630675
     /* 1630675 */   GIM_Try, /*On fail goto*//*Label 22482*/ GIMT_Encode4(1630761), // Rule ID 4023 //
     /* 1630680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1630691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1630694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1630697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630726 */     // MIs[0] policy
     /* 1630726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630736 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11682:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1630739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630760 */     // GIR_Coverage, 4023,
     /* 1630760 */     GIR_EraseRootFromParent_Done,
     /* 1630761 */   // Label 22482: @1630761
     /* 1630761 */   GIM_Try, /*On fail goto*//*Label 22483*/ GIMT_Encode4(1630847), // Rule ID 4026 //
     /* 1630766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1630777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1630780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1630783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630812 */     // MIs[0] policy
     /* 1630812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630822 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11682:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1630825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630846 */     // GIR_Coverage, 4026,
     /* 1630846 */     GIR_EraseRootFromParent_Done,
     /* 1630847 */   // Label 22483: @1630847
     /* 1630847 */   GIM_Try, /*On fail goto*//*Label 22484*/ GIMT_Encode4(1630933), // Rule ID 4027 //
     /* 1630852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1630863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1630866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1630869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630898 */     // MIs[0] policy
     /* 1630898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630908 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11682:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1630911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630932 */     // GIR_Coverage, 4027,
     /* 1630932 */     GIR_EraseRootFromParent_Done,
     /* 1630933 */   // Label 22484: @1630933
     /* 1630933 */   GIM_Try, /*On fail goto*//*Label 22485*/ GIMT_Encode4(1631019), // Rule ID 4030 //
     /* 1630938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1630949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1630952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1630955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1630961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630984 */     // MIs[0] policy
     /* 1630984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630994 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11682:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1630997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631018 */     // GIR_Coverage, 4030,
     /* 1631018 */     GIR_EraseRootFromParent_Done,
     /* 1631019 */   // Label 22485: @1631019
     /* 1631019 */   GIM_Try, /*On fail goto*//*Label 22486*/ GIMT_Encode4(1631105), // Rule ID 4031 //
     /* 1631024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1631035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1631038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1631041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1631047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631070 */     // MIs[0] policy
     /* 1631070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631080 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11682:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1631083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631104 */     // GIR_Coverage, 4031,
     /* 1631104 */     GIR_EraseRootFromParent_Done,
     /* 1631105 */   // Label 22486: @1631105
     /* 1631105 */   GIM_Try, /*On fail goto*//*Label 22487*/ GIMT_Encode4(1631191), // Rule ID 4034 //
     /* 1631110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1631121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1631124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1631127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1631133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631156 */     // MIs[0] policy
     /* 1631156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631166 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11682:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1631169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631190 */     // GIR_Coverage, 4034,
     /* 1631190 */     GIR_EraseRootFromParent_Done,
     /* 1631191 */   // Label 22487: @1631191
     /* 1631191 */   GIM_Try, /*On fail goto*//*Label 22488*/ GIMT_Encode4(1631277), // Rule ID 4035 //
     /* 1631196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1631207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1631210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1631213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1631219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631242 */     // MIs[0] policy
     /* 1631242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631252 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11682:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1631255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631276 */     // GIR_Coverage, 4035,
     /* 1631276 */     GIR_EraseRootFromParent_Done,
     /* 1631277 */   // Label 22488: @1631277
     /* 1631277 */   GIM_Try, /*On fail goto*//*Label 22489*/ GIMT_Encode4(1631363), // Rule ID 4038 //
     /* 1631282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1631293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1631296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1631299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631328 */     // MIs[0] policy
     /* 1631328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631338 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11682:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1631341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631362 */     // GIR_Coverage, 4038,
     /* 1631362 */     GIR_EraseRootFromParent_Done,
     /* 1631363 */   // Label 22489: @1631363
     /* 1631363 */   GIM_Try, /*On fail goto*//*Label 22490*/ GIMT_Encode4(1631449), // Rule ID 4039 //
     /* 1631368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1631379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1631382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1631385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631414 */     // MIs[0] policy
     /* 1631414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631424 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11682:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1631427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631448 */     // GIR_Coverage, 4039,
     /* 1631448 */     GIR_EraseRootFromParent_Done,
     /* 1631449 */   // Label 22490: @1631449
     /* 1631449 */   GIM_Try, /*On fail goto*//*Label 22491*/ GIMT_Encode4(1631535), // Rule ID 4042 //
     /* 1631454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1631465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1631468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1631471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631500 */     // MIs[0] policy
     /* 1631500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631510 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11682:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1631513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631534 */     // GIR_Coverage, 4042,
     /* 1631534 */     GIR_EraseRootFromParent_Done,
     /* 1631535 */   // Label 22491: @1631535
     /* 1631535 */   GIM_Try, /*On fail goto*//*Label 22492*/ GIMT_Encode4(1631621), // Rule ID 4043 //
     /* 1631540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1631551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1631554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1631557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631586 */     // MIs[0] policy
     /* 1631586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11682:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1631599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631620 */     // GIR_Coverage, 4043,
     /* 1631620 */     GIR_EraseRootFromParent_Done,
     /* 1631621 */   // Label 22492: @1631621
     /* 1631621 */   GIM_Try, /*On fail goto*//*Label 22493*/ GIMT_Encode4(1631707), // Rule ID 4046 //
     /* 1631626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1631637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1631640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1631643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631672 */     // MIs[0] policy
     /* 1631672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11682:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1631685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631706 */     // GIR_Coverage, 4046,
     /* 1631706 */     GIR_EraseRootFromParent_Done,
     /* 1631707 */   // Label 22493: @1631707
     /* 1631707 */   GIM_Try, /*On fail goto*//*Label 22494*/ GIMT_Encode4(1631793), // Rule ID 4047 //
     /* 1631712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1631723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1631726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1631729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631758 */     // MIs[0] policy
     /* 1631758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11682:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1631771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631792 */     // GIR_Coverage, 4047,
     /* 1631792 */     GIR_EraseRootFromParent_Done,
     /* 1631793 */   // Label 22494: @1631793
     /* 1631793 */   GIM_Try, /*On fail goto*//*Label 22495*/ GIMT_Encode4(1631879), // Rule ID 4050 //
     /* 1631798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1631809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1631812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1631815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631844 */     // MIs[0] policy
     /* 1631844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631854 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11682:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1631857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631878 */     // GIR_Coverage, 4050,
     /* 1631878 */     GIR_EraseRootFromParent_Done,
     /* 1631879 */   // Label 22495: @1631879
     /* 1631879 */   GIM_Try, /*On fail goto*//*Label 22496*/ GIMT_Encode4(1631965), // Rule ID 4051 //
     /* 1631884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1631895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1631898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1631901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631930 */     // MIs[0] policy
     /* 1631930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631940 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11682:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1631943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631964 */     // GIR_Coverage, 4051,
     /* 1631964 */     GIR_EraseRootFromParent_Done,
     /* 1631965 */   // Label 22496: @1631965
     /* 1631965 */   GIM_Try, /*On fail goto*//*Label 22497*/ GIMT_Encode4(1632051), // Rule ID 4054 //
     /* 1631970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1631981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1631984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1631987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1631993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632016 */     // MIs[0] policy
     /* 1632016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632026 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11682:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1632029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632050 */     // GIR_Coverage, 4054,
     /* 1632050 */     GIR_EraseRootFromParent_Done,
     /* 1632051 */   // Label 22497: @1632051
     /* 1632051 */   GIM_Try, /*On fail goto*//*Label 22498*/ GIMT_Encode4(1632137), // Rule ID 4055 //
     /* 1632056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1632067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1632070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1632073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1632079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632102 */     // MIs[0] policy
     /* 1632102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632112 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11682:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1632115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632136 */     // GIR_Coverage, 4055,
     /* 1632136 */     GIR_EraseRootFromParent_Done,
     /* 1632137 */   // Label 22498: @1632137
     /* 1632137 */   GIM_Try, /*On fail goto*//*Label 22499*/ GIMT_Encode4(1632223), // Rule ID 4058 //
     /* 1632142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1632153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1632156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1632159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632188 */     // MIs[0] policy
     /* 1632188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632198 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11682:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1632201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632222 */     // GIR_Coverage, 4058,
     /* 1632222 */     GIR_EraseRootFromParent_Done,
     /* 1632223 */   // Label 22499: @1632223
     /* 1632223 */   GIM_Try, /*On fail goto*//*Label 22500*/ GIMT_Encode4(1632309), // Rule ID 4059 //
     /* 1632228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1632239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1632242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1632245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632274 */     // MIs[0] policy
     /* 1632274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11682:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1632287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632308 */     // GIR_Coverage, 4059,
     /* 1632308 */     GIR_EraseRootFromParent_Done,
     /* 1632309 */   // Label 22500: @1632309
     /* 1632309 */   GIM_Try, /*On fail goto*//*Label 22501*/ GIMT_Encode4(1632395), // Rule ID 4062 //
     /* 1632314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1632325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1632328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1632331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632360 */     // MIs[0] policy
     /* 1632360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632370 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11682:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1632373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632394 */     // GIR_Coverage, 4062,
     /* 1632394 */     GIR_EraseRootFromParent_Done,
     /* 1632395 */   // Label 22501: @1632395
     /* 1632395 */   GIM_Try, /*On fail goto*//*Label 22502*/ GIMT_Encode4(1632481), // Rule ID 4063 //
     /* 1632400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1632411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1632414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1632417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632446 */     // MIs[0] policy
     /* 1632446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11682:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1632459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632480 */     // GIR_Coverage, 4063,
     /* 1632480 */     GIR_EraseRootFromParent_Done,
     /* 1632481 */   // Label 22502: @1632481
     /* 1632481 */   GIM_Try, /*On fail goto*//*Label 22503*/ GIMT_Encode4(1632567), // Rule ID 4066 //
     /* 1632486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1632497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1632500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1632503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632532 */     // MIs[0] policy
     /* 1632532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632542 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11682:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1632545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632566 */     // GIR_Coverage, 4066,
     /* 1632566 */     GIR_EraseRootFromParent_Done,
     /* 1632567 */   // Label 22503: @1632567
     /* 1632567 */   GIM_Try, /*On fail goto*//*Label 22504*/ GIMT_Encode4(1632653), // Rule ID 4067 //
     /* 1632572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1632583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1632586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1632589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632618 */     // MIs[0] policy
     /* 1632618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632628 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11682:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1632631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632652 */     // GIR_Coverage, 4067,
     /* 1632652 */     GIR_EraseRootFromParent_Done,
     /* 1632653 */   // Label 22504: @1632653
     /* 1632653 */   GIM_Try, /*On fail goto*//*Label 22505*/ GIMT_Encode4(1632739), // Rule ID 4070 //
     /* 1632658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1632669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1632672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1632675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632704 */     // MIs[0] policy
     /* 1632704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632714 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11682:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1632717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632738 */     // GIR_Coverage, 4070,
     /* 1632738 */     GIR_EraseRootFromParent_Done,
     /* 1632739 */   // Label 22505: @1632739
     /* 1632739 */   GIM_Try, /*On fail goto*//*Label 22506*/ GIMT_Encode4(1632825), // Rule ID 4071 //
     /* 1632744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1632755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1632758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1632761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632790 */     // MIs[0] policy
     /* 1632790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632800 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11682:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1632803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632824 */     // GIR_Coverage, 4071,
     /* 1632824 */     GIR_EraseRootFromParent_Done,
     /* 1632825 */   // Label 22506: @1632825
     /* 1632825 */   GIM_Try, /*On fail goto*//*Label 22507*/ GIMT_Encode4(1632911), // Rule ID 4080 //
     /* 1632830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1632841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1632844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1632847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1632850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632876 */     // MIs[0] policy
     /* 1632876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632886 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1632889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632910 */     // GIR_Coverage, 4080,
     /* 1632910 */     GIR_EraseRootFromParent_Done,
     /* 1632911 */   // Label 22507: @1632911
     /* 1632911 */   GIM_Try, /*On fail goto*//*Label 22508*/ GIMT_Encode4(1632997), // Rule ID 4081 //
     /* 1632916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1632927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1632930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1632933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1632936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632962 */     // MIs[0] policy
     /* 1632962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632972 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1632975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632996 */     // GIR_Coverage, 4081,
     /* 1632996 */     GIR_EraseRootFromParent_Done,
     /* 1632997 */   // Label 22508: @1632997
     /* 1632997 */   GIM_Try, /*On fail goto*//*Label 22509*/ GIMT_Encode4(1633083), // Rule ID 4090 //
     /* 1633002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1633013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1633016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1633019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1633022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633048 */     // MIs[0] policy
     /* 1633048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1633061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633082 */     // GIR_Coverage, 4090,
     /* 1633082 */     GIR_EraseRootFromParent_Done,
     /* 1633083 */   // Label 22509: @1633083
     /* 1633083 */   GIM_Try, /*On fail goto*//*Label 22510*/ GIMT_Encode4(1633169), // Rule ID 4091 //
     /* 1633088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1633099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1633102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1633105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1633108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633134 */     // MIs[0] policy
     /* 1633134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633144 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1633147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633168 */     // GIR_Coverage, 4091,
     /* 1633168 */     GIR_EraseRootFromParent_Done,
     /* 1633169 */   // Label 22510: @1633169
     /* 1633169 */   GIM_Try, /*On fail goto*//*Label 22511*/ GIMT_Encode4(1633255), // Rule ID 4100 //
     /* 1633174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1633185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1633188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1633194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633220 */     // MIs[0] policy
     /* 1633220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633230 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1633233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633254 */     // GIR_Coverage, 4100,
     /* 1633254 */     GIR_EraseRootFromParent_Done,
     /* 1633255 */   // Label 22511: @1633255
     /* 1633255 */   GIM_Try, /*On fail goto*//*Label 22512*/ GIMT_Encode4(1633341), // Rule ID 4101 //
     /* 1633260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1633271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1633274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1633280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633306 */     // MIs[0] policy
     /* 1633306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1633319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633340 */     // GIR_Coverage, 4101,
     /* 1633340 */     GIR_EraseRootFromParent_Done,
     /* 1633341 */   // Label 22512: @1633341
     /* 1633341 */   GIM_Try, /*On fail goto*//*Label 22513*/ GIMT_Encode4(1633427), // Rule ID 4110 //
     /* 1633346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1633357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1633360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1633366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633392 */     // MIs[0] policy
     /* 1633392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633402 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1633405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633426 */     // GIR_Coverage, 4110,
     /* 1633426 */     GIR_EraseRootFromParent_Done,
     /* 1633427 */   // Label 22513: @1633427
     /* 1633427 */   GIM_Try, /*On fail goto*//*Label 22514*/ GIMT_Encode4(1633513), // Rule ID 4111 //
     /* 1633432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1633443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1633446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1633452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633478 */     // MIs[0] policy
     /* 1633478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633488 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1633491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633512 */     // GIR_Coverage, 4111,
     /* 1633512 */     GIR_EraseRootFromParent_Done,
     /* 1633513 */   // Label 22514: @1633513
     /* 1633513 */   GIM_Try, /*On fail goto*//*Label 22515*/ GIMT_Encode4(1633599), // Rule ID 4120 //
     /* 1633518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1633529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1633532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1633535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1633538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1633541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633564 */     // MIs[0] policy
     /* 1633564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633574 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1633577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633598 */     // GIR_Coverage, 4120,
     /* 1633598 */     GIR_EraseRootFromParent_Done,
     /* 1633599 */   // Label 22515: @1633599
     /* 1633599 */   GIM_Try, /*On fail goto*//*Label 22516*/ GIMT_Encode4(1633685), // Rule ID 4121 //
     /* 1633604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1633615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1633618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1633621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1633624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1633627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633650 */     // MIs[0] policy
     /* 1633650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633660 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1633663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633684 */     // GIR_Coverage, 4121,
     /* 1633684 */     GIR_EraseRootFromParent_Done,
     /* 1633685 */   // Label 22516: @1633685
     /* 1633685 */   GIM_Try, /*On fail goto*//*Label 22517*/ GIMT_Encode4(1633771), // Rule ID 4130 //
     /* 1633690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1633701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1633704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1633707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1633710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1633713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633736 */     // MIs[0] policy
     /* 1633736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1633749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633770 */     // GIR_Coverage, 4130,
     /* 1633770 */     GIR_EraseRootFromParent_Done,
     /* 1633771 */   // Label 22517: @1633771
     /* 1633771 */   GIM_Try, /*On fail goto*//*Label 22518*/ GIMT_Encode4(1633857), // Rule ID 4131 //
     /* 1633776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1633787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1633790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1633793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1633796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1633799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633822 */     // MIs[0] policy
     /* 1633822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633832 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1633835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633856 */     // GIR_Coverage, 4131,
     /* 1633856 */     GIR_EraseRootFromParent_Done,
     /* 1633857 */   // Label 22518: @1633857
     /* 1633857 */   GIM_Try, /*On fail goto*//*Label 22519*/ GIMT_Encode4(1633943), // Rule ID 4140 //
     /* 1633862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1633873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1633876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1633879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1633882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633908 */     // MIs[0] policy
     /* 1633908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1633921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633942 */     // GIR_Coverage, 4140,
     /* 1633942 */     GIR_EraseRootFromParent_Done,
     /* 1633943 */   // Label 22519: @1633943
     /* 1633943 */   GIM_Try, /*On fail goto*//*Label 22520*/ GIMT_Encode4(1634029), // Rule ID 4141 //
     /* 1633948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1633959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1633962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1633965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1633968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633994 */     // MIs[0] policy
     /* 1633994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634004 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1634007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634028 */     // GIR_Coverage, 4141,
     /* 1634028 */     GIR_EraseRootFromParent_Done,
     /* 1634029 */   // Label 22520: @1634029
     /* 1634029 */   GIM_Try, /*On fail goto*//*Label 22521*/ GIMT_Encode4(1634115), // Rule ID 4150 //
     /* 1634034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1634045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1634048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1634051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1634054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634080 */     // MIs[0] policy
     /* 1634080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1634093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634114 */     // GIR_Coverage, 4150,
     /* 1634114 */     GIR_EraseRootFromParent_Done,
     /* 1634115 */   // Label 22521: @1634115
     /* 1634115 */   GIM_Try, /*On fail goto*//*Label 22522*/ GIMT_Encode4(1634201), // Rule ID 4151 //
     /* 1634120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1634131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1634134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1634137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1634140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634166 */     // MIs[0] policy
     /* 1634166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1634179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634200 */     // GIR_Coverage, 4151,
     /* 1634200 */     GIR_EraseRootFromParent_Done,
     /* 1634201 */   // Label 22522: @1634201
     /* 1634201 */   GIM_Try, /*On fail goto*//*Label 22523*/ GIMT_Encode4(1634287), // Rule ID 4160 //
     /* 1634206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1634217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1634220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1634223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1634226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634252 */     // MIs[0] policy
     /* 1634252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634262 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1634265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634286 */     // GIR_Coverage, 4160,
     /* 1634286 */     GIR_EraseRootFromParent_Done,
     /* 1634287 */   // Label 22523: @1634287
     /* 1634287 */   GIM_Try, /*On fail goto*//*Label 22524*/ GIMT_Encode4(1634373), // Rule ID 4161 //
     /* 1634292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1634303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1634306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1634309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1634312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634338 */     // MIs[0] policy
     /* 1634338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634348 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1634351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634372 */     // GIR_Coverage, 4161,
     /* 1634372 */     GIR_EraseRootFromParent_Done,
     /* 1634373 */   // Label 22524: @1634373
     /* 1634373 */   GIM_Try, /*On fail goto*//*Label 22525*/ GIMT_Encode4(1634459), // Rule ID 4170 //
     /* 1634378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1634389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1634392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1634395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1634398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634424 */     // MIs[0] policy
     /* 1634424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634434 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1634437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634458 */     // GIR_Coverage, 4170,
     /* 1634458 */     GIR_EraseRootFromParent_Done,
     /* 1634459 */   // Label 22525: @1634459
     /* 1634459 */   GIM_Try, /*On fail goto*//*Label 22526*/ GIMT_Encode4(1634545), // Rule ID 4171 //
     /* 1634464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1634475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1634478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1634481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1634484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634510 */     // MIs[0] policy
     /* 1634510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634520 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1634523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634544 */     // GIR_Coverage, 4171,
     /* 1634544 */     GIR_EraseRootFromParent_Done,
     /* 1634545 */   // Label 22526: @1634545
     /* 1634545 */   GIM_Try, /*On fail goto*//*Label 22527*/ GIMT_Encode4(1634631), // Rule ID 4180 //
     /* 1634550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1634553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1634561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1634564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1634567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1634570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634596 */     // MIs[0] policy
     /* 1634596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634606 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1634609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634630 */     // GIR_Coverage, 4180,
     /* 1634630 */     GIR_EraseRootFromParent_Done,
     /* 1634631 */   // Label 22527: @1634631
     /* 1634631 */   GIM_Try, /*On fail goto*//*Label 22528*/ GIMT_Encode4(1634717), // Rule ID 4181 //
     /* 1634636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1634639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1634647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1634650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1634653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1634656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634682 */     // MIs[0] policy
     /* 1634682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634692 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1634695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634716 */     // GIR_Coverage, 4181,
     /* 1634716 */     GIR_EraseRootFromParent_Done,
     /* 1634717 */   // Label 22528: @1634717
     /* 1634717 */   GIM_Try, /*On fail goto*//*Label 22529*/ GIMT_Encode4(1634803), // Rule ID 4190 //
     /* 1634722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1634725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1634733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1634736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1634739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1634742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634768 */     // MIs[0] policy
     /* 1634768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1634781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634802 */     // GIR_Coverage, 4190,
     /* 1634802 */     GIR_EraseRootFromParent_Done,
     /* 1634803 */   // Label 22529: @1634803
     /* 1634803 */   GIM_Try, /*On fail goto*//*Label 22530*/ GIMT_Encode4(1634889), // Rule ID 4191 //
     /* 1634808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1634811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1634819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1634822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1634825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1634828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634854 */     // MIs[0] policy
     /* 1634854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1634867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634888 */     // GIR_Coverage, 4191,
     /* 1634888 */     GIR_EraseRootFromParent_Done,
     /* 1634889 */   // Label 22530: @1634889
     /* 1634889 */   GIM_Try, /*On fail goto*//*Label 22531*/ GIMT_Encode4(1634975), // Rule ID 4200 //
     /* 1634894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1634897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1634905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1634908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1634911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1634914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634940 */     // MIs[0] policy
     /* 1634940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1634953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634974 */     // GIR_Coverage, 4200,
     /* 1634974 */     GIR_EraseRootFromParent_Done,
     /* 1634975 */   // Label 22531: @1634975
     /* 1634975 */   GIM_Try, /*On fail goto*//*Label 22532*/ GIMT_Encode4(1635061), // Rule ID 4201 //
     /* 1634980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1634983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1634991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1634994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1634997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1635000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1635010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635026 */     // MIs[0] policy
     /* 1635026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1635039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635060 */     // GIR_Coverage, 4201,
     /* 1635060 */     GIR_EraseRootFromParent_Done,
     /* 1635061 */   // Label 22532: @1635061
     /* 1635061 */   GIM_Try, /*On fail goto*//*Label 22533*/ GIMT_Encode4(1635147), // Rule ID 4210 //
     /* 1635066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1635077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1635080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1635083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1635086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635112 */     // MIs[0] policy
     /* 1635112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635122 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1635125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635146 */     // GIR_Coverage, 4210,
     /* 1635146 */     GIR_EraseRootFromParent_Done,
     /* 1635147 */   // Label 22533: @1635147
     /* 1635147 */   GIM_Try, /*On fail goto*//*Label 22534*/ GIMT_Encode4(1635233), // Rule ID 4211 //
     /* 1635152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1635163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1635166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1635169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1635172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635198 */     // MIs[0] policy
     /* 1635198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1635211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635232 */     // GIR_Coverage, 4211,
     /* 1635232 */     GIR_EraseRootFromParent_Done,
     /* 1635233 */   // Label 22534: @1635233
     /* 1635233 */   GIM_Try, /*On fail goto*//*Label 22535*/ GIMT_Encode4(1635319), // Rule ID 4214 //
     /* 1635238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1635249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1635252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635284 */     // MIs[0] policy
     /* 1635284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635294 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1635297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635318 */     // GIR_Coverage, 4214,
     /* 1635318 */     GIR_EraseRootFromParent_Done,
     /* 1635319 */   // Label 22535: @1635319
     /* 1635319 */   GIM_Try, /*On fail goto*//*Label 22536*/ GIMT_Encode4(1635405), // Rule ID 4215 //
     /* 1635324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1635335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1635338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635370 */     // MIs[0] policy
     /* 1635370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635380 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1635383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635404 */     // GIR_Coverage, 4215,
     /* 1635404 */     GIR_EraseRootFromParent_Done,
     /* 1635405 */   // Label 22536: @1635405
     /* 1635405 */   GIM_Try, /*On fail goto*//*Label 22537*/ GIMT_Encode4(1635491), // Rule ID 4218 //
     /* 1635410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1635421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1635424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635456 */     // MIs[0] policy
     /* 1635456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635466 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1635469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635490 */     // GIR_Coverage, 4218,
     /* 1635490 */     GIR_EraseRootFromParent_Done,
     /* 1635491 */   // Label 22537: @1635491
     /* 1635491 */   GIM_Try, /*On fail goto*//*Label 22538*/ GIMT_Encode4(1635577), // Rule ID 4219 //
     /* 1635496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1635507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1635510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635542 */     // MIs[0] policy
     /* 1635542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1635555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635576 */     // GIR_Coverage, 4219,
     /* 1635576 */     GIR_EraseRootFromParent_Done,
     /* 1635577 */   // Label 22538: @1635577
     /* 1635577 */   GIM_Try, /*On fail goto*//*Label 22539*/ GIMT_Encode4(1635663), // Rule ID 4222 //
     /* 1635582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1635593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1635596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1635599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635628 */     // MIs[0] policy
     /* 1635628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635638 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1635641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635662 */     // GIR_Coverage, 4222,
     /* 1635662 */     GIR_EraseRootFromParent_Done,
     /* 1635663 */   // Label 22539: @1635663
     /* 1635663 */   GIM_Try, /*On fail goto*//*Label 22540*/ GIMT_Encode4(1635749), // Rule ID 4223 //
     /* 1635668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1635679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1635682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1635685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635714 */     // MIs[0] policy
     /* 1635714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635724 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1635727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635748 */     // GIR_Coverage, 4223,
     /* 1635748 */     GIR_EraseRootFromParent_Done,
     /* 1635749 */   // Label 22540: @1635749
     /* 1635749 */   GIM_Try, /*On fail goto*//*Label 22541*/ GIMT_Encode4(1635835), // Rule ID 4226 //
     /* 1635754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1635765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1635768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1635771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635800 */     // MIs[0] policy
     /* 1635800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635810 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1635813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635834 */     // GIR_Coverage, 4226,
     /* 1635834 */     GIR_EraseRootFromParent_Done,
     /* 1635835 */   // Label 22541: @1635835
     /* 1635835 */   GIM_Try, /*On fail goto*//*Label 22542*/ GIMT_Encode4(1635921), // Rule ID 4227 //
     /* 1635840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1635851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1635854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1635857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635886 */     // MIs[0] policy
     /* 1635886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1635899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635920 */     // GIR_Coverage, 4227,
     /* 1635920 */     GIR_EraseRootFromParent_Done,
     /* 1635921 */   // Label 22542: @1635921
     /* 1635921 */   GIM_Try, /*On fail goto*//*Label 22543*/ GIMT_Encode4(1636007), // Rule ID 4230 //
     /* 1635926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1635937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1635940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1635943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1635949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1635956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635972 */     // MIs[0] policy
     /* 1635972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635982 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1635985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636006 */     // GIR_Coverage, 4230,
     /* 1636006 */     GIR_EraseRootFromParent_Done,
     /* 1636007 */   // Label 22543: @1636007
     /* 1636007 */   GIM_Try, /*On fail goto*//*Label 22544*/ GIMT_Encode4(1636093), // Rule ID 4231 //
     /* 1636012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1636023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1636026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1636029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1636035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636058 */     // MIs[0] policy
     /* 1636058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636068 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1636071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636092 */     // GIR_Coverage, 4231,
     /* 1636092 */     GIR_EraseRootFromParent_Done,
     /* 1636093 */   // Label 22544: @1636093
     /* 1636093 */   GIM_Try, /*On fail goto*//*Label 22545*/ GIMT_Encode4(1636179), // Rule ID 4234 //
     /* 1636098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1636109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1636112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1636115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1636121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636144 */     // MIs[0] policy
     /* 1636144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636154 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1636157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636178 */     // GIR_Coverage, 4234,
     /* 1636178 */     GIR_EraseRootFromParent_Done,
     /* 1636179 */   // Label 22545: @1636179
     /* 1636179 */   GIM_Try, /*On fail goto*//*Label 22546*/ GIMT_Encode4(1636265), // Rule ID 4235 //
     /* 1636184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1636195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1636198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1636201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1636207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636230 */     // MIs[0] policy
     /* 1636230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636240 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1636243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636264 */     // GIR_Coverage, 4235,
     /* 1636264 */     GIR_EraseRootFromParent_Done,
     /* 1636265 */   // Label 22546: @1636265
     /* 1636265 */   GIM_Try, /*On fail goto*//*Label 22547*/ GIMT_Encode4(1636351), // Rule ID 4238 //
     /* 1636270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1636281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1636284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1636287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636316 */     // MIs[0] policy
     /* 1636316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636326 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1636329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636350 */     // GIR_Coverage, 4238,
     /* 1636350 */     GIR_EraseRootFromParent_Done,
     /* 1636351 */   // Label 22547: @1636351
     /* 1636351 */   GIM_Try, /*On fail goto*//*Label 22548*/ GIMT_Encode4(1636437), // Rule ID 4239 //
     /* 1636356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1636367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1636370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1636373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636402 */     // MIs[0] policy
     /* 1636402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636412 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1636415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636436 */     // GIR_Coverage, 4239,
     /* 1636436 */     GIR_EraseRootFromParent_Done,
     /* 1636437 */   // Label 22548: @1636437
     /* 1636437 */   GIM_Try, /*On fail goto*//*Label 22549*/ GIMT_Encode4(1636523), // Rule ID 4242 //
     /* 1636442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1636453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1636456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1636459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636488 */     // MIs[0] policy
     /* 1636488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636498 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1636501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636522 */     // GIR_Coverage, 4242,
     /* 1636522 */     GIR_EraseRootFromParent_Done,
     /* 1636523 */   // Label 22549: @1636523
     /* 1636523 */   GIM_Try, /*On fail goto*//*Label 22550*/ GIMT_Encode4(1636609), // Rule ID 4243 //
     /* 1636528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1636539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1636542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1636545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636574 */     // MIs[0] policy
     /* 1636574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1636587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636608 */     // GIR_Coverage, 4243,
     /* 1636608 */     GIR_EraseRootFromParent_Done,
     /* 1636609 */   // Label 22550: @1636609
     /* 1636609 */   GIM_Try, /*On fail goto*//*Label 22551*/ GIMT_Encode4(1636695), // Rule ID 4246 //
     /* 1636614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1636625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1636628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1636631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636660 */     // MIs[0] policy
     /* 1636660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1636673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636694 */     // GIR_Coverage, 4246,
     /* 1636694 */     GIR_EraseRootFromParent_Done,
     /* 1636695 */   // Label 22551: @1636695
     /* 1636695 */   GIM_Try, /*On fail goto*//*Label 22552*/ GIMT_Encode4(1636781), // Rule ID 4247 //
     /* 1636700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1636711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1636714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1636717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636746 */     // MIs[0] policy
     /* 1636746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1636759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636780 */     // GIR_Coverage, 4247,
     /* 1636780 */     GIR_EraseRootFromParent_Done,
     /* 1636781 */   // Label 22552: @1636781
     /* 1636781 */   GIM_Try, /*On fail goto*//*Label 22553*/ GIMT_Encode4(1636867), // Rule ID 4250 //
     /* 1636786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1636797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1636800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1636803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636832 */     // MIs[0] policy
     /* 1636832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636842 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1636845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636866 */     // GIR_Coverage, 4250,
     /* 1636866 */     GIR_EraseRootFromParent_Done,
     /* 1636867 */   // Label 22553: @1636867
     /* 1636867 */   GIM_Try, /*On fail goto*//*Label 22554*/ GIMT_Encode4(1636953), // Rule ID 4251 //
     /* 1636872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1636883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1636886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1636889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636918 */     // MIs[0] policy
     /* 1636918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636928 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1636931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636952 */     // GIR_Coverage, 4251,
     /* 1636952 */     GIR_EraseRootFromParent_Done,
     /* 1636953 */   // Label 22554: @1636953
     /* 1636953 */   GIM_Try, /*On fail goto*//*Label 22555*/ GIMT_Encode4(1637039), // Rule ID 4254 //
     /* 1636958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1636969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1636972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1636975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1636981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637004 */     // MIs[0] policy
     /* 1637004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637014 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1637017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637038 */     // GIR_Coverage, 4254,
     /* 1637038 */     GIR_EraseRootFromParent_Done,
     /* 1637039 */   // Label 22555: @1637039
     /* 1637039 */   GIM_Try, /*On fail goto*//*Label 22556*/ GIMT_Encode4(1637125), // Rule ID 4255 //
     /* 1637044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1637055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1637058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1637061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637090 */     // MIs[0] policy
     /* 1637090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1637103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637124 */     // GIR_Coverage, 4255,
     /* 1637124 */     GIR_EraseRootFromParent_Done,
     /* 1637125 */   // Label 22556: @1637125
     /* 1637125 */   GIM_Try, /*On fail goto*//*Label 22557*/ GIMT_Encode4(1637211), // Rule ID 4258 //
     /* 1637130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1637141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1637144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1637147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637176 */     // MIs[0] policy
     /* 1637176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1637189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637210 */     // GIR_Coverage, 4258,
     /* 1637210 */     GIR_EraseRootFromParent_Done,
     /* 1637211 */   // Label 22557: @1637211
     /* 1637211 */   GIM_Try, /*On fail goto*//*Label 22558*/ GIMT_Encode4(1637297), // Rule ID 4259 //
     /* 1637216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1637227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1637230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1637233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637262 */     // MIs[0] policy
     /* 1637262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637272 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1637275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637296 */     // GIR_Coverage, 4259,
     /* 1637296 */     GIR_EraseRootFromParent_Done,
     /* 1637297 */   // Label 22558: @1637297
     /* 1637297 */   GIM_Try, /*On fail goto*//*Label 22559*/ GIMT_Encode4(1637383), // Rule ID 4262 //
     /* 1637302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1637313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1637316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1637319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637348 */     // MIs[0] policy
     /* 1637348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1637361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637382 */     // GIR_Coverage, 4262,
     /* 1637382 */     GIR_EraseRootFromParent_Done,
     /* 1637383 */   // Label 22559: @1637383
     /* 1637383 */   GIM_Try, /*On fail goto*//*Label 22560*/ GIMT_Encode4(1637469), // Rule ID 4263 //
     /* 1637388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1637399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1637402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1637405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637434 */     // MIs[0] policy
     /* 1637434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637444 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1637447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637468 */     // GIR_Coverage, 4263,
     /* 1637468 */     GIR_EraseRootFromParent_Done,
     /* 1637469 */   // Label 22560: @1637469
     /* 1637469 */   GIM_Try, /*On fail goto*//*Label 22561*/ GIMT_Encode4(1637555), // Rule ID 4266 //
     /* 1637474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1637485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1637488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1637491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637520 */     // MIs[0] policy
     /* 1637520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637530 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1637533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637554 */     // GIR_Coverage, 4266,
     /* 1637554 */     GIR_EraseRootFromParent_Done,
     /* 1637555 */   // Label 22561: @1637555
     /* 1637555 */   GIM_Try, /*On fail goto*//*Label 22562*/ GIMT_Encode4(1637641), // Rule ID 4267 //
     /* 1637560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1637571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1637574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1637577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637606 */     // MIs[0] policy
     /* 1637606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1637619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637640 */     // GIR_Coverage, 4267,
     /* 1637640 */     GIR_EraseRootFromParent_Done,
     /* 1637641 */   // Label 22562: @1637641
     /* 1637641 */   GIM_Try, /*On fail goto*//*Label 22563*/ GIMT_Encode4(1637727), // Rule ID 4270 //
     /* 1637646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1637657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1637660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1637663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637692 */     // MIs[0] policy
     /* 1637692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637702 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1637705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637726 */     // GIR_Coverage, 4270,
     /* 1637726 */     GIR_EraseRootFromParent_Done,
     /* 1637727 */   // Label 22563: @1637727
     /* 1637727 */   GIM_Try, /*On fail goto*//*Label 22564*/ GIMT_Encode4(1637813), // Rule ID 4271 //
     /* 1637732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1637743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1637746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1637749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637778 */     // MIs[0] policy
     /* 1637778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637788 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1637791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637812 */     // GIR_Coverage, 4271,
     /* 1637812 */     GIR_EraseRootFromParent_Done,
     /* 1637813 */   // Label 22564: @1637813
     /* 1637813 */   GIM_Try, /*On fail goto*//*Label 22565*/ GIMT_Encode4(1637899), // Rule ID 4280 //
     /* 1637818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1637829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1637832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1637835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1637838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637864 */     // MIs[0] policy
     /* 1637864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637874 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1637877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637898 */     // GIR_Coverage, 4280,
     /* 1637898 */     GIR_EraseRootFromParent_Done,
     /* 1637899 */   // Label 22565: @1637899
     /* 1637899 */   GIM_Try, /*On fail goto*//*Label 22566*/ GIMT_Encode4(1637985), // Rule ID 4281 //
     /* 1637904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1637915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1637918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1637921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1637924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637950 */     // MIs[0] policy
     /* 1637950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637960 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1637963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637984 */     // GIR_Coverage, 4281,
     /* 1637984 */     GIR_EraseRootFromParent_Done,
     /* 1637985 */   // Label 22566: @1637985
     /* 1637985 */   GIM_Try, /*On fail goto*//*Label 22567*/ GIMT_Encode4(1638071), // Rule ID 4290 //
     /* 1637990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1638001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1638004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1638007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1638010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638036 */     // MIs[0] policy
     /* 1638036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638046 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1638049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638070 */     // GIR_Coverage, 4290,
     /* 1638070 */     GIR_EraseRootFromParent_Done,
     /* 1638071 */   // Label 22567: @1638071
     /* 1638071 */   GIM_Try, /*On fail goto*//*Label 22568*/ GIMT_Encode4(1638157), // Rule ID 4291 //
     /* 1638076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1638087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1638090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1638093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1638096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638122 */     // MIs[0] policy
     /* 1638122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638132 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1638135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638156 */     // GIR_Coverage, 4291,
     /* 1638156 */     GIR_EraseRootFromParent_Done,
     /* 1638157 */   // Label 22568: @1638157
     /* 1638157 */   GIM_Try, /*On fail goto*//*Label 22569*/ GIMT_Encode4(1638243), // Rule ID 4300 //
     /* 1638162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1638173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1638176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1638179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1638182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638208 */     // MIs[0] policy
     /* 1638208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638218 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1638221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638242 */     // GIR_Coverage, 4300,
     /* 1638242 */     GIR_EraseRootFromParent_Done,
     /* 1638243 */   // Label 22569: @1638243
     /* 1638243 */   GIM_Try, /*On fail goto*//*Label 22570*/ GIMT_Encode4(1638329), // Rule ID 4301 //
     /* 1638248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1638259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1638262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1638265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1638268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638294 */     // MIs[0] policy
     /* 1638294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638304 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1638307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638328 */     // GIR_Coverage, 4301,
     /* 1638328 */     GIR_EraseRootFromParent_Done,
     /* 1638329 */   // Label 22570: @1638329
     /* 1638329 */   GIM_Try, /*On fail goto*//*Label 22571*/ GIMT_Encode4(1638415), // Rule ID 4310 //
     /* 1638334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1638345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1638348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1638351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1638354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638380 */     // MIs[0] policy
     /* 1638380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638390 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1638393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638414 */     // GIR_Coverage, 4310,
     /* 1638414 */     GIR_EraseRootFromParent_Done,
     /* 1638415 */   // Label 22571: @1638415
     /* 1638415 */   GIM_Try, /*On fail goto*//*Label 22572*/ GIMT_Encode4(1638501), // Rule ID 4311 //
     /* 1638420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1638431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1638434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1638437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1638440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638466 */     // MIs[0] policy
     /* 1638466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1638479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638500 */     // GIR_Coverage, 4311,
     /* 1638500 */     GIR_EraseRootFromParent_Done,
     /* 1638501 */   // Label 22572: @1638501
     /* 1638501 */   GIM_Try, /*On fail goto*//*Label 22573*/ GIMT_Encode4(1638587), // Rule ID 4320 //
     /* 1638506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1638517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1638520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1638523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1638526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638552 */     // MIs[0] policy
     /* 1638552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638562 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1638565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638586 */     // GIR_Coverage, 4320,
     /* 1638586 */     GIR_EraseRootFromParent_Done,
     /* 1638587 */   // Label 22573: @1638587
     /* 1638587 */   GIM_Try, /*On fail goto*//*Label 22574*/ GIMT_Encode4(1638673), // Rule ID 4321 //
     /* 1638592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1638603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1638606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1638609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1638612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638638 */     // MIs[0] policy
     /* 1638638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638648 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1638651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638672 */     // GIR_Coverage, 4321,
     /* 1638672 */     GIR_EraseRootFromParent_Done,
     /* 1638673 */   // Label 22574: @1638673
     /* 1638673 */   GIM_Try, /*On fail goto*//*Label 22575*/ GIMT_Encode4(1638759), // Rule ID 4330 //
     /* 1638678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1638689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1638692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1638695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1638698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1638701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638724 */     // MIs[0] policy
     /* 1638724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638734 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1638737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638758 */     // GIR_Coverage, 4330,
     /* 1638758 */     GIR_EraseRootFromParent_Done,
     /* 1638759 */   // Label 22575: @1638759
     /* 1638759 */   GIM_Try, /*On fail goto*//*Label 22576*/ GIMT_Encode4(1638845), // Rule ID 4331 //
     /* 1638764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1638775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1638778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1638781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1638784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1638787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638810 */     // MIs[0] policy
     /* 1638810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638820 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1638823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638844 */     // GIR_Coverage, 4331,
     /* 1638844 */     GIR_EraseRootFromParent_Done,
     /* 1638845 */   // Label 22576: @1638845
     /* 1638845 */   GIM_Try, /*On fail goto*//*Label 22577*/ GIMT_Encode4(1638931), // Rule ID 4340 //
     /* 1638850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1638861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1638864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1638867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1638870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638896 */     // MIs[0] policy
     /* 1638896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638906 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1638909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1638927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638930 */     // GIR_Coverage, 4340,
     /* 1638930 */     GIR_EraseRootFromParent_Done,
     /* 1638931 */   // Label 22577: @1638931
     /* 1638931 */   GIM_Try, /*On fail goto*//*Label 22578*/ GIMT_Encode4(1639017), // Rule ID 4341 //
     /* 1638936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1638947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1638950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1638953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1638956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638982 */     // MIs[0] policy
     /* 1638982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638992 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1638995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639016 */     // GIR_Coverage, 4341,
     /* 1639016 */     GIR_EraseRootFromParent_Done,
     /* 1639017 */   // Label 22578: @1639017
     /* 1639017 */   GIM_Try, /*On fail goto*//*Label 22579*/ GIMT_Encode4(1639103), // Rule ID 4350 //
     /* 1639022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1639033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1639036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1639039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1639042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639068 */     // MIs[0] policy
     /* 1639068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639078 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11688:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1639081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639102 */     // GIR_Coverage, 4350,
     /* 1639102 */     GIR_EraseRootFromParent_Done,
     /* 1639103 */   // Label 22579: @1639103
     /* 1639103 */   GIM_Try, /*On fail goto*//*Label 22580*/ GIMT_Encode4(1639189), // Rule ID 4351 //
     /* 1639108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1639119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1639122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1639125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1639128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639154 */     // MIs[0] policy
     /* 1639154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11688:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1639167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639188 */     // GIR_Coverage, 4351,
     /* 1639188 */     GIR_EraseRootFromParent_Done,
     /* 1639189 */   // Label 22580: @1639189
     /* 1639189 */   GIM_Try, /*On fail goto*//*Label 22581*/ GIMT_Encode4(1639275), // Rule ID 4360 //
     /* 1639194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1639205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1639208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1639211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1639214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639240 */     // MIs[0] policy
     /* 1639240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1639253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639274 */     // GIR_Coverage, 4360,
     /* 1639274 */     GIR_EraseRootFromParent_Done,
     /* 1639275 */   // Label 22581: @1639275
     /* 1639275 */   GIM_Try, /*On fail goto*//*Label 22582*/ GIMT_Encode4(1639361), // Rule ID 4361 //
     /* 1639280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1639291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1639294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1639297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1639300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639326 */     // MIs[0] policy
     /* 1639326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1639339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639360 */     // GIR_Coverage, 4361,
     /* 1639360 */     GIR_EraseRootFromParent_Done,
     /* 1639361 */   // Label 22582: @1639361
     /* 1639361 */   GIM_Try, /*On fail goto*//*Label 22583*/ GIMT_Encode4(1639447), // Rule ID 4370 //
     /* 1639366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1639377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1639380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1639383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1639386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639412 */     // MIs[0] policy
     /* 1639412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1639425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639446 */     // GIR_Coverage, 4370,
     /* 1639446 */     GIR_EraseRootFromParent_Done,
     /* 1639447 */   // Label 22583: @1639447
     /* 1639447 */   GIM_Try, /*On fail goto*//*Label 22584*/ GIMT_Encode4(1639533), // Rule ID 4371 //
     /* 1639452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1639463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1639466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1639469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1639472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639498 */     // MIs[0] policy
     /* 1639498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639508 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1639511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639532 */     // GIR_Coverage, 4371,
     /* 1639532 */     GIR_EraseRootFromParent_Done,
     /* 1639533 */   // Label 22584: @1639533
     /* 1639533 */   GIM_Try, /*On fail goto*//*Label 22585*/ GIMT_Encode4(1639619), // Rule ID 4380 //
     /* 1639538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1639549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1639552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1639555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1639558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1639561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639584 */     // MIs[0] policy
     /* 1639584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639594 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1639597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639618 */     // GIR_Coverage, 4380,
     /* 1639618 */     GIR_EraseRootFromParent_Done,
     /* 1639619 */   // Label 22585: @1639619
     /* 1639619 */   GIM_Try, /*On fail goto*//*Label 22586*/ GIMT_Encode4(1639705), // Rule ID 4381 //
     /* 1639624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1639635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1639638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1639641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1639644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1639647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639670 */     // MIs[0] policy
     /* 1639670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639680 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1639683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639704 */     // GIR_Coverage, 4381,
     /* 1639704 */     GIR_EraseRootFromParent_Done,
     /* 1639705 */   // Label 22586: @1639705
     /* 1639705 */   GIM_Try, /*On fail goto*//*Label 22587*/ GIMT_Encode4(1639791), // Rule ID 4390 //
     /* 1639710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1639713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1639721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1639724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1639727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1639730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639756 */     // MIs[0] policy
     /* 1639756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639766 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1639769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1639787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639790 */     // GIR_Coverage, 4390,
     /* 1639790 */     GIR_EraseRootFromParent_Done,
     /* 1639791 */   // Label 22587: @1639791
     /* 1639791 */   GIM_Try, /*On fail goto*//*Label 22588*/ GIMT_Encode4(1639877), // Rule ID 4391 //
     /* 1639796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1639799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1639807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1639810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1639813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1639816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639842 */     // MIs[0] policy
     /* 1639842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1639855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1639873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639876 */     // GIR_Coverage, 4391,
     /* 1639876 */     GIR_EraseRootFromParent_Done,
     /* 1639877 */   // Label 22588: @1639877
     /* 1639877 */   GIM_Try, /*On fail goto*//*Label 22589*/ GIMT_Encode4(1639963), // Rule ID 4400 //
     /* 1639882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1639885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1639893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1639896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1639899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1639902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639928 */     // MIs[0] policy
     /* 1639928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639938 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1639941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1639959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639962 */     // GIR_Coverage, 4400,
     /* 1639962 */     GIR_EraseRootFromParent_Done,
     /* 1639963 */   // Label 22589: @1639963
     /* 1639963 */   GIM_Try, /*On fail goto*//*Label 22590*/ GIMT_Encode4(1640049), // Rule ID 4401 //
     /* 1639968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1639971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1639979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1639982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1639985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1639988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640014 */     // MIs[0] policy
     /* 1640014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1640027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640048 */     // GIR_Coverage, 4401,
     /* 1640048 */     GIR_EraseRootFromParent_Done,
     /* 1640049 */   // Label 22590: @1640049
     /* 1640049 */   GIM_Try, /*On fail goto*//*Label 22591*/ GIMT_Encode4(1640135), // Rule ID 4410 //
     /* 1640054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1640065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1640068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1640071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1640074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640100 */     // MIs[0] policy
     /* 1640100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640110 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1640113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640134 */     // GIR_Coverage, 4410,
     /* 1640134 */     GIR_EraseRootFromParent_Done,
     /* 1640135 */   // Label 22591: @1640135
     /* 1640135 */   GIM_Try, /*On fail goto*//*Label 22592*/ GIMT_Encode4(1640221), // Rule ID 4411 //
     /* 1640140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1640151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1640154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1640157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1640160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640186 */     // MIs[0] policy
     /* 1640186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1640199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640220 */     // GIR_Coverage, 4411,
     /* 1640220 */     GIR_EraseRootFromParent_Done,
     /* 1640221 */   // Label 22592: @1640221
     /* 1640221 */   GIM_Try, /*On fail goto*//*Label 22593*/ GIMT_Encode4(1640307), // Rule ID 4420 //
     /* 1640226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1640237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1640240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1640243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1640246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640272 */     // MIs[0] policy
     /* 1640272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640282 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1640285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640306 */     // GIR_Coverage, 4420,
     /* 1640306 */     GIR_EraseRootFromParent_Done,
     /* 1640307 */   // Label 22593: @1640307
     /* 1640307 */   GIM_Try, /*On fail goto*//*Label 22594*/ GIMT_Encode4(1640393), // Rule ID 4421 //
     /* 1640312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1640323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1640326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1640329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1640332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640358 */     // MIs[0] policy
     /* 1640358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1640371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640392 */     // GIR_Coverage, 4421,
     /* 1640392 */     GIR_EraseRootFromParent_Done,
     /* 1640393 */   // Label 22594: @1640393
     /* 1640393 */   GIM_Try, /*On fail goto*//*Label 22595*/ GIMT_Encode4(1640479), // Rule ID 4424 //
     /* 1640398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1640409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1640412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1640415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640444 */     // MIs[0] policy
     /* 1640444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640454 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1640457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640478 */     // GIR_Coverage, 4424,
     /* 1640478 */     GIR_EraseRootFromParent_Done,
     /* 1640479 */   // Label 22595: @1640479
     /* 1640479 */   GIM_Try, /*On fail goto*//*Label 22596*/ GIMT_Encode4(1640565), // Rule ID 4425 //
     /* 1640484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1640495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1640498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1640501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640530 */     // MIs[0] policy
     /* 1640530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640540 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1640543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640564 */     // GIR_Coverage, 4425,
     /* 1640564 */     GIR_EraseRootFromParent_Done,
     /* 1640565 */   // Label 22596: @1640565
     /* 1640565 */   GIM_Try, /*On fail goto*//*Label 22597*/ GIMT_Encode4(1640651), // Rule ID 4428 //
     /* 1640570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1640581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1640584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1640587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640616 */     // MIs[0] policy
     /* 1640616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640626 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1640629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640650 */     // GIR_Coverage, 4428,
     /* 1640650 */     GIR_EraseRootFromParent_Done,
     /* 1640651 */   // Label 22597: @1640651
     /* 1640651 */   GIM_Try, /*On fail goto*//*Label 22598*/ GIMT_Encode4(1640737), // Rule ID 4429 //
     /* 1640656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1640667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1640670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1640673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640702 */     // MIs[0] policy
     /* 1640702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640712 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1640715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640736 */     // GIR_Coverage, 4429,
     /* 1640736 */     GIR_EraseRootFromParent_Done,
     /* 1640737 */   // Label 22598: @1640737
     /* 1640737 */   GIM_Try, /*On fail goto*//*Label 22599*/ GIMT_Encode4(1640823), // Rule ID 4432 //
     /* 1640742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1640753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1640756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1640759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640788 */     // MIs[0] policy
     /* 1640788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640798 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1640801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640822 */     // GIR_Coverage, 4432,
     /* 1640822 */     GIR_EraseRootFromParent_Done,
     /* 1640823 */   // Label 22599: @1640823
     /* 1640823 */   GIM_Try, /*On fail goto*//*Label 22600*/ GIMT_Encode4(1640909), // Rule ID 4433 //
     /* 1640828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1640839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1640842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1640845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640874 */     // MIs[0] policy
     /* 1640874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640884 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11688:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1640887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640908 */     // GIR_Coverage, 4433,
     /* 1640908 */     GIR_EraseRootFromParent_Done,
     /* 1640909 */   // Label 22600: @1640909
     /* 1640909 */   GIM_Try, /*On fail goto*//*Label 22601*/ GIMT_Encode4(1640995), // Rule ID 4436 //
     /* 1640914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1640925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1640928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1640931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640960 */     // MIs[0] policy
     /* 1640960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640970 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1640973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640994 */     // GIR_Coverage, 4436,
     /* 1640994 */     GIR_EraseRootFromParent_Done,
     /* 1640995 */   // Label 22601: @1640995
     /* 1640995 */   GIM_Try, /*On fail goto*//*Label 22602*/ GIMT_Encode4(1641081), // Rule ID 4437 //
     /* 1641000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1641011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1641014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1641017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641046 */     // MIs[0] policy
     /* 1641046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641056 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1641059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641080 */     // GIR_Coverage, 4437,
     /* 1641080 */     GIR_EraseRootFromParent_Done,
     /* 1641081 */   // Label 22602: @1641081
     /* 1641081 */   GIM_Try, /*On fail goto*//*Label 22603*/ GIMT_Encode4(1641167), // Rule ID 4440 //
     /* 1641086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1641097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1641100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1641103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1641109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641132 */     // MIs[0] policy
     /* 1641132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641142 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1641145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641166 */     // GIR_Coverage, 4440,
     /* 1641166 */     GIR_EraseRootFromParent_Done,
     /* 1641167 */   // Label 22603: @1641167
     /* 1641167 */   GIM_Try, /*On fail goto*//*Label 22604*/ GIMT_Encode4(1641253), // Rule ID 4441 //
     /* 1641172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1641183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1641186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1641189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1641195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641218 */     // MIs[0] policy
     /* 1641218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641228 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1641231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641252 */     // GIR_Coverage, 4441,
     /* 1641252 */     GIR_EraseRootFromParent_Done,
     /* 1641253 */   // Label 22604: @1641253
     /* 1641253 */   GIM_Try, /*On fail goto*//*Label 22605*/ GIMT_Encode4(1641339), // Rule ID 4444 //
     /* 1641258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1641269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1641272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1641275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1641281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641304 */     // MIs[0] policy
     /* 1641304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641314 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1641317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641338 */     // GIR_Coverage, 4444,
     /* 1641338 */     GIR_EraseRootFromParent_Done,
     /* 1641339 */   // Label 22605: @1641339
     /* 1641339 */   GIM_Try, /*On fail goto*//*Label 22606*/ GIMT_Encode4(1641425), // Rule ID 4445 //
     /* 1641344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1641355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1641358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1641361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1641367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641390 */     // MIs[0] policy
     /* 1641390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641400 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1641403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641424 */     // GIR_Coverage, 4445,
     /* 1641424 */     GIR_EraseRootFromParent_Done,
     /* 1641425 */   // Label 22606: @1641425
     /* 1641425 */   GIM_Try, /*On fail goto*//*Label 22607*/ GIMT_Encode4(1641511), // Rule ID 4448 //
     /* 1641430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1641441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1641444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1641447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641476 */     // MIs[0] policy
     /* 1641476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1641489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641510 */     // GIR_Coverage, 4448,
     /* 1641510 */     GIR_EraseRootFromParent_Done,
     /* 1641511 */   // Label 22607: @1641511
     /* 1641511 */   GIM_Try, /*On fail goto*//*Label 22608*/ GIMT_Encode4(1641597), // Rule ID 4449 //
     /* 1641516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1641527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1641530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1641533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641562 */     // MIs[0] policy
     /* 1641562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1641575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641596 */     // GIR_Coverage, 4449,
     /* 1641596 */     GIR_EraseRootFromParent_Done,
     /* 1641597 */   // Label 22608: @1641597
     /* 1641597 */   GIM_Try, /*On fail goto*//*Label 22609*/ GIMT_Encode4(1641683), // Rule ID 4452 //
     /* 1641602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1641613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1641616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1641619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641648 */     // MIs[0] policy
     /* 1641648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11688:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1641661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641682 */     // GIR_Coverage, 4452,
     /* 1641682 */     GIR_EraseRootFromParent_Done,
     /* 1641683 */   // Label 22609: @1641683
     /* 1641683 */   GIM_Try, /*On fail goto*//*Label 22610*/ GIMT_Encode4(1641769), // Rule ID 4453 //
     /* 1641688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1641699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1641702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1641705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641734 */     // MIs[0] policy
     /* 1641734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11688:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1641747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641768 */     // GIR_Coverage, 4453,
     /* 1641768 */     GIR_EraseRootFromParent_Done,
     /* 1641769 */   // Label 22610: @1641769
     /* 1641769 */   GIM_Try, /*On fail goto*//*Label 22611*/ GIMT_Encode4(1641855), // Rule ID 4456 //
     /* 1641774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1641785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1641788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1641791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641820 */     // MIs[0] policy
     /* 1641820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1641833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641854 */     // GIR_Coverage, 4456,
     /* 1641854 */     GIR_EraseRootFromParent_Done,
     /* 1641855 */   // Label 22611: @1641855
     /* 1641855 */   GIM_Try, /*On fail goto*//*Label 22612*/ GIMT_Encode4(1641941), // Rule ID 4457 //
     /* 1641860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1641871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1641874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1641877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641906 */     // MIs[0] policy
     /* 1641906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1641919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641940 */     // GIR_Coverage, 4457,
     /* 1641940 */     GIR_EraseRootFromParent_Done,
     /* 1641941 */   // Label 22612: @1641941
     /* 1641941 */   GIM_Try, /*On fail goto*//*Label 22613*/ GIMT_Encode4(1642027), // Rule ID 4460 //
     /* 1641946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1641957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1641960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1641963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641992 */     // MIs[0] policy
     /* 1641992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1642005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642026 */     // GIR_Coverage, 4460,
     /* 1642026 */     GIR_EraseRootFromParent_Done,
     /* 1642027 */   // Label 22613: @1642027
     /* 1642027 */   GIM_Try, /*On fail goto*//*Label 22614*/ GIMT_Encode4(1642113), // Rule ID 4461 //
     /* 1642032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1642043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1642046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1642049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642078 */     // MIs[0] policy
     /* 1642078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642088 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1642091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642112 */     // GIR_Coverage, 4461,
     /* 1642112 */     GIR_EraseRootFromParent_Done,
     /* 1642113 */   // Label 22614: @1642113
     /* 1642113 */   GIM_Try, /*On fail goto*//*Label 22615*/ GIMT_Encode4(1642199), // Rule ID 4464 //
     /* 1642118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1642129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1642132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1642135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642164 */     // MIs[0] policy
     /* 1642164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1642177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642198 */     // GIR_Coverage, 4464,
     /* 1642198 */     GIR_EraseRootFromParent_Done,
     /* 1642199 */   // Label 22615: @1642199
     /* 1642199 */   GIM_Try, /*On fail goto*//*Label 22616*/ GIMT_Encode4(1642285), // Rule ID 4465 //
     /* 1642204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1642215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1642218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1642221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642250 */     // MIs[0] policy
     /* 1642250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642260 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1642263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642284 */     // GIR_Coverage, 4465,
     /* 1642284 */     GIR_EraseRootFromParent_Done,
     /* 1642285 */   // Label 22616: @1642285
     /* 1642285 */   GIM_Try, /*On fail goto*//*Label 22617*/ GIMT_Encode4(1642371), // Rule ID 4468 //
     /* 1642290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1642301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1642304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1642307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642336 */     // MIs[0] policy
     /* 1642336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642346 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1642349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642370 */     // GIR_Coverage, 4468,
     /* 1642370 */     GIR_EraseRootFromParent_Done,
     /* 1642371 */   // Label 22617: @1642371
     /* 1642371 */   GIM_Try, /*On fail goto*//*Label 22618*/ GIMT_Encode4(1642457), // Rule ID 4469 //
     /* 1642376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1642379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1642387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1642390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1642393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642422 */     // MIs[0] policy
     /* 1642422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642432 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11688:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1642435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642456 */     // GIR_Coverage, 4469,
     /* 1642456 */     GIR_EraseRootFromParent_Done,
     /* 1642457 */   // Label 22618: @1642457
     /* 1642457 */   GIM_Try, /*On fail goto*//*Label 22619*/ GIMT_Encode4(1642543), // Rule ID 4472 //
     /* 1642462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1642473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1642476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1642479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642508 */     // MIs[0] policy
     /* 1642508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642518 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1642521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642542 */     // GIR_Coverage, 4472,
     /* 1642542 */     GIR_EraseRootFromParent_Done,
     /* 1642543 */   // Label 22619: @1642543
     /* 1642543 */   GIM_Try, /*On fail goto*//*Label 22620*/ GIMT_Encode4(1642629), // Rule ID 4473 //
     /* 1642548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1642551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1642559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1642562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1642565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642594 */     // MIs[0] policy
     /* 1642594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642604 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11688:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1642607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642628 */     // GIR_Coverage, 4473,
     /* 1642628 */     GIR_EraseRootFromParent_Done,
     /* 1642629 */   // Label 22620: @1642629
     /* 1642629 */   GIM_Try, /*On fail goto*//*Label 22621*/ GIMT_Encode4(1642715), // Rule ID 4476 //
     /* 1642634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1642645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1642648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1642651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642680 */     // MIs[0] policy
     /* 1642680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642690 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1642693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642714 */     // GIR_Coverage, 4476,
     /* 1642714 */     GIR_EraseRootFromParent_Done,
     /* 1642715 */   // Label 22621: @1642715
     /* 1642715 */   GIM_Try, /*On fail goto*//*Label 22622*/ GIMT_Encode4(1642801), // Rule ID 4477 //
     /* 1642720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1642723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1642731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1642734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1642737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642766 */     // MIs[0] policy
     /* 1642766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642776 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11688:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1642779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642800 */     // GIR_Coverage, 4477,
     /* 1642800 */     GIR_EraseRootFromParent_Done,
     /* 1642801 */   // Label 22622: @1642801
     /* 1642801 */   GIM_Try, /*On fail goto*//*Label 22623*/ GIMT_Encode4(1642887), // Rule ID 4480 //
     /* 1642806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1642817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1642820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1642823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642852 */     // MIs[0] policy
     /* 1642852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642862 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1642865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642886 */     // GIR_Coverage, 4480,
     /* 1642886 */     GIR_EraseRootFromParent_Done,
     /* 1642887 */   // Label 22623: @1642887
     /* 1642887 */   GIM_Try, /*On fail goto*//*Label 22624*/ GIMT_Encode4(1642973), // Rule ID 4481 //
     /* 1642892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1642895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1642903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1642906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1642909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642938 */     // MIs[0] policy
     /* 1642938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642948 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11688:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1642951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642972 */     // GIR_Coverage, 4481,
     /* 1642972 */     GIR_EraseRootFromParent_Done,
     /* 1642973 */   // Label 22624: @1642973
     /* 1642973 */   GIM_Try, /*On fail goto*//*Label 22625*/ GIMT_Encode4(1643059), // Rule ID 4490 //
     /* 1642978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1642989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1642992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1642995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1642998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643024 */     // MIs[0] policy
     /* 1643024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643034 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1643037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643058 */     // GIR_Coverage, 4490,
     /* 1643058 */     GIR_EraseRootFromParent_Done,
     /* 1643059 */   // Label 22625: @1643059
     /* 1643059 */   GIM_Try, /*On fail goto*//*Label 22626*/ GIMT_Encode4(1643145), // Rule ID 4491 //
     /* 1643064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1643075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1643078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1643081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1643084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643110 */     // MIs[0] policy
     /* 1643110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643120 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1643123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643144 */     // GIR_Coverage, 4491,
     /* 1643144 */     GIR_EraseRootFromParent_Done,
     /* 1643145 */   // Label 22626: @1643145
     /* 1643145 */   GIM_Try, /*On fail goto*//*Label 22627*/ GIMT_Encode4(1643231), // Rule ID 4500 //
     /* 1643150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1643161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1643164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1643167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1643170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643196 */     // MIs[0] policy
     /* 1643196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643206 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1643209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643230 */     // GIR_Coverage, 4500,
     /* 1643230 */     GIR_EraseRootFromParent_Done,
     /* 1643231 */   // Label 22627: @1643231
     /* 1643231 */   GIM_Try, /*On fail goto*//*Label 22628*/ GIMT_Encode4(1643317), // Rule ID 4501 //
     /* 1643236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1643247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1643250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1643253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1643256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643282 */     // MIs[0] policy
     /* 1643282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643292 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1643295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643316 */     // GIR_Coverage, 4501,
     /* 1643316 */     GIR_EraseRootFromParent_Done,
     /* 1643317 */   // Label 22628: @1643317
     /* 1643317 */   GIM_Try, /*On fail goto*//*Label 22629*/ GIMT_Encode4(1643403), // Rule ID 4510 //
     /* 1643322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1643333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1643336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1643339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1643342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643368 */     // MIs[0] policy
     /* 1643368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643378 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1643381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643402 */     // GIR_Coverage, 4510,
     /* 1643402 */     GIR_EraseRootFromParent_Done,
     /* 1643403 */   // Label 22629: @1643403
     /* 1643403 */   GIM_Try, /*On fail goto*//*Label 22630*/ GIMT_Encode4(1643489), // Rule ID 4511 //
     /* 1643408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1643419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1643422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1643425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1643428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643454 */     // MIs[0] policy
     /* 1643454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643464 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1643467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643488 */     // GIR_Coverage, 4511,
     /* 1643488 */     GIR_EraseRootFromParent_Done,
     /* 1643489 */   // Label 22630: @1643489
     /* 1643489 */   GIM_Try, /*On fail goto*//*Label 22631*/ GIMT_Encode4(1643575), // Rule ID 4520 //
     /* 1643494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1643505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1643508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1643511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1643514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643540 */     // MIs[0] policy
     /* 1643540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643550 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1643553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643574 */     // GIR_Coverage, 4520,
     /* 1643574 */     GIR_EraseRootFromParent_Done,
     /* 1643575 */   // Label 22631: @1643575
     /* 1643575 */   GIM_Try, /*On fail goto*//*Label 22632*/ GIMT_Encode4(1643661), // Rule ID 4521 //
     /* 1643580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1643591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1643594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1643597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1643600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643626 */     // MIs[0] policy
     /* 1643626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643636 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1643639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643660 */     // GIR_Coverage, 4521,
     /* 1643660 */     GIR_EraseRootFromParent_Done,
     /* 1643661 */   // Label 22632: @1643661
     /* 1643661 */   GIM_Try, /*On fail goto*//*Label 22633*/ GIMT_Encode4(1643747), // Rule ID 4530 //
     /* 1643666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1643677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1643680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1643683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1643686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1643689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643712 */     // MIs[0] policy
     /* 1643712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643722 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1643725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643746 */     // GIR_Coverage, 4530,
     /* 1643746 */     GIR_EraseRootFromParent_Done,
     /* 1643747 */   // Label 22633: @1643747
     /* 1643747 */   GIM_Try, /*On fail goto*//*Label 22634*/ GIMT_Encode4(1643833), // Rule ID 4531 //
     /* 1643752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1643763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1643766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1643769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1643772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1643775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643798 */     // MIs[0] policy
     /* 1643798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643808 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1643811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643832 */     // GIR_Coverage, 4531,
     /* 1643832 */     GIR_EraseRootFromParent_Done,
     /* 1643833 */   // Label 22634: @1643833
     /* 1643833 */   GIM_Try, /*On fail goto*//*Label 22635*/ GIMT_Encode4(1643919), // Rule ID 4540 //
     /* 1643838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1643849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1643852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1643855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1643858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1643861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643884 */     // MIs[0] policy
     /* 1643884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643894 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1643897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643918 */     // GIR_Coverage, 4540,
     /* 1643918 */     GIR_EraseRootFromParent_Done,
     /* 1643919 */   // Label 22635: @1643919
     /* 1643919 */   GIM_Try, /*On fail goto*//*Label 22636*/ GIMT_Encode4(1644005), // Rule ID 4541 //
     /* 1643924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1643935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1643938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1643941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1643944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1643947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643970 */     // MIs[0] policy
     /* 1643970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643980 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1643983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644004 */     // GIR_Coverage, 4541,
     /* 1644004 */     GIR_EraseRootFromParent_Done,
     /* 1644005 */   // Label 22636: @1644005
     /* 1644005 */   GIM_Try, /*On fail goto*//*Label 22637*/ GIMT_Encode4(1644091), // Rule ID 4550 //
     /* 1644010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1644021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1644024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1644027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1644030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644056 */     // MIs[0] policy
     /* 1644056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1644069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644090 */     // GIR_Coverage, 4550,
     /* 1644090 */     GIR_EraseRootFromParent_Done,
     /* 1644091 */   // Label 22637: @1644091
     /* 1644091 */   GIM_Try, /*On fail goto*//*Label 22638*/ GIMT_Encode4(1644177), // Rule ID 4551 //
     /* 1644096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1644107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1644110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1644113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1644116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644142 */     // MIs[0] policy
     /* 1644142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644152 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1644155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644176 */     // GIR_Coverage, 4551,
     /* 1644176 */     GIR_EraseRootFromParent_Done,
     /* 1644177 */   // Label 22638: @1644177
     /* 1644177 */   GIM_Try, /*On fail goto*//*Label 22639*/ GIMT_Encode4(1644263), // Rule ID 4560 //
     /* 1644182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1644193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1644196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1644199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1644202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644228 */     // MIs[0] policy
     /* 1644228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644238 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1644241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644262 */     // GIR_Coverage, 4560,
     /* 1644262 */     GIR_EraseRootFromParent_Done,
     /* 1644263 */   // Label 22639: @1644263
     /* 1644263 */   GIM_Try, /*On fail goto*//*Label 22640*/ GIMT_Encode4(1644349), // Rule ID 4561 //
     /* 1644268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1644279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1644282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1644285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1644288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644314 */     // MIs[0] policy
     /* 1644314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1644327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644348 */     // GIR_Coverage, 4561,
     /* 1644348 */     GIR_EraseRootFromParent_Done,
     /* 1644349 */   // Label 22640: @1644349
     /* 1644349 */   GIM_Try, /*On fail goto*//*Label 22641*/ GIMT_Encode4(1644435), // Rule ID 4570 //
     /* 1644354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1644365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1644368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1644371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1644374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644400 */     // MIs[0] policy
     /* 1644400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1644413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644434 */     // GIR_Coverage, 4570,
     /* 1644434 */     GIR_EraseRootFromParent_Done,
     /* 1644435 */   // Label 22641: @1644435
     /* 1644435 */   GIM_Try, /*On fail goto*//*Label 22642*/ GIMT_Encode4(1644521), // Rule ID 4571 //
     /* 1644440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1644451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1644454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1644457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1644460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644486 */     // MIs[0] policy
     /* 1644486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1644499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644520 */     // GIR_Coverage, 4571,
     /* 1644520 */     GIR_EraseRootFromParent_Done,
     /* 1644521 */   // Label 22642: @1644521
     /* 1644521 */   GIM_Try, /*On fail goto*//*Label 22643*/ GIMT_Encode4(1644607), // Rule ID 4580 //
     /* 1644526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1644537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1644540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1644543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1644546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644572 */     // MIs[0] policy
     /* 1644572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644582 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1644585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644606 */     // GIR_Coverage, 4580,
     /* 1644606 */     GIR_EraseRootFromParent_Done,
     /* 1644607 */   // Label 22643: @1644607
     /* 1644607 */   GIM_Try, /*On fail goto*//*Label 22644*/ GIMT_Encode4(1644693), // Rule ID 4581 //
     /* 1644612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1644623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1644626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1644629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1644632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644658 */     // MIs[0] policy
     /* 1644658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1644671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644692 */     // GIR_Coverage, 4581,
     /* 1644692 */     GIR_EraseRootFromParent_Done,
     /* 1644693 */   // Label 22644: @1644693
     /* 1644693 */   GIM_Try, /*On fail goto*//*Label 22645*/ GIMT_Encode4(1644779), // Rule ID 4590 //
     /* 1644698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1644709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1644712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1644715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1644718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644744 */     // MIs[0] policy
     /* 1644744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644754 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1644757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644778 */     // GIR_Coverage, 4590,
     /* 1644778 */     GIR_EraseRootFromParent_Done,
     /* 1644779 */   // Label 22645: @1644779
     /* 1644779 */   GIM_Try, /*On fail goto*//*Label 22646*/ GIMT_Encode4(1644865), // Rule ID 4591 //
     /* 1644784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1644795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1644798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1644801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1644804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644830 */     // MIs[0] policy
     /* 1644830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644840 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1644843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644864 */     // GIR_Coverage, 4591,
     /* 1644864 */     GIR_EraseRootFromParent_Done,
     /* 1644865 */   // Label 22646: @1644865
     /* 1644865 */   GIM_Try, /*On fail goto*//*Label 22647*/ GIMT_Encode4(1644951), // Rule ID 4600 //
     /* 1644870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1644873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1644881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1644884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1644887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1644890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644916 */     // MIs[0] policy
     /* 1644916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644926 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1644929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1644947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644950 */     // GIR_Coverage, 4600,
     /* 1644950 */     GIR_EraseRootFromParent_Done,
     /* 1644951 */   // Label 22647: @1644951
     /* 1644951 */   GIM_Try, /*On fail goto*//*Label 22648*/ GIMT_Encode4(1645037), // Rule ID 4601 //
     /* 1644956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1644959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1644967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1644970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1644973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1644976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645002 */     // MIs[0] policy
     /* 1645002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645012 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1645015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645036 */     // GIR_Coverage, 4601,
     /* 1645036 */     GIR_EraseRootFromParent_Done,
     /* 1645037 */   // Label 22648: @1645037
     /* 1645037 */   GIM_Try, /*On fail goto*//*Label 22649*/ GIMT_Encode4(1645123), // Rule ID 4610 //
     /* 1645042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1645053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1645056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1645059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1645062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645088 */     // MIs[0] policy
     /* 1645088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645098 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1645101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645122 */     // GIR_Coverage, 4610,
     /* 1645122 */     GIR_EraseRootFromParent_Done,
     /* 1645123 */   // Label 22649: @1645123
     /* 1645123 */   GIM_Try, /*On fail goto*//*Label 22650*/ GIMT_Encode4(1645209), // Rule ID 4611 //
     /* 1645128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1645139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1645142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1645145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1645148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645174 */     // MIs[0] policy
     /* 1645174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1645187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645208 */     // GIR_Coverage, 4611,
     /* 1645208 */     GIR_EraseRootFromParent_Done,
     /* 1645209 */   // Label 22650: @1645209
     /* 1645209 */   GIM_Try, /*On fail goto*//*Label 22651*/ GIMT_Encode4(1645295), // Rule ID 4620 //
     /* 1645214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1645225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1645228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1645231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1645234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645260 */     // MIs[0] policy
     /* 1645260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645270 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1645273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645294 */     // GIR_Coverage, 4620,
     /* 1645294 */     GIR_EraseRootFromParent_Done,
     /* 1645295 */   // Label 22651: @1645295
     /* 1645295 */   GIM_Try, /*On fail goto*//*Label 22652*/ GIMT_Encode4(1645381), // Rule ID 4621 //
     /* 1645300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1645311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1645314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1645317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1645320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645346 */     // MIs[0] policy
     /* 1645346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645356 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1645359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645380 */     // GIR_Coverage, 4621,
     /* 1645380 */     GIR_EraseRootFromParent_Done,
     /* 1645381 */   // Label 22652: @1645381
     /* 1645381 */   GIM_Try, /*On fail goto*//*Label 22653*/ GIMT_Encode4(1645467), // Rule ID 4630 //
     /* 1645386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1645397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1645400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1645403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1645406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645432 */     // MIs[0] policy
     /* 1645432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645442 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1645445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645466 */     // GIR_Coverage, 4630,
     /* 1645466 */     GIR_EraseRootFromParent_Done,
     /* 1645467 */   // Label 22653: @1645467
     /* 1645467 */   GIM_Try, /*On fail goto*//*Label 22654*/ GIMT_Encode4(1645553), // Rule ID 4631 //
     /* 1645472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1645483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1645486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1645489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1645492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645518 */     // MIs[0] policy
     /* 1645518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645528 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1645531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645552 */     // GIR_Coverage, 4631,
     /* 1645552 */     GIR_EraseRootFromParent_Done,
     /* 1645553 */   // Label 22654: @1645553
     /* 1645553 */   GIM_Try, /*On fail goto*//*Label 22655*/ GIMT_Encode4(1645639), // Rule ID 4634 //
     /* 1645558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1645569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1645572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1645575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645604 */     // MIs[0] policy
     /* 1645604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645614 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1645617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645638 */     // GIR_Coverage, 4634,
     /* 1645638 */     GIR_EraseRootFromParent_Done,
     /* 1645639 */   // Label 22655: @1645639
     /* 1645639 */   GIM_Try, /*On fail goto*//*Label 22656*/ GIMT_Encode4(1645725), // Rule ID 4635 //
     /* 1645644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1645655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1645658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1645661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645690 */     // MIs[0] policy
     /* 1645690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645700 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1645703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645724 */     // GIR_Coverage, 4635,
     /* 1645724 */     GIR_EraseRootFromParent_Done,
     /* 1645725 */   // Label 22656: @1645725
     /* 1645725 */   GIM_Try, /*On fail goto*//*Label 22657*/ GIMT_Encode4(1645811), // Rule ID 4638 //
     /* 1645730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1645741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1645744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1645747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645776 */     // MIs[0] policy
     /* 1645776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645786 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1645789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645810 */     // GIR_Coverage, 4638,
     /* 1645810 */     GIR_EraseRootFromParent_Done,
     /* 1645811 */   // Label 22657: @1645811
     /* 1645811 */   GIM_Try, /*On fail goto*//*Label 22658*/ GIMT_Encode4(1645897), // Rule ID 4639 //
     /* 1645816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1645827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1645830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1645833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645862 */     // MIs[0] policy
     /* 1645862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645872 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1645875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645896 */     // GIR_Coverage, 4639,
     /* 1645896 */     GIR_EraseRootFromParent_Done,
     /* 1645897 */   // Label 22658: @1645897
     /* 1645897 */   GIM_Try, /*On fail goto*//*Label 22659*/ GIMT_Encode4(1645983), // Rule ID 4642 //
     /* 1645902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1645913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1645916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1645919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645948 */     // MIs[0] policy
     /* 1645948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645958 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1645961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645982 */     // GIR_Coverage, 4642,
     /* 1645982 */     GIR_EraseRootFromParent_Done,
     /* 1645983 */   // Label 22659: @1645983
     /* 1645983 */   GIM_Try, /*On fail goto*//*Label 22660*/ GIMT_Encode4(1646069), // Rule ID 4643 //
     /* 1645988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1645999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1646002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1646005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646034 */     // MIs[0] policy
     /* 1646034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646044 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1646047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646068 */     // GIR_Coverage, 4643,
     /* 1646068 */     GIR_EraseRootFromParent_Done,
     /* 1646069 */   // Label 22660: @1646069
     /* 1646069 */   GIM_Try, /*On fail goto*//*Label 22661*/ GIMT_Encode4(1646155), // Rule ID 4646 //
     /* 1646074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1646085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1646088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1646091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646120 */     // MIs[0] policy
     /* 1646120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1646133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646154 */     // GIR_Coverage, 4646,
     /* 1646154 */     GIR_EraseRootFromParent_Done,
     /* 1646155 */   // Label 22661: @1646155
     /* 1646155 */   GIM_Try, /*On fail goto*//*Label 22662*/ GIMT_Encode4(1646241), // Rule ID 4647 //
     /* 1646160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1646171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1646174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1646177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646206 */     // MIs[0] policy
     /* 1646206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1646219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646240 */     // GIR_Coverage, 4647,
     /* 1646240 */     GIR_EraseRootFromParent_Done,
     /* 1646241 */   // Label 22662: @1646241
     /* 1646241 */   GIM_Try, /*On fail goto*//*Label 22663*/ GIMT_Encode4(1646327), // Rule ID 4650 //
     /* 1646246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1646257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1646260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1646263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1646269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646292 */     // MIs[0] policy
     /* 1646292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646302 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1646305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646326 */     // GIR_Coverage, 4650,
     /* 1646326 */     GIR_EraseRootFromParent_Done,
     /* 1646327 */   // Label 22663: @1646327
     /* 1646327 */   GIM_Try, /*On fail goto*//*Label 22664*/ GIMT_Encode4(1646413), // Rule ID 4651 //
     /* 1646332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1646343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1646346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1646349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1646355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646378 */     // MIs[0] policy
     /* 1646378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646388 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1646391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646412 */     // GIR_Coverage, 4651,
     /* 1646412 */     GIR_EraseRootFromParent_Done,
     /* 1646413 */   // Label 22664: @1646413
     /* 1646413 */   GIM_Try, /*On fail goto*//*Label 22665*/ GIMT_Encode4(1646499), // Rule ID 4654 //
     /* 1646418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1646429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1646432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1646435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1646441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646464 */     // MIs[0] policy
     /* 1646464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646474 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1646477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646498 */     // GIR_Coverage, 4654,
     /* 1646498 */     GIR_EraseRootFromParent_Done,
     /* 1646499 */   // Label 22665: @1646499
     /* 1646499 */   GIM_Try, /*On fail goto*//*Label 22666*/ GIMT_Encode4(1646585), // Rule ID 4655 //
     /* 1646504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1646515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1646518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1646521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1646527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646550 */     // MIs[0] policy
     /* 1646550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646560 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1646563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646584 */     // GIR_Coverage, 4655,
     /* 1646584 */     GIR_EraseRootFromParent_Done,
     /* 1646585 */   // Label 22666: @1646585
     /* 1646585 */   GIM_Try, /*On fail goto*//*Label 22667*/ GIMT_Encode4(1646671), // Rule ID 4658 //
     /* 1646590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1646601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1646604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1646607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646636 */     // MIs[0] policy
     /* 1646636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1646649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1646667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646670 */     // GIR_Coverage, 4658,
     /* 1646670 */     GIR_EraseRootFromParent_Done,
     /* 1646671 */   // Label 22667: @1646671
     /* 1646671 */   GIM_Try, /*On fail goto*//*Label 22668*/ GIMT_Encode4(1646757), // Rule ID 4659 //
     /* 1646676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1646687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1646690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1646693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646722 */     // MIs[0] policy
     /* 1646722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1646735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1646753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646756 */     // GIR_Coverage, 4659,
     /* 1646756 */     GIR_EraseRootFromParent_Done,
     /* 1646757 */   // Label 22668: @1646757
     /* 1646757 */   GIM_Try, /*On fail goto*//*Label 22669*/ GIMT_Encode4(1646843), // Rule ID 4662 //
     /* 1646762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1646773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1646776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1646779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646808 */     // MIs[0] policy
     /* 1646808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1646821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1646839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646842 */     // GIR_Coverage, 4662,
     /* 1646842 */     GIR_EraseRootFromParent_Done,
     /* 1646843 */   // Label 22669: @1646843
     /* 1646843 */   GIM_Try, /*On fail goto*//*Label 22670*/ GIMT_Encode4(1646929), // Rule ID 4663 //
     /* 1646848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1646859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1646862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1646865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646894 */     // MIs[0] policy
     /* 1646894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1646907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1646925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646928 */     // GIR_Coverage, 4663,
     /* 1646928 */     GIR_EraseRootFromParent_Done,
     /* 1646929 */   // Label 22670: @1646929
     /* 1646929 */   GIM_Try, /*On fail goto*//*Label 22671*/ GIMT_Encode4(1647015), // Rule ID 4666 //
     /* 1646934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1646945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1646948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1646951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646980 */     // MIs[0] policy
     /* 1646980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1646993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647014 */     // GIR_Coverage, 4666,
     /* 1647014 */     GIR_EraseRootFromParent_Done,
     /* 1647015 */   // Label 22671: @1647015
     /* 1647015 */   GIM_Try, /*On fail goto*//*Label 22672*/ GIMT_Encode4(1647101), // Rule ID 4667 //
     /* 1647020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1647031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1647034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1647037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647066 */     // MIs[0] policy
     /* 1647066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1647079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647100 */     // GIR_Coverage, 4667,
     /* 1647100 */     GIR_EraseRootFromParent_Done,
     /* 1647101 */   // Label 22672: @1647101
     /* 1647101 */   GIM_Try, /*On fail goto*//*Label 22673*/ GIMT_Encode4(1647187), // Rule ID 4670 //
     /* 1647106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1647117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1647120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1647123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647152 */     // MIs[0] policy
     /* 1647152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647162 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1647165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647186 */     // GIR_Coverage, 4670,
     /* 1647186 */     GIR_EraseRootFromParent_Done,
     /* 1647187 */   // Label 22673: @1647187
     /* 1647187 */   GIM_Try, /*On fail goto*//*Label 22674*/ GIMT_Encode4(1647273), // Rule ID 4671 //
     /* 1647192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1647203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1647206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1647209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647238 */     // MIs[0] policy
     /* 1647238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1647251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647272 */     // GIR_Coverage, 4671,
     /* 1647272 */     GIR_EraseRootFromParent_Done,
     /* 1647273 */   // Label 22674: @1647273
     /* 1647273 */   GIM_Try, /*On fail goto*//*Label 22675*/ GIMT_Encode4(1647359), // Rule ID 4674 //
     /* 1647278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1647289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1647292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1647295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1647301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647324 */     // MIs[0] policy
     /* 1647324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1647337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647358 */     // GIR_Coverage, 4674,
     /* 1647358 */     GIR_EraseRootFromParent_Done,
     /* 1647359 */   // Label 22675: @1647359
     /* 1647359 */   GIM_Try, /*On fail goto*//*Label 22676*/ GIMT_Encode4(1647445), // Rule ID 4675 //
     /* 1647364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1647375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1647378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1647381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1647387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647410 */     // MIs[0] policy
     /* 1647410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647420 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1647423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647444 */     // GIR_Coverage, 4675,
     /* 1647444 */     GIR_EraseRootFromParent_Done,
     /* 1647445 */   // Label 22676: @1647445
     /* 1647445 */   GIM_Try, /*On fail goto*//*Label 22677*/ GIMT_Encode4(1647531), // Rule ID 4678 //
     /* 1647450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1647453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1647461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1647464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1647467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647496 */     // MIs[0] policy
     /* 1647496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647506 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1647509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647530 */     // GIR_Coverage, 4678,
     /* 1647530 */     GIR_EraseRootFromParent_Done,
     /* 1647531 */   // Label 22677: @1647531
     /* 1647531 */   GIM_Try, /*On fail goto*//*Label 22678*/ GIMT_Encode4(1647617), // Rule ID 4679 //
     /* 1647536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1647539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1647547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1647550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1647553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647582 */     // MIs[0] policy
     /* 1647582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647592 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1647595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647616 */     // GIR_Coverage, 4679,
     /* 1647616 */     GIR_EraseRootFromParent_Done,
     /* 1647617 */   // Label 22678: @1647617
     /* 1647617 */   GIM_Try, /*On fail goto*//*Label 22679*/ GIMT_Encode4(1647703), // Rule ID 4682 //
     /* 1647622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1647625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1647633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1647636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1647639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647668 */     // MIs[0] policy
     /* 1647668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1647681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647702 */     // GIR_Coverage, 4682,
     /* 1647702 */     GIR_EraseRootFromParent_Done,
     /* 1647703 */   // Label 22679: @1647703
     /* 1647703 */   GIM_Try, /*On fail goto*//*Label 22680*/ GIMT_Encode4(1647789), // Rule ID 4683 //
     /* 1647708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1647711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1647719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1647722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1647725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647754 */     // MIs[0] policy
     /* 1647754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1647767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647788 */     // GIR_Coverage, 4683,
     /* 1647788 */     GIR_EraseRootFromParent_Done,
     /* 1647789 */   // Label 22680: @1647789
     /* 1647789 */   GIM_Try, /*On fail goto*//*Label 22681*/ GIMT_Encode4(1647875), // Rule ID 4686 //
     /* 1647794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1647797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1647805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1647808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1647811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647840 */     // MIs[0] policy
     /* 1647840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647850 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1647853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647874 */     // GIR_Coverage, 4686,
     /* 1647874 */     GIR_EraseRootFromParent_Done,
     /* 1647875 */   // Label 22681: @1647875
     /* 1647875 */   GIM_Try, /*On fail goto*//*Label 22682*/ GIMT_Encode4(1647961), // Rule ID 4687 //
     /* 1647880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1647883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1647891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1647894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1647897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647926 */     // MIs[0] policy
     /* 1647926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647936 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1647939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647960 */     // GIR_Coverage, 4687,
     /* 1647960 */     GIR_EraseRootFromParent_Done,
     /* 1647961 */   // Label 22682: @1647961
     /* 1647961 */   GIM_Try, /*On fail goto*//*Label 22683*/ GIMT_Encode4(1648047), // Rule ID 4690 //
     /* 1647966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1647969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1647977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1647980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1647983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648012 */     // MIs[0] policy
     /* 1648012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648022 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1648025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648046 */     // GIR_Coverage, 4690,
     /* 1648046 */     GIR_EraseRootFromParent_Done,
     /* 1648047 */   // Label 22683: @1648047
     /* 1648047 */   GIM_Try, /*On fail goto*//*Label 22684*/ GIMT_Encode4(1648133), // Rule ID 4691 //
     /* 1648052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1648063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1648066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1648069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1648072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648098 */     // MIs[0] policy
     /* 1648098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648108 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1648111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648132 */     // GIR_Coverage, 4691,
     /* 1648132 */     GIR_EraseRootFromParent_Done,
     /* 1648133 */   // Label 22684: @1648133
     /* 1648133 */   GIM_Try, /*On fail goto*//*Label 22685*/ GIMT_Encode4(1648219), // Rule ID 4700 //
     /* 1648138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1648149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1648152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1648155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1648158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648184 */     // MIs[0] policy
     /* 1648184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1648197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648218 */     // GIR_Coverage, 4700,
     /* 1648218 */     GIR_EraseRootFromParent_Done,
     /* 1648219 */   // Label 22685: @1648219
     /* 1648219 */   GIM_Try, /*On fail goto*//*Label 22686*/ GIMT_Encode4(1648305), // Rule ID 4701 //
     /* 1648224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1648235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1648238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1648241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1648244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648270 */     // MIs[0] policy
     /* 1648270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648280 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1648283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648304 */     // GIR_Coverage, 4701,
     /* 1648304 */     GIR_EraseRootFromParent_Done,
     /* 1648305 */   // Label 22686: @1648305
     /* 1648305 */   GIM_Try, /*On fail goto*//*Label 22687*/ GIMT_Encode4(1648391), // Rule ID 4710 //
     /* 1648310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1648321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1648324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1648327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1648330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648356 */     // MIs[0] policy
     /* 1648356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1648369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648390 */     // GIR_Coverage, 4710,
     /* 1648390 */     GIR_EraseRootFromParent_Done,
     /* 1648391 */   // Label 22687: @1648391
     /* 1648391 */   GIM_Try, /*On fail goto*//*Label 22688*/ GIMT_Encode4(1648477), // Rule ID 4711 //
     /* 1648396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1648407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1648410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1648413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1648416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648442 */     // MIs[0] policy
     /* 1648442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648452 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1648455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648476 */     // GIR_Coverage, 4711,
     /* 1648476 */     GIR_EraseRootFromParent_Done,
     /* 1648477 */   // Label 22688: @1648477
     /* 1648477 */   GIM_Try, /*On fail goto*//*Label 22689*/ GIMT_Encode4(1648563), // Rule ID 4720 //
     /* 1648482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1648493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1648496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1648499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1648502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648528 */     // MIs[0] policy
     /* 1648528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648538 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1648541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648562 */     // GIR_Coverage, 4720,
     /* 1648562 */     GIR_EraseRootFromParent_Done,
     /* 1648563 */   // Label 22689: @1648563
     /* 1648563 */   GIM_Try, /*On fail goto*//*Label 22690*/ GIMT_Encode4(1648649), // Rule ID 4721 //
     /* 1648568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1648579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1648582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1648585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1648588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648614 */     // MIs[0] policy
     /* 1648614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1648627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648648 */     // GIR_Coverage, 4721,
     /* 1648648 */     GIR_EraseRootFromParent_Done,
     /* 1648649 */   // Label 22690: @1648649
     /* 1648649 */   GIM_Try, /*On fail goto*//*Label 22691*/ GIMT_Encode4(1648735), // Rule ID 4730 //
     /* 1648654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1648665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1648668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1648671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1648674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648700 */     // MIs[0] policy
     /* 1648700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648710 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1648713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648734 */     // GIR_Coverage, 4730,
     /* 1648734 */     GIR_EraseRootFromParent_Done,
     /* 1648735 */   // Label 22691: @1648735
     /* 1648735 */   GIM_Try, /*On fail goto*//*Label 22692*/ GIMT_Encode4(1648821), // Rule ID 4731 //
     /* 1648740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1648751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1648754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1648757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1648760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648786 */     // MIs[0] policy
     /* 1648786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1648799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648820 */     // GIR_Coverage, 4731,
     /* 1648820 */     GIR_EraseRootFromParent_Done,
     /* 1648821 */   // Label 22692: @1648821
     /* 1648821 */   GIM_Try, /*On fail goto*//*Label 22693*/ GIMT_Encode4(1648907), // Rule ID 4740 //
     /* 1648826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1648837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1648840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1648843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1648846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1648849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648872 */     // MIs[0] policy
     /* 1648872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648882 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1648885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648906 */     // GIR_Coverage, 4740,
     /* 1648906 */     GIR_EraseRootFromParent_Done,
     /* 1648907 */   // Label 22693: @1648907
     /* 1648907 */   GIM_Try, /*On fail goto*//*Label 22694*/ GIMT_Encode4(1648993), // Rule ID 4741 //
     /* 1648912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1648923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1648926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1648929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1648932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1648935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648958 */     // MIs[0] policy
     /* 1648958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648968 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1648971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648992 */     // GIR_Coverage, 4741,
     /* 1648992 */     GIR_EraseRootFromParent_Done,
     /* 1648993 */   // Label 22694: @1648993
     /* 1648993 */   GIM_Try, /*On fail goto*//*Label 22695*/ GIMT_Encode4(1649079), // Rule ID 4750 //
     /* 1648998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1649009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1649012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1649015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1649018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1649021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649044 */     // MIs[0] policy
     /* 1649044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649054 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1649057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649078 */     // GIR_Coverage, 4750,
     /* 1649078 */     GIR_EraseRootFromParent_Done,
     /* 1649079 */   // Label 22695: @1649079
     /* 1649079 */   GIM_Try, /*On fail goto*//*Label 22696*/ GIMT_Encode4(1649165), // Rule ID 4751 //
     /* 1649084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1649095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1649098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1649101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1649104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1649107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649130 */     // MIs[0] policy
     /* 1649130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649140 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1649143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649164 */     // GIR_Coverage, 4751,
     /* 1649164 */     GIR_EraseRootFromParent_Done,
     /* 1649165 */   // Label 22696: @1649165
     /* 1649165 */   GIM_Try, /*On fail goto*//*Label 22697*/ GIMT_Encode4(1649251), // Rule ID 4760 //
     /* 1649170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1649181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1649184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1649187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1649190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649216 */     // MIs[0] policy
     /* 1649216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649226 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1649229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649250 */     // GIR_Coverage, 4760,
     /* 1649250 */     GIR_EraseRootFromParent_Done,
     /* 1649251 */   // Label 22697: @1649251
     /* 1649251 */   GIM_Try, /*On fail goto*//*Label 22698*/ GIMT_Encode4(1649337), // Rule ID 4761 //
     /* 1649256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1649267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1649270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1649273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1649276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649302 */     // MIs[0] policy
     /* 1649302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649312 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1649315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649336 */     // GIR_Coverage, 4761,
     /* 1649336 */     GIR_EraseRootFromParent_Done,
     /* 1649337 */   // Label 22698: @1649337
     /* 1649337 */   GIM_Try, /*On fail goto*//*Label 22699*/ GIMT_Encode4(1649423), // Rule ID 4770 //
     /* 1649342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1649353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1649356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1649359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1649362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649388 */     // MIs[0] policy
     /* 1649388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649398 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11684:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1649401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649422 */     // GIR_Coverage, 4770,
     /* 1649422 */     GIR_EraseRootFromParent_Done,
     /* 1649423 */   // Label 22699: @1649423
     /* 1649423 */   GIM_Try, /*On fail goto*//*Label 22700*/ GIMT_Encode4(1649509), // Rule ID 4771 //
     /* 1649428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1649439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1649442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1649445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1649448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649474 */     // MIs[0] policy
     /* 1649474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11684:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1649487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649508 */     // GIR_Coverage, 4771,
     /* 1649508 */     GIR_EraseRootFromParent_Done,
     /* 1649509 */   // Label 22700: @1649509
     /* 1649509 */   GIM_Try, /*On fail goto*//*Label 22701*/ GIMT_Encode4(1649595), // Rule ID 4780 //
     /* 1649514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1649525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1649528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1649531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1649534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649560 */     // MIs[0] policy
     /* 1649560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1649573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649594 */     // GIR_Coverage, 4780,
     /* 1649594 */     GIR_EraseRootFromParent_Done,
     /* 1649595 */   // Label 22701: @1649595
     /* 1649595 */   GIM_Try, /*On fail goto*//*Label 22702*/ GIMT_Encode4(1649681), // Rule ID 4781 //
     /* 1649600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1649611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1649614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1649617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1649620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649646 */     // MIs[0] policy
     /* 1649646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1649659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649680 */     // GIR_Coverage, 4781,
     /* 1649680 */     GIR_EraseRootFromParent_Done,
     /* 1649681 */   // Label 22702: @1649681
     /* 1649681 */   GIM_Try, /*On fail goto*//*Label 22703*/ GIMT_Encode4(1649767), // Rule ID 4790 //
     /* 1649686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1649697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1649700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1649703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1649706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649732 */     // MIs[0] policy
     /* 1649732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649742 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1649745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649766 */     // GIR_Coverage, 4790,
     /* 1649766 */     GIR_EraseRootFromParent_Done,
     /* 1649767 */   // Label 22703: @1649767
     /* 1649767 */   GIM_Try, /*On fail goto*//*Label 22704*/ GIMT_Encode4(1649853), // Rule ID 4791 //
     /* 1649772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1649783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1649786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1649789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1649792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649818 */     // MIs[0] policy
     /* 1649818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649828 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1649831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649852 */     // GIR_Coverage, 4791,
     /* 1649852 */     GIR_EraseRootFromParent_Done,
     /* 1649853 */   // Label 22704: @1649853
     /* 1649853 */   GIM_Try, /*On fail goto*//*Label 22705*/ GIMT_Encode4(1649939), // Rule ID 4800 //
     /* 1649858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1649869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1649872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1649875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1649878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649904 */     // MIs[0] policy
     /* 1649904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1649917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649938 */     // GIR_Coverage, 4800,
     /* 1649938 */     GIR_EraseRootFromParent_Done,
     /* 1649939 */   // Label 22705: @1649939
     /* 1649939 */   GIM_Try, /*On fail goto*//*Label 22706*/ GIMT_Encode4(1650025), // Rule ID 4801 //
     /* 1649944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1649955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1649958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1649961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1649964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649990 */     // MIs[0] policy
     /* 1649990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650000 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1650003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650024 */     // GIR_Coverage, 4801,
     /* 1650024 */     GIR_EraseRootFromParent_Done,
     /* 1650025 */   // Label 22706: @1650025
     /* 1650025 */   GIM_Try, /*On fail goto*//*Label 22707*/ GIMT_Encode4(1650111), // Rule ID 4810 //
     /* 1650030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1650041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1650044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1650047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1650050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650076 */     // MIs[0] policy
     /* 1650076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1650089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650110 */     // GIR_Coverage, 4810,
     /* 1650110 */     GIR_EraseRootFromParent_Done,
     /* 1650111 */   // Label 22707: @1650111
     /* 1650111 */   GIM_Try, /*On fail goto*//*Label 22708*/ GIMT_Encode4(1650197), // Rule ID 4811 //
     /* 1650116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1650127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1650130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1650133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1650136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650162 */     // MIs[0] policy
     /* 1650162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650172 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1650175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650196 */     // GIR_Coverage, 4811,
     /* 1650196 */     GIR_EraseRootFromParent_Done,
     /* 1650197 */   // Label 22708: @1650197
     /* 1650197 */   GIM_Try, /*On fail goto*//*Label 22709*/ GIMT_Encode4(1650283), // Rule ID 4820 //
     /* 1650202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1650213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1650216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1650219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1650222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650248 */     // MIs[0] policy
     /* 1650248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1650261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650282 */     // GIR_Coverage, 4820,
     /* 1650282 */     GIR_EraseRootFromParent_Done,
     /* 1650283 */   // Label 22709: @1650283
     /* 1650283 */   GIM_Try, /*On fail goto*//*Label 22710*/ GIMT_Encode4(1650369), // Rule ID 4821 //
     /* 1650288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1650299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1650302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1650305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1650308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650334 */     // MIs[0] policy
     /* 1650334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650344 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1650347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650368 */     // GIR_Coverage, 4821,
     /* 1650368 */     GIR_EraseRootFromParent_Done,
     /* 1650369 */   // Label 22710: @1650369
     /* 1650369 */   GIM_Try, /*On fail goto*//*Label 22711*/ GIMT_Encode4(1650455), // Rule ID 4830 //
     /* 1650374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1650385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1650388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1650391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1650394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650420 */     // MIs[0] policy
     /* 1650420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650430 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1650433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650454 */     // GIR_Coverage, 4830,
     /* 1650454 */     GIR_EraseRootFromParent_Done,
     /* 1650455 */   // Label 22711: @1650455
     /* 1650455 */   GIM_Try, /*On fail goto*//*Label 22712*/ GIMT_Encode4(1650541), // Rule ID 4831 //
     /* 1650460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1650471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1650474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1650477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1650480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650506 */     // MIs[0] policy
     /* 1650506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650516 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1650519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650540 */     // GIR_Coverage, 4831,
     /* 1650540 */     GIR_EraseRootFromParent_Done,
     /* 1650541 */   // Label 22712: @1650541
     /* 1650541 */   GIM_Try, /*On fail goto*//*Label 22713*/ GIMT_Encode4(1650627), // Rule ID 4840 //
     /* 1650546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1650557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1650560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1650563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1650566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650592 */     // MIs[0] policy
     /* 1650592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1650605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650626 */     // GIR_Coverage, 4840,
     /* 1650626 */     GIR_EraseRootFromParent_Done,
     /* 1650627 */   // Label 22713: @1650627
     /* 1650627 */   GIM_Try, /*On fail goto*//*Label 22714*/ GIMT_Encode4(1650713), // Rule ID 4841 //
     /* 1650632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1650643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1650646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1650649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1650652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650678 */     // MIs[0] policy
     /* 1650678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650688 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1650691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650712 */     // GIR_Coverage, 4841,
     /* 1650712 */     GIR_EraseRootFromParent_Done,
     /* 1650713 */   // Label 22714: @1650713
     /* 1650713 */   GIM_Try, /*On fail goto*//*Label 22715*/ GIMT_Encode4(1650799), // Rule ID 4844 //
     /* 1650718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1650729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1650732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1650735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650764 */     // MIs[0] policy
     /* 1650764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650774 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1650777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650798 */     // GIR_Coverage, 4844,
     /* 1650798 */     GIR_EraseRootFromParent_Done,
     /* 1650799 */   // Label 22715: @1650799
     /* 1650799 */   GIM_Try, /*On fail goto*//*Label 22716*/ GIMT_Encode4(1650885), // Rule ID 4845 //
     /* 1650804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1650815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1650818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1650821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650850 */     // MIs[0] policy
     /* 1650850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650860 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1650863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650884 */     // GIR_Coverage, 4845,
     /* 1650884 */     GIR_EraseRootFromParent_Done,
     /* 1650885 */   // Label 22716: @1650885
     /* 1650885 */   GIM_Try, /*On fail goto*//*Label 22717*/ GIMT_Encode4(1650971), // Rule ID 4848 //
     /* 1650890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1650901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1650904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1650907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650936 */     // MIs[0] policy
     /* 1650936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650946 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1650949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650970 */     // GIR_Coverage, 4848,
     /* 1650970 */     GIR_EraseRootFromParent_Done,
     /* 1650971 */   // Label 22717: @1650971
     /* 1650971 */   GIM_Try, /*On fail goto*//*Label 22718*/ GIMT_Encode4(1651057), // Rule ID 4849 //
     /* 1650976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1650987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1650990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1650993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651022 */     // MIs[0] policy
     /* 1651022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651032 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1651035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651056 */     // GIR_Coverage, 4849,
     /* 1651056 */     GIR_EraseRootFromParent_Done,
     /* 1651057 */   // Label 22718: @1651057
     /* 1651057 */   GIM_Try, /*On fail goto*//*Label 22719*/ GIMT_Encode4(1651143), // Rule ID 4852 //
     /* 1651062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1651073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1651076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1651079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651108 */     // MIs[0] policy
     /* 1651108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651118 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1651121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651142 */     // GIR_Coverage, 4852,
     /* 1651142 */     GIR_EraseRootFromParent_Done,
     /* 1651143 */   // Label 22719: @1651143
     /* 1651143 */   GIM_Try, /*On fail goto*//*Label 22720*/ GIMT_Encode4(1651229), // Rule ID 4853 //
     /* 1651148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1651159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1651162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1651165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651194 */     // MIs[0] policy
     /* 1651194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651204 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11684:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1651207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651228 */     // GIR_Coverage, 4853,
     /* 1651228 */     GIR_EraseRootFromParent_Done,
     /* 1651229 */   // Label 22720: @1651229
     /* 1651229 */   GIM_Try, /*On fail goto*//*Label 22721*/ GIMT_Encode4(1651315), // Rule ID 4856 //
     /* 1651234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1651245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1651248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1651251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651280 */     // MIs[0] policy
     /* 1651280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651290 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1651293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651314 */     // GIR_Coverage, 4856,
     /* 1651314 */     GIR_EraseRootFromParent_Done,
     /* 1651315 */   // Label 22721: @1651315
     /* 1651315 */   GIM_Try, /*On fail goto*//*Label 22722*/ GIMT_Encode4(1651401), // Rule ID 4857 //
     /* 1651320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1651331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1651334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1651337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651366 */     // MIs[0] policy
     /* 1651366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651376 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1651379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651400 */     // GIR_Coverage, 4857,
     /* 1651400 */     GIR_EraseRootFromParent_Done,
     /* 1651401 */   // Label 22722: @1651401
     /* 1651401 */   GIM_Try, /*On fail goto*//*Label 22723*/ GIMT_Encode4(1651487), // Rule ID 4860 //
     /* 1651406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1651417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1651420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1651423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651452 */     // MIs[0] policy
     /* 1651452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651462 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1651465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651486 */     // GIR_Coverage, 4860,
     /* 1651486 */     GIR_EraseRootFromParent_Done,
     /* 1651487 */   // Label 22723: @1651487
     /* 1651487 */   GIM_Try, /*On fail goto*//*Label 22724*/ GIMT_Encode4(1651573), // Rule ID 4861 //
     /* 1651492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1651503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1651506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1651509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651538 */     // MIs[0] policy
     /* 1651538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651548 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1651551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651572 */     // GIR_Coverage, 4861,
     /* 1651572 */     GIR_EraseRootFromParent_Done,
     /* 1651573 */   // Label 22724: @1651573
     /* 1651573 */   GIM_Try, /*On fail goto*//*Label 22725*/ GIMT_Encode4(1651659), // Rule ID 4864 //
     /* 1651578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1651589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1651592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1651595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1651601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651624 */     // MIs[0] policy
     /* 1651624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651634 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1651637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651658 */     // GIR_Coverage, 4864,
     /* 1651658 */     GIR_EraseRootFromParent_Done,
     /* 1651659 */   // Label 22725: @1651659
     /* 1651659 */   GIM_Try, /*On fail goto*//*Label 22726*/ GIMT_Encode4(1651745), // Rule ID 4865 //
     /* 1651664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1651675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1651678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1651681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1651687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651710 */     // MIs[0] policy
     /* 1651710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651720 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1651723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651744 */     // GIR_Coverage, 4865,
     /* 1651744 */     GIR_EraseRootFromParent_Done,
     /* 1651745 */   // Label 22726: @1651745
     /* 1651745 */   GIM_Try, /*On fail goto*//*Label 22727*/ GIMT_Encode4(1651831), // Rule ID 4868 //
     /* 1651750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1651761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1651764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1651767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651796 */     // MIs[0] policy
     /* 1651796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651806 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1651809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651830 */     // GIR_Coverage, 4868,
     /* 1651830 */     GIR_EraseRootFromParent_Done,
     /* 1651831 */   // Label 22727: @1651831
     /* 1651831 */   GIM_Try, /*On fail goto*//*Label 22728*/ GIMT_Encode4(1651917), // Rule ID 4869 //
     /* 1651836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1651847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1651850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1651853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651882 */     // MIs[0] policy
     /* 1651882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651892 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1651895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651916 */     // GIR_Coverage, 4869,
     /* 1651916 */     GIR_EraseRootFromParent_Done,
     /* 1651917 */   // Label 22728: @1651917
     /* 1651917 */   GIM_Try, /*On fail goto*//*Label 22729*/ GIMT_Encode4(1652003), // Rule ID 4872 //
     /* 1651922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1651933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1651936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1651939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651968 */     // MIs[0] policy
     /* 1651968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651978 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11684:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1651981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652002 */     // GIR_Coverage, 4872,
     /* 1652002 */     GIR_EraseRootFromParent_Done,
     /* 1652003 */   // Label 22729: @1652003
     /* 1652003 */   GIM_Try, /*On fail goto*//*Label 22730*/ GIMT_Encode4(1652089), // Rule ID 4873 //
     /* 1652008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1652019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1652022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1652025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652054 */     // MIs[0] policy
     /* 1652054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652064 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11684:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1652067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652088 */     // GIR_Coverage, 4873,
     /* 1652088 */     GIR_EraseRootFromParent_Done,
     /* 1652089 */   // Label 22730: @1652089
     /* 1652089 */   GIM_Try, /*On fail goto*//*Label 22731*/ GIMT_Encode4(1652175), // Rule ID 4876 //
     /* 1652094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1652105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1652108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1652111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652140 */     // MIs[0] policy
     /* 1652140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1652153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652174 */     // GIR_Coverage, 4876,
     /* 1652174 */     GIR_EraseRootFromParent_Done,
     /* 1652175 */   // Label 22731: @1652175
     /* 1652175 */   GIM_Try, /*On fail goto*//*Label 22732*/ GIMT_Encode4(1652261), // Rule ID 4877 //
     /* 1652180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1652191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1652194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1652197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652226 */     // MIs[0] policy
     /* 1652226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1652239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652260 */     // GIR_Coverage, 4877,
     /* 1652260 */     GIR_EraseRootFromParent_Done,
     /* 1652261 */   // Label 22732: @1652261
     /* 1652261 */   GIM_Try, /*On fail goto*//*Label 22733*/ GIMT_Encode4(1652347), // Rule ID 4880 //
     /* 1652266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1652277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1652280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1652283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652312 */     // MIs[0] policy
     /* 1652312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652322 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1652325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652346 */     // GIR_Coverage, 4880,
     /* 1652346 */     GIR_EraseRootFromParent_Done,
     /* 1652347 */   // Label 22733: @1652347
     /* 1652347 */   GIM_Try, /*On fail goto*//*Label 22734*/ GIMT_Encode4(1652433), // Rule ID 4881 //
     /* 1652352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1652363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1652366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1652369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652398 */     // MIs[0] policy
     /* 1652398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652408 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1652411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652432 */     // GIR_Coverage, 4881,
     /* 1652432 */     GIR_EraseRootFromParent_Done,
     /* 1652433 */   // Label 22734: @1652433
     /* 1652433 */   GIM_Try, /*On fail goto*//*Label 22735*/ GIMT_Encode4(1652519), // Rule ID 4884 //
     /* 1652438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1652449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1652452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1652455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652484 */     // MIs[0] policy
     /* 1652484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652494 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1652497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652518 */     // GIR_Coverage, 4884,
     /* 1652518 */     GIR_EraseRootFromParent_Done,
     /* 1652519 */   // Label 22735: @1652519
     /* 1652519 */   GIM_Try, /*On fail goto*//*Label 22736*/ GIMT_Encode4(1652605), // Rule ID 4885 //
     /* 1652524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1652535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1652538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1652541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652570 */     // MIs[0] policy
     /* 1652570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652580 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1652583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652604 */     // GIR_Coverage, 4885,
     /* 1652604 */     GIR_EraseRootFromParent_Done,
     /* 1652605 */   // Label 22736: @1652605
     /* 1652605 */   GIM_Try, /*On fail goto*//*Label 22737*/ GIMT_Encode4(1652691), // Rule ID 4888 //
     /* 1652610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1652613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1652621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1652624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1652627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652656 */     // MIs[0] policy
     /* 1652656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652666 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1652669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652690 */     // GIR_Coverage, 4888,
     /* 1652690 */     GIR_EraseRootFromParent_Done,
     /* 1652691 */   // Label 22737: @1652691
     /* 1652691 */   GIM_Try, /*On fail goto*//*Label 22738*/ GIMT_Encode4(1652777), // Rule ID 4889 //
     /* 1652696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1652699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1652707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1652710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1652713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652742 */     // MIs[0] policy
     /* 1652742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11684:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1652755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652776 */     // GIR_Coverage, 4889,
     /* 1652776 */     GIR_EraseRootFromParent_Done,
     /* 1652777 */   // Label 22738: @1652777
     /* 1652777 */   GIM_Try, /*On fail goto*//*Label 22739*/ GIMT_Encode4(1652863), // Rule ID 4892 //
     /* 1652782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1652785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1652793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1652796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1652799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652828 */     // MIs[0] policy
     /* 1652828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652838 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1652841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652862 */     // GIR_Coverage, 4892,
     /* 1652862 */     GIR_EraseRootFromParent_Done,
     /* 1652863 */   // Label 22739: @1652863
     /* 1652863 */   GIM_Try, /*On fail goto*//*Label 22740*/ GIMT_Encode4(1652949), // Rule ID 4893 //
     /* 1652868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1652871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1652879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1652882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1652885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652914 */     // MIs[0] policy
     /* 1652914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11684:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1652927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652948 */     // GIR_Coverage, 4893,
     /* 1652948 */     GIR_EraseRootFromParent_Done,
     /* 1652949 */   // Label 22740: @1652949
     /* 1652949 */   GIM_Try, /*On fail goto*//*Label 22741*/ GIMT_Encode4(1653035), // Rule ID 4896 //
     /* 1652954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1652957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1652965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1652968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1652971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653000 */     // MIs[0] policy
     /* 1653000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653010 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1653013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653034 */     // GIR_Coverage, 4896,
     /* 1653034 */     GIR_EraseRootFromParent_Done,
     /* 1653035 */   // Label 22741: @1653035
     /* 1653035 */   GIM_Try, /*On fail goto*//*Label 22742*/ GIMT_Encode4(1653121), // Rule ID 4897 //
     /* 1653040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1653043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1653051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1653054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1653057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653086 */     // MIs[0] policy
     /* 1653086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11684:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1653099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653120 */     // GIR_Coverage, 4897,
     /* 1653120 */     GIR_EraseRootFromParent_Done,
     /* 1653121 */   // Label 22742: @1653121
     /* 1653121 */   GIM_Try, /*On fail goto*//*Label 22743*/ GIMT_Encode4(1653207), // Rule ID 4900 //
     /* 1653126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1653129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1653137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1653140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1653143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653172 */     // MIs[0] policy
     /* 1653172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653182 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1653185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653206 */     // GIR_Coverage, 4900,
     /* 1653206 */     GIR_EraseRootFromParent_Done,
     /* 1653207 */   // Label 22743: @1653207
     /* 1653207 */   GIM_Try, /*On fail goto*//*Label 22744*/ GIMT_Encode4(1653293), // Rule ID 4901 //
     /* 1653212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1653215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1653223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1653226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1653229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653258 */     // MIs[0] policy
     /* 1653258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653268 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11684:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1653271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653292 */     // GIR_Coverage, 4901,
     /* 1653292 */     GIR_EraseRootFromParent_Done,
     /* 1653293 */   // Label 22744: @1653293
     /* 1653293 */   GIM_Try, /*On fail goto*//*Label 22745*/ GIMT_Encode4(1653379), // Rule ID 5778 //
     /* 1653298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1653309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1653312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1653315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1653318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653344 */     // MIs[0] policy
     /* 1653344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653354 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1653357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653378 */     // GIR_Coverage, 5778,
     /* 1653378 */     GIR_EraseRootFromParent_Done,
     /* 1653379 */   // Label 22745: @1653379
     /* 1653379 */   GIM_Try, /*On fail goto*//*Label 22746*/ GIMT_Encode4(1653465), // Rule ID 5779 //
     /* 1653384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1653395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1653398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1653401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1653404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653430 */     // MIs[0] policy
     /* 1653430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653440 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1653443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653464 */     // GIR_Coverage, 5779,
     /* 1653464 */     GIR_EraseRootFromParent_Done,
     /* 1653465 */   // Label 22746: @1653465
     /* 1653465 */   GIM_Try, /*On fail goto*//*Label 22747*/ GIMT_Encode4(1653551), // Rule ID 5782 //
     /* 1653470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1653481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1653484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1653487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1653490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653516 */     // MIs[0] policy
     /* 1653516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653526 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1653529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653550 */     // GIR_Coverage, 5782,
     /* 1653550 */     GIR_EraseRootFromParent_Done,
     /* 1653551 */   // Label 22747: @1653551
     /* 1653551 */   GIM_Try, /*On fail goto*//*Label 22748*/ GIMT_Encode4(1653637), // Rule ID 5783 //
     /* 1653556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1653567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1653570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1653573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1653576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653602 */     // MIs[0] policy
     /* 1653602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653612 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1653615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653636 */     // GIR_Coverage, 5783,
     /* 1653636 */     GIR_EraseRootFromParent_Done,
     /* 1653637 */   // Label 22748: @1653637
     /* 1653637 */   GIM_Try, /*On fail goto*//*Label 22749*/ GIMT_Encode4(1653723), // Rule ID 5786 //
     /* 1653642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1653653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1653656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1653659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1653662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653688 */     // MIs[0] policy
     /* 1653688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653698 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1653701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653722 */     // GIR_Coverage, 5786,
     /* 1653722 */     GIR_EraseRootFromParent_Done,
     /* 1653723 */   // Label 22749: @1653723
     /* 1653723 */   GIM_Try, /*On fail goto*//*Label 22750*/ GIMT_Encode4(1653809), // Rule ID 5787 //
     /* 1653728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1653739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1653742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1653745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1653748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653774 */     // MIs[0] policy
     /* 1653774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653784 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1653787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653808 */     // GIR_Coverage, 5787,
     /* 1653808 */     GIR_EraseRootFromParent_Done,
     /* 1653809 */   // Label 22750: @1653809
     /* 1653809 */   GIM_Try, /*On fail goto*//*Label 22751*/ GIMT_Encode4(1653895), // Rule ID 5790 //
     /* 1653814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1653825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1653828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1653831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1653834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653860 */     // MIs[0] policy
     /* 1653860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653870 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1653873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653894 */     // GIR_Coverage, 5790,
     /* 1653894 */     GIR_EraseRootFromParent_Done,
     /* 1653895 */   // Label 22751: @1653895
     /* 1653895 */   GIM_Try, /*On fail goto*//*Label 22752*/ GIMT_Encode4(1653981), // Rule ID 5791 //
     /* 1653900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1653911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1653914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1653917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1653920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653946 */     // MIs[0] policy
     /* 1653946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653956 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1653959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653980 */     // GIR_Coverage, 5791,
     /* 1653980 */     GIR_EraseRootFromParent_Done,
     /* 1653981 */   // Label 22752: @1653981
     /* 1653981 */   GIM_Try, /*On fail goto*//*Label 22753*/ GIMT_Encode4(1654067), // Rule ID 5794 //
     /* 1653986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1653997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1654000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1654003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1654006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654032 */     // MIs[0] policy
     /* 1654032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654042 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654066 */     // GIR_Coverage, 5794,
     /* 1654066 */     GIR_EraseRootFromParent_Done,
     /* 1654067 */   // Label 22753: @1654067
     /* 1654067 */   GIM_Try, /*On fail goto*//*Label 22754*/ GIMT_Encode4(1654153), // Rule ID 5795 //
     /* 1654072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1654083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1654086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1654089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1654092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654118 */     // MIs[0] policy
     /* 1654118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654128 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654152 */     // GIR_Coverage, 5795,
     /* 1654152 */     GIR_EraseRootFromParent_Done,
     /* 1654153 */   // Label 22754: @1654153
     /* 1654153 */   GIM_Try, /*On fail goto*//*Label 22755*/ GIMT_Encode4(1654239), // Rule ID 5798 //
     /* 1654158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1654169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1654172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1654175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1654178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654204 */     // MIs[0] policy
     /* 1654204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654214 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654238 */     // GIR_Coverage, 5798,
     /* 1654238 */     GIR_EraseRootFromParent_Done,
     /* 1654239 */   // Label 22755: @1654239
     /* 1654239 */   GIM_Try, /*On fail goto*//*Label 22756*/ GIMT_Encode4(1654325), // Rule ID 5799 //
     /* 1654244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1654255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1654258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1654261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1654264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654290 */     // MIs[0] policy
     /* 1654290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654300 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654324 */     // GIR_Coverage, 5799,
     /* 1654324 */     GIR_EraseRootFromParent_Done,
     /* 1654325 */   // Label 22756: @1654325
     /* 1654325 */   GIM_Try, /*On fail goto*//*Label 22757*/ GIMT_Encode4(1654411), // Rule ID 5802 //
     /* 1654330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1654341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1654344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1654347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1654350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654376 */     // MIs[0] policy
     /* 1654376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654386 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654410 */     // GIR_Coverage, 5802,
     /* 1654410 */     GIR_EraseRootFromParent_Done,
     /* 1654411 */   // Label 22757: @1654411
     /* 1654411 */   GIM_Try, /*On fail goto*//*Label 22758*/ GIMT_Encode4(1654497), // Rule ID 5803 //
     /* 1654416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1654427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1654430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1654433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1654436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654462 */     // MIs[0] policy
     /* 1654462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654472 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654496 */     // GIR_Coverage, 5803,
     /* 1654496 */     GIR_EraseRootFromParent_Done,
     /* 1654497 */   // Label 22758: @1654497
     /* 1654497 */   GIM_Try, /*On fail goto*//*Label 22759*/ GIMT_Encode4(1654583), // Rule ID 5806 //
     /* 1654502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1654513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1654516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1654519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1654522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654548 */     // MIs[0] policy
     /* 1654548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654582 */     // GIR_Coverage, 5806,
     /* 1654582 */     GIR_EraseRootFromParent_Done,
     /* 1654583 */   // Label 22759: @1654583
     /* 1654583 */   GIM_Try, /*On fail goto*//*Label 22760*/ GIMT_Encode4(1654669), // Rule ID 5807 //
     /* 1654588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1654599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1654602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1654605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1654608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654634 */     // MIs[0] policy
     /* 1654634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654644 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654668 */     // GIR_Coverage, 5807,
     /* 1654668 */     GIR_EraseRootFromParent_Done,
     /* 1654669 */   // Label 22760: @1654669
     /* 1654669 */   GIM_Try, /*On fail goto*//*Label 22761*/ GIMT_Encode4(1654755), // Rule ID 5810 //
     /* 1654674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1654685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1654688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1654691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1654694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654720 */     // MIs[0] policy
     /* 1654720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654730 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654754 */     // GIR_Coverage, 5810,
     /* 1654754 */     GIR_EraseRootFromParent_Done,
     /* 1654755 */   // Label 22761: @1654755
     /* 1654755 */   GIM_Try, /*On fail goto*//*Label 22762*/ GIMT_Encode4(1654841), // Rule ID 5811 //
     /* 1654760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1654771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1654774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1654777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1654780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654806 */     // MIs[0] policy
     /* 1654806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654816 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654840 */     // GIR_Coverage, 5811,
     /* 1654840 */     GIR_EraseRootFromParent_Done,
     /* 1654841 */   // Label 22762: @1654841
     /* 1654841 */   GIM_Try, /*On fail goto*//*Label 22763*/ GIMT_Encode4(1654927), // Rule ID 5814 //
     /* 1654846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1654849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1654857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1654860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1654863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1654866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654892 */     // MIs[0] policy
     /* 1654892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654902 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1654923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654926 */     // GIR_Coverage, 5814,
     /* 1654926 */     GIR_EraseRootFromParent_Done,
     /* 1654927 */   // Label 22763: @1654927
     /* 1654927 */   GIM_Try, /*On fail goto*//*Label 22764*/ GIMT_Encode4(1655013), // Rule ID 5815 //
     /* 1654932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1654935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1654943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1654946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1654949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1654952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654978 */     // MIs[0] policy
     /* 1654978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654988 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1655009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655012 */     // GIR_Coverage, 5815,
     /* 1655012 */     GIR_EraseRootFromParent_Done,
     /* 1655013 */   // Label 22764: @1655013
     /* 1655013 */   GIM_Try, /*On fail goto*//*Label 22765*/ GIMT_Encode4(1655099), // Rule ID 5818 //
     /* 1655018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1655029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1655032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1655035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1655038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655064 */     // MIs[0] policy
     /* 1655064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655074 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1655077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655098 */     // GIR_Coverage, 5818,
     /* 1655098 */     GIR_EraseRootFromParent_Done,
     /* 1655099 */   // Label 22765: @1655099
     /* 1655099 */   GIM_Try, /*On fail goto*//*Label 22766*/ GIMT_Encode4(1655185), // Rule ID 5819 //
     /* 1655104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1655115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1655118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1655121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1655124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655150 */     // MIs[0] policy
     /* 1655150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655160 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1655163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655184 */     // GIR_Coverage, 5819,
     /* 1655184 */     GIR_EraseRootFromParent_Done,
     /* 1655185 */   // Label 22766: @1655185
     /* 1655185 */   GIM_Try, /*On fail goto*//*Label 22767*/ GIMT_Encode4(1655271), // Rule ID 5822 //
     /* 1655190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1655201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1655204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1655207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1655210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655236 */     // MIs[0] policy
     /* 1655236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655246 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1655249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655270 */     // GIR_Coverage, 5822,
     /* 1655270 */     GIR_EraseRootFromParent_Done,
     /* 1655271 */   // Label 22767: @1655271
     /* 1655271 */   GIM_Try, /*On fail goto*//*Label 22768*/ GIMT_Encode4(1655357), // Rule ID 5823 //
     /* 1655276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1655287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1655290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1655293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1655296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655322 */     // MIs[0] policy
     /* 1655322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655332 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1655335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655356 */     // GIR_Coverage, 5823,
     /* 1655356 */     GIR_EraseRootFromParent_Done,
     /* 1655357 */   // Label 22768: @1655357
     /* 1655357 */   GIM_Try, /*On fail goto*//*Label 22769*/ GIMT_Encode4(1655443), // Rule ID 5826 //
     /* 1655362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1655373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1655376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1655379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1655382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1655385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655408 */     // MIs[0] policy
     /* 1655408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655418 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1655421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655442 */     // GIR_Coverage, 5826,
     /* 1655442 */     GIR_EraseRootFromParent_Done,
     /* 1655443 */   // Label 22769: @1655443
     /* 1655443 */   GIM_Try, /*On fail goto*//*Label 22770*/ GIMT_Encode4(1655529), // Rule ID 5827 //
     /* 1655448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1655459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1655462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1655465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1655468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1655471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655494 */     // MIs[0] policy
     /* 1655494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655504 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1655507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655528 */     // GIR_Coverage, 5827,
     /* 1655528 */     GIR_EraseRootFromParent_Done,
     /* 1655529 */   // Label 22770: @1655529
     /* 1655529 */   GIM_Try, /*On fail goto*//*Label 22771*/ GIMT_Encode4(1655615), // Rule ID 5830 //
     /* 1655534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1655545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1655548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1655551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1655554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1655557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655580 */     // MIs[0] policy
     /* 1655580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1655593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655614 */     // GIR_Coverage, 5830,
     /* 1655614 */     GIR_EraseRootFromParent_Done,
     /* 1655615 */   // Label 22771: @1655615
     /* 1655615 */   GIM_Try, /*On fail goto*//*Label 22772*/ GIMT_Encode4(1655701), // Rule ID 5831 //
     /* 1655620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1655631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1655634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1655637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1655640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1655643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655666 */     // MIs[0] policy
     /* 1655666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1655679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655700 */     // GIR_Coverage, 5831,
     /* 1655700 */     GIR_EraseRootFromParent_Done,
     /* 1655701 */   // Label 22772: @1655701
     /* 1655701 */   GIM_Try, /*On fail goto*//*Label 22773*/ GIMT_Encode4(1655787), // Rule ID 5834 //
     /* 1655706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1655717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1655720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1655723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1655726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655752 */     // MIs[0] policy
     /* 1655752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655762 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1655765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655786 */     // GIR_Coverage, 5834,
     /* 1655786 */     GIR_EraseRootFromParent_Done,
     /* 1655787 */   // Label 22773: @1655787
     /* 1655787 */   GIM_Try, /*On fail goto*//*Label 22774*/ GIMT_Encode4(1655873), // Rule ID 5835 //
     /* 1655792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1655803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1655806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1655809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1655812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655838 */     // MIs[0] policy
     /* 1655838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1655851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655872 */     // GIR_Coverage, 5835,
     /* 1655872 */     GIR_EraseRootFromParent_Done,
     /* 1655873 */   // Label 22774: @1655873
     /* 1655873 */   GIM_Try, /*On fail goto*//*Label 22775*/ GIMT_Encode4(1655959), // Rule ID 5838 //
     /* 1655878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1655889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1655892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1655895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1655898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655924 */     // MIs[0] policy
     /* 1655924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655934 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1655937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655958 */     // GIR_Coverage, 5838,
     /* 1655958 */     GIR_EraseRootFromParent_Done,
     /* 1655959 */   // Label 22775: @1655959
     /* 1655959 */   GIM_Try, /*On fail goto*//*Label 22776*/ GIMT_Encode4(1656045), // Rule ID 5839 //
     /* 1655964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1655975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1655978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1655981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1655984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656010 */     // MIs[0] policy
     /* 1656010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656020 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656044 */     // GIR_Coverage, 5839,
     /* 1656044 */     GIR_EraseRootFromParent_Done,
     /* 1656045 */   // Label 22776: @1656045
     /* 1656045 */   GIM_Try, /*On fail goto*//*Label 22777*/ GIMT_Encode4(1656131), // Rule ID 5842 //
     /* 1656050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1656061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1656064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1656067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1656070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656096 */     // MIs[0] policy
     /* 1656096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656130 */     // GIR_Coverage, 5842,
     /* 1656130 */     GIR_EraseRootFromParent_Done,
     /* 1656131 */   // Label 22777: @1656131
     /* 1656131 */   GIM_Try, /*On fail goto*//*Label 22778*/ GIMT_Encode4(1656217), // Rule ID 5843 //
     /* 1656136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1656147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1656150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1656153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1656156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656182 */     // MIs[0] policy
     /* 1656182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656216 */     // GIR_Coverage, 5843,
     /* 1656216 */     GIR_EraseRootFromParent_Done,
     /* 1656217 */   // Label 22778: @1656217
     /* 1656217 */   GIM_Try, /*On fail goto*//*Label 22779*/ GIMT_Encode4(1656303), // Rule ID 5846 //
     /* 1656222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1656233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1656236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1656239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1656242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656268 */     // MIs[0] policy
     /* 1656268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656278 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656302 */     // GIR_Coverage, 5846,
     /* 1656302 */     GIR_EraseRootFromParent_Done,
     /* 1656303 */   // Label 22779: @1656303
     /* 1656303 */   GIM_Try, /*On fail goto*//*Label 22780*/ GIMT_Encode4(1656389), // Rule ID 5847 //
     /* 1656308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1656319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1656322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1656325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1656328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656354 */     // MIs[0] policy
     /* 1656354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656388 */     // GIR_Coverage, 5847,
     /* 1656388 */     GIR_EraseRootFromParent_Done,
     /* 1656389 */   // Label 22780: @1656389
     /* 1656389 */   GIM_Try, /*On fail goto*//*Label 22781*/ GIMT_Encode4(1656475), // Rule ID 5850 //
     /* 1656394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1656405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1656408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1656411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1656414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656440 */     // MIs[0] policy
     /* 1656440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656450 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656474 */     // GIR_Coverage, 5850,
     /* 1656474 */     GIR_EraseRootFromParent_Done,
     /* 1656475 */   // Label 22781: @1656475
     /* 1656475 */   GIM_Try, /*On fail goto*//*Label 22782*/ GIMT_Encode4(1656561), // Rule ID 5851 //
     /* 1656480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1656491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1656494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1656497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1656500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656526 */     // MIs[0] policy
     /* 1656526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656560 */     // GIR_Coverage, 5851,
     /* 1656560 */     GIR_EraseRootFromParent_Done,
     /* 1656561 */   // Label 22782: @1656561
     /* 1656561 */   GIM_Try, /*On fail goto*//*Label 22783*/ GIMT_Encode4(1656647), // Rule ID 5854 //
     /* 1656566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1656569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1656577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1656580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1656583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1656586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1656589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656612 */     // MIs[0] policy
     /* 1656612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656622 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1656643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656646 */     // GIR_Coverage, 5854,
     /* 1656646 */     GIR_EraseRootFromParent_Done,
     /* 1656647 */   // Label 22783: @1656647
     /* 1656647 */   GIM_Try, /*On fail goto*//*Label 22784*/ GIMT_Encode4(1656733), // Rule ID 5855 //
     /* 1656652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1656655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1656663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1656666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1656669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1656672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1656675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656698 */     // MIs[0] policy
     /* 1656698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656708 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1656729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656732 */     // GIR_Coverage, 5855,
     /* 1656732 */     GIR_EraseRootFromParent_Done,
     /* 1656733 */   // Label 22784: @1656733
     /* 1656733 */   GIM_Try, /*On fail goto*//*Label 22785*/ GIMT_Encode4(1656819), // Rule ID 5858 //
     /* 1656738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1656741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1656749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1656752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1656755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1656758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656784 */     // MIs[0] policy
     /* 1656784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656794 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1656815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656818 */     // GIR_Coverage, 5858,
     /* 1656818 */     GIR_EraseRootFromParent_Done,
     /* 1656819 */   // Label 22785: @1656819
     /* 1656819 */   GIM_Try, /*On fail goto*//*Label 22786*/ GIMT_Encode4(1656905), // Rule ID 5859 //
     /* 1656824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1656827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1656835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1656838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1656841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1656844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656870 */     // MIs[0] policy
     /* 1656870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656880 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1656901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656904 */     // GIR_Coverage, 5859,
     /* 1656904 */     GIR_EraseRootFromParent_Done,
     /* 1656905 */   // Label 22786: @1656905
     /* 1656905 */   GIM_Try, /*On fail goto*//*Label 22787*/ GIMT_Encode4(1656991), // Rule ID 5862 //
     /* 1656910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1656913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1656921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1656924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1656927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1656930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656956 */     // MIs[0] policy
     /* 1656956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656966 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1656987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656990 */     // GIR_Coverage, 5862,
     /* 1656990 */     GIR_EraseRootFromParent_Done,
     /* 1656991 */   // Label 22787: @1656991
     /* 1656991 */   GIM_Try, /*On fail goto*//*Label 22788*/ GIMT_Encode4(1657077), // Rule ID 5863 //
     /* 1656996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1656999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1657007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1657010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1657013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1657016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657042 */     // MIs[0] policy
     /* 1657042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657052 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1657055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657076 */     // GIR_Coverage, 5863,
     /* 1657076 */     GIR_EraseRootFromParent_Done,
     /* 1657077 */   // Label 22788: @1657077
     /* 1657077 */   GIM_Try, /*On fail goto*//*Label 22789*/ GIMT_Encode4(1657163), // Rule ID 5866 //
     /* 1657082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1657093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1657096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1657099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657128 */     // MIs[0] policy
     /* 1657128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657138 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1657141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657162 */     // GIR_Coverage, 5866,
     /* 1657162 */     GIR_EraseRootFromParent_Done,
     /* 1657163 */   // Label 22789: @1657163
     /* 1657163 */   GIM_Try, /*On fail goto*//*Label 22790*/ GIMT_Encode4(1657249), // Rule ID 5867 //
     /* 1657168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1657179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1657182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1657185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657214 */     // MIs[0] policy
     /* 1657214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657224 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1657227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657248 */     // GIR_Coverage, 5867,
     /* 1657248 */     GIR_EraseRootFromParent_Done,
     /* 1657249 */   // Label 22790: @1657249
     /* 1657249 */   GIM_Try, /*On fail goto*//*Label 22791*/ GIMT_Encode4(1657335), // Rule ID 5870 //
     /* 1657254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1657265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1657268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1657271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657300 */     // MIs[0] policy
     /* 1657300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657310 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1657313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657334 */     // GIR_Coverage, 5870,
     /* 1657334 */     GIR_EraseRootFromParent_Done,
     /* 1657335 */   // Label 22791: @1657335
     /* 1657335 */   GIM_Try, /*On fail goto*//*Label 22792*/ GIMT_Encode4(1657421), // Rule ID 5871 //
     /* 1657340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1657351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1657354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1657357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657386 */     // MIs[0] policy
     /* 1657386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657396 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1657399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657420 */     // GIR_Coverage, 5871,
     /* 1657420 */     GIR_EraseRootFromParent_Done,
     /* 1657421 */   // Label 22792: @1657421
     /* 1657421 */   GIM_Try, /*On fail goto*//*Label 22793*/ GIMT_Encode4(1657507), // Rule ID 5874 //
     /* 1657426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1657437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1657440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1657443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657472 */     // MIs[0] policy
     /* 1657472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657482 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1657485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657506 */     // GIR_Coverage, 5874,
     /* 1657506 */     GIR_EraseRootFromParent_Done,
     /* 1657507 */   // Label 22793: @1657507
     /* 1657507 */   GIM_Try, /*On fail goto*//*Label 22794*/ GIMT_Encode4(1657593), // Rule ID 5875 //
     /* 1657512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1657523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1657526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1657529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657558 */     // MIs[0] policy
     /* 1657558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657568 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1657571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657592 */     // GIR_Coverage, 5875,
     /* 1657592 */     GIR_EraseRootFromParent_Done,
     /* 1657593 */   // Label 22794: @1657593
     /* 1657593 */   GIM_Try, /*On fail goto*//*Label 22795*/ GIMT_Encode4(1657679), // Rule ID 5878 //
     /* 1657598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1657609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1657612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1657615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657644 */     // MIs[0] policy
     /* 1657644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657654 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1657657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657678 */     // GIR_Coverage, 5878,
     /* 1657678 */     GIR_EraseRootFromParent_Done,
     /* 1657679 */   // Label 22795: @1657679
     /* 1657679 */   GIM_Try, /*On fail goto*//*Label 22796*/ GIMT_Encode4(1657765), // Rule ID 5879 //
     /* 1657684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1657695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1657698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1657701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657730 */     // MIs[0] policy
     /* 1657730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657740 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1657743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657764 */     // GIR_Coverage, 5879,
     /* 1657764 */     GIR_EraseRootFromParent_Done,
     /* 1657765 */   // Label 22796: @1657765
     /* 1657765 */   GIM_Try, /*On fail goto*//*Label 22797*/ GIMT_Encode4(1657851), // Rule ID 5882 //
     /* 1657770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1657781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1657784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1657787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657816 */     // MIs[0] policy
     /* 1657816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657826 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1657829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657850 */     // GIR_Coverage, 5882,
     /* 1657850 */     GIR_EraseRootFromParent_Done,
     /* 1657851 */   // Label 22797: @1657851
     /* 1657851 */   GIM_Try, /*On fail goto*//*Label 22798*/ GIMT_Encode4(1657937), // Rule ID 5883 //
     /* 1657856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1657867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1657870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1657873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657902 */     // MIs[0] policy
     /* 1657902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657912 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1657915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657936 */     // GIR_Coverage, 5883,
     /* 1657936 */     GIR_EraseRootFromParent_Done,
     /* 1657937 */   // Label 22798: @1657937
     /* 1657937 */   GIM_Try, /*On fail goto*//*Label 22799*/ GIMT_Encode4(1658023), // Rule ID 5886 //
     /* 1657942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1657953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1657956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1657959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657988 */     // MIs[0] policy
     /* 1657988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1658001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658022 */     // GIR_Coverage, 5886,
     /* 1658022 */     GIR_EraseRootFromParent_Done,
     /* 1658023 */   // Label 22799: @1658023
     /* 1658023 */   GIM_Try, /*On fail goto*//*Label 22800*/ GIMT_Encode4(1658109), // Rule ID 5887 //
     /* 1658028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1658039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1658042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1658045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658074 */     // MIs[0] policy
     /* 1658074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1658087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658108 */     // GIR_Coverage, 5887,
     /* 1658108 */     GIR_EraseRootFromParent_Done,
     /* 1658109 */   // Label 22800: @1658109
     /* 1658109 */   GIM_Try, /*On fail goto*//*Label 22801*/ GIMT_Encode4(1658195), // Rule ID 5890 //
     /* 1658114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1658125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1658128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1658131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658160 */     // MIs[0] policy
     /* 1658160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658170 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658194 */     // GIR_Coverage, 5890,
     /* 1658194 */     GIR_EraseRootFromParent_Done,
     /* 1658195 */   // Label 22801: @1658195
     /* 1658195 */   GIM_Try, /*On fail goto*//*Label 22802*/ GIMT_Encode4(1658281), // Rule ID 5891 //
     /* 1658200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1658211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1658214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1658217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658246 */     // MIs[0] policy
     /* 1658246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658256 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658280 */     // GIR_Coverage, 5891,
     /* 1658280 */     GIR_EraseRootFromParent_Done,
     /* 1658281 */   // Label 22802: @1658281
     /* 1658281 */   GIM_Try, /*On fail goto*//*Label 22803*/ GIMT_Encode4(1658367), // Rule ID 5894 //
     /* 1658286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1658297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1658300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1658303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658332 */     // MIs[0] policy
     /* 1658332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658366 */     // GIR_Coverage, 5894,
     /* 1658366 */     GIR_EraseRootFromParent_Done,
     /* 1658367 */   // Label 22803: @1658367
     /* 1658367 */   GIM_Try, /*On fail goto*//*Label 22804*/ GIMT_Encode4(1658453), // Rule ID 5895 //
     /* 1658372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1658383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1658386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1658389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658418 */     // MIs[0] policy
     /* 1658418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658428 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658452 */     // GIR_Coverage, 5895,
     /* 1658452 */     GIR_EraseRootFromParent_Done,
     /* 1658453 */   // Label 22804: @1658453
     /* 1658453 */   GIM_Try, /*On fail goto*//*Label 22805*/ GIMT_Encode4(1658539), // Rule ID 5898 //
     /* 1658458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1658469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1658472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1658475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658504 */     // MIs[0] policy
     /* 1658504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658514 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658538 */     // GIR_Coverage, 5898,
     /* 1658538 */     GIR_EraseRootFromParent_Done,
     /* 1658539 */   // Label 22805: @1658539
     /* 1658539 */   GIM_Try, /*On fail goto*//*Label 22806*/ GIMT_Encode4(1658625), // Rule ID 5899 //
     /* 1658544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1658555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1658558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1658561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658590 */     // MIs[0] policy
     /* 1658590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658624 */     // GIR_Coverage, 5899,
     /* 1658624 */     GIR_EraseRootFromParent_Done,
     /* 1658625 */   // Label 22806: @1658625
     /* 1658625 */   GIM_Try, /*On fail goto*//*Label 22807*/ GIMT_Encode4(1658711), // Rule ID 5902 //
     /* 1658630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1658633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1658641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1658644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1658647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658676 */     // MIs[0] policy
     /* 1658676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658686 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1658707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658710 */     // GIR_Coverage, 5902,
     /* 1658710 */     GIR_EraseRootFromParent_Done,
     /* 1658711 */   // Label 22807: @1658711
     /* 1658711 */   GIM_Try, /*On fail goto*//*Label 22808*/ GIMT_Encode4(1658797), // Rule ID 5903 //
     /* 1658716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1658719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1658727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1658730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1658733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658762 */     // MIs[0] policy
     /* 1658762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658772 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1658793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658796 */     // GIR_Coverage, 5903,
     /* 1658796 */     GIR_EraseRootFromParent_Done,
     /* 1658797 */   // Label 22808: @1658797
     /* 1658797 */   GIM_Try, /*On fail goto*//*Label 22809*/ GIMT_Encode4(1658883), // Rule ID 5906 //
     /* 1658802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1658813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1658816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1658819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1658825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1658832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658848 */     // MIs[0] policy
     /* 1658848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1658861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658882 */     // GIR_Coverage, 5906,
     /* 1658882 */     GIR_EraseRootFromParent_Done,
     /* 1658883 */   // Label 22809: @1658883
     /* 1658883 */   GIM_Try, /*On fail goto*//*Label 22810*/ GIMT_Encode4(1658969), // Rule ID 5907 //
     /* 1658888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1658899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1658902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1658905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1658911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1658918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658934 */     // MIs[0] policy
     /* 1658934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658944 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1658947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658968 */     // GIR_Coverage, 5907,
     /* 1658968 */     GIR_EraseRootFromParent_Done,
     /* 1658969 */   // Label 22810: @1658969
     /* 1658969 */   GIM_Try, /*On fail goto*//*Label 22811*/ GIMT_Encode4(1659055), // Rule ID 5910 //
     /* 1658974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1658985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1658988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1658991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1658997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659020 */     // MIs[0] policy
     /* 1659020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659030 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1659033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659054 */     // GIR_Coverage, 5910,
     /* 1659054 */     GIR_EraseRootFromParent_Done,
     /* 1659055 */   // Label 22811: @1659055
     /* 1659055 */   GIM_Try, /*On fail goto*//*Label 22812*/ GIMT_Encode4(1659141), // Rule ID 5911 //
     /* 1659060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1659071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1659074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1659077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659106 */     // MIs[0] policy
     /* 1659106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659116 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1659119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659140 */     // GIR_Coverage, 5911,
     /* 1659140 */     GIR_EraseRootFromParent_Done,
     /* 1659141 */   // Label 22812: @1659141
     /* 1659141 */   GIM_Try, /*On fail goto*//*Label 22813*/ GIMT_Encode4(1659227), // Rule ID 5914 //
     /* 1659146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1659157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1659160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1659163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1659169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659192 */     // MIs[0] policy
     /* 1659192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659202 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1659205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659226 */     // GIR_Coverage, 5914,
     /* 1659226 */     GIR_EraseRootFromParent_Done,
     /* 1659227 */   // Label 22813: @1659227
     /* 1659227 */   GIM_Try, /*On fail goto*//*Label 22814*/ GIMT_Encode4(1659313), // Rule ID 5915 //
     /* 1659232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1659243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1659246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1659249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1659255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659278 */     // MIs[0] policy
     /* 1659278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659288 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1659291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659312 */     // GIR_Coverage, 5915,
     /* 1659312 */     GIR_EraseRootFromParent_Done,
     /* 1659313 */   // Label 22814: @1659313
     /* 1659313 */   GIM_Try, /*On fail goto*//*Label 22815*/ GIMT_Encode4(1659399), // Rule ID 5918 //
     /* 1659318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1659329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1659332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1659335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659364 */     // MIs[0] policy
     /* 1659364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659374 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659398 */     // GIR_Coverage, 5918,
     /* 1659398 */     GIR_EraseRootFromParent_Done,
     /* 1659399 */   // Label 22815: @1659399
     /* 1659399 */   GIM_Try, /*On fail goto*//*Label 22816*/ GIMT_Encode4(1659485), // Rule ID 5919 //
     /* 1659404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1659415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1659418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1659421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659450 */     // MIs[0] policy
     /* 1659450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659484 */     // GIR_Coverage, 5919,
     /* 1659484 */     GIR_EraseRootFromParent_Done,
     /* 1659485 */   // Label 22816: @1659485
     /* 1659485 */   GIM_Try, /*On fail goto*//*Label 22817*/ GIMT_Encode4(1659571), // Rule ID 5922 //
     /* 1659490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1659501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1659504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1659507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659536 */     // MIs[0] policy
     /* 1659536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1659549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659570 */     // GIR_Coverage, 5922,
     /* 1659570 */     GIR_EraseRootFromParent_Done,
     /* 1659571 */   // Label 22817: @1659571
     /* 1659571 */   GIM_Try, /*On fail goto*//*Label 22818*/ GIMT_Encode4(1659657), // Rule ID 5923 //
     /* 1659576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1659587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1659590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1659593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659622 */     // MIs[0] policy
     /* 1659622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659632 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1659635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659656 */     // GIR_Coverage, 5923,
     /* 1659656 */     GIR_EraseRootFromParent_Done,
     /* 1659657 */   // Label 22818: @1659657
     /* 1659657 */   GIM_Try, /*On fail goto*//*Label 22819*/ GIMT_Encode4(1659743), // Rule ID 5926 //
     /* 1659662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1659673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1659676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1659679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659708 */     // MIs[0] policy
     /* 1659708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659718 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1659721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659742 */     // GIR_Coverage, 5926,
     /* 1659742 */     GIR_EraseRootFromParent_Done,
     /* 1659743 */   // Label 22819: @1659743
     /* 1659743 */   GIM_Try, /*On fail goto*//*Label 22820*/ GIMT_Encode4(1659829), // Rule ID 5927 //
     /* 1659748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1659759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1659762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1659765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659794 */     // MIs[0] policy
     /* 1659794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659804 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1659807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659828 */     // GIR_Coverage, 5927,
     /* 1659828 */     GIR_EraseRootFromParent_Done,
     /* 1659829 */   // Label 22820: @1659829
     /* 1659829 */   GIM_Try, /*On fail goto*//*Label 22821*/ GIMT_Encode4(1659915), // Rule ID 5930 //
     /* 1659834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1659845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1659848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1659851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659880 */     // MIs[0] policy
     /* 1659880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659914 */     // GIR_Coverage, 5930,
     /* 1659914 */     GIR_EraseRootFromParent_Done,
     /* 1659915 */   // Label 22821: @1659915
     /* 1659915 */   GIM_Try, /*On fail goto*//*Label 22822*/ GIMT_Encode4(1660001), // Rule ID 5931 //
     /* 1659920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1659931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1659934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1659937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659966 */     // MIs[0] policy
     /* 1659966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659976 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660000 */     // GIR_Coverage, 5931,
     /* 1660000 */     GIR_EraseRootFromParent_Done,
     /* 1660001 */   // Label 22822: @1660001
     /* 1660001 */   GIM_Try, /*On fail goto*//*Label 22823*/ GIMT_Encode4(1660087), // Rule ID 5934 //
     /* 1660006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1660017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1660020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1660023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660052 */     // MIs[0] policy
     /* 1660052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660062 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660086 */     // GIR_Coverage, 5934,
     /* 1660086 */     GIR_EraseRootFromParent_Done,
     /* 1660087 */   // Label 22823: @1660087
     /* 1660087 */   GIM_Try, /*On fail goto*//*Label 22824*/ GIMT_Encode4(1660173), // Rule ID 5935 //
     /* 1660092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1660103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1660106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1660109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660138 */     // MIs[0] policy
     /* 1660138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660148 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660172 */     // GIR_Coverage, 5935,
     /* 1660172 */     GIR_EraseRootFromParent_Done,
     /* 1660173 */   // Label 22824: @1660173
     /* 1660173 */   GIM_Try, /*On fail goto*//*Label 22825*/ GIMT_Encode4(1660259), // Rule ID 5938 //
     /* 1660178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1660189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1660192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1660195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660224 */     // MIs[0] policy
     /* 1660224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660234 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660258 */     // GIR_Coverage, 5938,
     /* 1660258 */     GIR_EraseRootFromParent_Done,
     /* 1660259 */   // Label 22825: @1660259
     /* 1660259 */   GIM_Try, /*On fail goto*//*Label 22826*/ GIMT_Encode4(1660345), // Rule ID 5939 //
     /* 1660264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1660275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1660278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1660281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660310 */     // MIs[0] policy
     /* 1660310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660320 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660344 */     // GIR_Coverage, 5939,
     /* 1660344 */     GIR_EraseRootFromParent_Done,
     /* 1660345 */   // Label 22826: @1660345
     /* 1660345 */   GIM_Try, /*On fail goto*//*Label 22827*/ GIMT_Encode4(1660431), // Rule ID 5942 //
     /* 1660350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1660361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1660364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1660367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660396 */     // MIs[0] policy
     /* 1660396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660406 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1660409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660430 */     // GIR_Coverage, 5942,
     /* 1660430 */     GIR_EraseRootFromParent_Done,
     /* 1660431 */   // Label 22827: @1660431
     /* 1660431 */   GIM_Try, /*On fail goto*//*Label 22828*/ GIMT_Encode4(1660517), // Rule ID 5943 //
     /* 1660436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1660439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1660447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1660450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1660453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660482 */     // MIs[0] policy
     /* 1660482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660492 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1660495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660516 */     // GIR_Coverage, 5943,
     /* 1660516 */     GIR_EraseRootFromParent_Done,
     /* 1660517 */   // Label 22828: @1660517
     /* 1660517 */   GIM_Try, /*On fail goto*//*Label 22829*/ GIMT_Encode4(1660603), // Rule ID 5946 //
     /* 1660522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1660533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1660536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1660539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660568 */     // MIs[0] policy
     /* 1660568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660578 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660602 */     // GIR_Coverage, 5946,
     /* 1660602 */     GIR_EraseRootFromParent_Done,
     /* 1660603 */   // Label 22829: @1660603
     /* 1660603 */   GIM_Try, /*On fail goto*//*Label 22830*/ GIMT_Encode4(1660689), // Rule ID 5947 //
     /* 1660608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1660611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1660619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1660622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1660625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660654 */     // MIs[0] policy
     /* 1660654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660664 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660688 */     // GIR_Coverage, 5947,
     /* 1660688 */     GIR_EraseRootFromParent_Done,
     /* 1660689 */   // Label 22830: @1660689
     /* 1660689 */   GIM_Try, /*On fail goto*//*Label 22831*/ GIMT_Encode4(1660775), // Rule ID 5950 //
     /* 1660694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1660705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1660708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1660711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660740 */     // MIs[0] policy
     /* 1660740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660750 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660774 */     // GIR_Coverage, 5950,
     /* 1660774 */     GIR_EraseRootFromParent_Done,
     /* 1660775 */   // Label 22831: @1660775
     /* 1660775 */   GIM_Try, /*On fail goto*//*Label 22832*/ GIMT_Encode4(1660861), // Rule ID 5951 //
     /* 1660780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1660783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1660791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1660794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1660797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660826 */     // MIs[0] policy
     /* 1660826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660836 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660860 */     // GIR_Coverage, 5951,
     /* 1660860 */     GIR_EraseRootFromParent_Done,
     /* 1660861 */   // Label 22832: @1660861
     /* 1660861 */   GIM_Try, /*On fail goto*//*Label 22833*/ GIMT_Encode4(1660947), // Rule ID 6042 //
     /* 1660866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1660877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1660880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1660883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1660886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1660889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1660896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660912 */     // MIs[0] policy
     /* 1660912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660922 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1660925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660946 */     // GIR_Coverage, 6042,
     /* 1660946 */     GIR_EraseRootFromParent_Done,
     /* 1660947 */   // Label 22833: @1660947
     /* 1660947 */   GIM_Try, /*On fail goto*//*Label 22834*/ GIMT_Encode4(1661033), // Rule ID 6043 //
     /* 1660952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1660963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1660966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1660969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1660972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1660975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1660982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660998 */     // MIs[0] policy
     /* 1660998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661008 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1661011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661032 */     // GIR_Coverage, 6043,
     /* 1661032 */     GIR_EraseRootFromParent_Done,
     /* 1661033 */   // Label 22834: @1661033
     /* 1661033 */   GIM_Try, /*On fail goto*//*Label 22835*/ GIMT_Encode4(1661119), // Rule ID 6046 //
     /* 1661038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1661049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1661052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1661055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1661058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661084 */     // MIs[0] policy
     /* 1661084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661094 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661118 */     // GIR_Coverage, 6046,
     /* 1661118 */     GIR_EraseRootFromParent_Done,
     /* 1661119 */   // Label 22835: @1661119
     /* 1661119 */   GIM_Try, /*On fail goto*//*Label 22836*/ GIMT_Encode4(1661205), // Rule ID 6047 //
     /* 1661124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1661135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1661138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1661141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1661144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661170 */     // MIs[0] policy
     /* 1661170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661180 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661204 */     // GIR_Coverage, 6047,
     /* 1661204 */     GIR_EraseRootFromParent_Done,
     /* 1661205 */   // Label 22836: @1661205
     /* 1661205 */   GIM_Try, /*On fail goto*//*Label 22837*/ GIMT_Encode4(1661291), // Rule ID 6050 //
     /* 1661210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1661221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1661224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1661227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1661230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661256 */     // MIs[0] policy
     /* 1661256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661266 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661290 */     // GIR_Coverage, 6050,
     /* 1661290 */     GIR_EraseRootFromParent_Done,
     /* 1661291 */   // Label 22837: @1661291
     /* 1661291 */   GIM_Try, /*On fail goto*//*Label 22838*/ GIMT_Encode4(1661377), // Rule ID 6051 //
     /* 1661296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1661307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1661310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1661313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1661316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661342 */     // MIs[0] policy
     /* 1661342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661352 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661376 */     // GIR_Coverage, 6051,
     /* 1661376 */     GIR_EraseRootFromParent_Done,
     /* 1661377 */   // Label 22838: @1661377
     /* 1661377 */   GIM_Try, /*On fail goto*//*Label 22839*/ GIMT_Encode4(1661463), // Rule ID 6054 //
     /* 1661382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1661393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1661396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1661399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1661402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661428 */     // MIs[0] policy
     /* 1661428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661438 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661462 */     // GIR_Coverage, 6054,
     /* 1661462 */     GIR_EraseRootFromParent_Done,
     /* 1661463 */   // Label 22839: @1661463
     /* 1661463 */   GIM_Try, /*On fail goto*//*Label 22840*/ GIMT_Encode4(1661549), // Rule ID 6055 //
     /* 1661468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1661479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1661482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1661485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1661488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661514 */     // MIs[0] policy
     /* 1661514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661524 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661548 */     // GIR_Coverage, 6055,
     /* 1661548 */     GIR_EraseRootFromParent_Done,
     /* 1661549 */   // Label 22840: @1661549
     /* 1661549 */   GIM_Try, /*On fail goto*//*Label 22841*/ GIMT_Encode4(1661635), // Rule ID 6058 //
     /* 1661554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1661565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1661568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1661571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1661574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661600 */     // MIs[0] policy
     /* 1661600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661610 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661634 */     // GIR_Coverage, 6058,
     /* 1661634 */     GIR_EraseRootFromParent_Done,
     /* 1661635 */   // Label 22841: @1661635
     /* 1661635 */   GIM_Try, /*On fail goto*//*Label 22842*/ GIMT_Encode4(1661721), // Rule ID 6059 //
     /* 1661640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1661651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1661654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1661657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1661660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661686 */     // MIs[0] policy
     /* 1661686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661720 */     // GIR_Coverage, 6059,
     /* 1661720 */     GIR_EraseRootFromParent_Done,
     /* 1661721 */   // Label 22842: @1661721
     /* 1661721 */   GIM_Try, /*On fail goto*//*Label 22843*/ GIMT_Encode4(1661807), // Rule ID 6062 //
     /* 1661726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1661737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1661740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1661743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1661746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661772 */     // MIs[0] policy
     /* 1661772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661806 */     // GIR_Coverage, 6062,
     /* 1661806 */     GIR_EraseRootFromParent_Done,
     /* 1661807 */   // Label 22843: @1661807
     /* 1661807 */   GIM_Try, /*On fail goto*//*Label 22844*/ GIMT_Encode4(1661893), // Rule ID 6063 //
     /* 1661812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1661823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1661826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1661829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1661832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661858 */     // MIs[0] policy
     /* 1661858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661892 */     // GIR_Coverage, 6063,
     /* 1661892 */     GIR_EraseRootFromParent_Done,
     /* 1661893 */   // Label 22844: @1661893
     /* 1661893 */   GIM_Try, /*On fail goto*//*Label 22845*/ GIMT_Encode4(1661979), // Rule ID 6066 //
     /* 1661898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1661909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1661912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1661915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1661918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661944 */     // MIs[0] policy
     /* 1661944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661954 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1661957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661978 */     // GIR_Coverage, 6066,
     /* 1661978 */     GIR_EraseRootFromParent_Done,
     /* 1661979 */   // Label 22845: @1661979
     /* 1661979 */   GIM_Try, /*On fail goto*//*Label 22846*/ GIMT_Encode4(1662065), // Rule ID 6067 //
     /* 1661984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1661995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1661998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1662001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1662004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1662007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662030 */     // MIs[0] policy
     /* 1662030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662064 */     // GIR_Coverage, 6067,
     /* 1662064 */     GIR_EraseRootFromParent_Done,
     /* 1662065 */   // Label 22846: @1662065
     /* 1662065 */   GIM_Try, /*On fail goto*//*Label 22847*/ GIMT_Encode4(1662151), // Rule ID 6070 //
     /* 1662070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1662081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1662084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1662087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1662090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662116 */     // MIs[0] policy
     /* 1662116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662126 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662150 */     // GIR_Coverage, 6070,
     /* 1662150 */     GIR_EraseRootFromParent_Done,
     /* 1662151 */   // Label 22847: @1662151
     /* 1662151 */   GIM_Try, /*On fail goto*//*Label 22848*/ GIMT_Encode4(1662237), // Rule ID 6071 //
     /* 1662156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1662167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1662170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1662173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1662176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662202 */     // MIs[0] policy
     /* 1662202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662212 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662236 */     // GIR_Coverage, 6071,
     /* 1662236 */     GIR_EraseRootFromParent_Done,
     /* 1662237 */   // Label 22848: @1662237
     /* 1662237 */   GIM_Try, /*On fail goto*//*Label 22849*/ GIMT_Encode4(1662323), // Rule ID 6074 //
     /* 1662242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1662253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1662256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1662259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1662262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662288 */     // MIs[0] policy
     /* 1662288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662298 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662322 */     // GIR_Coverage, 6074,
     /* 1662322 */     GIR_EraseRootFromParent_Done,
     /* 1662323 */   // Label 22849: @1662323
     /* 1662323 */   GIM_Try, /*On fail goto*//*Label 22850*/ GIMT_Encode4(1662409), // Rule ID 6075 //
     /* 1662328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1662339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1662342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1662345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1662348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662374 */     // MIs[0] policy
     /* 1662374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662384 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662408 */     // GIR_Coverage, 6075,
     /* 1662408 */     GIR_EraseRootFromParent_Done,
     /* 1662409 */   // Label 22850: @1662409
     /* 1662409 */   GIM_Try, /*On fail goto*//*Label 22851*/ GIMT_Encode4(1662495), // Rule ID 6078 //
     /* 1662414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1662417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1662425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1662428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1662431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1662434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662460 */     // MIs[0] policy
     /* 1662460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1662491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662494 */     // GIR_Coverage, 6078,
     /* 1662494 */     GIR_EraseRootFromParent_Done,
     /* 1662495 */   // Label 22851: @1662495
     /* 1662495 */   GIM_Try, /*On fail goto*//*Label 22852*/ GIMT_Encode4(1662581), // Rule ID 6079 //
     /* 1662500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1662503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1662511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1662514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1662517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1662520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662546 */     // MIs[0] policy
     /* 1662546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662556 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1662577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662580 */     // GIR_Coverage, 6079,
     /* 1662580 */     GIR_EraseRootFromParent_Done,
     /* 1662581 */   // Label 22852: @1662581
     /* 1662581 */   GIM_Try, /*On fail goto*//*Label 22853*/ GIMT_Encode4(1662667), // Rule ID 6082 //
     /* 1662586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1662597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1662600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1662603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1662606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1662609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1662616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662632 */     // MIs[0] policy
     /* 1662632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662642 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1662645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662666 */     // GIR_Coverage, 6082,
     /* 1662666 */     GIR_EraseRootFromParent_Done,
     /* 1662667 */   // Label 22853: @1662667
     /* 1662667 */   GIM_Try, /*On fail goto*//*Label 22854*/ GIMT_Encode4(1662753), // Rule ID 6083 //
     /* 1662672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1662683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1662686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1662689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1662692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1662695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1662702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662718 */     // MIs[0] policy
     /* 1662718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662728 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1662731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662752 */     // GIR_Coverage, 6083,
     /* 1662752 */     GIR_EraseRootFromParent_Done,
     /* 1662753 */   // Label 22854: @1662753
     /* 1662753 */   GIM_Try, /*On fail goto*//*Label 22855*/ GIMT_Encode4(1662839), // Rule ID 6086 //
     /* 1662758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1662769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1662772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1662775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1662778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1662781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1662788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662804 */     // MIs[0] policy
     /* 1662804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662814 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1662817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662838 */     // GIR_Coverage, 6086,
     /* 1662838 */     GIR_EraseRootFromParent_Done,
     /* 1662839 */   // Label 22855: @1662839
     /* 1662839 */   GIM_Try, /*On fail goto*//*Label 22856*/ GIMT_Encode4(1662925), // Rule ID 6087 //
     /* 1662844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1662855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1662858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1662861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1662864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1662867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1662874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662890 */     // MIs[0] policy
     /* 1662890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662900 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1662903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662924 */     // GIR_Coverage, 6087,
     /* 1662924 */     GIR_EraseRootFromParent_Done,
     /* 1662925 */   // Label 22856: @1662925
     /* 1662925 */   GIM_Try, /*On fail goto*//*Label 22857*/ GIMT_Encode4(1663011), // Rule ID 6090 //
     /* 1662930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1662941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1662944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1662947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1662950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1662953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1662960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1662964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1662968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1662972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662976 */     // MIs[0] policy
     /* 1662976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662986 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1662989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663010 */     // GIR_Coverage, 6090,
     /* 1663010 */     GIR_EraseRootFromParent_Done,
     /* 1663011 */   // Label 22857: @1663011
     /* 1663011 */   GIM_Try, /*On fail goto*//*Label 22858*/ GIMT_Encode4(1663097), // Rule ID 6091 //
     /* 1663016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1663027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1663030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1663033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1663036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1663039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663062 */     // MIs[0] policy
     /* 1663062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663072 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1663075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663096 */     // GIR_Coverage, 6091,
     /* 1663096 */     GIR_EraseRootFromParent_Done,
     /* 1663097 */   // Label 22858: @1663097
     /* 1663097 */   GIM_Try, /*On fail goto*//*Label 22859*/ GIMT_Encode4(1663183), // Rule ID 6094 //
     /* 1663102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1663113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1663116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1663119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1663122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663148 */     // MIs[0] policy
     /* 1663148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663158 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663182 */     // GIR_Coverage, 6094,
     /* 1663182 */     GIR_EraseRootFromParent_Done,
     /* 1663183 */   // Label 22859: @1663183
     /* 1663183 */   GIM_Try, /*On fail goto*//*Label 22860*/ GIMT_Encode4(1663269), // Rule ID 6095 //
     /* 1663188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1663199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1663202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1663205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1663208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663234 */     // MIs[0] policy
     /* 1663234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663244 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663268 */     // GIR_Coverage, 6095,
     /* 1663268 */     GIR_EraseRootFromParent_Done,
     /* 1663269 */   // Label 22860: @1663269
     /* 1663269 */   GIM_Try, /*On fail goto*//*Label 22861*/ GIMT_Encode4(1663355), // Rule ID 6098 //
     /* 1663274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1663285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1663288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1663291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1663294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663320 */     // MIs[0] policy
     /* 1663320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663330 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663354 */     // GIR_Coverage, 6098,
     /* 1663354 */     GIR_EraseRootFromParent_Done,
     /* 1663355 */   // Label 22861: @1663355
     /* 1663355 */   GIM_Try, /*On fail goto*//*Label 22862*/ GIMT_Encode4(1663441), // Rule ID 6099 //
     /* 1663360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1663371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1663374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1663377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1663380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663406 */     // MIs[0] policy
     /* 1663406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663416 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663440 */     // GIR_Coverage, 6099,
     /* 1663440 */     GIR_EraseRootFromParent_Done,
     /* 1663441 */   // Label 22862: @1663441
     /* 1663441 */   GIM_Try, /*On fail goto*//*Label 22863*/ GIMT_Encode4(1663527), // Rule ID 6102 //
     /* 1663446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1663457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1663460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1663463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1663466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663492 */     // MIs[0] policy
     /* 1663492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663502 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1663505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663526 */     // GIR_Coverage, 6102,
     /* 1663526 */     GIR_EraseRootFromParent_Done,
     /* 1663527 */   // Label 22863: @1663527
     /* 1663527 */   GIM_Try, /*On fail goto*//*Label 22864*/ GIMT_Encode4(1663613), // Rule ID 6103 //
     /* 1663532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1663543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1663546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1663549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1663552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663578 */     // MIs[0] policy
     /* 1663578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663588 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1663591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663612 */     // GIR_Coverage, 6103,
     /* 1663612 */     GIR_EraseRootFromParent_Done,
     /* 1663613 */   // Label 22864: @1663613
     /* 1663613 */   GIM_Try, /*On fail goto*//*Label 22865*/ GIMT_Encode4(1663699), // Rule ID 6106 //
     /* 1663618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1663629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1663632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1663635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1663638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1663641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663664 */     // MIs[0] policy
     /* 1663664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663674 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663698 */     // GIR_Coverage, 6106,
     /* 1663698 */     GIR_EraseRootFromParent_Done,
     /* 1663699 */   // Label 22865: @1663699
     /* 1663699 */   GIM_Try, /*On fail goto*//*Label 22866*/ GIMT_Encode4(1663785), // Rule ID 6107 //
     /* 1663704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1663715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1663718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1663721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1663724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1663727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663750 */     // MIs[0] policy
     /* 1663750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663784 */     // GIR_Coverage, 6107,
     /* 1663784 */     GIR_EraseRootFromParent_Done,
     /* 1663785 */   // Label 22866: @1663785
     /* 1663785 */   GIM_Try, /*On fail goto*//*Label 22867*/ GIMT_Encode4(1663871), // Rule ID 6110 //
     /* 1663790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1663801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1663804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1663807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1663810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663836 */     // MIs[0] policy
     /* 1663836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663870 */     // GIR_Coverage, 6110,
     /* 1663870 */     GIR_EraseRootFromParent_Done,
     /* 1663871 */   // Label 22867: @1663871
     /* 1663871 */   GIM_Try, /*On fail goto*//*Label 22868*/ GIMT_Encode4(1663957), // Rule ID 6111 //
     /* 1663876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1663887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1663890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1663893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1663896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663922 */     // MIs[0] policy
     /* 1663922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663932 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663956 */     // GIR_Coverage, 6111,
     /* 1663956 */     GIR_EraseRootFromParent_Done,
     /* 1663957 */   // Label 22868: @1663957
     /* 1663957 */   GIM_Try, /*On fail goto*//*Label 22869*/ GIMT_Encode4(1664043), // Rule ID 6114 //
     /* 1663962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1663973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1663976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1663979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1663982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664008 */     // MIs[0] policy
     /* 1664008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664042 */     // GIR_Coverage, 6114,
     /* 1664042 */     GIR_EraseRootFromParent_Done,
     /* 1664043 */   // Label 22869: @1664043
     /* 1664043 */   GIM_Try, /*On fail goto*//*Label 22870*/ GIMT_Encode4(1664129), // Rule ID 6115 //
     /* 1664048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1664059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1664062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1664065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1664068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664094 */     // MIs[0] policy
     /* 1664094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664104 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664128 */     // GIR_Coverage, 6115,
     /* 1664128 */     GIR_EraseRootFromParent_Done,
     /* 1664129 */   // Label 22870: @1664129
     /* 1664129 */   GIM_Try, /*On fail goto*//*Label 22871*/ GIMT_Encode4(1664215), // Rule ID 6118 //
     /* 1664134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1664145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1664148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1664151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1664154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664180 */     // MIs[0] policy
     /* 1664180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1664193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664214 */     // GIR_Coverage, 6118,
     /* 1664214 */     GIR_EraseRootFromParent_Done,
     /* 1664215 */   // Label 22871: @1664215
     /* 1664215 */   GIM_Try, /*On fail goto*//*Label 22872*/ GIMT_Encode4(1664301), // Rule ID 6119 //
     /* 1664220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1664231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1664234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1664237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1664240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664266 */     // MIs[0] policy
     /* 1664266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1664279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664300 */     // GIR_Coverage, 6119,
     /* 1664300 */     GIR_EraseRootFromParent_Done,
     /* 1664301 */   // Label 22872: @1664301
     /* 1664301 */   GIM_Try, /*On fail goto*//*Label 22873*/ GIMT_Encode4(1664387), // Rule ID 6122 //
     /* 1664306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1664317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1664320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1664323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1664326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664352 */     // MIs[0] policy
     /* 1664352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664362 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1664365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664386 */     // GIR_Coverage, 6122,
     /* 1664386 */     GIR_EraseRootFromParent_Done,
     /* 1664387 */   // Label 22873: @1664387
     /* 1664387 */   GIM_Try, /*On fail goto*//*Label 22874*/ GIMT_Encode4(1664473), // Rule ID 6123 //
     /* 1664392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1664403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1664406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1664409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1664412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664438 */     // MIs[0] policy
     /* 1664438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664448 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1664451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664472 */     // GIR_Coverage, 6123,
     /* 1664472 */     GIR_EraseRootFromParent_Done,
     /* 1664473 */   // Label 22874: @1664473
     /* 1664473 */   GIM_Try, /*On fail goto*//*Label 22875*/ GIMT_Encode4(1664559), // Rule ID 6126 //
     /* 1664478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1664489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1664492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1664495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1664498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664524 */     // MIs[0] policy
     /* 1664524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664534 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664558 */     // GIR_Coverage, 6126,
     /* 1664558 */     GIR_EraseRootFromParent_Done,
     /* 1664559 */   // Label 22875: @1664559
     /* 1664559 */   GIM_Try, /*On fail goto*//*Label 22876*/ GIMT_Encode4(1664645), // Rule ID 6127 //
     /* 1664564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1664575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1664578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1664581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1664584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664610 */     // MIs[0] policy
     /* 1664610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664620 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664644 */     // GIR_Coverage, 6127,
     /* 1664644 */     GIR_EraseRootFromParent_Done,
     /* 1664645 */   // Label 22876: @1664645
     /* 1664645 */   GIM_Try, /*On fail goto*//*Label 22877*/ GIMT_Encode4(1664731), // Rule ID 6130 //
     /* 1664650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1664661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1664664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1664667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1664673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664696 */     // MIs[0] policy
     /* 1664696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664706 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1664709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664730 */     // GIR_Coverage, 6130,
     /* 1664730 */     GIR_EraseRootFromParent_Done,
     /* 1664731 */   // Label 22877: @1664731
     /* 1664731 */   GIM_Try, /*On fail goto*//*Label 22878*/ GIMT_Encode4(1664817), // Rule ID 6131 //
     /* 1664736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1664747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1664750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1664753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1664759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664782 */     // MIs[0] policy
     /* 1664782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664792 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1664795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664816 */     // GIR_Coverage, 6131,
     /* 1664816 */     GIR_EraseRootFromParent_Done,
     /* 1664817 */   // Label 22878: @1664817
     /* 1664817 */   GIM_Try, /*On fail goto*//*Label 22879*/ GIMT_Encode4(1664903), // Rule ID 6134 //
     /* 1664822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1664833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1664836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1664839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664868 */     // MIs[0] policy
     /* 1664868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664878 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1664881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664902 */     // GIR_Coverage, 6134,
     /* 1664902 */     GIR_EraseRootFromParent_Done,
     /* 1664903 */   // Label 22879: @1664903
     /* 1664903 */   GIM_Try, /*On fail goto*//*Label 22880*/ GIMT_Encode4(1664989), // Rule ID 6135 //
     /* 1664908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1664919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1664922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1664925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664954 */     // MIs[0] policy
     /* 1664954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664964 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1664967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664988 */     // GIR_Coverage, 6135,
     /* 1664988 */     GIR_EraseRootFromParent_Done,
     /* 1664989 */   // Label 22880: @1664989
     /* 1664989 */   GIM_Try, /*On fail goto*//*Label 22881*/ GIMT_Encode4(1665075), // Rule ID 6138 //
     /* 1664994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1665005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1665008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1665011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665040 */     // MIs[0] policy
     /* 1665040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665050 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665074 */     // GIR_Coverage, 6138,
     /* 1665074 */     GIR_EraseRootFromParent_Done,
     /* 1665075 */   // Label 22881: @1665075
     /* 1665075 */   GIM_Try, /*On fail goto*//*Label 22882*/ GIMT_Encode4(1665161), // Rule ID 6139 //
     /* 1665080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1665091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1665094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1665097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665126 */     // MIs[0] policy
     /* 1665126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665136 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665160 */     // GIR_Coverage, 6139,
     /* 1665160 */     GIR_EraseRootFromParent_Done,
     /* 1665161 */   // Label 22882: @1665161
     /* 1665161 */   GIM_Try, /*On fail goto*//*Label 22883*/ GIMT_Encode4(1665247), // Rule ID 6142 //
     /* 1665166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1665177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1665180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1665183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665212 */     // MIs[0] policy
     /* 1665212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665222 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1665225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665246 */     // GIR_Coverage, 6142,
     /* 1665246 */     GIR_EraseRootFromParent_Done,
     /* 1665247 */   // Label 22883: @1665247
     /* 1665247 */   GIM_Try, /*On fail goto*//*Label 22884*/ GIMT_Encode4(1665333), // Rule ID 6143 //
     /* 1665252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1665263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1665266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1665269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665298 */     // MIs[0] policy
     /* 1665298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665308 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1665311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665332 */     // GIR_Coverage, 6143,
     /* 1665332 */     GIR_EraseRootFromParent_Done,
     /* 1665333 */   // Label 22884: @1665333
     /* 1665333 */   GIM_Try, /*On fail goto*//*Label 22885*/ GIMT_Encode4(1665419), // Rule ID 6146 //
     /* 1665338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1665349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1665352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1665355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665384 */     // MIs[0] policy
     /* 1665384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665394 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665418 */     // GIR_Coverage, 6146,
     /* 1665418 */     GIR_EraseRootFromParent_Done,
     /* 1665419 */   // Label 22885: @1665419
     /* 1665419 */   GIM_Try, /*On fail goto*//*Label 22886*/ GIMT_Encode4(1665505), // Rule ID 6147 //
     /* 1665424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1665435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1665438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1665441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665470 */     // MIs[0] policy
     /* 1665470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665480 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665504 */     // GIR_Coverage, 6147,
     /* 1665504 */     GIR_EraseRootFromParent_Done,
     /* 1665505 */   // Label 22886: @1665505
     /* 1665505 */   GIM_Try, /*On fail goto*//*Label 22887*/ GIMT_Encode4(1665591), // Rule ID 6150 //
     /* 1665510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1665521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1665524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1665527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665556 */     // MIs[0] policy
     /* 1665556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665566 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665590 */     // GIR_Coverage, 6150,
     /* 1665590 */     GIR_EraseRootFromParent_Done,
     /* 1665591 */   // Label 22887: @1665591
     /* 1665591 */   GIM_Try, /*On fail goto*//*Label 22888*/ GIMT_Encode4(1665677), // Rule ID 6151 //
     /* 1665596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1665607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1665610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1665613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665642 */     // MIs[0] policy
     /* 1665642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665676 */     // GIR_Coverage, 6151,
     /* 1665676 */     GIR_EraseRootFromParent_Done,
     /* 1665677 */   // Label 22888: @1665677
     /* 1665677 */   GIM_Try, /*On fail goto*//*Label 22889*/ GIMT_Encode4(1665763), // Rule ID 6154 //
     /* 1665682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1665693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1665696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1665699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665728 */     // MIs[0] policy
     /* 1665728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665738 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1665741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665762 */     // GIR_Coverage, 6154,
     /* 1665762 */     GIR_EraseRootFromParent_Done,
     /* 1665763 */   // Label 22889: @1665763
     /* 1665763 */   GIM_Try, /*On fail goto*//*Label 22890*/ GIMT_Encode4(1665849), // Rule ID 6155 //
     /* 1665768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1665779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1665782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1665785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665814 */     // MIs[0] policy
     /* 1665814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665824 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1665827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665848 */     // GIR_Coverage, 6155,
     /* 1665848 */     GIR_EraseRootFromParent_Done,
     /* 1665849 */   // Label 22890: @1665849
     /* 1665849 */   GIM_Try, /*On fail goto*//*Label 22891*/ GIMT_Encode4(1665935), // Rule ID 6158 //
     /* 1665854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1665865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1665868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1665871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665900 */     // MIs[0] policy
     /* 1665900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665910 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1665913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665934 */     // GIR_Coverage, 6158,
     /* 1665934 */     GIR_EraseRootFromParent_Done,
     /* 1665935 */   // Label 22891: @1665935
     /* 1665935 */   GIM_Try, /*On fail goto*//*Label 22892*/ GIMT_Encode4(1666021), // Rule ID 6159 //
     /* 1665940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1665951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1665954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1665957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665986 */     // MIs[0] policy
     /* 1665986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1665999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666020 */     // GIR_Coverage, 6159,
     /* 1666020 */     GIR_EraseRootFromParent_Done,
     /* 1666021 */   // Label 22892: @1666021
     /* 1666021 */   GIM_Try, /*On fail goto*//*Label 22893*/ GIMT_Encode4(1666107), // Rule ID 6162 //
     /* 1666026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1666037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1666040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1666043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666072 */     // MIs[0] policy
     /* 1666072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666082 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666106 */     // GIR_Coverage, 6162,
     /* 1666106 */     GIR_EraseRootFromParent_Done,
     /* 1666107 */   // Label 22893: @1666107
     /* 1666107 */   GIM_Try, /*On fail goto*//*Label 22894*/ GIMT_Encode4(1666193), // Rule ID 6163 //
     /* 1666112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1666123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1666126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1666129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666158 */     // MIs[0] policy
     /* 1666158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666168 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666192 */     // GIR_Coverage, 6163,
     /* 1666192 */     GIR_EraseRootFromParent_Done,
     /* 1666193 */   // Label 22894: @1666193
     /* 1666193 */   GIM_Try, /*On fail goto*//*Label 22895*/ GIMT_Encode4(1666279), // Rule ID 6166 //
     /* 1666198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1666201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1666209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1666212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1666215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666244 */     // MIs[0] policy
     /* 1666244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666254 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666278 */     // GIR_Coverage, 6166,
     /* 1666278 */     GIR_EraseRootFromParent_Done,
     /* 1666279 */   // Label 22895: @1666279
     /* 1666279 */   GIM_Try, /*On fail goto*//*Label 22896*/ GIMT_Encode4(1666365), // Rule ID 6167 //
     /* 1666284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1666287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1666295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1666298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1666301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666330 */     // MIs[0] policy
     /* 1666330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666340 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666364 */     // GIR_Coverage, 6167,
     /* 1666364 */     GIR_EraseRootFromParent_Done,
     /* 1666365 */   // Label 22896: @1666365
     /* 1666365 */   GIM_Try, /*On fail goto*//*Label 22897*/ GIMT_Encode4(1666451), // Rule ID 6170 //
     /* 1666370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1666381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1666384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1666387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1666393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666416 */     // MIs[0] policy
     /* 1666416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666426 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1666429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666450 */     // GIR_Coverage, 6170,
     /* 1666450 */     GIR_EraseRootFromParent_Done,
     /* 1666451 */   // Label 22897: @1666451
     /* 1666451 */   GIM_Try, /*On fail goto*//*Label 22898*/ GIMT_Encode4(1666537), // Rule ID 6171 //
     /* 1666456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1666467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1666470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1666473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1666479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666502 */     // MIs[0] policy
     /* 1666502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666512 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1666515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666536 */     // GIR_Coverage, 6171,
     /* 1666536 */     GIR_EraseRootFromParent_Done,
     /* 1666537 */   // Label 22898: @1666537
     /* 1666537 */   GIM_Try, /*On fail goto*//*Label 22899*/ GIMT_Encode4(1666623), // Rule ID 6174 //
     /* 1666542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1666553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1666556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1666559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1666565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1666572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666588 */     // MIs[0] policy
     /* 1666588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666598 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1666601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666622 */     // GIR_Coverage, 6174,
     /* 1666622 */     GIR_EraseRootFromParent_Done,
     /* 1666623 */   // Label 22899: @1666623
     /* 1666623 */   GIM_Try, /*On fail goto*//*Label 22900*/ GIMT_Encode4(1666709), // Rule ID 6175 //
     /* 1666628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1666639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1666642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1666645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1666651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1666658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666674 */     // MIs[0] policy
     /* 1666674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666684 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1666687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666708 */     // GIR_Coverage, 6175,
     /* 1666708 */     GIR_EraseRootFromParent_Done,
     /* 1666709 */   // Label 22900: @1666709
     /* 1666709 */   GIM_Try, /*On fail goto*//*Label 22901*/ GIMT_Encode4(1666795), // Rule ID 6178 //
     /* 1666714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1666725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1666728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1666731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1666737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1666744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666760 */     // MIs[0] policy
     /* 1666760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666770 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1666773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666794 */     // GIR_Coverage, 6178,
     /* 1666794 */     GIR_EraseRootFromParent_Done,
     /* 1666795 */   // Label 22901: @1666795
     /* 1666795 */   GIM_Try, /*On fail goto*//*Label 22902*/ GIMT_Encode4(1666881), // Rule ID 6179 //
     /* 1666800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1666811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1666814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1666817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1666823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1666830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666846 */     // MIs[0] policy
     /* 1666846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666856 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1666859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666880 */     // GIR_Coverage, 6179,
     /* 1666880 */     GIR_EraseRootFromParent_Done,
     /* 1666881 */   // Label 22902: @1666881
     /* 1666881 */   GIM_Try, /*On fail goto*//*Label 22903*/ GIMT_Encode4(1666967), // Rule ID 6182 //
     /* 1666886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1666897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1666900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1666903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666932 */     // MIs[0] policy
     /* 1666932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666942 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1666945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666966 */     // GIR_Coverage, 6182,
     /* 1666966 */     GIR_EraseRootFromParent_Done,
     /* 1666967 */   // Label 22903: @1666967
     /* 1666967 */   GIM_Try, /*On fail goto*//*Label 22904*/ GIMT_Encode4(1667053), // Rule ID 6183 //
     /* 1666972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1666983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1666986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1666989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667018 */     // MIs[0] policy
     /* 1667018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667028 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667052 */     // GIR_Coverage, 6183,
     /* 1667052 */     GIR_EraseRootFromParent_Done,
     /* 1667053 */   // Label 22904: @1667053
     /* 1667053 */   GIM_Try, /*On fail goto*//*Label 22905*/ GIMT_Encode4(1667139), // Rule ID 6186 //
     /* 1667058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1667069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1667072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1667075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667104 */     // MIs[0] policy
     /* 1667104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667114 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667138 */     // GIR_Coverage, 6186,
     /* 1667138 */     GIR_EraseRootFromParent_Done,
     /* 1667139 */   // Label 22905: @1667139
     /* 1667139 */   GIM_Try, /*On fail goto*//*Label 22906*/ GIMT_Encode4(1667225), // Rule ID 6187 //
     /* 1667144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1667155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1667158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1667161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667190 */     // MIs[0] policy
     /* 1667190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667200 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667224 */     // GIR_Coverage, 6187,
     /* 1667224 */     GIR_EraseRootFromParent_Done,
     /* 1667225 */   // Label 22906: @1667225
     /* 1667225 */   GIM_Try, /*On fail goto*//*Label 22907*/ GIMT_Encode4(1667311), // Rule ID 6190 //
     /* 1667230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1667241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1667244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1667247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667276 */     // MIs[0] policy
     /* 1667276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667310 */     // GIR_Coverage, 6190,
     /* 1667310 */     GIR_EraseRootFromParent_Done,
     /* 1667311 */   // Label 22907: @1667311
     /* 1667311 */   GIM_Try, /*On fail goto*//*Label 22908*/ GIMT_Encode4(1667397), // Rule ID 6191 //
     /* 1667316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1667327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1667330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1667333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667362 */     // MIs[0] policy
     /* 1667362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667372 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667396 */     // GIR_Coverage, 6191,
     /* 1667396 */     GIR_EraseRootFromParent_Done,
     /* 1667397 */   // Label 22908: @1667397
     /* 1667397 */   GIM_Try, /*On fail goto*//*Label 22909*/ GIMT_Encode4(1667483), // Rule ID 6194 //
     /* 1667402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1667413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1667416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1667419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667448 */     // MIs[0] policy
     /* 1667448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667482 */     // GIR_Coverage, 6194,
     /* 1667482 */     GIR_EraseRootFromParent_Done,
     /* 1667483 */   // Label 22909: @1667483
     /* 1667483 */   GIM_Try, /*On fail goto*//*Label 22910*/ GIMT_Encode4(1667569), // Rule ID 6195 //
     /* 1667488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1667499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1667502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1667505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667534 */     // MIs[0] policy
     /* 1667534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667568 */     // GIR_Coverage, 6195,
     /* 1667568 */     GIR_EraseRootFromParent_Done,
     /* 1667569 */   // Label 22910: @1667569
     /* 1667569 */   GIM_Try, /*On fail goto*//*Label 22911*/ GIMT_Encode4(1667655), // Rule ID 6198 //
     /* 1667574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1667585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1667588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1667591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667620 */     // MIs[0] policy
     /* 1667620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667630 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667654 */     // GIR_Coverage, 6198,
     /* 1667654 */     GIR_EraseRootFromParent_Done,
     /* 1667655 */   // Label 22911: @1667655
     /* 1667655 */   GIM_Try, /*On fail goto*//*Label 22912*/ GIMT_Encode4(1667741), // Rule ID 6199 //
     /* 1667660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1667671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1667674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1667677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667706 */     // MIs[0] policy
     /* 1667706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667740 */     // GIR_Coverage, 6199,
     /* 1667740 */     GIR_EraseRootFromParent_Done,
     /* 1667741 */   // Label 22912: @1667741
     /* 1667741 */   GIM_Try, /*On fail goto*//*Label 22913*/ GIMT_Encode4(1667827), // Rule ID 6202 //
     /* 1667746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1667757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1667760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1667763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667792 */     // MIs[0] policy
     /* 1667792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667802 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667826 */     // GIR_Coverage, 6202,
     /* 1667826 */     GIR_EraseRootFromParent_Done,
     /* 1667827 */   // Label 22913: @1667827
     /* 1667827 */   GIM_Try, /*On fail goto*//*Label 22914*/ GIMT_Encode4(1667913), // Rule ID 6203 //
     /* 1667832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1667843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1667846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1667849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667878 */     // MIs[0] policy
     /* 1667878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667888 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667912 */     // GIR_Coverage, 6203,
     /* 1667912 */     GIR_EraseRootFromParent_Done,
     /* 1667913 */   // Label 22914: @1667913
     /* 1667913 */   GIM_Try, /*On fail goto*//*Label 22915*/ GIMT_Encode4(1667999), // Rule ID 6206 //
     /* 1667918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1667921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1667929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1667932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1667935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1667941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667964 */     // MIs[0] policy
     /* 1667964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667974 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667998 */     // GIR_Coverage, 6206,
     /* 1667998 */     GIR_EraseRootFromParent_Done,
     /* 1667999 */   // Label 22915: @1667999
     /* 1667999 */   GIM_Try, /*On fail goto*//*Label 22916*/ GIMT_Encode4(1668085), // Rule ID 6207 //
     /* 1668004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1668015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1668018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1668021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668050 */     // MIs[0] policy
     /* 1668050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668060 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1668063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668084 */     // GIR_Coverage, 6207,
     /* 1668084 */     GIR_EraseRootFromParent_Done,
     /* 1668085 */   // Label 22916: @1668085
     /* 1668085 */   GIM_Try, /*On fail goto*//*Label 22917*/ GIMT_Encode4(1668171), // Rule ID 6210 //
     /* 1668090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1668093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668136 */     // MIs[0] policy
     /* 1668136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668146 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1668149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668170 */     // GIR_Coverage, 6210,
     /* 1668170 */     GIR_EraseRootFromParent_Done,
     /* 1668171 */   // Label 22917: @1668171
     /* 1668171 */   GIM_Try, /*On fail goto*//*Label 22918*/ GIMT_Encode4(1668257), // Rule ID 6211 //
     /* 1668176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668222 */     // MIs[0] policy
     /* 1668222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668232 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1668235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668256 */     // GIR_Coverage, 6211,
     /* 1668256 */     GIR_EraseRootFromParent_Done,
     /* 1668257 */   // Label 22918: @1668257
     /* 1668257 */   GIM_Try, /*On fail goto*//*Label 22919*/ GIMT_Encode4(1668343), // Rule ID 6214 //
     /* 1668262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1668265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1668273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1668276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1668279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668308 */     // MIs[0] policy
     /* 1668308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668318 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1668321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668342 */     // GIR_Coverage, 6214,
     /* 1668342 */     GIR_EraseRootFromParent_Done,
     /* 1668343 */   // Label 22919: @1668343
     /* 1668343 */   GIM_Try, /*On fail goto*//*Label 22920*/ GIMT_Encode4(1668429), // Rule ID 6215 //
     /* 1668348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1668359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1668362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1668365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668394 */     // MIs[0] policy
     /* 1668394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668404 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1668407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668428 */     // GIR_Coverage, 6215,
     /* 1668428 */     GIR_EraseRootFromParent_Done,
     /* 1668429 */   // Label 22920: @1668429
     /* 1668429 */   GIM_Try, /*On fail goto*//*Label 22921*/ GIMT_Encode4(1668515), // Rule ID 6306 //
     /* 1668434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1668445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1668448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1668451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1668454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1668457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668480 */     // MIs[0] policy
     /* 1668480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668490 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1668493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668514 */     // GIR_Coverage, 6306,
     /* 1668514 */     GIR_EraseRootFromParent_Done,
     /* 1668515 */   // Label 22921: @1668515
     /* 1668515 */   GIM_Try, /*On fail goto*//*Label 22922*/ GIMT_Encode4(1668601), // Rule ID 6307 //
     /* 1668520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1668531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1668534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1668537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1668540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1668543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668566 */     // MIs[0] policy
     /* 1668566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668576 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1668579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668600 */     // GIR_Coverage, 6307,
     /* 1668600 */     GIR_EraseRootFromParent_Done,
     /* 1668601 */   // Label 22922: @1668601
     /* 1668601 */   GIM_Try, /*On fail goto*//*Label 22923*/ GIMT_Encode4(1668687), // Rule ID 6310 //
     /* 1668606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1668617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1668620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1668623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1668626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668652 */     // MIs[0] policy
     /* 1668652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668662 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1668665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668686 */     // GIR_Coverage, 6310,
     /* 1668686 */     GIR_EraseRootFromParent_Done,
     /* 1668687 */   // Label 22923: @1668687
     /* 1668687 */   GIM_Try, /*On fail goto*//*Label 22924*/ GIMT_Encode4(1668773), // Rule ID 6311 //
     /* 1668692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1668703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1668706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1668709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1668712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668738 */     // MIs[0] policy
     /* 1668738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668748 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1668751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668772 */     // GIR_Coverage, 6311,
     /* 1668772 */     GIR_EraseRootFromParent_Done,
     /* 1668773 */   // Label 22924: @1668773
     /* 1668773 */   GIM_Try, /*On fail goto*//*Label 22925*/ GIMT_Encode4(1668859), // Rule ID 6314 //
     /* 1668778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1668789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1668792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1668795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1668798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668824 */     // MIs[0] policy
     /* 1668824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668834 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1668837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668858 */     // GIR_Coverage, 6314,
     /* 1668858 */     GIR_EraseRootFromParent_Done,
     /* 1668859 */   // Label 22925: @1668859
     /* 1668859 */   GIM_Try, /*On fail goto*//*Label 22926*/ GIMT_Encode4(1668945), // Rule ID 6315 //
     /* 1668864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1668875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1668878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1668881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1668884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668910 */     // MIs[0] policy
     /* 1668910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668920 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1668923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668944 */     // GIR_Coverage, 6315,
     /* 1668944 */     GIR_EraseRootFromParent_Done,
     /* 1668945 */   // Label 22926: @1668945
     /* 1668945 */   GIM_Try, /*On fail goto*//*Label 22927*/ GIMT_Encode4(1669031), // Rule ID 6318 //
     /* 1668950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1668961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1668964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1668967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1668970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1668973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668996 */     // MIs[0] policy
     /* 1668996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669006 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1669009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669030 */     // GIR_Coverage, 6318,
     /* 1669030 */     GIR_EraseRootFromParent_Done,
     /* 1669031 */   // Label 22927: @1669031
     /* 1669031 */   GIM_Try, /*On fail goto*//*Label 22928*/ GIMT_Encode4(1669117), // Rule ID 6319 //
     /* 1669036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1669047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1669050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1669053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1669056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669082 */     // MIs[0] policy
     /* 1669082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669092 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1669095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669116 */     // GIR_Coverage, 6319,
     /* 1669116 */     GIR_EraseRootFromParent_Done,
     /* 1669117 */   // Label 22928: @1669117
     /* 1669117 */   GIM_Try, /*On fail goto*//*Label 22929*/ GIMT_Encode4(1669203), // Rule ID 6322 //
     /* 1669122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1669133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1669136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1669139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1669142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669168 */     // MIs[0] policy
     /* 1669168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669178 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669202 */     // GIR_Coverage, 6322,
     /* 1669202 */     GIR_EraseRootFromParent_Done,
     /* 1669203 */   // Label 22929: @1669203
     /* 1669203 */   GIM_Try, /*On fail goto*//*Label 22930*/ GIMT_Encode4(1669289), // Rule ID 6323 //
     /* 1669208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1669219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1669222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1669225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1669228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669254 */     // MIs[0] policy
     /* 1669254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669288 */     // GIR_Coverage, 6323,
     /* 1669288 */     GIR_EraseRootFromParent_Done,
     /* 1669289 */   // Label 22930: @1669289
     /* 1669289 */   GIM_Try, /*On fail goto*//*Label 22931*/ GIMT_Encode4(1669375), // Rule ID 6326 //
     /* 1669294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1669305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1669308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1669311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1669314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669340 */     // MIs[0] policy
     /* 1669340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669350 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669374 */     // GIR_Coverage, 6326,
     /* 1669374 */     GIR_EraseRootFromParent_Done,
     /* 1669375 */   // Label 22931: @1669375
     /* 1669375 */   GIM_Try, /*On fail goto*//*Label 22932*/ GIMT_Encode4(1669461), // Rule ID 6327 //
     /* 1669380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1669391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1669394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1669397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1669400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669426 */     // MIs[0] policy
     /* 1669426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669436 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669460 */     // GIR_Coverage, 6327,
     /* 1669460 */     GIR_EraseRootFromParent_Done,
     /* 1669461 */   // Label 22932: @1669461
     /* 1669461 */   GIM_Try, /*On fail goto*//*Label 22933*/ GIMT_Encode4(1669547), // Rule ID 6330 //
     /* 1669466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1669477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1669480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1669483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1669486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669512 */     // MIs[0] policy
     /* 1669512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669522 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669546 */     // GIR_Coverage, 6330,
     /* 1669546 */     GIR_EraseRootFromParent_Done,
     /* 1669547 */   // Label 22933: @1669547
     /* 1669547 */   GIM_Try, /*On fail goto*//*Label 22934*/ GIMT_Encode4(1669633), // Rule ID 6331 //
     /* 1669552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1669563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1669566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1669569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1669572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669598 */     // MIs[0] policy
     /* 1669598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669608 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669632 */     // GIR_Coverage, 6331,
     /* 1669632 */     GIR_EraseRootFromParent_Done,
     /* 1669633 */   // Label 22934: @1669633
     /* 1669633 */   GIM_Try, /*On fail goto*//*Label 22935*/ GIMT_Encode4(1669719), // Rule ID 6334 //
     /* 1669638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1669649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1669652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1669655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1669658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669684 */     // MIs[0] policy
     /* 1669684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669718 */     // GIR_Coverage, 6334,
     /* 1669718 */     GIR_EraseRootFromParent_Done,
     /* 1669719 */   // Label 22935: @1669719
     /* 1669719 */   GIM_Try, /*On fail goto*//*Label 22936*/ GIMT_Encode4(1669805), // Rule ID 6335 //
     /* 1669724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1669735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1669738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1669741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1669744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669770 */     // MIs[0] policy
     /* 1669770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669780 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669804 */     // GIR_Coverage, 6335,
     /* 1669804 */     GIR_EraseRootFromParent_Done,
     /* 1669805 */   // Label 22936: @1669805
     /* 1669805 */   GIM_Try, /*On fail goto*//*Label 22937*/ GIMT_Encode4(1669891), // Rule ID 6338 //
     /* 1669810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1669821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1669824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1669827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1669830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669856 */     // MIs[0] policy
     /* 1669856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669866 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669890 */     // GIR_Coverage, 6338,
     /* 1669890 */     GIR_EraseRootFromParent_Done,
     /* 1669891 */   // Label 22937: @1669891
     /* 1669891 */   GIM_Try, /*On fail goto*//*Label 22938*/ GIMT_Encode4(1669977), // Rule ID 6339 //
     /* 1669896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1669907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1669910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1669913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1669916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669942 */     // MIs[0] policy
     /* 1669942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669976 */     // GIR_Coverage, 6339,
     /* 1669976 */     GIR_EraseRootFromParent_Done,
     /* 1669977 */   // Label 22938: @1669977
     /* 1669977 */   GIM_Try, /*On fail goto*//*Label 22939*/ GIMT_Encode4(1670063), // Rule ID 6342 //
     /* 1669982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1669985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1669993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1669996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1669999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1670002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670028 */     // MIs[0] policy
     /* 1670028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670038 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1670059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670062 */     // GIR_Coverage, 6342,
     /* 1670062 */     GIR_EraseRootFromParent_Done,
     /* 1670063 */   // Label 22939: @1670063
     /* 1670063 */   GIM_Try, /*On fail goto*//*Label 22940*/ GIMT_Encode4(1670149), // Rule ID 6343 //
     /* 1670068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1670071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1670079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1670082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1670085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1670088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670114 */     // MIs[0] policy
     /* 1670114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670124 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1670145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670148 */     // GIR_Coverage, 6343,
     /* 1670148 */     GIR_EraseRootFromParent_Done,
     /* 1670149 */   // Label 22940: @1670149
     /* 1670149 */   GIM_Try, /*On fail goto*//*Label 22941*/ GIMT_Encode4(1670235), // Rule ID 6346 //
     /* 1670154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1670165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1670168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1670171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1670174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670200 */     // MIs[0] policy
     /* 1670200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670210 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1670213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670234 */     // GIR_Coverage, 6346,
     /* 1670234 */     GIR_EraseRootFromParent_Done,
     /* 1670235 */   // Label 22941: @1670235
     /* 1670235 */   GIM_Try, /*On fail goto*//*Label 22942*/ GIMT_Encode4(1670321), // Rule ID 6347 //
     /* 1670240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1670251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1670254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1670257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1670260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670286 */     // MIs[0] policy
     /* 1670286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670296 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1670299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670320 */     // GIR_Coverage, 6347,
     /* 1670320 */     GIR_EraseRootFromParent_Done,
     /* 1670321 */   // Label 22942: @1670321
     /* 1670321 */   GIM_Try, /*On fail goto*//*Label 22943*/ GIMT_Encode4(1670407), // Rule ID 6350 //
     /* 1670326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1670337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1670340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1670343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1670346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1670349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670372 */     // MIs[0] policy
     /* 1670372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670382 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1670385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670406 */     // GIR_Coverage, 6350,
     /* 1670406 */     GIR_EraseRootFromParent_Done,
     /* 1670407 */   // Label 22943: @1670407
     /* 1670407 */   GIM_Try, /*On fail goto*//*Label 22944*/ GIMT_Encode4(1670493), // Rule ID 6351 //
     /* 1670412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1670423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1670426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1670429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1670432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1670435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670458 */     // MIs[0] policy
     /* 1670458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670468 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1670471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670492 */     // GIR_Coverage, 6351,
     /* 1670492 */     GIR_EraseRootFromParent_Done,
     /* 1670493 */   // Label 22944: @1670493
     /* 1670493 */   GIM_Try, /*On fail goto*//*Label 22945*/ GIMT_Encode4(1670579), // Rule ID 6354 //
     /* 1670498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1670509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1670512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1670515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1670518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1670521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1670528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670544 */     // MIs[0] policy
     /* 1670544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670554 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1670557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670578 */     // GIR_Coverage, 6354,
     /* 1670578 */     GIR_EraseRootFromParent_Done,
     /* 1670579 */   // Label 22945: @1670579
     /* 1670579 */   GIM_Try, /*On fail goto*//*Label 22946*/ GIMT_Encode4(1670665), // Rule ID 6355 //
     /* 1670584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1670595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1670598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1670601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1670604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1670607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1670614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670630 */     // MIs[0] policy
     /* 1670630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670640 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1670643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670664 */     // GIR_Coverage, 6355,
     /* 1670664 */     GIR_EraseRootFromParent_Done,
     /* 1670665 */   // Label 22946: @1670665
     /* 1670665 */   GIM_Try, /*On fail goto*//*Label 22947*/ GIMT_Encode4(1670751), // Rule ID 6358 //
     /* 1670670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1670681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1670684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1670687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1670690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1670693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670716 */     // MIs[0] policy
     /* 1670716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1670729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670750 */     // GIR_Coverage, 6358,
     /* 1670750 */     GIR_EraseRootFromParent_Done,
     /* 1670751 */   // Label 22947: @1670751
     /* 1670751 */   GIM_Try, /*On fail goto*//*Label 22948*/ GIMT_Encode4(1670837), // Rule ID 6359 //
     /* 1670756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1670767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1670770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1670773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1670776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1670779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670802 */     // MIs[0] policy
     /* 1670802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670812 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1670815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670836 */     // GIR_Coverage, 6359,
     /* 1670836 */     GIR_EraseRootFromParent_Done,
     /* 1670837 */   // Label 22948: @1670837
     /* 1670837 */   GIM_Try, /*On fail goto*//*Label 22949*/ GIMT_Encode4(1670923), // Rule ID 6362 //
     /* 1670842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1670853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1670856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1670859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1670862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670888 */     // MIs[0] policy
     /* 1670888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670898 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1670901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670922 */     // GIR_Coverage, 6362,
     /* 1670922 */     GIR_EraseRootFromParent_Done,
     /* 1670923 */   // Label 22949: @1670923
     /* 1670923 */   GIM_Try, /*On fail goto*//*Label 22950*/ GIMT_Encode4(1671009), // Rule ID 6363 //
     /* 1670928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1670939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1670942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1670945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1670948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670974 */     // MIs[0] policy
     /* 1670974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670984 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1670987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671008 */     // GIR_Coverage, 6363,
     /* 1671008 */     GIR_EraseRootFromParent_Done,
     /* 1671009 */   // Label 22950: @1671009
     /* 1671009 */   GIM_Try, /*On fail goto*//*Label 22951*/ GIMT_Encode4(1671095), // Rule ID 6366 //
     /* 1671014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1671025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1671028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1671031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1671034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671060 */     // MIs[0] policy
     /* 1671060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671070 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671094 */     // GIR_Coverage, 6366,
     /* 1671094 */     GIR_EraseRootFromParent_Done,
     /* 1671095 */   // Label 22951: @1671095
     /* 1671095 */   GIM_Try, /*On fail goto*//*Label 22952*/ GIMT_Encode4(1671181), // Rule ID 6367 //
     /* 1671100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1671111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1671114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1671117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1671120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671146 */     // MIs[0] policy
     /* 1671146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671156 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671180 */     // GIR_Coverage, 6367,
     /* 1671180 */     GIR_EraseRootFromParent_Done,
     /* 1671181 */   // Label 22952: @1671181
     /* 1671181 */   GIM_Try, /*On fail goto*//*Label 22953*/ GIMT_Encode4(1671267), // Rule ID 6370 //
     /* 1671186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1671197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1671200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1671203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1671206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671232 */     // MIs[0] policy
     /* 1671232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671266 */     // GIR_Coverage, 6370,
     /* 1671266 */     GIR_EraseRootFromParent_Done,
     /* 1671267 */   // Label 22953: @1671267
     /* 1671267 */   GIM_Try, /*On fail goto*//*Label 22954*/ GIMT_Encode4(1671353), // Rule ID 6371 //
     /* 1671272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1671283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1671286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1671289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1671292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671318 */     // MIs[0] policy
     /* 1671318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671352 */     // GIR_Coverage, 6371,
     /* 1671352 */     GIR_EraseRootFromParent_Done,
     /* 1671353 */   // Label 22954: @1671353
     /* 1671353 */   GIM_Try, /*On fail goto*//*Label 22955*/ GIMT_Encode4(1671439), // Rule ID 6374 //
     /* 1671358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1671369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1671372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1671375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1671378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671404 */     // MIs[0] policy
     /* 1671404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671414 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671438 */     // GIR_Coverage, 6374,
     /* 1671438 */     GIR_EraseRootFromParent_Done,
     /* 1671439 */   // Label 22955: @1671439
     /* 1671439 */   GIM_Try, /*On fail goto*//*Label 22956*/ GIMT_Encode4(1671525), // Rule ID 6375 //
     /* 1671444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1671455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1671458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1671461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1671464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671490 */     // MIs[0] policy
     /* 1671490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671524 */     // GIR_Coverage, 6375,
     /* 1671524 */     GIR_EraseRootFromParent_Done,
     /* 1671525 */   // Label 22956: @1671525
     /* 1671525 */   GIM_Try, /*On fail goto*//*Label 22957*/ GIMT_Encode4(1671611), // Rule ID 6378 //
     /* 1671530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1671541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1671544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1671547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1671550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671576 */     // MIs[0] policy
     /* 1671576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671586 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671610 */     // GIR_Coverage, 6378,
     /* 1671610 */     GIR_EraseRootFromParent_Done,
     /* 1671611 */   // Label 22957: @1671611
     /* 1671611 */   GIM_Try, /*On fail goto*//*Label 22958*/ GIMT_Encode4(1671697), // Rule ID 6379 //
     /* 1671616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1671627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1671630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1671633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1671636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671662 */     // MIs[0] policy
     /* 1671662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671672 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671696 */     // GIR_Coverage, 6379,
     /* 1671696 */     GIR_EraseRootFromParent_Done,
     /* 1671697 */   // Label 22958: @1671697
     /* 1671697 */   GIM_Try, /*On fail goto*//*Label 22959*/ GIMT_Encode4(1671783), // Rule ID 6382 //
     /* 1671702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1671705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1671713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1671716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1671719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1671722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1671725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671748 */     // MIs[0] policy
     /* 1671748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671758 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1671779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671782 */     // GIR_Coverage, 6382,
     /* 1671782 */     GIR_EraseRootFromParent_Done,
     /* 1671783 */   // Label 22959: @1671783
     /* 1671783 */   GIM_Try, /*On fail goto*//*Label 22960*/ GIMT_Encode4(1671869), // Rule ID 6383 //
     /* 1671788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1671791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1671799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1671802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1671805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1671808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1671811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671834 */     // MIs[0] policy
     /* 1671834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671844 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1671865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671868 */     // GIR_Coverage, 6383,
     /* 1671868 */     GIR_EraseRootFromParent_Done,
     /* 1671869 */   // Label 22960: @1671869
     /* 1671869 */   GIM_Try, /*On fail goto*//*Label 22961*/ GIMT_Encode4(1671955), // Rule ID 6386 //
     /* 1671874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1671877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1671885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1671888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1671891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1671894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671920 */     // MIs[0] policy
     /* 1671920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671930 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1671951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671954 */     // GIR_Coverage, 6386,
     /* 1671954 */     GIR_EraseRootFromParent_Done,
     /* 1671955 */   // Label 22961: @1671955
     /* 1671955 */   GIM_Try, /*On fail goto*//*Label 22962*/ GIMT_Encode4(1672041), // Rule ID 6387 //
     /* 1671960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1671963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1671971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1671974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1671977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1671980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672006 */     // MIs[0] policy
     /* 1672006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672016 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1672019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672040 */     // GIR_Coverage, 6387,
     /* 1672040 */     GIR_EraseRootFromParent_Done,
     /* 1672041 */   // Label 22962: @1672041
     /* 1672041 */   GIM_Try, /*On fail goto*//*Label 22963*/ GIMT_Encode4(1672127), // Rule ID 6390 //
     /* 1672046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1672057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1672060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1672063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1672066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672092 */     // MIs[0] policy
     /* 1672092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1672105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672126 */     // GIR_Coverage, 6390,
     /* 1672126 */     GIR_EraseRootFromParent_Done,
     /* 1672127 */   // Label 22963: @1672127
     /* 1672127 */   GIM_Try, /*On fail goto*//*Label 22964*/ GIMT_Encode4(1672213), // Rule ID 6391 //
     /* 1672132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1672143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1672146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1672149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1672152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672178 */     // MIs[0] policy
     /* 1672178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672188 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1672191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672212 */     // GIR_Coverage, 6391,
     /* 1672212 */     GIR_EraseRootFromParent_Done,
     /* 1672213 */   // Label 22964: @1672213
     /* 1672213 */   GIM_Try, /*On fail goto*//*Label 22965*/ GIMT_Encode4(1672299), // Rule ID 6394 //
     /* 1672218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1672229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1672232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1672235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672264 */     // MIs[0] policy
     /* 1672264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672274 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1672277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672298 */     // GIR_Coverage, 6394,
     /* 1672298 */     GIR_EraseRootFromParent_Done,
     /* 1672299 */   // Label 22965: @1672299
     /* 1672299 */   GIM_Try, /*On fail goto*//*Label 22966*/ GIMT_Encode4(1672385), // Rule ID 6395 //
     /* 1672304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1672315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1672318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1672321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672350 */     // MIs[0] policy
     /* 1672350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672360 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1672363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672384 */     // GIR_Coverage, 6395,
     /* 1672384 */     GIR_EraseRootFromParent_Done,
     /* 1672385 */   // Label 22966: @1672385
     /* 1672385 */   GIM_Try, /*On fail goto*//*Label 22967*/ GIMT_Encode4(1672471), // Rule ID 6398 //
     /* 1672390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1672401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1672404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1672407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672436 */     // MIs[0] policy
     /* 1672436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672446 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1672449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672470 */     // GIR_Coverage, 6398,
     /* 1672470 */     GIR_EraseRootFromParent_Done,
     /* 1672471 */   // Label 22967: @1672471
     /* 1672471 */   GIM_Try, /*On fail goto*//*Label 22968*/ GIMT_Encode4(1672557), // Rule ID 6399 //
     /* 1672476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1672487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1672490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1672493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672522 */     // MIs[0] policy
     /* 1672522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672532 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1672535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672556 */     // GIR_Coverage, 6399,
     /* 1672556 */     GIR_EraseRootFromParent_Done,
     /* 1672557 */   // Label 22968: @1672557
     /* 1672557 */   GIM_Try, /*On fail goto*//*Label 22969*/ GIMT_Encode4(1672643), // Rule ID 6402 //
     /* 1672562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1672573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1672576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1672579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672608 */     // MIs[0] policy
     /* 1672608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672618 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1672621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672642 */     // GIR_Coverage, 6402,
     /* 1672642 */     GIR_EraseRootFromParent_Done,
     /* 1672643 */   // Label 22969: @1672643
     /* 1672643 */   GIM_Try, /*On fail goto*//*Label 22970*/ GIMT_Encode4(1672729), // Rule ID 6403 //
     /* 1672648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1672659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1672662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1672665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672694 */     // MIs[0] policy
     /* 1672694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672704 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1672707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672728 */     // GIR_Coverage, 6403,
     /* 1672728 */     GIR_EraseRootFromParent_Done,
     /* 1672729 */   // Label 22970: @1672729
     /* 1672729 */   GIM_Try, /*On fail goto*//*Label 22971*/ GIMT_Encode4(1672815), // Rule ID 6406 //
     /* 1672734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1672745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1672748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1672751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672780 */     // MIs[0] policy
     /* 1672780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672790 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1672793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672814 */     // GIR_Coverage, 6406,
     /* 1672814 */     GIR_EraseRootFromParent_Done,
     /* 1672815 */   // Label 22971: @1672815
     /* 1672815 */   GIM_Try, /*On fail goto*//*Label 22972*/ GIMT_Encode4(1672901), // Rule ID 6407 //
     /* 1672820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1672831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1672834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1672837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672866 */     // MIs[0] policy
     /* 1672866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672876 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1672879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672900 */     // GIR_Coverage, 6407,
     /* 1672900 */     GIR_EraseRootFromParent_Done,
     /* 1672901 */   // Label 22972: @1672901
     /* 1672901 */   GIM_Try, /*On fail goto*//*Label 22973*/ GIMT_Encode4(1672987), // Rule ID 6410 //
     /* 1672906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1672917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1672920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1672923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672952 */     // MIs[0] policy
     /* 1672952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672962 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1672965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672986 */     // GIR_Coverage, 6410,
     /* 1672986 */     GIR_EraseRootFromParent_Done,
     /* 1672987 */   // Label 22973: @1672987
     /* 1672987 */   GIM_Try, /*On fail goto*//*Label 22974*/ GIMT_Encode4(1673073), // Rule ID 6411 //
     /* 1672992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1673003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1673006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1673009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673038 */     // MIs[0] policy
     /* 1673038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673048 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673072 */     // GIR_Coverage, 6411,
     /* 1673072 */     GIR_EraseRootFromParent_Done,
     /* 1673073 */   // Label 22974: @1673073
     /* 1673073 */   GIM_Try, /*On fail goto*//*Label 22975*/ GIMT_Encode4(1673159), // Rule ID 6414 //
     /* 1673078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1673089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1673092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1673095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673124 */     // MIs[0] policy
     /* 1673124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673134 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673158 */     // GIR_Coverage, 6414,
     /* 1673158 */     GIR_EraseRootFromParent_Done,
     /* 1673159 */   // Label 22975: @1673159
     /* 1673159 */   GIM_Try, /*On fail goto*//*Label 22976*/ GIMT_Encode4(1673245), // Rule ID 6415 //
     /* 1673164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1673175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1673178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1673181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673210 */     // MIs[0] policy
     /* 1673210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673220 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673244 */     // GIR_Coverage, 6415,
     /* 1673244 */     GIR_EraseRootFromParent_Done,
     /* 1673245 */   // Label 22976: @1673245
     /* 1673245 */   GIM_Try, /*On fail goto*//*Label 22977*/ GIMT_Encode4(1673331), // Rule ID 6418 //
     /* 1673250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1673261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1673264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1673267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673296 */     // MIs[0] policy
     /* 1673296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673306 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673330 */     // GIR_Coverage, 6418,
     /* 1673330 */     GIR_EraseRootFromParent_Done,
     /* 1673331 */   // Label 22977: @1673331
     /* 1673331 */   GIM_Try, /*On fail goto*//*Label 22978*/ GIMT_Encode4(1673417), // Rule ID 6419 //
     /* 1673336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1673347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1673350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1673353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673382 */     // MIs[0] policy
     /* 1673382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673392 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11690:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673416 */     // GIR_Coverage, 6419,
     /* 1673416 */     GIR_EraseRootFromParent_Done,
     /* 1673417 */   // Label 22978: @1673417
     /* 1673417 */   GIM_Try, /*On fail goto*//*Label 22979*/ GIMT_Encode4(1673503), // Rule ID 6422 //
     /* 1673422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1673433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1673436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1673439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673468 */     // MIs[0] policy
     /* 1673468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673478 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673502 */     // GIR_Coverage, 6422,
     /* 1673502 */     GIR_EraseRootFromParent_Done,
     /* 1673503 */   // Label 22979: @1673503
     /* 1673503 */   GIM_Try, /*On fail goto*//*Label 22980*/ GIMT_Encode4(1673589), // Rule ID 6423 //
     /* 1673508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1673519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1673522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1673525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673554 */     // MIs[0] policy
     /* 1673554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673564 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11690:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673588 */     // GIR_Coverage, 6423,
     /* 1673588 */     GIR_EraseRootFromParent_Done,
     /* 1673589 */   // Label 22980: @1673589
     /* 1673589 */   GIM_Try, /*On fail goto*//*Label 22981*/ GIMT_Encode4(1673675), // Rule ID 6426 //
     /* 1673594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1673605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1673608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1673611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673640 */     // MIs[0] policy
     /* 1673640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673674 */     // GIR_Coverage, 6426,
     /* 1673674 */     GIR_EraseRootFromParent_Done,
     /* 1673675 */   // Label 22981: @1673675
     /* 1673675 */   GIM_Try, /*On fail goto*//*Label 22982*/ GIMT_Encode4(1673761), // Rule ID 6427 //
     /* 1673680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1673691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1673694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1673697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673726 */     // MIs[0] policy
     /* 1673726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11690:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673760 */     // GIR_Coverage, 6427,
     /* 1673760 */     GIR_EraseRootFromParent_Done,
     /* 1673761 */   // Label 22982: @1673761
     /* 1673761 */   GIM_Try, /*On fail goto*//*Label 22983*/ GIMT_Encode4(1673847), // Rule ID 6430 //
     /* 1673766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1673769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1673777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1673780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1673783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673812 */     // MIs[0] policy
     /* 1673812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673822 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673846 */     // GIR_Coverage, 6430,
     /* 1673846 */     GIR_EraseRootFromParent_Done,
     /* 1673847 */   // Label 22983: @1673847
     /* 1673847 */   GIM_Try, /*On fail goto*//*Label 22984*/ GIMT_Encode4(1673933), // Rule ID 6431 //
     /* 1673852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1673855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1673863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1673866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1673869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673898 */     // MIs[0] policy
     /* 1673898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673908 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11690:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673932 */     // GIR_Coverage, 6431,
     /* 1673932 */     GIR_EraseRootFromParent_Done,
     /* 1673933 */   // Label 22984: @1673933
     /* 1673933 */   GIM_Try, /*On fail goto*//*Label 22985*/ GIMT_Encode4(1674019), // Rule ID 6434 //
     /* 1673938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1673949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1673952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1673955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1673961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1673968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1673972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1673976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673984 */     // MIs[0] policy
     /* 1673984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673994 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1673997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674018 */     // GIR_Coverage, 6434,
     /* 1674018 */     GIR_EraseRootFromParent_Done,
     /* 1674019 */   // Label 22985: @1674019
     /* 1674019 */   GIM_Try, /*On fail goto*//*Label 22986*/ GIMT_Encode4(1674105), // Rule ID 6435 //
     /* 1674024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1674035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1674038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1674041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674070 */     // MIs[0] policy
     /* 1674070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674080 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1674083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674104 */     // GIR_Coverage, 6435,
     /* 1674104 */     GIR_EraseRootFromParent_Done,
     /* 1674105 */   // Label 22986: @1674105
     /* 1674105 */   GIM_Try, /*On fail goto*//*Label 22987*/ GIMT_Encode4(1674191), // Rule ID 6438 //
     /* 1674110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1674121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1674124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1674127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674156 */     // MIs[0] policy
     /* 1674156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674166 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1674169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674190 */     // GIR_Coverage, 6438,
     /* 1674190 */     GIR_EraseRootFromParent_Done,
     /* 1674191 */   // Label 22987: @1674191
     /* 1674191 */   GIM_Try, /*On fail goto*//*Label 22988*/ GIMT_Encode4(1674277), // Rule ID 6439 //
     /* 1674196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1674207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1674210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1674213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674242 */     // MIs[0] policy
     /* 1674242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674252 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1674255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674276 */     // GIR_Coverage, 6439,
     /* 1674276 */     GIR_EraseRootFromParent_Done,
     /* 1674277 */   // Label 22988: @1674277
     /* 1674277 */   GIM_Try, /*On fail goto*//*Label 22989*/ GIMT_Encode4(1674363), // Rule ID 6442 //
     /* 1674282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1674293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1674296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1674299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1674305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674328 */     // MIs[0] policy
     /* 1674328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674338 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1674341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674362 */     // GIR_Coverage, 6442,
     /* 1674362 */     GIR_EraseRootFromParent_Done,
     /* 1674363 */   // Label 22989: @1674363
     /* 1674363 */   GIM_Try, /*On fail goto*//*Label 22990*/ GIMT_Encode4(1674449), // Rule ID 6443 //
     /* 1674368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1674379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1674382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1674385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1674391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674414 */     // MIs[0] policy
     /* 1674414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674424 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1674427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674448 */     // GIR_Coverage, 6443,
     /* 1674448 */     GIR_EraseRootFromParent_Done,
     /* 1674449 */   // Label 22990: @1674449
     /* 1674449 */   GIM_Try, /*On fail goto*//*Label 22991*/ GIMT_Encode4(1674535), // Rule ID 6446 //
     /* 1674454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1674465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1674468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1674471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1674477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674500 */     // MIs[0] policy
     /* 1674500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674510 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1674513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674534 */     // GIR_Coverage, 6446,
     /* 1674534 */     GIR_EraseRootFromParent_Done,
     /* 1674535 */   // Label 22991: @1674535
     /* 1674535 */   GIM_Try, /*On fail goto*//*Label 22992*/ GIMT_Encode4(1674621), // Rule ID 6447 //
     /* 1674540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1674551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1674554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1674557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1674563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674586 */     // MIs[0] policy
     /* 1674586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674596 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1674599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674620 */     // GIR_Coverage, 6447,
     /* 1674620 */     GIR_EraseRootFromParent_Done,
     /* 1674621 */   // Label 22992: @1674621
     /* 1674621 */   GIM_Try, /*On fail goto*//*Label 22993*/ GIMT_Encode4(1674707), // Rule ID 6450 //
     /* 1674626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1674637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1674640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1674643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674672 */     // MIs[0] policy
     /* 1674672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674682 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1674685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674706 */     // GIR_Coverage, 6450,
     /* 1674706 */     GIR_EraseRootFromParent_Done,
     /* 1674707 */   // Label 22993: @1674707
     /* 1674707 */   GIM_Try, /*On fail goto*//*Label 22994*/ GIMT_Encode4(1674793), // Rule ID 6451 //
     /* 1674712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1674723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1674726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1674729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674758 */     // MIs[0] policy
     /* 1674758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674768 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1674771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674792 */     // GIR_Coverage, 6451,
     /* 1674792 */     GIR_EraseRootFromParent_Done,
     /* 1674793 */   // Label 22994: @1674793
     /* 1674793 */   GIM_Try, /*On fail goto*//*Label 22995*/ GIMT_Encode4(1674879), // Rule ID 6454 //
     /* 1674798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1674809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1674812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1674815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674844 */     // MIs[0] policy
     /* 1674844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674854 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1674857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674878 */     // GIR_Coverage, 6454,
     /* 1674878 */     GIR_EraseRootFromParent_Done,
     /* 1674879 */   // Label 22995: @1674879
     /* 1674879 */   GIM_Try, /*On fail goto*//*Label 22996*/ GIMT_Encode4(1674965), // Rule ID 6455 //
     /* 1674884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1674895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1674898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1674901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674930 */     // MIs[0] policy
     /* 1674930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674940 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1674943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674964 */     // GIR_Coverage, 6455,
     /* 1674964 */     GIR_EraseRootFromParent_Done,
     /* 1674965 */   // Label 22996: @1674965
     /* 1674965 */   GIM_Try, /*On fail goto*//*Label 22997*/ GIMT_Encode4(1675051), // Rule ID 6458 //
     /* 1674970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1674981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1674984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1674987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1674993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675016 */     // MIs[0] policy
     /* 1675016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675050 */     // GIR_Coverage, 6458,
     /* 1675050 */     GIR_EraseRootFromParent_Done,
     /* 1675051 */   // Label 22997: @1675051
     /* 1675051 */   GIM_Try, /*On fail goto*//*Label 22998*/ GIMT_Encode4(1675137), // Rule ID 6459 //
     /* 1675056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1675067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1675070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1675073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675102 */     // MIs[0] policy
     /* 1675102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675112 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675136 */     // GIR_Coverage, 6459,
     /* 1675136 */     GIR_EraseRootFromParent_Done,
     /* 1675137 */   // Label 22998: @1675137
     /* 1675137 */   GIM_Try, /*On fail goto*//*Label 22999*/ GIMT_Encode4(1675223), // Rule ID 6462 //
     /* 1675142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1675153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1675156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1675159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675188 */     // MIs[0] policy
     /* 1675188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675198 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675222 */     // GIR_Coverage, 6462,
     /* 1675222 */     GIR_EraseRootFromParent_Done,
     /* 1675223 */   // Label 22999: @1675223
     /* 1675223 */   GIM_Try, /*On fail goto*//*Label 23000*/ GIMT_Encode4(1675309), // Rule ID 6463 //
     /* 1675228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1675239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1675242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1675245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675274 */     // MIs[0] policy
     /* 1675274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675284 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675308 */     // GIR_Coverage, 6463,
     /* 1675308 */     GIR_EraseRootFromParent_Done,
     /* 1675309 */   // Label 23000: @1675309
     /* 1675309 */   GIM_Try, /*On fail goto*//*Label 23001*/ GIMT_Encode4(1675395), // Rule ID 6466 //
     /* 1675314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1675325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1675328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1675331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675360 */     // MIs[0] policy
     /* 1675360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675370 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675394 */     // GIR_Coverage, 6466,
     /* 1675394 */     GIR_EraseRootFromParent_Done,
     /* 1675395 */   // Label 23001: @1675395
     /* 1675395 */   GIM_Try, /*On fail goto*//*Label 23002*/ GIMT_Encode4(1675481), // Rule ID 6467 //
     /* 1675400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1675411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1675414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1675417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675446 */     // MIs[0] policy
     /* 1675446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675456 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675480 */     // GIR_Coverage, 6467,
     /* 1675480 */     GIR_EraseRootFromParent_Done,
     /* 1675481 */   // Label 23002: @1675481
     /* 1675481 */   GIM_Try, /*On fail goto*//*Label 23003*/ GIMT_Encode4(1675567), // Rule ID 6470 //
     /* 1675486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1675489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1675497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1675500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1675503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1675509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675532 */     // MIs[0] policy
     /* 1675532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675566 */     // GIR_Coverage, 6470,
     /* 1675566 */     GIR_EraseRootFromParent_Done,
     /* 1675567 */   // Label 23003: @1675567
     /* 1675567 */   GIM_Try, /*On fail goto*//*Label 23004*/ GIMT_Encode4(1675653), // Rule ID 6471 //
     /* 1675572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1675575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1675583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1675586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1675589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1675595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675618 */     // MIs[0] policy
     /* 1675618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11690:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675652 */     // GIR_Coverage, 6471,
     /* 1675652 */     GIR_EraseRootFromParent_Done,
     /* 1675653 */   // Label 23004: @1675653
     /* 1675653 */   GIM_Try, /*On fail goto*//*Label 23005*/ GIMT_Encode4(1675739), // Rule ID 6474 //
     /* 1675658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1675661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1675669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1675672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1675675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675704 */     // MIs[0] policy
     /* 1675704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675714 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675738 */     // GIR_Coverage, 6474,
     /* 1675738 */     GIR_EraseRootFromParent_Done,
     /* 1675739 */   // Label 23005: @1675739
     /* 1675739 */   GIM_Try, /*On fail goto*//*Label 23006*/ GIMT_Encode4(1675825), // Rule ID 6475 //
     /* 1675744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1675747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1675755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1675758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1675761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675790 */     // MIs[0] policy
     /* 1675790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675800 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11690:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675824 */     // GIR_Coverage, 6475,
     /* 1675824 */     GIR_EraseRootFromParent_Done,
     /* 1675825 */   // Label 23006: @1675825
     /* 1675825 */   GIM_Try, /*On fail goto*//*Label 23007*/ GIMT_Encode4(1675911), // Rule ID 6478 //
     /* 1675830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1675833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1675841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1675844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1675847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675876 */     // MIs[0] policy
     /* 1675876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675910 */     // GIR_Coverage, 6478,
     /* 1675910 */     GIR_EraseRootFromParent_Done,
     /* 1675911 */   // Label 23007: @1675911
     /* 1675911 */   GIM_Try, /*On fail goto*//*Label 23008*/ GIMT_Encode4(1675997), // Rule ID 6479 //
     /* 1675916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1675919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1675927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1675930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1675933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675962 */     // MIs[0] policy
     /* 1675962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675972 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11690:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675996 */     // GIR_Coverage, 6479,
     /* 1675996 */     GIR_EraseRootFromParent_Done,
     /* 1675997 */   // Label 23008: @1675997
     /* 1675997 */   GIM_Try, /*On fail goto*//*Label 23009*/ GIMT_Encode4(1676083), // Rule ID 6570 //
     /* 1676002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1676013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1676016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1676019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1676022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676048 */     // MIs[0] policy
     /* 1676048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676058 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1676061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676082 */     // GIR_Coverage, 6570,
     /* 1676082 */     GIR_EraseRootFromParent_Done,
     /* 1676083 */   // Label 23009: @1676083
     /* 1676083 */   GIM_Try, /*On fail goto*//*Label 23010*/ GIMT_Encode4(1676169), // Rule ID 6571 //
     /* 1676088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1676099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1676102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1676105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1676108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676134 */     // MIs[0] policy
     /* 1676134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676144 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1676147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676168 */     // GIR_Coverage, 6571,
     /* 1676168 */     GIR_EraseRootFromParent_Done,
     /* 1676169 */   // Label 23010: @1676169
     /* 1676169 */   GIM_Try, /*On fail goto*//*Label 23011*/ GIMT_Encode4(1676255), // Rule ID 6574 //
     /* 1676174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1676185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1676188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1676191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1676194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676220 */     // MIs[0] policy
     /* 1676220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676230 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1676233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676254 */     // GIR_Coverage, 6574,
     /* 1676254 */     GIR_EraseRootFromParent_Done,
     /* 1676255 */   // Label 23011: @1676255
     /* 1676255 */   GIM_Try, /*On fail goto*//*Label 23012*/ GIMT_Encode4(1676341), // Rule ID 6575 //
     /* 1676260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1676271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1676274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1676277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1676280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676306 */     // MIs[0] policy
     /* 1676306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676316 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1676319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676340 */     // GIR_Coverage, 6575,
     /* 1676340 */     GIR_EraseRootFromParent_Done,
     /* 1676341 */   // Label 23012: @1676341
     /* 1676341 */   GIM_Try, /*On fail goto*//*Label 23013*/ GIMT_Encode4(1676427), // Rule ID 6578 //
     /* 1676346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1676357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1676360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1676363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1676366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676392 */     // MIs[0] policy
     /* 1676392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676402 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676426 */     // GIR_Coverage, 6578,
     /* 1676426 */     GIR_EraseRootFromParent_Done,
     /* 1676427 */   // Label 23013: @1676427
     /* 1676427 */   GIM_Try, /*On fail goto*//*Label 23014*/ GIMT_Encode4(1676513), // Rule ID 6579 //
     /* 1676432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1676443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1676446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1676449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1676452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676478 */     // MIs[0] policy
     /* 1676478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676488 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676512 */     // GIR_Coverage, 6579,
     /* 1676512 */     GIR_EraseRootFromParent_Done,
     /* 1676513 */   // Label 23014: @1676513
     /* 1676513 */   GIM_Try, /*On fail goto*//*Label 23015*/ GIMT_Encode4(1676599), // Rule ID 6582 //
     /* 1676518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1676529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1676532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1676535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1676538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676564 */     // MIs[0] policy
     /* 1676564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676574 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1676577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676598 */     // GIR_Coverage, 6582,
     /* 1676598 */     GIR_EraseRootFromParent_Done,
     /* 1676599 */   // Label 23015: @1676599
     /* 1676599 */   GIM_Try, /*On fail goto*//*Label 23016*/ GIMT_Encode4(1676685), // Rule ID 6583 //
     /* 1676604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1676615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1676618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1676621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1676624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676650 */     // MIs[0] policy
     /* 1676650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676660 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1676663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676684 */     // GIR_Coverage, 6583,
     /* 1676684 */     GIR_EraseRootFromParent_Done,
     /* 1676685 */   // Label 23016: @1676685
     /* 1676685 */   GIM_Try, /*On fail goto*//*Label 23017*/ GIMT_Encode4(1676771), // Rule ID 6586 //
     /* 1676690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1676701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1676704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1676707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1676710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676736 */     // MIs[0] policy
     /* 1676736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676746 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676770 */     // GIR_Coverage, 6586,
     /* 1676770 */     GIR_EraseRootFromParent_Done,
     /* 1676771 */   // Label 23017: @1676771
     /* 1676771 */   GIM_Try, /*On fail goto*//*Label 23018*/ GIMT_Encode4(1676857), // Rule ID 6587 //
     /* 1676776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1676787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1676790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1676793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1676796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676822 */     // MIs[0] policy
     /* 1676822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676832 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676856 */     // GIR_Coverage, 6587,
     /* 1676856 */     GIR_EraseRootFromParent_Done,
     /* 1676857 */   // Label 23018: @1676857
     /* 1676857 */   GIM_Try, /*On fail goto*//*Label 23019*/ GIMT_Encode4(1676943), // Rule ID 6590 //
     /* 1676862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1676873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1676876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1676879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1676882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676908 */     // MIs[0] policy
     /* 1676908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676942 */     // GIR_Coverage, 6590,
     /* 1676942 */     GIR_EraseRootFromParent_Done,
     /* 1676943 */   // Label 23019: @1676943
     /* 1676943 */   GIM_Try, /*On fail goto*//*Label 23020*/ GIMT_Encode4(1677029), // Rule ID 6591 //
     /* 1676948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1676959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1676962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1676965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1676968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676994 */     // MIs[0] policy
     /* 1676994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677004 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1677007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677028 */     // GIR_Coverage, 6591,
     /* 1677028 */     GIR_EraseRootFromParent_Done,
     /* 1677029 */   // Label 23020: @1677029
     /* 1677029 */   GIM_Try, /*On fail goto*//*Label 23021*/ GIMT_Encode4(1677115), // Rule ID 6594 //
     /* 1677034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1677045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1677048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1677051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1677054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677080 */     // MIs[0] policy
     /* 1677080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677090 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677114 */     // GIR_Coverage, 6594,
     /* 1677114 */     GIR_EraseRootFromParent_Done,
     /* 1677115 */   // Label 23021: @1677115
     /* 1677115 */   GIM_Try, /*On fail goto*//*Label 23022*/ GIMT_Encode4(1677201), // Rule ID 6595 //
     /* 1677120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1677131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1677134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1677137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1677140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677166 */     // MIs[0] policy
     /* 1677166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677176 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677200 */     // GIR_Coverage, 6595,
     /* 1677200 */     GIR_EraseRootFromParent_Done,
     /* 1677201 */   // Label 23022: @1677201
     /* 1677201 */   GIM_Try, /*On fail goto*//*Label 23023*/ GIMT_Encode4(1677287), // Rule ID 6598 //
     /* 1677206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1677217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1677220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1677223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1677226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677252 */     // MIs[0] policy
     /* 1677252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677262 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677286 */     // GIR_Coverage, 6598,
     /* 1677286 */     GIR_EraseRootFromParent_Done,
     /* 1677287 */   // Label 23023: @1677287
     /* 1677287 */   GIM_Try, /*On fail goto*//*Label 23024*/ GIMT_Encode4(1677373), // Rule ID 6599 //
     /* 1677292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1677303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1677306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1677309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1677312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677338 */     // MIs[0] policy
     /* 1677338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677348 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677372 */     // GIR_Coverage, 6599,
     /* 1677372 */     GIR_EraseRootFromParent_Done,
     /* 1677373 */   // Label 23024: @1677373
     /* 1677373 */   GIM_Try, /*On fail goto*//*Label 23025*/ GIMT_Encode4(1677459), // Rule ID 6602 //
     /* 1677378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1677389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1677392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1677395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1677398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677424 */     // MIs[0] policy
     /* 1677424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677434 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677458 */     // GIR_Coverage, 6602,
     /* 1677458 */     GIR_EraseRootFromParent_Done,
     /* 1677459 */   // Label 23025: @1677459
     /* 1677459 */   GIM_Try, /*On fail goto*//*Label 23026*/ GIMT_Encode4(1677545), // Rule ID 6603 //
     /* 1677464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1677475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1677478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1677481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1677484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677510 */     // MIs[0] policy
     /* 1677510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677520 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677544 */     // GIR_Coverage, 6603,
     /* 1677544 */     GIR_EraseRootFromParent_Done,
     /* 1677545 */   // Label 23026: @1677545
     /* 1677545 */   GIM_Try, /*On fail goto*//*Label 23027*/ GIMT_Encode4(1677631), // Rule ID 6606 //
     /* 1677550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1677553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1677561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1677564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1677567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1677570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677596 */     // MIs[0] policy
     /* 1677596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677606 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1677627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677630 */     // GIR_Coverage, 6606,
     /* 1677630 */     GIR_EraseRootFromParent_Done,
     /* 1677631 */   // Label 23027: @1677631
     /* 1677631 */   GIM_Try, /*On fail goto*//*Label 23028*/ GIMT_Encode4(1677717), // Rule ID 6607 //
     /* 1677636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1677639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1677647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1677650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1677653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1677656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677682 */     // MIs[0] policy
     /* 1677682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677692 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1677713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677716 */     // GIR_Coverage, 6607,
     /* 1677716 */     GIR_EraseRootFromParent_Done,
     /* 1677717 */   // Label 23028: @1677717
     /* 1677717 */   GIM_Try, /*On fail goto*//*Label 23029*/ GIMT_Encode4(1677803), // Rule ID 6610 //
     /* 1677722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1677733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1677736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1677739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1677742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1677745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1677752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677768 */     // MIs[0] policy
     /* 1677768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677778 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1677781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677802 */     // GIR_Coverage, 6610,
     /* 1677802 */     GIR_EraseRootFromParent_Done,
     /* 1677803 */   // Label 23029: @1677803
     /* 1677803 */   GIM_Try, /*On fail goto*//*Label 23030*/ GIMT_Encode4(1677889), // Rule ID 6611 //
     /* 1677808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1677819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1677822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1677825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1677828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1677831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1677838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677854 */     // MIs[0] policy
     /* 1677854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1677867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677888 */     // GIR_Coverage, 6611,
     /* 1677888 */     GIR_EraseRootFromParent_Done,
     /* 1677889 */   // Label 23030: @1677889
     /* 1677889 */   GIM_Try, /*On fail goto*//*Label 23031*/ GIMT_Encode4(1677975), // Rule ID 6614 //
     /* 1677894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1677905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1677908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1677911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1677914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1677917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1677924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677940 */     // MIs[0] policy
     /* 1677940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677950 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1677953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677974 */     // GIR_Coverage, 6614,
     /* 1677974 */     GIR_EraseRootFromParent_Done,
     /* 1677975 */   // Label 23031: @1677975
     /* 1677975 */   GIM_Try, /*On fail goto*//*Label 23032*/ GIMT_Encode4(1678061), // Rule ID 6615 //
     /* 1677980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1677991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1677994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1677997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1678000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678026 */     // MIs[0] policy
     /* 1678026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678036 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678060 */     // GIR_Coverage, 6615,
     /* 1678060 */     GIR_EraseRootFromParent_Done,
     /* 1678061 */   // Label 23032: @1678061
     /* 1678061 */   GIM_Try, /*On fail goto*//*Label 23033*/ GIMT_Encode4(1678147), // Rule ID 6618 //
     /* 1678066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1678077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1678080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1678083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1678086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1678089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678112 */     // MIs[0] policy
     /* 1678112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678122 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1678125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678146 */     // GIR_Coverage, 6618,
     /* 1678146 */     GIR_EraseRootFromParent_Done,
     /* 1678147 */   // Label 23033: @1678147
     /* 1678147 */   GIM_Try, /*On fail goto*//*Label 23034*/ GIMT_Encode4(1678233), // Rule ID 6619 //
     /* 1678152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1678163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1678166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1678169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1678172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1678175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678198 */     // MIs[0] policy
     /* 1678198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678208 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1678211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678232 */     // GIR_Coverage, 6619,
     /* 1678232 */     GIR_EraseRootFromParent_Done,
     /* 1678233 */   // Label 23034: @1678233
     /* 1678233 */   GIM_Try, /*On fail goto*//*Label 23035*/ GIMT_Encode4(1678319), // Rule ID 6622 //
     /* 1678238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1678249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1678252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1678255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1678258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678284 */     // MIs[0] policy
     /* 1678284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678294 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678318 */     // GIR_Coverage, 6622,
     /* 1678318 */     GIR_EraseRootFromParent_Done,
     /* 1678319 */   // Label 23035: @1678319
     /* 1678319 */   GIM_Try, /*On fail goto*//*Label 23036*/ GIMT_Encode4(1678405), // Rule ID 6623 //
     /* 1678324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1678335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1678338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1678341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1678344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678370 */     // MIs[0] policy
     /* 1678370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678380 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678404 */     // GIR_Coverage, 6623,
     /* 1678404 */     GIR_EraseRootFromParent_Done,
     /* 1678405 */   // Label 23036: @1678405
     /* 1678405 */   GIM_Try, /*On fail goto*//*Label 23037*/ GIMT_Encode4(1678491), // Rule ID 6626 //
     /* 1678410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1678421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1678424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1678427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1678430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678456 */     // MIs[0] policy
     /* 1678456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678466 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678490 */     // GIR_Coverage, 6626,
     /* 1678490 */     GIR_EraseRootFromParent_Done,
     /* 1678491 */   // Label 23037: @1678491
     /* 1678491 */   GIM_Try, /*On fail goto*//*Label 23038*/ GIMT_Encode4(1678577), // Rule ID 6627 //
     /* 1678496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1678507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1678510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1678513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1678516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678542 */     // MIs[0] policy
     /* 1678542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678552 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678576 */     // GIR_Coverage, 6627,
     /* 1678576 */     GIR_EraseRootFromParent_Done,
     /* 1678577 */   // Label 23038: @1678577
     /* 1678577 */   GIM_Try, /*On fail goto*//*Label 23039*/ GIMT_Encode4(1678663), // Rule ID 6630 //
     /* 1678582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1678593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1678596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1678599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1678602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678628 */     // MIs[0] policy
     /* 1678628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678638 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1678641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678662 */     // GIR_Coverage, 6630,
     /* 1678662 */     GIR_EraseRootFromParent_Done,
     /* 1678663 */   // Label 23039: @1678663
     /* 1678663 */   GIM_Try, /*On fail goto*//*Label 23040*/ GIMT_Encode4(1678749), // Rule ID 6631 //
     /* 1678668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1678679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1678682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1678685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1678688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678714 */     // MIs[0] policy
     /* 1678714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678724 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1678727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678748 */     // GIR_Coverage, 6631,
     /* 1678748 */     GIR_EraseRootFromParent_Done,
     /* 1678749 */   // Label 23040: @1678749
     /* 1678749 */   GIM_Try, /*On fail goto*//*Label 23041*/ GIMT_Encode4(1678835), // Rule ID 6634 //
     /* 1678754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1678765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1678768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1678771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1678774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1678777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678800 */     // MIs[0] policy
     /* 1678800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678810 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678834 */     // GIR_Coverage, 6634,
     /* 1678834 */     GIR_EraseRootFromParent_Done,
     /* 1678835 */   // Label 23041: @1678835
     /* 1678835 */   GIM_Try, /*On fail goto*//*Label 23042*/ GIMT_Encode4(1678921), // Rule ID 6635 //
     /* 1678840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1678851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1678854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1678857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1678860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1678863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678886 */     // MIs[0] policy
     /* 1678886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678920 */     // GIR_Coverage, 6635,
     /* 1678920 */     GIR_EraseRootFromParent_Done,
     /* 1678921 */   // Label 23042: @1678921
     /* 1678921 */   GIM_Try, /*On fail goto*//*Label 23043*/ GIMT_Encode4(1679007), // Rule ID 6638 //
     /* 1678926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1678937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1678940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1678943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1678946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678972 */     // MIs[0] policy
     /* 1678972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678982 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679006 */     // GIR_Coverage, 6638,
     /* 1679006 */     GIR_EraseRootFromParent_Done,
     /* 1679007 */   // Label 23043: @1679007
     /* 1679007 */   GIM_Try, /*On fail goto*//*Label 23044*/ GIMT_Encode4(1679093), // Rule ID 6639 //
     /* 1679012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1679023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1679026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1679029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1679032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679058 */     // MIs[0] policy
     /* 1679058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679068 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679092 */     // GIR_Coverage, 6639,
     /* 1679092 */     GIR_EraseRootFromParent_Done,
     /* 1679093 */   // Label 23044: @1679093
     /* 1679093 */   GIM_Try, /*On fail goto*//*Label 23045*/ GIMT_Encode4(1679179), // Rule ID 6642 //
     /* 1679098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1679109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1679112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1679115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1679118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679144 */     // MIs[0] policy
     /* 1679144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679154 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679178 */     // GIR_Coverage, 6642,
     /* 1679178 */     GIR_EraseRootFromParent_Done,
     /* 1679179 */   // Label 23045: @1679179
     /* 1679179 */   GIM_Try, /*On fail goto*//*Label 23046*/ GIMT_Encode4(1679265), // Rule ID 6643 //
     /* 1679184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1679195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1679198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1679201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1679204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679230 */     // MIs[0] policy
     /* 1679230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679240 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679264 */     // GIR_Coverage, 6643,
     /* 1679264 */     GIR_EraseRootFromParent_Done,
     /* 1679265 */   // Label 23046: @1679265
     /* 1679265 */   GIM_Try, /*On fail goto*//*Label 23047*/ GIMT_Encode4(1679351), // Rule ID 6646 //
     /* 1679270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1679281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1679284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1679287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1679290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679316 */     // MIs[0] policy
     /* 1679316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1679329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679350 */     // GIR_Coverage, 6646,
     /* 1679350 */     GIR_EraseRootFromParent_Done,
     /* 1679351 */   // Label 23047: @1679351
     /* 1679351 */   GIM_Try, /*On fail goto*//*Label 23048*/ GIMT_Encode4(1679437), // Rule ID 6647 //
     /* 1679356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1679367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1679370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1679373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1679376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679402 */     // MIs[0] policy
     /* 1679402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679412 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1679415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679436 */     // GIR_Coverage, 6647,
     /* 1679436 */     GIR_EraseRootFromParent_Done,
     /* 1679437 */   // Label 23048: @1679437
     /* 1679437 */   GIM_Try, /*On fail goto*//*Label 23049*/ GIMT_Encode4(1679523), // Rule ID 6650 //
     /* 1679442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1679453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1679456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1679459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1679462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679488 */     // MIs[0] policy
     /* 1679488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679498 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679522 */     // GIR_Coverage, 6650,
     /* 1679522 */     GIR_EraseRootFromParent_Done,
     /* 1679523 */   // Label 23049: @1679523
     /* 1679523 */   GIM_Try, /*On fail goto*//*Label 23050*/ GIMT_Encode4(1679609), // Rule ID 6651 //
     /* 1679528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1679539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1679542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1679545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1679548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679574 */     // MIs[0] policy
     /* 1679574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679584 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679608 */     // GIR_Coverage, 6651,
     /* 1679608 */     GIR_EraseRootFromParent_Done,
     /* 1679609 */   // Label 23050: @1679609
     /* 1679609 */   GIM_Try, /*On fail goto*//*Label 23051*/ GIMT_Encode4(1679695), // Rule ID 6654 //
     /* 1679614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1679625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1679628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1679631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1679634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679660 */     // MIs[0] policy
     /* 1679660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679670 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679694 */     // GIR_Coverage, 6654,
     /* 1679694 */     GIR_EraseRootFromParent_Done,
     /* 1679695 */   // Label 23051: @1679695
     /* 1679695 */   GIM_Try, /*On fail goto*//*Label 23052*/ GIMT_Encode4(1679781), // Rule ID 6655 //
     /* 1679700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1679711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1679714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1679717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1679720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679746 */     // MIs[0] policy
     /* 1679746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679756 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679780 */     // GIR_Coverage, 6655,
     /* 1679780 */     GIR_EraseRootFromParent_Done,
     /* 1679781 */   // Label 23052: @1679781
     /* 1679781 */   GIM_Try, /*On fail goto*//*Label 23053*/ GIMT_Encode4(1679867), // Rule ID 6658 //
     /* 1679786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1679797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1679800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1679803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1679809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1679816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679832 */     // MIs[0] policy
     /* 1679832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679842 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1679845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679866 */     // GIR_Coverage, 6658,
     /* 1679866 */     GIR_EraseRootFromParent_Done,
     /* 1679867 */   // Label 23053: @1679867
     /* 1679867 */   GIM_Try, /*On fail goto*//*Label 23054*/ GIMT_Encode4(1679953), // Rule ID 6659 //
     /* 1679872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1679883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1679886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1679889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1679892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1679895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1679902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679918 */     // MIs[0] policy
     /* 1679918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679928 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1679931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679952 */     // GIR_Coverage, 6659,
     /* 1679952 */     GIR_EraseRootFromParent_Done,
     /* 1679953 */   // Label 23054: @1679953
     /* 1679953 */   GIM_Try, /*On fail goto*//*Label 23055*/ GIMT_Encode4(1680039), // Rule ID 6662 //
     /* 1679958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1679969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1679972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1679975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1679988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680004 */     // MIs[0] policy
     /* 1680004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680014 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680038 */     // GIR_Coverage, 6662,
     /* 1680038 */     GIR_EraseRootFromParent_Done,
     /* 1680039 */   // Label 23055: @1680039
     /* 1680039 */   GIM_Try, /*On fail goto*//*Label 23056*/ GIMT_Encode4(1680125), // Rule ID 6663 //
     /* 1680044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1680055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1680058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1680061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680090 */     // MIs[0] policy
     /* 1680090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680100 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680124 */     // GIR_Coverage, 6663,
     /* 1680124 */     GIR_EraseRootFromParent_Done,
     /* 1680125 */   // Label 23056: @1680125
     /* 1680125 */   GIM_Try, /*On fail goto*//*Label 23057*/ GIMT_Encode4(1680211), // Rule ID 6666 //
     /* 1680130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1680141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1680144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1680147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680176 */     // MIs[0] policy
     /* 1680176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680186 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680210 */     // GIR_Coverage, 6666,
     /* 1680210 */     GIR_EraseRootFromParent_Done,
     /* 1680211 */   // Label 23057: @1680211
     /* 1680211 */   GIM_Try, /*On fail goto*//*Label 23058*/ GIMT_Encode4(1680297), // Rule ID 6667 //
     /* 1680216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1680227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1680230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1680233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680262 */     // MIs[0] policy
     /* 1680262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680272 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680296 */     // GIR_Coverage, 6667,
     /* 1680296 */     GIR_EraseRootFromParent_Done,
     /* 1680297 */   // Label 23058: @1680297
     /* 1680297 */   GIM_Try, /*On fail goto*//*Label 23059*/ GIMT_Encode4(1680383), // Rule ID 6670 //
     /* 1680302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1680313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1680316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1680319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680348 */     // MIs[0] policy
     /* 1680348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680358 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680382 */     // GIR_Coverage, 6670,
     /* 1680382 */     GIR_EraseRootFromParent_Done,
     /* 1680383 */   // Label 23059: @1680383
     /* 1680383 */   GIM_Try, /*On fail goto*//*Label 23060*/ GIMT_Encode4(1680469), // Rule ID 6671 //
     /* 1680388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1680399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1680402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1680405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680434 */     // MIs[0] policy
     /* 1680434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680444 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680468 */     // GIR_Coverage, 6671,
     /* 1680468 */     GIR_EraseRootFromParent_Done,
     /* 1680469 */   // Label 23060: @1680469
     /* 1680469 */   GIM_Try, /*On fail goto*//*Label 23061*/ GIMT_Encode4(1680555), // Rule ID 6674 //
     /* 1680474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1680485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1680488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1680491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680520 */     // MIs[0] policy
     /* 1680520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680530 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680554 */     // GIR_Coverage, 6674,
     /* 1680554 */     GIR_EraseRootFromParent_Done,
     /* 1680555 */   // Label 23061: @1680555
     /* 1680555 */   GIM_Try, /*On fail goto*//*Label 23062*/ GIMT_Encode4(1680641), // Rule ID 6675 //
     /* 1680560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1680571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1680574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1680577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680606 */     // MIs[0] policy
     /* 1680606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680616 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680640 */     // GIR_Coverage, 6675,
     /* 1680640 */     GIR_EraseRootFromParent_Done,
     /* 1680641 */   // Label 23062: @1680641
     /* 1680641 */   GIM_Try, /*On fail goto*//*Label 23063*/ GIMT_Encode4(1680727), // Rule ID 6678 //
     /* 1680646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1680657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1680660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1680663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680692 */     // MIs[0] policy
     /* 1680692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680726 */     // GIR_Coverage, 6678,
     /* 1680726 */     GIR_EraseRootFromParent_Done,
     /* 1680727 */   // Label 23063: @1680727
     /* 1680727 */   GIM_Try, /*On fail goto*//*Label 23064*/ GIMT_Encode4(1680813), // Rule ID 6679 //
     /* 1680732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1680743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1680746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1680749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680778 */     // MIs[0] policy
     /* 1680778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680788 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680812 */     // GIR_Coverage, 6679,
     /* 1680812 */     GIR_EraseRootFromParent_Done,
     /* 1680813 */   // Label 23064: @1680813
     /* 1680813 */   GIM_Try, /*On fail goto*//*Label 23065*/ GIMT_Encode4(1680899), // Rule ID 6682 //
     /* 1680818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1680829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1680832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1680835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680864 */     // MIs[0] policy
     /* 1680864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680874 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1680877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680898 */     // GIR_Coverage, 6682,
     /* 1680898 */     GIR_EraseRootFromParent_Done,
     /* 1680899 */   // Label 23065: @1680899
     /* 1680899 */   GIM_Try, /*On fail goto*//*Label 23066*/ GIMT_Encode4(1680985), // Rule ID 6683 //
     /* 1680904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1680915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1680918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1680921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680950 */     // MIs[0] policy
     /* 1680950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680960 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1680963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680984 */     // GIR_Coverage, 6683,
     /* 1680984 */     GIR_EraseRootFromParent_Done,
     /* 1680985 */   // Label 23066: @1680985
     /* 1680985 */   GIM_Try, /*On fail goto*//*Label 23067*/ GIMT_Encode4(1681071), // Rule ID 6686 //
     /* 1680990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1681001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1681004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1681007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681036 */     // MIs[0] policy
     /* 1681036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681046 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681070 */     // GIR_Coverage, 6686,
     /* 1681070 */     GIR_EraseRootFromParent_Done,
     /* 1681071 */   // Label 23067: @1681071
     /* 1681071 */   GIM_Try, /*On fail goto*//*Label 23068*/ GIMT_Encode4(1681157), // Rule ID 6687 //
     /* 1681076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1681087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1681090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1681093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681122 */     // MIs[0] policy
     /* 1681122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681132 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681156 */     // GIR_Coverage, 6687,
     /* 1681156 */     GIR_EraseRootFromParent_Done,
     /* 1681157 */   // Label 23068: @1681157
     /* 1681157 */   GIM_Try, /*On fail goto*//*Label 23069*/ GIMT_Encode4(1681243), // Rule ID 6690 //
     /* 1681162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1681173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1681176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1681179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681208 */     // MIs[0] policy
     /* 1681208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681242 */     // GIR_Coverage, 6690,
     /* 1681242 */     GIR_EraseRootFromParent_Done,
     /* 1681243 */   // Label 23069: @1681243
     /* 1681243 */   GIM_Try, /*On fail goto*//*Label 23070*/ GIMT_Encode4(1681329), // Rule ID 6691 //
     /* 1681248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1681259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1681262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1681265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681294 */     // MIs[0] policy
     /* 1681294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681328 */     // GIR_Coverage, 6691,
     /* 1681328 */     GIR_EraseRootFromParent_Done,
     /* 1681329 */   // Label 23070: @1681329
     /* 1681329 */   GIM_Try, /*On fail goto*//*Label 23071*/ GIMT_Encode4(1681415), // Rule ID 6694 //
     /* 1681334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1681337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1681345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1681348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1681351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681380 */     // MIs[0] policy
     /* 1681380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681414 */     // GIR_Coverage, 6694,
     /* 1681414 */     GIR_EraseRootFromParent_Done,
     /* 1681415 */   // Label 23071: @1681415
     /* 1681415 */   GIM_Try, /*On fail goto*//*Label 23072*/ GIMT_Encode4(1681501), // Rule ID 6695 //
     /* 1681420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1681423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1681431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1681434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1681437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681466 */     // MIs[0] policy
     /* 1681466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681500 */     // GIR_Coverage, 6695,
     /* 1681500 */     GIR_EraseRootFromParent_Done,
     /* 1681501 */   // Label 23072: @1681501
     /* 1681501 */   GIM_Try, /*On fail goto*//*Label 23073*/ GIMT_Encode4(1681587), // Rule ID 6698 //
     /* 1681506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1681517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1681520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1681523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1681529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1681536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681552 */     // MIs[0] policy
     /* 1681552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681562 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1681565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681586 */     // GIR_Coverage, 6698,
     /* 1681586 */     GIR_EraseRootFromParent_Done,
     /* 1681587 */   // Label 23073: @1681587
     /* 1681587 */   GIM_Try, /*On fail goto*//*Label 23074*/ GIMT_Encode4(1681673), // Rule ID 6699 //
     /* 1681592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1681603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1681606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1681609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1681615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1681622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681638 */     // MIs[0] policy
     /* 1681638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681648 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1681651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681672 */     // GIR_Coverage, 6699,
     /* 1681672 */     GIR_EraseRootFromParent_Done,
     /* 1681673 */   // Label 23074: @1681673
     /* 1681673 */   GIM_Try, /*On fail goto*//*Label 23075*/ GIMT_Encode4(1681759), // Rule ID 6702 //
     /* 1681678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1681689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1681692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1681695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1681701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1681708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681724 */     // MIs[0] policy
     /* 1681724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681734 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1681737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681758 */     // GIR_Coverage, 6702,
     /* 1681758 */     GIR_EraseRootFromParent_Done,
     /* 1681759 */   // Label 23075: @1681759
     /* 1681759 */   GIM_Try, /*On fail goto*//*Label 23076*/ GIMT_Encode4(1681845), // Rule ID 6703 //
     /* 1681764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1681775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1681778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1681781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1681787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1681794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681810 */     // MIs[0] policy
     /* 1681810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681820 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1681823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681844 */     // GIR_Coverage, 6703,
     /* 1681844 */     GIR_EraseRootFromParent_Done,
     /* 1681845 */   // Label 23076: @1681845
     /* 1681845 */   GIM_Try, /*On fail goto*//*Label 23077*/ GIMT_Encode4(1681931), // Rule ID 6706 //
     /* 1681850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1681861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1681864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1681867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1681873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1681880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681896 */     // MIs[0] policy
     /* 1681896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681906 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1681909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681930 */     // GIR_Coverage, 6706,
     /* 1681930 */     GIR_EraseRootFromParent_Done,
     /* 1681931 */   // Label 23077: @1681931
     /* 1681931 */   GIM_Try, /*On fail goto*//*Label 23078*/ GIMT_Encode4(1682017), // Rule ID 6707 //
     /* 1681936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1681947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1681950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1681953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1681959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1681966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681982 */     // MIs[0] policy
     /* 1681982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681992 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1681995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682016 */     // GIR_Coverage, 6707,
     /* 1682016 */     GIR_EraseRootFromParent_Done,
     /* 1682017 */   // Label 23078: @1682017
     /* 1682017 */   GIM_Try, /*On fail goto*//*Label 23079*/ GIMT_Encode4(1682103), // Rule ID 6710 //
     /* 1682022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1682033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1682036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1682039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682068 */     // MIs[0] policy
     /* 1682068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682078 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682102 */     // GIR_Coverage, 6710,
     /* 1682102 */     GIR_EraseRootFromParent_Done,
     /* 1682103 */   // Label 23079: @1682103
     /* 1682103 */   GIM_Try, /*On fail goto*//*Label 23080*/ GIMT_Encode4(1682189), // Rule ID 6711 //
     /* 1682108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1682119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1682122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1682125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682154 */     // MIs[0] policy
     /* 1682154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682164 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682188 */     // GIR_Coverage, 6711,
     /* 1682188 */     GIR_EraseRootFromParent_Done,
     /* 1682189 */   // Label 23080: @1682189
     /* 1682189 */   GIM_Try, /*On fail goto*//*Label 23081*/ GIMT_Encode4(1682275), // Rule ID 6714 //
     /* 1682194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1682205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1682208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1682211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682240 */     // MIs[0] policy
     /* 1682240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682250 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682274 */     // GIR_Coverage, 6714,
     /* 1682274 */     GIR_EraseRootFromParent_Done,
     /* 1682275 */   // Label 23081: @1682275
     /* 1682275 */   GIM_Try, /*On fail goto*//*Label 23082*/ GIMT_Encode4(1682361), // Rule ID 6715 //
     /* 1682280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1682291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1682294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1682297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682326 */     // MIs[0] policy
     /* 1682326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682336 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682360 */     // GIR_Coverage, 6715,
     /* 1682360 */     GIR_EraseRootFromParent_Done,
     /* 1682361 */   // Label 23082: @1682361
     /* 1682361 */   GIM_Try, /*On fail goto*//*Label 23083*/ GIMT_Encode4(1682447), // Rule ID 6718 //
     /* 1682366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1682377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1682380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1682383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682412 */     // MIs[0] policy
     /* 1682412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682422 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682446 */     // GIR_Coverage, 6718,
     /* 1682446 */     GIR_EraseRootFromParent_Done,
     /* 1682447 */   // Label 23083: @1682447
     /* 1682447 */   GIM_Try, /*On fail goto*//*Label 23084*/ GIMT_Encode4(1682533), // Rule ID 6719 //
     /* 1682452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1682463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1682466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1682469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682498 */     // MIs[0] policy
     /* 1682498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682508 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682532 */     // GIR_Coverage, 6719,
     /* 1682532 */     GIR_EraseRootFromParent_Done,
     /* 1682533 */   // Label 23084: @1682533
     /* 1682533 */   GIM_Try, /*On fail goto*//*Label 23085*/ GIMT_Encode4(1682619), // Rule ID 6722 //
     /* 1682538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1682549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1682552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1682555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1682561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682584 */     // MIs[0] policy
     /* 1682584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682618 */     // GIR_Coverage, 6722,
     /* 1682618 */     GIR_EraseRootFromParent_Done,
     /* 1682619 */   // Label 23085: @1682619
     /* 1682619 */   GIM_Try, /*On fail goto*//*Label 23086*/ GIMT_Encode4(1682705), // Rule ID 6723 //
     /* 1682624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1682635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1682638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1682641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1682647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682670 */     // MIs[0] policy
     /* 1682670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682704 */     // GIR_Coverage, 6723,
     /* 1682704 */     GIR_EraseRootFromParent_Done,
     /* 1682705 */   // Label 23086: @1682705
     /* 1682705 */   GIM_Try, /*On fail goto*//*Label 23087*/ GIMT_Encode4(1682791), // Rule ID 6726 //
     /* 1682710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1682721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1682724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1682727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682756 */     // MIs[0] policy
     /* 1682756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682790 */     // GIR_Coverage, 6726,
     /* 1682790 */     GIR_EraseRootFromParent_Done,
     /* 1682791 */   // Label 23087: @1682791
     /* 1682791 */   GIM_Try, /*On fail goto*//*Label 23088*/ GIMT_Encode4(1682877), // Rule ID 6727 //
     /* 1682796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1682807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1682810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1682813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682842 */     // MIs[0] policy
     /* 1682842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682876 */     // GIR_Coverage, 6727,
     /* 1682876 */     GIR_EraseRootFromParent_Done,
     /* 1682877 */   // Label 23088: @1682877
     /* 1682877 */   GIM_Try, /*On fail goto*//*Label 23089*/ GIMT_Encode4(1682963), // Rule ID 6730 //
     /* 1682882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1682893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1682896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1682899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682928 */     // MIs[0] policy
     /* 1682928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682938 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682962 */     // GIR_Coverage, 6730,
     /* 1682962 */     GIR_EraseRootFromParent_Done,
     /* 1682963 */   // Label 23089: @1682963
     /* 1682963 */   GIM_Try, /*On fail goto*//*Label 23090*/ GIMT_Encode4(1683049), // Rule ID 6731 //
     /* 1682968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1682979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1682982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1682985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683014 */     // MIs[0] policy
     /* 1683014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683024 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1683027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683048 */     // GIR_Coverage, 6731,
     /* 1683048 */     GIR_EraseRootFromParent_Done,
     /* 1683049 */   // Label 23090: @1683049
     /* 1683049 */   GIM_Try, /*On fail goto*//*Label 23091*/ GIMT_Encode4(1683135), // Rule ID 6734 //
     /* 1683054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1683065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1683068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1683071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683100 */     // MIs[0] policy
     /* 1683100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1683113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683134 */     // GIR_Coverage, 6734,
     /* 1683134 */     GIR_EraseRootFromParent_Done,
     /* 1683135 */   // Label 23091: @1683135
     /* 1683135 */   GIM_Try, /*On fail goto*//*Label 23092*/ GIMT_Encode4(1683221), // Rule ID 6735 //
     /* 1683140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1683151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1683154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1683157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683186 */     // MIs[0] policy
     /* 1683186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683196 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1683199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683220 */     // GIR_Coverage, 6735,
     /* 1683220 */     GIR_EraseRootFromParent_Done,
     /* 1683221 */   // Label 23092: @1683221
     /* 1683221 */   GIM_Try, /*On fail goto*//*Label 23093*/ GIMT_Encode4(1683307), // Rule ID 6738 //
     /* 1683226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1683237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1683240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1683243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683272 */     // MIs[0] policy
     /* 1683272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683282 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1683285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683306 */     // GIR_Coverage, 6738,
     /* 1683306 */     GIR_EraseRootFromParent_Done,
     /* 1683307 */   // Label 23093: @1683307
     /* 1683307 */   GIM_Try, /*On fail goto*//*Label 23094*/ GIMT_Encode4(1683393), // Rule ID 6739 //
     /* 1683312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1683323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1683326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1683329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683358 */     // MIs[0] policy
     /* 1683358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683368 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1683371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683392 */     // GIR_Coverage, 6739,
     /* 1683392 */     GIR_EraseRootFromParent_Done,
     /* 1683393 */   // Label 23094: @1683393
     /* 1683393 */   GIM_Try, /*On fail goto*//*Label 23095*/ GIMT_Encode4(1683479), // Rule ID 6742 //
     /* 1683398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1683409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1683412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1683415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683444 */     // MIs[0] policy
     /* 1683444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1683457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683478 */     // GIR_Coverage, 6742,
     /* 1683478 */     GIR_EraseRootFromParent_Done,
     /* 1683479 */   // Label 23095: @1683479
     /* 1683479 */   GIM_Try, /*On fail goto*//*Label 23096*/ GIMT_Encode4(1683565), // Rule ID 6743 //
     /* 1683484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1683495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1683498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1683501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683530 */     // MIs[0] policy
     /* 1683530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683540 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1683543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683564 */     // GIR_Coverage, 6743,
     /* 1683564 */     GIR_EraseRootFromParent_Done,
     /* 1683565 */   // Label 23096: @1683565
     /* 1683565 */   GIM_Try, /*On fail goto*//*Label 23097*/ GIMT_Encode4(1683651), // Rule ID 6834 //
     /* 1683570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1683581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1683584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1683587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1683590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1683593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683616 */     // MIs[0] policy
     /* 1683616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683626 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1683629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683650 */     // GIR_Coverage, 6834,
     /* 1683650 */     GIR_EraseRootFromParent_Done,
     /* 1683651 */   // Label 23097: @1683651
     /* 1683651 */   GIM_Try, /*On fail goto*//*Label 23098*/ GIMT_Encode4(1683737), // Rule ID 6835 //
     /* 1683656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1683667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1683670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1683673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1683676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1683679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683702 */     // MIs[0] policy
     /* 1683702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683712 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1683715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683736 */     // GIR_Coverage, 6835,
     /* 1683736 */     GIR_EraseRootFromParent_Done,
     /* 1683737 */   // Label 23098: @1683737
     /* 1683737 */   GIM_Try, /*On fail goto*//*Label 23099*/ GIMT_Encode4(1683823), // Rule ID 6838 //
     /* 1683742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1683753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1683756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1683759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1683762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683788 */     // MIs[0] policy
     /* 1683788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683798 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1683801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683822 */     // GIR_Coverage, 6838,
     /* 1683822 */     GIR_EraseRootFromParent_Done,
     /* 1683823 */   // Label 23099: @1683823
     /* 1683823 */   GIM_Try, /*On fail goto*//*Label 23100*/ GIMT_Encode4(1683909), // Rule ID 6839 //
     /* 1683828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1683839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1683842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1683845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1683848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683874 */     // MIs[0] policy
     /* 1683874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683884 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1683887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683908 */     // GIR_Coverage, 6839,
     /* 1683908 */     GIR_EraseRootFromParent_Done,
     /* 1683909 */   // Label 23100: @1683909
     /* 1683909 */   GIM_Try, /*On fail goto*//*Label 23101*/ GIMT_Encode4(1683995), // Rule ID 6842 //
     /* 1683914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1683925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1683928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1683931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1683934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683960 */     // MIs[0] policy
     /* 1683960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683970 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1683973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683994 */     // GIR_Coverage, 6842,
     /* 1683994 */     GIR_EraseRootFromParent_Done,
     /* 1683995 */   // Label 23101: @1683995
     /* 1683995 */   GIM_Try, /*On fail goto*//*Label 23102*/ GIMT_Encode4(1684081), // Rule ID 6843 //
     /* 1684000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1684011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1684014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1684017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1684020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684046 */     // MIs[0] policy
     /* 1684046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684056 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684080 */     // GIR_Coverage, 6843,
     /* 1684080 */     GIR_EraseRootFromParent_Done,
     /* 1684081 */   // Label 23102: @1684081
     /* 1684081 */   GIM_Try, /*On fail goto*//*Label 23103*/ GIMT_Encode4(1684167), // Rule ID 6846 //
     /* 1684086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1684097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1684100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1684103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1684106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684132 */     // MIs[0] policy
     /* 1684132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684142 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1684145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684166 */     // GIR_Coverage, 6846,
     /* 1684166 */     GIR_EraseRootFromParent_Done,
     /* 1684167 */   // Label 23103: @1684167
     /* 1684167 */   GIM_Try, /*On fail goto*//*Label 23104*/ GIMT_Encode4(1684253), // Rule ID 6847 //
     /* 1684172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1684183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1684186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1684189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1684192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684218 */     // MIs[0] policy
     /* 1684218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684228 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1684231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684252 */     // GIR_Coverage, 6847,
     /* 1684252 */     GIR_EraseRootFromParent_Done,
     /* 1684253 */   // Label 23104: @1684253
     /* 1684253 */   GIM_Try, /*On fail goto*//*Label 23105*/ GIMT_Encode4(1684339), // Rule ID 6850 //
     /* 1684258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1684269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1684272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1684275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1684278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684304 */     // MIs[0] policy
     /* 1684304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684314 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684338 */     // GIR_Coverage, 6850,
     /* 1684338 */     GIR_EraseRootFromParent_Done,
     /* 1684339 */   // Label 23105: @1684339
     /* 1684339 */   GIM_Try, /*On fail goto*//*Label 23106*/ GIMT_Encode4(1684425), // Rule ID 6851 //
     /* 1684344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1684355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1684358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1684361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1684364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684390 */     // MIs[0] policy
     /* 1684390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684400 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684424 */     // GIR_Coverage, 6851,
     /* 1684424 */     GIR_EraseRootFromParent_Done,
     /* 1684425 */   // Label 23106: @1684425
     /* 1684425 */   GIM_Try, /*On fail goto*//*Label 23107*/ GIMT_Encode4(1684511), // Rule ID 6854 //
     /* 1684430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1684441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1684444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1684447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1684450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684476 */     // MIs[0] policy
     /* 1684476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684510 */     // GIR_Coverage, 6854,
     /* 1684510 */     GIR_EraseRootFromParent_Done,
     /* 1684511 */   // Label 23107: @1684511
     /* 1684511 */   GIM_Try, /*On fail goto*//*Label 23108*/ GIMT_Encode4(1684597), // Rule ID 6855 //
     /* 1684516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1684527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1684530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1684533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1684536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684562 */     // MIs[0] policy
     /* 1684562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684596 */     // GIR_Coverage, 6855,
     /* 1684596 */     GIR_EraseRootFromParent_Done,
     /* 1684597 */   // Label 23108: @1684597
     /* 1684597 */   GIM_Try, /*On fail goto*//*Label 23109*/ GIMT_Encode4(1684683), // Rule ID 6858 //
     /* 1684602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1684613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1684616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1684619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1684622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1684625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684648 */     // MIs[0] policy
     /* 1684648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684658 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1684661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684682 */     // GIR_Coverage, 6858,
     /* 1684682 */     GIR_EraseRootFromParent_Done,
     /* 1684683 */   // Label 23109: @1684683
     /* 1684683 */   GIM_Try, /*On fail goto*//*Label 23110*/ GIMT_Encode4(1684769), // Rule ID 6859 //
     /* 1684688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1684699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1684702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1684705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1684708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1684711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684734 */     // MIs[0] policy
     /* 1684734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684744 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1684747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684768 */     // GIR_Coverage, 6859,
     /* 1684768 */     GIR_EraseRootFromParent_Done,
     /* 1684769 */   // Label 23110: @1684769
     /* 1684769 */   GIM_Try, /*On fail goto*//*Label 23111*/ GIMT_Encode4(1684855), // Rule ID 6862 //
     /* 1684774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1684785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1684788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1684791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1684794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684820 */     // MIs[0] policy
     /* 1684820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684830 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1684833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684854 */     // GIR_Coverage, 6862,
     /* 1684854 */     GIR_EraseRootFromParent_Done,
     /* 1684855 */   // Label 23111: @1684855
     /* 1684855 */   GIM_Try, /*On fail goto*//*Label 23112*/ GIMT_Encode4(1684941), // Rule ID 6863 //
     /* 1684860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1684871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1684874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1684877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1684880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684906 */     // MIs[0] policy
     /* 1684906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684916 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1684919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684940 */     // GIR_Coverage, 6863,
     /* 1684940 */     GIR_EraseRootFromParent_Done,
     /* 1684941 */   // Label 23112: @1684941
     /* 1684941 */   GIM_Try, /*On fail goto*//*Label 23113*/ GIMT_Encode4(1685027), // Rule ID 6866 //
     /* 1684946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1684957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1684960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1684963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1684966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684992 */     // MIs[0] policy
     /* 1684992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685026 */     // GIR_Coverage, 6866,
     /* 1685026 */     GIR_EraseRootFromParent_Done,
     /* 1685027 */   // Label 23113: @1685027
     /* 1685027 */   GIM_Try, /*On fail goto*//*Label 23114*/ GIMT_Encode4(1685113), // Rule ID 6867 //
     /* 1685032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1685043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1685046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1685049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1685052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685078 */     // MIs[0] policy
     /* 1685078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685088 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685112 */     // GIR_Coverage, 6867,
     /* 1685112 */     GIR_EraseRootFromParent_Done,
     /* 1685113 */   // Label 23114: @1685113
     /* 1685113 */   GIM_Try, /*On fail goto*//*Label 23115*/ GIMT_Encode4(1685199), // Rule ID 6870 //
     /* 1685118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1685121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1685129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1685132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1685135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1685138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685164 */     // MIs[0] policy
     /* 1685164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685198 */     // GIR_Coverage, 6870,
     /* 1685198 */     GIR_EraseRootFromParent_Done,
     /* 1685199 */   // Label 23115: @1685199
     /* 1685199 */   GIM_Try, /*On fail goto*//*Label 23116*/ GIMT_Encode4(1685285), // Rule ID 6871 //
     /* 1685204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1685207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1685215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1685218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1685221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1685224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685250 */     // MIs[0] policy
     /* 1685250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685260 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685284 */     // GIR_Coverage, 6871,
     /* 1685284 */     GIR_EraseRootFromParent_Done,
     /* 1685285 */   // Label 23116: @1685285
     /* 1685285 */   GIM_Try, /*On fail goto*//*Label 23117*/ GIMT_Encode4(1685371), // Rule ID 6874 //
     /* 1685290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1685301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1685304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1685307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1685310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1685313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685336 */     // MIs[0] policy
     /* 1685336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1685349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685370 */     // GIR_Coverage, 6874,
     /* 1685370 */     GIR_EraseRootFromParent_Done,
     /* 1685371 */   // Label 23117: @1685371
     /* 1685371 */   GIM_Try, /*On fail goto*//*Label 23118*/ GIMT_Encode4(1685457), // Rule ID 6875 //
     /* 1685376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1685387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1685390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1685393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1685396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1685399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685422 */     // MIs[0] policy
     /* 1685422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685432 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1685435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685456 */     // GIR_Coverage, 6875,
     /* 1685456 */     GIR_EraseRootFromParent_Done,
     /* 1685457 */   // Label 23118: @1685457
     /* 1685457 */   GIM_Try, /*On fail goto*//*Label 23119*/ GIMT_Encode4(1685543), // Rule ID 6878 //
     /* 1685462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1685473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1685476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1685479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1685482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1685485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1685492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685508 */     // MIs[0] policy
     /* 1685508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685518 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1685521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685542 */     // GIR_Coverage, 6878,
     /* 1685542 */     GIR_EraseRootFromParent_Done,
     /* 1685543 */   // Label 23119: @1685543
     /* 1685543 */   GIM_Try, /*On fail goto*//*Label 23120*/ GIMT_Encode4(1685629), // Rule ID 6879 //
     /* 1685548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1685559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1685562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1685565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1685568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1685571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1685578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685594 */     // MIs[0] policy
     /* 1685594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685604 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1685607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685628 */     // GIR_Coverage, 6879,
     /* 1685628 */     GIR_EraseRootFromParent_Done,
     /* 1685629 */   // Label 23120: @1685629
     /* 1685629 */   GIM_Try, /*On fail goto*//*Label 23121*/ GIMT_Encode4(1685715), // Rule ID 6882 //
     /* 1685634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1685645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1685648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1685651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1685654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1685657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1685664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685680 */     // MIs[0] policy
     /* 1685680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685690 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1685693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685714 */     // GIR_Coverage, 6882,
     /* 1685714 */     GIR_EraseRootFromParent_Done,
     /* 1685715 */   // Label 23121: @1685715
     /* 1685715 */   GIM_Try, /*On fail goto*//*Label 23122*/ GIMT_Encode4(1685801), // Rule ID 6883 //
     /* 1685720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1685731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1685734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1685737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1685740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1685743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1685750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685766 */     // MIs[0] policy
     /* 1685766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685776 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1685779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685800 */     // GIR_Coverage, 6883,
     /* 1685800 */     GIR_EraseRootFromParent_Done,
     /* 1685801 */   // Label 23122: @1685801
     /* 1685801 */   GIM_Try, /*On fail goto*//*Label 23123*/ GIMT_Encode4(1685887), // Rule ID 6886 //
     /* 1685806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1685817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1685820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1685823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1685826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685852 */     // MIs[0] policy
     /* 1685852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685862 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1685865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685886 */     // GIR_Coverage, 6886,
     /* 1685886 */     GIR_EraseRootFromParent_Done,
     /* 1685887 */   // Label 23123: @1685887
     /* 1685887 */   GIM_Try, /*On fail goto*//*Label 23124*/ GIMT_Encode4(1685973), // Rule ID 6887 //
     /* 1685892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1685903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1685906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1685909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1685912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685938 */     // MIs[0] policy
     /* 1685938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685948 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1685951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685972 */     // GIR_Coverage, 6887,
     /* 1685972 */     GIR_EraseRootFromParent_Done,
     /* 1685973 */   // Label 23124: @1685973
     /* 1685973 */   GIM_Try, /*On fail goto*//*Label 23125*/ GIMT_Encode4(1686059), // Rule ID 6890 //
     /* 1685978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1685989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1685992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1685995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1685998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686024 */     // MIs[0] policy
     /* 1686024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686058 */     // GIR_Coverage, 6890,
     /* 1686058 */     GIR_EraseRootFromParent_Done,
     /* 1686059 */   // Label 23125: @1686059
     /* 1686059 */   GIM_Try, /*On fail goto*//*Label 23126*/ GIMT_Encode4(1686145), // Rule ID 6891 //
     /* 1686064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1686075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1686078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1686081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1686084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686110 */     // MIs[0] policy
     /* 1686110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686120 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686144 */     // GIR_Coverage, 6891,
     /* 1686144 */     GIR_EraseRootFromParent_Done,
     /* 1686145 */   // Label 23126: @1686145
     /* 1686145 */   GIM_Try, /*On fail goto*//*Label 23127*/ GIMT_Encode4(1686231), // Rule ID 6894 //
     /* 1686150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1686161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1686164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1686167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1686170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686196 */     // MIs[0] policy
     /* 1686196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686230 */     // GIR_Coverage, 6894,
     /* 1686230 */     GIR_EraseRootFromParent_Done,
     /* 1686231 */   // Label 23127: @1686231
     /* 1686231 */   GIM_Try, /*On fail goto*//*Label 23128*/ GIMT_Encode4(1686317), // Rule ID 6895 //
     /* 1686236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1686247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1686250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1686253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1686256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686282 */     // MIs[0] policy
     /* 1686282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686292 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686316 */     // GIR_Coverage, 6895,
     /* 1686316 */     GIR_EraseRootFromParent_Done,
     /* 1686317 */   // Label 23128: @1686317
     /* 1686317 */   GIM_Try, /*On fail goto*//*Label 23129*/ GIMT_Encode4(1686403), // Rule ID 6898 //
     /* 1686322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1686333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1686336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1686339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1686342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1686345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686368 */     // MIs[0] policy
     /* 1686368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686378 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686402 */     // GIR_Coverage, 6898,
     /* 1686402 */     GIR_EraseRootFromParent_Done,
     /* 1686403 */   // Label 23129: @1686403
     /* 1686403 */   GIM_Try, /*On fail goto*//*Label 23130*/ GIMT_Encode4(1686489), // Rule ID 6899 //
     /* 1686408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1686419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1686422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1686425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1686428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1686431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686454 */     // MIs[0] policy
     /* 1686454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686488 */     // GIR_Coverage, 6899,
     /* 1686488 */     GIR_EraseRootFromParent_Done,
     /* 1686489 */   // Label 23130: @1686489
     /* 1686489 */   GIM_Try, /*On fail goto*//*Label 23131*/ GIMT_Encode4(1686575), // Rule ID 6902 //
     /* 1686494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1686505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1686508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1686511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1686514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686540 */     // MIs[0] policy
     /* 1686540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686550 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686574 */     // GIR_Coverage, 6902,
     /* 1686574 */     GIR_EraseRootFromParent_Done,
     /* 1686575 */   // Label 23131: @1686575
     /* 1686575 */   GIM_Try, /*On fail goto*//*Label 23132*/ GIMT_Encode4(1686661), // Rule ID 6903 //
     /* 1686580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1686591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1686594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1686597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1686600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686626 */     // MIs[0] policy
     /* 1686626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686636 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686660 */     // GIR_Coverage, 6903,
     /* 1686660 */     GIR_EraseRootFromParent_Done,
     /* 1686661 */   // Label 23132: @1686661
     /* 1686661 */   GIM_Try, /*On fail goto*//*Label 23133*/ GIMT_Encode4(1686747), // Rule ID 6906 //
     /* 1686666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1686677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1686680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1686683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1686686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686712 */     // MIs[0] policy
     /* 1686712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686746 */     // GIR_Coverage, 6906,
     /* 1686746 */     GIR_EraseRootFromParent_Done,
     /* 1686747 */   // Label 23133: @1686747
     /* 1686747 */   GIM_Try, /*On fail goto*//*Label 23134*/ GIMT_Encode4(1686833), // Rule ID 6907 //
     /* 1686752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1686763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1686766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1686769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1686772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686798 */     // MIs[0] policy
     /* 1686798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686808 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686832 */     // GIR_Coverage, 6907,
     /* 1686832 */     GIR_EraseRootFromParent_Done,
     /* 1686833 */   // Label 23134: @1686833
     /* 1686833 */   GIM_Try, /*On fail goto*//*Label 23135*/ GIMT_Encode4(1686919), // Rule ID 6910 //
     /* 1686838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1686841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1686849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1686852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1686855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1686858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1686861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686884 */     // MIs[0] policy
     /* 1686884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1686915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686918 */     // GIR_Coverage, 6910,
     /* 1686918 */     GIR_EraseRootFromParent_Done,
     /* 1686919 */   // Label 23135: @1686919
     /* 1686919 */   GIM_Try, /*On fail goto*//*Label 23136*/ GIMT_Encode4(1687005), // Rule ID 6911 //
     /* 1686924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1686927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1686935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1686938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1686941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1686944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1686947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686970 */     // MIs[0] policy
     /* 1686970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686980 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687004 */     // GIR_Coverage, 6911,
     /* 1687004 */     GIR_EraseRootFromParent_Done,
     /* 1687005 */   // Label 23136: @1687005
     /* 1687005 */   GIM_Try, /*On fail goto*//*Label 23137*/ GIMT_Encode4(1687091), // Rule ID 6914 //
     /* 1687010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1687021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1687024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1687027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1687030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687056 */     // MIs[0] policy
     /* 1687056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1687069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687090 */     // GIR_Coverage, 6914,
     /* 1687090 */     GIR_EraseRootFromParent_Done,
     /* 1687091 */   // Label 23137: @1687091
     /* 1687091 */   GIM_Try, /*On fail goto*//*Label 23138*/ GIMT_Encode4(1687177), // Rule ID 6915 //
     /* 1687096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1687107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1687110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1687113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1687116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687142 */     // MIs[0] policy
     /* 1687142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687152 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1687155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687176 */     // GIR_Coverage, 6915,
     /* 1687176 */     GIR_EraseRootFromParent_Done,
     /* 1687177 */   // Label 23138: @1687177
     /* 1687177 */   GIM_Try, /*On fail goto*//*Label 23139*/ GIMT_Encode4(1687263), // Rule ID 6918 //
     /* 1687182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1687193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1687196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1687199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1687202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687228 */     // MIs[0] policy
     /* 1687228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687238 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1687241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687262 */     // GIR_Coverage, 6918,
     /* 1687262 */     GIR_EraseRootFromParent_Done,
     /* 1687263 */   // Label 23139: @1687263
     /* 1687263 */   GIM_Try, /*On fail goto*//*Label 23140*/ GIMT_Encode4(1687349), // Rule ID 6919 //
     /* 1687268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1687279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1687282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1687285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1687288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687314 */     // MIs[0] policy
     /* 1687314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687324 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1687327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687348 */     // GIR_Coverage, 6919,
     /* 1687348 */     GIR_EraseRootFromParent_Done,
     /* 1687349 */   // Label 23140: @1687349
     /* 1687349 */   GIM_Try, /*On fail goto*//*Label 23141*/ GIMT_Encode4(1687435), // Rule ID 6922 //
     /* 1687354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1687365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1687368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1687371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687400 */     // MIs[0] policy
     /* 1687400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687410 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1687413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687434 */     // GIR_Coverage, 6922,
     /* 1687434 */     GIR_EraseRootFromParent_Done,
     /* 1687435 */   // Label 23141: @1687435
     /* 1687435 */   GIM_Try, /*On fail goto*//*Label 23142*/ GIMT_Encode4(1687521), // Rule ID 6923 //
     /* 1687440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1687451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1687454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1687457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687486 */     // MIs[0] policy
     /* 1687486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1687499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687520 */     // GIR_Coverage, 6923,
     /* 1687520 */     GIR_EraseRootFromParent_Done,
     /* 1687521 */   // Label 23142: @1687521
     /* 1687521 */   GIM_Try, /*On fail goto*//*Label 23143*/ GIMT_Encode4(1687607), // Rule ID 6926 //
     /* 1687526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1687537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1687540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1687543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687572 */     // MIs[0] policy
     /* 1687572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687582 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1687585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687606 */     // GIR_Coverage, 6926,
     /* 1687606 */     GIR_EraseRootFromParent_Done,
     /* 1687607 */   // Label 23143: @1687607
     /* 1687607 */   GIM_Try, /*On fail goto*//*Label 23144*/ GIMT_Encode4(1687693), // Rule ID 6927 //
     /* 1687612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1687623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1687626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1687629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687658 */     // MIs[0] policy
     /* 1687658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687668 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1687671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687692 */     // GIR_Coverage, 6927,
     /* 1687692 */     GIR_EraseRootFromParent_Done,
     /* 1687693 */   // Label 23144: @1687693
     /* 1687693 */   GIM_Try, /*On fail goto*//*Label 23145*/ GIMT_Encode4(1687779), // Rule ID 6930 //
     /* 1687698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1687709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1687712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1687715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687744 */     // MIs[0] policy
     /* 1687744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687754 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1687757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687778 */     // GIR_Coverage, 6930,
     /* 1687778 */     GIR_EraseRootFromParent_Done,
     /* 1687779 */   // Label 23145: @1687779
     /* 1687779 */   GIM_Try, /*On fail goto*//*Label 23146*/ GIMT_Encode4(1687865), // Rule ID 6931 //
     /* 1687784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1687795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1687798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1687801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687830 */     // MIs[0] policy
     /* 1687830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687840 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1687843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687864 */     // GIR_Coverage, 6931,
     /* 1687864 */     GIR_EraseRootFromParent_Done,
     /* 1687865 */   // Label 23146: @1687865
     /* 1687865 */   GIM_Try, /*On fail goto*//*Label 23147*/ GIMT_Encode4(1687951), // Rule ID 6934 //
     /* 1687870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1687881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1687884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1687887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687916 */     // MIs[0] policy
     /* 1687916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687926 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1687929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1687947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687950 */     // GIR_Coverage, 6934,
     /* 1687950 */     GIR_EraseRootFromParent_Done,
     /* 1687951 */   // Label 23147: @1687951
     /* 1687951 */   GIM_Try, /*On fail goto*//*Label 23148*/ GIMT_Encode4(1688037), // Rule ID 6935 //
     /* 1687956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1687967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1687970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1687973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688002 */     // MIs[0] policy
     /* 1688002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688012 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1688015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688036 */     // GIR_Coverage, 6935,
     /* 1688036 */     GIR_EraseRootFromParent_Done,
     /* 1688037 */   // Label 23148: @1688037
     /* 1688037 */   GIM_Try, /*On fail goto*//*Label 23149*/ GIMT_Encode4(1688123), // Rule ID 6938 //
     /* 1688042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1688053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1688056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1688059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688088 */     // MIs[0] policy
     /* 1688088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688098 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688122 */     // GIR_Coverage, 6938,
     /* 1688122 */     GIR_EraseRootFromParent_Done,
     /* 1688123 */   // Label 23149: @1688123
     /* 1688123 */   GIM_Try, /*On fail goto*//*Label 23150*/ GIMT_Encode4(1688209), // Rule ID 6939 //
     /* 1688128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1688139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1688142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1688145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688174 */     // MIs[0] policy
     /* 1688174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688184 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688208 */     // GIR_Coverage, 6939,
     /* 1688208 */     GIR_EraseRootFromParent_Done,
     /* 1688209 */   // Label 23150: @1688209
     /* 1688209 */   GIM_Try, /*On fail goto*//*Label 23151*/ GIMT_Encode4(1688295), // Rule ID 6942 //
     /* 1688214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1688225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1688228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1688231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688260 */     // MIs[0] policy
     /* 1688260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688270 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688294 */     // GIR_Coverage, 6942,
     /* 1688294 */     GIR_EraseRootFromParent_Done,
     /* 1688295 */   // Label 23151: @1688295
     /* 1688295 */   GIM_Try, /*On fail goto*//*Label 23152*/ GIMT_Encode4(1688381), // Rule ID 6943 //
     /* 1688300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1688311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1688314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1688317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688346 */     // MIs[0] policy
     /* 1688346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688356 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688380 */     // GIR_Coverage, 6943,
     /* 1688380 */     GIR_EraseRootFromParent_Done,
     /* 1688381 */   // Label 23152: @1688381
     /* 1688381 */   GIM_Try, /*On fail goto*//*Label 23153*/ GIMT_Encode4(1688467), // Rule ID 6946 //
     /* 1688386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1688397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1688400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1688403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688432 */     // MIs[0] policy
     /* 1688432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688466 */     // GIR_Coverage, 6946,
     /* 1688466 */     GIR_EraseRootFromParent_Done,
     /* 1688467 */   // Label 23153: @1688467
     /* 1688467 */   GIM_Try, /*On fail goto*//*Label 23154*/ GIMT_Encode4(1688553), // Rule ID 6947 //
     /* 1688472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1688483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1688486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1688489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688518 */     // MIs[0] policy
     /* 1688518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688528 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688552 */     // GIR_Coverage, 6947,
     /* 1688552 */     GIR_EraseRootFromParent_Done,
     /* 1688553 */   // Label 23154: @1688553
     /* 1688553 */   GIM_Try, /*On fail goto*//*Label 23155*/ GIMT_Encode4(1688639), // Rule ID 6950 //
     /* 1688558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1688569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1688572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1688575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688604 */     // MIs[0] policy
     /* 1688604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688614 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688638 */     // GIR_Coverage, 6950,
     /* 1688638 */     GIR_EraseRootFromParent_Done,
     /* 1688639 */   // Label 23155: @1688639
     /* 1688639 */   GIM_Try, /*On fail goto*//*Label 23156*/ GIMT_Encode4(1688725), // Rule ID 6951 //
     /* 1688644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1688655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1688658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1688661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688690 */     // MIs[0] policy
     /* 1688690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688724 */     // GIR_Coverage, 6951,
     /* 1688724 */     GIR_EraseRootFromParent_Done,
     /* 1688725 */   // Label 23156: @1688725
     /* 1688725 */   GIM_Try, /*On fail goto*//*Label 23157*/ GIMT_Encode4(1688811), // Rule ID 6954 //
     /* 1688730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1688741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1688744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1688747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688776 */     // MIs[0] policy
     /* 1688776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688786 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688810 */     // GIR_Coverage, 6954,
     /* 1688810 */     GIR_EraseRootFromParent_Done,
     /* 1688811 */   // Label 23157: @1688811
     /* 1688811 */   GIM_Try, /*On fail goto*//*Label 23158*/ GIMT_Encode4(1688897), // Rule ID 6955 //
     /* 1688816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1688827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1688830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1688833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688862 */     // MIs[0] policy
     /* 1688862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688872 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688896 */     // GIR_Coverage, 6955,
     /* 1688896 */     GIR_EraseRootFromParent_Done,
     /* 1688897 */   // Label 23158: @1688897
     /* 1688897 */   GIM_Try, /*On fail goto*//*Label 23159*/ GIMT_Encode4(1688983), // Rule ID 6958 //
     /* 1688902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1688905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1688913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1688916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1688919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688948 */     // MIs[0] policy
     /* 1688948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688958 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1688979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688982 */     // GIR_Coverage, 6958,
     /* 1688982 */     GIR_EraseRootFromParent_Done,
     /* 1688983 */   // Label 23159: @1688983
     /* 1688983 */   GIM_Try, /*On fail goto*//*Label 23160*/ GIMT_Encode4(1689069), // Rule ID 6959 //
     /* 1688988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1688991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1688999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1689002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1689005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689034 */     // MIs[0] policy
     /* 1689034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689044 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1689065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689068 */     // GIR_Coverage, 6959,
     /* 1689068 */     GIR_EraseRootFromParent_Done,
     /* 1689069 */   // Label 23160: @1689069
     /* 1689069 */   GIM_Try, /*On fail goto*//*Label 23161*/ GIMT_Encode4(1689155), // Rule ID 6962 //
     /* 1689074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1689085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1689088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1689091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689120 */     // MIs[0] policy
     /* 1689120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689130 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1689133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689154 */     // GIR_Coverage, 6962,
     /* 1689154 */     GIR_EraseRootFromParent_Done,
     /* 1689155 */   // Label 23161: @1689155
     /* 1689155 */   GIM_Try, /*On fail goto*//*Label 23162*/ GIMT_Encode4(1689241), // Rule ID 6963 //
     /* 1689160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1689171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1689174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1689177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689206 */     // MIs[0] policy
     /* 1689206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689216 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1689219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689240 */     // GIR_Coverage, 6963,
     /* 1689240 */     GIR_EraseRootFromParent_Done,
     /* 1689241 */   // Label 23162: @1689241
     /* 1689241 */   GIM_Try, /*On fail goto*//*Label 23163*/ GIMT_Encode4(1689327), // Rule ID 6966 //
     /* 1689246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1689257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1689260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1689263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1689269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689292 */     // MIs[0] policy
     /* 1689292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689302 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1689305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689326 */     // GIR_Coverage, 6966,
     /* 1689326 */     GIR_EraseRootFromParent_Done,
     /* 1689327 */   // Label 23163: @1689327
     /* 1689327 */   GIM_Try, /*On fail goto*//*Label 23164*/ GIMT_Encode4(1689413), // Rule ID 6967 //
     /* 1689332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1689343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1689346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1689349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1689355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689378 */     // MIs[0] policy
     /* 1689378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689388 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1689391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689412 */     // GIR_Coverage, 6967,
     /* 1689412 */     GIR_EraseRootFromParent_Done,
     /* 1689413 */   // Label 23164: @1689413
     /* 1689413 */   GIM_Try, /*On fail goto*//*Label 23165*/ GIMT_Encode4(1689499), // Rule ID 6970 //
     /* 1689418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1689429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1689432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1689435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1689441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1689448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689464 */     // MIs[0] policy
     /* 1689464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689474 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1689477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689498 */     // GIR_Coverage, 6970,
     /* 1689498 */     GIR_EraseRootFromParent_Done,
     /* 1689499 */   // Label 23165: @1689499
     /* 1689499 */   GIM_Try, /*On fail goto*//*Label 23166*/ GIMT_Encode4(1689585), // Rule ID 6971 //
     /* 1689504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1689515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1689518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1689521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1689527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1689534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689550 */     // MIs[0] policy
     /* 1689550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689560 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1689563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689584 */     // GIR_Coverage, 6971,
     /* 1689584 */     GIR_EraseRootFromParent_Done,
     /* 1689585 */   // Label 23166: @1689585
     /* 1689585 */   GIM_Try, /*On fail goto*//*Label 23167*/ GIMT_Encode4(1689671), // Rule ID 6974 //
     /* 1689590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1689601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1689604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1689607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1689613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689636 */     // MIs[0] policy
     /* 1689636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1689649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689670 */     // GIR_Coverage, 6974,
     /* 1689670 */     GIR_EraseRootFromParent_Done,
     /* 1689671 */   // Label 23167: @1689671
     /* 1689671 */   GIM_Try, /*On fail goto*//*Label 23168*/ GIMT_Encode4(1689757), // Rule ID 6975 //
     /* 1689676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1689687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1689690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1689693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1689699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689722 */     // MIs[0] policy
     /* 1689722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1689735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689756 */     // GIR_Coverage, 6975,
     /* 1689756 */     GIR_EraseRootFromParent_Done,
     /* 1689757 */   // Label 23168: @1689757
     /* 1689757 */   GIM_Try, /*On fail goto*//*Label 23169*/ GIMT_Encode4(1689843), // Rule ID 6978 //
     /* 1689762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1689773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1689776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1689779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689808 */     // MIs[0] policy
     /* 1689808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689818 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1689821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689842 */     // GIR_Coverage, 6978,
     /* 1689842 */     GIR_EraseRootFromParent_Done,
     /* 1689843 */   // Label 23169: @1689843
     /* 1689843 */   GIM_Try, /*On fail goto*//*Label 23170*/ GIMT_Encode4(1689929), // Rule ID 6979 //
     /* 1689848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1689859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1689862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1689865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689894 */     // MIs[0] policy
     /* 1689894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689904 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1689907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689928 */     // GIR_Coverage, 6979,
     /* 1689928 */     GIR_EraseRootFromParent_Done,
     /* 1689929 */   // Label 23170: @1689929
     /* 1689929 */   GIM_Try, /*On fail goto*//*Label 23171*/ GIMT_Encode4(1690015), // Rule ID 6982 //
     /* 1689934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1689945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1689948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1689951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1689957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1689964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689980 */     // MIs[0] policy
     /* 1689980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689990 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1689993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690014 */     // GIR_Coverage, 6982,
     /* 1690014 */     GIR_EraseRootFromParent_Done,
     /* 1690015 */   // Label 23171: @1690015
     /* 1690015 */   GIM_Try, /*On fail goto*//*Label 23172*/ GIMT_Encode4(1690101), // Rule ID 6983 //
     /* 1690020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1690031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1690034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1690037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690066 */     // MIs[0] policy
     /* 1690066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690076 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690100 */     // GIR_Coverage, 6983,
     /* 1690100 */     GIR_EraseRootFromParent_Done,
     /* 1690101 */   // Label 23172: @1690101
     /* 1690101 */   GIM_Try, /*On fail goto*//*Label 23173*/ GIMT_Encode4(1690187), // Rule ID 6986 //
     /* 1690106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1690117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1690120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1690123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690152 */     // MIs[0] policy
     /* 1690152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690186 */     // GIR_Coverage, 6986,
     /* 1690186 */     GIR_EraseRootFromParent_Done,
     /* 1690187 */   // Label 23173: @1690187
     /* 1690187 */   GIM_Try, /*On fail goto*//*Label 23174*/ GIMT_Encode4(1690273), // Rule ID 6987 //
     /* 1690192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1690203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1690206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1690209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690238 */     // MIs[0] policy
     /* 1690238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690272 */     // GIR_Coverage, 6987,
     /* 1690272 */     GIR_EraseRootFromParent_Done,
     /* 1690273 */   // Label 23174: @1690273
     /* 1690273 */   GIM_Try, /*On fail goto*//*Label 23175*/ GIMT_Encode4(1690359), // Rule ID 6990 //
     /* 1690278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1690289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1690292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1690295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690324 */     // MIs[0] policy
     /* 1690324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690358 */     // GIR_Coverage, 6990,
     /* 1690358 */     GIR_EraseRootFromParent_Done,
     /* 1690359 */   // Label 23175: @1690359
     /* 1690359 */   GIM_Try, /*On fail goto*//*Label 23176*/ GIMT_Encode4(1690445), // Rule ID 6991 //
     /* 1690364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1690375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1690378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1690381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690410 */     // MIs[0] policy
     /* 1690410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690420 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690444 */     // GIR_Coverage, 6991,
     /* 1690444 */     GIR_EraseRootFromParent_Done,
     /* 1690445 */   // Label 23176: @1690445
     /* 1690445 */   GIM_Try, /*On fail goto*//*Label 23177*/ GIMT_Encode4(1690531), // Rule ID 6994 //
     /* 1690450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1690461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1690464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1690467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690496 */     // MIs[0] policy
     /* 1690496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690506 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690530 */     // GIR_Coverage, 6994,
     /* 1690530 */     GIR_EraseRootFromParent_Done,
     /* 1690531 */   // Label 23177: @1690531
     /* 1690531 */   GIM_Try, /*On fail goto*//*Label 23178*/ GIMT_Encode4(1690617), // Rule ID 6995 //
     /* 1690536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1690547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1690550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1690553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690582 */     // MIs[0] policy
     /* 1690582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690592 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690616 */     // GIR_Coverage, 6995,
     /* 1690616 */     GIR_EraseRootFromParent_Done,
     /* 1690617 */   // Label 23178: @1690617
     /* 1690617 */   GIM_Try, /*On fail goto*//*Label 23179*/ GIMT_Encode4(1690703), // Rule ID 6998 //
     /* 1690622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1690625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1690633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1690636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1690639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1690645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690668 */     // MIs[0] policy
     /* 1690668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690702 */     // GIR_Coverage, 6998,
     /* 1690702 */     GIR_EraseRootFromParent_Done,
     /* 1690703 */   // Label 23179: @1690703
     /* 1690703 */   GIM_Try, /*On fail goto*//*Label 23180*/ GIMT_Encode4(1690789), // Rule ID 6999 //
     /* 1690708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1690711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1690719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1690722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1690725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1690731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690754 */     // MIs[0] policy
     /* 1690754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690788 */     // GIR_Coverage, 6999,
     /* 1690788 */     GIR_EraseRootFromParent_Done,
     /* 1690789 */   // Label 23180: @1690789
     /* 1690789 */   GIM_Try, /*On fail goto*//*Label 23181*/ GIMT_Encode4(1690875), // Rule ID 7002 //
     /* 1690794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1690797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1690805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1690808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1690811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690840 */     // MIs[0] policy
     /* 1690840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690850 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690874 */     // GIR_Coverage, 7002,
     /* 1690874 */     GIR_EraseRootFromParent_Done,
     /* 1690875 */   // Label 23181: @1690875
     /* 1690875 */   GIM_Try, /*On fail goto*//*Label 23182*/ GIMT_Encode4(1690961), // Rule ID 7003 //
     /* 1690880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1690883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1690891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1690894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1690897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690926 */     // MIs[0] policy
     /* 1690926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690936 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690960 */     // GIR_Coverage, 7003,
     /* 1690960 */     GIR_EraseRootFromParent_Done,
     /* 1690961 */   // Label 23182: @1690961
     /* 1690961 */   GIM_Try, /*On fail goto*//*Label 23183*/ GIMT_Encode4(1691047), // Rule ID 7006 //
     /* 1690966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1690969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1690977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1690980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1690983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691012 */     // MIs[0] policy
     /* 1691012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691022 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1691025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691046 */     // GIR_Coverage, 7006,
     /* 1691046 */     GIR_EraseRootFromParent_Done,
     /* 1691047 */   // Label 23183: @1691047
     /* 1691047 */   GIM_Try, /*On fail goto*//*Label 23184*/ GIMT_Encode4(1691133), // Rule ID 7007 //
     /* 1691052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1691063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1691066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1691069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691098 */     // MIs[0] policy
     /* 1691098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691108 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1691111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691132 */     // GIR_Coverage, 7007,
     /* 1691132 */     GIR_EraseRootFromParent_Done,
     /* 1691133 */   // Label 23184: @1691133
     /* 1691133 */   GIM_Try, /*On fail goto*//*Label 23185*/ GIMT_Encode4(1691219), // Rule ID 7098 //
     /* 1691138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1691149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1691152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1691155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1691158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691184 */     // MIs[0] policy
     /* 1691184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691194 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1691197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691218 */     // GIR_Coverage, 7098,
     /* 1691218 */     GIR_EraseRootFromParent_Done,
     /* 1691219 */   // Label 23185: @1691219
     /* 1691219 */   GIM_Try, /*On fail goto*//*Label 23186*/ GIMT_Encode4(1691305), // Rule ID 7099 //
     /* 1691224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1691235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1691238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1691241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1691244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691270 */     // MIs[0] policy
     /* 1691270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691280 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1691283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691304 */     // GIR_Coverage, 7099,
     /* 1691304 */     GIR_EraseRootFromParent_Done,
     /* 1691305 */   // Label 23186: @1691305
     /* 1691305 */   GIM_Try, /*On fail goto*//*Label 23187*/ GIMT_Encode4(1691391), // Rule ID 7102 //
     /* 1691310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1691321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1691324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1691327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1691330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691356 */     // MIs[0] policy
     /* 1691356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691366 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1691369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691390 */     // GIR_Coverage, 7102,
     /* 1691390 */     GIR_EraseRootFromParent_Done,
     /* 1691391 */   // Label 23187: @1691391
     /* 1691391 */   GIM_Try, /*On fail goto*//*Label 23188*/ GIMT_Encode4(1691477), // Rule ID 7103 //
     /* 1691396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1691407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1691410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1691413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1691416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691442 */     // MIs[0] policy
     /* 1691442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691452 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1691455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691476 */     // GIR_Coverage, 7103,
     /* 1691476 */     GIR_EraseRootFromParent_Done,
     /* 1691477 */   // Label 23188: @1691477
     /* 1691477 */   GIM_Try, /*On fail goto*//*Label 23189*/ GIMT_Encode4(1691563), // Rule ID 7106 //
     /* 1691482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1691493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1691496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1691499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1691502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691528 */     // MIs[0] policy
     /* 1691528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691538 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1691541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691562 */     // GIR_Coverage, 7106,
     /* 1691562 */     GIR_EraseRootFromParent_Done,
     /* 1691563 */   // Label 23189: @1691563
     /* 1691563 */   GIM_Try, /*On fail goto*//*Label 23190*/ GIMT_Encode4(1691649), // Rule ID 7107 //
     /* 1691568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1691579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1691582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1691585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1691588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691614 */     // MIs[0] policy
     /* 1691614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691624 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1691627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691648 */     // GIR_Coverage, 7107,
     /* 1691648 */     GIR_EraseRootFromParent_Done,
     /* 1691649 */   // Label 23190: @1691649
     /* 1691649 */   GIM_Try, /*On fail goto*//*Label 23191*/ GIMT_Encode4(1691735), // Rule ID 7110 //
     /* 1691654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1691665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1691668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1691671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1691674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691700 */     // MIs[0] policy
     /* 1691700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691710 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1691713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691734 */     // GIR_Coverage, 7110,
     /* 1691734 */     GIR_EraseRootFromParent_Done,
     /* 1691735 */   // Label 23191: @1691735
     /* 1691735 */   GIM_Try, /*On fail goto*//*Label 23192*/ GIMT_Encode4(1691821), // Rule ID 7111 //
     /* 1691740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1691751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1691754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1691757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1691760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691786 */     // MIs[0] policy
     /* 1691786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691796 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1691799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691820 */     // GIR_Coverage, 7111,
     /* 1691820 */     GIR_EraseRootFromParent_Done,
     /* 1691821 */   // Label 23192: @1691821
     /* 1691821 */   GIM_Try, /*On fail goto*//*Label 23193*/ GIMT_Encode4(1691907), // Rule ID 7114 //
     /* 1691826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1691837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1691840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1691843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1691846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691872 */     // MIs[0] policy
     /* 1691872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691882 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1691885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691906 */     // GIR_Coverage, 7114,
     /* 1691906 */     GIR_EraseRootFromParent_Done,
     /* 1691907 */   // Label 23193: @1691907
     /* 1691907 */   GIM_Try, /*On fail goto*//*Label 23194*/ GIMT_Encode4(1691993), // Rule ID 7115 //
     /* 1691912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1691923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1691926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1691929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1691932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691958 */     // MIs[0] policy
     /* 1691958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691968 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1691971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691992 */     // GIR_Coverage, 7115,
     /* 1691992 */     GIR_EraseRootFromParent_Done,
     /* 1691993 */   // Label 23194: @1691993
     /* 1691993 */   GIM_Try, /*On fail goto*//*Label 23195*/ GIMT_Encode4(1692079), // Rule ID 7118 //
     /* 1691998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1692009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1692012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1692015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1692018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692044 */     // MIs[0] policy
     /* 1692044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692078 */     // GIR_Coverage, 7118,
     /* 1692078 */     GIR_EraseRootFromParent_Done,
     /* 1692079 */   // Label 23195: @1692079
     /* 1692079 */   GIM_Try, /*On fail goto*//*Label 23196*/ GIMT_Encode4(1692165), // Rule ID 7119 //
     /* 1692084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1692095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1692098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1692101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1692104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692130 */     // MIs[0] policy
     /* 1692130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692140 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692164 */     // GIR_Coverage, 7119,
     /* 1692164 */     GIR_EraseRootFromParent_Done,
     /* 1692165 */   // Label 23196: @1692165
     /* 1692165 */   GIM_Try, /*On fail goto*//*Label 23197*/ GIMT_Encode4(1692251), // Rule ID 7122 //
     /* 1692170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1692187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1692190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692216 */     // MIs[0] policy
     /* 1692216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692250 */     // GIR_Coverage, 7122,
     /* 1692250 */     GIR_EraseRootFromParent_Done,
     /* 1692251 */   // Label 23197: @1692251
     /* 1692251 */   GIM_Try, /*On fail goto*//*Label 23198*/ GIMT_Encode4(1692337), // Rule ID 7123 //
     /* 1692256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1692273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1692276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692302 */     // MIs[0] policy
     /* 1692302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692312 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692336 */     // GIR_Coverage, 7123,
     /* 1692336 */     GIR_EraseRootFromParent_Done,
     /* 1692337 */   // Label 23198: @1692337
     /* 1692337 */   GIM_Try, /*On fail goto*//*Label 23199*/ GIMT_Encode4(1692423), // Rule ID 7126 //
     /* 1692342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1692353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1692356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1692359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1692362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692388 */     // MIs[0] policy
     /* 1692388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692422 */     // GIR_Coverage, 7126,
     /* 1692422 */     GIR_EraseRootFromParent_Done,
     /* 1692423 */   // Label 23199: @1692423
     /* 1692423 */   GIM_Try, /*On fail goto*//*Label 23200*/ GIMT_Encode4(1692509), // Rule ID 7127 //
     /* 1692428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1692439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1692442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1692445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1692448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692474 */     // MIs[0] policy
     /* 1692474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692508 */     // GIR_Coverage, 7127,
     /* 1692508 */     GIR_EraseRootFromParent_Done,
     /* 1692509 */   // Label 23200: @1692509
     /* 1692509 */   GIM_Try, /*On fail goto*//*Label 23201*/ GIMT_Encode4(1692595), // Rule ID 7130 //
     /* 1692514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1692525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1692528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1692531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1692534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692560 */     // MIs[0] policy
     /* 1692560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692594 */     // GIR_Coverage, 7130,
     /* 1692594 */     GIR_EraseRootFromParent_Done,
     /* 1692595 */   // Label 23201: @1692595
     /* 1692595 */   GIM_Try, /*On fail goto*//*Label 23202*/ GIMT_Encode4(1692681), // Rule ID 7131 //
     /* 1692600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1692611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1692614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1692617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1692620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692646 */     // MIs[0] policy
     /* 1692646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692680 */     // GIR_Coverage, 7131,
     /* 1692680 */     GIR_EraseRootFromParent_Done,
     /* 1692681 */   // Label 23202: @1692681
     /* 1692681 */   GIM_Try, /*On fail goto*//*Label 23203*/ GIMT_Encode4(1692767), // Rule ID 7134 //
     /* 1692686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1692689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1692697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1692700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1692703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1692706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692732 */     // MIs[0] policy
     /* 1692732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692742 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692766 */     // GIR_Coverage, 7134,
     /* 1692766 */     GIR_EraseRootFromParent_Done,
     /* 1692767 */   // Label 23203: @1692767
     /* 1692767 */   GIM_Try, /*On fail goto*//*Label 23204*/ GIMT_Encode4(1692853), // Rule ID 7135 //
     /* 1692772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1692775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1692783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1692786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1692789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1692792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692818 */     // MIs[0] policy
     /* 1692818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692828 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692852 */     // GIR_Coverage, 7135,
     /* 1692852 */     GIR_EraseRootFromParent_Done,
     /* 1692853 */   // Label 23204: @1692853
     /* 1692853 */   GIM_Try, /*On fail goto*//*Label 23205*/ GIMT_Encode4(1692939), // Rule ID 7138 //
     /* 1692858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1692869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1692872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1692875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1692878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1692881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1692888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692904 */     // MIs[0] policy
     /* 1692904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692914 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1692917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692938 */     // GIR_Coverage, 7138,
     /* 1692938 */     GIR_EraseRootFromParent_Done,
     /* 1692939 */   // Label 23205: @1692939
     /* 1692939 */   GIM_Try, /*On fail goto*//*Label 23206*/ GIMT_Encode4(1693025), // Rule ID 7139 //
     /* 1692944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1692955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1692958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1692961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1692964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1692967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1692974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692990 */     // MIs[0] policy
     /* 1692990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693000 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693024 */     // GIR_Coverage, 7139,
     /* 1693024 */     GIR_EraseRootFromParent_Done,
     /* 1693025 */   // Label 23206: @1693025
     /* 1693025 */   GIM_Try, /*On fail goto*//*Label 23207*/ GIMT_Encode4(1693111), // Rule ID 7142 //
     /* 1693030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1693041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1693044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1693047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1693050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693076 */     // MIs[0] policy
     /* 1693076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693086 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1693089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693110 */     // GIR_Coverage, 7142,
     /* 1693110 */     GIR_EraseRootFromParent_Done,
     /* 1693111 */   // Label 23207: @1693111
     /* 1693111 */   GIM_Try, /*On fail goto*//*Label 23208*/ GIMT_Encode4(1693197), // Rule ID 7143 //
     /* 1693116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1693127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1693130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1693133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1693136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693162 */     // MIs[0] policy
     /* 1693162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693172 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1693175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693196 */     // GIR_Coverage, 7143,
     /* 1693196 */     GIR_EraseRootFromParent_Done,
     /* 1693197 */   // Label 23208: @1693197
     /* 1693197 */   GIM_Try, /*On fail goto*//*Label 23209*/ GIMT_Encode4(1693283), // Rule ID 7146 //
     /* 1693202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1693213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1693216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1693219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1693222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1693225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693248 */     // MIs[0] policy
     /* 1693248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693258 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1693261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693282 */     // GIR_Coverage, 7146,
     /* 1693282 */     GIR_EraseRootFromParent_Done,
     /* 1693283 */   // Label 23209: @1693283
     /* 1693283 */   GIM_Try, /*On fail goto*//*Label 23210*/ GIMT_Encode4(1693369), // Rule ID 7147 //
     /* 1693288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1693299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1693302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1693305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1693308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1693311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693334 */     // MIs[0] policy
     /* 1693334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693344 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1693347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693368 */     // GIR_Coverage, 7147,
     /* 1693368 */     GIR_EraseRootFromParent_Done,
     /* 1693369 */   // Label 23210: @1693369
     /* 1693369 */   GIM_Try, /*On fail goto*//*Label 23211*/ GIMT_Encode4(1693455), // Rule ID 7150 //
     /* 1693374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1693385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1693388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1693391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1693394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693420 */     // MIs[0] policy
     /* 1693420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693430 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693454 */     // GIR_Coverage, 7150,
     /* 1693454 */     GIR_EraseRootFromParent_Done,
     /* 1693455 */   // Label 23211: @1693455
     /* 1693455 */   GIM_Try, /*On fail goto*//*Label 23212*/ GIMT_Encode4(1693541), // Rule ID 7151 //
     /* 1693460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1693471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1693474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1693477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1693480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693506 */     // MIs[0] policy
     /* 1693506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693540 */     // GIR_Coverage, 7151,
     /* 1693540 */     GIR_EraseRootFromParent_Done,
     /* 1693541 */   // Label 23212: @1693541
     /* 1693541 */   GIM_Try, /*On fail goto*//*Label 23213*/ GIMT_Encode4(1693627), // Rule ID 7154 //
     /* 1693546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1693557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1693560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1693563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1693566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693592 */     // MIs[0] policy
     /* 1693592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693602 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1693605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693626 */     // GIR_Coverage, 7154,
     /* 1693626 */     GIR_EraseRootFromParent_Done,
     /* 1693627 */   // Label 23213: @1693627
     /* 1693627 */   GIM_Try, /*On fail goto*//*Label 23214*/ GIMT_Encode4(1693713), // Rule ID 7155 //
     /* 1693632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1693643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1693646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1693649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1693652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693678 */     // MIs[0] policy
     /* 1693678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693688 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1693691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693712 */     // GIR_Coverage, 7155,
     /* 1693712 */     GIR_EraseRootFromParent_Done,
     /* 1693713 */   // Label 23214: @1693713
     /* 1693713 */   GIM_Try, /*On fail goto*//*Label 23215*/ GIMT_Encode4(1693799), // Rule ID 7158 //
     /* 1693718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1693729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1693732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1693735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1693738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693764 */     // MIs[0] policy
     /* 1693764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693774 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1693777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693798 */     // GIR_Coverage, 7158,
     /* 1693798 */     GIR_EraseRootFromParent_Done,
     /* 1693799 */   // Label 23215: @1693799
     /* 1693799 */   GIM_Try, /*On fail goto*//*Label 23216*/ GIMT_Encode4(1693885), // Rule ID 7159 //
     /* 1693804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1693815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1693818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1693821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1693824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693850 */     // MIs[0] policy
     /* 1693850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693860 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1693863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693884 */     // GIR_Coverage, 7159,
     /* 1693884 */     GIR_EraseRootFromParent_Done,
     /* 1693885 */   // Label 23216: @1693885
     /* 1693885 */   GIM_Try, /*On fail goto*//*Label 23217*/ GIMT_Encode4(1693971), // Rule ID 7162 //
     /* 1693890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1693901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1693904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1693907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1693910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1693913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693936 */     // MIs[0] policy
     /* 1693936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1693967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693970 */     // GIR_Coverage, 7162,
     /* 1693970 */     GIR_EraseRootFromParent_Done,
     /* 1693971 */   // Label 23217: @1693971
     /* 1693971 */   GIM_Try, /*On fail goto*//*Label 23218*/ GIMT_Encode4(1694057), // Rule ID 7163 //
     /* 1693976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1693987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1693990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1693993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1693996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1693999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694022 */     // MIs[0] policy
     /* 1694022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1694035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694056 */     // GIR_Coverage, 7163,
     /* 1694056 */     GIR_EraseRootFromParent_Done,
     /* 1694057 */   // Label 23218: @1694057
     /* 1694057 */   GIM_Try, /*On fail goto*//*Label 23219*/ GIMT_Encode4(1694143), // Rule ID 7166 //
     /* 1694062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1694079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1694082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694108 */     // MIs[0] policy
     /* 1694108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694142 */     // GIR_Coverage, 7166,
     /* 1694142 */     GIR_EraseRootFromParent_Done,
     /* 1694143 */   // Label 23219: @1694143
     /* 1694143 */   GIM_Try, /*On fail goto*//*Label 23220*/ GIMT_Encode4(1694229), // Rule ID 7167 //
     /* 1694148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1694165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1694168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694194 */     // MIs[0] policy
     /* 1694194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694204 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694228 */     // GIR_Coverage, 7167,
     /* 1694228 */     GIR_EraseRootFromParent_Done,
     /* 1694229 */   // Label 23220: @1694229
     /* 1694229 */   GIM_Try, /*On fail goto*//*Label 23221*/ GIMT_Encode4(1694315), // Rule ID 7170 //
     /* 1694234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1694245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1694248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1694251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1694254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694280 */     // MIs[0] policy
     /* 1694280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694290 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694314 */     // GIR_Coverage, 7170,
     /* 1694314 */     GIR_EraseRootFromParent_Done,
     /* 1694315 */   // Label 23221: @1694315
     /* 1694315 */   GIM_Try, /*On fail goto*//*Label 23222*/ GIMT_Encode4(1694401), // Rule ID 7171 //
     /* 1694320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1694331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1694334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1694337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1694340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694366 */     // MIs[0] policy
     /* 1694366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694376 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694400 */     // GIR_Coverage, 7171,
     /* 1694400 */     GIR_EraseRootFromParent_Done,
     /* 1694401 */   // Label 23222: @1694401
     /* 1694401 */   GIM_Try, /*On fail goto*//*Label 23223*/ GIMT_Encode4(1694487), // Rule ID 7174 //
     /* 1694406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1694409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1694417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1694420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1694423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1694426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694452 */     // MIs[0] policy
     /* 1694452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694462 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1694465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694486 */     // GIR_Coverage, 7174,
     /* 1694486 */     GIR_EraseRootFromParent_Done,
     /* 1694487 */   // Label 23223: @1694487
     /* 1694487 */   GIM_Try, /*On fail goto*//*Label 23224*/ GIMT_Encode4(1694573), // Rule ID 7175 //
     /* 1694492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1694495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1694503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1694506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1694509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1694512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694538 */     // MIs[0] policy
     /* 1694538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694548 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1694551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694572 */     // GIR_Coverage, 7175,
     /* 1694572 */     GIR_EraseRootFromParent_Done,
     /* 1694573 */   // Label 23224: @1694573
     /* 1694573 */   GIM_Try, /*On fail goto*//*Label 23225*/ GIMT_Encode4(1694659), // Rule ID 7178 //
     /* 1694578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1694581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1694589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1694592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1694595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1694598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694624 */     // MIs[0] policy
     /* 1694624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694658 */     // GIR_Coverage, 7178,
     /* 1694658 */     GIR_EraseRootFromParent_Done,
     /* 1694659 */   // Label 23225: @1694659
     /* 1694659 */   GIM_Try, /*On fail goto*//*Label 23226*/ GIMT_Encode4(1694745), // Rule ID 7179 //
     /* 1694664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1694667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1694675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1694678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1694681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1694684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694710 */     // MIs[0] policy
     /* 1694710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694744 */     // GIR_Coverage, 7179,
     /* 1694744 */     GIR_EraseRootFromParent_Done,
     /* 1694745 */   // Label 23226: @1694745
     /* 1694745 */   GIM_Try, /*On fail goto*//*Label 23227*/ GIMT_Encode4(1694831), // Rule ID 7182 //
     /* 1694750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1694753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1694761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1694764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1694767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1694770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694796 */     // MIs[0] policy
     /* 1694796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694830 */     // GIR_Coverage, 7182,
     /* 1694830 */     GIR_EraseRootFromParent_Done,
     /* 1694831 */   // Label 23227: @1694831
     /* 1694831 */   GIM_Try, /*On fail goto*//*Label 23228*/ GIMT_Encode4(1694917), // Rule ID 7183 //
     /* 1694836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1694839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1694847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1694850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1694853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1694856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694882 */     // MIs[0] policy
     /* 1694882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694892 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694916 */     // GIR_Coverage, 7183,
     /* 1694916 */     GIR_EraseRootFromParent_Done,
     /* 1694917 */   // Label 23228: @1694917
     /* 1694917 */   GIM_Try, /*On fail goto*//*Label 23229*/ GIMT_Encode4(1695003), // Rule ID 7186 //
     /* 1694922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1694933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1694936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1694939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1694945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694968 */     // MIs[0] policy
     /* 1694968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694978 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1694981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1694999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695002 */     // GIR_Coverage, 7186,
     /* 1695002 */     GIR_EraseRootFromParent_Done,
     /* 1695003 */   // Label 23229: @1695003
     /* 1695003 */   GIM_Try, /*On fail goto*//*Label 23230*/ GIMT_Encode4(1695089), // Rule ID 7187 //
     /* 1695008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1695019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1695022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1695025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695054 */     // MIs[0] policy
     /* 1695054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695064 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1695067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695088 */     // GIR_Coverage, 7187,
     /* 1695088 */     GIR_EraseRootFromParent_Done,
     /* 1695089 */   // Label 23230: @1695089
     /* 1695089 */   GIM_Try, /*On fail goto*//*Label 23231*/ GIMT_Encode4(1695175), // Rule ID 7190 //
     /* 1695094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1695105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1695108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1695111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695140 */     // MIs[0] policy
     /* 1695140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695150 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695174 */     // GIR_Coverage, 7190,
     /* 1695174 */     GIR_EraseRootFromParent_Done,
     /* 1695175 */   // Label 23231: @1695175
     /* 1695175 */   GIM_Try, /*On fail goto*//*Label 23232*/ GIMT_Encode4(1695261), // Rule ID 7191 //
     /* 1695180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1695191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1695194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1695197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695226 */     // MIs[0] policy
     /* 1695226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695236 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695260 */     // GIR_Coverage, 7191,
     /* 1695260 */     GIR_EraseRootFromParent_Done,
     /* 1695261 */   // Label 23232: @1695261
     /* 1695261 */   GIM_Try, /*On fail goto*//*Label 23233*/ GIMT_Encode4(1695347), // Rule ID 7194 //
     /* 1695266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1695277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1695280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1695283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695312 */     // MIs[0] policy
     /* 1695312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695322 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695346 */     // GIR_Coverage, 7194,
     /* 1695346 */     GIR_EraseRootFromParent_Done,
     /* 1695347 */   // Label 23233: @1695347
     /* 1695347 */   GIM_Try, /*On fail goto*//*Label 23234*/ GIMT_Encode4(1695433), // Rule ID 7195 //
     /* 1695352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1695363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1695366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1695369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695398 */     // MIs[0] policy
     /* 1695398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695408 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695432 */     // GIR_Coverage, 7195,
     /* 1695432 */     GIR_EraseRootFromParent_Done,
     /* 1695433 */   // Label 23234: @1695433
     /* 1695433 */   GIM_Try, /*On fail goto*//*Label 23235*/ GIMT_Encode4(1695519), // Rule ID 7198 //
     /* 1695438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1695449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1695452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1695455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695484 */     // MIs[0] policy
     /* 1695484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695518 */     // GIR_Coverage, 7198,
     /* 1695518 */     GIR_EraseRootFromParent_Done,
     /* 1695519 */   // Label 23235: @1695519
     /* 1695519 */   GIM_Try, /*On fail goto*//*Label 23236*/ GIMT_Encode4(1695605), // Rule ID 7199 //
     /* 1695524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1695535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1695538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1695541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695570 */     // MIs[0] policy
     /* 1695570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695580 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695604 */     // GIR_Coverage, 7199,
     /* 1695604 */     GIR_EraseRootFromParent_Done,
     /* 1695605 */   // Label 23236: @1695605
     /* 1695605 */   GIM_Try, /*On fail goto*//*Label 23237*/ GIMT_Encode4(1695691), // Rule ID 7202 //
     /* 1695610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1695621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1695624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1695627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695656 */     // MIs[0] policy
     /* 1695656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695666 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695690 */     // GIR_Coverage, 7202,
     /* 1695690 */     GIR_EraseRootFromParent_Done,
     /* 1695691 */   // Label 23237: @1695691
     /* 1695691 */   GIM_Try, /*On fail goto*//*Label 23238*/ GIMT_Encode4(1695777), // Rule ID 7203 //
     /* 1695696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1695707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1695710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1695713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695742 */     // MIs[0] policy
     /* 1695742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695752 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695776 */     // GIR_Coverage, 7203,
     /* 1695776 */     GIR_EraseRootFromParent_Done,
     /* 1695777 */   // Label 23238: @1695777
     /* 1695777 */   GIM_Try, /*On fail goto*//*Label 23239*/ GIMT_Encode4(1695863), // Rule ID 7206 //
     /* 1695782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1695793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1695796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1695799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695828 */     // MIs[0] policy
     /* 1695828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695838 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1695859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695862 */     // GIR_Coverage, 7206,
     /* 1695862 */     GIR_EraseRootFromParent_Done,
     /* 1695863 */   // Label 23239: @1695863
     /* 1695863 */   GIM_Try, /*On fail goto*//*Label 23240*/ GIMT_Encode4(1695949), // Rule ID 7207 //
     /* 1695868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1695879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1695882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1695885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695914 */     // MIs[0] policy
     /* 1695914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1695945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695948 */     // GIR_Coverage, 7207,
     /* 1695948 */     GIR_EraseRootFromParent_Done,
     /* 1695949 */   // Label 23240: @1695949
     /* 1695949 */   GIM_Try, /*On fail goto*//*Label 23241*/ GIMT_Encode4(1696035), // Rule ID 7210 //
     /* 1695954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1695965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1695968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1695971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1695977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696000 */     // MIs[0] policy
     /* 1696000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696010 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696034 */     // GIR_Coverage, 7210,
     /* 1696034 */     GIR_EraseRootFromParent_Done,
     /* 1696035 */   // Label 23241: @1696035
     /* 1696035 */   GIM_Try, /*On fail goto*//*Label 23242*/ GIMT_Encode4(1696121), // Rule ID 7211 //
     /* 1696040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1696051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1696054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1696057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696086 */     // MIs[0] policy
     /* 1696086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696120 */     // GIR_Coverage, 7211,
     /* 1696120 */     GIR_EraseRootFromParent_Done,
     /* 1696121 */   // Label 23242: @1696121
     /* 1696121 */   GIM_Try, /*On fail goto*//*Label 23243*/ GIMT_Encode4(1696207), // Rule ID 7214 //
     /* 1696126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696172 */     // MIs[0] policy
     /* 1696172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696206 */     // GIR_Coverage, 7214,
     /* 1696206 */     GIR_EraseRootFromParent_Done,
     /* 1696207 */   // Label 23243: @1696207
     /* 1696207 */   GIM_Try, /*On fail goto*//*Label 23244*/ GIMT_Encode4(1696293), // Rule ID 7215 //
     /* 1696212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696258 */     // MIs[0] policy
     /* 1696258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696292 */     // GIR_Coverage, 7215,
     /* 1696292 */     GIR_EraseRootFromParent_Done,
     /* 1696293 */   // Label 23244: @1696293
     /* 1696293 */   GIM_Try, /*On fail goto*//*Label 23245*/ GIMT_Encode4(1696379), // Rule ID 7218 //
     /* 1696298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1696309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1696312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1696315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696344 */     // MIs[0] policy
     /* 1696344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696378 */     // GIR_Coverage, 7218,
     /* 1696378 */     GIR_EraseRootFromParent_Done,
     /* 1696379 */   // Label 23245: @1696379
     /* 1696379 */   GIM_Try, /*On fail goto*//*Label 23246*/ GIMT_Encode4(1696465), // Rule ID 7219 //
     /* 1696384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1696395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1696398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1696401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696430 */     // MIs[0] policy
     /* 1696430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696464 */     // GIR_Coverage, 7219,
     /* 1696464 */     GIR_EraseRootFromParent_Done,
     /* 1696465 */   // Label 23246: @1696465
     /* 1696465 */   GIM_Try, /*On fail goto*//*Label 23247*/ GIMT_Encode4(1696551), // Rule ID 7222 //
     /* 1696470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1696473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1696481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1696484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1696487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696516 */     // MIs[0] policy
     /* 1696516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1696547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696550 */     // GIR_Coverage, 7222,
     /* 1696550 */     GIR_EraseRootFromParent_Done,
     /* 1696551 */   // Label 23247: @1696551
     /* 1696551 */   GIM_Try, /*On fail goto*//*Label 23248*/ GIMT_Encode4(1696637), // Rule ID 7223 //
     /* 1696556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1696559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1696567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1696570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1696573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696602 */     // MIs[0] policy
     /* 1696602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696612 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1696633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696636 */     // GIR_Coverage, 7223,
     /* 1696636 */     GIR_EraseRootFromParent_Done,
     /* 1696637 */   // Label 23248: @1696637
     /* 1696637 */   GIM_Try, /*On fail goto*//*Label 23249*/ GIMT_Encode4(1696723), // Rule ID 7226 //
     /* 1696642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1696653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1696656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1696659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1696665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1696672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696688 */     // MIs[0] policy
     /* 1696688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1696701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696722 */     // GIR_Coverage, 7226,
     /* 1696722 */     GIR_EraseRootFromParent_Done,
     /* 1696723 */   // Label 23249: @1696723
     /* 1696723 */   GIM_Try, /*On fail goto*//*Label 23250*/ GIMT_Encode4(1696809), // Rule ID 7227 //
     /* 1696728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1696739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1696742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1696745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1696751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1696758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696774 */     // MIs[0] policy
     /* 1696774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1696787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696808 */     // GIR_Coverage, 7227,
     /* 1696808 */     GIR_EraseRootFromParent_Done,
     /* 1696809 */   // Label 23250: @1696809
     /* 1696809 */   GIM_Try, /*On fail goto*//*Label 23251*/ GIMT_Encode4(1696895), // Rule ID 7230 //
     /* 1696814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1696825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1696828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1696831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1696837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1696844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696860 */     // MIs[0] policy
     /* 1696860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1696873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696894 */     // GIR_Coverage, 7230,
     /* 1696894 */     GIR_EraseRootFromParent_Done,
     /* 1696895 */   // Label 23251: @1696895
     /* 1696895 */   GIM_Try, /*On fail goto*//*Label 23252*/ GIMT_Encode4(1696981), // Rule ID 7231 //
     /* 1696900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1696911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1696914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1696917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1696923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1696930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696946 */     // MIs[0] policy
     /* 1696946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696956 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1696959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696980 */     // GIR_Coverage, 7231,
     /* 1696980 */     GIR_EraseRootFromParent_Done,
     /* 1696981 */   // Label 23252: @1696981
     /* 1696981 */   GIM_Try, /*On fail goto*//*Label 23253*/ GIMT_Encode4(1697067), // Rule ID 7234 //
     /* 1696986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1696997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1697000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1697003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1697009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697032 */     // MIs[0] policy
     /* 1697032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697042 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1697045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697066 */     // GIR_Coverage, 7234,
     /* 1697066 */     GIR_EraseRootFromParent_Done,
     /* 1697067 */   // Label 23253: @1697067
     /* 1697067 */   GIM_Try, /*On fail goto*//*Label 23254*/ GIMT_Encode4(1697153), // Rule ID 7235 //
     /* 1697072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1697083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1697086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1697089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1697095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697118 */     // MIs[0] policy
     /* 1697118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697128 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1697131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697152 */     // GIR_Coverage, 7235,
     /* 1697152 */     GIR_EraseRootFromParent_Done,
     /* 1697153 */   // Label 23254: @1697153
     /* 1697153 */   GIM_Try, /*On fail goto*//*Label 23255*/ GIMT_Encode4(1697239), // Rule ID 7238 //
     /* 1697158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1697169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1697172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697204 */     // MIs[0] policy
     /* 1697204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697214 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697238 */     // GIR_Coverage, 7238,
     /* 1697238 */     GIR_EraseRootFromParent_Done,
     /* 1697239 */   // Label 23255: @1697239
     /* 1697239 */   GIM_Try, /*On fail goto*//*Label 23256*/ GIMT_Encode4(1697325), // Rule ID 7239 //
     /* 1697244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1697255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1697258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697290 */     // MIs[0] policy
     /* 1697290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697300 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697324 */     // GIR_Coverage, 7239,
     /* 1697324 */     GIR_EraseRootFromParent_Done,
     /* 1697325 */   // Label 23256: @1697325
     /* 1697325 */   GIM_Try, /*On fail goto*//*Label 23257*/ GIMT_Encode4(1697411), // Rule ID 7242 //
     /* 1697330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1697341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1697344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1697347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697376 */     // MIs[0] policy
     /* 1697376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697386 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697410 */     // GIR_Coverage, 7242,
     /* 1697410 */     GIR_EraseRootFromParent_Done,
     /* 1697411 */   // Label 23257: @1697411
     /* 1697411 */   GIM_Try, /*On fail goto*//*Label 23258*/ GIMT_Encode4(1697497), // Rule ID 7243 //
     /* 1697416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1697427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1697430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1697433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697462 */     // MIs[0] policy
     /* 1697462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697472 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697496 */     // GIR_Coverage, 7243,
     /* 1697496 */     GIR_EraseRootFromParent_Done,
     /* 1697497 */   // Label 23258: @1697497
     /* 1697497 */   GIM_Try, /*On fail goto*//*Label 23259*/ GIMT_Encode4(1697583), // Rule ID 7246 //
     /* 1697502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1697513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1697516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1697519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697548 */     // MIs[0] policy
     /* 1697548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1697561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697582 */     // GIR_Coverage, 7246,
     /* 1697582 */     GIR_EraseRootFromParent_Done,
     /* 1697583 */   // Label 23259: @1697583
     /* 1697583 */   GIM_Try, /*On fail goto*//*Label 23260*/ GIMT_Encode4(1697669), // Rule ID 7247 //
     /* 1697588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1697599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1697602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1697605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697634 */     // MIs[0] policy
     /* 1697634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697644 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1697647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697668 */     // GIR_Coverage, 7247,
     /* 1697668 */     GIR_EraseRootFromParent_Done,
     /* 1697669 */   // Label 23260: @1697669
     /* 1697669 */   GIM_Try, /*On fail goto*//*Label 23261*/ GIMT_Encode4(1697755), // Rule ID 7250 //
     /* 1697674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1697685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1697688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1697691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1697697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697720 */     // MIs[0] policy
     /* 1697720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697754 */     // GIR_Coverage, 7250,
     /* 1697754 */     GIR_EraseRootFromParent_Done,
     /* 1697755 */   // Label 23261: @1697755
     /* 1697755 */   GIM_Try, /*On fail goto*//*Label 23262*/ GIMT_Encode4(1697841), // Rule ID 7251 //
     /* 1697760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1697771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1697774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1697777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1697783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697806 */     // MIs[0] policy
     /* 1697806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697816 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697840 */     // GIR_Coverage, 7251,
     /* 1697840 */     GIR_EraseRootFromParent_Done,
     /* 1697841 */   // Label 23262: @1697841
     /* 1697841 */   GIM_Try, /*On fail goto*//*Label 23263*/ GIMT_Encode4(1697927), // Rule ID 7254 //
     /* 1697846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1697857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1697860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1697863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697892 */     // MIs[0] policy
     /* 1697892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697926 */     // GIR_Coverage, 7254,
     /* 1697926 */     GIR_EraseRootFromParent_Done,
     /* 1697927 */   // Label 23263: @1697927
     /* 1697927 */   GIM_Try, /*On fail goto*//*Label 23264*/ GIMT_Encode4(1698013), // Rule ID 7255 //
     /* 1697932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1697943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1697946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1697949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697978 */     // MIs[0] policy
     /* 1697978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697988 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698012 */     // GIR_Coverage, 7255,
     /* 1698012 */     GIR_EraseRootFromParent_Done,
     /* 1698013 */   // Label 23264: @1698013
     /* 1698013 */   GIM_Try, /*On fail goto*//*Label 23265*/ GIMT_Encode4(1698099), // Rule ID 7258 //
     /* 1698018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1698029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1698032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698064 */     // MIs[0] policy
     /* 1698064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698074 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698098 */     // GIR_Coverage, 7258,
     /* 1698098 */     GIR_EraseRootFromParent_Done,
     /* 1698099 */   // Label 23265: @1698099
     /* 1698099 */   GIM_Try, /*On fail goto*//*Label 23266*/ GIMT_Encode4(1698185), // Rule ID 7259 //
     /* 1698104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1698115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1698118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698150 */     // MIs[0] policy
     /* 1698150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698160 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698184 */     // GIR_Coverage, 7259,
     /* 1698184 */     GIR_EraseRootFromParent_Done,
     /* 1698185 */   // Label 23266: @1698185
     /* 1698185 */   GIM_Try, /*On fail goto*//*Label 23267*/ GIMT_Encode4(1698271), // Rule ID 7262 //
     /* 1698190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1698201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1698204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698236 */     // MIs[0] policy
     /* 1698236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1698249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698270 */     // GIR_Coverage, 7262,
     /* 1698270 */     GIR_EraseRootFromParent_Done,
     /* 1698271 */   // Label 23267: @1698271
     /* 1698271 */   GIM_Try, /*On fail goto*//*Label 23268*/ GIMT_Encode4(1698357), // Rule ID 7263 //
     /* 1698276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1698287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1698290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698322 */     // MIs[0] policy
     /* 1698322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1698335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698356 */     // GIR_Coverage, 7263,
     /* 1698356 */     GIR_EraseRootFromParent_Done,
     /* 1698357 */   // Label 23268: @1698357
     /* 1698357 */   GIM_Try, /*On fail goto*//*Label 23269*/ GIMT_Encode4(1698443), // Rule ID 7266 //
     /* 1698362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1698373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1698376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1698379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698408 */     // MIs[0] policy
     /* 1698408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1698421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698442 */     // GIR_Coverage, 7266,
     /* 1698442 */     GIR_EraseRootFromParent_Done,
     /* 1698443 */   // Label 23269: @1698443
     /* 1698443 */   GIM_Try, /*On fail goto*//*Label 23270*/ GIMT_Encode4(1698529), // Rule ID 7267 //
     /* 1698448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1698459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1698462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1698465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698494 */     // MIs[0] policy
     /* 1698494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698504 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1698507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698528 */     // GIR_Coverage, 7267,
     /* 1698528 */     GIR_EraseRootFromParent_Done,
     /* 1698529 */   // Label 23270: @1698529
     /* 1698529 */   GIM_Try, /*On fail goto*//*Label 23271*/ GIMT_Encode4(1698615), // Rule ID 7270 //
     /* 1698534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1698545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1698548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1698551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698580 */     // MIs[0] policy
     /* 1698580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698614 */     // GIR_Coverage, 7270,
     /* 1698614 */     GIR_EraseRootFromParent_Done,
     /* 1698615 */   // Label 23271: @1698615
     /* 1698615 */   GIM_Try, /*On fail goto*//*Label 23272*/ GIMT_Encode4(1698701), // Rule ID 7271 //
     /* 1698620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1698631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1698634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1698637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698666 */     // MIs[0] policy
     /* 1698666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698700 */     // GIR_Coverage, 7271,
     /* 1698700 */     GIR_EraseRootFromParent_Done,
     /* 1698701 */   // Label 23272: @1698701
     /* 1698701 */   GIM_Try, /*On fail goto*//*Label 23273*/ GIMT_Encode4(1698787), // Rule ID 7450 //
     /* 1698706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1698717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1698720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1698723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1698726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1698729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698752 */     // MIs[0] policy
     /* 1698752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698762 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1698765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1698783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698786 */     // GIR_Coverage, 7450,
     /* 1698786 */     GIR_EraseRootFromParent_Done,
     /* 1698787 */   // Label 23273: @1698787
     /* 1698787 */   GIM_Try, /*On fail goto*//*Label 23274*/ GIMT_Encode4(1698873), // Rule ID 7451 //
     /* 1698792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1698803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1698806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1698809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1698812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1698815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698838 */     // MIs[0] policy
     /* 1698838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698848 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1698851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1698869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698872 */     // GIR_Coverage, 7451,
     /* 1698872 */     GIR_EraseRootFromParent_Done,
     /* 1698873 */   // Label 23274: @1698873
     /* 1698873 */   GIM_Try, /*On fail goto*//*Label 23275*/ GIMT_Encode4(1698959), // Rule ID 7454 //
     /* 1698878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1698889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1698892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1698895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1698898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698924 */     // MIs[0] policy
     /* 1698924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698934 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1698937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1698955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698958 */     // GIR_Coverage, 7454,
     /* 1698958 */     GIR_EraseRootFromParent_Done,
     /* 1698959 */   // Label 23275: @1698959
     /* 1698959 */   GIM_Try, /*On fail goto*//*Label 23276*/ GIMT_Encode4(1699045), // Rule ID 7455 //
     /* 1698964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1698975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1698978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1698981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1698984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699010 */     // MIs[0] policy
     /* 1699010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699020 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1699023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699044 */     // GIR_Coverage, 7455,
     /* 1699044 */     GIR_EraseRootFromParent_Done,
     /* 1699045 */   // Label 23276: @1699045
     /* 1699045 */   GIM_Try, /*On fail goto*//*Label 23277*/ GIMT_Encode4(1699131), // Rule ID 7458 //
     /* 1699050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1699061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1699064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1699067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1699070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699096 */     // MIs[0] policy
     /* 1699096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699106 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1699109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699130 */     // GIR_Coverage, 7458,
     /* 1699130 */     GIR_EraseRootFromParent_Done,
     /* 1699131 */   // Label 23277: @1699131
     /* 1699131 */   GIM_Try, /*On fail goto*//*Label 23278*/ GIMT_Encode4(1699217), // Rule ID 7459 //
     /* 1699136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1699147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1699150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1699153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1699156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699182 */     // MIs[0] policy
     /* 1699182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699192 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1699195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699216 */     // GIR_Coverage, 7459,
     /* 1699216 */     GIR_EraseRootFromParent_Done,
     /* 1699217 */   // Label 23278: @1699217
     /* 1699217 */   GIM_Try, /*On fail goto*//*Label 23279*/ GIMT_Encode4(1699303), // Rule ID 7462 //
     /* 1699222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1699233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1699236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1699239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1699242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699268 */     // MIs[0] policy
     /* 1699268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699278 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1699281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699302 */     // GIR_Coverage, 7462,
     /* 1699302 */     GIR_EraseRootFromParent_Done,
     /* 1699303 */   // Label 23279: @1699303
     /* 1699303 */   GIM_Try, /*On fail goto*//*Label 23280*/ GIMT_Encode4(1699389), // Rule ID 7463 //
     /* 1699308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1699319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1699322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1699325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1699328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699354 */     // MIs[0] policy
     /* 1699354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699364 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1699367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699388 */     // GIR_Coverage, 7463,
     /* 1699388 */     GIR_EraseRootFromParent_Done,
     /* 1699389 */   // Label 23280: @1699389
     /* 1699389 */   GIM_Try, /*On fail goto*//*Label 23281*/ GIMT_Encode4(1699475), // Rule ID 7466 //
     /* 1699394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1699405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1699408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1699411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1699414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1699417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699440 */     // MIs[0] policy
     /* 1699440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699450 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1699453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699474 */     // GIR_Coverage, 7466,
     /* 1699474 */     GIR_EraseRootFromParent_Done,
     /* 1699475 */   // Label 23281: @1699475
     /* 1699475 */   GIM_Try, /*On fail goto*//*Label 23282*/ GIMT_Encode4(1699561), // Rule ID 7467 //
     /* 1699480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1699491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1699494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1699497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1699500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1699503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699526 */     // MIs[0] policy
     /* 1699526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1699539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699560 */     // GIR_Coverage, 7467,
     /* 1699560 */     GIR_EraseRootFromParent_Done,
     /* 1699561 */   // Label 23282: @1699561
     /* 1699561 */   GIM_Try, /*On fail goto*//*Label 23283*/ GIMT_Encode4(1699647), // Rule ID 7470 //
     /* 1699566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1699577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1699580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1699583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1699586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1699589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1699596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699612 */     // MIs[0] policy
     /* 1699612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699622 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1699625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699646 */     // GIR_Coverage, 7470,
     /* 1699646 */     GIR_EraseRootFromParent_Done,
     /* 1699647 */   // Label 23283: @1699647
     /* 1699647 */   GIM_Try, /*On fail goto*//*Label 23284*/ GIMT_Encode4(1699733), // Rule ID 7471 //
     /* 1699652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1699663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1699666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1699669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1699672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1699675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1699682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699698 */     // MIs[0] policy
     /* 1699698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699708 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1699711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699732 */     // GIR_Coverage, 7471,
     /* 1699732 */     GIR_EraseRootFromParent_Done,
     /* 1699733 */   // Label 23284: @1699733
     /* 1699733 */   GIM_Try, /*On fail goto*//*Label 23285*/ GIMT_Encode4(1699819), // Rule ID 7474 //
     /* 1699738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1699749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1699752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1699755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1699758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699784 */     // MIs[0] policy
     /* 1699784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699794 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1699797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1699815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699818 */     // GIR_Coverage, 7474,
     /* 1699818 */     GIR_EraseRootFromParent_Done,
     /* 1699819 */   // Label 23285: @1699819
     /* 1699819 */   GIM_Try, /*On fail goto*//*Label 23286*/ GIMT_Encode4(1699905), // Rule ID 7475 //
     /* 1699824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1699835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1699838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1699841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1699844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699870 */     // MIs[0] policy
     /* 1699870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699880 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1699883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1699901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699904 */     // GIR_Coverage, 7475,
     /* 1699904 */     GIR_EraseRootFromParent_Done,
     /* 1699905 */   // Label 23286: @1699905
     /* 1699905 */   GIM_Try, /*On fail goto*//*Label 23287*/ GIMT_Encode4(1699991), // Rule ID 7478 //
     /* 1699910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1699921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1699924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1699927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1699930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699956 */     // MIs[0] policy
     /* 1699956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699966 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1699969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1699987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699990 */     // GIR_Coverage, 7478,
     /* 1699990 */     GIR_EraseRootFromParent_Done,
     /* 1699991 */   // Label 23287: @1699991
     /* 1699991 */   GIM_Try, /*On fail goto*//*Label 23288*/ GIMT_Encode4(1700077), // Rule ID 7479 //
     /* 1699996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1700007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1700010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1700013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1700016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700042 */     // MIs[0] policy
     /* 1700042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700052 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1700055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700076 */     // GIR_Coverage, 7479,
     /* 1700076 */     GIR_EraseRootFromParent_Done,
     /* 1700077 */   // Label 23288: @1700077
     /* 1700077 */   GIM_Try, /*On fail goto*//*Label 23289*/ GIMT_Encode4(1700163), // Rule ID 7482 //
     /* 1700082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1700093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1700096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1700099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1700102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700128 */     // MIs[0] policy
     /* 1700128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700138 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1700141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700162 */     // GIR_Coverage, 7482,
     /* 1700162 */     GIR_EraseRootFromParent_Done,
     /* 1700163 */   // Label 23289: @1700163
     /* 1700163 */   GIM_Try, /*On fail goto*//*Label 23290*/ GIMT_Encode4(1700249), // Rule ID 7483 //
     /* 1700168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1700179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1700182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1700185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1700188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700214 */     // MIs[0] policy
     /* 1700214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1700227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700248 */     // GIR_Coverage, 7483,
     /* 1700248 */     GIR_EraseRootFromParent_Done,
     /* 1700249 */   // Label 23290: @1700249
     /* 1700249 */   GIM_Try, /*On fail goto*//*Label 23291*/ GIMT_Encode4(1700335), // Rule ID 7486 //
     /* 1700254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1700265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1700268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1700271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1700274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1700277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700300 */     // MIs[0] policy
     /* 1700300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700310 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1700313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700334 */     // GIR_Coverage, 7486,
     /* 1700334 */     GIR_EraseRootFromParent_Done,
     /* 1700335 */   // Label 23291: @1700335
     /* 1700335 */   GIM_Try, /*On fail goto*//*Label 23292*/ GIMT_Encode4(1700421), // Rule ID 7487 //
     /* 1700340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1700351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1700354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1700357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1700360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1700363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700386 */     // MIs[0] policy
     /* 1700386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1700399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700420 */     // GIR_Coverage, 7487,
     /* 1700420 */     GIR_EraseRootFromParent_Done,
     /* 1700421 */   // Label 23292: @1700421
     /* 1700421 */   GIM_Try, /*On fail goto*//*Label 23293*/ GIMT_Encode4(1700507), // Rule ID 7490 //
     /* 1700426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1700437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1700440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1700443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1700446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700472 */     // MIs[0] policy
     /* 1700472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700482 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1700485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700506 */     // GIR_Coverage, 7490,
     /* 1700506 */     GIR_EraseRootFromParent_Done,
     /* 1700507 */   // Label 23293: @1700507
     /* 1700507 */   GIM_Try, /*On fail goto*//*Label 23294*/ GIMT_Encode4(1700593), // Rule ID 7491 //
     /* 1700512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1700523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1700526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1700529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1700532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700558 */     // MIs[0] policy
     /* 1700558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700568 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1700571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700592 */     // GIR_Coverage, 7491,
     /* 1700592 */     GIR_EraseRootFromParent_Done,
     /* 1700593 */   // Label 23294: @1700593
     /* 1700593 */   GIM_Try, /*On fail goto*//*Label 23295*/ GIMT_Encode4(1700679), // Rule ID 7494 //
     /* 1700598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1700601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1700609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1700612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1700615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1700618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700644 */     // MIs[0] policy
     /* 1700644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1700657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1700675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700678 */     // GIR_Coverage, 7494,
     /* 1700678 */     GIR_EraseRootFromParent_Done,
     /* 1700679 */   // Label 23295: @1700679
     /* 1700679 */   GIM_Try, /*On fail goto*//*Label 23296*/ GIMT_Encode4(1700765), // Rule ID 7495 //
     /* 1700684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1700687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1700695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1700698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1700701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1700704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700730 */     // MIs[0] policy
     /* 1700730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700740 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1700743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1700761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700764 */     // GIR_Coverage, 7495,
     /* 1700764 */     GIR_EraseRootFromParent_Done,
     /* 1700765 */   // Label 23296: @1700765
     /* 1700765 */   GIM_Try, /*On fail goto*//*Label 23297*/ GIMT_Encode4(1700851), // Rule ID 7498 //
     /* 1700770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1700773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1700781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1700784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1700787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1700790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700816 */     // MIs[0] policy
     /* 1700816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1700829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1700847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700850 */     // GIR_Coverage, 7498,
     /* 1700850 */     GIR_EraseRootFromParent_Done,
     /* 1700851 */   // Label 23297: @1700851
     /* 1700851 */   GIM_Try, /*On fail goto*//*Label 23298*/ GIMT_Encode4(1700937), // Rule ID 7499 //
     /* 1700856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1700859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1700867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1700870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1700873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1700876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700902 */     // MIs[0] policy
     /* 1700902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700912 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1700915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1700933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700936 */     // GIR_Coverage, 7499,
     /* 1700936 */     GIR_EraseRootFromParent_Done,
     /* 1700937 */   // Label 23298: @1700937
     /* 1700937 */   GIM_Try, /*On fail goto*//*Label 23299*/ GIMT_Encode4(1701023), // Rule ID 7502 //
     /* 1700942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1700945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1700953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1700956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1700959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1700962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700988 */     // MIs[0] policy
     /* 1700988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1701001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701022 */     // GIR_Coverage, 7502,
     /* 1701022 */     GIR_EraseRootFromParent_Done,
     /* 1701023 */   // Label 23299: @1701023
     /* 1701023 */   GIM_Try, /*On fail goto*//*Label 23300*/ GIMT_Encode4(1701109), // Rule ID 7503 //
     /* 1701028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1701039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1701042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1701045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1701048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701074 */     // MIs[0] policy
     /* 1701074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1701087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701108 */     // GIR_Coverage, 7503,
     /* 1701108 */     GIR_EraseRootFromParent_Done,
     /* 1701109 */   // Label 23300: @1701109
     /* 1701109 */   GIM_Try, /*On fail goto*//*Label 23301*/ GIMT_Encode4(1701195), // Rule ID 7506 //
     /* 1701114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1701125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1701128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1701131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1701134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701160 */     // MIs[0] policy
     /* 1701160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701170 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1701173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701194 */     // GIR_Coverage, 7506,
     /* 1701194 */     GIR_EraseRootFromParent_Done,
     /* 1701195 */   // Label 23301: @1701195
     /* 1701195 */   GIM_Try, /*On fail goto*//*Label 23302*/ GIMT_Encode4(1701281), // Rule ID 7507 //
     /* 1701200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1701211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1701214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1701217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1701220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701246 */     // MIs[0] policy
     /* 1701246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701256 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1701259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701280 */     // GIR_Coverage, 7507,
     /* 1701280 */     GIR_EraseRootFromParent_Done,
     /* 1701281 */   // Label 23302: @1701281
     /* 1701281 */   GIM_Try, /*On fail goto*//*Label 23303*/ GIMT_Encode4(1701367), // Rule ID 7510 //
     /* 1701286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1701297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1701300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1701303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701332 */     // MIs[0] policy
     /* 1701332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701342 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1701345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701366 */     // GIR_Coverage, 7510,
     /* 1701366 */     GIR_EraseRootFromParent_Done,
     /* 1701367 */   // Label 23303: @1701367
     /* 1701367 */   GIM_Try, /*On fail goto*//*Label 23304*/ GIMT_Encode4(1701453), // Rule ID 7511 //
     /* 1701372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1701383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1701386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1701389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701418 */     // MIs[0] policy
     /* 1701418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701428 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1701431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701452 */     // GIR_Coverage, 7511,
     /* 1701452 */     GIR_EraseRootFromParent_Done,
     /* 1701453 */   // Label 23304: @1701453
     /* 1701453 */   GIM_Try, /*On fail goto*//*Label 23305*/ GIMT_Encode4(1701539), // Rule ID 7514 //
     /* 1701458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1701469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1701472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1701475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701504 */     // MIs[0] policy
     /* 1701504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701514 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1701517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701538 */     // GIR_Coverage, 7514,
     /* 1701538 */     GIR_EraseRootFromParent_Done,
     /* 1701539 */   // Label 23305: @1701539
     /* 1701539 */   GIM_Try, /*On fail goto*//*Label 23306*/ GIMT_Encode4(1701625), // Rule ID 7515 //
     /* 1701544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1701555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1701558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1701561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701590 */     // MIs[0] policy
     /* 1701590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701600 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1701603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701624 */     // GIR_Coverage, 7515,
     /* 1701624 */     GIR_EraseRootFromParent_Done,
     /* 1701625 */   // Label 23306: @1701625
     /* 1701625 */   GIM_Try, /*On fail goto*//*Label 23307*/ GIMT_Encode4(1701711), // Rule ID 7518 //
     /* 1701630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1701641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1701644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1701647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701676 */     // MIs[0] policy
     /* 1701676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701686 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1701689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701710 */     // GIR_Coverage, 7518,
     /* 1701710 */     GIR_EraseRootFromParent_Done,
     /* 1701711 */   // Label 23307: @1701711
     /* 1701711 */   GIM_Try, /*On fail goto*//*Label 23308*/ GIMT_Encode4(1701797), // Rule ID 7519 //
     /* 1701716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1701727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1701730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1701733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701762 */     // MIs[0] policy
     /* 1701762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701772 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1701775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701796 */     // GIR_Coverage, 7519,
     /* 1701796 */     GIR_EraseRootFromParent_Done,
     /* 1701797 */   // Label 23308: @1701797
     /* 1701797 */   GIM_Try, /*On fail goto*//*Label 23309*/ GIMT_Encode4(1701883), // Rule ID 7522 //
     /* 1701802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1701813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1701816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1701819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701848 */     // MIs[0] policy
     /* 1701848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701858 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1701861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701882 */     // GIR_Coverage, 7522,
     /* 1701882 */     GIR_EraseRootFromParent_Done,
     /* 1701883 */   // Label 23309: @1701883
     /* 1701883 */   GIM_Try, /*On fail goto*//*Label 23310*/ GIMT_Encode4(1701969), // Rule ID 7523 //
     /* 1701888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1701899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1701902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1701905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701934 */     // MIs[0] policy
     /* 1701934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701944 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1701947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701968 */     // GIR_Coverage, 7523,
     /* 1701968 */     GIR_EraseRootFromParent_Done,
     /* 1701969 */   // Label 23310: @1701969
     /* 1701969 */   GIM_Try, /*On fail goto*//*Label 23311*/ GIMT_Encode4(1702055), // Rule ID 7526 //
     /* 1701974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1701985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1701988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1701991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1701997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702020 */     // MIs[0] policy
     /* 1702020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702030 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1702033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702054 */     // GIR_Coverage, 7526,
     /* 1702054 */     GIR_EraseRootFromParent_Done,
     /* 1702055 */   // Label 23311: @1702055
     /* 1702055 */   GIM_Try, /*On fail goto*//*Label 23312*/ GIMT_Encode4(1702141), // Rule ID 7527 //
     /* 1702060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1702071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1702074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1702077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1702083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702106 */     // MIs[0] policy
     /* 1702106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702116 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1702119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702140 */     // GIR_Coverage, 7527,
     /* 1702140 */     GIR_EraseRootFromParent_Done,
     /* 1702141 */   // Label 23312: @1702141
     /* 1702141 */   GIM_Try, /*On fail goto*//*Label 23313*/ GIMT_Encode4(1702227), // Rule ID 7530 //
     /* 1702146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1702157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1702160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1702163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1702169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702192 */     // MIs[0] policy
     /* 1702192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702202 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1702205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702226 */     // GIR_Coverage, 7530,
     /* 1702226 */     GIR_EraseRootFromParent_Done,
     /* 1702227 */   // Label 23313: @1702227
     /* 1702227 */   GIM_Try, /*On fail goto*//*Label 23314*/ GIMT_Encode4(1702313), // Rule ID 7531 //
     /* 1702232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1702243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1702246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1702249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1702255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702278 */     // MIs[0] policy
     /* 1702278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702288 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1702291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702312 */     // GIR_Coverage, 7531,
     /* 1702312 */     GIR_EraseRootFromParent_Done,
     /* 1702313 */   // Label 23314: @1702313
     /* 1702313 */   GIM_Try, /*On fail goto*//*Label 23315*/ GIMT_Encode4(1702399), // Rule ID 7534 //
     /* 1702318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1702329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1702332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1702335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702364 */     // MIs[0] policy
     /* 1702364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702374 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1702377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702398 */     // GIR_Coverage, 7534,
     /* 1702398 */     GIR_EraseRootFromParent_Done,
     /* 1702399 */   // Label 23315: @1702399
     /* 1702399 */   GIM_Try, /*On fail goto*//*Label 23316*/ GIMT_Encode4(1702485), // Rule ID 7535 //
     /* 1702404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1702415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1702418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1702421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702450 */     // MIs[0] policy
     /* 1702450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702460 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1702463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702484 */     // GIR_Coverage, 7535,
     /* 1702484 */     GIR_EraseRootFromParent_Done,
     /* 1702485 */   // Label 23316: @1702485
     /* 1702485 */   GIM_Try, /*On fail goto*//*Label 23317*/ GIMT_Encode4(1702571), // Rule ID 7538 //
     /* 1702490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1702501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1702504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1702507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702536 */     // MIs[0] policy
     /* 1702536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702546 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1702549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702570 */     // GIR_Coverage, 7538,
     /* 1702570 */     GIR_EraseRootFromParent_Done,
     /* 1702571 */   // Label 23317: @1702571
     /* 1702571 */   GIM_Try, /*On fail goto*//*Label 23318*/ GIMT_Encode4(1702657), // Rule ID 7539 //
     /* 1702576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1702587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1702590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1702593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702622 */     // MIs[0] policy
     /* 1702622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702632 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1702635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702656 */     // GIR_Coverage, 7539,
     /* 1702656 */     GIR_EraseRootFromParent_Done,
     /* 1702657 */   // Label 23318: @1702657
     /* 1702657 */   GIM_Try, /*On fail goto*//*Label 23319*/ GIMT_Encode4(1702743), // Rule ID 7542 //
     /* 1702662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1702673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1702676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1702679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702708 */     // MIs[0] policy
     /* 1702708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702718 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1702721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702742 */     // GIR_Coverage, 7542,
     /* 1702742 */     GIR_EraseRootFromParent_Done,
     /* 1702743 */   // Label 23319: @1702743
     /* 1702743 */   GIM_Try, /*On fail goto*//*Label 23320*/ GIMT_Encode4(1702829), // Rule ID 7543 //
     /* 1702748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1702759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1702762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1702765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702794 */     // MIs[0] policy
     /* 1702794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1702807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702828 */     // GIR_Coverage, 7543,
     /* 1702828 */     GIR_EraseRootFromParent_Done,
     /* 1702829 */   // Label 23320: @1702829
     /* 1702829 */   GIM_Try, /*On fail goto*//*Label 23321*/ GIMT_Encode4(1702915), // Rule ID 7546 //
     /* 1702834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1702845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1702848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1702851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702880 */     // MIs[0] policy
     /* 1702880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702890 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1702893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702914 */     // GIR_Coverage, 7546,
     /* 1702914 */     GIR_EraseRootFromParent_Done,
     /* 1702915 */   // Label 23321: @1702915
     /* 1702915 */   GIM_Try, /*On fail goto*//*Label 23322*/ GIMT_Encode4(1703001), // Rule ID 7547 //
     /* 1702920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1702931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1702934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1702937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702966 */     // MIs[0] policy
     /* 1702966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1702979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703000 */     // GIR_Coverage, 7547,
     /* 1703000 */     GIR_EraseRootFromParent_Done,
     /* 1703001 */   // Label 23322: @1703001
     /* 1703001 */   GIM_Try, /*On fail goto*//*Label 23323*/ GIMT_Encode4(1703087), // Rule ID 7550 //
     /* 1703006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1703017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1703020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1703023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703052 */     // MIs[0] policy
     /* 1703052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703062 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1703065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703086 */     // GIR_Coverage, 7550,
     /* 1703086 */     GIR_EraseRootFromParent_Done,
     /* 1703087 */   // Label 23323: @1703087
     /* 1703087 */   GIM_Try, /*On fail goto*//*Label 23324*/ GIMT_Encode4(1703173), // Rule ID 7551 //
     /* 1703092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1703103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1703106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1703109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703138 */     // MIs[0] policy
     /* 1703138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703148 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1703151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703172 */     // GIR_Coverage, 7551,
     /* 1703172 */     GIR_EraseRootFromParent_Done,
     /* 1703173 */   // Label 23324: @1703173
     /* 1703173 */   GIM_Try, /*On fail goto*//*Label 23325*/ GIMT_Encode4(1703259), // Rule ID 7554 //
     /* 1703178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1703189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1703192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1703195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703224 */     // MIs[0] policy
     /* 1703224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703234 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1703237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703258 */     // GIR_Coverage, 7554,
     /* 1703258 */     GIR_EraseRootFromParent_Done,
     /* 1703259 */   // Label 23325: @1703259
     /* 1703259 */   GIM_Try, /*On fail goto*//*Label 23326*/ GIMT_Encode4(1703345), // Rule ID 7555 //
     /* 1703264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1703275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1703278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1703281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703310 */     // MIs[0] policy
     /* 1703310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703320 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1703323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703344 */     // GIR_Coverage, 7555,
     /* 1703344 */     GIR_EraseRootFromParent_Done,
     /* 1703345 */   // Label 23326: @1703345
     /* 1703345 */   GIM_Try, /*On fail goto*//*Label 23327*/ GIMT_Encode4(1703431), // Rule ID 7558 //
     /* 1703350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1703367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703396 */     // MIs[0] policy
     /* 1703396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703406 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1703409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703430 */     // GIR_Coverage, 7558,
     /* 1703430 */     GIR_EraseRootFromParent_Done,
     /* 1703431 */   // Label 23327: @1703431
     /* 1703431 */   GIM_Try, /*On fail goto*//*Label 23328*/ GIMT_Encode4(1703517), // Rule ID 7559 //
     /* 1703436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1703453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703482 */     // MIs[0] policy
     /* 1703482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1703495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703516 */     // GIR_Coverage, 7559,
     /* 1703516 */     GIR_EraseRootFromParent_Done,
     /* 1703517 */   // Label 23328: @1703517
     /* 1703517 */   GIM_Try, /*On fail goto*//*Label 23329*/ GIMT_Encode4(1703603), // Rule ID 7562 //
     /* 1703522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1703533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1703536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1703539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703568 */     // MIs[0] policy
     /* 1703568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703578 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1703581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703602 */     // GIR_Coverage, 7562,
     /* 1703602 */     GIR_EraseRootFromParent_Done,
     /* 1703603 */   // Label 23329: @1703603
     /* 1703603 */   GIM_Try, /*On fail goto*//*Label 23330*/ GIMT_Encode4(1703689), // Rule ID 7563 //
     /* 1703608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1703619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1703622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1703625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703654 */     // MIs[0] policy
     /* 1703654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1703667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703688 */     // GIR_Coverage, 7563,
     /* 1703688 */     GIR_EraseRootFromParent_Done,
     /* 1703689 */   // Label 23330: @1703689
     /* 1703689 */   GIM_Try, /*On fail goto*//*Label 23331*/ GIMT_Encode4(1703775), // Rule ID 7566 //
     /* 1703694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1703705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1703708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1703711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703740 */     // MIs[0] policy
     /* 1703740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703750 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1703753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703774 */     // GIR_Coverage, 7566,
     /* 1703774 */     GIR_EraseRootFromParent_Done,
     /* 1703775 */   // Label 23331: @1703775
     /* 1703775 */   GIM_Try, /*On fail goto*//*Label 23332*/ GIMT_Encode4(1703861), // Rule ID 7567 //
     /* 1703780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1703791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1703794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1703797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703826 */     // MIs[0] policy
     /* 1703826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1703839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703860 */     // GIR_Coverage, 7567,
     /* 1703860 */     GIR_EraseRootFromParent_Done,
     /* 1703861 */   // Label 23332: @1703861
     /* 1703861 */   GIM_Try, /*On fail goto*//*Label 23333*/ GIMT_Encode4(1703947), // Rule ID 7630 //
     /* 1703866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1703877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1703880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1703883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1703886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703912 */     // MIs[0] policy
     /* 1703912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703922 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1703925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1703943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703946 */     // GIR_Coverage, 7630,
     /* 1703946 */     GIR_EraseRootFromParent_Done,
     /* 1703947 */   // Label 23333: @1703947
     /* 1703947 */   GIM_Try, /*On fail goto*//*Label 23334*/ GIMT_Encode4(1704033), // Rule ID 7631 //
     /* 1703952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1703963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1703966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1703969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1703972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703998 */     // MIs[0] policy
     /* 1703998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704008 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1704011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704032 */     // GIR_Coverage, 7631,
     /* 1704032 */     GIR_EraseRootFromParent_Done,
     /* 1704033 */   // Label 23334: @1704033
     /* 1704033 */   GIM_Try, /*On fail goto*//*Label 23335*/ GIMT_Encode4(1704119), // Rule ID 7634 //
     /* 1704038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1704049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1704052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1704055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1704058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704084 */     // MIs[0] policy
     /* 1704084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704094 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1704097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704118 */     // GIR_Coverage, 7634,
     /* 1704118 */     GIR_EraseRootFromParent_Done,
     /* 1704119 */   // Label 23335: @1704119
     /* 1704119 */   GIM_Try, /*On fail goto*//*Label 23336*/ GIMT_Encode4(1704205), // Rule ID 7635 //
     /* 1704124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1704135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1704138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1704141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1704144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704170 */     // MIs[0] policy
     /* 1704170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704180 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1704183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704204 */     // GIR_Coverage, 7635,
     /* 1704204 */     GIR_EraseRootFromParent_Done,
     /* 1704205 */   // Label 23336: @1704205
     /* 1704205 */   GIM_Try, /*On fail goto*//*Label 23337*/ GIMT_Encode4(1704291), // Rule ID 7638 //
     /* 1704210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1704221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1704224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1704227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1704230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704256 */     // MIs[0] policy
     /* 1704256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704266 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1704269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704290 */     // GIR_Coverage, 7638,
     /* 1704290 */     GIR_EraseRootFromParent_Done,
     /* 1704291 */   // Label 23337: @1704291
     /* 1704291 */   GIM_Try, /*On fail goto*//*Label 23338*/ GIMT_Encode4(1704377), // Rule ID 7639 //
     /* 1704296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1704307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1704310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1704313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1704316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704342 */     // MIs[0] policy
     /* 1704342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704352 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1704355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704376 */     // GIR_Coverage, 7639,
     /* 1704376 */     GIR_EraseRootFromParent_Done,
     /* 1704377 */   // Label 23338: @1704377
     /* 1704377 */   GIM_Try, /*On fail goto*//*Label 23339*/ GIMT_Encode4(1704463), // Rule ID 7642 //
     /* 1704382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1704393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1704396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1704399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1704402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704428 */     // MIs[0] policy
     /* 1704428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704438 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1704441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704462 */     // GIR_Coverage, 7642,
     /* 1704462 */     GIR_EraseRootFromParent_Done,
     /* 1704463 */   // Label 23339: @1704463
     /* 1704463 */   GIM_Try, /*On fail goto*//*Label 23340*/ GIMT_Encode4(1704549), // Rule ID 7643 //
     /* 1704468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1704479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1704482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1704485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1704488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704514 */     // MIs[0] policy
     /* 1704514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1704527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704548 */     // GIR_Coverage, 7643,
     /* 1704548 */     GIR_EraseRootFromParent_Done,
     /* 1704549 */   // Label 23340: @1704549
     /* 1704549 */   GIM_Try, /*On fail goto*//*Label 23341*/ GIMT_Encode4(1704635), // Rule ID 7646 //
     /* 1704554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1704565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1704568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1704571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1704574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1704577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704600 */     // MIs[0] policy
     /* 1704600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704610 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1704613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704634 */     // GIR_Coverage, 7646,
     /* 1704634 */     GIR_EraseRootFromParent_Done,
     /* 1704635 */   // Label 23341: @1704635
     /* 1704635 */   GIM_Try, /*On fail goto*//*Label 23342*/ GIMT_Encode4(1704721), // Rule ID 7647 //
     /* 1704640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1704651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1704654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1704657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1704660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1704663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704686 */     // MIs[0] policy
     /* 1704686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1704699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704720 */     // GIR_Coverage, 7647,
     /* 1704720 */     GIR_EraseRootFromParent_Done,
     /* 1704721 */   // Label 23342: @1704721
     /* 1704721 */   GIM_Try, /*On fail goto*//*Label 23343*/ GIMT_Encode4(1704807), // Rule ID 7650 //
     /* 1704726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1704737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1704740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1704743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1704746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1704749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704772 */     // MIs[0] policy
     /* 1704772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704782 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1704785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704806 */     // GIR_Coverage, 7650,
     /* 1704806 */     GIR_EraseRootFromParent_Done,
     /* 1704807 */   // Label 23343: @1704807
     /* 1704807 */   GIM_Try, /*On fail goto*//*Label 23344*/ GIMT_Encode4(1704893), // Rule ID 7651 //
     /* 1704812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1704823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1704826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1704829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1704832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1704835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704858 */     // MIs[0] policy
     /* 1704858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704868 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1704871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704892 */     // GIR_Coverage, 7651,
     /* 1704892 */     GIR_EraseRootFromParent_Done,
     /* 1704893 */   // Label 23344: @1704893
     /* 1704893 */   GIM_Try, /*On fail goto*//*Label 23345*/ GIMT_Encode4(1704979), // Rule ID 7654 //
     /* 1704898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1704909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1704912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1704915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1704918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704944 */     // MIs[0] policy
     /* 1704944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704954 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1704957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1704975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704978 */     // GIR_Coverage, 7654,
     /* 1704978 */     GIR_EraseRootFromParent_Done,
     /* 1704979 */   // Label 23345: @1704979
     /* 1704979 */   GIM_Try, /*On fail goto*//*Label 23346*/ GIMT_Encode4(1705065), // Rule ID 7655 //
     /* 1704984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1704995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1704998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1705001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1705004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705030 */     // MIs[0] policy
     /* 1705030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705040 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1705043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705064 */     // GIR_Coverage, 7655,
     /* 1705064 */     GIR_EraseRootFromParent_Done,
     /* 1705065 */   // Label 23346: @1705065
     /* 1705065 */   GIM_Try, /*On fail goto*//*Label 23347*/ GIMT_Encode4(1705151), // Rule ID 7658 //
     /* 1705070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1705081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1705084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1705087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1705090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705116 */     // MIs[0] policy
     /* 1705116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1705129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705150 */     // GIR_Coverage, 7658,
     /* 1705150 */     GIR_EraseRootFromParent_Done,
     /* 1705151 */   // Label 23347: @1705151
     /* 1705151 */   GIM_Try, /*On fail goto*//*Label 23348*/ GIMT_Encode4(1705237), // Rule ID 7659 //
     /* 1705156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1705167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1705170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1705173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1705176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705202 */     // MIs[0] policy
     /* 1705202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705212 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1705215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705236 */     // GIR_Coverage, 7659,
     /* 1705236 */     GIR_EraseRootFromParent_Done,
     /* 1705237 */   // Label 23348: @1705237
     /* 1705237 */   GIM_Try, /*On fail goto*//*Label 23349*/ GIMT_Encode4(1705323), // Rule ID 7662 //
     /* 1705242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1705253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1705256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1705259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1705262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705288 */     // MIs[0] policy
     /* 1705288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705298 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1705301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705322 */     // GIR_Coverage, 7662,
     /* 1705322 */     GIR_EraseRootFromParent_Done,
     /* 1705323 */   // Label 23349: @1705323
     /* 1705323 */   GIM_Try, /*On fail goto*//*Label 23350*/ GIMT_Encode4(1705409), // Rule ID 7663 //
     /* 1705328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1705339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1705342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1705345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1705348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705374 */     // MIs[0] policy
     /* 1705374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705384 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1705387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705408 */     // GIR_Coverage, 7663,
     /* 1705408 */     GIR_EraseRootFromParent_Done,
     /* 1705409 */   // Label 23350: @1705409
     /* 1705409 */   GIM_Try, /*On fail goto*//*Label 23351*/ GIMT_Encode4(1705495), // Rule ID 7666 //
     /* 1705414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1705425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1705428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1705431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1705434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705460 */     // MIs[0] policy
     /* 1705460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1705473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705494 */     // GIR_Coverage, 7666,
     /* 1705494 */     GIR_EraseRootFromParent_Done,
     /* 1705495 */   // Label 23351: @1705495
     /* 1705495 */   GIM_Try, /*On fail goto*//*Label 23352*/ GIMT_Encode4(1705581), // Rule ID 7667 //
     /* 1705500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1705511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1705514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1705517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1705520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705546 */     // MIs[0] policy
     /* 1705546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705556 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1705559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705580 */     // GIR_Coverage, 7667,
     /* 1705580 */     GIR_EraseRootFromParent_Done,
     /* 1705581 */   // Label 23352: @1705581
     /* 1705581 */   GIM_Try, /*On fail goto*//*Label 23353*/ GIMT_Encode4(1705667), // Rule ID 7670 //
     /* 1705586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1705597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1705600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1705603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1705606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705632 */     // MIs[0] policy
     /* 1705632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705642 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1705645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705666 */     // GIR_Coverage, 7670,
     /* 1705666 */     GIR_EraseRootFromParent_Done,
     /* 1705667 */   // Label 23353: @1705667
     /* 1705667 */   GIM_Try, /*On fail goto*//*Label 23354*/ GIMT_Encode4(1705753), // Rule ID 7671 //
     /* 1705672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1705683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1705686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1705689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1705692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705718 */     // MIs[0] policy
     /* 1705718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705728 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1705731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705752 */     // GIR_Coverage, 7671,
     /* 1705752 */     GIR_EraseRootFromParent_Done,
     /* 1705753 */   // Label 23354: @1705753
     /* 1705753 */   GIM_Try, /*On fail goto*//*Label 23355*/ GIMT_Encode4(1705839), // Rule ID 7674 //
     /* 1705758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1705761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1705769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1705772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1705775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1705778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705804 */     // MIs[0] policy
     /* 1705804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1705817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1705835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705838 */     // GIR_Coverage, 7674,
     /* 1705838 */     GIR_EraseRootFromParent_Done,
     /* 1705839 */   // Label 23355: @1705839
     /* 1705839 */   GIM_Try, /*On fail goto*//*Label 23356*/ GIMT_Encode4(1705925), // Rule ID 7675 //
     /* 1705844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1705847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1705855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1705858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1705861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1705864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705890 */     // MIs[0] policy
     /* 1705890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705900 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1705903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1705921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705924 */     // GIR_Coverage, 7675,
     /* 1705924 */     GIR_EraseRootFromParent_Done,
     /* 1705925 */   // Label 23356: @1705925
     /* 1705925 */   GIM_Try, /*On fail goto*//*Label 23357*/ GIMT_Encode4(1706011), // Rule ID 7678 //
     /* 1705930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1705933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1705941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1705944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1705947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1705950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705976 */     // MIs[0] policy
     /* 1705976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705986 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1705989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706010 */     // GIR_Coverage, 7678,
     /* 1706010 */     GIR_EraseRootFromParent_Done,
     /* 1706011 */   // Label 23357: @1706011
     /* 1706011 */   GIM_Try, /*On fail goto*//*Label 23358*/ GIMT_Encode4(1706097), // Rule ID 7679 //
     /* 1706016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1706027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1706030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1706033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1706036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706062 */     // MIs[0] policy
     /* 1706062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706072 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1706075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706096 */     // GIR_Coverage, 7679,
     /* 1706096 */     GIR_EraseRootFromParent_Done,
     /* 1706097 */   // Label 23358: @1706097
     /* 1706097 */   GIM_Try, /*On fail goto*//*Label 23359*/ GIMT_Encode4(1706183), // Rule ID 7682 //
     /* 1706102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1706113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1706116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1706119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1706122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706148 */     // MIs[0] policy
     /* 1706148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706158 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1706161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706182 */     // GIR_Coverage, 7682,
     /* 1706182 */     GIR_EraseRootFromParent_Done,
     /* 1706183 */   // Label 23359: @1706183
     /* 1706183 */   GIM_Try, /*On fail goto*//*Label 23360*/ GIMT_Encode4(1706269), // Rule ID 7683 //
     /* 1706188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1706199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1706202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1706205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1706208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706234 */     // MIs[0] policy
     /* 1706234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1706247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706268 */     // GIR_Coverage, 7683,
     /* 1706268 */     GIR_EraseRootFromParent_Done,
     /* 1706269 */   // Label 23360: @1706269
     /* 1706269 */   GIM_Try, /*On fail goto*//*Label 23361*/ GIMT_Encode4(1706355), // Rule ID 7686 //
     /* 1706274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1706285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1706288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1706291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1706294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706320 */     // MIs[0] policy
     /* 1706320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706330 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1706333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706354 */     // GIR_Coverage, 7686,
     /* 1706354 */     GIR_EraseRootFromParent_Done,
     /* 1706355 */   // Label 23361: @1706355
     /* 1706355 */   GIM_Try, /*On fail goto*//*Label 23362*/ GIMT_Encode4(1706441), // Rule ID 7687 //
     /* 1706360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1706371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1706374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1706377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1706380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706406 */     // MIs[0] policy
     /* 1706406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1706419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706440 */     // GIR_Coverage, 7687,
     /* 1706440 */     GIR_EraseRootFromParent_Done,
     /* 1706441 */   // Label 23362: @1706441
     /* 1706441 */   GIM_Try, /*On fail goto*//*Label 23363*/ GIMT_Encode4(1706527), // Rule ID 7690 //
     /* 1706446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1706457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1706460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1706463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706492 */     // MIs[0] policy
     /* 1706492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706502 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1706505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706526 */     // GIR_Coverage, 7690,
     /* 1706526 */     GIR_EraseRootFromParent_Done,
     /* 1706527 */   // Label 23363: @1706527
     /* 1706527 */   GIM_Try, /*On fail goto*//*Label 23364*/ GIMT_Encode4(1706613), // Rule ID 7691 //
     /* 1706532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1706543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1706546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1706549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706578 */     // MIs[0] policy
     /* 1706578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706588 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1706591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706612 */     // GIR_Coverage, 7691,
     /* 1706612 */     GIR_EraseRootFromParent_Done,
     /* 1706613 */   // Label 23364: @1706613
     /* 1706613 */   GIM_Try, /*On fail goto*//*Label 23365*/ GIMT_Encode4(1706699), // Rule ID 7694 //
     /* 1706618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1706629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1706632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1706635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706664 */     // MIs[0] policy
     /* 1706664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706674 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1706677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706698 */     // GIR_Coverage, 7694,
     /* 1706698 */     GIR_EraseRootFromParent_Done,
     /* 1706699 */   // Label 23365: @1706699
     /* 1706699 */   GIM_Try, /*On fail goto*//*Label 23366*/ GIMT_Encode4(1706785), // Rule ID 7695 //
     /* 1706704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1706715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1706718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1706721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706750 */     // MIs[0] policy
     /* 1706750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706760 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1706763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706784 */     // GIR_Coverage, 7695,
     /* 1706784 */     GIR_EraseRootFromParent_Done,
     /* 1706785 */   // Label 23366: @1706785
     /* 1706785 */   GIM_Try, /*On fail goto*//*Label 23367*/ GIMT_Encode4(1706871), // Rule ID 7698 //
     /* 1706790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1706801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1706804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1706807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706836 */     // MIs[0] policy
     /* 1706836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706846 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1706849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706870 */     // GIR_Coverage, 7698,
     /* 1706870 */     GIR_EraseRootFromParent_Done,
     /* 1706871 */   // Label 23367: @1706871
     /* 1706871 */   GIM_Try, /*On fail goto*//*Label 23368*/ GIMT_Encode4(1706957), // Rule ID 7699 //
     /* 1706876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1706887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1706890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1706893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706922 */     // MIs[0] policy
     /* 1706922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706932 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1706935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706956 */     // GIR_Coverage, 7699,
     /* 1706956 */     GIR_EraseRootFromParent_Done,
     /* 1706957 */   // Label 23368: @1706957
     /* 1706957 */   GIM_Try, /*On fail goto*//*Label 23369*/ GIMT_Encode4(1707043), // Rule ID 7702 //
     /* 1706962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1706973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1706976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1706979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707008 */     // MIs[0] policy
     /* 1707008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707018 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1707021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707042 */     // GIR_Coverage, 7702,
     /* 1707042 */     GIR_EraseRootFromParent_Done,
     /* 1707043 */   // Label 23369: @1707043
     /* 1707043 */   GIM_Try, /*On fail goto*//*Label 23370*/ GIMT_Encode4(1707129), // Rule ID 7703 //
     /* 1707048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1707059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1707062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1707065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707094 */     // MIs[0] policy
     /* 1707094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707104 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1707107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707128 */     // GIR_Coverage, 7703,
     /* 1707128 */     GIR_EraseRootFromParent_Done,
     /* 1707129 */   // Label 23370: @1707129
     /* 1707129 */   GIM_Try, /*On fail goto*//*Label 23371*/ GIMT_Encode4(1707215), // Rule ID 7706 //
     /* 1707134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1707145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1707148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1707151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1707157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1707164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707180 */     // MIs[0] policy
     /* 1707180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707190 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1707193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707214 */     // GIR_Coverage, 7706,
     /* 1707214 */     GIR_EraseRootFromParent_Done,
     /* 1707215 */   // Label 23371: @1707215
     /* 1707215 */   GIM_Try, /*On fail goto*//*Label 23372*/ GIMT_Encode4(1707301), // Rule ID 7707 //
     /* 1707220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1707231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1707234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1707237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1707243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1707250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707266 */     // MIs[0] policy
     /* 1707266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707276 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1707279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707300 */     // GIR_Coverage, 7707,
     /* 1707300 */     GIR_EraseRootFromParent_Done,
     /* 1707301 */   // Label 23372: @1707301
     /* 1707301 */   GIM_Try, /*On fail goto*//*Label 23373*/ GIMT_Encode4(1707387), // Rule ID 7710 //
     /* 1707306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1707317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1707320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1707323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1707329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1707336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1707344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707352 */     // MIs[0] policy
     /* 1707352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707362 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1707365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707386 */     // GIR_Coverage, 7710,
     /* 1707386 */     GIR_EraseRootFromParent_Done,
     /* 1707387 */   // Label 23373: @1707387
     /* 1707387 */   GIM_Try, /*On fail goto*//*Label 23374*/ GIMT_Encode4(1707473), // Rule ID 7711 //
     /* 1707392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1707403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1707406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1707409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1707415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1707422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1707430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707438 */     // MIs[0] policy
     /* 1707438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707448 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1707451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707472 */     // GIR_Coverage, 7711,
     /* 1707472 */     GIR_EraseRootFromParent_Done,
     /* 1707473 */   // Label 23374: @1707473
     /* 1707473 */   GIM_Try, /*On fail goto*//*Label 23375*/ GIMT_Encode4(1707559), // Rule ID 7714 //
     /* 1707478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1707489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1707492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1707495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707524 */     // MIs[0] policy
     /* 1707524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707534 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1707537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707558 */     // GIR_Coverage, 7714,
     /* 1707558 */     GIR_EraseRootFromParent_Done,
     /* 1707559 */   // Label 23375: @1707559
     /* 1707559 */   GIM_Try, /*On fail goto*//*Label 23376*/ GIMT_Encode4(1707645), // Rule ID 7715 //
     /* 1707564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1707575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1707578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1707581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707610 */     // MIs[0] policy
     /* 1707610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707620 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1707623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707644 */     // GIR_Coverage, 7715,
     /* 1707644 */     GIR_EraseRootFromParent_Done,
     /* 1707645 */   // Label 23376: @1707645
     /* 1707645 */   GIM_Try, /*On fail goto*//*Label 23377*/ GIMT_Encode4(1707731), // Rule ID 7718 //
     /* 1707650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1707661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1707664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1707667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707696 */     // MIs[0] policy
     /* 1707696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1707709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707730 */     // GIR_Coverage, 7718,
     /* 1707730 */     GIR_EraseRootFromParent_Done,
     /* 1707731 */   // Label 23377: @1707731
     /* 1707731 */   GIM_Try, /*On fail goto*//*Label 23378*/ GIMT_Encode4(1707817), // Rule ID 7719 //
     /* 1707736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1707747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1707750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1707753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707782 */     // MIs[0] policy
     /* 1707782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707792 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1707795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707816 */     // GIR_Coverage, 7719,
     /* 1707816 */     GIR_EraseRootFromParent_Done,
     /* 1707817 */   // Label 23378: @1707817
     /* 1707817 */   GIM_Try, /*On fail goto*//*Label 23379*/ GIMT_Encode4(1707903), // Rule ID 7722 //
     /* 1707822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1707833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1707836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1707839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707868 */     // MIs[0] policy
     /* 1707868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707878 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1707881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707902 */     // GIR_Coverage, 7722,
     /* 1707902 */     GIR_EraseRootFromParent_Done,
     /* 1707903 */   // Label 23379: @1707903
     /* 1707903 */   GIM_Try, /*On fail goto*//*Label 23380*/ GIMT_Encode4(1707989), // Rule ID 7723 //
     /* 1707908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1707919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1707922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1707925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707954 */     // MIs[0] policy
     /* 1707954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707964 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1707967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707988 */     // GIR_Coverage, 7723,
     /* 1707988 */     GIR_EraseRootFromParent_Done,
     /* 1707989 */   // Label 23380: @1707989
     /* 1707989 */   GIM_Try, /*On fail goto*//*Label 23381*/ GIMT_Encode4(1708075), // Rule ID 7726 //
     /* 1707994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1708005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1708008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1708011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708040 */     // MIs[0] policy
     /* 1708040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708050 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1708053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708074 */     // GIR_Coverage, 7726,
     /* 1708074 */     GIR_EraseRootFromParent_Done,
     /* 1708075 */   // Label 23381: @1708075
     /* 1708075 */   GIM_Try, /*On fail goto*//*Label 23382*/ GIMT_Encode4(1708161), // Rule ID 7727 //
     /* 1708080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1708091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1708094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1708097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708126 */     // MIs[0] policy
     /* 1708126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708136 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1708139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708160 */     // GIR_Coverage, 7727,
     /* 1708160 */     GIR_EraseRootFromParent_Done,
     /* 1708161 */   // Label 23382: @1708161
     /* 1708161 */   GIM_Try, /*On fail goto*//*Label 23383*/ GIMT_Encode4(1708247), // Rule ID 7730 //
     /* 1708166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1708177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1708180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1708183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708212 */     // MIs[0] policy
     /* 1708212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708222 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1708225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708246 */     // GIR_Coverage, 7730,
     /* 1708246 */     GIR_EraseRootFromParent_Done,
     /* 1708247 */   // Label 23383: @1708247
     /* 1708247 */   GIM_Try, /*On fail goto*//*Label 23384*/ GIMT_Encode4(1708333), // Rule ID 7731 //
     /* 1708252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1708263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1708266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1708269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708298 */     // MIs[0] policy
     /* 1708298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708308 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1708311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708332 */     // GIR_Coverage, 7731,
     /* 1708332 */     GIR_EraseRootFromParent_Done,
     /* 1708333 */   // Label 23384: @1708333
     /* 1708333 */   GIM_Try, /*On fail goto*//*Label 23385*/ GIMT_Encode4(1708419), // Rule ID 7734 //
     /* 1708338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1708341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1708349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1708352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1708355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708384 */     // MIs[0] policy
     /* 1708384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708394 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1708397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708418 */     // GIR_Coverage, 7734,
     /* 1708418 */     GIR_EraseRootFromParent_Done,
     /* 1708419 */   // Label 23385: @1708419
     /* 1708419 */   GIM_Try, /*On fail goto*//*Label 23386*/ GIMT_Encode4(1708505), // Rule ID 7735 //
     /* 1708424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1708427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1708435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1708438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1708441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708470 */     // MIs[0] policy
     /* 1708470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708480 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1708483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708504 */     // GIR_Coverage, 7735,
     /* 1708504 */     GIR_EraseRootFromParent_Done,
     /* 1708505 */   // Label 23386: @1708505
     /* 1708505 */   GIM_Try, /*On fail goto*//*Label 23387*/ GIMT_Encode4(1708591), // Rule ID 7738 //
     /* 1708510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1708513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1708521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1708524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1708527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708556 */     // MIs[0] policy
     /* 1708556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708566 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1708569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708590 */     // GIR_Coverage, 7738,
     /* 1708590 */     GIR_EraseRootFromParent_Done,
     /* 1708591 */   // Label 23387: @1708591
     /* 1708591 */   GIM_Try, /*On fail goto*//*Label 23388*/ GIMT_Encode4(1708677), // Rule ID 7739 //
     /* 1708596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1708599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1708607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1708610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1708613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708642 */     // MIs[0] policy
     /* 1708642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1708655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708676 */     // GIR_Coverage, 7739,
     /* 1708676 */     GIR_EraseRootFromParent_Done,
     /* 1708677 */   // Label 23388: @1708677
     /* 1708677 */   GIM_Try, /*On fail goto*//*Label 23389*/ GIMT_Encode4(1708763), // Rule ID 7742 //
     /* 1708682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1708685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1708693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1708696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1708699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708728 */     // MIs[0] policy
     /* 1708728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708738 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1708741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708762 */     // GIR_Coverage, 7742,
     /* 1708762 */     GIR_EraseRootFromParent_Done,
     /* 1708763 */   // Label 23389: @1708763
     /* 1708763 */   GIM_Try, /*On fail goto*//*Label 23390*/ GIMT_Encode4(1708849), // Rule ID 7743 //
     /* 1708768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1708771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1708779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1708782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1708785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708814 */     // MIs[0] policy
     /* 1708814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1708827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708848 */     // GIR_Coverage, 7743,
     /* 1708848 */     GIR_EraseRootFromParent_Done,
     /* 1708849 */   // Label 23390: @1708849
     /* 1708849 */   GIM_Try, /*On fail goto*//*Label 23391*/ GIMT_Encode4(1708935), // Rule ID 7746 //
     /* 1708854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1708857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1708865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1708868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1708871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708900 */     // MIs[0] policy
     /* 1708900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708910 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1708913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708934 */     // GIR_Coverage, 7746,
     /* 1708934 */     GIR_EraseRootFromParent_Done,
     /* 1708935 */   // Label 23391: @1708935
     /* 1708935 */   GIM_Try, /*On fail goto*//*Label 23392*/ GIMT_Encode4(1709021), // Rule ID 7747 //
     /* 1708940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1708943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1708951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1708954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1708957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708986 */     // MIs[0] policy
     /* 1708986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708996 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1708999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709020 */     // GIR_Coverage, 7747,
     /* 1709020 */     GIR_EraseRootFromParent_Done,
     /* 1709021 */   // Label 23392: @1709021
     /* 1709021 */   GIM_Try, /*On fail goto*//*Label 23393*/ GIMT_Encode4(1709107), // Rule ID 10262 //
     /* 1709026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1709037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1709040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1709043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1709046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709072 */     // MIs[0] policy
     /* 1709072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709082 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1709085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709106 */     // GIR_Coverage, 10262,
     /* 1709106 */     GIR_EraseRootFromParent_Done,
     /* 1709107 */   // Label 23393: @1709107
     /* 1709107 */   GIM_Try, /*On fail goto*//*Label 23394*/ GIMT_Encode4(1709193), // Rule ID 10263 //
     /* 1709112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1709123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1709126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1709129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1709132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709158 */     // MIs[0] policy
     /* 1709158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709168 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1709171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709192 */     // GIR_Coverage, 10263,
     /* 1709192 */     GIR_EraseRootFromParent_Done,
     /* 1709193 */   // Label 23394: @1709193
     /* 1709193 */   GIM_Try, /*On fail goto*//*Label 23395*/ GIMT_Encode4(1709279), // Rule ID 10266 //
     /* 1709198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1709209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1709212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1709215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1709218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709244 */     // MIs[0] policy
     /* 1709244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709254 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1709257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709278 */     // GIR_Coverage, 10266,
     /* 1709278 */     GIR_EraseRootFromParent_Done,
     /* 1709279 */   // Label 23395: @1709279
     /* 1709279 */   GIM_Try, /*On fail goto*//*Label 23396*/ GIMT_Encode4(1709365), // Rule ID 10267 //
     /* 1709284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1709295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1709298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1709301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1709304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709330 */     // MIs[0] policy
     /* 1709330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709340 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1709343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709364 */     // GIR_Coverage, 10267,
     /* 1709364 */     GIR_EraseRootFromParent_Done,
     /* 1709365 */   // Label 23396: @1709365
     /* 1709365 */   GIM_Try, /*On fail goto*//*Label 23397*/ GIMT_Encode4(1709451), // Rule ID 10270 //
     /* 1709370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1709381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1709384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1709387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1709390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709416 */     // MIs[0] policy
     /* 1709416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709426 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709450 */     // GIR_Coverage, 10270,
     /* 1709450 */     GIR_EraseRootFromParent_Done,
     /* 1709451 */   // Label 23397: @1709451
     /* 1709451 */   GIM_Try, /*On fail goto*//*Label 23398*/ GIMT_Encode4(1709537), // Rule ID 10271 //
     /* 1709456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1709467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1709470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1709473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1709476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709502 */     // MIs[0] policy
     /* 1709502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709512 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709536 */     // GIR_Coverage, 10271,
     /* 1709536 */     GIR_EraseRootFromParent_Done,
     /* 1709537 */   // Label 23398: @1709537
     /* 1709537 */   GIM_Try, /*On fail goto*//*Label 23399*/ GIMT_Encode4(1709623), // Rule ID 10274 //
     /* 1709542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1709553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1709556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1709559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1709562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709588 */     // MIs[0] policy
     /* 1709588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709598 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1709601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709622 */     // GIR_Coverage, 10274,
     /* 1709622 */     GIR_EraseRootFromParent_Done,
     /* 1709623 */   // Label 23399: @1709623
     /* 1709623 */   GIM_Try, /*On fail goto*//*Label 23400*/ GIMT_Encode4(1709709), // Rule ID 10275 //
     /* 1709628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1709639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1709642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1709645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1709648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709674 */     // MIs[0] policy
     /* 1709674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709684 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1709687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709708 */     // GIR_Coverage, 10275,
     /* 1709708 */     GIR_EraseRootFromParent_Done,
     /* 1709709 */   // Label 23400: @1709709
     /* 1709709 */   GIM_Try, /*On fail goto*//*Label 23401*/ GIMT_Encode4(1709795), // Rule ID 10278 //
     /* 1709714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1709725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1709728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1709731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1709734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709760 */     // MIs[0] policy
     /* 1709760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709770 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709794 */     // GIR_Coverage, 10278,
     /* 1709794 */     GIR_EraseRootFromParent_Done,
     /* 1709795 */   // Label 23401: @1709795
     /* 1709795 */   GIM_Try, /*On fail goto*//*Label 23402*/ GIMT_Encode4(1709881), // Rule ID 10279 //
     /* 1709800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1709811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1709814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1709817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1709820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709846 */     // MIs[0] policy
     /* 1709846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709856 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709880 */     // GIR_Coverage, 10279,
     /* 1709880 */     GIR_EraseRootFromParent_Done,
     /* 1709881 */   // Label 23402: @1709881
     /* 1709881 */   GIM_Try, /*On fail goto*//*Label 23403*/ GIMT_Encode4(1709967), // Rule ID 10282 //
     /* 1709886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1709897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1709900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1709903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1709906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709932 */     // MIs[0] policy
     /* 1709932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709942 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709966 */     // GIR_Coverage, 10282,
     /* 1709966 */     GIR_EraseRootFromParent_Done,
     /* 1709967 */   // Label 23403: @1709967
     /* 1709967 */   GIM_Try, /*On fail goto*//*Label 23404*/ GIMT_Encode4(1710053), // Rule ID 10283 //
     /* 1709972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1709983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1709986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1709989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1709992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710018 */     // MIs[0] policy
     /* 1710018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710028 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1710031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710052 */     // GIR_Coverage, 10283,
     /* 1710052 */     GIR_EraseRootFromParent_Done,
     /* 1710053 */   // Label 23404: @1710053
     /* 1710053 */   GIM_Try, /*On fail goto*//*Label 23405*/ GIMT_Encode4(1710139), // Rule ID 10286 //
     /* 1710058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1710069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1710072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1710075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1710078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710104 */     // MIs[0] policy
     /* 1710104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710114 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710138 */     // GIR_Coverage, 10286,
     /* 1710138 */     GIR_EraseRootFromParent_Done,
     /* 1710139 */   // Label 23405: @1710139
     /* 1710139 */   GIM_Try, /*On fail goto*//*Label 23406*/ GIMT_Encode4(1710225), // Rule ID 10287 //
     /* 1710144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1710155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1710158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1710161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1710164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710190 */     // MIs[0] policy
     /* 1710190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710200 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710224 */     // GIR_Coverage, 10287,
     /* 1710224 */     GIR_EraseRootFromParent_Done,
     /* 1710225 */   // Label 23406: @1710225
     /* 1710225 */   GIM_Try, /*On fail goto*//*Label 23407*/ GIMT_Encode4(1710311), // Rule ID 10290 //
     /* 1710230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1710241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1710244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1710247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1710250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710276 */     // MIs[0] policy
     /* 1710276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710286 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710310 */     // GIR_Coverage, 10290,
     /* 1710310 */     GIR_EraseRootFromParent_Done,
     /* 1710311 */   // Label 23407: @1710311
     /* 1710311 */   GIM_Try, /*On fail goto*//*Label 23408*/ GIMT_Encode4(1710397), // Rule ID 10291 //
     /* 1710316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1710327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1710330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1710333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1710336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710362 */     // MIs[0] policy
     /* 1710362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710372 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710396 */     // GIR_Coverage, 10291,
     /* 1710396 */     GIR_EraseRootFromParent_Done,
     /* 1710397 */   // Label 23408: @1710397
     /* 1710397 */   GIM_Try, /*On fail goto*//*Label 23409*/ GIMT_Encode4(1710483), // Rule ID 10294 //
     /* 1710402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1710413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1710416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1710419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1710422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710448 */     // MIs[0] policy
     /* 1710448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710458 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710482 */     // GIR_Coverage, 10294,
     /* 1710482 */     GIR_EraseRootFromParent_Done,
     /* 1710483 */   // Label 23409: @1710483
     /* 1710483 */   GIM_Try, /*On fail goto*//*Label 23410*/ GIMT_Encode4(1710569), // Rule ID 10295 //
     /* 1710488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1710499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1710502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1710505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1710508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710534 */     // MIs[0] policy
     /* 1710534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710544 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710568 */     // GIR_Coverage, 10295,
     /* 1710568 */     GIR_EraseRootFromParent_Done,
     /* 1710569 */   // Label 23410: @1710569
     /* 1710569 */   GIM_Try, /*On fail goto*//*Label 23411*/ GIMT_Encode4(1710655), // Rule ID 10298 //
     /* 1710574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1710577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1710585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1710588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1710591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1710594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710620 */     // MIs[0] policy
     /* 1710620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710630 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1710651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710654 */     // GIR_Coverage, 10298,
     /* 1710654 */     GIR_EraseRootFromParent_Done,
     /* 1710655 */   // Label 23411: @1710655
     /* 1710655 */   GIM_Try, /*On fail goto*//*Label 23412*/ GIMT_Encode4(1710741), // Rule ID 10299 //
     /* 1710660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1710663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1710671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1710674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1710677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1710680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710706 */     // MIs[0] policy
     /* 1710706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710716 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1710737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710740 */     // GIR_Coverage, 10299,
     /* 1710740 */     GIR_EraseRootFromParent_Done,
     /* 1710741 */   // Label 23412: @1710741
     /* 1710741 */   GIM_Try, /*On fail goto*//*Label 23413*/ GIMT_Encode4(1710827), // Rule ID 10302 //
     /* 1710746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1710757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1710760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1710763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1710766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1710769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1710776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710792 */     // MIs[0] policy
     /* 1710792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710802 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1710805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710826 */     // GIR_Coverage, 10302,
     /* 1710826 */     GIR_EraseRootFromParent_Done,
     /* 1710827 */   // Label 23413: @1710827
     /* 1710827 */   GIM_Try, /*On fail goto*//*Label 23414*/ GIMT_Encode4(1710913), // Rule ID 10303 //
     /* 1710832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1710843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1710846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1710849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1710852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1710855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1710862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710878 */     // MIs[0] policy
     /* 1710878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710888 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1710891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710912 */     // GIR_Coverage, 10303,
     /* 1710912 */     GIR_EraseRootFromParent_Done,
     /* 1710913 */   // Label 23414: @1710913
     /* 1710913 */   GIM_Try, /*On fail goto*//*Label 23415*/ GIMT_Encode4(1710999), // Rule ID 10306 //
     /* 1710918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1710929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1710932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1710935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1710938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1710941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1710948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710964 */     // MIs[0] policy
     /* 1710964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710974 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1710977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710998 */     // GIR_Coverage, 10306,
     /* 1710998 */     GIR_EraseRootFromParent_Done,
     /* 1710999 */   // Label 23415: @1710999
     /* 1710999 */   GIM_Try, /*On fail goto*//*Label 23416*/ GIMT_Encode4(1711085), // Rule ID 10307 //
     /* 1711004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1711015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1711018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1711021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1711024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711050 */     // MIs[0] policy
     /* 1711050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711060 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1711063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711084 */     // GIR_Coverage, 10307,
     /* 1711084 */     GIR_EraseRootFromParent_Done,
     /* 1711085 */   // Label 23416: @1711085
     /* 1711085 */   GIM_Try, /*On fail goto*//*Label 23417*/ GIMT_Encode4(1711171), // Rule ID 10310 //
     /* 1711090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1711101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1711104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1711107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1711110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1711113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711136 */     // MIs[0] policy
     /* 1711136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711146 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1711149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711170 */     // GIR_Coverage, 10310,
     /* 1711170 */     GIR_EraseRootFromParent_Done,
     /* 1711171 */   // Label 23417: @1711171
     /* 1711171 */   GIM_Try, /*On fail goto*//*Label 23418*/ GIMT_Encode4(1711257), // Rule ID 10311 //
     /* 1711176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1711187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1711190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1711193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1711196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1711199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711222 */     // MIs[0] policy
     /* 1711222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711232 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1711235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711256 */     // GIR_Coverage, 10311,
     /* 1711256 */     GIR_EraseRootFromParent_Done,
     /* 1711257 */   // Label 23418: @1711257
     /* 1711257 */   GIM_Try, /*On fail goto*//*Label 23419*/ GIMT_Encode4(1711343), // Rule ID 10314 //
     /* 1711262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1711273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1711276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1711279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1711282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711308 */     // MIs[0] policy
     /* 1711308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711342 */     // GIR_Coverage, 10314,
     /* 1711342 */     GIR_EraseRootFromParent_Done,
     /* 1711343 */   // Label 23419: @1711343
     /* 1711343 */   GIM_Try, /*On fail goto*//*Label 23420*/ GIMT_Encode4(1711429), // Rule ID 10315 //
     /* 1711348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1711359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1711362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1711365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1711368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711394 */     // MIs[0] policy
     /* 1711394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711428 */     // GIR_Coverage, 10315,
     /* 1711428 */     GIR_EraseRootFromParent_Done,
     /* 1711429 */   // Label 23420: @1711429
     /* 1711429 */   GIM_Try, /*On fail goto*//*Label 23421*/ GIMT_Encode4(1711515), // Rule ID 10318 //
     /* 1711434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1711445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1711448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1711451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1711454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711480 */     // MIs[0] policy
     /* 1711480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711490 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1711493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711514 */     // GIR_Coverage, 10318,
     /* 1711514 */     GIR_EraseRootFromParent_Done,
     /* 1711515 */   // Label 23421: @1711515
     /* 1711515 */   GIM_Try, /*On fail goto*//*Label 23422*/ GIMT_Encode4(1711601), // Rule ID 10319 //
     /* 1711520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1711531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1711534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1711537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1711540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711566 */     // MIs[0] policy
     /* 1711566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711576 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1711579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711600 */     // GIR_Coverage, 10319,
     /* 1711600 */     GIR_EraseRootFromParent_Done,
     /* 1711601 */   // Label 23422: @1711601
     /* 1711601 */   GIM_Try, /*On fail goto*//*Label 23423*/ GIMT_Encode4(1711687), // Rule ID 10322 //
     /* 1711606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1711617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1711620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1711623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1711626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711652 */     // MIs[0] policy
     /* 1711652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711662 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1711665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711686 */     // GIR_Coverage, 10322,
     /* 1711686 */     GIR_EraseRootFromParent_Done,
     /* 1711687 */   // Label 23423: @1711687
     /* 1711687 */   GIM_Try, /*On fail goto*//*Label 23424*/ GIMT_Encode4(1711773), // Rule ID 10323 //
     /* 1711692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1711703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1711706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1711709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1711712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711738 */     // MIs[0] policy
     /* 1711738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711748 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1711751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711772 */     // GIR_Coverage, 10323,
     /* 1711772 */     GIR_EraseRootFromParent_Done,
     /* 1711773 */   // Label 23424: @1711773
     /* 1711773 */   GIM_Try, /*On fail goto*//*Label 23425*/ GIMT_Encode4(1711859), // Rule ID 10326 //
     /* 1711778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1711789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1711792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1711795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1711798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711824 */     // MIs[0] policy
     /* 1711824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711858 */     // GIR_Coverage, 10326,
     /* 1711858 */     GIR_EraseRootFromParent_Done,
     /* 1711859 */   // Label 23425: @1711859
     /* 1711859 */   GIM_Try, /*On fail goto*//*Label 23426*/ GIMT_Encode4(1711945), // Rule ID 10327 //
     /* 1711864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1711875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1711878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1711881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1711884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711910 */     // MIs[0] policy
     /* 1711910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711944 */     // GIR_Coverage, 10327,
     /* 1711944 */     GIR_EraseRootFromParent_Done,
     /* 1711945 */   // Label 23426: @1711945
     /* 1711945 */   GIM_Try, /*On fail goto*//*Label 23427*/ GIMT_Encode4(1712031), // Rule ID 10330 //
     /* 1711950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1711961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1711964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1711967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1711970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711996 */     // MIs[0] policy
     /* 1711996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712006 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712030 */     // GIR_Coverage, 10330,
     /* 1712030 */     GIR_EraseRootFromParent_Done,
     /* 1712031 */   // Label 23427: @1712031
     /* 1712031 */   GIM_Try, /*On fail goto*//*Label 23428*/ GIMT_Encode4(1712117), // Rule ID 10331 //
     /* 1712036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1712047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1712050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1712053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1712056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712082 */     // MIs[0] policy
     /* 1712082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712092 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712116 */     // GIR_Coverage, 10331,
     /* 1712116 */     GIR_EraseRootFromParent_Done,
     /* 1712117 */   // Label 23428: @1712117
     /* 1712117 */   GIM_Try, /*On fail goto*//*Label 23429*/ GIMT_Encode4(1712203), // Rule ID 10334 //
     /* 1712122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1712133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1712136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1712139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1712142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712168 */     // MIs[0] policy
     /* 1712168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712178 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712202 */     // GIR_Coverage, 10334,
     /* 1712202 */     GIR_EraseRootFromParent_Done,
     /* 1712203 */   // Label 23429: @1712203
     /* 1712203 */   GIM_Try, /*On fail goto*//*Label 23430*/ GIMT_Encode4(1712289), // Rule ID 10335 //
     /* 1712208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1712219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1712222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1712225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1712228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712254 */     // MIs[0] policy
     /* 1712254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712264 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712288 */     // GIR_Coverage, 10335,
     /* 1712288 */     GIR_EraseRootFromParent_Done,
     /* 1712289 */   // Label 23430: @1712289
     /* 1712289 */   GIM_Try, /*On fail goto*//*Label 23431*/ GIMT_Encode4(1712375), // Rule ID 10338 //
     /* 1712294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1712297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1712305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1712308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1712311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1712314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712340 */     // MIs[0] policy
     /* 1712340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712350 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1712353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712374 */     // GIR_Coverage, 10338,
     /* 1712374 */     GIR_EraseRootFromParent_Done,
     /* 1712375 */   // Label 23431: @1712375
     /* 1712375 */   GIM_Try, /*On fail goto*//*Label 23432*/ GIMT_Encode4(1712461), // Rule ID 10339 //
     /* 1712380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1712383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1712391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1712394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1712397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1712400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712426 */     // MIs[0] policy
     /* 1712426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712436 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1712439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712460 */     // GIR_Coverage, 10339,
     /* 1712460 */     GIR_EraseRootFromParent_Done,
     /* 1712461 */   // Label 23432: @1712461
     /* 1712461 */   GIM_Try, /*On fail goto*//*Label 23433*/ GIMT_Encode4(1712547), // Rule ID 10342 //
     /* 1712466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1712469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1712477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1712480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1712483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1712486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712512 */     // MIs[0] policy
     /* 1712512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712522 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712546 */     // GIR_Coverage, 10342,
     /* 1712546 */     GIR_EraseRootFromParent_Done,
     /* 1712547 */   // Label 23433: @1712547
     /* 1712547 */   GIM_Try, /*On fail goto*//*Label 23434*/ GIMT_Encode4(1712633), // Rule ID 10343 //
     /* 1712552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1712555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1712563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1712566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1712569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1712572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712598 */     // MIs[0] policy
     /* 1712598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712608 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712632 */     // GIR_Coverage, 10343,
     /* 1712632 */     GIR_EraseRootFromParent_Done,
     /* 1712633 */   // Label 23434: @1712633
     /* 1712633 */   GIM_Try, /*On fail goto*//*Label 23435*/ GIMT_Encode4(1712719), // Rule ID 10346 //
     /* 1712638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1712641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1712649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1712652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1712655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1712658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712684 */     // MIs[0] policy
     /* 1712684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712718 */     // GIR_Coverage, 10346,
     /* 1712718 */     GIR_EraseRootFromParent_Done,
     /* 1712719 */   // Label 23435: @1712719
     /* 1712719 */   GIM_Try, /*On fail goto*//*Label 23436*/ GIMT_Encode4(1712805), // Rule ID 10347 //
     /* 1712724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1712727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1712735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1712738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1712741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1712744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712770 */     // MIs[0] policy
     /* 1712770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712780 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712804 */     // GIR_Coverage, 10347,
     /* 1712804 */     GIR_EraseRootFromParent_Done,
     /* 1712805 */   // Label 23436: @1712805
     /* 1712805 */   GIM_Try, /*On fail goto*//*Label 23437*/ GIMT_Encode4(1712891), // Rule ID 10350 //
     /* 1712810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1712821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1712824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1712827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1712833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712856 */     // MIs[0] policy
     /* 1712856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712866 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1712869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712890 */     // GIR_Coverage, 10350,
     /* 1712890 */     GIR_EraseRootFromParent_Done,
     /* 1712891 */   // Label 23437: @1712891
     /* 1712891 */   GIM_Try, /*On fail goto*//*Label 23438*/ GIMT_Encode4(1712977), // Rule ID 10351 //
     /* 1712896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1712907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1712910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1712913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1712919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712942 */     // MIs[0] policy
     /* 1712942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712952 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1712955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712976 */     // GIR_Coverage, 10351,
     /* 1712976 */     GIR_EraseRootFromParent_Done,
     /* 1712977 */   // Label 23438: @1712977
     /* 1712977 */   GIM_Try, /*On fail goto*//*Label 23439*/ GIMT_Encode4(1713063), // Rule ID 10354 //
     /* 1712982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1712993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1712996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1712999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713028 */     // MIs[0] policy
     /* 1713028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713038 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713062 */     // GIR_Coverage, 10354,
     /* 1713062 */     GIR_EraseRootFromParent_Done,
     /* 1713063 */   // Label 23439: @1713063
     /* 1713063 */   GIM_Try, /*On fail goto*//*Label 23440*/ GIMT_Encode4(1713149), // Rule ID 10355 //
     /* 1713068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1713079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1713082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1713085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713114 */     // MIs[0] policy
     /* 1713114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713124 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713148 */     // GIR_Coverage, 10355,
     /* 1713148 */     GIR_EraseRootFromParent_Done,
     /* 1713149 */   // Label 23440: @1713149
     /* 1713149 */   GIM_Try, /*On fail goto*//*Label 23441*/ GIMT_Encode4(1713235), // Rule ID 10358 //
     /* 1713154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1713165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1713168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1713171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713200 */     // MIs[0] policy
     /* 1713200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713210 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713234 */     // GIR_Coverage, 10358,
     /* 1713234 */     GIR_EraseRootFromParent_Done,
     /* 1713235 */   // Label 23441: @1713235
     /* 1713235 */   GIM_Try, /*On fail goto*//*Label 23442*/ GIMT_Encode4(1713321), // Rule ID 10359 //
     /* 1713240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1713251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1713254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1713257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713286 */     // MIs[0] policy
     /* 1713286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713296 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713320 */     // GIR_Coverage, 10359,
     /* 1713320 */     GIR_EraseRootFromParent_Done,
     /* 1713321 */   // Label 23442: @1713321
     /* 1713321 */   GIM_Try, /*On fail goto*//*Label 23443*/ GIMT_Encode4(1713407), // Rule ID 10362 //
     /* 1713326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1713337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1713340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1713343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713372 */     // MIs[0] policy
     /* 1713372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713382 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713406 */     // GIR_Coverage, 10362,
     /* 1713406 */     GIR_EraseRootFromParent_Done,
     /* 1713407 */   // Label 23443: @1713407
     /* 1713407 */   GIM_Try, /*On fail goto*//*Label 23444*/ GIMT_Encode4(1713493), // Rule ID 10363 //
     /* 1713412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1713423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1713426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1713429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713458 */     // MIs[0] policy
     /* 1713458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713468 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713492 */     // GIR_Coverage, 10363,
     /* 1713492 */     GIR_EraseRootFromParent_Done,
     /* 1713493 */   // Label 23444: @1713493
     /* 1713493 */   GIM_Try, /*On fail goto*//*Label 23445*/ GIMT_Encode4(1713579), // Rule ID 10366 //
     /* 1713498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1713509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1713512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1713515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713544 */     // MIs[0] policy
     /* 1713544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713554 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713578 */     // GIR_Coverage, 10366,
     /* 1713578 */     GIR_EraseRootFromParent_Done,
     /* 1713579 */   // Label 23445: @1713579
     /* 1713579 */   GIM_Try, /*On fail goto*//*Label 23446*/ GIMT_Encode4(1713665), // Rule ID 10367 //
     /* 1713584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1713595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1713598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1713601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713630 */     // MIs[0] policy
     /* 1713630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713640 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713664 */     // GIR_Coverage, 10367,
     /* 1713664 */     GIR_EraseRootFromParent_Done,
     /* 1713665 */   // Label 23446: @1713665
     /* 1713665 */   GIM_Try, /*On fail goto*//*Label 23447*/ GIMT_Encode4(1713751), // Rule ID 10370 //
     /* 1713670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1713681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1713684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1713687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713716 */     // MIs[0] policy
     /* 1713716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713726 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713750 */     // GIR_Coverage, 10370,
     /* 1713750 */     GIR_EraseRootFromParent_Done,
     /* 1713751 */   // Label 23447: @1713751
     /* 1713751 */   GIM_Try, /*On fail goto*//*Label 23448*/ GIMT_Encode4(1713837), // Rule ID 10371 //
     /* 1713756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1713767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1713770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1713773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713802 */     // MIs[0] policy
     /* 1713802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713812 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713836 */     // GIR_Coverage, 10371,
     /* 1713836 */     GIR_EraseRootFromParent_Done,
     /* 1713837 */   // Label 23448: @1713837
     /* 1713837 */   GIM_Try, /*On fail goto*//*Label 23449*/ GIMT_Encode4(1713923), // Rule ID 10374 //
     /* 1713842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1713853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1713856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1713859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713888 */     // MIs[0] policy
     /* 1713888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713898 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1713901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713922 */     // GIR_Coverage, 10374,
     /* 1713922 */     GIR_EraseRootFromParent_Done,
     /* 1713923 */   // Label 23449: @1713923
     /* 1713923 */   GIM_Try, /*On fail goto*//*Label 23450*/ GIMT_Encode4(1714009), // Rule ID 10375 //
     /* 1713928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1713939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1713942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1713945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713974 */     // MIs[0] policy
     /* 1713974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713984 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1713987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714008 */     // GIR_Coverage, 10375,
     /* 1714008 */     GIR_EraseRootFromParent_Done,
     /* 1714009 */   // Label 23450: @1714009
     /* 1714009 */   GIM_Try, /*On fail goto*//*Label 23451*/ GIMT_Encode4(1714095), // Rule ID 10378 //
     /* 1714014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1714025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1714028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1714031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714060 */     // MIs[0] policy
     /* 1714060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714070 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714094 */     // GIR_Coverage, 10378,
     /* 1714094 */     GIR_EraseRootFromParent_Done,
     /* 1714095 */   // Label 23451: @1714095
     /* 1714095 */   GIM_Try, /*On fail goto*//*Label 23452*/ GIMT_Encode4(1714181), // Rule ID 10379 //
     /* 1714100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1714111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1714114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1714117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714146 */     // MIs[0] policy
     /* 1714146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714180 */     // GIR_Coverage, 10379,
     /* 1714180 */     GIR_EraseRootFromParent_Done,
     /* 1714181 */   // Label 23452: @1714181
     /* 1714181 */   GIM_Try, /*On fail goto*//*Label 23453*/ GIMT_Encode4(1714267), // Rule ID 10382 //
     /* 1714186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1714197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1714200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1714203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714232 */     // MIs[0] policy
     /* 1714232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714242 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714266 */     // GIR_Coverage, 10382,
     /* 1714266 */     GIR_EraseRootFromParent_Done,
     /* 1714267 */   // Label 23453: @1714267
     /* 1714267 */   GIM_Try, /*On fail goto*//*Label 23454*/ GIMT_Encode4(1714353), // Rule ID 10383 //
     /* 1714272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1714283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1714286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1714289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714318 */     // MIs[0] policy
     /* 1714318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714328 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714352 */     // GIR_Coverage, 10383,
     /* 1714352 */     GIR_EraseRootFromParent_Done,
     /* 1714353 */   // Label 23454: @1714353
     /* 1714353 */   GIM_Try, /*On fail goto*//*Label 23455*/ GIMT_Encode4(1714439), // Rule ID 10386 //
     /* 1714358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1714361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1714369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1714372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1714375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714404 */     // MIs[0] policy
     /* 1714404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714438 */     // GIR_Coverage, 10386,
     /* 1714438 */     GIR_EraseRootFromParent_Done,
     /* 1714439 */   // Label 23455: @1714439
     /* 1714439 */   GIM_Try, /*On fail goto*//*Label 23456*/ GIMT_Encode4(1714525), // Rule ID 10387 //
     /* 1714444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1714447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1714455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1714458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1714461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714490 */     // MIs[0] policy
     /* 1714490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714500 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714524 */     // GIR_Coverage, 10387,
     /* 1714524 */     GIR_EraseRootFromParent_Done,
     /* 1714525 */   // Label 23456: @1714525
     /* 1714525 */   GIM_Try, /*On fail goto*//*Label 23457*/ GIMT_Encode4(1714611), // Rule ID 10390 //
     /* 1714530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1714541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1714544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1714547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1714553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1714560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714576 */     // MIs[0] policy
     /* 1714576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714586 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1714589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714610 */     // GIR_Coverage, 10390,
     /* 1714610 */     GIR_EraseRootFromParent_Done,
     /* 1714611 */   // Label 23457: @1714611
     /* 1714611 */   GIM_Try, /*On fail goto*//*Label 23458*/ GIMT_Encode4(1714697), // Rule ID 10391 //
     /* 1714616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1714627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1714630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1714633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1714639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1714646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714662 */     // MIs[0] policy
     /* 1714662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714672 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1714675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714696 */     // GIR_Coverage, 10391,
     /* 1714696 */     GIR_EraseRootFromParent_Done,
     /* 1714697 */   // Label 23458: @1714697
     /* 1714697 */   GIM_Try, /*On fail goto*//*Label 23459*/ GIMT_Encode4(1714783), // Rule ID 10394 //
     /* 1714702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1714713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1714716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1714719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1714725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1714732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714748 */     // MIs[0] policy
     /* 1714748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714758 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1714761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714782 */     // GIR_Coverage, 10394,
     /* 1714782 */     GIR_EraseRootFromParent_Done,
     /* 1714783 */   // Label 23459: @1714783
     /* 1714783 */   GIM_Try, /*On fail goto*//*Label 23460*/ GIMT_Encode4(1714869), // Rule ID 10395 //
     /* 1714788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1714799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1714802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1714805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1714811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1714818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714834 */     // MIs[0] policy
     /* 1714834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714844 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1714847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714868 */     // GIR_Coverage, 10395,
     /* 1714868 */     GIR_EraseRootFromParent_Done,
     /* 1714869 */   // Label 23460: @1714869
     /* 1714869 */   GIM_Try, /*On fail goto*//*Label 23461*/ GIMT_Encode4(1714955), // Rule ID 10398 //
     /* 1714874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1714885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1714888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1714891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1714897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1714904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714920 */     // MIs[0] policy
     /* 1714920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714930 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1714933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714954 */     // GIR_Coverage, 10398,
     /* 1714954 */     GIR_EraseRootFromParent_Done,
     /* 1714955 */   // Label 23461: @1714955
     /* 1714955 */   GIM_Try, /*On fail goto*//*Label 23462*/ GIMT_Encode4(1715041), // Rule ID 10399 //
     /* 1714960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1714971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1714974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1714977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1714983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1714990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715006 */     // MIs[0] policy
     /* 1715006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715016 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715040 */     // GIR_Coverage, 10399,
     /* 1715040 */     GIR_EraseRootFromParent_Done,
     /* 1715041 */   // Label 23462: @1715041
     /* 1715041 */   GIM_Try, /*On fail goto*//*Label 23463*/ GIMT_Encode4(1715127), // Rule ID 10402 //
     /* 1715046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1715057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1715060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1715063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715092 */     // MIs[0] policy
     /* 1715092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715102 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715126 */     // GIR_Coverage, 10402,
     /* 1715126 */     GIR_EraseRootFromParent_Done,
     /* 1715127 */   // Label 23463: @1715127
     /* 1715127 */   GIM_Try, /*On fail goto*//*Label 23464*/ GIMT_Encode4(1715213), // Rule ID 10403 //
     /* 1715132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1715143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1715146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1715149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715178 */     // MIs[0] policy
     /* 1715178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715212 */     // GIR_Coverage, 10403,
     /* 1715212 */     GIR_EraseRootFromParent_Done,
     /* 1715213 */   // Label 23464: @1715213
     /* 1715213 */   GIM_Try, /*On fail goto*//*Label 23465*/ GIMT_Encode4(1715299), // Rule ID 10406 //
     /* 1715218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1715229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1715232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1715235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715264 */     // MIs[0] policy
     /* 1715264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715274 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715298 */     // GIR_Coverage, 10406,
     /* 1715298 */     GIR_EraseRootFromParent_Done,
     /* 1715299 */   // Label 23465: @1715299
     /* 1715299 */   GIM_Try, /*On fail goto*//*Label 23466*/ GIMT_Encode4(1715385), // Rule ID 10407 //
     /* 1715304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1715315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1715318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1715321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715350 */     // MIs[0] policy
     /* 1715350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715360 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715384 */     // GIR_Coverage, 10407,
     /* 1715384 */     GIR_EraseRootFromParent_Done,
     /* 1715385 */   // Label 23466: @1715385
     /* 1715385 */   GIM_Try, /*On fail goto*//*Label 23467*/ GIMT_Encode4(1715471), // Rule ID 10410 //
     /* 1715390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1715401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1715404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1715407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715436 */     // MIs[0] policy
     /* 1715436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715470 */     // GIR_Coverage, 10410,
     /* 1715470 */     GIR_EraseRootFromParent_Done,
     /* 1715471 */   // Label 23467: @1715471
     /* 1715471 */   GIM_Try, /*On fail goto*//*Label 23468*/ GIMT_Encode4(1715557), // Rule ID 10411 //
     /* 1715476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1715487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1715490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1715493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715522 */     // MIs[0] policy
     /* 1715522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715532 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715556 */     // GIR_Coverage, 10411,
     /* 1715556 */     GIR_EraseRootFromParent_Done,
     /* 1715557 */   // Label 23468: @1715557
     /* 1715557 */   GIM_Try, /*On fail goto*//*Label 23469*/ GIMT_Encode4(1715643), // Rule ID 10414 //
     /* 1715562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1715573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1715576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1715579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715608 */     // MIs[0] policy
     /* 1715608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715618 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715642 */     // GIR_Coverage, 10414,
     /* 1715642 */     GIR_EraseRootFromParent_Done,
     /* 1715643 */   // Label 23469: @1715643
     /* 1715643 */   GIM_Try, /*On fail goto*//*Label 23470*/ GIMT_Encode4(1715729), // Rule ID 10415 //
     /* 1715648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1715659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1715662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1715665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715694 */     // MIs[0] policy
     /* 1715694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715728 */     // GIR_Coverage, 10415,
     /* 1715728 */     GIR_EraseRootFromParent_Done,
     /* 1715729 */   // Label 23470: @1715729
     /* 1715729 */   GIM_Try, /*On fail goto*//*Label 23471*/ GIMT_Encode4(1715815), // Rule ID 10418 //
     /* 1715734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1715745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1715748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1715751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715780 */     // MIs[0] policy
     /* 1715780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715790 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715814 */     // GIR_Coverage, 10418,
     /* 1715814 */     GIR_EraseRootFromParent_Done,
     /* 1715815 */   // Label 23471: @1715815
     /* 1715815 */   GIM_Try, /*On fail goto*//*Label 23472*/ GIMT_Encode4(1715901), // Rule ID 10419 //
     /* 1715820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1715831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1715834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1715837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715866 */     // MIs[0] policy
     /* 1715866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715876 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715900 */     // GIR_Coverage, 10419,
     /* 1715900 */     GIR_EraseRootFromParent_Done,
     /* 1715901 */   // Label 23472: @1715901
     /* 1715901 */   GIM_Try, /*On fail goto*//*Label 23473*/ GIMT_Encode4(1715987), // Rule ID 10422 //
     /* 1715906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1715917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1715920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1715923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715952 */     // MIs[0] policy
     /* 1715952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715962 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715986 */     // GIR_Coverage, 10422,
     /* 1715986 */     GIR_EraseRootFromParent_Done,
     /* 1715987 */   // Label 23473: @1715987
     /* 1715987 */   GIM_Try, /*On fail goto*//*Label 23474*/ GIMT_Encode4(1716073), // Rule ID 10423 //
     /* 1715992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1716003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1716006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1716009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716038 */     // MIs[0] policy
     /* 1716038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716048 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1716051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716072 */     // GIR_Coverage, 10423,
     /* 1716072 */     GIR_EraseRootFromParent_Done,
     /* 1716073 */   // Label 23474: @1716073
     /* 1716073 */   GIM_Try, /*On fail goto*//*Label 23475*/ GIMT_Encode4(1716159), // Rule ID 10426 //
     /* 1716078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1716089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1716092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1716095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716124 */     // MIs[0] policy
     /* 1716124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716134 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1716137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716158 */     // GIR_Coverage, 10426,
     /* 1716158 */     GIR_EraseRootFromParent_Done,
     /* 1716159 */   // Label 23475: @1716159
     /* 1716159 */   GIM_Try, /*On fail goto*//*Label 23476*/ GIMT_Encode4(1716245), // Rule ID 10427 //
     /* 1716164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1716175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1716178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1716181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716210 */     // MIs[0] policy
     /* 1716210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716220 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1716223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716244 */     // GIR_Coverage, 10427,
     /* 1716244 */     GIR_EraseRootFromParent_Done,
     /* 1716245 */   // Label 23476: @1716245
     /* 1716245 */   GIM_Try, /*On fail goto*//*Label 23477*/ GIMT_Encode4(1716331), // Rule ID 10430 //
     /* 1716250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1716261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1716264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1716267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716296 */     // MIs[0] policy
     /* 1716296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716306 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1716309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716330 */     // GIR_Coverage, 10430,
     /* 1716330 */     GIR_EraseRootFromParent_Done,
     /* 1716331 */   // Label 23477: @1716331
     /* 1716331 */   GIM_Try, /*On fail goto*//*Label 23478*/ GIMT_Encode4(1716417), // Rule ID 10431 //
     /* 1716336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1716347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1716350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1716353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716382 */     // MIs[0] policy
     /* 1716382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716392 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1716395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716416 */     // GIR_Coverage, 10431,
     /* 1716416 */     GIR_EraseRootFromParent_Done,
     /* 1716417 */   // Label 23478: @1716417
     /* 1716417 */   GIM_Try, /*On fail goto*//*Label 23479*/ GIMT_Encode4(1716503), // Rule ID 10434 //
     /* 1716422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1716433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1716436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1716439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716468 */     // MIs[0] policy
     /* 1716468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716478 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1716481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716502 */     // GIR_Coverage, 10434,
     /* 1716502 */     GIR_EraseRootFromParent_Done,
     /* 1716503 */   // Label 23479: @1716503
     /* 1716503 */   GIM_Try, /*On fail goto*//*Label 23480*/ GIMT_Encode4(1716589), // Rule ID 10435 //
     /* 1716508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1716519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1716522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1716525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716554 */     // MIs[0] policy
     /* 1716554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716564 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1716567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716588 */     // GIR_Coverage, 10435,
     /* 1716588 */     GIR_EraseRootFromParent_Done,
     /* 1716589 */   // Label 23480: @1716589
     /* 1716589 */   GIM_Try, /*On fail goto*//*Label 23481*/ GIMT_Encode4(1716675), // Rule ID 10438 //
     /* 1716594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1716605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1716608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1716611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1716614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1716617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716640 */     // MIs[0] policy
     /* 1716640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716650 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1716653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716674 */     // GIR_Coverage, 10438,
     /* 1716674 */     GIR_EraseRootFromParent_Done,
     /* 1716675 */   // Label 23481: @1716675
     /* 1716675 */   GIM_Try, /*On fail goto*//*Label 23482*/ GIMT_Encode4(1716761), // Rule ID 10439 //
     /* 1716680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1716691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1716694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1716697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1716700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1716703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716726 */     // MIs[0] policy
     /* 1716726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716736 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1716739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716760 */     // GIR_Coverage, 10439,
     /* 1716760 */     GIR_EraseRootFromParent_Done,
     /* 1716761 */   // Label 23482: @1716761
     /* 1716761 */   GIM_Try, /*On fail goto*//*Label 23483*/ GIMT_Encode4(1716847), // Rule ID 10442 //
     /* 1716766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1716777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1716780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1716783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1716786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716812 */     // MIs[0] policy
     /* 1716812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716822 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1716825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716846 */     // GIR_Coverage, 10442,
     /* 1716846 */     GIR_EraseRootFromParent_Done,
     /* 1716847 */   // Label 23483: @1716847
     /* 1716847 */   GIM_Try, /*On fail goto*//*Label 23484*/ GIMT_Encode4(1716933), // Rule ID 10443 //
     /* 1716852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1716863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1716866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1716869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1716872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716898 */     // MIs[0] policy
     /* 1716898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716908 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1716911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716932 */     // GIR_Coverage, 10443,
     /* 1716932 */     GIR_EraseRootFromParent_Done,
     /* 1716933 */   // Label 23484: @1716933
     /* 1716933 */   GIM_Try, /*On fail goto*//*Label 23485*/ GIMT_Encode4(1717019), // Rule ID 10446 //
     /* 1716938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1716949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1716952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1716955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1716958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716984 */     // MIs[0] policy
     /* 1716984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716994 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1716997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717018 */     // GIR_Coverage, 10446,
     /* 1717018 */     GIR_EraseRootFromParent_Done,
     /* 1717019 */   // Label 23485: @1717019
     /* 1717019 */   GIM_Try, /*On fail goto*//*Label 23486*/ GIMT_Encode4(1717105), // Rule ID 10447 //
     /* 1717024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1717035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1717038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1717041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1717044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717070 */     // MIs[0] policy
     /* 1717070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717080 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717104 */     // GIR_Coverage, 10447,
     /* 1717104 */     GIR_EraseRootFromParent_Done,
     /* 1717105 */   // Label 23486: @1717105
     /* 1717105 */   GIM_Try, /*On fail goto*//*Label 23487*/ GIMT_Encode4(1717191), // Rule ID 10450 //
     /* 1717110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1717121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1717124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1717127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1717130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717156 */     // MIs[0] policy
     /* 1717156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717166 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1717169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717190 */     // GIR_Coverage, 10450,
     /* 1717190 */     GIR_EraseRootFromParent_Done,
     /* 1717191 */   // Label 23487: @1717191
     /* 1717191 */   GIM_Try, /*On fail goto*//*Label 23488*/ GIMT_Encode4(1717277), // Rule ID 10451 //
     /* 1717196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1717207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1717210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1717213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1717216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717242 */     // MIs[0] policy
     /* 1717242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717252 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1717255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717276 */     // GIR_Coverage, 10451,
     /* 1717276 */     GIR_EraseRootFromParent_Done,
     /* 1717277 */   // Label 23488: @1717277
     /* 1717277 */   GIM_Try, /*On fail goto*//*Label 23489*/ GIMT_Encode4(1717363), // Rule ID 10454 //
     /* 1717282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1717293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1717296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1717299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1717302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717328 */     // MIs[0] policy
     /* 1717328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717338 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717362 */     // GIR_Coverage, 10454,
     /* 1717362 */     GIR_EraseRootFromParent_Done,
     /* 1717363 */   // Label 23489: @1717363
     /* 1717363 */   GIM_Try, /*On fail goto*//*Label 23490*/ GIMT_Encode4(1717449), // Rule ID 10455 //
     /* 1717368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1717379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1717382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1717385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1717388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717414 */     // MIs[0] policy
     /* 1717414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717424 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717448 */     // GIR_Coverage, 10455,
     /* 1717448 */     GIR_EraseRootFromParent_Done,
     /* 1717449 */   // Label 23490: @1717449
     /* 1717449 */   GIM_Try, /*On fail goto*//*Label 23491*/ GIMT_Encode4(1717535), // Rule ID 10458 //
     /* 1717454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1717465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1717468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1717471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1717474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717500 */     // MIs[0] policy
     /* 1717500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717510 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717534 */     // GIR_Coverage, 10458,
     /* 1717534 */     GIR_EraseRootFromParent_Done,
     /* 1717535 */   // Label 23491: @1717535
     /* 1717535 */   GIM_Try, /*On fail goto*//*Label 23492*/ GIMT_Encode4(1717621), // Rule ID 10459 //
     /* 1717540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1717551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1717554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1717557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1717560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717586 */     // MIs[0] policy
     /* 1717586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717596 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717620 */     // GIR_Coverage, 10459,
     /* 1717620 */     GIR_EraseRootFromParent_Done,
     /* 1717621 */   // Label 23492: @1717621
     /* 1717621 */   GIM_Try, /*On fail goto*//*Label 23493*/ GIMT_Encode4(1717707), // Rule ID 10462 //
     /* 1717626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1717637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1717640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1717643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1717646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717672 */     // MIs[0] policy
     /* 1717672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717682 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1717685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717706 */     // GIR_Coverage, 10462,
     /* 1717706 */     GIR_EraseRootFromParent_Done,
     /* 1717707 */   // Label 23493: @1717707
     /* 1717707 */   GIM_Try, /*On fail goto*//*Label 23494*/ GIMT_Encode4(1717793), // Rule ID 10463 //
     /* 1717712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1717723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1717726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1717729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1717732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717758 */     // MIs[0] policy
     /* 1717758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717768 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1717771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717792 */     // GIR_Coverage, 10463,
     /* 1717792 */     GIR_EraseRootFromParent_Done,
     /* 1717793 */   // Label 23494: @1717793
     /* 1717793 */   GIM_Try, /*On fail goto*//*Label 23495*/ GIMT_Encode4(1717879), // Rule ID 10466 //
     /* 1717798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1717809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1717812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1717815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1717818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717844 */     // MIs[0] policy
     /* 1717844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717854 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1717857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717878 */     // GIR_Coverage, 10466,
     /* 1717878 */     GIR_EraseRootFromParent_Done,
     /* 1717879 */   // Label 23495: @1717879
     /* 1717879 */   GIM_Try, /*On fail goto*//*Label 23496*/ GIMT_Encode4(1717965), // Rule ID 10467 //
     /* 1717884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1717895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1717898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1717901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1717904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717930 */     // MIs[0] policy
     /* 1717930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1717943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717964 */     // GIR_Coverage, 10467,
     /* 1717964 */     GIR_EraseRootFromParent_Done,
     /* 1717965 */   // Label 23496: @1717965
     /* 1717965 */   GIM_Try, /*On fail goto*//*Label 23497*/ GIMT_Encode4(1718051), // Rule ID 10470 //
     /* 1717970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1717981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1717984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1717987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1717990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718016 */     // MIs[0] policy
     /* 1718016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718026 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718050 */     // GIR_Coverage, 10470,
     /* 1718050 */     GIR_EraseRootFromParent_Done,
     /* 1718051 */   // Label 23497: @1718051
     /* 1718051 */   GIM_Try, /*On fail goto*//*Label 23498*/ GIMT_Encode4(1718137), // Rule ID 10471 //
     /* 1718056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1718067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1718070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1718073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1718076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718102 */     // MIs[0] policy
     /* 1718102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718112 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718136 */     // GIR_Coverage, 10471,
     /* 1718136 */     GIR_EraseRootFromParent_Done,
     /* 1718137 */   // Label 23498: @1718137
     /* 1718137 */   GIM_Try, /*On fail goto*//*Label 23499*/ GIMT_Encode4(1718223), // Rule ID 10474 //
     /* 1718142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1718145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1718153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1718156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1718159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1718162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718188 */     // MIs[0] policy
     /* 1718188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718198 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718222 */     // GIR_Coverage, 10474,
     /* 1718222 */     GIR_EraseRootFromParent_Done,
     /* 1718223 */   // Label 23499: @1718223
     /* 1718223 */   GIM_Try, /*On fail goto*//*Label 23500*/ GIMT_Encode4(1718309), // Rule ID 10475 //
     /* 1718228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1718231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1718239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1718242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1718245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1718248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718274 */     // MIs[0] policy
     /* 1718274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718308 */     // GIR_Coverage, 10475,
     /* 1718308 */     GIR_EraseRootFromParent_Done,
     /* 1718309 */   // Label 23500: @1718309
     /* 1718309 */   GIM_Try, /*On fail goto*//*Label 23501*/ GIMT_Encode4(1718395), // Rule ID 10478 //
     /* 1718314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1718325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1718328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1718331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1718334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1718337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718360 */     // MIs[0] policy
     /* 1718360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718370 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1718373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718394 */     // GIR_Coverage, 10478,
     /* 1718394 */     GIR_EraseRootFromParent_Done,
     /* 1718395 */   // Label 23501: @1718395
     /* 1718395 */   GIM_Try, /*On fail goto*//*Label 23502*/ GIMT_Encode4(1718481), // Rule ID 10479 //
     /* 1718400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1718411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1718414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1718417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1718420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1718423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718446 */     // MIs[0] policy
     /* 1718446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718456 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1718459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718480 */     // GIR_Coverage, 10479,
     /* 1718480 */     GIR_EraseRootFromParent_Done,
     /* 1718481 */   // Label 23502: @1718481
     /* 1718481 */   GIM_Try, /*On fail goto*//*Label 23503*/ GIMT_Encode4(1718567), // Rule ID 10482 //
     /* 1718486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1718497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1718500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1718503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1718506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1718509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1718516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718532 */     // MIs[0] policy
     /* 1718532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718542 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1718545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718566 */     // GIR_Coverage, 10482,
     /* 1718566 */     GIR_EraseRootFromParent_Done,
     /* 1718567 */   // Label 23503: @1718567
     /* 1718567 */   GIM_Try, /*On fail goto*//*Label 23504*/ GIMT_Encode4(1718653), // Rule ID 10483 //
     /* 1718572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1718583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1718586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1718589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1718592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1718595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1718602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718618 */     // MIs[0] policy
     /* 1718618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718628 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1718631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718652 */     // GIR_Coverage, 10483,
     /* 1718652 */     GIR_EraseRootFromParent_Done,
     /* 1718653 */   // Label 23504: @1718653
     /* 1718653 */   GIM_Try, /*On fail goto*//*Label 23505*/ GIMT_Encode4(1718739), // Rule ID 10486 //
     /* 1718658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1718669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1718672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1718675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1718678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1718681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1718688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718704 */     // MIs[0] policy
     /* 1718704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718714 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1718717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718738 */     // GIR_Coverage, 10486,
     /* 1718738 */     GIR_EraseRootFromParent_Done,
     /* 1718739 */   // Label 23505: @1718739
     /* 1718739 */   GIM_Try, /*On fail goto*//*Label 23506*/ GIMT_Encode4(1718825), // Rule ID 10487 //
     /* 1718744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1718755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1718758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1718761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1718764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1718767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1718774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718790 */     // MIs[0] policy
     /* 1718790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718800 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1718803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718824 */     // GIR_Coverage, 10487,
     /* 1718824 */     GIR_EraseRootFromParent_Done,
     /* 1718825 */   // Label 23506: @1718825
     /* 1718825 */   GIM_Try, /*On fail goto*//*Label 23507*/ GIMT_Encode4(1718911), // Rule ID 10490 //
     /* 1718830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1718841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1718844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1718847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1718850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718876 */     // MIs[0] policy
     /* 1718876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1718889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718910 */     // GIR_Coverage, 10490,
     /* 1718910 */     GIR_EraseRootFromParent_Done,
     /* 1718911 */   // Label 23507: @1718911
     /* 1718911 */   GIM_Try, /*On fail goto*//*Label 23508*/ GIMT_Encode4(1718997), // Rule ID 10491 //
     /* 1718916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1718927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1718930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1718933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1718936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718962 */     // MIs[0] policy
     /* 1718962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718972 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1718975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718996 */     // GIR_Coverage, 10491,
     /* 1718996 */     GIR_EraseRootFromParent_Done,
     /* 1718997 */   // Label 23508: @1718997
     /* 1718997 */   GIM_Try, /*On fail goto*//*Label 23509*/ GIMT_Encode4(1719083), // Rule ID 10494 //
     /* 1719002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1719013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1719016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1719019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1719022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719048 */     // MIs[0] policy
     /* 1719048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719058 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719082 */     // GIR_Coverage, 10494,
     /* 1719082 */     GIR_EraseRootFromParent_Done,
     /* 1719083 */   // Label 23509: @1719083
     /* 1719083 */   GIM_Try, /*On fail goto*//*Label 23510*/ GIMT_Encode4(1719169), // Rule ID 10495 //
     /* 1719088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1719099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1719102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1719105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1719108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719134 */     // MIs[0] policy
     /* 1719134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719144 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719168 */     // GIR_Coverage, 10495,
     /* 1719168 */     GIR_EraseRootFromParent_Done,
     /* 1719169 */   // Label 23510: @1719169
     /* 1719169 */   GIM_Try, /*On fail goto*//*Label 23511*/ GIMT_Encode4(1719255), // Rule ID 10498 //
     /* 1719174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1719185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1719188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1719191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1719194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719220 */     // MIs[0] policy
     /* 1719220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719230 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719254 */     // GIR_Coverage, 10498,
     /* 1719254 */     GIR_EraseRootFromParent_Done,
     /* 1719255 */   // Label 23511: @1719255
     /* 1719255 */   GIM_Try, /*On fail goto*//*Label 23512*/ GIMT_Encode4(1719341), // Rule ID 10499 //
     /* 1719260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1719271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1719274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1719277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1719280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719306 */     // MIs[0] policy
     /* 1719306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719316 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719340 */     // GIR_Coverage, 10499,
     /* 1719340 */     GIR_EraseRootFromParent_Done,
     /* 1719341 */   // Label 23512: @1719341
     /* 1719341 */   GIM_Try, /*On fail goto*//*Label 23513*/ GIMT_Encode4(1719427), // Rule ID 10502 //
     /* 1719346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1719357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1719360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1719363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1719366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719392 */     // MIs[0] policy
     /* 1719392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719426 */     // GIR_Coverage, 10502,
     /* 1719426 */     GIR_EraseRootFromParent_Done,
     /* 1719427 */   // Label 23513: @1719427
     /* 1719427 */   GIM_Try, /*On fail goto*//*Label 23514*/ GIMT_Encode4(1719513), // Rule ID 10503 //
     /* 1719432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1719443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1719446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1719449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1719452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719478 */     // MIs[0] policy
     /* 1719478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719488 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719512 */     // GIR_Coverage, 10503,
     /* 1719512 */     GIR_EraseRootFromParent_Done,
     /* 1719513 */   // Label 23514: @1719513
     /* 1719513 */   GIM_Try, /*On fail goto*//*Label 23515*/ GIMT_Encode4(1719599), // Rule ID 10506 //
     /* 1719518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1719529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1719532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1719535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1719538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719564 */     // MIs[0] policy
     /* 1719564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719598 */     // GIR_Coverage, 10506,
     /* 1719598 */     GIR_EraseRootFromParent_Done,
     /* 1719599 */   // Label 23515: @1719599
     /* 1719599 */   GIM_Try, /*On fail goto*//*Label 23516*/ GIMT_Encode4(1719685), // Rule ID 10507 //
     /* 1719604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1719615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1719618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1719621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1719624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719650 */     // MIs[0] policy
     /* 1719650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719660 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719684 */     // GIR_Coverage, 10507,
     /* 1719684 */     GIR_EraseRootFromParent_Done,
     /* 1719685 */   // Label 23516: @1719685
     /* 1719685 */   GIM_Try, /*On fail goto*//*Label 23517*/ GIMT_Encode4(1719771), // Rule ID 10510 //
     /* 1719690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1719701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1719704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1719707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1719710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719736 */     // MIs[0] policy
     /* 1719736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719746 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719770 */     // GIR_Coverage, 10510,
     /* 1719770 */     GIR_EraseRootFromParent_Done,
     /* 1719771 */   // Label 23517: @1719771
     /* 1719771 */   GIM_Try, /*On fail goto*//*Label 23518*/ GIMT_Encode4(1719857), // Rule ID 10511 //
     /* 1719776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1719787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1719790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1719793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1719796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719822 */     // MIs[0] policy
     /* 1719822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719832 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719856 */     // GIR_Coverage, 10511,
     /* 1719856 */     GIR_EraseRootFromParent_Done,
     /* 1719857 */   // Label 23518: @1719857
     /* 1719857 */   GIM_Try, /*On fail goto*//*Label 23519*/ GIMT_Encode4(1719943), // Rule ID 10514 //
     /* 1719862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1719865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1719873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1719876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1719879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1719882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1719885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719908 */     // MIs[0] policy
     /* 1719908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719918 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1719939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719942 */     // GIR_Coverage, 10514,
     /* 1719942 */     GIR_EraseRootFromParent_Done,
     /* 1719943 */   // Label 23519: @1719943
     /* 1719943 */   GIM_Try, /*On fail goto*//*Label 23520*/ GIMT_Encode4(1720029), // Rule ID 10515 //
     /* 1719948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1719951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1719959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1719962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1719965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1719968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1719971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719994 */     // MIs[0] policy
     /* 1719994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720004 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1720007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720028 */     // GIR_Coverage, 10515,
     /* 1720028 */     GIR_EraseRootFromParent_Done,
     /* 1720029 */   // Label 23520: @1720029
     /* 1720029 */   GIM_Try, /*On fail goto*//*Label 23521*/ GIMT_Encode4(1720115), // Rule ID 10518 //
     /* 1720034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1720045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1720048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1720051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1720054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720080 */     // MIs[0] policy
     /* 1720080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720090 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1720093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720114 */     // GIR_Coverage, 10518,
     /* 1720114 */     GIR_EraseRootFromParent_Done,
     /* 1720115 */   // Label 23521: @1720115
     /* 1720115 */   GIM_Try, /*On fail goto*//*Label 23522*/ GIMT_Encode4(1720201), // Rule ID 10519 //
     /* 1720120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1720131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1720134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1720137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1720140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720166 */     // MIs[0] policy
     /* 1720166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720176 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1720179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720200 */     // GIR_Coverage, 10519,
     /* 1720200 */     GIR_EraseRootFromParent_Done,
     /* 1720201 */   // Label 23522: @1720201
     /* 1720201 */   GIM_Try, /*On fail goto*//*Label 23523*/ GIMT_Encode4(1720287), // Rule ID 10522 //
     /* 1720206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1720217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1720220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1720223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1720226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720252 */     // MIs[0] policy
     /* 1720252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720262 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1720265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720286 */     // GIR_Coverage, 10522,
     /* 1720286 */     GIR_EraseRootFromParent_Done,
     /* 1720287 */   // Label 23523: @1720287
     /* 1720287 */   GIM_Try, /*On fail goto*//*Label 23524*/ GIMT_Encode4(1720373), // Rule ID 10523 //
     /* 1720292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1720303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1720306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1720309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1720312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720338 */     // MIs[0] policy
     /* 1720338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720348 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1720351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720372 */     // GIR_Coverage, 10523,
     /* 1720372 */     GIR_EraseRootFromParent_Done,
     /* 1720373 */   // Label 23524: @1720373
     /* 1720373 */   GIM_Try, /*On fail goto*//*Label 23525*/ GIMT_Encode4(1720459), // Rule ID 10526 //
     /* 1720378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1720389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1720392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1720395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720424 */     // MIs[0] policy
     /* 1720424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720434 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1720437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720458 */     // GIR_Coverage, 10526,
     /* 1720458 */     GIR_EraseRootFromParent_Done,
     /* 1720459 */   // Label 23525: @1720459
     /* 1720459 */   GIM_Try, /*On fail goto*//*Label 23526*/ GIMT_Encode4(1720545), // Rule ID 10527 //
     /* 1720464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1720475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1720478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1720481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720510 */     // MIs[0] policy
     /* 1720510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720520 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1720523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720544 */     // GIR_Coverage, 10527,
     /* 1720544 */     GIR_EraseRootFromParent_Done,
     /* 1720545 */   // Label 23526: @1720545
     /* 1720545 */   GIM_Try, /*On fail goto*//*Label 23527*/ GIMT_Encode4(1720631), // Rule ID 10530 //
     /* 1720550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1720561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1720564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1720567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1720573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720596 */     // MIs[0] policy
     /* 1720596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720606 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1720609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720630 */     // GIR_Coverage, 10530,
     /* 1720630 */     GIR_EraseRootFromParent_Done,
     /* 1720631 */   // Label 23527: @1720631
     /* 1720631 */   GIM_Try, /*On fail goto*//*Label 23528*/ GIMT_Encode4(1720717), // Rule ID 10531 //
     /* 1720636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1720647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1720650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1720653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1720659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720682 */     // MIs[0] policy
     /* 1720682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720692 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1720695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720716 */     // GIR_Coverage, 10531,
     /* 1720716 */     GIR_EraseRootFromParent_Done,
     /* 1720717 */   // Label 23528: @1720717
     /* 1720717 */   GIM_Try, /*On fail goto*//*Label 23529*/ GIMT_Encode4(1720803), // Rule ID 10534 //
     /* 1720722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1720733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1720736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1720739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720768 */     // MIs[0] policy
     /* 1720768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720778 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1720781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720802 */     // GIR_Coverage, 10534,
     /* 1720802 */     GIR_EraseRootFromParent_Done,
     /* 1720803 */   // Label 23529: @1720803
     /* 1720803 */   GIM_Try, /*On fail goto*//*Label 23530*/ GIMT_Encode4(1720889), // Rule ID 10535 //
     /* 1720808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1720819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1720822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1720825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720854 */     // MIs[0] policy
     /* 1720854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720864 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1720867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720888 */     // GIR_Coverage, 10535,
     /* 1720888 */     GIR_EraseRootFromParent_Done,
     /* 1720889 */   // Label 23530: @1720889
     /* 1720889 */   GIM_Try, /*On fail goto*//*Label 23531*/ GIMT_Encode4(1720975), // Rule ID 10538 //
     /* 1720894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1720905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1720908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1720911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720940 */     // MIs[0] policy
     /* 1720940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720950 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1720953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720974 */     // GIR_Coverage, 10538,
     /* 1720974 */     GIR_EraseRootFromParent_Done,
     /* 1720975 */   // Label 23531: @1720975
     /* 1720975 */   GIM_Try, /*On fail goto*//*Label 23532*/ GIMT_Encode4(1721061), // Rule ID 10539 //
     /* 1720980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1720991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1720994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1720997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721026 */     // MIs[0] policy
     /* 1721026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721036 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1721039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721060 */     // GIR_Coverage, 10539,
     /* 1721060 */     GIR_EraseRootFromParent_Done,
     /* 1721061 */   // Label 23532: @1721061
     /* 1721061 */   GIM_Try, /*On fail goto*//*Label 23533*/ GIMT_Encode4(1721147), // Rule ID 10542 //
     /* 1721066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1721077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1721080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1721083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721112 */     // MIs[0] policy
     /* 1721112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721122 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721146 */     // GIR_Coverage, 10542,
     /* 1721146 */     GIR_EraseRootFromParent_Done,
     /* 1721147 */   // Label 23533: @1721147
     /* 1721147 */   GIM_Try, /*On fail goto*//*Label 23534*/ GIMT_Encode4(1721233), // Rule ID 10543 //
     /* 1721152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1721163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1721166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1721169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721198 */     // MIs[0] policy
     /* 1721198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721208 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721232 */     // GIR_Coverage, 10543,
     /* 1721232 */     GIR_EraseRootFromParent_Done,
     /* 1721233 */   // Label 23534: @1721233
     /* 1721233 */   GIM_Try, /*On fail goto*//*Label 23535*/ GIMT_Encode4(1721319), // Rule ID 10546 //
     /* 1721238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1721249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1721252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1721255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721284 */     // MIs[0] policy
     /* 1721284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721318 */     // GIR_Coverage, 10546,
     /* 1721318 */     GIR_EraseRootFromParent_Done,
     /* 1721319 */   // Label 23535: @1721319
     /* 1721319 */   GIM_Try, /*On fail goto*//*Label 23536*/ GIMT_Encode4(1721405), // Rule ID 10547 //
     /* 1721324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1721335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1721338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1721341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721370 */     // MIs[0] policy
     /* 1721370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721380 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721404 */     // GIR_Coverage, 10547,
     /* 1721404 */     GIR_EraseRootFromParent_Done,
     /* 1721405 */   // Label 23536: @1721405
     /* 1721405 */   GIM_Try, /*On fail goto*//*Label 23537*/ GIMT_Encode4(1721491), // Rule ID 10550 //
     /* 1721410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1721421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1721424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1721427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721456 */     // MIs[0] policy
     /* 1721456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721466 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721490 */     // GIR_Coverage, 10550,
     /* 1721490 */     GIR_EraseRootFromParent_Done,
     /* 1721491 */   // Label 23537: @1721491
     /* 1721491 */   GIM_Try, /*On fail goto*//*Label 23538*/ GIMT_Encode4(1721577), // Rule ID 10551 //
     /* 1721496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1721507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1721510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1721513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721542 */     // MIs[0] policy
     /* 1721542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721552 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721576 */     // GIR_Coverage, 10551,
     /* 1721576 */     GIR_EraseRootFromParent_Done,
     /* 1721577 */   // Label 23538: @1721577
     /* 1721577 */   GIM_Try, /*On fail goto*//*Label 23539*/ GIMT_Encode4(1721663), // Rule ID 10554 //
     /* 1721582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1721593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1721596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1721599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721628 */     // MIs[0] policy
     /* 1721628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721638 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721662 */     // GIR_Coverage, 10554,
     /* 1721662 */     GIR_EraseRootFromParent_Done,
     /* 1721663 */   // Label 23539: @1721663
     /* 1721663 */   GIM_Try, /*On fail goto*//*Label 23540*/ GIMT_Encode4(1721749), // Rule ID 10555 //
     /* 1721668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1721679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1721682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1721685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721714 */     // MIs[0] policy
     /* 1721714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721724 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721748 */     // GIR_Coverage, 10555,
     /* 1721748 */     GIR_EraseRootFromParent_Done,
     /* 1721749 */   // Label 23540: @1721749
     /* 1721749 */   GIM_Try, /*On fail goto*//*Label 23541*/ GIMT_Encode4(1721835), // Rule ID 10558 //
     /* 1721754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1721765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1721768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1721771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721800 */     // MIs[0] policy
     /* 1721800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721834 */     // GIR_Coverage, 10558,
     /* 1721834 */     GIR_EraseRootFromParent_Done,
     /* 1721835 */   // Label 23541: @1721835
     /* 1721835 */   GIM_Try, /*On fail goto*//*Label 23542*/ GIMT_Encode4(1721921), // Rule ID 10559 //
     /* 1721840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1721851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1721854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1721857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721886 */     // MIs[0] policy
     /* 1721886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721896 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721920 */     // GIR_Coverage, 10559,
     /* 1721920 */     GIR_EraseRootFromParent_Done,
     /* 1721921 */   // Label 23542: @1721921
     /* 1721921 */   GIM_Try, /*On fail goto*//*Label 23543*/ GIMT_Encode4(1722007), // Rule ID 10562 //
     /* 1721926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1721929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1721937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1721940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1721943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721972 */     // MIs[0] policy
     /* 1721972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721982 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1722003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722006 */     // GIR_Coverage, 10562,
     /* 1722006 */     GIR_EraseRootFromParent_Done,
     /* 1722007 */   // Label 23543: @1722007
     /* 1722007 */   GIM_Try, /*On fail goto*//*Label 23544*/ GIMT_Encode4(1722093), // Rule ID 10563 //
     /* 1722012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1722015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1722023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1722026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1722029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722058 */     // MIs[0] policy
     /* 1722058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1722089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722092 */     // GIR_Coverage, 10563,
     /* 1722092 */     GIR_EraseRootFromParent_Done,
     /* 1722093 */   // Label 23544: @1722093
     /* 1722093 */   GIM_Try, /*On fail goto*//*Label 23545*/ GIMT_Encode4(1722179), // Rule ID 10566 //
     /* 1722098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1722109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1722112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1722115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722144 */     // MIs[0] policy
     /* 1722144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722154 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1722157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722178 */     // GIR_Coverage, 10566,
     /* 1722178 */     GIR_EraseRootFromParent_Done,
     /* 1722179 */   // Label 23545: @1722179
     /* 1722179 */   GIM_Try, /*On fail goto*//*Label 23546*/ GIMT_Encode4(1722265), // Rule ID 10567 //
     /* 1722184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1722195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1722198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1722201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722230 */     // MIs[0] policy
     /* 1722230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722240 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1722243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722264 */     // GIR_Coverage, 10567,
     /* 1722264 */     GIR_EraseRootFromParent_Done,
     /* 1722265 */   // Label 23546: @1722265
     /* 1722265 */   GIM_Try, /*On fail goto*//*Label 23547*/ GIMT_Encode4(1722351), // Rule ID 10570 //
     /* 1722270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1722281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1722284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1722287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1722293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722316 */     // MIs[0] policy
     /* 1722316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722326 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1722329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722350 */     // GIR_Coverage, 10570,
     /* 1722350 */     GIR_EraseRootFromParent_Done,
     /* 1722351 */   // Label 23547: @1722351
     /* 1722351 */   GIM_Try, /*On fail goto*//*Label 23548*/ GIMT_Encode4(1722437), // Rule ID 10571 //
     /* 1722356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1722367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1722370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1722373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1722379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722402 */     // MIs[0] policy
     /* 1722402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722412 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1722415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722436 */     // GIR_Coverage, 10571,
     /* 1722436 */     GIR_EraseRootFromParent_Done,
     /* 1722437 */   // Label 23548: @1722437
     /* 1722437 */   GIM_Try, /*On fail goto*//*Label 23549*/ GIMT_Encode4(1722523), // Rule ID 10574 //
     /* 1722442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1722453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1722456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1722459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1722465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1722472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722488 */     // MIs[0] policy
     /* 1722488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722498 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1722501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722522 */     // GIR_Coverage, 10574,
     /* 1722522 */     GIR_EraseRootFromParent_Done,
     /* 1722523 */   // Label 23549: @1722523
     /* 1722523 */   GIM_Try, /*On fail goto*//*Label 23550*/ GIMT_Encode4(1722609), // Rule ID 10575 //
     /* 1722528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1722539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1722542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1722545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1722551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1722558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722574 */     // MIs[0] policy
     /* 1722574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722584 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1722587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722608 */     // GIR_Coverage, 10575,
     /* 1722608 */     GIR_EraseRootFromParent_Done,
     /* 1722609 */   // Label 23550: @1722609
     /* 1722609 */   GIM_Try, /*On fail goto*//*Label 23551*/ GIMT_Encode4(1722695), // Rule ID 10578 //
     /* 1722614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1722625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1722628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1722631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1722637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722660 */     // MIs[0] policy
     /* 1722660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1722673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722694 */     // GIR_Coverage, 10578,
     /* 1722694 */     GIR_EraseRootFromParent_Done,
     /* 1722695 */   // Label 23551: @1722695
     /* 1722695 */   GIM_Try, /*On fail goto*//*Label 23552*/ GIMT_Encode4(1722781), // Rule ID 10579 //
     /* 1722700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1722711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1722714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1722717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1722723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722746 */     // MIs[0] policy
     /* 1722746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722756 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1722759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722780 */     // GIR_Coverage, 10579,
     /* 1722780 */     GIR_EraseRootFromParent_Done,
     /* 1722781 */   // Label 23552: @1722781
     /* 1722781 */   GIM_Try, /*On fail goto*//*Label 23553*/ GIMT_Encode4(1722867), // Rule ID 10582 //
     /* 1722786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1722797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1722800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1722803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722832 */     // MIs[0] policy
     /* 1722832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722842 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1722845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722866 */     // GIR_Coverage, 10582,
     /* 1722866 */     GIR_EraseRootFromParent_Done,
     /* 1722867 */   // Label 23553: @1722867
     /* 1722867 */   GIM_Try, /*On fail goto*//*Label 23554*/ GIMT_Encode4(1722953), // Rule ID 10583 //
     /* 1722872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1722883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1722886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1722889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722918 */     // MIs[0] policy
     /* 1722918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722928 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1722931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722952 */     // GIR_Coverage, 10583,
     /* 1722952 */     GIR_EraseRootFromParent_Done,
     /* 1722953 */   // Label 23554: @1722953
     /* 1722953 */   GIM_Try, /*On fail goto*//*Label 23555*/ GIMT_Encode4(1723039), // Rule ID 10586 //
     /* 1722958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1722969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1722972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1722975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1722981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1722988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723004 */     // MIs[0] policy
     /* 1723004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723014 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723038 */     // GIR_Coverage, 10586,
     /* 1723038 */     GIR_EraseRootFromParent_Done,
     /* 1723039 */   // Label 23555: @1723039
     /* 1723039 */   GIM_Try, /*On fail goto*//*Label 23556*/ GIMT_Encode4(1723125), // Rule ID 10587 //
     /* 1723044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1723055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1723058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1723061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1723067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723090 */     // MIs[0] policy
     /* 1723090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723100 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723124 */     // GIR_Coverage, 10587,
     /* 1723124 */     GIR_EraseRootFromParent_Done,
     /* 1723125 */   // Label 23556: @1723125
     /* 1723125 */   GIM_Try, /*On fail goto*//*Label 23557*/ GIMT_Encode4(1723211), // Rule ID 10590 //
     /* 1723130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1723141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1723144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1723147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723176 */     // MIs[0] policy
     /* 1723176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723186 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723210 */     // GIR_Coverage, 10590,
     /* 1723210 */     GIR_EraseRootFromParent_Done,
     /* 1723211 */   // Label 23557: @1723211
     /* 1723211 */   GIM_Try, /*On fail goto*//*Label 23558*/ GIMT_Encode4(1723297), // Rule ID 10591 //
     /* 1723216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1723227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1723230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1723233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723262 */     // MIs[0] policy
     /* 1723262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723272 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723296 */     // GIR_Coverage, 10591,
     /* 1723296 */     GIR_EraseRootFromParent_Done,
     /* 1723297 */   // Label 23558: @1723297
     /* 1723297 */   GIM_Try, /*On fail goto*//*Label 23559*/ GIMT_Encode4(1723383), // Rule ID 10594 //
     /* 1723302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1723313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1723316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1723319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723348 */     // MIs[0] policy
     /* 1723348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723358 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723382 */     // GIR_Coverage, 10594,
     /* 1723382 */     GIR_EraseRootFromParent_Done,
     /* 1723383 */   // Label 23559: @1723383
     /* 1723383 */   GIM_Try, /*On fail goto*//*Label 23560*/ GIMT_Encode4(1723469), // Rule ID 10595 //
     /* 1723388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1723399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1723402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1723405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723434 */     // MIs[0] policy
     /* 1723434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723444 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723468 */     // GIR_Coverage, 10595,
     /* 1723468 */     GIR_EraseRootFromParent_Done,
     /* 1723469 */   // Label 23560: @1723469
     /* 1723469 */   GIM_Try, /*On fail goto*//*Label 23561*/ GIMT_Encode4(1723555), // Rule ID 10598 //
     /* 1723474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1723485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1723488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1723491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723520 */     // MIs[0] policy
     /* 1723520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723530 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723554 */     // GIR_Coverage, 10598,
     /* 1723554 */     GIR_EraseRootFromParent_Done,
     /* 1723555 */   // Label 23561: @1723555
     /* 1723555 */   GIM_Try, /*On fail goto*//*Label 23562*/ GIMT_Encode4(1723641), // Rule ID 10599 //
     /* 1723560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1723571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1723574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1723577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723606 */     // MIs[0] policy
     /* 1723606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723616 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723640 */     // GIR_Coverage, 10599,
     /* 1723640 */     GIR_EraseRootFromParent_Done,
     /* 1723641 */   // Label 23562: @1723641
     /* 1723641 */   GIM_Try, /*On fail goto*//*Label 23563*/ GIMT_Encode4(1723727), // Rule ID 10602 //
     /* 1723646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1723649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1723657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1723660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1723663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1723669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723692 */     // MIs[0] policy
     /* 1723692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723726 */     // GIR_Coverage, 10602,
     /* 1723726 */     GIR_EraseRootFromParent_Done,
     /* 1723727 */   // Label 23563: @1723727
     /* 1723727 */   GIM_Try, /*On fail goto*//*Label 23564*/ GIMT_Encode4(1723813), // Rule ID 10603 //
     /* 1723732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1723735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1723743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1723746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1723749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1723755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723778 */     // MIs[0] policy
     /* 1723778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723812 */     // GIR_Coverage, 10603,
     /* 1723812 */     GIR_EraseRootFromParent_Done,
     /* 1723813 */   // Label 23564: @1723813
     /* 1723813 */   GIM_Try, /*On fail goto*//*Label 23565*/ GIMT_Encode4(1723899), // Rule ID 10606 //
     /* 1723818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1723821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1723829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1723832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1723835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723864 */     // MIs[0] policy
     /* 1723864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723898 */     // GIR_Coverage, 10606,
     /* 1723898 */     GIR_EraseRootFromParent_Done,
     /* 1723899 */   // Label 23565: @1723899
     /* 1723899 */   GIM_Try, /*On fail goto*//*Label 23566*/ GIMT_Encode4(1723985), // Rule ID 10607 //
     /* 1723904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1723907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1723915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1723918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1723921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723950 */     // MIs[0] policy
     /* 1723950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723960 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723984 */     // GIR_Coverage, 10607,
     /* 1723984 */     GIR_EraseRootFromParent_Done,
     /* 1723985 */   // Label 23566: @1723985
     /* 1723985 */   GIM_Try, /*On fail goto*//*Label 23567*/ GIMT_Encode4(1724071), // Rule ID 10610 //
     /* 1723990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1723993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1724001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1724004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1724007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724036 */     // MIs[0] policy
     /* 1724036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1724049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724070 */     // GIR_Coverage, 10610,
     /* 1724070 */     GIR_EraseRootFromParent_Done,
     /* 1724071 */   // Label 23567: @1724071
     /* 1724071 */   GIM_Try, /*On fail goto*//*Label 23568*/ GIMT_Encode4(1724157), // Rule ID 10611 //
     /* 1724076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1724079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1724087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1724090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1724093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724122 */     // MIs[0] policy
     /* 1724122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724132 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1724135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724156 */     // GIR_Coverage, 10611,
     /* 1724156 */     GIR_EraseRootFromParent_Done,
     /* 1724157 */   // Label 23568: @1724157
     /* 1724157 */   GIM_Try, /*On fail goto*//*Label 23569*/ GIMT_Encode4(1724243), // Rule ID 10614 //
     /* 1724162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1724173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1724176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1724179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1724182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724208 */     // MIs[0] policy
     /* 1724208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724218 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1724221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724242 */     // GIR_Coverage, 10614,
     /* 1724242 */     GIR_EraseRootFromParent_Done,
     /* 1724243 */   // Label 23569: @1724243
     /* 1724243 */   GIM_Try, /*On fail goto*//*Label 23570*/ GIMT_Encode4(1724329), // Rule ID 10615 //
     /* 1724248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1724259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1724262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1724265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1724268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724294 */     // MIs[0] policy
     /* 1724294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724304 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1724307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724328 */     // GIR_Coverage, 10615,
     /* 1724328 */     GIR_EraseRootFromParent_Done,
     /* 1724329 */   // Label 23570: @1724329
     /* 1724329 */   GIM_Try, /*On fail goto*//*Label 23571*/ GIMT_Encode4(1724415), // Rule ID 10618 //
     /* 1724334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1724345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1724348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1724351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1724354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724380 */     // MIs[0] policy
     /* 1724380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724390 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1724393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724414 */     // GIR_Coverage, 10618,
     /* 1724414 */     GIR_EraseRootFromParent_Done,
     /* 1724415 */   // Label 23571: @1724415
     /* 1724415 */   GIM_Try, /*On fail goto*//*Label 23572*/ GIMT_Encode4(1724501), // Rule ID 10619 //
     /* 1724420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1724431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1724434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1724437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1724440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724466 */     // MIs[0] policy
     /* 1724466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724476 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1724479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724500 */     // GIR_Coverage, 10619,
     /* 1724500 */     GIR_EraseRootFromParent_Done,
     /* 1724501 */   // Label 23572: @1724501
     /* 1724501 */   GIM_Try, /*On fail goto*//*Label 23573*/ GIMT_Encode4(1724587), // Rule ID 10622 //
     /* 1724506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1724517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1724520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1724523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1724526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724552 */     // MIs[0] policy
     /* 1724552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724562 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1724565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724586 */     // GIR_Coverage, 10622,
     /* 1724586 */     GIR_EraseRootFromParent_Done,
     /* 1724587 */   // Label 23573: @1724587
     /* 1724587 */   GIM_Try, /*On fail goto*//*Label 23574*/ GIMT_Encode4(1724673), // Rule ID 10623 //
     /* 1724592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1724603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1724606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1724609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1724612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724638 */     // MIs[0] policy
     /* 1724638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724648 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1724651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724672 */     // GIR_Coverage, 10623,
     /* 1724672 */     GIR_EraseRootFromParent_Done,
     /* 1724673 */   // Label 23574: @1724673
     /* 1724673 */   GIM_Try, /*On fail goto*//*Label 23575*/ GIMT_Encode4(1724759), // Rule ID 10626 //
     /* 1724678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1724689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1724692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1724695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1724698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724724 */     // MIs[0] policy
     /* 1724724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724734 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1724737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724758 */     // GIR_Coverage, 10626,
     /* 1724758 */     GIR_EraseRootFromParent_Done,
     /* 1724759 */   // Label 23575: @1724759
     /* 1724759 */   GIM_Try, /*On fail goto*//*Label 23576*/ GIMT_Encode4(1724845), // Rule ID 10627 //
     /* 1724764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1724775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1724778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1724781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1724784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724810 */     // MIs[0] policy
     /* 1724810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724820 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1724823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724844 */     // GIR_Coverage, 10627,
     /* 1724844 */     GIR_EraseRootFromParent_Done,
     /* 1724845 */   // Label 23576: @1724845
     /* 1724845 */   GIM_Try, /*On fail goto*//*Label 23577*/ GIMT_Encode4(1724931), // Rule ID 10630 //
     /* 1724850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1724861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1724864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1724867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1724870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724896 */     // MIs[0] policy
     /* 1724896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724906 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1724909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724930 */     // GIR_Coverage, 10630,
     /* 1724930 */     GIR_EraseRootFromParent_Done,
     /* 1724931 */   // Label 23577: @1724931
     /* 1724931 */   GIM_Try, /*On fail goto*//*Label 23578*/ GIMT_Encode4(1725017), // Rule ID 10631 //
     /* 1724936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1724947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1724950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1724953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1724956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724982 */     // MIs[0] policy
     /* 1724982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724992 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1724995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725016 */     // GIR_Coverage, 10631,
     /* 1725016 */     GIR_EraseRootFromParent_Done,
     /* 1725017 */   // Label 23578: @1725017
     /* 1725017 */   GIM_Try, /*On fail goto*//*Label 23579*/ GIMT_Encode4(1725103), // Rule ID 10634 //
     /* 1725022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1725033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1725036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1725039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1725042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725068 */     // MIs[0] policy
     /* 1725068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725078 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725102 */     // GIR_Coverage, 10634,
     /* 1725102 */     GIR_EraseRootFromParent_Done,
     /* 1725103 */   // Label 23579: @1725103
     /* 1725103 */   GIM_Try, /*On fail goto*//*Label 23580*/ GIMT_Encode4(1725189), // Rule ID 10635 //
     /* 1725108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1725119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1725122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1725125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1725128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725154 */     // MIs[0] policy
     /* 1725154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725164 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725188 */     // GIR_Coverage, 10635,
     /* 1725188 */     GIR_EraseRootFromParent_Done,
     /* 1725189 */   // Label 23580: @1725189
     /* 1725189 */   GIM_Try, /*On fail goto*//*Label 23581*/ GIMT_Encode4(1725275), // Rule ID 10638 //
     /* 1725194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1725205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1725208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1725211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1725214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725240 */     // MIs[0] policy
     /* 1725240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725250 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725274 */     // GIR_Coverage, 10638,
     /* 1725274 */     GIR_EraseRootFromParent_Done,
     /* 1725275 */   // Label 23581: @1725275
     /* 1725275 */   GIM_Try, /*On fail goto*//*Label 23582*/ GIMT_Encode4(1725361), // Rule ID 10639 //
     /* 1725280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1725291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1725294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1725297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1725300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725326 */     // MIs[0] policy
     /* 1725326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725336 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725360 */     // GIR_Coverage, 10639,
     /* 1725360 */     GIR_EraseRootFromParent_Done,
     /* 1725361 */   // Label 23582: @1725361
     /* 1725361 */   GIM_Try, /*On fail goto*//*Label 23583*/ GIMT_Encode4(1725447), // Rule ID 10642 //
     /* 1725366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1725377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1725380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1725383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1725386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725412 */     // MIs[0] policy
     /* 1725412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725422 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725446 */     // GIR_Coverage, 10642,
     /* 1725446 */     GIR_EraseRootFromParent_Done,
     /* 1725447 */   // Label 23583: @1725447
     /* 1725447 */   GIM_Try, /*On fail goto*//*Label 23584*/ GIMT_Encode4(1725533), // Rule ID 10643 //
     /* 1725452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1725463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1725466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1725469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1725472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725498 */     // MIs[0] policy
     /* 1725498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725508 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725532 */     // GIR_Coverage, 10643,
     /* 1725532 */     GIR_EraseRootFromParent_Done,
     /* 1725533 */   // Label 23584: @1725533
     /* 1725533 */   GIM_Try, /*On fail goto*//*Label 23585*/ GIMT_Encode4(1725619), // Rule ID 10646 //
     /* 1725538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1725549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1725552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1725555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1725558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725584 */     // MIs[0] policy
     /* 1725584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725594 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725618 */     // GIR_Coverage, 10646,
     /* 1725618 */     GIR_EraseRootFromParent_Done,
     /* 1725619 */   // Label 23585: @1725619
     /* 1725619 */   GIM_Try, /*On fail goto*//*Label 23586*/ GIMT_Encode4(1725705), // Rule ID 10647 //
     /* 1725624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1725635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1725638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1725641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1725644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725670 */     // MIs[0] policy
     /* 1725670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725680 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725704 */     // GIR_Coverage, 10647,
     /* 1725704 */     GIR_EraseRootFromParent_Done,
     /* 1725705 */   // Label 23586: @1725705
     /* 1725705 */   GIM_Try, /*On fail goto*//*Label 23587*/ GIMT_Encode4(1725791), // Rule ID 10650 //
     /* 1725710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1725713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1725721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1725724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1725727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1725730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725756 */     // MIs[0] policy
     /* 1725756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725766 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725790 */     // GIR_Coverage, 10650,
     /* 1725790 */     GIR_EraseRootFromParent_Done,
     /* 1725791 */   // Label 23587: @1725791
     /* 1725791 */   GIM_Try, /*On fail goto*//*Label 23588*/ GIMT_Encode4(1725877), // Rule ID 10651 //
     /* 1725796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1725799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1725807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1725810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1725813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1725816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725842 */     // MIs[0] policy
     /* 1725842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725876 */     // GIR_Coverage, 10651,
     /* 1725876 */     GIR_EraseRootFromParent_Done,
     /* 1725877 */   // Label 23588: @1725877
     /* 1725877 */   GIM_Try, /*On fail goto*//*Label 23589*/ GIMT_Encode4(1725963), // Rule ID 10654 //
     /* 1725882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1725893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1725896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1725899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1725902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1725905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1725912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725928 */     // MIs[0] policy
     /* 1725928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725938 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1725941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725962 */     // GIR_Coverage, 10654,
     /* 1725962 */     GIR_EraseRootFromParent_Done,
     /* 1725963 */   // Label 23589: @1725963
     /* 1725963 */   GIM_Try, /*On fail goto*//*Label 23590*/ GIMT_Encode4(1726049), // Rule ID 10655 //
     /* 1725968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1725979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1725982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1725985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1725988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1725991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1725998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726014 */     // MIs[0] policy
     /* 1726014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726024 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726048 */     // GIR_Coverage, 10655,
     /* 1726048 */     GIR_EraseRootFromParent_Done,
     /* 1726049 */   // Label 23590: @1726049
     /* 1726049 */   GIM_Try, /*On fail goto*//*Label 23591*/ GIMT_Encode4(1726135), // Rule ID 10658 //
     /* 1726054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1726065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1726068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1726071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1726074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726100 */     // MIs[0] policy
     /* 1726100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726110 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1726113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726134 */     // GIR_Coverage, 10658,
     /* 1726134 */     GIR_EraseRootFromParent_Done,
     /* 1726135 */   // Label 23591: @1726135
     /* 1726135 */   GIM_Try, /*On fail goto*//*Label 23592*/ GIMT_Encode4(1726221), // Rule ID 10659 //
     /* 1726140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1726151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1726154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1726157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1726160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726186 */     // MIs[0] policy
     /* 1726186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726196 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1726199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726220 */     // GIR_Coverage, 10659,
     /* 1726220 */     GIR_EraseRootFromParent_Done,
     /* 1726221 */   // Label 23592: @1726221
     /* 1726221 */   GIM_Try, /*On fail goto*//*Label 23593*/ GIMT_Encode4(1726307), // Rule ID 10662 //
     /* 1726226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1726237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1726240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1726243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1726246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1726249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726272 */     // MIs[0] policy
     /* 1726272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726282 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1726285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726306 */     // GIR_Coverage, 10662,
     /* 1726306 */     GIR_EraseRootFromParent_Done,
     /* 1726307 */   // Label 23593: @1726307
     /* 1726307 */   GIM_Try, /*On fail goto*//*Label 23594*/ GIMT_Encode4(1726393), // Rule ID 10663 //
     /* 1726312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1726323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1726326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1726329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1726332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1726335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726358 */     // MIs[0] policy
     /* 1726358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726368 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1726371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726392 */     // GIR_Coverage, 10663,
     /* 1726392 */     GIR_EraseRootFromParent_Done,
     /* 1726393 */   // Label 23594: @1726393
     /* 1726393 */   GIM_Try, /*On fail goto*//*Label 23595*/ GIMT_Encode4(1726479), // Rule ID 10666 //
     /* 1726398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1726409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1726412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1726415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1726418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726444 */     // MIs[0] policy
     /* 1726444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726454 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726478 */     // GIR_Coverage, 10666,
     /* 1726478 */     GIR_EraseRootFromParent_Done,
     /* 1726479 */   // Label 23595: @1726479
     /* 1726479 */   GIM_Try, /*On fail goto*//*Label 23596*/ GIMT_Encode4(1726565), // Rule ID 10667 //
     /* 1726484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1726495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1726498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1726501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1726504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726530 */     // MIs[0] policy
     /* 1726530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726540 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726564 */     // GIR_Coverage, 10667,
     /* 1726564 */     GIR_EraseRootFromParent_Done,
     /* 1726565 */   // Label 23596: @1726565
     /* 1726565 */   GIM_Try, /*On fail goto*//*Label 23597*/ GIMT_Encode4(1726651), // Rule ID 10670 //
     /* 1726570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1726581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1726584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1726587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1726590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1726593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726616 */     // MIs[0] policy
     /* 1726616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1726629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726650 */     // GIR_Coverage, 10670,
     /* 1726650 */     GIR_EraseRootFromParent_Done,
     /* 1726651 */   // Label 23597: @1726651
     /* 1726651 */   GIM_Try, /*On fail goto*//*Label 23598*/ GIMT_Encode4(1726737), // Rule ID 10671 //
     /* 1726656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1726667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1726670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1726673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1726676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1726679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726702 */     // MIs[0] policy
     /* 1726702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726712 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1726715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726736 */     // GIR_Coverage, 10671,
     /* 1726736 */     GIR_EraseRootFromParent_Done,
     /* 1726737 */   // Label 23598: @1726737
     /* 1726737 */   GIM_Try, /*On fail goto*//*Label 23599*/ GIMT_Encode4(1726823), // Rule ID 10674 //
     /* 1726742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1726753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1726756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1726759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1726762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726788 */     // MIs[0] policy
     /* 1726788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726798 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1726801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726822 */     // GIR_Coverage, 10674,
     /* 1726822 */     GIR_EraseRootFromParent_Done,
     /* 1726823 */   // Label 23599: @1726823
     /* 1726823 */   GIM_Try, /*On fail goto*//*Label 23600*/ GIMT_Encode4(1726909), // Rule ID 10675 //
     /* 1726828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1726839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1726842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1726845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1726848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726874 */     // MIs[0] policy
     /* 1726874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726884 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1726887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726908 */     // GIR_Coverage, 10675,
     /* 1726908 */     GIR_EraseRootFromParent_Done,
     /* 1726909 */   // Label 23600: @1726909
     /* 1726909 */   GIM_Try, /*On fail goto*//*Label 23601*/ GIMT_Encode4(1726995), // Rule ID 10678 //
     /* 1726914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1726925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1726928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1726931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1726934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1726937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726960 */     // MIs[0] policy
     /* 1726960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726970 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1726991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726994 */     // GIR_Coverage, 10678,
     /* 1726994 */     GIR_EraseRootFromParent_Done,
     /* 1726995 */   // Label 23601: @1726995
     /* 1726995 */   GIM_Try, /*On fail goto*//*Label 23602*/ GIMT_Encode4(1727081), // Rule ID 10679 //
     /* 1727000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1727011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1727014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1727017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1727020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727046 */     // MIs[0] policy
     /* 1727046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1727059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727080 */     // GIR_Coverage, 10679,
     /* 1727080 */     GIR_EraseRootFromParent_Done,
     /* 1727081 */   // Label 23602: @1727081
     /* 1727081 */   GIM_Try, /*On fail goto*//*Label 23603*/ GIMT_Encode4(1727167), // Rule ID 10682 //
     /* 1727086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1727097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1727100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1727103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1727106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727132 */     // MIs[0] policy
     /* 1727132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727142 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727166 */     // GIR_Coverage, 10682,
     /* 1727166 */     GIR_EraseRootFromParent_Done,
     /* 1727167 */   // Label 23603: @1727167
     /* 1727167 */   GIM_Try, /*On fail goto*//*Label 23604*/ GIMT_Encode4(1727253), // Rule ID 10683 //
     /* 1727172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1727183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1727186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1727189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1727192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727218 */     // MIs[0] policy
     /* 1727218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727228 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727252 */     // GIR_Coverage, 10683,
     /* 1727252 */     GIR_EraseRootFromParent_Done,
     /* 1727253 */   // Label 23604: @1727253
     /* 1727253 */   GIM_Try, /*On fail goto*//*Label 23605*/ GIMT_Encode4(1727339), // Rule ID 10686 //
     /* 1727258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1727269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1727272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1727275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1727278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727304 */     // MIs[0] policy
     /* 1727304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727314 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727338 */     // GIR_Coverage, 10686,
     /* 1727338 */     GIR_EraseRootFromParent_Done,
     /* 1727339 */   // Label 23605: @1727339
     /* 1727339 */   GIM_Try, /*On fail goto*//*Label 23606*/ GIMT_Encode4(1727425), // Rule ID 10687 //
     /* 1727344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1727355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1727358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1727361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1727364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727390 */     // MIs[0] policy
     /* 1727390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727424 */     // GIR_Coverage, 10687,
     /* 1727424 */     GIR_EraseRootFromParent_Done,
     /* 1727425 */   // Label 23606: @1727425
     /* 1727425 */   GIM_Try, /*On fail goto*//*Label 23607*/ GIMT_Encode4(1727511), // Rule ID 10690 //
     /* 1727430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1727433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1727441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1727444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1727447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1727450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1727453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727476 */     // MIs[0] policy
     /* 1727476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1727489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727510 */     // GIR_Coverage, 10690,
     /* 1727510 */     GIR_EraseRootFromParent_Done,
     /* 1727511 */   // Label 23607: @1727511
     /* 1727511 */   GIM_Try, /*On fail goto*//*Label 23608*/ GIMT_Encode4(1727597), // Rule ID 10691 //
     /* 1727516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1727519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1727527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1727530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1727533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1727536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1727539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727562 */     // MIs[0] policy
     /* 1727562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727572 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1727575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727596 */     // GIR_Coverage, 10691,
     /* 1727596 */     GIR_EraseRootFromParent_Done,
     /* 1727597 */   // Label 23608: @1727597
     /* 1727597 */   GIM_Try, /*On fail goto*//*Label 23609*/ GIMT_Encode4(1727683), // Rule ID 10694 //
     /* 1727602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1727605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1727613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1727616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1727619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1727622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727648 */     // MIs[0] policy
     /* 1727648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727658 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727682 */     // GIR_Coverage, 10694,
     /* 1727682 */     GIR_EraseRootFromParent_Done,
     /* 1727683 */   // Label 23609: @1727683
     /* 1727683 */   GIM_Try, /*On fail goto*//*Label 23610*/ GIMT_Encode4(1727769), // Rule ID 10695 //
     /* 1727688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1727691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1727699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1727702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1727705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1727708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727734 */     // MIs[0] policy
     /* 1727734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727744 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727768 */     // GIR_Coverage, 10695,
     /* 1727768 */     GIR_EraseRootFromParent_Done,
     /* 1727769 */   // Label 23610: @1727769
     /* 1727769 */   GIM_Try, /*On fail goto*//*Label 23611*/ GIMT_Encode4(1727855), // Rule ID 10698 //
     /* 1727774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1727777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1727785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1727788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1727791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1727794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727820 */     // MIs[0] policy
     /* 1727820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727830 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727854 */     // GIR_Coverage, 10698,
     /* 1727854 */     GIR_EraseRootFromParent_Done,
     /* 1727855 */   // Label 23611: @1727855
     /* 1727855 */   GIM_Try, /*On fail goto*//*Label 23612*/ GIMT_Encode4(1727941), // Rule ID 10699 //
     /* 1727860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1727863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1727871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1727874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1727877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1727880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727906 */     // MIs[0] policy
     /* 1727906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727916 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727940 */     // GIR_Coverage, 10699,
     /* 1727940 */     GIR_EraseRootFromParent_Done,
     /* 1727941 */   // Label 23612: @1727941
     /* 1727941 */   GIM_Try, /*On fail goto*//*Label 23613*/ GIMT_Encode4(1728027), // Rule ID 10702 //
     /* 1727946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1727957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1727960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1727963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1727966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1727969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727992 */     // MIs[0] policy
     /* 1727992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728002 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1728005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728026 */     // GIR_Coverage, 10702,
     /* 1728026 */     GIR_EraseRootFromParent_Done,
     /* 1728027 */   // Label 23613: @1728027
     /* 1728027 */   GIM_Try, /*On fail goto*//*Label 23614*/ GIMT_Encode4(1728113), // Rule ID 10703 //
     /* 1728032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1728043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1728046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1728049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728078 */     // MIs[0] policy
     /* 1728078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728088 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1728091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728112 */     // GIR_Coverage, 10703,
     /* 1728112 */     GIR_EraseRootFromParent_Done,
     /* 1728113 */   // Label 23614: @1728113
     /* 1728113 */   GIM_Try, /*On fail goto*//*Label 23615*/ GIMT_Encode4(1728199), // Rule ID 10706 //
     /* 1728118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1728129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1728132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1728135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728164 */     // MIs[0] policy
     /* 1728164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728174 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728198 */     // GIR_Coverage, 10706,
     /* 1728198 */     GIR_EraseRootFromParent_Done,
     /* 1728199 */   // Label 23615: @1728199
     /* 1728199 */   GIM_Try, /*On fail goto*//*Label 23616*/ GIMT_Encode4(1728285), // Rule ID 10707 //
     /* 1728204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1728215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1728218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1728221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728250 */     // MIs[0] policy
     /* 1728250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728260 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728284 */     // GIR_Coverage, 10707,
     /* 1728284 */     GIR_EraseRootFromParent_Done,
     /* 1728285 */   // Label 23616: @1728285
     /* 1728285 */   GIM_Try, /*On fail goto*//*Label 23617*/ GIMT_Encode4(1728371), // Rule ID 10710 //
     /* 1728290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1728301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1728304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1728307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728336 */     // MIs[0] policy
     /* 1728336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728346 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728370 */     // GIR_Coverage, 10710,
     /* 1728370 */     GIR_EraseRootFromParent_Done,
     /* 1728371 */   // Label 23617: @1728371
     /* 1728371 */   GIM_Try, /*On fail goto*//*Label 23618*/ GIMT_Encode4(1728457), // Rule ID 10711 //
     /* 1728376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1728387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1728390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1728393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728422 */     // MIs[0] policy
     /* 1728422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728432 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728456 */     // GIR_Coverage, 10711,
     /* 1728456 */     GIR_EraseRootFromParent_Done,
     /* 1728457 */   // Label 23618: @1728457
     /* 1728457 */   GIM_Try, /*On fail goto*//*Label 23619*/ GIMT_Encode4(1728543), // Rule ID 10714 //
     /* 1728462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1728473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1728476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1728479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728508 */     // MIs[0] policy
     /* 1728508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728518 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728542 */     // GIR_Coverage, 10714,
     /* 1728542 */     GIR_EraseRootFromParent_Done,
     /* 1728543 */   // Label 23619: @1728543
     /* 1728543 */   GIM_Try, /*On fail goto*//*Label 23620*/ GIMT_Encode4(1728629), // Rule ID 10715 //
     /* 1728548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1728559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1728562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1728565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728594 */     // MIs[0] policy
     /* 1728594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728604 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728628 */     // GIR_Coverage, 10715,
     /* 1728628 */     GIR_EraseRootFromParent_Done,
     /* 1728629 */   // Label 23620: @1728629
     /* 1728629 */   GIM_Try, /*On fail goto*//*Label 23621*/ GIMT_Encode4(1728715), // Rule ID 10718 //
     /* 1728634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1728645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1728648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1728651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728680 */     // MIs[0] policy
     /* 1728680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728690 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728714 */     // GIR_Coverage, 10718,
     /* 1728714 */     GIR_EraseRootFromParent_Done,
     /* 1728715 */   // Label 23621: @1728715
     /* 1728715 */   GIM_Try, /*On fail goto*//*Label 23622*/ GIMT_Encode4(1728801), // Rule ID 10719 //
     /* 1728720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1728731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1728734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1728737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728766 */     // MIs[0] policy
     /* 1728766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728776 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728800 */     // GIR_Coverage, 10719,
     /* 1728800 */     GIR_EraseRootFromParent_Done,
     /* 1728801 */   // Label 23622: @1728801
     /* 1728801 */   GIM_Try, /*On fail goto*//*Label 23623*/ GIMT_Encode4(1728887), // Rule ID 10722 //
     /* 1728806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1728817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1728820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1728823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728852 */     // MIs[0] policy
     /* 1728852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728862 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728886 */     // GIR_Coverage, 10722,
     /* 1728886 */     GIR_EraseRootFromParent_Done,
     /* 1728887 */   // Label 23623: @1728887
     /* 1728887 */   GIM_Try, /*On fail goto*//*Label 23624*/ GIMT_Encode4(1728973), // Rule ID 10723 //
     /* 1728892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1728903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1728906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1728909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728938 */     // MIs[0] policy
     /* 1728938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728948 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728972 */     // GIR_Coverage, 10723,
     /* 1728972 */     GIR_EraseRootFromParent_Done,
     /* 1728973 */   // Label 23624: @1728973
     /* 1728973 */   GIM_Try, /*On fail goto*//*Label 23625*/ GIMT_Encode4(1729059), // Rule ID 10726 //
     /* 1728978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1728989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1728992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1728995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729024 */     // MIs[0] policy
     /* 1729024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729034 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729058 */     // GIR_Coverage, 10726,
     /* 1729058 */     GIR_EraseRootFromParent_Done,
     /* 1729059 */   // Label 23625: @1729059
     /* 1729059 */   GIM_Try, /*On fail goto*//*Label 23626*/ GIMT_Encode4(1729145), // Rule ID 10727 //
     /* 1729064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1729075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1729078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1729081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729110 */     // MIs[0] policy
     /* 1729110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729120 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729144 */     // GIR_Coverage, 10727,
     /* 1729144 */     GIR_EraseRootFromParent_Done,
     /* 1729145 */   // Label 23626: @1729145
     /* 1729145 */   GIM_Try, /*On fail goto*//*Label 23627*/ GIMT_Encode4(1729231), // Rule ID 10730 //
     /* 1729150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1729161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1729164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1729167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729196 */     // MIs[0] policy
     /* 1729196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729206 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729230 */     // GIR_Coverage, 10730,
     /* 1729230 */     GIR_EraseRootFromParent_Done,
     /* 1729231 */   // Label 23627: @1729231
     /* 1729231 */   GIM_Try, /*On fail goto*//*Label 23628*/ GIMT_Encode4(1729317), // Rule ID 10731 //
     /* 1729236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1729247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1729250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1729253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729282 */     // MIs[0] policy
     /* 1729282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729292 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729316 */     // GIR_Coverage, 10731,
     /* 1729316 */     GIR_EraseRootFromParent_Done,
     /* 1729317 */   // Label 23628: @1729317
     /* 1729317 */   GIM_Try, /*On fail goto*//*Label 23629*/ GIMT_Encode4(1729403), // Rule ID 10734 //
     /* 1729322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1729333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1729336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1729339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729368 */     // MIs[0] policy
     /* 1729368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729378 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729402 */     // GIR_Coverage, 10734,
     /* 1729402 */     GIR_EraseRootFromParent_Done,
     /* 1729403 */   // Label 23629: @1729403
     /* 1729403 */   GIM_Try, /*On fail goto*//*Label 23630*/ GIMT_Encode4(1729489), // Rule ID 10735 //
     /* 1729408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1729419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1729422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1729425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729454 */     // MIs[0] policy
     /* 1729454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729488 */     // GIR_Coverage, 10735,
     /* 1729488 */     GIR_EraseRootFromParent_Done,
     /* 1729489 */   // Label 23630: @1729489
     /* 1729489 */   GIM_Try, /*On fail goto*//*Label 23631*/ GIMT_Encode4(1729575), // Rule ID 10738 //
     /* 1729494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1729497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1729505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1729508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1729511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729540 */     // MIs[0] policy
     /* 1729540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729550 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729574 */     // GIR_Coverage, 10738,
     /* 1729574 */     GIR_EraseRootFromParent_Done,
     /* 1729575 */   // Label 23631: @1729575
     /* 1729575 */   GIM_Try, /*On fail goto*//*Label 23632*/ GIMT_Encode4(1729661), // Rule ID 10739 //
     /* 1729580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1729583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1729591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1729594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1729597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729626 */     // MIs[0] policy
     /* 1729626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729660 */     // GIR_Coverage, 10739,
     /* 1729660 */     GIR_EraseRootFromParent_Done,
     /* 1729661 */   // Label 23632: @1729661
     /* 1729661 */   GIM_Try, /*On fail goto*//*Label 23633*/ GIMT_Encode4(1729747), // Rule ID 10742 //
     /* 1729666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1729677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1729680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1729683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1729689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1729696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729712 */     // MIs[0] policy
     /* 1729712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729722 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1729725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729746 */     // GIR_Coverage, 10742,
     /* 1729746 */     GIR_EraseRootFromParent_Done,
     /* 1729747 */   // Label 23633: @1729747
     /* 1729747 */   GIM_Try, /*On fail goto*//*Label 23634*/ GIMT_Encode4(1729833), // Rule ID 10743 //
     /* 1729752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1729763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1729766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1729769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1729775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1729782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729798 */     // MIs[0] policy
     /* 1729798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729808 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1729811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729832 */     // GIR_Coverage, 10743,
     /* 1729832 */     GIR_EraseRootFromParent_Done,
     /* 1729833 */   // Label 23634: @1729833
     /* 1729833 */   GIM_Try, /*On fail goto*//*Label 23635*/ GIMT_Encode4(1729919), // Rule ID 10746 //
     /* 1729838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1729849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1729852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1729855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1729861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1729868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729884 */     // MIs[0] policy
     /* 1729884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729894 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1729897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729918 */     // GIR_Coverage, 10746,
     /* 1729918 */     GIR_EraseRootFromParent_Done,
     /* 1729919 */   // Label 23635: @1729919
     /* 1729919 */   GIM_Try, /*On fail goto*//*Label 23636*/ GIMT_Encode4(1730005), // Rule ID 10747 //
     /* 1729924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1729935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1729938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1729941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1729947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1729954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729970 */     // MIs[0] policy
     /* 1729970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729980 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1729983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730004 */     // GIR_Coverage, 10747,
     /* 1730004 */     GIR_EraseRootFromParent_Done,
     /* 1730005 */   // Label 23636: @1730005
     /* 1730005 */   GIM_Try, /*On fail goto*//*Label 23637*/ GIMT_Encode4(1730091), // Rule ID 10750 //
     /* 1730010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1730021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1730024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1730027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1730033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730056 */     // MIs[0] policy
     /* 1730056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730066 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1730069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730090 */     // GIR_Coverage, 10750,
     /* 1730090 */     GIR_EraseRootFromParent_Done,
     /* 1730091 */   // Label 23637: @1730091
     /* 1730091 */   GIM_Try, /*On fail goto*//*Label 23638*/ GIMT_Encode4(1730177), // Rule ID 10751 //
     /* 1730096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1730107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1730110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1730113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1730119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730142 */     // MIs[0] policy
     /* 1730142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730152 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1730155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730176 */     // GIR_Coverage, 10751,
     /* 1730176 */     GIR_EraseRootFromParent_Done,
     /* 1730177 */   // Label 23638: @1730177
     /* 1730177 */   GIM_Try, /*On fail goto*//*Label 23639*/ GIMT_Encode4(1730263), // Rule ID 10754 //
     /* 1730182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1730193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1730196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1730199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730228 */     // MIs[0] policy
     /* 1730228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730238 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730262 */     // GIR_Coverage, 10754,
     /* 1730262 */     GIR_EraseRootFromParent_Done,
     /* 1730263 */   // Label 23639: @1730263
     /* 1730263 */   GIM_Try, /*On fail goto*//*Label 23640*/ GIMT_Encode4(1730349), // Rule ID 10755 //
     /* 1730268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1730279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1730282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1730285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730314 */     // MIs[0] policy
     /* 1730314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730348 */     // GIR_Coverage, 10755,
     /* 1730348 */     GIR_EraseRootFromParent_Done,
     /* 1730349 */   // Label 23640: @1730349
     /* 1730349 */   GIM_Try, /*On fail goto*//*Label 23641*/ GIMT_Encode4(1730435), // Rule ID 10758 //
     /* 1730354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1730365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1730368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1730371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730400 */     // MIs[0] policy
     /* 1730400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730410 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730434 */     // GIR_Coverage, 10758,
     /* 1730434 */     GIR_EraseRootFromParent_Done,
     /* 1730435 */   // Label 23641: @1730435
     /* 1730435 */   GIM_Try, /*On fail goto*//*Label 23642*/ GIMT_Encode4(1730521), // Rule ID 10759 //
     /* 1730440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1730451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1730454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1730457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730486 */     // MIs[0] policy
     /* 1730486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730520 */     // GIR_Coverage, 10759,
     /* 1730520 */     GIR_EraseRootFromParent_Done,
     /* 1730521 */   // Label 23642: @1730521
     /* 1730521 */   GIM_Try, /*On fail goto*//*Label 23643*/ GIMT_Encode4(1730607), // Rule ID 10762 //
     /* 1730526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1730537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1730540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1730543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1730549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730572 */     // MIs[0] policy
     /* 1730572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730582 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1730585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730606 */     // GIR_Coverage, 10762,
     /* 1730606 */     GIR_EraseRootFromParent_Done,
     /* 1730607 */   // Label 23643: @1730607
     /* 1730607 */   GIM_Try, /*On fail goto*//*Label 23644*/ GIMT_Encode4(1730693), // Rule ID 10763 //
     /* 1730612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1730623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1730626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1730629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1730635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730658 */     // MIs[0] policy
     /* 1730658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730668 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1730671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730692 */     // GIR_Coverage, 10763,
     /* 1730692 */     GIR_EraseRootFromParent_Done,
     /* 1730693 */   // Label 23644: @1730693
     /* 1730693 */   GIM_Try, /*On fail goto*//*Label 23645*/ GIMT_Encode4(1730779), // Rule ID 10766 //
     /* 1730698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1730709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1730712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1730715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1730721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730744 */     // MIs[0] policy
     /* 1730744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730778 */     // GIR_Coverage, 10766,
     /* 1730778 */     GIR_EraseRootFromParent_Done,
     /* 1730779 */   // Label 23645: @1730779
     /* 1730779 */   GIM_Try, /*On fail goto*//*Label 23646*/ GIMT_Encode4(1730865), // Rule ID 10767 //
     /* 1730784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1730795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1730798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1730801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1730807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730830 */     // MIs[0] policy
     /* 1730830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730864 */     // GIR_Coverage, 10767,
     /* 1730864 */     GIR_EraseRootFromParent_Done,
     /* 1730865 */   // Label 23646: @1730865
     /* 1730865 */   GIM_Try, /*On fail goto*//*Label 23647*/ GIMT_Encode4(1730951), // Rule ID 10770 //
     /* 1730870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1730881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1730884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1730887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730916 */     // MIs[0] policy
     /* 1730916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730950 */     // GIR_Coverage, 10770,
     /* 1730950 */     GIR_EraseRootFromParent_Done,
     /* 1730951 */   // Label 23647: @1730951
     /* 1730951 */   GIM_Try, /*On fail goto*//*Label 23648*/ GIMT_Encode4(1731037), // Rule ID 10771 //
     /* 1730956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1730967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1730970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1730973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731002 */     // MIs[0] policy
     /* 1731002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731012 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731036 */     // GIR_Coverage, 10771,
     /* 1731036 */     GIR_EraseRootFromParent_Done,
     /* 1731037 */   // Label 23648: @1731037
     /* 1731037 */   GIM_Try, /*On fail goto*//*Label 23649*/ GIMT_Encode4(1731123), // Rule ID 10774 //
     /* 1731042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1731053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1731056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1731059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731088 */     // MIs[0] policy
     /* 1731088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731098 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731122 */     // GIR_Coverage, 10774,
     /* 1731122 */     GIR_EraseRootFromParent_Done,
     /* 1731123 */   // Label 23649: @1731123
     /* 1731123 */   GIM_Try, /*On fail goto*//*Label 23650*/ GIMT_Encode4(1731209), // Rule ID 10775 //
     /* 1731128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1731139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1731142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1731145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731174 */     // MIs[0] policy
     /* 1731174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731184 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731208 */     // GIR_Coverage, 10775,
     /* 1731208 */     GIR_EraseRootFromParent_Done,
     /* 1731209 */   // Label 23650: @1731209
     /* 1731209 */   GIM_Try, /*On fail goto*//*Label 23651*/ GIMT_Encode4(1731295), // Rule ID 10778 //
     /* 1731214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1731225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1731228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1731231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731260 */     // MIs[0] policy
     /* 1731260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731270 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1731273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731294 */     // GIR_Coverage, 10778,
     /* 1731294 */     GIR_EraseRootFromParent_Done,
     /* 1731295 */   // Label 23651: @1731295
     /* 1731295 */   GIM_Try, /*On fail goto*//*Label 23652*/ GIMT_Encode4(1731381), // Rule ID 10779 //
     /* 1731300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1731311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1731314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1731317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731346 */     // MIs[0] policy
     /* 1731346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731356 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1731359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731380 */     // GIR_Coverage, 10779,
     /* 1731380 */     GIR_EraseRootFromParent_Done,
     /* 1731381 */   // Label 23652: @1731381
     /* 1731381 */   GIM_Try, /*On fail goto*//*Label 23653*/ GIMT_Encode4(1731467), // Rule ID 10782 //
     /* 1731386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1731397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1731400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1731403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731432 */     // MIs[0] policy
     /* 1731432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731442 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731466 */     // GIR_Coverage, 10782,
     /* 1731466 */     GIR_EraseRootFromParent_Done,
     /* 1731467 */   // Label 23653: @1731467
     /* 1731467 */   GIM_Try, /*On fail goto*//*Label 23654*/ GIMT_Encode4(1731553), // Rule ID 10783 //
     /* 1731472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1731483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1731486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1731489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731518 */     // MIs[0] policy
     /* 1731518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731528 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731552 */     // GIR_Coverage, 10783,
     /* 1731552 */     GIR_EraseRootFromParent_Done,
     /* 1731553 */   // Label 23654: @1731553
     /* 1731553 */   GIM_Try, /*On fail goto*//*Label 23655*/ GIMT_Encode4(1731639), // Rule ID 10786 //
     /* 1731558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1731569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1731572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1731575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731604 */     // MIs[0] policy
     /* 1731604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731614 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731638 */     // GIR_Coverage, 10786,
     /* 1731638 */     GIR_EraseRootFromParent_Done,
     /* 1731639 */   // Label 23655: @1731639
     /* 1731639 */   GIM_Try, /*On fail goto*//*Label 23656*/ GIMT_Encode4(1731725), // Rule ID 10787 //
     /* 1731644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1731655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1731658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1731661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731690 */     // MIs[0] policy
     /* 1731690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731700 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11431:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731724 */     // GIR_Coverage, 10787,
     /* 1731724 */     GIR_EraseRootFromParent_Done,
     /* 1731725 */   // Label 23656: @1731725
     /* 1731725 */   GIM_Try, /*On fail goto*//*Label 23657*/ GIMT_Encode4(1731811), // Rule ID 10790 //
     /* 1731730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1731741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1731744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1731747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1731750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1731753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731776 */     // MIs[0] policy
     /* 1731776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731786 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1731789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731810 */     // GIR_Coverage, 10790,
     /* 1731810 */     GIR_EraseRootFromParent_Done,
     /* 1731811 */   // Label 23657: @1731811
     /* 1731811 */   GIM_Try, /*On fail goto*//*Label 23658*/ GIMT_Encode4(1731897), // Rule ID 10791 //
     /* 1731816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1731827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1731830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1731833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1731836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1731839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731862 */     // MIs[0] policy
     /* 1731862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731872 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1731875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731896 */     // GIR_Coverage, 10791,
     /* 1731896 */     GIR_EraseRootFromParent_Done,
     /* 1731897 */   // Label 23658: @1731897
     /* 1731897 */   GIM_Try, /*On fail goto*//*Label 23659*/ GIMT_Encode4(1731983), // Rule ID 10794 //
     /* 1731902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1731913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1731916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1731919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1731922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731948 */     // MIs[0] policy
     /* 1731948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731958 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1731961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731982 */     // GIR_Coverage, 10794,
     /* 1731982 */     GIR_EraseRootFromParent_Done,
     /* 1731983 */   // Label 23659: @1731983
     /* 1731983 */   GIM_Try, /*On fail goto*//*Label 23660*/ GIMT_Encode4(1732069), // Rule ID 10795 //
     /* 1731988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1731999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1732002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1732005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1732008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732034 */     // MIs[0] policy
     /* 1732034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732044 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732068 */     // GIR_Coverage, 10795,
     /* 1732068 */     GIR_EraseRootFromParent_Done,
     /* 1732069 */   // Label 23660: @1732069
     /* 1732069 */   GIM_Try, /*On fail goto*//*Label 23661*/ GIMT_Encode4(1732155), // Rule ID 10798 //
     /* 1732074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1732085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1732088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1732091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1732094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732120 */     // MIs[0] policy
     /* 1732120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732130 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732154 */     // GIR_Coverage, 10798,
     /* 1732154 */     GIR_EraseRootFromParent_Done,
     /* 1732155 */   // Label 23661: @1732155
     /* 1732155 */   GIM_Try, /*On fail goto*//*Label 23662*/ GIMT_Encode4(1732241), // Rule ID 10799 //
     /* 1732160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1732171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1732174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1732177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1732180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732206 */     // MIs[0] policy
     /* 1732206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732216 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732240 */     // GIR_Coverage, 10799,
     /* 1732240 */     GIR_EraseRootFromParent_Done,
     /* 1732241 */   // Label 23662: @1732241
     /* 1732241 */   GIM_Try, /*On fail goto*//*Label 23663*/ GIMT_Encode4(1732327), // Rule ID 10802 //
     /* 1732246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1732257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1732260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1732263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1732266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732292 */     // MIs[0] policy
     /* 1732292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732302 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732326 */     // GIR_Coverage, 10802,
     /* 1732326 */     GIR_EraseRootFromParent_Done,
     /* 1732327 */   // Label 23663: @1732327
     /* 1732327 */   GIM_Try, /*On fail goto*//*Label 23664*/ GIMT_Encode4(1732413), // Rule ID 10803 //
     /* 1732332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1732343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1732346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1732349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1732352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732378 */     // MIs[0] policy
     /* 1732378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732388 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732412 */     // GIR_Coverage, 10803,
     /* 1732412 */     GIR_EraseRootFromParent_Done,
     /* 1732413 */   // Label 23664: @1732413
     /* 1732413 */   GIM_Try, /*On fail goto*//*Label 23665*/ GIMT_Encode4(1732499), // Rule ID 10806 //
     /* 1732418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1732429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1732432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1732435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1732438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732464 */     // MIs[0] policy
     /* 1732464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732474 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732498 */     // GIR_Coverage, 10806,
     /* 1732498 */     GIR_EraseRootFromParent_Done,
     /* 1732499 */   // Label 23665: @1732499
     /* 1732499 */   GIM_Try, /*On fail goto*//*Label 23666*/ GIMT_Encode4(1732585), // Rule ID 10807 //
     /* 1732504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1732515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1732518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1732521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1732524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732550 */     // MIs[0] policy
     /* 1732550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732560 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732584 */     // GIR_Coverage, 10807,
     /* 1732584 */     GIR_EraseRootFromParent_Done,
     /* 1732585 */   // Label 23666: @1732585
     /* 1732585 */   GIM_Try, /*On fail goto*//*Label 23667*/ GIMT_Encode4(1732671), // Rule ID 10810 //
     /* 1732590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1732601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1732604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1732607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1732610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732636 */     // MIs[0] policy
     /* 1732636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732670 */     // GIR_Coverage, 10810,
     /* 1732670 */     GIR_EraseRootFromParent_Done,
     /* 1732671 */   // Label 23667: @1732671
     /* 1732671 */   GIM_Try, /*On fail goto*//*Label 23668*/ GIMT_Encode4(1732757), // Rule ID 10811 //
     /* 1732676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1732687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1732690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1732693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1732696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732722 */     // MIs[0] policy
     /* 1732722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732756 */     // GIR_Coverage, 10811,
     /* 1732756 */     GIR_EraseRootFromParent_Done,
     /* 1732757 */   // Label 23668: @1732757
     /* 1732757 */   GIM_Try, /*On fail goto*//*Label 23669*/ GIMT_Encode4(1732843), // Rule ID 10814 //
     /* 1732762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1732773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1732776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1732779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1732782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732808 */     // MIs[0] policy
     /* 1732808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1732821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732842 */     // GIR_Coverage, 10814,
     /* 1732842 */     GIR_EraseRootFromParent_Done,
     /* 1732843 */   // Label 23669: @1732843
     /* 1732843 */   GIM_Try, /*On fail goto*//*Label 23670*/ GIMT_Encode4(1732929), // Rule ID 10815 //
     /* 1732848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1732859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1732862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1732865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1732868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732894 */     // MIs[0] policy
     /* 1732894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732904 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1732907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732928 */     // GIR_Coverage, 10815,
     /* 1732928 */     GIR_EraseRootFromParent_Done,
     /* 1732929 */   // Label 23670: @1732929
     /* 1732929 */   GIM_Try, /*On fail goto*//*Label 23671*/ GIMT_Encode4(1733015), // Rule ID 10818 //
     /* 1732934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1732945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1732948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1732951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1732954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732980 */     // MIs[0] policy
     /* 1732980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732990 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1732993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733014 */     // GIR_Coverage, 10818,
     /* 1733014 */     GIR_EraseRootFromParent_Done,
     /* 1733015 */   // Label 23671: @1733015
     /* 1733015 */   GIM_Try, /*On fail goto*//*Label 23672*/ GIMT_Encode4(1733101), // Rule ID 10819 //
     /* 1733020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1733031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1733034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1733037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1733040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733066 */     // MIs[0] policy
     /* 1733066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733076 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733100 */     // GIR_Coverage, 10819,
     /* 1733100 */     GIR_EraseRootFromParent_Done,
     /* 1733101 */   // Label 23672: @1733101
     /* 1733101 */   GIM_Try, /*On fail goto*//*Label 23673*/ GIMT_Encode4(1733187), // Rule ID 10822 //
     /* 1733106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1733117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1733120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1733123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1733126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733152 */     // MIs[0] policy
     /* 1733152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733162 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733186 */     // GIR_Coverage, 10822,
     /* 1733186 */     GIR_EraseRootFromParent_Done,
     /* 1733187 */   // Label 23673: @1733187
     /* 1733187 */   GIM_Try, /*On fail goto*//*Label 23674*/ GIMT_Encode4(1733273), // Rule ID 10823 //
     /* 1733192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1733203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1733206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1733209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1733212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733238 */     // MIs[0] policy
     /* 1733238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733248 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733272 */     // GIR_Coverage, 10823,
     /* 1733272 */     GIR_EraseRootFromParent_Done,
     /* 1733273 */   // Label 23674: @1733273
     /* 1733273 */   GIM_Try, /*On fail goto*//*Label 23675*/ GIMT_Encode4(1733359), // Rule ID 10826 //
     /* 1733278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1733281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1733289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1733292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1733295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1733298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733324 */     // MIs[0] policy
     /* 1733324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733334 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733358 */     // GIR_Coverage, 10826,
     /* 1733358 */     GIR_EraseRootFromParent_Done,
     /* 1733359 */   // Label 23675: @1733359
     /* 1733359 */   GIM_Try, /*On fail goto*//*Label 23676*/ GIMT_Encode4(1733445), // Rule ID 10827 //
     /* 1733364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1733367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1733375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1733378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1733381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1733384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733410 */     // MIs[0] policy
     /* 1733410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733444 */     // GIR_Coverage, 10827,
     /* 1733444 */     GIR_EraseRootFromParent_Done,
     /* 1733445 */   // Label 23676: @1733445
     /* 1733445 */   GIM_Try, /*On fail goto*//*Label 23677*/ GIMT_Encode4(1733531), // Rule ID 10830 //
     /* 1733450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1733461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1733464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1733467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1733470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1733473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1733480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733496 */     // MIs[0] policy
     /* 1733496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733506 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1733509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733530 */     // GIR_Coverage, 10830,
     /* 1733530 */     GIR_EraseRootFromParent_Done,
     /* 1733531 */   // Label 23677: @1733531
     /* 1733531 */   GIM_Try, /*On fail goto*//*Label 23678*/ GIMT_Encode4(1733617), // Rule ID 10831 //
     /* 1733536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1733547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1733550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1733553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1733556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1733559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1733566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733582 */     // MIs[0] policy
     /* 1733582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1733595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733616 */     // GIR_Coverage, 10831,
     /* 1733616 */     GIR_EraseRootFromParent_Done,
     /* 1733617 */   // Label 23678: @1733617
     /* 1733617 */   GIM_Try, /*On fail goto*//*Label 23679*/ GIMT_Encode4(1733703), // Rule ID 10834 //
     /* 1733622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1733633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1733636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1733639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1733642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1733645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1733652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733668 */     // MIs[0] policy
     /* 1733668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733678 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1733681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733702 */     // GIR_Coverage, 10834,
     /* 1733702 */     GIR_EraseRootFromParent_Done,
     /* 1733703 */   // Label 23679: @1733703
     /* 1733703 */   GIM_Try, /*On fail goto*//*Label 23680*/ GIMT_Encode4(1733789), // Rule ID 10835 //
     /* 1733708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1733719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1733722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1733725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1733728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1733731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1733738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733754 */     // MIs[0] policy
     /* 1733754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733764 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1733767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733788 */     // GIR_Coverage, 10835,
     /* 1733788 */     GIR_EraseRootFromParent_Done,
     /* 1733789 */   // Label 23680: @1733789
     /* 1733789 */   GIM_Try, /*On fail goto*//*Label 23681*/ GIMT_Encode4(1733875), // Rule ID 10838 //
     /* 1733794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1733805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1733808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1733811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1733814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1733817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1733824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733840 */     // MIs[0] policy
     /* 1733840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733850 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1733853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733874 */     // GIR_Coverage, 10838,
     /* 1733874 */     GIR_EraseRootFromParent_Done,
     /* 1733875 */   // Label 23681: @1733875
     /* 1733875 */   GIM_Try, /*On fail goto*//*Label 23682*/ GIMT_Encode4(1733961), // Rule ID 10839 //
     /* 1733880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1733891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1733894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1733897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1733900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1733903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1733910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733926 */     // MIs[0] policy
     /* 1733926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733936 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1733939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733960 */     // GIR_Coverage, 10839,
     /* 1733960 */     GIR_EraseRootFromParent_Done,
     /* 1733961 */   // Label 23682: @1733961
     /* 1733961 */   GIM_Try, /*On fail goto*//*Label 23683*/ GIMT_Encode4(1734047), // Rule ID 10842 //
     /* 1733966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1733977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1733980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1733983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1733986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1733989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1733996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734012 */     // MIs[0] policy
     /* 1734012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734046 */     // GIR_Coverage, 10842,
     /* 1734046 */     GIR_EraseRootFromParent_Done,
     /* 1734047 */   // Label 23683: @1734047
     /* 1734047 */   GIM_Try, /*On fail goto*//*Label 23684*/ GIMT_Encode4(1734133), // Rule ID 10843 //
     /* 1734052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1734063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1734066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1734069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1734072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734098 */     // MIs[0] policy
     /* 1734098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734108 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734132 */     // GIR_Coverage, 10843,
     /* 1734132 */     GIR_EraseRootFromParent_Done,
     /* 1734133 */   // Label 23684: @1734133
     /* 1734133 */   GIM_Try, /*On fail goto*//*Label 23685*/ GIMT_Encode4(1734219), // Rule ID 10846 //
     /* 1734138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1734149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1734152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1734155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1734158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734184 */     // MIs[0] policy
     /* 1734184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734194 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734218 */     // GIR_Coverage, 10846,
     /* 1734218 */     GIR_EraseRootFromParent_Done,
     /* 1734219 */   // Label 23685: @1734219
     /* 1734219 */   GIM_Try, /*On fail goto*//*Label 23686*/ GIMT_Encode4(1734305), // Rule ID 10847 //
     /* 1734224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1734235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1734238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1734241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1734244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734270 */     // MIs[0] policy
     /* 1734270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734280 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734304 */     // GIR_Coverage, 10847,
     /* 1734304 */     GIR_EraseRootFromParent_Done,
     /* 1734305 */   // Label 23686: @1734305
     /* 1734305 */   GIM_Try, /*On fail goto*//*Label 23687*/ GIMT_Encode4(1734391), // Rule ID 10850 //
     /* 1734310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1734321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1734324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1734327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1734330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734356 */     // MIs[0] policy
     /* 1734356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734366 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734390 */     // GIR_Coverage, 10850,
     /* 1734390 */     GIR_EraseRootFromParent_Done,
     /* 1734391 */   // Label 23687: @1734391
     /* 1734391 */   GIM_Try, /*On fail goto*//*Label 23688*/ GIMT_Encode4(1734477), // Rule ID 10851 //
     /* 1734396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1734407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1734410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1734413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1734416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734442 */     // MIs[0] policy
     /* 1734442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734452 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734476 */     // GIR_Coverage, 10851,
     /* 1734476 */     GIR_EraseRootFromParent_Done,
     /* 1734477 */   // Label 23688: @1734477
     /* 1734477 */   GIM_Try, /*On fail goto*//*Label 23689*/ GIMT_Encode4(1734563), // Rule ID 10854 //
     /* 1734482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1734493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1734496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1734499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1734502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734528 */     // MIs[0] policy
     /* 1734528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734538 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734562 */     // GIR_Coverage, 10854,
     /* 1734562 */     GIR_EraseRootFromParent_Done,
     /* 1734563 */   // Label 23689: @1734563
     /* 1734563 */   GIM_Try, /*On fail goto*//*Label 23690*/ GIMT_Encode4(1734649), // Rule ID 10855 //
     /* 1734568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1734579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1734582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1734585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1734588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734614 */     // MIs[0] policy
     /* 1734614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734648 */     // GIR_Coverage, 10855,
     /* 1734648 */     GIR_EraseRootFromParent_Done,
     /* 1734649 */   // Label 23690: @1734649
     /* 1734649 */   GIM_Try, /*On fail goto*//*Label 23691*/ GIMT_Encode4(1734735), // Rule ID 10858 //
     /* 1734654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1734665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1734668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1734671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1734674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734700 */     // MIs[0] policy
     /* 1734700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734710 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734734 */     // GIR_Coverage, 10858,
     /* 1734734 */     GIR_EraseRootFromParent_Done,
     /* 1734735 */   // Label 23691: @1734735
     /* 1734735 */   GIM_Try, /*On fail goto*//*Label 23692*/ GIMT_Encode4(1734821), // Rule ID 10859 //
     /* 1734740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1734751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1734754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1734757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1734760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734786 */     // MIs[0] policy
     /* 1734786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734796 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734820 */     // GIR_Coverage, 10859,
     /* 1734820 */     GIR_EraseRootFromParent_Done,
     /* 1734821 */   // Label 23692: @1734821
     /* 1734821 */   GIM_Try, /*On fail goto*//*Label 23693*/ GIMT_Encode4(1734907), // Rule ID 10862 //
     /* 1734826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1734837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1734840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1734843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1734846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734872 */     // MIs[0] policy
     /* 1734872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734882 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734906 */     // GIR_Coverage, 10862,
     /* 1734906 */     GIR_EraseRootFromParent_Done,
     /* 1734907 */   // Label 23693: @1734907
     /* 1734907 */   GIM_Try, /*On fail goto*//*Label 23694*/ GIMT_Encode4(1734993), // Rule ID 10863 //
     /* 1734912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1734923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1734926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1734929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1734932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734958 */     // MIs[0] policy
     /* 1734958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734968 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734992 */     // GIR_Coverage, 10863,
     /* 1734992 */     GIR_EraseRootFromParent_Done,
     /* 1734993 */   // Label 23694: @1734993
     /* 1734993 */   GIM_Try, /*On fail goto*//*Label 23695*/ GIMT_Encode4(1735079), // Rule ID 10866 //
     /* 1734998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1735009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1735012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1735015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1735018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735044 */     // MIs[0] policy
     /* 1735044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735054 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1735057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735078 */     // GIR_Coverage, 10866,
     /* 1735078 */     GIR_EraseRootFromParent_Done,
     /* 1735079 */   // Label 23695: @1735079
     /* 1735079 */   GIM_Try, /*On fail goto*//*Label 23696*/ GIMT_Encode4(1735165), // Rule ID 10867 //
     /* 1735084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1735095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1735098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1735101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1735104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735130 */     // MIs[0] policy
     /* 1735130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735140 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1735143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735164 */     // GIR_Coverage, 10867,
     /* 1735164 */     GIR_EraseRootFromParent_Done,
     /* 1735165 */   // Label 23696: @1735165
     /* 1735165 */   GIM_Try, /*On fail goto*//*Label 23697*/ GIMT_Encode4(1735251), // Rule ID 10870 //
     /* 1735170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1735181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1735184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1735187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1735190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735216 */     // MIs[0] policy
     /* 1735216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735226 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1735229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735250 */     // GIR_Coverage, 10870,
     /* 1735250 */     GIR_EraseRootFromParent_Done,
     /* 1735251 */   // Label 23697: @1735251
     /* 1735251 */   GIM_Try, /*On fail goto*//*Label 23698*/ GIMT_Encode4(1735337), // Rule ID 10871 //
     /* 1735256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1735267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1735270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1735273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1735276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735302 */     // MIs[0] policy
     /* 1735302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735312 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1735315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735336 */     // GIR_Coverage, 10871,
     /* 1735336 */     GIR_EraseRootFromParent_Done,
     /* 1735337 */   // Label 23698: @1735337
     /* 1735337 */   GIM_Try, /*On fail goto*//*Label 23699*/ GIMT_Encode4(1735423), // Rule ID 10874 //
     /* 1735342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1735353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1735356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1735359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1735362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735388 */     // MIs[0] policy
     /* 1735388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735398 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1735401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735422 */     // GIR_Coverage, 10874,
     /* 1735422 */     GIR_EraseRootFromParent_Done,
     /* 1735423 */   // Label 23699: @1735423
     /* 1735423 */   GIM_Try, /*On fail goto*//*Label 23700*/ GIMT_Encode4(1735509), // Rule ID 10875 //
     /* 1735428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1735439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1735442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1735445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1735448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735474 */     // MIs[0] policy
     /* 1735474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1735487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735508 */     // GIR_Coverage, 10875,
     /* 1735508 */     GIR_EraseRootFromParent_Done,
     /* 1735509 */   // Label 23700: @1735509
     /* 1735509 */   GIM_Try, /*On fail goto*//*Label 23701*/ GIMT_Encode4(1735595), // Rule ID 10878 //
     /* 1735514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1735525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1735528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1735531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1735537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735560 */     // MIs[0] policy
     /* 1735560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735570 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1735573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735594 */     // GIR_Coverage, 10878,
     /* 1735594 */     GIR_EraseRootFromParent_Done,
     /* 1735595 */   // Label 23701: @1735595
     /* 1735595 */   GIM_Try, /*On fail goto*//*Label 23702*/ GIMT_Encode4(1735681), // Rule ID 10879 //
     /* 1735600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1735611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1735614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1735617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1735623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735646 */     // MIs[0] policy
     /* 1735646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735656 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1735659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735680 */     // GIR_Coverage, 10879,
     /* 1735680 */     GIR_EraseRootFromParent_Done,
     /* 1735681 */   // Label 23702: @1735681
     /* 1735681 */   GIM_Try, /*On fail goto*//*Label 23703*/ GIMT_Encode4(1735767), // Rule ID 10882 //
     /* 1735686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1735697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1735700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1735703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735732 */     // MIs[0] policy
     /* 1735732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735742 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1735745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735766 */     // GIR_Coverage, 10882,
     /* 1735766 */     GIR_EraseRootFromParent_Done,
     /* 1735767 */   // Label 23703: @1735767
     /* 1735767 */   GIM_Try, /*On fail goto*//*Label 23704*/ GIMT_Encode4(1735853), // Rule ID 10883 //
     /* 1735772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1735783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1735786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1735789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735818 */     // MIs[0] policy
     /* 1735818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735828 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1735831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735852 */     // GIR_Coverage, 10883,
     /* 1735852 */     GIR_EraseRootFromParent_Done,
     /* 1735853 */   // Label 23704: @1735853
     /* 1735853 */   GIM_Try, /*On fail goto*//*Label 23705*/ GIMT_Encode4(1735939), // Rule ID 10886 //
     /* 1735858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1735869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1735872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1735875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735904 */     // MIs[0] policy
     /* 1735904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735914 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1735917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735938 */     // GIR_Coverage, 10886,
     /* 1735938 */     GIR_EraseRootFromParent_Done,
     /* 1735939 */   // Label 23705: @1735939
     /* 1735939 */   GIM_Try, /*On fail goto*//*Label 23706*/ GIMT_Encode4(1736025), // Rule ID 10887 //
     /* 1735944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1735955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1735958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1735961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735990 */     // MIs[0] policy
     /* 1735990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736000 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736024 */     // GIR_Coverage, 10887,
     /* 1736024 */     GIR_EraseRootFromParent_Done,
     /* 1736025 */   // Label 23706: @1736025
     /* 1736025 */   GIM_Try, /*On fail goto*//*Label 23707*/ GIMT_Encode4(1736111), // Rule ID 10890 //
     /* 1736030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1736041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1736044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1736047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736076 */     // MIs[0] policy
     /* 1736076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736086 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1736089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736110 */     // GIR_Coverage, 10890,
     /* 1736110 */     GIR_EraseRootFromParent_Done,
     /* 1736111 */   // Label 23707: @1736111
     /* 1736111 */   GIM_Try, /*On fail goto*//*Label 23708*/ GIMT_Encode4(1736197), // Rule ID 10891 //
     /* 1736116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1736127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1736130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1736133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736162 */     // MIs[0] policy
     /* 1736162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736172 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1736175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736196 */     // GIR_Coverage, 10891,
     /* 1736196 */     GIR_EraseRootFromParent_Done,
     /* 1736197 */   // Label 23708: @1736197
     /* 1736197 */   GIM_Try, /*On fail goto*//*Label 23709*/ GIMT_Encode4(1736283), // Rule ID 10894 //
     /* 1736202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1736213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1736216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1736219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736248 */     // MIs[0] policy
     /* 1736248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736258 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736282 */     // GIR_Coverage, 10894,
     /* 1736282 */     GIR_EraseRootFromParent_Done,
     /* 1736283 */   // Label 23709: @1736283
     /* 1736283 */   GIM_Try, /*On fail goto*//*Label 23710*/ GIMT_Encode4(1736369), // Rule ID 10895 //
     /* 1736288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1736299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1736302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1736305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736334 */     // MIs[0] policy
     /* 1736334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736344 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736368 */     // GIR_Coverage, 10895,
     /* 1736368 */     GIR_EraseRootFromParent_Done,
     /* 1736369 */   // Label 23710: @1736369
     /* 1736369 */   GIM_Try, /*On fail goto*//*Label 23711*/ GIMT_Encode4(1736455), // Rule ID 10898 //
     /* 1736374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1736385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1736388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1736391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736420 */     // MIs[0] policy
     /* 1736420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736430 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736454 */     // GIR_Coverage, 10898,
     /* 1736454 */     GIR_EraseRootFromParent_Done,
     /* 1736455 */   // Label 23711: @1736455
     /* 1736455 */   GIM_Try, /*On fail goto*//*Label 23712*/ GIMT_Encode4(1736541), // Rule ID 10899 //
     /* 1736460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1736471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1736474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1736477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736506 */     // MIs[0] policy
     /* 1736506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736516 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736540 */     // GIR_Coverage, 10899,
     /* 1736540 */     GIR_EraseRootFromParent_Done,
     /* 1736541 */   // Label 23712: @1736541
     /* 1736541 */   GIM_Try, /*On fail goto*//*Label 23713*/ GIMT_Encode4(1736627), // Rule ID 10902 //
     /* 1736546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1736557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1736560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1736563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736592 */     // MIs[0] policy
     /* 1736592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1736605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736626 */     // GIR_Coverage, 10902,
     /* 1736626 */     GIR_EraseRootFromParent_Done,
     /* 1736627 */   // Label 23713: @1736627
     /* 1736627 */   GIM_Try, /*On fail goto*//*Label 23714*/ GIMT_Encode4(1736713), // Rule ID 10903 //
     /* 1736632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1736643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1736646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1736649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736678 */     // MIs[0] policy
     /* 1736678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736688 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1736691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736712 */     // GIR_Coverage, 10903,
     /* 1736712 */     GIR_EraseRootFromParent_Done,
     /* 1736713 */   // Label 23714: @1736713
     /* 1736713 */   GIM_Try, /*On fail goto*//*Label 23715*/ GIMT_Encode4(1736799), // Rule ID 10906 //
     /* 1736718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1736729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1736732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1736735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736764 */     // MIs[0] policy
     /* 1736764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736774 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1736777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736798 */     // GIR_Coverage, 10906,
     /* 1736798 */     GIR_EraseRootFromParent_Done,
     /* 1736799 */   // Label 23715: @1736799
     /* 1736799 */   GIM_Try, /*On fail goto*//*Label 23716*/ GIMT_Encode4(1736885), // Rule ID 10907 //
     /* 1736804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1736815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1736818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1736821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736850 */     // MIs[0] policy
     /* 1736850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1736863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736884 */     // GIR_Coverage, 10907,
     /* 1736884 */     GIR_EraseRootFromParent_Done,
     /* 1736885 */   // Label 23716: @1736885
     /* 1736885 */   GIM_Try, /*On fail goto*//*Label 23717*/ GIMT_Encode4(1736971), // Rule ID 10910 //
     /* 1736890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1736901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1736904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1736907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736936 */     // MIs[0] policy
     /* 1736936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1736949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736970 */     // GIR_Coverage, 10910,
     /* 1736970 */     GIR_EraseRootFromParent_Done,
     /* 1736971 */   // Label 23717: @1736971
     /* 1736971 */   GIM_Try, /*On fail goto*//*Label 23718*/ GIMT_Encode4(1737057), // Rule ID 10911 //
     /* 1736976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1736987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1736990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1736993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737022 */     // MIs[0] policy
     /* 1737022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737032 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1737053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737056 */     // GIR_Coverage, 10911,
     /* 1737056 */     GIR_EraseRootFromParent_Done,
     /* 1737057 */   // Label 23718: @1737057
     /* 1737057 */   GIM_Try, /*On fail goto*//*Label 23719*/ GIMT_Encode4(1737143), // Rule ID 10914 //
     /* 1737062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1737065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1737073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1737076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1737079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737108 */     // MIs[0] policy
     /* 1737108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737118 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737142 */     // GIR_Coverage, 10914,
     /* 1737142 */     GIR_EraseRootFromParent_Done,
     /* 1737143 */   // Label 23719: @1737143
     /* 1737143 */   GIM_Try, /*On fail goto*//*Label 23720*/ GIMT_Encode4(1737229), // Rule ID 10915 //
     /* 1737148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1737151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1737159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1737162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1737165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737194 */     // MIs[0] policy
     /* 1737194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737204 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737228 */     // GIR_Coverage, 10915,
     /* 1737228 */     GIR_EraseRootFromParent_Done,
     /* 1737229 */   // Label 23720: @1737229
     /* 1737229 */   GIM_Try, /*On fail goto*//*Label 23721*/ GIMT_Encode4(1737315), // Rule ID 10918 //
     /* 1737234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1737245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1737248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1737251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1737257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737280 */     // MIs[0] policy
     /* 1737280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737290 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1737293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737314 */     // GIR_Coverage, 10918,
     /* 1737314 */     GIR_EraseRootFromParent_Done,
     /* 1737315 */   // Label 23721: @1737315
     /* 1737315 */   GIM_Try, /*On fail goto*//*Label 23722*/ GIMT_Encode4(1737401), // Rule ID 10919 //
     /* 1737320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1737331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1737334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1737337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1737343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737366 */     // MIs[0] policy
     /* 1737366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737376 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1737379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737400 */     // GIR_Coverage, 10919,
     /* 1737400 */     GIR_EraseRootFromParent_Done,
     /* 1737401 */   // Label 23722: @1737401
     /* 1737401 */   GIM_Try, /*On fail goto*//*Label 23723*/ GIMT_Encode4(1737487), // Rule ID 10922 //
     /* 1737406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1737417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1737420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1737423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1737429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737452 */     // MIs[0] policy
     /* 1737452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737462 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1737465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737486 */     // GIR_Coverage, 10922,
     /* 1737486 */     GIR_EraseRootFromParent_Done,
     /* 1737487 */   // Label 23723: @1737487
     /* 1737487 */   GIM_Try, /*On fail goto*//*Label 23724*/ GIMT_Encode4(1737573), // Rule ID 10923 //
     /* 1737492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1737503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1737506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1737509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1737515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737538 */     // MIs[0] policy
     /* 1737538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737548 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1737551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737572 */     // GIR_Coverage, 10923,
     /* 1737572 */     GIR_EraseRootFromParent_Done,
     /* 1737573 */   // Label 23724: @1737573
     /* 1737573 */   GIM_Try, /*On fail goto*//*Label 23725*/ GIMT_Encode4(1737659), // Rule ID 10926 //
     /* 1737578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1737589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1737592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1737595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1737601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1737608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737624 */     // MIs[0] policy
     /* 1737624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737634 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1737637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737658 */     // GIR_Coverage, 10926,
     /* 1737658 */     GIR_EraseRootFromParent_Done,
     /* 1737659 */   // Label 23725: @1737659
     /* 1737659 */   GIM_Try, /*On fail goto*//*Label 23726*/ GIMT_Encode4(1737745), // Rule ID 10927 //
     /* 1737664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1737675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1737678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1737681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1737687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1737694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737710 */     // MIs[0] policy
     /* 1737710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737720 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1737723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737744 */     // GIR_Coverage, 10927,
     /* 1737744 */     GIR_EraseRootFromParent_Done,
     /* 1737745 */   // Label 23726: @1737745
     /* 1737745 */   GIM_Try, /*On fail goto*//*Label 23727*/ GIMT_Encode4(1737831), // Rule ID 10930 //
     /* 1737750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1737761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1737764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1737767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737796 */     // MIs[0] policy
     /* 1737796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737806 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1737809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737830 */     // GIR_Coverage, 10930,
     /* 1737830 */     GIR_EraseRootFromParent_Done,
     /* 1737831 */   // Label 23727: @1737831
     /* 1737831 */   GIM_Try, /*On fail goto*//*Label 23728*/ GIMT_Encode4(1737917), // Rule ID 10931 //
     /* 1737836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1737847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1737850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1737853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737882 */     // MIs[0] policy
     /* 1737882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737892 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1737895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737916 */     // GIR_Coverage, 10931,
     /* 1737916 */     GIR_EraseRootFromParent_Done,
     /* 1737917 */   // Label 23728: @1737917
     /* 1737917 */   GIM_Try, /*On fail goto*//*Label 23729*/ GIMT_Encode4(1738003), // Rule ID 10934 //
     /* 1737922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1737933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1737936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1737939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1737945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737968 */     // MIs[0] policy
     /* 1737968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737978 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1737981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738002 */     // GIR_Coverage, 10934,
     /* 1738002 */     GIR_EraseRootFromParent_Done,
     /* 1738003 */   // Label 23729: @1738003
     /* 1738003 */   GIM_Try, /*On fail goto*//*Label 23730*/ GIMT_Encode4(1738089), // Rule ID 10935 //
     /* 1738008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1738019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1738022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1738025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738054 */     // MIs[0] policy
     /* 1738054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738088 */     // GIR_Coverage, 10935,
     /* 1738088 */     GIR_EraseRootFromParent_Done,
     /* 1738089 */   // Label 23730: @1738089
     /* 1738089 */   GIM_Try, /*On fail goto*//*Label 23731*/ GIMT_Encode4(1738175), // Rule ID 10938 //
     /* 1738094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1738105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1738108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1738111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1738117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738140 */     // MIs[0] policy
     /* 1738140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738150 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738174 */     // GIR_Coverage, 10938,
     /* 1738174 */     GIR_EraseRootFromParent_Done,
     /* 1738175 */   // Label 23731: @1738175
     /* 1738175 */   GIM_Try, /*On fail goto*//*Label 23732*/ GIMT_Encode4(1738261), // Rule ID 10939 //
     /* 1738180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1738191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1738194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1738197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1738203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738226 */     // MIs[0] policy
     /* 1738226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738236 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738260 */     // GIR_Coverage, 10939,
     /* 1738260 */     GIR_EraseRootFromParent_Done,
     /* 1738261 */   // Label 23732: @1738261
     /* 1738261 */   GIM_Try, /*On fail goto*//*Label 23733*/ GIMT_Encode4(1738347), // Rule ID 10942 //
     /* 1738266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1738277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1738280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1738283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738312 */     // MIs[0] policy
     /* 1738312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738346 */     // GIR_Coverage, 10942,
     /* 1738346 */     GIR_EraseRootFromParent_Done,
     /* 1738347 */   // Label 23733: @1738347
     /* 1738347 */   GIM_Try, /*On fail goto*//*Label 23734*/ GIMT_Encode4(1738433), // Rule ID 10943 //
     /* 1738352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1738363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1738366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1738369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738398 */     // MIs[0] policy
     /* 1738398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738408 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738432 */     // GIR_Coverage, 10943,
     /* 1738432 */     GIR_EraseRootFromParent_Done,
     /* 1738433 */   // Label 23734: @1738433
     /* 1738433 */   GIM_Try, /*On fail goto*//*Label 23735*/ GIMT_Encode4(1738519), // Rule ID 10946 //
     /* 1738438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1738449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1738452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1738455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738484 */     // MIs[0] policy
     /* 1738484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738518 */     // GIR_Coverage, 10946,
     /* 1738518 */     GIR_EraseRootFromParent_Done,
     /* 1738519 */   // Label 23735: @1738519
     /* 1738519 */   GIM_Try, /*On fail goto*//*Label 23736*/ GIMT_Encode4(1738605), // Rule ID 10947 //
     /* 1738524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1738535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1738538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1738541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738570 */     // MIs[0] policy
     /* 1738570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738580 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738604 */     // GIR_Coverage, 10947,
     /* 1738604 */     GIR_EraseRootFromParent_Done,
     /* 1738605 */   // Label 23736: @1738605
     /* 1738605 */   GIM_Try, /*On fail goto*//*Label 23737*/ GIMT_Encode4(1738691), // Rule ID 10950 //
     /* 1738610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1738621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1738624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1738627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738656 */     // MIs[0] policy
     /* 1738656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738690 */     // GIR_Coverage, 10950,
     /* 1738690 */     GIR_EraseRootFromParent_Done,
     /* 1738691 */   // Label 23737: @1738691
     /* 1738691 */   GIM_Try, /*On fail goto*//*Label 23738*/ GIMT_Encode4(1738777), // Rule ID 10951 //
     /* 1738696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1738707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1738710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1738713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738742 */     // MIs[0] policy
     /* 1738742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738776 */     // GIR_Coverage, 10951,
     /* 1738776 */     GIR_EraseRootFromParent_Done,
     /* 1738777 */   // Label 23738: @1738777
     /* 1738777 */   GIM_Try, /*On fail goto*//*Label 23739*/ GIMT_Encode4(1738863), // Rule ID 10954 //
     /* 1738782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1738785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1738793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1738796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1738799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1738805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738828 */     // MIs[0] policy
     /* 1738828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738838 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1738859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738862 */     // GIR_Coverage, 10954,
     /* 1738862 */     GIR_EraseRootFromParent_Done,
     /* 1738863 */   // Label 23739: @1738863
     /* 1738863 */   GIM_Try, /*On fail goto*//*Label 23740*/ GIMT_Encode4(1738949), // Rule ID 10955 //
     /* 1738868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1738871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1738879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1738882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1738885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1738891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738914 */     // MIs[0] policy
     /* 1738914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1738945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738948 */     // GIR_Coverage, 10955,
     /* 1738948 */     GIR_EraseRootFromParent_Done,
     /* 1738949 */   // Label 23740: @1738949
     /* 1738949 */   GIM_Try, /*On fail goto*//*Label 23741*/ GIMT_Encode4(1739035), // Rule ID 10958 //
     /* 1738954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1738957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1738965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1738968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1738971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739000 */     // MIs[0] policy
     /* 1739000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739010 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1739013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739034 */     // GIR_Coverage, 10958,
     /* 1739034 */     GIR_EraseRootFromParent_Done,
     /* 1739035 */   // Label 23741: @1739035
     /* 1739035 */   GIM_Try, /*On fail goto*//*Label 23742*/ GIMT_Encode4(1739121), // Rule ID 10959 //
     /* 1739040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1739051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1739054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1739057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739086 */     // MIs[0] policy
     /* 1739086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1739099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739120 */     // GIR_Coverage, 10959,
     /* 1739120 */     GIR_EraseRootFromParent_Done,
     /* 1739121 */   // Label 23742: @1739121
     /* 1739121 */   GIM_Try, /*On fail goto*//*Label 23743*/ GIMT_Encode4(1739207), // Rule ID 10962 //
     /* 1739126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1739129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1739137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1739140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1739143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739172 */     // MIs[0] policy
     /* 1739172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739182 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1739185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739206 */     // GIR_Coverage, 10962,
     /* 1739206 */     GIR_EraseRootFromParent_Done,
     /* 1739207 */   // Label 23743: @1739207
     /* 1739207 */   GIM_Try, /*On fail goto*//*Label 23744*/ GIMT_Encode4(1739293), // Rule ID 10963 //
     /* 1739212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1739223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1739226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1739229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739258 */     // MIs[0] policy
     /* 1739258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739268 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1739271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739292 */     // GIR_Coverage, 10963,
     /* 1739292 */     GIR_EraseRootFromParent_Done,
     /* 1739293 */   // Label 23744: @1739293
     /* 1739293 */   GIM_Try, /*On fail goto*//*Label 23745*/ GIMT_Encode4(1739379), // Rule ID 10966 //
     /* 1739298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1739309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1739312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1739315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1739318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739344 */     // MIs[0] policy
     /* 1739344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739354 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1739357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739378 */     // GIR_Coverage, 10966,
     /* 1739378 */     GIR_EraseRootFromParent_Done,
     /* 1739379 */   // Label 23745: @1739379
     /* 1739379 */   GIM_Try, /*On fail goto*//*Label 23746*/ GIMT_Encode4(1739465), // Rule ID 10967 //
     /* 1739384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1739395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1739398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1739401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1739404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739430 */     // MIs[0] policy
     /* 1739430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739440 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1739443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739464 */     // GIR_Coverage, 10967,
     /* 1739464 */     GIR_EraseRootFromParent_Done,
     /* 1739465 */   // Label 23746: @1739465
     /* 1739465 */   GIM_Try, /*On fail goto*//*Label 23747*/ GIMT_Encode4(1739551), // Rule ID 10970 //
     /* 1739470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1739481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1739484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1739487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1739490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739516 */     // MIs[0] policy
     /* 1739516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739526 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1739529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739550 */     // GIR_Coverage, 10970,
     /* 1739550 */     GIR_EraseRootFromParent_Done,
     /* 1739551 */   // Label 23747: @1739551
     /* 1739551 */   GIM_Try, /*On fail goto*//*Label 23748*/ GIMT_Encode4(1739637), // Rule ID 10971 //
     /* 1739556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1739567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1739570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1739573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1739576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739602 */     // MIs[0] policy
     /* 1739602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739612 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1739615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739636 */     // GIR_Coverage, 10971,
     /* 1739636 */     GIR_EraseRootFromParent_Done,
     /* 1739637 */   // Label 23748: @1739637
     /* 1739637 */   GIM_Try, /*On fail goto*//*Label 23749*/ GIMT_Encode4(1739723), // Rule ID 10974 //
     /* 1739642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1739653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1739656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1739659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1739662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739688 */     // MIs[0] policy
     /* 1739688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739698 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1739701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739722 */     // GIR_Coverage, 10974,
     /* 1739722 */     GIR_EraseRootFromParent_Done,
     /* 1739723 */   // Label 23749: @1739723
     /* 1739723 */   GIM_Try, /*On fail goto*//*Label 23750*/ GIMT_Encode4(1739809), // Rule ID 10975 //
     /* 1739728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1739739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1739742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1739745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1739748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739774 */     // MIs[0] policy
     /* 1739774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739784 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1739787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739808 */     // GIR_Coverage, 10975,
     /* 1739808 */     GIR_EraseRootFromParent_Done,
     /* 1739809 */   // Label 23750: @1739809
     /* 1739809 */   GIM_Try, /*On fail goto*//*Label 23751*/ GIMT_Encode4(1739895), // Rule ID 10978 //
     /* 1739814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1739825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1739828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1739831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1739834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739860 */     // MIs[0] policy
     /* 1739860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739870 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1739873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739894 */     // GIR_Coverage, 10978,
     /* 1739894 */     GIR_EraseRootFromParent_Done,
     /* 1739895 */   // Label 23751: @1739895
     /* 1739895 */   GIM_Try, /*On fail goto*//*Label 23752*/ GIMT_Encode4(1739981), // Rule ID 10979 //
     /* 1739900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1739911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1739914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1739917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1739920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739946 */     // MIs[0] policy
     /* 1739946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739956 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1739959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739980 */     // GIR_Coverage, 10979,
     /* 1739980 */     GIR_EraseRootFromParent_Done,
     /* 1739981 */   // Label 23752: @1739981
     /* 1739981 */   GIM_Try, /*On fail goto*//*Label 23753*/ GIMT_Encode4(1740067), // Rule ID 10982 //
     /* 1739986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1739997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1740000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1740003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1740006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740032 */     // MIs[0] policy
     /* 1740032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740042 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740066 */     // GIR_Coverage, 10982,
     /* 1740066 */     GIR_EraseRootFromParent_Done,
     /* 1740067 */   // Label 23753: @1740067
     /* 1740067 */   GIM_Try, /*On fail goto*//*Label 23754*/ GIMT_Encode4(1740153), // Rule ID 10983 //
     /* 1740072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1740083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1740086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1740089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1740092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740118 */     // MIs[0] policy
     /* 1740118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740128 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740152 */     // GIR_Coverage, 10983,
     /* 1740152 */     GIR_EraseRootFromParent_Done,
     /* 1740153 */   // Label 23754: @1740153
     /* 1740153 */   GIM_Try, /*On fail goto*//*Label 23755*/ GIMT_Encode4(1740239), // Rule ID 10986 //
     /* 1740158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1740169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1740172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1740175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1740178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740204 */     // MIs[0] policy
     /* 1740204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740214 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740238 */     // GIR_Coverage, 10986,
     /* 1740238 */     GIR_EraseRootFromParent_Done,
     /* 1740239 */   // Label 23755: @1740239
     /* 1740239 */   GIM_Try, /*On fail goto*//*Label 23756*/ GIMT_Encode4(1740325), // Rule ID 10987 //
     /* 1740244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1740255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1740258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1740261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1740264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740290 */     // MIs[0] policy
     /* 1740290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740300 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740324 */     // GIR_Coverage, 10987,
     /* 1740324 */     GIR_EraseRootFromParent_Done,
     /* 1740325 */   // Label 23756: @1740325
     /* 1740325 */   GIM_Try, /*On fail goto*//*Label 23757*/ GIMT_Encode4(1740411), // Rule ID 10990 //
     /* 1740330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1740341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1740344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1740347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1740350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740376 */     // MIs[0] policy
     /* 1740376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740386 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740410 */     // GIR_Coverage, 10990,
     /* 1740410 */     GIR_EraseRootFromParent_Done,
     /* 1740411 */   // Label 23757: @1740411
     /* 1740411 */   GIM_Try, /*On fail goto*//*Label 23758*/ GIMT_Encode4(1740497), // Rule ID 10991 //
     /* 1740416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1740427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1740430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1740433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1740436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740462 */     // MIs[0] policy
     /* 1740462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740472 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740496 */     // GIR_Coverage, 10991,
     /* 1740496 */     GIR_EraseRootFromParent_Done,
     /* 1740497 */   // Label 23758: @1740497
     /* 1740497 */   GIM_Try, /*On fail goto*//*Label 23759*/ GIMT_Encode4(1740583), // Rule ID 10994 //
     /* 1740502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1740513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1740516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1740519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1740522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740548 */     // MIs[0] policy
     /* 1740548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740582 */     // GIR_Coverage, 10994,
     /* 1740582 */     GIR_EraseRootFromParent_Done,
     /* 1740583 */   // Label 23759: @1740583
     /* 1740583 */   GIM_Try, /*On fail goto*//*Label 23760*/ GIMT_Encode4(1740669), // Rule ID 10995 //
     /* 1740588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1740599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1740602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1740605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1740608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740634 */     // MIs[0] policy
     /* 1740634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740644 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740668 */     // GIR_Coverage, 10995,
     /* 1740668 */     GIR_EraseRootFromParent_Done,
     /* 1740669 */   // Label 23760: @1740669
     /* 1740669 */   GIM_Try, /*On fail goto*//*Label 23761*/ GIMT_Encode4(1740755), // Rule ID 10998 //
     /* 1740674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1740685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1740688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1740691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1740694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740720 */     // MIs[0] policy
     /* 1740720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740730 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740754 */     // GIR_Coverage, 10998,
     /* 1740754 */     GIR_EraseRootFromParent_Done,
     /* 1740755 */   // Label 23761: @1740755
     /* 1740755 */   GIM_Try, /*On fail goto*//*Label 23762*/ GIMT_Encode4(1740841), // Rule ID 10999 //
     /* 1740760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1740771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1740774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1740777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1740780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740806 */     // MIs[0] policy
     /* 1740806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740816 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740840 */     // GIR_Coverage, 10999,
     /* 1740840 */     GIR_EraseRootFromParent_Done,
     /* 1740841 */   // Label 23762: @1740841
     /* 1740841 */   GIM_Try, /*On fail goto*//*Label 23763*/ GIMT_Encode4(1740927), // Rule ID 11002 //
     /* 1740846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1740849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1740857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1740860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1740863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1740866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740892 */     // MIs[0] policy
     /* 1740892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740902 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740926 */     // GIR_Coverage, 11002,
     /* 1740926 */     GIR_EraseRootFromParent_Done,
     /* 1740927 */   // Label 23763: @1740927
     /* 1740927 */   GIM_Try, /*On fail goto*//*Label 23764*/ GIMT_Encode4(1741013), // Rule ID 11003 //
     /* 1740932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1740935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1740943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1740946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1740949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1740952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740978 */     // MIs[0] policy
     /* 1740978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740988 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1741009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741012 */     // GIR_Coverage, 11003,
     /* 1741012 */     GIR_EraseRootFromParent_Done,
     /* 1741013 */   // Label 23764: @1741013
     /* 1741013 */   GIM_Try, /*On fail goto*//*Label 23765*/ GIMT_Encode4(1741099), // Rule ID 11006 //
     /* 1741018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1741029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1741032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1741035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1741038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741064 */     // MIs[0] policy
     /* 1741064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741074 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1741077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741098 */     // GIR_Coverage, 11006,
     /* 1741098 */     GIR_EraseRootFromParent_Done,
     /* 1741099 */   // Label 23765: @1741099
     /* 1741099 */   GIM_Try, /*On fail goto*//*Label 23766*/ GIMT_Encode4(1741185), // Rule ID 11007 //
     /* 1741104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1741115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1741118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1741121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1741124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741150 */     // MIs[0] policy
     /* 1741150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741160 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1741163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741184 */     // GIR_Coverage, 11007,
     /* 1741184 */     GIR_EraseRootFromParent_Done,
     /* 1741185 */   // Label 23766: @1741185
     /* 1741185 */   GIM_Try, /*On fail goto*//*Label 23767*/ GIMT_Encode4(1741271), // Rule ID 11010 //
     /* 1741190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1741201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1741204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1741207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1741210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741236 */     // MIs[0] policy
     /* 1741236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741246 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1741249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741270 */     // GIR_Coverage, 11010,
     /* 1741270 */     GIR_EraseRootFromParent_Done,
     /* 1741271 */   // Label 23767: @1741271
     /* 1741271 */   GIM_Try, /*On fail goto*//*Label 23768*/ GIMT_Encode4(1741357), // Rule ID 11011 //
     /* 1741276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1741287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1741290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1741293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1741296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741322 */     // MIs[0] policy
     /* 1741322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741332 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1741335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741356 */     // GIR_Coverage, 11011,
     /* 1741356 */     GIR_EraseRootFromParent_Done,
     /* 1741357 */   // Label 23768: @1741357
     /* 1741357 */   GIM_Try, /*On fail goto*//*Label 23769*/ GIMT_Encode4(1741443), // Rule ID 11014 //
     /* 1741362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1741373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1741376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1741379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1741382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1741385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741408 */     // MIs[0] policy
     /* 1741408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741418 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1741421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741442 */     // GIR_Coverage, 11014,
     /* 1741442 */     GIR_EraseRootFromParent_Done,
     /* 1741443 */   // Label 23769: @1741443
     /* 1741443 */   GIM_Try, /*On fail goto*//*Label 23770*/ GIMT_Encode4(1741529), // Rule ID 11015 //
     /* 1741448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1741459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1741462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1741465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1741468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1741471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741494 */     // MIs[0] policy
     /* 1741494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741504 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1741507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741528 */     // GIR_Coverage, 11015,
     /* 1741528 */     GIR_EraseRootFromParent_Done,
     /* 1741529 */   // Label 23770: @1741529
     /* 1741529 */   GIM_Try, /*On fail goto*//*Label 23771*/ GIMT_Encode4(1741615), // Rule ID 11018 //
     /* 1741534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1741545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1741548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1741551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1741554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1741557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741580 */     // MIs[0] policy
     /* 1741580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1741593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741614 */     // GIR_Coverage, 11018,
     /* 1741614 */     GIR_EraseRootFromParent_Done,
     /* 1741615 */   // Label 23771: @1741615
     /* 1741615 */   GIM_Try, /*On fail goto*//*Label 23772*/ GIMT_Encode4(1741701), // Rule ID 11019 //
     /* 1741620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1741631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1741634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1741637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1741640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1741643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741666 */     // MIs[0] policy
     /* 1741666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1741679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741700 */     // GIR_Coverage, 11019,
     /* 1741700 */     GIR_EraseRootFromParent_Done,
     /* 1741701 */   // Label 23772: @1741701
     /* 1741701 */   GIM_Try, /*On fail goto*//*Label 23773*/ GIMT_Encode4(1741787), // Rule ID 11022 //
     /* 1741706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1741717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1741720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1741723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1741726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741752 */     // MIs[0] policy
     /* 1741752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741762 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1741765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741786 */     // GIR_Coverage, 11022,
     /* 1741786 */     GIR_EraseRootFromParent_Done,
     /* 1741787 */   // Label 23773: @1741787
     /* 1741787 */   GIM_Try, /*On fail goto*//*Label 23774*/ GIMT_Encode4(1741873), // Rule ID 11023 //
     /* 1741792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1741803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1741806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1741809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1741812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741838 */     // MIs[0] policy
     /* 1741838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1741851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741872 */     // GIR_Coverage, 11023,
     /* 1741872 */     GIR_EraseRootFromParent_Done,
     /* 1741873 */   // Label 23774: @1741873
     /* 1741873 */   GIM_Try, /*On fail goto*//*Label 23775*/ GIMT_Encode4(1741959), // Rule ID 11026 //
     /* 1741878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1741889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1741892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1741895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1741898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741924 */     // MIs[0] policy
     /* 1741924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741934 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1741937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741958 */     // GIR_Coverage, 11026,
     /* 1741958 */     GIR_EraseRootFromParent_Done,
     /* 1741959 */   // Label 23775: @1741959
     /* 1741959 */   GIM_Try, /*On fail goto*//*Label 23776*/ GIMT_Encode4(1742045), // Rule ID 11027 //
     /* 1741964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1741975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1741978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1741981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1741984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742010 */     // MIs[0] policy
     /* 1742010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742020 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742044 */     // GIR_Coverage, 11027,
     /* 1742044 */     GIR_EraseRootFromParent_Done,
     /* 1742045 */   // Label 23776: @1742045
     /* 1742045 */   GIM_Try, /*On fail goto*//*Label 23777*/ GIMT_Encode4(1742131), // Rule ID 11030 //
     /* 1742050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1742061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1742064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1742067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1742070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742096 */     // MIs[0] policy
     /* 1742096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742130 */     // GIR_Coverage, 11030,
     /* 1742130 */     GIR_EraseRootFromParent_Done,
     /* 1742131 */   // Label 23777: @1742131
     /* 1742131 */   GIM_Try, /*On fail goto*//*Label 23778*/ GIMT_Encode4(1742217), // Rule ID 11031 //
     /* 1742136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1742147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1742150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1742153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1742156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742182 */     // MIs[0] policy
     /* 1742182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742216 */     // GIR_Coverage, 11031,
     /* 1742216 */     GIR_EraseRootFromParent_Done,
     /* 1742217 */   // Label 23778: @1742217
     /* 1742217 */   GIM_Try, /*On fail goto*//*Label 23779*/ GIMT_Encode4(1742303), // Rule ID 11034 //
     /* 1742222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1742233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1742236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1742239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1742242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742268 */     // MIs[0] policy
     /* 1742268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742278 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742302 */     // GIR_Coverage, 11034,
     /* 1742302 */     GIR_EraseRootFromParent_Done,
     /* 1742303 */   // Label 23779: @1742303
     /* 1742303 */   GIM_Try, /*On fail goto*//*Label 23780*/ GIMT_Encode4(1742389), // Rule ID 11035 //
     /* 1742308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1742319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1742322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1742325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1742328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742354 */     // MIs[0] policy
     /* 1742354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742388 */     // GIR_Coverage, 11035,
     /* 1742388 */     GIR_EraseRootFromParent_Done,
     /* 1742389 */   // Label 23780: @1742389
     /* 1742389 */   GIM_Try, /*On fail goto*//*Label 23781*/ GIMT_Encode4(1742475), // Rule ID 11038 //
     /* 1742394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1742405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1742408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1742411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1742414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742440 */     // MIs[0] policy
     /* 1742440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742450 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742474 */     // GIR_Coverage, 11038,
     /* 1742474 */     GIR_EraseRootFromParent_Done,
     /* 1742475 */   // Label 23781: @1742475
     /* 1742475 */   GIM_Try, /*On fail goto*//*Label 23782*/ GIMT_Encode4(1742561), // Rule ID 11039 //
     /* 1742480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1742491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1742494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1742497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1742500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742526 */     // MIs[0] policy
     /* 1742526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742560 */     // GIR_Coverage, 11039,
     /* 1742560 */     GIR_EraseRootFromParent_Done,
     /* 1742561 */   // Label 23782: @1742561
     /* 1742561 */   GIM_Try, /*On fail goto*//*Label 23783*/ GIMT_Encode4(1742647), // Rule ID 11042 //
     /* 1742566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1742569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1742577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1742580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1742583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1742586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1742589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742612 */     // MIs[0] policy
     /* 1742612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742622 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742646 */     // GIR_Coverage, 11042,
     /* 1742646 */     GIR_EraseRootFromParent_Done,
     /* 1742647 */   // Label 23783: @1742647
     /* 1742647 */   GIM_Try, /*On fail goto*//*Label 23784*/ GIMT_Encode4(1742733), // Rule ID 11043 //
     /* 1742652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1742655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1742663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1742666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1742669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1742672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1742675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742698 */     // MIs[0] policy
     /* 1742698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742708 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742732 */     // GIR_Coverage, 11043,
     /* 1742732 */     GIR_EraseRootFromParent_Done,
     /* 1742733 */   // Label 23784: @1742733
     /* 1742733 */   GIM_Try, /*On fail goto*//*Label 23785*/ GIMT_Encode4(1742819), // Rule ID 11046 //
     /* 1742738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1742741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1742749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1742752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1742755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1742758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742784 */     // MIs[0] policy
     /* 1742784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742794 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742818 */     // GIR_Coverage, 11046,
     /* 1742818 */     GIR_EraseRootFromParent_Done,
     /* 1742819 */   // Label 23785: @1742819
     /* 1742819 */   GIM_Try, /*On fail goto*//*Label 23786*/ GIMT_Encode4(1742905), // Rule ID 11047 //
     /* 1742824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1742827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1742835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1742838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1742841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1742844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742870 */     // MIs[0] policy
     /* 1742870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742880 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742904 */     // GIR_Coverage, 11047,
     /* 1742904 */     GIR_EraseRootFromParent_Done,
     /* 1742905 */   // Label 23786: @1742905
     /* 1742905 */   GIM_Try, /*On fail goto*//*Label 23787*/ GIMT_Encode4(1742991), // Rule ID 11050 //
     /* 1742910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1742913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1742921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1742924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1742927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1742930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742956 */     // MIs[0] policy
     /* 1742956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742966 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742990 */     // GIR_Coverage, 11050,
     /* 1742990 */     GIR_EraseRootFromParent_Done,
     /* 1742991 */   // Label 23787: @1742991
     /* 1742991 */   GIM_Try, /*On fail goto*//*Label 23788*/ GIMT_Encode4(1743077), // Rule ID 11051 //
     /* 1742996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1742999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1743007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1743010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1743013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1743016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743042 */     // MIs[0] policy
     /* 1743042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743052 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1743055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743076 */     // GIR_Coverage, 11051,
     /* 1743076 */     GIR_EraseRootFromParent_Done,
     /* 1743077 */   // Label 23788: @1743077
     /* 1743077 */   GIM_Try, /*On fail goto*//*Label 23789*/ GIMT_Encode4(1743163), // Rule ID 11054 //
     /* 1743082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1743093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1743096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1743099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743128 */     // MIs[0] policy
     /* 1743128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743138 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1743141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743162 */     // GIR_Coverage, 11054,
     /* 1743162 */     GIR_EraseRootFromParent_Done,
     /* 1743163 */   // Label 23789: @1743163
     /* 1743163 */   GIM_Try, /*On fail goto*//*Label 23790*/ GIMT_Encode4(1743249), // Rule ID 11055 //
     /* 1743168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1743179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1743182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1743185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743214 */     // MIs[0] policy
     /* 1743214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743224 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1743227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743248 */     // GIR_Coverage, 11055,
     /* 1743248 */     GIR_EraseRootFromParent_Done,
     /* 1743249 */   // Label 23790: @1743249
     /* 1743249 */   GIM_Try, /*On fail goto*//*Label 23791*/ GIMT_Encode4(1743335), // Rule ID 11058 //
     /* 1743254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1743265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1743268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1743271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743300 */     // MIs[0] policy
     /* 1743300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743310 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1743313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743334 */     // GIR_Coverage, 11058,
     /* 1743334 */     GIR_EraseRootFromParent_Done,
     /* 1743335 */   // Label 23791: @1743335
     /* 1743335 */   GIM_Try, /*On fail goto*//*Label 23792*/ GIMT_Encode4(1743421), // Rule ID 11059 //
     /* 1743340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1743351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1743354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1743357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743386 */     // MIs[0] policy
     /* 1743386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743396 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1743399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743420 */     // GIR_Coverage, 11059,
     /* 1743420 */     GIR_EraseRootFromParent_Done,
     /* 1743421 */   // Label 23792: @1743421
     /* 1743421 */   GIM_Try, /*On fail goto*//*Label 23793*/ GIMT_Encode4(1743507), // Rule ID 11062 //
     /* 1743426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1743437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1743440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1743443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743472 */     // MIs[0] policy
     /* 1743472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743482 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1743485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743506 */     // GIR_Coverage, 11062,
     /* 1743506 */     GIR_EraseRootFromParent_Done,
     /* 1743507 */   // Label 23793: @1743507
     /* 1743507 */   GIM_Try, /*On fail goto*//*Label 23794*/ GIMT_Encode4(1743593), // Rule ID 11063 //
     /* 1743512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1743523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1743526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1743529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743558 */     // MIs[0] policy
     /* 1743558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743568 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1743571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743592 */     // GIR_Coverage, 11063,
     /* 1743592 */     GIR_EraseRootFromParent_Done,
     /* 1743593 */   // Label 23794: @1743593
     /* 1743593 */   GIM_Try, /*On fail goto*//*Label 23795*/ GIMT_Encode4(1743679), // Rule ID 11066 //
     /* 1743598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1743609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1743612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1743615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743644 */     // MIs[0] policy
     /* 1743644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743654 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1743657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743678 */     // GIR_Coverage, 11066,
     /* 1743678 */     GIR_EraseRootFromParent_Done,
     /* 1743679 */   // Label 23795: @1743679
     /* 1743679 */   GIM_Try, /*On fail goto*//*Label 23796*/ GIMT_Encode4(1743765), // Rule ID 11067 //
     /* 1743684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1743695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1743698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1743701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743730 */     // MIs[0] policy
     /* 1743730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743740 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1743743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743764 */     // GIR_Coverage, 11067,
     /* 1743764 */     GIR_EraseRootFromParent_Done,
     /* 1743765 */   // Label 23796: @1743765
     /* 1743765 */   GIM_Try, /*On fail goto*//*Label 23797*/ GIMT_Encode4(1743851), // Rule ID 11070 //
     /* 1743770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1743781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1743784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1743787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743816 */     // MIs[0] policy
     /* 1743816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743826 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1743829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743850 */     // GIR_Coverage, 11070,
     /* 1743850 */     GIR_EraseRootFromParent_Done,
     /* 1743851 */   // Label 23797: @1743851
     /* 1743851 */   GIM_Try, /*On fail goto*//*Label 23798*/ GIMT_Encode4(1743937), // Rule ID 11071 //
     /* 1743856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1743867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1743870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1743873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743902 */     // MIs[0] policy
     /* 1743902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743912 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1743915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743936 */     // GIR_Coverage, 11071,
     /* 1743936 */     GIR_EraseRootFromParent_Done,
     /* 1743937 */   // Label 23798: @1743937
     /* 1743937 */   GIM_Try, /*On fail goto*//*Label 23799*/ GIMT_Encode4(1744023), // Rule ID 11074 //
     /* 1743942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1743953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1743956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1743959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743988 */     // MIs[0] policy
     /* 1743988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1744001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744022 */     // GIR_Coverage, 11074,
     /* 1744022 */     GIR_EraseRootFromParent_Done,
     /* 1744023 */   // Label 23799: @1744023
     /* 1744023 */   GIM_Try, /*On fail goto*//*Label 23800*/ GIMT_Encode4(1744109), // Rule ID 11075 //
     /* 1744028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1744039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1744042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1744045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744074 */     // MIs[0] policy
     /* 1744074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1744087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744108 */     // GIR_Coverage, 11075,
     /* 1744108 */     GIR_EraseRootFromParent_Done,
     /* 1744109 */   // Label 23800: @1744109
     /* 1744109 */   GIM_Try, /*On fail goto*//*Label 23801*/ GIMT_Encode4(1744195), // Rule ID 11078 //
     /* 1744114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1744125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1744128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1744131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744160 */     // MIs[0] policy
     /* 1744160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744170 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744194 */     // GIR_Coverage, 11078,
     /* 1744194 */     GIR_EraseRootFromParent_Done,
     /* 1744195 */   // Label 23801: @1744195
     /* 1744195 */   GIM_Try, /*On fail goto*//*Label 23802*/ GIMT_Encode4(1744281), // Rule ID 11079 //
     /* 1744200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1744211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1744214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1744217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744246 */     // MIs[0] policy
     /* 1744246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744256 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744280 */     // GIR_Coverage, 11079,
     /* 1744280 */     GIR_EraseRootFromParent_Done,
     /* 1744281 */   // Label 23802: @1744281
     /* 1744281 */   GIM_Try, /*On fail goto*//*Label 23803*/ GIMT_Encode4(1744367), // Rule ID 11082 //
     /* 1744286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1744297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1744300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1744303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744332 */     // MIs[0] policy
     /* 1744332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744366 */     // GIR_Coverage, 11082,
     /* 1744366 */     GIR_EraseRootFromParent_Done,
     /* 1744367 */   // Label 23803: @1744367
     /* 1744367 */   GIM_Try, /*On fail goto*//*Label 23804*/ GIMT_Encode4(1744453), // Rule ID 11083 //
     /* 1744372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1744383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1744386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1744389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744418 */     // MIs[0] policy
     /* 1744418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744428 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744452 */     // GIR_Coverage, 11083,
     /* 1744452 */     GIR_EraseRootFromParent_Done,
     /* 1744453 */   // Label 23804: @1744453
     /* 1744453 */   GIM_Try, /*On fail goto*//*Label 23805*/ GIMT_Encode4(1744539), // Rule ID 11086 //
     /* 1744458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1744469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1744472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1744475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744504 */     // MIs[0] policy
     /* 1744504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744514 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744538 */     // GIR_Coverage, 11086,
     /* 1744538 */     GIR_EraseRootFromParent_Done,
     /* 1744539 */   // Label 23805: @1744539
     /* 1744539 */   GIM_Try, /*On fail goto*//*Label 23806*/ GIMT_Encode4(1744625), // Rule ID 11087 //
     /* 1744544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1744555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1744558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1744561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744590 */     // MIs[0] policy
     /* 1744590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744624 */     // GIR_Coverage, 11087,
     /* 1744624 */     GIR_EraseRootFromParent_Done,
     /* 1744625 */   // Label 23806: @1744625
     /* 1744625 */   GIM_Try, /*On fail goto*//*Label 23807*/ GIMT_Encode4(1744711), // Rule ID 11090 //
     /* 1744630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1744633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1744641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1744644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1744647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744676 */     // MIs[0] policy
     /* 1744676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744686 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744710 */     // GIR_Coverage, 11090,
     /* 1744710 */     GIR_EraseRootFromParent_Done,
     /* 1744711 */   // Label 23807: @1744711
     /* 1744711 */   GIM_Try, /*On fail goto*//*Label 23808*/ GIMT_Encode4(1744797), // Rule ID 11091 //
     /* 1744716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1744719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1744727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1744730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1744733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744762 */     // MIs[0] policy
     /* 1744762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744772 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744796 */     // GIR_Coverage, 11091,
     /* 1744796 */     GIR_EraseRootFromParent_Done,
     /* 1744797 */   // Label 23808: @1744797
     /* 1744797 */   GIM_Try, /*On fail goto*//*Label 23809*/ GIMT_Encode4(1744883), // Rule ID 11094 //
     /* 1744802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1744813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1744816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1744819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1744825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1744832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744848 */     // MIs[0] policy
     /* 1744848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1744861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744882 */     // GIR_Coverage, 11094,
     /* 1744882 */     GIR_EraseRootFromParent_Done,
     /* 1744883 */   // Label 23809: @1744883
     /* 1744883 */   GIM_Try, /*On fail goto*//*Label 23810*/ GIMT_Encode4(1744969), // Rule ID 11095 //
     /* 1744888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1744899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1744902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1744905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1744911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1744918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744934 */     // MIs[0] policy
     /* 1744934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744944 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1744947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744968 */     // GIR_Coverage, 11095,
     /* 1744968 */     GIR_EraseRootFromParent_Done,
     /* 1744969 */   // Label 23810: @1744969
     /* 1744969 */   GIM_Try, /*On fail goto*//*Label 23811*/ GIMT_Encode4(1745055), // Rule ID 11098 //
     /* 1744974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1744985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1744988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1744991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1744997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745020 */     // MIs[0] policy
     /* 1745020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745030 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1745033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745054 */     // GIR_Coverage, 11098,
     /* 1745054 */     GIR_EraseRootFromParent_Done,
     /* 1745055 */   // Label 23811: @1745055
     /* 1745055 */   GIM_Try, /*On fail goto*//*Label 23812*/ GIMT_Encode4(1745141), // Rule ID 11099 //
     /* 1745060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1745071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1745074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1745077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745106 */     // MIs[0] policy
     /* 1745106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745116 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1745119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745140 */     // GIR_Coverage, 11099,
     /* 1745140 */     GIR_EraseRootFromParent_Done,
     /* 1745141 */   // Label 23812: @1745141
     /* 1745141 */   GIM_Try, /*On fail goto*//*Label 23813*/ GIMT_Encode4(1745227), // Rule ID 11102 //
     /* 1745146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1745157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1745160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1745163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1745169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745192 */     // MIs[0] policy
     /* 1745192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745202 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1745205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745226 */     // GIR_Coverage, 11102,
     /* 1745226 */     GIR_EraseRootFromParent_Done,
     /* 1745227 */   // Label 23813: @1745227
     /* 1745227 */   GIM_Try, /*On fail goto*//*Label 23814*/ GIMT_Encode4(1745313), // Rule ID 11103 //
     /* 1745232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1745243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1745246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1745249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1745255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745278 */     // MIs[0] policy
     /* 1745278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745288 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1745291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745312 */     // GIR_Coverage, 11103,
     /* 1745312 */     GIR_EraseRootFromParent_Done,
     /* 1745313 */   // Label 23814: @1745313
     /* 1745313 */   GIM_Try, /*On fail goto*//*Label 23815*/ GIMT_Encode4(1745399), // Rule ID 11106 //
     /* 1745318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1745335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745364 */     // MIs[0] policy
     /* 1745364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745374 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745398 */     // GIR_Coverage, 11106,
     /* 1745398 */     GIR_EraseRootFromParent_Done,
     /* 1745399 */   // Label 23815: @1745399
     /* 1745399 */   GIM_Try, /*On fail goto*//*Label 23816*/ GIMT_Encode4(1745485), // Rule ID 11107 //
     /* 1745404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1745421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745450 */     // MIs[0] policy
     /* 1745450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745484 */     // GIR_Coverage, 11107,
     /* 1745484 */     GIR_EraseRootFromParent_Done,
     /* 1745485 */   // Label 23816: @1745485
     /* 1745485 */   GIM_Try, /*On fail goto*//*Label 23817*/ GIMT_Encode4(1745571), // Rule ID 11110 //
     /* 1745490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1745501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1745504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1745507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745536 */     // MIs[0] policy
     /* 1745536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1745549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745570 */     // GIR_Coverage, 11110,
     /* 1745570 */     GIR_EraseRootFromParent_Done,
     /* 1745571 */   // Label 23817: @1745571
     /* 1745571 */   GIM_Try, /*On fail goto*//*Label 23818*/ GIMT_Encode4(1745657), // Rule ID 11111 //
     /* 1745576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1745587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1745590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1745593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745622 */     // MIs[0] policy
     /* 1745622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745632 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1745635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745656 */     // GIR_Coverage, 11111,
     /* 1745656 */     GIR_EraseRootFromParent_Done,
     /* 1745657 */   // Label 23818: @1745657
     /* 1745657 */   GIM_Try, /*On fail goto*//*Label 23819*/ GIMT_Encode4(1745743), // Rule ID 11114 //
     /* 1745662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1745673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1745676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1745679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745708 */     // MIs[0] policy
     /* 1745708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745718 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1745721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745742 */     // GIR_Coverage, 11114,
     /* 1745742 */     GIR_EraseRootFromParent_Done,
     /* 1745743 */   // Label 23819: @1745743
     /* 1745743 */   GIM_Try, /*On fail goto*//*Label 23820*/ GIMT_Encode4(1745829), // Rule ID 11115 //
     /* 1745748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1745759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1745762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1745765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745794 */     // MIs[0] policy
     /* 1745794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745804 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1745807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745828 */     // GIR_Coverage, 11115,
     /* 1745828 */     GIR_EraseRootFromParent_Done,
     /* 1745829 */   // Label 23820: @1745829
     /* 1745829 */   GIM_Try, /*On fail goto*//*Label 23821*/ GIMT_Encode4(1745915), // Rule ID 11118 //
     /* 1745834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1745845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1745848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1745851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1745857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745880 */     // MIs[0] policy
     /* 1745880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1745911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745914 */     // GIR_Coverage, 11118,
     /* 1745914 */     GIR_EraseRootFromParent_Done,
     /* 1745915 */   // Label 23821: @1745915
     /* 1745915 */   GIM_Try, /*On fail goto*//*Label 23822*/ GIMT_Encode4(1746001), // Rule ID 11119 //
     /* 1745920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1745931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1745934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1745937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1745943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745966 */     // MIs[0] policy
     /* 1745966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745976 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1745997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746000 */     // GIR_Coverage, 11119,
     /* 1746000 */     GIR_EraseRootFromParent_Done,
     /* 1746001 */   // Label 23822: @1746001
     /* 1746001 */   GIM_Try, /*On fail goto*//*Label 23823*/ GIMT_Encode4(1746087), // Rule ID 11122 //
     /* 1746006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1746023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746052 */     // MIs[0] policy
     /* 1746052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746062 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746086 */     // GIR_Coverage, 11122,
     /* 1746086 */     GIR_EraseRootFromParent_Done,
     /* 1746087 */   // Label 23823: @1746087
     /* 1746087 */   GIM_Try, /*On fail goto*//*Label 23824*/ GIMT_Encode4(1746173), // Rule ID 11123 //
     /* 1746092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1746109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746138 */     // MIs[0] policy
     /* 1746138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746148 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746172 */     // GIR_Coverage, 11123,
     /* 1746172 */     GIR_EraseRootFromParent_Done,
     /* 1746173 */   // Label 23824: @1746173
     /* 1746173 */   GIM_Try, /*On fail goto*//*Label 23825*/ GIMT_Encode4(1746259), // Rule ID 11126 //
     /* 1746178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1746195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746224 */     // MIs[0] policy
     /* 1746224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746234 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746258 */     // GIR_Coverage, 11126,
     /* 1746258 */     GIR_EraseRootFromParent_Done,
     /* 1746259 */   // Label 23825: @1746259
     /* 1746259 */   GIM_Try, /*On fail goto*//*Label 23826*/ GIMT_Encode4(1746345), // Rule ID 11127 //
     /* 1746264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1746281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746310 */     // MIs[0] policy
     /* 1746310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746320 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746344 */     // GIR_Coverage, 11127,
     /* 1746344 */     GIR_EraseRootFromParent_Done,
     /* 1746345 */   // Label 23826: @1746345
     /* 1746345 */   GIM_Try, /*On fail goto*//*Label 23827*/ GIMT_Encode4(1746431), // Rule ID 11130 //
     /* 1746350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1746353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1746361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1746364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1746367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746396 */     // MIs[0] policy
     /* 1746396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746406 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1746409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746430 */     // GIR_Coverage, 11130,
     /* 1746430 */     GIR_EraseRootFromParent_Done,
     /* 1746431 */   // Label 23827: @1746431
     /* 1746431 */   GIM_Try, /*On fail goto*//*Label 23828*/ GIMT_Encode4(1746517), // Rule ID 11131 //
     /* 1746436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1746439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1746447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1746450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1746453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746482 */     // MIs[0] policy
     /* 1746482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746492 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1746495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746516 */     // GIR_Coverage, 11131,
     /* 1746516 */     GIR_EraseRootFromParent_Done,
     /* 1746517 */   // Label 23828: @1746517
     /* 1746517 */   GIM_Try, /*On fail goto*//*Label 23829*/ GIMT_Encode4(1746603), // Rule ID 11134 //
     /* 1746522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1746525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1746533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1746536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1746539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746568 */     // MIs[0] policy
     /* 1746568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746578 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746602 */     // GIR_Coverage, 11134,
     /* 1746602 */     GIR_EraseRootFromParent_Done,
     /* 1746603 */   // Label 23829: @1746603
     /* 1746603 */   GIM_Try, /*On fail goto*//*Label 23830*/ GIMT_Encode4(1746689), // Rule ID 11135 //
     /* 1746608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1746611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1746619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1746622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1746625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746654 */     // MIs[0] policy
     /* 1746654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746664 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746688 */     // GIR_Coverage, 11135,
     /* 1746688 */     GIR_EraseRootFromParent_Done,
     /* 1746689 */   // Label 23830: @1746689
     /* 1746689 */   GIM_Try, /*On fail goto*//*Label 23831*/ GIMT_Encode4(1746775), // Rule ID 11138 //
     /* 1746694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1746697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1746705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1746708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1746711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746740 */     // MIs[0] policy
     /* 1746740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746750 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746774 */     // GIR_Coverage, 11138,
     /* 1746774 */     GIR_EraseRootFromParent_Done,
     /* 1746775 */   // Label 23831: @1746775
     /* 1746775 */   GIM_Try, /*On fail goto*//*Label 23832*/ GIMT_Encode4(1746861), // Rule ID 11139 //
     /* 1746780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1746783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1746791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1746794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1746797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746826 */     // MIs[0] policy
     /* 1746826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746836 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746860 */     // GIR_Coverage, 11139,
     /* 1746860 */     GIR_EraseRootFromParent_Done,
     /* 1746861 */   // Label 23832: @1746861
     /* 1746861 */   GIM_Try, /*On fail goto*//*Label 23833*/ GIMT_Encode4(1746947), // Rule ID 11142 //
     /* 1746866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1746877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1746880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1746883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1746886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1746889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746912 */     // MIs[0] policy
     /* 1746912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746922 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1746925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746946 */     // GIR_Coverage, 11142,
     /* 1746946 */     GIR_EraseRootFromParent_Done,
     /* 1746947 */   // Label 23833: @1746947
     /* 1746947 */   GIM_Try, /*On fail goto*//*Label 23834*/ GIMT_Encode4(1747033), // Rule ID 11143 //
     /* 1746952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1746963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1746966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1746969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1746972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1746975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746998 */     // MIs[0] policy
     /* 1746998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747008 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1747011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747032 */     // GIR_Coverage, 11143,
     /* 1747032 */     GIR_EraseRootFromParent_Done,
     /* 1747033 */   // Label 23834: @1747033
     /* 1747033 */   GIM_Try, /*On fail goto*//*Label 23835*/ GIMT_Encode4(1747119), // Rule ID 11146 //
     /* 1747038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1747049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1747052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1747055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1747058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747084 */     // MIs[0] policy
     /* 1747084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747094 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747118 */     // GIR_Coverage, 11146,
     /* 1747118 */     GIR_EraseRootFromParent_Done,
     /* 1747119 */   // Label 23835: @1747119
     /* 1747119 */   GIM_Try, /*On fail goto*//*Label 23836*/ GIMT_Encode4(1747205), // Rule ID 11147 //
     /* 1747124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1747135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1747138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1747141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1747144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747170 */     // MIs[0] policy
     /* 1747170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747180 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747204 */     // GIR_Coverage, 11147,
     /* 1747204 */     GIR_EraseRootFromParent_Done,
     /* 1747205 */   // Label 23836: @1747205
     /* 1747205 */   GIM_Try, /*On fail goto*//*Label 23837*/ GIMT_Encode4(1747291), // Rule ID 11150 //
     /* 1747210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1747221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1747224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1747227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1747230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747256 */     // MIs[0] policy
     /* 1747256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747266 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747290 */     // GIR_Coverage, 11150,
     /* 1747290 */     GIR_EraseRootFromParent_Done,
     /* 1747291 */   // Label 23837: @1747291
     /* 1747291 */   GIM_Try, /*On fail goto*//*Label 23838*/ GIMT_Encode4(1747377), // Rule ID 11151 //
     /* 1747296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1747307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1747310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1747313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1747316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747342 */     // MIs[0] policy
     /* 1747342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747352 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747376 */     // GIR_Coverage, 11151,
     /* 1747376 */     GIR_EraseRootFromParent_Done,
     /* 1747377 */   // Label 23838: @1747377
     /* 1747377 */   GIM_Try, /*On fail goto*//*Label 23839*/ GIMT_Encode4(1747463), // Rule ID 11154 //
     /* 1747382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1747393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1747396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1747399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1747402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747428 */     // MIs[0] policy
     /* 1747428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747438 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747462 */     // GIR_Coverage, 11154,
     /* 1747462 */     GIR_EraseRootFromParent_Done,
     /* 1747463 */   // Label 23839: @1747463
     /* 1747463 */   GIM_Try, /*On fail goto*//*Label 23840*/ GIMT_Encode4(1747549), // Rule ID 11155 //
     /* 1747468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1747479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1747482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1747485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1747488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747514 */     // MIs[0] policy
     /* 1747514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747524 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747548 */     // GIR_Coverage, 11155,
     /* 1747548 */     GIR_EraseRootFromParent_Done,
     /* 1747549 */   // Label 23840: @1747549
     /* 1747549 */   GIM_Try, /*On fail goto*//*Label 23841*/ GIMT_Encode4(1747635), // Rule ID 11158 //
     /* 1747554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1747565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1747568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1747571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1747574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747600 */     // MIs[0] policy
     /* 1747600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747610 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747634 */     // GIR_Coverage, 11158,
     /* 1747634 */     GIR_EraseRootFromParent_Done,
     /* 1747635 */   // Label 23841: @1747635
     /* 1747635 */   GIM_Try, /*On fail goto*//*Label 23842*/ GIMT_Encode4(1747721), // Rule ID 11159 //
     /* 1747640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1747651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1747654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1747657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1747660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747686 */     // MIs[0] policy
     /* 1747686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747720 */     // GIR_Coverage, 11159,
     /* 1747720 */     GIR_EraseRootFromParent_Done,
     /* 1747721 */   // Label 23842: @1747721
     /* 1747721 */   GIM_Try, /*On fail goto*//*Label 23843*/ GIMT_Encode4(1747807), // Rule ID 11162 //
     /* 1747726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1747737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1747740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1747743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1747746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747772 */     // MIs[0] policy
     /* 1747772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747806 */     // GIR_Coverage, 11162,
     /* 1747806 */     GIR_EraseRootFromParent_Done,
     /* 1747807 */   // Label 23843: @1747807
     /* 1747807 */   GIM_Try, /*On fail goto*//*Label 23844*/ GIMT_Encode4(1747893), // Rule ID 11163 //
     /* 1747812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1747823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1747826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1747829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1747832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747858 */     // MIs[0] policy
     /* 1747858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747892 */     // GIR_Coverage, 11163,
     /* 1747892 */     GIR_EraseRootFromParent_Done,
     /* 1747893 */   // Label 23844: @1747893
     /* 1747893 */   GIM_Try, /*On fail goto*//*Label 23845*/ GIMT_Encode4(1747979), // Rule ID 11166 //
     /* 1747898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1747909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1747912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1747915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1747918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747944 */     // MIs[0] policy
     /* 1747944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747954 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1747957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747978 */     // GIR_Coverage, 11166,
     /* 1747978 */     GIR_EraseRootFromParent_Done,
     /* 1747979 */   // Label 23845: @1747979
     /* 1747979 */   GIM_Try, /*On fail goto*//*Label 23846*/ GIMT_Encode4(1748065), // Rule ID 11167 //
     /* 1747984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1747995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1747998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1748001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1748004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748030 */     // MIs[0] policy
     /* 1748030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748064 */     // GIR_Coverage, 11167,
     /* 1748064 */     GIR_EraseRootFromParent_Done,
     /* 1748065 */   // Label 23846: @1748065
     /* 1748065 */   GIM_Try, /*On fail goto*//*Label 23847*/ GIMT_Encode4(1748151), // Rule ID 11170 //
     /* 1748070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1748081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1748084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1748087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1748090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748116 */     // MIs[0] policy
     /* 1748116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748126 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748150 */     // GIR_Coverage, 11170,
     /* 1748150 */     GIR_EraseRootFromParent_Done,
     /* 1748151 */   // Label 23847: @1748151
     /* 1748151 */   GIM_Try, /*On fail goto*//*Label 23848*/ GIMT_Encode4(1748237), // Rule ID 11171 //
     /* 1748156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1748167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1748170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1748173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1748176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748202 */     // MIs[0] policy
     /* 1748202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748212 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748236 */     // GIR_Coverage, 11171,
     /* 1748236 */     GIR_EraseRootFromParent_Done,
     /* 1748237 */   // Label 23848: @1748237
     /* 1748237 */   GIM_Try, /*On fail goto*//*Label 23849*/ GIMT_Encode4(1748323), // Rule ID 11174 //
     /* 1748242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1748253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1748256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1748259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1748262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748288 */     // MIs[0] policy
     /* 1748288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748298 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748322 */     // GIR_Coverage, 11174,
     /* 1748322 */     GIR_EraseRootFromParent_Done,
     /* 1748323 */   // Label 23849: @1748323
     /* 1748323 */   GIM_Try, /*On fail goto*//*Label 23850*/ GIMT_Encode4(1748409), // Rule ID 11175 //
     /* 1748328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1748339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1748342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1748345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1748348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748374 */     // MIs[0] policy
     /* 1748374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748384 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748408 */     // GIR_Coverage, 11175,
     /* 1748408 */     GIR_EraseRootFromParent_Done,
     /* 1748409 */   // Label 23850: @1748409
     /* 1748409 */   GIM_Try, /*On fail goto*//*Label 23851*/ GIMT_Encode4(1748495), // Rule ID 11178 //
     /* 1748414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1748425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1748428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1748431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1748434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748460 */     // MIs[0] policy
     /* 1748460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748470 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1748473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748494 */     // GIR_Coverage, 11178,
     /* 1748494 */     GIR_EraseRootFromParent_Done,
     /* 1748495 */   // Label 23851: @1748495
     /* 1748495 */   GIM_Try, /*On fail goto*//*Label 23852*/ GIMT_Encode4(1748581), // Rule ID 11179 //
     /* 1748500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1748511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1748514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1748517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1748520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748546 */     // MIs[0] policy
     /* 1748546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748556 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1748559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748580 */     // GIR_Coverage, 11179,
     /* 1748580 */     GIR_EraseRootFromParent_Done,
     /* 1748581 */   // Label 23852: @1748581
     /* 1748581 */   GIM_Try, /*On fail goto*//*Label 23853*/ GIMT_Encode4(1748667), // Rule ID 11182 //
     /* 1748586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1748597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1748600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1748603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1748606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1748609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1748616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748632 */     // MIs[0] policy
     /* 1748632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748642 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1748645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748666 */     // GIR_Coverage, 11182,
     /* 1748666 */     GIR_EraseRootFromParent_Done,
     /* 1748667 */   // Label 23853: @1748667
     /* 1748667 */   GIM_Try, /*On fail goto*//*Label 23854*/ GIMT_Encode4(1748753), // Rule ID 11183 //
     /* 1748672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1748683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1748686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1748689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1748692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1748695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1748702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748718 */     // MIs[0] policy
     /* 1748718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748728 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1748731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748752 */     // GIR_Coverage, 11183,
     /* 1748752 */     GIR_EraseRootFromParent_Done,
     /* 1748753 */   // Label 23854: @1748753
     /* 1748753 */   GIM_Try, /*On fail goto*//*Label 23855*/ GIMT_Encode4(1748839), // Rule ID 11186 //
     /* 1748758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1748769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1748772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1748775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1748778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1748781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1748788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748804 */     // MIs[0] policy
     /* 1748804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748814 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1748817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748838 */     // GIR_Coverage, 11186,
     /* 1748838 */     GIR_EraseRootFromParent_Done,
     /* 1748839 */   // Label 23855: @1748839
     /* 1748839 */   GIM_Try, /*On fail goto*//*Label 23856*/ GIMT_Encode4(1748925), // Rule ID 11187 //
     /* 1748844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1748855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1748858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1748861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1748864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1748867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1748874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748890 */     // MIs[0] policy
     /* 1748890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748900 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1748903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748924 */     // GIR_Coverage, 11187,
     /* 1748924 */     GIR_EraseRootFromParent_Done,
     /* 1748925 */   // Label 23856: @1748925
     /* 1748925 */   GIM_Try, /*On fail goto*//*Label 23857*/ GIMT_Encode4(1749011), // Rule ID 11190 //
     /* 1748930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1748941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1748944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1748947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1748950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748976 */     // MIs[0] policy
     /* 1748976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1748989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749010 */     // GIR_Coverage, 11190,
     /* 1749010 */     GIR_EraseRootFromParent_Done,
     /* 1749011 */   // Label 23857: @1749011
     /* 1749011 */   GIM_Try, /*On fail goto*//*Label 23858*/ GIMT_Encode4(1749097), // Rule ID 11191 //
     /* 1749016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1749027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1749030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1749033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1749036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749062 */     // MIs[0] policy
     /* 1749062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749072 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749096 */     // GIR_Coverage, 11191,
     /* 1749096 */     GIR_EraseRootFromParent_Done,
     /* 1749097 */   // Label 23858: @1749097
     /* 1749097 */   GIM_Try, /*On fail goto*//*Label 23859*/ GIMT_Encode4(1749183), // Rule ID 11194 //
     /* 1749102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1749113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1749116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1749119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1749122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749148 */     // MIs[0] policy
     /* 1749148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749158 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749182 */     // GIR_Coverage, 11194,
     /* 1749182 */     GIR_EraseRootFromParent_Done,
     /* 1749183 */   // Label 23859: @1749183
     /* 1749183 */   GIM_Try, /*On fail goto*//*Label 23860*/ GIMT_Encode4(1749269), // Rule ID 11195 //
     /* 1749188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1749199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1749202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1749205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1749208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749234 */     // MIs[0] policy
     /* 1749234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749268 */     // GIR_Coverage, 11195,
     /* 1749268 */     GIR_EraseRootFromParent_Done,
     /* 1749269 */   // Label 23860: @1749269
     /* 1749269 */   GIM_Try, /*On fail goto*//*Label 23861*/ GIMT_Encode4(1749355), // Rule ID 11198 //
     /* 1749274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1749285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1749288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1749291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1749294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749320 */     // MIs[0] policy
     /* 1749320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749330 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749354 */     // GIR_Coverage, 11198,
     /* 1749354 */     GIR_EraseRootFromParent_Done,
     /* 1749355 */   // Label 23861: @1749355
     /* 1749355 */   GIM_Try, /*On fail goto*//*Label 23862*/ GIMT_Encode4(1749441), // Rule ID 11199 //
     /* 1749360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1749371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1749374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1749377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1749380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749406 */     // MIs[0] policy
     /* 1749406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749416 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749440 */     // GIR_Coverage, 11199,
     /* 1749440 */     GIR_EraseRootFromParent_Done,
     /* 1749441 */   // Label 23862: @1749441
     /* 1749441 */   GIM_Try, /*On fail goto*//*Label 23863*/ GIMT_Encode4(1749527), // Rule ID 11202 //
     /* 1749446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1749457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1749460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1749463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1749466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749492 */     // MIs[0] policy
     /* 1749492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749526 */     // GIR_Coverage, 11202,
     /* 1749526 */     GIR_EraseRootFromParent_Done,
     /* 1749527 */   // Label 23863: @1749527
     /* 1749527 */   GIM_Try, /*On fail goto*//*Label 23864*/ GIMT_Encode4(1749613), // Rule ID 11203 //
     /* 1749532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1749543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1749546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1749549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1749552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749578 */     // MIs[0] policy
     /* 1749578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749612 */     // GIR_Coverage, 11203,
     /* 1749612 */     GIR_EraseRootFromParent_Done,
     /* 1749613 */   // Label 23864: @1749613
     /* 1749613 */   GIM_Try, /*On fail goto*//*Label 23865*/ GIMT_Encode4(1749699), // Rule ID 11206 //
     /* 1749618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1749629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1749632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1749635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1749638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749664 */     // MIs[0] policy
     /* 1749664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749698 */     // GIR_Coverage, 11206,
     /* 1749698 */     GIR_EraseRootFromParent_Done,
     /* 1749699 */   // Label 23865: @1749699
     /* 1749699 */   GIM_Try, /*On fail goto*//*Label 23866*/ GIMT_Encode4(1749785), // Rule ID 11207 //
     /* 1749704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1749715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1749718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1749721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1749724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749750 */     // MIs[0] policy
     /* 1749750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749760 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749784 */     // GIR_Coverage, 11207,
     /* 1749784 */     GIR_EraseRootFromParent_Done,
     /* 1749785 */   // Label 23866: @1749785
     /* 1749785 */   GIM_Try, /*On fail goto*//*Label 23867*/ GIMT_Encode4(1749871), // Rule ID 11210 //
     /* 1749790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1749801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1749804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1749807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1749810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749836 */     // MIs[0] policy
     /* 1749836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749846 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749870 */     // GIR_Coverage, 11210,
     /* 1749870 */     GIR_EraseRootFromParent_Done,
     /* 1749871 */   // Label 23867: @1749871
     /* 1749871 */   GIM_Try, /*On fail goto*//*Label 23868*/ GIMT_Encode4(1749957), // Rule ID 11211 //
     /* 1749876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1749887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1749890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1749893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1749896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749922 */     // MIs[0] policy
     /* 1749922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749932 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749956 */     // GIR_Coverage, 11211,
     /* 1749956 */     GIR_EraseRootFromParent_Done,
     /* 1749957 */   // Label 23868: @1749957
     /* 1749957 */   GIM_Try, /*On fail goto*//*Label 23869*/ GIMT_Encode4(1750043), // Rule ID 11214 //
     /* 1749962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1749973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1749976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1749979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1749985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1749992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750008 */     // MIs[0] policy
     /* 1750008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750018 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1750021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750042 */     // GIR_Coverage, 11214,
     /* 1750042 */     GIR_EraseRootFromParent_Done,
     /* 1750043 */   // Label 23869: @1750043
     /* 1750043 */   GIM_Try, /*On fail goto*//*Label 23870*/ GIMT_Encode4(1750129), // Rule ID 11215 //
     /* 1750048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1750059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1750062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1750065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750094 */     // MIs[0] policy
     /* 1750094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750104 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1750107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750128 */     // GIR_Coverage, 11215,
     /* 1750128 */     GIR_EraseRootFromParent_Done,
     /* 1750129 */   // Label 23870: @1750129
     /* 1750129 */   GIM_Try, /*On fail goto*//*Label 23871*/ GIMT_Encode4(1750215), // Rule ID 11218 //
     /* 1750134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1750145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1750148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1750151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750180 */     // MIs[0] policy
     /* 1750180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750190 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750214 */     // GIR_Coverage, 11218,
     /* 1750214 */     GIR_EraseRootFromParent_Done,
     /* 1750215 */   // Label 23871: @1750215
     /* 1750215 */   GIM_Try, /*On fail goto*//*Label 23872*/ GIMT_Encode4(1750301), // Rule ID 11219 //
     /* 1750220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1750231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1750234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1750237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750266 */     // MIs[0] policy
     /* 1750266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750276 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750300 */     // GIR_Coverage, 11219,
     /* 1750300 */     GIR_EraseRootFromParent_Done,
     /* 1750301 */   // Label 23872: @1750301
     /* 1750301 */   GIM_Try, /*On fail goto*//*Label 23873*/ GIMT_Encode4(1750387), // Rule ID 11222 //
     /* 1750306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1750317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1750320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1750323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750352 */     // MIs[0] policy
     /* 1750352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750362 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750386 */     // GIR_Coverage, 11222,
     /* 1750386 */     GIR_EraseRootFromParent_Done,
     /* 1750387 */   // Label 23873: @1750387
     /* 1750387 */   GIM_Try, /*On fail goto*//*Label 23874*/ GIMT_Encode4(1750473), // Rule ID 11223 //
     /* 1750392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1750403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1750406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1750409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750438 */     // MIs[0] policy
     /* 1750438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750448 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750472 */     // GIR_Coverage, 11223,
     /* 1750472 */     GIR_EraseRootFromParent_Done,
     /* 1750473 */   // Label 23874: @1750473
     /* 1750473 */   GIM_Try, /*On fail goto*//*Label 23875*/ GIMT_Encode4(1750559), // Rule ID 11226 //
     /* 1750478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1750489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1750492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1750495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750524 */     // MIs[0] policy
     /* 1750524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750534 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750558 */     // GIR_Coverage, 11226,
     /* 1750558 */     GIR_EraseRootFromParent_Done,
     /* 1750559 */   // Label 23875: @1750559
     /* 1750559 */   GIM_Try, /*On fail goto*//*Label 23876*/ GIMT_Encode4(1750645), // Rule ID 11227 //
     /* 1750564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1750575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1750578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1750581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750610 */     // MIs[0] policy
     /* 1750610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750620 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750644 */     // GIR_Coverage, 11227,
     /* 1750644 */     GIR_EraseRootFromParent_Done,
     /* 1750645 */   // Label 23876: @1750645
     /* 1750645 */   GIM_Try, /*On fail goto*//*Label 23877*/ GIMT_Encode4(1750731), // Rule ID 11230 //
     /* 1750650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1750661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1750664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1750667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750696 */     // MIs[0] policy
     /* 1750696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750730 */     // GIR_Coverage, 11230,
     /* 1750730 */     GIR_EraseRootFromParent_Done,
     /* 1750731 */   // Label 23877: @1750731
     /* 1750731 */   GIM_Try, /*On fail goto*//*Label 23878*/ GIMT_Encode4(1750817), // Rule ID 11231 //
     /* 1750736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1750747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1750750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1750753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750782 */     // MIs[0] policy
     /* 1750782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750792 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750816 */     // GIR_Coverage, 11231,
     /* 1750816 */     GIR_EraseRootFromParent_Done,
     /* 1750817 */   // Label 23878: @1750817
     /* 1750817 */   GIM_Try, /*On fail goto*//*Label 23879*/ GIMT_Encode4(1750903), // Rule ID 11234 //
     /* 1750822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1750833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1750836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1750839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750868 */     // MIs[0] policy
     /* 1750868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750878 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750902 */     // GIR_Coverage, 11234,
     /* 1750902 */     GIR_EraseRootFromParent_Done,
     /* 1750903 */   // Label 23879: @1750903
     /* 1750903 */   GIM_Try, /*On fail goto*//*Label 23880*/ GIMT_Encode4(1750989), // Rule ID 11235 //
     /* 1750908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1750919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1750922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1750925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750954 */     // MIs[0] policy
     /* 1750954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750964 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750988 */     // GIR_Coverage, 11235,
     /* 1750988 */     GIR_EraseRootFromParent_Done,
     /* 1750989 */   // Label 23880: @1750989
     /* 1750989 */   GIM_Try, /*On fail goto*//*Label 23881*/ GIMT_Encode4(1751075), // Rule ID 11238 //
     /* 1750994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1751005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1751008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1751011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751040 */     // MIs[0] policy
     /* 1751040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751050 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751074 */     // GIR_Coverage, 11238,
     /* 1751074 */     GIR_EraseRootFromParent_Done,
     /* 1751075 */   // Label 23881: @1751075
     /* 1751075 */   GIM_Try, /*On fail goto*//*Label 23882*/ GIMT_Encode4(1751161), // Rule ID 11239 //
     /* 1751080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1751091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1751094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1751097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751126 */     // MIs[0] policy
     /* 1751126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751136 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751160 */     // GIR_Coverage, 11239,
     /* 1751160 */     GIR_EraseRootFromParent_Done,
     /* 1751161 */   // Label 23882: @1751161
     /* 1751161 */   GIM_Try, /*On fail goto*//*Label 23883*/ GIMT_Encode4(1751247), // Rule ID 11242 //
     /* 1751166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1751177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1751180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1751183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751212 */     // MIs[0] policy
     /* 1751212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751222 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751246 */     // GIR_Coverage, 11242,
     /* 1751246 */     GIR_EraseRootFromParent_Done,
     /* 1751247 */   // Label 23883: @1751247
     /* 1751247 */   GIM_Try, /*On fail goto*//*Label 23884*/ GIMT_Encode4(1751333), // Rule ID 11243 //
     /* 1751252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1751263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1751266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1751269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751298 */     // MIs[0] policy
     /* 1751298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751332 */     // GIR_Coverage, 11243,
     /* 1751332 */     GIR_EraseRootFromParent_Done,
     /* 1751333 */   // Label 23884: @1751333
     /* 1751333 */   GIM_Try, /*On fail goto*//*Label 23885*/ GIMT_Encode4(1751419), // Rule ID 11246 //
     /* 1751338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1751349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1751352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1751355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751384 */     // MIs[0] policy
     /* 1751384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751394 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751418 */     // GIR_Coverage, 11246,
     /* 1751418 */     GIR_EraseRootFromParent_Done,
     /* 1751419 */   // Label 23885: @1751419
     /* 1751419 */   GIM_Try, /*On fail goto*//*Label 23886*/ GIMT_Encode4(1751505), // Rule ID 11247 //
     /* 1751424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1751435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1751438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1751441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751470 */     // MIs[0] policy
     /* 1751470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751480 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751504 */     // GIR_Coverage, 11247,
     /* 1751504 */     GIR_EraseRootFromParent_Done,
     /* 1751505 */   // Label 23886: @1751505
     /* 1751505 */   GIM_Try, /*On fail goto*//*Label 23887*/ GIMT_Encode4(1751591), // Rule ID 11250 //
     /* 1751510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1751521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1751524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1751527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1751533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1751540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751556 */     // MIs[0] policy
     /* 1751556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751566 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1751569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751590 */     // GIR_Coverage, 11250,
     /* 1751590 */     GIR_EraseRootFromParent_Done,
     /* 1751591 */   // Label 23887: @1751591
     /* 1751591 */   GIM_Try, /*On fail goto*//*Label 23888*/ GIMT_Encode4(1751677), // Rule ID 11251 //
     /* 1751596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1751607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1751610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1751613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1751619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1751626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751642 */     // MIs[0] policy
     /* 1751642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751652 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1751655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751676 */     // GIR_Coverage, 11251,
     /* 1751676 */     GIR_EraseRootFromParent_Done,
     /* 1751677 */   // Label 23888: @1751677
     /* 1751677 */   GIM_Try, /*On fail goto*//*Label 23889*/ GIMT_Encode4(1751763), // Rule ID 11254 //
     /* 1751682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1751693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1751696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1751699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1751705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1751712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751728 */     // MIs[0] policy
     /* 1751728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751738 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1751741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751762 */     // GIR_Coverage, 11254,
     /* 1751762 */     GIR_EraseRootFromParent_Done,
     /* 1751763 */   // Label 23889: @1751763
     /* 1751763 */   GIM_Try, /*On fail goto*//*Label 23890*/ GIMT_Encode4(1751849), // Rule ID 11255 //
     /* 1751768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1751779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1751782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1751785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1751791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1751798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751814 */     // MIs[0] policy
     /* 1751814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751824 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1751827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751848 */     // GIR_Coverage, 11255,
     /* 1751848 */     GIR_EraseRootFromParent_Done,
     /* 1751849 */   // Label 23890: @1751849
     /* 1751849 */   GIM_Try, /*On fail goto*//*Label 23891*/ GIMT_Encode4(1751935), // Rule ID 11258 //
     /* 1751854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1751865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1751868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1751871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1751877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1751884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751900 */     // MIs[0] policy
     /* 1751900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751910 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1751913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751934 */     // GIR_Coverage, 11258,
     /* 1751934 */     GIR_EraseRootFromParent_Done,
     /* 1751935 */   // Label 23891: @1751935
     /* 1751935 */   GIM_Try, /*On fail goto*//*Label 23892*/ GIMT_Encode4(1752021), // Rule ID 11259 //
     /* 1751940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1751951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1751954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1751957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1751963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1751970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751986 */     // MIs[0] policy
     /* 1751986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751996 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1751999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752020 */     // GIR_Coverage, 11259,
     /* 1752020 */     GIR_EraseRootFromParent_Done,
     /* 1752021 */   // Label 23892: @1752021
     /* 1752021 */   GIM_Try, /*On fail goto*//*Label 23893*/ GIMT_Encode4(1752107), // Rule ID 11262 //
     /* 1752026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1752037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1752040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1752043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752072 */     // MIs[0] policy
     /* 1752072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752082 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752106 */     // GIR_Coverage, 11262,
     /* 1752106 */     GIR_EraseRootFromParent_Done,
     /* 1752107 */   // Label 23893: @1752107
     /* 1752107 */   GIM_Try, /*On fail goto*//*Label 23894*/ GIMT_Encode4(1752193), // Rule ID 11263 //
     /* 1752112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1752123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1752126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1752129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752158 */     // MIs[0] policy
     /* 1752158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752192 */     // GIR_Coverage, 11263,
     /* 1752192 */     GIR_EraseRootFromParent_Done,
     /* 1752193 */   // Label 23894: @1752193
     /* 1752193 */   GIM_Try, /*On fail goto*//*Label 23895*/ GIMT_Encode4(1752279), // Rule ID 11266 //
     /* 1752198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1752209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1752212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1752215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752244 */     // MIs[0] policy
     /* 1752244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752254 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752278 */     // GIR_Coverage, 11266,
     /* 1752278 */     GIR_EraseRootFromParent_Done,
     /* 1752279 */   // Label 23895: @1752279
     /* 1752279 */   GIM_Try, /*On fail goto*//*Label 23896*/ GIMT_Encode4(1752365), // Rule ID 11267 //
     /* 1752284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1752295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1752298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1752301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752330 */     // MIs[0] policy
     /* 1752330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752340 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752364 */     // GIR_Coverage, 11267,
     /* 1752364 */     GIR_EraseRootFromParent_Done,
     /* 1752365 */   // Label 23896: @1752365
     /* 1752365 */   GIM_Try, /*On fail goto*//*Label 23897*/ GIMT_Encode4(1752451), // Rule ID 11270 //
     /* 1752370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1752381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1752384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1752387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752416 */     // MIs[0] policy
     /* 1752416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752426 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752450 */     // GIR_Coverage, 11270,
     /* 1752450 */     GIR_EraseRootFromParent_Done,
     /* 1752451 */   // Label 23897: @1752451
     /* 1752451 */   GIM_Try, /*On fail goto*//*Label 23898*/ GIMT_Encode4(1752537), // Rule ID 11271 //
     /* 1752456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1752467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1752470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1752473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752502 */     // MIs[0] policy
     /* 1752502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752512 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752536 */     // GIR_Coverage, 11271,
     /* 1752536 */     GIR_EraseRootFromParent_Done,
     /* 1752537 */   // Label 23898: @1752537
     /* 1752537 */   GIM_Try, /*On fail goto*//*Label 23899*/ GIMT_Encode4(1752623), // Rule ID 11274 //
     /* 1752542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1752553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1752556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1752559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1752565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752588 */     // MIs[0] policy
     /* 1752588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752622 */     // GIR_Coverage, 11274,
     /* 1752622 */     GIR_EraseRootFromParent_Done,
     /* 1752623 */   // Label 23899: @1752623
     /* 1752623 */   GIM_Try, /*On fail goto*//*Label 23900*/ GIMT_Encode4(1752709), // Rule ID 11275 //
     /* 1752628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1752639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1752642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1752645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1752651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752674 */     // MIs[0] policy
     /* 1752674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752684 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752708 */     // GIR_Coverage, 11275,
     /* 1752708 */     GIR_EraseRootFromParent_Done,
     /* 1752709 */   // Label 23900: @1752709
     /* 1752709 */   GIM_Try, /*On fail goto*//*Label 23901*/ GIMT_Encode4(1752795), // Rule ID 11278 //
     /* 1752714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1752725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1752728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1752731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752760 */     // MIs[0] policy
     /* 1752760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752770 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752794 */     // GIR_Coverage, 11278,
     /* 1752794 */     GIR_EraseRootFromParent_Done,
     /* 1752795 */   // Label 23901: @1752795
     /* 1752795 */   GIM_Try, /*On fail goto*//*Label 23902*/ GIMT_Encode4(1752881), // Rule ID 11279 //
     /* 1752800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1752811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1752814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1752817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752846 */     // MIs[0] policy
     /* 1752846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752856 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752880 */     // GIR_Coverage, 11279,
     /* 1752880 */     GIR_EraseRootFromParent_Done,
     /* 1752881 */   // Label 23902: @1752881
     /* 1752881 */   GIM_Try, /*On fail goto*//*Label 23903*/ GIMT_Encode4(1752967), // Rule ID 11282 //
     /* 1752886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1752897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1752900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1752903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752932 */     // MIs[0] policy
     /* 1752932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752942 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752966 */     // GIR_Coverage, 11282,
     /* 1752966 */     GIR_EraseRootFromParent_Done,
     /* 1752967 */   // Label 23903: @1752967
     /* 1752967 */   GIM_Try, /*On fail goto*//*Label 23904*/ GIMT_Encode4(1753053), // Rule ID 11283 //
     /* 1752972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1752983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1752986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1752989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753018 */     // MIs[0] policy
     /* 1753018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753028 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1753031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753052 */     // GIR_Coverage, 11283,
     /* 1753052 */     GIR_EraseRootFromParent_Done,
     /* 1753053 */   // Label 23904: @1753053
     /* 1753053 */   GIM_Try, /*On fail goto*//*Label 23905*/ GIMT_Encode4(1753139), // Rule ID 11286 //
     /* 1753058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1753069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1753072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1753075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1753078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753104 */     // MIs[0] policy
     /* 1753104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753114 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1753117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753138 */     // GIR_Coverage, 11286,
     /* 1753138 */     GIR_EraseRootFromParent_Done,
     /* 1753139 */   // Label 23905: @1753139
     /* 1753139 */   GIM_Try, /*On fail goto*//*Label 23906*/ GIMT_Encode4(1753225), // Rule ID 11287 //
     /* 1753144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1753155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1753158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1753161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1753164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753190 */     // MIs[0] policy
     /* 1753190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753200 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1753203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753224 */     // GIR_Coverage, 11287,
     /* 1753224 */     GIR_EraseRootFromParent_Done,
     /* 1753225 */   // Label 23906: @1753225
     /* 1753225 */   GIM_Try, /*On fail goto*//*Label 23907*/ GIMT_Encode4(1753311), // Rule ID 11290 //
     /* 1753230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1753241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1753244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1753247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1753250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753276 */     // MIs[0] policy
     /* 1753276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753286 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1753289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753310 */     // GIR_Coverage, 11290,
     /* 1753310 */     GIR_EraseRootFromParent_Done,
     /* 1753311 */   // Label 23907: @1753311
     /* 1753311 */   GIM_Try, /*On fail goto*//*Label 23908*/ GIMT_Encode4(1753397), // Rule ID 11291 //
     /* 1753316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1753327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1753330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1753333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1753336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753362 */     // MIs[0] policy
     /* 1753362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753372 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1753375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753396 */     // GIR_Coverage, 11291,
     /* 1753396 */     GIR_EraseRootFromParent_Done,
     /* 1753397 */   // Label 23908: @1753397
     /* 1753397 */   GIM_Try, /*On fail goto*//*Label 23909*/ GIMT_Encode4(1753483), // Rule ID 11294 //
     /* 1753402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1753413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1753416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1753419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1753422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753448 */     // MIs[0] policy
     /* 1753448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753458 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1753461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753482 */     // GIR_Coverage, 11294,
     /* 1753482 */     GIR_EraseRootFromParent_Done,
     /* 1753483 */   // Label 23909: @1753483
     /* 1753483 */   GIM_Try, /*On fail goto*//*Label 23910*/ GIMT_Encode4(1753569), // Rule ID 11295 //
     /* 1753488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1753499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1753502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1753505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1753508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753534 */     // MIs[0] policy
     /* 1753534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753544 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1753547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753568 */     // GIR_Coverage, 11295,
     /* 1753568 */     GIR_EraseRootFromParent_Done,
     /* 1753569 */   // Label 23910: @1753569
     /* 1753569 */   GIM_Try, /*On fail goto*//*Label 23911*/ GIMT_Encode4(1753655), // Rule ID 11298 //
     /* 1753574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1753585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1753588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1753591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1753594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753620 */     // MIs[0] policy
     /* 1753620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1753633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753654 */     // GIR_Coverage, 11298,
     /* 1753654 */     GIR_EraseRootFromParent_Done,
     /* 1753655 */   // Label 23911: @1753655
     /* 1753655 */   GIM_Try, /*On fail goto*//*Label 23912*/ GIMT_Encode4(1753741), // Rule ID 11299 //
     /* 1753660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1753671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1753674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1753677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1753680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753706 */     // MIs[0] policy
     /* 1753706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753716 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1753719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753740 */     // GIR_Coverage, 11299,
     /* 1753740 */     GIR_EraseRootFromParent_Done,
     /* 1753741 */   // Label 23912: @1753741
     /* 1753741 */   GIM_Try, /*On fail goto*//*Label 23913*/ GIMT_Encode4(1753827), // Rule ID 11302 //
     /* 1753746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1753757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1753760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1753763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1753766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753792 */     // MIs[0] policy
     /* 1753792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753802 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1753805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753826 */     // GIR_Coverage, 11302,
     /* 1753826 */     GIR_EraseRootFromParent_Done,
     /* 1753827 */   // Label 23913: @1753827
     /* 1753827 */   GIM_Try, /*On fail goto*//*Label 23914*/ GIMT_Encode4(1753913), // Rule ID 11303 //
     /* 1753832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1753843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1753846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1753849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1753852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753878 */     // MIs[0] policy
     /* 1753878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753888 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1753891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753912 */     // GIR_Coverage, 11303,
     /* 1753912 */     GIR_EraseRootFromParent_Done,
     /* 1753913 */   // Label 23914: @1753913
     /* 1753913 */   GIM_Try, /*On fail goto*//*Label 23915*/ GIMT_Encode4(1753999), // Rule ID 11306 //
     /* 1753918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1753929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1753932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1753935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1753938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753964 */     // MIs[0] policy
     /* 1753964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753974 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1753977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753998 */     // GIR_Coverage, 11306,
     /* 1753998 */     GIR_EraseRootFromParent_Done,
     /* 1753999 */   // Label 23915: @1753999
     /* 1753999 */   GIM_Try, /*On fail goto*//*Label 23916*/ GIMT_Encode4(1754085), // Rule ID 11307 //
     /* 1754004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1754015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1754018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1754021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1754024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754050 */     // MIs[0] policy
     /* 1754050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754060 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1754063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754084 */     // GIR_Coverage, 11307,
     /* 1754084 */     GIR_EraseRootFromParent_Done,
     /* 1754085 */   // Label 23916: @1754085
     /* 1754085 */   GIM_Try, /*On fail goto*//*Label 23917*/ GIMT_Encode4(1754171), // Rule ID 11310 //
     /* 1754090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1754101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1754104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1754107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1754110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754136 */     // MIs[0] policy
     /* 1754136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754146 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754170 */     // GIR_Coverage, 11310,
     /* 1754170 */     GIR_EraseRootFromParent_Done,
     /* 1754171 */   // Label 23917: @1754171
     /* 1754171 */   GIM_Try, /*On fail goto*//*Label 23918*/ GIMT_Encode4(1754257), // Rule ID 11311 //
     /* 1754176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1754187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1754190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1754193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1754196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754222 */     // MIs[0] policy
     /* 1754222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754256 */     // GIR_Coverage, 11311,
     /* 1754256 */     GIR_EraseRootFromParent_Done,
     /* 1754257 */   // Label 23918: @1754257
     /* 1754257 */   GIM_Try, /*On fail goto*//*Label 23919*/ GIMT_Encode4(1754343), // Rule ID 11314 //
     /* 1754262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1754273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1754276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1754279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1754282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754308 */     // MIs[0] policy
     /* 1754308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754342 */     // GIR_Coverage, 11314,
     /* 1754342 */     GIR_EraseRootFromParent_Done,
     /* 1754343 */   // Label 23919: @1754343
     /* 1754343 */   GIM_Try, /*On fail goto*//*Label 23920*/ GIMT_Encode4(1754429), // Rule ID 11315 //
     /* 1754348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1754359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1754362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1754365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1754368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754394 */     // MIs[0] policy
     /* 1754394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754404 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754428 */     // GIR_Coverage, 11315,
     /* 1754428 */     GIR_EraseRootFromParent_Done,
     /* 1754429 */   // Label 23920: @1754429
     /* 1754429 */   GIM_Try, /*On fail goto*//*Label 23921*/ GIMT_Encode4(1754515), // Rule ID 11318 //
     /* 1754434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1754445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1754448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1754451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1754454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754480 */     // MIs[0] policy
     /* 1754480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754514 */     // GIR_Coverage, 11318,
     /* 1754514 */     GIR_EraseRootFromParent_Done,
     /* 1754515 */   // Label 23921: @1754515
     /* 1754515 */   GIM_Try, /*On fail goto*//*Label 23922*/ GIMT_Encode4(1754601), // Rule ID 11319 //
     /* 1754520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1754531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1754534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1754537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1754540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754566 */     // MIs[0] policy
     /* 1754566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754600 */     // GIR_Coverage, 11319,
     /* 1754600 */     GIR_EraseRootFromParent_Done,
     /* 1754601 */   // Label 23922: @1754601
     /* 1754601 */   GIM_Try, /*On fail goto*//*Label 23923*/ GIMT_Encode4(1754687), // Rule ID 11322 //
     /* 1754606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1754617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1754620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1754623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1754626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1754629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1754636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754652 */     // MIs[0] policy
     /* 1754652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754662 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1754665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754686 */     // GIR_Coverage, 11322,
     /* 1754686 */     GIR_EraseRootFromParent_Done,
     /* 1754687 */   // Label 23923: @1754687
     /* 1754687 */   GIM_Try, /*On fail goto*//*Label 23924*/ GIMT_Encode4(1754773), // Rule ID 11323 //
     /* 1754692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1754703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1754706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1754709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1754712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1754715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1754722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754738 */     // MIs[0] policy
     /* 1754738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754748 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1754751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754772 */     // GIR_Coverage, 11323,
     /* 1754772 */     GIR_EraseRootFromParent_Done,
     /* 1754773 */   // Label 23924: @1754773
     /* 1754773 */   GIM_Try, /*On fail goto*//*Label 23925*/ GIMT_Encode4(1754859), // Rule ID 11326 //
     /* 1754778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1754789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1754792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1754795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1754798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1754801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1754808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754824 */     // MIs[0] policy
     /* 1754824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754834 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1754837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754858 */     // GIR_Coverage, 11326,
     /* 1754858 */     GIR_EraseRootFromParent_Done,
     /* 1754859 */   // Label 23925: @1754859
     /* 1754859 */   GIM_Try, /*On fail goto*//*Label 23926*/ GIMT_Encode4(1754945), // Rule ID 11327 //
     /* 1754864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1754875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1754878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1754881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1754884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1754887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1754894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754910 */     // MIs[0] policy
     /* 1754910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754920 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1754923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754944 */     // GIR_Coverage, 11327,
     /* 1754944 */     GIR_EraseRootFromParent_Done,
     /* 1754945 */   // Label 23926: @1754945
     /* 1754945 */   GIM_Try, /*On fail goto*//*Label 23927*/ GIMT_Encode4(1755031), // Rule ID 11330 //
     /* 1754950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1754961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1754964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1754967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1754970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1754973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1754980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754996 */     // MIs[0] policy
     /* 1754996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755006 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1755009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755030 */     // GIR_Coverage, 11330,
     /* 1755030 */     GIR_EraseRootFromParent_Done,
     /* 1755031 */   // Label 23927: @1755031
     /* 1755031 */   GIM_Try, /*On fail goto*//*Label 23928*/ GIMT_Encode4(1755117), // Rule ID 11331 //
     /* 1755036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1755047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1755050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1755053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1755056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1755059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755082 */     // MIs[0] policy
     /* 1755082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1755095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755116 */     // GIR_Coverage, 11331,
     /* 1755116 */     GIR_EraseRootFromParent_Done,
     /* 1755117 */   // Label 23928: @1755117
     /* 1755117 */   GIM_Try, /*On fail goto*//*Label 23929*/ GIMT_Encode4(1755203), // Rule ID 11334 //
     /* 1755122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1755133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1755136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1755139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1755142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755168 */     // MIs[0] policy
     /* 1755168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755178 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755202 */     // GIR_Coverage, 11334,
     /* 1755202 */     GIR_EraseRootFromParent_Done,
     /* 1755203 */   // Label 23929: @1755203
     /* 1755203 */   GIM_Try, /*On fail goto*//*Label 23930*/ GIMT_Encode4(1755289), // Rule ID 11335 //
     /* 1755208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1755219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1755222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1755225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1755228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755254 */     // MIs[0] policy
     /* 1755254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755264 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755288 */     // GIR_Coverage, 11335,
     /* 1755288 */     GIR_EraseRootFromParent_Done,
     /* 1755289 */   // Label 23930: @1755289
     /* 1755289 */   GIM_Try, /*On fail goto*//*Label 23931*/ GIMT_Encode4(1755375), // Rule ID 11338 //
     /* 1755294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1755305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1755308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1755311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1755314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755340 */     // MIs[0] policy
     /* 1755340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755374 */     // GIR_Coverage, 11338,
     /* 1755374 */     GIR_EraseRootFromParent_Done,
     /* 1755375 */   // Label 23931: @1755375
     /* 1755375 */   GIM_Try, /*On fail goto*//*Label 23932*/ GIMT_Encode4(1755461), // Rule ID 11339 //
     /* 1755380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1755391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1755394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1755397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1755400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755426 */     // MIs[0] policy
     /* 1755426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755436 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755460 */     // GIR_Coverage, 11339,
     /* 1755460 */     GIR_EraseRootFromParent_Done,
     /* 1755461 */   // Label 23932: @1755461
     /* 1755461 */   GIM_Try, /*On fail goto*//*Label 23933*/ GIMT_Encode4(1755547), // Rule ID 11342 //
     /* 1755466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1755477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1755480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1755483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1755486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755512 */     // MIs[0] policy
     /* 1755512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755522 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1755525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755546 */     // GIR_Coverage, 11342,
     /* 1755546 */     GIR_EraseRootFromParent_Done,
     /* 1755547 */   // Label 23933: @1755547
     /* 1755547 */   GIM_Try, /*On fail goto*//*Label 23934*/ GIMT_Encode4(1755633), // Rule ID 11343 //
     /* 1755552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1755563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1755566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1755569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1755572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755598 */     // MIs[0] policy
     /* 1755598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1755611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755632 */     // GIR_Coverage, 11343,
     /* 1755632 */     GIR_EraseRootFromParent_Done,
     /* 1755633 */   // Label 23934: @1755633
     /* 1755633 */   GIM_Try, /*On fail goto*//*Label 23935*/ GIMT_Encode4(1755719), // Rule ID 11346 //
     /* 1755638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1755649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1755652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1755655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1755658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1755661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755684 */     // MIs[0] policy
     /* 1755684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755718 */     // GIR_Coverage, 11346,
     /* 1755718 */     GIR_EraseRootFromParent_Done,
     /* 1755719 */   // Label 23935: @1755719
     /* 1755719 */   GIM_Try, /*On fail goto*//*Label 23936*/ GIMT_Encode4(1755805), // Rule ID 11347 //
     /* 1755724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1755735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1755738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1755741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1755744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1755747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755770 */     // MIs[0] policy
     /* 1755770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755780 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755804 */     // GIR_Coverage, 11347,
     /* 1755804 */     GIR_EraseRootFromParent_Done,
     /* 1755805 */   // Label 23936: @1755805
     /* 1755805 */   GIM_Try, /*On fail goto*//*Label 23937*/ GIMT_Encode4(1755891), // Rule ID 11350 //
     /* 1755810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1755821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1755824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1755827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1755830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755856 */     // MIs[0] policy
     /* 1755856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755890 */     // GIR_Coverage, 11350,
     /* 1755890 */     GIR_EraseRootFromParent_Done,
     /* 1755891 */   // Label 23937: @1755891
     /* 1755891 */   GIM_Try, /*On fail goto*//*Label 23938*/ GIMT_Encode4(1755977), // Rule ID 11351 //
     /* 1755896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1755907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1755910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1755913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1755916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755942 */     // MIs[0] policy
     /* 1755942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755952 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755976 */     // GIR_Coverage, 11351,
     /* 1755976 */     GIR_EraseRootFromParent_Done,
     /* 1755977 */   // Label 23938: @1755977
     /* 1755977 */   GIM_Try, /*On fail goto*//*Label 23939*/ GIMT_Encode4(1756063), // Rule ID 11354 //
     /* 1755982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1755993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1755996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1755999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1756002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756028 */     // MIs[0] policy
     /* 1756028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1756041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756062 */     // GIR_Coverage, 11354,
     /* 1756062 */     GIR_EraseRootFromParent_Done,
     /* 1756063 */   // Label 23939: @1756063
     /* 1756063 */   GIM_Try, /*On fail goto*//*Label 23940*/ GIMT_Encode4(1756149), // Rule ID 11355 //
     /* 1756068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1756079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1756082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1756085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1756088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756114 */     // MIs[0] policy
     /* 1756114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756124 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1756127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756148 */     // GIR_Coverage, 11355,
     /* 1756148 */     GIR_EraseRootFromParent_Done,
     /* 1756149 */   // Label 23940: @1756149
     /* 1756149 */   GIM_Try, /*On fail goto*//*Label 23941*/ GIMT_Encode4(1756235), // Rule ID 11358 //
     /* 1756154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1756165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1756168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1756171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756200 */     // MIs[0] policy
     /* 1756200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756210 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1756213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756234 */     // GIR_Coverage, 11358,
     /* 1756234 */     GIR_EraseRootFromParent_Done,
     /* 1756235 */   // Label 23941: @1756235
     /* 1756235 */   GIM_Try, /*On fail goto*//*Label 23942*/ GIMT_Encode4(1756321), // Rule ID 11359 //
     /* 1756240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1756251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1756254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1756257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756286 */     // MIs[0] policy
     /* 1756286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1756299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756320 */     // GIR_Coverage, 11359,
     /* 1756320 */     GIR_EraseRootFromParent_Done,
     /* 1756321 */   // Label 23942: @1756321
     /* 1756321 */   GIM_Try, /*On fail goto*//*Label 23943*/ GIMT_Encode4(1756407), // Rule ID 11362 //
     /* 1756326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1756337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1756340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1756343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756372 */     // MIs[0] policy
     /* 1756372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756382 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1756385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756406 */     // GIR_Coverage, 11362,
     /* 1756406 */     GIR_EraseRootFromParent_Done,
     /* 1756407 */   // Label 23943: @1756407
     /* 1756407 */   GIM_Try, /*On fail goto*//*Label 23944*/ GIMT_Encode4(1756493), // Rule ID 11363 //
     /* 1756412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1756423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1756426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1756429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756458 */     // MIs[0] policy
     /* 1756458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756468 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1756471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756492 */     // GIR_Coverage, 11363,
     /* 1756492 */     GIR_EraseRootFromParent_Done,
     /* 1756493 */   // Label 23944: @1756493
     /* 1756493 */   GIM_Try, /*On fail goto*//*Label 23945*/ GIMT_Encode4(1756579), // Rule ID 11366 //
     /* 1756498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1756509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1756512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1756515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756544 */     // MIs[0] policy
     /* 1756544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756554 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1756557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756578 */     // GIR_Coverage, 11366,
     /* 1756578 */     GIR_EraseRootFromParent_Done,
     /* 1756579 */   // Label 23945: @1756579
     /* 1756579 */   GIM_Try, /*On fail goto*//*Label 23946*/ GIMT_Encode4(1756665), // Rule ID 11367 //
     /* 1756584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1756595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1756598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1756601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756630 */     // MIs[0] policy
     /* 1756630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756640 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1756643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756664 */     // GIR_Coverage, 11367,
     /* 1756664 */     GIR_EraseRootFromParent_Done,
     /* 1756665 */   // Label 23946: @1756665
     /* 1756665 */   GIM_Try, /*On fail goto*//*Label 23947*/ GIMT_Encode4(1756751), // Rule ID 11370 //
     /* 1756670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1756681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1756684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1756687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756716 */     // MIs[0] policy
     /* 1756716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756726 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1756729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756750 */     // GIR_Coverage, 11370,
     /* 1756750 */     GIR_EraseRootFromParent_Done,
     /* 1756751 */   // Label 23947: @1756751
     /* 1756751 */   GIM_Try, /*On fail goto*//*Label 23948*/ GIMT_Encode4(1756837), // Rule ID 11371 //
     /* 1756756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1756767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1756770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1756773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756802 */     // MIs[0] policy
     /* 1756802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756812 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1756815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756836 */     // GIR_Coverage, 11371,
     /* 1756836 */     GIR_EraseRootFromParent_Done,
     /* 1756837 */   // Label 23948: @1756837
     /* 1756837 */   GIM_Try, /*On fail goto*//*Label 23949*/ GIMT_Encode4(1756923), // Rule ID 11374 //
     /* 1756842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1756853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1756856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1756859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756888 */     // MIs[0] policy
     /* 1756888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756898 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1756901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756922 */     // GIR_Coverage, 11374,
     /* 1756922 */     GIR_EraseRootFromParent_Done,
     /* 1756923 */   // Label 23949: @1756923
     /* 1756923 */   GIM_Try, /*On fail goto*//*Label 23950*/ GIMT_Encode4(1757009), // Rule ID 11375 //
     /* 1756928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1756939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1756942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1756945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756974 */     // MIs[0] policy
     /* 1756974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756984 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1756987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757008 */     // GIR_Coverage, 11375,
     /* 1757008 */     GIR_EraseRootFromParent_Done,
     /* 1757009 */   // Label 23950: @1757009
     /* 1757009 */   GIM_Try, /*On fail goto*//*Label 23951*/ GIMT_Encode4(1757095), // Rule ID 11378 //
     /* 1757014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1757025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1757028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757060 */     // MIs[0] policy
     /* 1757060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757070 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757094 */     // GIR_Coverage, 11378,
     /* 1757094 */     GIR_EraseRootFromParent_Done,
     /* 1757095 */   // Label 23951: @1757095
     /* 1757095 */   GIM_Try, /*On fail goto*//*Label 23952*/ GIMT_Encode4(1757181), // Rule ID 11379 //
     /* 1757100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1757111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1757114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757146 */     // MIs[0] policy
     /* 1757146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757156 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757180 */     // GIR_Coverage, 11379,
     /* 1757180 */     GIR_EraseRootFromParent_Done,
     /* 1757181 */   // Label 23952: @1757181
     /* 1757181 */   GIM_Try, /*On fail goto*//*Label 23953*/ GIMT_Encode4(1757267), // Rule ID 11382 //
     /* 1757186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1757197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1757200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1757203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1757209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757232 */     // MIs[0] policy
     /* 1757232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757242 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757266 */     // GIR_Coverage, 11382,
     /* 1757266 */     GIR_EraseRootFromParent_Done,
     /* 1757267 */   // Label 23953: @1757267
     /* 1757267 */   GIM_Try, /*On fail goto*//*Label 23954*/ GIMT_Encode4(1757353), // Rule ID 11383 //
     /* 1757272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1757283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1757286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1757289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1757295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757318 */     // MIs[0] policy
     /* 1757318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757328 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757352 */     // GIR_Coverage, 11383,
     /* 1757352 */     GIR_EraseRootFromParent_Done,
     /* 1757353 */   // Label 23954: @1757353
     /* 1757353 */   GIM_Try, /*On fail goto*//*Label 23955*/ GIMT_Encode4(1757439), // Rule ID 11386 //
     /* 1757358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1757369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1757372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1757375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757404 */     // MIs[0] policy
     /* 1757404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757414 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757438 */     // GIR_Coverage, 11386,
     /* 1757438 */     GIR_EraseRootFromParent_Done,
     /* 1757439 */   // Label 23955: @1757439
     /* 1757439 */   GIM_Try, /*On fail goto*//*Label 23956*/ GIMT_Encode4(1757525), // Rule ID 11387 //
     /* 1757444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1757455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1757458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1757461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757490 */     // MIs[0] policy
     /* 1757490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757500 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757524 */     // GIR_Coverage, 11387,
     /* 1757524 */     GIR_EraseRootFromParent_Done,
     /* 1757525 */   // Label 23956: @1757525
     /* 1757525 */   GIM_Try, /*On fail goto*//*Label 23957*/ GIMT_Encode4(1757611), // Rule ID 11390 //
     /* 1757530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1757541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1757544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1757547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757576 */     // MIs[0] policy
     /* 1757576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757586 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757610 */     // GIR_Coverage, 11390,
     /* 1757610 */     GIR_EraseRootFromParent_Done,
     /* 1757611 */   // Label 23957: @1757611
     /* 1757611 */   GIM_Try, /*On fail goto*//*Label 23958*/ GIMT_Encode4(1757697), // Rule ID 11391 //
     /* 1757616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1757627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1757630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1757633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757662 */     // MIs[0] policy
     /* 1757662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757672 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757696 */     // GIR_Coverage, 11391,
     /* 1757696 */     GIR_EraseRootFromParent_Done,
     /* 1757697 */   // Label 23958: @1757697
     /* 1757697 */   GIM_Try, /*On fail goto*//*Label 23959*/ GIMT_Encode4(1757783), // Rule ID 11394 //
     /* 1757702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1757713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1757716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1757719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1757725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1757732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757748 */     // MIs[0] policy
     /* 1757748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757758 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1757761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757782 */     // GIR_Coverage, 11394,
     /* 1757782 */     GIR_EraseRootFromParent_Done,
     /* 1757783 */   // Label 23959: @1757783
     /* 1757783 */   GIM_Try, /*On fail goto*//*Label 23960*/ GIMT_Encode4(1757869), // Rule ID 11395 //
     /* 1757788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1757799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1757802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1757805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1757811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1757818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757834 */     // MIs[0] policy
     /* 1757834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757844 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1757847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757868 */     // GIR_Coverage, 11395,
     /* 1757868 */     GIR_EraseRootFromParent_Done,
     /* 1757869 */   // Label 23960: @1757869
     /* 1757869 */   GIM_Try, /*On fail goto*//*Label 23961*/ GIMT_Encode4(1757955), // Rule ID 11398 //
     /* 1757874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1757885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1757888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1757891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1757897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1757904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757920 */     // MIs[0] policy
     /* 1757920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757930 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1757933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757954 */     // GIR_Coverage, 11398,
     /* 1757954 */     GIR_EraseRootFromParent_Done,
     /* 1757955 */   // Label 23961: @1757955
     /* 1757955 */   GIM_Try, /*On fail goto*//*Label 23962*/ GIMT_Encode4(1758041), // Rule ID 11399 //
     /* 1757960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1757971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1757974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1757977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1757983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1757990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758006 */     // MIs[0] policy
     /* 1758006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758016 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758040 */     // GIR_Coverage, 11399,
     /* 1758040 */     GIR_EraseRootFromParent_Done,
     /* 1758041 */   // Label 23962: @1758041
     /* 1758041 */   GIM_Try, /*On fail goto*//*Label 23963*/ GIMT_Encode4(1758127), // Rule ID 11402 //
     /* 1758046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1758057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1758060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1758063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1758069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758092 */     // MIs[0] policy
     /* 1758092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758102 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1758105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758126 */     // GIR_Coverage, 11402,
     /* 1758126 */     GIR_EraseRootFromParent_Done,
     /* 1758127 */   // Label 23963: @1758127
     /* 1758127 */   GIM_Try, /*On fail goto*//*Label 23964*/ GIMT_Encode4(1758213), // Rule ID 11403 //
     /* 1758132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1758143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1758146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1758149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1758155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758178 */     // MIs[0] policy
     /* 1758178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758188 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1758191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758212 */     // GIR_Coverage, 11403,
     /* 1758212 */     GIR_EraseRootFromParent_Done,
     /* 1758213 */   // Label 23964: @1758213
     /* 1758213 */   GIM_Try, /*On fail goto*//*Label 23965*/ GIMT_Encode4(1758299), // Rule ID 11406 //
     /* 1758218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1758229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1758232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1758235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758264 */     // MIs[0] policy
     /* 1758264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758274 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758298 */     // GIR_Coverage, 11406,
     /* 1758298 */     GIR_EraseRootFromParent_Done,
     /* 1758299 */   // Label 23965: @1758299
     /* 1758299 */   GIM_Try, /*On fail goto*//*Label 23966*/ GIMT_Encode4(1758385), // Rule ID 11407 //
     /* 1758304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1758315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1758318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1758321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758350 */     // MIs[0] policy
     /* 1758350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758360 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758384 */     // GIR_Coverage, 11407,
     /* 1758384 */     GIR_EraseRootFromParent_Done,
     /* 1758385 */   // Label 23966: @1758385
     /* 1758385 */   GIM_Try, /*On fail goto*//*Label 23967*/ GIMT_Encode4(1758471), // Rule ID 11410 //
     /* 1758390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1758401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1758404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1758407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758436 */     // MIs[0] policy
     /* 1758436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758446 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758470 */     // GIR_Coverage, 11410,
     /* 1758470 */     GIR_EraseRootFromParent_Done,
     /* 1758471 */   // Label 23967: @1758471
     /* 1758471 */   GIM_Try, /*On fail goto*//*Label 23968*/ GIMT_Encode4(1758557), // Rule ID 11411 //
     /* 1758476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1758487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1758490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1758493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758522 */     // MIs[0] policy
     /* 1758522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758532 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758556 */     // GIR_Coverage, 11411,
     /* 1758556 */     GIR_EraseRootFromParent_Done,
     /* 1758557 */   // Label 23968: @1758557
     /* 1758557 */   GIM_Try, /*On fail goto*//*Label 23969*/ GIMT_Encode4(1758643), // Rule ID 11414 //
     /* 1758562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1758573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1758576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1758579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758608 */     // MIs[0] policy
     /* 1758608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758618 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1758621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758642 */     // GIR_Coverage, 11414,
     /* 1758642 */     GIR_EraseRootFromParent_Done,
     /* 1758643 */   // Label 23969: @1758643
     /* 1758643 */   GIM_Try, /*On fail goto*//*Label 23970*/ GIMT_Encode4(1758729), // Rule ID 11415 //
     /* 1758648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1758659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1758662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1758665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758694 */     // MIs[0] policy
     /* 1758694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758704 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1758707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758728 */     // GIR_Coverage, 11415,
     /* 1758728 */     GIR_EraseRootFromParent_Done,
     /* 1758729 */   // Label 23970: @1758729
     /* 1758729 */   GIM_Try, /*On fail goto*//*Label 23971*/ GIMT_Encode4(1758815), // Rule ID 11418 //
     /* 1758734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1758745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1758748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1758751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1758757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758780 */     // MIs[0] policy
     /* 1758780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758814 */     // GIR_Coverage, 11418,
     /* 1758814 */     GIR_EraseRootFromParent_Done,
     /* 1758815 */   // Label 23971: @1758815
     /* 1758815 */   GIM_Try, /*On fail goto*//*Label 23972*/ GIMT_Encode4(1758901), // Rule ID 11419 //
     /* 1758820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1758831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1758834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1758837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1758843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758866 */     // MIs[0] policy
     /* 1758866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758900 */     // GIR_Coverage, 11419,
     /* 1758900 */     GIR_EraseRootFromParent_Done,
     /* 1758901 */   // Label 23972: @1758901
     /* 1758901 */   GIM_Try, /*On fail goto*//*Label 23973*/ GIMT_Encode4(1758987), // Rule ID 11422 //
     /* 1758906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1758917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1758920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1758923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758952 */     // MIs[0] policy
     /* 1758952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758962 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758986 */     // GIR_Coverage, 11422,
     /* 1758986 */     GIR_EraseRootFromParent_Done,
     /* 1758987 */   // Label 23973: @1758987
     /* 1758987 */   GIM_Try, /*On fail goto*//*Label 23974*/ GIMT_Encode4(1759073), // Rule ID 11423 //
     /* 1758992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1759003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1759006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1759009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759038 */     // MIs[0] policy
     /* 1759038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759048 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1759051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759072 */     // GIR_Coverage, 11423,
     /* 1759072 */     GIR_EraseRootFromParent_Done,
     /* 1759073 */   // Label 23974: @1759073
     /* 1759073 */   GIM_Try, /*On fail goto*//*Label 23975*/ GIMT_Encode4(1759159), // Rule ID 11426 //
     /* 1759078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1759089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1759092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1759095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1759098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759124 */     // MIs[0] policy
     /* 1759124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759134 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1759137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759158 */     // GIR_Coverage, 11426,
     /* 1759158 */     GIR_EraseRootFromParent_Done,
     /* 1759159 */   // Label 23975: @1759159
     /* 1759159 */   GIM_Try, /*On fail goto*//*Label 23976*/ GIMT_Encode4(1759245), // Rule ID 11427 //
     /* 1759164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1759175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1759178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1759181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759210 */     // MIs[0] policy
     /* 1759210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759220 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1759223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759244 */     // GIR_Coverage, 11427,
     /* 1759244 */     GIR_EraseRootFromParent_Done,
     /* 1759245 */   // Label 23976: @1759245
     /* 1759245 */   GIM_Try, /*On fail goto*//*Label 23977*/ GIMT_Encode4(1759331), // Rule ID 11430 //
     /* 1759250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1759261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1759264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1759267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1759270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759296 */     // MIs[0] policy
     /* 1759296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759306 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1759309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759330 */     // GIR_Coverage, 11430,
     /* 1759330 */     GIR_EraseRootFromParent_Done,
     /* 1759331 */   // Label 23977: @1759331
     /* 1759331 */   GIM_Try, /*On fail goto*//*Label 23978*/ GIMT_Encode4(1759417), // Rule ID 11431 //
     /* 1759336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1759347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1759350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1759353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1759356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759382 */     // MIs[0] policy
     /* 1759382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759392 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1759395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759416 */     // GIR_Coverage, 11431,
     /* 1759416 */     GIR_EraseRootFromParent_Done,
     /* 1759417 */   // Label 23978: @1759417
     /* 1759417 */   GIM_Try, /*On fail goto*//*Label 23979*/ GIMT_Encode4(1759503), // Rule ID 11434 //
     /* 1759422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1759433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1759436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1759439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1759442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759468 */     // MIs[0] policy
     /* 1759468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759478 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1759481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759502 */     // GIR_Coverage, 11434,
     /* 1759502 */     GIR_EraseRootFromParent_Done,
     /* 1759503 */   // Label 23979: @1759503
     /* 1759503 */   GIM_Try, /*On fail goto*//*Label 23980*/ GIMT_Encode4(1759589), // Rule ID 11435 //
     /* 1759508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1759519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1759522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1759525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1759528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759554 */     // MIs[0] policy
     /* 1759554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759564 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1759567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759588 */     // GIR_Coverage, 11435,
     /* 1759588 */     GIR_EraseRootFromParent_Done,
     /* 1759589 */   // Label 23980: @1759589
     /* 1759589 */   GIM_Try, /*On fail goto*//*Label 23981*/ GIMT_Encode4(1759675), // Rule ID 11438 //
     /* 1759594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1759605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1759608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1759611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1759614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759640 */     // MIs[0] policy
     /* 1759640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759650 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1759653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759674 */     // GIR_Coverage, 11438,
     /* 1759674 */     GIR_EraseRootFromParent_Done,
     /* 1759675 */   // Label 23981: @1759675
     /* 1759675 */   GIM_Try, /*On fail goto*//*Label 23982*/ GIMT_Encode4(1759761), // Rule ID 11439 //
     /* 1759680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1759691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1759694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1759697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1759700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759726 */     // MIs[0] policy
     /* 1759726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759736 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1759739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759760 */     // GIR_Coverage, 11439,
     /* 1759760 */     GIR_EraseRootFromParent_Done,
     /* 1759761 */   // Label 23982: @1759761
     /* 1759761 */   GIM_Try, /*On fail goto*//*Label 23983*/ GIMT_Encode4(1759847), // Rule ID 11442 //
     /* 1759766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1759777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1759780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1759783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1759786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759812 */     // MIs[0] policy
     /* 1759812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759822 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1759825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759846 */     // GIR_Coverage, 11442,
     /* 1759846 */     GIR_EraseRootFromParent_Done,
     /* 1759847 */   // Label 23983: @1759847
     /* 1759847 */   GIM_Try, /*On fail goto*//*Label 23984*/ GIMT_Encode4(1759933), // Rule ID 11443 //
     /* 1759852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1759863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1759866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1759869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1759872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759898 */     // MIs[0] policy
     /* 1759898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759908 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1759911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759932 */     // GIR_Coverage, 11443,
     /* 1759932 */     GIR_EraseRootFromParent_Done,
     /* 1759933 */   // Label 23984: @1759933
     /* 1759933 */   GIM_Try, /*On fail goto*//*Label 23985*/ GIMT_Encode4(1760019), // Rule ID 11446 //
     /* 1759938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1759949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1759952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1759955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1759958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759984 */     // MIs[0] policy
     /* 1759984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759994 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1759997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760018 */     // GIR_Coverage, 11446,
     /* 1760018 */     GIR_EraseRootFromParent_Done,
     /* 1760019 */   // Label 23985: @1760019
     /* 1760019 */   GIM_Try, /*On fail goto*//*Label 23986*/ GIMT_Encode4(1760105), // Rule ID 11447 //
     /* 1760024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1760035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1760038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1760041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1760044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760070 */     // MIs[0] policy
     /* 1760070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760080 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760104 */     // GIR_Coverage, 11447,
     /* 1760104 */     GIR_EraseRootFromParent_Done,
     /* 1760105 */   // Label 23986: @1760105
     /* 1760105 */   GIM_Try, /*On fail goto*//*Label 23987*/ GIMT_Encode4(1760191), // Rule ID 11450 //
     /* 1760110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1760121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1760124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1760127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1760130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760156 */     // MIs[0] policy
     /* 1760156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760166 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760190 */     // GIR_Coverage, 11450,
     /* 1760190 */     GIR_EraseRootFromParent_Done,
     /* 1760191 */   // Label 23987: @1760191
     /* 1760191 */   GIM_Try, /*On fail goto*//*Label 23988*/ GIMT_Encode4(1760277), // Rule ID 11451 //
     /* 1760196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1760207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1760210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1760213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1760216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760242 */     // MIs[0] policy
     /* 1760242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760252 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760276 */     // GIR_Coverage, 11451,
     /* 1760276 */     GIR_EraseRootFromParent_Done,
     /* 1760277 */   // Label 23988: @1760277
     /* 1760277 */   GIM_Try, /*On fail goto*//*Label 23989*/ GIMT_Encode4(1760363), // Rule ID 11454 //
     /* 1760282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1760293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1760296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1760299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1760302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760328 */     // MIs[0] policy
     /* 1760328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760338 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760362 */     // GIR_Coverage, 11454,
     /* 1760362 */     GIR_EraseRootFromParent_Done,
     /* 1760363 */   // Label 23989: @1760363
     /* 1760363 */   GIM_Try, /*On fail goto*//*Label 23990*/ GIMT_Encode4(1760449), // Rule ID 11455 //
     /* 1760368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1760379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1760382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1760385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1760388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760414 */     // MIs[0] policy
     /* 1760414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760448 */     // GIR_Coverage, 11455,
     /* 1760448 */     GIR_EraseRootFromParent_Done,
     /* 1760449 */   // Label 23990: @1760449
     /* 1760449 */   GIM_Try, /*On fail goto*//*Label 23991*/ GIMT_Encode4(1760535), // Rule ID 11458 //
     /* 1760454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1760465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1760468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1760471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1760474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760500 */     // MIs[0] policy
     /* 1760500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760510 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760534 */     // GIR_Coverage, 11458,
     /* 1760534 */     GIR_EraseRootFromParent_Done,
     /* 1760535 */   // Label 23991: @1760535
     /* 1760535 */   GIM_Try, /*On fail goto*//*Label 23992*/ GIMT_Encode4(1760621), // Rule ID 11459 //
     /* 1760540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1760551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1760554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1760557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1760560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760586 */     // MIs[0] policy
     /* 1760586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760596 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760620 */     // GIR_Coverage, 11459,
     /* 1760620 */     GIR_EraseRootFromParent_Done,
     /* 1760621 */   // Label 23992: @1760621
     /* 1760621 */   GIM_Try, /*On fail goto*//*Label 23993*/ GIMT_Encode4(1760707), // Rule ID 11462 //
     /* 1760626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1760637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1760640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1760643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1760646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760672 */     // MIs[0] policy
     /* 1760672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760706 */     // GIR_Coverage, 11462,
     /* 1760706 */     GIR_EraseRootFromParent_Done,
     /* 1760707 */   // Label 23993: @1760707
     /* 1760707 */   GIM_Try, /*On fail goto*//*Label 23994*/ GIMT_Encode4(1760793), // Rule ID 11463 //
     /* 1760712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1760723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1760726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1760729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1760732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760758 */     // MIs[0] policy
     /* 1760758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760768 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760792 */     // GIR_Coverage, 11463,
     /* 1760792 */     GIR_EraseRootFromParent_Done,
     /* 1760793 */   // Label 23994: @1760793
     /* 1760793 */   GIM_Try, /*On fail goto*//*Label 23995*/ GIMT_Encode4(1760879), // Rule ID 11466 //
     /* 1760798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1760809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1760812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1760815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1760818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1760821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1760828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760844 */     // MIs[0] policy
     /* 1760844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760854 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1760857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760878 */     // GIR_Coverage, 11466,
     /* 1760878 */     GIR_EraseRootFromParent_Done,
     /* 1760879 */   // Label 23995: @1760879
     /* 1760879 */   GIM_Try, /*On fail goto*//*Label 23996*/ GIMT_Encode4(1760965), // Rule ID 11467 //
     /* 1760884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1760895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1760898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1760901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1760904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1760907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1760914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760930 */     // MIs[0] policy
     /* 1760930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760940 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1760943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760964 */     // GIR_Coverage, 11467,
     /* 1760964 */     GIR_EraseRootFromParent_Done,
     /* 1760965 */   // Label 23996: @1760965
     /* 1760965 */   GIM_Try, /*On fail goto*//*Label 23997*/ GIMT_Encode4(1761051), // Rule ID 11470 //
     /* 1760970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1760981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1760984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1760987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1760990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1760993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761016 */     // MIs[0] policy
     /* 1761016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761026 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761050 */     // GIR_Coverage, 11470,
     /* 1761050 */     GIR_EraseRootFromParent_Done,
     /* 1761051 */   // Label 23997: @1761051
     /* 1761051 */   GIM_Try, /*On fail goto*//*Label 23998*/ GIMT_Encode4(1761137), // Rule ID 11471 //
     /* 1761056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1761067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1761070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1761073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1761076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761102 */     // MIs[0] policy
     /* 1761102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761112 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761136 */     // GIR_Coverage, 11471,
     /* 1761136 */     GIR_EraseRootFromParent_Done,
     /* 1761137 */   // Label 23998: @1761137
     /* 1761137 */   GIM_Try, /*On fail goto*//*Label 23999*/ GIMT_Encode4(1761223), // Rule ID 11474 //
     /* 1761142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1761153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1761156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1761159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1761162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1761165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761188 */     // MIs[0] policy
     /* 1761188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761198 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1761201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761222 */     // GIR_Coverage, 11474,
     /* 1761222 */     GIR_EraseRootFromParent_Done,
     /* 1761223 */   // Label 23999: @1761223
     /* 1761223 */   GIM_Try, /*On fail goto*//*Label 24000*/ GIMT_Encode4(1761309), // Rule ID 11475 //
     /* 1761228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1761239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1761242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1761245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1761248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1761251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761274 */     // MIs[0] policy
     /* 1761274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761284 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1761287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761308 */     // GIR_Coverage, 11475,
     /* 1761308 */     GIR_EraseRootFromParent_Done,
     /* 1761309 */   // Label 24000: @1761309
     /* 1761309 */   GIM_Try, /*On fail goto*//*Label 24001*/ GIMT_Encode4(1761395), // Rule ID 11478 //
     /* 1761314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1761325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1761328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1761331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1761334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761360 */     // MIs[0] policy
     /* 1761360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761370 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761394 */     // GIR_Coverage, 11478,
     /* 1761394 */     GIR_EraseRootFromParent_Done,
     /* 1761395 */   // Label 24001: @1761395
     /* 1761395 */   GIM_Try, /*On fail goto*//*Label 24002*/ GIMT_Encode4(1761481), // Rule ID 11479 //
     /* 1761400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1761411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1761414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1761417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1761420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761446 */     // MIs[0] policy
     /* 1761446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761456 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761480 */     // GIR_Coverage, 11479,
     /* 1761480 */     GIR_EraseRootFromParent_Done,
     /* 1761481 */   // Label 24002: @1761481
     /* 1761481 */   GIM_Try, /*On fail goto*//*Label 24003*/ GIMT_Encode4(1761567), // Rule ID 11482 //
     /* 1761486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1761497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1761500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1761503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1761506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761532 */     // MIs[0] policy
     /* 1761532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761542 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761566 */     // GIR_Coverage, 11482,
     /* 1761566 */     GIR_EraseRootFromParent_Done,
     /* 1761567 */   // Label 24003: @1761567
     /* 1761567 */   GIM_Try, /*On fail goto*//*Label 24004*/ GIMT_Encode4(1761653), // Rule ID 11483 //
     /* 1761572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1761583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1761586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1761589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1761592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761618 */     // MIs[0] policy
     /* 1761618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761628 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761652 */     // GIR_Coverage, 11483,
     /* 1761652 */     GIR_EraseRootFromParent_Done,
     /* 1761653 */   // Label 24004: @1761653
     /* 1761653 */   GIM_Try, /*On fail goto*//*Label 24005*/ GIMT_Encode4(1761739), // Rule ID 11486 //
     /* 1761658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1761669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1761672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1761675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1761678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761704 */     // MIs[0] policy
     /* 1761704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761714 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1761717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761738 */     // GIR_Coverage, 11486,
     /* 1761738 */     GIR_EraseRootFromParent_Done,
     /* 1761739 */   // Label 24005: @1761739
     /* 1761739 */   GIM_Try, /*On fail goto*//*Label 24006*/ GIMT_Encode4(1761825), // Rule ID 11487 //
     /* 1761744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1761755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1761758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1761761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1761764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761790 */     // MIs[0] policy
     /* 1761790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761800 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1761803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761824 */     // GIR_Coverage, 11487,
     /* 1761824 */     GIR_EraseRootFromParent_Done,
     /* 1761825 */   // Label 24006: @1761825
     /* 1761825 */   GIM_Try, /*On fail goto*//*Label 24007*/ GIMT_Encode4(1761911), // Rule ID 11490 //
     /* 1761830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1761841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1761844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1761847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1761850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761876 */     // MIs[0] policy
     /* 1761876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761886 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761910 */     // GIR_Coverage, 11490,
     /* 1761910 */     GIR_EraseRootFromParent_Done,
     /* 1761911 */   // Label 24007: @1761911
     /* 1761911 */   GIM_Try, /*On fail goto*//*Label 24008*/ GIMT_Encode4(1761997), // Rule ID 11491 //
     /* 1761916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1761927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1761930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1761933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1761936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761962 */     // MIs[0] policy
     /* 1761962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761996 */     // GIR_Coverage, 11491,
     /* 1761996 */     GIR_EraseRootFromParent_Done,
     /* 1761997 */   // Label 24008: @1761997
     /* 1761997 */   GIM_Try, /*On fail goto*//*Label 24009*/ GIMT_Encode4(1762083), // Rule ID 11494 //
     /* 1762002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1762013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1762016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1762019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1762022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762048 */     // MIs[0] policy
     /* 1762048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762058 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1762061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762082 */     // GIR_Coverage, 11494,
     /* 1762082 */     GIR_EraseRootFromParent_Done,
     /* 1762083 */   // Label 24009: @1762083
     /* 1762083 */   GIM_Try, /*On fail goto*//*Label 24010*/ GIMT_Encode4(1762169), // Rule ID 11495 //
     /* 1762088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1762099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1762102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1762105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1762108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762134 */     // MIs[0] policy
     /* 1762134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762144 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1762147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762168 */     // GIR_Coverage, 11495,
     /* 1762168 */     GIR_EraseRootFromParent_Done,
     /* 1762169 */   // Label 24010: @1762169
     /* 1762169 */   GIM_Try, /*On fail goto*//*Label 24011*/ GIMT_Encode4(1762255), // Rule ID 11498 //
     /* 1762174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1762185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1762188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1762191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1762194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762220 */     // MIs[0] policy
     /* 1762220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762230 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762254 */     // GIR_Coverage, 11498,
     /* 1762254 */     GIR_EraseRootFromParent_Done,
     /* 1762255 */   // Label 24011: @1762255
     /* 1762255 */   GIM_Try, /*On fail goto*//*Label 24012*/ GIMT_Encode4(1762341), // Rule ID 11499 //
     /* 1762260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1762271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1762274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1762277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1762280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762306 */     // MIs[0] policy
     /* 1762306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762316 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762340 */     // GIR_Coverage, 11499,
     /* 1762340 */     GIR_EraseRootFromParent_Done,
     /* 1762341 */   // Label 24012: @1762341
     /* 1762341 */   GIM_Try, /*On fail goto*//*Label 24013*/ GIMT_Encode4(1762427), // Rule ID 11502 //
     /* 1762346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1762357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1762360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1762363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762392 */     // MIs[0] policy
     /* 1762392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762402 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1762405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762426 */     // GIR_Coverage, 11502,
     /* 1762426 */     GIR_EraseRootFromParent_Done,
     /* 1762427 */   // Label 24013: @1762427
     /* 1762427 */   GIM_Try, /*On fail goto*//*Label 24014*/ GIMT_Encode4(1762513), // Rule ID 11503 //
     /* 1762432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1762443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1762446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1762449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762478 */     // MIs[0] policy
     /* 1762478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762488 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1762491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762512 */     // GIR_Coverage, 11503,
     /* 1762512 */     GIR_EraseRootFromParent_Done,
     /* 1762513 */   // Label 24014: @1762513
     /* 1762513 */   GIM_Try, /*On fail goto*//*Label 24015*/ GIMT_Encode4(1762599), // Rule ID 11506 //
     /* 1762518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1762529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1762532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1762535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1762541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762564 */     // MIs[0] policy
     /* 1762564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762574 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1762577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762598 */     // GIR_Coverage, 11506,
     /* 1762598 */     GIR_EraseRootFromParent_Done,
     /* 1762599 */   // Label 24015: @1762599
     /* 1762599 */   GIM_Try, /*On fail goto*//*Label 24016*/ GIMT_Encode4(1762685), // Rule ID 11507 //
     /* 1762604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1762615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1762618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1762621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1762627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762650 */     // MIs[0] policy
     /* 1762650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762660 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1762663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762684 */     // GIR_Coverage, 11507,
     /* 1762684 */     GIR_EraseRootFromParent_Done,
     /* 1762685 */   // Label 24016: @1762685
     /* 1762685 */   GIM_Try, /*On fail goto*//*Label 24017*/ GIMT_Encode4(1762771), // Rule ID 11510 //
     /* 1762690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1762701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1762704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1762707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762736 */     // MIs[0] policy
     /* 1762736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762746 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1762749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762770 */     // GIR_Coverage, 11510,
     /* 1762770 */     GIR_EraseRootFromParent_Done,
     /* 1762771 */   // Label 24017: @1762771
     /* 1762771 */   GIM_Try, /*On fail goto*//*Label 24018*/ GIMT_Encode4(1762857), // Rule ID 11511 //
     /* 1762776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1762787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1762790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1762793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762822 */     // MIs[0] policy
     /* 1762822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762832 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1762835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762856 */     // GIR_Coverage, 11511,
     /* 1762856 */     GIR_EraseRootFromParent_Done,
     /* 1762857 */   // Label 24018: @1762857
     /* 1762857 */   GIM_Try, /*On fail goto*//*Label 24019*/ GIMT_Encode4(1762943), // Rule ID 11514 //
     /* 1762862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1762873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1762876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1762879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762908 */     // MIs[0] policy
     /* 1762908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762918 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1762921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762942 */     // GIR_Coverage, 11514,
     /* 1762942 */     GIR_EraseRootFromParent_Done,
     /* 1762943 */   // Label 24019: @1762943
     /* 1762943 */   GIM_Try, /*On fail goto*//*Label 24020*/ GIMT_Encode4(1763029), // Rule ID 11515 //
     /* 1762948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1762959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1762962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1762965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762994 */     // MIs[0] policy
     /* 1762994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763004 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1763007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763028 */     // GIR_Coverage, 11515,
     /* 1763028 */     GIR_EraseRootFromParent_Done,
     /* 1763029 */   // Label 24020: @1763029
     /* 1763029 */   GIM_Try, /*On fail goto*//*Label 24021*/ GIMT_Encode4(1763115), // Rule ID 11518 //
     /* 1763034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763080 */     // MIs[0] policy
     /* 1763080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763090 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763114 */     // GIR_Coverage, 11518,
     /* 1763114 */     GIR_EraseRootFromParent_Done,
     /* 1763115 */   // Label 24021: @1763115
     /* 1763115 */   GIM_Try, /*On fail goto*//*Label 24022*/ GIMT_Encode4(1763201), // Rule ID 11519 //
     /* 1763120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763166 */     // MIs[0] policy
     /* 1763166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763176 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763200 */     // GIR_Coverage, 11519,
     /* 1763200 */     GIR_EraseRootFromParent_Done,
     /* 1763201 */   // Label 24022: @1763201
     /* 1763201 */   GIM_Try, /*On fail goto*//*Label 24023*/ GIMT_Encode4(1763287), // Rule ID 11522 //
     /* 1763206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1763217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1763220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1763223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763252 */     // MIs[0] policy
     /* 1763252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763262 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763286 */     // GIR_Coverage, 11522,
     /* 1763286 */     GIR_EraseRootFromParent_Done,
     /* 1763287 */   // Label 24023: @1763287
     /* 1763287 */   GIM_Try, /*On fail goto*//*Label 24024*/ GIMT_Encode4(1763373), // Rule ID 11523 //
     /* 1763292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1763303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1763306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1763309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763338 */     // MIs[0] policy
     /* 1763338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763348 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763372 */     // GIR_Coverage, 11523,
     /* 1763372 */     GIR_EraseRootFromParent_Done,
     /* 1763373 */   // Label 24024: @1763373
     /* 1763373 */   GIM_Try, /*On fail goto*//*Label 24025*/ GIMT_Encode4(1763459), // Rule ID 11526 //
     /* 1763378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1763389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1763392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1763395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1763401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763424 */     // MIs[0] policy
     /* 1763424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763434 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763458 */     // GIR_Coverage, 11526,
     /* 1763458 */     GIR_EraseRootFromParent_Done,
     /* 1763459 */   // Label 24025: @1763459
     /* 1763459 */   GIM_Try, /*On fail goto*//*Label 24026*/ GIMT_Encode4(1763545), // Rule ID 11527 //
     /* 1763464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1763475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1763478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1763481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1763487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763510 */     // MIs[0] policy
     /* 1763510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763520 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763544 */     // GIR_Coverage, 11527,
     /* 1763544 */     GIR_EraseRootFromParent_Done,
     /* 1763545 */   // Label 24026: @1763545
     /* 1763545 */   GIM_Try, /*On fail goto*//*Label 24027*/ GIMT_Encode4(1763631), // Rule ID 11530 //
     /* 1763550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1763561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1763564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1763567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763596 */     // MIs[0] policy
     /* 1763596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763606 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763630 */     // GIR_Coverage, 11530,
     /* 1763630 */     GIR_EraseRootFromParent_Done,
     /* 1763631 */   // Label 24027: @1763631
     /* 1763631 */   GIM_Try, /*On fail goto*//*Label 24028*/ GIMT_Encode4(1763717), // Rule ID 11531 //
     /* 1763636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1763647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1763650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1763653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763682 */     // MIs[0] policy
     /* 1763682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763692 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763716 */     // GIR_Coverage, 11531,
     /* 1763716 */     GIR_EraseRootFromParent_Done,
     /* 1763717 */   // Label 24028: @1763717
     /* 1763717 */   GIM_Try, /*On fail goto*//*Label 24029*/ GIMT_Encode4(1763803), // Rule ID 11534 //
     /* 1763722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1763733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1763736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1763739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763768 */     // MIs[0] policy
     /* 1763768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763778 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763802 */     // GIR_Coverage, 11534,
     /* 1763802 */     GIR_EraseRootFromParent_Done,
     /* 1763803 */   // Label 24029: @1763803
     /* 1763803 */   GIM_Try, /*On fail goto*//*Label 24030*/ GIMT_Encode4(1763889), // Rule ID 11535 //
     /* 1763808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1763819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1763822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1763825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763854 */     // MIs[0] policy
     /* 1763854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763864 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763888 */     // GIR_Coverage, 11535,
     /* 1763888 */     GIR_EraseRootFromParent_Done,
     /* 1763889 */   // Label 24030: @1763889
     /* 1763889 */   GIM_Try, /*On fail goto*//*Label 24031*/ GIMT_Encode4(1763975), // Rule ID 11538 //
     /* 1763894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1763905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1763908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1763911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1763917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1763924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1763928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1763932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763940 */     // MIs[0] policy
     /* 1763940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763950 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1763953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763974 */     // GIR_Coverage, 11538,
     /* 1763974 */     GIR_EraseRootFromParent_Done,
     /* 1763975 */   // Label 24031: @1763975
     /* 1763975 */   GIM_Try, /*On fail goto*//*Label 24032*/ GIMT_Encode4(1764061), // Rule ID 11539 //
     /* 1763980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1763991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1763994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1763997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764026 */     // MIs[0] policy
     /* 1764026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764036 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764060 */     // GIR_Coverage, 11539,
     /* 1764060 */     GIR_EraseRootFromParent_Done,
     /* 1764061 */   // Label 24032: @1764061
     /* 1764061 */   GIM_Try, /*On fail goto*//*Label 24033*/ GIMT_Encode4(1764147), // Rule ID 11542 //
     /* 1764066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1764077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1764080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1764083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764112 */     // MIs[0] policy
     /* 1764112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764122 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1764125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764146 */     // GIR_Coverage, 11542,
     /* 1764146 */     GIR_EraseRootFromParent_Done,
     /* 1764147 */   // Label 24033: @1764147
     /* 1764147 */   GIM_Try, /*On fail goto*//*Label 24034*/ GIMT_Encode4(1764233), // Rule ID 11543 //
     /* 1764152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1764163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1764166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1764169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764198 */     // MIs[0] policy
     /* 1764198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764208 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1764211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764232 */     // GIR_Coverage, 11543,
     /* 1764232 */     GIR_EraseRootFromParent_Done,
     /* 1764233 */   // Label 24034: @1764233
     /* 1764233 */   GIM_Try, /*On fail goto*//*Label 24035*/ GIMT_Encode4(1764319), // Rule ID 11546 //
     /* 1764238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1764249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1764252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1764255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1764261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764284 */     // MIs[0] policy
     /* 1764284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764294 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1764297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764318 */     // GIR_Coverage, 11546,
     /* 1764318 */     GIR_EraseRootFromParent_Done,
     /* 1764319 */   // Label 24035: @1764319
     /* 1764319 */   GIM_Try, /*On fail goto*//*Label 24036*/ GIMT_Encode4(1764405), // Rule ID 11547 //
     /* 1764324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1764335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1764338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1764341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1764347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764370 */     // MIs[0] policy
     /* 1764370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764380 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1764383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764404 */     // GIR_Coverage, 11547,
     /* 1764404 */     GIR_EraseRootFromParent_Done,
     /* 1764405 */   // Label 24036: @1764405
     /* 1764405 */   GIM_Try, /*On fail goto*//*Label 24037*/ GIMT_Encode4(1764491), // Rule ID 11550 //
     /* 1764410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1764421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1764424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1764427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764456 */     // MIs[0] policy
     /* 1764456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764490 */     // GIR_Coverage, 11550,
     /* 1764490 */     GIR_EraseRootFromParent_Done,
     /* 1764491 */   // Label 24037: @1764491
     /* 1764491 */   GIM_Try, /*On fail goto*//*Label 24038*/ GIMT_Encode4(1764577), // Rule ID 11551 //
     /* 1764496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1764507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1764510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1764513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764542 */     // MIs[0] policy
     /* 1764542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764576 */     // GIR_Coverage, 11551,
     /* 1764576 */     GIR_EraseRootFromParent_Done,
     /* 1764577 */   // Label 24038: @1764577
     /* 1764577 */   GIM_Try, /*On fail goto*//*Label 24039*/ GIMT_Encode4(1764663), // Rule ID 11554 //
     /* 1764582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1764593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1764596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1764599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764628 */     // MIs[0] policy
     /* 1764628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764638 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1764641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764662 */     // GIR_Coverage, 11554,
     /* 1764662 */     GIR_EraseRootFromParent_Done,
     /* 1764663 */   // Label 24039: @1764663
     /* 1764663 */   GIM_Try, /*On fail goto*//*Label 24040*/ GIMT_Encode4(1764749), // Rule ID 11555 //
     /* 1764668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1764679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1764682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1764685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764714 */     // MIs[0] policy
     /* 1764714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764724 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1764727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764748 */     // GIR_Coverage, 11555,
     /* 1764748 */     GIR_EraseRootFromParent_Done,
     /* 1764749 */   // Label 24040: @1764749
     /* 1764749 */   GIM_Try, /*On fail goto*//*Label 24041*/ GIMT_Encode4(1764835), // Rule ID 11558 //
     /* 1764754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1764765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1764768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1764771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764800 */     // MIs[0] policy
     /* 1764800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764810 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1764813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764834 */     // GIR_Coverage, 11558,
     /* 1764834 */     GIR_EraseRootFromParent_Done,
     /* 1764835 */   // Label 24041: @1764835
     /* 1764835 */   GIM_Try, /*On fail goto*//*Label 24042*/ GIMT_Encode4(1764921), // Rule ID 11559 //
     /* 1764840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1764851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1764854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1764857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764886 */     // MIs[0] policy
     /* 1764886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764896 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1764899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764920 */     // GIR_Coverage, 11559,
     /* 1764920 */     GIR_EraseRootFromParent_Done,
     /* 1764921 */   // Label 24042: @1764921
     /* 1764921 */   GIM_Try, /*On fail goto*//*Label 24043*/ GIMT_Encode4(1765007), // Rule ID 11562 //
     /* 1764926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1764937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1764940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1764943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764972 */     // MIs[0] policy
     /* 1764972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765006 */     // GIR_Coverage, 11562,
     /* 1765006 */     GIR_EraseRootFromParent_Done,
     /* 1765007 */   // Label 24043: @1765007
     /* 1765007 */   GIM_Try, /*On fail goto*//*Label 24044*/ GIMT_Encode4(1765093), // Rule ID 11563 //
     /* 1765012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1765023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1765026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1765029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765058 */     // MIs[0] policy
     /* 1765058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1765071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765092 */     // GIR_Coverage, 11563,
     /* 1765092 */     GIR_EraseRootFromParent_Done,
     /* 1765093 */   // Label 24044: @1765093
     /* 1765093 */   GIM_Try, /*On fail goto*//*Label 24045*/ GIMT_Encode4(1765179), // Rule ID 11566 //
     /* 1765098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1765109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1765112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1765115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765144 */     // MIs[0] policy
     /* 1765144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765154 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1765157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765178 */     // GIR_Coverage, 11566,
     /* 1765178 */     GIR_EraseRootFromParent_Done,
     /* 1765179 */   // Label 24045: @1765179
     /* 1765179 */   GIM_Try, /*On fail goto*//*Label 24046*/ GIMT_Encode4(1765265), // Rule ID 11567 //
     /* 1765184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1765195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1765198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1765201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765230 */     // MIs[0] policy
     /* 1765230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765240 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1765243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765264 */     // GIR_Coverage, 11567,
     /* 1765264 */     GIR_EraseRootFromParent_Done,
     /* 1765265 */   // Label 24046: @1765265
     /* 1765265 */   GIM_Try, /*On fail goto*//*Label 24047*/ GIMT_Encode4(1765351), // Rule ID 11570 //
     /* 1765270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1765281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1765284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1765287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765316 */     // MIs[0] policy
     /* 1765316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765326 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1765329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765350 */     // GIR_Coverage, 11570,
     /* 1765350 */     GIR_EraseRootFromParent_Done,
     /* 1765351 */   // Label 24047: @1765351
     /* 1765351 */   GIM_Try, /*On fail goto*//*Label 24048*/ GIMT_Encode4(1765437), // Rule ID 11571 //
     /* 1765356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1765367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1765370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1765373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765402 */     // MIs[0] policy
     /* 1765402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765412 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1765415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765436 */     // GIR_Coverage, 11571,
     /* 1765436 */     GIR_EraseRootFromParent_Done,
     /* 1765437 */   // Label 24048: @1765437
     /* 1765437 */   GIM_Try, /*On fail goto*//*Label 24049*/ GIMT_Encode4(1765523), // Rule ID 11574 //
     /* 1765442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1765453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1765456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1765459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1765462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1765465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1765472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765488 */     // MIs[0] policy
     /* 1765488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765498 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1765501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765522 */     // GIR_Coverage, 11574,
     /* 1765522 */     GIR_EraseRootFromParent_Done,
     /* 1765523 */   // Label 24049: @1765523
     /* 1765523 */   GIM_Try, /*On fail goto*//*Label 24050*/ GIMT_Encode4(1765609), // Rule ID 11575 //
     /* 1765528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1765539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1765542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1765545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1765548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1765551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1765558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765574 */     // MIs[0] policy
     /* 1765574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765584 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1765587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765608 */     // GIR_Coverage, 11575,
     /* 1765608 */     GIR_EraseRootFromParent_Done,
     /* 1765609 */   // Label 24050: @1765609
     /* 1765609 */   GIM_Try, /*On fail goto*//*Label 24051*/ GIMT_Encode4(1765695), // Rule ID 11578 //
     /* 1765614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1765625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1765628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1765631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1765634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1765637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765660 */     // MIs[0] policy
     /* 1765660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1765673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765694 */     // GIR_Coverage, 11578,
     /* 1765694 */     GIR_EraseRootFromParent_Done,
     /* 1765695 */   // Label 24051: @1765695
     /* 1765695 */   GIM_Try, /*On fail goto*//*Label 24052*/ GIMT_Encode4(1765781), // Rule ID 11579 //
     /* 1765700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1765711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1765714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1765717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1765720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1765723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765746 */     // MIs[0] policy
     /* 1765746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765756 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1765759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765780 */     // GIR_Coverage, 11579,
     /* 1765780 */     GIR_EraseRootFromParent_Done,
     /* 1765781 */   // Label 24052: @1765781
     /* 1765781 */   GIM_Try, /*On fail goto*//*Label 24053*/ GIMT_Encode4(1765867), // Rule ID 11582 //
     /* 1765786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1765797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1765800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1765803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1765806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765832 */     // MIs[0] policy
     /* 1765832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765842 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1765845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765866 */     // GIR_Coverage, 11582,
     /* 1765866 */     GIR_EraseRootFromParent_Done,
     /* 1765867 */   // Label 24053: @1765867
     /* 1765867 */   GIM_Try, /*On fail goto*//*Label 24054*/ GIMT_Encode4(1765953), // Rule ID 11583 //
     /* 1765872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1765883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1765886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1765889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1765892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765918 */     // MIs[0] policy
     /* 1765918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765928 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1765931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765952 */     // GIR_Coverage, 11583,
     /* 1765952 */     GIR_EraseRootFromParent_Done,
     /* 1765953 */   // Label 24054: @1765953
     /* 1765953 */   GIM_Try, /*On fail goto*//*Label 24055*/ GIMT_Encode4(1766039), // Rule ID 11586 //
     /* 1765958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1765969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1765972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1765975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1765978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766004 */     // MIs[0] policy
     /* 1766004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766014 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1766017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766038 */     // GIR_Coverage, 11586,
     /* 1766038 */     GIR_EraseRootFromParent_Done,
     /* 1766039 */   // Label 24055: @1766039
     /* 1766039 */   GIM_Try, /*On fail goto*//*Label 24056*/ GIMT_Encode4(1766125), // Rule ID 11587 //
     /* 1766044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1766064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766090 */     // MIs[0] policy
     /* 1766090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766100 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1766103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766124 */     // GIR_Coverage, 11587,
     /* 1766124 */     GIR_EraseRootFromParent_Done,
     /* 1766125 */   // Label 24056: @1766125
     /* 1766125 */   GIM_Try, /*On fail goto*//*Label 24057*/ GIMT_Encode4(1766211), // Rule ID 11590 //
     /* 1766130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766176 */     // MIs[0] policy
     /* 1766176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1766189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766210 */     // GIR_Coverage, 11590,
     /* 1766210 */     GIR_EraseRootFromParent_Done,
     /* 1766211 */   // Label 24057: @1766211
     /* 1766211 */   GIM_Try, /*On fail goto*//*Label 24058*/ GIMT_Encode4(1766297), // Rule ID 11591 //
     /* 1766216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766262 */     // MIs[0] policy
     /* 1766262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766272 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1766275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766296 */     // GIR_Coverage, 11591,
     /* 1766296 */     GIR_EraseRootFromParent_Done,
     /* 1766297 */   // Label 24058: @1766297
     /* 1766297 */   GIM_Try, /*On fail goto*//*Label 24059*/ GIMT_Encode4(1766383), // Rule ID 11594 //
     /* 1766302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766348 */     // MIs[0] policy
     /* 1766348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1766361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766382 */     // GIR_Coverage, 11594,
     /* 1766382 */     GIR_EraseRootFromParent_Done,
     /* 1766383 */   // Label 24059: @1766383
     /* 1766383 */   GIM_Try, /*On fail goto*//*Label 24060*/ GIMT_Encode4(1766469), // Rule ID 11595 //
     /* 1766388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766434 */     // MIs[0] policy
     /* 1766434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766444 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1766447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766468 */     // GIR_Coverage, 11595,
     /* 1766468 */     GIR_EraseRootFromParent_Done,
     /* 1766469 */   // Label 24060: @1766469
     /* 1766469 */   GIM_Try, /*On fail goto*//*Label 24061*/ GIMT_Encode4(1766555), // Rule ID 11598 //
     /* 1766474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766520 */     // MIs[0] policy
     /* 1766520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766530 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1766533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766554 */     // GIR_Coverage, 11598,
     /* 1766554 */     GIR_EraseRootFromParent_Done,
     /* 1766555 */   // Label 24061: @1766555
     /* 1766555 */   GIM_Try, /*On fail goto*//*Label 24062*/ GIMT_Encode4(1766641), // Rule ID 11599 //
     /* 1766560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766606 */     // MIs[0] policy
     /* 1766606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1766619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766640 */     // GIR_Coverage, 11599,
     /* 1766640 */     GIR_EraseRootFromParent_Done,
     /* 1766641 */   // Label 24062: @1766641
     /* 1766641 */   GIM_Try, /*On fail goto*//*Label 24063*/ GIMT_Encode4(1766727), // Rule ID 11602 //
     /* 1766646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766692 */     // MIs[0] policy
     /* 1766692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766702 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1766705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766726 */     // GIR_Coverage, 11602,
     /* 1766726 */     GIR_EraseRootFromParent_Done,
     /* 1766727 */   // Label 24063: @1766727
     /* 1766727 */   GIM_Try, /*On fail goto*//*Label 24064*/ GIMT_Encode4(1766813), // Rule ID 11603 //
     /* 1766732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766778 */     // MIs[0] policy
     /* 1766778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766788 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1766791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766812 */     // GIR_Coverage, 11603,
     /* 1766812 */     GIR_EraseRootFromParent_Done,
     /* 1766813 */   // Label 24064: @1766813
     /* 1766813 */   GIM_Try, /*On fail goto*//*Label 24065*/ GIMT_Encode4(1766899), // Rule ID 11606 //
     /* 1766818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1766826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1766838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766864 */     // MIs[0] policy
     /* 1766864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766874 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1766877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766898 */     // GIR_Coverage, 11606,
     /* 1766898 */     GIR_EraseRootFromParent_Done,
     /* 1766899 */   // Label 24065: @1766899
     /* 1766899 */   GIM_Try, /*On fail goto*//*Label 24066*/ GIMT_Encode4(1766985), // Rule ID 11607 //
     /* 1766904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1766912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1766924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766950 */     // MIs[0] policy
     /* 1766950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766960 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1766963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766984 */     // GIR_Coverage, 11607,
     /* 1766984 */     GIR_EraseRootFromParent_Done,
     /* 1766985 */   // Label 24066: @1766985
     /* 1766985 */   GIM_Try, /*On fail goto*//*Label 24067*/ GIMT_Encode4(1767071), // Rule ID 11610 //
     /* 1766990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1766998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1767001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1767004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1767007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1767010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767036 */     // MIs[0] policy
     /* 1767036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1767049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767070 */     // GIR_Coverage, 11610,
     /* 1767070 */     GIR_EraseRootFromParent_Done,
     /* 1767071 */   // Label 24067: @1767071
     /* 1767071 */   GIM_Try, /*On fail goto*//*Label 24068*/ GIMT_Encode4(1767157), // Rule ID 11611 //
     /* 1767076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1767087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1767090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1767093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1767096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767122 */     // MIs[0] policy
     /* 1767122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1767135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767156 */     // GIR_Coverage, 11611,
     /* 1767156 */     GIR_EraseRootFromParent_Done,
     /* 1767157 */   // Label 24068: @1767157
     /* 1767157 */   GIM_Try, /*On fail goto*//*Label 24069*/ GIMT_Encode4(1767243), // Rule ID 11614 //
     /* 1767162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1767182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767208 */     // MIs[0] policy
     /* 1767208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767218 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1767221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767242 */     // GIR_Coverage, 11614,
     /* 1767242 */     GIR_EraseRootFromParent_Done,
     /* 1767243 */   // Label 24069: @1767243
     /* 1767243 */   GIM_Try, /*On fail goto*//*Label 24070*/ GIMT_Encode4(1767329), // Rule ID 11615 //
     /* 1767248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1767268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767294 */     // MIs[0] policy
     /* 1767294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767304 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1767307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767328 */     // GIR_Coverage, 11615,
     /* 1767328 */     GIR_EraseRootFromParent_Done,
     /* 1767329 */   // Label 24070: @1767329
     /* 1767329 */   GIM_Try, /*On fail goto*//*Label 24071*/ GIMT_Encode4(1767415), // Rule ID 11618 //
     /* 1767334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1767354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767380 */     // MIs[0] policy
     /* 1767380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767390 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1767393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767414 */     // GIR_Coverage, 11618,
     /* 1767414 */     GIR_EraseRootFromParent_Done,
     /* 1767415 */   // Label 24071: @1767415
     /* 1767415 */   GIM_Try, /*On fail goto*//*Label 24072*/ GIMT_Encode4(1767501), // Rule ID 11619 //
     /* 1767420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1767440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767466 */     // MIs[0] policy
     /* 1767466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1767479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767500 */     // GIR_Coverage, 11619,
     /* 1767500 */     GIR_EraseRootFromParent_Done,
     /* 1767501 */   // Label 24072: @1767501
     /* 1767501 */   GIM_Try, /*On fail goto*//*Label 24073*/ GIMT_Encode4(1767587), // Rule ID 11622 //
     /* 1767506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1767517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1767520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1767523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767552 */     // MIs[0] policy
     /* 1767552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767562 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1767565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767586 */     // GIR_Coverage, 11622,
     /* 1767586 */     GIR_EraseRootFromParent_Done,
     /* 1767587 */   // Label 24073: @1767587
     /* 1767587 */   GIM_Try, /*On fail goto*//*Label 24074*/ GIMT_Encode4(1767673), // Rule ID 11623 //
     /* 1767592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1767603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1767606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1767609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767638 */     // MIs[0] policy
     /* 1767638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767648 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1767651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767672 */     // GIR_Coverage, 11623,
     /* 1767672 */     GIR_EraseRootFromParent_Done,
     /* 1767673 */   // Label 24074: @1767673
     /* 1767673 */   GIM_Try, /*On fail goto*//*Label 24075*/ GIMT_Encode4(1767759), // Rule ID 11626 //
     /* 1767678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1767689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1767692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1767695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767724 */     // MIs[0] policy
     /* 1767724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767734 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1767737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767758 */     // GIR_Coverage, 11626,
     /* 1767758 */     GIR_EraseRootFromParent_Done,
     /* 1767759 */   // Label 24075: @1767759
     /* 1767759 */   GIM_Try, /*On fail goto*//*Label 24076*/ GIMT_Encode4(1767845), // Rule ID 11627 //
     /* 1767764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1767775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1767778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1767781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767810 */     // MIs[0] policy
     /* 1767810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767820 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1767823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767844 */     // GIR_Coverage, 11627,
     /* 1767844 */     GIR_EraseRootFromParent_Done,
     /* 1767845 */   // Label 24076: @1767845
     /* 1767845 */   GIM_Try, /*On fail goto*//*Label 24077*/ GIMT_Encode4(1767931), // Rule ID 11630 //
     /* 1767850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767896 */     // MIs[0] policy
     /* 1767896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767906 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1767909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767930 */     // GIR_Coverage, 11630,
     /* 1767930 */     GIR_EraseRootFromParent_Done,
     /* 1767931 */   // Label 24077: @1767931
     /* 1767931 */   GIM_Try, /*On fail goto*//*Label 24078*/ GIMT_Encode4(1768017), // Rule ID 11631 //
     /* 1767936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767982 */     // MIs[0] policy
     /* 1767982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767992 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1767995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768016 */     // GIR_Coverage, 11631,
     /* 1768016 */     GIR_EraseRootFromParent_Done,
     /* 1768017 */   // Label 24078: @1768017
     /* 1768017 */   GIM_Try, /*On fail goto*//*Label 24079*/ GIMT_Encode4(1768103), // Rule ID 11634 //
     /* 1768022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1768033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1768036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1768039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768068 */     // MIs[0] policy
     /* 1768068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768078 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1768081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768102 */     // GIR_Coverage, 11634,
     /* 1768102 */     GIR_EraseRootFromParent_Done,
     /* 1768103 */   // Label 24079: @1768103
     /* 1768103 */   GIM_Try, /*On fail goto*//*Label 24080*/ GIMT_Encode4(1768189), // Rule ID 11635 //
     /* 1768108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1768119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1768122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1768125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768154 */     // MIs[0] policy
     /* 1768154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768164 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1768167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768188 */     // GIR_Coverage, 11635,
     /* 1768188 */     GIR_EraseRootFromParent_Done,
     /* 1768189 */   // Label 24080: @1768189
     /* 1768189 */   GIM_Try, /*On fail goto*//*Label 24081*/ GIMT_Encode4(1768275), // Rule ID 11638 //
     /* 1768194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1768214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768240 */     // MIs[0] policy
     /* 1768240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768250 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1768253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768274 */     // GIR_Coverage, 11638,
     /* 1768274 */     GIR_EraseRootFromParent_Done,
     /* 1768275 */   // Label 24081: @1768275
     /* 1768275 */   GIM_Try, /*On fail goto*//*Label 24082*/ GIMT_Encode4(1768361), // Rule ID 11639 //
     /* 1768280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1768300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768326 */     // MIs[0] policy
     /* 1768326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1768339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768360 */     // GIR_Coverage, 11639,
     /* 1768360 */     GIR_EraseRootFromParent_Done,
     /* 1768361 */   // Label 24082: @1768361
     /* 1768361 */   GIM_Try, /*On fail goto*//*Label 24083*/ GIMT_Encode4(1768447), // Rule ID 11642 //
     /* 1768366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1768377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1768380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1768383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1768386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768412 */     // MIs[0] policy
     /* 1768412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768422 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1768425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768446 */     // GIR_Coverage, 11642,
     /* 1768446 */     GIR_EraseRootFromParent_Done,
     /* 1768447 */   // Label 24083: @1768447
     /* 1768447 */   GIM_Try, /*On fail goto*//*Label 24084*/ GIMT_Encode4(1768533), // Rule ID 11643 //
     /* 1768452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1768463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1768466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1768469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1768472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768498 */     // MIs[0] policy
     /* 1768498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1768511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768532 */     // GIR_Coverage, 11643,
     /* 1768532 */     GIR_EraseRootFromParent_Done,
     /* 1768533 */   // Label 24084: @1768533
     /* 1768533 */   GIM_Try, /*On fail goto*//*Label 24085*/ GIMT_Encode4(1768619), // Rule ID 11646 //
     /* 1768538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1768549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1768552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1768555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1768558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768584 */     // MIs[0] policy
     /* 1768584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768594 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1768597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768618 */     // GIR_Coverage, 11646,
     /* 1768618 */     GIR_EraseRootFromParent_Done,
     /* 1768619 */   // Label 24085: @1768619
     /* 1768619 */   GIM_Try, /*On fail goto*//*Label 24086*/ GIMT_Encode4(1768705), // Rule ID 11647 //
     /* 1768624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1768635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1768638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1768641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1768644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768670 */     // MIs[0] policy
     /* 1768670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768680 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1768683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768704 */     // GIR_Coverage, 11647,
     /* 1768704 */     GIR_EraseRootFromParent_Done,
     /* 1768705 */   // Label 24086: @1768705
     /* 1768705 */   GIM_Try, /*On fail goto*//*Label 24087*/ GIMT_Encode4(1768791), // Rule ID 11650 //
     /* 1768710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1768721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1768724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1768727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1768730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768756 */     // MIs[0] policy
     /* 1768756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768766 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1768769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768790 */     // GIR_Coverage, 11650,
     /* 1768790 */     GIR_EraseRootFromParent_Done,
     /* 1768791 */   // Label 24087: @1768791
     /* 1768791 */   GIM_Try, /*On fail goto*//*Label 24088*/ GIMT_Encode4(1768877), // Rule ID 11651 //
     /* 1768796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1768807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1768810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1768813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1768816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768842 */     // MIs[0] policy
     /* 1768842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768852 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1768855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768876 */     // GIR_Coverage, 11651,
     /* 1768876 */     GIR_EraseRootFromParent_Done,
     /* 1768877 */   // Label 24088: @1768877
     /* 1768877 */   GIM_Try, /*On fail goto*//*Label 24089*/ GIMT_Encode4(1768963), // Rule ID 11654 //
     /* 1768882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768928 */     // MIs[0] policy
     /* 1768928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768938 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1768941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768962 */     // GIR_Coverage, 11654,
     /* 1768962 */     GIR_EraseRootFromParent_Done,
     /* 1768963 */   // Label 24089: @1768963
     /* 1768963 */   GIM_Try, /*On fail goto*//*Label 24090*/ GIMT_Encode4(1769049), // Rule ID 11655 //
     /* 1768968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769014 */     // MIs[0] policy
     /* 1769014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769024 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1769027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769048 */     // GIR_Coverage, 11655,
     /* 1769048 */     GIR_EraseRootFromParent_Done,
     /* 1769049 */   // Label 24090: @1769049
     /* 1769049 */   GIM_Try, /*On fail goto*//*Label 24091*/ GIMT_Encode4(1769135), // Rule ID 11658 //
     /* 1769054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1769065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1769068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1769071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769100 */     // MIs[0] policy
     /* 1769100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1769113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769134 */     // GIR_Coverage, 11658,
     /* 1769134 */     GIR_EraseRootFromParent_Done,
     /* 1769135 */   // Label 24091: @1769135
     /* 1769135 */   GIM_Try, /*On fail goto*//*Label 24092*/ GIMT_Encode4(1769221), // Rule ID 11659 //
     /* 1769140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1769151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1769154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1769157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769186 */     // MIs[0] policy
     /* 1769186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769196 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1769199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769220 */     // GIR_Coverage, 11659,
     /* 1769220 */     GIR_EraseRootFromParent_Done,
     /* 1769221 */   // Label 24092: @1769221
     /* 1769221 */   GIM_Try, /*On fail goto*//*Label 24093*/ GIMT_Encode4(1769307), // Rule ID 11662 //
     /* 1769226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769272 */     // MIs[0] policy
     /* 1769272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769282 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1769285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769306 */     // GIR_Coverage, 11662,
     /* 1769306 */     GIR_EraseRootFromParent_Done,
     /* 1769307 */   // Label 24093: @1769307
     /* 1769307 */   GIM_Try, /*On fail goto*//*Label 24094*/ GIMT_Encode4(1769393), // Rule ID 11663 //
     /* 1769312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769358 */     // MIs[0] policy
     /* 1769358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769368 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1769371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769392 */     // GIR_Coverage, 11663,
     /* 1769392 */     GIR_EraseRootFromParent_Done,
     /* 1769393 */   // Label 24094: @1769393
     /* 1769393 */   GIM_Try, /*On fail goto*//*Label 24095*/ GIMT_Encode4(1769479), // Rule ID 11666 //
     /* 1769398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769444 */     // MIs[0] policy
     /* 1769444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1769457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769478 */     // GIR_Coverage, 11666,
     /* 1769478 */     GIR_EraseRootFromParent_Done,
     /* 1769479 */   // Label 24095: @1769479
     /* 1769479 */   GIM_Try, /*On fail goto*//*Label 24096*/ GIMT_Encode4(1769565), // Rule ID 11667 //
     /* 1769484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769530 */     // MIs[0] policy
     /* 1769530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769540 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1769543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769564 */     // GIR_Coverage, 11667,
     /* 1769564 */     GIR_EraseRootFromParent_Done,
     /* 1769565 */   // Label 24096: @1769565
     /* 1769565 */   GIM_Try, /*On fail goto*//*Label 24097*/ GIMT_Encode4(1769651), // Rule ID 11670 //
     /* 1769570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1769581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1769584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1769587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1769590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1769593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769616 */     // MIs[0] policy
     /* 1769616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769626 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1769629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769650 */     // GIR_Coverage, 11670,
     /* 1769650 */     GIR_EraseRootFromParent_Done,
     /* 1769651 */   // Label 24097: @1769651
     /* 1769651 */   GIM_Try, /*On fail goto*//*Label 24098*/ GIMT_Encode4(1769737), // Rule ID 11671 //
     /* 1769656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1769667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1769670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1769673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1769676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1769679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769702 */     // MIs[0] policy
     /* 1769702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769712 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1769715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769736 */     // GIR_Coverage, 11671,
     /* 1769736 */     GIR_EraseRootFromParent_Done,
     /* 1769737 */   // Label 24098: @1769737
     /* 1769737 */   GIM_Try, /*On fail goto*//*Label 24099*/ GIMT_Encode4(1769823), // Rule ID 11674 //
     /* 1769742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1769753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1769756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1769759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1769762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769788 */     // MIs[0] policy
     /* 1769788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769798 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1769801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769822 */     // GIR_Coverage, 11674,
     /* 1769822 */     GIR_EraseRootFromParent_Done,
     /* 1769823 */   // Label 24099: @1769823
     /* 1769823 */   GIM_Try, /*On fail goto*//*Label 24100*/ GIMT_Encode4(1769909), // Rule ID 11675 //
     /* 1769828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1769839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1769842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1769845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1769848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769874 */     // MIs[0] policy
     /* 1769874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769884 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1769887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769908 */     // GIR_Coverage, 11675,
     /* 1769908 */     GIR_EraseRootFromParent_Done,
     /* 1769909 */   // Label 24100: @1769909
     /* 1769909 */   GIM_Try, /*On fail goto*//*Label 24101*/ GIMT_Encode4(1769995), // Rule ID 11678 //
     /* 1769914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1769925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1769928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1769931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1769934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769960 */     // MIs[0] policy
     /* 1769960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769970 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1769973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769994 */     // GIR_Coverage, 11678,
     /* 1769994 */     GIR_EraseRootFromParent_Done,
     /* 1769995 */   // Label 24101: @1769995
     /* 1769995 */   GIM_Try, /*On fail goto*//*Label 24102*/ GIMT_Encode4(1770081), // Rule ID 11679 //
     /* 1770000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1770011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1770014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1770017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1770020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770046 */     // MIs[0] policy
     /* 1770046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770056 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1770059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770080 */     // GIR_Coverage, 11679,
     /* 1770080 */     GIR_EraseRootFromParent_Done,
     /* 1770081 */   // Label 24102: @1770081
     /* 1770081 */   GIM_Try, /*On fail goto*//*Label 24103*/ GIMT_Encode4(1770167), // Rule ID 11682 //
     /* 1770086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1770097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1770100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1770103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1770106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770132 */     // MIs[0] policy
     /* 1770132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770142 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1770145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770166 */     // GIR_Coverage, 11682,
     /* 1770166 */     GIR_EraseRootFromParent_Done,
     /* 1770167 */   // Label 24103: @1770167
     /* 1770167 */   GIM_Try, /*On fail goto*//*Label 24104*/ GIMT_Encode4(1770253), // Rule ID 11683 //
     /* 1770172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1770183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1770186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1770189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1770192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770218 */     // MIs[0] policy
     /* 1770218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770228 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1770231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770252 */     // GIR_Coverage, 11683,
     /* 1770252 */     GIR_EraseRootFromParent_Done,
     /* 1770253 */   // Label 24104: @1770253
     /* 1770253 */   GIM_Try, /*On fail goto*//*Label 24105*/ GIMT_Encode4(1770339), // Rule ID 11686 //
     /* 1770258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1770269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1770272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1770275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1770278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770304 */     // MIs[0] policy
     /* 1770304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770314 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1770317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770338 */     // GIR_Coverage, 11686,
     /* 1770338 */     GIR_EraseRootFromParent_Done,
     /* 1770339 */   // Label 24105: @1770339
     /* 1770339 */   GIM_Try, /*On fail goto*//*Label 24106*/ GIMT_Encode4(1770425), // Rule ID 11687 //
     /* 1770344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1770355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1770358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1770361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1770364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770390 */     // MIs[0] policy
     /* 1770390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770400 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1770403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770424 */     // GIR_Coverage, 11687,
     /* 1770424 */     GIR_EraseRootFromParent_Done,
     /* 1770425 */   // Label 24106: @1770425
     /* 1770425 */   GIM_Try, /*On fail goto*//*Label 24107*/ GIMT_Encode4(1770511), // Rule ID 11690 //
     /* 1770430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1770441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1770444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1770447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1770450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770476 */     // MIs[0] policy
     /* 1770476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1770489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770510 */     // GIR_Coverage, 11690,
     /* 1770510 */     GIR_EraseRootFromParent_Done,
     /* 1770511 */   // Label 24107: @1770511
     /* 1770511 */   GIM_Try, /*On fail goto*//*Label 24108*/ GIMT_Encode4(1770597), // Rule ID 11691 //
     /* 1770516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1770527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1770530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1770533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1770536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770562 */     // MIs[0] policy
     /* 1770562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1770575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770596 */     // GIR_Coverage, 11691,
     /* 1770596 */     GIR_EraseRootFromParent_Done,
     /* 1770597 */   // Label 24108: @1770597
     /* 1770597 */   GIM_Try, /*On fail goto*//*Label 24109*/ GIMT_Encode4(1770683), // Rule ID 11694 //
     /* 1770602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1770613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1770616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1770619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1770622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770648 */     // MIs[0] policy
     /* 1770648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770658 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1770661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770682 */     // GIR_Coverage, 11694,
     /* 1770682 */     GIR_EraseRootFromParent_Done,
     /* 1770683 */   // Label 24109: @1770683
     /* 1770683 */   GIM_Try, /*On fail goto*//*Label 24110*/ GIMT_Encode4(1770769), // Rule ID 11695 //
     /* 1770688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1770699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1770702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1770705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1770708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770734 */     // MIs[0] policy
     /* 1770734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770744 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1770747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770768 */     // GIR_Coverage, 11695,
     /* 1770768 */     GIR_EraseRootFromParent_Done,
     /* 1770769 */   // Label 24110: @1770769
     /* 1770769 */   GIM_Try, /*On fail goto*//*Label 24111*/ GIMT_Encode4(1770855), // Rule ID 11698 //
     /* 1770774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1770785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1770788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1770791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1770794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770820 */     // MIs[0] policy
     /* 1770820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770830 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1770833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770854 */     // GIR_Coverage, 11698,
     /* 1770854 */     GIR_EraseRootFromParent_Done,
     /* 1770855 */   // Label 24111: @1770855
     /* 1770855 */   GIM_Try, /*On fail goto*//*Label 24112*/ GIMT_Encode4(1770941), // Rule ID 11699 //
     /* 1770860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1770871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1770874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1770877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1770880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770906 */     // MIs[0] policy
     /* 1770906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770916 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1770919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770940 */     // GIR_Coverage, 11699,
     /* 1770940 */     GIR_EraseRootFromParent_Done,
     /* 1770941 */   // Label 24112: @1770941
     /* 1770941 */   GIM_Try, /*On fail goto*//*Label 24113*/ GIMT_Encode4(1771027), // Rule ID 11702 //
     /* 1770946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1770957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1770960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1770963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1770966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770992 */     // MIs[0] policy
     /* 1770992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1771005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771026 */     // GIR_Coverage, 11702,
     /* 1771026 */     GIR_EraseRootFromParent_Done,
     /* 1771027 */   // Label 24113: @1771027
     /* 1771027 */   GIM_Try, /*On fail goto*//*Label 24114*/ GIMT_Encode4(1771113), // Rule ID 11703 //
     /* 1771032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1771043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1771046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1771049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1771052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771078 */     // MIs[0] policy
     /* 1771078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771088 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1771091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771112 */     // GIR_Coverage, 11703,
     /* 1771112 */     GIR_EraseRootFromParent_Done,
     /* 1771113 */   // Label 24114: @1771113
     /* 1771113 */   GIM_Try, /*On fail goto*//*Label 24115*/ GIMT_Encode4(1771199), // Rule ID 11706 //
     /* 1771118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1771121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1771129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1771132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1771135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1771138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771164 */     // MIs[0] policy
     /* 1771164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1771177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771198 */     // GIR_Coverage, 11706,
     /* 1771198 */     GIR_EraseRootFromParent_Done,
     /* 1771199 */   // Label 24115: @1771199
     /* 1771199 */   GIM_Try, /*On fail goto*//*Label 24116*/ GIMT_Encode4(1771285), // Rule ID 11707 //
     /* 1771204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1771207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1771215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1771218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1771221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1771224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771250 */     // MIs[0] policy
     /* 1771250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771260 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1771263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771284 */     // GIR_Coverage, 11707,
     /* 1771284 */     GIR_EraseRootFromParent_Done,
     /* 1771285 */   // Label 24116: @1771285
     /* 1771285 */   GIM_Try, /*On fail goto*//*Label 24117*/ GIMT_Encode4(1771371), // Rule ID 11710 //
     /* 1771290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1771301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1771304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1771307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1771310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1771313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771336 */     // MIs[0] policy
     /* 1771336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1771349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771370 */     // GIR_Coverage, 11710,
     /* 1771370 */     GIR_EraseRootFromParent_Done,
     /* 1771371 */   // Label 24117: @1771371
     /* 1771371 */   GIM_Try, /*On fail goto*//*Label 24118*/ GIMT_Encode4(1771457), // Rule ID 11711 //
     /* 1771376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1771387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1771390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1771393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1771396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1771399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771422 */     // MIs[0] policy
     /* 1771422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771432 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1771435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771456 */     // GIR_Coverage, 11711,
     /* 1771456 */     GIR_EraseRootFromParent_Done,
     /* 1771457 */   // Label 24118: @1771457
     /* 1771457 */   GIM_Try, /*On fail goto*//*Label 24119*/ GIMT_Encode4(1771543), // Rule ID 11714 //
     /* 1771462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1771473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1771476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1771479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1771482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1771485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1771492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771508 */     // MIs[0] policy
     /* 1771508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771518 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1771521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771542 */     // GIR_Coverage, 11714,
     /* 1771542 */     GIR_EraseRootFromParent_Done,
     /* 1771543 */   // Label 24119: @1771543
     /* 1771543 */   GIM_Try, /*On fail goto*//*Label 24120*/ GIMT_Encode4(1771629), // Rule ID 11715 //
     /* 1771548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1771559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1771562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1771565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1771568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1771571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1771578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771594 */     // MIs[0] policy
     /* 1771594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771604 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1771607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771628 */     // GIR_Coverage, 11715,
     /* 1771628 */     GIR_EraseRootFromParent_Done,
     /* 1771629 */   // Label 24120: @1771629
     /* 1771629 */   GIM_Try, /*On fail goto*//*Label 24121*/ GIMT_Encode4(1771715), // Rule ID 11718 //
     /* 1771634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1771645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1771648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1771651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1771654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1771657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1771664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771680 */     // MIs[0] policy
     /* 1771680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771690 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1771693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771714 */     // GIR_Coverage, 11718,
     /* 1771714 */     GIR_EraseRootFromParent_Done,
     /* 1771715 */   // Label 24121: @1771715
     /* 1771715 */   GIM_Try, /*On fail goto*//*Label 24122*/ GIMT_Encode4(1771801), // Rule ID 11719 //
     /* 1771720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1771731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1771734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1771737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1771740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1771743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1771750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771766 */     // MIs[0] policy
     /* 1771766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771776 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1771779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771800 */     // GIR_Coverage, 11719,
     /* 1771800 */     GIR_EraseRootFromParent_Done,
     /* 1771801 */   // Label 24122: @1771801
     /* 1771801 */   GIM_Try, /*On fail goto*//*Label 24123*/ GIMT_Encode4(1771887), // Rule ID 11722 //
     /* 1771806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1771817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1771820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1771823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1771826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771852 */     // MIs[0] policy
     /* 1771852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771862 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1771865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771886 */     // GIR_Coverage, 11722,
     /* 1771886 */     GIR_EraseRootFromParent_Done,
     /* 1771887 */   // Label 24123: @1771887
     /* 1771887 */   GIM_Try, /*On fail goto*//*Label 24124*/ GIMT_Encode4(1771973), // Rule ID 11723 //
     /* 1771892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1771903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1771906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1771909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1771912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771938 */     // MIs[0] policy
     /* 1771938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771948 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1771951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771972 */     // GIR_Coverage, 11723,
     /* 1771972 */     GIR_EraseRootFromParent_Done,
     /* 1771973 */   // Label 24124: @1771973
     /* 1771973 */   GIM_Try, /*On fail goto*//*Label 24125*/ GIMT_Encode4(1772059), // Rule ID 11726 //
     /* 1771978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1771989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1771992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1771995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1771998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772024 */     // MIs[0] policy
     /* 1772024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1772037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772058 */     // GIR_Coverage, 11726,
     /* 1772058 */     GIR_EraseRootFromParent_Done,
     /* 1772059 */   // Label 24125: @1772059
     /* 1772059 */   GIM_Try, /*On fail goto*//*Label 24126*/ GIMT_Encode4(1772145), // Rule ID 11727 //
     /* 1772064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1772075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1772078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1772081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1772084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772110 */     // MIs[0] policy
     /* 1772110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772120 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1772123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772144 */     // GIR_Coverage, 11727,
     /* 1772144 */     GIR_EraseRootFromParent_Done,
     /* 1772145 */   // Label 24126: @1772145
     /* 1772145 */   GIM_Try, /*On fail goto*//*Label 24127*/ GIMT_Encode4(1772231), // Rule ID 11730 //
     /* 1772150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1772161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1772164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1772167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1772170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772196 */     // MIs[0] policy
     /* 1772196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1772209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772230 */     // GIR_Coverage, 11730,
     /* 1772230 */     GIR_EraseRootFromParent_Done,
     /* 1772231 */   // Label 24127: @1772231
     /* 1772231 */   GIM_Try, /*On fail goto*//*Label 24128*/ GIMT_Encode4(1772317), // Rule ID 11731 //
     /* 1772236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1772247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1772250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1772253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1772256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772282 */     // MIs[0] policy
     /* 1772282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772292 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1772295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772316 */     // GIR_Coverage, 11731,
     /* 1772316 */     GIR_EraseRootFromParent_Done,
     /* 1772317 */   // Label 24128: @1772317
     /* 1772317 */   GIM_Try, /*On fail goto*//*Label 24129*/ GIMT_Encode4(1772403), // Rule ID 11734 //
     /* 1772322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1772333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1772336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1772339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1772342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772368 */     // MIs[0] policy
     /* 1772368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772378 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1772381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772402 */     // GIR_Coverage, 11734,
     /* 1772402 */     GIR_EraseRootFromParent_Done,
     /* 1772403 */   // Label 24129: @1772403
     /* 1772403 */   GIM_Try, /*On fail goto*//*Label 24130*/ GIMT_Encode4(1772489), // Rule ID 11735 //
     /* 1772408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1772419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1772422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1772425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1772428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772454 */     // MIs[0] policy
     /* 1772454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1772467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772488 */     // GIR_Coverage, 11735,
     /* 1772488 */     GIR_EraseRootFromParent_Done,
     /* 1772489 */   // Label 24130: @1772489
     /* 1772489 */   GIM_Try, /*On fail goto*//*Label 24131*/ GIMT_Encode4(1772575), // Rule ID 11738 //
     /* 1772494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1772505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1772508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1772511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1772514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772540 */     // MIs[0] policy
     /* 1772540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772550 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1772553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772574 */     // GIR_Coverage, 11738,
     /* 1772574 */     GIR_EraseRootFromParent_Done,
     /* 1772575 */   // Label 24131: @1772575
     /* 1772575 */   GIM_Try, /*On fail goto*//*Label 24132*/ GIMT_Encode4(1772661), // Rule ID 11739 //
     /* 1772580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1772591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1772594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1772597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1772600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772626 */     // MIs[0] policy
     /* 1772626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772636 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1772639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772660 */     // GIR_Coverage, 11739,
     /* 1772660 */     GIR_EraseRootFromParent_Done,
     /* 1772661 */   // Label 24132: @1772661
     /* 1772661 */   GIM_Try, /*On fail goto*//*Label 24133*/ GIMT_Encode4(1772747), // Rule ID 11742 //
     /* 1772666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1772677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1772680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1772683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1772686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772712 */     // MIs[0] policy
     /* 1772712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1772725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772746 */     // GIR_Coverage, 11742,
     /* 1772746 */     GIR_EraseRootFromParent_Done,
     /* 1772747 */   // Label 24133: @1772747
     /* 1772747 */   GIM_Try, /*On fail goto*//*Label 24134*/ GIMT_Encode4(1772833), // Rule ID 11743 //
     /* 1772752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1772763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1772766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1772769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1772772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772798 */     // MIs[0] policy
     /* 1772798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772808 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1772811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772832 */     // GIR_Coverage, 11743,
     /* 1772832 */     GIR_EraseRootFromParent_Done,
     /* 1772833 */   // Label 24134: @1772833
     /* 1772833 */   GIM_Try, /*On fail goto*//*Label 24135*/ GIMT_Encode4(1772919), // Rule ID 11746 //
     /* 1772838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1772841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1772849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1772852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1772855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1772858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1772861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772884 */     // MIs[0] policy
     /* 1772884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1772897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772918 */     // GIR_Coverage, 11746,
     /* 1772918 */     GIR_EraseRootFromParent_Done,
     /* 1772919 */   // Label 24135: @1772919
     /* 1772919 */   GIM_Try, /*On fail goto*//*Label 24136*/ GIMT_Encode4(1773005), // Rule ID 11747 //
     /* 1772924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1772927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1772935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1772938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1772941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1772944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1772947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772970 */     // MIs[0] policy
     /* 1772970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772980 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1772983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773004 */     // GIR_Coverage, 11747,
     /* 1773004 */     GIR_EraseRootFromParent_Done,
     /* 1773005 */   // Label 24136: @1773005
     /* 1773005 */   GIM_Try, /*On fail goto*//*Label 24137*/ GIMT_Encode4(1773091), // Rule ID 11750 //
     /* 1773010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1773013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1773021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1773024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1773027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1773030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773056 */     // MIs[0] policy
     /* 1773056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1773069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773090 */     // GIR_Coverage, 11750,
     /* 1773090 */     GIR_EraseRootFromParent_Done,
     /* 1773091 */   // Label 24137: @1773091
     /* 1773091 */   GIM_Try, /*On fail goto*//*Label 24138*/ GIMT_Encode4(1773177), // Rule ID 11751 //
     /* 1773096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1773099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1773107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1773110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1773113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1773116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773142 */     // MIs[0] policy
     /* 1773142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773152 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1773155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773176 */     // GIR_Coverage, 11751,
     /* 1773176 */     GIR_EraseRootFromParent_Done,
     /* 1773177 */   // Label 24138: @1773177
     /* 1773177 */   GIM_Try, /*On fail goto*//*Label 24139*/ GIMT_Encode4(1773263), // Rule ID 11754 //
     /* 1773182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1773185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1773193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1773196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1773199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1773202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773228 */     // MIs[0] policy
     /* 1773228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773238 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1773241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773262 */     // GIR_Coverage, 11754,
     /* 1773262 */     GIR_EraseRootFromParent_Done,
     /* 1773263 */   // Label 24139: @1773263
     /* 1773263 */   GIM_Try, /*On fail goto*//*Label 24140*/ GIMT_Encode4(1773349), // Rule ID 11755 //
     /* 1773268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1773271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1773279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1773282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1773285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1773288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773314 */     // MIs[0] policy
     /* 1773314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773324 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1773327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773348 */     // GIR_Coverage, 11755,
     /* 1773348 */     GIR_EraseRootFromParent_Done,
     /* 1773349 */   // Label 24140: @1773349
     /* 1773349 */   GIM_Try, /*On fail goto*//*Label 24141*/ GIMT_Encode4(1773435), // Rule ID 11758 //
     /* 1773354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1773365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1773368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1773371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773400 */     // MIs[0] policy
     /* 1773400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773410 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1773413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773434 */     // GIR_Coverage, 11758,
     /* 1773434 */     GIR_EraseRootFromParent_Done,
     /* 1773435 */   // Label 24141: @1773435
     /* 1773435 */   GIM_Try, /*On fail goto*//*Label 24142*/ GIMT_Encode4(1773521), // Rule ID 11759 //
     /* 1773440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1773451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1773454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1773457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773486 */     // MIs[0] policy
     /* 1773486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1773499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773520 */     // GIR_Coverage, 11759,
     /* 1773520 */     GIR_EraseRootFromParent_Done,
     /* 1773521 */   // Label 24142: @1773521
     /* 1773521 */   GIM_Try, /*On fail goto*//*Label 24143*/ GIMT_Encode4(1773607), // Rule ID 11762 //
     /* 1773526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1773537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1773540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1773543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1773549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773572 */     // MIs[0] policy
     /* 1773572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773582 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1773585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773606 */     // GIR_Coverage, 11762,
     /* 1773606 */     GIR_EraseRootFromParent_Done,
     /* 1773607 */   // Label 24143: @1773607
     /* 1773607 */   GIM_Try, /*On fail goto*//*Label 24144*/ GIMT_Encode4(1773693), // Rule ID 11763 //
     /* 1773612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1773623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1773626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1773629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1773635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773658 */     // MIs[0] policy
     /* 1773658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773668 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1773671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773692 */     // GIR_Coverage, 11763,
     /* 1773692 */     GIR_EraseRootFromParent_Done,
     /* 1773693 */   // Label 24144: @1773693
     /* 1773693 */   GIM_Try, /*On fail goto*//*Label 24145*/ GIMT_Encode4(1773779), // Rule ID 11766 //
     /* 1773698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1773709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1773712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1773715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773744 */     // MIs[0] policy
     /* 1773744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773754 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1773757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773778 */     // GIR_Coverage, 11766,
     /* 1773778 */     GIR_EraseRootFromParent_Done,
     /* 1773779 */   // Label 24145: @1773779
     /* 1773779 */   GIM_Try, /*On fail goto*//*Label 24146*/ GIMT_Encode4(1773865), // Rule ID 11767 //
     /* 1773784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1773795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1773798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1773801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773830 */     // MIs[0] policy
     /* 1773830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773840 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1773843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773864 */     // GIR_Coverage, 11767,
     /* 1773864 */     GIR_EraseRootFromParent_Done,
     /* 1773865 */   // Label 24146: @1773865
     /* 1773865 */   GIM_Try, /*On fail goto*//*Label 24147*/ GIMT_Encode4(1773951), // Rule ID 11770 //
     /* 1773870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1773881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1773884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1773887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773916 */     // MIs[0] policy
     /* 1773916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773926 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1773929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773950 */     // GIR_Coverage, 11770,
     /* 1773950 */     GIR_EraseRootFromParent_Done,
     /* 1773951 */   // Label 24147: @1773951
     /* 1773951 */   GIM_Try, /*On fail goto*//*Label 24148*/ GIMT_Encode4(1774037), // Rule ID 11771 //
     /* 1773956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1773967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1773970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1773973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774002 */     // MIs[0] policy
     /* 1774002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774012 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1774015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774036 */     // GIR_Coverage, 11771,
     /* 1774036 */     GIR_EraseRootFromParent_Done,
     /* 1774037 */   // Label 24148: @1774037
     /* 1774037 */   GIM_Try, /*On fail goto*//*Label 24149*/ GIMT_Encode4(1774123), // Rule ID 11774 //
     /* 1774042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1774053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1774056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1774059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774088 */     // MIs[0] policy
     /* 1774088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774098 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1774101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774122 */     // GIR_Coverage, 11774,
     /* 1774122 */     GIR_EraseRootFromParent_Done,
     /* 1774123 */   // Label 24149: @1774123
     /* 1774123 */   GIM_Try, /*On fail goto*//*Label 24150*/ GIMT_Encode4(1774209), // Rule ID 11775 //
     /* 1774128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1774139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1774142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1774145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774174 */     // MIs[0] policy
     /* 1774174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774184 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1774187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774208 */     // GIR_Coverage, 11775,
     /* 1774208 */     GIR_EraseRootFromParent_Done,
     /* 1774209 */   // Label 24150: @1774209
     /* 1774209 */   GIM_Try, /*On fail goto*//*Label 24151*/ GIMT_Encode4(1774295), // Rule ID 11778 //
     /* 1774214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1774225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1774228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1774231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774260 */     // MIs[0] policy
     /* 1774260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774270 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1774273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774294 */     // GIR_Coverage, 11778,
     /* 1774294 */     GIR_EraseRootFromParent_Done,
     /* 1774295 */   // Label 24151: @1774295
     /* 1774295 */   GIM_Try, /*On fail goto*//*Label 24152*/ GIMT_Encode4(1774381), // Rule ID 11779 //
     /* 1774300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1774311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1774314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1774317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774346 */     // MIs[0] policy
     /* 1774346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774356 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1774359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774380 */     // GIR_Coverage, 11779,
     /* 1774380 */     GIR_EraseRootFromParent_Done,
     /* 1774381 */   // Label 24152: @1774381
     /* 1774381 */   GIM_Try, /*On fail goto*//*Label 24153*/ GIMT_Encode4(1774467), // Rule ID 11782 //
     /* 1774386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1774397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1774400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1774403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774432 */     // MIs[0] policy
     /* 1774432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1774445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774466 */     // GIR_Coverage, 11782,
     /* 1774466 */     GIR_EraseRootFromParent_Done,
     /* 1774467 */   // Label 24153: @1774467
     /* 1774467 */   GIM_Try, /*On fail goto*//*Label 24154*/ GIMT_Encode4(1774553), // Rule ID 11783 //
     /* 1774472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1774483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1774486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1774489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774518 */     // MIs[0] policy
     /* 1774518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774528 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1774531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774552 */     // GIR_Coverage, 11783,
     /* 1774552 */     GIR_EraseRootFromParent_Done,
     /* 1774553 */   // Label 24154: @1774553
     /* 1774553 */   GIM_Try, /*On fail goto*//*Label 24155*/ GIMT_Encode4(1774639), // Rule ID 11786 //
     /* 1774558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1774569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1774572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1774575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774604 */     // MIs[0] policy
     /* 1774604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774614 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1774617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774638 */     // GIR_Coverage, 11786,
     /* 1774638 */     GIR_EraseRootFromParent_Done,
     /* 1774639 */   // Label 24155: @1774639
     /* 1774639 */   GIM_Try, /*On fail goto*//*Label 24156*/ GIMT_Encode4(1774725), // Rule ID 11787 //
     /* 1774644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1774655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1774658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1774661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774690 */     // MIs[0] policy
     /* 1774690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1774703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774724 */     // GIR_Coverage, 11787,
     /* 1774724 */     GIR_EraseRootFromParent_Done,
     /* 1774725 */   // Label 24156: @1774725
     /* 1774725 */   GIM_Try, /*On fail goto*//*Label 24157*/ GIMT_Encode4(1774811), // Rule ID 11790 //
     /* 1774730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1774741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1774744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1774747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774776 */     // MIs[0] policy
     /* 1774776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774786 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1774789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774810 */     // GIR_Coverage, 11790,
     /* 1774810 */     GIR_EraseRootFromParent_Done,
     /* 1774811 */   // Label 24157: @1774811
     /* 1774811 */   GIM_Try, /*On fail goto*//*Label 24158*/ GIMT_Encode4(1774897), // Rule ID 11791 //
     /* 1774816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1774827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1774830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1774833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774862 */     // MIs[0] policy
     /* 1774862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774872 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1774875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774896 */     // GIR_Coverage, 11791,
     /* 1774896 */     GIR_EraseRootFromParent_Done,
     /* 1774897 */   // Label 24158: @1774897
     /* 1774897 */   GIM_Try, /*On fail goto*//*Label 24159*/ GIMT_Encode4(1774983), // Rule ID 11794 //
     /* 1774902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1774905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1774913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1774916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1774919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774948 */     // MIs[0] policy
     /* 1774948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774958 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1774961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774982 */     // GIR_Coverage, 11794,
     /* 1774982 */     GIR_EraseRootFromParent_Done,
     /* 1774983 */   // Label 24159: @1774983
     /* 1774983 */   GIM_Try, /*On fail goto*//*Label 24160*/ GIMT_Encode4(1775069), // Rule ID 11795 //
     /* 1774988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1774991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1774999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1775002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1775005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775034 */     // MIs[0] policy
     /* 1775034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775044 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1775047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1775065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775068 */     // GIR_Coverage, 11795,
     /* 1775068 */     GIR_EraseRootFromParent_Done,
     /* 1775069 */   // Label 24160: @1775069
     /* 1775069 */   GIM_Try, /*On fail goto*//*Label 24161*/ GIMT_Encode4(1775155), // Rule ID 11798 //
     /* 1775074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1775085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1775088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1775091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775120 */     // MIs[0] policy
     /* 1775120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775130 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1775133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775154 */     // GIR_Coverage, 11798,
     /* 1775154 */     GIR_EraseRootFromParent_Done,
     /* 1775155 */   // Label 24161: @1775155
     /* 1775155 */   GIM_Try, /*On fail goto*//*Label 24162*/ GIMT_Encode4(1775241), // Rule ID 11799 //
     /* 1775160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1775171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1775174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1775177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775206 */     // MIs[0] policy
     /* 1775206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775216 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1775219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775240 */     // GIR_Coverage, 11799,
     /* 1775240 */     GIR_EraseRootFromParent_Done,
     /* 1775241 */   // Label 24162: @1775241
     /* 1775241 */   GIM_Try, /*On fail goto*//*Label 24163*/ GIMT_Encode4(1775327), // Rule ID 11802 //
     /* 1775246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1775257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1775260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1775263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1775269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775292 */     // MIs[0] policy
     /* 1775292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775302 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1775305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775326 */     // GIR_Coverage, 11802,
     /* 1775326 */     GIR_EraseRootFromParent_Done,
     /* 1775327 */   // Label 24163: @1775327
     /* 1775327 */   GIM_Try, /*On fail goto*//*Label 24164*/ GIMT_Encode4(1775413), // Rule ID 11803 //
     /* 1775332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1775343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1775346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1775349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1775355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775378 */     // MIs[0] policy
     /* 1775378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775388 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1775391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775412 */     // GIR_Coverage, 11803,
     /* 1775412 */     GIR_EraseRootFromParent_Done,
     /* 1775413 */   // Label 24164: @1775413
     /* 1775413 */   GIM_Try, /*On fail goto*//*Label 24165*/ GIMT_Encode4(1775499), // Rule ID 11806 //
     /* 1775418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1775429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1775432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1775435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1775441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1775448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775464 */     // MIs[0] policy
     /* 1775464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775474 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1775477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775498 */     // GIR_Coverage, 11806,
     /* 1775498 */     GIR_EraseRootFromParent_Done,
     /* 1775499 */   // Label 24165: @1775499
     /* 1775499 */   GIM_Try, /*On fail goto*//*Label 24166*/ GIMT_Encode4(1775585), // Rule ID 11807 //
     /* 1775504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1775515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1775518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1775521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1775527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1775534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775550 */     // MIs[0] policy
     /* 1775550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775560 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1775563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775584 */     // GIR_Coverage, 11807,
     /* 1775584 */     GIR_EraseRootFromParent_Done,
     /* 1775585 */   // Label 24166: @1775585
     /* 1775585 */   GIM_Try, /*On fail goto*//*Label 24167*/ GIMT_Encode4(1775671), // Rule ID 11810 //
     /* 1775590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1775601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1775604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1775607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1775613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775636 */     // MIs[0] policy
     /* 1775636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1775649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775670 */     // GIR_Coverage, 11810,
     /* 1775670 */     GIR_EraseRootFromParent_Done,
     /* 1775671 */   // Label 24167: @1775671
     /* 1775671 */   GIM_Try, /*On fail goto*//*Label 24168*/ GIMT_Encode4(1775757), // Rule ID 11811 //
     /* 1775676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1775687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1775690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1775693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1775699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775722 */     // MIs[0] policy
     /* 1775722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1775735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775756 */     // GIR_Coverage, 11811,
     /* 1775756 */     GIR_EraseRootFromParent_Done,
     /* 1775757 */   // Label 24168: @1775757
     /* 1775757 */   GIM_Try, /*On fail goto*//*Label 24169*/ GIMT_Encode4(1775843), // Rule ID 11814 //
     /* 1775762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1775773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1775776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1775779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775808 */     // MIs[0] policy
     /* 1775808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775818 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1775821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775842 */     // GIR_Coverage, 11814,
     /* 1775842 */     GIR_EraseRootFromParent_Done,
     /* 1775843 */   // Label 24169: @1775843
     /* 1775843 */   GIM_Try, /*On fail goto*//*Label 24170*/ GIMT_Encode4(1775929), // Rule ID 11815 //
     /* 1775848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1775859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1775862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1775865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775894 */     // MIs[0] policy
     /* 1775894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775904 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1775907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775928 */     // GIR_Coverage, 11815,
     /* 1775928 */     GIR_EraseRootFromParent_Done,
     /* 1775929 */   // Label 24170: @1775929
     /* 1775929 */   GIM_Try, /*On fail goto*//*Label 24171*/ GIMT_Encode4(1776015), // Rule ID 11818 //
     /* 1775934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1775945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1775948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1775951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1775957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1775964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775980 */     // MIs[0] policy
     /* 1775980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775990 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1775993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776014 */     // GIR_Coverage, 11818,
     /* 1776014 */     GIR_EraseRootFromParent_Done,
     /* 1776015 */   // Label 24171: @1776015
     /* 1776015 */   GIM_Try, /*On fail goto*//*Label 24172*/ GIMT_Encode4(1776101), // Rule ID 11819 //
     /* 1776020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1776031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1776034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1776037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776066 */     // MIs[0] policy
     /* 1776066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776076 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1776079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776100 */     // GIR_Coverage, 11819,
     /* 1776100 */     GIR_EraseRootFromParent_Done,
     /* 1776101 */   // Label 24172: @1776101
     /* 1776101 */   GIM_Try, /*On fail goto*//*Label 24173*/ GIMT_Encode4(1776187), // Rule ID 11822 //
     /* 1776106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1776117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1776120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1776123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776152 */     // MIs[0] policy
     /* 1776152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1776165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776186 */     // GIR_Coverage, 11822,
     /* 1776186 */     GIR_EraseRootFromParent_Done,
     /* 1776187 */   // Label 24173: @1776187
     /* 1776187 */   GIM_Try, /*On fail goto*//*Label 24174*/ GIMT_Encode4(1776273), // Rule ID 11823 //
     /* 1776192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1776203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1776206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1776209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776238 */     // MIs[0] policy
     /* 1776238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1776251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776272 */     // GIR_Coverage, 11823,
     /* 1776272 */     GIR_EraseRootFromParent_Done,
     /* 1776273 */   // Label 24174: @1776273
     /* 1776273 */   GIM_Try, /*On fail goto*//*Label 24175*/ GIMT_Encode4(1776359), // Rule ID 11826 //
     /* 1776278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1776289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1776292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1776295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776324 */     // MIs[0] policy
     /* 1776324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1776337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776358 */     // GIR_Coverage, 11826,
     /* 1776358 */     GIR_EraseRootFromParent_Done,
     /* 1776359 */   // Label 24175: @1776359
     /* 1776359 */   GIM_Try, /*On fail goto*//*Label 24176*/ GIMT_Encode4(1776445), // Rule ID 11827 //
     /* 1776364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1776375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1776378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1776381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776410 */     // MIs[0] policy
     /* 1776410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776420 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1776423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776444 */     // GIR_Coverage, 11827,
     /* 1776444 */     GIR_EraseRootFromParent_Done,
     /* 1776445 */   // Label 24176: @1776445
     /* 1776445 */   GIM_Try, /*On fail goto*//*Label 24177*/ GIMT_Encode4(1776531), // Rule ID 11830 //
     /* 1776450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1776461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1776464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1776467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776496 */     // MIs[0] policy
     /* 1776496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776506 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1776509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776530 */     // GIR_Coverage, 11830,
     /* 1776530 */     GIR_EraseRootFromParent_Done,
     /* 1776531 */   // Label 24177: @1776531
     /* 1776531 */   GIM_Try, /*On fail goto*//*Label 24178*/ GIMT_Encode4(1776617), // Rule ID 11831 //
     /* 1776536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1776547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1776550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1776553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776582 */     // MIs[0] policy
     /* 1776582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776592 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1776595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776616 */     // GIR_Coverage, 11831,
     /* 1776616 */     GIR_EraseRootFromParent_Done,
     /* 1776617 */   // Label 24178: @1776617
     /* 1776617 */   GIM_Try, /*On fail goto*//*Label 24179*/ GIMT_Encode4(1776703), // Rule ID 11834 //
     /* 1776622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1776625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1776633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1776636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1776639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1776645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776668 */     // MIs[0] policy
     /* 1776668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1776681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776702 */     // GIR_Coverage, 11834,
     /* 1776702 */     GIR_EraseRootFromParent_Done,
     /* 1776703 */   // Label 24179: @1776703
     /* 1776703 */   GIM_Try, /*On fail goto*//*Label 24180*/ GIMT_Encode4(1776789), // Rule ID 11835 //
     /* 1776708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1776711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1776719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1776722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1776725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1776731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776754 */     // MIs[0] policy
     /* 1776754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1776767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776788 */     // GIR_Coverage, 11835,
     /* 1776788 */     GIR_EraseRootFromParent_Done,
     /* 1776789 */   // Label 24180: @1776789
     /* 1776789 */   GIM_Try, /*On fail goto*//*Label 24181*/ GIMT_Encode4(1776875), // Rule ID 11838 //
     /* 1776794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1776797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1776805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1776808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1776811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776840 */     // MIs[0] policy
     /* 1776840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776850 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1776853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776874 */     // GIR_Coverage, 11838,
     /* 1776874 */     GIR_EraseRootFromParent_Done,
     /* 1776875 */   // Label 24181: @1776875
     /* 1776875 */   GIM_Try, /*On fail goto*//*Label 24182*/ GIMT_Encode4(1776961), // Rule ID 11839 //
     /* 1776880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1776883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1776891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1776894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1776897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776926 */     // MIs[0] policy
     /* 1776926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776936 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1776939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776960 */     // GIR_Coverage, 11839,
     /* 1776960 */     GIR_EraseRootFromParent_Done,
     /* 1776961 */   // Label 24182: @1776961
     /* 1776961 */   GIM_Try, /*On fail goto*//*Label 24183*/ GIMT_Encode4(1777047), // Rule ID 11842 //
     /* 1776966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1776969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1776977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1776980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1776983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777012 */     // MIs[0] policy
     /* 1777012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777022 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1777025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777046 */     // GIR_Coverage, 11842,
     /* 1777046 */     GIR_EraseRootFromParent_Done,
     /* 1777047 */   // Label 24183: @1777047
     /* 1777047 */   GIM_Try, /*On fail goto*//*Label 24184*/ GIMT_Encode4(1777133), // Rule ID 11843 //
     /* 1777052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1777055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1777063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1777066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1777069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777098 */     // MIs[0] policy
     /* 1777098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777108 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1777111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777132 */     // GIR_Coverage, 11843,
     /* 1777132 */     GIR_EraseRootFromParent_Done,
     /* 1777133 */   // Label 24184: @1777133
     /* 1777133 */   GIM_Try, /*On fail goto*//*Label 24185*/ GIMT_Encode4(1777219), // Rule ID 11846 //
     /* 1777138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1777149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1777152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1777155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1777158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777184 */     // MIs[0] policy
     /* 1777184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777194 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1777197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777218 */     // GIR_Coverage, 11846,
     /* 1777218 */     GIR_EraseRootFromParent_Done,
     /* 1777219 */   // Label 24185: @1777219
     /* 1777219 */   GIM_Try, /*On fail goto*//*Label 24186*/ GIMT_Encode4(1777305), // Rule ID 11847 //
     /* 1777224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1777235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1777238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1777241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1777244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777270 */     // MIs[0] policy
     /* 1777270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777280 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1777283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777304 */     // GIR_Coverage, 11847,
     /* 1777304 */     GIR_EraseRootFromParent_Done,
     /* 1777305 */   // Label 24186: @1777305
     /* 1777305 */   GIM_Try, /*On fail goto*//*Label 24187*/ GIMT_Encode4(1777391), // Rule ID 11850 //
     /* 1777310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1777321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1777324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1777327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1777330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777356 */     // MIs[0] policy
     /* 1777356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777366 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1777369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777390 */     // GIR_Coverage, 11850,
     /* 1777390 */     GIR_EraseRootFromParent_Done,
     /* 1777391 */   // Label 24187: @1777391
     /* 1777391 */   GIM_Try, /*On fail goto*//*Label 24188*/ GIMT_Encode4(1777477), // Rule ID 11851 //
     /* 1777396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1777407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1777410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1777413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1777416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777442 */     // MIs[0] policy
     /* 1777442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777452 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1777455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777476 */     // GIR_Coverage, 11851,
     /* 1777476 */     GIR_EraseRootFromParent_Done,
     /* 1777477 */   // Label 24188: @1777477
     /* 1777477 */   GIM_Try, /*On fail goto*//*Label 24189*/ GIMT_Encode4(1777563), // Rule ID 11854 //
     /* 1777482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1777493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1777496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1777499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1777502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777528 */     // MIs[0] policy
     /* 1777528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777538 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1777541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777562 */     // GIR_Coverage, 11854,
     /* 1777562 */     GIR_EraseRootFromParent_Done,
     /* 1777563 */   // Label 24189: @1777563
     /* 1777563 */   GIM_Try, /*On fail goto*//*Label 24190*/ GIMT_Encode4(1777649), // Rule ID 11855 //
     /* 1777568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1777579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1777582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1777585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1777588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777614 */     // MIs[0] policy
     /* 1777614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777624 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1777627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777648 */     // GIR_Coverage, 11855,
     /* 1777648 */     GIR_EraseRootFromParent_Done,
     /* 1777649 */   // Label 24190: @1777649
     /* 1777649 */   GIM_Try, /*On fail goto*//*Label 24191*/ GIMT_Encode4(1777735), // Rule ID 11858 //
     /* 1777654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1777665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1777668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1777671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1777674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777700 */     // MIs[0] policy
     /* 1777700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777710 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1777713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777734 */     // GIR_Coverage, 11858,
     /* 1777734 */     GIR_EraseRootFromParent_Done,
     /* 1777735 */   // Label 24191: @1777735
     /* 1777735 */   GIM_Try, /*On fail goto*//*Label 24192*/ GIMT_Encode4(1777821), // Rule ID 11859 //
     /* 1777740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1777751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1777754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1777757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1777760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777786 */     // MIs[0] policy
     /* 1777786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777796 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1777799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777820 */     // GIR_Coverage, 11859,
     /* 1777820 */     GIR_EraseRootFromParent_Done,
     /* 1777821 */   // Label 24192: @1777821
     /* 1777821 */   GIM_Try, /*On fail goto*//*Label 24193*/ GIMT_Encode4(1777907), // Rule ID 11862 //
     /* 1777826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1777837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1777840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1777843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1777846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777872 */     // MIs[0] policy
     /* 1777872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777882 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1777885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777906 */     // GIR_Coverage, 11862,
     /* 1777906 */     GIR_EraseRootFromParent_Done,
     /* 1777907 */   // Label 24193: @1777907
     /* 1777907 */   GIM_Try, /*On fail goto*//*Label 24194*/ GIMT_Encode4(1777993), // Rule ID 11863 //
     /* 1777912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1777923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1777926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1777929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1777932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777958 */     // MIs[0] policy
     /* 1777958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777968 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1777971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777992 */     // GIR_Coverage, 11863,
     /* 1777992 */     GIR_EraseRootFromParent_Done,
     /* 1777993 */   // Label 24194: @1777993
     /* 1777993 */   GIM_Try, /*On fail goto*//*Label 24195*/ GIMT_Encode4(1778079), // Rule ID 11866 //
     /* 1777998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1778009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1778012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1778015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1778018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778044 */     // MIs[0] policy
     /* 1778044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1778057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778078 */     // GIR_Coverage, 11866,
     /* 1778078 */     GIR_EraseRootFromParent_Done,
     /* 1778079 */   // Label 24195: @1778079
     /* 1778079 */   GIM_Try, /*On fail goto*//*Label 24196*/ GIMT_Encode4(1778165), // Rule ID 11867 //
     /* 1778084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1778095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1778098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1778101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1778104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778130 */     // MIs[0] policy
     /* 1778130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778140 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1778143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778164 */     // GIR_Coverage, 11867,
     /* 1778164 */     GIR_EraseRootFromParent_Done,
     /* 1778165 */   // Label 24196: @1778165
     /* 1778165 */   GIM_Try, /*On fail goto*//*Label 24197*/ GIMT_Encode4(1778251), // Rule ID 11870 //
     /* 1778170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1778181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1778184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1778187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1778190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778216 */     // MIs[0] policy
     /* 1778216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1778229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778250 */     // GIR_Coverage, 11870,
     /* 1778250 */     GIR_EraseRootFromParent_Done,
     /* 1778251 */   // Label 24197: @1778251
     /* 1778251 */   GIM_Try, /*On fail goto*//*Label 24198*/ GIMT_Encode4(1778337), // Rule ID 11871 //
     /* 1778256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1778267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1778270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1778273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1778276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778302 */     // MIs[0] policy
     /* 1778302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778312 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1778315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778336 */     // GIR_Coverage, 11871,
     /* 1778336 */     GIR_EraseRootFromParent_Done,
     /* 1778337 */   // Label 24198: @1778337
     /* 1778337 */   GIM_Try, /*On fail goto*//*Label 24199*/ GIMT_Encode4(1778423), // Rule ID 11874 //
     /* 1778342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1778353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1778356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1778359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1778362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778388 */     // MIs[0] policy
     /* 1778388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1778401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778422 */     // GIR_Coverage, 11874,
     /* 1778422 */     GIR_EraseRootFromParent_Done,
     /* 1778423 */   // Label 24199: @1778423
     /* 1778423 */   GIM_Try, /*On fail goto*//*Label 24200*/ GIMT_Encode4(1778509), // Rule ID 11875 //
     /* 1778428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1778439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1778442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1778445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1778448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778474 */     // MIs[0] policy
     /* 1778474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1778487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778508 */     // GIR_Coverage, 11875,
     /* 1778508 */     GIR_EraseRootFromParent_Done,
     /* 1778509 */   // Label 24200: @1778509
     /* 1778509 */   GIM_Try, /*On fail goto*//*Label 24201*/ GIMT_Encode4(1778595), // Rule ID 11878 //
     /* 1778514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1778525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1778528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1778531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1778534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778560 */     // MIs[0] policy
     /* 1778560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1778573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778594 */     // GIR_Coverage, 11878,
     /* 1778594 */     GIR_EraseRootFromParent_Done,
     /* 1778595 */   // Label 24201: @1778595
     /* 1778595 */   GIM_Try, /*On fail goto*//*Label 24202*/ GIMT_Encode4(1778681), // Rule ID 11879 //
     /* 1778600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1778611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1778614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1778617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1778620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778646 */     // MIs[0] policy
     /* 1778646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1778659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778680 */     // GIR_Coverage, 11879,
     /* 1778680 */     GIR_EraseRootFromParent_Done,
     /* 1778681 */   // Label 24202: @1778681
     /* 1778681 */   GIM_Try, /*On fail goto*//*Label 24203*/ GIMT_Encode4(1778767), // Rule ID 11882 //
     /* 1778686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1778689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1778697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1778700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1778703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1778706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778732 */     // MIs[0] policy
     /* 1778732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778742 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1778745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778766 */     // GIR_Coverage, 11882,
     /* 1778766 */     GIR_EraseRootFromParent_Done,
     /* 1778767 */   // Label 24203: @1778767
     /* 1778767 */   GIM_Try, /*On fail goto*//*Label 24204*/ GIMT_Encode4(1778853), // Rule ID 11883 //
     /* 1778772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1778775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1778783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1778786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1778789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1778792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778818 */     // MIs[0] policy
     /* 1778818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778828 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1778831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778852 */     // GIR_Coverage, 11883,
     /* 1778852 */     GIR_EraseRootFromParent_Done,
     /* 1778853 */   // Label 24204: @1778853
     /* 1778853 */   GIM_Try, /*On fail goto*//*Label 24205*/ GIMT_Encode4(1778939), // Rule ID 11886 //
     /* 1778858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1778869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1778872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1778875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1778878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1778881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1778888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778904 */     // MIs[0] policy
     /* 1778904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778914 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1778917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778938 */     // GIR_Coverage, 11886,
     /* 1778938 */     GIR_EraseRootFromParent_Done,
     /* 1778939 */   // Label 24205: @1778939
     /* 1778939 */   GIM_Try, /*On fail goto*//*Label 24206*/ GIMT_Encode4(1779025), // Rule ID 11887 //
     /* 1778944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1778955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1778958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1778961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1778964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1778967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1778974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778990 */     // MIs[0] policy
     /* 1778990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779000 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1779003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779024 */     // GIR_Coverage, 11887,
     /* 1779024 */     GIR_EraseRootFromParent_Done,
     /* 1779025 */   // Label 24206: @1779025
     /* 1779025 */   GIM_Try, /*On fail goto*//*Label 24207*/ GIMT_Encode4(1779111), // Rule ID 11890 //
     /* 1779030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1779041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1779044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1779047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1779050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779076 */     // MIs[0] policy
     /* 1779076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779086 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1779089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779110 */     // GIR_Coverage, 11890,
     /* 1779110 */     GIR_EraseRootFromParent_Done,
     /* 1779111 */   // Label 24207: @1779111
     /* 1779111 */   GIM_Try, /*On fail goto*//*Label 24208*/ GIMT_Encode4(1779197), // Rule ID 11891 //
     /* 1779116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1779127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1779130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1779133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1779136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779162 */     // MIs[0] policy
     /* 1779162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779172 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1779175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779196 */     // GIR_Coverage, 11891,
     /* 1779196 */     GIR_EraseRootFromParent_Done,
     /* 1779197 */   // Label 24208: @1779197
     /* 1779197 */   GIM_Try, /*On fail goto*//*Label 24209*/ GIMT_Encode4(1779283), // Rule ID 11894 //
     /* 1779202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1779213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1779216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1779219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1779222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1779225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779248 */     // MIs[0] policy
     /* 1779248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779258 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1779261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779282 */     // GIR_Coverage, 11894,
     /* 1779282 */     GIR_EraseRootFromParent_Done,
     /* 1779283 */   // Label 24209: @1779283
     /* 1779283 */   GIM_Try, /*On fail goto*//*Label 24210*/ GIMT_Encode4(1779369), // Rule ID 11895 //
     /* 1779288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1779299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1779302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1779305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1779308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1779311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779334 */     // MIs[0] policy
     /* 1779334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779344 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1779347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779368 */     // GIR_Coverage, 11895,
     /* 1779368 */     GIR_EraseRootFromParent_Done,
     /* 1779369 */   // Label 24210: @1779369
     /* 1779369 */   GIM_Try, /*On fail goto*//*Label 24211*/ GIMT_Encode4(1779455), // Rule ID 11898 //
     /* 1779374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1779385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1779388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1779391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1779394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779420 */     // MIs[0] policy
     /* 1779420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779430 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1779433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779454 */     // GIR_Coverage, 11898,
     /* 1779454 */     GIR_EraseRootFromParent_Done,
     /* 1779455 */   // Label 24211: @1779455
     /* 1779455 */   GIM_Try, /*On fail goto*//*Label 24212*/ GIMT_Encode4(1779541), // Rule ID 11899 //
     /* 1779460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1779471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1779474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1779477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1779480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779506 */     // MIs[0] policy
     /* 1779506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1779519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779540 */     // GIR_Coverage, 11899,
     /* 1779540 */     GIR_EraseRootFromParent_Done,
     /* 1779541 */   // Label 24212: @1779541
     /* 1779541 */   GIM_Try, /*On fail goto*//*Label 24213*/ GIMT_Encode4(1779627), // Rule ID 11902 //
     /* 1779546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1779557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1779560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1779563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1779566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1779569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779592 */     // MIs[0] policy
     /* 1779592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779602 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1779605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779626 */     // GIR_Coverage, 11902,
     /* 1779626 */     GIR_EraseRootFromParent_Done,
     /* 1779627 */   // Label 24213: @1779627
     /* 1779627 */   GIM_Try, /*On fail goto*//*Label 24214*/ GIMT_Encode4(1779713), // Rule ID 11903 //
     /* 1779632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1779643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1779646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1779649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1779652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1779655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779678 */     // MIs[0] policy
     /* 1779678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779688 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1779691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779712 */     // GIR_Coverage, 11903,
     /* 1779712 */     GIR_EraseRootFromParent_Done,
     /* 1779713 */   // Label 24214: @1779713
     /* 1779713 */   GIM_Try, /*On fail goto*//*Label 24215*/ GIMT_Encode4(1779799), // Rule ID 11906 //
     /* 1779718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1779729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1779732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1779735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1779738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779764 */     // MIs[0] policy
     /* 1779764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779774 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1779777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779798 */     // GIR_Coverage, 11906,
     /* 1779798 */     GIR_EraseRootFromParent_Done,
     /* 1779799 */   // Label 24215: @1779799
     /* 1779799 */   GIM_Try, /*On fail goto*//*Label 24216*/ GIMT_Encode4(1779885), // Rule ID 11907 //
     /* 1779804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1779815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1779818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1779821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1779824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779850 */     // MIs[0] policy
     /* 1779850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779860 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1779863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779884 */     // GIR_Coverage, 11907,
     /* 1779884 */     GIR_EraseRootFromParent_Done,
     /* 1779885 */   // Label 24216: @1779885
     /* 1779885 */   GIM_Try, /*On fail goto*//*Label 24217*/ GIMT_Encode4(1779971), // Rule ID 11910 //
     /* 1779890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1779901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1779904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1779907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1779910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779936 */     // MIs[0] policy
     /* 1779936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1779949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779970 */     // GIR_Coverage, 11910,
     /* 1779970 */     GIR_EraseRootFromParent_Done,
     /* 1779971 */   // Label 24217: @1779971
     /* 1779971 */   GIM_Try, /*On fail goto*//*Label 24218*/ GIMT_Encode4(1780057), // Rule ID 11911 //
     /* 1779976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1779987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1779990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1779993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1779996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780022 */     // MIs[0] policy
     /* 1780022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1780035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780056 */     // GIR_Coverage, 11911,
     /* 1780056 */     GIR_EraseRootFromParent_Done,
     /* 1780057 */   // Label 24218: @1780057
     /* 1780057 */   GIM_Try, /*On fail goto*//*Label 24219*/ GIMT_Encode4(1780143), // Rule ID 11914 //
     /* 1780062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1780073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1780076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1780079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1780082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780108 */     // MIs[0] policy
     /* 1780108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1780121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780142 */     // GIR_Coverage, 11914,
     /* 1780142 */     GIR_EraseRootFromParent_Done,
     /* 1780143 */   // Label 24219: @1780143
     /* 1780143 */   GIM_Try, /*On fail goto*//*Label 24220*/ GIMT_Encode4(1780229), // Rule ID 11915 //
     /* 1780148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1780159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1780162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1780165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1780168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780194 */     // MIs[0] policy
     /* 1780194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780204 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1780207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780228 */     // GIR_Coverage, 11915,
     /* 1780228 */     GIR_EraseRootFromParent_Done,
     /* 1780229 */   // Label 24220: @1780229
     /* 1780229 */   GIM_Try, /*On fail goto*//*Label 24221*/ GIMT_Encode4(1780315), // Rule ID 11918 //
     /* 1780234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1780245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1780248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1780251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1780254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780280 */     // MIs[0] policy
     /* 1780280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780290 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1780293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780314 */     // GIR_Coverage, 11918,
     /* 1780314 */     GIR_EraseRootFromParent_Done,
     /* 1780315 */   // Label 24221: @1780315
     /* 1780315 */   GIM_Try, /*On fail goto*//*Label 24222*/ GIMT_Encode4(1780401), // Rule ID 11919 //
     /* 1780320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1780331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1780334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1780337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1780340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780366 */     // MIs[0] policy
     /* 1780366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780376 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1780379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780400 */     // GIR_Coverage, 11919,
     /* 1780400 */     GIR_EraseRootFromParent_Done,
     /* 1780401 */   // Label 24222: @1780401
     /* 1780401 */   GIM_Try, /*On fail goto*//*Label 24223*/ GIMT_Encode4(1780487), // Rule ID 11922 //
     /* 1780406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1780409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1780417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1780420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1780423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1780426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780452 */     // MIs[0] policy
     /* 1780452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780462 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1780465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780486 */     // GIR_Coverage, 11922,
     /* 1780486 */     GIR_EraseRootFromParent_Done,
     /* 1780487 */   // Label 24223: @1780487
     /* 1780487 */   GIM_Try, /*On fail goto*//*Label 24224*/ GIMT_Encode4(1780573), // Rule ID 11923 //
     /* 1780492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1780495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1780503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1780506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1780509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1780512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780538 */     // MIs[0] policy
     /* 1780538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780548 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1780551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780572 */     // GIR_Coverage, 11923,
     /* 1780572 */     GIR_EraseRootFromParent_Done,
     /* 1780573 */   // Label 24224: @1780573
     /* 1780573 */   GIM_Try, /*On fail goto*//*Label 24225*/ GIMT_Encode4(1780659), // Rule ID 11926 //
     /* 1780578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1780581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1780589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1780592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1780595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1780598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780624 */     // MIs[0] policy
     /* 1780624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1780637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780658 */     // GIR_Coverage, 11926,
     /* 1780658 */     GIR_EraseRootFromParent_Done,
     /* 1780659 */   // Label 24225: @1780659
     /* 1780659 */   GIM_Try, /*On fail goto*//*Label 24226*/ GIMT_Encode4(1780745), // Rule ID 11927 //
     /* 1780664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1780667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1780675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1780678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1780681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1780684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780710 */     // MIs[0] policy
     /* 1780710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1780723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780744 */     // GIR_Coverage, 11927,
     /* 1780744 */     GIR_EraseRootFromParent_Done,
     /* 1780745 */   // Label 24226: @1780745
     /* 1780745 */   GIM_Try, /*On fail goto*//*Label 24227*/ GIMT_Encode4(1780831), // Rule ID 11930 //
     /* 1780750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1780753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1780761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1780764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1780767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1780770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780796 */     // MIs[0] policy
     /* 1780796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1780809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780830 */     // GIR_Coverage, 11930,
     /* 1780830 */     GIR_EraseRootFromParent_Done,
     /* 1780831 */   // Label 24227: @1780831
     /* 1780831 */   GIM_Try, /*On fail goto*//*Label 24228*/ GIMT_Encode4(1780917), // Rule ID 11931 //
     /* 1780836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1780839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1780847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1780850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1780853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1780856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780882 */     // MIs[0] policy
     /* 1780882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780892 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1780895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780916 */     // GIR_Coverage, 11931,
     /* 1780916 */     GIR_EraseRootFromParent_Done,
     /* 1780917 */   // Label 24228: @1780917
     /* 1780917 */   GIM_Try, /*On fail goto*//*Label 24229*/ GIMT_Encode4(1781003), // Rule ID 11934 //
     /* 1780922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1780933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1780936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1780939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1780942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1780945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1780952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780968 */     // MIs[0] policy
     /* 1780968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780978 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1780981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781002 */     // GIR_Coverage, 11934,
     /* 1781002 */     GIR_EraseRootFromParent_Done,
     /* 1781003 */   // Label 24229: @1781003
     /* 1781003 */   GIM_Try, /*On fail goto*//*Label 24230*/ GIMT_Encode4(1781089), // Rule ID 11935 //
     /* 1781008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1781019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1781022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1781025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781054 */     // MIs[0] policy
     /* 1781054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781064 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1781067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781088 */     // GIR_Coverage, 11935,
     /* 1781088 */     GIR_EraseRootFromParent_Done,
     /* 1781089 */   // Label 24230: @1781089
     /* 1781089 */   GIM_Try, /*On fail goto*//*Label 24231*/ GIMT_Encode4(1781175), // Rule ID 11938 //
     /* 1781094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1781105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1781108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1781111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781140 */     // MIs[0] policy
     /* 1781140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781150 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1781153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781174 */     // GIR_Coverage, 11938,
     /* 1781174 */     GIR_EraseRootFromParent_Done,
     /* 1781175 */   // Label 24231: @1781175
     /* 1781175 */   GIM_Try, /*On fail goto*//*Label 24232*/ GIMT_Encode4(1781261), // Rule ID 11939 //
     /* 1781180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1781191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1781194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1781197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781226 */     // MIs[0] policy
     /* 1781226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781236 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1781239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781260 */     // GIR_Coverage, 11939,
     /* 1781260 */     GIR_EraseRootFromParent_Done,
     /* 1781261 */   // Label 24232: @1781261
     /* 1781261 */   GIM_Try, /*On fail goto*//*Label 24233*/ GIMT_Encode4(1781347), // Rule ID 11942 //
     /* 1781266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1781277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1781280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1781283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781312 */     // MIs[0] policy
     /* 1781312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781322 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1781325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781346 */     // GIR_Coverage, 11942,
     /* 1781346 */     GIR_EraseRootFromParent_Done,
     /* 1781347 */   // Label 24233: @1781347
     /* 1781347 */   GIM_Try, /*On fail goto*//*Label 24234*/ GIMT_Encode4(1781433), // Rule ID 11943 //
     /* 1781352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1781363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1781366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1781369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781398 */     // MIs[0] policy
     /* 1781398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781408 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1781411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781432 */     // GIR_Coverage, 11943,
     /* 1781432 */     GIR_EraseRootFromParent_Done,
     /* 1781433 */   // Label 24234: @1781433
     /* 1781433 */   GIM_Try, /*On fail goto*//*Label 24235*/ GIMT_Encode4(1781519), // Rule ID 11946 //
     /* 1781438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1781449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1781452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1781455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781484 */     // MIs[0] policy
     /* 1781484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1781497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781518 */     // GIR_Coverage, 11946,
     /* 1781518 */     GIR_EraseRootFromParent_Done,
     /* 1781519 */   // Label 24235: @1781519
     /* 1781519 */   GIM_Try, /*On fail goto*//*Label 24236*/ GIMT_Encode4(1781605), // Rule ID 11947 //
     /* 1781524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1781535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1781538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1781541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781570 */     // MIs[0] policy
     /* 1781570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781580 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1781583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781604 */     // GIR_Coverage, 11947,
     /* 1781604 */     GIR_EraseRootFromParent_Done,
     /* 1781605 */   // Label 24236: @1781605
     /* 1781605 */   GIM_Try, /*On fail goto*//*Label 24237*/ GIMT_Encode4(1781691), // Rule ID 11950 //
     /* 1781610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1781621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1781624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1781627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781656 */     // MIs[0] policy
     /* 1781656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781666 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1781669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781690 */     // GIR_Coverage, 11950,
     /* 1781690 */     GIR_EraseRootFromParent_Done,
     /* 1781691 */   // Label 24237: @1781691
     /* 1781691 */   GIM_Try, /*On fail goto*//*Label 24238*/ GIMT_Encode4(1781777), // Rule ID 11951 //
     /* 1781696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1781707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1781710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1781713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781742 */     // MIs[0] policy
     /* 1781742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781752 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1781755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781776 */     // GIR_Coverage, 11951,
     /* 1781776 */     GIR_EraseRootFromParent_Done,
     /* 1781777 */   // Label 24238: @1781777
     /* 1781777 */   GIM_Try, /*On fail goto*//*Label 24239*/ GIMT_Encode4(1781863), // Rule ID 11954 //
     /* 1781782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1781793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1781796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1781799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781828 */     // MIs[0] policy
     /* 1781828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781838 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1781841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781862 */     // GIR_Coverage, 11954,
     /* 1781862 */     GIR_EraseRootFromParent_Done,
     /* 1781863 */   // Label 24239: @1781863
     /* 1781863 */   GIM_Try, /*On fail goto*//*Label 24240*/ GIMT_Encode4(1781949), // Rule ID 11955 //
     /* 1781868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1781879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1781882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1781885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781914 */     // MIs[0] policy
     /* 1781914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1781927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781948 */     // GIR_Coverage, 11955,
     /* 1781948 */     GIR_EraseRootFromParent_Done,
     /* 1781949 */   // Label 24240: @1781949
     /* 1781949 */   GIM_Try, /*On fail goto*//*Label 24241*/ GIMT_Encode4(1782035), // Rule ID 11958 //
     /* 1781954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1781965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1781968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1781971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782000 */     // MIs[0] policy
     /* 1782000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782010 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1782013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782034 */     // GIR_Coverage, 11958,
     /* 1782034 */     GIR_EraseRootFromParent_Done,
     /* 1782035 */   // Label 24241: @1782035
     /* 1782035 */   GIM_Try, /*On fail goto*//*Label 24242*/ GIMT_Encode4(1782121), // Rule ID 11959 //
     /* 1782040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1782051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1782054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1782057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1782063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782086 */     // MIs[0] policy
     /* 1782086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1782099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782120 */     // GIR_Coverage, 11959,
     /* 1782120 */     GIR_EraseRootFromParent_Done,
     /* 1782121 */   // Label 24242: @1782121
     /* 1782121 */   GIM_Try, /*On fail goto*//*Label 24243*/ GIMT_Encode4(1782207), // Rule ID 11962 //
     /* 1782126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1782137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1782140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1782143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782172 */     // MIs[0] policy
     /* 1782172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1782185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782206 */     // GIR_Coverage, 11962,
     /* 1782206 */     GIR_EraseRootFromParent_Done,
     /* 1782207 */   // Label 24243: @1782207
     /* 1782207 */   GIM_Try, /*On fail goto*//*Label 24244*/ GIMT_Encode4(1782293), // Rule ID 11963 //
     /* 1782212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1782223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1782226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1782229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782258 */     // MIs[0] policy
     /* 1782258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1782271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782292 */     // GIR_Coverage, 11963,
     /* 1782292 */     GIR_EraseRootFromParent_Done,
     /* 1782293 */   // Label 24244: @1782293
     /* 1782293 */   GIM_Try, /*On fail goto*//*Label 24245*/ GIMT_Encode4(1782379), // Rule ID 11966 //
     /* 1782298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1782309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1782312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1782315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782344 */     // MIs[0] policy
     /* 1782344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1782357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782378 */     // GIR_Coverage, 11966,
     /* 1782378 */     GIR_EraseRootFromParent_Done,
     /* 1782379 */   // Label 24245: @1782379
     /* 1782379 */   GIM_Try, /*On fail goto*//*Label 24246*/ GIMT_Encode4(1782465), // Rule ID 11967 //
     /* 1782384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1782395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1782398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1782401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782430 */     // MIs[0] policy
     /* 1782430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1782443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782464 */     // GIR_Coverage, 11967,
     /* 1782464 */     GIR_EraseRootFromParent_Done,
     /* 1782465 */   // Label 24246: @1782465
     /* 1782465 */   GIM_Try, /*On fail goto*//*Label 24247*/ GIMT_Encode4(1782551), // Rule ID 11970 //
     /* 1782470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1782473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1782481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1782484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1782487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782516 */     // MIs[0] policy
     /* 1782516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1782529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782550 */     // GIR_Coverage, 11970,
     /* 1782550 */     GIR_EraseRootFromParent_Done,
     /* 1782551 */   // Label 24247: @1782551
     /* 1782551 */   GIM_Try, /*On fail goto*//*Label 24248*/ GIMT_Encode4(1782637), // Rule ID 11971 //
     /* 1782556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1782559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1782567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1782570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1782573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782602 */     // MIs[0] policy
     /* 1782602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782612 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1782615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782636 */     // GIR_Coverage, 11971,
     /* 1782636 */     GIR_EraseRootFromParent_Done,
     /* 1782637 */   // Label 24248: @1782637
     /* 1782637 */   GIM_Try, /*On fail goto*//*Label 24249*/ GIMT_Encode4(1782723), // Rule ID 11974 //
     /* 1782642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1782653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1782656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1782659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1782665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1782672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782688 */     // MIs[0] policy
     /* 1782688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1782701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782722 */     // GIR_Coverage, 11974,
     /* 1782722 */     GIR_EraseRootFromParent_Done,
     /* 1782723 */   // Label 24249: @1782723
     /* 1782723 */   GIM_Try, /*On fail goto*//*Label 24250*/ GIMT_Encode4(1782809), // Rule ID 11975 //
     /* 1782728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1782739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1782742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1782745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1782751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1782758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782774 */     // MIs[0] policy
     /* 1782774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1782787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782808 */     // GIR_Coverage, 11975,
     /* 1782808 */     GIR_EraseRootFromParent_Done,
     /* 1782809 */   // Label 24250: @1782809
     /* 1782809 */   GIM_Try, /*On fail goto*//*Label 24251*/ GIMT_Encode4(1782895), // Rule ID 11978 //
     /* 1782814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1782825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1782828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1782831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1782837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1782844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782860 */     // MIs[0] policy
     /* 1782860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1782873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782894 */     // GIR_Coverage, 11978,
     /* 1782894 */     GIR_EraseRootFromParent_Done,
     /* 1782895 */   // Label 24251: @1782895
     /* 1782895 */   GIM_Try, /*On fail goto*//*Label 24252*/ GIMT_Encode4(1782981), // Rule ID 11979 //
     /* 1782900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1782911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1782914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1782917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1782923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1782930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782946 */     // MIs[0] policy
     /* 1782946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782956 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1782959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782980 */     // GIR_Coverage, 11979,
     /* 1782980 */     GIR_EraseRootFromParent_Done,
     /* 1782981 */   // Label 24252: @1782981
     /* 1782981 */   GIM_Try, /*On fail goto*//*Label 24253*/ GIMT_Encode4(1783067), // Rule ID 11982 //
     /* 1782986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1782997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1783000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1783003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1783009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783032 */     // MIs[0] policy
     /* 1783032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783042 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1783045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783066 */     // GIR_Coverage, 11982,
     /* 1783066 */     GIR_EraseRootFromParent_Done,
     /* 1783067 */   // Label 24253: @1783067
     /* 1783067 */   GIM_Try, /*On fail goto*//*Label 24254*/ GIMT_Encode4(1783153), // Rule ID 11983 //
     /* 1783072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1783083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1783086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1783089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1783095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783118 */     // MIs[0] policy
     /* 1783118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783128 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1783131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783152 */     // GIR_Coverage, 11983,
     /* 1783152 */     GIR_EraseRootFromParent_Done,
     /* 1783153 */   // Label 24254: @1783153
     /* 1783153 */   GIM_Try, /*On fail goto*//*Label 24255*/ GIMT_Encode4(1783239), // Rule ID 11986 //
     /* 1783158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1783169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1783172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1783175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783204 */     // MIs[0] policy
     /* 1783204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783214 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1783217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783238 */     // GIR_Coverage, 11986,
     /* 1783238 */     GIR_EraseRootFromParent_Done,
     /* 1783239 */   // Label 24255: @1783239
     /* 1783239 */   GIM_Try, /*On fail goto*//*Label 24256*/ GIMT_Encode4(1783325), // Rule ID 11987 //
     /* 1783244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1783255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1783258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1783261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783290 */     // MIs[0] policy
     /* 1783290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783300 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1783303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783324 */     // GIR_Coverage, 11987,
     /* 1783324 */     GIR_EraseRootFromParent_Done,
     /* 1783325 */   // Label 24256: @1783325
     /* 1783325 */   GIM_Try, /*On fail goto*//*Label 24257*/ GIMT_Encode4(1783411), // Rule ID 11990 //
     /* 1783330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1783341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1783344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1783347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783376 */     // MIs[0] policy
     /* 1783376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783386 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1783389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783410 */     // GIR_Coverage, 11990,
     /* 1783410 */     GIR_EraseRootFromParent_Done,
     /* 1783411 */   // Label 24257: @1783411
     /* 1783411 */   GIM_Try, /*On fail goto*//*Label 24258*/ GIMT_Encode4(1783497), // Rule ID 11991 //
     /* 1783416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1783427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1783430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1783433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783462 */     // MIs[0] policy
     /* 1783462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783472 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1783475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783496 */     // GIR_Coverage, 11991,
     /* 1783496 */     GIR_EraseRootFromParent_Done,
     /* 1783497 */   // Label 24258: @1783497
     /* 1783497 */   GIM_Try, /*On fail goto*//*Label 24259*/ GIMT_Encode4(1783583), // Rule ID 11994 //
     /* 1783502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1783513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1783516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1783519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783548 */     // MIs[0] policy
     /* 1783548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1783561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783582 */     // GIR_Coverage, 11994,
     /* 1783582 */     GIR_EraseRootFromParent_Done,
     /* 1783583 */   // Label 24259: @1783583
     /* 1783583 */   GIM_Try, /*On fail goto*//*Label 24260*/ GIMT_Encode4(1783669), // Rule ID 11995 //
     /* 1783588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1783599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1783602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1783605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783634 */     // MIs[0] policy
     /* 1783634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783644 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1783647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783668 */     // GIR_Coverage, 11995,
     /* 1783668 */     GIR_EraseRootFromParent_Done,
     /* 1783669 */   // Label 24260: @1783669
     /* 1783669 */   GIM_Try, /*On fail goto*//*Label 24261*/ GIMT_Encode4(1783755), // Rule ID 11998 //
     /* 1783674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1783685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1783688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1783691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1783697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783720 */     // MIs[0] policy
     /* 1783720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1783733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783754 */     // GIR_Coverage, 11998,
     /* 1783754 */     GIR_EraseRootFromParent_Done,
     /* 1783755 */   // Label 24261: @1783755
     /* 1783755 */   GIM_Try, /*On fail goto*//*Label 24262*/ GIMT_Encode4(1783841), // Rule ID 11999 //
     /* 1783760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1783771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1783774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1783777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1783783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783806 */     // MIs[0] policy
     /* 1783806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783816 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1783819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783840 */     // GIR_Coverage, 11999,
     /* 1783840 */     GIR_EraseRootFromParent_Done,
     /* 1783841 */   // Label 24262: @1783841
     /* 1783841 */   GIM_Try, /*On fail goto*//*Label 24263*/ GIMT_Encode4(1783927), // Rule ID 12002 //
     /* 1783846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1783857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1783860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1783863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783892 */     // MIs[0] policy
     /* 1783892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1783905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783926 */     // GIR_Coverage, 12002,
     /* 1783926 */     GIR_EraseRootFromParent_Done,
     /* 1783927 */   // Label 24263: @1783927
     /* 1783927 */   GIM_Try, /*On fail goto*//*Label 24264*/ GIMT_Encode4(1784013), // Rule ID 12003 //
     /* 1783932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1783943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1783946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1783949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783978 */     // MIs[0] policy
     /* 1783978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783988 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1783991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784012 */     // GIR_Coverage, 12003,
     /* 1784012 */     GIR_EraseRootFromParent_Done,
     /* 1784013 */   // Label 24264: @1784013
     /* 1784013 */   GIM_Try, /*On fail goto*//*Label 24265*/ GIMT_Encode4(1784099), // Rule ID 12006 //
     /* 1784018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1784029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1784032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1784035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784064 */     // MIs[0] policy
     /* 1784064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784074 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1784077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784098 */     // GIR_Coverage, 12006,
     /* 1784098 */     GIR_EraseRootFromParent_Done,
     /* 1784099 */   // Label 24265: @1784099
     /* 1784099 */   GIM_Try, /*On fail goto*//*Label 24266*/ GIMT_Encode4(1784185), // Rule ID 12007 //
     /* 1784104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1784115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1784118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1784121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784150 */     // MIs[0] policy
     /* 1784150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784160 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1784163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784184 */     // GIR_Coverage, 12007,
     /* 1784184 */     GIR_EraseRootFromParent_Done,
     /* 1784185 */   // Label 24266: @1784185
     /* 1784185 */   GIM_Try, /*On fail goto*//*Label 24267*/ GIMT_Encode4(1784271), // Rule ID 12010 //
     /* 1784190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1784201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1784204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1784207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784236 */     // MIs[0] policy
     /* 1784236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1784249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784270 */     // GIR_Coverage, 12010,
     /* 1784270 */     GIR_EraseRootFromParent_Done,
     /* 1784271 */   // Label 24267: @1784271
     /* 1784271 */   GIM_Try, /*On fail goto*//*Label 24268*/ GIMT_Encode4(1784357), // Rule ID 12011 //
     /* 1784276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1784287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1784290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1784293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784322 */     // MIs[0] policy
     /* 1784322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1784335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784356 */     // GIR_Coverage, 12011,
     /* 1784356 */     GIR_EraseRootFromParent_Done,
     /* 1784357 */   // Label 24268: @1784357
     /* 1784357 */   GIM_Try, /*On fail goto*//*Label 24269*/ GIMT_Encode4(1784443), // Rule ID 12014 //
     /* 1784362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1784373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1784376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1784379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784408 */     // MIs[0] policy
     /* 1784408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1784421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784442 */     // GIR_Coverage, 12014,
     /* 1784442 */     GIR_EraseRootFromParent_Done,
     /* 1784443 */   // Label 24269: @1784443
     /* 1784443 */   GIM_Try, /*On fail goto*//*Label 24270*/ GIMT_Encode4(1784529), // Rule ID 12015 //
     /* 1784448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1784459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1784462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1784465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784494 */     // MIs[0] policy
     /* 1784494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784504 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1784507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784528 */     // GIR_Coverage, 12015,
     /* 1784528 */     GIR_EraseRootFromParent_Done,
     /* 1784529 */   // Label 24270: @1784529
     /* 1784529 */   GIM_Try, /*On fail goto*//*Label 24271*/ GIMT_Encode4(1784615), // Rule ID 12018 //
     /* 1784534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1784545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1784548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1784551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784580 */     // MIs[0] policy
     /* 1784580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1784593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784614 */     // GIR_Coverage, 12018,
     /* 1784614 */     GIR_EraseRootFromParent_Done,
     /* 1784615 */   // Label 24271: @1784615
     /* 1784615 */   GIM_Try, /*On fail goto*//*Label 24272*/ GIMT_Encode4(1784701), // Rule ID 12019 //
     /* 1784620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1784631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1784634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1784637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784666 */     // MIs[0] policy
     /* 1784666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1784679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784700 */     // GIR_Coverage, 12019,
     /* 1784700 */     GIR_EraseRootFromParent_Done,
     /* 1784701 */   // Label 24272: @1784701
     /* 1784701 */   GIM_Try, /*On fail goto*//*Label 24273*/ GIMT_Encode4(1784787), // Rule ID 12022 //
     /* 1784706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1784717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1784720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1784723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1784726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1784729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784752 */     // MIs[0] policy
     /* 1784752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784762 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1784765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784786 */     // GIR_Coverage, 12022,
     /* 1784786 */     GIR_EraseRootFromParent_Done,
     /* 1784787 */   // Label 24273: @1784787
     /* 1784787 */   GIM_Try, /*On fail goto*//*Label 24274*/ GIMT_Encode4(1784873), // Rule ID 12023 //
     /* 1784792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1784803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1784806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1784809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1784812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1784815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784838 */     // MIs[0] policy
     /* 1784838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784848 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1784851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784872 */     // GIR_Coverage, 12023,
     /* 1784872 */     GIR_EraseRootFromParent_Done,
     /* 1784873 */   // Label 24274: @1784873
     /* 1784873 */   GIM_Try, /*On fail goto*//*Label 24275*/ GIMT_Encode4(1784959), // Rule ID 12026 //
     /* 1784878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1784889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1784892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1784895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1784898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784924 */     // MIs[0] policy
     /* 1784924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784934 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1784937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784958 */     // GIR_Coverage, 12026,
     /* 1784958 */     GIR_EraseRootFromParent_Done,
     /* 1784959 */   // Label 24275: @1784959
     /* 1784959 */   GIM_Try, /*On fail goto*//*Label 24276*/ GIMT_Encode4(1785045), // Rule ID 12027 //
     /* 1784964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1784975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1784978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1784981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1784984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785010 */     // MIs[0] policy
     /* 1785010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785020 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1785023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785044 */     // GIR_Coverage, 12027,
     /* 1785044 */     GIR_EraseRootFromParent_Done,
     /* 1785045 */   // Label 24276: @1785045
     /* 1785045 */   GIM_Try, /*On fail goto*//*Label 24277*/ GIMT_Encode4(1785131), // Rule ID 12030 //
     /* 1785050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1785061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1785064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1785067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1785070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785096 */     // MIs[0] policy
     /* 1785096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785106 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1785109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785130 */     // GIR_Coverage, 12030,
     /* 1785130 */     GIR_EraseRootFromParent_Done,
     /* 1785131 */   // Label 24277: @1785131
     /* 1785131 */   GIM_Try, /*On fail goto*//*Label 24278*/ GIMT_Encode4(1785217), // Rule ID 12031 //
     /* 1785136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1785147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1785150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1785153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1785156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785182 */     // MIs[0] policy
     /* 1785182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785192 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1785195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785216 */     // GIR_Coverage, 12031,
     /* 1785216 */     GIR_EraseRootFromParent_Done,
     /* 1785217 */   // Label 24278: @1785217
     /* 1785217 */   GIM_Try, /*On fail goto*//*Label 24279*/ GIMT_Encode4(1785303), // Rule ID 12034 //
     /* 1785222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1785233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1785236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1785239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1785242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785268 */     // MIs[0] policy
     /* 1785268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785278 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1785281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785302 */     // GIR_Coverage, 12034,
     /* 1785302 */     GIR_EraseRootFromParent_Done,
     /* 1785303 */   // Label 24279: @1785303
     /* 1785303 */   GIM_Try, /*On fail goto*//*Label 24280*/ GIMT_Encode4(1785389), // Rule ID 12035 //
     /* 1785308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1785319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1785322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1785325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1785328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785354 */     // MIs[0] policy
     /* 1785354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785364 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1785367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785388 */     // GIR_Coverage, 12035,
     /* 1785388 */     GIR_EraseRootFromParent_Done,
     /* 1785389 */   // Label 24280: @1785389
     /* 1785389 */   GIM_Try, /*On fail goto*//*Label 24281*/ GIMT_Encode4(1785475), // Rule ID 12038 //
     /* 1785394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1785405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1785408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1785411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1785414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785440 */     // MIs[0] policy
     /* 1785440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785450 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1785453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785474 */     // GIR_Coverage, 12038,
     /* 1785474 */     GIR_EraseRootFromParent_Done,
     /* 1785475 */   // Label 24281: @1785475
     /* 1785475 */   GIM_Try, /*On fail goto*//*Label 24282*/ GIMT_Encode4(1785561), // Rule ID 12039 //
     /* 1785480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1785491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1785494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1785497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1785500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785526 */     // MIs[0] policy
     /* 1785526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785536 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1785539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785560 */     // GIR_Coverage, 12039,
     /* 1785560 */     GIR_EraseRootFromParent_Done,
     /* 1785561 */   // Label 24282: @1785561
     /* 1785561 */   GIM_Try, /*On fail goto*//*Label 24283*/ GIMT_Encode4(1785647), // Rule ID 12042 //
     /* 1785566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1785577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1785580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1785583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1785586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785612 */     // MIs[0] policy
     /* 1785612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785622 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1785625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785646 */     // GIR_Coverage, 12042,
     /* 1785646 */     GIR_EraseRootFromParent_Done,
     /* 1785647 */   // Label 24283: @1785647
     /* 1785647 */   GIM_Try, /*On fail goto*//*Label 24284*/ GIMT_Encode4(1785733), // Rule ID 12043 //
     /* 1785652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1785663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1785666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1785669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1785672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785698 */     // MIs[0] policy
     /* 1785698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785708 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1785711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785732 */     // GIR_Coverage, 12043,
     /* 1785732 */     GIR_EraseRootFromParent_Done,
     /* 1785733 */   // Label 24284: @1785733
     /* 1785733 */   GIM_Try, /*On fail goto*//*Label 24285*/ GIMT_Encode4(1785819), // Rule ID 12046 //
     /* 1785738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1785749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1785752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1785755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1785758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785784 */     // MIs[0] policy
     /* 1785784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785794 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1785797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785818 */     // GIR_Coverage, 12046,
     /* 1785818 */     GIR_EraseRootFromParent_Done,
     /* 1785819 */   // Label 24285: @1785819
     /* 1785819 */   GIM_Try, /*On fail goto*//*Label 24286*/ GIMT_Encode4(1785905), // Rule ID 12047 //
     /* 1785824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1785835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1785838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1785841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1785844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785870 */     // MIs[0] policy
     /* 1785870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785880 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1785883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785904 */     // GIR_Coverage, 12047,
     /* 1785904 */     GIR_EraseRootFromParent_Done,
     /* 1785905 */   // Label 24286: @1785905
     /* 1785905 */   GIM_Try, /*On fail goto*//*Label 24287*/ GIMT_Encode4(1785991), // Rule ID 12050 //
     /* 1785910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1785921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1785924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1785927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1785930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785956 */     // MIs[0] policy
     /* 1785956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785966 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1785969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785990 */     // GIR_Coverage, 12050,
     /* 1785990 */     GIR_EraseRootFromParent_Done,
     /* 1785991 */   // Label 24287: @1785991
     /* 1785991 */   GIM_Try, /*On fail goto*//*Label 24288*/ GIMT_Encode4(1786077), // Rule ID 12051 //
     /* 1785996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1786007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1786010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1786013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1786016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786042 */     // MIs[0] policy
     /* 1786042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1786055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786076 */     // GIR_Coverage, 12051,
     /* 1786076 */     GIR_EraseRootFromParent_Done,
     /* 1786077 */   // Label 24288: @1786077
     /* 1786077 */   GIM_Try, /*On fail goto*//*Label 24289*/ GIMT_Encode4(1786163), // Rule ID 12054 //
     /* 1786082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1786093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1786096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1786099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1786102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786128 */     // MIs[0] policy
     /* 1786128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786138 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1786141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786162 */     // GIR_Coverage, 12054,
     /* 1786162 */     GIR_EraseRootFromParent_Done,
     /* 1786163 */   // Label 24289: @1786163
     /* 1786163 */   GIM_Try, /*On fail goto*//*Label 24290*/ GIMT_Encode4(1786249), // Rule ID 12055 //
     /* 1786168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1786179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1786182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1786185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1786188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786214 */     // MIs[0] policy
     /* 1786214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1786227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786248 */     // GIR_Coverage, 12055,
     /* 1786248 */     GIR_EraseRootFromParent_Done,
     /* 1786249 */   // Label 24290: @1786249
     /* 1786249 */   GIM_Try, /*On fail goto*//*Label 24291*/ GIMT_Encode4(1786335), // Rule ID 12058 //
     /* 1786254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1786257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1786265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1786268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1786271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1786274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786300 */     // MIs[0] policy
     /* 1786300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786310 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1786313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786334 */     // GIR_Coverage, 12058,
     /* 1786334 */     GIR_EraseRootFromParent_Done,
     /* 1786335 */   // Label 24291: @1786335
     /* 1786335 */   GIM_Try, /*On fail goto*//*Label 24292*/ GIMT_Encode4(1786421), // Rule ID 12059 //
     /* 1786340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1786343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1786351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1786354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1786357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1786360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786386 */     // MIs[0] policy
     /* 1786386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786396 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1786399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786420 */     // GIR_Coverage, 12059,
     /* 1786420 */     GIR_EraseRootFromParent_Done,
     /* 1786421 */   // Label 24292: @1786421
     /* 1786421 */   GIM_Try, /*On fail goto*//*Label 24293*/ GIMT_Encode4(1786507), // Rule ID 12062 //
     /* 1786426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1786437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1786440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1786443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1786446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1786449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1786456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786472 */     // MIs[0] policy
     /* 1786472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1786485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786506 */     // GIR_Coverage, 12062,
     /* 1786506 */     GIR_EraseRootFromParent_Done,
     /* 1786507 */   // Label 24293: @1786507
     /* 1786507 */   GIM_Try, /*On fail goto*//*Label 24294*/ GIMT_Encode4(1786593), // Rule ID 12063 //
     /* 1786512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1786523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1786526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1786529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1786532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1786535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1786542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786558 */     // MIs[0] policy
     /* 1786558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786568 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1786571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786592 */     // GIR_Coverage, 12063,
     /* 1786592 */     GIR_EraseRootFromParent_Done,
     /* 1786593 */   // Label 24294: @1786593
     /* 1786593 */   GIM_Try, /*On fail goto*//*Label 24295*/ GIMT_Encode4(1786679), // Rule ID 12066 //
     /* 1786598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1786609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1786612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1786615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1786618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1786621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1786628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786644 */     // MIs[0] policy
     /* 1786644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786654 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1786657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786678 */     // GIR_Coverage, 12066,
     /* 1786678 */     GIR_EraseRootFromParent_Done,
     /* 1786679 */   // Label 24295: @1786679
     /* 1786679 */   GIM_Try, /*On fail goto*//*Label 24296*/ GIMT_Encode4(1786765), // Rule ID 12067 //
     /* 1786684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1786695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1786698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1786701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1786704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1786707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1786714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786730 */     // MIs[0] policy
     /* 1786730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786740 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1786743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786764 */     // GIR_Coverage, 12067,
     /* 1786764 */     GIR_EraseRootFromParent_Done,
     /* 1786765 */   // Label 24296: @1786765
     /* 1786765 */   GIM_Try, /*On fail goto*//*Label 24297*/ GIMT_Encode4(1786851), // Rule ID 12070 //
     /* 1786770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1786781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1786784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1786787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1786790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1786793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1786800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786816 */     // MIs[0] policy
     /* 1786816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786826 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1786829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786850 */     // GIR_Coverage, 12070,
     /* 1786850 */     GIR_EraseRootFromParent_Done,
     /* 1786851 */   // Label 24297: @1786851
     /* 1786851 */   GIM_Try, /*On fail goto*//*Label 24298*/ GIMT_Encode4(1786937), // Rule ID 12071 //
     /* 1786856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1786867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1786870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1786873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1786876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1786879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1786886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786902 */     // MIs[0] policy
     /* 1786902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786912 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1786915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786936 */     // GIR_Coverage, 12071,
     /* 1786936 */     GIR_EraseRootFromParent_Done,
     /* 1786937 */   // Label 24298: @1786937
     /* 1786937 */   GIM_Try, /*On fail goto*//*Label 24299*/ GIMT_Encode4(1787023), // Rule ID 12074 //
     /* 1786942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1786953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1786956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1786959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1786962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1786965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1786972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786988 */     // MIs[0] policy
     /* 1786988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786998 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1787001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787022 */     // GIR_Coverage, 12074,
     /* 1787022 */     GIR_EraseRootFromParent_Done,
     /* 1787023 */   // Label 24299: @1787023
     /* 1787023 */   GIM_Try, /*On fail goto*//*Label 24300*/ GIMT_Encode4(1787109), // Rule ID 12075 //
     /* 1787028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1787039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1787042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1787045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1787048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787074 */     // MIs[0] policy
     /* 1787074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787084 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1787087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787108 */     // GIR_Coverage, 12075,
     /* 1787108 */     GIR_EraseRootFromParent_Done,
     /* 1787109 */   // Label 24300: @1787109
     /* 1787109 */   GIM_Try, /*On fail goto*//*Label 24301*/ GIMT_Encode4(1787195), // Rule ID 12078 //
     /* 1787114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1787125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1787128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1787131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1787134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787160 */     // MIs[0] policy
     /* 1787160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787170 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1787173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787194 */     // GIR_Coverage, 12078,
     /* 1787194 */     GIR_EraseRootFromParent_Done,
     /* 1787195 */   // Label 24301: @1787195
     /* 1787195 */   GIM_Try, /*On fail goto*//*Label 24302*/ GIMT_Encode4(1787281), // Rule ID 12079 //
     /* 1787200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1787211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1787214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1787217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1787220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787246 */     // MIs[0] policy
     /* 1787246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787256 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1787259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787280 */     // GIR_Coverage, 12079,
     /* 1787280 */     GIR_EraseRootFromParent_Done,
     /* 1787281 */   // Label 24302: @1787281
     /* 1787281 */   GIM_Try, /*On fail goto*//*Label 24303*/ GIMT_Encode4(1787367), // Rule ID 12082 //
     /* 1787286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1787297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1787300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1787303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1787306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787332 */     // MIs[0] policy
     /* 1787332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787342 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1787345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787366 */     // GIR_Coverage, 12082,
     /* 1787366 */     GIR_EraseRootFromParent_Done,
     /* 1787367 */   // Label 24303: @1787367
     /* 1787367 */   GIM_Try, /*On fail goto*//*Label 24304*/ GIMT_Encode4(1787453), // Rule ID 12083 //
     /* 1787372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1787383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1787386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1787389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1787392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787418 */     // MIs[0] policy
     /* 1787418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787428 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1787431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787452 */     // GIR_Coverage, 12083,
     /* 1787452 */     GIR_EraseRootFromParent_Done,
     /* 1787453 */   // Label 24304: @1787453
     /* 1787453 */   GIM_Try, /*On fail goto*//*Label 24305*/ GIMT_Encode4(1787539), // Rule ID 12086 //
     /* 1787458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1787469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1787472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1787475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1787478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1787481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787504 */     // MIs[0] policy
     /* 1787504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787514 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1787517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787538 */     // GIR_Coverage, 12086,
     /* 1787538 */     GIR_EraseRootFromParent_Done,
     /* 1787539 */   // Label 24305: @1787539
     /* 1787539 */   GIM_Try, /*On fail goto*//*Label 24306*/ GIMT_Encode4(1787625), // Rule ID 12087 //
     /* 1787544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1787555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1787558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1787561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1787564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1787567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787590 */     // MIs[0] policy
     /* 1787590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1787603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787624 */     // GIR_Coverage, 12087,
     /* 1787624 */     GIR_EraseRootFromParent_Done,
     /* 1787625 */   // Label 24306: @1787625
     /* 1787625 */   GIM_Try, /*On fail goto*//*Label 24307*/ GIMT_Encode4(1787711), // Rule ID 12090 //
     /* 1787630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1787641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1787644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1787647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1787650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787676 */     // MIs[0] policy
     /* 1787676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1787689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787710 */     // GIR_Coverage, 12090,
     /* 1787710 */     GIR_EraseRootFromParent_Done,
     /* 1787711 */   // Label 24307: @1787711
     /* 1787711 */   GIM_Try, /*On fail goto*//*Label 24308*/ GIMT_Encode4(1787797), // Rule ID 12091 //
     /* 1787716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1787727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1787730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1787733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1787736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787762 */     // MIs[0] policy
     /* 1787762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787772 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1787775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787796 */     // GIR_Coverage, 12091,
     /* 1787796 */     GIR_EraseRootFromParent_Done,
     /* 1787797 */   // Label 24308: @1787797
     /* 1787797 */   GIM_Try, /*On fail goto*//*Label 24309*/ GIMT_Encode4(1787883), // Rule ID 12094 //
     /* 1787802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1787813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1787816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1787819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1787822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787848 */     // MIs[0] policy
     /* 1787848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787858 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1787861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787882 */     // GIR_Coverage, 12094,
     /* 1787882 */     GIR_EraseRootFromParent_Done,
     /* 1787883 */   // Label 24309: @1787883
     /* 1787883 */   GIM_Try, /*On fail goto*//*Label 24310*/ GIMT_Encode4(1787969), // Rule ID 12095 //
     /* 1787888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1787899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1787902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1787905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1787908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787934 */     // MIs[0] policy
     /* 1787934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787944 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1787947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787968 */     // GIR_Coverage, 12095,
     /* 1787968 */     GIR_EraseRootFromParent_Done,
     /* 1787969 */   // Label 24310: @1787969
     /* 1787969 */   GIM_Try, /*On fail goto*//*Label 24311*/ GIMT_Encode4(1788055), // Rule ID 12098 //
     /* 1787974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1787977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1787985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1787988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1787991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1787994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1787997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788020 */     // MIs[0] policy
     /* 1788020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788030 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1788033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788054 */     // GIR_Coverage, 12098,
     /* 1788054 */     GIR_EraseRootFromParent_Done,
     /* 1788055 */   // Label 24311: @1788055
     /* 1788055 */   GIM_Try, /*On fail goto*//*Label 24312*/ GIMT_Encode4(1788141), // Rule ID 12099 //
     /* 1788060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1788071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1788074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1788077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1788080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788106 */     // MIs[0] policy
     /* 1788106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788116 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1788119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788140 */     // GIR_Coverage, 12099,
     /* 1788140 */     GIR_EraseRootFromParent_Done,
     /* 1788141 */   // Label 24312: @1788141
     /* 1788141 */   GIM_Try, /*On fail goto*//*Label 24313*/ GIMT_Encode4(1788227), // Rule ID 12102 //
     /* 1788146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1788157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1788160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1788163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1788166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788192 */     // MIs[0] policy
     /* 1788192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788202 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1788205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788226 */     // GIR_Coverage, 12102,
     /* 1788226 */     GIR_EraseRootFromParent_Done,
     /* 1788227 */   // Label 24313: @1788227
     /* 1788227 */   GIM_Try, /*On fail goto*//*Label 24314*/ GIMT_Encode4(1788313), // Rule ID 12103 //
     /* 1788232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1788243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1788246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1788249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1788252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788278 */     // MIs[0] policy
     /* 1788278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788288 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1788291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788312 */     // GIR_Coverage, 12103,
     /* 1788312 */     GIR_EraseRootFromParent_Done,
     /* 1788313 */   // Label 24314: @1788313
     /* 1788313 */   GIM_Try, /*On fail goto*//*Label 24315*/ GIMT_Encode4(1788399), // Rule ID 12106 //
     /* 1788318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1788329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1788332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1788335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1788338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788364 */     // MIs[0] policy
     /* 1788364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788374 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1788377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788398 */     // GIR_Coverage, 12106,
     /* 1788398 */     GIR_EraseRootFromParent_Done,
     /* 1788399 */   // Label 24315: @1788399
     /* 1788399 */   GIM_Try, /*On fail goto*//*Label 24316*/ GIMT_Encode4(1788485), // Rule ID 12107 //
     /* 1788404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1788415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1788418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1788421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1788424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788450 */     // MIs[0] policy
     /* 1788450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788460 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1788463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788484 */     // GIR_Coverage, 12107,
     /* 1788484 */     GIR_EraseRootFromParent_Done,
     /* 1788485 */   // Label 24316: @1788485
     /* 1788485 */   GIM_Try, /*On fail goto*//*Label 24317*/ GIMT_Encode4(1788571), // Rule ID 12110 //
     /* 1788490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1788501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1788504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1788507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1788513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788536 */     // MIs[0] policy
     /* 1788536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788546 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1788549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788570 */     // GIR_Coverage, 12110,
     /* 1788570 */     GIR_EraseRootFromParent_Done,
     /* 1788571 */   // Label 24317: @1788571
     /* 1788571 */   GIM_Try, /*On fail goto*//*Label 24318*/ GIMT_Encode4(1788657), // Rule ID 12111 //
     /* 1788576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1788587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1788590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1788593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1788599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788622 */     // MIs[0] policy
     /* 1788622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788632 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1788635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788656 */     // GIR_Coverage, 12111,
     /* 1788656 */     GIR_EraseRootFromParent_Done,
     /* 1788657 */   // Label 24318: @1788657
     /* 1788657 */   GIM_Try, /*On fail goto*//*Label 24319*/ GIMT_Encode4(1788743), // Rule ID 12114 //
     /* 1788662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1788673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1788676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1788679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788708 */     // MIs[0] policy
     /* 1788708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788718 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1788721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788742 */     // GIR_Coverage, 12114,
     /* 1788742 */     GIR_EraseRootFromParent_Done,
     /* 1788743 */   // Label 24319: @1788743
     /* 1788743 */   GIM_Try, /*On fail goto*//*Label 24320*/ GIMT_Encode4(1788829), // Rule ID 12115 //
     /* 1788748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1788759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1788762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1788765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788794 */     // MIs[0] policy
     /* 1788794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788804 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1788807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788828 */     // GIR_Coverage, 12115,
     /* 1788828 */     GIR_EraseRootFromParent_Done,
     /* 1788829 */   // Label 24320: @1788829
     /* 1788829 */   GIM_Try, /*On fail goto*//*Label 24321*/ GIMT_Encode4(1788915), // Rule ID 12118 //
     /* 1788834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1788845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1788848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1788851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788880 */     // MIs[0] policy
     /* 1788880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788890 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1788893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788914 */     // GIR_Coverage, 12118,
     /* 1788914 */     GIR_EraseRootFromParent_Done,
     /* 1788915 */   // Label 24321: @1788915
     /* 1788915 */   GIM_Try, /*On fail goto*//*Label 24322*/ GIMT_Encode4(1789001), // Rule ID 12119 //
     /* 1788920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1788931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1788934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1788937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788966 */     // MIs[0] policy
     /* 1788966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788976 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1788979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789000 */     // GIR_Coverage, 12119,
     /* 1789000 */     GIR_EraseRootFromParent_Done,
     /* 1789001 */   // Label 24322: @1789001
     /* 1789001 */   GIM_Try, /*On fail goto*//*Label 24323*/ GIMT_Encode4(1789087), // Rule ID 12122 //
     /* 1789006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1789017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1789020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1789023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789052 */     // MIs[0] policy
     /* 1789052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789062 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1789065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789086 */     // GIR_Coverage, 12122,
     /* 1789086 */     GIR_EraseRootFromParent_Done,
     /* 1789087 */   // Label 24323: @1789087
     /* 1789087 */   GIM_Try, /*On fail goto*//*Label 24324*/ GIMT_Encode4(1789173), // Rule ID 12123 //
     /* 1789092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1789103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1789106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1789109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789138 */     // MIs[0] policy
     /* 1789138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789148 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1789151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789172 */     // GIR_Coverage, 12123,
     /* 1789172 */     GIR_EraseRootFromParent_Done,
     /* 1789173 */   // Label 24324: @1789173
     /* 1789173 */   GIM_Try, /*On fail goto*//*Label 24325*/ GIMT_Encode4(1789259), // Rule ID 12126 //
     /* 1789178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1789189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1789192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1789195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789224 */     // MIs[0] policy
     /* 1789224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789234 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1789237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789258 */     // GIR_Coverage, 12126,
     /* 1789258 */     GIR_EraseRootFromParent_Done,
     /* 1789259 */   // Label 24325: @1789259
     /* 1789259 */   GIM_Try, /*On fail goto*//*Label 24326*/ GIMT_Encode4(1789345), // Rule ID 12127 //
     /* 1789264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1789275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1789278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1789281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789310 */     // MIs[0] policy
     /* 1789310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789320 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1789323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789344 */     // GIR_Coverage, 12127,
     /* 1789344 */     GIR_EraseRootFromParent_Done,
     /* 1789345 */   // Label 24326: @1789345
     /* 1789345 */   GIM_Try, /*On fail goto*//*Label 24327*/ GIMT_Encode4(1789431), // Rule ID 12130 //
     /* 1789350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1789361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1789364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1789367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789396 */     // MIs[0] policy
     /* 1789396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789406 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1789409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789430 */     // GIR_Coverage, 12130,
     /* 1789430 */     GIR_EraseRootFromParent_Done,
     /* 1789431 */   // Label 24327: @1789431
     /* 1789431 */   GIM_Try, /*On fail goto*//*Label 24328*/ GIMT_Encode4(1789517), // Rule ID 12131 //
     /* 1789436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1789447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1789450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1789453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789482 */     // MIs[0] policy
     /* 1789482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789492 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1789495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789516 */     // GIR_Coverage, 12131,
     /* 1789516 */     GIR_EraseRootFromParent_Done,
     /* 1789517 */   // Label 24328: @1789517
     /* 1789517 */   GIM_Try, /*On fail goto*//*Label 24329*/ GIMT_Encode4(1789603), // Rule ID 12134 //
     /* 1789522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1789533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1789536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1789539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789568 */     // MIs[0] policy
     /* 1789568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789578 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1789581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789602 */     // GIR_Coverage, 12134,
     /* 1789602 */     GIR_EraseRootFromParent_Done,
     /* 1789603 */   // Label 24329: @1789603
     /* 1789603 */   GIM_Try, /*On fail goto*//*Label 24330*/ GIMT_Encode4(1789689), // Rule ID 12135 //
     /* 1789608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1789619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1789622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1789625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789654 */     // MIs[0] policy
     /* 1789654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789664 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1789667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789688 */     // GIR_Coverage, 12135,
     /* 1789688 */     GIR_EraseRootFromParent_Done,
     /* 1789689 */   // Label 24330: @1789689
     /* 1789689 */   GIM_Try, /*On fail goto*//*Label 24331*/ GIMT_Encode4(1789775), // Rule ID 12138 //
     /* 1789694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1789705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1789708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1789711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789740 */     // MIs[0] policy
     /* 1789740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1789753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789774 */     // GIR_Coverage, 12138,
     /* 1789774 */     GIR_EraseRootFromParent_Done,
     /* 1789775 */   // Label 24331: @1789775
     /* 1789775 */   GIM_Try, /*On fail goto*//*Label 24332*/ GIMT_Encode4(1789861), // Rule ID 12139 //
     /* 1789780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1789791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1789794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1789797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789826 */     // MIs[0] policy
     /* 1789826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789836 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1789839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789860 */     // GIR_Coverage, 12139,
     /* 1789860 */     GIR_EraseRootFromParent_Done,
     /* 1789861 */   // Label 24332: @1789861
     /* 1789861 */   GIM_Try, /*On fail goto*//*Label 24333*/ GIMT_Encode4(1789947), // Rule ID 12142 //
     /* 1789866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1789877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1789880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1789883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789912 */     // MIs[0] policy
     /* 1789912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789922 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1789925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789946 */     // GIR_Coverage, 12142,
     /* 1789946 */     GIR_EraseRootFromParent_Done,
     /* 1789947 */   // Label 24333: @1789947
     /* 1789947 */   GIM_Try, /*On fail goto*//*Label 24334*/ GIMT_Encode4(1790033), // Rule ID 12143 //
     /* 1789952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1789963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1789966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1789969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789998 */     // MIs[0] policy
     /* 1789998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1790011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1790029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790032 */     // GIR_Coverage, 12143,
     /* 1790032 */     GIR_EraseRootFromParent_Done,
     /* 1790033 */   // Label 24334: @1790033
     /* 1790033 */   GIM_Try, /*On fail goto*//*Label 24335*/ GIMT_Encode4(1790119), // Rule ID 12146 //
     /* 1790038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1790041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1790049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1790052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1790055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790084 */     // MIs[0] policy
     /* 1790084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1790097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790118 */     // GIR_Coverage, 12146,
     /* 1790118 */     GIR_EraseRootFromParent_Done,
     /* 1790119 */   // Label 24335: @1790119
     /* 1790119 */   GIM_Try, /*On fail goto*//*Label 24336*/ GIMT_Encode4(1790205), // Rule ID 12147 //
     /* 1790124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1790127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1790135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1790138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1790141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790170 */     // MIs[0] policy
     /* 1790170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790180 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1790183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790204 */     // GIR_Coverage, 12147,
     /* 1790204 */     GIR_EraseRootFromParent_Done,
     /* 1790205 */   // Label 24336: @1790205
     /* 1790205 */   GIM_Try, /*On fail goto*//*Label 24337*/ GIMT_Encode4(1790291), // Rule ID 12150 //
     /* 1790210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1790221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1790224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1790227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790256 */     // MIs[0] policy
     /* 1790256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1790269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790290 */     // GIR_Coverage, 12150,
     /* 1790290 */     GIR_EraseRootFromParent_Done,
     /* 1790291 */   // Label 24337: @1790291
     /* 1790291 */   GIM_Try, /*On fail goto*//*Label 24338*/ GIMT_Encode4(1790377), // Rule ID 12151 //
     /* 1790296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1790307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1790310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1790313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790342 */     // MIs[0] policy
     /* 1790342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790352 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1790355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790376 */     // GIR_Coverage, 12151,
     /* 1790376 */     GIR_EraseRootFromParent_Done,
     /* 1790377 */   // Label 24338: @1790377
     /* 1790377 */   GIM_Try, /*On fail goto*//*Label 24339*/ GIMT_Encode4(1790463), // Rule ID 12154 //
     /* 1790382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1790393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1790396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1790399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1790405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790428 */     // MIs[0] policy
     /* 1790428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790438 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1790441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790462 */     // GIR_Coverage, 12154,
     /* 1790462 */     GIR_EraseRootFromParent_Done,
     /* 1790463 */   // Label 24339: @1790463
     /* 1790463 */   GIM_Try, /*On fail goto*//*Label 24340*/ GIMT_Encode4(1790549), // Rule ID 12155 //
     /* 1790468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1790479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1790482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1790485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1790491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790514 */     // MIs[0] policy
     /* 1790514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790524 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1790527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790548 */     // GIR_Coverage, 12155,
     /* 1790548 */     GIR_EraseRootFromParent_Done,
     /* 1790549 */   // Label 24340: @1790549
     /* 1790549 */   GIM_Try, /*On fail goto*//*Label 24341*/ GIMT_Encode4(1790635), // Rule ID 12158 //
     /* 1790554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1790565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1790568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1790571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1790577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1790584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790600 */     // MIs[0] policy
     /* 1790600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790610 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1790613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790634 */     // GIR_Coverage, 12158,
     /* 1790634 */     GIR_EraseRootFromParent_Done,
     /* 1790635 */   // Label 24341: @1790635
     /* 1790635 */   GIM_Try, /*On fail goto*//*Label 24342*/ GIMT_Encode4(1790721), // Rule ID 12159 //
     /* 1790640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1790651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1790654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1790657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1790663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1790670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790686 */     // MIs[0] policy
     /* 1790686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790696 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1790699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790720 */     // GIR_Coverage, 12159,
     /* 1790720 */     GIR_EraseRootFromParent_Done,
     /* 1790721 */   // Label 24342: @1790721
     /* 1790721 */   GIM_Try, /*On fail goto*//*Label 24343*/ GIMT_Encode4(1790807), // Rule ID 12162 //
     /* 1790726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1790737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1790740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1790743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1790749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790772 */     // MIs[0] policy
     /* 1790772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1790785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790806 */     // GIR_Coverage, 12162,
     /* 1790806 */     GIR_EraseRootFromParent_Done,
     /* 1790807 */   // Label 24343: @1790807
     /* 1790807 */   GIM_Try, /*On fail goto*//*Label 24344*/ GIMT_Encode4(1790893), // Rule ID 12163 //
     /* 1790812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1790823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1790826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1790829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1790835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790858 */     // MIs[0] policy
     /* 1790858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1790871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790892 */     // GIR_Coverage, 12163,
     /* 1790892 */     GIR_EraseRootFromParent_Done,
     /* 1790893 */   // Label 24344: @1790893
     /* 1790893 */   GIM_Try, /*On fail goto*//*Label 24345*/ GIMT_Encode4(1790979), // Rule ID 12166 //
     /* 1790898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1790909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1790912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1790915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790944 */     // MIs[0] policy
     /* 1790944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790954 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1790957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790978 */     // GIR_Coverage, 12166,
     /* 1790978 */     GIR_EraseRootFromParent_Done,
     /* 1790979 */   // Label 24345: @1790979
     /* 1790979 */   GIM_Try, /*On fail goto*//*Label 24346*/ GIMT_Encode4(1791065), // Rule ID 12167 //
     /* 1790984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1790995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1790998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1791001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791030 */     // MIs[0] policy
     /* 1791030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791040 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1791043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791064 */     // GIR_Coverage, 12167,
     /* 1791064 */     GIR_EraseRootFromParent_Done,
     /* 1791065 */   // Label 24346: @1791065
     /* 1791065 */   GIM_Try, /*On fail goto*//*Label 24347*/ GIMT_Encode4(1791151), // Rule ID 12170 //
     /* 1791070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1791081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1791084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1791087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1791093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791116 */     // MIs[0] policy
     /* 1791116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791126 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1791129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791150 */     // GIR_Coverage, 12170,
     /* 1791150 */     GIR_EraseRootFromParent_Done,
     /* 1791151 */   // Label 24347: @1791151
     /* 1791151 */   GIM_Try, /*On fail goto*//*Label 24348*/ GIMT_Encode4(1791237), // Rule ID 12171 //
     /* 1791156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1791167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1791170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1791173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1791179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791202 */     // MIs[0] policy
     /* 1791202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791212 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1791215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791236 */     // GIR_Coverage, 12171,
     /* 1791236 */     GIR_EraseRootFromParent_Done,
     /* 1791237 */   // Label 24348: @1791237
     /* 1791237 */   GIM_Try, /*On fail goto*//*Label 24349*/ GIMT_Encode4(1791323), // Rule ID 12174 //
     /* 1791242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1791253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1791256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1791259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791288 */     // MIs[0] policy
     /* 1791288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1791301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791322 */     // GIR_Coverage, 12174,
     /* 1791322 */     GIR_EraseRootFromParent_Done,
     /* 1791323 */   // Label 24349: @1791323
     /* 1791323 */   GIM_Try, /*On fail goto*//*Label 24350*/ GIMT_Encode4(1791409), // Rule ID 12175 //
     /* 1791328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1791339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1791342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1791345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791374 */     // MIs[0] policy
     /* 1791374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1791387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791408 */     // GIR_Coverage, 12175,
     /* 1791408 */     GIR_EraseRootFromParent_Done,
     /* 1791409 */   // Label 24350: @1791409
     /* 1791409 */   GIM_Try, /*On fail goto*//*Label 24351*/ GIMT_Encode4(1791495), // Rule ID 12178 //
     /* 1791414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1791425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1791428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1791431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791460 */     // MIs[0] policy
     /* 1791460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791470 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1791473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791494 */     // GIR_Coverage, 12178,
     /* 1791494 */     GIR_EraseRootFromParent_Done,
     /* 1791495 */   // Label 24351: @1791495
     /* 1791495 */   GIM_Try, /*On fail goto*//*Label 24352*/ GIMT_Encode4(1791581), // Rule ID 12179 //
     /* 1791500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1791511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1791514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1791517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791546 */     // MIs[0] policy
     /* 1791546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791556 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1791559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791580 */     // GIR_Coverage, 12179,
     /* 1791580 */     GIR_EraseRootFromParent_Done,
     /* 1791581 */   // Label 24352: @1791581
     /* 1791581 */   GIM_Try, /*On fail goto*//*Label 24353*/ GIMT_Encode4(1791667), // Rule ID 12182 //
     /* 1791586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1791597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1791600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1791603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791632 */     // MIs[0] policy
     /* 1791632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791642 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1791645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791666 */     // GIR_Coverage, 12182,
     /* 1791666 */     GIR_EraseRootFromParent_Done,
     /* 1791667 */   // Label 24353: @1791667
     /* 1791667 */   GIM_Try, /*On fail goto*//*Label 24354*/ GIMT_Encode4(1791753), // Rule ID 12183 //
     /* 1791672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1791683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1791686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1791689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791718 */     // MIs[0] policy
     /* 1791718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791728 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1791731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791752 */     // GIR_Coverage, 12183,
     /* 1791752 */     GIR_EraseRootFromParent_Done,
     /* 1791753 */   // Label 24354: @1791753
     /* 1791753 */   GIM_Try, /*On fail goto*//*Label 24355*/ GIMT_Encode4(1791839), // Rule ID 12186 //
     /* 1791758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1791761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1791769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1791772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1791775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1791781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791804 */     // MIs[0] policy
     /* 1791804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1791817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1791835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791838 */     // GIR_Coverage, 12186,
     /* 1791838 */     GIR_EraseRootFromParent_Done,
     /* 1791839 */   // Label 24355: @1791839
     /* 1791839 */   GIM_Try, /*On fail goto*//*Label 24356*/ GIMT_Encode4(1791925), // Rule ID 12187 //
     /* 1791844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1791847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1791855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1791858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1791861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1791867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791890 */     // MIs[0] policy
     /* 1791890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1791903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1791921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791924 */     // GIR_Coverage, 12187,
     /* 1791924 */     GIR_EraseRootFromParent_Done,
     /* 1791925 */   // Label 24356: @1791925
     /* 1791925 */   GIM_Try, /*On fail goto*//*Label 24357*/ GIMT_Encode4(1792011), // Rule ID 12190 //
     /* 1791930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1791933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1791941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1791944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1791947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791976 */     // MIs[0] policy
     /* 1791976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1791989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792010 */     // GIR_Coverage, 12190,
     /* 1792010 */     GIR_EraseRootFromParent_Done,
     /* 1792011 */   // Label 24357: @1792011
     /* 1792011 */   GIM_Try, /*On fail goto*//*Label 24358*/ GIMT_Encode4(1792097), // Rule ID 12191 //
     /* 1792016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1792027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1792030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1792033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792062 */     // MIs[0] policy
     /* 1792062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792072 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1792075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792096 */     // GIR_Coverage, 12191,
     /* 1792096 */     GIR_EraseRootFromParent_Done,
     /* 1792097 */   // Label 24358: @1792097
     /* 1792097 */   GIM_Try, /*On fail goto*//*Label 24359*/ GIMT_Encode4(1792183), // Rule ID 12194 //
     /* 1792102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1792105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1792113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1792116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1792119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792148 */     // MIs[0] policy
     /* 1792148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1792161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792182 */     // GIR_Coverage, 12194,
     /* 1792182 */     GIR_EraseRootFromParent_Done,
     /* 1792183 */   // Label 24359: @1792183
     /* 1792183 */   GIM_Try, /*On fail goto*//*Label 24360*/ GIMT_Encode4(1792269), // Rule ID 12195 //
     /* 1792188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1792199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1792202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1792205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792234 */     // MIs[0] policy
     /* 1792234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792244 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1792247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792268 */     // GIR_Coverage, 12195,
     /* 1792268 */     GIR_EraseRootFromParent_Done,
     /* 1792269 */   // Label 24360: @1792269
     /* 1792269 */   GIM_Try, /*On fail goto*//*Label 24361*/ GIMT_Encode4(1792355), // Rule ID 12198 //
     /* 1792274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1792285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1792288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1792291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1792294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792320 */     // MIs[0] policy
     /* 1792320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792330 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1792333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792354 */     // GIR_Coverage, 12198,
     /* 1792354 */     GIR_EraseRootFromParent_Done,
     /* 1792355 */   // Label 24361: @1792355
     /* 1792355 */   GIM_Try, /*On fail goto*//*Label 24362*/ GIMT_Encode4(1792441), // Rule ID 12199 //
     /* 1792360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1792371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1792374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1792377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1792380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792406 */     // MIs[0] policy
     /* 1792406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792416 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1792419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792440 */     // GIR_Coverage, 12199,
     /* 1792440 */     GIR_EraseRootFromParent_Done,
     /* 1792441 */   // Label 24362: @1792441
     /* 1792441 */   GIM_Try, /*On fail goto*//*Label 24363*/ GIMT_Encode4(1792527), // Rule ID 12202 //
     /* 1792446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1792457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1792460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1792463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1792466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792492 */     // MIs[0] policy
     /* 1792492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792502 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1792505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792526 */     // GIR_Coverage, 12202,
     /* 1792526 */     GIR_EraseRootFromParent_Done,
     /* 1792527 */   // Label 24363: @1792527
     /* 1792527 */   GIM_Try, /*On fail goto*//*Label 24364*/ GIMT_Encode4(1792613), // Rule ID 12203 //
     /* 1792532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1792543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1792546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1792549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1792552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792578 */     // MIs[0] policy
     /* 1792578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792588 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1792591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792612 */     // GIR_Coverage, 12203,
     /* 1792612 */     GIR_EraseRootFromParent_Done,
     /* 1792613 */   // Label 24364: @1792613
     /* 1792613 */   GIM_Try, /*On fail goto*//*Label 24365*/ GIMT_Encode4(1792699), // Rule ID 12206 //
     /* 1792618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1792629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1792632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1792635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1792638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792664 */     // MIs[0] policy
     /* 1792664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792674 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1792677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792698 */     // GIR_Coverage, 12206,
     /* 1792698 */     GIR_EraseRootFromParent_Done,
     /* 1792699 */   // Label 24365: @1792699
     /* 1792699 */   GIM_Try, /*On fail goto*//*Label 24366*/ GIMT_Encode4(1792785), // Rule ID 12207 //
     /* 1792704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1792715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1792718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1792721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1792724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792750 */     // MIs[0] policy
     /* 1792750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792760 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1792763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792784 */     // GIR_Coverage, 12207,
     /* 1792784 */     GIR_EraseRootFromParent_Done,
     /* 1792785 */   // Label 24366: @1792785
     /* 1792785 */   GIM_Try, /*On fail goto*//*Label 24367*/ GIMT_Encode4(1792871), // Rule ID 12210 //
     /* 1792790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1792801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1792804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1792807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1792810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792836 */     // MIs[0] policy
     /* 1792836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1792849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792870 */     // GIR_Coverage, 12210,
     /* 1792870 */     GIR_EraseRootFromParent_Done,
     /* 1792871 */   // Label 24367: @1792871
     /* 1792871 */   GIM_Try, /*On fail goto*//*Label 24368*/ GIMT_Encode4(1792957), // Rule ID 12211 //
     /* 1792876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1792887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1792890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1792893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1792896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792922 */     // MIs[0] policy
     /* 1792922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792932 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1792935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792956 */     // GIR_Coverage, 12211,
     /* 1792956 */     GIR_EraseRootFromParent_Done,
     /* 1792957 */   // Label 24368: @1792957
     /* 1792957 */   GIM_Try, /*On fail goto*//*Label 24369*/ GIMT_Encode4(1793043), // Rule ID 12214 //
     /* 1792962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1792973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1792976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1792979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1792982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793008 */     // MIs[0] policy
     /* 1793008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793018 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1793021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793042 */     // GIR_Coverage, 12214,
     /* 1793042 */     GIR_EraseRootFromParent_Done,
     /* 1793043 */   // Label 24369: @1793043
     /* 1793043 */   GIM_Try, /*On fail goto*//*Label 24370*/ GIMT_Encode4(1793129), // Rule ID 12215 //
     /* 1793048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1793059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1793062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1793065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1793068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793094 */     // MIs[0] policy
     /* 1793094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793104 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1793107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793128 */     // GIR_Coverage, 12215,
     /* 1793128 */     GIR_EraseRootFromParent_Done,
     /* 1793129 */   // Label 24370: @1793129
     /* 1793129 */   GIM_Try, /*On fail goto*//*Label 24371*/ GIMT_Encode4(1793215), // Rule ID 12218 //
     /* 1793134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1793145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1793148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1793151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1793154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793180 */     // MIs[0] policy
     /* 1793180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793190 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1793193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793214 */     // GIR_Coverage, 12218,
     /* 1793214 */     GIR_EraseRootFromParent_Done,
     /* 1793215 */   // Label 24371: @1793215
     /* 1793215 */   GIM_Try, /*On fail goto*//*Label 24372*/ GIMT_Encode4(1793301), // Rule ID 12219 //
     /* 1793220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1793231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1793234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1793237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1793240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793266 */     // MIs[0] policy
     /* 1793266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1793279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793300 */     // GIR_Coverage, 12219,
     /* 1793300 */     GIR_EraseRootFromParent_Done,
     /* 1793301 */   // Label 24372: @1793301
     /* 1793301 */   GIM_Try, /*On fail goto*//*Label 24373*/ GIMT_Encode4(1793387), // Rule ID 12222 //
     /* 1793306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1793317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1793320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1793323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1793326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793352 */     // MIs[0] policy
     /* 1793352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793362 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1793365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793386 */     // GIR_Coverage, 12222,
     /* 1793386 */     GIR_EraseRootFromParent_Done,
     /* 1793387 */   // Label 24373: @1793387
     /* 1793387 */   GIM_Try, /*On fail goto*//*Label 24374*/ GIMT_Encode4(1793473), // Rule ID 12223 //
     /* 1793392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1793403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1793406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1793409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1793412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793438 */     // MIs[0] policy
     /* 1793438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793448 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1793451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793472 */     // GIR_Coverage, 12223,
     /* 1793472 */     GIR_EraseRootFromParent_Done,
     /* 1793473 */   // Label 24374: @1793473
     /* 1793473 */   GIM_Try, /*On fail goto*//*Label 24375*/ GIMT_Encode4(1793559), // Rule ID 12226 //
     /* 1793478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1793489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1793492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1793495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1793498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793524 */     // MIs[0] policy
     /* 1793524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793534 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1793537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793558 */     // GIR_Coverage, 12226,
     /* 1793558 */     GIR_EraseRootFromParent_Done,
     /* 1793559 */   // Label 24375: @1793559
     /* 1793559 */   GIM_Try, /*On fail goto*//*Label 24376*/ GIMT_Encode4(1793645), // Rule ID 12227 //
     /* 1793564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1793575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1793578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1793581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1793584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793610 */     // MIs[0] policy
     /* 1793610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1793623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793644 */     // GIR_Coverage, 12227,
     /* 1793644 */     GIR_EraseRootFromParent_Done,
     /* 1793645 */   // Label 24376: @1793645
     /* 1793645 */   GIM_Try, /*On fail goto*//*Label 24377*/ GIMT_Encode4(1793731), // Rule ID 12230 //
     /* 1793650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1793661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1793664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1793667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1793670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793696 */     // MIs[0] policy
     /* 1793696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793706 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1793709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793730 */     // GIR_Coverage, 12230,
     /* 1793730 */     GIR_EraseRootFromParent_Done,
     /* 1793731 */   // Label 24377: @1793731
     /* 1793731 */   GIM_Try, /*On fail goto*//*Label 24378*/ GIMT_Encode4(1793817), // Rule ID 12231 //
     /* 1793736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1793747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1793750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1793753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1793756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793782 */     // MIs[0] policy
     /* 1793782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1793795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793816 */     // GIR_Coverage, 12231,
     /* 1793816 */     GIR_EraseRootFromParent_Done,
     /* 1793817 */   // Label 24378: @1793817
     /* 1793817 */   GIM_Try, /*On fail goto*//*Label 24379*/ GIMT_Encode4(1793903), // Rule ID 12234 //
     /* 1793822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1793825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1793833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1793836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1793839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1793842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793868 */     // MIs[0] policy
     /* 1793868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793878 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1793881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793902 */     // GIR_Coverage, 12234,
     /* 1793902 */     GIR_EraseRootFromParent_Done,
     /* 1793903 */   // Label 24379: @1793903
     /* 1793903 */   GIM_Try, /*On fail goto*//*Label 24380*/ GIMT_Encode4(1793989), // Rule ID 12235 //
     /* 1793908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1793911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1793919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1793922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1793925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1793928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793954 */     // MIs[0] policy
     /* 1793954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793964 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1793967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793988 */     // GIR_Coverage, 12235,
     /* 1793988 */     GIR_EraseRootFromParent_Done,
     /* 1793989 */   // Label 24380: @1793989
     /* 1793989 */   GIM_Try, /*On fail goto*//*Label 24381*/ GIMT_Encode4(1794075), // Rule ID 12238 //
     /* 1793994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1794005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1794008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1794011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1794014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794040 */     // MIs[0] policy
     /* 1794040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794050 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1794053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794074 */     // GIR_Coverage, 12238,
     /* 1794074 */     GIR_EraseRootFromParent_Done,
     /* 1794075 */   // Label 24381: @1794075
     /* 1794075 */   GIM_Try, /*On fail goto*//*Label 24382*/ GIMT_Encode4(1794161), // Rule ID 12239 //
     /* 1794080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1794091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1794094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1794097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1794100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794126 */     // MIs[0] policy
     /* 1794126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794136 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1794139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794160 */     // GIR_Coverage, 12239,
     /* 1794160 */     GIR_EraseRootFromParent_Done,
     /* 1794161 */   // Label 24382: @1794161
     /* 1794161 */   GIM_Try, /*On fail goto*//*Label 24383*/ GIMT_Encode4(1794247), // Rule ID 12242 //
     /* 1794166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1794177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1794180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1794183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1794186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794212 */     // MIs[0] policy
     /* 1794212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794222 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1794225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794246 */     // GIR_Coverage, 12242,
     /* 1794246 */     GIR_EraseRootFromParent_Done,
     /* 1794247 */   // Label 24383: @1794247
     /* 1794247 */   GIM_Try, /*On fail goto*//*Label 24384*/ GIMT_Encode4(1794333), // Rule ID 12243 //
     /* 1794252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1794263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1794266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1794269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1794272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794298 */     // MIs[0] policy
     /* 1794298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794308 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1794311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794332 */     // GIR_Coverage, 12243,
     /* 1794332 */     GIR_EraseRootFromParent_Done,
     /* 1794333 */   // Label 24384: @1794333
     /* 1794333 */   GIM_Try, /*On fail goto*//*Label 24385*/ GIMT_Encode4(1794419), // Rule ID 12246 //
     /* 1794338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1794349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1794352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1794355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1794358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1794361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794384 */     // MIs[0] policy
     /* 1794384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794394 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1794397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794418 */     // GIR_Coverage, 12246,
     /* 1794418 */     GIR_EraseRootFromParent_Done,
     /* 1794419 */   // Label 24385: @1794419
     /* 1794419 */   GIM_Try, /*On fail goto*//*Label 24386*/ GIMT_Encode4(1794505), // Rule ID 12247 //
     /* 1794424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1794435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1794438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1794441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1794444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1794447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794470 */     // MIs[0] policy
     /* 1794470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794480 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1794483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794504 */     // GIR_Coverage, 12247,
     /* 1794504 */     GIR_EraseRootFromParent_Done,
     /* 1794505 */   // Label 24386: @1794505
     /* 1794505 */   GIM_Try, /*On fail goto*//*Label 24387*/ GIMT_Encode4(1794591), // Rule ID 12250 //
     /* 1794510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1794521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1794524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1794527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1794530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794556 */     // MIs[0] policy
     /* 1794556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794566 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1794569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794590 */     // GIR_Coverage, 12250,
     /* 1794590 */     GIR_EraseRootFromParent_Done,
     /* 1794591 */   // Label 24387: @1794591
     /* 1794591 */   GIM_Try, /*On fail goto*//*Label 24388*/ GIMT_Encode4(1794677), // Rule ID 12251 //
     /* 1794596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1794607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1794610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1794613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1794616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794642 */     // MIs[0] policy
     /* 1794642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1794655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794676 */     // GIR_Coverage, 12251,
     /* 1794676 */     GIR_EraseRootFromParent_Done,
     /* 1794677 */   // Label 24388: @1794677
     /* 1794677 */   GIM_Try, /*On fail goto*//*Label 24389*/ GIMT_Encode4(1794763), // Rule ID 12254 //
     /* 1794682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1794693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1794696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1794699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1794702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794728 */     // MIs[0] policy
     /* 1794728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794738 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1794741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794762 */     // GIR_Coverage, 12254,
     /* 1794762 */     GIR_EraseRootFromParent_Done,
     /* 1794763 */   // Label 24389: @1794763
     /* 1794763 */   GIM_Try, /*On fail goto*//*Label 24390*/ GIMT_Encode4(1794849), // Rule ID 12255 //
     /* 1794768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1794779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1794782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1794785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1794788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794814 */     // MIs[0] policy
     /* 1794814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794824 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1794827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794848 */     // GIR_Coverage, 12255,
     /* 1794848 */     GIR_EraseRootFromParent_Done,
     /* 1794849 */   // Label 24390: @1794849
     /* 1794849 */   GIM_Try, /*On fail goto*//*Label 24391*/ GIMT_Encode4(1794935), // Rule ID 12258 //
     /* 1794854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1794865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1794868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1794871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1794874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794900 */     // MIs[0] policy
     /* 1794900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794910 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1794913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794934 */     // GIR_Coverage, 12258,
     /* 1794934 */     GIR_EraseRootFromParent_Done,
     /* 1794935 */   // Label 24391: @1794935
     /* 1794935 */   GIM_Try, /*On fail goto*//*Label 24392*/ GIMT_Encode4(1795021), // Rule ID 12259 //
     /* 1794940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1794951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1794954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1794957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1794960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794986 */     // MIs[0] policy
     /* 1794986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794996 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1794999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795020 */     // GIR_Coverage, 12259,
     /* 1795020 */     GIR_EraseRootFromParent_Done,
     /* 1795021 */   // Label 24392: @1795021
     /* 1795021 */   GIM_Try, /*On fail goto*//*Label 24393*/ GIMT_Encode4(1795107), // Rule ID 12262 //
     /* 1795026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1795037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1795040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1795046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795072 */     // MIs[0] policy
     /* 1795072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1795085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795106 */     // GIR_Coverage, 12262,
     /* 1795106 */     GIR_EraseRootFromParent_Done,
     /* 1795107 */   // Label 24393: @1795107
     /* 1795107 */   GIM_Try, /*On fail goto*//*Label 24394*/ GIMT_Encode4(1795193), // Rule ID 12263 //
     /* 1795112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1795123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1795126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1795132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795158 */     // MIs[0] policy
     /* 1795158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795168 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1795171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795192 */     // GIR_Coverage, 12263,
     /* 1795192 */     GIR_EraseRootFromParent_Done,
     /* 1795193 */   // Label 24394: @1795193
     /* 1795193 */   GIM_Try, /*On fail goto*//*Label 24395*/ GIMT_Encode4(1795279), // Rule ID 12266 //
     /* 1795198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1795209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1795212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1795215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1795218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795244 */     // MIs[0] policy
     /* 1795244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1795257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795278 */     // GIR_Coverage, 12266,
     /* 1795278 */     GIR_EraseRootFromParent_Done,
     /* 1795279 */   // Label 24395: @1795279
     /* 1795279 */   GIM_Try, /*On fail goto*//*Label 24396*/ GIMT_Encode4(1795365), // Rule ID 12267 //
     /* 1795284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1795295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1795298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1795301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1795304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795330 */     // MIs[0] policy
     /* 1795330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795340 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1795343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795364 */     // GIR_Coverage, 12267,
     /* 1795364 */     GIR_EraseRootFromParent_Done,
     /* 1795365 */   // Label 24396: @1795365
     /* 1795365 */   GIM_Try, /*On fail goto*//*Label 24397*/ GIMT_Encode4(1795451), // Rule ID 12270 //
     /* 1795370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1795381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1795384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1795387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1795390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795416 */     // MIs[0] policy
     /* 1795416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795426 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1795429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795450 */     // GIR_Coverage, 12270,
     /* 1795450 */     GIR_EraseRootFromParent_Done,
     /* 1795451 */   // Label 24397: @1795451
     /* 1795451 */   GIM_Try, /*On fail goto*//*Label 24398*/ GIMT_Encode4(1795537), // Rule ID 12271 //
     /* 1795456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1795467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1795470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1795473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1795476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795502 */     // MIs[0] policy
     /* 1795502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795512 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1795515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795536 */     // GIR_Coverage, 12271,
     /* 1795536 */     GIR_EraseRootFromParent_Done,
     /* 1795537 */   // Label 24398: @1795537
     /* 1795537 */   GIM_Try, /*On fail goto*//*Label 24399*/ GIMT_Encode4(1795623), // Rule ID 12274 //
     /* 1795542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1795545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1795553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1795556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1795559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1795562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1795565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795588 */     // MIs[0] policy
     /* 1795588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795598 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1795601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795622 */     // GIR_Coverage, 12274,
     /* 1795622 */     GIR_EraseRootFromParent_Done,
     /* 1795623 */   // Label 24399: @1795623
     /* 1795623 */   GIM_Try, /*On fail goto*//*Label 24400*/ GIMT_Encode4(1795709), // Rule ID 12275 //
     /* 1795628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1795631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1795639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1795642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1795645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1795648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1795651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795674 */     // MIs[0] policy
     /* 1795674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795684 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1795687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795708 */     // GIR_Coverage, 12275,
     /* 1795708 */     GIR_EraseRootFromParent_Done,
     /* 1795709 */   // Label 24400: @1795709
     /* 1795709 */   GIM_Try, /*On fail goto*//*Label 24401*/ GIMT_Encode4(1795795), // Rule ID 12278 //
     /* 1795714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1795717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1795725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1795728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1795731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1795734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795760 */     // MIs[0] policy
     /* 1795760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795770 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1795773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795794 */     // GIR_Coverage, 12278,
     /* 1795794 */     GIR_EraseRootFromParent_Done,
     /* 1795795 */   // Label 24401: @1795795
     /* 1795795 */   GIM_Try, /*On fail goto*//*Label 24402*/ GIMT_Encode4(1795881), // Rule ID 12279 //
     /* 1795800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1795803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1795811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1795814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1795817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1795820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795846 */     // MIs[0] policy
     /* 1795846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795856 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1795859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795880 */     // GIR_Coverage, 12279,
     /* 1795880 */     GIR_EraseRootFromParent_Done,
     /* 1795881 */   // Label 24402: @1795881
     /* 1795881 */   GIM_Try, /*On fail goto*//*Label 24403*/ GIMT_Encode4(1795967), // Rule ID 12282 //
     /* 1795886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1795889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1795897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1795900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1795903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1795906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795932 */     // MIs[0] policy
     /* 1795932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1795945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795966 */     // GIR_Coverage, 12282,
     /* 1795966 */     GIR_EraseRootFromParent_Done,
     /* 1795967 */   // Label 24403: @1795967
     /* 1795967 */   GIM_Try, /*On fail goto*//*Label 24404*/ GIMT_Encode4(1796053), // Rule ID 12283 //
     /* 1795972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1795975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1795983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1795986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1795989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1795992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796018 */     // MIs[0] policy
     /* 1796018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796028 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1796031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796052 */     // GIR_Coverage, 12283,
     /* 1796052 */     GIR_EraseRootFromParent_Done,
     /* 1796053 */   // Label 24404: @1796053
     /* 1796053 */   GIM_Try, /*On fail goto*//*Label 24405*/ GIMT_Encode4(1796139), // Rule ID 12286 //
     /* 1796058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1796069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1796072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1796075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796104 */     // MIs[0] policy
     /* 1796104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796114 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1796117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796138 */     // GIR_Coverage, 12286,
     /* 1796138 */     GIR_EraseRootFromParent_Done,
     /* 1796139 */   // Label 24405: @1796139
     /* 1796139 */   GIM_Try, /*On fail goto*//*Label 24406*/ GIMT_Encode4(1796225), // Rule ID 12287 //
     /* 1796144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1796155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1796158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1796161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796190 */     // MIs[0] policy
     /* 1796190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796200 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1796203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796224 */     // GIR_Coverage, 12287,
     /* 1796224 */     GIR_EraseRootFromParent_Done,
     /* 1796225 */   // Label 24406: @1796225
     /* 1796225 */   GIM_Try, /*On fail goto*//*Label 24407*/ GIMT_Encode4(1796311), // Rule ID 12290 //
     /* 1796230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1796241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1796244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1796247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796276 */     // MIs[0] policy
     /* 1796276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796286 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1796289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796310 */     // GIR_Coverage, 12290,
     /* 1796310 */     GIR_EraseRootFromParent_Done,
     /* 1796311 */   // Label 24407: @1796311
     /* 1796311 */   GIM_Try, /*On fail goto*//*Label 24408*/ GIMT_Encode4(1796397), // Rule ID 12291 //
     /* 1796316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1796327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1796330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1796333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796362 */     // MIs[0] policy
     /* 1796362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796372 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1796375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796396 */     // GIR_Coverage, 12291,
     /* 1796396 */     GIR_EraseRootFromParent_Done,
     /* 1796397 */   // Label 24408: @1796397
     /* 1796397 */   GIM_Try, /*On fail goto*//*Label 24409*/ GIMT_Encode4(1796483), // Rule ID 12294 //
     /* 1796402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1796413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1796416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1796419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796448 */     // MIs[0] policy
     /* 1796448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796458 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1796461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796482 */     // GIR_Coverage, 12294,
     /* 1796482 */     GIR_EraseRootFromParent_Done,
     /* 1796483 */   // Label 24409: @1796483
     /* 1796483 */   GIM_Try, /*On fail goto*//*Label 24410*/ GIMT_Encode4(1796569), // Rule ID 12295 //
     /* 1796488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1796499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1796502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1796505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796534 */     // MIs[0] policy
     /* 1796534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796544 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1796547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796568 */     // GIR_Coverage, 12295,
     /* 1796568 */     GIR_EraseRootFromParent_Done,
     /* 1796569 */   // Label 24410: @1796569
     /* 1796569 */   GIM_Try, /*On fail goto*//*Label 24411*/ GIMT_Encode4(1796655), // Rule ID 12298 //
     /* 1796574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1796585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1796588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1796591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796620 */     // MIs[0] policy
     /* 1796620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1796633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796654 */     // GIR_Coverage, 12298,
     /* 1796654 */     GIR_EraseRootFromParent_Done,
     /* 1796655 */   // Label 24411: @1796655
     /* 1796655 */   GIM_Try, /*On fail goto*//*Label 24412*/ GIMT_Encode4(1796741), // Rule ID 12299 //
     /* 1796660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1796671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1796674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1796677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796706 */     // MIs[0] policy
     /* 1796706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796716 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1796719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796740 */     // GIR_Coverage, 12299,
     /* 1796740 */     GIR_EraseRootFromParent_Done,
     /* 1796741 */   // Label 24412: @1796741
     /* 1796741 */   GIM_Try, /*On fail goto*//*Label 24413*/ GIMT_Encode4(1796827), // Rule ID 12302 //
     /* 1796746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1796757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1796760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1796763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796792 */     // MIs[0] policy
     /* 1796792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796802 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1796805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796826 */     // GIR_Coverage, 12302,
     /* 1796826 */     GIR_EraseRootFromParent_Done,
     /* 1796827 */   // Label 24413: @1796827
     /* 1796827 */   GIM_Try, /*On fail goto*//*Label 24414*/ GIMT_Encode4(1796913), // Rule ID 12303 //
     /* 1796832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1796843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1796846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1796849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796878 */     // MIs[0] policy
     /* 1796878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796888 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1796891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796912 */     // GIR_Coverage, 12303,
     /* 1796912 */     GIR_EraseRootFromParent_Done,
     /* 1796913 */   // Label 24414: @1796913
     /* 1796913 */   GIM_Try, /*On fail goto*//*Label 24415*/ GIMT_Encode4(1796999), // Rule ID 12306 //
     /* 1796918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1796929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1796932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1796935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796964 */     // MIs[0] policy
     /* 1796964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796974 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1796977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1796995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796998 */     // GIR_Coverage, 12306,
     /* 1796998 */     GIR_EraseRootFromParent_Done,
     /* 1796999 */   // Label 24415: @1796999
     /* 1796999 */   GIM_Try, /*On fail goto*//*Label 24416*/ GIMT_Encode4(1797085), // Rule ID 12307 //
     /* 1797004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1797015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1797018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1797021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797050 */     // MIs[0] policy
     /* 1797050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797060 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1797063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797084 */     // GIR_Coverage, 12307,
     /* 1797084 */     GIR_EraseRootFromParent_Done,
     /* 1797085 */   // Label 24416: @1797085
     /* 1797085 */   GIM_Try, /*On fail goto*//*Label 24417*/ GIMT_Encode4(1797171), // Rule ID 12310 //
     /* 1797090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1797101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1797104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1797107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797136 */     // MIs[0] policy
     /* 1797136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797146 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1797149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797170 */     // GIR_Coverage, 12310,
     /* 1797170 */     GIR_EraseRootFromParent_Done,
     /* 1797171 */   // Label 24417: @1797171
     /* 1797171 */   GIM_Try, /*On fail goto*//*Label 24418*/ GIMT_Encode4(1797257), // Rule ID 12311 //
     /* 1797176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1797187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1797190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1797193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797222 */     // MIs[0] policy
     /* 1797222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1797235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797256 */     // GIR_Coverage, 12311,
     /* 1797256 */     GIR_EraseRootFromParent_Done,
     /* 1797257 */   // Label 24418: @1797257
     /* 1797257 */   GIM_Try, /*On fail goto*//*Label 24419*/ GIMT_Encode4(1797343), // Rule ID 12314 //
     /* 1797262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1797273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1797276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797308 */     // MIs[0] policy
     /* 1797308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1797321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797342 */     // GIR_Coverage, 12314,
     /* 1797342 */     GIR_EraseRootFromParent_Done,
     /* 1797343 */   // Label 24419: @1797343
     /* 1797343 */   GIM_Try, /*On fail goto*//*Label 24420*/ GIMT_Encode4(1797429), // Rule ID 12315 //
     /* 1797348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1797359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1797362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797394 */     // MIs[0] policy
     /* 1797394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797404 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1797407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797428 */     // GIR_Coverage, 12315,
     /* 1797428 */     GIR_EraseRootFromParent_Done,
     /* 1797429 */   // Label 24420: @1797429
     /* 1797429 */   GIM_Try, /*On fail goto*//*Label 24421*/ GIMT_Encode4(1797515), // Rule ID 12318 //
     /* 1797434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797480 */     // MIs[0] policy
     /* 1797480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1797493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797514 */     // GIR_Coverage, 12318,
     /* 1797514 */     GIR_EraseRootFromParent_Done,
     /* 1797515 */   // Label 24421: @1797515
     /* 1797515 */   GIM_Try, /*On fail goto*//*Label 24422*/ GIMT_Encode4(1797601), // Rule ID 12319 //
     /* 1797520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797566 */     // MIs[0] policy
     /* 1797566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1797579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797600 */     // GIR_Coverage, 12319,
     /* 1797600 */     GIR_EraseRootFromParent_Done,
     /* 1797601 */   // Label 24422: @1797601
     /* 1797601 */   GIM_Try, /*On fail goto*//*Label 24423*/ GIMT_Encode4(1797687), // Rule ID 12322 //
     /* 1797606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1797609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1797617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1797620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1797623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797652 */     // MIs[0] policy
     /* 1797652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797662 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1797665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797686 */     // GIR_Coverage, 12322,
     /* 1797686 */     GIR_EraseRootFromParent_Done,
     /* 1797687 */   // Label 24423: @1797687
     /* 1797687 */   GIM_Try, /*On fail goto*//*Label 24424*/ GIMT_Encode4(1797773), // Rule ID 12323 //
     /* 1797692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1797695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1797703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1797706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1797709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797738 */     // MIs[0] policy
     /* 1797738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797748 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1797751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797772 */     // GIR_Coverage, 12323,
     /* 1797772 */     GIR_EraseRootFromParent_Done,
     /* 1797773 */   // Label 24424: @1797773
     /* 1797773 */   GIM_Try, /*On fail goto*//*Label 24425*/ GIMT_Encode4(1797859), // Rule ID 12326 //
     /* 1797778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1797789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1797792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1797795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1797801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1797808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797824 */     // MIs[0] policy
     /* 1797824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797834 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1797837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797858 */     // GIR_Coverage, 12326,
     /* 1797858 */     GIR_EraseRootFromParent_Done,
     /* 1797859 */   // Label 24425: @1797859
     /* 1797859 */   GIM_Try, /*On fail goto*//*Label 24426*/ GIMT_Encode4(1797945), // Rule ID 12327 //
     /* 1797864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1797875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1797878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1797881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1797887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1797894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797910 */     // MIs[0] policy
     /* 1797910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797920 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1797923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797944 */     // GIR_Coverage, 12327,
     /* 1797944 */     GIR_EraseRootFromParent_Done,
     /* 1797945 */   // Label 24426: @1797945
     /* 1797945 */   GIM_Try, /*On fail goto*//*Label 24427*/ GIMT_Encode4(1798031), // Rule ID 12330 //
     /* 1797950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1797961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1797964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1797967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1797973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1797980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1797984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1797988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797996 */     // MIs[0] policy
     /* 1797996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798006 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1798009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798030 */     // GIR_Coverage, 12330,
     /* 1798030 */     GIR_EraseRootFromParent_Done,
     /* 1798031 */   // Label 24427: @1798031
     /* 1798031 */   GIM_Try, /*On fail goto*//*Label 24428*/ GIMT_Encode4(1798117), // Rule ID 12331 //
     /* 1798036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1798047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1798050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1798053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798082 */     // MIs[0] policy
     /* 1798082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798092 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1798095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798116 */     // GIR_Coverage, 12331,
     /* 1798116 */     GIR_EraseRootFromParent_Done,
     /* 1798117 */   // Label 24428: @1798117
     /* 1798117 */   GIM_Try, /*On fail goto*//*Label 24429*/ GIMT_Encode4(1798203), // Rule ID 12334 //
     /* 1798122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1798133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1798136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1798139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1798145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798168 */     // MIs[0] policy
     /* 1798168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798178 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1798181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798202 */     // GIR_Coverage, 12334,
     /* 1798202 */     GIR_EraseRootFromParent_Done,
     /* 1798203 */   // Label 24429: @1798203
     /* 1798203 */   GIM_Try, /*On fail goto*//*Label 24430*/ GIMT_Encode4(1798289), // Rule ID 12335 //
     /* 1798208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1798219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1798222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1798225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1798231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798254 */     // MIs[0] policy
     /* 1798254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798264 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1798267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798288 */     // GIR_Coverage, 12335,
     /* 1798288 */     GIR_EraseRootFromParent_Done,
     /* 1798289 */   // Label 24430: @1798289
     /* 1798289 */   GIM_Try, /*On fail goto*//*Label 24431*/ GIMT_Encode4(1798375), // Rule ID 12338 //
     /* 1798294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1798311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798340 */     // MIs[0] policy
     /* 1798340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1798353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798374 */     // GIR_Coverage, 12338,
     /* 1798374 */     GIR_EraseRootFromParent_Done,
     /* 1798375 */   // Label 24431: @1798375
     /* 1798375 */   GIM_Try, /*On fail goto*//*Label 24432*/ GIMT_Encode4(1798461), // Rule ID 12339 //
     /* 1798380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1798397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798426 */     // MIs[0] policy
     /* 1798426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798436 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1798439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798460 */     // GIR_Coverage, 12339,
     /* 1798460 */     GIR_EraseRootFromParent_Done,
     /* 1798461 */   // Label 24432: @1798461
     /* 1798461 */   GIM_Try, /*On fail goto*//*Label 24433*/ GIMT_Encode4(1798547), // Rule ID 12342 //
     /* 1798466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1798477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1798480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1798483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798512 */     // MIs[0] policy
     /* 1798512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798522 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1798525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798546 */     // GIR_Coverage, 12342,
     /* 1798546 */     GIR_EraseRootFromParent_Done,
     /* 1798547 */   // Label 24433: @1798547
     /* 1798547 */   GIM_Try, /*On fail goto*//*Label 24434*/ GIMT_Encode4(1798633), // Rule ID 12343 //
     /* 1798552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1798563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1798566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1798569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798598 */     // MIs[0] policy
     /* 1798598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798608 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1798611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798632 */     // GIR_Coverage, 12343,
     /* 1798632 */     GIR_EraseRootFromParent_Done,
     /* 1798633 */   // Label 24434: @1798633
     /* 1798633 */   GIM_Try, /*On fail goto*//*Label 24435*/ GIMT_Encode4(1798719), // Rule ID 12346 //
     /* 1798638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1798649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1798652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1798655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798684 */     // MIs[0] policy
     /* 1798684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798694 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1798697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798718 */     // GIR_Coverage, 12346,
     /* 1798718 */     GIR_EraseRootFromParent_Done,
     /* 1798719 */   // Label 24435: @1798719
     /* 1798719 */   GIM_Try, /*On fail goto*//*Label 24436*/ GIMT_Encode4(1798805), // Rule ID 12347 //
     /* 1798724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1798735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1798738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1798741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798770 */     // MIs[0] policy
     /* 1798770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798780 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1798783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798804 */     // GIR_Coverage, 12347,
     /* 1798804 */     GIR_EraseRootFromParent_Done,
     /* 1798805 */   // Label 24436: @1798805
     /* 1798805 */   GIM_Try, /*On fail goto*//*Label 24437*/ GIMT_Encode4(1798891), // Rule ID 12350 //
     /* 1798810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1798821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1798824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1798827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798856 */     // MIs[0] policy
     /* 1798856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1798869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798890 */     // GIR_Coverage, 12350,
     /* 1798890 */     GIR_EraseRootFromParent_Done,
     /* 1798891 */   // Label 24437: @1798891
     /* 1798891 */   GIM_Try, /*On fail goto*//*Label 24438*/ GIMT_Encode4(1798977), // Rule ID 12351 //
     /* 1798896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1798907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1798910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1798913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798942 */     // MIs[0] policy
     /* 1798942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798952 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1798955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798976 */     // GIR_Coverage, 12351,
     /* 1798976 */     GIR_EraseRootFromParent_Done,
     /* 1798977 */   // Label 24438: @1798977
     /* 1798977 */   GIM_Try, /*On fail goto*//*Label 24439*/ GIMT_Encode4(1799063), // Rule ID 12354 //
     /* 1798982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1798993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1798996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1798999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799028 */     // MIs[0] policy
     /* 1799028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799038 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1799041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799062 */     // GIR_Coverage, 12354,
     /* 1799062 */     GIR_EraseRootFromParent_Done,
     /* 1799063 */   // Label 24439: @1799063
     /* 1799063 */   GIM_Try, /*On fail goto*//*Label 24440*/ GIMT_Encode4(1799149), // Rule ID 12355 //
     /* 1799068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1799079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1799082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1799085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799114 */     // MIs[0] policy
     /* 1799114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799124 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1799127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799148 */     // GIR_Coverage, 12355,
     /* 1799148 */     GIR_EraseRootFromParent_Done,
     /* 1799149 */   // Label 24440: @1799149
     /* 1799149 */   GIM_Try, /*On fail goto*//*Label 24441*/ GIMT_Encode4(1799235), // Rule ID 12358 //
     /* 1799154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1799165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1799168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1799171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799200 */     // MIs[0] policy
     /* 1799200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799210 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1799213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799234 */     // GIR_Coverage, 12358,
     /* 1799234 */     GIR_EraseRootFromParent_Done,
     /* 1799235 */   // Label 24441: @1799235
     /* 1799235 */   GIM_Try, /*On fail goto*//*Label 24442*/ GIMT_Encode4(1799321), // Rule ID 12359 //
     /* 1799240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1799251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1799254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1799257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799286 */     // MIs[0] policy
     /* 1799286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799296 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1799299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799320 */     // GIR_Coverage, 12359,
     /* 1799320 */     GIR_EraseRootFromParent_Done,
     /* 1799321 */   // Label 24442: @1799321
     /* 1799321 */   GIM_Try, /*On fail goto*//*Label 24443*/ GIMT_Encode4(1799407), // Rule ID 12362 //
     /* 1799326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1799329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1799337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1799340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1799343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799372 */     // MIs[0] policy
     /* 1799372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1799385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799406 */     // GIR_Coverage, 12362,
     /* 1799406 */     GIR_EraseRootFromParent_Done,
     /* 1799407 */   // Label 24443: @1799407
     /* 1799407 */   GIM_Try, /*On fail goto*//*Label 24444*/ GIMT_Encode4(1799493), // Rule ID 12363 //
     /* 1799412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1799415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1799423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1799426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1799429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799458 */     // MIs[0] policy
     /* 1799458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1799471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799492 */     // GIR_Coverage, 12363,
     /* 1799492 */     GIR_EraseRootFromParent_Done,
     /* 1799493 */   // Label 24444: @1799493
     /* 1799493 */   GIM_Try, /*On fail goto*//*Label 24445*/ GIMT_Encode4(1799579), // Rule ID 12366 //
     /* 1799498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1799501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1799509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1799512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1799515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799544 */     // MIs[0] policy
     /* 1799544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799554 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1799557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799578 */     // GIR_Coverage, 12366,
     /* 1799578 */     GIR_EraseRootFromParent_Done,
     /* 1799579 */   // Label 24445: @1799579
     /* 1799579 */   GIM_Try, /*On fail goto*//*Label 24446*/ GIMT_Encode4(1799665), // Rule ID 12367 //
     /* 1799584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1799587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1799595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1799598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1799601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799630 */     // MIs[0] policy
     /* 1799630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799640 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1799643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799664 */     // GIR_Coverage, 12367,
     /* 1799664 */     GIR_EraseRootFromParent_Done,
     /* 1799665 */   // Label 24446: @1799665
     /* 1799665 */   GIM_Try, /*On fail goto*//*Label 24447*/ GIMT_Encode4(1799751), // Rule ID 12370 //
     /* 1799670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1799673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1799681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1799684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1799687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799716 */     // MIs[0] policy
     /* 1799716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799726 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1799729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799750 */     // GIR_Coverage, 12370,
     /* 1799750 */     GIR_EraseRootFromParent_Done,
     /* 1799751 */   // Label 24447: @1799751
     /* 1799751 */   GIM_Try, /*On fail goto*//*Label 24448*/ GIMT_Encode4(1799837), // Rule ID 12371 //
     /* 1799756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1799759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1799767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1799770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1799773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799802 */     // MIs[0] policy
     /* 1799802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799812 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1799815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799836 */     // GIR_Coverage, 12371,
     /* 1799836 */     GIR_EraseRootFromParent_Done,
     /* 1799837 */   // Label 24448: @1799837
     /* 1799837 */   GIM_Try, /*On fail goto*//*Label 24449*/ GIMT_Encode4(1799923), // Rule ID 12374 //
     /* 1799842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1799853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1799856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1799859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1799862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799888 */     // MIs[0] policy
     /* 1799888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799898 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1799901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1799919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799922 */     // GIR_Coverage, 12374,
     /* 1799922 */     GIR_EraseRootFromParent_Done,
     /* 1799923 */   // Label 24449: @1799923
     /* 1799923 */   GIM_Try, /*On fail goto*//*Label 24450*/ GIMT_Encode4(1800009), // Rule ID 12375 //
     /* 1799928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1799939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1799942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1799945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1799948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799974 */     // MIs[0] policy
     /* 1799974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799984 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1799987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800008 */     // GIR_Coverage, 12375,
     /* 1800008 */     GIR_EraseRootFromParent_Done,
     /* 1800009 */   // Label 24450: @1800009
     /* 1800009 */   GIM_Try, /*On fail goto*//*Label 24451*/ GIMT_Encode4(1800095), // Rule ID 12378 //
     /* 1800014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1800025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1800028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1800031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1800034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800060 */     // MIs[0] policy
     /* 1800060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800070 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1800073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800094 */     // GIR_Coverage, 12378,
     /* 1800094 */     GIR_EraseRootFromParent_Done,
     /* 1800095 */   // Label 24451: @1800095
     /* 1800095 */   GIM_Try, /*On fail goto*//*Label 24452*/ GIMT_Encode4(1800181), // Rule ID 12379 //
     /* 1800100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1800111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1800114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1800117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1800120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800146 */     // MIs[0] policy
     /* 1800146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800156 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1800159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800180 */     // GIR_Coverage, 12379,
     /* 1800180 */     GIR_EraseRootFromParent_Done,
     /* 1800181 */   // Label 24452: @1800181
     /* 1800181 */   GIM_Try, /*On fail goto*//*Label 24453*/ GIMT_Encode4(1800267), // Rule ID 12382 //
     /* 1800186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1800197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1800200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1800203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1800206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800232 */     // MIs[0] policy
     /* 1800232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800242 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1800245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800266 */     // GIR_Coverage, 12382,
     /* 1800266 */     GIR_EraseRootFromParent_Done,
     /* 1800267 */   // Label 24453: @1800267
     /* 1800267 */   GIM_Try, /*On fail goto*//*Label 24454*/ GIMT_Encode4(1800353), // Rule ID 12383 //
     /* 1800272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1800283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1800286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1800289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1800292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800318 */     // MIs[0] policy
     /* 1800318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800328 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1800331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800352 */     // GIR_Coverage, 12383,
     /* 1800352 */     GIR_EraseRootFromParent_Done,
     /* 1800353 */   // Label 24454: @1800353
     /* 1800353 */   GIM_Try, /*On fail goto*//*Label 24455*/ GIMT_Encode4(1800439), // Rule ID 12386 //
     /* 1800358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1800369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1800372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1800375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1800378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800404 */     // MIs[0] policy
     /* 1800404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800414 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1800417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800438 */     // GIR_Coverage, 12386,
     /* 1800438 */     GIR_EraseRootFromParent_Done,
     /* 1800439 */   // Label 24455: @1800439
     /* 1800439 */   GIM_Try, /*On fail goto*//*Label 24456*/ GIMT_Encode4(1800525), // Rule ID 12387 //
     /* 1800444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1800455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1800458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1800461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1800464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800490 */     // MIs[0] policy
     /* 1800490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800500 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1800503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800524 */     // GIR_Coverage, 12387,
     /* 1800524 */     GIR_EraseRootFromParent_Done,
     /* 1800525 */   // Label 24456: @1800525
     /* 1800525 */   GIM_Try, /*On fail goto*//*Label 24457*/ GIMT_Encode4(1800611), // Rule ID 12390 //
     /* 1800530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1800541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1800544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1800547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1800550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1800553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1800560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800576 */     // MIs[0] policy
     /* 1800576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800586 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1800589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800610 */     // GIR_Coverage, 12390,
     /* 1800610 */     GIR_EraseRootFromParent_Done,
     /* 1800611 */   // Label 24457: @1800611
     /* 1800611 */   GIM_Try, /*On fail goto*//*Label 24458*/ GIMT_Encode4(1800697), // Rule ID 12391 //
     /* 1800616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1800627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1800630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1800633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1800636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1800639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1800646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800662 */     // MIs[0] policy
     /* 1800662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800672 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1800675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800696 */     // GIR_Coverage, 12391,
     /* 1800696 */     GIR_EraseRootFromParent_Done,
     /* 1800697 */   // Label 24458: @1800697
     /* 1800697 */   GIM_Try, /*On fail goto*//*Label 24459*/ GIMT_Encode4(1800783), // Rule ID 12394 //
     /* 1800702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1800713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1800716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1800719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1800722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1800725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800748 */     // MIs[0] policy
     /* 1800748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800758 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1800761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800782 */     // GIR_Coverage, 12394,
     /* 1800782 */     GIR_EraseRootFromParent_Done,
     /* 1800783 */   // Label 24459: @1800783
     /* 1800783 */   GIM_Try, /*On fail goto*//*Label 24460*/ GIMT_Encode4(1800869), // Rule ID 12395 //
     /* 1800788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1800799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1800802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1800805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1800808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1800811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800834 */     // MIs[0] policy
     /* 1800834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800844 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1800847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800868 */     // GIR_Coverage, 12395,
     /* 1800868 */     GIR_EraseRootFromParent_Done,
     /* 1800869 */   // Label 24460: @1800869
     /* 1800869 */   GIM_Try, /*On fail goto*//*Label 24461*/ GIMT_Encode4(1800955), // Rule ID 12398 //
     /* 1800874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1800885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1800888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1800891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1800894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800920 */     // MIs[0] policy
     /* 1800920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800930 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1800933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800954 */     // GIR_Coverage, 12398,
     /* 1800954 */     GIR_EraseRootFromParent_Done,
     /* 1800955 */   // Label 24461: @1800955
     /* 1800955 */   GIM_Try, /*On fail goto*//*Label 24462*/ GIMT_Encode4(1801041), // Rule ID 12399 //
     /* 1800960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1800971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1800974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1800977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1800980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801006 */     // MIs[0] policy
     /* 1801006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1801019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801040 */     // GIR_Coverage, 12399,
     /* 1801040 */     GIR_EraseRootFromParent_Done,
     /* 1801041 */   // Label 24462: @1801041
     /* 1801041 */   GIM_Try, /*On fail goto*//*Label 24463*/ GIMT_Encode4(1801127), // Rule ID 12402 //
     /* 1801046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1801057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1801060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1801063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1801066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801092 */     // MIs[0] policy
     /* 1801092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801102 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1801105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801126 */     // GIR_Coverage, 12402,
     /* 1801126 */     GIR_EraseRootFromParent_Done,
     /* 1801127 */   // Label 24463: @1801127
     /* 1801127 */   GIM_Try, /*On fail goto*//*Label 24464*/ GIMT_Encode4(1801213), // Rule ID 12403 //
     /* 1801132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1801143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1801146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1801149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1801152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801178 */     // MIs[0] policy
     /* 1801178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801188 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1801191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801212 */     // GIR_Coverage, 12403,
     /* 1801212 */     GIR_EraseRootFromParent_Done,
     /* 1801213 */   // Label 24464: @1801213
     /* 1801213 */   GIM_Try, /*On fail goto*//*Label 24465*/ GIMT_Encode4(1801299), // Rule ID 12406 //
     /* 1801218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1801229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1801232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1801235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1801238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801264 */     // MIs[0] policy
     /* 1801264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1801277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801298 */     // GIR_Coverage, 12406,
     /* 1801298 */     GIR_EraseRootFromParent_Done,
     /* 1801299 */   // Label 24465: @1801299
     /* 1801299 */   GIM_Try, /*On fail goto*//*Label 24466*/ GIMT_Encode4(1801385), // Rule ID 12407 //
     /* 1801304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1801315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1801318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1801321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1801324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801350 */     // MIs[0] policy
     /* 1801350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801360 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1801363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801384 */     // GIR_Coverage, 12407,
     /* 1801384 */     GIR_EraseRootFromParent_Done,
     /* 1801385 */   // Label 24466: @1801385
     /* 1801385 */   GIM_Try, /*On fail goto*//*Label 24467*/ GIMT_Encode4(1801471), // Rule ID 12410 //
     /* 1801390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1801401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1801404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1801407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1801410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801436 */     // MIs[0] policy
     /* 1801436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1801449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801470 */     // GIR_Coverage, 12410,
     /* 1801470 */     GIR_EraseRootFromParent_Done,
     /* 1801471 */   // Label 24467: @1801471
     /* 1801471 */   GIM_Try, /*On fail goto*//*Label 24468*/ GIMT_Encode4(1801557), // Rule ID 12411 //
     /* 1801476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1801487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1801490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1801493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1801496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801522 */     // MIs[0] policy
     /* 1801522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801532 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1801535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801556 */     // GIR_Coverage, 12411,
     /* 1801556 */     GIR_EraseRootFromParent_Done,
     /* 1801557 */   // Label 24468: @1801557
     /* 1801557 */   GIM_Try, /*On fail goto*//*Label 24469*/ GIMT_Encode4(1801643), // Rule ID 12414 //
     /* 1801562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1801573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1801576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1801579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1801582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801608 */     // MIs[0] policy
     /* 1801608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1801621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801642 */     // GIR_Coverage, 12414,
     /* 1801642 */     GIR_EraseRootFromParent_Done,
     /* 1801643 */   // Label 24469: @1801643
     /* 1801643 */   GIM_Try, /*On fail goto*//*Label 24470*/ GIMT_Encode4(1801729), // Rule ID 12415 //
     /* 1801648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1801659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1801662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1801665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1801668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801694 */     // MIs[0] policy
     /* 1801694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801704 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1801707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801728 */     // GIR_Coverage, 12415,
     /* 1801728 */     GIR_EraseRootFromParent_Done,
     /* 1801729 */   // Label 24470: @1801729
     /* 1801729 */   GIM_Try, /*On fail goto*//*Label 24471*/ GIMT_Encode4(1801815), // Rule ID 12418 //
     /* 1801734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1801737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1801745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1801748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1801751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1801754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801780 */     // MIs[0] policy
     /* 1801780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1801793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801814 */     // GIR_Coverage, 12418,
     /* 1801814 */     GIR_EraseRootFromParent_Done,
     /* 1801815 */   // Label 24471: @1801815
     /* 1801815 */   GIM_Try, /*On fail goto*//*Label 24472*/ GIMT_Encode4(1801901), // Rule ID 12419 //
     /* 1801820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1801823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1801831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1801834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1801837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1801840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801866 */     // MIs[0] policy
     /* 1801866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1801879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801900 */     // GIR_Coverage, 12419,
     /* 1801900 */     GIR_EraseRootFromParent_Done,
     /* 1801901 */   // Label 24472: @1801901
     /* 1801901 */   GIM_Try, /*On fail goto*//*Label 24473*/ GIMT_Encode4(1801987), // Rule ID 12422 //
     /* 1801906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1801909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1801917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1801920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1801923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1801926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801952 */     // MIs[0] policy
     /* 1801952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801962 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1801965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801986 */     // GIR_Coverage, 12422,
     /* 1801986 */     GIR_EraseRootFromParent_Done,
     /* 1801987 */   // Label 24473: @1801987
     /* 1801987 */   GIM_Try, /*On fail goto*//*Label 24474*/ GIMT_Encode4(1802073), // Rule ID 12423 //
     /* 1801992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1801995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1802003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1802006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1802009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1802012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802038 */     // MIs[0] policy
     /* 1802038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802048 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1802051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802072 */     // GIR_Coverage, 12423,
     /* 1802072 */     GIR_EraseRootFromParent_Done,
     /* 1802073 */   // Label 24474: @1802073
     /* 1802073 */   GIM_Try, /*On fail goto*//*Label 24475*/ GIMT_Encode4(1802159), // Rule ID 12426 //
     /* 1802078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1802089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1802092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1802095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1802098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802124 */     // MIs[0] policy
     /* 1802124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802134 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1802137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802158 */     // GIR_Coverage, 12426,
     /* 1802158 */     GIR_EraseRootFromParent_Done,
     /* 1802159 */   // Label 24475: @1802159
     /* 1802159 */   GIM_Try, /*On fail goto*//*Label 24476*/ GIMT_Encode4(1802245), // Rule ID 12427 //
     /* 1802164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1802175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1802178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1802181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1802184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802210 */     // MIs[0] policy
     /* 1802210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802220 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1802223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802244 */     // GIR_Coverage, 12427,
     /* 1802244 */     GIR_EraseRootFromParent_Done,
     /* 1802245 */   // Label 24476: @1802245
     /* 1802245 */   GIM_Try, /*On fail goto*//*Label 24477*/ GIMT_Encode4(1802331), // Rule ID 12430 //
     /* 1802250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1802261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1802264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1802267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1802270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802296 */     // MIs[0] policy
     /* 1802296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1802309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802330 */     // GIR_Coverage, 12430,
     /* 1802330 */     GIR_EraseRootFromParent_Done,
     /* 1802331 */   // Label 24477: @1802331
     /* 1802331 */   GIM_Try, /*On fail goto*//*Label 24478*/ GIMT_Encode4(1802417), // Rule ID 12431 //
     /* 1802336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1802347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1802350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1802353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1802356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802382 */     // MIs[0] policy
     /* 1802382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802392 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1802395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802416 */     // GIR_Coverage, 12431,
     /* 1802416 */     GIR_EraseRootFromParent_Done,
     /* 1802417 */   // Label 24478: @1802417
     /* 1802417 */   GIM_Try, /*On fail goto*//*Label 24479*/ GIMT_Encode4(1802503), // Rule ID 12434 //
     /* 1802422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1802433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1802436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1802439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802468 */     // MIs[0] policy
     /* 1802468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802478 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1802481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802502 */     // GIR_Coverage, 12434,
     /* 1802502 */     GIR_EraseRootFromParent_Done,
     /* 1802503 */   // Label 24479: @1802503
     /* 1802503 */   GIM_Try, /*On fail goto*//*Label 24480*/ GIMT_Encode4(1802589), // Rule ID 12435 //
     /* 1802508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1802519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1802522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1802525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802554 */     // MIs[0] policy
     /* 1802554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802564 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1802567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802588 */     // GIR_Coverage, 12435,
     /* 1802588 */     GIR_EraseRootFromParent_Done,
     /* 1802589 */   // Label 24480: @1802589
     /* 1802589 */   GIM_Try, /*On fail goto*//*Label 24481*/ GIMT_Encode4(1802675), // Rule ID 12438 //
     /* 1802594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1802605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1802608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1802611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802640 */     // MIs[0] policy
     /* 1802640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802650 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1802653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802674 */     // GIR_Coverage, 12438,
     /* 1802674 */     GIR_EraseRootFromParent_Done,
     /* 1802675 */   // Label 24481: @1802675
     /* 1802675 */   GIM_Try, /*On fail goto*//*Label 24482*/ GIMT_Encode4(1802761), // Rule ID 12439 //
     /* 1802680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1802691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1802694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1802697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802726 */     // MIs[0] policy
     /* 1802726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802736 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1802739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802760 */     // GIR_Coverage, 12439,
     /* 1802760 */     GIR_EraseRootFromParent_Done,
     /* 1802761 */   // Label 24482: @1802761
     /* 1802761 */   GIM_Try, /*On fail goto*//*Label 24483*/ GIMT_Encode4(1802847), // Rule ID 12442 //
     /* 1802766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1802777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1802780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1802783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802812 */     // MIs[0] policy
     /* 1802812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802822 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1802825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802846 */     // GIR_Coverage, 12442,
     /* 1802846 */     GIR_EraseRootFromParent_Done,
     /* 1802847 */   // Label 24483: @1802847
     /* 1802847 */   GIM_Try, /*On fail goto*//*Label 24484*/ GIMT_Encode4(1802933), // Rule ID 12443 //
     /* 1802852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1802863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1802866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1802869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802898 */     // MIs[0] policy
     /* 1802898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802908 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1802911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802932 */     // GIR_Coverage, 12443,
     /* 1802932 */     GIR_EraseRootFromParent_Done,
     /* 1802933 */   // Label 24484: @1802933
     /* 1802933 */   GIM_Try, /*On fail goto*//*Label 24485*/ GIMT_Encode4(1803019), // Rule ID 12446 //
     /* 1802938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1802949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1802952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1802955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802984 */     // MIs[0] policy
     /* 1802984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1802997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803018 */     // GIR_Coverage, 12446,
     /* 1803018 */     GIR_EraseRootFromParent_Done,
     /* 1803019 */   // Label 24485: @1803019
     /* 1803019 */   GIM_Try, /*On fail goto*//*Label 24486*/ GIMT_Encode4(1803105), // Rule ID 12447 //
     /* 1803024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1803035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1803038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1803041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803070 */     // MIs[0] policy
     /* 1803070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803080 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1803083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803104 */     // GIR_Coverage, 12447,
     /* 1803104 */     GIR_EraseRootFromParent_Done,
     /* 1803105 */   // Label 24486: @1803105
     /* 1803105 */   GIM_Try, /*On fail goto*//*Label 24487*/ GIMT_Encode4(1803191), // Rule ID 12450 //
     /* 1803110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1803121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1803124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1803127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803156 */     // MIs[0] policy
     /* 1803156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803166 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1803169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803190 */     // GIR_Coverage, 12450,
     /* 1803190 */     GIR_EraseRootFromParent_Done,
     /* 1803191 */   // Label 24487: @1803191
     /* 1803191 */   GIM_Try, /*On fail goto*//*Label 24488*/ GIMT_Encode4(1803277), // Rule ID 12451 //
     /* 1803196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1803207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1803210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1803213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803242 */     // MIs[0] policy
     /* 1803242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803252 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1803255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803276 */     // GIR_Coverage, 12451,
     /* 1803276 */     GIR_EraseRootFromParent_Done,
     /* 1803277 */   // Label 24488: @1803277
     /* 1803277 */   GIM_Try, /*On fail goto*//*Label 24489*/ GIMT_Encode4(1803363), // Rule ID 12454 //
     /* 1803282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1803293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1803296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1803299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1803305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803328 */     // MIs[0] policy
     /* 1803328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803338 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1803341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803362 */     // GIR_Coverage, 12454,
     /* 1803362 */     GIR_EraseRootFromParent_Done,
     /* 1803363 */   // Label 24489: @1803363
     /* 1803363 */   GIM_Try, /*On fail goto*//*Label 24490*/ GIMT_Encode4(1803449), // Rule ID 12455 //
     /* 1803368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1803379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1803382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1803385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1803391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803414 */     // MIs[0] policy
     /* 1803414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803424 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1803427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803448 */     // GIR_Coverage, 12455,
     /* 1803448 */     GIR_EraseRootFromParent_Done,
     /* 1803449 */   // Label 24490: @1803449
     /* 1803449 */   GIM_Try, /*On fail goto*//*Label 24491*/ GIMT_Encode4(1803535), // Rule ID 12458 //
     /* 1803454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1803465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1803468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1803471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1803477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803500 */     // MIs[0] policy
     /* 1803500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803510 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1803513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803534 */     // GIR_Coverage, 12458,
     /* 1803534 */     GIR_EraseRootFromParent_Done,
     /* 1803535 */   // Label 24491: @1803535
     /* 1803535 */   GIM_Try, /*On fail goto*//*Label 24492*/ GIMT_Encode4(1803621), // Rule ID 12459 //
     /* 1803540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1803551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1803554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1803557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1803563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803586 */     // MIs[0] policy
     /* 1803586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803596 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1803599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803620 */     // GIR_Coverage, 12459,
     /* 1803620 */     GIR_EraseRootFromParent_Done,
     /* 1803621 */   // Label 24492: @1803621
     /* 1803621 */   GIM_Try, /*On fail goto*//*Label 24493*/ GIMT_Encode4(1803707), // Rule ID 12462 //
     /* 1803626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1803637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1803640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1803643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803672 */     // MIs[0] policy
     /* 1803672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1803685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803706 */     // GIR_Coverage, 12462,
     /* 1803706 */     GIR_EraseRootFromParent_Done,
     /* 1803707 */   // Label 24493: @1803707
     /* 1803707 */   GIM_Try, /*On fail goto*//*Label 24494*/ GIMT_Encode4(1803793), // Rule ID 12463 //
     /* 1803712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1803723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1803726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1803729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803758 */     // MIs[0] policy
     /* 1803758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803768 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1803771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803792 */     // GIR_Coverage, 12463,
     /* 1803792 */     GIR_EraseRootFromParent_Done,
     /* 1803793 */   // Label 24494: @1803793
     /* 1803793 */   GIM_Try, /*On fail goto*//*Label 24495*/ GIMT_Encode4(1803879), // Rule ID 12466 //
     /* 1803798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1803809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1803812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1803815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803844 */     // MIs[0] policy
     /* 1803844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1803857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803878 */     // GIR_Coverage, 12466,
     /* 1803878 */     GIR_EraseRootFromParent_Done,
     /* 1803879 */   // Label 24495: @1803879
     /* 1803879 */   GIM_Try, /*On fail goto*//*Label 24496*/ GIMT_Encode4(1803965), // Rule ID 12467 //
     /* 1803884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1803895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1803898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1803901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803930 */     // MIs[0] policy
     /* 1803930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1803943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803964 */     // GIR_Coverage, 12467,
     /* 1803964 */     GIR_EraseRootFromParent_Done,
     /* 1803965 */   // Label 24496: @1803965
     /* 1803965 */   GIM_Try, /*On fail goto*//*Label 24497*/ GIMT_Encode4(1804051), // Rule ID 12470 //
     /* 1803970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1803981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1803984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1803987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804016 */     // MIs[0] policy
     /* 1804016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804026 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1804029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804050 */     // GIR_Coverage, 12470,
     /* 1804050 */     GIR_EraseRootFromParent_Done,
     /* 1804051 */   // Label 24497: @1804051
     /* 1804051 */   GIM_Try, /*On fail goto*//*Label 24498*/ GIMT_Encode4(1804137), // Rule ID 12471 //
     /* 1804056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1804067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1804070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1804073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804102 */     // MIs[0] policy
     /* 1804102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1804115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804136 */     // GIR_Coverage, 12471,
     /* 1804136 */     GIR_EraseRootFromParent_Done,
     /* 1804137 */   // Label 24498: @1804137
     /* 1804137 */   GIM_Try, /*On fail goto*//*Label 24499*/ GIMT_Encode4(1804223), // Rule ID 12474 //
     /* 1804142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1804153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1804156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1804159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804188 */     // MIs[0] policy
     /* 1804188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1804201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804222 */     // GIR_Coverage, 12474,
     /* 1804222 */     GIR_EraseRootFromParent_Done,
     /* 1804223 */   // Label 24499: @1804223
     /* 1804223 */   GIM_Try, /*On fail goto*//*Label 24500*/ GIMT_Encode4(1804309), // Rule ID 12475 //
     /* 1804228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1804239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1804242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1804245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804274 */     // MIs[0] policy
     /* 1804274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804284 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1804287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804308 */     // GIR_Coverage, 12475,
     /* 1804308 */     GIR_EraseRootFromParent_Done,
     /* 1804309 */   // Label 24500: @1804309
     /* 1804309 */   GIM_Try, /*On fail goto*//*Label 24501*/ GIMT_Encode4(1804395), // Rule ID 12478 //
     /* 1804314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1804325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1804328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1804331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804360 */     // MIs[0] policy
     /* 1804360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804370 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1804373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804394 */     // GIR_Coverage, 12478,
     /* 1804394 */     GIR_EraseRootFromParent_Done,
     /* 1804395 */   // Label 24501: @1804395
     /* 1804395 */   GIM_Try, /*On fail goto*//*Label 24502*/ GIMT_Encode4(1804481), // Rule ID 12479 //
     /* 1804400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1804403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1804411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1804414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1804417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804446 */     // MIs[0] policy
     /* 1804446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804456 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1804459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804480 */     // GIR_Coverage, 12479,
     /* 1804480 */     GIR_EraseRootFromParent_Done,
     /* 1804481 */   // Label 24502: @1804481
     /* 1804481 */   GIM_Try, /*On fail goto*//*Label 24503*/ GIMT_Encode4(1804567), // Rule ID 12482 //
     /* 1804486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1804497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1804500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1804503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804532 */     // MIs[0] policy
     /* 1804532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1804545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804566 */     // GIR_Coverage, 12482,
     /* 1804566 */     GIR_EraseRootFromParent_Done,
     /* 1804567 */   // Label 24503: @1804567
     /* 1804567 */   GIM_Try, /*On fail goto*//*Label 24504*/ GIMT_Encode4(1804653), // Rule ID 12483 //
     /* 1804572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1804575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1804583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1804586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1804589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804618 */     // MIs[0] policy
     /* 1804618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1804631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804652 */     // GIR_Coverage, 12483,
     /* 1804652 */     GIR_EraseRootFromParent_Done,
     /* 1804653 */   // Label 24504: @1804653
     /* 1804653 */   GIM_Try, /*On fail goto*//*Label 24505*/ GIMT_Encode4(1804739), // Rule ID 12486 //
     /* 1804658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1804669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1804672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1804675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804704 */     // MIs[0] policy
     /* 1804704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804714 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1804717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804738 */     // GIR_Coverage, 12486,
     /* 1804738 */     GIR_EraseRootFromParent_Done,
     /* 1804739 */   // Label 24505: @1804739
     /* 1804739 */   GIM_Try, /*On fail goto*//*Label 24506*/ GIMT_Encode4(1804825), // Rule ID 12487 //
     /* 1804744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1804747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1804755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1804758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1804761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804790 */     // MIs[0] policy
     /* 1804790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804800 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1804803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804824 */     // GIR_Coverage, 12487,
     /* 1804824 */     GIR_EraseRootFromParent_Done,
     /* 1804825 */   // Label 24506: @1804825
     /* 1804825 */   GIM_Try, /*On fail goto*//*Label 24507*/ GIMT_Encode4(1804911), // Rule ID 12490 //
     /* 1804830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1804841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1804844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1804847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804876 */     // MIs[0] policy
     /* 1804876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1804889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804910 */     // GIR_Coverage, 12490,
     /* 1804910 */     GIR_EraseRootFromParent_Done,
     /* 1804911 */   // Label 24507: @1804911
     /* 1804911 */   GIM_Try, /*On fail goto*//*Label 24508*/ GIMT_Encode4(1804997), // Rule ID 12491 //
     /* 1804916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1804919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1804927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1804930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1804933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804962 */     // MIs[0] policy
     /* 1804962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804972 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1804975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804996 */     // GIR_Coverage, 12491,
     /* 1804996 */     GIR_EraseRootFromParent_Done,
     /* 1804997 */   // Label 24508: @1804997
     /* 1804997 */   GIM_Try, /*On fail goto*//*Label 24509*/ GIMT_Encode4(1805083), // Rule ID 12494 //
     /* 1805002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1805013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1805016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1805019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1805022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805048 */     // MIs[0] policy
     /* 1805048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805058 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1805061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805082 */     // GIR_Coverage, 12494,
     /* 1805082 */     GIR_EraseRootFromParent_Done,
     /* 1805083 */   // Label 24509: @1805083
     /* 1805083 */   GIM_Try, /*On fail goto*//*Label 24510*/ GIMT_Encode4(1805169), // Rule ID 12495 //
     /* 1805088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1805099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1805102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1805105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1805108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805134 */     // MIs[0] policy
     /* 1805134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805144 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1805147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805168 */     // GIR_Coverage, 12495,
     /* 1805168 */     GIR_EraseRootFromParent_Done,
     /* 1805169 */   // Label 24510: @1805169
     /* 1805169 */   GIM_Try, /*On fail goto*//*Label 24511*/ GIMT_Encode4(1805255), // Rule ID 12498 //
     /* 1805174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1805185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1805188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1805191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1805194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805220 */     // MIs[0] policy
     /* 1805220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805230 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1805233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805254 */     // GIR_Coverage, 12498,
     /* 1805254 */     GIR_EraseRootFromParent_Done,
     /* 1805255 */   // Label 24511: @1805255
     /* 1805255 */   GIM_Try, /*On fail goto*//*Label 24512*/ GIMT_Encode4(1805341), // Rule ID 12499 //
     /* 1805260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1805271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1805274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1805277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1805280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805306 */     // MIs[0] policy
     /* 1805306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805316 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1805319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805340 */     // GIR_Coverage, 12499,
     /* 1805340 */     GIR_EraseRootFromParent_Done,
     /* 1805341 */   // Label 24512: @1805341
     /* 1805341 */   GIM_Try, /*On fail goto*//*Label 24513*/ GIMT_Encode4(1805427), // Rule ID 12502 //
     /* 1805346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1805357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1805360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1805363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1805366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805392 */     // MIs[0] policy
     /* 1805392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1805405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805426 */     // GIR_Coverage, 12502,
     /* 1805426 */     GIR_EraseRootFromParent_Done,
     /* 1805427 */   // Label 24513: @1805427
     /* 1805427 */   GIM_Try, /*On fail goto*//*Label 24514*/ GIMT_Encode4(1805513), // Rule ID 12503 //
     /* 1805432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1805443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1805446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1805449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1805452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805478 */     // MIs[0] policy
     /* 1805478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805488 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1805491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805512 */     // GIR_Coverage, 12503,
     /* 1805512 */     GIR_EraseRootFromParent_Done,
     /* 1805513 */   // Label 24514: @1805513
     /* 1805513 */   GIM_Try, /*On fail goto*//*Label 24515*/ GIMT_Encode4(1805599), // Rule ID 12506 //
     /* 1805518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1805529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1805532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1805535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1805538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805564 */     // MIs[0] policy
     /* 1805564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805574 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1805577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805598 */     // GIR_Coverage, 12506,
     /* 1805598 */     GIR_EraseRootFromParent_Done,
     /* 1805599 */   // Label 24515: @1805599
     /* 1805599 */   GIM_Try, /*On fail goto*//*Label 24516*/ GIMT_Encode4(1805685), // Rule ID 12507 //
     /* 1805604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1805615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1805618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1805621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1805624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805650 */     // MIs[0] policy
     /* 1805650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1805663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805684 */     // GIR_Coverage, 12507,
     /* 1805684 */     GIR_EraseRootFromParent_Done,
     /* 1805685 */   // Label 24516: @1805685
     /* 1805685 */   GIM_Try, /*On fail goto*//*Label 24517*/ GIMT_Encode4(1805771), // Rule ID 12510 //
     /* 1805690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1805701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1805704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1805707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1805710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1805713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805736 */     // MIs[0] policy
     /* 1805736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805746 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1805749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805770 */     // GIR_Coverage, 12510,
     /* 1805770 */     GIR_EraseRootFromParent_Done,
     /* 1805771 */   // Label 24517: @1805771
     /* 1805771 */   GIM_Try, /*On fail goto*//*Label 24518*/ GIMT_Encode4(1805857), // Rule ID 12511 //
     /* 1805776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1805787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1805790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1805793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1805796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1805799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805822 */     // MIs[0] policy
     /* 1805822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805832 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1805835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805856 */     // GIR_Coverage, 12511,
     /* 1805856 */     GIR_EraseRootFromParent_Done,
     /* 1805857 */   // Label 24518: @1805857
     /* 1805857 */   GIM_Try, /*On fail goto*//*Label 24519*/ GIMT_Encode4(1805943), // Rule ID 12514 //
     /* 1805862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1805873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1805876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1805879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1805882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1805885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805908 */     // MIs[0] policy
     /* 1805908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805918 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1805921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805942 */     // GIR_Coverage, 12514,
     /* 1805942 */     GIR_EraseRootFromParent_Done,
     /* 1805943 */   // Label 24519: @1805943
     /* 1805943 */   GIM_Try, /*On fail goto*//*Label 24520*/ GIMT_Encode4(1806029), // Rule ID 12515 //
     /* 1805948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1805959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1805962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1805965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1805968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1805971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805994 */     // MIs[0] policy
     /* 1805994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806004 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1806007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806028 */     // GIR_Coverage, 12515,
     /* 1806028 */     GIR_EraseRootFromParent_Done,
     /* 1806029 */   // Label 24520: @1806029
     /* 1806029 */   GIM_Try, /*On fail goto*//*Label 24521*/ GIMT_Encode4(1806115), // Rule ID 12518 //
     /* 1806034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1806045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1806048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1806051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1806054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806080 */     // MIs[0] policy
     /* 1806080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806090 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1806093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806114 */     // GIR_Coverage, 12518,
     /* 1806114 */     GIR_EraseRootFromParent_Done,
     /* 1806115 */   // Label 24521: @1806115
     /* 1806115 */   GIM_Try, /*On fail goto*//*Label 24522*/ GIMT_Encode4(1806201), // Rule ID 12519 //
     /* 1806120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1806131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1806134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1806137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1806140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806166 */     // MIs[0] policy
     /* 1806166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1806179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806200 */     // GIR_Coverage, 12519,
     /* 1806200 */     GIR_EraseRootFromParent_Done,
     /* 1806201 */   // Label 24522: @1806201
     /* 1806201 */   GIM_Try, /*On fail goto*//*Label 24523*/ GIMT_Encode4(1806287), // Rule ID 12522 //
     /* 1806206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1806217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1806220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1806223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1806226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806252 */     // MIs[0] policy
     /* 1806252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806262 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1806265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806286 */     // GIR_Coverage, 12522,
     /* 1806286 */     GIR_EraseRootFromParent_Done,
     /* 1806287 */   // Label 24523: @1806287
     /* 1806287 */   GIM_Try, /*On fail goto*//*Label 24524*/ GIMT_Encode4(1806373), // Rule ID 12523 //
     /* 1806292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1806303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1806306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1806309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1806312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806338 */     // MIs[0] policy
     /* 1806338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806348 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1806351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806372 */     // GIR_Coverage, 12523,
     /* 1806372 */     GIR_EraseRootFromParent_Done,
     /* 1806373 */   // Label 24524: @1806373
     /* 1806373 */   GIM_Try, /*On fail goto*//*Label 24525*/ GIMT_Encode4(1806459), // Rule ID 12526 //
     /* 1806378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1806389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1806392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1806395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1806398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806424 */     // MIs[0] policy
     /* 1806424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1806437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806458 */     // GIR_Coverage, 12526,
     /* 1806458 */     GIR_EraseRootFromParent_Done,
     /* 1806459 */   // Label 24525: @1806459
     /* 1806459 */   GIM_Try, /*On fail goto*//*Label 24526*/ GIMT_Encode4(1806545), // Rule ID 12527 //
     /* 1806464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1806475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1806478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1806481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1806484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806510 */     // MIs[0] policy
     /* 1806510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806520 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1806523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806544 */     // GIR_Coverage, 12527,
     /* 1806544 */     GIR_EraseRootFromParent_Done,
     /* 1806545 */   // Label 24526: @1806545
     /* 1806545 */   GIM_Try, /*On fail goto*//*Label 24527*/ GIMT_Encode4(1806631), // Rule ID 12530 //
     /* 1806550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1806561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1806564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1806567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1806570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806596 */     // MIs[0] policy
     /* 1806596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1806609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806630 */     // GIR_Coverage, 12530,
     /* 1806630 */     GIR_EraseRootFromParent_Done,
     /* 1806631 */   // Label 24527: @1806631
     /* 1806631 */   GIM_Try, /*On fail goto*//*Label 24528*/ GIMT_Encode4(1806717), // Rule ID 12531 //
     /* 1806636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1806647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1806650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1806653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1806656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806682 */     // MIs[0] policy
     /* 1806682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806692 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1806695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806716 */     // GIR_Coverage, 12531,
     /* 1806716 */     GIR_EraseRootFromParent_Done,
     /* 1806717 */   // Label 24528: @1806717
     /* 1806717 */   GIM_Try, /*On fail goto*//*Label 24529*/ GIMT_Encode4(1806803), // Rule ID 12534 //
     /* 1806722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1806733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1806736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1806739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1806742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806768 */     // MIs[0] policy
     /* 1806768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806778 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1806781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806802 */     // GIR_Coverage, 12534,
     /* 1806802 */     GIR_EraseRootFromParent_Done,
     /* 1806803 */   // Label 24529: @1806803
     /* 1806803 */   GIM_Try, /*On fail goto*//*Label 24530*/ GIMT_Encode4(1806889), // Rule ID 12535 //
     /* 1806808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1806819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1806822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1806825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1806828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806854 */     // MIs[0] policy
     /* 1806854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1806867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806888 */     // GIR_Coverage, 12535,
     /* 1806888 */     GIR_EraseRootFromParent_Done,
     /* 1806889 */   // Label 24530: @1806889
     /* 1806889 */   GIM_Try, /*On fail goto*//*Label 24531*/ GIMT_Encode4(1806975), // Rule ID 12538 //
     /* 1806894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1806897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1806905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1806908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1806911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1806914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806940 */     // MIs[0] policy
     /* 1806940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806950 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1806953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1806971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806974 */     // GIR_Coverage, 12538,
     /* 1806974 */     GIR_EraseRootFromParent_Done,
     /* 1806975 */   // Label 24531: @1806975
     /* 1806975 */   GIM_Try, /*On fail goto*//*Label 24532*/ GIMT_Encode4(1807061), // Rule ID 12539 //
     /* 1806980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1806983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1806991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1806994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1806997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1807000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807026 */     // MIs[0] policy
     /* 1807026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807036 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1807039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807060 */     // GIR_Coverage, 12539,
     /* 1807060 */     GIR_EraseRootFromParent_Done,
     /* 1807061 */   // Label 24532: @1807061
     /* 1807061 */   GIM_Try, /*On fail goto*//*Label 24533*/ GIMT_Encode4(1807147), // Rule ID 12542 //
     /* 1807066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1807077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1807080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1807083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1807086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807112 */     // MIs[0] policy
     /* 1807112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1807125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807146 */     // GIR_Coverage, 12542,
     /* 1807146 */     GIR_EraseRootFromParent_Done,
     /* 1807147 */   // Label 24533: @1807147
     /* 1807147 */   GIM_Try, /*On fail goto*//*Label 24534*/ GIMT_Encode4(1807233), // Rule ID 12543 //
     /* 1807152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1807163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1807166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1807169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1807172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807198 */     // MIs[0] policy
     /* 1807198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807208 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1807211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807232 */     // GIR_Coverage, 12543,
     /* 1807232 */     GIR_EraseRootFromParent_Done,
     /* 1807233 */   // Label 24534: @1807233
     /* 1807233 */   GIM_Try, /*On fail goto*//*Label 24535*/ GIMT_Encode4(1807319), // Rule ID 12546 //
     /* 1807238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1807249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1807252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1807255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1807258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807284 */     // MIs[0] policy
     /* 1807284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807294 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1807297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807318 */     // GIR_Coverage, 12546,
     /* 1807318 */     GIR_EraseRootFromParent_Done,
     /* 1807319 */   // Label 24535: @1807319
     /* 1807319 */   GIM_Try, /*On fail goto*//*Label 24536*/ GIMT_Encode4(1807405), // Rule ID 12547 //
     /* 1807324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1807335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1807338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1807341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1807344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807370 */     // MIs[0] policy
     /* 1807370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807380 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1807383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807404 */     // GIR_Coverage, 12547,
     /* 1807404 */     GIR_EraseRootFromParent_Done,
     /* 1807405 */   // Label 24536: @1807405
     /* 1807405 */   GIM_Try, /*On fail goto*//*Label 24537*/ GIMT_Encode4(1807491), // Rule ID 12550 //
     /* 1807410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1807421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1807424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1807427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1807430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807456 */     // MIs[0] policy
     /* 1807456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807466 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1807469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807490 */     // GIR_Coverage, 12550,
     /* 1807490 */     GIR_EraseRootFromParent_Done,
     /* 1807491 */   // Label 24537: @1807491
     /* 1807491 */   GIM_Try, /*On fail goto*//*Label 24538*/ GIMT_Encode4(1807577), // Rule ID 12551 //
     /* 1807496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1807507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1807510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1807513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1807516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807542 */     // MIs[0] policy
     /* 1807542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807552 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1807555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807576 */     // GIR_Coverage, 12551,
     /* 1807576 */     GIR_EraseRootFromParent_Done,
     /* 1807577 */   // Label 24538: @1807577
     /* 1807577 */   GIM_Try, /*On fail goto*//*Label 24539*/ GIMT_Encode4(1807663), // Rule ID 12554 //
     /* 1807582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1807593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1807596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1807599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807628 */     // MIs[0] policy
     /* 1807628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807638 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1807641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807662 */     // GIR_Coverage, 12554,
     /* 1807662 */     GIR_EraseRootFromParent_Done,
     /* 1807663 */   // Label 24539: @1807663
     /* 1807663 */   GIM_Try, /*On fail goto*//*Label 24540*/ GIMT_Encode4(1807749), // Rule ID 12555 //
     /* 1807668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1807679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1807682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1807685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807714 */     // MIs[0] policy
     /* 1807714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807724 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1807727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807748 */     // GIR_Coverage, 12555,
     /* 1807748 */     GIR_EraseRootFromParent_Done,
     /* 1807749 */   // Label 24540: @1807749
     /* 1807749 */   GIM_Try, /*On fail goto*//*Label 24541*/ GIMT_Encode4(1807835), // Rule ID 12558 //
     /* 1807754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1807765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1807768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1807771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807800 */     // MIs[0] policy
     /* 1807800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807810 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1807813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807834 */     // GIR_Coverage, 12558,
     /* 1807834 */     GIR_EraseRootFromParent_Done,
     /* 1807835 */   // Label 24541: @1807835
     /* 1807835 */   GIM_Try, /*On fail goto*//*Label 24542*/ GIMT_Encode4(1807921), // Rule ID 12559 //
     /* 1807840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1807851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1807854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1807857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807886 */     // MIs[0] policy
     /* 1807886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1807899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807920 */     // GIR_Coverage, 12559,
     /* 1807920 */     GIR_EraseRootFromParent_Done,
     /* 1807921 */   // Label 24542: @1807921
     /* 1807921 */   GIM_Try, /*On fail goto*//*Label 24543*/ GIMT_Encode4(1808007), // Rule ID 12562 //
     /* 1807926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1807937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1807940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1807943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807972 */     // MIs[0] policy
     /* 1807972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807982 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1807985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808006 */     // GIR_Coverage, 12562,
     /* 1808006 */     GIR_EraseRootFromParent_Done,
     /* 1808007 */   // Label 24543: @1808007
     /* 1808007 */   GIM_Try, /*On fail goto*//*Label 24544*/ GIMT_Encode4(1808093), // Rule ID 12563 //
     /* 1808012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1808023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1808026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1808029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808058 */     // MIs[0] policy
     /* 1808058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1808071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808092 */     // GIR_Coverage, 12563,
     /* 1808092 */     GIR_EraseRootFromParent_Done,
     /* 1808093 */   // Label 24544: @1808093
     /* 1808093 */   GIM_Try, /*On fail goto*//*Label 24545*/ GIMT_Encode4(1808179), // Rule ID 12566 //
     /* 1808098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1808109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1808112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1808115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808144 */     // MIs[0] policy
     /* 1808144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808154 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1808157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808178 */     // GIR_Coverage, 12566,
     /* 1808178 */     GIR_EraseRootFromParent_Done,
     /* 1808179 */   // Label 24545: @1808179
     /* 1808179 */   GIM_Try, /*On fail goto*//*Label 24546*/ GIMT_Encode4(1808265), // Rule ID 12567 //
     /* 1808184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1808195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1808198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1808201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808230 */     // MIs[0] policy
     /* 1808230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808240 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1808243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808264 */     // GIR_Coverage, 12567,
     /* 1808264 */     GIR_EraseRootFromParent_Done,
     /* 1808265 */   // Label 24546: @1808265
     /* 1808265 */   GIM_Try, /*On fail goto*//*Label 24547*/ GIMT_Encode4(1808351), // Rule ID 12570 //
     /* 1808270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1808281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1808284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1808287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1808293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808316 */     // MIs[0] policy
     /* 1808316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808326 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1808329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808350 */     // GIR_Coverage, 12570,
     /* 1808350 */     GIR_EraseRootFromParent_Done,
     /* 1808351 */   // Label 24547: @1808351
     /* 1808351 */   GIM_Try, /*On fail goto*//*Label 24548*/ GIMT_Encode4(1808437), // Rule ID 12571 //
     /* 1808356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1808367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1808370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1808373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1808379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808402 */     // MIs[0] policy
     /* 1808402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808412 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1808415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808436 */     // GIR_Coverage, 12571,
     /* 1808436 */     GIR_EraseRootFromParent_Done,
     /* 1808437 */   // Label 24548: @1808437
     /* 1808437 */   GIM_Try, /*On fail goto*//*Label 24549*/ GIMT_Encode4(1808523), // Rule ID 12574 //
     /* 1808442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1808453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1808456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1808459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1808465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808488 */     // MIs[0] policy
     /* 1808488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808498 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1808501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808522 */     // GIR_Coverage, 12574,
     /* 1808522 */     GIR_EraseRootFromParent_Done,
     /* 1808523 */   // Label 24549: @1808523
     /* 1808523 */   GIM_Try, /*On fail goto*//*Label 24550*/ GIMT_Encode4(1808609), // Rule ID 12575 //
     /* 1808528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1808539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1808542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1808545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1808551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808574 */     // MIs[0] policy
     /* 1808574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808584 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1808587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808608 */     // GIR_Coverage, 12575,
     /* 1808608 */     GIR_EraseRootFromParent_Done,
     /* 1808609 */   // Label 24550: @1808609
     /* 1808609 */   GIM_Try, /*On fail goto*//*Label 24551*/ GIMT_Encode4(1808695), // Rule ID 12578 //
     /* 1808614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1808625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1808628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1808631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808660 */     // MIs[0] policy
     /* 1808660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808670 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1808673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808694 */     // GIR_Coverage, 12578,
     /* 1808694 */     GIR_EraseRootFromParent_Done,
     /* 1808695 */   // Label 24551: @1808695
     /* 1808695 */   GIM_Try, /*On fail goto*//*Label 24552*/ GIMT_Encode4(1808781), // Rule ID 12579 //
     /* 1808700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1808711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1808714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1808717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808746 */     // MIs[0] policy
     /* 1808746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808756 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1808759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808780 */     // GIR_Coverage, 12579,
     /* 1808780 */     GIR_EraseRootFromParent_Done,
     /* 1808781 */   // Label 24552: @1808781
     /* 1808781 */   GIM_Try, /*On fail goto*//*Label 24553*/ GIMT_Encode4(1808867), // Rule ID 12582 //
     /* 1808786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1808797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1808800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1808803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808832 */     // MIs[0] policy
     /* 1808832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1808845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808866 */     // GIR_Coverage, 12582,
     /* 1808866 */     GIR_EraseRootFromParent_Done,
     /* 1808867 */   // Label 24553: @1808867
     /* 1808867 */   GIM_Try, /*On fail goto*//*Label 24554*/ GIMT_Encode4(1808953), // Rule ID 12583 //
     /* 1808872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1808883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1808886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1808889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808918 */     // MIs[0] policy
     /* 1808918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808928 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1808931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808952 */     // GIR_Coverage, 12583,
     /* 1808952 */     GIR_EraseRootFromParent_Done,
     /* 1808953 */   // Label 24554: @1808953
     /* 1808953 */   GIM_Try, /*On fail goto*//*Label 24555*/ GIMT_Encode4(1809039), // Rule ID 12586 //
     /* 1808958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1808969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1808972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1808975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809004 */     // MIs[0] policy
     /* 1809004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1809017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809038 */     // GIR_Coverage, 12586,
     /* 1809038 */     GIR_EraseRootFromParent_Done,
     /* 1809039 */   // Label 24555: @1809039
     /* 1809039 */   GIM_Try, /*On fail goto*//*Label 24556*/ GIMT_Encode4(1809125), // Rule ID 12587 //
     /* 1809044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1809055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1809058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1809061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809090 */     // MIs[0] policy
     /* 1809090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1809103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809124 */     // GIR_Coverage, 12587,
     /* 1809124 */     GIR_EraseRootFromParent_Done,
     /* 1809125 */   // Label 24556: @1809125
     /* 1809125 */   GIM_Try, /*On fail goto*//*Label 24557*/ GIMT_Encode4(1809211), // Rule ID 12590 //
     /* 1809130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1809141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1809144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1809147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809176 */     // MIs[0] policy
     /* 1809176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809186 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1809189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809210 */     // GIR_Coverage, 12590,
     /* 1809210 */     GIR_EraseRootFromParent_Done,
     /* 1809211 */   // Label 24557: @1809211
     /* 1809211 */   GIM_Try, /*On fail goto*//*Label 24558*/ GIMT_Encode4(1809297), // Rule ID 12591 //
     /* 1809216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1809227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1809230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1809233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809262 */     // MIs[0] policy
     /* 1809262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809272 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1809275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809296 */     // GIR_Coverage, 12591,
     /* 1809296 */     GIR_EraseRootFromParent_Done,
     /* 1809297 */   // Label 24558: @1809297
     /* 1809297 */   GIM_Try, /*On fail goto*//*Label 24559*/ GIMT_Encode4(1809383), // Rule ID 12594 //
     /* 1809302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1809313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1809316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1809319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809348 */     // MIs[0] policy
     /* 1809348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809358 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1809361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809382 */     // GIR_Coverage, 12594,
     /* 1809382 */     GIR_EraseRootFromParent_Done,
     /* 1809383 */   // Label 24559: @1809383
     /* 1809383 */   GIM_Try, /*On fail goto*//*Label 24560*/ GIMT_Encode4(1809469), // Rule ID 12595 //
     /* 1809388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1809399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1809402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1809405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809434 */     // MIs[0] policy
     /* 1809434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809444 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1809447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809468 */     // GIR_Coverage, 12595,
     /* 1809468 */     GIR_EraseRootFromParent_Done,
     /* 1809469 */   // Label 24560: @1809469
     /* 1809469 */   GIM_Try, /*On fail goto*//*Label 24561*/ GIMT_Encode4(1809555), // Rule ID 12598 //
     /* 1809474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1809477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1809485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1809488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1809491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809520 */     // MIs[0] policy
     /* 1809520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809530 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1809533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809554 */     // GIR_Coverage, 12598,
     /* 1809554 */     GIR_EraseRootFromParent_Done,
     /* 1809555 */   // Label 24561: @1809555
     /* 1809555 */   GIM_Try, /*On fail goto*//*Label 24562*/ GIMT_Encode4(1809641), // Rule ID 12599 //
     /* 1809560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1809563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1809571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1809574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1809577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809606 */     // MIs[0] policy
     /* 1809606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809616 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1809619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809640 */     // GIR_Coverage, 12599,
     /* 1809640 */     GIR_EraseRootFromParent_Done,
     /* 1809641 */   // Label 24562: @1809641
     /* 1809641 */   GIM_Try, /*On fail goto*//*Label 24563*/ GIMT_Encode4(1809727), // Rule ID 12602 //
     /* 1809646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1809649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1809657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1809660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1809663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809692 */     // MIs[0] policy
     /* 1809692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1809705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809726 */     // GIR_Coverage, 12602,
     /* 1809726 */     GIR_EraseRootFromParent_Done,
     /* 1809727 */   // Label 24563: @1809727
     /* 1809727 */   GIM_Try, /*On fail goto*//*Label 24564*/ GIMT_Encode4(1809813), // Rule ID 12603 //
     /* 1809732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1809735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1809743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1809746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1809749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809778 */     // MIs[0] policy
     /* 1809778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1809791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809812 */     // GIR_Coverage, 12603,
     /* 1809812 */     GIR_EraseRootFromParent_Done,
     /* 1809813 */   // Label 24564: @1809813
     /* 1809813 */   GIM_Try, /*On fail goto*//*Label 24565*/ GIMT_Encode4(1809899), // Rule ID 12606 //
     /* 1809818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1809821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1809829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1809832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1809835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809864 */     // MIs[0] policy
     /* 1809864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1809877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809898 */     // GIR_Coverage, 12606,
     /* 1809898 */     GIR_EraseRootFromParent_Done,
     /* 1809899 */   // Label 24565: @1809899
     /* 1809899 */   GIM_Try, /*On fail goto*//*Label 24566*/ GIMT_Encode4(1809985), // Rule ID 12607 //
     /* 1809904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1809907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1809915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1809918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1809921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809950 */     // MIs[0] policy
     /* 1809950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809960 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1809963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809984 */     // GIR_Coverage, 12607,
     /* 1809984 */     GIR_EraseRootFromParent_Done,
     /* 1809985 */   // Label 24566: @1809985
     /* 1809985 */   GIM_Try, /*On fail goto*//*Label 24567*/ GIMT_Encode4(1810071), // Rule ID 12610 //
     /* 1809990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1809993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1810001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1810004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1810007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1810010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810036 */     // MIs[0] policy
     /* 1810036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1810049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810070 */     // GIR_Coverage, 12610,
     /* 1810070 */     GIR_EraseRootFromParent_Done,
     /* 1810071 */   // Label 24567: @1810071
     /* 1810071 */   GIM_Try, /*On fail goto*//*Label 24568*/ GIMT_Encode4(1810157), // Rule ID 12611 //
     /* 1810076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1810087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1810090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1810093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1810096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810122 */     // MIs[0] policy
     /* 1810122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810132 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1810135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810156 */     // GIR_Coverage, 12611,
     /* 1810156 */     GIR_EraseRootFromParent_Done,
     /* 1810157 */   // Label 24568: @1810157
     /* 1810157 */   GIM_Try, /*On fail goto*//*Label 24569*/ GIMT_Encode4(1810243), // Rule ID 12614 //
     /* 1810162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1810173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1810176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1810179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1810182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810208 */     // MIs[0] policy
     /* 1810208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810218 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1810221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810242 */     // GIR_Coverage, 12614,
     /* 1810242 */     GIR_EraseRootFromParent_Done,
     /* 1810243 */   // Label 24569: @1810243
     /* 1810243 */   GIM_Try, /*On fail goto*//*Label 24570*/ GIMT_Encode4(1810329), // Rule ID 12615 //
     /* 1810248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1810259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1810262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1810265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1810268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810294 */     // MIs[0] policy
     /* 1810294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810304 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1810307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810328 */     // GIR_Coverage, 12615,
     /* 1810328 */     GIR_EraseRootFromParent_Done,
     /* 1810329 */   // Label 24570: @1810329
     /* 1810329 */   GIM_Try, /*On fail goto*//*Label 24571*/ GIMT_Encode4(1810415), // Rule ID 12618 //
     /* 1810334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1810345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1810348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1810351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1810354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810380 */     // MIs[0] policy
     /* 1810380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810390 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1810393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810414 */     // GIR_Coverage, 12618,
     /* 1810414 */     GIR_EraseRootFromParent_Done,
     /* 1810415 */   // Label 24571: @1810415
     /* 1810415 */   GIM_Try, /*On fail goto*//*Label 24572*/ GIMT_Encode4(1810501), // Rule ID 12619 //
     /* 1810420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1810431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1810434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1810437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1810440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810466 */     // MIs[0] policy
     /* 1810466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810476 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1810479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810500 */     // GIR_Coverage, 12619,
     /* 1810500 */     GIR_EraseRootFromParent_Done,
     /* 1810501 */   // Label 24572: @1810501
     /* 1810501 */   GIM_Try, /*On fail goto*//*Label 24573*/ GIMT_Encode4(1810587), // Rule ID 12622 //
     /* 1810506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1810517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1810520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1810523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1810526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810552 */     // MIs[0] policy
     /* 1810552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810562 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1810565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810586 */     // GIR_Coverage, 12622,
     /* 1810586 */     GIR_EraseRootFromParent_Done,
     /* 1810587 */   // Label 24573: @1810587
     /* 1810587 */   GIM_Try, /*On fail goto*//*Label 24574*/ GIMT_Encode4(1810673), // Rule ID 12623 //
     /* 1810592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1810603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1810606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1810609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1810612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810638 */     // MIs[0] policy
     /* 1810638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810648 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1810651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810672 */     // GIR_Coverage, 12623,
     /* 1810672 */     GIR_EraseRootFromParent_Done,
     /* 1810673 */   // Label 24574: @1810673
     /* 1810673 */   GIM_Try, /*On fail goto*//*Label 24575*/ GIMT_Encode4(1810759), // Rule ID 12626 //
     /* 1810678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1810689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1810692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1810695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1810698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810724 */     // MIs[0] policy
     /* 1810724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1810737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810758 */     // GIR_Coverage, 12626,
     /* 1810758 */     GIR_EraseRootFromParent_Done,
     /* 1810759 */   // Label 24575: @1810759
     /* 1810759 */   GIM_Try, /*On fail goto*//*Label 24576*/ GIMT_Encode4(1810845), // Rule ID 12627 //
     /* 1810764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1810775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1810778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1810781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1810784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810810 */     // MIs[0] policy
     /* 1810810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810820 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1810823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810844 */     // GIR_Coverage, 12627,
     /* 1810844 */     GIR_EraseRootFromParent_Done,
     /* 1810845 */   // Label 24576: @1810845
     /* 1810845 */   GIM_Try, /*On fail goto*//*Label 24577*/ GIMT_Encode4(1810931), // Rule ID 12630 //
     /* 1810850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1810861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1810864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1810867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1810870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1810873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810896 */     // MIs[0] policy
     /* 1810896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810906 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1810909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810930 */     // GIR_Coverage, 12630,
     /* 1810930 */     GIR_EraseRootFromParent_Done,
     /* 1810931 */   // Label 24577: @1810931
     /* 1810931 */   GIM_Try, /*On fail goto*//*Label 24578*/ GIMT_Encode4(1811017), // Rule ID 12631 //
     /* 1810936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1810947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1810950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1810953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1810956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1810959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810982 */     // MIs[0] policy
     /* 1810982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810992 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1810995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811016 */     // GIR_Coverage, 12631,
     /* 1811016 */     GIR_EraseRootFromParent_Done,
     /* 1811017 */   // Label 24578: @1811017
     /* 1811017 */   GIM_Try, /*On fail goto*//*Label 24579*/ GIMT_Encode4(1811103), // Rule ID 12634 //
     /* 1811022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1811039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1811042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811068 */     // MIs[0] policy
     /* 1811068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811078 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1811081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811102 */     // GIR_Coverage, 12634,
     /* 1811102 */     GIR_EraseRootFromParent_Done,
     /* 1811103 */   // Label 24579: @1811103
     /* 1811103 */   GIM_Try, /*On fail goto*//*Label 24580*/ GIMT_Encode4(1811189), // Rule ID 12635 //
     /* 1811108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1811125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1811128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811154 */     // MIs[0] policy
     /* 1811154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811164 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1811167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811188 */     // GIR_Coverage, 12635,
     /* 1811188 */     GIR_EraseRootFromParent_Done,
     /* 1811189 */   // Label 24580: @1811189
     /* 1811189 */   GIM_Try, /*On fail goto*//*Label 24581*/ GIMT_Encode4(1811275), // Rule ID 12638 //
     /* 1811194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1811205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1811208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1811211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1811214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1811217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811240 */     // MIs[0] policy
     /* 1811240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811250 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1811253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811274 */     // GIR_Coverage, 12638,
     /* 1811274 */     GIR_EraseRootFromParent_Done,
     /* 1811275 */   // Label 24581: @1811275
     /* 1811275 */   GIM_Try, /*On fail goto*//*Label 24582*/ GIMT_Encode4(1811361), // Rule ID 12639 //
     /* 1811280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1811291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1811294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1811297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1811300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1811303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811326 */     // MIs[0] policy
     /* 1811326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811336 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1811339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811360 */     // GIR_Coverage, 12639,
     /* 1811360 */     GIR_EraseRootFromParent_Done,
     /* 1811361 */   // Label 24582: @1811361
     /* 1811361 */   GIM_Try, /*On fail goto*//*Label 24583*/ GIMT_Encode4(1811447), // Rule ID 12642 //
     /* 1811366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1811377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1811380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1811383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1811386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811412 */     // MIs[0] policy
     /* 1811412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1811425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811446 */     // GIR_Coverage, 12642,
     /* 1811446 */     GIR_EraseRootFromParent_Done,
     /* 1811447 */   // Label 24583: @1811447
     /* 1811447 */   GIM_Try, /*On fail goto*//*Label 24584*/ GIMT_Encode4(1811533), // Rule ID 12643 //
     /* 1811452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1811463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1811466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1811469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1811472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811498 */     // MIs[0] policy
     /* 1811498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1811511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811532 */     // GIR_Coverage, 12643,
     /* 1811532 */     GIR_EraseRootFromParent_Done,
     /* 1811533 */   // Label 24584: @1811533
     /* 1811533 */   GIM_Try, /*On fail goto*//*Label 24585*/ GIMT_Encode4(1811619), // Rule ID 12646 //
     /* 1811538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1811549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1811552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1811555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1811558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811584 */     // MIs[0] policy
     /* 1811584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1811597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811618 */     // GIR_Coverage, 12646,
     /* 1811618 */     GIR_EraseRootFromParent_Done,
     /* 1811619 */   // Label 24585: @1811619
     /* 1811619 */   GIM_Try, /*On fail goto*//*Label 24586*/ GIMT_Encode4(1811705), // Rule ID 12647 //
     /* 1811624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1811635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1811638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1811641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1811644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811670 */     // MIs[0] policy
     /* 1811670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1811683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811704 */     // GIR_Coverage, 12647,
     /* 1811704 */     GIR_EraseRootFromParent_Done,
     /* 1811705 */   // Label 24586: @1811705
     /* 1811705 */   GIM_Try, /*On fail goto*//*Label 24587*/ GIMT_Encode4(1811791), // Rule ID 12650 //
     /* 1811710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1811721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1811724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1811727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1811730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811756 */     // MIs[0] policy
     /* 1811756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1811769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811790 */     // GIR_Coverage, 12650,
     /* 1811790 */     GIR_EraseRootFromParent_Done,
     /* 1811791 */   // Label 24587: @1811791
     /* 1811791 */   GIM_Try, /*On fail goto*//*Label 24588*/ GIMT_Encode4(1811877), // Rule ID 12651 //
     /* 1811796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1811807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1811810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1811813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1811816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811842 */     // MIs[0] policy
     /* 1811842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1811855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811876 */     // GIR_Coverage, 12651,
     /* 1811876 */     GIR_EraseRootFromParent_Done,
     /* 1811877 */   // Label 24588: @1811877
     /* 1811877 */   GIM_Try, /*On fail goto*//*Label 24589*/ GIMT_Encode4(1811963), // Rule ID 12654 //
     /* 1811882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1811893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1811896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1811899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1811902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811928 */     // MIs[0] policy
     /* 1811928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811938 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1811941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811962 */     // GIR_Coverage, 12654,
     /* 1811962 */     GIR_EraseRootFromParent_Done,
     /* 1811963 */   // Label 24589: @1811963
     /* 1811963 */   GIM_Try, /*On fail goto*//*Label 24590*/ GIMT_Encode4(1812049), // Rule ID 12655 //
     /* 1811968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1811979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1811982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1811985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1811988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812014 */     // MIs[0] policy
     /* 1812014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812024 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1812027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812048 */     // GIR_Coverage, 12655,
     /* 1812048 */     GIR_EraseRootFromParent_Done,
     /* 1812049 */   // Label 24590: @1812049
     /* 1812049 */   GIM_Try, /*On fail goto*//*Label 24591*/ GIMT_Encode4(1812135), // Rule ID 12658 //
     /* 1812054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1812065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1812068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1812071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1812074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812100 */     // MIs[0] policy
     /* 1812100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812110 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1812113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812134 */     // GIR_Coverage, 12658,
     /* 1812134 */     GIR_EraseRootFromParent_Done,
     /* 1812135 */   // Label 24591: @1812135
     /* 1812135 */   GIM_Try, /*On fail goto*//*Label 24592*/ GIMT_Encode4(1812221), // Rule ID 12659 //
     /* 1812140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1812151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1812154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1812157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1812160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812186 */     // MIs[0] policy
     /* 1812186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812196 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1812199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812220 */     // GIR_Coverage, 12659,
     /* 1812220 */     GIR_EraseRootFromParent_Done,
     /* 1812221 */   // Label 24592: @1812221
     /* 1812221 */   GIM_Try, /*On fail goto*//*Label 24593*/ GIMT_Encode4(1812307), // Rule ID 12662 //
     /* 1812226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1812237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1812240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1812243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1812246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812272 */     // MIs[0] policy
     /* 1812272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812282 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1812285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812306 */     // GIR_Coverage, 12662,
     /* 1812306 */     GIR_EraseRootFromParent_Done,
     /* 1812307 */   // Label 24593: @1812307
     /* 1812307 */   GIM_Try, /*On fail goto*//*Label 24594*/ GIMT_Encode4(1812393), // Rule ID 12663 //
     /* 1812312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1812323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1812326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1812329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1812332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812358 */     // MIs[0] policy
     /* 1812358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812368 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1812371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812392 */     // GIR_Coverage, 12663,
     /* 1812392 */     GIR_EraseRootFromParent_Done,
     /* 1812393 */   // Label 24594: @1812393
     /* 1812393 */   GIM_Try, /*On fail goto*//*Label 24595*/ GIMT_Encode4(1812479), // Rule ID 12666 //
     /* 1812398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1812415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1812418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812444 */     // MIs[0] policy
     /* 1812444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812454 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1812457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812478 */     // GIR_Coverage, 12666,
     /* 1812478 */     GIR_EraseRootFromParent_Done,
     /* 1812479 */   // Label 24595: @1812479
     /* 1812479 */   GIM_Try, /*On fail goto*//*Label 24596*/ GIMT_Encode4(1812565), // Rule ID 12667 //
     /* 1812484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1812501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1812504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812530 */     // MIs[0] policy
     /* 1812530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812540 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1812543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812564 */     // GIR_Coverage, 12667,
     /* 1812564 */     GIR_EraseRootFromParent_Done,
     /* 1812565 */   // Label 24596: @1812565
     /* 1812565 */   GIM_Try, /*On fail goto*//*Label 24597*/ GIMT_Encode4(1812651), // Rule ID 12670 //
     /* 1812570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1812581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1812584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1812587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1812590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812616 */     // MIs[0] policy
     /* 1812616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812626 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1812629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812650 */     // GIR_Coverage, 12670,
     /* 1812650 */     GIR_EraseRootFromParent_Done,
     /* 1812651 */   // Label 24597: @1812651
     /* 1812651 */   GIM_Try, /*On fail goto*//*Label 24598*/ GIMT_Encode4(1812737), // Rule ID 12671 //
     /* 1812656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1812667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1812670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1812673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1812676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812702 */     // MIs[0] policy
     /* 1812702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812712 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1812715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812736 */     // GIR_Coverage, 12671,
     /* 1812736 */     GIR_EraseRootFromParent_Done,
     /* 1812737 */   // Label 24598: @1812737
     /* 1812737 */   GIM_Try, /*On fail goto*//*Label 24599*/ GIMT_Encode4(1812823), // Rule ID 12674 //
     /* 1812742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1812753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1812756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1812759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812788 */     // MIs[0] policy
     /* 1812788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812798 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1812801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812822 */     // GIR_Coverage, 12674,
     /* 1812822 */     GIR_EraseRootFromParent_Done,
     /* 1812823 */   // Label 24599: @1812823
     /* 1812823 */   GIM_Try, /*On fail goto*//*Label 24600*/ GIMT_Encode4(1812909), // Rule ID 12675 //
     /* 1812828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1812839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1812842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1812845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812874 */     // MIs[0] policy
     /* 1812874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812884 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1812887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812908 */     // GIR_Coverage, 12675,
     /* 1812908 */     GIR_EraseRootFromParent_Done,
     /* 1812909 */   // Label 24600: @1812909
     /* 1812909 */   GIM_Try, /*On fail goto*//*Label 24601*/ GIMT_Encode4(1812995), // Rule ID 12678 //
     /* 1812914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1812925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1812928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1812931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812960 */     // MIs[0] policy
     /* 1812960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812970 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1812973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812994 */     // GIR_Coverage, 12678,
     /* 1812994 */     GIR_EraseRootFromParent_Done,
     /* 1812995 */   // Label 24601: @1812995
     /* 1812995 */   GIM_Try, /*On fail goto*//*Label 24602*/ GIMT_Encode4(1813081), // Rule ID 12679 //
     /* 1813000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1813011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1813014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1813017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813046 */     // MIs[0] policy
     /* 1813046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813056 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1813059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813080 */     // GIR_Coverage, 12679,
     /* 1813080 */     GIR_EraseRootFromParent_Done,
     /* 1813081 */   // Label 24602: @1813081
     /* 1813081 */   GIM_Try, /*On fail goto*//*Label 24603*/ GIMT_Encode4(1813167), // Rule ID 12682 //
     /* 1813086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1813097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1813100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1813103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813132 */     // MIs[0] policy
     /* 1813132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813142 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1813145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813166 */     // GIR_Coverage, 12682,
     /* 1813166 */     GIR_EraseRootFromParent_Done,
     /* 1813167 */   // Label 24603: @1813167
     /* 1813167 */   GIM_Try, /*On fail goto*//*Label 24604*/ GIMT_Encode4(1813253), // Rule ID 12683 //
     /* 1813172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1813183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1813186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1813189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813218 */     // MIs[0] policy
     /* 1813218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813228 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1813231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813252 */     // GIR_Coverage, 12683,
     /* 1813252 */     GIR_EraseRootFromParent_Done,
     /* 1813253 */   // Label 24604: @1813253
     /* 1813253 */   GIM_Try, /*On fail goto*//*Label 24605*/ GIMT_Encode4(1813339), // Rule ID 12686 //
     /* 1813258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1813269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1813272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1813275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1813288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813304 */     // MIs[0] policy
     /* 1813304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1813317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813338 */     // GIR_Coverage, 12686,
     /* 1813338 */     GIR_EraseRootFromParent_Done,
     /* 1813339 */   // Label 24605: @1813339
     /* 1813339 */   GIM_Try, /*On fail goto*//*Label 24606*/ GIMT_Encode4(1813425), // Rule ID 12687 //
     /* 1813344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1813355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1813358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1813361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1813374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813390 */     // MIs[0] policy
     /* 1813390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1813403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813424 */     // GIR_Coverage, 12687,
     /* 1813424 */     GIR_EraseRootFromParent_Done,
     /* 1813425 */   // Label 24606: @1813425
     /* 1813425 */   GIM_Try, /*On fail goto*//*Label 24607*/ GIMT_Encode4(1813511), // Rule ID 12690 //
     /* 1813430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1813441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1813444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1813447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1813453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1813460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813476 */     // MIs[0] policy
     /* 1813476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813486 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1813489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813510 */     // GIR_Coverage, 12690,
     /* 1813510 */     GIR_EraseRootFromParent_Done,
     /* 1813511 */   // Label 24607: @1813511
     /* 1813511 */   GIM_Try, /*On fail goto*//*Label 24608*/ GIMT_Encode4(1813597), // Rule ID 12691 //
     /* 1813516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1813527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1813530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1813533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1813539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1813546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813562 */     // MIs[0] policy
     /* 1813562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813572 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1813575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813596 */     // GIR_Coverage, 12691,
     /* 1813596 */     GIR_EraseRootFromParent_Done,
     /* 1813597 */   // Label 24608: @1813597
     /* 1813597 */   GIM_Try, /*On fail goto*//*Label 24609*/ GIMT_Encode4(1813683), // Rule ID 12694 //
     /* 1813602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1813613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1813616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1813619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1813625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813648 */     // MIs[0] policy
     /* 1813648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813658 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1813661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813682 */     // GIR_Coverage, 12694,
     /* 1813682 */     GIR_EraseRootFromParent_Done,
     /* 1813683 */   // Label 24609: @1813683
     /* 1813683 */   GIM_Try, /*On fail goto*//*Label 24610*/ GIMT_Encode4(1813769), // Rule ID 12695 //
     /* 1813688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1813699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1813702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1813705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1813711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813734 */     // MIs[0] policy
     /* 1813734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813744 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1813747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813768 */     // GIR_Coverage, 12695,
     /* 1813768 */     GIR_EraseRootFromParent_Done,
     /* 1813769 */   // Label 24610: @1813769
     /* 1813769 */   GIM_Try, /*On fail goto*//*Label 24611*/ GIMT_Encode4(1813855), // Rule ID 12698 //
     /* 1813774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1813785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1813788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1813791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813820 */     // MIs[0] policy
     /* 1813820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813830 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1813833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813854 */     // GIR_Coverage, 12698,
     /* 1813854 */     GIR_EraseRootFromParent_Done,
     /* 1813855 */   // Label 24611: @1813855
     /* 1813855 */   GIM_Try, /*On fail goto*//*Label 24612*/ GIMT_Encode4(1813941), // Rule ID 12699 //
     /* 1813860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1813871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1813874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1813877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813906 */     // MIs[0] policy
     /* 1813906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813916 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1813919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813940 */     // GIR_Coverage, 12699,
     /* 1813940 */     GIR_EraseRootFromParent_Done,
     /* 1813941 */   // Label 24612: @1813941
     /* 1813941 */   GIM_Try, /*On fail goto*//*Label 24613*/ GIMT_Encode4(1814027), // Rule ID 12702 //
     /* 1813946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1813957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1813960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1813963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813992 */     // MIs[0] policy
     /* 1813992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1814005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814026 */     // GIR_Coverage, 12702,
     /* 1814026 */     GIR_EraseRootFromParent_Done,
     /* 1814027 */   // Label 24613: @1814027
     /* 1814027 */   GIM_Try, /*On fail goto*//*Label 24614*/ GIMT_Encode4(1814113), // Rule ID 12703 //
     /* 1814032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1814043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1814046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1814049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814078 */     // MIs[0] policy
     /* 1814078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814088 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1814091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814112 */     // GIR_Coverage, 12703,
     /* 1814112 */     GIR_EraseRootFromParent_Done,
     /* 1814113 */   // Label 24614: @1814113
     /* 1814113 */   GIM_Try, /*On fail goto*//*Label 24615*/ GIMT_Encode4(1814199), // Rule ID 12706 //
     /* 1814118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1814129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1814132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1814135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814164 */     // MIs[0] policy
     /* 1814164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1814177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814198 */     // GIR_Coverage, 12706,
     /* 1814198 */     GIR_EraseRootFromParent_Done,
     /* 1814199 */   // Label 24615: @1814199
     /* 1814199 */   GIM_Try, /*On fail goto*//*Label 24616*/ GIMT_Encode4(1814285), // Rule ID 12707 //
     /* 1814204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1814215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1814218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1814221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814250 */     // MIs[0] policy
     /* 1814250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1814263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814284 */     // GIR_Coverage, 12707,
     /* 1814284 */     GIR_EraseRootFromParent_Done,
     /* 1814285 */   // Label 24616: @1814285
     /* 1814285 */   GIM_Try, /*On fail goto*//*Label 24617*/ GIMT_Encode4(1814371), // Rule ID 12710 //
     /* 1814290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1814301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1814304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1814307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814336 */     // MIs[0] policy
     /* 1814336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1814349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814370 */     // GIR_Coverage, 12710,
     /* 1814370 */     GIR_EraseRootFromParent_Done,
     /* 1814371 */   // Label 24617: @1814371
     /* 1814371 */   GIM_Try, /*On fail goto*//*Label 24618*/ GIMT_Encode4(1814457), // Rule ID 12711 //
     /* 1814376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1814387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1814390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1814393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814422 */     // MIs[0] policy
     /* 1814422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814432 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1814435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814456 */     // GIR_Coverage, 12711,
     /* 1814456 */     GIR_EraseRootFromParent_Done,
     /* 1814457 */   // Label 24618: @1814457
     /* 1814457 */   GIM_Try, /*On fail goto*//*Label 24619*/ GIMT_Encode4(1814543), // Rule ID 12714 //
     /* 1814462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1814473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1814476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1814479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814508 */     // MIs[0] policy
     /* 1814508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1814521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814542 */     // GIR_Coverage, 12714,
     /* 1814542 */     GIR_EraseRootFromParent_Done,
     /* 1814543 */   // Label 24619: @1814543
     /* 1814543 */   GIM_Try, /*On fail goto*//*Label 24620*/ GIMT_Encode4(1814629), // Rule ID 12715 //
     /* 1814548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1814559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1814562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1814565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814594 */     // MIs[0] policy
     /* 1814594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814604 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1814607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814628 */     // GIR_Coverage, 12715,
     /* 1814628 */     GIR_EraseRootFromParent_Done,
     /* 1814629 */   // Label 24620: @1814629
     /* 1814629 */   GIM_Try, /*On fail goto*//*Label 24621*/ GIMT_Encode4(1814715), // Rule ID 12718 //
     /* 1814634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1814637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1814645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1814648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1814651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1814657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814680 */     // MIs[0] policy
     /* 1814680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814690 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1814693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814714 */     // GIR_Coverage, 12718,
     /* 1814714 */     GIR_EraseRootFromParent_Done,
     /* 1814715 */   // Label 24621: @1814715
     /* 1814715 */   GIM_Try, /*On fail goto*//*Label 24622*/ GIMT_Encode4(1814801), // Rule ID 12719 //
     /* 1814720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1814723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1814731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1814734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1814737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1814743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814766 */     // MIs[0] policy
     /* 1814766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814776 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1814779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814800 */     // GIR_Coverage, 12719,
     /* 1814800 */     GIR_EraseRootFromParent_Done,
     /* 1814801 */   // Label 24622: @1814801
     /* 1814801 */   GIM_Try, /*On fail goto*//*Label 24623*/ GIMT_Encode4(1814887), // Rule ID 12722 //
     /* 1814806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1814809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1814817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1814820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1814823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814852 */     // MIs[0] policy
     /* 1814852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814862 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1814865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814886 */     // GIR_Coverage, 12722,
     /* 1814886 */     GIR_EraseRootFromParent_Done,
     /* 1814887 */   // Label 24623: @1814887
     /* 1814887 */   GIM_Try, /*On fail goto*//*Label 24624*/ GIMT_Encode4(1814973), // Rule ID 12723 //
     /* 1814892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1814895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1814903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1814906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1814909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814938 */     // MIs[0] policy
     /* 1814938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814948 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1814951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814972 */     // GIR_Coverage, 12723,
     /* 1814972 */     GIR_EraseRootFromParent_Done,
     /* 1814973 */   // Label 24624: @1814973
     /* 1814973 */   GIM_Try, /*On fail goto*//*Label 24625*/ GIMT_Encode4(1815059), // Rule ID 12726 //
     /* 1814978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1814981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1814989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1814992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1814995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815024 */     // MIs[0] policy
     /* 1815024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815034 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1815037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815058 */     // GIR_Coverage, 12726,
     /* 1815058 */     GIR_EraseRootFromParent_Done,
     /* 1815059 */   // Label 24625: @1815059
     /* 1815059 */   GIM_Try, /*On fail goto*//*Label 24626*/ GIMT_Encode4(1815145), // Rule ID 12727 //
     /* 1815064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1815067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1815075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1815078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1815081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815110 */     // MIs[0] policy
     /* 1815110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815120 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1815123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815144 */     // GIR_Coverage, 12727,
     /* 1815144 */     GIR_EraseRootFromParent_Done,
     /* 1815145 */   // Label 24626: @1815145
     /* 1815145 */   GIM_Try, /*On fail goto*//*Label 24627*/ GIMT_Encode4(1815231), // Rule ID 12730 //
     /* 1815150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1815153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1815161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1815164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1815167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1815170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815196 */     // MIs[0] policy
     /* 1815196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815206 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1815209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815230 */     // GIR_Coverage, 12730,
     /* 1815230 */     GIR_EraseRootFromParent_Done,
     /* 1815231 */   // Label 24627: @1815231
     /* 1815231 */   GIM_Try, /*On fail goto*//*Label 24628*/ GIMT_Encode4(1815317), // Rule ID 12731 //
     /* 1815236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1815239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1815247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1815250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1815253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815282 */     // MIs[0] policy
     /* 1815282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815292 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1815295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815316 */     // GIR_Coverage, 12731,
     /* 1815316 */     GIR_EraseRootFromParent_Done,
     /* 1815317 */   // Label 24628: @1815317
     /* 1815317 */   GIM_Try, /*On fail goto*//*Label 24629*/ GIMT_Encode4(1815403), // Rule ID 12734 //
     /* 1815322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1815333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1815336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1815339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1815342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815368 */     // MIs[0] policy
     /* 1815368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815378 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1815381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815402 */     // GIR_Coverage, 12734,
     /* 1815402 */     GIR_EraseRootFromParent_Done,
     /* 1815403 */   // Label 24629: @1815403
     /* 1815403 */   GIM_Try, /*On fail goto*//*Label 24630*/ GIMT_Encode4(1815489), // Rule ID 12735 //
     /* 1815408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1815419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1815422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1815425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1815428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815454 */     // MIs[0] policy
     /* 1815454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815464 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1815467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815488 */     // GIR_Coverage, 12735,
     /* 1815488 */     GIR_EraseRootFromParent_Done,
     /* 1815489 */   // Label 24630: @1815489
     /* 1815489 */   GIM_Try, /*On fail goto*//*Label 24631*/ GIMT_Encode4(1815575), // Rule ID 12738 //
     /* 1815494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1815505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1815508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1815511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1815514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815540 */     // MIs[0] policy
     /* 1815540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815550 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1815553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815574 */     // GIR_Coverage, 12738,
     /* 1815574 */     GIR_EraseRootFromParent_Done,
     /* 1815575 */   // Label 24631: @1815575
     /* 1815575 */   GIM_Try, /*On fail goto*//*Label 24632*/ GIMT_Encode4(1815661), // Rule ID 12739 //
     /* 1815580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1815591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1815594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1815597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1815600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815626 */     // MIs[0] policy
     /* 1815626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815636 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1815639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815660 */     // GIR_Coverage, 12739,
     /* 1815660 */     GIR_EraseRootFromParent_Done,
     /* 1815661 */   // Label 24632: @1815661
     /* 1815661 */   GIM_Try, /*On fail goto*//*Label 24633*/ GIMT_Encode4(1815747), // Rule ID 12742 //
     /* 1815666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1815677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1815680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1815683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1815686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815712 */     // MIs[0] policy
     /* 1815712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815722 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1815725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815746 */     // GIR_Coverage, 12742,
     /* 1815746 */     GIR_EraseRootFromParent_Done,
     /* 1815747 */   // Label 24633: @1815747
     /* 1815747 */   GIM_Try, /*On fail goto*//*Label 24634*/ GIMT_Encode4(1815833), // Rule ID 12743 //
     /* 1815752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1815763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1815766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1815769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1815772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815798 */     // MIs[0] policy
     /* 1815798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815808 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1815811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815832 */     // GIR_Coverage, 12743,
     /* 1815832 */     GIR_EraseRootFromParent_Done,
     /* 1815833 */   // Label 24634: @1815833
     /* 1815833 */   GIM_Try, /*On fail goto*//*Label 24635*/ GIMT_Encode4(1815919), // Rule ID 12746 //
     /* 1815838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1815849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1815852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1815855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1815858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815884 */     // MIs[0] policy
     /* 1815884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815894 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1815897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815918 */     // GIR_Coverage, 12746,
     /* 1815918 */     GIR_EraseRootFromParent_Done,
     /* 1815919 */   // Label 24635: @1815919
     /* 1815919 */   GIM_Try, /*On fail goto*//*Label 24636*/ GIMT_Encode4(1816005), // Rule ID 12747 //
     /* 1815924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1815935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1815938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1815941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1815944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815970 */     // MIs[0] policy
     /* 1815970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815980 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1815983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816004 */     // GIR_Coverage, 12747,
     /* 1816004 */     GIR_EraseRootFromParent_Done,
     /* 1816005 */   // Label 24636: @1816005
     /* 1816005 */   GIM_Try, /*On fail goto*//*Label 24637*/ GIMT_Encode4(1816091), // Rule ID 12750 //
     /* 1816010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1816021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1816024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1816027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1816030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816056 */     // MIs[0] policy
     /* 1816056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816090 */     // GIR_Coverage, 12750,
     /* 1816090 */     GIR_EraseRootFromParent_Done,
     /* 1816091 */   // Label 24637: @1816091
     /* 1816091 */   GIM_Try, /*On fail goto*//*Label 24638*/ GIMT_Encode4(1816177), // Rule ID 12751 //
     /* 1816096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1816107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1816110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1816113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1816116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816142 */     // MIs[0] policy
     /* 1816142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816152 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816176 */     // GIR_Coverage, 12751,
     /* 1816176 */     GIR_EraseRootFromParent_Done,
     /* 1816177 */   // Label 24638: @1816177
     /* 1816177 */   GIM_Try, /*On fail goto*//*Label 24639*/ GIMT_Encode4(1816263), // Rule ID 12754 //
     /* 1816182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1816193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1816196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1816199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1816202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816228 */     // MIs[0] policy
     /* 1816228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816238 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816262 */     // GIR_Coverage, 12754,
     /* 1816262 */     GIR_EraseRootFromParent_Done,
     /* 1816263 */   // Label 24639: @1816263
     /* 1816263 */   GIM_Try, /*On fail goto*//*Label 24640*/ GIMT_Encode4(1816349), // Rule ID 12755 //
     /* 1816268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1816279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1816282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1816285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1816288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816314 */     // MIs[0] policy
     /* 1816314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816324 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816348 */     // GIR_Coverage, 12755,
     /* 1816348 */     GIR_EraseRootFromParent_Done,
     /* 1816349 */   // Label 24640: @1816349
     /* 1816349 */   GIM_Try, /*On fail goto*//*Label 24641*/ GIMT_Encode4(1816435), // Rule ID 12758 //
     /* 1816354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1816365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1816368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1816371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1816374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816400 */     // MIs[0] policy
     /* 1816400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816410 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816434 */     // GIR_Coverage, 12758,
     /* 1816434 */     GIR_EraseRootFromParent_Done,
     /* 1816435 */   // Label 24641: @1816435
     /* 1816435 */   GIM_Try, /*On fail goto*//*Label 24642*/ GIMT_Encode4(1816521), // Rule ID 12759 //
     /* 1816440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1816451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1816454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1816457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1816460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816486 */     // MIs[0] policy
     /* 1816486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816496 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816520 */     // GIR_Coverage, 12759,
     /* 1816520 */     GIR_EraseRootFromParent_Done,
     /* 1816521 */   // Label 24642: @1816521
     /* 1816521 */   GIM_Try, /*On fail goto*//*Label 24643*/ GIMT_Encode4(1816607), // Rule ID 12762 //
     /* 1816526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1816537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1816540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1816543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1816546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816572 */     // MIs[0] policy
     /* 1816572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816582 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816606 */     // GIR_Coverage, 12762,
     /* 1816606 */     GIR_EraseRootFromParent_Done,
     /* 1816607 */   // Label 24643: @1816607
     /* 1816607 */   GIM_Try, /*On fail goto*//*Label 24644*/ GIMT_Encode4(1816693), // Rule ID 12763 //
     /* 1816612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1816623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1816626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1816629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1816632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816658 */     // MIs[0] policy
     /* 1816658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816668 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816692 */     // GIR_Coverage, 12763,
     /* 1816692 */     GIR_EraseRootFromParent_Done,
     /* 1816693 */   // Label 24644: @1816693
     /* 1816693 */   GIM_Try, /*On fail goto*//*Label 24645*/ GIMT_Encode4(1816779), // Rule ID 12766 //
     /* 1816698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1816701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1816709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1816712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1816715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1816718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816744 */     // MIs[0] policy
     /* 1816744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816754 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1816775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816778 */     // GIR_Coverage, 12766,
     /* 1816778 */     GIR_EraseRootFromParent_Done,
     /* 1816779 */   // Label 24645: @1816779
     /* 1816779 */   GIM_Try, /*On fail goto*//*Label 24646*/ GIMT_Encode4(1816865), // Rule ID 12767 //
     /* 1816784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1816787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1816795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1816798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1816801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1816804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816830 */     // MIs[0] policy
     /* 1816830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816840 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1816861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816864 */     // GIR_Coverage, 12767,
     /* 1816864 */     GIR_EraseRootFromParent_Done,
     /* 1816865 */   // Label 24646: @1816865
     /* 1816865 */   GIM_Try, /*On fail goto*//*Label 24647*/ GIMT_Encode4(1816951), // Rule ID 12770 //
     /* 1816870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1816881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1816884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1816887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1816890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1816893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1816900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816916 */     // MIs[0] policy
     /* 1816916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816926 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1816929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816950 */     // GIR_Coverage, 12770,
     /* 1816950 */     GIR_EraseRootFromParent_Done,
     /* 1816951 */   // Label 24647: @1816951
     /* 1816951 */   GIM_Try, /*On fail goto*//*Label 24648*/ GIMT_Encode4(1817037), // Rule ID 12771 //
     /* 1816956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1816967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1816970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1816973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1816976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1816979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1816986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817002 */     // MIs[0] policy
     /* 1817002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817012 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817036 */     // GIR_Coverage, 12771,
     /* 1817036 */     GIR_EraseRootFromParent_Done,
     /* 1817037 */   // Label 24648: @1817037
     /* 1817037 */   GIM_Try, /*On fail goto*//*Label 24649*/ GIMT_Encode4(1817123), // Rule ID 12774 //
     /* 1817042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1817053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1817056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1817059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1817062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817088 */     // MIs[0] policy
     /* 1817088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817098 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1817101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817122 */     // GIR_Coverage, 12774,
     /* 1817122 */     GIR_EraseRootFromParent_Done,
     /* 1817123 */   // Label 24649: @1817123
     /* 1817123 */   GIM_Try, /*On fail goto*//*Label 24650*/ GIMT_Encode4(1817209), // Rule ID 12775 //
     /* 1817128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1817139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1817142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1817145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1817148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817174 */     // MIs[0] policy
     /* 1817174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817184 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1817187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817208 */     // GIR_Coverage, 12775,
     /* 1817208 */     GIR_EraseRootFromParent_Done,
     /* 1817209 */   // Label 24650: @1817209
     /* 1817209 */   GIM_Try, /*On fail goto*//*Label 24651*/ GIMT_Encode4(1817295), // Rule ID 12778 //
     /* 1817214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1817225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1817228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1817231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1817234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1817237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817260 */     // MIs[0] policy
     /* 1817260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817270 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1817273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817294 */     // GIR_Coverage, 12778,
     /* 1817294 */     GIR_EraseRootFromParent_Done,
     /* 1817295 */   // Label 24651: @1817295
     /* 1817295 */   GIM_Try, /*On fail goto*//*Label 24652*/ GIMT_Encode4(1817381), // Rule ID 12779 //
     /* 1817300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1817311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1817314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1817317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1817320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1817323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817346 */     // MIs[0] policy
     /* 1817346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817356 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1817359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817380 */     // GIR_Coverage, 12779,
     /* 1817380 */     GIR_EraseRootFromParent_Done,
     /* 1817381 */   // Label 24652: @1817381
     /* 1817381 */   GIM_Try, /*On fail goto*//*Label 24653*/ GIMT_Encode4(1817467), // Rule ID 12782 //
     /* 1817386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1817397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1817400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1817403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1817406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817432 */     // MIs[0] policy
     /* 1817432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817466 */     // GIR_Coverage, 12782,
     /* 1817466 */     GIR_EraseRootFromParent_Done,
     /* 1817467 */   // Label 24653: @1817467
     /* 1817467 */   GIM_Try, /*On fail goto*//*Label 24654*/ GIMT_Encode4(1817553), // Rule ID 12783 //
     /* 1817472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1817483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1817486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1817489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1817492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817518 */     // MIs[0] policy
     /* 1817518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817528 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817552 */     // GIR_Coverage, 12783,
     /* 1817552 */     GIR_EraseRootFromParent_Done,
     /* 1817553 */   // Label 24654: @1817553
     /* 1817553 */   GIM_Try, /*On fail goto*//*Label 24655*/ GIMT_Encode4(1817639), // Rule ID 12786 //
     /* 1817558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1817569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1817572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1817575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1817578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1817581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817604 */     // MIs[0] policy
     /* 1817604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817614 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1817617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817638 */     // GIR_Coverage, 12786,
     /* 1817638 */     GIR_EraseRootFromParent_Done,
     /* 1817639 */   // Label 24655: @1817639
     /* 1817639 */   GIM_Try, /*On fail goto*//*Label 24656*/ GIMT_Encode4(1817725), // Rule ID 12787 //
     /* 1817644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1817655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1817658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1817661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1817664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1817667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817690 */     // MIs[0] policy
     /* 1817690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817700 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1817703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817724 */     // GIR_Coverage, 12787,
     /* 1817724 */     GIR_EraseRootFromParent_Done,
     /* 1817725 */   // Label 24656: @1817725
     /* 1817725 */   GIM_Try, /*On fail goto*//*Label 24657*/ GIMT_Encode4(1817811), // Rule ID 12790 //
     /* 1817730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1817741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1817744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1817747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1817750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817776 */     // MIs[0] policy
     /* 1817776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817786 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1817789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817810 */     // GIR_Coverage, 12790,
     /* 1817810 */     GIR_EraseRootFromParent_Done,
     /* 1817811 */   // Label 24657: @1817811
     /* 1817811 */   GIM_Try, /*On fail goto*//*Label 24658*/ GIMT_Encode4(1817897), // Rule ID 12791 //
     /* 1817816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1817827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1817830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1817833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1817836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817862 */     // MIs[0] policy
     /* 1817862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817872 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1817875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817896 */     // GIR_Coverage, 12791,
     /* 1817896 */     GIR_EraseRootFromParent_Done,
     /* 1817897 */   // Label 24658: @1817897
     /* 1817897 */   GIM_Try, /*On fail goto*//*Label 24659*/ GIMT_Encode4(1817983), // Rule ID 12794 //
     /* 1817902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1817913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1817916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1817919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1817922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1817925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817948 */     // MIs[0] policy
     /* 1817948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817982 */     // GIR_Coverage, 12794,
     /* 1817982 */     GIR_EraseRootFromParent_Done,
     /* 1817983 */   // Label 24659: @1817983
     /* 1817983 */   GIM_Try, /*On fail goto*//*Label 24660*/ GIMT_Encode4(1818069), // Rule ID 12795 //
     /* 1817988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1817999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1818002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1818005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1818008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818034 */     // MIs[0] policy
     /* 1818034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818044 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1818047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818068 */     // GIR_Coverage, 12795,
     /* 1818068 */     GIR_EraseRootFromParent_Done,
     /* 1818069 */   // Label 24660: @1818069
     /* 1818069 */   GIM_Try, /*On fail goto*//*Label 24661*/ GIMT_Encode4(1818155), // Rule ID 12798 //
     /* 1818074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1818085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1818088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1818091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1818094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818120 */     // MIs[0] policy
     /* 1818120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818130 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818154 */     // GIR_Coverage, 12798,
     /* 1818154 */     GIR_EraseRootFromParent_Done,
     /* 1818155 */   // Label 24661: @1818155
     /* 1818155 */   GIM_Try, /*On fail goto*//*Label 24662*/ GIMT_Encode4(1818241), // Rule ID 12799 //
     /* 1818160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1818171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1818174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1818177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1818180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818206 */     // MIs[0] policy
     /* 1818206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818216 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818240 */     // GIR_Coverage, 12799,
     /* 1818240 */     GIR_EraseRootFromParent_Done,
     /* 1818241 */   // Label 24662: @1818241
     /* 1818241 */   GIM_Try, /*On fail goto*//*Label 24663*/ GIMT_Encode4(1818327), // Rule ID 12802 //
     /* 1818246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1818257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1818260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1818263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1818266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818292 */     // MIs[0] policy
     /* 1818292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818302 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818326 */     // GIR_Coverage, 12802,
     /* 1818326 */     GIR_EraseRootFromParent_Done,
     /* 1818327 */   // Label 24663: @1818327
     /* 1818327 */   GIM_Try, /*On fail goto*//*Label 24664*/ GIMT_Encode4(1818413), // Rule ID 12803 //
     /* 1818332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1818343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1818346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1818349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1818352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818378 */     // MIs[0] policy
     /* 1818378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818388 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818412 */     // GIR_Coverage, 12803,
     /* 1818412 */     GIR_EraseRootFromParent_Done,
     /* 1818413 */   // Label 24664: @1818413
     /* 1818413 */   GIM_Try, /*On fail goto*//*Label 24665*/ GIMT_Encode4(1818499), // Rule ID 12806 //
     /* 1818418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1818421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1818429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1818432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1818435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1818438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818464 */     // MIs[0] policy
     /* 1818464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818474 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1818477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818498 */     // GIR_Coverage, 12806,
     /* 1818498 */     GIR_EraseRootFromParent_Done,
     /* 1818499 */   // Label 24665: @1818499
     /* 1818499 */   GIM_Try, /*On fail goto*//*Label 24666*/ GIMT_Encode4(1818585), // Rule ID 12807 //
     /* 1818504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1818507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1818515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1818518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1818521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1818524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818550 */     // MIs[0] policy
     /* 1818550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818560 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1818563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818584 */     // GIR_Coverage, 12807,
     /* 1818584 */     GIR_EraseRootFromParent_Done,
     /* 1818585 */   // Label 24666: @1818585
     /* 1818585 */   GIM_Try, /*On fail goto*//*Label 24667*/ GIMT_Encode4(1818671), // Rule ID 12810 //
     /* 1818590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1818593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1818601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1818604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1818607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1818610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818636 */     // MIs[0] policy
     /* 1818636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818646 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818670 */     // GIR_Coverage, 12810,
     /* 1818670 */     GIR_EraseRootFromParent_Done,
     /* 1818671 */   // Label 24667: @1818671
     /* 1818671 */   GIM_Try, /*On fail goto*//*Label 24668*/ GIMT_Encode4(1818757), // Rule ID 12811 //
     /* 1818676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1818679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1818687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1818690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1818693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1818696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818722 */     // MIs[0] policy
     /* 1818722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818732 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818756 */     // GIR_Coverage, 12811,
     /* 1818756 */     GIR_EraseRootFromParent_Done,
     /* 1818757 */   // Label 24668: @1818757
     /* 1818757 */   GIM_Try, /*On fail goto*//*Label 24669*/ GIMT_Encode4(1818843), // Rule ID 12814 //
     /* 1818762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1818765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1818773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1818776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1818779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1818782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818808 */     // MIs[0] policy
     /* 1818808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818818 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818842 */     // GIR_Coverage, 12814,
     /* 1818842 */     GIR_EraseRootFromParent_Done,
     /* 1818843 */   // Label 24669: @1818843
     /* 1818843 */   GIM_Try, /*On fail goto*//*Label 24670*/ GIMT_Encode4(1818929), // Rule ID 12815 //
     /* 1818848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1818851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1818859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1818862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1818865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1818868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818894 */     // MIs[0] policy
     /* 1818894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818904 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818928 */     // GIR_Coverage, 12815,
     /* 1818928 */     GIR_EraseRootFromParent_Done,
     /* 1818929 */   // Label 24670: @1818929
     /* 1818929 */   GIM_Try, /*On fail goto*//*Label 24671*/ GIMT_Encode4(1819015), // Rule ID 12818 //
     /* 1818934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1818945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1818948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1818951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1818954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1818957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818980 */     // MIs[0] policy
     /* 1818980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818990 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1818993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819014 */     // GIR_Coverage, 12818,
     /* 1819014 */     GIR_EraseRootFromParent_Done,
     /* 1819015 */   // Label 24671: @1819015
     /* 1819015 */   GIM_Try, /*On fail goto*//*Label 24672*/ GIMT_Encode4(1819101), // Rule ID 12819 //
     /* 1819020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1819031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1819034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1819040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819066 */     // MIs[0] policy
     /* 1819066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819076 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1819079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819100 */     // GIR_Coverage, 12819,
     /* 1819100 */     GIR_EraseRootFromParent_Done,
     /* 1819101 */   // Label 24672: @1819101
     /* 1819101 */   GIM_Try, /*On fail goto*//*Label 24673*/ GIMT_Encode4(1819187), // Rule ID 12822 //
     /* 1819106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1819117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1819120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1819126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819152 */     // MIs[0] policy
     /* 1819152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819162 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819186 */     // GIR_Coverage, 12822,
     /* 1819186 */     GIR_EraseRootFromParent_Done,
     /* 1819187 */   // Label 24673: @1819187
     /* 1819187 */   GIM_Try, /*On fail goto*//*Label 24674*/ GIMT_Encode4(1819273), // Rule ID 12823 //
     /* 1819192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1819203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1819206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1819212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819238 */     // MIs[0] policy
     /* 1819238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819248 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819272 */     // GIR_Coverage, 12823,
     /* 1819272 */     GIR_EraseRootFromParent_Done,
     /* 1819273 */   // Label 24674: @1819273
     /* 1819273 */   GIM_Try, /*On fail goto*//*Label 24675*/ GIMT_Encode4(1819359), // Rule ID 12826 //
     /* 1819278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1819289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1819292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1819298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819324 */     // MIs[0] policy
     /* 1819324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819334 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819358 */     // GIR_Coverage, 12826,
     /* 1819358 */     GIR_EraseRootFromParent_Done,
     /* 1819359 */   // Label 24675: @1819359
     /* 1819359 */   GIM_Try, /*On fail goto*//*Label 24676*/ GIMT_Encode4(1819445), // Rule ID 12827 //
     /* 1819364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1819375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1819378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1819384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819410 */     // MIs[0] policy
     /* 1819410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819420 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819444 */     // GIR_Coverage, 12827,
     /* 1819444 */     GIR_EraseRootFromParent_Done,
     /* 1819445 */   // Label 24676: @1819445
     /* 1819445 */   GIM_Try, /*On fail goto*//*Label 24677*/ GIMT_Encode4(1819531), // Rule ID 12830 //
     /* 1819450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1819461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1819464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1819470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819496 */     // MIs[0] policy
     /* 1819496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819506 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819530 */     // GIR_Coverage, 12830,
     /* 1819530 */     GIR_EraseRootFromParent_Done,
     /* 1819531 */   // Label 24677: @1819531
     /* 1819531 */   GIM_Try, /*On fail goto*//*Label 24678*/ GIMT_Encode4(1819617), // Rule ID 12831 //
     /* 1819536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1819547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1819550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1819556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819582 */     // MIs[0] policy
     /* 1819582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819592 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819616 */     // GIR_Coverage, 12831,
     /* 1819616 */     GIR_EraseRootFromParent_Done,
     /* 1819617 */   // Label 24678: @1819617
     /* 1819617 */   GIM_Try, /*On fail goto*//*Label 24679*/ GIMT_Encode4(1819703), // Rule ID 12834 //
     /* 1819622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1819633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1819636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1819642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819668 */     // MIs[0] policy
     /* 1819668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819678 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819702 */     // GIR_Coverage, 12834,
     /* 1819702 */     GIR_EraseRootFromParent_Done,
     /* 1819703 */   // Label 24679: @1819703
     /* 1819703 */   GIM_Try, /*On fail goto*//*Label 24680*/ GIMT_Encode4(1819789), // Rule ID 12835 //
     /* 1819708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1819719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1819722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1819728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819754 */     // MIs[0] policy
     /* 1819754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819764 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819788 */     // GIR_Coverage, 12835,
     /* 1819788 */     GIR_EraseRootFromParent_Done,
     /* 1819789 */   // Label 24680: @1819789
     /* 1819789 */   GIM_Try, /*On fail goto*//*Label 24681*/ GIMT_Encode4(1819875), // Rule ID 12838 //
     /* 1819794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1819805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1819808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1819814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819840 */     // MIs[0] policy
     /* 1819840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819850 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819874 */     // GIR_Coverage, 12838,
     /* 1819874 */     GIR_EraseRootFromParent_Done,
     /* 1819875 */   // Label 24681: @1819875
     /* 1819875 */   GIM_Try, /*On fail goto*//*Label 24682*/ GIMT_Encode4(1819961), // Rule ID 12839 //
     /* 1819880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1819891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1819894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1819900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819926 */     // MIs[0] policy
     /* 1819926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819936 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819960 */     // GIR_Coverage, 12839,
     /* 1819960 */     GIR_EraseRootFromParent_Done,
     /* 1819961 */   // Label 24682: @1819961
     /* 1819961 */   GIM_Try, /*On fail goto*//*Label 24683*/ GIMT_Encode4(1820047), // Rule ID 12842 //
     /* 1819966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1819977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1819980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1819986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820012 */     // MIs[0] policy
     /* 1820012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820022 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820046 */     // GIR_Coverage, 12842,
     /* 1820046 */     GIR_EraseRootFromParent_Done,
     /* 1820047 */   // Label 24683: @1820047
     /* 1820047 */   GIM_Try, /*On fail goto*//*Label 24684*/ GIMT_Encode4(1820133), // Rule ID 12843 //
     /* 1820052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1820063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1820066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1820072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1820075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820098 */     // MIs[0] policy
     /* 1820098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820108 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820132 */     // GIR_Coverage, 12843,
     /* 1820132 */     GIR_EraseRootFromParent_Done,
     /* 1820133 */   // Label 24684: @1820133
     /* 1820133 */   GIM_Try, /*On fail goto*//*Label 24685*/ GIMT_Encode4(1820219), // Rule ID 12846 //
     /* 1820138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1820149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1820152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1820158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820184 */     // MIs[0] policy
     /* 1820184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820194 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820218 */     // GIR_Coverage, 12846,
     /* 1820218 */     GIR_EraseRootFromParent_Done,
     /* 1820219 */   // Label 24685: @1820219
     /* 1820219 */   GIM_Try, /*On fail goto*//*Label 24686*/ GIMT_Encode4(1820305), // Rule ID 12847 //
     /* 1820224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1820235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1820238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1820244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820270 */     // MIs[0] policy
     /* 1820270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820280 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820304 */     // GIR_Coverage, 12847,
     /* 1820304 */     GIR_EraseRootFromParent_Done,
     /* 1820305 */   // Label 24686: @1820305
     /* 1820305 */   GIM_Try, /*On fail goto*//*Label 24687*/ GIMT_Encode4(1820391), // Rule ID 12850 //
     /* 1820310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1820321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1820324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1820330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820356 */     // MIs[0] policy
     /* 1820356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820366 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820390 */     // GIR_Coverage, 12850,
     /* 1820390 */     GIR_EraseRootFromParent_Done,
     /* 1820391 */   // Label 24687: @1820391
     /* 1820391 */   GIM_Try, /*On fail goto*//*Label 24688*/ GIMT_Encode4(1820477), // Rule ID 12851 //
     /* 1820396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1820407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1820410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1820416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820442 */     // MIs[0] policy
     /* 1820442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820476 */     // GIR_Coverage, 12851,
     /* 1820476 */     GIR_EraseRootFromParent_Done,
     /* 1820477 */   // Label 24688: @1820477
     /* 1820477 */   GIM_Try, /*On fail goto*//*Label 24689*/ GIMT_Encode4(1820563), // Rule ID 12854 //
     /* 1820482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1820485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1820493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1820496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1820502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820528 */     // MIs[0] policy
     /* 1820528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820538 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820562 */     // GIR_Coverage, 12854,
     /* 1820562 */     GIR_EraseRootFromParent_Done,
     /* 1820563 */   // Label 24689: @1820563
     /* 1820563 */   GIM_Try, /*On fail goto*//*Label 24690*/ GIMT_Encode4(1820649), // Rule ID 12855 //
     /* 1820568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1820571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1820579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1820582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1820588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820614 */     // MIs[0] policy
     /* 1820614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820624 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820648 */     // GIR_Coverage, 12855,
     /* 1820648 */     GIR_EraseRootFromParent_Done,
     /* 1820649 */   // Label 24690: @1820649
     /* 1820649 */   GIM_Try, /*On fail goto*//*Label 24691*/ GIMT_Encode4(1820735), // Rule ID 12858 //
     /* 1820654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1820665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1820668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1820674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1820677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1820684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820700 */     // MIs[0] policy
     /* 1820700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820710 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1820713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820734 */     // GIR_Coverage, 12858,
     /* 1820734 */     GIR_EraseRootFromParent_Done,
     /* 1820735 */   // Label 24691: @1820735
     /* 1820735 */   GIM_Try, /*On fail goto*//*Label 24692*/ GIMT_Encode4(1820821), // Rule ID 12859 //
     /* 1820740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1820751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1820754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1820760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1820763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1820770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820786 */     // MIs[0] policy
     /* 1820786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1820799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820820 */     // GIR_Coverage, 12859,
     /* 1820820 */     GIR_EraseRootFromParent_Done,
     /* 1820821 */   // Label 24692: @1820821
     /* 1820821 */   GIM_Try, /*On fail goto*//*Label 24693*/ GIMT_Encode4(1820907), // Rule ID 12862 //
     /* 1820826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1820837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1820840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1820846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1820849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1820856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820872 */     // MIs[0] policy
     /* 1820872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820882 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1820885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820906 */     // GIR_Coverage, 12862,
     /* 1820906 */     GIR_EraseRootFromParent_Done,
     /* 1820907 */   // Label 24693: @1820907
     /* 1820907 */   GIM_Try, /*On fail goto*//*Label 24694*/ GIMT_Encode4(1820993), // Rule ID 12863 //
     /* 1820912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1820923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1820926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1820932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1820935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1820942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820958 */     // MIs[0] policy
     /* 1820958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820968 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1820971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820992 */     // GIR_Coverage, 12863,
     /* 1820992 */     GIR_EraseRootFromParent_Done,
     /* 1820993 */   // Label 24694: @1820993
     /* 1820993 */   GIM_Try, /*On fail goto*//*Label 24695*/ GIMT_Encode4(1821079), // Rule ID 12866 //
     /* 1820998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1821009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1821012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1821018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1821021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821044 */     // MIs[0] policy
     /* 1821044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821054 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1821057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821078 */     // GIR_Coverage, 12866,
     /* 1821078 */     GIR_EraseRootFromParent_Done,
     /* 1821079 */   // Label 24695: @1821079
     /* 1821079 */   GIM_Try, /*On fail goto*//*Label 24696*/ GIMT_Encode4(1821165), // Rule ID 12867 //
     /* 1821084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1821095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1821098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1821104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1821107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821130 */     // MIs[0] policy
     /* 1821130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821140 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1821143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821164 */     // GIR_Coverage, 12867,
     /* 1821164 */     GIR_EraseRootFromParent_Done,
     /* 1821165 */   // Label 24696: @1821165
     /* 1821165 */   GIM_Try, /*On fail goto*//*Label 24697*/ GIMT_Encode4(1821251), // Rule ID 12870 //
     /* 1821170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1821181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1821184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1821190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821216 */     // MIs[0] policy
     /* 1821216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821226 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821250 */     // GIR_Coverage, 12870,
     /* 1821250 */     GIR_EraseRootFromParent_Done,
     /* 1821251 */   // Label 24697: @1821251
     /* 1821251 */   GIM_Try, /*On fail goto*//*Label 24698*/ GIMT_Encode4(1821337), // Rule ID 12871 //
     /* 1821256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1821267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1821270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1821276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821302 */     // MIs[0] policy
     /* 1821302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821312 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821336 */     // GIR_Coverage, 12871,
     /* 1821336 */     GIR_EraseRootFromParent_Done,
     /* 1821337 */   // Label 24698: @1821337
     /* 1821337 */   GIM_Try, /*On fail goto*//*Label 24699*/ GIMT_Encode4(1821423), // Rule ID 12874 //
     /* 1821342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1821353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1821356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1821362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821388 */     // MIs[0] policy
     /* 1821388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821398 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821422 */     // GIR_Coverage, 12874,
     /* 1821422 */     GIR_EraseRootFromParent_Done,
     /* 1821423 */   // Label 24699: @1821423
     /* 1821423 */   GIM_Try, /*On fail goto*//*Label 24700*/ GIMT_Encode4(1821509), // Rule ID 12875 //
     /* 1821428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1821439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1821442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1821448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821474 */     // MIs[0] policy
     /* 1821474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821484 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821508 */     // GIR_Coverage, 12875,
     /* 1821508 */     GIR_EraseRootFromParent_Done,
     /* 1821509 */   // Label 24700: @1821509
     /* 1821509 */   GIM_Try, /*On fail goto*//*Label 24701*/ GIMT_Encode4(1821595), // Rule ID 12878 //
     /* 1821514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1821525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1821528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1821534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821560 */     // MIs[0] policy
     /* 1821560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821570 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1821573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821594 */     // GIR_Coverage, 12878,
     /* 1821594 */     GIR_EraseRootFromParent_Done,
     /* 1821595 */   // Label 24701: @1821595
     /* 1821595 */   GIM_Try, /*On fail goto*//*Label 24702*/ GIMT_Encode4(1821681), // Rule ID 12879 //
     /* 1821600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1821611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1821614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1821620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821646 */     // MIs[0] policy
     /* 1821646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821656 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1821659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821680 */     // GIR_Coverage, 12879,
     /* 1821680 */     GIR_EraseRootFromParent_Done,
     /* 1821681 */   // Label 24702: @1821681
     /* 1821681 */   GIM_Try, /*On fail goto*//*Label 24703*/ GIMT_Encode4(1821767), // Rule ID 12882 //
     /* 1821686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1821697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1821700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1821706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1821709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821732 */     // MIs[0] policy
     /* 1821732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821742 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821766 */     // GIR_Coverage, 12882,
     /* 1821766 */     GIR_EraseRootFromParent_Done,
     /* 1821767 */   // Label 24703: @1821767
     /* 1821767 */   GIM_Try, /*On fail goto*//*Label 24704*/ GIMT_Encode4(1821853), // Rule ID 12883 //
     /* 1821772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1821783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1821786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1821792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1821795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821818 */     // MIs[0] policy
     /* 1821818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821852 */     // GIR_Coverage, 12883,
     /* 1821852 */     GIR_EraseRootFromParent_Done,
     /* 1821853 */   // Label 24704: @1821853
     /* 1821853 */   GIM_Try, /*On fail goto*//*Label 24705*/ GIMT_Encode4(1821939), // Rule ID 12886 //
     /* 1821858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1821869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1821872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1821878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821904 */     // MIs[0] policy
     /* 1821904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821938 */     // GIR_Coverage, 12886,
     /* 1821938 */     GIR_EraseRootFromParent_Done,
     /* 1821939 */   // Label 24705: @1821939
     /* 1821939 */   GIM_Try, /*On fail goto*//*Label 24706*/ GIMT_Encode4(1822025), // Rule ID 12887 //
     /* 1821944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1821955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1821958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1821964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821990 */     // MIs[0] policy
     /* 1821990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822000 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1822003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822024 */     // GIR_Coverage, 12887,
     /* 1822024 */     GIR_EraseRootFromParent_Done,
     /* 1822025 */   // Label 24706: @1822025
     /* 1822025 */   GIM_Try, /*On fail goto*//*Label 24707*/ GIMT_Encode4(1822111), // Rule ID 12890 //
     /* 1822030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1822041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1822044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1822050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822076 */     // MIs[0] policy
     /* 1822076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822086 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822110 */     // GIR_Coverage, 12890,
     /* 1822110 */     GIR_EraseRootFromParent_Done,
     /* 1822111 */   // Label 24707: @1822111
     /* 1822111 */   GIM_Try, /*On fail goto*//*Label 24708*/ GIMT_Encode4(1822197), // Rule ID 12891 //
     /* 1822116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1822127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1822130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1822136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822162 */     // MIs[0] policy
     /* 1822162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822172 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822196 */     // GIR_Coverage, 12891,
     /* 1822196 */     GIR_EraseRootFromParent_Done,
     /* 1822197 */   // Label 24708: @1822197
     /* 1822197 */   GIM_Try, /*On fail goto*//*Label 24709*/ GIMT_Encode4(1822283), // Rule ID 12894 //
     /* 1822202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1822213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1822216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1822222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822248 */     // MIs[0] policy
     /* 1822248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1822261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822282 */     // GIR_Coverage, 12894,
     /* 1822282 */     GIR_EraseRootFromParent_Done,
     /* 1822283 */   // Label 24709: @1822283
     /* 1822283 */   GIM_Try, /*On fail goto*//*Label 24710*/ GIMT_Encode4(1822369), // Rule ID 12895 //
     /* 1822288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1822299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1822302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1822308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822334 */     // MIs[0] policy
     /* 1822334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822344 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1822347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822368 */     // GIR_Coverage, 12895,
     /* 1822368 */     GIR_EraseRootFromParent_Done,
     /* 1822369 */   // Label 24710: @1822369
     /* 1822369 */   GIM_Try, /*On fail goto*//*Label 24711*/ GIMT_Encode4(1822455), // Rule ID 12898 //
     /* 1822374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1822385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1822388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1822394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822420 */     // MIs[0] policy
     /* 1822420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822430 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1822433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822454 */     // GIR_Coverage, 12898,
     /* 1822454 */     GIR_EraseRootFromParent_Done,
     /* 1822455 */   // Label 24711: @1822455
     /* 1822455 */   GIM_Try, /*On fail goto*//*Label 24712*/ GIMT_Encode4(1822541), // Rule ID 12899 //
     /* 1822460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1822471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1822474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1822480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822506 */     // MIs[0] policy
     /* 1822506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822516 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1822519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822540 */     // GIR_Coverage, 12899,
     /* 1822540 */     GIR_EraseRootFromParent_Done,
     /* 1822541 */   // Label 24712: @1822541
     /* 1822541 */   GIM_Try, /*On fail goto*//*Label 24713*/ GIMT_Encode4(1822627), // Rule ID 12902 //
     /* 1822546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1822557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1822560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1822566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822592 */     // MIs[0] policy
     /* 1822592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822626 */     // GIR_Coverage, 12902,
     /* 1822626 */     GIR_EraseRootFromParent_Done,
     /* 1822627 */   // Label 24713: @1822627
     /* 1822627 */   GIM_Try, /*On fail goto*//*Label 24714*/ GIMT_Encode4(1822713), // Rule ID 12903 //
     /* 1822632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1822643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1822646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1822652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822678 */     // MIs[0] policy
     /* 1822678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822688 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11425:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822712 */     // GIR_Coverage, 12903,
     /* 1822712 */     GIR_EraseRootFromParent_Done,
     /* 1822713 */   // Label 24714: @1822713
     /* 1822713 */   GIM_Try, /*On fail goto*//*Label 24715*/ GIMT_Encode4(1822799), // Rule ID 12906 //
     /* 1822718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1822729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1822732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1822735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1822738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1822741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1822748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822764 */     // MIs[0] policy
     /* 1822764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822774 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1822777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822798 */     // GIR_Coverage, 12906,
     /* 1822798 */     GIR_EraseRootFromParent_Done,
     /* 1822799 */   // Label 24715: @1822799
     /* 1822799 */   GIM_Try, /*On fail goto*//*Label 24716*/ GIMT_Encode4(1822885), // Rule ID 12907 //
     /* 1822804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1822815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1822818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1822821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1822824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1822827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1822834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822850 */     // MIs[0] policy
     /* 1822850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822860 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1822863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822884 */     // GIR_Coverage, 12907,
     /* 1822884 */     GIR_EraseRootFromParent_Done,
     /* 1822885 */   // Label 24716: @1822885
     /* 1822885 */   GIM_Try, /*On fail goto*//*Label 24717*/ GIMT_Encode4(1822971), // Rule ID 12910 //
     /* 1822890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1822901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1822904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1822907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1822910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1822920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822936 */     // MIs[0] policy
     /* 1822936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822946 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1822949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822970 */     // GIR_Coverage, 12910,
     /* 1822970 */     GIR_EraseRootFromParent_Done,
     /* 1822971 */   // Label 24717: @1822971
     /* 1822971 */   GIM_Try, /*On fail goto*//*Label 24718*/ GIMT_Encode4(1823057), // Rule ID 12911 //
     /* 1822976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1822987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1822990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1822993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1822996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823022 */     // MIs[0] policy
     /* 1823022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823032 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823056 */     // GIR_Coverage, 12911,
     /* 1823056 */     GIR_EraseRootFromParent_Done,
     /* 1823057 */   // Label 24718: @1823057
     /* 1823057 */   GIM_Try, /*On fail goto*//*Label 24719*/ GIMT_Encode4(1823143), // Rule ID 12914 //
     /* 1823062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1823073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1823076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1823079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1823082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823108 */     // MIs[0] policy
     /* 1823108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823142 */     // GIR_Coverage, 12914,
     /* 1823142 */     GIR_EraseRootFromParent_Done,
     /* 1823143 */   // Label 24719: @1823143
     /* 1823143 */   GIM_Try, /*On fail goto*//*Label 24720*/ GIMT_Encode4(1823229), // Rule ID 12915 //
     /* 1823148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1823159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1823162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1823165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1823168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823194 */     // MIs[0] policy
     /* 1823194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823204 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823228 */     // GIR_Coverage, 12915,
     /* 1823228 */     GIR_EraseRootFromParent_Done,
     /* 1823229 */   // Label 24720: @1823229
     /* 1823229 */   GIM_Try, /*On fail goto*//*Label 24721*/ GIMT_Encode4(1823315), // Rule ID 12918 //
     /* 1823234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1823245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1823248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1823251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1823254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823280 */     // MIs[0] policy
     /* 1823280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823290 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823314 */     // GIR_Coverage, 12918,
     /* 1823314 */     GIR_EraseRootFromParent_Done,
     /* 1823315 */   // Label 24721: @1823315
     /* 1823315 */   GIM_Try, /*On fail goto*//*Label 24722*/ GIMT_Encode4(1823401), // Rule ID 12919 //
     /* 1823320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1823331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1823334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1823337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1823340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823366 */     // MIs[0] policy
     /* 1823366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823400 */     // GIR_Coverage, 12919,
     /* 1823400 */     GIR_EraseRootFromParent_Done,
     /* 1823401 */   // Label 24722: @1823401
     /* 1823401 */   GIM_Try, /*On fail goto*//*Label 24723*/ GIMT_Encode4(1823487), // Rule ID 12922 //
     /* 1823406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1823417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1823420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1823423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1823426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823452 */     // MIs[0] policy
     /* 1823452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823462 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823486 */     // GIR_Coverage, 12922,
     /* 1823486 */     GIR_EraseRootFromParent_Done,
     /* 1823487 */   // Label 24723: @1823487
     /* 1823487 */   GIM_Try, /*On fail goto*//*Label 24724*/ GIMT_Encode4(1823573), // Rule ID 12923 //
     /* 1823492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1823503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1823506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1823509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1823512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823538 */     // MIs[0] policy
     /* 1823538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823572 */     // GIR_Coverage, 12923,
     /* 1823572 */     GIR_EraseRootFromParent_Done,
     /* 1823573 */   // Label 24724: @1823573
     /* 1823573 */   GIM_Try, /*On fail goto*//*Label 24725*/ GIMT_Encode4(1823659), // Rule ID 12926 //
     /* 1823578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1823589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1823592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1823595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1823598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823624 */     // MIs[0] policy
     /* 1823624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823634 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823658 */     // GIR_Coverage, 12926,
     /* 1823658 */     GIR_EraseRootFromParent_Done,
     /* 1823659 */   // Label 24725: @1823659
     /* 1823659 */   GIM_Try, /*On fail goto*//*Label 24726*/ GIMT_Encode4(1823745), // Rule ID 12927 //
     /* 1823664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1823675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1823678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1823681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1823684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823710 */     // MIs[0] policy
     /* 1823710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823720 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823744 */     // GIR_Coverage, 12927,
     /* 1823744 */     GIR_EraseRootFromParent_Done,
     /* 1823745 */   // Label 24726: @1823745
     /* 1823745 */   GIM_Try, /*On fail goto*//*Label 24727*/ GIMT_Encode4(1823831), // Rule ID 12930 //
     /* 1823750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1823761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1823764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1823767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1823770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823796 */     // MIs[0] policy
     /* 1823796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823806 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1823809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823830 */     // GIR_Coverage, 12930,
     /* 1823830 */     GIR_EraseRootFromParent_Done,
     /* 1823831 */   // Label 24727: @1823831
     /* 1823831 */   GIM_Try, /*On fail goto*//*Label 24728*/ GIMT_Encode4(1823917), // Rule ID 12931 //
     /* 1823836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1823847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1823850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1823853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1823856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823882 */     // MIs[0] policy
     /* 1823882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823892 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1823895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823916 */     // GIR_Coverage, 12931,
     /* 1823916 */     GIR_EraseRootFromParent_Done,
     /* 1823917 */   // Label 24728: @1823917
     /* 1823917 */   GIM_Try, /*On fail goto*//*Label 24729*/ GIMT_Encode4(1824003), // Rule ID 12934 //
     /* 1823922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1823933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1823936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1823939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1823942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823968 */     // MIs[0] policy
     /* 1823968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823978 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1823981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824002 */     // GIR_Coverage, 12934,
     /* 1824002 */     GIR_EraseRootFromParent_Done,
     /* 1824003 */   // Label 24729: @1824003
     /* 1824003 */   GIM_Try, /*On fail goto*//*Label 24730*/ GIMT_Encode4(1824089), // Rule ID 12935 //
     /* 1824008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1824019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1824022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1824025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1824028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824054 */     // MIs[0] policy
     /* 1824054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824064 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824088 */     // GIR_Coverage, 12935,
     /* 1824088 */     GIR_EraseRootFromParent_Done,
     /* 1824089 */   // Label 24730: @1824089
     /* 1824089 */   GIM_Try, /*On fail goto*//*Label 24731*/ GIMT_Encode4(1824175), // Rule ID 12938 //
     /* 1824094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1824105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1824108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1824111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1824114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824140 */     // MIs[0] policy
     /* 1824140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824174 */     // GIR_Coverage, 12938,
     /* 1824174 */     GIR_EraseRootFromParent_Done,
     /* 1824175 */   // Label 24731: @1824175
     /* 1824175 */   GIM_Try, /*On fail goto*//*Label 24732*/ GIMT_Encode4(1824261), // Rule ID 12939 //
     /* 1824180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1824191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1824194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1824197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1824200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824226 */     // MIs[0] policy
     /* 1824226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824260 */     // GIR_Coverage, 12939,
     /* 1824260 */     GIR_EraseRootFromParent_Done,
     /* 1824261 */   // Label 24732: @1824261
     /* 1824261 */   GIM_Try, /*On fail goto*//*Label 24733*/ GIMT_Encode4(1824347), // Rule ID 12942 //
     /* 1824266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1824269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1824277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1824280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1824283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1824286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824312 */     // MIs[0] policy
     /* 1824312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824322 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1824343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824346 */     // GIR_Coverage, 12942,
     /* 1824346 */     GIR_EraseRootFromParent_Done,
     /* 1824347 */   // Label 24733: @1824347
     /* 1824347 */   GIM_Try, /*On fail goto*//*Label 24734*/ GIMT_Encode4(1824433), // Rule ID 12943 //
     /* 1824352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1824355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1824363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1824366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1824369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1824372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824398 */     // MIs[0] policy
     /* 1824398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1824429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824432 */     // GIR_Coverage, 12943,
     /* 1824432 */     GIR_EraseRootFromParent_Done,
     /* 1824433 */   // Label 24734: @1824433
     /* 1824433 */   GIM_Try, /*On fail goto*//*Label 24735*/ GIMT_Encode4(1824519), // Rule ID 12946 //
     /* 1824438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1824449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1824452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1824455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1824458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1824461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1824468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824484 */     // MIs[0] policy
     /* 1824484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824494 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1824497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824518 */     // GIR_Coverage, 12946,
     /* 1824518 */     GIR_EraseRootFromParent_Done,
     /* 1824519 */   // Label 24735: @1824519
     /* 1824519 */   GIM_Try, /*On fail goto*//*Label 24736*/ GIMT_Encode4(1824605), // Rule ID 12947 //
     /* 1824524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1824535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1824538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1824541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1824544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1824547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1824554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824570 */     // MIs[0] policy
     /* 1824570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824580 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1824583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824604 */     // GIR_Coverage, 12947,
     /* 1824604 */     GIR_EraseRootFromParent_Done,
     /* 1824605 */   // Label 24736: @1824605
     /* 1824605 */   GIM_Try, /*On fail goto*//*Label 24737*/ GIMT_Encode4(1824691), // Rule ID 12950 //
     /* 1824610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1824621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1824624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1824627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1824630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1824633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1824640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824656 */     // MIs[0] policy
     /* 1824656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824666 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1824669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824690 */     // GIR_Coverage, 12950,
     /* 1824690 */     GIR_EraseRootFromParent_Done,
     /* 1824691 */   // Label 24737: @1824691
     /* 1824691 */   GIM_Try, /*On fail goto*//*Label 24738*/ GIMT_Encode4(1824777), // Rule ID 12951 //
     /* 1824696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1824707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1824710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1824713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1824716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1824719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1824726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824742 */     // MIs[0] policy
     /* 1824742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824752 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1824755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824776 */     // GIR_Coverage, 12951,
     /* 1824776 */     GIR_EraseRootFromParent_Done,
     /* 1824777 */   // Label 24738: @1824777
     /* 1824777 */   GIM_Try, /*On fail goto*//*Label 24739*/ GIMT_Encode4(1824863), // Rule ID 12954 //
     /* 1824782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1824793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1824796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1824799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1824802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1824805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1824812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824828 */     // MIs[0] policy
     /* 1824828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824838 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1824841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824862 */     // GIR_Coverage, 12954,
     /* 1824862 */     GIR_EraseRootFromParent_Done,
     /* 1824863 */   // Label 24739: @1824863
     /* 1824863 */   GIM_Try, /*On fail goto*//*Label 24740*/ GIMT_Encode4(1824949), // Rule ID 12955 //
     /* 1824868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1824879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1824882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1824885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1824888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1824891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1824898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824914 */     // MIs[0] policy
     /* 1824914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824924 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1824927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824948 */     // GIR_Coverage, 12955,
     /* 1824948 */     GIR_EraseRootFromParent_Done,
     /* 1824949 */   // Label 24740: @1824949
     /* 1824949 */   GIM_Try, /*On fail goto*//*Label 24741*/ GIMT_Encode4(1825035), // Rule ID 12958 //
     /* 1824954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1824965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1824968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1824971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1824974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1824977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1824984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825000 */     // MIs[0] policy
     /* 1825000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825010 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825034 */     // GIR_Coverage, 12958,
     /* 1825034 */     GIR_EraseRootFromParent_Done,
     /* 1825035 */   // Label 24741: @1825035
     /* 1825035 */   GIM_Try, /*On fail goto*//*Label 24742*/ GIMT_Encode4(1825121), // Rule ID 12959 //
     /* 1825040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1825051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1825054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1825057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1825060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825086 */     // MIs[0] policy
     /* 1825086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825120 */     // GIR_Coverage, 12959,
     /* 1825120 */     GIR_EraseRootFromParent_Done,
     /* 1825121 */   // Label 24742: @1825121
     /* 1825121 */   GIM_Try, /*On fail goto*//*Label 24743*/ GIMT_Encode4(1825207), // Rule ID 12962 //
     /* 1825126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1825137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1825140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1825143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1825146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825172 */     // MIs[0] policy
     /* 1825172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825182 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825206 */     // GIR_Coverage, 12962,
     /* 1825206 */     GIR_EraseRootFromParent_Done,
     /* 1825207 */   // Label 24743: @1825207
     /* 1825207 */   GIM_Try, /*On fail goto*//*Label 24744*/ GIMT_Encode4(1825293), // Rule ID 12963 //
     /* 1825212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1825223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1825226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1825229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1825232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825258 */     // MIs[0] policy
     /* 1825258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825268 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825292 */     // GIR_Coverage, 12963,
     /* 1825292 */     GIR_EraseRootFromParent_Done,
     /* 1825293 */   // Label 24744: @1825293
     /* 1825293 */   GIM_Try, /*On fail goto*//*Label 24745*/ GIMT_Encode4(1825379), // Rule ID 12966 //
     /* 1825298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1825309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1825312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1825315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1825318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825344 */     // MIs[0] policy
     /* 1825344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825354 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825378 */     // GIR_Coverage, 12966,
     /* 1825378 */     GIR_EraseRootFromParent_Done,
     /* 1825379 */   // Label 24745: @1825379
     /* 1825379 */   GIM_Try, /*On fail goto*//*Label 24746*/ GIMT_Encode4(1825465), // Rule ID 12967 //
     /* 1825384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1825395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1825398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1825401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1825404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825430 */     // MIs[0] policy
     /* 1825430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825440 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825464 */     // GIR_Coverage, 12967,
     /* 1825464 */     GIR_EraseRootFromParent_Done,
     /* 1825465 */   // Label 24746: @1825465
     /* 1825465 */   GIM_Try, /*On fail goto*//*Label 24747*/ GIMT_Encode4(1825551), // Rule ID 12970 //
     /* 1825470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1825481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1825484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1825487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1825490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1825493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825516 */     // MIs[0] policy
     /* 1825516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825550 */     // GIR_Coverage, 12970,
     /* 1825550 */     GIR_EraseRootFromParent_Done,
     /* 1825551 */   // Label 24747: @1825551
     /* 1825551 */   GIM_Try, /*On fail goto*//*Label 24748*/ GIMT_Encode4(1825637), // Rule ID 12971 //
     /* 1825556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1825567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1825570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1825573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1825576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1825579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825602 */     // MIs[0] policy
     /* 1825602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825636 */     // GIR_Coverage, 12971,
     /* 1825636 */     GIR_EraseRootFromParent_Done,
     /* 1825637 */   // Label 24748: @1825637
     /* 1825637 */   GIM_Try, /*On fail goto*//*Label 24749*/ GIMT_Encode4(1825723), // Rule ID 12974 //
     /* 1825642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1825653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1825656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1825659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1825662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825688 */     // MIs[0] policy
     /* 1825688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825698 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825722 */     // GIR_Coverage, 12974,
     /* 1825722 */     GIR_EraseRootFromParent_Done,
     /* 1825723 */   // Label 24749: @1825723
     /* 1825723 */   GIM_Try, /*On fail goto*//*Label 24750*/ GIMT_Encode4(1825809), // Rule ID 12975 //
     /* 1825728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1825739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1825742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1825745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1825748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825774 */     // MIs[0] policy
     /* 1825774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825808 */     // GIR_Coverage, 12975,
     /* 1825808 */     GIR_EraseRootFromParent_Done,
     /* 1825809 */   // Label 24750: @1825809
     /* 1825809 */   GIM_Try, /*On fail goto*//*Label 24751*/ GIMT_Encode4(1825895), // Rule ID 12978 //
     /* 1825814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1825825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1825828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1825831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1825834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825860 */     // MIs[0] policy
     /* 1825860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825870 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825894 */     // GIR_Coverage, 12978,
     /* 1825894 */     GIR_EraseRootFromParent_Done,
     /* 1825895 */   // Label 24751: @1825895
     /* 1825895 */   GIM_Try, /*On fail goto*//*Label 24752*/ GIMT_Encode4(1825981), // Rule ID 12979 //
     /* 1825900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1825911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1825914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1825917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1825920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825946 */     // MIs[0] policy
     /* 1825946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825956 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825980 */     // GIR_Coverage, 12979,
     /* 1825980 */     GIR_EraseRootFromParent_Done,
     /* 1825981 */   // Label 24752: @1825981
     /* 1825981 */   GIM_Try, /*On fail goto*//*Label 24753*/ GIMT_Encode4(1826067), // Rule ID 12982 //
     /* 1825986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1825989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1825997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1826000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1826003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1826006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826032 */     // MIs[0] policy
     /* 1826032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826042 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1826045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826066 */     // GIR_Coverage, 12982,
     /* 1826066 */     GIR_EraseRootFromParent_Done,
     /* 1826067 */   // Label 24753: @1826067
     /* 1826067 */   GIM_Try, /*On fail goto*//*Label 24754*/ GIMT_Encode4(1826153), // Rule ID 12983 //
     /* 1826072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1826083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1826086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1826089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1826092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826118 */     // MIs[0] policy
     /* 1826118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826128 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1826131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826152 */     // GIR_Coverage, 12983,
     /* 1826152 */     GIR_EraseRootFromParent_Done,
     /* 1826153 */   // Label 24754: @1826153
     /* 1826153 */   GIM_Try, /*On fail goto*//*Label 24755*/ GIMT_Encode4(1826239), // Rule ID 12986 //
     /* 1826158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1826169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1826172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1826175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1826178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826204 */     // MIs[0] policy
     /* 1826204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826214 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1826217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826238 */     // GIR_Coverage, 12986,
     /* 1826238 */     GIR_EraseRootFromParent_Done,
     /* 1826239 */   // Label 24755: @1826239
     /* 1826239 */   GIM_Try, /*On fail goto*//*Label 24756*/ GIMT_Encode4(1826325), // Rule ID 12987 //
     /* 1826244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1826255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1826258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1826261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1826264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826290 */     // MIs[0] policy
     /* 1826290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826300 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1826303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826324 */     // GIR_Coverage, 12987,
     /* 1826324 */     GIR_EraseRootFromParent_Done,
     /* 1826325 */   // Label 24756: @1826325
     /* 1826325 */   GIM_Try, /*On fail goto*//*Label 24757*/ GIMT_Encode4(1826411), // Rule ID 12990 //
     /* 1826330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1826341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1826344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1826347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1826350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826376 */     // MIs[0] policy
     /* 1826376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1826389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826410 */     // GIR_Coverage, 12990,
     /* 1826410 */     GIR_EraseRootFromParent_Done,
     /* 1826411 */   // Label 24757: @1826411
     /* 1826411 */   GIM_Try, /*On fail goto*//*Label 24758*/ GIMT_Encode4(1826497), // Rule ID 12991 //
     /* 1826416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1826427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1826430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1826433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1826436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826462 */     // MIs[0] policy
     /* 1826462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826472 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1826475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826496 */     // GIR_Coverage, 12991,
     /* 1826496 */     GIR_EraseRootFromParent_Done,
     /* 1826497 */   // Label 24758: @1826497
     /* 1826497 */   GIM_Try, /*On fail goto*//*Label 24759*/ GIMT_Encode4(1826583), // Rule ID 12994 //
     /* 1826502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1826513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1826516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1826522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1826525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826548 */     // MIs[0] policy
     /* 1826548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826558 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1826561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826582 */     // GIR_Coverage, 12994,
     /* 1826582 */     GIR_EraseRootFromParent_Done,
     /* 1826583 */   // Label 24759: @1826583
     /* 1826583 */   GIM_Try, /*On fail goto*//*Label 24760*/ GIMT_Encode4(1826669), // Rule ID 12995 //
     /* 1826588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1826599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1826602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1826608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1826611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826634 */     // MIs[0] policy
     /* 1826634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826644 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1826647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826668 */     // GIR_Coverage, 12995,
     /* 1826668 */     GIR_EraseRootFromParent_Done,
     /* 1826669 */   // Label 24760: @1826669
     /* 1826669 */   GIM_Try, /*On fail goto*//*Label 24761*/ GIMT_Encode4(1826755), // Rule ID 12998 //
     /* 1826674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1826685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1826688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1826694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826720 */     // MIs[0] policy
     /* 1826720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826730 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1826733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826754 */     // GIR_Coverage, 12998,
     /* 1826754 */     GIR_EraseRootFromParent_Done,
     /* 1826755 */   // Label 24761: @1826755
     /* 1826755 */   GIM_Try, /*On fail goto*//*Label 24762*/ GIMT_Encode4(1826841), // Rule ID 12999 //
     /* 1826760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1826771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1826774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1826780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826806 */     // MIs[0] policy
     /* 1826806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826816 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1826819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826840 */     // GIR_Coverage, 12999,
     /* 1826840 */     GIR_EraseRootFromParent_Done,
     /* 1826841 */   // Label 24762: @1826841
     /* 1826841 */   GIM_Try, /*On fail goto*//*Label 24763*/ GIMT_Encode4(1826927), // Rule ID 13002 //
     /* 1826846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1826857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1826860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1826866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826892 */     // MIs[0] policy
     /* 1826892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826902 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1826905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826926 */     // GIR_Coverage, 13002,
     /* 1826926 */     GIR_EraseRootFromParent_Done,
     /* 1826927 */   // Label 24763: @1826927
     /* 1826927 */   GIM_Try, /*On fail goto*//*Label 24764*/ GIMT_Encode4(1827013), // Rule ID 13003 //
     /* 1826932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1826943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1826946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1826952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826978 */     // MIs[0] policy
     /* 1826978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826988 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1826991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827012 */     // GIR_Coverage, 13003,
     /* 1827012 */     GIR_EraseRootFromParent_Done,
     /* 1827013 */   // Label 24764: @1827013
     /* 1827013 */   GIM_Try, /*On fail goto*//*Label 24765*/ GIMT_Encode4(1827099), // Rule ID 13006 //
     /* 1827018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1827029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1827032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1827038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827064 */     // MIs[0] policy
     /* 1827064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827074 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1827077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827098 */     // GIR_Coverage, 13006,
     /* 1827098 */     GIR_EraseRootFromParent_Done,
     /* 1827099 */   // Label 24765: @1827099
     /* 1827099 */   GIM_Try, /*On fail goto*//*Label 24766*/ GIMT_Encode4(1827185), // Rule ID 13007 //
     /* 1827104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1827115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1827118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1827124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827150 */     // MIs[0] policy
     /* 1827150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827160 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1827163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827184 */     // GIR_Coverage, 13007,
     /* 1827184 */     GIR_EraseRootFromParent_Done,
     /* 1827185 */   // Label 24766: @1827185
     /* 1827185 */   GIM_Try, /*On fail goto*//*Label 24767*/ GIMT_Encode4(1827271), // Rule ID 13010 //
     /* 1827190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1827201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1827204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1827210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827236 */     // MIs[0] policy
     /* 1827236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827246 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827270 */     // GIR_Coverage, 13010,
     /* 1827270 */     GIR_EraseRootFromParent_Done,
     /* 1827271 */   // Label 24767: @1827271
     /* 1827271 */   GIM_Try, /*On fail goto*//*Label 24768*/ GIMT_Encode4(1827357), // Rule ID 13011 //
     /* 1827276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1827287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1827290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1827296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827322 */     // MIs[0] policy
     /* 1827322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827332 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827356 */     // GIR_Coverage, 13011,
     /* 1827356 */     GIR_EraseRootFromParent_Done,
     /* 1827357 */   // Label 24768: @1827357
     /* 1827357 */   GIM_Try, /*On fail goto*//*Label 24769*/ GIMT_Encode4(1827443), // Rule ID 13014 //
     /* 1827362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1827373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1827376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1827382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827408 */     // MIs[0] policy
     /* 1827408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827418 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827442 */     // GIR_Coverage, 13014,
     /* 1827442 */     GIR_EraseRootFromParent_Done,
     /* 1827443 */   // Label 24769: @1827443
     /* 1827443 */   GIM_Try, /*On fail goto*//*Label 24770*/ GIMT_Encode4(1827529), // Rule ID 13015 //
     /* 1827448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1827459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1827462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1827468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827494 */     // MIs[0] policy
     /* 1827494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827504 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827528 */     // GIR_Coverage, 13015,
     /* 1827528 */     GIR_EraseRootFromParent_Done,
     /* 1827529 */   // Label 24770: @1827529
     /* 1827529 */   GIM_Try, /*On fail goto*//*Label 24771*/ GIMT_Encode4(1827615), // Rule ID 13018 //
     /* 1827534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1827545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1827548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1827554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827580 */     // MIs[0] policy
     /* 1827580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827590 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1827593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827614 */     // GIR_Coverage, 13018,
     /* 1827614 */     GIR_EraseRootFromParent_Done,
     /* 1827615 */   // Label 24771: @1827615
     /* 1827615 */   GIM_Try, /*On fail goto*//*Label 24772*/ GIMT_Encode4(1827701), // Rule ID 13019 //
     /* 1827620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1827631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1827634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1827640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827666 */     // MIs[0] policy
     /* 1827666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827676 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1827679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827700 */     // GIR_Coverage, 13019,
     /* 1827700 */     GIR_EraseRootFromParent_Done,
     /* 1827701 */   // Label 24772: @1827701
     /* 1827701 */   GIM_Try, /*On fail goto*//*Label 24773*/ GIMT_Encode4(1827787), // Rule ID 13022 //
     /* 1827706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1827717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1827720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1827726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827752 */     // MIs[0] policy
     /* 1827752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827762 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1827765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827786 */     // GIR_Coverage, 13022,
     /* 1827786 */     GIR_EraseRootFromParent_Done,
     /* 1827787 */   // Label 24773: @1827787
     /* 1827787 */   GIM_Try, /*On fail goto*//*Label 24774*/ GIMT_Encode4(1827873), // Rule ID 13023 //
     /* 1827792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1827803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1827806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1827812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827838 */     // MIs[0] policy
     /* 1827838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827848 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1827851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827872 */     // GIR_Coverage, 13023,
     /* 1827872 */     GIR_EraseRootFromParent_Done,
     /* 1827873 */   // Label 24774: @1827873
     /* 1827873 */   GIM_Try, /*On fail goto*//*Label 24775*/ GIMT_Encode4(1827959), // Rule ID 13026 //
     /* 1827878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1827889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1827892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1827898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827924 */     // MIs[0] policy
     /* 1827924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1827937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827958 */     // GIR_Coverage, 13026,
     /* 1827958 */     GIR_EraseRootFromParent_Done,
     /* 1827959 */   // Label 24775: @1827959
     /* 1827959 */   GIM_Try, /*On fail goto*//*Label 24776*/ GIMT_Encode4(1828045), // Rule ID 13027 //
     /* 1827964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1827975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1827978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1827984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828010 */     // MIs[0] policy
     /* 1828010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828044 */     // GIR_Coverage, 13027,
     /* 1828044 */     GIR_EraseRootFromParent_Done,
     /* 1828045 */   // Label 24776: @1828045
     /* 1828045 */   GIM_Try, /*On fail goto*//*Label 24777*/ GIMT_Encode4(1828131), // Rule ID 13030 //
     /* 1828050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1828053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1828061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1828064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1828070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828096 */     // MIs[0] policy
     /* 1828096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1828127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828130 */     // GIR_Coverage, 13030,
     /* 1828130 */     GIR_EraseRootFromParent_Done,
     /* 1828131 */   // Label 24777: @1828131
     /* 1828131 */   GIM_Try, /*On fail goto*//*Label 24778*/ GIMT_Encode4(1828217), // Rule ID 13031 //
     /* 1828136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1828139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1828147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1828150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1828156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828182 */     // MIs[0] policy
     /* 1828182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828192 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1828213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828216 */     // GIR_Coverage, 13031,
     /* 1828216 */     GIR_EraseRootFromParent_Done,
     /* 1828217 */   // Label 24778: @1828217
     /* 1828217 */   GIM_Try, /*On fail goto*//*Label 24779*/ GIMT_Encode4(1828303), // Rule ID 13034 //
     /* 1828222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1828233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1828236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1828242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1828245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828268 */     // MIs[0] policy
     /* 1828268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828278 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1828281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828302 */     // GIR_Coverage, 13034,
     /* 1828302 */     GIR_EraseRootFromParent_Done,
     /* 1828303 */   // Label 24779: @1828303
     /* 1828303 */   GIM_Try, /*On fail goto*//*Label 24780*/ GIMT_Encode4(1828389), // Rule ID 13035 //
     /* 1828308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1828319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1828322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1828328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1828331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828354 */     // MIs[0] policy
     /* 1828354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828364 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1828367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828388 */     // GIR_Coverage, 13035,
     /* 1828388 */     GIR_EraseRootFromParent_Done,
     /* 1828389 */   // Label 24780: @1828389
     /* 1828389 */   GIM_Try, /*On fail goto*//*Label 24781*/ GIMT_Encode4(1828475), // Rule ID 13038 //
     /* 1828394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1828405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1828408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1828414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1828417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1828424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828440 */     // MIs[0] policy
     /* 1828440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828450 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1828453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828474 */     // GIR_Coverage, 13038,
     /* 1828474 */     GIR_EraseRootFromParent_Done,
     /* 1828475 */   // Label 24781: @1828475
     /* 1828475 */   GIM_Try, /*On fail goto*//*Label 24782*/ GIMT_Encode4(1828561), // Rule ID 13039 //
     /* 1828480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1828491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1828494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1828500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1828503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1828510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828526 */     // MIs[0] policy
     /* 1828526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828536 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1828539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828560 */     // GIR_Coverage, 13039,
     /* 1828560 */     GIR_EraseRootFromParent_Done,
     /* 1828561 */   // Label 24782: @1828561
     /* 1828561 */   GIM_Try, /*On fail goto*//*Label 24783*/ GIMT_Encode4(1828647), // Rule ID 13042 //
     /* 1828566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1828577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1828580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1828586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1828589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1828596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828612 */     // MIs[0] policy
     /* 1828612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828622 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1828625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828646 */     // GIR_Coverage, 13042,
     /* 1828646 */     GIR_EraseRootFromParent_Done,
     /* 1828647 */   // Label 24783: @1828647
     /* 1828647 */   GIM_Try, /*On fail goto*//*Label 24784*/ GIMT_Encode4(1828733), // Rule ID 13043 //
     /* 1828652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1828663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1828666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1828672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1828675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1828682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828698 */     // MIs[0] policy
     /* 1828698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828708 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1828711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828732 */     // GIR_Coverage, 13043,
     /* 1828732 */     GIR_EraseRootFromParent_Done,
     /* 1828733 */   // Label 24784: @1828733
     /* 1828733 */   GIM_Try, /*On fail goto*//*Label 24785*/ GIMT_Encode4(1828819), // Rule ID 13046 //
     /* 1828738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1828749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1828752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1828758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828784 */     // MIs[0] policy
     /* 1828784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1828797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828818 */     // GIR_Coverage, 13046,
     /* 1828818 */     GIR_EraseRootFromParent_Done,
     /* 1828819 */   // Label 24785: @1828819
     /* 1828819 */   GIM_Try, /*On fail goto*//*Label 24786*/ GIMT_Encode4(1828905), // Rule ID 13047 //
     /* 1828824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1828835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1828838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1828844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828870 */     // MIs[0] policy
     /* 1828870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828880 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1828883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828904 */     // GIR_Coverage, 13047,
     /* 1828904 */     GIR_EraseRootFromParent_Done,
     /* 1828905 */   // Label 24786: @1828905
     /* 1828905 */   GIM_Try, /*On fail goto*//*Label 24787*/ GIMT_Encode4(1828991), // Rule ID 13050 //
     /* 1828910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1828921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1828924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1828930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1828933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1828940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828956 */     // MIs[0] policy
     /* 1828956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828966 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1828969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828990 */     // GIR_Coverage, 13050,
     /* 1828990 */     GIR_EraseRootFromParent_Done,
     /* 1828991 */   // Label 24787: @1828991
     /* 1828991 */   GIM_Try, /*On fail goto*//*Label 24788*/ GIMT_Encode4(1829077), // Rule ID 13051 //
     /* 1828996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1829007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1829010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1829016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829042 */     // MIs[0] policy
     /* 1829042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829052 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829076 */     // GIR_Coverage, 13051,
     /* 1829076 */     GIR_EraseRootFromParent_Done,
     /* 1829077 */   // Label 24788: @1829077
     /* 1829077 */   GIM_Try, /*On fail goto*//*Label 24789*/ GIMT_Encode4(1829163), // Rule ID 13054 //
     /* 1829082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1829093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1829096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1829102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829128 */     // MIs[0] policy
     /* 1829128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829138 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829162 */     // GIR_Coverage, 13054,
     /* 1829162 */     GIR_EraseRootFromParent_Done,
     /* 1829163 */   // Label 24789: @1829163
     /* 1829163 */   GIM_Try, /*On fail goto*//*Label 24790*/ GIMT_Encode4(1829249), // Rule ID 13055 //
     /* 1829168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1829179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1829182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1829188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829214 */     // MIs[0] policy
     /* 1829214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829224 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829248 */     // GIR_Coverage, 13055,
     /* 1829248 */     GIR_EraseRootFromParent_Done,
     /* 1829249 */   // Label 24790: @1829249
     /* 1829249 */   GIM_Try, /*On fail goto*//*Label 24791*/ GIMT_Encode4(1829335), // Rule ID 13058 //
     /* 1829254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1829265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1829268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1829274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829300 */     // MIs[0] policy
     /* 1829300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829310 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829334 */     // GIR_Coverage, 13058,
     /* 1829334 */     GIR_EraseRootFromParent_Done,
     /* 1829335 */   // Label 24791: @1829335
     /* 1829335 */   GIM_Try, /*On fail goto*//*Label 24792*/ GIMT_Encode4(1829421), // Rule ID 13059 //
     /* 1829340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1829351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1829354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1829360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829386 */     // MIs[0] policy
     /* 1829386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829420 */     // GIR_Coverage, 13059,
     /* 1829420 */     GIR_EraseRootFromParent_Done,
     /* 1829421 */   // Label 24792: @1829421
     /* 1829421 */   GIM_Try, /*On fail goto*//*Label 24793*/ GIMT_Encode4(1829507), // Rule ID 13062 //
     /* 1829426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1829437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1829440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1829446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829472 */     // MIs[0] policy
     /* 1829472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829506 */     // GIR_Coverage, 13062,
     /* 1829506 */     GIR_EraseRootFromParent_Done,
     /* 1829507 */   // Label 24793: @1829507
     /* 1829507 */   GIM_Try, /*On fail goto*//*Label 24794*/ GIMT_Encode4(1829593), // Rule ID 13063 //
     /* 1829512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1829523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1829526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1829532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829558 */     // MIs[0] policy
     /* 1829558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829592 */     // GIR_Coverage, 13063,
     /* 1829592 */     GIR_EraseRootFromParent_Done,
     /* 1829593 */   // Label 24794: @1829593
     /* 1829593 */   GIM_Try, /*On fail goto*//*Label 24795*/ GIMT_Encode4(1829679), // Rule ID 13066 //
     /* 1829598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1829609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1829612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1829618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829644 */     // MIs[0] policy
     /* 1829644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829654 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829678 */     // GIR_Coverage, 13066,
     /* 1829678 */     GIR_EraseRootFromParent_Done,
     /* 1829679 */   // Label 24795: @1829679
     /* 1829679 */   GIM_Try, /*On fail goto*//*Label 24796*/ GIMT_Encode4(1829765), // Rule ID 13067 //
     /* 1829684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1829695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1829698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1829704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829730 */     // MIs[0] policy
     /* 1829730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829740 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829764 */     // GIR_Coverage, 13067,
     /* 1829764 */     GIR_EraseRootFromParent_Done,
     /* 1829765 */   // Label 24796: @1829765
     /* 1829765 */   GIM_Try, /*On fail goto*//*Label 24797*/ GIMT_Encode4(1829851), // Rule ID 13070 //
     /* 1829770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1829773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1829781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1829784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1829790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1829793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829816 */     // MIs[0] policy
     /* 1829816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829826 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1829847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829850 */     // GIR_Coverage, 13070,
     /* 1829850 */     GIR_EraseRootFromParent_Done,
     /* 1829851 */   // Label 24797: @1829851
     /* 1829851 */   GIM_Try, /*On fail goto*//*Label 24798*/ GIMT_Encode4(1829937), // Rule ID 13071 //
     /* 1829856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1829859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1829867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1829870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1829876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1829879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829902 */     // MIs[0] policy
     /* 1829902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829912 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1829933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829936 */     // GIR_Coverage, 13071,
     /* 1829936 */     GIR_EraseRootFromParent_Done,
     /* 1829937 */   // Label 24798: @1829937
     /* 1829937 */   GIM_Try, /*On fail goto*//*Label 24799*/ GIMT_Encode4(1830023), // Rule ID 13074 //
     /* 1829942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1829945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1829953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1829956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1829962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829988 */     // MIs[0] policy
     /* 1829988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829998 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1830001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830022 */     // GIR_Coverage, 13074,
     /* 1830022 */     GIR_EraseRootFromParent_Done,
     /* 1830023 */   // Label 24799: @1830023
     /* 1830023 */   GIM_Try, /*On fail goto*//*Label 24800*/ GIMT_Encode4(1830109), // Rule ID 13075 //
     /* 1830028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1830031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1830039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1830042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1830048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830074 */     // MIs[0] policy
     /* 1830074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830084 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1830087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830108 */     // GIR_Coverage, 13075,
     /* 1830108 */     GIR_EraseRootFromParent_Done,
     /* 1830109 */   // Label 24800: @1830109
     /* 1830109 */   GIM_Try, /*On fail goto*//*Label 24801*/ GIMT_Encode4(1830195), // Rule ID 13078 //
     /* 1830114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1830117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1830125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1830128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1830134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830160 */     // MIs[0] policy
     /* 1830160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830170 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1830173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830194 */     // GIR_Coverage, 13078,
     /* 1830194 */     GIR_EraseRootFromParent_Done,
     /* 1830195 */   // Label 24801: @1830195
     /* 1830195 */   GIM_Try, /*On fail goto*//*Label 24802*/ GIMT_Encode4(1830281), // Rule ID 13079 //
     /* 1830200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1830203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1830211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1830214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1830220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830246 */     // MIs[0] policy
     /* 1830246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830256 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1830259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830280 */     // GIR_Coverage, 13079,
     /* 1830280 */     GIR_EraseRootFromParent_Done,
     /* 1830281 */   // Label 24802: @1830281
     /* 1830281 */   GIM_Try, /*On fail goto*//*Label 24803*/ GIMT_Encode4(1830367), // Rule ID 13082 //
     /* 1830286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1830297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1830300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1830303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1830306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830332 */     // MIs[0] policy
     /* 1830332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830342 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1830345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830366 */     // GIR_Coverage, 13082,
     /* 1830366 */     GIR_EraseRootFromParent_Done,
     /* 1830367 */   // Label 24803: @1830367
     /* 1830367 */   GIM_Try, /*On fail goto*//*Label 24804*/ GIMT_Encode4(1830453), // Rule ID 13083 //
     /* 1830372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1830383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1830386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1830389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1830392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830418 */     // MIs[0] policy
     /* 1830418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830428 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1830431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830452 */     // GIR_Coverage, 13083,
     /* 1830452 */     GIR_EraseRootFromParent_Done,
     /* 1830453 */   // Label 24804: @1830453
     /* 1830453 */   GIM_Try, /*On fail goto*//*Label 24805*/ GIMT_Encode4(1830539), // Rule ID 13086 //
     /* 1830458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1830469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1830472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1830475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1830478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830504 */     // MIs[0] policy
     /* 1830504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830514 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1830517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830538 */     // GIR_Coverage, 13086,
     /* 1830538 */     GIR_EraseRootFromParent_Done,
     /* 1830539 */   // Label 24805: @1830539
     /* 1830539 */   GIM_Try, /*On fail goto*//*Label 24806*/ GIMT_Encode4(1830625), // Rule ID 13087 //
     /* 1830544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1830555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1830558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1830561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1830564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830590 */     // MIs[0] policy
     /* 1830590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830600 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1830603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830624 */     // GIR_Coverage, 13087,
     /* 1830624 */     GIR_EraseRootFromParent_Done,
     /* 1830625 */   // Label 24806: @1830625
     /* 1830625 */   GIM_Try, /*On fail goto*//*Label 24807*/ GIMT_Encode4(1830711), // Rule ID 13090 //
     /* 1830630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1830641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1830644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1830647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1830650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830676 */     // MIs[0] policy
     /* 1830676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830686 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1830689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830710 */     // GIR_Coverage, 13090,
     /* 1830710 */     GIR_EraseRootFromParent_Done,
     /* 1830711 */   // Label 24807: @1830711
     /* 1830711 */   GIM_Try, /*On fail goto*//*Label 24808*/ GIMT_Encode4(1830797), // Rule ID 13091 //
     /* 1830716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1830727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1830730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1830733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1830736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830762 */     // MIs[0] policy
     /* 1830762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830772 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1830775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830796 */     // GIR_Coverage, 13091,
     /* 1830796 */     GIR_EraseRootFromParent_Done,
     /* 1830797 */   // Label 24808: @1830797
     /* 1830797 */   GIM_Try, /*On fail goto*//*Label 24809*/ GIMT_Encode4(1830883), // Rule ID 13094 //
     /* 1830802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1830813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1830816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1830819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1830822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830848 */     // MIs[0] policy
     /* 1830848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830858 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1830861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830882 */     // GIR_Coverage, 13094,
     /* 1830882 */     GIR_EraseRootFromParent_Done,
     /* 1830883 */   // Label 24809: @1830883
     /* 1830883 */   GIM_Try, /*On fail goto*//*Label 24810*/ GIMT_Encode4(1830969), // Rule ID 13095 //
     /* 1830888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1830899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1830902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1830905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1830908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830934 */     // MIs[0] policy
     /* 1830934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830944 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1830947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830968 */     // GIR_Coverage, 13095,
     /* 1830968 */     GIR_EraseRootFromParent_Done,
     /* 1830969 */   // Label 24810: @1830969
     /* 1830969 */   GIM_Try, /*On fail goto*//*Label 24811*/ GIMT_Encode4(1831055), // Rule ID 13098 //
     /* 1830974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1830985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1830988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1830991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1830994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831020 */     // MIs[0] policy
     /* 1831020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831030 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831054 */     // GIR_Coverage, 13098,
     /* 1831054 */     GIR_EraseRootFromParent_Done,
     /* 1831055 */   // Label 24811: @1831055
     /* 1831055 */   GIM_Try, /*On fail goto*//*Label 24812*/ GIMT_Encode4(1831141), // Rule ID 13099 //
     /* 1831060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1831071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1831074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1831077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1831080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831106 */     // MIs[0] policy
     /* 1831106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831116 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831140 */     // GIR_Coverage, 13099,
     /* 1831140 */     GIR_EraseRootFromParent_Done,
     /* 1831141 */   // Label 24812: @1831141
     /* 1831141 */   GIM_Try, /*On fail goto*//*Label 24813*/ GIMT_Encode4(1831227), // Rule ID 13102 //
     /* 1831146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1831157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1831160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1831163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1831166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831192 */     // MIs[0] policy
     /* 1831192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831202 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831226 */     // GIR_Coverage, 13102,
     /* 1831226 */     GIR_EraseRootFromParent_Done,
     /* 1831227 */   // Label 24813: @1831227
     /* 1831227 */   GIM_Try, /*On fail goto*//*Label 24814*/ GIMT_Encode4(1831313), // Rule ID 13103 //
     /* 1831232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1831243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1831246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1831249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1831252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831278 */     // MIs[0] policy
     /* 1831278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831288 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831312 */     // GIR_Coverage, 13103,
     /* 1831312 */     GIR_EraseRootFromParent_Done,
     /* 1831313 */   // Label 24814: @1831313
     /* 1831313 */   GIM_Try, /*On fail goto*//*Label 24815*/ GIMT_Encode4(1831399), // Rule ID 13106 //
     /* 1831318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1831329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1831332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1831335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1831338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831364 */     // MIs[0] policy
     /* 1831364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831374 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831398 */     // GIR_Coverage, 13106,
     /* 1831398 */     GIR_EraseRootFromParent_Done,
     /* 1831399 */   // Label 24815: @1831399
     /* 1831399 */   GIM_Try, /*On fail goto*//*Label 24816*/ GIMT_Encode4(1831485), // Rule ID 13107 //
     /* 1831404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1831415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1831418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1831421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1831424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831450 */     // MIs[0] policy
     /* 1831450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831460 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831484 */     // GIR_Coverage, 13107,
     /* 1831484 */     GIR_EraseRootFromParent_Done,
     /* 1831485 */   // Label 24816: @1831485
     /* 1831485 */   GIM_Try, /*On fail goto*//*Label 24817*/ GIMT_Encode4(1831571), // Rule ID 13110 //
     /* 1831490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1831501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1831504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1831507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1831510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831536 */     // MIs[0] policy
     /* 1831536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831570 */     // GIR_Coverage, 13110,
     /* 1831570 */     GIR_EraseRootFromParent_Done,
     /* 1831571 */   // Label 24817: @1831571
     /* 1831571 */   GIM_Try, /*On fail goto*//*Label 24818*/ GIMT_Encode4(1831657), // Rule ID 13111 //
     /* 1831576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1831587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1831590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1831593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1831596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831622 */     // MIs[0] policy
     /* 1831622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831656 */     // GIR_Coverage, 13111,
     /* 1831656 */     GIR_EraseRootFromParent_Done,
     /* 1831657 */   // Label 24818: @1831657
     /* 1831657 */   GIM_Try, /*On fail goto*//*Label 24819*/ GIMT_Encode4(1831743), // Rule ID 13114 //
     /* 1831662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1831673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1831676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1831679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1831682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831708 */     // MIs[0] policy
     /* 1831708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831742 */     // GIR_Coverage, 13114,
     /* 1831742 */     GIR_EraseRootFromParent_Done,
     /* 1831743 */   // Label 24819: @1831743
     /* 1831743 */   GIM_Try, /*On fail goto*//*Label 24820*/ GIMT_Encode4(1831829), // Rule ID 13115 //
     /* 1831748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1831759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1831762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1831765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1831768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831794 */     // MIs[0] policy
     /* 1831794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831804 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831828 */     // GIR_Coverage, 13115,
     /* 1831828 */     GIR_EraseRootFromParent_Done,
     /* 1831829 */   // Label 24820: @1831829
     /* 1831829 */   GIM_Try, /*On fail goto*//*Label 24821*/ GIMT_Encode4(1831915), // Rule ID 13118 //
     /* 1831834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1831837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1831845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1831848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1831851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1831854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831880 */     // MIs[0] policy
     /* 1831880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831914 */     // GIR_Coverage, 13118,
     /* 1831914 */     GIR_EraseRootFromParent_Done,
     /* 1831915 */   // Label 24821: @1831915
     /* 1831915 */   GIM_Try, /*On fail goto*//*Label 24822*/ GIMT_Encode4(1832001), // Rule ID 13119 //
     /* 1831920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1831923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1831931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1831934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1831937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1831940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831966 */     // MIs[0] policy
     /* 1831966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831976 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832000 */     // GIR_Coverage, 13119,
     /* 1832000 */     GIR_EraseRootFromParent_Done,
     /* 1832001 */   // Label 24822: @1832001
     /* 1832001 */   GIM_Try, /*On fail goto*//*Label 24823*/ GIMT_Encode4(1832087), // Rule ID 13122 //
     /* 1832006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1832017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1832020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1832023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1832026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832052 */     // MIs[0] policy
     /* 1832052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832062 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1832065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832086 */     // GIR_Coverage, 13122,
     /* 1832086 */     GIR_EraseRootFromParent_Done,
     /* 1832087 */   // Label 24823: @1832087
     /* 1832087 */   GIM_Try, /*On fail goto*//*Label 24824*/ GIMT_Encode4(1832173), // Rule ID 13123 //
     /* 1832092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1832103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1832106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1832109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1832112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832138 */     // MIs[0] policy
     /* 1832138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832148 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1832151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832172 */     // GIR_Coverage, 13123,
     /* 1832172 */     GIR_EraseRootFromParent_Done,
     /* 1832173 */   // Label 24824: @1832173
     /* 1832173 */   GIM_Try, /*On fail goto*//*Label 24825*/ GIMT_Encode4(1832259), // Rule ID 13126 //
     /* 1832178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1832189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1832192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1832195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1832198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832224 */     // MIs[0] policy
     /* 1832224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832234 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1832237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832258 */     // GIR_Coverage, 13126,
     /* 1832258 */     GIR_EraseRootFromParent_Done,
     /* 1832259 */   // Label 24825: @1832259
     /* 1832259 */   GIM_Try, /*On fail goto*//*Label 24826*/ GIMT_Encode4(1832345), // Rule ID 13127 //
     /* 1832264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1832275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1832278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1832281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1832284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832310 */     // MIs[0] policy
     /* 1832310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832320 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1832323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832344 */     // GIR_Coverage, 13127,
     /* 1832344 */     GIR_EraseRootFromParent_Done,
     /* 1832345 */   // Label 24826: @1832345
     /* 1832345 */   GIM_Try, /*On fail goto*//*Label 24827*/ GIMT_Encode4(1832431), // Rule ID 13130 //
     /* 1832350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1832361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1832364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1832367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1832370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1832373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832396 */     // MIs[0] policy
     /* 1832396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832406 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1832409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832430 */     // GIR_Coverage, 13130,
     /* 1832430 */     GIR_EraseRootFromParent_Done,
     /* 1832431 */   // Label 24827: @1832431
     /* 1832431 */   GIM_Try, /*On fail goto*//*Label 24828*/ GIMT_Encode4(1832517), // Rule ID 13131 //
     /* 1832436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1832447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1832450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1832453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1832456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1832459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832482 */     // MIs[0] policy
     /* 1832482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832492 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1832495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832516 */     // GIR_Coverage, 13131,
     /* 1832516 */     GIR_EraseRootFromParent_Done,
     /* 1832517 */   // Label 24828: @1832517
     /* 1832517 */   GIM_Try, /*On fail goto*//*Label 24829*/ GIMT_Encode4(1832603), // Rule ID 13134 //
     /* 1832522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1832533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1832536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1832539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1832542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1832545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832568 */     // MIs[0] policy
     /* 1832568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832578 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1832581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832602 */     // GIR_Coverage, 13134,
     /* 1832602 */     GIR_EraseRootFromParent_Done,
     /* 1832603 */   // Label 24829: @1832603
     /* 1832603 */   GIM_Try, /*On fail goto*//*Label 24830*/ GIMT_Encode4(1832689), // Rule ID 13135 //
     /* 1832608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1832619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1832622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1832625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1832628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1832631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832654 */     // MIs[0] policy
     /* 1832654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832664 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1832667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832688 */     // GIR_Coverage, 13135,
     /* 1832688 */     GIR_EraseRootFromParent_Done,
     /* 1832689 */   // Label 24830: @1832689
     /* 1832689 */   GIM_Try, /*On fail goto*//*Label 24831*/ GIMT_Encode4(1832775), // Rule ID 13138 //
     /* 1832694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1832705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1832708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1832711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1832714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832740 */     // MIs[0] policy
     /* 1832740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832750 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1832753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832774 */     // GIR_Coverage, 13138,
     /* 1832774 */     GIR_EraseRootFromParent_Done,
     /* 1832775 */   // Label 24831: @1832775
     /* 1832775 */   GIM_Try, /*On fail goto*//*Label 24832*/ GIMT_Encode4(1832861), // Rule ID 13139 //
     /* 1832780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1832791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1832794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1832797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1832800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832826 */     // MIs[0] policy
     /* 1832826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832836 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1832839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832860 */     // GIR_Coverage, 13139,
     /* 1832860 */     GIR_EraseRootFromParent_Done,
     /* 1832861 */   // Label 24832: @1832861
     /* 1832861 */   GIM_Try, /*On fail goto*//*Label 24833*/ GIMT_Encode4(1832947), // Rule ID 13142 //
     /* 1832866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1832877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1832880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1832883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1832886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832912 */     // MIs[0] policy
     /* 1832912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832922 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1832925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832946 */     // GIR_Coverage, 13142,
     /* 1832946 */     GIR_EraseRootFromParent_Done,
     /* 1832947 */   // Label 24833: @1832947
     /* 1832947 */   GIM_Try, /*On fail goto*//*Label 24834*/ GIMT_Encode4(1833033), // Rule ID 13143 //
     /* 1832952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1832963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1832966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1832969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1832972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832998 */     // MIs[0] policy
     /* 1832998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833008 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833032 */     // GIR_Coverage, 13143,
     /* 1833032 */     GIR_EraseRootFromParent_Done,
     /* 1833033 */   // Label 24834: @1833033
     /* 1833033 */   GIM_Try, /*On fail goto*//*Label 24835*/ GIMT_Encode4(1833119), // Rule ID 13146 //
     /* 1833038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1833049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1833052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1833055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1833058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833084 */     // MIs[0] policy
     /* 1833084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833118 */     // GIR_Coverage, 13146,
     /* 1833118 */     GIR_EraseRootFromParent_Done,
     /* 1833119 */   // Label 24835: @1833119
     /* 1833119 */   GIM_Try, /*On fail goto*//*Label 24836*/ GIMT_Encode4(1833205), // Rule ID 13147 //
     /* 1833124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1833135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1833138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1833141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1833144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833170 */     // MIs[0] policy
     /* 1833170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833180 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833204 */     // GIR_Coverage, 13147,
     /* 1833204 */     GIR_EraseRootFromParent_Done,
     /* 1833205 */   // Label 24836: @1833205
     /* 1833205 */   GIM_Try, /*On fail goto*//*Label 24837*/ GIMT_Encode4(1833291), // Rule ID 13150 //
     /* 1833210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1833221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1833224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1833227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1833230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833256 */     // MIs[0] policy
     /* 1833256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833266 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833290 */     // GIR_Coverage, 13150,
     /* 1833290 */     GIR_EraseRootFromParent_Done,
     /* 1833291 */   // Label 24837: @1833291
     /* 1833291 */   GIM_Try, /*On fail goto*//*Label 24838*/ GIMT_Encode4(1833377), // Rule ID 13151 //
     /* 1833296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1833307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1833310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1833313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1833316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833342 */     // MIs[0] policy
     /* 1833342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833352 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833376 */     // GIR_Coverage, 13151,
     /* 1833376 */     GIR_EraseRootFromParent_Done,
     /* 1833377 */   // Label 24838: @1833377
     /* 1833377 */   GIM_Try, /*On fail goto*//*Label 24839*/ GIMT_Encode4(1833463), // Rule ID 13154 //
     /* 1833382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1833393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1833396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1833399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1833402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833428 */     // MIs[0] policy
     /* 1833428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833438 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833462 */     // GIR_Coverage, 13154,
     /* 1833462 */     GIR_EraseRootFromParent_Done,
     /* 1833463 */   // Label 24839: @1833463
     /* 1833463 */   GIM_Try, /*On fail goto*//*Label 24840*/ GIMT_Encode4(1833549), // Rule ID 13155 //
     /* 1833468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1833479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1833482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1833485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1833488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833514 */     // MIs[0] policy
     /* 1833514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833524 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833548 */     // GIR_Coverage, 13155,
     /* 1833548 */     GIR_EraseRootFromParent_Done,
     /* 1833549 */   // Label 24840: @1833549
     /* 1833549 */   GIM_Try, /*On fail goto*//*Label 24841*/ GIMT_Encode4(1833635), // Rule ID 13158 //
     /* 1833554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1833557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1833565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1833568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1833571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1833574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1833577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833600 */     // MIs[0] policy
     /* 1833600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833610 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833634 */     // GIR_Coverage, 13158,
     /* 1833634 */     GIR_EraseRootFromParent_Done,
     /* 1833635 */   // Label 24841: @1833635
     /* 1833635 */   GIM_Try, /*On fail goto*//*Label 24842*/ GIMT_Encode4(1833721), // Rule ID 13159 //
     /* 1833640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1833643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1833651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1833654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1833657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1833660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1833663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833686 */     // MIs[0] policy
     /* 1833686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833696 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833720 */     // GIR_Coverage, 13159,
     /* 1833720 */     GIR_EraseRootFromParent_Done,
     /* 1833721 */   // Label 24842: @1833721
     /* 1833721 */   GIM_Try, /*On fail goto*//*Label 24843*/ GIMT_Encode4(1833807), // Rule ID 13162 //
     /* 1833726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1833729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1833737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1833740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1833743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1833746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833772 */     // MIs[0] policy
     /* 1833772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833782 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833806 */     // GIR_Coverage, 13162,
     /* 1833806 */     GIR_EraseRootFromParent_Done,
     /* 1833807 */   // Label 24843: @1833807
     /* 1833807 */   GIM_Try, /*On fail goto*//*Label 24844*/ GIMT_Encode4(1833893), // Rule ID 13163 //
     /* 1833812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1833815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1833823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1833826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1833829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1833832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833858 */     // MIs[0] policy
     /* 1833858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833868 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833892 */     // GIR_Coverage, 13163,
     /* 1833892 */     GIR_EraseRootFromParent_Done,
     /* 1833893 */   // Label 24844: @1833893
     /* 1833893 */   GIM_Try, /*On fail goto*//*Label 24845*/ GIMT_Encode4(1833979), // Rule ID 13166 //
     /* 1833898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1833901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1833909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1833912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1833915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1833918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833944 */     // MIs[0] policy
     /* 1833944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833954 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833978 */     // GIR_Coverage, 13166,
     /* 1833978 */     GIR_EraseRootFromParent_Done,
     /* 1833979 */   // Label 24845: @1833979
     /* 1833979 */   GIM_Try, /*On fail goto*//*Label 24846*/ GIMT_Encode4(1834065), // Rule ID 13167 //
     /* 1833984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1833987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1833995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1833998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1834001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1834004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834030 */     // MIs[0] policy
     /* 1834030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834040 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1834043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834064 */     // GIR_Coverage, 13167,
     /* 1834064 */     GIR_EraseRootFromParent_Done,
     /* 1834065 */   // Label 24846: @1834065
     /* 1834065 */   GIM_Try, /*On fail goto*//*Label 24847*/ GIMT_Encode4(1834151), // Rule ID 13170 //
     /* 1834070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1834081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1834084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1834090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834116 */     // MIs[0] policy
     /* 1834116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834126 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1834129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834150 */     // GIR_Coverage, 13170,
     /* 1834150 */     GIR_EraseRootFromParent_Done,
     /* 1834151 */   // Label 24847: @1834151
     /* 1834151 */   GIM_Try, /*On fail goto*//*Label 24848*/ GIMT_Encode4(1834237), // Rule ID 13171 //
     /* 1834156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1834167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1834170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1834176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834202 */     // MIs[0] policy
     /* 1834202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834212 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1834215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834236 */     // GIR_Coverage, 13171,
     /* 1834236 */     GIR_EraseRootFromParent_Done,
     /* 1834237 */   // Label 24848: @1834237
     /* 1834237 */   GIM_Try, /*On fail goto*//*Label 24849*/ GIMT_Encode4(1834323), // Rule ID 13174 //
     /* 1834242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1834253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1834256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1834262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834288 */     // MIs[0] policy
     /* 1834288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834298 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1834301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834322 */     // GIR_Coverage, 13174,
     /* 1834322 */     GIR_EraseRootFromParent_Done,
     /* 1834323 */   // Label 24849: @1834323
     /* 1834323 */   GIM_Try, /*On fail goto*//*Label 24850*/ GIMT_Encode4(1834409), // Rule ID 13175 //
     /* 1834328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1834339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1834342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1834348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834374 */     // MIs[0] policy
     /* 1834374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834384 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1834387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834408 */     // GIR_Coverage, 13175,
     /* 1834408 */     GIR_EraseRootFromParent_Done,
     /* 1834409 */   // Label 24850: @1834409
     /* 1834409 */   GIM_Try, /*On fail goto*//*Label 24851*/ GIMT_Encode4(1834495), // Rule ID 13178 //
     /* 1834414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1834425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1834428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1834434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834460 */     // MIs[0] policy
     /* 1834460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834470 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1834473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834494 */     // GIR_Coverage, 13178,
     /* 1834494 */     GIR_EraseRootFromParent_Done,
     /* 1834495 */   // Label 24851: @1834495
     /* 1834495 */   GIM_Try, /*On fail goto*//*Label 24852*/ GIMT_Encode4(1834581), // Rule ID 13179 //
     /* 1834500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1834511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1834514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1834520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834546 */     // MIs[0] policy
     /* 1834546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834556 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1834559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834580 */     // GIR_Coverage, 13179,
     /* 1834580 */     GIR_EraseRootFromParent_Done,
     /* 1834581 */   // Label 24852: @1834581
     /* 1834581 */   GIM_Try, /*On fail goto*//*Label 24853*/ GIMT_Encode4(1834667), // Rule ID 13182 //
     /* 1834586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1834597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1834600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1834606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834632 */     // MIs[0] policy
     /* 1834632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834642 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1834645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834666 */     // GIR_Coverage, 13182,
     /* 1834666 */     GIR_EraseRootFromParent_Done,
     /* 1834667 */   // Label 24853: @1834667
     /* 1834667 */   GIM_Try, /*On fail goto*//*Label 24854*/ GIMT_Encode4(1834753), // Rule ID 13183 //
     /* 1834672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1834683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1834686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1834692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834718 */     // MIs[0] policy
     /* 1834718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834728 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1834731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834752 */     // GIR_Coverage, 13183,
     /* 1834752 */     GIR_EraseRootFromParent_Done,
     /* 1834753 */   // Label 24854: @1834753
     /* 1834753 */   GIM_Try, /*On fail goto*//*Label 24855*/ GIMT_Encode4(1834839), // Rule ID 13186 //
     /* 1834758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1834769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1834772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1834778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834804 */     // MIs[0] policy
     /* 1834804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834814 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1834817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834838 */     // GIR_Coverage, 13186,
     /* 1834838 */     GIR_EraseRootFromParent_Done,
     /* 1834839 */   // Label 24855: @1834839
     /* 1834839 */   GIM_Try, /*On fail goto*//*Label 24856*/ GIMT_Encode4(1834925), // Rule ID 13187 //
     /* 1834844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1834855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1834858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1834864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834890 */     // MIs[0] policy
     /* 1834890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834900 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1834903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834924 */     // GIR_Coverage, 13187,
     /* 1834924 */     GIR_EraseRootFromParent_Done,
     /* 1834925 */   // Label 24856: @1834925
     /* 1834925 */   GIM_Try, /*On fail goto*//*Label 24857*/ GIMT_Encode4(1835011), // Rule ID 13190 //
     /* 1834930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1834941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1834944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1834950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834976 */     // MIs[0] policy
     /* 1834976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834986 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1834989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835010 */     // GIR_Coverage, 13190,
     /* 1835010 */     GIR_EraseRootFromParent_Done,
     /* 1835011 */   // Label 24857: @1835011
     /* 1835011 */   GIM_Try, /*On fail goto*//*Label 24858*/ GIMT_Encode4(1835097), // Rule ID 13191 //
     /* 1835016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1835027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1835030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1835036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835062 */     // MIs[0] policy
     /* 1835062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835072 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1835075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835096 */     // GIR_Coverage, 13191,
     /* 1835096 */     GIR_EraseRootFromParent_Done,
     /* 1835097 */   // Label 24858: @1835097
     /* 1835097 */   GIM_Try, /*On fail goto*//*Label 24859*/ GIMT_Encode4(1835183), // Rule ID 13194 //
     /* 1835102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1835113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1835116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1835122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835148 */     // MIs[0] policy
     /* 1835148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835158 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835182 */     // GIR_Coverage, 13194,
     /* 1835182 */     GIR_EraseRootFromParent_Done,
     /* 1835183 */   // Label 24859: @1835183
     /* 1835183 */   GIM_Try, /*On fail goto*//*Label 24860*/ GIMT_Encode4(1835269), // Rule ID 13195 //
     /* 1835188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1835199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1835202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1835208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835234 */     // MIs[0] policy
     /* 1835234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835244 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835268 */     // GIR_Coverage, 13195,
     /* 1835268 */     GIR_EraseRootFromParent_Done,
     /* 1835269 */   // Label 24860: @1835269
     /* 1835269 */   GIM_Try, /*On fail goto*//*Label 24861*/ GIMT_Encode4(1835355), // Rule ID 13198 //
     /* 1835274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1835285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1835288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1835294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835320 */     // MIs[0] policy
     /* 1835320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835330 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835354 */     // GIR_Coverage, 13198,
     /* 1835354 */     GIR_EraseRootFromParent_Done,
     /* 1835355 */   // Label 24861: @1835355
     /* 1835355 */   GIM_Try, /*On fail goto*//*Label 24862*/ GIMT_Encode4(1835441), // Rule ID 13199 //
     /* 1835360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1835371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1835374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1835380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835406 */     // MIs[0] policy
     /* 1835406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835416 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835440 */     // GIR_Coverage, 13199,
     /* 1835440 */     GIR_EraseRootFromParent_Done,
     /* 1835441 */   // Label 24862: @1835441
     /* 1835441 */   GIM_Try, /*On fail goto*//*Label 24863*/ GIMT_Encode4(1835527), // Rule ID 13202 //
     /* 1835446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1835457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1835460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1835466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835492 */     // MIs[0] policy
     /* 1835492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835526 */     // GIR_Coverage, 13202,
     /* 1835526 */     GIR_EraseRootFromParent_Done,
     /* 1835527 */   // Label 24863: @1835527
     /* 1835527 */   GIM_Try, /*On fail goto*//*Label 24864*/ GIMT_Encode4(1835613), // Rule ID 13203 //
     /* 1835532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1835543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1835546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1835552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835578 */     // MIs[0] policy
     /* 1835578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835612 */     // GIR_Coverage, 13203,
     /* 1835612 */     GIR_EraseRootFromParent_Done,
     /* 1835613 */   // Label 24864: @1835613
     /* 1835613 */   GIM_Try, /*On fail goto*//*Label 24865*/ GIMT_Encode4(1835699), // Rule ID 13206 //
     /* 1835618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1835621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1835629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1835632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1835638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835664 */     // MIs[0] policy
     /* 1835664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835674 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835698 */     // GIR_Coverage, 13206,
     /* 1835698 */     GIR_EraseRootFromParent_Done,
     /* 1835699 */   // Label 24865: @1835699
     /* 1835699 */   GIM_Try, /*On fail goto*//*Label 24866*/ GIMT_Encode4(1835785), // Rule ID 13207 //
     /* 1835704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1835707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1835715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1835718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1835724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835750 */     // MIs[0] policy
     /* 1835750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835784 */     // GIR_Coverage, 13207,
     /* 1835784 */     GIR_EraseRootFromParent_Done,
     /* 1835785 */   // Label 24866: @1835785
     /* 1835785 */   GIM_Try, /*On fail goto*//*Label 24867*/ GIMT_Encode4(1835871), // Rule ID 13210 //
     /* 1835790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1835801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1835804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1835810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1835813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1835820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835836 */     // MIs[0] policy
     /* 1835836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835846 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1835849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835870 */     // GIR_Coverage, 13210,
     /* 1835870 */     GIR_EraseRootFromParent_Done,
     /* 1835871 */   // Label 24867: @1835871
     /* 1835871 */   GIM_Try, /*On fail goto*//*Label 24868*/ GIMT_Encode4(1835957), // Rule ID 13211 //
     /* 1835876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1835887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1835890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1835896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1835899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1835906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835922 */     // MIs[0] policy
     /* 1835922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835932 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1835935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835956 */     // GIR_Coverage, 13211,
     /* 1835956 */     GIR_EraseRootFromParent_Done,
     /* 1835957 */   // Label 24868: @1835957
     /* 1835957 */   GIM_Try, /*On fail goto*//*Label 24869*/ GIMT_Encode4(1836043), // Rule ID 13214 //
     /* 1835962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1835973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1835976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1835982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1835985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1835992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1835996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836008 */     // MIs[0] policy
     /* 1836008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836018 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836042 */     // GIR_Coverage, 13214,
     /* 1836042 */     GIR_EraseRootFromParent_Done,
     /* 1836043 */   // Label 24869: @1836043
     /* 1836043 */   GIM_Try, /*On fail goto*//*Label 24870*/ GIMT_Encode4(1836129), // Rule ID 13215 //
     /* 1836048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1836059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1836062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1836068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836094 */     // MIs[0] policy
     /* 1836094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836104 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836128 */     // GIR_Coverage, 13215,
     /* 1836128 */     GIR_EraseRootFromParent_Done,
     /* 1836129 */   // Label 24870: @1836129
     /* 1836129 */   GIM_Try, /*On fail goto*//*Label 24871*/ GIMT_Encode4(1836215), // Rule ID 13218 //
     /* 1836134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1836145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1836148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1836154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1836157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836180 */     // MIs[0] policy
     /* 1836180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836190 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1836193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836214 */     // GIR_Coverage, 13218,
     /* 1836214 */     GIR_EraseRootFromParent_Done,
     /* 1836215 */   // Label 24871: @1836215
     /* 1836215 */   GIM_Try, /*On fail goto*//*Label 24872*/ GIMT_Encode4(1836301), // Rule ID 13219 //
     /* 1836220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1836231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1836234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1836240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1836243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836266 */     // MIs[0] policy
     /* 1836266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836276 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1836279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836300 */     // GIR_Coverage, 13219,
     /* 1836300 */     GIR_EraseRootFromParent_Done,
     /* 1836301 */   // Label 24872: @1836301
     /* 1836301 */   GIM_Try, /*On fail goto*//*Label 24873*/ GIMT_Encode4(1836387), // Rule ID 13222 //
     /* 1836306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1836317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1836320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1836326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836352 */     // MIs[0] policy
     /* 1836352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836362 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836386 */     // GIR_Coverage, 13222,
     /* 1836386 */     GIR_EraseRootFromParent_Done,
     /* 1836387 */   // Label 24873: @1836387
     /* 1836387 */   GIM_Try, /*On fail goto*//*Label 24874*/ GIMT_Encode4(1836473), // Rule ID 13223 //
     /* 1836392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1836403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1836406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1836412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836438 */     // MIs[0] policy
     /* 1836438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836472 */     // GIR_Coverage, 13223,
     /* 1836472 */     GIR_EraseRootFromParent_Done,
     /* 1836473 */   // Label 24874: @1836473
     /* 1836473 */   GIM_Try, /*On fail goto*//*Label 24875*/ GIMT_Encode4(1836559), // Rule ID 13226 //
     /* 1836478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1836489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1836492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1836498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836524 */     // MIs[0] policy
     /* 1836524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836534 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836558 */     // GIR_Coverage, 13226,
     /* 1836558 */     GIR_EraseRootFromParent_Done,
     /* 1836559 */   // Label 24875: @1836559
     /* 1836559 */   GIM_Try, /*On fail goto*//*Label 24876*/ GIMT_Encode4(1836645), // Rule ID 13227 //
     /* 1836564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1836575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1836578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1836584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836610 */     // MIs[0] policy
     /* 1836610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836620 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836644 */     // GIR_Coverage, 13227,
     /* 1836644 */     GIR_EraseRootFromParent_Done,
     /* 1836645 */   // Label 24876: @1836645
     /* 1836645 */   GIM_Try, /*On fail goto*//*Label 24877*/ GIMT_Encode4(1836731), // Rule ID 13230 //
     /* 1836650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1836661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1836664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1836670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836696 */     // MIs[0] policy
     /* 1836696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836706 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1836709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836730 */     // GIR_Coverage, 13230,
     /* 1836730 */     GIR_EraseRootFromParent_Done,
     /* 1836731 */   // Label 24877: @1836731
     /* 1836731 */   GIM_Try, /*On fail goto*//*Label 24878*/ GIMT_Encode4(1836817), // Rule ID 13231 //
     /* 1836736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1836747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1836750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1836756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836782 */     // MIs[0] policy
     /* 1836782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836792 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1836795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836816 */     // GIR_Coverage, 13231,
     /* 1836816 */     GIR_EraseRootFromParent_Done,
     /* 1836817 */   // Label 24878: @1836817
     /* 1836817 */   GIM_Try, /*On fail goto*//*Label 24879*/ GIMT_Encode4(1836903), // Rule ID 13234 //
     /* 1836822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1836833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1836836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1836842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1836845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836868 */     // MIs[0] policy
     /* 1836868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836902 */     // GIR_Coverage, 13234,
     /* 1836902 */     GIR_EraseRootFromParent_Done,
     /* 1836903 */   // Label 24879: @1836903
     /* 1836903 */   GIM_Try, /*On fail goto*//*Label 24880*/ GIMT_Encode4(1836989), // Rule ID 13235 //
     /* 1836908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1836919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1836922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1836928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1836931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836954 */     // MIs[0] policy
     /* 1836954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836988 */     // GIR_Coverage, 13235,
     /* 1836988 */     GIR_EraseRootFromParent_Done,
     /* 1836989 */   // Label 24880: @1836989
     /* 1836989 */   GIM_Try, /*On fail goto*//*Label 24881*/ GIMT_Encode4(1837075), // Rule ID 13238 //
     /* 1836994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1837005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1837008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1837014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837040 */     // MIs[0] policy
     /* 1837040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837050 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837074 */     // GIR_Coverage, 13238,
     /* 1837074 */     GIR_EraseRootFromParent_Done,
     /* 1837075 */   // Label 24881: @1837075
     /* 1837075 */   GIM_Try, /*On fail goto*//*Label 24882*/ GIMT_Encode4(1837161), // Rule ID 13239 //
     /* 1837080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1837091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1837094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1837100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837126 */     // MIs[0] policy
     /* 1837126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837136 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837160 */     // GIR_Coverage, 13239,
     /* 1837160 */     GIR_EraseRootFromParent_Done,
     /* 1837161 */   // Label 24882: @1837161
     /* 1837161 */   GIM_Try, /*On fail goto*//*Label 24883*/ GIMT_Encode4(1837247), // Rule ID 13242 //
     /* 1837166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1837177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1837180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1837186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837212 */     // MIs[0] policy
     /* 1837212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837222 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837246 */     // GIR_Coverage, 13242,
     /* 1837246 */     GIR_EraseRootFromParent_Done,
     /* 1837247 */   // Label 24883: @1837247
     /* 1837247 */   GIM_Try, /*On fail goto*//*Label 24884*/ GIMT_Encode4(1837333), // Rule ID 13243 //
     /* 1837252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1837263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1837266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1837272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837298 */     // MIs[0] policy
     /* 1837298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837308 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837332 */     // GIR_Coverage, 13243,
     /* 1837332 */     GIR_EraseRootFromParent_Done,
     /* 1837333 */   // Label 24884: @1837333
     /* 1837333 */   GIM_Try, /*On fail goto*//*Label 24885*/ GIMT_Encode4(1837419), // Rule ID 13246 //
     /* 1837338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1837349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1837352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1837358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837384 */     // MIs[0] policy
     /* 1837384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1837397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837418 */     // GIR_Coverage, 13246,
     /* 1837418 */     GIR_EraseRootFromParent_Done,
     /* 1837419 */   // Label 24885: @1837419
     /* 1837419 */   GIM_Try, /*On fail goto*//*Label 24886*/ GIMT_Encode4(1837505), // Rule ID 13247 //
     /* 1837424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1837427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1837435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1837438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1837444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837470 */     // MIs[0] policy
     /* 1837470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837480 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1837483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837504 */     // GIR_Coverage, 13247,
     /* 1837504 */     GIR_EraseRootFromParent_Done,
     /* 1837505 */   // Label 24886: @1837505
     /* 1837505 */   GIM_Try, /*On fail goto*//*Label 24887*/ GIMT_Encode4(1837591), // Rule ID 13250 //
     /* 1837510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1837521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1837524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1837530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837556 */     // MIs[0] policy
     /* 1837556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837566 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837590 */     // GIR_Coverage, 13250,
     /* 1837590 */     GIR_EraseRootFromParent_Done,
     /* 1837591 */   // Label 24887: @1837591
     /* 1837591 */   GIM_Try, /*On fail goto*//*Label 24888*/ GIMT_Encode4(1837677), // Rule ID 13251 //
     /* 1837596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1837599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1837607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1837610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1837616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837642 */     // MIs[0] policy
     /* 1837642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837652 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837676 */     // GIR_Coverage, 13251,
     /* 1837676 */     GIR_EraseRootFromParent_Done,
     /* 1837677 */   // Label 24888: @1837677
     /* 1837677 */   GIM_Try, /*On fail goto*//*Label 24889*/ GIMT_Encode4(1837763), // Rule ID 13254 //
     /* 1837682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1837693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1837696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1837702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837728 */     // MIs[0] policy
     /* 1837728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837738 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837762 */     // GIR_Coverage, 13254,
     /* 1837762 */     GIR_EraseRootFromParent_Done,
     /* 1837763 */   // Label 24889: @1837763
     /* 1837763 */   GIM_Try, /*On fail goto*//*Label 24890*/ GIMT_Encode4(1837849), // Rule ID 13255 //
     /* 1837768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1837771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1837779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1837782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1837788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837814 */     // MIs[0] policy
     /* 1837814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837824 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837848 */     // GIR_Coverage, 13255,
     /* 1837848 */     GIR_EraseRootFromParent_Done,
     /* 1837849 */   // Label 24890: @1837849
     /* 1837849 */   GIM_Try, /*On fail goto*//*Label 24891*/ GIMT_Encode4(1837935), // Rule ID 13258 //
     /* 1837854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1837865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1837868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1837871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1837874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1837877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1837884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837900 */     // MIs[0] policy
     /* 1837900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837910 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1837913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1837931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837934 */     // GIR_Coverage, 13258,
     /* 1837934 */     GIR_EraseRootFromParent_Done,
     /* 1837935 */   // Label 24891: @1837935
     /* 1837935 */   GIM_Try, /*On fail goto*//*Label 24892*/ GIMT_Encode4(1838021), // Rule ID 13259 //
     /* 1837940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1837951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1837954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1837957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1837960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1837963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1837970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837986 */     // MIs[0] policy
     /* 1837986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1837999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838020 */     // GIR_Coverage, 13259,
     /* 1838020 */     GIR_EraseRootFromParent_Done,
     /* 1838021 */   // Label 24892: @1838021
     /* 1838021 */   GIM_Try, /*On fail goto*//*Label 24893*/ GIMT_Encode4(1838107), // Rule ID 13262 //
     /* 1838026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1838037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1838040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1838043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1838046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838072 */     // MIs[0] policy
     /* 1838072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838082 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838106 */     // GIR_Coverage, 13262,
     /* 1838106 */     GIR_EraseRootFromParent_Done,
     /* 1838107 */   // Label 24893: @1838107
     /* 1838107 */   GIM_Try, /*On fail goto*//*Label 24894*/ GIMT_Encode4(1838193), // Rule ID 13263 //
     /* 1838112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1838123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1838126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1838129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1838132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838158 */     // MIs[0] policy
     /* 1838158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838168 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838192 */     // GIR_Coverage, 13263,
     /* 1838192 */     GIR_EraseRootFromParent_Done,
     /* 1838193 */   // Label 24894: @1838193
     /* 1838193 */   GIM_Try, /*On fail goto*//*Label 24895*/ GIMT_Encode4(1838279), // Rule ID 13266 //
     /* 1838198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1838209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1838212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1838215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1838218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838244 */     // MIs[0] policy
     /* 1838244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838254 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838278 */     // GIR_Coverage, 13266,
     /* 1838278 */     GIR_EraseRootFromParent_Done,
     /* 1838279 */   // Label 24895: @1838279
     /* 1838279 */   GIM_Try, /*On fail goto*//*Label 24896*/ GIMT_Encode4(1838365), // Rule ID 13267 //
     /* 1838284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1838295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1838298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1838301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1838304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838330 */     // MIs[0] policy
     /* 1838330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838340 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838364 */     // GIR_Coverage, 13267,
     /* 1838364 */     GIR_EraseRootFromParent_Done,
     /* 1838365 */   // Label 24896: @1838365
     /* 1838365 */   GIM_Try, /*On fail goto*//*Label 24897*/ GIMT_Encode4(1838451), // Rule ID 13270 //
     /* 1838370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1838381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1838384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1838387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1838390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838416 */     // MIs[0] policy
     /* 1838416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838426 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838450 */     // GIR_Coverage, 13270,
     /* 1838450 */     GIR_EraseRootFromParent_Done,
     /* 1838451 */   // Label 24897: @1838451
     /* 1838451 */   GIM_Try, /*On fail goto*//*Label 24898*/ GIMT_Encode4(1838537), // Rule ID 13271 //
     /* 1838456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1838467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1838470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1838473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1838476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838502 */     // MIs[0] policy
     /* 1838502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838512 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838536 */     // GIR_Coverage, 13271,
     /* 1838536 */     GIR_EraseRootFromParent_Done,
     /* 1838537 */   // Label 24898: @1838537
     /* 1838537 */   GIM_Try, /*On fail goto*//*Label 24899*/ GIMT_Encode4(1838623), // Rule ID 13274 //
     /* 1838542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1838553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1838556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1838559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1838562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838588 */     // MIs[0] policy
     /* 1838588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838598 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838622 */     // GIR_Coverage, 13274,
     /* 1838622 */     GIR_EraseRootFromParent_Done,
     /* 1838623 */   // Label 24899: @1838623
     /* 1838623 */   GIM_Try, /*On fail goto*//*Label 24900*/ GIMT_Encode4(1838709), // Rule ID 13275 //
     /* 1838628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1838639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1838642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1838645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1838648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838674 */     // MIs[0] policy
     /* 1838674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838684 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838708 */     // GIR_Coverage, 13275,
     /* 1838708 */     GIR_EraseRootFromParent_Done,
     /* 1838709 */   // Label 24900: @1838709
     /* 1838709 */   GIM_Try, /*On fail goto*//*Label 24901*/ GIMT_Encode4(1838795), // Rule ID 13278 //
     /* 1838714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1838725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1838728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1838731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1838734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838760 */     // MIs[0] policy
     /* 1838760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838770 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838794 */     // GIR_Coverage, 13278,
     /* 1838794 */     GIR_EraseRootFromParent_Done,
     /* 1838795 */   // Label 24901: @1838795
     /* 1838795 */   GIM_Try, /*On fail goto*//*Label 24902*/ GIMT_Encode4(1838881), // Rule ID 13279 //
     /* 1838800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1838811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1838814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1838817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1838820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838846 */     // MIs[0] policy
     /* 1838846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838856 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838880 */     // GIR_Coverage, 13279,
     /* 1838880 */     GIR_EraseRootFromParent_Done,
     /* 1838881 */   // Label 24902: @1838881
     /* 1838881 */   GIM_Try, /*On fail goto*//*Label 24903*/ GIMT_Encode4(1838967), // Rule ID 13282 //
     /* 1838886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1838897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1838900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1838903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1838906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838932 */     // MIs[0] policy
     /* 1838932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838942 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1838945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838966 */     // GIR_Coverage, 13282,
     /* 1838966 */     GIR_EraseRootFromParent_Done,
     /* 1838967 */   // Label 24903: @1838967
     /* 1838967 */   GIM_Try, /*On fail goto*//*Label 24904*/ GIMT_Encode4(1839053), // Rule ID 13283 //
     /* 1838972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1838983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1838986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1838989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1838992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839018 */     // MIs[0] policy
     /* 1839018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839028 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839052 */     // GIR_Coverage, 13283,
     /* 1839052 */     GIR_EraseRootFromParent_Done,
     /* 1839053 */   // Label 24904: @1839053
     /* 1839053 */   GIM_Try, /*On fail goto*//*Label 24905*/ GIMT_Encode4(1839139), // Rule ID 13286 //
     /* 1839058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1839069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1839072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1839075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1839078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839104 */     // MIs[0] policy
     /* 1839104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839138 */     // GIR_Coverage, 13286,
     /* 1839138 */     GIR_EraseRootFromParent_Done,
     /* 1839139 */   // Label 24905: @1839139
     /* 1839139 */   GIM_Try, /*On fail goto*//*Label 24906*/ GIMT_Encode4(1839225), // Rule ID 13287 //
     /* 1839144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1839155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1839158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1839161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1839164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839190 */     // MIs[0] policy
     /* 1839190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839224 */     // GIR_Coverage, 13287,
     /* 1839224 */     GIR_EraseRootFromParent_Done,
     /* 1839225 */   // Label 24906: @1839225
     /* 1839225 */   GIM_Try, /*On fail goto*//*Label 24907*/ GIMT_Encode4(1839311), // Rule ID 13290 //
     /* 1839230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1839241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1839244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1839247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1839250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839276 */     // MIs[0] policy
     /* 1839276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839310 */     // GIR_Coverage, 13290,
     /* 1839310 */     GIR_EraseRootFromParent_Done,
     /* 1839311 */   // Label 24907: @1839311
     /* 1839311 */   GIM_Try, /*On fail goto*//*Label 24908*/ GIMT_Encode4(1839397), // Rule ID 13291 //
     /* 1839316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1839327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1839330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1839333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1839336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839362 */     // MIs[0] policy
     /* 1839362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839372 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839396 */     // GIR_Coverage, 13291,
     /* 1839396 */     GIR_EraseRootFromParent_Done,
     /* 1839397 */   // Label 24908: @1839397
     /* 1839397 */   GIM_Try, /*On fail goto*//*Label 24909*/ GIMT_Encode4(1839483), // Rule ID 13294 //
     /* 1839402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1839405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1839413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1839416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1839419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1839422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839448 */     // MIs[0] policy
     /* 1839448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839458 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839482 */     // GIR_Coverage, 13294,
     /* 1839482 */     GIR_EraseRootFromParent_Done,
     /* 1839483 */   // Label 24909: @1839483
     /* 1839483 */   GIM_Try, /*On fail goto*//*Label 24910*/ GIMT_Encode4(1839569), // Rule ID 13295 //
     /* 1839488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1839491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1839499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1839502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1839505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1839508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839534 */     // MIs[0] policy
     /* 1839534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839568 */     // GIR_Coverage, 13295,
     /* 1839568 */     GIR_EraseRootFromParent_Done,
     /* 1839569 */   // Label 24910: @1839569
     /* 1839569 */   GIM_Try, /*On fail goto*//*Label 24911*/ GIMT_Encode4(1839655), // Rule ID 13298 //
     /* 1839574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1839585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1839588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1839591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1839594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1839597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1839604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839620 */     // MIs[0] policy
     /* 1839620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839630 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1839633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839654 */     // GIR_Coverage, 13298,
     /* 1839654 */     GIR_EraseRootFromParent_Done,
     /* 1839655 */   // Label 24911: @1839655
     /* 1839655 */   GIM_Try, /*On fail goto*//*Label 24912*/ GIMT_Encode4(1839741), // Rule ID 13299 //
     /* 1839660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1839671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1839674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1839677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1839680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1839683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1839690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839706 */     // MIs[0] policy
     /* 1839706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839716 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1839719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839740 */     // GIR_Coverage, 13299,
     /* 1839740 */     GIR_EraseRootFromParent_Done,
     /* 1839741 */   // Label 24912: @1839741
     /* 1839741 */   GIM_Try, /*On fail goto*//*Label 24913*/ GIMT_Encode4(1839827), // Rule ID 13302 //
     /* 1839746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1839757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1839760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1839763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1839766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1839769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839792 */     // MIs[0] policy
     /* 1839792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839802 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1839805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839826 */     // GIR_Coverage, 13302,
     /* 1839826 */     GIR_EraseRootFromParent_Done,
     /* 1839827 */   // Label 24913: @1839827
     /* 1839827 */   GIM_Try, /*On fail goto*//*Label 24914*/ GIMT_Encode4(1839913), // Rule ID 13303 //
     /* 1839832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1839843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1839846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1839849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1839852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1839855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839878 */     // MIs[0] policy
     /* 1839878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839888 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1839891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839912 */     // GIR_Coverage, 13303,
     /* 1839912 */     GIR_EraseRootFromParent_Done,
     /* 1839913 */   // Label 24914: @1839913
     /* 1839913 */   GIM_Try, /*On fail goto*//*Label 24915*/ GIMT_Encode4(1839999), // Rule ID 13306 //
     /* 1839918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1839929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1839932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1839935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1839938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1839941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1839948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839964 */     // MIs[0] policy
     /* 1839964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839974 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1839977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839998 */     // GIR_Coverage, 13306,
     /* 1839998 */     GIR_EraseRootFromParent_Done,
     /* 1839999 */   // Label 24915: @1839999
     /* 1839999 */   GIM_Try, /*On fail goto*//*Label 24916*/ GIMT_Encode4(1840085), // Rule ID 13307 //
     /* 1840004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1840015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1840018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1840021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1840024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1840027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840050 */     // MIs[0] policy
     /* 1840050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840060 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1840063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840084 */     // GIR_Coverage, 13307,
     /* 1840084 */     GIR_EraseRootFromParent_Done,
     /* 1840085 */   // Label 24916: @1840085
     /* 1840085 */   GIM_Try, /*On fail goto*//*Label 24917*/ GIMT_Encode4(1840171), // Rule ID 13310 //
     /* 1840090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1840101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1840104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1840107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1840110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840136 */     // MIs[0] policy
     /* 1840136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840170 */     // GIR_Coverage, 13310,
     /* 1840170 */     GIR_EraseRootFromParent_Done,
     /* 1840171 */   // Label 24917: @1840171
     /* 1840171 */   GIM_Try, /*On fail goto*//*Label 24918*/ GIMT_Encode4(1840257), // Rule ID 13311 //
     /* 1840176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1840187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1840190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1840193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1840196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840222 */     // MIs[0] policy
     /* 1840222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840232 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840256 */     // GIR_Coverage, 13311,
     /* 1840256 */     GIR_EraseRootFromParent_Done,
     /* 1840257 */   // Label 24918: @1840257
     /* 1840257 */   GIM_Try, /*On fail goto*//*Label 24919*/ GIMT_Encode4(1840343), // Rule ID 13314 //
     /* 1840262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1840273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1840276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1840279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1840282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840308 */     // MIs[0] policy
     /* 1840308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840318 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840342 */     // GIR_Coverage, 13314,
     /* 1840342 */     GIR_EraseRootFromParent_Done,
     /* 1840343 */   // Label 24919: @1840343
     /* 1840343 */   GIM_Try, /*On fail goto*//*Label 24920*/ GIMT_Encode4(1840429), // Rule ID 13315 //
     /* 1840348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1840359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1840362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1840365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1840368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840394 */     // MIs[0] policy
     /* 1840394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840428 */     // GIR_Coverage, 13315,
     /* 1840428 */     GIR_EraseRootFromParent_Done,
     /* 1840429 */   // Label 24920: @1840429
     /* 1840429 */   GIM_Try, /*On fail goto*//*Label 24921*/ GIMT_Encode4(1840515), // Rule ID 13318 //
     /* 1840434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1840445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1840448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1840451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1840454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1840457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840480 */     // MIs[0] policy
     /* 1840480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840490 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1840493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840514 */     // GIR_Coverage, 13318,
     /* 1840514 */     GIR_EraseRootFromParent_Done,
     /* 1840515 */   // Label 24921: @1840515
     /* 1840515 */   GIM_Try, /*On fail goto*//*Label 24922*/ GIMT_Encode4(1840601), // Rule ID 13319 //
     /* 1840520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1840531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1840534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1840537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1840540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1840543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840566 */     // MIs[0] policy
     /* 1840566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840576 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1840579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840600 */     // GIR_Coverage, 13319,
     /* 1840600 */     GIR_EraseRootFromParent_Done,
     /* 1840601 */   // Label 24922: @1840601
     /* 1840601 */   GIM_Try, /*On fail goto*//*Label 24923*/ GIMT_Encode4(1840687), // Rule ID 13322 //
     /* 1840606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1840617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1840620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1840623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1840626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1840629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840652 */     // MIs[0] policy
     /* 1840652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840686 */     // GIR_Coverage, 13322,
     /* 1840686 */     GIR_EraseRootFromParent_Done,
     /* 1840687 */   // Label 24923: @1840687
     /* 1840687 */   GIM_Try, /*On fail goto*//*Label 24924*/ GIMT_Encode4(1840773), // Rule ID 13323 //
     /* 1840692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1840703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1840706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1840709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1840712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1840715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840738 */     // MIs[0] policy
     /* 1840738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840772 */     // GIR_Coverage, 13323,
     /* 1840772 */     GIR_EraseRootFromParent_Done,
     /* 1840773 */   // Label 24924: @1840773
     /* 1840773 */   GIM_Try, /*On fail goto*//*Label 24925*/ GIMT_Encode4(1840859), // Rule ID 13326 //
     /* 1840778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1840789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1840792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1840795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1840798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840824 */     // MIs[0] policy
     /* 1840824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840834 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840858 */     // GIR_Coverage, 13326,
     /* 1840858 */     GIR_EraseRootFromParent_Done,
     /* 1840859 */   // Label 24925: @1840859
     /* 1840859 */   GIM_Try, /*On fail goto*//*Label 24926*/ GIMT_Encode4(1840945), // Rule ID 13327 //
     /* 1840864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1840875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1840878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1840881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1840884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840910 */     // MIs[0] policy
     /* 1840910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840920 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840944 */     // GIR_Coverage, 13327,
     /* 1840944 */     GIR_EraseRootFromParent_Done,
     /* 1840945 */   // Label 24926: @1840945
     /* 1840945 */   GIM_Try, /*On fail goto*//*Label 24927*/ GIMT_Encode4(1841031), // Rule ID 13330 //
     /* 1840950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1840961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1840964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1840967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1840970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840996 */     // MIs[0] policy
     /* 1840996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841006 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841030 */     // GIR_Coverage, 13330,
     /* 1841030 */     GIR_EraseRootFromParent_Done,
     /* 1841031 */   // Label 24927: @1841031
     /* 1841031 */   GIM_Try, /*On fail goto*//*Label 24928*/ GIMT_Encode4(1841117), // Rule ID 13331 //
     /* 1841036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1841047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1841050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1841053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1841056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841082 */     // MIs[0] policy
     /* 1841082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841092 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841116 */     // GIR_Coverage, 13331,
     /* 1841116 */     GIR_EraseRootFromParent_Done,
     /* 1841117 */   // Label 24928: @1841117
     /* 1841117 */   GIM_Try, /*On fail goto*//*Label 24929*/ GIMT_Encode4(1841203), // Rule ID 13334 //
     /* 1841122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1841133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1841136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1841139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1841142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841168 */     // MIs[0] policy
     /* 1841168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841178 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1841181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841202 */     // GIR_Coverage, 13334,
     /* 1841202 */     GIR_EraseRootFromParent_Done,
     /* 1841203 */   // Label 24929: @1841203
     /* 1841203 */   GIM_Try, /*On fail goto*//*Label 24930*/ GIMT_Encode4(1841289), // Rule ID 13335 //
     /* 1841208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1841219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1841222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1841225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1841228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841254 */     // MIs[0] policy
     /* 1841254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841264 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1841267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841288 */     // GIR_Coverage, 13335,
     /* 1841288 */     GIR_EraseRootFromParent_Done,
     /* 1841289 */   // Label 24930: @1841289
     /* 1841289 */   GIM_Try, /*On fail goto*//*Label 24931*/ GIMT_Encode4(1841375), // Rule ID 13338 //
     /* 1841294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1841305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1841308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1841311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1841314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841340 */     // MIs[0] policy
     /* 1841340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841350 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1841353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841374 */     // GIR_Coverage, 13338,
     /* 1841374 */     GIR_EraseRootFromParent_Done,
     /* 1841375 */   // Label 24931: @1841375
     /* 1841375 */   GIM_Try, /*On fail goto*//*Label 24932*/ GIMT_Encode4(1841461), // Rule ID 13339 //
     /* 1841380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1841391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1841394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1841397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1841400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841426 */     // MIs[0] policy
     /* 1841426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1841439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841460 */     // GIR_Coverage, 13339,
     /* 1841460 */     GIR_EraseRootFromParent_Done,
     /* 1841461 */   // Label 24932: @1841461
     /* 1841461 */   GIM_Try, /*On fail goto*//*Label 24933*/ GIMT_Encode4(1841547), // Rule ID 13342 //
     /* 1841466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1841477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1841480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1841483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1841486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841512 */     // MIs[0] policy
     /* 1841512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841522 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841546 */     // GIR_Coverage, 13342,
     /* 1841546 */     GIR_EraseRootFromParent_Done,
     /* 1841547 */   // Label 24933: @1841547
     /* 1841547 */   GIM_Try, /*On fail goto*//*Label 24934*/ GIMT_Encode4(1841633), // Rule ID 13343 //
     /* 1841552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1841563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1841566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1841569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1841572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841598 */     // MIs[0] policy
     /* 1841598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841608 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841632 */     // GIR_Coverage, 13343,
     /* 1841632 */     GIR_EraseRootFromParent_Done,
     /* 1841633 */   // Label 24934: @1841633
     /* 1841633 */   GIM_Try, /*On fail goto*//*Label 24935*/ GIMT_Encode4(1841719), // Rule ID 13346 //
     /* 1841638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1841649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1841652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1841658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1841661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841684 */     // MIs[0] policy
     /* 1841684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841694 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1841697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841718 */     // GIR_Coverage, 13346,
     /* 1841718 */     GIR_EraseRootFromParent_Done,
     /* 1841719 */   // Label 24935: @1841719
     /* 1841719 */   GIM_Try, /*On fail goto*//*Label 24936*/ GIMT_Encode4(1841805), // Rule ID 13347 //
     /* 1841724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1841735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1841738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1841744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1841747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841770 */     // MIs[0] policy
     /* 1841770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841780 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1841783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841804 */     // GIR_Coverage, 13347,
     /* 1841804 */     GIR_EraseRootFromParent_Done,
     /* 1841805 */   // Label 24936: @1841805
     /* 1841805 */   GIM_Try, /*On fail goto*//*Label 24937*/ GIMT_Encode4(1841891), // Rule ID 13350 //
     /* 1841810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1841821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1841824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1841830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841856 */     // MIs[0] policy
     /* 1841856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841866 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1841869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841890 */     // GIR_Coverage, 13350,
     /* 1841890 */     GIR_EraseRootFromParent_Done,
     /* 1841891 */   // Label 24937: @1841891
     /* 1841891 */   GIM_Try, /*On fail goto*//*Label 24938*/ GIMT_Encode4(1841977), // Rule ID 13351 //
     /* 1841896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1841907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1841910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1841916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841942 */     // MIs[0] policy
     /* 1841942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841952 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1841955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841976 */     // GIR_Coverage, 13351,
     /* 1841976 */     GIR_EraseRootFromParent_Done,
     /* 1841977 */   // Label 24938: @1841977
     /* 1841977 */   GIM_Try, /*On fail goto*//*Label 24939*/ GIMT_Encode4(1842063), // Rule ID 13354 //
     /* 1841982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1841993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1841996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1842002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842028 */     // MIs[0] policy
     /* 1842028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842038 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842062 */     // GIR_Coverage, 13354,
     /* 1842062 */     GIR_EraseRootFromParent_Done,
     /* 1842063 */   // Label 24939: @1842063
     /* 1842063 */   GIM_Try, /*On fail goto*//*Label 24940*/ GIMT_Encode4(1842149), // Rule ID 13355 //
     /* 1842068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1842079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1842082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1842088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842114 */     // MIs[0] policy
     /* 1842114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842124 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842148 */     // GIR_Coverage, 13355,
     /* 1842148 */     GIR_EraseRootFromParent_Done,
     /* 1842149 */   // Label 24940: @1842149
     /* 1842149 */   GIM_Try, /*On fail goto*//*Label 24941*/ GIMT_Encode4(1842235), // Rule ID 13358 //
     /* 1842154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1842165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1842168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1842174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842200 */     // MIs[0] policy
     /* 1842200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1842213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842234 */     // GIR_Coverage, 13358,
     /* 1842234 */     GIR_EraseRootFromParent_Done,
     /* 1842235 */   // Label 24941: @1842235
     /* 1842235 */   GIM_Try, /*On fail goto*//*Label 24942*/ GIMT_Encode4(1842321), // Rule ID 13359 //
     /* 1842240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1842251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1842254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1842260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842286 */     // MIs[0] policy
     /* 1842286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842296 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1842299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842320 */     // GIR_Coverage, 13359,
     /* 1842320 */     GIR_EraseRootFromParent_Done,
     /* 1842321 */   // Label 24942: @1842321
     /* 1842321 */   GIM_Try, /*On fail goto*//*Label 24943*/ GIMT_Encode4(1842407), // Rule ID 13362 //
     /* 1842326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1842337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1842340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1842346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842372 */     // MIs[0] policy
     /* 1842372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842406 */     // GIR_Coverage, 13362,
     /* 1842406 */     GIR_EraseRootFromParent_Done,
     /* 1842407 */   // Label 24943: @1842407
     /* 1842407 */   GIM_Try, /*On fail goto*//*Label 24944*/ GIMT_Encode4(1842493), // Rule ID 13363 //
     /* 1842412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1842423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1842426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1842432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842458 */     // MIs[0] policy
     /* 1842458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842468 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842492 */     // GIR_Coverage, 13363,
     /* 1842492 */     GIR_EraseRootFromParent_Done,
     /* 1842493 */   // Label 24944: @1842493
     /* 1842493 */   GIM_Try, /*On fail goto*//*Label 24945*/ GIMT_Encode4(1842579), // Rule ID 13366 //
     /* 1842498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1842509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1842512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1842518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842544 */     // MIs[0] policy
     /* 1842544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842554 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842578 */     // GIR_Coverage, 13366,
     /* 1842578 */     GIR_EraseRootFromParent_Done,
     /* 1842579 */   // Label 24945: @1842579
     /* 1842579 */   GIM_Try, /*On fail goto*//*Label 24946*/ GIMT_Encode4(1842665), // Rule ID 13367 //
     /* 1842584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1842595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1842598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1842604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842630 */     // MIs[0] policy
     /* 1842630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842640 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842664 */     // GIR_Coverage, 13367,
     /* 1842664 */     GIR_EraseRootFromParent_Done,
     /* 1842665 */   // Label 24946: @1842665
     /* 1842665 */   GIM_Try, /*On fail goto*//*Label 24947*/ GIMT_Encode4(1842751), // Rule ID 13370 //
     /* 1842670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1842681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1842684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1842690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842716 */     // MIs[0] policy
     /* 1842716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842726 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1842729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842750 */     // GIR_Coverage, 13370,
     /* 1842750 */     GIR_EraseRootFromParent_Done,
     /* 1842751 */   // Label 24947: @1842751
     /* 1842751 */   GIM_Try, /*On fail goto*//*Label 24948*/ GIMT_Encode4(1842837), // Rule ID 13371 //
     /* 1842756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1842767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1842770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1842776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842802 */     // MIs[0] policy
     /* 1842802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842812 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1842815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842836 */     // GIR_Coverage, 13371,
     /* 1842836 */     GIR_EraseRootFromParent_Done,
     /* 1842837 */   // Label 24948: @1842837
     /* 1842837 */   GIM_Try, /*On fail goto*//*Label 24949*/ GIMT_Encode4(1842923), // Rule ID 13374 //
     /* 1842842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1842853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1842856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1842862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842888 */     // MIs[0] policy
     /* 1842888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1842901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842922 */     // GIR_Coverage, 13374,
     /* 1842922 */     GIR_EraseRootFromParent_Done,
     /* 1842923 */   // Label 24949: @1842923
     /* 1842923 */   GIM_Try, /*On fail goto*//*Label 24950*/ GIMT_Encode4(1843009), // Rule ID 13375 //
     /* 1842928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1842939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1842942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1842948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842974 */     // MIs[0] policy
     /* 1842974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842984 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1842987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843008 */     // GIR_Coverage, 13375,
     /* 1843008 */     GIR_EraseRootFromParent_Done,
     /* 1843009 */   // Label 24950: @1843009
     /* 1843009 */   GIM_Try, /*On fail goto*//*Label 24951*/ GIMT_Encode4(1843095), // Rule ID 13378 //
     /* 1843014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1843025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1843028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1843034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843060 */     // MIs[0] policy
     /* 1843060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843070 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843094 */     // GIR_Coverage, 13378,
     /* 1843094 */     GIR_EraseRootFromParent_Done,
     /* 1843095 */   // Label 24951: @1843095
     /* 1843095 */   GIM_Try, /*On fail goto*//*Label 24952*/ GIMT_Encode4(1843181), // Rule ID 13379 //
     /* 1843100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1843111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1843114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1843120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843146 */     // MIs[0] policy
     /* 1843146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843180 */     // GIR_Coverage, 13379,
     /* 1843180 */     GIR_EraseRootFromParent_Done,
     /* 1843181 */   // Label 24952: @1843181
     /* 1843181 */   GIM_Try, /*On fail goto*//*Label 24953*/ GIMT_Encode4(1843267), // Rule ID 13382 //
     /* 1843186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1843189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1843206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843232 */     // MIs[0] policy
     /* 1843232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843242 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1843263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843266 */     // GIR_Coverage, 13382,
     /* 1843266 */     GIR_EraseRootFromParent_Done,
     /* 1843267 */   // Label 24953: @1843267
     /* 1843267 */   GIM_Try, /*On fail goto*//*Label 24954*/ GIMT_Encode4(1843353), // Rule ID 13383 //
     /* 1843272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1843275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1843292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843318 */     // MIs[0] policy
     /* 1843318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1843349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843352 */     // GIR_Coverage, 13383,
     /* 1843352 */     GIR_EraseRootFromParent_Done,
     /* 1843353 */   // Label 24954: @1843353
     /* 1843353 */   GIM_Try, /*On fail goto*//*Label 24955*/ GIMT_Encode4(1843439), // Rule ID 13386 //
     /* 1843358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1843369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1843372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1843378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843404 */     // MIs[0] policy
     /* 1843404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843414 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1843417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843438 */     // GIR_Coverage, 13386,
     /* 1843438 */     GIR_EraseRootFromParent_Done,
     /* 1843439 */   // Label 24955: @1843439
     /* 1843439 */   GIM_Try, /*On fail goto*//*Label 24956*/ GIMT_Encode4(1843525), // Rule ID 13387 //
     /* 1843444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1843455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1843458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1843464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843490 */     // MIs[0] policy
     /* 1843490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843500 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1843503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843524 */     // GIR_Coverage, 13387,
     /* 1843524 */     GIR_EraseRootFromParent_Done,
     /* 1843525 */   // Label 24956: @1843525
     /* 1843525 */   GIM_Try, /*On fail goto*//*Label 24957*/ GIMT_Encode4(1843611), // Rule ID 13390 //
     /* 1843530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1843541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1843544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1843550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1843553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1843560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843576 */     // MIs[0] policy
     /* 1843576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843586 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1843589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843610 */     // GIR_Coverage, 13390,
     /* 1843610 */     GIR_EraseRootFromParent_Done,
     /* 1843611 */   // Label 24957: @1843611
     /* 1843611 */   GIM_Try, /*On fail goto*//*Label 24958*/ GIMT_Encode4(1843697), // Rule ID 13391 //
     /* 1843616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1843627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1843630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1843636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1843639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1843646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843662 */     // MIs[0] policy
     /* 1843662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843672 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1843675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843696 */     // GIR_Coverage, 13391,
     /* 1843696 */     GIR_EraseRootFromParent_Done,
     /* 1843697 */   // Label 24958: @1843697
     /* 1843697 */   GIM_Try, /*On fail goto*//*Label 24959*/ GIMT_Encode4(1843783), // Rule ID 13394 //
     /* 1843702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1843713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1843716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1843722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1843725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1843732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843748 */     // MIs[0] policy
     /* 1843748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843758 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1843761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843782 */     // GIR_Coverage, 13394,
     /* 1843782 */     GIR_EraseRootFromParent_Done,
     /* 1843783 */   // Label 24959: @1843783
     /* 1843783 */   GIM_Try, /*On fail goto*//*Label 24960*/ GIMT_Encode4(1843869), // Rule ID 13395 //
     /* 1843788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1843799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1843802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1843808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1843811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1843818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843834 */     // MIs[0] policy
     /* 1843834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843844 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1843847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843868 */     // GIR_Coverage, 13395,
     /* 1843868 */     GIR_EraseRootFromParent_Done,
     /* 1843869 */   // Label 24960: @1843869
     /* 1843869 */   GIM_Try, /*On fail goto*//*Label 24961*/ GIMT_Encode4(1843955), // Rule ID 13398 //
     /* 1843874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1843885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1843888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1843894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843920 */     // MIs[0] policy
     /* 1843920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843930 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1843933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843954 */     // GIR_Coverage, 13398,
     /* 1843954 */     GIR_EraseRootFromParent_Done,
     /* 1843955 */   // Label 24961: @1843955
     /* 1843955 */   GIM_Try, /*On fail goto*//*Label 24962*/ GIMT_Encode4(1844041), // Rule ID 13399 //
     /* 1843960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1843971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1843974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1843980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844006 */     // MIs[0] policy
     /* 1844006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844016 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844040 */     // GIR_Coverage, 13399,
     /* 1844040 */     GIR_EraseRootFromParent_Done,
     /* 1844041 */   // Label 24962: @1844041
     /* 1844041 */   GIM_Try, /*On fail goto*//*Label 24963*/ GIMT_Encode4(1844127), // Rule ID 13402 //
     /* 1844046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1844066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844092 */     // MIs[0] policy
     /* 1844092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844102 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844126 */     // GIR_Coverage, 13402,
     /* 1844126 */     GIR_EraseRootFromParent_Done,
     /* 1844127 */   // Label 24963: @1844127
     /* 1844127 */   GIM_Try, /*On fail goto*//*Label 24964*/ GIMT_Encode4(1844213), // Rule ID 13403 //
     /* 1844132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1844152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844178 */     // MIs[0] policy
     /* 1844178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844188 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844212 */     // GIR_Coverage, 13403,
     /* 1844212 */     GIR_EraseRootFromParent_Done,
     /* 1844213 */   // Label 24964: @1844213
     /* 1844213 */   GIM_Try, /*On fail goto*//*Label 24965*/ GIMT_Encode4(1844299), // Rule ID 13406 //
     /* 1844218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1844238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844264 */     // MIs[0] policy
     /* 1844264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844274 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844298 */     // GIR_Coverage, 13406,
     /* 1844298 */     GIR_EraseRootFromParent_Done,
     /* 1844299 */   // Label 24965: @1844299
     /* 1844299 */   GIM_Try, /*On fail goto*//*Label 24966*/ GIMT_Encode4(1844385), // Rule ID 13407 //
     /* 1844304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1844324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844350 */     // MIs[0] policy
     /* 1844350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844360 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844384 */     // GIR_Coverage, 13407,
     /* 1844384 */     GIR_EraseRootFromParent_Done,
     /* 1844385 */   // Label 24966: @1844385
     /* 1844385 */   GIM_Try, /*On fail goto*//*Label 24967*/ GIMT_Encode4(1844471), // Rule ID 13410 //
     /* 1844390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1844410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844436 */     // MIs[0] policy
     /* 1844436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844470 */     // GIR_Coverage, 13410,
     /* 1844470 */     GIR_EraseRootFromParent_Done,
     /* 1844471 */   // Label 24967: @1844471
     /* 1844471 */   GIM_Try, /*On fail goto*//*Label 24968*/ GIMT_Encode4(1844557), // Rule ID 13411 //
     /* 1844476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1844496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844522 */     // MIs[0] policy
     /* 1844522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844532 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844556 */     // GIR_Coverage, 13411,
     /* 1844556 */     GIR_EraseRootFromParent_Done,
     /* 1844557 */   // Label 24968: @1844557
     /* 1844557 */   GIM_Try, /*On fail goto*//*Label 24969*/ GIMT_Encode4(1844643), // Rule ID 13414 //
     /* 1844562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1844573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1844576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1844582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844608 */     // MIs[0] policy
     /* 1844608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844642 */     // GIR_Coverage, 13414,
     /* 1844642 */     GIR_EraseRootFromParent_Done,
     /* 1844643 */   // Label 24969: @1844643
     /* 1844643 */   GIM_Try, /*On fail goto*//*Label 24970*/ GIMT_Encode4(1844729), // Rule ID 13415 //
     /* 1844648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1844659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1844662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1844668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844694 */     // MIs[0] policy
     /* 1844694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844704 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844728 */     // GIR_Coverage, 13415,
     /* 1844728 */     GIR_EraseRootFromParent_Done,
     /* 1844729 */   // Label 24970: @1844729
     /* 1844729 */   GIM_Try, /*On fail goto*//*Label 24971*/ GIMT_Encode4(1844815), // Rule ID 13418 //
     /* 1844734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1844745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1844748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1844754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844780 */     // MIs[0] policy
     /* 1844780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844790 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844814 */     // GIR_Coverage, 13418,
     /* 1844814 */     GIR_EraseRootFromParent_Done,
     /* 1844815 */   // Label 24971: @1844815
     /* 1844815 */   GIM_Try, /*On fail goto*//*Label 24972*/ GIMT_Encode4(1844901), // Rule ID 13419 //
     /* 1844820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1844831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1844834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1844840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844866 */     // MIs[0] policy
     /* 1844866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844876 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844900 */     // GIR_Coverage, 13419,
     /* 1844900 */     GIR_EraseRootFromParent_Done,
     /* 1844901 */   // Label 24972: @1844901
     /* 1844901 */   GIM_Try, /*On fail goto*//*Label 24973*/ GIMT_Encode4(1844987), // Rule ID 13422 //
     /* 1844906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1844909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1844917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1844920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1844926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1844929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844952 */     // MIs[0] policy
     /* 1844952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844962 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1844983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844986 */     // GIR_Coverage, 13422,
     /* 1844986 */     GIR_EraseRootFromParent_Done,
     /* 1844987 */   // Label 24973: @1844987
     /* 1844987 */   GIM_Try, /*On fail goto*//*Label 24974*/ GIMT_Encode4(1845073), // Rule ID 13423 //
     /* 1844992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1844995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1845003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1845006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1845012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845038 */     // MIs[0] policy
     /* 1845038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845048 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1845051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845072 */     // GIR_Coverage, 13423,
     /* 1845072 */     GIR_EraseRootFromParent_Done,
     /* 1845073 */   // Label 24974: @1845073
     /* 1845073 */   GIM_Try, /*On fail goto*//*Label 24975*/ GIMT_Encode4(1845159), // Rule ID 13426 //
     /* 1845078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1845081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1845098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845124 */     // MIs[0] policy
     /* 1845124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845134 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1845137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845158 */     // GIR_Coverage, 13426,
     /* 1845158 */     GIR_EraseRootFromParent_Done,
     /* 1845159 */   // Label 24975: @1845159
     /* 1845159 */   GIM_Try, /*On fail goto*//*Label 24976*/ GIMT_Encode4(1845245), // Rule ID 13427 //
     /* 1845164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1845167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1845184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845210 */     // MIs[0] policy
     /* 1845210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845220 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1845223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845244 */     // GIR_Coverage, 13427,
     /* 1845244 */     GIR_EraseRootFromParent_Done,
     /* 1845245 */   // Label 24976: @1845245
     /* 1845245 */   GIM_Try, /*On fail goto*//*Label 24977*/ GIMT_Encode4(1845331), // Rule ID 13430 //
     /* 1845250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1845253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1845270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845296 */     // MIs[0] policy
     /* 1845296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1845309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845330 */     // GIR_Coverage, 13430,
     /* 1845330 */     GIR_EraseRootFromParent_Done,
     /* 1845331 */   // Label 24977: @1845331
     /* 1845331 */   GIM_Try, /*On fail goto*//*Label 24978*/ GIMT_Encode4(1845417), // Rule ID 13431 //
     /* 1845336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1845339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1845356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845382 */     // MIs[0] policy
     /* 1845382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845392 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1845395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845416 */     // GIR_Coverage, 13431,
     /* 1845416 */     GIR_EraseRootFromParent_Done,
     /* 1845417 */   // Label 24978: @1845417
     /* 1845417 */   GIM_Try, /*On fail goto*//*Label 24979*/ GIMT_Encode4(1845503), // Rule ID 13434 //
     /* 1845422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1845433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1845436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1845439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845468 */     // MIs[0] policy
     /* 1845468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845478 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1845481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845502 */     // GIR_Coverage, 13434,
     /* 1845502 */     GIR_EraseRootFromParent_Done,
     /* 1845503 */   // Label 24979: @1845503
     /* 1845503 */   GIM_Try, /*On fail goto*//*Label 24980*/ GIMT_Encode4(1845589), // Rule ID 13435 //
     /* 1845508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1845519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1845522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1845525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845554 */     // MIs[0] policy
     /* 1845554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845564 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1845567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845588 */     // GIR_Coverage, 13435,
     /* 1845588 */     GIR_EraseRootFromParent_Done,
     /* 1845589 */   // Label 24980: @1845589
     /* 1845589 */   GIM_Try, /*On fail goto*//*Label 24981*/ GIMT_Encode4(1845675), // Rule ID 13438 //
     /* 1845594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1845605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1845608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1845611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1845614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845640 */     // MIs[0] policy
     /* 1845640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845650 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1845653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845674 */     // GIR_Coverage, 13438,
     /* 1845674 */     GIR_EraseRootFromParent_Done,
     /* 1845675 */   // Label 24981: @1845675
     /* 1845675 */   GIM_Try, /*On fail goto*//*Label 24982*/ GIMT_Encode4(1845761), // Rule ID 13439 //
     /* 1845680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1845691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1845694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1845697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1845700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845726 */     // MIs[0] policy
     /* 1845726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845736 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1845739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845760 */     // GIR_Coverage, 13439,
     /* 1845760 */     GIR_EraseRootFromParent_Done,
     /* 1845761 */   // Label 24982: @1845761
     /* 1845761 */   GIM_Try, /*On fail goto*//*Label 24983*/ GIMT_Encode4(1845847), // Rule ID 13442 //
     /* 1845766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1845777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1845780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1845783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1845786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845812 */     // MIs[0] policy
     /* 1845812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845822 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1845825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845846 */     // GIR_Coverage, 13442,
     /* 1845846 */     GIR_EraseRootFromParent_Done,
     /* 1845847 */   // Label 24983: @1845847
     /* 1845847 */   GIM_Try, /*On fail goto*//*Label 24984*/ GIMT_Encode4(1845933), // Rule ID 13443 //
     /* 1845852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1845863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1845866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1845869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1845872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845898 */     // MIs[0] policy
     /* 1845898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845908 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1845911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845932 */     // GIR_Coverage, 13443,
     /* 1845932 */     GIR_EraseRootFromParent_Done,
     /* 1845933 */   // Label 24984: @1845933
     /* 1845933 */   GIM_Try, /*On fail goto*//*Label 24985*/ GIMT_Encode4(1846019), // Rule ID 13446 //
     /* 1845938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1845949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1845952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1845955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1845958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845984 */     // MIs[0] policy
     /* 1845984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1845997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846018 */     // GIR_Coverage, 13446,
     /* 1846018 */     GIR_EraseRootFromParent_Done,
     /* 1846019 */   // Label 24985: @1846019
     /* 1846019 */   GIM_Try, /*On fail goto*//*Label 24986*/ GIMT_Encode4(1846105), // Rule ID 13447 //
     /* 1846024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1846035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1846038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1846041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1846044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846070 */     // MIs[0] policy
     /* 1846070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846080 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1846083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846104 */     // GIR_Coverage, 13447,
     /* 1846104 */     GIR_EraseRootFromParent_Done,
     /* 1846105 */   // Label 24986: @1846105
     /* 1846105 */   GIM_Try, /*On fail goto*//*Label 24987*/ GIMT_Encode4(1846191), // Rule ID 13450 //
     /* 1846110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1846121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1846124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1846127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1846130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1846133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1846140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846156 */     // MIs[0] policy
     /* 1846156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846166 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1846169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846190 */     // GIR_Coverage, 13450,
     /* 1846190 */     GIR_EraseRootFromParent_Done,
     /* 1846191 */   // Label 24987: @1846191
     /* 1846191 */   GIM_Try, /*On fail goto*//*Label 24988*/ GIMT_Encode4(1846277), // Rule ID 13451 //
     /* 1846196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1846207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1846210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1846213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1846216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1846219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1846226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846242 */     // MIs[0] policy
     /* 1846242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846252 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1846255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846276 */     // GIR_Coverage, 13451,
     /* 1846276 */     GIR_EraseRootFromParent_Done,
     /* 1846277 */   // Label 24988: @1846277
     /* 1846277 */   GIM_Try, /*On fail goto*//*Label 24989*/ GIMT_Encode4(1846363), // Rule ID 13454 //
     /* 1846282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1846293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1846296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1846299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1846302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1846305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1846312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1846316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846328 */     // MIs[0] policy
     /* 1846328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846338 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1846341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846362 */     // GIR_Coverage, 13454,
     /* 1846362 */     GIR_EraseRootFromParent_Done,
     /* 1846363 */   // Label 24989: @1846363
     /* 1846363 */   GIM_Try, /*On fail goto*//*Label 24990*/ GIMT_Encode4(1846449), // Rule ID 13455 //
     /* 1846368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1846379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1846382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1846385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1846388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1846391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1846398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1846402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846414 */     // MIs[0] policy
     /* 1846414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846424 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1846427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846448 */     // GIR_Coverage, 13455,
     /* 1846448 */     GIR_EraseRootFromParent_Done,
     /* 1846449 */   // Label 24990: @1846449
     /* 1846449 */   GIM_Try, /*On fail goto*//*Label 24991*/ GIMT_Encode4(1846535), // Rule ID 13458 //
     /* 1846454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1846465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1846468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1846471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1846474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846500 */     // MIs[0] policy
     /* 1846500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846510 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1846513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846534 */     // GIR_Coverage, 13458,
     /* 1846534 */     GIR_EraseRootFromParent_Done,
     /* 1846535 */   // Label 24991: @1846535
     /* 1846535 */   GIM_Try, /*On fail goto*//*Label 24992*/ GIMT_Encode4(1846621), // Rule ID 13459 //
     /* 1846540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1846551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1846554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1846557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1846560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846586 */     // MIs[0] policy
     /* 1846586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846596 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1846599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846620 */     // GIR_Coverage, 13459,
     /* 1846620 */     GIR_EraseRootFromParent_Done,
     /* 1846621 */   // Label 24992: @1846621
     /* 1846621 */   GIM_Try, /*On fail goto*//*Label 24993*/ GIMT_Encode4(1846707), // Rule ID 13462 //
     /* 1846626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1846637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1846640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1846643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1846646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846672 */     // MIs[0] policy
     /* 1846672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1846685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846706 */     // GIR_Coverage, 13462,
     /* 1846706 */     GIR_EraseRootFromParent_Done,
     /* 1846707 */   // Label 24993: @1846707
     /* 1846707 */   GIM_Try, /*On fail goto*//*Label 24994*/ GIMT_Encode4(1846793), // Rule ID 13463 //
     /* 1846712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1846723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1846726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1846729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1846732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846758 */     // MIs[0] policy
     /* 1846758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846768 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1846771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846792 */     // GIR_Coverage, 13463,
     /* 1846792 */     GIR_EraseRootFromParent_Done,
     /* 1846793 */   // Label 24994: @1846793
     /* 1846793 */   GIM_Try, /*On fail goto*//*Label 24995*/ GIMT_Encode4(1846879), // Rule ID 13466 //
     /* 1846798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1846809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1846812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1846815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1846818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846844 */     // MIs[0] policy
     /* 1846844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1846857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846878 */     // GIR_Coverage, 13466,
     /* 1846878 */     GIR_EraseRootFromParent_Done,
     /* 1846879 */   // Label 24995: @1846879
     /* 1846879 */   GIM_Try, /*On fail goto*//*Label 24996*/ GIMT_Encode4(1846965), // Rule ID 13467 //
     /* 1846884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1846895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1846898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1846901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1846904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846930 */     // MIs[0] policy
     /* 1846930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1846943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846964 */     // GIR_Coverage, 13467,
     /* 1846964 */     GIR_EraseRootFromParent_Done,
     /* 1846965 */   // Label 24996: @1846965
     /* 1846965 */   GIM_Try, /*On fail goto*//*Label 24997*/ GIMT_Encode4(1847051), // Rule ID 13470 //
     /* 1846970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1846981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1846984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1846987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1846990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847016 */     // MIs[0] policy
     /* 1847016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847026 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1847029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847050 */     // GIR_Coverage, 13470,
     /* 1847050 */     GIR_EraseRootFromParent_Done,
     /* 1847051 */   // Label 24997: @1847051
     /* 1847051 */   GIM_Try, /*On fail goto*//*Label 24998*/ GIMT_Encode4(1847137), // Rule ID 13471 //
     /* 1847056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1847067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1847070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1847073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1847076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847102 */     // MIs[0] policy
     /* 1847102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1847115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847136 */     // GIR_Coverage, 13471,
     /* 1847136 */     GIR_EraseRootFromParent_Done,
     /* 1847137 */   // Label 24998: @1847137
     /* 1847137 */   GIM_Try, /*On fail goto*//*Label 24999*/ GIMT_Encode4(1847223), // Rule ID 13474 //
     /* 1847142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1847153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1847156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1847159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1847162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847188 */     // MIs[0] policy
     /* 1847188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1847201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847222 */     // GIR_Coverage, 13474,
     /* 1847222 */     GIR_EraseRootFromParent_Done,
     /* 1847223 */   // Label 24999: @1847223
     /* 1847223 */   GIM_Try, /*On fail goto*//*Label 25000*/ GIMT_Encode4(1847309), // Rule ID 13475 //
     /* 1847228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1847239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1847242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1847245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1847248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847274 */     // MIs[0] policy
     /* 1847274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847284 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1847287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847308 */     // GIR_Coverage, 13475,
     /* 1847308 */     GIR_EraseRootFromParent_Done,
     /* 1847309 */   // Label 25000: @1847309
     /* 1847309 */   GIM_Try, /*On fail goto*//*Label 25001*/ GIMT_Encode4(1847395), // Rule ID 13478 //
     /* 1847314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1847331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1847334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847360 */     // MIs[0] policy
     /* 1847360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847370 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1847373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847394 */     // GIR_Coverage, 13478,
     /* 1847394 */     GIR_EraseRootFromParent_Done,
     /* 1847395 */   // Label 25001: @1847395
     /* 1847395 */   GIM_Try, /*On fail goto*//*Label 25002*/ GIMT_Encode4(1847481), // Rule ID 13479 //
     /* 1847400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1847403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1847417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1847420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847446 */     // MIs[0] policy
     /* 1847446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847456 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1847459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847480 */     // GIR_Coverage, 13479,
     /* 1847480 */     GIR_EraseRootFromParent_Done,
     /* 1847481 */   // Label 25002: @1847481
     /* 1847481 */   GIM_Try, /*On fail goto*//*Label 25003*/ GIMT_Encode4(1847567), // Rule ID 13482 //
     /* 1847486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1847497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1847500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1847503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1847506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847532 */     // MIs[0] policy
     /* 1847532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1847545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847566 */     // GIR_Coverage, 13482,
     /* 1847566 */     GIR_EraseRootFromParent_Done,
     /* 1847567 */   // Label 25003: @1847567
     /* 1847567 */   GIM_Try, /*On fail goto*//*Label 25004*/ GIMT_Encode4(1847653), // Rule ID 13483 //
     /* 1847572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1847575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1847583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1847586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1847589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1847592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847618 */     // MIs[0] policy
     /* 1847618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1847631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847652 */     // GIR_Coverage, 13483,
     /* 1847652 */     GIR_EraseRootFromParent_Done,
     /* 1847653 */   // Label 25004: @1847653
     /* 1847653 */   GIM_Try, /*On fail goto*//*Label 25005*/ GIMT_Encode4(1847739), // Rule ID 13486 //
     /* 1847658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1847669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1847672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1847675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1847678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1847681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847704 */     // MIs[0] policy
     /* 1847704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847714 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1847717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847738 */     // GIR_Coverage, 13486,
     /* 1847738 */     GIR_EraseRootFromParent_Done,
     /* 1847739 */   // Label 25005: @1847739
     /* 1847739 */   GIM_Try, /*On fail goto*//*Label 25006*/ GIMT_Encode4(1847825), // Rule ID 13487 //
     /* 1847744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1847747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1847755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1847758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1847761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1847764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1847767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847790 */     // MIs[0] policy
     /* 1847790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847800 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1847803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847824 */     // GIR_Coverage, 13487,
     /* 1847824 */     GIR_EraseRootFromParent_Done,
     /* 1847825 */   // Label 25006: @1847825
     /* 1847825 */   GIM_Try, /*On fail goto*//*Label 25007*/ GIMT_Encode4(1847911), // Rule ID 13490 //
     /* 1847830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1847841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1847844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1847847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1847850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847876 */     // MIs[0] policy
     /* 1847876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1847889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847910 */     // GIR_Coverage, 13490,
     /* 1847910 */     GIR_EraseRootFromParent_Done,
     /* 1847911 */   // Label 25007: @1847911
     /* 1847911 */   GIM_Try, /*On fail goto*//*Label 25008*/ GIMT_Encode4(1847997), // Rule ID 13491 //
     /* 1847916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1847919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1847927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1847930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1847933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1847936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847962 */     // MIs[0] policy
     /* 1847962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847972 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1847975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847996 */     // GIR_Coverage, 13491,
     /* 1847996 */     GIR_EraseRootFromParent_Done,
     /* 1847997 */   // Label 25008: @1847997
     /* 1847997 */   GIM_Try, /*On fail goto*//*Label 25009*/ GIMT_Encode4(1848083), // Rule ID 13494 //
     /* 1848002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1848013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1848016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1848022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1848025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848048 */     // MIs[0] policy
     /* 1848048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848058 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1848061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848082 */     // GIR_Coverage, 13494,
     /* 1848082 */     GIR_EraseRootFromParent_Done,
     /* 1848083 */   // Label 25009: @1848083
     /* 1848083 */   GIM_Try, /*On fail goto*//*Label 25010*/ GIMT_Encode4(1848169), // Rule ID 13495 //
     /* 1848088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1848099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1848102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1848108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1848111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848134 */     // MIs[0] policy
     /* 1848134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848144 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1848147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848168 */     // GIR_Coverage, 13495,
     /* 1848168 */     GIR_EraseRootFromParent_Done,
     /* 1848169 */   // Label 25010: @1848169
     /* 1848169 */   GIM_Try, /*On fail goto*//*Label 25011*/ GIMT_Encode4(1848255), // Rule ID 13498 //
     /* 1848174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1848185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1848188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1848194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848220 */     // MIs[0] policy
     /* 1848220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848230 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1848233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848254 */     // GIR_Coverage, 13498,
     /* 1848254 */     GIR_EraseRootFromParent_Done,
     /* 1848255 */   // Label 25011: @1848255
     /* 1848255 */   GIM_Try, /*On fail goto*//*Label 25012*/ GIMT_Encode4(1848341), // Rule ID 13499 //
     /* 1848260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1848271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1848274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1848280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848306 */     // MIs[0] policy
     /* 1848306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848316 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1848319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848340 */     // GIR_Coverage, 13499,
     /* 1848340 */     GIR_EraseRootFromParent_Done,
     /* 1848341 */   // Label 25012: @1848341
     /* 1848341 */   GIM_Try, /*On fail goto*//*Label 25013*/ GIMT_Encode4(1848427), // Rule ID 13502 //
     /* 1848346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1848357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1848360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1848366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848392 */     // MIs[0] policy
     /* 1848392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1848405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848426 */     // GIR_Coverage, 13502,
     /* 1848426 */     GIR_EraseRootFromParent_Done,
     /* 1848427 */   // Label 25013: @1848427
     /* 1848427 */   GIM_Try, /*On fail goto*//*Label 25014*/ GIMT_Encode4(1848513), // Rule ID 13503 //
     /* 1848432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1848443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1848446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1848452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848478 */     // MIs[0] policy
     /* 1848478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848488 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1848491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848512 */     // GIR_Coverage, 13503,
     /* 1848512 */     GIR_EraseRootFromParent_Done,
     /* 1848513 */   // Label 25014: @1848513
     /* 1848513 */   GIM_Try, /*On fail goto*//*Label 25015*/ GIMT_Encode4(1848599), // Rule ID 13506 //
     /* 1848518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1848529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1848532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1848538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848564 */     // MIs[0] policy
     /* 1848564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848574 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1848577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848598 */     // GIR_Coverage, 13506,
     /* 1848598 */     GIR_EraseRootFromParent_Done,
     /* 1848599 */   // Label 25015: @1848599
     /* 1848599 */   GIM_Try, /*On fail goto*//*Label 25016*/ GIMT_Encode4(1848685), // Rule ID 13507 //
     /* 1848604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1848615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1848618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1848624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848650 */     // MIs[0] policy
     /* 1848650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1848663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848684 */     // GIR_Coverage, 13507,
     /* 1848684 */     GIR_EraseRootFromParent_Done,
     /* 1848685 */   // Label 25016: @1848685
     /* 1848685 */   GIM_Try, /*On fail goto*//*Label 25017*/ GIMT_Encode4(1848771), // Rule ID 13510 //
     /* 1848690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1848701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1848704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1848710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1848713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848736 */     // MIs[0] policy
     /* 1848736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848746 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1848749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848770 */     // GIR_Coverage, 13510,
     /* 1848770 */     GIR_EraseRootFromParent_Done,
     /* 1848771 */   // Label 25017: @1848771
     /* 1848771 */   GIM_Try, /*On fail goto*//*Label 25018*/ GIMT_Encode4(1848857), // Rule ID 13511 //
     /* 1848776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1848787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1848790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1848796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1848799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848822 */     // MIs[0] policy
     /* 1848822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848832 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1848835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848856 */     // GIR_Coverage, 13511,
     /* 1848856 */     GIR_EraseRootFromParent_Done,
     /* 1848857 */   // Label 25018: @1848857
     /* 1848857 */   GIM_Try, /*On fail goto*//*Label 25019*/ GIMT_Encode4(1848943), // Rule ID 13514 //
     /* 1848862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1848873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1848876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1848882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1848885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848908 */     // MIs[0] policy
     /* 1848908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848918 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1848921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848942 */     // GIR_Coverage, 13514,
     /* 1848942 */     GIR_EraseRootFromParent_Done,
     /* 1848943 */   // Label 25019: @1848943
     /* 1848943 */   GIM_Try, /*On fail goto*//*Label 25020*/ GIMT_Encode4(1849029), // Rule ID 13515 //
     /* 1848948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1848959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1848962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1848968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1848971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848994 */     // MIs[0] policy
     /* 1848994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849004 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1849007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849028 */     // GIR_Coverage, 13515,
     /* 1849028 */     GIR_EraseRootFromParent_Done,
     /* 1849029 */   // Label 25020: @1849029
     /* 1849029 */   GIM_Try, /*On fail goto*//*Label 25021*/ GIMT_Encode4(1849115), // Rule ID 13518 //
     /* 1849034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1849045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1849048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1849054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849080 */     // MIs[0] policy
     /* 1849080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849090 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1849093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849114 */     // GIR_Coverage, 13518,
     /* 1849114 */     GIR_EraseRootFromParent_Done,
     /* 1849115 */   // Label 25021: @1849115
     /* 1849115 */   GIM_Try, /*On fail goto*//*Label 25022*/ GIMT_Encode4(1849201), // Rule ID 13519 //
     /* 1849120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1849131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1849134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1849140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849166 */     // MIs[0] policy
     /* 1849166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1849179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849200 */     // GIR_Coverage, 13519,
     /* 1849200 */     GIR_EraseRootFromParent_Done,
     /* 1849201 */   // Label 25022: @1849201
     /* 1849201 */   GIM_Try, /*On fail goto*//*Label 25023*/ GIMT_Encode4(1849287), // Rule ID 13522 //
     /* 1849206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1849217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1849220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1849226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849252 */     // MIs[0] policy
     /* 1849252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849262 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1849265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849286 */     // GIR_Coverage, 13522,
     /* 1849286 */     GIR_EraseRootFromParent_Done,
     /* 1849287 */   // Label 25023: @1849287
     /* 1849287 */   GIM_Try, /*On fail goto*//*Label 25024*/ GIMT_Encode4(1849373), // Rule ID 13523 //
     /* 1849292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1849303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1849306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1849312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849338 */     // MIs[0] policy
     /* 1849338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849348 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1849351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849372 */     // GIR_Coverage, 13523,
     /* 1849372 */     GIR_EraseRootFromParent_Done,
     /* 1849373 */   // Label 25024: @1849373
     /* 1849373 */   GIM_Try, /*On fail goto*//*Label 25025*/ GIMT_Encode4(1849459), // Rule ID 13526 //
     /* 1849378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1849389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1849392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1849398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849424 */     // MIs[0] policy
     /* 1849424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1849437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849458 */     // GIR_Coverage, 13526,
     /* 1849458 */     GIR_EraseRootFromParent_Done,
     /* 1849459 */   // Label 25025: @1849459
     /* 1849459 */   GIM_Try, /*On fail goto*//*Label 25026*/ GIMT_Encode4(1849545), // Rule ID 13527 //
     /* 1849464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1849475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1849478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1849484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849510 */     // MIs[0] policy
     /* 1849510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849520 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1849523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849544 */     // GIR_Coverage, 13527,
     /* 1849544 */     GIR_EraseRootFromParent_Done,
     /* 1849545 */   // Label 25026: @1849545
     /* 1849545 */   GIM_Try, /*On fail goto*//*Label 25027*/ GIMT_Encode4(1849631), // Rule ID 13530 //
     /* 1849550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1849561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1849564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1849570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849596 */     // MIs[0] policy
     /* 1849596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1849609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849630 */     // GIR_Coverage, 13530,
     /* 1849630 */     GIR_EraseRootFromParent_Done,
     /* 1849631 */   // Label 25027: @1849631
     /* 1849631 */   GIM_Try, /*On fail goto*//*Label 25028*/ GIMT_Encode4(1849717), // Rule ID 13531 //
     /* 1849636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1849647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1849650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1849656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849682 */     // MIs[0] policy
     /* 1849682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849692 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1849695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849716 */     // GIR_Coverage, 13531,
     /* 1849716 */     GIR_EraseRootFromParent_Done,
     /* 1849717 */   // Label 25028: @1849717
     /* 1849717 */   GIM_Try, /*On fail goto*//*Label 25029*/ GIMT_Encode4(1849803), // Rule ID 13534 //
     /* 1849722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1849733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1849736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1849742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1849745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849768 */     // MIs[0] policy
     /* 1849768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849778 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1849781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849802 */     // GIR_Coverage, 13534,
     /* 1849802 */     GIR_EraseRootFromParent_Done,
     /* 1849803 */   // Label 25029: @1849803
     /* 1849803 */   GIM_Try, /*On fail goto*//*Label 25030*/ GIMT_Encode4(1849889), // Rule ID 13535 //
     /* 1849808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1849819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1849822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1849828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1849831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849854 */     // MIs[0] policy
     /* 1849854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1849867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849888 */     // GIR_Coverage, 13535,
     /* 1849888 */     GIR_EraseRootFromParent_Done,
     /* 1849889 */   // Label 25030: @1849889
     /* 1849889 */   GIM_Try, /*On fail goto*//*Label 25031*/ GIMT_Encode4(1849975), // Rule ID 13538 //
     /* 1849894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1849897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1849905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1849908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1849914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849940 */     // MIs[0] policy
     /* 1849940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849950 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1849953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1849971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849974 */     // GIR_Coverage, 13538,
     /* 1849974 */     GIR_EraseRootFromParent_Done,
     /* 1849975 */   // Label 25031: @1849975
     /* 1849975 */   GIM_Try, /*On fail goto*//*Label 25032*/ GIMT_Encode4(1850061), // Rule ID 13539 //
     /* 1849980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1849983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1849991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1849994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1850000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850026 */     // MIs[0] policy
     /* 1850026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850036 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1850039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850060 */     // GIR_Coverage, 13539,
     /* 1850060 */     GIR_EraseRootFromParent_Done,
     /* 1850061 */   // Label 25032: @1850061
     /* 1850061 */   GIM_Try, /*On fail goto*//*Label 25033*/ GIMT_Encode4(1850147), // Rule ID 13542 //
     /* 1850066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1850077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1850080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1850086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850112 */     // MIs[0] policy
     /* 1850112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1850125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850146 */     // GIR_Coverage, 13542,
     /* 1850146 */     GIR_EraseRootFromParent_Done,
     /* 1850147 */   // Label 25033: @1850147
     /* 1850147 */   GIM_Try, /*On fail goto*//*Label 25034*/ GIMT_Encode4(1850233), // Rule ID 13543 //
     /* 1850152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1850163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1850166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1850172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850198 */     // MIs[0] policy
     /* 1850198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850208 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1850211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850232 */     // GIR_Coverage, 13543,
     /* 1850232 */     GIR_EraseRootFromParent_Done,
     /* 1850233 */   // Label 25034: @1850233
     /* 1850233 */   GIM_Try, /*On fail goto*//*Label 25035*/ GIMT_Encode4(1850319), // Rule ID 13546 //
     /* 1850238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1850249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1850252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1850258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850284 */     // MIs[0] policy
     /* 1850284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850294 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1850297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850318 */     // GIR_Coverage, 13546,
     /* 1850318 */     GIR_EraseRootFromParent_Done,
     /* 1850319 */   // Label 25035: @1850319
     /* 1850319 */   GIM_Try, /*On fail goto*//*Label 25036*/ GIMT_Encode4(1850405), // Rule ID 13547 //
     /* 1850324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1850335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1850338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1850344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850370 */     // MIs[0] policy
     /* 1850370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850380 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1850383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850404 */     // GIR_Coverage, 13547,
     /* 1850404 */     GIR_EraseRootFromParent_Done,
     /* 1850405 */   // Label 25036: @1850405
     /* 1850405 */   GIM_Try, /*On fail goto*//*Label 25037*/ GIMT_Encode4(1850491), // Rule ID 13550 //
     /* 1850410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1850421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1850424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1850430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850456 */     // MIs[0] policy
     /* 1850456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850466 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1850469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850490 */     // GIR_Coverage, 13550,
     /* 1850490 */     GIR_EraseRootFromParent_Done,
     /* 1850491 */   // Label 25037: @1850491
     /* 1850491 */   GIM_Try, /*On fail goto*//*Label 25038*/ GIMT_Encode4(1850577), // Rule ID 13551 //
     /* 1850496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1850507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1850510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1850516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850542 */     // MIs[0] policy
     /* 1850542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850552 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1850555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850576 */     // GIR_Coverage, 13551,
     /* 1850576 */     GIR_EraseRootFromParent_Done,
     /* 1850577 */   // Label 25038: @1850577
     /* 1850577 */   GIM_Try, /*On fail goto*//*Label 25039*/ GIMT_Encode4(1850663), // Rule ID 13554 //
     /* 1850582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1850593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1850596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1850599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1850602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850628 */     // MIs[0] policy
     /* 1850628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850638 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1850641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850662 */     // GIR_Coverage, 13554,
     /* 1850662 */     GIR_EraseRootFromParent_Done,
     /* 1850663 */   // Label 25039: @1850663
     /* 1850663 */   GIM_Try, /*On fail goto*//*Label 25040*/ GIMT_Encode4(1850749), // Rule ID 13555 //
     /* 1850668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1850679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1850682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1850685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1850688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850714 */     // MIs[0] policy
     /* 1850714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850724 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1850727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850748 */     // GIR_Coverage, 13555,
     /* 1850748 */     GIR_EraseRootFromParent_Done,
     /* 1850749 */   // Label 25040: @1850749
     /* 1850749 */   GIM_Try, /*On fail goto*//*Label 25041*/ GIMT_Encode4(1850835), // Rule ID 13558 //
     /* 1850754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1850765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1850768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1850771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1850774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850800 */     // MIs[0] policy
     /* 1850800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850810 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1850813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850834 */     // GIR_Coverage, 13558,
     /* 1850834 */     GIR_EraseRootFromParent_Done,
     /* 1850835 */   // Label 25041: @1850835
     /* 1850835 */   GIM_Try, /*On fail goto*//*Label 25042*/ GIMT_Encode4(1850921), // Rule ID 13559 //
     /* 1850840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1850851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1850854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1850857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1850860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850886 */     // MIs[0] policy
     /* 1850886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1850899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850920 */     // GIR_Coverage, 13559,
     /* 1850920 */     GIR_EraseRootFromParent_Done,
     /* 1850921 */   // Label 25042: @1850921
     /* 1850921 */   GIM_Try, /*On fail goto*//*Label 25043*/ GIMT_Encode4(1851007), // Rule ID 13562 //
     /* 1850926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1850937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1850940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1850943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1850946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850972 */     // MIs[0] policy
     /* 1850972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850982 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1850985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851006 */     // GIR_Coverage, 13562,
     /* 1851006 */     GIR_EraseRootFromParent_Done,
     /* 1851007 */   // Label 25043: @1851007
     /* 1851007 */   GIM_Try, /*On fail goto*//*Label 25044*/ GIMT_Encode4(1851093), // Rule ID 13563 //
     /* 1851012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1851023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1851026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1851029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1851032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851058 */     // MIs[0] policy
     /* 1851058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1851071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851092 */     // GIR_Coverage, 13563,
     /* 1851092 */     GIR_EraseRootFromParent_Done,
     /* 1851093 */   // Label 25044: @1851093
     /* 1851093 */   GIM_Try, /*On fail goto*//*Label 25045*/ GIMT_Encode4(1851179), // Rule ID 13566 //
     /* 1851098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1851109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1851112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1851115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1851118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851144 */     // MIs[0] policy
     /* 1851144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851154 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11662:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1851157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851178 */     // GIR_Coverage, 13566,
     /* 1851178 */     GIR_EraseRootFromParent_Done,
     /* 1851179 */   // Label 25045: @1851179
     /* 1851179 */   GIM_Try, /*On fail goto*//*Label 25046*/ GIMT_Encode4(1851265), // Rule ID 13567 //
     /* 1851184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1851195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1851198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1851201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1851204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851230 */     // MIs[0] policy
     /* 1851230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851240 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11662:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1851243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851264 */     // GIR_Coverage, 13567,
     /* 1851264 */     GIR_EraseRootFromParent_Done,
     /* 1851265 */   // Label 25046: @1851265
     /* 1851265 */   GIM_Try, /*On fail goto*//*Label 25047*/ GIMT_Encode4(1851351), // Rule ID 13570 //
     /* 1851270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1851281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1851284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1851287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1851290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851316 */     // MIs[0] policy
     /* 1851316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851326 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11662:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1851329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851350 */     // GIR_Coverage, 13570,
     /* 1851350 */     GIR_EraseRootFromParent_Done,
     /* 1851351 */   // Label 25047: @1851351
     /* 1851351 */   GIM_Try, /*On fail goto*//*Label 25048*/ GIMT_Encode4(1851437), // Rule ID 13571 //
     /* 1851356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1851367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1851370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1851373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1851376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851402 */     // MIs[0] policy
     /* 1851402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851412 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11662:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1851415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851436 */     // GIR_Coverage, 13571,
     /* 1851436 */     GIR_EraseRootFromParent_Done,
     /* 1851437 */   // Label 25048: @1851437
     /* 1851437 */   GIM_Try, /*On fail goto*//*Label 25049*/ GIMT_Encode4(1851523), // Rule ID 13574 //
     /* 1851442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1851453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1851456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1851459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1851462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1851465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851488 */     // MIs[0] policy
     /* 1851488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851498 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11662:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1851501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851522 */     // GIR_Coverage, 13574,
     /* 1851522 */     GIR_EraseRootFromParent_Done,
     /* 1851523 */   // Label 25049: @1851523
     /* 1851523 */   GIM_Try, /*On fail goto*//*Label 25050*/ GIMT_Encode4(1851609), // Rule ID 13575 //
     /* 1851528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1851539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1851542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1851545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1851548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1851551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851574 */     // MIs[0] policy
     /* 1851574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851584 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11662:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1851587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851608 */     // GIR_Coverage, 13575,
     /* 1851608 */     GIR_EraseRootFromParent_Done,
     /* 1851609 */   // Label 25050: @1851609
     /* 1851609 */   GIM_Try, /*On fail goto*//*Label 25051*/ GIMT_Encode4(1851695), // Rule ID 13578 //
     /* 1851614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1851625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1851628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1851631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1851634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851660 */     // MIs[0] policy
     /* 1851660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851670 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1851673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851694 */     // GIR_Coverage, 13578,
     /* 1851694 */     GIR_EraseRootFromParent_Done,
     /* 1851695 */   // Label 25051: @1851695
     /* 1851695 */   GIM_Try, /*On fail goto*//*Label 25052*/ GIMT_Encode4(1851781), // Rule ID 13579 //
     /* 1851700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1851711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1851714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1851717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1851720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851746 */     // MIs[0] policy
     /* 1851746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851756 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1851759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851780 */     // GIR_Coverage, 13579,
     /* 1851780 */     GIR_EraseRootFromParent_Done,
     /* 1851781 */   // Label 25052: @1851781
     /* 1851781 */   GIM_Try, /*On fail goto*//*Label 25053*/ GIMT_Encode4(1851867), // Rule ID 13582 //
     /* 1851786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1851797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1851800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1851803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1851806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851832 */     // MIs[0] policy
     /* 1851832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1851845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851866 */     // GIR_Coverage, 13582,
     /* 1851866 */     GIR_EraseRootFromParent_Done,
     /* 1851867 */   // Label 25053: @1851867
     /* 1851867 */   GIM_Try, /*On fail goto*//*Label 25054*/ GIMT_Encode4(1851953), // Rule ID 13583 //
     /* 1851872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1851883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1851886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1851889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1851892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851918 */     // MIs[0] policy
     /* 1851918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851928 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1851931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851952 */     // GIR_Coverage, 13583,
     /* 1851952 */     GIR_EraseRootFromParent_Done,
     /* 1851953 */   // Label 25054: @1851953
     /* 1851953 */   GIM_Try, /*On fail goto*//*Label 25055*/ GIMT_Encode4(1852039), // Rule ID 13586 //
     /* 1851958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1851969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1851972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1851975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1851978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852004 */     // MIs[0] policy
     /* 1852004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11662:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1852017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852038 */     // GIR_Coverage, 13586,
     /* 1852038 */     GIR_EraseRootFromParent_Done,
     /* 1852039 */   // Label 25055: @1852039
     /* 1852039 */   GIM_Try, /*On fail goto*//*Label 25056*/ GIMT_Encode4(1852125), // Rule ID 13587 //
     /* 1852044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1852055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1852058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1852061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1852064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852090 */     // MIs[0] policy
     /* 1852090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11662:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1852103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852124 */     // GIR_Coverage, 13587,
     /* 1852124 */     GIR_EraseRootFromParent_Done,
     /* 1852125 */   // Label 25056: @1852125
     /* 1852125 */   GIM_Try, /*On fail goto*//*Label 25057*/ GIMT_Encode4(1852211), // Rule ID 13590 //
     /* 1852130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1852141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1852144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1852147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1852150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852176 */     // MIs[0] policy
     /* 1852176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852186 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11662:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1852189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852210 */     // GIR_Coverage, 13590,
     /* 1852210 */     GIR_EraseRootFromParent_Done,
     /* 1852211 */   // Label 25057: @1852211
     /* 1852211 */   GIM_Try, /*On fail goto*//*Label 25058*/ GIMT_Encode4(1852297), // Rule ID 13591 //
     /* 1852216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1852227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1852230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1852233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1852236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852262 */     // MIs[0] policy
     /* 1852262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852272 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11662:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1852275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852296 */     // GIR_Coverage, 13591,
     /* 1852296 */     GIR_EraseRootFromParent_Done,
     /* 1852297 */   // Label 25058: @1852297
     /* 1852297 */   GIM_Try, /*On fail goto*//*Label 25059*/ GIMT_Encode4(1852383), // Rule ID 13594 //
     /* 1852302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1852313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1852316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1852319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1852322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852348 */     // MIs[0] policy
     /* 1852348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852358 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11662:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1852361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852382 */     // GIR_Coverage, 13594,
     /* 1852382 */     GIR_EraseRootFromParent_Done,
     /* 1852383 */   // Label 25059: @1852383
     /* 1852383 */   GIM_Try, /*On fail goto*//*Label 25060*/ GIMT_Encode4(1852469), // Rule ID 13595 //
     /* 1852388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1852399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1852402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1852405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1852408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852434 */     // MIs[0] policy
     /* 1852434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852444 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11662:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1852447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852468 */     // GIR_Coverage, 13595,
     /* 1852468 */     GIR_EraseRootFromParent_Done,
     /* 1852469 */   // Label 25060: @1852469
     /* 1852469 */   GIM_Try, /*On fail goto*//*Label 25061*/ GIMT_Encode4(1852555), // Rule ID 13598 //
     /* 1852474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1852477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1852485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1852488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1852491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1852494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852520 */     // MIs[0] policy
     /* 1852520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852530 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1852533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852554 */     // GIR_Coverage, 13598,
     /* 1852554 */     GIR_EraseRootFromParent_Done,
     /* 1852555 */   // Label 25061: @1852555
     /* 1852555 */   GIM_Try, /*On fail goto*//*Label 25062*/ GIMT_Encode4(1852641), // Rule ID 13599 //
     /* 1852560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1852563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1852571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1852574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1852577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1852580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852606 */     // MIs[0] policy
     /* 1852606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852616 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1852619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852640 */     // GIR_Coverage, 13599,
     /* 1852640 */     GIR_EraseRootFromParent_Done,
     /* 1852641 */   // Label 25062: @1852641
     /* 1852641 */   GIM_Try, /*On fail goto*//*Label 25063*/ GIMT_Encode4(1852727), // Rule ID 13602 //
     /* 1852646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1852649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1852657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1852660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1852663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1852666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852692 */     // MIs[0] policy
     /* 1852692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11662:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1852705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852726 */     // GIR_Coverage, 13602,
     /* 1852726 */     GIR_EraseRootFromParent_Done,
     /* 1852727 */   // Label 25063: @1852727
     /* 1852727 */   GIM_Try, /*On fail goto*//*Label 25064*/ GIMT_Encode4(1852813), // Rule ID 13603 //
     /* 1852732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1852735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1852743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1852746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1852749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1852752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852778 */     // MIs[0] policy
     /* 1852778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11662:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1852791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852812 */     // GIR_Coverage, 13603,
     /* 1852812 */     GIR_EraseRootFromParent_Done,
     /* 1852813 */   // Label 25064: @1852813
     /* 1852813 */   GIM_Try, /*On fail goto*//*Label 25065*/ GIMT_Encode4(1852899), // Rule ID 13606 //
     /* 1852818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1852821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1852829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1852832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1852835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1852838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852864 */     // MIs[0] policy
     /* 1852864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11662:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1852877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852898 */     // GIR_Coverage, 13606,
     /* 1852898 */     GIR_EraseRootFromParent_Done,
     /* 1852899 */   // Label 25065: @1852899
     /* 1852899 */   GIM_Try, /*On fail goto*//*Label 25066*/ GIMT_Encode4(1852985), // Rule ID 13607 //
     /* 1852904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1852907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1852915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1852918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1852921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1852924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852950 */     // MIs[0] policy
     /* 1852950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852960 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11662:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1852963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852984 */     // GIR_Coverage, 13607,
     /* 1852984 */     GIR_EraseRootFromParent_Done,
     /* 1852985 */   // Label 25066: @1852985
     /* 1852985 */   GIM_Try, /*On fail goto*//*Label 25067*/ GIMT_Encode4(1853071), // Rule ID 13610 //
     /* 1852990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1852993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1853001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1853004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1853007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1853010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853036 */     // MIs[0] policy
     /* 1853036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11662:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1853049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853070 */     // GIR_Coverage, 13610,
     /* 1853070 */     GIR_EraseRootFromParent_Done,
     /* 1853071 */   // Label 25067: @1853071
     /* 1853071 */   GIM_Try, /*On fail goto*//*Label 25068*/ GIMT_Encode4(1853157), // Rule ID 13611 //
     /* 1853076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1853087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1853090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1853093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1853096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853122 */     // MIs[0] policy
     /* 1853122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853132 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11662:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1853135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853156 */     // GIR_Coverage, 13611,
     /* 1853156 */     GIR_EraseRootFromParent_Done,
     /* 1853157 */   // Label 25068: @1853157
     /* 1853157 */   GIM_Try, /*On fail goto*//*Label 25069*/ GIMT_Encode4(1853243), // Rule ID 13614 //
     /* 1853162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1853173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1853176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1853182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853208 */     // MIs[0] policy
     /* 1853208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853218 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1853221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853242 */     // GIR_Coverage, 13614,
     /* 1853242 */     GIR_EraseRootFromParent_Done,
     /* 1853243 */   // Label 25069: @1853243
     /* 1853243 */   GIM_Try, /*On fail goto*//*Label 25070*/ GIMT_Encode4(1853329), // Rule ID 13615 //
     /* 1853248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1853259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1853262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1853268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853294 */     // MIs[0] policy
     /* 1853294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853304 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1853307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853328 */     // GIR_Coverage, 13615,
     /* 1853328 */     GIR_EraseRootFromParent_Done,
     /* 1853329 */   // Label 25070: @1853329
     /* 1853329 */   GIM_Try, /*On fail goto*//*Label 25071*/ GIMT_Encode4(1853415), // Rule ID 13618 //
     /* 1853334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1853345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1853348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1853354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853380 */     // MIs[0] policy
     /* 1853380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853390 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1853393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853414 */     // GIR_Coverage, 13618,
     /* 1853414 */     GIR_EraseRootFromParent_Done,
     /* 1853415 */   // Label 25071: @1853415
     /* 1853415 */   GIM_Try, /*On fail goto*//*Label 25072*/ GIMT_Encode4(1853501), // Rule ID 13619 //
     /* 1853420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1853431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1853434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1853440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853466 */     // MIs[0] policy
     /* 1853466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853476 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1853479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853500 */     // GIR_Coverage, 13619,
     /* 1853500 */     GIR_EraseRootFromParent_Done,
     /* 1853501 */   // Label 25072: @1853501
     /* 1853501 */   GIM_Try, /*On fail goto*//*Label 25073*/ GIMT_Encode4(1853587), // Rule ID 13622 //
     /* 1853506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1853517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1853520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1853526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853552 */     // MIs[0] policy
     /* 1853552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853562 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1853565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853586 */     // GIR_Coverage, 13622,
     /* 1853586 */     GIR_EraseRootFromParent_Done,
     /* 1853587 */   // Label 25073: @1853587
     /* 1853587 */   GIM_Try, /*On fail goto*//*Label 25074*/ GIMT_Encode4(1853673), // Rule ID 13623 //
     /* 1853592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1853603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1853606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1853612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853638 */     // MIs[0] policy
     /* 1853638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853648 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1853651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853672 */     // GIR_Coverage, 13623,
     /* 1853672 */     GIR_EraseRootFromParent_Done,
     /* 1853673 */   // Label 25074: @1853673
     /* 1853673 */   GIM_Try, /*On fail goto*//*Label 25075*/ GIMT_Encode4(1853759), // Rule ID 13626 //
     /* 1853678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1853689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1853692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1853698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853724 */     // MIs[0] policy
     /* 1853724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11662:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1853737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853758 */     // GIR_Coverage, 13626,
     /* 1853758 */     GIR_EraseRootFromParent_Done,
     /* 1853759 */   // Label 25075: @1853759
     /* 1853759 */   GIM_Try, /*On fail goto*//*Label 25076*/ GIMT_Encode4(1853845), // Rule ID 13627 //
     /* 1853764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1853775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1853778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1853784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853810 */     // MIs[0] policy
     /* 1853810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853820 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11662:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1853823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853844 */     // GIR_Coverage, 13627,
     /* 1853844 */     GIR_EraseRootFromParent_Done,
     /* 1853845 */   // Label 25076: @1853845
     /* 1853845 */   GIM_Try, /*On fail goto*//*Label 25077*/ GIMT_Encode4(1853931), // Rule ID 13630 //
     /* 1853850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1853861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1853864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1853870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1853873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853896 */     // MIs[0] policy
     /* 1853896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853906 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11662:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1853909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853930 */     // GIR_Coverage, 13630,
     /* 1853930 */     GIR_EraseRootFromParent_Done,
     /* 1853931 */   // Label 25077: @1853931
     /* 1853931 */   GIM_Try, /*On fail goto*//*Label 25078*/ GIMT_Encode4(1854017), // Rule ID 13631 //
     /* 1853936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1853947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1853950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1853956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1853959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853982 */     // MIs[0] policy
     /* 1853982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853992 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11662:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1853995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854016 */     // GIR_Coverage, 13631,
     /* 1854016 */     GIR_EraseRootFromParent_Done,
     /* 1854017 */   // Label 25078: @1854017
     /* 1854017 */   GIM_Try, /*On fail goto*//*Label 25079*/ GIMT_Encode4(1854103), // Rule ID 13634 //
     /* 1854022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1854033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1854036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1854042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1854045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854068 */     // MIs[0] policy
     /* 1854068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854078 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11662:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1854081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854102 */     // GIR_Coverage, 13634,
     /* 1854102 */     GIR_EraseRootFromParent_Done,
     /* 1854103 */   // Label 25079: @1854103
     /* 1854103 */   GIM_Try, /*On fail goto*//*Label 25080*/ GIMT_Encode4(1854189), // Rule ID 13635 //
     /* 1854108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1854119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1854122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1854128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1854131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854154 */     // MIs[0] policy
     /* 1854154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854164 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11662:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1854167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854188 */     // GIR_Coverage, 13635,
     /* 1854188 */     GIR_EraseRootFromParent_Done,
     /* 1854189 */   // Label 25080: @1854189
     /* 1854189 */   GIM_Try, /*On fail goto*//*Label 25081*/ GIMT_Encode4(1854275), // Rule ID 13638 //
     /* 1854194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1854205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1854208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854240 */     // MIs[0] policy
     /* 1854240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854250 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1854253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854274 */     // GIR_Coverage, 13638,
     /* 1854274 */     GIR_EraseRootFromParent_Done,
     /* 1854275 */   // Label 25081: @1854275
     /* 1854275 */   GIM_Try, /*On fail goto*//*Label 25082*/ GIMT_Encode4(1854361), // Rule ID 13639 //
     /* 1854280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1854291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1854294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854326 */     // MIs[0] policy
     /* 1854326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854336 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1854339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854360 */     // GIR_Coverage, 13639,
     /* 1854360 */     GIR_EraseRootFromParent_Done,
     /* 1854361 */   // Label 25082: @1854361
     /* 1854361 */   GIM_Try, /*On fail goto*//*Label 25083*/ GIMT_Encode4(1854447), // Rule ID 13642 //
     /* 1854366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1854377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1854380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1854386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854412 */     // MIs[0] policy
     /* 1854412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1854425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854446 */     // GIR_Coverage, 13642,
     /* 1854446 */     GIR_EraseRootFromParent_Done,
     /* 1854447 */   // Label 25083: @1854447
     /* 1854447 */   GIM_Try, /*On fail goto*//*Label 25084*/ GIMT_Encode4(1854533), // Rule ID 13643 //
     /* 1854452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1854463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1854466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1854472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854498 */     // MIs[0] policy
     /* 1854498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1854511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854532 */     // GIR_Coverage, 13643,
     /* 1854532 */     GIR_EraseRootFromParent_Done,
     /* 1854533 */   // Label 25084: @1854533
     /* 1854533 */   GIM_Try, /*On fail goto*//*Label 25085*/ GIMT_Encode4(1854619), // Rule ID 13646 //
     /* 1854538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1854549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1854552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1854558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854584 */     // MIs[0] policy
     /* 1854584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11662:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1854597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854618 */     // GIR_Coverage, 13646,
     /* 1854618 */     GIR_EraseRootFromParent_Done,
     /* 1854619 */   // Label 25085: @1854619
     /* 1854619 */   GIM_Try, /*On fail goto*//*Label 25086*/ GIMT_Encode4(1854705), // Rule ID 13647 //
     /* 1854624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1854635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1854638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1854644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854670 */     // MIs[0] policy
     /* 1854670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11662:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1854683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854704 */     // GIR_Coverage, 13647,
     /* 1854704 */     GIR_EraseRootFromParent_Done,
     /* 1854705 */   // Label 25086: @1854705
     /* 1854705 */   GIM_Try, /*On fail goto*//*Label 25087*/ GIMT_Encode4(1854791), // Rule ID 13650 //
     /* 1854710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1854721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1854724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1854730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1854740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854756 */     // MIs[0] policy
     /* 1854756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11662:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1854769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854790 */     // GIR_Coverage, 13650,
     /* 1854790 */     GIR_EraseRootFromParent_Done,
     /* 1854791 */   // Label 25087: @1854791
     /* 1854791 */   GIM_Try, /*On fail goto*//*Label 25088*/ GIMT_Encode4(1854877), // Rule ID 13651 //
     /* 1854796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1854807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1854810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1854816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1854826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854842 */     // MIs[0] policy
     /* 1854842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11662:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1854855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854876 */     // GIR_Coverage, 13651,
     /* 1854876 */     GIR_EraseRootFromParent_Done,
     /* 1854877 */   // Label 25088: @1854877
     /* 1854877 */   GIM_Try, /*On fail goto*//*Label 25089*/ GIMT_Encode4(1854963), // Rule ID 13654 //
     /* 1854882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1854893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1854896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1854902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1854905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854928 */     // MIs[0] policy
     /* 1854928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854938 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11662:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1854941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854962 */     // GIR_Coverage, 13654,
     /* 1854962 */     GIR_EraseRootFromParent_Done,
     /* 1854963 */   // Label 25089: @1854963
     /* 1854963 */   GIM_Try, /*On fail goto*//*Label 25090*/ GIMT_Encode4(1855049), // Rule ID 13655 //
     /* 1854968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1854979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1854982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1854988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1854991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855014 */     // MIs[0] policy
     /* 1855014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855024 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11662:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1855027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855048 */     // GIR_Coverage, 13655,
     /* 1855048 */     GIR_EraseRootFromParent_Done,
     /* 1855049 */   // Label 25090: @1855049
     /* 1855049 */   GIM_Try, /*On fail goto*//*Label 25091*/ GIMT_Encode4(1855135), // Rule ID 13658 //
     /* 1855054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1855065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1855068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1855074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855100 */     // MIs[0] policy
     /* 1855100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855110 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1855113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855134 */     // GIR_Coverage, 13658,
     /* 1855134 */     GIR_EraseRootFromParent_Done,
     /* 1855135 */   // Label 25091: @1855135
     /* 1855135 */   GIM_Try, /*On fail goto*//*Label 25092*/ GIMT_Encode4(1855221), // Rule ID 13659 //
     /* 1855140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1855151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1855154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1855160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855186 */     // MIs[0] policy
     /* 1855186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855196 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1855199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855220 */     // GIR_Coverage, 13659,
     /* 1855220 */     GIR_EraseRootFromParent_Done,
     /* 1855221 */   // Label 25092: @1855221
     /* 1855221 */   GIM_Try, /*On fail goto*//*Label 25093*/ GIMT_Encode4(1855307), // Rule ID 13662 //
     /* 1855226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1855237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1855240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1855246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855272 */     // MIs[0] policy
     /* 1855272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855282 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11662:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1855285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855306 */     // GIR_Coverage, 13662,
     /* 1855306 */     GIR_EraseRootFromParent_Done,
     /* 1855307 */   // Label 25093: @1855307
     /* 1855307 */   GIM_Try, /*On fail goto*//*Label 25094*/ GIMT_Encode4(1855393), // Rule ID 13663 //
     /* 1855312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1855323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1855326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1855332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855358 */     // MIs[0] policy
     /* 1855358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855368 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11662:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1855371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855392 */     // GIR_Coverage, 13663,
     /* 1855392 */     GIR_EraseRootFromParent_Done,
     /* 1855393 */   // Label 25094: @1855393
     /* 1855393 */   GIM_Try, /*On fail goto*//*Label 25095*/ GIMT_Encode4(1855479), // Rule ID 13666 //
     /* 1855398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1855409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1855412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1855418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855444 */     // MIs[0] policy
     /* 1855444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855454 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11662:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1855457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855478 */     // GIR_Coverage, 13666,
     /* 1855478 */     GIR_EraseRootFromParent_Done,
     /* 1855479 */   // Label 25095: @1855479
     /* 1855479 */   GIM_Try, /*On fail goto*//*Label 25096*/ GIMT_Encode4(1855565), // Rule ID 13667 //
     /* 1855484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1855495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1855498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1855504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855530 */     // MIs[0] policy
     /* 1855530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855540 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11662:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1855543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855564 */     // GIR_Coverage, 13667,
     /* 1855564 */     GIR_EraseRootFromParent_Done,
     /* 1855565 */   // Label 25096: @1855565
     /* 1855565 */   GIM_Try, /*On fail goto*//*Label 25097*/ GIMT_Encode4(1855651), // Rule ID 13670 //
     /* 1855570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1855581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1855584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1855590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855616 */     // MIs[0] policy
     /* 1855616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855626 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11662:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1855629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855650 */     // GIR_Coverage, 13670,
     /* 1855650 */     GIR_EraseRootFromParent_Done,
     /* 1855651 */   // Label 25097: @1855651
     /* 1855651 */   GIM_Try, /*On fail goto*//*Label 25098*/ GIMT_Encode4(1855737), // Rule ID 13671 //
     /* 1855656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1855667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1855670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1855676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855702 */     // MIs[0] policy
     /* 1855702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855712 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11662:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1855715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855736 */     // GIR_Coverage, 13671,
     /* 1855736 */     GIR_EraseRootFromParent_Done,
     /* 1855737 */   // Label 25098: @1855737
     /* 1855737 */   GIM_Try, /*On fail goto*//*Label 25099*/ GIMT_Encode4(1855823), // Rule ID 13674 //
     /* 1855742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1855753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1855756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1855759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1855762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855788 */     // MIs[0] policy
     /* 1855788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855798 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1855801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855822 */     // GIR_Coverage, 13674,
     /* 1855822 */     GIR_EraseRootFromParent_Done,
     /* 1855823 */   // Label 25099: @1855823
     /* 1855823 */   GIM_Try, /*On fail goto*//*Label 25100*/ GIMT_Encode4(1855909), // Rule ID 13675 //
     /* 1855828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1855839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1855842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1855845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1855848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855874 */     // MIs[0] policy
     /* 1855874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855884 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1855887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855908 */     // GIR_Coverage, 13675,
     /* 1855908 */     GIR_EraseRootFromParent_Done,
     /* 1855909 */   // Label 25100: @1855909
     /* 1855909 */   GIM_Try, /*On fail goto*//*Label 25101*/ GIMT_Encode4(1855995), // Rule ID 13678 //
     /* 1855914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1855925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1855928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1855931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1855934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855960 */     // MIs[0] policy
     /* 1855960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855970 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1855973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855994 */     // GIR_Coverage, 13678,
     /* 1855994 */     GIR_EraseRootFromParent_Done,
     /* 1855995 */   // Label 25101: @1855995
     /* 1855995 */   GIM_Try, /*On fail goto*//*Label 25102*/ GIMT_Encode4(1856081), // Rule ID 13679 //
     /* 1856000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1856011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1856014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1856017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1856020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856046 */     // MIs[0] policy
     /* 1856046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856056 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1856059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856080 */     // GIR_Coverage, 13679,
     /* 1856080 */     GIR_EraseRootFromParent_Done,
     /* 1856081 */   // Label 25102: @1856081
     /* 1856081 */   GIM_Try, /*On fail goto*//*Label 25103*/ GIMT_Encode4(1856167), // Rule ID 13682 //
     /* 1856086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1856097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1856100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1856103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1856106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856132 */     // MIs[0] policy
     /* 1856132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856142 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1856145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856166 */     // GIR_Coverage, 13682,
     /* 1856166 */     GIR_EraseRootFromParent_Done,
     /* 1856167 */   // Label 25103: @1856167
     /* 1856167 */   GIM_Try, /*On fail goto*//*Label 25104*/ GIMT_Encode4(1856253), // Rule ID 13683 //
     /* 1856172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1856183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1856186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1856189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1856192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856218 */     // MIs[0] policy
     /* 1856218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856228 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1856231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856252 */     // GIR_Coverage, 13683,
     /* 1856252 */     GIR_EraseRootFromParent_Done,
     /* 1856253 */   // Label 25104: @1856253
     /* 1856253 */   GIM_Try, /*On fail goto*//*Label 25105*/ GIMT_Encode4(1856339), // Rule ID 13686 //
     /* 1856258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1856269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1856272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1856275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1856278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856304 */     // MIs[0] policy
     /* 1856304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11664:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1856317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856338 */     // GIR_Coverage, 13686,
     /* 1856338 */     GIR_EraseRootFromParent_Done,
     /* 1856339 */   // Label 25105: @1856339
     /* 1856339 */   GIM_Try, /*On fail goto*//*Label 25106*/ GIMT_Encode4(1856425), // Rule ID 13687 //
     /* 1856344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1856355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1856358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1856361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1856364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856390 */     // MIs[0] policy
     /* 1856390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11664:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1856403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856424 */     // GIR_Coverage, 13687,
     /* 1856424 */     GIR_EraseRootFromParent_Done,
     /* 1856425 */   // Label 25106: @1856425
     /* 1856425 */   GIM_Try, /*On fail goto*//*Label 25107*/ GIMT_Encode4(1856511), // Rule ID 13690 //
     /* 1856430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1856441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1856444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1856447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1856450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856476 */     // MIs[0] policy
     /* 1856476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856486 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11664:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1856489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856510 */     // GIR_Coverage, 13690,
     /* 1856510 */     GIR_EraseRootFromParent_Done,
     /* 1856511 */   // Label 25107: @1856511
     /* 1856511 */   GIM_Try, /*On fail goto*//*Label 25108*/ GIMT_Encode4(1856597), // Rule ID 13691 //
     /* 1856516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1856527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1856530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1856533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1856536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856562 */     // MIs[0] policy
     /* 1856562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856572 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11664:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1856575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856596 */     // GIR_Coverage, 13691,
     /* 1856596 */     GIR_EraseRootFromParent_Done,
     /* 1856597 */   // Label 25108: @1856597
     /* 1856597 */   GIM_Try, /*On fail goto*//*Label 25109*/ GIMT_Encode4(1856683), // Rule ID 13694 //
     /* 1856602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1856613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1856616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1856619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1856622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1856625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856648 */     // MIs[0] policy
     /* 1856648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856658 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11664:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1856661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856682 */     // GIR_Coverage, 13694,
     /* 1856682 */     GIR_EraseRootFromParent_Done,
     /* 1856683 */   // Label 25109: @1856683
     /* 1856683 */   GIM_Try, /*On fail goto*//*Label 25110*/ GIMT_Encode4(1856769), // Rule ID 13695 //
     /* 1856688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1856699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1856702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1856705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1856708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1856711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856734 */     // MIs[0] policy
     /* 1856734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856744 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11664:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1856747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856768 */     // GIR_Coverage, 13695,
     /* 1856768 */     GIR_EraseRootFromParent_Done,
     /* 1856769 */   // Label 25110: @1856769
     /* 1856769 */   GIM_Try, /*On fail goto*//*Label 25111*/ GIMT_Encode4(1856855), // Rule ID 13698 //
     /* 1856774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1856785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1856788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1856791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1856794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856820 */     // MIs[0] policy
     /* 1856820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856830 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1856833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1856851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856854 */     // GIR_Coverage, 13698,
     /* 1856854 */     GIR_EraseRootFromParent_Done,
     /* 1856855 */   // Label 25111: @1856855
     /* 1856855 */   GIM_Try, /*On fail goto*//*Label 25112*/ GIMT_Encode4(1856941), // Rule ID 13699 //
     /* 1856860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1856871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1856874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1856877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1856880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856906 */     // MIs[0] policy
     /* 1856906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856916 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1856919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1856937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856940 */     // GIR_Coverage, 13699,
     /* 1856940 */     GIR_EraseRootFromParent_Done,
     /* 1856941 */   // Label 25112: @1856941
     /* 1856941 */   GIM_Try, /*On fail goto*//*Label 25113*/ GIMT_Encode4(1857027), // Rule ID 13702 //
     /* 1856946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1856957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1856960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1856963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1856966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856992 */     // MIs[0] policy
     /* 1856992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1857005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857026 */     // GIR_Coverage, 13702,
     /* 1857026 */     GIR_EraseRootFromParent_Done,
     /* 1857027 */   // Label 25113: @1857027
     /* 1857027 */   GIM_Try, /*On fail goto*//*Label 25114*/ GIMT_Encode4(1857113), // Rule ID 13703 //
     /* 1857032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1857043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1857046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1857049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1857052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857078 */     // MIs[0] policy
     /* 1857078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857088 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1857091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857112 */     // GIR_Coverage, 13703,
     /* 1857112 */     GIR_EraseRootFromParent_Done,
     /* 1857113 */   // Label 25114: @1857113
     /* 1857113 */   GIM_Try, /*On fail goto*//*Label 25115*/ GIMT_Encode4(1857199), // Rule ID 13706 //
     /* 1857118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1857129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1857132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1857135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1857138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857164 */     // MIs[0] policy
     /* 1857164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11664:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1857177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857198 */     // GIR_Coverage, 13706,
     /* 1857198 */     GIR_EraseRootFromParent_Done,
     /* 1857199 */   // Label 25115: @1857199
     /* 1857199 */   GIM_Try, /*On fail goto*//*Label 25116*/ GIMT_Encode4(1857285), // Rule ID 13707 //
     /* 1857204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1857215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1857218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1857221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1857224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857250 */     // MIs[0] policy
     /* 1857250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11664:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1857263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857284 */     // GIR_Coverage, 13707,
     /* 1857284 */     GIR_EraseRootFromParent_Done,
     /* 1857285 */   // Label 25116: @1857285
     /* 1857285 */   GIM_Try, /*On fail goto*//*Label 25117*/ GIMT_Encode4(1857371), // Rule ID 13710 //
     /* 1857290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1857301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1857304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1857307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1857310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857336 */     // MIs[0] policy
     /* 1857336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11664:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1857349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857370 */     // GIR_Coverage, 13710,
     /* 1857370 */     GIR_EraseRootFromParent_Done,
     /* 1857371 */   // Label 25117: @1857371
     /* 1857371 */   GIM_Try, /*On fail goto*//*Label 25118*/ GIMT_Encode4(1857457), // Rule ID 13711 //
     /* 1857376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1857387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1857390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1857393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1857396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857422 */     // MIs[0] policy
     /* 1857422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857432 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11664:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1857435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857456 */     // GIR_Coverage, 13711,
     /* 1857456 */     GIR_EraseRootFromParent_Done,
     /* 1857457 */   // Label 25118: @1857457
     /* 1857457 */   GIM_Try, /*On fail goto*//*Label 25119*/ GIMT_Encode4(1857543), // Rule ID 13714 //
     /* 1857462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1857473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1857476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1857479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1857482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1857485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857508 */     // MIs[0] policy
     /* 1857508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11664:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1857521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857542 */     // GIR_Coverage, 13714,
     /* 1857542 */     GIR_EraseRootFromParent_Done,
     /* 1857543 */   // Label 25119: @1857543
     /* 1857543 */   GIM_Try, /*On fail goto*//*Label 25120*/ GIMT_Encode4(1857629), // Rule ID 13715 //
     /* 1857548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1857559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1857562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1857565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1857568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1857571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857594 */     // MIs[0] policy
     /* 1857594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857604 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11664:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1857607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857628 */     // GIR_Coverage, 13715,
     /* 1857628 */     GIR_EraseRootFromParent_Done,
     /* 1857629 */   // Label 25120: @1857629
     /* 1857629 */   GIM_Try, /*On fail goto*//*Label 25121*/ GIMT_Encode4(1857715), // Rule ID 13718 //
     /* 1857634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1857637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1857645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1857648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1857651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1857654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857680 */     // MIs[0] policy
     /* 1857680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857690 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1857693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857714 */     // GIR_Coverage, 13718,
     /* 1857714 */     GIR_EraseRootFromParent_Done,
     /* 1857715 */   // Label 25121: @1857715
     /* 1857715 */   GIM_Try, /*On fail goto*//*Label 25122*/ GIMT_Encode4(1857801), // Rule ID 13719 //
     /* 1857720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1857723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1857731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1857734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1857737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1857740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857766 */     // MIs[0] policy
     /* 1857766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857776 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1857779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857800 */     // GIR_Coverage, 13719,
     /* 1857800 */     GIR_EraseRootFromParent_Done,
     /* 1857801 */   // Label 25122: @1857801
     /* 1857801 */   GIM_Try, /*On fail goto*//*Label 25123*/ GIMT_Encode4(1857887), // Rule ID 13722 //
     /* 1857806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1857809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1857817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1857820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1857823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1857826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857852 */     // MIs[0] policy
     /* 1857852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857862 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11664:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1857865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857886 */     // GIR_Coverage, 13722,
     /* 1857886 */     GIR_EraseRootFromParent_Done,
     /* 1857887 */   // Label 25123: @1857887
     /* 1857887 */   GIM_Try, /*On fail goto*//*Label 25124*/ GIMT_Encode4(1857973), // Rule ID 13723 //
     /* 1857892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1857895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1857903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1857906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1857909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1857912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857938 */     // MIs[0] policy
     /* 1857938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857948 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11664:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1857951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857972 */     // GIR_Coverage, 13723,
     /* 1857972 */     GIR_EraseRootFromParent_Done,
     /* 1857973 */   // Label 25124: @1857973
     /* 1857973 */   GIM_Try, /*On fail goto*//*Label 25125*/ GIMT_Encode4(1858059), // Rule ID 13726 //
     /* 1857978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1857981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1857989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1857992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1857995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1857998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858024 */     // MIs[0] policy
     /* 1858024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858034 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11664:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1858037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858058 */     // GIR_Coverage, 13726,
     /* 1858058 */     GIR_EraseRootFromParent_Done,
     /* 1858059 */   // Label 25125: @1858059
     /* 1858059 */   GIM_Try, /*On fail goto*//*Label 25126*/ GIMT_Encode4(1858145), // Rule ID 13727 //
     /* 1858064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1858075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1858078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1858081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1858084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858110 */     // MIs[0] policy
     /* 1858110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858120 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11664:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1858123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858144 */     // GIR_Coverage, 13727,
     /* 1858144 */     GIR_EraseRootFromParent_Done,
     /* 1858145 */   // Label 25126: @1858145
     /* 1858145 */   GIM_Try, /*On fail goto*//*Label 25127*/ GIMT_Encode4(1858231), // Rule ID 13730 //
     /* 1858150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1858161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1858164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1858167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1858170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858196 */     // MIs[0] policy
     /* 1858196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858206 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11664:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1858209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858230 */     // GIR_Coverage, 13730,
     /* 1858230 */     GIR_EraseRootFromParent_Done,
     /* 1858231 */   // Label 25127: @1858231
     /* 1858231 */   GIM_Try, /*On fail goto*//*Label 25128*/ GIMT_Encode4(1858317), // Rule ID 13731 //
     /* 1858236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1858247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1858250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1858253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1858256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858282 */     // MIs[0] policy
     /* 1858282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858292 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11664:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1858295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858316 */     // GIR_Coverage, 13731,
     /* 1858316 */     GIR_EraseRootFromParent_Done,
     /* 1858317 */   // Label 25128: @1858317
     /* 1858317 */   GIM_Try, /*On fail goto*//*Label 25129*/ GIMT_Encode4(1858403), // Rule ID 13734 //
     /* 1858322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1858333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1858336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1858342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858368 */     // MIs[0] policy
     /* 1858368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858378 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1858381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858402 */     // GIR_Coverage, 13734,
     /* 1858402 */     GIR_EraseRootFromParent_Done,
     /* 1858403 */   // Label 25129: @1858403
     /* 1858403 */   GIM_Try, /*On fail goto*//*Label 25130*/ GIMT_Encode4(1858489), // Rule ID 13735 //
     /* 1858408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1858419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1858422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1858428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858454 */     // MIs[0] policy
     /* 1858454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858464 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1858467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858488 */     // GIR_Coverage, 13735,
     /* 1858488 */     GIR_EraseRootFromParent_Done,
     /* 1858489 */   // Label 25130: @1858489
     /* 1858489 */   GIM_Try, /*On fail goto*//*Label 25131*/ GIMT_Encode4(1858575), // Rule ID 13738 //
     /* 1858494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1858505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1858508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1858514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858540 */     // MIs[0] policy
     /* 1858540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858550 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1858553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858574 */     // GIR_Coverage, 13738,
     /* 1858574 */     GIR_EraseRootFromParent_Done,
     /* 1858575 */   // Label 25131: @1858575
     /* 1858575 */   GIM_Try, /*On fail goto*//*Label 25132*/ GIMT_Encode4(1858661), // Rule ID 13739 //
     /* 1858580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1858591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1858594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1858600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858626 */     // MIs[0] policy
     /* 1858626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858636 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1858639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858660 */     // GIR_Coverage, 13739,
     /* 1858660 */     GIR_EraseRootFromParent_Done,
     /* 1858661 */   // Label 25132: @1858661
     /* 1858661 */   GIM_Try, /*On fail goto*//*Label 25133*/ GIMT_Encode4(1858747), // Rule ID 13742 //
     /* 1858666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1858677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1858680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1858686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858712 */     // MIs[0] policy
     /* 1858712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858722 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1858725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858746 */     // GIR_Coverage, 13742,
     /* 1858746 */     GIR_EraseRootFromParent_Done,
     /* 1858747 */   // Label 25133: @1858747
     /* 1858747 */   GIM_Try, /*On fail goto*//*Label 25134*/ GIMT_Encode4(1858833), // Rule ID 13743 //
     /* 1858752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1858763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1858766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1858772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858798 */     // MIs[0] policy
     /* 1858798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858808 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1858811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858832 */     // GIR_Coverage, 13743,
     /* 1858832 */     GIR_EraseRootFromParent_Done,
     /* 1858833 */   // Label 25134: @1858833
     /* 1858833 */   GIM_Try, /*On fail goto*//*Label 25135*/ GIMT_Encode4(1858919), // Rule ID 13746 //
     /* 1858838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1858849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1858852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1858858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858884 */     // MIs[0] policy
     /* 1858884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11664:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1858897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858918 */     // GIR_Coverage, 13746,
     /* 1858918 */     GIR_EraseRootFromParent_Done,
     /* 1858919 */   // Label 25135: @1858919
     /* 1858919 */   GIM_Try, /*On fail goto*//*Label 25136*/ GIMT_Encode4(1859005), // Rule ID 13747 //
     /* 1858924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1858935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1858938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1858944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858970 */     // MIs[0] policy
     /* 1858970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858980 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11664:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1858983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859004 */     // GIR_Coverage, 13747,
     /* 1859004 */     GIR_EraseRootFromParent_Done,
     /* 1859005 */   // Label 25136: @1859005
     /* 1859005 */   GIM_Try, /*On fail goto*//*Label 25137*/ GIMT_Encode4(1859091), // Rule ID 13750 //
     /* 1859010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1859021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1859024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1859030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859056 */     // MIs[0] policy
     /* 1859056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859066 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11664:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1859069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859090 */     // GIR_Coverage, 13750,
     /* 1859090 */     GIR_EraseRootFromParent_Done,
     /* 1859091 */   // Label 25137: @1859091
     /* 1859091 */   GIM_Try, /*On fail goto*//*Label 25138*/ GIMT_Encode4(1859177), // Rule ID 13751 //
     /* 1859096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1859107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1859110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1859116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859142 */     // MIs[0] policy
     /* 1859142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859152 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11664:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1859155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859176 */     // GIR_Coverage, 13751,
     /* 1859176 */     GIR_EraseRootFromParent_Done,
     /* 1859177 */   // Label 25138: @1859177
     /* 1859177 */   GIM_Try, /*On fail goto*//*Label 25139*/ GIMT_Encode4(1859263), // Rule ID 13754 //
     /* 1859182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1859193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1859196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1859202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1859205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859228 */     // MIs[0] policy
     /* 1859228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859238 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11664:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1859241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859262 */     // GIR_Coverage, 13754,
     /* 1859262 */     GIR_EraseRootFromParent_Done,
     /* 1859263 */   // Label 25139: @1859263
     /* 1859263 */   GIM_Try, /*On fail goto*//*Label 25140*/ GIMT_Encode4(1859349), // Rule ID 13755 //
     /* 1859268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1859279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1859282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1859288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1859291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859314 */     // MIs[0] policy
     /* 1859314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859324 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11664:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1859327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859348 */     // GIR_Coverage, 13755,
     /* 1859348 */     GIR_EraseRootFromParent_Done,
     /* 1859349 */   // Label 25140: @1859349
     /* 1859349 */   GIM_Try, /*On fail goto*//*Label 25141*/ GIMT_Encode4(1859435), // Rule ID 13758 //
     /* 1859354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1859365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1859368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1859374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859400 */     // MIs[0] policy
     /* 1859400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859410 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1859413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859434 */     // GIR_Coverage, 13758,
     /* 1859434 */     GIR_EraseRootFromParent_Done,
     /* 1859435 */   // Label 25141: @1859435
     /* 1859435 */   GIM_Try, /*On fail goto*//*Label 25142*/ GIMT_Encode4(1859521), // Rule ID 13759 //
     /* 1859440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1859451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1859454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1859460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859486 */     // MIs[0] policy
     /* 1859486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859496 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1859499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859520 */     // GIR_Coverage, 13759,
     /* 1859520 */     GIR_EraseRootFromParent_Done,
     /* 1859521 */   // Label 25142: @1859521
     /* 1859521 */   GIM_Try, /*On fail goto*//*Label 25143*/ GIMT_Encode4(1859607), // Rule ID 13762 //
     /* 1859526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1859537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1859540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1859546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859572 */     // MIs[0] policy
     /* 1859572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859582 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1859585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859606 */     // GIR_Coverage, 13762,
     /* 1859606 */     GIR_EraseRootFromParent_Done,
     /* 1859607 */   // Label 25143: @1859607
     /* 1859607 */   GIM_Try, /*On fail goto*//*Label 25144*/ GIMT_Encode4(1859693), // Rule ID 13763 //
     /* 1859612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1859623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1859626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1859632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859658 */     // MIs[0] policy
     /* 1859658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859668 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1859671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859692 */     // GIR_Coverage, 13763,
     /* 1859692 */     GIR_EraseRootFromParent_Done,
     /* 1859693 */   // Label 25144: @1859693
     /* 1859693 */   GIM_Try, /*On fail goto*//*Label 25145*/ GIMT_Encode4(1859779), // Rule ID 13766 //
     /* 1859698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1859709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1859712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1859718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859744 */     // MIs[0] policy
     /* 1859744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11664:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1859757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859778 */     // GIR_Coverage, 13766,
     /* 1859778 */     GIR_EraseRootFromParent_Done,
     /* 1859779 */   // Label 25145: @1859779
     /* 1859779 */   GIM_Try, /*On fail goto*//*Label 25146*/ GIMT_Encode4(1859865), // Rule ID 13767 //
     /* 1859784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1859795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1859798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1859804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859830 */     // MIs[0] policy
     /* 1859830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11664:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1859843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859864 */     // GIR_Coverage, 13767,
     /* 1859864 */     GIR_EraseRootFromParent_Done,
     /* 1859865 */   // Label 25146: @1859865
     /* 1859865 */   GIM_Try, /*On fail goto*//*Label 25147*/ GIMT_Encode4(1859951), // Rule ID 13770 //
     /* 1859870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1859881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1859884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1859890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859916 */     // MIs[0] policy
     /* 1859916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11664:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1859929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859950 */     // GIR_Coverage, 13770,
     /* 1859950 */     GIR_EraseRootFromParent_Done,
     /* 1859951 */   // Label 25147: @1859951
     /* 1859951 */   GIM_Try, /*On fail goto*//*Label 25148*/ GIMT_Encode4(1860037), // Rule ID 13771 //
     /* 1859956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1859967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1859970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1859976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860002 */     // MIs[0] policy
     /* 1860002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860012 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11664:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1860015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860036 */     // GIR_Coverage, 13771,
     /* 1860036 */     GIR_EraseRootFromParent_Done,
     /* 1860037 */   // Label 25148: @1860037
     /* 1860037 */   GIM_Try, /*On fail goto*//*Label 25149*/ GIMT_Encode4(1860123), // Rule ID 13774 //
     /* 1860042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1860053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1860056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1860062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860088 */     // MIs[0] policy
     /* 1860088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860098 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11664:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1860101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860122 */     // GIR_Coverage, 13774,
     /* 1860122 */     GIR_EraseRootFromParent_Done,
     /* 1860123 */   // Label 25149: @1860123
     /* 1860123 */   GIM_Try, /*On fail goto*//*Label 25150*/ GIMT_Encode4(1860209), // Rule ID 13775 //
     /* 1860128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1860139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1860142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1860148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860174 */     // MIs[0] policy
     /* 1860174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860184 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11664:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1860187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860208 */     // GIR_Coverage, 13775,
     /* 1860208 */     GIR_EraseRootFromParent_Done,
     /* 1860209 */   // Label 25150: @1860209
     /* 1860209 */   GIM_Try, /*On fail goto*//*Label 25151*/ GIMT_Encode4(1860295), // Rule ID 13778 //
     /* 1860214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1860225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1860228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1860234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860260 */     // MIs[0] policy
     /* 1860260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860270 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1860273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860294 */     // GIR_Coverage, 13778,
     /* 1860294 */     GIR_EraseRootFromParent_Done,
     /* 1860295 */   // Label 25151: @1860295
     /* 1860295 */   GIM_Try, /*On fail goto*//*Label 25152*/ GIMT_Encode4(1860381), // Rule ID 13779 //
     /* 1860300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1860311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1860314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1860320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860346 */     // MIs[0] policy
     /* 1860346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1860359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860380 */     // GIR_Coverage, 13779,
     /* 1860380 */     GIR_EraseRootFromParent_Done,
     /* 1860381 */   // Label 25152: @1860381
     /* 1860381 */   GIM_Try, /*On fail goto*//*Label 25153*/ GIMT_Encode4(1860467), // Rule ID 13782 //
     /* 1860386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1860397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1860400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1860406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860432 */     // MIs[0] policy
     /* 1860432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860442 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11664:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1860445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860466 */     // GIR_Coverage, 13782,
     /* 1860466 */     GIR_EraseRootFromParent_Done,
     /* 1860467 */   // Label 25153: @1860467
     /* 1860467 */   GIM_Try, /*On fail goto*//*Label 25154*/ GIMT_Encode4(1860553), // Rule ID 13783 //
     /* 1860472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1860483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1860486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1860492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860518 */     // MIs[0] policy
     /* 1860518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860528 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11664:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1860531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860552 */     // GIR_Coverage, 13783,
     /* 1860552 */     GIR_EraseRootFromParent_Done,
     /* 1860553 */   // Label 25154: @1860553
     /* 1860553 */   GIM_Try, /*On fail goto*//*Label 25155*/ GIMT_Encode4(1860639), // Rule ID 13786 //
     /* 1860558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1860569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1860572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1860578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860604 */     // MIs[0] policy
     /* 1860604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860614 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11664:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1860617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860638 */     // GIR_Coverage, 13786,
     /* 1860638 */     GIR_EraseRootFromParent_Done,
     /* 1860639 */   // Label 25155: @1860639
     /* 1860639 */   GIM_Try, /*On fail goto*//*Label 25156*/ GIMT_Encode4(1860725), // Rule ID 13787 //
     /* 1860644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1860655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1860658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1860664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860690 */     // MIs[0] policy
     /* 1860690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860700 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11664:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1860703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860724 */     // GIR_Coverage, 13787,
     /* 1860724 */     GIR_EraseRootFromParent_Done,
     /* 1860725 */   // Label 25156: @1860725
     /* 1860725 */   GIM_Try, /*On fail goto*//*Label 25157*/ GIMT_Encode4(1860811), // Rule ID 13790 //
     /* 1860730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1860741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1860744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1860750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860776 */     // MIs[0] policy
     /* 1860776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11664:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1860789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860810 */     // GIR_Coverage, 13790,
     /* 1860810 */     GIR_EraseRootFromParent_Done,
     /* 1860811 */   // Label 25157: @1860811
     /* 1860811 */   GIM_Try, /*On fail goto*//*Label 25158*/ GIMT_Encode4(1860897), // Rule ID 13791 //
     /* 1860816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1860827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1860830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1860836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860862 */     // MIs[0] policy
     /* 1860862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860872 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11664:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1860875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860896 */     // GIR_Coverage, 13791,
     /* 1860896 */     GIR_EraseRootFromParent_Done,
     /* 1860897 */   // Label 25158: @1860897
     /* 1860897 */   GIM_Try, /*On fail goto*//*Label 25159*/ GIMT_Encode4(1860983), // Rule ID 13794 //
     /* 1860902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1860913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1860916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1860922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860948 */     // MIs[0] policy
     /* 1860948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860958 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1860961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1860979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860982 */     // GIR_Coverage, 13794,
     /* 1860982 */     GIR_EraseRootFromParent_Done,
     /* 1860983 */   // Label 25159: @1860983
     /* 1860983 */   GIM_Try, /*On fail goto*//*Label 25160*/ GIMT_Encode4(1861069), // Rule ID 13795 //
     /* 1860988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1860999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1861002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1861008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861034 */     // MIs[0] policy
     /* 1861034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861044 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1861047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861068 */     // GIR_Coverage, 13795,
     /* 1861068 */     GIR_EraseRootFromParent_Done,
     /* 1861069 */   // Label 25160: @1861069
     /* 1861069 */   GIM_Try, /*On fail goto*//*Label 25161*/ GIMT_Encode4(1861155), // Rule ID 13798 //
     /* 1861074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1861085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1861088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1861094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861120 */     // MIs[0] policy
     /* 1861120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861130 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1861133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861154 */     // GIR_Coverage, 13798,
     /* 1861154 */     GIR_EraseRootFromParent_Done,
     /* 1861155 */   // Label 25161: @1861155
     /* 1861155 */   GIM_Try, /*On fail goto*//*Label 25162*/ GIMT_Encode4(1861241), // Rule ID 13799 //
     /* 1861160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1861171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1861174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1861180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861206 */     // MIs[0] policy
     /* 1861206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861216 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1861219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861240 */     // GIR_Coverage, 13799,
     /* 1861240 */     GIR_EraseRootFromParent_Done,
     /* 1861241 */   // Label 25162: @1861241
     /* 1861241 */   GIM_Try, /*On fail goto*//*Label 25163*/ GIMT_Encode4(1861327), // Rule ID 13802 //
     /* 1861246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1861257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1861260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1861266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861292 */     // MIs[0] policy
     /* 1861292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1861305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861326 */     // GIR_Coverage, 13802,
     /* 1861326 */     GIR_EraseRootFromParent_Done,
     /* 1861327 */   // Label 25163: @1861327
     /* 1861327 */   GIM_Try, /*On fail goto*//*Label 25164*/ GIMT_Encode4(1861413), // Rule ID 13803 //
     /* 1861332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1861343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1861346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1861352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861378 */     // MIs[0] policy
     /* 1861378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861388 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1861391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861412 */     // GIR_Coverage, 13803,
     /* 1861412 */     GIR_EraseRootFromParent_Done,
     /* 1861413 */   // Label 25164: @1861413
     /* 1861413 */   GIM_Try, /*On fail goto*//*Label 25165*/ GIMT_Encode4(1861499), // Rule ID 13806 //
     /* 1861418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1861429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1861432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1861438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1861448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861464 */     // MIs[0] policy
     /* 1861464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861474 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1861477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861498 */     // GIR_Coverage, 13806,
     /* 1861498 */     GIR_EraseRootFromParent_Done,
     /* 1861499 */   // Label 25165: @1861499
     /* 1861499 */   GIM_Try, /*On fail goto*//*Label 25166*/ GIMT_Encode4(1861585), // Rule ID 13807 //
     /* 1861504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1861515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1861518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1861524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1861534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861550 */     // MIs[0] policy
     /* 1861550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861560 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1861563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861584 */     // GIR_Coverage, 13807,
     /* 1861584 */     GIR_EraseRootFromParent_Done,
     /* 1861585 */   // Label 25166: @1861585
     /* 1861585 */   GIM_Try, /*On fail goto*//*Label 25167*/ GIMT_Encode4(1861671), // Rule ID 13810 //
     /* 1861590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1861601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1861604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1861610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1861613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861636 */     // MIs[0] policy
     /* 1861636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861646 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1861649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861670 */     // GIR_Coverage, 13810,
     /* 1861670 */     GIR_EraseRootFromParent_Done,
     /* 1861671 */   // Label 25167: @1861671
     /* 1861671 */   GIM_Try, /*On fail goto*//*Label 25168*/ GIMT_Encode4(1861757), // Rule ID 13811 //
     /* 1861676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1861687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1861690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1861696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1861699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861722 */     // MIs[0] policy
     /* 1861722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861732 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1861735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861756 */     // GIR_Coverage, 13811,
     /* 1861756 */     GIR_EraseRootFromParent_Done,
     /* 1861757 */   // Label 25168: @1861757
     /* 1861757 */   GIM_Try, /*On fail goto*//*Label 25169*/ GIMT_Encode4(1861843), // Rule ID 13814 //
     /* 1861762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1861773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1861776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1861782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1861785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861808 */     // MIs[0] policy
     /* 1861808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861818 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1861821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861842 */     // GIR_Coverage, 13814,
     /* 1861842 */     GIR_EraseRootFromParent_Done,
     /* 1861843 */   // Label 25169: @1861843
     /* 1861843 */   GIM_Try, /*On fail goto*//*Label 25170*/ GIMT_Encode4(1861929), // Rule ID 13815 //
     /* 1861848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1861859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1861862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1861868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1861871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861894 */     // MIs[0] policy
     /* 1861894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861904 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1861907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861928 */     // GIR_Coverage, 13815,
     /* 1861928 */     GIR_EraseRootFromParent_Done,
     /* 1861929 */   // Label 25170: @1861929
     /* 1861929 */   GIM_Try, /*On fail goto*//*Label 25171*/ GIMT_Encode4(1862015), // Rule ID 13818 //
     /* 1861934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1861945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1861948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1861954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861980 */     // MIs[0] policy
     /* 1861980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861990 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1861993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862014 */     // GIR_Coverage, 13818,
     /* 1862014 */     GIR_EraseRootFromParent_Done,
     /* 1862015 */   // Label 25171: @1862015
     /* 1862015 */   GIM_Try, /*On fail goto*//*Label 25172*/ GIMT_Encode4(1862101), // Rule ID 13819 //
     /* 1862020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1862031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1862034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1862040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862066 */     // MIs[0] policy
     /* 1862066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862076 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1862079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862100 */     // GIR_Coverage, 13819,
     /* 1862100 */     GIR_EraseRootFromParent_Done,
     /* 1862101 */   // Label 25172: @1862101
     /* 1862101 */   GIM_Try, /*On fail goto*//*Label 25173*/ GIMT_Encode4(1862187), // Rule ID 13822 //
     /* 1862106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1862126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862152 */     // MIs[0] policy
     /* 1862152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862162 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11668:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1862165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862186 */     // GIR_Coverage, 13822,
     /* 1862186 */     GIR_EraseRootFromParent_Done,
     /* 1862187 */   // Label 25173: @1862187
     /* 1862187 */   GIM_Try, /*On fail goto*//*Label 25174*/ GIMT_Encode4(1862273), // Rule ID 13823 //
     /* 1862192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1862212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862238 */     // MIs[0] policy
     /* 1862238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862248 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11668:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1862251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862272 */     // GIR_Coverage, 13823,
     /* 1862272 */     GIR_EraseRootFromParent_Done,
     /* 1862273 */   // Label 25174: @1862273
     /* 1862273 */   GIM_Try, /*On fail goto*//*Label 25175*/ GIMT_Encode4(1862359), // Rule ID 13826 //
     /* 1862278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1862289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1862292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1862298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862324 */     // MIs[0] policy
     /* 1862324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1862337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862358 */     // GIR_Coverage, 13826,
     /* 1862358 */     GIR_EraseRootFromParent_Done,
     /* 1862359 */   // Label 25175: @1862359
     /* 1862359 */   GIM_Try, /*On fail goto*//*Label 25176*/ GIMT_Encode4(1862445), // Rule ID 13827 //
     /* 1862364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1862375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1862378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1862384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862410 */     // MIs[0] policy
     /* 1862410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1862423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862444 */     // GIR_Coverage, 13827,
     /* 1862444 */     GIR_EraseRootFromParent_Done,
     /* 1862445 */   // Label 25176: @1862445
     /* 1862445 */   GIM_Try, /*On fail goto*//*Label 25177*/ GIMT_Encode4(1862531), // Rule ID 13830 //
     /* 1862450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1862461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1862464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1862470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1862473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862496 */     // MIs[0] policy
     /* 1862496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862506 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1862509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862530 */     // GIR_Coverage, 13830,
     /* 1862530 */     GIR_EraseRootFromParent_Done,
     /* 1862531 */   // Label 25177: @1862531
     /* 1862531 */   GIM_Try, /*On fail goto*//*Label 25178*/ GIMT_Encode4(1862617), // Rule ID 13831 //
     /* 1862536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1862547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1862550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1862556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1862559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862582 */     // MIs[0] policy
     /* 1862582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1862595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862616 */     // GIR_Coverage, 13831,
     /* 1862616 */     GIR_EraseRootFromParent_Done,
     /* 1862617 */   // Label 25178: @1862617
     /* 1862617 */   GIM_Try, /*On fail goto*//*Label 25179*/ GIMT_Encode4(1862703), // Rule ID 13834 //
     /* 1862622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1862633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1862636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1862642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1862645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1862652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1862656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862668 */     // MIs[0] policy
     /* 1862668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862678 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1862681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862702 */     // GIR_Coverage, 13834,
     /* 1862702 */     GIR_EraseRootFromParent_Done,
     /* 1862703 */   // Label 25179: @1862703
     /* 1862703 */   GIM_Try, /*On fail goto*//*Label 25180*/ GIMT_Encode4(1862789), // Rule ID 13835 //
     /* 1862708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1862719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1862722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1862728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1862731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1862738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1862742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862754 */     // MIs[0] policy
     /* 1862754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862764 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1862767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862788 */     // GIR_Coverage, 13835,
     /* 1862788 */     GIR_EraseRootFromParent_Done,
     /* 1862789 */   // Label 25180: @1862789
     /* 1862789 */   GIM_Try, /*On fail goto*//*Label 25181*/ GIMT_Encode4(1862875), // Rule ID 13838 //
     /* 1862794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1862797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1862805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1862808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1862814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862840 */     // MIs[0] policy
     /* 1862840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862850 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1862853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862874 */     // GIR_Coverage, 13838,
     /* 1862874 */     GIR_EraseRootFromParent_Done,
     /* 1862875 */   // Label 25181: @1862875
     /* 1862875 */   GIM_Try, /*On fail goto*//*Label 25182*/ GIMT_Encode4(1862961), // Rule ID 13839 //
     /* 1862880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1862883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1862891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1862894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1862900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862926 */     // MIs[0] policy
     /* 1862926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862936 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1862939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862960 */     // GIR_Coverage, 13839,
     /* 1862960 */     GIR_EraseRootFromParent_Done,
     /* 1862961 */   // Label 25182: @1862961
     /* 1862961 */   GIM_Try, /*On fail goto*//*Label 25183*/ GIMT_Encode4(1863047), // Rule ID 13842 //
     /* 1862966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1862969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1862977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1862980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1862986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863012 */     // MIs[0] policy
     /* 1863012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863022 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1863025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863046 */     // GIR_Coverage, 13842,
     /* 1863046 */     GIR_EraseRootFromParent_Done,
     /* 1863047 */   // Label 25183: @1863047
     /* 1863047 */   GIM_Try, /*On fail goto*//*Label 25184*/ GIMT_Encode4(1863133), // Rule ID 13843 //
     /* 1863052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1863063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1863066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1863072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1863075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863098 */     // MIs[0] policy
     /* 1863098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863108 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1863111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863132 */     // GIR_Coverage, 13843,
     /* 1863132 */     GIR_EraseRootFromParent_Done,
     /* 1863133 */   // Label 25184: @1863133
     /* 1863133 */   GIM_Try, /*On fail goto*//*Label 25185*/ GIMT_Encode4(1863219), // Rule ID 13846 //
     /* 1863138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1863141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1863149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1863152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1863158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863184 */     // MIs[0] policy
     /* 1863184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863194 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1863197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863218 */     // GIR_Coverage, 13846,
     /* 1863218 */     GIR_EraseRootFromParent_Done,
     /* 1863219 */   // Label 25185: @1863219
     /* 1863219 */   GIM_Try, /*On fail goto*//*Label 25186*/ GIMT_Encode4(1863305), // Rule ID 13847 //
     /* 1863224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1863235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1863238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1863244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863270 */     // MIs[0] policy
     /* 1863270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863280 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1863283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863304 */     // GIR_Coverage, 13847,
     /* 1863304 */     GIR_EraseRootFromParent_Done,
     /* 1863305 */   // Label 25186: @1863305
     /* 1863305 */   GIM_Try, /*On fail goto*//*Label 25187*/ GIMT_Encode4(1863391), // Rule ID 13850 //
     /* 1863310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1863313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1863321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1863324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1863330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863356 */     // MIs[0] policy
     /* 1863356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863366 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1863369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863390 */     // GIR_Coverage, 13850,
     /* 1863390 */     GIR_EraseRootFromParent_Done,
     /* 1863391 */   // Label 25187: @1863391
     /* 1863391 */   GIM_Try, /*On fail goto*//*Label 25188*/ GIMT_Encode4(1863477), // Rule ID 13851 //
     /* 1863396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1863407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1863410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1863416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863442 */     // MIs[0] policy
     /* 1863442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863452 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1863455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863476 */     // GIR_Coverage, 13851,
     /* 1863476 */     GIR_EraseRootFromParent_Done,
     /* 1863477 */   // Label 25188: @1863477
     /* 1863477 */   GIM_Try, /*On fail goto*//*Label 25189*/ GIMT_Encode4(1863566), // Rule ID 14060 //
     /* 1863482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1863493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1863496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1863499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1863502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1863505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863528 */     // MIs[0] policy
     /* 1863528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863538 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1863541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863565 */     // GIR_Coverage, 14060,
     /* 1863565 */     GIR_EraseRootFromParent_Done,
     /* 1863566 */   // Label 25189: @1863566
     /* 1863566 */   GIM_Try, /*On fail goto*//*Label 25190*/ GIMT_Encode4(1863655), // Rule ID 14061 //
     /* 1863571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1863582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1863585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1863588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1863591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1863594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863617 */     // MIs[0] policy
     /* 1863617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863627 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1863630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863654 */     // GIR_Coverage, 14061,
     /* 1863654 */     GIR_EraseRootFromParent_Done,
     /* 1863655 */   // Label 25190: @1863655
     /* 1863655 */   GIM_Try, /*On fail goto*//*Label 25191*/ GIMT_Encode4(1863744), // Rule ID 14064 //
     /* 1863660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1863671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1863674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1863677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1863680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1863683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863706 */     // MIs[0] policy
     /* 1863706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863716 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1863719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863743 */     // GIR_Coverage, 14064,
     /* 1863743 */     GIR_EraseRootFromParent_Done,
     /* 1863744 */   // Label 25191: @1863744
     /* 1863744 */   GIM_Try, /*On fail goto*//*Label 25192*/ GIMT_Encode4(1863833), // Rule ID 14065 //
     /* 1863749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1863760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1863763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1863766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1863769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1863772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863795 */     // MIs[0] policy
     /* 1863795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863805 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1863808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863832 */     // GIR_Coverage, 14065,
     /* 1863832 */     GIR_EraseRootFromParent_Done,
     /* 1863833 */   // Label 25192: @1863833
     /* 1863833 */   GIM_Try, /*On fail goto*//*Label 25193*/ GIMT_Encode4(1863922), // Rule ID 14068 //
     /* 1863838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1863849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1863852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1863855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1863858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863884 */     // MIs[0] policy
     /* 1863884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863894 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1863897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863921 */     // GIR_Coverage, 14068,
     /* 1863921 */     GIR_EraseRootFromParent_Done,
     /* 1863922 */   // Label 25193: @1863922
     /* 1863922 */   GIM_Try, /*On fail goto*//*Label 25194*/ GIMT_Encode4(1864011), // Rule ID 14069 //
     /* 1863927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1863938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1863941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1863944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1863947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863973 */     // MIs[0] policy
     /* 1863973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863983 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1863986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864010 */     // GIR_Coverage, 14069,
     /* 1864010 */     GIR_EraseRootFromParent_Done,
     /* 1864011 */   // Label 25194: @1864011
     /* 1864011 */   GIM_Try, /*On fail goto*//*Label 25195*/ GIMT_Encode4(1864100), // Rule ID 14072 //
     /* 1864016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1864027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1864030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1864033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1864036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864062 */     // MIs[0] policy
     /* 1864062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864072 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1864075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864099 */     // GIR_Coverage, 14072,
     /* 1864099 */     GIR_EraseRootFromParent_Done,
     /* 1864100 */   // Label 25195: @1864100
     /* 1864100 */   GIM_Try, /*On fail goto*//*Label 25196*/ GIMT_Encode4(1864189), // Rule ID 14073 //
     /* 1864105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1864116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1864119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1864122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1864125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864151 */     // MIs[0] policy
     /* 1864151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864161 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1864164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864188 */     // GIR_Coverage, 14073,
     /* 1864188 */     GIR_EraseRootFromParent_Done,
     /* 1864189 */   // Label 25196: @1864189
     /* 1864189 */   GIM_Try, /*On fail goto*//*Label 25197*/ GIMT_Encode4(1864278), // Rule ID 14076 //
     /* 1864194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1864205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1864208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1864211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1864214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864240 */     // MIs[0] policy
     /* 1864240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864250 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864277 */     // GIR_Coverage, 14076,
     /* 1864277 */     GIR_EraseRootFromParent_Done,
     /* 1864278 */   // Label 25197: @1864278
     /* 1864278 */   GIM_Try, /*On fail goto*//*Label 25198*/ GIMT_Encode4(1864367), // Rule ID 14077 //
     /* 1864283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1864294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1864297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1864300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1864303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864329 */     // MIs[0] policy
     /* 1864329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864339 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864366 */     // GIR_Coverage, 14077,
     /* 1864366 */     GIR_EraseRootFromParent_Done,
     /* 1864367 */   // Label 25198: @1864367
     /* 1864367 */   GIM_Try, /*On fail goto*//*Label 25199*/ GIMT_Encode4(1864456), // Rule ID 14080 //
     /* 1864372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1864383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1864386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1864389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1864392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864418 */     // MIs[0] policy
     /* 1864418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864428 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864455 */     // GIR_Coverage, 14080,
     /* 1864455 */     GIR_EraseRootFromParent_Done,
     /* 1864456 */   // Label 25199: @1864456
     /* 1864456 */   GIM_Try, /*On fail goto*//*Label 25200*/ GIMT_Encode4(1864545), // Rule ID 14081 //
     /* 1864461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1864472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1864475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1864478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1864481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864507 */     // MIs[0] policy
     /* 1864507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864517 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864544 */     // GIR_Coverage, 14081,
     /* 1864544 */     GIR_EraseRootFromParent_Done,
     /* 1864545 */   // Label 25200: @1864545
     /* 1864545 */   GIM_Try, /*On fail goto*//*Label 25201*/ GIMT_Encode4(1864634), // Rule ID 14084 //
     /* 1864550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1864561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1864564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1864567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1864570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1864573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864596 */     // MIs[0] policy
     /* 1864596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864606 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1864609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864633 */     // GIR_Coverage, 14084,
     /* 1864633 */     GIR_EraseRootFromParent_Done,
     /* 1864634 */   // Label 25201: @1864634
     /* 1864634 */   GIM_Try, /*On fail goto*//*Label 25202*/ GIMT_Encode4(1864723), // Rule ID 14085 //
     /* 1864639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1864650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1864653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1864656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1864659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1864662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864685 */     // MIs[0] policy
     /* 1864685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864695 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1864698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864722 */     // GIR_Coverage, 14085,
     /* 1864722 */     GIR_EraseRootFromParent_Done,
     /* 1864723 */   // Label 25202: @1864723
     /* 1864723 */   GIM_Try, /*On fail goto*//*Label 25203*/ GIMT_Encode4(1864812), // Rule ID 14088 //
     /* 1864728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1864739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1864742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1864745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1864748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864774 */     // MIs[0] policy
     /* 1864774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1864787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864811 */     // GIR_Coverage, 14088,
     /* 1864811 */     GIR_EraseRootFromParent_Done,
     /* 1864812 */   // Label 25203: @1864812
     /* 1864812 */   GIM_Try, /*On fail goto*//*Label 25204*/ GIMT_Encode4(1864901), // Rule ID 14089 //
     /* 1864817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1864828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1864831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1864834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1864837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864863 */     // MIs[0] policy
     /* 1864863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864873 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1864876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864900 */     // GIR_Coverage, 14089,
     /* 1864900 */     GIR_EraseRootFromParent_Done,
     /* 1864901 */   // Label 25204: @1864901
     /* 1864901 */   GIM_Try, /*On fail goto*//*Label 25205*/ GIMT_Encode4(1864990), // Rule ID 14092 //
     /* 1864906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1864917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1864920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1864923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1864926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864952 */     // MIs[0] policy
     /* 1864952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864962 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1864965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864989 */     // GIR_Coverage, 14092,
     /* 1864989 */     GIR_EraseRootFromParent_Done,
     /* 1864990 */   // Label 25205: @1864990
     /* 1864990 */   GIM_Try, /*On fail goto*//*Label 25206*/ GIMT_Encode4(1865079), // Rule ID 14093 //
     /* 1864995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1865006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1865009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1865012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1865015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865041 */     // MIs[0] policy
     /* 1865041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865051 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1865072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865078 */     // GIR_Coverage, 14093,
     /* 1865078 */     GIR_EraseRootFromParent_Done,
     /* 1865079 */   // Label 25206: @1865079
     /* 1865079 */   GIM_Try, /*On fail goto*//*Label 25207*/ GIMT_Encode4(1865168), // Rule ID 14096 //
     /* 1865084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1865087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1865095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1865098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1865101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1865104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865130 */     // MIs[0] policy
     /* 1865130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1865161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865167 */     // GIR_Coverage, 14096,
     /* 1865167 */     GIR_EraseRootFromParent_Done,
     /* 1865168 */   // Label 25207: @1865168
     /* 1865168 */   GIM_Try, /*On fail goto*//*Label 25208*/ GIMT_Encode4(1865257), // Rule ID 14097 //
     /* 1865173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1865176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1865184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1865187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1865190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1865193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865219 */     // MIs[0] policy
     /* 1865219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865229 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1865250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865256 */     // GIR_Coverage, 14097,
     /* 1865256 */     GIR_EraseRootFromParent_Done,
     /* 1865257 */   // Label 25208: @1865257
     /* 1865257 */   GIM_Try, /*On fail goto*//*Label 25209*/ GIMT_Encode4(1865346), // Rule ID 14100 //
     /* 1865262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1865273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1865276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1865279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1865282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865308 */     // MIs[0] policy
     /* 1865308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1865321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865345 */     // GIR_Coverage, 14100,
     /* 1865345 */     GIR_EraseRootFromParent_Done,
     /* 1865346 */   // Label 25209: @1865346
     /* 1865346 */   GIM_Try, /*On fail goto*//*Label 25210*/ GIMT_Encode4(1865435), // Rule ID 14101 //
     /* 1865351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1865362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1865365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1865368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1865371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865397 */     // MIs[0] policy
     /* 1865397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865407 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1865410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865434 */     // GIR_Coverage, 14101,
     /* 1865434 */     GIR_EraseRootFromParent_Done,
     /* 1865435 */   // Label 25210: @1865435
     /* 1865435 */   GIM_Try, /*On fail goto*//*Label 25211*/ GIMT_Encode4(1865524), // Rule ID 14104 //
     /* 1865440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1865451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1865454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1865457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1865460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1865463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1865470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865486 */     // MIs[0] policy
     /* 1865486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865496 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1865499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865523 */     // GIR_Coverage, 14104,
     /* 1865523 */     GIR_EraseRootFromParent_Done,
     /* 1865524 */   // Label 25211: @1865524
     /* 1865524 */   GIM_Try, /*On fail goto*//*Label 25212*/ GIMT_Encode4(1865613), // Rule ID 14105 //
     /* 1865529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1865540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1865543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1865546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1865549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1865552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1865559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865575 */     // MIs[0] policy
     /* 1865575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865585 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1865588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865612 */     // GIR_Coverage, 14105,
     /* 1865612 */     GIR_EraseRootFromParent_Done,
     /* 1865613 */   // Label 25212: @1865613
     /* 1865613 */   GIM_Try, /*On fail goto*//*Label 25213*/ GIMT_Encode4(1865702), // Rule ID 14108 //
     /* 1865618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1865629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1865632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1865635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1865638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1865641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1865648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865664 */     // MIs[0] policy
     /* 1865664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865674 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1865677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865701 */     // GIR_Coverage, 14108,
     /* 1865701 */     GIR_EraseRootFromParent_Done,
     /* 1865702 */   // Label 25213: @1865702
     /* 1865702 */   GIM_Try, /*On fail goto*//*Label 25214*/ GIMT_Encode4(1865791), // Rule ID 14109 //
     /* 1865707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1865718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1865721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1865724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1865727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1865730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1865737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865753 */     // MIs[0] policy
     /* 1865753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865763 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1865766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865790 */     // GIR_Coverage, 14109,
     /* 1865790 */     GIR_EraseRootFromParent_Done,
     /* 1865791 */   // Label 25214: @1865791
     /* 1865791 */   GIM_Try, /*On fail goto*//*Label 25215*/ GIMT_Encode4(1865880), // Rule ID 14112 //
     /* 1865796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1865807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1865810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1865813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1865816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865842 */     // MIs[0] policy
     /* 1865842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865852 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1865855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865875 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865879 */     // GIR_Coverage, 14112,
     /* 1865879 */     GIR_EraseRootFromParent_Done,
     /* 1865880 */   // Label 25215: @1865880
     /* 1865880 */   GIM_Try, /*On fail goto*//*Label 25216*/ GIMT_Encode4(1865969), // Rule ID 14113 //
     /* 1865885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1865896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1865899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1865902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1865905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865931 */     // MIs[0] policy
     /* 1865931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865941 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1865944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865968 */     // GIR_Coverage, 14113,
     /* 1865968 */     GIR_EraseRootFromParent_Done,
     /* 1865969 */   // Label 25216: @1865969
     /* 1865969 */   GIM_Try, /*On fail goto*//*Label 25217*/ GIMT_Encode4(1866058), // Rule ID 14116 //
     /* 1865974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1865985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1865988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1865991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1865994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866020 */     // MIs[0] policy
     /* 1866020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866030 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866057 */     // GIR_Coverage, 14116,
     /* 1866057 */     GIR_EraseRootFromParent_Done,
     /* 1866058 */   // Label 25217: @1866058
     /* 1866058 */   GIM_Try, /*On fail goto*//*Label 25218*/ GIMT_Encode4(1866147), // Rule ID 14117 //
     /* 1866063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1866074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1866077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1866080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1866083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866109 */     // MIs[0] policy
     /* 1866109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866119 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866146 */     // GIR_Coverage, 14117,
     /* 1866146 */     GIR_EraseRootFromParent_Done,
     /* 1866147 */   // Label 25218: @1866147
     /* 1866147 */   GIM_Try, /*On fail goto*//*Label 25219*/ GIMT_Encode4(1866236), // Rule ID 14120 //
     /* 1866152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1866163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1866166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1866169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1866172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1866175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866198 */     // MIs[0] policy
     /* 1866198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866208 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866235 */     // GIR_Coverage, 14120,
     /* 1866235 */     GIR_EraseRootFromParent_Done,
     /* 1866236 */   // Label 25219: @1866236
     /* 1866236 */   GIM_Try, /*On fail goto*//*Label 25220*/ GIMT_Encode4(1866325), // Rule ID 14121 //
     /* 1866241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1866252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1866255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1866258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1866261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1866264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866287 */     // MIs[0] policy
     /* 1866287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866297 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866324 */     // GIR_Coverage, 14121,
     /* 1866324 */     GIR_EraseRootFromParent_Done,
     /* 1866325 */   // Label 25220: @1866325
     /* 1866325 */   GIM_Try, /*On fail goto*//*Label 25221*/ GIMT_Encode4(1866414), // Rule ID 14124 //
     /* 1866330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1866341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1866344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1866347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1866350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866376 */     // MIs[0] policy
     /* 1866376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866386 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866413 */     // GIR_Coverage, 14124,
     /* 1866413 */     GIR_EraseRootFromParent_Done,
     /* 1866414 */   // Label 25221: @1866414
     /* 1866414 */   GIM_Try, /*On fail goto*//*Label 25222*/ GIMT_Encode4(1866503), // Rule ID 14125 //
     /* 1866419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1866430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1866433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1866436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1866439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866465 */     // MIs[0] policy
     /* 1866465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866475 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866502 */     // GIR_Coverage, 14125,
     /* 1866502 */     GIR_EraseRootFromParent_Done,
     /* 1866503 */   // Label 25222: @1866503
     /* 1866503 */   GIM_Try, /*On fail goto*//*Label 25223*/ GIMT_Encode4(1866592), // Rule ID 14128 //
     /* 1866508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1866519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1866522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1866525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1866528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866554 */     // MIs[0] policy
     /* 1866554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866564 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866591 */     // GIR_Coverage, 14128,
     /* 1866591 */     GIR_EraseRootFromParent_Done,
     /* 1866592 */   // Label 25223: @1866592
     /* 1866592 */   GIM_Try, /*On fail goto*//*Label 25224*/ GIMT_Encode4(1866681), // Rule ID 14129 //
     /* 1866597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1866608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1866611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1866614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1866617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866643 */     // MIs[0] policy
     /* 1866643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866653 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866680 */     // GIR_Coverage, 14129,
     /* 1866680 */     GIR_EraseRootFromParent_Done,
     /* 1866681 */   // Label 25224: @1866681
     /* 1866681 */   GIM_Try, /*On fail goto*//*Label 25225*/ GIMT_Encode4(1866770), // Rule ID 14132 //
     /* 1866686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1866697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1866700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1866703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1866706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866732 */     // MIs[0] policy
     /* 1866732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866742 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866769 */     // GIR_Coverage, 14132,
     /* 1866769 */     GIR_EraseRootFromParent_Done,
     /* 1866770 */   // Label 25225: @1866770
     /* 1866770 */   GIM_Try, /*On fail goto*//*Label 25226*/ GIMT_Encode4(1866859), // Rule ID 14133 //
     /* 1866775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1866786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1866789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1866792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1866795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866821 */     // MIs[0] policy
     /* 1866821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866831 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866858 */     // GIR_Coverage, 14133,
     /* 1866858 */     GIR_EraseRootFromParent_Done,
     /* 1866859 */   // Label 25226: @1866859
     /* 1866859 */   GIM_Try, /*On fail goto*//*Label 25227*/ GIMT_Encode4(1866948), // Rule ID 14136 //
     /* 1866864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1866867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1866875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1866878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1866881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1866884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1866887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866910 */     // MIs[0] policy
     /* 1866910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866920 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1866941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866947 */     // GIR_Coverage, 14136,
     /* 1866947 */     GIR_EraseRootFromParent_Done,
     /* 1866948 */   // Label 25227: @1866948
     /* 1866948 */   GIM_Try, /*On fail goto*//*Label 25228*/ GIMT_Encode4(1867037), // Rule ID 14137 //
     /* 1866953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1866956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1866964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1866967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1866970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1866973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1866976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866999 */     // MIs[0] policy
     /* 1866999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1867012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867036 */     // GIR_Coverage, 14137,
     /* 1867036 */     GIR_EraseRootFromParent_Done,
     /* 1867037 */   // Label 25228: @1867037
     /* 1867037 */   GIM_Try, /*On fail goto*//*Label 25229*/ GIMT_Encode4(1867126), // Rule ID 14140 //
     /* 1867042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1867045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1867053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1867056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1867059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1867062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867088 */     // MIs[0] policy
     /* 1867088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867098 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1867101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867121 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867125 */     // GIR_Coverage, 14140,
     /* 1867125 */     GIR_EraseRootFromParent_Done,
     /* 1867126 */   // Label 25229: @1867126
     /* 1867126 */   GIM_Try, /*On fail goto*//*Label 25230*/ GIMT_Encode4(1867215), // Rule ID 14141 //
     /* 1867131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1867134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1867142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1867145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1867148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1867151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867177 */     // MIs[0] policy
     /* 1867177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867187 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1867190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867214 */     // GIR_Coverage, 14141,
     /* 1867214 */     GIR_EraseRootFromParent_Done,
     /* 1867215 */   // Label 25230: @1867215
     /* 1867215 */   GIM_Try, /*On fail goto*//*Label 25231*/ GIMT_Encode4(1867304), // Rule ID 14144 //
     /* 1867220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1867223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1867231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1867234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1867237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1867240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867266 */     // MIs[0] policy
     /* 1867266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867276 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1867279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867303 */     // GIR_Coverage, 14144,
     /* 1867303 */     GIR_EraseRootFromParent_Done,
     /* 1867304 */   // Label 25231: @1867304
     /* 1867304 */   GIM_Try, /*On fail goto*//*Label 25232*/ GIMT_Encode4(1867393), // Rule ID 14145 //
     /* 1867309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1867312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1867320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1867323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1867326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1867329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867355 */     // MIs[0] policy
     /* 1867355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867365 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1867368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867392 */     // GIR_Coverage, 14145,
     /* 1867392 */     GIR_EraseRootFromParent_Done,
     /* 1867393 */   // Label 25232: @1867393
     /* 1867393 */   GIM_Try, /*On fail goto*//*Label 25233*/ GIMT_Encode4(1867482), // Rule ID 14148 //
     /* 1867398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1867409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1867412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1867415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867444 */     // MIs[0] policy
     /* 1867444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867454 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1867457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867481 */     // GIR_Coverage, 14148,
     /* 1867481 */     GIR_EraseRootFromParent_Done,
     /* 1867482 */   // Label 25233: @1867482
     /* 1867482 */   GIM_Try, /*On fail goto*//*Label 25234*/ GIMT_Encode4(1867571), // Rule ID 14149 //
     /* 1867487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1867498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1867501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1867504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867533 */     // MIs[0] policy
     /* 1867533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867543 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1867546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867570 */     // GIR_Coverage, 14149,
     /* 1867570 */     GIR_EraseRootFromParent_Done,
     /* 1867571 */   // Label 25234: @1867571
     /* 1867571 */   GIM_Try, /*On fail goto*//*Label 25235*/ GIMT_Encode4(1867660), // Rule ID 14152 //
     /* 1867576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1867587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1867590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1867593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1867599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867622 */     // MIs[0] policy
     /* 1867622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867632 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1867635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867659 */     // GIR_Coverage, 14152,
     /* 1867659 */     GIR_EraseRootFromParent_Done,
     /* 1867660 */   // Label 25235: @1867660
     /* 1867660 */   GIM_Try, /*On fail goto*//*Label 25236*/ GIMT_Encode4(1867749), // Rule ID 14153 //
     /* 1867665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1867676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1867679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1867682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1867688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867711 */     // MIs[0] policy
     /* 1867711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867721 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1867724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867748 */     // GIR_Coverage, 14153,
     /* 1867748 */     GIR_EraseRootFromParent_Done,
     /* 1867749 */   // Label 25236: @1867749
     /* 1867749 */   GIM_Try, /*On fail goto*//*Label 25237*/ GIMT_Encode4(1867838), // Rule ID 14156 //
     /* 1867754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1867765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1867768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1867771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867800 */     // MIs[0] policy
     /* 1867800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867810 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1867813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867837 */     // GIR_Coverage, 14156,
     /* 1867837 */     GIR_EraseRootFromParent_Done,
     /* 1867838 */   // Label 25237: @1867838
     /* 1867838 */   GIM_Try, /*On fail goto*//*Label 25238*/ GIMT_Encode4(1867927), // Rule ID 14157 //
     /* 1867843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1867854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1867857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1867860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867889 */     // MIs[0] policy
     /* 1867889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867899 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1867902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867926 */     // GIR_Coverage, 14157,
     /* 1867926 */     GIR_EraseRootFromParent_Done,
     /* 1867927 */   // Label 25238: @1867927
     /* 1867927 */   GIM_Try, /*On fail goto*//*Label 25239*/ GIMT_Encode4(1868016), // Rule ID 14160 //
     /* 1867932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1867943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1867946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1867949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867978 */     // MIs[0] policy
     /* 1867978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867988 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1867991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868015 */     // GIR_Coverage, 14160,
     /* 1868015 */     GIR_EraseRootFromParent_Done,
     /* 1868016 */   // Label 25239: @1868016
     /* 1868016 */   GIM_Try, /*On fail goto*//*Label 25240*/ GIMT_Encode4(1868105), // Rule ID 14161 //
     /* 1868021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1868032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1868035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1868038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868067 */     // MIs[0] policy
     /* 1868067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868077 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1868080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868104 */     // GIR_Coverage, 14161,
     /* 1868104 */     GIR_EraseRootFromParent_Done,
     /* 1868105 */   // Label 25240: @1868105
     /* 1868105 */   GIM_Try, /*On fail goto*//*Label 25241*/ GIMT_Encode4(1868194), // Rule ID 14164 //
     /* 1868110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1868121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1868124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1868127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868156 */     // MIs[0] policy
     /* 1868156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868166 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868193 */     // GIR_Coverage, 14164,
     /* 1868193 */     GIR_EraseRootFromParent_Done,
     /* 1868194 */   // Label 25241: @1868194
     /* 1868194 */   GIM_Try, /*On fail goto*//*Label 25242*/ GIMT_Encode4(1868283), // Rule ID 14165 //
     /* 1868199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1868210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1868213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1868216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868245 */     // MIs[0] policy
     /* 1868245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868255 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868282 */     // GIR_Coverage, 14165,
     /* 1868282 */     GIR_EraseRootFromParent_Done,
     /* 1868283 */   // Label 25242: @1868283
     /* 1868283 */   GIM_Try, /*On fail goto*//*Label 25243*/ GIMT_Encode4(1868372), // Rule ID 14168 //
     /* 1868288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1868299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1868302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1868305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868334 */     // MIs[0] policy
     /* 1868334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868344 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868371 */     // GIR_Coverage, 14168,
     /* 1868371 */     GIR_EraseRootFromParent_Done,
     /* 1868372 */   // Label 25243: @1868372
     /* 1868372 */   GIM_Try, /*On fail goto*//*Label 25244*/ GIMT_Encode4(1868461), // Rule ID 14169 //
     /* 1868377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1868388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1868391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1868394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868423 */     // MIs[0] policy
     /* 1868423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868433 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868460 */     // GIR_Coverage, 14169,
     /* 1868460 */     GIR_EraseRootFromParent_Done,
     /* 1868461 */   // Label 25244: @1868461
     /* 1868461 */   GIM_Try, /*On fail goto*//*Label 25245*/ GIMT_Encode4(1868550), // Rule ID 14172 //
     /* 1868466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1868477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1868480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1868483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868512 */     // MIs[0] policy
     /* 1868512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868522 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868549 */     // GIR_Coverage, 14172,
     /* 1868549 */     GIR_EraseRootFromParent_Done,
     /* 1868550 */   // Label 25245: @1868550
     /* 1868550 */   GIM_Try, /*On fail goto*//*Label 25246*/ GIMT_Encode4(1868639), // Rule ID 14173 //
     /* 1868555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1868566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1868569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1868572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868601 */     // MIs[0] policy
     /* 1868601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868611 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868638 */     // GIR_Coverage, 14173,
     /* 1868638 */     GIR_EraseRootFromParent_Done,
     /* 1868639 */   // Label 25246: @1868639
     /* 1868639 */   GIM_Try, /*On fail goto*//*Label 25247*/ GIMT_Encode4(1868728), // Rule ID 14176 //
     /* 1868644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1868655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1868658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1868661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868690 */     // MIs[0] policy
     /* 1868690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868727 */     // GIR_Coverage, 14176,
     /* 1868727 */     GIR_EraseRootFromParent_Done,
     /* 1868728 */   // Label 25247: @1868728
     /* 1868728 */   GIM_Try, /*On fail goto*//*Label 25248*/ GIMT_Encode4(1868817), // Rule ID 14177 //
     /* 1868733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1868744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1868747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1868750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868779 */     // MIs[0] policy
     /* 1868779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868789 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868816 */     // GIR_Coverage, 14177,
     /* 1868816 */     GIR_EraseRootFromParent_Done,
     /* 1868817 */   // Label 25248: @1868817
     /* 1868817 */   GIM_Try, /*On fail goto*//*Label 25249*/ GIMT_Encode4(1868906), // Rule ID 14180 //
     /* 1868822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1868833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1868836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1868839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868868 */     // MIs[0] policy
     /* 1868868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868878 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868905 */     // GIR_Coverage, 14180,
     /* 1868905 */     GIR_EraseRootFromParent_Done,
     /* 1868906 */   // Label 25249: @1868906
     /* 1868906 */   GIM_Try, /*On fail goto*//*Label 25250*/ GIMT_Encode4(1868995), // Rule ID 14181 //
     /* 1868911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1868922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1868925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1868928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868957 */     // MIs[0] policy
     /* 1868957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868967 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868994 */     // GIR_Coverage, 14181,
     /* 1868994 */     GIR_EraseRootFromParent_Done,
     /* 1868995 */   // Label 25250: @1868995
     /* 1868995 */   GIM_Try, /*On fail goto*//*Label 25251*/ GIMT_Encode4(1869084), // Rule ID 14184 //
     /* 1869000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1869003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1869011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1869014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1869017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869046 */     // MIs[0] policy
     /* 1869046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869056 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869083 */     // GIR_Coverage, 14184,
     /* 1869083 */     GIR_EraseRootFromParent_Done,
     /* 1869084 */   // Label 25251: @1869084
     /* 1869084 */   GIM_Try, /*On fail goto*//*Label 25252*/ GIMT_Encode4(1869173), // Rule ID 14185 //
     /* 1869089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1869092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1869100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1869103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1869106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869135 */     // MIs[0] policy
     /* 1869135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869145 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869172 */     // GIR_Coverage, 14185,
     /* 1869172 */     GIR_EraseRootFromParent_Done,
     /* 1869173 */   // Label 25252: @1869173
     /* 1869173 */   GIM_Try, /*On fail goto*//*Label 25253*/ GIMT_Encode4(1869262), // Rule ID 14188 //
     /* 1869178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1869189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1869192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1869195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869224 */     // MIs[0] policy
     /* 1869224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869234 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1869237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869261 */     // GIR_Coverage, 14188,
     /* 1869261 */     GIR_EraseRootFromParent_Done,
     /* 1869262 */   // Label 25253: @1869262
     /* 1869262 */   GIM_Try, /*On fail goto*//*Label 25254*/ GIMT_Encode4(1869351), // Rule ID 14189 //
     /* 1869267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1869278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1869281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1869284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869313 */     // MIs[0] policy
     /* 1869313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869323 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1869326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869350 */     // GIR_Coverage, 14189,
     /* 1869350 */     GIR_EraseRootFromParent_Done,
     /* 1869351 */   // Label 25254: @1869351
     /* 1869351 */   GIM_Try, /*On fail goto*//*Label 25255*/ GIMT_Encode4(1869440), // Rule ID 14192 //
     /* 1869356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1869367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1869370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1869373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1869379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869402 */     // MIs[0] policy
     /* 1869402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869412 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1869415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869439 */     // GIR_Coverage, 14192,
     /* 1869439 */     GIR_EraseRootFromParent_Done,
     /* 1869440 */   // Label 25255: @1869440
     /* 1869440 */   GIM_Try, /*On fail goto*//*Label 25256*/ GIMT_Encode4(1869529), // Rule ID 14193 //
     /* 1869445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1869456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1869459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1869462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1869468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869491 */     // MIs[0] policy
     /* 1869491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869501 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1869504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869528 */     // GIR_Coverage, 14193,
     /* 1869528 */     GIR_EraseRootFromParent_Done,
     /* 1869529 */   // Label 25256: @1869529
     /* 1869529 */   GIM_Try, /*On fail goto*//*Label 25257*/ GIMT_Encode4(1869618), // Rule ID 14196 //
     /* 1869534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1869545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1869548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1869551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1869557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1869564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869580 */     // MIs[0] policy
     /* 1869580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869590 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1869593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869617 */     // GIR_Coverage, 14196,
     /* 1869617 */     GIR_EraseRootFromParent_Done,
     /* 1869618 */   // Label 25257: @1869618
     /* 1869618 */   GIM_Try, /*On fail goto*//*Label 25258*/ GIMT_Encode4(1869707), // Rule ID 14197 //
     /* 1869623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1869634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1869637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1869640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1869646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1869653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869669 */     // MIs[0] policy
     /* 1869669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869679 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1869682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869706 */     // GIR_Coverage, 14197,
     /* 1869706 */     GIR_EraseRootFromParent_Done,
     /* 1869707 */   // Label 25258: @1869707
     /* 1869707 */   GIM_Try, /*On fail goto*//*Label 25259*/ GIMT_Encode4(1869796), // Rule ID 14200 //
     /* 1869712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1869723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1869726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1869729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1869735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869758 */     // MIs[0] policy
     /* 1869758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1869771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869795 */     // GIR_Coverage, 14200,
     /* 1869795 */     GIR_EraseRootFromParent_Done,
     /* 1869796 */   // Label 25259: @1869796
     /* 1869796 */   GIM_Try, /*On fail goto*//*Label 25260*/ GIMT_Encode4(1869885), // Rule ID 14201 //
     /* 1869801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1869812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1869815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1869818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1869824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869847 */     // MIs[0] policy
     /* 1869847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869857 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1869860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869884 */     // GIR_Coverage, 14201,
     /* 1869884 */     GIR_EraseRootFromParent_Done,
     /* 1869885 */   // Label 25260: @1869885
     /* 1869885 */   GIM_Try, /*On fail goto*//*Label 25261*/ GIMT_Encode4(1869974), // Rule ID 14204 //
     /* 1869890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1869901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1869904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1869907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869936 */     // MIs[0] policy
     /* 1869936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869946 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1869949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869973 */     // GIR_Coverage, 14204,
     /* 1869973 */     GIR_EraseRootFromParent_Done,
     /* 1869974 */   // Label 25261: @1869974
     /* 1869974 */   GIM_Try, /*On fail goto*//*Label 25262*/ GIMT_Encode4(1870063), // Rule ID 14205 //
     /* 1869979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1869990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1869993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1869996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870025 */     // MIs[0] policy
     /* 1870025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870035 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1870038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870062 */     // GIR_Coverage, 14205,
     /* 1870062 */     GIR_EraseRootFromParent_Done,
     /* 1870063 */   // Label 25262: @1870063
     /* 1870063 */   GIM_Try, /*On fail goto*//*Label 25263*/ GIMT_Encode4(1870152), // Rule ID 14208 //
     /* 1870068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1870079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1870082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1870085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1870091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870114 */     // MIs[0] policy
     /* 1870114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870124 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870151 */     // GIR_Coverage, 14208,
     /* 1870151 */     GIR_EraseRootFromParent_Done,
     /* 1870152 */   // Label 25263: @1870152
     /* 1870152 */   GIM_Try, /*On fail goto*//*Label 25264*/ GIMT_Encode4(1870241), // Rule ID 14209 //
     /* 1870157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1870168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1870171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1870174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1870180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870203 */     // MIs[0] policy
     /* 1870203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870213 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870240 */     // GIR_Coverage, 14209,
     /* 1870240 */     GIR_EraseRootFromParent_Done,
     /* 1870241 */   // Label 25264: @1870241
     /* 1870241 */   GIM_Try, /*On fail goto*//*Label 25265*/ GIMT_Encode4(1870330), // Rule ID 14212 //
     /* 1870246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1870257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1870260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1870263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870292 */     // MIs[0] policy
     /* 1870292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870329 */     // GIR_Coverage, 14212,
     /* 1870329 */     GIR_EraseRootFromParent_Done,
     /* 1870330 */   // Label 25265: @1870330
     /* 1870330 */   GIM_Try, /*On fail goto*//*Label 25266*/ GIMT_Encode4(1870419), // Rule ID 14213 //
     /* 1870335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1870346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1870349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1870352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870381 */     // MIs[0] policy
     /* 1870381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870391 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870418 */     // GIR_Coverage, 14213,
     /* 1870418 */     GIR_EraseRootFromParent_Done,
     /* 1870419 */   // Label 25266: @1870419
     /* 1870419 */   GIM_Try, /*On fail goto*//*Label 25267*/ GIMT_Encode4(1870508), // Rule ID 14216 //
     /* 1870424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1870435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1870438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1870441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870470 */     // MIs[0] policy
     /* 1870470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870480 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1870483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870507 */     // GIR_Coverage, 14216,
     /* 1870507 */     GIR_EraseRootFromParent_Done,
     /* 1870508 */   // Label 25267: @1870508
     /* 1870508 */   GIM_Try, /*On fail goto*//*Label 25268*/ GIMT_Encode4(1870597), // Rule ID 14217 //
     /* 1870513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1870524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1870527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1870530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870559 */     // MIs[0] policy
     /* 1870559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870569 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1870572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870596 */     // GIR_Coverage, 14217,
     /* 1870596 */     GIR_EraseRootFromParent_Done,
     /* 1870597 */   // Label 25268: @1870597
     /* 1870597 */   GIM_Try, /*On fail goto*//*Label 25269*/ GIMT_Encode4(1870686), // Rule ID 14220 //
     /* 1870602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1870613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1870616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1870619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870648 */     // MIs[0] policy
     /* 1870648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870658 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870685 */     // GIR_Coverage, 14220,
     /* 1870685 */     GIR_EraseRootFromParent_Done,
     /* 1870686 */   // Label 25269: @1870686
     /* 1870686 */   GIM_Try, /*On fail goto*//*Label 25270*/ GIMT_Encode4(1870775), // Rule ID 14221 //
     /* 1870691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1870702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1870705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1870708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870737 */     // MIs[0] policy
     /* 1870737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870747 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870774 */     // GIR_Coverage, 14221,
     /* 1870774 */     GIR_EraseRootFromParent_Done,
     /* 1870775 */   // Label 25270: @1870775
     /* 1870775 */   GIM_Try, /*On fail goto*//*Label 25271*/ GIMT_Encode4(1870864), // Rule ID 14224 //
     /* 1870780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1870783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1870791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1870794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1870797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1870803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870826 */     // MIs[0] policy
     /* 1870826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870863 */     // GIR_Coverage, 14224,
     /* 1870863 */     GIR_EraseRootFromParent_Done,
     /* 1870864 */   // Label 25271: @1870864
     /* 1870864 */   GIM_Try, /*On fail goto*//*Label 25272*/ GIMT_Encode4(1870953), // Rule ID 14225 //
     /* 1870869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1870872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1870880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1870883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1870886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1870892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870915 */     // MIs[0] policy
     /* 1870915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870925 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870952 */     // GIR_Coverage, 14225,
     /* 1870952 */     GIR_EraseRootFromParent_Done,
     /* 1870953 */   // Label 25272: @1870953
     /* 1870953 */   GIM_Try, /*On fail goto*//*Label 25273*/ GIMT_Encode4(1871042), // Rule ID 14228 //
     /* 1870958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1870961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1870969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1870972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1870975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871004 */     // MIs[0] policy
     /* 1871004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871014 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1871017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871041 */     // GIR_Coverage, 14228,
     /* 1871041 */     GIR_EraseRootFromParent_Done,
     /* 1871042 */   // Label 25273: @1871042
     /* 1871042 */   GIM_Try, /*On fail goto*//*Label 25274*/ GIMT_Encode4(1871131), // Rule ID 14229 //
     /* 1871047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1871050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1871058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1871061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1871064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871093 */     // MIs[0] policy
     /* 1871093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871103 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1871106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871130 */     // GIR_Coverage, 14229,
     /* 1871130 */     GIR_EraseRootFromParent_Done,
     /* 1871131 */   // Label 25274: @1871131
     /* 1871131 */   GIM_Try, /*On fail goto*//*Label 25275*/ GIMT_Encode4(1871220), // Rule ID 14232 //
     /* 1871136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1871139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1871147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1871150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1871153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871182 */     // MIs[0] policy
     /* 1871182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871192 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1871195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871219 */     // GIR_Coverage, 14232,
     /* 1871219 */     GIR_EraseRootFromParent_Done,
     /* 1871220 */   // Label 25275: @1871220
     /* 1871220 */   GIM_Try, /*On fail goto*//*Label 25276*/ GIMT_Encode4(1871309), // Rule ID 14233 //
     /* 1871225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1871228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1871236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1871239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1871242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871271 */     // MIs[0] policy
     /* 1871271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871281 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1871284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871308 */     // GIR_Coverage, 14233,
     /* 1871308 */     GIR_EraseRootFromParent_Done,
     /* 1871309 */   // Label 25276: @1871309
     /* 1871309 */   GIM_Try, /*On fail goto*//*Label 25277*/ GIMT_Encode4(1871398), // Rule ID 14324 //
     /* 1871314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1871325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1871328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1871331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1871334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871360 */     // MIs[0] policy
     /* 1871360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871370 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1871373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871393 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871397 */     // GIR_Coverage, 14324,
     /* 1871397 */     GIR_EraseRootFromParent_Done,
     /* 1871398 */   // Label 25277: @1871398
     /* 1871398 */   GIM_Try, /*On fail goto*//*Label 25278*/ GIMT_Encode4(1871487), // Rule ID 14325 //
     /* 1871403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1871414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1871417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1871420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1871423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871449 */     // MIs[0] policy
     /* 1871449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871459 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1871462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871486 */     // GIR_Coverage, 14325,
     /* 1871486 */     GIR_EraseRootFromParent_Done,
     /* 1871487 */   // Label 25278: @1871487
     /* 1871487 */   GIM_Try, /*On fail goto*//*Label 25279*/ GIMT_Encode4(1871576), // Rule ID 14328 //
     /* 1871492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1871503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1871506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1871509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1871512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871538 */     // MIs[0] policy
     /* 1871538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871548 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1871551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871575 */     // GIR_Coverage, 14328,
     /* 1871575 */     GIR_EraseRootFromParent_Done,
     /* 1871576 */   // Label 25279: @1871576
     /* 1871576 */   GIM_Try, /*On fail goto*//*Label 25280*/ GIMT_Encode4(1871665), // Rule ID 14329 //
     /* 1871581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1871592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1871595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1871598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1871601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871627 */     // MIs[0] policy
     /* 1871627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871637 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1871640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871664 */     // GIR_Coverage, 14329,
     /* 1871664 */     GIR_EraseRootFromParent_Done,
     /* 1871665 */   // Label 25280: @1871665
     /* 1871665 */   GIM_Try, /*On fail goto*//*Label 25281*/ GIMT_Encode4(1871754), // Rule ID 14332 //
     /* 1871670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1871681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1871684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1871687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1871690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871716 */     // MIs[0] policy
     /* 1871716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871726 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1871729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871753 */     // GIR_Coverage, 14332,
     /* 1871753 */     GIR_EraseRootFromParent_Done,
     /* 1871754 */   // Label 25281: @1871754
     /* 1871754 */   GIM_Try, /*On fail goto*//*Label 25282*/ GIMT_Encode4(1871843), // Rule ID 14333 //
     /* 1871759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1871770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1871773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1871776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1871779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871805 */     // MIs[0] policy
     /* 1871805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871815 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1871818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871842 */     // GIR_Coverage, 14333,
     /* 1871842 */     GIR_EraseRootFromParent_Done,
     /* 1871843 */   // Label 25282: @1871843
     /* 1871843 */   GIM_Try, /*On fail goto*//*Label 25283*/ GIMT_Encode4(1871932), // Rule ID 14336 //
     /* 1871848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1871859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1871862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1871865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1871868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871894 */     // MIs[0] policy
     /* 1871894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871904 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1871907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871931 */     // GIR_Coverage, 14336,
     /* 1871931 */     GIR_EraseRootFromParent_Done,
     /* 1871932 */   // Label 25283: @1871932
     /* 1871932 */   GIM_Try, /*On fail goto*//*Label 25284*/ GIMT_Encode4(1872021), // Rule ID 14337 //
     /* 1871937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1871948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1871951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1871954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1871957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871983 */     // MIs[0] policy
     /* 1871983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871993 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1871996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872020 */     // GIR_Coverage, 14337,
     /* 1872020 */     GIR_EraseRootFromParent_Done,
     /* 1872021 */   // Label 25284: @1872021
     /* 1872021 */   GIM_Try, /*On fail goto*//*Label 25285*/ GIMT_Encode4(1872110), // Rule ID 14340 //
     /* 1872026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1872037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1872040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1872043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1872046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872072 */     // MIs[0] policy
     /* 1872072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872082 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872109 */     // GIR_Coverage, 14340,
     /* 1872109 */     GIR_EraseRootFromParent_Done,
     /* 1872110 */   // Label 25285: @1872110
     /* 1872110 */   GIM_Try, /*On fail goto*//*Label 25286*/ GIMT_Encode4(1872199), // Rule ID 14341 //
     /* 1872115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1872126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1872129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1872132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1872135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872161 */     // MIs[0] policy
     /* 1872161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872198 */     // GIR_Coverage, 14341,
     /* 1872198 */     GIR_EraseRootFromParent_Done,
     /* 1872199 */   // Label 25286: @1872199
     /* 1872199 */   GIM_Try, /*On fail goto*//*Label 25287*/ GIMT_Encode4(1872288), // Rule ID 14344 //
     /* 1872204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1872215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1872218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1872221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1872224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872250 */     // MIs[0] policy
     /* 1872250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872260 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872287 */     // GIR_Coverage, 14344,
     /* 1872287 */     GIR_EraseRootFromParent_Done,
     /* 1872288 */   // Label 25287: @1872288
     /* 1872288 */   GIM_Try, /*On fail goto*//*Label 25288*/ GIMT_Encode4(1872377), // Rule ID 14345 //
     /* 1872293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1872304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1872307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1872310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1872313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872339 */     // MIs[0] policy
     /* 1872339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872349 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872376 */     // GIR_Coverage, 14345,
     /* 1872376 */     GIR_EraseRootFromParent_Done,
     /* 1872377 */   // Label 25288: @1872377
     /* 1872377 */   GIM_Try, /*On fail goto*//*Label 25289*/ GIMT_Encode4(1872466), // Rule ID 14348 //
     /* 1872382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1872393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1872396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1872399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1872402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872428 */     // MIs[0] policy
     /* 1872428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872438 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872465 */     // GIR_Coverage, 14348,
     /* 1872465 */     GIR_EraseRootFromParent_Done,
     /* 1872466 */   // Label 25289: @1872466
     /* 1872466 */   GIM_Try, /*On fail goto*//*Label 25290*/ GIMT_Encode4(1872555), // Rule ID 14349 //
     /* 1872471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1872482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1872485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1872488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1872491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872517 */     // MIs[0] policy
     /* 1872517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872527 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872554 */     // GIR_Coverage, 14349,
     /* 1872554 */     GIR_EraseRootFromParent_Done,
     /* 1872555 */   // Label 25290: @1872555
     /* 1872555 */   GIM_Try, /*On fail goto*//*Label 25291*/ GIMT_Encode4(1872644), // Rule ID 14352 //
     /* 1872560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1872571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1872574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1872577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1872580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872606 */     // MIs[0] policy
     /* 1872606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872616 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872643 */     // GIR_Coverage, 14352,
     /* 1872643 */     GIR_EraseRootFromParent_Done,
     /* 1872644 */   // Label 25291: @1872644
     /* 1872644 */   GIM_Try, /*On fail goto*//*Label 25292*/ GIMT_Encode4(1872733), // Rule ID 14353 //
     /* 1872649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1872660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1872663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1872666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1872669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872695 */     // MIs[0] policy
     /* 1872695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872705 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872732 */     // GIR_Coverage, 14353,
     /* 1872732 */     GIR_EraseRootFromParent_Done,
     /* 1872733 */   // Label 25292: @1872733
     /* 1872733 */   GIM_Try, /*On fail goto*//*Label 25293*/ GIMT_Encode4(1872822), // Rule ID 14356 //
     /* 1872738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1872749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1872752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1872755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1872758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872784 */     // MIs[0] policy
     /* 1872784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872794 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872821 */     // GIR_Coverage, 14356,
     /* 1872821 */     GIR_EraseRootFromParent_Done,
     /* 1872822 */   // Label 25293: @1872822
     /* 1872822 */   GIM_Try, /*On fail goto*//*Label 25294*/ GIMT_Encode4(1872911), // Rule ID 14357 //
     /* 1872827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1872838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1872841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1872844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1872847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872873 */     // MIs[0] policy
     /* 1872873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872883 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872910 */     // GIR_Coverage, 14357,
     /* 1872910 */     GIR_EraseRootFromParent_Done,
     /* 1872911 */   // Label 25294: @1872911
     /* 1872911 */   GIM_Try, /*On fail goto*//*Label 25295*/ GIMT_Encode4(1873000), // Rule ID 14360 //
     /* 1872916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1872919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1872927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1872930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1872933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1872936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872962 */     // MIs[0] policy
     /* 1872962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872972 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872999 */     // GIR_Coverage, 14360,
     /* 1872999 */     GIR_EraseRootFromParent_Done,
     /* 1873000 */   // Label 25295: @1873000
     /* 1873000 */   GIM_Try, /*On fail goto*//*Label 25296*/ GIMT_Encode4(1873089), // Rule ID 14361 //
     /* 1873005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1873008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1873016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1873019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1873022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1873025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873051 */     // MIs[0] policy
     /* 1873051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873061 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1873082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873088 */     // GIR_Coverage, 14361,
     /* 1873088 */     GIR_EraseRootFromParent_Done,
     /* 1873089 */   // Label 25296: @1873089
     /* 1873089 */   GIM_Try, /*On fail goto*//*Label 25297*/ GIMT_Encode4(1873178), // Rule ID 14364 //
     /* 1873094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1873105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1873108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1873111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1873114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873140 */     // MIs[0] policy
     /* 1873140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873150 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1873153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873177 */     // GIR_Coverage, 14364,
     /* 1873177 */     GIR_EraseRootFromParent_Done,
     /* 1873178 */   // Label 25297: @1873178
     /* 1873178 */   GIM_Try, /*On fail goto*//*Label 25298*/ GIMT_Encode4(1873267), // Rule ID 14365 //
     /* 1873183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1873194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1873197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1873200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1873203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873229 */     // MIs[0] policy
     /* 1873229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873239 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1873242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873266 */     // GIR_Coverage, 14365,
     /* 1873266 */     GIR_EraseRootFromParent_Done,
     /* 1873267 */   // Label 25298: @1873267
     /* 1873267 */   GIM_Try, /*On fail goto*//*Label 25299*/ GIMT_Encode4(1873356), // Rule ID 14368 //
     /* 1873272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1873283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1873286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1873289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1873292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1873295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873318 */     // MIs[0] policy
     /* 1873318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873328 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1873331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873355 */     // GIR_Coverage, 14368,
     /* 1873355 */     GIR_EraseRootFromParent_Done,
     /* 1873356 */   // Label 25299: @1873356
     /* 1873356 */   GIM_Try, /*On fail goto*//*Label 25300*/ GIMT_Encode4(1873445), // Rule ID 14369 //
     /* 1873361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1873372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1873375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1873378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1873381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1873384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873407 */     // MIs[0] policy
     /* 1873407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873417 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1873420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873444 */     // GIR_Coverage, 14369,
     /* 1873444 */     GIR_EraseRootFromParent_Done,
     /* 1873445 */   // Label 25300: @1873445
     /* 1873445 */   GIM_Try, /*On fail goto*//*Label 25301*/ GIMT_Encode4(1873534), // Rule ID 14372 //
     /* 1873450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1873461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1873464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1873467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1873470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1873473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1873480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873496 */     // MIs[0] policy
     /* 1873496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873506 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1873509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873533 */     // GIR_Coverage, 14372,
     /* 1873533 */     GIR_EraseRootFromParent_Done,
     /* 1873534 */   // Label 25301: @1873534
     /* 1873534 */   GIM_Try, /*On fail goto*//*Label 25302*/ GIMT_Encode4(1873623), // Rule ID 14373 //
     /* 1873539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1873550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1873553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1873556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1873559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1873562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1873569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873585 */     // MIs[0] policy
     /* 1873585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873595 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1873598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873622 */     // GIR_Coverage, 14373,
     /* 1873622 */     GIR_EraseRootFromParent_Done,
     /* 1873623 */   // Label 25302: @1873623
     /* 1873623 */   GIM_Try, /*On fail goto*//*Label 25303*/ GIMT_Encode4(1873712), // Rule ID 14376 //
     /* 1873628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1873639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1873642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1873645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1873648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1873651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873674 */     // MIs[0] policy
     /* 1873674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1873687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873711 */     // GIR_Coverage, 14376,
     /* 1873711 */     GIR_EraseRootFromParent_Done,
     /* 1873712 */   // Label 25303: @1873712
     /* 1873712 */   GIM_Try, /*On fail goto*//*Label 25304*/ GIMT_Encode4(1873801), // Rule ID 14377 //
     /* 1873717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1873728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1873731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1873734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1873737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1873740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873763 */     // MIs[0] policy
     /* 1873763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873773 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1873776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873800 */     // GIR_Coverage, 14377,
     /* 1873800 */     GIR_EraseRootFromParent_Done,
     /* 1873801 */   // Label 25304: @1873801
     /* 1873801 */   GIM_Try, /*On fail goto*//*Label 25305*/ GIMT_Encode4(1873890), // Rule ID 14380 //
     /* 1873806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1873817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1873820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1873823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1873826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873852 */     // MIs[0] policy
     /* 1873852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873862 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1873865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873889 */     // GIR_Coverage, 14380,
     /* 1873889 */     GIR_EraseRootFromParent_Done,
     /* 1873890 */   // Label 25305: @1873890
     /* 1873890 */   GIM_Try, /*On fail goto*//*Label 25306*/ GIMT_Encode4(1873979), // Rule ID 14381 //
     /* 1873895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1873906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1873909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1873912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1873915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873941 */     // MIs[0] policy
     /* 1873941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873951 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1873954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873978 */     // GIR_Coverage, 14381,
     /* 1873978 */     GIR_EraseRootFromParent_Done,
     /* 1873979 */   // Label 25306: @1873979
     /* 1873979 */   GIM_Try, /*On fail goto*//*Label 25307*/ GIMT_Encode4(1874068), // Rule ID 14384 //
     /* 1873984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1873995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1873998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1874001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1874004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1874007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874030 */     // MIs[0] policy
     /* 1874030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874040 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874067 */     // GIR_Coverage, 14384,
     /* 1874067 */     GIR_EraseRootFromParent_Done,
     /* 1874068 */   // Label 25307: @1874068
     /* 1874068 */   GIM_Try, /*On fail goto*//*Label 25308*/ GIMT_Encode4(1874157), // Rule ID 14385 //
     /* 1874073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1874084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1874087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1874090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1874093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1874096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874119 */     // MIs[0] policy
     /* 1874119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874129 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874156 */     // GIR_Coverage, 14385,
     /* 1874156 */     GIR_EraseRootFromParent_Done,
     /* 1874157 */   // Label 25308: @1874157
     /* 1874157 */   GIM_Try, /*On fail goto*//*Label 25309*/ GIMT_Encode4(1874246), // Rule ID 14388 //
     /* 1874162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1874173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1874176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1874179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1874182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874208 */     // MIs[0] policy
     /* 1874208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874245 */     // GIR_Coverage, 14388,
     /* 1874245 */     GIR_EraseRootFromParent_Done,
     /* 1874246 */   // Label 25309: @1874246
     /* 1874246 */   GIM_Try, /*On fail goto*//*Label 25310*/ GIMT_Encode4(1874335), // Rule ID 14389 //
     /* 1874251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1874262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1874265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1874268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1874271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874297 */     // MIs[0] policy
     /* 1874297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874307 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874334 */     // GIR_Coverage, 14389,
     /* 1874334 */     GIR_EraseRootFromParent_Done,
     /* 1874335 */   // Label 25310: @1874335
     /* 1874335 */   GIM_Try, /*On fail goto*//*Label 25311*/ GIMT_Encode4(1874424), // Rule ID 14392 //
     /* 1874340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1874351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1874354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1874357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1874360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874386 */     // MIs[0] policy
     /* 1874386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874396 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874423 */     // GIR_Coverage, 14392,
     /* 1874423 */     GIR_EraseRootFromParent_Done,
     /* 1874424 */   // Label 25311: @1874424
     /* 1874424 */   GIM_Try, /*On fail goto*//*Label 25312*/ GIMT_Encode4(1874513), // Rule ID 14393 //
     /* 1874429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1874440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1874443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1874446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1874449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874475 */     // MIs[0] policy
     /* 1874475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874485 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874512 */     // GIR_Coverage, 14393,
     /* 1874512 */     GIR_EraseRootFromParent_Done,
     /* 1874513 */   // Label 25312: @1874513
     /* 1874513 */   GIM_Try, /*On fail goto*//*Label 25313*/ GIMT_Encode4(1874602), // Rule ID 14396 //
     /* 1874518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1874529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1874532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1874535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1874538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874564 */     // MIs[0] policy
     /* 1874564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874574 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874601 */     // GIR_Coverage, 14396,
     /* 1874601 */     GIR_EraseRootFromParent_Done,
     /* 1874602 */   // Label 25313: @1874602
     /* 1874602 */   GIM_Try, /*On fail goto*//*Label 25314*/ GIMT_Encode4(1874691), // Rule ID 14397 //
     /* 1874607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1874618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1874621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1874624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1874627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874653 */     // MIs[0] policy
     /* 1874653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874663 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874690 */     // GIR_Coverage, 14397,
     /* 1874690 */     GIR_EraseRootFromParent_Done,
     /* 1874691 */   // Label 25314: @1874691
     /* 1874691 */   GIM_Try, /*On fail goto*//*Label 25315*/ GIMT_Encode4(1874780), // Rule ID 14400 //
     /* 1874696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1874699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1874707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1874710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1874713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1874716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1874719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874742 */     // MIs[0] policy
     /* 1874742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874779 */     // GIR_Coverage, 14400,
     /* 1874779 */     GIR_EraseRootFromParent_Done,
     /* 1874780 */   // Label 25315: @1874780
     /* 1874780 */   GIM_Try, /*On fail goto*//*Label 25316*/ GIMT_Encode4(1874869), // Rule ID 14401 //
     /* 1874785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1874788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1874796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1874799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1874802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1874805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1874808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874831 */     // MIs[0] policy
     /* 1874831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874841 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874868 */     // GIR_Coverage, 14401,
     /* 1874868 */     GIR_EraseRootFromParent_Done,
     /* 1874869 */   // Label 25316: @1874869
     /* 1874869 */   GIM_Try, /*On fail goto*//*Label 25317*/ GIMT_Encode4(1874958), // Rule ID 14404 //
     /* 1874874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1874877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1874885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1874888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1874891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1874894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874920 */     // MIs[0] policy
     /* 1874920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874930 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874957 */     // GIR_Coverage, 14404,
     /* 1874957 */     GIR_EraseRootFromParent_Done,
     /* 1874958 */   // Label 25317: @1874958
     /* 1874958 */   GIM_Try, /*On fail goto*//*Label 25318*/ GIMT_Encode4(1875047), // Rule ID 14405 //
     /* 1874963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1874966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1874974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1874977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1874980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1874983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875009 */     // MIs[0] policy
     /* 1875009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875019 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1875022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875046 */     // GIR_Coverage, 14405,
     /* 1875046 */     GIR_EraseRootFromParent_Done,
     /* 1875047 */   // Label 25318: @1875047
     /* 1875047 */   GIM_Try, /*On fail goto*//*Label 25319*/ GIMT_Encode4(1875136), // Rule ID 14408 //
     /* 1875052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1875055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1875063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1875066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1875069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1875072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875098 */     // MIs[0] policy
     /* 1875098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875108 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1875111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875131 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875135 */     // GIR_Coverage, 14408,
     /* 1875135 */     GIR_EraseRootFromParent_Done,
     /* 1875136 */   // Label 25319: @1875136
     /* 1875136 */   GIM_Try, /*On fail goto*//*Label 25320*/ GIMT_Encode4(1875225), // Rule ID 14409 //
     /* 1875141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1875144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1875152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1875155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1875158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1875161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875187 */     // MIs[0] policy
     /* 1875187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875197 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1875200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875224 */     // GIR_Coverage, 14409,
     /* 1875224 */     GIR_EraseRootFromParent_Done,
     /* 1875225 */   // Label 25320: @1875225
     /* 1875225 */   GIM_Try, /*On fail goto*//*Label 25321*/ GIMT_Encode4(1875314), // Rule ID 14412 //
     /* 1875230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1875241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1875244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1875247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875276 */     // MIs[0] policy
     /* 1875276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875286 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1875289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875313 */     // GIR_Coverage, 14412,
     /* 1875313 */     GIR_EraseRootFromParent_Done,
     /* 1875314 */   // Label 25321: @1875314
     /* 1875314 */   GIM_Try, /*On fail goto*//*Label 25322*/ GIMT_Encode4(1875403), // Rule ID 14413 //
     /* 1875319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1875330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1875333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1875336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875365 */     // MIs[0] policy
     /* 1875365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875375 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1875378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875402 */     // GIR_Coverage, 14413,
     /* 1875402 */     GIR_EraseRootFromParent_Done,
     /* 1875403 */   // Label 25322: @1875403
     /* 1875403 */   GIM_Try, /*On fail goto*//*Label 25323*/ GIMT_Encode4(1875492), // Rule ID 14416 //
     /* 1875408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1875419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1875422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1875425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875454 */     // MIs[0] policy
     /* 1875454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875464 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1875467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875491 */     // GIR_Coverage, 14416,
     /* 1875491 */     GIR_EraseRootFromParent_Done,
     /* 1875492 */   // Label 25323: @1875492
     /* 1875492 */   GIM_Try, /*On fail goto*//*Label 25324*/ GIMT_Encode4(1875581), // Rule ID 14417 //
     /* 1875497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1875508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1875511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1875514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875543 */     // MIs[0] policy
     /* 1875543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875553 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1875556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875580 */     // GIR_Coverage, 14417,
     /* 1875580 */     GIR_EraseRootFromParent_Done,
     /* 1875581 */   // Label 25324: @1875581
     /* 1875581 */   GIM_Try, /*On fail goto*//*Label 25325*/ GIMT_Encode4(1875670), // Rule ID 14420 //
     /* 1875586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1875597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1875600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1875603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875632 */     // MIs[0] policy
     /* 1875632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875642 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1875645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875669 */     // GIR_Coverage, 14420,
     /* 1875669 */     GIR_EraseRootFromParent_Done,
     /* 1875670 */   // Label 25325: @1875670
     /* 1875670 */   GIM_Try, /*On fail goto*//*Label 25326*/ GIMT_Encode4(1875759), // Rule ID 14421 //
     /* 1875675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1875686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1875689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1875692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875721 */     // MIs[0] policy
     /* 1875721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875731 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1875734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875758 */     // GIR_Coverage, 14421,
     /* 1875758 */     GIR_EraseRootFromParent_Done,
     /* 1875759 */   // Label 25326: @1875759
     /* 1875759 */   GIM_Try, /*On fail goto*//*Label 25327*/ GIMT_Encode4(1875848), // Rule ID 14424 //
     /* 1875764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1875775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1875778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1875781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875810 */     // MIs[0] policy
     /* 1875810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875820 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1875823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875847 */     // GIR_Coverage, 14424,
     /* 1875847 */     GIR_EraseRootFromParent_Done,
     /* 1875848 */   // Label 25327: @1875848
     /* 1875848 */   GIM_Try, /*On fail goto*//*Label 25328*/ GIMT_Encode4(1875937), // Rule ID 14425 //
     /* 1875853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1875864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1875867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1875870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875899 */     // MIs[0] policy
     /* 1875899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875909 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1875912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875936 */     // GIR_Coverage, 14425,
     /* 1875936 */     GIR_EraseRootFromParent_Done,
     /* 1875937 */   // Label 25328: @1875937
     /* 1875937 */   GIM_Try, /*On fail goto*//*Label 25329*/ GIMT_Encode4(1876026), // Rule ID 14428 //
     /* 1875942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1875953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1875956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1875959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875988 */     // MIs[0] policy
     /* 1875988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875998 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876025 */     // GIR_Coverage, 14428,
     /* 1876025 */     GIR_EraseRootFromParent_Done,
     /* 1876026 */   // Label 25329: @1876026
     /* 1876026 */   GIM_Try, /*On fail goto*//*Label 25330*/ GIMT_Encode4(1876115), // Rule ID 14429 //
     /* 1876031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1876042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1876045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1876048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876077 */     // MIs[0] policy
     /* 1876077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876087 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876114 */     // GIR_Coverage, 14429,
     /* 1876114 */     GIR_EraseRootFromParent_Done,
     /* 1876115 */   // Label 25330: @1876115
     /* 1876115 */   GIM_Try, /*On fail goto*//*Label 25331*/ GIMT_Encode4(1876204), // Rule ID 14432 //
     /* 1876120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1876131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1876134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1876137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876166 */     // MIs[0] policy
     /* 1876166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876203 */     // GIR_Coverage, 14432,
     /* 1876203 */     GIR_EraseRootFromParent_Done,
     /* 1876204 */   // Label 25331: @1876204
     /* 1876204 */   GIM_Try, /*On fail goto*//*Label 25332*/ GIMT_Encode4(1876293), // Rule ID 14433 //
     /* 1876209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1876220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1876223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1876226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876255 */     // MIs[0] policy
     /* 1876255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876265 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876292 */     // GIR_Coverage, 14433,
     /* 1876292 */     GIR_EraseRootFromParent_Done,
     /* 1876293 */   // Label 25332: @1876293
     /* 1876293 */   GIM_Try, /*On fail goto*//*Label 25333*/ GIMT_Encode4(1876382), // Rule ID 14436 //
     /* 1876298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1876309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1876312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1876315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876344 */     // MIs[0] policy
     /* 1876344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876354 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876377 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876381 */     // GIR_Coverage, 14436,
     /* 1876381 */     GIR_EraseRootFromParent_Done,
     /* 1876382 */   // Label 25333: @1876382
     /* 1876382 */   GIM_Try, /*On fail goto*//*Label 25334*/ GIMT_Encode4(1876471), // Rule ID 14437 //
     /* 1876387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1876398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1876401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1876404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876433 */     // MIs[0] policy
     /* 1876433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876443 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876470 */     // GIR_Coverage, 14437,
     /* 1876470 */     GIR_EraseRootFromParent_Done,
     /* 1876471 */   // Label 25334: @1876471
     /* 1876471 */   GIM_Try, /*On fail goto*//*Label 25335*/ GIMT_Encode4(1876560), // Rule ID 14440 //
     /* 1876476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1876487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1876490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1876493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876522 */     // MIs[0] policy
     /* 1876522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876559 */     // GIR_Coverage, 14440,
     /* 1876559 */     GIR_EraseRootFromParent_Done,
     /* 1876560 */   // Label 25335: @1876560
     /* 1876560 */   GIM_Try, /*On fail goto*//*Label 25336*/ GIMT_Encode4(1876649), // Rule ID 14441 //
     /* 1876565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1876576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1876579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1876582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876611 */     // MIs[0] policy
     /* 1876611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876648 */     // GIR_Coverage, 14441,
     /* 1876648 */     GIR_EraseRootFromParent_Done,
     /* 1876649 */   // Label 25336: @1876649
     /* 1876649 */   GIM_Try, /*On fail goto*//*Label 25337*/ GIMT_Encode4(1876738), // Rule ID 14444 //
     /* 1876654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1876665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1876668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1876671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876700 */     // MIs[0] policy
     /* 1876700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876710 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876733 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876737 */     // GIR_Coverage, 14444,
     /* 1876737 */     GIR_EraseRootFromParent_Done,
     /* 1876738 */   // Label 25337: @1876738
     /* 1876738 */   GIM_Try, /*On fail goto*//*Label 25338*/ GIMT_Encode4(1876827), // Rule ID 14445 //
     /* 1876743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1876754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1876757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1876760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876789 */     // MIs[0] policy
     /* 1876789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876799 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876826 */     // GIR_Coverage, 14445,
     /* 1876826 */     GIR_EraseRootFromParent_Done,
     /* 1876827 */   // Label 25338: @1876827
     /* 1876827 */   GIM_Try, /*On fail goto*//*Label 25339*/ GIMT_Encode4(1876916), // Rule ID 14448 //
     /* 1876832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1876835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1876843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1876846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1876849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876878 */     // MIs[0] policy
     /* 1876878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876888 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876915 */     // GIR_Coverage, 14448,
     /* 1876915 */     GIR_EraseRootFromParent_Done,
     /* 1876916 */   // Label 25339: @1876916
     /* 1876916 */   GIM_Try, /*On fail goto*//*Label 25340*/ GIMT_Encode4(1877005), // Rule ID 14449 //
     /* 1876921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1876924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1876932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1876935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1876938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876967 */     // MIs[0] policy
     /* 1876967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876977 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877004 */     // GIR_Coverage, 14449,
     /* 1877004 */     GIR_EraseRootFromParent_Done,
     /* 1877005 */   // Label 25340: @1877005
     /* 1877005 */   GIM_Try, /*On fail goto*//*Label 25341*/ GIMT_Encode4(1877094), // Rule ID 14452 //
     /* 1877010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1877021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1877024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1877027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877056 */     // MIs[0] policy
     /* 1877056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877066 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1877069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877093 */     // GIR_Coverage, 14452,
     /* 1877093 */     GIR_EraseRootFromParent_Done,
     /* 1877094 */   // Label 25341: @1877094
     /* 1877094 */   GIM_Try, /*On fail goto*//*Label 25342*/ GIMT_Encode4(1877183), // Rule ID 14453 //
     /* 1877099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1877110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1877113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1877116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877145 */     // MIs[0] policy
     /* 1877145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877155 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1877158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877182 */     // GIR_Coverage, 14453,
     /* 1877182 */     GIR_EraseRootFromParent_Done,
     /* 1877183 */   // Label 25342: @1877183
     /* 1877183 */   GIM_Try, /*On fail goto*//*Label 25343*/ GIMT_Encode4(1877272), // Rule ID 14456 //
     /* 1877188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1877199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1877202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1877205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877234 */     // MIs[0] policy
     /* 1877234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877244 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1877247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877271 */     // GIR_Coverage, 14456,
     /* 1877271 */     GIR_EraseRootFromParent_Done,
     /* 1877272 */   // Label 25343: @1877272
     /* 1877272 */   GIM_Try, /*On fail goto*//*Label 25344*/ GIMT_Encode4(1877361), // Rule ID 14457 //
     /* 1877277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1877288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1877291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1877294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877323 */     // MIs[0] policy
     /* 1877323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877333 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1877336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877360 */     // GIR_Coverage, 14457,
     /* 1877360 */     GIR_EraseRootFromParent_Done,
     /* 1877361 */   // Label 25344: @1877361
     /* 1877361 */   GIM_Try, /*On fail goto*//*Label 25345*/ GIMT_Encode4(1877450), // Rule ID 14460 //
     /* 1877366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1877377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1877380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1877383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1877389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877412 */     // MIs[0] policy
     /* 1877412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877422 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1877425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877449 */     // GIR_Coverage, 14460,
     /* 1877449 */     GIR_EraseRootFromParent_Done,
     /* 1877450 */   // Label 25345: @1877450
     /* 1877450 */   GIM_Try, /*On fail goto*//*Label 25346*/ GIMT_Encode4(1877539), // Rule ID 14461 //
     /* 1877455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1877466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1877469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1877472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1877478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877501 */     // MIs[0] policy
     /* 1877501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877511 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1877514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877538 */     // GIR_Coverage, 14461,
     /* 1877538 */     GIR_EraseRootFromParent_Done,
     /* 1877539 */   // Label 25346: @1877539
     /* 1877539 */   GIM_Try, /*On fail goto*//*Label 25347*/ GIMT_Encode4(1877628), // Rule ID 14464 //
     /* 1877544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1877555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1877558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1877561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1877567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877590 */     // MIs[0] policy
     /* 1877590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1877603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877627 */     // GIR_Coverage, 14464,
     /* 1877627 */     GIR_EraseRootFromParent_Done,
     /* 1877628 */   // Label 25347: @1877628
     /* 1877628 */   GIM_Try, /*On fail goto*//*Label 25348*/ GIMT_Encode4(1877717), // Rule ID 14465 //
     /* 1877633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1877644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1877647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1877650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1877656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877679 */     // MIs[0] policy
     /* 1877679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877689 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1877692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877716 */     // GIR_Coverage, 14465,
     /* 1877716 */     GIR_EraseRootFromParent_Done,
     /* 1877717 */   // Label 25348: @1877717
     /* 1877717 */   GIM_Try, /*On fail goto*//*Label 25349*/ GIMT_Encode4(1877806), // Rule ID 14468 //
     /* 1877722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1877733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1877736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1877739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877768 */     // MIs[0] policy
     /* 1877768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877778 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1877781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877805 */     // GIR_Coverage, 14468,
     /* 1877805 */     GIR_EraseRootFromParent_Done,
     /* 1877806 */   // Label 25349: @1877806
     /* 1877806 */   GIM_Try, /*On fail goto*//*Label 25350*/ GIMT_Encode4(1877895), // Rule ID 14469 //
     /* 1877811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1877822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1877825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1877828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877857 */     // MIs[0] policy
     /* 1877857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877867 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1877870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877894 */     // GIR_Coverage, 14469,
     /* 1877894 */     GIR_EraseRootFromParent_Done,
     /* 1877895 */   // Label 25350: @1877895
     /* 1877895 */   GIM_Try, /*On fail goto*//*Label 25351*/ GIMT_Encode4(1877984), // Rule ID 14472 //
     /* 1877900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1877911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1877914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1877917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877946 */     // MIs[0] policy
     /* 1877946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877956 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1877959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877983 */     // GIR_Coverage, 14472,
     /* 1877983 */     GIR_EraseRootFromParent_Done,
     /* 1877984 */   // Label 25351: @1877984
     /* 1877984 */   GIM_Try, /*On fail goto*//*Label 25352*/ GIMT_Encode4(1878073), // Rule ID 14473 //
     /* 1877989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1878000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1878003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1878006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878035 */     // MIs[0] policy
     /* 1878035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878045 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1878048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878068 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878072 */     // GIR_Coverage, 14473,
     /* 1878072 */     GIR_EraseRootFromParent_Done,
     /* 1878073 */   // Label 25352: @1878073
     /* 1878073 */   GIM_Try, /*On fail goto*//*Label 25353*/ GIMT_Encode4(1878162), // Rule ID 14476 //
     /* 1878078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1878089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1878092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1878095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878124 */     // MIs[0] policy
     /* 1878124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878161 */     // GIR_Coverage, 14476,
     /* 1878161 */     GIR_EraseRootFromParent_Done,
     /* 1878162 */   // Label 25353: @1878162
     /* 1878162 */   GIM_Try, /*On fail goto*//*Label 25354*/ GIMT_Encode4(1878251), // Rule ID 14477 //
     /* 1878167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1878178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1878181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1878184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878213 */     // MIs[0] policy
     /* 1878213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878223 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878250 */     // GIR_Coverage, 14477,
     /* 1878250 */     GIR_EraseRootFromParent_Done,
     /* 1878251 */   // Label 25354: @1878251
     /* 1878251 */   GIM_Try, /*On fail goto*//*Label 25355*/ GIMT_Encode4(1878340), // Rule ID 14480 //
     /* 1878256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1878267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1878270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1878273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878302 */     // MIs[0] policy
     /* 1878302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878312 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878339 */     // GIR_Coverage, 14480,
     /* 1878339 */     GIR_EraseRootFromParent_Done,
     /* 1878340 */   // Label 25355: @1878340
     /* 1878340 */   GIM_Try, /*On fail goto*//*Label 25356*/ GIMT_Encode4(1878429), // Rule ID 14481 //
     /* 1878345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1878356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1878359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1878362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878391 */     // MIs[0] policy
     /* 1878391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878401 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878428 */     // GIR_Coverage, 14481,
     /* 1878428 */     GIR_EraseRootFromParent_Done,
     /* 1878429 */   // Label 25356: @1878429
     /* 1878429 */   GIM_Try, /*On fail goto*//*Label 25357*/ GIMT_Encode4(1878518), // Rule ID 14484 //
     /* 1878434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1878445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1878448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1878451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878480 */     // MIs[0] policy
     /* 1878480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878490 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1878493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878517 */     // GIR_Coverage, 14484,
     /* 1878517 */     GIR_EraseRootFromParent_Done,
     /* 1878518 */   // Label 25357: @1878518
     /* 1878518 */   GIM_Try, /*On fail goto*//*Label 25358*/ GIMT_Encode4(1878607), // Rule ID 14485 //
     /* 1878523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1878534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1878537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1878540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878569 */     // MIs[0] policy
     /* 1878569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878579 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1878582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878606 */     // GIR_Coverage, 14485,
     /* 1878606 */     GIR_EraseRootFromParent_Done,
     /* 1878607 */   // Label 25358: @1878607
     /* 1878607 */   GIM_Try, /*On fail goto*//*Label 25359*/ GIMT_Encode4(1878696), // Rule ID 14488 //
     /* 1878612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1878615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1878623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1878626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1878629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1878635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878658 */     // MIs[0] policy
     /* 1878658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878695 */     // GIR_Coverage, 14488,
     /* 1878695 */     GIR_EraseRootFromParent_Done,
     /* 1878696 */   // Label 25359: @1878696
     /* 1878696 */   GIM_Try, /*On fail goto*//*Label 25360*/ GIMT_Encode4(1878785), // Rule ID 14489 //
     /* 1878701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1878704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1878712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1878715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1878718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1878724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878747 */     // MIs[0] policy
     /* 1878747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878784 */     // GIR_Coverage, 14489,
     /* 1878784 */     GIR_EraseRootFromParent_Done,
     /* 1878785 */   // Label 25360: @1878785
     /* 1878785 */   GIM_Try, /*On fail goto*//*Label 25361*/ GIMT_Encode4(1878874), // Rule ID 14492 //
     /* 1878790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1878793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1878801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1878804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1878807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878836 */     // MIs[0] policy
     /* 1878836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878846 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878873 */     // GIR_Coverage, 14492,
     /* 1878873 */     GIR_EraseRootFromParent_Done,
     /* 1878874 */   // Label 25361: @1878874
     /* 1878874 */   GIM_Try, /*On fail goto*//*Label 25362*/ GIMT_Encode4(1878963), // Rule ID 14493 //
     /* 1878879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1878882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1878890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1878893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1878896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878925 */     // MIs[0] policy
     /* 1878925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878935 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878962 */     // GIR_Coverage, 14493,
     /* 1878962 */     GIR_EraseRootFromParent_Done,
     /* 1878963 */   // Label 25362: @1878963
     /* 1878963 */   GIM_Try, /*On fail goto*//*Label 25363*/ GIMT_Encode4(1879052), // Rule ID 14496 //
     /* 1878968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1878971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1878979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1878982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1878985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879014 */     // MIs[0] policy
     /* 1879014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879024 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1879027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879051 */     // GIR_Coverage, 14496,
     /* 1879051 */     GIR_EraseRootFromParent_Done,
     /* 1879052 */   // Label 25363: @1879052
     /* 1879052 */   GIM_Try, /*On fail goto*//*Label 25364*/ GIMT_Encode4(1879141), // Rule ID 14497 //
     /* 1879057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1879060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1879068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1879071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1879074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879103 */     // MIs[0] policy
     /* 1879103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879113 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1879116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879140 */     // GIR_Coverage, 14497,
     /* 1879140 */     GIR_EraseRootFromParent_Done,
     /* 1879141 */   // Label 25364: @1879141
     /* 1879141 */   GIM_Try, /*On fail goto*//*Label 25365*/ GIMT_Encode4(1879230), // Rule ID 14588 //
     /* 1879146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1879157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1879160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1879163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1879166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879192 */     // MIs[0] policy
     /* 1879192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879202 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1879205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879229 */     // GIR_Coverage, 14588,
     /* 1879229 */     GIR_EraseRootFromParent_Done,
     /* 1879230 */   // Label 25365: @1879230
     /* 1879230 */   GIM_Try, /*On fail goto*//*Label 25366*/ GIMT_Encode4(1879319), // Rule ID 14589 //
     /* 1879235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1879246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1879249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1879252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1879255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879281 */     // MIs[0] policy
     /* 1879281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879291 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1879294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879318 */     // GIR_Coverage, 14589,
     /* 1879318 */     GIR_EraseRootFromParent_Done,
     /* 1879319 */   // Label 25366: @1879319
     /* 1879319 */   GIM_Try, /*On fail goto*//*Label 25367*/ GIMT_Encode4(1879408), // Rule ID 14592 //
     /* 1879324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1879335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1879338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1879341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1879344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879370 */     // MIs[0] policy
     /* 1879370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879380 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1879383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879407 */     // GIR_Coverage, 14592,
     /* 1879407 */     GIR_EraseRootFromParent_Done,
     /* 1879408 */   // Label 25367: @1879408
     /* 1879408 */   GIM_Try, /*On fail goto*//*Label 25368*/ GIMT_Encode4(1879497), // Rule ID 14593 //
     /* 1879413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1879424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1879427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1879430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1879433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879459 */     // MIs[0] policy
     /* 1879459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879469 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1879472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879496 */     // GIR_Coverage, 14593,
     /* 1879496 */     GIR_EraseRootFromParent_Done,
     /* 1879497 */   // Label 25368: @1879497
     /* 1879497 */   GIM_Try, /*On fail goto*//*Label 25369*/ GIMT_Encode4(1879586), // Rule ID 14596 //
     /* 1879502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1879513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1879516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1879519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1879522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879548 */     // MIs[0] policy
     /* 1879548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879558 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1879561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879585 */     // GIR_Coverage, 14596,
     /* 1879585 */     GIR_EraseRootFromParent_Done,
     /* 1879586 */   // Label 25369: @1879586
     /* 1879586 */   GIM_Try, /*On fail goto*//*Label 25370*/ GIMT_Encode4(1879675), // Rule ID 14597 //
     /* 1879591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1879602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1879605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1879608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1879611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879637 */     // MIs[0] policy
     /* 1879637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879647 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1879650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879674 */     // GIR_Coverage, 14597,
     /* 1879674 */     GIR_EraseRootFromParent_Done,
     /* 1879675 */   // Label 25370: @1879675
     /* 1879675 */   GIM_Try, /*On fail goto*//*Label 25371*/ GIMT_Encode4(1879764), // Rule ID 14600 //
     /* 1879680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1879691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1879694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1879697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1879700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879726 */     // MIs[0] policy
     /* 1879726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879736 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1879739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879763 */     // GIR_Coverage, 14600,
     /* 1879763 */     GIR_EraseRootFromParent_Done,
     /* 1879764 */   // Label 25371: @1879764
     /* 1879764 */   GIM_Try, /*On fail goto*//*Label 25372*/ GIMT_Encode4(1879853), // Rule ID 14601 //
     /* 1879769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1879780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1879783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1879786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1879789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879815 */     // MIs[0] policy
     /* 1879815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879825 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1879828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879852 */     // GIR_Coverage, 14601,
     /* 1879852 */     GIR_EraseRootFromParent_Done,
     /* 1879853 */   // Label 25372: @1879853
     /* 1879853 */   GIM_Try, /*On fail goto*//*Label 25373*/ GIMT_Encode4(1879942), // Rule ID 14604 //
     /* 1879858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1879869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1879872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1879875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1879878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879904 */     // MIs[0] policy
     /* 1879904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879914 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1879917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879941 */     // GIR_Coverage, 14604,
     /* 1879941 */     GIR_EraseRootFromParent_Done,
     /* 1879942 */   // Label 25373: @1879942
     /* 1879942 */   GIM_Try, /*On fail goto*//*Label 25374*/ GIMT_Encode4(1880031), // Rule ID 14605 //
     /* 1879947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1879958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1879961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1879964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1879967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879993 */     // MIs[0] policy
     /* 1879993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880003 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880030 */     // GIR_Coverage, 14605,
     /* 1880030 */     GIR_EraseRootFromParent_Done,
     /* 1880031 */   // Label 25374: @1880031
     /* 1880031 */   GIM_Try, /*On fail goto*//*Label 25375*/ GIMT_Encode4(1880120), // Rule ID 14608 //
     /* 1880036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1880047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1880050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1880053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1880056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880082 */     // MIs[0] policy
     /* 1880082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880092 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880119 */     // GIR_Coverage, 14608,
     /* 1880119 */     GIR_EraseRootFromParent_Done,
     /* 1880120 */   // Label 25375: @1880120
     /* 1880120 */   GIM_Try, /*On fail goto*//*Label 25376*/ GIMT_Encode4(1880209), // Rule ID 14609 //
     /* 1880125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1880136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1880139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1880142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1880145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880171 */     // MIs[0] policy
     /* 1880171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880181 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880208 */     // GIR_Coverage, 14609,
     /* 1880208 */     GIR_EraseRootFromParent_Done,
     /* 1880209 */   // Label 25376: @1880209
     /* 1880209 */   GIM_Try, /*On fail goto*//*Label 25377*/ GIMT_Encode4(1880298), // Rule ID 14612 //
     /* 1880214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1880225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1880228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1880231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1880234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880260 */     // MIs[0] policy
     /* 1880260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880270 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880297 */     // GIR_Coverage, 14612,
     /* 1880297 */     GIR_EraseRootFromParent_Done,
     /* 1880298 */   // Label 25377: @1880298
     /* 1880298 */   GIM_Try, /*On fail goto*//*Label 25378*/ GIMT_Encode4(1880387), // Rule ID 14613 //
     /* 1880303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1880314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1880317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1880320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1880323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880349 */     // MIs[0] policy
     /* 1880349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880359 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880386 */     // GIR_Coverage, 14613,
     /* 1880386 */     GIR_EraseRootFromParent_Done,
     /* 1880387 */   // Label 25378: @1880387
     /* 1880387 */   GIM_Try, /*On fail goto*//*Label 25379*/ GIMT_Encode4(1880476), // Rule ID 14616 //
     /* 1880392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1880403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1880406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1880409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1880412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880438 */     // MIs[0] policy
     /* 1880438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880475 */     // GIR_Coverage, 14616,
     /* 1880475 */     GIR_EraseRootFromParent_Done,
     /* 1880476 */   // Label 25379: @1880476
     /* 1880476 */   GIM_Try, /*On fail goto*//*Label 25380*/ GIMT_Encode4(1880565), // Rule ID 14617 //
     /* 1880481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1880492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1880495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1880498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1880501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880527 */     // MIs[0] policy
     /* 1880527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880537 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880564 */     // GIR_Coverage, 14617,
     /* 1880564 */     GIR_EraseRootFromParent_Done,
     /* 1880565 */   // Label 25380: @1880565
     /* 1880565 */   GIM_Try, /*On fail goto*//*Label 25381*/ GIMT_Encode4(1880654), // Rule ID 14620 //
     /* 1880570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1880581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1880584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1880587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1880590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880616 */     // MIs[0] policy
     /* 1880616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880626 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880653 */     // GIR_Coverage, 14620,
     /* 1880653 */     GIR_EraseRootFromParent_Done,
     /* 1880654 */   // Label 25381: @1880654
     /* 1880654 */   GIM_Try, /*On fail goto*//*Label 25382*/ GIMT_Encode4(1880743), // Rule ID 14621 //
     /* 1880659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1880670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1880673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1880676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1880679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880705 */     // MIs[0] policy
     /* 1880705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880715 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880742 */     // GIR_Coverage, 14621,
     /* 1880742 */     GIR_EraseRootFromParent_Done,
     /* 1880743 */   // Label 25382: @1880743
     /* 1880743 */   GIM_Try, /*On fail goto*//*Label 25383*/ GIMT_Encode4(1880832), // Rule ID 14624 //
     /* 1880748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1880751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1880759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1880762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1880765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1880768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880794 */     // MIs[0] policy
     /* 1880794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880804 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880831 */     // GIR_Coverage, 14624,
     /* 1880831 */     GIR_EraseRootFromParent_Done,
     /* 1880832 */   // Label 25383: @1880832
     /* 1880832 */   GIM_Try, /*On fail goto*//*Label 25384*/ GIMT_Encode4(1880921), // Rule ID 14625 //
     /* 1880837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1880840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1880848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1880851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1880854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1880857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880883 */     // MIs[0] policy
     /* 1880883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880893 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880920 */     // GIR_Coverage, 14625,
     /* 1880920 */     GIR_EraseRootFromParent_Done,
     /* 1880921 */   // Label 25384: @1880921
     /* 1880921 */   GIM_Try, /*On fail goto*//*Label 25385*/ GIMT_Encode4(1881010), // Rule ID 14628 //
     /* 1880926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1880937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1880940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1880943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1880946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1880949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1880956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880972 */     // MIs[0] policy
     /* 1880972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880982 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1880985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881009 */     // GIR_Coverage, 14628,
     /* 1881009 */     GIR_EraseRootFromParent_Done,
     /* 1881010 */   // Label 25385: @1881010
     /* 1881010 */   GIM_Try, /*On fail goto*//*Label 25386*/ GIMT_Encode4(1881099), // Rule ID 14629 //
     /* 1881015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1881026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1881029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1881032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1881035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881061 */     // MIs[0] policy
     /* 1881061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881071 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1881074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881098 */     // GIR_Coverage, 14629,
     /* 1881098 */     GIR_EraseRootFromParent_Done,
     /* 1881099 */   // Label 25386: @1881099
     /* 1881099 */   GIM_Try, /*On fail goto*//*Label 25387*/ GIMT_Encode4(1881188), // Rule ID 14632 //
     /* 1881104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1881115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1881118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1881121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1881124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881150 */     // MIs[0] policy
     /* 1881150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881160 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1881163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881187 */     // GIR_Coverage, 14632,
     /* 1881187 */     GIR_EraseRootFromParent_Done,
     /* 1881188 */   // Label 25387: @1881188
     /* 1881188 */   GIM_Try, /*On fail goto*//*Label 25388*/ GIMT_Encode4(1881277), // Rule ID 14633 //
     /* 1881193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1881204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1881207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1881210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1881213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881239 */     // MIs[0] policy
     /* 1881239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881249 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1881252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881276 */     // GIR_Coverage, 14633,
     /* 1881276 */     GIR_EraseRootFromParent_Done,
     /* 1881277 */   // Label 25388: @1881277
     /* 1881277 */   GIM_Try, /*On fail goto*//*Label 25389*/ GIMT_Encode4(1881366), // Rule ID 14636 //
     /* 1881282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1881293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1881296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1881299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1881302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1881305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881328 */     // MIs[0] policy
     /* 1881328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881338 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1881341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881365 */     // GIR_Coverage, 14636,
     /* 1881365 */     GIR_EraseRootFromParent_Done,
     /* 1881366 */   // Label 25389: @1881366
     /* 1881366 */   GIM_Try, /*On fail goto*//*Label 25390*/ GIMT_Encode4(1881455), // Rule ID 14637 //
     /* 1881371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1881382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1881385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1881388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1881391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1881394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881417 */     // MIs[0] policy
     /* 1881417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881427 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1881430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881454 */     // GIR_Coverage, 14637,
     /* 1881454 */     GIR_EraseRootFromParent_Done,
     /* 1881455 */   // Label 25390: @1881455
     /* 1881455 */   GIM_Try, /*On fail goto*//*Label 25391*/ GIMT_Encode4(1881544), // Rule ID 14640 //
     /* 1881460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1881471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1881474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1881477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1881480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881506 */     // MIs[0] policy
     /* 1881506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1881519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881543 */     // GIR_Coverage, 14640,
     /* 1881543 */     GIR_EraseRootFromParent_Done,
     /* 1881544 */   // Label 25391: @1881544
     /* 1881544 */   GIM_Try, /*On fail goto*//*Label 25392*/ GIMT_Encode4(1881633), // Rule ID 14641 //
     /* 1881549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1881560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1881563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1881566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1881569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881595 */     // MIs[0] policy
     /* 1881595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881605 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1881608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881632 */     // GIR_Coverage, 14641,
     /* 1881632 */     GIR_EraseRootFromParent_Done,
     /* 1881633 */   // Label 25392: @1881633
     /* 1881633 */   GIM_Try, /*On fail goto*//*Label 25393*/ GIMT_Encode4(1881722), // Rule ID 14644 //
     /* 1881638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1881649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1881652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1881655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1881658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881684 */     // MIs[0] policy
     /* 1881684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881694 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1881697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881721 */     // GIR_Coverage, 14644,
     /* 1881721 */     GIR_EraseRootFromParent_Done,
     /* 1881722 */   // Label 25393: @1881722
     /* 1881722 */   GIM_Try, /*On fail goto*//*Label 25394*/ GIMT_Encode4(1881811), // Rule ID 14645 //
     /* 1881727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1881738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1881741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1881744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1881747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881773 */     // MIs[0] policy
     /* 1881773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881783 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1881786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881810 */     // GIR_Coverage, 14645,
     /* 1881810 */     GIR_EraseRootFromParent_Done,
     /* 1881811 */   // Label 25394: @1881811
     /* 1881811 */   GIM_Try, /*On fail goto*//*Label 25395*/ GIMT_Encode4(1881900), // Rule ID 14648 //
     /* 1881816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1881827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1881830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1881833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1881836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881862 */     // MIs[0] policy
     /* 1881862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881872 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1881875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881899 */     // GIR_Coverage, 14648,
     /* 1881899 */     GIR_EraseRootFromParent_Done,
     /* 1881900 */   // Label 25395: @1881900
     /* 1881900 */   GIM_Try, /*On fail goto*//*Label 25396*/ GIMT_Encode4(1881989), // Rule ID 14649 //
     /* 1881905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1881916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1881919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1881922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1881925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881951 */     // MIs[0] policy
     /* 1881951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881961 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1881964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881988 */     // GIR_Coverage, 14649,
     /* 1881988 */     GIR_EraseRootFromParent_Done,
     /* 1881989 */   // Label 25396: @1881989
     /* 1881989 */   GIM_Try, /*On fail goto*//*Label 25397*/ GIMT_Encode4(1882078), // Rule ID 14652 //
     /* 1881994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1882005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1882008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1882011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1882014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882040 */     // MIs[0] policy
     /* 1882040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882050 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882077 */     // GIR_Coverage, 14652,
     /* 1882077 */     GIR_EraseRootFromParent_Done,
     /* 1882078 */   // Label 25397: @1882078
     /* 1882078 */   GIM_Try, /*On fail goto*//*Label 25398*/ GIMT_Encode4(1882167), // Rule ID 14653 //
     /* 1882083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1882094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1882097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1882100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1882103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882129 */     // MIs[0] policy
     /* 1882129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882166 */     // GIR_Coverage, 14653,
     /* 1882166 */     GIR_EraseRootFromParent_Done,
     /* 1882167 */   // Label 25398: @1882167
     /* 1882167 */   GIM_Try, /*On fail goto*//*Label 25399*/ GIMT_Encode4(1882256), // Rule ID 14656 //
     /* 1882172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1882183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1882186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1882189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1882192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882218 */     // MIs[0] policy
     /* 1882218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882228 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882255 */     // GIR_Coverage, 14656,
     /* 1882255 */     GIR_EraseRootFromParent_Done,
     /* 1882256 */   // Label 25399: @1882256
     /* 1882256 */   GIM_Try, /*On fail goto*//*Label 25400*/ GIMT_Encode4(1882345), // Rule ID 14657 //
     /* 1882261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1882272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1882275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1882278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1882281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882307 */     // MIs[0] policy
     /* 1882307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882317 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882344 */     // GIR_Coverage, 14657,
     /* 1882344 */     GIR_EraseRootFromParent_Done,
     /* 1882345 */   // Label 25400: @1882345
     /* 1882345 */   GIM_Try, /*On fail goto*//*Label 25401*/ GIMT_Encode4(1882434), // Rule ID 14660 //
     /* 1882350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1882361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1882364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1882367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1882370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882396 */     // MIs[0] policy
     /* 1882396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882406 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882433 */     // GIR_Coverage, 14660,
     /* 1882433 */     GIR_EraseRootFromParent_Done,
     /* 1882434 */   // Label 25401: @1882434
     /* 1882434 */   GIM_Try, /*On fail goto*//*Label 25402*/ GIMT_Encode4(1882523), // Rule ID 14661 //
     /* 1882439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1882450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1882453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1882456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1882459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882485 */     // MIs[0] policy
     /* 1882485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882495 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882522 */     // GIR_Coverage, 14661,
     /* 1882522 */     GIR_EraseRootFromParent_Done,
     /* 1882523 */   // Label 25402: @1882523
     /* 1882523 */   GIM_Try, /*On fail goto*//*Label 25403*/ GIMT_Encode4(1882612), // Rule ID 14664 //
     /* 1882528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1882531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1882539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1882542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1882545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1882548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1882551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882574 */     // MIs[0] policy
     /* 1882574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882611 */     // GIR_Coverage, 14664,
     /* 1882611 */     GIR_EraseRootFromParent_Done,
     /* 1882612 */   // Label 25403: @1882612
     /* 1882612 */   GIM_Try, /*On fail goto*//*Label 25404*/ GIMT_Encode4(1882701), // Rule ID 14665 //
     /* 1882617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1882620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1882628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1882631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1882634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1882637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1882640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882663 */     // MIs[0] policy
     /* 1882663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882673 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882700 */     // GIR_Coverage, 14665,
     /* 1882700 */     GIR_EraseRootFromParent_Done,
     /* 1882701 */   // Label 25404: @1882701
     /* 1882701 */   GIM_Try, /*On fail goto*//*Label 25405*/ GIMT_Encode4(1882790), // Rule ID 14668 //
     /* 1882706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1882709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1882717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1882720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1882723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1882726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882752 */     // MIs[0] policy
     /* 1882752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882762 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882789 */     // GIR_Coverage, 14668,
     /* 1882789 */     GIR_EraseRootFromParent_Done,
     /* 1882790 */   // Label 25405: @1882790
     /* 1882790 */   GIM_Try, /*On fail goto*//*Label 25406*/ GIMT_Encode4(1882879), // Rule ID 14669 //
     /* 1882795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1882798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1882806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1882809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1882812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1882815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882841 */     // MIs[0] policy
     /* 1882841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882851 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882878 */     // GIR_Coverage, 14669,
     /* 1882878 */     GIR_EraseRootFromParent_Done,
     /* 1882879 */   // Label 25406: @1882879
     /* 1882879 */   GIM_Try, /*On fail goto*//*Label 25407*/ GIMT_Encode4(1882968), // Rule ID 14672 //
     /* 1882884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1882887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1882895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1882898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1882901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1882904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882930 */     // MIs[0] policy
     /* 1882930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882940 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882967 */     // GIR_Coverage, 14672,
     /* 1882967 */     GIR_EraseRootFromParent_Done,
     /* 1882968 */   // Label 25407: @1882968
     /* 1882968 */   GIM_Try, /*On fail goto*//*Label 25408*/ GIMT_Encode4(1883057), // Rule ID 14673 //
     /* 1882973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1882976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1882984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1882987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1882990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1882993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883019 */     // MIs[0] policy
     /* 1883019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883029 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1883032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883056 */     // GIR_Coverage, 14673,
     /* 1883056 */     GIR_EraseRootFromParent_Done,
     /* 1883057 */   // Label 25408: @1883057
     /* 1883057 */   GIM_Try, /*On fail goto*//*Label 25409*/ GIMT_Encode4(1883146), // Rule ID 14676 //
     /* 1883062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1883073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1883076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1883079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883108 */     // MIs[0] policy
     /* 1883108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883118 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1883121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883145 */     // GIR_Coverage, 14676,
     /* 1883145 */     GIR_EraseRootFromParent_Done,
     /* 1883146 */   // Label 25409: @1883146
     /* 1883146 */   GIM_Try, /*On fail goto*//*Label 25410*/ GIMT_Encode4(1883235), // Rule ID 14677 //
     /* 1883151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1883162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1883165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1883168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883197 */     // MIs[0] policy
     /* 1883197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883207 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1883210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883234 */     // GIR_Coverage, 14677,
     /* 1883234 */     GIR_EraseRootFromParent_Done,
     /* 1883235 */   // Label 25410: @1883235
     /* 1883235 */   GIM_Try, /*On fail goto*//*Label 25411*/ GIMT_Encode4(1883324), // Rule ID 14680 //
     /* 1883240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1883251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1883254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1883257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883286 */     // MIs[0] policy
     /* 1883286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883296 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1883299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883323 */     // GIR_Coverage, 14680,
     /* 1883323 */     GIR_EraseRootFromParent_Done,
     /* 1883324 */   // Label 25411: @1883324
     /* 1883324 */   GIM_Try, /*On fail goto*//*Label 25412*/ GIMT_Encode4(1883413), // Rule ID 14681 //
     /* 1883329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1883340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1883343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1883346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883375 */     // MIs[0] policy
     /* 1883375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883385 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1883388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883412 */     // GIR_Coverage, 14681,
     /* 1883412 */     GIR_EraseRootFromParent_Done,
     /* 1883413 */   // Label 25412: @1883413
     /* 1883413 */   GIM_Try, /*On fail goto*//*Label 25413*/ GIMT_Encode4(1883502), // Rule ID 14684 //
     /* 1883418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1883429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1883432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1883435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883464 */     // MIs[0] policy
     /* 1883464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883474 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1883477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883501 */     // GIR_Coverage, 14684,
     /* 1883501 */     GIR_EraseRootFromParent_Done,
     /* 1883502 */   // Label 25413: @1883502
     /* 1883502 */   GIM_Try, /*On fail goto*//*Label 25414*/ GIMT_Encode4(1883591), // Rule ID 14685 //
     /* 1883507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1883518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1883521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1883524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883553 */     // MIs[0] policy
     /* 1883553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883563 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1883566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883590 */     // GIR_Coverage, 14685,
     /* 1883590 */     GIR_EraseRootFromParent_Done,
     /* 1883591 */   // Label 25414: @1883591
     /* 1883591 */   GIM_Try, /*On fail goto*//*Label 25415*/ GIMT_Encode4(1883680), // Rule ID 14688 //
     /* 1883596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1883607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1883610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1883613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883642 */     // MIs[0] policy
     /* 1883642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883652 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1883655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883679 */     // GIR_Coverage, 14688,
     /* 1883679 */     GIR_EraseRootFromParent_Done,
     /* 1883680 */   // Label 25415: @1883680
     /* 1883680 */   GIM_Try, /*On fail goto*//*Label 25416*/ GIMT_Encode4(1883769), // Rule ID 14689 //
     /* 1883685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1883696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1883699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1883702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883731 */     // MIs[0] policy
     /* 1883731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883741 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1883744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883768 */     // GIR_Coverage, 14689,
     /* 1883768 */     GIR_EraseRootFromParent_Done,
     /* 1883769 */   // Label 25416: @1883769
     /* 1883769 */   GIM_Try, /*On fail goto*//*Label 25417*/ GIMT_Encode4(1883858), // Rule ID 14692 //
     /* 1883774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1883785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1883788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1883791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883820 */     // MIs[0] policy
     /* 1883820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883830 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1883833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883857 */     // GIR_Coverage, 14692,
     /* 1883857 */     GIR_EraseRootFromParent_Done,
     /* 1883858 */   // Label 25417: @1883858
     /* 1883858 */   GIM_Try, /*On fail goto*//*Label 25418*/ GIMT_Encode4(1883947), // Rule ID 14693 //
     /* 1883863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1883874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1883877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1883880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883909 */     // MIs[0] policy
     /* 1883909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883919 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1883922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883946 */     // GIR_Coverage, 14693,
     /* 1883946 */     GIR_EraseRootFromParent_Done,
     /* 1883947 */   // Label 25418: @1883947
     /* 1883947 */   GIM_Try, /*On fail goto*//*Label 25419*/ GIMT_Encode4(1884036), // Rule ID 14696 //
     /* 1883952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1883963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1883966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1883969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883998 */     // MIs[0] policy
     /* 1883998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884008 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1884011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884035 */     // GIR_Coverage, 14696,
     /* 1884035 */     GIR_EraseRootFromParent_Done,
     /* 1884036 */   // Label 25419: @1884036
     /* 1884036 */   GIM_Try, /*On fail goto*//*Label 25420*/ GIMT_Encode4(1884125), // Rule ID 14697 //
     /* 1884041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1884052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1884055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1884058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884087 */     // MIs[0] policy
     /* 1884087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884097 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1884100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884124 */     // GIR_Coverage, 14697,
     /* 1884124 */     GIR_EraseRootFromParent_Done,
     /* 1884125 */   // Label 25420: @1884125
     /* 1884125 */   GIM_Try, /*On fail goto*//*Label 25421*/ GIMT_Encode4(1884214), // Rule ID 14700 //
     /* 1884130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1884141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1884144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1884147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884176 */     // MIs[0] policy
     /* 1884176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884186 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884209 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884213 */     // GIR_Coverage, 14700,
     /* 1884213 */     GIR_EraseRootFromParent_Done,
     /* 1884214 */   // Label 25421: @1884214
     /* 1884214 */   GIM_Try, /*On fail goto*//*Label 25422*/ GIMT_Encode4(1884303), // Rule ID 14701 //
     /* 1884219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1884230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1884233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1884236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884265 */     // MIs[0] policy
     /* 1884265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884275 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884302 */     // GIR_Coverage, 14701,
     /* 1884302 */     GIR_EraseRootFromParent_Done,
     /* 1884303 */   // Label 25422: @1884303
     /* 1884303 */   GIM_Try, /*On fail goto*//*Label 25423*/ GIMT_Encode4(1884392), // Rule ID 14704 //
     /* 1884308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1884319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1884322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1884325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884354 */     // MIs[0] policy
     /* 1884354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884364 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884391 */     // GIR_Coverage, 14704,
     /* 1884391 */     GIR_EraseRootFromParent_Done,
     /* 1884392 */   // Label 25423: @1884392
     /* 1884392 */   GIM_Try, /*On fail goto*//*Label 25424*/ GIMT_Encode4(1884481), // Rule ID 14705 //
     /* 1884397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1884408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1884411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1884414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884443 */     // MIs[0] policy
     /* 1884443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884453 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884480 */     // GIR_Coverage, 14705,
     /* 1884480 */     GIR_EraseRootFromParent_Done,
     /* 1884481 */   // Label 25424: @1884481
     /* 1884481 */   GIM_Try, /*On fail goto*//*Label 25425*/ GIMT_Encode4(1884570), // Rule ID 14708 //
     /* 1884486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1884497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1884500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1884503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884532 */     // MIs[0] policy
     /* 1884532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884542 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884569 */     // GIR_Coverage, 14708,
     /* 1884569 */     GIR_EraseRootFromParent_Done,
     /* 1884570 */   // Label 25425: @1884570
     /* 1884570 */   GIM_Try, /*On fail goto*//*Label 25426*/ GIMT_Encode4(1884659), // Rule ID 14709 //
     /* 1884575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1884586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1884589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1884592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884621 */     // MIs[0] policy
     /* 1884621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884631 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884658 */     // GIR_Coverage, 14709,
     /* 1884658 */     GIR_EraseRootFromParent_Done,
     /* 1884659 */   // Label 25426: @1884659
     /* 1884659 */   GIM_Try, /*On fail goto*//*Label 25427*/ GIMT_Encode4(1884748), // Rule ID 14712 //
     /* 1884664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1884667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1884675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1884678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1884681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884710 */     // MIs[0] policy
     /* 1884710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884720 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884747 */     // GIR_Coverage, 14712,
     /* 1884747 */     GIR_EraseRootFromParent_Done,
     /* 1884748 */   // Label 25427: @1884748
     /* 1884748 */   GIM_Try, /*On fail goto*//*Label 25428*/ GIMT_Encode4(1884837), // Rule ID 14713 //
     /* 1884753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1884756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1884764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1884767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1884770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884799 */     // MIs[0] policy
     /* 1884799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884809 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884836 */     // GIR_Coverage, 14713,
     /* 1884836 */     GIR_EraseRootFromParent_Done,
     /* 1884837 */   // Label 25428: @1884837
     /* 1884837 */   GIM_Try, /*On fail goto*//*Label 25429*/ GIMT_Encode4(1884926), // Rule ID 14716 //
     /* 1884842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1884853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1884856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1884859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1884865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1884872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884888 */     // MIs[0] policy
     /* 1884888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884898 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1884901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884925 */     // GIR_Coverage, 14716,
     /* 1884925 */     GIR_EraseRootFromParent_Done,
     /* 1884926 */   // Label 25429: @1884926
     /* 1884926 */   GIM_Try, /*On fail goto*//*Label 25430*/ GIMT_Encode4(1885015), // Rule ID 14717 //
     /* 1884931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1884942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1884945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1884948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1884954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1884961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884977 */     // MIs[0] policy
     /* 1884977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884987 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1884990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885014 */     // GIR_Coverage, 14717,
     /* 1885014 */     GIR_EraseRootFromParent_Done,
     /* 1885015 */   // Label 25430: @1885015
     /* 1885015 */   GIM_Try, /*On fail goto*//*Label 25431*/ GIMT_Encode4(1885104), // Rule ID 14720 //
     /* 1885020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1885031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1885034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1885037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885066 */     // MIs[0] policy
     /* 1885066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885076 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1885079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885103 */     // GIR_Coverage, 14720,
     /* 1885103 */     GIR_EraseRootFromParent_Done,
     /* 1885104 */   // Label 25431: @1885104
     /* 1885104 */   GIM_Try, /*On fail goto*//*Label 25432*/ GIMT_Encode4(1885193), // Rule ID 14721 //
     /* 1885109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1885120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1885123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1885126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885155 */     // MIs[0] policy
     /* 1885155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885165 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1885168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885192 */     // GIR_Coverage, 14721,
     /* 1885192 */     GIR_EraseRootFromParent_Done,
     /* 1885193 */   // Label 25432: @1885193
     /* 1885193 */   GIM_Try, /*On fail goto*//*Label 25433*/ GIMT_Encode4(1885282), // Rule ID 14724 //
     /* 1885198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1885209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1885212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1885215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1885221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885244 */     // MIs[0] policy
     /* 1885244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885254 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1885257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885281 */     // GIR_Coverage, 14724,
     /* 1885281 */     GIR_EraseRootFromParent_Done,
     /* 1885282 */   // Label 25433: @1885282
     /* 1885282 */   GIM_Try, /*On fail goto*//*Label 25434*/ GIMT_Encode4(1885371), // Rule ID 14725 //
     /* 1885287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1885298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1885301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1885304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1885310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885333 */     // MIs[0] policy
     /* 1885333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885343 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1885346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885370 */     // GIR_Coverage, 14725,
     /* 1885370 */     GIR_EraseRootFromParent_Done,
     /* 1885371 */   // Label 25434: @1885371
     /* 1885371 */   GIM_Try, /*On fail goto*//*Label 25435*/ GIMT_Encode4(1885460), // Rule ID 14728 //
     /* 1885376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1885387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1885390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1885393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885422 */     // MIs[0] policy
     /* 1885422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885432 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885459 */     // GIR_Coverage, 14728,
     /* 1885459 */     GIR_EraseRootFromParent_Done,
     /* 1885460 */   // Label 25435: @1885460
     /* 1885460 */   GIM_Try, /*On fail goto*//*Label 25436*/ GIMT_Encode4(1885549), // Rule ID 14729 //
     /* 1885465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1885476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1885479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1885482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885511 */     // MIs[0] policy
     /* 1885511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885548 */     // GIR_Coverage, 14729,
     /* 1885548 */     GIR_EraseRootFromParent_Done,
     /* 1885549 */   // Label 25436: @1885549
     /* 1885549 */   GIM_Try, /*On fail goto*//*Label 25437*/ GIMT_Encode4(1885638), // Rule ID 14732 //
     /* 1885554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1885565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1885568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1885571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1885577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885600 */     // MIs[0] policy
     /* 1885600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885610 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1885613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885637 */     // GIR_Coverage, 14732,
     /* 1885637 */     GIR_EraseRootFromParent_Done,
     /* 1885638 */   // Label 25437: @1885638
     /* 1885638 */   GIM_Try, /*On fail goto*//*Label 25438*/ GIMT_Encode4(1885727), // Rule ID 14733 //
     /* 1885643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1885654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1885657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1885660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1885666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885689 */     // MIs[0] policy
     /* 1885689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885699 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1885702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885726 */     // GIR_Coverage, 14733,
     /* 1885726 */     GIR_EraseRootFromParent_Done,
     /* 1885727 */   // Label 25438: @1885727
     /* 1885727 */   GIM_Try, /*On fail goto*//*Label 25439*/ GIMT_Encode4(1885816), // Rule ID 14736 //
     /* 1885732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1885743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1885746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1885749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885778 */     // MIs[0] policy
     /* 1885778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885788 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1885791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885815 */     // GIR_Coverage, 14736,
     /* 1885815 */     GIR_EraseRootFromParent_Done,
     /* 1885816 */   // Label 25439: @1885816
     /* 1885816 */   GIM_Try, /*On fail goto*//*Label 25440*/ GIMT_Encode4(1885905), // Rule ID 14737 //
     /* 1885821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1885832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1885835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1885838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885867 */     // MIs[0] policy
     /* 1885867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885877 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1885880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885904 */     // GIR_Coverage, 14737,
     /* 1885904 */     GIR_EraseRootFromParent_Done,
     /* 1885905 */   // Label 25440: @1885905
     /* 1885905 */   GIM_Try, /*On fail goto*//*Label 25441*/ GIMT_Encode4(1885994), // Rule ID 14740 //
     /* 1885910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1885921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1885924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1885927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1885933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885956 */     // MIs[0] policy
     /* 1885956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885993 */     // GIR_Coverage, 14740,
     /* 1885993 */     GIR_EraseRootFromParent_Done,
     /* 1885994 */   // Label 25441: @1885994
     /* 1885994 */   GIM_Try, /*On fail goto*//*Label 25442*/ GIMT_Encode4(1886083), // Rule ID 14741 //
     /* 1885999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1886010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1886013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1886016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886045 */     // MIs[0] policy
     /* 1886045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1886058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886082 */     // GIR_Coverage, 14741,
     /* 1886082 */     GIR_EraseRootFromParent_Done,
     /* 1886083 */   // Label 25442: @1886083
     /* 1886083 */   GIM_Try, /*On fail goto*//*Label 25443*/ GIMT_Encode4(1886172), // Rule ID 14744 //
     /* 1886088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1886099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1886102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1886105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886134 */     // MIs[0] policy
     /* 1886134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886144 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886171 */     // GIR_Coverage, 14744,
     /* 1886171 */     GIR_EraseRootFromParent_Done,
     /* 1886172 */   // Label 25443: @1886172
     /* 1886172 */   GIM_Try, /*On fail goto*//*Label 25444*/ GIMT_Encode4(1886261), // Rule ID 14745 //
     /* 1886177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1886188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1886191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1886194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886223 */     // MIs[0] policy
     /* 1886223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886233 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886260 */     // GIR_Coverage, 14745,
     /* 1886260 */     GIR_EraseRootFromParent_Done,
     /* 1886261 */   // Label 25444: @1886261
     /* 1886261 */   GIM_Try, /*On fail goto*//*Label 25445*/ GIMT_Encode4(1886350), // Rule ID 14748 //
     /* 1886266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1886277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1886280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1886283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886312 */     // MIs[0] policy
     /* 1886312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886322 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886349 */     // GIR_Coverage, 14748,
     /* 1886349 */     GIR_EraseRootFromParent_Done,
     /* 1886350 */   // Label 25445: @1886350
     /* 1886350 */   GIM_Try, /*On fail goto*//*Label 25446*/ GIMT_Encode4(1886439), // Rule ID 14749 //
     /* 1886355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1886366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1886369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1886372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886401 */     // MIs[0] policy
     /* 1886401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886411 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886438 */     // GIR_Coverage, 14749,
     /* 1886438 */     GIR_EraseRootFromParent_Done,
     /* 1886439 */   // Label 25446: @1886439
     /* 1886439 */   GIM_Try, /*On fail goto*//*Label 25447*/ GIMT_Encode4(1886528), // Rule ID 14752 //
     /* 1886444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1886447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1886455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1886458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1886461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1886467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886490 */     // MIs[0] policy
     /* 1886490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886500 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1886503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886527 */     // GIR_Coverage, 14752,
     /* 1886527 */     GIR_EraseRootFromParent_Done,
     /* 1886528 */   // Label 25447: @1886528
     /* 1886528 */   GIM_Try, /*On fail goto*//*Label 25448*/ GIMT_Encode4(1886617), // Rule ID 14753 //
     /* 1886533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1886536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1886544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1886547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1886550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1886556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886579 */     // MIs[0] policy
     /* 1886579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886589 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1886592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886616 */     // GIR_Coverage, 14753,
     /* 1886616 */     GIR_EraseRootFromParent_Done,
     /* 1886617 */   // Label 25448: @1886617
     /* 1886617 */   GIM_Try, /*On fail goto*//*Label 25449*/ GIMT_Encode4(1886706), // Rule ID 14756 //
     /* 1886622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1886625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1886633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1886636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1886639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886668 */     // MIs[0] policy
     /* 1886668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886678 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886705 */     // GIR_Coverage, 14756,
     /* 1886705 */     GIR_EraseRootFromParent_Done,
     /* 1886706 */   // Label 25449: @1886706
     /* 1886706 */   GIM_Try, /*On fail goto*//*Label 25450*/ GIMT_Encode4(1886795), // Rule ID 14757 //
     /* 1886711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1886714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1886722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1886725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1886728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886757 */     // MIs[0] policy
     /* 1886757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886767 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886794 */     // GIR_Coverage, 14757,
     /* 1886794 */     GIR_EraseRootFromParent_Done,
     /* 1886795 */   // Label 25450: @1886795
     /* 1886795 */   GIM_Try, /*On fail goto*//*Label 25451*/ GIMT_Encode4(1886884), // Rule ID 14760 //
     /* 1886800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1886803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1886811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1886814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1886817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886846 */     // MIs[0] policy
     /* 1886846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886856 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886883 */     // GIR_Coverage, 14760,
     /* 1886883 */     GIR_EraseRootFromParent_Done,
     /* 1886884 */   // Label 25451: @1886884
     /* 1886884 */   GIM_Try, /*On fail goto*//*Label 25452*/ GIMT_Encode4(1886973), // Rule ID 14761 //
     /* 1886889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1886892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1886900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1886903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1886906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886935 */     // MIs[0] policy
     /* 1886935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886945 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886972 */     // GIR_Coverage, 14761,
     /* 1886972 */     GIR_EraseRootFromParent_Done,
     /* 1886973 */   // Label 25452: @1886973
     /* 1886973 */   GIM_Try, /*On fail goto*//*Label 25453*/ GIMT_Encode4(1887062), // Rule ID 14764 //
     /* 1886978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1886989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1886992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1886995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1886998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887024 */     // MIs[0] policy
     /* 1887024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887034 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1887037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887061 */     // GIR_Coverage, 14764,
     /* 1887061 */     GIR_EraseRootFromParent_Done,
     /* 1887062 */   // Label 25453: @1887062
     /* 1887062 */   GIM_Try, /*On fail goto*//*Label 25454*/ GIMT_Encode4(1887151), // Rule ID 14765 //
     /* 1887067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1887078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1887081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1887084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1887087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887113 */     // MIs[0] policy
     /* 1887113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887123 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1887126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887150 */     // GIR_Coverage, 14765,
     /* 1887150 */     GIR_EraseRootFromParent_Done,
     /* 1887151 */   // Label 25454: @1887151
     /* 1887151 */   GIM_Try, /*On fail goto*//*Label 25455*/ GIMT_Encode4(1887240), // Rule ID 14768 //
     /* 1887156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1887167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1887170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1887173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1887176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887202 */     // MIs[0] policy
     /* 1887202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887212 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1887215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887239 */     // GIR_Coverage, 14768,
     /* 1887239 */     GIR_EraseRootFromParent_Done,
     /* 1887240 */   // Label 25455: @1887240
     /* 1887240 */   GIM_Try, /*On fail goto*//*Label 25456*/ GIMT_Encode4(1887329), // Rule ID 14769 //
     /* 1887245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1887256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1887259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1887262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1887265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887291 */     // MIs[0] policy
     /* 1887291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887301 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1887304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887328 */     // GIR_Coverage, 14769,
     /* 1887328 */     GIR_EraseRootFromParent_Done,
     /* 1887329 */   // Label 25456: @1887329
     /* 1887329 */   GIM_Try, /*On fail goto*//*Label 25457*/ GIMT_Encode4(1887418), // Rule ID 14772 //
     /* 1887334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1887345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1887348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1887351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1887354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887380 */     // MIs[0] policy
     /* 1887380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887390 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887417 */     // GIR_Coverage, 14772,
     /* 1887417 */     GIR_EraseRootFromParent_Done,
     /* 1887418 */   // Label 25457: @1887418
     /* 1887418 */   GIM_Try, /*On fail goto*//*Label 25458*/ GIMT_Encode4(1887507), // Rule ID 14773 //
     /* 1887423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1887434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1887437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1887440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1887443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887469 */     // MIs[0] policy
     /* 1887469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887479 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887506 */     // GIR_Coverage, 14773,
     /* 1887506 */     GIR_EraseRootFromParent_Done,
     /* 1887507 */   // Label 25458: @1887507
     /* 1887507 */   GIM_Try, /*On fail goto*//*Label 25459*/ GIMT_Encode4(1887596), // Rule ID 14776 //
     /* 1887512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1887523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1887526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1887529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1887532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887558 */     // MIs[0] policy
     /* 1887558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1887571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887595 */     // GIR_Coverage, 14776,
     /* 1887595 */     GIR_EraseRootFromParent_Done,
     /* 1887596 */   // Label 25459: @1887596
     /* 1887596 */   GIM_Try, /*On fail goto*//*Label 25460*/ GIMT_Encode4(1887685), // Rule ID 14777 //
     /* 1887601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1887612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1887615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1887618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1887621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887647 */     // MIs[0] policy
     /* 1887647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887657 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1887660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887684 */     // GIR_Coverage, 14777,
     /* 1887684 */     GIR_EraseRootFromParent_Done,
     /* 1887685 */   // Label 25460: @1887685
     /* 1887685 */   GIM_Try, /*On fail goto*//*Label 25461*/ GIMT_Encode4(1887774), // Rule ID 14780 //
     /* 1887690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1887701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1887704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1887707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1887710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887736 */     // MIs[0] policy
     /* 1887736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887746 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887773 */     // GIR_Coverage, 14780,
     /* 1887773 */     GIR_EraseRootFromParent_Done,
     /* 1887774 */   // Label 25461: @1887774
     /* 1887774 */   GIM_Try, /*On fail goto*//*Label 25462*/ GIMT_Encode4(1887863), // Rule ID 14781 //
     /* 1887779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1887790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1887793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1887796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1887799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887825 */     // MIs[0] policy
     /* 1887825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887835 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887862 */     // GIR_Coverage, 14781,
     /* 1887862 */     GIR_EraseRootFromParent_Done,
     /* 1887863 */   // Label 25462: @1887863
     /* 1887863 */   GIM_Try, /*On fail goto*//*Label 25463*/ GIMT_Encode4(1887952), // Rule ID 14784 //
     /* 1887868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1887879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1887882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1887885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1887888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887914 */     // MIs[0] policy
     /* 1887914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887951 */     // GIR_Coverage, 14784,
     /* 1887951 */     GIR_EraseRootFromParent_Done,
     /* 1887952 */   // Label 25463: @1887952
     /* 1887952 */   GIM_Try, /*On fail goto*//*Label 25464*/ GIMT_Encode4(1888041), // Rule ID 14785 //
     /* 1887957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1887968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1887971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1887974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1887977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888003 */     // MIs[0] policy
     /* 1888003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888013 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1888016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888040 */     // GIR_Coverage, 14785,
     /* 1888040 */     GIR_EraseRootFromParent_Done,
     /* 1888041 */   // Label 25464: @1888041
     /* 1888041 */   GIM_Try, /*On fail goto*//*Label 25465*/ GIMT_Encode4(1888130), // Rule ID 14788 //
     /* 1888046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1888057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1888060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1888063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1888066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888092 */     // MIs[0] policy
     /* 1888092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888129 */     // GIR_Coverage, 14788,
     /* 1888129 */     GIR_EraseRootFromParent_Done,
     /* 1888130 */   // Label 25465: @1888130
     /* 1888130 */   GIM_Try, /*On fail goto*//*Label 25466*/ GIMT_Encode4(1888219), // Rule ID 14789 //
     /* 1888135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1888146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1888149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1888152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1888155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888181 */     // MIs[0] policy
     /* 1888181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888191 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888218 */     // GIR_Coverage, 14789,
     /* 1888218 */     GIR_EraseRootFromParent_Done,
     /* 1888219 */   // Label 25466: @1888219
     /* 1888219 */   GIM_Try, /*On fail goto*//*Label 25467*/ GIMT_Encode4(1888308), // Rule ID 14792 //
     /* 1888224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1888244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888270 */     // MIs[0] policy
     /* 1888270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888280 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888307 */     // GIR_Coverage, 14792,
     /* 1888307 */     GIR_EraseRootFromParent_Done,
     /* 1888308 */   // Label 25467: @1888308
     /* 1888308 */   GIM_Try, /*On fail goto*//*Label 25468*/ GIMT_Encode4(1888397), // Rule ID 14793 //
     /* 1888313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1888333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888359 */     // MIs[0] policy
     /* 1888359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888369 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888396 */     // GIR_Coverage, 14793,
     /* 1888396 */     GIR_EraseRootFromParent_Done,
     /* 1888397 */   // Label 25468: @1888397
     /* 1888397 */   GIM_Try, /*On fail goto*//*Label 25469*/ GIMT_Encode4(1888486), // Rule ID 14796 //
     /* 1888402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1888413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1888416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1888419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1888422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888448 */     // MIs[0] policy
     /* 1888448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888458 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888485 */     // GIR_Coverage, 14796,
     /* 1888485 */     GIR_EraseRootFromParent_Done,
     /* 1888486 */   // Label 25469: @1888486
     /* 1888486 */   GIM_Try, /*On fail goto*//*Label 25470*/ GIMT_Encode4(1888575), // Rule ID 14797 //
     /* 1888491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1888502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1888505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1888508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1888511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888537 */     // MIs[0] policy
     /* 1888537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888547 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888574 */     // GIR_Coverage, 14797,
     /* 1888574 */     GIR_EraseRootFromParent_Done,
     /* 1888575 */   // Label 25470: @1888575
     /* 1888575 */   GIM_Try, /*On fail goto*//*Label 25471*/ GIMT_Encode4(1888664), // Rule ID 14800 //
     /* 1888580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1888583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1888591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1888594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1888597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1888600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888626 */     // MIs[0] policy
     /* 1888626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888663 */     // GIR_Coverage, 14800,
     /* 1888663 */     GIR_EraseRootFromParent_Done,
     /* 1888664 */   // Label 25471: @1888664
     /* 1888664 */   GIM_Try, /*On fail goto*//*Label 25472*/ GIMT_Encode4(1888753), // Rule ID 14801 //
     /* 1888669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1888672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1888680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1888683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1888686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1888689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888715 */     // MIs[0] policy
     /* 1888715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888725 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888752 */     // GIR_Coverage, 14801,
     /* 1888752 */     GIR_EraseRootFromParent_Done,
     /* 1888753 */   // Label 25472: @1888753
     /* 1888753 */   GIM_Try, /*On fail goto*//*Label 25473*/ GIMT_Encode4(1888842), // Rule ID 14804 //
     /* 1888758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1888769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1888772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1888775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1888778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1888781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1888788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888804 */     // MIs[0] policy
     /* 1888804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888814 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1888817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888841 */     // GIR_Coverage, 14804,
     /* 1888841 */     GIR_EraseRootFromParent_Done,
     /* 1888842 */   // Label 25473: @1888842
     /* 1888842 */   GIM_Try, /*On fail goto*//*Label 25474*/ GIMT_Encode4(1888931), // Rule ID 14805 //
     /* 1888847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1888858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1888861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1888864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1888867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1888870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1888877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888893 */     // MIs[0] policy
     /* 1888893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888903 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1888906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888930 */     // GIR_Coverage, 14805,
     /* 1888930 */     GIR_EraseRootFromParent_Done,
     /* 1888931 */   // Label 25474: @1888931
     /* 1888931 */   GIM_Try, /*On fail goto*//*Label 25475*/ GIMT_Encode4(1889020), // Rule ID 14808 //
     /* 1888936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1888947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1888950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1888953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1888956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1888959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1888966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888982 */     // MIs[0] policy
     /* 1888982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888992 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1888995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889019 */     // GIR_Coverage, 14808,
     /* 1889019 */     GIR_EraseRootFromParent_Done,
     /* 1889020 */   // Label 25475: @1889020
     /* 1889020 */   GIM_Try, /*On fail goto*//*Label 25476*/ GIMT_Encode4(1889109), // Rule ID 14809 //
     /* 1889025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1889036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1889039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1889042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1889045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889071 */     // MIs[0] policy
     /* 1889071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889081 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1889084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889108 */     // GIR_Coverage, 14809,
     /* 1889108 */     GIR_EraseRootFromParent_Done,
     /* 1889109 */   // Label 25476: @1889109
     /* 1889109 */   GIM_Try, /*On fail goto*//*Label 25477*/ GIMT_Encode4(1889198), // Rule ID 14812 //
     /* 1889114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1889125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1889128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1889131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1889134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1889137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889160 */     // MIs[0] policy
     /* 1889160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889170 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1889173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889197 */     // GIR_Coverage, 14812,
     /* 1889197 */     GIR_EraseRootFromParent_Done,
     /* 1889198 */   // Label 25477: @1889198
     /* 1889198 */   GIM_Try, /*On fail goto*//*Label 25478*/ GIMT_Encode4(1889287), // Rule ID 14813 //
     /* 1889203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1889214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1889217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1889220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1889223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1889226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889249 */     // MIs[0] policy
     /* 1889249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889259 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1889262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889286 */     // GIR_Coverage, 14813,
     /* 1889286 */     GIR_EraseRootFromParent_Done,
     /* 1889287 */   // Label 25478: @1889287
     /* 1889287 */   GIM_Try, /*On fail goto*//*Label 25479*/ GIMT_Encode4(1889376), // Rule ID 14816 //
     /* 1889292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1889312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889338 */     // MIs[0] policy
     /* 1889338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889375 */     // GIR_Coverage, 14816,
     /* 1889375 */     GIR_EraseRootFromParent_Done,
     /* 1889376 */   // Label 25479: @1889376
     /* 1889376 */   GIM_Try, /*On fail goto*//*Label 25480*/ GIMT_Encode4(1889465), // Rule ID 14817 //
     /* 1889381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1889401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889427 */     // MIs[0] policy
     /* 1889427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889437 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889464 */     // GIR_Coverage, 14817,
     /* 1889464 */     GIR_EraseRootFromParent_Done,
     /* 1889465 */   // Label 25480: @1889465
     /* 1889465 */   GIM_Try, /*On fail goto*//*Label 25481*/ GIMT_Encode4(1889554), // Rule ID 14820 //
     /* 1889470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1889481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1889484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1889487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1889490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889516 */     // MIs[0] policy
     /* 1889516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889526 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1889529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889553 */     // GIR_Coverage, 14820,
     /* 1889553 */     GIR_EraseRootFromParent_Done,
     /* 1889554 */   // Label 25481: @1889554
     /* 1889554 */   GIM_Try, /*On fail goto*//*Label 25482*/ GIMT_Encode4(1889643), // Rule ID 14821 //
     /* 1889559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1889570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1889573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1889576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1889579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889605 */     // MIs[0] policy
     /* 1889605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889615 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1889618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889642 */     // GIR_Coverage, 14821,
     /* 1889642 */     GIR_EraseRootFromParent_Done,
     /* 1889643 */   // Label 25482: @1889643
     /* 1889643 */   GIM_Try, /*On fail goto*//*Label 25483*/ GIMT_Encode4(1889732), // Rule ID 14824 //
     /* 1889648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1889659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1889662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1889665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1889668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889694 */     // MIs[0] policy
     /* 1889694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889704 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1889707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889731 */     // GIR_Coverage, 14824,
     /* 1889731 */     GIR_EraseRootFromParent_Done,
     /* 1889732 */   // Label 25483: @1889732
     /* 1889732 */   GIM_Try, /*On fail goto*//*Label 25484*/ GIMT_Encode4(1889821), // Rule ID 14825 //
     /* 1889737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1889748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1889751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1889754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1889757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889783 */     // MIs[0] policy
     /* 1889783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889793 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1889796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889820 */     // GIR_Coverage, 14825,
     /* 1889820 */     GIR_EraseRootFromParent_Done,
     /* 1889821 */   // Label 25484: @1889821
     /* 1889821 */   GIM_Try, /*On fail goto*//*Label 25485*/ GIMT_Encode4(1889910), // Rule ID 14828 //
     /* 1889826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1889837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1889840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1889843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1889846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1889849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889872 */     // MIs[0] policy
     /* 1889872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889882 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889909 */     // GIR_Coverage, 14828,
     /* 1889909 */     GIR_EraseRootFromParent_Done,
     /* 1889910 */   // Label 25485: @1889910
     /* 1889910 */   GIM_Try, /*On fail goto*//*Label 25486*/ GIMT_Encode4(1889999), // Rule ID 14829 //
     /* 1889915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1889926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1889929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1889932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1889935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1889938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889961 */     // MIs[0] policy
     /* 1889961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889998 */     // GIR_Coverage, 14829,
     /* 1889998 */     GIR_EraseRootFromParent_Done,
     /* 1889999 */   // Label 25486: @1889999
     /* 1889999 */   GIM_Try, /*On fail goto*//*Label 25487*/ GIMT_Encode4(1890088), // Rule ID 14832 //
     /* 1890004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1890015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1890018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1890021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1890024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890050 */     // MIs[0] policy
     /* 1890050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890060 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890087 */     // GIR_Coverage, 14832,
     /* 1890087 */     GIR_EraseRootFromParent_Done,
     /* 1890088 */   // Label 25487: @1890088
     /* 1890088 */   GIM_Try, /*On fail goto*//*Label 25488*/ GIMT_Encode4(1890177), // Rule ID 14833 //
     /* 1890093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1890104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1890107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1890110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1890113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890139 */     // MIs[0] policy
     /* 1890139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890149 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890176 */     // GIR_Coverage, 14833,
     /* 1890176 */     GIR_EraseRootFromParent_Done,
     /* 1890177 */   // Label 25488: @1890177
     /* 1890177 */   GIM_Try, /*On fail goto*//*Label 25489*/ GIMT_Encode4(1890266), // Rule ID 14836 //
     /* 1890182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1890202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890228 */     // MIs[0] policy
     /* 1890228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890238 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890265 */     // GIR_Coverage, 14836,
     /* 1890265 */     GIR_EraseRootFromParent_Done,
     /* 1890266 */   // Label 25489: @1890266
     /* 1890266 */   GIM_Try, /*On fail goto*//*Label 25490*/ GIMT_Encode4(1890355), // Rule ID 14837 //
     /* 1890271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1890291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890317 */     // MIs[0] policy
     /* 1890317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890327 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890354 */     // GIR_Coverage, 14837,
     /* 1890354 */     GIR_EraseRootFromParent_Done,
     /* 1890355 */   // Label 25490: @1890355
     /* 1890355 */   GIM_Try, /*On fail goto*//*Label 25491*/ GIMT_Encode4(1890444), // Rule ID 14840 //
     /* 1890360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1890363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1890380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890406 */     // MIs[0] policy
     /* 1890406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1890419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890443 */     // GIR_Coverage, 14840,
     /* 1890443 */     GIR_EraseRootFromParent_Done,
     /* 1890444 */   // Label 25491: @1890444
     /* 1890444 */   GIM_Try, /*On fail goto*//*Label 25492*/ GIMT_Encode4(1890533), // Rule ID 14841 //
     /* 1890449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1890452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1890469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890495 */     // MIs[0] policy
     /* 1890495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1890508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890532 */     // GIR_Coverage, 14841,
     /* 1890532 */     GIR_EraseRootFromParent_Done,
     /* 1890533 */   // Label 25492: @1890533
     /* 1890533 */   GIM_Try, /*On fail goto*//*Label 25493*/ GIMT_Encode4(1890622), // Rule ID 14844 //
     /* 1890538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1890541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1890549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1890552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1890555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1890558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890584 */     // MIs[0] policy
     /* 1890584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890594 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890621 */     // GIR_Coverage, 14844,
     /* 1890621 */     GIR_EraseRootFromParent_Done,
     /* 1890622 */   // Label 25493: @1890622
     /* 1890622 */   GIM_Try, /*On fail goto*//*Label 25494*/ GIMT_Encode4(1890711), // Rule ID 14845 //
     /* 1890627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1890630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1890638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1890641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1890644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1890647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890673 */     // MIs[0] policy
     /* 1890673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890683 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890710 */     // GIR_Coverage, 14845,
     /* 1890710 */     GIR_EraseRootFromParent_Done,
     /* 1890711 */   // Label 25494: @1890711
     /* 1890711 */   GIM_Try, /*On fail goto*//*Label 25495*/ GIMT_Encode4(1890800), // Rule ID 14848 //
     /* 1890716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1890719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1890727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1890730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1890733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1890736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890762 */     // MIs[0] policy
     /* 1890762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890772 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890799 */     // GIR_Coverage, 14848,
     /* 1890799 */     GIR_EraseRootFromParent_Done,
     /* 1890800 */   // Label 25495: @1890800
     /* 1890800 */   GIM_Try, /*On fail goto*//*Label 25496*/ GIMT_Encode4(1890889), // Rule ID 14849 //
     /* 1890805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1890808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1890816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1890819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1890822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1890825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890851 */     // MIs[0] policy
     /* 1890851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890861 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890888 */     // GIR_Coverage, 14849,
     /* 1890888 */     GIR_EraseRootFromParent_Done,
     /* 1890889 */   // Label 25496: @1890889
     /* 1890889 */   GIM_Try, /*On fail goto*//*Label 25497*/ GIMT_Encode4(1890978), // Rule ID 14852 //
     /* 1890894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1890905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1890908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1890911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1890914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1890917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1890924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890940 */     // MIs[0] policy
     /* 1890940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890950 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1890953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1890971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890977 */     // GIR_Coverage, 14852,
     /* 1890977 */     GIR_EraseRootFromParent_Done,
     /* 1890978 */   // Label 25497: @1890978
     /* 1890978 */   GIM_Try, /*On fail goto*//*Label 25498*/ GIMT_Encode4(1891067), // Rule ID 14853 //
     /* 1890983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1890994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1890997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1891000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891029 */     // MIs[0] policy
     /* 1891029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891039 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1891042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891066 */     // GIR_Coverage, 14853,
     /* 1891066 */     GIR_EraseRootFromParent_Done,
     /* 1891067 */   // Label 25498: @1891067
     /* 1891067 */   GIM_Try, /*On fail goto*//*Label 25499*/ GIMT_Encode4(1891156), // Rule ID 14856 //
     /* 1891072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1891083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1891086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1891089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891118 */     // MIs[0] policy
     /* 1891118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891128 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891155 */     // GIR_Coverage, 14856,
     /* 1891155 */     GIR_EraseRootFromParent_Done,
     /* 1891156 */   // Label 25499: @1891156
     /* 1891156 */   GIM_Try, /*On fail goto*//*Label 25500*/ GIMT_Encode4(1891245), // Rule ID 14857 //
     /* 1891161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1891172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1891175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1891178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891207 */     // MIs[0] policy
     /* 1891207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891217 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891244 */     // GIR_Coverage, 14857,
     /* 1891244 */     GIR_EraseRootFromParent_Done,
     /* 1891245 */   // Label 25500: @1891245
     /* 1891245 */   GIM_Try, /*On fail goto*//*Label 25501*/ GIMT_Encode4(1891334), // Rule ID 14860 //
     /* 1891250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1891261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1891264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1891267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891296 */     // MIs[0] policy
     /* 1891296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891306 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891333 */     // GIR_Coverage, 14860,
     /* 1891333 */     GIR_EraseRootFromParent_Done,
     /* 1891334 */   // Label 25501: @1891334
     /* 1891334 */   GIM_Try, /*On fail goto*//*Label 25502*/ GIMT_Encode4(1891423), // Rule ID 14861 //
     /* 1891339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1891350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1891353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1891356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891385 */     // MIs[0] policy
     /* 1891385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891395 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891422 */     // GIR_Coverage, 14861,
     /* 1891422 */     GIR_EraseRootFromParent_Done,
     /* 1891423 */   // Label 25502: @1891423
     /* 1891423 */   GIM_Try, /*On fail goto*//*Label 25503*/ GIMT_Encode4(1891512), // Rule ID 14864 //
     /* 1891428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1891439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1891442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1891445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891474 */     // MIs[0] policy
     /* 1891474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891511 */     // GIR_Coverage, 14864,
     /* 1891511 */     GIR_EraseRootFromParent_Done,
     /* 1891512 */   // Label 25503: @1891512
     /* 1891512 */   GIM_Try, /*On fail goto*//*Label 25504*/ GIMT_Encode4(1891601), // Rule ID 14865 //
     /* 1891517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1891528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1891531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1891534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891563 */     // MIs[0] policy
     /* 1891563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891573 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891600 */     // GIR_Coverage, 14865,
     /* 1891600 */     GIR_EraseRootFromParent_Done,
     /* 1891601 */   // Label 25504: @1891601
     /* 1891601 */   GIM_Try, /*On fail goto*//*Label 25505*/ GIMT_Encode4(1891690), // Rule ID 14868 //
     /* 1891606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1891617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1891620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1891623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891652 */     // MIs[0] policy
     /* 1891652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891662 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891689 */     // GIR_Coverage, 14868,
     /* 1891689 */     GIR_EraseRootFromParent_Done,
     /* 1891690 */   // Label 25505: @1891690
     /* 1891690 */   GIM_Try, /*On fail goto*//*Label 25506*/ GIMT_Encode4(1891779), // Rule ID 14869 //
     /* 1891695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1891706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1891709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1891712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891741 */     // MIs[0] policy
     /* 1891741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891751 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891778 */     // GIR_Coverage, 14869,
     /* 1891778 */     GIR_EraseRootFromParent_Done,
     /* 1891779 */   // Label 25506: @1891779
     /* 1891779 */   GIM_Try, /*On fail goto*//*Label 25507*/ GIMT_Encode4(1891868), // Rule ID 14872 //
     /* 1891784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1891795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1891798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1891801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891830 */     // MIs[0] policy
     /* 1891830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891867 */     // GIR_Coverage, 14872,
     /* 1891867 */     GIR_EraseRootFromParent_Done,
     /* 1891868 */   // Label 25507: @1891868
     /* 1891868 */   GIM_Try, /*On fail goto*//*Label 25508*/ GIMT_Encode4(1891957), // Rule ID 14873 //
     /* 1891873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1891884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1891887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1891890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891919 */     // MIs[0] policy
     /* 1891919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891929 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891956 */     // GIR_Coverage, 14873,
     /* 1891956 */     GIR_EraseRootFromParent_Done,
     /* 1891957 */   // Label 25508: @1891957
     /* 1891957 */   GIM_Try, /*On fail goto*//*Label 25509*/ GIMT_Encode4(1892046), // Rule ID 14876 //
     /* 1891962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1891973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1891976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1891979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892008 */     // MIs[0] policy
     /* 1892008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892018 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892045 */     // GIR_Coverage, 14876,
     /* 1892045 */     GIR_EraseRootFromParent_Done,
     /* 1892046 */   // Label 25509: @1892046
     /* 1892046 */   GIM_Try, /*On fail goto*//*Label 25510*/ GIMT_Encode4(1892135), // Rule ID 14877 //
     /* 1892051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1892062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1892065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1892068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1892074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892097 */     // MIs[0] policy
     /* 1892097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892107 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11632:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892134 */     // GIR_Coverage, 14877,
     /* 1892134 */     GIR_EraseRootFromParent_Done,
     /* 1892135 */   // Label 25510: @1892135
     /* 1892135 */   GIM_Try, /*On fail goto*//*Label 25511*/ GIMT_Encode4(1892224), // Rule ID 14880 //
     /* 1892140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1892151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1892154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1892157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892186 */     // MIs[0] policy
     /* 1892186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892196 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892223 */     // GIR_Coverage, 14880,
     /* 1892223 */     GIR_EraseRootFromParent_Done,
     /* 1892224 */   // Label 25511: @1892224
     /* 1892224 */   GIM_Try, /*On fail goto*//*Label 25512*/ GIMT_Encode4(1892313), // Rule ID 14881 //
     /* 1892229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1892240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1892243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1892246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892275 */     // MIs[0] policy
     /* 1892275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892285 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892312 */     // GIR_Coverage, 14881,
     /* 1892312 */     GIR_EraseRootFromParent_Done,
     /* 1892313 */   // Label 25512: @1892313
     /* 1892313 */   GIM_Try, /*On fail goto*//*Label 25513*/ GIMT_Encode4(1892402), // Rule ID 14884 //
     /* 1892318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1892329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1892332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1892335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892364 */     // MIs[0] policy
     /* 1892364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892374 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892401 */     // GIR_Coverage, 14884,
     /* 1892401 */     GIR_EraseRootFromParent_Done,
     /* 1892402 */   // Label 25513: @1892402
     /* 1892402 */   GIM_Try, /*On fail goto*//*Label 25514*/ GIMT_Encode4(1892491), // Rule ID 14885 //
     /* 1892407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1892418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1892421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1892424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892453 */     // MIs[0] policy
     /* 1892453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892463 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892490 */     // GIR_Coverage, 14885,
     /* 1892490 */     GIR_EraseRootFromParent_Done,
     /* 1892491 */   // Label 25514: @1892491
     /* 1892491 */   GIM_Try, /*On fail goto*//*Label 25515*/ GIMT_Encode4(1892580), // Rule ID 14888 //
     /* 1892496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1892499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1892507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1892510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1892513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892542 */     // MIs[0] policy
     /* 1892542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892552 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892579 */     // GIR_Coverage, 14888,
     /* 1892579 */     GIR_EraseRootFromParent_Done,
     /* 1892580 */   // Label 25515: @1892580
     /* 1892580 */   GIM_Try, /*On fail goto*//*Label 25516*/ GIMT_Encode4(1892669), // Rule ID 14889 //
     /* 1892585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1892588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1892596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1892599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1892602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892631 */     // MIs[0] policy
     /* 1892631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892641 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892668 */     // GIR_Coverage, 14889,
     /* 1892668 */     GIR_EraseRootFromParent_Done,
     /* 1892669 */   // Label 25516: @1892669
     /* 1892669 */   GIM_Try, /*On fail goto*//*Label 25517*/ GIMT_Encode4(1892758), // Rule ID 14892 //
     /* 1892674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1892685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1892688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1892691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1892697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1892704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892720 */     // MIs[0] policy
     /* 1892720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892730 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1892733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892757 */     // GIR_Coverage, 14892,
     /* 1892757 */     GIR_EraseRootFromParent_Done,
     /* 1892758 */   // Label 25517: @1892758
     /* 1892758 */   GIM_Try, /*On fail goto*//*Label 25518*/ GIMT_Encode4(1892847), // Rule ID 14893 //
     /* 1892763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1892774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1892777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1892780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1892786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1892793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892809 */     // MIs[0] policy
     /* 1892809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892819 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1892822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892846 */     // GIR_Coverage, 14893,
     /* 1892846 */     GIR_EraseRootFromParent_Done,
     /* 1892847 */   // Label 25518: @1892847
     /* 1892847 */   GIM_Try, /*On fail goto*//*Label 25519*/ GIMT_Encode4(1892936), // Rule ID 14896 //
     /* 1892852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1892863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1892866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1892869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1892875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1892882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892898 */     // MIs[0] policy
     /* 1892898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892908 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1892911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892935 */     // GIR_Coverage, 14896,
     /* 1892935 */     GIR_EraseRootFromParent_Done,
     /* 1892936 */   // Label 25519: @1892936
     /* 1892936 */   GIM_Try, /*On fail goto*//*Label 25520*/ GIMT_Encode4(1893025), // Rule ID 14897 //
     /* 1892941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1892952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1892955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1892958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1892964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1892971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892987 */     // MIs[0] policy
     /* 1892987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892997 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893024 */     // GIR_Coverage, 14897,
     /* 1893024 */     GIR_EraseRootFromParent_Done,
     /* 1893025 */   // Label 25520: @1893025
     /* 1893025 */   GIM_Try, /*On fail goto*//*Label 25521*/ GIMT_Encode4(1893114), // Rule ID 14900 //
     /* 1893030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1893041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1893044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1893047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1893053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893076 */     // MIs[0] policy
     /* 1893076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893086 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1893089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893113 */     // GIR_Coverage, 14900,
     /* 1893113 */     GIR_EraseRootFromParent_Done,
     /* 1893114 */   // Label 25521: @1893114
     /* 1893114 */   GIM_Try, /*On fail goto*//*Label 25522*/ GIMT_Encode4(1893203), // Rule ID 14901 //
     /* 1893119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1893130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1893133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1893136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1893142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893165 */     // MIs[0] policy
     /* 1893165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893175 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1893178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893202 */     // GIR_Coverage, 14901,
     /* 1893202 */     GIR_EraseRootFromParent_Done,
     /* 1893203 */   // Label 25522: @1893203
     /* 1893203 */   GIM_Try, /*On fail goto*//*Label 25523*/ GIMT_Encode4(1893292), // Rule ID 14904 //
     /* 1893208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893254 */     // MIs[0] policy
     /* 1893254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893264 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893291 */     // GIR_Coverage, 14904,
     /* 1893291 */     GIR_EraseRootFromParent_Done,
     /* 1893292 */   // Label 25523: @1893292
     /* 1893292 */   GIM_Try, /*On fail goto*//*Label 25524*/ GIMT_Encode4(1893381), // Rule ID 14905 //
     /* 1893297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893343 */     // MIs[0] policy
     /* 1893343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893380 */     // GIR_Coverage, 14905,
     /* 1893380 */     GIR_EraseRootFromParent_Done,
     /* 1893381 */   // Label 25524: @1893381
     /* 1893381 */   GIM_Try, /*On fail goto*//*Label 25525*/ GIMT_Encode4(1893470), // Rule ID 14908 //
     /* 1893386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893432 */     // MIs[0] policy
     /* 1893432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893442 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893469 */     // GIR_Coverage, 14908,
     /* 1893469 */     GIR_EraseRootFromParent_Done,
     /* 1893470 */   // Label 25525: @1893470
     /* 1893470 */   GIM_Try, /*On fail goto*//*Label 25526*/ GIMT_Encode4(1893559), // Rule ID 14909 //
     /* 1893475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893521 */     // MIs[0] policy
     /* 1893521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893531 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893558 */     // GIR_Coverage, 14909,
     /* 1893558 */     GIR_EraseRootFromParent_Done,
     /* 1893559 */   // Label 25526: @1893559
     /* 1893559 */   GIM_Try, /*On fail goto*//*Label 25527*/ GIMT_Encode4(1893648), // Rule ID 14912 //
     /* 1893564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1893575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1893578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1893581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893610 */     // MIs[0] policy
     /* 1893610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893620 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1893623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893647 */     // GIR_Coverage, 14912,
     /* 1893647 */     GIR_EraseRootFromParent_Done,
     /* 1893648 */   // Label 25527: @1893648
     /* 1893648 */   GIM_Try, /*On fail goto*//*Label 25528*/ GIMT_Encode4(1893737), // Rule ID 14913 //
     /* 1893653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1893664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1893667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1893670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893699 */     // MIs[0] policy
     /* 1893699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893709 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1893712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893736 */     // GIR_Coverage, 14913,
     /* 1893736 */     GIR_EraseRootFromParent_Done,
     /* 1893737 */   // Label 25528: @1893737
     /* 1893737 */   GIM_Try, /*On fail goto*//*Label 25529*/ GIMT_Encode4(1893826), // Rule ID 14916 //
     /* 1893742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1893753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1893756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1893759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1893765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893788 */     // MIs[0] policy
     /* 1893788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893825 */     // GIR_Coverage, 14916,
     /* 1893825 */     GIR_EraseRootFromParent_Done,
     /* 1893826 */   // Label 25529: @1893826
     /* 1893826 */   GIM_Try, /*On fail goto*//*Label 25530*/ GIMT_Encode4(1893915), // Rule ID 14917 //
     /* 1893831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1893842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1893845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1893848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1893854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893877 */     // MIs[0] policy
     /* 1893877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893914 */     // GIR_Coverage, 14917,
     /* 1893914 */     GIR_EraseRootFromParent_Done,
     /* 1893915 */   // Label 25530: @1893915
     /* 1893915 */   GIM_Try, /*On fail goto*//*Label 25531*/ GIMT_Encode4(1894004), // Rule ID 14920 //
     /* 1893920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1893931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1893934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1893937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893966 */     // MIs[0] policy
     /* 1893966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894003 */     // GIR_Coverage, 14920,
     /* 1894003 */     GIR_EraseRootFromParent_Done,
     /* 1894004 */   // Label 25531: @1894004
     /* 1894004 */   GIM_Try, /*On fail goto*//*Label 25532*/ GIMT_Encode4(1894093), // Rule ID 14921 //
     /* 1894009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1894020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1894023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1894026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894055 */     // MIs[0] policy
     /* 1894055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894065 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1894068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894092 */     // GIR_Coverage, 14921,
     /* 1894092 */     GIR_EraseRootFromParent_Done,
     /* 1894093 */   // Label 25532: @1894093
     /* 1894093 */   GIM_Try, /*On fail goto*//*Label 25533*/ GIMT_Encode4(1894182), // Rule ID 14924 //
     /* 1894098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1894101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894144 */     // MIs[0] policy
     /* 1894144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894154 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894181 */     // GIR_Coverage, 14924,
     /* 1894181 */     GIR_EraseRootFromParent_Done,
     /* 1894182 */   // Label 25533: @1894182
     /* 1894182 */   GIM_Try, /*On fail goto*//*Label 25534*/ GIMT_Encode4(1894271), // Rule ID 14925 //
     /* 1894187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894233 */     // MIs[0] policy
     /* 1894233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894243 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894270 */     // GIR_Coverage, 14925,
     /* 1894270 */     GIR_EraseRootFromParent_Done,
     /* 1894271 */   // Label 25534: @1894271
     /* 1894271 */   GIM_Try, /*On fail goto*//*Label 25535*/ GIMT_Encode4(1894360), // Rule ID 14928 //
     /* 1894276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1894279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894322 */     // MIs[0] policy
     /* 1894322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1894335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894359 */     // GIR_Coverage, 14928,
     /* 1894359 */     GIR_EraseRootFromParent_Done,
     /* 1894360 */   // Label 25535: @1894360
     /* 1894360 */   GIM_Try, /*On fail goto*//*Label 25536*/ GIMT_Encode4(1894449), // Rule ID 14929 //
     /* 1894365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1894368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894411 */     // MIs[0] policy
     /* 1894411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1894424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894448 */     // GIR_Coverage, 14929,
     /* 1894448 */     GIR_EraseRootFromParent_Done,
     /* 1894449 */   // Label 25536: @1894449
     /* 1894449 */   GIM_Try, /*On fail goto*//*Label 25537*/ GIMT_Encode4(1894538), // Rule ID 14932 //
     /* 1894454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1894457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1894465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1894468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1894471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894500 */     // MIs[0] policy
     /* 1894500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894510 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1894513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894533 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894537 */     // GIR_Coverage, 14932,
     /* 1894537 */     GIR_EraseRootFromParent_Done,
     /* 1894538 */   // Label 25537: @1894538
     /* 1894538 */   GIM_Try, /*On fail goto*//*Label 25538*/ GIMT_Encode4(1894627), // Rule ID 14933 //
     /* 1894543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1894546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1894554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1894557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1894560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894589 */     // MIs[0] policy
     /* 1894589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894599 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1894602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894626 */     // GIR_Coverage, 14933,
     /* 1894626 */     GIR_EraseRootFromParent_Done,
     /* 1894627 */   // Label 25538: @1894627
     /* 1894627 */   GIM_Try, /*On fail goto*//*Label 25539*/ GIMT_Encode4(1894716), // Rule ID 14936 //
     /* 1894632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1894635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1894643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1894646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1894649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894678 */     // MIs[0] policy
     /* 1894678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894688 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894715 */     // GIR_Coverage, 14936,
     /* 1894715 */     GIR_EraseRootFromParent_Done,
     /* 1894716 */   // Label 25539: @1894716
     /* 1894716 */   GIM_Try, /*On fail goto*//*Label 25540*/ GIMT_Encode4(1894805), // Rule ID 14937 //
     /* 1894721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1894724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1894732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1894735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1894738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894767 */     // MIs[0] policy
     /* 1894767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894777 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894804 */     // GIR_Coverage, 14937,
     /* 1894804 */     GIR_EraseRootFromParent_Done,
     /* 1894805 */   // Label 25540: @1894805
     /* 1894805 */   GIM_Try, /*On fail goto*//*Label 25541*/ GIMT_Encode4(1894891), // Rule ID 19178 //
     /* 1894810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1894813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1894821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1894824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1894827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1894830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1894833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1894840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894856 */     // MIs[0] policy
     /* 1894856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894866 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1894869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894890 */     // GIR_Coverage, 19178,
     /* 1894890 */     GIR_EraseRootFromParent_Done,
     /* 1894891 */   // Label 25541: @1894891
     /* 1894891 */   GIM_Try, /*On fail goto*//*Label 25542*/ GIMT_Encode4(1894977), // Rule ID 19179 //
     /* 1894896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1894899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1894907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1894910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1894913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1894916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1894919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1894926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894942 */     // MIs[0] policy
     /* 1894942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894952 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1894955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894976 */     // GIR_Coverage, 19179,
     /* 1894976 */     GIR_EraseRootFromParent_Done,
     /* 1894977 */   // Label 25542: @1894977
     /* 1894977 */   GIM_Try, /*On fail goto*//*Label 25543*/ GIMT_Encode4(1895063), // Rule ID 19182 //
     /* 1894982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1894985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1894993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1894996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1894999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1895002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895028 */     // MIs[0] policy
     /* 1895028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895038 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1895041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895062 */     // GIR_Coverage, 19182,
     /* 1895062 */     GIR_EraseRootFromParent_Done,
     /* 1895063 */   // Label 25543: @1895063
     /* 1895063 */   GIM_Try, /*On fail goto*//*Label 25544*/ GIMT_Encode4(1895149), // Rule ID 19183 //
     /* 1895068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1895079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1895082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1895085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1895088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895114 */     // MIs[0] policy
     /* 1895114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895124 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1895127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895148 */     // GIR_Coverage, 19183,
     /* 1895148 */     GIR_EraseRootFromParent_Done,
     /* 1895149 */   // Label 25544: @1895149
     /* 1895149 */   GIM_Try, /*On fail goto*//*Label 25545*/ GIMT_Encode4(1895235), // Rule ID 19186 //
     /* 1895154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1895157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1895171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1895174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895200 */     // MIs[0] policy
     /* 1895200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895210 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1895213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895234 */     // GIR_Coverage, 19186,
     /* 1895234 */     GIR_EraseRootFromParent_Done,
     /* 1895235 */   // Label 25545: @1895235
     /* 1895235 */   GIM_Try, /*On fail goto*//*Label 25546*/ GIMT_Encode4(1895321), // Rule ID 19187 //
     /* 1895240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1895243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1895257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1895260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895286 */     // MIs[0] policy
     /* 1895286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895296 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1895299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895320 */     // GIR_Coverage, 19187,
     /* 1895320 */     GIR_EraseRootFromParent_Done,
     /* 1895321 */   // Label 25546: @1895321
     /* 1895321 */   GIM_Try, /*On fail goto*//*Label 25547*/ GIMT_Encode4(1895407), // Rule ID 19190 //
     /* 1895326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1895337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1895340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1895343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1895346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895372 */     // MIs[0] policy
     /* 1895372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895382 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1895385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895406 */     // GIR_Coverage, 19190,
     /* 1895406 */     GIR_EraseRootFromParent_Done,
     /* 1895407 */   // Label 25547: @1895407
     /* 1895407 */   GIM_Try, /*On fail goto*//*Label 25548*/ GIMT_Encode4(1895493), // Rule ID 19191 //
     /* 1895412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1895423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1895426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1895429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1895432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895458 */     // MIs[0] policy
     /* 1895458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895468 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1895471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895492 */     // GIR_Coverage, 19191,
     /* 1895492 */     GIR_EraseRootFromParent_Done,
     /* 1895493 */   // Label 25548: @1895493
     /* 1895493 */   GIM_Try, /*On fail goto*//*Label 25549*/ GIMT_Encode4(1895579), // Rule ID 19194 //
     /* 1895498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1895501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1895509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1895512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1895515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1895518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895544 */     // MIs[0] policy
     /* 1895544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895554 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1895557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895578 */     // GIR_Coverage, 19194,
     /* 1895578 */     GIR_EraseRootFromParent_Done,
     /* 1895579 */   // Label 25549: @1895579
     /* 1895579 */   GIM_Try, /*On fail goto*//*Label 25550*/ GIMT_Encode4(1895665), // Rule ID 19195 //
     /* 1895584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1895587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1895595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1895598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1895601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1895604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895630 */     // MIs[0] policy
     /* 1895630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895640 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1895643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895664 */     // GIR_Coverage, 19195,
     /* 1895664 */     GIR_EraseRootFromParent_Done,
     /* 1895665 */   // Label 25550: @1895665
     /* 1895665 */   GIM_Try, /*On fail goto*//*Label 25551*/ GIMT_Encode4(1895751), // Rule ID 19198 //
     /* 1895670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1895673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1895681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1895684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1895687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1895690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895716 */     // MIs[0] policy
     /* 1895716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895726 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1895729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895750 */     // GIR_Coverage, 19198,
     /* 1895750 */     GIR_EraseRootFromParent_Done,
     /* 1895751 */   // Label 25551: @1895751
     /* 1895751 */   GIM_Try, /*On fail goto*//*Label 25552*/ GIMT_Encode4(1895837), // Rule ID 19199 //
     /* 1895756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1895759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1895767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1895770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1895773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1895776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895802 */     // MIs[0] policy
     /* 1895802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895812 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1895815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895836 */     // GIR_Coverage, 19199,
     /* 1895836 */     GIR_EraseRootFromParent_Done,
     /* 1895837 */   // Label 25552: @1895837
     /* 1895837 */   GIM_Try, /*On fail goto*//*Label 25553*/ GIMT_Encode4(1895923), // Rule ID 19202 //
     /* 1895842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1895853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1895856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1895859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1895862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1895872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895888 */     // MIs[0] policy
     /* 1895888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895898 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1895901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895922 */     // GIR_Coverage, 19202,
     /* 1895922 */     GIR_EraseRootFromParent_Done,
     /* 1895923 */   // Label 25553: @1895923
     /* 1895923 */   GIM_Try, /*On fail goto*//*Label 25554*/ GIMT_Encode4(1896009), // Rule ID 19203 //
     /* 1895928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1895939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1895942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1895945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1895948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1895958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895974 */     // MIs[0] policy
     /* 1895974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895984 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1895987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896008 */     // GIR_Coverage, 19203,
     /* 1896008 */     GIR_EraseRootFromParent_Done,
     /* 1896009 */   // Label 25554: @1896009
     /* 1896009 */   GIM_Try, /*On fail goto*//*Label 25555*/ GIMT_Encode4(1896095), // Rule ID 19206 //
     /* 1896014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1896025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1896028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1896031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1896034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896060 */     // MIs[0] policy
     /* 1896060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896070 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1896073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896094 */     // GIR_Coverage, 19206,
     /* 1896094 */     GIR_EraseRootFromParent_Done,
     /* 1896095 */   // Label 25555: @1896095
     /* 1896095 */   GIM_Try, /*On fail goto*//*Label 25556*/ GIMT_Encode4(1896181), // Rule ID 19207 //
     /* 1896100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1896111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1896114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1896117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1896120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896146 */     // MIs[0] policy
     /* 1896146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896156 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1896159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896180 */     // GIR_Coverage, 19207,
     /* 1896180 */     GIR_EraseRootFromParent_Done,
     /* 1896181 */   // Label 25556: @1896181
     /* 1896181 */   GIM_Try, /*On fail goto*//*Label 25557*/ GIMT_Encode4(1896267), // Rule ID 19210 //
     /* 1896186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1896197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1896200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1896203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1896206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896232 */     // MIs[0] policy
     /* 1896232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896242 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1896245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896266 */     // GIR_Coverage, 19210,
     /* 1896266 */     GIR_EraseRootFromParent_Done,
     /* 1896267 */   // Label 25557: @1896267
     /* 1896267 */   GIM_Try, /*On fail goto*//*Label 25558*/ GIMT_Encode4(1896353), // Rule ID 19211 //
     /* 1896272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1896283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1896286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1896289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1896292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896318 */     // MIs[0] policy
     /* 1896318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896328 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1896331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896352 */     // GIR_Coverage, 19211,
     /* 1896352 */     GIR_EraseRootFromParent_Done,
     /* 1896353 */   // Label 25558: @1896353
     /* 1896353 */   GIM_Try, /*On fail goto*//*Label 25559*/ GIMT_Encode4(1896439), // Rule ID 19214 //
     /* 1896358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1896369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1896372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1896375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1896378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896404 */     // MIs[0] policy
     /* 1896404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896414 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1896417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896438 */     // GIR_Coverage, 19214,
     /* 1896438 */     GIR_EraseRootFromParent_Done,
     /* 1896439 */   // Label 25559: @1896439
     /* 1896439 */   GIM_Try, /*On fail goto*//*Label 25560*/ GIMT_Encode4(1896525), // Rule ID 19215 //
     /* 1896444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1896455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1896458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1896461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1896464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896490 */     // MIs[0] policy
     /* 1896490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896500 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1896503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896524 */     // GIR_Coverage, 19215,
     /* 1896524 */     GIR_EraseRootFromParent_Done,
     /* 1896525 */   // Label 25560: @1896525
     /* 1896525 */   GIM_Try, /*On fail goto*//*Label 25561*/ GIMT_Encode4(1896611), // Rule ID 19218 //
     /* 1896530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1896541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1896544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1896547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1896550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896576 */     // MIs[0] policy
     /* 1896576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896586 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1896589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896610 */     // GIR_Coverage, 19218,
     /* 1896610 */     GIR_EraseRootFromParent_Done,
     /* 1896611 */   // Label 25561: @1896611
     /* 1896611 */   GIM_Try, /*On fail goto*//*Label 25562*/ GIMT_Encode4(1896697), // Rule ID 19219 //
     /* 1896616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1896627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1896630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1896633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1896636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896662 */     // MIs[0] policy
     /* 1896662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896672 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1896675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896696 */     // GIR_Coverage, 19219,
     /* 1896696 */     GIR_EraseRootFromParent_Done,
     /* 1896697 */   // Label 25562: @1896697
     /* 1896697 */   GIM_Try, /*On fail goto*//*Label 25563*/ GIMT_Encode4(1896783), // Rule ID 19222 //
     /* 1896702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1896713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1896716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1896719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1896722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896748 */     // MIs[0] policy
     /* 1896748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896758 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1896761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896782 */     // GIR_Coverage, 19222,
     /* 1896782 */     GIR_EraseRootFromParent_Done,
     /* 1896783 */   // Label 25563: @1896783
     /* 1896783 */   GIM_Try, /*On fail goto*//*Label 25564*/ GIMT_Encode4(1896869), // Rule ID 19223 //
     /* 1896788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1896799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1896802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1896805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1896808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896834 */     // MIs[0] policy
     /* 1896834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896844 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1896847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896868 */     // GIR_Coverage, 19223,
     /* 1896868 */     GIR_EraseRootFromParent_Done,
     /* 1896869 */   // Label 25564: @1896869
     /* 1896869 */   GIM_Try, /*On fail goto*//*Label 25565*/ GIMT_Encode4(1896955), // Rule ID 19226 //
     /* 1896874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1896877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1896885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1896888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1896891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1896894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1896897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896920 */     // MIs[0] policy
     /* 1896920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896930 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1896933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1896951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896954 */     // GIR_Coverage, 19226,
     /* 1896954 */     GIR_EraseRootFromParent_Done,
     /* 1896955 */   // Label 25565: @1896955
     /* 1896955 */   GIM_Try, /*On fail goto*//*Label 25566*/ GIMT_Encode4(1897041), // Rule ID 19227 //
     /* 1896960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1896963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1896971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1896974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1896977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1896980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1896983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897006 */     // MIs[0] policy
     /* 1897006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897016 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1897019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897040 */     // GIR_Coverage, 19227,
     /* 1897040 */     GIR_EraseRootFromParent_Done,
     /* 1897041 */   // Label 25566: @1897041
     /* 1897041 */   GIM_Try, /*On fail goto*//*Label 25567*/ GIMT_Encode4(1897127), // Rule ID 19230 //
     /* 1897046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1897049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1897057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1897060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1897063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1897066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897092 */     // MIs[0] policy
     /* 1897092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1897105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897126 */     // GIR_Coverage, 19230,
     /* 1897126 */     GIR_EraseRootFromParent_Done,
     /* 1897127 */   // Label 25567: @1897127
     /* 1897127 */   GIM_Try, /*On fail goto*//*Label 25568*/ GIMT_Encode4(1897213), // Rule ID 19231 //
     /* 1897132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1897135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1897143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1897146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1897149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1897152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897178 */     // MIs[0] policy
     /* 1897178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897188 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1897191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897212 */     // GIR_Coverage, 19231,
     /* 1897212 */     GIR_EraseRootFromParent_Done,
     /* 1897213 */   // Label 25568: @1897213
     /* 1897213 */   GIM_Try, /*On fail goto*//*Label 25569*/ GIMT_Encode4(1897299), // Rule ID 19234 //
     /* 1897218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1897221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1897229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1897232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1897235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1897238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897264 */     // MIs[0] policy
     /* 1897264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897274 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1897277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897298 */     // GIR_Coverage, 19234,
     /* 1897298 */     GIR_EraseRootFromParent_Done,
     /* 1897299 */   // Label 25569: @1897299
     /* 1897299 */   GIM_Try, /*On fail goto*//*Label 25570*/ GIMT_Encode4(1897385), // Rule ID 19235 //
     /* 1897304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1897307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1897315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1897318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1897321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1897324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897350 */     // MIs[0] policy
     /* 1897350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897360 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1897363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897384 */     // GIR_Coverage, 19235,
     /* 1897384 */     GIR_EraseRootFromParent_Done,
     /* 1897385 */   // Label 25570: @1897385
     /* 1897385 */   GIM_Try, /*On fail goto*//*Label 25571*/ GIMT_Encode4(1897471), // Rule ID 19238 //
     /* 1897390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1897393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1897401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1897404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1897407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897436 */     // MIs[0] policy
     /* 1897436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897446 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1897449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897470 */     // GIR_Coverage, 19238,
     /* 1897470 */     GIR_EraseRootFromParent_Done,
     /* 1897471 */   // Label 25571: @1897471
     /* 1897471 */   GIM_Try, /*On fail goto*//*Label 25572*/ GIMT_Encode4(1897557), // Rule ID 19239 //
     /* 1897476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1897479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1897487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1897490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1897493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897522 */     // MIs[0] policy
     /* 1897522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897532 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1897535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897556 */     // GIR_Coverage, 19239,
     /* 1897556 */     GIR_EraseRootFromParent_Done,
     /* 1897557 */   // Label 25572: @1897557
     /* 1897557 */   GIM_Try, /*On fail goto*//*Label 25573*/ GIMT_Encode4(1897643), // Rule ID 19242 //
     /* 1897562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1897565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1897573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1897576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1897579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1897585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897608 */     // MIs[0] policy
     /* 1897608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897618 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1897621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897642 */     // GIR_Coverage, 19242,
     /* 1897642 */     GIR_EraseRootFromParent_Done,
     /* 1897643 */   // Label 25573: @1897643
     /* 1897643 */   GIM_Try, /*On fail goto*//*Label 25574*/ GIMT_Encode4(1897729), // Rule ID 19243 //
     /* 1897648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1897651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1897659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1897662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1897665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1897671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897694 */     // MIs[0] policy
     /* 1897694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897704 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1897707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897728 */     // GIR_Coverage, 19243,
     /* 1897728 */     GIR_EraseRootFromParent_Done,
     /* 1897729 */   // Label 25574: @1897729
     /* 1897729 */   GIM_Try, /*On fail goto*//*Label 25575*/ GIMT_Encode4(1897815), // Rule ID 19246 //
     /* 1897734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1897737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1897745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1897748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1897751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1897776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897780 */     // MIs[0] policy
     /* 1897780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897790 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1897793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897814 */     // GIR_Coverage, 19246,
     /* 1897814 */     GIR_EraseRootFromParent_Done,
     /* 1897815 */   // Label 25575: @1897815
     /* 1897815 */   GIM_Try, /*On fail goto*//*Label 25576*/ GIMT_Encode4(1897901), // Rule ID 19247 //
     /* 1897820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1897823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1897831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1897834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1897837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1897862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897866 */     // MIs[0] policy
     /* 1897866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897876 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1897879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897900 */     // GIR_Coverage, 19247,
     /* 1897900 */     GIR_EraseRootFromParent_Done,
     /* 1897901 */   // Label 25576: @1897901
     /* 1897901 */   GIM_Try, /*On fail goto*//*Label 25577*/ GIMT_Encode4(1897987), // Rule ID 19250 //
     /* 1897906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1897909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1897917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1897920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1897923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897952 */     // MIs[0] policy
     /* 1897952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897962 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1897965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897986 */     // GIR_Coverage, 19250,
     /* 1897986 */     GIR_EraseRootFromParent_Done,
     /* 1897987 */   // Label 25577: @1897987
     /* 1897987 */   GIM_Try, /*On fail goto*//*Label 25578*/ GIMT_Encode4(1898073), // Rule ID 19251 //
     /* 1897992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1897995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1898003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1898006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1898009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898038 */     // MIs[0] policy
     /* 1898038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898048 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1898051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898072 */     // GIR_Coverage, 19251,
     /* 1898072 */     GIR_EraseRootFromParent_Done,
     /* 1898073 */   // Label 25578: @1898073
     /* 1898073 */   GIM_Try, /*On fail goto*//*Label 25579*/ GIMT_Encode4(1898159), // Rule ID 19254 //
     /* 1898078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1898081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1898089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1898092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1898095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898124 */     // MIs[0] policy
     /* 1898124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898134 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1898137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898158 */     // GIR_Coverage, 19254,
     /* 1898158 */     GIR_EraseRootFromParent_Done,
     /* 1898159 */   // Label 25579: @1898159
     /* 1898159 */   GIM_Try, /*On fail goto*//*Label 25580*/ GIMT_Encode4(1898245), // Rule ID 19255 //
     /* 1898164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1898167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1898175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1898178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1898181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898210 */     // MIs[0] policy
     /* 1898210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898220 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1898223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898244 */     // GIR_Coverage, 19255,
     /* 1898244 */     GIR_EraseRootFromParent_Done,
     /* 1898245 */   // Label 25580: @1898245
     /* 1898245 */   GIM_Try, /*On fail goto*//*Label 25581*/ GIMT_Encode4(1898331), // Rule ID 19258 //
     /* 1898250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1898253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1898261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1898264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1898267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898296 */     // MIs[0] policy
     /* 1898296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898306 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1898309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898330 */     // GIR_Coverage, 19258,
     /* 1898330 */     GIR_EraseRootFromParent_Done,
     /* 1898331 */   // Label 25581: @1898331
     /* 1898331 */   GIM_Try, /*On fail goto*//*Label 25582*/ GIMT_Encode4(1898417), // Rule ID 19259 //
     /* 1898336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1898339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1898347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1898350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1898353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898382 */     // MIs[0] policy
     /* 1898382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898392 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1898395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898416 */     // GIR_Coverage, 19259,
     /* 1898416 */     GIR_EraseRootFromParent_Done,
     /* 1898417 */   // Label 25582: @1898417
     /* 1898417 */   GIM_Try, /*On fail goto*//*Label 25583*/ GIMT_Encode4(1898503), // Rule ID 19262 //
     /* 1898422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1898433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1898436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1898439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898468 */     // MIs[0] policy
     /* 1898468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898478 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1898481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898502 */     // GIR_Coverage, 19262,
     /* 1898502 */     GIR_EraseRootFromParent_Done,
     /* 1898503 */   // Label 25583: @1898503
     /* 1898503 */   GIM_Try, /*On fail goto*//*Label 25584*/ GIMT_Encode4(1898589), // Rule ID 19263 //
     /* 1898508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1898519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1898522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1898525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898554 */     // MIs[0] policy
     /* 1898554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898564 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1898567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898588 */     // GIR_Coverage, 19263,
     /* 1898588 */     GIR_EraseRootFromParent_Done,
     /* 1898589 */   // Label 25584: @1898589
     /* 1898589 */   GIM_Try, /*On fail goto*//*Label 25585*/ GIMT_Encode4(1898675), // Rule ID 19266 //
     /* 1898594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1898605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1898608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1898611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1898617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1898624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898640 */     // MIs[0] policy
     /* 1898640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898650 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1898653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898674 */     // GIR_Coverage, 19266,
     /* 1898674 */     GIR_EraseRootFromParent_Done,
     /* 1898675 */   // Label 25585: @1898675
     /* 1898675 */   GIM_Try, /*On fail goto*//*Label 25586*/ GIMT_Encode4(1898761), // Rule ID 19267 //
     /* 1898680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1898691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1898694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1898697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1898703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1898710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898726 */     // MIs[0] policy
     /* 1898726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898736 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1898739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898760 */     // GIR_Coverage, 19267,
     /* 1898760 */     GIR_EraseRootFromParent_Done,
     /* 1898761 */   // Label 25586: @1898761
     /* 1898761 */   GIM_Try, /*On fail goto*//*Label 25587*/ GIMT_Encode4(1898847), // Rule ID 19270 //
     /* 1898766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1898777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1898780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1898783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1898789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1898796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898812 */     // MIs[0] policy
     /* 1898812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898822 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1898825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898846 */     // GIR_Coverage, 19270,
     /* 1898846 */     GIR_EraseRootFromParent_Done,
     /* 1898847 */   // Label 25587: @1898847
     /* 1898847 */   GIM_Try, /*On fail goto*//*Label 25588*/ GIMT_Encode4(1898933), // Rule ID 19271 //
     /* 1898852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1898863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1898866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1898869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1898875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1898882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898898 */     // MIs[0] policy
     /* 1898898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898908 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1898911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898932 */     // GIR_Coverage, 19271,
     /* 1898932 */     GIR_EraseRootFromParent_Done,
     /* 1898933 */   // Label 25588: @1898933
     /* 1898933 */   GIM_Try, /*On fail goto*//*Label 25589*/ GIMT_Encode4(1899019), // Rule ID 19274 //
     /* 1898938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1898941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1898949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1898952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1898955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898984 */     // MIs[0] policy
     /* 1898984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898994 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1898997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899018 */     // GIR_Coverage, 19274,
     /* 1899018 */     GIR_EraseRootFromParent_Done,
     /* 1899019 */   // Label 25589: @1899019
     /* 1899019 */   GIM_Try, /*On fail goto*//*Label 25590*/ GIMT_Encode4(1899105), // Rule ID 19275 //
     /* 1899024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1899035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1899038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1899041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899070 */     // MIs[0] policy
     /* 1899070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899080 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1899083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899104 */     // GIR_Coverage, 19275,
     /* 1899104 */     GIR_EraseRootFromParent_Done,
     /* 1899105 */   // Label 25590: @1899105
     /* 1899105 */   GIM_Try, /*On fail goto*//*Label 25591*/ GIMT_Encode4(1899191), // Rule ID 19278 //
     /* 1899110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1899121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1899124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1899127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899156 */     // MIs[0] policy
     /* 1899156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899166 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1899169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899190 */     // GIR_Coverage, 19278,
     /* 1899190 */     GIR_EraseRootFromParent_Done,
     /* 1899191 */   // Label 25591: @1899191
     /* 1899191 */   GIM_Try, /*On fail goto*//*Label 25592*/ GIMT_Encode4(1899277), // Rule ID 19279 //
     /* 1899196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1899207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1899210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1899213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899242 */     // MIs[0] policy
     /* 1899242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899252 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1899255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899276 */     // GIR_Coverage, 19279,
     /* 1899276 */     GIR_EraseRootFromParent_Done,
     /* 1899277 */   // Label 25592: @1899277
     /* 1899277 */   GIM_Try, /*On fail goto*//*Label 25593*/ GIMT_Encode4(1899363), // Rule ID 19282 //
     /* 1899282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1899293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1899296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1899299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899328 */     // MIs[0] policy
     /* 1899328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899338 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1899341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899362 */     // GIR_Coverage, 19282,
     /* 1899362 */     GIR_EraseRootFromParent_Done,
     /* 1899363 */   // Label 25593: @1899363
     /* 1899363 */   GIM_Try, /*On fail goto*//*Label 25594*/ GIMT_Encode4(1899449), // Rule ID 19283 //
     /* 1899368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1899379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1899382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1899385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899414 */     // MIs[0] policy
     /* 1899414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899424 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1899427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899448 */     // GIR_Coverage, 19283,
     /* 1899448 */     GIR_EraseRootFromParent_Done,
     /* 1899449 */   // Label 25594: @1899449
     /* 1899449 */   GIM_Try, /*On fail goto*//*Label 25595*/ GIMT_Encode4(1899535), // Rule ID 19286 //
     /* 1899454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1899457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1899465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1899468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1899471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1899477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899500 */     // MIs[0] policy
     /* 1899500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899510 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1899513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899534 */     // GIR_Coverage, 19286,
     /* 1899534 */     GIR_EraseRootFromParent_Done,
     /* 1899535 */   // Label 25595: @1899535
     /* 1899535 */   GIM_Try, /*On fail goto*//*Label 25596*/ GIMT_Encode4(1899621), // Rule ID 19287 //
     /* 1899540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1899543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1899551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1899554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1899557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1899563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899586 */     // MIs[0] policy
     /* 1899586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899596 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1899599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899620 */     // GIR_Coverage, 19287,
     /* 1899620 */     GIR_EraseRootFromParent_Done,
     /* 1899621 */   // Label 25596: @1899621
     /* 1899621 */   GIM_Try, /*On fail goto*//*Label 25597*/ GIMT_Encode4(1899707), // Rule ID 19290 //
     /* 1899626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1899629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1899637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1899640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1899643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899672 */     // MIs[0] policy
     /* 1899672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899682 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1899685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899706 */     // GIR_Coverage, 19290,
     /* 1899706 */     GIR_EraseRootFromParent_Done,
     /* 1899707 */   // Label 25597: @1899707
     /* 1899707 */   GIM_Try, /*On fail goto*//*Label 25598*/ GIMT_Encode4(1899793), // Rule ID 19291 //
     /* 1899712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1899715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1899723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1899726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1899729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899758 */     // MIs[0] policy
     /* 1899758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899768 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1899771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899792 */     // GIR_Coverage, 19291,
     /* 1899792 */     GIR_EraseRootFromParent_Done,
     /* 1899793 */   // Label 25598: @1899793
     /* 1899793 */   GIM_Try, /*On fail goto*//*Label 25599*/ GIMT_Encode4(1899879), // Rule ID 19294 //
     /* 1899798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1899801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1899809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1899812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1899815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899844 */     // MIs[0] policy
     /* 1899844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899854 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1899857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899878 */     // GIR_Coverage, 19294,
     /* 1899878 */     GIR_EraseRootFromParent_Done,
     /* 1899879 */   // Label 25599: @1899879
     /* 1899879 */   GIM_Try, /*On fail goto*//*Label 25600*/ GIMT_Encode4(1899965), // Rule ID 19295 //
     /* 1899884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1899887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1899895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1899898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1899901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899930 */     // MIs[0] policy
     /* 1899930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899940 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1899943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899964 */     // GIR_Coverage, 19295,
     /* 1899964 */     GIR_EraseRootFromParent_Done,
     /* 1899965 */   // Label 25600: @1899965
     /* 1899965 */   GIM_Try, /*On fail goto*//*Label 25601*/ GIMT_Encode4(1900051), // Rule ID 19298 //
     /* 1899970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1899981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1899984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1899987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1899990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1899993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900016 */     // MIs[0] policy
     /* 1900016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900026 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1900029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900050 */     // GIR_Coverage, 19298,
     /* 1900050 */     GIR_EraseRootFromParent_Done,
     /* 1900051 */   // Label 25601: @1900051
     /* 1900051 */   GIM_Try, /*On fail goto*//*Label 25602*/ GIMT_Encode4(1900137), // Rule ID 19299 //
     /* 1900056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1900067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1900070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1900073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1900076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900102 */     // MIs[0] policy
     /* 1900102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900112 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1900115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900136 */     // GIR_Coverage, 19299,
     /* 1900136 */     GIR_EraseRootFromParent_Done,
     /* 1900137 */   // Label 25602: @1900137
     /* 1900137 */   GIM_Try, /*On fail goto*//*Label 25603*/ GIMT_Encode4(1900223), // Rule ID 19302 //
     /* 1900142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1900153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1900156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1900159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1900162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900188 */     // MIs[0] policy
     /* 1900188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900198 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1900201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900222 */     // GIR_Coverage, 19302,
     /* 1900222 */     GIR_EraseRootFromParent_Done,
     /* 1900223 */   // Label 25603: @1900223
     /* 1900223 */   GIM_Try, /*On fail goto*//*Label 25604*/ GIMT_Encode4(1900309), // Rule ID 19303 //
     /* 1900228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1900239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1900242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1900245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1900248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900274 */     // MIs[0] policy
     /* 1900274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900284 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1900287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900308 */     // GIR_Coverage, 19303,
     /* 1900308 */     GIR_EraseRootFromParent_Done,
     /* 1900309 */   // Label 25604: @1900309
     /* 1900309 */   GIM_Try, /*On fail goto*//*Label 25605*/ GIMT_Encode4(1900395), // Rule ID 19306 //
     /* 1900314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1900325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1900328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1900331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1900334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900360 */     // MIs[0] policy
     /* 1900360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900370 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1900373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900394 */     // GIR_Coverage, 19306,
     /* 1900394 */     GIR_EraseRootFromParent_Done,
     /* 1900395 */   // Label 25605: @1900395
     /* 1900395 */   GIM_Try, /*On fail goto*//*Label 25606*/ GIMT_Encode4(1900481), // Rule ID 19307 //
     /* 1900400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1900403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1900411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1900414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1900417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1900420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900446 */     // MIs[0] policy
     /* 1900446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900456 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1900459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900480 */     // GIR_Coverage, 19307,
     /* 1900480 */     GIR_EraseRootFromParent_Done,
     /* 1900481 */   // Label 25606: @1900481
     /* 1900481 */   GIM_Try, /*On fail goto*//*Label 25607*/ GIMT_Encode4(1900567), // Rule ID 19310 //
     /* 1900486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1900497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1900500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1900503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1900506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900532 */     // MIs[0] policy
     /* 1900532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900542 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1900545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900566 */     // GIR_Coverage, 19310,
     /* 1900566 */     GIR_EraseRootFromParent_Done,
     /* 1900567 */   // Label 25607: @1900567
     /* 1900567 */   GIM_Try, /*On fail goto*//*Label 25608*/ GIMT_Encode4(1900653), // Rule ID 19311 //
     /* 1900572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1900583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1900586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1900589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1900592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900618 */     // MIs[0] policy
     /* 1900618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900628 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1900631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900652 */     // GIR_Coverage, 19311,
     /* 1900652 */     GIR_EraseRootFromParent_Done,
     /* 1900653 */   // Label 25608: @1900653
     /* 1900653 */   GIM_Try, /*On fail goto*//*Label 25609*/ GIMT_Encode4(1900739), // Rule ID 19314 //
     /* 1900658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1900669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1900672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1900675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1900678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900704 */     // MIs[0] policy
     /* 1900704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900714 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1900717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900738 */     // GIR_Coverage, 19314,
     /* 1900738 */     GIR_EraseRootFromParent_Done,
     /* 1900739 */   // Label 25609: @1900739
     /* 1900739 */   GIM_Try, /*On fail goto*//*Label 25610*/ GIMT_Encode4(1900825), // Rule ID 19315 //
     /* 1900744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1900747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1900755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1900758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1900761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1900764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900790 */     // MIs[0] policy
     /* 1900790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900800 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1900803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900824 */     // GIR_Coverage, 19315,
     /* 1900824 */     GIR_EraseRootFromParent_Done,
     /* 1900825 */   // Label 25610: @1900825
     /* 1900825 */   GIM_Try, /*On fail goto*//*Label 25611*/ GIMT_Encode4(1900911), // Rule ID 19318 //
     /* 1900830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1900833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1900841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1900844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1900847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1900850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900876 */     // MIs[0] policy
     /* 1900876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900886 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1900889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900910 */     // GIR_Coverage, 19318,
     /* 1900910 */     GIR_EraseRootFromParent_Done,
     /* 1900911 */   // Label 25611: @1900911
     /* 1900911 */   GIM_Try, /*On fail goto*//*Label 25612*/ GIMT_Encode4(1900997), // Rule ID 19319 //
     /* 1900916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1900919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1900927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1900930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1900933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1900936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900962 */     // MIs[0] policy
     /* 1900962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900972 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1900975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900996 */     // GIR_Coverage, 19319,
     /* 1900996 */     GIR_EraseRootFromParent_Done,
     /* 1900997 */   // Label 25612: @1900997
     /* 1900997 */   GIM_Try, /*On fail goto*//*Label 25613*/ GIMT_Encode4(1901083), // Rule ID 19322 //
     /* 1901002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1901013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1901016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1901019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1901022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901048 */     // MIs[0] policy
     /* 1901048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901058 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1901061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901082 */     // GIR_Coverage, 19322,
     /* 1901082 */     GIR_EraseRootFromParent_Done,
     /* 1901083 */   // Label 25613: @1901083
     /* 1901083 */   GIM_Try, /*On fail goto*//*Label 25614*/ GIMT_Encode4(1901169), // Rule ID 19323 //
     /* 1901088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1901099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1901102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1901105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1901108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901134 */     // MIs[0] policy
     /* 1901134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901144 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1901147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901168 */     // GIR_Coverage, 19323,
     /* 1901168 */     GIR_EraseRootFromParent_Done,
     /* 1901169 */   // Label 25614: @1901169
     /* 1901169 */   GIM_Try, /*On fail goto*//*Label 25615*/ GIMT_Encode4(1901255), // Rule ID 19326 //
     /* 1901174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1901185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1901188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1901191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1901194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901220 */     // MIs[0] policy
     /* 1901220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901230 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1901233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901254 */     // GIR_Coverage, 19326,
     /* 1901254 */     GIR_EraseRootFromParent_Done,
     /* 1901255 */   // Label 25615: @1901255
     /* 1901255 */   GIM_Try, /*On fail goto*//*Label 25616*/ GIMT_Encode4(1901341), // Rule ID 19327 //
     /* 1901260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1901271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1901274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1901277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1901280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901306 */     // MIs[0] policy
     /* 1901306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901316 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1901319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901340 */     // GIR_Coverage, 19327,
     /* 1901340 */     GIR_EraseRootFromParent_Done,
     /* 1901341 */   // Label 25616: @1901341
     /* 1901341 */   GIM_Try, /*On fail goto*//*Label 25617*/ GIMT_Encode4(1901427), // Rule ID 19330 //
     /* 1901346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1901357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1901360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1901363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1901366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1901369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901392 */     // MIs[0] policy
     /* 1901392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901402 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1901405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901426 */     // GIR_Coverage, 19330,
     /* 1901426 */     GIR_EraseRootFromParent_Done,
     /* 1901427 */   // Label 25617: @1901427
     /* 1901427 */   GIM_Try, /*On fail goto*//*Label 25618*/ GIMT_Encode4(1901513), // Rule ID 19331 //
     /* 1901432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1901443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1901446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1901449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1901452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1901455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901478 */     // MIs[0] policy
     /* 1901478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901488 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1901491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901512 */     // GIR_Coverage, 19331,
     /* 1901512 */     GIR_EraseRootFromParent_Done,
     /* 1901513 */   // Label 25618: @1901513
     /* 1901513 */   GIM_Try, /*On fail goto*//*Label 25619*/ GIMT_Encode4(1901599), // Rule ID 19334 //
     /* 1901518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1901529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1901532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1901535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1901538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901564 */     // MIs[0] policy
     /* 1901564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901574 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1901577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901598 */     // GIR_Coverage, 19334,
     /* 1901598 */     GIR_EraseRootFromParent_Done,
     /* 1901599 */   // Label 25619: @1901599
     /* 1901599 */   GIM_Try, /*On fail goto*//*Label 25620*/ GIMT_Encode4(1901685), // Rule ID 19335 //
     /* 1901604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1901615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1901618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1901621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1901624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901650 */     // MIs[0] policy
     /* 1901650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901660 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1901663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901684 */     // GIR_Coverage, 19335,
     /* 1901684 */     GIR_EraseRootFromParent_Done,
     /* 1901685 */   // Label 25620: @1901685
     /* 1901685 */   GIM_Try, /*On fail goto*//*Label 25621*/ GIMT_Encode4(1901771), // Rule ID 19338 //
     /* 1901690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1901701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1901704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1901707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1901710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901736 */     // MIs[0] policy
     /* 1901736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901746 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1901749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901770 */     // GIR_Coverage, 19338,
     /* 1901770 */     GIR_EraseRootFromParent_Done,
     /* 1901771 */   // Label 25621: @1901771
     /* 1901771 */   GIM_Try, /*On fail goto*//*Label 25622*/ GIMT_Encode4(1901857), // Rule ID 19339 //
     /* 1901776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1901787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1901790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1901793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1901796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901822 */     // MIs[0] policy
     /* 1901822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901832 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1901835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901856 */     // GIR_Coverage, 19339,
     /* 1901856 */     GIR_EraseRootFromParent_Done,
     /* 1901857 */   // Label 25622: @1901857
     /* 1901857 */   GIM_Try, /*On fail goto*//*Label 25623*/ GIMT_Encode4(1901943), // Rule ID 19342 //
     /* 1901862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1901873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1901876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1901879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1901882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901908 */     // MIs[0] policy
     /* 1901908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901918 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1901921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901942 */     // GIR_Coverage, 19342,
     /* 1901942 */     GIR_EraseRootFromParent_Done,
     /* 1901943 */   // Label 25623: @1901943
     /* 1901943 */   GIM_Try, /*On fail goto*//*Label 25624*/ GIMT_Encode4(1902029), // Rule ID 19343 //
     /* 1901948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1901959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1901962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1901965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1901968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901994 */     // MIs[0] policy
     /* 1901994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902004 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1902007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902028 */     // GIR_Coverage, 19343,
     /* 1902028 */     GIR_EraseRootFromParent_Done,
     /* 1902029 */   // Label 25624: @1902029
     /* 1902029 */   GIM_Try, /*On fail goto*//*Label 25625*/ GIMT_Encode4(1902115), // Rule ID 19346 //
     /* 1902034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1902045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1902048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1902051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1902054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902080 */     // MIs[0] policy
     /* 1902080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902090 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1902093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902114 */     // GIR_Coverage, 19346,
     /* 1902114 */     GIR_EraseRootFromParent_Done,
     /* 1902115 */   // Label 25625: @1902115
     /* 1902115 */   GIM_Try, /*On fail goto*//*Label 25626*/ GIMT_Encode4(1902201), // Rule ID 19347 //
     /* 1902120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1902131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1902134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1902137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1902140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902166 */     // MIs[0] policy
     /* 1902166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902176 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1902179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902200 */     // GIR_Coverage, 19347,
     /* 1902200 */     GIR_EraseRootFromParent_Done,
     /* 1902201 */   // Label 25626: @1902201
     /* 1902201 */   GIM_Try, /*On fail goto*//*Label 25627*/ GIMT_Encode4(1902287), // Rule ID 19350 //
     /* 1902206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1902217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1902220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1902223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1902226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902252 */     // MIs[0] policy
     /* 1902252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902262 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1902265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902286 */     // GIR_Coverage, 19350,
     /* 1902286 */     GIR_EraseRootFromParent_Done,
     /* 1902287 */   // Label 25627: @1902287
     /* 1902287 */   GIM_Try, /*On fail goto*//*Label 25628*/ GIMT_Encode4(1902373), // Rule ID 19351 //
     /* 1902292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1902303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1902306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1902309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1902312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902338 */     // MIs[0] policy
     /* 1902338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902348 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1902351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902372 */     // GIR_Coverage, 19351,
     /* 1902372 */     GIR_EraseRootFromParent_Done,
     /* 1902373 */   // Label 25628: @1902373
     /* 1902373 */   GIM_Try, /*On fail goto*//*Label 25629*/ GIMT_Encode4(1902459), // Rule ID 19354 //
     /* 1902378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1902389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1902392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1902395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1902398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902424 */     // MIs[0] policy
     /* 1902424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902434 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1902437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902458 */     // GIR_Coverage, 19354,
     /* 1902458 */     GIR_EraseRootFromParent_Done,
     /* 1902459 */   // Label 25629: @1902459
     /* 1902459 */   GIM_Try, /*On fail goto*//*Label 25630*/ GIMT_Encode4(1902545), // Rule ID 19355 //
     /* 1902464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1902475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1902478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1902481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1902484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902510 */     // MIs[0] policy
     /* 1902510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902520 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1902523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902544 */     // GIR_Coverage, 19355,
     /* 1902544 */     GIR_EraseRootFromParent_Done,
     /* 1902545 */   // Label 25630: @1902545
     /* 1902545 */   GIM_Try, /*On fail goto*//*Label 25631*/ GIMT_Encode4(1902631), // Rule ID 19358 //
     /* 1902550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1902561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1902564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1902567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902596 */     // MIs[0] policy
     /* 1902596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902606 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1902609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902630 */     // GIR_Coverage, 19358,
     /* 1902630 */     GIR_EraseRootFromParent_Done,
     /* 1902631 */   // Label 25631: @1902631
     /* 1902631 */   GIM_Try, /*On fail goto*//*Label 25632*/ GIMT_Encode4(1902717), // Rule ID 19359 //
     /* 1902636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1902647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1902650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1902653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902682 */     // MIs[0] policy
     /* 1902682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902692 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1902695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902716 */     // GIR_Coverage, 19359,
     /* 1902716 */     GIR_EraseRootFromParent_Done,
     /* 1902717 */   // Label 25632: @1902717
     /* 1902717 */   GIM_Try, /*On fail goto*//*Label 25633*/ GIMT_Encode4(1902803), // Rule ID 19362 //
     /* 1902722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1902733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1902736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1902739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902768 */     // MIs[0] policy
     /* 1902768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902778 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1902781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902802 */     // GIR_Coverage, 19362,
     /* 1902802 */     GIR_EraseRootFromParent_Done,
     /* 1902803 */   // Label 25633: @1902803
     /* 1902803 */   GIM_Try, /*On fail goto*//*Label 25634*/ GIMT_Encode4(1902889), // Rule ID 19363 //
     /* 1902808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1902819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1902822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1902825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902854 */     // MIs[0] policy
     /* 1902854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902864 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1902867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902888 */     // GIR_Coverage, 19363,
     /* 1902888 */     GIR_EraseRootFromParent_Done,
     /* 1902889 */   // Label 25634: @1902889
     /* 1902889 */   GIM_Try, /*On fail goto*//*Label 25635*/ GIMT_Encode4(1902975), // Rule ID 19366 //
     /* 1902894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1902905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1902908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1902911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902940 */     // MIs[0] policy
     /* 1902940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902950 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1902953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902974 */     // GIR_Coverage, 19366,
     /* 1902974 */     GIR_EraseRootFromParent_Done,
     /* 1902975 */   // Label 25635: @1902975
     /* 1902975 */   GIM_Try, /*On fail goto*//*Label 25636*/ GIMT_Encode4(1903061), // Rule ID 19367 //
     /* 1902980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1902991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1902994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1902997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903026 */     // MIs[0] policy
     /* 1903026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903036 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1903039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903060 */     // GIR_Coverage, 19367,
     /* 1903060 */     GIR_EraseRootFromParent_Done,
     /* 1903061 */   // Label 25636: @1903061
     /* 1903061 */   GIM_Try, /*On fail goto*//*Label 25637*/ GIMT_Encode4(1903147), // Rule ID 19370 //
     /* 1903066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1903077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1903080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1903083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903112 */     // MIs[0] policy
     /* 1903112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903122 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1903125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903146 */     // GIR_Coverage, 19370,
     /* 1903146 */     GIR_EraseRootFromParent_Done,
     /* 1903147 */   // Label 25637: @1903147
     /* 1903147 */   GIM_Try, /*On fail goto*//*Label 25638*/ GIMT_Encode4(1903233), // Rule ID 19371 //
     /* 1903152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1903163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1903166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1903169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903198 */     // MIs[0] policy
     /* 1903198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903208 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1903211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903232 */     // GIR_Coverage, 19371,
     /* 1903232 */     GIR_EraseRootFromParent_Done,
     /* 1903233 */   // Label 25638: @1903233
     /* 1903233 */   GIM_Try, /*On fail goto*//*Label 25639*/ GIMT_Encode4(1903319), // Rule ID 19374 //
     /* 1903238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1903241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1903249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1903252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1903255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903284 */     // MIs[0] policy
     /* 1903284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903294 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1903297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903318 */     // GIR_Coverage, 19374,
     /* 1903318 */     GIR_EraseRootFromParent_Done,
     /* 1903319 */   // Label 25639: @1903319
     /* 1903319 */   GIM_Try, /*On fail goto*//*Label 25640*/ GIMT_Encode4(1903405), // Rule ID 19375 //
     /* 1903324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1903327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1903335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1903338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1903341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903370 */     // MIs[0] policy
     /* 1903370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903380 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1903383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903404 */     // GIR_Coverage, 19375,
     /* 1903404 */     GIR_EraseRootFromParent_Done,
     /* 1903405 */   // Label 25640: @1903405
     /* 1903405 */   GIM_Try, /*On fail goto*//*Label 25641*/ GIMT_Encode4(1903491), // Rule ID 19378 //
     /* 1903410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1903427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903456 */     // MIs[0] policy
     /* 1903456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903466 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1903469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903490 */     // GIR_Coverage, 19378,
     /* 1903490 */     GIR_EraseRootFromParent_Done,
     /* 1903491 */   // Label 25641: @1903491
     /* 1903491 */   GIM_Try, /*On fail goto*//*Label 25642*/ GIMT_Encode4(1903577), // Rule ID 19379 //
     /* 1903496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1903513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903542 */     // MIs[0] policy
     /* 1903542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903552 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1903555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903576 */     // GIR_Coverage, 19379,
     /* 1903576 */     GIR_EraseRootFromParent_Done,
     /* 1903577 */   // Label 25642: @1903577
     /* 1903577 */   GIM_Try, /*On fail goto*//*Label 25643*/ GIMT_Encode4(1903663), // Rule ID 19382 //
     /* 1903582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1903593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1903596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1903599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1903605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1903612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903628 */     // MIs[0] policy
     /* 1903628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903638 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1903641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903662 */     // GIR_Coverage, 19382,
     /* 1903662 */     GIR_EraseRootFromParent_Done,
     /* 1903663 */   // Label 25643: @1903663
     /* 1903663 */   GIM_Try, /*On fail goto*//*Label 25644*/ GIMT_Encode4(1903749), // Rule ID 19383 //
     /* 1903668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1903679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1903682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1903685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1903691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1903698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903714 */     // MIs[0] policy
     /* 1903714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903724 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1903727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903748 */     // GIR_Coverage, 19383,
     /* 1903748 */     GIR_EraseRootFromParent_Done,
     /* 1903749 */   // Label 25644: @1903749
     /* 1903749 */   GIM_Try, /*On fail goto*//*Label 25645*/ GIMT_Encode4(1903835), // Rule ID 19386 //
     /* 1903754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1903765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1903768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1903771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1903777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1903784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903800 */     // MIs[0] policy
     /* 1903800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903810 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1903813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903834 */     // GIR_Coverage, 19386,
     /* 1903834 */     GIR_EraseRootFromParent_Done,
     /* 1903835 */   // Label 25645: @1903835
     /* 1903835 */   GIM_Try, /*On fail goto*//*Label 25646*/ GIMT_Encode4(1903921), // Rule ID 19387 //
     /* 1903840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1903851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1903854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1903857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1903863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1903870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903886 */     // MIs[0] policy
     /* 1903886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903896 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1903899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903920 */     // GIR_Coverage, 19387,
     /* 1903920 */     GIR_EraseRootFromParent_Done,
     /* 1903921 */   // Label 25646: @1903921
     /* 1903921 */   GIM_Try, /*On fail goto*//*Label 25647*/ GIMT_Encode4(1904007), // Rule ID 19390 //
     /* 1903926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1903937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1903940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1903943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1903949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1903956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903972 */     // MIs[0] policy
     /* 1903972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903982 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1903985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904006 */     // GIR_Coverage, 19390,
     /* 1904006 */     GIR_EraseRootFromParent_Done,
     /* 1904007 */   // Label 25647: @1904007
     /* 1904007 */   GIM_Try, /*On fail goto*//*Label 25648*/ GIMT_Encode4(1904093), // Rule ID 19391 //
     /* 1904012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1904023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1904026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1904029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1904035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904058 */     // MIs[0] policy
     /* 1904058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904068 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1904071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904092 */     // GIR_Coverage, 19391,
     /* 1904092 */     GIR_EraseRootFromParent_Done,
     /* 1904093 */   // Label 25648: @1904093
     /* 1904093 */   GIM_Try, /*On fail goto*//*Label 25649*/ GIMT_Encode4(1904179), // Rule ID 19394 //
     /* 1904098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1904109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1904112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1904115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904144 */     // MIs[0] policy
     /* 1904144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904154 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1904157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904178 */     // GIR_Coverage, 19394,
     /* 1904178 */     GIR_EraseRootFromParent_Done,
     /* 1904179 */   // Label 25649: @1904179
     /* 1904179 */   GIM_Try, /*On fail goto*//*Label 25650*/ GIMT_Encode4(1904265), // Rule ID 19395 //
     /* 1904184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1904195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1904198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1904201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904230 */     // MIs[0] policy
     /* 1904230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904240 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1904243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904264 */     // GIR_Coverage, 19395,
     /* 1904264 */     GIR_EraseRootFromParent_Done,
     /* 1904265 */   // Label 25650: @1904265
     /* 1904265 */   GIM_Try, /*On fail goto*//*Label 25651*/ GIMT_Encode4(1904351), // Rule ID 19398 //
     /* 1904270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1904281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1904284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1904287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904316 */     // MIs[0] policy
     /* 1904316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904326 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1904329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904350 */     // GIR_Coverage, 19398,
     /* 1904350 */     GIR_EraseRootFromParent_Done,
     /* 1904351 */   // Label 25651: @1904351
     /* 1904351 */   GIM_Try, /*On fail goto*//*Label 25652*/ GIMT_Encode4(1904437), // Rule ID 19399 //
     /* 1904356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1904367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1904370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1904373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904402 */     // MIs[0] policy
     /* 1904402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904412 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1904415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904436 */     // GIR_Coverage, 19399,
     /* 1904436 */     GIR_EraseRootFromParent_Done,
     /* 1904437 */   // Label 25652: @1904437
     /* 1904437 */   GIM_Try, /*On fail goto*//*Label 25653*/ GIMT_Encode4(1904523), // Rule ID 19402 //
     /* 1904442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1904453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1904456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1904459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904488 */     // MIs[0] policy
     /* 1904488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904498 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1904501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904522 */     // GIR_Coverage, 19402,
     /* 1904522 */     GIR_EraseRootFromParent_Done,
     /* 1904523 */   // Label 25653: @1904523
     /* 1904523 */   GIM_Try, /*On fail goto*//*Label 25654*/ GIMT_Encode4(1904609), // Rule ID 19403 //
     /* 1904528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1904539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1904542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1904545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904574 */     // MIs[0] policy
     /* 1904574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904584 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1904587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904608 */     // GIR_Coverage, 19403,
     /* 1904608 */     GIR_EraseRootFromParent_Done,
     /* 1904609 */   // Label 25654: @1904609
     /* 1904609 */   GIM_Try, /*On fail goto*//*Label 25655*/ GIMT_Encode4(1904695), // Rule ID 19406 //
     /* 1904614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1904617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1904625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1904628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1904631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1904634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1904656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904660 */     // MIs[0] policy
     /* 1904660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904670 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1904673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904694 */     // GIR_Coverage, 19406,
     /* 1904694 */     GIR_EraseRootFromParent_Done,
     /* 1904695 */   // Label 25655: @1904695
     /* 1904695 */   GIM_Try, /*On fail goto*//*Label 25656*/ GIMT_Encode4(1904781), // Rule ID 19407 //
     /* 1904700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1904703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1904711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1904714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1904717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1904720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1904742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904746 */     // MIs[0] policy
     /* 1904746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904756 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1904759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904780 */     // GIR_Coverage, 19407,
     /* 1904780 */     GIR_EraseRootFromParent_Done,
     /* 1904781 */   // Label 25656: @1904781
     /* 1904781 */   GIM_Try, /*On fail goto*//*Label 25657*/ GIMT_Encode4(1904867), // Rule ID 19410 //
     /* 1904786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1904789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1904797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1904800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1904803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1904806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1904828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904832 */     // MIs[0] policy
     /* 1904832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904842 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1904845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904866 */     // GIR_Coverage, 19410,
     /* 1904866 */     GIR_EraseRootFromParent_Done,
     /* 1904867 */   // Label 25657: @1904867
     /* 1904867 */   GIM_Try, /*On fail goto*//*Label 25658*/ GIMT_Encode4(1904953), // Rule ID 19411 //
     /* 1904872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1904875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1904883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1904886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1904889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1904892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1904914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904918 */     // MIs[0] policy
     /* 1904918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904928 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1904931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904952 */     // GIR_Coverage, 19411,
     /* 1904952 */     GIR_EraseRootFromParent_Done,
     /* 1904953 */   // Label 25658: @1904953
     /* 1904953 */   GIM_Try, /*On fail goto*//*Label 25659*/ GIMT_Encode4(1905039), // Rule ID 19414 //
     /* 1904958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1904961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1904969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1904972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1904975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1904978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905004 */     // MIs[0] policy
     /* 1905004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905014 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1905017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905038 */     // GIR_Coverage, 19414,
     /* 1905038 */     GIR_EraseRootFromParent_Done,
     /* 1905039 */   // Label 25659: @1905039
     /* 1905039 */   GIM_Try, /*On fail goto*//*Label 25660*/ GIMT_Encode4(1905125), // Rule ID 19415 //
     /* 1905044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1905047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1905055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1905058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1905061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905090 */     // MIs[0] policy
     /* 1905090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905100 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1905103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905124 */     // GIR_Coverage, 19415,
     /* 1905124 */     GIR_EraseRootFromParent_Done,
     /* 1905125 */   // Label 25660: @1905125
     /* 1905125 */   GIM_Try, /*On fail goto*//*Label 25661*/ GIMT_Encode4(1905211), // Rule ID 19418 //
     /* 1905130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1905141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1905144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1905147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1905150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905176 */     // MIs[0] policy
     /* 1905176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905186 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1905189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905210 */     // GIR_Coverage, 19418,
     /* 1905210 */     GIR_EraseRootFromParent_Done,
     /* 1905211 */   // Label 25661: @1905211
     /* 1905211 */   GIM_Try, /*On fail goto*//*Label 25662*/ GIMT_Encode4(1905297), // Rule ID 19419 //
     /* 1905216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1905227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1905230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1905233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1905236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905262 */     // MIs[0] policy
     /* 1905262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905272 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1905275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905296 */     // GIR_Coverage, 19419,
     /* 1905296 */     GIR_EraseRootFromParent_Done,
     /* 1905297 */   // Label 25662: @1905297
     /* 1905297 */   GIM_Try, /*On fail goto*//*Label 25663*/ GIMT_Encode4(1905383), // Rule ID 19422 //
     /* 1905302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1905313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1905316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1905319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1905322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905348 */     // MIs[0] policy
     /* 1905348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905358 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1905361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905382 */     // GIR_Coverage, 19422,
     /* 1905382 */     GIR_EraseRootFromParent_Done,
     /* 1905383 */   // Label 25663: @1905383
     /* 1905383 */   GIM_Try, /*On fail goto*//*Label 25664*/ GIMT_Encode4(1905469), // Rule ID 19423 //
     /* 1905388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1905399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1905402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1905405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1905408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905434 */     // MIs[0] policy
     /* 1905434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905444 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1905447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905468 */     // GIR_Coverage, 19423,
     /* 1905468 */     GIR_EraseRootFromParent_Done,
     /* 1905469 */   // Label 25664: @1905469
     /* 1905469 */   GIM_Try, /*On fail goto*//*Label 25665*/ GIMT_Encode4(1905555), // Rule ID 19426 //
     /* 1905474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1905485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1905488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1905491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1905494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905520 */     // MIs[0] policy
     /* 1905520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905530 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1905533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905554 */     // GIR_Coverage, 19426,
     /* 1905554 */     GIR_EraseRootFromParent_Done,
     /* 1905555 */   // Label 25665: @1905555
     /* 1905555 */   GIM_Try, /*On fail goto*//*Label 25666*/ GIMT_Encode4(1905641), // Rule ID 19427 //
     /* 1905560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1905571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1905574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1905577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1905580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905606 */     // MIs[0] policy
     /* 1905606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905616 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1905619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905640 */     // GIR_Coverage, 19427,
     /* 1905640 */     GIR_EraseRootFromParent_Done,
     /* 1905641 */   // Label 25666: @1905641
     /* 1905641 */   GIM_Try, /*On fail goto*//*Label 25667*/ GIMT_Encode4(1905727), // Rule ID 19430 //
     /* 1905646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1905657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1905660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1905663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1905666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905692 */     // MIs[0] policy
     /* 1905692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905702 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1905705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905726 */     // GIR_Coverage, 19430,
     /* 1905726 */     GIR_EraseRootFromParent_Done,
     /* 1905727 */   // Label 25667: @1905727
     /* 1905727 */   GIM_Try, /*On fail goto*//*Label 25668*/ GIMT_Encode4(1905813), // Rule ID 19431 //
     /* 1905732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1905743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1905746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1905749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1905752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905778 */     // MIs[0] policy
     /* 1905778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905788 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1905791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905812 */     // GIR_Coverage, 19431,
     /* 1905812 */     GIR_EraseRootFromParent_Done,
     /* 1905813 */   // Label 25668: @1905813
     /* 1905813 */   GIM_Try, /*On fail goto*//*Label 25669*/ GIMT_Encode4(1905899), // Rule ID 19434 //
     /* 1905818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1905829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1905832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1905835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1905838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905864 */     // MIs[0] policy
     /* 1905864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905874 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1905877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905898 */     // GIR_Coverage, 19434,
     /* 1905898 */     GIR_EraseRootFromParent_Done,
     /* 1905899 */   // Label 25669: @1905899
     /* 1905899 */   GIM_Try, /*On fail goto*//*Label 25670*/ GIMT_Encode4(1905985), // Rule ID 19435 //
     /* 1905904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1905915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1905918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1905921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1905924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905950 */     // MIs[0] policy
     /* 1905950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905960 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1905963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905984 */     // GIR_Coverage, 19435,
     /* 1905984 */     GIR_EraseRootFromParent_Done,
     /* 1905985 */   // Label 25670: @1905985
     /* 1905985 */   GIM_Try, /*On fail goto*//*Label 25671*/ GIMT_Encode4(1906071), // Rule ID 19438 //
     /* 1905990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1906007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906036 */     // MIs[0] policy
     /* 1906036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906046 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1906049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906070 */     // GIR_Coverage, 19438,
     /* 1906070 */     GIR_EraseRootFromParent_Done,
     /* 1906071 */   // Label 25671: @1906071
     /* 1906071 */   GIM_Try, /*On fail goto*//*Label 25672*/ GIMT_Encode4(1906157), // Rule ID 19439 //
     /* 1906076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1906079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1906093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906122 */     // MIs[0] policy
     /* 1906122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906132 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1906135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906156 */     // GIR_Coverage, 19439,
     /* 1906156 */     GIR_EraseRootFromParent_Done,
     /* 1906157 */   // Label 25672: @1906157
     /* 1906157 */   GIM_Try, /*On fail goto*//*Label 25673*/ GIMT_Encode4(1906243), // Rule ID 19442 //
     /* 1906162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1906173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1906176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1906179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1906182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906208 */     // MIs[0] policy
     /* 1906208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906218 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1906221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906242 */     // GIR_Coverage, 19442,
     /* 1906242 */     GIR_EraseRootFromParent_Done,
     /* 1906243 */   // Label 25673: @1906243
     /* 1906243 */   GIM_Try, /*On fail goto*//*Label 25674*/ GIMT_Encode4(1906329), // Rule ID 19443 //
     /* 1906248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1906259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1906262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1906265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1906268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906294 */     // MIs[0] policy
     /* 1906294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906304 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1906307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906328 */     // GIR_Coverage, 19443,
     /* 1906328 */     GIR_EraseRootFromParent_Done,
     /* 1906329 */   // Label 25674: @1906329
     /* 1906329 */   GIM_Try, /*On fail goto*//*Label 25675*/ GIMT_Encode4(1906415), // Rule ID 19446 //
     /* 1906334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1906345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1906348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1906351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1906354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1906357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906380 */     // MIs[0] policy
     /* 1906380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906390 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1906393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906414 */     // GIR_Coverage, 19446,
     /* 1906414 */     GIR_EraseRootFromParent_Done,
     /* 1906415 */   // Label 25675: @1906415
     /* 1906415 */   GIM_Try, /*On fail goto*//*Label 25676*/ GIMT_Encode4(1906501), // Rule ID 19447 //
     /* 1906420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1906431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1906434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1906437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1906440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1906443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906466 */     // MIs[0] policy
     /* 1906466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906476 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1906479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906500 */     // GIR_Coverage, 19447,
     /* 1906500 */     GIR_EraseRootFromParent_Done,
     /* 1906501 */   // Label 25676: @1906501
     /* 1906501 */   GIM_Try, /*On fail goto*//*Label 25677*/ GIMT_Encode4(1906587), // Rule ID 19450 //
     /* 1906506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1906517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1906520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1906523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1906526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1906529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1906536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906552 */     // MIs[0] policy
     /* 1906552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906562 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1906565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906586 */     // GIR_Coverage, 19450,
     /* 1906586 */     GIR_EraseRootFromParent_Done,
     /* 1906587 */   // Label 25677: @1906587
     /* 1906587 */   GIM_Try, /*On fail goto*//*Label 25678*/ GIMT_Encode4(1906673), // Rule ID 19451 //
     /* 1906592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1906603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1906606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1906609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1906612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1906615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1906622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906638 */     // MIs[0] policy
     /* 1906638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906648 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1906651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906672 */     // GIR_Coverage, 19451,
     /* 1906672 */     GIR_EraseRootFromParent_Done,
     /* 1906673 */   // Label 25678: @1906673
     /* 1906673 */   GIM_Try, /*On fail goto*//*Label 25679*/ GIMT_Encode4(1906759), // Rule ID 19454 //
     /* 1906678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1906681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1906689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1906692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1906695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1906698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906724 */     // MIs[0] policy
     /* 1906724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906734 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1906737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906758 */     // GIR_Coverage, 19454,
     /* 1906758 */     GIR_EraseRootFromParent_Done,
     /* 1906759 */   // Label 25679: @1906759
     /* 1906759 */   GIM_Try, /*On fail goto*//*Label 25680*/ GIMT_Encode4(1906845), // Rule ID 19455 //
     /* 1906764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1906767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1906775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1906778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1906781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1906784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906810 */     // MIs[0] policy
     /* 1906810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906820 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1906823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906844 */     // GIR_Coverage, 19455,
     /* 1906844 */     GIR_EraseRootFromParent_Done,
     /* 1906845 */   // Label 25680: @1906845
     /* 1906845 */   GIM_Try, /*On fail goto*//*Label 25681*/ GIMT_Encode4(1906931), // Rule ID 19458 //
     /* 1906850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1906853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1906861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1906864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1906867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1906870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906896 */     // MIs[0] policy
     /* 1906896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906906 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1906909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906930 */     // GIR_Coverage, 19458,
     /* 1906930 */     GIR_EraseRootFromParent_Done,
     /* 1906931 */   // Label 25681: @1906931
     /* 1906931 */   GIM_Try, /*On fail goto*//*Label 25682*/ GIMT_Encode4(1907017), // Rule ID 19459 //
     /* 1906936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1906939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1906947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1906950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1906953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1906956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906982 */     // MIs[0] policy
     /* 1906982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906992 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1906995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907016 */     // GIR_Coverage, 19459,
     /* 1907016 */     GIR_EraseRootFromParent_Done,
     /* 1907017 */   // Label 25682: @1907017
     /* 1907017 */   GIM_Try, /*On fail goto*//*Label 25683*/ GIMT_Encode4(1907103), // Rule ID 19462 //
     /* 1907022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1907033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1907036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1907039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1907042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907068 */     // MIs[0] policy
     /* 1907068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907078 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1907081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907102 */     // GIR_Coverage, 19462,
     /* 1907102 */     GIR_EraseRootFromParent_Done,
     /* 1907103 */   // Label 25683: @1907103
     /* 1907103 */   GIM_Try, /*On fail goto*//*Label 25684*/ GIMT_Encode4(1907189), // Rule ID 19463 //
     /* 1907108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1907119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1907122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1907125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1907128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907154 */     // MIs[0] policy
     /* 1907154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907164 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1907167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907188 */     // GIR_Coverage, 19463,
     /* 1907188 */     GIR_EraseRootFromParent_Done,
     /* 1907189 */   // Label 25684: @1907189
     /* 1907189 */   GIM_Try, /*On fail goto*//*Label 25685*/ GIMT_Encode4(1907275), // Rule ID 19466 //
     /* 1907194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1907205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1907208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1907211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1907214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907240 */     // MIs[0] policy
     /* 1907240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1907253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907274 */     // GIR_Coverage, 19466,
     /* 1907274 */     GIR_EraseRootFromParent_Done,
     /* 1907275 */   // Label 25685: @1907275
     /* 1907275 */   GIM_Try, /*On fail goto*//*Label 25686*/ GIMT_Encode4(1907361), // Rule ID 19467 //
     /* 1907280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1907291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1907294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1907297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1907300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907326 */     // MIs[0] policy
     /* 1907326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907336 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1907339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907360 */     // GIR_Coverage, 19467,
     /* 1907360 */     GIR_EraseRootFromParent_Done,
     /* 1907361 */   // Label 25686: @1907361
     /* 1907361 */   GIM_Try, /*On fail goto*//*Label 25687*/ GIMT_Encode4(1907447), // Rule ID 19470 //
     /* 1907366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1907377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1907380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1907383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1907386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907412 */     // MIs[0] policy
     /* 1907412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907422 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1907425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907446 */     // GIR_Coverage, 19470,
     /* 1907446 */     GIR_EraseRootFromParent_Done,
     /* 1907447 */   // Label 25687: @1907447
     /* 1907447 */   GIM_Try, /*On fail goto*//*Label 25688*/ GIMT_Encode4(1907533), // Rule ID 19471 //
     /* 1907452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1907463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1907466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1907469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1907472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907498 */     // MIs[0] policy
     /* 1907498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907508 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1907511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907532 */     // GIR_Coverage, 19471,
     /* 1907532 */     GIR_EraseRootFromParent_Done,
     /* 1907533 */   // Label 25688: @1907533
     /* 1907533 */   GIM_Try, /*On fail goto*//*Label 25689*/ GIMT_Encode4(1907619), // Rule ID 19474 //
     /* 1907538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1907549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1907552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1907555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1907558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907584 */     // MIs[0] policy
     /* 1907584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907594 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1907597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907618 */     // GIR_Coverage, 19474,
     /* 1907618 */     GIR_EraseRootFromParent_Done,
     /* 1907619 */   // Label 25689: @1907619
     /* 1907619 */   GIM_Try, /*On fail goto*//*Label 25690*/ GIMT_Encode4(1907705), // Rule ID 19475 //
     /* 1907624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1907635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1907638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1907641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1907644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907670 */     // MIs[0] policy
     /* 1907670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907680 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1907683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907704 */     // GIR_Coverage, 19475,
     /* 1907704 */     GIR_EraseRootFromParent_Done,
     /* 1907705 */   // Label 25690: @1907705
     /* 1907705 */   GIM_Try, /*On fail goto*//*Label 25691*/ GIMT_Encode4(1907791), // Rule ID 19478 //
     /* 1907710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1907721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1907724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1907727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1907733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907756 */     // MIs[0] policy
     /* 1907756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907766 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1907769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907790 */     // GIR_Coverage, 19478,
     /* 1907790 */     GIR_EraseRootFromParent_Done,
     /* 1907791 */   // Label 25691: @1907791
     /* 1907791 */   GIM_Try, /*On fail goto*//*Label 25692*/ GIMT_Encode4(1907877), // Rule ID 19479 //
     /* 1907796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1907807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1907810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1907813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1907819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907842 */     // MIs[0] policy
     /* 1907842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907852 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1907855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907876 */     // GIR_Coverage, 19479,
     /* 1907876 */     GIR_EraseRootFromParent_Done,
     /* 1907877 */   // Label 25692: @1907877
     /* 1907877 */   GIM_Try, /*On fail goto*//*Label 25693*/ GIMT_Encode4(1907963), // Rule ID 19482 //
     /* 1907882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1907893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1907896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1907899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907928 */     // MIs[0] policy
     /* 1907928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907938 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1907941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907962 */     // GIR_Coverage, 19482,
     /* 1907962 */     GIR_EraseRootFromParent_Done,
     /* 1907963 */   // Label 25693: @1907963
     /* 1907963 */   GIM_Try, /*On fail goto*//*Label 25694*/ GIMT_Encode4(1908049), // Rule ID 19483 //
     /* 1907968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1907979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1907982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1907985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908014 */     // MIs[0] policy
     /* 1908014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908024 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1908027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908048 */     // GIR_Coverage, 19483,
     /* 1908048 */     GIR_EraseRootFromParent_Done,
     /* 1908049 */   // Label 25694: @1908049
     /* 1908049 */   GIM_Try, /*On fail goto*//*Label 25695*/ GIMT_Encode4(1908135), // Rule ID 19486 //
     /* 1908054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1908065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1908068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1908071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908100 */     // MIs[0] policy
     /* 1908100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908110 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1908113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908134 */     // GIR_Coverage, 19486,
     /* 1908134 */     GIR_EraseRootFromParent_Done,
     /* 1908135 */   // Label 25695: @1908135
     /* 1908135 */   GIM_Try, /*On fail goto*//*Label 25696*/ GIMT_Encode4(1908221), // Rule ID 19487 //
     /* 1908140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1908151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1908154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1908157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908186 */     // MIs[0] policy
     /* 1908186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908196 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1908199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908220 */     // GIR_Coverage, 19487,
     /* 1908220 */     GIR_EraseRootFromParent_Done,
     /* 1908221 */   // Label 25696: @1908221
     /* 1908221 */   GIM_Try, /*On fail goto*//*Label 25697*/ GIMT_Encode4(1908307), // Rule ID 19490 //
     /* 1908226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1908237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1908240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1908243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908272 */     // MIs[0] policy
     /* 1908272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908282 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1908285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908306 */     // GIR_Coverage, 19490,
     /* 1908306 */     GIR_EraseRootFromParent_Done,
     /* 1908307 */   // Label 25697: @1908307
     /* 1908307 */   GIM_Try, /*On fail goto*//*Label 25698*/ GIMT_Encode4(1908393), // Rule ID 19491 //
     /* 1908312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1908323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1908326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1908329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908358 */     // MIs[0] policy
     /* 1908358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908368 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1908371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908392 */     // GIR_Coverage, 19491,
     /* 1908392 */     GIR_EraseRootFromParent_Done,
     /* 1908393 */   // Label 25698: @1908393
     /* 1908393 */   GIM_Try, /*On fail goto*//*Label 25699*/ GIMT_Encode4(1908479), // Rule ID 19494 //
     /* 1908398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1908415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908444 */     // MIs[0] policy
     /* 1908444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908454 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1908457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908478 */     // GIR_Coverage, 19494,
     /* 1908478 */     GIR_EraseRootFromParent_Done,
     /* 1908479 */   // Label 25699: @1908479
     /* 1908479 */   GIM_Try, /*On fail goto*//*Label 25700*/ GIMT_Encode4(1908565), // Rule ID 19495 //
     /* 1908484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1908501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908530 */     // MIs[0] policy
     /* 1908530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908540 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1908543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908564 */     // GIR_Coverage, 19495,
     /* 1908564 */     GIR_EraseRootFromParent_Done,
     /* 1908565 */   // Label 25700: @1908565
     /* 1908565 */   GIM_Try, /*On fail goto*//*Label 25701*/ GIMT_Encode4(1908651), // Rule ID 19498 //
     /* 1908570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1908573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1908581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1908584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1908587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908616 */     // MIs[0] policy
     /* 1908616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908626 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1908629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908650 */     // GIR_Coverage, 19498,
     /* 1908650 */     GIR_EraseRootFromParent_Done,
     /* 1908651 */   // Label 25701: @1908651
     /* 1908651 */   GIM_Try, /*On fail goto*//*Label 25702*/ GIMT_Encode4(1908737), // Rule ID 19499 //
     /* 1908656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1908659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1908667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1908670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1908673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908702 */     // MIs[0] policy
     /* 1908702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908712 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1908715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908736 */     // GIR_Coverage, 19499,
     /* 1908736 */     GIR_EraseRootFromParent_Done,
     /* 1908737 */   // Label 25702: @1908737
     /* 1908737 */   GIM_Try, /*On fail goto*//*Label 25703*/ GIMT_Encode4(1908823), // Rule ID 19502 //
     /* 1908742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1908753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1908756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1908759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1908772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908788 */     // MIs[0] policy
     /* 1908788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908798 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1908801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908822 */     // GIR_Coverage, 19502,
     /* 1908822 */     GIR_EraseRootFromParent_Done,
     /* 1908823 */   // Label 25703: @1908823
     /* 1908823 */   GIM_Try, /*On fail goto*//*Label 25704*/ GIMT_Encode4(1908909), // Rule ID 19503 //
     /* 1908828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1908839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1908842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1908845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1908858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908874 */     // MIs[0] policy
     /* 1908874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908884 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1908887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908908 */     // GIR_Coverage, 19503,
     /* 1908908 */     GIR_EraseRootFromParent_Done,
     /* 1908909 */   // Label 25704: @1908909
     /* 1908909 */   GIM_Try, /*On fail goto*//*Label 25705*/ GIMT_Encode4(1908995), // Rule ID 19506 //
     /* 1908914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1908925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1908928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1908931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1908937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1908944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908960 */     // MIs[0] policy
     /* 1908960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908970 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1908973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908994 */     // GIR_Coverage, 19506,
     /* 1908994 */     GIR_EraseRootFromParent_Done,
     /* 1908995 */   // Label 25705: @1908995
     /* 1908995 */   GIM_Try, /*On fail goto*//*Label 25706*/ GIMT_Encode4(1909081), // Rule ID 19507 //
     /* 1909000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1909011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1909014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1909017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909046 */     // MIs[0] policy
     /* 1909046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909056 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1909059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909080 */     // GIR_Coverage, 19507,
     /* 1909080 */     GIR_EraseRootFromParent_Done,
     /* 1909081 */   // Label 25706: @1909081
     /* 1909081 */   GIM_Try, /*On fail goto*//*Label 25707*/ GIMT_Encode4(1909167), // Rule ID 19510 //
     /* 1909086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1909097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1909100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1909103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1909109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909132 */     // MIs[0] policy
     /* 1909132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909142 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1909145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909166 */     // GIR_Coverage, 19510,
     /* 1909166 */     GIR_EraseRootFromParent_Done,
     /* 1909167 */   // Label 25707: @1909167
     /* 1909167 */   GIM_Try, /*On fail goto*//*Label 25708*/ GIMT_Encode4(1909253), // Rule ID 19511 //
     /* 1909172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1909183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1909186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1909189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1909195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909218 */     // MIs[0] policy
     /* 1909218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909228 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1909231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909252 */     // GIR_Coverage, 19511,
     /* 1909252 */     GIR_EraseRootFromParent_Done,
     /* 1909253 */   // Label 25708: @1909253
     /* 1909253 */   GIM_Try, /*On fail goto*//*Label 25709*/ GIMT_Encode4(1909339), // Rule ID 19514 //
     /* 1909258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1909269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1909272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1909275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909304 */     // MIs[0] policy
     /* 1909304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909314 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1909317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909338 */     // GIR_Coverage, 19514,
     /* 1909338 */     GIR_EraseRootFromParent_Done,
     /* 1909339 */   // Label 25709: @1909339
     /* 1909339 */   GIM_Try, /*On fail goto*//*Label 25710*/ GIMT_Encode4(1909425), // Rule ID 19515 //
     /* 1909344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1909355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1909358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1909361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909390 */     // MIs[0] policy
     /* 1909390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909400 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1909403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909424 */     // GIR_Coverage, 19515,
     /* 1909424 */     GIR_EraseRootFromParent_Done,
     /* 1909425 */   // Label 25710: @1909425
     /* 1909425 */   GIM_Try, /*On fail goto*//*Label 25711*/ GIMT_Encode4(1909511), // Rule ID 19518 //
     /* 1909430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1909441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1909444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1909447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909476 */     // MIs[0] policy
     /* 1909476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909486 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1909489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909510 */     // GIR_Coverage, 19518,
     /* 1909510 */     GIR_EraseRootFromParent_Done,
     /* 1909511 */   // Label 25711: @1909511
     /* 1909511 */   GIM_Try, /*On fail goto*//*Label 25712*/ GIMT_Encode4(1909597), // Rule ID 19519 //
     /* 1909516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1909527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1909530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1909533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909562 */     // MIs[0] policy
     /* 1909562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909572 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1909575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909596 */     // GIR_Coverage, 19519,
     /* 1909596 */     GIR_EraseRootFromParent_Done,
     /* 1909597 */   // Label 25712: @1909597
     /* 1909597 */   GIM_Try, /*On fail goto*//*Label 25713*/ GIMT_Encode4(1909683), // Rule ID 19522 //
     /* 1909602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1909613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1909616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1909619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909648 */     // MIs[0] policy
     /* 1909648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909658 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1909661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909682 */     // GIR_Coverage, 19522,
     /* 1909682 */     GIR_EraseRootFromParent_Done,
     /* 1909683 */   // Label 25713: @1909683
     /* 1909683 */   GIM_Try, /*On fail goto*//*Label 25714*/ GIMT_Encode4(1909769), // Rule ID 19523 //
     /* 1909688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1909699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1909702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1909705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909734 */     // MIs[0] policy
     /* 1909734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909744 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1909747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909768 */     // GIR_Coverage, 19523,
     /* 1909768 */     GIR_EraseRootFromParent_Done,
     /* 1909769 */   // Label 25714: @1909769
     /* 1909769 */   GIM_Try, /*On fail goto*//*Label 25715*/ GIMT_Encode4(1909855), // Rule ID 19526 //
     /* 1909774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1909777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1909785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1909788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1909791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1909794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1909816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909820 */     // MIs[0] policy
     /* 1909820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909830 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1909833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1909851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909854 */     // GIR_Coverage, 19526,
     /* 1909854 */     GIR_EraseRootFromParent_Done,
     /* 1909855 */   // Label 25715: @1909855
     /* 1909855 */   GIM_Try, /*On fail goto*//*Label 25716*/ GIMT_Encode4(1909941), // Rule ID 19527 //
     /* 1909860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1909863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1909871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1909874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1909877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1909880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1909902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909906 */     // MIs[0] policy
     /* 1909906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909916 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1909919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1909937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909940 */     // GIR_Coverage, 19527,
     /* 1909940 */     GIR_EraseRootFromParent_Done,
     /* 1909941 */   // Label 25716: @1909941
     /* 1909941 */   GIM_Try, /*On fail goto*//*Label 25717*/ GIMT_Encode4(1910027), // Rule ID 19530 //
     /* 1909946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1909949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1909957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1909960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1909963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1909966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1909988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909992 */     // MIs[0] policy
     /* 1909992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910002 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1910005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910026 */     // GIR_Coverage, 19530,
     /* 1910026 */     GIR_EraseRootFromParent_Done,
     /* 1910027 */   // Label 25717: @1910027
     /* 1910027 */   GIM_Try, /*On fail goto*//*Label 25718*/ GIMT_Encode4(1910113), // Rule ID 19531 //
     /* 1910032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1910035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1910043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1910046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1910049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910078 */     // MIs[0] policy
     /* 1910078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910088 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1910091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910112 */     // GIR_Coverage, 19531,
     /* 1910112 */     GIR_EraseRootFromParent_Done,
     /* 1910113 */   // Label 25718: @1910113
     /* 1910113 */   GIM_Try, /*On fail goto*//*Label 25719*/ GIMT_Encode4(1910199), // Rule ID 19534 //
     /* 1910118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1910121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1910129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1910132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1910135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910164 */     // MIs[0] policy
     /* 1910164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910174 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1910177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910198 */     // GIR_Coverage, 19534,
     /* 1910198 */     GIR_EraseRootFromParent_Done,
     /* 1910199 */   // Label 25719: @1910199
     /* 1910199 */   GIM_Try, /*On fail goto*//*Label 25720*/ GIMT_Encode4(1910285), // Rule ID 19535 //
     /* 1910204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1910207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1910215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1910218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1910221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910250 */     // MIs[0] policy
     /* 1910250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910260 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1910263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910284 */     // GIR_Coverage, 19535,
     /* 1910284 */     GIR_EraseRootFromParent_Done,
     /* 1910285 */   // Label 25720: @1910285
     /* 1910285 */   GIM_Try, /*On fail goto*//*Label 25721*/ GIMT_Encode4(1910371), // Rule ID 19538 //
     /* 1910290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1910301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1910304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1910307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1910310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910336 */     // MIs[0] policy
     /* 1910336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910346 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1910349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910370 */     // GIR_Coverage, 19538,
     /* 1910370 */     GIR_EraseRootFromParent_Done,
     /* 1910371 */   // Label 25721: @1910371
     /* 1910371 */   GIM_Try, /*On fail goto*//*Label 25722*/ GIMT_Encode4(1910457), // Rule ID 19539 //
     /* 1910376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1910387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1910390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1910393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1910396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910422 */     // MIs[0] policy
     /* 1910422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910432 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1910435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910456 */     // GIR_Coverage, 19539,
     /* 1910456 */     GIR_EraseRootFromParent_Done,
     /* 1910457 */   // Label 25722: @1910457
     /* 1910457 */   GIM_Try, /*On fail goto*//*Label 25723*/ GIMT_Encode4(1910543), // Rule ID 19542 //
     /* 1910462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1910473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1910476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1910479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1910482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910508 */     // MIs[0] policy
     /* 1910508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910518 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1910521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910542 */     // GIR_Coverage, 19542,
     /* 1910542 */     GIR_EraseRootFromParent_Done,
     /* 1910543 */   // Label 25723: @1910543
     /* 1910543 */   GIM_Try, /*On fail goto*//*Label 25724*/ GIMT_Encode4(1910629), // Rule ID 19543 //
     /* 1910548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1910559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1910562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1910565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1910568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910594 */     // MIs[0] policy
     /* 1910594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910604 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1910607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910628 */     // GIR_Coverage, 19543,
     /* 1910628 */     GIR_EraseRootFromParent_Done,
     /* 1910629 */   // Label 25724: @1910629
     /* 1910629 */   GIM_Try, /*On fail goto*//*Label 25725*/ GIMT_Encode4(1910715), // Rule ID 19546 //
     /* 1910634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1910645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1910648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1910651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1910654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910680 */     // MIs[0] policy
     /* 1910680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910690 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1910693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910714 */     // GIR_Coverage, 19546,
     /* 1910714 */     GIR_EraseRootFromParent_Done,
     /* 1910715 */   // Label 25725: @1910715
     /* 1910715 */   GIM_Try, /*On fail goto*//*Label 25726*/ GIMT_Encode4(1910801), // Rule ID 19547 //
     /* 1910720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1910723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1910731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1910734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1910737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1910740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910766 */     // MIs[0] policy
     /* 1910766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910776 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1910779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910800 */     // GIR_Coverage, 19547,
     /* 1910800 */     GIR_EraseRootFromParent_Done,
     /* 1910801 */   // Label 25726: @1910801
     /* 1910801 */   GIM_Try, /*On fail goto*//*Label 25727*/ GIMT_Encode4(1910887), // Rule ID 19550 //
     /* 1910806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1910817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1910820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1910823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1910826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910852 */     // MIs[0] policy
     /* 1910852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910862 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1910865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910886 */     // GIR_Coverage, 19550,
     /* 1910886 */     GIR_EraseRootFromParent_Done,
     /* 1910887 */   // Label 25727: @1910887
     /* 1910887 */   GIM_Try, /*On fail goto*//*Label 25728*/ GIMT_Encode4(1910973), // Rule ID 19551 //
     /* 1910892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1910903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1910906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1910909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1910912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910938 */     // MIs[0] policy
     /* 1910938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910948 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1910951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910972 */     // GIR_Coverage, 19551,
     /* 1910972 */     GIR_EraseRootFromParent_Done,
     /* 1910973 */   // Label 25728: @1910973
     /* 1910973 */   GIM_Try, /*On fail goto*//*Label 25729*/ GIMT_Encode4(1911059), // Rule ID 19554 //
     /* 1910978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1910989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1910992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1910995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1910998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911024 */     // MIs[0] policy
     /* 1911024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911034 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1911037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911058 */     // GIR_Coverage, 19554,
     /* 1911058 */     GIR_EraseRootFromParent_Done,
     /* 1911059 */   // Label 25729: @1911059
     /* 1911059 */   GIM_Try, /*On fail goto*//*Label 25730*/ GIMT_Encode4(1911145), // Rule ID 19555 //
     /* 1911064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1911067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1911075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1911078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1911081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1911084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911110 */     // MIs[0] policy
     /* 1911110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911120 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1911123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911144 */     // GIR_Coverage, 19555,
     /* 1911144 */     GIR_EraseRootFromParent_Done,
     /* 1911145 */   // Label 25730: @1911145
     /* 1911145 */   GIM_Try, /*On fail goto*//*Label 25731*/ GIMT_Encode4(1911231), // Rule ID 19558 //
     /* 1911150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1911153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1911161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1911164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1911167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1911170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911196 */     // MIs[0] policy
     /* 1911196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911206 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1911209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911230 */     // GIR_Coverage, 19558,
     /* 1911230 */     GIR_EraseRootFromParent_Done,
     /* 1911231 */   // Label 25731: @1911231
     /* 1911231 */   GIM_Try, /*On fail goto*//*Label 25732*/ GIMT_Encode4(1911317), // Rule ID 19559 //
     /* 1911236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1911239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1911247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1911250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1911253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1911256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911282 */     // MIs[0] policy
     /* 1911282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911292 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1911295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911316 */     // GIR_Coverage, 19559,
     /* 1911316 */     GIR_EraseRootFromParent_Done,
     /* 1911317 */   // Label 25732: @1911317
     /* 1911317 */   GIM_Try, /*On fail goto*//*Label 25733*/ GIMT_Encode4(1911403), // Rule ID 19562 //
     /* 1911322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1911333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1911336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1911339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1911342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911368 */     // MIs[0] policy
     /* 1911368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911378 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1911381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911402 */     // GIR_Coverage, 19562,
     /* 1911402 */     GIR_EraseRootFromParent_Done,
     /* 1911403 */   // Label 25733: @1911403
     /* 1911403 */   GIM_Try, /*On fail goto*//*Label 25734*/ GIMT_Encode4(1911489), // Rule ID 19563 //
     /* 1911408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1911419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1911422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1911425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1911428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911454 */     // MIs[0] policy
     /* 1911454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911464 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1911467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911488 */     // GIR_Coverage, 19563,
     /* 1911488 */     GIR_EraseRootFromParent_Done,
     /* 1911489 */   // Label 25734: @1911489
     /* 1911489 */   GIM_Try, /*On fail goto*//*Label 25735*/ GIMT_Encode4(1911575), // Rule ID 19566 //
     /* 1911494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1911505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1911508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1911511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1911514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1911517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1911524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911540 */     // MIs[0] policy
     /* 1911540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911550 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1911553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911574 */     // GIR_Coverage, 19566,
     /* 1911574 */     GIR_EraseRootFromParent_Done,
     /* 1911575 */   // Label 25735: @1911575
     /* 1911575 */   GIM_Try, /*On fail goto*//*Label 25736*/ GIMT_Encode4(1911661), // Rule ID 19567 //
     /* 1911580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1911591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1911594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1911597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1911600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1911603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1911610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911626 */     // MIs[0] policy
     /* 1911626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911636 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1911639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911660 */     // GIR_Coverage, 19567,
     /* 1911660 */     GIR_EraseRootFromParent_Done,
     /* 1911661 */   // Label 25736: @1911661
     /* 1911661 */   GIM_Try, /*On fail goto*//*Label 25737*/ GIMT_Encode4(1911747), // Rule ID 19570 //
     /* 1911666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1911677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1911680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1911683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1911686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1911689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1911696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911712 */     // MIs[0] policy
     /* 1911712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911722 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1911725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911746 */     // GIR_Coverage, 19570,
     /* 1911746 */     GIR_EraseRootFromParent_Done,
     /* 1911747 */   // Label 25737: @1911747
     /* 1911747 */   GIM_Try, /*On fail goto*//*Label 25738*/ GIMT_Encode4(1911833), // Rule ID 19571 //
     /* 1911752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1911763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1911766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1911769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1911772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1911775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1911782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911798 */     // MIs[0] policy
     /* 1911798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911808 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1911811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911832 */     // GIR_Coverage, 19571,
     /* 1911832 */     GIR_EraseRootFromParent_Done,
     /* 1911833 */   // Label 25738: @1911833
     /* 1911833 */   GIM_Try, /*On fail goto*//*Label 25739*/ GIMT_Encode4(1911919), // Rule ID 19574 //
     /* 1911838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1911841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1911849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1911852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1911855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1911858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911884 */     // MIs[0] policy
     /* 1911884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911894 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1911897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911918 */     // GIR_Coverage, 19574,
     /* 1911918 */     GIR_EraseRootFromParent_Done,
     /* 1911919 */   // Label 25739: @1911919
     /* 1911919 */   GIM_Try, /*On fail goto*//*Label 25740*/ GIMT_Encode4(1912005), // Rule ID 19575 //
     /* 1911924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1911927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1911935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1911938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1911941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1911944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911970 */     // MIs[0] policy
     /* 1911970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911980 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1911983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912004 */     // GIR_Coverage, 19575,
     /* 1912004 */     GIR_EraseRootFromParent_Done,
     /* 1912005 */   // Label 25740: @1912005
     /* 1912005 */   GIM_Try, /*On fail goto*//*Label 25741*/ GIMT_Encode4(1912091), // Rule ID 19578 //
     /* 1912010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1912021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1912024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1912027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1912030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912056 */     // MIs[0] policy
     /* 1912056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912066 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1912069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912090 */     // GIR_Coverage, 19578,
     /* 1912090 */     GIR_EraseRootFromParent_Done,
     /* 1912091 */   // Label 25741: @1912091
     /* 1912091 */   GIM_Try, /*On fail goto*//*Label 25742*/ GIMT_Encode4(1912177), // Rule ID 19579 //
     /* 1912096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1912107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1912110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1912113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1912116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912142 */     // MIs[0] policy
     /* 1912142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912152 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1912155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912176 */     // GIR_Coverage, 19579,
     /* 1912176 */     GIR_EraseRootFromParent_Done,
     /* 1912177 */   // Label 25742: @1912177
     /* 1912177 */   GIM_Try, /*On fail goto*//*Label 25743*/ GIMT_Encode4(1912263), // Rule ID 19582 //
     /* 1912182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1912193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1912196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1912199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1912202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912228 */     // MIs[0] policy
     /* 1912228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912238 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1912241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912262 */     // GIR_Coverage, 19582,
     /* 1912262 */     GIR_EraseRootFromParent_Done,
     /* 1912263 */   // Label 25743: @1912263
     /* 1912263 */   GIM_Try, /*On fail goto*//*Label 25744*/ GIMT_Encode4(1912349), // Rule ID 19583 //
     /* 1912268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1912279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1912282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1912285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1912288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912314 */     // MIs[0] policy
     /* 1912314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912324 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1912327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912348 */     // GIR_Coverage, 19583,
     /* 1912348 */     GIR_EraseRootFromParent_Done,
     /* 1912349 */   // Label 25744: @1912349
     /* 1912349 */   GIM_Try, /*On fail goto*//*Label 25745*/ GIMT_Encode4(1912435), // Rule ID 19586 //
     /* 1912354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1912365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1912368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1912371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1912374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912400 */     // MIs[0] policy
     /* 1912400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912410 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1912413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912434 */     // GIR_Coverage, 19586,
     /* 1912434 */     GIR_EraseRootFromParent_Done,
     /* 1912435 */   // Label 25745: @1912435
     /* 1912435 */   GIM_Try, /*On fail goto*//*Label 25746*/ GIMT_Encode4(1912521), // Rule ID 19587 //
     /* 1912440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1912443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1912451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1912454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1912457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1912460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912486 */     // MIs[0] policy
     /* 1912486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912496 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1912499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912520 */     // GIR_Coverage, 19587,
     /* 1912520 */     GIR_EraseRootFromParent_Done,
     /* 1912521 */   // Label 25746: @1912521
     /* 1912521 */   GIM_Try, /*On fail goto*//*Label 25747*/ GIMT_Encode4(1912607), // Rule ID 19590 //
     /* 1912526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1912537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1912540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1912543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1912546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912572 */     // MIs[0] policy
     /* 1912572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912582 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1912585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912606 */     // GIR_Coverage, 19590,
     /* 1912606 */     GIR_EraseRootFromParent_Done,
     /* 1912607 */   // Label 25747: @1912607
     /* 1912607 */   GIM_Try, /*On fail goto*//*Label 25748*/ GIMT_Encode4(1912693), // Rule ID 19591 //
     /* 1912612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1912615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1912623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1912626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1912629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1912632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912658 */     // MIs[0] policy
     /* 1912658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912668 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1912671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912692 */     // GIR_Coverage, 19591,
     /* 1912692 */     GIR_EraseRootFromParent_Done,
     /* 1912693 */   // Label 25748: @1912693
     /* 1912693 */   GIM_Try, /*On fail goto*//*Label 25749*/ GIMT_Encode4(1912779), // Rule ID 19594 //
     /* 1912698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1912709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1912712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1912715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1912718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912744 */     // MIs[0] policy
     /* 1912744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912754 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1912757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912778 */     // GIR_Coverage, 19594,
     /* 1912778 */     GIR_EraseRootFromParent_Done,
     /* 1912779 */   // Label 25749: @1912779
     /* 1912779 */   GIM_Try, /*On fail goto*//*Label 25750*/ GIMT_Encode4(1912865), // Rule ID 19595 //
     /* 1912784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1912787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1912795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1912798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1912801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1912804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912830 */     // MIs[0] policy
     /* 1912830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912840 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1912843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912864 */     // GIR_Coverage, 19595,
     /* 1912864 */     GIR_EraseRootFromParent_Done,
     /* 1912865 */   // Label 25750: @1912865
     /* 1912865 */   GIM_Try, /*On fail goto*//*Label 25751*/ GIMT_Encode4(1912951), // Rule ID 19598 //
     /* 1912870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1912873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1912881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1912884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1912887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1912893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912916 */     // MIs[0] policy
     /* 1912916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912926 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1912929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912950 */     // GIR_Coverage, 19598,
     /* 1912950 */     GIR_EraseRootFromParent_Done,
     /* 1912951 */   // Label 25751: @1912951
     /* 1912951 */   GIM_Try, /*On fail goto*//*Label 25752*/ GIMT_Encode4(1913037), // Rule ID 19599 //
     /* 1912956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1912967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1912970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1912973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1912979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913002 */     // MIs[0] policy
     /* 1913002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913012 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1913015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913036 */     // GIR_Coverage, 19599,
     /* 1913036 */     GIR_EraseRootFromParent_Done,
     /* 1913037 */   // Label 25752: @1913037
     /* 1913037 */   GIM_Try, /*On fail goto*//*Label 25753*/ GIMT_Encode4(1913123), // Rule ID 19602 //
     /* 1913042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1913053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1913056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1913059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913088 */     // MIs[0] policy
     /* 1913088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913098 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1913101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913122 */     // GIR_Coverage, 19602,
     /* 1913122 */     GIR_EraseRootFromParent_Done,
     /* 1913123 */   // Label 25753: @1913123
     /* 1913123 */   GIM_Try, /*On fail goto*//*Label 25754*/ GIMT_Encode4(1913209), // Rule ID 19603 //
     /* 1913128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1913139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1913142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1913145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913174 */     // MIs[0] policy
     /* 1913174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913184 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1913187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913208 */     // GIR_Coverage, 19603,
     /* 1913208 */     GIR_EraseRootFromParent_Done,
     /* 1913209 */   // Label 25754: @1913209
     /* 1913209 */   GIM_Try, /*On fail goto*//*Label 25755*/ GIMT_Encode4(1913295), // Rule ID 19606 //
     /* 1913214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1913217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1913225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1913228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1913231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913260 */     // MIs[0] policy
     /* 1913260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913270 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1913273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913294 */     // GIR_Coverage, 19606,
     /* 1913294 */     GIR_EraseRootFromParent_Done,
     /* 1913295 */   // Label 25755: @1913295
     /* 1913295 */   GIM_Try, /*On fail goto*//*Label 25756*/ GIMT_Encode4(1913381), // Rule ID 19607 //
     /* 1913300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1913311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1913314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1913317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913346 */     // MIs[0] policy
     /* 1913346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913356 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1913359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913380 */     // GIR_Coverage, 19607,
     /* 1913380 */     GIR_EraseRootFromParent_Done,
     /* 1913381 */   // Label 25756: @1913381
     /* 1913381 */   GIM_Try, /*On fail goto*//*Label 25757*/ GIMT_Encode4(1913467), // Rule ID 19610 //
     /* 1913386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1913397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1913400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1913403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913432 */     // MIs[0] policy
     /* 1913432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913442 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1913445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913466 */     // GIR_Coverage, 19610,
     /* 1913466 */     GIR_EraseRootFromParent_Done,
     /* 1913467 */   // Label 25757: @1913467
     /* 1913467 */   GIM_Try, /*On fail goto*//*Label 25758*/ GIMT_Encode4(1913553), // Rule ID 19611 //
     /* 1913472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1913483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1913486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1913489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913518 */     // MIs[0] policy
     /* 1913518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913528 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1913531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913552 */     // GIR_Coverage, 19611,
     /* 1913552 */     GIR_EraseRootFromParent_Done,
     /* 1913553 */   // Label 25758: @1913553
     /* 1913553 */   GIM_Try, /*On fail goto*//*Label 25759*/ GIMT_Encode4(1913639), // Rule ID 19614 //
     /* 1913558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1913561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1913569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1913572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1913575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913604 */     // MIs[0] policy
     /* 1913604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913614 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1913617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913638 */     // GIR_Coverage, 19614,
     /* 1913638 */     GIR_EraseRootFromParent_Done,
     /* 1913639 */   // Label 25759: @1913639
     /* 1913639 */   GIM_Try, /*On fail goto*//*Label 25760*/ GIMT_Encode4(1913725), // Rule ID 19615 //
     /* 1913644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1913655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1913658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1913661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913690 */     // MIs[0] policy
     /* 1913690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913700 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1913703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913724 */     // GIR_Coverage, 19615,
     /* 1913724 */     GIR_EraseRootFromParent_Done,
     /* 1913725 */   // Label 25760: @1913725
     /* 1913725 */   GIM_Try, /*On fail goto*//*Label 25761*/ GIMT_Encode4(1913811), // Rule ID 19618 //
     /* 1913730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1913733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1913741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1913744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1913747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913776 */     // MIs[0] policy
     /* 1913776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913786 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1913789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913810 */     // GIR_Coverage, 19618,
     /* 1913810 */     GIR_EraseRootFromParent_Done,
     /* 1913811 */   // Label 25761: @1913811
     /* 1913811 */   GIM_Try, /*On fail goto*//*Label 25762*/ GIMT_Encode4(1913897), // Rule ID 19619 //
     /* 1913816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1913819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1913827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1913830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1913833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913862 */     // MIs[0] policy
     /* 1913862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913872 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1913875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913896 */     // GIR_Coverage, 19619,
     /* 1913896 */     GIR_EraseRootFromParent_Done,
     /* 1913897 */   // Label 25762: @1913897
     /* 1913897 */   GIM_Try, /*On fail goto*//*Label 25763*/ GIMT_Encode4(1913983), // Rule ID 19622 //
     /* 1913902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1913913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1913916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1913919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913948 */     // MIs[0] policy
     /* 1913948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913958 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1913961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913982 */     // GIR_Coverage, 19622,
     /* 1913982 */     GIR_EraseRootFromParent_Done,
     /* 1913983 */   // Label 25763: @1913983
     /* 1913983 */   GIM_Try, /*On fail goto*//*Label 25764*/ GIMT_Encode4(1914069), // Rule ID 19623 //
     /* 1913988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1913999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1914002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1914005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914034 */     // MIs[0] policy
     /* 1914034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914044 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1914047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914068 */     // GIR_Coverage, 19623,
     /* 1914068 */     GIR_EraseRootFromParent_Done,
     /* 1914069 */   // Label 25764: @1914069
     /* 1914069 */   GIM_Try, /*On fail goto*//*Label 25765*/ GIMT_Encode4(1914155), // Rule ID 19626 //
     /* 1914074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1914085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1914088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1914091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914120 */     // MIs[0] policy
     /* 1914120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914130 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1914133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914154 */     // GIR_Coverage, 19626,
     /* 1914154 */     GIR_EraseRootFromParent_Done,
     /* 1914155 */   // Label 25765: @1914155
     /* 1914155 */   GIM_Try, /*On fail goto*//*Label 25766*/ GIMT_Encode4(1914241), // Rule ID 19627 //
     /* 1914160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1914171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1914174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1914177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914206 */     // MIs[0] policy
     /* 1914206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914216 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1914219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914240 */     // GIR_Coverage, 19627,
     /* 1914240 */     GIR_EraseRootFromParent_Done,
     /* 1914241 */   // Label 25766: @1914241
     /* 1914241 */   GIM_Try, /*On fail goto*//*Label 25767*/ GIMT_Encode4(1914327), // Rule ID 19630 //
     /* 1914246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1914257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1914260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1914263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1914269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914292 */     // MIs[0] policy
     /* 1914292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914302 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1914305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914326 */     // GIR_Coverage, 19630,
     /* 1914326 */     GIR_EraseRootFromParent_Done,
     /* 1914327 */   // Label 25767: @1914327
     /* 1914327 */   GIM_Try, /*On fail goto*//*Label 25768*/ GIMT_Encode4(1914413), // Rule ID 19631 //
     /* 1914332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1914343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1914346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1914349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1914355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914378 */     // MIs[0] policy
     /* 1914378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914388 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1914391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914412 */     // GIR_Coverage, 19631,
     /* 1914412 */     GIR_EraseRootFromParent_Done,
     /* 1914413 */   // Label 25768: @1914413
     /* 1914413 */   GIM_Try, /*On fail goto*//*Label 25769*/ GIMT_Encode4(1914499), // Rule ID 19634 //
     /* 1914418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1914429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1914432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1914435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914464 */     // MIs[0] policy
     /* 1914464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914474 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1914477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914498 */     // GIR_Coverage, 19634,
     /* 1914498 */     GIR_EraseRootFromParent_Done,
     /* 1914499 */   // Label 25769: @1914499
     /* 1914499 */   GIM_Try, /*On fail goto*//*Label 25770*/ GIMT_Encode4(1914585), // Rule ID 19635 //
     /* 1914504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1914507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1914515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1914518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1914521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914550 */     // MIs[0] policy
     /* 1914550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914560 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1914563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914584 */     // GIR_Coverage, 19635,
     /* 1914584 */     GIR_EraseRootFromParent_Done,
     /* 1914585 */   // Label 25770: @1914585
     /* 1914585 */   GIM_Try, /*On fail goto*//*Label 25771*/ GIMT_Encode4(1914671), // Rule ID 19638 //
     /* 1914590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1914601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1914604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1914607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914636 */     // MIs[0] policy
     /* 1914636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914646 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1914649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914670 */     // GIR_Coverage, 19638,
     /* 1914670 */     GIR_EraseRootFromParent_Done,
     /* 1914671 */   // Label 25771: @1914671
     /* 1914671 */   GIM_Try, /*On fail goto*//*Label 25772*/ GIMT_Encode4(1914757), // Rule ID 19639 //
     /* 1914676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1914679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1914687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1914690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1914693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914722 */     // MIs[0] policy
     /* 1914722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914732 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1914735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914756 */     // GIR_Coverage, 19639,
     /* 1914756 */     GIR_EraseRootFromParent_Done,
     /* 1914757 */   // Label 25772: @1914757
     /* 1914757 */   GIM_Try, /*On fail goto*//*Label 25773*/ GIMT_Encode4(1914843), // Rule ID 19642 //
     /* 1914762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1914773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1914776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1914779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914808 */     // MIs[0] policy
     /* 1914808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914818 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1914821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914842 */     // GIR_Coverage, 19642,
     /* 1914842 */     GIR_EraseRootFromParent_Done,
     /* 1914843 */   // Label 25773: @1914843
     /* 1914843 */   GIM_Try, /*On fail goto*//*Label 25774*/ GIMT_Encode4(1914929), // Rule ID 19643 //
     /* 1914848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1914851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1914859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1914862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1914865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914894 */     // MIs[0] policy
     /* 1914894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914904 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1914907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914928 */     // GIR_Coverage, 19643,
     /* 1914928 */     GIR_EraseRootFromParent_Done,
     /* 1914929 */   // Label 25774: @1914929
     /* 1914929 */   GIM_Try, /*On fail goto*//*Label 25775*/ GIMT_Encode4(1915015), // Rule ID 19646 //
     /* 1914934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1914937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1914945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1914948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1914951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1914976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914980 */     // MIs[0] policy
     /* 1914980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914990 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1914993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915014 */     // GIR_Coverage, 19646,
     /* 1915014 */     GIR_EraseRootFromParent_Done,
     /* 1915015 */   // Label 25775: @1915015
     /* 1915015 */   GIM_Try, /*On fail goto*//*Label 25776*/ GIMT_Encode4(1915101), // Rule ID 19647 //
     /* 1915020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1915031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1915034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1915037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915066 */     // MIs[0] policy
     /* 1915066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915076 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1915079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915100 */     // GIR_Coverage, 19647,
     /* 1915100 */     GIR_EraseRootFromParent_Done,
     /* 1915101 */   // Label 25776: @1915101
     /* 1915101 */   GIM_Try, /*On fail goto*//*Label 25777*/ GIMT_Encode4(1915187), // Rule ID 19650 //
     /* 1915106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1915109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1915117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1915120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1915123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915152 */     // MIs[0] policy
     /* 1915152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915162 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1915165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915186 */     // GIR_Coverage, 19650,
     /* 1915186 */     GIR_EraseRootFromParent_Done,
     /* 1915187 */   // Label 25777: @1915187
     /* 1915187 */   GIM_Try, /*On fail goto*//*Label 25778*/ GIMT_Encode4(1915273), // Rule ID 19651 //
     /* 1915192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1915203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1915206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1915209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915238 */     // MIs[0] policy
     /* 1915238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915248 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1915251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915272 */     // GIR_Coverage, 19651,
     /* 1915272 */     GIR_EraseRootFromParent_Done,
     /* 1915273 */   // Label 25778: @1915273
     /* 1915273 */   GIM_Try, /*On fail goto*//*Label 25779*/ GIMT_Encode4(1915359), // Rule ID 19654 //
     /* 1915278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1915281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1915289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1915292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1915295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915324 */     // MIs[0] policy
     /* 1915324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915334 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1915337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915358 */     // GIR_Coverage, 19654,
     /* 1915358 */     GIR_EraseRootFromParent_Done,
     /* 1915359 */   // Label 25779: @1915359
     /* 1915359 */   GIM_Try, /*On fail goto*//*Label 25780*/ GIMT_Encode4(1915445), // Rule ID 19655 //
     /* 1915364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1915375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1915378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1915381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915410 */     // MIs[0] policy
     /* 1915410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915420 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1915423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915444 */     // GIR_Coverage, 19655,
     /* 1915444 */     GIR_EraseRootFromParent_Done,
     /* 1915445 */   // Label 25780: @1915445
     /* 1915445 */   GIM_Try, /*On fail goto*//*Label 25781*/ GIMT_Encode4(1915531), // Rule ID 19658 //
     /* 1915450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1915453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1915461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1915464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1915467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1915470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915496 */     // MIs[0] policy
     /* 1915496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915506 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1915509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915530 */     // GIR_Coverage, 19658,
     /* 1915530 */     GIR_EraseRootFromParent_Done,
     /* 1915531 */   // Label 25781: @1915531
     /* 1915531 */   GIM_Try, /*On fail goto*//*Label 25782*/ GIMT_Encode4(1915617), // Rule ID 19659 //
     /* 1915536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1915539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1915547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1915550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1915553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1915556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915582 */     // MIs[0] policy
     /* 1915582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915592 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1915595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915616 */     // GIR_Coverage, 19659,
     /* 1915616 */     GIR_EraseRootFromParent_Done,
     /* 1915617 */   // Label 25782: @1915617
     /* 1915617 */   GIM_Try, /*On fail goto*//*Label 25783*/ GIMT_Encode4(1915703), // Rule ID 19662 //
     /* 1915622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1915625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1915633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1915636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1915639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1915642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915668 */     // MIs[0] policy
     /* 1915668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915678 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1915681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915702 */     // GIR_Coverage, 19662,
     /* 1915702 */     GIR_EraseRootFromParent_Done,
     /* 1915703 */   // Label 25783: @1915703
     /* 1915703 */   GIM_Try, /*On fail goto*//*Label 25784*/ GIMT_Encode4(1915789), // Rule ID 19663 //
     /* 1915708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1915711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1915719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1915722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1915725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1915728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915754 */     // MIs[0] policy
     /* 1915754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915764 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1915767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915788 */     // GIR_Coverage, 19663,
     /* 1915788 */     GIR_EraseRootFromParent_Done,
     /* 1915789 */   // Label 25784: @1915789
     /* 1915789 */   GIM_Try, /*On fail goto*//*Label 25785*/ GIMT_Encode4(1915875), // Rule ID 19666 //
     /* 1915794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1915797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1915805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1915808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1915811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1915814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915840 */     // MIs[0] policy
     /* 1915840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915850 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1915853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915874 */     // GIR_Coverage, 19666,
     /* 1915874 */     GIR_EraseRootFromParent_Done,
     /* 1915875 */   // Label 25785: @1915875
     /* 1915875 */   GIM_Try, /*On fail goto*//*Label 25786*/ GIMT_Encode4(1915961), // Rule ID 19667 //
     /* 1915880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1915883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1915891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1915894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1915897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1915900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915926 */     // MIs[0] policy
     /* 1915926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915936 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1915939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915960 */     // GIR_Coverage, 19667,
     /* 1915960 */     GIR_EraseRootFromParent_Done,
     /* 1915961 */   // Label 25786: @1915961
     /* 1915961 */   GIM_Try, /*On fail goto*//*Label 25787*/ GIMT_Encode4(1916047), // Rule ID 19670 //
     /* 1915966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1915969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1915977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1915980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1915983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1915986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916012 */     // MIs[0] policy
     /* 1916012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916022 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1916025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916046 */     // GIR_Coverage, 19670,
     /* 1916046 */     GIR_EraseRootFromParent_Done,
     /* 1916047 */   // Label 25787: @1916047
     /* 1916047 */   GIM_Try, /*On fail goto*//*Label 25788*/ GIMT_Encode4(1916133), // Rule ID 19671 //
     /* 1916052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1916063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1916066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1916069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1916072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916098 */     // MIs[0] policy
     /* 1916098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916108 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1916111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916132 */     // GIR_Coverage, 19671,
     /* 1916132 */     GIR_EraseRootFromParent_Done,
     /* 1916133 */   // Label 25788: @1916133
     /* 1916133 */   GIM_Try, /*On fail goto*//*Label 25789*/ GIMT_Encode4(1916219), // Rule ID 19674 //
     /* 1916138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1916141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1916149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1916152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1916155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1916158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916184 */     // MIs[0] policy
     /* 1916184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916194 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1916197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916218 */     // GIR_Coverage, 19674,
     /* 1916218 */     GIR_EraseRootFromParent_Done,
     /* 1916219 */   // Label 25789: @1916219
     /* 1916219 */   GIM_Try, /*On fail goto*//*Label 25790*/ GIMT_Encode4(1916305), // Rule ID 19675 //
     /* 1916224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1916227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1916235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1916238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1916241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1916244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916270 */     // MIs[0] policy
     /* 1916270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916280 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1916283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916304 */     // GIR_Coverage, 19675,
     /* 1916304 */     GIR_EraseRootFromParent_Done,
     /* 1916305 */   // Label 25790: @1916305
     /* 1916305 */   GIM_Try, /*On fail goto*//*Label 25791*/ GIMT_Encode4(1916391), // Rule ID 19678 //
     /* 1916310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1916313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1916321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1916324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1916327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1916330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916356 */     // MIs[0] policy
     /* 1916356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916366 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1916369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916390 */     // GIR_Coverage, 19678,
     /* 1916390 */     GIR_EraseRootFromParent_Done,
     /* 1916391 */   // Label 25791: @1916391
     /* 1916391 */   GIM_Try, /*On fail goto*//*Label 25792*/ GIMT_Encode4(1916477), // Rule ID 19679 //
     /* 1916396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1916399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1916407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1916410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1916413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1916416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916442 */     // MIs[0] policy
     /* 1916442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916452 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1916455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916476 */     // GIR_Coverage, 19679,
     /* 1916476 */     GIR_EraseRootFromParent_Done,
     /* 1916477 */   // Label 25792: @1916477
     /* 1916477 */   GIM_Try, /*On fail goto*//*Label 25793*/ GIMT_Encode4(1916563), // Rule ID 19682 //
     /* 1916482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1916493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1916496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1916499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1916502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916528 */     // MIs[0] policy
     /* 1916528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916538 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1916541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916562 */     // GIR_Coverage, 19682,
     /* 1916562 */     GIR_EraseRootFromParent_Done,
     /* 1916563 */   // Label 25793: @1916563
     /* 1916563 */   GIM_Try, /*On fail goto*//*Label 25794*/ GIMT_Encode4(1916649), // Rule ID 19683 //
     /* 1916568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1916579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1916582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1916585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1916588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916614 */     // MIs[0] policy
     /* 1916614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916624 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1916627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916648 */     // GIR_Coverage, 19683,
     /* 1916648 */     GIR_EraseRootFromParent_Done,
     /* 1916649 */   // Label 25794: @1916649
     /* 1916649 */   GIM_Try, /*On fail goto*//*Label 25795*/ GIMT_Encode4(1916735), // Rule ID 19686 //
     /* 1916654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1916665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1916668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1916671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1916674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1916677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1916684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916700 */     // MIs[0] policy
     /* 1916700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916710 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1916713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916734 */     // GIR_Coverage, 19686,
     /* 1916734 */     GIR_EraseRootFromParent_Done,
     /* 1916735 */   // Label 25795: @1916735
     /* 1916735 */   GIM_Try, /*On fail goto*//*Label 25796*/ GIMT_Encode4(1916821), // Rule ID 19687 //
     /* 1916740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1916751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1916754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1916757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1916760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1916763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1916770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916786 */     // MIs[0] policy
     /* 1916786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916796 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1916799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916820 */     // GIR_Coverage, 19687,
     /* 1916820 */     GIR_EraseRootFromParent_Done,
     /* 1916821 */   // Label 25796: @1916821
     /* 1916821 */   GIM_Try, /*On fail goto*//*Label 25797*/ GIMT_Encode4(1916907), // Rule ID 19690 //
     /* 1916826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1916837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1916840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1916843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1916846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1916849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1916856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916872 */     // MIs[0] policy
     /* 1916872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916882 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1916885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916906 */     // GIR_Coverage, 19690,
     /* 1916906 */     GIR_EraseRootFromParent_Done,
     /* 1916907 */   // Label 25797: @1916907
     /* 1916907 */   GIM_Try, /*On fail goto*//*Label 25798*/ GIMT_Encode4(1916993), // Rule ID 19691 //
     /* 1916912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1916923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1916926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1916929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1916932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1916935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1916942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916958 */     // MIs[0] policy
     /* 1916958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916968 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1916971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916992 */     // GIR_Coverage, 19691,
     /* 1916992 */     GIR_EraseRootFromParent_Done,
     /* 1916993 */   // Label 25798: @1916993
     /* 1916993 */   GIM_Try, /*On fail goto*//*Label 25799*/ GIMT_Encode4(1917079), // Rule ID 19694 //
     /* 1916998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1917009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1917012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1917015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1917018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917044 */     // MIs[0] policy
     /* 1917044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917054 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1917057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917078 */     // GIR_Coverage, 19694,
     /* 1917078 */     GIR_EraseRootFromParent_Done,
     /* 1917079 */   // Label 25799: @1917079
     /* 1917079 */   GIM_Try, /*On fail goto*//*Label 25800*/ GIMT_Encode4(1917165), // Rule ID 19695 //
     /* 1917084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1917095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1917098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1917101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1917104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917130 */     // MIs[0] policy
     /* 1917130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917140 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1917143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917164 */     // GIR_Coverage, 19695,
     /* 1917164 */     GIR_EraseRootFromParent_Done,
     /* 1917165 */   // Label 25800: @1917165
     /* 1917165 */   GIM_Try, /*On fail goto*//*Label 25801*/ GIMT_Encode4(1917251), // Rule ID 19698 //
     /* 1917170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1917181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1917184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1917187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1917190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917216 */     // MIs[0] policy
     /* 1917216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917226 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1917229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917250 */     // GIR_Coverage, 19698,
     /* 1917250 */     GIR_EraseRootFromParent_Done,
     /* 1917251 */   // Label 25801: @1917251
     /* 1917251 */   GIM_Try, /*On fail goto*//*Label 25802*/ GIMT_Encode4(1917337), // Rule ID 19699 //
     /* 1917256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1917267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1917270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1917273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1917276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917302 */     // MIs[0] policy
     /* 1917302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917312 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1917315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917336 */     // GIR_Coverage, 19699,
     /* 1917336 */     GIR_EraseRootFromParent_Done,
     /* 1917337 */   // Label 25802: @1917337
     /* 1917337 */   GIM_Try, /*On fail goto*//*Label 25803*/ GIMT_Encode4(1917423), // Rule ID 19702 //
     /* 1917342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1917353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1917356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1917359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1917362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917388 */     // MIs[0] policy
     /* 1917388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917398 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1917401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917422 */     // GIR_Coverage, 19702,
     /* 1917422 */     GIR_EraseRootFromParent_Done,
     /* 1917423 */   // Label 25803: @1917423
     /* 1917423 */   GIM_Try, /*On fail goto*//*Label 25804*/ GIMT_Encode4(1917509), // Rule ID 19703 //
     /* 1917428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1917439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1917442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1917445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1917448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917474 */     // MIs[0] policy
     /* 1917474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917484 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1917487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917508 */     // GIR_Coverage, 19703,
     /* 1917508 */     GIR_EraseRootFromParent_Done,
     /* 1917509 */   // Label 25804: @1917509
     /* 1917509 */   GIM_Try, /*On fail goto*//*Label 25805*/ GIMT_Encode4(1917595), // Rule ID 19706 //
     /* 1917514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1917517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1917525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1917528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1917531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1917534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1917537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917560 */     // MIs[0] policy
     /* 1917560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917570 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1917573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917594 */     // GIR_Coverage, 19706,
     /* 1917594 */     GIR_EraseRootFromParent_Done,
     /* 1917595 */   // Label 25805: @1917595
     /* 1917595 */   GIM_Try, /*On fail goto*//*Label 25806*/ GIMT_Encode4(1917681), // Rule ID 19707 //
     /* 1917600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1917603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1917611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1917614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1917617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1917620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1917623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917646 */     // MIs[0] policy
     /* 1917646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917656 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1917659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917680 */     // GIR_Coverage, 19707,
     /* 1917680 */     GIR_EraseRootFromParent_Done,
     /* 1917681 */   // Label 25806: @1917681
     /* 1917681 */   GIM_Try, /*On fail goto*//*Label 25807*/ GIMT_Encode4(1917767), // Rule ID 19710 //
     /* 1917686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1917689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1917697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1917700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1917703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1917706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917732 */     // MIs[0] policy
     /* 1917732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917742 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1917745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917766 */     // GIR_Coverage, 19710,
     /* 1917766 */     GIR_EraseRootFromParent_Done,
     /* 1917767 */   // Label 25807: @1917767
     /* 1917767 */   GIM_Try, /*On fail goto*//*Label 25808*/ GIMT_Encode4(1917853), // Rule ID 19711 //
     /* 1917772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1917775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1917783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1917786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1917789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1917792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917818 */     // MIs[0] policy
     /* 1917818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917828 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1917831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917852 */     // GIR_Coverage, 19711,
     /* 1917852 */     GIR_EraseRootFromParent_Done,
     /* 1917853 */   // Label 25808: @1917853
     /* 1917853 */   GIM_Try, /*On fail goto*//*Label 25809*/ GIMT_Encode4(1917939), // Rule ID 19714 //
     /* 1917858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1917861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1917869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1917872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1917875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1917878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917904 */     // MIs[0] policy
     /* 1917904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917914 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1917917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917938 */     // GIR_Coverage, 19714,
     /* 1917938 */     GIR_EraseRootFromParent_Done,
     /* 1917939 */   // Label 25809: @1917939
     /* 1917939 */   GIM_Try, /*On fail goto*//*Label 25810*/ GIMT_Encode4(1918025), // Rule ID 19715 //
     /* 1917944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1917947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1917955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1917958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1917961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1917964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917990 */     // MIs[0] policy
     /* 1917990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918000 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1918003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918024 */     // GIR_Coverage, 19715,
     /* 1918024 */     GIR_EraseRootFromParent_Done,
     /* 1918025 */   // Label 25810: @1918025
     /* 1918025 */   GIM_Try, /*On fail goto*//*Label 25811*/ GIMT_Encode4(1918111), // Rule ID 19718 //
     /* 1918030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1918033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1918041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1918044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1918047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918076 */     // MIs[0] policy
     /* 1918076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918086 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1918089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918110 */     // GIR_Coverage, 19718,
     /* 1918110 */     GIR_EraseRootFromParent_Done,
     /* 1918111 */   // Label 25811: @1918111
     /* 1918111 */   GIM_Try, /*On fail goto*//*Label 25812*/ GIMT_Encode4(1918197), // Rule ID 19719 //
     /* 1918116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1918119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1918127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1918130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1918133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918162 */     // MIs[0] policy
     /* 1918162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918172 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1918175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918196 */     // GIR_Coverage, 19719,
     /* 1918196 */     GIR_EraseRootFromParent_Done,
     /* 1918197 */   // Label 25812: @1918197
     /* 1918197 */   GIM_Try, /*On fail goto*//*Label 25813*/ GIMT_Encode4(1918283), // Rule ID 19722 //
     /* 1918202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1918205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1918213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1918216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1918219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918248 */     // MIs[0] policy
     /* 1918248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918258 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1918261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918282 */     // GIR_Coverage, 19722,
     /* 1918282 */     GIR_EraseRootFromParent_Done,
     /* 1918283 */   // Label 25813: @1918283
     /* 1918283 */   GIM_Try, /*On fail goto*//*Label 25814*/ GIMT_Encode4(1918369), // Rule ID 19723 //
     /* 1918288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1918291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1918299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1918302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1918305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918334 */     // MIs[0] policy
     /* 1918334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918344 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1918347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918368 */     // GIR_Coverage, 19723,
     /* 1918368 */     GIR_EraseRootFromParent_Done,
     /* 1918369 */   // Label 25814: @1918369
     /* 1918369 */   GIM_Try, /*On fail goto*//*Label 25815*/ GIMT_Encode4(1918455), // Rule ID 19726 //
     /* 1918374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1918377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1918385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1918388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1918391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918420 */     // MIs[0] policy
     /* 1918420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918430 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1918433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918454 */     // GIR_Coverage, 19726,
     /* 1918454 */     GIR_EraseRootFromParent_Done,
     /* 1918455 */   // Label 25815: @1918455
     /* 1918455 */   GIM_Try, /*On fail goto*//*Label 25816*/ GIMT_Encode4(1918541), // Rule ID 19727 //
     /* 1918460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1918463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1918471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1918474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1918477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918506 */     // MIs[0] policy
     /* 1918506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918516 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1918519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918540 */     // GIR_Coverage, 19727,
     /* 1918540 */     GIR_EraseRootFromParent_Done,
     /* 1918541 */   // Label 25816: @1918541
     /* 1918541 */   GIM_Try, /*On fail goto*//*Label 25817*/ GIMT_Encode4(1918627), // Rule ID 19730 //
     /* 1918546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1918549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1918557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1918560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1918563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918592 */     // MIs[0] policy
     /* 1918592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918602 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1918605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918626 */     // GIR_Coverage, 19730,
     /* 1918626 */     GIR_EraseRootFromParent_Done,
     /* 1918627 */   // Label 25817: @1918627
     /* 1918627 */   GIM_Try, /*On fail goto*//*Label 25818*/ GIMT_Encode4(1918713), // Rule ID 19731 //
     /* 1918632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1918635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1918643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1918646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1918649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918678 */     // MIs[0] policy
     /* 1918678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918688 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1918691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918712 */     // GIR_Coverage, 19731,
     /* 1918712 */     GIR_EraseRootFromParent_Done,
     /* 1918713 */   // Label 25818: @1918713
     /* 1918713 */   GIM_Try, /*On fail goto*//*Label 25819*/ GIMT_Encode4(1918799), // Rule ID 19734 //
     /* 1918718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1918721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1918729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1918732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1918735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918764 */     // MIs[0] policy
     /* 1918764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918774 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1918777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918798 */     // GIR_Coverage, 19734,
     /* 1918798 */     GIR_EraseRootFromParent_Done,
     /* 1918799 */   // Label 25819: @1918799
     /* 1918799 */   GIM_Try, /*On fail goto*//*Label 25820*/ GIMT_Encode4(1918885), // Rule ID 19735 //
     /* 1918804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1918807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1918815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1918818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1918821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918850 */     // MIs[0] policy
     /* 1918850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918860 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1918863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918884 */     // GIR_Coverage, 19735,
     /* 1918884 */     GIR_EraseRootFromParent_Done,
     /* 1918885 */   // Label 25820: @1918885
     /* 1918885 */   GIM_Try, /*On fail goto*//*Label 25821*/ GIMT_Encode4(1918971), // Rule ID 19738 //
     /* 1918890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1918893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1918901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1918904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1918907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1918932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918936 */     // MIs[0] policy
     /* 1918936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918946 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1918949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918970 */     // GIR_Coverage, 19738,
     /* 1918970 */     GIR_EraseRootFromParent_Done,
     /* 1918971 */   // Label 25821: @1918971
     /* 1918971 */   GIM_Try, /*On fail goto*//*Label 25822*/ GIMT_Encode4(1919057), // Rule ID 19739 //
     /* 1918976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1918979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1918987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1918990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1918993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1919018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919022 */     // MIs[0] policy
     /* 1919022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919032 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1919035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919056 */     // GIR_Coverage, 19739,
     /* 1919056 */     GIR_EraseRootFromParent_Done,
     /* 1919057 */   // Label 25822: @1919057
     /* 1919057 */   GIM_Try, /*On fail goto*//*Label 25823*/ GIMT_Encode4(1919143), // Rule ID 19742 //
     /* 1919062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1919073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1919076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1919079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919108 */     // MIs[0] policy
     /* 1919108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919118 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1919121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919142 */     // GIR_Coverage, 19742,
     /* 1919142 */     GIR_EraseRootFromParent_Done,
     /* 1919143 */   // Label 25823: @1919143
     /* 1919143 */   GIM_Try, /*On fail goto*//*Label 25824*/ GIMT_Encode4(1919229), // Rule ID 19743 //
     /* 1919148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1919159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1919162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1919165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919194 */     // MIs[0] policy
     /* 1919194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919204 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1919207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919228 */     // GIR_Coverage, 19743,
     /* 1919228 */     GIR_EraseRootFromParent_Done,
     /* 1919229 */   // Label 25824: @1919229
     /* 1919229 */   GIM_Try, /*On fail goto*//*Label 25825*/ GIMT_Encode4(1919315), // Rule ID 19746 //
     /* 1919234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1919245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1919248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1919251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1919257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919280 */     // MIs[0] policy
     /* 1919280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919290 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1919293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919314 */     // GIR_Coverage, 19746,
     /* 1919314 */     GIR_EraseRootFromParent_Done,
     /* 1919315 */   // Label 25825: @1919315
     /* 1919315 */   GIM_Try, /*On fail goto*//*Label 25826*/ GIMT_Encode4(1919401), // Rule ID 19747 //
     /* 1919320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1919331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1919334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1919337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1919343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919366 */     // MIs[0] policy
     /* 1919366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919376 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1919379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919400 */     // GIR_Coverage, 19747,
     /* 1919400 */     GIR_EraseRootFromParent_Done,
     /* 1919401 */   // Label 25826: @1919401
     /* 1919401 */   GIM_Try, /*On fail goto*//*Label 25827*/ GIMT_Encode4(1919487), // Rule ID 19750 //
     /* 1919406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1919417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1919420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1919423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1919429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919452 */     // MIs[0] policy
     /* 1919452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919462 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1919465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919486 */     // GIR_Coverage, 19750,
     /* 1919486 */     GIR_EraseRootFromParent_Done,
     /* 1919487 */   // Label 25827: @1919487
     /* 1919487 */   GIM_Try, /*On fail goto*//*Label 25828*/ GIMT_Encode4(1919573), // Rule ID 19751 //
     /* 1919492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1919503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1919506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1919509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1919515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919538 */     // MIs[0] policy
     /* 1919538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919548 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1919551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919572 */     // GIR_Coverage, 19751,
     /* 1919572 */     GIR_EraseRootFromParent_Done,
     /* 1919573 */   // Label 25828: @1919573
     /* 1919573 */   GIM_Try, /*On fail goto*//*Label 25829*/ GIMT_Encode4(1919659), // Rule ID 19754 //
     /* 1919578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1919581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1919589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1919592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1919595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919624 */     // MIs[0] policy
     /* 1919624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919634 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1919637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919658 */     // GIR_Coverage, 19754,
     /* 1919658 */     GIR_EraseRootFromParent_Done,
     /* 1919659 */   // Label 25829: @1919659
     /* 1919659 */   GIM_Try, /*On fail goto*//*Label 25830*/ GIMT_Encode4(1919745), // Rule ID 19755 //
     /* 1919664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1919667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1919675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1919678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1919681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919710 */     // MIs[0] policy
     /* 1919710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919720 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1919723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919744 */     // GIR_Coverage, 19755,
     /* 1919744 */     GIR_EraseRootFromParent_Done,
     /* 1919745 */   // Label 25830: @1919745
     /* 1919745 */   GIM_Try, /*On fail goto*//*Label 25831*/ GIMT_Encode4(1919831), // Rule ID 19758 //
     /* 1919750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1919753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1919761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1919764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1919767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919796 */     // MIs[0] policy
     /* 1919796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919806 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1919809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919830 */     // GIR_Coverage, 19758,
     /* 1919830 */     GIR_EraseRootFromParent_Done,
     /* 1919831 */   // Label 25831: @1919831
     /* 1919831 */   GIM_Try, /*On fail goto*//*Label 25832*/ GIMT_Encode4(1919917), // Rule ID 19759 //
     /* 1919836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1919839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1919847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1919850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1919853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919882 */     // MIs[0] policy
     /* 1919882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919892 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1919895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919916 */     // GIR_Coverage, 19759,
     /* 1919916 */     GIR_EraseRootFromParent_Done,
     /* 1919917 */   // Label 25832: @1919917
     /* 1919917 */   GIM_Try, /*On fail goto*//*Label 25833*/ GIMT_Encode4(1920003), // Rule ID 19762 //
     /* 1919922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1919925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1919933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1919936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1919939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1919945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919968 */     // MIs[0] policy
     /* 1919968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919978 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1919981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920002 */     // GIR_Coverage, 19762,
     /* 1920002 */     GIR_EraseRootFromParent_Done,
     /* 1920003 */   // Label 25833: @1920003
     /* 1920003 */   GIM_Try, /*On fail goto*//*Label 25834*/ GIMT_Encode4(1920089), // Rule ID 19763 //
     /* 1920008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1920011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1920019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1920022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1920025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920054 */     // MIs[0] policy
     /* 1920054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920064 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1920067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920088 */     // GIR_Coverage, 19763,
     /* 1920088 */     GIR_EraseRootFromParent_Done,
     /* 1920089 */   // Label 25834: @1920089
     /* 1920089 */   GIM_Try, /*On fail goto*//*Label 25835*/ GIMT_Encode4(1920175), // Rule ID 19766 //
     /* 1920094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1920097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1920105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1920108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1920111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920140 */     // MIs[0] policy
     /* 1920140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920150 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1920153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920174 */     // GIR_Coverage, 19766,
     /* 1920174 */     GIR_EraseRootFromParent_Done,
     /* 1920175 */   // Label 25835: @1920175
     /* 1920175 */   GIM_Try, /*On fail goto*//*Label 25836*/ GIMT_Encode4(1920261), // Rule ID 19767 //
     /* 1920180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1920183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1920191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1920194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1920197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920226 */     // MIs[0] policy
     /* 1920226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920236 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1920239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920260 */     // GIR_Coverage, 19767,
     /* 1920260 */     GIR_EraseRootFromParent_Done,
     /* 1920261 */   // Label 25836: @1920261
     /* 1920261 */   GIM_Try, /*On fail goto*//*Label 25837*/ GIMT_Encode4(1920347), // Rule ID 19770 //
     /* 1920266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1920269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1920277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1920280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1920283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920312 */     // MIs[0] policy
     /* 1920312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920322 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1920325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920346 */     // GIR_Coverage, 19770,
     /* 1920346 */     GIR_EraseRootFromParent_Done,
     /* 1920347 */   // Label 25837: @1920347
     /* 1920347 */   GIM_Try, /*On fail goto*//*Label 25838*/ GIMT_Encode4(1920433), // Rule ID 19771 //
     /* 1920352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1920355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1920363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1920366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1920369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920398 */     // MIs[0] policy
     /* 1920398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920408 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1920411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920432 */     // GIR_Coverage, 19771,
     /* 1920432 */     GIR_EraseRootFromParent_Done,
     /* 1920433 */   // Label 25838: @1920433
     /* 1920433 */   GIM_Try, /*On fail goto*//*Label 25839*/ GIMT_Encode4(1920519), // Rule ID 19774 //
     /* 1920438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1920441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1920449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1920452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1920455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920484 */     // MIs[0] policy
     /* 1920484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920494 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1920497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920518 */     // GIR_Coverage, 19774,
     /* 1920518 */     GIR_EraseRootFromParent_Done,
     /* 1920519 */   // Label 25839: @1920519
     /* 1920519 */   GIM_Try, /*On fail goto*//*Label 25840*/ GIMT_Encode4(1920605), // Rule ID 19775 //
     /* 1920524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1920527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1920535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1920538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1920541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920570 */     // MIs[0] policy
     /* 1920570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920580 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1920583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920604 */     // GIR_Coverage, 19775,
     /* 1920604 */     GIR_EraseRootFromParent_Done,
     /* 1920605 */   // Label 25840: @1920605
     /* 1920605 */   GIM_Try, /*On fail goto*//*Label 25841*/ GIMT_Encode4(1920691), // Rule ID 23616 //
     /* 1920610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1920621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1920624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1920627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1920633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920656 */     // MIs[0] policy
     /* 1920656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920666 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1920669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920690 */     // GIR_Coverage, 23616,
     /* 1920690 */     GIR_EraseRootFromParent_Done,
     /* 1920691 */   // Label 25841: @1920691
     /* 1920691 */   GIM_Try, /*On fail goto*//*Label 25842*/ GIMT_Encode4(1920777), // Rule ID 23617 //
     /* 1920696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1920707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1920710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1920713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1920719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920742 */     // MIs[0] policy
     /* 1920742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920752 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1920755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920776 */     // GIR_Coverage, 23617,
     /* 1920776 */     GIR_EraseRootFromParent_Done,
     /* 1920777 */   // Label 25842: @1920777
     /* 1920777 */   GIM_Try, /*On fail goto*//*Label 25843*/ GIMT_Encode4(1920863), // Rule ID 23620 //
     /* 1920782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1920793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1920796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1920799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920828 */     // MIs[0] policy
     /* 1920828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920838 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1920841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920862 */     // GIR_Coverage, 23620,
     /* 1920862 */     GIR_EraseRootFromParent_Done,
     /* 1920863 */   // Label 25843: @1920863
     /* 1920863 */   GIM_Try, /*On fail goto*//*Label 25844*/ GIMT_Encode4(1920949), // Rule ID 23621 //
     /* 1920868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1920879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1920882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1920885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920914 */     // MIs[0] policy
     /* 1920914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920924 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1920927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920948 */     // GIR_Coverage, 23621,
     /* 1920948 */     GIR_EraseRootFromParent_Done,
     /* 1920949 */   // Label 25844: @1920949
     /* 1920949 */   GIM_Try, /*On fail goto*//*Label 25845*/ GIMT_Encode4(1921035), // Rule ID 23624 //
     /* 1920954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1920965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1920968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1920971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921000 */     // MIs[0] policy
     /* 1921000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921010 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921034 */     // GIR_Coverage, 23624,
     /* 1921034 */     GIR_EraseRootFromParent_Done,
     /* 1921035 */   // Label 25845: @1921035
     /* 1921035 */   GIM_Try, /*On fail goto*//*Label 25846*/ GIMT_Encode4(1921121), // Rule ID 23625 //
     /* 1921040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1921051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1921054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1921057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921086 */     // MIs[0] policy
     /* 1921086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921120 */     // GIR_Coverage, 23625,
     /* 1921120 */     GIR_EraseRootFromParent_Done,
     /* 1921121 */   // Label 25846: @1921121
     /* 1921121 */   GIM_Try, /*On fail goto*//*Label 25847*/ GIMT_Encode4(1921207), // Rule ID 23628 //
     /* 1921126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1921137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1921140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1921143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921172 */     // MIs[0] policy
     /* 1921172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921182 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1921185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921206 */     // GIR_Coverage, 23628,
     /* 1921206 */     GIR_EraseRootFromParent_Done,
     /* 1921207 */   // Label 25847: @1921207
     /* 1921207 */   GIM_Try, /*On fail goto*//*Label 25848*/ GIMT_Encode4(1921293), // Rule ID 23629 //
     /* 1921212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1921223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1921226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1921229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921258 */     // MIs[0] policy
     /* 1921258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1921271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921292 */     // GIR_Coverage, 23629,
     /* 1921292 */     GIR_EraseRootFromParent_Done,
     /* 1921293 */   // Label 25848: @1921293
     /* 1921293 */   GIM_Try, /*On fail goto*//*Label 25849*/ GIMT_Encode4(1921379), // Rule ID 23632 //
     /* 1921298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1921309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1921312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1921315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921344 */     // MIs[0] policy
     /* 1921344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921354 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921378 */     // GIR_Coverage, 23632,
     /* 1921378 */     GIR_EraseRootFromParent_Done,
     /* 1921379 */   // Label 25849: @1921379
     /* 1921379 */   GIM_Try, /*On fail goto*//*Label 25850*/ GIMT_Encode4(1921465), // Rule ID 23633 //
     /* 1921384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1921395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1921398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1921401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921430 */     // MIs[0] policy
     /* 1921430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921440 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921464 */     // GIR_Coverage, 23633,
     /* 1921464 */     GIR_EraseRootFromParent_Done,
     /* 1921465 */   // Label 25850: @1921465
     /* 1921465 */   GIM_Try, /*On fail goto*//*Label 25851*/ GIMT_Encode4(1921551), // Rule ID 23636 //
     /* 1921470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1921481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1921484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1921487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921516 */     // MIs[0] policy
     /* 1921516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921526 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921550 */     // GIR_Coverage, 23636,
     /* 1921550 */     GIR_EraseRootFromParent_Done,
     /* 1921551 */   // Label 25851: @1921551
     /* 1921551 */   GIM_Try, /*On fail goto*//*Label 25852*/ GIMT_Encode4(1921637), // Rule ID 23637 //
     /* 1921556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1921567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1921570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1921573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921602 */     // MIs[0] policy
     /* 1921602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921612 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921636 */     // GIR_Coverage, 23637,
     /* 1921636 */     GIR_EraseRootFromParent_Done,
     /* 1921637 */   // Label 25852: @1921637
     /* 1921637 */   GIM_Try, /*On fail goto*//*Label 25853*/ GIMT_Encode4(1921723), // Rule ID 23640 //
     /* 1921642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1921653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1921656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1921659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921688 */     // MIs[0] policy
     /* 1921688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921698 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1921701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921722 */     // GIR_Coverage, 23640,
     /* 1921722 */     GIR_EraseRootFromParent_Done,
     /* 1921723 */   // Label 25853: @1921723
     /* 1921723 */   GIM_Try, /*On fail goto*//*Label 25854*/ GIMT_Encode4(1921809), // Rule ID 23641 //
     /* 1921728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1921739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1921742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1921745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921774 */     // MIs[0] policy
     /* 1921774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921784 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1921787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921808 */     // GIR_Coverage, 23641,
     /* 1921808 */     GIR_EraseRootFromParent_Done,
     /* 1921809 */   // Label 25854: @1921809
     /* 1921809 */   GIM_Try, /*On fail goto*//*Label 25855*/ GIMT_Encode4(1921895), // Rule ID 23644 //
     /* 1921814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1921825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1921828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1921831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921860 */     // MIs[0] policy
     /* 1921860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921870 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1921873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921894 */     // GIR_Coverage, 23644,
     /* 1921894 */     GIR_EraseRootFromParent_Done,
     /* 1921895 */   // Label 25855: @1921895
     /* 1921895 */   GIM_Try, /*On fail goto*//*Label 25856*/ GIMT_Encode4(1921981), // Rule ID 23645 //
     /* 1921900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1921911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1921914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1921917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921946 */     // MIs[0] policy
     /* 1921946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921956 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1921959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921980 */     // GIR_Coverage, 23645,
     /* 1921980 */     GIR_EraseRootFromParent_Done,
     /* 1921981 */   // Label 25856: @1921981
     /* 1921981 */   GIM_Try, /*On fail goto*//*Label 25857*/ GIMT_Encode4(1922067), // Rule ID 23648 //
     /* 1921986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1921997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1922000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1922003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922032 */     // MIs[0] policy
     /* 1922032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922042 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922066 */     // GIR_Coverage, 23648,
     /* 1922066 */     GIR_EraseRootFromParent_Done,
     /* 1922067 */   // Label 25857: @1922067
     /* 1922067 */   GIM_Try, /*On fail goto*//*Label 25858*/ GIMT_Encode4(1922153), // Rule ID 23649 //
     /* 1922072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1922083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1922086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1922089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922118 */     // MIs[0] policy
     /* 1922118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922128 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922152 */     // GIR_Coverage, 23649,
     /* 1922152 */     GIR_EraseRootFromParent_Done,
     /* 1922153 */   // Label 25858: @1922153
     /* 1922153 */   GIM_Try, /*On fail goto*//*Label 25859*/ GIMT_Encode4(1922239), // Rule ID 23652 //
     /* 1922158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1922161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1922169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1922172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1922175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922204 */     // MIs[0] policy
     /* 1922204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922214 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1922235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922238 */     // GIR_Coverage, 23652,
     /* 1922238 */     GIR_EraseRootFromParent_Done,
     /* 1922239 */   // Label 25859: @1922239
     /* 1922239 */   GIM_Try, /*On fail goto*//*Label 25860*/ GIMT_Encode4(1922325), // Rule ID 23653 //
     /* 1922244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1922247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1922255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1922258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1922261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922290 */     // MIs[0] policy
     /* 1922290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922300 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1922321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922324 */     // GIR_Coverage, 23653,
     /* 1922324 */     GIR_EraseRootFromParent_Done,
     /* 1922325 */   // Label 25860: @1922325
     /* 1922325 */   GIM_Try, /*On fail goto*//*Label 25861*/ GIMT_Encode4(1922411), // Rule ID 23656 //
     /* 1922330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1922341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1922344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1922347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1922353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922376 */     // MIs[0] policy
     /* 1922376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922386 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1922389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922410 */     // GIR_Coverage, 23656,
     /* 1922410 */     GIR_EraseRootFromParent_Done,
     /* 1922411 */   // Label 25861: @1922411
     /* 1922411 */   GIM_Try, /*On fail goto*//*Label 25862*/ GIMT_Encode4(1922497), // Rule ID 23657 //
     /* 1922416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1922427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1922430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1922433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1922439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922462 */     // MIs[0] policy
     /* 1922462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922472 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1922475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922496 */     // GIR_Coverage, 23657,
     /* 1922496 */     GIR_EraseRootFromParent_Done,
     /* 1922497 */   // Label 25862: @1922497
     /* 1922497 */   GIM_Try, /*On fail goto*//*Label 25863*/ GIMT_Encode4(1922583), // Rule ID 23660 //
     /* 1922502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1922513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1922516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1922519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1922525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1922532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922548 */     // MIs[0] policy
     /* 1922548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922558 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1922561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922582 */     // GIR_Coverage, 23660,
     /* 1922582 */     GIR_EraseRootFromParent_Done,
     /* 1922583 */   // Label 25863: @1922583
     /* 1922583 */   GIM_Try, /*On fail goto*//*Label 25864*/ GIMT_Encode4(1922669), // Rule ID 23661 //
     /* 1922588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1922599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1922602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1922605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1922611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1922618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922634 */     // MIs[0] policy
     /* 1922634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922644 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1922647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922668 */     // GIR_Coverage, 23661,
     /* 1922668 */     GIR_EraseRootFromParent_Done,
     /* 1922669 */   // Label 25864: @1922669
     /* 1922669 */   GIM_Try, /*On fail goto*//*Label 25865*/ GIMT_Encode4(1922755), // Rule ID 23664 //
     /* 1922674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1922685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1922688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1922691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1922697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1922704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922720 */     // MIs[0] policy
     /* 1922720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922730 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1922733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922754 */     // GIR_Coverage, 23664,
     /* 1922754 */     GIR_EraseRootFromParent_Done,
     /* 1922755 */   // Label 25865: @1922755
     /* 1922755 */   GIM_Try, /*On fail goto*//*Label 25866*/ GIMT_Encode4(1922841), // Rule ID 23665 //
     /* 1922760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1922771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1922774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1922777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1922783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1922790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922806 */     // MIs[0] policy
     /* 1922806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922816 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1922819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922840 */     // GIR_Coverage, 23665,
     /* 1922840 */     GIR_EraseRootFromParent_Done,
     /* 1922841 */   // Label 25866: @1922841
     /* 1922841 */   GIM_Try, /*On fail goto*//*Label 25867*/ GIMT_Encode4(1922927), // Rule ID 23668 //
     /* 1922846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1922857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1922860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1922863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922892 */     // MIs[0] policy
     /* 1922892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1922905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922926 */     // GIR_Coverage, 23668,
     /* 1922926 */     GIR_EraseRootFromParent_Done,
     /* 1922927 */   // Label 25867: @1922927
     /* 1922927 */   GIM_Try, /*On fail goto*//*Label 25868*/ GIMT_Encode4(1923013), // Rule ID 23669 //
     /* 1922932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1922943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1922946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1922949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922978 */     // MIs[0] policy
     /* 1922978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922988 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1922991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923012 */     // GIR_Coverage, 23669,
     /* 1923012 */     GIR_EraseRootFromParent_Done,
     /* 1923013 */   // Label 25868: @1923013
     /* 1923013 */   GIM_Try, /*On fail goto*//*Label 25869*/ GIMT_Encode4(1923099), // Rule ID 23672 //
     /* 1923018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1923029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1923032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1923035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923064 */     // MIs[0] policy
     /* 1923064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923074 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923098 */     // GIR_Coverage, 23672,
     /* 1923098 */     GIR_EraseRootFromParent_Done,
     /* 1923099 */   // Label 25869: @1923099
     /* 1923099 */   GIM_Try, /*On fail goto*//*Label 25870*/ GIMT_Encode4(1923185), // Rule ID 23673 //
     /* 1923104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1923115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1923118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1923121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923150 */     // MIs[0] policy
     /* 1923150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923160 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923184 */     // GIR_Coverage, 23673,
     /* 1923184 */     GIR_EraseRootFromParent_Done,
     /* 1923185 */   // Label 25870: @1923185
     /* 1923185 */   GIM_Try, /*On fail goto*//*Label 25871*/ GIMT_Encode4(1923271), // Rule ID 23676 //
     /* 1923190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1923201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1923204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1923207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923236 */     // MIs[0] policy
     /* 1923236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923246 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923270 */     // GIR_Coverage, 23676,
     /* 1923270 */     GIR_EraseRootFromParent_Done,
     /* 1923271 */   // Label 25871: @1923271
     /* 1923271 */   GIM_Try, /*On fail goto*//*Label 25872*/ GIMT_Encode4(1923357), // Rule ID 23677 //
     /* 1923276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1923287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1923290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1923293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923322 */     // MIs[0] policy
     /* 1923322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923332 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923356 */     // GIR_Coverage, 23677,
     /* 1923356 */     GIR_EraseRootFromParent_Done,
     /* 1923357 */   // Label 25872: @1923357
     /* 1923357 */   GIM_Try, /*On fail goto*//*Label 25873*/ GIMT_Encode4(1923443), // Rule ID 23680 //
     /* 1923362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1923373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1923376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1923379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1923385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923408 */     // MIs[0] policy
     /* 1923408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923442 */     // GIR_Coverage, 23680,
     /* 1923442 */     GIR_EraseRootFromParent_Done,
     /* 1923443 */   // Label 25873: @1923443
     /* 1923443 */   GIM_Try, /*On fail goto*//*Label 25874*/ GIMT_Encode4(1923529), // Rule ID 23681 //
     /* 1923448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1923459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1923462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1923465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1923471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923494 */     // MIs[0] policy
     /* 1923494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923504 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923528 */     // GIR_Coverage, 23681,
     /* 1923528 */     GIR_EraseRootFromParent_Done,
     /* 1923529 */   // Label 25874: @1923529
     /* 1923529 */   GIM_Try, /*On fail goto*//*Label 25875*/ GIMT_Encode4(1923615), // Rule ID 23684 //
     /* 1923534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1923545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1923548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1923551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923580 */     // MIs[0] policy
     /* 1923580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923590 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923614 */     // GIR_Coverage, 23684,
     /* 1923614 */     GIR_EraseRootFromParent_Done,
     /* 1923615 */   // Label 25875: @1923615
     /* 1923615 */   GIM_Try, /*On fail goto*//*Label 25876*/ GIMT_Encode4(1923701), // Rule ID 23685 //
     /* 1923620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1923631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1923634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1923637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923666 */     // MIs[0] policy
     /* 1923666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923676 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923700 */     // GIR_Coverage, 23685,
     /* 1923700 */     GIR_EraseRootFromParent_Done,
     /* 1923701 */   // Label 25876: @1923701
     /* 1923701 */   GIM_Try, /*On fail goto*//*Label 25877*/ GIMT_Encode4(1923787), // Rule ID 23688 //
     /* 1923706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1923717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1923720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1923723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923752 */     // MIs[0] policy
     /* 1923752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923762 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923786 */     // GIR_Coverage, 23688,
     /* 1923786 */     GIR_EraseRootFromParent_Done,
     /* 1923787 */   // Label 25877: @1923787
     /* 1923787 */   GIM_Try, /*On fail goto*//*Label 25878*/ GIMT_Encode4(1923873), // Rule ID 23689 //
     /* 1923792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1923803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1923806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1923809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923838 */     // MIs[0] policy
     /* 1923838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923848 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923872 */     // GIR_Coverage, 23689,
     /* 1923872 */     GIR_EraseRootFromParent_Done,
     /* 1923873 */   // Label 25878: @1923873
     /* 1923873 */   GIM_Try, /*On fail goto*//*Label 25879*/ GIMT_Encode4(1923959), // Rule ID 23692 //
     /* 1923878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1923881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1923889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1923892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1923895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1923901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923924 */     // MIs[0] policy
     /* 1923924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923934 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1923955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923958 */     // GIR_Coverage, 23692,
     /* 1923958 */     GIR_EraseRootFromParent_Done,
     /* 1923959 */   // Label 25879: @1923959
     /* 1923959 */   GIM_Try, /*On fail goto*//*Label 25880*/ GIMT_Encode4(1924045), // Rule ID 23693 //
     /* 1923964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1923967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1923975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1923978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1923981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1923987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924010 */     // MIs[0] policy
     /* 1924010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924020 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1924023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924044 */     // GIR_Coverage, 23693,
     /* 1924044 */     GIR_EraseRootFromParent_Done,
     /* 1924045 */   // Label 25880: @1924045
     /* 1924045 */   GIM_Try, /*On fail goto*//*Label 25881*/ GIMT_Encode4(1924131), // Rule ID 23696 //
     /* 1924050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1924053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1924061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1924064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1924067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924096 */     // MIs[0] policy
     /* 1924096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924106 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1924109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924130 */     // GIR_Coverage, 23696,
     /* 1924130 */     GIR_EraseRootFromParent_Done,
     /* 1924131 */   // Label 25881: @1924131
     /* 1924131 */   GIM_Try, /*On fail goto*//*Label 25882*/ GIMT_Encode4(1924217), // Rule ID 23697 //
     /* 1924136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1924139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1924147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1924150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1924153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924182 */     // MIs[0] policy
     /* 1924182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924192 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1924195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924216 */     // GIR_Coverage, 23697,
     /* 1924216 */     GIR_EraseRootFromParent_Done,
     /* 1924217 */   // Label 25882: @1924217
     /* 1924217 */   GIM_Try, /*On fail goto*//*Label 25883*/ GIMT_Encode4(1924303), // Rule ID 23700 //
     /* 1924222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1924225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1924233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1924236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1924239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924268 */     // MIs[0] policy
     /* 1924268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924278 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1924281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924302 */     // GIR_Coverage, 23700,
     /* 1924302 */     GIR_EraseRootFromParent_Done,
     /* 1924303 */   // Label 25883: @1924303
     /* 1924303 */   GIM_Try, /*On fail goto*//*Label 25884*/ GIMT_Encode4(1924389), // Rule ID 23701 //
     /* 1924308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1924311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1924319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1924322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1924325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924354 */     // MIs[0] policy
     /* 1924354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924364 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1924367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924388 */     // GIR_Coverage, 23701,
     /* 1924388 */     GIR_EraseRootFromParent_Done,
     /* 1924389 */   // Label 25884: @1924389
     /* 1924389 */   GIM_Try, /*On fail goto*//*Label 25885*/ GIMT_Encode4(1924475), // Rule ID 23792 //
     /* 1924394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1924405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1924408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1924411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924440 */     // MIs[0] policy
     /* 1924440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924450 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1924453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924474 */     // GIR_Coverage, 23792,
     /* 1924474 */     GIR_EraseRootFromParent_Done,
     /* 1924475 */   // Label 25885: @1924475
     /* 1924475 */   GIM_Try, /*On fail goto*//*Label 25886*/ GIMT_Encode4(1924561), // Rule ID 23793 //
     /* 1924480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1924491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1924494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1924497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924526 */     // MIs[0] policy
     /* 1924526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924536 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1924539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924560 */     // GIR_Coverage, 23793,
     /* 1924560 */     GIR_EraseRootFromParent_Done,
     /* 1924561 */   // Label 25886: @1924561
     /* 1924561 */   GIM_Try, /*On fail goto*//*Label 25887*/ GIMT_Encode4(1924647), // Rule ID 23796 //
     /* 1924566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1924577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1924580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1924583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924612 */     // MIs[0] policy
     /* 1924612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924622 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1924625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924646 */     // GIR_Coverage, 23796,
     /* 1924646 */     GIR_EraseRootFromParent_Done,
     /* 1924647 */   // Label 25887: @1924647
     /* 1924647 */   GIM_Try, /*On fail goto*//*Label 25888*/ GIMT_Encode4(1924733), // Rule ID 23797 //
     /* 1924652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1924663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1924666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1924669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924698 */     // MIs[0] policy
     /* 1924698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924708 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1924711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924732 */     // GIR_Coverage, 23797,
     /* 1924732 */     GIR_EraseRootFromParent_Done,
     /* 1924733 */   // Label 25888: @1924733
     /* 1924733 */   GIM_Try, /*On fail goto*//*Label 25889*/ GIMT_Encode4(1924819), // Rule ID 23800 //
     /* 1924738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1924749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1924752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1924755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924784 */     // MIs[0] policy
     /* 1924784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924794 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1924797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924818 */     // GIR_Coverage, 23800,
     /* 1924818 */     GIR_EraseRootFromParent_Done,
     /* 1924819 */   // Label 25889: @1924819
     /* 1924819 */   GIM_Try, /*On fail goto*//*Label 25890*/ GIMT_Encode4(1924905), // Rule ID 23801 //
     /* 1924824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1924835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1924838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1924841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924870 */     // MIs[0] policy
     /* 1924870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924880 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1924883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924904 */     // GIR_Coverage, 23801,
     /* 1924904 */     GIR_EraseRootFromParent_Done,
     /* 1924905 */   // Label 25890: @1924905
     /* 1924905 */   GIM_Try, /*On fail goto*//*Label 25891*/ GIMT_Encode4(1924991), // Rule ID 23804 //
     /* 1924910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1924921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1924924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1924927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924956 */     // MIs[0] policy
     /* 1924956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924966 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1924969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924990 */     // GIR_Coverage, 23804,
     /* 1924990 */     GIR_EraseRootFromParent_Done,
     /* 1924991 */   // Label 25891: @1924991
     /* 1924991 */   GIM_Try, /*On fail goto*//*Label 25892*/ GIMT_Encode4(1925077), // Rule ID 23805 //
     /* 1924996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1925007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1925010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1925013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925042 */     // MIs[0] policy
     /* 1925042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925052 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1925055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925076 */     // GIR_Coverage, 23805,
     /* 1925076 */     GIR_EraseRootFromParent_Done,
     /* 1925077 */   // Label 25892: @1925077
     /* 1925077 */   GIM_Try, /*On fail goto*//*Label 25893*/ GIMT_Encode4(1925163), // Rule ID 23808 //
     /* 1925082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1925093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1925096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1925099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925128 */     // MIs[0] policy
     /* 1925128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925138 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925162 */     // GIR_Coverage, 23808,
     /* 1925162 */     GIR_EraseRootFromParent_Done,
     /* 1925163 */   // Label 25893: @1925163
     /* 1925163 */   GIM_Try, /*On fail goto*//*Label 25894*/ GIMT_Encode4(1925249), // Rule ID 23809 //
     /* 1925168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1925179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1925182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1925185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925214 */     // MIs[0] policy
     /* 1925214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925224 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925248 */     // GIR_Coverage, 23809,
     /* 1925248 */     GIR_EraseRootFromParent_Done,
     /* 1925249 */   // Label 25894: @1925249
     /* 1925249 */   GIM_Try, /*On fail goto*//*Label 25895*/ GIMT_Encode4(1925335), // Rule ID 23812 //
     /* 1925254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1925265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1925268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1925271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925300 */     // MIs[0] policy
     /* 1925300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925310 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925334 */     // GIR_Coverage, 23812,
     /* 1925334 */     GIR_EraseRootFromParent_Done,
     /* 1925335 */   // Label 25895: @1925335
     /* 1925335 */   GIM_Try, /*On fail goto*//*Label 25896*/ GIMT_Encode4(1925421), // Rule ID 23813 //
     /* 1925340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1925351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1925354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1925357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925386 */     // MIs[0] policy
     /* 1925386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925420 */     // GIR_Coverage, 23813,
     /* 1925420 */     GIR_EraseRootFromParent_Done,
     /* 1925421 */   // Label 25896: @1925421
     /* 1925421 */   GIM_Try, /*On fail goto*//*Label 25897*/ GIMT_Encode4(1925507), // Rule ID 23816 //
     /* 1925426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1925437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1925440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1925443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925472 */     // MIs[0] policy
     /* 1925472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925482 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925506 */     // GIR_Coverage, 23816,
     /* 1925506 */     GIR_EraseRootFromParent_Done,
     /* 1925507 */   // Label 25897: @1925507
     /* 1925507 */   GIM_Try, /*On fail goto*//*Label 25898*/ GIMT_Encode4(1925593), // Rule ID 23817 //
     /* 1925512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1925523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1925526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1925529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925558 */     // MIs[0] policy
     /* 1925558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925568 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925592 */     // GIR_Coverage, 23817,
     /* 1925592 */     GIR_EraseRootFromParent_Done,
     /* 1925593 */   // Label 25898: @1925593
     /* 1925593 */   GIM_Try, /*On fail goto*//*Label 25899*/ GIMT_Encode4(1925679), // Rule ID 23820 //
     /* 1925598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1925609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1925612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1925615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925644 */     // MIs[0] policy
     /* 1925644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925654 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925678 */     // GIR_Coverage, 23820,
     /* 1925678 */     GIR_EraseRootFromParent_Done,
     /* 1925679 */   // Label 25899: @1925679
     /* 1925679 */   GIM_Try, /*On fail goto*//*Label 25900*/ GIMT_Encode4(1925765), // Rule ID 23821 //
     /* 1925684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1925695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1925698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1925701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925730 */     // MIs[0] policy
     /* 1925730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925740 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925764 */     // GIR_Coverage, 23821,
     /* 1925764 */     GIR_EraseRootFromParent_Done,
     /* 1925765 */   // Label 25900: @1925765
     /* 1925765 */   GIM_Try, /*On fail goto*//*Label 25901*/ GIMT_Encode4(1925851), // Rule ID 23824 //
     /* 1925770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1925781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1925784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1925787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925816 */     // MIs[0] policy
     /* 1925816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925850 */     // GIR_Coverage, 23824,
     /* 1925850 */     GIR_EraseRootFromParent_Done,
     /* 1925851 */   // Label 25901: @1925851
     /* 1925851 */   GIM_Try, /*On fail goto*//*Label 25902*/ GIMT_Encode4(1925937), // Rule ID 23825 //
     /* 1925856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1925867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1925870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1925873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925902 */     // MIs[0] policy
     /* 1925902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925912 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925936 */     // GIR_Coverage, 23825,
     /* 1925936 */     GIR_EraseRootFromParent_Done,
     /* 1925937 */   // Label 25902: @1925937
     /* 1925937 */   GIM_Try, /*On fail goto*//*Label 25903*/ GIMT_Encode4(1926023), // Rule ID 23828 //
     /* 1925942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1925945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1925953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1925956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1925959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925988 */     // MIs[0] policy
     /* 1925988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925998 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1926019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926022 */     // GIR_Coverage, 23828,
     /* 1926022 */     GIR_EraseRootFromParent_Done,
     /* 1926023 */   // Label 25903: @1926023
     /* 1926023 */   GIM_Try, /*On fail goto*//*Label 25904*/ GIMT_Encode4(1926109), // Rule ID 23829 //
     /* 1926028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1926031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1926039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1926042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1926045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926074 */     // MIs[0] policy
     /* 1926074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926084 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1926105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926108 */     // GIR_Coverage, 23829,
     /* 1926108 */     GIR_EraseRootFromParent_Done,
     /* 1926109 */   // Label 25904: @1926109
     /* 1926109 */   GIM_Try, /*On fail goto*//*Label 25905*/ GIMT_Encode4(1926195), // Rule ID 23832 //
     /* 1926114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1926125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1926128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1926131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926160 */     // MIs[0] policy
     /* 1926160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926170 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1926173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926194 */     // GIR_Coverage, 23832,
     /* 1926194 */     GIR_EraseRootFromParent_Done,
     /* 1926195 */   // Label 25905: @1926195
     /* 1926195 */   GIM_Try, /*On fail goto*//*Label 25906*/ GIMT_Encode4(1926281), // Rule ID 23833 //
     /* 1926200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1926211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1926214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1926217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926246 */     // MIs[0] policy
     /* 1926246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926256 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1926259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926280 */     // GIR_Coverage, 23833,
     /* 1926280 */     GIR_EraseRootFromParent_Done,
     /* 1926281 */   // Label 25906: @1926281
     /* 1926281 */   GIM_Try, /*On fail goto*//*Label 25907*/ GIMT_Encode4(1926367), // Rule ID 23836 //
     /* 1926286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1926297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1926300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1926303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1926309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926332 */     // MIs[0] policy
     /* 1926332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926342 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1926345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926366 */     // GIR_Coverage, 23836,
     /* 1926366 */     GIR_EraseRootFromParent_Done,
     /* 1926367 */   // Label 25907: @1926367
     /* 1926367 */   GIM_Try, /*On fail goto*//*Label 25908*/ GIMT_Encode4(1926453), // Rule ID 23837 //
     /* 1926372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1926383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1926386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1926389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1926395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926418 */     // MIs[0] policy
     /* 1926418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926428 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1926431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926452 */     // GIR_Coverage, 23837,
     /* 1926452 */     GIR_EraseRootFromParent_Done,
     /* 1926453 */   // Label 25908: @1926453
     /* 1926453 */   GIM_Try, /*On fail goto*//*Label 25909*/ GIMT_Encode4(1926539), // Rule ID 23840 //
     /* 1926458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1926469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1926472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1926475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1926481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1926488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926504 */     // MIs[0] policy
     /* 1926504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926514 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1926517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926538 */     // GIR_Coverage, 23840,
     /* 1926538 */     GIR_EraseRootFromParent_Done,
     /* 1926539 */   // Label 25909: @1926539
     /* 1926539 */   GIM_Try, /*On fail goto*//*Label 25910*/ GIMT_Encode4(1926625), // Rule ID 23841 //
     /* 1926544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1926555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1926558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1926561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1926567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1926574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926590 */     // MIs[0] policy
     /* 1926590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926600 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1926603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926624 */     // GIR_Coverage, 23841,
     /* 1926624 */     GIR_EraseRootFromParent_Done,
     /* 1926625 */   // Label 25910: @1926625
     /* 1926625 */   GIM_Try, /*On fail goto*//*Label 25911*/ GIMT_Encode4(1926711), // Rule ID 23844 //
     /* 1926630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1926641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1926644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1926647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1926653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926676 */     // MIs[0] policy
     /* 1926676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1926689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926710 */     // GIR_Coverage, 23844,
     /* 1926710 */     GIR_EraseRootFromParent_Done,
     /* 1926711 */   // Label 25911: @1926711
     /* 1926711 */   GIM_Try, /*On fail goto*//*Label 25912*/ GIMT_Encode4(1926797), // Rule ID 23845 //
     /* 1926716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1926727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1926730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1926733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1926739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926762 */     // MIs[0] policy
     /* 1926762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926772 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1926775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926796 */     // GIR_Coverage, 23845,
     /* 1926796 */     GIR_EraseRootFromParent_Done,
     /* 1926797 */   // Label 25912: @1926797
     /* 1926797 */   GIM_Try, /*On fail goto*//*Label 25913*/ GIMT_Encode4(1926883), // Rule ID 23848 //
     /* 1926802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1926813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1926816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1926819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926848 */     // MIs[0] policy
     /* 1926848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926858 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1926861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926882 */     // GIR_Coverage, 23848,
     /* 1926882 */     GIR_EraseRootFromParent_Done,
     /* 1926883 */   // Label 25913: @1926883
     /* 1926883 */   GIM_Try, /*On fail goto*//*Label 25914*/ GIMT_Encode4(1926969), // Rule ID 23849 //
     /* 1926888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1926899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1926902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1926905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926934 */     // MIs[0] policy
     /* 1926934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1926947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926968 */     // GIR_Coverage, 23849,
     /* 1926968 */     GIR_EraseRootFromParent_Done,
     /* 1926969 */   // Label 25914: @1926969
     /* 1926969 */   GIM_Try, /*On fail goto*//*Label 25915*/ GIMT_Encode4(1927055), // Rule ID 23852 //
     /* 1926974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1926985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1926988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1926991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1926997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927020 */     // MIs[0] policy
     /* 1927020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927030 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927054 */     // GIR_Coverage, 23852,
     /* 1927054 */     GIR_EraseRootFromParent_Done,
     /* 1927055 */   // Label 25915: @1927055
     /* 1927055 */   GIM_Try, /*On fail goto*//*Label 25916*/ GIMT_Encode4(1927141), // Rule ID 23853 //
     /* 1927060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1927071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1927074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1927077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1927083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927106 */     // MIs[0] policy
     /* 1927106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927116 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927140 */     // GIR_Coverage, 23853,
     /* 1927140 */     GIR_EraseRootFromParent_Done,
     /* 1927141 */   // Label 25916: @1927141
     /* 1927141 */   GIM_Try, /*On fail goto*//*Label 25917*/ GIMT_Encode4(1927227), // Rule ID 23856 //
     /* 1927146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1927157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1927160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1927163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927192 */     // MIs[0] policy
     /* 1927192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927226 */     // GIR_Coverage, 23856,
     /* 1927226 */     GIR_EraseRootFromParent_Done,
     /* 1927227 */   // Label 25917: @1927227
     /* 1927227 */   GIM_Try, /*On fail goto*//*Label 25918*/ GIMT_Encode4(1927313), // Rule ID 23857 //
     /* 1927232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1927243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1927246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1927249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927278 */     // MIs[0] policy
     /* 1927278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927288 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927312 */     // GIR_Coverage, 23857,
     /* 1927312 */     GIR_EraseRootFromParent_Done,
     /* 1927313 */   // Label 25918: @1927313
     /* 1927313 */   GIM_Try, /*On fail goto*//*Label 25919*/ GIMT_Encode4(1927399), // Rule ID 23860 //
     /* 1927318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1927329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1927332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1927335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927364 */     // MIs[0] policy
     /* 1927364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927374 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927398 */     // GIR_Coverage, 23860,
     /* 1927398 */     GIR_EraseRootFromParent_Done,
     /* 1927399 */   // Label 25919: @1927399
     /* 1927399 */   GIM_Try, /*On fail goto*//*Label 25920*/ GIMT_Encode4(1927485), // Rule ID 23861 //
     /* 1927404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1927415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1927418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1927421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927450 */     // MIs[0] policy
     /* 1927450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927484 */     // GIR_Coverage, 23861,
     /* 1927484 */     GIR_EraseRootFromParent_Done,
     /* 1927485 */   // Label 25920: @1927485
     /* 1927485 */   GIM_Try, /*On fail goto*//*Label 25921*/ GIMT_Encode4(1927571), // Rule ID 23864 //
     /* 1927490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1927501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1927504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1927507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927536 */     // MIs[0] policy
     /* 1927536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927570 */     // GIR_Coverage, 23864,
     /* 1927570 */     GIR_EraseRootFromParent_Done,
     /* 1927571 */   // Label 25921: @1927571
     /* 1927571 */   GIM_Try, /*On fail goto*//*Label 25922*/ GIMT_Encode4(1927657), // Rule ID 23865 //
     /* 1927576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1927587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1927590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1927593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927622 */     // MIs[0] policy
     /* 1927622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927656 */     // GIR_Coverage, 23865,
     /* 1927656 */     GIR_EraseRootFromParent_Done,
     /* 1927657 */   // Label 25922: @1927657
     /* 1927657 */   GIM_Try, /*On fail goto*//*Label 25923*/ GIMT_Encode4(1927743), // Rule ID 23868 //
     /* 1927662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1927665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1927673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1927676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1927679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1927685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927708 */     // MIs[0] policy
     /* 1927708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927718 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927742 */     // GIR_Coverage, 23868,
     /* 1927742 */     GIR_EraseRootFromParent_Done,
     /* 1927743 */   // Label 25923: @1927743
     /* 1927743 */   GIM_Try, /*On fail goto*//*Label 25924*/ GIMT_Encode4(1927829), // Rule ID 23869 //
     /* 1927748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1927751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1927759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1927762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1927765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1927771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927794 */     // MIs[0] policy
     /* 1927794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927828 */     // GIR_Coverage, 23869,
     /* 1927828 */     GIR_EraseRootFromParent_Done,
     /* 1927829 */   // Label 25924: @1927829
     /* 1927829 */   GIM_Try, /*On fail goto*//*Label 25925*/ GIMT_Encode4(1927915), // Rule ID 23872 //
     /* 1927834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1927837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1927845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1927848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1927851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927880 */     // MIs[0] policy
     /* 1927880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927890 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927914 */     // GIR_Coverage, 23872,
     /* 1927914 */     GIR_EraseRootFromParent_Done,
     /* 1927915 */   // Label 25925: @1927915
     /* 1927915 */   GIM_Try, /*On fail goto*//*Label 25926*/ GIMT_Encode4(1928001), // Rule ID 23873 //
     /* 1927920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1927923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1927931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1927934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1927937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927966 */     // MIs[0] policy
     /* 1927966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927976 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928000 */     // GIR_Coverage, 23873,
     /* 1928000 */     GIR_EraseRootFromParent_Done,
     /* 1928001 */   // Label 25926: @1928001
     /* 1928001 */   GIM_Try, /*On fail goto*//*Label 25927*/ GIMT_Encode4(1928087), // Rule ID 23876 //
     /* 1928006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1928009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1928017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1928020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1928023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928052 */     // MIs[0] policy
     /* 1928052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928062 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1928065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928086 */     // GIR_Coverage, 23876,
     /* 1928086 */     GIR_EraseRootFromParent_Done,
     /* 1928087 */   // Label 25927: @1928087
     /* 1928087 */   GIM_Try, /*On fail goto*//*Label 25928*/ GIMT_Encode4(1928173), // Rule ID 23877 //
     /* 1928092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1928095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1928103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1928106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1928109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928138 */     // MIs[0] policy
     /* 1928138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928148 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1928151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928172 */     // GIR_Coverage, 23877,
     /* 1928172 */     GIR_EraseRootFromParent_Done,
     /* 1928173 */   // Label 25928: @1928173
     /* 1928173 */   GIM_Try, /*On fail goto*//*Label 25929*/ GIMT_Encode4(1928259), // Rule ID 23968 //
     /* 1928178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1928189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1928192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1928195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928224 */     // MIs[0] policy
     /* 1928224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928234 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1928237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928258 */     // GIR_Coverage, 23968,
     /* 1928258 */     GIR_EraseRootFromParent_Done,
     /* 1928259 */   // Label 25929: @1928259
     /* 1928259 */   GIM_Try, /*On fail goto*//*Label 25930*/ GIMT_Encode4(1928345), // Rule ID 23969 //
     /* 1928264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1928275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1928278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1928281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928310 */     // MIs[0] policy
     /* 1928310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928320 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1928323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928344 */     // GIR_Coverage, 23969,
     /* 1928344 */     GIR_EraseRootFromParent_Done,
     /* 1928345 */   // Label 25930: @1928345
     /* 1928345 */   GIM_Try, /*On fail goto*//*Label 25931*/ GIMT_Encode4(1928431), // Rule ID 23972 //
     /* 1928350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1928361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1928364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1928367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928396 */     // MIs[0] policy
     /* 1928396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928406 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1928409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928430 */     // GIR_Coverage, 23972,
     /* 1928430 */     GIR_EraseRootFromParent_Done,
     /* 1928431 */   // Label 25931: @1928431
     /* 1928431 */   GIM_Try, /*On fail goto*//*Label 25932*/ GIMT_Encode4(1928517), // Rule ID 23973 //
     /* 1928436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1928447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1928450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1928453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928482 */     // MIs[0] policy
     /* 1928482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928492 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1928495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928516 */     // GIR_Coverage, 23973,
     /* 1928516 */     GIR_EraseRootFromParent_Done,
     /* 1928517 */   // Label 25932: @1928517
     /* 1928517 */   GIM_Try, /*On fail goto*//*Label 25933*/ GIMT_Encode4(1928603), // Rule ID 23976 //
     /* 1928522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1928533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1928536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1928539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928568 */     // MIs[0] policy
     /* 1928568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928578 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1928581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928602 */     // GIR_Coverage, 23976,
     /* 1928602 */     GIR_EraseRootFromParent_Done,
     /* 1928603 */   // Label 25933: @1928603
     /* 1928603 */   GIM_Try, /*On fail goto*//*Label 25934*/ GIMT_Encode4(1928689), // Rule ID 23977 //
     /* 1928608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1928619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1928622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1928625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928654 */     // MIs[0] policy
     /* 1928654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928664 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1928667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928688 */     // GIR_Coverage, 23977,
     /* 1928688 */     GIR_EraseRootFromParent_Done,
     /* 1928689 */   // Label 25934: @1928689
     /* 1928689 */   GIM_Try, /*On fail goto*//*Label 25935*/ GIMT_Encode4(1928775), // Rule ID 23980 //
     /* 1928694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1928705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1928708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1928711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928740 */     // MIs[0] policy
     /* 1928740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928750 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1928753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928774 */     // GIR_Coverage, 23980,
     /* 1928774 */     GIR_EraseRootFromParent_Done,
     /* 1928775 */   // Label 25935: @1928775
     /* 1928775 */   GIM_Try, /*On fail goto*//*Label 25936*/ GIMT_Encode4(1928861), // Rule ID 23981 //
     /* 1928780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1928791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1928794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1928797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928826 */     // MIs[0] policy
     /* 1928826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928836 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1928839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928860 */     // GIR_Coverage, 23981,
     /* 1928860 */     GIR_EraseRootFromParent_Done,
     /* 1928861 */   // Label 25936: @1928861
     /* 1928861 */   GIM_Try, /*On fail goto*//*Label 25937*/ GIMT_Encode4(1928947), // Rule ID 23984 //
     /* 1928866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1928877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1928880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1928883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928912 */     // MIs[0] policy
     /* 1928912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928922 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1928925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928946 */     // GIR_Coverage, 23984,
     /* 1928946 */     GIR_EraseRootFromParent_Done,
     /* 1928947 */   // Label 25937: @1928947
     /* 1928947 */   GIM_Try, /*On fail goto*//*Label 25938*/ GIMT_Encode4(1929033), // Rule ID 23985 //
     /* 1928952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1928963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1928966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1928969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928998 */     // MIs[0] policy
     /* 1928998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929008 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929032 */     // GIR_Coverage, 23985,
     /* 1929032 */     GIR_EraseRootFromParent_Done,
     /* 1929033 */   // Label 25938: @1929033
     /* 1929033 */   GIM_Try, /*On fail goto*//*Label 25939*/ GIMT_Encode4(1929119), // Rule ID 23988 //
     /* 1929038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929084 */     // MIs[0] policy
     /* 1929084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929094 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929118 */     // GIR_Coverage, 23988,
     /* 1929118 */     GIR_EraseRootFromParent_Done,
     /* 1929119 */   // Label 25939: @1929119
     /* 1929119 */   GIM_Try, /*On fail goto*//*Label 25940*/ GIMT_Encode4(1929205), // Rule ID 23989 //
     /* 1929124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929170 */     // MIs[0] policy
     /* 1929170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929180 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929204 */     // GIR_Coverage, 23989,
     /* 1929204 */     GIR_EraseRootFromParent_Done,
     /* 1929205 */   // Label 25940: @1929205
     /* 1929205 */   GIM_Try, /*On fail goto*//*Label 25941*/ GIMT_Encode4(1929291), // Rule ID 23992 //
     /* 1929210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1929221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1929224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1929227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1929233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929256 */     // MIs[0] policy
     /* 1929256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929266 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929290 */     // GIR_Coverage, 23992,
     /* 1929290 */     GIR_EraseRootFromParent_Done,
     /* 1929291 */   // Label 25941: @1929291
     /* 1929291 */   GIM_Try, /*On fail goto*//*Label 25942*/ GIMT_Encode4(1929377), // Rule ID 23993 //
     /* 1929296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1929307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1929310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1929313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1929319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929342 */     // MIs[0] policy
     /* 1929342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929376 */     // GIR_Coverage, 23993,
     /* 1929376 */     GIR_EraseRootFromParent_Done,
     /* 1929377 */   // Label 25942: @1929377
     /* 1929377 */   GIM_Try, /*On fail goto*//*Label 25943*/ GIMT_Encode4(1929463), // Rule ID 23996 //
     /* 1929382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1929393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1929396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1929399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929428 */     // MIs[0] policy
     /* 1929428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929438 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929462 */     // GIR_Coverage, 23996,
     /* 1929462 */     GIR_EraseRootFromParent_Done,
     /* 1929463 */   // Label 25943: @1929463
     /* 1929463 */   GIM_Try, /*On fail goto*//*Label 25944*/ GIMT_Encode4(1929549), // Rule ID 23997 //
     /* 1929468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1929479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1929482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1929485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929514 */     // MIs[0] policy
     /* 1929514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929548 */     // GIR_Coverage, 23997,
     /* 1929548 */     GIR_EraseRootFromParent_Done,
     /* 1929549 */   // Label 25944: @1929549
     /* 1929549 */   GIM_Try, /*On fail goto*//*Label 25945*/ GIMT_Encode4(1929635), // Rule ID 24000 //
     /* 1929554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1929565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1929568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1929571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929600 */     // MIs[0] policy
     /* 1929600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929610 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929634 */     // GIR_Coverage, 24000,
     /* 1929634 */     GIR_EraseRootFromParent_Done,
     /* 1929635 */   // Label 25945: @1929635
     /* 1929635 */   GIM_Try, /*On fail goto*//*Label 25946*/ GIMT_Encode4(1929721), // Rule ID 24001 //
     /* 1929640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1929651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1929654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1929657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929686 */     // MIs[0] policy
     /* 1929686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929720 */     // GIR_Coverage, 24001,
     /* 1929720 */     GIR_EraseRootFromParent_Done,
     /* 1929721 */   // Label 25946: @1929721
     /* 1929721 */   GIM_Try, /*On fail goto*//*Label 25947*/ GIMT_Encode4(1929807), // Rule ID 24004 //
     /* 1929726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1929729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1929737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1929740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1929743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929772 */     // MIs[0] policy
     /* 1929772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929782 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929806 */     // GIR_Coverage, 24004,
     /* 1929806 */     GIR_EraseRootFromParent_Done,
     /* 1929807 */   // Label 25947: @1929807
     /* 1929807 */   GIM_Try, /*On fail goto*//*Label 25948*/ GIMT_Encode4(1929893), // Rule ID 24005 //
     /* 1929812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1929815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1929823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1929826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1929829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929858 */     // MIs[0] policy
     /* 1929858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929868 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929892 */     // GIR_Coverage, 24005,
     /* 1929892 */     GIR_EraseRootFromParent_Done,
     /* 1929893 */   // Label 25948: @1929893
     /* 1929893 */   GIM_Try, /*On fail goto*//*Label 25949*/ GIMT_Encode4(1929979), // Rule ID 24008 //
     /* 1929898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1929909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1929912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1929915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1929921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1929928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1929932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1929936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929944 */     // MIs[0] policy
     /* 1929944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929954 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1929957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929978 */     // GIR_Coverage, 24008,
     /* 1929978 */     GIR_EraseRootFromParent_Done,
     /* 1929979 */   // Label 25949: @1929979
     /* 1929979 */   GIM_Try, /*On fail goto*//*Label 25950*/ GIMT_Encode4(1930065), // Rule ID 24009 //
     /* 1929984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1929995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1929998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1930001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930030 */     // MIs[0] policy
     /* 1930030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930040 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930064 */     // GIR_Coverage, 24009,
     /* 1930064 */     GIR_EraseRootFromParent_Done,
     /* 1930065 */   // Label 25950: @1930065
     /* 1930065 */   GIM_Try, /*On fail goto*//*Label 25951*/ GIMT_Encode4(1930151), // Rule ID 24012 //
     /* 1930070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1930081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1930084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1930087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930116 */     // MIs[0] policy
     /* 1930116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930126 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1930129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930150 */     // GIR_Coverage, 24012,
     /* 1930150 */     GIR_EraseRootFromParent_Done,
     /* 1930151 */   // Label 25951: @1930151
     /* 1930151 */   GIM_Try, /*On fail goto*//*Label 25952*/ GIMT_Encode4(1930237), // Rule ID 24013 //
     /* 1930156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1930167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1930170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1930173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930202 */     // MIs[0] policy
     /* 1930202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930212 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1930215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930236 */     // GIR_Coverage, 24013,
     /* 1930236 */     GIR_EraseRootFromParent_Done,
     /* 1930237 */   // Label 25952: @1930237
     /* 1930237 */   GIM_Try, /*On fail goto*//*Label 25953*/ GIMT_Encode4(1930323), // Rule ID 24016 //
     /* 1930242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1930253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1930256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1930259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1930265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930288 */     // MIs[0] policy
     /* 1930288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930298 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1930301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930322 */     // GIR_Coverage, 24016,
     /* 1930322 */     GIR_EraseRootFromParent_Done,
     /* 1930323 */   // Label 25953: @1930323
     /* 1930323 */   GIM_Try, /*On fail goto*//*Label 25954*/ GIMT_Encode4(1930409), // Rule ID 24017 //
     /* 1930328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1930339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1930342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1930345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1930351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930374 */     // MIs[0] policy
     /* 1930374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930384 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1930387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930408 */     // GIR_Coverage, 24017,
     /* 1930408 */     GIR_EraseRootFromParent_Done,
     /* 1930409 */   // Label 25954: @1930409
     /* 1930409 */   GIM_Try, /*On fail goto*//*Label 25955*/ GIMT_Encode4(1930495), // Rule ID 24020 //
     /* 1930414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1930425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1930428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1930431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930460 */     // MIs[0] policy
     /* 1930460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930494 */     // GIR_Coverage, 24020,
     /* 1930494 */     GIR_EraseRootFromParent_Done,
     /* 1930495 */   // Label 25955: @1930495
     /* 1930495 */   GIM_Try, /*On fail goto*//*Label 25956*/ GIMT_Encode4(1930581), // Rule ID 24021 //
     /* 1930500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1930511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1930514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1930517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930546 */     // MIs[0] policy
     /* 1930546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930556 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930580 */     // GIR_Coverage, 24021,
     /* 1930580 */     GIR_EraseRootFromParent_Done,
     /* 1930581 */   // Label 25956: @1930581
     /* 1930581 */   GIM_Try, /*On fail goto*//*Label 25957*/ GIMT_Encode4(1930667), // Rule ID 24024 //
     /* 1930586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1930597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1930600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1930603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930632 */     // MIs[0] policy
     /* 1930632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930642 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1930645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930666 */     // GIR_Coverage, 24024,
     /* 1930666 */     GIR_EraseRootFromParent_Done,
     /* 1930667 */   // Label 25957: @1930667
     /* 1930667 */   GIM_Try, /*On fail goto*//*Label 25958*/ GIMT_Encode4(1930753), // Rule ID 24025 //
     /* 1930672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1930683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1930686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1930689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930718 */     // MIs[0] policy
     /* 1930718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930728 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1930731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930752 */     // GIR_Coverage, 24025,
     /* 1930752 */     GIR_EraseRootFromParent_Done,
     /* 1930753 */   // Label 25958: @1930753
     /* 1930753 */   GIM_Try, /*On fail goto*//*Label 25959*/ GIMT_Encode4(1930839), // Rule ID 24028 //
     /* 1930758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1930769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1930772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1930775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930804 */     // MIs[0] policy
     /* 1930804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930814 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1930817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930838 */     // GIR_Coverage, 24028,
     /* 1930838 */     GIR_EraseRootFromParent_Done,
     /* 1930839 */   // Label 25959: @1930839
     /* 1930839 */   GIM_Try, /*On fail goto*//*Label 25960*/ GIMT_Encode4(1930925), // Rule ID 24029 //
     /* 1930844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1930855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1930858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1930861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930890 */     // MIs[0] policy
     /* 1930890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930900 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1930903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930924 */     // GIR_Coverage, 24029,
     /* 1930924 */     GIR_EraseRootFromParent_Done,
     /* 1930925 */   // Label 25960: @1930925
     /* 1930925 */   GIM_Try, /*On fail goto*//*Label 25961*/ GIMT_Encode4(1931011), // Rule ID 24032 //
     /* 1930930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1930941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1930944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1930947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1930953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930976 */     // MIs[0] policy
     /* 1930976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931010 */     // GIR_Coverage, 24032,
     /* 1931010 */     GIR_EraseRootFromParent_Done,
     /* 1931011 */   // Label 25961: @1931011
     /* 1931011 */   GIM_Try, /*On fail goto*//*Label 25962*/ GIMT_Encode4(1931097), // Rule ID 24033 //
     /* 1931016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1931027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1931030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1931033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931062 */     // MIs[0] policy
     /* 1931062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931072 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931096 */     // GIR_Coverage, 24033,
     /* 1931096 */     GIR_EraseRootFromParent_Done,
     /* 1931097 */   // Label 25962: @1931097
     /* 1931097 */   GIM_Try, /*On fail goto*//*Label 25963*/ GIMT_Encode4(1931183), // Rule ID 24036 //
     /* 1931102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1931113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1931116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1931119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931148 */     // MIs[0] policy
     /* 1931148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931158 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931182 */     // GIR_Coverage, 24036,
     /* 1931182 */     GIR_EraseRootFromParent_Done,
     /* 1931183 */   // Label 25963: @1931183
     /* 1931183 */   GIM_Try, /*On fail goto*//*Label 25964*/ GIMT_Encode4(1931269), // Rule ID 24037 //
     /* 1931188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1931199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1931202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1931205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931234 */     // MIs[0] policy
     /* 1931234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931244 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931268 */     // GIR_Coverage, 24037,
     /* 1931268 */     GIR_EraseRootFromParent_Done,
     /* 1931269 */   // Label 25964: @1931269
     /* 1931269 */   GIM_Try, /*On fail goto*//*Label 25965*/ GIMT_Encode4(1931355), // Rule ID 24040 //
     /* 1931274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1931285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1931288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1931291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931320 */     // MIs[0] policy
     /* 1931320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931330 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931354 */     // GIR_Coverage, 24040,
     /* 1931354 */     GIR_EraseRootFromParent_Done,
     /* 1931355 */   // Label 25965: @1931355
     /* 1931355 */   GIM_Try, /*On fail goto*//*Label 25966*/ GIMT_Encode4(1931441), // Rule ID 24041 //
     /* 1931360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1931371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1931374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1931377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931406 */     // MIs[0] policy
     /* 1931406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931416 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931440 */     // GIR_Coverage, 24041,
     /* 1931440 */     GIR_EraseRootFromParent_Done,
     /* 1931441 */   // Label 25966: @1931441
     /* 1931441 */   GIM_Try, /*On fail goto*//*Label 25967*/ GIMT_Encode4(1931527), // Rule ID 24044 //
     /* 1931446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1931449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1931457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1931460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1931463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1931469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931492 */     // MIs[0] policy
     /* 1931492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931502 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931526 */     // GIR_Coverage, 24044,
     /* 1931526 */     GIR_EraseRootFromParent_Done,
     /* 1931527 */   // Label 25967: @1931527
     /* 1931527 */   GIM_Try, /*On fail goto*//*Label 25968*/ GIMT_Encode4(1931613), // Rule ID 24045 //
     /* 1931532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1931535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1931543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1931546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1931549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1931555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931578 */     // MIs[0] policy
     /* 1931578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931588 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931612 */     // GIR_Coverage, 24045,
     /* 1931612 */     GIR_EraseRootFromParent_Done,
     /* 1931613 */   // Label 25968: @1931613
     /* 1931613 */   GIM_Try, /*On fail goto*//*Label 25969*/ GIMT_Encode4(1931699), // Rule ID 24048 //
     /* 1931618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1931621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1931629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1931632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1931635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931664 */     // MIs[0] policy
     /* 1931664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931674 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931698 */     // GIR_Coverage, 24048,
     /* 1931698 */     GIR_EraseRootFromParent_Done,
     /* 1931699 */   // Label 25969: @1931699
     /* 1931699 */   GIM_Try, /*On fail goto*//*Label 25970*/ GIMT_Encode4(1931785), // Rule ID 24049 //
     /* 1931704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1931707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1931715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1931718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1931721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931750 */     // MIs[0] policy
     /* 1931750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931760 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931784 */     // GIR_Coverage, 24049,
     /* 1931784 */     GIR_EraseRootFromParent_Done,
     /* 1931785 */   // Label 25970: @1931785
     /* 1931785 */   GIM_Try, /*On fail goto*//*Label 25971*/ GIMT_Encode4(1931871), // Rule ID 24052 //
     /* 1931790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1931793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1931801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1931804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1931807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931836 */     // MIs[0] policy
     /* 1931836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931870 */     // GIR_Coverage, 24052,
     /* 1931870 */     GIR_EraseRootFromParent_Done,
     /* 1931871 */   // Label 25971: @1931871
     /* 1931871 */   GIM_Try, /*On fail goto*//*Label 25972*/ GIMT_Encode4(1931957), // Rule ID 24053 //
     /* 1931876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1931879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1931887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1931890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1931893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931922 */     // MIs[0] policy
     /* 1931922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931932 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931956 */     // GIR_Coverage, 24053,
     /* 1931956 */     GIR_EraseRootFromParent_Done,
     /* 1931957 */   // Label 25972: @1931957
     /* 1931957 */   GIM_Try, /*On fail goto*//*Label 25973*/ GIMT_Encode4(1932043), // Rule ID 24056 //
     /* 1931962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1931973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1931976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1931979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1931985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1931992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932008 */     // MIs[0] policy
     /* 1932008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932018 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1932021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932042 */     // GIR_Coverage, 24056,
     /* 1932042 */     GIR_EraseRootFromParent_Done,
     /* 1932043 */   // Label 25973: @1932043
     /* 1932043 */   GIM_Try, /*On fail goto*//*Label 25974*/ GIMT_Encode4(1932129), // Rule ID 24057 //
     /* 1932048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1932059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1932062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1932065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932094 */     // MIs[0] policy
     /* 1932094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932104 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1932107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932128 */     // GIR_Coverage, 24057,
     /* 1932128 */     GIR_EraseRootFromParent_Done,
     /* 1932129 */   // Label 25974: @1932129
     /* 1932129 */   GIM_Try, /*On fail goto*//*Label 25975*/ GIMT_Encode4(1932215), // Rule ID 24060 //
     /* 1932134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1932145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1932148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1932151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932180 */     // MIs[0] policy
     /* 1932180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932190 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932214 */     // GIR_Coverage, 24060,
     /* 1932214 */     GIR_EraseRootFromParent_Done,
     /* 1932215 */   // Label 25975: @1932215
     /* 1932215 */   GIM_Try, /*On fail goto*//*Label 25976*/ GIMT_Encode4(1932301), // Rule ID 24061 //
     /* 1932220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1932231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1932234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1932237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932266 */     // MIs[0] policy
     /* 1932266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932276 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932300 */     // GIR_Coverage, 24061,
     /* 1932300 */     GIR_EraseRootFromParent_Done,
     /* 1932301 */   // Label 25976: @1932301
     /* 1932301 */   GIM_Try, /*On fail goto*//*Label 25977*/ GIMT_Encode4(1932387), // Rule ID 24064 //
     /* 1932306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1932317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1932320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1932323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932352 */     // MIs[0] policy
     /* 1932352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932362 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932386 */     // GIR_Coverage, 24064,
     /* 1932386 */     GIR_EraseRootFromParent_Done,
     /* 1932387 */   // Label 25977: @1932387
     /* 1932387 */   GIM_Try, /*On fail goto*//*Label 25978*/ GIMT_Encode4(1932473), // Rule ID 24065 //
     /* 1932392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1932403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1932406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1932409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932438 */     // MIs[0] policy
     /* 1932438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932448 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932472 */     // GIR_Coverage, 24065,
     /* 1932472 */     GIR_EraseRootFromParent_Done,
     /* 1932473 */   // Label 25978: @1932473
     /* 1932473 */   GIM_Try, /*On fail goto*//*Label 25979*/ GIMT_Encode4(1932559), // Rule ID 24068 //
     /* 1932478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1932489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1932492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1932495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932524 */     // MIs[0] policy
     /* 1932524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932534 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932558 */     // GIR_Coverage, 24068,
     /* 1932558 */     GIR_EraseRootFromParent_Done,
     /* 1932559 */   // Label 25979: @1932559
     /* 1932559 */   GIM_Try, /*On fail goto*//*Label 25980*/ GIMT_Encode4(1932645), // Rule ID 24069 //
     /* 1932564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1932575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1932578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1932581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932610 */     // MIs[0] policy
     /* 1932610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932620 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932644 */     // GIR_Coverage, 24069,
     /* 1932644 */     GIR_EraseRootFromParent_Done,
     /* 1932645 */   // Label 25980: @1932645
     /* 1932645 */   GIM_Try, /*On fail goto*//*Label 25981*/ GIMT_Encode4(1932731), // Rule ID 24072 //
     /* 1932650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1932661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1932664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1932667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932696 */     // MIs[0] policy
     /* 1932696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932730 */     // GIR_Coverage, 24072,
     /* 1932730 */     GIR_EraseRootFromParent_Done,
     /* 1932731 */   // Label 25981: @1932731
     /* 1932731 */   GIM_Try, /*On fail goto*//*Label 25982*/ GIMT_Encode4(1932817), // Rule ID 24073 //
     /* 1932736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1932747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1932750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1932753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932782 */     // MIs[0] policy
     /* 1932782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932792 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932816 */     // GIR_Coverage, 24073,
     /* 1932816 */     GIR_EraseRootFromParent_Done,
     /* 1932817 */   // Label 25982: @1932817
     /* 1932817 */   GIM_Try, /*On fail goto*//*Label 25983*/ GIMT_Encode4(1932903), // Rule ID 24076 //
     /* 1932822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1932833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1932836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1932839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932868 */     // MIs[0] policy
     /* 1932868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932878 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932902 */     // GIR_Coverage, 24076,
     /* 1932902 */     GIR_EraseRootFromParent_Done,
     /* 1932903 */   // Label 25983: @1932903
     /* 1932903 */   GIM_Try, /*On fail goto*//*Label 25984*/ GIMT_Encode4(1932989), // Rule ID 24077 //
     /* 1932908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1932919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1932922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1932925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932954 */     // MIs[0] policy
     /* 1932954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932964 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932988 */     // GIR_Coverage, 24077,
     /* 1932988 */     GIR_EraseRootFromParent_Done,
     /* 1932989 */   // Label 25984: @1932989
     /* 1932989 */   GIM_Try, /*On fail goto*//*Label 25985*/ GIMT_Encode4(1933075), // Rule ID 24080 //
     /* 1932994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1933005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1933008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1933011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933040 */     // MIs[0] policy
     /* 1933040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933050 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933074 */     // GIR_Coverage, 24080,
     /* 1933074 */     GIR_EraseRootFromParent_Done,
     /* 1933075 */   // Label 25985: @1933075
     /* 1933075 */   GIM_Try, /*On fail goto*//*Label 25986*/ GIMT_Encode4(1933161), // Rule ID 24081 //
     /* 1933080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1933091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1933094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1933097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933126 */     // MIs[0] policy
     /* 1933126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933136 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933160 */     // GIR_Coverage, 24081,
     /* 1933160 */     GIR_EraseRootFromParent_Done,
     /* 1933161 */   // Label 25986: @1933161
     /* 1933161 */   GIM_Try, /*On fail goto*//*Label 25987*/ GIMT_Encode4(1933247), // Rule ID 24084 //
     /* 1933166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1933177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1933180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1933183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933212 */     // MIs[0] policy
     /* 1933212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933222 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933246 */     // GIR_Coverage, 24084,
     /* 1933246 */     GIR_EraseRootFromParent_Done,
     /* 1933247 */   // Label 25987: @1933247
     /* 1933247 */   GIM_Try, /*On fail goto*//*Label 25988*/ GIMT_Encode4(1933333), // Rule ID 24085 //
     /* 1933252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1933263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1933266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1933269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933298 */     // MIs[0] policy
     /* 1933298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933332 */     // GIR_Coverage, 24085,
     /* 1933332 */     GIR_EraseRootFromParent_Done,
     /* 1933333 */   // Label 25988: @1933333
     /* 1933333 */   GIM_Try, /*On fail goto*//*Label 25989*/ GIMT_Encode4(1933419), // Rule ID 24088 //
     /* 1933338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1933349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1933352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1933355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933384 */     // MIs[0] policy
     /* 1933384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933394 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933418 */     // GIR_Coverage, 24088,
     /* 1933418 */     GIR_EraseRootFromParent_Done,
     /* 1933419 */   // Label 25989: @1933419
     /* 1933419 */   GIM_Try, /*On fail goto*//*Label 25990*/ GIMT_Encode4(1933505), // Rule ID 24089 //
     /* 1933424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1933435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1933438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1933441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933470 */     // MIs[0] policy
     /* 1933470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933480 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933504 */     // GIR_Coverage, 24089,
     /* 1933504 */     GIR_EraseRootFromParent_Done,
     /* 1933505 */   // Label 25990: @1933505
     /* 1933505 */   GIM_Try, /*On fail goto*//*Label 25991*/ GIMT_Encode4(1933591), // Rule ID 24092 //
     /* 1933510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1933513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1933521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1933524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1933527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933556 */     // MIs[0] policy
     /* 1933556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933590 */     // GIR_Coverage, 24092,
     /* 1933590 */     GIR_EraseRootFromParent_Done,
     /* 1933591 */   // Label 25991: @1933591
     /* 1933591 */   GIM_Try, /*On fail goto*//*Label 25992*/ GIMT_Encode4(1933677), // Rule ID 24093 //
     /* 1933596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1933599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1933607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1933610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1933613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933642 */     // MIs[0] policy
     /* 1933642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933676 */     // GIR_Coverage, 24093,
     /* 1933676 */     GIR_EraseRootFromParent_Done,
     /* 1933677 */   // Label 25992: @1933677
     /* 1933677 */   GIM_Try, /*On fail goto*//*Label 25993*/ GIMT_Encode4(1933763), // Rule ID 24096 //
     /* 1933682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1933693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1933696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1933699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1933705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1933712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933728 */     // MIs[0] policy
     /* 1933728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933738 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1933741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933762 */     // GIR_Coverage, 24096,
     /* 1933762 */     GIR_EraseRootFromParent_Done,
     /* 1933763 */   // Label 25993: @1933763
     /* 1933763 */   GIM_Try, /*On fail goto*//*Label 25994*/ GIMT_Encode4(1933849), // Rule ID 24097 //
     /* 1933768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1933779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1933782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1933785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1933791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1933798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933814 */     // MIs[0] policy
     /* 1933814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933824 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1933827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933848 */     // GIR_Coverage, 24097,
     /* 1933848 */     GIR_EraseRootFromParent_Done,
     /* 1933849 */   // Label 25994: @1933849
     /* 1933849 */   GIM_Try, /*On fail goto*//*Label 25995*/ GIMT_Encode4(1933935), // Rule ID 24100 //
     /* 1933854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1933865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1933868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1933871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1933877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1933884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933900 */     // MIs[0] policy
     /* 1933900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933910 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1933913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933934 */     // GIR_Coverage, 24100,
     /* 1933934 */     GIR_EraseRootFromParent_Done,
     /* 1933935 */   // Label 25995: @1933935
     /* 1933935 */   GIM_Try, /*On fail goto*//*Label 25996*/ GIMT_Encode4(1934021), // Rule ID 24101 //
     /* 1933940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1933951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1933954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1933957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1933963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1933970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933986 */     // MIs[0] policy
     /* 1933986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933996 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1933999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934020 */     // GIR_Coverage, 24101,
     /* 1934020 */     GIR_EraseRootFromParent_Done,
     /* 1934021 */   // Label 25996: @1934021
     /* 1934021 */   GIM_Try, /*On fail goto*//*Label 25997*/ GIMT_Encode4(1934107), // Rule ID 24104 //
     /* 1934026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1934037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1934040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1934043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1934049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934072 */     // MIs[0] policy
     /* 1934072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934082 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1934085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934106 */     // GIR_Coverage, 24104,
     /* 1934106 */     GIR_EraseRootFromParent_Done,
     /* 1934107 */   // Label 25997: @1934107
     /* 1934107 */   GIM_Try, /*On fail goto*//*Label 25998*/ GIMT_Encode4(1934193), // Rule ID 24105 //
     /* 1934112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1934123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1934126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1934129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1934135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934158 */     // MIs[0] policy
     /* 1934158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934168 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1934171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934192 */     // GIR_Coverage, 24105,
     /* 1934192 */     GIR_EraseRootFromParent_Done,
     /* 1934193 */   // Label 25998: @1934193
     /* 1934193 */   GIM_Try, /*On fail goto*//*Label 25999*/ GIMT_Encode4(1934279), // Rule ID 24108 //
     /* 1934198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1934209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1934212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1934215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934244 */     // MIs[0] policy
     /* 1934244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934254 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934278 */     // GIR_Coverage, 24108,
     /* 1934278 */     GIR_EraseRootFromParent_Done,
     /* 1934279 */   // Label 25999: @1934279
     /* 1934279 */   GIM_Try, /*On fail goto*//*Label 26000*/ GIMT_Encode4(1934365), // Rule ID 24109 //
     /* 1934284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1934295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1934298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1934301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934330 */     // MIs[0] policy
     /* 1934330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934364 */     // GIR_Coverage, 24109,
     /* 1934364 */     GIR_EraseRootFromParent_Done,
     /* 1934365 */   // Label 26000: @1934365
     /* 1934365 */   GIM_Try, /*On fail goto*//*Label 26001*/ GIMT_Encode4(1934451), // Rule ID 24112 //
     /* 1934370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1934381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1934384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1934387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934416 */     // MIs[0] policy
     /* 1934416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934426 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934450 */     // GIR_Coverage, 24112,
     /* 1934450 */     GIR_EraseRootFromParent_Done,
     /* 1934451 */   // Label 26001: @1934451
     /* 1934451 */   GIM_Try, /*On fail goto*//*Label 26002*/ GIMT_Encode4(1934537), // Rule ID 24113 //
     /* 1934456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1934467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1934470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1934473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934502 */     // MIs[0] policy
     /* 1934502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934512 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934536 */     // GIR_Coverage, 24113,
     /* 1934536 */     GIR_EraseRootFromParent_Done,
     /* 1934537 */   // Label 26002: @1934537
     /* 1934537 */   GIM_Try, /*On fail goto*//*Label 26003*/ GIMT_Encode4(1934623), // Rule ID 24116 //
     /* 1934542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1934553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1934556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1934559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1934565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934588 */     // MIs[0] policy
     /* 1934588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934598 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1934601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934622 */     // GIR_Coverage, 24116,
     /* 1934622 */     GIR_EraseRootFromParent_Done,
     /* 1934623 */   // Label 26003: @1934623
     /* 1934623 */   GIM_Try, /*On fail goto*//*Label 26004*/ GIMT_Encode4(1934709), // Rule ID 24117 //
     /* 1934628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1934639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1934642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1934645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1934651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934674 */     // MIs[0] policy
     /* 1934674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934684 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1934687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934708 */     // GIR_Coverage, 24117,
     /* 1934708 */     GIR_EraseRootFromParent_Done,
     /* 1934709 */   // Label 26004: @1934709
     /* 1934709 */   GIM_Try, /*On fail goto*//*Label 26005*/ GIMT_Encode4(1934795), // Rule ID 24120 //
     /* 1934714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1934725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1934728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1934731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1934737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934760 */     // MIs[0] policy
     /* 1934760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934794 */     // GIR_Coverage, 24120,
     /* 1934794 */     GIR_EraseRootFromParent_Done,
     /* 1934795 */   // Label 26005: @1934795
     /* 1934795 */   GIM_Try, /*On fail goto*//*Label 26006*/ GIMT_Encode4(1934881), // Rule ID 24121 //
     /* 1934800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1934811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1934814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1934817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1934823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934846 */     // MIs[0] policy
     /* 1934846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934880 */     // GIR_Coverage, 24121,
     /* 1934880 */     GIR_EraseRootFromParent_Done,
     /* 1934881 */   // Label 26006: @1934881
     /* 1934881 */   GIM_Try, /*On fail goto*//*Label 26007*/ GIMT_Encode4(1934967), // Rule ID 24124 //
     /* 1934886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1934897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1934900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1934903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934932 */     // MIs[0] policy
     /* 1934932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934942 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934966 */     // GIR_Coverage, 24124,
     /* 1934966 */     GIR_EraseRootFromParent_Done,
     /* 1934967 */   // Label 26007: @1934967
     /* 1934967 */   GIM_Try, /*On fail goto*//*Label 26008*/ GIMT_Encode4(1935053), // Rule ID 24125 //
     /* 1934972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1934983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1934986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1934989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935018 */     // MIs[0] policy
     /* 1935018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935028 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1935031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935052 */     // GIR_Coverage, 24125,
     /* 1935052 */     GIR_EraseRootFromParent_Done,
     /* 1935053 */   // Label 26008: @1935053
     /* 1935053 */   GIM_Try, /*On fail goto*//*Label 26009*/ GIMT_Encode4(1935139), // Rule ID 24128 //
     /* 1935058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1935069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1935072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1935075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935104 */     // MIs[0] policy
     /* 1935104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935114 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935138 */     // GIR_Coverage, 24128,
     /* 1935138 */     GIR_EraseRootFromParent_Done,
     /* 1935139 */   // Label 26009: @1935139
     /* 1935139 */   GIM_Try, /*On fail goto*//*Label 26010*/ GIMT_Encode4(1935225), // Rule ID 24129 //
     /* 1935144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1935155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1935158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1935161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935190 */     // MIs[0] policy
     /* 1935190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935200 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935224 */     // GIR_Coverage, 24129,
     /* 1935224 */     GIR_EraseRootFromParent_Done,
     /* 1935225 */   // Label 26010: @1935225
     /* 1935225 */   GIM_Try, /*On fail goto*//*Label 26011*/ GIMT_Encode4(1935311), // Rule ID 24132 //
     /* 1935230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1935233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1935241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1935244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1935247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935276 */     // MIs[0] policy
     /* 1935276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935286 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1935289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935310 */     // GIR_Coverage, 24132,
     /* 1935310 */     GIR_EraseRootFromParent_Done,
     /* 1935311 */   // Label 26011: @1935311
     /* 1935311 */   GIM_Try, /*On fail goto*//*Label 26012*/ GIMT_Encode4(1935397), // Rule ID 24133 //
     /* 1935316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1935319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1935327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1935330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1935333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935362 */     // MIs[0] policy
     /* 1935362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935372 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1935375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935396 */     // GIR_Coverage, 24133,
     /* 1935396 */     GIR_EraseRootFromParent_Done,
     /* 1935397 */   // Label 26012: @1935397
     /* 1935397 */   GIM_Try, /*On fail goto*//*Label 26013*/ GIMT_Encode4(1935483), // Rule ID 24136 //
     /* 1935402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1935405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1935413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1935416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1935419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935448 */     // MIs[0] policy
     /* 1935448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935458 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1935461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935482 */     // GIR_Coverage, 24136,
     /* 1935482 */     GIR_EraseRootFromParent_Done,
     /* 1935483 */   // Label 26013: @1935483
     /* 1935483 */   GIM_Try, /*On fail goto*//*Label 26014*/ GIMT_Encode4(1935569), // Rule ID 24137 //
     /* 1935488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1935491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1935499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1935502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1935505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935534 */     // MIs[0] policy
     /* 1935534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935544 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1935547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935568 */     // GIR_Coverage, 24137,
     /* 1935568 */     GIR_EraseRootFromParent_Done,
     /* 1935569 */   // Label 26014: @1935569
     /* 1935569 */   GIM_Try, /*On fail goto*//*Label 26015*/ GIMT_Encode4(1935655), // Rule ID 24140 //
     /* 1935574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1935577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1935585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1935588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1935591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935620 */     // MIs[0] policy
     /* 1935620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935630 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935654 */     // GIR_Coverage, 24140,
     /* 1935654 */     GIR_EraseRootFromParent_Done,
     /* 1935655 */   // Label 26015: @1935655
     /* 1935655 */   GIM_Try, /*On fail goto*//*Label 26016*/ GIMT_Encode4(1935741), // Rule ID 24141 //
     /* 1935660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1935663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1935671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1935674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1935677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935706 */     // MIs[0] policy
     /* 1935706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935716 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935740 */     // GIR_Coverage, 24141,
     /* 1935740 */     GIR_EraseRootFromParent_Done,
     /* 1935741 */   // Label 26016: @1935741
     /* 1935741 */   GIM_Try, /*On fail goto*//*Label 26017*/ GIMT_Encode4(1935827), // Rule ID 24144 //
     /* 1935746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1935757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1935760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1935763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1935769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1935776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935792 */     // MIs[0] policy
     /* 1935792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935802 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1935805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935826 */     // GIR_Coverage, 24144,
     /* 1935826 */     GIR_EraseRootFromParent_Done,
     /* 1935827 */   // Label 26017: @1935827
     /* 1935827 */   GIM_Try, /*On fail goto*//*Label 26018*/ GIMT_Encode4(1935913), // Rule ID 24145 //
     /* 1935832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1935843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1935846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1935849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1935855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1935862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935878 */     // MIs[0] policy
     /* 1935878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935888 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1935891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935912 */     // GIR_Coverage, 24145,
     /* 1935912 */     GIR_EraseRootFromParent_Done,
     /* 1935913 */   // Label 26018: @1935913
     /* 1935913 */   GIM_Try, /*On fail goto*//*Label 26019*/ GIMT_Encode4(1935999), // Rule ID 24148 //
     /* 1935918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1935929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1935932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1935935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1935948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935964 */     // MIs[0] policy
     /* 1935964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935974 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1935977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935998 */     // GIR_Coverage, 24148,
     /* 1935998 */     GIR_EraseRootFromParent_Done,
     /* 1935999 */   // Label 26019: @1935999
     /* 1935999 */   GIM_Try, /*On fail goto*//*Label 26020*/ GIMT_Encode4(1936085), // Rule ID 24149 //
     /* 1936004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1936015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1936018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1936021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936050 */     // MIs[0] policy
     /* 1936050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936060 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936084 */     // GIR_Coverage, 24149,
     /* 1936084 */     GIR_EraseRootFromParent_Done,
     /* 1936085 */   // Label 26020: @1936085
     /* 1936085 */   GIM_Try, /*On fail goto*//*Label 26021*/ GIMT_Encode4(1936171), // Rule ID 24152 //
     /* 1936090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1936101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1936104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1936107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936136 */     // MIs[0] policy
     /* 1936136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936146 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936170 */     // GIR_Coverage, 24152,
     /* 1936170 */     GIR_EraseRootFromParent_Done,
     /* 1936171 */   // Label 26021: @1936171
     /* 1936171 */   GIM_Try, /*On fail goto*//*Label 26022*/ GIMT_Encode4(1936257), // Rule ID 24153 //
     /* 1936176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1936187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1936190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1936193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936222 */     // MIs[0] policy
     /* 1936222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936232 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936256 */     // GIR_Coverage, 24153,
     /* 1936256 */     GIR_EraseRootFromParent_Done,
     /* 1936257 */   // Label 26022: @1936257
     /* 1936257 */   GIM_Try, /*On fail goto*//*Label 26023*/ GIMT_Encode4(1936343), // Rule ID 24156 //
     /* 1936262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1936273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1936276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1936279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936308 */     // MIs[0] policy
     /* 1936308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936318 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936342 */     // GIR_Coverage, 24156,
     /* 1936342 */     GIR_EraseRootFromParent_Done,
     /* 1936343 */   // Label 26023: @1936343
     /* 1936343 */   GIM_Try, /*On fail goto*//*Label 26024*/ GIMT_Encode4(1936429), // Rule ID 24157 //
     /* 1936348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1936359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1936362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1936365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936394 */     // MIs[0] policy
     /* 1936394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936404 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936428 */     // GIR_Coverage, 24157,
     /* 1936428 */     GIR_EraseRootFromParent_Done,
     /* 1936429 */   // Label 26024: @1936429
     /* 1936429 */   GIM_Try, /*On fail goto*//*Label 26025*/ GIMT_Encode4(1936515), // Rule ID 24160 //
     /* 1936434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1936445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1936448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1936451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936480 */     // MIs[0] policy
     /* 1936480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936490 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936514 */     // GIR_Coverage, 24160,
     /* 1936514 */     GIR_EraseRootFromParent_Done,
     /* 1936515 */   // Label 26025: @1936515
     /* 1936515 */   GIM_Try, /*On fail goto*//*Label 26026*/ GIMT_Encode4(1936601), // Rule ID 24161 //
     /* 1936520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1936531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1936534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1936537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936566 */     // MIs[0] policy
     /* 1936566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936576 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936600 */     // GIR_Coverage, 24161,
     /* 1936600 */     GIR_EraseRootFromParent_Done,
     /* 1936601 */   // Label 26026: @1936601
     /* 1936601 */   GIM_Try, /*On fail goto*//*Label 26027*/ GIMT_Encode4(1936687), // Rule ID 24164 //
     /* 1936606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1936609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1936617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1936620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1936623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936652 */     // MIs[0] policy
     /* 1936652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936662 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936686 */     // GIR_Coverage, 24164,
     /* 1936686 */     GIR_EraseRootFromParent_Done,
     /* 1936687 */   // Label 26027: @1936687
     /* 1936687 */   GIM_Try, /*On fail goto*//*Label 26028*/ GIMT_Encode4(1936773), // Rule ID 24165 //
     /* 1936692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1936695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1936703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1936706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1936709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936738 */     // MIs[0] policy
     /* 1936738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936748 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936772 */     // GIR_Coverage, 24165,
     /* 1936772 */     GIR_EraseRootFromParent_Done,
     /* 1936773 */   // Label 26028: @1936773
     /* 1936773 */   GIM_Try, /*On fail goto*//*Label 26029*/ GIMT_Encode4(1936859), // Rule ID 24168 //
     /* 1936778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1936789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1936792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1936795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1936808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936824 */     // MIs[0] policy
     /* 1936824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936834 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1936837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936858 */     // GIR_Coverage, 24168,
     /* 1936858 */     GIR_EraseRootFromParent_Done,
     /* 1936859 */   // Label 26029: @1936859
     /* 1936859 */   GIM_Try, /*On fail goto*//*Label 26030*/ GIMT_Encode4(1936945), // Rule ID 24169 //
     /* 1936864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1936875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1936878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1936881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1936894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936910 */     // MIs[0] policy
     /* 1936910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936920 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1936923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936944 */     // GIR_Coverage, 24169,
     /* 1936944 */     GIR_EraseRootFromParent_Done,
     /* 1936945 */   // Label 26030: @1936945
     /* 1936945 */   GIM_Try, /*On fail goto*//*Label 26031*/ GIMT_Encode4(1937031), // Rule ID 24172 //
     /* 1936950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1936961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1936964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1936967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1936973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1936980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936996 */     // MIs[0] policy
     /* 1936996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937006 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1937009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937030 */     // GIR_Coverage, 24172,
     /* 1937030 */     GIR_EraseRootFromParent_Done,
     /* 1937031 */   // Label 26031: @1937031
     /* 1937031 */   GIM_Try, /*On fail goto*//*Label 26032*/ GIMT_Encode4(1937117), // Rule ID 24173 //
     /* 1937036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1937047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1937050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1937053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937082 */     // MIs[0] policy
     /* 1937082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937092 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1937095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937116 */     // GIR_Coverage, 24173,
     /* 1937116 */     GIR_EraseRootFromParent_Done,
     /* 1937117 */   // Label 26032: @1937117
     /* 1937117 */   GIM_Try, /*On fail goto*//*Label 26033*/ GIMT_Encode4(1937203), // Rule ID 24176 //
     /* 1937122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1937133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1937136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1937139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1937145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937168 */     // MIs[0] policy
     /* 1937168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937178 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1937181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937202 */     // GIR_Coverage, 24176,
     /* 1937202 */     GIR_EraseRootFromParent_Done,
     /* 1937203 */   // Label 26033: @1937203
     /* 1937203 */   GIM_Try, /*On fail goto*//*Label 26034*/ GIMT_Encode4(1937289), // Rule ID 24177 //
     /* 1937208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1937219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1937222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1937225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1937231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937254 */     // MIs[0] policy
     /* 1937254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937264 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1937267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937288 */     // GIR_Coverage, 24177,
     /* 1937288 */     GIR_EraseRootFromParent_Done,
     /* 1937289 */   // Label 26034: @1937289
     /* 1937289 */   GIM_Try, /*On fail goto*//*Label 26035*/ GIMT_Encode4(1937375), // Rule ID 24180 //
     /* 1937294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1937305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1937308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1937311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937340 */     // MIs[0] policy
     /* 1937340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937350 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937374 */     // GIR_Coverage, 24180,
     /* 1937374 */     GIR_EraseRootFromParent_Done,
     /* 1937375 */   // Label 26035: @1937375
     /* 1937375 */   GIM_Try, /*On fail goto*//*Label 26036*/ GIMT_Encode4(1937461), // Rule ID 24181 //
     /* 1937380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1937391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1937394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1937397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937426 */     // MIs[0] policy
     /* 1937426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937436 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937460 */     // GIR_Coverage, 24181,
     /* 1937460 */     GIR_EraseRootFromParent_Done,
     /* 1937461 */   // Label 26036: @1937461
     /* 1937461 */   GIM_Try, /*On fail goto*//*Label 26037*/ GIMT_Encode4(1937547), // Rule ID 24184 //
     /* 1937466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1937477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1937480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1937483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937512 */     // MIs[0] policy
     /* 1937512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937522 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1937525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937546 */     // GIR_Coverage, 24184,
     /* 1937546 */     GIR_EraseRootFromParent_Done,
     /* 1937547 */   // Label 26037: @1937547
     /* 1937547 */   GIM_Try, /*On fail goto*//*Label 26038*/ GIMT_Encode4(1937633), // Rule ID 24185 //
     /* 1937552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1937563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1937566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1937569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937598 */     // MIs[0] policy
     /* 1937598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937608 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1937611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937632 */     // GIR_Coverage, 24185,
     /* 1937632 */     GIR_EraseRootFromParent_Done,
     /* 1937633 */   // Label 26038: @1937633
     /* 1937633 */   GIM_Try, /*On fail goto*//*Label 26039*/ GIMT_Encode4(1937719), // Rule ID 24188 //
     /* 1937638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1937649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1937652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1937655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937684 */     // MIs[0] policy
     /* 1937684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937694 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1937697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937718 */     // GIR_Coverage, 24188,
     /* 1937718 */     GIR_EraseRootFromParent_Done,
     /* 1937719 */   // Label 26039: @1937719
     /* 1937719 */   GIM_Try, /*On fail goto*//*Label 26040*/ GIMT_Encode4(1937805), // Rule ID 24189 //
     /* 1937724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1937735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1937738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1937741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937770 */     // MIs[0] policy
     /* 1937770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937780 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1937783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937804 */     // GIR_Coverage, 24189,
     /* 1937804 */     GIR_EraseRootFromParent_Done,
     /* 1937805 */   // Label 26040: @1937805
     /* 1937805 */   GIM_Try, /*On fail goto*//*Label 26041*/ GIMT_Encode4(1937891), // Rule ID 24192 //
     /* 1937810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1937813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1937821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1937824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1937827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937856 */     // MIs[0] policy
     /* 1937856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937866 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937890 */     // GIR_Coverage, 24192,
     /* 1937890 */     GIR_EraseRootFromParent_Done,
     /* 1937891 */   // Label 26041: @1937891
     /* 1937891 */   GIM_Try, /*On fail goto*//*Label 26042*/ GIMT_Encode4(1937977), // Rule ID 24193 //
     /* 1937896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1937899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1937907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1937910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1937913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937942 */     // MIs[0] policy
     /* 1937942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11566:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937976 */     // GIR_Coverage, 24193,
     /* 1937976 */     GIR_EraseRootFromParent_Done,
     /* 1937977 */   // Label 26042: @1937977
     /* 1937977 */   GIM_Try, /*On fail goto*//*Label 26043*/ GIMT_Encode4(1938063), // Rule ID 24196 //
     /* 1937982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1937985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1937993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1937996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1937999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938028 */     // MIs[0] policy
     /* 1938028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938038 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1938041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938062 */     // GIR_Coverage, 24196,
     /* 1938062 */     GIR_EraseRootFromParent_Done,
     /* 1938063 */   // Label 26043: @1938063
     /* 1938063 */   GIM_Try, /*On fail goto*//*Label 26044*/ GIMT_Encode4(1938149), // Rule ID 24197 //
     /* 1938068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1938071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1938079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1938082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1938085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938114 */     // MIs[0] policy
     /* 1938114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938124 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11566:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1938127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938148 */     // GIR_Coverage, 24197,
     /* 1938148 */     GIR_EraseRootFromParent_Done,
     /* 1938149 */   // Label 26044: @1938149
     /* 1938149 */   GIM_Try, /*On fail goto*//*Label 26045*/ GIMT_Encode4(1938235), // Rule ID 24200 //
     /* 1938154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1938157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1938165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1938168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1938171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938200 */     // MIs[0] policy
     /* 1938200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938210 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1938213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938234 */     // GIR_Coverage, 24200,
     /* 1938234 */     GIR_EraseRootFromParent_Done,
     /* 1938235 */   // Label 26045: @1938235
     /* 1938235 */   GIM_Try, /*On fail goto*//*Label 26046*/ GIMT_Encode4(1938321), // Rule ID 24201 //
     /* 1938240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1938243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1938251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1938254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1938257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938286 */     // MIs[0] policy
     /* 1938286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938296 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11566:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1938299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938320 */     // GIR_Coverage, 24201,
     /* 1938320 */     GIR_EraseRootFromParent_Done,
     /* 1938321 */   // Label 26046: @1938321
     /* 1938321 */   GIM_Try, /*On fail goto*//*Label 26047*/ GIMT_Encode4(1938407), // Rule ID 24264 //
     /* 1938326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1938337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1938340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1938343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938372 */     // MIs[0] policy
     /* 1938372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938382 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1938385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938406 */     // GIR_Coverage, 24264,
     /* 1938406 */     GIR_EraseRootFromParent_Done,
     /* 1938407 */   // Label 26047: @1938407
     /* 1938407 */   GIM_Try, /*On fail goto*//*Label 26048*/ GIMT_Encode4(1938493), // Rule ID 24265 //
     /* 1938412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1938423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1938426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1938429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938458 */     // MIs[0] policy
     /* 1938458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938468 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1938471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938492 */     // GIR_Coverage, 24265,
     /* 1938492 */     GIR_EraseRootFromParent_Done,
     /* 1938493 */   // Label 26048: @1938493
     /* 1938493 */   GIM_Try, /*On fail goto*//*Label 26049*/ GIMT_Encode4(1938579), // Rule ID 24268 //
     /* 1938498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1938509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1938512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1938515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938544 */     // MIs[0] policy
     /* 1938544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938554 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1938557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938578 */     // GIR_Coverage, 24268,
     /* 1938578 */     GIR_EraseRootFromParent_Done,
     /* 1938579 */   // Label 26049: @1938579
     /* 1938579 */   GIM_Try, /*On fail goto*//*Label 26050*/ GIMT_Encode4(1938665), // Rule ID 24269 //
     /* 1938584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1938595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1938598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1938601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938630 */     // MIs[0] policy
     /* 1938630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938640 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1938643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938664 */     // GIR_Coverage, 24269,
     /* 1938664 */     GIR_EraseRootFromParent_Done,
     /* 1938665 */   // Label 26050: @1938665
     /* 1938665 */   GIM_Try, /*On fail goto*//*Label 26051*/ GIMT_Encode4(1938751), // Rule ID 24272 //
     /* 1938670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1938681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1938684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1938687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938716 */     // MIs[0] policy
     /* 1938716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938726 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1938729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938750 */     // GIR_Coverage, 24272,
     /* 1938750 */     GIR_EraseRootFromParent_Done,
     /* 1938751 */   // Label 26051: @1938751
     /* 1938751 */   GIM_Try, /*On fail goto*//*Label 26052*/ GIMT_Encode4(1938837), // Rule ID 24273 //
     /* 1938756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1938767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1938770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1938773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938802 */     // MIs[0] policy
     /* 1938802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938812 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1938815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938836 */     // GIR_Coverage, 24273,
     /* 1938836 */     GIR_EraseRootFromParent_Done,
     /* 1938837 */   // Label 26052: @1938837
     /* 1938837 */   GIM_Try, /*On fail goto*//*Label 26053*/ GIMT_Encode4(1938923), // Rule ID 24276 //
     /* 1938842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1938853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1938856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1938859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938888 */     // MIs[0] policy
     /* 1938888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938898 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1938901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938922 */     // GIR_Coverage, 24276,
     /* 1938922 */     GIR_EraseRootFromParent_Done,
     /* 1938923 */   // Label 26053: @1938923
     /* 1938923 */   GIM_Try, /*On fail goto*//*Label 26054*/ GIMT_Encode4(1939009), // Rule ID 24277 //
     /* 1938928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1938939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1938942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1938945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938974 */     // MIs[0] policy
     /* 1938974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938984 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1938987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939008 */     // GIR_Coverage, 24277,
     /* 1939008 */     GIR_EraseRootFromParent_Done,
     /* 1939009 */   // Label 26054: @1939009
     /* 1939009 */   GIM_Try, /*On fail goto*//*Label 26055*/ GIMT_Encode4(1939095), // Rule ID 24280 //
     /* 1939014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1939025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1939028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1939031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939060 */     // MIs[0] policy
     /* 1939060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939070 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939094 */     // GIR_Coverage, 24280,
     /* 1939094 */     GIR_EraseRootFromParent_Done,
     /* 1939095 */   // Label 26055: @1939095
     /* 1939095 */   GIM_Try, /*On fail goto*//*Label 26056*/ GIMT_Encode4(1939181), // Rule ID 24281 //
     /* 1939100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1939111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1939114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1939117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939146 */     // MIs[0] policy
     /* 1939146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939156 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939180 */     // GIR_Coverage, 24281,
     /* 1939180 */     GIR_EraseRootFromParent_Done,
     /* 1939181 */   // Label 26056: @1939181
     /* 1939181 */   GIM_Try, /*On fail goto*//*Label 26057*/ GIMT_Encode4(1939267), // Rule ID 24284 //
     /* 1939186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1939189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1939197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1939200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1939203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939232 */     // MIs[0] policy
     /* 1939232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939242 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939266 */     // GIR_Coverage, 24284,
     /* 1939266 */     GIR_EraseRootFromParent_Done,
     /* 1939267 */   // Label 26057: @1939267
     /* 1939267 */   GIM_Try, /*On fail goto*//*Label 26058*/ GIMT_Encode4(1939353), // Rule ID 24285 //
     /* 1939272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1939275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1939283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1939286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1939289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939318 */     // MIs[0] policy
     /* 1939318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939328 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939352 */     // GIR_Coverage, 24285,
     /* 1939352 */     GIR_EraseRootFromParent_Done,
     /* 1939353 */   // Label 26058: @1939353
     /* 1939353 */   GIM_Try, /*On fail goto*//*Label 26059*/ GIMT_Encode4(1939439), // Rule ID 24288 //
     /* 1939358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1939369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1939372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1939375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939404 */     // MIs[0] policy
     /* 1939404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939414 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1939417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939438 */     // GIR_Coverage, 24288,
     /* 1939438 */     GIR_EraseRootFromParent_Done,
     /* 1939439 */   // Label 26059: @1939439
     /* 1939439 */   GIM_Try, /*On fail goto*//*Label 26060*/ GIMT_Encode4(1939525), // Rule ID 24289 //
     /* 1939444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1939455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1939458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1939461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939490 */     // MIs[0] policy
     /* 1939490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939500 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1939503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939524 */     // GIR_Coverage, 24289,
     /* 1939524 */     GIR_EraseRootFromParent_Done,
     /* 1939525 */   // Label 26060: @1939525
     /* 1939525 */   GIM_Try, /*On fail goto*//*Label 26061*/ GIMT_Encode4(1939611), // Rule ID 24292 //
     /* 1939530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1939541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1939544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1939547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1939553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939576 */     // MIs[0] policy
     /* 1939576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939586 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1939589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939610 */     // GIR_Coverage, 24292,
     /* 1939610 */     GIR_EraseRootFromParent_Done,
     /* 1939611 */   // Label 26061: @1939611
     /* 1939611 */   GIM_Try, /*On fail goto*//*Label 26062*/ GIMT_Encode4(1939697), // Rule ID 24293 //
     /* 1939616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1939627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1939630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1939633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1939639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939662 */     // MIs[0] policy
     /* 1939662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939672 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1939675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939696 */     // GIR_Coverage, 24293,
     /* 1939696 */     GIR_EraseRootFromParent_Done,
     /* 1939697 */   // Label 26062: @1939697
     /* 1939697 */   GIM_Try, /*On fail goto*//*Label 26063*/ GIMT_Encode4(1939783), // Rule ID 24296 //
     /* 1939702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1939713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1939716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1939719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1939725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1939732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939748 */     // MIs[0] policy
     /* 1939748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939758 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1939761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939782 */     // GIR_Coverage, 24296,
     /* 1939782 */     GIR_EraseRootFromParent_Done,
     /* 1939783 */   // Label 26063: @1939783
     /* 1939783 */   GIM_Try, /*On fail goto*//*Label 26064*/ GIMT_Encode4(1939869), // Rule ID 24297 //
     /* 1939788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1939799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1939802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1939805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1939811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1939818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939834 */     // MIs[0] policy
     /* 1939834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939844 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1939847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939868 */     // GIR_Coverage, 24297,
     /* 1939868 */     GIR_EraseRootFromParent_Done,
     /* 1939869 */   // Label 26064: @1939869
     /* 1939869 */   GIM_Try, /*On fail goto*//*Label 26065*/ GIMT_Encode4(1939955), // Rule ID 24300 //
     /* 1939874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1939885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1939888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1939891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939920 */     // MIs[0] policy
     /* 1939920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939930 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1939933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939954 */     // GIR_Coverage, 24300,
     /* 1939954 */     GIR_EraseRootFromParent_Done,
     /* 1939955 */   // Label 26065: @1939955
     /* 1939955 */   GIM_Try, /*On fail goto*//*Label 26066*/ GIMT_Encode4(1940041), // Rule ID 24301 //
     /* 1939960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1939971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1939974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1939977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940006 */     // MIs[0] policy
     /* 1940006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940016 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940040 */     // GIR_Coverage, 24301,
     /* 1940040 */     GIR_EraseRootFromParent_Done,
     /* 1940041 */   // Label 26066: @1940041
     /* 1940041 */   GIM_Try, /*On fail goto*//*Label 26067*/ GIMT_Encode4(1940127), // Rule ID 24304 //
     /* 1940046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1940057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1940060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1940063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940092 */     // MIs[0] policy
     /* 1940092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940102 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940126 */     // GIR_Coverage, 24304,
     /* 1940126 */     GIR_EraseRootFromParent_Done,
     /* 1940127 */   // Label 26067: @1940127
     /* 1940127 */   GIM_Try, /*On fail goto*//*Label 26068*/ GIMT_Encode4(1940213), // Rule ID 24305 //
     /* 1940132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1940143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1940146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1940149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940178 */     // MIs[0] policy
     /* 1940178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940188 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940212 */     // GIR_Coverage, 24305,
     /* 1940212 */     GIR_EraseRootFromParent_Done,
     /* 1940213 */   // Label 26068: @1940213
     /* 1940213 */   GIM_Try, /*On fail goto*//*Label 26069*/ GIMT_Encode4(1940299), // Rule ID 24308 //
     /* 1940218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1940229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1940232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1940235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940264 */     // MIs[0] policy
     /* 1940264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940274 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940298 */     // GIR_Coverage, 24308,
     /* 1940298 */     GIR_EraseRootFromParent_Done,
     /* 1940299 */   // Label 26069: @1940299
     /* 1940299 */   GIM_Try, /*On fail goto*//*Label 26070*/ GIMT_Encode4(1940385), // Rule ID 24309 //
     /* 1940304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1940315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1940318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1940321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940350 */     // MIs[0] policy
     /* 1940350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940360 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940384 */     // GIR_Coverage, 24309,
     /* 1940384 */     GIR_EraseRootFromParent_Done,
     /* 1940385 */   // Label 26070: @1940385
     /* 1940385 */   GIM_Try, /*On fail goto*//*Label 26071*/ GIMT_Encode4(1940471), // Rule ID 24312 //
     /* 1940390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1940393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1940401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1940404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1940407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940436 */     // MIs[0] policy
     /* 1940436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940446 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940470 */     // GIR_Coverage, 24312,
     /* 1940470 */     GIR_EraseRootFromParent_Done,
     /* 1940471 */   // Label 26071: @1940471
     /* 1940471 */   GIM_Try, /*On fail goto*//*Label 26072*/ GIMT_Encode4(1940557), // Rule ID 24313 //
     /* 1940476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1940479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1940487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1940490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1940493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940522 */     // MIs[0] policy
     /* 1940522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940532 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11564:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940556 */     // GIR_Coverage, 24313,
     /* 1940556 */     GIR_EraseRootFromParent_Done,
     /* 1940557 */   // Label 26072: @1940557
     /* 1940557 */   GIM_Try, /*On fail goto*//*Label 26073*/ GIMT_Encode4(1940643), // Rule ID 24316 //
     /* 1940562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1940565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1940573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1940576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1940579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940608 */     // MIs[0] policy
     /* 1940608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940618 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940642 */     // GIR_Coverage, 24316,
     /* 1940642 */     GIR_EraseRootFromParent_Done,
     /* 1940643 */   // Label 26073: @1940643
     /* 1940643 */   GIM_Try, /*On fail goto*//*Label 26074*/ GIMT_Encode4(1940729), // Rule ID 24317 //
     /* 1940648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1940651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1940659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1940662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1940665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940694 */     // MIs[0] policy
     /* 1940694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940704 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11564:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940728 */     // GIR_Coverage, 24317,
     /* 1940728 */     GIR_EraseRootFromParent_Done,
     /* 1940729 */   // Label 26074: @1940729
     /* 1940729 */   GIM_Try, /*On fail goto*//*Label 26075*/ GIMT_Encode4(1940815), // Rule ID 24320 //
     /* 1940734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1940737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1940745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1940748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1940751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940780 */     // MIs[0] policy
     /* 1940780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940790 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940814 */     // GIR_Coverage, 24320,
     /* 1940814 */     GIR_EraseRootFromParent_Done,
     /* 1940815 */   // Label 26075: @1940815
     /* 1940815 */   GIM_Try, /*On fail goto*//*Label 26076*/ GIMT_Encode4(1940901), // Rule ID 24321 //
     /* 1940820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1940823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1940831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1940834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1940837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940866 */     // MIs[0] policy
     /* 1940866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940876 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11564:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940900 */     // GIR_Coverage, 24321,
     /* 1940900 */     GIR_EraseRootFromParent_Done,
     /* 1940901 */   // Label 26076: @1940901
     /* 1940901 */   GIM_Try, /*On fail goto*//*Label 26077*/ GIMT_Encode4(1940987), // Rule ID 24384 //
     /* 1940906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1940909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1940917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1940920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1940923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1940926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1940929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1940948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940952 */     // MIs[0] policy
     /* 1940952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940962 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1940965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940986 */     // GIR_Coverage, 24384,
     /* 1940986 */     GIR_EraseRootFromParent_Done,
     /* 1940987 */   // Label 26077: @1940987
     /* 1940987 */   GIM_Try, /*On fail goto*//*Label 26078*/ GIMT_Encode4(1941073), // Rule ID 24385 //
     /* 1940992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1940995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1941003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1941006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1941009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941038 */     // MIs[0] policy
     /* 1941038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941048 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1941051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941072 */     // GIR_Coverage, 24385,
     /* 1941072 */     GIR_EraseRootFromParent_Done,
     /* 1941073 */   // Label 26078: @1941073
     /* 1941073 */   GIM_Try, /*On fail goto*//*Label 26079*/ GIMT_Encode4(1941159), // Rule ID 24388 //
     /* 1941078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1941089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1941092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1941095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941124 */     // MIs[0] policy
     /* 1941124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941134 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1941137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941158 */     // GIR_Coverage, 24388,
     /* 1941158 */     GIR_EraseRootFromParent_Done,
     /* 1941159 */   // Label 26079: @1941159
     /* 1941159 */   GIM_Try, /*On fail goto*//*Label 26080*/ GIMT_Encode4(1941245), // Rule ID 24389 //
     /* 1941164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1941175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1941178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1941181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941210 */     // MIs[0] policy
     /* 1941210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941220 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1941223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941244 */     // GIR_Coverage, 24389,
     /* 1941244 */     GIR_EraseRootFromParent_Done,
     /* 1941245 */   // Label 26080: @1941245
     /* 1941245 */   GIM_Try, /*On fail goto*//*Label 26081*/ GIMT_Encode4(1941331), // Rule ID 24392 //
     /* 1941250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1941253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1941261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1941264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1941267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941296 */     // MIs[0] policy
     /* 1941296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941306 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1941309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941330 */     // GIR_Coverage, 24392,
     /* 1941330 */     GIR_EraseRootFromParent_Done,
     /* 1941331 */   // Label 26081: @1941331
     /* 1941331 */   GIM_Try, /*On fail goto*//*Label 26082*/ GIMT_Encode4(1941417), // Rule ID 24393 //
     /* 1941336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1941339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1941347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1941350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1941353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941382 */     // MIs[0] policy
     /* 1941382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941392 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1941395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941416 */     // GIR_Coverage, 24393,
     /* 1941416 */     GIR_EraseRootFromParent_Done,
     /* 1941417 */   // Label 26082: @1941417
     /* 1941417 */   GIM_Try, /*On fail goto*//*Label 26083*/ GIMT_Encode4(1941503), // Rule ID 24396 //
     /* 1941422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1941433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1941436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1941439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941468 */     // MIs[0] policy
     /* 1941468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941478 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1941481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941502 */     // GIR_Coverage, 24396,
     /* 1941502 */     GIR_EraseRootFromParent_Done,
     /* 1941503 */   // Label 26083: @1941503
     /* 1941503 */   GIM_Try, /*On fail goto*//*Label 26084*/ GIMT_Encode4(1941589), // Rule ID 24397 //
     /* 1941508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1941519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1941522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1941525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941554 */     // MIs[0] policy
     /* 1941554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941564 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1941567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941588 */     // GIR_Coverage, 24397,
     /* 1941588 */     GIR_EraseRootFromParent_Done,
     /* 1941589 */   // Label 26084: @1941589
     /* 1941589 */   GIM_Try, /*On fail goto*//*Label 26085*/ GIMT_Encode4(1941675), // Rule ID 24400 //
     /* 1941594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1941597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1941605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1941608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1941611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941640 */     // MIs[0] policy
     /* 1941640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941650 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1941653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941674 */     // GIR_Coverage, 24400,
     /* 1941674 */     GIR_EraseRootFromParent_Done,
     /* 1941675 */   // Label 26085: @1941675
     /* 1941675 */   GIM_Try, /*On fail goto*//*Label 26086*/ GIMT_Encode4(1941761), // Rule ID 24401 //
     /* 1941680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1941683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1941691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1941694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1941697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941726 */     // MIs[0] policy
     /* 1941726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941736 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1941739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941760 */     // GIR_Coverage, 24401,
     /* 1941760 */     GIR_EraseRootFromParent_Done,
     /* 1941761 */   // Label 26086: @1941761
     /* 1941761 */   GIM_Try, /*On fail goto*//*Label 26087*/ GIMT_Encode4(1941847), // Rule ID 24404 //
     /* 1941766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1941769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1941777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1941780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1941783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1941808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941812 */     // MIs[0] policy
     /* 1941812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941822 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1941825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941846 */     // GIR_Coverage, 24404,
     /* 1941846 */     GIR_EraseRootFromParent_Done,
     /* 1941847 */   // Label 26087: @1941847
     /* 1941847 */   GIM_Try, /*On fail goto*//*Label 26088*/ GIMT_Encode4(1941933), // Rule ID 24405 //
     /* 1941852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1941855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1941863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1941866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1941869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1941894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941898 */     // MIs[0] policy
     /* 1941898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941908 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1941911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941932 */     // GIR_Coverage, 24405,
     /* 1941932 */     GIR_EraseRootFromParent_Done,
     /* 1941933 */   // Label 26088: @1941933
     /* 1941933 */   GIM_Try, /*On fail goto*//*Label 26089*/ GIMT_Encode4(1942019), // Rule ID 24408 //
     /* 1941938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1941949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1941952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1941955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1941968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941984 */     // MIs[0] policy
     /* 1941984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941994 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1941997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942018 */     // GIR_Coverage, 24408,
     /* 1942018 */     GIR_EraseRootFromParent_Done,
     /* 1942019 */   // Label 26089: @1942019
     /* 1942019 */   GIM_Try, /*On fail goto*//*Label 26090*/ GIMT_Encode4(1942105), // Rule ID 24409 //
     /* 1942024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1942035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1942038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1942041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942070 */     // MIs[0] policy
     /* 1942070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942080 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1942083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942104 */     // GIR_Coverage, 24409,
     /* 1942104 */     GIR_EraseRootFromParent_Done,
     /* 1942105 */   // Label 26090: @1942105
     /* 1942105 */   GIM_Try, /*On fail goto*//*Label 26091*/ GIMT_Encode4(1942191), // Rule ID 24412 //
     /* 1942110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1942121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1942124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1942127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942156 */     // MIs[0] policy
     /* 1942156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942166 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1942169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942190 */     // GIR_Coverage, 24412,
     /* 1942190 */     GIR_EraseRootFromParent_Done,
     /* 1942191 */   // Label 26091: @1942191
     /* 1942191 */   GIM_Try, /*On fail goto*//*Label 26092*/ GIMT_Encode4(1942277), // Rule ID 24413 //
     /* 1942196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1942207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1942210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1942213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942242 */     // MIs[0] policy
     /* 1942242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942252 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1942255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942276 */     // GIR_Coverage, 24413,
     /* 1942276 */     GIR_EraseRootFromParent_Done,
     /* 1942277 */   // Label 26092: @1942277
     /* 1942277 */   GIM_Try, /*On fail goto*//*Label 26093*/ GIMT_Encode4(1942363), // Rule ID 24416 //
     /* 1942282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1942293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1942296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1942299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1942305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942328 */     // MIs[0] policy
     /* 1942328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942338 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11288:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1942341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942362 */     // GIR_Coverage, 24416,
     /* 1942362 */     GIR_EraseRootFromParent_Done,
     /* 1942363 */   // Label 26093: @1942363
     /* 1942363 */   GIM_Try, /*On fail goto*//*Label 26094*/ GIMT_Encode4(1942449), // Rule ID 24417 //
     /* 1942368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1942379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1942382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1942385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1942391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942414 */     // MIs[0] policy
     /* 1942414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942424 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11288:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1942427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942448 */     // GIR_Coverage, 24417,
     /* 1942448 */     GIR_EraseRootFromParent_Done,
     /* 1942449 */   // Label 26094: @1942449
     /* 1942449 */   GIM_Try, /*On fail goto*//*Label 26095*/ GIMT_Encode4(1942535), // Rule ID 24420 //
     /* 1942454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1942465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1942468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1942471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942500 */     // MIs[0] policy
     /* 1942500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942510 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1942513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942534 */     // GIR_Coverage, 24420,
     /* 1942534 */     GIR_EraseRootFromParent_Done,
     /* 1942535 */   // Label 26095: @1942535
     /* 1942535 */   GIM_Try, /*On fail goto*//*Label 26096*/ GIMT_Encode4(1942621), // Rule ID 24421 //
     /* 1942540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1942543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1942551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1942554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1942557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942586 */     // MIs[0] policy
     /* 1942586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942596 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1942599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942620 */     // GIR_Coverage, 24421,
     /* 1942620 */     GIR_EraseRootFromParent_Done,
     /* 1942621 */   // Label 26096: @1942621
     /* 1942621 */   GIM_Try, /*On fail goto*//*Label 26097*/ GIMT_Encode4(1942707), // Rule ID 24424 //
     /* 1942626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1942637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1942640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1942643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942672 */     // MIs[0] policy
     /* 1942672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942682 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1942685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942706 */     // GIR_Coverage, 24424,
     /* 1942706 */     GIR_EraseRootFromParent_Done,
     /* 1942707 */   // Label 26097: @1942707
     /* 1942707 */   GIM_Try, /*On fail goto*//*Label 26098*/ GIMT_Encode4(1942793), // Rule ID 24425 //
     /* 1942712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1942715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1942723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1942726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1942729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942758 */     // MIs[0] policy
     /* 1942758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942768 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1942771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942792 */     // GIR_Coverage, 24425,
     /* 1942792 */     GIR_EraseRootFromParent_Done,
     /* 1942793 */   // Label 26098: @1942793
     /* 1942793 */   GIM_Try, /*On fail goto*//*Label 26099*/ GIMT_Encode4(1942879), // Rule ID 24428 //
     /* 1942798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1942809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1942812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1942815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942844 */     // MIs[0] policy
     /* 1942844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942854 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11288:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1942857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942878 */     // GIR_Coverage, 24428,
     /* 1942878 */     GIR_EraseRootFromParent_Done,
     /* 1942879 */   // Label 26099: @1942879
     /* 1942879 */   GIM_Try, /*On fail goto*//*Label 26100*/ GIMT_Encode4(1942965), // Rule ID 24429 //
     /* 1942884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1942887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1942895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1942898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1942901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942930 */     // MIs[0] policy
     /* 1942930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942940 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11288:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1942943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942964 */     // GIR_Coverage, 24429,
     /* 1942964 */     GIR_EraseRootFromParent_Done,
     /* 1942965 */   // Label 26100: @1942965
     /* 1942965 */   GIM_Try, /*On fail goto*//*Label 26101*/ GIMT_Encode4(1943051), // Rule ID 24432 //
     /* 1942970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1942973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1942981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1942984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1942987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943016 */     // MIs[0] policy
     /* 1943016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943026 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1943029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943050 */     // GIR_Coverage, 24432,
     /* 1943050 */     GIR_EraseRootFromParent_Done,
     /* 1943051 */   // Label 26101: @1943051
     /* 1943051 */   GIM_Try, /*On fail goto*//*Label 26102*/ GIMT_Encode4(1943137), // Rule ID 24433 //
     /* 1943056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1943067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1943070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1943073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943102 */     // MIs[0] policy
     /* 1943102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943112 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1943115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943136 */     // GIR_Coverage, 24433,
     /* 1943136 */     GIR_EraseRootFromParent_Done,
     /* 1943137 */   // Label 26102: @1943137
     /* 1943137 */   GIM_Try, /*On fail goto*//*Label 26103*/ GIMT_Encode4(1943223), // Rule ID 24436 //
     /* 1943142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1943153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1943156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1943159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943188 */     // MIs[0] policy
     /* 1943188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943198 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1943201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943222 */     // GIR_Coverage, 24436,
     /* 1943222 */     GIR_EraseRootFromParent_Done,
     /* 1943223 */   // Label 26103: @1943223
     /* 1943223 */   GIM_Try, /*On fail goto*//*Label 26104*/ GIMT_Encode4(1943309), // Rule ID 24437 //
     /* 1943228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1943239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1943242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1943245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943274 */     // MIs[0] policy
     /* 1943274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943284 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1943287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943308 */     // GIR_Coverage, 24437,
     /* 1943308 */     GIR_EraseRootFromParent_Done,
     /* 1943309 */   // Label 26104: @1943309
     /* 1943309 */   GIM_Try, /*On fail goto*//*Label 26105*/ GIMT_Encode4(1943395), // Rule ID 24440 //
     /* 1943314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1943325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1943328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1943331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943360 */     // MIs[0] policy
     /* 1943360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943370 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11288:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1943373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943394 */     // GIR_Coverage, 24440,
     /* 1943394 */     GIR_EraseRootFromParent_Done,
     /* 1943395 */   // Label 26105: @1943395
     /* 1943395 */   GIM_Try, /*On fail goto*//*Label 26106*/ GIMT_Encode4(1943481), // Rule ID 24441 //
     /* 1943400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1943411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1943414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1943417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943446 */     // MIs[0] policy
     /* 1943446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943456 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11288:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1943459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943480 */     // GIR_Coverage, 24441,
     /* 1943480 */     GIR_EraseRootFromParent_Done,
     /* 1943481 */   // Label 26106: @1943481
     /* 1943481 */   GIM_Try, /*On fail goto*//*Label 26107*/ GIMT_Encode4(1943567), // Rule ID 24444 //
     /* 1943486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1943489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1943497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1943500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1943503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1943506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1943528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943532 */     // MIs[0] policy
     /* 1943532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943542 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1943545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943566 */     // GIR_Coverage, 24444,
     /* 1943566 */     GIR_EraseRootFromParent_Done,
     /* 1943567 */   // Label 26107: @1943567
     /* 1943567 */   GIM_Try, /*On fail goto*//*Label 26108*/ GIMT_Encode4(1943653), // Rule ID 24445 //
     /* 1943572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1943575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1943583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1943586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1943589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1943592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1943614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943618 */     // MIs[0] policy
     /* 1943618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943628 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1943631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943652 */     // GIR_Coverage, 24445,
     /* 1943652 */     GIR_EraseRootFromParent_Done,
     /* 1943653 */   // Label 26108: @1943653
     /* 1943653 */   GIM_Try, /*On fail goto*//*Label 26109*/ GIMT_Encode4(1943739), // Rule ID 24448 //
     /* 1943658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1943661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1943669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1943672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1943675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1943678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1943700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943704 */     // MIs[0] policy
     /* 1943704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943714 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1943717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943738 */     // GIR_Coverage, 24448,
     /* 1943738 */     GIR_EraseRootFromParent_Done,
     /* 1943739 */   // Label 26109: @1943739
     /* 1943739 */   GIM_Try, /*On fail goto*//*Label 26110*/ GIMT_Encode4(1943825), // Rule ID 24449 //
     /* 1943744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1943747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1943755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1943758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1943761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1943764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1943786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943790 */     // MIs[0] policy
     /* 1943790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943800 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1943803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943824 */     // GIR_Coverage, 24449,
     /* 1943824 */     GIR_EraseRootFromParent_Done,
     /* 1943825 */   // Label 26110: @1943825
     /* 1943825 */   GIM_Try, /*On fail goto*//*Label 26111*/ GIMT_Encode4(1943911), // Rule ID 24452 //
     /* 1943830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1943833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1943841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1943844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1943847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943876 */     // MIs[0] policy
     /* 1943876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943886 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1943889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943910 */     // GIR_Coverage, 24452,
     /* 1943910 */     GIR_EraseRootFromParent_Done,
     /* 1943911 */   // Label 26111: @1943911
     /* 1943911 */   GIM_Try, /*On fail goto*//*Label 26112*/ GIMT_Encode4(1943997), // Rule ID 24453 //
     /* 1943916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1943919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1943927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1943930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1943933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943962 */     // MIs[0] policy
     /* 1943962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943972 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1943975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943996 */     // GIR_Coverage, 24453,
     /* 1943996 */     GIR_EraseRootFromParent_Done,
     /* 1943997 */   // Label 26112: @1943997
     /* 1943997 */   GIM_Try, /*On fail goto*//*Label 26113*/ GIMT_Encode4(1944083), // Rule ID 24456 //
     /* 1944002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1944013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1944016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1944019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944048 */     // MIs[0] policy
     /* 1944048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944058 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1944061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944082 */     // GIR_Coverage, 24456,
     /* 1944082 */     GIR_EraseRootFromParent_Done,
     /* 1944083 */   // Label 26113: @1944083
     /* 1944083 */   GIM_Try, /*On fail goto*//*Label 26114*/ GIMT_Encode4(1944169), // Rule ID 24457 //
     /* 1944088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1944099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1944102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1944105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944134 */     // MIs[0] policy
     /* 1944134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944144 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1944147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944168 */     // GIR_Coverage, 24457,
     /* 1944168 */     GIR_EraseRootFromParent_Done,
     /* 1944169 */   // Label 26114: @1944169
     /* 1944169 */   GIM_Try, /*On fail goto*//*Label 26115*/ GIMT_Encode4(1944255), // Rule ID 24460 //
     /* 1944174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1944177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1944185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1944188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1944191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1944216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944220 */     // MIs[0] policy
     /* 1944220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944230 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1944233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944254 */     // GIR_Coverage, 24460,
     /* 1944254 */     GIR_EraseRootFromParent_Done,
     /* 1944255 */   // Label 26115: @1944255
     /* 1944255 */   GIM_Try, /*On fail goto*//*Label 26116*/ GIMT_Encode4(1944341), // Rule ID 24461 //
     /* 1944260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1944263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1944271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1944274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1944277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1944302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944306 */     // MIs[0] policy
     /* 1944306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944316 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1944319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944340 */     // GIR_Coverage, 24461,
     /* 1944340 */     GIR_EraseRootFromParent_Done,
     /* 1944341 */   // Label 26116: @1944341
     /* 1944341 */   GIM_Try, /*On fail goto*//*Label 26117*/ GIMT_Encode4(1944427), // Rule ID 24464 //
     /* 1944346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1944349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1944357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1944360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1944363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1944388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944392 */     // MIs[0] policy
     /* 1944392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944402 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1944405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944426 */     // GIR_Coverage, 24464,
     /* 1944426 */     GIR_EraseRootFromParent_Done,
     /* 1944427 */   // Label 26117: @1944427
     /* 1944427 */   GIM_Try, /*On fail goto*//*Label 26118*/ GIMT_Encode4(1944513), // Rule ID 24465 //
     /* 1944432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1944435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1944443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1944446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1944449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1944474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944478 */     // MIs[0] policy
     /* 1944478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944488 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1944491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944512 */     // GIR_Coverage, 24465,
     /* 1944512 */     GIR_EraseRootFromParent_Done,
     /* 1944513 */   // Label 26118: @1944513
     /* 1944513 */   GIM_Try, /*On fail goto*//*Label 26119*/ GIMT_Encode4(1944599), // Rule ID 24468 //
     /* 1944518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1944529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1944532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1944535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1944541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1944548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944564 */     // MIs[0] policy
     /* 1944564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944574 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1944577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944598 */     // GIR_Coverage, 24468,
     /* 1944598 */     GIR_EraseRootFromParent_Done,
     /* 1944599 */   // Label 26119: @1944599
     /* 1944599 */   GIM_Try, /*On fail goto*//*Label 26120*/ GIMT_Encode4(1944685), // Rule ID 24469 //
     /* 1944604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1944615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1944618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1944621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1944627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1944634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944650 */     // MIs[0] policy
     /* 1944650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944660 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1944663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944684 */     // GIR_Coverage, 24469,
     /* 1944684 */     GIR_EraseRootFromParent_Done,
     /* 1944685 */   // Label 26120: @1944685
     /* 1944685 */   GIM_Try, /*On fail goto*//*Label 26121*/ GIMT_Encode4(1944771), // Rule ID 24472 //
     /* 1944690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1944701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1944704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1944707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1944713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1944720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944736 */     // MIs[0] policy
     /* 1944736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944746 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1944749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944770 */     // GIR_Coverage, 24472,
     /* 1944770 */     GIR_EraseRootFromParent_Done,
     /* 1944771 */   // Label 26121: @1944771
     /* 1944771 */   GIM_Try, /*On fail goto*//*Label 26122*/ GIMT_Encode4(1944857), // Rule ID 24473 //
     /* 1944776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1944787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1944790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1944793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1944799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1944806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944822 */     // MIs[0] policy
     /* 1944822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944832 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1944835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944856 */     // GIR_Coverage, 24473,
     /* 1944856 */     GIR_EraseRootFromParent_Done,
     /* 1944857 */   // Label 26122: @1944857
     /* 1944857 */   GIM_Try, /*On fail goto*//*Label 26123*/ GIMT_Encode4(1944943), // Rule ID 24476 //
     /* 1944862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1944873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1944876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1944879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1944885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1944892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944908 */     // MIs[0] policy
     /* 1944908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944918 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1944921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944942 */     // GIR_Coverage, 24476,
     /* 1944942 */     GIR_EraseRootFromParent_Done,
     /* 1944943 */   // Label 26123: @1944943
     /* 1944943 */   GIM_Try, /*On fail goto*//*Label 26124*/ GIMT_Encode4(1945029), // Rule ID 24477 //
     /* 1944948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1944959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1944962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1944965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1944971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1944978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944994 */     // MIs[0] policy
     /* 1944994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945004 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1945007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945028 */     // GIR_Coverage, 24477,
     /* 1945028 */     GIR_EraseRootFromParent_Done,
     /* 1945029 */   // Label 26124: @1945029
     /* 1945029 */   GIM_Try, /*On fail goto*//*Label 26125*/ GIMT_Encode4(1945115), // Rule ID 24480 //
     /* 1945034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1945045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1945048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1945051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945080 */     // MIs[0] policy
     /* 1945080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945090 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1945093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945114 */     // GIR_Coverage, 24480,
     /* 1945114 */     GIR_EraseRootFromParent_Done,
     /* 1945115 */   // Label 26125: @1945115
     /* 1945115 */   GIM_Try, /*On fail goto*//*Label 26126*/ GIMT_Encode4(1945201), // Rule ID 24481 //
     /* 1945120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1945131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1945134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1945137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945166 */     // MIs[0] policy
     /* 1945166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945176 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1945179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945200 */     // GIR_Coverage, 24481,
     /* 1945200 */     GIR_EraseRootFromParent_Done,
     /* 1945201 */   // Label 26126: @1945201
     /* 1945201 */   GIM_Try, /*On fail goto*//*Label 26127*/ GIMT_Encode4(1945287), // Rule ID 24484 //
     /* 1945206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1945217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1945220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1945223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945252 */     // MIs[0] policy
     /* 1945252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945262 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1945265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945286 */     // GIR_Coverage, 24484,
     /* 1945286 */     GIR_EraseRootFromParent_Done,
     /* 1945287 */   // Label 26127: @1945287
     /* 1945287 */   GIM_Try, /*On fail goto*//*Label 26128*/ GIMT_Encode4(1945373), // Rule ID 24485 //
     /* 1945292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1945303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1945306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1945309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945338 */     // MIs[0] policy
     /* 1945338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945348 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1945351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945372 */     // GIR_Coverage, 24485,
     /* 1945372 */     GIR_EraseRootFromParent_Done,
     /* 1945373 */   // Label 26128: @1945373
     /* 1945373 */   GIM_Try, /*On fail goto*//*Label 26129*/ GIMT_Encode4(1945459), // Rule ID 24488 //
     /* 1945378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1945389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1945392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1945395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945424 */     // MIs[0] policy
     /* 1945424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945434 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1945437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945458 */     // GIR_Coverage, 24488,
     /* 1945458 */     GIR_EraseRootFromParent_Done,
     /* 1945459 */   // Label 26129: @1945459
     /* 1945459 */   GIM_Try, /*On fail goto*//*Label 26130*/ GIMT_Encode4(1945545), // Rule ID 24489 //
     /* 1945464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1945475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1945478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1945481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945510 */     // MIs[0] policy
     /* 1945510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945520 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1945523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945544 */     // GIR_Coverage, 24489,
     /* 1945544 */     GIR_EraseRootFromParent_Done,
     /* 1945545 */   // Label 26130: @1945545
     /* 1945545 */   GIM_Try, /*On fail goto*//*Label 26131*/ GIMT_Encode4(1945631), // Rule ID 24492 //
     /* 1945550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1945553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1945561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1945564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1945567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1945573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1945592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945596 */     // MIs[0] policy
     /* 1945596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945606 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1945609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945630 */     // GIR_Coverage, 24492,
     /* 1945630 */     GIR_EraseRootFromParent_Done,
     /* 1945631 */   // Label 26131: @1945631
     /* 1945631 */   GIM_Try, /*On fail goto*//*Label 26132*/ GIMT_Encode4(1945717), // Rule ID 24493 //
     /* 1945636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1945639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1945647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1945650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1945653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1945659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1945678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945682 */     // MIs[0] policy
     /* 1945682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945692 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1945695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945716 */     // GIR_Coverage, 24493,
     /* 1945716 */     GIR_EraseRootFromParent_Done,
     /* 1945717 */   // Label 26132: @1945717
     /* 1945717 */   GIM_Try, /*On fail goto*//*Label 26133*/ GIMT_Encode4(1945803), // Rule ID 24496 //
     /* 1945722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1945725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1945733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1945736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1945739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1945764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945768 */     // MIs[0] policy
     /* 1945768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945778 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1945781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945802 */     // GIR_Coverage, 24496,
     /* 1945802 */     GIR_EraseRootFromParent_Done,
     /* 1945803 */   // Label 26133: @1945803
     /* 1945803 */   GIM_Try, /*On fail goto*//*Label 26134*/ GIMT_Encode4(1945889), // Rule ID 24497 //
     /* 1945808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1945811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1945819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1945822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1945825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1945850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945854 */     // MIs[0] policy
     /* 1945854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945864 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1945867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945888 */     // GIR_Coverage, 24497,
     /* 1945888 */     GIR_EraseRootFromParent_Done,
     /* 1945889 */   // Label 26134: @1945889
     /* 1945889 */   GIM_Try, /*On fail goto*//*Label 26135*/ GIMT_Encode4(1945975), // Rule ID 24500 //
     /* 1945894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1945897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1945905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1945908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1945911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1945936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945940 */     // MIs[0] policy
     /* 1945940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945950 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1945953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945974 */     // GIR_Coverage, 24500,
     /* 1945974 */     GIR_EraseRootFromParent_Done,
     /* 1945975 */   // Label 26135: @1945975
     /* 1945975 */   GIM_Try, /*On fail goto*//*Label 26136*/ GIMT_Encode4(1946061), // Rule ID 24501 //
     /* 1945980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1945983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1945991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1945994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1945997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946026 */     // MIs[0] policy
     /* 1946026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946036 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1946039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946060 */     // GIR_Coverage, 24501,
     /* 1946060 */     GIR_EraseRootFromParent_Done,
     /* 1946061 */   // Label 26136: @1946061
     /* 1946061 */   GIM_Try, /*On fail goto*//*Label 26137*/ GIMT_Encode4(1946147), // Rule ID 24504 //
     /* 1946066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1946077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1946080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1946083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1946086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946112 */     // MIs[0] policy
     /* 1946112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946122 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1946125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946146 */     // GIR_Coverage, 24504,
     /* 1946146 */     GIR_EraseRootFromParent_Done,
     /* 1946147 */   // Label 26137: @1946147
     /* 1946147 */   GIM_Try, /*On fail goto*//*Label 26138*/ GIMT_Encode4(1946233), // Rule ID 24505 //
     /* 1946152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1946163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1946166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1946169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1946172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946198 */     // MIs[0] policy
     /* 1946198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946208 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1946211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946232 */     // GIR_Coverage, 24505,
     /* 1946232 */     GIR_EraseRootFromParent_Done,
     /* 1946233 */   // Label 26138: @1946233
     /* 1946233 */   GIM_Try, /*On fail goto*//*Label 26139*/ GIMT_Encode4(1946319), // Rule ID 24508 //
     /* 1946238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1946249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1946252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1946255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1946258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946284 */     // MIs[0] policy
     /* 1946284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946294 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1946297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946318 */     // GIR_Coverage, 24508,
     /* 1946318 */     GIR_EraseRootFromParent_Done,
     /* 1946319 */   // Label 26139: @1946319
     /* 1946319 */   GIM_Try, /*On fail goto*//*Label 26140*/ GIMT_Encode4(1946405), // Rule ID 24509 //
     /* 1946324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1946335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1946338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1946341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1946344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946370 */     // MIs[0] policy
     /* 1946370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946380 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1946383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946404 */     // GIR_Coverage, 24509,
     /* 1946404 */     GIR_EraseRootFromParent_Done,
     /* 1946405 */   // Label 26140: @1946405
     /* 1946405 */   GIM_Try, /*On fail goto*//*Label 26141*/ GIMT_Encode4(1946491), // Rule ID 24512 //
     /* 1946410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1946421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1946424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1946427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1946430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946456 */     // MIs[0] policy
     /* 1946456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946466 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1946469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946490 */     // GIR_Coverage, 24512,
     /* 1946490 */     GIR_EraseRootFromParent_Done,
     /* 1946491 */   // Label 26141: @1946491
     /* 1946491 */   GIM_Try, /*On fail goto*//*Label 26142*/ GIMT_Encode4(1946577), // Rule ID 24513 //
     /* 1946496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1946507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1946510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1946513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1946516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946542 */     // MIs[0] policy
     /* 1946542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946552 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1946555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946576 */     // GIR_Coverage, 24513,
     /* 1946576 */     GIR_EraseRootFromParent_Done,
     /* 1946577 */   // Label 26142: @1946577
     /* 1946577 */   GIM_Try, /*On fail goto*//*Label 26143*/ GIMT_Encode4(1946663), // Rule ID 24516 //
     /* 1946582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1946593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1946596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1946599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1946602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946628 */     // MIs[0] policy
     /* 1946628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946638 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1946641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946662 */     // GIR_Coverage, 24516,
     /* 1946662 */     GIR_EraseRootFromParent_Done,
     /* 1946663 */   // Label 26143: @1946663
     /* 1946663 */   GIM_Try, /*On fail goto*//*Label 26144*/ GIMT_Encode4(1946749), // Rule ID 24517 //
     /* 1946668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1946679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1946682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1946685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1946688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946714 */     // MIs[0] policy
     /* 1946714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946724 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1946727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946748 */     // GIR_Coverage, 24517,
     /* 1946748 */     GIR_EraseRootFromParent_Done,
     /* 1946749 */   // Label 26144: @1946749
     /* 1946749 */   GIM_Try, /*On fail goto*//*Label 26145*/ GIMT_Encode4(1946835), // Rule ID 24520 //
     /* 1946754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1946765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1946768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1946771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1946774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946800 */     // MIs[0] policy
     /* 1946800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946810 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1946813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946834 */     // GIR_Coverage, 24520,
     /* 1946834 */     GIR_EraseRootFromParent_Done,
     /* 1946835 */   // Label 26145: @1946835
     /* 1946835 */   GIM_Try, /*On fail goto*//*Label 26146*/ GIMT_Encode4(1946921), // Rule ID 24521 //
     /* 1946840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1946851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1946854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1946857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1946860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946886 */     // MIs[0] policy
     /* 1946886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1946899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946920 */     // GIR_Coverage, 24521,
     /* 1946920 */     GIR_EraseRootFromParent_Done,
     /* 1946921 */   // Label 26146: @1946921
     /* 1946921 */   GIM_Try, /*On fail goto*//*Label 26147*/ GIMT_Encode4(1947007), // Rule ID 24524 //
     /* 1946926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1946937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1946940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1946943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1946946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946972 */     // MIs[0] policy
     /* 1946972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946982 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1946985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947006 */     // GIR_Coverage, 24524,
     /* 1947006 */     GIR_EraseRootFromParent_Done,
     /* 1947007 */   // Label 26147: @1947007
     /* 1947007 */   GIM_Try, /*On fail goto*//*Label 26148*/ GIMT_Encode4(1947093), // Rule ID 24525 //
     /* 1947012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1947023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1947026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1947029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1947032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947058 */     // MIs[0] policy
     /* 1947058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947068 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1947071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947092 */     // GIR_Coverage, 24525,
     /* 1947092 */     GIR_EraseRootFromParent_Done,
     /* 1947093 */   // Label 26148: @1947093
     /* 1947093 */   GIM_Try, /*On fail goto*//*Label 26149*/ GIMT_Encode4(1947179), // Rule ID 24528 //
     /* 1947098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1947109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1947112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1947115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1947118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947144 */     // MIs[0] policy
     /* 1947144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947154 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1947157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947178 */     // GIR_Coverage, 24528,
     /* 1947178 */     GIR_EraseRootFromParent_Done,
     /* 1947179 */   // Label 26149: @1947179
     /* 1947179 */   GIM_Try, /*On fail goto*//*Label 26150*/ GIMT_Encode4(1947265), // Rule ID 24529 //
     /* 1947184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1947195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1947198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1947201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1947204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947230 */     // MIs[0] policy
     /* 1947230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947240 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1947243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947264 */     // GIR_Coverage, 24529,
     /* 1947264 */     GIR_EraseRootFromParent_Done,
     /* 1947265 */   // Label 26150: @1947265
     /* 1947265 */   GIM_Try, /*On fail goto*//*Label 26151*/ GIMT_Encode4(1947351), // Rule ID 24532 //
     /* 1947270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1947281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1947284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1947287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1947290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947316 */     // MIs[0] policy
     /* 1947316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947326 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1947329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947350 */     // GIR_Coverage, 24532,
     /* 1947350 */     GIR_EraseRootFromParent_Done,
     /* 1947351 */   // Label 26151: @1947351
     /* 1947351 */   GIM_Try, /*On fail goto*//*Label 26152*/ GIMT_Encode4(1947437), // Rule ID 24533 //
     /* 1947356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1947367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1947370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1947373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1947376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947402 */     // MIs[0] policy
     /* 1947402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947412 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1947415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947436 */     // GIR_Coverage, 24533,
     /* 1947436 */     GIR_EraseRootFromParent_Done,
     /* 1947437 */   // Label 26152: @1947437
     /* 1947437 */   GIM_Try, /*On fail goto*//*Label 26153*/ GIMT_Encode4(1947523), // Rule ID 24536 //
     /* 1947442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1947453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1947456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1947459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1947462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947488 */     // MIs[0] policy
     /* 1947488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947498 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1947501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947522 */     // GIR_Coverage, 24536,
     /* 1947522 */     GIR_EraseRootFromParent_Done,
     /* 1947523 */   // Label 26153: @1947523
     /* 1947523 */   GIM_Try, /*On fail goto*//*Label 26154*/ GIMT_Encode4(1947609), // Rule ID 24537 //
     /* 1947528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1947539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1947542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1947545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1947548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947574 */     // MIs[0] policy
     /* 1947574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1947587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947608 */     // GIR_Coverage, 24537,
     /* 1947608 */     GIR_EraseRootFromParent_Done,
     /* 1947609 */   // Label 26154: @1947609
     /* 1947609 */   GIM_Try, /*On fail goto*//*Label 26155*/ GIMT_Encode4(1947695), // Rule ID 24540 //
     /* 1947614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1947617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1947625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1947628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1947631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1947634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947660 */     // MIs[0] policy
     /* 1947660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947670 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1947673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947694 */     // GIR_Coverage, 24540,
     /* 1947694 */     GIR_EraseRootFromParent_Done,
     /* 1947695 */   // Label 26155: @1947695
     /* 1947695 */   GIM_Try, /*On fail goto*//*Label 26156*/ GIMT_Encode4(1947781), // Rule ID 24541 //
     /* 1947700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1947703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1947711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1947714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1947717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1947720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947746 */     // MIs[0] policy
     /* 1947746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947756 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1947759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947780 */     // GIR_Coverage, 24541,
     /* 1947780 */     GIR_EraseRootFromParent_Done,
     /* 1947781 */   // Label 26156: @1947781
     /* 1947781 */   GIM_Try, /*On fail goto*//*Label 26157*/ GIMT_Encode4(1947867), // Rule ID 24544 //
     /* 1947786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1947797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1947800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1947803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1947806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1947809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1947816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947832 */     // MIs[0] policy
     /* 1947832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947842 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1947845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947866 */     // GIR_Coverage, 24544,
     /* 1947866 */     GIR_EraseRootFromParent_Done,
     /* 1947867 */   // Label 26157: @1947867
     /* 1947867 */   GIM_Try, /*On fail goto*//*Label 26158*/ GIMT_Encode4(1947953), // Rule ID 24545 //
     /* 1947872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1947883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1947886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1947889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1947892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1947895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1947902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947918 */     // MIs[0] policy
     /* 1947918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947928 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1947931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947952 */     // GIR_Coverage, 24545,
     /* 1947952 */     GIR_EraseRootFromParent_Done,
     /* 1947953 */   // Label 26158: @1947953
     /* 1947953 */   GIM_Try, /*On fail goto*//*Label 26159*/ GIMT_Encode4(1948039), // Rule ID 24548 //
     /* 1947958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1947969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1947972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1947975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1947978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1947981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1947988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948004 */     // MIs[0] policy
     /* 1948004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948014 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1948017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948038 */     // GIR_Coverage, 24548,
     /* 1948038 */     GIR_EraseRootFromParent_Done,
     /* 1948039 */   // Label 26159: @1948039
     /* 1948039 */   GIM_Try, /*On fail goto*//*Label 26160*/ GIMT_Encode4(1948125), // Rule ID 24549 //
     /* 1948044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1948055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1948058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1948061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1948064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948090 */     // MIs[0] policy
     /* 1948090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948100 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1948103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948124 */     // GIR_Coverage, 24549,
     /* 1948124 */     GIR_EraseRootFromParent_Done,
     /* 1948125 */   // Label 26160: @1948125
     /* 1948125 */   GIM_Try, /*On fail goto*//*Label 26161*/ GIMT_Encode4(1948211), // Rule ID 24552 //
     /* 1948130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1948141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1948144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1948147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1948150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1948153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948176 */     // MIs[0] policy
     /* 1948176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948186 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1948189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948210 */     // GIR_Coverage, 24552,
     /* 1948210 */     GIR_EraseRootFromParent_Done,
     /* 1948211 */   // Label 26161: @1948211
     /* 1948211 */   GIM_Try, /*On fail goto*//*Label 26162*/ GIMT_Encode4(1948297), // Rule ID 24553 //
     /* 1948216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1948227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1948230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1948233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1948236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1948239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948262 */     // MIs[0] policy
     /* 1948262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948272 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1948275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948296 */     // GIR_Coverage, 24553,
     /* 1948296 */     GIR_EraseRootFromParent_Done,
     /* 1948297 */   // Label 26162: @1948297
     /* 1948297 */   GIM_Try, /*On fail goto*//*Label 26163*/ GIMT_Encode4(1948383), // Rule ID 24556 //
     /* 1948302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1948313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1948316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1948319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1948322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948348 */     // MIs[0] policy
     /* 1948348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948358 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1948361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948382 */     // GIR_Coverage, 24556,
     /* 1948382 */     GIR_EraseRootFromParent_Done,
     /* 1948383 */   // Label 26163: @1948383
     /* 1948383 */   GIM_Try, /*On fail goto*//*Label 26164*/ GIMT_Encode4(1948469), // Rule ID 24557 //
     /* 1948388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1948399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1948402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1948405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1948408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948434 */     // MIs[0] policy
     /* 1948434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1948447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948468 */     // GIR_Coverage, 24557,
     /* 1948468 */     GIR_EraseRootFromParent_Done,
     /* 1948469 */   // Label 26164: @1948469
     /* 1948469 */   GIM_Try, /*On fail goto*//*Label 26165*/ GIMT_Encode4(1948555), // Rule ID 24560 //
     /* 1948474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1948485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1948488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1948491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1948494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948520 */     // MIs[0] policy
     /* 1948520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948530 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1948533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948554 */     // GIR_Coverage, 24560,
     /* 1948554 */     GIR_EraseRootFromParent_Done,
     /* 1948555 */   // Label 26165: @1948555
     /* 1948555 */   GIM_Try, /*On fail goto*//*Label 26166*/ GIMT_Encode4(1948641), // Rule ID 24561 //
     /* 1948560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1948571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1948574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1948577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1948580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948606 */     // MIs[0] policy
     /* 1948606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948616 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1948619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948640 */     // GIR_Coverage, 24561,
     /* 1948640 */     GIR_EraseRootFromParent_Done,
     /* 1948641 */   // Label 26166: @1948641
     /* 1948641 */   GIM_Try, /*On fail goto*//*Label 26167*/ GIMT_Encode4(1948727), // Rule ID 24564 //
     /* 1948646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1948657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1948660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1948663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1948666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948692 */     // MIs[0] policy
     /* 1948692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948702 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1948705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948726 */     // GIR_Coverage, 24564,
     /* 1948726 */     GIR_EraseRootFromParent_Done,
     /* 1948727 */   // Label 26167: @1948727
     /* 1948727 */   GIM_Try, /*On fail goto*//*Label 26168*/ GIMT_Encode4(1948813), // Rule ID 24565 //
     /* 1948732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1948743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1948746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1948749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1948752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948778 */     // MIs[0] policy
     /* 1948778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948788 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1948791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948812 */     // GIR_Coverage, 24565,
     /* 1948812 */     GIR_EraseRootFromParent_Done,
     /* 1948813 */   // Label 26168: @1948813
     /* 1948813 */   GIM_Try, /*On fail goto*//*Label 26169*/ GIMT_Encode4(1948899), // Rule ID 24568 //
     /* 1948818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1948829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1948832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1948835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1948838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948864 */     // MIs[0] policy
     /* 1948864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1948877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948898 */     // GIR_Coverage, 24568,
     /* 1948898 */     GIR_EraseRootFromParent_Done,
     /* 1948899 */   // Label 26169: @1948899
     /* 1948899 */   GIM_Try, /*On fail goto*//*Label 26170*/ GIMT_Encode4(1948985), // Rule ID 24569 //
     /* 1948904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1948915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1948918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1948921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1948924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948950 */     // MIs[0] policy
     /* 1948950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948960 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1948963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948984 */     // GIR_Coverage, 24569,
     /* 1948984 */     GIR_EraseRootFromParent_Done,
     /* 1948985 */   // Label 26170: @1948985
     /* 1948985 */   GIM_Try, /*On fail goto*//*Label 26171*/ GIMT_Encode4(1949071), // Rule ID 24572 //
     /* 1948990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1949001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1949004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1949007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1949010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949036 */     // MIs[0] policy
     /* 1949036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1949049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949070 */     // GIR_Coverage, 24572,
     /* 1949070 */     GIR_EraseRootFromParent_Done,
     /* 1949071 */   // Label 26171: @1949071
     /* 1949071 */   GIM_Try, /*On fail goto*//*Label 26172*/ GIMT_Encode4(1949157), // Rule ID 24573 //
     /* 1949076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1949087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1949090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1949093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1949096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949122 */     // MIs[0] policy
     /* 1949122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949132 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1949135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949156 */     // GIR_Coverage, 24573,
     /* 1949156 */     GIR_EraseRootFromParent_Done,
     /* 1949157 */   // Label 26172: @1949157
     /* 1949157 */   GIM_Try, /*On fail goto*//*Label 26173*/ GIMT_Encode4(1949243), // Rule ID 24576 //
     /* 1949162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1949173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1949176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1949179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1949182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949208 */     // MIs[0] policy
     /* 1949208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949218 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1949221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949242 */     // GIR_Coverage, 24576,
     /* 1949242 */     GIR_EraseRootFromParent_Done,
     /* 1949243 */   // Label 26173: @1949243
     /* 1949243 */   GIM_Try, /*On fail goto*//*Label 26174*/ GIMT_Encode4(1949329), // Rule ID 24577 //
     /* 1949248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1949259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1949262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1949265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1949268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949294 */     // MIs[0] policy
     /* 1949294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949304 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1949307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949328 */     // GIR_Coverage, 24577,
     /* 1949328 */     GIR_EraseRootFromParent_Done,
     /* 1949329 */   // Label 26174: @1949329
     /* 1949329 */   GIM_Try, /*On fail goto*//*Label 26175*/ GIMT_Encode4(1949415), // Rule ID 24580 //
     /* 1949334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1949337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1949345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1949348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1949351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1949354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949380 */     // MIs[0] policy
     /* 1949380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949390 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1949393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949414 */     // GIR_Coverage, 24580,
     /* 1949414 */     GIR_EraseRootFromParent_Done,
     /* 1949415 */   // Label 26175: @1949415
     /* 1949415 */   GIM_Try, /*On fail goto*//*Label 26176*/ GIMT_Encode4(1949501), // Rule ID 24581 //
     /* 1949420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1949423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1949431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1949434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1949437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1949440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949466 */     // MIs[0] policy
     /* 1949466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1949479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949500 */     // GIR_Coverage, 24581,
     /* 1949500 */     GIR_EraseRootFromParent_Done,
     /* 1949501 */   // Label 26176: @1949501
     /* 1949501 */   GIM_Try, /*On fail goto*//*Label 26177*/ GIMT_Encode4(1949587), // Rule ID 24584 //
     /* 1949506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1949509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1949517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1949520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1949523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1949526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949552 */     // MIs[0] policy
     /* 1949552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949562 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1949565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949586 */     // GIR_Coverage, 24584,
     /* 1949586 */     GIR_EraseRootFromParent_Done,
     /* 1949587 */   // Label 26177: @1949587
     /* 1949587 */   GIM_Try, /*On fail goto*//*Label 26178*/ GIMT_Encode4(1949673), // Rule ID 24585 //
     /* 1949592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1949595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1949603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1949606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1949609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1949612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949638 */     // MIs[0] policy
     /* 1949638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949648 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1949651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949672 */     // GIR_Coverage, 24585,
     /* 1949672 */     GIR_EraseRootFromParent_Done,
     /* 1949673 */   // Label 26178: @1949673
     /* 1949673 */   GIM_Try, /*On fail goto*//*Label 26179*/ GIMT_Encode4(1949759), // Rule ID 24588 //
     /* 1949678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1949681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1949689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1949692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1949695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1949698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949724 */     // MIs[0] policy
     /* 1949724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949734 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1949737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949758 */     // GIR_Coverage, 24588,
     /* 1949758 */     GIR_EraseRootFromParent_Done,
     /* 1949759 */   // Label 26179: @1949759
     /* 1949759 */   GIM_Try, /*On fail goto*//*Label 26180*/ GIMT_Encode4(1949845), // Rule ID 24589 //
     /* 1949764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1949767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1949775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1949778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1949781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1949784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949810 */     // MIs[0] policy
     /* 1949810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949820 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1949823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949844 */     // GIR_Coverage, 24589,
     /* 1949844 */     GIR_EraseRootFromParent_Done,
     /* 1949845 */   // Label 26180: @1949845
     /* 1949845 */   GIM_Try, /*On fail goto*//*Label 26181*/ GIMT_Encode4(1949931), // Rule ID 24592 //
     /* 1949850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1949861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1949864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1949867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1949873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949896 */     // MIs[0] policy
     /* 1949896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949906 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1949909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949930 */     // GIR_Coverage, 24592,
     /* 1949930 */     GIR_EraseRootFromParent_Done,
     /* 1949931 */   // Label 26181: @1949931
     /* 1949931 */   GIM_Try, /*On fail goto*//*Label 26182*/ GIMT_Encode4(1950017), // Rule ID 24593 //
     /* 1949936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1949947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1949950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1949953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1949959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949982 */     // MIs[0] policy
     /* 1949982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949992 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1949995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950016 */     // GIR_Coverage, 24593,
     /* 1950016 */     GIR_EraseRootFromParent_Done,
     /* 1950017 */   // Label 26182: @1950017
     /* 1950017 */   GIM_Try, /*On fail goto*//*Label 26183*/ GIMT_Encode4(1950103), // Rule ID 24596 //
     /* 1950022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1950033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1950036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1950039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950068 */     // MIs[0] policy
     /* 1950068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950078 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950102 */     // GIR_Coverage, 24596,
     /* 1950102 */     GIR_EraseRootFromParent_Done,
     /* 1950103 */   // Label 26183: @1950103
     /* 1950103 */   GIM_Try, /*On fail goto*//*Label 26184*/ GIMT_Encode4(1950189), // Rule ID 24597 //
     /* 1950108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1950119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1950122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1950125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950154 */     // MIs[0] policy
     /* 1950154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950164 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950188 */     // GIR_Coverage, 24597,
     /* 1950188 */     GIR_EraseRootFromParent_Done,
     /* 1950189 */   // Label 26184: @1950189
     /* 1950189 */   GIM_Try, /*On fail goto*//*Label 26185*/ GIMT_Encode4(1950275), // Rule ID 24600 //
     /* 1950194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1950205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1950208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1950211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950240 */     // MIs[0] policy
     /* 1950240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950250 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950274 */     // GIR_Coverage, 24600,
     /* 1950274 */     GIR_EraseRootFromParent_Done,
     /* 1950275 */   // Label 26185: @1950275
     /* 1950275 */   GIM_Try, /*On fail goto*//*Label 26186*/ GIMT_Encode4(1950361), // Rule ID 24601 //
     /* 1950280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1950291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1950294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1950297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950326 */     // MIs[0] policy
     /* 1950326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950336 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950360 */     // GIR_Coverage, 24601,
     /* 1950360 */     GIR_EraseRootFromParent_Done,
     /* 1950361 */   // Label 26186: @1950361
     /* 1950361 */   GIM_Try, /*On fail goto*//*Label 26187*/ GIMT_Encode4(1950447), // Rule ID 24604 //
     /* 1950366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1950377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1950380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1950383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950412 */     // MIs[0] policy
     /* 1950412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950422 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950446 */     // GIR_Coverage, 24604,
     /* 1950446 */     GIR_EraseRootFromParent_Done,
     /* 1950447 */   // Label 26187: @1950447
     /* 1950447 */   GIM_Try, /*On fail goto*//*Label 26188*/ GIMT_Encode4(1950533), // Rule ID 24605 //
     /* 1950452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1950463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1950466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1950469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950498 */     // MIs[0] policy
     /* 1950498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950508 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950532 */     // GIR_Coverage, 24605,
     /* 1950532 */     GIR_EraseRootFromParent_Done,
     /* 1950533 */   // Label 26188: @1950533
     /* 1950533 */   GIM_Try, /*On fail goto*//*Label 26189*/ GIMT_Encode4(1950619), // Rule ID 24608 //
     /* 1950538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1950549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1950552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1950555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950584 */     // MIs[0] policy
     /* 1950584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950594 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950618 */     // GIR_Coverage, 24608,
     /* 1950618 */     GIR_EraseRootFromParent_Done,
     /* 1950619 */   // Label 26189: @1950619
     /* 1950619 */   GIM_Try, /*On fail goto*//*Label 26190*/ GIMT_Encode4(1950705), // Rule ID 24609 //
     /* 1950624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1950635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1950638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1950641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950670 */     // MIs[0] policy
     /* 1950670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950680 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950704 */     // GIR_Coverage, 24609,
     /* 1950704 */     GIR_EraseRootFromParent_Done,
     /* 1950705 */   // Label 26190: @1950705
     /* 1950705 */   GIM_Try, /*On fail goto*//*Label 26191*/ GIMT_Encode4(1950791), // Rule ID 24612 //
     /* 1950710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1950721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1950724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1950727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950756 */     // MIs[0] policy
     /* 1950756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950766 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950790 */     // GIR_Coverage, 24612,
     /* 1950790 */     GIR_EraseRootFromParent_Done,
     /* 1950791 */   // Label 26191: @1950791
     /* 1950791 */   GIM_Try, /*On fail goto*//*Label 26192*/ GIMT_Encode4(1950877), // Rule ID 24613 //
     /* 1950796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1950807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1950810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1950813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950842 */     // MIs[0] policy
     /* 1950842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950852 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950876 */     // GIR_Coverage, 24613,
     /* 1950876 */     GIR_EraseRootFromParent_Done,
     /* 1950877 */   // Label 26192: @1950877
     /* 1950877 */   GIM_Try, /*On fail goto*//*Label 26193*/ GIMT_Encode4(1950963), // Rule ID 24616 //
     /* 1950882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1950893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1950896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1950899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950928 */     // MIs[0] policy
     /* 1950928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950938 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1950941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950962 */     // GIR_Coverage, 24616,
     /* 1950962 */     GIR_EraseRootFromParent_Done,
     /* 1950963 */   // Label 26193: @1950963
     /* 1950963 */   GIM_Try, /*On fail goto*//*Label 26194*/ GIMT_Encode4(1951049), // Rule ID 24617 //
     /* 1950968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1950979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1950982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1950985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951014 */     // MIs[0] policy
     /* 1951014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951024 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11536:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951048 */     // GIR_Coverage, 24617,
     /* 1951048 */     GIR_EraseRootFromParent_Done,
     /* 1951049 */   // Label 26194: @1951049
     /* 1951049 */   GIM_Try, /*On fail goto*//*Label 26195*/ GIMT_Encode4(1951135), // Rule ID 24620 //
     /* 1951054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1951065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1951068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1951071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951100 */     // MIs[0] policy
     /* 1951100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951110 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951134 */     // GIR_Coverage, 24620,
     /* 1951134 */     GIR_EraseRootFromParent_Done,
     /* 1951135 */   // Label 26195: @1951135
     /* 1951135 */   GIM_Try, /*On fail goto*//*Label 26196*/ GIMT_Encode4(1951221), // Rule ID 24621 //
     /* 1951140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1951151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1951154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1951157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951186 */     // MIs[0] policy
     /* 1951186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951196 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951220 */     // GIR_Coverage, 24621,
     /* 1951220 */     GIR_EraseRootFromParent_Done,
     /* 1951221 */   // Label 26196: @1951221
     /* 1951221 */   GIM_Try, /*On fail goto*//*Label 26197*/ GIMT_Encode4(1951307), // Rule ID 24624 //
     /* 1951226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1951237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1951240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1951243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951272 */     // MIs[0] policy
     /* 1951272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951282 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951306 */     // GIR_Coverage, 24624,
     /* 1951306 */     GIR_EraseRootFromParent_Done,
     /* 1951307 */   // Label 26197: @1951307
     /* 1951307 */   GIM_Try, /*On fail goto*//*Label 26198*/ GIMT_Encode4(1951393), // Rule ID 24625 //
     /* 1951312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1951323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1951326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1951329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951358 */     // MIs[0] policy
     /* 1951358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951368 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951392 */     // GIR_Coverage, 24625,
     /* 1951392 */     GIR_EraseRootFromParent_Done,
     /* 1951393 */   // Label 26198: @1951393
     /* 1951393 */   GIM_Try, /*On fail goto*//*Label 26199*/ GIMT_Encode4(1951479), // Rule ID 24628 //
     /* 1951398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1951401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1951409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1951412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1951415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951444 */     // MIs[0] policy
     /* 1951444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951454 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951478 */     // GIR_Coverage, 24628,
     /* 1951478 */     GIR_EraseRootFromParent_Done,
     /* 1951479 */   // Label 26199: @1951479
     /* 1951479 */   GIM_Try, /*On fail goto*//*Label 26200*/ GIMT_Encode4(1951565), // Rule ID 24629 //
     /* 1951484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1951487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1951495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1951498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1951501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951530 */     // MIs[0] policy
     /* 1951530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951540 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951564 */     // GIR_Coverage, 24629,
     /* 1951564 */     GIR_EraseRootFromParent_Done,
     /* 1951565 */   // Label 26200: @1951565
     /* 1951565 */   GIM_Try, /*On fail goto*//*Label 26201*/ GIMT_Encode4(1951651), // Rule ID 24632 //
     /* 1951570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1951581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1951584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1951587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1951593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951616 */     // MIs[0] policy
     /* 1951616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951626 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1951629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951650 */     // GIR_Coverage, 24632,
     /* 1951650 */     GIR_EraseRootFromParent_Done,
     /* 1951651 */   // Label 26201: @1951651
     /* 1951651 */   GIM_Try, /*On fail goto*//*Label 26202*/ GIMT_Encode4(1951737), // Rule ID 24633 //
     /* 1951656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1951667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1951670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1951673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1951679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951702 */     // MIs[0] policy
     /* 1951702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951712 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1951715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951736 */     // GIR_Coverage, 24633,
     /* 1951736 */     GIR_EraseRootFromParent_Done,
     /* 1951737 */   // Label 26202: @1951737
     /* 1951737 */   GIM_Try, /*On fail goto*//*Label 26203*/ GIMT_Encode4(1951823), // Rule ID 24636 //
     /* 1951742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1951753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1951756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1951759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1951765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951788 */     // MIs[0] policy
     /* 1951788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951798 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1951801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951822 */     // GIR_Coverage, 24636,
     /* 1951822 */     GIR_EraseRootFromParent_Done,
     /* 1951823 */   // Label 26203: @1951823
     /* 1951823 */   GIM_Try, /*On fail goto*//*Label 26204*/ GIMT_Encode4(1951909), // Rule ID 24637 //
     /* 1951828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1951839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1951842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1951845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1951851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951874 */     // MIs[0] policy
     /* 1951874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951884 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1951887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951908 */     // GIR_Coverage, 24637,
     /* 1951908 */     GIR_EraseRootFromParent_Done,
     /* 1951909 */   // Label 26204: @1951909
     /* 1951909 */   GIM_Try, /*On fail goto*//*Label 26205*/ GIMT_Encode4(1951995), // Rule ID 24640 //
     /* 1951914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1951925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1951928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1951931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1951937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1951944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951960 */     // MIs[0] policy
     /* 1951960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951970 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1951973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951994 */     // GIR_Coverage, 24640,
     /* 1951994 */     GIR_EraseRootFromParent_Done,
     /* 1951995 */   // Label 26205: @1951995
     /* 1951995 */   GIM_Try, /*On fail goto*//*Label 26206*/ GIMT_Encode4(1952081), // Rule ID 24641 //
     /* 1952000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1952011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1952014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1952017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1952023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952046 */     // MIs[0] policy
     /* 1952046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952056 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1952059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952080 */     // GIR_Coverage, 24641,
     /* 1952080 */     GIR_EraseRootFromParent_Done,
     /* 1952081 */   // Label 26206: @1952081
     /* 1952081 */   GIM_Try, /*On fail goto*//*Label 26207*/ GIMT_Encode4(1952167), // Rule ID 24644 //
     /* 1952086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1952097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1952100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1952103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952132 */     // MIs[0] policy
     /* 1952132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952142 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952166 */     // GIR_Coverage, 24644,
     /* 1952166 */     GIR_EraseRootFromParent_Done,
     /* 1952167 */   // Label 26207: @1952167
     /* 1952167 */   GIM_Try, /*On fail goto*//*Label 26208*/ GIMT_Encode4(1952253), // Rule ID 24645 //
     /* 1952172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1952183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1952186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1952189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952218 */     // MIs[0] policy
     /* 1952218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952252 */     // GIR_Coverage, 24645,
     /* 1952252 */     GIR_EraseRootFromParent_Done,
     /* 1952253 */   // Label 26208: @1952253
     /* 1952253 */   GIM_Try, /*On fail goto*//*Label 26209*/ GIMT_Encode4(1952339), // Rule ID 24648 //
     /* 1952258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1952269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1952272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1952275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952304 */     // MIs[0] policy
     /* 1952304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952314 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952338 */     // GIR_Coverage, 24648,
     /* 1952338 */     GIR_EraseRootFromParent_Done,
     /* 1952339 */   // Label 26209: @1952339
     /* 1952339 */   GIM_Try, /*On fail goto*//*Label 26210*/ GIMT_Encode4(1952425), // Rule ID 24649 //
     /* 1952344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1952355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1952358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1952361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952390 */     // MIs[0] policy
     /* 1952390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952424 */     // GIR_Coverage, 24649,
     /* 1952424 */     GIR_EraseRootFromParent_Done,
     /* 1952425 */   // Label 26210: @1952425
     /* 1952425 */   GIM_Try, /*On fail goto*//*Label 26211*/ GIMT_Encode4(1952511), // Rule ID 24652 //
     /* 1952430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1952441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1952444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1952447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952476 */     // MIs[0] policy
     /* 1952476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952486 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1952489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952510 */     // GIR_Coverage, 24652,
     /* 1952510 */     GIR_EraseRootFromParent_Done,
     /* 1952511 */   // Label 26211: @1952511
     /* 1952511 */   GIM_Try, /*On fail goto*//*Label 26212*/ GIMT_Encode4(1952597), // Rule ID 24653 //
     /* 1952516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1952527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1952530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1952533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952562 */     // MIs[0] policy
     /* 1952562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952572 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1952575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952596 */     // GIR_Coverage, 24653,
     /* 1952596 */     GIR_EraseRootFromParent_Done,
     /* 1952597 */   // Label 26212: @1952597
     /* 1952597 */   GIM_Try, /*On fail goto*//*Label 26213*/ GIMT_Encode4(1952683), // Rule ID 24656 //
     /* 1952602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1952613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1952616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1952619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952648 */     // MIs[0] policy
     /* 1952648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952658 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952682 */     // GIR_Coverage, 24656,
     /* 1952682 */     GIR_EraseRootFromParent_Done,
     /* 1952683 */   // Label 26213: @1952683
     /* 1952683 */   GIM_Try, /*On fail goto*//*Label 26214*/ GIMT_Encode4(1952769), // Rule ID 24657 //
     /* 1952688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1952699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1952702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1952705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952734 */     // MIs[0] policy
     /* 1952734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952768 */     // GIR_Coverage, 24657,
     /* 1952768 */     GIR_EraseRootFromParent_Done,
     /* 1952769 */   // Label 26214: @1952769
     /* 1952769 */   GIM_Try, /*On fail goto*//*Label 26215*/ GIMT_Encode4(1952855), // Rule ID 24660 //
     /* 1952774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1952785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1952788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1952791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952820 */     // MIs[0] policy
     /* 1952820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952830 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952854 */     // GIR_Coverage, 24660,
     /* 1952854 */     GIR_EraseRootFromParent_Done,
     /* 1952855 */   // Label 26215: @1952855
     /* 1952855 */   GIM_Try, /*On fail goto*//*Label 26216*/ GIMT_Encode4(1952941), // Rule ID 24661 //
     /* 1952860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1952871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1952874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1952877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952906 */     // MIs[0] policy
     /* 1952906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952916 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952940 */     // GIR_Coverage, 24661,
     /* 1952940 */     GIR_EraseRootFromParent_Done,
     /* 1952941 */   // Label 26216: @1952941
     /* 1952941 */   GIM_Try, /*On fail goto*//*Label 26217*/ GIMT_Encode4(1953027), // Rule ID 24664 //
     /* 1952946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1952957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1952960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1952963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952992 */     // MIs[0] policy
     /* 1952992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953002 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953026 */     // GIR_Coverage, 24664,
     /* 1953026 */     GIR_EraseRootFromParent_Done,
     /* 1953027 */   // Label 26217: @1953027
     /* 1953027 */   GIM_Try, /*On fail goto*//*Label 26218*/ GIMT_Encode4(1953113), // Rule ID 24665 //
     /* 1953032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1953043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1953046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1953049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953078 */     // MIs[0] policy
     /* 1953078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953088 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953112 */     // GIR_Coverage, 24665,
     /* 1953112 */     GIR_EraseRootFromParent_Done,
     /* 1953113 */   // Label 26218: @1953113
     /* 1953113 */   GIM_Try, /*On fail goto*//*Label 26219*/ GIMT_Encode4(1953199), // Rule ID 24668 //
     /* 1953118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1953129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1953132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1953135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953164 */     // MIs[0] policy
     /* 1953164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953174 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953198 */     // GIR_Coverage, 24668,
     /* 1953198 */     GIR_EraseRootFromParent_Done,
     /* 1953199 */   // Label 26219: @1953199
     /* 1953199 */   GIM_Try, /*On fail goto*//*Label 26220*/ GIMT_Encode4(1953285), // Rule ID 24669 //
     /* 1953204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1953215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1953218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1953221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953250 */     // MIs[0] policy
     /* 1953250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953260 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953284 */     // GIR_Coverage, 24669,
     /* 1953284 */     GIR_EraseRootFromParent_Done,
     /* 1953285 */   // Label 26220: @1953285
     /* 1953285 */   GIM_Try, /*On fail goto*//*Label 26221*/ GIMT_Encode4(1953371), // Rule ID 24672 //
     /* 1953290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1953301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1953304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1953307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953336 */     // MIs[0] policy
     /* 1953336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953346 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953370 */     // GIR_Coverage, 24672,
     /* 1953370 */     GIR_EraseRootFromParent_Done,
     /* 1953371 */   // Label 26221: @1953371
     /* 1953371 */   GIM_Try, /*On fail goto*//*Label 26222*/ GIMT_Encode4(1953457), // Rule ID 24673 //
     /* 1953376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1953387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1953390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1953393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953422 */     // MIs[0] policy
     /* 1953422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953432 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953456 */     // GIR_Coverage, 24673,
     /* 1953456 */     GIR_EraseRootFromParent_Done,
     /* 1953457 */   // Label 26222: @1953457
     /* 1953457 */   GIM_Try, /*On fail goto*//*Label 26223*/ GIMT_Encode4(1953543), // Rule ID 24676 //
     /* 1953462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1953473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1953476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1953479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953508 */     // MIs[0] policy
     /* 1953508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953518 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953542 */     // GIR_Coverage, 24676,
     /* 1953542 */     GIR_EraseRootFromParent_Done,
     /* 1953543 */   // Label 26223: @1953543
     /* 1953543 */   GIM_Try, /*On fail goto*//*Label 26224*/ GIMT_Encode4(1953629), // Rule ID 24677 //
     /* 1953548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1953559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1953562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1953565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953594 */     // MIs[0] policy
     /* 1953594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953604 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953628 */     // GIR_Coverage, 24677,
     /* 1953628 */     GIR_EraseRootFromParent_Done,
     /* 1953629 */   // Label 26224: @1953629
     /* 1953629 */   GIM_Try, /*On fail goto*//*Label 26225*/ GIMT_Encode4(1953715), // Rule ID 24768 //
     /* 1953634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1953645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1953648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1953651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1953654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1953657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953680 */     // MIs[0] policy
     /* 1953680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953690 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1953693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953714 */     // GIR_Coverage, 24768,
     /* 1953714 */     GIR_EraseRootFromParent_Done,
     /* 1953715 */   // Label 26225: @1953715
     /* 1953715 */   GIM_Try, /*On fail goto*//*Label 26226*/ GIMT_Encode4(1953801), // Rule ID 24769 //
     /* 1953720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1953731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1953734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1953737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1953740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1953743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953766 */     // MIs[0] policy
     /* 1953766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953776 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1953779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953800 */     // GIR_Coverage, 24769,
     /* 1953800 */     GIR_EraseRootFromParent_Done,
     /* 1953801 */   // Label 26226: @1953801
     /* 1953801 */   GIM_Try, /*On fail goto*//*Label 26227*/ GIMT_Encode4(1953887), // Rule ID 24772 //
     /* 1953806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1953817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1953820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1953823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1953826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953852 */     // MIs[0] policy
     /* 1953852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953862 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1953865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953886 */     // GIR_Coverage, 24772,
     /* 1953886 */     GIR_EraseRootFromParent_Done,
     /* 1953887 */   // Label 26227: @1953887
     /* 1953887 */   GIM_Try, /*On fail goto*//*Label 26228*/ GIMT_Encode4(1953973), // Rule ID 24773 //
     /* 1953892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1953903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1953906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1953909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1953912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953938 */     // MIs[0] policy
     /* 1953938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953948 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1953951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953972 */     // GIR_Coverage, 24773,
     /* 1953972 */     GIR_EraseRootFromParent_Done,
     /* 1953973 */   // Label 26228: @1953973
     /* 1953973 */   GIM_Try, /*On fail goto*//*Label 26229*/ GIMT_Encode4(1954059), // Rule ID 24776 //
     /* 1953978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1953989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1953992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1953995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1953998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954024 */     // MIs[0] policy
     /* 1954024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954034 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1954037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954058 */     // GIR_Coverage, 24776,
     /* 1954058 */     GIR_EraseRootFromParent_Done,
     /* 1954059 */   // Label 26229: @1954059
     /* 1954059 */   GIM_Try, /*On fail goto*//*Label 26230*/ GIMT_Encode4(1954145), // Rule ID 24777 //
     /* 1954064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1954075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1954078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1954081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954110 */     // MIs[0] policy
     /* 1954110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954120 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1954123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954144 */     // GIR_Coverage, 24777,
     /* 1954144 */     GIR_EraseRootFromParent_Done,
     /* 1954145 */   // Label 26230: @1954145
     /* 1954145 */   GIM_Try, /*On fail goto*//*Label 26231*/ GIMT_Encode4(1954231), // Rule ID 24780 //
     /* 1954150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1954161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1954164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1954167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954196 */     // MIs[0] policy
     /* 1954196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954206 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1954209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954230 */     // GIR_Coverage, 24780,
     /* 1954230 */     GIR_EraseRootFromParent_Done,
     /* 1954231 */   // Label 26231: @1954231
     /* 1954231 */   GIM_Try, /*On fail goto*//*Label 26232*/ GIMT_Encode4(1954317), // Rule ID 24781 //
     /* 1954236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1954247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1954250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1954253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954282 */     // MIs[0] policy
     /* 1954282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954292 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1954295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954316 */     // GIR_Coverage, 24781,
     /* 1954316 */     GIR_EraseRootFromParent_Done,
     /* 1954317 */   // Label 26232: @1954317
     /* 1954317 */   GIM_Try, /*On fail goto*//*Label 26233*/ GIMT_Encode4(1954403), // Rule ID 24784 //
     /* 1954322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1954333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1954336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1954339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954368 */     // MIs[0] policy
     /* 1954368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954378 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1954381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954402 */     // GIR_Coverage, 24784,
     /* 1954402 */     GIR_EraseRootFromParent_Done,
     /* 1954403 */   // Label 26233: @1954403
     /* 1954403 */   GIM_Try, /*On fail goto*//*Label 26234*/ GIMT_Encode4(1954489), // Rule ID 24785 //
     /* 1954408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1954419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1954422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1954425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954454 */     // MIs[0] policy
     /* 1954454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954464 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1954467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954488 */     // GIR_Coverage, 24785,
     /* 1954488 */     GIR_EraseRootFromParent_Done,
     /* 1954489 */   // Label 26234: @1954489
     /* 1954489 */   GIM_Try, /*On fail goto*//*Label 26235*/ GIMT_Encode4(1954575), // Rule ID 24788 //
     /* 1954494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1954505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1954508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1954511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954540 */     // MIs[0] policy
     /* 1954540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954550 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1954553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954574 */     // GIR_Coverage, 24788,
     /* 1954574 */     GIR_EraseRootFromParent_Done,
     /* 1954575 */   // Label 26235: @1954575
     /* 1954575 */   GIM_Try, /*On fail goto*//*Label 26236*/ GIMT_Encode4(1954661), // Rule ID 24789 //
     /* 1954580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1954591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1954594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1954597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954626 */     // MIs[0] policy
     /* 1954626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954636 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1954639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954660 */     // GIR_Coverage, 24789,
     /* 1954660 */     GIR_EraseRootFromParent_Done,
     /* 1954661 */   // Label 26236: @1954661
     /* 1954661 */   GIM_Try, /*On fail goto*//*Label 26237*/ GIMT_Encode4(1954747), // Rule ID 24792 //
     /* 1954666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1954677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1954680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1954683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1954686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954712 */     // MIs[0] policy
     /* 1954712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954722 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1954725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954746 */     // GIR_Coverage, 24792,
     /* 1954746 */     GIR_EraseRootFromParent_Done,
     /* 1954747 */   // Label 26237: @1954747
     /* 1954747 */   GIM_Try, /*On fail goto*//*Label 26238*/ GIMT_Encode4(1954833), // Rule ID 24793 //
     /* 1954752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1954763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1954766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1954769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1954772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954798 */     // MIs[0] policy
     /* 1954798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954808 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1954811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954832 */     // GIR_Coverage, 24793,
     /* 1954832 */     GIR_EraseRootFromParent_Done,
     /* 1954833 */   // Label 26238: @1954833
     /* 1954833 */   GIM_Try, /*On fail goto*//*Label 26239*/ GIMT_Encode4(1954919), // Rule ID 24796 //
     /* 1954838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1954849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1954852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1954855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954884 */     // MIs[0] policy
     /* 1954884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954894 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1954897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954918 */     // GIR_Coverage, 24796,
     /* 1954918 */     GIR_EraseRootFromParent_Done,
     /* 1954919 */   // Label 26239: @1954919
     /* 1954919 */   GIM_Try, /*On fail goto*//*Label 26240*/ GIMT_Encode4(1955005), // Rule ID 24797 //
     /* 1954924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1954935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1954938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1954941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954970 */     // MIs[0] policy
     /* 1954970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954980 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1954983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955004 */     // GIR_Coverage, 24797,
     /* 1955004 */     GIR_EraseRootFromParent_Done,
     /* 1955005 */   // Label 26240: @1955005
     /* 1955005 */   GIM_Try, /*On fail goto*//*Label 26241*/ GIMT_Encode4(1955091), // Rule ID 24800 //
     /* 1955010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1955021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1955024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1955027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1955030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1955033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955056 */     // MIs[0] policy
     /* 1955056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955066 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1955069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955090 */     // GIR_Coverage, 24800,
     /* 1955090 */     GIR_EraseRootFromParent_Done,
     /* 1955091 */   // Label 26241: @1955091
     /* 1955091 */   GIM_Try, /*On fail goto*//*Label 26242*/ GIMT_Encode4(1955177), // Rule ID 24801 //
     /* 1955096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1955107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1955110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1955113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1955116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1955119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955142 */     // MIs[0] policy
     /* 1955142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1955155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955176 */     // GIR_Coverage, 24801,
     /* 1955176 */     GIR_EraseRootFromParent_Done,
     /* 1955177 */   // Label 26242: @1955177
     /* 1955177 */   GIM_Try, /*On fail goto*//*Label 26243*/ GIMT_Encode4(1955263), // Rule ID 24804 //
     /* 1955182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1955185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1955193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1955196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1955199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1955202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955228 */     // MIs[0] policy
     /* 1955228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955238 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1955241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1955259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955262 */     // GIR_Coverage, 24804,
     /* 1955262 */     GIR_EraseRootFromParent_Done,
     /* 1955263 */   // Label 26243: @1955263
     /* 1955263 */   GIM_Try, /*On fail goto*//*Label 26244*/ GIMT_Encode4(1955349), // Rule ID 24805 //
     /* 1955268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1955271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1955279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1955282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1955285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1955288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955314 */     // MIs[0] policy
     /* 1955314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955324 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1955327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1955345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955348 */     // GIR_Coverage, 24805,
     /* 1955348 */     GIR_EraseRootFromParent_Done,
     /* 1955349 */   // Label 26244: @1955349
     /* 1955349 */   GIM_Try, /*On fail goto*//*Label 26245*/ GIMT_Encode4(1955435), // Rule ID 24808 //
     /* 1955354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1955365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1955368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1955371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955400 */     // MIs[0] policy
     /* 1955400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955410 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1955413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955434 */     // GIR_Coverage, 24808,
     /* 1955434 */     GIR_EraseRootFromParent_Done,
     /* 1955435 */   // Label 26245: @1955435
     /* 1955435 */   GIM_Try, /*On fail goto*//*Label 26246*/ GIMT_Encode4(1955521), // Rule ID 24809 //
     /* 1955440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1955451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1955454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1955457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955486 */     // MIs[0] policy
     /* 1955486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955496 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1955499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955520 */     // GIR_Coverage, 24809,
     /* 1955520 */     GIR_EraseRootFromParent_Done,
     /* 1955521 */   // Label 26246: @1955521
     /* 1955521 */   GIM_Try, /*On fail goto*//*Label 26247*/ GIMT_Encode4(1955607), // Rule ID 24812 //
     /* 1955526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1955537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1955540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1955543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1955546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1955549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955572 */     // MIs[0] policy
     /* 1955572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955582 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1955585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955606 */     // GIR_Coverage, 24812,
     /* 1955606 */     GIR_EraseRootFromParent_Done,
     /* 1955607 */   // Label 26247: @1955607
     /* 1955607 */   GIM_Try, /*On fail goto*//*Label 26248*/ GIMT_Encode4(1955693), // Rule ID 24813 //
     /* 1955612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1955623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1955626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1955629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1955632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1955635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955658 */     // MIs[0] policy
     /* 1955658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955668 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1955671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955692 */     // GIR_Coverage, 24813,
     /* 1955692 */     GIR_EraseRootFromParent_Done,
     /* 1955693 */   // Label 26248: @1955693
     /* 1955693 */   GIM_Try, /*On fail goto*//*Label 26249*/ GIMT_Encode4(1955779), // Rule ID 24816 //
     /* 1955698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1955709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1955712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1955715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1955718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955744 */     // MIs[0] policy
     /* 1955744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1955757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955778 */     // GIR_Coverage, 24816,
     /* 1955778 */     GIR_EraseRootFromParent_Done,
     /* 1955779 */   // Label 26249: @1955779
     /* 1955779 */   GIM_Try, /*On fail goto*//*Label 26250*/ GIMT_Encode4(1955865), // Rule ID 24817 //
     /* 1955784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1955795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1955798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1955801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1955804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955830 */     // MIs[0] policy
     /* 1955830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955840 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1955843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955864 */     // GIR_Coverage, 24817,
     /* 1955864 */     GIR_EraseRootFromParent_Done,
     /* 1955865 */   // Label 26250: @1955865
     /* 1955865 */   GIM_Try, /*On fail goto*//*Label 26251*/ GIMT_Encode4(1955951), // Rule ID 24820 //
     /* 1955870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1955881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1955884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1955887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955916 */     // MIs[0] policy
     /* 1955916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1955929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955950 */     // GIR_Coverage, 24820,
     /* 1955950 */     GIR_EraseRootFromParent_Done,
     /* 1955951 */   // Label 26251: @1955951
     /* 1955951 */   GIM_Try, /*On fail goto*//*Label 26252*/ GIMT_Encode4(1956037), // Rule ID 24821 //
     /* 1955956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1955967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1955970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1955973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956002 */     // MIs[0] policy
     /* 1956002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956012 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1956015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956036 */     // GIR_Coverage, 24821,
     /* 1956036 */     GIR_EraseRootFromParent_Done,
     /* 1956037 */   // Label 26252: @1956037
     /* 1956037 */   GIM_Try, /*On fail goto*//*Label 26253*/ GIMT_Encode4(1956123), // Rule ID 24824 //
     /* 1956042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1956053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1956056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1956059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1956062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956088 */     // MIs[0] policy
     /* 1956088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956098 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1956101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956122 */     // GIR_Coverage, 24824,
     /* 1956122 */     GIR_EraseRootFromParent_Done,
     /* 1956123 */   // Label 26253: @1956123
     /* 1956123 */   GIM_Try, /*On fail goto*//*Label 26254*/ GIMT_Encode4(1956209), // Rule ID 24825 //
     /* 1956128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1956139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1956142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1956145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1956148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956174 */     // MIs[0] policy
     /* 1956174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956184 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1956187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956208 */     // GIR_Coverage, 24825,
     /* 1956208 */     GIR_EraseRootFromParent_Done,
     /* 1956209 */   // Label 26254: @1956209
     /* 1956209 */   GIM_Try, /*On fail goto*//*Label 26255*/ GIMT_Encode4(1956295), // Rule ID 24828 //
     /* 1956214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1956225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1956228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1956231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1956234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956260 */     // MIs[0] policy
     /* 1956260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1956273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956294 */     // GIR_Coverage, 24828,
     /* 1956294 */     GIR_EraseRootFromParent_Done,
     /* 1956295 */   // Label 26255: @1956295
     /* 1956295 */   GIM_Try, /*On fail goto*//*Label 26256*/ GIMT_Encode4(1956381), // Rule ID 24829 //
     /* 1956300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1956311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1956314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1956317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1956320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956346 */     // MIs[0] policy
     /* 1956346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1956359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956380 */     // GIR_Coverage, 24829,
     /* 1956380 */     GIR_EraseRootFromParent_Done,
     /* 1956381 */   // Label 26256: @1956381
     /* 1956381 */   GIM_Try, /*On fail goto*//*Label 26257*/ GIMT_Encode4(1956467), // Rule ID 24832 //
     /* 1956386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1956397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1956400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1956403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956432 */     // MIs[0] policy
     /* 1956432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956442 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1956445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956466 */     // GIR_Coverage, 24832,
     /* 1956466 */     GIR_EraseRootFromParent_Done,
     /* 1956467 */   // Label 26257: @1956467
     /* 1956467 */   GIM_Try, /*On fail goto*//*Label 26258*/ GIMT_Encode4(1956553), // Rule ID 24833 //
     /* 1956472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1956483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1956486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1956489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956518 */     // MIs[0] policy
     /* 1956518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956528 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1956531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956552 */     // GIR_Coverage, 24833,
     /* 1956552 */     GIR_EraseRootFromParent_Done,
     /* 1956553 */   // Label 26258: @1956553
     /* 1956553 */   GIM_Try, /*On fail goto*//*Label 26259*/ GIMT_Encode4(1956639), // Rule ID 24836 //
     /* 1956558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1956569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1956572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1956575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1956578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956604 */     // MIs[0] policy
     /* 1956604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1956617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956638 */     // GIR_Coverage, 24836,
     /* 1956638 */     GIR_EraseRootFromParent_Done,
     /* 1956639 */   // Label 26259: @1956639
     /* 1956639 */   GIM_Try, /*On fail goto*//*Label 26260*/ GIMT_Encode4(1956725), // Rule ID 24837 //
     /* 1956644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1956655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1956658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1956661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1956664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956690 */     // MIs[0] policy
     /* 1956690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956700 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1956703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956724 */     // GIR_Coverage, 24837,
     /* 1956724 */     GIR_EraseRootFromParent_Done,
     /* 1956725 */   // Label 26260: @1956725
     /* 1956725 */   GIM_Try, /*On fail goto*//*Label 26261*/ GIMT_Encode4(1956811), // Rule ID 24840 //
     /* 1956730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1956733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1956741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1956744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1956747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1956750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956776 */     // MIs[0] policy
     /* 1956776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1956789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956810 */     // GIR_Coverage, 24840,
     /* 1956810 */     GIR_EraseRootFromParent_Done,
     /* 1956811 */   // Label 26261: @1956811
     /* 1956811 */   GIM_Try, /*On fail goto*//*Label 26262*/ GIMT_Encode4(1956897), // Rule ID 24841 //
     /* 1956816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1956819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1956827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1956830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1956833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1956836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956862 */     // MIs[0] policy
     /* 1956862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956872 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1956875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956896 */     // GIR_Coverage, 24841,
     /* 1956896 */     GIR_EraseRootFromParent_Done,
     /* 1956897 */   // Label 26262: @1956897
     /* 1956897 */   GIM_Try, /*On fail goto*//*Label 26263*/ GIMT_Encode4(1956983), // Rule ID 24844 //
     /* 1956902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1956905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1956913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1956916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1956919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1956922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956948 */     // MIs[0] policy
     /* 1956948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956958 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1956961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956982 */     // GIR_Coverage, 24844,
     /* 1956982 */     GIR_EraseRootFromParent_Done,
     /* 1956983 */   // Label 26263: @1956983
     /* 1956983 */   GIM_Try, /*On fail goto*//*Label 26264*/ GIMT_Encode4(1957069), // Rule ID 24845 //
     /* 1956988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1956991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1956999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1957002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1957005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1957008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957034 */     // MIs[0] policy
     /* 1957034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957044 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1957047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957068 */     // GIR_Coverage, 24845,
     /* 1957068 */     GIR_EraseRootFromParent_Done,
     /* 1957069 */   // Label 26264: @1957069
     /* 1957069 */   GIM_Try, /*On fail goto*//*Label 26265*/ GIMT_Encode4(1957155), // Rule ID 24848 //
     /* 1957074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1957077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1957085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1957088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1957091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1957094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957120 */     // MIs[0] policy
     /* 1957120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957130 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1957133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957154 */     // GIR_Coverage, 24848,
     /* 1957154 */     GIR_EraseRootFromParent_Done,
     /* 1957155 */   // Label 26265: @1957155
     /* 1957155 */   GIM_Try, /*On fail goto*//*Label 26266*/ GIMT_Encode4(1957241), // Rule ID 24849 //
     /* 1957160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1957163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1957171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1957174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1957177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1957180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957206 */     // MIs[0] policy
     /* 1957206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957216 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1957219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957240 */     // GIR_Coverage, 24849,
     /* 1957240 */     GIR_EraseRootFromParent_Done,
     /* 1957241 */   // Label 26266: @1957241
     /* 1957241 */   GIM_Try, /*On fail goto*//*Label 26267*/ GIMT_Encode4(1957327), // Rule ID 24852 //
     /* 1957246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1957257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1957260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1957263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1957266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957292 */     // MIs[0] policy
     /* 1957292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957302 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1957305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957326 */     // GIR_Coverage, 24852,
     /* 1957326 */     GIR_EraseRootFromParent_Done,
     /* 1957327 */   // Label 26267: @1957327
     /* 1957327 */   GIM_Try, /*On fail goto*//*Label 26268*/ GIMT_Encode4(1957413), // Rule ID 24853 //
     /* 1957332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1957343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1957346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1957349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1957352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957378 */     // MIs[0] policy
     /* 1957378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957388 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1957391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957412 */     // GIR_Coverage, 24853,
     /* 1957412 */     GIR_EraseRootFromParent_Done,
     /* 1957413 */   // Label 26268: @1957413
     /* 1957413 */   GIM_Try, /*On fail goto*//*Label 26269*/ GIMT_Encode4(1957499), // Rule ID 24856 //
     /* 1957418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1957429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1957432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1957435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957464 */     // MIs[0] policy
     /* 1957464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957474 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1957477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957498 */     // GIR_Coverage, 24856,
     /* 1957498 */     GIR_EraseRootFromParent_Done,
     /* 1957499 */   // Label 26269: @1957499
     /* 1957499 */   GIM_Try, /*On fail goto*//*Label 26270*/ GIMT_Encode4(1957585), // Rule ID 24857 //
     /* 1957504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1957515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1957518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1957521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957550 */     // MIs[0] policy
     /* 1957550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957560 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1957563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957584 */     // GIR_Coverage, 24857,
     /* 1957584 */     GIR_EraseRootFromParent_Done,
     /* 1957585 */   // Label 26270: @1957585
     /* 1957585 */   GIM_Try, /*On fail goto*//*Label 26271*/ GIMT_Encode4(1957671), // Rule ID 24860 //
     /* 1957590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1957601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1957604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1957607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1957610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957636 */     // MIs[0] policy
     /* 1957636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957646 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1957649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957670 */     // GIR_Coverage, 24860,
     /* 1957670 */     GIR_EraseRootFromParent_Done,
     /* 1957671 */   // Label 26271: @1957671
     /* 1957671 */   GIM_Try, /*On fail goto*//*Label 26272*/ GIMT_Encode4(1957757), // Rule ID 24861 //
     /* 1957676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1957687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1957690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1957693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1957696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957722 */     // MIs[0] policy
     /* 1957722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957732 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1957735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957756 */     // GIR_Coverage, 24861,
     /* 1957756 */     GIR_EraseRootFromParent_Done,
     /* 1957757 */   // Label 26272: @1957757
     /* 1957757 */   GIM_Try, /*On fail goto*//*Label 26273*/ GIMT_Encode4(1957843), // Rule ID 24864 //
     /* 1957762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1957773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1957776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1957779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1957782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957808 */     // MIs[0] policy
     /* 1957808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957818 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1957821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957842 */     // GIR_Coverage, 24864,
     /* 1957842 */     GIR_EraseRootFromParent_Done,
     /* 1957843 */   // Label 26273: @1957843
     /* 1957843 */   GIM_Try, /*On fail goto*//*Label 26274*/ GIMT_Encode4(1957929), // Rule ID 24865 //
     /* 1957848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1957859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1957862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1957865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1957868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957894 */     // MIs[0] policy
     /* 1957894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957904 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1957907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957928 */     // GIR_Coverage, 24865,
     /* 1957928 */     GIR_EraseRootFromParent_Done,
     /* 1957929 */   // Label 26274: @1957929
     /* 1957929 */   GIM_Try, /*On fail goto*//*Label 26275*/ GIMT_Encode4(1958015), // Rule ID 24868 //
     /* 1957934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1957945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1957948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1957951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1957954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957980 */     // MIs[0] policy
     /* 1957980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957990 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1957993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958014 */     // GIR_Coverage, 24868,
     /* 1958014 */     GIR_EraseRootFromParent_Done,
     /* 1958015 */   // Label 26275: @1958015
     /* 1958015 */   GIM_Try, /*On fail goto*//*Label 26276*/ GIMT_Encode4(1958101), // Rule ID 24869 //
     /* 1958020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1958031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1958034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1958037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1958040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958066 */     // MIs[0] policy
     /* 1958066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958076 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1958079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958100 */     // GIR_Coverage, 24869,
     /* 1958100 */     GIR_EraseRootFromParent_Done,
     /* 1958101 */   // Label 26276: @1958101
     /* 1958101 */   GIM_Try, /*On fail goto*//*Label 26277*/ GIMT_Encode4(1958187), // Rule ID 24872 //
     /* 1958106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1958109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1958117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1958120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1958123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1958126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958152 */     // MIs[0] policy
     /* 1958152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958162 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1958165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958186 */     // GIR_Coverage, 24872,
     /* 1958186 */     GIR_EraseRootFromParent_Done,
     /* 1958187 */   // Label 26277: @1958187
     /* 1958187 */   GIM_Try, /*On fail goto*//*Label 26278*/ GIMT_Encode4(1958273), // Rule ID 24873 //
     /* 1958192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1958195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1958203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1958206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1958209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1958212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958238 */     // MIs[0] policy
     /* 1958238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958248 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1958251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958272 */     // GIR_Coverage, 24873,
     /* 1958272 */     GIR_EraseRootFromParent_Done,
     /* 1958273 */   // Label 26278: @1958273
     /* 1958273 */   GIM_Try, /*On fail goto*//*Label 26279*/ GIMT_Encode4(1958359), // Rule ID 24876 //
     /* 1958278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1958289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1958292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1958295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958324 */     // MIs[0] policy
     /* 1958324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958334 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1958337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958358 */     // GIR_Coverage, 24876,
     /* 1958358 */     GIR_EraseRootFromParent_Done,
     /* 1958359 */   // Label 26279: @1958359
     /* 1958359 */   GIM_Try, /*On fail goto*//*Label 26280*/ GIMT_Encode4(1958445), // Rule ID 24877 //
     /* 1958364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1958375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1958378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1958381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958410 */     // MIs[0] policy
     /* 1958410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958420 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1958423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958444 */     // GIR_Coverage, 24877,
     /* 1958444 */     GIR_EraseRootFromParent_Done,
     /* 1958445 */   // Label 26280: @1958445
     /* 1958445 */   GIM_Try, /*On fail goto*//*Label 26281*/ GIMT_Encode4(1958531), // Rule ID 24880 //
     /* 1958450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1958461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1958464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1958467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1958470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1958473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1958480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958496 */     // MIs[0] policy
     /* 1958496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958506 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1958509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958530 */     // GIR_Coverage, 24880,
     /* 1958530 */     GIR_EraseRootFromParent_Done,
     /* 1958531 */   // Label 26281: @1958531
     /* 1958531 */   GIM_Try, /*On fail goto*//*Label 26282*/ GIMT_Encode4(1958617), // Rule ID 24881 //
     /* 1958536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1958547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1958550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1958553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1958556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1958559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1958566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958582 */     // MIs[0] policy
     /* 1958582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958592 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1958595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958616 */     // GIR_Coverage, 24881,
     /* 1958616 */     GIR_EraseRootFromParent_Done,
     /* 1958617 */   // Label 26282: @1958617
     /* 1958617 */   GIM_Try, /*On fail goto*//*Label 26283*/ GIMT_Encode4(1958703), // Rule ID 24884 //
     /* 1958622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1958633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1958636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1958639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1958642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1958645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1958652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958668 */     // MIs[0] policy
     /* 1958668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958678 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1958681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958702 */     // GIR_Coverage, 24884,
     /* 1958702 */     GIR_EraseRootFromParent_Done,
     /* 1958703 */   // Label 26283: @1958703
     /* 1958703 */   GIM_Try, /*On fail goto*//*Label 26284*/ GIMT_Encode4(1958789), // Rule ID 24885 //
     /* 1958708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1958719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1958722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1958725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1958728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1958731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1958738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958754 */     // MIs[0] policy
     /* 1958754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958764 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1958767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958788 */     // GIR_Coverage, 24885,
     /* 1958788 */     GIR_EraseRootFromParent_Done,
     /* 1958789 */   // Label 26284: @1958789
     /* 1958789 */   GIM_Try, /*On fail goto*//*Label 26285*/ GIMT_Encode4(1958875), // Rule ID 24888 //
     /* 1958794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1958805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1958808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1958811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1958814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958840 */     // MIs[0] policy
     /* 1958840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958850 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1958853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958874 */     // GIR_Coverage, 24888,
     /* 1958874 */     GIR_EraseRootFromParent_Done,
     /* 1958875 */   // Label 26285: @1958875
     /* 1958875 */   GIM_Try, /*On fail goto*//*Label 26286*/ GIMT_Encode4(1958961), // Rule ID 24889 //
     /* 1958880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1958891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1958894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1958897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1958900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958926 */     // MIs[0] policy
     /* 1958926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958936 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1958939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958960 */     // GIR_Coverage, 24889,
     /* 1958960 */     GIR_EraseRootFromParent_Done,
     /* 1958961 */   // Label 26286: @1958961
     /* 1958961 */   GIM_Try, /*On fail goto*//*Label 26287*/ GIMT_Encode4(1959047), // Rule ID 24892 //
     /* 1958966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1958977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1958980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1958983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1958986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1958996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959012 */     // MIs[0] policy
     /* 1959012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959022 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1959025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959046 */     // GIR_Coverage, 24892,
     /* 1959046 */     GIR_EraseRootFromParent_Done,
     /* 1959047 */   // Label 26287: @1959047
     /* 1959047 */   GIM_Try, /*On fail goto*//*Label 26288*/ GIMT_Encode4(1959133), // Rule ID 24893 //
     /* 1959052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1959063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1959066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1959069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1959072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959098 */     // MIs[0] policy
     /* 1959098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959108 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1959111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959132 */     // GIR_Coverage, 24893,
     /* 1959132 */     GIR_EraseRootFromParent_Done,
     /* 1959133 */   // Label 26288: @1959133
     /* 1959133 */   GIM_Try, /*On fail goto*//*Label 26289*/ GIMT_Encode4(1959219), // Rule ID 24896 //
     /* 1959138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1959149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1959152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1959155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1959158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959184 */     // MIs[0] policy
     /* 1959184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959194 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1959197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959218 */     // GIR_Coverage, 24896,
     /* 1959218 */     GIR_EraseRootFromParent_Done,
     /* 1959219 */   // Label 26289: @1959219
     /* 1959219 */   GIM_Try, /*On fail goto*//*Label 26290*/ GIMT_Encode4(1959305), // Rule ID 24897 //
     /* 1959224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1959235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1959238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1959241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1959244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959270 */     // MIs[0] policy
     /* 1959270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959280 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1959283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959304 */     // GIR_Coverage, 24897,
     /* 1959304 */     GIR_EraseRootFromParent_Done,
     /* 1959305 */   // Label 26290: @1959305
     /* 1959305 */   GIM_Try, /*On fail goto*//*Label 26291*/ GIMT_Encode4(1959391), // Rule ID 24900 //
     /* 1959310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1959313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1959321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1959324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1959327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1959330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1959333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959356 */     // MIs[0] policy
     /* 1959356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959366 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1959369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959390 */     // GIR_Coverage, 24900,
     /* 1959390 */     GIR_EraseRootFromParent_Done,
     /* 1959391 */   // Label 26291: @1959391
     /* 1959391 */   GIM_Try, /*On fail goto*//*Label 26292*/ GIMT_Encode4(1959477), // Rule ID 24901 //
     /* 1959396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1959399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1959407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1959410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1959413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1959416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1959419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959442 */     // MIs[0] policy
     /* 1959442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959452 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1959455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959476 */     // GIR_Coverage, 24901,
     /* 1959476 */     GIR_EraseRootFromParent_Done,
     /* 1959477 */   // Label 26292: @1959477
     /* 1959477 */   GIM_Try, /*On fail goto*//*Label 26293*/ GIMT_Encode4(1959563), // Rule ID 24904 //
     /* 1959482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1959485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1959493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1959496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1959499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1959502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959528 */     // MIs[0] policy
     /* 1959528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959538 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1959541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959562 */     // GIR_Coverage, 24904,
     /* 1959562 */     GIR_EraseRootFromParent_Done,
     /* 1959563 */   // Label 26293: @1959563
     /* 1959563 */   GIM_Try, /*On fail goto*//*Label 26294*/ GIMT_Encode4(1959649), // Rule ID 24905 //
     /* 1959568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1959571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1959579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1959582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1959585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1959588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959614 */     // MIs[0] policy
     /* 1959614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959624 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1959627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959648 */     // GIR_Coverage, 24905,
     /* 1959648 */     GIR_EraseRootFromParent_Done,
     /* 1959649 */   // Label 26294: @1959649
     /* 1959649 */   GIM_Try, /*On fail goto*//*Label 26295*/ GIMT_Encode4(1959735), // Rule ID 24908 //
     /* 1959654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1959657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1959665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1959668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1959671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1959674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959700 */     // MIs[0] policy
     /* 1959700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959710 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1959713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959734 */     // GIR_Coverage, 24908,
     /* 1959734 */     GIR_EraseRootFromParent_Done,
     /* 1959735 */   // Label 26295: @1959735
     /* 1959735 */   GIM_Try, /*On fail goto*//*Label 26296*/ GIMT_Encode4(1959821), // Rule ID 24909 //
     /* 1959740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1959743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1959751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1959754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1959757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1959760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959786 */     // MIs[0] policy
     /* 1959786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959796 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1959799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959820 */     // GIR_Coverage, 24909,
     /* 1959820 */     GIR_EraseRootFromParent_Done,
     /* 1959821 */   // Label 26296: @1959821
     /* 1959821 */   GIM_Try, /*On fail goto*//*Label 26297*/ GIMT_Encode4(1959907), // Rule ID 24912 //
     /* 1959826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1959837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1959840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1959843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1959846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1959849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959872 */     // MIs[0] policy
     /* 1959872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959882 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1959885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959906 */     // GIR_Coverage, 24912,
     /* 1959906 */     GIR_EraseRootFromParent_Done,
     /* 1959907 */   // Label 26297: @1959907
     /* 1959907 */   GIM_Try, /*On fail goto*//*Label 26298*/ GIMT_Encode4(1959993), // Rule ID 24913 //
     /* 1959912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1959923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1959926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1959929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1959932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1959935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959958 */     // MIs[0] policy
     /* 1959958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959968 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1959971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959992 */     // GIR_Coverage, 24913,
     /* 1959992 */     GIR_EraseRootFromParent_Done,
     /* 1959993 */   // Label 26298: @1959993
     /* 1959993 */   GIM_Try, /*On fail goto*//*Label 26299*/ GIMT_Encode4(1960079), // Rule ID 24916 //
     /* 1959998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1960009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1960012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1960015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960044 */     // MIs[0] policy
     /* 1960044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960054 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960078 */     // GIR_Coverage, 24916,
     /* 1960078 */     GIR_EraseRootFromParent_Done,
     /* 1960079 */   // Label 26299: @1960079
     /* 1960079 */   GIM_Try, /*On fail goto*//*Label 26300*/ GIMT_Encode4(1960165), // Rule ID 24917 //
     /* 1960084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1960095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1960098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1960101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960130 */     // MIs[0] policy
     /* 1960130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960140 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960164 */     // GIR_Coverage, 24917,
     /* 1960164 */     GIR_EraseRootFromParent_Done,
     /* 1960165 */   // Label 26300: @1960165
     /* 1960165 */   GIM_Try, /*On fail goto*//*Label 26301*/ GIMT_Encode4(1960251), // Rule ID 24920 //
     /* 1960170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1960181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1960184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1960187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960216 */     // MIs[0] policy
     /* 1960216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960226 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960250 */     // GIR_Coverage, 24920,
     /* 1960250 */     GIR_EraseRootFromParent_Done,
     /* 1960251 */   // Label 26301: @1960251
     /* 1960251 */   GIM_Try, /*On fail goto*//*Label 26302*/ GIMT_Encode4(1960337), // Rule ID 24921 //
     /* 1960256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1960267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1960270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1960273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960302 */     // MIs[0] policy
     /* 1960302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960312 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960336 */     // GIR_Coverage, 24921,
     /* 1960336 */     GIR_EraseRootFromParent_Done,
     /* 1960337 */   // Label 26302: @1960337
     /* 1960337 */   GIM_Try, /*On fail goto*//*Label 26303*/ GIMT_Encode4(1960423), // Rule ID 24924 //
     /* 1960342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1960353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1960356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1960359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960388 */     // MIs[0] policy
     /* 1960388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960398 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960422 */     // GIR_Coverage, 24924,
     /* 1960422 */     GIR_EraseRootFromParent_Done,
     /* 1960423 */   // Label 26303: @1960423
     /* 1960423 */   GIM_Try, /*On fail goto*//*Label 26304*/ GIMT_Encode4(1960509), // Rule ID 24925 //
     /* 1960428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1960439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1960442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1960445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960474 */     // MIs[0] policy
     /* 1960474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960484 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960508 */     // GIR_Coverage, 24925,
     /* 1960508 */     GIR_EraseRootFromParent_Done,
     /* 1960509 */   // Label 26304: @1960509
     /* 1960509 */   GIM_Try, /*On fail goto*//*Label 26305*/ GIMT_Encode4(1960595), // Rule ID 24928 //
     /* 1960514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1960525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1960528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1960531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960560 */     // MIs[0] policy
     /* 1960560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960570 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960594 */     // GIR_Coverage, 24928,
     /* 1960594 */     GIR_EraseRootFromParent_Done,
     /* 1960595 */   // Label 26305: @1960595
     /* 1960595 */   GIM_Try, /*On fail goto*//*Label 26306*/ GIMT_Encode4(1960681), // Rule ID 24929 //
     /* 1960600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1960611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1960614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1960617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960646 */     // MIs[0] policy
     /* 1960646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960656 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960680 */     // GIR_Coverage, 24929,
     /* 1960680 */     GIR_EraseRootFromParent_Done,
     /* 1960681 */   // Label 26306: @1960681
     /* 1960681 */   GIM_Try, /*On fail goto*//*Label 26307*/ GIMT_Encode4(1960767), // Rule ID 24932 //
     /* 1960686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1960689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1960697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1960700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1960703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960732 */     // MIs[0] policy
     /* 1960732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960742 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960766 */     // GIR_Coverage, 24932,
     /* 1960766 */     GIR_EraseRootFromParent_Done,
     /* 1960767 */   // Label 26307: @1960767
     /* 1960767 */   GIM_Try, /*On fail goto*//*Label 26308*/ GIMT_Encode4(1960853), // Rule ID 24933 //
     /* 1960772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1960775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1960783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1960786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1960789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960818 */     // MIs[0] policy
     /* 1960818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960828 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960852 */     // GIR_Coverage, 24933,
     /* 1960852 */     GIR_EraseRootFromParent_Done,
     /* 1960853 */   // Label 26308: @1960853
     /* 1960853 */   GIM_Try, /*On fail goto*//*Label 26309*/ GIMT_Encode4(1960939), // Rule ID 24936 //
     /* 1960858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1960869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1960872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1960875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960904 */     // MIs[0] policy
     /* 1960904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960914 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1960917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960938 */     // GIR_Coverage, 24936,
     /* 1960938 */     GIR_EraseRootFromParent_Done,
     /* 1960939 */   // Label 26309: @1960939
     /* 1960939 */   GIM_Try, /*On fail goto*//*Label 26310*/ GIMT_Encode4(1961025), // Rule ID 24937 //
     /* 1960944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1960955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1960958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1960961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960990 */     // MIs[0] policy
     /* 1960990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961000 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961024 */     // GIR_Coverage, 24937,
     /* 1961024 */     GIR_EraseRootFromParent_Done,
     /* 1961025 */   // Label 26310: @1961025
     /* 1961025 */   GIM_Try, /*On fail goto*//*Label 26311*/ GIMT_Encode4(1961111), // Rule ID 24940 //
     /* 1961030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1961041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1961044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1961047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961076 */     // MIs[0] policy
     /* 1961076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961086 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1961089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961110 */     // GIR_Coverage, 24940,
     /* 1961110 */     GIR_EraseRootFromParent_Done,
     /* 1961111 */   // Label 26311: @1961111
     /* 1961111 */   GIM_Try, /*On fail goto*//*Label 26312*/ GIMT_Encode4(1961197), // Rule ID 24941 //
     /* 1961116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1961127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1961130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1961133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961162 */     // MIs[0] policy
     /* 1961162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961172 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1961175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961196 */     // GIR_Coverage, 24941,
     /* 1961196 */     GIR_EraseRootFromParent_Done,
     /* 1961197 */   // Label 26312: @1961197
     /* 1961197 */   GIM_Try, /*On fail goto*//*Label 26313*/ GIMT_Encode4(1961283), // Rule ID 24944 //
     /* 1961202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1961213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1961216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1961219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1961225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961248 */     // MIs[0] policy
     /* 1961248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961258 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1961261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961282 */     // GIR_Coverage, 24944,
     /* 1961282 */     GIR_EraseRootFromParent_Done,
     /* 1961283 */   // Label 26313: @1961283
     /* 1961283 */   GIM_Try, /*On fail goto*//*Label 26314*/ GIMT_Encode4(1961369), // Rule ID 24945 //
     /* 1961288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1961299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1961302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1961305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1961311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961334 */     // MIs[0] policy
     /* 1961334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961344 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1961347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961368 */     // GIR_Coverage, 24945,
     /* 1961368 */     GIR_EraseRootFromParent_Done,
     /* 1961369 */   // Label 26314: @1961369
     /* 1961369 */   GIM_Try, /*On fail goto*//*Label 26315*/ GIMT_Encode4(1961455), // Rule ID 24948 //
     /* 1961374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1961385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1961388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1961391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961420 */     // MIs[0] policy
     /* 1961420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961430 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961454 */     // GIR_Coverage, 24948,
     /* 1961454 */     GIR_EraseRootFromParent_Done,
     /* 1961455 */   // Label 26315: @1961455
     /* 1961455 */   GIM_Try, /*On fail goto*//*Label 26316*/ GIMT_Encode4(1961541), // Rule ID 24949 //
     /* 1961460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1961471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1961474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1961477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961506 */     // MIs[0] policy
     /* 1961506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961516 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961540 */     // GIR_Coverage, 24949,
     /* 1961540 */     GIR_EraseRootFromParent_Done,
     /* 1961541 */   // Label 26316: @1961541
     /* 1961541 */   GIM_Try, /*On fail goto*//*Label 26317*/ GIMT_Encode4(1961627), // Rule ID 24952 //
     /* 1961546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1961557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1961560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1961563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961592 */     // MIs[0] policy
     /* 1961592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961602 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1961605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961626 */     // GIR_Coverage, 24952,
     /* 1961626 */     GIR_EraseRootFromParent_Done,
     /* 1961627 */   // Label 26317: @1961627
     /* 1961627 */   GIM_Try, /*On fail goto*//*Label 26318*/ GIMT_Encode4(1961713), // Rule ID 24953 //
     /* 1961632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1961643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1961646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1961649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961678 */     // MIs[0] policy
     /* 1961678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961688 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1961691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961712 */     // GIR_Coverage, 24953,
     /* 1961712 */     GIR_EraseRootFromParent_Done,
     /* 1961713 */   // Label 26318: @1961713
     /* 1961713 */   GIM_Try, /*On fail goto*//*Label 26319*/ GIMT_Encode4(1961799), // Rule ID 24956 //
     /* 1961718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1961729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1961732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1961735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961764 */     // MIs[0] policy
     /* 1961764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961774 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1961777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961798 */     // GIR_Coverage, 24956,
     /* 1961798 */     GIR_EraseRootFromParent_Done,
     /* 1961799 */   // Label 26319: @1961799
     /* 1961799 */   GIM_Try, /*On fail goto*//*Label 26320*/ GIMT_Encode4(1961885), // Rule ID 24957 //
     /* 1961804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1961815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1961818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1961821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961850 */     // MIs[0] policy
     /* 1961850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961860 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1961863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961884 */     // GIR_Coverage, 24957,
     /* 1961884 */     GIR_EraseRootFromParent_Done,
     /* 1961885 */   // Label 26320: @1961885
     /* 1961885 */   GIM_Try, /*On fail goto*//*Label 26321*/ GIMT_Encode4(1961971), // Rule ID 24960 //
     /* 1961890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1961893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1961901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1961904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1961907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1961913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961936 */     // MIs[0] policy
     /* 1961936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961946 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961970 */     // GIR_Coverage, 24960,
     /* 1961970 */     GIR_EraseRootFromParent_Done,
     /* 1961971 */   // Label 26321: @1961971
     /* 1961971 */   GIM_Try, /*On fail goto*//*Label 26322*/ GIMT_Encode4(1962057), // Rule ID 24961 //
     /* 1961976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1961979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1961987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1961990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1961993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1961999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1962006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962022 */     // MIs[0] policy
     /* 1962022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962032 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1962035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962056 */     // GIR_Coverage, 24961,
     /* 1962056 */     GIR_EraseRootFromParent_Done,
     /* 1962057 */   // Label 26322: @1962057
     /* 1962057 */   GIM_Try, /*On fail goto*//*Label 26323*/ GIMT_Encode4(1962143), // Rule ID 24964 //
     /* 1962062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1962065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1962073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1962076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1962079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962108 */     // MIs[0] policy
     /* 1962108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962118 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1962121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962142 */     // GIR_Coverage, 24964,
     /* 1962142 */     GIR_EraseRootFromParent_Done,
     /* 1962143 */   // Label 26323: @1962143
     /* 1962143 */   GIM_Try, /*On fail goto*//*Label 26324*/ GIMT_Encode4(1962229), // Rule ID 24965 //
     /* 1962148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1962151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1962159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1962162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1962165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962194 */     // MIs[0] policy
     /* 1962194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962204 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1962207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962228 */     // GIR_Coverage, 24965,
     /* 1962228 */     GIR_EraseRootFromParent_Done,
     /* 1962229 */   // Label 26324: @1962229
     /* 1962229 */   GIM_Try, /*On fail goto*//*Label 26325*/ GIMT_Encode4(1962315), // Rule ID 24968 //
     /* 1962234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1962237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1962245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1962248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1962251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962280 */     // MIs[0] policy
     /* 1962280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962290 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1962293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962314 */     // GIR_Coverage, 24968,
     /* 1962314 */     GIR_EraseRootFromParent_Done,
     /* 1962315 */   // Label 26325: @1962315
     /* 1962315 */   GIM_Try, /*On fail goto*//*Label 26326*/ GIMT_Encode4(1962401), // Rule ID 24969 //
     /* 1962320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1962323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1962331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1962334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1962337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962366 */     // MIs[0] policy
     /* 1962366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962376 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1962379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962400 */     // GIR_Coverage, 24969,
     /* 1962400 */     GIR_EraseRootFromParent_Done,
     /* 1962401 */   // Label 26326: @1962401
     /* 1962401 */   GIM_Try, /*On fail goto*//*Label 26327*/ GIMT_Encode4(1962487), // Rule ID 25032 //
     /* 1962406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1962417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1962420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1962423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1962426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962452 */     // MIs[0] policy
     /* 1962452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962462 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1962465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962486 */     // GIR_Coverage, 25032,
     /* 1962486 */     GIR_EraseRootFromParent_Done,
     /* 1962487 */   // Label 26327: @1962487
     /* 1962487 */   GIM_Try, /*On fail goto*//*Label 26328*/ GIMT_Encode4(1962573), // Rule ID 25033 //
     /* 1962492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1962503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1962506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1962509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1962512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962538 */     // MIs[0] policy
     /* 1962538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962548 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1962551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962572 */     // GIR_Coverage, 25033,
     /* 1962572 */     GIR_EraseRootFromParent_Done,
     /* 1962573 */   // Label 26328: @1962573
     /* 1962573 */   GIM_Try, /*On fail goto*//*Label 26329*/ GIMT_Encode4(1962659), // Rule ID 25036 //
     /* 1962578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1962589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1962592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1962595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1962598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962624 */     // MIs[0] policy
     /* 1962624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962634 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1962637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962658 */     // GIR_Coverage, 25036,
     /* 1962658 */     GIR_EraseRootFromParent_Done,
     /* 1962659 */   // Label 26329: @1962659
     /* 1962659 */   GIM_Try, /*On fail goto*//*Label 26330*/ GIMT_Encode4(1962745), // Rule ID 25037 //
     /* 1962664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1962675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1962678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1962681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1962684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962710 */     // MIs[0] policy
     /* 1962710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962720 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1962723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962744 */     // GIR_Coverage, 25037,
     /* 1962744 */     GIR_EraseRootFromParent_Done,
     /* 1962745 */   // Label 26330: @1962745
     /* 1962745 */   GIM_Try, /*On fail goto*//*Label 26331*/ GIMT_Encode4(1962831), // Rule ID 25040 //
     /* 1962750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1962761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1962764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1962767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1962770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962796 */     // MIs[0] policy
     /* 1962796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962806 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1962809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962830 */     // GIR_Coverage, 25040,
     /* 1962830 */     GIR_EraseRootFromParent_Done,
     /* 1962831 */   // Label 26331: @1962831
     /* 1962831 */   GIM_Try, /*On fail goto*//*Label 26332*/ GIMT_Encode4(1962917), // Rule ID 25041 //
     /* 1962836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1962847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1962850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1962853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1962856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962882 */     // MIs[0] policy
     /* 1962882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962892 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1962895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962916 */     // GIR_Coverage, 25041,
     /* 1962916 */     GIR_EraseRootFromParent_Done,
     /* 1962917 */   // Label 26332: @1962917
     /* 1962917 */   GIM_Try, /*On fail goto*//*Label 26333*/ GIMT_Encode4(1963003), // Rule ID 25044 //
     /* 1962922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1962933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1962936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1962939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1962942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962968 */     // MIs[0] policy
     /* 1962968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962978 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1962981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963002 */     // GIR_Coverage, 25044,
     /* 1963002 */     GIR_EraseRootFromParent_Done,
     /* 1963003 */   // Label 26333: @1963003
     /* 1963003 */   GIM_Try, /*On fail goto*//*Label 26334*/ GIMT_Encode4(1963089), // Rule ID 25045 //
     /* 1963008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1963019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1963022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1963025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1963028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963054 */     // MIs[0] policy
     /* 1963054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963064 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1963067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963088 */     // GIR_Coverage, 25045,
     /* 1963088 */     GIR_EraseRootFromParent_Done,
     /* 1963089 */   // Label 26334: @1963089
     /* 1963089 */   GIM_Try, /*On fail goto*//*Label 26335*/ GIMT_Encode4(1963175), // Rule ID 25048 //
     /* 1963094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1963105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1963108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1963111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1963114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963140 */     // MIs[0] policy
     /* 1963140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963150 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1963153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963174 */     // GIR_Coverage, 25048,
     /* 1963174 */     GIR_EraseRootFromParent_Done,
     /* 1963175 */   // Label 26335: @1963175
     /* 1963175 */   GIM_Try, /*On fail goto*//*Label 26336*/ GIMT_Encode4(1963261), // Rule ID 25049 //
     /* 1963180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1963191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1963194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1963197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1963200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963226 */     // MIs[0] policy
     /* 1963226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963236 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1963239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963260 */     // GIR_Coverage, 25049,
     /* 1963260 */     GIR_EraseRootFromParent_Done,
     /* 1963261 */   // Label 26336: @1963261
     /* 1963261 */   GIM_Try, /*On fail goto*//*Label 26337*/ GIMT_Encode4(1963347), // Rule ID 25052 //
     /* 1963266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1963269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1963277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1963280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1963283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963312 */     // MIs[0] policy
     /* 1963312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963322 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1963325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963346 */     // GIR_Coverage, 25052,
     /* 1963346 */     GIR_EraseRootFromParent_Done,
     /* 1963347 */   // Label 26337: @1963347
     /* 1963347 */   GIM_Try, /*On fail goto*//*Label 26338*/ GIMT_Encode4(1963433), // Rule ID 25053 //
     /* 1963352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1963355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1963363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1963366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1963369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963398 */     // MIs[0] policy
     /* 1963398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963408 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1963411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963432 */     // GIR_Coverage, 25053,
     /* 1963432 */     GIR_EraseRootFromParent_Done,
     /* 1963433 */   // Label 26338: @1963433
     /* 1963433 */   GIM_Try, /*On fail goto*//*Label 26339*/ GIMT_Encode4(1963519), // Rule ID 25056 //
     /* 1963438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1963449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1963452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1963455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1963458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963484 */     // MIs[0] policy
     /* 1963484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963494 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1963497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963518 */     // GIR_Coverage, 25056,
     /* 1963518 */     GIR_EraseRootFromParent_Done,
     /* 1963519 */   // Label 26339: @1963519
     /* 1963519 */   GIM_Try, /*On fail goto*//*Label 26340*/ GIMT_Encode4(1963605), // Rule ID 25057 //
     /* 1963524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1963535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1963538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1963541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1963544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963570 */     // MIs[0] policy
     /* 1963570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963580 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1963583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963604 */     // GIR_Coverage, 25057,
     /* 1963604 */     GIR_EraseRootFromParent_Done,
     /* 1963605 */   // Label 26340: @1963605
     /* 1963605 */   GIM_Try, /*On fail goto*//*Label 26341*/ GIMT_Encode4(1963691), // Rule ID 25060 //
     /* 1963610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1963621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1963624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1963627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1963630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1963633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963656 */     // MIs[0] policy
     /* 1963656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963666 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1963669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963690 */     // GIR_Coverage, 25060,
     /* 1963690 */     GIR_EraseRootFromParent_Done,
     /* 1963691 */   // Label 26341: @1963691
     /* 1963691 */   GIM_Try, /*On fail goto*//*Label 26342*/ GIMT_Encode4(1963777), // Rule ID 25061 //
     /* 1963696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1963707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1963710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1963713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1963716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1963719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963742 */     // MIs[0] policy
     /* 1963742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963752 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1963755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963776 */     // GIR_Coverage, 25061,
     /* 1963776 */     GIR_EraseRootFromParent_Done,
     /* 1963777 */   // Label 26342: @1963777
     /* 1963777 */   GIM_Try, /*On fail goto*//*Label 26343*/ GIMT_Encode4(1963863), // Rule ID 25064 //
     /* 1963782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1963793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1963796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1963799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1963802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1963805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963828 */     // MIs[0] policy
     /* 1963828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963838 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1963841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963862 */     // GIR_Coverage, 25064,
     /* 1963862 */     GIR_EraseRootFromParent_Done,
     /* 1963863 */   // Label 26343: @1963863
     /* 1963863 */   GIM_Try, /*On fail goto*//*Label 26344*/ GIMT_Encode4(1963949), // Rule ID 25065 //
     /* 1963868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1963879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1963882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1963885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1963888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1963891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963914 */     // MIs[0] policy
     /* 1963914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963924 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1963927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963948 */     // GIR_Coverage, 25065,
     /* 1963948 */     GIR_EraseRootFromParent_Done,
     /* 1963949 */   // Label 26344: @1963949
     /* 1963949 */   GIM_Try, /*On fail goto*//*Label 26345*/ GIMT_Encode4(1964035), // Rule ID 25068 //
     /* 1963954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1963965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1963968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1963971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1963974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964000 */     // MIs[0] policy
     /* 1964000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964010 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1964013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964034 */     // GIR_Coverage, 25068,
     /* 1964034 */     GIR_EraseRootFromParent_Done,
     /* 1964035 */   // Label 26345: @1964035
     /* 1964035 */   GIM_Try, /*On fail goto*//*Label 26346*/ GIMT_Encode4(1964121), // Rule ID 25069 //
     /* 1964040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1964051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1964054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1964057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964086 */     // MIs[0] policy
     /* 1964086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964096 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1964099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964120 */     // GIR_Coverage, 25069,
     /* 1964120 */     GIR_EraseRootFromParent_Done,
     /* 1964121 */   // Label 26346: @1964121
     /* 1964121 */   GIM_Try, /*On fail goto*//*Label 26347*/ GIMT_Encode4(1964207), // Rule ID 25072 //
     /* 1964126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1964137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1964140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1964143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964172 */     // MIs[0] policy
     /* 1964172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964182 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1964185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964206 */     // GIR_Coverage, 25072,
     /* 1964206 */     GIR_EraseRootFromParent_Done,
     /* 1964207 */   // Label 26347: @1964207
     /* 1964207 */   GIM_Try, /*On fail goto*//*Label 26348*/ GIMT_Encode4(1964293), // Rule ID 25073 //
     /* 1964212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1964223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1964226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1964229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964258 */     // MIs[0] policy
     /* 1964258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964268 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1964271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964292 */     // GIR_Coverage, 25073,
     /* 1964292 */     GIR_EraseRootFromParent_Done,
     /* 1964293 */   // Label 26348: @1964293
     /* 1964293 */   GIM_Try, /*On fail goto*//*Label 26349*/ GIMT_Encode4(1964379), // Rule ID 25076 //
     /* 1964298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1964309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1964312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1964315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964344 */     // MIs[0] policy
     /* 1964344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964354 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1964357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964378 */     // GIR_Coverage, 25076,
     /* 1964378 */     GIR_EraseRootFromParent_Done,
     /* 1964379 */   // Label 26349: @1964379
     /* 1964379 */   GIM_Try, /*On fail goto*//*Label 26350*/ GIMT_Encode4(1964465), // Rule ID 25077 //
     /* 1964384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1964395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1964398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1964401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964430 */     // MIs[0] policy
     /* 1964430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964440 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1964443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964464 */     // GIR_Coverage, 25077,
     /* 1964464 */     GIR_EraseRootFromParent_Done,
     /* 1964465 */   // Label 26350: @1964465
     /* 1964465 */   GIM_Try, /*On fail goto*//*Label 26351*/ GIMT_Encode4(1964551), // Rule ID 25080 //
     /* 1964470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1964473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1964481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1964484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1964487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1964490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964516 */     // MIs[0] policy
     /* 1964516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964526 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1964529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964550 */     // GIR_Coverage, 25080,
     /* 1964550 */     GIR_EraseRootFromParent_Done,
     /* 1964551 */   // Label 26351: @1964551
     /* 1964551 */   GIM_Try, /*On fail goto*//*Label 26352*/ GIMT_Encode4(1964637), // Rule ID 25081 //
     /* 1964556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1964559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1964567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1964570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1964573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1964576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964602 */     // MIs[0] policy
     /* 1964602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964612 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1964615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964636 */     // GIR_Coverage, 25081,
     /* 1964636 */     GIR_EraseRootFromParent_Done,
     /* 1964637 */   // Label 26352: @1964637
     /* 1964637 */   GIM_Try, /*On fail goto*//*Label 26353*/ GIMT_Encode4(1964723), // Rule ID 25084 //
     /* 1964642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1964645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1964653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1964656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1964659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964688 */     // MIs[0] policy
     /* 1964688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964698 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1964701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964722 */     // GIR_Coverage, 25084,
     /* 1964722 */     GIR_EraseRootFromParent_Done,
     /* 1964723 */   // Label 26353: @1964723
     /* 1964723 */   GIM_Try, /*On fail goto*//*Label 26354*/ GIMT_Encode4(1964809), // Rule ID 25085 //
     /* 1964728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1964731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1964739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1964742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1964745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964774 */     // MIs[0] policy
     /* 1964774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964784 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1964787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964808 */     // GIR_Coverage, 25085,
     /* 1964808 */     GIR_EraseRootFromParent_Done,
     /* 1964809 */   // Label 26354: @1964809
     /* 1964809 */   GIM_Try, /*On fail goto*//*Label 26355*/ GIMT_Encode4(1964895), // Rule ID 25088 //
     /* 1964814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1964817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1964825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1964828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1964831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964860 */     // MIs[0] policy
     /* 1964860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964870 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1964873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964894 */     // GIR_Coverage, 25088,
     /* 1964894 */     GIR_EraseRootFromParent_Done,
     /* 1964895 */   // Label 26355: @1964895
     /* 1964895 */   GIM_Try, /*On fail goto*//*Label 26356*/ GIMT_Encode4(1964981), // Rule ID 25089 //
     /* 1964900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1964903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1964911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1964914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1964917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964946 */     // MIs[0] policy
     /* 1964946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964956 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1964959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964980 */     // GIR_Coverage, 25089,
     /* 1964980 */     GIR_EraseRootFromParent_Done,
     /* 1964981 */   // Label 26356: @1964981
     /* 1964981 */   GIM_Try, /*On fail goto*//*Label 26357*/ GIMT_Encode4(1965067), // Rule ID 60976 //
     /* 1964986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1964989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1964997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1965000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1965003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1965006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965032 */     // MIs[0] policy
     /* 1965032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965042 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1965045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965066 */     // GIR_Coverage, 60976,
     /* 1965066 */     GIR_EraseRootFromParent_Done,
     /* 1965067 */   // Label 26357: @1965067
     /* 1965067 */   GIM_Try, /*On fail goto*//*Label 26358*/ GIMT_Encode4(1965153), // Rule ID 60977 //
     /* 1965072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1965083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1965086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1965089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1965092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965118 */     // MIs[0] policy
     /* 1965118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965128 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1965131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965152 */     // GIR_Coverage, 60977,
     /* 1965152 */     GIR_EraseRootFromParent_Done,
     /* 1965153 */   // Label 26358: @1965153
     /* 1965153 */   GIM_Try, /*On fail goto*//*Label 26359*/ GIMT_Encode4(1965239), // Rule ID 60980 //
     /* 1965158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1965175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1965178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965204 */     // MIs[0] policy
     /* 1965204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965214 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1965217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965238 */     // GIR_Coverage, 60980,
     /* 1965238 */     GIR_EraseRootFromParent_Done,
     /* 1965239 */   // Label 26359: @1965239
     /* 1965239 */   GIM_Try, /*On fail goto*//*Label 26360*/ GIMT_Encode4(1965325), // Rule ID 60981 //
     /* 1965244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1965261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1965264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965290 */     // MIs[0] policy
     /* 1965290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965300 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1965303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965324 */     // GIR_Coverage, 60981,
     /* 1965324 */     GIR_EraseRootFromParent_Done,
     /* 1965325 */   // Label 26360: @1965325
     /* 1965325 */   GIM_Try, /*On fail goto*//*Label 26361*/ GIMT_Encode4(1965411), // Rule ID 60984 //
     /* 1965330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1965341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1965344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1965347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1965350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965376 */     // MIs[0] policy
     /* 1965376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1965389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965410 */     // GIR_Coverage, 60984,
     /* 1965410 */     GIR_EraseRootFromParent_Done,
     /* 1965411 */   // Label 26361: @1965411
     /* 1965411 */   GIM_Try, /*On fail goto*//*Label 26362*/ GIMT_Encode4(1965497), // Rule ID 60985 //
     /* 1965416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1965427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1965430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1965433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1965436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965462 */     // MIs[0] policy
     /* 1965462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965472 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1965475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965496 */     // GIR_Coverage, 60985,
     /* 1965496 */     GIR_EraseRootFromParent_Done,
     /* 1965497 */   // Label 26362: @1965497
     /* 1965497 */   GIM_Try, /*On fail goto*//*Label 26363*/ GIMT_Encode4(1965583), // Rule ID 60988 //
     /* 1965502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1965513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1965516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1965519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1965522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965548 */     // MIs[0] policy
     /* 1965548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965558 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1965561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965582 */     // GIR_Coverage, 60988,
     /* 1965582 */     GIR_EraseRootFromParent_Done,
     /* 1965583 */   // Label 26363: @1965583
     /* 1965583 */   GIM_Try, /*On fail goto*//*Label 26364*/ GIMT_Encode4(1965669), // Rule ID 60989 //
     /* 1965588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1965599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1965602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1965605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1965608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965634 */     // MIs[0] policy
     /* 1965634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1965647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965668 */     // GIR_Coverage, 60989,
     /* 1965668 */     GIR_EraseRootFromParent_Done,
     /* 1965669 */   // Label 26364: @1965669
     /* 1965669 */   GIM_Try, /*On fail goto*//*Label 26365*/ GIMT_Encode4(1965755), // Rule ID 60992 //
     /* 1965674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1965685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1965688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1965691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1965694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1965697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965720 */     // MIs[0] policy
     /* 1965720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965730 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1965733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965754 */     // GIR_Coverage, 60992,
     /* 1965754 */     GIR_EraseRootFromParent_Done,
     /* 1965755 */   // Label 26365: @1965755
     /* 1965755 */   GIM_Try, /*On fail goto*//*Label 26366*/ GIMT_Encode4(1965841), // Rule ID 60993 //
     /* 1965760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1965771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1965774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1965777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1965780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1965783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965806 */     // MIs[0] policy
     /* 1965806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965816 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1965819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965840 */     // GIR_Coverage, 60993,
     /* 1965840 */     GIR_EraseRootFromParent_Done,
     /* 1965841 */   // Label 26366: @1965841
     /* 1965841 */   GIM_Try, /*On fail goto*//*Label 26367*/ GIMT_Encode4(1965927), // Rule ID 60996 //
     /* 1965846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1965857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1965860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1965863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1965866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1965869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965892 */     // MIs[0] policy
     /* 1965892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965902 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1965905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965926 */     // GIR_Coverage, 60996,
     /* 1965926 */     GIR_EraseRootFromParent_Done,
     /* 1965927 */   // Label 26367: @1965927
     /* 1965927 */   GIM_Try, /*On fail goto*//*Label 26368*/ GIMT_Encode4(1966013), // Rule ID 60997 //
     /* 1965932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1965943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1965946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1965949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1965952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1965955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965978 */     // MIs[0] policy
     /* 1965978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965988 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1965991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966012 */     // GIR_Coverage, 60997,
     /* 1966012 */     GIR_EraseRootFromParent_Done,
     /* 1966013 */   // Label 26368: @1966013
     /* 1966013 */   GIM_Try, /*On fail goto*//*Label 26369*/ GIMT_Encode4(1966099), // Rule ID 61000 //
     /* 1966018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1966029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1966032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966064 */     // MIs[0] policy
     /* 1966064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966074 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1966077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966098 */     // GIR_Coverage, 61000,
     /* 1966098 */     GIR_EraseRootFromParent_Done,
     /* 1966099 */   // Label 26369: @1966099
     /* 1966099 */   GIM_Try, /*On fail goto*//*Label 26370*/ GIMT_Encode4(1966185), // Rule ID 61001 //
     /* 1966104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1966115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1966118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966150 */     // MIs[0] policy
     /* 1966150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966160 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1966163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966184 */     // GIR_Coverage, 61001,
     /* 1966184 */     GIR_EraseRootFromParent_Done,
     /* 1966185 */   // Label 26370: @1966185
     /* 1966185 */   GIM_Try, /*On fail goto*//*Label 26371*/ GIMT_Encode4(1966271), // Rule ID 61004 //
     /* 1966190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1966201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1966204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1966207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1966210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966236 */     // MIs[0] policy
     /* 1966236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966246 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11680:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1966249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966270 */     // GIR_Coverage, 61004,
     /* 1966270 */     GIR_EraseRootFromParent_Done,
     /* 1966271 */   // Label 26371: @1966271
     /* 1966271 */   GIM_Try, /*On fail goto*//*Label 26372*/ GIMT_Encode4(1966357), // Rule ID 61005 //
     /* 1966276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1966287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1966290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1966293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1966296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966322 */     // MIs[0] policy
     /* 1966322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966332 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11680:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1966335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966356 */     // GIR_Coverage, 61005,
     /* 1966356 */     GIR_EraseRootFromParent_Done,
     /* 1966357 */   // Label 26372: @1966357
     /* 1966357 */   GIM_Try, /*On fail goto*//*Label 26373*/ GIMT_Encode4(1966443), // Rule ID 61008 //
     /* 1966362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1966373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1966376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1966379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1966382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966408 */     // MIs[0] policy
     /* 1966408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1966421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966442 */     // GIR_Coverage, 61008,
     /* 1966442 */     GIR_EraseRootFromParent_Done,
     /* 1966443 */   // Label 26373: @1966443
     /* 1966443 */   GIM_Try, /*On fail goto*//*Label 26374*/ GIMT_Encode4(1966529), // Rule ID 61009 //
     /* 1966448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1966459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1966462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1966465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1966468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966494 */     // MIs[0] policy
     /* 1966494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966504 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1966507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966528 */     // GIR_Coverage, 61009,
     /* 1966528 */     GIR_EraseRootFromParent_Done,
     /* 1966529 */   // Label 26374: @1966529
     /* 1966529 */   GIM_Try, /*On fail goto*//*Label 26375*/ GIMT_Encode4(1966615), // Rule ID 61012 //
     /* 1966534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1966545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1966548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1966551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1966554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1966557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966580 */     // MIs[0] policy
     /* 1966580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966590 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1966593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966614 */     // GIR_Coverage, 61012,
     /* 1966614 */     GIR_EraseRootFromParent_Done,
     /* 1966615 */   // Label 26375: @1966615
     /* 1966615 */   GIM_Try, /*On fail goto*//*Label 26376*/ GIMT_Encode4(1966701), // Rule ID 61013 //
     /* 1966620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1966631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1966634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1966637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1966640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1966643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966666 */     // MIs[0] policy
     /* 1966666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966676 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1966679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966700 */     // GIR_Coverage, 61013,
     /* 1966700 */     GIR_EraseRootFromParent_Done,
     /* 1966701 */   // Label 26376: @1966701
     /* 1966701 */   GIM_Try, /*On fail goto*//*Label 26377*/ GIMT_Encode4(1966787), // Rule ID 61016 //
     /* 1966706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1966717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1966720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1966723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1966726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1966729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966752 */     // MIs[0] policy
     /* 1966752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966762 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1966765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966786 */     // GIR_Coverage, 61016,
     /* 1966786 */     GIR_EraseRootFromParent_Done,
     /* 1966787 */   // Label 26377: @1966787
     /* 1966787 */   GIM_Try, /*On fail goto*//*Label 26378*/ GIMT_Encode4(1966873), // Rule ID 61017 //
     /* 1966792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1966803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1966806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1966809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1966812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1966815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966838 */     // MIs[0] policy
     /* 1966838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966848 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1966851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966872 */     // GIR_Coverage, 61017,
     /* 1966872 */     GIR_EraseRootFromParent_Done,
     /* 1966873 */   // Label 26378: @1966873
     /* 1966873 */   GIM_Try, /*On fail goto*//*Label 26379*/ GIMT_Encode4(1966959), // Rule ID 61020 //
     /* 1966878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1966889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1966892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1966895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1966898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966924 */     // MIs[0] policy
     /* 1966924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966934 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1966937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1966955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966958 */     // GIR_Coverage, 61020,
     /* 1966958 */     GIR_EraseRootFromParent_Done,
     /* 1966959 */   // Label 26379: @1966959
     /* 1966959 */   GIM_Try, /*On fail goto*//*Label 26380*/ GIMT_Encode4(1967045), // Rule ID 61021 //
     /* 1966964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1966975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1966978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1966981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1966984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967010 */     // MIs[0] policy
     /* 1967010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1967023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967044 */     // GIR_Coverage, 61021,
     /* 1967044 */     GIR_EraseRootFromParent_Done,
     /* 1967045 */   // Label 26380: @1967045
     /* 1967045 */   GIM_Try, /*On fail goto*//*Label 26381*/ GIMT_Encode4(1967131), // Rule ID 61024 //
     /* 1967050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1967061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1967064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1967067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1967070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967096 */     // MIs[0] policy
     /* 1967096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967106 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1967109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967130 */     // GIR_Coverage, 61024,
     /* 1967130 */     GIR_EraseRootFromParent_Done,
     /* 1967131 */   // Label 26381: @1967131
     /* 1967131 */   GIM_Try, /*On fail goto*//*Label 26382*/ GIMT_Encode4(1967217), // Rule ID 61025 //
     /* 1967136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1967147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1967150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1967153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1967156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967182 */     // MIs[0] policy
     /* 1967182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1967195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967216 */     // GIR_Coverage, 61025,
     /* 1967216 */     GIR_EraseRootFromParent_Done,
     /* 1967217 */   // Label 26382: @1967217
     /* 1967217 */   GIM_Try, /*On fail goto*//*Label 26383*/ GIMT_Encode4(1967303), // Rule ID 61028 //
     /* 1967222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1967233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1967236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1967242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967268 */     // MIs[0] policy
     /* 1967268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967278 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1967281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967302 */     // GIR_Coverage, 61028,
     /* 1967302 */     GIR_EraseRootFromParent_Done,
     /* 1967303 */   // Label 26383: @1967303
     /* 1967303 */   GIM_Try, /*On fail goto*//*Label 26384*/ GIMT_Encode4(1967389), // Rule ID 61029 //
     /* 1967308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1967319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1967322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1967328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967354 */     // MIs[0] policy
     /* 1967354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1967367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967388 */     // GIR_Coverage, 61029,
     /* 1967388 */     GIR_EraseRootFromParent_Done,
     /* 1967389 */   // Label 26384: @1967389
     /* 1967389 */   GIM_Try, /*On fail goto*//*Label 26385*/ GIMT_Encode4(1967475), // Rule ID 61032 //
     /* 1967394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1967405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1967408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1967411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1967414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967440 */     // MIs[0] policy
     /* 1967440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967450 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1967453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967474 */     // GIR_Coverage, 61032,
     /* 1967474 */     GIR_EraseRootFromParent_Done,
     /* 1967475 */   // Label 26385: @1967475
     /* 1967475 */   GIM_Try, /*On fail goto*//*Label 26386*/ GIMT_Encode4(1967561), // Rule ID 61033 //
     /* 1967480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1967491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1967494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1967497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1967500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967526 */     // MIs[0] policy
     /* 1967526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1967539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967560 */     // GIR_Coverage, 61033,
     /* 1967560 */     GIR_EraseRootFromParent_Done,
     /* 1967561 */   // Label 26386: @1967561
     /* 1967561 */   GIM_Try, /*On fail goto*//*Label 26387*/ GIMT_Encode4(1967647), // Rule ID 61036 //
     /* 1967566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1967577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1967580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1967583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967612 */     // MIs[0] policy
     /* 1967612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967622 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1967625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1967643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967646 */     // GIR_Coverage, 61036,
     /* 1967646 */     GIR_EraseRootFromParent_Done,
     /* 1967647 */   // Label 26387: @1967647
     /* 1967647 */   GIM_Try, /*On fail goto*//*Label 26388*/ GIMT_Encode4(1967733), // Rule ID 61037 //
     /* 1967652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1967663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1967666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1967669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967698 */     // MIs[0] policy
     /* 1967698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967708 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1967711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1967729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967732 */     // GIR_Coverage, 61037,
     /* 1967732 */     GIR_EraseRootFromParent_Done,
     /* 1967733 */   // Label 26388: @1967733
     /* 1967733 */   GIM_Try, /*On fail goto*//*Label 26389*/ GIMT_Encode4(1967819), // Rule ID 61044 //
     /* 1967738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1967749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1967752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1967755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967784 */     // MIs[0] policy
     /* 1967784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967794 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1967797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1967815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967818 */     // GIR_Coverage, 61044,
     /* 1967818 */     GIR_EraseRootFromParent_Done,
     /* 1967819 */   // Label 26389: @1967819
     /* 1967819 */   GIM_Try, /*On fail goto*//*Label 26390*/ GIMT_Encode4(1967905), // Rule ID 61045 //
     /* 1967824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1967835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1967838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1967841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967870 */     // MIs[0] policy
     /* 1967870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967880 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1967883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1967901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967904 */     // GIR_Coverage, 61045,
     /* 1967904 */     GIR_EraseRootFromParent_Done,
     /* 1967905 */   // Label 26390: @1967905
     /* 1967905 */   GIM_Try, /*On fail goto*//*Label 26391*/ GIMT_Encode4(1967991), // Rule ID 61052 //
     /* 1967910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1967921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1967924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1967927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967956 */     // MIs[0] policy
     /* 1967956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967966 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1967969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1967987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967990 */     // GIR_Coverage, 61052,
     /* 1967990 */     GIR_EraseRootFromParent_Done,
     /* 1967991 */   // Label 26391: @1967991
     /* 1967991 */   GIM_Try, /*On fail goto*//*Label 26392*/ GIMT_Encode4(1968077), // Rule ID 61053 //
     /* 1967996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1968007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1968010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1968013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968042 */     // MIs[0] policy
     /* 1968042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11680:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1968055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968076 */     // GIR_Coverage, 61053,
     /* 1968076 */     GIR_EraseRootFromParent_Done,
     /* 1968077 */   // Label 26392: @1968077
     /* 1968077 */   GIM_Try, /*On fail goto*//*Label 26393*/ GIMT_Encode4(1968163), // Rule ID 61060 //
     /* 1968082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1968093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1968096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1968099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968128 */     // MIs[0] policy
     /* 1968128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968138 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1968141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968162 */     // GIR_Coverage, 61060,
     /* 1968162 */     GIR_EraseRootFromParent_Done,
     /* 1968163 */   // Label 26393: @1968163
     /* 1968163 */   GIM_Try, /*On fail goto*//*Label 26394*/ GIMT_Encode4(1968249), // Rule ID 61061 //
     /* 1968168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1968179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1968182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1968185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968214 */     // MIs[0] policy
     /* 1968214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1968227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968248 */     // GIR_Coverage, 61061,
     /* 1968248 */     GIR_EraseRootFromParent_Done,
     /* 1968249 */   // Label 26394: @1968249
     /* 1968249 */   GIM_Try, /*On fail goto*//*Label 26395*/ GIMT_Encode4(1968335), // Rule ID 61068 //
     /* 1968254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1968265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1968268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1968271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968300 */     // MIs[0] policy
     /* 1968300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968310 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1968313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968334 */     // GIR_Coverage, 61068,
     /* 1968334 */     GIR_EraseRootFromParent_Done,
     /* 1968335 */   // Label 26395: @1968335
     /* 1968335 */   GIM_Try, /*On fail goto*//*Label 26396*/ GIMT_Encode4(1968421), // Rule ID 61069 //
     /* 1968340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1968351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1968354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1968357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968386 */     // MIs[0] policy
     /* 1968386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1968399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968420 */     // GIR_Coverage, 61069,
     /* 1968420 */     GIR_EraseRootFromParent_Done,
     /* 1968421 */   // Label 26396: @1968421
     /* 1968421 */   GIM_Try, /*On fail goto*//*Label 26397*/ GIMT_Encode4(1968507), // Rule ID 61076 //
     /* 1968426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1968437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1968440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1968443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1968449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968472 */     // MIs[0] policy
     /* 1968472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968482 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1968485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968506 */     // GIR_Coverage, 61076,
     /* 1968506 */     GIR_EraseRootFromParent_Done,
     /* 1968507 */   // Label 26397: @1968507
     /* 1968507 */   GIM_Try, /*On fail goto*//*Label 26398*/ GIMT_Encode4(1968593), // Rule ID 61077 //
     /* 1968512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1968523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1968526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1968529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1968535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968558 */     // MIs[0] policy
     /* 1968558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968568 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1968571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968592 */     // GIR_Coverage, 61077,
     /* 1968592 */     GIR_EraseRootFromParent_Done,
     /* 1968593 */   // Label 26398: @1968593
     /* 1968593 */   GIM_Try, /*On fail goto*//*Label 26399*/ GIMT_Encode4(1968679), // Rule ID 61084 //
     /* 1968598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1968609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1968612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1968615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968644 */     // MIs[0] policy
     /* 1968644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1968657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1968675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968678 */     // GIR_Coverage, 61084,
     /* 1968678 */     GIR_EraseRootFromParent_Done,
     /* 1968679 */   // Label 26399: @1968679
     /* 1968679 */   GIM_Try, /*On fail goto*//*Label 26400*/ GIMT_Encode4(1968765), // Rule ID 61085 //
     /* 1968684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1968695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1968698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1968701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968730 */     // MIs[0] policy
     /* 1968730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968740 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1968743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1968761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968764 */     // GIR_Coverage, 61085,
     /* 1968764 */     GIR_EraseRootFromParent_Done,
     /* 1968765 */   // Label 26400: @1968765
     /* 1968765 */   GIM_Try, /*On fail goto*//*Label 26401*/ GIMT_Encode4(1968851), // Rule ID 61092 //
     /* 1968770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1968781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1968784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1968787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968816 */     // MIs[0] policy
     /* 1968816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11680:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1968829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1968847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968850 */     // GIR_Coverage, 61092,
     /* 1968850 */     GIR_EraseRootFromParent_Done,
     /* 1968851 */   // Label 26401: @1968851
     /* 1968851 */   GIM_Try, /*On fail goto*//*Label 26402*/ GIMT_Encode4(1968937), // Rule ID 61093 //
     /* 1968856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1968867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1968870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1968873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968902 */     // MIs[0] policy
     /* 1968902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968912 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11680:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1968915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1968933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968936 */     // GIR_Coverage, 61093,
     /* 1968936 */     GIR_EraseRootFromParent_Done,
     /* 1968937 */   // Label 26402: @1968937
     /* 1968937 */   GIM_Try, /*On fail goto*//*Label 26403*/ GIMT_Encode4(1969023), // Rule ID 61100 //
     /* 1968942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1968953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1968956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1968959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968988 */     // MIs[0] policy
     /* 1968988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1969001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969022 */     // GIR_Coverage, 61100,
     /* 1969022 */     GIR_EraseRootFromParent_Done,
     /* 1969023 */   // Label 26403: @1969023
     /* 1969023 */   GIM_Try, /*On fail goto*//*Label 26404*/ GIMT_Encode4(1969109), // Rule ID 61101 //
     /* 1969028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1969039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1969042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1969045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969074 */     // MIs[0] policy
     /* 1969074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1969087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969108 */     // GIR_Coverage, 61101,
     /* 1969108 */     GIR_EraseRootFromParent_Done,
     /* 1969109 */   // Label 26404: @1969109
     /* 1969109 */   GIM_Try, /*On fail goto*//*Label 26405*/ GIMT_Encode4(1969195), // Rule ID 61108 //
     /* 1969114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1969125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1969128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1969131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969160 */     // MIs[0] policy
     /* 1969160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969170 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1969173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969194 */     // GIR_Coverage, 61108,
     /* 1969194 */     GIR_EraseRootFromParent_Done,
     /* 1969195 */   // Label 26405: @1969195
     /* 1969195 */   GIM_Try, /*On fail goto*//*Label 26406*/ GIMT_Encode4(1969281), // Rule ID 61109 //
     /* 1969200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1969211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1969214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1969217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969246 */     // MIs[0] policy
     /* 1969246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969256 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1969259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969280 */     // GIR_Coverage, 61109,
     /* 1969280 */     GIR_EraseRootFromParent_Done,
     /* 1969281 */   // Label 26406: @1969281
     /* 1969281 */   GIM_Try, /*On fail goto*//*Label 26407*/ GIMT_Encode4(1969367), // Rule ID 61116 //
     /* 1969286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1969297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1969300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1969303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1969309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969332 */     // MIs[0] policy
     /* 1969332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969342 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1969345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969366 */     // GIR_Coverage, 61116,
     /* 1969366 */     GIR_EraseRootFromParent_Done,
     /* 1969367 */   // Label 26407: @1969367
     /* 1969367 */   GIM_Try, /*On fail goto*//*Label 26408*/ GIMT_Encode4(1969453), // Rule ID 61117 //
     /* 1969372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1969383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1969386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1969389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1969395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969418 */     // MIs[0] policy
     /* 1969418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969428 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1969431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969452 */     // GIR_Coverage, 61117,
     /* 1969452 */     GIR_EraseRootFromParent_Done,
     /* 1969453 */   // Label 26408: @1969453
     /* 1969453 */   GIM_Try, /*On fail goto*//*Label 26409*/ GIMT_Encode4(1969539), // Rule ID 61124 //
     /* 1969458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1969469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1969472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1969475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969504 */     // MIs[0] policy
     /* 1969504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969514 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1969517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969538 */     // GIR_Coverage, 61124,
     /* 1969538 */     GIR_EraseRootFromParent_Done,
     /* 1969539 */   // Label 26409: @1969539
     /* 1969539 */   GIM_Try, /*On fail goto*//*Label 26410*/ GIMT_Encode4(1969625), // Rule ID 61125 //
     /* 1969544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1969555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1969558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1969561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969590 */     // MIs[0] policy
     /* 1969590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11680:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1969603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969624 */     // GIR_Coverage, 61125,
     /* 1969624 */     GIR_EraseRootFromParent_Done,
     /* 1969625 */   // Label 26410: @1969625
     /* 1969625 */   GIM_Try, /*On fail goto*//*Label 26411*/ GIMT_Encode4(1969711), // Rule ID 61132 //
     /* 1969630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1969641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1969644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1969647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969676 */     // MIs[0] policy
     /* 1969676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969686 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1969689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969710 */     // GIR_Coverage, 61132,
     /* 1969710 */     GIR_EraseRootFromParent_Done,
     /* 1969711 */   // Label 26411: @1969711
     /* 1969711 */   GIM_Try, /*On fail goto*//*Label 26412*/ GIMT_Encode4(1969797), // Rule ID 61133 //
     /* 1969716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1969727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1969730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1969733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969762 */     // MIs[0] policy
     /* 1969762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969772 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11680:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1969775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969796 */     // GIR_Coverage, 61133,
     /* 1969796 */     GIR_EraseRootFromParent_Done,
     /* 1969797 */   // Label 26412: @1969797
     /* 1969797 */   GIM_Try, /*On fail goto*//*Label 26413*/ GIMT_Encode4(1969883), // Rule ID 61140 //
     /* 1969802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1969813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1969816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1969819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969848 */     // MIs[0] policy
     /* 1969848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969858 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1969861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969882 */     // GIR_Coverage, 61140,
     /* 1969882 */     GIR_EraseRootFromParent_Done,
     /* 1969883 */   // Label 26413: @1969883
     /* 1969883 */   GIM_Try, /*On fail goto*//*Label 26414*/ GIMT_Encode4(1969969), // Rule ID 61141 //
     /* 1969888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1969899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1969902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1969905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969934 */     // MIs[0] policy
     /* 1969934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969944 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11680:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1969947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969968 */     // GIR_Coverage, 61141,
     /* 1969968 */     GIR_EraseRootFromParent_Done,
     /* 1969969 */   // Label 26414: @1969969
     /* 1969969 */   GIM_Try, /*On fail goto*//*Label 26415*/ GIMT_Encode4(1970055), // Rule ID 61148 //
     /* 1969974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1969985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1969988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1969991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970020 */     // MIs[0] policy
     /* 1970020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970030 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1970033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970054 */     // GIR_Coverage, 61148,
     /* 1970054 */     GIR_EraseRootFromParent_Done,
     /* 1970055 */   // Label 26415: @1970055
     /* 1970055 */   GIM_Try, /*On fail goto*//*Label 26416*/ GIMT_Encode4(1970141), // Rule ID 61149 //
     /* 1970060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1970071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1970074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1970077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970106 */     // MIs[0] policy
     /* 1970106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970116 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11680:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1970119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970140 */     // GIR_Coverage, 61149,
     /* 1970140 */     GIR_EraseRootFromParent_Done,
     /* 1970141 */   // Label 26416: @1970141
     /* 1970141 */   GIM_Try, /*On fail goto*//*Label 26417*/ GIMT_Encode4(1970227), // Rule ID 61156 //
     /* 1970146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1970163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1970166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970192 */     // MIs[0] policy
     /* 1970192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970202 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1970205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970226 */     // GIR_Coverage, 61156,
     /* 1970226 */     GIR_EraseRootFromParent_Done,
     /* 1970227 */   // Label 26417: @1970227
     /* 1970227 */   GIM_Try, /*On fail goto*//*Label 26418*/ GIMT_Encode4(1970313), // Rule ID 61157 //
     /* 1970232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1970249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1970252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970278 */     // MIs[0] policy
     /* 1970278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970288 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1970291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970312 */     // GIR_Coverage, 61157,
     /* 1970312 */     GIR_EraseRootFromParent_Done,
     /* 1970313 */   // Label 26418: @1970313
     /* 1970313 */   GIM_Try, /*On fail goto*//*Label 26419*/ GIMT_Encode4(1970399), // Rule ID 61160 //
     /* 1970318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1970335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1970338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970364 */     // MIs[0] policy
     /* 1970364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970374 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1970377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970398 */     // GIR_Coverage, 61160,
     /* 1970398 */     GIR_EraseRootFromParent_Done,
     /* 1970399 */   // Label 26419: @1970399
     /* 1970399 */   GIM_Try, /*On fail goto*//*Label 26420*/ GIMT_Encode4(1970485), // Rule ID 61161 //
     /* 1970404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1970421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1970424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970450 */     // MIs[0] policy
     /* 1970450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970460 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1970463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970484 */     // GIR_Coverage, 61161,
     /* 1970484 */     GIR_EraseRootFromParent_Done,
     /* 1970485 */   // Label 26420: @1970485
     /* 1970485 */   GIM_Try, /*On fail goto*//*Label 26421*/ GIMT_Encode4(1970571), // Rule ID 61164 //
     /* 1970490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1970501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1970504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1970507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1970510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970536 */     // MIs[0] policy
     /* 1970536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970546 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1970549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970570 */     // GIR_Coverage, 61164,
     /* 1970570 */     GIR_EraseRootFromParent_Done,
     /* 1970571 */   // Label 26421: @1970571
     /* 1970571 */   GIM_Try, /*On fail goto*//*Label 26422*/ GIMT_Encode4(1970657), // Rule ID 61165 //
     /* 1970576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1970587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1970590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1970593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1970596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970622 */     // MIs[0] policy
     /* 1970622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970632 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1970635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970656 */     // GIR_Coverage, 61165,
     /* 1970656 */     GIR_EraseRootFromParent_Done,
     /* 1970657 */   // Label 26422: @1970657
     /* 1970657 */   GIM_Try, /*On fail goto*//*Label 26423*/ GIMT_Encode4(1970743), // Rule ID 61168 //
     /* 1970662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1970673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1970676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1970679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1970682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970708 */     // MIs[0] policy
     /* 1970708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1970721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970742 */     // GIR_Coverage, 61168,
     /* 1970742 */     GIR_EraseRootFromParent_Done,
     /* 1970743 */   // Label 26423: @1970743
     /* 1970743 */   GIM_Try, /*On fail goto*//*Label 26424*/ GIMT_Encode4(1970829), // Rule ID 61169 //
     /* 1970748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1970759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1970762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1970765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1970768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970794 */     // MIs[0] policy
     /* 1970794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970804 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1970807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970828 */     // GIR_Coverage, 61169,
     /* 1970828 */     GIR_EraseRootFromParent_Done,
     /* 1970829 */   // Label 26424: @1970829
     /* 1970829 */   GIM_Try, /*On fail goto*//*Label 26425*/ GIMT_Encode4(1970915), // Rule ID 61172 //
     /* 1970834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1970851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970880 */     // MIs[0] policy
     /* 1970880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1970893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970914 */     // GIR_Coverage, 61172,
     /* 1970914 */     GIR_EraseRootFromParent_Done,
     /* 1970915 */   // Label 26425: @1970915
     /* 1970915 */   GIM_Try, /*On fail goto*//*Label 26426*/ GIMT_Encode4(1971001), // Rule ID 61173 //
     /* 1970920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1970937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970966 */     // MIs[0] policy
     /* 1970966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970976 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1970979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971000 */     // GIR_Coverage, 61173,
     /* 1971000 */     GIR_EraseRootFromParent_Done,
     /* 1971001 */   // Label 26426: @1971001
     /* 1971001 */   GIM_Try, /*On fail goto*//*Label 26427*/ GIMT_Encode4(1971087), // Rule ID 61176 //
     /* 1971006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1971017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1971020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1971023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971052 */     // MIs[0] policy
     /* 1971052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1971065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971086 */     // GIR_Coverage, 61176,
     /* 1971086 */     GIR_EraseRootFromParent_Done,
     /* 1971087 */   // Label 26427: @1971087
     /* 1971087 */   GIM_Try, /*On fail goto*//*Label 26428*/ GIMT_Encode4(1971173), // Rule ID 61177 //
     /* 1971092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1971103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1971106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1971109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971138 */     // MIs[0] policy
     /* 1971138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971148 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1971151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971172 */     // GIR_Coverage, 61177,
     /* 1971172 */     GIR_EraseRootFromParent_Done,
     /* 1971173 */   // Label 26428: @1971173
     /* 1971173 */   GIM_Try, /*On fail goto*//*Label 26429*/ GIMT_Encode4(1971259), // Rule ID 61180 //
     /* 1971178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971224 */     // MIs[0] policy
     /* 1971224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971234 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1971237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971258 */     // GIR_Coverage, 61180,
     /* 1971258 */     GIR_EraseRootFromParent_Done,
     /* 1971259 */   // Label 26429: @1971259
     /* 1971259 */   GIM_Try, /*On fail goto*//*Label 26430*/ GIMT_Encode4(1971345), // Rule ID 61181 //
     /* 1971264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971310 */     // MIs[0] policy
     /* 1971310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971320 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1971323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971344 */     // GIR_Coverage, 61181,
     /* 1971344 */     GIR_EraseRootFromParent_Done,
     /* 1971345 */   // Label 26430: @1971345
     /* 1971345 */   GIM_Try, /*On fail goto*//*Label 26431*/ GIMT_Encode4(1971431), // Rule ID 61184 //
     /* 1971350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1971367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971396 */     // MIs[0] policy
     /* 1971396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971406 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1971409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971430 */     // GIR_Coverage, 61184,
     /* 1971430 */     GIR_EraseRootFromParent_Done,
     /* 1971431 */   // Label 26431: @1971431
     /* 1971431 */   GIM_Try, /*On fail goto*//*Label 26432*/ GIMT_Encode4(1971517), // Rule ID 61185 //
     /* 1971436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1971453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971482 */     // MIs[0] policy
     /* 1971482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971492 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1971495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971516 */     // GIR_Coverage, 61185,
     /* 1971516 */     GIR_EraseRootFromParent_Done,
     /* 1971517 */   // Label 26432: @1971517
     /* 1971517 */   GIM_Try, /*On fail goto*//*Label 26433*/ GIMT_Encode4(1971603), // Rule ID 61188 //
     /* 1971522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1971539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1971542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971568 */     // MIs[0] policy
     /* 1971568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971578 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1971581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971602 */     // GIR_Coverage, 61188,
     /* 1971602 */     GIR_EraseRootFromParent_Done,
     /* 1971603 */   // Label 26433: @1971603
     /* 1971603 */   GIM_Try, /*On fail goto*//*Label 26434*/ GIMT_Encode4(1971689), // Rule ID 61189 //
     /* 1971608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1971625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1971628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971654 */     // MIs[0] policy
     /* 1971654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971664 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1971667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971688 */     // GIR_Coverage, 61189,
     /* 1971688 */     GIR_EraseRootFromParent_Done,
     /* 1971689 */   // Label 26434: @1971689
     /* 1971689 */   GIM_Try, /*On fail goto*//*Label 26435*/ GIMT_Encode4(1971775), // Rule ID 61192 //
     /* 1971694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1971705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1971708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1971711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1971714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971740 */     // MIs[0] policy
     /* 1971740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971750 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1971753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971774 */     // GIR_Coverage, 61192,
     /* 1971774 */     GIR_EraseRootFromParent_Done,
     /* 1971775 */   // Label 26435: @1971775
     /* 1971775 */   GIM_Try, /*On fail goto*//*Label 26436*/ GIMT_Encode4(1971861), // Rule ID 61193 //
     /* 1971780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1971791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1971794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1971797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1971800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971826 */     // MIs[0] policy
     /* 1971826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1971839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971860 */     // GIR_Coverage, 61193,
     /* 1971860 */     GIR_EraseRootFromParent_Done,
     /* 1971861 */   // Label 26436: @1971861
     /* 1971861 */   GIM_Try, /*On fail goto*//*Label 26437*/ GIMT_Encode4(1971947), // Rule ID 61196 //
     /* 1971866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1971886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971912 */     // MIs[0] policy
     /* 1971912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971922 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1971925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971946 */     // GIR_Coverage, 61196,
     /* 1971946 */     GIR_EraseRootFromParent_Done,
     /* 1971947 */   // Label 26437: @1971947
     /* 1971947 */   GIM_Try, /*On fail goto*//*Label 26438*/ GIMT_Encode4(1972033), // Rule ID 61197 //
     /* 1971952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1971972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971998 */     // MIs[0] policy
     /* 1971998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972008 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1972011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972032 */     // GIR_Coverage, 61197,
     /* 1972032 */     GIR_EraseRootFromParent_Done,
     /* 1972033 */   // Label 26438: @1972033
     /* 1972033 */   GIM_Try, /*On fail goto*//*Label 26439*/ GIMT_Encode4(1972119), // Rule ID 61200 //
     /* 1972038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1972049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1972052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1972055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1972058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972084 */     // MIs[0] policy
     /* 1972084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972094 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1972097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972118 */     // GIR_Coverage, 61200,
     /* 1972118 */     GIR_EraseRootFromParent_Done,
     /* 1972119 */   // Label 26439: @1972119
     /* 1972119 */   GIM_Try, /*On fail goto*//*Label 26440*/ GIMT_Encode4(1972205), // Rule ID 61201 //
     /* 1972124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1972135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1972138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1972141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1972144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972170 */     // MIs[0] policy
     /* 1972170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972180 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1972183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972204 */     // GIR_Coverage, 61201,
     /* 1972204 */     GIR_EraseRootFromParent_Done,
     /* 1972205 */   // Label 26440: @1972205
     /* 1972205 */   GIM_Try, /*On fail goto*//*Label 26441*/ GIMT_Encode4(1972291), // Rule ID 61204 //
     /* 1972210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1972221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1972224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1972227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972256 */     // MIs[0] policy
     /* 1972256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972266 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1972269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972290 */     // GIR_Coverage, 61204,
     /* 1972290 */     GIR_EraseRootFromParent_Done,
     /* 1972291 */   // Label 26441: @1972291
     /* 1972291 */   GIM_Try, /*On fail goto*//*Label 26442*/ GIMT_Encode4(1972377), // Rule ID 61205 //
     /* 1972296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1972307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1972310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1972313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972342 */     // MIs[0] policy
     /* 1972342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1972355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972376 */     // GIR_Coverage, 61205,
     /* 1972376 */     GIR_EraseRootFromParent_Done,
     /* 1972377 */   // Label 26442: @1972377
     /* 1972377 */   GIM_Try, /*On fail goto*//*Label 26443*/ GIMT_Encode4(1972463), // Rule ID 61208 //
     /* 1972382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1972393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1972396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1972399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972428 */     // MIs[0] policy
     /* 1972428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972438 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1972441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972462 */     // GIR_Coverage, 61208,
     /* 1972462 */     GIR_EraseRootFromParent_Done,
     /* 1972463 */   // Label 26443: @1972463
     /* 1972463 */   GIM_Try, /*On fail goto*//*Label 26444*/ GIMT_Encode4(1972549), // Rule ID 61209 //
     /* 1972468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1972479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1972482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1972485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972514 */     // MIs[0] policy
     /* 1972514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1972527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972548 */     // GIR_Coverage, 61209,
     /* 1972548 */     GIR_EraseRootFromParent_Done,
     /* 1972549 */   // Label 26444: @1972549
     /* 1972549 */   GIM_Try, /*On fail goto*//*Label 26445*/ GIMT_Encode4(1972635), // Rule ID 61212 //
     /* 1972554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1972565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1972568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1972571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972600 */     // MIs[0] policy
     /* 1972600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972610 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1972613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972634 */     // GIR_Coverage, 61212,
     /* 1972634 */     GIR_EraseRootFromParent_Done,
     /* 1972635 */   // Label 26445: @1972635
     /* 1972635 */   GIM_Try, /*On fail goto*//*Label 26446*/ GIMT_Encode4(1972721), // Rule ID 61213 //
     /* 1972640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1972651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1972654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1972657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972686 */     // MIs[0] policy
     /* 1972686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972696 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1972699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972720 */     // GIR_Coverage, 61213,
     /* 1972720 */     GIR_EraseRootFromParent_Done,
     /* 1972721 */   // Label 26446: @1972721
     /* 1972721 */   GIM_Try, /*On fail goto*//*Label 26447*/ GIMT_Encode4(1972807), // Rule ID 61216 //
     /* 1972726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1972737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1972740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1972743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972772 */     // MIs[0] policy
     /* 1972772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972782 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1972785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972806 */     // GIR_Coverage, 61216,
     /* 1972806 */     GIR_EraseRootFromParent_Done,
     /* 1972807 */   // Label 26447: @1972807
     /* 1972807 */   GIM_Try, /*On fail goto*//*Label 26448*/ GIMT_Encode4(1972893), // Rule ID 61217 //
     /* 1972812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1972823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1972826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1972829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972858 */     // MIs[0] policy
     /* 1972858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1972871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972892 */     // GIR_Coverage, 61217,
     /* 1972892 */     GIR_EraseRootFromParent_Done,
     /* 1972893 */   // Label 26448: @1972893
     /* 1972893 */   GIM_Try, /*On fail goto*//*Label 26449*/ GIMT_Encode4(1972979), // Rule ID 61220 //
     /* 1972898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1972901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1972909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1972912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1972915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1972918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972944 */     // MIs[0] policy
     /* 1972944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972954 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1972957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972978 */     // GIR_Coverage, 61220,
     /* 1972978 */     GIR_EraseRootFromParent_Done,
     /* 1972979 */   // Label 26449: @1972979
     /* 1972979 */   GIM_Try, /*On fail goto*//*Label 26450*/ GIMT_Encode4(1973065), // Rule ID 61221 //
     /* 1972984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1972995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1972998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1973001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1973004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973030 */     // MIs[0] policy
     /* 1973030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973040 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1973043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973064 */     // GIR_Coverage, 61221,
     /* 1973064 */     GIR_EraseRootFromParent_Done,
     /* 1973065 */   // Label 26450: @1973065
     /* 1973065 */   GIM_Try, /*On fail goto*//*Label 26451*/ GIMT_Encode4(1973151), // Rule ID 61224 //
     /* 1973070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1973081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1973084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1973087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1973090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973116 */     // MIs[0] policy
     /* 1973116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973126 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973150 */     // GIR_Coverage, 61224,
     /* 1973150 */     GIR_EraseRootFromParent_Done,
     /* 1973151 */   // Label 26451: @1973151
     /* 1973151 */   GIM_Try, /*On fail goto*//*Label 26452*/ GIMT_Encode4(1973237), // Rule ID 61225 //
     /* 1973156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1973167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1973170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1973173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1973176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973202 */     // MIs[0] policy
     /* 1973202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973212 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973236 */     // GIR_Coverage, 61225,
     /* 1973236 */     GIR_EraseRootFromParent_Done,
     /* 1973237 */   // Label 26452: @1973237
     /* 1973237 */   GIM_Try, /*On fail goto*//*Label 26453*/ GIMT_Encode4(1973323), // Rule ID 61228 //
     /* 1973242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1973253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1973256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1973259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1973262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973288 */     // MIs[0] policy
     /* 1973288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973298 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973322 */     // GIR_Coverage, 61228,
     /* 1973322 */     GIR_EraseRootFromParent_Done,
     /* 1973323 */   // Label 26453: @1973323
     /* 1973323 */   GIM_Try, /*On fail goto*//*Label 26454*/ GIMT_Encode4(1973409), // Rule ID 61229 //
     /* 1973328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1973339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1973342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1973345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1973348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973374 */     // MIs[0] policy
     /* 1973374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973384 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973408 */     // GIR_Coverage, 61229,
     /* 1973408 */     GIR_EraseRootFromParent_Done,
     /* 1973409 */   // Label 26454: @1973409
     /* 1973409 */   GIM_Try, /*On fail goto*//*Label 26455*/ GIMT_Encode4(1973495), // Rule ID 61232 //
     /* 1973414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1973425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1973428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1973431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1973434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973460 */     // MIs[0] policy
     /* 1973460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973470 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973494 */     // GIR_Coverage, 61232,
     /* 1973494 */     GIR_EraseRootFromParent_Done,
     /* 1973495 */   // Label 26455: @1973495
     /* 1973495 */   GIM_Try, /*On fail goto*//*Label 26456*/ GIMT_Encode4(1973581), // Rule ID 61233 //
     /* 1973500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1973511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1973514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1973517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1973520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973546 */     // MIs[0] policy
     /* 1973546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973556 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973580 */     // GIR_Coverage, 61233,
     /* 1973580 */     GIR_EraseRootFromParent_Done,
     /* 1973581 */   // Label 26456: @1973581
     /* 1973581 */   GIM_Try, /*On fail goto*//*Label 26457*/ GIMT_Encode4(1973667), // Rule ID 61236 //
     /* 1973586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1973597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1973600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1973603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1973606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973632 */     // MIs[0] policy
     /* 1973632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973642 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973666 */     // GIR_Coverage, 61236,
     /* 1973666 */     GIR_EraseRootFromParent_Done,
     /* 1973667 */   // Label 26457: @1973667
     /* 1973667 */   GIM_Try, /*On fail goto*//*Label 26458*/ GIMT_Encode4(1973753), // Rule ID 61237 //
     /* 1973672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1973683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1973686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1973689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1973692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973718 */     // MIs[0] policy
     /* 1973718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973728 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973752 */     // GIR_Coverage, 61237,
     /* 1973752 */     GIR_EraseRootFromParent_Done,
     /* 1973753 */   // Label 26458: @1973753
     /* 1973753 */   GIM_Try, /*On fail goto*//*Label 26459*/ GIMT_Encode4(1973839), // Rule ID 61240 //
     /* 1973758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1973769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1973772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1973775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1973778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973804 */     // MIs[0] policy
     /* 1973804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973838 */     // GIR_Coverage, 61240,
     /* 1973838 */     GIR_EraseRootFromParent_Done,
     /* 1973839 */   // Label 26459: @1973839
     /* 1973839 */   GIM_Try, /*On fail goto*//*Label 26460*/ GIMT_Encode4(1973925), // Rule ID 61241 //
     /* 1973844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1973855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1973858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1973861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1973864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973890 */     // MIs[0] policy
     /* 1973890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973900 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973924 */     // GIR_Coverage, 61241,
     /* 1973924 */     GIR_EraseRootFromParent_Done,
     /* 1973925 */   // Label 26460: @1973925
     /* 1973925 */   GIM_Try, /*On fail goto*//*Label 26461*/ GIMT_Encode4(1974011), // Rule ID 61244 //
     /* 1973930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1973941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1973944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1973947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1973950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973976 */     // MIs[0] policy
     /* 1973976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973986 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1973989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974010 */     // GIR_Coverage, 61244,
     /* 1974010 */     GIR_EraseRootFromParent_Done,
     /* 1974011 */   // Label 26461: @1974011
     /* 1974011 */   GIM_Try, /*On fail goto*//*Label 26462*/ GIMT_Encode4(1974097), // Rule ID 61245 //
     /* 1974016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1974027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1974030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1974033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1974036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1974039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974062 */     // MIs[0] policy
     /* 1974062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974072 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974096 */     // GIR_Coverage, 61245,
     /* 1974096 */     GIR_EraseRootFromParent_Done,
     /* 1974097 */   // Label 26462: @1974097
     /* 1974097 */   GIM_Try, /*On fail goto*//*Label 26463*/ GIMT_Encode4(1974183), // Rule ID 61248 //
     /* 1974102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1974113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1974116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1974119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1974122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974148 */     // MIs[0] policy
     /* 1974148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974182 */     // GIR_Coverage, 61248,
     /* 1974182 */     GIR_EraseRootFromParent_Done,
     /* 1974183 */   // Label 26463: @1974183
     /* 1974183 */   GIM_Try, /*On fail goto*//*Label 26464*/ GIMT_Encode4(1974269), // Rule ID 61249 //
     /* 1974188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1974199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1974202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1974205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1974208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974234 */     // MIs[0] policy
     /* 1974234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974244 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974268 */     // GIR_Coverage, 61249,
     /* 1974268 */     GIR_EraseRootFromParent_Done,
     /* 1974269 */   // Label 26464: @1974269
     /* 1974269 */   GIM_Try, /*On fail goto*//*Label 26465*/ GIMT_Encode4(1974355), // Rule ID 61252 //
     /* 1974274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1974285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1974288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1974291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1974294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974320 */     // MIs[0] policy
     /* 1974320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974330 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974354 */     // GIR_Coverage, 61252,
     /* 1974354 */     GIR_EraseRootFromParent_Done,
     /* 1974355 */   // Label 26465: @1974355
     /* 1974355 */   GIM_Try, /*On fail goto*//*Label 26466*/ GIMT_Encode4(1974441), // Rule ID 61253 //
     /* 1974360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1974371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1974374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1974377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1974380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974406 */     // MIs[0] policy
     /* 1974406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974416 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974440 */     // GIR_Coverage, 61253,
     /* 1974440 */     GIR_EraseRootFromParent_Done,
     /* 1974441 */   // Label 26466: @1974441
     /* 1974441 */   GIM_Try, /*On fail goto*//*Label 26467*/ GIMT_Encode4(1974527), // Rule ID 61256 //
     /* 1974446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1974457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1974460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1974463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1974466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974492 */     // MIs[0] policy
     /* 1974492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974526 */     // GIR_Coverage, 61256,
     /* 1974526 */     GIR_EraseRootFromParent_Done,
     /* 1974527 */   // Label 26467: @1974527
     /* 1974527 */   GIM_Try, /*On fail goto*//*Label 26468*/ GIMT_Encode4(1974613), // Rule ID 61257 //
     /* 1974532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1974543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1974546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1974549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1974552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974578 */     // MIs[0] policy
     /* 1974578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974588 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974612 */     // GIR_Coverage, 61257,
     /* 1974612 */     GIR_EraseRootFromParent_Done,
     /* 1974613 */   // Label 26468: @1974613
     /* 1974613 */   GIM_Try, /*On fail goto*//*Label 26469*/ GIMT_Encode4(1974699), // Rule ID 61260 //
     /* 1974618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1974629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1974632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1974635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1974638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1974641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1974648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974664 */     // MIs[0] policy
     /* 1974664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974674 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1974677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974698 */     // GIR_Coverage, 61260,
     /* 1974698 */     GIR_EraseRootFromParent_Done,
     /* 1974699 */   // Label 26469: @1974699
     /* 1974699 */   GIM_Try, /*On fail goto*//*Label 26470*/ GIMT_Encode4(1974785), // Rule ID 61261 //
     /* 1974704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1974715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1974718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1974721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1974724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1974727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1974734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974750 */     // MIs[0] policy
     /* 1974750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974760 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1974763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974784 */     // GIR_Coverage, 61261,
     /* 1974784 */     GIR_EraseRootFromParent_Done,
     /* 1974785 */   // Label 26470: @1974785
     /* 1974785 */   GIM_Try, /*On fail goto*//*Label 26471*/ GIMT_Encode4(1974871), // Rule ID 61264 //
     /* 1974790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1974801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1974804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1974807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1974810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1974813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1974820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974836 */     // MIs[0] policy
     /* 1974836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1974849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974870 */     // GIR_Coverage, 61264,
     /* 1974870 */     GIR_EraseRootFromParent_Done,
     /* 1974871 */   // Label 26471: @1974871
     /* 1974871 */   GIM_Try, /*On fail goto*//*Label 26472*/ GIMT_Encode4(1974957), // Rule ID 61265 //
     /* 1974876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1974887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1974890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1974893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1974896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1974899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1974906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974922 */     // MIs[0] policy
     /* 1974922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974932 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1974935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974956 */     // GIR_Coverage, 61265,
     /* 1974956 */     GIR_EraseRootFromParent_Done,
     /* 1974957 */   // Label 26472: @1974957
     /* 1974957 */   GIM_Try, /*On fail goto*//*Label 26473*/ GIMT_Encode4(1975043), // Rule ID 61268 //
     /* 1974962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1974973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1974976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1974979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1974982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1974985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1974992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975008 */     // MIs[0] policy
     /* 1975008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975018 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975042 */     // GIR_Coverage, 61268,
     /* 1975042 */     GIR_EraseRootFromParent_Done,
     /* 1975043 */   // Label 26473: @1975043
     /* 1975043 */   GIM_Try, /*On fail goto*//*Label 26474*/ GIMT_Encode4(1975129), // Rule ID 61269 //
     /* 1975048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1975059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1975062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1975065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1975068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1975071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975094 */     // MIs[0] policy
     /* 1975094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975104 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975128 */     // GIR_Coverage, 61269,
     /* 1975128 */     GIR_EraseRootFromParent_Done,
     /* 1975129 */   // Label 26474: @1975129
     /* 1975129 */   GIM_Try, /*On fail goto*//*Label 26475*/ GIMT_Encode4(1975215), // Rule ID 61272 //
     /* 1975134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1975145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1975148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1975151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1975154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975180 */     // MIs[0] policy
     /* 1975180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975214 */     // GIR_Coverage, 61272,
     /* 1975214 */     GIR_EraseRootFromParent_Done,
     /* 1975215 */   // Label 26475: @1975215
     /* 1975215 */   GIM_Try, /*On fail goto*//*Label 26476*/ GIMT_Encode4(1975301), // Rule ID 61273 //
     /* 1975220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1975231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1975234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1975237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1975240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975266 */     // MIs[0] policy
     /* 1975266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975276 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975300 */     // GIR_Coverage, 61273,
     /* 1975300 */     GIR_EraseRootFromParent_Done,
     /* 1975301 */   // Label 26476: @1975301
     /* 1975301 */   GIM_Try, /*On fail goto*//*Label 26477*/ GIMT_Encode4(1975387), // Rule ID 61276 //
     /* 1975306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1975317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1975320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1975323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1975326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975352 */     // MIs[0] policy
     /* 1975352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975362 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975386 */     // GIR_Coverage, 61276,
     /* 1975386 */     GIR_EraseRootFromParent_Done,
     /* 1975387 */   // Label 26477: @1975387
     /* 1975387 */   GIM_Try, /*On fail goto*//*Label 26478*/ GIMT_Encode4(1975473), // Rule ID 61277 //
     /* 1975392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1975403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1975406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1975409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1975412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975438 */     // MIs[0] policy
     /* 1975438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975448 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975472 */     // GIR_Coverage, 61277,
     /* 1975472 */     GIR_EraseRootFromParent_Done,
     /* 1975473 */   // Label 26478: @1975473
     /* 1975473 */   GIM_Try, /*On fail goto*//*Label 26479*/ GIMT_Encode4(1975559), // Rule ID 61280 //
     /* 1975478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1975489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1975492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1975495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1975498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975524 */     // MIs[0] policy
     /* 1975524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975534 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975558 */     // GIR_Coverage, 61280,
     /* 1975558 */     GIR_EraseRootFromParent_Done,
     /* 1975559 */   // Label 26479: @1975559
     /* 1975559 */   GIM_Try, /*On fail goto*//*Label 26480*/ GIMT_Encode4(1975645), // Rule ID 61281 //
     /* 1975564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1975575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1975578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1975581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1975584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975610 */     // MIs[0] policy
     /* 1975610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975620 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975644 */     // GIR_Coverage, 61281,
     /* 1975644 */     GIR_EraseRootFromParent_Done,
     /* 1975645 */   // Label 26480: @1975645
     /* 1975645 */   GIM_Try, /*On fail goto*//*Label 26481*/ GIMT_Encode4(1975731), // Rule ID 61284 //
     /* 1975650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1975661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1975664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1975667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1975670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1975673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975696 */     // MIs[0] policy
     /* 1975696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975730 */     // GIR_Coverage, 61284,
     /* 1975730 */     GIR_EraseRootFromParent_Done,
     /* 1975731 */   // Label 26481: @1975731
     /* 1975731 */   GIM_Try, /*On fail goto*//*Label 26482*/ GIMT_Encode4(1975817), // Rule ID 61285 //
     /* 1975736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1975747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1975750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1975753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1975756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1975759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975782 */     // MIs[0] policy
     /* 1975782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975792 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975816 */     // GIR_Coverage, 61285,
     /* 1975816 */     GIR_EraseRootFromParent_Done,
     /* 1975817 */   // Label 26482: @1975817
     /* 1975817 */   GIM_Try, /*On fail goto*//*Label 26483*/ GIMT_Encode4(1975903), // Rule ID 61288 //
     /* 1975822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1975833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1975836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1975839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1975842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975868 */     // MIs[0] policy
     /* 1975868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975902 */     // GIR_Coverage, 61288,
     /* 1975902 */     GIR_EraseRootFromParent_Done,
     /* 1975903 */   // Label 26483: @1975903
     /* 1975903 */   GIM_Try, /*On fail goto*//*Label 26484*/ GIMT_Encode4(1975989), // Rule ID 61289 //
     /* 1975908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1975919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1975922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1975925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1975928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975954 */     // MIs[0] policy
     /* 1975954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975964 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975988 */     // GIR_Coverage, 61289,
     /* 1975988 */     GIR_EraseRootFromParent_Done,
     /* 1975989 */   // Label 26484: @1975989
     /* 1975989 */   GIM_Try, /*On fail goto*//*Label 26485*/ GIMT_Encode4(1976075), // Rule ID 61292 //
     /* 1975994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1976005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1976008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1976011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1976014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976040 */     // MIs[0] policy
     /* 1976040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976050 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976074 */     // GIR_Coverage, 61292,
     /* 1976074 */     GIR_EraseRootFromParent_Done,
     /* 1976075 */   // Label 26485: @1976075
     /* 1976075 */   GIM_Try, /*On fail goto*//*Label 26486*/ GIMT_Encode4(1976161), // Rule ID 61293 //
     /* 1976080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1976091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1976094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1976097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1976100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976126 */     // MIs[0] policy
     /* 1976126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976136 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976160 */     // GIR_Coverage, 61293,
     /* 1976160 */     GIR_EraseRootFromParent_Done,
     /* 1976161 */   // Label 26486: @1976161
     /* 1976161 */   GIM_Try, /*On fail goto*//*Label 26487*/ GIMT_Encode4(1976247), // Rule ID 61296 //
     /* 1976166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1976177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1976180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1976183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1976186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976212 */     // MIs[0] policy
     /* 1976212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976222 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1976225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976246 */     // GIR_Coverage, 61296,
     /* 1976246 */     GIR_EraseRootFromParent_Done,
     /* 1976247 */   // Label 26487: @1976247
     /* 1976247 */   GIM_Try, /*On fail goto*//*Label 26488*/ GIMT_Encode4(1976333), // Rule ID 61297 //
     /* 1976252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1976263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1976266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1976269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1976272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976298 */     // MIs[0] policy
     /* 1976298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976308 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1976311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976332 */     // GIR_Coverage, 61297,
     /* 1976332 */     GIR_EraseRootFromParent_Done,
     /* 1976333 */   // Label 26488: @1976333
     /* 1976333 */   GIM_Try, /*On fail goto*//*Label 26489*/ GIMT_Encode4(1976419), // Rule ID 61300 //
     /* 1976338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1976349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1976352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1976355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1976358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976384 */     // MIs[0] policy
     /* 1976384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976394 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1976397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976418 */     // GIR_Coverage, 61300,
     /* 1976418 */     GIR_EraseRootFromParent_Done,
     /* 1976419 */   // Label 26489: @1976419
     /* 1976419 */   GIM_Try, /*On fail goto*//*Label 26490*/ GIMT_Encode4(1976505), // Rule ID 61301 //
     /* 1976424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1976435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1976438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1976441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1976444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976470 */     // MIs[0] policy
     /* 1976470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976480 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1976483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976504 */     // GIR_Coverage, 61301,
     /* 1976504 */     GIR_EraseRootFromParent_Done,
     /* 1976505 */   // Label 26490: @1976505
     /* 1976505 */   GIM_Try, /*On fail goto*//*Label 26491*/ GIMT_Encode4(1976591), // Rule ID 61304 //
     /* 1976510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1976521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1976524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1976527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1976530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976556 */     // MIs[0] policy
     /* 1976556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976566 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976590 */     // GIR_Coverage, 61304,
     /* 1976590 */     GIR_EraseRootFromParent_Done,
     /* 1976591 */   // Label 26491: @1976591
     /* 1976591 */   GIM_Try, /*On fail goto*//*Label 26492*/ GIMT_Encode4(1976677), // Rule ID 61305 //
     /* 1976596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1976607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1976610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1976613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1976616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976642 */     // MIs[0] policy
     /* 1976642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976652 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976676 */     // GIR_Coverage, 61305,
     /* 1976676 */     GIR_EraseRootFromParent_Done,
     /* 1976677 */   // Label 26492: @1976677
     /* 1976677 */   GIM_Try, /*On fail goto*//*Label 26493*/ GIMT_Encode4(1976763), // Rule ID 61308 //
     /* 1976682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1976693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1976696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1976699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1976705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976728 */     // MIs[0] policy
     /* 1976728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976738 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1976741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976762 */     // GIR_Coverage, 61308,
     /* 1976762 */     GIR_EraseRootFromParent_Done,
     /* 1976763 */   // Label 26493: @1976763
     /* 1976763 */   GIM_Try, /*On fail goto*//*Label 26494*/ GIMT_Encode4(1976849), // Rule ID 61309 //
     /* 1976768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1976779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1976782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1976785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1976791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976814 */     // MIs[0] policy
     /* 1976814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976824 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1976827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976848 */     // GIR_Coverage, 61309,
     /* 1976848 */     GIR_EraseRootFromParent_Done,
     /* 1976849 */   // Label 26494: @1976849
     /* 1976849 */   GIM_Try, /*On fail goto*//*Label 26495*/ GIMT_Encode4(1976935), // Rule ID 61312 //
     /* 1976854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1976865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1976868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1976871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976900 */     // MIs[0] policy
     /* 1976900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976910 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1976913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976934 */     // GIR_Coverage, 61312,
     /* 1976934 */     GIR_EraseRootFromParent_Done,
     /* 1976935 */   // Label 26495: @1976935
     /* 1976935 */   GIM_Try, /*On fail goto*//*Label 26496*/ GIMT_Encode4(1977021), // Rule ID 61313 //
     /* 1976940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1976951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1976954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1976957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976986 */     // MIs[0] policy
     /* 1976986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976996 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1976999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977020 */     // GIR_Coverage, 61313,
     /* 1977020 */     GIR_EraseRootFromParent_Done,
     /* 1977021 */   // Label 26496: @1977021
     /* 1977021 */   GIM_Try, /*On fail goto*//*Label 26497*/ GIMT_Encode4(1977107), // Rule ID 61316 //
     /* 1977026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1977037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1977040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1977043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977072 */     // MIs[0] policy
     /* 1977072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977082 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977106 */     // GIR_Coverage, 61316,
     /* 1977106 */     GIR_EraseRootFromParent_Done,
     /* 1977107 */   // Label 26497: @1977107
     /* 1977107 */   GIM_Try, /*On fail goto*//*Label 26498*/ GIMT_Encode4(1977193), // Rule ID 61317 //
     /* 1977112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1977123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1977126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1977129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977158 */     // MIs[0] policy
     /* 1977158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977168 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977192 */     // GIR_Coverage, 61317,
     /* 1977192 */     GIR_EraseRootFromParent_Done,
     /* 1977193 */   // Label 26498: @1977193
     /* 1977193 */   GIM_Try, /*On fail goto*//*Label 26499*/ GIMT_Encode4(1977279), // Rule ID 61320 //
     /* 1977198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1977209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1977212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1977215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977244 */     // MIs[0] policy
     /* 1977244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977254 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1977257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977278 */     // GIR_Coverage, 61320,
     /* 1977278 */     GIR_EraseRootFromParent_Done,
     /* 1977279 */   // Label 26499: @1977279
     /* 1977279 */   GIM_Try, /*On fail goto*//*Label 26500*/ GIMT_Encode4(1977365), // Rule ID 61321 //
     /* 1977284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1977295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1977298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1977301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977330 */     // MIs[0] policy
     /* 1977330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977340 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1977343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977364 */     // GIR_Coverage, 61321,
     /* 1977364 */     GIR_EraseRootFromParent_Done,
     /* 1977365 */   // Label 26500: @1977365
     /* 1977365 */   GIM_Try, /*On fail goto*//*Label 26501*/ GIMT_Encode4(1977451), // Rule ID 61324 //
     /* 1977370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1977381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1977384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1977387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977416 */     // MIs[0] policy
     /* 1977416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977426 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977450 */     // GIR_Coverage, 61324,
     /* 1977450 */     GIR_EraseRootFromParent_Done,
     /* 1977451 */   // Label 26501: @1977451
     /* 1977451 */   GIM_Try, /*On fail goto*//*Label 26502*/ GIMT_Encode4(1977537), // Rule ID 61325 //
     /* 1977456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1977467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1977470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1977473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977502 */     // MIs[0] policy
     /* 1977502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977512 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977536 */     // GIR_Coverage, 61325,
     /* 1977536 */     GIR_EraseRootFromParent_Done,
     /* 1977537 */   // Label 26502: @1977537
     /* 1977537 */   GIM_Try, /*On fail goto*//*Label 26503*/ GIMT_Encode4(1977623), // Rule ID 61328 //
     /* 1977542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1977553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1977556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1977559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977588 */     // MIs[0] policy
     /* 1977588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977598 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977622 */     // GIR_Coverage, 61328,
     /* 1977622 */     GIR_EraseRootFromParent_Done,
     /* 1977623 */   // Label 26503: @1977623
     /* 1977623 */   GIM_Try, /*On fail goto*//*Label 26504*/ GIMT_Encode4(1977709), // Rule ID 61329 //
     /* 1977628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1977639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1977642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1977645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977674 */     // MIs[0] policy
     /* 1977674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977708 */     // GIR_Coverage, 61329,
     /* 1977708 */     GIR_EraseRootFromParent_Done,
     /* 1977709 */   // Label 26504: @1977709
     /* 1977709 */   GIM_Try, /*On fail goto*//*Label 26505*/ GIMT_Encode4(1977795), // Rule ID 61332 //
     /* 1977714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1977725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1977728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1977731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977760 */     // MIs[0] policy
     /* 1977760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977770 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1977773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977794 */     // GIR_Coverage, 61332,
     /* 1977794 */     GIR_EraseRootFromParent_Done,
     /* 1977795 */   // Label 26505: @1977795
     /* 1977795 */   GIM_Try, /*On fail goto*//*Label 26506*/ GIMT_Encode4(1977881), // Rule ID 61333 //
     /* 1977800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1977811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1977814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1977817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977846 */     // MIs[0] policy
     /* 1977846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977856 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1977859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977880 */     // GIR_Coverage, 61333,
     /* 1977880 */     GIR_EraseRootFromParent_Done,
     /* 1977881 */   // Label 26506: @1977881
     /* 1977881 */   GIM_Try, /*On fail goto*//*Label 26507*/ GIMT_Encode4(1977967), // Rule ID 61336 //
     /* 1977886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1977897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1977900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1977903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977932 */     // MIs[0] policy
     /* 1977932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977942 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1977945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977966 */     // GIR_Coverage, 61336,
     /* 1977966 */     GIR_EraseRootFromParent_Done,
     /* 1977967 */   // Label 26507: @1977967
     /* 1977967 */   GIM_Try, /*On fail goto*//*Label 26508*/ GIMT_Encode4(1978053), // Rule ID 61337 //
     /* 1977972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1977983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1977986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1977989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978018 */     // MIs[0] policy
     /* 1978018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978028 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978052 */     // GIR_Coverage, 61337,
     /* 1978052 */     GIR_EraseRootFromParent_Done,
     /* 1978053 */   // Label 26508: @1978053
     /* 1978053 */   GIM_Try, /*On fail goto*//*Label 26509*/ GIMT_Encode4(1978139), // Rule ID 61340 //
     /* 1978058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1978069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1978072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1978075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978104 */     // MIs[0] policy
     /* 1978104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978138 */     // GIR_Coverage, 61340,
     /* 1978138 */     GIR_EraseRootFromParent_Done,
     /* 1978139 */   // Label 26509: @1978139
     /* 1978139 */   GIM_Try, /*On fail goto*//*Label 26510*/ GIMT_Encode4(1978225), // Rule ID 61341 //
     /* 1978144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1978155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1978158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1978161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978190 */     // MIs[0] policy
     /* 1978190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978200 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978224 */     // GIR_Coverage, 61341,
     /* 1978224 */     GIR_EraseRootFromParent_Done,
     /* 1978225 */   // Label 26510: @1978225
     /* 1978225 */   GIM_Try, /*On fail goto*//*Label 26511*/ GIMT_Encode4(1978311), // Rule ID 61344 //
     /* 1978230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1978241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1978244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1978247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978276 */     // MIs[0] policy
     /* 1978276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978286 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1978307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978310 */     // GIR_Coverage, 61344,
     /* 1978310 */     GIR_EraseRootFromParent_Done,
     /* 1978311 */   // Label 26511: @1978311
     /* 1978311 */   GIM_Try, /*On fail goto*//*Label 26512*/ GIMT_Encode4(1978397), // Rule ID 61345 //
     /* 1978316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1978327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1978330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1978333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978362 */     // MIs[0] policy
     /* 1978362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978372 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1978393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978396 */     // GIR_Coverage, 61345,
     /* 1978396 */     GIR_EraseRootFromParent_Done,
     /* 1978397 */   // Label 26512: @1978397
     /* 1978397 */   GIM_Try, /*On fail goto*//*Label 26513*/ GIMT_Encode4(1978483), // Rule ID 61348 //
     /* 1978402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1978413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1978416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1978419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1978425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1978432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978448 */     // MIs[0] policy
     /* 1978448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978458 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1978461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978482 */     // GIR_Coverage, 61348,
     /* 1978482 */     GIR_EraseRootFromParent_Done,
     /* 1978483 */   // Label 26513: @1978483
     /* 1978483 */   GIM_Try, /*On fail goto*//*Label 26514*/ GIMT_Encode4(1978569), // Rule ID 61349 //
     /* 1978488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1978499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1978502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1978505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1978511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1978518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978534 */     // MIs[0] policy
     /* 1978534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978544 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1978547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978568 */     // GIR_Coverage, 61349,
     /* 1978568 */     GIR_EraseRootFromParent_Done,
     /* 1978569 */   // Label 26514: @1978569
     /* 1978569 */   GIM_Try, /*On fail goto*//*Label 26515*/ GIMT_Encode4(1978655), // Rule ID 61352 //
     /* 1978574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1978585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1978588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1978591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1978597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1978604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978620 */     // MIs[0] policy
     /* 1978620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978630 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1978633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978654 */     // GIR_Coverage, 61352,
     /* 1978654 */     GIR_EraseRootFromParent_Done,
     /* 1978655 */   // Label 26515: @1978655
     /* 1978655 */   GIM_Try, /*On fail goto*//*Label 26516*/ GIMT_Encode4(1978741), // Rule ID 61353 //
     /* 1978660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1978671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1978674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1978677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1978683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1978690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978706 */     // MIs[0] policy
     /* 1978706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978716 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1978719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978740 */     // GIR_Coverage, 61353,
     /* 1978740 */     GIR_EraseRootFromParent_Done,
     /* 1978741 */   // Label 26516: @1978741
     /* 1978741 */   GIM_Try, /*On fail goto*//*Label 26517*/ GIMT_Encode4(1978827), // Rule ID 61356 //
     /* 1978746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1978757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1978760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1978763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1978769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1978776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978792 */     // MIs[0] policy
     /* 1978792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978802 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1978805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978826 */     // GIR_Coverage, 61356,
     /* 1978826 */     GIR_EraseRootFromParent_Done,
     /* 1978827 */   // Label 26517: @1978827
     /* 1978827 */   GIM_Try, /*On fail goto*//*Label 26518*/ GIMT_Encode4(1978913), // Rule ID 61357 //
     /* 1978832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1978843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1978846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1978849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1978855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1978862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978878 */     // MIs[0] policy
     /* 1978878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978888 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1978891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978912 */     // GIR_Coverage, 61357,
     /* 1978912 */     GIR_EraseRootFromParent_Done,
     /* 1978913 */   // Label 26518: @1978913
     /* 1978913 */   GIM_Try, /*On fail goto*//*Label 26519*/ GIMT_Encode4(1978999), // Rule ID 61360 //
     /* 1978918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1978929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1978932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1978935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1978941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1978948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978964 */     // MIs[0] policy
     /* 1978964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978974 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1978977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978998 */     // GIR_Coverage, 61360,
     /* 1978998 */     GIR_EraseRootFromParent_Done,
     /* 1978999 */   // Label 26519: @1978999
     /* 1978999 */   GIM_Try, /*On fail goto*//*Label 26520*/ GIMT_Encode4(1979085), // Rule ID 61361 //
     /* 1979004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1979015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1979018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1979021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979050 */     // MIs[0] policy
     /* 1979050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979084 */     // GIR_Coverage, 61361,
     /* 1979084 */     GIR_EraseRootFromParent_Done,
     /* 1979085 */   // Label 26520: @1979085
     /* 1979085 */   GIM_Try, /*On fail goto*//*Label 26521*/ GIMT_Encode4(1979171), // Rule ID 61364 //
     /* 1979090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1979101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1979104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1979107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979136 */     // MIs[0] policy
     /* 1979136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979146 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979170 */     // GIR_Coverage, 61364,
     /* 1979170 */     GIR_EraseRootFromParent_Done,
     /* 1979171 */   // Label 26521: @1979171
     /* 1979171 */   GIM_Try, /*On fail goto*//*Label 26522*/ GIMT_Encode4(1979257), // Rule ID 61365 //
     /* 1979176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1979187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1979190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1979193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979222 */     // MIs[0] policy
     /* 1979222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979232 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979256 */     // GIR_Coverage, 61365,
     /* 1979256 */     GIR_EraseRootFromParent_Done,
     /* 1979257 */   // Label 26522: @1979257
     /* 1979257 */   GIM_Try, /*On fail goto*//*Label 26523*/ GIMT_Encode4(1979343), // Rule ID 61368 //
     /* 1979262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1979273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1979276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1979279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979308 */     // MIs[0] policy
     /* 1979308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979318 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979342 */     // GIR_Coverage, 61368,
     /* 1979342 */     GIR_EraseRootFromParent_Done,
     /* 1979343 */   // Label 26523: @1979343
     /* 1979343 */   GIM_Try, /*On fail goto*//*Label 26524*/ GIMT_Encode4(1979429), // Rule ID 61369 //
     /* 1979348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1979359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1979362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1979365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979394 */     // MIs[0] policy
     /* 1979394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979404 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979428 */     // GIR_Coverage, 61369,
     /* 1979428 */     GIR_EraseRootFromParent_Done,
     /* 1979429 */   // Label 26524: @1979429
     /* 1979429 */   GIM_Try, /*On fail goto*//*Label 26525*/ GIMT_Encode4(1979515), // Rule ID 61372 //
     /* 1979434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1979445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1979448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1979451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1979457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979480 */     // MIs[0] policy
     /* 1979480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979490 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979514 */     // GIR_Coverage, 61372,
     /* 1979514 */     GIR_EraseRootFromParent_Done,
     /* 1979515 */   // Label 26525: @1979515
     /* 1979515 */   GIM_Try, /*On fail goto*//*Label 26526*/ GIMT_Encode4(1979601), // Rule ID 61373 //
     /* 1979520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1979531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1979534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1979537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1979543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979566 */     // MIs[0] policy
     /* 1979566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979600 */     // GIR_Coverage, 61373,
     /* 1979600 */     GIR_EraseRootFromParent_Done,
     /* 1979601 */   // Label 26526: @1979601
     /* 1979601 */   GIM_Try, /*On fail goto*//*Label 26527*/ GIMT_Encode4(1979687), // Rule ID 61376 //
     /* 1979606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1979617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1979620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1979623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979652 */     // MIs[0] policy
     /* 1979652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979662 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979686 */     // GIR_Coverage, 61376,
     /* 1979686 */     GIR_EraseRootFromParent_Done,
     /* 1979687 */   // Label 26527: @1979687
     /* 1979687 */   GIM_Try, /*On fail goto*//*Label 26528*/ GIMT_Encode4(1979773), // Rule ID 61377 //
     /* 1979692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1979703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1979706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1979709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979738 */     // MIs[0] policy
     /* 1979738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979772 */     // GIR_Coverage, 61377,
     /* 1979772 */     GIR_EraseRootFromParent_Done,
     /* 1979773 */   // Label 26528: @1979773
     /* 1979773 */   GIM_Try, /*On fail goto*//*Label 26529*/ GIMT_Encode4(1979859), // Rule ID 61380 //
     /* 1979778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1979789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1979792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1979795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979824 */     // MIs[0] policy
     /* 1979824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979834 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979858 */     // GIR_Coverage, 61380,
     /* 1979858 */     GIR_EraseRootFromParent_Done,
     /* 1979859 */   // Label 26529: @1979859
     /* 1979859 */   GIM_Try, /*On fail goto*//*Label 26530*/ GIMT_Encode4(1979945), // Rule ID 61381 //
     /* 1979864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1979875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1979878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1979881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979910 */     // MIs[0] policy
     /* 1979910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979920 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979944 */     // GIR_Coverage, 61381,
     /* 1979944 */     GIR_EraseRootFromParent_Done,
     /* 1979945 */   // Label 26530: @1979945
     /* 1979945 */   GIM_Try, /*On fail goto*//*Label 26531*/ GIMT_Encode4(1980031), // Rule ID 61384 //
     /* 1979950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1979961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1979964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1979967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1979973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979996 */     // MIs[0] policy
     /* 1979996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1980009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980030 */     // GIR_Coverage, 61384,
     /* 1980030 */     GIR_EraseRootFromParent_Done,
     /* 1980031 */   // Label 26531: @1980031
     /* 1980031 */   GIM_Try, /*On fail goto*//*Label 26532*/ GIMT_Encode4(1980117), // Rule ID 61385 //
     /* 1980036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1980047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1980050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1980053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980082 */     // MIs[0] policy
     /* 1980082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980092 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1980095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980116 */     // GIR_Coverage, 61385,
     /* 1980116 */     GIR_EraseRootFromParent_Done,
     /* 1980117 */   // Label 26532: @1980117
     /* 1980117 */   GIM_Try, /*On fail goto*//*Label 26533*/ GIMT_Encode4(1980203), // Rule ID 61388 //
     /* 1980122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1980133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1980136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1980139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980168 */     // MIs[0] policy
     /* 1980168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980178 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1980181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980202 */     // GIR_Coverage, 61388,
     /* 1980202 */     GIR_EraseRootFromParent_Done,
     /* 1980203 */   // Label 26533: @1980203
     /* 1980203 */   GIM_Try, /*On fail goto*//*Label 26534*/ GIMT_Encode4(1980289), // Rule ID 61389 //
     /* 1980208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1980219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1980222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1980225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980254 */     // MIs[0] policy
     /* 1980254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1980267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980288 */     // GIR_Coverage, 61389,
     /* 1980288 */     GIR_EraseRootFromParent_Done,
     /* 1980289 */   // Label 26534: @1980289
     /* 1980289 */   GIM_Try, /*On fail goto*//*Label 26535*/ GIMT_Encode4(1980375), // Rule ID 61392 //
     /* 1980294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1980305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1980308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1980311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980340 */     // MIs[0] policy
     /* 1980340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980350 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1980353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980374 */     // GIR_Coverage, 61392,
     /* 1980374 */     GIR_EraseRootFromParent_Done,
     /* 1980375 */   // Label 26535: @1980375
     /* 1980375 */   GIM_Try, /*On fail goto*//*Label 26536*/ GIMT_Encode4(1980461), // Rule ID 61393 //
     /* 1980380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1980391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1980394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1980397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980426 */     // MIs[0] policy
     /* 1980426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980436 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1980439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980460 */     // GIR_Coverage, 61393,
     /* 1980460 */     GIR_EraseRootFromParent_Done,
     /* 1980461 */   // Label 26536: @1980461
     /* 1980461 */   GIM_Try, /*On fail goto*//*Label 26537*/ GIMT_Encode4(1980547), // Rule ID 61572 //
     /* 1980466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1980477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1980480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1980483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1980486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1980489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980512 */     // MIs[0] policy
     /* 1980512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980522 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1980525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980546 */     // GIR_Coverage, 61572,
     /* 1980546 */     GIR_EraseRootFromParent_Done,
     /* 1980547 */   // Label 26537: @1980547
     /* 1980547 */   GIM_Try, /*On fail goto*//*Label 26538*/ GIMT_Encode4(1980633), // Rule ID 61573 //
     /* 1980552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1980563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1980566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1980569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1980572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1980575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980598 */     // MIs[0] policy
     /* 1980598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980608 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1980611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980632 */     // GIR_Coverage, 61573,
     /* 1980632 */     GIR_EraseRootFromParent_Done,
     /* 1980633 */   // Label 26538: @1980633
     /* 1980633 */   GIM_Try, /*On fail goto*//*Label 26539*/ GIMT_Encode4(1980719), // Rule ID 61576 //
     /* 1980638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1980649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1980652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1980655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1980658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980684 */     // MIs[0] policy
     /* 1980684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980694 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1980697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980718 */     // GIR_Coverage, 61576,
     /* 1980718 */     GIR_EraseRootFromParent_Done,
     /* 1980719 */   // Label 26539: @1980719
     /* 1980719 */   GIM_Try, /*On fail goto*//*Label 26540*/ GIMT_Encode4(1980805), // Rule ID 61577 //
     /* 1980724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1980735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1980738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1980741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1980744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980770 */     // MIs[0] policy
     /* 1980770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980780 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1980783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980804 */     // GIR_Coverage, 61577,
     /* 1980804 */     GIR_EraseRootFromParent_Done,
     /* 1980805 */   // Label 26540: @1980805
     /* 1980805 */   GIM_Try, /*On fail goto*//*Label 26541*/ GIMT_Encode4(1980891), // Rule ID 61580 //
     /* 1980810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1980821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1980824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1980827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1980830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980856 */     // MIs[0] policy
     /* 1980856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980866 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1980869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980890 */     // GIR_Coverage, 61580,
     /* 1980890 */     GIR_EraseRootFromParent_Done,
     /* 1980891 */   // Label 26541: @1980891
     /* 1980891 */   GIM_Try, /*On fail goto*//*Label 26542*/ GIMT_Encode4(1980977), // Rule ID 61581 //
     /* 1980896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1980907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1980910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1980913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1980916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980942 */     // MIs[0] policy
     /* 1980942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980952 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1980955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980976 */     // GIR_Coverage, 61581,
     /* 1980976 */     GIR_EraseRootFromParent_Done,
     /* 1980977 */   // Label 26542: @1980977
     /* 1980977 */   GIM_Try, /*On fail goto*//*Label 26543*/ GIMT_Encode4(1981063), // Rule ID 61584 //
     /* 1980982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1980993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1980996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1980999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1981002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981028 */     // MIs[0] policy
     /* 1981028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981038 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1981041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981062 */     // GIR_Coverage, 61584,
     /* 1981062 */     GIR_EraseRootFromParent_Done,
     /* 1981063 */   // Label 26543: @1981063
     /* 1981063 */   GIM_Try, /*On fail goto*//*Label 26544*/ GIMT_Encode4(1981149), // Rule ID 61585 //
     /* 1981068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1981079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1981082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1981085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1981088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981114 */     // MIs[0] policy
     /* 1981114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981124 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1981127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981148 */     // GIR_Coverage, 61585,
     /* 1981148 */     GIR_EraseRootFromParent_Done,
     /* 1981149 */   // Label 26544: @1981149
     /* 1981149 */   GIM_Try, /*On fail goto*//*Label 26545*/ GIMT_Encode4(1981235), // Rule ID 61588 //
     /* 1981154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1981165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1981168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1981171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1981174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981200 */     // MIs[0] policy
     /* 1981200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981210 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981234 */     // GIR_Coverage, 61588,
     /* 1981234 */     GIR_EraseRootFromParent_Done,
     /* 1981235 */   // Label 26545: @1981235
     /* 1981235 */   GIM_Try, /*On fail goto*//*Label 26546*/ GIMT_Encode4(1981321), // Rule ID 61589 //
     /* 1981240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1981251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1981254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1981257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1981260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981286 */     // MIs[0] policy
     /* 1981286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981296 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981320 */     // GIR_Coverage, 61589,
     /* 1981320 */     GIR_EraseRootFromParent_Done,
     /* 1981321 */   // Label 26546: @1981321
     /* 1981321 */   GIM_Try, /*On fail goto*//*Label 26547*/ GIMT_Encode4(1981407), // Rule ID 61592 //
     /* 1981326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1981337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1981340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1981343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1981346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981372 */     // MIs[0] policy
     /* 1981372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981382 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981406 */     // GIR_Coverage, 61592,
     /* 1981406 */     GIR_EraseRootFromParent_Done,
     /* 1981407 */   // Label 26547: @1981407
     /* 1981407 */   GIM_Try, /*On fail goto*//*Label 26548*/ GIMT_Encode4(1981493), // Rule ID 61593 //
     /* 1981412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1981423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1981426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1981429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1981432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981458 */     // MIs[0] policy
     /* 1981458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981468 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981492 */     // GIR_Coverage, 61593,
     /* 1981492 */     GIR_EraseRootFromParent_Done,
     /* 1981493 */   // Label 26548: @1981493
     /* 1981493 */   GIM_Try, /*On fail goto*//*Label 26549*/ GIMT_Encode4(1981579), // Rule ID 61596 //
     /* 1981498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1981509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1981512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1981515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1981518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981544 */     // MIs[0] policy
     /* 1981544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981554 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1981557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981578 */     // GIR_Coverage, 61596,
     /* 1981578 */     GIR_EraseRootFromParent_Done,
     /* 1981579 */   // Label 26549: @1981579
     /* 1981579 */   GIM_Try, /*On fail goto*//*Label 26550*/ GIMT_Encode4(1981665), // Rule ID 61597 //
     /* 1981584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1981595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1981598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1981601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1981604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981630 */     // MIs[0] policy
     /* 1981630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981640 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1981643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981664 */     // GIR_Coverage, 61597,
     /* 1981664 */     GIR_EraseRootFromParent_Done,
     /* 1981665 */   // Label 26550: @1981665
     /* 1981665 */   GIM_Try, /*On fail goto*//*Label 26551*/ GIMT_Encode4(1981751), // Rule ID 61600 //
     /* 1981670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1981681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1981684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1981687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1981690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981716 */     // MIs[0] policy
     /* 1981716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981726 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1981729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981750 */     // GIR_Coverage, 61600,
     /* 1981750 */     GIR_EraseRootFromParent_Done,
     /* 1981751 */   // Label 26551: @1981751
     /* 1981751 */   GIM_Try, /*On fail goto*//*Label 26552*/ GIMT_Encode4(1981837), // Rule ID 61601 //
     /* 1981756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1981767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1981770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1981773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1981776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981802 */     // MIs[0] policy
     /* 1981802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981812 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1981815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981836 */     // GIR_Coverage, 61601,
     /* 1981836 */     GIR_EraseRootFromParent_Done,
     /* 1981837 */   // Label 26552: @1981837
     /* 1981837 */   GIM_Try, /*On fail goto*//*Label 26553*/ GIMT_Encode4(1981923), // Rule ID 61604 //
     /* 1981842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1981853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1981856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1981859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1981862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981888 */     // MIs[0] policy
     /* 1981888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981898 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1981901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981922 */     // GIR_Coverage, 61604,
     /* 1981922 */     GIR_EraseRootFromParent_Done,
     /* 1981923 */   // Label 26553: @1981923
     /* 1981923 */   GIM_Try, /*On fail goto*//*Label 26554*/ GIMT_Encode4(1982009), // Rule ID 61605 //
     /* 1981928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1981939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1981942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1981945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1981948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981974 */     // MIs[0] policy
     /* 1981974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1981987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1982005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982008 */     // GIR_Coverage, 61605,
     /* 1982008 */     GIR_EraseRootFromParent_Done,
     /* 1982009 */   // Label 26554: @1982009
     /* 1982009 */   GIM_Try, /*On fail goto*//*Label 26555*/ GIMT_Encode4(1982095), // Rule ID 61608 //
     /* 1982014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1982025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1982028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1982031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1982034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982060 */     // MIs[0] policy
     /* 1982060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982070 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1982091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982094 */     // GIR_Coverage, 61608,
     /* 1982094 */     GIR_EraseRootFromParent_Done,
     /* 1982095 */   // Label 26555: @1982095
     /* 1982095 */   GIM_Try, /*On fail goto*//*Label 26556*/ GIMT_Encode4(1982181), // Rule ID 61609 //
     /* 1982100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1982111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1982114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1982117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1982120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982146 */     // MIs[0] policy
     /* 1982146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982156 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1982177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982180 */     // GIR_Coverage, 61609,
     /* 1982180 */     GIR_EraseRootFromParent_Done,
     /* 1982181 */   // Label 26556: @1982181
     /* 1982181 */   GIM_Try, /*On fail goto*//*Label 26557*/ GIMT_Encode4(1982267), // Rule ID 61612 //
     /* 1982186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1982197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1982200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1982203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1982206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982232 */     // MIs[0] policy
     /* 1982232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982242 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1982245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982266 */     // GIR_Coverage, 61612,
     /* 1982266 */     GIR_EraseRootFromParent_Done,
     /* 1982267 */   // Label 26557: @1982267
     /* 1982267 */   GIM_Try, /*On fail goto*//*Label 26558*/ GIMT_Encode4(1982353), // Rule ID 61613 //
     /* 1982272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1982283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1982286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1982289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1982292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982318 */     // MIs[0] policy
     /* 1982318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982328 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1982331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982352 */     // GIR_Coverage, 61613,
     /* 1982352 */     GIR_EraseRootFromParent_Done,
     /* 1982353 */   // Label 26558: @1982353
     /* 1982353 */   GIM_Try, /*On fail goto*//*Label 26559*/ GIMT_Encode4(1982439), // Rule ID 61616 //
     /* 1982358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1982369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1982372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1982375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1982378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1982381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982404 */     // MIs[0] policy
     /* 1982404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982414 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1982417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982438 */     // GIR_Coverage, 61616,
     /* 1982438 */     GIR_EraseRootFromParent_Done,
     /* 1982439 */   // Label 26559: @1982439
     /* 1982439 */   GIM_Try, /*On fail goto*//*Label 26560*/ GIMT_Encode4(1982525), // Rule ID 61617 //
     /* 1982444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1982455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1982458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1982461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1982464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1982467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982490 */     // MIs[0] policy
     /* 1982490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982500 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1982503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982524 */     // GIR_Coverage, 61617,
     /* 1982524 */     GIR_EraseRootFromParent_Done,
     /* 1982525 */   // Label 26560: @1982525
     /* 1982525 */   GIM_Try, /*On fail goto*//*Label 26561*/ GIMT_Encode4(1982611), // Rule ID 61620 //
     /* 1982530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1982541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1982544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1982547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1982550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1982553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1982560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982576 */     // MIs[0] policy
     /* 1982576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982586 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1982589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982610 */     // GIR_Coverage, 61620,
     /* 1982610 */     GIR_EraseRootFromParent_Done,
     /* 1982611 */   // Label 26561: @1982611
     /* 1982611 */   GIM_Try, /*On fail goto*//*Label 26562*/ GIMT_Encode4(1982697), // Rule ID 61621 //
     /* 1982616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1982627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1982630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1982633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1982636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1982639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1982646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982662 */     // MIs[0] policy
     /* 1982662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982672 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1982675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982696 */     // GIR_Coverage, 61621,
     /* 1982696 */     GIR_EraseRootFromParent_Done,
     /* 1982697 */   // Label 26562: @1982697
     /* 1982697 */   GIM_Try, /*On fail goto*//*Label 26563*/ GIMT_Encode4(1982783), // Rule ID 61624 //
     /* 1982702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1982713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1982716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1982719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1982722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1982725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982748 */     // MIs[0] policy
     /* 1982748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982758 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1982761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982782 */     // GIR_Coverage, 61624,
     /* 1982782 */     GIR_EraseRootFromParent_Done,
     /* 1982783 */   // Label 26563: @1982783
     /* 1982783 */   GIM_Try, /*On fail goto*//*Label 26564*/ GIMT_Encode4(1982869), // Rule ID 61625 //
     /* 1982788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1982799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1982802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1982805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1982808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1982811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982834 */     // MIs[0] policy
     /* 1982834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982844 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1982847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982868 */     // GIR_Coverage, 61625,
     /* 1982868 */     GIR_EraseRootFromParent_Done,
     /* 1982869 */   // Label 26564: @1982869
     /* 1982869 */   GIM_Try, /*On fail goto*//*Label 26565*/ GIMT_Encode4(1982955), // Rule ID 61628 //
     /* 1982874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1982885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1982888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1982891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1982894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982920 */     // MIs[0] policy
     /* 1982920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982930 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1982933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982954 */     // GIR_Coverage, 61628,
     /* 1982954 */     GIR_EraseRootFromParent_Done,
     /* 1982955 */   // Label 26565: @1982955
     /* 1982955 */   GIM_Try, /*On fail goto*//*Label 26566*/ GIMT_Encode4(1983041), // Rule ID 61629 //
     /* 1982960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1982971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1982974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1982977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1982980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983006 */     // MIs[0] policy
     /* 1983006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983016 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983040 */     // GIR_Coverage, 61629,
     /* 1983040 */     GIR_EraseRootFromParent_Done,
     /* 1983041 */   // Label 26566: @1983041
     /* 1983041 */   GIM_Try, /*On fail goto*//*Label 26567*/ GIMT_Encode4(1983127), // Rule ID 61632 //
     /* 1983046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1983057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1983060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1983063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1983066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983092 */     // MIs[0] policy
     /* 1983092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983102 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983126 */     // GIR_Coverage, 61632,
     /* 1983126 */     GIR_EraseRootFromParent_Done,
     /* 1983127 */   // Label 26567: @1983127
     /* 1983127 */   GIM_Try, /*On fail goto*//*Label 26568*/ GIMT_Encode4(1983213), // Rule ID 61633 //
     /* 1983132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1983143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1983146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1983149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1983152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983178 */     // MIs[0] policy
     /* 1983178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983188 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983212 */     // GIR_Coverage, 61633,
     /* 1983212 */     GIR_EraseRootFromParent_Done,
     /* 1983213 */   // Label 26568: @1983213
     /* 1983213 */   GIM_Try, /*On fail goto*//*Label 26569*/ GIMT_Encode4(1983299), // Rule ID 61636 //
     /* 1983218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1983229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1983232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1983235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1983238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983264 */     // MIs[0] policy
     /* 1983264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983298 */     // GIR_Coverage, 61636,
     /* 1983298 */     GIR_EraseRootFromParent_Done,
     /* 1983299 */   // Label 26569: @1983299
     /* 1983299 */   GIM_Try, /*On fail goto*//*Label 26570*/ GIMT_Encode4(1983385), // Rule ID 61637 //
     /* 1983304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1983315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1983318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1983321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1983324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983350 */     // MIs[0] policy
     /* 1983350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983360 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983384 */     // GIR_Coverage, 61637,
     /* 1983384 */     GIR_EraseRootFromParent_Done,
     /* 1983385 */   // Label 26570: @1983385
     /* 1983385 */   GIM_Try, /*On fail goto*//*Label 26571*/ GIMT_Encode4(1983471), // Rule ID 61640 //
     /* 1983390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1983401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1983404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1983407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1983410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983436 */     // MIs[0] policy
     /* 1983436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983470 */     // GIR_Coverage, 61640,
     /* 1983470 */     GIR_EraseRootFromParent_Done,
     /* 1983471 */   // Label 26571: @1983471
     /* 1983471 */   GIM_Try, /*On fail goto*//*Label 26572*/ GIMT_Encode4(1983557), // Rule ID 61641 //
     /* 1983476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1983487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1983490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1983493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1983496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983522 */     // MIs[0] policy
     /* 1983522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983532 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983556 */     // GIR_Coverage, 61641,
     /* 1983556 */     GIR_EraseRootFromParent_Done,
     /* 1983557 */   // Label 26572: @1983557
     /* 1983557 */   GIM_Try, /*On fail goto*//*Label 26573*/ GIMT_Encode4(1983643), // Rule ID 61644 //
     /* 1983562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1983573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1983576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1983579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1983582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983608 */     // MIs[0] policy
     /* 1983608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983642 */     // GIR_Coverage, 61644,
     /* 1983642 */     GIR_EraseRootFromParent_Done,
     /* 1983643 */   // Label 26573: @1983643
     /* 1983643 */   GIM_Try, /*On fail goto*//*Label 26574*/ GIMT_Encode4(1983729), // Rule ID 61645 //
     /* 1983648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1983659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1983662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1983665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1983668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983694 */     // MIs[0] policy
     /* 1983694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983704 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983728 */     // GIR_Coverage, 61645,
     /* 1983728 */     GIR_EraseRootFromParent_Done,
     /* 1983729 */   // Label 26574: @1983729
     /* 1983729 */   GIM_Try, /*On fail goto*//*Label 26575*/ GIMT_Encode4(1983815), // Rule ID 61648 //
     /* 1983734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1983745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1983748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1983751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1983754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1983757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983780 */     // MIs[0] policy
     /* 1983780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983814 */     // GIR_Coverage, 61648,
     /* 1983814 */     GIR_EraseRootFromParent_Done,
     /* 1983815 */   // Label 26575: @1983815
     /* 1983815 */   GIM_Try, /*On fail goto*//*Label 26576*/ GIMT_Encode4(1983901), // Rule ID 61649 //
     /* 1983820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1983831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1983834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1983837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1983840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1983843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983866 */     // MIs[0] policy
     /* 1983866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983900 */     // GIR_Coverage, 61649,
     /* 1983900 */     GIR_EraseRootFromParent_Done,
     /* 1983901 */   // Label 26576: @1983901
     /* 1983901 */   GIM_Try, /*On fail goto*//*Label 26577*/ GIMT_Encode4(1983987), // Rule ID 61652 //
     /* 1983906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1983917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1983920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1983923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1983926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983952 */     // MIs[0] policy
     /* 1983952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983962 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983986 */     // GIR_Coverage, 61652,
     /* 1983986 */     GIR_EraseRootFromParent_Done,
     /* 1983987 */   // Label 26577: @1983987
     /* 1983987 */   GIM_Try, /*On fail goto*//*Label 26578*/ GIMT_Encode4(1984073), // Rule ID 61653 //
     /* 1983992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1984003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1984006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1984009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1984012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984038 */     // MIs[0] policy
     /* 1984038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984048 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1984051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984072 */     // GIR_Coverage, 61653,
     /* 1984072 */     GIR_EraseRootFromParent_Done,
     /* 1984073 */   // Label 26578: @1984073
     /* 1984073 */   GIM_Try, /*On fail goto*//*Label 26579*/ GIMT_Encode4(1984159), // Rule ID 61656 //
     /* 1984078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1984089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1984092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1984095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1984098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984124 */     // MIs[0] policy
     /* 1984124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984134 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1984137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984158 */     // GIR_Coverage, 61656,
     /* 1984158 */     GIR_EraseRootFromParent_Done,
     /* 1984159 */   // Label 26579: @1984159
     /* 1984159 */   GIM_Try, /*On fail goto*//*Label 26580*/ GIMT_Encode4(1984245), // Rule ID 61657 //
     /* 1984164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1984175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1984178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1984181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1984184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984210 */     // MIs[0] policy
     /* 1984210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1984223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984244 */     // GIR_Coverage, 61657,
     /* 1984244 */     GIR_EraseRootFromParent_Done,
     /* 1984245 */   // Label 26580: @1984245
     /* 1984245 */   GIM_Try, /*On fail goto*//*Label 26581*/ GIMT_Encode4(1984331), // Rule ID 61660 //
     /* 1984250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1984261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1984264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1984267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984296 */     // MIs[0] policy
     /* 1984296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984306 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1984309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984330 */     // GIR_Coverage, 61660,
     /* 1984330 */     GIR_EraseRootFromParent_Done,
     /* 1984331 */   // Label 26581: @1984331
     /* 1984331 */   GIM_Try, /*On fail goto*//*Label 26582*/ GIMT_Encode4(1984417), // Rule ID 61661 //
     /* 1984336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1984347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1984350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1984353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984382 */     // MIs[0] policy
     /* 1984382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984392 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1984395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984416 */     // GIR_Coverage, 61661,
     /* 1984416 */     GIR_EraseRootFromParent_Done,
     /* 1984417 */   // Label 26582: @1984417
     /* 1984417 */   GIM_Try, /*On fail goto*//*Label 26583*/ GIMT_Encode4(1984503), // Rule ID 61664 //
     /* 1984422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1984433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1984436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1984439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984468 */     // MIs[0] policy
     /* 1984468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984478 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1984481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984502 */     // GIR_Coverage, 61664,
     /* 1984502 */     GIR_EraseRootFromParent_Done,
     /* 1984503 */   // Label 26583: @1984503
     /* 1984503 */   GIM_Try, /*On fail goto*//*Label 26584*/ GIMT_Encode4(1984589), // Rule ID 61665 //
     /* 1984508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1984519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1984522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1984525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984554 */     // MIs[0] policy
     /* 1984554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984564 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1984567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984588 */     // GIR_Coverage, 61665,
     /* 1984588 */     GIR_EraseRootFromParent_Done,
     /* 1984589 */   // Label 26584: @1984589
     /* 1984589 */   GIM_Try, /*On fail goto*//*Label 26585*/ GIMT_Encode4(1984675), // Rule ID 61668 //
     /* 1984594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1984605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1984608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1984611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984640 */     // MIs[0] policy
     /* 1984640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984650 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1984653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984674 */     // GIR_Coverage, 61668,
     /* 1984674 */     GIR_EraseRootFromParent_Done,
     /* 1984675 */   // Label 26585: @1984675
     /* 1984675 */   GIM_Try, /*On fail goto*//*Label 26586*/ GIMT_Encode4(1984761), // Rule ID 61669 //
     /* 1984680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1984691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1984694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1984697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984726 */     // MIs[0] policy
     /* 1984726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984736 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1984739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984760 */     // GIR_Coverage, 61669,
     /* 1984760 */     GIR_EraseRootFromParent_Done,
     /* 1984761 */   // Label 26586: @1984761
     /* 1984761 */   GIM_Try, /*On fail goto*//*Label 26587*/ GIMT_Encode4(1984847), // Rule ID 61672 //
     /* 1984766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1984777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1984780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1984783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984812 */     // MIs[0] policy
     /* 1984812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984822 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1984825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984846 */     // GIR_Coverage, 61672,
     /* 1984846 */     GIR_EraseRootFromParent_Done,
     /* 1984847 */   // Label 26587: @1984847
     /* 1984847 */   GIM_Try, /*On fail goto*//*Label 26588*/ GIMT_Encode4(1984933), // Rule ID 61673 //
     /* 1984852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1984863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1984866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1984869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984898 */     // MIs[0] policy
     /* 1984898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984908 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1984911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984932 */     // GIR_Coverage, 61673,
     /* 1984932 */     GIR_EraseRootFromParent_Done,
     /* 1984933 */   // Label 26588: @1984933
     /* 1984933 */   GIM_Try, /*On fail goto*//*Label 26589*/ GIMT_Encode4(1985019), // Rule ID 61676 //
     /* 1984938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1984949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1984952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1984955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984984 */     // MIs[0] policy
     /* 1984984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984994 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1984997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985018 */     // GIR_Coverage, 61676,
     /* 1985018 */     GIR_EraseRootFromParent_Done,
     /* 1985019 */   // Label 26589: @1985019
     /* 1985019 */   GIM_Try, /*On fail goto*//*Label 26590*/ GIMT_Encode4(1985105), // Rule ID 61677 //
     /* 1985024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1985035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1985038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1985041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985070 */     // MIs[0] policy
     /* 1985070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985080 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985104 */     // GIR_Coverage, 61677,
     /* 1985104 */     GIR_EraseRootFromParent_Done,
     /* 1985105 */   // Label 26590: @1985105
     /* 1985105 */   GIM_Try, /*On fail goto*//*Label 26591*/ GIMT_Encode4(1985191), // Rule ID 61680 //
     /* 1985110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1985121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1985124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1985127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985156 */     // MIs[0] policy
     /* 1985156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985166 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985190 */     // GIR_Coverage, 61680,
     /* 1985190 */     GIR_EraseRootFromParent_Done,
     /* 1985191 */   // Label 26591: @1985191
     /* 1985191 */   GIM_Try, /*On fail goto*//*Label 26592*/ GIMT_Encode4(1985277), // Rule ID 61681 //
     /* 1985196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1985207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1985210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1985213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985242 */     // MIs[0] policy
     /* 1985242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985252 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985276 */     // GIR_Coverage, 61681,
     /* 1985276 */     GIR_EraseRootFromParent_Done,
     /* 1985277 */   // Label 26592: @1985277
     /* 1985277 */   GIM_Try, /*On fail goto*//*Label 26593*/ GIMT_Encode4(1985363), // Rule ID 61684 //
     /* 1985282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1985293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1985296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1985299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985328 */     // MIs[0] policy
     /* 1985328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985338 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985362 */     // GIR_Coverage, 61684,
     /* 1985362 */     GIR_EraseRootFromParent_Done,
     /* 1985363 */   // Label 26593: @1985363
     /* 1985363 */   GIM_Try, /*On fail goto*//*Label 26594*/ GIMT_Encode4(1985449), // Rule ID 61685 //
     /* 1985368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1985379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1985382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1985385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985414 */     // MIs[0] policy
     /* 1985414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985448 */     // GIR_Coverage, 61685,
     /* 1985448 */     GIR_EraseRootFromParent_Done,
     /* 1985449 */   // Label 26594: @1985449
     /* 1985449 */   GIM_Try, /*On fail goto*//*Label 26595*/ GIMT_Encode4(1985535), // Rule ID 61688 //
     /* 1985454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1985465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1985468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1985471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985500 */     // MIs[0] policy
     /* 1985500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985510 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985534 */     // GIR_Coverage, 61688,
     /* 1985534 */     GIR_EraseRootFromParent_Done,
     /* 1985535 */   // Label 26595: @1985535
     /* 1985535 */   GIM_Try, /*On fail goto*//*Label 26596*/ GIMT_Encode4(1985621), // Rule ID 61689 //
     /* 1985540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1985551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1985554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1985557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985586 */     // MIs[0] policy
     /* 1985586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985596 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985620 */     // GIR_Coverage, 61689,
     /* 1985620 */     GIR_EraseRootFromParent_Done,
     /* 1985621 */   // Label 26596: @1985621
     /* 1985621 */   GIM_Try, /*On fail goto*//*Label 26597*/ GIMT_Encode4(1985707), // Rule ID 61692 //
     /* 1985626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1985637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1985640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1985643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985672 */     // MIs[0] policy
     /* 1985672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985706 */     // GIR_Coverage, 61692,
     /* 1985706 */     GIR_EraseRootFromParent_Done,
     /* 1985707 */   // Label 26597: @1985707
     /* 1985707 */   GIM_Try, /*On fail goto*//*Label 26598*/ GIMT_Encode4(1985793), // Rule ID 61693 //
     /* 1985712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1985723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1985726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1985729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985758 */     // MIs[0] policy
     /* 1985758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985768 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985792 */     // GIR_Coverage, 61693,
     /* 1985792 */     GIR_EraseRootFromParent_Done,
     /* 1985793 */   // Label 26598: @1985793
     /* 1985793 */   GIM_Try, /*On fail goto*//*Label 26599*/ GIMT_Encode4(1985879), // Rule ID 61696 //
     /* 1985798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1985809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1985812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1985815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985844 */     // MIs[0] policy
     /* 1985844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985854 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985878 */     // GIR_Coverage, 61696,
     /* 1985878 */     GIR_EraseRootFromParent_Done,
     /* 1985879 */   // Label 26599: @1985879
     /* 1985879 */   GIM_Try, /*On fail goto*//*Label 26600*/ GIMT_Encode4(1985965), // Rule ID 61697 //
     /* 1985884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1985895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1985898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1985901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985930 */     // MIs[0] policy
     /* 1985930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985940 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985964 */     // GIR_Coverage, 61697,
     /* 1985964 */     GIR_EraseRootFromParent_Done,
     /* 1985965 */   // Label 26600: @1985965
     /* 1985965 */   GIM_Try, /*On fail goto*//*Label 26601*/ GIMT_Encode4(1986051), // Rule ID 61700 //
     /* 1985970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1985981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1985984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1985987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1985993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986016 */     // MIs[0] policy
     /* 1986016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1986029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986050 */     // GIR_Coverage, 61700,
     /* 1986050 */     GIR_EraseRootFromParent_Done,
     /* 1986051 */   // Label 26601: @1986051
     /* 1986051 */   GIM_Try, /*On fail goto*//*Label 26602*/ GIMT_Encode4(1986137), // Rule ID 61701 //
     /* 1986056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1986067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1986070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1986073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986102 */     // MIs[0] policy
     /* 1986102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986112 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1986115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986136 */     // GIR_Coverage, 61701,
     /* 1986136 */     GIR_EraseRootFromParent_Done,
     /* 1986137 */   // Label 26602: @1986137
     /* 1986137 */   GIM_Try, /*On fail goto*//*Label 26603*/ GIMT_Encode4(1986223), // Rule ID 61704 //
     /* 1986142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1986153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1986156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1986159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986188 */     // MIs[0] policy
     /* 1986188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986198 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1986201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986222 */     // GIR_Coverage, 61704,
     /* 1986222 */     GIR_EraseRootFromParent_Done,
     /* 1986223 */   // Label 26603: @1986223
     /* 1986223 */   GIM_Try, /*On fail goto*//*Label 26604*/ GIMT_Encode4(1986309), // Rule ID 61705 //
     /* 1986228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1986239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1986242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1986245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986274 */     // MIs[0] policy
     /* 1986274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986284 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1986287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986308 */     // GIR_Coverage, 61705,
     /* 1986308 */     GIR_EraseRootFromParent_Done,
     /* 1986309 */   // Label 26604: @1986309
     /* 1986309 */   GIM_Try, /*On fail goto*//*Label 26605*/ GIMT_Encode4(1986395), // Rule ID 61708 //
     /* 1986314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1986325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1986328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1986331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1986337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986360 */     // MIs[0] policy
     /* 1986360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986370 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1986373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986394 */     // GIR_Coverage, 61708,
     /* 1986394 */     GIR_EraseRootFromParent_Done,
     /* 1986395 */   // Label 26605: @1986395
     /* 1986395 */   GIM_Try, /*On fail goto*//*Label 26606*/ GIMT_Encode4(1986481), // Rule ID 61709 //
     /* 1986400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1986411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1986414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1986417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1986423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986446 */     // MIs[0] policy
     /* 1986446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986456 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1986459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986480 */     // GIR_Coverage, 61709,
     /* 1986480 */     GIR_EraseRootFromParent_Done,
     /* 1986481 */   // Label 26606: @1986481
     /* 1986481 */   GIM_Try, /*On fail goto*//*Label 26607*/ GIMT_Encode4(1986567), // Rule ID 61712 //
     /* 1986486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1986497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1986500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1986503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986532 */     // MIs[0] policy
     /* 1986532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986542 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1986545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986566 */     // GIR_Coverage, 61712,
     /* 1986566 */     GIR_EraseRootFromParent_Done,
     /* 1986567 */   // Label 26607: @1986567
     /* 1986567 */   GIM_Try, /*On fail goto*//*Label 26608*/ GIMT_Encode4(1986653), // Rule ID 61713 //
     /* 1986572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1986583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1986586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1986589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986618 */     // MIs[0] policy
     /* 1986618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986628 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1986631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986652 */     // GIR_Coverage, 61713,
     /* 1986652 */     GIR_EraseRootFromParent_Done,
     /* 1986653 */   // Label 26608: @1986653
     /* 1986653 */   GIM_Try, /*On fail goto*//*Label 26609*/ GIMT_Encode4(1986739), // Rule ID 61716 //
     /* 1986658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1986669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1986672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1986675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986704 */     // MIs[0] policy
     /* 1986704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986714 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1986717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986738 */     // GIR_Coverage, 61716,
     /* 1986738 */     GIR_EraseRootFromParent_Done,
     /* 1986739 */   // Label 26609: @1986739
     /* 1986739 */   GIM_Try, /*On fail goto*//*Label 26610*/ GIMT_Encode4(1986825), // Rule ID 61717 //
     /* 1986744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1986755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1986758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1986761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986790 */     // MIs[0] policy
     /* 1986790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986800 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1986803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986824 */     // GIR_Coverage, 61717,
     /* 1986824 */     GIR_EraseRootFromParent_Done,
     /* 1986825 */   // Label 26610: @1986825
     /* 1986825 */   GIM_Try, /*On fail goto*//*Label 26611*/ GIMT_Encode4(1986911), // Rule ID 61720 //
     /* 1986830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1986841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1986844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1986847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986876 */     // MIs[0] policy
     /* 1986876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986886 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1986889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986910 */     // GIR_Coverage, 61720,
     /* 1986910 */     GIR_EraseRootFromParent_Done,
     /* 1986911 */   // Label 26611: @1986911
     /* 1986911 */   GIM_Try, /*On fail goto*//*Label 26612*/ GIMT_Encode4(1986997), // Rule ID 61721 //
     /* 1986916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1986927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1986930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1986933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986962 */     // MIs[0] policy
     /* 1986962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986972 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1986975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986996 */     // GIR_Coverage, 61721,
     /* 1986996 */     GIR_EraseRootFromParent_Done,
     /* 1986997 */   // Label 26612: @1986997
     /* 1986997 */   GIM_Try, /*On fail goto*//*Label 26613*/ GIMT_Encode4(1987083), // Rule ID 61724 //
     /* 1987002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1987013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1987016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1987019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987048 */     // MIs[0] policy
     /* 1987048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987082 */     // GIR_Coverage, 61724,
     /* 1987082 */     GIR_EraseRootFromParent_Done,
     /* 1987083 */   // Label 26613: @1987083
     /* 1987083 */   GIM_Try, /*On fail goto*//*Label 26614*/ GIMT_Encode4(1987169), // Rule ID 61725 //
     /* 1987088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1987099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1987102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1987105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987134 */     // MIs[0] policy
     /* 1987134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987144 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987168 */     // GIR_Coverage, 61725,
     /* 1987168 */     GIR_EraseRootFromParent_Done,
     /* 1987169 */   // Label 26614: @1987169
     /* 1987169 */   GIM_Try, /*On fail goto*//*Label 26615*/ GIMT_Encode4(1987255), // Rule ID 61728 //
     /* 1987174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1987185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1987188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1987191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987220 */     // MIs[0] policy
     /* 1987220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987230 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987254 */     // GIR_Coverage, 61728,
     /* 1987254 */     GIR_EraseRootFromParent_Done,
     /* 1987255 */   // Label 26615: @1987255
     /* 1987255 */   GIM_Try, /*On fail goto*//*Label 26616*/ GIMT_Encode4(1987341), // Rule ID 61729 //
     /* 1987260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1987271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1987274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1987277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987306 */     // MIs[0] policy
     /* 1987306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987316 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987340 */     // GIR_Coverage, 61729,
     /* 1987340 */     GIR_EraseRootFromParent_Done,
     /* 1987341 */   // Label 26616: @1987341
     /* 1987341 */   GIM_Try, /*On fail goto*//*Label 26617*/ GIMT_Encode4(1987427), // Rule ID 61732 //
     /* 1987346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1987357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1987360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1987363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987392 */     // MIs[0] policy
     /* 1987392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987402 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987426 */     // GIR_Coverage, 61732,
     /* 1987426 */     GIR_EraseRootFromParent_Done,
     /* 1987427 */   // Label 26617: @1987427
     /* 1987427 */   GIM_Try, /*On fail goto*//*Label 26618*/ GIMT_Encode4(1987513), // Rule ID 61733 //
     /* 1987432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1987443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1987446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1987449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987478 */     // MIs[0] policy
     /* 1987478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987488 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987512 */     // GIR_Coverage, 61733,
     /* 1987512 */     GIR_EraseRootFromParent_Done,
     /* 1987513 */   // Label 26618: @1987513
     /* 1987513 */   GIM_Try, /*On fail goto*//*Label 26619*/ GIMT_Encode4(1987599), // Rule ID 61736 //
     /* 1987518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1987529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1987532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1987535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1987541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987564 */     // MIs[0] policy
     /* 1987564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987574 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987598 */     // GIR_Coverage, 61736,
     /* 1987598 */     GIR_EraseRootFromParent_Done,
     /* 1987599 */   // Label 26619: @1987599
     /* 1987599 */   GIM_Try, /*On fail goto*//*Label 26620*/ GIMT_Encode4(1987685), // Rule ID 61737 //
     /* 1987604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1987615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1987618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1987621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1987627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987650 */     // MIs[0] policy
     /* 1987650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987684 */     // GIR_Coverage, 61737,
     /* 1987684 */     GIR_EraseRootFromParent_Done,
     /* 1987685 */   // Label 26620: @1987685
     /* 1987685 */   GIM_Try, /*On fail goto*//*Label 26621*/ GIMT_Encode4(1987771), // Rule ID 61740 //
     /* 1987690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1987701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1987704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1987707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987736 */     // MIs[0] policy
     /* 1987736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987746 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987770 */     // GIR_Coverage, 61740,
     /* 1987770 */     GIR_EraseRootFromParent_Done,
     /* 1987771 */   // Label 26621: @1987771
     /* 1987771 */   GIM_Try, /*On fail goto*//*Label 26622*/ GIMT_Encode4(1987857), // Rule ID 61741 //
     /* 1987776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1987787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1987790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1987793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987822 */     // MIs[0] policy
     /* 1987822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987832 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987856 */     // GIR_Coverage, 61741,
     /* 1987856 */     GIR_EraseRootFromParent_Done,
     /* 1987857 */   // Label 26622: @1987857
     /* 1987857 */   GIM_Try, /*On fail goto*//*Label 26623*/ GIMT_Encode4(1987943), // Rule ID 61744 //
     /* 1987862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1987873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1987876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1987879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987908 */     // MIs[0] policy
     /* 1987908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987918 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987942 */     // GIR_Coverage, 61744,
     /* 1987942 */     GIR_EraseRootFromParent_Done,
     /* 1987943 */   // Label 26623: @1987943
     /* 1987943 */   GIM_Try, /*On fail goto*//*Label 26624*/ GIMT_Encode4(1988029), // Rule ID 61745 //
     /* 1987948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1987959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1987962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1987965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987994 */     // MIs[0] policy
     /* 1987994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988004 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1988007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988028 */     // GIR_Coverage, 61745,
     /* 1988028 */     GIR_EraseRootFromParent_Done,
     /* 1988029 */   // Label 26624: @1988029
     /* 1988029 */   GIM_Try, /*On fail goto*//*Label 26625*/ GIMT_Encode4(1988115), // Rule ID 61832 //
     /* 1988034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1988045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1988048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1988051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1988054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988080 */     // MIs[0] policy
     /* 1988080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988090 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1988093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988114 */     // GIR_Coverage, 61832,
     /* 1988114 */     GIR_EraseRootFromParent_Done,
     /* 1988115 */   // Label 26625: @1988115
     /* 1988115 */   GIM_Try, /*On fail goto*//*Label 26626*/ GIMT_Encode4(1988201), // Rule ID 61833 //
     /* 1988120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1988131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1988134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1988137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1988140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988166 */     // MIs[0] policy
     /* 1988166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988176 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1988179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988200 */     // GIR_Coverage, 61833,
     /* 1988200 */     GIR_EraseRootFromParent_Done,
     /* 1988201 */   // Label 26626: @1988201
     /* 1988201 */   GIM_Try, /*On fail goto*//*Label 26627*/ GIMT_Encode4(1988287), // Rule ID 61836 //
     /* 1988206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1988217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1988220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1988223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1988226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988252 */     // MIs[0] policy
     /* 1988252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988262 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1988265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988286 */     // GIR_Coverage, 61836,
     /* 1988286 */     GIR_EraseRootFromParent_Done,
     /* 1988287 */   // Label 26627: @1988287
     /* 1988287 */   GIM_Try, /*On fail goto*//*Label 26628*/ GIMT_Encode4(1988373), // Rule ID 61837 //
     /* 1988292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1988303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1988306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1988309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1988312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988338 */     // MIs[0] policy
     /* 1988338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988348 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1988351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988372 */     // GIR_Coverage, 61837,
     /* 1988372 */     GIR_EraseRootFromParent_Done,
     /* 1988373 */   // Label 26628: @1988373
     /* 1988373 */   GIM_Try, /*On fail goto*//*Label 26629*/ GIMT_Encode4(1988459), // Rule ID 61840 //
     /* 1988378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1988389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1988392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1988395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1988398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988424 */     // MIs[0] policy
     /* 1988424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988434 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988458 */     // GIR_Coverage, 61840,
     /* 1988458 */     GIR_EraseRootFromParent_Done,
     /* 1988459 */   // Label 26629: @1988459
     /* 1988459 */   GIM_Try, /*On fail goto*//*Label 26630*/ GIMT_Encode4(1988545), // Rule ID 61841 //
     /* 1988464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1988475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1988478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1988481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1988484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988510 */     // MIs[0] policy
     /* 1988510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988520 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988544 */     // GIR_Coverage, 61841,
     /* 1988544 */     GIR_EraseRootFromParent_Done,
     /* 1988545 */   // Label 26630: @1988545
     /* 1988545 */   GIM_Try, /*On fail goto*//*Label 26631*/ GIMT_Encode4(1988631), // Rule ID 61844 //
     /* 1988550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1988561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1988564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1988567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1988570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988596 */     // MIs[0] policy
     /* 1988596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988606 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1988609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988630 */     // GIR_Coverage, 61844,
     /* 1988630 */     GIR_EraseRootFromParent_Done,
     /* 1988631 */   // Label 26631: @1988631
     /* 1988631 */   GIM_Try, /*On fail goto*//*Label 26632*/ GIMT_Encode4(1988717), // Rule ID 61845 //
     /* 1988636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1988647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1988650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1988653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1988656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988682 */     // MIs[0] policy
     /* 1988682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988692 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1988695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988716 */     // GIR_Coverage, 61845,
     /* 1988716 */     GIR_EraseRootFromParent_Done,
     /* 1988717 */   // Label 26632: @1988717
     /* 1988717 */   GIM_Try, /*On fail goto*//*Label 26633*/ GIMT_Encode4(1988803), // Rule ID 61848 //
     /* 1988722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1988733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1988736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1988739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1988742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988768 */     // MIs[0] policy
     /* 1988768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988778 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988802 */     // GIR_Coverage, 61848,
     /* 1988802 */     GIR_EraseRootFromParent_Done,
     /* 1988803 */   // Label 26633: @1988803
     /* 1988803 */   GIM_Try, /*On fail goto*//*Label 26634*/ GIMT_Encode4(1988889), // Rule ID 61849 //
     /* 1988808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1988819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1988822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1988825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1988828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988854 */     // MIs[0] policy
     /* 1988854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988864 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988888 */     // GIR_Coverage, 61849,
     /* 1988888 */     GIR_EraseRootFromParent_Done,
     /* 1988889 */   // Label 26634: @1988889
     /* 1988889 */   GIM_Try, /*On fail goto*//*Label 26635*/ GIMT_Encode4(1988975), // Rule ID 61852 //
     /* 1988894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1988905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1988908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1988911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1988914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988940 */     // MIs[0] policy
     /* 1988940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988950 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988974 */     // GIR_Coverage, 61852,
     /* 1988974 */     GIR_EraseRootFromParent_Done,
     /* 1988975 */   // Label 26635: @1988975
     /* 1988975 */   GIM_Try, /*On fail goto*//*Label 26636*/ GIMT_Encode4(1989061), // Rule ID 61853 //
     /* 1988980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1988991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1988994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1988997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1989000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989026 */     // MIs[0] policy
     /* 1989026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989036 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1989039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989060 */     // GIR_Coverage, 61853,
     /* 1989060 */     GIR_EraseRootFromParent_Done,
     /* 1989061 */   // Label 26636: @1989061
     /* 1989061 */   GIM_Try, /*On fail goto*//*Label 26637*/ GIMT_Encode4(1989147), // Rule ID 61856 //
     /* 1989066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1989077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1989080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1989083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1989086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989112 */     // MIs[0] policy
     /* 1989112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989122 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989146 */     // GIR_Coverage, 61856,
     /* 1989146 */     GIR_EraseRootFromParent_Done,
     /* 1989147 */   // Label 26637: @1989147
     /* 1989147 */   GIM_Try, /*On fail goto*//*Label 26638*/ GIMT_Encode4(1989233), // Rule ID 61857 //
     /* 1989152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1989163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1989166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1989169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1989172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989198 */     // MIs[0] policy
     /* 1989198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989208 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989232 */     // GIR_Coverage, 61857,
     /* 1989232 */     GIR_EraseRootFromParent_Done,
     /* 1989233 */   // Label 26638: @1989233
     /* 1989233 */   GIM_Try, /*On fail goto*//*Label 26639*/ GIMT_Encode4(1989319), // Rule ID 61860 //
     /* 1989238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1989249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1989252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1989255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1989258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989284 */     // MIs[0] policy
     /* 1989284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989294 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989318 */     // GIR_Coverage, 61860,
     /* 1989318 */     GIR_EraseRootFromParent_Done,
     /* 1989319 */   // Label 26639: @1989319
     /* 1989319 */   GIM_Try, /*On fail goto*//*Label 26640*/ GIMT_Encode4(1989405), // Rule ID 61861 //
     /* 1989324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1989335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1989338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1989341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1989344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989370 */     // MIs[0] policy
     /* 1989370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989380 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989404 */     // GIR_Coverage, 61861,
     /* 1989404 */     GIR_EraseRootFromParent_Done,
     /* 1989405 */   // Label 26640: @1989405
     /* 1989405 */   GIM_Try, /*On fail goto*//*Label 26641*/ GIMT_Encode4(1989491), // Rule ID 61864 //
     /* 1989410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1989421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1989424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1989427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1989430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989456 */     // MIs[0] policy
     /* 1989456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989466 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989490 */     // GIR_Coverage, 61864,
     /* 1989490 */     GIR_EraseRootFromParent_Done,
     /* 1989491 */   // Label 26641: @1989491
     /* 1989491 */   GIM_Try, /*On fail goto*//*Label 26642*/ GIMT_Encode4(1989577), // Rule ID 61865 //
     /* 1989496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1989507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1989510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1989513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1989516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989542 */     // MIs[0] policy
     /* 1989542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989576 */     // GIR_Coverage, 61865,
     /* 1989576 */     GIR_EraseRootFromParent_Done,
     /* 1989577 */   // Label 26642: @1989577
     /* 1989577 */   GIM_Try, /*On fail goto*//*Label 26643*/ GIMT_Encode4(1989663), // Rule ID 61868 //
     /* 1989582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1989593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1989596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1989599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1989602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989628 */     // MIs[0] policy
     /* 1989628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989638 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1989659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989662 */     // GIR_Coverage, 61868,
     /* 1989662 */     GIR_EraseRootFromParent_Done,
     /* 1989663 */   // Label 26643: @1989663
     /* 1989663 */   GIM_Try, /*On fail goto*//*Label 26644*/ GIMT_Encode4(1989749), // Rule ID 61869 //
     /* 1989668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1989679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1989682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1989685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1989688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989714 */     // MIs[0] policy
     /* 1989714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989724 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1989745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989748 */     // GIR_Coverage, 61869,
     /* 1989748 */     GIR_EraseRootFromParent_Done,
     /* 1989749 */   // Label 26644: @1989749
     /* 1989749 */   GIM_Try, /*On fail goto*//*Label 26645*/ GIMT_Encode4(1989835), // Rule ID 61872 //
     /* 1989754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1989765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1989768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1989771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1989774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1989777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1989784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989800 */     // MIs[0] policy
     /* 1989800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989810 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1989813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989834 */     // GIR_Coverage, 61872,
     /* 1989834 */     GIR_EraseRootFromParent_Done,
     /* 1989835 */   // Label 26645: @1989835
     /* 1989835 */   GIM_Try, /*On fail goto*//*Label 26646*/ GIMT_Encode4(1989921), // Rule ID 61873 //
     /* 1989840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1989851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1989854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1989857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1989860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1989863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1989870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989886 */     // MIs[0] policy
     /* 1989886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1989899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989920 */     // GIR_Coverage, 61873,
     /* 1989920 */     GIR_EraseRootFromParent_Done,
     /* 1989921 */   // Label 26646: @1989921
     /* 1989921 */   GIM_Try, /*On fail goto*//*Label 26647*/ GIMT_Encode4(1990007), // Rule ID 61876 //
     /* 1989926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1989937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1989940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1989943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1989946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1989949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1989956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989972 */     // MIs[0] policy
     /* 1989972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989982 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1989985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990006 */     // GIR_Coverage, 61876,
     /* 1990006 */     GIR_EraseRootFromParent_Done,
     /* 1990007 */   // Label 26647: @1990007
     /* 1990007 */   GIM_Try, /*On fail goto*//*Label 26648*/ GIMT_Encode4(1990093), // Rule ID 61877 //
     /* 1990012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1990023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1990026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1990029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1990032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990058 */     // MIs[0] policy
     /* 1990058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990068 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1990071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990092 */     // GIR_Coverage, 61877,
     /* 1990092 */     GIR_EraseRootFromParent_Done,
     /* 1990093 */   // Label 26648: @1990093
     /* 1990093 */   GIM_Try, /*On fail goto*//*Label 26649*/ GIMT_Encode4(1990179), // Rule ID 61880 //
     /* 1990098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1990109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1990112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1990115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1990118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1990121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990144 */     // MIs[0] policy
     /* 1990144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990154 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1990157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990178 */     // GIR_Coverage, 61880,
     /* 1990178 */     GIR_EraseRootFromParent_Done,
     /* 1990179 */   // Label 26649: @1990179
     /* 1990179 */   GIM_Try, /*On fail goto*//*Label 26650*/ GIMT_Encode4(1990265), // Rule ID 61881 //
     /* 1990184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1990195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1990198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1990201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1990204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1990207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990230 */     // MIs[0] policy
     /* 1990230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990240 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1990243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990264 */     // GIR_Coverage, 61881,
     /* 1990264 */     GIR_EraseRootFromParent_Done,
     /* 1990265 */   // Label 26650: @1990265
     /* 1990265 */   GIM_Try, /*On fail goto*//*Label 26651*/ GIMT_Encode4(1990351), // Rule ID 61884 //
     /* 1990270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1990281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1990284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1990287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1990290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990316 */     // MIs[0] policy
     /* 1990316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990350 */     // GIR_Coverage, 61884,
     /* 1990350 */     GIR_EraseRootFromParent_Done,
     /* 1990351 */   // Label 26651: @1990351
     /* 1990351 */   GIM_Try, /*On fail goto*//*Label 26652*/ GIMT_Encode4(1990437), // Rule ID 61885 //
     /* 1990356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1990367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1990370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1990373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1990376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990402 */     // MIs[0] policy
     /* 1990402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990412 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990436 */     // GIR_Coverage, 61885,
     /* 1990436 */     GIR_EraseRootFromParent_Done,
     /* 1990437 */   // Label 26652: @1990437
     /* 1990437 */   GIM_Try, /*On fail goto*//*Label 26653*/ GIMT_Encode4(1990523), // Rule ID 61888 //
     /* 1990442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1990453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1990456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1990459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1990462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990488 */     // MIs[0] policy
     /* 1990488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990498 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1990501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990522 */     // GIR_Coverage, 61888,
     /* 1990522 */     GIR_EraseRootFromParent_Done,
     /* 1990523 */   // Label 26653: @1990523
     /* 1990523 */   GIM_Try, /*On fail goto*//*Label 26654*/ GIMT_Encode4(1990609), // Rule ID 61889 //
     /* 1990528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1990539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1990542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1990545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1990548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990574 */     // MIs[0] policy
     /* 1990574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990584 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1990587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990608 */     // GIR_Coverage, 61889,
     /* 1990608 */     GIR_EraseRootFromParent_Done,
     /* 1990609 */   // Label 26654: @1990609
     /* 1990609 */   GIM_Try, /*On fail goto*//*Label 26655*/ GIMT_Encode4(1990695), // Rule ID 61892 //
     /* 1990614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1990625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1990628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1990631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1990634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990660 */     // MIs[0] policy
     /* 1990660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990670 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1990673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990694 */     // GIR_Coverage, 61892,
     /* 1990694 */     GIR_EraseRootFromParent_Done,
     /* 1990695 */   // Label 26655: @1990695
     /* 1990695 */   GIM_Try, /*On fail goto*//*Label 26656*/ GIMT_Encode4(1990781), // Rule ID 61893 //
     /* 1990700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1990711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1990714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1990717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1990720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990746 */     // MIs[0] policy
     /* 1990746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990756 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1990759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990780 */     // GIR_Coverage, 61893,
     /* 1990780 */     GIR_EraseRootFromParent_Done,
     /* 1990781 */   // Label 26656: @1990781
     /* 1990781 */   GIM_Try, /*On fail goto*//*Label 26657*/ GIMT_Encode4(1990867), // Rule ID 61896 //
     /* 1990786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1990797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1990800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1990803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1990806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1990809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990832 */     // MIs[0] policy
     /* 1990832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990842 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990866 */     // GIR_Coverage, 61896,
     /* 1990866 */     GIR_EraseRootFromParent_Done,
     /* 1990867 */   // Label 26657: @1990867
     /* 1990867 */   GIM_Try, /*On fail goto*//*Label 26658*/ GIMT_Encode4(1990953), // Rule ID 61897 //
     /* 1990872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1990883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1990886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1990889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1990892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1990895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990918 */     // MIs[0] policy
     /* 1990918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990952 */     // GIR_Coverage, 61897,
     /* 1990952 */     GIR_EraseRootFromParent_Done,
     /* 1990953 */   // Label 26658: @1990953
     /* 1990953 */   GIM_Try, /*On fail goto*//*Label 26659*/ GIMT_Encode4(1991039), // Rule ID 61900 //
     /* 1990958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1990969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1990972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1990975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1990978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991004 */     // MIs[0] policy
     /* 1991004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991014 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991038 */     // GIR_Coverage, 61900,
     /* 1991038 */     GIR_EraseRootFromParent_Done,
     /* 1991039 */   // Label 26659: @1991039
     /* 1991039 */   GIM_Try, /*On fail goto*//*Label 26660*/ GIMT_Encode4(1991125), // Rule ID 61901 //
     /* 1991044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1991055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1991058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1991061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1991064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991090 */     // MIs[0] policy
     /* 1991090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991100 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991124 */     // GIR_Coverage, 61901,
     /* 1991124 */     GIR_EraseRootFromParent_Done,
     /* 1991125 */   // Label 26660: @1991125
     /* 1991125 */   GIM_Try, /*On fail goto*//*Label 26661*/ GIMT_Encode4(1991211), // Rule ID 61904 //
     /* 1991130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1991141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1991144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1991147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1991150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991176 */     // MIs[0] policy
     /* 1991176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991210 */     // GIR_Coverage, 61904,
     /* 1991210 */     GIR_EraseRootFromParent_Done,
     /* 1991211 */   // Label 26661: @1991211
     /* 1991211 */   GIM_Try, /*On fail goto*//*Label 26662*/ GIMT_Encode4(1991297), // Rule ID 61905 //
     /* 1991216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1991227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1991230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1991233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1991236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991262 */     // MIs[0] policy
     /* 1991262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991272 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991296 */     // GIR_Coverage, 61905,
     /* 1991296 */     GIR_EraseRootFromParent_Done,
     /* 1991297 */   // Label 26662: @1991297
     /* 1991297 */   GIM_Try, /*On fail goto*//*Label 26663*/ GIMT_Encode4(1991383), // Rule ID 61908 //
     /* 1991302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1991313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1991316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1991319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1991322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1991325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991348 */     // MIs[0] policy
     /* 1991348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1991361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991382 */     // GIR_Coverage, 61908,
     /* 1991382 */     GIR_EraseRootFromParent_Done,
     /* 1991383 */   // Label 26663: @1991383
     /* 1991383 */   GIM_Try, /*On fail goto*//*Label 26664*/ GIMT_Encode4(1991469), // Rule ID 61909 //
     /* 1991388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1991399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1991402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1991405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1991408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1991411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991434 */     // MIs[0] policy
     /* 1991434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991444 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1991447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991468 */     // GIR_Coverage, 61909,
     /* 1991468 */     GIR_EraseRootFromParent_Done,
     /* 1991469 */   // Label 26664: @1991469
     /* 1991469 */   GIM_Try, /*On fail goto*//*Label 26665*/ GIMT_Encode4(1991555), // Rule ID 61912 //
     /* 1991474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1991485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1991488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1991491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1991494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991520 */     // MIs[0] policy
     /* 1991520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991530 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991554 */     // GIR_Coverage, 61912,
     /* 1991554 */     GIR_EraseRootFromParent_Done,
     /* 1991555 */   // Label 26665: @1991555
     /* 1991555 */   GIM_Try, /*On fail goto*//*Label 26666*/ GIMT_Encode4(1991641), // Rule ID 61913 //
     /* 1991560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1991571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1991574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1991577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1991580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991606 */     // MIs[0] policy
     /* 1991606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991640 */     // GIR_Coverage, 61913,
     /* 1991640 */     GIR_EraseRootFromParent_Done,
     /* 1991641 */   // Label 26666: @1991641
     /* 1991641 */   GIM_Try, /*On fail goto*//*Label 26667*/ GIMT_Encode4(1991727), // Rule ID 61916 //
     /* 1991646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1991657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1991660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1991663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1991666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991692 */     // MIs[0] policy
     /* 1991692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991702 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991726 */     // GIR_Coverage, 61916,
     /* 1991726 */     GIR_EraseRootFromParent_Done,
     /* 1991727 */   // Label 26667: @1991727
     /* 1991727 */   GIM_Try, /*On fail goto*//*Label 26668*/ GIMT_Encode4(1991813), // Rule ID 61917 //
     /* 1991732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1991743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1991746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1991749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1991752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991778 */     // MIs[0] policy
     /* 1991778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991788 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991812 */     // GIR_Coverage, 61917,
     /* 1991812 */     GIR_EraseRootFromParent_Done,
     /* 1991813 */   // Label 26668: @1991813
     /* 1991813 */   GIM_Try, /*On fail goto*//*Label 26669*/ GIMT_Encode4(1991899), // Rule ID 61920 //
     /* 1991818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1991829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1991832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1991835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1991838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1991841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991864 */     // MIs[0] policy
     /* 1991864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991874 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1991877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991898 */     // GIR_Coverage, 61920,
     /* 1991898 */     GIR_EraseRootFromParent_Done,
     /* 1991899 */   // Label 26669: @1991899
     /* 1991899 */   GIM_Try, /*On fail goto*//*Label 26670*/ GIMT_Encode4(1991985), // Rule ID 61921 //
     /* 1991904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1991915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1991918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1991921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1991927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991950 */     // MIs[0] policy
     /* 1991950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991960 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1991963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991984 */     // GIR_Coverage, 61921,
     /* 1991984 */     GIR_EraseRootFromParent_Done,
     /* 1991985 */   // Label 26670: @1991985
     /* 1991985 */   GIM_Try, /*On fail goto*//*Label 26671*/ GIMT_Encode4(1992071), // Rule ID 61924 //
     /* 1991990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1992001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1992004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1992007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992036 */     // MIs[0] policy
     /* 1992036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992070 */     // GIR_Coverage, 61924,
     /* 1992070 */     GIR_EraseRootFromParent_Done,
     /* 1992071 */   // Label 26671: @1992071
     /* 1992071 */   GIM_Try, /*On fail goto*//*Label 26672*/ GIMT_Encode4(1992157), // Rule ID 61925 //
     /* 1992076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1992087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1992090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1992093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992122 */     // MIs[0] policy
     /* 1992122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992132 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992156 */     // GIR_Coverage, 61925,
     /* 1992156 */     GIR_EraseRootFromParent_Done,
     /* 1992157 */   // Label 26672: @1992157
     /* 1992157 */   GIM_Try, /*On fail goto*//*Label 26673*/ GIMT_Encode4(1992243), // Rule ID 61928 //
     /* 1992162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1992173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1992176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1992179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992208 */     // MIs[0] policy
     /* 1992208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992218 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992242 */     // GIR_Coverage, 61928,
     /* 1992242 */     GIR_EraseRootFromParent_Done,
     /* 1992243 */   // Label 26673: @1992243
     /* 1992243 */   GIM_Try, /*On fail goto*//*Label 26674*/ GIMT_Encode4(1992329), // Rule ID 61929 //
     /* 1992248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1992259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1992262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1992265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992294 */     // MIs[0] policy
     /* 1992294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992304 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992328 */     // GIR_Coverage, 61929,
     /* 1992328 */     GIR_EraseRootFromParent_Done,
     /* 1992329 */   // Label 26674: @1992329
     /* 1992329 */   GIM_Try, /*On fail goto*//*Label 26675*/ GIMT_Encode4(1992415), // Rule ID 61932 //
     /* 1992334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1992345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1992348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1992351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992380 */     // MIs[0] policy
     /* 1992380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992390 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992414 */     // GIR_Coverage, 61932,
     /* 1992414 */     GIR_EraseRootFromParent_Done,
     /* 1992415 */   // Label 26675: @1992415
     /* 1992415 */   GIM_Try, /*On fail goto*//*Label 26676*/ GIMT_Encode4(1992501), // Rule ID 61933 //
     /* 1992420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1992431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1992434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1992437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992466 */     // MIs[0] policy
     /* 1992466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992476 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992500 */     // GIR_Coverage, 61933,
     /* 1992500 */     GIR_EraseRootFromParent_Done,
     /* 1992501 */   // Label 26676: @1992501
     /* 1992501 */   GIM_Try, /*On fail goto*//*Label 26677*/ GIMT_Encode4(1992587), // Rule ID 61936 //
     /* 1992506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1992517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1992520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1992523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992552 */     // MIs[0] policy
     /* 1992552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992562 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992586 */     // GIR_Coverage, 61936,
     /* 1992586 */     GIR_EraseRootFromParent_Done,
     /* 1992587 */   // Label 26677: @1992587
     /* 1992587 */   GIM_Try, /*On fail goto*//*Label 26678*/ GIMT_Encode4(1992673), // Rule ID 61937 //
     /* 1992592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1992603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1992606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1992609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992638 */     // MIs[0] policy
     /* 1992638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992648 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992672 */     // GIR_Coverage, 61937,
     /* 1992672 */     GIR_EraseRootFromParent_Done,
     /* 1992673 */   // Label 26678: @1992673
     /* 1992673 */   GIM_Try, /*On fail goto*//*Label 26679*/ GIMT_Encode4(1992759), // Rule ID 61940 //
     /* 1992678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1992689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1992692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1992695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992724 */     // MIs[0] policy
     /* 1992724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992734 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992758 */     // GIR_Coverage, 61940,
     /* 1992758 */     GIR_EraseRootFromParent_Done,
     /* 1992759 */   // Label 26679: @1992759
     /* 1992759 */   GIM_Try, /*On fail goto*//*Label 26680*/ GIMT_Encode4(1992845), // Rule ID 61941 //
     /* 1992764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1992775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1992778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1992781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992810 */     // MIs[0] policy
     /* 1992810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992820 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992844 */     // GIR_Coverage, 61941,
     /* 1992844 */     GIR_EraseRootFromParent_Done,
     /* 1992845 */   // Label 26680: @1992845
     /* 1992845 */   GIM_Try, /*On fail goto*//*Label 26681*/ GIMT_Encode4(1992931), // Rule ID 61944 //
     /* 1992850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1992861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1992864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1992867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992896 */     // MIs[0] policy
     /* 1992896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992906 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1992909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992930 */     // GIR_Coverage, 61944,
     /* 1992930 */     GIR_EraseRootFromParent_Done,
     /* 1992931 */   // Label 26681: @1992931
     /* 1992931 */   GIM_Try, /*On fail goto*//*Label 26682*/ GIMT_Encode4(1993017), // Rule ID 61945 //
     /* 1992936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1992947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1992950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1992953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992982 */     // MIs[0] policy
     /* 1992982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992992 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1992995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993016 */     // GIR_Coverage, 61945,
     /* 1993016 */     GIR_EraseRootFromParent_Done,
     /* 1993017 */   // Label 26682: @1993017
     /* 1993017 */   GIM_Try, /*On fail goto*//*Label 26683*/ GIMT_Encode4(1993103), // Rule ID 61948 //
     /* 1993022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1993033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1993036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1993039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993068 */     // MIs[0] policy
     /* 1993068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993078 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993102 */     // GIR_Coverage, 61948,
     /* 1993102 */     GIR_EraseRootFromParent_Done,
     /* 1993103 */   // Label 26683: @1993103
     /* 1993103 */   GIM_Try, /*On fail goto*//*Label 26684*/ GIMT_Encode4(1993189), // Rule ID 61949 //
     /* 1993108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1993119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1993122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1993125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993154 */     // MIs[0] policy
     /* 1993154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993164 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993188 */     // GIR_Coverage, 61949,
     /* 1993188 */     GIR_EraseRootFromParent_Done,
     /* 1993189 */   // Label 26684: @1993189
     /* 1993189 */   GIM_Try, /*On fail goto*//*Label 26685*/ GIMT_Encode4(1993275), // Rule ID 61952 //
     /* 1993194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1993211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993240 */     // MIs[0] policy
     /* 1993240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993274 */     // GIR_Coverage, 61952,
     /* 1993274 */     GIR_EraseRootFromParent_Done,
     /* 1993275 */   // Label 26685: @1993275
     /* 1993275 */   GIM_Try, /*On fail goto*//*Label 26686*/ GIMT_Encode4(1993361), // Rule ID 61953 //
     /* 1993280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1993297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993326 */     // MIs[0] policy
     /* 1993326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993360 */     // GIR_Coverage, 61953,
     /* 1993360 */     GIR_EraseRootFromParent_Done,
     /* 1993361 */   // Label 26686: @1993361
     /* 1993361 */   GIM_Try, /*On fail goto*//*Label 26687*/ GIMT_Encode4(1993447), // Rule ID 61956 //
     /* 1993366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1993377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1993380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1993383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993412 */     // MIs[0] policy
     /* 1993412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993422 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993446 */     // GIR_Coverage, 61956,
     /* 1993446 */     GIR_EraseRootFromParent_Done,
     /* 1993447 */   // Label 26687: @1993447
     /* 1993447 */   GIM_Try, /*On fail goto*//*Label 26688*/ GIMT_Encode4(1993533), // Rule ID 61957 //
     /* 1993452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1993463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1993466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1993469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993498 */     // MIs[0] policy
     /* 1993498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993508 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993532 */     // GIR_Coverage, 61957,
     /* 1993532 */     GIR_EraseRootFromParent_Done,
     /* 1993533 */   // Label 26688: @1993533
     /* 1993533 */   GIM_Try, /*On fail goto*//*Label 26689*/ GIMT_Encode4(1993619), // Rule ID 61960 //
     /* 1993538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1993549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1993552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1993555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1993561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1993568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993584 */     // MIs[0] policy
     /* 1993584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993594 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1993597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993618 */     // GIR_Coverage, 61960,
     /* 1993618 */     GIR_EraseRootFromParent_Done,
     /* 1993619 */   // Label 26689: @1993619
     /* 1993619 */   GIM_Try, /*On fail goto*//*Label 26690*/ GIMT_Encode4(1993705), // Rule ID 61961 //
     /* 1993624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1993635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1993638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1993641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1993647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1993654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993670 */     // MIs[0] policy
     /* 1993670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993680 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1993683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993704 */     // GIR_Coverage, 61961,
     /* 1993704 */     GIR_EraseRootFromParent_Done,
     /* 1993705 */   // Label 26690: @1993705
     /* 1993705 */   GIM_Try, /*On fail goto*//*Label 26691*/ GIMT_Encode4(1993791), // Rule ID 61964 //
     /* 1993710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1993721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1993724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1993727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1993733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993756 */     // MIs[0] policy
     /* 1993756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993766 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1993769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993790 */     // GIR_Coverage, 61964,
     /* 1993790 */     GIR_EraseRootFromParent_Done,
     /* 1993791 */   // Label 26691: @1993791
     /* 1993791 */   GIM_Try, /*On fail goto*//*Label 26692*/ GIMT_Encode4(1993877), // Rule ID 61965 //
     /* 1993796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1993807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1993810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1993813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1993819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993842 */     // MIs[0] policy
     /* 1993842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993852 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1993855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993876 */     // GIR_Coverage, 61965,
     /* 1993876 */     GIR_EraseRootFromParent_Done,
     /* 1993877 */   // Label 26692: @1993877
     /* 1993877 */   GIM_Try, /*On fail goto*//*Label 26693*/ GIMT_Encode4(1993963), // Rule ID 61968 //
     /* 1993882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1993893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1993896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1993899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1993905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1993912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993928 */     // MIs[0] policy
     /* 1993928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993938 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1993941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993962 */     // GIR_Coverage, 61968,
     /* 1993962 */     GIR_EraseRootFromParent_Done,
     /* 1993963 */   // Label 26693: @1993963
     /* 1993963 */   GIM_Try, /*On fail goto*//*Label 26694*/ GIMT_Encode4(1994049), // Rule ID 61969 //
     /* 1993968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1993979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1993982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1993985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1993991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1993998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994014 */     // MIs[0] policy
     /* 1994014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994024 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994048 */     // GIR_Coverage, 61969,
     /* 1994048 */     GIR_EraseRootFromParent_Done,
     /* 1994049 */   // Label 26694: @1994049
     /* 1994049 */   GIM_Try, /*On fail goto*//*Label 26695*/ GIMT_Encode4(1994135), // Rule ID 61972 //
     /* 1994054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1994065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1994068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1994071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994100 */     // MIs[0] policy
     /* 1994100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994110 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994134 */     // GIR_Coverage, 61972,
     /* 1994134 */     GIR_EraseRootFromParent_Done,
     /* 1994135 */   // Label 26695: @1994135
     /* 1994135 */   GIM_Try, /*On fail goto*//*Label 26696*/ GIMT_Encode4(1994221), // Rule ID 61973 //
     /* 1994140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1994151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1994154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1994157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994186 */     // MIs[0] policy
     /* 1994186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994196 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994220 */     // GIR_Coverage, 61973,
     /* 1994220 */     GIR_EraseRootFromParent_Done,
     /* 1994221 */   // Label 26696: @1994221
     /* 1994221 */   GIM_Try, /*On fail goto*//*Label 26697*/ GIMT_Encode4(1994307), // Rule ID 61976 //
     /* 1994226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1994237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1994240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1994243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994272 */     // MIs[0] policy
     /* 1994272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994282 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994306 */     // GIR_Coverage, 61976,
     /* 1994306 */     GIR_EraseRootFromParent_Done,
     /* 1994307 */   // Label 26697: @1994307
     /* 1994307 */   GIM_Try, /*On fail goto*//*Label 26698*/ GIMT_Encode4(1994393), // Rule ID 61977 //
     /* 1994312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1994323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1994326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1994329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994358 */     // MIs[0] policy
     /* 1994358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994368 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994392 */     // GIR_Coverage, 61977,
     /* 1994392 */     GIR_EraseRootFromParent_Done,
     /* 1994393 */   // Label 26698: @1994393
     /* 1994393 */   GIM_Try, /*On fail goto*//*Label 26699*/ GIMT_Encode4(1994479), // Rule ID 61980 //
     /* 1994398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1994409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1994412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1994415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994444 */     // MIs[0] policy
     /* 1994444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994454 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994478 */     // GIR_Coverage, 61980,
     /* 1994478 */     GIR_EraseRootFromParent_Done,
     /* 1994479 */   // Label 26699: @1994479
     /* 1994479 */   GIM_Try, /*On fail goto*//*Label 26700*/ GIMT_Encode4(1994565), // Rule ID 61981 //
     /* 1994484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1994495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1994498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1994501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994530 */     // MIs[0] policy
     /* 1994530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994540 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994564 */     // GIR_Coverage, 61981,
     /* 1994564 */     GIR_EraseRootFromParent_Done,
     /* 1994565 */   // Label 26700: @1994565
     /* 1994565 */   GIM_Try, /*On fail goto*//*Label 26701*/ GIMT_Encode4(1994651), // Rule ID 61984 //
     /* 1994570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1994581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1994584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1994587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1994593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994616 */     // MIs[0] policy
     /* 1994616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994650 */     // GIR_Coverage, 61984,
     /* 1994650 */     GIR_EraseRootFromParent_Done,
     /* 1994651 */   // Label 26701: @1994651
     /* 1994651 */   GIM_Try, /*On fail goto*//*Label 26702*/ GIMT_Encode4(1994737), // Rule ID 61985 //
     /* 1994656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1994667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1994670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1994673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1994679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994702 */     // MIs[0] policy
     /* 1994702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994736 */     // GIR_Coverage, 61985,
     /* 1994736 */     GIR_EraseRootFromParent_Done,
     /* 1994737 */   // Label 26702: @1994737
     /* 1994737 */   GIM_Try, /*On fail goto*//*Label 26703*/ GIMT_Encode4(1994823), // Rule ID 61988 //
     /* 1994742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1994753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1994756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1994759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994788 */     // MIs[0] policy
     /* 1994788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994798 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994822 */     // GIR_Coverage, 61988,
     /* 1994822 */     GIR_EraseRootFromParent_Done,
     /* 1994823 */   // Label 26703: @1994823
     /* 1994823 */   GIM_Try, /*On fail goto*//*Label 26704*/ GIMT_Encode4(1994909), // Rule ID 61989 //
     /* 1994828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1994839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1994842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1994845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994874 */     // MIs[0] policy
     /* 1994874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994908 */     // GIR_Coverage, 61989,
     /* 1994908 */     GIR_EraseRootFromParent_Done,
     /* 1994909 */   // Label 26704: @1994909
     /* 1994909 */   GIM_Try, /*On fail goto*//*Label 26705*/ GIMT_Encode4(1994995), // Rule ID 61992 //
     /* 1994914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1994925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1994928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1994931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994960 */     // MIs[0] policy
     /* 1994960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994970 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994994 */     // GIR_Coverage, 61992,
     /* 1994994 */     GIR_EraseRootFromParent_Done,
     /* 1994995 */   // Label 26705: @1994995
     /* 1994995 */   GIM_Try, /*On fail goto*//*Label 26706*/ GIMT_Encode4(1995081), // Rule ID 61993 //
     /* 1995000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1995011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1995014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1995017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1995023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995046 */     // MIs[0] policy
     /* 1995046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995056 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1995059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995080 */     // GIR_Coverage, 61993,
     /* 1995080 */     GIR_EraseRootFromParent_Done,
     /* 1995081 */   // Label 26706: @1995081
     /* 1995081 */   GIM_Try, /*On fail goto*//*Label 26707*/ GIMT_Encode4(1995167), // Rule ID 61996 //
     /* 1995086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1995097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1995100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1995103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995132 */     // MIs[0] policy
     /* 1995132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995142 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1995145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995166 */     // GIR_Coverage, 61996,
     /* 1995166 */     GIR_EraseRootFromParent_Done,
     /* 1995167 */   // Label 26707: @1995167
     /* 1995167 */   GIM_Try, /*On fail goto*//*Label 26708*/ GIMT_Encode4(1995253), // Rule ID 61997 //
     /* 1995172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1995183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1995186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1995189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995218 */     // MIs[0] policy
     /* 1995218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995228 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1995231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995252 */     // GIR_Coverage, 61997,
     /* 1995252 */     GIR_EraseRootFromParent_Done,
     /* 1995253 */   // Label 26708: @1995253
     /* 1995253 */   GIM_Try, /*On fail goto*//*Label 26709*/ GIMT_Encode4(1995339), // Rule ID 62000 //
     /* 1995258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1995269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1995272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1995275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995304 */     // MIs[0] policy
     /* 1995304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995314 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1995317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995338 */     // GIR_Coverage, 62000,
     /* 1995338 */     GIR_EraseRootFromParent_Done,
     /* 1995339 */   // Label 26709: @1995339
     /* 1995339 */   GIM_Try, /*On fail goto*//*Label 26710*/ GIMT_Encode4(1995425), // Rule ID 62001 //
     /* 1995344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1995355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1995358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1995361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995390 */     // MIs[0] policy
     /* 1995390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995400 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1995403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995424 */     // GIR_Coverage, 62001,
     /* 1995424 */     GIR_EraseRootFromParent_Done,
     /* 1995425 */   // Label 26710: @1995425
     /* 1995425 */   GIM_Try, /*On fail goto*//*Label 26711*/ GIMT_Encode4(1995511), // Rule ID 62004 //
     /* 1995430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1995441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1995444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1995447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995476 */     // MIs[0] policy
     /* 1995476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995486 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1995489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995510 */     // GIR_Coverage, 62004,
     /* 1995510 */     GIR_EraseRootFromParent_Done,
     /* 1995511 */   // Label 26711: @1995511
     /* 1995511 */   GIM_Try, /*On fail goto*//*Label 26712*/ GIMT_Encode4(1995597), // Rule ID 62005 //
     /* 1995516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1995527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1995530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1995533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995562 */     // MIs[0] policy
     /* 1995562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995572 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1995575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995596 */     // GIR_Coverage, 62005,
     /* 1995596 */     GIR_EraseRootFromParent_Done,
     /* 1995597 */   // Label 26712: @1995597
     /* 1995597 */   GIM_Try, /*On fail goto*//*Label 26713*/ GIMT_Encode4(1995683), // Rule ID 62610 //
     /* 1995602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1995605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1995610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1995613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1995616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1995619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1995622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995648 */     // MIs[0] policy
     /* 1995648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995658 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_MF2_MASK),
     /* 1995661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995682 */     // GIR_Coverage, 62610,
     /* 1995682 */     GIR_EraseRootFromParent_Done,
     /* 1995683 */   // Label 26713: @1995683
     /* 1995683 */   GIM_Try, /*On fail goto*//*Label 26714*/ GIMT_Encode4(1995769), // Rule ID 62611 //
     /* 1995688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1995691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1995696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1995699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1995702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1995705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1995708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995734 */     // MIs[0] policy
     /* 1995734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995744 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_MF2_MASK),
     /* 1995747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995768 */     // GIR_Coverage, 62611,
     /* 1995768 */     GIR_EraseRootFromParent_Done,
     /* 1995769 */   // Label 26714: @1995769
     /* 1995769 */   GIM_Try, /*On fail goto*//*Label 26715*/ GIMT_Encode4(1995855), // Rule ID 62614 //
     /* 1995774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1995777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1995782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1995785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1995788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1995791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1995794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995820 */     // MIs[0] policy
     /* 1995820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M1_MASK),
     /* 1995833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995854 */     // GIR_Coverage, 62614,
     /* 1995854 */     GIR_EraseRootFromParent_Done,
     /* 1995855 */   // Label 26715: @1995855
     /* 1995855 */   GIM_Try, /*On fail goto*//*Label 26716*/ GIMT_Encode4(1995941), // Rule ID 62615 //
     /* 1995860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1995863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1995868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1995871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1995874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1995877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1995880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995906 */     // MIs[0] policy
     /* 1995906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M1_MASK),
     /* 1995919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995940 */     // GIR_Coverage, 62615,
     /* 1995940 */     GIR_EraseRootFromParent_Done,
     /* 1995941 */   // Label 26716: @1995941
     /* 1995941 */   GIM_Try, /*On fail goto*//*Label 26717*/ GIMT_Encode4(1996027), // Rule ID 62618 //
     /* 1995946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1995949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1995954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1995957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1995960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1995963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1995966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1995969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995992 */     // MIs[0] policy
     /* 1995992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M2_MASK),
     /* 1996005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996026 */     // GIR_Coverage, 62618,
     /* 1996026 */     GIR_EraseRootFromParent_Done,
     /* 1996027 */   // Label 26717: @1996027
     /* 1996027 */   GIM_Try, /*On fail goto*//*Label 26718*/ GIMT_Encode4(1996113), // Rule ID 62619 //
     /* 1996032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1996049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1996052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996078 */     // MIs[0] policy
     /* 1996078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M2_MASK),
     /* 1996091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996112 */     // GIR_Coverage, 62619,
     /* 1996112 */     GIR_EraseRootFromParent_Done,
     /* 1996113 */   // Label 26718: @1996113
     /* 1996113 */   GIM_Try, /*On fail goto*//*Label 26719*/ GIMT_Encode4(1996199), // Rule ID 62622 //
     /* 1996118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1996135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1996138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1996141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1996148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996164 */     // MIs[0] policy
     /* 1996164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996174 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M4_MASK),
     /* 1996177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996198 */     // GIR_Coverage, 62622,
     /* 1996198 */     GIR_EraseRootFromParent_Done,
     /* 1996199 */   // Label 26719: @1996199
     /* 1996199 */   GIM_Try, /*On fail goto*//*Label 26720*/ GIMT_Encode4(1996285), // Rule ID 62623 //
     /* 1996204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1996221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1996224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1996227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1996234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996250 */     // MIs[0] policy
     /* 1996250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996260 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M4_MASK),
     /* 1996263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996284 */     // GIR_Coverage, 62623,
     /* 1996284 */     GIR_EraseRootFromParent_Done,
     /* 1996285 */   // Label 26720: @1996285
     /* 1996285 */   GIM_Try, /*On fail goto*//*Label 26721*/ GIMT_Encode4(1996371), // Rule ID 62626 //
     /* 1996290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1996301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1996304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1996307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1996310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1996313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1996320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996336 */     // MIs[0] policy
     /* 1996336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996346 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M8_MASK),
     /* 1996349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996370 */     // GIR_Coverage, 62626,
     /* 1996370 */     GIR_EraseRootFromParent_Done,
     /* 1996371 */   // Label 26721: @1996371
     /* 1996371 */   GIM_Try, /*On fail goto*//*Label 26722*/ GIMT_Encode4(1996457), // Rule ID 62627 //
     /* 1996376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1996387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1996390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1996393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1996396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1996399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1996406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996422 */     // MIs[0] policy
     /* 1996422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996432 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M8_MASK),
     /* 1996435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996456 */     // GIR_Coverage, 62627,
     /* 1996456 */     GIR_EraseRootFromParent_Done,
     /* 1996457 */   // Label 26722: @1996457
     /* 1996457 */   GIM_Try, /*On fail goto*//*Label 26723*/ GIMT_Encode4(1996543), // Rule ID 62630 //
     /* 1996462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1996482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996508 */     // MIs[0] policy
     /* 1996508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996518 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_MF2_MASK),
     /* 1996521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996542 */     // GIR_Coverage, 62630,
     /* 1996542 */     GIR_EraseRootFromParent_Done,
     /* 1996543 */   // Label 26723: @1996543
     /* 1996543 */   GIM_Try, /*On fail goto*//*Label 26724*/ GIMT_Encode4(1996629), // Rule ID 62631 //
     /* 1996548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1996565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1996568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996594 */     // MIs[0] policy
     /* 1996594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996604 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_MF2_MASK),
     /* 1996607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996628 */     // GIR_Coverage, 62631,
     /* 1996628 */     GIR_EraseRootFromParent_Done,
     /* 1996629 */   // Label 26724: @1996629
     /* 1996629 */   GIM_Try, /*On fail goto*//*Label 26725*/ GIMT_Encode4(1996715), // Rule ID 62634 //
     /* 1996634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1996654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996680 */     // MIs[0] policy
     /* 1996680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M1_MASK),
     /* 1996693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996714 */     // GIR_Coverage, 62634,
     /* 1996714 */     GIR_EraseRootFromParent_Done,
     /* 1996715 */   // Label 26725: @1996715
     /* 1996715 */   GIM_Try, /*On fail goto*//*Label 26726*/ GIMT_Encode4(1996801), // Rule ID 62635 //
     /* 1996720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1996737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1996740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996766 */     // MIs[0] policy
     /* 1996766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996776 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M1_MASK),
     /* 1996779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996800 */     // GIR_Coverage, 62635,
     /* 1996800 */     GIR_EraseRootFromParent_Done,
     /* 1996801 */   // Label 26726: @1996801
     /* 1996801 */   GIM_Try, /*On fail goto*//*Label 26727*/ GIMT_Encode4(1996887), // Rule ID 62638 //
     /* 1996806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1996826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996852 */     // MIs[0] policy
     /* 1996852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M2_MASK),
     /* 1996865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996886 */     // GIR_Coverage, 62638,
     /* 1996886 */     GIR_EraseRootFromParent_Done,
     /* 1996887 */   // Label 26727: @1996887
     /* 1996887 */   GIM_Try, /*On fail goto*//*Label 26728*/ GIMT_Encode4(1996973), // Rule ID 62639 //
     /* 1996892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1996909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1996912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996938 */     // MIs[0] policy
     /* 1996938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M2_MASK),
     /* 1996951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996972 */     // GIR_Coverage, 62639,
     /* 1996972 */     GIR_EraseRootFromParent_Done,
     /* 1996973 */   // Label 26728: @1996973
     /* 1996973 */   GIM_Try, /*On fail goto*//*Label 26729*/ GIMT_Encode4(1997059), // Rule ID 62642 //
     /* 1996978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1996998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997024 */     // MIs[0] policy
     /* 1997024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997034 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M4_MASK),
     /* 1997037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997058 */     // GIR_Coverage, 62642,
     /* 1997058 */     GIR_EraseRootFromParent_Done,
     /* 1997059 */   // Label 26729: @1997059
     /* 1997059 */   GIM_Try, /*On fail goto*//*Label 26730*/ GIMT_Encode4(1997145), // Rule ID 62643 //
     /* 1997064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1997075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1997078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1997084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997110 */     // MIs[0] policy
     /* 1997110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997120 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M4_MASK),
     /* 1997123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997144 */     // GIR_Coverage, 62643,
     /* 1997144 */     GIR_EraseRootFromParent_Done,
     /* 1997145 */   // Label 26730: @1997145
     /* 1997145 */   GIM_Try, /*On fail goto*//*Label 26731*/ GIMT_Encode4(1997231), // Rule ID 62646 //
     /* 1997150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1997161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1997164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1997167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1997170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1997173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1997180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997196 */     // MIs[0] policy
     /* 1997196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997206 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M8_MASK),
     /* 1997209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997230 */     // GIR_Coverage, 62646,
     /* 1997230 */     GIR_EraseRootFromParent_Done,
     /* 1997231 */   // Label 26731: @1997231
     /* 1997231 */   GIM_Try, /*On fail goto*//*Label 26732*/ GIMT_Encode4(1997317), // Rule ID 62647 //
     /* 1997236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1997247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1997250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1997256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1997259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1997266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997282 */     // MIs[0] policy
     /* 1997282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997292 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M8_MASK),
     /* 1997295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997316 */     // GIR_Coverage, 62647,
     /* 1997316 */     GIR_EraseRootFromParent_Done,
     /* 1997317 */   // Label 26732: @1997317
     /* 1997317 */   GIM_Try, /*On fail goto*//*Label 26733*/ GIMT_Encode4(1997403), // Rule ID 62650 //
     /* 1997322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1997339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1997342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997368 */     // MIs[0] policy
     /* 1997368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_MF2_MASK),
     /* 1997381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997402 */     // GIR_Coverage, 62650,
     /* 1997402 */     GIR_EraseRootFromParent_Done,
     /* 1997403 */   // Label 26733: @1997403
     /* 1997403 */   GIM_Try, /*On fail goto*//*Label 26734*/ GIMT_Encode4(1997489), // Rule ID 62651 //
     /* 1997408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1997425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1997428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997454 */     // MIs[0] policy
     /* 1997454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997464 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_MF2_MASK),
     /* 1997467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997488 */     // GIR_Coverage, 62651,
     /* 1997488 */     GIR_EraseRootFromParent_Done,
     /* 1997489 */   // Label 26734: @1997489
     /* 1997489 */   GIM_Try, /*On fail goto*//*Label 26735*/ GIMT_Encode4(1997575), // Rule ID 62654 //
     /* 1997494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1997511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1997514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997540 */     // MIs[0] policy
     /* 1997540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M1_MASK),
     /* 1997553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997574 */     // GIR_Coverage, 62654,
     /* 1997574 */     GIR_EraseRootFromParent_Done,
     /* 1997575 */   // Label 26735: @1997575
     /* 1997575 */   GIM_Try, /*On fail goto*//*Label 26736*/ GIMT_Encode4(1997661), // Rule ID 62655 //
     /* 1997580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1997597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1997600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997626 */     // MIs[0] policy
     /* 1997626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997636 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M1_MASK),
     /* 1997639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997660 */     // GIR_Coverage, 62655,
     /* 1997660 */     GIR_EraseRootFromParent_Done,
     /* 1997661 */   // Label 26736: @1997661
     /* 1997661 */   GIM_Try, /*On fail goto*//*Label 26737*/ GIMT_Encode4(1997747), // Rule ID 62658 //
     /* 1997666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1997677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1997680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1997683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1997686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997712 */     // MIs[0] policy
     /* 1997712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M2_MASK),
     /* 1997725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997746 */     // GIR_Coverage, 62658,
     /* 1997746 */     GIR_EraseRootFromParent_Done,
     /* 1997747 */   // Label 26737: @1997747
     /* 1997747 */   GIM_Try, /*On fail goto*//*Label 26738*/ GIMT_Encode4(1997833), // Rule ID 62659 //
     /* 1997752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1997763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1997766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1997769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1997772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997798 */     // MIs[0] policy
     /* 1997798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997808 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M2_MASK),
     /* 1997811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997832 */     // GIR_Coverage, 62659,
     /* 1997832 */     GIR_EraseRootFromParent_Done,
     /* 1997833 */   // Label 26738: @1997833
     /* 1997833 */   GIM_Try, /*On fail goto*//*Label 26739*/ GIMT_Encode4(1997919), // Rule ID 62662 //
     /* 1997838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1997849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1997852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1997855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1997858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997884 */     // MIs[0] policy
     /* 1997884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997894 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M4_MASK),
     /* 1997897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997918 */     // GIR_Coverage, 62662,
     /* 1997918 */     GIR_EraseRootFromParent_Done,
     /* 1997919 */   // Label 26739: @1997919
     /* 1997919 */   GIM_Try, /*On fail goto*//*Label 26740*/ GIMT_Encode4(1998005), // Rule ID 62663 //
     /* 1997924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1997935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1997938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1997941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1997944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997970 */     // MIs[0] policy
     /* 1997970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M4_MASK),
     /* 1997983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998004 */     // GIR_Coverage, 62663,
     /* 1998004 */     GIR_EraseRootFromParent_Done,
     /* 1998005 */   // Label 26740: @1998005
     /* 1998005 */   GIM_Try, /*On fail goto*//*Label 26741*/ GIMT_Encode4(1998091), // Rule ID 62666 //
     /* 1998010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1998027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998056 */     // MIs[0] policy
     /* 1998056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998066 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M8_MASK),
     /* 1998069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998090 */     // GIR_Coverage, 62666,
     /* 1998090 */     GIR_EraseRootFromParent_Done,
     /* 1998091 */   // Label 26741: @1998091
     /* 1998091 */   GIM_Try, /*On fail goto*//*Label 26742*/ GIMT_Encode4(1998177), // Rule ID 62667 //
     /* 1998096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1998113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998142 */     // MIs[0] policy
     /* 1998142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998152 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M8_MASK),
     /* 1998155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998176 */     // GIR_Coverage, 62667,
     /* 1998176 */     GIR_EraseRootFromParent_Done,
     /* 1998177 */   // Label 26742: @1998177
     /* 1998177 */   GIM_Try, /*On fail goto*//*Label 26743*/ GIMT_Encode4(1998263), // Rule ID 62670 //
     /* 1998182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1998193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1998196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1998202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998228 */     // MIs[0] policy
     /* 1998228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998238 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_MF2_MASK),
     /* 1998241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998262 */     // GIR_Coverage, 62670,
     /* 1998262 */     GIR_EraseRootFromParent_Done,
     /* 1998263 */   // Label 26743: @1998263
     /* 1998263 */   GIM_Try, /*On fail goto*//*Label 26744*/ GIMT_Encode4(1998349), // Rule ID 62671 //
     /* 1998268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1998279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1998282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1998288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998314 */     // MIs[0] policy
     /* 1998314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998324 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_MF2_MASK),
     /* 1998327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998348 */     // GIR_Coverage, 62671,
     /* 1998348 */     GIR_EraseRootFromParent_Done,
     /* 1998349 */   // Label 26744: @1998349
     /* 1998349 */   GIM_Try, /*On fail goto*//*Label 26745*/ GIMT_Encode4(1998435), // Rule ID 62674 //
     /* 1998354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1998374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998400 */     // MIs[0] policy
     /* 1998400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998410 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M1_MASK),
     /* 1998413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998434 */     // GIR_Coverage, 62674,
     /* 1998434 */     GIR_EraseRootFromParent_Done,
     /* 1998435 */   // Label 26745: @1998435
     /* 1998435 */   GIM_Try, /*On fail goto*//*Label 26746*/ GIMT_Encode4(1998521), // Rule ID 62675 //
     /* 1998440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1998460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998486 */     // MIs[0] policy
     /* 1998486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M1_MASK),
     /* 1998499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998520 */     // GIR_Coverage, 62675,
     /* 1998520 */     GIR_EraseRootFromParent_Done,
     /* 1998521 */   // Label 26746: @1998521
     /* 1998521 */   GIM_Try, /*On fail goto*//*Label 26747*/ GIMT_Encode4(1998607), // Rule ID 62678 //
     /* 1998526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1998546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998572 */     // MIs[0] policy
     /* 1998572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M2_MASK),
     /* 1998585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998606 */     // GIR_Coverage, 62678,
     /* 1998606 */     GIR_EraseRootFromParent_Done,
     /* 1998607 */   // Label 26747: @1998607
     /* 1998607 */   GIM_Try, /*On fail goto*//*Label 26748*/ GIMT_Encode4(1998693), // Rule ID 62679 //
     /* 1998612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1998632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998658 */     // MIs[0] policy
     /* 1998658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M2_MASK),
     /* 1998671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998692 */     // GIR_Coverage, 62679,
     /* 1998692 */     GIR_EraseRootFromParent_Done,
     /* 1998693 */   // Label 26748: @1998693
     /* 1998693 */   GIM_Try, /*On fail goto*//*Label 26749*/ GIMT_Encode4(1998779), // Rule ID 62682 //
     /* 1998698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1998718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998744 */     // MIs[0] policy
     /* 1998744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998754 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M4_MASK),
     /* 1998757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998778 */     // GIR_Coverage, 62682,
     /* 1998778 */     GIR_EraseRootFromParent_Done,
     /* 1998779 */   // Label 26749: @1998779
     /* 1998779 */   GIM_Try, /*On fail goto*//*Label 26750*/ GIMT_Encode4(1998865), // Rule ID 62683 //
     /* 1998784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1998804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998830 */     // MIs[0] policy
     /* 1998830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M4_MASK),
     /* 1998843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998864 */     // GIR_Coverage, 62683,
     /* 1998864 */     GIR_EraseRootFromParent_Done,
     /* 1998865 */   // Label 26750: @1998865
     /* 1998865 */   GIM_Try, /*On fail goto*//*Label 26751*/ GIMT_Encode4(1998951), // Rule ID 62686 //
     /* 1998870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998916 */     // MIs[0] policy
     /* 1998916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998926 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M8_MASK),
     /* 1998929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998950 */     // GIR_Coverage, 62686,
     /* 1998950 */     GIR_EraseRootFromParent_Done,
     /* 1998951 */   // Label 26751: @1998951
     /* 1998951 */   GIM_Try, /*On fail goto*//*Label 26752*/ GIMT_Encode4(1999037), // Rule ID 62687 //
     /* 1998956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999002 */     // MIs[0] policy
     /* 1999002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999012 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M8_MASK),
     /* 1999015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999036 */     // GIR_Coverage, 62687,
     /* 1999036 */     GIR_EraseRootFromParent_Done,
     /* 1999037 */   // Label 26752: @1999037
     /* 1999037 */   GIM_Try, /*On fail goto*//*Label 26753*/ GIMT_Encode4(1999123), // Rule ID 62690 //
     /* 1999042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1999059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1999062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999088 */     // MIs[0] policy
     /* 1999088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999098 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_MF2_MASK),
     /* 1999101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999122 */     // GIR_Coverage, 62690,
     /* 1999122 */     GIR_EraseRootFromParent_Done,
     /* 1999123 */   // Label 26753: @1999123
     /* 1999123 */   GIM_Try, /*On fail goto*//*Label 26754*/ GIMT_Encode4(1999209), // Rule ID 62691 //
     /* 1999128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1999145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1999148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999174 */     // MIs[0] policy
     /* 1999174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999184 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_MF2_MASK),
     /* 1999187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999208 */     // GIR_Coverage, 62691,
     /* 1999208 */     GIR_EraseRootFromParent_Done,
     /* 1999209 */   // Label 26754: @1999209
     /* 1999209 */   GIM_Try, /*On fail goto*//*Label 26755*/ GIMT_Encode4(1999295), // Rule ID 62694 //
     /* 1999214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1999231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1999234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999260 */     // MIs[0] policy
     /* 1999260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M1_MASK),
     /* 1999273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999294 */     // GIR_Coverage, 62694,
     /* 1999294 */     GIR_EraseRootFromParent_Done,
     /* 1999295 */   // Label 26755: @1999295
     /* 1999295 */   GIM_Try, /*On fail goto*//*Label 26756*/ GIMT_Encode4(1999381), // Rule ID 62695 //
     /* 1999300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1999317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1999320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999346 */     // MIs[0] policy
     /* 1999346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999356 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M1_MASK),
     /* 1999359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999380 */     // GIR_Coverage, 62695,
     /* 1999380 */     GIR_EraseRootFromParent_Done,
     /* 1999381 */   // Label 26756: @1999381
     /* 1999381 */   GIM_Try, /*On fail goto*//*Label 26757*/ GIMT_Encode4(1999467), // Rule ID 62698 //
     /* 1999386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1999397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1999400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1999403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999432 */     // MIs[0] policy
     /* 1999432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999442 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M2_MASK),
     /* 1999445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999466 */     // GIR_Coverage, 62698,
     /* 1999466 */     GIR_EraseRootFromParent_Done,
     /* 1999467 */   // Label 26757: @1999467
     /* 1999467 */   GIM_Try, /*On fail goto*//*Label 26758*/ GIMT_Encode4(1999553), // Rule ID 62699 //
     /* 1999472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1999483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1999486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1999489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999518 */     // MIs[0] policy
     /* 1999518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999528 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M2_MASK),
     /* 1999531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999552 */     // GIR_Coverage, 62699,
     /* 1999552 */     GIR_EraseRootFromParent_Done,
     /* 1999553 */   // Label 26758: @1999553
     /* 1999553 */   GIM_Try, /*On fail goto*//*Label 26759*/ GIMT_Encode4(1999639), // Rule ID 62702 //
     /* 1999558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1999569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1999572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1999575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1999578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1999581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999604 */     // MIs[0] policy
     /* 1999604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999614 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M4_MASK),
     /* 1999617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999638 */     // GIR_Coverage, 62702,
     /* 1999638 */     GIR_EraseRootFromParent_Done,
     /* 1999639 */   // Label 26759: @1999639
     /* 1999639 */   GIM_Try, /*On fail goto*//*Label 26760*/ GIMT_Encode4(1999725), // Rule ID 62703 //
     /* 1999644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1999655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1999658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1999661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1999664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1999667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999690 */     // MIs[0] policy
     /* 1999690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999700 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M4_MASK),
     /* 1999703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999724 */     // GIR_Coverage, 62703,
     /* 1999724 */     GIR_EraseRootFromParent_Done,
     /* 1999725 */   // Label 26760: @1999725
     /* 1999725 */   GIM_Try, /*On fail goto*//*Label 26761*/ GIMT_Encode4(1999811), // Rule ID 62706 //
     /* 1999730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1999741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1999744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1999747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1999750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1999753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999776 */     // MIs[0] policy
     /* 1999776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999786 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M8_MASK),
     /* 1999789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999810 */     // GIR_Coverage, 62706,
     /* 1999810 */     GIR_EraseRootFromParent_Done,
     /* 1999811 */   // Label 26761: @1999811
     /* 1999811 */   GIM_Try, /*On fail goto*//*Label 26762*/ GIMT_Encode4(1999897), // Rule ID 62707 //
     /* 1999816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1999827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1999830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1999833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1999836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1999839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999862 */     // MIs[0] policy
     /* 1999862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999872 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M8_MASK),
     /* 1999875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999896 */     // GIR_Coverage, 62707,
     /* 1999896 */     GIR_EraseRootFromParent_Done,
     /* 1999897 */   // Label 26762: @1999897
     /* 1999897 */   GIM_Try, /*On fail goto*//*Label 26763*/ GIMT_Encode4(1999983), // Rule ID 62710 //
     /* 1999902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1999919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1999922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999948 */     // MIs[0] policy
     /* 1999948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999958 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_MF2_MASK),
     /* 1999961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999982 */     // GIR_Coverage, 62710,
     /* 1999982 */     GIR_EraseRootFromParent_Done,
     /* 1999983 */   // Label 26763: @1999983
     /* 1999983 */   GIM_Try, /*On fail goto*//*Label 26764*/ GIMT_Encode4(2000069), // Rule ID 62711 //
     /* 1999988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2000002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2000008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000034 */     // MIs[0] policy
     /* 2000034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000044 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_MF2_MASK),
     /* 2000047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000068 */     // GIR_Coverage, 62711,
     /* 2000068 */     GIR_EraseRootFromParent_Done,
     /* 2000069 */   // Label 26764: @2000069
     /* 2000069 */   GIM_Try, /*On fail goto*//*Label 26765*/ GIMT_Encode4(2000155), // Rule ID 62714 //
     /* 2000074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2000094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000120 */     // MIs[0] policy
     /* 2000120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M1_MASK),
     /* 2000133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000154 */     // GIR_Coverage, 62714,
     /* 2000154 */     GIR_EraseRootFromParent_Done,
     /* 2000155 */   // Label 26765: @2000155
     /* 2000155 */   GIM_Try, /*On fail goto*//*Label 26766*/ GIMT_Encode4(2000241), // Rule ID 62715 //
     /* 2000160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2000180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000206 */     // MIs[0] policy
     /* 2000206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M1_MASK),
     /* 2000219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000240 */     // GIR_Coverage, 62715,
     /* 2000240 */     GIR_EraseRootFromParent_Done,
     /* 2000241 */   // Label 26766: @2000241
     /* 2000241 */   GIM_Try, /*On fail goto*//*Label 26767*/ GIMT_Encode4(2000327), // Rule ID 62718 //
     /* 2000246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2000257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2000260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2000266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2000276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000292 */     // MIs[0] policy
     /* 2000292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M2_MASK),
     /* 2000305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000326 */     // GIR_Coverage, 62718,
     /* 2000326 */     GIR_EraseRootFromParent_Done,
     /* 2000327 */   // Label 26767: @2000327
     /* 2000327 */   GIM_Try, /*On fail goto*//*Label 26768*/ GIMT_Encode4(2000413), // Rule ID 62719 //
     /* 2000332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2000343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2000346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2000352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2000362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000378 */     // MIs[0] policy
     /* 2000378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000388 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M2_MASK),
     /* 2000391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000412 */     // GIR_Coverage, 62719,
     /* 2000412 */     GIR_EraseRootFromParent_Done,
     /* 2000413 */   // Label 26768: @2000413
     /* 2000413 */   GIM_Try, /*On fail goto*//*Label 26769*/ GIMT_Encode4(2000499), // Rule ID 62722 //
     /* 2000418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000464 */     // MIs[0] policy
     /* 2000464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000474 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M4_MASK),
     /* 2000477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000498 */     // GIR_Coverage, 62722,
     /* 2000498 */     GIR_EraseRootFromParent_Done,
     /* 2000499 */   // Label 26769: @2000499
     /* 2000499 */   GIM_Try, /*On fail goto*//*Label 26770*/ GIMT_Encode4(2000585), // Rule ID 62723 //
     /* 2000504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000550 */     // MIs[0] policy
     /* 2000550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000560 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M4_MASK),
     /* 2000563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000584 */     // GIR_Coverage, 62723,
     /* 2000584 */     GIR_EraseRootFromParent_Done,
     /* 2000585 */   // Label 26770: @2000585
     /* 2000585 */   GIM_Try, /*On fail goto*//*Label 26771*/ GIMT_Encode4(2000671), // Rule ID 62726 //
     /* 2000590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2000601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2000604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2000610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2000613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2000620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000636 */     // MIs[0] policy
     /* 2000636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000646 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M8_MASK),
     /* 2000649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000670 */     // GIR_Coverage, 62726,
     /* 2000670 */     GIR_EraseRootFromParent_Done,
     /* 2000671 */   // Label 26771: @2000671
     /* 2000671 */   GIM_Try, /*On fail goto*//*Label 26772*/ GIMT_Encode4(2000757), // Rule ID 62727 //
     /* 2000676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2000687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2000690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2000696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2000699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2000706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000722 */     // MIs[0] policy
     /* 2000722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000732 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M8_MASK),
     /* 2000735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000756 */     // GIR_Coverage, 62727,
     /* 2000756 */     GIR_EraseRootFromParent_Done,
     /* 2000757 */   // Label 26772: @2000757
     /* 2000757 */   GIM_Try, /*On fail goto*//*Label 26773*/ GIMT_Encode4(2000843), // Rule ID 62730 //
     /* 2000762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2000770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2000773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2000776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2000782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000808 */     // MIs[0] policy
     /* 2000808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000818 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_MF2_MASK),
     /* 2000821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000842 */     // GIR_Coverage, 62730,
     /* 2000842 */     GIR_EraseRootFromParent_Done,
     /* 2000843 */   // Label 26773: @2000843
     /* 2000843 */   GIM_Try, /*On fail goto*//*Label 26774*/ GIMT_Encode4(2000929), // Rule ID 62731 //
     /* 2000848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2000856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2000859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2000862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2000868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000894 */     // MIs[0] policy
     /* 2000894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000904 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_MF2_MASK),
     /* 2000907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000928 */     // GIR_Coverage, 62731,
     /* 2000928 */     GIR_EraseRootFromParent_Done,
     /* 2000929 */   // Label 26774: @2000929
     /* 2000929 */   GIM_Try, /*On fail goto*//*Label 26775*/ GIMT_Encode4(2001015), // Rule ID 62734 //
     /* 2000934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2000942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2000954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000980 */     // MIs[0] policy
     /* 2000980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M1_MASK),
     /* 2000993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001014 */     // GIR_Coverage, 62734,
     /* 2001014 */     GIR_EraseRootFromParent_Done,
     /* 2001015 */   // Label 26775: @2001015
     /* 2001015 */   GIM_Try, /*On fail goto*//*Label 26776*/ GIMT_Encode4(2001101), // Rule ID 62735 //
     /* 2001020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2001040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001066 */     // MIs[0] policy
     /* 2001066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001076 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M1_MASK),
     /* 2001079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001100 */     // GIR_Coverage, 62735,
     /* 2001100 */     GIR_EraseRootFromParent_Done,
     /* 2001101 */   // Label 26776: @2001101
     /* 2001101 */   GIM_Try, /*On fail goto*//*Label 26777*/ GIMT_Encode4(2001187), // Rule ID 62738 //
     /* 2001106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2001126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001152 */     // MIs[0] policy
     /* 2001152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M2_MASK),
     /* 2001165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001186 */     // GIR_Coverage, 62738,
     /* 2001186 */     GIR_EraseRootFromParent_Done,
     /* 2001187 */   // Label 26777: @2001187
     /* 2001187 */   GIM_Try, /*On fail goto*//*Label 26778*/ GIMT_Encode4(2001273), // Rule ID 62739 //
     /* 2001192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2001212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001238 */     // MIs[0] policy
     /* 2001238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M2_MASK),
     /* 2001251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001272 */     // GIR_Coverage, 62739,
     /* 2001272 */     GIR_EraseRootFromParent_Done,
     /* 2001273 */   // Label 26778: @2001273
     /* 2001273 */   GIM_Try, /*On fail goto*//*Label 26779*/ GIMT_Encode4(2001359), // Rule ID 62742 //
     /* 2001278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2001289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2001292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2001298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2001301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001324 */     // MIs[0] policy
     /* 2001324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M4_MASK),
     /* 2001337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001358 */     // GIR_Coverage, 62742,
     /* 2001358 */     GIR_EraseRootFromParent_Done,
     /* 2001359 */   // Label 26779: @2001359
     /* 2001359 */   GIM_Try, /*On fail goto*//*Label 26780*/ GIMT_Encode4(2001445), // Rule ID 62743 //
     /* 2001364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2001375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2001378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2001384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2001387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001410 */     // MIs[0] policy
     /* 2001410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001420 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M4_MASK),
     /* 2001423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001444 */     // GIR_Coverage, 62743,
     /* 2001444 */     GIR_EraseRootFromParent_Done,
     /* 2001445 */   // Label 26780: @2001445
     /* 2001445 */   GIM_Try, /*On fail goto*//*Label 26781*/ GIMT_Encode4(2001531), // Rule ID 62746 //
     /* 2001450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001496 */     // MIs[0] policy
     /* 2001496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001506 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M8_MASK),
     /* 2001509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001530 */     // GIR_Coverage, 62746,
     /* 2001530 */     GIR_EraseRootFromParent_Done,
     /* 2001531 */   // Label 26781: @2001531
     /* 2001531 */   GIM_Try, /*On fail goto*//*Label 26782*/ GIMT_Encode4(2001617), // Rule ID 62747 //
     /* 2001536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001582 */     // MIs[0] policy
     /* 2001582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001592 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M8_MASK),
     /* 2001595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001616 */     // GIR_Coverage, 62747,
     /* 2001616 */     GIR_EraseRootFromParent_Done,
     /* 2001617 */   // Label 26782: @2001617
     /* 2001617 */   GIM_Try, /*On fail goto*//*Label 26783*/ GIMT_Encode4(2001703), // Rule ID 65179 //
     /* 2001622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2001625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2001630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2001633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2001636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2001639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2001642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2001645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001668 */     // MIs[0] policy
     /* 2001668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001678 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2_MASK),
     /* 2001681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001702 */     // GIR_Coverage, 65179,
     /* 2001702 */     GIR_EraseRootFromParent_Done,
     /* 2001703 */   // Label 26783: @2001703
     /* 2001703 */   GIM_Try, /*On fail goto*//*Label 26784*/ GIMT_Encode4(2001789), // Rule ID 65180 //
     /* 2001708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2001711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2001716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2001719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2001722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2001725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2001728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2001731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001754 */     // MIs[0] policy
     /* 2001754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001764 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2_MASK),
     /* 2001767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001788 */     // GIR_Coverage, 65180,
     /* 2001788 */     GIR_EraseRootFromParent_Done,
     /* 2001789 */   // Label 26784: @2001789
     /* 2001789 */   GIM_Try, /*On fail goto*//*Label 26785*/ GIMT_Encode4(2001875), // Rule ID 65183 //
     /* 2001794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2001797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2001802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2001811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2001814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2001817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001840 */     // MIs[0] policy
     /* 2001840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001850 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2001853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001874 */     // GIR_Coverage, 65183,
     /* 2001874 */     GIR_EraseRootFromParent_Done,
     /* 2001875 */   // Label 26785: @2001875
     /* 2001875 */   GIM_Try, /*On fail goto*//*Label 26786*/ GIMT_Encode4(2001961), // Rule ID 65184 //
     /* 2001880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2001883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2001888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2001897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2001900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2001903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001926 */     // MIs[0] policy
     /* 2001926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001936 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2001939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001960 */     // GIR_Coverage, 65184,
     /* 2001960 */     GIR_EraseRootFromParent_Done,
     /* 2001961 */   // Label 26786: @2001961
     /* 2001961 */   GIM_Try, /*On fail goto*//*Label 26787*/ GIMT_Encode4(2002047), // Rule ID 65187 //
     /* 2001966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2001969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2001974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2001983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2001986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002012 */     // MIs[0] policy
     /* 2002012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002022 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2002025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002046 */     // GIR_Coverage, 65187,
     /* 2002046 */     GIR_EraseRootFromParent_Done,
     /* 2002047 */   // Label 26787: @2002047
     /* 2002047 */   GIM_Try, /*On fail goto*//*Label 26788*/ GIMT_Encode4(2002133), // Rule ID 65188 //
     /* 2002052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2002063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2002066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2002069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2002072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2002082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002098 */     // MIs[0] policy
     /* 2002098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002108 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2002111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002132 */     // GIR_Coverage, 65188,
     /* 2002132 */     GIR_EraseRootFromParent_Done,
     /* 2002133 */   // Label 26788: @2002133
     /* 2002133 */   GIM_Try, /*On fail goto*//*Label 26789*/ GIMT_Encode4(2002219), // Rule ID 65191 //
     /* 2002138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2002149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2002152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2002155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2002158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2002161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002184 */     // MIs[0] policy
     /* 2002184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002194 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2002197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002218 */     // GIR_Coverage, 65191,
     /* 2002218 */     GIR_EraseRootFromParent_Done,
     /* 2002219 */   // Label 26789: @2002219
     /* 2002219 */   GIM_Try, /*On fail goto*//*Label 26790*/ GIMT_Encode4(2002305), // Rule ID 65192 //
     /* 2002224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2002235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2002238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2002241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2002244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2002247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002270 */     // MIs[0] policy
     /* 2002270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002280 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2002283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002304 */     // GIR_Coverage, 65192,
     /* 2002304 */     GIR_EraseRootFromParent_Done,
     /* 2002305 */   // Label 26790: @2002305
     /* 2002305 */   GIM_Try, /*On fail goto*//*Label 26791*/ GIMT_Encode4(2002391), // Rule ID 65195 //
     /* 2002310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2002321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2002324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2002327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2002330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2002333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002356 */     // MIs[0] policy
     /* 2002356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002366 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2002369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002390 */     // GIR_Coverage, 65195,
     /* 2002390 */     GIR_EraseRootFromParent_Done,
     /* 2002391 */   // Label 26791: @2002391
     /* 2002391 */   GIM_Try, /*On fail goto*//*Label 26792*/ GIMT_Encode4(2002477), // Rule ID 65196 //
     /* 2002396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2002407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2002410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2002413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2002416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2002419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002442 */     // MIs[0] policy
     /* 2002442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002452 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2002455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002476 */     // GIR_Coverage, 65196,
     /* 2002476 */     GIR_EraseRootFromParent_Done,
     /* 2002477 */   // Label 26792: @2002477
     /* 2002477 */   GIM_Try, /*On fail goto*//*Label 26793*/ GIMT_Encode4(2002563), // Rule ID 65199 //
     /* 2002482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2002485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2002493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2002496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2002499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002528 */     // MIs[0] policy
     /* 2002528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002538 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2002541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002562 */     // GIR_Coverage, 65199,
     /* 2002562 */     GIR_EraseRootFromParent_Done,
     /* 2002563 */   // Label 26793: @2002563
     /* 2002563 */   GIM_Try, /*On fail goto*//*Label 26794*/ GIMT_Encode4(2002649), // Rule ID 65200 //
     /* 2002568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2002571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2002579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2002582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2002585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002614 */     // MIs[0] policy
     /* 2002614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002624 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2002627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002648 */     // GIR_Coverage, 65200,
     /* 2002648 */     GIR_EraseRootFromParent_Done,
     /* 2002649 */   // Label 26794: @2002649
     /* 2002649 */   GIM_Try, /*On fail goto*//*Label 26795*/ GIMT_Encode4(2002735), // Rule ID 65203 //
     /* 2002654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2002657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2002665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2002668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2002671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2002674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2002684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002700 */     // MIs[0] policy
     /* 2002700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2002713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002734 */     // GIR_Coverage, 65203,
     /* 2002734 */     GIR_EraseRootFromParent_Done,
     /* 2002735 */   // Label 26795: @2002735
     /* 2002735 */   GIM_Try, /*On fail goto*//*Label 26796*/ GIMT_Encode4(2002821), // Rule ID 65204 //
     /* 2002740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2002743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2002751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2002754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2002757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2002760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2002770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002786 */     // MIs[0] policy
     /* 2002786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002796 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2002799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002820 */     // GIR_Coverage, 65204,
     /* 2002820 */     GIR_EraseRootFromParent_Done,
     /* 2002821 */   // Label 26796: @2002821
     /* 2002821 */   GIM_Try, /*On fail goto*//*Label 26797*/ GIMT_Encode4(2002907), // Rule ID 65207 //
     /* 2002826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2002829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2002837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2002840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2002843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2002846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002872 */     // MIs[0] policy
     /* 2002872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002882 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2002885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002906 */     // GIR_Coverage, 65207,
     /* 2002906 */     GIR_EraseRootFromParent_Done,
     /* 2002907 */   // Label 26797: @2002907
     /* 2002907 */   GIM_Try, /*On fail goto*//*Label 26798*/ GIMT_Encode4(2002993), // Rule ID 65208 //
     /* 2002912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2002915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2002923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2002926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2002929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2002932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002958 */     // MIs[0] policy
     /* 2002958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002968 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2002971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002992 */     // GIR_Coverage, 65208,
     /* 2002992 */     GIR_EraseRootFromParent_Done,
     /* 2002993 */   // Label 26798: @2002993
     /* 2002993 */   GIM_Try, /*On fail goto*//*Label 26799*/ GIMT_Encode4(2003079), // Rule ID 65211 //
     /* 2002998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2003001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2003009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2003012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2003018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003044 */     // MIs[0] policy
     /* 2003044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003054 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2003057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003078 */     // GIR_Coverage, 65211,
     /* 2003078 */     GIR_EraseRootFromParent_Done,
     /* 2003079 */   // Label 26799: @2003079
     /* 2003079 */   GIM_Try, /*On fail goto*//*Label 26800*/ GIMT_Encode4(2003165), // Rule ID 65212 //
     /* 2003084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2003087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2003095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2003098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2003104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003130 */     // MIs[0] policy
     /* 2003130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003140 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2003143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003164 */     // GIR_Coverage, 65212,
     /* 2003164 */     GIR_EraseRootFromParent_Done,
     /* 2003165 */   // Label 26800: @2003165
     /* 2003165 */   GIM_Try, /*On fail goto*//*Label 26801*/ GIMT_Encode4(2003251), // Rule ID 65215 //
     /* 2003170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2003181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2003184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2003187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2003190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2003193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003216 */     // MIs[0] policy
     /* 2003216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003226 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2_MASK),
     /* 2003229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003250 */     // GIR_Coverage, 65215,
     /* 2003250 */     GIR_EraseRootFromParent_Done,
     /* 2003251 */   // Label 26801: @2003251
     /* 2003251 */   GIM_Try, /*On fail goto*//*Label 26802*/ GIMT_Encode4(2003337), // Rule ID 65216 //
     /* 2003256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2003267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2003270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2003273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2003276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2003279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003302 */     // MIs[0] policy
     /* 2003302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003312 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2_MASK),
     /* 2003315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003336 */     // GIR_Coverage, 65216,
     /* 2003336 */     GIR_EraseRootFromParent_Done,
     /* 2003337 */   // Label 26802: @2003337
     /* 2003337 */   GIM_Try, /*On fail goto*//*Label 26803*/ GIMT_Encode4(2003423), // Rule ID 65219 //
     /* 2003342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2003359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2003362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003388 */     // MIs[0] policy
     /* 2003388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003398 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2003401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003422 */     // GIR_Coverage, 65219,
     /* 2003422 */     GIR_EraseRootFromParent_Done,
     /* 2003423 */   // Label 26803: @2003423
     /* 2003423 */   GIM_Try, /*On fail goto*//*Label 26804*/ GIMT_Encode4(2003509), // Rule ID 65220 //
     /* 2003428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2003445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2003448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003474 */     // MIs[0] policy
     /* 2003474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2003487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003508 */     // GIR_Coverage, 65220,
     /* 2003508 */     GIR_EraseRootFromParent_Done,
     /* 2003509 */   // Label 26804: @2003509
     /* 2003509 */   GIM_Try, /*On fail goto*//*Label 26805*/ GIMT_Encode4(2003595), // Rule ID 65223 //
     /* 2003514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2003525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2003528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2003531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2003534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003560 */     // MIs[0] policy
     /* 2003560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2003573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003594 */     // GIR_Coverage, 65223,
     /* 2003594 */     GIR_EraseRootFromParent_Done,
     /* 2003595 */   // Label 26805: @2003595
     /* 2003595 */   GIM_Try, /*On fail goto*//*Label 26806*/ GIMT_Encode4(2003681), // Rule ID 65224 //
     /* 2003600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2003611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2003614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2003617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2003620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003646 */     // MIs[0] policy
     /* 2003646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2003659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003680 */     // GIR_Coverage, 65224,
     /* 2003680 */     GIR_EraseRootFromParent_Done,
     /* 2003681 */   // Label 26806: @2003681
     /* 2003681 */   GIM_Try, /*On fail goto*//*Label 26807*/ GIMT_Encode4(2003767), // Rule ID 65227 //
     /* 2003686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2003697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2003700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2003703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2003706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2003716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003732 */     // MIs[0] policy
     /* 2003732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003742 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2003745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003766 */     // GIR_Coverage, 65227,
     /* 2003766 */     GIR_EraseRootFromParent_Done,
     /* 2003767 */   // Label 26807: @2003767
     /* 2003767 */   GIM_Try, /*On fail goto*//*Label 26808*/ GIMT_Encode4(2003853), // Rule ID 65228 //
     /* 2003772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2003783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2003786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2003789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2003792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2003802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003818 */     // MIs[0] policy
     /* 2003818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003828 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2003831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003852 */     // GIR_Coverage, 65228,
     /* 2003852 */     GIR_EraseRootFromParent_Done,
     /* 2003853 */   // Label 26808: @2003853
     /* 2003853 */   GIM_Try, /*On fail goto*//*Label 26809*/ GIMT_Encode4(2003939), // Rule ID 65231 //
     /* 2003858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2003869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2003872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2003875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2003878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2003881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003904 */     // MIs[0] policy
     /* 2003904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2003917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003938 */     // GIR_Coverage, 65231,
     /* 2003938 */     GIR_EraseRootFromParent_Done,
     /* 2003939 */   // Label 26809: @2003939
     /* 2003939 */   GIM_Try, /*On fail goto*//*Label 26810*/ GIMT_Encode4(2004025), // Rule ID 65232 //
     /* 2003944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2003955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2003958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2003961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2003964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2003967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003990 */     // MIs[0] policy
     /* 2003990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004000 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2004003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004024 */     // GIR_Coverage, 65232,
     /* 2004024 */     GIR_EraseRootFromParent_Done,
     /* 2004025 */   // Label 26810: @2004025
     /* 2004025 */   GIM_Try, /*On fail goto*//*Label 26811*/ GIMT_Encode4(2004111), // Rule ID 65235 //
     /* 2004030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2004047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2004050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004076 */     // MIs[0] policy
     /* 2004076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2004089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004110 */     // GIR_Coverage, 65235,
     /* 2004110 */     GIR_EraseRootFromParent_Done,
     /* 2004111 */   // Label 26811: @2004111
     /* 2004111 */   GIM_Try, /*On fail goto*//*Label 26812*/ GIMT_Encode4(2004197), // Rule ID 65236 //
     /* 2004116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2004133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2004136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004162 */     // MIs[0] policy
     /* 2004162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004172 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2004175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004196 */     // GIR_Coverage, 65236,
     /* 2004196 */     GIR_EraseRootFromParent_Done,
     /* 2004197 */   // Label 26812: @2004197
     /* 2004197 */   GIM_Try, /*On fail goto*//*Label 26813*/ GIMT_Encode4(2004283), // Rule ID 65239 //
     /* 2004202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2004213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2004216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2004219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2004222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004248 */     // MIs[0] policy
     /* 2004248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2004261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004282 */     // GIR_Coverage, 65239,
     /* 2004282 */     GIR_EraseRootFromParent_Done,
     /* 2004283 */   // Label 26813: @2004283
     /* 2004283 */   GIM_Try, /*On fail goto*//*Label 26814*/ GIMT_Encode4(2004369), // Rule ID 65240 //
     /* 2004288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2004299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2004302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2004305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2004308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004334 */     // MIs[0] policy
     /* 2004334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004344 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2004347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004368 */     // GIR_Coverage, 65240,
     /* 2004368 */     GIR_EraseRootFromParent_Done,
     /* 2004369 */   // Label 26814: @2004369
     /* 2004369 */   GIM_Try, /*On fail goto*//*Label 26815*/ GIMT_Encode4(2004455), // Rule ID 65243 //
     /* 2004374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2004385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2004388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2004391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2004394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004420 */     // MIs[0] policy
     /* 2004420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004430 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2004433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004454 */     // GIR_Coverage, 65243,
     /* 2004454 */     GIR_EraseRootFromParent_Done,
     /* 2004455 */   // Label 26815: @2004455
     /* 2004455 */   GIM_Try, /*On fail goto*//*Label 26816*/ GIMT_Encode4(2004541), // Rule ID 65244 //
     /* 2004460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2004471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2004474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2004477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2004480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004506 */     // MIs[0] policy
     /* 2004506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004516 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2004519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004540 */     // GIR_Coverage, 65244,
     /* 2004540 */     GIR_EraseRootFromParent_Done,
     /* 2004541 */   // Label 26816: @2004541
     /* 2004541 */   GIM_Try, /*On fail goto*//*Label 26817*/ GIMT_Encode4(2004627), // Rule ID 65247 //
     /* 2004546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2004557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2004560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2004563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2004566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004592 */     // MIs[0] policy
     /* 2004592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2004605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004626 */     // GIR_Coverage, 65247,
     /* 2004626 */     GIR_EraseRootFromParent_Done,
     /* 2004627 */   // Label 26817: @2004627
     /* 2004627 */   GIM_Try, /*On fail goto*//*Label 26818*/ GIMT_Encode4(2004713), // Rule ID 65248 //
     /* 2004632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2004643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2004646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2004649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2004652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004678 */     // MIs[0] policy
     /* 2004678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004688 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2004691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004712 */     // GIR_Coverage, 65248,
     /* 2004712 */     GIR_EraseRootFromParent_Done,
     /* 2004713 */   // Label 26818: @2004713
     /* 2004713 */   GIM_Try, /*On fail goto*//*Label 26819*/ GIMT_Encode4(2004799), // Rule ID 65251 //
     /* 2004718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2004721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2004726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2004729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2004732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2004735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2004738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004764 */     // MIs[0] policy
     /* 2004764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004774 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2_MASK),
     /* 2004777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004798 */     // GIR_Coverage, 65251,
     /* 2004798 */     GIR_EraseRootFromParent_Done,
     /* 2004799 */   // Label 26819: @2004799
     /* 2004799 */   GIM_Try, /*On fail goto*//*Label 26820*/ GIMT_Encode4(2004885), // Rule ID 65252 //
     /* 2004804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2004807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2004812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2004815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2004818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2004821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2004824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004850 */     // MIs[0] policy
     /* 2004850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004860 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2_MASK),
     /* 2004863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004884 */     // GIR_Coverage, 65252,
     /* 2004884 */     GIR_EraseRootFromParent_Done,
     /* 2004885 */   // Label 26820: @2004885
     /* 2004885 */   GIM_Try, /*On fail goto*//*Label 26821*/ GIMT_Encode4(2004971), // Rule ID 65255 //
     /* 2004890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2004893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2004898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2004901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2004904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2004907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2004910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004936 */     // MIs[0] policy
     /* 2004936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2004949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004970 */     // GIR_Coverage, 65255,
     /* 2004970 */     GIR_EraseRootFromParent_Done,
     /* 2004971 */   // Label 26821: @2004971
     /* 2004971 */   GIM_Try, /*On fail goto*//*Label 26822*/ GIMT_Encode4(2005057), // Rule ID 65256 //
     /* 2004976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2004979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2004984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2004987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2004990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2004993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2004996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005022 */     // MIs[0] policy
     /* 2005022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005032 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2005035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005056 */     // GIR_Coverage, 65256,
     /* 2005056 */     GIR_EraseRootFromParent_Done,
     /* 2005057 */   // Label 26822: @2005057
     /* 2005057 */   GIM_Try, /*On fail goto*//*Label 26823*/ GIMT_Encode4(2005143), // Rule ID 65259 //
     /* 2005062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2005073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2005076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2005079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2005082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005108 */     // MIs[0] policy
     /* 2005108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2005121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005142 */     // GIR_Coverage, 65259,
     /* 2005142 */     GIR_EraseRootFromParent_Done,
     /* 2005143 */   // Label 26823: @2005143
     /* 2005143 */   GIM_Try, /*On fail goto*//*Label 26824*/ GIMT_Encode4(2005229), // Rule ID 65260 //
     /* 2005148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2005159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2005162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2005165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2005168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005194 */     // MIs[0] policy
     /* 2005194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005204 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2005207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005228 */     // GIR_Coverage, 65260,
     /* 2005228 */     GIR_EraseRootFromParent_Done,
     /* 2005229 */   // Label 26824: @2005229
     /* 2005229 */   GIM_Try, /*On fail goto*//*Label 26825*/ GIMT_Encode4(2005315), // Rule ID 65263 //
     /* 2005234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2005245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2005248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2005251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2005254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2005264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005280 */     // MIs[0] policy
     /* 2005280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005290 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2005293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005314 */     // GIR_Coverage, 65263,
     /* 2005314 */     GIR_EraseRootFromParent_Done,
     /* 2005315 */   // Label 26825: @2005315
     /* 2005315 */   GIM_Try, /*On fail goto*//*Label 26826*/ GIMT_Encode4(2005401), // Rule ID 65264 //
     /* 2005320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2005331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2005334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2005337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2005340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2005350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005366 */     // MIs[0] policy
     /* 2005366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005376 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2005379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005400 */     // GIR_Coverage, 65264,
     /* 2005400 */     GIR_EraseRootFromParent_Done,
     /* 2005401 */   // Label 26826: @2005401
     /* 2005401 */   GIM_Try, /*On fail goto*//*Label 26827*/ GIMT_Encode4(2005487), // Rule ID 65267 //
     /* 2005406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2005417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2005420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2005423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2005426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2005429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005452 */     // MIs[0] policy
     /* 2005452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005462 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2005465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005486 */     // GIR_Coverage, 65267,
     /* 2005486 */     GIR_EraseRootFromParent_Done,
     /* 2005487 */   // Label 26827: @2005487
     /* 2005487 */   GIM_Try, /*On fail goto*//*Label 26828*/ GIMT_Encode4(2005573), // Rule ID 65268 //
     /* 2005492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2005503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2005506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2005509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2005512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2005515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005538 */     // MIs[0] policy
     /* 2005538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005548 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2005551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005572 */     // GIR_Coverage, 65268,
     /* 2005572 */     GIR_EraseRootFromParent_Done,
     /* 2005573 */   // Label 26828: @2005573
     /* 2005573 */   GIM_Try, /*On fail goto*//*Label 26829*/ GIMT_Encode4(2005659), // Rule ID 65271 //
     /* 2005578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2005581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2005589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2005592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2005595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2005598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005624 */     // MIs[0] policy
     /* 2005624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005634 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2005637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005658 */     // GIR_Coverage, 65271,
     /* 2005658 */     GIR_EraseRootFromParent_Done,
     /* 2005659 */   // Label 26829: @2005659
     /* 2005659 */   GIM_Try, /*On fail goto*//*Label 26830*/ GIMT_Encode4(2005745), // Rule ID 65272 //
     /* 2005664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2005667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2005675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2005678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2005681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2005684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005710 */     // MIs[0] policy
     /* 2005710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005720 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2005723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005744 */     // GIR_Coverage, 65272,
     /* 2005744 */     GIR_EraseRootFromParent_Done,
     /* 2005745 */   // Label 26830: @2005745
     /* 2005745 */   GIM_Try, /*On fail goto*//*Label 26831*/ GIMT_Encode4(2005831), // Rule ID 65275 //
     /* 2005750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2005753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2005761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2005764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2005767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2005770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005796 */     // MIs[0] policy
     /* 2005796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005806 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2005809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005830 */     // GIR_Coverage, 65275,
     /* 2005830 */     GIR_EraseRootFromParent_Done,
     /* 2005831 */   // Label 26831: @2005831
     /* 2005831 */   GIM_Try, /*On fail goto*//*Label 26832*/ GIMT_Encode4(2005917), // Rule ID 65276 //
     /* 2005836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2005839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2005847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2005850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2005853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2005856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005882 */     // MIs[0] policy
     /* 2005882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2005895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005916 */     // GIR_Coverage, 65276,
     /* 2005916 */     GIR_EraseRootFromParent_Done,
     /* 2005917 */   // Label 26832: @2005917
     /* 2005917 */   GIM_Try, /*On fail goto*//*Label 26833*/ GIMT_Encode4(2006003), // Rule ID 65279 //
     /* 2005922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2005925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2005933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2005936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2005939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2005942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2005952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005968 */     // MIs[0] policy
     /* 2005968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005978 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2005981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006002 */     // GIR_Coverage, 65279,
     /* 2006002 */     GIR_EraseRootFromParent_Done,
     /* 2006003 */   // Label 26833: @2006003
     /* 2006003 */   GIM_Try, /*On fail goto*//*Label 26834*/ GIMT_Encode4(2006089), // Rule ID 65280 //
     /* 2006008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2006019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2006022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2006025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2006028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006054 */     // MIs[0] policy
     /* 2006054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2006067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006088 */     // GIR_Coverage, 65280,
     /* 2006088 */     GIR_EraseRootFromParent_Done,
     /* 2006089 */   // Label 26834: @2006089
     /* 2006089 */   GIM_Try, /*On fail goto*//*Label 26835*/ GIMT_Encode4(2006175), // Rule ID 65283 //
     /* 2006094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2006105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2006108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2006111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2006114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006140 */     // MIs[0] policy
     /* 2006140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006150 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2006153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006174 */     // GIR_Coverage, 65283,
     /* 2006174 */     GIR_EraseRootFromParent_Done,
     /* 2006175 */   // Label 26835: @2006175
     /* 2006175 */   GIM_Try, /*On fail goto*//*Label 26836*/ GIMT_Encode4(2006261), // Rule ID 65284 //
     /* 2006180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2006191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2006194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2006197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2006200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006226 */     // MIs[0] policy
     /* 2006226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006236 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2006239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006260 */     // GIR_Coverage, 65284,
     /* 2006260 */     GIR_EraseRootFromParent_Done,
     /* 2006261 */   // Label 26836: @2006261
     /* 2006261 */   GIM_Try, /*On fail goto*//*Label 26837*/ GIMT_Encode4(2006350), // Rule ID 2790 //
     /* 2006266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2006283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006312 */     // MIs[0] round
     /* 2006312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006322 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 2006325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006349 */     // GIR_Coverage, 2790,
     /* 2006349 */     GIR_EraseRootFromParent_Done,
     /* 2006350 */   // Label 26837: @2006350
     /* 2006350 */   GIM_Try, /*On fail goto*//*Label 26838*/ GIMT_Encode4(2006439), // Rule ID 2791 //
     /* 2006355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2006372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006401 */     // MIs[0] round
     /* 2006401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006411 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 2006414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006438 */     // GIR_Coverage, 2791,
     /* 2006438 */     GIR_EraseRootFromParent_Done,
     /* 2006439 */   // Label 26838: @2006439
     /* 2006439 */   GIM_Try, /*On fail goto*//*Label 26839*/ GIMT_Encode4(2006528), // Rule ID 22836 //
     /* 2006444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2006461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006490 */     // MIs[0] round
     /* 2006490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006500 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 2006503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006527 */     // GIR_Coverage, 22836,
     /* 2006527 */     GIR_EraseRootFromParent_Done,
     /* 2006528 */   // Label 26839: @2006528
     /* 2006528 */   GIM_Try, /*On fail goto*//*Label 26840*/ GIMT_Encode4(2006617), // Rule ID 22837 //
     /* 2006533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2006550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006579 */     // MIs[0] round
     /* 2006579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006589 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 2006592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006616 */     // GIR_Coverage, 22837,
     /* 2006616 */     GIR_EraseRootFromParent_Done,
     /* 2006617 */   // Label 26840: @2006617
     /* 2006617 */   GIM_Try, /*On fail goto*//*Label 26841*/ GIMT_Encode4(2006706), // Rule ID 22840 //
     /* 2006622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2006625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2006633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2006636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2006639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2006642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006668 */     // MIs[0] round
     /* 2006668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006678 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 2006681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006705 */     // GIR_Coverage, 22840,
     /* 2006705 */     GIR_EraseRootFromParent_Done,
     /* 2006706 */   // Label 26841: @2006706
     /* 2006706 */   GIM_Try, /*On fail goto*//*Label 26842*/ GIMT_Encode4(2006795), // Rule ID 22841 //
     /* 2006711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2006714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2006722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2006725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2006728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2006731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006757 */     // MIs[0] round
     /* 2006757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006767 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 2006770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006794 */     // GIR_Coverage, 22841,
     /* 2006794 */     GIR_EraseRootFromParent_Done,
     /* 2006795 */   // Label 26842: @2006795
     /* 2006795 */   GIM_Try, /*On fail goto*//*Label 26843*/ GIMT_Encode4(2006884), // Rule ID 22844 //
     /* 2006800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2006817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006846 */     // MIs[0] round
     /* 2006846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006856 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 2006859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006883 */     // GIR_Coverage, 22844,
     /* 2006883 */     GIR_EraseRootFromParent_Done,
     /* 2006884 */   // Label 26843: @2006884
     /* 2006884 */   GIM_Try, /*On fail goto*//*Label 26844*/ GIMT_Encode4(2006973), // Rule ID 22845 //
     /* 2006889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2006906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006935 */     // MIs[0] round
     /* 2006935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006945 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 2006948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006972 */     // GIR_Coverage, 22845,
     /* 2006972 */     GIR_EraseRootFromParent_Done,
     /* 2006973 */   // Label 26844: @2006973
     /* 2006973 */   GIM_Try, /*On fail goto*//*Label 26845*/ GIMT_Encode4(2007062), // Rule ID 22848 //
     /* 2006978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2006981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2006989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2006992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2006995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2006998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007024 */     // MIs[0] round
     /* 2007024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007034 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 2007037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007061 */     // GIR_Coverage, 22848,
     /* 2007061 */     GIR_EraseRootFromParent_Done,
     /* 2007062 */   // Label 26845: @2007062
     /* 2007062 */   GIM_Try, /*On fail goto*//*Label 26846*/ GIMT_Encode4(2007151), // Rule ID 22849 //
     /* 2007067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2007070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2007084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007113 */     // MIs[0] round
     /* 2007113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007123 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 2007126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007150 */     // GIR_Coverage, 22849,
     /* 2007150 */     GIR_EraseRootFromParent_Done,
     /* 2007151 */   // Label 26846: @2007151
     /* 2007151 */   GIM_Try, /*On fail goto*//*Label 26847*/ GIMT_Encode4(2007240), // Rule ID 22852 //
     /* 2007156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2007159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2007173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2007176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007202 */     // MIs[0] round
     /* 2007202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007212 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 2007215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007239 */     // GIR_Coverage, 22852,
     /* 2007239 */     GIR_EraseRootFromParent_Done,
     /* 2007240 */   // Label 26847: @2007240
     /* 2007240 */   GIM_Try, /*On fail goto*//*Label 26848*/ GIMT_Encode4(2007329), // Rule ID 22853 //
     /* 2007245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2007248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2007262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2007265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007291 */     // MIs[0] round
     /* 2007291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007301 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 2007304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007328 */     // GIR_Coverage, 22853,
     /* 2007328 */     GIR_EraseRootFromParent_Done,
     /* 2007329 */   // Label 26848: @2007329
     /* 2007329 */   GIM_Try, /*On fail goto*//*Label 26849*/ GIMT_Encode4(2007418), // Rule ID 22856 //
     /* 2007334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2007351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007380 */     // MIs[0] round
     /* 2007380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007390 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 2007393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007417 */     // GIR_Coverage, 22856,
     /* 2007417 */     GIR_EraseRootFromParent_Done,
     /* 2007418 */   // Label 26849: @2007418
     /* 2007418 */   GIM_Try, /*On fail goto*//*Label 26850*/ GIMT_Encode4(2007507), // Rule ID 22857 //
     /* 2007423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2007440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007469 */     // MIs[0] round
     /* 2007469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007479 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 2007482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007506 */     // GIR_Coverage, 22857,
     /* 2007506 */     GIR_EraseRootFromParent_Done,
     /* 2007507 */   // Label 26850: @2007507
     /* 2007507 */   GIM_Try, /*On fail goto*//*Label 26851*/ GIMT_Encode4(2007596), // Rule ID 22860 //
     /* 2007512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2007529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007558 */     // MIs[0] round
     /* 2007558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007568 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 2007571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007595 */     // GIR_Coverage, 22860,
     /* 2007595 */     GIR_EraseRootFromParent_Done,
     /* 2007596 */   // Label 26851: @2007596
     /* 2007596 */   GIM_Try, /*On fail goto*//*Label 26852*/ GIMT_Encode4(2007685), // Rule ID 22861 //
     /* 2007601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2007618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007647 */     // MIs[0] round
     /* 2007647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007657 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 2007660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007684 */     // GIR_Coverage, 22861,
     /* 2007684 */     GIR_EraseRootFromParent_Done,
     /* 2007685 */   // Label 26852: @2007685
     /* 2007685 */   GIM_Try, /*On fail goto*//*Label 26853*/ GIMT_Encode4(2007774), // Rule ID 22864 //
     /* 2007690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2007707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2007713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007736 */     // MIs[0] round
     /* 2007736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007746 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 2007749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007773 */     // GIR_Coverage, 22864,
     /* 2007773 */     GIR_EraseRootFromParent_Done,
     /* 2007774 */   // Label 26853: @2007774
     /* 2007774 */   GIM_Try, /*On fail goto*//*Label 26854*/ GIMT_Encode4(2007863), // Rule ID 22865 //
     /* 2007779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2007796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2007802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007825 */     // MIs[0] round
     /* 2007825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007835 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 2007838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007862 */     // GIR_Coverage, 22865,
     /* 2007862 */     GIR_EraseRootFromParent_Done,
     /* 2007863 */   // Label 26854: @2007863
     /* 2007863 */   GIM_Try, /*On fail goto*//*Label 26855*/ GIMT_Encode4(2007952), // Rule ID 22868 //
     /* 2007868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2007871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2007885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007914 */     // MIs[0] round
     /* 2007914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007924 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 2007927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007951 */     // GIR_Coverage, 22868,
     /* 2007951 */     GIR_EraseRootFromParent_Done,
     /* 2007952 */   // Label 26855: @2007952
     /* 2007952 */   GIM_Try, /*On fail goto*//*Label 26856*/ GIMT_Encode4(2008041), // Rule ID 22869 //
     /* 2007957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2007960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2007974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008003 */     // MIs[0] round
     /* 2008003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008013 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 2008016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008040 */     // GIR_Coverage, 22869,
     /* 2008040 */     GIR_EraseRootFromParent_Done,
     /* 2008041 */   // Label 26856: @2008041
     /* 2008041 */   GIM_Try, /*On fail goto*//*Label 26857*/ GIMT_Encode4(2008130), // Rule ID 22872 //
     /* 2008046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2008063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008092 */     // MIs[0] round
     /* 2008092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008102 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 2008105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008129 */     // GIR_Coverage, 22872,
     /* 2008129 */     GIR_EraseRootFromParent_Done,
     /* 2008130 */   // Label 26857: @2008130
     /* 2008130 */   GIM_Try, /*On fail goto*//*Label 26858*/ GIMT_Encode4(2008219), // Rule ID 22873 //
     /* 2008135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2008152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008181 */     // MIs[0] round
     /* 2008181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008191 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 2008194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008218 */     // GIR_Coverage, 22873,
     /* 2008218 */     GIR_EraseRootFromParent_Done,
     /* 2008219 */   // Label 26858: @2008219
     /* 2008219 */   GIM_Try, /*On fail goto*//*Label 26859*/ GIMT_Encode4(2008308), // Rule ID 22876 //
     /* 2008224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2008241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008270 */     // MIs[0] round
     /* 2008270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008280 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 2008283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008307 */     // GIR_Coverage, 22876,
     /* 2008307 */     GIR_EraseRootFromParent_Done,
     /* 2008308 */   // Label 26859: @2008308
     /* 2008308 */   GIM_Try, /*On fail goto*//*Label 26860*/ GIMT_Encode4(2008397), // Rule ID 22877 //
     /* 2008313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2008330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008359 */     // MIs[0] round
     /* 2008359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008369 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 2008372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008396 */     // GIR_Coverage, 22877,
     /* 2008396 */     GIR_EraseRootFromParent_Done,
     /* 2008397 */   // Label 26860: @2008397
     /* 2008397 */   GIM_Try, /*On fail goto*//*Label 26861*/ GIMT_Encode4(2008486), // Rule ID 22880 //
     /* 2008402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2008405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2008419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008448 */     // MIs[0] round
     /* 2008448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008458 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 2008461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008485 */     // GIR_Coverage, 22880,
     /* 2008485 */     GIR_EraseRootFromParent_Done,
     /* 2008486 */   // Label 26861: @2008486
     /* 2008486 */   GIM_Try, /*On fail goto*//*Label 26862*/ GIMT_Encode4(2008575), // Rule ID 22881 //
     /* 2008491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2008494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2008508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008537 */     // MIs[0] round
     /* 2008537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008547 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 2008550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008574 */     // GIR_Coverage, 22881,
     /* 2008574 */     GIR_EraseRootFromParent_Done,
     /* 2008575 */   // Label 26862: @2008575
     /* 2008575 */   GIM_Try, /*On fail goto*//*Label 26863*/ GIMT_Encode4(2008664), // Rule ID 22884 //
     /* 2008580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2008583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2008597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008626 */     // MIs[0] round
     /* 2008626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008636 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 2008639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008663 */     // GIR_Coverage, 22884,
     /* 2008663 */     GIR_EraseRootFromParent_Done,
     /* 2008664 */   // Label 26863: @2008664
     /* 2008664 */   GIM_Try, /*On fail goto*//*Label 26864*/ GIMT_Encode4(2008753), // Rule ID 22885 //
     /* 2008669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2008672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2008686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008715 */     // MIs[0] round
     /* 2008715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008725 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 2008728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008752 */     // GIR_Coverage, 22885,
     /* 2008752 */     GIR_EraseRootFromParent_Done,
     /* 2008753 */   // Label 26864: @2008753
     /* 2008753 */   GIM_Try, /*On fail goto*//*Label 26865*/ GIMT_Encode4(2008842), // Rule ID 22888 //
     /* 2008758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2008761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2008775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008804 */     // MIs[0] round
     /* 2008804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008814 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 2008817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008841 */     // GIR_Coverage, 22888,
     /* 2008841 */     GIR_EraseRootFromParent_Done,
     /* 2008842 */   // Label 26865: @2008842
     /* 2008842 */   GIM_Try, /*On fail goto*//*Label 26866*/ GIMT_Encode4(2008931), // Rule ID 22889 //
     /* 2008847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2008850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2008864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008893 */     // MIs[0] round
     /* 2008893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008903 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 2008906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008930 */     // GIR_Coverage, 22889,
     /* 2008930 */     GIR_EraseRootFromParent_Done,
     /* 2008931 */   // Label 26866: @2008931
     /* 2008931 */   GIM_Try, /*On fail goto*//*Label 26867*/ GIMT_Encode4(2009020), // Rule ID 22892 //
     /* 2008936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2008939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2008944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2008947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2008950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2008953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2008956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2008959 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008982 */     // MIs[0] round
     /* 2008982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008992 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 2008995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009019 */     // GIR_Coverage, 22892,
     /* 2009019 */     GIR_EraseRootFromParent_Done,
     /* 2009020 */   // Label 26867: @2009020
     /* 2009020 */   GIM_Try, /*On fail goto*//*Label 26868*/ GIMT_Encode4(2009109), // Rule ID 22893 //
     /* 2009025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2009028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2009042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009071 */     // MIs[0] round
     /* 2009071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009081 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 2009084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009108 */     // GIR_Coverage, 22893,
     /* 2009108 */     GIR_EraseRootFromParent_Done,
     /* 2009109 */   // Label 26868: @2009109
     /* 2009109 */   GIM_Try, /*On fail goto*//*Label 26869*/ GIMT_Encode4(2009198), // Rule ID 22896 //
     /* 2009114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2009117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2009131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009160 */     // MIs[0] round
     /* 2009160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009170 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 2009173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009197 */     // GIR_Coverage, 22896,
     /* 2009197 */     GIR_EraseRootFromParent_Done,
     /* 2009198 */   // Label 26869: @2009198
     /* 2009198 */   GIM_Try, /*On fail goto*//*Label 26870*/ GIMT_Encode4(2009287), // Rule ID 22897 //
     /* 2009203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2009206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2009220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009249 */     // MIs[0] round
     /* 2009249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009259 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 2009262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009286 */     // GIR_Coverage, 22897,
     /* 2009286 */     GIR_EraseRootFromParent_Done,
     /* 2009287 */   // Label 26870: @2009287
     /* 2009287 */   GIM_Try, /*On fail goto*//*Label 26871*/ GIMT_Encode4(2009376), // Rule ID 22900 //
     /* 2009292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2009295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2009303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2009306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2009309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2009312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009338 */     // MIs[0] round
     /* 2009338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009348 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 2009351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009375 */     // GIR_Coverage, 22900,
     /* 2009375 */     GIR_EraseRootFromParent_Done,
     /* 2009376 */   // Label 26871: @2009376
     /* 2009376 */   GIM_Try, /*On fail goto*//*Label 26872*/ GIMT_Encode4(2009465), // Rule ID 22901 //
     /* 2009381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2009384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2009392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2009395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2009398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2009401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009427 */     // MIs[0] round
     /* 2009427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009437 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 2009440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009464 */     // GIR_Coverage, 22901,
     /* 2009464 */     GIR_EraseRootFromParent_Done,
     /* 2009465 */   // Label 26872: @2009465
     /* 2009465 */   GIM_Try, /*On fail goto*//*Label 26873*/ GIMT_Encode4(2009554), // Rule ID 22904 //
     /* 2009470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2009473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2009487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009516 */     // MIs[0] round
     /* 2009516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009526 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 2009529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009553 */     // GIR_Coverage, 22904,
     /* 2009553 */     GIR_EraseRootFromParent_Done,
     /* 2009554 */   // Label 26873: @2009554
     /* 2009554 */   GIM_Try, /*On fail goto*//*Label 26874*/ GIMT_Encode4(2009643), // Rule ID 22905 //
     /* 2009559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2009562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2009576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009605 */     // MIs[0] round
     /* 2009605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009615 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 2009618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009642 */     // GIR_Coverage, 22905,
     /* 2009642 */     GIR_EraseRootFromParent_Done,
     /* 2009643 */   // Label 26874: @2009643
     /* 2009643 */   GIM_Try, /*On fail goto*//*Label 26875*/ GIMT_Encode4(2009732), // Rule ID 22908 //
     /* 2009648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2009651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2009659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2009662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2009665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2009668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009694 */     // MIs[0] round
     /* 2009694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009704 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 2009707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009731 */     // GIR_Coverage, 22908,
     /* 2009731 */     GIR_EraseRootFromParent_Done,
     /* 2009732 */   // Label 26875: @2009732
     /* 2009732 */   GIM_Try, /*On fail goto*//*Label 26876*/ GIMT_Encode4(2009821), // Rule ID 22909 //
     /* 2009737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2009740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2009748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2009751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2009754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2009757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009783 */     // MIs[0] round
     /* 2009783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009793 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 2009796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009820 */     // GIR_Coverage, 22909,
     /* 2009820 */     GIR_EraseRootFromParent_Done,
     /* 2009821 */   // Label 26876: @2009821
     /* 2009821 */   GIM_Try, /*On fail goto*//*Label 26877*/ GIMT_Encode4(2009910), // Rule ID 22912 //
     /* 2009826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2009829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2009843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2009846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009872 */     // MIs[0] round
     /* 2009872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009882 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 2009885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009909 */     // GIR_Coverage, 22912,
     /* 2009909 */     GIR_EraseRootFromParent_Done,
     /* 2009910 */   // Label 26877: @2009910
     /* 2009910 */   GIM_Try, /*On fail goto*//*Label 26878*/ GIMT_Encode4(2009999), // Rule ID 22913 //
     /* 2009915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2009918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2009932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2009935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009961 */     // MIs[0] round
     /* 2009961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009971 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 2009974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009998 */     // GIR_Coverage, 22913,
     /* 2009998 */     GIR_EraseRootFromParent_Done,
     /* 2009999 */   // Label 26878: @2009999
     /* 2009999 */   GIM_Try, /*On fail goto*//*Label 26879*/ GIMT_Encode4(2010088), // Rule ID 22916 //
     /* 2010004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2010021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010050 */     // MIs[0] round
     /* 2010050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010060 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 2010063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010087 */     // GIR_Coverage, 22916,
     /* 2010087 */     GIR_EraseRootFromParent_Done,
     /* 2010088 */   // Label 26879: @2010088
     /* 2010088 */   GIM_Try, /*On fail goto*//*Label 26880*/ GIMT_Encode4(2010177), // Rule ID 22917 //
     /* 2010093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2010110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010139 */     // MIs[0] round
     /* 2010139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010149 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 2010152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010176 */     // GIR_Coverage, 22917,
     /* 2010176 */     GIR_EraseRootFromParent_Done,
     /* 2010177 */   // Label 26880: @2010177
     /* 2010177 */   GIM_Try, /*On fail goto*//*Label 26881*/ GIMT_Encode4(2010266), // Rule ID 22920 //
     /* 2010182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2010199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010228 */     // MIs[0] round
     /* 2010228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010238 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 2010241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010265 */     // GIR_Coverage, 22920,
     /* 2010265 */     GIR_EraseRootFromParent_Done,
     /* 2010266 */   // Label 26881: @2010266
     /* 2010266 */   GIM_Try, /*On fail goto*//*Label 26882*/ GIMT_Encode4(2010355), // Rule ID 22921 //
     /* 2010271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2010288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010317 */     // MIs[0] round
     /* 2010317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010327 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 2010330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010354 */     // GIR_Coverage, 22921,
     /* 2010354 */     GIR_EraseRootFromParent_Done,
     /* 2010355 */   // Label 26882: @2010355
     /* 2010355 */   GIM_Try, /*On fail goto*//*Label 26883*/ GIMT_Encode4(2010444), // Rule ID 22924 //
     /* 2010360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2010377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2010383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010406 */     // MIs[0] round
     /* 2010406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010416 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 2010419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010443 */     // GIR_Coverage, 22924,
     /* 2010443 */     GIR_EraseRootFromParent_Done,
     /* 2010444 */   // Label 26883: @2010444
     /* 2010444 */   GIM_Try, /*On fail goto*//*Label 26884*/ GIMT_Encode4(2010533), // Rule ID 22925 //
     /* 2010449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2010466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2010472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010495 */     // MIs[0] round
     /* 2010495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010505 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 2010508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010532 */     // GIR_Coverage, 22925,
     /* 2010532 */     GIR_EraseRootFromParent_Done,
     /* 2010533 */   // Label 26884: @2010533
     /* 2010533 */   GIM_Try, /*On fail goto*//*Label 26885*/ GIMT_Encode4(2010622), // Rule ID 22928 //
     /* 2010538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2010541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2010555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010584 */     // MIs[0] round
     /* 2010584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010594 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 2010597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010621 */     // GIR_Coverage, 22928,
     /* 2010621 */     GIR_EraseRootFromParent_Done,
     /* 2010622 */   // Label 26885: @2010622
     /* 2010622 */   GIM_Try, /*On fail goto*//*Label 26886*/ GIMT_Encode4(2010711), // Rule ID 22929 //
     /* 2010627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2010630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2010644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010673 */     // MIs[0] round
     /* 2010673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010683 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 2010686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010710 */     // GIR_Coverage, 22929,
     /* 2010710 */     GIR_EraseRootFromParent_Done,
     /* 2010711 */   // Label 26886: @2010711
     /* 2010711 */   GIM_Try, /*On fail goto*//*Label 26887*/ GIMT_Encode4(2010800), // Rule ID 22932 //
     /* 2010716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2010719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2010733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010762 */     // MIs[0] round
     /* 2010762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010772 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 2010775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010799 */     // GIR_Coverage, 22932,
     /* 2010799 */     GIR_EraseRootFromParent_Done,
     /* 2010800 */   // Label 26887: @2010800
     /* 2010800 */   GIM_Try, /*On fail goto*//*Label 26888*/ GIMT_Encode4(2010889), // Rule ID 22933 //
     /* 2010805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2010808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2010822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010851 */     // MIs[0] round
     /* 2010851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010861 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 2010864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010888 */     // GIR_Coverage, 22933,
     /* 2010888 */     GIR_EraseRootFromParent_Done,
     /* 2010889 */   // Label 26888: @2010889
     /* 2010889 */   GIM_Try, /*On fail goto*//*Label 26889*/ GIMT_Encode4(2010978), // Rule ID 22936 //
     /* 2010894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2010897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2010911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010940 */     // MIs[0] round
     /* 2010940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010950 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 2010953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010977 */     // GIR_Coverage, 22936,
     /* 2010977 */     GIR_EraseRootFromParent_Done,
     /* 2010978 */   // Label 26889: @2010978
     /* 2010978 */   GIM_Try, /*On fail goto*//*Label 26890*/ GIMT_Encode4(2011067), // Rule ID 22937 //
     /* 2010983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2010986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2011000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2011006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011029 */     // MIs[0] round
     /* 2011029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011039 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 2011042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011066 */     // GIR_Coverage, 22937,
     /* 2011066 */     GIR_EraseRootFromParent_Done,
     /* 2011067 */   // Label 26890: @2011067
     /* 2011067 */   GIM_Try, /*On fail goto*//*Label 26891*/ GIMT_Encode4(2011156), // Rule ID 22940 //
     /* 2011072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2011075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2011089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011118 */     // MIs[0] round
     /* 2011118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011128 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 2011131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011155 */     // GIR_Coverage, 22940,
     /* 2011155 */     GIR_EraseRootFromParent_Done,
     /* 2011156 */   // Label 26891: @2011156
     /* 2011156 */   GIM_Try, /*On fail goto*//*Label 26892*/ GIMT_Encode4(2011245), // Rule ID 22941 //
     /* 2011161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2011164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2011178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011207 */     // MIs[0] round
     /* 2011207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011217 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 2011220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011244 */     // GIR_Coverage, 22941,
     /* 2011244 */     GIR_EraseRootFromParent_Done,
     /* 2011245 */   // Label 26892: @2011245
     /* 2011245 */   GIM_Try, /*On fail goto*//*Label 26893*/ GIMT_Encode4(2011334), // Rule ID 22944 //
     /* 2011250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2011253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2011267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011296 */     // MIs[0] round
     /* 2011296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011306 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2011309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011333 */     // GIR_Coverage, 22944,
     /* 2011333 */     GIR_EraseRootFromParent_Done,
     /* 2011334 */   // Label 26893: @2011334
     /* 2011334 */   GIM_Try, /*On fail goto*//*Label 26894*/ GIMT_Encode4(2011423), // Rule ID 22945 //
     /* 2011339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2011342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2011356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011385 */     // MIs[0] round
     /* 2011385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011395 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2011398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011422 */     // GIR_Coverage, 22945,
     /* 2011422 */     GIR_EraseRootFromParent_Done,
     /* 2011423 */   // Label 26894: @2011423
     /* 2011423 */   GIM_Try, /*On fail goto*//*Label 26895*/ GIMT_Encode4(2011512), // Rule ID 22948 //
     /* 2011428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2011431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2011445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011474 */     // MIs[0] round
     /* 2011474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011484 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2011487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011511 */     // GIR_Coverage, 22948,
     /* 2011511 */     GIR_EraseRootFromParent_Done,
     /* 2011512 */   // Label 26895: @2011512
     /* 2011512 */   GIM_Try, /*On fail goto*//*Label 26896*/ GIMT_Encode4(2011601), // Rule ID 22949 //
     /* 2011517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2011520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2011534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011563 */     // MIs[0] round
     /* 2011563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011573 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2011576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011600 */     // GIR_Coverage, 22949,
     /* 2011600 */     GIR_EraseRootFromParent_Done,
     /* 2011601 */   // Label 26896: @2011601
     /* 2011601 */   GIM_Try, /*On fail goto*//*Label 26897*/ GIMT_Encode4(2011690), // Rule ID 23072 //
     /* 2011606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2011609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2011614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2011623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2011629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011652 */     // MIs[0] round
     /* 2011652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011662 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2011665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011689 */     // GIR_Coverage, 23072,
     /* 2011689 */     GIR_EraseRootFromParent_Done,
     /* 2011690 */   // Label 26897: @2011690
     /* 2011690 */   GIM_Try, /*On fail goto*//*Label 26898*/ GIMT_Encode4(2011779), // Rule ID 23073 //
     /* 2011695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2011698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2011703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2011712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2011718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011741 */     // MIs[0] round
     /* 2011741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011751 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2011754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011778 */     // GIR_Coverage, 23073,
     /* 2011778 */     GIR_EraseRootFromParent_Done,
     /* 2011779 */   // Label 26898: @2011779
     /* 2011779 */   GIM_Try, /*On fail goto*//*Label 26899*/ GIMT_Encode4(2011868), // Rule ID 23076 //
     /* 2011784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2011787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2011792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2011801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011830 */     // MIs[0] round
     /* 2011830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011840 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2011843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011867 */     // GIR_Coverage, 23076,
     /* 2011867 */     GIR_EraseRootFromParent_Done,
     /* 2011868 */   // Label 26899: @2011868
     /* 2011868 */   GIM_Try, /*On fail goto*//*Label 26900*/ GIMT_Encode4(2011957), // Rule ID 23077 //
     /* 2011873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2011876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2011881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2011890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011919 */     // MIs[0] round
     /* 2011919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011929 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2011932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011956 */     // GIR_Coverage, 23077,
     /* 2011956 */     GIR_EraseRootFromParent_Done,
     /* 2011957 */   // Label 26900: @2011957
     /* 2011957 */   GIM_Try, /*On fail goto*//*Label 26901*/ GIMT_Encode4(2012046), // Rule ID 23080 //
     /* 2011962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2011965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2011970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2011979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2011985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012008 */     // MIs[0] round
     /* 2012008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012018 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2012021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012045 */     // GIR_Coverage, 23080,
     /* 2012045 */     GIR_EraseRootFromParent_Done,
     /* 2012046 */   // Label 26901: @2012046
     /* 2012046 */   GIM_Try, /*On fail goto*//*Label 26902*/ GIMT_Encode4(2012135), // Rule ID 23081 //
     /* 2012051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2012054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2012068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012097 */     // MIs[0] round
     /* 2012097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012107 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2012110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012134 */     // GIR_Coverage, 23081,
     /* 2012134 */     GIR_EraseRootFromParent_Done,
     /* 2012135 */   // Label 26902: @2012135
     /* 2012135 */   GIM_Try, /*On fail goto*//*Label 26903*/ GIMT_Encode4(2012224), // Rule ID 23084 //
     /* 2012140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2012157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012186 */     // MIs[0] round
     /* 2012186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012196 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2012199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012223 */     // GIR_Coverage, 23084,
     /* 2012223 */     GIR_EraseRootFromParent_Done,
     /* 2012224 */   // Label 26903: @2012224
     /* 2012224 */   GIM_Try, /*On fail goto*//*Label 26904*/ GIMT_Encode4(2012313), // Rule ID 23085 //
     /* 2012229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2012246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012275 */     // MIs[0] round
     /* 2012275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012285 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2012288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012312 */     // GIR_Coverage, 23085,
     /* 2012312 */     GIR_EraseRootFromParent_Done,
     /* 2012313 */   // Label 26904: @2012313
     /* 2012313 */   GIM_Try, /*On fail goto*//*Label 26905*/ GIMT_Encode4(2012402), // Rule ID 23088 //
     /* 2012318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2012321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2012335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012364 */     // MIs[0] round
     /* 2012364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012374 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2012377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012401 */     // GIR_Coverage, 23088,
     /* 2012401 */     GIR_EraseRootFromParent_Done,
     /* 2012402 */   // Label 26905: @2012402
     /* 2012402 */   GIM_Try, /*On fail goto*//*Label 26906*/ GIMT_Encode4(2012491), // Rule ID 23089 //
     /* 2012407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2012410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2012424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012453 */     // MIs[0] round
     /* 2012453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012463 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2012466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012490 */     // GIR_Coverage, 23089,
     /* 2012490 */     GIR_EraseRootFromParent_Done,
     /* 2012491 */   // Label 26906: @2012491
     /* 2012491 */   GIM_Try, /*On fail goto*//*Label 26907*/ GIMT_Encode4(2012580), // Rule ID 23092 //
     /* 2012496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2012513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012542 */     // MIs[0] round
     /* 2012542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012552 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2012555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012579 */     // GIR_Coverage, 23092,
     /* 2012579 */     GIR_EraseRootFromParent_Done,
     /* 2012580 */   // Label 26907: @2012580
     /* 2012580 */   GIM_Try, /*On fail goto*//*Label 26908*/ GIMT_Encode4(2012669), // Rule ID 23093 //
     /* 2012585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2012602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012631 */     // MIs[0] round
     /* 2012631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012641 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2012644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012668 */     // GIR_Coverage, 23093,
     /* 2012668 */     GIR_EraseRootFromParent_Done,
     /* 2012669 */   // Label 26908: @2012669
     /* 2012669 */   GIM_Try, /*On fail goto*//*Label 26909*/ GIMT_Encode4(2012758), // Rule ID 23096 //
     /* 2012674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2012691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2012697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012720 */     // MIs[0] round
     /* 2012720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012730 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2012733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012757 */     // GIR_Coverage, 23096,
     /* 2012757 */     GIR_EraseRootFromParent_Done,
     /* 2012758 */   // Label 26909: @2012758
     /* 2012758 */   GIM_Try, /*On fail goto*//*Label 26910*/ GIMT_Encode4(2012847), // Rule ID 23097 //
     /* 2012763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2012780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2012786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012809 */     // MIs[0] round
     /* 2012809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012819 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2012822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012846 */     // GIR_Coverage, 23097,
     /* 2012846 */     GIR_EraseRootFromParent_Done,
     /* 2012847 */   // Label 26910: @2012847
     /* 2012847 */   GIM_Try, /*On fail goto*//*Label 26911*/ GIMT_Encode4(2012936), // Rule ID 23100 //
     /* 2012852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2012869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2012875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012898 */     // MIs[0] round
     /* 2012898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012908 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2012911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012935 */     // GIR_Coverage, 23100,
     /* 2012935 */     GIR_EraseRootFromParent_Done,
     /* 2012936 */   // Label 26911: @2012936
     /* 2012936 */   GIM_Try, /*On fail goto*//*Label 26912*/ GIMT_Encode4(2013025), // Rule ID 23101 //
     /* 2012941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2012958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2012964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012987 */     // MIs[0] round
     /* 2012987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012997 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2013000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013024 */     // GIR_Coverage, 23101,
     /* 2013024 */     GIR_EraseRootFromParent_Done,
     /* 2013025 */   // Label 26912: @2013025
     /* 2013025 */   GIM_Try, /*On fail goto*//*Label 26913*/ GIMT_Encode4(2013114), // Rule ID 23104 //
     /* 2013030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2013047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013076 */     // MIs[0] round
     /* 2013076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013086 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2013089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013113 */     // GIR_Coverage, 23104,
     /* 2013113 */     GIR_EraseRootFromParent_Done,
     /* 2013114 */   // Label 26913: @2013114
     /* 2013114 */   GIM_Try, /*On fail goto*//*Label 26914*/ GIMT_Encode4(2013203), // Rule ID 23105 //
     /* 2013119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2013136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013165 */     // MIs[0] round
     /* 2013165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013175 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2013178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013202 */     // GIR_Coverage, 23105,
     /* 2013202 */     GIR_EraseRootFromParent_Done,
     /* 2013203 */   // Label 26914: @2013203
     /* 2013203 */   GIM_Try, /*On fail goto*//*Label 26915*/ GIMT_Encode4(2013292), // Rule ID 23108 //
     /* 2013208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2013225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013254 */     // MIs[0] round
     /* 2013254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013264 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2013267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013291 */     // GIR_Coverage, 23108,
     /* 2013291 */     GIR_EraseRootFromParent_Done,
     /* 2013292 */   // Label 26915: @2013292
     /* 2013292 */   GIM_Try, /*On fail goto*//*Label 26916*/ GIMT_Encode4(2013381), // Rule ID 23109 //
     /* 2013297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2013314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013343 */     // MIs[0] round
     /* 2013343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013353 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2013356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013380 */     // GIR_Coverage, 23109,
     /* 2013380 */     GIR_EraseRootFromParent_Done,
     /* 2013381 */   // Label 26916: @2013381
     /* 2013381 */   GIM_Try, /*On fail goto*//*Label 26917*/ GIMT_Encode4(2013470), // Rule ID 23112 //
     /* 2013386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2013403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2013409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013432 */     // MIs[0] round
     /* 2013432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013442 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2013445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013469 */     // GIR_Coverage, 23112,
     /* 2013469 */     GIR_EraseRootFromParent_Done,
     /* 2013470 */   // Label 26917: @2013470
     /* 2013470 */   GIM_Try, /*On fail goto*//*Label 26918*/ GIMT_Encode4(2013559), // Rule ID 23113 //
     /* 2013475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2013492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2013498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013521 */     // MIs[0] round
     /* 2013521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013531 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2013534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013558 */     // GIR_Coverage, 23113,
     /* 2013558 */     GIR_EraseRootFromParent_Done,
     /* 2013559 */   // Label 26918: @2013559
     /* 2013559 */   GIM_Try, /*On fail goto*//*Label 26919*/ GIMT_Encode4(2013648), // Rule ID 23116 //
     /* 2013564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2013567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2013572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2013581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013610 */     // MIs[0] round
     /* 2013610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013620 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2013623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013647 */     // GIR_Coverage, 23116,
     /* 2013647 */     GIR_EraseRootFromParent_Done,
     /* 2013648 */   // Label 26919: @2013648
     /* 2013648 */   GIM_Try, /*On fail goto*//*Label 26920*/ GIMT_Encode4(2013737), // Rule ID 23117 //
     /* 2013653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2013656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2013661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2013670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013699 */     // MIs[0] round
     /* 2013699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013709 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2013712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013736 */     // GIR_Coverage, 23117,
     /* 2013736 */     GIR_EraseRootFromParent_Done,
     /* 2013737 */   // Label 26920: @2013737
     /* 2013737 */   GIM_Try, /*On fail goto*//*Label 26921*/ GIMT_Encode4(2013826), // Rule ID 23120 //
     /* 2013742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2013745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2013750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2013759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013788 */     // MIs[0] round
     /* 2013788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013798 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2013801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013825 */     // GIR_Coverage, 23120,
     /* 2013825 */     GIR_EraseRootFromParent_Done,
     /* 2013826 */   // Label 26921: @2013826
     /* 2013826 */   GIM_Try, /*On fail goto*//*Label 26922*/ GIMT_Encode4(2013915), // Rule ID 23121 //
     /* 2013831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2013834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2013839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2013848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013877 */     // MIs[0] round
     /* 2013877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013887 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2013890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013914 */     // GIR_Coverage, 23121,
     /* 2013914 */     GIR_EraseRootFromParent_Done,
     /* 2013915 */   // Label 26922: @2013915
     /* 2013915 */   GIM_Try, /*On fail goto*//*Label 26923*/ GIMT_Encode4(2014004), // Rule ID 23124 //
     /* 2013920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2013928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2013937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013966 */     // MIs[0] round
     /* 2013966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013976 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2013979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014003 */     // GIR_Coverage, 23124,
     /* 2014003 */     GIR_EraseRootFromParent_Done,
     /* 2014004 */   // Label 26923: @2014004
     /* 2014004 */   GIM_Try, /*On fail goto*//*Label 26924*/ GIMT_Encode4(2014093), // Rule ID 23125 //
     /* 2014009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2014012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2014026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014055 */     // MIs[0] round
     /* 2014055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014065 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2014068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014092 */     // GIR_Coverage, 23125,
     /* 2014092 */     GIR_EraseRootFromParent_Done,
     /* 2014093 */   // Label 26924: @2014093
     /* 2014093 */   GIM_Try, /*On fail goto*//*Label 26925*/ GIMT_Encode4(2014182), // Rule ID 23128 //
     /* 2014098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2014115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014144 */     // MIs[0] round
     /* 2014144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014154 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2014157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014181 */     // GIR_Coverage, 23128,
     /* 2014181 */     GIR_EraseRootFromParent_Done,
     /* 2014182 */   // Label 26925: @2014182
     /* 2014182 */   GIM_Try, /*On fail goto*//*Label 26926*/ GIMT_Encode4(2014271), // Rule ID 23129 //
     /* 2014187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2014204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014233 */     // MIs[0] round
     /* 2014233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014243 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2014246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014270 */     // GIR_Coverage, 23129,
     /* 2014270 */     GIR_EraseRootFromParent_Done,
     /* 2014271 */   // Label 26926: @2014271
     /* 2014271 */   GIM_Try, /*On fail goto*//*Label 26927*/ GIMT_Encode4(2014360), // Rule ID 23132 //
     /* 2014276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2014279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014322 */     // MIs[0] round
     /* 2014322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014332 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2014335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014359 */     // GIR_Coverage, 23132,
     /* 2014359 */     GIR_EraseRootFromParent_Done,
     /* 2014360 */   // Label 26927: @2014360
     /* 2014360 */   GIM_Try, /*On fail goto*//*Label 26928*/ GIMT_Encode4(2014449), // Rule ID 23133 //
     /* 2014365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2014368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014411 */     // MIs[0] round
     /* 2014411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014421 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2014424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014448 */     // GIR_Coverage, 23133,
     /* 2014448 */     GIR_EraseRootFromParent_Done,
     /* 2014449 */   // Label 26928: @2014449
     /* 2014449 */   GIM_Try, /*On fail goto*//*Label 26929*/ GIMT_Encode4(2014538), // Rule ID 23136 //
     /* 2014454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2014471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2014477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014500 */     // MIs[0] round
     /* 2014500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014510 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2014513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014537 */     // GIR_Coverage, 23136,
     /* 2014537 */     GIR_EraseRootFromParent_Done,
     /* 2014538 */   // Label 26929: @2014538
     /* 2014538 */   GIM_Try, /*On fail goto*//*Label 26930*/ GIMT_Encode4(2014627), // Rule ID 23137 //
     /* 2014543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2014560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2014566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014589 */     // MIs[0] round
     /* 2014589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014599 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2014602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014626 */     // GIR_Coverage, 23137,
     /* 2014626 */     GIR_EraseRootFromParent_Done,
     /* 2014627 */   // Label 26930: @2014627
     /* 2014627 */   GIM_Try, /*On fail goto*//*Label 26931*/ GIMT_Encode4(2014716), // Rule ID 23140 //
     /* 2014632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2014649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2014655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014678 */     // MIs[0] round
     /* 2014678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014688 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2014691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014715 */     // GIR_Coverage, 23140,
     /* 2014715 */     GIR_EraseRootFromParent_Done,
     /* 2014716 */   // Label 26931: @2014716
     /* 2014716 */   GIM_Try, /*On fail goto*//*Label 26932*/ GIMT_Encode4(2014805), // Rule ID 23141 //
     /* 2014721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2014738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2014744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014767 */     // MIs[0] round
     /* 2014767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014777 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2014780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014804 */     // GIR_Coverage, 23141,
     /* 2014804 */     GIR_EraseRootFromParent_Done,
     /* 2014805 */   // Label 26932: @2014805
     /* 2014805 */   GIM_Try, /*On fail goto*//*Label 26933*/ GIMT_Encode4(2014894), // Rule ID 23144 //
     /* 2014810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2014827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2014833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2014848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014856 */     // MIs[0] round
     /* 2014856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014866 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2014869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014893 */     // GIR_Coverage, 23144,
     /* 2014893 */     GIR_EraseRootFromParent_Done,
     /* 2014894 */   // Label 26933: @2014894
     /* 2014894 */   GIM_Try, /*On fail goto*//*Label 26934*/ GIMT_Encode4(2014983), // Rule ID 23145 //
     /* 2014899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2014916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2014922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2014937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014945 */     // MIs[0] round
     /* 2014945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014955 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2014958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014982 */     // GIR_Coverage, 23145,
     /* 2014982 */     GIR_EraseRootFromParent_Done,
     /* 2014983 */   // Label 26934: @2014983
     /* 2014983 */   GIM_Try, /*On fail goto*//*Label 26935*/ GIMT_Encode4(2015072), // Rule ID 23148 //
     /* 2014988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2014991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2015005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015034 */     // MIs[0] round
     /* 2015034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015044 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2015047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015071 */     // GIR_Coverage, 23148,
     /* 2015071 */     GIR_EraseRootFromParent_Done,
     /* 2015072 */   // Label 26935: @2015072
     /* 2015072 */   GIM_Try, /*On fail goto*//*Label 26936*/ GIMT_Encode4(2015161), // Rule ID 23149 //
     /* 2015077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2015080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2015094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015123 */     // MIs[0] round
     /* 2015123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015133 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2015136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015160 */     // GIR_Coverage, 23149,
     /* 2015160 */     GIR_EraseRootFromParent_Done,
     /* 2015161 */   // Label 26936: @2015161
     /* 2015161 */   GIM_Try, /*On fail goto*//*Label 26937*/ GIMT_Encode4(2015250), // Rule ID 23152 //
     /* 2015166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2015169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2015183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015212 */     // MIs[0] round
     /* 2015212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015222 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2015225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015249 */     // GIR_Coverage, 23152,
     /* 2015249 */     GIR_EraseRootFromParent_Done,
     /* 2015250 */   // Label 26937: @2015250
     /* 2015250 */   GIM_Try, /*On fail goto*//*Label 26938*/ GIMT_Encode4(2015339), // Rule ID 23153 //
     /* 2015255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2015258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2015272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015301 */     // MIs[0] round
     /* 2015301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015311 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2015314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015338 */     // GIR_Coverage, 23153,
     /* 2015338 */     GIR_EraseRootFromParent_Done,
     /* 2015339 */   // Label 26938: @2015339
     /* 2015339 */   GIM_Try, /*On fail goto*//*Label 26939*/ GIMT_Encode4(2015428), // Rule ID 23156 //
     /* 2015344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2015347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2015361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015390 */     // MIs[0] round
     /* 2015390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015400 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2015403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015427 */     // GIR_Coverage, 23156,
     /* 2015427 */     GIR_EraseRootFromParent_Done,
     /* 2015428 */   // Label 26939: @2015428
     /* 2015428 */   GIM_Try, /*On fail goto*//*Label 26940*/ GIMT_Encode4(2015517), // Rule ID 23157 //
     /* 2015433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2015436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2015450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015479 */     // MIs[0] round
     /* 2015479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015489 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2015492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015516 */     // GIR_Coverage, 23157,
     /* 2015516 */     GIR_EraseRootFromParent_Done,
     /* 2015517 */   // Label 26940: @2015517
     /* 2015517 */   GIM_Reject,
     /* 2015518 */ // Label 19884: @2015518
     /* 2015518 */ GIM_Try, /*On fail goto*//*Label 26941*/ GIMT_Encode4(2206003),
     /* 2015523 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 2015526 */   GIM_Try, /*On fail goto*//*Label 26942*/ GIMT_Encode4(2015628), // Rule ID 15992 //
     /* 2015531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2015539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2015542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2015545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2015548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2015554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015581 */     // MIs[1] Operand 1
     /* 2015581 */     // No operand predicates
     /* 2015581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015585 */     // MIs[0] round
     /* 2015585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015588 */     // MIs[0] policy
     /* 2015588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015600 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2015603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015627 */     // GIR_Coverage, 15992,
     /* 2015627 */     GIR_EraseRootFromParent_Done,
     /* 2015628 */   // Label 26942: @2015628
     /* 2015628 */   GIM_Try, /*On fail goto*//*Label 26943*/ GIMT_Encode4(2015730), // Rule ID 15993 //
     /* 2015633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2015636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2015641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2015644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2015647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2015650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2015656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015683 */     // MIs[1] Operand 1
     /* 2015683 */     // No operand predicates
     /* 2015683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015687 */     // MIs[0] round
     /* 2015687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015690 */     // MIs[0] policy
     /* 2015690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015702 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2015705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015726 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015729 */     // GIR_Coverage, 15993,
     /* 2015729 */     GIR_EraseRootFromParent_Done,
     /* 2015730 */   // Label 26943: @2015730
     /* 2015730 */   GIM_Try, /*On fail goto*//*Label 26944*/ GIMT_Encode4(2015832), // Rule ID 15996 //
     /* 2015735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2015743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2015746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2015749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2015752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2015758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015785 */     // MIs[1] Operand 1
     /* 2015785 */     // No operand predicates
     /* 2015785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015789 */     // MIs[0] round
     /* 2015789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015792 */     // MIs[0] policy
     /* 2015792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015804 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2015807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015831 */     // GIR_Coverage, 15996,
     /* 2015831 */     GIR_EraseRootFromParent_Done,
     /* 2015832 */   // Label 26944: @2015832
     /* 2015832 */   GIM_Try, /*On fail goto*//*Label 26945*/ GIMT_Encode4(2015934), // Rule ID 15997 //
     /* 2015837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2015840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2015845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2015848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2015851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2015854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2015860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015887 */     // MIs[1] Operand 1
     /* 2015887 */     // No operand predicates
     /* 2015887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015891 */     // MIs[0] round
     /* 2015891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015894 */     // MIs[0] policy
     /* 2015894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015906 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2015909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015933 */     // GIR_Coverage, 15997,
     /* 2015933 */     GIR_EraseRootFromParent_Done,
     /* 2015934 */   // Label 26945: @2015934
     /* 2015934 */   GIM_Try, /*On fail goto*//*Label 26946*/ GIMT_Encode4(2016036), // Rule ID 16000 //
     /* 2015939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2015947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2015950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2015953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2015956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015989 */     // MIs[1] Operand 1
     /* 2015989 */     // No operand predicates
     /* 2015989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015993 */     // MIs[0] round
     /* 2015993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015996 */     // MIs[0] policy
     /* 2015996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016008 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016035 */     // GIR_Coverage, 16000,
     /* 2016035 */     GIR_EraseRootFromParent_Done,
     /* 2016036 */   // Label 26946: @2016036
     /* 2016036 */   GIM_Try, /*On fail goto*//*Label 26947*/ GIMT_Encode4(2016138), // Rule ID 16001 //
     /* 2016041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2016052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2016055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2016058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016091 */     // MIs[1] Operand 1
     /* 2016091 */     // No operand predicates
     /* 2016091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016095 */     // MIs[0] round
     /* 2016095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016098 */     // MIs[0] policy
     /* 2016098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016110 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016137 */     // GIR_Coverage, 16001,
     /* 2016137 */     GIR_EraseRootFromParent_Done,
     /* 2016138 */   // Label 26947: @2016138
     /* 2016138 */   GIM_Try, /*On fail goto*//*Label 26948*/ GIMT_Encode4(2016240), // Rule ID 16004 //
     /* 2016143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2016154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2016157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2016160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016193 */     // MIs[1] Operand 1
     /* 2016193 */     // No operand predicates
     /* 2016193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016197 */     // MIs[0] round
     /* 2016197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016200 */     // MIs[0] policy
     /* 2016200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016212 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2016215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016239 */     // GIR_Coverage, 16004,
     /* 2016239 */     GIR_EraseRootFromParent_Done,
     /* 2016240 */   // Label 26948: @2016240
     /* 2016240 */   GIM_Try, /*On fail goto*//*Label 26949*/ GIMT_Encode4(2016342), // Rule ID 16005 //
     /* 2016245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2016256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2016259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2016262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016295 */     // MIs[1] Operand 1
     /* 2016295 */     // No operand predicates
     /* 2016295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016299 */     // MIs[0] round
     /* 2016299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016302 */     // MIs[0] policy
     /* 2016302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016314 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2016317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016341 */     // GIR_Coverage, 16005,
     /* 2016341 */     GIR_EraseRootFromParent_Done,
     /* 2016342 */   // Label 26949: @2016342
     /* 2016342 */   GIM_Try, /*On fail goto*//*Label 26950*/ GIMT_Encode4(2016444), // Rule ID 16008 //
     /* 2016347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2016358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2016361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2016364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016397 */     // MIs[1] Operand 1
     /* 2016397 */     // No operand predicates
     /* 2016397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016401 */     // MIs[0] round
     /* 2016401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016404 */     // MIs[0] policy
     /* 2016404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016416 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016443 */     // GIR_Coverage, 16008,
     /* 2016443 */     GIR_EraseRootFromParent_Done,
     /* 2016444 */   // Label 26950: @2016444
     /* 2016444 */   GIM_Try, /*On fail goto*//*Label 26951*/ GIMT_Encode4(2016546), // Rule ID 16009 //
     /* 2016449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2016460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2016463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2016466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016499 */     // MIs[1] Operand 1
     /* 2016499 */     // No operand predicates
     /* 2016499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016503 */     // MIs[0] round
     /* 2016503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016506 */     // MIs[0] policy
     /* 2016506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016545 */     // GIR_Coverage, 16009,
     /* 2016545 */     GIR_EraseRootFromParent_Done,
     /* 2016546 */   // Label 26951: @2016546
     /* 2016546 */   GIM_Try, /*On fail goto*//*Label 26952*/ GIMT_Encode4(2016648), // Rule ID 16012 //
     /* 2016551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2016562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2016565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2016568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016601 */     // MIs[1] Operand 1
     /* 2016601 */     // No operand predicates
     /* 2016601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016605 */     // MIs[0] round
     /* 2016605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016608 */     // MIs[0] policy
     /* 2016608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016620 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016647 */     // GIR_Coverage, 16012,
     /* 2016647 */     GIR_EraseRootFromParent_Done,
     /* 2016648 */   // Label 26952: @2016648
     /* 2016648 */   GIM_Try, /*On fail goto*//*Label 26953*/ GIMT_Encode4(2016750), // Rule ID 16013 //
     /* 2016653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2016664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2016667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2016670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016703 */     // MIs[1] Operand 1
     /* 2016703 */     // No operand predicates
     /* 2016703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016707 */     // MIs[0] round
     /* 2016707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016710 */     // MIs[0] policy
     /* 2016710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016722 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016736 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016746 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016749 */     // GIR_Coverage, 16013,
     /* 2016749 */     GIR_EraseRootFromParent_Done,
     /* 2016750 */   // Label 26953: @2016750
     /* 2016750 */   GIM_Try, /*On fail goto*//*Label 26954*/ GIMT_Encode4(2016852), // Rule ID 16016 //
     /* 2016755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2016766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2016769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2016772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2016778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016805 */     // MIs[1] Operand 1
     /* 2016805 */     // No operand predicates
     /* 2016805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016809 */     // MIs[0] round
     /* 2016809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016812 */     // MIs[0] policy
     /* 2016812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016824 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2016827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016851 */     // GIR_Coverage, 16016,
     /* 2016851 */     GIR_EraseRootFromParent_Done,
     /* 2016852 */   // Label 26954: @2016852
     /* 2016852 */   GIM_Try, /*On fail goto*//*Label 26955*/ GIMT_Encode4(2016954), // Rule ID 16017 //
     /* 2016857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2016868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2016871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2016874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2016880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016907 */     // MIs[1] Operand 1
     /* 2016907 */     // No operand predicates
     /* 2016907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016911 */     // MIs[0] round
     /* 2016911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016914 */     // MIs[0] policy
     /* 2016914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016926 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2016929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016953 */     // GIR_Coverage, 16017,
     /* 2016953 */     GIR_EraseRootFromParent_Done,
     /* 2016954 */   // Label 26955: @2016954
     /* 2016954 */   GIM_Try, /*On fail goto*//*Label 26956*/ GIMT_Encode4(2017056), // Rule ID 16020 //
     /* 2016959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2016970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2016973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2016976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017009 */     // MIs[1] Operand 1
     /* 2017009 */     // No operand predicates
     /* 2017009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017013 */     // MIs[0] round
     /* 2017013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017016 */     // MIs[0] policy
     /* 2017016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017028 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017055 */     // GIR_Coverage, 16020,
     /* 2017055 */     GIR_EraseRootFromParent_Done,
     /* 2017056 */   // Label 26956: @2017056
     /* 2017056 */   GIM_Try, /*On fail goto*//*Label 26957*/ GIMT_Encode4(2017158), // Rule ID 16021 //
     /* 2017061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2017072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2017075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2017078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2017084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017111 */     // MIs[1] Operand 1
     /* 2017111 */     // No operand predicates
     /* 2017111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017115 */     // MIs[0] round
     /* 2017115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017118 */     // MIs[0] policy
     /* 2017118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017130 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017157 */     // GIR_Coverage, 16021,
     /* 2017157 */     GIR_EraseRootFromParent_Done,
     /* 2017158 */   // Label 26957: @2017158
     /* 2017158 */   GIM_Try, /*On fail goto*//*Label 26958*/ GIMT_Encode4(2017260), // Rule ID 16024 //
     /* 2017163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2017180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017213 */     // MIs[1] Operand 1
     /* 2017213 */     // No operand predicates
     /* 2017213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017217 */     // MIs[0] round
     /* 2017217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017220 */     // MIs[0] policy
     /* 2017220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017259 */     // GIR_Coverage, 16024,
     /* 2017259 */     GIR_EraseRootFromParent_Done,
     /* 2017260 */   // Label 26958: @2017260
     /* 2017260 */   GIM_Try, /*On fail goto*//*Label 26959*/ GIMT_Encode4(2017362), // Rule ID 16025 //
     /* 2017265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2017282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017315 */     // MIs[1] Operand 1
     /* 2017315 */     // No operand predicates
     /* 2017315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017319 */     // MIs[0] round
     /* 2017319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017322 */     // MIs[0] policy
     /* 2017322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017361 */     // GIR_Coverage, 16025,
     /* 2017361 */     GIR_EraseRootFromParent_Done,
     /* 2017362 */   // Label 26959: @2017362
     /* 2017362 */   GIM_Try, /*On fail goto*//*Label 26960*/ GIMT_Encode4(2017464), // Rule ID 16028 //
     /* 2017367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2017370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2017384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017417 */     // MIs[1] Operand 1
     /* 2017417 */     // No operand predicates
     /* 2017417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017421 */     // MIs[0] round
     /* 2017421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017424 */     // MIs[0] policy
     /* 2017424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017436 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2017460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017463 */     // GIR_Coverage, 16028,
     /* 2017463 */     GIR_EraseRootFromParent_Done,
     /* 2017464 */   // Label 26960: @2017464
     /* 2017464 */   GIM_Try, /*On fail goto*//*Label 26961*/ GIMT_Encode4(2017566), // Rule ID 16029 //
     /* 2017469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2017472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2017486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017519 */     // MIs[1] Operand 1
     /* 2017519 */     // No operand predicates
     /* 2017519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017523 */     // MIs[0] round
     /* 2017523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017526 */     // MIs[0] policy
     /* 2017526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017538 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017552 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2017562 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017565 */     // GIR_Coverage, 16029,
     /* 2017565 */     GIR_EraseRootFromParent_Done,
     /* 2017566 */   // Label 26961: @2017566
     /* 2017566 */   GIM_Try, /*On fail goto*//*Label 26962*/ GIMT_Encode4(2017668), // Rule ID 16032 //
     /* 2017571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2017582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2017585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2017588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2017594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2017601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017621 */     // MIs[1] Operand 1
     /* 2017621 */     // No operand predicates
     /* 2017621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017625 */     // MIs[0] round
     /* 2017625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017628 */     // MIs[0] policy
     /* 2017628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017640 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2017643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017664 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017667 */     // GIR_Coverage, 16032,
     /* 2017667 */     GIR_EraseRootFromParent_Done,
     /* 2017668 */   // Label 26962: @2017668
     /* 2017668 */   GIM_Try, /*On fail goto*//*Label 26963*/ GIMT_Encode4(2017770), // Rule ID 16033 //
     /* 2017673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2017684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2017687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2017690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2017696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2017703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017723 */     // MIs[1] Operand 1
     /* 2017723 */     // No operand predicates
     /* 2017723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017727 */     // MIs[0] round
     /* 2017727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017730 */     // MIs[0] policy
     /* 2017730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017742 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2017745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017769 */     // GIR_Coverage, 16033,
     /* 2017769 */     GIR_EraseRootFromParent_Done,
     /* 2017770 */   // Label 26963: @2017770
     /* 2017770 */   GIM_Try, /*On fail goto*//*Label 26964*/ GIMT_Encode4(2017872), // Rule ID 16036 //
     /* 2017775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2017786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2017789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2017792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2017798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2017805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017825 */     // MIs[1] Operand 1
     /* 2017825 */     // No operand predicates
     /* 2017825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017829 */     // MIs[0] round
     /* 2017829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017832 */     // MIs[0] policy
     /* 2017832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017844 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2017847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017871 */     // GIR_Coverage, 16036,
     /* 2017871 */     GIR_EraseRootFromParent_Done,
     /* 2017872 */   // Label 26964: @2017872
     /* 2017872 */   GIM_Try, /*On fail goto*//*Label 26965*/ GIMT_Encode4(2017974), // Rule ID 16037 //
     /* 2017877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2017888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2017891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2017894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2017900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2017907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017927 */     // MIs[1] Operand 1
     /* 2017927 */     // No operand predicates
     /* 2017927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017931 */     // MIs[0] round
     /* 2017931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017934 */     // MIs[0] policy
     /* 2017934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017946 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2017949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017973 */     // GIR_Coverage, 16037,
     /* 2017973 */     GIR_EraseRootFromParent_Done,
     /* 2017974 */   // Label 26965: @2017974
     /* 2017974 */   GIM_Try, /*On fail goto*//*Label 26966*/ GIMT_Encode4(2018076), // Rule ID 16040 //
     /* 2017979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2017990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2017993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2017996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2018002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2018009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018029 */     // MIs[1] Operand 1
     /* 2018029 */     // No operand predicates
     /* 2018029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018033 */     // MIs[0] round
     /* 2018033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018036 */     // MIs[0] policy
     /* 2018036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018048 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2018051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018075 */     // GIR_Coverage, 16040,
     /* 2018075 */     GIR_EraseRootFromParent_Done,
     /* 2018076 */   // Label 26966: @2018076
     /* 2018076 */   GIM_Try, /*On fail goto*//*Label 26967*/ GIMT_Encode4(2018178), // Rule ID 16041 //
     /* 2018081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2018092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2018095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2018098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2018104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2018111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018131 */     // MIs[1] Operand 1
     /* 2018131 */     // No operand predicates
     /* 2018131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018135 */     // MIs[0] round
     /* 2018135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018138 */     // MIs[0] policy
     /* 2018138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018150 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2018153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018177 */     // GIR_Coverage, 16041,
     /* 2018177 */     GIR_EraseRootFromParent_Done,
     /* 2018178 */   // Label 26967: @2018178
     /* 2018178 */   GIM_Try, /*On fail goto*//*Label 26968*/ GIMT_Encode4(2018280), // Rule ID 16044 //
     /* 2018183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2018194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2018197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2018200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018233 */     // MIs[1] Operand 1
     /* 2018233 */     // No operand predicates
     /* 2018233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018237 */     // MIs[0] round
     /* 2018237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018240 */     // MIs[0] policy
     /* 2018240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018252 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018276 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018279 */     // GIR_Coverage, 16044,
     /* 2018279 */     GIR_EraseRootFromParent_Done,
     /* 2018280 */   // Label 26968: @2018280
     /* 2018280 */   GIM_Try, /*On fail goto*//*Label 26969*/ GIMT_Encode4(2018382), // Rule ID 16045 //
     /* 2018285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2018296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2018299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2018302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018335 */     // MIs[1] Operand 1
     /* 2018335 */     // No operand predicates
     /* 2018335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018339 */     // MIs[0] round
     /* 2018339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018342 */     // MIs[0] policy
     /* 2018342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018354 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018368 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018378 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018381 */     // GIR_Coverage, 16045,
     /* 2018381 */     GIR_EraseRootFromParent_Done,
     /* 2018382 */   // Label 26969: @2018382
     /* 2018382 */   GIM_Try, /*On fail goto*//*Label 26970*/ GIMT_Encode4(2018484), // Rule ID 16048 //
     /* 2018387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2018398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2018401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2018404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018437 */     // MIs[1] Operand 1
     /* 2018437 */     // No operand predicates
     /* 2018437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018441 */     // MIs[0] round
     /* 2018441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018444 */     // MIs[0] policy
     /* 2018444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018456 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2018459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018483 */     // GIR_Coverage, 16048,
     /* 2018483 */     GIR_EraseRootFromParent_Done,
     /* 2018484 */   // Label 26970: @2018484
     /* 2018484 */   GIM_Try, /*On fail goto*//*Label 26971*/ GIMT_Encode4(2018586), // Rule ID 16049 //
     /* 2018489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2018500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2018503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2018506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018539 */     // MIs[1] Operand 1
     /* 2018539 */     // No operand predicates
     /* 2018539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018543 */     // MIs[0] round
     /* 2018543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018546 */     // MIs[0] policy
     /* 2018546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018558 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2018561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018585 */     // GIR_Coverage, 16049,
     /* 2018585 */     GIR_EraseRootFromParent_Done,
     /* 2018586 */   // Label 26971: @2018586
     /* 2018586 */   GIM_Try, /*On fail goto*//*Label 26972*/ GIMT_Encode4(2018688), // Rule ID 16052 //
     /* 2018591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2018602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2018605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2018608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2018614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2018621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018641 */     // MIs[1] Operand 1
     /* 2018641 */     // No operand predicates
     /* 2018641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018645 */     // MIs[0] round
     /* 2018645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018648 */     // MIs[0] policy
     /* 2018648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018660 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2018663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018687 */     // GIR_Coverage, 16052,
     /* 2018687 */     GIR_EraseRootFromParent_Done,
     /* 2018688 */   // Label 26972: @2018688
     /* 2018688 */   GIM_Try, /*On fail goto*//*Label 26973*/ GIMT_Encode4(2018790), // Rule ID 16053 //
     /* 2018693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2018704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2018707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2018710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2018716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2018723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018743 */     // MIs[1] Operand 1
     /* 2018743 */     // No operand predicates
     /* 2018743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018747 */     // MIs[0] round
     /* 2018747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018750 */     // MIs[0] policy
     /* 2018750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018762 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2018765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018789 */     // GIR_Coverage, 16053,
     /* 2018789 */     GIR_EraseRootFromParent_Done,
     /* 2018790 */   // Label 26973: @2018790
     /* 2018790 */   GIM_Try, /*On fail goto*//*Label 26974*/ GIMT_Encode4(2018892), // Rule ID 16056 //
     /* 2018795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2018806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2018809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2018812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018845 */     // MIs[1] Operand 1
     /* 2018845 */     // No operand predicates
     /* 2018845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018849 */     // MIs[0] round
     /* 2018849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018852 */     // MIs[0] policy
     /* 2018852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018891 */     // GIR_Coverage, 16056,
     /* 2018891 */     GIR_EraseRootFromParent_Done,
     /* 2018892 */   // Label 26974: @2018892
     /* 2018892 */   GIM_Try, /*On fail goto*//*Label 26975*/ GIMT_Encode4(2018994), // Rule ID 16057 //
     /* 2018897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2018908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2018911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2018914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018947 */     // MIs[1] Operand 1
     /* 2018947 */     // No operand predicates
     /* 2018947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018951 */     // MIs[0] round
     /* 2018951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018954 */     // MIs[0] policy
     /* 2018954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018993 */     // GIR_Coverage, 16057,
     /* 2018993 */     GIR_EraseRootFromParent_Done,
     /* 2018994 */   // Label 26975: @2018994
     /* 2018994 */   GIM_Try, /*On fail goto*//*Label 26976*/ GIMT_Encode4(2019096), // Rule ID 16060 //
     /* 2018999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2019010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2019013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2019016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019049 */     // MIs[1] Operand 1
     /* 2019049 */     // No operand predicates
     /* 2019049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019053 */     // MIs[0] round
     /* 2019053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019056 */     // MIs[0] policy
     /* 2019056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019068 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019095 */     // GIR_Coverage, 16060,
     /* 2019095 */     GIR_EraseRootFromParent_Done,
     /* 2019096 */   // Label 26976: @2019096
     /* 2019096 */   GIM_Try, /*On fail goto*//*Label 26977*/ GIMT_Encode4(2019198), // Rule ID 16061 //
     /* 2019101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2019112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2019115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2019118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019151 */     // MIs[1] Operand 1
     /* 2019151 */     // No operand predicates
     /* 2019151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019155 */     // MIs[0] round
     /* 2019155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019158 */     // MIs[0] policy
     /* 2019158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019170 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019194 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019197 */     // GIR_Coverage, 16061,
     /* 2019197 */     GIR_EraseRootFromParent_Done,
     /* 2019198 */   // Label 26977: @2019198
     /* 2019198 */   GIM_Try, /*On fail goto*//*Label 26978*/ GIMT_Encode4(2019300), // Rule ID 16064 //
     /* 2019203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2019214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2019217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019253 */     // MIs[1] Operand 1
     /* 2019253 */     // No operand predicates
     /* 2019253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019257 */     // MIs[0] round
     /* 2019257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019260 */     // MIs[0] policy
     /* 2019260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019272 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019299 */     // GIR_Coverage, 16064,
     /* 2019299 */     GIR_EraseRootFromParent_Done,
     /* 2019300 */   // Label 26978: @2019300
     /* 2019300 */   GIM_Try, /*On fail goto*//*Label 26979*/ GIMT_Encode4(2019402), // Rule ID 16065 //
     /* 2019305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2019316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2019319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019355 */     // MIs[1] Operand 1
     /* 2019355 */     // No operand predicates
     /* 2019355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019359 */     // MIs[0] round
     /* 2019359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019362 */     // MIs[0] policy
     /* 2019362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019374 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019401 */     // GIR_Coverage, 16065,
     /* 2019401 */     GIR_EraseRootFromParent_Done,
     /* 2019402 */   // Label 26979: @2019402
     /* 2019402 */   GIM_Try, /*On fail goto*//*Label 26980*/ GIMT_Encode4(2019504), // Rule ID 16068 //
     /* 2019407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2019410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2019418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2019421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2019424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019457 */     // MIs[1] Operand 1
     /* 2019457 */     // No operand predicates
     /* 2019457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019461 */     // MIs[0] round
     /* 2019461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019464 */     // MIs[0] policy
     /* 2019464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2019479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2019500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019503 */     // GIR_Coverage, 16068,
     /* 2019503 */     GIR_EraseRootFromParent_Done,
     /* 2019504 */   // Label 26980: @2019504
     /* 2019504 */   GIM_Try, /*On fail goto*//*Label 26981*/ GIMT_Encode4(2019606), // Rule ID 16069 //
     /* 2019509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2019512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2019520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2019523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2019526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019559 */     // MIs[1] Operand 1
     /* 2019559 */     // No operand predicates
     /* 2019559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019563 */     // MIs[0] round
     /* 2019563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019566 */     // MIs[0] policy
     /* 2019566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2019581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2019602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019605 */     // GIR_Coverage, 16069,
     /* 2019605 */     GIR_EraseRootFromParent_Done,
     /* 2019606 */   // Label 26981: @2019606
     /* 2019606 */   GIM_Try, /*On fail goto*//*Label 26982*/ GIMT_Encode4(2019708), // Rule ID 16072 //
     /* 2019611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2019614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2019622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2019625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2019628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019661 */     // MIs[1] Operand 1
     /* 2019661 */     // No operand predicates
     /* 2019661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019665 */     // MIs[0] round
     /* 2019665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019668 */     // MIs[0] policy
     /* 2019668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019680 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2019704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019707 */     // GIR_Coverage, 16072,
     /* 2019707 */     GIR_EraseRootFromParent_Done,
     /* 2019708 */   // Label 26982: @2019708
     /* 2019708 */   GIM_Try, /*On fail goto*//*Label 26983*/ GIMT_Encode4(2019810), // Rule ID 16073 //
     /* 2019713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2019716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2019724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2019727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2019730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019763 */     // MIs[1] Operand 1
     /* 2019763 */     // No operand predicates
     /* 2019763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019767 */     // MIs[0] round
     /* 2019767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019770 */     // MIs[0] policy
     /* 2019770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019782 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2019806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019809 */     // GIR_Coverage, 16073,
     /* 2019809 */     GIR_EraseRootFromParent_Done,
     /* 2019810 */   // Label 26983: @2019810
     /* 2019810 */   GIM_Try, /*On fail goto*//*Label 26984*/ GIMT_Encode4(2019912), // Rule ID 16076 //
     /* 2019815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2019818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2019826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2019829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2019832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019865 */     // MIs[1] Operand 1
     /* 2019865 */     // No operand predicates
     /* 2019865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019869 */     // MIs[0] round
     /* 2019869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019872 */     // MIs[0] policy
     /* 2019872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019884 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019898 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2019908 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019911 */     // GIR_Coverage, 16076,
     /* 2019911 */     GIR_EraseRootFromParent_Done,
     /* 2019912 */   // Label 26984: @2019912
     /* 2019912 */   GIM_Try, /*On fail goto*//*Label 26985*/ GIMT_Encode4(2020014), // Rule ID 16077 //
     /* 2019917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2019920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2019928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2019931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2019934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019967 */     // MIs[1] Operand 1
     /* 2019967 */     // No operand predicates
     /* 2019967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019971 */     // MIs[0] round
     /* 2019971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019974 */     // MIs[0] policy
     /* 2019974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019986 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2020010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020013 */     // GIR_Coverage, 16077,
     /* 2020013 */     GIR_EraseRootFromParent_Done,
     /* 2020014 */   // Label 26985: @2020014
     /* 2020014 */   GIM_Try, /*On fail goto*//*Label 26986*/ GIMT_Encode4(2020116), // Rule ID 16256 //
     /* 2020019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2020030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2020033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2020036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020069 */     // MIs[1] Operand 1
     /* 2020069 */     // No operand predicates
     /* 2020069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020073 */     // MIs[0] round
     /* 2020073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020076 */     // MIs[0] policy
     /* 2020076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020088 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2020091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020115 */     // GIR_Coverage, 16256,
     /* 2020115 */     GIR_EraseRootFromParent_Done,
     /* 2020116 */   // Label 26986: @2020116
     /* 2020116 */   GIM_Try, /*On fail goto*//*Label 26987*/ GIMT_Encode4(2020218), // Rule ID 16257 //
     /* 2020121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2020132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2020135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2020138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020171 */     // MIs[1] Operand 1
     /* 2020171 */     // No operand predicates
     /* 2020171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020175 */     // MIs[0] round
     /* 2020175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020178 */     // MIs[0] policy
     /* 2020178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020190 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2020193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020217 */     // GIR_Coverage, 16257,
     /* 2020217 */     GIR_EraseRootFromParent_Done,
     /* 2020218 */   // Label 26987: @2020218
     /* 2020218 */   GIM_Try, /*On fail goto*//*Label 26988*/ GIMT_Encode4(2020320), // Rule ID 16260 //
     /* 2020223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2020234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2020237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2020240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020273 */     // MIs[1] Operand 1
     /* 2020273 */     // No operand predicates
     /* 2020273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020277 */     // MIs[0] round
     /* 2020277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020280 */     // MIs[0] policy
     /* 2020280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020292 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2020295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020319 */     // GIR_Coverage, 16260,
     /* 2020319 */     GIR_EraseRootFromParent_Done,
     /* 2020320 */   // Label 26988: @2020320
     /* 2020320 */   GIM_Try, /*On fail goto*//*Label 26989*/ GIMT_Encode4(2020422), // Rule ID 16261 //
     /* 2020325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2020336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2020339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2020342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020375 */     // MIs[1] Operand 1
     /* 2020375 */     // No operand predicates
     /* 2020375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020379 */     // MIs[0] round
     /* 2020379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020382 */     // MIs[0] policy
     /* 2020382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020394 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2020397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020421 */     // GIR_Coverage, 16261,
     /* 2020421 */     GIR_EraseRootFromParent_Done,
     /* 2020422 */   // Label 26989: @2020422
     /* 2020422 */   GIM_Try, /*On fail goto*//*Label 26990*/ GIMT_Encode4(2020524), // Rule ID 16264 //
     /* 2020427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2020438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2020441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2020444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020477 */     // MIs[1] Operand 1
     /* 2020477 */     // No operand predicates
     /* 2020477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020481 */     // MIs[0] round
     /* 2020481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020484 */     // MIs[0] policy
     /* 2020484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2020499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020523 */     // GIR_Coverage, 16264,
     /* 2020523 */     GIR_EraseRootFromParent_Done,
     /* 2020524 */   // Label 26990: @2020524
     /* 2020524 */   GIM_Try, /*On fail goto*//*Label 26991*/ GIMT_Encode4(2020626), // Rule ID 16265 //
     /* 2020529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2020540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2020543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2020546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020579 */     // MIs[1] Operand 1
     /* 2020579 */     // No operand predicates
     /* 2020579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020583 */     // MIs[0] round
     /* 2020583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020586 */     // MIs[0] policy
     /* 2020586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020598 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2020601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020625 */     // GIR_Coverage, 16265,
     /* 2020625 */     GIR_EraseRootFromParent_Done,
     /* 2020626 */   // Label 26991: @2020626
     /* 2020626 */   GIM_Try, /*On fail goto*//*Label 26992*/ GIMT_Encode4(2020728), // Rule ID 16268 //
     /* 2020631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2020642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2020645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2020648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020681 */     // MIs[1] Operand 1
     /* 2020681 */     // No operand predicates
     /* 2020681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020685 */     // MIs[0] round
     /* 2020685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020688 */     // MIs[0] policy
     /* 2020688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020700 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2020703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020727 */     // GIR_Coverage, 16268,
     /* 2020727 */     GIR_EraseRootFromParent_Done,
     /* 2020728 */   // Label 26992: @2020728
     /* 2020728 */   GIM_Try, /*On fail goto*//*Label 26993*/ GIMT_Encode4(2020830), // Rule ID 16269 //
     /* 2020733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2020744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2020747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2020750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020783 */     // MIs[1] Operand 1
     /* 2020783 */     // No operand predicates
     /* 2020783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020787 */     // MIs[0] round
     /* 2020787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020790 */     // MIs[0] policy
     /* 2020790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020802 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2020805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020829 */     // GIR_Coverage, 16269,
     /* 2020829 */     GIR_EraseRootFromParent_Done,
     /* 2020830 */   // Label 26993: @2020830
     /* 2020830 */   GIM_Try, /*On fail goto*//*Label 26994*/ GIMT_Encode4(2020932), // Rule ID 16272 //
     /* 2020835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2020846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2020849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2020852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020885 */     // MIs[1] Operand 1
     /* 2020885 */     // No operand predicates
     /* 2020885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020889 */     // MIs[0] round
     /* 2020889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020892 */     // MIs[0] policy
     /* 2020892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020904 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2020907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020931 */     // GIR_Coverage, 16272,
     /* 2020931 */     GIR_EraseRootFromParent_Done,
     /* 2020932 */   // Label 26994: @2020932
     /* 2020932 */   GIM_Try, /*On fail goto*//*Label 26995*/ GIMT_Encode4(2021034), // Rule ID 16273 //
     /* 2020937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2020948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2020951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2020954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020987 */     // MIs[1] Operand 1
     /* 2020987 */     // No operand predicates
     /* 2020987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020991 */     // MIs[0] round
     /* 2020991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020994 */     // MIs[0] policy
     /* 2020994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021006 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021033 */     // GIR_Coverage, 16273,
     /* 2021033 */     GIR_EraseRootFromParent_Done,
     /* 2021034 */   // Label 26995: @2021034
     /* 2021034 */   GIM_Try, /*On fail goto*//*Label 26996*/ GIMT_Encode4(2021136), // Rule ID 16276 //
     /* 2021039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2021050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2021053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2021056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021089 */     // MIs[1] Operand 1
     /* 2021089 */     // No operand predicates
     /* 2021089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021093 */     // MIs[0] round
     /* 2021093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021096 */     // MIs[0] policy
     /* 2021096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021135 */     // GIR_Coverage, 16276,
     /* 2021135 */     GIR_EraseRootFromParent_Done,
     /* 2021136 */   // Label 26996: @2021136
     /* 2021136 */   GIM_Try, /*On fail goto*//*Label 26997*/ GIMT_Encode4(2021238), // Rule ID 16277 //
     /* 2021141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2021152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2021155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2021158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021191 */     // MIs[1] Operand 1
     /* 2021191 */     // No operand predicates
     /* 2021191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021195 */     // MIs[0] round
     /* 2021195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021198 */     // MIs[0] policy
     /* 2021198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021210 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021237 */     // GIR_Coverage, 16277,
     /* 2021237 */     GIR_EraseRootFromParent_Done,
     /* 2021238 */   // Label 26997: @2021238
     /* 2021238 */   GIM_Try, /*On fail goto*//*Label 26998*/ GIMT_Encode4(2021340), // Rule ID 16280 //
     /* 2021243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2021254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2021257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2021260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021293 */     // MIs[1] Operand 1
     /* 2021293 */     // No operand predicates
     /* 2021293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021297 */     // MIs[0] round
     /* 2021297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021300 */     // MIs[0] policy
     /* 2021300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021312 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021339 */     // GIR_Coverage, 16280,
     /* 2021339 */     GIR_EraseRootFromParent_Done,
     /* 2021340 */   // Label 26998: @2021340
     /* 2021340 */   GIM_Try, /*On fail goto*//*Label 26999*/ GIMT_Encode4(2021442), // Rule ID 16281 //
     /* 2021345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2021356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2021359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2021362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021395 */     // MIs[1] Operand 1
     /* 2021395 */     // No operand predicates
     /* 2021395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021399 */     // MIs[0] round
     /* 2021399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021402 */     // MIs[0] policy
     /* 2021402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021414 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021441 */     // GIR_Coverage, 16281,
     /* 2021441 */     GIR_EraseRootFromParent_Done,
     /* 2021442 */   // Label 26999: @2021442
     /* 2021442 */   GIM_Try, /*On fail goto*//*Label 27000*/ GIMT_Encode4(2021544), // Rule ID 16284 //
     /* 2021447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2021458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2021461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2021464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021497 */     // MIs[1] Operand 1
     /* 2021497 */     // No operand predicates
     /* 2021497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021501 */     // MIs[0] round
     /* 2021501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021504 */     // MIs[0] policy
     /* 2021504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021516 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021543 */     // GIR_Coverage, 16284,
     /* 2021543 */     GIR_EraseRootFromParent_Done,
     /* 2021544 */   // Label 27000: @2021544
     /* 2021544 */   GIM_Try, /*On fail goto*//*Label 27001*/ GIMT_Encode4(2021646), // Rule ID 16285 //
     /* 2021549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2021560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2021563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2021566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021599 */     // MIs[1] Operand 1
     /* 2021599 */     // No operand predicates
     /* 2021599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021603 */     // MIs[0] round
     /* 2021603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021606 */     // MIs[0] policy
     /* 2021606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021618 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021645 */     // GIR_Coverage, 16285,
     /* 2021645 */     GIR_EraseRootFromParent_Done,
     /* 2021646 */   // Label 27001: @2021646
     /* 2021646 */   GIM_Try, /*On fail goto*//*Label 27002*/ GIMT_Encode4(2021748), // Rule ID 16288 //
     /* 2021651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2021662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2021665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2021668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021701 */     // MIs[1] Operand 1
     /* 2021701 */     // No operand predicates
     /* 2021701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021705 */     // MIs[0] round
     /* 2021705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021708 */     // MIs[0] policy
     /* 2021708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021720 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021747 */     // GIR_Coverage, 16288,
     /* 2021747 */     GIR_EraseRootFromParent_Done,
     /* 2021748 */   // Label 27002: @2021748
     /* 2021748 */   GIM_Try, /*On fail goto*//*Label 27003*/ GIMT_Encode4(2021850), // Rule ID 16289 //
     /* 2021753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2021764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2021767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2021770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021803 */     // MIs[1] Operand 1
     /* 2021803 */     // No operand predicates
     /* 2021803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021807 */     // MIs[0] round
     /* 2021807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021810 */     // MIs[0] policy
     /* 2021810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021822 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021849 */     // GIR_Coverage, 16289,
     /* 2021849 */     GIR_EraseRootFromParent_Done,
     /* 2021850 */   // Label 27003: @2021850
     /* 2021850 */   GIM_Try, /*On fail goto*//*Label 27004*/ GIMT_Encode4(2021952), // Rule ID 16292 //
     /* 2021855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2021858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2021866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2021869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2021872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021905 */     // MIs[1] Operand 1
     /* 2021905 */     // No operand predicates
     /* 2021905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021909 */     // MIs[0] round
     /* 2021909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021912 */     // MIs[0] policy
     /* 2021912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021924 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2021948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021951 */     // GIR_Coverage, 16292,
     /* 2021951 */     GIR_EraseRootFromParent_Done,
     /* 2021952 */   // Label 27004: @2021952
     /* 2021952 */   GIM_Try, /*On fail goto*//*Label 27005*/ GIMT_Encode4(2022054), // Rule ID 16293 //
     /* 2021957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2021960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2021968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2021971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2021974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022007 */     // MIs[1] Operand 1
     /* 2022007 */     // No operand predicates
     /* 2022007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022011 */     // MIs[0] round
     /* 2022011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022014 */     // MIs[0] policy
     /* 2022014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022026 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2022029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2022050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022053 */     // GIR_Coverage, 16293,
     /* 2022053 */     GIR_EraseRootFromParent_Done,
     /* 2022054 */   // Label 27005: @2022054
     /* 2022054 */   GIM_Try, /*On fail goto*//*Label 27006*/ GIMT_Encode4(2022156), // Rule ID 16296 //
     /* 2022059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2022070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2022073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2022076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022109 */     // MIs[1] Operand 1
     /* 2022109 */     // No operand predicates
     /* 2022109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022113 */     // MIs[0] round
     /* 2022113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022116 */     // MIs[0] policy
     /* 2022116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022128 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2022131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022155 */     // GIR_Coverage, 16296,
     /* 2022155 */     GIR_EraseRootFromParent_Done,
     /* 2022156 */   // Label 27006: @2022156
     /* 2022156 */   GIM_Try, /*On fail goto*//*Label 27007*/ GIMT_Encode4(2022258), // Rule ID 16297 //
     /* 2022161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2022172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2022175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2022178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022211 */     // MIs[1] Operand 1
     /* 2022211 */     // No operand predicates
     /* 2022211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022215 */     // MIs[0] round
     /* 2022215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022218 */     // MIs[0] policy
     /* 2022218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2022233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022257 */     // GIR_Coverage, 16297,
     /* 2022257 */     GIR_EraseRootFromParent_Done,
     /* 2022258 */   // Label 27007: @2022258
     /* 2022258 */   GIM_Try, /*On fail goto*//*Label 27008*/ GIMT_Encode4(2022360), // Rule ID 16300 //
     /* 2022263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2022274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2022277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2022280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2022286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022313 */     // MIs[1] Operand 1
     /* 2022313 */     // No operand predicates
     /* 2022313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022317 */     // MIs[0] round
     /* 2022317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022320 */     // MIs[0] policy
     /* 2022320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022332 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2022335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022359 */     // GIR_Coverage, 16300,
     /* 2022359 */     GIR_EraseRootFromParent_Done,
     /* 2022360 */   // Label 27008: @2022360
     /* 2022360 */   GIM_Try, /*On fail goto*//*Label 27009*/ GIMT_Encode4(2022462), // Rule ID 16301 //
     /* 2022365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2022376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2022379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2022382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2022388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022415 */     // MIs[1] Operand 1
     /* 2022415 */     // No operand predicates
     /* 2022415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022419 */     // MIs[0] round
     /* 2022419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022422 */     // MIs[0] policy
     /* 2022422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022434 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2022437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022461 */     // GIR_Coverage, 16301,
     /* 2022461 */     GIR_EraseRootFromParent_Done,
     /* 2022462 */   // Label 27009: @2022462
     /* 2022462 */   GIM_Try, /*On fail goto*//*Label 27010*/ GIMT_Encode4(2022564), // Rule ID 16304 //
     /* 2022467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2022478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2022481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2022484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2022490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2022497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022517 */     // MIs[1] Operand 1
     /* 2022517 */     // No operand predicates
     /* 2022517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022521 */     // MIs[0] round
     /* 2022521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022524 */     // MIs[0] policy
     /* 2022524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022536 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2022539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022550 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022560 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022563 */     // GIR_Coverage, 16304,
     /* 2022563 */     GIR_EraseRootFromParent_Done,
     /* 2022564 */   // Label 27010: @2022564
     /* 2022564 */   GIM_Try, /*On fail goto*//*Label 27011*/ GIMT_Encode4(2022666), // Rule ID 16305 //
     /* 2022569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2022580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2022583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2022586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2022592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2022599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022619 */     // MIs[1] Operand 1
     /* 2022619 */     // No operand predicates
     /* 2022619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022623 */     // MIs[0] round
     /* 2022623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022626 */     // MIs[0] policy
     /* 2022626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022638 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2022641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022665 */     // GIR_Coverage, 16305,
     /* 2022665 */     GIR_EraseRootFromParent_Done,
     /* 2022666 */   // Label 27011: @2022666
     /* 2022666 */   GIM_Try, /*On fail goto*//*Label 27012*/ GIMT_Encode4(2022768), // Rule ID 16308 //
     /* 2022671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2022682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2022685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2022688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022721 */     // MIs[1] Operand 1
     /* 2022721 */     // No operand predicates
     /* 2022721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022725 */     // MIs[0] round
     /* 2022725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022728 */     // MIs[0] policy
     /* 2022728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022740 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2022743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022767 */     // GIR_Coverage, 16308,
     /* 2022767 */     GIR_EraseRootFromParent_Done,
     /* 2022768 */   // Label 27012: @2022768
     /* 2022768 */   GIM_Try, /*On fail goto*//*Label 27013*/ GIMT_Encode4(2022870), // Rule ID 16309 //
     /* 2022773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2022784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2022787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2022790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022823 */     // MIs[1] Operand 1
     /* 2022823 */     // No operand predicates
     /* 2022823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022827 */     // MIs[0] round
     /* 2022827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022830 */     // MIs[0] policy
     /* 2022830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022842 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2022845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022869 */     // GIR_Coverage, 16309,
     /* 2022869 */     GIR_EraseRootFromParent_Done,
     /* 2022870 */   // Label 27013: @2022870
     /* 2022870 */   GIM_Try, /*On fail goto*//*Label 27014*/ GIMT_Encode4(2022972), // Rule ID 16312 //
     /* 2022875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2022886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2022889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2022892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022925 */     // MIs[1] Operand 1
     /* 2022925 */     // No operand predicates
     /* 2022925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022929 */     // MIs[0] round
     /* 2022929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022932 */     // MIs[0] policy
     /* 2022932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2022947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022971 */     // GIR_Coverage, 16312,
     /* 2022971 */     GIR_EraseRootFromParent_Done,
     /* 2022972 */   // Label 27014: @2022972
     /* 2022972 */   GIM_Try, /*On fail goto*//*Label 27015*/ GIMT_Encode4(2023074), // Rule ID 16313 //
     /* 2022977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2022988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2022991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2022994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2023000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023027 */     // MIs[1] Operand 1
     /* 2023027 */     // No operand predicates
     /* 2023027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023031 */     // MIs[0] round
     /* 2023031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023034 */     // MIs[0] policy
     /* 2023034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023046 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2023049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023073 */     // GIR_Coverage, 16313,
     /* 2023073 */     GIR_EraseRootFromParent_Done,
     /* 2023074 */   // Label 27015: @2023074
     /* 2023074 */   GIM_Try, /*On fail goto*//*Label 27016*/ GIMT_Encode4(2023176), // Rule ID 16316 //
     /* 2023079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2023090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2023093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2023096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2023102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023129 */     // MIs[1] Operand 1
     /* 2023129 */     // No operand predicates
     /* 2023129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023133 */     // MIs[0] round
     /* 2023133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023136 */     // MIs[0] policy
     /* 2023136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023148 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023175 */     // GIR_Coverage, 16316,
     /* 2023175 */     GIR_EraseRootFromParent_Done,
     /* 2023176 */   // Label 27016: @2023176
     /* 2023176 */   GIM_Try, /*On fail goto*//*Label 27017*/ GIMT_Encode4(2023278), // Rule ID 16317 //
     /* 2023181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2023192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2023195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2023198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2023204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023231 */     // MIs[1] Operand 1
     /* 2023231 */     // No operand predicates
     /* 2023231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023235 */     // MIs[0] round
     /* 2023235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023238 */     // MIs[0] policy
     /* 2023238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023250 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023264 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023274 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023277 */     // GIR_Coverage, 16317,
     /* 2023277 */     GIR_EraseRootFromParent_Done,
     /* 2023278 */   // Label 27017: @2023278
     /* 2023278 */   GIM_Try, /*On fail goto*//*Label 27018*/ GIMT_Encode4(2023380), // Rule ID 16320 //
     /* 2023283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2023294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2023297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2023300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023333 */     // MIs[1] Operand 1
     /* 2023333 */     // No operand predicates
     /* 2023333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023337 */     // MIs[0] round
     /* 2023337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023340 */     // MIs[0] policy
     /* 2023340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023376 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023379 */     // GIR_Coverage, 16320,
     /* 2023379 */     GIR_EraseRootFromParent_Done,
     /* 2023380 */   // Label 27018: @2023380
     /* 2023380 */   GIM_Try, /*On fail goto*//*Label 27019*/ GIMT_Encode4(2023482), // Rule ID 16321 //
     /* 2023385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2023396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2023399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2023402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023435 */     // MIs[1] Operand 1
     /* 2023435 */     // No operand predicates
     /* 2023435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023439 */     // MIs[0] round
     /* 2023439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023442 */     // MIs[0] policy
     /* 2023442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023454 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023481 */     // GIR_Coverage, 16321,
     /* 2023481 */     GIR_EraseRootFromParent_Done,
     /* 2023482 */   // Label 27019: @2023482
     /* 2023482 */   GIM_Try, /*On fail goto*//*Label 27020*/ GIMT_Encode4(2023584), // Rule ID 16324 //
     /* 2023487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2023498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2023501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2023504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023537 */     // MIs[1] Operand 1
     /* 2023537 */     // No operand predicates
     /* 2023537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023541 */     // MIs[0] round
     /* 2023541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023544 */     // MIs[0] policy
     /* 2023544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023556 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2023559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023583 */     // GIR_Coverage, 16324,
     /* 2023583 */     GIR_EraseRootFromParent_Done,
     /* 2023584 */   // Label 27020: @2023584
     /* 2023584 */   GIM_Try, /*On fail goto*//*Label 27021*/ GIMT_Encode4(2023686), // Rule ID 16325 //
     /* 2023589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2023600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2023603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2023606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023639 */     // MIs[1] Operand 1
     /* 2023639 */     // No operand predicates
     /* 2023639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023643 */     // MIs[0] round
     /* 2023643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023646 */     // MIs[0] policy
     /* 2023646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023658 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2023661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023685 */     // GIR_Coverage, 16325,
     /* 2023685 */     GIR_EraseRootFromParent_Done,
     /* 2023686 */   // Label 27021: @2023686
     /* 2023686 */   GIM_Try, /*On fail goto*//*Label 27022*/ GIMT_Encode4(2023788), // Rule ID 16328 //
     /* 2023691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2023702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2023705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2023708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2023714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023741 */     // MIs[1] Operand 1
     /* 2023741 */     // No operand predicates
     /* 2023741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023745 */     // MIs[0] round
     /* 2023745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023748 */     // MIs[0] policy
     /* 2023748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023760 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023787 */     // GIR_Coverage, 16328,
     /* 2023787 */     GIR_EraseRootFromParent_Done,
     /* 2023788 */   // Label 27022: @2023788
     /* 2023788 */   GIM_Try, /*On fail goto*//*Label 27023*/ GIMT_Encode4(2023890), // Rule ID 16329 //
     /* 2023793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2023804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2023807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2023810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2023816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023843 */     // MIs[1] Operand 1
     /* 2023843 */     // No operand predicates
     /* 2023843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023847 */     // MIs[0] round
     /* 2023847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023850 */     // MIs[0] policy
     /* 2023850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023862 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023889 */     // GIR_Coverage, 16329,
     /* 2023889 */     GIR_EraseRootFromParent_Done,
     /* 2023890 */   // Label 27023: @2023890
     /* 2023890 */   GIM_Try, /*On fail goto*//*Label 27024*/ GIMT_Encode4(2023992), // Rule ID 16332 //
     /* 2023895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2023898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2023906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2023909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2023912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2023918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023945 */     // MIs[1] Operand 1
     /* 2023945 */     // No operand predicates
     /* 2023945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023949 */     // MIs[0] round
     /* 2023949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023952 */     // MIs[0] policy
     /* 2023952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023964 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2023988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023991 */     // GIR_Coverage, 16332,
     /* 2023991 */     GIR_EraseRootFromParent_Done,
     /* 2023992 */   // Label 27024: @2023992
     /* 2023992 */   GIM_Try, /*On fail goto*//*Label 27025*/ GIMT_Encode4(2024094), // Rule ID 16333 //
     /* 2023997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2024000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2024008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2024011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2024014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2024027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024047 */     // MIs[1] Operand 1
     /* 2024047 */     // No operand predicates
     /* 2024047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024051 */     // MIs[0] round
     /* 2024051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024054 */     // MIs[0] policy
     /* 2024054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024066 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2024069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024093 */     // GIR_Coverage, 16333,
     /* 2024093 */     GIR_EraseRootFromParent_Done,
     /* 2024094 */   // Label 27025: @2024094
     /* 2024094 */   GIM_Try, /*On fail goto*//*Label 27026*/ GIMT_Encode4(2024196), // Rule ID 16336 //
     /* 2024099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2024102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2024110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2024113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2024116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024149 */     // MIs[1] Operand 1
     /* 2024149 */     // No operand predicates
     /* 2024149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024153 */     // MIs[0] round
     /* 2024153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024156 */     // MIs[0] policy
     /* 2024156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024168 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2024171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024195 */     // GIR_Coverage, 16336,
     /* 2024195 */     GIR_EraseRootFromParent_Done,
     /* 2024196 */   // Label 27026: @2024196
     /* 2024196 */   GIM_Try, /*On fail goto*//*Label 27027*/ GIMT_Encode4(2024298), // Rule ID 16337 //
     /* 2024201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2024204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2024212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2024215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2024218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024251 */     // MIs[1] Operand 1
     /* 2024251 */     // No operand predicates
     /* 2024251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024255 */     // MIs[0] round
     /* 2024255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024258 */     // MIs[0] policy
     /* 2024258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024270 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2024273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024297 */     // GIR_Coverage, 16337,
     /* 2024297 */     GIR_EraseRootFromParent_Done,
     /* 2024298 */   // Label 27027: @2024298
     /* 2024298 */   GIM_Try, /*On fail goto*//*Label 27028*/ GIMT_Encode4(2024400), // Rule ID 16340 //
     /* 2024303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2024306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2024314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2024317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2024320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024353 */     // MIs[1] Operand 1
     /* 2024353 */     // No operand predicates
     /* 2024353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024357 */     // MIs[0] round
     /* 2024357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024360 */     // MIs[0] policy
     /* 2024360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024372 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2024375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024399 */     // GIR_Coverage, 16340,
     /* 2024399 */     GIR_EraseRootFromParent_Done,
     /* 2024400 */   // Label 27028: @2024400
     /* 2024400 */   GIM_Try, /*On fail goto*//*Label 27029*/ GIMT_Encode4(2024502), // Rule ID 16341 //
     /* 2024405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2024408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2024416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2024419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2024422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024455 */     // MIs[1] Operand 1
     /* 2024455 */     // No operand predicates
     /* 2024455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024459 */     // MIs[0] round
     /* 2024459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024462 */     // MIs[0] policy
     /* 2024462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024474 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2024477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024501 */     // GIR_Coverage, 16341,
     /* 2024501 */     GIR_EraseRootFromParent_Done,
     /* 2024502 */   // Label 27029: @2024502
     /* 2024502 */   GIM_Try, /*On fail goto*//*Label 27030*/ GIMT_Encode4(2024607), // Rule ID 16464 //
     /* 2024507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2024515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2024518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2024521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2024524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024557 */     // MIs[1] Operand 1
     /* 2024557 */     // No operand predicates
     /* 2024557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024561 */     // MIs[0] round
     /* 2024561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024564 */     // MIs[0] policy
     /* 2024564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024576 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2024579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2024605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024606 */     // GIR_Coverage, 16464,
     /* 2024606 */     GIR_EraseRootFromParent_Done,
     /* 2024607 */   // Label 27030: @2024607
     /* 2024607 */   GIM_Try, /*On fail goto*//*Label 27031*/ GIMT_Encode4(2024712), // Rule ID 16465 //
     /* 2024612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2024620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2024623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2024626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2024629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024662 */     // MIs[1] Operand 1
     /* 2024662 */     // No operand predicates
     /* 2024662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024666 */     // MIs[0] round
     /* 2024666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024669 */     // MIs[0] policy
     /* 2024669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024681 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2024684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2024710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024711 */     // GIR_Coverage, 16465,
     /* 2024711 */     GIR_EraseRootFromParent_Done,
     /* 2024712 */   // Label 27031: @2024712
     /* 2024712 */   GIM_Try, /*On fail goto*//*Label 27032*/ GIMT_Encode4(2024817), // Rule ID 16468 //
     /* 2024717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2024725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2024728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2024731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2024734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024767 */     // MIs[1] Operand 1
     /* 2024767 */     // No operand predicates
     /* 2024767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024771 */     // MIs[0] round
     /* 2024771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024774 */     // MIs[0] policy
     /* 2024774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024786 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2024789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2024815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024816 */     // GIR_Coverage, 16468,
     /* 2024816 */     GIR_EraseRootFromParent_Done,
     /* 2024817 */   // Label 27032: @2024817
     /* 2024817 */   GIM_Try, /*On fail goto*//*Label 27033*/ GIMT_Encode4(2024922), // Rule ID 16469 //
     /* 2024822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2024830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2024833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2024836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2024839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024872 */     // MIs[1] Operand 1
     /* 2024872 */     // No operand predicates
     /* 2024872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024876 */     // MIs[0] round
     /* 2024876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024879 */     // MIs[0] policy
     /* 2024879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024891 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2024894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2024920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024921 */     // GIR_Coverage, 16469,
     /* 2024921 */     GIR_EraseRootFromParent_Done,
     /* 2024922 */   // Label 27033: @2024922
     /* 2024922 */   GIM_Try, /*On fail goto*//*Label 27034*/ GIMT_Encode4(2025027), // Rule ID 16472 //
     /* 2024927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2024935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2024938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2024941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2024944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024977 */     // MIs[1] Operand 1
     /* 2024977 */     // No operand predicates
     /* 2024977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024981 */     // MIs[0] round
     /* 2024981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024984 */     // MIs[0] policy
     /* 2024984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024996 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2024999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025026 */     // GIR_Coverage, 16472,
     /* 2025026 */     GIR_EraseRootFromParent_Done,
     /* 2025027 */   // Label 27034: @2025027
     /* 2025027 */   GIM_Try, /*On fail goto*//*Label 27035*/ GIMT_Encode4(2025132), // Rule ID 16473 //
     /* 2025032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2025043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2025046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2025049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025082 */     // MIs[1] Operand 1
     /* 2025082 */     // No operand predicates
     /* 2025082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025086 */     // MIs[0] round
     /* 2025086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025089 */     // MIs[0] policy
     /* 2025089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025101 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2025104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025131 */     // GIR_Coverage, 16473,
     /* 2025131 */     GIR_EraseRootFromParent_Done,
     /* 2025132 */   // Label 27035: @2025132
     /* 2025132 */   GIM_Try, /*On fail goto*//*Label 27036*/ GIMT_Encode4(2025237), // Rule ID 16476 //
     /* 2025137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2025148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2025151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2025154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025187 */     // MIs[1] Operand 1
     /* 2025187 */     // No operand predicates
     /* 2025187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025191 */     // MIs[0] round
     /* 2025191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025194 */     // MIs[0] policy
     /* 2025194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025206 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2025209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025236 */     // GIR_Coverage, 16476,
     /* 2025236 */     GIR_EraseRootFromParent_Done,
     /* 2025237 */   // Label 27036: @2025237
     /* 2025237 */   GIM_Try, /*On fail goto*//*Label 27037*/ GIMT_Encode4(2025342), // Rule ID 16477 //
     /* 2025242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2025253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2025256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2025259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025292 */     // MIs[1] Operand 1
     /* 2025292 */     // No operand predicates
     /* 2025292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025296 */     // MIs[0] round
     /* 2025296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025299 */     // MIs[0] policy
     /* 2025299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025311 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2025314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025337 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025341 */     // GIR_Coverage, 16477,
     /* 2025341 */     GIR_EraseRootFromParent_Done,
     /* 2025342 */   // Label 27037: @2025342
     /* 2025342 */   GIM_Try, /*On fail goto*//*Label 27038*/ GIMT_Encode4(2025447), // Rule ID 16480 //
     /* 2025347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2025358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2025361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2025364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2025370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025397 */     // MIs[1] Operand 1
     /* 2025397 */     // No operand predicates
     /* 2025397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025401 */     // MIs[0] round
     /* 2025401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025404 */     // MIs[0] policy
     /* 2025404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025416 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2025419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025446 */     // GIR_Coverage, 16480,
     /* 2025446 */     GIR_EraseRootFromParent_Done,
     /* 2025447 */   // Label 27038: @2025447
     /* 2025447 */   GIM_Try, /*On fail goto*//*Label 27039*/ GIMT_Encode4(2025552), // Rule ID 16481 //
     /* 2025452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2025463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2025466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2025469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2025475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025502 */     // MIs[1] Operand 1
     /* 2025502 */     // No operand predicates
     /* 2025502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025506 */     // MIs[0] round
     /* 2025506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025509 */     // MIs[0] policy
     /* 2025509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025521 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2025524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025547 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025551 */     // GIR_Coverage, 16481,
     /* 2025551 */     GIR_EraseRootFromParent_Done,
     /* 2025552 */   // Label 27039: @2025552
     /* 2025552 */   GIM_Try, /*On fail goto*//*Label 27040*/ GIMT_Encode4(2025657), // Rule ID 16484 //
     /* 2025557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2025568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2025571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2025574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2025580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025607 */     // MIs[1] Operand 1
     /* 2025607 */     // No operand predicates
     /* 2025607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025611 */     // MIs[0] round
     /* 2025611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025614 */     // MIs[0] policy
     /* 2025614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025626 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2025629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025656 */     // GIR_Coverage, 16484,
     /* 2025656 */     GIR_EraseRootFromParent_Done,
     /* 2025657 */   // Label 27040: @2025657
     /* 2025657 */   GIM_Try, /*On fail goto*//*Label 27041*/ GIMT_Encode4(2025762), // Rule ID 16485 //
     /* 2025662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2025673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2025676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2025679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2025685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025712 */     // MIs[1] Operand 1
     /* 2025712 */     // No operand predicates
     /* 2025712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025716 */     // MIs[0] round
     /* 2025716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025719 */     // MIs[0] policy
     /* 2025719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025731 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2025734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025761 */     // GIR_Coverage, 16485,
     /* 2025761 */     GIR_EraseRootFromParent_Done,
     /* 2025762 */   // Label 27041: @2025762
     /* 2025762 */   GIM_Try, /*On fail goto*//*Label 27042*/ GIMT_Encode4(2025867), // Rule ID 16488 //
     /* 2025767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2025778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2025781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2025784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2025790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025817 */     // MIs[1] Operand 1
     /* 2025817 */     // No operand predicates
     /* 2025817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025821 */     // MIs[0] round
     /* 2025821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025824 */     // MIs[0] policy
     /* 2025824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025836 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2025839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025866 */     // GIR_Coverage, 16488,
     /* 2025866 */     GIR_EraseRootFromParent_Done,
     /* 2025867 */   // Label 27042: @2025867
     /* 2025867 */   GIM_Try, /*On fail goto*//*Label 27043*/ GIMT_Encode4(2025972), // Rule ID 16489 //
     /* 2025872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2025883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2025886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2025889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2025895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025922 */     // MIs[1] Operand 1
     /* 2025922 */     // No operand predicates
     /* 2025922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025926 */     // MIs[0] round
     /* 2025926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025929 */     // MIs[0] policy
     /* 2025929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025941 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2025944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025971 */     // GIR_Coverage, 16489,
     /* 2025971 */     GIR_EraseRootFromParent_Done,
     /* 2025972 */   // Label 27043: @2025972
     /* 2025972 */   GIM_Try, /*On fail goto*//*Label 27044*/ GIMT_Encode4(2026077), // Rule ID 16492 //
     /* 2025977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2025988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2025991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2025994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026027 */     // MIs[1] Operand 1
     /* 2026027 */     // No operand predicates
     /* 2026027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026031 */     // MIs[0] round
     /* 2026031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026034 */     // MIs[0] policy
     /* 2026034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026046 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2026049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026076 */     // GIR_Coverage, 16492,
     /* 2026076 */     GIR_EraseRootFromParent_Done,
     /* 2026077 */   // Label 27044: @2026077
     /* 2026077 */   GIM_Try, /*On fail goto*//*Label 27045*/ GIMT_Encode4(2026182), // Rule ID 16493 //
     /* 2026082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2026093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2026096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2026099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026132 */     // MIs[1] Operand 1
     /* 2026132 */     // No operand predicates
     /* 2026132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026136 */     // MIs[0] round
     /* 2026136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026139 */     // MIs[0] policy
     /* 2026139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026151 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2026154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026181 */     // GIR_Coverage, 16493,
     /* 2026181 */     GIR_EraseRootFromParent_Done,
     /* 2026182 */   // Label 27045: @2026182
     /* 2026182 */   GIM_Try, /*On fail goto*//*Label 27046*/ GIMT_Encode4(2026287), // Rule ID 16496 //
     /* 2026187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2026198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2026201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2026204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026237 */     // MIs[1] Operand 1
     /* 2026237 */     // No operand predicates
     /* 2026237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026241 */     // MIs[0] round
     /* 2026241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026244 */     // MIs[0] policy
     /* 2026244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026256 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2026259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026286 */     // GIR_Coverage, 16496,
     /* 2026286 */     GIR_EraseRootFromParent_Done,
     /* 2026287 */   // Label 27046: @2026287
     /* 2026287 */   GIM_Try, /*On fail goto*//*Label 27047*/ GIMT_Encode4(2026392), // Rule ID 16497 //
     /* 2026292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2026303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2026306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2026309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026342 */     // MIs[1] Operand 1
     /* 2026342 */     // No operand predicates
     /* 2026342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026346 */     // MIs[0] round
     /* 2026346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026349 */     // MIs[0] policy
     /* 2026349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026361 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2026364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026391 */     // GIR_Coverage, 16497,
     /* 2026391 */     GIR_EraseRootFromParent_Done,
     /* 2026392 */   // Label 27047: @2026392
     /* 2026392 */   GIM_Try, /*On fail goto*//*Label 27048*/ GIMT_Encode4(2026497), // Rule ID 16500 //
     /* 2026397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2026408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2026411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2026414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026447 */     // MIs[1] Operand 1
     /* 2026447 */     // No operand predicates
     /* 2026447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026451 */     // MIs[0] round
     /* 2026451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026454 */     // MIs[0] policy
     /* 2026454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2026469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026496 */     // GIR_Coverage, 16500,
     /* 2026496 */     GIR_EraseRootFromParent_Done,
     /* 2026497 */   // Label 27048: @2026497
     /* 2026497 */   GIM_Try, /*On fail goto*//*Label 27049*/ GIMT_Encode4(2026602), // Rule ID 16501 //
     /* 2026502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2026513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2026516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2026519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026552 */     // MIs[1] Operand 1
     /* 2026552 */     // No operand predicates
     /* 2026552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026556 */     // MIs[0] round
     /* 2026556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026559 */     // MIs[0] policy
     /* 2026559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026571 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2026574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026601 */     // GIR_Coverage, 16501,
     /* 2026601 */     GIR_EraseRootFromParent_Done,
     /* 2026602 */   // Label 27049: @2026602
     /* 2026602 */   GIM_Try, /*On fail goto*//*Label 27050*/ GIMT_Encode4(2026707), // Rule ID 16504 //
     /* 2026607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2026618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2026621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2026624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2026630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026657 */     // MIs[1] Operand 1
     /* 2026657 */     // No operand predicates
     /* 2026657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026661 */     // MIs[0] round
     /* 2026661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026664 */     // MIs[0] policy
     /* 2026664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2026679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026706 */     // GIR_Coverage, 16504,
     /* 2026706 */     GIR_EraseRootFromParent_Done,
     /* 2026707 */   // Label 27050: @2026707
     /* 2026707 */   GIM_Try, /*On fail goto*//*Label 27051*/ GIMT_Encode4(2026812), // Rule ID 16505 //
     /* 2026712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2026723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2026726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2026729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2026735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026762 */     // MIs[1] Operand 1
     /* 2026762 */     // No operand predicates
     /* 2026762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026766 */     // MIs[0] round
     /* 2026766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026769 */     // MIs[0] policy
     /* 2026769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026781 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2026784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026811 */     // GIR_Coverage, 16505,
     /* 2026811 */     GIR_EraseRootFromParent_Done,
     /* 2026812 */   // Label 27051: @2026812
     /* 2026812 */   GIM_Try, /*On fail goto*//*Label 27052*/ GIMT_Encode4(2026917), // Rule ID 16508 //
     /* 2026817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2026820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2026828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2026831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2026834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026867 */     // MIs[1] Operand 1
     /* 2026867 */     // No operand predicates
     /* 2026867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026871 */     // MIs[0] round
     /* 2026871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026874 */     // MIs[0] policy
     /* 2026874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026886 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2026889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026916 */     // GIR_Coverage, 16508,
     /* 2026916 */     GIR_EraseRootFromParent_Done,
     /* 2026917 */   // Label 27052: @2026917
     /* 2026917 */   GIM_Try, /*On fail goto*//*Label 27053*/ GIMT_Encode4(2027022), // Rule ID 16509 //
     /* 2026922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2026925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2026933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2026936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2026939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026972 */     // MIs[1] Operand 1
     /* 2026972 */     // No operand predicates
     /* 2026972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026976 */     // MIs[0] round
     /* 2026976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026979 */     // MIs[0] policy
     /* 2026979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026991 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2026994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027021 */     // GIR_Coverage, 16509,
     /* 2027021 */     GIR_EraseRootFromParent_Done,
     /* 2027022 */   // Label 27053: @2027022
     /* 2027022 */   GIM_Try, /*On fail goto*//*Label 27054*/ GIMT_Encode4(2027127), // Rule ID 16512 //
     /* 2027027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2027038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2027041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2027044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027077 */     // MIs[1] Operand 1
     /* 2027077 */     // No operand predicates
     /* 2027077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027081 */     // MIs[0] round
     /* 2027081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027084 */     // MIs[0] policy
     /* 2027084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2027099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027126 */     // GIR_Coverage, 16512,
     /* 2027126 */     GIR_EraseRootFromParent_Done,
     /* 2027127 */   // Label 27054: @2027127
     /* 2027127 */   GIM_Try, /*On fail goto*//*Label 27055*/ GIMT_Encode4(2027232), // Rule ID 16513 //
     /* 2027132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2027135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2027143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2027146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2027149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027182 */     // MIs[1] Operand 1
     /* 2027182 */     // No operand predicates
     /* 2027182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027186 */     // MIs[0] round
     /* 2027186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027189 */     // MIs[0] policy
     /* 2027189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027201 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2027204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027231 */     // GIR_Coverage, 16513,
     /* 2027231 */     GIR_EraseRootFromParent_Done,
     /* 2027232 */   // Label 27055: @2027232
     /* 2027232 */   GIM_Try, /*On fail goto*//*Label 27056*/ GIMT_Encode4(2027337), // Rule ID 16516 //
     /* 2027237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2027248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2027251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2027254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027287 */     // MIs[1] Operand 1
     /* 2027287 */     // No operand predicates
     /* 2027287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027291 */     // MIs[0] round
     /* 2027291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027294 */     // MIs[0] policy
     /* 2027294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027306 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2027309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027336 */     // GIR_Coverage, 16516,
     /* 2027336 */     GIR_EraseRootFromParent_Done,
     /* 2027337 */   // Label 27056: @2027337
     /* 2027337 */   GIM_Try, /*On fail goto*//*Label 27057*/ GIMT_Encode4(2027442), // Rule ID 16517 //
     /* 2027342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2027345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2027353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2027356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2027359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027392 */     // MIs[1] Operand 1
     /* 2027392 */     // No operand predicates
     /* 2027392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027396 */     // MIs[0] round
     /* 2027396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027399 */     // MIs[0] policy
     /* 2027399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027411 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2027414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027441 */     // GIR_Coverage, 16517,
     /* 2027441 */     GIR_EraseRootFromParent_Done,
     /* 2027442 */   // Label 27057: @2027442
     /* 2027442 */   GIM_Try, /*On fail goto*//*Label 27058*/ GIMT_Encode4(2027547), // Rule ID 16520 //
     /* 2027447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2027458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2027461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2027464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2027470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027497 */     // MIs[1] Operand 1
     /* 2027497 */     // No operand predicates
     /* 2027497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027501 */     // MIs[0] round
     /* 2027501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027504 */     // MIs[0] policy
     /* 2027504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2027519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027546 */     // GIR_Coverage, 16520,
     /* 2027546 */     GIR_EraseRootFromParent_Done,
     /* 2027547 */   // Label 27058: @2027547
     /* 2027547 */   GIM_Try, /*On fail goto*//*Label 27059*/ GIMT_Encode4(2027652), // Rule ID 16521 //
     /* 2027552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2027555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2027563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2027566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2027569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2027575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027602 */     // MIs[1] Operand 1
     /* 2027602 */     // No operand predicates
     /* 2027602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027606 */     // MIs[0] round
     /* 2027606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027609 */     // MIs[0] policy
     /* 2027609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027621 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2027624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027651 */     // GIR_Coverage, 16521,
     /* 2027651 */     GIR_EraseRootFromParent_Done,
     /* 2027652 */   // Label 27059: @2027652
     /* 2027652 */   GIM_Try, /*On fail goto*//*Label 27060*/ GIMT_Encode4(2027757), // Rule ID 16644 //
     /* 2027657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2027665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2027668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2027671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2027674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027707 */     // MIs[1] Operand 1
     /* 2027707 */     // No operand predicates
     /* 2027707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027711 */     // MIs[0] round
     /* 2027711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027714 */     // MIs[0] policy
     /* 2027714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027726 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2027729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027756 */     // GIR_Coverage, 16644,
     /* 2027756 */     GIR_EraseRootFromParent_Done,
     /* 2027757 */   // Label 27060: @2027757
     /* 2027757 */   GIM_Try, /*On fail goto*//*Label 27061*/ GIMT_Encode4(2027862), // Rule ID 16645 //
     /* 2027762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2027770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2027773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2027776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2027779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027812 */     // MIs[1] Operand 1
     /* 2027812 */     // No operand predicates
     /* 2027812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027816 */     // MIs[0] round
     /* 2027816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027819 */     // MIs[0] policy
     /* 2027819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027831 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2027834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027861 */     // GIR_Coverage, 16645,
     /* 2027861 */     GIR_EraseRootFromParent_Done,
     /* 2027862 */   // Label 27061: @2027862
     /* 2027862 */   GIM_Try, /*On fail goto*//*Label 27062*/ GIMT_Encode4(2027967), // Rule ID 16648 //
     /* 2027867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2027875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2027878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2027881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2027884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027917 */     // MIs[1] Operand 1
     /* 2027917 */     // No operand predicates
     /* 2027917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027921 */     // MIs[0] round
     /* 2027921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027924 */     // MIs[0] policy
     /* 2027924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027936 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2027939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027966 */     // GIR_Coverage, 16648,
     /* 2027966 */     GIR_EraseRootFromParent_Done,
     /* 2027967 */   // Label 27062: @2027967
     /* 2027967 */   GIM_Try, /*On fail goto*//*Label 27063*/ GIMT_Encode4(2028072), // Rule ID 16649 //
     /* 2027972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2027980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2027983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2027986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2027989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028022 */     // MIs[1] Operand 1
     /* 2028022 */     // No operand predicates
     /* 2028022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028026 */     // MIs[0] round
     /* 2028026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028029 */     // MIs[0] policy
     /* 2028029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028041 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2028044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028071 */     // GIR_Coverage, 16649,
     /* 2028071 */     GIR_EraseRootFromParent_Done,
     /* 2028072 */   // Label 27063: @2028072
     /* 2028072 */   GIM_Try, /*On fail goto*//*Label 27064*/ GIMT_Encode4(2028177), // Rule ID 16652 //
     /* 2028077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2028088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2028091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028127 */     // MIs[1] Operand 1
     /* 2028127 */     // No operand predicates
     /* 2028127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028131 */     // MIs[0] round
     /* 2028131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028134 */     // MIs[0] policy
     /* 2028134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028146 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2028149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028176 */     // GIR_Coverage, 16652,
     /* 2028176 */     GIR_EraseRootFromParent_Done,
     /* 2028177 */   // Label 27064: @2028177
     /* 2028177 */   GIM_Try, /*On fail goto*//*Label 27065*/ GIMT_Encode4(2028282), // Rule ID 16653 //
     /* 2028182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2028193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2028196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028232 */     // MIs[1] Operand 1
     /* 2028232 */     // No operand predicates
     /* 2028232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028236 */     // MIs[0] round
     /* 2028236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028239 */     // MIs[0] policy
     /* 2028239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028251 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2028254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028281 */     // GIR_Coverage, 16653,
     /* 2028281 */     GIR_EraseRootFromParent_Done,
     /* 2028282 */   // Label 27065: @2028282
     /* 2028282 */   GIM_Try, /*On fail goto*//*Label 27066*/ GIMT_Encode4(2028387), // Rule ID 16656 //
     /* 2028287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2028298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2028301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2028304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028337 */     // MIs[1] Operand 1
     /* 2028337 */     // No operand predicates
     /* 2028337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028341 */     // MIs[0] round
     /* 2028341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028344 */     // MIs[0] policy
     /* 2028344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028356 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2028359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028386 */     // GIR_Coverage, 16656,
     /* 2028386 */     GIR_EraseRootFromParent_Done,
     /* 2028387 */   // Label 27066: @2028387
     /* 2028387 */   GIM_Try, /*On fail goto*//*Label 27067*/ GIMT_Encode4(2028492), // Rule ID 16657 //
     /* 2028392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2028403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2028406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2028409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028442 */     // MIs[1] Operand 1
     /* 2028442 */     // No operand predicates
     /* 2028442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028446 */     // MIs[0] round
     /* 2028446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028449 */     // MIs[0] policy
     /* 2028449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028461 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2028464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028491 */     // GIR_Coverage, 16657,
     /* 2028491 */     GIR_EraseRootFromParent_Done,
     /* 2028492 */   // Label 27067: @2028492
     /* 2028492 */   GIM_Try, /*On fail goto*//*Label 27068*/ GIMT_Encode4(2028597), // Rule ID 16660 //
     /* 2028497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2028508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2028511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2028514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2028520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2028527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028547 */     // MIs[1] Operand 1
     /* 2028547 */     // No operand predicates
     /* 2028547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028551 */     // MIs[0] round
     /* 2028551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028554 */     // MIs[0] policy
     /* 2028554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028566 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2028569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028596 */     // GIR_Coverage, 16660,
     /* 2028596 */     GIR_EraseRootFromParent_Done,
     /* 2028597 */   // Label 27068: @2028597
     /* 2028597 */   GIM_Try, /*On fail goto*//*Label 27069*/ GIMT_Encode4(2028702), // Rule ID 16661 //
     /* 2028602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2028613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2028616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2028619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2028625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2028632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028652 */     // MIs[1] Operand 1
     /* 2028652 */     // No operand predicates
     /* 2028652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028656 */     // MIs[0] round
     /* 2028656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028659 */     // MIs[0] policy
     /* 2028659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028671 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2028674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028701 */     // GIR_Coverage, 16661,
     /* 2028701 */     GIR_EraseRootFromParent_Done,
     /* 2028702 */   // Label 27069: @2028702
     /* 2028702 */   GIM_Try, /*On fail goto*//*Label 27070*/ GIMT_Encode4(2028807), // Rule ID 16664 //
     /* 2028707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2028718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2028721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2028724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2028730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2028737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028757 */     // MIs[1] Operand 1
     /* 2028757 */     // No operand predicates
     /* 2028757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028761 */     // MIs[0] round
     /* 2028761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028764 */     // MIs[0] policy
     /* 2028764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028776 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2028779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028806 */     // GIR_Coverage, 16664,
     /* 2028806 */     GIR_EraseRootFromParent_Done,
     /* 2028807 */   // Label 27070: @2028807
     /* 2028807 */   GIM_Try, /*On fail goto*//*Label 27071*/ GIMT_Encode4(2028912), // Rule ID 16665 //
     /* 2028812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2028823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2028826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2028829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2028835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2028842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028862 */     // MIs[1] Operand 1
     /* 2028862 */     // No operand predicates
     /* 2028862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028866 */     // MIs[0] round
     /* 2028866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028869 */     // MIs[0] policy
     /* 2028869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028881 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2028884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028911 */     // GIR_Coverage, 16665,
     /* 2028911 */     GIR_EraseRootFromParent_Done,
     /* 2028912 */   // Label 27071: @2028912
     /* 2028912 */   GIM_Try, /*On fail goto*//*Label 27072*/ GIMT_Encode4(2029017), // Rule ID 16668 //
     /* 2028917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2028928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2028931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2028934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028967 */     // MIs[1] Operand 1
     /* 2028967 */     // No operand predicates
     /* 2028967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028971 */     // MIs[0] round
     /* 2028971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028974 */     // MIs[0] policy
     /* 2028974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028986 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2028989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029016 */     // GIR_Coverage, 16668,
     /* 2029016 */     GIR_EraseRootFromParent_Done,
     /* 2029017 */   // Label 27072: @2029017
     /* 2029017 */   GIM_Try, /*On fail goto*//*Label 27073*/ GIMT_Encode4(2029122), // Rule ID 16669 //
     /* 2029022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2029033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2029036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2029039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029045 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029072 */     // MIs[1] Operand 1
     /* 2029072 */     // No operand predicates
     /* 2029072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029076 */     // MIs[0] round
     /* 2029076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029079 */     // MIs[0] policy
     /* 2029079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029091 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2029094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029121 */     // GIR_Coverage, 16669,
     /* 2029121 */     GIR_EraseRootFromParent_Done,
     /* 2029122 */   // Label 27073: @2029122
     /* 2029122 */   GIM_Try, /*On fail goto*//*Label 27074*/ GIMT_Encode4(2029227), // Rule ID 16672 //
     /* 2029127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2029138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2029141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2029144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029177 */     // MIs[1] Operand 1
     /* 2029177 */     // No operand predicates
     /* 2029177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029181 */     // MIs[0] round
     /* 2029181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029184 */     // MIs[0] policy
     /* 2029184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2029199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029226 */     // GIR_Coverage, 16672,
     /* 2029226 */     GIR_EraseRootFromParent_Done,
     /* 2029227 */   // Label 27074: @2029227
     /* 2029227 */   GIM_Try, /*On fail goto*//*Label 27075*/ GIMT_Encode4(2029332), // Rule ID 16673 //
     /* 2029232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2029243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2029246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2029249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029282 */     // MIs[1] Operand 1
     /* 2029282 */     // No operand predicates
     /* 2029282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029286 */     // MIs[0] round
     /* 2029286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029289 */     // MIs[0] policy
     /* 2029289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029301 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2029304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029331 */     // GIR_Coverage, 16673,
     /* 2029331 */     GIR_EraseRootFromParent_Done,
     /* 2029332 */   // Label 27075: @2029332
     /* 2029332 */   GIM_Try, /*On fail goto*//*Label 27076*/ GIMT_Encode4(2029437), // Rule ID 16676 //
     /* 2029337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2029348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2029351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2029354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2029360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029387 */     // MIs[1] Operand 1
     /* 2029387 */     // No operand predicates
     /* 2029387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029391 */     // MIs[0] round
     /* 2029391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029394 */     // MIs[0] policy
     /* 2029394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029406 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2029409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029436 */     // GIR_Coverage, 16676,
     /* 2029436 */     GIR_EraseRootFromParent_Done,
     /* 2029437 */   // Label 27076: @2029437
     /* 2029437 */   GIM_Try, /*On fail goto*//*Label 27077*/ GIMT_Encode4(2029542), // Rule ID 16677 //
     /* 2029442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2029453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2029456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2029459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2029465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029492 */     // MIs[1] Operand 1
     /* 2029492 */     // No operand predicates
     /* 2029492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029496 */     // MIs[0] round
     /* 2029496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029499 */     // MIs[0] policy
     /* 2029499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029511 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2029514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029541 */     // GIR_Coverage, 16677,
     /* 2029541 */     GIR_EraseRootFromParent_Done,
     /* 2029542 */   // Label 27077: @2029542
     /* 2029542 */   GIM_Try, /*On fail goto*//*Label 27078*/ GIMT_Encode4(2029647), // Rule ID 16680 //
     /* 2029547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2029558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2029561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2029564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2029570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029597 */     // MIs[1] Operand 1
     /* 2029597 */     // No operand predicates
     /* 2029597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029601 */     // MIs[0] round
     /* 2029601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029604 */     // MIs[0] policy
     /* 2029604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2029619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029646 */     // GIR_Coverage, 16680,
     /* 2029646 */     GIR_EraseRootFromParent_Done,
     /* 2029647 */   // Label 27078: @2029647
     /* 2029647 */   GIM_Try, /*On fail goto*//*Label 27079*/ GIMT_Encode4(2029752), // Rule ID 16681 //
     /* 2029652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2029663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2029666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2029669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2029675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029702 */     // MIs[1] Operand 1
     /* 2029702 */     // No operand predicates
     /* 2029702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029706 */     // MIs[0] round
     /* 2029706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029709 */     // MIs[0] policy
     /* 2029709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029721 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2029724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029751 */     // GIR_Coverage, 16681,
     /* 2029751 */     GIR_EraseRootFromParent_Done,
     /* 2029752 */   // Label 27079: @2029752
     /* 2029752 */   GIM_Try, /*On fail goto*//*Label 27080*/ GIMT_Encode4(2029857), // Rule ID 16684 //
     /* 2029757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2029768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2029771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2029774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2029780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029807 */     // MIs[1] Operand 1
     /* 2029807 */     // No operand predicates
     /* 2029807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029811 */     // MIs[0] round
     /* 2029811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029814 */     // MIs[0] policy
     /* 2029814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029826 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2029829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029856 */     // GIR_Coverage, 16684,
     /* 2029856 */     GIR_EraseRootFromParent_Done,
     /* 2029857 */   // Label 27080: @2029857
     /* 2029857 */   GIM_Try, /*On fail goto*//*Label 27081*/ GIMT_Encode4(2029962), // Rule ID 16685 //
     /* 2029862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2029873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2029876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2029879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2029885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029912 */     // MIs[1] Operand 1
     /* 2029912 */     // No operand predicates
     /* 2029912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029916 */     // MIs[0] round
     /* 2029916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029919 */     // MIs[0] policy
     /* 2029919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029931 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2029934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029961 */     // GIR_Coverage, 16685,
     /* 2029961 */     GIR_EraseRootFromParent_Done,
     /* 2029962 */   // Label 27081: @2029962
     /* 2029962 */   GIM_Try, /*On fail goto*//*Label 27082*/ GIMT_Encode4(2030067), // Rule ID 16688 //
     /* 2029967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2029970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2029978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2029981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2029984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030017 */     // MIs[1] Operand 1
     /* 2030017 */     // No operand predicates
     /* 2030017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030021 */     // MIs[0] round
     /* 2030021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030024 */     // MIs[0] policy
     /* 2030024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030036 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2030039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030066 */     // GIR_Coverage, 16688,
     /* 2030066 */     GIR_EraseRootFromParent_Done,
     /* 2030067 */   // Label 27082: @2030067
     /* 2030067 */   GIM_Try, /*On fail goto*//*Label 27083*/ GIMT_Encode4(2030172), // Rule ID 16689 //
     /* 2030072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2030083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2030086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2030089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2030095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030122 */     // MIs[1] Operand 1
     /* 2030122 */     // No operand predicates
     /* 2030122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030126 */     // MIs[0] round
     /* 2030126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030129 */     // MIs[0] policy
     /* 2030129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030141 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2030144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030171 */     // GIR_Coverage, 16689,
     /* 2030171 */     GIR_EraseRootFromParent_Done,
     /* 2030172 */   // Label 27083: @2030172
     /* 2030172 */   GIM_Try, /*On fail goto*//*Label 27084*/ GIMT_Encode4(2030277), // Rule ID 16692 //
     /* 2030177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2030188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2030191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030227 */     // MIs[1] Operand 1
     /* 2030227 */     // No operand predicates
     /* 2030227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030231 */     // MIs[0] round
     /* 2030231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030234 */     // MIs[0] policy
     /* 2030234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030246 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2030249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030276 */     // GIR_Coverage, 16692,
     /* 2030276 */     GIR_EraseRootFromParent_Done,
     /* 2030277 */   // Label 27084: @2030277
     /* 2030277 */   GIM_Try, /*On fail goto*//*Label 27085*/ GIMT_Encode4(2030382), // Rule ID 16693 //
     /* 2030282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2030293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2030296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030332 */     // MIs[1] Operand 1
     /* 2030332 */     // No operand predicates
     /* 2030332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030336 */     // MIs[0] round
     /* 2030336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030339 */     // MIs[0] policy
     /* 2030339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030351 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2030354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030377 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030381 */     // GIR_Coverage, 16693,
     /* 2030381 */     GIR_EraseRootFromParent_Done,
     /* 2030382 */   // Label 27085: @2030382
     /* 2030382 */   GIM_Try, /*On fail goto*//*Label 27086*/ GIMT_Encode4(2030487), // Rule ID 16696 //
     /* 2030387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2030398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2030401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2030404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030437 */     // MIs[1] Operand 1
     /* 2030437 */     // No operand predicates
     /* 2030437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030441 */     // MIs[0] round
     /* 2030441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030444 */     // MIs[0] policy
     /* 2030444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030456 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2030459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030486 */     // GIR_Coverage, 16696,
     /* 2030486 */     GIR_EraseRootFromParent_Done,
     /* 2030487 */   // Label 27086: @2030487
     /* 2030487 */   GIM_Try, /*On fail goto*//*Label 27087*/ GIMT_Encode4(2030592), // Rule ID 16697 //
     /* 2030492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2030503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2030506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2030509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030542 */     // MIs[1] Operand 1
     /* 2030542 */     // No operand predicates
     /* 2030542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030546 */     // MIs[0] round
     /* 2030546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030549 */     // MIs[0] policy
     /* 2030549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030561 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2030564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030591 */     // GIR_Coverage, 16697,
     /* 2030591 */     GIR_EraseRootFromParent_Done,
     /* 2030592 */   // Label 27087: @2030592
     /* 2030592 */   GIM_Try, /*On fail goto*//*Label 27088*/ GIMT_Encode4(2030697), // Rule ID 16700 //
     /* 2030597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2030608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2030611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2030614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030647 */     // MIs[1] Operand 1
     /* 2030647 */     // No operand predicates
     /* 2030647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030651 */     // MIs[0] round
     /* 2030651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030654 */     // MIs[0] policy
     /* 2030654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030666 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2030669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030696 */     // GIR_Coverage, 16700,
     /* 2030696 */     GIR_EraseRootFromParent_Done,
     /* 2030697 */   // Label 27088: @2030697
     /* 2030697 */   GIM_Try, /*On fail goto*//*Label 27089*/ GIMT_Encode4(2030802), // Rule ID 16701 //
     /* 2030702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2030713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2030716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2030719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030752 */     // MIs[1] Operand 1
     /* 2030752 */     // No operand predicates
     /* 2030752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030756 */     // MIs[0] round
     /* 2030756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030759 */     // MIs[0] policy
     /* 2030759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030771 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2030774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030801 */     // GIR_Coverage, 16701,
     /* 2030801 */     GIR_EraseRootFromParent_Done,
     /* 2030802 */   // Label 27089: @2030802
     /* 2030802 */   GIM_Try, /*On fail goto*//*Label 27090*/ GIMT_Encode4(2030889), // Rule ID 2772 //
     /* 2030807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2030810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2030815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2030818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2030821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2030824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2030827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030838 */     // MIs[0] passthru
     /* 2030838 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2030843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030851 */     // MIs[0] round
     /* 2030851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030854 */     // MIs[0] policy
     /* 2030854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030864 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2030867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030888 */     // GIR_Coverage, 2772,
     /* 2030888 */     GIR_EraseRootFromParent_Done,
     /* 2030889 */   // Label 27090: @2030889
     /* 2030889 */   GIM_Try, /*On fail goto*//*Label 27091*/ GIMT_Encode4(2030976), // Rule ID 2773 //
     /* 2030894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2030897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2030902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2030905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2030908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2030911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2030914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030925 */     // MIs[0] passthru
     /* 2030925 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2030930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030938 */     // MIs[0] round
     /* 2030938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030941 */     // MIs[0] policy
     /* 2030941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030951 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2030954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030975 */     // GIR_Coverage, 2773,
     /* 2030975 */     GIR_EraseRootFromParent_Done,
     /* 2030976 */   // Label 27091: @2030976
     /* 2030976 */   GIM_Try, /*On fail goto*//*Label 27092*/ GIMT_Encode4(2031063), // Rule ID 17152 //
     /* 2030981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2030984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2030989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2030992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2030995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2030998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031012 */     // MIs[0] passthru
     /* 2031012 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031025 */     // MIs[0] round
     /* 2031025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031028 */     // MIs[0] policy
     /* 2031028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031038 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2031041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031062 */     // GIR_Coverage, 17152,
     /* 2031062 */     GIR_EraseRootFromParent_Done,
     /* 2031063 */   // Label 27092: @2031063
     /* 2031063 */   GIM_Try, /*On fail goto*//*Label 27093*/ GIMT_Encode4(2031150), // Rule ID 17153 //
     /* 2031068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2031079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2031082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2031085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031099 */     // MIs[0] passthru
     /* 2031099 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031112 */     // MIs[0] round
     /* 2031112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031115 */     // MIs[0] policy
     /* 2031115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031125 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2031128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031149 */     // GIR_Coverage, 17153,
     /* 2031149 */     GIR_EraseRootFromParent_Done,
     /* 2031150 */   // Label 27093: @2031150
     /* 2031150 */   GIM_Try, /*On fail goto*//*Label 27094*/ GIMT_Encode4(2031237), // Rule ID 17162 //
     /* 2031155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2031166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2031169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2031172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031186 */     // MIs[0] passthru
     /* 2031186 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031199 */     // MIs[0] round
     /* 2031199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031202 */     // MIs[0] policy
     /* 2031202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031212 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2031215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031236 */     // GIR_Coverage, 17162,
     /* 2031236 */     GIR_EraseRootFromParent_Done,
     /* 2031237 */   // Label 27094: @2031237
     /* 2031237 */   GIM_Try, /*On fail goto*//*Label 27095*/ GIMT_Encode4(2031324), // Rule ID 17163 //
     /* 2031242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2031253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2031256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2031259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031273 */     // MIs[0] passthru
     /* 2031273 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031286 */     // MIs[0] round
     /* 2031286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031289 */     // MIs[0] policy
     /* 2031289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031299 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2031302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031323 */     // GIR_Coverage, 17163,
     /* 2031323 */     GIR_EraseRootFromParent_Done,
     /* 2031324 */   // Label 27095: @2031324
     /* 2031324 */   GIM_Try, /*On fail goto*//*Label 27096*/ GIMT_Encode4(2031411), // Rule ID 17172 //
     /* 2031329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2031346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031360 */     // MIs[0] passthru
     /* 2031360 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031373 */     // MIs[0] round
     /* 2031373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031376 */     // MIs[0] policy
     /* 2031376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031386 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2031389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031410 */     // GIR_Coverage, 17172,
     /* 2031410 */     GIR_EraseRootFromParent_Done,
     /* 2031411 */   // Label 27096: @2031411
     /* 2031411 */   GIM_Try, /*On fail goto*//*Label 27097*/ GIMT_Encode4(2031498), // Rule ID 17173 //
     /* 2031416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2031433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031447 */     // MIs[0] passthru
     /* 2031447 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031460 */     // MIs[0] round
     /* 2031460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031463 */     // MIs[0] policy
     /* 2031463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031473 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2031476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031497 */     // GIR_Coverage, 17173,
     /* 2031497 */     GIR_EraseRootFromParent_Done,
     /* 2031498 */   // Label 27097: @2031498
     /* 2031498 */   GIM_Try, /*On fail goto*//*Label 27098*/ GIMT_Encode4(2031585), // Rule ID 17182 //
     /* 2031503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2031514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2031517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2031520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2031523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2031530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031534 */     // MIs[0] passthru
     /* 2031534 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031547 */     // MIs[0] round
     /* 2031547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031550 */     // MIs[0] policy
     /* 2031550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031560 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2031563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031584 */     // GIR_Coverage, 17182,
     /* 2031584 */     GIR_EraseRootFromParent_Done,
     /* 2031585 */   // Label 27098: @2031585
     /* 2031585 */   GIM_Try, /*On fail goto*//*Label 27099*/ GIMT_Encode4(2031672), // Rule ID 17183 //
     /* 2031590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2031601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2031604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2031607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2031610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2031617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031621 */     // MIs[0] passthru
     /* 2031621 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031634 */     // MIs[0] round
     /* 2031634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031637 */     // MIs[0] policy
     /* 2031637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031647 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2031650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031671 */     // GIR_Coverage, 17183,
     /* 2031671 */     GIR_EraseRootFromParent_Done,
     /* 2031672 */   // Label 27099: @2031672
     /* 2031672 */   GIM_Try, /*On fail goto*//*Label 27100*/ GIMT_Encode4(2031759), // Rule ID 17192 //
     /* 2031677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2031680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2031688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2031691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2031694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031708 */     // MIs[0] passthru
     /* 2031708 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031721 */     // MIs[0] round
     /* 2031721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031724 */     // MIs[0] policy
     /* 2031724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031734 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2031737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031758 */     // GIR_Coverage, 17192,
     /* 2031758 */     GIR_EraseRootFromParent_Done,
     /* 2031759 */   // Label 27100: @2031759
     /* 2031759 */   GIM_Try, /*On fail goto*//*Label 27101*/ GIMT_Encode4(2031846), // Rule ID 17193 //
     /* 2031764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2031767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2031775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2031778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2031781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031795 */     // MIs[0] passthru
     /* 2031795 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031808 */     // MIs[0] round
     /* 2031808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031811 */     // MIs[0] policy
     /* 2031811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031821 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2031824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031845 */     // GIR_Coverage, 17193,
     /* 2031845 */     GIR_EraseRootFromParent_Done,
     /* 2031846 */   // Label 27101: @2031846
     /* 2031846 */   GIM_Try, /*On fail goto*//*Label 27102*/ GIMT_Encode4(2031933), // Rule ID 17202 //
     /* 2031851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2031854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2031862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2031865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2031868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031882 */     // MIs[0] passthru
     /* 2031882 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031895 */     // MIs[0] round
     /* 2031895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031898 */     // MIs[0] policy
     /* 2031898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031908 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2031911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031932 */     // GIR_Coverage, 17202,
     /* 2031932 */     GIR_EraseRootFromParent_Done,
     /* 2031933 */   // Label 27102: @2031933
     /* 2031933 */   GIM_Try, /*On fail goto*//*Label 27103*/ GIMT_Encode4(2032020), // Rule ID 17203 //
     /* 2031938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2031941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2031949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2031952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2031955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031969 */     // MIs[0] passthru
     /* 2031969 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031982 */     // MIs[0] round
     /* 2031982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031985 */     // MIs[0] policy
     /* 2031985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031995 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2031998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032019 */     // GIR_Coverage, 17203,
     /* 2032019 */     GIR_EraseRootFromParent_Done,
     /* 2032020 */   // Label 27103: @2032020
     /* 2032020 */   GIM_Try, /*On fail goto*//*Label 27104*/ GIMT_Encode4(2032107), // Rule ID 17212 //
     /* 2032025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2032028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2032036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2032039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2032042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032045 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032056 */     // MIs[0] passthru
     /* 2032056 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032069 */     // MIs[0] round
     /* 2032069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032072 */     // MIs[0] policy
     /* 2032072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032082 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2032085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032106 */     // GIR_Coverage, 17212,
     /* 2032106 */     GIR_EraseRootFromParent_Done,
     /* 2032107 */   // Label 27104: @2032107
     /* 2032107 */   GIM_Try, /*On fail goto*//*Label 27105*/ GIMT_Encode4(2032194), // Rule ID 17213 //
     /* 2032112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2032115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2032123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2032126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2032129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032143 */     // MIs[0] passthru
     /* 2032143 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032156 */     // MIs[0] round
     /* 2032156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032159 */     // MIs[0] policy
     /* 2032159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032169 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2032172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032193 */     // GIR_Coverage, 17213,
     /* 2032193 */     GIR_EraseRootFromParent_Done,
     /* 2032194 */   // Label 27105: @2032194
     /* 2032194 */   GIM_Try, /*On fail goto*//*Label 27106*/ GIMT_Encode4(2032281), // Rule ID 17222 //
     /* 2032199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2032202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2032210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2032213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2032216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2032226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2032230 */     // MIs[0] passthru
     /* 2032230 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032243 */     // MIs[0] round
     /* 2032243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032246 */     // MIs[0] policy
     /* 2032246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032256 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2032259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032280 */     // GIR_Coverage, 17222,
     /* 2032280 */     GIR_EraseRootFromParent_Done,
     /* 2032281 */   // Label 27106: @2032281
     /* 2032281 */   GIM_Try, /*On fail goto*//*Label 27107*/ GIMT_Encode4(2032368), // Rule ID 17223 //
     /* 2032286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2032289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2032297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2032300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2032303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2032313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2032317 */     // MIs[0] passthru
     /* 2032317 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032330 */     // MIs[0] round
     /* 2032330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032333 */     // MIs[0] policy
     /* 2032333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032343 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2032346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032367 */     // GIR_Coverage, 17223,
     /* 2032367 */     GIR_EraseRootFromParent_Done,
     /* 2032368 */   // Label 27107: @2032368
     /* 2032368 */   GIM_Try, /*On fail goto*//*Label 27108*/ GIMT_Encode4(2032455), // Rule ID 17268 //
     /* 2032373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2032376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2032384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2032387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2032390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032404 */     // MIs[0] passthru
     /* 2032404 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032417 */     // MIs[0] round
     /* 2032417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032420 */     // MIs[0] policy
     /* 2032420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032430 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2032433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032454 */     // GIR_Coverage, 17268,
     /* 2032454 */     GIR_EraseRootFromParent_Done,
     /* 2032455 */   // Label 27108: @2032455
     /* 2032455 */   GIM_Try, /*On fail goto*//*Label 27109*/ GIMT_Encode4(2032542), // Rule ID 17269 //
     /* 2032460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2032463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2032471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2032474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2032477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032491 */     // MIs[0] passthru
     /* 2032491 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032504 */     // MIs[0] round
     /* 2032504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032507 */     // MIs[0] policy
     /* 2032507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032517 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2032520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032541 */     // GIR_Coverage, 17269,
     /* 2032541 */     GIR_EraseRootFromParent_Done,
     /* 2032542 */   // Label 27109: @2032542
     /* 2032542 */   GIM_Try, /*On fail goto*//*Label 27110*/ GIMT_Encode4(2032629), // Rule ID 17278 //
     /* 2032547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2032550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2032558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2032561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2032564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032578 */     // MIs[0] passthru
     /* 2032578 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032591 */     // MIs[0] round
     /* 2032591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032594 */     // MIs[0] policy
     /* 2032594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032604 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2032607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032628 */     // GIR_Coverage, 17278,
     /* 2032628 */     GIR_EraseRootFromParent_Done,
     /* 2032629 */   // Label 27110: @2032629
     /* 2032629 */   GIM_Try, /*On fail goto*//*Label 27111*/ GIMT_Encode4(2032716), // Rule ID 17279 //
     /* 2032634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2032637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2032645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2032648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2032651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032665 */     // MIs[0] passthru
     /* 2032665 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032678 */     // MIs[0] round
     /* 2032678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032681 */     // MIs[0] policy
     /* 2032681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032691 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2032694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032715 */     // GIR_Coverage, 17279,
     /* 2032715 */     GIR_EraseRootFromParent_Done,
     /* 2032716 */   // Label 27111: @2032716
     /* 2032716 */   GIM_Try, /*On fail goto*//*Label 27112*/ GIMT_Encode4(2032803), // Rule ID 17288 //
     /* 2032721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2032724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2032732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2032735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2032738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2032748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032752 */     // MIs[0] passthru
     /* 2032752 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032765 */     // MIs[0] round
     /* 2032765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032768 */     // MIs[0] policy
     /* 2032768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032778 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2032781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032802 */     // GIR_Coverage, 17288,
     /* 2032802 */     GIR_EraseRootFromParent_Done,
     /* 2032803 */   // Label 27112: @2032803
     /* 2032803 */   GIM_Try, /*On fail goto*//*Label 27113*/ GIMT_Encode4(2032890), // Rule ID 17289 //
     /* 2032808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2032811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2032819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2032822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2032825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2032835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032839 */     // MIs[0] passthru
     /* 2032839 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032852 */     // MIs[0] round
     /* 2032852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032855 */     // MIs[0] policy
     /* 2032855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032865 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2032868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032889 */     // GIR_Coverage, 17289,
     /* 2032889 */     GIR_EraseRootFromParent_Done,
     /* 2032890 */   // Label 27113: @2032890
     /* 2032890 */   GIM_Try, /*On fail goto*//*Label 27114*/ GIMT_Encode4(2032977), // Rule ID 17298 //
     /* 2032895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2032898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2032906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2032909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2032912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032926 */     // MIs[0] passthru
     /* 2032926 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032939 */     // MIs[0] round
     /* 2032939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032942 */     // MIs[0] policy
     /* 2032942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032952 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2032955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032976 */     // GIR_Coverage, 17298,
     /* 2032976 */     GIR_EraseRootFromParent_Done,
     /* 2032977 */   // Label 27114: @2032977
     /* 2032977 */   GIM_Try, /*On fail goto*//*Label 27115*/ GIMT_Encode4(2033064), // Rule ID 17299 //
     /* 2032982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2032985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2032993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2032996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2032999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033013 */     // MIs[0] passthru
     /* 2033013 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033026 */     // MIs[0] round
     /* 2033026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033029 */     // MIs[0] policy
     /* 2033029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033039 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2033042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033063 */     // GIR_Coverage, 17299,
     /* 2033063 */     GIR_EraseRootFromParent_Done,
     /* 2033064 */   // Label 27115: @2033064
     /* 2033064 */   GIM_Try, /*On fail goto*//*Label 27116*/ GIMT_Encode4(2033151), // Rule ID 17308 //
     /* 2033069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2033072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2033080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2033083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2033086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033100 */     // MIs[0] passthru
     /* 2033100 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033113 */     // MIs[0] round
     /* 2033113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033116 */     // MIs[0] policy
     /* 2033116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033126 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2033129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033150 */     // GIR_Coverage, 17308,
     /* 2033150 */     GIR_EraseRootFromParent_Done,
     /* 2033151 */   // Label 27116: @2033151
     /* 2033151 */   GIM_Try, /*On fail goto*//*Label 27117*/ GIMT_Encode4(2033238), // Rule ID 17309 //
     /* 2033156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2033159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2033167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2033170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2033173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033187 */     // MIs[0] passthru
     /* 2033187 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033200 */     // MIs[0] round
     /* 2033200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033203 */     // MIs[0] policy
     /* 2033203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033213 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2033216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033237 */     // GIR_Coverage, 17309,
     /* 2033237 */     GIR_EraseRootFromParent_Done,
     /* 2033238 */   // Label 27117: @2033238
     /* 2033238 */   GIM_Try, /*On fail goto*//*Label 27118*/ GIMT_Encode4(2033325), // Rule ID 17318 //
     /* 2033243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2033246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2033254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2033257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2033260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033274 */     // MIs[0] passthru
     /* 2033274 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033287 */     // MIs[0] round
     /* 2033287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033290 */     // MIs[0] policy
     /* 2033290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033300 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2033303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033324 */     // GIR_Coverage, 17318,
     /* 2033324 */     GIR_EraseRootFromParent_Done,
     /* 2033325 */   // Label 27118: @2033325
     /* 2033325 */   GIM_Try, /*On fail goto*//*Label 27119*/ GIMT_Encode4(2033412), // Rule ID 17319 //
     /* 2033330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2033333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2033341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2033344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2033347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033361 */     // MIs[0] passthru
     /* 2033361 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033374 */     // MIs[0] round
     /* 2033374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033377 */     // MIs[0] policy
     /* 2033377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033387 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2033390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033411 */     // GIR_Coverage, 17319,
     /* 2033411 */     GIR_EraseRootFromParent_Done,
     /* 2033412 */   // Label 27119: @2033412
     /* 2033412 */   GIM_Try, /*On fail goto*//*Label 27120*/ GIMT_Encode4(2033499), // Rule ID 17328 //
     /* 2033417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2033420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2033428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2033431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2033434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033448 */     // MIs[0] passthru
     /* 2033448 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033461 */     // MIs[0] round
     /* 2033461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033464 */     // MIs[0] policy
     /* 2033464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033474 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2033477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033498 */     // GIR_Coverage, 17328,
     /* 2033498 */     GIR_EraseRootFromParent_Done,
     /* 2033499 */   // Label 27120: @2033499
     /* 2033499 */   GIM_Try, /*On fail goto*//*Label 27121*/ GIMT_Encode4(2033586), // Rule ID 17329 //
     /* 2033504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2033507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2033515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2033518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2033521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033535 */     // MIs[0] passthru
     /* 2033535 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033548 */     // MIs[0] round
     /* 2033548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033551 */     // MIs[0] policy
     /* 2033551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033561 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2033564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033585 */     // GIR_Coverage, 17329,
     /* 2033585 */     GIR_EraseRootFromParent_Done,
     /* 2033586 */   // Label 27121: @2033586
     /* 2033586 */   GIM_Try, /*On fail goto*//*Label 27122*/ GIMT_Encode4(2033673), // Rule ID 17338 //
     /* 2033591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2033594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2033602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2033605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2033608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2033611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033622 */     // MIs[0] passthru
     /* 2033622 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033635 */     // MIs[0] round
     /* 2033635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033638 */     // MIs[0] policy
     /* 2033638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033648 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2033651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033672 */     // GIR_Coverage, 17338,
     /* 2033672 */     GIR_EraseRootFromParent_Done,
     /* 2033673 */   // Label 27122: @2033673
     /* 2033673 */   GIM_Try, /*On fail goto*//*Label 27123*/ GIMT_Encode4(2033760), // Rule ID 17339 //
     /* 2033678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2033681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2033689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2033692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2033695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2033698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033709 */     // MIs[0] passthru
     /* 2033709 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033722 */     // MIs[0] round
     /* 2033722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033725 */     // MIs[0] policy
     /* 2033725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033735 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2033738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033759 */     // GIR_Coverage, 17339,
     /* 2033759 */     GIR_EraseRootFromParent_Done,
     /* 2033760 */   // Label 27123: @2033760
     /* 2033760 */   GIM_Try, /*On fail goto*//*Label 27124*/ GIMT_Encode4(2033847), // Rule ID 17348 //
     /* 2033765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2033768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2033776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2033779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2033782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033796 */     // MIs[0] passthru
     /* 2033796 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033809 */     // MIs[0] round
     /* 2033809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033812 */     // MIs[0] policy
     /* 2033812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033822 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2033825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033846 */     // GIR_Coverage, 17348,
     /* 2033846 */     GIR_EraseRootFromParent_Done,
     /* 2033847 */   // Label 27124: @2033847
     /* 2033847 */   GIM_Try, /*On fail goto*//*Label 27125*/ GIMT_Encode4(2033934), // Rule ID 17349 //
     /* 2033852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2033855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2033863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2033866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2033869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033883 */     // MIs[0] passthru
     /* 2033883 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033896 */     // MIs[0] round
     /* 2033896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033899 */     // MIs[0] policy
     /* 2033899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033909 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2033912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033933 */     // GIR_Coverage, 17349,
     /* 2033933 */     GIR_EraseRootFromParent_Done,
     /* 2033934 */   // Label 27125: @2033934
     /* 2033934 */   GIM_Try, /*On fail goto*//*Label 27126*/ GIMT_Encode4(2034025), // Rule ID 2730 //
     /* 2033939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2033947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2033950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2033953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2033956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2033959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033985 */     // MIs[0] round
     /* 2033985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033988 */     // MIs[0] policy
     /* 2033988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033998 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2034001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034024 */     // GIR_Coverage, 2730,
     /* 2034024 */     GIR_EraseRootFromParent_Done,
     /* 2034025 */   // Label 27126: @2034025
     /* 2034025 */   GIM_Try, /*On fail goto*//*Label 27127*/ GIMT_Encode4(2034116), // Rule ID 2731 //
     /* 2034030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2034041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2034044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2034047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2034050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034076 */     // MIs[0] round
     /* 2034076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034079 */     // MIs[0] policy
     /* 2034079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034089 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2034092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034115 */     // GIR_Coverage, 2731,
     /* 2034115 */     GIR_EraseRootFromParent_Done,
     /* 2034116 */   // Label 27127: @2034116
     /* 2034116 */   GIM_Try, /*On fail goto*//*Label 27128*/ GIMT_Encode4(2034207), // Rule ID 2774 //
     /* 2034121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2034124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2034129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2034132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2034135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2034138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034167 */     // MIs[0] round
     /* 2034167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034170 */     // MIs[0] policy
     /* 2034170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034180 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2034183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034206 */     // GIR_Coverage, 2774,
     /* 2034206 */     GIR_EraseRootFromParent_Done,
     /* 2034207 */   // Label 27128: @2034207
     /* 2034207 */   GIM_Try, /*On fail goto*//*Label 27129*/ GIMT_Encode4(2034298), // Rule ID 2775 //
     /* 2034212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2034215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2034220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2034223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2034226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2034229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034258 */     // MIs[0] round
     /* 2034258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034261 */     // MIs[0] policy
     /* 2034261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034271 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2034274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034297 */     // GIR_Coverage, 2775,
     /* 2034297 */     GIR_EraseRootFromParent_Done,
     /* 2034298 */   // Label 27129: @2034298
     /* 2034298 */   GIM_Try, /*On fail goto*//*Label 27130*/ GIMT_Encode4(2034389), // Rule ID 2782 //
     /* 2034303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2034306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2034311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034349 */     // MIs[0] round
     /* 2034349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034352 */     // MIs[0] policy
     /* 2034352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034362 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2034365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2034369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034388 */     // GIR_Coverage, 2782,
     /* 2034388 */     GIR_EraseRootFromParent_Done,
     /* 2034389 */   // Label 27130: @2034389
     /* 2034389 */   GIM_Try, /*On fail goto*//*Label 27131*/ GIMT_Encode4(2034480), // Rule ID 2783 //
     /* 2034394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2034397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2034402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034417 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034440 */     // MIs[0] round
     /* 2034440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034443 */     // MIs[0] policy
     /* 2034443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034453 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2034456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2034460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034479 */     // GIR_Coverage, 2783,
     /* 2034479 */     GIR_EraseRootFromParent_Done,
     /* 2034480 */   // Label 27131: @2034480
     /* 2034480 */   GIM_Try, /*On fail goto*//*Label 27132*/ GIMT_Encode4(2034571), // Rule ID 14940 //
     /* 2034485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2034496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2034499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2034502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2034505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034531 */     // MIs[0] round
     /* 2034531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034534 */     // MIs[0] policy
     /* 2034534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034544 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2034547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034570 */     // GIR_Coverage, 14940,
     /* 2034570 */     GIR_EraseRootFromParent_Done,
     /* 2034571 */   // Label 27132: @2034571
     /* 2034571 */   GIM_Try, /*On fail goto*//*Label 27133*/ GIMT_Encode4(2034662), // Rule ID 14941 //
     /* 2034576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2034587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2034590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2034593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2034596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034622 */     // MIs[0] round
     /* 2034622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034625 */     // MIs[0] policy
     /* 2034625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034635 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2034638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034661 */     // GIR_Coverage, 14941,
     /* 2034661 */     GIR_EraseRootFromParent_Done,
     /* 2034662 */   // Label 27133: @2034662
     /* 2034662 */   GIM_Try, /*On fail goto*//*Label 27134*/ GIMT_Encode4(2034753), // Rule ID 14944 //
     /* 2034667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2034678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2034681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2034684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2034687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034713 */     // MIs[0] round
     /* 2034713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034716 */     // MIs[0] policy
     /* 2034716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034726 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2034729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034752 */     // GIR_Coverage, 14944,
     /* 2034752 */     GIR_EraseRootFromParent_Done,
     /* 2034753 */   // Label 27134: @2034753
     /* 2034753 */   GIM_Try, /*On fail goto*//*Label 27135*/ GIMT_Encode4(2034844), // Rule ID 14945 //
     /* 2034758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2034769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2034772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2034775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2034778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034804 */     // MIs[0] round
     /* 2034804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034807 */     // MIs[0] policy
     /* 2034807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034817 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2034820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034843 */     // GIR_Coverage, 14945,
     /* 2034843 */     GIR_EraseRootFromParent_Done,
     /* 2034844 */   // Label 27135: @2034844
     /* 2034844 */   GIM_Try, /*On fail goto*//*Label 27136*/ GIMT_Encode4(2034935), // Rule ID 14948 //
     /* 2034849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034895 */     // MIs[0] round
     /* 2034895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034898 */     // MIs[0] policy
     /* 2034898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034908 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2034911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034934 */     // GIR_Coverage, 14948,
     /* 2034934 */     GIR_EraseRootFromParent_Done,
     /* 2034935 */   // Label 27136: @2034935
     /* 2034935 */   GIM_Try, /*On fail goto*//*Label 27137*/ GIMT_Encode4(2035026), // Rule ID 14949 //
     /* 2034940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034986 */     // MIs[0] round
     /* 2034986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034989 */     // MIs[0] policy
     /* 2034989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034999 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2035002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035025 */     // GIR_Coverage, 14949,
     /* 2035025 */     GIR_EraseRootFromParent_Done,
     /* 2035026 */   // Label 27137: @2035026
     /* 2035026 */   GIM_Try, /*On fail goto*//*Label 27138*/ GIMT_Encode4(2035117), // Rule ID 14952 //
     /* 2035031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2035042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2035045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2035048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2035051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035077 */     // MIs[0] round
     /* 2035077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035080 */     // MIs[0] policy
     /* 2035080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035090 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035116 */     // GIR_Coverage, 14952,
     /* 2035116 */     GIR_EraseRootFromParent_Done,
     /* 2035117 */   // Label 27138: @2035117
     /* 2035117 */   GIM_Try, /*On fail goto*//*Label 27139*/ GIMT_Encode4(2035208), // Rule ID 14953 //
     /* 2035122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2035133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2035136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2035139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2035142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035168 */     // MIs[0] round
     /* 2035168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035171 */     // MIs[0] policy
     /* 2035171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035181 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035207 */     // GIR_Coverage, 14953,
     /* 2035207 */     GIR_EraseRootFromParent_Done,
     /* 2035208 */   // Label 27139: @2035208
     /* 2035208 */   GIM_Try, /*On fail goto*//*Label 27140*/ GIMT_Encode4(2035299), // Rule ID 14956 //
     /* 2035213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2035224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2035227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2035230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2035233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035259 */     // MIs[0] round
     /* 2035259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035262 */     // MIs[0] policy
     /* 2035262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035272 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035298 */     // GIR_Coverage, 14956,
     /* 2035298 */     GIR_EraseRootFromParent_Done,
     /* 2035299 */   // Label 27140: @2035299
     /* 2035299 */   GIM_Try, /*On fail goto*//*Label 27141*/ GIMT_Encode4(2035390), // Rule ID 14957 //
     /* 2035304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2035315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2035318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2035321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2035324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035350 */     // MIs[0] round
     /* 2035350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035353 */     // MIs[0] policy
     /* 2035353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035363 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035389 */     // GIR_Coverage, 14957,
     /* 2035389 */     GIR_EraseRootFromParent_Done,
     /* 2035390 */   // Label 27141: @2035390
     /* 2035390 */   GIM_Try, /*On fail goto*//*Label 27142*/ GIMT_Encode4(2035481), // Rule ID 14960 //
     /* 2035395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2035406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2035409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2035412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2035415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035441 */     // MIs[0] round
     /* 2035441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035444 */     // MIs[0] policy
     /* 2035444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035454 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035480 */     // GIR_Coverage, 14960,
     /* 2035480 */     GIR_EraseRootFromParent_Done,
     /* 2035481 */   // Label 27142: @2035481
     /* 2035481 */   GIM_Try, /*On fail goto*//*Label 27143*/ GIMT_Encode4(2035572), // Rule ID 14961 //
     /* 2035486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2035497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2035500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2035503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2035506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035532 */     // MIs[0] round
     /* 2035532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035535 */     // MIs[0] policy
     /* 2035535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035545 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035571 */     // GIR_Coverage, 14961,
     /* 2035571 */     GIR_EraseRootFromParent_Done,
     /* 2035572 */   // Label 27143: @2035572
     /* 2035572 */   GIM_Try, /*On fail goto*//*Label 27144*/ GIMT_Encode4(2035663), // Rule ID 14964 //
     /* 2035577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2035588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2035591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2035594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2035597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035623 */     // MIs[0] round
     /* 2035623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035626 */     // MIs[0] policy
     /* 2035626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035636 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035662 */     // GIR_Coverage, 14964,
     /* 2035662 */     GIR_EraseRootFromParent_Done,
     /* 2035663 */   // Label 27144: @2035663
     /* 2035663 */   GIM_Try, /*On fail goto*//*Label 27145*/ GIMT_Encode4(2035754), // Rule ID 14965 //
     /* 2035668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2035679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2035682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2035685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2035688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035714 */     // MIs[0] round
     /* 2035714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035717 */     // MIs[0] policy
     /* 2035717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035727 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035753 */     // GIR_Coverage, 14965,
     /* 2035753 */     GIR_EraseRootFromParent_Done,
     /* 2035754 */   // Label 27145: @2035754
     /* 2035754 */   GIM_Try, /*On fail goto*//*Label 27146*/ GIMT_Encode4(2035845), // Rule ID 14968 //
     /* 2035759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2035770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2035773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2035776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2035779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035805 */     // MIs[0] round
     /* 2035805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035808 */     // MIs[0] policy
     /* 2035808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035844 */     // GIR_Coverage, 14968,
     /* 2035844 */     GIR_EraseRootFromParent_Done,
     /* 2035845 */   // Label 27146: @2035845
     /* 2035845 */   GIM_Try, /*On fail goto*//*Label 27147*/ GIMT_Encode4(2035936), // Rule ID 14969 //
     /* 2035850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2035861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2035864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2035867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2035870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035896 */     // MIs[0] round
     /* 2035896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035899 */     // MIs[0] policy
     /* 2035899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035909 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035935 */     // GIR_Coverage, 14969,
     /* 2035935 */     GIR_EraseRootFromParent_Done,
     /* 2035936 */   // Label 27147: @2035936
     /* 2035936 */   GIM_Try, /*On fail goto*//*Label 27148*/ GIMT_Encode4(2036027), // Rule ID 14972 //
     /* 2035941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2035944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2035952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2035955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2035958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2035961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035987 */     // MIs[0] round
     /* 2035987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035990 */     // MIs[0] policy
     /* 2035990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036000 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036026 */     // GIR_Coverage, 14972,
     /* 2036026 */     GIR_EraseRootFromParent_Done,
     /* 2036027 */   // Label 27148: @2036027
     /* 2036027 */   GIM_Try, /*On fail goto*//*Label 27149*/ GIMT_Encode4(2036118), // Rule ID 14973 //
     /* 2036032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2036035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2036043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2036046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2036049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2036052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036078 */     // MIs[0] round
     /* 2036078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036081 */     // MIs[0] policy
     /* 2036081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036091 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036117 */     // GIR_Coverage, 14973,
     /* 2036117 */     GIR_EraseRootFromParent_Done,
     /* 2036118 */   // Label 27149: @2036118
     /* 2036118 */   GIM_Try, /*On fail goto*//*Label 27150*/ GIMT_Encode4(2036209), // Rule ID 14976 //
     /* 2036123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2036134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2036137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2036140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2036143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036169 */     // MIs[0] round
     /* 2036169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036172 */     // MIs[0] policy
     /* 2036172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036182 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2036185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036208 */     // GIR_Coverage, 14976,
     /* 2036208 */     GIR_EraseRootFromParent_Done,
     /* 2036209 */   // Label 27150: @2036209
     /* 2036209 */   GIM_Try, /*On fail goto*//*Label 27151*/ GIMT_Encode4(2036300), // Rule ID 14977 //
     /* 2036214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2036225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2036228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2036231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2036234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036237 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036260 */     // MIs[0] round
     /* 2036260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036263 */     // MIs[0] policy
     /* 2036263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036273 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2036276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036299 */     // GIR_Coverage, 14977,
     /* 2036299 */     GIR_EraseRootFromParent_Done,
     /* 2036300 */   // Label 27151: @2036300
     /* 2036300 */   GIM_Try, /*On fail goto*//*Label 27152*/ GIMT_Encode4(2036391), // Rule ID 14980 //
     /* 2036305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2036316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2036319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2036322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2036325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2036328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036351 */     // MIs[0] round
     /* 2036351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036354 */     // MIs[0] policy
     /* 2036354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036364 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2036367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036390 */     // GIR_Coverage, 14980,
     /* 2036390 */     GIR_EraseRootFromParent_Done,
     /* 2036391 */   // Label 27152: @2036391
     /* 2036391 */   GIM_Try, /*On fail goto*//*Label 27153*/ GIMT_Encode4(2036482), // Rule ID 14981 //
     /* 2036396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2036407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2036410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2036413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2036416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2036419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036442 */     // MIs[0] round
     /* 2036442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036445 */     // MIs[0] policy
     /* 2036445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036455 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2036458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036481 */     // GIR_Coverage, 14981,
     /* 2036481 */     GIR_EraseRootFromParent_Done,
     /* 2036482 */   // Label 27153: @2036482
     /* 2036482 */   GIM_Try, /*On fail goto*//*Label 27154*/ GIMT_Encode4(2036573), // Rule ID 14984 //
     /* 2036487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2036498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2036501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2036504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2036507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2036510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2036517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036533 */     // MIs[0] round
     /* 2036533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036536 */     // MIs[0] policy
     /* 2036536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036546 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2036549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036572 */     // GIR_Coverage, 14984,
     /* 2036572 */     GIR_EraseRootFromParent_Done,
     /* 2036573 */   // Label 27154: @2036573
     /* 2036573 */   GIM_Try, /*On fail goto*//*Label 27155*/ GIMT_Encode4(2036664), // Rule ID 14985 //
     /* 2036578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2036589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2036592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2036595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2036598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2036601 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2036608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036624 */     // MIs[0] round
     /* 2036624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036627 */     // MIs[0] policy
     /* 2036627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036637 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2036640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036663 */     // GIR_Coverage, 14985,
     /* 2036663 */     GIR_EraseRootFromParent_Done,
     /* 2036664 */   // Label 27155: @2036664
     /* 2036664 */   GIM_Try, /*On fail goto*//*Label 27156*/ GIMT_Encode4(2036755), // Rule ID 14988 //
     /* 2036669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2036680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2036683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2036686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2036689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036715 */     // MIs[0] round
     /* 2036715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036718 */     // MIs[0] policy
     /* 2036718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2036731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036754 */     // GIR_Coverage, 14988,
     /* 2036754 */     GIR_EraseRootFromParent_Done,
     /* 2036755 */   // Label 27156: @2036755
     /* 2036755 */   GIM_Try, /*On fail goto*//*Label 27157*/ GIMT_Encode4(2036846), // Rule ID 14989 //
     /* 2036760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2036771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2036774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2036777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2036780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036806 */     // MIs[0] round
     /* 2036806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036809 */     // MIs[0] policy
     /* 2036809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036819 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2036822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036845 */     // GIR_Coverage, 14989,
     /* 2036845 */     GIR_EraseRootFromParent_Done,
     /* 2036846 */   // Label 27157: @2036846
     /* 2036846 */   GIM_Try, /*On fail goto*//*Label 27158*/ GIMT_Encode4(2036937), // Rule ID 14992 //
     /* 2036851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2036862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2036865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2036868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2036871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036897 */     // MIs[0] round
     /* 2036897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036900 */     // MIs[0] policy
     /* 2036900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036910 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2036913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036936 */     // GIR_Coverage, 14992,
     /* 2036936 */     GIR_EraseRootFromParent_Done,
     /* 2036937 */   // Label 27158: @2036937
     /* 2036937 */   GIM_Try, /*On fail goto*//*Label 27159*/ GIMT_Encode4(2037028), // Rule ID 14993 //
     /* 2036942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2036953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2036956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2036959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2036962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036988 */     // MIs[0] round
     /* 2036988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036991 */     // MIs[0] policy
     /* 2036991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037001 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2037004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037027 */     // GIR_Coverage, 14993,
     /* 2037027 */     GIR_EraseRootFromParent_Done,
     /* 2037028 */   // Label 27159: @2037028
     /* 2037028 */   GIM_Try, /*On fail goto*//*Label 27160*/ GIMT_Encode4(2037119), // Rule ID 14996 //
     /* 2037033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2037044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2037047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2037050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2037053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037079 */     // MIs[0] round
     /* 2037079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037082 */     // MIs[0] policy
     /* 2037082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037092 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037118 */     // GIR_Coverage, 14996,
     /* 2037118 */     GIR_EraseRootFromParent_Done,
     /* 2037119 */   // Label 27160: @2037119
     /* 2037119 */   GIM_Try, /*On fail goto*//*Label 27161*/ GIMT_Encode4(2037210), // Rule ID 14997 //
     /* 2037124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2037135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2037138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2037141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2037144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037170 */     // MIs[0] round
     /* 2037170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037173 */     // MIs[0] policy
     /* 2037173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037183 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037209 */     // GIR_Coverage, 14997,
     /* 2037209 */     GIR_EraseRootFromParent_Done,
     /* 2037210 */   // Label 27161: @2037210
     /* 2037210 */   GIM_Try, /*On fail goto*//*Label 27162*/ GIMT_Encode4(2037301), // Rule ID 15000 //
     /* 2037215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2037226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2037229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2037232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2037235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037261 */     // MIs[0] round
     /* 2037261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037264 */     // MIs[0] policy
     /* 2037264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037300 */     // GIR_Coverage, 15000,
     /* 2037300 */     GIR_EraseRootFromParent_Done,
     /* 2037301 */   // Label 27162: @2037301
     /* 2037301 */   GIM_Try, /*On fail goto*//*Label 27163*/ GIMT_Encode4(2037392), // Rule ID 15001 //
     /* 2037306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2037317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2037320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2037323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2037326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037352 */     // MIs[0] round
     /* 2037352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037355 */     // MIs[0] policy
     /* 2037355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037365 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037391 */     // GIR_Coverage, 15001,
     /* 2037391 */     GIR_EraseRootFromParent_Done,
     /* 2037392 */   // Label 27163: @2037392
     /* 2037392 */   GIM_Try, /*On fail goto*//*Label 27164*/ GIMT_Encode4(2037483), // Rule ID 15004 //
     /* 2037397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2037408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2037411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2037414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2037417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037443 */     // MIs[0] round
     /* 2037443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037446 */     // MIs[0] policy
     /* 2037446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037456 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2037459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037482 */     // GIR_Coverage, 15004,
     /* 2037482 */     GIR_EraseRootFromParent_Done,
     /* 2037483 */   // Label 27164: @2037483
     /* 2037483 */   GIM_Try, /*On fail goto*//*Label 27165*/ GIMT_Encode4(2037574), // Rule ID 15005 //
     /* 2037488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2037499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2037502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2037505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2037508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037534 */     // MIs[0] round
     /* 2037534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037537 */     // MIs[0] policy
     /* 2037537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037547 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2037550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037573 */     // GIR_Coverage, 15005,
     /* 2037573 */     GIR_EraseRootFromParent_Done,
     /* 2037574 */   // Label 27165: @2037574
     /* 2037574 */   GIM_Try, /*On fail goto*//*Label 27166*/ GIMT_Encode4(2037665), // Rule ID 15008 //
     /* 2037579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2037590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2037593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2037596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2037599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037625 */     // MIs[0] round
     /* 2037625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037628 */     // MIs[0] policy
     /* 2037628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037638 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037664 */     // GIR_Coverage, 15008,
     /* 2037664 */     GIR_EraseRootFromParent_Done,
     /* 2037665 */   // Label 27166: @2037665
     /* 2037665 */   GIM_Try, /*On fail goto*//*Label 27167*/ GIMT_Encode4(2037756), // Rule ID 15009 //
     /* 2037670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2037681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2037684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2037687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2037690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037716 */     // MIs[0] round
     /* 2037716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037719 */     // MIs[0] policy
     /* 2037719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037729 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037755 */     // GIR_Coverage, 15009,
     /* 2037755 */     GIR_EraseRootFromParent_Done,
     /* 2037756 */   // Label 27167: @2037756
     /* 2037756 */   GIM_Try, /*On fail goto*//*Label 27168*/ GIMT_Encode4(2037847), // Rule ID 15012 //
     /* 2037761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2037764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2037772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2037775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2037778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2037781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2037784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037807 */     // MIs[0] round
     /* 2037807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037810 */     // MIs[0] policy
     /* 2037810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037820 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2037843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037846 */     // GIR_Coverage, 15012,
     /* 2037846 */     GIR_EraseRootFromParent_Done,
     /* 2037847 */   // Label 27168: @2037847
     /* 2037847 */   GIM_Try, /*On fail goto*//*Label 27169*/ GIMT_Encode4(2037938), // Rule ID 15013 //
     /* 2037852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2037855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2037863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2037866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2037869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2037872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2037875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037898 */     // MIs[0] round
     /* 2037898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037901 */     // MIs[0] policy
     /* 2037901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037911 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2037934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037937 */     // GIR_Coverage, 15013,
     /* 2037937 */     GIR_EraseRootFromParent_Done,
     /* 2037938 */   // Label 27169: @2037938
     /* 2037938 */   GIM_Try, /*On fail goto*//*Label 27170*/ GIMT_Encode4(2038029), // Rule ID 15016 //
     /* 2037943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2037946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2037954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2037957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2037960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2037963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037989 */     // MIs[0] round
     /* 2037989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037992 */     // MIs[0] policy
     /* 2037992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038002 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2038005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038028 */     // GIR_Coverage, 15016,
     /* 2038028 */     GIR_EraseRootFromParent_Done,
     /* 2038029 */   // Label 27170: @2038029
     /* 2038029 */   GIM_Try, /*On fail goto*//*Label 27171*/ GIMT_Encode4(2038120), // Rule ID 15017 //
     /* 2038034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2038045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2038048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2038051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2038054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038080 */     // MIs[0] round
     /* 2038080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038083 */     // MIs[0] policy
     /* 2038083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038093 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2038096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038119 */     // GIR_Coverage, 15017,
     /* 2038119 */     GIR_EraseRootFromParent_Done,
     /* 2038120 */   // Label 27171: @2038120
     /* 2038120 */   GIM_Try, /*On fail goto*//*Label 27172*/ GIMT_Encode4(2038211), // Rule ID 15020 //
     /* 2038125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2038128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2038136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2038139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2038142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2038145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038171 */     // MIs[0] round
     /* 2038171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038174 */     // MIs[0] policy
     /* 2038174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038184 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2038187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038210 */     // GIR_Coverage, 15020,
     /* 2038210 */     GIR_EraseRootFromParent_Done,
     /* 2038211 */   // Label 27172: @2038211
     /* 2038211 */   GIM_Try, /*On fail goto*//*Label 27173*/ GIMT_Encode4(2038302), // Rule ID 15021 //
     /* 2038216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2038227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2038230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2038233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2038236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038262 */     // MIs[0] round
     /* 2038262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038265 */     // MIs[0] policy
     /* 2038265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038275 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2038278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038301 */     // GIR_Coverage, 15021,
     /* 2038301 */     GIR_EraseRootFromParent_Done,
     /* 2038302 */   // Label 27173: @2038302
     /* 2038302 */   GIM_Try, /*On fail goto*//*Label 27174*/ GIMT_Encode4(2038393), // Rule ID 15024 //
     /* 2038307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2038318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2038321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2038324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038353 */     // MIs[0] round
     /* 2038353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038356 */     // MIs[0] policy
     /* 2038356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038366 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2038369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038392 */     // GIR_Coverage, 15024,
     /* 2038392 */     GIR_EraseRootFromParent_Done,
     /* 2038393 */   // Label 27174: @2038393
     /* 2038393 */   GIM_Try, /*On fail goto*//*Label 27175*/ GIMT_Encode4(2038484), // Rule ID 15025 //
     /* 2038398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2038409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2038412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2038415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038444 */     // MIs[0] round
     /* 2038444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038447 */     // MIs[0] policy
     /* 2038447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038457 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2038460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038483 */     // GIR_Coverage, 15025,
     /* 2038483 */     GIR_EraseRootFromParent_Done,
     /* 2038484 */   // Label 27175: @2038484
     /* 2038484 */   GIM_Try, /*On fail goto*//*Label 27176*/ GIMT_Encode4(2038575), // Rule ID 15028 //
     /* 2038489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2038500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2038503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2038506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038535 */     // MIs[0] round
     /* 2038535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038538 */     // MIs[0] policy
     /* 2038538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038548 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2038551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038574 */     // GIR_Coverage, 15028,
     /* 2038574 */     GIR_EraseRootFromParent_Done,
     /* 2038575 */   // Label 27176: @2038575
     /* 2038575 */   GIM_Try, /*On fail goto*//*Label 27177*/ GIMT_Encode4(2038666), // Rule ID 15029 //
     /* 2038580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2038591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2038594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2038597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038626 */     // MIs[0] round
     /* 2038626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038629 */     // MIs[0] policy
     /* 2038629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038639 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2038642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038665 */     // GIR_Coverage, 15029,
     /* 2038665 */     GIR_EraseRootFromParent_Done,
     /* 2038666 */   // Label 27177: @2038666
     /* 2038666 */   GIM_Try, /*On fail goto*//*Label 27178*/ GIMT_Encode4(2038757), // Rule ID 15032 //
     /* 2038671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2038682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2038685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2038688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038717 */     // MIs[0] round
     /* 2038717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038720 */     // MIs[0] policy
     /* 2038720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038730 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2038733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038756 */     // GIR_Coverage, 15032,
     /* 2038756 */     GIR_EraseRootFromParent_Done,
     /* 2038757 */   // Label 27178: @2038757
     /* 2038757 */   GIM_Try, /*On fail goto*//*Label 27179*/ GIMT_Encode4(2038848), // Rule ID 15033 //
     /* 2038762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2038773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2038776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2038779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038808 */     // MIs[0] round
     /* 2038808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038811 */     // MIs[0] policy
     /* 2038811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038821 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2038824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038834 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038844 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038847 */     // GIR_Coverage, 15033,
     /* 2038847 */     GIR_EraseRootFromParent_Done,
     /* 2038848 */   // Label 27179: @2038848
     /* 2038848 */   GIM_Try, /*On fail goto*//*Label 27180*/ GIMT_Encode4(2038939), // Rule ID 15036 //
     /* 2038853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2038864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2038867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2038870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038899 */     // MIs[0] round
     /* 2038899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038902 */     // MIs[0] policy
     /* 2038902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038912 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2038915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038938 */     // GIR_Coverage, 15036,
     /* 2038938 */     GIR_EraseRootFromParent_Done,
     /* 2038939 */   // Label 27180: @2038939
     /* 2038939 */   GIM_Try, /*On fail goto*//*Label 27181*/ GIMT_Encode4(2039030), // Rule ID 15037 //
     /* 2038944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2038955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2038958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2038961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038990 */     // MIs[0] round
     /* 2038990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038993 */     // MIs[0] policy
     /* 2038993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039003 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2039006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039029 */     // GIR_Coverage, 15037,
     /* 2039029 */     GIR_EraseRootFromParent_Done,
     /* 2039030 */   // Label 27181: @2039030
     /* 2039030 */   GIM_Try, /*On fail goto*//*Label 27182*/ GIMT_Encode4(2039121), // Rule ID 15040 //
     /* 2039035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2039046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2039049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2039052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039081 */     // MIs[0] round
     /* 2039081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039084 */     // MIs[0] policy
     /* 2039084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039094 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039120 */     // GIR_Coverage, 15040,
     /* 2039120 */     GIR_EraseRootFromParent_Done,
     /* 2039121 */   // Label 27182: @2039121
     /* 2039121 */   GIM_Try, /*On fail goto*//*Label 27183*/ GIMT_Encode4(2039212), // Rule ID 15041 //
     /* 2039126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2039137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2039140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2039143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039172 */     // MIs[0] round
     /* 2039172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039175 */     // MIs[0] policy
     /* 2039175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039185 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039211 */     // GIR_Coverage, 15041,
     /* 2039211 */     GIR_EraseRootFromParent_Done,
     /* 2039212 */   // Label 27183: @2039212
     /* 2039212 */   GIM_Try, /*On fail goto*//*Label 27184*/ GIMT_Encode4(2039303), // Rule ID 15044 //
     /* 2039217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2039228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2039231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2039234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039263 */     // MIs[0] round
     /* 2039263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039266 */     // MIs[0] policy
     /* 2039266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039302 */     // GIR_Coverage, 15044,
     /* 2039302 */     GIR_EraseRootFromParent_Done,
     /* 2039303 */   // Label 27184: @2039303
     /* 2039303 */   GIM_Try, /*On fail goto*//*Label 27185*/ GIMT_Encode4(2039394), // Rule ID 15045 //
     /* 2039308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2039319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2039322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2039325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039354 */     // MIs[0] round
     /* 2039354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039357 */     // MIs[0] policy
     /* 2039357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039367 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039393 */     // GIR_Coverage, 15045,
     /* 2039393 */     GIR_EraseRootFromParent_Done,
     /* 2039394 */   // Label 27185: @2039394
     /* 2039394 */   GIM_Try, /*On fail goto*//*Label 27186*/ GIMT_Encode4(2039485), // Rule ID 15048 //
     /* 2039399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2039410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2039413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2039416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039445 */     // MIs[0] round
     /* 2039445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039448 */     // MIs[0] policy
     /* 2039448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039458 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039484 */     // GIR_Coverage, 15048,
     /* 2039484 */     GIR_EraseRootFromParent_Done,
     /* 2039485 */   // Label 27186: @2039485
     /* 2039485 */   GIM_Try, /*On fail goto*//*Label 27187*/ GIMT_Encode4(2039576), // Rule ID 15049 //
     /* 2039490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2039501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2039504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2039507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039536 */     // MIs[0] round
     /* 2039536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039539 */     // MIs[0] policy
     /* 2039539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039549 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039575 */     // GIR_Coverage, 15049,
     /* 2039575 */     GIR_EraseRootFromParent_Done,
     /* 2039576 */   // Label 27187: @2039576
     /* 2039576 */   GIM_Try, /*On fail goto*//*Label 27188*/ GIMT_Encode4(2039667), // Rule ID 15052 //
     /* 2039581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2039592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2039595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2039598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039627 */     // MIs[0] round
     /* 2039627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039630 */     // MIs[0] policy
     /* 2039630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039640 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039666 */     // GIR_Coverage, 15052,
     /* 2039666 */     GIR_EraseRootFromParent_Done,
     /* 2039667 */   // Label 27188: @2039667
     /* 2039667 */   GIM_Try, /*On fail goto*//*Label 27189*/ GIMT_Encode4(2039758), // Rule ID 15053 //
     /* 2039672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2039683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2039686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2039689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039695 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039718 */     // MIs[0] round
     /* 2039718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039721 */     // MIs[0] policy
     /* 2039721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039731 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039757 */     // GIR_Coverage, 15053,
     /* 2039757 */     GIR_EraseRootFromParent_Done,
     /* 2039758 */   // Label 27189: @2039758
     /* 2039758 */   GIM_Try, /*On fail goto*//*Label 27190*/ GIMT_Encode4(2039849), // Rule ID 15056 //
     /* 2039763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2039774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2039777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2039780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039809 */     // MIs[0] round
     /* 2039809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039812 */     // MIs[0] policy
     /* 2039812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039822 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039848 */     // GIR_Coverage, 15056,
     /* 2039848 */     GIR_EraseRootFromParent_Done,
     /* 2039849 */   // Label 27190: @2039849
     /* 2039849 */   GIM_Try, /*On fail goto*//*Label 27191*/ GIMT_Encode4(2039940), // Rule ID 15057 //
     /* 2039854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2039865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2039868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2039871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039900 */     // MIs[0] round
     /* 2039900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039903 */     // MIs[0] policy
     /* 2039903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039913 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039939 */     // GIR_Coverage, 15057,
     /* 2039939 */     GIR_EraseRootFromParent_Done,
     /* 2039940 */   // Label 27191: @2039940
     /* 2039940 */   GIM_Try, /*On fail goto*//*Label 27192*/ GIMT_Encode4(2040031), // Rule ID 15060 //
     /* 2039945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2039948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2039956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2039959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2039962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039991 */     // MIs[0] round
     /* 2039991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039994 */     // MIs[0] policy
     /* 2039994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040004 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2040027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040030 */     // GIR_Coverage, 15060,
     /* 2040030 */     GIR_EraseRootFromParent_Done,
     /* 2040031 */   // Label 27192: @2040031
     /* 2040031 */   GIM_Try, /*On fail goto*//*Label 27193*/ GIMT_Encode4(2040122), // Rule ID 15061 //
     /* 2040036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2040039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2040047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2040050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2040053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040082 */     // MIs[0] round
     /* 2040082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040085 */     // MIs[0] policy
     /* 2040085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040095 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2040118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040121 */     // GIR_Coverage, 15061,
     /* 2040121 */     GIR_EraseRootFromParent_Done,
     /* 2040122 */   // Label 27193: @2040122
     /* 2040122 */   GIM_Try, /*On fail goto*//*Label 27194*/ GIMT_Encode4(2040213), // Rule ID 15064 //
     /* 2040127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2040138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2040141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2040144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040173 */     // MIs[0] round
     /* 2040173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040176 */     // MIs[0] policy
     /* 2040176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040186 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2040189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040212 */     // GIR_Coverage, 15064,
     /* 2040212 */     GIR_EraseRootFromParent_Done,
     /* 2040213 */   // Label 27194: @2040213
     /* 2040213 */   GIM_Try, /*On fail goto*//*Label 27195*/ GIMT_Encode4(2040304), // Rule ID 15065 //
     /* 2040218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2040229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2040232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2040235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040264 */     // MIs[0] round
     /* 2040264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040267 */     // MIs[0] policy
     /* 2040267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040277 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2040280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040303 */     // GIR_Coverage, 15065,
     /* 2040303 */     GIR_EraseRootFromParent_Done,
     /* 2040304 */   // Label 27195: @2040304
     /* 2040304 */   GIM_Try, /*On fail goto*//*Label 27196*/ GIMT_Encode4(2040395), // Rule ID 15068 //
     /* 2040309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2040320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2040323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2040326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2040332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040355 */     // MIs[0] round
     /* 2040355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040358 */     // MIs[0] policy
     /* 2040358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040368 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2040371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040394 */     // GIR_Coverage, 15068,
     /* 2040394 */     GIR_EraseRootFromParent_Done,
     /* 2040395 */   // Label 27196: @2040395
     /* 2040395 */   GIM_Try, /*On fail goto*//*Label 27197*/ GIMT_Encode4(2040486), // Rule ID 15069 //
     /* 2040400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2040411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2040414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2040417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2040423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040446 */     // MIs[0] round
     /* 2040446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040449 */     // MIs[0] policy
     /* 2040449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040459 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2040462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040485 */     // GIR_Coverage, 15069,
     /* 2040485 */     GIR_EraseRootFromParent_Done,
     /* 2040486 */   // Label 27197: @2040486
     /* 2040486 */   GIM_Try, /*On fail goto*//*Label 27198*/ GIMT_Encode4(2040577), // Rule ID 15072 //
     /* 2040491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2040502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2040505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2040508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2040514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2040521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040537 */     // MIs[0] round
     /* 2040537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040540 */     // MIs[0] policy
     /* 2040540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040550 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2040553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040576 */     // GIR_Coverage, 15072,
     /* 2040576 */     GIR_EraseRootFromParent_Done,
     /* 2040577 */   // Label 27198: @2040577
     /* 2040577 */   GIM_Try, /*On fail goto*//*Label 27199*/ GIMT_Encode4(2040668), // Rule ID 15073 //
     /* 2040582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2040593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2040596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2040599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2040605 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2040612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040628 */     // MIs[0] round
     /* 2040628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040631 */     // MIs[0] policy
     /* 2040631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040641 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2040644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040664 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040667 */     // GIR_Coverage, 15073,
     /* 2040667 */     GIR_EraseRootFromParent_Done,
     /* 2040668 */   // Label 27199: @2040668
     /* 2040668 */   GIM_Try, /*On fail goto*//*Label 27200*/ GIMT_Encode4(2040759), // Rule ID 15076 //
     /* 2040673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2040684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2040687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2040690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2040696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040719 */     // MIs[0] round
     /* 2040719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040722 */     // MIs[0] policy
     /* 2040722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2040735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040758 */     // GIR_Coverage, 15076,
     /* 2040758 */     GIR_EraseRootFromParent_Done,
     /* 2040759 */   // Label 27200: @2040759
     /* 2040759 */   GIM_Try, /*On fail goto*//*Label 27201*/ GIMT_Encode4(2040850), // Rule ID 15077 //
     /* 2040764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2040775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2040778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2040781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2040787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040810 */     // MIs[0] round
     /* 2040810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040813 */     // MIs[0] policy
     /* 2040813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040823 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2040826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040849 */     // GIR_Coverage, 15077,
     /* 2040849 */     GIR_EraseRootFromParent_Done,
     /* 2040850 */   // Label 27201: @2040850
     /* 2040850 */   GIM_Try, /*On fail goto*//*Label 27202*/ GIMT_Encode4(2040941), // Rule ID 15080 //
     /* 2040855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2040866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2040869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2040872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040901 */     // MIs[0] round
     /* 2040901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040904 */     // MIs[0] policy
     /* 2040904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040914 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2040917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040940 */     // GIR_Coverage, 15080,
     /* 2040940 */     GIR_EraseRootFromParent_Done,
     /* 2040941 */   // Label 27202: @2040941
     /* 2040941 */   GIM_Try, /*On fail goto*//*Label 27203*/ GIMT_Encode4(2041032), // Rule ID 15081 //
     /* 2040946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2040957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2040960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2040963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040992 */     // MIs[0] round
     /* 2040992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040995 */     // MIs[0] policy
     /* 2040995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041005 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2041008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041018 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041028 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041031 */     // GIR_Coverage, 15081,
     /* 2041031 */     GIR_EraseRootFromParent_Done,
     /* 2041032 */   // Label 27203: @2041032
     /* 2041032 */   GIM_Try, /*On fail goto*//*Label 27204*/ GIMT_Encode4(2041123), // Rule ID 15084 //
     /* 2041037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2041048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2041051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2041054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041083 */     // MIs[0] round
     /* 2041083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041086 */     // MIs[0] policy
     /* 2041086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041096 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041119 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041122 */     // GIR_Coverage, 15084,
     /* 2041122 */     GIR_EraseRootFromParent_Done,
     /* 2041123 */   // Label 27204: @2041123
     /* 2041123 */   GIM_Try, /*On fail goto*//*Label 27205*/ GIMT_Encode4(2041214), // Rule ID 15085 //
     /* 2041128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2041139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2041142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2041145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041174 */     // MIs[0] round
     /* 2041174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041177 */     // MIs[0] policy
     /* 2041177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041187 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041213 */     // GIR_Coverage, 15085,
     /* 2041213 */     GIR_EraseRootFromParent_Done,
     /* 2041214 */   // Label 27205: @2041214
     /* 2041214 */   GIM_Try, /*On fail goto*//*Label 27206*/ GIMT_Encode4(2041305), // Rule ID 15088 //
     /* 2041219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2041230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2041233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2041236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041265 */     // MIs[0] round
     /* 2041265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041268 */     // MIs[0] policy
     /* 2041268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041304 */     // GIR_Coverage, 15088,
     /* 2041304 */     GIR_EraseRootFromParent_Done,
     /* 2041305 */   // Label 27206: @2041305
     /* 2041305 */   GIM_Try, /*On fail goto*//*Label 27207*/ GIMT_Encode4(2041396), // Rule ID 15089 //
     /* 2041310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2041321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2041324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2041327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041356 */     // MIs[0] round
     /* 2041356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041359 */     // MIs[0] policy
     /* 2041359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041369 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041395 */     // GIR_Coverage, 15089,
     /* 2041395 */     GIR_EraseRootFromParent_Done,
     /* 2041396 */   // Label 27207: @2041396
     /* 2041396 */   GIM_Try, /*On fail goto*//*Label 27208*/ GIMT_Encode4(2041487), // Rule ID 15092 //
     /* 2041401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2041412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2041415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2041418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041447 */     // MIs[0] round
     /* 2041447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041450 */     // MIs[0] policy
     /* 2041450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2041463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041486 */     // GIR_Coverage, 15092,
     /* 2041486 */     GIR_EraseRootFromParent_Done,
     /* 2041487 */   // Label 27208: @2041487
     /* 2041487 */   GIM_Try, /*On fail goto*//*Label 27209*/ GIMT_Encode4(2041578), // Rule ID 15093 //
     /* 2041492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2041503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2041506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2041509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041538 */     // MIs[0] round
     /* 2041538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041541 */     // MIs[0] policy
     /* 2041541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2041554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041577 */     // GIR_Coverage, 15093,
     /* 2041577 */     GIR_EraseRootFromParent_Done,
     /* 2041578 */   // Label 27209: @2041578
     /* 2041578 */   GIM_Try, /*On fail goto*//*Label 27210*/ GIMT_Encode4(2041669), // Rule ID 15096 //
     /* 2041583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2041594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2041597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2041600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041629 */     // MIs[0] round
     /* 2041629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041632 */     // MIs[0] policy
     /* 2041632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041642 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041668 */     // GIR_Coverage, 15096,
     /* 2041668 */     GIR_EraseRootFromParent_Done,
     /* 2041669 */   // Label 27210: @2041669
     /* 2041669 */   GIM_Try, /*On fail goto*//*Label 27211*/ GIMT_Encode4(2041760), // Rule ID 15097 //
     /* 2041674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2041685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2041688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2041691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041720 */     // MIs[0] round
     /* 2041720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041723 */     // MIs[0] policy
     /* 2041723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041733 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041759 */     // GIR_Coverage, 15097,
     /* 2041759 */     GIR_EraseRootFromParent_Done,
     /* 2041760 */   // Label 27211: @2041760
     /* 2041760 */   GIM_Try, /*On fail goto*//*Label 27212*/ GIMT_Encode4(2041851), // Rule ID 15100 //
     /* 2041765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2041768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2041776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2041779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2041782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2041788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041811 */     // MIs[0] round
     /* 2041811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041814 */     // MIs[0] policy
     /* 2041814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2041847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041850 */     // GIR_Coverage, 15100,
     /* 2041850 */     GIR_EraseRootFromParent_Done,
     /* 2041851 */   // Label 27212: @2041851
     /* 2041851 */   GIM_Try, /*On fail goto*//*Label 27213*/ GIMT_Encode4(2041942), // Rule ID 15101 //
     /* 2041856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2041859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2041867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2041870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2041873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2041879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041902 */     // MIs[0] round
     /* 2041902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041905 */     // MIs[0] policy
     /* 2041905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041915 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2041938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041941 */     // GIR_Coverage, 15101,
     /* 2041941 */     GIR_EraseRootFromParent_Done,
     /* 2041942 */   // Label 27213: @2041942
     /* 2041942 */   GIM_Try, /*On fail goto*//*Label 27214*/ GIMT_Encode4(2042033), // Rule ID 15104 //
     /* 2041947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2041950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2041958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2041961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2041964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041993 */     // MIs[0] round
     /* 2041993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041996 */     // MIs[0] policy
     /* 2041996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042006 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2042009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042032 */     // GIR_Coverage, 15104,
     /* 2042032 */     GIR_EraseRootFromParent_Done,
     /* 2042033 */   // Label 27214: @2042033
     /* 2042033 */   GIM_Try, /*On fail goto*//*Label 27215*/ GIMT_Encode4(2042124), // Rule ID 15105 //
     /* 2042038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2042049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2042052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2042055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042084 */     // MIs[0] round
     /* 2042084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042087 */     // MIs[0] policy
     /* 2042087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042097 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2042100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042123 */     // GIR_Coverage, 15105,
     /* 2042123 */     GIR_EraseRootFromParent_Done,
     /* 2042124 */   // Label 27215: @2042124
     /* 2042124 */   GIM_Try, /*On fail goto*//*Label 27216*/ GIMT_Encode4(2042215), // Rule ID 15108 //
     /* 2042129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2042132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2042140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2042143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2042146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042175 */     // MIs[0] round
     /* 2042175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042178 */     // MIs[0] policy
     /* 2042178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042188 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2042191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042214 */     // GIR_Coverage, 15108,
     /* 2042214 */     GIR_EraseRootFromParent_Done,
     /* 2042215 */   // Label 27216: @2042215
     /* 2042215 */   GIM_Try, /*On fail goto*//*Label 27217*/ GIMT_Encode4(2042306), // Rule ID 15109 //
     /* 2042220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2042231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2042234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2042237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042266 */     // MIs[0] round
     /* 2042266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042269 */     // MIs[0] policy
     /* 2042269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042279 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2042282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042305 */     // GIR_Coverage, 15109,
     /* 2042305 */     GIR_EraseRootFromParent_Done,
     /* 2042306 */   // Label 27217: @2042306
     /* 2042306 */   GIM_Try, /*On fail goto*//*Label 27218*/ GIMT_Encode4(2042397), // Rule ID 15112 //
     /* 2042311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2042322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2042325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2042328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2042331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042357 */     // MIs[0] round
     /* 2042357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042360 */     // MIs[0] policy
     /* 2042360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042370 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2042373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042396 */     // GIR_Coverage, 15112,
     /* 2042396 */     GIR_EraseRootFromParent_Done,
     /* 2042397 */   // Label 27218: @2042397
     /* 2042397 */   GIM_Try, /*On fail goto*//*Label 27219*/ GIMT_Encode4(2042488), // Rule ID 15113 //
     /* 2042402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2042413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2042416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2042419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2042422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042448 */     // MIs[0] round
     /* 2042448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042451 */     // MIs[0] policy
     /* 2042451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042461 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2042464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042487 */     // GIR_Coverage, 15113,
     /* 2042487 */     GIR_EraseRootFromParent_Done,
     /* 2042488 */   // Label 27219: @2042488
     /* 2042488 */   GIM_Try, /*On fail goto*//*Label 27220*/ GIMT_Encode4(2042579), // Rule ID 15116 //
     /* 2042493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2042504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2042507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2042510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2042513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042539 */     // MIs[0] round
     /* 2042539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042542 */     // MIs[0] policy
     /* 2042542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2042555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042578 */     // GIR_Coverage, 15116,
     /* 2042578 */     GIR_EraseRootFromParent_Done,
     /* 2042579 */   // Label 27220: @2042579
     /* 2042579 */   GIM_Try, /*On fail goto*//*Label 27221*/ GIMT_Encode4(2042670), // Rule ID 15117 //
     /* 2042584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2042595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2042598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2042601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2042604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042630 */     // MIs[0] round
     /* 2042630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042633 */     // MIs[0] policy
     /* 2042633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042643 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2042646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042669 */     // GIR_Coverage, 15117,
     /* 2042669 */     GIR_EraseRootFromParent_Done,
     /* 2042670 */   // Label 27221: @2042670
     /* 2042670 */   GIM_Try, /*On fail goto*//*Label 27222*/ GIMT_Encode4(2042761), // Rule ID 15120 //
     /* 2042675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2042686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2042689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2042692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2042695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042721 */     // MIs[0] round
     /* 2042721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042724 */     // MIs[0] policy
     /* 2042724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042734 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2042737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042760 */     // GIR_Coverage, 15120,
     /* 2042760 */     GIR_EraseRootFromParent_Done,
     /* 2042761 */   // Label 27222: @2042761
     /* 2042761 */   GIM_Try, /*On fail goto*//*Label 27223*/ GIMT_Encode4(2042852), // Rule ID 15121 //
     /* 2042766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2042777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2042780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2042783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2042786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042789 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042812 */     // MIs[0] round
     /* 2042812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042815 */     // MIs[0] policy
     /* 2042815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042825 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2042828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042851 */     // GIR_Coverage, 15121,
     /* 2042851 */     GIR_EraseRootFromParent_Done,
     /* 2042852 */   // Label 27223: @2042852
     /* 2042852 */   GIM_Try, /*On fail goto*//*Label 27224*/ GIMT_Encode4(2042943), // Rule ID 15124 //
     /* 2042857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2042868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2042871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2042874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2042877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042903 */     // MIs[0] round
     /* 2042903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042906 */     // MIs[0] policy
     /* 2042906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042916 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2042919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2042939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042942 */     // GIR_Coverage, 15124,
     /* 2042942 */     GIR_EraseRootFromParent_Done,
     /* 2042943 */   // Label 27224: @2042943
     /* 2042943 */   GIM_Try, /*On fail goto*//*Label 27225*/ GIMT_Encode4(2043034), // Rule ID 15125 //
     /* 2042948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2042959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2042962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2042965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2042968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042994 */     // MIs[0] round
     /* 2042994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042997 */     // MIs[0] policy
     /* 2042997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043007 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2043010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043033 */     // GIR_Coverage, 15125,
     /* 2043033 */     GIR_EraseRootFromParent_Done,
     /* 2043034 */   // Label 27225: @2043034
     /* 2043034 */   GIM_Try, /*On fail goto*//*Label 27226*/ GIMT_Encode4(2043125), // Rule ID 15128 //
     /* 2043039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2043050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2043053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2043056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2043059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043085 */     // MIs[0] round
     /* 2043085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043088 */     // MIs[0] policy
     /* 2043088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043098 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043124 */     // GIR_Coverage, 15128,
     /* 2043124 */     GIR_EraseRootFromParent_Done,
     /* 2043125 */   // Label 27226: @2043125
     /* 2043125 */   GIM_Try, /*On fail goto*//*Label 27227*/ GIMT_Encode4(2043216), // Rule ID 15129 //
     /* 2043130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2043141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2043144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2043147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2043150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043176 */     // MIs[0] round
     /* 2043176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043179 */     // MIs[0] policy
     /* 2043179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043189 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043215 */     // GIR_Coverage, 15129,
     /* 2043215 */     GIR_EraseRootFromParent_Done,
     /* 2043216 */   // Label 27227: @2043216
     /* 2043216 */   GIM_Try, /*On fail goto*//*Label 27228*/ GIMT_Encode4(2043307), // Rule ID 15132 //
     /* 2043221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2043232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2043235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2043238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2043241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043267 */     // MIs[0] round
     /* 2043267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043270 */     // MIs[0] policy
     /* 2043270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043280 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043306 */     // GIR_Coverage, 15132,
     /* 2043306 */     GIR_EraseRootFromParent_Done,
     /* 2043307 */   // Label 27228: @2043307
     /* 2043307 */   GIM_Try, /*On fail goto*//*Label 27229*/ GIMT_Encode4(2043398), // Rule ID 15133 //
     /* 2043312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2043323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2043326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2043329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2043332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043358 */     // MIs[0] round
     /* 2043358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043361 */     // MIs[0] policy
     /* 2043361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043371 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043397 */     // GIR_Coverage, 15133,
     /* 2043397 */     GIR_EraseRootFromParent_Done,
     /* 2043398 */   // Label 27229: @2043398
     /* 2043398 */   GIM_Try, /*On fail goto*//*Label 27230*/ GIMT_Encode4(2043489), // Rule ID 15136 //
     /* 2043403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2043414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2043417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2043420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2043423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043449 */     // MIs[0] round
     /* 2043449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043452 */     // MIs[0] policy
     /* 2043452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043462 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043488 */     // GIR_Coverage, 15136,
     /* 2043488 */     GIR_EraseRootFromParent_Done,
     /* 2043489 */   // Label 27230: @2043489
     /* 2043489 */   GIM_Try, /*On fail goto*//*Label 27231*/ GIMT_Encode4(2043580), // Rule ID 15137 //
     /* 2043494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2043505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2043508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2043511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2043514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043540 */     // MIs[0] round
     /* 2043540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043543 */     // MIs[0] policy
     /* 2043543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043553 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043579 */     // GIR_Coverage, 15137,
     /* 2043579 */     GIR_EraseRootFromParent_Done,
     /* 2043580 */   // Label 27231: @2043580
     /* 2043580 */   GIM_Try, /*On fail goto*//*Label 27232*/ GIMT_Encode4(2043671), // Rule ID 15140 //
     /* 2043585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2043596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2043599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2043602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2043605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043631 */     // MIs[0] round
     /* 2043631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043634 */     // MIs[0] policy
     /* 2043634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043644 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043670 */     // GIR_Coverage, 15140,
     /* 2043670 */     GIR_EraseRootFromParent_Done,
     /* 2043671 */   // Label 27232: @2043671
     /* 2043671 */   GIM_Try, /*On fail goto*//*Label 27233*/ GIMT_Encode4(2043762), // Rule ID 15141 //
     /* 2043676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2043687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2043690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2043693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2043696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043699 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043722 */     // MIs[0] round
     /* 2043722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043725 */     // MIs[0] policy
     /* 2043725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043735 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043761 */     // GIR_Coverage, 15141,
     /* 2043761 */     GIR_EraseRootFromParent_Done,
     /* 2043762 */   // Label 27233: @2043762
     /* 2043762 */   GIM_Try, /*On fail goto*//*Label 27234*/ GIMT_Encode4(2043853), // Rule ID 15144 //
     /* 2043767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2043778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2043781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2043784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2043787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043813 */     // MIs[0] round
     /* 2043813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043816 */     // MIs[0] policy
     /* 2043816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043852 */     // GIR_Coverage, 15144,
     /* 2043852 */     GIR_EraseRootFromParent_Done,
     /* 2043853 */   // Label 27234: @2043853
     /* 2043853 */   GIM_Try, /*On fail goto*//*Label 27235*/ GIMT_Encode4(2043944), // Rule ID 15145 //
     /* 2043858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2043869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2043872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2043875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2043878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043904 */     // MIs[0] round
     /* 2043904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043907 */     // MIs[0] policy
     /* 2043907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043917 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043943 */     // GIR_Coverage, 15145,
     /* 2043943 */     GIR_EraseRootFromParent_Done,
     /* 2043944 */   // Label 27235: @2043944
     /* 2043944 */   GIM_Try, /*On fail goto*//*Label 27236*/ GIMT_Encode4(2044035), // Rule ID 15148 //
     /* 2043949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2043952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2043960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2043963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2043966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2043969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043995 */     // MIs[0] round
     /* 2043995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043998 */     // MIs[0] policy
     /* 2043998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044008 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2044031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044034 */     // GIR_Coverage, 15148,
     /* 2044034 */     GIR_EraseRootFromParent_Done,
     /* 2044035 */   // Label 27236: @2044035
     /* 2044035 */   GIM_Try, /*On fail goto*//*Label 27237*/ GIMT_Encode4(2044126), // Rule ID 15149 //
     /* 2044040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2044043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2044051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2044054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2044057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2044060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2044063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044086 */     // MIs[0] round
     /* 2044086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044089 */     // MIs[0] policy
     /* 2044089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044099 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2044122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044125 */     // GIR_Coverage, 15149,
     /* 2044125 */     GIR_EraseRootFromParent_Done,
     /* 2044126 */   // Label 27237: @2044126
     /* 2044126 */   GIM_Try, /*On fail goto*//*Label 27238*/ GIMT_Encode4(2044217), // Rule ID 15152 //
     /* 2044131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2044142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2044145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2044148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2044151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044177 */     // MIs[0] round
     /* 2044177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044180 */     // MIs[0] policy
     /* 2044180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044190 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2044193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044216 */     // GIR_Coverage, 15152,
     /* 2044216 */     GIR_EraseRootFromParent_Done,
     /* 2044217 */   // Label 27238: @2044217
     /* 2044217 */   GIM_Try, /*On fail goto*//*Label 27239*/ GIMT_Encode4(2044308), // Rule ID 15153 //
     /* 2044222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2044233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2044236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2044239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2044242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044268 */     // MIs[0] round
     /* 2044268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044271 */     // MIs[0] policy
     /* 2044271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044281 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2044284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044307 */     // GIR_Coverage, 15153,
     /* 2044307 */     GIR_EraseRootFromParent_Done,
     /* 2044308 */   // Label 27239: @2044308
     /* 2044308 */   GIM_Try, /*On fail goto*//*Label 27240*/ GIMT_Encode4(2044399), // Rule ID 15156 //
     /* 2044313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2044324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2044327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2044330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2044333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044359 */     // MIs[0] round
     /* 2044359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044362 */     // MIs[0] policy
     /* 2044362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044372 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2044375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044398 */     // GIR_Coverage, 15156,
     /* 2044398 */     GIR_EraseRootFromParent_Done,
     /* 2044399 */   // Label 27240: @2044399
     /* 2044399 */   GIM_Try, /*On fail goto*//*Label 27241*/ GIMT_Encode4(2044490), // Rule ID 15157 //
     /* 2044404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2044415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2044418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2044421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2044424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044450 */     // MIs[0] round
     /* 2044450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044453 */     // MIs[0] policy
     /* 2044453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044463 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2044466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044489 */     // GIR_Coverage, 15157,
     /* 2044489 */     GIR_EraseRootFromParent_Done,
     /* 2044490 */   // Label 27241: @2044490
     /* 2044490 */   GIM_Try, /*On fail goto*//*Label 27242*/ GIMT_Encode4(2044581), // Rule ID 15160 //
     /* 2044495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2044506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2044509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2044512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2044515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2044518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044541 */     // MIs[0] round
     /* 2044541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044544 */     // MIs[0] policy
     /* 2044544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044554 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2044557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044580 */     // GIR_Coverage, 15160,
     /* 2044580 */     GIR_EraseRootFromParent_Done,
     /* 2044581 */   // Label 27242: @2044581
     /* 2044581 */   GIM_Try, /*On fail goto*//*Label 27243*/ GIMT_Encode4(2044672), // Rule ID 15161 //
     /* 2044586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2044597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2044600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2044603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2044606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2044609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044632 */     // MIs[0] round
     /* 2044632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044635 */     // MIs[0] policy
     /* 2044635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044645 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2044648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044671 */     // GIR_Coverage, 15161,
     /* 2044671 */     GIR_EraseRootFromParent_Done,
     /* 2044672 */   // Label 27243: @2044672
     /* 2044672 */   GIM_Try, /*On fail goto*//*Label 27244*/ GIMT_Encode4(2044763), // Rule ID 15164 //
     /* 2044677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2044688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2044691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2044694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2044697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2044700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044723 */     // MIs[0] round
     /* 2044723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044726 */     // MIs[0] policy
     /* 2044726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2044739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044762 */     // GIR_Coverage, 15164,
     /* 2044762 */     GIR_EraseRootFromParent_Done,
     /* 2044763 */   // Label 27244: @2044763
     /* 2044763 */   GIM_Try, /*On fail goto*//*Label 27245*/ GIMT_Encode4(2044854), // Rule ID 15165 //
     /* 2044768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2044779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2044782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2044785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2044788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2044791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044814 */     // MIs[0] round
     /* 2044814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044817 */     // MIs[0] policy
     /* 2044817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044827 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2044830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044853 */     // GIR_Coverage, 15165,
     /* 2044853 */     GIR_EraseRootFromParent_Done,
     /* 2044854 */   // Label 27245: @2044854
     /* 2044854 */   GIM_Try, /*On fail goto*//*Label 27246*/ GIMT_Encode4(2044945), // Rule ID 15168 //
     /* 2044859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2044870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2044873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2044876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2044879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044905 */     // MIs[0] round
     /* 2044905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044908 */     // MIs[0] policy
     /* 2044908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2044921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044944 */     // GIR_Coverage, 15168,
     /* 2044944 */     GIR_EraseRootFromParent_Done,
     /* 2044945 */   // Label 27246: @2044945
     /* 2044945 */   GIM_Try, /*On fail goto*//*Label 27247*/ GIMT_Encode4(2045036), // Rule ID 15169 //
     /* 2044950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2044961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2044964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2044967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2044970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044996 */     // MIs[0] round
     /* 2044996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044999 */     // MIs[0] policy
     /* 2044999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045009 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2045012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045035 */     // GIR_Coverage, 15169,
     /* 2045035 */     GIR_EraseRootFromParent_Done,
     /* 2045036 */   // Label 27247: @2045036
     /* 2045036 */   GIM_Try, /*On fail goto*//*Label 27248*/ GIMT_Encode4(2045127), // Rule ID 15172 //
     /* 2045041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2045052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2045055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2045058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2045061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045087 */     // MIs[0] round
     /* 2045087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045090 */     // MIs[0] policy
     /* 2045090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045100 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045126 */     // GIR_Coverage, 15172,
     /* 2045126 */     GIR_EraseRootFromParent_Done,
     /* 2045127 */   // Label 27248: @2045127
     /* 2045127 */   GIM_Try, /*On fail goto*//*Label 27249*/ GIMT_Encode4(2045218), // Rule ID 15173 //
     /* 2045132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2045143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2045146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2045149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2045152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045178 */     // MIs[0] round
     /* 2045178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045181 */     // MIs[0] policy
     /* 2045181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045191 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045217 */     // GIR_Coverage, 15173,
     /* 2045217 */     GIR_EraseRootFromParent_Done,
     /* 2045218 */   // Label 27249: @2045218
     /* 2045218 */   GIM_Try, /*On fail goto*//*Label 27250*/ GIMT_Encode4(2045309), // Rule ID 15176 //
     /* 2045223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2045234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2045237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2045240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2045243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045269 */     // MIs[0] round
     /* 2045269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045272 */     // MIs[0] policy
     /* 2045272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045282 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045308 */     // GIR_Coverage, 15176,
     /* 2045308 */     GIR_EraseRootFromParent_Done,
     /* 2045309 */   // Label 27250: @2045309
     /* 2045309 */   GIM_Try, /*On fail goto*//*Label 27251*/ GIMT_Encode4(2045400), // Rule ID 15177 //
     /* 2045314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2045325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2045328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2045331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2045334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045360 */     // MIs[0] round
     /* 2045360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045363 */     // MIs[0] policy
     /* 2045363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045399 */     // GIR_Coverage, 15177,
     /* 2045399 */     GIR_EraseRootFromParent_Done,
     /* 2045400 */   // Label 27251: @2045400
     /* 2045400 */   GIM_Try, /*On fail goto*//*Label 27252*/ GIMT_Encode4(2045491), // Rule ID 15180 //
     /* 2045405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2045416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2045419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2045422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2045425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045451 */     // MIs[0] round
     /* 2045451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045454 */     // MIs[0] policy
     /* 2045454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2045467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045490 */     // GIR_Coverage, 15180,
     /* 2045490 */     GIR_EraseRootFromParent_Done,
     /* 2045491 */   // Label 27252: @2045491
     /* 2045491 */   GIM_Try, /*On fail goto*//*Label 27253*/ GIMT_Encode4(2045582), // Rule ID 15181 //
     /* 2045496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2045507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2045510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2045513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2045516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045542 */     // MIs[0] round
     /* 2045542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045545 */     // MIs[0] policy
     /* 2045545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045555 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2045558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045581 */     // GIR_Coverage, 15181,
     /* 2045581 */     GIR_EraseRootFromParent_Done,
     /* 2045582 */   // Label 27253: @2045582
     /* 2045582 */   GIM_Try, /*On fail goto*//*Label 27254*/ GIMT_Encode4(2045673), // Rule ID 15184 //
     /* 2045587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2045598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2045601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2045604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2045607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045633 */     // MIs[0] round
     /* 2045633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045636 */     // MIs[0] policy
     /* 2045636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045646 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045672 */     // GIR_Coverage, 15184,
     /* 2045672 */     GIR_EraseRootFromParent_Done,
     /* 2045673 */   // Label 27254: @2045673
     /* 2045673 */   GIM_Try, /*On fail goto*//*Label 27255*/ GIMT_Encode4(2045764), // Rule ID 15185 //
     /* 2045678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2045689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2045692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2045695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2045698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045724 */     // MIs[0] round
     /* 2045724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045727 */     // MIs[0] policy
     /* 2045727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045737 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045763 */     // GIR_Coverage, 15185,
     /* 2045763 */     GIR_EraseRootFromParent_Done,
     /* 2045764 */   // Label 27255: @2045764
     /* 2045764 */   GIM_Try, /*On fail goto*//*Label 27256*/ GIMT_Encode4(2045855), // Rule ID 15188 //
     /* 2045769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2045772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2045780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2045783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2045786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2045789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2045792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045815 */     // MIs[0] round
     /* 2045815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045818 */     // MIs[0] policy
     /* 2045818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045828 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045854 */     // GIR_Coverage, 15188,
     /* 2045854 */     GIR_EraseRootFromParent_Done,
     /* 2045855 */   // Label 27256: @2045855
     /* 2045855 */   GIM_Try, /*On fail goto*//*Label 27257*/ GIMT_Encode4(2045946), // Rule ID 15189 //
     /* 2045860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2045863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2045871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2045874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2045877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2045880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2045883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045906 */     // MIs[0] round
     /* 2045906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045909 */     // MIs[0] policy
     /* 2045909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045919 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045945 */     // GIR_Coverage, 15189,
     /* 2045945 */     GIR_EraseRootFromParent_Done,
     /* 2045946 */   // Label 27257: @2045946
     /* 2045946 */   GIM_Try, /*On fail goto*//*Label 27258*/ GIMT_Encode4(2046037), // Rule ID 15192 //
     /* 2045951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2045954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2045962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2045965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2045968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2045971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045997 */     // MIs[0] round
     /* 2045997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046000 */     // MIs[0] policy
     /* 2046000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046010 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2046013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046036 */     // GIR_Coverage, 15192,
     /* 2046036 */     GIR_EraseRootFromParent_Done,
     /* 2046037 */   // Label 27258: @2046037
     /* 2046037 */   GIM_Try, /*On fail goto*//*Label 27259*/ GIMT_Encode4(2046128), // Rule ID 15193 //
     /* 2046042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2046053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2046056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2046059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2046062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046088 */     // MIs[0] round
     /* 2046088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046091 */     // MIs[0] policy
     /* 2046091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046101 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2046104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046127 */     // GIR_Coverage, 15193,
     /* 2046127 */     GIR_EraseRootFromParent_Done,
     /* 2046128 */   // Label 27259: @2046128
     /* 2046128 */   GIM_Try, /*On fail goto*//*Label 27260*/ GIMT_Encode4(2046219), // Rule ID 15196 //
     /* 2046133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2046136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2046144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2046147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2046150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2046153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046179 */     // MIs[0] round
     /* 2046179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046182 */     // MIs[0] policy
     /* 2046182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046192 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2046195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046218 */     // GIR_Coverage, 15196,
     /* 2046218 */     GIR_EraseRootFromParent_Done,
     /* 2046219 */   // Label 27260: @2046219
     /* 2046219 */   GIM_Try, /*On fail goto*//*Label 27261*/ GIMT_Encode4(2046310), // Rule ID 15197 //
     /* 2046224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2046235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2046238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2046241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2046244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046270 */     // MIs[0] round
     /* 2046270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046273 */     // MIs[0] policy
     /* 2046273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046283 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2046286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046296 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046306 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046309 */     // GIR_Coverage, 15197,
     /* 2046309 */     GIR_EraseRootFromParent_Done,
     /* 2046310 */   // Label 27261: @2046310
     /* 2046310 */   GIM_Try, /*On fail goto*//*Label 27262*/ GIMT_Encode4(2046401), // Rule ID 15200 //
     /* 2046315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2046326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2046329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2046332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046361 */     // MIs[0] round
     /* 2046361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046364 */     // MIs[0] policy
     /* 2046364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046374 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2046377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046400 */     // GIR_Coverage, 15200,
     /* 2046400 */     GIR_EraseRootFromParent_Done,
     /* 2046401 */   // Label 27262: @2046401
     /* 2046401 */   GIM_Try, /*On fail goto*//*Label 27263*/ GIMT_Encode4(2046492), // Rule ID 15201 //
     /* 2046406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2046417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2046420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2046423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046452 */     // MIs[0] round
     /* 2046452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046455 */     // MIs[0] policy
     /* 2046455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046465 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2046468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046491 */     // GIR_Coverage, 15201,
     /* 2046491 */     GIR_EraseRootFromParent_Done,
     /* 2046492 */   // Label 27263: @2046492
     /* 2046492 */   GIM_Try, /*On fail goto*//*Label 27264*/ GIMT_Encode4(2046583), // Rule ID 15204 //
     /* 2046497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2046508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2046511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2046514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046543 */     // MIs[0] round
     /* 2046543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046546 */     // MIs[0] policy
     /* 2046546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046556 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2046559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046582 */     // GIR_Coverage, 15204,
     /* 2046582 */     GIR_EraseRootFromParent_Done,
     /* 2046583 */   // Label 27264: @2046583
     /* 2046583 */   GIM_Try, /*On fail goto*//*Label 27265*/ GIMT_Encode4(2046674), // Rule ID 15205 //
     /* 2046588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2046599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2046602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2046605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046634 */     // MIs[0] round
     /* 2046634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046637 */     // MIs[0] policy
     /* 2046637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046647 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2046650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046673 */     // GIR_Coverage, 15205,
     /* 2046673 */     GIR_EraseRootFromParent_Done,
     /* 2046674 */   // Label 27265: @2046674
     /* 2046674 */   GIM_Try, /*On fail goto*//*Label 27266*/ GIMT_Encode4(2046765), // Rule ID 15208 //
     /* 2046679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2046690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2046693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2046696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046725 */     // MIs[0] round
     /* 2046725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046728 */     // MIs[0] policy
     /* 2046728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046738 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2046741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046764 */     // GIR_Coverage, 15208,
     /* 2046764 */     GIR_EraseRootFromParent_Done,
     /* 2046765 */   // Label 27266: @2046765
     /* 2046765 */   GIM_Try, /*On fail goto*//*Label 27267*/ GIMT_Encode4(2046856), // Rule ID 15209 //
     /* 2046770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2046781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2046784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2046787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046816 */     // MIs[0] round
     /* 2046816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046819 */     // MIs[0] policy
     /* 2046819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046829 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2046832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046855 */     // GIR_Coverage, 15209,
     /* 2046855 */     GIR_EraseRootFromParent_Done,
     /* 2046856 */   // Label 27267: @2046856
     /* 2046856 */   GIM_Try, /*On fail goto*//*Label 27268*/ GIMT_Encode4(2046947), // Rule ID 15212 //
     /* 2046861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2046872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2046875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2046878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046907 */     // MIs[0] round
     /* 2046907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046910 */     // MIs[0] policy
     /* 2046910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046920 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2046923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046946 */     // GIR_Coverage, 15212,
     /* 2046946 */     GIR_EraseRootFromParent_Done,
     /* 2046947 */   // Label 27268: @2046947
     /* 2046947 */   GIM_Try, /*On fail goto*//*Label 27269*/ GIMT_Encode4(2047038), // Rule ID 15213 //
     /* 2046952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2046963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2046966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2046969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046975 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046998 */     // MIs[0] round
     /* 2046998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047001 */     // MIs[0] policy
     /* 2047001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047011 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2047014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047037 */     // GIR_Coverage, 15213,
     /* 2047037 */     GIR_EraseRootFromParent_Done,
     /* 2047038 */   // Label 27269: @2047038
     /* 2047038 */   GIM_Try, /*On fail goto*//*Label 27270*/ GIMT_Encode4(2047129), // Rule ID 15216 //
     /* 2047043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2047054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2047057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2047060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047089 */     // MIs[0] round
     /* 2047089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047092 */     // MIs[0] policy
     /* 2047092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047102 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047128 */     // GIR_Coverage, 15216,
     /* 2047128 */     GIR_EraseRootFromParent_Done,
     /* 2047129 */   // Label 27270: @2047129
     /* 2047129 */   GIM_Try, /*On fail goto*//*Label 27271*/ GIMT_Encode4(2047220), // Rule ID 15217 //
     /* 2047134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2047145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2047148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2047151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047180 */     // MIs[0] round
     /* 2047180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047183 */     // MIs[0] policy
     /* 2047183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047193 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047206 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047216 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047219 */     // GIR_Coverage, 15217,
     /* 2047219 */     GIR_EraseRootFromParent_Done,
     /* 2047220 */   // Label 27271: @2047220
     /* 2047220 */   GIM_Try, /*On fail goto*//*Label 27272*/ GIMT_Encode4(2047311), // Rule ID 15220 //
     /* 2047225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2047236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2047239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2047242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047271 */     // MIs[0] round
     /* 2047271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047274 */     // MIs[0] policy
     /* 2047274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047284 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047307 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047310 */     // GIR_Coverage, 15220,
     /* 2047310 */     GIR_EraseRootFromParent_Done,
     /* 2047311 */   // Label 27272: @2047311
     /* 2047311 */   GIM_Try, /*On fail goto*//*Label 27273*/ GIMT_Encode4(2047402), // Rule ID 15221 //
     /* 2047316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2047327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2047330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2047333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047362 */     // MIs[0] round
     /* 2047362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047365 */     // MIs[0] policy
     /* 2047365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047375 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047401 */     // GIR_Coverage, 15221,
     /* 2047401 */     GIR_EraseRootFromParent_Done,
     /* 2047402 */   // Label 27273: @2047402
     /* 2047402 */   GIM_Try, /*On fail goto*//*Label 27274*/ GIMT_Encode4(2047493), // Rule ID 15224 //
     /* 2047407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2047418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2047421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2047424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047453 */     // MIs[0] round
     /* 2047453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047456 */     // MIs[0] policy
     /* 2047456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047466 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047492 */     // GIR_Coverage, 15224,
     /* 2047492 */     GIR_EraseRootFromParent_Done,
     /* 2047493 */   // Label 27274: @2047493
     /* 2047493 */   GIM_Try, /*On fail goto*//*Label 27275*/ GIMT_Encode4(2047584), // Rule ID 15225 //
     /* 2047498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2047509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2047512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2047515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047544 */     // MIs[0] round
     /* 2047544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047547 */     // MIs[0] policy
     /* 2047547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047557 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047583 */     // GIR_Coverage, 15225,
     /* 2047583 */     GIR_EraseRootFromParent_Done,
     /* 2047584 */   // Label 27275: @2047584
     /* 2047584 */   GIM_Try, /*On fail goto*//*Label 27276*/ GIMT_Encode4(2047675), // Rule ID 15228 //
     /* 2047589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2047600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2047603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2047606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047635 */     // MIs[0] round
     /* 2047635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047638 */     // MIs[0] policy
     /* 2047638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047648 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047674 */     // GIR_Coverage, 15228,
     /* 2047674 */     GIR_EraseRootFromParent_Done,
     /* 2047675 */   // Label 27276: @2047675
     /* 2047675 */   GIM_Try, /*On fail goto*//*Label 27277*/ GIMT_Encode4(2047766), // Rule ID 15229 //
     /* 2047680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2047691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2047694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2047697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047726 */     // MIs[0] round
     /* 2047726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047729 */     // MIs[0] policy
     /* 2047729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047739 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047765 */     // GIR_Coverage, 15229,
     /* 2047765 */     GIR_EraseRootFromParent_Done,
     /* 2047766 */   // Label 27277: @2047766
     /* 2047766 */   GIM_Try, /*On fail goto*//*Label 27278*/ GIMT_Encode4(2047857), // Rule ID 15232 //
     /* 2047771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2047782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2047785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2047788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047817 */     // MIs[0] round
     /* 2047817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047820 */     // MIs[0] policy
     /* 2047820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047856 */     // GIR_Coverage, 15232,
     /* 2047856 */     GIR_EraseRootFromParent_Done,
     /* 2047857 */   // Label 27278: @2047857
     /* 2047857 */   GIM_Try, /*On fail goto*//*Label 27279*/ GIMT_Encode4(2047948), // Rule ID 15233 //
     /* 2047862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2047873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2047876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2047879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047908 */     // MIs[0] round
     /* 2047908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047911 */     // MIs[0] policy
     /* 2047911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047921 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047947 */     // GIR_Coverage, 15233,
     /* 2047947 */     GIR_EraseRootFromParent_Done,
     /* 2047948 */   // Label 27279: @2047948
     /* 2047948 */   GIM_Try, /*On fail goto*//*Label 27280*/ GIMT_Encode4(2048039), // Rule ID 15236 //
     /* 2047953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2047956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2047964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2047967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2047970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047999 */     // MIs[0] round
     /* 2047999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048002 */     // MIs[0] policy
     /* 2048002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048012 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048038 */     // GIR_Coverage, 15236,
     /* 2048038 */     GIR_EraseRootFromParent_Done,
     /* 2048039 */   // Label 27280: @2048039
     /* 2048039 */   GIM_Try, /*On fail goto*//*Label 27281*/ GIMT_Encode4(2048130), // Rule ID 15237 //
     /* 2048044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2048047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2048055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2048058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2048061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048090 */     // MIs[0] round
     /* 2048090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048093 */     // MIs[0] policy
     /* 2048093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048103 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048129 */     // GIR_Coverage, 15237,
     /* 2048129 */     GIR_EraseRootFromParent_Done,
     /* 2048130 */   // Label 27281: @2048130
     /* 2048130 */   GIM_Try, /*On fail goto*//*Label 27282*/ GIMT_Encode4(2048221), // Rule ID 15240 //
     /* 2048135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2048146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2048149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2048152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048181 */     // MIs[0] round
     /* 2048181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048184 */     // MIs[0] policy
     /* 2048184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048194 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2048197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048220 */     // GIR_Coverage, 15240,
     /* 2048220 */     GIR_EraseRootFromParent_Done,
     /* 2048221 */   // Label 27282: @2048221
     /* 2048221 */   GIM_Try, /*On fail goto*//*Label 27283*/ GIMT_Encode4(2048312), // Rule ID 15241 //
     /* 2048226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2048237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2048240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2048243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048272 */     // MIs[0] round
     /* 2048272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048275 */     // MIs[0] policy
     /* 2048275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048285 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2048288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048311 */     // GIR_Coverage, 15241,
     /* 2048311 */     GIR_EraseRootFromParent_Done,
     /* 2048312 */   // Label 27283: @2048312
     /* 2048312 */   GIM_Try, /*On fail goto*//*Label 27284*/ GIMT_Encode4(2048403), // Rule ID 15244 //
     /* 2048317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2048328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2048331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2048334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2048340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048363 */     // MIs[0] round
     /* 2048363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048366 */     // MIs[0] policy
     /* 2048366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048376 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2048379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048402 */     // GIR_Coverage, 15244,
     /* 2048402 */     GIR_EraseRootFromParent_Done,
     /* 2048403 */   // Label 27284: @2048403
     /* 2048403 */   GIM_Try, /*On fail goto*//*Label 27285*/ GIMT_Encode4(2048494), // Rule ID 15245 //
     /* 2048408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2048419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2048422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2048425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2048431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048454 */     // MIs[0] round
     /* 2048454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048457 */     // MIs[0] policy
     /* 2048457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048467 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2048470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048493 */     // GIR_Coverage, 15245,
     /* 2048493 */     GIR_EraseRootFromParent_Done,
     /* 2048494 */   // Label 27285: @2048494
     /* 2048494 */   GIM_Try, /*On fail goto*//*Label 27286*/ GIMT_Encode4(2048585), // Rule ID 15248 //
     /* 2048499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2048510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2048513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2048516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2048522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2048529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048545 */     // MIs[0] round
     /* 2048545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048548 */     // MIs[0] policy
     /* 2048548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048558 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2048561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048584 */     // GIR_Coverage, 15248,
     /* 2048584 */     GIR_EraseRootFromParent_Done,
     /* 2048585 */   // Label 27286: @2048585
     /* 2048585 */   GIM_Try, /*On fail goto*//*Label 27287*/ GIMT_Encode4(2048676), // Rule ID 15249 //
     /* 2048590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2048601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2048604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2048607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2048613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2048620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048636 */     // MIs[0] round
     /* 2048636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048639 */     // MIs[0] policy
     /* 2048639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048649 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2048652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048675 */     // GIR_Coverage, 15249,
     /* 2048675 */     GIR_EraseRootFromParent_Done,
     /* 2048676 */   // Label 27287: @2048676
     /* 2048676 */   GIM_Try, /*On fail goto*//*Label 27288*/ GIMT_Encode4(2048767), // Rule ID 15252 //
     /* 2048681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2048692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2048695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2048698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2048704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048727 */     // MIs[0] round
     /* 2048727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048730 */     // MIs[0] policy
     /* 2048730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048740 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2048743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048766 */     // GIR_Coverage, 15252,
     /* 2048766 */     GIR_EraseRootFromParent_Done,
     /* 2048767 */   // Label 27288: @2048767
     /* 2048767 */   GIM_Try, /*On fail goto*//*Label 27289*/ GIMT_Encode4(2048858), // Rule ID 15253 //
     /* 2048772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2048783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2048786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2048789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2048795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048818 */     // MIs[0] round
     /* 2048818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048821 */     // MIs[0] policy
     /* 2048821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048831 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2048834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048857 */     // GIR_Coverage, 15253,
     /* 2048857 */     GIR_EraseRootFromParent_Done,
     /* 2048858 */   // Label 27289: @2048858
     /* 2048858 */   GIM_Try, /*On fail goto*//*Label 27290*/ GIMT_Encode4(2048949), // Rule ID 15256 //
     /* 2048863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2048874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2048877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2048880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048909 */     // MIs[0] round
     /* 2048909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048912 */     // MIs[0] policy
     /* 2048912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048922 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2048925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048948 */     // GIR_Coverage, 15256,
     /* 2048948 */     GIR_EraseRootFromParent_Done,
     /* 2048949 */   // Label 27290: @2048949
     /* 2048949 */   GIM_Try, /*On fail goto*//*Label 27291*/ GIMT_Encode4(2049040), // Rule ID 15257 //
     /* 2048954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2048965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2048968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2048971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049000 */     // MIs[0] round
     /* 2049000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049003 */     // MIs[0] policy
     /* 2049003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049013 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2049016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049039 */     // GIR_Coverage, 15257,
     /* 2049039 */     GIR_EraseRootFromParent_Done,
     /* 2049040 */   // Label 27291: @2049040
     /* 2049040 */   GIM_Try, /*On fail goto*//*Label 27292*/ GIMT_Encode4(2049131), // Rule ID 15260 //
     /* 2049045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2049056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2049059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2049062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049091 */     // MIs[0] round
     /* 2049091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049094 */     // MIs[0] policy
     /* 2049094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049104 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049130 */     // GIR_Coverage, 15260,
     /* 2049130 */     GIR_EraseRootFromParent_Done,
     /* 2049131 */   // Label 27292: @2049131
     /* 2049131 */   GIM_Try, /*On fail goto*//*Label 27293*/ GIMT_Encode4(2049222), // Rule ID 15261 //
     /* 2049136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2049147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2049150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2049153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049182 */     // MIs[0] round
     /* 2049182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049185 */     // MIs[0] policy
     /* 2049185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049195 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049221 */     // GIR_Coverage, 15261,
     /* 2049221 */     GIR_EraseRootFromParent_Done,
     /* 2049222 */   // Label 27293: @2049222
     /* 2049222 */   GIM_Try, /*On fail goto*//*Label 27294*/ GIMT_Encode4(2049313), // Rule ID 15264 //
     /* 2049227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2049238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2049241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2049244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049273 */     // MIs[0] round
     /* 2049273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049276 */     // MIs[0] policy
     /* 2049276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049312 */     // GIR_Coverage, 15264,
     /* 2049312 */     GIR_EraseRootFromParent_Done,
     /* 2049313 */   // Label 27294: @2049313
     /* 2049313 */   GIM_Try, /*On fail goto*//*Label 27295*/ GIMT_Encode4(2049404), // Rule ID 15265 //
     /* 2049318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2049329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2049332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2049335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049364 */     // MIs[0] round
     /* 2049364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049367 */     // MIs[0] policy
     /* 2049367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049377 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049403 */     // GIR_Coverage, 15265,
     /* 2049403 */     GIR_EraseRootFromParent_Done,
     /* 2049404 */   // Label 27295: @2049404
     /* 2049404 */   GIM_Try, /*On fail goto*//*Label 27296*/ GIMT_Encode4(2049495), // Rule ID 15268 //
     /* 2049409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2049420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2049423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2049426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049455 */     // MIs[0] round
     /* 2049455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049458 */     // MIs[0] policy
     /* 2049458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2049471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049494 */     // GIR_Coverage, 15268,
     /* 2049494 */     GIR_EraseRootFromParent_Done,
     /* 2049495 */   // Label 27296: @2049495
     /* 2049495 */   GIM_Try, /*On fail goto*//*Label 27297*/ GIMT_Encode4(2049586), // Rule ID 15269 //
     /* 2049500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2049511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2049514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2049517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049546 */     // MIs[0] round
     /* 2049546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049549 */     // MIs[0] policy
     /* 2049549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049559 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2049562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049585 */     // GIR_Coverage, 15269,
     /* 2049585 */     GIR_EraseRootFromParent_Done,
     /* 2049586 */   // Label 27297: @2049586
     /* 2049586 */   GIM_Try, /*On fail goto*//*Label 27298*/ GIMT_Encode4(2049677), // Rule ID 15272 //
     /* 2049591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2049602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2049605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2049608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049637 */     // MIs[0] round
     /* 2049637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049640 */     // MIs[0] policy
     /* 2049640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049650 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049676 */     // GIR_Coverage, 15272,
     /* 2049676 */     GIR_EraseRootFromParent_Done,
     /* 2049677 */   // Label 27298: @2049677
     /* 2049677 */   GIM_Try, /*On fail goto*//*Label 27299*/ GIMT_Encode4(2049768), // Rule ID 15273 //
     /* 2049682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2049693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2049696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2049699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049728 */     // MIs[0] round
     /* 2049728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049731 */     // MIs[0] policy
     /* 2049731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049741 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049767 */     // GIR_Coverage, 15273,
     /* 2049767 */     GIR_EraseRootFromParent_Done,
     /* 2049768 */   // Label 27299: @2049768
     /* 2049768 */   GIM_Try, /*On fail goto*//*Label 27300*/ GIMT_Encode4(2049859), // Rule ID 15276 //
     /* 2049773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2049776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2049784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2049787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2049790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2049796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049819 */     // MIs[0] round
     /* 2049819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049822 */     // MIs[0] policy
     /* 2049822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049832 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2049855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049858 */     // GIR_Coverage, 15276,
     /* 2049858 */     GIR_EraseRootFromParent_Done,
     /* 2049859 */   // Label 27300: @2049859
     /* 2049859 */   GIM_Try, /*On fail goto*//*Label 27301*/ GIMT_Encode4(2049950), // Rule ID 15277 //
     /* 2049864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2049867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2049875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2049878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2049881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2049887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049910 */     // MIs[0] round
     /* 2049910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049913 */     // MIs[0] policy
     /* 2049913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049923 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049936 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2049946 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049949 */     // GIR_Coverage, 15277,
     /* 2049949 */     GIR_EraseRootFromParent_Done,
     /* 2049950 */   // Label 27301: @2049950
     /* 2049950 */   GIM_Try, /*On fail goto*//*Label 27302*/ GIMT_Encode4(2050041), // Rule ID 15280 //
     /* 2049955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2049958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2049966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2049969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2049972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050001 */     // MIs[0] round
     /* 2050001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050004 */     // MIs[0] policy
     /* 2050004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050014 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2050017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050040 */     // GIR_Coverage, 15280,
     /* 2050040 */     GIR_EraseRootFromParent_Done,
     /* 2050041 */   // Label 27302: @2050041
     /* 2050041 */   GIM_Try, /*On fail goto*//*Label 27303*/ GIMT_Encode4(2050132), // Rule ID 15281 //
     /* 2050046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2050057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2050060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2050063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050092 */     // MIs[0] round
     /* 2050092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050095 */     // MIs[0] policy
     /* 2050095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050105 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2050108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050131 */     // GIR_Coverage, 15281,
     /* 2050131 */     GIR_EraseRootFromParent_Done,
     /* 2050132 */   // Label 27303: @2050132
     /* 2050132 */   GIM_Try, /*On fail goto*//*Label 27304*/ GIMT_Encode4(2050223), // Rule ID 15284 //
     /* 2050137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2050140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2050148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2050151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2050154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050183 */     // MIs[0] round
     /* 2050183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050186 */     // MIs[0] policy
     /* 2050186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050196 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2050199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050222 */     // GIR_Coverage, 15284,
     /* 2050222 */     GIR_EraseRootFromParent_Done,
     /* 2050223 */   // Label 27304: @2050223
     /* 2050223 */   GIM_Try, /*On fail goto*//*Label 27305*/ GIMT_Encode4(2050314), // Rule ID 15285 //
     /* 2050228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2050239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2050242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2050245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050274 */     // MIs[0] round
     /* 2050274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050277 */     // MIs[0] policy
     /* 2050277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050287 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2050290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050313 */     // GIR_Coverage, 15285,
     /* 2050313 */     GIR_EraseRootFromParent_Done,
     /* 2050314 */   // Label 27305: @2050314
     /* 2050314 */   GIM_Try, /*On fail goto*//*Label 27306*/ GIMT_Encode4(2050405), // Rule ID 15288 //
     /* 2050319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2050330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2050333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2050336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2050339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050365 */     // MIs[0] round
     /* 2050365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050368 */     // MIs[0] policy
     /* 2050368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050378 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2050381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050404 */     // GIR_Coverage, 15288,
     /* 2050404 */     GIR_EraseRootFromParent_Done,
     /* 2050405 */   // Label 27306: @2050405
     /* 2050405 */   GIM_Try, /*On fail goto*//*Label 27307*/ GIMT_Encode4(2050496), // Rule ID 15289 //
     /* 2050410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2050421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2050424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2050427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2050430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050456 */     // MIs[0] round
     /* 2050456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050459 */     // MIs[0] policy
     /* 2050459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050469 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2050472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050495 */     // GIR_Coverage, 15289,
     /* 2050495 */     GIR_EraseRootFromParent_Done,
     /* 2050496 */   // Label 27307: @2050496
     /* 2050496 */   GIM_Try, /*On fail goto*//*Label 27308*/ GIMT_Encode4(2050587), // Rule ID 15292 //
     /* 2050501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2050512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2050515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2050518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2050521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050547 */     // MIs[0] round
     /* 2050547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050550 */     // MIs[0] policy
     /* 2050550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050560 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2050563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050586 */     // GIR_Coverage, 15292,
     /* 2050586 */     GIR_EraseRootFromParent_Done,
     /* 2050587 */   // Label 27308: @2050587
     /* 2050587 */   GIM_Try, /*On fail goto*//*Label 27309*/ GIMT_Encode4(2050678), // Rule ID 15293 //
     /* 2050592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2050603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2050606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2050609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2050612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050638 */     // MIs[0] round
     /* 2050638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050641 */     // MIs[0] policy
     /* 2050641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050651 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2050654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050677 */     // GIR_Coverage, 15293,
     /* 2050677 */     GIR_EraseRootFromParent_Done,
     /* 2050678 */   // Label 27309: @2050678
     /* 2050678 */   GIM_Try, /*On fail goto*//*Label 27310*/ GIMT_Encode4(2050769), // Rule ID 15296 //
     /* 2050683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2050694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2050697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2050700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2050703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050729 */     // MIs[0] round
     /* 2050729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050732 */     // MIs[0] policy
     /* 2050732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050742 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2050745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050768 */     // GIR_Coverage, 15296,
     /* 2050768 */     GIR_EraseRootFromParent_Done,
     /* 2050769 */   // Label 27310: @2050769
     /* 2050769 */   GIM_Try, /*On fail goto*//*Label 27311*/ GIMT_Encode4(2050860), // Rule ID 15297 //
     /* 2050774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2050785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2050788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2050791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2050794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050820 */     // MIs[0] round
     /* 2050820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050823 */     // MIs[0] policy
     /* 2050823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050833 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2050836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050859 */     // GIR_Coverage, 15297,
     /* 2050859 */     GIR_EraseRootFromParent_Done,
     /* 2050860 */   // Label 27311: @2050860
     /* 2050860 */   GIM_Try, /*On fail goto*//*Label 27312*/ GIMT_Encode4(2050951), // Rule ID 15300 //
     /* 2050865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2050876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2050879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2050882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2050885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050911 */     // MIs[0] round
     /* 2050911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050914 */     // MIs[0] policy
     /* 2050914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050924 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2050927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2050947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050950 */     // GIR_Coverage, 15300,
     /* 2050950 */     GIR_EraseRootFromParent_Done,
     /* 2050951 */   // Label 27312: @2050951
     /* 2050951 */   GIM_Try, /*On fail goto*//*Label 27313*/ GIMT_Encode4(2051042), // Rule ID 15301 //
     /* 2050956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2050967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2050970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2050973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2050976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051002 */     // MIs[0] round
     /* 2051002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051005 */     // MIs[0] policy
     /* 2051005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051015 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2051018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051041 */     // GIR_Coverage, 15301,
     /* 2051041 */     GIR_EraseRootFromParent_Done,
     /* 2051042 */   // Label 27313: @2051042
     /* 2051042 */   GIM_Try, /*On fail goto*//*Label 27314*/ GIMT_Encode4(2051133), // Rule ID 15304 //
     /* 2051047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2051058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2051061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2051064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2051067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051093 */     // MIs[0] round
     /* 2051093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051096 */     // MIs[0] policy
     /* 2051096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051106 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051132 */     // GIR_Coverage, 15304,
     /* 2051132 */     GIR_EraseRootFromParent_Done,
     /* 2051133 */   // Label 27314: @2051133
     /* 2051133 */   GIM_Try, /*On fail goto*//*Label 27315*/ GIMT_Encode4(2051224), // Rule ID 15305 //
     /* 2051138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2051149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2051152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2051155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2051158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051184 */     // MIs[0] round
     /* 2051184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051187 */     // MIs[0] policy
     /* 2051187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051197 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051223 */     // GIR_Coverage, 15305,
     /* 2051223 */     GIR_EraseRootFromParent_Done,
     /* 2051224 */   // Label 27315: @2051224
     /* 2051224 */   GIM_Try, /*On fail goto*//*Label 27316*/ GIMT_Encode4(2051315), // Rule ID 15308 //
     /* 2051229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2051240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2051243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2051246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2051249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051275 */     // MIs[0] round
     /* 2051275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051278 */     // MIs[0] policy
     /* 2051278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051288 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051314 */     // GIR_Coverage, 15308,
     /* 2051314 */     GIR_EraseRootFromParent_Done,
     /* 2051315 */   // Label 27316: @2051315
     /* 2051315 */   GIM_Try, /*On fail goto*//*Label 27317*/ GIMT_Encode4(2051406), // Rule ID 15309 //
     /* 2051320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2051331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2051334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2051337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2051340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051366 */     // MIs[0] round
     /* 2051366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051369 */     // MIs[0] policy
     /* 2051369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051379 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051405 */     // GIR_Coverage, 15309,
     /* 2051405 */     GIR_EraseRootFromParent_Done,
     /* 2051406 */   // Label 27317: @2051406
     /* 2051406 */   GIM_Try, /*On fail goto*//*Label 27318*/ GIMT_Encode4(2051497), // Rule ID 15312 //
     /* 2051411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2051422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2051425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2051428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2051431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2051434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051457 */     // MIs[0] round
     /* 2051457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051460 */     // MIs[0] policy
     /* 2051460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051470 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051496 */     // GIR_Coverage, 15312,
     /* 2051496 */     GIR_EraseRootFromParent_Done,
     /* 2051497 */   // Label 27318: @2051497
     /* 2051497 */   GIM_Try, /*On fail goto*//*Label 27319*/ GIMT_Encode4(2051588), // Rule ID 15313 //
     /* 2051502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2051513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2051516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2051519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2051522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2051525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051548 */     // MIs[0] round
     /* 2051548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051551 */     // MIs[0] policy
     /* 2051551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051561 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051587 */     // GIR_Coverage, 15313,
     /* 2051587 */     GIR_EraseRootFromParent_Done,
     /* 2051588 */   // Label 27319: @2051588
     /* 2051588 */   GIM_Try, /*On fail goto*//*Label 27320*/ GIMT_Encode4(2051679), // Rule ID 15316 //
     /* 2051593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2051604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2051607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2051610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2051613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051639 */     // MIs[0] round
     /* 2051639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051642 */     // MIs[0] policy
     /* 2051642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051678 */     // GIR_Coverage, 15316,
     /* 2051678 */     GIR_EraseRootFromParent_Done,
     /* 2051679 */   // Label 27320: @2051679
     /* 2051679 */   GIM_Try, /*On fail goto*//*Label 27321*/ GIMT_Encode4(2051770), // Rule ID 15317 //
     /* 2051684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2051695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2051698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2051701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2051704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051730 */     // MIs[0] round
     /* 2051730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051733 */     // MIs[0] policy
     /* 2051733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051743 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051769 */     // GIR_Coverage, 15317,
     /* 2051769 */     GIR_EraseRootFromParent_Done,
     /* 2051770 */   // Label 27321: @2051770
     /* 2051770 */   GIM_Try, /*On fail goto*//*Label 27322*/ GIMT_Encode4(2051861), // Rule ID 15320 //
     /* 2051775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2051786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2051789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2051792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2051795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051821 */     // MIs[0] round
     /* 2051821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051824 */     // MIs[0] policy
     /* 2051824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051860 */     // GIR_Coverage, 15320,
     /* 2051860 */     GIR_EraseRootFromParent_Done,
     /* 2051861 */   // Label 27322: @2051861
     /* 2051861 */   GIM_Try, /*On fail goto*//*Label 27323*/ GIMT_Encode4(2051952), // Rule ID 15321 //
     /* 2051866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2051877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2051880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2051883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2051886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051912 */     // MIs[0] round
     /* 2051912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051915 */     // MIs[0] policy
     /* 2051915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051925 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051951 */     // GIR_Coverage, 15321,
     /* 2051951 */     GIR_EraseRootFromParent_Done,
     /* 2051952 */   // Label 27323: @2051952
     /* 2051952 */   GIM_Try, /*On fail goto*//*Label 27324*/ GIMT_Encode4(2052043), // Rule ID 15324 //
     /* 2051957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2051960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2051968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2051971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2051974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2051977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052003 */     // MIs[0] round
     /* 2052003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052006 */     // MIs[0] policy
     /* 2052006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052016 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2052039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052042 */     // GIR_Coverage, 15324,
     /* 2052042 */     GIR_EraseRootFromParent_Done,
     /* 2052043 */   // Label 27324: @2052043
     /* 2052043 */   GIM_Try, /*On fail goto*//*Label 27325*/ GIMT_Encode4(2052134), // Rule ID 15325 //
     /* 2052048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2052051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2052059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2052062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2052065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2052068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052094 */     // MIs[0] round
     /* 2052094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052097 */     // MIs[0] policy
     /* 2052097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052107 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2052130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052133 */     // GIR_Coverage, 15325,
     /* 2052133 */     GIR_EraseRootFromParent_Done,
     /* 2052134 */   // Label 27325: @2052134
     /* 2052134 */   GIM_Try, /*On fail goto*//*Label 27326*/ GIMT_Encode4(2052225), // Rule ID 15328 //
     /* 2052139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2052150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2052153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2052156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2052159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052185 */     // MIs[0] round
     /* 2052185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052188 */     // MIs[0] policy
     /* 2052188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052198 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2052201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052224 */     // GIR_Coverage, 15328,
     /* 2052224 */     GIR_EraseRootFromParent_Done,
     /* 2052225 */   // Label 27326: @2052225
     /* 2052225 */   GIM_Try, /*On fail goto*//*Label 27327*/ GIMT_Encode4(2052316), // Rule ID 15329 //
     /* 2052230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2052241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2052244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2052247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2052250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052276 */     // MIs[0] round
     /* 2052276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052279 */     // MIs[0] policy
     /* 2052279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052289 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2052292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052315 */     // GIR_Coverage, 15329,
     /* 2052315 */     GIR_EraseRootFromParent_Done,
     /* 2052316 */   // Label 27327: @2052316
     /* 2052316 */   GIM_Try, /*On fail goto*//*Label 27328*/ GIMT_Encode4(2052407), // Rule ID 15332 //
     /* 2052321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2052332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2052335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2052338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2052341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052367 */     // MIs[0] round
     /* 2052367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052370 */     // MIs[0] policy
     /* 2052370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052380 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2052383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052406 */     // GIR_Coverage, 15332,
     /* 2052406 */     GIR_EraseRootFromParent_Done,
     /* 2052407 */   // Label 27328: @2052407
     /* 2052407 */   GIM_Try, /*On fail goto*//*Label 27329*/ GIMT_Encode4(2052498), // Rule ID 15333 //
     /* 2052412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2052423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2052426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2052429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2052432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052458 */     // MIs[0] round
     /* 2052458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052461 */     // MIs[0] policy
     /* 2052461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052471 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2052474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052497 */     // GIR_Coverage, 15333,
     /* 2052497 */     GIR_EraseRootFromParent_Done,
     /* 2052498 */   // Label 27329: @2052498
     /* 2052498 */   GIM_Try, /*On fail goto*//*Label 27330*/ GIMT_Encode4(2052589), // Rule ID 15336 //
     /* 2052503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2052514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2052517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2052520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2052523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2052526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2052533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052549 */     // MIs[0] round
     /* 2052549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052552 */     // MIs[0] policy
     /* 2052552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052562 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2052565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052588 */     // GIR_Coverage, 15336,
     /* 2052588 */     GIR_EraseRootFromParent_Done,
     /* 2052589 */   // Label 27330: @2052589
     /* 2052589 */   GIM_Try, /*On fail goto*//*Label 27331*/ GIMT_Encode4(2052680), // Rule ID 15337 //
     /* 2052594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2052605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2052608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2052611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2052614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2052617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2052624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052640 */     // MIs[0] round
     /* 2052640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052643 */     // MIs[0] policy
     /* 2052643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052653 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2052656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052679 */     // GIR_Coverage, 15337,
     /* 2052679 */     GIR_EraseRootFromParent_Done,
     /* 2052680 */   // Label 27331: @2052680
     /* 2052680 */   GIM_Try, /*On fail goto*//*Label 27332*/ GIMT_Encode4(2052771), // Rule ID 15340 //
     /* 2052685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2052696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2052699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2052702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2052705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052731 */     // MIs[0] round
     /* 2052731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052734 */     // MIs[0] policy
     /* 2052734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052744 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2052747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052770 */     // GIR_Coverage, 15340,
     /* 2052770 */     GIR_EraseRootFromParent_Done,
     /* 2052771 */   // Label 27332: @2052771
     /* 2052771 */   GIM_Try, /*On fail goto*//*Label 27333*/ GIMT_Encode4(2052862), // Rule ID 15341 //
     /* 2052776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2052787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2052790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2052793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2052796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052822 */     // MIs[0] round
     /* 2052822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052825 */     // MIs[0] policy
     /* 2052825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2052838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052861 */     // GIR_Coverage, 15341,
     /* 2052861 */     GIR_EraseRootFromParent_Done,
     /* 2052862 */   // Label 27333: @2052862
     /* 2052862 */   GIM_Try, /*On fail goto*//*Label 27334*/ GIMT_Encode4(2052953), // Rule ID 15344 //
     /* 2052867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2052878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2052881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2052884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2052887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052913 */     // MIs[0] round
     /* 2052913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052916 */     // MIs[0] policy
     /* 2052916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2052929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052952 */     // GIR_Coverage, 15344,
     /* 2052952 */     GIR_EraseRootFromParent_Done,
     /* 2052953 */   // Label 27334: @2052953
     /* 2052953 */   GIM_Try, /*On fail goto*//*Label 27335*/ GIMT_Encode4(2053044), // Rule ID 15345 //
     /* 2052958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2052969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2052972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2052975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2052978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053004 */     // MIs[0] round
     /* 2053004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053007 */     // MIs[0] policy
     /* 2053007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053017 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2053020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053043 */     // GIR_Coverage, 15345,
     /* 2053043 */     GIR_EraseRootFromParent_Done,
     /* 2053044 */   // Label 27335: @2053044
     /* 2053044 */   GIM_Try, /*On fail goto*//*Label 27336*/ GIMT_Encode4(2053135), // Rule ID 15348 //
     /* 2053049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2053060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2053063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2053066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2053069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053095 */     // MIs[0] round
     /* 2053095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053098 */     // MIs[0] policy
     /* 2053098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053108 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053134 */     // GIR_Coverage, 15348,
     /* 2053134 */     GIR_EraseRootFromParent_Done,
     /* 2053135 */   // Label 27336: @2053135
     /* 2053135 */   GIM_Try, /*On fail goto*//*Label 27337*/ GIMT_Encode4(2053226), // Rule ID 15349 //
     /* 2053140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2053151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2053154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2053157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2053160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053186 */     // MIs[0] round
     /* 2053186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053189 */     // MIs[0] policy
     /* 2053189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053199 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053225 */     // GIR_Coverage, 15349,
     /* 2053225 */     GIR_EraseRootFromParent_Done,
     /* 2053226 */   // Label 27337: @2053226
     /* 2053226 */   GIM_Try, /*On fail goto*//*Label 27338*/ GIMT_Encode4(2053317), // Rule ID 15352 //
     /* 2053231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2053242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2053245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2053248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2053251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053277 */     // MIs[0] round
     /* 2053277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053280 */     // MIs[0] policy
     /* 2053280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053316 */     // GIR_Coverage, 15352,
     /* 2053316 */     GIR_EraseRootFromParent_Done,
     /* 2053317 */   // Label 27338: @2053317
     /* 2053317 */   GIM_Try, /*On fail goto*//*Label 27339*/ GIMT_Encode4(2053408), // Rule ID 15353 //
     /* 2053322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2053333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2053336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2053339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2053342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053368 */     // MIs[0] round
     /* 2053368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053371 */     // MIs[0] policy
     /* 2053371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053381 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053407 */     // GIR_Coverage, 15353,
     /* 2053407 */     GIR_EraseRootFromParent_Done,
     /* 2053408 */   // Label 27339: @2053408
     /* 2053408 */   GIM_Try, /*On fail goto*//*Label 27340*/ GIMT_Encode4(2053499), // Rule ID 15356 //
     /* 2053413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2053424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2053427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2053430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2053433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053459 */     // MIs[0] round
     /* 2053459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053462 */     // MIs[0] policy
     /* 2053462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053472 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2053475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053498 */     // GIR_Coverage, 15356,
     /* 2053498 */     GIR_EraseRootFromParent_Done,
     /* 2053499 */   // Label 27340: @2053499
     /* 2053499 */   GIM_Try, /*On fail goto*//*Label 27341*/ GIMT_Encode4(2053590), // Rule ID 15357 //
     /* 2053504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2053515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2053518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2053521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2053524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053550 */     // MIs[0] round
     /* 2053550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053553 */     // MIs[0] policy
     /* 2053553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053563 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2053566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053589 */     // GIR_Coverage, 15357,
     /* 2053589 */     GIR_EraseRootFromParent_Done,
     /* 2053590 */   // Label 27341: @2053590
     /* 2053590 */   GIM_Try, /*On fail goto*//*Label 27342*/ GIMT_Encode4(2053681), // Rule ID 15360 //
     /* 2053595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2053606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2053609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2053612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2053615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053641 */     // MIs[0] round
     /* 2053641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053644 */     // MIs[0] policy
     /* 2053644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053654 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053680 */     // GIR_Coverage, 15360,
     /* 2053680 */     GIR_EraseRootFromParent_Done,
     /* 2053681 */   // Label 27342: @2053681
     /* 2053681 */   GIM_Try, /*On fail goto*//*Label 27343*/ GIMT_Encode4(2053772), // Rule ID 15361 //
     /* 2053686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2053697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2053700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2053703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2053706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053732 */     // MIs[0] round
     /* 2053732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053735 */     // MIs[0] policy
     /* 2053735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053745 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053771 */     // GIR_Coverage, 15361,
     /* 2053771 */     GIR_EraseRootFromParent_Done,
     /* 2053772 */   // Label 27343: @2053772
     /* 2053772 */   GIM_Try, /*On fail goto*//*Label 27344*/ GIMT_Encode4(2053863), // Rule ID 15364 //
     /* 2053777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2053780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2053788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2053791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2053794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2053797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2053800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053823 */     // MIs[0] round
     /* 2053823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053826 */     // MIs[0] policy
     /* 2053826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053862 */     // GIR_Coverage, 15364,
     /* 2053862 */     GIR_EraseRootFromParent_Done,
     /* 2053863 */   // Label 27344: @2053863
     /* 2053863 */   GIM_Try, /*On fail goto*//*Label 27345*/ GIMT_Encode4(2053954), // Rule ID 15365 //
     /* 2053868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2053871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2053879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2053882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2053885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2053888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2053891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053914 */     // MIs[0] round
     /* 2053914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053917 */     // MIs[0] policy
     /* 2053917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053953 */     // GIR_Coverage, 15365,
     /* 2053953 */     GIR_EraseRootFromParent_Done,
     /* 2053954 */   // Label 27345: @2053954
     /* 2053954 */   GIM_Try, /*On fail goto*//*Label 27346*/ GIMT_Encode4(2054045), // Rule ID 15368 //
     /* 2053959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2053962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2053970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2053973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2053976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2053979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054005 */     // MIs[0] round
     /* 2054005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054008 */     // MIs[0] policy
     /* 2054008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2054021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054044 */     // GIR_Coverage, 15368,
     /* 2054044 */     GIR_EraseRootFromParent_Done,
     /* 2054045 */   // Label 27346: @2054045
     /* 2054045 */   GIM_Try, /*On fail goto*//*Label 27347*/ GIMT_Encode4(2054136), // Rule ID 15369 //
     /* 2054050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2054061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2054064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2054067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2054070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054096 */     // MIs[0] round
     /* 2054096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054099 */     // MIs[0] policy
     /* 2054099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054109 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2054112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054135 */     // GIR_Coverage, 15369,
     /* 2054135 */     GIR_EraseRootFromParent_Done,
     /* 2054136 */   // Label 27347: @2054136
     /* 2054136 */   GIM_Try, /*On fail goto*//*Label 27348*/ GIMT_Encode4(2054227), // Rule ID 15372 //
     /* 2054141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2054144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2054152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2054155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2054158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2054161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054187 */     // MIs[0] round
     /* 2054187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054190 */     // MIs[0] policy
     /* 2054190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054200 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2054203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054226 */     // GIR_Coverage, 15372,
     /* 2054226 */     GIR_EraseRootFromParent_Done,
     /* 2054227 */   // Label 27348: @2054227
     /* 2054227 */   GIM_Try, /*On fail goto*//*Label 27349*/ GIMT_Encode4(2054318), // Rule ID 15373 //
     /* 2054232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2054243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2054246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2054249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2054252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054278 */     // MIs[0] round
     /* 2054278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054281 */     // MIs[0] policy
     /* 2054281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054291 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2054294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054317 */     // GIR_Coverage, 15373,
     /* 2054317 */     GIR_EraseRootFromParent_Done,
     /* 2054318 */   // Label 27349: @2054318
     /* 2054318 */   GIM_Try, /*On fail goto*//*Label 27350*/ GIMT_Encode4(2054409), // Rule ID 15376 //
     /* 2054323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2054334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2054337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2054340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054369 */     // MIs[0] round
     /* 2054369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054372 */     // MIs[0] policy
     /* 2054372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054382 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2054385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054408 */     // GIR_Coverage, 15376,
     /* 2054408 */     GIR_EraseRootFromParent_Done,
     /* 2054409 */   // Label 27350: @2054409
     /* 2054409 */   GIM_Try, /*On fail goto*//*Label 27351*/ GIMT_Encode4(2054500), // Rule ID 15377 //
     /* 2054414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2054425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2054428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2054431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054460 */     // MIs[0] round
     /* 2054460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054463 */     // MIs[0] policy
     /* 2054463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054473 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2054476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054499 */     // GIR_Coverage, 15377,
     /* 2054499 */     GIR_EraseRootFromParent_Done,
     /* 2054500 */   // Label 27351: @2054500
     /* 2054500 */   GIM_Try, /*On fail goto*//*Label 27352*/ GIMT_Encode4(2054591), // Rule ID 15380 //
     /* 2054505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2054516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2054519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2054522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054551 */     // MIs[0] round
     /* 2054551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054554 */     // MIs[0] policy
     /* 2054554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054564 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2054567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054590 */     // GIR_Coverage, 15380,
     /* 2054590 */     GIR_EraseRootFromParent_Done,
     /* 2054591 */   // Label 27352: @2054591
     /* 2054591 */   GIM_Try, /*On fail goto*//*Label 27353*/ GIMT_Encode4(2054682), // Rule ID 15381 //
     /* 2054596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2054607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2054610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2054613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054642 */     // MIs[0] round
     /* 2054642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054645 */     // MIs[0] policy
     /* 2054645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054655 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2054658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054681 */     // GIR_Coverage, 15381,
     /* 2054681 */     GIR_EraseRootFromParent_Done,
     /* 2054682 */   // Label 27353: @2054682
     /* 2054682 */   GIM_Try, /*On fail goto*//*Label 27354*/ GIMT_Encode4(2054773), // Rule ID 15384 //
     /* 2054687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2054698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2054701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2054704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054733 */     // MIs[0] round
     /* 2054733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054736 */     // MIs[0] policy
     /* 2054736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054746 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2054749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054772 */     // GIR_Coverage, 15384,
     /* 2054772 */     GIR_EraseRootFromParent_Done,
     /* 2054773 */   // Label 27354: @2054773
     /* 2054773 */   GIM_Try, /*On fail goto*//*Label 27355*/ GIMT_Encode4(2054864), // Rule ID 15385 //
     /* 2054778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2054789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2054792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2054795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054824 */     // MIs[0] round
     /* 2054824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054827 */     // MIs[0] policy
     /* 2054827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054837 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2054840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054863 */     // GIR_Coverage, 15385,
     /* 2054863 */     GIR_EraseRootFromParent_Done,
     /* 2054864 */   // Label 27355: @2054864
     /* 2054864 */   GIM_Try, /*On fail goto*//*Label 27356*/ GIMT_Encode4(2054955), // Rule ID 15388 //
     /* 2054869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2054880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2054883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2054886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054915 */     // MIs[0] round
     /* 2054915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054918 */     // MIs[0] policy
     /* 2054918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054928 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2054931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054954 */     // GIR_Coverage, 15388,
     /* 2054954 */     GIR_EraseRootFromParent_Done,
     /* 2054955 */   // Label 27356: @2054955
     /* 2054955 */   GIM_Try, /*On fail goto*//*Label 27357*/ GIMT_Encode4(2055046), // Rule ID 15389 //
     /* 2054960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2054971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2054974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2054977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055006 */     // MIs[0] round
     /* 2055006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055009 */     // MIs[0] policy
     /* 2055009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055019 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2055022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055045 */     // GIR_Coverage, 15389,
     /* 2055045 */     GIR_EraseRootFromParent_Done,
     /* 2055046 */   // Label 27357: @2055046
     /* 2055046 */   GIM_Try, /*On fail goto*//*Label 27358*/ GIMT_Encode4(2055137), // Rule ID 15392 //
     /* 2055051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2055062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2055065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2055068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055097 */     // MIs[0] round
     /* 2055097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055100 */     // MIs[0] policy
     /* 2055100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055110 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055136 */     // GIR_Coverage, 15392,
     /* 2055136 */     GIR_EraseRootFromParent_Done,
     /* 2055137 */   // Label 27358: @2055137
     /* 2055137 */   GIM_Try, /*On fail goto*//*Label 27359*/ GIMT_Encode4(2055228), // Rule ID 15393 //
     /* 2055142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2055153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2055156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2055159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055188 */     // MIs[0] round
     /* 2055188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055191 */     // MIs[0] policy
     /* 2055191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055201 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055227 */     // GIR_Coverage, 15393,
     /* 2055227 */     GIR_EraseRootFromParent_Done,
     /* 2055228 */   // Label 27359: @2055228
     /* 2055228 */   GIM_Try, /*On fail goto*//*Label 27360*/ GIMT_Encode4(2055319), // Rule ID 15396 //
     /* 2055233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2055244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2055247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2055250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055279 */     // MIs[0] round
     /* 2055279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055282 */     // MIs[0] policy
     /* 2055282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055292 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055318 */     // GIR_Coverage, 15396,
     /* 2055318 */     GIR_EraseRootFromParent_Done,
     /* 2055319 */   // Label 27360: @2055319
     /* 2055319 */   GIM_Try, /*On fail goto*//*Label 27361*/ GIMT_Encode4(2055410), // Rule ID 15397 //
     /* 2055324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2055335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2055338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2055341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055370 */     // MIs[0] round
     /* 2055370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055373 */     // MIs[0] policy
     /* 2055373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055383 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055409 */     // GIR_Coverage, 15397,
     /* 2055409 */     GIR_EraseRootFromParent_Done,
     /* 2055410 */   // Label 27361: @2055410
     /* 2055410 */   GIM_Try, /*On fail goto*//*Label 27362*/ GIMT_Encode4(2055501), // Rule ID 15400 //
     /* 2055415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2055426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2055429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2055432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055461 */     // MIs[0] round
     /* 2055461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055464 */     // MIs[0] policy
     /* 2055464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055474 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055500 */     // GIR_Coverage, 15400,
     /* 2055500 */     GIR_EraseRootFromParent_Done,
     /* 2055501 */   // Label 27362: @2055501
     /* 2055501 */   GIM_Try, /*On fail goto*//*Label 27363*/ GIMT_Encode4(2055592), // Rule ID 15401 //
     /* 2055506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2055517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2055520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2055523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055552 */     // MIs[0] round
     /* 2055552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055555 */     // MIs[0] policy
     /* 2055555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055565 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055591 */     // GIR_Coverage, 15401,
     /* 2055591 */     GIR_EraseRootFromParent_Done,
     /* 2055592 */   // Label 27363: @2055592
     /* 2055592 */   GIM_Try, /*On fail goto*//*Label 27364*/ GIMT_Encode4(2055683), // Rule ID 15404 //
     /* 2055597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2055608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2055611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2055614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055643 */     // MIs[0] round
     /* 2055643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055646 */     // MIs[0] policy
     /* 2055646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055656 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055682 */     // GIR_Coverage, 15404,
     /* 2055682 */     GIR_EraseRootFromParent_Done,
     /* 2055683 */   // Label 27364: @2055683
     /* 2055683 */   GIM_Try, /*On fail goto*//*Label 27365*/ GIMT_Encode4(2055774), // Rule ID 15405 //
     /* 2055688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2055699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2055702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2055705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055734 */     // MIs[0] round
     /* 2055734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055737 */     // MIs[0] policy
     /* 2055737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055747 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055773 */     // GIR_Coverage, 15405,
     /* 2055773 */     GIR_EraseRootFromParent_Done,
     /* 2055774 */   // Label 27365: @2055774
     /* 2055774 */   GIM_Try, /*On fail goto*//*Label 27366*/ GIMT_Encode4(2055865), // Rule ID 15408 //
     /* 2055779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2055790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2055793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2055796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055825 */     // MIs[0] round
     /* 2055825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055828 */     // MIs[0] policy
     /* 2055828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055864 */     // GIR_Coverage, 15408,
     /* 2055864 */     GIR_EraseRootFromParent_Done,
     /* 2055865 */   // Label 27366: @2055865
     /* 2055865 */   GIM_Try, /*On fail goto*//*Label 27367*/ GIMT_Encode4(2055956), // Rule ID 15409 //
     /* 2055870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2055881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2055884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2055887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055916 */     // MIs[0] round
     /* 2055916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055919 */     // MIs[0] policy
     /* 2055919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055929 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055955 */     // GIR_Coverage, 15409,
     /* 2055955 */     GIR_EraseRootFromParent_Done,
     /* 2055956 */   // Label 27367: @2055956
     /* 2055956 */   GIM_Try, /*On fail goto*//*Label 27368*/ GIMT_Encode4(2056047), // Rule ID 15412 //
     /* 2055961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2055964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2055972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2055975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2055978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056007 */     // MIs[0] round
     /* 2056007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056010 */     // MIs[0] policy
     /* 2056010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056046 */     // GIR_Coverage, 15412,
     /* 2056046 */     GIR_EraseRootFromParent_Done,
     /* 2056047 */   // Label 27368: @2056047
     /* 2056047 */   GIM_Try, /*On fail goto*//*Label 27369*/ GIMT_Encode4(2056138), // Rule ID 15413 //
     /* 2056052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2056055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2056063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2056066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2056069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056098 */     // MIs[0] round
     /* 2056098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056101 */     // MIs[0] policy
     /* 2056101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056111 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056137 */     // GIR_Coverage, 15413,
     /* 2056137 */     GIR_EraseRootFromParent_Done,
     /* 2056138 */   // Label 27369: @2056138
     /* 2056138 */   GIM_Try, /*On fail goto*//*Label 27370*/ GIMT_Encode4(2056229), // Rule ID 15416 //
     /* 2056143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2056154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2056157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2056160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056189 */     // MIs[0] round
     /* 2056189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056192 */     // MIs[0] policy
     /* 2056192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056202 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2056205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056228 */     // GIR_Coverage, 15416,
     /* 2056228 */     GIR_EraseRootFromParent_Done,
     /* 2056229 */   // Label 27370: @2056229
     /* 2056229 */   GIM_Try, /*On fail goto*//*Label 27371*/ GIMT_Encode4(2056320), // Rule ID 15417 //
     /* 2056234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2056245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2056248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2056251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056280 */     // MIs[0] round
     /* 2056280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056283 */     // MIs[0] policy
     /* 2056283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056293 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2056296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056319 */     // GIR_Coverage, 15417,
     /* 2056319 */     GIR_EraseRootFromParent_Done,
     /* 2056320 */   // Label 27371: @2056320
     /* 2056320 */   GIM_Try, /*On fail goto*//*Label 27372*/ GIMT_Encode4(2056411), // Rule ID 15420 //
     /* 2056325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2056336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2056339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2056342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2056348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056371 */     // MIs[0] round
     /* 2056371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056374 */     // MIs[0] policy
     /* 2056374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2056387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056410 */     // GIR_Coverage, 15420,
     /* 2056410 */     GIR_EraseRootFromParent_Done,
     /* 2056411 */   // Label 27372: @2056411
     /* 2056411 */   GIM_Try, /*On fail goto*//*Label 27373*/ GIMT_Encode4(2056502), // Rule ID 15421 //
     /* 2056416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2056427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2056430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2056433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2056439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056462 */     // MIs[0] round
     /* 2056462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056465 */     // MIs[0] policy
     /* 2056465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056475 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2056478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056501 */     // GIR_Coverage, 15421,
     /* 2056501 */     GIR_EraseRootFromParent_Done,
     /* 2056502 */   // Label 27373: @2056502
     /* 2056502 */   GIM_Try, /*On fail goto*//*Label 27374*/ GIMT_Encode4(2056593), // Rule ID 15424 //
     /* 2056507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2056518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2056521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2056524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2056530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2056537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056553 */     // MIs[0] round
     /* 2056553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056556 */     // MIs[0] policy
     /* 2056556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056566 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2056569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056592 */     // GIR_Coverage, 15424,
     /* 2056592 */     GIR_EraseRootFromParent_Done,
     /* 2056593 */   // Label 27374: @2056593
     /* 2056593 */   GIM_Try, /*On fail goto*//*Label 27375*/ GIMT_Encode4(2056684), // Rule ID 15425 //
     /* 2056598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2056609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2056612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2056615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2056621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2056628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056644 */     // MIs[0] round
     /* 2056644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056647 */     // MIs[0] policy
     /* 2056647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056657 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2056660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056683 */     // GIR_Coverage, 15425,
     /* 2056683 */     GIR_EraseRootFromParent_Done,
     /* 2056684 */   // Label 27375: @2056684
     /* 2056684 */   GIM_Try, /*On fail goto*//*Label 27376*/ GIMT_Encode4(2056775), // Rule ID 15428 //
     /* 2056689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2056700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2056703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2056706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2056712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056735 */     // MIs[0] round
     /* 2056735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056738 */     // MIs[0] policy
     /* 2056738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056748 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2056751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056774 */     // GIR_Coverage, 15428,
     /* 2056774 */     GIR_EraseRootFromParent_Done,
     /* 2056775 */   // Label 27376: @2056775
     /* 2056775 */   GIM_Try, /*On fail goto*//*Label 27377*/ GIMT_Encode4(2056866), // Rule ID 15429 //
     /* 2056780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2056791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2056794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2056797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2056803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056826 */     // MIs[0] round
     /* 2056826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056829 */     // MIs[0] policy
     /* 2056829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056839 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2056842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056865 */     // GIR_Coverage, 15429,
     /* 2056865 */     GIR_EraseRootFromParent_Done,
     /* 2056866 */   // Label 27377: @2056866
     /* 2056866 */   GIM_Try, /*On fail goto*//*Label 27378*/ GIMT_Encode4(2056957), // Rule ID 15432 //
     /* 2056871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2056882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2056885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2056888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056917 */     // MIs[0] round
     /* 2056917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056920 */     // MIs[0] policy
     /* 2056920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056930 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2056933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056956 */     // GIR_Coverage, 15432,
     /* 2056956 */     GIR_EraseRootFromParent_Done,
     /* 2056957 */   // Label 27378: @2056957
     /* 2056957 */   GIM_Try, /*On fail goto*//*Label 27379*/ GIMT_Encode4(2057048), // Rule ID 15433 //
     /* 2056962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2056973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2056976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2056979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057008 */     // MIs[0] round
     /* 2057008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057011 */     // MIs[0] policy
     /* 2057011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057021 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2057024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057047 */     // GIR_Coverage, 15433,
     /* 2057047 */     GIR_EraseRootFromParent_Done,
     /* 2057048 */   // Label 27379: @2057048
     /* 2057048 */   GIM_Try, /*On fail goto*//*Label 27380*/ GIMT_Encode4(2057139), // Rule ID 15436 //
     /* 2057053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2057064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2057067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2057070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057099 */     // MIs[0] round
     /* 2057099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057102 */     // MIs[0] policy
     /* 2057102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057112 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057138 */     // GIR_Coverage, 15436,
     /* 2057138 */     GIR_EraseRootFromParent_Done,
     /* 2057139 */   // Label 27380: @2057139
     /* 2057139 */   GIM_Try, /*On fail goto*//*Label 27381*/ GIMT_Encode4(2057230), // Rule ID 15437 //
     /* 2057144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2057155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2057158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2057161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057190 */     // MIs[0] round
     /* 2057190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057193 */     // MIs[0] policy
     /* 2057193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057203 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057229 */     // GIR_Coverage, 15437,
     /* 2057229 */     GIR_EraseRootFromParent_Done,
     /* 2057230 */   // Label 27381: @2057230
     /* 2057230 */   GIM_Try, /*On fail goto*//*Label 27382*/ GIMT_Encode4(2057321), // Rule ID 15440 //
     /* 2057235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2057246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2057249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2057252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057281 */     // MIs[0] round
     /* 2057281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057284 */     // MIs[0] policy
     /* 2057284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057294 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057320 */     // GIR_Coverage, 15440,
     /* 2057320 */     GIR_EraseRootFromParent_Done,
     /* 2057321 */   // Label 27382: @2057321
     /* 2057321 */   GIM_Try, /*On fail goto*//*Label 27383*/ GIMT_Encode4(2057412), // Rule ID 15441 //
     /* 2057326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2057337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2057340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2057343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057372 */     // MIs[0] round
     /* 2057372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057375 */     // MIs[0] policy
     /* 2057375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057385 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057411 */     // GIR_Coverage, 15441,
     /* 2057411 */     GIR_EraseRootFromParent_Done,
     /* 2057412 */   // Label 27383: @2057412
     /* 2057412 */   GIM_Try, /*On fail goto*//*Label 27384*/ GIMT_Encode4(2057503), // Rule ID 15444 //
     /* 2057417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2057428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2057431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2057434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057463 */     // MIs[0] round
     /* 2057463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057466 */     // MIs[0] policy
     /* 2057466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057476 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2057479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057502 */     // GIR_Coverage, 15444,
     /* 2057502 */     GIR_EraseRootFromParent_Done,
     /* 2057503 */   // Label 27384: @2057503
     /* 2057503 */   GIM_Try, /*On fail goto*//*Label 27385*/ GIMT_Encode4(2057594), // Rule ID 15445 //
     /* 2057508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2057519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2057522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2057525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057554 */     // MIs[0] round
     /* 2057554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057557 */     // MIs[0] policy
     /* 2057557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057567 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2057570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057593 */     // GIR_Coverage, 15445,
     /* 2057593 */     GIR_EraseRootFromParent_Done,
     /* 2057594 */   // Label 27385: @2057594
     /* 2057594 */   GIM_Try, /*On fail goto*//*Label 27386*/ GIMT_Encode4(2057685), // Rule ID 15448 //
     /* 2057599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2057610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2057613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2057616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057645 */     // MIs[0] round
     /* 2057645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057648 */     // MIs[0] policy
     /* 2057648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057658 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057684 */     // GIR_Coverage, 15448,
     /* 2057684 */     GIR_EraseRootFromParent_Done,
     /* 2057685 */   // Label 27386: @2057685
     /* 2057685 */   GIM_Try, /*On fail goto*//*Label 27387*/ GIMT_Encode4(2057776), // Rule ID 15449 //
     /* 2057690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2057701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2057704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2057707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057736 */     // MIs[0] round
     /* 2057736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057739 */     // MIs[0] policy
     /* 2057739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057749 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057775 */     // GIR_Coverage, 15449,
     /* 2057775 */     GIR_EraseRootFromParent_Done,
     /* 2057776 */   // Label 27387: @2057776
     /* 2057776 */   GIM_Try, /*On fail goto*//*Label 27388*/ GIMT_Encode4(2057867), // Rule ID 15452 //
     /* 2057781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2057784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2057792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2057795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2057798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2057804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057827 */     // MIs[0] round
     /* 2057827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057830 */     // MIs[0] policy
     /* 2057830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057840 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2057863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057866 */     // GIR_Coverage, 15452,
     /* 2057866 */     GIR_EraseRootFromParent_Done,
     /* 2057867 */   // Label 27388: @2057867
     /* 2057867 */   GIM_Try, /*On fail goto*//*Label 27389*/ GIMT_Encode4(2057958), // Rule ID 15453 //
     /* 2057872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2057875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2057883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2057886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2057889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2057895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057918 */     // MIs[0] round
     /* 2057918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057921 */     // MIs[0] policy
     /* 2057921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057931 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2057954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057957 */     // GIR_Coverage, 15453,
     /* 2057957 */     GIR_EraseRootFromParent_Done,
     /* 2057958 */   // Label 27389: @2057958
     /* 2057958 */   GIM_Try, /*On fail goto*//*Label 27390*/ GIMT_Encode4(2058049), // Rule ID 15456 //
     /* 2057963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2057966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2057974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2057977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2057980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058009 */     // MIs[0] round
     /* 2058009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058012 */     // MIs[0] policy
     /* 2058012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058022 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2058025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058048 */     // GIR_Coverage, 15456,
     /* 2058048 */     GIR_EraseRootFromParent_Done,
     /* 2058049 */   // Label 27390: @2058049
     /* 2058049 */   GIM_Try, /*On fail goto*//*Label 27391*/ GIMT_Encode4(2058140), // Rule ID 15457 //
     /* 2058054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2058057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2058065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2058068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2058071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058100 */     // MIs[0] round
     /* 2058100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058103 */     // MIs[0] policy
     /* 2058103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058113 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2058116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058139 */     // GIR_Coverage, 15457,
     /* 2058139 */     GIR_EraseRootFromParent_Done,
     /* 2058140 */   // Label 27391: @2058140
     /* 2058140 */   GIM_Try, /*On fail goto*//*Label 27392*/ GIMT_Encode4(2058231), // Rule ID 15460 //
     /* 2058145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2058148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2058156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2058159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2058162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058191 */     // MIs[0] round
     /* 2058191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058194 */     // MIs[0] policy
     /* 2058194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058204 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2058207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058230 */     // GIR_Coverage, 15460,
     /* 2058230 */     GIR_EraseRootFromParent_Done,
     /* 2058231 */   // Label 27392: @2058231
     /* 2058231 */   GIM_Try, /*On fail goto*//*Label 27393*/ GIMT_Encode4(2058322), // Rule ID 15461 //
     /* 2058236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2058239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2058247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2058250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2058253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058282 */     // MIs[0] round
     /* 2058282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058285 */     // MIs[0] policy
     /* 2058285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058295 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2058298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058321 */     // GIR_Coverage, 15461,
     /* 2058321 */     GIR_EraseRootFromParent_Done,
     /* 2058322 */   // Label 27393: @2058322
     /* 2058322 */   GIM_Try, /*On fail goto*//*Label 27394*/ GIMT_Encode4(2058413), // Rule ID 15464 //
     /* 2058327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2058338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2058341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2058344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2058347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058373 */     // MIs[0] round
     /* 2058373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058376 */     // MIs[0] policy
     /* 2058376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058386 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2058389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058412 */     // GIR_Coverage, 15464,
     /* 2058412 */     GIR_EraseRootFromParent_Done,
     /* 2058413 */   // Label 27394: @2058413
     /* 2058413 */   GIM_Try, /*On fail goto*//*Label 27395*/ GIMT_Encode4(2058504), // Rule ID 15465 //
     /* 2058418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2058429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2058432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2058435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2058438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058464 */     // MIs[0] round
     /* 2058464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058467 */     // MIs[0] policy
     /* 2058467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058477 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2058480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058503 */     // GIR_Coverage, 15465,
     /* 2058503 */     GIR_EraseRootFromParent_Done,
     /* 2058504 */   // Label 27395: @2058504
     /* 2058504 */   GIM_Try, /*On fail goto*//*Label 27396*/ GIMT_Encode4(2058595), // Rule ID 15468 //
     /* 2058509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2058520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2058523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2058526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2058529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058555 */     // MIs[0] round
     /* 2058555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058558 */     // MIs[0] policy
     /* 2058558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058568 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2058571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058594 */     // GIR_Coverage, 15468,
     /* 2058594 */     GIR_EraseRootFromParent_Done,
     /* 2058595 */   // Label 27396: @2058595
     /* 2058595 */   GIM_Try, /*On fail goto*//*Label 27397*/ GIMT_Encode4(2058686), // Rule ID 15469 //
     /* 2058600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2058611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2058614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2058617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2058620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058646 */     // MIs[0] round
     /* 2058646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058649 */     // MIs[0] policy
     /* 2058649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058659 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2058662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058685 */     // GIR_Coverage, 15469,
     /* 2058685 */     GIR_EraseRootFromParent_Done,
     /* 2058686 */   // Label 27397: @2058686
     /* 2058686 */   GIM_Try, /*On fail goto*//*Label 27398*/ GIMT_Encode4(2058777), // Rule ID 15472 //
     /* 2058691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2058702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2058705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2058708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2058711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058737 */     // MIs[0] round
     /* 2058737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058740 */     // MIs[0] policy
     /* 2058740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058750 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2058753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058776 */     // GIR_Coverage, 15472,
     /* 2058776 */     GIR_EraseRootFromParent_Done,
     /* 2058777 */   // Label 27398: @2058777
     /* 2058777 */   GIM_Try, /*On fail goto*//*Label 27399*/ GIMT_Encode4(2058868), // Rule ID 15473 //
     /* 2058782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2058793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2058796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2058799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2058802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058828 */     // MIs[0] round
     /* 2058828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058831 */     // MIs[0] policy
     /* 2058831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058841 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2058844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058867 */     // GIR_Coverage, 15473,
     /* 2058867 */     GIR_EraseRootFromParent_Done,
     /* 2058868 */   // Label 27399: @2058868
     /* 2058868 */   GIM_Try, /*On fail goto*//*Label 27400*/ GIMT_Encode4(2058959), // Rule ID 15476 //
     /* 2058873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2058884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2058887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2058890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2058893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058919 */     // MIs[0] round
     /* 2058919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058922 */     // MIs[0] policy
     /* 2058922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058932 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2058935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2058955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058958 */     // GIR_Coverage, 15476,
     /* 2058958 */     GIR_EraseRootFromParent_Done,
     /* 2058959 */   // Label 27400: @2058959
     /* 2058959 */   GIM_Try, /*On fail goto*//*Label 27401*/ GIMT_Encode4(2059050), // Rule ID 15477 //
     /* 2058964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2058975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2058978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2058981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2058984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059010 */     // MIs[0] round
     /* 2059010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059013 */     // MIs[0] policy
     /* 2059013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059023 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2059026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059049 */     // GIR_Coverage, 15477,
     /* 2059049 */     GIR_EraseRootFromParent_Done,
     /* 2059050 */   // Label 27401: @2059050
     /* 2059050 */   GIM_Try, /*On fail goto*//*Label 27402*/ GIMT_Encode4(2059141), // Rule ID 15480 //
     /* 2059055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2059066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2059069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2059072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2059075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059101 */     // MIs[0] round
     /* 2059101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059104 */     // MIs[0] policy
     /* 2059104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059114 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059140 */     // GIR_Coverage, 15480,
     /* 2059140 */     GIR_EraseRootFromParent_Done,
     /* 2059141 */   // Label 27402: @2059141
     /* 2059141 */   GIM_Try, /*On fail goto*//*Label 27403*/ GIMT_Encode4(2059232), // Rule ID 15481 //
     /* 2059146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2059157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2059160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2059163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2059166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059192 */     // MIs[0] round
     /* 2059192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059195 */     // MIs[0] policy
     /* 2059195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059205 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059231 */     // GIR_Coverage, 15481,
     /* 2059231 */     GIR_EraseRootFromParent_Done,
     /* 2059232 */   // Label 27403: @2059232
     /* 2059232 */   GIM_Try, /*On fail goto*//*Label 27404*/ GIMT_Encode4(2059323), // Rule ID 15484 //
     /* 2059237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2059254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2059257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059283 */     // MIs[0] round
     /* 2059283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059286 */     // MIs[0] policy
     /* 2059286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059296 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059322 */     // GIR_Coverage, 15484,
     /* 2059322 */     GIR_EraseRootFromParent_Done,
     /* 2059323 */   // Label 27404: @2059323
     /* 2059323 */   GIM_Try, /*On fail goto*//*Label 27405*/ GIMT_Encode4(2059414), // Rule ID 15485 //
     /* 2059328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2059345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2059348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059374 */     // MIs[0] round
     /* 2059374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059377 */     // MIs[0] policy
     /* 2059377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059387 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059413 */     // GIR_Coverage, 15485,
     /* 2059413 */     GIR_EraseRootFromParent_Done,
     /* 2059414 */   // Label 27405: @2059414
     /* 2059414 */   GIM_Try, /*On fail goto*//*Label 27406*/ GIMT_Encode4(2059505), // Rule ID 15488 //
     /* 2059419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2059430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2059433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2059436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2059439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059465 */     // MIs[0] round
     /* 2059465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059468 */     // MIs[0] policy
     /* 2059468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059478 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059504 */     // GIR_Coverage, 15488,
     /* 2059504 */     GIR_EraseRootFromParent_Done,
     /* 2059505 */   // Label 27406: @2059505
     /* 2059505 */   GIM_Try, /*On fail goto*//*Label 27407*/ GIMT_Encode4(2059596), // Rule ID 15489 //
     /* 2059510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2059521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2059524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2059527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2059530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059556 */     // MIs[0] round
     /* 2059556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059559 */     // MIs[0] policy
     /* 2059559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059569 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059595 */     // GIR_Coverage, 15489,
     /* 2059595 */     GIR_EraseRootFromParent_Done,
     /* 2059596 */   // Label 27407: @2059596
     /* 2059596 */   GIM_Try, /*On fail goto*//*Label 27408*/ GIMT_Encode4(2059687), // Rule ID 15492 //
     /* 2059601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2059612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2059615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2059618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2059621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059647 */     // MIs[0] round
     /* 2059647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059650 */     // MIs[0] policy
     /* 2059650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059660 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059686 */     // GIR_Coverage, 15492,
     /* 2059686 */     GIR_EraseRootFromParent_Done,
     /* 2059687 */   // Label 27408: @2059687
     /* 2059687 */   GIM_Try, /*On fail goto*//*Label 27409*/ GIMT_Encode4(2059778), // Rule ID 15493 //
     /* 2059692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2059703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2059706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2059709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2059712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059738 */     // MIs[0] round
     /* 2059738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059741 */     // MIs[0] policy
     /* 2059741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059751 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059777 */     // GIR_Coverage, 15493,
     /* 2059777 */     GIR_EraseRootFromParent_Done,
     /* 2059778 */   // Label 27409: @2059778
     /* 2059778 */   GIM_Try, /*On fail goto*//*Label 27410*/ GIMT_Encode4(2059869), // Rule ID 15496 //
     /* 2059783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2059794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2059797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2059800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2059803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059829 */     // MIs[0] round
     /* 2059829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059832 */     // MIs[0] policy
     /* 2059832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059868 */     // GIR_Coverage, 15496,
     /* 2059868 */     GIR_EraseRootFromParent_Done,
     /* 2059869 */   // Label 27410: @2059869
     /* 2059869 */   GIM_Try, /*On fail goto*//*Label 27411*/ GIMT_Encode4(2059960), // Rule ID 15497 //
     /* 2059874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2059885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2059888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2059891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2059894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059920 */     // MIs[0] round
     /* 2059920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059923 */     // MIs[0] policy
     /* 2059923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059933 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059959 */     // GIR_Coverage, 15497,
     /* 2059959 */     GIR_EraseRootFromParent_Done,
     /* 2059960 */   // Label 27411: @2059960
     /* 2059960 */   GIM_Try, /*On fail goto*//*Label 27412*/ GIMT_Encode4(2060051), // Rule ID 15500 //
     /* 2059965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2059968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2059976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2059979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2059982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2059985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060011 */     // MIs[0] round
     /* 2060011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060014 */     // MIs[0] policy
     /* 2060014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060024 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2060047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060050 */     // GIR_Coverage, 15500,
     /* 2060050 */     GIR_EraseRootFromParent_Done,
     /* 2060051 */   // Label 27412: @2060051
     /* 2060051 */   GIM_Try, /*On fail goto*//*Label 27413*/ GIMT_Encode4(2060142), // Rule ID 15501 //
     /* 2060056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2060059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2060067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2060070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2060073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2060076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2060079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060102 */     // MIs[0] round
     /* 2060102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060105 */     // MIs[0] policy
     /* 2060105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060115 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2060138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060141 */     // GIR_Coverage, 15501,
     /* 2060141 */     GIR_EraseRootFromParent_Done,
     /* 2060142 */   // Label 27413: @2060142
     /* 2060142 */   GIM_Try, /*On fail goto*//*Label 27414*/ GIMT_Encode4(2060233), // Rule ID 15504 //
     /* 2060147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2060158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2060161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2060164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2060167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060193 */     // MIs[0] round
     /* 2060193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060196 */     // MIs[0] policy
     /* 2060196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060206 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2060209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060232 */     // GIR_Coverage, 15504,
     /* 2060232 */     GIR_EraseRootFromParent_Done,
     /* 2060233 */   // Label 27414: @2060233
     /* 2060233 */   GIM_Try, /*On fail goto*//*Label 27415*/ GIMT_Encode4(2060324), // Rule ID 15505 //
     /* 2060238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2060249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2060252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2060255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2060258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060284 */     // MIs[0] round
     /* 2060284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060287 */     // MIs[0] policy
     /* 2060287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060297 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2060300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060323 */     // GIR_Coverage, 15505,
     /* 2060323 */     GIR_EraseRootFromParent_Done,
     /* 2060324 */   // Label 27415: @2060324
     /* 2060324 */   GIM_Try, /*On fail goto*//*Label 27416*/ GIMT_Encode4(2060415), // Rule ID 15508 //
     /* 2060329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2060340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2060343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2060346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2060349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060375 */     // MIs[0] round
     /* 2060375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060378 */     // MIs[0] policy
     /* 2060378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060388 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2060391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060414 */     // GIR_Coverage, 15508,
     /* 2060414 */     GIR_EraseRootFromParent_Done,
     /* 2060415 */   // Label 27416: @2060415
     /* 2060415 */   GIM_Try, /*On fail goto*//*Label 27417*/ GIMT_Encode4(2060506), // Rule ID 15509 //
     /* 2060420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2060431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2060434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2060437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2060440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060466 */     // MIs[0] round
     /* 2060466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060469 */     // MIs[0] policy
     /* 2060469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060479 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2060482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060505 */     // GIR_Coverage, 15509,
     /* 2060505 */     GIR_EraseRootFromParent_Done,
     /* 2060506 */   // Label 27417: @2060506
     /* 2060506 */   GIM_Try, /*On fail goto*//*Label 27418*/ GIMT_Encode4(2060597), // Rule ID 15512 //
     /* 2060511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2060522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2060525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2060528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2060531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2060534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2060541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060557 */     // MIs[0] round
     /* 2060557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060560 */     // MIs[0] policy
     /* 2060560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060570 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2060573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060596 */     // GIR_Coverage, 15512,
     /* 2060596 */     GIR_EraseRootFromParent_Done,
     /* 2060597 */   // Label 27418: @2060597
     /* 2060597 */   GIM_Try, /*On fail goto*//*Label 27419*/ GIMT_Encode4(2060688), // Rule ID 15513 //
     /* 2060602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2060613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2060616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2060619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2060622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2060625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2060632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060648 */     // MIs[0] round
     /* 2060648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060651 */     // MIs[0] policy
     /* 2060651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060661 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2060664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060687 */     // GIR_Coverage, 15513,
     /* 2060687 */     GIR_EraseRootFromParent_Done,
     /* 2060688 */   // Label 27419: @2060688
     /* 2060688 */   GIM_Try, /*On fail goto*//*Label 27420*/ GIMT_Encode4(2060779), // Rule ID 15516 //
     /* 2060693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2060704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2060707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2060710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2060713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2060716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060739 */     // MIs[0] round
     /* 2060739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060742 */     // MIs[0] policy
     /* 2060742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060752 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2060755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060778 */     // GIR_Coverage, 15516,
     /* 2060778 */     GIR_EraseRootFromParent_Done,
     /* 2060779 */   // Label 27420: @2060779
     /* 2060779 */   GIM_Try, /*On fail goto*//*Label 27421*/ GIMT_Encode4(2060870), // Rule ID 15517 //
     /* 2060784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2060795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2060798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2060801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2060804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2060807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060830 */     // MIs[0] round
     /* 2060830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060833 */     // MIs[0] policy
     /* 2060833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2060846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060869 */     // GIR_Coverage, 15517,
     /* 2060869 */     GIR_EraseRootFromParent_Done,
     /* 2060870 */   // Label 27421: @2060870
     /* 2060870 */   GIM_Try, /*On fail goto*//*Label 27422*/ GIMT_Encode4(2060961), // Rule ID 15520 //
     /* 2060875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2060886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2060889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2060892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2060895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060921 */     // MIs[0] round
     /* 2060921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060924 */     // MIs[0] policy
     /* 2060924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2060937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060960 */     // GIR_Coverage, 15520,
     /* 2060960 */     GIR_EraseRootFromParent_Done,
     /* 2060961 */   // Label 27422: @2060961
     /* 2060961 */   GIM_Try, /*On fail goto*//*Label 27423*/ GIMT_Encode4(2061052), // Rule ID 15521 //
     /* 2060966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2060977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2060980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2060983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2060986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061012 */     // MIs[0] round
     /* 2061012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061015 */     // MIs[0] policy
     /* 2061015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061025 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2061028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061051 */     // GIR_Coverage, 15521,
     /* 2061051 */     GIR_EraseRootFromParent_Done,
     /* 2061052 */   // Label 27423: @2061052
     /* 2061052 */   GIM_Try, /*On fail goto*//*Label 27424*/ GIMT_Encode4(2061143), // Rule ID 15524 //
     /* 2061057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2061068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2061071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2061074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2061077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2061080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061103 */     // MIs[0] round
     /* 2061103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061106 */     // MIs[0] policy
     /* 2061106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061116 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061142 */     // GIR_Coverage, 15524,
     /* 2061142 */     GIR_EraseRootFromParent_Done,
     /* 2061143 */   // Label 27424: @2061143
     /* 2061143 */   GIM_Try, /*On fail goto*//*Label 27425*/ GIMT_Encode4(2061234), // Rule ID 15525 //
     /* 2061148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2061159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2061162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2061165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2061168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2061171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061194 */     // MIs[0] round
     /* 2061194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061197 */     // MIs[0] policy
     /* 2061197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061207 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061233 */     // GIR_Coverage, 15525,
     /* 2061233 */     GIR_EraseRootFromParent_Done,
     /* 2061234 */   // Label 27425: @2061234
     /* 2061234 */   GIM_Try, /*On fail goto*//*Label 27426*/ GIMT_Encode4(2061325), // Rule ID 15528 //
     /* 2061239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2061250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2061253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2061256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2061259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061285 */     // MIs[0] round
     /* 2061285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061288 */     // MIs[0] policy
     /* 2061288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061324 */     // GIR_Coverage, 15528,
     /* 2061324 */     GIR_EraseRootFromParent_Done,
     /* 2061325 */   // Label 27426: @2061325
     /* 2061325 */   GIM_Try, /*On fail goto*//*Label 27427*/ GIMT_Encode4(2061416), // Rule ID 15529 //
     /* 2061330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2061341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2061344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2061347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2061350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061376 */     // MIs[0] round
     /* 2061376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061379 */     // MIs[0] policy
     /* 2061379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061415 */     // GIR_Coverage, 15529,
     /* 2061415 */     GIR_EraseRootFromParent_Done,
     /* 2061416 */   // Label 27427: @2061416
     /* 2061416 */   GIM_Try, /*On fail goto*//*Label 27428*/ GIMT_Encode4(2061507), // Rule ID 15532 //
     /* 2061421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2061438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2061441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061467 */     // MIs[0] round
     /* 2061467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061470 */     // MIs[0] policy
     /* 2061470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061480 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2061483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061506 */     // GIR_Coverage, 15532,
     /* 2061506 */     GIR_EraseRootFromParent_Done,
     /* 2061507 */   // Label 27428: @2061507
     /* 2061507 */   GIM_Try, /*On fail goto*//*Label 27429*/ GIMT_Encode4(2061598), // Rule ID 15533 //
     /* 2061512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2061529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2061532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061558 */     // MIs[0] round
     /* 2061558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061561 */     // MIs[0] policy
     /* 2061561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061571 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2061574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061597 */     // GIR_Coverage, 15533,
     /* 2061597 */     GIR_EraseRootFromParent_Done,
     /* 2061598 */   // Label 27429: @2061598
     /* 2061598 */   GIM_Try, /*On fail goto*//*Label 27430*/ GIMT_Encode4(2061689), // Rule ID 15536 //
     /* 2061603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2061614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2061617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2061620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2061623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061649 */     // MIs[0] round
     /* 2061649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061652 */     // MIs[0] policy
     /* 2061652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061662 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061688 */     // GIR_Coverage, 15536,
     /* 2061688 */     GIR_EraseRootFromParent_Done,
     /* 2061689 */   // Label 27430: @2061689
     /* 2061689 */   GIM_Try, /*On fail goto*//*Label 27431*/ GIMT_Encode4(2061780), // Rule ID 15537 //
     /* 2061694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2061705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2061708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2061711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2061714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061740 */     // MIs[0] round
     /* 2061740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061743 */     // MIs[0] policy
     /* 2061743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061753 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061779 */     // GIR_Coverage, 15537,
     /* 2061779 */     GIR_EraseRootFromParent_Done,
     /* 2061780 */   // Label 27431: @2061780
     /* 2061780 */   GIM_Try, /*On fail goto*//*Label 27432*/ GIMT_Encode4(2061871), // Rule ID 15540 //
     /* 2061785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2061788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2061796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2061799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2061802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2061805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2061808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061831 */     // MIs[0] round
     /* 2061831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061834 */     // MIs[0] policy
     /* 2061834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061844 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061870 */     // GIR_Coverage, 15540,
     /* 2061870 */     GIR_EraseRootFromParent_Done,
     /* 2061871 */   // Label 27432: @2061871
     /* 2061871 */   GIM_Try, /*On fail goto*//*Label 27433*/ GIMT_Encode4(2061962), // Rule ID 15541 //
     /* 2061876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2061879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2061887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2061890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2061893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2061896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2061899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061922 */     // MIs[0] round
     /* 2061922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061925 */     // MIs[0] policy
     /* 2061925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061935 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061961 */     // GIR_Coverage, 15541,
     /* 2061961 */     GIR_EraseRootFromParent_Done,
     /* 2061962 */   // Label 27433: @2061962
     /* 2061962 */   GIM_Try, /*On fail goto*//*Label 27434*/ GIMT_Encode4(2062053), // Rule ID 15544 //
     /* 2061967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2061970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2061978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2061981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2061984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2061987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062013 */     // MIs[0] round
     /* 2062013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062016 */     // MIs[0] policy
     /* 2062016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062026 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2062029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062052 */     // GIR_Coverage, 15544,
     /* 2062052 */     GIR_EraseRootFromParent_Done,
     /* 2062053 */   // Label 27434: @2062053
     /* 2062053 */   GIM_Try, /*On fail goto*//*Label 27435*/ GIMT_Encode4(2062144), // Rule ID 15545 //
     /* 2062058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2062061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2062069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2062072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2062075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2062078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2062088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062104 */     // MIs[0] round
     /* 2062104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062107 */     // MIs[0] policy
     /* 2062107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062117 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2062120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062143 */     // GIR_Coverage, 15545,
     /* 2062143 */     GIR_EraseRootFromParent_Done,
     /* 2062144 */   // Label 27435: @2062144
     /* 2062144 */   GIM_Try, /*On fail goto*//*Label 27436*/ GIMT_Encode4(2062235), // Rule ID 15548 //
     /* 2062149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2062152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2062160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2062163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2062166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2062169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062195 */     // MIs[0] round
     /* 2062195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062198 */     // MIs[0] policy
     /* 2062198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2062211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062234 */     // GIR_Coverage, 15548,
     /* 2062234 */     GIR_EraseRootFromParent_Done,
     /* 2062235 */   // Label 27436: @2062235
     /* 2062235 */   GIM_Try, /*On fail goto*//*Label 27437*/ GIMT_Encode4(2062326), // Rule ID 15549 //
     /* 2062240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2062243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2062251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2062254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2062257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2062260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062286 */     // MIs[0] round
     /* 2062286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062289 */     // MIs[0] policy
     /* 2062289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062299 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2062302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062325 */     // GIR_Coverage, 15549,
     /* 2062325 */     GIR_EraseRootFromParent_Done,
     /* 2062326 */   // Label 27437: @2062326
     /* 2062326 */   GIM_Try, /*On fail goto*//*Label 27438*/ GIMT_Encode4(2062417), // Rule ID 15552 //
     /* 2062331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2062342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2062345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2062348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062377 */     // MIs[0] round
     /* 2062377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062380 */     // MIs[0] policy
     /* 2062380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062390 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2062393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062416 */     // GIR_Coverage, 15552,
     /* 2062416 */     GIR_EraseRootFromParent_Done,
     /* 2062417 */   // Label 27438: @2062417
     /* 2062417 */   GIM_Try, /*On fail goto*//*Label 27439*/ GIMT_Encode4(2062508), // Rule ID 15553 //
     /* 2062422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2062433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2062436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2062439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062468 */     // MIs[0] round
     /* 2062468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062471 */     // MIs[0] policy
     /* 2062471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062481 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2062484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062507 */     // GIR_Coverage, 15553,
     /* 2062507 */     GIR_EraseRootFromParent_Done,
     /* 2062508 */   // Label 27439: @2062508
     /* 2062508 */   GIM_Try, /*On fail goto*//*Label 27440*/ GIMT_Encode4(2062599), // Rule ID 15556 //
     /* 2062513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2062524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2062527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2062530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062559 */     // MIs[0] round
     /* 2062559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062562 */     // MIs[0] policy
     /* 2062562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062572 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2062575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062598 */     // GIR_Coverage, 15556,
     /* 2062598 */     GIR_EraseRootFromParent_Done,
     /* 2062599 */   // Label 27440: @2062599
     /* 2062599 */   GIM_Try, /*On fail goto*//*Label 27441*/ GIMT_Encode4(2062690), // Rule ID 15557 //
     /* 2062604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2062615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2062618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2062621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062650 */     // MIs[0] round
     /* 2062650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062653 */     // MIs[0] policy
     /* 2062653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062663 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2062666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062689 */     // GIR_Coverage, 15557,
     /* 2062689 */     GIR_EraseRootFromParent_Done,
     /* 2062690 */   // Label 27441: @2062690
     /* 2062690 */   GIM_Try, /*On fail goto*//*Label 27442*/ GIMT_Encode4(2062781), // Rule ID 15560 //
     /* 2062695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2062706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2062709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2062712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062741 */     // MIs[0] round
     /* 2062741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062744 */     // MIs[0] policy
     /* 2062744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062754 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2062757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062780 */     // GIR_Coverage, 15560,
     /* 2062780 */     GIR_EraseRootFromParent_Done,
     /* 2062781 */   // Label 27442: @2062781
     /* 2062781 */   GIM_Try, /*On fail goto*//*Label 27443*/ GIMT_Encode4(2062872), // Rule ID 15561 //
     /* 2062786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2062797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2062800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2062803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062832 */     // MIs[0] round
     /* 2062832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062835 */     // MIs[0] policy
     /* 2062835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062845 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2062848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062871 */     // GIR_Coverage, 15561,
     /* 2062871 */     GIR_EraseRootFromParent_Done,
     /* 2062872 */   // Label 27443: @2062872
     /* 2062872 */   GIM_Try, /*On fail goto*//*Label 27444*/ GIMT_Encode4(2062963), // Rule ID 15564 //
     /* 2062877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2062888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2062891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2062894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062923 */     // MIs[0] round
     /* 2062923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062926 */     // MIs[0] policy
     /* 2062926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062936 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2062939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062962 */     // GIR_Coverage, 15564,
     /* 2062962 */     GIR_EraseRootFromParent_Done,
     /* 2062963 */   // Label 27444: @2062963
     /* 2062963 */   GIM_Try, /*On fail goto*//*Label 27445*/ GIMT_Encode4(2063054), // Rule ID 15565 //
     /* 2062968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2062979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2062982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2062985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063014 */     // MIs[0] round
     /* 2063014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063017 */     // MIs[0] policy
     /* 2063017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063027 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2063030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063053 */     // GIR_Coverage, 15565,
     /* 2063053 */     GIR_EraseRootFromParent_Done,
     /* 2063054 */   // Label 27445: @2063054
     /* 2063054 */   GIM_Try, /*On fail goto*//*Label 27446*/ GIMT_Encode4(2063145), // Rule ID 15568 //
     /* 2063059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2063070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2063073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2063076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063105 */     // MIs[0] round
     /* 2063105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063108 */     // MIs[0] policy
     /* 2063108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063118 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063144 */     // GIR_Coverage, 15568,
     /* 2063144 */     GIR_EraseRootFromParent_Done,
     /* 2063145 */   // Label 27446: @2063145
     /* 2063145 */   GIM_Try, /*On fail goto*//*Label 27447*/ GIMT_Encode4(2063236), // Rule ID 15569 //
     /* 2063150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2063161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2063164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2063167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063196 */     // MIs[0] round
     /* 2063196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063199 */     // MIs[0] policy
     /* 2063199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063209 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063235 */     // GIR_Coverage, 15569,
     /* 2063235 */     GIR_EraseRootFromParent_Done,
     /* 2063236 */   // Label 27447: @2063236
     /* 2063236 */   GIM_Try, /*On fail goto*//*Label 27448*/ GIMT_Encode4(2063327), // Rule ID 15572 //
     /* 2063241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2063252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2063255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2063258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063287 */     // MIs[0] round
     /* 2063287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063290 */     // MIs[0] policy
     /* 2063290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063300 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063326 */     // GIR_Coverage, 15572,
     /* 2063326 */     GIR_EraseRootFromParent_Done,
     /* 2063327 */   // Label 27448: @2063327
     /* 2063327 */   GIM_Try, /*On fail goto*//*Label 27449*/ GIMT_Encode4(2063418), // Rule ID 15573 //
     /* 2063332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2063343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2063346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2063349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063378 */     // MIs[0] round
     /* 2063378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063381 */     // MIs[0] policy
     /* 2063381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063391 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063417 */     // GIR_Coverage, 15573,
     /* 2063417 */     GIR_EraseRootFromParent_Done,
     /* 2063418 */   // Label 27449: @2063418
     /* 2063418 */   GIM_Try, /*On fail goto*//*Label 27450*/ GIMT_Encode4(2063509), // Rule ID 15576 //
     /* 2063423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2063434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2063437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2063440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063469 */     // MIs[0] round
     /* 2063469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063472 */     // MIs[0] policy
     /* 2063472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063482 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063508 */     // GIR_Coverage, 15576,
     /* 2063508 */     GIR_EraseRootFromParent_Done,
     /* 2063509 */   // Label 27450: @2063509
     /* 2063509 */   GIM_Try, /*On fail goto*//*Label 27451*/ GIMT_Encode4(2063600), // Rule ID 15577 //
     /* 2063514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2063525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2063528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2063531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063560 */     // MIs[0] round
     /* 2063560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063563 */     // MIs[0] policy
     /* 2063563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063573 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063599 */     // GIR_Coverage, 15577,
     /* 2063599 */     GIR_EraseRootFromParent_Done,
     /* 2063600 */   // Label 27451: @2063600
     /* 2063600 */   GIM_Try, /*On fail goto*//*Label 27452*/ GIMT_Encode4(2063691), // Rule ID 15580 //
     /* 2063605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2063616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2063619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2063622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063651 */     // MIs[0] round
     /* 2063651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063654 */     // MIs[0] policy
     /* 2063654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063664 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063690 */     // GIR_Coverage, 15580,
     /* 2063690 */     GIR_EraseRootFromParent_Done,
     /* 2063691 */   // Label 27452: @2063691
     /* 2063691 */   GIM_Try, /*On fail goto*//*Label 27453*/ GIMT_Encode4(2063782), // Rule ID 15581 //
     /* 2063696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2063707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2063710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2063713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063742 */     // MIs[0] round
     /* 2063742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063745 */     // MIs[0] policy
     /* 2063745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063755 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063781 */     // GIR_Coverage, 15581,
     /* 2063781 */     GIR_EraseRootFromParent_Done,
     /* 2063782 */   // Label 27453: @2063782
     /* 2063782 */   GIM_Try, /*On fail goto*//*Label 27454*/ GIMT_Encode4(2063873), // Rule ID 15584 //
     /* 2063787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2063798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2063801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2063804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063833 */     // MIs[0] round
     /* 2063833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063836 */     // MIs[0] policy
     /* 2063836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063846 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063872 */     // GIR_Coverage, 15584,
     /* 2063872 */     GIR_EraseRootFromParent_Done,
     /* 2063873 */   // Label 27454: @2063873
     /* 2063873 */   GIM_Try, /*On fail goto*//*Label 27455*/ GIMT_Encode4(2063964), // Rule ID 15585 //
     /* 2063878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2063889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2063892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2063895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063924 */     // MIs[0] round
     /* 2063924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063927 */     // MIs[0] policy
     /* 2063927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063937 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063963 */     // GIR_Coverage, 15585,
     /* 2063963 */     GIR_EraseRootFromParent_Done,
     /* 2063964 */   // Label 27455: @2063964
     /* 2063964 */   GIM_Try, /*On fail goto*//*Label 27456*/ GIMT_Encode4(2064055), // Rule ID 15588 //
     /* 2063969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2063972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2063980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2063983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2063986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064015 */     // MIs[0] round
     /* 2064015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064018 */     // MIs[0] policy
     /* 2064018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064028 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064054 */     // GIR_Coverage, 15588,
     /* 2064054 */     GIR_EraseRootFromParent_Done,
     /* 2064055 */   // Label 27456: @2064055
     /* 2064055 */   GIM_Try, /*On fail goto*//*Label 27457*/ GIMT_Encode4(2064146), // Rule ID 15589 //
     /* 2064060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2064063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2064071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2064074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2064077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2064083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064106 */     // MIs[0] round
     /* 2064106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064109 */     // MIs[0] policy
     /* 2064109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064119 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064145 */     // GIR_Coverage, 15589,
     /* 2064145 */     GIR_EraseRootFromParent_Done,
     /* 2064146 */   // Label 27457: @2064146
     /* 2064146 */   GIM_Try, /*On fail goto*//*Label 27458*/ GIMT_Encode4(2064237), // Rule ID 15592 //
     /* 2064151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2064162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2064165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2064168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064197 */     // MIs[0] round
     /* 2064197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064200 */     // MIs[0] policy
     /* 2064200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064210 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2064213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064236 */     // GIR_Coverage, 15592,
     /* 2064236 */     GIR_EraseRootFromParent_Done,
     /* 2064237 */   // Label 27458: @2064237
     /* 2064237 */   GIM_Try, /*On fail goto*//*Label 27459*/ GIMT_Encode4(2064328), // Rule ID 15593 //
     /* 2064242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2064253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2064256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2064259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064288 */     // MIs[0] round
     /* 2064288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064291 */     // MIs[0] policy
     /* 2064291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064301 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2064304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064327 */     // GIR_Coverage, 15593,
     /* 2064327 */     GIR_EraseRootFromParent_Done,
     /* 2064328 */   // Label 27459: @2064328
     /* 2064328 */   GIM_Try, /*On fail goto*//*Label 27460*/ GIMT_Encode4(2064419), // Rule ID 15596 //
     /* 2064333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2064344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2064347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2064350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2064356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064379 */     // MIs[0] round
     /* 2064379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064382 */     // MIs[0] policy
     /* 2064382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064392 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2064395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064418 */     // GIR_Coverage, 15596,
     /* 2064418 */     GIR_EraseRootFromParent_Done,
     /* 2064419 */   // Label 27460: @2064419
     /* 2064419 */   GIM_Try, /*On fail goto*//*Label 27461*/ GIMT_Encode4(2064510), // Rule ID 15597 //
     /* 2064424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2064435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2064438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2064441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2064447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064470 */     // MIs[0] round
     /* 2064470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064473 */     // MIs[0] policy
     /* 2064473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064483 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2064486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064509 */     // GIR_Coverage, 15597,
     /* 2064509 */     GIR_EraseRootFromParent_Done,
     /* 2064510 */   // Label 27461: @2064510
     /* 2064510 */   GIM_Try, /*On fail goto*//*Label 27462*/ GIMT_Encode4(2064601), // Rule ID 15600 //
     /* 2064515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2064526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2064529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2064532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2064538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2064545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064561 */     // MIs[0] round
     /* 2064561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064564 */     // MIs[0] policy
     /* 2064564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064574 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2064577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064600 */     // GIR_Coverage, 15600,
     /* 2064600 */     GIR_EraseRootFromParent_Done,
     /* 2064601 */   // Label 27462: @2064601
     /* 2064601 */   GIM_Try, /*On fail goto*//*Label 27463*/ GIMT_Encode4(2064692), // Rule ID 15601 //
     /* 2064606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2064617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2064620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2064623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2064629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2064636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064652 */     // MIs[0] round
     /* 2064652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064655 */     // MIs[0] policy
     /* 2064655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064665 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2064668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064691 */     // GIR_Coverage, 15601,
     /* 2064691 */     GIR_EraseRootFromParent_Done,
     /* 2064692 */   // Label 27463: @2064692
     /* 2064692 */   GIM_Try, /*On fail goto*//*Label 27464*/ GIMT_Encode4(2064783), // Rule ID 15604 //
     /* 2064697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2064708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2064711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2064714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2064720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064743 */     // MIs[0] round
     /* 2064743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064746 */     // MIs[0] policy
     /* 2064746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064756 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2064759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064782 */     // GIR_Coverage, 15604,
     /* 2064782 */     GIR_EraseRootFromParent_Done,
     /* 2064783 */   // Label 27464: @2064783
     /* 2064783 */   GIM_Try, /*On fail goto*//*Label 27465*/ GIMT_Encode4(2064874), // Rule ID 15605 //
     /* 2064788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2064799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2064802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2064805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2064811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064834 */     // MIs[0] round
     /* 2064834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064837 */     // MIs[0] policy
     /* 2064837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064847 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2064850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064873 */     // GIR_Coverage, 15605,
     /* 2064873 */     GIR_EraseRootFromParent_Done,
     /* 2064874 */   // Label 27465: @2064874
     /* 2064874 */   GIM_Try, /*On fail goto*//*Label 27466*/ GIMT_Encode4(2064965), // Rule ID 15608 //
     /* 2064879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2064890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2064893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2064896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064925 */     // MIs[0] round
     /* 2064925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064928 */     // MIs[0] policy
     /* 2064928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064938 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2064941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064964 */     // GIR_Coverage, 15608,
     /* 2064964 */     GIR_EraseRootFromParent_Done,
     /* 2064965 */   // Label 27466: @2064965
     /* 2064965 */   GIM_Try, /*On fail goto*//*Label 27467*/ GIMT_Encode4(2065056), // Rule ID 15609 //
     /* 2064970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2064981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2064984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2064987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065016 */     // MIs[0] round
     /* 2065016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065019 */     // MIs[0] policy
     /* 2065019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065029 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2065032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065055 */     // GIR_Coverage, 15609,
     /* 2065055 */     GIR_EraseRootFromParent_Done,
     /* 2065056 */   // Label 27467: @2065056
     /* 2065056 */   GIM_Try, /*On fail goto*//*Label 27468*/ GIMT_Encode4(2065147), // Rule ID 15612 //
     /* 2065061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2065072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2065075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2065078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2065084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065107 */     // MIs[0] round
     /* 2065107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065110 */     // MIs[0] policy
     /* 2065110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065120 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065146 */     // GIR_Coverage, 15612,
     /* 2065146 */     GIR_EraseRootFromParent_Done,
     /* 2065147 */   // Label 27468: @2065147
     /* 2065147 */   GIM_Try, /*On fail goto*//*Label 27469*/ GIMT_Encode4(2065238), // Rule ID 15613 //
     /* 2065152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2065163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2065166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2065169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2065175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065198 */     // MIs[0] round
     /* 2065198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065201 */     // MIs[0] policy
     /* 2065201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065211 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065237 */     // GIR_Coverage, 15613,
     /* 2065237 */     GIR_EraseRootFromParent_Done,
     /* 2065238 */   // Label 27469: @2065238
     /* 2065238 */   GIM_Try, /*On fail goto*//*Label 27470*/ GIMT_Encode4(2065329), // Rule ID 15616 //
     /* 2065243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2065254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2065257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2065260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065289 */     // MIs[0] round
     /* 2065289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065292 */     // MIs[0] policy
     /* 2065292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065328 */     // GIR_Coverage, 15616,
     /* 2065328 */     GIR_EraseRootFromParent_Done,
     /* 2065329 */   // Label 27470: @2065329
     /* 2065329 */   GIM_Try, /*On fail goto*//*Label 27471*/ GIMT_Encode4(2065420), // Rule ID 15617 //
     /* 2065334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2065345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2065348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2065351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065380 */     // MIs[0] round
     /* 2065380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065383 */     // MIs[0] policy
     /* 2065383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065419 */     // GIR_Coverage, 15617,
     /* 2065419 */     GIR_EraseRootFromParent_Done,
     /* 2065420 */   // Label 27471: @2065420
     /* 2065420 */   GIM_Try, /*On fail goto*//*Label 27472*/ GIMT_Encode4(2065511), // Rule ID 15620 //
     /* 2065425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2065436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2065439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2065442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065471 */     // MIs[0] round
     /* 2065471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065474 */     // MIs[0] policy
     /* 2065474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2065487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065510 */     // GIR_Coverage, 15620,
     /* 2065510 */     GIR_EraseRootFromParent_Done,
     /* 2065511 */   // Label 27472: @2065511
     /* 2065511 */   GIM_Try, /*On fail goto*//*Label 27473*/ GIMT_Encode4(2065602), // Rule ID 15621 //
     /* 2065516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2065527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2065530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2065533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065562 */     // MIs[0] round
     /* 2065562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065565 */     // MIs[0] policy
     /* 2065565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065575 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2065578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065601 */     // GIR_Coverage, 15621,
     /* 2065601 */     GIR_EraseRootFromParent_Done,
     /* 2065602 */   // Label 27473: @2065602
     /* 2065602 */   GIM_Try, /*On fail goto*//*Label 27474*/ GIMT_Encode4(2065693), // Rule ID 15624 //
     /* 2065607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2065618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2065621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2065624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065653 */     // MIs[0] round
     /* 2065653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065656 */     // MIs[0] policy
     /* 2065656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065692 */     // GIR_Coverage, 15624,
     /* 2065692 */     GIR_EraseRootFromParent_Done,
     /* 2065693 */   // Label 27474: @2065693
     /* 2065693 */   GIM_Try, /*On fail goto*//*Label 27475*/ GIMT_Encode4(2065784), // Rule ID 15625 //
     /* 2065698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2065709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2065712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2065715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065744 */     // MIs[0] round
     /* 2065744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065747 */     // MIs[0] policy
     /* 2065747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065757 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065783 */     // GIR_Coverage, 15625,
     /* 2065783 */     GIR_EraseRootFromParent_Done,
     /* 2065784 */   // Label 27475: @2065784
     /* 2065784 */   GIM_Try, /*On fail goto*//*Label 27476*/ GIMT_Encode4(2065875), // Rule ID 15628 //
     /* 2065789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2065792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2065800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2065803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2065806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2065812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065835 */     // MIs[0] round
     /* 2065835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065838 */     // MIs[0] policy
     /* 2065838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065848 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2065871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065874 */     // GIR_Coverage, 15628,
     /* 2065874 */     GIR_EraseRootFromParent_Done,
     /* 2065875 */   // Label 27476: @2065875
     /* 2065875 */   GIM_Try, /*On fail goto*//*Label 27477*/ GIMT_Encode4(2065966), // Rule ID 15629 //
     /* 2065880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2065883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2065891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2065894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2065897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2065903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065926 */     // MIs[0] round
     /* 2065926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065929 */     // MIs[0] policy
     /* 2065929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065939 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2065962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065965 */     // GIR_Coverage, 15629,
     /* 2065965 */     GIR_EraseRootFromParent_Done,
     /* 2065966 */   // Label 27477: @2065966
     /* 2065966 */   GIM_Try, /*On fail goto*//*Label 27478*/ GIMT_Encode4(2066057), // Rule ID 15632 //
     /* 2065971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2065974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2065982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2065985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2065988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066017 */     // MIs[0] round
     /* 2066017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066020 */     // MIs[0] policy
     /* 2066020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066030 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2066033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066056 */     // GIR_Coverage, 15632,
     /* 2066056 */     GIR_EraseRootFromParent_Done,
     /* 2066057 */   // Label 27478: @2066057
     /* 2066057 */   GIM_Try, /*On fail goto*//*Label 27479*/ GIMT_Encode4(2066148), // Rule ID 15633 //
     /* 2066062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2066065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2066073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2066076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2066079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066108 */     // MIs[0] round
     /* 2066108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066111 */     // MIs[0] policy
     /* 2066111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066121 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2066124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066147 */     // GIR_Coverage, 15633,
     /* 2066147 */     GIR_EraseRootFromParent_Done,
     /* 2066148 */   // Label 27479: @2066148
     /* 2066148 */   GIM_Try, /*On fail goto*//*Label 27480*/ GIMT_Encode4(2066239), // Rule ID 15636 //
     /* 2066153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2066156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2066164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2066167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2066170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066199 */     // MIs[0] round
     /* 2066199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066202 */     // MIs[0] policy
     /* 2066202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066212 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2066215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066238 */     // GIR_Coverage, 15636,
     /* 2066238 */     GIR_EraseRootFromParent_Done,
     /* 2066239 */   // Label 27480: @2066239
     /* 2066239 */   GIM_Try, /*On fail goto*//*Label 27481*/ GIMT_Encode4(2066330), // Rule ID 15637 //
     /* 2066244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2066247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2066255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2066258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2066261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066290 */     // MIs[0] round
     /* 2066290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066293 */     // MIs[0] policy
     /* 2066293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066303 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2066306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066329 */     // GIR_Coverage, 15637,
     /* 2066329 */     GIR_EraseRootFromParent_Done,
     /* 2066330 */   // Label 27481: @2066330
     /* 2066330 */   GIM_Try, /*On fail goto*//*Label 27482*/ GIMT_Encode4(2066424), // Rule ID 15640 //
     /* 2066335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2066346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2066349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2066352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2066355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066381 */     // MIs[0] round
     /* 2066381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066384 */     // MIs[0] policy
     /* 2066384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066394 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2066397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066423 */     // GIR_Coverage, 15640,
     /* 2066423 */     GIR_EraseRootFromParent_Done,
     /* 2066424 */   // Label 27482: @2066424
     /* 2066424 */   GIM_Try, /*On fail goto*//*Label 27483*/ GIMT_Encode4(2066518), // Rule ID 15641 //
     /* 2066429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2066440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2066443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2066446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2066449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066475 */     // MIs[0] round
     /* 2066475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066478 */     // MIs[0] policy
     /* 2066478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066488 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2066491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066517 */     // GIR_Coverage, 15641,
     /* 2066517 */     GIR_EraseRootFromParent_Done,
     /* 2066518 */   // Label 27483: @2066518
     /* 2066518 */   GIM_Try, /*On fail goto*//*Label 27484*/ GIMT_Encode4(2066612), // Rule ID 15644 //
     /* 2066523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2066534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2066537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2066540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2066543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066569 */     // MIs[0] round
     /* 2066569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066572 */     // MIs[0] policy
     /* 2066572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066582 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2066585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066611 */     // GIR_Coverage, 15644,
     /* 2066611 */     GIR_EraseRootFromParent_Done,
     /* 2066612 */   // Label 27484: @2066612
     /* 2066612 */   GIM_Try, /*On fail goto*//*Label 27485*/ GIMT_Encode4(2066706), // Rule ID 15645 //
     /* 2066617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2066628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2066631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2066634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2066637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066663 */     // MIs[0] round
     /* 2066663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066666 */     // MIs[0] policy
     /* 2066666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066676 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2066679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066705 */     // GIR_Coverage, 15645,
     /* 2066705 */     GIR_EraseRootFromParent_Done,
     /* 2066706 */   // Label 27485: @2066706
     /* 2066706 */   GIM_Try, /*On fail goto*//*Label 27486*/ GIMT_Encode4(2066800), // Rule ID 15648 //
     /* 2066711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2066722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2066725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2066728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2066731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066757 */     // MIs[0] round
     /* 2066757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066760 */     // MIs[0] policy
     /* 2066760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066770 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2066773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066799 */     // GIR_Coverage, 15648,
     /* 2066799 */     GIR_EraseRootFromParent_Done,
     /* 2066800 */   // Label 27486: @2066800
     /* 2066800 */   GIM_Try, /*On fail goto*//*Label 27487*/ GIMT_Encode4(2066894), // Rule ID 15649 //
     /* 2066805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2066816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2066819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2066822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2066825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066851 */     // MIs[0] round
     /* 2066851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066854 */     // MIs[0] policy
     /* 2066854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066864 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2066867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066893 */     // GIR_Coverage, 15649,
     /* 2066893 */     GIR_EraseRootFromParent_Done,
     /* 2066894 */   // Label 27487: @2066894
     /* 2066894 */   GIM_Try, /*On fail goto*//*Label 27488*/ GIMT_Encode4(2066988), // Rule ID 15652 //
     /* 2066899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2066910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2066913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2066916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2066919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066945 */     // MIs[0] round
     /* 2066945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066948 */     // MIs[0] policy
     /* 2066948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066958 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2066961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2066981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066987 */     // GIR_Coverage, 15652,
     /* 2066987 */     GIR_EraseRootFromParent_Done,
     /* 2066988 */   // Label 27488: @2066988
     /* 2066988 */   GIM_Try, /*On fail goto*//*Label 27489*/ GIMT_Encode4(2067082), // Rule ID 15653 //
     /* 2066993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2067004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2067007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2067010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2067013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067039 */     // MIs[0] round
     /* 2067039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067042 */     // MIs[0] policy
     /* 2067042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067052 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2067055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067081 */     // GIR_Coverage, 15653,
     /* 2067081 */     GIR_EraseRootFromParent_Done,
     /* 2067082 */   // Label 27489: @2067082
     /* 2067082 */   GIM_Try, /*On fail goto*//*Label 27490*/ GIMT_Encode4(2067176), // Rule ID 15656 //
     /* 2067087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2067098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2067101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2067104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2067107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067133 */     // MIs[0] round
     /* 2067133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067136 */     // MIs[0] policy
     /* 2067136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067146 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067175 */     // GIR_Coverage, 15656,
     /* 2067175 */     GIR_EraseRootFromParent_Done,
     /* 2067176 */   // Label 27490: @2067176
     /* 2067176 */   GIM_Try, /*On fail goto*//*Label 27491*/ GIMT_Encode4(2067270), // Rule ID 15657 //
     /* 2067181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2067192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2067195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2067198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2067201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067227 */     // MIs[0] round
     /* 2067227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067230 */     // MIs[0] policy
     /* 2067230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067240 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067269 */     // GIR_Coverage, 15657,
     /* 2067269 */     GIR_EraseRootFromParent_Done,
     /* 2067270 */   // Label 27491: @2067270
     /* 2067270 */   GIM_Try, /*On fail goto*//*Label 27492*/ GIMT_Encode4(2067364), // Rule ID 15660 //
     /* 2067275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2067286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2067289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2067292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2067295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067321 */     // MIs[0] round
     /* 2067321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067324 */     // MIs[0] policy
     /* 2067324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067334 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067363 */     // GIR_Coverage, 15660,
     /* 2067363 */     GIR_EraseRootFromParent_Done,
     /* 2067364 */   // Label 27492: @2067364
     /* 2067364 */   GIM_Try, /*On fail goto*//*Label 27493*/ GIMT_Encode4(2067458), // Rule ID 15661 //
     /* 2067369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2067380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2067383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2067386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2067389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067415 */     // MIs[0] round
     /* 2067415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067418 */     // MIs[0] policy
     /* 2067418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067428 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067453 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067457 */     // GIR_Coverage, 15661,
     /* 2067457 */     GIR_EraseRootFromParent_Done,
     /* 2067458 */   // Label 27493: @2067458
     /* 2067458 */   GIM_Try, /*On fail goto*//*Label 27494*/ GIMT_Encode4(2067552), // Rule ID 15664 //
     /* 2067463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2067474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2067477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2067480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2067483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067509 */     // MIs[0] round
     /* 2067509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067512 */     // MIs[0] policy
     /* 2067512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067522 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067547 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067551 */     // GIR_Coverage, 15664,
     /* 2067551 */     GIR_EraseRootFromParent_Done,
     /* 2067552 */   // Label 27494: @2067552
     /* 2067552 */   GIM_Try, /*On fail goto*//*Label 27495*/ GIMT_Encode4(2067646), // Rule ID 15665 //
     /* 2067557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2067568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2067571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2067574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2067577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067603 */     // MIs[0] round
     /* 2067603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067606 */     // MIs[0] policy
     /* 2067606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067616 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067645 */     // GIR_Coverage, 15665,
     /* 2067645 */     GIR_EraseRootFromParent_Done,
     /* 2067646 */   // Label 27495: @2067646
     /* 2067646 */   GIM_Try, /*On fail goto*//*Label 27496*/ GIMT_Encode4(2067740), // Rule ID 15668 //
     /* 2067651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2067662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2067665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2067668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2067671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067697 */     // MIs[0] round
     /* 2067697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067700 */     // MIs[0] policy
     /* 2067700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067739 */     // GIR_Coverage, 15668,
     /* 2067739 */     GIR_EraseRootFromParent_Done,
     /* 2067740 */   // Label 27496: @2067740
     /* 2067740 */   GIM_Try, /*On fail goto*//*Label 27497*/ GIMT_Encode4(2067834), // Rule ID 15669 //
     /* 2067745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2067756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2067759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2067762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2067765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067791 */     // MIs[0] round
     /* 2067791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067794 */     // MIs[0] policy
     /* 2067794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067833 */     // GIR_Coverage, 15669,
     /* 2067833 */     GIR_EraseRootFromParent_Done,
     /* 2067834 */   // Label 27497: @2067834
     /* 2067834 */   GIM_Try, /*On fail goto*//*Label 27498*/ GIMT_Encode4(2067928), // Rule ID 15672 //
     /* 2067839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2067850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2067853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2067856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2067859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067885 */     // MIs[0] round
     /* 2067885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067888 */     // MIs[0] policy
     /* 2067888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067898 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067927 */     // GIR_Coverage, 15672,
     /* 2067927 */     GIR_EraseRootFromParent_Done,
     /* 2067928 */   // Label 27498: @2067928
     /* 2067928 */   GIM_Try, /*On fail goto*//*Label 27499*/ GIMT_Encode4(2068022), // Rule ID 15673 //
     /* 2067933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2067944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2067947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2067950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2067953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067979 */     // MIs[0] round
     /* 2067979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067982 */     // MIs[0] policy
     /* 2067982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067992 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068021 */     // GIR_Coverage, 15673,
     /* 2068021 */     GIR_EraseRootFromParent_Done,
     /* 2068022 */   // Label 27499: @2068022
     /* 2068022 */   GIM_Try, /*On fail goto*//*Label 27500*/ GIMT_Encode4(2068116), // Rule ID 15676 //
     /* 2068027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2068038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2068041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2068044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2068047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068073 */     // MIs[0] round
     /* 2068073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068076 */     // MIs[0] policy
     /* 2068076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068086 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2068089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068115 */     // GIR_Coverage, 15676,
     /* 2068115 */     GIR_EraseRootFromParent_Done,
     /* 2068116 */   // Label 27500: @2068116
     /* 2068116 */   GIM_Try, /*On fail goto*//*Label 27501*/ GIMT_Encode4(2068210), // Rule ID 15677 //
     /* 2068121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2068132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2068135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2068138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2068141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068167 */     // MIs[0] round
     /* 2068167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068170 */     // MIs[0] policy
     /* 2068170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2068183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068209 */     // GIR_Coverage, 15677,
     /* 2068209 */     GIR_EraseRootFromParent_Done,
     /* 2068210 */   // Label 27501: @2068210
     /* 2068210 */   GIM_Try, /*On fail goto*//*Label 27502*/ GIMT_Encode4(2068304), // Rule ID 15680 //
     /* 2068215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2068226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2068229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2068232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2068235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068261 */     // MIs[0] round
     /* 2068261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068264 */     // MIs[0] policy
     /* 2068264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068274 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2068277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068303 */     // GIR_Coverage, 15680,
     /* 2068303 */     GIR_EraseRootFromParent_Done,
     /* 2068304 */   // Label 27502: @2068304
     /* 2068304 */   GIM_Try, /*On fail goto*//*Label 27503*/ GIMT_Encode4(2068398), // Rule ID 15681 //
     /* 2068309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2068320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2068323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2068326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2068329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068355 */     // MIs[0] round
     /* 2068355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068358 */     // MIs[0] policy
     /* 2068358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068368 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2068371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068393 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068397 */     // GIR_Coverage, 15681,
     /* 2068397 */     GIR_EraseRootFromParent_Done,
     /* 2068398 */   // Label 27503: @2068398
     /* 2068398 */   GIM_Try, /*On fail goto*//*Label 27504*/ GIMT_Encode4(2068492), // Rule ID 15684 //
     /* 2068403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2068414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2068417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2068420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2068423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2068426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068449 */     // MIs[0] round
     /* 2068449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068452 */     // MIs[0] policy
     /* 2068452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068462 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2068465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068491 */     // GIR_Coverage, 15684,
     /* 2068491 */     GIR_EraseRootFromParent_Done,
     /* 2068492 */   // Label 27504: @2068492
     /* 2068492 */   GIM_Try, /*On fail goto*//*Label 27505*/ GIMT_Encode4(2068586), // Rule ID 15685 //
     /* 2068497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2068508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2068511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2068514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2068517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2068520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068543 */     // MIs[0] round
     /* 2068543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068546 */     // MIs[0] policy
     /* 2068546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068556 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2068559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068585 */     // GIR_Coverage, 15685,
     /* 2068585 */     GIR_EraseRootFromParent_Done,
     /* 2068586 */   // Label 27505: @2068586
     /* 2068586 */   GIM_Try, /*On fail goto*//*Label 27506*/ GIMT_Encode4(2068680), // Rule ID 15688 //
     /* 2068591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2068602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2068605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2068608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2068611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068637 */     // MIs[0] round
     /* 2068637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068640 */     // MIs[0] policy
     /* 2068640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068650 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2068653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068679 */     // GIR_Coverage, 15688,
     /* 2068679 */     GIR_EraseRootFromParent_Done,
     /* 2068680 */   // Label 27506: @2068680
     /* 2068680 */   GIM_Try, /*On fail goto*//*Label 27507*/ GIMT_Encode4(2068774), // Rule ID 15689 //
     /* 2068685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2068696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2068699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2068702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2068705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068731 */     // MIs[0] round
     /* 2068731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068734 */     // MIs[0] policy
     /* 2068734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068744 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2068747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068773 */     // GIR_Coverage, 15689,
     /* 2068773 */     GIR_EraseRootFromParent_Done,
     /* 2068774 */   // Label 27507: @2068774
     /* 2068774 */   GIM_Try, /*On fail goto*//*Label 27508*/ GIMT_Encode4(2068868), // Rule ID 15692 //
     /* 2068779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2068790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2068793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2068796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2068799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068825 */     // MIs[0] round
     /* 2068825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068828 */     // MIs[0] policy
     /* 2068828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068838 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2068841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068867 */     // GIR_Coverage, 15692,
     /* 2068867 */     GIR_EraseRootFromParent_Done,
     /* 2068868 */   // Label 27508: @2068868
     /* 2068868 */   GIM_Try, /*On fail goto*//*Label 27509*/ GIMT_Encode4(2068962), // Rule ID 15693 //
     /* 2068873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2068884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2068887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2068890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2068893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068919 */     // MIs[0] round
     /* 2068919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068922 */     // MIs[0] policy
     /* 2068922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068932 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2068935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068961 */     // GIR_Coverage, 15693,
     /* 2068961 */     GIR_EraseRootFromParent_Done,
     /* 2068962 */   // Label 27509: @2068962
     /* 2068962 */   GIM_Try, /*On fail goto*//*Label 27510*/ GIMT_Encode4(2069056), // Rule ID 15696 //
     /* 2068967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2068978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2068981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2068984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2068987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069013 */     // MIs[0] round
     /* 2069013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069016 */     // MIs[0] policy
     /* 2069016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069026 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069055 */     // GIR_Coverage, 15696,
     /* 2069055 */     GIR_EraseRootFromParent_Done,
     /* 2069056 */   // Label 27510: @2069056
     /* 2069056 */   GIM_Try, /*On fail goto*//*Label 27511*/ GIMT_Encode4(2069150), // Rule ID 15697 //
     /* 2069061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2069072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2069075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2069078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2069081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2069084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069107 */     // MIs[0] round
     /* 2069107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069110 */     // MIs[0] policy
     /* 2069110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069120 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069149 */     // GIR_Coverage, 15697,
     /* 2069149 */     GIR_EraseRootFromParent_Done,
     /* 2069150 */   // Label 27511: @2069150
     /* 2069150 */   GIM_Try, /*On fail goto*//*Label 27512*/ GIMT_Encode4(2069244), // Rule ID 15700 //
     /* 2069155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2069166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2069169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2069172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2069175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069201 */     // MIs[0] round
     /* 2069201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069204 */     // MIs[0] policy
     /* 2069204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2069217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069243 */     // GIR_Coverage, 15700,
     /* 2069243 */     GIR_EraseRootFromParent_Done,
     /* 2069244 */   // Label 27512: @2069244
     /* 2069244 */   GIM_Try, /*On fail goto*//*Label 27513*/ GIMT_Encode4(2069338), // Rule ID 15701 //
     /* 2069249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2069260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2069263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2069266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2069269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069295 */     // MIs[0] round
     /* 2069295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069298 */     // MIs[0] policy
     /* 2069298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069308 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2069311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069337 */     // GIR_Coverage, 15701,
     /* 2069337 */     GIR_EraseRootFromParent_Done,
     /* 2069338 */   // Label 27513: @2069338
     /* 2069338 */   GIM_Try, /*On fail goto*//*Label 27514*/ GIMT_Encode4(2069432), // Rule ID 15704 //
     /* 2069343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2069354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2069357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2069360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2069363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069389 */     // MIs[0] round
     /* 2069389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069392 */     // MIs[0] policy
     /* 2069392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069402 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2069405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069431 */     // GIR_Coverage, 15704,
     /* 2069431 */     GIR_EraseRootFromParent_Done,
     /* 2069432 */   // Label 27514: @2069432
     /* 2069432 */   GIM_Try, /*On fail goto*//*Label 27515*/ GIMT_Encode4(2069526), // Rule ID 15705 //
     /* 2069437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2069448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2069451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2069454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2069457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069483 */     // MIs[0] round
     /* 2069483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069486 */     // MIs[0] policy
     /* 2069486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2069499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069521 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069525 */     // GIR_Coverage, 15705,
     /* 2069525 */     GIR_EraseRootFromParent_Done,
     /* 2069526 */   // Label 27515: @2069526
     /* 2069526 */   GIM_Try, /*On fail goto*//*Label 27516*/ GIMT_Encode4(2069620), // Rule ID 15708 //
     /* 2069531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2069542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2069545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2069548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2069551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069577 */     // MIs[0] round
     /* 2069577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069580 */     // MIs[0] policy
     /* 2069580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069590 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069619 */     // GIR_Coverage, 15708,
     /* 2069619 */     GIR_EraseRootFromParent_Done,
     /* 2069620 */   // Label 27516: @2069620
     /* 2069620 */   GIM_Try, /*On fail goto*//*Label 27517*/ GIMT_Encode4(2069714), // Rule ID 15709 //
     /* 2069625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2069636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2069639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2069642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2069645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069671 */     // MIs[0] round
     /* 2069671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069674 */     // MIs[0] policy
     /* 2069674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069684 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069713 */     // GIR_Coverage, 15709,
     /* 2069713 */     GIR_EraseRootFromParent_Done,
     /* 2069714 */   // Label 27517: @2069714
     /* 2069714 */   GIM_Try, /*On fail goto*//*Label 27518*/ GIMT_Encode4(2069808), // Rule ID 15712 //
     /* 2069719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2069730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2069733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2069736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2069742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069765 */     // MIs[0] round
     /* 2069765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069768 */     // MIs[0] policy
     /* 2069768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069778 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2069781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069807 */     // GIR_Coverage, 15712,
     /* 2069807 */     GIR_EraseRootFromParent_Done,
     /* 2069808 */   // Label 27518: @2069808
     /* 2069808 */   GIM_Try, /*On fail goto*//*Label 27519*/ GIMT_Encode4(2069902), // Rule ID 15713 //
     /* 2069813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2069824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2069827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2069830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2069833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2069836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069859 */     // MIs[0] round
     /* 2069859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069862 */     // MIs[0] policy
     /* 2069862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069872 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2069875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069901 */     // GIR_Coverage, 15713,
     /* 2069901 */     GIR_EraseRootFromParent_Done,
     /* 2069902 */   // Label 27519: @2069902
     /* 2069902 */   GIM_Try, /*On fail goto*//*Label 27520*/ GIMT_Encode4(2069996), // Rule ID 15716 //
     /* 2069907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2069918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2069921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2069924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2069930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069953 */     // MIs[0] round
     /* 2069953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069956 */     // MIs[0] policy
     /* 2069956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069966 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2069969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069995 */     // GIR_Coverage, 15716,
     /* 2069995 */     GIR_EraseRootFromParent_Done,
     /* 2069996 */   // Label 27520: @2069996
     /* 2069996 */   GIM_Try, /*On fail goto*//*Label 27521*/ GIMT_Encode4(2070090), // Rule ID 15717 //
     /* 2070001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2070012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2070015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2070018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070047 */     // MIs[0] round
     /* 2070047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070050 */     // MIs[0] policy
     /* 2070050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070060 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070089 */     // GIR_Coverage, 15717,
     /* 2070089 */     GIR_EraseRootFromParent_Done,
     /* 2070090 */   // Label 27521: @2070090
     /* 2070090 */   GIM_Try, /*On fail goto*//*Label 27522*/ GIMT_Encode4(2070184), // Rule ID 15720 //
     /* 2070095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2070106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2070109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2070112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070141 */     // MIs[0] round
     /* 2070141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070144 */     // MIs[0] policy
     /* 2070144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070154 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070183 */     // GIR_Coverage, 15720,
     /* 2070183 */     GIR_EraseRootFromParent_Done,
     /* 2070184 */   // Label 27522: @2070184
     /* 2070184 */   GIM_Try, /*On fail goto*//*Label 27523*/ GIMT_Encode4(2070278), // Rule ID 15721 //
     /* 2070189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2070200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2070203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2070206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070235 */     // MIs[0] round
     /* 2070235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070238 */     // MIs[0] policy
     /* 2070238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070248 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070277 */     // GIR_Coverage, 15721,
     /* 2070277 */     GIR_EraseRootFromParent_Done,
     /* 2070278 */   // Label 27523: @2070278
     /* 2070278 */   GIM_Try, /*On fail goto*//*Label 27524*/ GIMT_Encode4(2070372), // Rule ID 15724 //
     /* 2070283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2070294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2070297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2070300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070329 */     // MIs[0] round
     /* 2070329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070332 */     // MIs[0] policy
     /* 2070332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070342 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070371 */     // GIR_Coverage, 15724,
     /* 2070371 */     GIR_EraseRootFromParent_Done,
     /* 2070372 */   // Label 27524: @2070372
     /* 2070372 */   GIM_Try, /*On fail goto*//*Label 27525*/ GIMT_Encode4(2070466), // Rule ID 15725 //
     /* 2070377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2070388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2070391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2070394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070423 */     // MIs[0] round
     /* 2070423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070426 */     // MIs[0] policy
     /* 2070426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070436 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070465 */     // GIR_Coverage, 15725,
     /* 2070465 */     GIR_EraseRootFromParent_Done,
     /* 2070466 */   // Label 27525: @2070466
     /* 2070466 */   GIM_Try, /*On fail goto*//*Label 27526*/ GIMT_Encode4(2070560), // Rule ID 15728 //
     /* 2070471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2070482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2070485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2070488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070517 */     // MIs[0] round
     /* 2070517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070520 */     // MIs[0] policy
     /* 2070520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070530 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070559 */     // GIR_Coverage, 15728,
     /* 2070559 */     GIR_EraseRootFromParent_Done,
     /* 2070560 */   // Label 27526: @2070560
     /* 2070560 */   GIM_Try, /*On fail goto*//*Label 27527*/ GIMT_Encode4(2070654), // Rule ID 15729 //
     /* 2070565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2070576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2070579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2070582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070611 */     // MIs[0] round
     /* 2070611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070614 */     // MIs[0] policy
     /* 2070614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070624 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070653 */     // GIR_Coverage, 15729,
     /* 2070653 */     GIR_EraseRootFromParent_Done,
     /* 2070654 */   // Label 27527: @2070654
     /* 2070654 */   GIM_Try, /*On fail goto*//*Label 27528*/ GIMT_Encode4(2070748), // Rule ID 15732 //
     /* 2070659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2070670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2070673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2070676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070705 */     // MIs[0] round
     /* 2070705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070708 */     // MIs[0] policy
     /* 2070708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070718 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070747 */     // GIR_Coverage, 15732,
     /* 2070747 */     GIR_EraseRootFromParent_Done,
     /* 2070748 */   // Label 27528: @2070748
     /* 2070748 */   GIM_Try, /*On fail goto*//*Label 27529*/ GIMT_Encode4(2070842), // Rule ID 15733 //
     /* 2070753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2070764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2070767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2070770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070799 */     // MIs[0] round
     /* 2070799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070802 */     // MIs[0] policy
     /* 2070802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070812 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070841 */     // GIR_Coverage, 15733,
     /* 2070841 */     GIR_EraseRootFromParent_Done,
     /* 2070842 */   // Label 27529: @2070842
     /* 2070842 */   GIM_Try, /*On fail goto*//*Label 27530*/ GIMT_Encode4(2070936), // Rule ID 15736 //
     /* 2070847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2070858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2070861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2070864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2070870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070893 */     // MIs[0] round
     /* 2070893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070896 */     // MIs[0] policy
     /* 2070896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070906 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2070909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070935 */     // GIR_Coverage, 15736,
     /* 2070935 */     GIR_EraseRootFromParent_Done,
     /* 2070936 */   // Label 27530: @2070936
     /* 2070936 */   GIM_Try, /*On fail goto*//*Label 27531*/ GIMT_Encode4(2071030), // Rule ID 15737 //
     /* 2070941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2070952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2070955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2070958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2070964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070987 */     // MIs[0] round
     /* 2070987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070990 */     // MIs[0] policy
     /* 2070990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071000 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071029 */     // GIR_Coverage, 15737,
     /* 2071029 */     GIR_EraseRootFromParent_Done,
     /* 2071030 */   // Label 27531: @2071030
     /* 2071030 */   GIM_Try, /*On fail goto*//*Label 27532*/ GIMT_Encode4(2071124), // Rule ID 15740 //
     /* 2071035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2071046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2071049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2071052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071081 */     // MIs[0] round
     /* 2071081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071084 */     // MIs[0] policy
     /* 2071084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071123 */     // GIR_Coverage, 15740,
     /* 2071123 */     GIR_EraseRootFromParent_Done,
     /* 2071124 */   // Label 27532: @2071124
     /* 2071124 */   GIM_Try, /*On fail goto*//*Label 27533*/ GIMT_Encode4(2071218), // Rule ID 15741 //
     /* 2071129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2071140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2071143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2071146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071175 */     // MIs[0] round
     /* 2071175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071178 */     // MIs[0] policy
     /* 2071178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071188 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071217 */     // GIR_Coverage, 15741,
     /* 2071217 */     GIR_EraseRootFromParent_Done,
     /* 2071218 */   // Label 27533: @2071218
     /* 2071218 */   GIM_Try, /*On fail goto*//*Label 27534*/ GIMT_Encode4(2071312), // Rule ID 15744 //
     /* 2071223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2071234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2071237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2071240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071269 */     // MIs[0] round
     /* 2071269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071272 */     // MIs[0] policy
     /* 2071272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071282 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071311 */     // GIR_Coverage, 15744,
     /* 2071311 */     GIR_EraseRootFromParent_Done,
     /* 2071312 */   // Label 27534: @2071312
     /* 2071312 */   GIM_Try, /*On fail goto*//*Label 27535*/ GIMT_Encode4(2071406), // Rule ID 15745 //
     /* 2071317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2071328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2071331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2071334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071363 */     // MIs[0] round
     /* 2071363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071366 */     // MIs[0] policy
     /* 2071366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071376 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071405 */     // GIR_Coverage, 15745,
     /* 2071405 */     GIR_EraseRootFromParent_Done,
     /* 2071406 */   // Label 27535: @2071406
     /* 2071406 */   GIM_Try, /*On fail goto*//*Label 27536*/ GIMT_Encode4(2071500), // Rule ID 15748 //
     /* 2071411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2071422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2071425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2071428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071457 */     // MIs[0] round
     /* 2071457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071460 */     // MIs[0] policy
     /* 2071460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071470 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2071473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071499 */     // GIR_Coverage, 15748,
     /* 2071499 */     GIR_EraseRootFromParent_Done,
     /* 2071500 */   // Label 27536: @2071500
     /* 2071500 */   GIM_Try, /*On fail goto*//*Label 27537*/ GIMT_Encode4(2071594), // Rule ID 15749 //
     /* 2071505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2071516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2071519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2071522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071551 */     // MIs[0] round
     /* 2071551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071554 */     // MIs[0] policy
     /* 2071554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071564 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2071567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071593 */     // GIR_Coverage, 15749,
     /* 2071593 */     GIR_EraseRootFromParent_Done,
     /* 2071594 */   // Label 27537: @2071594
     /* 2071594 */   GIM_Try, /*On fail goto*//*Label 27538*/ GIMT_Encode4(2071688), // Rule ID 15752 //
     /* 2071599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2071610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2071613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2071616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2071622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2071629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071645 */     // MIs[0] round
     /* 2071645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071648 */     // MIs[0] policy
     /* 2071648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071658 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2071661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071687 */     // GIR_Coverage, 15752,
     /* 2071687 */     GIR_EraseRootFromParent_Done,
     /* 2071688 */   // Label 27538: @2071688
     /* 2071688 */   GIM_Try, /*On fail goto*//*Label 27539*/ GIMT_Encode4(2071782), // Rule ID 15753 //
     /* 2071693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2071704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2071707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2071710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2071716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2071723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071739 */     // MIs[0] round
     /* 2071739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071742 */     // MIs[0] policy
     /* 2071742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071752 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2071755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071781 */     // GIR_Coverage, 15753,
     /* 2071781 */     GIR_EraseRootFromParent_Done,
     /* 2071782 */   // Label 27539: @2071782
     /* 2071782 */   GIM_Try, /*On fail goto*//*Label 27540*/ GIMT_Encode4(2071876), // Rule ID 15756 //
     /* 2071787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2071798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2071801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2071804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2071810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2071817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071833 */     // MIs[0] round
     /* 2071833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071836 */     // MIs[0] policy
     /* 2071836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071846 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2071849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071875 */     // GIR_Coverage, 15756,
     /* 2071875 */     GIR_EraseRootFromParent_Done,
     /* 2071876 */   // Label 27540: @2071876
     /* 2071876 */   GIM_Try, /*On fail goto*//*Label 27541*/ GIMT_Encode4(2071970), // Rule ID 15757 //
     /* 2071881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2071892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2071895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2071898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2071904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2071911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071927 */     // MIs[0] round
     /* 2071927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071930 */     // MIs[0] policy
     /* 2071930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071940 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2071943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071969 */     // GIR_Coverage, 15757,
     /* 2071969 */     GIR_EraseRootFromParent_Done,
     /* 2071970 */   // Label 27541: @2071970
     /* 2071970 */   GIM_Try, /*On fail goto*//*Label 27542*/ GIMT_Encode4(2072064), // Rule ID 15760 //
     /* 2071975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2071986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2071989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2071992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072021 */     // MIs[0] round
     /* 2072021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072024 */     // MIs[0] policy
     /* 2072024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072034 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072063 */     // GIR_Coverage, 15760,
     /* 2072063 */     GIR_EraseRootFromParent_Done,
     /* 2072064 */   // Label 27542: @2072064
     /* 2072064 */   GIM_Try, /*On fail goto*//*Label 27543*/ GIMT_Encode4(2072158), // Rule ID 15761 //
     /* 2072069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2072080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2072083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2072086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072115 */     // MIs[0] round
     /* 2072115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072118 */     // MIs[0] policy
     /* 2072118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072128 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072157 */     // GIR_Coverage, 15761,
     /* 2072157 */     GIR_EraseRootFromParent_Done,
     /* 2072158 */   // Label 27543: @2072158
     /* 2072158 */   GIM_Try, /*On fail goto*//*Label 27544*/ GIMT_Encode4(2072252), // Rule ID 15764 //
     /* 2072163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2072174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2072177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2072180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072209 */     // MIs[0] round
     /* 2072209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072212 */     // MIs[0] policy
     /* 2072212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072222 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072251 */     // GIR_Coverage, 15764,
     /* 2072251 */     GIR_EraseRootFromParent_Done,
     /* 2072252 */   // Label 27544: @2072252
     /* 2072252 */   GIM_Try, /*On fail goto*//*Label 27545*/ GIMT_Encode4(2072346), // Rule ID 15765 //
     /* 2072257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2072268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2072271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2072274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072303 */     // MIs[0] round
     /* 2072303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072306 */     // MIs[0] policy
     /* 2072306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072316 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072345 */     // GIR_Coverage, 15765,
     /* 2072345 */     GIR_EraseRootFromParent_Done,
     /* 2072346 */   // Label 27545: @2072346
     /* 2072346 */   GIM_Try, /*On fail goto*//*Label 27546*/ GIMT_Encode4(2072440), // Rule ID 15768 //
     /* 2072351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2072362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2072365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2072368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072397 */     // MIs[0] round
     /* 2072397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072400 */     // MIs[0] policy
     /* 2072400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072410 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072439 */     // GIR_Coverage, 15768,
     /* 2072439 */     GIR_EraseRootFromParent_Done,
     /* 2072440 */   // Label 27546: @2072440
     /* 2072440 */   GIM_Try, /*On fail goto*//*Label 27547*/ GIMT_Encode4(2072534), // Rule ID 15769 //
     /* 2072445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2072456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2072459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2072462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072491 */     // MIs[0] round
     /* 2072491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072494 */     // MIs[0] policy
     /* 2072494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072504 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072533 */     // GIR_Coverage, 15769,
     /* 2072533 */     GIR_EraseRootFromParent_Done,
     /* 2072534 */   // Label 27547: @2072534
     /* 2072534 */   GIM_Try, /*On fail goto*//*Label 27548*/ GIMT_Encode4(2072628), // Rule ID 15772 //
     /* 2072539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2072550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2072553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2072556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2072562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072585 */     // MIs[0] round
     /* 2072585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072588 */     // MIs[0] policy
     /* 2072588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072627 */     // GIR_Coverage, 15772,
     /* 2072627 */     GIR_EraseRootFromParent_Done,
     /* 2072628 */   // Label 27548: @2072628
     /* 2072628 */   GIM_Try, /*On fail goto*//*Label 27549*/ GIMT_Encode4(2072722), // Rule ID 15773 //
     /* 2072633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2072644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2072647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2072650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2072656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072679 */     // MIs[0] round
     /* 2072679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072682 */     // MIs[0] policy
     /* 2072682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072721 */     // GIR_Coverage, 15773,
     /* 2072721 */     GIR_EraseRootFromParent_Done,
     /* 2072722 */   // Label 27549: @2072722
     /* 2072722 */   GIM_Try, /*On fail goto*//*Label 27550*/ GIMT_Encode4(2072816), // Rule ID 15776 //
     /* 2072727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2072738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2072741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2072744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072773 */     // MIs[0] round
     /* 2072773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072776 */     // MIs[0] policy
     /* 2072776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072786 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072815 */     // GIR_Coverage, 15776,
     /* 2072815 */     GIR_EraseRootFromParent_Done,
     /* 2072816 */   // Label 27550: @2072816
     /* 2072816 */   GIM_Try, /*On fail goto*//*Label 27551*/ GIMT_Encode4(2072910), // Rule ID 15777 //
     /* 2072821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2072832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2072835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2072838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072867 */     // MIs[0] round
     /* 2072867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072870 */     // MIs[0] policy
     /* 2072870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072880 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072909 */     // GIR_Coverage, 15777,
     /* 2072909 */     GIR_EraseRootFromParent_Done,
     /* 2072910 */   // Label 27551: @2072910
     /* 2072910 */   GIM_Try, /*On fail goto*//*Label 27552*/ GIMT_Encode4(2073004), // Rule ID 15780 //
     /* 2072915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2072926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2072929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2072932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072961 */     // MIs[0] round
     /* 2072961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072964 */     // MIs[0] policy
     /* 2072964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072974 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073003 */     // GIR_Coverage, 15780,
     /* 2073003 */     GIR_EraseRootFromParent_Done,
     /* 2073004 */   // Label 27552: @2073004
     /* 2073004 */   GIM_Try, /*On fail goto*//*Label 27553*/ GIMT_Encode4(2073098), // Rule ID 15781 //
     /* 2073009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2073020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2073023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2073026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2073032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073055 */     // MIs[0] round
     /* 2073055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073058 */     // MIs[0] policy
     /* 2073058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073068 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2073071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073097 */     // GIR_Coverage, 15781,
     /* 2073097 */     GIR_EraseRootFromParent_Done,
     /* 2073098 */   // Label 27553: @2073098
     /* 2073098 */   GIM_Try, /*On fail goto*//*Label 27554*/ GIMT_Encode4(2073192), // Rule ID 15784 //
     /* 2073103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2073123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073149 */     // MIs[0] round
     /* 2073149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073152 */     // MIs[0] policy
     /* 2073152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073162 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2073165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073191 */     // GIR_Coverage, 15784,
     /* 2073191 */     GIR_EraseRootFromParent_Done,
     /* 2073192 */   // Label 27554: @2073192
     /* 2073192 */   GIM_Try, /*On fail goto*//*Label 27555*/ GIMT_Encode4(2073286), // Rule ID 15785 //
     /* 2073197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2073217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073243 */     // MIs[0] round
     /* 2073243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073246 */     // MIs[0] policy
     /* 2073246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073256 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2073259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073285 */     // GIR_Coverage, 15785,
     /* 2073285 */     GIR_EraseRootFromParent_Done,
     /* 2073286 */   // Label 27555: @2073286
     /* 2073286 */   GIM_Try, /*On fail goto*//*Label 27556*/ GIMT_Encode4(2073380), // Rule ID 15788 //
     /* 2073291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2073302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2073305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2073308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2073311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073337 */     // MIs[0] round
     /* 2073337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073340 */     // MIs[0] policy
     /* 2073340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073350 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2073353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073379 */     // GIR_Coverage, 15788,
     /* 2073379 */     GIR_EraseRootFromParent_Done,
     /* 2073380 */   // Label 27556: @2073380
     /* 2073380 */   GIM_Try, /*On fail goto*//*Label 27557*/ GIMT_Encode4(2073474), // Rule ID 15789 //
     /* 2073385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2073396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2073399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2073402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2073405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073431 */     // MIs[0] round
     /* 2073431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073434 */     // MIs[0] policy
     /* 2073434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073444 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2073447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073473 */     // GIR_Coverage, 15789,
     /* 2073473 */     GIR_EraseRootFromParent_Done,
     /* 2073474 */   // Label 27557: @2073474
     /* 2073474 */   GIM_Try, /*On fail goto*//*Label 27558*/ GIMT_Encode4(2073568), // Rule ID 15792 //
     /* 2073479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2073490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2073493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2073496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2073499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073525 */     // MIs[0] round
     /* 2073525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073528 */     // MIs[0] policy
     /* 2073528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073538 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2073541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073563 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073567 */     // GIR_Coverage, 15792,
     /* 2073567 */     GIR_EraseRootFromParent_Done,
     /* 2073568 */   // Label 27558: @2073568
     /* 2073568 */   GIM_Try, /*On fail goto*//*Label 27559*/ GIMT_Encode4(2073662), // Rule ID 15793 //
     /* 2073573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2073584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2073587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2073590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2073593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073619 */     // MIs[0] round
     /* 2073619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073622 */     // MIs[0] policy
     /* 2073622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073632 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2073635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073657 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073661 */     // GIR_Coverage, 15793,
     /* 2073661 */     GIR_EraseRootFromParent_Done,
     /* 2073662 */   // Label 27559: @2073662
     /* 2073662 */   GIM_Try, /*On fail goto*//*Label 27560*/ GIMT_Encode4(2073756), // Rule ID 15796 //
     /* 2073667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2073678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2073681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2073684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2073687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2073690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073713 */     // MIs[0] round
     /* 2073713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073716 */     // MIs[0] policy
     /* 2073716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073726 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2073729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073755 */     // GIR_Coverage, 15796,
     /* 2073755 */     GIR_EraseRootFromParent_Done,
     /* 2073756 */   // Label 27560: @2073756
     /* 2073756 */   GIM_Try, /*On fail goto*//*Label 27561*/ GIMT_Encode4(2073850), // Rule ID 15797 //
     /* 2073761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2073772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2073775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2073778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2073781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2073784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073807 */     // MIs[0] round
     /* 2073807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073810 */     // MIs[0] policy
     /* 2073810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073820 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2073823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073849 */     // GIR_Coverage, 15797,
     /* 2073849 */     GIR_EraseRootFromParent_Done,
     /* 2073850 */   // Label 27561: @2073850
     /* 2073850 */   GIM_Try, /*On fail goto*//*Label 27562*/ GIMT_Encode4(2073944), // Rule ID 15800 //
     /* 2073855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073901 */     // MIs[0] round
     /* 2073901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073904 */     // MIs[0] policy
     /* 2073904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073914 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2073917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073943 */     // GIR_Coverage, 15800,
     /* 2073943 */     GIR_EraseRootFromParent_Done,
     /* 2073944 */   // Label 27562: @2073944
     /* 2073944 */   GIM_Try, /*On fail goto*//*Label 27563*/ GIMT_Encode4(2074038), // Rule ID 15801 //
     /* 2073949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073995 */     // MIs[0] round
     /* 2073995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073998 */     // MIs[0] policy
     /* 2073998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074008 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2074011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074037 */     // GIR_Coverage, 15801,
     /* 2074037 */     GIR_EraseRootFromParent_Done,
     /* 2074038 */   // Label 27563: @2074038
     /* 2074038 */   GIM_Try, /*On fail goto*//*Label 27564*/ GIMT_Encode4(2074132), // Rule ID 15804 //
     /* 2074043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2074054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2074057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2074060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074089 */     // MIs[0] round
     /* 2074089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074092 */     // MIs[0] policy
     /* 2074092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074102 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2074105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074131 */     // GIR_Coverage, 15804,
     /* 2074131 */     GIR_EraseRootFromParent_Done,
     /* 2074132 */   // Label 27564: @2074132
     /* 2074132 */   GIM_Try, /*On fail goto*//*Label 27565*/ GIMT_Encode4(2074226), // Rule ID 15805 //
     /* 2074137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2074148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2074151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2074154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074183 */     // MIs[0] round
     /* 2074183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074186 */     // MIs[0] policy
     /* 2074186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074196 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2074199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074221 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074225 */     // GIR_Coverage, 15805,
     /* 2074225 */     GIR_EraseRootFromParent_Done,
     /* 2074226 */   // Label 27565: @2074226
     /* 2074226 */   GIM_Try, /*On fail goto*//*Label 27566*/ GIMT_Encode4(2074320), // Rule ID 15808 //
     /* 2074231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2074242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2074245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2074248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074277 */     // MIs[0] round
     /* 2074277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074280 */     // MIs[0] policy
     /* 2074280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074290 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2074293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074319 */     // GIR_Coverage, 15808,
     /* 2074319 */     GIR_EraseRootFromParent_Done,
     /* 2074320 */   // Label 27566: @2074320
     /* 2074320 */   GIM_Try, /*On fail goto*//*Label 27567*/ GIMT_Encode4(2074414), // Rule ID 15809 //
     /* 2074325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2074336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2074339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2074342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074371 */     // MIs[0] round
     /* 2074371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074374 */     // MIs[0] policy
     /* 2074374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074384 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2074387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074413 */     // GIR_Coverage, 15809,
     /* 2074413 */     GIR_EraseRootFromParent_Done,
     /* 2074414 */   // Label 27567: @2074414
     /* 2074414 */   GIM_Try, /*On fail goto*//*Label 27568*/ GIMT_Encode4(2074508), // Rule ID 15812 //
     /* 2074419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2074430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2074433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2074436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074465 */     // MIs[0] round
     /* 2074465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074468 */     // MIs[0] policy
     /* 2074468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074478 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2074481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074507 */     // GIR_Coverage, 15812,
     /* 2074507 */     GIR_EraseRootFromParent_Done,
     /* 2074508 */   // Label 27568: @2074508
     /* 2074508 */   GIM_Try, /*On fail goto*//*Label 27569*/ GIMT_Encode4(2074602), // Rule ID 15813 //
     /* 2074513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2074524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2074527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2074530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074559 */     // MIs[0] round
     /* 2074559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074562 */     // MIs[0] policy
     /* 2074562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074572 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2074575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074601 */     // GIR_Coverage, 15813,
     /* 2074601 */     GIR_EraseRootFromParent_Done,
     /* 2074602 */   // Label 27569: @2074602
     /* 2074602 */   GIM_Try, /*On fail goto*//*Label 27570*/ GIMT_Encode4(2074693), // Rule ID 15816 //
     /* 2074607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2074618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2074621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2074624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2074627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2074630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074653 */     // MIs[0] round
     /* 2074653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074656 */     // MIs[0] policy
     /* 2074656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074666 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2074669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2074689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074692 */     // GIR_Coverage, 15816,
     /* 2074692 */     GIR_EraseRootFromParent_Done,
     /* 2074693 */   // Label 27570: @2074693
     /* 2074693 */   GIM_Try, /*On fail goto*//*Label 27571*/ GIMT_Encode4(2074784), // Rule ID 15817 //
     /* 2074698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2074709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2074712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2074715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2074718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2074721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074744 */     // MIs[0] round
     /* 2074744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074747 */     // MIs[0] policy
     /* 2074747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074757 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2074760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2074780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074783 */     // GIR_Coverage, 15817,
     /* 2074783 */     GIR_EraseRootFromParent_Done,
     /* 2074784 */   // Label 27571: @2074784
     /* 2074784 */   GIM_Try, /*On fail goto*//*Label 27572*/ GIMT_Encode4(2074875), // Rule ID 15820 //
     /* 2074789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2074800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2074803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2074806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2074809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074835 */     // MIs[0] round
     /* 2074835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074838 */     // MIs[0] policy
     /* 2074838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074848 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2074851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2074871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074874 */     // GIR_Coverage, 15820,
     /* 2074874 */     GIR_EraseRootFromParent_Done,
     /* 2074875 */   // Label 27572: @2074875
     /* 2074875 */   GIM_Try, /*On fail goto*//*Label 27573*/ GIMT_Encode4(2074966), // Rule ID 15821 //
     /* 2074880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2074891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2074894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2074897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2074900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074926 */     // MIs[0] round
     /* 2074926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074929 */     // MIs[0] policy
     /* 2074929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074939 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2074942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2074962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074965 */     // GIR_Coverage, 15821,
     /* 2074965 */     GIR_EraseRootFromParent_Done,
     /* 2074966 */   // Label 27573: @2074966
     /* 2074966 */   GIM_Try, /*On fail goto*//*Label 27574*/ GIMT_Encode4(2075057), // Rule ID 15824 //
     /* 2074971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2074982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2074985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2074988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2074991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075017 */     // MIs[0] round
     /* 2075017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075020 */     // MIs[0] policy
     /* 2075020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075030 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075056 */     // GIR_Coverage, 15824,
     /* 2075056 */     GIR_EraseRootFromParent_Done,
     /* 2075057 */   // Label 27574: @2075057
     /* 2075057 */   GIM_Try, /*On fail goto*//*Label 27575*/ GIMT_Encode4(2075148), // Rule ID 15825 //
     /* 2075062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2075073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2075076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2075079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2075082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075108 */     // MIs[0] round
     /* 2075108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075111 */     // MIs[0] policy
     /* 2075111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075121 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075147 */     // GIR_Coverage, 15825,
     /* 2075147 */     GIR_EraseRootFromParent_Done,
     /* 2075148 */   // Label 27575: @2075148
     /* 2075148 */   GIM_Try, /*On fail goto*//*Label 27576*/ GIMT_Encode4(2075239), // Rule ID 15828 //
     /* 2075153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2075164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2075167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2075170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2075173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075199 */     // MIs[0] round
     /* 2075199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075202 */     // MIs[0] policy
     /* 2075202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075212 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2075215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075238 */     // GIR_Coverage, 15828,
     /* 2075238 */     GIR_EraseRootFromParent_Done,
     /* 2075239 */   // Label 27576: @2075239
     /* 2075239 */   GIM_Try, /*On fail goto*//*Label 27577*/ GIMT_Encode4(2075330), // Rule ID 15829 //
     /* 2075244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2075255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2075258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2075261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2075264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075290 */     // MIs[0] round
     /* 2075290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075293 */     // MIs[0] policy
     /* 2075293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075303 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2075306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075329 */     // GIR_Coverage, 15829,
     /* 2075329 */     GIR_EraseRootFromParent_Done,
     /* 2075330 */   // Label 27577: @2075330
     /* 2075330 */   GIM_Try, /*On fail goto*//*Label 27578*/ GIMT_Encode4(2075421), // Rule ID 15832 //
     /* 2075335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2075346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2075349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2075352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2075355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075381 */     // MIs[0] round
     /* 2075381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075384 */     // MIs[0] policy
     /* 2075384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075394 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075420 */     // GIR_Coverage, 15832,
     /* 2075420 */     GIR_EraseRootFromParent_Done,
     /* 2075421 */   // Label 27578: @2075421
     /* 2075421 */   GIM_Try, /*On fail goto*//*Label 27579*/ GIMT_Encode4(2075512), // Rule ID 15833 //
     /* 2075426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2075437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2075440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2075443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2075446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075472 */     // MIs[0] round
     /* 2075472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075475 */     // MIs[0] policy
     /* 2075475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075485 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075511 */     // GIR_Coverage, 15833,
     /* 2075511 */     GIR_EraseRootFromParent_Done,
     /* 2075512 */   // Label 27579: @2075512
     /* 2075512 */   GIM_Try, /*On fail goto*//*Label 27580*/ GIMT_Encode4(2075603), // Rule ID 15836 //
     /* 2075517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2075528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2075531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2075534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2075537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075563 */     // MIs[0] round
     /* 2075563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075566 */     // MIs[0] policy
     /* 2075566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075576 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2075599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075602 */     // GIR_Coverage, 15836,
     /* 2075602 */     GIR_EraseRootFromParent_Done,
     /* 2075603 */   // Label 27580: @2075603
     /* 2075603 */   GIM_Try, /*On fail goto*//*Label 27581*/ GIMT_Encode4(2075694), // Rule ID 15837 //
     /* 2075608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2075619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2075622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2075625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2075628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075654 */     // MIs[0] round
     /* 2075654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075657 */     // MIs[0] policy
     /* 2075657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075667 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2075690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075693 */     // GIR_Coverage, 15837,
     /* 2075693 */     GIR_EraseRootFromParent_Done,
     /* 2075694 */   // Label 27581: @2075694
     /* 2075694 */   GIM_Try, /*On fail goto*//*Label 27582*/ GIMT_Encode4(2075785), // Rule ID 15840 //
     /* 2075699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2075710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2075713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2075716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2075719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2075722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075745 */     // MIs[0] round
     /* 2075745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075748 */     // MIs[0] policy
     /* 2075748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2075761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075784 */     // GIR_Coverage, 15840,
     /* 2075784 */     GIR_EraseRootFromParent_Done,
     /* 2075785 */   // Label 27582: @2075785
     /* 2075785 */   GIM_Try, /*On fail goto*//*Label 27583*/ GIMT_Encode4(2075876), // Rule ID 15841 //
     /* 2075790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2075801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2075804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2075807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2075810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2075813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075836 */     // MIs[0] round
     /* 2075836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075839 */     // MIs[0] policy
     /* 2075839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075849 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2075852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075875 */     // GIR_Coverage, 15841,
     /* 2075875 */     GIR_EraseRootFromParent_Done,
     /* 2075876 */   // Label 27583: @2075876
     /* 2075876 */   GIM_Try, /*On fail goto*//*Label 27584*/ GIMT_Encode4(2075967), // Rule ID 15844 //
     /* 2075881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2075892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2075895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2075898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2075901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075927 */     // MIs[0] round
     /* 2075927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075930 */     // MIs[0] policy
     /* 2075930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2075943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075966 */     // GIR_Coverage, 15844,
     /* 2075966 */     GIR_EraseRootFromParent_Done,
     /* 2075967 */   // Label 27584: @2075967
     /* 2075967 */   GIM_Try, /*On fail goto*//*Label 27585*/ GIMT_Encode4(2076058), // Rule ID 15845 //
     /* 2075972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2075983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2075986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2075989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2075992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076018 */     // MIs[0] round
     /* 2076018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076021 */     // MIs[0] policy
     /* 2076021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076031 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076057 */     // GIR_Coverage, 15845,
     /* 2076057 */     GIR_EraseRootFromParent_Done,
     /* 2076058 */   // Label 27585: @2076058
     /* 2076058 */   GIM_Try, /*On fail goto*//*Label 27586*/ GIMT_Encode4(2076149), // Rule ID 15848 //
     /* 2076063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2076074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2076077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2076080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2076083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076109 */     // MIs[0] round
     /* 2076109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076112 */     // MIs[0] policy
     /* 2076112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076122 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076148 */     // GIR_Coverage, 15848,
     /* 2076148 */     GIR_EraseRootFromParent_Done,
     /* 2076149 */   // Label 27586: @2076149
     /* 2076149 */   GIM_Try, /*On fail goto*//*Label 27587*/ GIMT_Encode4(2076240), // Rule ID 15849 //
     /* 2076154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2076165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2076168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2076171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2076174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076200 */     // MIs[0] round
     /* 2076200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076203 */     // MIs[0] policy
     /* 2076203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076213 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076239 */     // GIR_Coverage, 15849,
     /* 2076239 */     GIR_EraseRootFromParent_Done,
     /* 2076240 */   // Label 27587: @2076240
     /* 2076240 */   GIM_Try, /*On fail goto*//*Label 27588*/ GIMT_Encode4(2076331), // Rule ID 15852 //
     /* 2076245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2076248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2076256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2076259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2076262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2076265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076291 */     // MIs[0] round
     /* 2076291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076294 */     // MIs[0] policy
     /* 2076294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076304 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2076327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076330 */     // GIR_Coverage, 15852,
     /* 2076330 */     GIR_EraseRootFromParent_Done,
     /* 2076331 */   // Label 27588: @2076331
     /* 2076331 */   GIM_Try, /*On fail goto*//*Label 27589*/ GIMT_Encode4(2076422), // Rule ID 15853 //
     /* 2076336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2076339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2076347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2076350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2076353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2076356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076382 */     // MIs[0] round
     /* 2076382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076385 */     // MIs[0] policy
     /* 2076385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076395 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2076418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076421 */     // GIR_Coverage, 15853,
     /* 2076421 */     GIR_EraseRootFromParent_Done,
     /* 2076422 */   // Label 27589: @2076422
     /* 2076422 */   GIM_Try, /*On fail goto*//*Label 27590*/ GIMT_Encode4(2076513), // Rule ID 15856 //
     /* 2076427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2076438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2076441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2076444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2076447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2076450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2076457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076473 */     // MIs[0] round
     /* 2076473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076476 */     // MIs[0] policy
     /* 2076476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076486 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2076489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076512 */     // GIR_Coverage, 15856,
     /* 2076512 */     GIR_EraseRootFromParent_Done,
     /* 2076513 */   // Label 27590: @2076513
     /* 2076513 */   GIM_Try, /*On fail goto*//*Label 27591*/ GIMT_Encode4(2076604), // Rule ID 15857 //
     /* 2076518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2076529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2076532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2076535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2076538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2076541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2076548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076564 */     // MIs[0] round
     /* 2076564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076567 */     // MIs[0] policy
     /* 2076567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076577 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2076580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076603 */     // GIR_Coverage, 15857,
     /* 2076603 */     GIR_EraseRootFromParent_Done,
     /* 2076604 */   // Label 27591: @2076604
     /* 2076604 */   GIM_Try, /*On fail goto*//*Label 27592*/ GIMT_Encode4(2076695), // Rule ID 15860 //
     /* 2076609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2076620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2076623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2076626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2076629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2076632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2076639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076655 */     // MIs[0] round
     /* 2076655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076658 */     // MIs[0] policy
     /* 2076658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076668 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2076671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076694 */     // GIR_Coverage, 15860,
     /* 2076694 */     GIR_EraseRootFromParent_Done,
     /* 2076695 */   // Label 27592: @2076695
     /* 2076695 */   GIM_Try, /*On fail goto*//*Label 27593*/ GIMT_Encode4(2076786), // Rule ID 15861 //
     /* 2076700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2076711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2076714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2076717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2076720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2076723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2076730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076746 */     // MIs[0] round
     /* 2076746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076749 */     // MIs[0] policy
     /* 2076749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076759 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2076762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076785 */     // GIR_Coverage, 15861,
     /* 2076785 */     GIR_EraseRootFromParent_Done,
     /* 2076786 */   // Label 27593: @2076786
     /* 2076786 */   GIM_Try, /*On fail goto*//*Label 27594*/ GIMT_Encode4(2076877), // Rule ID 15864 //
     /* 2076791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2076802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2076805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2076808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2076811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2076814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2076821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076837 */     // MIs[0] round
     /* 2076837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076840 */     // MIs[0] policy
     /* 2076840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076850 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2076853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076876 */     // GIR_Coverage, 15864,
     /* 2076876 */     GIR_EraseRootFromParent_Done,
     /* 2076877 */   // Label 27594: @2076877
     /* 2076877 */   GIM_Try, /*On fail goto*//*Label 27595*/ GIMT_Encode4(2076968), // Rule ID 15865 //
     /* 2076882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2076893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2076896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2076899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2076902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2076905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2076912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076928 */     // MIs[0] round
     /* 2076928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076931 */     // MIs[0] policy
     /* 2076931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076941 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2076944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076967 */     // GIR_Coverage, 15865,
     /* 2076967 */     GIR_EraseRootFromParent_Done,
     /* 2076968 */   // Label 27595: @2076968
     /* 2076968 */   GIM_Try, /*On fail goto*//*Label 27596*/ GIMT_Encode4(2077059), // Rule ID 15868 //
     /* 2076973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2076984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2076987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2076990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2076993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077019 */     // MIs[0] round
     /* 2077019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077022 */     // MIs[0] policy
     /* 2077022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077032 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077058 */     // GIR_Coverage, 15868,
     /* 2077058 */     GIR_EraseRootFromParent_Done,
     /* 2077059 */   // Label 27596: @2077059
     /* 2077059 */   GIM_Try, /*On fail goto*//*Label 27597*/ GIMT_Encode4(2077150), // Rule ID 15869 //
     /* 2077064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2077075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2077078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2077081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2077084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077110 */     // MIs[0] round
     /* 2077110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077113 */     // MIs[0] policy
     /* 2077113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077123 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077149 */     // GIR_Coverage, 15869,
     /* 2077149 */     GIR_EraseRootFromParent_Done,
     /* 2077150 */   // Label 27597: @2077150
     /* 2077150 */   GIM_Try, /*On fail goto*//*Label 27598*/ GIMT_Encode4(2077241), // Rule ID 15872 //
     /* 2077155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2077166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2077169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2077172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2077175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077201 */     // MIs[0] round
     /* 2077201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077204 */     // MIs[0] policy
     /* 2077204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077214 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077240 */     // GIR_Coverage, 15872,
     /* 2077240 */     GIR_EraseRootFromParent_Done,
     /* 2077241 */   // Label 27598: @2077241
     /* 2077241 */   GIM_Try, /*On fail goto*//*Label 27599*/ GIMT_Encode4(2077332), // Rule ID 15873 //
     /* 2077246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2077257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2077260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2077263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2077266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077292 */     // MIs[0] round
     /* 2077292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077295 */     // MIs[0] policy
     /* 2077295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077305 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077331 */     // GIR_Coverage, 15873,
     /* 2077331 */     GIR_EraseRootFromParent_Done,
     /* 2077332 */   // Label 27599: @2077332
     /* 2077332 */   GIM_Try, /*On fail goto*//*Label 27600*/ GIMT_Encode4(2077423), // Rule ID 15876 //
     /* 2077337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2077348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2077351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2077354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2077357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077383 */     // MIs[0] round
     /* 2077383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077386 */     // MIs[0] policy
     /* 2077386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077396 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077422 */     // GIR_Coverage, 15876,
     /* 2077422 */     GIR_EraseRootFromParent_Done,
     /* 2077423 */   // Label 27600: @2077423
     /* 2077423 */   GIM_Try, /*On fail goto*//*Label 27601*/ GIMT_Encode4(2077514), // Rule ID 15877 //
     /* 2077428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2077439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2077442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2077445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2077448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077474 */     // MIs[0] round
     /* 2077474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077477 */     // MIs[0] policy
     /* 2077477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077487 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077513 */     // GIR_Coverage, 15877,
     /* 2077513 */     GIR_EraseRootFromParent_Done,
     /* 2077514 */   // Label 27601: @2077514
     /* 2077514 */   GIM_Try, /*On fail goto*//*Label 27602*/ GIMT_Encode4(2077605), // Rule ID 15880 //
     /* 2077519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2077530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2077533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2077536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2077539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2077542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077565 */     // MIs[0] round
     /* 2077565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077568 */     // MIs[0] policy
     /* 2077568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077578 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077604 */     // GIR_Coverage, 15880,
     /* 2077604 */     GIR_EraseRootFromParent_Done,
     /* 2077605 */   // Label 27602: @2077605
     /* 2077605 */   GIM_Try, /*On fail goto*//*Label 27603*/ GIMT_Encode4(2077696), // Rule ID 15881 //
     /* 2077610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2077621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2077624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2077627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2077630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2077633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077656 */     // MIs[0] round
     /* 2077656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077659 */     // MIs[0] policy
     /* 2077659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077669 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077695 */     // GIR_Coverage, 15881,
     /* 2077695 */     GIR_EraseRootFromParent_Done,
     /* 2077696 */   // Label 27603: @2077696
     /* 2077696 */   GIM_Try, /*On fail goto*//*Label 27604*/ GIMT_Encode4(2077787), // Rule ID 15884 //
     /* 2077701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2077712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2077715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2077718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2077721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077747 */     // MIs[0] round
     /* 2077747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077750 */     // MIs[0] policy
     /* 2077750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077760 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077786 */     // GIR_Coverage, 15884,
     /* 2077786 */     GIR_EraseRootFromParent_Done,
     /* 2077787 */   // Label 27604: @2077787
     /* 2077787 */   GIM_Try, /*On fail goto*//*Label 27605*/ GIMT_Encode4(2077878), // Rule ID 15885 //
     /* 2077792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2077803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2077806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2077809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2077812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077838 */     // MIs[0] round
     /* 2077838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077841 */     // MIs[0] policy
     /* 2077841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077851 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077877 */     // GIR_Coverage, 15885,
     /* 2077877 */     GIR_EraseRootFromParent_Done,
     /* 2077878 */   // Label 27605: @2077878
     /* 2077878 */   GIM_Try, /*On fail goto*//*Label 27606*/ GIMT_Encode4(2077969), // Rule ID 15888 //
     /* 2077883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2077894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2077897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2077900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2077903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077929 */     // MIs[0] round
     /* 2077929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077932 */     // MIs[0] policy
     /* 2077932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077942 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077968 */     // GIR_Coverage, 15888,
     /* 2077968 */     GIR_EraseRootFromParent_Done,
     /* 2077969 */   // Label 27606: @2077969
     /* 2077969 */   GIM_Try, /*On fail goto*//*Label 27607*/ GIMT_Encode4(2078060), // Rule ID 15889 //
     /* 2077974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2077985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2077988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2077991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2077994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078020 */     // MIs[0] round
     /* 2078020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078023 */     // MIs[0] policy
     /* 2078023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078033 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2078036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078059 */     // GIR_Coverage, 15889,
     /* 2078059 */     GIR_EraseRootFromParent_Done,
     /* 2078060 */   // Label 27607: @2078060
     /* 2078060 */   GIM_Try, /*On fail goto*//*Label 27608*/ GIMT_Encode4(2078151), // Rule ID 15892 //
     /* 2078065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2078068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2078076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2078079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2078082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2078085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078111 */     // MIs[0] round
     /* 2078111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078114 */     // MIs[0] policy
     /* 2078114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2078127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078150 */     // GIR_Coverage, 15892,
     /* 2078150 */     GIR_EraseRootFromParent_Done,
     /* 2078151 */   // Label 27608: @2078151
     /* 2078151 */   GIM_Try, /*On fail goto*//*Label 27609*/ GIMT_Encode4(2078242), // Rule ID 15893 //
     /* 2078156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2078159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2078167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2078170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2078173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2078176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078202 */     // MIs[0] round
     /* 2078202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078205 */     // MIs[0] policy
     /* 2078205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078215 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2078218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078241 */     // GIR_Coverage, 15893,
     /* 2078241 */     GIR_EraseRootFromParent_Done,
     /* 2078242 */   // Label 27609: @2078242
     /* 2078242 */   GIM_Try, /*On fail goto*//*Label 27610*/ GIMT_Encode4(2078333), // Rule ID 15896 //
     /* 2078247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2078250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2078258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2078261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2078264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2078267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078293 */     // MIs[0] round
     /* 2078293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078296 */     // MIs[0] policy
     /* 2078296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078306 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2078309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078332 */     // GIR_Coverage, 15896,
     /* 2078332 */     GIR_EraseRootFromParent_Done,
     /* 2078333 */   // Label 27610: @2078333
     /* 2078333 */   GIM_Try, /*On fail goto*//*Label 27611*/ GIMT_Encode4(2078424), // Rule ID 15897 //
     /* 2078338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2078341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2078349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2078352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2078355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2078358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078384 */     // MIs[0] round
     /* 2078384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078387 */     // MIs[0] policy
     /* 2078387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078397 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2078400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078423 */     // GIR_Coverage, 15897,
     /* 2078423 */     GIR_EraseRootFromParent_Done,
     /* 2078424 */   // Label 27611: @2078424
     /* 2078424 */   GIM_Try, /*On fail goto*//*Label 27612*/ GIMT_Encode4(2078515), // Rule ID 15900 //
     /* 2078429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2078432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2078440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2078443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2078446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2078449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078475 */     // MIs[0] round
     /* 2078475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078478 */     // MIs[0] policy
     /* 2078478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078488 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2078491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078514 */     // GIR_Coverage, 15900,
     /* 2078514 */     GIR_EraseRootFromParent_Done,
     /* 2078515 */   // Label 27612: @2078515
     /* 2078515 */   GIM_Try, /*On fail goto*//*Label 27613*/ GIMT_Encode4(2078606), // Rule ID 15901 //
     /* 2078520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2078523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2078531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2078534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2078537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2078540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078566 */     // MIs[0] round
     /* 2078566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078569 */     // MIs[0] policy
     /* 2078569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078579 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2078582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078605 */     // GIR_Coverage, 15901,
     /* 2078605 */     GIR_EraseRootFromParent_Done,
     /* 2078606 */   // Label 27613: @2078606
     /* 2078606 */   GIM_Try, /*On fail goto*//*Label 27614*/ GIMT_Encode4(2078697), // Rule ID 15904 //
     /* 2078611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2078622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2078625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2078628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2078631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2078634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078657 */     // MIs[0] round
     /* 2078657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078660 */     // MIs[0] policy
     /* 2078660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078670 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2078673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078696 */     // GIR_Coverage, 15904,
     /* 2078696 */     GIR_EraseRootFromParent_Done,
     /* 2078697 */   // Label 27614: @2078697
     /* 2078697 */   GIM_Try, /*On fail goto*//*Label 27615*/ GIMT_Encode4(2078788), // Rule ID 15905 //
     /* 2078702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2078713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2078716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2078719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2078722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2078725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078748 */     // MIs[0] round
     /* 2078748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078751 */     // MIs[0] policy
     /* 2078751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078761 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2078764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078787 */     // GIR_Coverage, 15905,
     /* 2078787 */     GIR_EraseRootFromParent_Done,
     /* 2078788 */   // Label 27615: @2078788
     /* 2078788 */   GIM_Try, /*On fail goto*//*Label 27616*/ GIMT_Encode4(2078879), // Rule ID 15908 //
     /* 2078793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2078804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2078807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2078810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2078813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078839 */     // MIs[0] round
     /* 2078839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078842 */     // MIs[0] policy
     /* 2078842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078852 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2078855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078878 */     // GIR_Coverage, 15908,
     /* 2078878 */     GIR_EraseRootFromParent_Done,
     /* 2078879 */   // Label 27616: @2078879
     /* 2078879 */   GIM_Try, /*On fail goto*//*Label 27617*/ GIMT_Encode4(2078970), // Rule ID 15909 //
     /* 2078884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2078895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2078898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2078901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2078904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078930 */     // MIs[0] round
     /* 2078930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078933 */     // MIs[0] policy
     /* 2078933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078943 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2078946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078969 */     // GIR_Coverage, 15909,
     /* 2078969 */     GIR_EraseRootFromParent_Done,
     /* 2078970 */   // Label 27617: @2078970
     /* 2078970 */   GIM_Try, /*On fail goto*//*Label 27618*/ GIMT_Encode4(2079061), // Rule ID 15912 //
     /* 2078975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2078986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2078989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2078992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2078995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079021 */     // MIs[0] round
     /* 2079021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079024 */     // MIs[0] policy
     /* 2079024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079034 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079060 */     // GIR_Coverage, 15912,
     /* 2079060 */     GIR_EraseRootFromParent_Done,
     /* 2079061 */   // Label 27618: @2079061
     /* 2079061 */   GIM_Try, /*On fail goto*//*Label 27619*/ GIMT_Encode4(2079152), // Rule ID 15913 //
     /* 2079066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2079077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2079080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2079083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079112 */     // MIs[0] round
     /* 2079112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079115 */     // MIs[0] policy
     /* 2079115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079125 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079151 */     // GIR_Coverage, 15913,
     /* 2079151 */     GIR_EraseRootFromParent_Done,
     /* 2079152 */   // Label 27619: @2079152
     /* 2079152 */   GIM_Try, /*On fail goto*//*Label 27620*/ GIMT_Encode4(2079243), // Rule ID 15916 //
     /* 2079157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2079168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2079171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2079174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079203 */     // MIs[0] round
     /* 2079203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079206 */     // MIs[0] policy
     /* 2079206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079216 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2079219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079242 */     // GIR_Coverage, 15916,
     /* 2079242 */     GIR_EraseRootFromParent_Done,
     /* 2079243 */   // Label 27620: @2079243
     /* 2079243 */   GIM_Try, /*On fail goto*//*Label 27621*/ GIMT_Encode4(2079334), // Rule ID 15917 //
     /* 2079248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2079259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2079262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2079265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079294 */     // MIs[0] round
     /* 2079294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079297 */     // MIs[0] policy
     /* 2079297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079307 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2079310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079333 */     // GIR_Coverage, 15917,
     /* 2079333 */     GIR_EraseRootFromParent_Done,
     /* 2079334 */   // Label 27621: @2079334
     /* 2079334 */   GIM_Try, /*On fail goto*//*Label 27622*/ GIMT_Encode4(2079425), // Rule ID 15920 //
     /* 2079339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2079350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2079353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2079356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079385 */     // MIs[0] round
     /* 2079385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079388 */     // MIs[0] policy
     /* 2079388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079398 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079424 */     // GIR_Coverage, 15920,
     /* 2079424 */     GIR_EraseRootFromParent_Done,
     /* 2079425 */   // Label 27622: @2079425
     /* 2079425 */   GIM_Try, /*On fail goto*//*Label 27623*/ GIMT_Encode4(2079516), // Rule ID 15921 //
     /* 2079430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2079441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2079444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2079447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079476 */     // MIs[0] round
     /* 2079476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079479 */     // MIs[0] policy
     /* 2079479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079489 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079515 */     // GIR_Coverage, 15921,
     /* 2079515 */     GIR_EraseRootFromParent_Done,
     /* 2079516 */   // Label 27623: @2079516
     /* 2079516 */   GIM_Try, /*On fail goto*//*Label 27624*/ GIMT_Encode4(2079607), // Rule ID 15924 //
     /* 2079521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2079532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2079535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2079538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079567 */     // MIs[0] round
     /* 2079567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079570 */     // MIs[0] policy
     /* 2079570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079580 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2079603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079606 */     // GIR_Coverage, 15924,
     /* 2079606 */     GIR_EraseRootFromParent_Done,
     /* 2079607 */   // Label 27624: @2079607
     /* 2079607 */   GIM_Try, /*On fail goto*//*Label 27625*/ GIMT_Encode4(2079698), // Rule ID 15925 //
     /* 2079612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2079623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2079626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2079629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079658 */     // MIs[0] round
     /* 2079658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079661 */     // MIs[0] policy
     /* 2079661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079671 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2079694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079697 */     // GIR_Coverage, 15925,
     /* 2079697 */     GIR_EraseRootFromParent_Done,
     /* 2079698 */   // Label 27625: @2079698
     /* 2079698 */   GIM_Try, /*On fail goto*//*Label 27626*/ GIMT_Encode4(2079789), // Rule ID 15928 //
     /* 2079703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2079714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2079717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2079720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079749 */     // MIs[0] round
     /* 2079749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079752 */     // MIs[0] policy
     /* 2079752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079762 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2079765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079788 */     // GIR_Coverage, 15928,
     /* 2079788 */     GIR_EraseRootFromParent_Done,
     /* 2079789 */   // Label 27626: @2079789
     /* 2079789 */   GIM_Try, /*On fail goto*//*Label 27627*/ GIMT_Encode4(2079880), // Rule ID 15929 //
     /* 2079794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2079805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2079808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2079811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079840 */     // MIs[0] round
     /* 2079840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079843 */     // MIs[0] policy
     /* 2079843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079853 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2079856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079879 */     // GIR_Coverage, 15929,
     /* 2079879 */     GIR_EraseRootFromParent_Done,
     /* 2079880 */   // Label 27627: @2079880
     /* 2079880 */   GIM_Try, /*On fail goto*//*Label 27628*/ GIMT_Encode4(2079971), // Rule ID 15932 //
     /* 2079885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2079896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2079899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2079902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079931 */     // MIs[0] round
     /* 2079931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079934 */     // MIs[0] policy
     /* 2079934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079944 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2079947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079970 */     // GIR_Coverage, 15932,
     /* 2079970 */     GIR_EraseRootFromParent_Done,
     /* 2079971 */   // Label 27628: @2079971
     /* 2079971 */   GIM_Try, /*On fail goto*//*Label 27629*/ GIMT_Encode4(2080062), // Rule ID 15933 //
     /* 2079976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2079987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2079990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2079993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080022 */     // MIs[0] round
     /* 2080022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080025 */     // MIs[0] policy
     /* 2080025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080035 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080061 */     // GIR_Coverage, 15933,
     /* 2080061 */     GIR_EraseRootFromParent_Done,
     /* 2080062 */   // Label 27629: @2080062
     /* 2080062 */   GIM_Try, /*On fail goto*//*Label 27630*/ GIMT_Encode4(2080153), // Rule ID 15936 //
     /* 2080067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2080078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2080081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2080084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080113 */     // MIs[0] round
     /* 2080113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080116 */     // MIs[0] policy
     /* 2080116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080126 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080152 */     // GIR_Coverage, 15936,
     /* 2080152 */     GIR_EraseRootFromParent_Done,
     /* 2080153 */   // Label 27630: @2080153
     /* 2080153 */   GIM_Try, /*On fail goto*//*Label 27631*/ GIMT_Encode4(2080244), // Rule ID 15937 //
     /* 2080158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2080169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2080172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2080175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080204 */     // MIs[0] round
     /* 2080204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080207 */     // MIs[0] policy
     /* 2080207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080217 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080243 */     // GIR_Coverage, 15937,
     /* 2080243 */     GIR_EraseRootFromParent_Done,
     /* 2080244 */   // Label 27631: @2080244
     /* 2080244 */   GIM_Try, /*On fail goto*//*Label 27632*/ GIMT_Encode4(2080335), // Rule ID 15940 //
     /* 2080249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2080252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2080260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2080263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2080266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080295 */     // MIs[0] round
     /* 2080295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080298 */     // MIs[0] policy
     /* 2080298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080334 */     // GIR_Coverage, 15940,
     /* 2080334 */     GIR_EraseRootFromParent_Done,
     /* 2080335 */   // Label 27632: @2080335
     /* 2080335 */   GIM_Try, /*On fail goto*//*Label 27633*/ GIMT_Encode4(2080426), // Rule ID 15941 //
     /* 2080340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2080343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2080351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2080354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2080357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080386 */     // MIs[0] round
     /* 2080386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080389 */     // MIs[0] policy
     /* 2080389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080399 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080425 */     // GIR_Coverage, 15941,
     /* 2080425 */     GIR_EraseRootFromParent_Done,
     /* 2080426 */   // Label 27633: @2080426
     /* 2080426 */   GIM_Try, /*On fail goto*//*Label 27634*/ GIMT_Encode4(2080517), // Rule ID 15944 //
     /* 2080431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2080442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2080445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2080448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2080454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080477 */     // MIs[0] round
     /* 2080477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080480 */     // MIs[0] policy
     /* 2080480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080490 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2080493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080516 */     // GIR_Coverage, 15944,
     /* 2080516 */     GIR_EraseRootFromParent_Done,
     /* 2080517 */   // Label 27634: @2080517
     /* 2080517 */   GIM_Try, /*On fail goto*//*Label 27635*/ GIMT_Encode4(2080608), // Rule ID 15945 //
     /* 2080522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2080533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2080536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2080539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2080545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080568 */     // MIs[0] round
     /* 2080568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080571 */     // MIs[0] policy
     /* 2080571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080581 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2080584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080607 */     // GIR_Coverage, 15945,
     /* 2080607 */     GIR_EraseRootFromParent_Done,
     /* 2080608 */   // Label 27635: @2080608
     /* 2080608 */   GIM_Try, /*On fail goto*//*Label 27636*/ GIMT_Encode4(2080699), // Rule ID 15948 //
     /* 2080613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2080624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2080627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2080630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2080636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2080643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080659 */     // MIs[0] round
     /* 2080659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080662 */     // MIs[0] policy
     /* 2080662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080672 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2080675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080698 */     // GIR_Coverage, 15948,
     /* 2080698 */     GIR_EraseRootFromParent_Done,
     /* 2080699 */   // Label 27636: @2080699
     /* 2080699 */   GIM_Try, /*On fail goto*//*Label 27637*/ GIMT_Encode4(2080790), // Rule ID 15949 //
     /* 2080704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2080715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2080718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2080721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2080727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2080734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080750 */     // MIs[0] round
     /* 2080750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080753 */     // MIs[0] policy
     /* 2080753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080763 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2080766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080789 */     // GIR_Coverage, 15949,
     /* 2080789 */     GIR_EraseRootFromParent_Done,
     /* 2080790 */   // Label 27637: @2080790
     /* 2080790 */   GIM_Try, /*On fail goto*//*Label 27638*/ GIMT_Encode4(2080881), // Rule ID 15952 //
     /* 2080795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2080806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2080809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2080812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2080818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2080825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080841 */     // MIs[0] round
     /* 2080841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080844 */     // MIs[0] policy
     /* 2080844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080854 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2080857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080880 */     // GIR_Coverage, 15952,
     /* 2080880 */     GIR_EraseRootFromParent_Done,
     /* 2080881 */   // Label 27638: @2080881
     /* 2080881 */   GIM_Try, /*On fail goto*//*Label 27639*/ GIMT_Encode4(2080972), // Rule ID 15953 //
     /* 2080886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2080897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2080900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2080903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2080909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2080916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080932 */     // MIs[0] round
     /* 2080932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080935 */     // MIs[0] policy
     /* 2080935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080945 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2080948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080971 */     // GIR_Coverage, 15953,
     /* 2080971 */     GIR_EraseRootFromParent_Done,
     /* 2080972 */   // Label 27639: @2080972
     /* 2080972 */   GIM_Try, /*On fail goto*//*Label 27640*/ GIMT_Encode4(2081063), // Rule ID 15956 //
     /* 2080977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2080988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2080991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2080994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081023 */     // MIs[0] round
     /* 2081023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081026 */     // MIs[0] policy
     /* 2081026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081036 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081062 */     // GIR_Coverage, 15956,
     /* 2081062 */     GIR_EraseRootFromParent_Done,
     /* 2081063 */   // Label 27640: @2081063
     /* 2081063 */   GIM_Try, /*On fail goto*//*Label 27641*/ GIMT_Encode4(2081154), // Rule ID 15957 //
     /* 2081068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2081079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2081082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2081085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081114 */     // MIs[0] round
     /* 2081114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081117 */     // MIs[0] policy
     /* 2081117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081127 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081153 */     // GIR_Coverage, 15957,
     /* 2081153 */     GIR_EraseRootFromParent_Done,
     /* 2081154 */   // Label 27641: @2081154
     /* 2081154 */   GIM_Try, /*On fail goto*//*Label 27642*/ GIMT_Encode4(2081245), // Rule ID 15960 //
     /* 2081159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2081170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2081173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2081176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081205 */     // MIs[0] round
     /* 2081205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081208 */     // MIs[0] policy
     /* 2081208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081244 */     // GIR_Coverage, 15960,
     /* 2081244 */     GIR_EraseRootFromParent_Done,
     /* 2081245 */   // Label 27642: @2081245
     /* 2081245 */   GIM_Try, /*On fail goto*//*Label 27643*/ GIMT_Encode4(2081336), // Rule ID 15961 //
     /* 2081250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2081261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2081264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2081267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081296 */     // MIs[0] round
     /* 2081296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081299 */     // MIs[0] policy
     /* 2081299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081309 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081335 */     // GIR_Coverage, 15961,
     /* 2081335 */     GIR_EraseRootFromParent_Done,
     /* 2081336 */   // Label 27643: @2081336
     /* 2081336 */   GIM_Try, /*On fail goto*//*Label 27644*/ GIMT_Encode4(2081427), // Rule ID 15964 //
     /* 2081341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2081352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2081355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2081358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081387 */     // MIs[0] round
     /* 2081387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081390 */     // MIs[0] policy
     /* 2081390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081400 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081426 */     // GIR_Coverage, 15964,
     /* 2081426 */     GIR_EraseRootFromParent_Done,
     /* 2081427 */   // Label 27644: @2081427
     /* 2081427 */   GIM_Try, /*On fail goto*//*Label 27645*/ GIMT_Encode4(2081518), // Rule ID 15965 //
     /* 2081432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2081443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2081446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2081449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081478 */     // MIs[0] round
     /* 2081478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081481 */     // MIs[0] policy
     /* 2081481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081491 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081517 */     // GIR_Coverage, 15965,
     /* 2081517 */     GIR_EraseRootFromParent_Done,
     /* 2081518 */   // Label 27645: @2081518
     /* 2081518 */   GIM_Try, /*On fail goto*//*Label 27646*/ GIMT_Encode4(2081609), // Rule ID 15968 //
     /* 2081523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2081534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2081537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2081540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2081546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081569 */     // MIs[0] round
     /* 2081569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081572 */     // MIs[0] policy
     /* 2081572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081608 */     // GIR_Coverage, 15968,
     /* 2081608 */     GIR_EraseRootFromParent_Done,
     /* 2081609 */   // Label 27646: @2081609
     /* 2081609 */   GIM_Try, /*On fail goto*//*Label 27647*/ GIMT_Encode4(2081700), // Rule ID 15969 //
     /* 2081614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2081625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2081628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2081631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2081637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081660 */     // MIs[0] round
     /* 2081660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081663 */     // MIs[0] policy
     /* 2081663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081673 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081699 */     // GIR_Coverage, 15969,
     /* 2081699 */     GIR_EraseRootFromParent_Done,
     /* 2081700 */   // Label 27647: @2081700
     /* 2081700 */   GIM_Try, /*On fail goto*//*Label 27648*/ GIMT_Encode4(2081791), // Rule ID 15972 //
     /* 2081705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2081716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2081719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2081722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081751 */     // MIs[0] round
     /* 2081751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081754 */     // MIs[0] policy
     /* 2081754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081764 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081790 */     // GIR_Coverage, 15972,
     /* 2081790 */     GIR_EraseRootFromParent_Done,
     /* 2081791 */   // Label 27648: @2081791
     /* 2081791 */   GIM_Try, /*On fail goto*//*Label 27649*/ GIMT_Encode4(2081882), // Rule ID 15973 //
     /* 2081796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2081807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2081810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2081813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081842 */     // MIs[0] round
     /* 2081842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081845 */     // MIs[0] policy
     /* 2081845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081855 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081881 */     // GIR_Coverage, 15973,
     /* 2081881 */     GIR_EraseRootFromParent_Done,
     /* 2081882 */   // Label 27649: @2081882
     /* 2081882 */   GIM_Try, /*On fail goto*//*Label 27650*/ GIMT_Encode4(2081973), // Rule ID 15976 //
     /* 2081887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2081898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2081901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2081904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081933 */     // MIs[0] round
     /* 2081933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081936 */     // MIs[0] policy
     /* 2081936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081946 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081972 */     // GIR_Coverage, 15976,
     /* 2081972 */     GIR_EraseRootFromParent_Done,
     /* 2081973 */   // Label 27650: @2081973
     /* 2081973 */   GIM_Try, /*On fail goto*//*Label 27651*/ GIMT_Encode4(2082064), // Rule ID 15977 //
     /* 2081978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2081989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2081992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2081995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2082001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082024 */     // MIs[0] round
     /* 2082024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082027 */     // MIs[0] policy
     /* 2082027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082037 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2082040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082063 */     // GIR_Coverage, 15977,
     /* 2082063 */     GIR_EraseRootFromParent_Done,
     /* 2082064 */   // Label 27651: @2082064
     /* 2082064 */   GIM_Try, /*On fail goto*//*Label 27652*/ GIMT_Encode4(2082155), // Rule ID 15980 //
     /* 2082069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2082080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2082083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2082086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082115 */     // MIs[0] round
     /* 2082115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082118 */     // MIs[0] policy
     /* 2082118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082128 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2082131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082154 */     // GIR_Coverage, 15980,
     /* 2082154 */     GIR_EraseRootFromParent_Done,
     /* 2082155 */   // Label 27652: @2082155
     /* 2082155 */   GIM_Try, /*On fail goto*//*Label 27653*/ GIMT_Encode4(2082246), // Rule ID 15981 //
     /* 2082160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2082171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2082174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2082177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082206 */     // MIs[0] round
     /* 2082206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082209 */     // MIs[0] policy
     /* 2082209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2082222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082245 */     // GIR_Coverage, 15981,
     /* 2082245 */     GIR_EraseRootFromParent_Done,
     /* 2082246 */   // Label 27653: @2082246
     /* 2082246 */   GIM_Try, /*On fail goto*//*Label 27654*/ GIMT_Encode4(2082337), // Rule ID 15984 //
     /* 2082251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2082262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2082265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2082268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082297 */     // MIs[0] round
     /* 2082297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082300 */     // MIs[0] policy
     /* 2082300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082310 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2082313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082336 */     // GIR_Coverage, 15984,
     /* 2082336 */     GIR_EraseRootFromParent_Done,
     /* 2082337 */   // Label 27654: @2082337
     /* 2082337 */   GIM_Try, /*On fail goto*//*Label 27655*/ GIMT_Encode4(2082428), // Rule ID 15985 //
     /* 2082342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2082353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2082356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2082359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082388 */     // MIs[0] round
     /* 2082388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082391 */     // MIs[0] policy
     /* 2082391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082401 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2082404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082427 */     // GIR_Coverage, 15985,
     /* 2082427 */     GIR_EraseRootFromParent_Done,
     /* 2082428 */   // Label 27655: @2082428
     /* 2082428 */   GIM_Try, /*On fail goto*//*Label 27656*/ GIMT_Encode4(2082519), // Rule ID 15988 //
     /* 2082433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2082444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2082447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2082450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082479 */     // MIs[0] round
     /* 2082479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082482 */     // MIs[0] policy
     /* 2082482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082492 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2082495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082518 */     // GIR_Coverage, 15988,
     /* 2082518 */     GIR_EraseRootFromParent_Done,
     /* 2082519 */   // Label 27656: @2082519
     /* 2082519 */   GIM_Try, /*On fail goto*//*Label 27657*/ GIMT_Encode4(2082610), // Rule ID 15989 //
     /* 2082524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2082535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2082538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2082541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082570 */     // MIs[0] round
     /* 2082570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082573 */     // MIs[0] policy
     /* 2082573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082583 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2082586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082609 */     // GIR_Coverage, 15989,
     /* 2082609 */     GIR_EraseRootFromParent_Done,
     /* 2082610 */   // Label 27657: @2082610
     /* 2082610 */   GIM_Try, /*On fail goto*//*Label 27658*/ GIMT_Encode4(2082701), // Rule ID 16080 //
     /* 2082615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2082626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2082629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2082632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2082635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2082638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082661 */     // MIs[0] round
     /* 2082661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082664 */     // MIs[0] policy
     /* 2082664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082674 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2082677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082700 */     // GIR_Coverage, 16080,
     /* 2082700 */     GIR_EraseRootFromParent_Done,
     /* 2082701 */   // Label 27658: @2082701
     /* 2082701 */   GIM_Try, /*On fail goto*//*Label 27659*/ GIMT_Encode4(2082792), // Rule ID 16081 //
     /* 2082706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2082717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2082720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2082723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2082726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2082729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082752 */     // MIs[0] round
     /* 2082752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082755 */     // MIs[0] policy
     /* 2082755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082765 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2082768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082791 */     // GIR_Coverage, 16081,
     /* 2082791 */     GIR_EraseRootFromParent_Done,
     /* 2082792 */   // Label 27659: @2082792
     /* 2082792 */   GIM_Try, /*On fail goto*//*Label 27660*/ GIMT_Encode4(2082883), // Rule ID 16084 //
     /* 2082797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2082808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2082811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2082814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2082817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082843 */     // MIs[0] round
     /* 2082843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082846 */     // MIs[0] policy
     /* 2082846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082856 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2082859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082882 */     // GIR_Coverage, 16084,
     /* 2082882 */     GIR_EraseRootFromParent_Done,
     /* 2082883 */   // Label 27660: @2082883
     /* 2082883 */   GIM_Try, /*On fail goto*//*Label 27661*/ GIMT_Encode4(2082974), // Rule ID 16085 //
     /* 2082888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2082899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2082902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2082905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2082908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082934 */     // MIs[0] round
     /* 2082934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082937 */     // MIs[0] policy
     /* 2082937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082947 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2082950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082973 */     // GIR_Coverage, 16085,
     /* 2082973 */     GIR_EraseRootFromParent_Done,
     /* 2082974 */   // Label 27661: @2082974
     /* 2082974 */   GIM_Try, /*On fail goto*//*Label 27662*/ GIMT_Encode4(2083065), // Rule ID 16088 //
     /* 2082979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2082990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2082993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2082996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2082999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083025 */     // MIs[0] round
     /* 2083025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083028 */     // MIs[0] policy
     /* 2083028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083038 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083064 */     // GIR_Coverage, 16088,
     /* 2083064 */     GIR_EraseRootFromParent_Done,
     /* 2083065 */   // Label 27662: @2083065
     /* 2083065 */   GIM_Try, /*On fail goto*//*Label 27663*/ GIMT_Encode4(2083156), // Rule ID 16089 //
     /* 2083070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2083081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2083084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2083087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2083090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083116 */     // MIs[0] round
     /* 2083116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083119 */     // MIs[0] policy
     /* 2083119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083129 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083155 */     // GIR_Coverage, 16089,
     /* 2083155 */     GIR_EraseRootFromParent_Done,
     /* 2083156 */   // Label 27663: @2083156
     /* 2083156 */   GIM_Try, /*On fail goto*//*Label 27664*/ GIMT_Encode4(2083247), // Rule ID 16092 //
     /* 2083161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2083172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2083175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2083181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083207 */     // MIs[0] round
     /* 2083207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083210 */     // MIs[0] policy
     /* 2083210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083220 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2083223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083246 */     // GIR_Coverage, 16092,
     /* 2083246 */     GIR_EraseRootFromParent_Done,
     /* 2083247 */   // Label 27664: @2083247
     /* 2083247 */   GIM_Try, /*On fail goto*//*Label 27665*/ GIMT_Encode4(2083338), // Rule ID 16093 //
     /* 2083252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2083263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2083266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2083272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083298 */     // MIs[0] round
     /* 2083298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083301 */     // MIs[0] policy
     /* 2083301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083311 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2083314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083337 */     // GIR_Coverage, 16093,
     /* 2083337 */     GIR_EraseRootFromParent_Done,
     /* 2083338 */   // Label 27665: @2083338
     /* 2083338 */   GIM_Try, /*On fail goto*//*Label 27666*/ GIMT_Encode4(2083429), // Rule ID 16096 //
     /* 2083343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2083354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2083357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2083360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2083363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083389 */     // MIs[0] round
     /* 2083389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083392 */     // MIs[0] policy
     /* 2083392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083402 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083428 */     // GIR_Coverage, 16096,
     /* 2083428 */     GIR_EraseRootFromParent_Done,
     /* 2083429 */   // Label 27666: @2083429
     /* 2083429 */   GIM_Try, /*On fail goto*//*Label 27667*/ GIMT_Encode4(2083520), // Rule ID 16097 //
     /* 2083434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2083445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2083448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2083451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2083454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083480 */     // MIs[0] round
     /* 2083480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083483 */     // MIs[0] policy
     /* 2083483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083519 */     // GIR_Coverage, 16097,
     /* 2083519 */     GIR_EraseRootFromParent_Done,
     /* 2083520 */   // Label 27667: @2083520
     /* 2083520 */   GIM_Try, /*On fail goto*//*Label 27668*/ GIMT_Encode4(2083611), // Rule ID 16100 //
     /* 2083525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2083536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2083539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2083542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2083545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083571 */     // MIs[0] round
     /* 2083571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083574 */     // MIs[0] policy
     /* 2083574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083584 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2083607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083610 */     // GIR_Coverage, 16100,
     /* 2083610 */     GIR_EraseRootFromParent_Done,
     /* 2083611 */   // Label 27668: @2083611
     /* 2083611 */   GIM_Try, /*On fail goto*//*Label 27669*/ GIMT_Encode4(2083702), // Rule ID 16101 //
     /* 2083616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2083627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2083630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2083633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2083636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083662 */     // MIs[0] round
     /* 2083662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083665 */     // MIs[0] policy
     /* 2083665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083675 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2083698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083701 */     // GIR_Coverage, 16101,
     /* 2083701 */     GIR_EraseRootFromParent_Done,
     /* 2083702 */   // Label 27669: @2083702
     /* 2083702 */   GIM_Try, /*On fail goto*//*Label 27670*/ GIMT_Encode4(2083793), // Rule ID 16104 //
     /* 2083707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2083718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2083721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2083724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2083727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2083730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083753 */     // MIs[0] round
     /* 2083753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083756 */     // MIs[0] policy
     /* 2083756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083766 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2083769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083792 */     // GIR_Coverage, 16104,
     /* 2083792 */     GIR_EraseRootFromParent_Done,
     /* 2083793 */   // Label 27670: @2083793
     /* 2083793 */   GIM_Try, /*On fail goto*//*Label 27671*/ GIMT_Encode4(2083884), // Rule ID 16105 //
     /* 2083798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2083809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2083812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2083815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2083818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2083821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083844 */     // MIs[0] round
     /* 2083844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083847 */     // MIs[0] policy
     /* 2083847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083857 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2083860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083883 */     // GIR_Coverage, 16105,
     /* 2083883 */     GIR_EraseRootFromParent_Done,
     /* 2083884 */   // Label 27671: @2083884
     /* 2083884 */   GIM_Try, /*On fail goto*//*Label 27672*/ GIMT_Encode4(2083975), // Rule ID 16108 //
     /* 2083889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2083900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2083903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2083906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2083909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083935 */     // MIs[0] round
     /* 2083935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083938 */     // MIs[0] policy
     /* 2083938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083948 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2083951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083974 */     // GIR_Coverage, 16108,
     /* 2083974 */     GIR_EraseRootFromParent_Done,
     /* 2083975 */   // Label 27672: @2083975
     /* 2083975 */   GIM_Try, /*On fail goto*//*Label 27673*/ GIMT_Encode4(2084066), // Rule ID 16109 //
     /* 2083980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2083991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2083994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2083997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2084000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2084003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084026 */     // MIs[0] round
     /* 2084026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084029 */     // MIs[0] policy
     /* 2084029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084039 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084065 */     // GIR_Coverage, 16109,
     /* 2084065 */     GIR_EraseRootFromParent_Done,
     /* 2084066 */   // Label 27673: @2084066
     /* 2084066 */   GIM_Try, /*On fail goto*//*Label 27674*/ GIMT_Encode4(2084157), // Rule ID 16112 //
     /* 2084071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2084082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2084085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2084088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2084091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084117 */     // MIs[0] round
     /* 2084117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084120 */     // MIs[0] policy
     /* 2084120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084156 */     // GIR_Coverage, 16112,
     /* 2084156 */     GIR_EraseRootFromParent_Done,
     /* 2084157 */   // Label 27674: @2084157
     /* 2084157 */   GIM_Try, /*On fail goto*//*Label 27675*/ GIMT_Encode4(2084248), // Rule ID 16113 //
     /* 2084162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2084173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2084176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2084179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2084182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084208 */     // MIs[0] round
     /* 2084208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084211 */     // MIs[0] policy
     /* 2084211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084221 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084247 */     // GIR_Coverage, 16113,
     /* 2084247 */     GIR_EraseRootFromParent_Done,
     /* 2084248 */   // Label 27675: @2084248
     /* 2084248 */   GIM_Try, /*On fail goto*//*Label 27676*/ GIMT_Encode4(2084339), // Rule ID 16116 //
     /* 2084253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2084256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2084264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2084267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2084270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2084273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084299 */     // MIs[0] round
     /* 2084299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084302 */     // MIs[0] policy
     /* 2084302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084312 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2084335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084338 */     // GIR_Coverage, 16116,
     /* 2084338 */     GIR_EraseRootFromParent_Done,
     /* 2084339 */   // Label 27676: @2084339
     /* 2084339 */   GIM_Try, /*On fail goto*//*Label 27677*/ GIMT_Encode4(2084430), // Rule ID 16117 //
     /* 2084344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2084347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2084355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2084358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2084361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2084364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084390 */     // MIs[0] round
     /* 2084390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084393 */     // MIs[0] policy
     /* 2084393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084403 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2084426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084429 */     // GIR_Coverage, 16117,
     /* 2084429 */     GIR_EraseRootFromParent_Done,
     /* 2084430 */   // Label 27677: @2084430
     /* 2084430 */   GIM_Try, /*On fail goto*//*Label 27678*/ GIMT_Encode4(2084521), // Rule ID 16120 //
     /* 2084435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2084446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2084449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2084452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2084455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084481 */     // MIs[0] round
     /* 2084481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084484 */     // MIs[0] policy
     /* 2084484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084494 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2084497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084520 */     // GIR_Coverage, 16120,
     /* 2084520 */     GIR_EraseRootFromParent_Done,
     /* 2084521 */   // Label 27678: @2084521
     /* 2084521 */   GIM_Try, /*On fail goto*//*Label 27679*/ GIMT_Encode4(2084612), // Rule ID 16121 //
     /* 2084526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2084537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2084540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2084543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2084546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084572 */     // MIs[0] round
     /* 2084572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084575 */     // MIs[0] policy
     /* 2084575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084585 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2084588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084611 */     // GIR_Coverage, 16121,
     /* 2084611 */     GIR_EraseRootFromParent_Done,
     /* 2084612 */   // Label 27679: @2084612
     /* 2084612 */   GIM_Try, /*On fail goto*//*Label 27680*/ GIMT_Encode4(2084703), // Rule ID 16124 //
     /* 2084617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2084628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2084631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2084634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2084637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2084640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084663 */     // MIs[0] round
     /* 2084663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084666 */     // MIs[0] policy
     /* 2084666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084676 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2084679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084702 */     // GIR_Coverage, 16124,
     /* 2084702 */     GIR_EraseRootFromParent_Done,
     /* 2084703 */   // Label 27680: @2084703
     /* 2084703 */   GIM_Try, /*On fail goto*//*Label 27681*/ GIMT_Encode4(2084794), // Rule ID 16125 //
     /* 2084708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2084719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2084722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2084725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2084728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2084731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084754 */     // MIs[0] round
     /* 2084754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084757 */     // MIs[0] policy
     /* 2084757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084767 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2084770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084793 */     // GIR_Coverage, 16125,
     /* 2084793 */     GIR_EraseRootFromParent_Done,
     /* 2084794 */   // Label 27681: @2084794
     /* 2084794 */   GIM_Try, /*On fail goto*//*Label 27682*/ GIMT_Encode4(2084885), // Rule ID 16128 //
     /* 2084799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2084810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2084813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2084816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2084819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2084822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2084829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084845 */     // MIs[0] round
     /* 2084845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084848 */     // MIs[0] policy
     /* 2084848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084858 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2084861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084884 */     // GIR_Coverage, 16128,
     /* 2084884 */     GIR_EraseRootFromParent_Done,
     /* 2084885 */   // Label 27682: @2084885
     /* 2084885 */   GIM_Try, /*On fail goto*//*Label 27683*/ GIMT_Encode4(2084976), // Rule ID 16129 //
     /* 2084890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2084901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2084904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2084907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2084910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2084913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2084920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084936 */     // MIs[0] round
     /* 2084936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084939 */     // MIs[0] policy
     /* 2084939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084949 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2084952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084975 */     // GIR_Coverage, 16129,
     /* 2084975 */     GIR_EraseRootFromParent_Done,
     /* 2084976 */   // Label 27683: @2084976
     /* 2084976 */   GIM_Try, /*On fail goto*//*Label 27684*/ GIMT_Encode4(2085067), // Rule ID 16132 //
     /* 2084981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2084992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2084995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2084998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2085001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085027 */     // MIs[0] round
     /* 2085027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085030 */     // MIs[0] policy
     /* 2085030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085040 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085066 */     // GIR_Coverage, 16132,
     /* 2085066 */     GIR_EraseRootFromParent_Done,
     /* 2085067 */   // Label 27684: @2085067
     /* 2085067 */   GIM_Try, /*On fail goto*//*Label 27685*/ GIMT_Encode4(2085158), // Rule ID 16133 //
     /* 2085072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2085083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2085086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2085089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2085092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085118 */     // MIs[0] round
     /* 2085118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085121 */     // MIs[0] policy
     /* 2085121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085131 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085157 */     // GIR_Coverage, 16133,
     /* 2085157 */     GIR_EraseRootFromParent_Done,
     /* 2085158 */   // Label 27685: @2085158
     /* 2085158 */   GIM_Try, /*On fail goto*//*Label 27686*/ GIMT_Encode4(2085249), // Rule ID 16136 //
     /* 2085163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2085174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2085177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2085180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2085183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085209 */     // MIs[0] round
     /* 2085209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085212 */     // MIs[0] policy
     /* 2085212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085222 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085248 */     // GIR_Coverage, 16136,
     /* 2085248 */     GIR_EraseRootFromParent_Done,
     /* 2085249 */   // Label 27686: @2085249
     /* 2085249 */   GIM_Try, /*On fail goto*//*Label 27687*/ GIMT_Encode4(2085340), // Rule ID 16137 //
     /* 2085254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2085265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2085268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2085271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2085274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085300 */     // MIs[0] round
     /* 2085300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085303 */     // MIs[0] policy
     /* 2085303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085313 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085339 */     // GIR_Coverage, 16137,
     /* 2085339 */     GIR_EraseRootFromParent_Done,
     /* 2085340 */   // Label 27687: @2085340
     /* 2085340 */   GIM_Try, /*On fail goto*//*Label 27688*/ GIMT_Encode4(2085431), // Rule ID 16140 //
     /* 2085345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2085356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2085359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2085362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2085365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085391 */     // MIs[0] round
     /* 2085391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085394 */     // MIs[0] policy
     /* 2085394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085404 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085430 */     // GIR_Coverage, 16140,
     /* 2085430 */     GIR_EraseRootFromParent_Done,
     /* 2085431 */   // Label 27688: @2085431
     /* 2085431 */   GIM_Try, /*On fail goto*//*Label 27689*/ GIMT_Encode4(2085522), // Rule ID 16141 //
     /* 2085436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2085447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2085450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2085453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2085456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085482 */     // MIs[0] round
     /* 2085482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085485 */     // MIs[0] policy
     /* 2085485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085495 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085521 */     // GIR_Coverage, 16141,
     /* 2085521 */     GIR_EraseRootFromParent_Done,
     /* 2085522 */   // Label 27689: @2085522
     /* 2085522 */   GIM_Try, /*On fail goto*//*Label 27690*/ GIMT_Encode4(2085613), // Rule ID 16144 //
     /* 2085527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2085538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2085541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2085544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2085547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085573 */     // MIs[0] round
     /* 2085573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085576 */     // MIs[0] policy
     /* 2085576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085612 */     // GIR_Coverage, 16144,
     /* 2085612 */     GIR_EraseRootFromParent_Done,
     /* 2085613 */   // Label 27690: @2085613
     /* 2085613 */   GIM_Try, /*On fail goto*//*Label 27691*/ GIMT_Encode4(2085704), // Rule ID 16145 //
     /* 2085618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2085629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2085632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2085635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2085638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085664 */     // MIs[0] round
     /* 2085664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085667 */     // MIs[0] policy
     /* 2085667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085677 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085703 */     // GIR_Coverage, 16145,
     /* 2085703 */     GIR_EraseRootFromParent_Done,
     /* 2085704 */   // Label 27691: @2085704
     /* 2085704 */   GIM_Try, /*On fail goto*//*Label 27692*/ GIMT_Encode4(2085795), // Rule ID 16148 //
     /* 2085709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2085720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2085723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2085726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2085729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085755 */     // MIs[0] round
     /* 2085755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085758 */     // MIs[0] policy
     /* 2085758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085794 */     // GIR_Coverage, 16148,
     /* 2085794 */     GIR_EraseRootFromParent_Done,
     /* 2085795 */   // Label 27692: @2085795
     /* 2085795 */   GIM_Try, /*On fail goto*//*Label 27693*/ GIMT_Encode4(2085886), // Rule ID 16149 //
     /* 2085800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2085811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2085814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2085817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2085820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085846 */     // MIs[0] round
     /* 2085846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085849 */     // MIs[0] policy
     /* 2085849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085859 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085885 */     // GIR_Coverage, 16149,
     /* 2085885 */     GIR_EraseRootFromParent_Done,
     /* 2085886 */   // Label 27693: @2085886
     /* 2085886 */   GIM_Try, /*On fail goto*//*Label 27694*/ GIMT_Encode4(2085977), // Rule ID 16152 //
     /* 2085891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2085902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2085905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2085908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2085911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085937 */     // MIs[0] round
     /* 2085937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085940 */     // MIs[0] policy
     /* 2085940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085950 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085976 */     // GIR_Coverage, 16152,
     /* 2085976 */     GIR_EraseRootFromParent_Done,
     /* 2085977 */   // Label 27694: @2085977
     /* 2085977 */   GIM_Try, /*On fail goto*//*Label 27695*/ GIMT_Encode4(2086068), // Rule ID 16153 //
     /* 2085982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2085993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2085996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2085999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2086002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2086005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086028 */     // MIs[0] round
     /* 2086028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086031 */     // MIs[0] policy
     /* 2086031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086041 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2086044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086067 */     // GIR_Coverage, 16153,
     /* 2086067 */     GIR_EraseRootFromParent_Done,
     /* 2086068 */   // Label 27695: @2086068
     /* 2086068 */   GIM_Try, /*On fail goto*//*Label 27696*/ GIMT_Encode4(2086159), // Rule ID 16156 //
     /* 2086073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2086084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2086087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2086090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2086093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086119 */     // MIs[0] round
     /* 2086119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086122 */     // MIs[0] policy
     /* 2086122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2086135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086158 */     // GIR_Coverage, 16156,
     /* 2086158 */     GIR_EraseRootFromParent_Done,
     /* 2086159 */   // Label 27696: @2086159
     /* 2086159 */   GIM_Try, /*On fail goto*//*Label 27697*/ GIMT_Encode4(2086250), // Rule ID 16157 //
     /* 2086164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2086175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2086178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2086181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2086184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086210 */     // MIs[0] round
     /* 2086210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086213 */     // MIs[0] policy
     /* 2086213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086223 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2086226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086249 */     // GIR_Coverage, 16157,
     /* 2086249 */     GIR_EraseRootFromParent_Done,
     /* 2086250 */   // Label 27697: @2086250
     /* 2086250 */   GIM_Try, /*On fail goto*//*Label 27698*/ GIMT_Encode4(2086341), // Rule ID 16160 //
     /* 2086255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2086266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2086269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2086272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2086275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086301 */     // MIs[0] round
     /* 2086301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086304 */     // MIs[0] policy
     /* 2086304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086314 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2086317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086340 */     // GIR_Coverage, 16160,
     /* 2086340 */     GIR_EraseRootFromParent_Done,
     /* 2086341 */   // Label 27698: @2086341
     /* 2086341 */   GIM_Try, /*On fail goto*//*Label 27699*/ GIMT_Encode4(2086432), // Rule ID 16161 //
     /* 2086346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2086357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2086360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2086363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2086366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086392 */     // MIs[0] round
     /* 2086392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086395 */     // MIs[0] policy
     /* 2086395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086405 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2086408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086431 */     // GIR_Coverage, 16161,
     /* 2086431 */     GIR_EraseRootFromParent_Done,
     /* 2086432 */   // Label 27699: @2086432
     /* 2086432 */   GIM_Try, /*On fail goto*//*Label 27700*/ GIMT_Encode4(2086523), // Rule ID 16164 //
     /* 2086437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2086448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2086451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2086454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2086457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086483 */     // MIs[0] round
     /* 2086483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086486 */     // MIs[0] policy
     /* 2086486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086496 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2086499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086522 */     // GIR_Coverage, 16164,
     /* 2086522 */     GIR_EraseRootFromParent_Done,
     /* 2086523 */   // Label 27700: @2086523
     /* 2086523 */   GIM_Try, /*On fail goto*//*Label 27701*/ GIMT_Encode4(2086614), // Rule ID 16165 //
     /* 2086528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2086539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2086542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2086545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2086548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086574 */     // MIs[0] round
     /* 2086574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086577 */     // MIs[0] policy
     /* 2086577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086587 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2086590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086613 */     // GIR_Coverage, 16165,
     /* 2086613 */     GIR_EraseRootFromParent_Done,
     /* 2086614 */   // Label 27701: @2086614
     /* 2086614 */   GIM_Try, /*On fail goto*//*Label 27702*/ GIMT_Encode4(2086705), // Rule ID 16168 //
     /* 2086619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2086630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2086633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2086636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2086639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2086642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086665 */     // MIs[0] round
     /* 2086665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086668 */     // MIs[0] policy
     /* 2086668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086678 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2086681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086704 */     // GIR_Coverage, 16168,
     /* 2086704 */     GIR_EraseRootFromParent_Done,
     /* 2086705 */   // Label 27702: @2086705
     /* 2086705 */   GIM_Try, /*On fail goto*//*Label 27703*/ GIMT_Encode4(2086796), // Rule ID 16169 //
     /* 2086710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2086721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2086724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2086727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2086730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2086733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086756 */     // MIs[0] round
     /* 2086756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086759 */     // MIs[0] policy
     /* 2086759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086769 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2086772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086795 */     // GIR_Coverage, 16169,
     /* 2086795 */     GIR_EraseRootFromParent_Done,
     /* 2086796 */   // Label 27703: @2086796
     /* 2086796 */   GIM_Try, /*On fail goto*//*Label 27704*/ GIMT_Encode4(2086887), // Rule ID 16172 //
     /* 2086801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2086812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2086815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2086818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2086821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086847 */     // MIs[0] round
     /* 2086847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086850 */     // MIs[0] policy
     /* 2086850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086860 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2086863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086886 */     // GIR_Coverage, 16172,
     /* 2086886 */     GIR_EraseRootFromParent_Done,
     /* 2086887 */   // Label 27704: @2086887
     /* 2086887 */   GIM_Try, /*On fail goto*//*Label 27705*/ GIMT_Encode4(2086978), // Rule ID 16173 //
     /* 2086892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2086903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2086906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2086909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2086912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086938 */     // MIs[0] round
     /* 2086938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086941 */     // MIs[0] policy
     /* 2086941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086951 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2086954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086977 */     // GIR_Coverage, 16173,
     /* 2086977 */     GIR_EraseRootFromParent_Done,
     /* 2086978 */   // Label 27705: @2086978
     /* 2086978 */   GIM_Try, /*On fail goto*//*Label 27706*/ GIMT_Encode4(2087069), // Rule ID 16176 //
     /* 2086983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2086994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2086997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2087000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087029 */     // MIs[0] round
     /* 2087029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087032 */     // MIs[0] policy
     /* 2087032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087042 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087068 */     // GIR_Coverage, 16176,
     /* 2087068 */     GIR_EraseRootFromParent_Done,
     /* 2087069 */   // Label 27706: @2087069
     /* 2087069 */   GIM_Try, /*On fail goto*//*Label 27707*/ GIMT_Encode4(2087160), // Rule ID 16177 //
     /* 2087074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2087085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2087088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2087091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087120 */     // MIs[0] round
     /* 2087120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087123 */     // MIs[0] policy
     /* 2087123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087133 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087159 */     // GIR_Coverage, 16177,
     /* 2087159 */     GIR_EraseRootFromParent_Done,
     /* 2087160 */   // Label 27707: @2087160
     /* 2087160 */   GIM_Try, /*On fail goto*//*Label 27708*/ GIMT_Encode4(2087251), // Rule ID 16180 //
     /* 2087165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2087176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2087179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087211 */     // MIs[0] round
     /* 2087211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087214 */     // MIs[0] policy
     /* 2087214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087224 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2087227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087250 */     // GIR_Coverage, 16180,
     /* 2087250 */     GIR_EraseRootFromParent_Done,
     /* 2087251 */   // Label 27708: @2087251
     /* 2087251 */   GIM_Try, /*On fail goto*//*Label 27709*/ GIMT_Encode4(2087342), // Rule ID 16181 //
     /* 2087256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2087267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2087270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087302 */     // MIs[0] round
     /* 2087302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087305 */     // MIs[0] policy
     /* 2087305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087315 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2087318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087341 */     // GIR_Coverage, 16181,
     /* 2087341 */     GIR_EraseRootFromParent_Done,
     /* 2087342 */   // Label 27709: @2087342
     /* 2087342 */   GIM_Try, /*On fail goto*//*Label 27710*/ GIMT_Encode4(2087433), // Rule ID 16184 //
     /* 2087347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2087358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2087361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2087364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087393 */     // MIs[0] round
     /* 2087393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087396 */     // MIs[0] policy
     /* 2087396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087406 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087432 */     // GIR_Coverage, 16184,
     /* 2087432 */     GIR_EraseRootFromParent_Done,
     /* 2087433 */   // Label 27710: @2087433
     /* 2087433 */   GIM_Try, /*On fail goto*//*Label 27711*/ GIMT_Encode4(2087524), // Rule ID 16185 //
     /* 2087438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2087449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2087452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2087455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087484 */     // MIs[0] round
     /* 2087484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087487 */     // MIs[0] policy
     /* 2087487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087497 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087523 */     // GIR_Coverage, 16185,
     /* 2087523 */     GIR_EraseRootFromParent_Done,
     /* 2087524 */   // Label 27711: @2087524
     /* 2087524 */   GIM_Try, /*On fail goto*//*Label 27712*/ GIMT_Encode4(2087615), // Rule ID 16188 //
     /* 2087529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2087540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2087543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2087546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087575 */     // MIs[0] round
     /* 2087575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087578 */     // MIs[0] policy
     /* 2087578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087588 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087614 */     // GIR_Coverage, 16188,
     /* 2087614 */     GIR_EraseRootFromParent_Done,
     /* 2087615 */   // Label 27712: @2087615
     /* 2087615 */   GIM_Try, /*On fail goto*//*Label 27713*/ GIMT_Encode4(2087706), // Rule ID 16189 //
     /* 2087620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2087631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2087634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2087637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087666 */     // MIs[0] round
     /* 2087666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087669 */     // MIs[0] policy
     /* 2087669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087679 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087705 */     // GIR_Coverage, 16189,
     /* 2087705 */     GIR_EraseRootFromParent_Done,
     /* 2087706 */   // Label 27713: @2087706
     /* 2087706 */   GIM_Try, /*On fail goto*//*Label 27714*/ GIMT_Encode4(2087797), // Rule ID 16192 //
     /* 2087711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2087722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2087725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2087728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087757 */     // MIs[0] round
     /* 2087757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087760 */     // MIs[0] policy
     /* 2087760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087770 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2087773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087796 */     // GIR_Coverage, 16192,
     /* 2087796 */     GIR_EraseRootFromParent_Done,
     /* 2087797 */   // Label 27714: @2087797
     /* 2087797 */   GIM_Try, /*On fail goto*//*Label 27715*/ GIMT_Encode4(2087888), // Rule ID 16193 //
     /* 2087802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2087813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2087816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2087819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087848 */     // MIs[0] round
     /* 2087848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087851 */     // MIs[0] policy
     /* 2087851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087861 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2087864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087887 */     // GIR_Coverage, 16193,
     /* 2087887 */     GIR_EraseRootFromParent_Done,
     /* 2087888 */   // Label 27715: @2087888
     /* 2087888 */   GIM_Try, /*On fail goto*//*Label 27716*/ GIMT_Encode4(2087979), // Rule ID 16196 //
     /* 2087893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2087904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2087907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2087910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087939 */     // MIs[0] round
     /* 2087939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087942 */     // MIs[0] policy
     /* 2087942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087952 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2087955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087978 */     // GIR_Coverage, 16196,
     /* 2087978 */     GIR_EraseRootFromParent_Done,
     /* 2087979 */   // Label 27716: @2087979
     /* 2087979 */   GIM_Try, /*On fail goto*//*Label 27717*/ GIMT_Encode4(2088070), // Rule ID 16197 //
     /* 2087984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2087995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2087998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2088001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2088007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088030 */     // MIs[0] round
     /* 2088030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088033 */     // MIs[0] policy
     /* 2088033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088043 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088069 */     // GIR_Coverage, 16197,
     /* 2088069 */     GIR_EraseRootFromParent_Done,
     /* 2088070 */   // Label 27717: @2088070
     /* 2088070 */   GIM_Try, /*On fail goto*//*Label 27718*/ GIMT_Encode4(2088161), // Rule ID 16200 //
     /* 2088075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2088086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2088089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2088092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088121 */     // MIs[0] round
     /* 2088121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088124 */     // MIs[0] policy
     /* 2088124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088134 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088160 */     // GIR_Coverage, 16200,
     /* 2088160 */     GIR_EraseRootFromParent_Done,
     /* 2088161 */   // Label 27718: @2088161
     /* 2088161 */   GIM_Try, /*On fail goto*//*Label 27719*/ GIMT_Encode4(2088252), // Rule ID 16201 //
     /* 2088166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2088177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2088180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2088183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088212 */     // MIs[0] round
     /* 2088212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088215 */     // MIs[0] policy
     /* 2088215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088225 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088251 */     // GIR_Coverage, 16201,
     /* 2088251 */     GIR_EraseRootFromParent_Done,
     /* 2088252 */   // Label 27719: @2088252
     /* 2088252 */   GIM_Try, /*On fail goto*//*Label 27720*/ GIMT_Encode4(2088343), // Rule ID 16204 //
     /* 2088257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2088260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2088268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2088271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2088274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088303 */     // MIs[0] round
     /* 2088303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088306 */     // MIs[0] policy
     /* 2088306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2088339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088342 */     // GIR_Coverage, 16204,
     /* 2088342 */     GIR_EraseRootFromParent_Done,
     /* 2088343 */   // Label 27720: @2088343
     /* 2088343 */   GIM_Try, /*On fail goto*//*Label 27721*/ GIMT_Encode4(2088434), // Rule ID 16205 //
     /* 2088348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2088351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2088359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2088362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2088365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088394 */     // MIs[0] round
     /* 2088394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088397 */     // MIs[0] policy
     /* 2088397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088407 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2088430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088433 */     // GIR_Coverage, 16205,
     /* 2088433 */     GIR_EraseRootFromParent_Done,
     /* 2088434 */   // Label 27721: @2088434
     /* 2088434 */   GIM_Try, /*On fail goto*//*Label 27722*/ GIMT_Encode4(2088525), // Rule ID 16208 //
     /* 2088439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2088450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2088453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2088456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2088462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088485 */     // MIs[0] round
     /* 2088485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088488 */     // MIs[0] policy
     /* 2088488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088498 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2088501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088524 */     // GIR_Coverage, 16208,
     /* 2088524 */     GIR_EraseRootFromParent_Done,
     /* 2088525 */   // Label 27722: @2088525
     /* 2088525 */   GIM_Try, /*On fail goto*//*Label 27723*/ GIMT_Encode4(2088616), // Rule ID 16209 //
     /* 2088530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2088541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2088544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2088547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2088553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088576 */     // MIs[0] round
     /* 2088576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088579 */     // MIs[0] policy
     /* 2088579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088589 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2088592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088615 */     // GIR_Coverage, 16209,
     /* 2088615 */     GIR_EraseRootFromParent_Done,
     /* 2088616 */   // Label 27723: @2088616
     /* 2088616 */   GIM_Try, /*On fail goto*//*Label 27724*/ GIMT_Encode4(2088707), // Rule ID 16212 //
     /* 2088621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2088632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2088635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2088638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2088644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2088651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088667 */     // MIs[0] round
     /* 2088667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088670 */     // MIs[0] policy
     /* 2088670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088680 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2088683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088706 */     // GIR_Coverage, 16212,
     /* 2088706 */     GIR_EraseRootFromParent_Done,
     /* 2088707 */   // Label 27724: @2088707
     /* 2088707 */   GIM_Try, /*On fail goto*//*Label 27725*/ GIMT_Encode4(2088798), // Rule ID 16213 //
     /* 2088712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2088723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2088726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2088729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2088735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2088742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088758 */     // MIs[0] round
     /* 2088758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088761 */     // MIs[0] policy
     /* 2088761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088771 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2088774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088797 */     // GIR_Coverage, 16213,
     /* 2088797 */     GIR_EraseRootFromParent_Done,
     /* 2088798 */   // Label 27725: @2088798
     /* 2088798 */   GIM_Try, /*On fail goto*//*Label 27726*/ GIMT_Encode4(2088889), // Rule ID 16216 //
     /* 2088803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2088814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2088817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2088820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2088826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2088833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088849 */     // MIs[0] round
     /* 2088849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088852 */     // MIs[0] policy
     /* 2088852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088862 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2088865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088888 */     // GIR_Coverage, 16216,
     /* 2088888 */     GIR_EraseRootFromParent_Done,
     /* 2088889 */   // Label 27726: @2088889
     /* 2088889 */   GIM_Try, /*On fail goto*//*Label 27727*/ GIMT_Encode4(2088980), // Rule ID 16217 //
     /* 2088894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2088905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2088908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2088911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2088917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2088924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088940 */     // MIs[0] round
     /* 2088940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088943 */     // MIs[0] policy
     /* 2088943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088953 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2088956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088979 */     // GIR_Coverage, 16217,
     /* 2088979 */     GIR_EraseRootFromParent_Done,
     /* 2088980 */   // Label 27727: @2088980
     /* 2088980 */   GIM_Try, /*On fail goto*//*Label 27728*/ GIMT_Encode4(2089071), // Rule ID 16220 //
     /* 2088985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2088996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2088999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2089002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089031 */     // MIs[0] round
     /* 2089031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089034 */     // MIs[0] policy
     /* 2089034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089044 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089070 */     // GIR_Coverage, 16220,
     /* 2089070 */     GIR_EraseRootFromParent_Done,
     /* 2089071 */   // Label 27728: @2089071
     /* 2089071 */   GIM_Try, /*On fail goto*//*Label 27729*/ GIMT_Encode4(2089162), // Rule ID 16221 //
     /* 2089076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2089087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2089090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2089093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089122 */     // MIs[0] round
     /* 2089122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089125 */     // MIs[0] policy
     /* 2089125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089135 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089161 */     // GIR_Coverage, 16221,
     /* 2089161 */     GIR_EraseRootFromParent_Done,
     /* 2089162 */   // Label 27729: @2089162
     /* 2089162 */   GIM_Try, /*On fail goto*//*Label 27730*/ GIMT_Encode4(2089253), // Rule ID 16224 //
     /* 2089167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2089178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2089181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2089184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089213 */     // MIs[0] round
     /* 2089213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089216 */     // MIs[0] policy
     /* 2089216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089226 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089252 */     // GIR_Coverage, 16224,
     /* 2089252 */     GIR_EraseRootFromParent_Done,
     /* 2089253 */   // Label 27730: @2089253
     /* 2089253 */   GIM_Try, /*On fail goto*//*Label 27731*/ GIMT_Encode4(2089344), // Rule ID 16225 //
     /* 2089258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2089269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2089272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2089275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089304 */     // MIs[0] round
     /* 2089304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089307 */     // MIs[0] policy
     /* 2089307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089317 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089343 */     // GIR_Coverage, 16225,
     /* 2089343 */     GIR_EraseRootFromParent_Done,
     /* 2089344 */   // Label 27731: @2089344
     /* 2089344 */   GIM_Try, /*On fail goto*//*Label 27732*/ GIMT_Encode4(2089435), // Rule ID 16228 //
     /* 2089349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2089360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2089363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2089366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089395 */     // MIs[0] round
     /* 2089395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089398 */     // MIs[0] policy
     /* 2089398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089408 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089434 */     // GIR_Coverage, 16228,
     /* 2089434 */     GIR_EraseRootFromParent_Done,
     /* 2089435 */   // Label 27732: @2089435
     /* 2089435 */   GIM_Try, /*On fail goto*//*Label 27733*/ GIMT_Encode4(2089526), // Rule ID 16229 //
     /* 2089440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2089451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2089454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2089457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089486 */     // MIs[0] round
     /* 2089486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089489 */     // MIs[0] policy
     /* 2089489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089499 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089525 */     // GIR_Coverage, 16229,
     /* 2089525 */     GIR_EraseRootFromParent_Done,
     /* 2089526 */   // Label 27733: @2089526
     /* 2089526 */   GIM_Try, /*On fail goto*//*Label 27734*/ GIMT_Encode4(2089617), // Rule ID 16232 //
     /* 2089531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2089542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2089545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2089548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089577 */     // MIs[0] round
     /* 2089577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089580 */     // MIs[0] policy
     /* 2089580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089590 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089616 */     // GIR_Coverage, 16232,
     /* 2089616 */     GIR_EraseRootFromParent_Done,
     /* 2089617 */   // Label 27734: @2089617
     /* 2089617 */   GIM_Try, /*On fail goto*//*Label 27735*/ GIMT_Encode4(2089708), // Rule ID 16233 //
     /* 2089622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2089633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2089636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2089639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089668 */     // MIs[0] round
     /* 2089668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089671 */     // MIs[0] policy
     /* 2089671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089707 */     // GIR_Coverage, 16233,
     /* 2089707 */     GIR_EraseRootFromParent_Done,
     /* 2089708 */   // Label 27735: @2089708
     /* 2089708 */   GIM_Try, /*On fail goto*//*Label 27736*/ GIMT_Encode4(2089799), // Rule ID 16236 //
     /* 2089713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2089724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2089727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2089730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089759 */     // MIs[0] round
     /* 2089759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089762 */     // MIs[0] policy
     /* 2089762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089772 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089798 */     // GIR_Coverage, 16236,
     /* 2089798 */     GIR_EraseRootFromParent_Done,
     /* 2089799 */   // Label 27736: @2089799
     /* 2089799 */   GIM_Try, /*On fail goto*//*Label 27737*/ GIMT_Encode4(2089890), // Rule ID 16237 //
     /* 2089804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2089815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2089818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2089821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089850 */     // MIs[0] round
     /* 2089850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089853 */     // MIs[0] policy
     /* 2089853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089863 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089889 */     // GIR_Coverage, 16237,
     /* 2089889 */     GIR_EraseRootFromParent_Done,
     /* 2089890 */   // Label 27737: @2089890
     /* 2089890 */   GIM_Try, /*On fail goto*//*Label 27738*/ GIMT_Encode4(2089981), // Rule ID 16240 //
     /* 2089895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2089906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2089909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2089912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089941 */     // MIs[0] round
     /* 2089941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089944 */     // MIs[0] policy
     /* 2089944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089954 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089980 */     // GIR_Coverage, 16240,
     /* 2089980 */     GIR_EraseRootFromParent_Done,
     /* 2089981 */   // Label 27738: @2089981
     /* 2089981 */   GIM_Try, /*On fail goto*//*Label 27739*/ GIMT_Encode4(2090072), // Rule ID 16241 //
     /* 2089986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2089997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2090000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2090003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2090009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090032 */     // MIs[0] round
     /* 2090032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090035 */     // MIs[0] policy
     /* 2090035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090045 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2090048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090071 */     // GIR_Coverage, 16241,
     /* 2090071 */     GIR_EraseRootFromParent_Done,
     /* 2090072 */   // Label 27739: @2090072
     /* 2090072 */   GIM_Try, /*On fail goto*//*Label 27740*/ GIMT_Encode4(2090163), // Rule ID 16244 //
     /* 2090077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2090088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2090091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2090094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090123 */     // MIs[0] round
     /* 2090123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090126 */     // MIs[0] policy
     /* 2090126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090136 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2090139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090162 */     // GIR_Coverage, 16244,
     /* 2090162 */     GIR_EraseRootFromParent_Done,
     /* 2090163 */   // Label 27740: @2090163
     /* 2090163 */   GIM_Try, /*On fail goto*//*Label 27741*/ GIMT_Encode4(2090254), // Rule ID 16245 //
     /* 2090168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2090179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2090182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2090185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090214 */     // MIs[0] round
     /* 2090214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090217 */     // MIs[0] policy
     /* 2090217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090227 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2090230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090253 */     // GIR_Coverage, 16245,
     /* 2090253 */     GIR_EraseRootFromParent_Done,
     /* 2090254 */   // Label 27741: @2090254
     /* 2090254 */   GIM_Try, /*On fail goto*//*Label 27742*/ GIMT_Encode4(2090345), // Rule ID 16248 //
     /* 2090259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2090270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2090273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2090276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090305 */     // MIs[0] round
     /* 2090305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090308 */     // MIs[0] policy
     /* 2090308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090318 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2090321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090344 */     // GIR_Coverage, 16248,
     /* 2090344 */     GIR_EraseRootFromParent_Done,
     /* 2090345 */   // Label 27742: @2090345
     /* 2090345 */   GIM_Try, /*On fail goto*//*Label 27743*/ GIMT_Encode4(2090436), // Rule ID 16249 //
     /* 2090350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2090361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2090364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2090367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090396 */     // MIs[0] round
     /* 2090396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090399 */     // MIs[0] policy
     /* 2090399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090409 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2090412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090435 */     // GIR_Coverage, 16249,
     /* 2090435 */     GIR_EraseRootFromParent_Done,
     /* 2090436 */   // Label 27743: @2090436
     /* 2090436 */   GIM_Try, /*On fail goto*//*Label 27744*/ GIMT_Encode4(2090527), // Rule ID 16252 //
     /* 2090441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2090452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2090455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2090458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090487 */     // MIs[0] round
     /* 2090487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090490 */     // MIs[0] policy
     /* 2090490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090500 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2090503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090526 */     // GIR_Coverage, 16252,
     /* 2090526 */     GIR_EraseRootFromParent_Done,
     /* 2090527 */   // Label 27744: @2090527
     /* 2090527 */   GIM_Try, /*On fail goto*//*Label 27745*/ GIMT_Encode4(2090618), // Rule ID 16253 //
     /* 2090532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2090543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2090546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2090549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090578 */     // MIs[0] round
     /* 2090578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090581 */     // MIs[0] policy
     /* 2090581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090591 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2090594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090617 */     // GIR_Coverage, 16253,
     /* 2090617 */     GIR_EraseRootFromParent_Done,
     /* 2090618 */   // Label 27745: @2090618
     /* 2090618 */   GIM_Try, /*On fail goto*//*Label 27746*/ GIMT_Encode4(2090712), // Rule ID 16344 //
     /* 2090623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2090631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2090634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2090637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2090640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2090643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2090646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090669 */     // MIs[0] round
     /* 2090669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090672 */     // MIs[0] policy
     /* 2090672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090682 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2090685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090711 */     // GIR_Coverage, 16344,
     /* 2090711 */     GIR_EraseRootFromParent_Done,
     /* 2090712 */   // Label 27746: @2090712
     /* 2090712 */   GIM_Try, /*On fail goto*//*Label 27747*/ GIMT_Encode4(2090806), // Rule ID 16345 //
     /* 2090717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2090725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2090728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2090731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2090734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2090737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2090740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090763 */     // MIs[0] round
     /* 2090763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090766 */     // MIs[0] policy
     /* 2090766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090776 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2090779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090805 */     // GIR_Coverage, 16345,
     /* 2090805 */     GIR_EraseRootFromParent_Done,
     /* 2090806 */   // Label 27747: @2090806
     /* 2090806 */   GIM_Try, /*On fail goto*//*Label 27748*/ GIMT_Encode4(2090900), // Rule ID 16348 //
     /* 2090811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2090819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2090822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2090825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2090828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2090831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090857 */     // MIs[0] round
     /* 2090857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090860 */     // MIs[0] policy
     /* 2090860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090870 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2090873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090899 */     // GIR_Coverage, 16348,
     /* 2090899 */     GIR_EraseRootFromParent_Done,
     /* 2090900 */   // Label 27748: @2090900
     /* 2090900 */   GIM_Try, /*On fail goto*//*Label 27749*/ GIMT_Encode4(2090994), // Rule ID 16349 //
     /* 2090905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2090913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2090916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2090919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2090922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2090925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090951 */     // MIs[0] round
     /* 2090951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090954 */     // MIs[0] policy
     /* 2090954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090964 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2090967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090993 */     // GIR_Coverage, 16349,
     /* 2090993 */     GIR_EraseRootFromParent_Done,
     /* 2090994 */   // Label 27749: @2090994
     /* 2090994 */   GIM_Try, /*On fail goto*//*Label 27750*/ GIMT_Encode4(2091088), // Rule ID 16352 //
     /* 2090999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2091010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2091013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2091016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2091019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091045 */     // MIs[0] round
     /* 2091045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091048 */     // MIs[0] policy
     /* 2091048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091058 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2091061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091087 */     // GIR_Coverage, 16352,
     /* 2091087 */     GIR_EraseRootFromParent_Done,
     /* 2091088 */   // Label 27750: @2091088
     /* 2091088 */   GIM_Try, /*On fail goto*//*Label 27751*/ GIMT_Encode4(2091182), // Rule ID 16353 //
     /* 2091093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2091104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2091107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2091110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2091113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091139 */     // MIs[0] round
     /* 2091139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091142 */     // MIs[0] policy
     /* 2091142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091152 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2091155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091181 */     // GIR_Coverage, 16353,
     /* 2091181 */     GIR_EraseRootFromParent_Done,
     /* 2091182 */   // Label 27751: @2091182
     /* 2091182 */   GIM_Try, /*On fail goto*//*Label 27752*/ GIMT_Encode4(2091276), // Rule ID 16356 //
     /* 2091187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2091198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2091201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2091204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2091207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091233 */     // MIs[0] round
     /* 2091233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091236 */     // MIs[0] policy
     /* 2091236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091246 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2091249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091275 */     // GIR_Coverage, 16356,
     /* 2091275 */     GIR_EraseRootFromParent_Done,
     /* 2091276 */   // Label 27752: @2091276
     /* 2091276 */   GIM_Try, /*On fail goto*//*Label 27753*/ GIMT_Encode4(2091370), // Rule ID 16357 //
     /* 2091281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2091292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2091295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2091298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2091301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091327 */     // MIs[0] round
     /* 2091327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091330 */     // MIs[0] policy
     /* 2091330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091340 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2091343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091369 */     // GIR_Coverage, 16357,
     /* 2091369 */     GIR_EraseRootFromParent_Done,
     /* 2091370 */   // Label 27753: @2091370
     /* 2091370 */   GIM_Try, /*On fail goto*//*Label 27754*/ GIMT_Encode4(2091464), // Rule ID 16360 //
     /* 2091375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2091386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2091389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2091392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2091395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2091398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091421 */     // MIs[0] round
     /* 2091421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091424 */     // MIs[0] policy
     /* 2091424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091434 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2091437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091463 */     // GIR_Coverage, 16360,
     /* 2091463 */     GIR_EraseRootFromParent_Done,
     /* 2091464 */   // Label 27754: @2091464
     /* 2091464 */   GIM_Try, /*On fail goto*//*Label 27755*/ GIMT_Encode4(2091558), // Rule ID 16361 //
     /* 2091469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2091480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2091483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2091486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2091489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2091492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091515 */     // MIs[0] round
     /* 2091515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091518 */     // MIs[0] policy
     /* 2091518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091528 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2091531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091557 */     // GIR_Coverage, 16361,
     /* 2091557 */     GIR_EraseRootFromParent_Done,
     /* 2091558 */   // Label 27755: @2091558
     /* 2091558 */   GIM_Try, /*On fail goto*//*Label 27756*/ GIMT_Encode4(2091652), // Rule ID 16364 //
     /* 2091563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2091574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2091577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2091580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2091583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2091586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2091593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091609 */     // MIs[0] round
     /* 2091609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091612 */     // MIs[0] policy
     /* 2091612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091622 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2091625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091651 */     // GIR_Coverage, 16364,
     /* 2091651 */     GIR_EraseRootFromParent_Done,
     /* 2091652 */   // Label 27756: @2091652
     /* 2091652 */   GIM_Try, /*On fail goto*//*Label 27757*/ GIMT_Encode4(2091746), // Rule ID 16365 //
     /* 2091657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2091668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2091671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2091674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2091677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2091680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2091687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091703 */     // MIs[0] round
     /* 2091703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091706 */     // MIs[0] policy
     /* 2091706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091716 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2091719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091745 */     // GIR_Coverage, 16365,
     /* 2091745 */     GIR_EraseRootFromParent_Done,
     /* 2091746 */   // Label 27757: @2091746
     /* 2091746 */   GIM_Try, /*On fail goto*//*Label 27758*/ GIMT_Encode4(2091840), // Rule ID 16368 //
     /* 2091751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2091762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2091765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2091768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2091771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091797 */     // MIs[0] round
     /* 2091797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091800 */     // MIs[0] policy
     /* 2091800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091810 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2091813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091839 */     // GIR_Coverage, 16368,
     /* 2091839 */     GIR_EraseRootFromParent_Done,
     /* 2091840 */   // Label 27758: @2091840
     /* 2091840 */   GIM_Try, /*On fail goto*//*Label 27759*/ GIMT_Encode4(2091934), // Rule ID 16369 //
     /* 2091845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2091856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2091859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2091862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2091865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091891 */     // MIs[0] round
     /* 2091891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091894 */     // MIs[0] policy
     /* 2091894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091904 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2091907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091933 */     // GIR_Coverage, 16369,
     /* 2091933 */     GIR_EraseRootFromParent_Done,
     /* 2091934 */   // Label 27759: @2091934
     /* 2091934 */   GIM_Try, /*On fail goto*//*Label 27760*/ GIMT_Encode4(2092028), // Rule ID 16372 //
     /* 2091939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2091950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2091953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2091956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2091959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091985 */     // MIs[0] round
     /* 2091985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091988 */     // MIs[0] policy
     /* 2091988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091998 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2092001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092027 */     // GIR_Coverage, 16372,
     /* 2092027 */     GIR_EraseRootFromParent_Done,
     /* 2092028 */   // Label 27760: @2092028
     /* 2092028 */   GIM_Try, /*On fail goto*//*Label 27761*/ GIMT_Encode4(2092122), // Rule ID 16373 //
     /* 2092033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2092044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2092047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2092050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2092053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092079 */     // MIs[0] round
     /* 2092079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092082 */     // MIs[0] policy
     /* 2092082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092092 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2092095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092121 */     // GIR_Coverage, 16373,
     /* 2092121 */     GIR_EraseRootFromParent_Done,
     /* 2092122 */   // Label 27761: @2092122
     /* 2092122 */   GIM_Try, /*On fail goto*//*Label 27762*/ GIMT_Encode4(2092216), // Rule ID 16376 //
     /* 2092127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2092138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2092141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2092144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2092147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092173 */     // MIs[0] round
     /* 2092173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092176 */     // MIs[0] policy
     /* 2092176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092186 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2092189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092215 */     // GIR_Coverage, 16376,
     /* 2092215 */     GIR_EraseRootFromParent_Done,
     /* 2092216 */   // Label 27762: @2092216
     /* 2092216 */   GIM_Try, /*On fail goto*//*Label 27763*/ GIMT_Encode4(2092310), // Rule ID 16377 //
     /* 2092221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2092232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2092235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2092238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2092241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092267 */     // MIs[0] round
     /* 2092267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092270 */     // MIs[0] policy
     /* 2092270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092280 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2092283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092309 */     // GIR_Coverage, 16377,
     /* 2092309 */     GIR_EraseRootFromParent_Done,
     /* 2092310 */   // Label 27763: @2092310
     /* 2092310 */   GIM_Try, /*On fail goto*//*Label 27764*/ GIMT_Encode4(2092404), // Rule ID 16380 //
     /* 2092315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2092326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2092329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2092332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2092335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092361 */     // MIs[0] round
     /* 2092361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092364 */     // MIs[0] policy
     /* 2092364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092374 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2092377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092403 */     // GIR_Coverage, 16380,
     /* 2092403 */     GIR_EraseRootFromParent_Done,
     /* 2092404 */   // Label 27764: @2092404
     /* 2092404 */   GIM_Try, /*On fail goto*//*Label 27765*/ GIMT_Encode4(2092498), // Rule ID 16381 //
     /* 2092409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2092420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2092423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2092426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2092429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092455 */     // MIs[0] round
     /* 2092455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092458 */     // MIs[0] policy
     /* 2092458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2092471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092497 */     // GIR_Coverage, 16381,
     /* 2092497 */     GIR_EraseRootFromParent_Done,
     /* 2092498 */   // Label 27765: @2092498
     /* 2092498 */   GIM_Try, /*On fail goto*//*Label 27766*/ GIMT_Encode4(2092592), // Rule ID 16384 //
     /* 2092503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2092514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2092517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2092520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2092523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092549 */     // MIs[0] round
     /* 2092549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092552 */     // MIs[0] policy
     /* 2092552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092562 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2092565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092591 */     // GIR_Coverage, 16384,
     /* 2092591 */     GIR_EraseRootFromParent_Done,
     /* 2092592 */   // Label 27766: @2092592
     /* 2092592 */   GIM_Try, /*On fail goto*//*Label 27767*/ GIMT_Encode4(2092686), // Rule ID 16385 //
     /* 2092597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2092608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2092611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2092614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2092617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092643 */     // MIs[0] round
     /* 2092643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092646 */     // MIs[0] policy
     /* 2092646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092656 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2092659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092685 */     // GIR_Coverage, 16385,
     /* 2092685 */     GIR_EraseRootFromParent_Done,
     /* 2092686 */   // Label 27767: @2092686
     /* 2092686 */   GIM_Try, /*On fail goto*//*Label 27768*/ GIMT_Encode4(2092780), // Rule ID 16388 //
     /* 2092691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2092694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2092702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2092705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2092708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2092711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092737 */     // MIs[0] round
     /* 2092737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092740 */     // MIs[0] policy
     /* 2092740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092750 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2092753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092779 */     // GIR_Coverage, 16388,
     /* 2092779 */     GIR_EraseRootFromParent_Done,
     /* 2092780 */   // Label 27768: @2092780
     /* 2092780 */   GIM_Try, /*On fail goto*//*Label 27769*/ GIMT_Encode4(2092874), // Rule ID 16389 //
     /* 2092785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2092788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2092796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2092799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2092802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2092805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092831 */     // MIs[0] round
     /* 2092831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092834 */     // MIs[0] policy
     /* 2092834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092844 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2092847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092873 */     // GIR_Coverage, 16389,
     /* 2092873 */     GIR_EraseRootFromParent_Done,
     /* 2092874 */   // Label 27769: @2092874
     /* 2092874 */   GIM_Try, /*On fail goto*//*Label 27770*/ GIMT_Encode4(2092968), // Rule ID 16392 //
     /* 2092879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2092882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2092890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2092893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2092896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2092899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092925 */     // MIs[0] round
     /* 2092925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092928 */     // MIs[0] policy
     /* 2092928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092938 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2092941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092967 */     // GIR_Coverage, 16392,
     /* 2092967 */     GIR_EraseRootFromParent_Done,
     /* 2092968 */   // Label 27770: @2092968
     /* 2092968 */   GIM_Try, /*On fail goto*//*Label 27771*/ GIMT_Encode4(2093062), // Rule ID 16393 //
     /* 2092973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2092976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2092984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2092987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2092990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2092993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093019 */     // MIs[0] round
     /* 2093019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093022 */     // MIs[0] policy
     /* 2093022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093032 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2093035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093061 */     // GIR_Coverage, 16393,
     /* 2093061 */     GIR_EraseRootFromParent_Done,
     /* 2093062 */   // Label 27771: @2093062
     /* 2093062 */   GIM_Try, /*On fail goto*//*Label 27772*/ GIMT_Encode4(2093156), // Rule ID 16396 //
     /* 2093067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2093070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2093078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2093081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2093084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2093087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093113 */     // MIs[0] round
     /* 2093113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093116 */     // MIs[0] policy
     /* 2093116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093126 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2093129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093155 */     // GIR_Coverage, 16396,
     /* 2093155 */     GIR_EraseRootFromParent_Done,
     /* 2093156 */   // Label 27772: @2093156
     /* 2093156 */   GIM_Try, /*On fail goto*//*Label 27773*/ GIMT_Encode4(2093250), // Rule ID 16397 //
     /* 2093161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2093164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2093172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2093175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2093178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2093181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093207 */     // MIs[0] round
     /* 2093207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093210 */     // MIs[0] policy
     /* 2093210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093220 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2093223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093249 */     // GIR_Coverage, 16397,
     /* 2093249 */     GIR_EraseRootFromParent_Done,
     /* 2093250 */   // Label 27773: @2093250
     /* 2093250 */   GIM_Try, /*On fail goto*//*Label 27774*/ GIMT_Encode4(2093344), // Rule ID 16400 //
     /* 2093255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2093258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2093266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2093269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2093272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2093275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093301 */     // MIs[0] round
     /* 2093301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093304 */     // MIs[0] policy
     /* 2093304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2093317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093343 */     // GIR_Coverage, 16400,
     /* 2093343 */     GIR_EraseRootFromParent_Done,
     /* 2093344 */   // Label 27774: @2093344
     /* 2093344 */   GIM_Try, /*On fail goto*//*Label 27775*/ GIMT_Encode4(2093438), // Rule ID 16401 //
     /* 2093349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2093352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2093360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2093363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2093366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2093369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093395 */     // MIs[0] round
     /* 2093395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093398 */     // MIs[0] policy
     /* 2093398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093408 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2093411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093437 */     // GIR_Coverage, 16401,
     /* 2093437 */     GIR_EraseRootFromParent_Done,
     /* 2093438 */   // Label 27775: @2093438
     /* 2093438 */   GIM_Try, /*On fail goto*//*Label 27776*/ GIMT_Encode4(2093532), // Rule ID 16404 //
     /* 2093443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2093454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2093457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2093460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093489 */     // MIs[0] round
     /* 2093489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093492 */     // MIs[0] policy
     /* 2093492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093502 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2093505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093531 */     // GIR_Coverage, 16404,
     /* 2093531 */     GIR_EraseRootFromParent_Done,
     /* 2093532 */   // Label 27776: @2093532
     /* 2093532 */   GIM_Try, /*On fail goto*//*Label 27777*/ GIMT_Encode4(2093626), // Rule ID 16405 //
     /* 2093537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2093548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2093551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2093554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093583 */     // MIs[0] round
     /* 2093583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093586 */     // MIs[0] policy
     /* 2093586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2093599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093625 */     // GIR_Coverage, 16405,
     /* 2093625 */     GIR_EraseRootFromParent_Done,
     /* 2093626 */   // Label 27777: @2093626
     /* 2093626 */   GIM_Try, /*On fail goto*//*Label 27778*/ GIMT_Encode4(2093720), // Rule ID 16408 //
     /* 2093631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2093642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2093645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2093648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093677 */     // MIs[0] round
     /* 2093677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093680 */     // MIs[0] policy
     /* 2093680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093690 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2093693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093719 */     // GIR_Coverage, 16408,
     /* 2093719 */     GIR_EraseRootFromParent_Done,
     /* 2093720 */   // Label 27778: @2093720
     /* 2093720 */   GIM_Try, /*On fail goto*//*Label 27779*/ GIMT_Encode4(2093814), // Rule ID 16409 //
     /* 2093725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2093736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2093739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2093742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093771 */     // MIs[0] round
     /* 2093771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093774 */     // MIs[0] policy
     /* 2093774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093784 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2093787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093813 */     // GIR_Coverage, 16409,
     /* 2093813 */     GIR_EraseRootFromParent_Done,
     /* 2093814 */   // Label 27779: @2093814
     /* 2093814 */   GIM_Try, /*On fail goto*//*Label 27780*/ GIMT_Encode4(2093908), // Rule ID 16412 //
     /* 2093819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2093830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2093833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2093836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093865 */     // MIs[0] round
     /* 2093865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093868 */     // MIs[0] policy
     /* 2093868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093878 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2093881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093903 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093907 */     // GIR_Coverage, 16412,
     /* 2093907 */     GIR_EraseRootFromParent_Done,
     /* 2093908 */   // Label 27780: @2093908
     /* 2093908 */   GIM_Try, /*On fail goto*//*Label 27781*/ GIMT_Encode4(2094002), // Rule ID 16413 //
     /* 2093913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2093924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2093927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2093930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093959 */     // MIs[0] round
     /* 2093959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093962 */     // MIs[0] policy
     /* 2093962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093972 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2093975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094001 */     // GIR_Coverage, 16413,
     /* 2094001 */     GIR_EraseRootFromParent_Done,
     /* 2094002 */   // Label 27781: @2094002
     /* 2094002 */   GIM_Try, /*On fail goto*//*Label 27782*/ GIMT_Encode4(2094096), // Rule ID 16416 //
     /* 2094007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2094018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2094021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2094024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094053 */     // MIs[0] round
     /* 2094053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094056 */     // MIs[0] policy
     /* 2094056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094066 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2094069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094095 */     // GIR_Coverage, 16416,
     /* 2094095 */     GIR_EraseRootFromParent_Done,
     /* 2094096 */   // Label 27782: @2094096
     /* 2094096 */   GIM_Try, /*On fail goto*//*Label 27783*/ GIMT_Encode4(2094190), // Rule ID 16417 //
     /* 2094101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2094112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2094115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2094118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094147 */     // MIs[0] round
     /* 2094147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094150 */     // MIs[0] policy
     /* 2094150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094160 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2094163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094189 */     // GIR_Coverage, 16417,
     /* 2094189 */     GIR_EraseRootFromParent_Done,
     /* 2094190 */   // Label 27783: @2094190
     /* 2094190 */   GIM_Try, /*On fail goto*//*Label 27784*/ GIMT_Encode4(2094284), // Rule ID 16420 //
     /* 2094195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2094206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2094209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2094212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094241 */     // MIs[0] round
     /* 2094241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094244 */     // MIs[0] policy
     /* 2094244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094254 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2094257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094283 */     // GIR_Coverage, 16420,
     /* 2094283 */     GIR_EraseRootFromParent_Done,
     /* 2094284 */   // Label 27784: @2094284
     /* 2094284 */   GIM_Try, /*On fail goto*//*Label 27785*/ GIMT_Encode4(2094378), // Rule ID 16421 //
     /* 2094289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2094300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2094303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2094306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094335 */     // MIs[0] round
     /* 2094335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094338 */     // MIs[0] policy
     /* 2094338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094348 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2094351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094377 */     // GIR_Coverage, 16421,
     /* 2094377 */     GIR_EraseRootFromParent_Done,
     /* 2094378 */   // Label 27785: @2094378
     /* 2094378 */   GIM_Try, /*On fail goto*//*Label 27786*/ GIMT_Encode4(2094472), // Rule ID 16424 //
     /* 2094383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2094394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2094397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2094400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2094406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094429 */     // MIs[0] round
     /* 2094429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094432 */     // MIs[0] policy
     /* 2094432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094442 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2094445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094471 */     // GIR_Coverage, 16424,
     /* 2094471 */     GIR_EraseRootFromParent_Done,
     /* 2094472 */   // Label 27786: @2094472
     /* 2094472 */   GIM_Try, /*On fail goto*//*Label 27787*/ GIMT_Encode4(2094566), // Rule ID 16425 //
     /* 2094477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2094488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2094491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2094494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2094500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094523 */     // MIs[0] round
     /* 2094523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094526 */     // MIs[0] policy
     /* 2094526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094536 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2094539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094565 */     // GIR_Coverage, 16425,
     /* 2094565 */     GIR_EraseRootFromParent_Done,
     /* 2094566 */   // Label 27787: @2094566
     /* 2094566 */   GIM_Try, /*On fail goto*//*Label 27788*/ GIMT_Encode4(2094660), // Rule ID 16428 //
     /* 2094571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2094582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2094585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2094588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094617 */     // MIs[0] round
     /* 2094617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094620 */     // MIs[0] policy
     /* 2094620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2094633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094659 */     // GIR_Coverage, 16428,
     /* 2094659 */     GIR_EraseRootFromParent_Done,
     /* 2094660 */   // Label 27788: @2094660
     /* 2094660 */   GIM_Try, /*On fail goto*//*Label 27789*/ GIMT_Encode4(2094754), // Rule ID 16429 //
     /* 2094665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2094676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2094679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2094682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094711 */     // MIs[0] round
     /* 2094711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094714 */     // MIs[0] policy
     /* 2094714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094724 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2094727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094753 */     // GIR_Coverage, 16429,
     /* 2094753 */     GIR_EraseRootFromParent_Done,
     /* 2094754 */   // Label 27789: @2094754
     /* 2094754 */   GIM_Try, /*On fail goto*//*Label 27790*/ GIMT_Encode4(2094848), // Rule ID 16432 //
     /* 2094759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2094770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2094773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2094776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094805 */     // MIs[0] round
     /* 2094805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094808 */     // MIs[0] policy
     /* 2094808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094818 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2094821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094847 */     // GIR_Coverage, 16432,
     /* 2094847 */     GIR_EraseRootFromParent_Done,
     /* 2094848 */   // Label 27790: @2094848
     /* 2094848 */   GIM_Try, /*On fail goto*//*Label 27791*/ GIMT_Encode4(2094942), // Rule ID 16433 //
     /* 2094853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2094864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2094867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2094870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094899 */     // MIs[0] round
     /* 2094899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094902 */     // MIs[0] policy
     /* 2094902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094912 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2094915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094941 */     // GIR_Coverage, 16433,
     /* 2094941 */     GIR_EraseRootFromParent_Done,
     /* 2094942 */   // Label 27791: @2094942
     /* 2094942 */   GIM_Try, /*On fail goto*//*Label 27792*/ GIMT_Encode4(2095036), // Rule ID 16436 //
     /* 2094947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2094958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2094961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2094964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094993 */     // MIs[0] round
     /* 2094993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094996 */     // MIs[0] policy
     /* 2094996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095006 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2095009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095035 */     // GIR_Coverage, 16436,
     /* 2095035 */     GIR_EraseRootFromParent_Done,
     /* 2095036 */   // Label 27792: @2095036
     /* 2095036 */   GIM_Try, /*On fail goto*//*Label 27793*/ GIMT_Encode4(2095130), // Rule ID 16437 //
     /* 2095041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2095052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2095055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2095058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095087 */     // MIs[0] round
     /* 2095087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095090 */     // MIs[0] policy
     /* 2095090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2095103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095129 */     // GIR_Coverage, 16437,
     /* 2095129 */     GIR_EraseRootFromParent_Done,
     /* 2095130 */   // Label 27793: @2095130
     /* 2095130 */   GIM_Try, /*On fail goto*//*Label 27794*/ GIMT_Encode4(2095224), // Rule ID 16440 //
     /* 2095135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2095146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2095149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2095152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095181 */     // MIs[0] round
     /* 2095181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095184 */     // MIs[0] policy
     /* 2095184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2095197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095223 */     // GIR_Coverage, 16440,
     /* 2095223 */     GIR_EraseRootFromParent_Done,
     /* 2095224 */   // Label 27794: @2095224
     /* 2095224 */   GIM_Try, /*On fail goto*//*Label 27795*/ GIMT_Encode4(2095318), // Rule ID 16441 //
     /* 2095229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2095240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2095243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2095246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095275 */     // MIs[0] round
     /* 2095275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095278 */     // MIs[0] policy
     /* 2095278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095288 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2095291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095317 */     // GIR_Coverage, 16441,
     /* 2095317 */     GIR_EraseRootFromParent_Done,
     /* 2095318 */   // Label 27795: @2095318
     /* 2095318 */   GIM_Try, /*On fail goto*//*Label 27796*/ GIMT_Encode4(2095412), // Rule ID 16444 //
     /* 2095323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2095334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2095337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2095340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2095346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095369 */     // MIs[0] round
     /* 2095369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095372 */     // MIs[0] policy
     /* 2095372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095382 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2095385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095411 */     // GIR_Coverage, 16444,
     /* 2095411 */     GIR_EraseRootFromParent_Done,
     /* 2095412 */   // Label 27796: @2095412
     /* 2095412 */   GIM_Try, /*On fail goto*//*Label 27797*/ GIMT_Encode4(2095506), // Rule ID 16445 //
     /* 2095417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2095428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2095431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2095434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2095440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095463 */     // MIs[0] round
     /* 2095463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095466 */     // MIs[0] policy
     /* 2095466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095476 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2095479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095505 */     // GIR_Coverage, 16445,
     /* 2095505 */     GIR_EraseRootFromParent_Done,
     /* 2095506 */   // Label 27797: @2095506
     /* 2095506 */   GIM_Try, /*On fail goto*//*Label 27798*/ GIMT_Encode4(2095600), // Rule ID 16448 //
     /* 2095511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2095514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2095522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2095525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2095528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095557 */     // MIs[0] round
     /* 2095557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095560 */     // MIs[0] policy
     /* 2095560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095570 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2095573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095599 */     // GIR_Coverage, 16448,
     /* 2095599 */     GIR_EraseRootFromParent_Done,
     /* 2095600 */   // Label 27798: @2095600
     /* 2095600 */   GIM_Try, /*On fail goto*//*Label 27799*/ GIMT_Encode4(2095694), // Rule ID 16449 //
     /* 2095605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2095608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2095616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2095619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2095622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095651 */     // MIs[0] round
     /* 2095651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095654 */     // MIs[0] policy
     /* 2095654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095664 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2095667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095693 */     // GIR_Coverage, 16449,
     /* 2095693 */     GIR_EraseRootFromParent_Done,
     /* 2095694 */   // Label 27799: @2095694
     /* 2095694 */   GIM_Try, /*On fail goto*//*Label 27800*/ GIMT_Encode4(2095788), // Rule ID 16452 //
     /* 2095699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2095702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2095710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2095713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2095716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095745 */     // MIs[0] round
     /* 2095745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095748 */     // MIs[0] policy
     /* 2095748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095758 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2095761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095787 */     // GIR_Coverage, 16452,
     /* 2095787 */     GIR_EraseRootFromParent_Done,
     /* 2095788 */   // Label 27800: @2095788
     /* 2095788 */   GIM_Try, /*On fail goto*//*Label 27801*/ GIMT_Encode4(2095882), // Rule ID 16453 //
     /* 2095793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2095796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2095804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2095807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2095810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095839 */     // MIs[0] round
     /* 2095839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095842 */     // MIs[0] policy
     /* 2095842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2095855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095881 */     // GIR_Coverage, 16453,
     /* 2095881 */     GIR_EraseRootFromParent_Done,
     /* 2095882 */   // Label 27801: @2095882
     /* 2095882 */   GIM_Try, /*On fail goto*//*Label 27802*/ GIMT_Encode4(2095976), // Rule ID 16456 //
     /* 2095887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2095890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2095898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2095901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2095904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095933 */     // MIs[0] round
     /* 2095933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095936 */     // MIs[0] policy
     /* 2095936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2095949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095975 */     // GIR_Coverage, 16456,
     /* 2095975 */     GIR_EraseRootFromParent_Done,
     /* 2095976 */   // Label 27802: @2095976
     /* 2095976 */   GIM_Try, /*On fail goto*//*Label 27803*/ GIMT_Encode4(2096070), // Rule ID 16457 //
     /* 2095981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2095984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2095992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2095995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2095998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2096001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096027 */     // MIs[0] round
     /* 2096027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096030 */     // MIs[0] policy
     /* 2096030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2096043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096069 */     // GIR_Coverage, 16457,
     /* 2096069 */     GIR_EraseRootFromParent_Done,
     /* 2096070 */   // Label 27803: @2096070
     /* 2096070 */   GIM_Try, /*On fail goto*//*Label 27804*/ GIMT_Encode4(2096164), // Rule ID 16460 //
     /* 2096075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2096078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2096086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2096089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2096092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2096095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096121 */     // MIs[0] round
     /* 2096121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096124 */     // MIs[0] policy
     /* 2096124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096134 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2096137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096163 */     // GIR_Coverage, 16460,
     /* 2096163 */     GIR_EraseRootFromParent_Done,
     /* 2096164 */   // Label 27804: @2096164
     /* 2096164 */   GIM_Try, /*On fail goto*//*Label 27805*/ GIMT_Encode4(2096258), // Rule ID 16461 //
     /* 2096169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2096172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2096180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2096183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2096186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2096189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096215 */     // MIs[0] round
     /* 2096215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096218 */     // MIs[0] policy
     /* 2096218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096228 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2096231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096257 */     // GIR_Coverage, 16461,
     /* 2096257 */     GIR_EraseRootFromParent_Done,
     /* 2096258 */   // Label 27805: @2096258
     /* 2096258 */   GIM_Try, /*On fail goto*//*Label 27806*/ GIMT_Encode4(2096352), // Rule ID 16524 //
     /* 2096263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2096274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2096277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2096280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2096283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096309 */     // MIs[0] round
     /* 2096309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096312 */     // MIs[0] policy
     /* 2096312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096322 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2096325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096351 */     // GIR_Coverage, 16524,
     /* 2096351 */     GIR_EraseRootFromParent_Done,
     /* 2096352 */   // Label 27806: @2096352
     /* 2096352 */   GIM_Try, /*On fail goto*//*Label 27807*/ GIMT_Encode4(2096446), // Rule ID 16525 //
     /* 2096357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2096360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2096368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2096371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2096374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2096377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096403 */     // MIs[0] round
     /* 2096403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096406 */     // MIs[0] policy
     /* 2096406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096416 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2096419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096445 */     // GIR_Coverage, 16525,
     /* 2096445 */     GIR_EraseRootFromParent_Done,
     /* 2096446 */   // Label 27807: @2096446
     /* 2096446 */   GIM_Try, /*On fail goto*//*Label 27808*/ GIMT_Encode4(2096540), // Rule ID 16528 //
     /* 2096451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2096462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2096465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2096468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2096471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096497 */     // MIs[0] round
     /* 2096497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096500 */     // MIs[0] policy
     /* 2096500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096510 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2096513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096539 */     // GIR_Coverage, 16528,
     /* 2096539 */     GIR_EraseRootFromParent_Done,
     /* 2096540 */   // Label 27808: @2096540
     /* 2096540 */   GIM_Try, /*On fail goto*//*Label 27809*/ GIMT_Encode4(2096634), // Rule ID 16529 //
     /* 2096545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2096548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2096556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2096559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2096562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2096565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096591 */     // MIs[0] round
     /* 2096591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096594 */     // MIs[0] policy
     /* 2096594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096604 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2096607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096633 */     // GIR_Coverage, 16529,
     /* 2096633 */     GIR_EraseRootFromParent_Done,
     /* 2096634 */   // Label 27809: @2096634
     /* 2096634 */   GIM_Try, /*On fail goto*//*Label 27810*/ GIMT_Encode4(2096728), // Rule ID 16532 //
     /* 2096639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2096650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2096653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2096656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2096659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096685 */     // MIs[0] round
     /* 2096685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096688 */     // MIs[0] policy
     /* 2096688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096698 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2096701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096727 */     // GIR_Coverage, 16532,
     /* 2096727 */     GIR_EraseRootFromParent_Done,
     /* 2096728 */   // Label 27810: @2096728
     /* 2096728 */   GIM_Try, /*On fail goto*//*Label 27811*/ GIMT_Encode4(2096822), // Rule ID 16533 //
     /* 2096733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2096736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2096744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2096747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2096750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2096753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096779 */     // MIs[0] round
     /* 2096779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096782 */     // MIs[0] policy
     /* 2096782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096792 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2096795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096821 */     // GIR_Coverage, 16533,
     /* 2096821 */     GIR_EraseRootFromParent_Done,
     /* 2096822 */   // Label 27811: @2096822
     /* 2096822 */   GIM_Try, /*On fail goto*//*Label 27812*/ GIMT_Encode4(2096916), // Rule ID 16536 //
     /* 2096827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2096838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2096841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2096844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2096847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096873 */     // MIs[0] round
     /* 2096873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096876 */     // MIs[0] policy
     /* 2096876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096886 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2096889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096915 */     // GIR_Coverage, 16536,
     /* 2096915 */     GIR_EraseRootFromParent_Done,
     /* 2096916 */   // Label 27812: @2096916
     /* 2096916 */   GIM_Try, /*On fail goto*//*Label 27813*/ GIMT_Encode4(2097010), // Rule ID 16537 //
     /* 2096921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2096924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2096932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2096935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2096938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2096941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096967 */     // MIs[0] round
     /* 2096967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096970 */     // MIs[0] policy
     /* 2096970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096980 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2096983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097009 */     // GIR_Coverage, 16537,
     /* 2097009 */     GIR_EraseRootFromParent_Done,
     /* 2097010 */   // Label 27813: @2097010
     /* 2097010 */   GIM_Try, /*On fail goto*//*Label 27814*/ GIMT_Encode4(2097104), // Rule ID 16540 //
     /* 2097015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2097026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2097029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2097032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2097035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097061 */     // MIs[0] round
     /* 2097061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097064 */     // MIs[0] policy
     /* 2097064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097074 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2097077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097103 */     // GIR_Coverage, 16540,
     /* 2097103 */     GIR_EraseRootFromParent_Done,
     /* 2097104 */   // Label 27814: @2097104
     /* 2097104 */   GIM_Try, /*On fail goto*//*Label 27815*/ GIMT_Encode4(2097198), // Rule ID 16541 //
     /* 2097109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2097120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2097123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2097126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2097129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097155 */     // MIs[0] round
     /* 2097155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097158 */     // MIs[0] policy
     /* 2097158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097168 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2097171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097197 */     // GIR_Coverage, 16541,
     /* 2097197 */     GIR_EraseRootFromParent_Done,
     /* 2097198 */   // Label 27815: @2097198
     /* 2097198 */   GIM_Try, /*On fail goto*//*Label 27816*/ GIMT_Encode4(2097292), // Rule ID 16544 //
     /* 2097203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2097214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2097217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2097220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2097223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2097226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097249 */     // MIs[0] round
     /* 2097249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097252 */     // MIs[0] policy
     /* 2097252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097262 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2097265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097291 */     // GIR_Coverage, 16544,
     /* 2097291 */     GIR_EraseRootFromParent_Done,
     /* 2097292 */   // Label 27816: @2097292
     /* 2097292 */   GIM_Try, /*On fail goto*//*Label 27817*/ GIMT_Encode4(2097386), // Rule ID 16545 //
     /* 2097297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2097308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2097311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2097314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2097317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2097320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097343 */     // MIs[0] round
     /* 2097343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097346 */     // MIs[0] policy
     /* 2097346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097356 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2097359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097385 */     // GIR_Coverage, 16545,
     /* 2097385 */     GIR_EraseRootFromParent_Done,
     /* 2097386 */   // Label 27817: @2097386
     /* 2097386 */   GIM_Try, /*On fail goto*//*Label 27818*/ GIMT_Encode4(2097480), // Rule ID 16548 //
     /* 2097391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2097402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2097405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2097408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2097411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097437 */     // MIs[0] round
     /* 2097437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097440 */     // MIs[0] policy
     /* 2097440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097450 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2097453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097479 */     // GIR_Coverage, 16548,
     /* 2097479 */     GIR_EraseRootFromParent_Done,
     /* 2097480 */   // Label 27818: @2097480
     /* 2097480 */   GIM_Try, /*On fail goto*//*Label 27819*/ GIMT_Encode4(2097574), // Rule ID 16549 //
     /* 2097485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2097496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2097499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2097502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2097505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097531 */     // MIs[0] round
     /* 2097531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097534 */     // MIs[0] policy
     /* 2097534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097544 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2097547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097573 */     // GIR_Coverage, 16549,
     /* 2097573 */     GIR_EraseRootFromParent_Done,
     /* 2097574 */   // Label 27819: @2097574
     /* 2097574 */   GIM_Try, /*On fail goto*//*Label 27820*/ GIMT_Encode4(2097668), // Rule ID 16552 //
     /* 2097579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2097590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2097593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2097596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2097599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097625 */     // MIs[0] round
     /* 2097625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097628 */     // MIs[0] policy
     /* 2097628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097638 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2097641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097667 */     // GIR_Coverage, 16552,
     /* 2097667 */     GIR_EraseRootFromParent_Done,
     /* 2097668 */   // Label 27820: @2097668
     /* 2097668 */   GIM_Try, /*On fail goto*//*Label 27821*/ GIMT_Encode4(2097762), // Rule ID 16553 //
     /* 2097673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2097684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2097687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2097690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2097693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097719 */     // MIs[0] round
     /* 2097719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097722 */     // MIs[0] policy
     /* 2097722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097732 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2097735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097761 */     // GIR_Coverage, 16553,
     /* 2097761 */     GIR_EraseRootFromParent_Done,
     /* 2097762 */   // Label 27821: @2097762
     /* 2097762 */   GIM_Try, /*On fail goto*//*Label 27822*/ GIMT_Encode4(2097856), // Rule ID 16556 //
     /* 2097767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2097778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2097781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2097784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2097787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097813 */     // MIs[0] round
     /* 2097813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097816 */     // MIs[0] policy
     /* 2097816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097826 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2097829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097855 */     // GIR_Coverage, 16556,
     /* 2097855 */     GIR_EraseRootFromParent_Done,
     /* 2097856 */   // Label 27822: @2097856
     /* 2097856 */   GIM_Try, /*On fail goto*//*Label 27823*/ GIMT_Encode4(2097950), // Rule ID 16557 //
     /* 2097861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2097872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2097875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2097878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2097881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097907 */     // MIs[0] round
     /* 2097907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097910 */     // MIs[0] policy
     /* 2097910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097920 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2097923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097949 */     // GIR_Coverage, 16557,
     /* 2097949 */     GIR_EraseRootFromParent_Done,
     /* 2097950 */   // Label 27823: @2097950
     /* 2097950 */   GIM_Try, /*On fail goto*//*Label 27824*/ GIMT_Encode4(2098044), // Rule ID 16560 //
     /* 2097955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2097966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2097969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2097972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2097975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098001 */     // MIs[0] round
     /* 2098001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098004 */     // MIs[0] policy
     /* 2098004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2098017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098043 */     // GIR_Coverage, 16560,
     /* 2098043 */     GIR_EraseRootFromParent_Done,
     /* 2098044 */   // Label 27824: @2098044
     /* 2098044 */   GIM_Try, /*On fail goto*//*Label 27825*/ GIMT_Encode4(2098138), // Rule ID 16561 //
     /* 2098049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2098060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2098063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2098066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2098069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098095 */     // MIs[0] round
     /* 2098095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098098 */     // MIs[0] policy
     /* 2098098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098108 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2098111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098137 */     // GIR_Coverage, 16561,
     /* 2098137 */     GIR_EraseRootFromParent_Done,
     /* 2098138 */   // Label 27825: @2098138
     /* 2098138 */   GIM_Try, /*On fail goto*//*Label 27826*/ GIMT_Encode4(2098232), // Rule ID 16564 //
     /* 2098143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2098154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2098157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2098160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2098163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098189 */     // MIs[0] round
     /* 2098189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098192 */     // MIs[0] policy
     /* 2098192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098202 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2098205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098231 */     // GIR_Coverage, 16564,
     /* 2098231 */     GIR_EraseRootFromParent_Done,
     /* 2098232 */   // Label 27826: @2098232
     /* 2098232 */   GIM_Try, /*On fail goto*//*Label 27827*/ GIMT_Encode4(2098326), // Rule ID 16565 //
     /* 2098237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2098248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2098251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2098254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2098257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098283 */     // MIs[0] round
     /* 2098283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098286 */     // MIs[0] policy
     /* 2098286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2098299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098325 */     // GIR_Coverage, 16565,
     /* 2098325 */     GIR_EraseRootFromParent_Done,
     /* 2098326 */   // Label 27827: @2098326
     /* 2098326 */   GIM_Try, /*On fail goto*//*Label 27828*/ GIMT_Encode4(2098420), // Rule ID 16568 //
     /* 2098331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2098334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2098342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2098345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2098348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2098351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098377 */     // MIs[0] round
     /* 2098377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098380 */     // MIs[0] policy
     /* 2098380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098390 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2098393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098419 */     // GIR_Coverage, 16568,
     /* 2098419 */     GIR_EraseRootFromParent_Done,
     /* 2098420 */   // Label 27828: @2098420
     /* 2098420 */   GIM_Try, /*On fail goto*//*Label 27829*/ GIMT_Encode4(2098514), // Rule ID 16569 //
     /* 2098425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2098428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2098436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2098439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2098442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2098445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098471 */     // MIs[0] round
     /* 2098471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098474 */     // MIs[0] policy
     /* 2098474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2098487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098513 */     // GIR_Coverage, 16569,
     /* 2098513 */     GIR_EraseRootFromParent_Done,
     /* 2098514 */   // Label 27829: @2098514
     /* 2098514 */   GIM_Try, /*On fail goto*//*Label 27830*/ GIMT_Encode4(2098608), // Rule ID 16572 //
     /* 2098519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2098522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2098530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2098533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2098536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2098539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098565 */     // MIs[0] round
     /* 2098565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098568 */     // MIs[0] policy
     /* 2098568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098578 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2098581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098607 */     // GIR_Coverage, 16572,
     /* 2098607 */     GIR_EraseRootFromParent_Done,
     /* 2098608 */   // Label 27830: @2098608
     /* 2098608 */   GIM_Try, /*On fail goto*//*Label 27831*/ GIMT_Encode4(2098702), // Rule ID 16573 //
     /* 2098613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2098616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2098624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2098627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2098630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2098633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098659 */     // MIs[0] round
     /* 2098659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098662 */     // MIs[0] policy
     /* 2098662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098672 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2098675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098701 */     // GIR_Coverage, 16573,
     /* 2098701 */     GIR_EraseRootFromParent_Done,
     /* 2098702 */   // Label 27831: @2098702
     /* 2098702 */   GIM_Try, /*On fail goto*//*Label 27832*/ GIMT_Encode4(2098796), // Rule ID 16576 //
     /* 2098707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2098710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2098718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2098721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2098724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2098727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098753 */     // MIs[0] round
     /* 2098753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098756 */     // MIs[0] policy
     /* 2098756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2098769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098795 */     // GIR_Coverage, 16576,
     /* 2098795 */     GIR_EraseRootFromParent_Done,
     /* 2098796 */   // Label 27832: @2098796
     /* 2098796 */   GIM_Try, /*On fail goto*//*Label 27833*/ GIMT_Encode4(2098890), // Rule ID 16577 //
     /* 2098801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2098804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2098812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2098815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2098818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2098821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098847 */     // MIs[0] round
     /* 2098847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098850 */     // MIs[0] policy
     /* 2098850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098860 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2098863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098889 */     // GIR_Coverage, 16577,
     /* 2098889 */     GIR_EraseRootFromParent_Done,
     /* 2098890 */   // Label 27833: @2098890
     /* 2098890 */   GIM_Try, /*On fail goto*//*Label 27834*/ GIMT_Encode4(2098984), // Rule ID 16580 //
     /* 2098895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2098898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2098906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2098909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2098912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2098915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098941 */     // MIs[0] round
     /* 2098941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098944 */     // MIs[0] policy
     /* 2098944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098954 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2098957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098983 */     // GIR_Coverage, 16580,
     /* 2098983 */     GIR_EraseRootFromParent_Done,
     /* 2098984 */   // Label 27834: @2098984
     /* 2098984 */   GIM_Try, /*On fail goto*//*Label 27835*/ GIMT_Encode4(2099078), // Rule ID 16581 //
     /* 2098989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2098992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2099000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2099003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2099006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2099009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2099019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099035 */     // MIs[0] round
     /* 2099035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099038 */     // MIs[0] policy
     /* 2099038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099048 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2099051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099077 */     // GIR_Coverage, 16581,
     /* 2099077 */     GIR_EraseRootFromParent_Done,
     /* 2099078 */   // Label 27835: @2099078
     /* 2099078 */   GIM_Try, /*On fail goto*//*Label 27836*/ GIMT_Encode4(2099172), // Rule ID 16584 //
     /* 2099083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2099094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2099097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2099100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099129 */     // MIs[0] round
     /* 2099129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099132 */     // MIs[0] policy
     /* 2099132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099142 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2099145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099171 */     // GIR_Coverage, 16584,
     /* 2099171 */     GIR_EraseRootFromParent_Done,
     /* 2099172 */   // Label 27836: @2099172
     /* 2099172 */   GIM_Try, /*On fail goto*//*Label 27837*/ GIMT_Encode4(2099266), // Rule ID 16585 //
     /* 2099177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2099188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2099191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2099194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099223 */     // MIs[0] round
     /* 2099223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099226 */     // MIs[0] policy
     /* 2099226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099236 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2099239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099265 */     // GIR_Coverage, 16585,
     /* 2099265 */     GIR_EraseRootFromParent_Done,
     /* 2099266 */   // Label 27837: @2099266
     /* 2099266 */   GIM_Try, /*On fail goto*//*Label 27838*/ GIMT_Encode4(2099360), // Rule ID 16588 //
     /* 2099271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2099282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2099285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2099288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099317 */     // MIs[0] round
     /* 2099317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099320 */     // MIs[0] policy
     /* 2099320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099330 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2099333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099359 */     // GIR_Coverage, 16588,
     /* 2099359 */     GIR_EraseRootFromParent_Done,
     /* 2099360 */   // Label 27838: @2099360
     /* 2099360 */   GIM_Try, /*On fail goto*//*Label 27839*/ GIMT_Encode4(2099454), // Rule ID 16589 //
     /* 2099365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2099376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2099379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2099382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099411 */     // MIs[0] round
     /* 2099411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099414 */     // MIs[0] policy
     /* 2099414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099424 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2099427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099453 */     // GIR_Coverage, 16589,
     /* 2099453 */     GIR_EraseRootFromParent_Done,
     /* 2099454 */   // Label 27839: @2099454
     /* 2099454 */   GIM_Try, /*On fail goto*//*Label 27840*/ GIMT_Encode4(2099548), // Rule ID 16592 //
     /* 2099459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2099470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2099473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2099476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099505 */     // MIs[0] round
     /* 2099505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099508 */     // MIs[0] policy
     /* 2099508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099518 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2099521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099547 */     // GIR_Coverage, 16592,
     /* 2099547 */     GIR_EraseRootFromParent_Done,
     /* 2099548 */   // Label 27840: @2099548
     /* 2099548 */   GIM_Try, /*On fail goto*//*Label 27841*/ GIMT_Encode4(2099642), // Rule ID 16593 //
     /* 2099553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2099564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2099567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2099570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099599 */     // MIs[0] round
     /* 2099599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099602 */     // MIs[0] policy
     /* 2099602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099612 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2099615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099641 */     // GIR_Coverage, 16593,
     /* 2099641 */     GIR_EraseRootFromParent_Done,
     /* 2099642 */   // Label 27841: @2099642
     /* 2099642 */   GIM_Try, /*On fail goto*//*Label 27842*/ GIMT_Encode4(2099736), // Rule ID 16596 //
     /* 2099647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2099658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2099661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2099664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099693 */     // MIs[0] round
     /* 2099693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099696 */     // MIs[0] policy
     /* 2099696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099706 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2099709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099735 */     // GIR_Coverage, 16596,
     /* 2099735 */     GIR_EraseRootFromParent_Done,
     /* 2099736 */   // Label 27842: @2099736
     /* 2099736 */   GIM_Try, /*On fail goto*//*Label 27843*/ GIMT_Encode4(2099830), // Rule ID 16597 //
     /* 2099741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2099752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2099755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2099758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099787 */     // MIs[0] round
     /* 2099787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099790 */     // MIs[0] policy
     /* 2099790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099800 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2099803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099829 */     // GIR_Coverage, 16597,
     /* 2099829 */     GIR_EraseRootFromParent_Done,
     /* 2099830 */   // Label 27843: @2099830
     /* 2099830 */   GIM_Try, /*On fail goto*//*Label 27844*/ GIMT_Encode4(2099924), // Rule ID 16600 //
     /* 2099835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2099846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2099849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2099852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2099858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099881 */     // MIs[0] round
     /* 2099881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099884 */     // MIs[0] policy
     /* 2099884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099894 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2099897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099923 */     // GIR_Coverage, 16600,
     /* 2099923 */     GIR_EraseRootFromParent_Done,
     /* 2099924 */   // Label 27844: @2099924
     /* 2099924 */   GIM_Try, /*On fail goto*//*Label 27845*/ GIMT_Encode4(2100018), // Rule ID 16601 //
     /* 2099929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2099940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2099943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2099946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2099952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099975 */     // MIs[0] round
     /* 2099975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099978 */     // MIs[0] policy
     /* 2099978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099988 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2099991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100013 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100017 */     // GIR_Coverage, 16601,
     /* 2100017 */     GIR_EraseRootFromParent_Done,
     /* 2100018 */   // Label 27845: @2100018
     /* 2100018 */   GIM_Try, /*On fail goto*//*Label 27846*/ GIMT_Encode4(2100112), // Rule ID 16604 //
     /* 2100023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2100034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2100037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2100040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2100046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100069 */     // MIs[0] round
     /* 2100069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100072 */     // MIs[0] policy
     /* 2100072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100082 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2100085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100111 */     // GIR_Coverage, 16604,
     /* 2100111 */     GIR_EraseRootFromParent_Done,
     /* 2100112 */   // Label 27846: @2100112
     /* 2100112 */   GIM_Try, /*On fail goto*//*Label 27847*/ GIMT_Encode4(2100206), // Rule ID 16605 //
     /* 2100117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2100128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2100131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2100134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2100140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100163 */     // MIs[0] round
     /* 2100163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100166 */     // MIs[0] policy
     /* 2100166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100176 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2100179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100205 */     // GIR_Coverage, 16605,
     /* 2100205 */     GIR_EraseRootFromParent_Done,
     /* 2100206 */   // Label 27847: @2100206
     /* 2100206 */   GIM_Try, /*On fail goto*//*Label 27848*/ GIMT_Encode4(2100300), // Rule ID 16608 //
     /* 2100211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2100222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2100225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2100228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100257 */     // MIs[0] round
     /* 2100257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100260 */     // MIs[0] policy
     /* 2100260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100270 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2100273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100299 */     // GIR_Coverage, 16608,
     /* 2100299 */     GIR_EraseRootFromParent_Done,
     /* 2100300 */   // Label 27848: @2100300
     /* 2100300 */   GIM_Try, /*On fail goto*//*Label 27849*/ GIMT_Encode4(2100394), // Rule ID 16609 //
     /* 2100305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2100316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2100319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2100322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100351 */     // MIs[0] round
     /* 2100351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100354 */     // MIs[0] policy
     /* 2100354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100364 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2100367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100393 */     // GIR_Coverage, 16609,
     /* 2100393 */     GIR_EraseRootFromParent_Done,
     /* 2100394 */   // Label 27849: @2100394
     /* 2100394 */   GIM_Try, /*On fail goto*//*Label 27850*/ GIMT_Encode4(2100488), // Rule ID 16612 //
     /* 2100399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2100410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2100413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2100416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2100422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100445 */     // MIs[0] round
     /* 2100445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100448 */     // MIs[0] policy
     /* 2100448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100458 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2100461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100487 */     // GIR_Coverage, 16612,
     /* 2100487 */     GIR_EraseRootFromParent_Done,
     /* 2100488 */   // Label 27850: @2100488
     /* 2100488 */   GIM_Try, /*On fail goto*//*Label 27851*/ GIMT_Encode4(2100582), // Rule ID 16613 //
     /* 2100493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2100504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2100507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2100510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2100516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100539 */     // MIs[0] round
     /* 2100539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100542 */     // MIs[0] policy
     /* 2100542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2100555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100581 */     // GIR_Coverage, 16613,
     /* 2100581 */     GIR_EraseRootFromParent_Done,
     /* 2100582 */   // Label 27851: @2100582
     /* 2100582 */   GIM_Try, /*On fail goto*//*Label 27852*/ GIMT_Encode4(2100676), // Rule ID 16616 //
     /* 2100587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2100598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2100601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2100604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2100610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100633 */     // MIs[0] round
     /* 2100633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100636 */     // MIs[0] policy
     /* 2100636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2100649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100675 */     // GIR_Coverage, 16616,
     /* 2100675 */     GIR_EraseRootFromParent_Done,
     /* 2100676 */   // Label 27852: @2100676
     /* 2100676 */   GIM_Try, /*On fail goto*//*Label 27853*/ GIMT_Encode4(2100770), // Rule ID 16617 //
     /* 2100681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2100692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2100695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2100698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2100704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100727 */     // MIs[0] round
     /* 2100727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100730 */     // MIs[0] policy
     /* 2100730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100740 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2100743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100769 */     // GIR_Coverage, 16617,
     /* 2100769 */     GIR_EraseRootFromParent_Done,
     /* 2100770 */   // Label 27853: @2100770
     /* 2100770 */   GIM_Try, /*On fail goto*//*Label 27854*/ GIMT_Encode4(2100864), // Rule ID 16620 //
     /* 2100775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2100786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2100789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2100792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100821 */     // MIs[0] round
     /* 2100821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100824 */     // MIs[0] policy
     /* 2100824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100834 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2100837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100863 */     // GIR_Coverage, 16620,
     /* 2100863 */     GIR_EraseRootFromParent_Done,
     /* 2100864 */   // Label 27854: @2100864
     /* 2100864 */   GIM_Try, /*On fail goto*//*Label 27855*/ GIMT_Encode4(2100958), // Rule ID 16621 //
     /* 2100869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2100880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2100883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2100886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100915 */     // MIs[0] round
     /* 2100915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100918 */     // MIs[0] policy
     /* 2100918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100928 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2100931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100957 */     // GIR_Coverage, 16621,
     /* 2100957 */     GIR_EraseRootFromParent_Done,
     /* 2100958 */   // Label 27855: @2100958
     /* 2100958 */   GIM_Try, /*On fail goto*//*Label 27856*/ GIMT_Encode4(2101052), // Rule ID 16624 //
     /* 2100963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2100974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2100977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2100980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2100986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101009 */     // MIs[0] round
     /* 2101009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101012 */     // MIs[0] policy
     /* 2101012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101022 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2101025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101051 */     // GIR_Coverage, 16624,
     /* 2101051 */     GIR_EraseRootFromParent_Done,
     /* 2101052 */   // Label 27856: @2101052
     /* 2101052 */   GIM_Try, /*On fail goto*//*Label 27857*/ GIMT_Encode4(2101146), // Rule ID 16625 //
     /* 2101057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2101068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2101071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2101074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2101080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101103 */     // MIs[0] round
     /* 2101103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101106 */     // MIs[0] policy
     /* 2101106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101116 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2101119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101145 */     // GIR_Coverage, 16625,
     /* 2101145 */     GIR_EraseRootFromParent_Done,
     /* 2101146 */   // Label 27857: @2101146
     /* 2101146 */   GIM_Try, /*On fail goto*//*Label 27858*/ GIMT_Encode4(2101240), // Rule ID 16628 //
     /* 2101151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2101162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2101165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2101168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101197 */     // MIs[0] round
     /* 2101197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101200 */     // MIs[0] policy
     /* 2101200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101210 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2101213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101239 */     // GIR_Coverage, 16628,
     /* 2101239 */     GIR_EraseRootFromParent_Done,
     /* 2101240 */   // Label 27858: @2101240
     /* 2101240 */   GIM_Try, /*On fail goto*//*Label 27859*/ GIMT_Encode4(2101334), // Rule ID 16629 //
     /* 2101245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2101256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2101259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2101262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101291 */     // MIs[0] round
     /* 2101291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101294 */     // MIs[0] policy
     /* 2101294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101304 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2101307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101333 */     // GIR_Coverage, 16629,
     /* 2101333 */     GIR_EraseRootFromParent_Done,
     /* 2101334 */   // Label 27859: @2101334
     /* 2101334 */   GIM_Try, /*On fail goto*//*Label 27860*/ GIMT_Encode4(2101428), // Rule ID 16632 //
     /* 2101339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2101350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2101353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2101356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101385 */     // MIs[0] round
     /* 2101385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101388 */     // MIs[0] policy
     /* 2101388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101398 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2101401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101427 */     // GIR_Coverage, 16632,
     /* 2101427 */     GIR_EraseRootFromParent_Done,
     /* 2101428 */   // Label 27860: @2101428
     /* 2101428 */   GIM_Try, /*On fail goto*//*Label 27861*/ GIMT_Encode4(2101522), // Rule ID 16633 //
     /* 2101433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2101444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2101447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2101450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101479 */     // MIs[0] round
     /* 2101479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101482 */     // MIs[0] policy
     /* 2101482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2101495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101521 */     // GIR_Coverage, 16633,
     /* 2101521 */     GIR_EraseRootFromParent_Done,
     /* 2101522 */   // Label 27861: @2101522
     /* 2101522 */   GIM_Try, /*On fail goto*//*Label 27862*/ GIMT_Encode4(2101616), // Rule ID 16636 //
     /* 2101527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2101538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2101541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2101544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101573 */     // MIs[0] round
     /* 2101573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101576 */     // MIs[0] policy
     /* 2101576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2101589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101615 */     // GIR_Coverage, 16636,
     /* 2101615 */     GIR_EraseRootFromParent_Done,
     /* 2101616 */   // Label 27862: @2101616
     /* 2101616 */   GIM_Try, /*On fail goto*//*Label 27863*/ GIMT_Encode4(2101710), // Rule ID 16637 //
     /* 2101621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2101632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2101635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2101638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101667 */     // MIs[0] round
     /* 2101667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101670 */     // MIs[0] policy
     /* 2101670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2101683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101709 */     // GIR_Coverage, 16637,
     /* 2101709 */     GIR_EraseRootFromParent_Done,
     /* 2101710 */   // Label 27863: @2101710
     /* 2101710 */   GIM_Try, /*On fail goto*//*Label 27864*/ GIMT_Encode4(2101804), // Rule ID 16640 //
     /* 2101715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2101726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2101729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2101732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101761 */     // MIs[0] round
     /* 2101761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101764 */     // MIs[0] policy
     /* 2101764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101774 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2101777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101803 */     // GIR_Coverage, 16640,
     /* 2101803 */     GIR_EraseRootFromParent_Done,
     /* 2101804 */   // Label 27864: @2101804
     /* 2101804 */   GIM_Try, /*On fail goto*//*Label 27865*/ GIMT_Encode4(2101898), // Rule ID 16641 //
     /* 2101809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2101820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2101823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2101826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101855 */     // MIs[0] round
     /* 2101855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101858 */     // MIs[0] policy
     /* 2101858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2101871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101897 */     // GIR_Coverage, 16641,
     /* 2101897 */     GIR_EraseRootFromParent_Done,
     /* 2101898 */   // Label 27865: @2101898
     /* 2101898 */   GIM_Try, /*On fail goto*//*Label 27866*/ GIMT_Encode4(2101989), // Rule ID 16704 //
     /* 2101903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2101906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2101911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2101914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2101917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2101920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2101923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101949 */     // MIs[0] round
     /* 2101949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101952 */     // MIs[0] policy
     /* 2101952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101962 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2101965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101988 */     // GIR_Coverage, 16704,
     /* 2101988 */     GIR_EraseRootFromParent_Done,
     /* 2101989 */   // Label 27866: @2101989
     /* 2101989 */   GIM_Try, /*On fail goto*//*Label 27867*/ GIMT_Encode4(2102080), // Rule ID 16705 //
     /* 2101994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2101997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2102005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2102008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2102011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2102014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102040 */     // MIs[0] round
     /* 2102040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102043 */     // MIs[0] policy
     /* 2102043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102053 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2102056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102079 */     // GIR_Coverage, 16705,
     /* 2102079 */     GIR_EraseRootFromParent_Done,
     /* 2102080 */   // Label 27867: @2102080
     /* 2102080 */   GIM_Try, /*On fail goto*//*Label 27868*/ GIMT_Encode4(2102171), // Rule ID 16708 //
     /* 2102085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2102096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2102099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2102102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2102105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102131 */     // MIs[0] round
     /* 2102131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102134 */     // MIs[0] policy
     /* 2102134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102144 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2102147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102170 */     // GIR_Coverage, 16708,
     /* 2102170 */     GIR_EraseRootFromParent_Done,
     /* 2102171 */   // Label 27868: @2102171
     /* 2102171 */   GIM_Try, /*On fail goto*//*Label 27869*/ GIMT_Encode4(2102262), // Rule ID 16709 //
     /* 2102176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2102179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2102187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2102190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2102193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2102196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102222 */     // MIs[0] round
     /* 2102222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102225 */     // MIs[0] policy
     /* 2102225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102235 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2102238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102261 */     // GIR_Coverage, 16709,
     /* 2102261 */     GIR_EraseRootFromParent_Done,
     /* 2102262 */   // Label 27869: @2102262
     /* 2102262 */   GIM_Try, /*On fail goto*//*Label 27870*/ GIMT_Encode4(2102353), // Rule ID 16712 //
     /* 2102267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2102270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2102278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2102281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2102284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2102287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102313 */     // MIs[0] round
     /* 2102313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102316 */     // MIs[0] policy
     /* 2102316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102326 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2102329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102352 */     // GIR_Coverage, 16712,
     /* 2102352 */     GIR_EraseRootFromParent_Done,
     /* 2102353 */   // Label 27870: @2102353
     /* 2102353 */   GIM_Try, /*On fail goto*//*Label 27871*/ GIMT_Encode4(2102444), // Rule ID 16713 //
     /* 2102358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2102361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2102369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2102372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2102375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2102378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102404 */     // MIs[0] round
     /* 2102404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102407 */     // MIs[0] policy
     /* 2102407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102417 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2102420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102443 */     // GIR_Coverage, 16713,
     /* 2102443 */     GIR_EraseRootFromParent_Done,
     /* 2102444 */   // Label 27871: @2102444
     /* 2102444 */   GIM_Try, /*On fail goto*//*Label 27872*/ GIMT_Encode4(2102535), // Rule ID 16716 //
     /* 2102449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2102460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2102463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2102466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2102469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102495 */     // MIs[0] round
     /* 2102495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102498 */     // MIs[0] policy
     /* 2102498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102508 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2102511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102534 */     // GIR_Coverage, 16716,
     /* 2102534 */     GIR_EraseRootFromParent_Done,
     /* 2102535 */   // Label 27872: @2102535
     /* 2102535 */   GIM_Try, /*On fail goto*//*Label 27873*/ GIMT_Encode4(2102626), // Rule ID 16717 //
     /* 2102540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2102543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2102551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2102554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2102557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2102560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102586 */     // MIs[0] round
     /* 2102586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102589 */     // MIs[0] policy
     /* 2102589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102599 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2102602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102625 */     // GIR_Coverage, 16717,
     /* 2102625 */     GIR_EraseRootFromParent_Done,
     /* 2102626 */   // Label 27873: @2102626
     /* 2102626 */   GIM_Try, /*On fail goto*//*Label 27874*/ GIMT_Encode4(2102717), // Rule ID 16720 //
     /* 2102631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2102634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2102642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2102645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2102648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2102651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102677 */     // MIs[0] round
     /* 2102677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102680 */     // MIs[0] policy
     /* 2102680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102690 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2102693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102716 */     // GIR_Coverage, 16720,
     /* 2102716 */     GIR_EraseRootFromParent_Done,
     /* 2102717 */   // Label 27874: @2102717
     /* 2102717 */   GIM_Try, /*On fail goto*//*Label 27875*/ GIMT_Encode4(2102808), // Rule ID 16721 //
     /* 2102722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2102725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2102733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2102736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2102739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2102742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102768 */     // MIs[0] round
     /* 2102768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102771 */     // MIs[0] policy
     /* 2102771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102781 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2102784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102807 */     // GIR_Coverage, 16721,
     /* 2102807 */     GIR_EraseRootFromParent_Done,
     /* 2102808 */   // Label 27875: @2102808
     /* 2102808 */   GIM_Try, /*On fail goto*//*Label 27876*/ GIMT_Encode4(2102899), // Rule ID 16724 //
     /* 2102813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2102816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2102824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2102827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2102830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2102833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102859 */     // MIs[0] round
     /* 2102859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102862 */     // MIs[0] policy
     /* 2102862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102872 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2102875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102898 */     // GIR_Coverage, 16724,
     /* 2102898 */     GIR_EraseRootFromParent_Done,
     /* 2102899 */   // Label 27876: @2102899
     /* 2102899 */   GIM_Try, /*On fail goto*//*Label 27877*/ GIMT_Encode4(2102990), // Rule ID 16725 //
     /* 2102904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2102907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2102915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2102918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2102921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2102924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102950 */     // MIs[0] round
     /* 2102950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102953 */     // MIs[0] policy
     /* 2102953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102963 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2102966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102989 */     // GIR_Coverage, 16725,
     /* 2102989 */     GIR_EraseRootFromParent_Done,
     /* 2102990 */   // Label 27877: @2102990
     /* 2102990 */   GIM_Try, /*On fail goto*//*Label 27878*/ GIMT_Encode4(2103081), // Rule ID 16728 //
     /* 2102995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2103006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2103009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2103012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2103015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103041 */     // MIs[0] round
     /* 2103041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103044 */     // MIs[0] policy
     /* 2103044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103054 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2103057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103080 */     // GIR_Coverage, 16728,
     /* 2103080 */     GIR_EraseRootFromParent_Done,
     /* 2103081 */   // Label 27878: @2103081
     /* 2103081 */   GIM_Try, /*On fail goto*//*Label 27879*/ GIMT_Encode4(2103172), // Rule ID 16729 //
     /* 2103086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2103097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2103100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2103103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2103106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103132 */     // MIs[0] round
     /* 2103132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103135 */     // MIs[0] policy
     /* 2103135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103145 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2103148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103171 */     // GIR_Coverage, 16729,
     /* 2103171 */     GIR_EraseRootFromParent_Done,
     /* 2103172 */   // Label 27879: @2103172
     /* 2103172 */   GIM_Try, /*On fail goto*//*Label 27880*/ GIMT_Encode4(2103263), // Rule ID 16732 //
     /* 2103177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2103188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2103191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2103194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2103197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103223 */     // MIs[0] round
     /* 2103223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103226 */     // MIs[0] policy
     /* 2103226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103236 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2103239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103262 */     // GIR_Coverage, 16732,
     /* 2103262 */     GIR_EraseRootFromParent_Done,
     /* 2103263 */   // Label 27880: @2103263
     /* 2103263 */   GIM_Try, /*On fail goto*//*Label 27881*/ GIMT_Encode4(2103354), // Rule ID 16733 //
     /* 2103268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2103279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2103282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2103285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2103288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103314 */     // MIs[0] round
     /* 2103314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103317 */     // MIs[0] policy
     /* 2103317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103327 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2103330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103353 */     // GIR_Coverage, 16733,
     /* 2103353 */     GIR_EraseRootFromParent_Done,
     /* 2103354 */   // Label 27881: @2103354
     /* 2103354 */   GIM_Try, /*On fail goto*//*Label 27882*/ GIMT_Encode4(2103445), // Rule ID 16736 //
     /* 2103359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2103370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2103373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2103376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2103379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2103382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103405 */     // MIs[0] round
     /* 2103405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103408 */     // MIs[0] policy
     /* 2103408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103418 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2103421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103444 */     // GIR_Coverage, 16736,
     /* 2103444 */     GIR_EraseRootFromParent_Done,
     /* 2103445 */   // Label 27882: @2103445
     /* 2103445 */   GIM_Try, /*On fail goto*//*Label 27883*/ GIMT_Encode4(2103536), // Rule ID 16737 //
     /* 2103450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2103461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2103464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2103467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2103470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2103473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103496 */     // MIs[0] round
     /* 2103496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103499 */     // MIs[0] policy
     /* 2103499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103509 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2103512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103535 */     // GIR_Coverage, 16737,
     /* 2103535 */     GIR_EraseRootFromParent_Done,
     /* 2103536 */   // Label 27883: @2103536
     /* 2103536 */   GIM_Try, /*On fail goto*//*Label 27884*/ GIMT_Encode4(2103627), // Rule ID 16740 //
     /* 2103541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2103552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2103555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2103558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2103561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2103564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103587 */     // MIs[0] round
     /* 2103587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103590 */     // MIs[0] policy
     /* 2103590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103600 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2103603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103626 */     // GIR_Coverage, 16740,
     /* 2103626 */     GIR_EraseRootFromParent_Done,
     /* 2103627 */   // Label 27884: @2103627
     /* 2103627 */   GIM_Try, /*On fail goto*//*Label 27885*/ GIMT_Encode4(2103718), // Rule ID 16741 //
     /* 2103632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2103635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2103643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2103646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2103649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2103652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2103655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103678 */     // MIs[0] round
     /* 2103678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103681 */     // MIs[0] policy
     /* 2103681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103691 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2103694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103717 */     // GIR_Coverage, 16741,
     /* 2103717 */     GIR_EraseRootFromParent_Done,
     /* 2103718 */   // Label 27885: @2103718
     /* 2103718 */   GIM_Try, /*On fail goto*//*Label 27886*/ GIMT_Encode4(2103809), // Rule ID 16744 //
     /* 2103723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2103734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2103737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2103740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2103743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103769 */     // MIs[0] round
     /* 2103769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103772 */     // MIs[0] policy
     /* 2103772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103782 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2103785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103808 */     // GIR_Coverage, 16744,
     /* 2103808 */     GIR_EraseRootFromParent_Done,
     /* 2103809 */   // Label 27886: @2103809
     /* 2103809 */   GIM_Try, /*On fail goto*//*Label 27887*/ GIMT_Encode4(2103900), // Rule ID 16745 //
     /* 2103814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2103817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2103825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2103828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2103831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2103834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103860 */     // MIs[0] round
     /* 2103860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103863 */     // MIs[0] policy
     /* 2103863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103873 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2103876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103899 */     // GIR_Coverage, 16745,
     /* 2103899 */     GIR_EraseRootFromParent_Done,
     /* 2103900 */   // Label 27887: @2103900
     /* 2103900 */   GIM_Try, /*On fail goto*//*Label 27888*/ GIMT_Encode4(2103991), // Rule ID 16748 //
     /* 2103905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2103916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2103919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2103922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2103925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103951 */     // MIs[0] round
     /* 2103951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103954 */     // MIs[0] policy
     /* 2103954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103964 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2103967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103990 */     // GIR_Coverage, 16748,
     /* 2103990 */     GIR_EraseRootFromParent_Done,
     /* 2103991 */   // Label 27888: @2103991
     /* 2103991 */   GIM_Try, /*On fail goto*//*Label 27889*/ GIMT_Encode4(2104082), // Rule ID 16749 //
     /* 2103996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2103999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2104007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2104010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2104013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2104016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2104019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104042 */     // MIs[0] round
     /* 2104042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104045 */     // MIs[0] policy
     /* 2104045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104055 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2104058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104081 */     // GIR_Coverage, 16749,
     /* 2104081 */     GIR_EraseRootFromParent_Done,
     /* 2104082 */   // Label 27889: @2104082
     /* 2104082 */   GIM_Try, /*On fail goto*//*Label 27890*/ GIMT_Encode4(2104173), // Rule ID 16752 //
     /* 2104087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2104098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2104101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2104104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2104107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104133 */     // MIs[0] round
     /* 2104133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104136 */     // MIs[0] policy
     /* 2104136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104146 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2104149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104172 */     // GIR_Coverage, 16752,
     /* 2104172 */     GIR_EraseRootFromParent_Done,
     /* 2104173 */   // Label 27890: @2104173
     /* 2104173 */   GIM_Try, /*On fail goto*//*Label 27891*/ GIMT_Encode4(2104264), // Rule ID 16753 //
     /* 2104178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2104189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2104192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2104195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2104198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104224 */     // MIs[0] round
     /* 2104224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104227 */     // MIs[0] policy
     /* 2104227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104237 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2104240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104263 */     // GIR_Coverage, 16753,
     /* 2104263 */     GIR_EraseRootFromParent_Done,
     /* 2104264 */   // Label 27891: @2104264
     /* 2104264 */   GIM_Try, /*On fail goto*//*Label 27892*/ GIMT_Encode4(2104355), // Rule ID 16756 //
     /* 2104269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2104280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2104283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2104286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2104289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104315 */     // MIs[0] round
     /* 2104315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104318 */     // MIs[0] policy
     /* 2104318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104328 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2104331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104354 */     // GIR_Coverage, 16756,
     /* 2104354 */     GIR_EraseRootFromParent_Done,
     /* 2104355 */   // Label 27892: @2104355
     /* 2104355 */   GIM_Try, /*On fail goto*//*Label 27893*/ GIMT_Encode4(2104446), // Rule ID 16757 //
     /* 2104360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2104371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2104374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2104377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2104380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104406 */     // MIs[0] round
     /* 2104406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104409 */     // MIs[0] policy
     /* 2104409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104419 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2104422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104445 */     // GIR_Coverage, 16757,
     /* 2104445 */     GIR_EraseRootFromParent_Done,
     /* 2104446 */   // Label 27893: @2104446
     /* 2104446 */   GIM_Try, /*On fail goto*//*Label 27894*/ GIMT_Encode4(2104537), // Rule ID 16760 //
     /* 2104451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2104462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2104465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2104468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2104471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104497 */     // MIs[0] round
     /* 2104497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104500 */     // MIs[0] policy
     /* 2104500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104510 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2104513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104536 */     // GIR_Coverage, 16760,
     /* 2104536 */     GIR_EraseRootFromParent_Done,
     /* 2104537 */   // Label 27894: @2104537
     /* 2104537 */   GIM_Try, /*On fail goto*//*Label 27895*/ GIMT_Encode4(2104628), // Rule ID 16761 //
     /* 2104542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2104553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2104556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2104559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2104562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104588 */     // MIs[0] round
     /* 2104588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104591 */     // MIs[0] policy
     /* 2104591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104601 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2104604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104627 */     // GIR_Coverage, 16761,
     /* 2104627 */     GIR_EraseRootFromParent_Done,
     /* 2104628 */   // Label 27895: @2104628
     /* 2104628 */   GIM_Try, /*On fail goto*//*Label 27896*/ GIMT_Encode4(2104719), // Rule ID 16764 //
     /* 2104633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2104636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2104644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2104647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2104650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2104656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104679 */     // MIs[0] round
     /* 2104679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104682 */     // MIs[0] policy
     /* 2104682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104692 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2104695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104718 */     // GIR_Coverage, 16764,
     /* 2104718 */     GIR_EraseRootFromParent_Done,
     /* 2104719 */   // Label 27896: @2104719
     /* 2104719 */   GIM_Try, /*On fail goto*//*Label 27897*/ GIMT_Encode4(2104810), // Rule ID 16765 //
     /* 2104724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2104727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2104735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2104738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2104741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2104747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104770 */     // MIs[0] round
     /* 2104770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104773 */     // MIs[0] policy
     /* 2104773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104783 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2104786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104809 */     // GIR_Coverage, 16765,
     /* 2104809 */     GIR_EraseRootFromParent_Done,
     /* 2104810 */   // Label 27897: @2104810
     /* 2104810 */   GIM_Try, /*On fail goto*//*Label 27898*/ GIMT_Encode4(2104901), // Rule ID 16768 //
     /* 2104815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2104818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2104826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2104829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2104832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104861 */     // MIs[0] round
     /* 2104861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104864 */     // MIs[0] policy
     /* 2104864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104874 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2104877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104900 */     // GIR_Coverage, 16768,
     /* 2104900 */     GIR_EraseRootFromParent_Done,
     /* 2104901 */   // Label 27898: @2104901
     /* 2104901 */   GIM_Try, /*On fail goto*//*Label 27899*/ GIMT_Encode4(2104992), // Rule ID 16769 //
     /* 2104906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2104909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2104917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2104920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2104923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104952 */     // MIs[0] round
     /* 2104952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104955 */     // MIs[0] policy
     /* 2104955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104965 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2104968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104991 */     // GIR_Coverage, 16769,
     /* 2104991 */     GIR_EraseRootFromParent_Done,
     /* 2104992 */   // Label 27899: @2104992
     /* 2104992 */   GIM_Try, /*On fail goto*//*Label 27900*/ GIMT_Encode4(2105083), // Rule ID 16772 //
     /* 2104997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2105000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2105008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2105011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2105014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105043 */     // MIs[0] round
     /* 2105043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105046 */     // MIs[0] policy
     /* 2105046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105056 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2105059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105082 */     // GIR_Coverage, 16772,
     /* 2105082 */     GIR_EraseRootFromParent_Done,
     /* 2105083 */   // Label 27900: @2105083
     /* 2105083 */   GIM_Try, /*On fail goto*//*Label 27901*/ GIMT_Encode4(2105174), // Rule ID 16773 //
     /* 2105088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2105091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2105099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2105102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2105105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105134 */     // MIs[0] round
     /* 2105134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105137 */     // MIs[0] policy
     /* 2105137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105147 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2105150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105173 */     // GIR_Coverage, 16773,
     /* 2105173 */     GIR_EraseRootFromParent_Done,
     /* 2105174 */   // Label 27901: @2105174
     /* 2105174 */   GIM_Try, /*On fail goto*//*Label 27902*/ GIMT_Encode4(2105265), // Rule ID 16776 //
     /* 2105179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2105190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2105193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2105196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105225 */     // MIs[0] round
     /* 2105225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105228 */     // MIs[0] policy
     /* 2105228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105238 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2105241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105264 */     // GIR_Coverage, 16776,
     /* 2105264 */     GIR_EraseRootFromParent_Done,
     /* 2105265 */   // Label 27902: @2105265
     /* 2105265 */   GIM_Try, /*On fail goto*//*Label 27903*/ GIMT_Encode4(2105356), // Rule ID 16777 //
     /* 2105270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2105273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2105281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2105284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2105287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105316 */     // MIs[0] round
     /* 2105316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105319 */     // MIs[0] policy
     /* 2105319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105329 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2105332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105355 */     // GIR_Coverage, 16777,
     /* 2105355 */     GIR_EraseRootFromParent_Done,
     /* 2105356 */   // Label 27903: @2105356
     /* 2105356 */   GIM_Try, /*On fail goto*//*Label 27904*/ GIMT_Encode4(2105447), // Rule ID 16780 //
     /* 2105361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2105364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2105372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2105375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2105378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105407 */     // MIs[0] round
     /* 2105407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105410 */     // MIs[0] policy
     /* 2105410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105420 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2105423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105446 */     // GIR_Coverage, 16780,
     /* 2105446 */     GIR_EraseRootFromParent_Done,
     /* 2105447 */   // Label 27904: @2105447
     /* 2105447 */   GIM_Try, /*On fail goto*//*Label 27905*/ GIMT_Encode4(2105538), // Rule ID 16781 //
     /* 2105452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2105455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2105463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2105466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2105469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105498 */     // MIs[0] round
     /* 2105498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105501 */     // MIs[0] policy
     /* 2105501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105511 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2105514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105537 */     // GIR_Coverage, 16781,
     /* 2105537 */     GIR_EraseRootFromParent_Done,
     /* 2105538 */   // Label 27905: @2105538
     /* 2105538 */   GIM_Try, /*On fail goto*//*Label 27906*/ GIMT_Encode4(2105629), // Rule ID 16784 //
     /* 2105543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2105546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2105554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2105557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2105560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2105585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105589 */     // MIs[0] round
     /* 2105589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105592 */     // MIs[0] policy
     /* 2105592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105602 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2105605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105628 */     // GIR_Coverage, 16784,
     /* 2105628 */     GIR_EraseRootFromParent_Done,
     /* 2105629 */   // Label 27906: @2105629
     /* 2105629 */   GIM_Try, /*On fail goto*//*Label 27907*/ GIMT_Encode4(2105720), // Rule ID 16785 //
     /* 2105634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2105637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2105645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2105648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2105651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2105676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105680 */     // MIs[0] round
     /* 2105680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105683 */     // MIs[0] policy
     /* 2105683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105693 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2105696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105719 */     // GIR_Coverage, 16785,
     /* 2105719 */     GIR_EraseRootFromParent_Done,
     /* 2105720 */   // Label 27907: @2105720
     /* 2105720 */   GIM_Try, /*On fail goto*//*Label 27908*/ GIMT_Encode4(2105811), // Rule ID 16788 //
     /* 2105725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2105736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2105739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2105742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2105755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105771 */     // MIs[0] round
     /* 2105771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105774 */     // MIs[0] policy
     /* 2105774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105784 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2105787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105810 */     // GIR_Coverage, 16788,
     /* 2105810 */     GIR_EraseRootFromParent_Done,
     /* 2105811 */   // Label 27908: @2105811
     /* 2105811 */   GIM_Try, /*On fail goto*//*Label 27909*/ GIMT_Encode4(2105902), // Rule ID 16789 //
     /* 2105816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2105819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2105827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2105830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2105833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2105846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105862 */     // MIs[0] round
     /* 2105862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105865 */     // MIs[0] policy
     /* 2105865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105875 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2105878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105901 */     // GIR_Coverage, 16789,
     /* 2105901 */     GIR_EraseRootFromParent_Done,
     /* 2105902 */   // Label 27909: @2105902
     /* 2105902 */   GIM_Try, /*On fail goto*//*Label 27910*/ GIMT_Encode4(2105993), // Rule ID 16792 //
     /* 2105907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2105918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2105921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2105924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2105930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2105937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105953 */     // MIs[0] round
     /* 2105953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105956 */     // MIs[0] policy
     /* 2105956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105966 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2105969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105992 */     // GIR_Coverage, 16792,
     /* 2105992 */     GIR_EraseRootFromParent_Done,
     /* 2105993 */   // Label 27910: @2105993
     /* 2105993 */   GIM_Try, /*On fail goto*//*Label 27911*/ GIMT_Encode4(2106084), // Rule ID 16793 //
     /* 2105998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2106009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2106012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2106015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2106021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106044 */     // MIs[0] round
     /* 2106044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106047 */     // MIs[0] policy
     /* 2106047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106057 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2106060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106083 */     // GIR_Coverage, 16793,
     /* 2106083 */     GIR_EraseRootFromParent_Done,
     /* 2106084 */   // Label 27911: @2106084
     /* 2106084 */   GIM_Try, /*On fail goto*//*Label 27912*/ GIMT_Encode4(2106175), // Rule ID 16796 //
     /* 2106089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2106092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2106100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2106103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2106106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2106112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106135 */     // MIs[0] round
     /* 2106135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106138 */     // MIs[0] policy
     /* 2106138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106148 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2106151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106174 */     // GIR_Coverage, 16796,
     /* 2106174 */     GIR_EraseRootFromParent_Done,
     /* 2106175 */   // Label 27912: @2106175
     /* 2106175 */   GIM_Try, /*On fail goto*//*Label 27913*/ GIMT_Encode4(2106266), // Rule ID 16797 //
     /* 2106180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2106191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2106194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2106197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2106203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106226 */     // MIs[0] round
     /* 2106226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106229 */     // MIs[0] policy
     /* 2106229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106239 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2106242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106265 */     // GIR_Coverage, 16797,
     /* 2106265 */     GIR_EraseRootFromParent_Done,
     /* 2106266 */   // Label 27913: @2106266
     /* 2106266 */   GIM_Try, /*On fail goto*//*Label 27914*/ GIMT_Encode4(2106357), // Rule ID 16800 //
     /* 2106271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2106282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2106285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2106288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106317 */     // MIs[0] round
     /* 2106317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106320 */     // MIs[0] policy
     /* 2106320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106330 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2106333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106356 */     // GIR_Coverage, 16800,
     /* 2106356 */     GIR_EraseRootFromParent_Done,
     /* 2106357 */   // Label 27914: @2106357
     /* 2106357 */   GIM_Try, /*On fail goto*//*Label 27915*/ GIMT_Encode4(2106448), // Rule ID 16801 //
     /* 2106362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2106365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2106373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2106376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2106379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106408 */     // MIs[0] round
     /* 2106408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106411 */     // MIs[0] policy
     /* 2106411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106421 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2106424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106447 */     // GIR_Coverage, 16801,
     /* 2106447 */     GIR_EraseRootFromParent_Done,
     /* 2106448 */   // Label 27915: @2106448
     /* 2106448 */   GIM_Try, /*On fail goto*//*Label 27916*/ GIMT_Encode4(2106539), // Rule ID 16804 //
     /* 2106453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2106464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2106467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2106470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106499 */     // MIs[0] round
     /* 2106499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106502 */     // MIs[0] policy
     /* 2106502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106512 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2106515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106538 */     // GIR_Coverage, 16804,
     /* 2106538 */     GIR_EraseRootFromParent_Done,
     /* 2106539 */   // Label 27916: @2106539
     /* 2106539 */   GIM_Try, /*On fail goto*//*Label 27917*/ GIMT_Encode4(2106630), // Rule ID 16805 //
     /* 2106544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2106547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2106555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2106558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2106561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106590 */     // MIs[0] round
     /* 2106590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106593 */     // MIs[0] policy
     /* 2106593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106603 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2106606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106629 */     // GIR_Coverage, 16805,
     /* 2106629 */     GIR_EraseRootFromParent_Done,
     /* 2106630 */   // Label 27917: @2106630
     /* 2106630 */   GIM_Try, /*On fail goto*//*Label 27918*/ GIMT_Encode4(2106721), // Rule ID 16808 //
     /* 2106635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2106646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2106649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2106652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2106658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106681 */     // MIs[0] round
     /* 2106681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106684 */     // MIs[0] policy
     /* 2106684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106694 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2106697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106720 */     // GIR_Coverage, 16808,
     /* 2106720 */     GIR_EraseRootFromParent_Done,
     /* 2106721 */   // Label 27918: @2106721
     /* 2106721 */   GIM_Try, /*On fail goto*//*Label 27919*/ GIMT_Encode4(2106812), // Rule ID 16809 //
     /* 2106726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2106729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2106737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2106740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2106743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2106749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106772 */     // MIs[0] round
     /* 2106772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106775 */     // MIs[0] policy
     /* 2106775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106785 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2106788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106811 */     // GIR_Coverage, 16809,
     /* 2106811 */     GIR_EraseRootFromParent_Done,
     /* 2106812 */   // Label 27919: @2106812
     /* 2106812 */   GIM_Try, /*On fail goto*//*Label 27920*/ GIMT_Encode4(2106903), // Rule ID 16812 //
     /* 2106817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2106820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2106828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2106831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2106834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2106837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2106840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2106859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106863 */     // MIs[0] round
     /* 2106863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106866 */     // MIs[0] policy
     /* 2106866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106876 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2106879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106902 */     // GIR_Coverage, 16812,
     /* 2106902 */     GIR_EraseRootFromParent_Done,
     /* 2106903 */   // Label 27920: @2106903
     /* 2106903 */   GIM_Try, /*On fail goto*//*Label 27921*/ GIMT_Encode4(2106994), // Rule ID 16813 //
     /* 2106908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2106911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2106919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2106922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2106925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2106928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2106931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2106950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106954 */     // MIs[0] round
     /* 2106954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106957 */     // MIs[0] policy
     /* 2106957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106967 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2106970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106993 */     // GIR_Coverage, 16813,
     /* 2106993 */     GIR_EraseRootFromParent_Done,
     /* 2106994 */   // Label 27921: @2106994
     /* 2106994 */   GIM_Try, /*On fail goto*//*Label 27922*/ GIMT_Encode4(2107085), // Rule ID 16816 //
     /* 2106999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2107002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2107010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2107013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2107016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107045 */     // MIs[0] round
     /* 2107045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107048 */     // MIs[0] policy
     /* 2107048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107058 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2107061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107084 */     // GIR_Coverage, 16816,
     /* 2107084 */     GIR_EraseRootFromParent_Done,
     /* 2107085 */   // Label 27922: @2107085
     /* 2107085 */   GIM_Try, /*On fail goto*//*Label 27923*/ GIMT_Encode4(2107176), // Rule ID 16817 //
     /* 2107090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2107093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2107101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2107104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2107107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107136 */     // MIs[0] round
     /* 2107136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107139 */     // MIs[0] policy
     /* 2107139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107149 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2107152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107175 */     // GIR_Coverage, 16817,
     /* 2107175 */     GIR_EraseRootFromParent_Done,
     /* 2107176 */   // Label 27923: @2107176
     /* 2107176 */   GIM_Try, /*On fail goto*//*Label 27924*/ GIMT_Encode4(2107267), // Rule ID 16820 //
     /* 2107181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2107184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2107192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2107195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2107198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107227 */     // MIs[0] round
     /* 2107227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107230 */     // MIs[0] policy
     /* 2107230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107240 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2107243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107266 */     // GIR_Coverage, 16820,
     /* 2107266 */     GIR_EraseRootFromParent_Done,
     /* 2107267 */   // Label 27924: @2107267
     /* 2107267 */   GIM_Try, /*On fail goto*//*Label 27925*/ GIMT_Encode4(2107358), // Rule ID 16821 //
     /* 2107272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2107275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2107283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2107286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2107289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107318 */     // MIs[0] round
     /* 2107318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107321 */     // MIs[0] policy
     /* 2107321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107331 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2107334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107357 */     // GIR_Coverage, 16821,
     /* 2107357 */     GIR_EraseRootFromParent_Done,
     /* 2107358 */   // Label 27925: @2107358
     /* 2107358 */   GIM_Try, /*On fail goto*//*Label 27926*/ GIMT_Encode4(2107449), // Rule ID 16824 //
     /* 2107363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2107366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2107374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2107377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2107380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2107383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107409 */     // MIs[0] round
     /* 2107409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107412 */     // MIs[0] policy
     /* 2107412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107422 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2107425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107448 */     // GIR_Coverage, 16824,
     /* 2107448 */     GIR_EraseRootFromParent_Done,
     /* 2107449 */   // Label 27926: @2107449
     /* 2107449 */   GIM_Try, /*On fail goto*//*Label 27927*/ GIMT_Encode4(2107540), // Rule ID 16825 //
     /* 2107454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2107457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2107465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2107468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2107471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2107474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107500 */     // MIs[0] round
     /* 2107500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107503 */     // MIs[0] policy
     /* 2107503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107513 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2107516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107539 */     // GIR_Coverage, 16825,
     /* 2107539 */     GIR_EraseRootFromParent_Done,
     /* 2107540 */   // Label 27927: @2107540
     /* 2107540 */   GIM_Try, /*On fail goto*//*Label 27928*/ GIMT_Encode4(2107631), // Rule ID 16828 //
     /* 2107545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2107548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2107556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2107559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2107562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2107565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2107568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107591 */     // MIs[0] round
     /* 2107591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107594 */     // MIs[0] policy
     /* 2107594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107604 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2107607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107630 */     // GIR_Coverage, 16828,
     /* 2107630 */     GIR_EraseRootFromParent_Done,
     /* 2107631 */   // Label 27928: @2107631
     /* 2107631 */   GIM_Try, /*On fail goto*//*Label 27929*/ GIMT_Encode4(2107722), // Rule ID 16829 //
     /* 2107636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2107639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2107647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2107650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2107653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2107656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2107659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107682 */     // MIs[0] round
     /* 2107682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107685 */     // MIs[0] policy
     /* 2107685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107695 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2107698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107721 */     // GIR_Coverage, 16829,
     /* 2107721 */     GIR_EraseRootFromParent_Done,
     /* 2107722 */   // Label 27929: @2107722
     /* 2107722 */   GIM_Try, /*On fail goto*//*Label 27930*/ GIMT_Encode4(2107813), // Rule ID 16832 //
     /* 2107727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2107730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2107738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2107741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2107744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2107747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107773 */     // MIs[0] round
     /* 2107773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107776 */     // MIs[0] policy
     /* 2107776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107786 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2107789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107812 */     // GIR_Coverage, 16832,
     /* 2107812 */     GIR_EraseRootFromParent_Done,
     /* 2107813 */   // Label 27930: @2107813
     /* 2107813 */   GIM_Try, /*On fail goto*//*Label 27931*/ GIMT_Encode4(2107904), // Rule ID 16833 //
     /* 2107818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2107821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2107829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2107832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2107835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2107838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107864 */     // MIs[0] round
     /* 2107864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107867 */     // MIs[0] policy
     /* 2107867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107877 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2107880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107903 */     // GIR_Coverage, 16833,
     /* 2107903 */     GIR_EraseRootFromParent_Done,
     /* 2107904 */   // Label 27931: @2107904
     /* 2107904 */   GIM_Try, /*On fail goto*//*Label 27932*/ GIMT_Encode4(2107995), // Rule ID 16836 //
     /* 2107909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2107912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2107920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2107923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2107926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2107929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107955 */     // MIs[0] round
     /* 2107955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107958 */     // MIs[0] policy
     /* 2107958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107968 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2107971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107994 */     // GIR_Coverage, 16836,
     /* 2107994 */     GIR_EraseRootFromParent_Done,
     /* 2107995 */   // Label 27932: @2107995
     /* 2107995 */   GIM_Try, /*On fail goto*//*Label 27933*/ GIMT_Encode4(2108086), // Rule ID 16837 //
     /* 2108000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2108003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2108011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2108014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2108017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2108020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2108023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108046 */     // MIs[0] round
     /* 2108046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108049 */     // MIs[0] policy
     /* 2108049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108059 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2108062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108085 */     // GIR_Coverage, 16837,
     /* 2108085 */     GIR_EraseRootFromParent_Done,
     /* 2108086 */   // Label 27933: @2108086
     /* 2108086 */   GIM_Try, /*On fail goto*//*Label 27934*/ GIMT_Encode4(2108177), // Rule ID 16840 //
     /* 2108091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2108094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2108102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2108105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2108108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2108111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108137 */     // MIs[0] round
     /* 2108137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108140 */     // MIs[0] policy
     /* 2108140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108150 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2108153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108176 */     // GIR_Coverage, 16840,
     /* 2108176 */     GIR_EraseRootFromParent_Done,
     /* 2108177 */   // Label 27934: @2108177
     /* 2108177 */   GIM_Try, /*On fail goto*//*Label 27935*/ GIMT_Encode4(2108268), // Rule ID 16841 //
     /* 2108182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2108185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2108193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2108196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2108199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2108202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108228 */     // MIs[0] round
     /* 2108228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108231 */     // MIs[0] policy
     /* 2108231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108241 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2108244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108267 */     // GIR_Coverage, 16841,
     /* 2108267 */     GIR_EraseRootFromParent_Done,
     /* 2108268 */   // Label 27935: @2108268
     /* 2108268 */   GIM_Try, /*On fail goto*//*Label 27936*/ GIMT_Encode4(2108359), // Rule ID 16844 //
     /* 2108273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2108276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2108284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2108287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2108290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2108293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108319 */     // MIs[0] round
     /* 2108319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108322 */     // MIs[0] policy
     /* 2108322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108332 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2108335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108358 */     // GIR_Coverage, 16844,
     /* 2108358 */     GIR_EraseRootFromParent_Done,
     /* 2108359 */   // Label 27936: @2108359
     /* 2108359 */   GIM_Try, /*On fail goto*//*Label 27937*/ GIMT_Encode4(2108450), // Rule ID 16845 //
     /* 2108364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2108367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2108375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2108378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2108381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2108384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108410 */     // MIs[0] round
     /* 2108410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108413 */     // MIs[0] policy
     /* 2108413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108423 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2108426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108449 */     // GIR_Coverage, 16845,
     /* 2108449 */     GIR_EraseRootFromParent_Done,
     /* 2108450 */   // Label 27937: @2108450
     /* 2108450 */   GIM_Try, /*On fail goto*//*Label 27938*/ GIMT_Encode4(2108541), // Rule ID 16848 //
     /* 2108455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2108466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2108469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2108472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2108475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2108478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2108485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108501 */     // MIs[0] round
     /* 2108501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108504 */     // MIs[0] policy
     /* 2108504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108514 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2108517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108540 */     // GIR_Coverage, 16848,
     /* 2108540 */     GIR_EraseRootFromParent_Done,
     /* 2108541 */   // Label 27938: @2108541
     /* 2108541 */   GIM_Try, /*On fail goto*//*Label 27939*/ GIMT_Encode4(2108632), // Rule ID 16849 //
     /* 2108546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2108549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2108557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2108560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2108563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2108566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2108569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2108576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108592 */     // MIs[0] round
     /* 2108592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108595 */     // MIs[0] policy
     /* 2108595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108605 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2108608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108631 */     // GIR_Coverage, 16849,
     /* 2108631 */     GIR_EraseRootFromParent_Done,
     /* 2108632 */   // Label 27939: @2108632
     /* 2108632 */   GIM_Try, /*On fail goto*//*Label 27940*/ GIMT_Encode4(2108723), // Rule ID 16852 //
     /* 2108637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2108648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2108651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2108654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2108657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2108660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2108667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108683 */     // MIs[0] round
     /* 2108683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108686 */     // MIs[0] policy
     /* 2108686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108696 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2108699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108722 */     // GIR_Coverage, 16852,
     /* 2108722 */     GIR_EraseRootFromParent_Done,
     /* 2108723 */   // Label 27940: @2108723
     /* 2108723 */   GIM_Try, /*On fail goto*//*Label 27941*/ GIMT_Encode4(2108814), // Rule ID 16853 //
     /* 2108728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2108731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2108739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2108742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2108745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2108748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2108751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2108758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108774 */     // MIs[0] round
     /* 2108774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108777 */     // MIs[0] policy
     /* 2108777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108787 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2108790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108813 */     // GIR_Coverage, 16853,
     /* 2108813 */     GIR_EraseRootFromParent_Done,
     /* 2108814 */   // Label 27941: @2108814
     /* 2108814 */   GIM_Try, /*On fail goto*//*Label 27942*/ GIMT_Encode4(2108905), // Rule ID 16856 //
     /* 2108819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2108830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2108833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2108836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2108839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2108842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2108849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108865 */     // MIs[0] round
     /* 2108865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108868 */     // MIs[0] policy
     /* 2108868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108878 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2108881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108904 */     // GIR_Coverage, 16856,
     /* 2108904 */     GIR_EraseRootFromParent_Done,
     /* 2108905 */   // Label 27942: @2108905
     /* 2108905 */   GIM_Try, /*On fail goto*//*Label 27943*/ GIMT_Encode4(2108996), // Rule ID 16857 //
     /* 2108910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2108913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2108921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2108924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2108927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2108930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2108933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2108940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108956 */     // MIs[0] round
     /* 2108956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108959 */     // MIs[0] policy
     /* 2108959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108969 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2108972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108995 */     // GIR_Coverage, 16857,
     /* 2108995 */     GIR_EraseRootFromParent_Done,
     /* 2108996 */   // Label 27943: @2108996
     /* 2108996 */   GIM_Try, /*On fail goto*//*Label 27944*/ GIMT_Encode4(2109087), // Rule ID 16860 //
     /* 2109001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2109004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2109012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2109015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2109018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2109021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109047 */     // MIs[0] round
     /* 2109047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109050 */     // MIs[0] policy
     /* 2109050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109060 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2109063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109086 */     // GIR_Coverage, 16860,
     /* 2109086 */     GIR_EraseRootFromParent_Done,
     /* 2109087 */   // Label 27944: @2109087
     /* 2109087 */   GIM_Try, /*On fail goto*//*Label 27945*/ GIMT_Encode4(2109178), // Rule ID 16861 //
     /* 2109092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2109095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2109103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2109106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2109109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2109112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109138 */     // MIs[0] round
     /* 2109138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109141 */     // MIs[0] policy
     /* 2109141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109151 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2109154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109177 */     // GIR_Coverage, 16861,
     /* 2109177 */     GIR_EraseRootFromParent_Done,
     /* 2109178 */   // Label 27945: @2109178
     /* 2109178 */   GIM_Try, /*On fail goto*//*Label 27946*/ GIMT_Encode4(2109269), // Rule ID 16864 //
     /* 2109183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2109186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2109194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2109197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2109200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2109203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109229 */     // MIs[0] round
     /* 2109229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109232 */     // MIs[0] policy
     /* 2109232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109242 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2109245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109268 */     // GIR_Coverage, 16864,
     /* 2109268 */     GIR_EraseRootFromParent_Done,
     /* 2109269 */   // Label 27946: @2109269
     /* 2109269 */   GIM_Try, /*On fail goto*//*Label 27947*/ GIMT_Encode4(2109360), // Rule ID 16865 //
     /* 2109274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2109277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2109285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2109288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2109291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2109294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109320 */     // MIs[0] round
     /* 2109320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109323 */     // MIs[0] policy
     /* 2109323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109333 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2109336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109359 */     // GIR_Coverage, 16865,
     /* 2109359 */     GIR_EraseRootFromParent_Done,
     /* 2109360 */   // Label 27947: @2109360
     /* 2109360 */   GIM_Try, /*On fail goto*//*Label 27948*/ GIMT_Encode4(2109451), // Rule ID 16868 //
     /* 2109365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2109368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2109376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2109379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2109382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2109385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109411 */     // MIs[0] round
     /* 2109411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109414 */     // MIs[0] policy
     /* 2109414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109424 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2109427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109450 */     // GIR_Coverage, 16868,
     /* 2109450 */     GIR_EraseRootFromParent_Done,
     /* 2109451 */   // Label 27948: @2109451
     /* 2109451 */   GIM_Try, /*On fail goto*//*Label 27949*/ GIMT_Encode4(2109542), // Rule ID 16869 //
     /* 2109456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2109459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2109467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2109470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2109473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2109476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109502 */     // MIs[0] round
     /* 2109502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109505 */     // MIs[0] policy
     /* 2109505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109515 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2109518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109541 */     // GIR_Coverage, 16869,
     /* 2109541 */     GIR_EraseRootFromParent_Done,
     /* 2109542 */   // Label 27949: @2109542
     /* 2109542 */   GIM_Try, /*On fail goto*//*Label 27950*/ GIMT_Encode4(2109633), // Rule ID 16872 //
     /* 2109547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2109550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2109558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2109561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2109564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2109567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2109570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109593 */     // MIs[0] round
     /* 2109593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109596 */     // MIs[0] policy
     /* 2109596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109606 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2109609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109632 */     // GIR_Coverage, 16872,
     /* 2109632 */     GIR_EraseRootFromParent_Done,
     /* 2109633 */   // Label 27950: @2109633
     /* 2109633 */   GIM_Try, /*On fail goto*//*Label 27951*/ GIMT_Encode4(2109724), // Rule ID 16873 //
     /* 2109638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2109641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2109649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2109652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2109655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2109658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2109661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109684 */     // MIs[0] round
     /* 2109684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109687 */     // MIs[0] policy
     /* 2109687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109697 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2109700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109723 */     // GIR_Coverage, 16873,
     /* 2109723 */     GIR_EraseRootFromParent_Done,
     /* 2109724 */   // Label 27951: @2109724
     /* 2109724 */   GIM_Try, /*On fail goto*//*Label 27952*/ GIMT_Encode4(2109815), // Rule ID 16876 //
     /* 2109729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2109732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2109740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2109743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2109746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2109749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109775 */     // MIs[0] round
     /* 2109775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109778 */     // MIs[0] policy
     /* 2109778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109788 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2109791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109814 */     // GIR_Coverage, 16876,
     /* 2109814 */     GIR_EraseRootFromParent_Done,
     /* 2109815 */   // Label 27952: @2109815
     /* 2109815 */   GIM_Try, /*On fail goto*//*Label 27953*/ GIMT_Encode4(2109906), // Rule ID 16877 //
     /* 2109820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2109823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2109831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2109834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2109837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2109840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109866 */     // MIs[0] round
     /* 2109866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109869 */     // MIs[0] policy
     /* 2109869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109879 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2109882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109905 */     // GIR_Coverage, 16877,
     /* 2109905 */     GIR_EraseRootFromParent_Done,
     /* 2109906 */   // Label 27953: @2109906
     /* 2109906 */   GIM_Try, /*On fail goto*//*Label 27954*/ GIMT_Encode4(2109997), // Rule ID 16880 //
     /* 2109911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2109914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2109922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2109925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2109928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2109931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109957 */     // MIs[0] round
     /* 2109957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109960 */     // MIs[0] policy
     /* 2109960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109970 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2109973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109996 */     // GIR_Coverage, 16880,
     /* 2109996 */     GIR_EraseRootFromParent_Done,
     /* 2109997 */   // Label 27954: @2109997
     /* 2109997 */   GIM_Try, /*On fail goto*//*Label 27955*/ GIMT_Encode4(2110088), // Rule ID 16881 //
     /* 2110002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2110005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2110013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2110016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2110019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2110022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110048 */     // MIs[0] round
     /* 2110048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110051 */     // MIs[0] policy
     /* 2110051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110061 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2110064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110087 */     // GIR_Coverage, 16881,
     /* 2110087 */     GIR_EraseRootFromParent_Done,
     /* 2110088 */   // Label 27955: @2110088
     /* 2110088 */   GIM_Try, /*On fail goto*//*Label 27956*/ GIMT_Encode4(2110179), // Rule ID 16884 //
     /* 2110093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2110096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2110104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2110107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2110110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110139 */     // MIs[0] round
     /* 2110139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110142 */     // MIs[0] policy
     /* 2110142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110152 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2110155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110178 */     // GIR_Coverage, 16884,
     /* 2110178 */     GIR_EraseRootFromParent_Done,
     /* 2110179 */   // Label 27956: @2110179
     /* 2110179 */   GIM_Try, /*On fail goto*//*Label 27957*/ GIMT_Encode4(2110270), // Rule ID 16885 //
     /* 2110184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2110187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2110195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2110198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2110201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110230 */     // MIs[0] round
     /* 2110230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110233 */     // MIs[0] policy
     /* 2110233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110243 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2110246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110269 */     // GIR_Coverage, 16885,
     /* 2110269 */     GIR_EraseRootFromParent_Done,
     /* 2110270 */   // Label 27957: @2110270
     /* 2110270 */   GIM_Try, /*On fail goto*//*Label 27958*/ GIMT_Encode4(2110361), // Rule ID 16888 //
     /* 2110275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2110278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2110286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2110289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2110292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110321 */     // MIs[0] round
     /* 2110321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110324 */     // MIs[0] policy
     /* 2110324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110334 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2110337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110360 */     // GIR_Coverage, 16888,
     /* 2110360 */     GIR_EraseRootFromParent_Done,
     /* 2110361 */   // Label 27958: @2110361
     /* 2110361 */   GIM_Try, /*On fail goto*//*Label 27959*/ GIMT_Encode4(2110452), // Rule ID 16889 //
     /* 2110366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2110369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2110377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2110380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2110383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110412 */     // MIs[0] round
     /* 2110412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110415 */     // MIs[0] policy
     /* 2110415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110425 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2110428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110451 */     // GIR_Coverage, 16889,
     /* 2110451 */     GIR_EraseRootFromParent_Done,
     /* 2110452 */   // Label 27959: @2110452
     /* 2110452 */   GIM_Try, /*On fail goto*//*Label 27960*/ GIMT_Encode4(2110543), // Rule ID 16892 //
     /* 2110457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2110460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2110468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2110471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2110474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110503 */     // MIs[0] round
     /* 2110503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110506 */     // MIs[0] policy
     /* 2110506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110516 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2110519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110542 */     // GIR_Coverage, 16892,
     /* 2110542 */     GIR_EraseRootFromParent_Done,
     /* 2110543 */   // Label 27960: @2110543
     /* 2110543 */   GIM_Try, /*On fail goto*//*Label 27961*/ GIMT_Encode4(2110634), // Rule ID 16893 //
     /* 2110548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2110551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2110559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2110562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2110565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110594 */     // MIs[0] round
     /* 2110594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110597 */     // MIs[0] policy
     /* 2110597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110607 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2110610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110633 */     // GIR_Coverage, 16893,
     /* 2110633 */     GIR_EraseRootFromParent_Done,
     /* 2110634 */   // Label 27961: @2110634
     /* 2110634 */   GIM_Try, /*On fail goto*//*Label 27962*/ GIMT_Encode4(2110725), // Rule ID 16896 //
     /* 2110639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2110642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2110650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2110653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2110656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110685 */     // MIs[0] round
     /* 2110685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110688 */     // MIs[0] policy
     /* 2110688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110698 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2110701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110724 */     // GIR_Coverage, 16896,
     /* 2110724 */     GIR_EraseRootFromParent_Done,
     /* 2110725 */   // Label 27962: @2110725
     /* 2110725 */   GIM_Try, /*On fail goto*//*Label 27963*/ GIMT_Encode4(2110816), // Rule ID 16897 //
     /* 2110730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2110733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2110741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2110744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2110747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110776 */     // MIs[0] round
     /* 2110776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110779 */     // MIs[0] policy
     /* 2110779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110789 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2110792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110815 */     // GIR_Coverage, 16897,
     /* 2110815 */     GIR_EraseRootFromParent_Done,
     /* 2110816 */   // Label 27963: @2110816
     /* 2110816 */   GIM_Try, /*On fail goto*//*Label 27964*/ GIMT_Encode4(2110907), // Rule ID 16900 //
     /* 2110821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2110824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2110832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2110835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2110838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110867 */     // MIs[0] round
     /* 2110867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110870 */     // MIs[0] policy
     /* 2110870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110880 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2110883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110906 */     // GIR_Coverage, 16900,
     /* 2110906 */     GIR_EraseRootFromParent_Done,
     /* 2110907 */   // Label 27964: @2110907
     /* 2110907 */   GIM_Try, /*On fail goto*//*Label 27965*/ GIMT_Encode4(2110998), // Rule ID 16901 //
     /* 2110912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2110915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2110923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2110926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2110929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110958 */     // MIs[0] round
     /* 2110958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110961 */     // MIs[0] policy
     /* 2110961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110971 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2110974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110997 */     // GIR_Coverage, 16901,
     /* 2110997 */     GIR_EraseRootFromParent_Done,
     /* 2110998 */   // Label 27965: @2110998
     /* 2110998 */   GIM_Try, /*On fail goto*//*Label 27966*/ GIMT_Encode4(2111089), // Rule ID 16904 //
     /* 2111003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2111006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2111014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2111017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2111020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2111023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2111045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111049 */     // MIs[0] round
     /* 2111049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111052 */     // MIs[0] policy
     /* 2111052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111062 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2111065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2111085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111088 */     // GIR_Coverage, 16904,
     /* 2111088 */     GIR_EraseRootFromParent_Done,
     /* 2111089 */   // Label 27966: @2111089
     /* 2111089 */   GIM_Try, /*On fail goto*//*Label 27967*/ GIMT_Encode4(2111180), // Rule ID 16905 //
     /* 2111094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2111097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2111105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2111108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2111111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2111114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2111136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111140 */     // MIs[0] round
     /* 2111140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111143 */     // MIs[0] policy
     /* 2111143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111153 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2111156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2111176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111179 */     // GIR_Coverage, 16905,
     /* 2111179 */     GIR_EraseRootFromParent_Done,
     /* 2111180 */   // Label 27967: @2111180
     /* 2111180 */   GIM_Try, /*On fail goto*//*Label 27968*/ GIMT_Encode4(2111271), // Rule ID 16908 //
     /* 2111185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2111196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2111199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2111202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111231 */     // MIs[0] round
     /* 2111231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111234 */     // MIs[0] policy
     /* 2111234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111244 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2111247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111270 */     // GIR_Coverage, 16908,
     /* 2111270 */     GIR_EraseRootFromParent_Done,
     /* 2111271 */   // Label 27968: @2111271
     /* 2111271 */   GIM_Try, /*On fail goto*//*Label 27969*/ GIMT_Encode4(2111362), // Rule ID 16909 //
     /* 2111276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2111287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2111290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2111293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111322 */     // MIs[0] round
     /* 2111322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111325 */     // MIs[0] policy
     /* 2111325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111335 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2111338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111361 */     // GIR_Coverage, 16909,
     /* 2111361 */     GIR_EraseRootFromParent_Done,
     /* 2111362 */   // Label 27969: @2111362
     /* 2111362 */   GIM_Try, /*On fail goto*//*Label 27970*/ GIMT_Encode4(2111453), // Rule ID 16912 //
     /* 2111367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2111378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2111381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2111384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2111390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111413 */     // MIs[0] round
     /* 2111413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111416 */     // MIs[0] policy
     /* 2111416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111426 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2111429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111452 */     // GIR_Coverage, 16912,
     /* 2111452 */     GIR_EraseRootFromParent_Done,
     /* 2111453 */   // Label 27970: @2111453
     /* 2111453 */   GIM_Try, /*On fail goto*//*Label 27971*/ GIMT_Encode4(2111544), // Rule ID 16913 //
     /* 2111458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2111469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2111472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2111475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2111481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111504 */     // MIs[0] round
     /* 2111504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111507 */     // MIs[0] policy
     /* 2111507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111517 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2111520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111543 */     // GIR_Coverage, 16913,
     /* 2111543 */     GIR_EraseRootFromParent_Done,
     /* 2111544 */   // Label 27971: @2111544
     /* 2111544 */   GIM_Try, /*On fail goto*//*Label 27972*/ GIMT_Encode4(2111635), // Rule ID 16916 //
     /* 2111549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2111560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2111563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2111566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2111572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2111579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111595 */     // MIs[0] round
     /* 2111595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111598 */     // MIs[0] policy
     /* 2111598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111608 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2111611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111634 */     // GIR_Coverage, 16916,
     /* 2111634 */     GIR_EraseRootFromParent_Done,
     /* 2111635 */   // Label 27972: @2111635
     /* 2111635 */   GIM_Try, /*On fail goto*//*Label 27973*/ GIMT_Encode4(2111726), // Rule ID 16917 //
     /* 2111640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2111651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2111654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2111657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2111663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2111670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111686 */     // MIs[0] round
     /* 2111686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111689 */     // MIs[0] policy
     /* 2111689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111699 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2111702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111725 */     // GIR_Coverage, 16917,
     /* 2111725 */     GIR_EraseRootFromParent_Done,
     /* 2111726 */   // Label 27973: @2111726
     /* 2111726 */   GIM_Try, /*On fail goto*//*Label 27974*/ GIMT_Encode4(2111817), // Rule ID 16920 //
     /* 2111731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2111734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2111742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2111745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2111748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111777 */     // MIs[0] round
     /* 2111777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111780 */     // MIs[0] policy
     /* 2111780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111790 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2111793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111816 */     // GIR_Coverage, 16920,
     /* 2111816 */     GIR_EraseRootFromParent_Done,
     /* 2111817 */   // Label 27974: @2111817
     /* 2111817 */   GIM_Try, /*On fail goto*//*Label 27975*/ GIMT_Encode4(2111908), // Rule ID 16921 //
     /* 2111822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2111825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2111833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2111836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2111839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111868 */     // MIs[0] round
     /* 2111868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111871 */     // MIs[0] policy
     /* 2111871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111881 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2111884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111907 */     // GIR_Coverage, 16921,
     /* 2111907 */     GIR_EraseRootFromParent_Done,
     /* 2111908 */   // Label 27975: @2111908
     /* 2111908 */   GIM_Try, /*On fail goto*//*Label 27976*/ GIMT_Encode4(2111999), // Rule ID 16924 //
     /* 2111913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2111916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2111924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2111927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2111930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111959 */     // MIs[0] round
     /* 2111959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111962 */     // MIs[0] policy
     /* 2111962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111972 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2111975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111998 */     // GIR_Coverage, 16924,
     /* 2111998 */     GIR_EraseRootFromParent_Done,
     /* 2111999 */   // Label 27976: @2111999
     /* 2111999 */   GIM_Try, /*On fail goto*//*Label 27977*/ GIMT_Encode4(2112090), // Rule ID 16925 //
     /* 2112004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2112007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2112015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2112018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2112021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112050 */     // MIs[0] round
     /* 2112050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112053 */     // MIs[0] policy
     /* 2112053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112063 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2112066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112089 */     // GIR_Coverage, 16925,
     /* 2112089 */     GIR_EraseRootFromParent_Done,
     /* 2112090 */   // Label 27977: @2112090
     /* 2112090 */   GIM_Try, /*On fail goto*//*Label 27978*/ GIMT_Encode4(2112181), // Rule ID 16928 //
     /* 2112095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2112098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2112106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2112109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2112112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2112118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112141 */     // MIs[0] round
     /* 2112141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112144 */     // MIs[0] policy
     /* 2112144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112154 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2112157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112180 */     // GIR_Coverage, 16928,
     /* 2112180 */     GIR_EraseRootFromParent_Done,
     /* 2112181 */   // Label 27978: @2112181
     /* 2112181 */   GIM_Try, /*On fail goto*//*Label 27979*/ GIMT_Encode4(2112272), // Rule ID 16929 //
     /* 2112186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2112189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2112197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2112200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2112203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2112209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112232 */     // MIs[0] round
     /* 2112232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112235 */     // MIs[0] policy
     /* 2112235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112245 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2112248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112271 */     // GIR_Coverage, 16929,
     /* 2112271 */     GIR_EraseRootFromParent_Done,
     /* 2112272 */   // Label 27979: @2112272
     /* 2112272 */   GIM_Try, /*On fail goto*//*Label 27980*/ GIMT_Encode4(2112363), // Rule ID 16932 //
     /* 2112277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2112280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2112288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2112291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2112294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2112300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112323 */     // MIs[0] round
     /* 2112323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112326 */     // MIs[0] policy
     /* 2112326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112336 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2112339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112362 */     // GIR_Coverage, 16932,
     /* 2112362 */     GIR_EraseRootFromParent_Done,
     /* 2112363 */   // Label 27980: @2112363
     /* 2112363 */   GIM_Try, /*On fail goto*//*Label 27981*/ GIMT_Encode4(2112454), // Rule ID 16933 //
     /* 2112368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2112371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2112379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2112382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2112385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2112391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112414 */     // MIs[0] round
     /* 2112414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112417 */     // MIs[0] policy
     /* 2112417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112427 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2112430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112453 */     // GIR_Coverage, 16933,
     /* 2112453 */     GIR_EraseRootFromParent_Done,
     /* 2112454 */   // Label 27981: @2112454
     /* 2112454 */   GIM_Try, /*On fail goto*//*Label 27982*/ GIMT_Encode4(2112545), // Rule ID 16936 //
     /* 2112459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2112462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2112470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2112473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2112476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112505 */     // MIs[0] round
     /* 2112505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112508 */     // MIs[0] policy
     /* 2112508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112518 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2112521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112544 */     // GIR_Coverage, 16936,
     /* 2112544 */     GIR_EraseRootFromParent_Done,
     /* 2112545 */   // Label 27982: @2112545
     /* 2112545 */   GIM_Try, /*On fail goto*//*Label 27983*/ GIMT_Encode4(2112636), // Rule ID 16937 //
     /* 2112550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2112553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2112561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2112564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2112567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112596 */     // MIs[0] round
     /* 2112596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112599 */     // MIs[0] policy
     /* 2112599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112609 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2112612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112635 */     // GIR_Coverage, 16937,
     /* 2112635 */     GIR_EraseRootFromParent_Done,
     /* 2112636 */   // Label 27983: @2112636
     /* 2112636 */   GIM_Try, /*On fail goto*//*Label 27984*/ GIMT_Encode4(2112727), // Rule ID 16940 //
     /* 2112641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2112644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2112652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2112655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2112658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112687 */     // MIs[0] round
     /* 2112687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112690 */     // MIs[0] policy
     /* 2112690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112700 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2112703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112726 */     // GIR_Coverage, 16940,
     /* 2112726 */     GIR_EraseRootFromParent_Done,
     /* 2112727 */   // Label 27984: @2112727
     /* 2112727 */   GIM_Try, /*On fail goto*//*Label 27985*/ GIMT_Encode4(2112818), // Rule ID 16941 //
     /* 2112732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2112735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2112743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2112746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2112749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112778 */     // MIs[0] round
     /* 2112778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112781 */     // MIs[0] policy
     /* 2112781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112791 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2112794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112817 */     // GIR_Coverage, 16941,
     /* 2112817 */     GIR_EraseRootFromParent_Done,
     /* 2112818 */   // Label 27985: @2112818
     /* 2112818 */   GIM_Try, /*On fail goto*//*Label 27986*/ GIMT_Encode4(2112909), // Rule ID 16944 //
     /* 2112823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2112826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2112831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2112834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2112837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2112840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2112846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112869 */     // MIs[0] round
     /* 2112869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112872 */     // MIs[0] policy
     /* 2112872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112882 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2112885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112908 */     // GIR_Coverage, 16944,
     /* 2112908 */     GIR_EraseRootFromParent_Done,
     /* 2112909 */   // Label 27986: @2112909
     /* 2112909 */   GIM_Try, /*On fail goto*//*Label 27987*/ GIMT_Encode4(2113000), // Rule ID 16945 //
     /* 2112914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2112917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2112922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2112925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2112928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2112931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2112937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112960 */     // MIs[0] round
     /* 2112960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112963 */     // MIs[0] policy
     /* 2112963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112973 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2112976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112999 */     // GIR_Coverage, 16945,
     /* 2112999 */     GIR_EraseRootFromParent_Done,
     /* 2113000 */   // Label 27987: @2113000
     /* 2113000 */   GIM_Try, /*On fail goto*//*Label 27988*/ GIMT_Encode4(2113091), // Rule ID 16948 //
     /* 2113005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2113008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2113016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2113019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2113022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113051 */     // MIs[0] round
     /* 2113051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113054 */     // MIs[0] policy
     /* 2113054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113064 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2113067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113090 */     // GIR_Coverage, 16948,
     /* 2113090 */     GIR_EraseRootFromParent_Done,
     /* 2113091 */   // Label 27988: @2113091
     /* 2113091 */   GIM_Try, /*On fail goto*//*Label 27989*/ GIMT_Encode4(2113182), // Rule ID 16949 //
     /* 2113096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2113099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2113107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2113110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2113113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113142 */     // MIs[0] round
     /* 2113142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113145 */     // MIs[0] policy
     /* 2113145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113155 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2113158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113181 */     // GIR_Coverage, 16949,
     /* 2113181 */     GIR_EraseRootFromParent_Done,
     /* 2113182 */   // Label 27989: @2113182
     /* 2113182 */   GIM_Try, /*On fail goto*//*Label 27990*/ GIMT_Encode4(2113273), // Rule ID 16952 //
     /* 2113187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2113190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2113198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2113201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2113204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113233 */     // MIs[0] round
     /* 2113233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113236 */     // MIs[0] policy
     /* 2113236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113246 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2113249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113272 */     // GIR_Coverage, 16952,
     /* 2113272 */     GIR_EraseRootFromParent_Done,
     /* 2113273 */   // Label 27990: @2113273
     /* 2113273 */   GIM_Try, /*On fail goto*//*Label 27991*/ GIMT_Encode4(2113364), // Rule ID 16953 //
     /* 2113278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2113281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2113289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2113292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2113295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113324 */     // MIs[0] round
     /* 2113324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113327 */     // MIs[0] policy
     /* 2113327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113337 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2113340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113363 */     // GIR_Coverage, 16953,
     /* 2113363 */     GIR_EraseRootFromParent_Done,
     /* 2113364 */   // Label 27991: @2113364
     /* 2113364 */   GIM_Try, /*On fail goto*//*Label 27992*/ GIMT_Encode4(2113455), // Rule ID 16956 //
     /* 2113369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2113372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2113380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2113383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2113386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113415 */     // MIs[0] round
     /* 2113415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113418 */     // MIs[0] policy
     /* 2113418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113428 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2113431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113454 */     // GIR_Coverage, 16956,
     /* 2113454 */     GIR_EraseRootFromParent_Done,
     /* 2113455 */   // Label 27992: @2113455
     /* 2113455 */   GIM_Try, /*On fail goto*//*Label 27993*/ GIMT_Encode4(2113546), // Rule ID 16957 //
     /* 2113460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2113463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2113471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2113474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2113477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113506 */     // MIs[0] round
     /* 2113506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113509 */     // MIs[0] policy
     /* 2113509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113519 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2113522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113545 */     // GIR_Coverage, 16957,
     /* 2113545 */     GIR_EraseRootFromParent_Done,
     /* 2113546 */   // Label 27993: @2113546
     /* 2113546 */   GIM_Try, /*On fail goto*//*Label 27994*/ GIMT_Encode4(2113637), // Rule ID 16960 //
     /* 2113551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2113554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2113562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2113565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2113568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113597 */     // MIs[0] round
     /* 2113597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113600 */     // MIs[0] policy
     /* 2113600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113610 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2113613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113636 */     // GIR_Coverage, 16960,
     /* 2113636 */     GIR_EraseRootFromParent_Done,
     /* 2113637 */   // Label 27994: @2113637
     /* 2113637 */   GIM_Try, /*On fail goto*//*Label 27995*/ GIMT_Encode4(2113728), // Rule ID 16961 //
     /* 2113642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2113645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2113653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2113656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2113659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113688 */     // MIs[0] round
     /* 2113688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113691 */     // MIs[0] policy
     /* 2113691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113701 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2113704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113727 */     // GIR_Coverage, 16961,
     /* 2113727 */     GIR_EraseRootFromParent_Done,
     /* 2113728 */   // Label 27995: @2113728
     /* 2113728 */   GIM_Try, /*On fail goto*//*Label 27996*/ GIMT_Encode4(2113819), // Rule ID 16964 //
     /* 2113733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2113736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2113744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2113747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2113750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2113753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2113775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113779 */     // MIs[0] round
     /* 2113779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113782 */     // MIs[0] policy
     /* 2113782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113792 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2113795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113818 */     // GIR_Coverage, 16964,
     /* 2113818 */     GIR_EraseRootFromParent_Done,
     /* 2113819 */   // Label 27996: @2113819
     /* 2113819 */   GIM_Try, /*On fail goto*//*Label 27997*/ GIMT_Encode4(2113910), // Rule ID 16965 //
     /* 2113824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2113827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2113835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2113838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2113841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2113844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2113866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113870 */     // MIs[0] round
     /* 2113870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113873 */     // MIs[0] policy
     /* 2113873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113883 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2113886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113906 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113909 */     // GIR_Coverage, 16965,
     /* 2113909 */     GIR_EraseRootFromParent_Done,
     /* 2113910 */   // Label 27997: @2113910
     /* 2113910 */   GIM_Try, /*On fail goto*//*Label 27998*/ GIMT_Encode4(2114001), // Rule ID 16968 //
     /* 2113915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2113918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2113926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2113929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2113932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2113945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113961 */     // MIs[0] round
     /* 2113961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113964 */     // MIs[0] policy
     /* 2113964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113974 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2113977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114000 */     // GIR_Coverage, 16968,
     /* 2114000 */     GIR_EraseRootFromParent_Done,
     /* 2114001 */   // Label 27998: @2114001
     /* 2114001 */   GIM_Try, /*On fail goto*//*Label 27999*/ GIMT_Encode4(2114092), // Rule ID 16969 //
     /* 2114006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2114017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2114020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2114023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114052 */     // MIs[0] round
     /* 2114052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114055 */     // MIs[0] policy
     /* 2114055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114065 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2114068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114091 */     // GIR_Coverage, 16969,
     /* 2114091 */     GIR_EraseRootFromParent_Done,
     /* 2114092 */   // Label 27999: @2114092
     /* 2114092 */   GIM_Try, /*On fail goto*//*Label 28000*/ GIMT_Encode4(2114183), // Rule ID 16972 //
     /* 2114097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2114100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2114108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2114111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2114114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114143 */     // MIs[0] round
     /* 2114143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114146 */     // MIs[0] policy
     /* 2114146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114156 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2114159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114182 */     // GIR_Coverage, 16972,
     /* 2114182 */     GIR_EraseRootFromParent_Done,
     /* 2114183 */   // Label 28000: @2114183
     /* 2114183 */   GIM_Try, /*On fail goto*//*Label 28001*/ GIMT_Encode4(2114274), // Rule ID 16973 //
     /* 2114188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2114199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2114202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2114205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114234 */     // MIs[0] round
     /* 2114234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114237 */     // MIs[0] policy
     /* 2114237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114247 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2114250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114273 */     // GIR_Coverage, 16973,
     /* 2114273 */     GIR_EraseRootFromParent_Done,
     /* 2114274 */   // Label 28001: @2114274
     /* 2114274 */   GIM_Try, /*On fail goto*//*Label 28002*/ GIMT_Encode4(2114365), // Rule ID 16976 //
     /* 2114279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2114282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2114290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2114293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2114296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2114302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114325 */     // MIs[0] round
     /* 2114325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114328 */     // MIs[0] policy
     /* 2114328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114338 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2114341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114364 */     // GIR_Coverage, 16976,
     /* 2114364 */     GIR_EraseRootFromParent_Done,
     /* 2114365 */   // Label 28002: @2114365
     /* 2114365 */   GIM_Try, /*On fail goto*//*Label 28003*/ GIMT_Encode4(2114456), // Rule ID 16977 //
     /* 2114370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2114381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2114384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2114387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2114393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114416 */     // MIs[0] round
     /* 2114416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114419 */     // MIs[0] policy
     /* 2114419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114429 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2114432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114455 */     // GIR_Coverage, 16977,
     /* 2114455 */     GIR_EraseRootFromParent_Done,
     /* 2114456 */   // Label 28003: @2114456
     /* 2114456 */   GIM_Try, /*On fail goto*//*Label 28004*/ GIMT_Encode4(2114547), // Rule ID 16980 //
     /* 2114461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2114464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2114472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2114475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2114478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2114484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114507 */     // MIs[0] round
     /* 2114507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114510 */     // MIs[0] policy
     /* 2114510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114520 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2114523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114546 */     // GIR_Coverage, 16980,
     /* 2114546 */     GIR_EraseRootFromParent_Done,
     /* 2114547 */   // Label 28004: @2114547
     /* 2114547 */   GIM_Try, /*On fail goto*//*Label 28005*/ GIMT_Encode4(2114638), // Rule ID 16981 //
     /* 2114552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2114555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2114563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2114566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2114569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2114575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114598 */     // MIs[0] round
     /* 2114598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114601 */     // MIs[0] policy
     /* 2114601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114611 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2114614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114634 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114637 */     // GIR_Coverage, 16981,
     /* 2114637 */     GIR_EraseRootFromParent_Done,
     /* 2114638 */   // Label 28005: @2114638
     /* 2114638 */   GIM_Try, /*On fail goto*//*Label 28006*/ GIMT_Encode4(2114729), // Rule ID 16984 //
     /* 2114643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2114646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2114654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2114657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2114660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114689 */     // MIs[0] round
     /* 2114689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114692 */     // MIs[0] policy
     /* 2114692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114702 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2114705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114728 */     // GIR_Coverage, 16984,
     /* 2114728 */     GIR_EraseRootFromParent_Done,
     /* 2114729 */   // Label 28006: @2114729
     /* 2114729 */   GIM_Try, /*On fail goto*//*Label 28007*/ GIMT_Encode4(2114820), // Rule ID 16985 //
     /* 2114734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2114737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2114745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2114748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2114751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114757 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114780 */     // MIs[0] round
     /* 2114780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114783 */     // MIs[0] policy
     /* 2114783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114793 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2114796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114819 */     // GIR_Coverage, 16985,
     /* 2114819 */     GIR_EraseRootFromParent_Done,
     /* 2114820 */   // Label 28007: @2114820
     /* 2114820 */   GIM_Try, /*On fail goto*//*Label 28008*/ GIMT_Encode4(2114911), // Rule ID 16988 //
     /* 2114825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2114828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2114836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2114839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2114842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114871 */     // MIs[0] round
     /* 2114871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114874 */     // MIs[0] policy
     /* 2114874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114884 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2114887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114910 */     // GIR_Coverage, 16988,
     /* 2114910 */     GIR_EraseRootFromParent_Done,
     /* 2114911 */   // Label 28008: @2114911
     /* 2114911 */   GIM_Try, /*On fail goto*//*Label 28009*/ GIMT_Encode4(2115002), // Rule ID 16989 //
     /* 2114916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2114919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2114927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2114930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2114933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114962 */     // MIs[0] round
     /* 2114962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114965 */     // MIs[0] policy
     /* 2114965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114975 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2114978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115001 */     // GIR_Coverage, 16989,
     /* 2115001 */     GIR_EraseRootFromParent_Done,
     /* 2115002 */   // Label 28009: @2115002
     /* 2115002 */   GIM_Try, /*On fail goto*//*Label 28010*/ GIMT_Encode4(2115093), // Rule ID 16992 //
     /* 2115007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2115010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2115018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2115021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2115024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115053 */     // MIs[0] round
     /* 2115053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115056 */     // MIs[0] policy
     /* 2115056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115066 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2115069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115092 */     // GIR_Coverage, 16992,
     /* 2115092 */     GIR_EraseRootFromParent_Done,
     /* 2115093 */   // Label 28010: @2115093
     /* 2115093 */   GIM_Try, /*On fail goto*//*Label 28011*/ GIMT_Encode4(2115184), // Rule ID 16993 //
     /* 2115098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2115101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2115109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2115112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2115115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115144 */     // MIs[0] round
     /* 2115144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115147 */     // MIs[0] policy
     /* 2115147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115157 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2115160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115183 */     // GIR_Coverage, 16993,
     /* 2115183 */     GIR_EraseRootFromParent_Done,
     /* 2115184 */   // Label 28011: @2115184
     /* 2115184 */   GIM_Try, /*On fail goto*//*Label 28012*/ GIMT_Encode4(2115275), // Rule ID 16996 //
     /* 2115189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2115192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2115200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2115203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2115206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115235 */     // MIs[0] round
     /* 2115235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115238 */     // MIs[0] policy
     /* 2115238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115248 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2115251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115274 */     // GIR_Coverage, 16996,
     /* 2115274 */     GIR_EraseRootFromParent_Done,
     /* 2115275 */   // Label 28012: @2115275
     /* 2115275 */   GIM_Try, /*On fail goto*//*Label 28013*/ GIMT_Encode4(2115366), // Rule ID 16997 //
     /* 2115280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2115283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2115291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2115294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2115297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115326 */     // MIs[0] round
     /* 2115326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115329 */     // MIs[0] policy
     /* 2115329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115339 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2115342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115352 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115362 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115365 */     // GIR_Coverage, 16997,
     /* 2115365 */     GIR_EraseRootFromParent_Done,
     /* 2115366 */   // Label 28013: @2115366
     /* 2115366 */   GIM_Try, /*On fail goto*//*Label 28014*/ GIMT_Encode4(2115457), // Rule ID 17000 //
     /* 2115371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2115374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2115382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2115385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2115388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115417 */     // MIs[0] round
     /* 2115417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115420 */     // MIs[0] policy
     /* 2115420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115430 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2115433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115456 */     // GIR_Coverage, 17000,
     /* 2115456 */     GIR_EraseRootFromParent_Done,
     /* 2115457 */   // Label 28014: @2115457
     /* 2115457 */   GIM_Try, /*On fail goto*//*Label 28015*/ GIMT_Encode4(2115548), // Rule ID 17001 //
     /* 2115462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2115465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2115473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2115476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2115479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115485 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115508 */     // MIs[0] round
     /* 2115508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115511 */     // MIs[0] policy
     /* 2115511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115521 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2115524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115547 */     // GIR_Coverage, 17001,
     /* 2115547 */     GIR_EraseRootFromParent_Done,
     /* 2115548 */   // Label 28015: @2115548
     /* 2115548 */   GIM_Try, /*On fail goto*//*Label 28016*/ GIMT_Encode4(2115639), // Rule ID 17004 //
     /* 2115553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2115556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2115561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2115564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2115567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2115570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2115573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2115576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115599 */     // MIs[0] round
     /* 2115599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115602 */     // MIs[0] policy
     /* 2115602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115612 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2115615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115638 */     // GIR_Coverage, 17004,
     /* 2115638 */     GIR_EraseRootFromParent_Done,
     /* 2115639 */   // Label 28016: @2115639
     /* 2115639 */   GIM_Try, /*On fail goto*//*Label 28017*/ GIMT_Encode4(2115730), // Rule ID 17005 //
     /* 2115644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2115647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2115652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2115655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2115658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2115661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2115664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2115667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115690 */     // MIs[0] round
     /* 2115690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115693 */     // MIs[0] policy
     /* 2115693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115703 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2115706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115726 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115729 */     // GIR_Coverage, 17005,
     /* 2115729 */     GIR_EraseRootFromParent_Done,
     /* 2115730 */   // Label 28017: @2115730
     /* 2115730 */   GIM_Try, /*On fail goto*//*Label 28018*/ GIMT_Encode4(2115821), // Rule ID 17008 //
     /* 2115735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2115738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2115743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2115746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2115749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2115752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2115755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115781 */     // MIs[0] round
     /* 2115781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115784 */     // MIs[0] policy
     /* 2115784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115794 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2115797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115820 */     // GIR_Coverage, 17008,
     /* 2115820 */     GIR_EraseRootFromParent_Done,
     /* 2115821 */   // Label 28018: @2115821
     /* 2115821 */   GIM_Try, /*On fail goto*//*Label 28019*/ GIMT_Encode4(2115912), // Rule ID 17009 //
     /* 2115826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2115829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2115834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2115837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2115840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2115843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2115846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115872 */     // MIs[0] round
     /* 2115872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115875 */     // MIs[0] policy
     /* 2115875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115885 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2115888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115898 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115908 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115911 */     // GIR_Coverage, 17009,
     /* 2115911 */     GIR_EraseRootFromParent_Done,
     /* 2115912 */   // Label 28019: @2115912
     /* 2115912 */   GIM_Try, /*On fail goto*//*Label 28020*/ GIMT_Encode4(2116003), // Rule ID 17012 //
     /* 2115917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2115920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2115925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2115928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2115931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2115934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2115937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115963 */     // MIs[0] round
     /* 2115963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115966 */     // MIs[0] policy
     /* 2115966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115976 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2115979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116002 */     // GIR_Coverage, 17012,
     /* 2116002 */     GIR_EraseRootFromParent_Done,
     /* 2116003 */   // Label 28020: @2116003
     /* 2116003 */   GIM_Try, /*On fail goto*//*Label 28021*/ GIMT_Encode4(2116094), // Rule ID 17013 //
     /* 2116008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2116019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2116022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2116025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2116028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116054 */     // MIs[0] round
     /* 2116054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116057 */     // MIs[0] policy
     /* 2116057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116067 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2116070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116093 */     // GIR_Coverage, 17013,
     /* 2116093 */     GIR_EraseRootFromParent_Done,
     /* 2116094 */   // Label 28021: @2116094
     /* 2116094 */   GIM_Try, /*On fail goto*//*Label 28022*/ GIMT_Encode4(2116185), // Rule ID 17016 //
     /* 2116099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2116110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2116113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2116116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2116119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116145 */     // MIs[0] round
     /* 2116145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116148 */     // MIs[0] policy
     /* 2116148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116158 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2116161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116181 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116184 */     // GIR_Coverage, 17016,
     /* 2116184 */     GIR_EraseRootFromParent_Done,
     /* 2116185 */   // Label 28022: @2116185
     /* 2116185 */   GIM_Try, /*On fail goto*//*Label 28023*/ GIMT_Encode4(2116276), // Rule ID 17017 //
     /* 2116190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2116201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2116204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2116207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2116210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116236 */     // MIs[0] round
     /* 2116236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116239 */     // MIs[0] policy
     /* 2116239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116249 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2116252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116275 */     // GIR_Coverage, 17017,
     /* 2116275 */     GIR_EraseRootFromParent_Done,
     /* 2116276 */   // Label 28023: @2116276
     /* 2116276 */   GIM_Try, /*On fail goto*//*Label 28024*/ GIMT_Encode4(2116367), // Rule ID 17020 //
     /* 2116281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2116292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2116295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2116298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2116301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2116304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116327 */     // MIs[0] round
     /* 2116327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116330 */     // MIs[0] policy
     /* 2116330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116340 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2116343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116366 */     // GIR_Coverage, 17020,
     /* 2116366 */     GIR_EraseRootFromParent_Done,
     /* 2116367 */   // Label 28024: @2116367
     /* 2116367 */   GIM_Try, /*On fail goto*//*Label 28025*/ GIMT_Encode4(2116458), // Rule ID 17021 //
     /* 2116372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2116383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2116386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2116389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2116392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2116395 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116418 */     // MIs[0] round
     /* 2116418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116421 */     // MIs[0] policy
     /* 2116421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116431 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2116434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116457 */     // GIR_Coverage, 17021,
     /* 2116457 */     GIR_EraseRootFromParent_Done,
     /* 2116458 */   // Label 28025: @2116458
     /* 2116458 */   GIM_Try, /*On fail goto*//*Label 28026*/ GIMT_Encode4(2116549), // Rule ID 17024 //
     /* 2116463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2116474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2116477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2116480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2116483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116509 */     // MIs[0] round
     /* 2116509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116512 */     // MIs[0] policy
     /* 2116512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116522 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2116525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116548 */     // GIR_Coverage, 17024,
     /* 2116548 */     GIR_EraseRootFromParent_Done,
     /* 2116549 */   // Label 28026: @2116549
     /* 2116549 */   GIM_Try, /*On fail goto*//*Label 28027*/ GIMT_Encode4(2116640), // Rule ID 17025 //
     /* 2116554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2116557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2116565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2116568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2116571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2116574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116600 */     // MIs[0] round
     /* 2116600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116603 */     // MIs[0] policy
     /* 2116603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116613 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2116616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116639 */     // GIR_Coverage, 17025,
     /* 2116639 */     GIR_EraseRootFromParent_Done,
     /* 2116640 */   // Label 28027: @2116640
     /* 2116640 */   GIM_Try, /*On fail goto*//*Label 28028*/ GIMT_Encode4(2116731), // Rule ID 17028 //
     /* 2116645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2116656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2116659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2116662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2116665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116691 */     // MIs[0] round
     /* 2116691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116694 */     // MIs[0] policy
     /* 2116694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116704 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2116707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116730 */     // GIR_Coverage, 17028,
     /* 2116730 */     GIR_EraseRootFromParent_Done,
     /* 2116731 */   // Label 28028: @2116731
     /* 2116731 */   GIM_Try, /*On fail goto*//*Label 28029*/ GIMT_Encode4(2116822), // Rule ID 17029 //
     /* 2116736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2116739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2116747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2116750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2116753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2116756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116782 */     // MIs[0] round
     /* 2116782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116785 */     // MIs[0] policy
     /* 2116785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116795 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2116798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116821 */     // GIR_Coverage, 17029,
     /* 2116821 */     GIR_EraseRootFromParent_Done,
     /* 2116822 */   // Label 28029: @2116822
     /* 2116822 */   GIM_Try, /*On fail goto*//*Label 28030*/ GIMT_Encode4(2116913), // Rule ID 17032 //
     /* 2116827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2116838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2116841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2116844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2116847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116873 */     // MIs[0] round
     /* 2116873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116876 */     // MIs[0] policy
     /* 2116876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116886 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2116889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116912 */     // GIR_Coverage, 17032,
     /* 2116912 */     GIR_EraseRootFromParent_Done,
     /* 2116913 */   // Label 28030: @2116913
     /* 2116913 */   GIM_Try, /*On fail goto*//*Label 28031*/ GIMT_Encode4(2117004), // Rule ID 17033 //
     /* 2116918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2116921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2116929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2116932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2116935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2116938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116964 */     // MIs[0] round
     /* 2116964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116967 */     // MIs[0] policy
     /* 2116967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116977 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2116980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116990 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117000 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117003 */     // GIR_Coverage, 17033,
     /* 2117003 */     GIR_EraseRootFromParent_Done,
     /* 2117004 */   // Label 28031: @2117004
     /* 2117004 */   GIM_Try, /*On fail goto*//*Label 28032*/ GIMT_Encode4(2117095), // Rule ID 17036 //
     /* 2117009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2117012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2117020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2117023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2117026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2117029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117055 */     // MIs[0] round
     /* 2117055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117058 */     // MIs[0] policy
     /* 2117058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117068 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2117071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117094 */     // GIR_Coverage, 17036,
     /* 2117094 */     GIR_EraseRootFromParent_Done,
     /* 2117095 */   // Label 28032: @2117095
     /* 2117095 */   GIM_Try, /*On fail goto*//*Label 28033*/ GIMT_Encode4(2117186), // Rule ID 17037 //
     /* 2117100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2117103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2117111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2117114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2117117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2117120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117146 */     // MIs[0] round
     /* 2117146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117149 */     // MIs[0] policy
     /* 2117149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117159 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2117162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117185 */     // GIR_Coverage, 17037,
     /* 2117185 */     GIR_EraseRootFromParent_Done,
     /* 2117186 */   // Label 28033: @2117186
     /* 2117186 */   GIM_Try, /*On fail goto*//*Label 28034*/ GIMT_Encode4(2117277), // Rule ID 17040 //
     /* 2117191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2117202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2117205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2117208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117237 */     // MIs[0] round
     /* 2117237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117240 */     // MIs[0] policy
     /* 2117240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117250 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2117253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117276 */     // GIR_Coverage, 17040,
     /* 2117276 */     GIR_EraseRootFromParent_Done,
     /* 2117277 */   // Label 28034: @2117277
     /* 2117277 */   GIM_Try, /*On fail goto*//*Label 28035*/ GIMT_Encode4(2117368), // Rule ID 17041 //
     /* 2117282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2117293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2117296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2117299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117328 */     // MIs[0] round
     /* 2117328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117331 */     // MIs[0] policy
     /* 2117331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117341 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2117344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117367 */     // GIR_Coverage, 17041,
     /* 2117367 */     GIR_EraseRootFromParent_Done,
     /* 2117368 */   // Label 28035: @2117368
     /* 2117368 */   GIM_Try, /*On fail goto*//*Label 28036*/ GIMT_Encode4(2117459), // Rule ID 17044 //
     /* 2117373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2117384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2117387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2117390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117419 */     // MIs[0] round
     /* 2117419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117422 */     // MIs[0] policy
     /* 2117422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117432 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2117435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117458 */     // GIR_Coverage, 17044,
     /* 2117458 */     GIR_EraseRootFromParent_Done,
     /* 2117459 */   // Label 28036: @2117459
     /* 2117459 */   GIM_Try, /*On fail goto*//*Label 28037*/ GIMT_Encode4(2117550), // Rule ID 17045 //
     /* 2117464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2117475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2117478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2117481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117510 */     // MIs[0] round
     /* 2117510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117513 */     // MIs[0] policy
     /* 2117513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117523 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2117526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117549 */     // GIR_Coverage, 17045,
     /* 2117549 */     GIR_EraseRootFromParent_Done,
     /* 2117550 */   // Label 28037: @2117550
     /* 2117550 */   GIM_Try, /*On fail goto*//*Label 28038*/ GIMT_Encode4(2117641), // Rule ID 17048 //
     /* 2117555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2117566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2117569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2117572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117601 */     // MIs[0] round
     /* 2117601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117604 */     // MIs[0] policy
     /* 2117604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117614 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2117617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117640 */     // GIR_Coverage, 17048,
     /* 2117640 */     GIR_EraseRootFromParent_Done,
     /* 2117641 */   // Label 28038: @2117641
     /* 2117641 */   GIM_Try, /*On fail goto*//*Label 28039*/ GIMT_Encode4(2117732), // Rule ID 17049 //
     /* 2117646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2117657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2117660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2117663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117692 */     // MIs[0] round
     /* 2117692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117695 */     // MIs[0] policy
     /* 2117695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117705 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2117708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117731 */     // GIR_Coverage, 17049,
     /* 2117731 */     GIR_EraseRootFromParent_Done,
     /* 2117732 */   // Label 28039: @2117732
     /* 2117732 */   GIM_Try, /*On fail goto*//*Label 28040*/ GIMT_Encode4(2117823), // Rule ID 17052 //
     /* 2117737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2117748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2117751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2117754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2117767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117783 */     // MIs[0] round
     /* 2117783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117786 */     // MIs[0] policy
     /* 2117786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117796 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2117799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117822 */     // GIR_Coverage, 17052,
     /* 2117822 */     GIR_EraseRootFromParent_Done,
     /* 2117823 */   // Label 28040: @2117823
     /* 2117823 */   GIM_Try, /*On fail goto*//*Label 28041*/ GIMT_Encode4(2117914), // Rule ID 17053 //
     /* 2117828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2117839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2117842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2117845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2117858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117874 */     // MIs[0] round
     /* 2117874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117877 */     // MIs[0] policy
     /* 2117877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117887 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2117890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117913 */     // GIR_Coverage, 17053,
     /* 2117913 */     GIR_EraseRootFromParent_Done,
     /* 2117914 */   // Label 28041: @2117914
     /* 2117914 */   GIM_Try, /*On fail goto*//*Label 28042*/ GIMT_Encode4(2118005), // Rule ID 17056 //
     /* 2117919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2117930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2117933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2117936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2117942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117965 */     // MIs[0] round
     /* 2117965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117968 */     // MIs[0] policy
     /* 2117968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117978 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2117981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118004 */     // GIR_Coverage, 17056,
     /* 2118004 */     GIR_EraseRootFromParent_Done,
     /* 2118005 */   // Label 28042: @2118005
     /* 2118005 */   GIM_Try, /*On fail goto*//*Label 28043*/ GIMT_Encode4(2118096), // Rule ID 17057 //
     /* 2118010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2118021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2118024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2118027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2118033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118056 */     // MIs[0] round
     /* 2118056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118059 */     // MIs[0] policy
     /* 2118059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118069 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2118072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118095 */     // GIR_Coverage, 17057,
     /* 2118095 */     GIR_EraseRootFromParent_Done,
     /* 2118096 */   // Label 28043: @2118096
     /* 2118096 */   GIM_Try, /*On fail goto*//*Label 28044*/ GIMT_Encode4(2118187), // Rule ID 17060 //
     /* 2118101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2118112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2118115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2118118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118147 */     // MIs[0] round
     /* 2118147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118150 */     // MIs[0] policy
     /* 2118150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118160 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2118163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118186 */     // GIR_Coverage, 17060,
     /* 2118186 */     GIR_EraseRootFromParent_Done,
     /* 2118187 */   // Label 28044: @2118187
     /* 2118187 */   GIM_Try, /*On fail goto*//*Label 28045*/ GIMT_Encode4(2118278), // Rule ID 17061 //
     /* 2118192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2118203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2118206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2118209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118238 */     // MIs[0] round
     /* 2118238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118241 */     // MIs[0] policy
     /* 2118241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118251 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2118254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118264 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118274 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118277 */     // GIR_Coverage, 17061,
     /* 2118277 */     GIR_EraseRootFromParent_Done,
     /* 2118278 */   // Label 28045: @2118278
     /* 2118278 */   GIM_Try, /*On fail goto*//*Label 28046*/ GIMT_Encode4(2118369), // Rule ID 17064 //
     /* 2118283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2118294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2118297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2118300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2118306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118329 */     // MIs[0] round
     /* 2118329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118332 */     // MIs[0] policy
     /* 2118332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118342 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2118345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118368 */     // GIR_Coverage, 17064,
     /* 2118368 */     GIR_EraseRootFromParent_Done,
     /* 2118369 */   // Label 28046: @2118369
     /* 2118369 */   GIM_Try, /*On fail goto*//*Label 28047*/ GIMT_Encode4(2118460), // Rule ID 17065 //
     /* 2118374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2118385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2118388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2118391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2118397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118420 */     // MIs[0] round
     /* 2118420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118423 */     // MIs[0] policy
     /* 2118423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118433 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2118436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118456 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118459 */     // GIR_Coverage, 17065,
     /* 2118459 */     GIR_EraseRootFromParent_Done,
     /* 2118460 */   // Label 28047: @2118460
     /* 2118460 */   GIM_Try, /*On fail goto*//*Label 28048*/ GIMT_Encode4(2118551), // Rule ID 17068 //
     /* 2118465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2118476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2118479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2118482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118511 */     // MIs[0] round
     /* 2118511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118514 */     // MIs[0] policy
     /* 2118514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118524 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2118527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118550 */     // GIR_Coverage, 17068,
     /* 2118550 */     GIR_EraseRootFromParent_Done,
     /* 2118551 */   // Label 28048: @2118551
     /* 2118551 */   GIM_Try, /*On fail goto*//*Label 28049*/ GIMT_Encode4(2118642), // Rule ID 17069 //
     /* 2118556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2118567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2118570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2118573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118602 */     // MIs[0] round
     /* 2118602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118605 */     // MIs[0] policy
     /* 2118605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118615 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2118618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118641 */     // GIR_Coverage, 17069,
     /* 2118641 */     GIR_EraseRootFromParent_Done,
     /* 2118642 */   // Label 28049: @2118642
     /* 2118642 */   GIM_Try, /*On fail goto*//*Label 28050*/ GIMT_Encode4(2118733), // Rule ID 17072 //
     /* 2118647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2118658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2118661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2118664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118693 */     // MIs[0] round
     /* 2118693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118696 */     // MIs[0] policy
     /* 2118696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118706 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2118709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118732 */     // GIR_Coverage, 17072,
     /* 2118732 */     GIR_EraseRootFromParent_Done,
     /* 2118733 */   // Label 28050: @2118733
     /* 2118733 */   GIM_Try, /*On fail goto*//*Label 28051*/ GIMT_Encode4(2118824), // Rule ID 17073 //
     /* 2118738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2118749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2118752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2118755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118784 */     // MIs[0] round
     /* 2118784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118787 */     // MIs[0] policy
     /* 2118787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118797 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2118800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118823 */     // GIR_Coverage, 17073,
     /* 2118823 */     GIR_EraseRootFromParent_Done,
     /* 2118824 */   // Label 28051: @2118824
     /* 2118824 */   GIM_Try, /*On fail goto*//*Label 28052*/ GIMT_Encode4(2118915), // Rule ID 17076 //
     /* 2118829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2118832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2118837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2118840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2118843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2118846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2118849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118875 */     // MIs[0] round
     /* 2118875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118878 */     // MIs[0] policy
     /* 2118878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118888 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2118891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118914 */     // GIR_Coverage, 17076,
     /* 2118914 */     GIR_EraseRootFromParent_Done,
     /* 2118915 */   // Label 28052: @2118915
     /* 2118915 */   GIM_Try, /*On fail goto*//*Label 28053*/ GIMT_Encode4(2119006), // Rule ID 17077 //
     /* 2118920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2118928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2118931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2118934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2118937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2118940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118966 */     // MIs[0] round
     /* 2118966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118969 */     // MIs[0] policy
     /* 2118969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118979 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2118982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119005 */     // GIR_Coverage, 17077,
     /* 2119005 */     GIR_EraseRootFromParent_Done,
     /* 2119006 */   // Label 28053: @2119006
     /* 2119006 */   GIM_Try, /*On fail goto*//*Label 28054*/ GIMT_Encode4(2119097), // Rule ID 17080 //
     /* 2119011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2119022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2119025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2119028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2119031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119057 */     // MIs[0] round
     /* 2119057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119060 */     // MIs[0] policy
     /* 2119060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119070 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2119073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119096 */     // GIR_Coverage, 17080,
     /* 2119096 */     GIR_EraseRootFromParent_Done,
     /* 2119097 */   // Label 28054: @2119097
     /* 2119097 */   GIM_Try, /*On fail goto*//*Label 28055*/ GIMT_Encode4(2119188), // Rule ID 17081 //
     /* 2119102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2119113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2119116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2119119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2119122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119148 */     // MIs[0] round
     /* 2119148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119151 */     // MIs[0] policy
     /* 2119151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119161 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2119164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119174 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119184 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119187 */     // GIR_Coverage, 17081,
     /* 2119187 */     GIR_EraseRootFromParent_Done,
     /* 2119188 */   // Label 28055: @2119188
     /* 2119188 */   GIM_Try, /*On fail goto*//*Label 28056*/ GIMT_Encode4(2119279), // Rule ID 17084 //
     /* 2119193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2119204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2119207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2119210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2119213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119239 */     // MIs[0] round
     /* 2119239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119242 */     // MIs[0] policy
     /* 2119242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2119255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119278 */     // GIR_Coverage, 17084,
     /* 2119278 */     GIR_EraseRootFromParent_Done,
     /* 2119279 */   // Label 28056: @2119279
     /* 2119279 */   GIM_Try, /*On fail goto*//*Label 28057*/ GIMT_Encode4(2119370), // Rule ID 17085 //
     /* 2119284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2119295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2119298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2119301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2119304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119330 */     // MIs[0] round
     /* 2119330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119333 */     // MIs[0] policy
     /* 2119333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119343 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2119346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119369 */     // GIR_Coverage, 17085,
     /* 2119369 */     GIR_EraseRootFromParent_Done,
     /* 2119370 */   // Label 28057: @2119370
     /* 2119370 */   GIM_Try, /*On fail goto*//*Label 28058*/ GIMT_Encode4(2119461), // Rule ID 17088 //
     /* 2119375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2119386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2119389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2119392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2119395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119421 */     // MIs[0] round
     /* 2119421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119424 */     // MIs[0] policy
     /* 2119424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119434 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2119437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119460 */     // GIR_Coverage, 17088,
     /* 2119460 */     GIR_EraseRootFromParent_Done,
     /* 2119461 */   // Label 28058: @2119461
     /* 2119461 */   GIM_Try, /*On fail goto*//*Label 28059*/ GIMT_Encode4(2119552), // Rule ID 17089 //
     /* 2119466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2119477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2119480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2119483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2119486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119489 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119512 */     // MIs[0] round
     /* 2119512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119515 */     // MIs[0] policy
     /* 2119515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119525 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2119528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119551 */     // GIR_Coverage, 17089,
     /* 2119551 */     GIR_EraseRootFromParent_Done,
     /* 2119552 */   // Label 28059: @2119552
     /* 2119552 */   GIM_Try, /*On fail goto*//*Label 28060*/ GIMT_Encode4(2119643), // Rule ID 17092 //
     /* 2119557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2119568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2119571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2119574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2119577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2119580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119603 */     // MIs[0] round
     /* 2119603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119606 */     // MIs[0] policy
     /* 2119606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119616 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2119619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119642 */     // GIR_Coverage, 17092,
     /* 2119642 */     GIR_EraseRootFromParent_Done,
     /* 2119643 */   // Label 28060: @2119643
     /* 2119643 */   GIM_Try, /*On fail goto*//*Label 28061*/ GIMT_Encode4(2119734), // Rule ID 17093 //
     /* 2119648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2119659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2119662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2119665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2119668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2119671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119694 */     // MIs[0] round
     /* 2119694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119697 */     // MIs[0] policy
     /* 2119697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119707 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2119710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119733 */     // GIR_Coverage, 17093,
     /* 2119733 */     GIR_EraseRootFromParent_Done,
     /* 2119734 */   // Label 28061: @2119734
     /* 2119734 */   GIM_Try, /*On fail goto*//*Label 28062*/ GIMT_Encode4(2119825), // Rule ID 17096 //
     /* 2119739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2119742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2119750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2119753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2119756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2119759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119785 */     // MIs[0] round
     /* 2119785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119788 */     // MIs[0] policy
     /* 2119788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119798 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2119801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119824 */     // GIR_Coverage, 17096,
     /* 2119824 */     GIR_EraseRootFromParent_Done,
     /* 2119825 */   // Label 28062: @2119825
     /* 2119825 */   GIM_Try, /*On fail goto*//*Label 28063*/ GIMT_Encode4(2119916), // Rule ID 17097 //
     /* 2119830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2119833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2119841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2119844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2119847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2119850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119876 */     // MIs[0] round
     /* 2119876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119879 */     // MIs[0] policy
     /* 2119879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119889 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2119892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119915 */     // GIR_Coverage, 17097,
     /* 2119915 */     GIR_EraseRootFromParent_Done,
     /* 2119916 */   // Label 28063: @2119916
     /* 2119916 */   GIM_Try, /*On fail goto*//*Label 28064*/ GIMT_Encode4(2120007), // Rule ID 17100 //
     /* 2119921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2119924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2119932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2119935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2119938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2119941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119967 */     // MIs[0] round
     /* 2119967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119970 */     // MIs[0] policy
     /* 2119970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119980 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2119983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120006 */     // GIR_Coverage, 17100,
     /* 2120006 */     GIR_EraseRootFromParent_Done,
     /* 2120007 */   // Label 28064: @2120007
     /* 2120007 */   GIM_Try, /*On fail goto*//*Label 28065*/ GIMT_Encode4(2120098), // Rule ID 17101 //
     /* 2120012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2120023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2120026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2120029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2120032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120035 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120058 */     // MIs[0] round
     /* 2120058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120061 */     // MIs[0] policy
     /* 2120061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120071 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2120074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120097 */     // GIR_Coverage, 17101,
     /* 2120097 */     GIR_EraseRootFromParent_Done,
     /* 2120098 */   // Label 28065: @2120098
     /* 2120098 */   GIM_Try, /*On fail goto*//*Label 28066*/ GIMT_Encode4(2120189), // Rule ID 17104 //
     /* 2120103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2120114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2120117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2120120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2120123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2120133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120149 */     // MIs[0] round
     /* 2120149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120152 */     // MIs[0] policy
     /* 2120152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120162 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2120165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120188 */     // GIR_Coverage, 17104,
     /* 2120188 */     GIR_EraseRootFromParent_Done,
     /* 2120189 */   // Label 28066: @2120189
     /* 2120189 */   GIM_Try, /*On fail goto*//*Label 28067*/ GIMT_Encode4(2120280), // Rule ID 17105 //
     /* 2120194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2120205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2120208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2120211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2120214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120217 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2120224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120240 */     // MIs[0] round
     /* 2120240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120243 */     // MIs[0] policy
     /* 2120243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120253 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2120256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120276 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120279 */     // GIR_Coverage, 17105,
     /* 2120279 */     GIR_EraseRootFromParent_Done,
     /* 2120280 */   // Label 28067: @2120280
     /* 2120280 */   GIM_Try, /*On fail goto*//*Label 28068*/ GIMT_Encode4(2120371), // Rule ID 17108 //
     /* 2120285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2120296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2120299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2120302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2120305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2120308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120331 */     // MIs[0] round
     /* 2120331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120334 */     // MIs[0] policy
     /* 2120334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120344 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2120347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120370 */     // GIR_Coverage, 17108,
     /* 2120370 */     GIR_EraseRootFromParent_Done,
     /* 2120371 */   // Label 28068: @2120371
     /* 2120371 */   GIM_Try, /*On fail goto*//*Label 28069*/ GIMT_Encode4(2120462), // Rule ID 17109 //
     /* 2120376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2120387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2120390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2120393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2120396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2120399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120422 */     // MIs[0] round
     /* 2120422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120425 */     // MIs[0] policy
     /* 2120425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120435 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2120438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120461 */     // GIR_Coverage, 17109,
     /* 2120461 */     GIR_EraseRootFromParent_Done,
     /* 2120462 */   // Label 28069: @2120462
     /* 2120462 */   GIM_Try, /*On fail goto*//*Label 28070*/ GIMT_Encode4(2120553), // Rule ID 17112 //
     /* 2120467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2120478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2120481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2120484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120513 */     // MIs[0] round
     /* 2120513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120516 */     // MIs[0] policy
     /* 2120516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120526 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2120529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120552 */     // GIR_Coverage, 17112,
     /* 2120552 */     GIR_EraseRootFromParent_Done,
     /* 2120553 */   // Label 28070: @2120553
     /* 2120553 */   GIM_Try, /*On fail goto*//*Label 28071*/ GIMT_Encode4(2120644), // Rule ID 17113 //
     /* 2120558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2120569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2120572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2120575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120604 */     // MIs[0] round
     /* 2120604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120607 */     // MIs[0] policy
     /* 2120607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120617 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2120620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120643 */     // GIR_Coverage, 17113,
     /* 2120643 */     GIR_EraseRootFromParent_Done,
     /* 2120644 */   // Label 28071: @2120644
     /* 2120644 */   GIM_Try, /*On fail goto*//*Label 28072*/ GIMT_Encode4(2120735), // Rule ID 17116 //
     /* 2120649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2120660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2120663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2120666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120695 */     // MIs[0] round
     /* 2120695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120698 */     // MIs[0] policy
     /* 2120698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120708 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2120711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120734 */     // GIR_Coverage, 17116,
     /* 2120734 */     GIR_EraseRootFromParent_Done,
     /* 2120735 */   // Label 28072: @2120735
     /* 2120735 */   GIM_Try, /*On fail goto*//*Label 28073*/ GIMT_Encode4(2120826), // Rule ID 17117 //
     /* 2120740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2120751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2120754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2120757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120786 */     // MIs[0] round
     /* 2120786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120789 */     // MIs[0] policy
     /* 2120789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120799 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2120802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120825 */     // GIR_Coverage, 17117,
     /* 2120825 */     GIR_EraseRootFromParent_Done,
     /* 2120826 */   // Label 28073: @2120826
     /* 2120826 */   GIM_Try, /*On fail goto*//*Label 28074*/ GIMT_Encode4(2120917), // Rule ID 17120 //
     /* 2120831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2120842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2120845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2120848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120877 */     // MIs[0] round
     /* 2120877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120880 */     // MIs[0] policy
     /* 2120880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120890 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2120893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120916 */     // GIR_Coverage, 17120,
     /* 2120916 */     GIR_EraseRootFromParent_Done,
     /* 2120917 */   // Label 28074: @2120917
     /* 2120917 */   GIM_Try, /*On fail goto*//*Label 28075*/ GIMT_Encode4(2121008), // Rule ID 17121 //
     /* 2120922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2120933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2120936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2120939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120968 */     // MIs[0] round
     /* 2120968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120971 */     // MIs[0] policy
     /* 2120971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120981 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2120984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121007 */     // GIR_Coverage, 17121,
     /* 2121007 */     GIR_EraseRootFromParent_Done,
     /* 2121008 */   // Label 28075: @2121008
     /* 2121008 */   GIM_Try, /*On fail goto*//*Label 28076*/ GIMT_Encode4(2121099), // Rule ID 17124 //
     /* 2121013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2121024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2121027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2121030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121059 */     // MIs[0] round
     /* 2121059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121062 */     // MIs[0] policy
     /* 2121062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121072 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2121075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121098 */     // GIR_Coverage, 17124,
     /* 2121098 */     GIR_EraseRootFromParent_Done,
     /* 2121099 */   // Label 28076: @2121099
     /* 2121099 */   GIM_Try, /*On fail goto*//*Label 28077*/ GIMT_Encode4(2121190), // Rule ID 17125 //
     /* 2121104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2121115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2121118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2121121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121150 */     // MIs[0] round
     /* 2121150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121153 */     // MIs[0] policy
     /* 2121153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121163 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2121166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121189 */     // GIR_Coverage, 17125,
     /* 2121189 */     GIR_EraseRootFromParent_Done,
     /* 2121190 */   // Label 28077: @2121190
     /* 2121190 */   GIM_Try, /*On fail goto*//*Label 28078*/ GIMT_Encode4(2121281), // Rule ID 17128 //
     /* 2121195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2121206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2121209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2121212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2121218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121241 */     // MIs[0] round
     /* 2121241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121244 */     // MIs[0] policy
     /* 2121244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121254 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2121257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121280 */     // GIR_Coverage, 17128,
     /* 2121280 */     GIR_EraseRootFromParent_Done,
     /* 2121281 */   // Label 28078: @2121281
     /* 2121281 */   GIM_Try, /*On fail goto*//*Label 28079*/ GIMT_Encode4(2121372), // Rule ID 17129 //
     /* 2121286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2121297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2121300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2121303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2121309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121332 */     // MIs[0] round
     /* 2121332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121335 */     // MIs[0] policy
     /* 2121335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121345 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2121348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121371 */     // GIR_Coverage, 17129,
     /* 2121371 */     GIR_EraseRootFromParent_Done,
     /* 2121372 */   // Label 28079: @2121372
     /* 2121372 */   GIM_Try, /*On fail goto*//*Label 28080*/ GIMT_Encode4(2121463), // Rule ID 17132 //
     /* 2121377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2121388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2121391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2121394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121423 */     // MIs[0] round
     /* 2121423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121426 */     // MIs[0] policy
     /* 2121426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121436 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2121439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121462 */     // GIR_Coverage, 17132,
     /* 2121462 */     GIR_EraseRootFromParent_Done,
     /* 2121463 */   // Label 28080: @2121463
     /* 2121463 */   GIM_Try, /*On fail goto*//*Label 28081*/ GIMT_Encode4(2121554), // Rule ID 17133 //
     /* 2121468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2121471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2121479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2121482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2121485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121514 */     // MIs[0] round
     /* 2121514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121517 */     // MIs[0] policy
     /* 2121517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121527 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2121530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121553 */     // GIR_Coverage, 17133,
     /* 2121553 */     GIR_EraseRootFromParent_Done,
     /* 2121554 */   // Label 28081: @2121554
     /* 2121554 */   GIM_Try, /*On fail goto*//*Label 28082*/ GIMT_Encode4(2121645), // Rule ID 17136 //
     /* 2121559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2121570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2121573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2121576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121605 */     // MIs[0] round
     /* 2121605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121608 */     // MIs[0] policy
     /* 2121608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121618 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2121621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121644 */     // GIR_Coverage, 17136,
     /* 2121644 */     GIR_EraseRootFromParent_Done,
     /* 2121645 */   // Label 28082: @2121645
     /* 2121645 */   GIM_Try, /*On fail goto*//*Label 28083*/ GIMT_Encode4(2121736), // Rule ID 17137 //
     /* 2121650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2121653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2121661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2121664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2121667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121696 */     // MIs[0] round
     /* 2121696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121699 */     // MIs[0] policy
     /* 2121699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121709 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2121712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121735 */     // GIR_Coverage, 17137,
     /* 2121735 */     GIR_EraseRootFromParent_Done,
     /* 2121736 */   // Label 28083: @2121736
     /* 2121736 */   GIM_Try, /*On fail goto*//*Label 28084*/ GIMT_Encode4(2121827), // Rule ID 17140 //
     /* 2121741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2121752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2121755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2121758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121787 */     // MIs[0] round
     /* 2121787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121790 */     // MIs[0] policy
     /* 2121790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121800 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2121803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121826 */     // GIR_Coverage, 17140,
     /* 2121826 */     GIR_EraseRootFromParent_Done,
     /* 2121827 */   // Label 28084: @2121827
     /* 2121827 */   GIM_Try, /*On fail goto*//*Label 28085*/ GIMT_Encode4(2121918), // Rule ID 17141 //
     /* 2121832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2121835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2121843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2121846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2121849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121878 */     // MIs[0] round
     /* 2121878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121881 */     // MIs[0] policy
     /* 2121881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121891 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2121894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121917 */     // GIR_Coverage, 17141,
     /* 2121917 */     GIR_EraseRootFromParent_Done,
     /* 2121918 */   // Label 28085: @2121918
     /* 2121918 */   GIM_Try, /*On fail goto*//*Label 28086*/ GIMT_Encode4(2122009), // Rule ID 17144 //
     /* 2121923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2121934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2121937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2121940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121969 */     // MIs[0] round
     /* 2121969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121972 */     // MIs[0] policy
     /* 2121972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121982 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2121985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122008 */     // GIR_Coverage, 17144,
     /* 2122008 */     GIR_EraseRootFromParent_Done,
     /* 2122009 */   // Label 28086: @2122009
     /* 2122009 */   GIM_Try, /*On fail goto*//*Label 28087*/ GIMT_Encode4(2122100), // Rule ID 17145 //
     /* 2122014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2122025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2122028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122060 */     // MIs[0] round
     /* 2122060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122063 */     // MIs[0] policy
     /* 2122063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122073 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2122076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122099 */     // GIR_Coverage, 17145,
     /* 2122099 */     GIR_EraseRootFromParent_Done,
     /* 2122100 */   // Label 28087: @2122100
     /* 2122100 */   GIM_Try, /*On fail goto*//*Label 28088*/ GIMT_Encode4(2122191), // Rule ID 17154 //
     /* 2122105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2122116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2122119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2122125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122151 */     // MIs[0] round
     /* 2122151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122154 */     // MIs[0] policy
     /* 2122154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122164 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2122167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122190 */     // GIR_Coverage, 17154,
     /* 2122190 */     GIR_EraseRootFromParent_Done,
     /* 2122191 */   // Label 28088: @2122191
     /* 2122191 */   GIM_Try, /*On fail goto*//*Label 28089*/ GIMT_Encode4(2122282), // Rule ID 17155 //
     /* 2122196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2122207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2122210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2122216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122242 */     // MIs[0] round
     /* 2122242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122245 */     // MIs[0] policy
     /* 2122245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122255 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2122258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122281 */     // GIR_Coverage, 17155,
     /* 2122281 */     GIR_EraseRootFromParent_Done,
     /* 2122282 */   // Label 28089: @2122282
     /* 2122282 */   GIM_Try, /*On fail goto*//*Label 28090*/ GIMT_Encode4(2122373), // Rule ID 17164 //
     /* 2122287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2122298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2122301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2122307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122333 */     // MIs[0] round
     /* 2122333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122336 */     // MIs[0] policy
     /* 2122336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122346 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2122349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122372 */     // GIR_Coverage, 17164,
     /* 2122372 */     GIR_EraseRootFromParent_Done,
     /* 2122373 */   // Label 28090: @2122373
     /* 2122373 */   GIM_Try, /*On fail goto*//*Label 28091*/ GIMT_Encode4(2122464), // Rule ID 17165 //
     /* 2122378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2122389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2122392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2122398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122424 */     // MIs[0] round
     /* 2122424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122427 */     // MIs[0] policy
     /* 2122427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122437 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2122440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122463 */     // GIR_Coverage, 17165,
     /* 2122463 */     GIR_EraseRootFromParent_Done,
     /* 2122464 */   // Label 28091: @2122464
     /* 2122464 */   GIM_Try, /*On fail goto*//*Label 28092*/ GIMT_Encode4(2122555), // Rule ID 17174 //
     /* 2122469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2122480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2122483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2122489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122515 */     // MIs[0] round
     /* 2122515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122518 */     // MIs[0] policy
     /* 2122518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122528 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2122531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122554 */     // GIR_Coverage, 17174,
     /* 2122554 */     GIR_EraseRootFromParent_Done,
     /* 2122555 */   // Label 28092: @2122555
     /* 2122555 */   GIM_Try, /*On fail goto*//*Label 28093*/ GIMT_Encode4(2122646), // Rule ID 17175 //
     /* 2122560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2122571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2122574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2122580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122606 */     // MIs[0] round
     /* 2122606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122609 */     // MIs[0] policy
     /* 2122609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122619 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2122622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122645 */     // GIR_Coverage, 17175,
     /* 2122645 */     GIR_EraseRootFromParent_Done,
     /* 2122646 */   // Label 28093: @2122646
     /* 2122646 */   GIM_Try, /*On fail goto*//*Label 28094*/ GIMT_Encode4(2122737), // Rule ID 17184 //
     /* 2122651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2122662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2122665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2122668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2122671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2122674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122697 */     // MIs[0] round
     /* 2122697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122700 */     // MIs[0] policy
     /* 2122700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122710 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2122713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122736 */     // GIR_Coverage, 17184,
     /* 2122736 */     GIR_EraseRootFromParent_Done,
     /* 2122737 */   // Label 28094: @2122737
     /* 2122737 */   GIM_Try, /*On fail goto*//*Label 28095*/ GIMT_Encode4(2122828), // Rule ID 17185 //
     /* 2122742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2122753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2122756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2122759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2122762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2122765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122788 */     // MIs[0] round
     /* 2122788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122791 */     // MIs[0] policy
     /* 2122791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122801 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2122804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122814 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122824 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122827 */     // GIR_Coverage, 17185,
     /* 2122827 */     GIR_EraseRootFromParent_Done,
     /* 2122828 */   // Label 28095: @2122828
     /* 2122828 */   GIM_Try, /*On fail goto*//*Label 28096*/ GIMT_Encode4(2122919), // Rule ID 17194 //
     /* 2122833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2122836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2122844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2122847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2122850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2122853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2122856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122879 */     // MIs[0] round
     /* 2122879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122882 */     // MIs[0] policy
     /* 2122882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122892 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2122895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122918 */     // GIR_Coverage, 17194,
     /* 2122918 */     GIR_EraseRootFromParent_Done,
     /* 2122919 */   // Label 28096: @2122919
     /* 2122919 */   GIM_Try, /*On fail goto*//*Label 28097*/ GIMT_Encode4(2123010), // Rule ID 17195 //
     /* 2122924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2122935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2122938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2122941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2122944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2122947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122970 */     // MIs[0] round
     /* 2122970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122973 */     // MIs[0] policy
     /* 2122973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122983 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2122986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122996 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123006 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123009 */     // GIR_Coverage, 17195,
     /* 2123009 */     GIR_EraseRootFromParent_Done,
     /* 2123010 */   // Label 28097: @2123010
     /* 2123010 */   GIM_Try, /*On fail goto*//*Label 28098*/ GIMT_Encode4(2123101), // Rule ID 17204 //
     /* 2123015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2123026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2123029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2123032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2123035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123061 */     // MIs[0] round
     /* 2123061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123064 */     // MIs[0] policy
     /* 2123064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123074 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2123077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123100 */     // GIR_Coverage, 17204,
     /* 2123100 */     GIR_EraseRootFromParent_Done,
     /* 2123101 */   // Label 28098: @2123101
     /* 2123101 */   GIM_Try, /*On fail goto*//*Label 28099*/ GIMT_Encode4(2123192), // Rule ID 17205 //
     /* 2123106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2123117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2123120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2123123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2123126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123152 */     // MIs[0] round
     /* 2123152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123155 */     // MIs[0] policy
     /* 2123155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123165 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2123168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123191 */     // GIR_Coverage, 17205,
     /* 2123191 */     GIR_EraseRootFromParent_Done,
     /* 2123192 */   // Label 28099: @2123192
     /* 2123192 */   GIM_Try, /*On fail goto*//*Label 28100*/ GIMT_Encode4(2123283), // Rule ID 17214 //
     /* 2123197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2123208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2123211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2123214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2123217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123243 */     // MIs[0] round
     /* 2123243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123246 */     // MIs[0] policy
     /* 2123246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123256 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2123259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123282 */     // GIR_Coverage, 17214,
     /* 2123282 */     GIR_EraseRootFromParent_Done,
     /* 2123283 */   // Label 28100: @2123283
     /* 2123283 */   GIM_Try, /*On fail goto*//*Label 28101*/ GIMT_Encode4(2123374), // Rule ID 17215 //
     /* 2123288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2123299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2123302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2123305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2123308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123334 */     // MIs[0] round
     /* 2123334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123337 */     // MIs[0] policy
     /* 2123337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123347 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2123350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123373 */     // GIR_Coverage, 17215,
     /* 2123373 */     GIR_EraseRootFromParent_Done,
     /* 2123374 */   // Label 28101: @2123374
     /* 2123374 */   GIM_Try, /*On fail goto*//*Label 28102*/ GIMT_Encode4(2123465), // Rule ID 17224 //
     /* 2123379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2123390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2123393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2123396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2123399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123425 */     // MIs[0] round
     /* 2123425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123428 */     // MIs[0] policy
     /* 2123428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123438 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2123441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123464 */     // GIR_Coverage, 17224,
     /* 2123464 */     GIR_EraseRootFromParent_Done,
     /* 2123465 */   // Label 28102: @2123465
     /* 2123465 */   GIM_Try, /*On fail goto*//*Label 28103*/ GIMT_Encode4(2123556), // Rule ID 17225 //
     /* 2123470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2123481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2123484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2123487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2123490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123516 */     // MIs[0] round
     /* 2123516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123519 */     // MIs[0] policy
     /* 2123519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123529 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2123532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123555 */     // GIR_Coverage, 17225,
     /* 2123555 */     GIR_EraseRootFromParent_Done,
     /* 2123556 */   // Label 28103: @2123556
     /* 2123556 */   GIM_Try, /*On fail goto*//*Label 28104*/ GIMT_Encode4(2123647), // Rule ID 17228 //
     /* 2123561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2123564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2123572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2123575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2123578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2123581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2123603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123607 */     // MIs[0] round
     /* 2123607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123610 */     // MIs[0] policy
     /* 2123610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123620 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2123623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123646 */     // GIR_Coverage, 17228,
     /* 2123646 */     GIR_EraseRootFromParent_Done,
     /* 2123647 */   // Label 28104: @2123647
     /* 2123647 */   GIM_Try, /*On fail goto*//*Label 28105*/ GIMT_Encode4(2123738), // Rule ID 17229 //
     /* 2123652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2123655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2123663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2123666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2123669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2123672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2123694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123698 */     // MIs[0] round
     /* 2123698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123701 */     // MIs[0] policy
     /* 2123701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123711 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2123714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123737 */     // GIR_Coverage, 17229,
     /* 2123737 */     GIR_EraseRootFromParent_Done,
     /* 2123738 */   // Label 28105: @2123738
     /* 2123738 */   GIM_Try, /*On fail goto*//*Label 28106*/ GIMT_Encode4(2123829), // Rule ID 17232 //
     /* 2123743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2123746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2123754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2123757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2123760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2123763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2123785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123789 */     // MIs[0] round
     /* 2123789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123792 */     // MIs[0] policy
     /* 2123792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123802 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2123805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123828 */     // GIR_Coverage, 17232,
     /* 2123828 */     GIR_EraseRootFromParent_Done,
     /* 2123829 */   // Label 28106: @2123829
     /* 2123829 */   GIM_Try, /*On fail goto*//*Label 28107*/ GIMT_Encode4(2123920), // Rule ID 17233 //
     /* 2123834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2123837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2123845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2123848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2123851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2123854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123857 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2123876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123880 */     // MIs[0] round
     /* 2123880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123883 */     // MIs[0] policy
     /* 2123883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123893 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2123896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123919 */     // GIR_Coverage, 17233,
     /* 2123919 */     GIR_EraseRootFromParent_Done,
     /* 2123920 */   // Label 28107: @2123920
     /* 2123920 */   GIM_Try, /*On fail goto*//*Label 28108*/ GIMT_Encode4(2124011), // Rule ID 17236 //
     /* 2123925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2123928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2123936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2123939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2123942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2123945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2123967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123971 */     // MIs[0] round
     /* 2123971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123974 */     // MIs[0] policy
     /* 2123974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123984 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2123987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124010 */     // GIR_Coverage, 17236,
     /* 2124010 */     GIR_EraseRootFromParent_Done,
     /* 2124011 */   // Label 28108: @2124011
     /* 2124011 */   GIM_Try, /*On fail goto*//*Label 28109*/ GIMT_Encode4(2124102), // Rule ID 17237 //
     /* 2124016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2124027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2124030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2124033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124062 */     // MIs[0] round
     /* 2124062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124065 */     // MIs[0] policy
     /* 2124065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124075 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2124078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124101 */     // GIR_Coverage, 17237,
     /* 2124101 */     GIR_EraseRootFromParent_Done,
     /* 2124102 */   // Label 28109: @2124102
     /* 2124102 */   GIM_Try, /*On fail goto*//*Label 28110*/ GIMT_Encode4(2124193), // Rule ID 17240 //
     /* 2124107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2124118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2124121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2124124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124153 */     // MIs[0] round
     /* 2124153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124156 */     // MIs[0] policy
     /* 2124156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124166 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2124169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124192 */     // GIR_Coverage, 17240,
     /* 2124192 */     GIR_EraseRootFromParent_Done,
     /* 2124193 */   // Label 28110: @2124193
     /* 2124193 */   GIM_Try, /*On fail goto*//*Label 28111*/ GIMT_Encode4(2124284), // Rule ID 17241 //
     /* 2124198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2124209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2124212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2124215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124244 */     // MIs[0] round
     /* 2124244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124247 */     // MIs[0] policy
     /* 2124247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124257 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2124260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124283 */     // GIR_Coverage, 17241,
     /* 2124283 */     GIR_EraseRootFromParent_Done,
     /* 2124284 */   // Label 28111: @2124284
     /* 2124284 */   GIM_Try, /*On fail goto*//*Label 28112*/ GIMT_Encode4(2124375), // Rule ID 17244 //
     /* 2124289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2124300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2124303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2124306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2124312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124335 */     // MIs[0] round
     /* 2124335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124338 */     // MIs[0] policy
     /* 2124338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124348 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2124351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124374 */     // GIR_Coverage, 17244,
     /* 2124374 */     GIR_EraseRootFromParent_Done,
     /* 2124375 */   // Label 28112: @2124375
     /* 2124375 */   GIM_Try, /*On fail goto*//*Label 28113*/ GIMT_Encode4(2124466), // Rule ID 17245 //
     /* 2124380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2124391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2124394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2124397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2124403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124426 */     // MIs[0] round
     /* 2124426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124429 */     // MIs[0] policy
     /* 2124429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124439 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2124442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124452 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124462 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124465 */     // GIR_Coverage, 17245,
     /* 2124465 */     GIR_EraseRootFromParent_Done,
     /* 2124466 */   // Label 28113: @2124466
     /* 2124466 */   GIM_Try, /*On fail goto*//*Label 28114*/ GIMT_Encode4(2124557), // Rule ID 17248 //
     /* 2124471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2124474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2124482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2124485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2124488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124517 */     // MIs[0] round
     /* 2124517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124520 */     // MIs[0] policy
     /* 2124520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124530 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2124533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124556 */     // GIR_Coverage, 17248,
     /* 2124556 */     GIR_EraseRootFromParent_Done,
     /* 2124557 */   // Label 28114: @2124557
     /* 2124557 */   GIM_Try, /*On fail goto*//*Label 28115*/ GIMT_Encode4(2124648), // Rule ID 17249 //
     /* 2124562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2124565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2124573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2124576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2124579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124608 */     // MIs[0] round
     /* 2124608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124611 */     // MIs[0] policy
     /* 2124611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124621 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2124624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124647 */     // GIR_Coverage, 17249,
     /* 2124647 */     GIR_EraseRootFromParent_Done,
     /* 2124648 */   // Label 28115: @2124648
     /* 2124648 */   GIM_Try, /*On fail goto*//*Label 28116*/ GIMT_Encode4(2124739), // Rule ID 17252 //
     /* 2124653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2124656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2124664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2124667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2124670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124699 */     // MIs[0] round
     /* 2124699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124702 */     // MIs[0] policy
     /* 2124702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124712 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2124715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124738 */     // GIR_Coverage, 17252,
     /* 2124738 */     GIR_EraseRootFromParent_Done,
     /* 2124739 */   // Label 28116: @2124739
     /* 2124739 */   GIM_Try, /*On fail goto*//*Label 28117*/ GIMT_Encode4(2124830), // Rule ID 17253 //
     /* 2124744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2124747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2124755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2124758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2124761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124790 */     // MIs[0] round
     /* 2124790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124793 */     // MIs[0] policy
     /* 2124793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124803 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2124806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124829 */     // GIR_Coverage, 17253,
     /* 2124829 */     GIR_EraseRootFromParent_Done,
     /* 2124830 */   // Label 28117: @2124830
     /* 2124830 */   GIM_Try, /*On fail goto*//*Label 28118*/ GIMT_Encode4(2124921), // Rule ID 17256 //
     /* 2124835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2124838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2124846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2124849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2124852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124881 */     // MIs[0] round
     /* 2124881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124884 */     // MIs[0] policy
     /* 2124884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124894 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2124897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124920 */     // GIR_Coverage, 17256,
     /* 2124920 */     GIR_EraseRootFromParent_Done,
     /* 2124921 */   // Label 28118: @2124921
     /* 2124921 */   GIM_Try, /*On fail goto*//*Label 28119*/ GIMT_Encode4(2125012), // Rule ID 17257 //
     /* 2124926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2124929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2124937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2124940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2124943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124972 */     // MIs[0] round
     /* 2124972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124975 */     // MIs[0] policy
     /* 2124975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124985 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2124988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125008 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125011 */     // GIR_Coverage, 17257,
     /* 2125011 */     GIR_EraseRootFromParent_Done,
     /* 2125012 */   // Label 28119: @2125012
     /* 2125012 */   GIM_Try, /*On fail goto*//*Label 28120*/ GIMT_Encode4(2125103), // Rule ID 17260 //
     /* 2125017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2125020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2125028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2125031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2125034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125063 */     // MIs[0] round
     /* 2125063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125066 */     // MIs[0] policy
     /* 2125066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125076 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2125079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125102 */     // GIR_Coverage, 17260,
     /* 2125102 */     GIR_EraseRootFromParent_Done,
     /* 2125103 */   // Label 28120: @2125103
     /* 2125103 */   GIM_Try, /*On fail goto*//*Label 28121*/ GIMT_Encode4(2125194), // Rule ID 17261 //
     /* 2125108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2125119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2125122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2125125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125154 */     // MIs[0] round
     /* 2125154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125157 */     // MIs[0] policy
     /* 2125157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125167 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2125170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125193 */     // GIR_Coverage, 17261,
     /* 2125193 */     GIR_EraseRootFromParent_Done,
     /* 2125194 */   // Label 28121: @2125194
     /* 2125194 */   GIM_Try, /*On fail goto*//*Label 28122*/ GIMT_Encode4(2125285), // Rule ID 17270 //
     /* 2125199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2125210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2125213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2125216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2125219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125245 */     // MIs[0] round
     /* 2125245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125248 */     // MIs[0] policy
     /* 2125248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125258 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2125261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125284 */     // GIR_Coverage, 17270,
     /* 2125284 */     GIR_EraseRootFromParent_Done,
     /* 2125285 */   // Label 28122: @2125285
     /* 2125285 */   GIM_Try, /*On fail goto*//*Label 28123*/ GIMT_Encode4(2125376), // Rule ID 17271 //
     /* 2125290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2125293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2125301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2125304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2125307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2125310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125313 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125336 */     // MIs[0] round
     /* 2125336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125339 */     // MIs[0] policy
     /* 2125339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125349 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2125352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125375 */     // GIR_Coverage, 17271,
     /* 2125375 */     GIR_EraseRootFromParent_Done,
     /* 2125376 */   // Label 28123: @2125376
     /* 2125376 */   GIM_Try, /*On fail goto*//*Label 28124*/ GIMT_Encode4(2125467), // Rule ID 17280 //
     /* 2125381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2125392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2125395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2125398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2125401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125427 */     // MIs[0] round
     /* 2125427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125430 */     // MIs[0] policy
     /* 2125430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125440 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2125443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125466 */     // GIR_Coverage, 17280,
     /* 2125466 */     GIR_EraseRootFromParent_Done,
     /* 2125467 */   // Label 28124: @2125467
     /* 2125467 */   GIM_Try, /*On fail goto*//*Label 28125*/ GIMT_Encode4(2125558), // Rule ID 17281 //
     /* 2125472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2125475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2125483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2125486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2125489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2125492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125495 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125518 */     // MIs[0] round
     /* 2125518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125521 */     // MIs[0] policy
     /* 2125521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125531 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2125534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125554 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125557 */     // GIR_Coverage, 17281,
     /* 2125557 */     GIR_EraseRootFromParent_Done,
     /* 2125558 */   // Label 28125: @2125558
     /* 2125558 */   GIM_Try, /*On fail goto*//*Label 28126*/ GIMT_Encode4(2125649), // Rule ID 17290 //
     /* 2125563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2125574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2125577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2125580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2125583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2125593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125609 */     // MIs[0] round
     /* 2125609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125612 */     // MIs[0] policy
     /* 2125612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125622 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2125625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125648 */     // GIR_Coverage, 17290,
     /* 2125648 */     GIR_EraseRootFromParent_Done,
     /* 2125649 */   // Label 28126: @2125649
     /* 2125649 */   GIM_Try, /*On fail goto*//*Label 28127*/ GIMT_Encode4(2125740), // Rule ID 17291 //
     /* 2125654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2125657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2125665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2125668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2125671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2125674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125677 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2125684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125700 */     // MIs[0] round
     /* 2125700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125703 */     // MIs[0] policy
     /* 2125703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125713 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2125716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125736 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125739 */     // GIR_Coverage, 17291,
     /* 2125739 */     GIR_EraseRootFromParent_Done,
     /* 2125740 */   // Label 28127: @2125740
     /* 2125740 */   GIM_Try, /*On fail goto*//*Label 28128*/ GIMT_Encode4(2125831), // Rule ID 17300 //
     /* 2125745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2125756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2125759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2125762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2125765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125791 */     // MIs[0] round
     /* 2125791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125794 */     // MIs[0] policy
     /* 2125794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125804 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2125807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125830 */     // GIR_Coverage, 17300,
     /* 2125830 */     GIR_EraseRootFromParent_Done,
     /* 2125831 */   // Label 28128: @2125831
     /* 2125831 */   GIM_Try, /*On fail goto*//*Label 28129*/ GIMT_Encode4(2125922), // Rule ID 17301 //
     /* 2125836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2125839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2125847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2125850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2125853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2125856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125882 */     // MIs[0] round
     /* 2125882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125885 */     // MIs[0] policy
     /* 2125885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125895 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2125898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125921 */     // GIR_Coverage, 17301,
     /* 2125921 */     GIR_EraseRootFromParent_Done,
     /* 2125922 */   // Label 28129: @2125922
     /* 2125922 */   GIM_Try, /*On fail goto*//*Label 28130*/ GIMT_Encode4(2126013), // Rule ID 17310 //
     /* 2125927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2125938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2125941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2125944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2125947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2125950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125973 */     // MIs[0] round
     /* 2125973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125976 */     // MIs[0] policy
     /* 2125976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125986 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2125989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126012 */     // GIR_Coverage, 17310,
     /* 2126012 */     GIR_EraseRootFromParent_Done,
     /* 2126013 */   // Label 28130: @2126013
     /* 2126013 */   GIM_Try, /*On fail goto*//*Label 28131*/ GIMT_Encode4(2126104), // Rule ID 17311 //
     /* 2126018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2126029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2126032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2126035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2126038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2126041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126064 */     // MIs[0] round
     /* 2126064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126067 */     // MIs[0] policy
     /* 2126067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126077 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2126080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126103 */     // GIR_Coverage, 17311,
     /* 2126103 */     GIR_EraseRootFromParent_Done,
     /* 2126104 */   // Label 28131: @2126104
     /* 2126104 */   GIM_Try, /*On fail goto*//*Label 28132*/ GIMT_Encode4(2126195), // Rule ID 17320 //
     /* 2126109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2126120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2126123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2126126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2126129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126155 */     // MIs[0] round
     /* 2126155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126158 */     // MIs[0] policy
     /* 2126158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126168 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2126171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126194 */     // GIR_Coverage, 17320,
     /* 2126194 */     GIR_EraseRootFromParent_Done,
     /* 2126195 */   // Label 28132: @2126195
     /* 2126195 */   GIM_Try, /*On fail goto*//*Label 28133*/ GIMT_Encode4(2126286), // Rule ID 17321 //
     /* 2126200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2126211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2126214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2126217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2126220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126246 */     // MIs[0] round
     /* 2126246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126249 */     // MIs[0] policy
     /* 2126249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126259 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2126262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126285 */     // GIR_Coverage, 17321,
     /* 2126285 */     GIR_EraseRootFromParent_Done,
     /* 2126286 */   // Label 28133: @2126286
     /* 2126286 */   GIM_Try, /*On fail goto*//*Label 28134*/ GIMT_Encode4(2126377), // Rule ID 17330 //
     /* 2126291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2126302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2126305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2126308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2126311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126337 */     // MIs[0] round
     /* 2126337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126340 */     // MIs[0] policy
     /* 2126340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126350 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2126353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126376 */     // GIR_Coverage, 17330,
     /* 2126376 */     GIR_EraseRootFromParent_Done,
     /* 2126377 */   // Label 28134: @2126377
     /* 2126377 */   GIM_Try, /*On fail goto*//*Label 28135*/ GIMT_Encode4(2126468), // Rule ID 17331 //
     /* 2126382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2126393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2126396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2126399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2126402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126428 */     // MIs[0] round
     /* 2126428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126431 */     // MIs[0] policy
     /* 2126431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126441 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2126444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126467 */     // GIR_Coverage, 17331,
     /* 2126467 */     GIR_EraseRootFromParent_Done,
     /* 2126468 */   // Label 28135: @2126468
     /* 2126468 */   GIM_Try, /*On fail goto*//*Label 28136*/ GIMT_Encode4(2126559), // Rule ID 17340 //
     /* 2126473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2126484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2126487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2126490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2126493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126519 */     // MIs[0] round
     /* 2126519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126522 */     // MIs[0] policy
     /* 2126522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126532 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2126535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126558 */     // GIR_Coverage, 17340,
     /* 2126558 */     GIR_EraseRootFromParent_Done,
     /* 2126559 */   // Label 28136: @2126559
     /* 2126559 */   GIM_Try, /*On fail goto*//*Label 28137*/ GIMT_Encode4(2126650), // Rule ID 17341 //
     /* 2126564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2126575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2126578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2126581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2126584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126610 */     // MIs[0] round
     /* 2126610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126613 */     // MIs[0] policy
     /* 2126613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126623 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2126626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126649 */     // GIR_Coverage, 17341,
     /* 2126649 */     GIR_EraseRootFromParent_Done,
     /* 2126650 */   // Label 28137: @2126650
     /* 2126650 */   GIM_Try, /*On fail goto*//*Label 28138*/ GIMT_Encode4(2126741), // Rule ID 17350 //
     /* 2126655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2126666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2126669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2126672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2126675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126701 */     // MIs[0] round
     /* 2126701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126704 */     // MIs[0] policy
     /* 2126704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126714 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2126717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126740 */     // GIR_Coverage, 17350,
     /* 2126740 */     GIR_EraseRootFromParent_Done,
     /* 2126741 */   // Label 28138: @2126741
     /* 2126741 */   GIM_Try, /*On fail goto*//*Label 28139*/ GIMT_Encode4(2126832), // Rule ID 17351 //
     /* 2126746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2126757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2126760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2126763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2126766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126792 */     // MIs[0] round
     /* 2126792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126795 */     // MIs[0] policy
     /* 2126795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126805 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2126808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126831 */     // GIR_Coverage, 17351,
     /* 2126831 */     GIR_EraseRootFromParent_Done,
     /* 2126832 */   // Label 28139: @2126832
     /* 2126832 */   GIM_Try, /*On fail goto*//*Label 28140*/ GIMT_Encode4(2126923), // Rule ID 17354 //
     /* 2126837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2126840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2126848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2126851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2126854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2126857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2126879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126883 */     // MIs[0] round
     /* 2126883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126886 */     // MIs[0] policy
     /* 2126886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126896 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2126899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126922 */     // GIR_Coverage, 17354,
     /* 2126922 */     GIR_EraseRootFromParent_Done,
     /* 2126923 */   // Label 28140: @2126923
     /* 2126923 */   GIM_Try, /*On fail goto*//*Label 28141*/ GIMT_Encode4(2127014), // Rule ID 17355 //
     /* 2126928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2126939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2126942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2126945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2126948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126951 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2126970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126974 */     // MIs[0] round
     /* 2126974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126977 */     // MIs[0] policy
     /* 2126977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126987 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2126990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127013 */     // GIR_Coverage, 17355,
     /* 2127013 */     GIR_EraseRootFromParent_Done,
     /* 2127014 */   // Label 28141: @2127014
     /* 2127014 */   GIM_Try, /*On fail goto*//*Label 28142*/ GIMT_Encode4(2127105), // Rule ID 17358 //
     /* 2127019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2127030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2127033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2127036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127065 */     // MIs[0] round
     /* 2127065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127068 */     // MIs[0] policy
     /* 2127068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127078 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2127081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127104 */     // GIR_Coverage, 17358,
     /* 2127104 */     GIR_EraseRootFromParent_Done,
     /* 2127105 */   // Label 28142: @2127105
     /* 2127105 */   GIM_Try, /*On fail goto*//*Label 28143*/ GIMT_Encode4(2127196), // Rule ID 17359 //
     /* 2127110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2127121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2127124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2127127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127156 */     // MIs[0] round
     /* 2127156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127159 */     // MIs[0] policy
     /* 2127159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127169 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2127172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127195 */     // GIR_Coverage, 17359,
     /* 2127195 */     GIR_EraseRootFromParent_Done,
     /* 2127196 */   // Label 28143: @2127196
     /* 2127196 */   GIM_Try, /*On fail goto*//*Label 28144*/ GIMT_Encode4(2127287), // Rule ID 17362 //
     /* 2127201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2127212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2127215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2127218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127247 */     // MIs[0] round
     /* 2127247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127250 */     // MIs[0] policy
     /* 2127250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127260 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2127263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127286 */     // GIR_Coverage, 17362,
     /* 2127286 */     GIR_EraseRootFromParent_Done,
     /* 2127287 */   // Label 28144: @2127287
     /* 2127287 */   GIM_Try, /*On fail goto*//*Label 28145*/ GIMT_Encode4(2127378), // Rule ID 17363 //
     /* 2127292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2127303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2127306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2127309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127338 */     // MIs[0] round
     /* 2127338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127341 */     // MIs[0] policy
     /* 2127341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127351 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2127354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127377 */     // GIR_Coverage, 17363,
     /* 2127377 */     GIR_EraseRootFromParent_Done,
     /* 2127378 */   // Label 28145: @2127378
     /* 2127378 */   GIM_Try, /*On fail goto*//*Label 28146*/ GIMT_Encode4(2127469), // Rule ID 17366 //
     /* 2127383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2127394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2127397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2127400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127429 */     // MIs[0] round
     /* 2127429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127432 */     // MIs[0] policy
     /* 2127432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127442 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2127445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127468 */     // GIR_Coverage, 17366,
     /* 2127468 */     GIR_EraseRootFromParent_Done,
     /* 2127469 */   // Label 28146: @2127469
     /* 2127469 */   GIM_Try, /*On fail goto*//*Label 28147*/ GIMT_Encode4(2127560), // Rule ID 17367 //
     /* 2127474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2127485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2127488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2127491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127520 */     // MIs[0] round
     /* 2127520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127523 */     // MIs[0] policy
     /* 2127523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127533 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2127536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127546 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127556 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127559 */     // GIR_Coverage, 17367,
     /* 2127559 */     GIR_EraseRootFromParent_Done,
     /* 2127560 */   // Label 28147: @2127560
     /* 2127560 */   GIM_Try, /*On fail goto*//*Label 28148*/ GIMT_Encode4(2127651), // Rule ID 17370 //
     /* 2127565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2127576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2127579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2127582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2127588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2127595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127611 */     // MIs[0] round
     /* 2127611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127614 */     // MIs[0] policy
     /* 2127614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127624 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2127627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127650 */     // GIR_Coverage, 17370,
     /* 2127650 */     GIR_EraseRootFromParent_Done,
     /* 2127651 */   // Label 28148: @2127651
     /* 2127651 */   GIM_Try, /*On fail goto*//*Label 28149*/ GIMT_Encode4(2127742), // Rule ID 17371 //
     /* 2127656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2127667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2127670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2127673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2127679 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2127686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127702 */     // MIs[0] round
     /* 2127702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127705 */     // MIs[0] policy
     /* 2127705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127715 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2127718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127741 */     // GIR_Coverage, 17371,
     /* 2127741 */     GIR_EraseRootFromParent_Done,
     /* 2127742 */   // Label 28149: @2127742
     /* 2127742 */   GIM_Try, /*On fail goto*//*Label 28150*/ GIMT_Encode4(2127833), // Rule ID 17374 //
     /* 2127747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2127750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2127758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2127761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2127764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2127767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2127789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127793 */     // MIs[0] round
     /* 2127793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127796 */     // MIs[0] policy
     /* 2127796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127806 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2127809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127832 */     // GIR_Coverage, 17374,
     /* 2127832 */     GIR_EraseRootFromParent_Done,
     /* 2127833 */   // Label 28150: @2127833
     /* 2127833 */   GIM_Try, /*On fail goto*//*Label 28151*/ GIMT_Encode4(2127924), // Rule ID 17375 //
     /* 2127838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2127841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2127849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2127852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2127855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2127858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2127880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127884 */     // MIs[0] round
     /* 2127884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127887 */     // MIs[0] policy
     /* 2127887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127897 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2127900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127923 */     // GIR_Coverage, 17375,
     /* 2127923 */     GIR_EraseRootFromParent_Done,
     /* 2127924 */   // Label 28151: @2127924
     /* 2127924 */   GIM_Try, /*On fail goto*//*Label 28152*/ GIMT_Encode4(2128015), // Rule ID 17378 //
     /* 2127929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2127932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2127940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2127943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2127946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2127949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2127971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127975 */     // MIs[0] round
     /* 2127975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127978 */     // MIs[0] policy
     /* 2127978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127988 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2127991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128014 */     // GIR_Coverage, 17378,
     /* 2128014 */     GIR_EraseRootFromParent_Done,
     /* 2128015 */   // Label 28152: @2128015
     /* 2128015 */   GIM_Try, /*On fail goto*//*Label 28153*/ GIMT_Encode4(2128106), // Rule ID 17379 //
     /* 2128020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2128031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2128034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2128037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2128050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128066 */     // MIs[0] round
     /* 2128066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128069 */     // MIs[0] policy
     /* 2128069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128079 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2128082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128105 */     // GIR_Coverage, 17379,
     /* 2128105 */     GIR_EraseRootFromParent_Done,
     /* 2128106 */   // Label 28153: @2128106
     /* 2128106 */   GIM_Try, /*On fail goto*//*Label 28154*/ GIMT_Encode4(2128197), // Rule ID 17382 //
     /* 2128111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2128122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2128125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2128128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128157 */     // MIs[0] round
     /* 2128157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128160 */     // MIs[0] policy
     /* 2128160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128170 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2128173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128196 */     // GIR_Coverage, 17382,
     /* 2128196 */     GIR_EraseRootFromParent_Done,
     /* 2128197 */   // Label 28154: @2128197
     /* 2128197 */   GIM_Try, /*On fail goto*//*Label 28155*/ GIMT_Encode4(2128288), // Rule ID 17383 //
     /* 2128202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2128213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2128216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2128219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128248 */     // MIs[0] round
     /* 2128248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128251 */     // MIs[0] policy
     /* 2128251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128261 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2128264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128287 */     // GIR_Coverage, 17383,
     /* 2128287 */     GIR_EraseRootFromParent_Done,
     /* 2128288 */   // Label 28155: @2128288
     /* 2128288 */   GIM_Try, /*On fail goto*//*Label 28156*/ GIMT_Encode4(2128379), // Rule ID 17386 //
     /* 2128293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2128304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2128307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2128310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128339 */     // MIs[0] round
     /* 2128339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128342 */     // MIs[0] policy
     /* 2128342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128352 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2128355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128378 */     // GIR_Coverage, 17386,
     /* 2128378 */     GIR_EraseRootFromParent_Done,
     /* 2128379 */   // Label 28156: @2128379
     /* 2128379 */   GIM_Try, /*On fail goto*//*Label 28157*/ GIMT_Encode4(2128470), // Rule ID 17387 //
     /* 2128384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2128395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2128398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2128401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128430 */     // MIs[0] round
     /* 2128430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128433 */     // MIs[0] policy
     /* 2128433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128443 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2128446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128469 */     // GIR_Coverage, 17387,
     /* 2128469 */     GIR_EraseRootFromParent_Done,
     /* 2128470 */   // Label 28157: @2128470
     /* 2128470 */   GIM_Try, /*On fail goto*//*Label 28158*/ GIMT_Encode4(2128561), // Rule ID 17390 //
     /* 2128475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2128478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2128486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2128489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2128492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2128495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128521 */     // MIs[0] round
     /* 2128521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128524 */     // MIs[0] policy
     /* 2128524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128534 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2128537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128560 */     // GIR_Coverage, 17390,
     /* 2128560 */     GIR_EraseRootFromParent_Done,
     /* 2128561 */   // Label 28158: @2128561
     /* 2128561 */   GIM_Try, /*On fail goto*//*Label 28159*/ GIMT_Encode4(2128652), // Rule ID 17391 //
     /* 2128566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2128569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2128577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2128580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2128583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2128586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128612 */     // MIs[0] round
     /* 2128612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128615 */     // MIs[0] policy
     /* 2128615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128625 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2128628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128651 */     // GIR_Coverage, 17391,
     /* 2128651 */     GIR_EraseRootFromParent_Done,
     /* 2128652 */   // Label 28159: @2128652
     /* 2128652 */   GIM_Try, /*On fail goto*//*Label 28160*/ GIMT_Encode4(2128743), // Rule ID 17394 //
     /* 2128657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2128660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2128668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2128671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2128674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2128677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128703 */     // MIs[0] round
     /* 2128703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128706 */     // MIs[0] policy
     /* 2128706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128716 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2128719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128742 */     // GIR_Coverage, 17394,
     /* 2128742 */     GIR_EraseRootFromParent_Done,
     /* 2128743 */   // Label 28160: @2128743
     /* 2128743 */   GIM_Try, /*On fail goto*//*Label 28161*/ GIMT_Encode4(2128834), // Rule ID 17395 //
     /* 2128748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2128751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2128759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2128762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2128765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2128768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128794 */     // MIs[0] round
     /* 2128794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128797 */     // MIs[0] policy
     /* 2128797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128807 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2128810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128833 */     // GIR_Coverage, 17395,
     /* 2128833 */     GIR_EraseRootFromParent_Done,
     /* 2128834 */   // Label 28161: @2128834
     /* 2128834 */   GIM_Try, /*On fail goto*//*Label 28162*/ GIMT_Encode4(2128925), // Rule ID 17398 //
     /* 2128839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2128842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2128850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2128853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2128856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2128859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128885 */     // MIs[0] round
     /* 2128885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128888 */     // MIs[0] policy
     /* 2128888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128898 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2128901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128924 */     // GIR_Coverage, 17398,
     /* 2128924 */     GIR_EraseRootFromParent_Done,
     /* 2128925 */   // Label 28162: @2128925
     /* 2128925 */   GIM_Try, /*On fail goto*//*Label 28163*/ GIMT_Encode4(2129016), // Rule ID 17399 //
     /* 2128930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2128933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2128941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2128944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2128947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2128950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128976 */     // MIs[0] round
     /* 2128976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128979 */     // MIs[0] policy
     /* 2128979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128989 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2128992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129002 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129012 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129015 */     // GIR_Coverage, 17399,
     /* 2129015 */     GIR_EraseRootFromParent_Done,
     /* 2129016 */   // Label 28163: @2129016
     /* 2129016 */   GIM_Try, /*On fail goto*//*Label 28164*/ GIMT_Encode4(2129107), // Rule ID 17402 //
     /* 2129021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2129032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2129035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2129038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2129041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129067 */     // MIs[0] round
     /* 2129067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129070 */     // MIs[0] policy
     /* 2129070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129080 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2129083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129106 */     // GIR_Coverage, 17402,
     /* 2129106 */     GIR_EraseRootFromParent_Done,
     /* 2129107 */   // Label 28164: @2129107
     /* 2129107 */   GIM_Try, /*On fail goto*//*Label 28165*/ GIMT_Encode4(2129198), // Rule ID 17403 //
     /* 2129112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2129123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2129126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2129129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2129132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129135 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129158 */     // MIs[0] round
     /* 2129158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129161 */     // MIs[0] policy
     /* 2129161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129171 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2129174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129194 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129197 */     // GIR_Coverage, 17403,
     /* 2129197 */     GIR_EraseRootFromParent_Done,
     /* 2129198 */   // Label 28165: @2129198
     /* 2129198 */   GIM_Try, /*On fail goto*//*Label 28166*/ GIMT_Encode4(2129289), // Rule ID 17406 //
     /* 2129203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2129206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2129214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2129217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2129220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2129223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129249 */     // MIs[0] round
     /* 2129249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129252 */     // MIs[0] policy
     /* 2129252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129262 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2129265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129288 */     // GIR_Coverage, 17406,
     /* 2129288 */     GIR_EraseRootFromParent_Done,
     /* 2129289 */   // Label 28166: @2129289
     /* 2129289 */   GIM_Try, /*On fail goto*//*Label 28167*/ GIMT_Encode4(2129380), // Rule ID 17407 //
     /* 2129294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2129297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2129305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2129308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2129311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2129314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129317 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129340 */     // MIs[0] round
     /* 2129340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129343 */     // MIs[0] policy
     /* 2129343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129353 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2129356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129376 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129379 */     // GIR_Coverage, 17407,
     /* 2129379 */     GIR_EraseRootFromParent_Done,
     /* 2129380 */   // Label 28167: @2129380
     /* 2129380 */   GIM_Try, /*On fail goto*//*Label 28168*/ GIMT_Encode4(2129471), // Rule ID 17410 //
     /* 2129385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2129388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2129396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2129399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2129402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2129405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129431 */     // MIs[0] round
     /* 2129431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129434 */     // MIs[0] policy
     /* 2129434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129444 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2129447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129470 */     // GIR_Coverage, 17410,
     /* 2129470 */     GIR_EraseRootFromParent_Done,
     /* 2129471 */   // Label 28168: @2129471
     /* 2129471 */   GIM_Try, /*On fail goto*//*Label 28169*/ GIMT_Encode4(2129562), // Rule ID 17411 //
     /* 2129476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2129479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2129487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2129490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2129493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2129496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129522 */     // MIs[0] round
     /* 2129522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129525 */     // MIs[0] policy
     /* 2129525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129535 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2129538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129558 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129561 */     // GIR_Coverage, 17411,
     /* 2129561 */     GIR_EraseRootFromParent_Done,
     /* 2129562 */   // Label 28169: @2129562
     /* 2129562 */   GIM_Try, /*On fail goto*//*Label 28170*/ GIMT_Encode4(2129653), // Rule ID 17414 //
     /* 2129567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2129578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2129581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2129584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2129587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2129590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2129597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129613 */     // MIs[0] round
     /* 2129613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129616 */     // MIs[0] policy
     /* 2129616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129626 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2129629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129639 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129649 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129652 */     // GIR_Coverage, 17414,
     /* 2129652 */     GIR_EraseRootFromParent_Done,
     /* 2129653 */   // Label 28170: @2129653
     /* 2129653 */   GIM_Try, /*On fail goto*//*Label 28171*/ GIMT_Encode4(2129744), // Rule ID 17415 //
     /* 2129658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2129669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2129672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2129675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2129678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2129681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2129688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129704 */     // MIs[0] round
     /* 2129704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129707 */     // MIs[0] policy
     /* 2129707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129717 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2129720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129730 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129740 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129743 */     // GIR_Coverage, 17415,
     /* 2129743 */     GIR_EraseRootFromParent_Done,
     /* 2129744 */   // Label 28171: @2129744
     /* 2129744 */   GIM_Try, /*On fail goto*//*Label 28172*/ GIMT_Encode4(2129835), // Rule ID 17418 //
     /* 2129749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2129760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2129763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2129766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2129769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2129772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2129779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129795 */     // MIs[0] round
     /* 2129795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129798 */     // MIs[0] policy
     /* 2129798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129808 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2129811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129834 */     // GIR_Coverage, 17418,
     /* 2129834 */     GIR_EraseRootFromParent_Done,
     /* 2129835 */   // Label 28172: @2129835
     /* 2129835 */   GIM_Try, /*On fail goto*//*Label 28173*/ GIMT_Encode4(2129926), // Rule ID 17419 //
     /* 2129840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2129851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2129854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2129857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2129860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2129863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2129870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129886 */     // MIs[0] round
     /* 2129886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129889 */     // MIs[0] policy
     /* 2129889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129899 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2129902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129925 */     // GIR_Coverage, 17419,
     /* 2129925 */     GIR_EraseRootFromParent_Done,
     /* 2129926 */   // Label 28173: @2129926
     /* 2129926 */   GIM_Try, /*On fail goto*//*Label 28174*/ GIMT_Encode4(2130017), // Rule ID 17422 //
     /* 2129931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2129942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2129945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2129948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2129951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2129954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2129961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129977 */     // MIs[0] round
     /* 2129977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129980 */     // MIs[0] policy
     /* 2129980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129990 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2129993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130016 */     // GIR_Coverage, 17422,
     /* 2130016 */     GIR_EraseRootFromParent_Done,
     /* 2130017 */   // Label 28174: @2130017
     /* 2130017 */   GIM_Try, /*On fail goto*//*Label 28175*/ GIMT_Encode4(2130108), // Rule ID 17423 //
     /* 2130022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2130025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2130033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2130036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2130039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2130042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2130045 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130068 */     // MIs[0] round
     /* 2130068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130071 */     // MIs[0] policy
     /* 2130071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130081 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2130084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130104 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130107 */     // GIR_Coverage, 17423,
     /* 2130107 */     GIR_EraseRootFromParent_Done,
     /* 2130108 */   // Label 28175: @2130108
     /* 2130108 */   GIM_Try, /*On fail goto*//*Label 28176*/ GIMT_Encode4(2130199), // Rule ID 17426 //
     /* 2130113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2130124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2130127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2130130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2130133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130159 */     // MIs[0] round
     /* 2130159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130162 */     // MIs[0] policy
     /* 2130162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130172 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2130175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130198 */     // GIR_Coverage, 17426,
     /* 2130198 */     GIR_EraseRootFromParent_Done,
     /* 2130199 */   // Label 28176: @2130199
     /* 2130199 */   GIM_Try, /*On fail goto*//*Label 28177*/ GIMT_Encode4(2130290), // Rule ID 17427 //
     /* 2130204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2130215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2130218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2130221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2130224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130250 */     // MIs[0] round
     /* 2130250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130253 */     // MIs[0] policy
     /* 2130253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130263 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2130266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130286 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130289 */     // GIR_Coverage, 17427,
     /* 2130289 */     GIR_EraseRootFromParent_Done,
     /* 2130290 */   // Label 28177: @2130290
     /* 2130290 */   GIM_Try, /*On fail goto*//*Label 28178*/ GIMT_Encode4(2130381), // Rule ID 17430 //
     /* 2130295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2130306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2130309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2130312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2130315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130341 */     // MIs[0] round
     /* 2130341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130344 */     // MIs[0] policy
     /* 2130344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130354 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2130357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130380 */     // GIR_Coverage, 17430,
     /* 2130380 */     GIR_EraseRootFromParent_Done,
     /* 2130381 */   // Label 28178: @2130381
     /* 2130381 */   GIM_Try, /*On fail goto*//*Label 28179*/ GIMT_Encode4(2130472), // Rule ID 17431 //
     /* 2130386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2130397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2130400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2130403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2130406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130432 */     // MIs[0] round
     /* 2130432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130435 */     // MIs[0] policy
     /* 2130435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130445 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2130448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130471 */     // GIR_Coverage, 17431,
     /* 2130471 */     GIR_EraseRootFromParent_Done,
     /* 2130472 */   // Label 28179: @2130472
     /* 2130472 */   GIM_Try, /*On fail goto*//*Label 28180*/ GIMT_Encode4(2130563), // Rule ID 17434 //
     /* 2130477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2130488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2130491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2130494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2130497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2130500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130523 */     // MIs[0] round
     /* 2130523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130526 */     // MIs[0] policy
     /* 2130526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130536 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2130539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130562 */     // GIR_Coverage, 17434,
     /* 2130562 */     GIR_EraseRootFromParent_Done,
     /* 2130563 */   // Label 28180: @2130563
     /* 2130563 */   GIM_Try, /*On fail goto*//*Label 28181*/ GIMT_Encode4(2130654), // Rule ID 17435 //
     /* 2130568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2130579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2130582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2130585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2130588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2130591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130614 */     // MIs[0] round
     /* 2130614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130617 */     // MIs[0] policy
     /* 2130617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130627 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2130630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130653 */     // GIR_Coverage, 17435,
     /* 2130653 */     GIR_EraseRootFromParent_Done,
     /* 2130654 */   // Label 28181: @2130654
     /* 2130654 */   GIM_Try, /*On fail goto*//*Label 28182*/ GIMT_Encode4(2130745), // Rule ID 17438 //
     /* 2130659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2130662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2130670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2130673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2130676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2130679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2130682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130705 */     // MIs[0] round
     /* 2130705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130708 */     // MIs[0] policy
     /* 2130708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130718 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2130721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130744 */     // GIR_Coverage, 17438,
     /* 2130744 */     GIR_EraseRootFromParent_Done,
     /* 2130745 */   // Label 28182: @2130745
     /* 2130745 */   GIM_Try, /*On fail goto*//*Label 28183*/ GIMT_Encode4(2130836), // Rule ID 17439 //
     /* 2130750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2130753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2130761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2130764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2130767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2130770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2130773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130796 */     // MIs[0] round
     /* 2130796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130799 */     // MIs[0] policy
     /* 2130799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130809 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2130812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130822 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130832 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130835 */     // GIR_Coverage, 17439,
     /* 2130835 */     GIR_EraseRootFromParent_Done,
     /* 2130836 */   // Label 28183: @2130836
     /* 2130836 */   GIM_Try, /*On fail goto*//*Label 28184*/ GIMT_Encode4(2130927), // Rule ID 17442 //
     /* 2130841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2130844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2130852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2130855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2130858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2130861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130887 */     // MIs[0] round
     /* 2130887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130890 */     // MIs[0] policy
     /* 2130890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130900 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2130903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130926 */     // GIR_Coverage, 17442,
     /* 2130926 */     GIR_EraseRootFromParent_Done,
     /* 2130927 */   // Label 28184: @2130927
     /* 2130927 */   GIM_Try, /*On fail goto*//*Label 28185*/ GIMT_Encode4(2131018), // Rule ID 17443 //
     /* 2130932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2130935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2130943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2130946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2130949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2130952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130978 */     // MIs[0] round
     /* 2130978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130981 */     // MIs[0] policy
     /* 2130981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130991 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2130994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131004 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131014 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131017 */     // GIR_Coverage, 17443,
     /* 2131017 */     GIR_EraseRootFromParent_Done,
     /* 2131018 */   // Label 28185: @2131018
     /* 2131018 */   GIM_Try, /*On fail goto*//*Label 28186*/ GIMT_Encode4(2131109), // Rule ID 17446 //
     /* 2131023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2131026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2131034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2131037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2131040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2131043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131069 */     // MIs[0] round
     /* 2131069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131072 */     // MIs[0] policy
     /* 2131072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131082 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2131085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131108 */     // GIR_Coverage, 17446,
     /* 2131108 */     GIR_EraseRootFromParent_Done,
     /* 2131109 */   // Label 28186: @2131109
     /* 2131109 */   GIM_Try, /*On fail goto*//*Label 28187*/ GIMT_Encode4(2131200), // Rule ID 17447 //
     /* 2131114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2131117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2131125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2131128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2131131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2131134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131160 */     // MIs[0] round
     /* 2131160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131163 */     // MIs[0] policy
     /* 2131163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131173 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2131176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131186 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131196 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131199 */     // GIR_Coverage, 17447,
     /* 2131199 */     GIR_EraseRootFromParent_Done,
     /* 2131200 */   // Label 28187: @2131200
     /* 2131200 */   GIM_Try, /*On fail goto*//*Label 28188*/ GIMT_Encode4(2131291), // Rule ID 17450 //
     /* 2131205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2131208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2131216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2131219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2131222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131251 */     // MIs[0] round
     /* 2131251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131254 */     // MIs[0] policy
     /* 2131254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131264 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2131267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131287 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131290 */     // GIR_Coverage, 17450,
     /* 2131290 */     GIR_EraseRootFromParent_Done,
     /* 2131291 */   // Label 28188: @2131291
     /* 2131291 */   GIM_Try, /*On fail goto*//*Label 28189*/ GIMT_Encode4(2131382), // Rule ID 17451 //
     /* 2131296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2131299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2131307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2131310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2131313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131319 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131342 */     // MIs[0] round
     /* 2131342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131345 */     // MIs[0] policy
     /* 2131345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131355 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2131358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131368 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131378 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131381 */     // GIR_Coverage, 17451,
     /* 2131381 */     GIR_EraseRootFromParent_Done,
     /* 2131382 */   // Label 28189: @2131382
     /* 2131382 */   GIM_Try, /*On fail goto*//*Label 28190*/ GIMT_Encode4(2131473), // Rule ID 17454 //
     /* 2131387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2131390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2131398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2131401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2131404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131433 */     // MIs[0] round
     /* 2131433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131436 */     // MIs[0] policy
     /* 2131436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131446 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2131449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131472 */     // GIR_Coverage, 17454,
     /* 2131472 */     GIR_EraseRootFromParent_Done,
     /* 2131473 */   // Label 28190: @2131473
     /* 2131473 */   GIM_Try, /*On fail goto*//*Label 28191*/ GIMT_Encode4(2131564), // Rule ID 17455 //
     /* 2131478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2131481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2131489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2131492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2131495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131501 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131524 */     // MIs[0] round
     /* 2131524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131527 */     // MIs[0] policy
     /* 2131527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131537 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2131540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131550 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131560 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131563 */     // GIR_Coverage, 17455,
     /* 2131563 */     GIR_EraseRootFromParent_Done,
     /* 2131564 */   // Label 28191: @2131564
     /* 2131564 */   GIM_Try, /*On fail goto*//*Label 28192*/ GIMT_Encode4(2131655), // Rule ID 17458 //
     /* 2131569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2131572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2131580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2131583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2131586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131615 */     // MIs[0] round
     /* 2131615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131618 */     // MIs[0] policy
     /* 2131618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131628 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2131631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131641 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131651 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131654 */     // GIR_Coverage, 17458,
     /* 2131654 */     GIR_EraseRootFromParent_Done,
     /* 2131655 */   // Label 28192: @2131655
     /* 2131655 */   GIM_Try, /*On fail goto*//*Label 28193*/ GIMT_Encode4(2131746), // Rule ID 17459 //
     /* 2131660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2131663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2131671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2131674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2131677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131683 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131706 */     // MIs[0] round
     /* 2131706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131709 */     // MIs[0] policy
     /* 2131709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131719 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2131722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131745 */     // GIR_Coverage, 17459,
     /* 2131745 */     GIR_EraseRootFromParent_Done,
     /* 2131746 */   // Label 28193: @2131746
     /* 2131746 */   GIM_Try, /*On fail goto*//*Label 28194*/ GIMT_Encode4(2131837), // Rule ID 17462 //
     /* 2131751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2131754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2131762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2131765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2131768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131797 */     // MIs[0] round
     /* 2131797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131800 */     // MIs[0] policy
     /* 2131800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131810 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2131813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131836 */     // GIR_Coverage, 17462,
     /* 2131836 */     GIR_EraseRootFromParent_Done,
     /* 2131837 */   // Label 28194: @2131837
     /* 2131837 */   GIM_Try, /*On fail goto*//*Label 28195*/ GIMT_Encode4(2131928), // Rule ID 17463 //
     /* 2131842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2131845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2131853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2131856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2131859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131865 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131888 */     // MIs[0] round
     /* 2131888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131891 */     // MIs[0] policy
     /* 2131891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131901 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2131904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131914 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131924 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131927 */     // GIR_Coverage, 17463,
     /* 2131927 */     GIR_EraseRootFromParent_Done,
     /* 2131928 */   // Label 28195: @2131928
     /* 2131928 */   GIM_Try, /*On fail goto*//*Label 28196*/ GIMT_Encode4(2132019), // Rule ID 17466 //
     /* 2131933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2131936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2131944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2131947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2131950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131979 */     // MIs[0] round
     /* 2131979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131982 */     // MIs[0] policy
     /* 2131982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131992 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2131995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132018 */     // GIR_Coverage, 17466,
     /* 2132018 */     GIR_EraseRootFromParent_Done,
     /* 2132019 */   // Label 28196: @2132019
     /* 2132019 */   GIM_Try, /*On fail goto*//*Label 28197*/ GIMT_Encode4(2132110), // Rule ID 17467 //
     /* 2132024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2132027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2132035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2132038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2132041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132070 */     // MIs[0] round
     /* 2132070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132073 */     // MIs[0] policy
     /* 2132073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132083 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2132086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132109 */     // GIR_Coverage, 17467,
     /* 2132109 */     GIR_EraseRootFromParent_Done,
     /* 2132110 */   // Label 28197: @2132110
     /* 2132110 */   GIM_Try, /*On fail goto*//*Label 28198*/ GIMT_Encode4(2132201), // Rule ID 17470 //
     /* 2132115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2132118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2132126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2132135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132161 */     // MIs[0] round
     /* 2132161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132164 */     // MIs[0] policy
     /* 2132164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132174 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2132177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132197 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132200 */     // GIR_Coverage, 17470,
     /* 2132200 */     GIR_EraseRootFromParent_Done,
     /* 2132201 */   // Label 28198: @2132201
     /* 2132201 */   GIM_Try, /*On fail goto*//*Label 28199*/ GIMT_Encode4(2132292), // Rule ID 17471 //
     /* 2132206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2132209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2132217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2132226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132252 */     // MIs[0] round
     /* 2132252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132255 */     // MIs[0] policy
     /* 2132255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132265 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2132268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132278 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132288 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132291 */     // GIR_Coverage, 17471,
     /* 2132291 */     GIR_EraseRootFromParent_Done,
     /* 2132292 */   // Label 28199: @2132292
     /* 2132292 */   GIM_Try, /*On fail goto*//*Label 28200*/ GIMT_Encode4(2132383), // Rule ID 17474 //
     /* 2132297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2132308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2132311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2132314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132343 */     // MIs[0] round
     /* 2132343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132346 */     // MIs[0] policy
     /* 2132346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132356 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2132359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132382 */     // GIR_Coverage, 17474,
     /* 2132382 */     GIR_EraseRootFromParent_Done,
     /* 2132383 */   // Label 28200: @2132383
     /* 2132383 */   GIM_Try, /*On fail goto*//*Label 28201*/ GIMT_Encode4(2132474), // Rule ID 17475 //
     /* 2132388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2132399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2132402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2132405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132411 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132434 */     // MIs[0] round
     /* 2132434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132437 */     // MIs[0] policy
     /* 2132437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132447 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2132450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132460 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132470 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132473 */     // GIR_Coverage, 17475,
     /* 2132473 */     GIR_EraseRootFromParent_Done,
     /* 2132474 */   // Label 28201: @2132474
     /* 2132474 */   GIM_Try, /*On fail goto*//*Label 28202*/ GIMT_Encode4(2132565), // Rule ID 17478 //
     /* 2132479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2132490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2132493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2132496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2132502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2132509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132525 */     // MIs[0] round
     /* 2132525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132528 */     // MIs[0] policy
     /* 2132528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132538 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2132541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132564 */     // GIR_Coverage, 17478,
     /* 2132564 */     GIR_EraseRootFromParent_Done,
     /* 2132565 */   // Label 28202: @2132565
     /* 2132565 */   GIM_Try, /*On fail goto*//*Label 28203*/ GIMT_Encode4(2132656), // Rule ID 17479 //
     /* 2132570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2132581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2132584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2132587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2132593 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2132600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132616 */     // MIs[0] round
     /* 2132616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132619 */     // MIs[0] policy
     /* 2132619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132629 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2132632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132652 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132655 */     // GIR_Coverage, 17479,
     /* 2132655 */     GIR_EraseRootFromParent_Done,
     /* 2132656 */   // Label 28203: @2132656
     /* 2132656 */   GIM_Try, /*On fail goto*//*Label 28204*/ GIMT_Encode4(2132747), // Rule ID 17482 //
     /* 2132661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2132672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2132675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2132678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2132684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2132691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132707 */     // MIs[0] round
     /* 2132707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132710 */     // MIs[0] policy
     /* 2132710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132720 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2132723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132746 */     // GIR_Coverage, 17482,
     /* 2132746 */     GIR_EraseRootFromParent_Done,
     /* 2132747 */   // Label 28204: @2132747
     /* 2132747 */   GIM_Try, /*On fail goto*//*Label 28205*/ GIMT_Encode4(2132838), // Rule ID 17483 //
     /* 2132752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2132763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2132766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2132769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2132775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2132782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132798 */     // MIs[0] round
     /* 2132798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132801 */     // MIs[0] policy
     /* 2132801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132811 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2132814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132837 */     // GIR_Coverage, 17483,
     /* 2132837 */     GIR_EraseRootFromParent_Done,
     /* 2132838 */   // Label 28205: @2132838
     /* 2132838 */   GIM_Try, /*On fail goto*//*Label 28206*/ GIMT_Encode4(2132929), // Rule ID 17486 //
     /* 2132843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2132846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2132854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2132857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2132860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132889 */     // MIs[0] round
     /* 2132889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132892 */     // MIs[0] policy
     /* 2132892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132902 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2132905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132928 */     // GIR_Coverage, 17486,
     /* 2132928 */     GIR_EraseRootFromParent_Done,
     /* 2132929 */   // Label 28206: @2132929
     /* 2132929 */   GIM_Try, /*On fail goto*//*Label 28207*/ GIMT_Encode4(2133020), // Rule ID 17487 //
     /* 2132934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2132937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2132945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2132948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2132951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132980 */     // MIs[0] round
     /* 2132980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132983 */     // MIs[0] policy
     /* 2132983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132993 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2132996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133019 */     // GIR_Coverage, 17487,
     /* 2133019 */     GIR_EraseRootFromParent_Done,
     /* 2133020 */   // Label 28207: @2133020
     /* 2133020 */   GIM_Try, /*On fail goto*//*Label 28208*/ GIMT_Encode4(2133111), // Rule ID 17490 //
     /* 2133025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2133028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2133036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2133039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2133042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133071 */     // MIs[0] round
     /* 2133071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133074 */     // MIs[0] policy
     /* 2133074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133084 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2133087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133110 */     // GIR_Coverage, 17490,
     /* 2133110 */     GIR_EraseRootFromParent_Done,
     /* 2133111 */   // Label 28208: @2133111
     /* 2133111 */   GIM_Try, /*On fail goto*//*Label 28209*/ GIMT_Encode4(2133202), // Rule ID 17491 //
     /* 2133116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2133119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2133127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2133130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2133133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133139 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133162 */     // MIs[0] round
     /* 2133162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133165 */     // MIs[0] policy
     /* 2133165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133175 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2133178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133201 */     // GIR_Coverage, 17491,
     /* 2133201 */     GIR_EraseRootFromParent_Done,
     /* 2133202 */   // Label 28209: @2133202
     /* 2133202 */   GIM_Try, /*On fail goto*//*Label 28210*/ GIMT_Encode4(2133293), // Rule ID 17494 //
     /* 2133207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2133210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2133218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2133221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2133224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133253 */     // MIs[0] round
     /* 2133253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133256 */     // MIs[0] policy
     /* 2133256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133266 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2133269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133292 */     // GIR_Coverage, 17494,
     /* 2133292 */     GIR_EraseRootFromParent_Done,
     /* 2133293 */   // Label 28210: @2133293
     /* 2133293 */   GIM_Try, /*On fail goto*//*Label 28211*/ GIMT_Encode4(2133384), // Rule ID 17495 //
     /* 2133298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2133301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2133309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2133312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2133315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133321 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133344 */     // MIs[0] round
     /* 2133344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133347 */     // MIs[0] policy
     /* 2133347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133357 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2133360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133383 */     // GIR_Coverage, 17495,
     /* 2133383 */     GIR_EraseRootFromParent_Done,
     /* 2133384 */   // Label 28211: @2133384
     /* 2133384 */   GIM_Try, /*On fail goto*//*Label 28212*/ GIMT_Encode4(2133475), // Rule ID 17498 //
     /* 2133389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2133392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2133400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2133403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2133406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133435 */     // MIs[0] round
     /* 2133435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133438 */     // MIs[0] policy
     /* 2133438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133448 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2133451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133461 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133471 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133474 */     // GIR_Coverage, 17498,
     /* 2133474 */     GIR_EraseRootFromParent_Done,
     /* 2133475 */   // Label 28212: @2133475
     /* 2133475 */   GIM_Try, /*On fail goto*//*Label 28213*/ GIMT_Encode4(2133566), // Rule ID 17499 //
     /* 2133480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2133483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2133491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2133494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2133497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133526 */     // MIs[0] round
     /* 2133526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133529 */     // MIs[0] policy
     /* 2133529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133539 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2133542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133552 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133562 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133565 */     // GIR_Coverage, 17499,
     /* 2133565 */     GIR_EraseRootFromParent_Done,
     /* 2133566 */   // Label 28213: @2133566
     /* 2133566 */   GIM_Try, /*On fail goto*//*Label 28214*/ GIMT_Encode4(2133657), // Rule ID 17502 //
     /* 2133571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2133574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2133582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2133585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2133588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2133594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133617 */     // MIs[0] round
     /* 2133617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133620 */     // MIs[0] policy
     /* 2133620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133630 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2133633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133656 */     // GIR_Coverage, 17502,
     /* 2133656 */     GIR_EraseRootFromParent_Done,
     /* 2133657 */   // Label 28214: @2133657
     /* 2133657 */   GIM_Try, /*On fail goto*//*Label 28215*/ GIMT_Encode4(2133748), // Rule ID 17503 //
     /* 2133662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2133665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2133673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2133676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2133679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2133685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133708 */     // MIs[0] round
     /* 2133708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133711 */     // MIs[0] policy
     /* 2133711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133721 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2133724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133747 */     // GIR_Coverage, 17503,
     /* 2133747 */     GIR_EraseRootFromParent_Done,
     /* 2133748 */   // Label 28215: @2133748
     /* 2133748 */   GIM_Try, /*On fail goto*//*Label 28216*/ GIMT_Encode4(2133839), // Rule ID 17506 //
     /* 2133753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2133756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2133764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2133767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2133770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133799 */     // MIs[0] round
     /* 2133799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133802 */     // MIs[0] policy
     /* 2133802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133812 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2133815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133838 */     // GIR_Coverage, 17506,
     /* 2133838 */     GIR_EraseRootFromParent_Done,
     /* 2133839 */   // Label 28216: @2133839
     /* 2133839 */   GIM_Try, /*On fail goto*//*Label 28217*/ GIMT_Encode4(2133930), // Rule ID 17507 //
     /* 2133844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2133847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2133855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2133858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2133861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133890 */     // MIs[0] round
     /* 2133890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133893 */     // MIs[0] policy
     /* 2133893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133903 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2133906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133926 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133929 */     // GIR_Coverage, 17507,
     /* 2133929 */     GIR_EraseRootFromParent_Done,
     /* 2133930 */   // Label 28217: @2133930
     /* 2133930 */   GIM_Try, /*On fail goto*//*Label 28218*/ GIMT_Encode4(2134021), // Rule ID 17510 //
     /* 2133935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2133938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2133943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2133946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2133949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2133952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2133955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2133958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133981 */     // MIs[0] round
     /* 2133981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133984 */     // MIs[0] policy
     /* 2133984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133994 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2133997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134020 */     // GIR_Coverage, 17510,
     /* 2134020 */     GIR_EraseRootFromParent_Done,
     /* 2134021 */   // Label 28218: @2134021
     /* 2134021 */   GIM_Try, /*On fail goto*//*Label 28219*/ GIMT_Encode4(2134112), // Rule ID 17511 //
     /* 2134026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2134029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2134037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2134040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2134043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2134046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134072 */     // MIs[0] round
     /* 2134072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134075 */     // MIs[0] policy
     /* 2134075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134085 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2134088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134111 */     // GIR_Coverage, 17511,
     /* 2134111 */     GIR_EraseRootFromParent_Done,
     /* 2134112 */   // Label 28219: @2134112
     /* 2134112 */   GIM_Try, /*On fail goto*//*Label 28220*/ GIMT_Encode4(2134203), // Rule ID 17514 //
     /* 2134117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2134120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2134128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2134131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2134134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2134137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134163 */     // MIs[0] round
     /* 2134163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134166 */     // MIs[0] policy
     /* 2134166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134176 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2134179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134202 */     // GIR_Coverage, 17514,
     /* 2134202 */     GIR_EraseRootFromParent_Done,
     /* 2134203 */   // Label 28220: @2134203
     /* 2134203 */   GIM_Try, /*On fail goto*//*Label 28221*/ GIMT_Encode4(2134294), // Rule ID 17515 //
     /* 2134208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2134211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2134219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2134222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2134225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2134228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134254 */     // MIs[0] round
     /* 2134254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134257 */     // MIs[0] policy
     /* 2134257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134267 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2134270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134293 */     // GIR_Coverage, 17515,
     /* 2134293 */     GIR_EraseRootFromParent_Done,
     /* 2134294 */   // Label 28221: @2134294
     /* 2134294 */   GIM_Try, /*On fail goto*//*Label 28222*/ GIMT_Encode4(2134385), // Rule ID 17518 //
     /* 2134299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2134302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2134310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2134319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134345 */     // MIs[0] round
     /* 2134345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134348 */     // MIs[0] policy
     /* 2134348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134358 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2134361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134381 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134384 */     // GIR_Coverage, 17518,
     /* 2134384 */     GIR_EraseRootFromParent_Done,
     /* 2134385 */   // Label 28222: @2134385
     /* 2134385 */   GIM_Try, /*On fail goto*//*Label 28223*/ GIMT_Encode4(2134476), // Rule ID 17519 //
     /* 2134390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2134401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2134410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134436 */     // MIs[0] round
     /* 2134436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134439 */     // MIs[0] policy
     /* 2134439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134449 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2134452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134475 */     // GIR_Coverage, 17519,
     /* 2134475 */     GIR_EraseRootFromParent_Done,
     /* 2134476 */   // Label 28223: @2134476
     /* 2134476 */   GIM_Try, /*On fail goto*//*Label 28224*/ GIMT_Encode4(2134567), // Rule ID 17522 //
     /* 2134481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2134484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2134492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2134495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2134498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2134501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134527 */     // MIs[0] round
     /* 2134527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134530 */     // MIs[0] policy
     /* 2134530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134540 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2134543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134566 */     // GIR_Coverage, 17522,
     /* 2134566 */     GIR_EraseRootFromParent_Done,
     /* 2134567 */   // Label 28224: @2134567
     /* 2134567 */   GIM_Try, /*On fail goto*//*Label 28225*/ GIMT_Encode4(2134658), // Rule ID 17523 //
     /* 2134572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2134575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2134583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2134586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2134589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2134592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134618 */     // MIs[0] round
     /* 2134618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134621 */     // MIs[0] policy
     /* 2134621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134631 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2134634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134644 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134654 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134657 */     // GIR_Coverage, 17523,
     /* 2134657 */     GIR_EraseRootFromParent_Done,
     /* 2134658 */   // Label 28225: @2134658
     /* 2134658 */   GIM_Try, /*On fail goto*//*Label 28226*/ GIMT_Encode4(2134749), // Rule ID 17526 //
     /* 2134663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2134666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2134674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2134677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2134680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2134683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134709 */     // MIs[0] round
     /* 2134709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134712 */     // MIs[0] policy
     /* 2134712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134722 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2134725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134748 */     // GIR_Coverage, 17526,
     /* 2134748 */     GIR_EraseRootFromParent_Done,
     /* 2134749 */   // Label 28226: @2134749
     /* 2134749 */   GIM_Try, /*On fail goto*//*Label 28227*/ GIMT_Encode4(2134840), // Rule ID 17527 //
     /* 2134754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2134765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2134768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2134771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2134774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134800 */     // MIs[0] round
     /* 2134800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134803 */     // MIs[0] policy
     /* 2134803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134813 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2134816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134839 */     // GIR_Coverage, 17527,
     /* 2134839 */     GIR_EraseRootFromParent_Done,
     /* 2134840 */   // Label 28227: @2134840
     /* 2134840 */   GIM_Try, /*On fail goto*//*Label 28228*/ GIMT_Encode4(2134931), // Rule ID 17530 //
     /* 2134845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2134848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2134856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2134859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2134862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2134865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134891 */     // MIs[0] round
     /* 2134891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134894 */     // MIs[0] policy
     /* 2134894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134904 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2134907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134930 */     // GIR_Coverage, 17530,
     /* 2134930 */     GIR_EraseRootFromParent_Done,
     /* 2134931 */   // Label 28228: @2134931
     /* 2134931 */   GIM_Try, /*On fail goto*//*Label 28229*/ GIMT_Encode4(2135022), // Rule ID 17531 //
     /* 2134936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2134939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2134947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2134950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2134953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2134956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134959 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134982 */     // MIs[0] round
     /* 2134982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134985 */     // MIs[0] policy
     /* 2134985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134995 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2134998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135008 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135018 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135021 */     // GIR_Coverage, 17531,
     /* 2135021 */     GIR_EraseRootFromParent_Done,
     /* 2135022 */   // Label 28229: @2135022
     /* 2135022 */   GIM_Try, /*On fail goto*//*Label 28230*/ GIMT_Encode4(2135113), // Rule ID 17534 //
     /* 2135027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2135038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2135041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2135044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2135047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135073 */     // MIs[0] round
     /* 2135073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135076 */     // MIs[0] policy
     /* 2135076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135086 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2135089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135112 */     // GIR_Coverage, 17534,
     /* 2135112 */     GIR_EraseRootFromParent_Done,
     /* 2135113 */   // Label 28230: @2135113
     /* 2135113 */   GIM_Try, /*On fail goto*//*Label 28231*/ GIMT_Encode4(2135204), // Rule ID 17535 //
     /* 2135118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2135129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2135132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2135135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2135138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135164 */     // MIs[0] round
     /* 2135164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135167 */     // MIs[0] policy
     /* 2135167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135177 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2135180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135203 */     // GIR_Coverage, 17535,
     /* 2135203 */     GIR_EraseRootFromParent_Done,
     /* 2135204 */   // Label 28231: @2135204
     /* 2135204 */   GIM_Try, /*On fail goto*//*Label 28232*/ GIMT_Encode4(2135295), // Rule ID 17538 //
     /* 2135209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2135220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2135223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2135226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2135229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2135232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135255 */     // MIs[0] round
     /* 2135255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135258 */     // MIs[0] policy
     /* 2135258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135268 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2135271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135294 */     // GIR_Coverage, 17538,
     /* 2135294 */     GIR_EraseRootFromParent_Done,
     /* 2135295 */   // Label 28232: @2135295
     /* 2135295 */   GIM_Try, /*On fail goto*//*Label 28233*/ GIMT_Encode4(2135386), // Rule ID 17539 //
     /* 2135300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2135311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2135314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2135317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2135320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2135323 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135346 */     // MIs[0] round
     /* 2135346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135349 */     // MIs[0] policy
     /* 2135349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135359 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2135362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135372 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135382 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135385 */     // GIR_Coverage, 17539,
     /* 2135385 */     GIR_EraseRootFromParent_Done,
     /* 2135386 */   // Label 28233: @2135386
     /* 2135386 */   GIM_Try, /*On fail goto*//*Label 28234*/ GIMT_Encode4(2135477), // Rule ID 17542 //
     /* 2135391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2135402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2135405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2135408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2135411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2135414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135437 */     // MIs[0] round
     /* 2135437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135440 */     // MIs[0] policy
     /* 2135440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135450 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2135453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135476 */     // GIR_Coverage, 17542,
     /* 2135476 */     GIR_EraseRootFromParent_Done,
     /* 2135477 */   // Label 28234: @2135477
     /* 2135477 */   GIM_Try, /*On fail goto*//*Label 28235*/ GIMT_Encode4(2135568), // Rule ID 17543 //
     /* 2135482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2135493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2135496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2135499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2135502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2135505 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135528 */     // MIs[0] round
     /* 2135528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135531 */     // MIs[0] policy
     /* 2135531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135541 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2135544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135554 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135564 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135567 */     // GIR_Coverage, 17543,
     /* 2135567 */     GIR_EraseRootFromParent_Done,
     /* 2135568 */   // Label 28235: @2135568
     /* 2135568 */   GIM_Try, /*On fail goto*//*Label 28236*/ GIMT_Encode4(2135659), // Rule ID 17546 //
     /* 2135573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2135576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2135584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2135587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2135590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2135593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2135596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135619 */     // MIs[0] round
     /* 2135619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135622 */     // MIs[0] policy
     /* 2135622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135632 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2135635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135658 */     // GIR_Coverage, 17546,
     /* 2135658 */     GIR_EraseRootFromParent_Done,
     /* 2135659 */   // Label 28236: @2135659
     /* 2135659 */   GIM_Try, /*On fail goto*//*Label 28237*/ GIMT_Encode4(2135750), // Rule ID 17547 //
     /* 2135664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2135667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2135675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2135678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2135681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2135684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2135687 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135710 */     // MIs[0] round
     /* 2135710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135713 */     // MIs[0] policy
     /* 2135713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135723 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2135726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135736 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135746 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135749 */     // GIR_Coverage, 17547,
     /* 2135749 */     GIR_EraseRootFromParent_Done,
     /* 2135750 */   // Label 28237: @2135750
     /* 2135750 */   GIM_Try, /*On fail goto*//*Label 28238*/ GIMT_Encode4(2135841), // Rule ID 17550 //
     /* 2135755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2135758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2135766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2135769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2135772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2135775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135801 */     // MIs[0] round
     /* 2135801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135804 */     // MIs[0] policy
     /* 2135804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135814 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2135817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135837 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135840 */     // GIR_Coverage, 17550,
     /* 2135840 */     GIR_EraseRootFromParent_Done,
     /* 2135841 */   // Label 28238: @2135841
     /* 2135841 */   GIM_Try, /*On fail goto*//*Label 28239*/ GIMT_Encode4(2135932), // Rule ID 17551 //
     /* 2135846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2135849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2135857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2135860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2135863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2135866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135869 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135892 */     // MIs[0] round
     /* 2135892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135895 */     // MIs[0] policy
     /* 2135895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135905 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2135908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135931 */     // GIR_Coverage, 17551,
     /* 2135931 */     GIR_EraseRootFromParent_Done,
     /* 2135932 */   // Label 28239: @2135932
     /* 2135932 */   GIM_Try, /*On fail goto*//*Label 28240*/ GIMT_Encode4(2136023), // Rule ID 17554 //
     /* 2135937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2135940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2135948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2135951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2135954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2135957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2135960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135983 */     // MIs[0] round
     /* 2135983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135986 */     // MIs[0] policy
     /* 2135986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135996 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2135999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136022 */     // GIR_Coverage, 17554,
     /* 2136022 */     GIR_EraseRootFromParent_Done,
     /* 2136023 */   // Label 28240: @2136023
     /* 2136023 */   GIM_Try, /*On fail goto*//*Label 28241*/ GIMT_Encode4(2136114), // Rule ID 17555 //
     /* 2136028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2136031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2136039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2136042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2136045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2136048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2136051 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136074 */     // MIs[0] round
     /* 2136074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136077 */     // MIs[0] policy
     /* 2136077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136087 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2136090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136100 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136110 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136113 */     // GIR_Coverage, 17555,
     /* 2136113 */     GIR_EraseRootFromParent_Done,
     /* 2136114 */   // Label 28241: @2136114
     /* 2136114 */   GIM_Try, /*On fail goto*//*Label 28242*/ GIMT_Encode4(2136205), // Rule ID 17558 //
     /* 2136119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2136130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2136139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136165 */     // MIs[0] round
     /* 2136165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136168 */     // MIs[0] policy
     /* 2136168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136178 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2136181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136204 */     // GIR_Coverage, 17558,
     /* 2136204 */     GIR_EraseRootFromParent_Done,
     /* 2136205 */   // Label 28242: @2136205
     /* 2136205 */   GIM_Try, /*On fail goto*//*Label 28243*/ GIMT_Encode4(2136296), // Rule ID 17559 //
     /* 2136210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2136221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2136230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136233 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136256 */     // MIs[0] round
     /* 2136256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136259 */     // MIs[0] policy
     /* 2136259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136269 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2136272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136282 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136292 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136295 */     // GIR_Coverage, 17559,
     /* 2136295 */     GIR_EraseRootFromParent_Done,
     /* 2136296 */   // Label 28243: @2136296
     /* 2136296 */   GIM_Try, /*On fail goto*//*Label 28244*/ GIMT_Encode4(2136387), // Rule ID 17562 //
     /* 2136301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2136312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2136315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2136318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2136321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136347 */     // MIs[0] round
     /* 2136347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136350 */     // MIs[0] policy
     /* 2136350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136360 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2136363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136386 */     // GIR_Coverage, 17562,
     /* 2136386 */     GIR_EraseRootFromParent_Done,
     /* 2136387 */   // Label 28244: @2136387
     /* 2136387 */   GIM_Try, /*On fail goto*//*Label 28245*/ GIMT_Encode4(2136478), // Rule ID 17563 //
     /* 2136392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2136403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2136406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2136409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2136412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136438 */     // MIs[0] round
     /* 2136438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136441 */     // MIs[0] policy
     /* 2136441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136451 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2136454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136477 */     // GIR_Coverage, 17563,
     /* 2136477 */     GIR_EraseRootFromParent_Done,
     /* 2136478 */   // Label 28245: @2136478
     /* 2136478 */   GIM_Try, /*On fail goto*//*Label 28246*/ GIMT_Encode4(2136569), // Rule ID 17566 //
     /* 2136483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2136494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2136497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2136500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2136503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136529 */     // MIs[0] round
     /* 2136529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136532 */     // MIs[0] policy
     /* 2136532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136542 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2136545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136568 */     // GIR_Coverage, 17566,
     /* 2136568 */     GIR_EraseRootFromParent_Done,
     /* 2136569 */   // Label 28246: @2136569
     /* 2136569 */   GIM_Try, /*On fail goto*//*Label 28247*/ GIMT_Encode4(2136660), // Rule ID 17567 //
     /* 2136574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2136585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2136588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2136591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2136594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136620 */     // MIs[0] round
     /* 2136620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136623 */     // MIs[0] policy
     /* 2136623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136633 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2136636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136646 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136656 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136659 */     // GIR_Coverage, 17567,
     /* 2136659 */     GIR_EraseRootFromParent_Done,
     /* 2136660 */   // Label 28247: @2136660
     /* 2136660 */   GIM_Try, /*On fail goto*//*Label 28248*/ GIMT_Encode4(2136751), // Rule ID 17570 //
     /* 2136665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2136668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2136676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2136679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2136682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2136688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136711 */     // MIs[0] round
     /* 2136711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136714 */     // MIs[0] policy
     /* 2136714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136724 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2136727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136750 */     // GIR_Coverage, 17570,
     /* 2136750 */     GIR_EraseRootFromParent_Done,
     /* 2136751 */   // Label 28248: @2136751
     /* 2136751 */   GIM_Try, /*On fail goto*//*Label 28249*/ GIMT_Encode4(2136842), // Rule ID 17571 //
     /* 2136756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2136759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2136767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2136770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2136773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2136779 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136802 */     // MIs[0] round
     /* 2136802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136805 */     // MIs[0] policy
     /* 2136805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136815 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2136818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136841 */     // GIR_Coverage, 17571,
     /* 2136841 */     GIR_EraseRootFromParent_Done,
     /* 2136842 */   // Label 28249: @2136842
     /* 2136842 */   GIM_Try, /*On fail goto*//*Label 28250*/ GIMT_Encode4(2136933), // Rule ID 17574 //
     /* 2136847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2136850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2136858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2136861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2136864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136893 */     // MIs[0] round
     /* 2136893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136896 */     // MIs[0] policy
     /* 2136896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136906 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2136909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136932 */     // GIR_Coverage, 17574,
     /* 2136932 */     GIR_EraseRootFromParent_Done,
     /* 2136933 */   // Label 28250: @2136933
     /* 2136933 */   GIM_Try, /*On fail goto*//*Label 28251*/ GIMT_Encode4(2137024), // Rule ID 17575 //
     /* 2136938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2136941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2136949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2136952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2136955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136961 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136984 */     // MIs[0] round
     /* 2136984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136987 */     // MIs[0] policy
     /* 2136987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136997 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2137000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137023 */     // GIR_Coverage, 17575,
     /* 2137023 */     GIR_EraseRootFromParent_Done,
     /* 2137024 */   // Label 28251: @2137024
     /* 2137024 */   GIM_Try, /*On fail goto*//*Label 28252*/ GIMT_Encode4(2137115), // Rule ID 17578 //
     /* 2137029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2137032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2137040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2137043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2137046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137075 */     // MIs[0] round
     /* 2137075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137078 */     // MIs[0] policy
     /* 2137078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137088 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2137091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137114 */     // GIR_Coverage, 17578,
     /* 2137114 */     GIR_EraseRootFromParent_Done,
     /* 2137115 */   // Label 28252: @2137115
     /* 2137115 */   GIM_Try, /*On fail goto*//*Label 28253*/ GIMT_Encode4(2137206), // Rule ID 17579 //
     /* 2137120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2137123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2137131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2137134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2137137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137143 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137166 */     // MIs[0] round
     /* 2137166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137169 */     // MIs[0] policy
     /* 2137169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137179 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2137182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137202 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137205 */     // GIR_Coverage, 17579,
     /* 2137205 */     GIR_EraseRootFromParent_Done,
     /* 2137206 */   // Label 28253: @2137206
     /* 2137206 */   GIM_Try, /*On fail goto*//*Label 28254*/ GIMT_Encode4(2137297), // Rule ID 17582 //
     /* 2137211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2137222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2137225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2137228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137257 */     // MIs[0] round
     /* 2137257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137260 */     // MIs[0] policy
     /* 2137260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137270 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2137273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137296 */     // GIR_Coverage, 17582,
     /* 2137296 */     GIR_EraseRootFromParent_Done,
     /* 2137297 */   // Label 28254: @2137297
     /* 2137297 */   GIM_Try, /*On fail goto*//*Label 28255*/ GIMT_Encode4(2137388), // Rule ID 17583 //
     /* 2137302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2137305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2137313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2137316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2137319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137348 */     // MIs[0] round
     /* 2137348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137351 */     // MIs[0] policy
     /* 2137351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137361 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2137364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137387 */     // GIR_Coverage, 17583,
     /* 2137387 */     GIR_EraseRootFromParent_Done,
     /* 2137388 */   // Label 28255: @2137388
     /* 2137388 */   GIM_Try, /*On fail goto*//*Label 28256*/ GIMT_Encode4(2137479), // Rule ID 17586 //
     /* 2137393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2137396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2137404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2137410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137439 */     // MIs[0] round
     /* 2137439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137442 */     // MIs[0] policy
     /* 2137442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137452 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2137455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137478 */     // GIR_Coverage, 17586,
     /* 2137478 */     GIR_EraseRootFromParent_Done,
     /* 2137479 */   // Label 28256: @2137479
     /* 2137479 */   GIM_Try, /*On fail goto*//*Label 28257*/ GIMT_Encode4(2137570), // Rule ID 17587 //
     /* 2137484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2137487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2137495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2137501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137530 */     // MIs[0] round
     /* 2137530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137533 */     // MIs[0] policy
     /* 2137533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137543 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2137546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137566 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137569 */     // GIR_Coverage, 17587,
     /* 2137569 */     GIR_EraseRootFromParent_Done,
     /* 2137570 */   // Label 28257: @2137570
     /* 2137570 */   GIM_Try, /*On fail goto*//*Label 28258*/ GIMT_Encode4(2137661), // Rule ID 17590 //
     /* 2137575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2137578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2137586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2137589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2137592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2137595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2137617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137621 */     // MIs[0] round
     /* 2137621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137624 */     // MIs[0] policy
     /* 2137624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137634 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2137637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137660 */     // GIR_Coverage, 17590,
     /* 2137660 */     GIR_EraseRootFromParent_Done,
     /* 2137661 */   // Label 28258: @2137661
     /* 2137661 */   GIM_Try, /*On fail goto*//*Label 28259*/ GIMT_Encode4(2137752), // Rule ID 17591 //
     /* 2137666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2137669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2137677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2137680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2137683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2137686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2137708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137712 */     // MIs[0] round
     /* 2137712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137715 */     // MIs[0] policy
     /* 2137715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137725 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2137728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137751 */     // GIR_Coverage, 17591,
     /* 2137751 */     GIR_EraseRootFromParent_Done,
     /* 2137752 */   // Label 28259: @2137752
     /* 2137752 */   GIM_Try, /*On fail goto*//*Label 28260*/ GIMT_Encode4(2137843), // Rule ID 17594 //
     /* 2137757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2137768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2137771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2137774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2137780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2137787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137803 */     // MIs[0] round
     /* 2137803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137806 */     // MIs[0] policy
     /* 2137806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137816 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2137819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137842 */     // GIR_Coverage, 17594,
     /* 2137842 */     GIR_EraseRootFromParent_Done,
     /* 2137843 */   // Label 28260: @2137843
     /* 2137843 */   GIM_Try, /*On fail goto*//*Label 28261*/ GIMT_Encode4(2137934), // Rule ID 17595 //
     /* 2137848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2137851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2137859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2137862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2137865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2137871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2137878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137894 */     // MIs[0] round
     /* 2137894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137897 */     // MIs[0] policy
     /* 2137897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137907 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2137910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137933 */     // GIR_Coverage, 17595,
     /* 2137933 */     GIR_EraseRootFromParent_Done,
     /* 2137934 */   // Label 28261: @2137934
     /* 2137934 */   GIM_Try, /*On fail goto*//*Label 28262*/ GIMT_Encode4(2138025), // Rule ID 17598 //
     /* 2137939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2137950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2137953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2137956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2137962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2137969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2137973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2137977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137985 */     // MIs[0] round
     /* 2137985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137988 */     // MIs[0] policy
     /* 2137988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137998 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2138001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138024 */     // GIR_Coverage, 17598,
     /* 2138024 */     GIR_EraseRootFromParent_Done,
     /* 2138025 */   // Label 28262: @2138025
     /* 2138025 */   GIM_Try, /*On fail goto*//*Label 28263*/ GIMT_Encode4(2138116), // Rule ID 17599 //
     /* 2138030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2138041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2138044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2138047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138076 */     // MIs[0] round
     /* 2138076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138079 */     // MIs[0] policy
     /* 2138079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138089 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2138092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138115 */     // GIR_Coverage, 17599,
     /* 2138115 */     GIR_EraseRootFromParent_Done,
     /* 2138116 */   // Label 28263: @2138116
     /* 2138116 */   GIM_Try, /*On fail goto*//*Label 28264*/ GIMT_Encode4(2138207), // Rule ID 17602 //
     /* 2138121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2138124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2138132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2138135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2138138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2138144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138167 */     // MIs[0] round
     /* 2138167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138170 */     // MIs[0] policy
     /* 2138170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138180 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2138183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138206 */     // GIR_Coverage, 17602,
     /* 2138206 */     GIR_EraseRootFromParent_Done,
     /* 2138207 */   // Label 28264: @2138207
     /* 2138207 */   GIM_Try, /*On fail goto*//*Label 28265*/ GIMT_Encode4(2138298), // Rule ID 17603 //
     /* 2138212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2138223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2138226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2138229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2138235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138258 */     // MIs[0] round
     /* 2138258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138261 */     // MIs[0] policy
     /* 2138261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138271 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2138274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138297 */     // GIR_Coverage, 17603,
     /* 2138297 */     GIR_EraseRootFromParent_Done,
     /* 2138298 */   // Label 28265: @2138298
     /* 2138298 */   GIM_Try, /*On fail goto*//*Label 28266*/ GIMT_Encode4(2138389), // Rule ID 17606 //
     /* 2138303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2138314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2138317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2138320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138349 */     // MIs[0] round
     /* 2138349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138352 */     // MIs[0] policy
     /* 2138352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138362 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2138365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138388 */     // GIR_Coverage, 17606,
     /* 2138388 */     GIR_EraseRootFromParent_Done,
     /* 2138389 */   // Label 28266: @2138389
     /* 2138389 */   GIM_Try, /*On fail goto*//*Label 28267*/ GIMT_Encode4(2138480), // Rule ID 17607 //
     /* 2138394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2138405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2138408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2138411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138417 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138440 */     // MIs[0] round
     /* 2138440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138443 */     // MIs[0] policy
     /* 2138443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138453 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2138456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138479 */     // GIR_Coverage, 17607,
     /* 2138479 */     GIR_EraseRootFromParent_Done,
     /* 2138480 */   // Label 28267: @2138480
     /* 2138480 */   GIM_Try, /*On fail goto*//*Label 28268*/ GIMT_Encode4(2138571), // Rule ID 17610 //
     /* 2138485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2138496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2138499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2138502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138531 */     // MIs[0] round
     /* 2138531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138534 */     // MIs[0] policy
     /* 2138534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138544 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2138547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138570 */     // GIR_Coverage, 17610,
     /* 2138570 */     GIR_EraseRootFromParent_Done,
     /* 2138571 */   // Label 28268: @2138571
     /* 2138571 */   GIM_Try, /*On fail goto*//*Label 28269*/ GIMT_Encode4(2138662), // Rule ID 17611 //
     /* 2138576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2138587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2138590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2138593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138622 */     // MIs[0] round
     /* 2138622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138625 */     // MIs[0] policy
     /* 2138625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138635 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2138638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138661 */     // GIR_Coverage, 17611,
     /* 2138661 */     GIR_EraseRootFromParent_Done,
     /* 2138662 */   // Label 28269: @2138662
     /* 2138662 */   GIM_Try, /*On fail goto*//*Label 28270*/ GIMT_Encode4(2138753), // Rule ID 17614 //
     /* 2138667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2138678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2138681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2138684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138713 */     // MIs[0] round
     /* 2138713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138716 */     // MIs[0] policy
     /* 2138716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138726 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2138729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138752 */     // GIR_Coverage, 17614,
     /* 2138752 */     GIR_EraseRootFromParent_Done,
     /* 2138753 */   // Label 28270: @2138753
     /* 2138753 */   GIM_Try, /*On fail goto*//*Label 28271*/ GIMT_Encode4(2138844), // Rule ID 17615 //
     /* 2138758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2138769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2138772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2138775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138804 */     // MIs[0] round
     /* 2138804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138807 */     // MIs[0] policy
     /* 2138807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138817 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2138820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138843 */     // GIR_Coverage, 17615,
     /* 2138843 */     GIR_EraseRootFromParent_Done,
     /* 2138844 */   // Label 28271: @2138844
     /* 2138844 */   GIM_Try, /*On fail goto*//*Label 28272*/ GIMT_Encode4(2138935), // Rule ID 17618 //
     /* 2138849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2138852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2138860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2138863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2138866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2138869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2138872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2138891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138895 */     // MIs[0] round
     /* 2138895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138898 */     // MIs[0] policy
     /* 2138898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138908 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2138911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138934 */     // GIR_Coverage, 17618,
     /* 2138934 */     GIR_EraseRootFromParent_Done,
     /* 2138935 */   // Label 28272: @2138935
     /* 2138935 */   GIM_Try, /*On fail goto*//*Label 28273*/ GIMT_Encode4(2139026), // Rule ID 17619 //
     /* 2138940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2138943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2138951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2138954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2138957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2138960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2138963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2138982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138986 */     // MIs[0] round
     /* 2138986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138989 */     // MIs[0] policy
     /* 2138989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138999 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2139002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139025 */     // GIR_Coverage, 17619,
     /* 2139025 */     GIR_EraseRootFromParent_Done,
     /* 2139026 */   // Label 28273: @2139026
     /* 2139026 */   GIM_Try, /*On fail goto*//*Label 28274*/ GIMT_Encode4(2139117), // Rule ID 17622 //
     /* 2139031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2139042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2139045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2139048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139077 */     // MIs[0] round
     /* 2139077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139080 */     // MIs[0] policy
     /* 2139080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139090 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2139093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139116 */     // GIR_Coverage, 17622,
     /* 2139116 */     GIR_EraseRootFromParent_Done,
     /* 2139117 */   // Label 28274: @2139117
     /* 2139117 */   GIM_Try, /*On fail goto*//*Label 28275*/ GIMT_Encode4(2139208), // Rule ID 17623 //
     /* 2139122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2139125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2139133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2139136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2139139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139168 */     // MIs[0] round
     /* 2139168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139171 */     // MIs[0] policy
     /* 2139171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139181 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2139184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139207 */     // GIR_Coverage, 17623,
     /* 2139207 */     GIR_EraseRootFromParent_Done,
     /* 2139208 */   // Label 28275: @2139208
     /* 2139208 */   GIM_Try, /*On fail goto*//*Label 28276*/ GIMT_Encode4(2139299), // Rule ID 17626 //
     /* 2139213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2139224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2139227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2139230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139259 */     // MIs[0] round
     /* 2139259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139262 */     // MIs[0] policy
     /* 2139262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139272 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2139275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139298 */     // GIR_Coverage, 17626,
     /* 2139298 */     GIR_EraseRootFromParent_Done,
     /* 2139299 */   // Label 28276: @2139299
     /* 2139299 */   GIM_Try, /*On fail goto*//*Label 28277*/ GIMT_Encode4(2139390), // Rule ID 17627 //
     /* 2139304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2139307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2139315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2139318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2139321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139350 */     // MIs[0] round
     /* 2139350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139353 */     // MIs[0] policy
     /* 2139353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139363 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2139366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139389 */     // GIR_Coverage, 17627,
     /* 2139389 */     GIR_EraseRootFromParent_Done,
     /* 2139390 */   // Label 28277: @2139390
     /* 2139390 */   GIM_Try, /*On fail goto*//*Label 28278*/ GIMT_Encode4(2139481), // Rule ID 17630 //
     /* 2139395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2139406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2139409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2139412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139441 */     // MIs[0] round
     /* 2139441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139444 */     // MIs[0] policy
     /* 2139444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139454 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2139457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139480 */     // GIR_Coverage, 17630,
     /* 2139480 */     GIR_EraseRootFromParent_Done,
     /* 2139481 */   // Label 28278: @2139481
     /* 2139481 */   GIM_Try, /*On fail goto*//*Label 28279*/ GIMT_Encode4(2139572), // Rule ID 17631 //
     /* 2139486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2139489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2139497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2139500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2139503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139532 */     // MIs[0] round
     /* 2139532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139535 */     // MIs[0] policy
     /* 2139535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139545 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2139548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139571 */     // GIR_Coverage, 17631,
     /* 2139571 */     GIR_EraseRootFromParent_Done,
     /* 2139572 */   // Label 28279: @2139572
     /* 2139572 */   GIM_Try, /*On fail goto*//*Label 28280*/ GIMT_Encode4(2139663), // Rule ID 17634 //
     /* 2139577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2139588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2139591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2139594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139623 */     // MIs[0] round
     /* 2139623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139626 */     // MIs[0] policy
     /* 2139626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139636 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2139639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139662 */     // GIR_Coverage, 17634,
     /* 2139662 */     GIR_EraseRootFromParent_Done,
     /* 2139663 */   // Label 28280: @2139663
     /* 2139663 */   GIM_Try, /*On fail goto*//*Label 28281*/ GIMT_Encode4(2139754), // Rule ID 17635 //
     /* 2139668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2139671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2139679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2139682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2139685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139714 */     // MIs[0] round
     /* 2139714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139717 */     // MIs[0] policy
     /* 2139717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139727 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2139730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139753 */     // GIR_Coverage, 17635,
     /* 2139753 */     GIR_EraseRootFromParent_Done,
     /* 2139754 */   // Label 28281: @2139754
     /* 2139754 */   GIM_Try, /*On fail goto*//*Label 28282*/ GIMT_Encode4(2139845), // Rule ID 17638 //
     /* 2139759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2139762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2139770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2139773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2139776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2139779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2139801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139805 */     // MIs[0] round
     /* 2139805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139808 */     // MIs[0] policy
     /* 2139808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139818 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2139821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139844 */     // GIR_Coverage, 17638,
     /* 2139844 */     GIR_EraseRootFromParent_Done,
     /* 2139845 */   // Label 28282: @2139845
     /* 2139845 */   GIM_Try, /*On fail goto*//*Label 28283*/ GIMT_Encode4(2139936), // Rule ID 17639 //
     /* 2139850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2139853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2139861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2139864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2139867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2139870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2139892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139896 */     // MIs[0] round
     /* 2139896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139899 */     // MIs[0] policy
     /* 2139899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139909 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2139912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139935 */     // GIR_Coverage, 17639,
     /* 2139935 */     GIR_EraseRootFromParent_Done,
     /* 2139936 */   // Label 28283: @2139936
     /* 2139936 */   GIM_Try, /*On fail goto*//*Label 28284*/ GIMT_Encode4(2140027), // Rule ID 17642 //
     /* 2139941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2139952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2139955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2139958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139987 */     // MIs[0] round
     /* 2139987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139990 */     // MIs[0] policy
     /* 2139990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140000 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2140003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140026 */     // GIR_Coverage, 17642,
     /* 2140026 */     GIR_EraseRootFromParent_Done,
     /* 2140027 */   // Label 28284: @2140027
     /* 2140027 */   GIM_Try, /*On fail goto*//*Label 28285*/ GIMT_Encode4(2140118), // Rule ID 17643 //
     /* 2140032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2140043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2140046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2140049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2140055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140078 */     // MIs[0] round
     /* 2140078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140081 */     // MIs[0] policy
     /* 2140081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140091 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2140094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140117 */     // GIR_Coverage, 17643,
     /* 2140117 */     GIR_EraseRootFromParent_Done,
     /* 2140118 */   // Label 28285: @2140118
     /* 2140118 */   GIM_Try, /*On fail goto*//*Label 28286*/ GIMT_Encode4(2140209), // Rule ID 17646 //
     /* 2140123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2140126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2140134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2140137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2140140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140169 */     // MIs[0] round
     /* 2140169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140172 */     // MIs[0] policy
     /* 2140172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140182 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2140185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140208 */     // GIR_Coverage, 17646,
     /* 2140208 */     GIR_EraseRootFromParent_Done,
     /* 2140209 */   // Label 28286: @2140209
     /* 2140209 */   GIM_Try, /*On fail goto*//*Label 28287*/ GIMT_Encode4(2140300), // Rule ID 17647 //
     /* 2140214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2140217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2140225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2140228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2140231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140237 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140260 */     // MIs[0] round
     /* 2140260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140263 */     // MIs[0] policy
     /* 2140263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140273 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2140276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140299 */     // GIR_Coverage, 17647,
     /* 2140299 */     GIR_EraseRootFromParent_Done,
     /* 2140300 */   // Label 28287: @2140300
     /* 2140300 */   GIM_Try, /*On fail goto*//*Label 28288*/ GIMT_Encode4(2140391), // Rule ID 17650 //
     /* 2140305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2140308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2140316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2140319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2140322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2140325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2140347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140351 */     // MIs[0] round
     /* 2140351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140354 */     // MIs[0] policy
     /* 2140354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140364 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2140367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140390 */     // GIR_Coverage, 17650,
     /* 2140390 */     GIR_EraseRootFromParent_Done,
     /* 2140391 */   // Label 28288: @2140391
     /* 2140391 */   GIM_Try, /*On fail goto*//*Label 28289*/ GIMT_Encode4(2140482), // Rule ID 17651 //
     /* 2140396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2140399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2140407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2140410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2140413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2140416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2140438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140442 */     // MIs[0] round
     /* 2140442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140445 */     // MIs[0] policy
     /* 2140445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140455 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2140458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140481 */     // GIR_Coverage, 17651,
     /* 2140481 */     GIR_EraseRootFromParent_Done,
     /* 2140482 */   // Label 28289: @2140482
     /* 2140482 */   GIM_Try, /*On fail goto*//*Label 28290*/ GIMT_Encode4(2140573), // Rule ID 17654 //
     /* 2140487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2140498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2140501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2140504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2140517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140533 */     // MIs[0] round
     /* 2140533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140536 */     // MIs[0] policy
     /* 2140536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140546 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2140549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140572 */     // GIR_Coverage, 17654,
     /* 2140572 */     GIR_EraseRootFromParent_Done,
     /* 2140573 */   // Label 28290: @2140573
     /* 2140573 */   GIM_Try, /*On fail goto*//*Label 28291*/ GIMT_Encode4(2140664), // Rule ID 17655 //
     /* 2140578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2140589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2140592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2140595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140601 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2140608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140624 */     // MIs[0] round
     /* 2140624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140627 */     // MIs[0] policy
     /* 2140627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140637 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2140640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140663 */     // GIR_Coverage, 17655,
     /* 2140663 */     GIR_EraseRootFromParent_Done,
     /* 2140664 */   // Label 28291: @2140664
     /* 2140664 */   GIM_Try, /*On fail goto*//*Label 28292*/ GIMT_Encode4(2140755), // Rule ID 17658 //
     /* 2140669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2140680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2140683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2140686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2140692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2140699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140715 */     // MIs[0] round
     /* 2140715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140718 */     // MIs[0] policy
     /* 2140718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140728 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2140731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140754 */     // GIR_Coverage, 17658,
     /* 2140754 */     GIR_EraseRootFromParent_Done,
     /* 2140755 */   // Label 28292: @2140755
     /* 2140755 */   GIM_Try, /*On fail goto*//*Label 28293*/ GIMT_Encode4(2140846), // Rule ID 17659 //
     /* 2140760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2140771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2140774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2140777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2140783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2140790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140806 */     // MIs[0] round
     /* 2140806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140809 */     // MIs[0] policy
     /* 2140809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140819 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2140822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140845 */     // GIR_Coverage, 17659,
     /* 2140845 */     GIR_EraseRootFromParent_Done,
     /* 2140846 */   // Label 28293: @2140846
     /* 2140846 */   GIM_Try, /*On fail goto*//*Label 28294*/ GIMT_Encode4(2140937), // Rule ID 17662 //
     /* 2140851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2140862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2140865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2140868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2140874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2140881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140897 */     // MIs[0] round
     /* 2140897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140900 */     // MIs[0] policy
     /* 2140900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140910 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2140913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140936 */     // GIR_Coverage, 17662,
     /* 2140936 */     GIR_EraseRootFromParent_Done,
     /* 2140937 */   // Label 28294: @2140937
     /* 2140937 */   GIM_Try, /*On fail goto*//*Label 28295*/ GIMT_Encode4(2141028), // Rule ID 17663 //
     /* 2140942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2140953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2140956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2140959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2140965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2140972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140988 */     // MIs[0] round
     /* 2140988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140991 */     // MIs[0] policy
     /* 2140991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141001 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2141004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141027 */     // GIR_Coverage, 17663,
     /* 2141027 */     GIR_EraseRootFromParent_Done,
     /* 2141028 */   // Label 28295: @2141028
     /* 2141028 */   GIM_Try, /*On fail goto*//*Label 28296*/ GIMT_Encode4(2141119), // Rule ID 17666 //
     /* 2141033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2141044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141079 */     // MIs[0] round
     /* 2141079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141082 */     // MIs[0] policy
     /* 2141082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141092 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2141095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141118 */     // GIR_Coverage, 17666,
     /* 2141118 */     GIR_EraseRootFromParent_Done,
     /* 2141119 */   // Label 28296: @2141119
     /* 2141119 */   GIM_Try, /*On fail goto*//*Label 28297*/ GIMT_Encode4(2141210), // Rule ID 17667 //
     /* 2141124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2141135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141170 */     // MIs[0] round
     /* 2141170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141173 */     // MIs[0] policy
     /* 2141173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141183 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2141186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141209 */     // GIR_Coverage, 17667,
     /* 2141209 */     GIR_EraseRootFromParent_Done,
     /* 2141210 */   // Label 28297: @2141210
     /* 2141210 */   GIM_Try, /*On fail goto*//*Label 28298*/ GIMT_Encode4(2141301), // Rule ID 17670 //
     /* 2141215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2141226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2141229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2141232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141261 */     // MIs[0] round
     /* 2141261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141264 */     // MIs[0] policy
     /* 2141264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141274 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2141277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141300 */     // GIR_Coverage, 17670,
     /* 2141300 */     GIR_EraseRootFromParent_Done,
     /* 2141301 */   // Label 28298: @2141301
     /* 2141301 */   GIM_Try, /*On fail goto*//*Label 28299*/ GIMT_Encode4(2141392), // Rule ID 17671 //
     /* 2141306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2141317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2141320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2141323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141352 */     // MIs[0] round
     /* 2141352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141355 */     // MIs[0] policy
     /* 2141355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141365 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2141368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141391 */     // GIR_Coverage, 17671,
     /* 2141391 */     GIR_EraseRootFromParent_Done,
     /* 2141392 */   // Label 28299: @2141392
     /* 2141392 */   GIM_Try, /*On fail goto*//*Label 28300*/ GIMT_Encode4(2141483), // Rule ID 17674 //
     /* 2141397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2141408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2141411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2141414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141443 */     // MIs[0] round
     /* 2141443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141446 */     // MIs[0] policy
     /* 2141446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141456 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2141459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141482 */     // GIR_Coverage, 17674,
     /* 2141482 */     GIR_EraseRootFromParent_Done,
     /* 2141483 */   // Label 28300: @2141483
     /* 2141483 */   GIM_Try, /*On fail goto*//*Label 28301*/ GIMT_Encode4(2141574), // Rule ID 17675 //
     /* 2141488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2141499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2141502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2141505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141534 */     // MIs[0] round
     /* 2141534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141537 */     // MIs[0] policy
     /* 2141537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141547 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2141550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141573 */     // GIR_Coverage, 17675,
     /* 2141573 */     GIR_EraseRootFromParent_Done,
     /* 2141574 */   // Label 28301: @2141574
     /* 2141574 */   GIM_Try, /*On fail goto*//*Label 28302*/ GIMT_Encode4(2141665), // Rule ID 17678 //
     /* 2141579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2141582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2141590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2141593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2141596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2141599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2141602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2141621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141625 */     // MIs[0] round
     /* 2141625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141628 */     // MIs[0] policy
     /* 2141628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141638 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2141641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141664 */     // GIR_Coverage, 17678,
     /* 2141664 */     GIR_EraseRootFromParent_Done,
     /* 2141665 */   // Label 28302: @2141665
     /* 2141665 */   GIM_Try, /*On fail goto*//*Label 28303*/ GIMT_Encode4(2141756), // Rule ID 17679 //
     /* 2141670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2141673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2141681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2141684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2141687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2141690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2141693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2141712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141716 */     // MIs[0] round
     /* 2141716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141719 */     // MIs[0] policy
     /* 2141719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141729 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2141732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141755 */     // GIR_Coverage, 17679,
     /* 2141755 */     GIR_EraseRootFromParent_Done,
     /* 2141756 */   // Label 28303: @2141756
     /* 2141756 */   GIM_Try, /*On fail goto*//*Label 28304*/ GIMT_Encode4(2141847), // Rule ID 17682 //
     /* 2141761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2141764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2141772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2141775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2141778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2141781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2141803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141807 */     // MIs[0] round
     /* 2141807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141810 */     // MIs[0] policy
     /* 2141810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141820 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2141823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141846 */     // GIR_Coverage, 17682,
     /* 2141846 */     GIR_EraseRootFromParent_Done,
     /* 2141847 */   // Label 28304: @2141847
     /* 2141847 */   GIM_Try, /*On fail goto*//*Label 28305*/ GIMT_Encode4(2141938), // Rule ID 17683 //
     /* 2141852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2141855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2141863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2141866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2141869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2141872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2141894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141898 */     // MIs[0] round
     /* 2141898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141901 */     // MIs[0] policy
     /* 2141901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141911 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2141914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141937 */     // GIR_Coverage, 17683,
     /* 2141937 */     GIR_EraseRootFromParent_Done,
     /* 2141938 */   // Label 28305: @2141938
     /* 2141938 */   GIM_Try, /*On fail goto*//*Label 28306*/ GIMT_Encode4(2142029), // Rule ID 17686 //
     /* 2141943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2141946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2141954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2141957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2141960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2141963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2141985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141989 */     // MIs[0] round
     /* 2141989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141992 */     // MIs[0] policy
     /* 2141992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142002 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2142005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142028 */     // GIR_Coverage, 17686,
     /* 2142028 */     GIR_EraseRootFromParent_Done,
     /* 2142029 */   // Label 28306: @2142029
     /* 2142029 */   GIM_Try, /*On fail goto*//*Label 28307*/ GIMT_Encode4(2142120), // Rule ID 17687 //
     /* 2142034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2142037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2142045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2142048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2142051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142080 */     // MIs[0] round
     /* 2142080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142083 */     // MIs[0] policy
     /* 2142083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142093 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2142096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142119 */     // GIR_Coverage, 17687,
     /* 2142119 */     GIR_EraseRootFromParent_Done,
     /* 2142120 */   // Label 28307: @2142120
     /* 2142120 */   GIM_Try, /*On fail goto*//*Label 28308*/ GIMT_Encode4(2142211), // Rule ID 17690 //
     /* 2142125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2142136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2142139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2142142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2142145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2142148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142171 */     // MIs[0] round
     /* 2142171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142174 */     // MIs[0] policy
     /* 2142174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142184 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2142187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142210 */     // GIR_Coverage, 17690,
     /* 2142210 */     GIR_EraseRootFromParent_Done,
     /* 2142211 */   // Label 28308: @2142211
     /* 2142211 */   GIM_Try, /*On fail goto*//*Label 28309*/ GIMT_Encode4(2142302), // Rule ID 17691 //
     /* 2142216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2142227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2142230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2142233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2142236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2142239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142262 */     // MIs[0] round
     /* 2142262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142265 */     // MIs[0] policy
     /* 2142265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142275 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2142278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142301 */     // GIR_Coverage, 17691,
     /* 2142301 */     GIR_EraseRootFromParent_Done,
     /* 2142302 */   // Label 28309: @2142302
     /* 2142302 */   GIM_Try, /*On fail goto*//*Label 28310*/ GIMT_Encode4(2142393), // Rule ID 17694 //
     /* 2142307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2142318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2142321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2142324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2142327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142353 */     // MIs[0] round
     /* 2142353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142356 */     // MIs[0] policy
     /* 2142356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142366 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2142369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142392 */     // GIR_Coverage, 17694,
     /* 2142392 */     GIR_EraseRootFromParent_Done,
     /* 2142393 */   // Label 28310: @2142393
     /* 2142393 */   GIM_Try, /*On fail goto*//*Label 28311*/ GIMT_Encode4(2142484), // Rule ID 17695 //
     /* 2142398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2142409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2142412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2142415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2142418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142444 */     // MIs[0] round
     /* 2142444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142447 */     // MIs[0] policy
     /* 2142447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142457 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2142460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142483 */     // GIR_Coverage, 17695,
     /* 2142483 */     GIR_EraseRootFromParent_Done,
     /* 2142484 */   // Label 28311: @2142484
     /* 2142484 */   GIM_Try, /*On fail goto*//*Label 28312*/ GIMT_Encode4(2142575), // Rule ID 17698 //
     /* 2142489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2142500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2142506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2142509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142535 */     // MIs[0] round
     /* 2142535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142538 */     // MIs[0] policy
     /* 2142538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142548 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2142551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142574 */     // GIR_Coverage, 17698,
     /* 2142574 */     GIR_EraseRootFromParent_Done,
     /* 2142575 */   // Label 28312: @2142575
     /* 2142575 */   GIM_Try, /*On fail goto*//*Label 28313*/ GIMT_Encode4(2142666), // Rule ID 17699 //
     /* 2142580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2142591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2142597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2142600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142626 */     // MIs[0] round
     /* 2142626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142629 */     // MIs[0] policy
     /* 2142629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142639 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2142642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142665 */     // GIR_Coverage, 17699,
     /* 2142665 */     GIR_EraseRootFromParent_Done,
     /* 2142666 */   // Label 28313: @2142666
     /* 2142666 */   GIM_Try, /*On fail goto*//*Label 28314*/ GIMT_Encode4(2142757), // Rule ID 17702 //
     /* 2142671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2142682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2142685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2142688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2142691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142717 */     // MIs[0] round
     /* 2142717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142720 */     // MIs[0] policy
     /* 2142720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142730 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2142733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142756 */     // GIR_Coverage, 17702,
     /* 2142756 */     GIR_EraseRootFromParent_Done,
     /* 2142757 */   // Label 28314: @2142757
     /* 2142757 */   GIM_Try, /*On fail goto*//*Label 28315*/ GIMT_Encode4(2142848), // Rule ID 17703 //
     /* 2142762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2142773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2142776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2142779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2142782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142808 */     // MIs[0] round
     /* 2142808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142811 */     // MIs[0] policy
     /* 2142811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142821 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2142824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142834 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142844 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142847 */     // GIR_Coverage, 17703,
     /* 2142847 */     GIR_EraseRootFromParent_Done,
     /* 2142848 */   // Label 28315: @2142848
     /* 2142848 */   GIM_Try, /*On fail goto*//*Label 28316*/ GIMT_Encode4(2142939), // Rule ID 17706 //
     /* 2142853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2142864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2142867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2142870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2142873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2142876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142899 */     // MIs[0] round
     /* 2142899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142902 */     // MIs[0] policy
     /* 2142902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142912 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2142915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142938 */     // GIR_Coverage, 17706,
     /* 2142938 */     GIR_EraseRootFromParent_Done,
     /* 2142939 */   // Label 28316: @2142939
     /* 2142939 */   GIM_Try, /*On fail goto*//*Label 28317*/ GIMT_Encode4(2143030), // Rule ID 17707 //
     /* 2142944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2142955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2142958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2142961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2142964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2142967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142990 */     // MIs[0] round
     /* 2142990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142993 */     // MIs[0] policy
     /* 2142993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143003 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2143006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143029 */     // GIR_Coverage, 17707,
     /* 2143029 */     GIR_EraseRootFromParent_Done,
     /* 2143030 */   // Label 28317: @2143030
     /* 2143030 */   GIM_Try, /*On fail goto*//*Label 28318*/ GIMT_Encode4(2143121), // Rule ID 17710 //
     /* 2143035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2143046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2143049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2143052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2143055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143081 */     // MIs[0] round
     /* 2143081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143084 */     // MIs[0] policy
     /* 2143084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143094 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2143097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143120 */     // GIR_Coverage, 17710,
     /* 2143120 */     GIR_EraseRootFromParent_Done,
     /* 2143121 */   // Label 28318: @2143121
     /* 2143121 */   GIM_Try, /*On fail goto*//*Label 28319*/ GIMT_Encode4(2143212), // Rule ID 17711 //
     /* 2143126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2143137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2143140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2143143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2143146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143172 */     // MIs[0] round
     /* 2143172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143175 */     // MIs[0] policy
     /* 2143175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143185 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2143188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143211 */     // GIR_Coverage, 17711,
     /* 2143211 */     GIR_EraseRootFromParent_Done,
     /* 2143212 */   // Label 28319: @2143212
     /* 2143212 */   GIM_Try, /*On fail goto*//*Label 28320*/ GIMT_Encode4(2143303), // Rule ID 17714 //
     /* 2143217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2143228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2143231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2143234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2143237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143263 */     // MIs[0] round
     /* 2143263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143266 */     // MIs[0] policy
     /* 2143266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143276 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2143279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143302 */     // GIR_Coverage, 17714,
     /* 2143302 */     GIR_EraseRootFromParent_Done,
     /* 2143303 */   // Label 28320: @2143303
     /* 2143303 */   GIM_Try, /*On fail goto*//*Label 28321*/ GIMT_Encode4(2143394), // Rule ID 17715 //
     /* 2143308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2143319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2143322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2143325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2143328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143354 */     // MIs[0] round
     /* 2143354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143357 */     // MIs[0] policy
     /* 2143357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143367 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2143370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143393 */     // GIR_Coverage, 17715,
     /* 2143393 */     GIR_EraseRootFromParent_Done,
     /* 2143394 */   // Label 28321: @2143394
     /* 2143394 */   GIM_Try, /*On fail goto*//*Label 28322*/ GIMT_Encode4(2143485), // Rule ID 17718 //
     /* 2143399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2143410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2143413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2143416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2143419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143445 */     // MIs[0] round
     /* 2143445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143448 */     // MIs[0] policy
     /* 2143448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143458 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2143461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143484 */     // GIR_Coverage, 17718,
     /* 2143484 */     GIR_EraseRootFromParent_Done,
     /* 2143485 */   // Label 28322: @2143485
     /* 2143485 */   GIM_Try, /*On fail goto*//*Label 28323*/ GIMT_Encode4(2143576), // Rule ID 17719 //
     /* 2143490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2143501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2143504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2143507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2143510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143536 */     // MIs[0] round
     /* 2143536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143539 */     // MIs[0] policy
     /* 2143539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143549 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2143552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143575 */     // GIR_Coverage, 17719,
     /* 2143575 */     GIR_EraseRootFromParent_Done,
     /* 2143576 */   // Label 28323: @2143576
     /* 2143576 */   GIM_Try, /*On fail goto*//*Label 28324*/ GIMT_Encode4(2143667), // Rule ID 17722 //
     /* 2143581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2143592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2143595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2143598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2143601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143627 */     // MIs[0] round
     /* 2143627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143630 */     // MIs[0] policy
     /* 2143630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143640 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2143643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143666 */     // GIR_Coverage, 17722,
     /* 2143666 */     GIR_EraseRootFromParent_Done,
     /* 2143667 */   // Label 28324: @2143667
     /* 2143667 */   GIM_Try, /*On fail goto*//*Label 28325*/ GIMT_Encode4(2143758), // Rule ID 17723 //
     /* 2143672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2143683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2143686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2143689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2143692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143695 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143718 */     // MIs[0] round
     /* 2143718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143721 */     // MIs[0] policy
     /* 2143721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143731 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2143734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143757 */     // GIR_Coverage, 17723,
     /* 2143757 */     GIR_EraseRootFromParent_Done,
     /* 2143758 */   // Label 28325: @2143758
     /* 2143758 */   GIM_Try, /*On fail goto*//*Label 28326*/ GIMT_Encode4(2143849), // Rule ID 17726 //
     /* 2143763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2143766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2143774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2143777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2143780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2143783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143809 */     // MIs[0] round
     /* 2143809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143812 */     // MIs[0] policy
     /* 2143812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143822 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2143825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143848 */     // GIR_Coverage, 17726,
     /* 2143848 */     GIR_EraseRootFromParent_Done,
     /* 2143849 */   // Label 28326: @2143849
     /* 2143849 */   GIM_Try, /*On fail goto*//*Label 28327*/ GIMT_Encode4(2143940), // Rule ID 17727 //
     /* 2143854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2143857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2143865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2143868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2143871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2143874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143900 */     // MIs[0] round
     /* 2143900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143903 */     // MIs[0] policy
     /* 2143903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143913 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2143916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143939 */     // GIR_Coverage, 17727,
     /* 2143939 */     GIR_EraseRootFromParent_Done,
     /* 2143940 */   // Label 28327: @2143940
     /* 2143940 */   GIM_Try, /*On fail goto*//*Label 28328*/ GIMT_Encode4(2144031), // Rule ID 17730 //
     /* 2143945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2143948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2143956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2143959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2143962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2143965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143991 */     // MIs[0] round
     /* 2143991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143994 */     // MIs[0] policy
     /* 2143994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144004 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2144007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144030 */     // GIR_Coverage, 17730,
     /* 2144030 */     GIR_EraseRootFromParent_Done,
     /* 2144031 */   // Label 28328: @2144031
     /* 2144031 */   GIM_Try, /*On fail goto*//*Label 28329*/ GIMT_Encode4(2144122), // Rule ID 17731 //
     /* 2144036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2144047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2144050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2144053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144082 */     // MIs[0] round
     /* 2144082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144085 */     // MIs[0] policy
     /* 2144085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144095 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2144098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144121 */     // GIR_Coverage, 17731,
     /* 2144121 */     GIR_EraseRootFromParent_Done,
     /* 2144122 */   // Label 28329: @2144122
     /* 2144122 */   GIM_Try, /*On fail goto*//*Label 28330*/ GIMT_Encode4(2144213), // Rule ID 17734 //
     /* 2144127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2144138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2144141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2144144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144173 */     // MIs[0] round
     /* 2144173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144176 */     // MIs[0] policy
     /* 2144176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144186 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2144189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144212 */     // GIR_Coverage, 17734,
     /* 2144212 */     GIR_EraseRootFromParent_Done,
     /* 2144213 */   // Label 28330: @2144213
     /* 2144213 */   GIM_Try, /*On fail goto*//*Label 28331*/ GIMT_Encode4(2144304), // Rule ID 17735 //
     /* 2144218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2144229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2144232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2144235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144264 */     // MIs[0] round
     /* 2144264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144267 */     // MIs[0] policy
     /* 2144267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144277 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2144280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144303 */     // GIR_Coverage, 17735,
     /* 2144303 */     GIR_EraseRootFromParent_Done,
     /* 2144304 */   // Label 28331: @2144304
     /* 2144304 */   GIM_Try, /*On fail goto*//*Label 28332*/ GIMT_Encode4(2144395), // Rule ID 17738 //
     /* 2144309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2144320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144355 */     // MIs[0] round
     /* 2144355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144358 */     // MIs[0] policy
     /* 2144358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144368 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2144371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144394 */     // GIR_Coverage, 17738,
     /* 2144394 */     GIR_EraseRootFromParent_Done,
     /* 2144395 */   // Label 28332: @2144395
     /* 2144395 */   GIM_Try, /*On fail goto*//*Label 28333*/ GIMT_Encode4(2144486), // Rule ID 17739 //
     /* 2144400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2144411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144446 */     // MIs[0] round
     /* 2144446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144449 */     // MIs[0] policy
     /* 2144449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144459 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2144462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144485 */     // GIR_Coverage, 17739,
     /* 2144485 */     GIR_EraseRootFromParent_Done,
     /* 2144486 */   // Label 28333: @2144486
     /* 2144486 */   GIM_Try, /*On fail goto*//*Label 28334*/ GIMT_Encode4(2144577), // Rule ID 17742 //
     /* 2144491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2144502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2144505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2144508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2144514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144537 */     // MIs[0] round
     /* 2144537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144540 */     // MIs[0] policy
     /* 2144540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144550 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2144553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144576 */     // GIR_Coverage, 17742,
     /* 2144576 */     GIR_EraseRootFromParent_Done,
     /* 2144577 */   // Label 28334: @2144577
     /* 2144577 */   GIM_Try, /*On fail goto*//*Label 28335*/ GIMT_Encode4(2144668), // Rule ID 17743 //
     /* 2144582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2144593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2144596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2144599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2144605 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144628 */     // MIs[0] round
     /* 2144628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144631 */     // MIs[0] policy
     /* 2144631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144641 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2144644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144664 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144667 */     // GIR_Coverage, 17743,
     /* 2144667 */     GIR_EraseRootFromParent_Done,
     /* 2144668 */   // Label 28335: @2144668
     /* 2144668 */   GIM_Try, /*On fail goto*//*Label 28336*/ GIMT_Encode4(2144759), // Rule ID 17746 //
     /* 2144673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2144676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2144684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2144687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2144690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2144693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144719 */     // MIs[0] round
     /* 2144719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144722 */     // MIs[0] policy
     /* 2144722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144732 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2144735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144758 */     // GIR_Coverage, 17746,
     /* 2144758 */     GIR_EraseRootFromParent_Done,
     /* 2144759 */   // Label 28336: @2144759
     /* 2144759 */   GIM_Try, /*On fail goto*//*Label 28337*/ GIMT_Encode4(2144850), // Rule ID 17747 //
     /* 2144764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2144767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2144775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2144778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2144781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2144784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144810 */     // MIs[0] round
     /* 2144810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144813 */     // MIs[0] policy
     /* 2144813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144823 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2144826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144849 */     // GIR_Coverage, 17747,
     /* 2144849 */     GIR_EraseRootFromParent_Done,
     /* 2144850 */   // Label 28337: @2144850
     /* 2144850 */   GIM_Try, /*On fail goto*//*Label 28338*/ GIMT_Encode4(2144941), // Rule ID 17750 //
     /* 2144855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2144858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2144866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2144869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2144872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2144875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144901 */     // MIs[0] round
     /* 2144901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144904 */     // MIs[0] policy
     /* 2144904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144914 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2144917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144940 */     // GIR_Coverage, 17750,
     /* 2144940 */     GIR_EraseRootFromParent_Done,
     /* 2144941 */   // Label 28338: @2144941
     /* 2144941 */   GIM_Try, /*On fail goto*//*Label 28339*/ GIMT_Encode4(2145032), // Rule ID 17751 //
     /* 2144946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2144949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2144957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2144960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2144963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2144966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144992 */     // MIs[0] round
     /* 2144992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144995 */     // MIs[0] policy
     /* 2144995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145005 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2145008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145018 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145028 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145031 */     // GIR_Coverage, 17751,
     /* 2145031 */     GIR_EraseRootFromParent_Done,
     /* 2145032 */   // Label 28339: @2145032
     /* 2145032 */   GIM_Try, /*On fail goto*//*Label 28340*/ GIMT_Encode4(2145123), // Rule ID 17754 //
     /* 2145037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2145040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2145048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2145051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2145054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145083 */     // MIs[0] round
     /* 2145083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145086 */     // MIs[0] policy
     /* 2145086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145096 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2145099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145119 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145122 */     // GIR_Coverage, 17754,
     /* 2145122 */     GIR_EraseRootFromParent_Done,
     /* 2145123 */   // Label 28340: @2145123
     /* 2145123 */   GIM_Try, /*On fail goto*//*Label 28341*/ GIMT_Encode4(2145214), // Rule ID 17755 //
     /* 2145128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2145131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2145139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2145142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2145145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145174 */     // MIs[0] round
     /* 2145174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145177 */     // MIs[0] policy
     /* 2145177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145187 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2145190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145213 */     // GIR_Coverage, 17755,
     /* 2145213 */     GIR_EraseRootFromParent_Done,
     /* 2145214 */   // Label 28341: @2145214
     /* 2145214 */   GIM_Try, /*On fail goto*//*Label 28342*/ GIMT_Encode4(2145305), // Rule ID 17758 //
     /* 2145219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2145222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2145230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145265 */     // MIs[0] round
     /* 2145265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145268 */     // MIs[0] policy
     /* 2145268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145278 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2145281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145304 */     // GIR_Coverage, 17758,
     /* 2145304 */     GIR_EraseRootFromParent_Done,
     /* 2145305 */   // Label 28342: @2145305
     /* 2145305 */   GIM_Try, /*On fail goto*//*Label 28343*/ GIMT_Encode4(2145396), // Rule ID 17759 //
     /* 2145310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2145313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2145321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145356 */     // MIs[0] round
     /* 2145356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145359 */     // MIs[0] policy
     /* 2145359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145369 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2145372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145395 */     // GIR_Coverage, 17759,
     /* 2145395 */     GIR_EraseRootFromParent_Done,
     /* 2145396 */   // Label 28343: @2145396
     /* 2145396 */   GIM_Try, /*On fail goto*//*Label 28344*/ GIMT_Encode4(2145487), // Rule ID 17762 //
     /* 2145401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2145404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2145412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2145415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2145418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2145421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145447 */     // MIs[0] round
     /* 2145447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145450 */     // MIs[0] policy
     /* 2145450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145460 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2145463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145486 */     // GIR_Coverage, 17762,
     /* 2145486 */     GIR_EraseRootFromParent_Done,
     /* 2145487 */   // Label 28344: @2145487
     /* 2145487 */   GIM_Try, /*On fail goto*//*Label 28345*/ GIMT_Encode4(2145578), // Rule ID 17763 //
     /* 2145492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2145495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2145503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2145506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2145509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2145512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145538 */     // MIs[0] round
     /* 2145538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145541 */     // MIs[0] policy
     /* 2145541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145551 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2145554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145577 */     // GIR_Coverage, 17763,
     /* 2145577 */     GIR_EraseRootFromParent_Done,
     /* 2145578 */   // Label 28345: @2145578
     /* 2145578 */   GIM_Try, /*On fail goto*//*Label 28346*/ GIMT_Encode4(2145669), // Rule ID 17766 //
     /* 2145583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2145586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2145594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2145597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2145600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2145603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145629 */     // MIs[0] round
     /* 2145629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145632 */     // MIs[0] policy
     /* 2145632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145642 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2145645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145668 */     // GIR_Coverage, 17766,
     /* 2145668 */     GIR_EraseRootFromParent_Done,
     /* 2145669 */   // Label 28346: @2145669
     /* 2145669 */   GIM_Try, /*On fail goto*//*Label 28347*/ GIMT_Encode4(2145760), // Rule ID 17767 //
     /* 2145674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2145677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2145685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2145688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2145691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2145694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145720 */     // MIs[0] round
     /* 2145720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145723 */     // MIs[0] policy
     /* 2145723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145733 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2145736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145759 */     // GIR_Coverage, 17767,
     /* 2145759 */     GIR_EraseRootFromParent_Done,
     /* 2145760 */   // Label 28347: @2145760
     /* 2145760 */   GIM_Try, /*On fail goto*//*Label 28348*/ GIMT_Encode4(2145851), // Rule ID 17770 //
     /* 2145765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2145768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2145776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2145779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2145782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2145785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145811 */     // MIs[0] round
     /* 2145811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145814 */     // MIs[0] policy
     /* 2145814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145824 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2145827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145850 */     // GIR_Coverage, 17770,
     /* 2145850 */     GIR_EraseRootFromParent_Done,
     /* 2145851 */   // Label 28348: @2145851
     /* 2145851 */   GIM_Try, /*On fail goto*//*Label 28349*/ GIMT_Encode4(2145942), // Rule ID 17771 //
     /* 2145856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2145859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2145867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2145870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2145873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2145876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145902 */     // MIs[0] round
     /* 2145902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145905 */     // MIs[0] policy
     /* 2145905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145915 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2145918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145941 */     // GIR_Coverage, 17771,
     /* 2145941 */     GIR_EraseRootFromParent_Done,
     /* 2145942 */   // Label 28349: @2145942
     /* 2145942 */   GIM_Try, /*On fail goto*//*Label 28350*/ GIMT_Encode4(2146033), // Rule ID 17774 //
     /* 2145947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2145950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2145958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2145961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2145964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2145967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145993 */     // MIs[0] round
     /* 2145993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145996 */     // MIs[0] policy
     /* 2145996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146006 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2146009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146032 */     // GIR_Coverage, 17774,
     /* 2146032 */     GIR_EraseRootFromParent_Done,
     /* 2146033 */   // Label 28350: @2146033
     /* 2146033 */   GIM_Try, /*On fail goto*//*Label 28351*/ GIMT_Encode4(2146124), // Rule ID 17775 //
     /* 2146038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2146041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2146049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2146052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2146055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2146058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2146061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146084 */     // MIs[0] round
     /* 2146084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146087 */     // MIs[0] policy
     /* 2146087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146097 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2146100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146123 */     // GIR_Coverage, 17775,
     /* 2146123 */     GIR_EraseRootFromParent_Done,
     /* 2146124 */   // Label 28351: @2146124
     /* 2146124 */   GIM_Try, /*On fail goto*//*Label 28352*/ GIMT_Encode4(2146215), // Rule ID 17778 //
     /* 2146129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2146132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2146140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2146143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2146146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2146149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146175 */     // MIs[0] round
     /* 2146175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146178 */     // MIs[0] policy
     /* 2146178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146188 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2146191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146214 */     // GIR_Coverage, 17778,
     /* 2146214 */     GIR_EraseRootFromParent_Done,
     /* 2146215 */   // Label 28352: @2146215
     /* 2146215 */   GIM_Try, /*On fail goto*//*Label 28353*/ GIMT_Encode4(2146306), // Rule ID 17779 //
     /* 2146220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2146223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2146231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2146234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2146237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2146240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146266 */     // MIs[0] round
     /* 2146266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146269 */     // MIs[0] policy
     /* 2146269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146279 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2146282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146305 */     // GIR_Coverage, 17779,
     /* 2146305 */     GIR_EraseRootFromParent_Done,
     /* 2146306 */   // Label 28353: @2146306
     /* 2146306 */   GIM_Try, /*On fail goto*//*Label 28354*/ GIMT_Encode4(2146397), // Rule ID 17782 //
     /* 2146311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2146322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2146331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146357 */     // MIs[0] round
     /* 2146357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146360 */     // MIs[0] policy
     /* 2146360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146370 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2146373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146396 */     // GIR_Coverage, 17782,
     /* 2146396 */     GIR_EraseRootFromParent_Done,
     /* 2146397 */   // Label 28354: @2146397
     /* 2146397 */   GIM_Try, /*On fail goto*//*Label 28355*/ GIMT_Encode4(2146488), // Rule ID 17783 //
     /* 2146402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2146413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2146422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146448 */     // MIs[0] round
     /* 2146448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146451 */     // MIs[0] policy
     /* 2146451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146461 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2146464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146487 */     // GIR_Coverage, 17783,
     /* 2146487 */     GIR_EraseRootFromParent_Done,
     /* 2146488 */   // Label 28355: @2146488
     /* 2146488 */   GIM_Try, /*On fail goto*//*Label 28356*/ GIMT_Encode4(2146579), // Rule ID 17786 //
     /* 2146493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2146504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2146507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2146510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2146513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2146516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146539 */     // MIs[0] round
     /* 2146539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146542 */     // MIs[0] policy
     /* 2146542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146552 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2146555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146578 */     // GIR_Coverage, 17786,
     /* 2146578 */     GIR_EraseRootFromParent_Done,
     /* 2146579 */   // Label 28356: @2146579
     /* 2146579 */   GIM_Try, /*On fail goto*//*Label 28357*/ GIMT_Encode4(2146670), // Rule ID 17787 //
     /* 2146584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2146595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2146598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2146601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2146604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2146607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146630 */     // MIs[0] round
     /* 2146630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146633 */     // MIs[0] policy
     /* 2146633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146643 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2146646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146669 */     // GIR_Coverage, 17787,
     /* 2146669 */     GIR_EraseRootFromParent_Done,
     /* 2146670 */   // Label 28357: @2146670
     /* 2146670 */   GIM_Try, /*On fail goto*//*Label 28358*/ GIMT_Encode4(2146761), // Rule ID 17790 //
     /* 2146675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2146686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2146689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2146692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2146695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2146698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2146705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146721 */     // MIs[0] round
     /* 2146721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146724 */     // MIs[0] policy
     /* 2146724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146734 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2146737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146760 */     // GIR_Coverage, 17790,
     /* 2146760 */     GIR_EraseRootFromParent_Done,
     /* 2146761 */   // Label 28358: @2146761
     /* 2146761 */   GIM_Try, /*On fail goto*//*Label 28359*/ GIMT_Encode4(2146852), // Rule ID 17791 //
     /* 2146766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2146777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2146780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2146783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2146786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2146789 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2146796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146812 */     // MIs[0] round
     /* 2146812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146815 */     // MIs[0] policy
     /* 2146815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146825 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2146828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146851 */     // GIR_Coverage, 17791,
     /* 2146851 */     GIR_EraseRootFromParent_Done,
     /* 2146852 */   // Label 28359: @2146852
     /* 2146852 */   GIM_Try, /*On fail goto*//*Label 28360*/ GIMT_Encode4(2146943), // Rule ID 17794 //
     /* 2146857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2146860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2146868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2146871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2146874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2146877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146903 */     // MIs[0] round
     /* 2146903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146906 */     // MIs[0] policy
     /* 2146906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146916 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2146919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146942 */     // GIR_Coverage, 17794,
     /* 2146942 */     GIR_EraseRootFromParent_Done,
     /* 2146943 */   // Label 28360: @2146943
     /* 2146943 */   GIM_Try, /*On fail goto*//*Label 28361*/ GIMT_Encode4(2147034), // Rule ID 17795 //
     /* 2146948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2146951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2146959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2146962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2146965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2146968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146994 */     // MIs[0] round
     /* 2146994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146997 */     // MIs[0] policy
     /* 2146997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147007 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2147010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147033 */     // GIR_Coverage, 17795,
     /* 2147033 */     GIR_EraseRootFromParent_Done,
     /* 2147034 */   // Label 28361: @2147034
     /* 2147034 */   GIM_Try, /*On fail goto*//*Label 28362*/ GIMT_Encode4(2147125), // Rule ID 17798 //
     /* 2147039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2147042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2147050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2147053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2147056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2147059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147085 */     // MIs[0] round
     /* 2147085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147088 */     // MIs[0] policy
     /* 2147088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147098 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2147101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147124 */     // GIR_Coverage, 17798,
     /* 2147124 */     GIR_EraseRootFromParent_Done,
     /* 2147125 */   // Label 28362: @2147125
     /* 2147125 */   GIM_Try, /*On fail goto*//*Label 28363*/ GIMT_Encode4(2147216), // Rule ID 17799 //
     /* 2147130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2147133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2147141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2147144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2147147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2147150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147176 */     // MIs[0] round
     /* 2147176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147179 */     // MIs[0] policy
     /* 2147179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147189 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2147192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147215 */     // GIR_Coverage, 17799,
     /* 2147215 */     GIR_EraseRootFromParent_Done,
     /* 2147216 */   // Label 28363: @2147216
     /* 2147216 */   GIM_Try, /*On fail goto*//*Label 28364*/ GIMT_Encode4(2147307), // Rule ID 17802 //
     /* 2147221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2147224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2147232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2147241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2147244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147267 */     // MIs[0] round
     /* 2147267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147270 */     // MIs[0] policy
     /* 2147270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147280 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2147283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147306 */     // GIR_Coverage, 17802,
     /* 2147306 */     GIR_EraseRootFromParent_Done,
     /* 2147307 */   // Label 28364: @2147307
     /* 2147307 */   GIM_Try, /*On fail goto*//*Label 28365*/ GIMT_Encode4(2147398), // Rule ID 17803 //
     /* 2147312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2147315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2147323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2147332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2147335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147358 */     // MIs[0] round
     /* 2147358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147361 */     // MIs[0] policy
     /* 2147361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147371 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2147374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147397 */     // GIR_Coverage, 17803,
     /* 2147397 */     GIR_EraseRootFromParent_Done,
     /* 2147398 */   // Label 28365: @2147398
     /* 2147398 */   GIM_Try, /*On fail goto*//*Label 28366*/ GIMT_Encode4(2147489), // Rule ID 17806 //
     /* 2147403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2147406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2147414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2147417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2147420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2147423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147449 */     // MIs[0] round
     /* 2147449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147452 */     // MIs[0] policy
     /* 2147452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147462 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2147465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147488 */     // GIR_Coverage, 17806,
     /* 2147488 */     GIR_EraseRootFromParent_Done,
     /* 2147489 */   // Label 28366: @2147489
     /* 2147489 */   GIM_Try, /*On fail goto*//*Label 28367*/ GIMT_Encode4(2147580), // Rule ID 17807 //
     /* 2147494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2147497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2147505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2147508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2147511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2147514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147540 */     // MIs[0] round
     /* 2147540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147543 */     // MIs[0] policy
     /* 2147543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147553 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2147556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147579 */     // GIR_Coverage, 17807,
     /* 2147579 */     GIR_EraseRootFromParent_Done,
     /* 2147580 */   // Label 28367: @2147580
     /* 2147580 */   GIM_Try, /*On fail goto*//*Label 28368*/ GIMT_Encode4(2147671), // Rule ID 17810 //
     /* 2147585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2147588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2147596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2147599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2147602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2147605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147631 */     // MIs[0] round
     /* 2147631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147634 */     // MIs[0] policy
     /* 2147634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147644 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2147647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147670 */     // GIR_Coverage, 17810,
     /* 2147670 */     GIR_EraseRootFromParent_Done,
     /* 2147671 */   // Label 28368: @2147671
     /* 2147671 */   GIM_Try, /*On fail goto*//*Label 28369*/ GIMT_Encode4(2147762), // Rule ID 17811 //
     /* 2147676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2147679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2147687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2147690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2147693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2147696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147699 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147722 */     // MIs[0] round
     /* 2147722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147725 */     // MIs[0] policy
     /* 2147725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147735 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2147738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147761 */     // GIR_Coverage, 17811,
     /* 2147761 */     GIR_EraseRootFromParent_Done,
     /* 2147762 */   // Label 28369: @2147762
     /* 2147762 */   GIM_Try, /*On fail goto*//*Label 28370*/ GIMT_Encode4(2147853), // Rule ID 17814 //
     /* 2147767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2147770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2147778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2147781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2147784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2147787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147813 */     // MIs[0] round
     /* 2147813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147816 */     // MIs[0] policy
     /* 2147816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147826 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2147829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147852 */     // GIR_Coverage, 17814,
     /* 2147852 */     GIR_EraseRootFromParent_Done,
     /* 2147853 */   // Label 28370: @2147853
     /* 2147853 */   GIM_Try, /*On fail goto*//*Label 28371*/ GIMT_Encode4(2147944), // Rule ID 17815 //
     /* 2147858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2147861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2147869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2147872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2147875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2147878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147904 */     // MIs[0] round
     /* 2147904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147907 */     // MIs[0] policy
     /* 2147907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147917 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2147920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147943 */     // GIR_Coverage, 17815,
     /* 2147943 */     GIR_EraseRootFromParent_Done,
     /* 2147944 */   // Label 28371: @2147944
     /* 2147944 */   GIM_Try, /*On fail goto*//*Label 28372*/ GIMT_Encode4(2148035), // Rule ID 17818 //
     /* 2147949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2147952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2147960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2147963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2147966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2147969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2147972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147995 */     // MIs[0] round
     /* 2147995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147998 */     // MIs[0] policy
     /* 2147998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148008 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2148011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148034 */     // GIR_Coverage, 17818,
     /* 2148034 */     GIR_EraseRootFromParent_Done,
     /* 2148035 */   // Label 28372: @2148035
     /* 2148035 */   GIM_Try, /*On fail goto*//*Label 28373*/ GIMT_Encode4(2148126), // Rule ID 17819 //
     /* 2148040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2148051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2148054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2148060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148086 */     // MIs[0] round
     /* 2148086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148089 */     // MIs[0] policy
     /* 2148089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148099 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2148102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148125 */     // GIR_Coverage, 17819,
     /* 2148125 */     GIR_EraseRootFromParent_Done,
     /* 2148126 */   // Label 28373: @2148126
     /* 2148126 */   GIM_Try, /*On fail goto*//*Label 28374*/ GIMT_Encode4(2148217), // Rule ID 17822 //
     /* 2148131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2148134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2148142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2148145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2148151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148177 */     // MIs[0] round
     /* 2148177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148180 */     // MIs[0] policy
     /* 2148180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148190 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2148193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148216 */     // GIR_Coverage, 17822,
     /* 2148216 */     GIR_EraseRootFromParent_Done,
     /* 2148217 */   // Label 28374: @2148217
     /* 2148217 */   GIM_Try, /*On fail goto*//*Label 28375*/ GIMT_Encode4(2148308), // Rule ID 17823 //
     /* 2148222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2148233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2148236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2148242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148268 */     // MIs[0] round
     /* 2148268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148271 */     // MIs[0] policy
     /* 2148271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148281 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2148284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148307 */     // GIR_Coverage, 17823,
     /* 2148307 */     GIR_EraseRootFromParent_Done,
     /* 2148308 */   // Label 28375: @2148308
     /* 2148308 */   GIM_Try, /*On fail goto*//*Label 28376*/ GIMT_Encode4(2148399), // Rule ID 17826 //
     /* 2148313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2148316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2148324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2148327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2148333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148359 */     // MIs[0] round
     /* 2148359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148362 */     // MIs[0] policy
     /* 2148362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148372 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2148375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148398 */     // GIR_Coverage, 17826,
     /* 2148398 */     GIR_EraseRootFromParent_Done,
     /* 2148399 */   // Label 28376: @2148399
     /* 2148399 */   GIM_Try, /*On fail goto*//*Label 28377*/ GIMT_Encode4(2148490), // Rule ID 17827 //
     /* 2148404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2148407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2148415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2148418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2148424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148450 */     // MIs[0] round
     /* 2148450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148453 */     // MIs[0] policy
     /* 2148453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148463 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2148466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148489 */     // GIR_Coverage, 17827,
     /* 2148489 */     GIR_EraseRootFromParent_Done,
     /* 2148490 */   // Label 28377: @2148490
     /* 2148490 */   GIM_Try, /*On fail goto*//*Label 28378*/ GIMT_Encode4(2148581), // Rule ID 17830 //
     /* 2148495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2148498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2148506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2148509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2148515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148541 */     // MIs[0] round
     /* 2148541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148544 */     // MIs[0] policy
     /* 2148544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148554 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2148557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148580 */     // GIR_Coverage, 17830,
     /* 2148580 */     GIR_EraseRootFromParent_Done,
     /* 2148581 */   // Label 28378: @2148581
     /* 2148581 */   GIM_Try, /*On fail goto*//*Label 28379*/ GIMT_Encode4(2148672), // Rule ID 17831 //
     /* 2148586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2148597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2148600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2148606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148632 */     // MIs[0] round
     /* 2148632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148635 */     // MIs[0] policy
     /* 2148635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148645 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2148648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148671 */     // GIR_Coverage, 17831,
     /* 2148671 */     GIR_EraseRootFromParent_Done,
     /* 2148672 */   // Label 28379: @2148672
     /* 2148672 */   GIM_Try, /*On fail goto*//*Label 28380*/ GIMT_Encode4(2148763), // Rule ID 17834 //
     /* 2148677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2148680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2148688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2148691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2148697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148723 */     // MIs[0] round
     /* 2148723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148726 */     // MIs[0] policy
     /* 2148726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148736 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2148739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148762 */     // GIR_Coverage, 17834,
     /* 2148762 */     GIR_EraseRootFromParent_Done,
     /* 2148763 */   // Label 28380: @2148763
     /* 2148763 */   GIM_Try, /*On fail goto*//*Label 28381*/ GIMT_Encode4(2148854), // Rule ID 17835 //
     /* 2148768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2148771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2148779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2148782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2148788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148814 */     // MIs[0] round
     /* 2148814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148817 */     // MIs[0] policy
     /* 2148817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148827 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2148830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148853 */     // GIR_Coverage, 17835,
     /* 2148853 */     GIR_EraseRootFromParent_Done,
     /* 2148854 */   // Label 28381: @2148854
     /* 2148854 */   GIM_Try, /*On fail goto*//*Label 28382*/ GIMT_Encode4(2148945), // Rule ID 17838 //
     /* 2148859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2148862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2148870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2148873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2148876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2148879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2148897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148905 */     // MIs[0] round
     /* 2148905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148908 */     // MIs[0] policy
     /* 2148908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148918 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2148921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148944 */     // GIR_Coverage, 17838,
     /* 2148944 */     GIR_EraseRootFromParent_Done,
     /* 2148945 */   // Label 28382: @2148945
     /* 2148945 */   GIM_Try, /*On fail goto*//*Label 28383*/ GIMT_Encode4(2149036), // Rule ID 17839 //
     /* 2148950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2148953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2148961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2148964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2148967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2148970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2148988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148996 */     // MIs[0] round
     /* 2148996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148999 */     // MIs[0] policy
     /* 2148999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149009 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2149012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2149032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149035 */     // GIR_Coverage, 17839,
     /* 2149035 */     GIR_EraseRootFromParent_Done,
     /* 2149036 */   // Label 28383: @2149036
     /* 2149036 */   GIM_Try, /*On fail goto*//*Label 28384*/ GIMT_Encode4(2149127), // Rule ID 17842 //
     /* 2149041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2149052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2149055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2149061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149087 */     // MIs[0] round
     /* 2149087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149090 */     // MIs[0] policy
     /* 2149090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149100 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2149103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149126 */     // GIR_Coverage, 17842,
     /* 2149126 */     GIR_EraseRootFromParent_Done,
     /* 2149127 */   // Label 28384: @2149127
     /* 2149127 */   GIM_Try, /*On fail goto*//*Label 28385*/ GIMT_Encode4(2149218), // Rule ID 17843 //
     /* 2149132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2149143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2149146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2149152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149178 */     // MIs[0] round
     /* 2149178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149181 */     // MIs[0] policy
     /* 2149181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149191 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2149194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149217 */     // GIR_Coverage, 17843,
     /* 2149217 */     GIR_EraseRootFromParent_Done,
     /* 2149218 */   // Label 28385: @2149218
     /* 2149218 */   GIM_Try, /*On fail goto*//*Label 28386*/ GIMT_Encode4(2149309), // Rule ID 17846 //
     /* 2149223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2149234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2149243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2149246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149269 */     // MIs[0] round
     /* 2149269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149272 */     // MIs[0] policy
     /* 2149272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149282 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2149285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149308 */     // GIR_Coverage, 17846,
     /* 2149308 */     GIR_EraseRootFromParent_Done,
     /* 2149309 */   // Label 28386: @2149309
     /* 2149309 */   GIM_Try, /*On fail goto*//*Label 28387*/ GIMT_Encode4(2149400), // Rule ID 17847 //
     /* 2149314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2149325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2149334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2149337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149360 */     // MIs[0] round
     /* 2149360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149363 */     // MIs[0] policy
     /* 2149363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149373 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2149376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149399 */     // GIR_Coverage, 17847,
     /* 2149399 */     GIR_EraseRootFromParent_Done,
     /* 2149400 */   // Label 28387: @2149400
     /* 2149400 */   GIM_Try, /*On fail goto*//*Label 28388*/ GIMT_Encode4(2149491), // Rule ID 17850 //
     /* 2149405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2149416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2149419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2149425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2149428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149451 */     // MIs[0] round
     /* 2149451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149454 */     // MIs[0] policy
     /* 2149454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149464 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2149467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149490 */     // GIR_Coverage, 17850,
     /* 2149490 */     GIR_EraseRootFromParent_Done,
     /* 2149491 */   // Label 28388: @2149491
     /* 2149491 */   GIM_Try, /*On fail goto*//*Label 28389*/ GIMT_Encode4(2149582), // Rule ID 17851 //
     /* 2149496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2149507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2149510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2149516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2149519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149542 */     // MIs[0] round
     /* 2149542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149545 */     // MIs[0] policy
     /* 2149545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149555 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2149558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149581 */     // GIR_Coverage, 17851,
     /* 2149581 */     GIR_EraseRootFromParent_Done,
     /* 2149582 */   // Label 28389: @2149582
     /* 2149582 */   GIM_Try, /*On fail goto*//*Label 28390*/ GIMT_Encode4(2149673), // Rule ID 17854 //
     /* 2149587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2149598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2149601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2149607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2149610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149633 */     // MIs[0] round
     /* 2149633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149636 */     // MIs[0] policy
     /* 2149636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149646 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2149649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149672 */     // GIR_Coverage, 17854,
     /* 2149672 */     GIR_EraseRootFromParent_Done,
     /* 2149673 */   // Label 28390: @2149673
     /* 2149673 */   GIM_Try, /*On fail goto*//*Label 28391*/ GIMT_Encode4(2149764), // Rule ID 17855 //
     /* 2149678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2149681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2149689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2149692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2149698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2149701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149724 */     // MIs[0] round
     /* 2149724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149727 */     // MIs[0] policy
     /* 2149727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149737 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2149740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149763 */     // GIR_Coverage, 17855,
     /* 2149763 */     GIR_EraseRootFromParent_Done,
     /* 2149764 */   // Label 28391: @2149764
     /* 2149764 */   GIM_Try, /*On fail goto*//*Label 28392*/ GIMT_Encode4(2149855), // Rule ID 17858 //
     /* 2149769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2149780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2149783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2149789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149815 */     // MIs[0] round
     /* 2149815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149818 */     // MIs[0] policy
     /* 2149818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149828 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2149831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149854 */     // GIR_Coverage, 17858,
     /* 2149854 */     GIR_EraseRootFromParent_Done,
     /* 2149855 */   // Label 28392: @2149855
     /* 2149855 */   GIM_Try, /*On fail goto*//*Label 28393*/ GIMT_Encode4(2149946), // Rule ID 17859 //
     /* 2149860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2149863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2149871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2149874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2149880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149906 */     // MIs[0] round
     /* 2149906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149909 */     // MIs[0] policy
     /* 2149909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149919 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2149922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149945 */     // GIR_Coverage, 17859,
     /* 2149945 */     GIR_EraseRootFromParent_Done,
     /* 2149946 */   // Label 28393: @2149946
     /* 2149946 */   GIM_Try, /*On fail goto*//*Label 28394*/ GIMT_Encode4(2150037), // Rule ID 17862 //
     /* 2149951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2149962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2149965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2149971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2149974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149997 */     // MIs[0] round
     /* 2149997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150000 */     // MIs[0] policy
     /* 2150000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150010 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2150013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150036 */     // GIR_Coverage, 17862,
     /* 2150036 */     GIR_EraseRootFromParent_Done,
     /* 2150037 */   // Label 28394: @2150037
     /* 2150037 */   GIM_Try, /*On fail goto*//*Label 28395*/ GIMT_Encode4(2150128), // Rule ID 17863 //
     /* 2150042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2150045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2150053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2150056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2150062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2150065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150088 */     // MIs[0] round
     /* 2150088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150091 */     // MIs[0] policy
     /* 2150091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150101 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2150104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150127 */     // GIR_Coverage, 17863,
     /* 2150127 */     GIR_EraseRootFromParent_Done,
     /* 2150128 */   // Label 28395: @2150128
     /* 2150128 */   GIM_Try, /*On fail goto*//*Label 28396*/ GIMT_Encode4(2150219), // Rule ID 17866 //
     /* 2150133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2150144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2150147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2150153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150179 */     // MIs[0] round
     /* 2150179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150182 */     // MIs[0] policy
     /* 2150182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150192 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2150195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150218 */     // GIR_Coverage, 17866,
     /* 2150218 */     GIR_EraseRootFromParent_Done,
     /* 2150219 */   // Label 28396: @2150219
     /* 2150219 */   GIM_Try, /*On fail goto*//*Label 28397*/ GIMT_Encode4(2150310), // Rule ID 17867 //
     /* 2150224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2150235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2150238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2150244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150270 */     // MIs[0] round
     /* 2150270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150273 */     // MIs[0] policy
     /* 2150273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150283 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2150286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150296 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150306 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150309 */     // GIR_Coverage, 17867,
     /* 2150309 */     GIR_EraseRootFromParent_Done,
     /* 2150310 */   // Label 28397: @2150310
     /* 2150310 */   GIM_Try, /*On fail goto*//*Label 28398*/ GIMT_Encode4(2150401), // Rule ID 17870 //
     /* 2150315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2150326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2150329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2150335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150361 */     // MIs[0] round
     /* 2150361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150364 */     // MIs[0] policy
     /* 2150364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150374 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2150377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150400 */     // GIR_Coverage, 17870,
     /* 2150400 */     GIR_EraseRootFromParent_Done,
     /* 2150401 */   // Label 28398: @2150401
     /* 2150401 */   GIM_Try, /*On fail goto*//*Label 28399*/ GIMT_Encode4(2150492), // Rule ID 17871 //
     /* 2150406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2150417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2150420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2150426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150452 */     // MIs[0] round
     /* 2150452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150455 */     // MIs[0] policy
     /* 2150455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150465 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2150468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150491 */     // GIR_Coverage, 17871,
     /* 2150491 */     GIR_EraseRootFromParent_Done,
     /* 2150492 */   // Label 28399: @2150492
     /* 2150492 */   GIM_Try, /*On fail goto*//*Label 28400*/ GIMT_Encode4(2150583), // Rule ID 17874 //
     /* 2150497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2150508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2150511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2150517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150543 */     // MIs[0] round
     /* 2150543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150546 */     // MIs[0] policy
     /* 2150546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150556 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2150559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150582 */     // GIR_Coverage, 17874,
     /* 2150582 */     GIR_EraseRootFromParent_Done,
     /* 2150583 */   // Label 28400: @2150583
     /* 2150583 */   GIM_Try, /*On fail goto*//*Label 28401*/ GIMT_Encode4(2150674), // Rule ID 17875 //
     /* 2150588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2150599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2150602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2150608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150634 */     // MIs[0] round
     /* 2150634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150637 */     // MIs[0] policy
     /* 2150637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150647 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2150650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150673 */     // GIR_Coverage, 17875,
     /* 2150673 */     GIR_EraseRootFromParent_Done,
     /* 2150674 */   // Label 28401: @2150674
     /* 2150674 */   GIM_Try, /*On fail goto*//*Label 28402*/ GIMT_Encode4(2150765), // Rule ID 17878 //
     /* 2150679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2150682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2150687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2150690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2150693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2150696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2150699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2150702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150725 */     // MIs[0] round
     /* 2150725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150728 */     // MIs[0] policy
     /* 2150728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150738 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2150741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150764 */     // GIR_Coverage, 17878,
     /* 2150764 */     GIR_EraseRootFromParent_Done,
     /* 2150765 */   // Label 28402: @2150765
     /* 2150765 */   GIM_Try, /*On fail goto*//*Label 28403*/ GIMT_Encode4(2150856), // Rule ID 17879 //
     /* 2150770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2150773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2150778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2150781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2150784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2150787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2150790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2150793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150816 */     // MIs[0] round
     /* 2150816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150819 */     // MIs[0] policy
     /* 2150819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150829 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2150832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150855 */     // GIR_Coverage, 17879,
     /* 2150855 */     GIR_EraseRootFromParent_Done,
     /* 2150856 */   // Label 28403: @2150856
     /* 2150856 */   GIM_Try, /*On fail goto*//*Label 28404*/ GIMT_Encode4(2150947), // Rule ID 17882 //
     /* 2150861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2150864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2150869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2150872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2150875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2150878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2150881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150907 */     // MIs[0] round
     /* 2150907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150910 */     // MIs[0] policy
     /* 2150910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150920 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2150923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150946 */     // GIR_Coverage, 17882,
     /* 2150946 */     GIR_EraseRootFromParent_Done,
     /* 2150947 */   // Label 28404: @2150947
     /* 2150947 */   GIM_Try, /*On fail goto*//*Label 28405*/ GIMT_Encode4(2151038), // Rule ID 17883 //
     /* 2150952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2150955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2150960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2150963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2150966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2150969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2150972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150975 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150998 */     // MIs[0] round
     /* 2150998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151001 */     // MIs[0] policy
     /* 2151001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151011 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2151014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151037 */     // GIR_Coverage, 17883,
     /* 2151037 */     GIR_EraseRootFromParent_Done,
     /* 2151038 */   // Label 28405: @2151038
     /* 2151038 */   GIM_Try, /*On fail goto*//*Label 28406*/ GIMT_Encode4(2151129), // Rule ID 17886 //
     /* 2151043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2151046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2151054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2151057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2151060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2151063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151089 */     // MIs[0] round
     /* 2151089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151092 */     // MIs[0] policy
     /* 2151092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151102 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2151105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151128 */     // GIR_Coverage, 17886,
     /* 2151128 */     GIR_EraseRootFromParent_Done,
     /* 2151129 */   // Label 28406: @2151129
     /* 2151129 */   GIM_Try, /*On fail goto*//*Label 28407*/ GIMT_Encode4(2151220), // Rule ID 17887 //
     /* 2151134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2151137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2151145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2151148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2151151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2151154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151180 */     // MIs[0] round
     /* 2151180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151183 */     // MIs[0] policy
     /* 2151183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151193 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2151196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151206 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151216 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151219 */     // GIR_Coverage, 17887,
     /* 2151219 */     GIR_EraseRootFromParent_Done,
     /* 2151220 */   // Label 28407: @2151220
     /* 2151220 */   GIM_Try, /*On fail goto*//*Label 28408*/ GIMT_Encode4(2151311), // Rule ID 17890 //
     /* 2151225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2151236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2151239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2151242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2151245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151271 */     // MIs[0] round
     /* 2151271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151274 */     // MIs[0] policy
     /* 2151274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151284 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2151287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151307 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151310 */     // GIR_Coverage, 17890,
     /* 2151310 */     GIR_EraseRootFromParent_Done,
     /* 2151311 */   // Label 28408: @2151311
     /* 2151311 */   GIM_Try, /*On fail goto*//*Label 28409*/ GIMT_Encode4(2151402), // Rule ID 17891 //
     /* 2151316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2151327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2151330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2151333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2151336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151362 */     // MIs[0] round
     /* 2151362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151365 */     // MIs[0] policy
     /* 2151365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151375 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2151378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151401 */     // GIR_Coverage, 17891,
     /* 2151401 */     GIR_EraseRootFromParent_Done,
     /* 2151402 */   // Label 28409: @2151402
     /* 2151402 */   GIM_Try, /*On fail goto*//*Label 28410*/ GIMT_Encode4(2151493), // Rule ID 17894 //
     /* 2151407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2151410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2151418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2151421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2151424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2151427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151453 */     // MIs[0] round
     /* 2151453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151456 */     // MIs[0] policy
     /* 2151456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151466 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2151469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151492 */     // GIR_Coverage, 17894,
     /* 2151492 */     GIR_EraseRootFromParent_Done,
     /* 2151493 */   // Label 28410: @2151493
     /* 2151493 */   GIM_Try, /*On fail goto*//*Label 28411*/ GIMT_Encode4(2151584), // Rule ID 17895 //
     /* 2151498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2151501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2151509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2151512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2151515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2151518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151544 */     // MIs[0] round
     /* 2151544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151547 */     // MIs[0] policy
     /* 2151547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151557 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2151560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151583 */     // GIR_Coverage, 17895,
     /* 2151583 */     GIR_EraseRootFromParent_Done,
     /* 2151584 */   // Label 28411: @2151584
     /* 2151584 */   GIM_Try, /*On fail goto*//*Label 28412*/ GIMT_Encode4(2151675), // Rule ID 17898 //
     /* 2151589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2151592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2151600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2151603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2151606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2151609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151635 */     // MIs[0] round
     /* 2151635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151638 */     // MIs[0] policy
     /* 2151638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151648 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2151651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151674 */     // GIR_Coverage, 17898,
     /* 2151674 */     GIR_EraseRootFromParent_Done,
     /* 2151675 */   // Label 28412: @2151675
     /* 2151675 */   GIM_Try, /*On fail goto*//*Label 28413*/ GIMT_Encode4(2151766), // Rule ID 17899 //
     /* 2151680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2151683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2151691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2151694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2151697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2151700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151726 */     // MIs[0] round
     /* 2151726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151729 */     // MIs[0] policy
     /* 2151729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151739 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2151742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151765 */     // GIR_Coverage, 17899,
     /* 2151765 */     GIR_EraseRootFromParent_Done,
     /* 2151766 */   // Label 28413: @2151766
     /* 2151766 */   GIM_Try, /*On fail goto*//*Label 28414*/ GIMT_Encode4(2151857), // Rule ID 17902 //
     /* 2151771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2151782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2151785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2151788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2151791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2151801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151817 */     // MIs[0] round
     /* 2151817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151820 */     // MIs[0] policy
     /* 2151820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151830 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2151833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151856 */     // GIR_Coverage, 17902,
     /* 2151856 */     GIR_EraseRootFromParent_Done,
     /* 2151857 */   // Label 28414: @2151857
     /* 2151857 */   GIM_Try, /*On fail goto*//*Label 28415*/ GIMT_Encode4(2151948), // Rule ID 17903 //
     /* 2151862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2151873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2151876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2151879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2151882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2151892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151908 */     // MIs[0] round
     /* 2151908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151911 */     // MIs[0] policy
     /* 2151911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151921 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2151924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151947 */     // GIR_Coverage, 17903,
     /* 2151947 */     GIR_EraseRootFromParent_Done,
     /* 2151948 */   // Label 28415: @2151948
     /* 2151948 */   GIM_Try, /*On fail goto*//*Label 28416*/ GIMT_Encode4(2152039), // Rule ID 17906 //
     /* 2151953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2151964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2151967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2151970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2151973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2151976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2151983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151999 */     // MIs[0] round
     /* 2151999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152002 */     // MIs[0] policy
     /* 2152002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152012 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2152015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152038 */     // GIR_Coverage, 17906,
     /* 2152038 */     GIR_EraseRootFromParent_Done,
     /* 2152039 */   // Label 28416: @2152039
     /* 2152039 */   GIM_Try, /*On fail goto*//*Label 28417*/ GIMT_Encode4(2152130), // Rule ID 17907 //
     /* 2152044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2152055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2152058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2152061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2152064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2152067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152090 */     // MIs[0] round
     /* 2152090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152093 */     // MIs[0] policy
     /* 2152093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152103 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2152106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152129 */     // GIR_Coverage, 17907,
     /* 2152129 */     GIR_EraseRootFromParent_Done,
     /* 2152130 */   // Label 28417: @2152130
     /* 2152130 */   GIM_Try, /*On fail goto*//*Label 28418*/ GIMT_Encode4(2152221), // Rule ID 17910 //
     /* 2152135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2152138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2152146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2152149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2152152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2152155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2152158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152181 */     // MIs[0] round
     /* 2152181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152184 */     // MIs[0] policy
     /* 2152184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152194 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2152197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152220 */     // GIR_Coverage, 17910,
     /* 2152220 */     GIR_EraseRootFromParent_Done,
     /* 2152221 */   // Label 28418: @2152221
     /* 2152221 */   GIM_Try, /*On fail goto*//*Label 28419*/ GIMT_Encode4(2152312), // Rule ID 17911 //
     /* 2152226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2152237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2152240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2152243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2152246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2152249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152272 */     // MIs[0] round
     /* 2152272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152275 */     // MIs[0] policy
     /* 2152275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152285 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2152288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152311 */     // GIR_Coverage, 17911,
     /* 2152311 */     GIR_EraseRootFromParent_Done,
     /* 2152312 */   // Label 28419: @2152312
     /* 2152312 */   GIM_Try, /*On fail goto*//*Label 28420*/ GIMT_Encode4(2152403), // Rule ID 17914 //
     /* 2152317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2152328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2152331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2152334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2152337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152363 */     // MIs[0] round
     /* 2152363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152366 */     // MIs[0] policy
     /* 2152366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152376 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2152379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152402 */     // GIR_Coverage, 17914,
     /* 2152402 */     GIR_EraseRootFromParent_Done,
     /* 2152403 */   // Label 28420: @2152403
     /* 2152403 */   GIM_Try, /*On fail goto*//*Label 28421*/ GIMT_Encode4(2152494), // Rule ID 17915 //
     /* 2152408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2152419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2152422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2152425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2152428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152454 */     // MIs[0] round
     /* 2152454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152457 */     // MIs[0] policy
     /* 2152457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152467 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2152470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152493 */     // GIR_Coverage, 17915,
     /* 2152493 */     GIR_EraseRootFromParent_Done,
     /* 2152494 */   // Label 28421: @2152494
     /* 2152494 */   GIM_Try, /*On fail goto*//*Label 28422*/ GIMT_Encode4(2152585), // Rule ID 17918 //
     /* 2152499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2152510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2152513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2152516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2152519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152545 */     // MIs[0] round
     /* 2152545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152548 */     // MIs[0] policy
     /* 2152548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152558 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2152561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152584 */     // GIR_Coverage, 17918,
     /* 2152584 */     GIR_EraseRootFromParent_Done,
     /* 2152585 */   // Label 28422: @2152585
     /* 2152585 */   GIM_Try, /*On fail goto*//*Label 28423*/ GIMT_Encode4(2152676), // Rule ID 17919 //
     /* 2152590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2152601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2152604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2152607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2152610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152636 */     // MIs[0] round
     /* 2152636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152639 */     // MIs[0] policy
     /* 2152639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152649 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2152652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152675 */     // GIR_Coverage, 17919,
     /* 2152675 */     GIR_EraseRootFromParent_Done,
     /* 2152676 */   // Label 28423: @2152676
     /* 2152676 */   GIM_Try, /*On fail goto*//*Label 28424*/ GIMT_Encode4(2152767), // Rule ID 17922 //
     /* 2152681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2152692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2152695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2152698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2152701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2152704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152727 */     // MIs[0] round
     /* 2152727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152730 */     // MIs[0] policy
     /* 2152730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152740 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2152743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152766 */     // GIR_Coverage, 17922,
     /* 2152766 */     GIR_EraseRootFromParent_Done,
     /* 2152767 */   // Label 28424: @2152767
     /* 2152767 */   GIM_Try, /*On fail goto*//*Label 28425*/ GIMT_Encode4(2152858), // Rule ID 17923 //
     /* 2152772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2152783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2152786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2152789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2152792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2152795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152818 */     // MIs[0] round
     /* 2152818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152821 */     // MIs[0] policy
     /* 2152821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152831 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2152834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152857 */     // GIR_Coverage, 17923,
     /* 2152857 */     GIR_EraseRootFromParent_Done,
     /* 2152858 */   // Label 28425: @2152858
     /* 2152858 */   GIM_Try, /*On fail goto*//*Label 28426*/ GIMT_Encode4(2152949), // Rule ID 17926 //
     /* 2152863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2152866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2152874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2152877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2152880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2152883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2152886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152909 */     // MIs[0] round
     /* 2152909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152912 */     // MIs[0] policy
     /* 2152912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152922 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2152925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152948 */     // GIR_Coverage, 17926,
     /* 2152948 */     GIR_EraseRootFromParent_Done,
     /* 2152949 */   // Label 28426: @2152949
     /* 2152949 */   GIM_Try, /*On fail goto*//*Label 28427*/ GIMT_Encode4(2153040), // Rule ID 17927 //
     /* 2152954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2152957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2152965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2152968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2152971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2152974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2152977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153000 */     // MIs[0] round
     /* 2153000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153003 */     // MIs[0] policy
     /* 2153003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153013 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2153016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153039 */     // GIR_Coverage, 17927,
     /* 2153039 */     GIR_EraseRootFromParent_Done,
     /* 2153040 */   // Label 28427: @2153040
     /* 2153040 */   GIM_Try, /*On fail goto*//*Label 28428*/ GIMT_Encode4(2153131), // Rule ID 17930 //
     /* 2153045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2153048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2153056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2153059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2153062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2153065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153091 */     // MIs[0] round
     /* 2153091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153094 */     // MIs[0] policy
     /* 2153094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153104 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2153107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153130 */     // GIR_Coverage, 17930,
     /* 2153130 */     GIR_EraseRootFromParent_Done,
     /* 2153131 */   // Label 28428: @2153131
     /* 2153131 */   GIM_Try, /*On fail goto*//*Label 28429*/ GIMT_Encode4(2153222), // Rule ID 17931 //
     /* 2153136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2153139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2153147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2153150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2153153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2153156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153182 */     // MIs[0] round
     /* 2153182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153185 */     // MIs[0] policy
     /* 2153185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153195 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2153198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153221 */     // GIR_Coverage, 17931,
     /* 2153221 */     GIR_EraseRootFromParent_Done,
     /* 2153222 */   // Label 28429: @2153222
     /* 2153222 */   GIM_Try, /*On fail goto*//*Label 28430*/ GIMT_Encode4(2153313), // Rule ID 17934 //
     /* 2153227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2153230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2153238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2153241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2153244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2153247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153273 */     // MIs[0] round
     /* 2153273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153276 */     // MIs[0] policy
     /* 2153276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153286 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2153289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153312 */     // GIR_Coverage, 17934,
     /* 2153312 */     GIR_EraseRootFromParent_Done,
     /* 2153313 */   // Label 28430: @2153313
     /* 2153313 */   GIM_Try, /*On fail goto*//*Label 28431*/ GIMT_Encode4(2153404), // Rule ID 17935 //
     /* 2153318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2153321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2153329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2153332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2153335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2153338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153364 */     // MIs[0] round
     /* 2153364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153367 */     // MIs[0] policy
     /* 2153367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153377 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2153380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153403 */     // GIR_Coverage, 17935,
     /* 2153403 */     GIR_EraseRootFromParent_Done,
     /* 2153404 */   // Label 28431: @2153404
     /* 2153404 */   GIM_Try, /*On fail goto*//*Label 28432*/ GIMT_Encode4(2153495), // Rule ID 17938 //
     /* 2153409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2153420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2153423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2153429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153455 */     // MIs[0] round
     /* 2153455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153458 */     // MIs[0] policy
     /* 2153458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153468 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2153471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153494 */     // GIR_Coverage, 17938,
     /* 2153494 */     GIR_EraseRootFromParent_Done,
     /* 2153495 */   // Label 28432: @2153495
     /* 2153495 */   GIM_Try, /*On fail goto*//*Label 28433*/ GIMT_Encode4(2153586), // Rule ID 17939 //
     /* 2153500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2153511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2153514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2153520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153546 */     // MIs[0] round
     /* 2153546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153549 */     // MIs[0] policy
     /* 2153549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153559 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2153562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153585 */     // GIR_Coverage, 17939,
     /* 2153585 */     GIR_EraseRootFromParent_Done,
     /* 2153586 */   // Label 28433: @2153586
     /* 2153586 */   GIM_Try, /*On fail goto*//*Label 28434*/ GIMT_Encode4(2153677), // Rule ID 17942 //
     /* 2153591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2153602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2153605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2153611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2153614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153637 */     // MIs[0] round
     /* 2153637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153640 */     // MIs[0] policy
     /* 2153640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153650 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2153653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153676 */     // GIR_Coverage, 17942,
     /* 2153676 */     GIR_EraseRootFromParent_Done,
     /* 2153677 */   // Label 28434: @2153677
     /* 2153677 */   GIM_Try, /*On fail goto*//*Label 28435*/ GIMT_Encode4(2153768), // Rule ID 17943 //
     /* 2153682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2153693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2153696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2153702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2153705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153728 */     // MIs[0] round
     /* 2153728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153731 */     // MIs[0] policy
     /* 2153731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153741 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2153744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153767 */     // GIR_Coverage, 17943,
     /* 2153767 */     GIR_EraseRootFromParent_Done,
     /* 2153768 */   // Label 28435: @2153768
     /* 2153768 */   GIM_Try, /*On fail goto*//*Label 28436*/ GIMT_Encode4(2153859), // Rule ID 17946 //
     /* 2153773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2153776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2153784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2153787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2153793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153819 */     // MIs[0] round
     /* 2153819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153822 */     // MIs[0] policy
     /* 2153822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153832 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2153835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153858 */     // GIR_Coverage, 17946,
     /* 2153858 */     GIR_EraseRootFromParent_Done,
     /* 2153859 */   // Label 28436: @2153859
     /* 2153859 */   GIM_Try, /*On fail goto*//*Label 28437*/ GIMT_Encode4(2153950), // Rule ID 17947 //
     /* 2153864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2153867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2153875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2153878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2153884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153910 */     // MIs[0] round
     /* 2153910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153913 */     // MIs[0] policy
     /* 2153913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153923 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2153926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153936 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153946 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153949 */     // GIR_Coverage, 17947,
     /* 2153949 */     GIR_EraseRootFromParent_Done,
     /* 2153950 */   // Label 28437: @2153950
     /* 2153950 */   GIM_Try, /*On fail goto*//*Label 28438*/ GIMT_Encode4(2154041), // Rule ID 17950 //
     /* 2153955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2153966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2153969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2153975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154001 */     // MIs[0] round
     /* 2154001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154004 */     // MIs[0] policy
     /* 2154004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154014 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2154017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154040 */     // GIR_Coverage, 17950,
     /* 2154040 */     GIR_EraseRootFromParent_Done,
     /* 2154041 */   // Label 28438: @2154041
     /* 2154041 */   GIM_Try, /*On fail goto*//*Label 28439*/ GIMT_Encode4(2154132), // Rule ID 17951 //
     /* 2154046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2154057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2154060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2154066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2154069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154092 */     // MIs[0] round
     /* 2154092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154095 */     // MIs[0] policy
     /* 2154095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154105 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2154108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154131 */     // GIR_Coverage, 17951,
     /* 2154131 */     GIR_EraseRootFromParent_Done,
     /* 2154132 */   // Label 28439: @2154132
     /* 2154132 */   GIM_Try, /*On fail goto*//*Label 28440*/ GIMT_Encode4(2154223), // Rule ID 17954 //
     /* 2154137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2154140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2154148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2154151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2154157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154183 */     // MIs[0] round
     /* 2154183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154186 */     // MIs[0] policy
     /* 2154186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154196 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2154199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154222 */     // GIR_Coverage, 17954,
     /* 2154222 */     GIR_EraseRootFromParent_Done,
     /* 2154223 */   // Label 28440: @2154223
     /* 2154223 */   GIM_Try, /*On fail goto*//*Label 28441*/ GIMT_Encode4(2154314), // Rule ID 17955 //
     /* 2154228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2154231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2154239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2154242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2154248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154274 */     // MIs[0] round
     /* 2154274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154277 */     // MIs[0] policy
     /* 2154277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154287 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2154290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154313 */     // GIR_Coverage, 17955,
     /* 2154313 */     GIR_EraseRootFromParent_Done,
     /* 2154314 */   // Label 28441: @2154314
     /* 2154314 */   GIM_Try, /*On fail goto*//*Label 28442*/ GIMT_Encode4(2154405), // Rule ID 17958 //
     /* 2154319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2154322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2154330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2154339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154365 */     // MIs[0] round
     /* 2154365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154368 */     // MIs[0] policy
     /* 2154368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154378 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2154381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154404 */     // GIR_Coverage, 17958,
     /* 2154404 */     GIR_EraseRootFromParent_Done,
     /* 2154405 */   // Label 28442: @2154405
     /* 2154405 */   GIM_Try, /*On fail goto*//*Label 28443*/ GIMT_Encode4(2154496), // Rule ID 17959 //
     /* 2154410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2154413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2154421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2154430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154456 */     // MIs[0] round
     /* 2154456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154459 */     // MIs[0] policy
     /* 2154459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154469 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2154472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154495 */     // GIR_Coverage, 17959,
     /* 2154495 */     GIR_EraseRootFromParent_Done,
     /* 2154496 */   // Label 28443: @2154496
     /* 2154496 */   GIM_Try, /*On fail goto*//*Label 28444*/ GIMT_Encode4(2154587), // Rule ID 17962 //
     /* 2154501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2154512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2154515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2154521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2154524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2154531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154547 */     // MIs[0] round
     /* 2154547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154550 */     // MIs[0] policy
     /* 2154550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154560 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2154563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154586 */     // GIR_Coverage, 17962,
     /* 2154586 */     GIR_EraseRootFromParent_Done,
     /* 2154587 */   // Label 28444: @2154587
     /* 2154587 */   GIM_Try, /*On fail goto*//*Label 28445*/ GIMT_Encode4(2154678), // Rule ID 17963 //
     /* 2154592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2154603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2154606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2154612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2154615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2154622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154638 */     // MIs[0] round
     /* 2154638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154641 */     // MIs[0] policy
     /* 2154641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154651 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2154654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154677 */     // GIR_Coverage, 17963,
     /* 2154677 */     GIR_EraseRootFromParent_Done,
     /* 2154678 */   // Label 28445: @2154678
     /* 2154678 */   GIM_Try, /*On fail goto*//*Label 28446*/ GIMT_Encode4(2154769), // Rule ID 17966 //
     /* 2154683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2154694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2154697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2154703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2154706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2154713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154729 */     // MIs[0] round
     /* 2154729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154732 */     // MIs[0] policy
     /* 2154732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154742 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2154745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154768 */     // GIR_Coverage, 17966,
     /* 2154768 */     GIR_EraseRootFromParent_Done,
     /* 2154769 */   // Label 28446: @2154769
     /* 2154769 */   GIM_Try, /*On fail goto*//*Label 28447*/ GIMT_Encode4(2154860), // Rule ID 17967 //
     /* 2154774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2154785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2154788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2154794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2154797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2154804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154820 */     // MIs[0] round
     /* 2154820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154823 */     // MIs[0] policy
     /* 2154823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154833 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2154836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154859 */     // GIR_Coverage, 17967,
     /* 2154859 */     GIR_EraseRootFromParent_Done,
     /* 2154860 */   // Label 28447: @2154860
     /* 2154860 */   GIM_Try, /*On fail goto*//*Label 28448*/ GIMT_Encode4(2154951), // Rule ID 17970 //
     /* 2154865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2154876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2154879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2154885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2154888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2154895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154911 */     // MIs[0] round
     /* 2154911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154914 */     // MIs[0] policy
     /* 2154914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154924 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2154927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154950 */     // GIR_Coverage, 17970,
     /* 2154950 */     GIR_EraseRootFromParent_Done,
     /* 2154951 */   // Label 28448: @2154951
     /* 2154951 */   GIM_Try, /*On fail goto*//*Label 28449*/ GIMT_Encode4(2155042), // Rule ID 17971 //
     /* 2154956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2154967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2154970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2154976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2154979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2154986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155002 */     // MIs[0] round
     /* 2155002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155005 */     // MIs[0] policy
     /* 2155005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155015 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2155018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155041 */     // GIR_Coverage, 17971,
     /* 2155041 */     GIR_EraseRootFromParent_Done,
     /* 2155042 */   // Label 28449: @2155042
     /* 2155042 */   GIM_Try, /*On fail goto*//*Label 28450*/ GIMT_Encode4(2155133), // Rule ID 17974 //
     /* 2155047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2155058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2155061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2155067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155093 */     // MIs[0] round
     /* 2155093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155096 */     // MIs[0] policy
     /* 2155096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155106 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2155109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155132 */     // GIR_Coverage, 17974,
     /* 2155132 */     GIR_EraseRootFromParent_Done,
     /* 2155133 */   // Label 28450: @2155133
     /* 2155133 */   GIM_Try, /*On fail goto*//*Label 28451*/ GIMT_Encode4(2155224), // Rule ID 17975 //
     /* 2155138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2155149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2155152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2155158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155184 */     // MIs[0] round
     /* 2155184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155187 */     // MIs[0] policy
     /* 2155187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155197 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2155200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155223 */     // GIR_Coverage, 17975,
     /* 2155223 */     GIR_EraseRootFromParent_Done,
     /* 2155224 */   // Label 28451: @2155224
     /* 2155224 */   GIM_Try, /*On fail goto*//*Label 28452*/ GIMT_Encode4(2155315), // Rule ID 17978 //
     /* 2155229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2155240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2155243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2155249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155275 */     // MIs[0] round
     /* 2155275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155278 */     // MIs[0] policy
     /* 2155278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155288 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2155291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155314 */     // GIR_Coverage, 17978,
     /* 2155314 */     GIR_EraseRootFromParent_Done,
     /* 2155315 */   // Label 28452: @2155315
     /* 2155315 */   GIM_Try, /*On fail goto*//*Label 28453*/ GIMT_Encode4(2155406), // Rule ID 17979 //
     /* 2155320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2155331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2155334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2155340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155366 */     // MIs[0] round
     /* 2155366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155369 */     // MIs[0] policy
     /* 2155369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155379 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2155382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155405 */     // GIR_Coverage, 17979,
     /* 2155405 */     GIR_EraseRootFromParent_Done,
     /* 2155406 */   // Label 28453: @2155406
     /* 2155406 */   GIM_Try, /*On fail goto*//*Label 28454*/ GIMT_Encode4(2155497), // Rule ID 17982 //
     /* 2155411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2155422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2155425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2155431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155457 */     // MIs[0] round
     /* 2155457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155460 */     // MIs[0] policy
     /* 2155460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155470 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2155473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155496 */     // GIR_Coverage, 17982,
     /* 2155496 */     GIR_EraseRootFromParent_Done,
     /* 2155497 */   // Label 28454: @2155497
     /* 2155497 */   GIM_Try, /*On fail goto*//*Label 28455*/ GIMT_Encode4(2155588), // Rule ID 17983 //
     /* 2155502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2155513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2155516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2155522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155548 */     // MIs[0] round
     /* 2155548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155551 */     // MIs[0] policy
     /* 2155551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155561 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2155564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155587 */     // GIR_Coverage, 17983,
     /* 2155587 */     GIR_EraseRootFromParent_Done,
     /* 2155588 */   // Label 28455: @2155588
     /* 2155588 */   GIM_Try, /*On fail goto*//*Label 28456*/ GIMT_Encode4(2155679), // Rule ID 17986 //
     /* 2155593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2155604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2155607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2155613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2155616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155639 */     // MIs[0] round
     /* 2155639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155642 */     // MIs[0] policy
     /* 2155642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155652 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2155655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155678 */     // GIR_Coverage, 17986,
     /* 2155678 */     GIR_EraseRootFromParent_Done,
     /* 2155679 */   // Label 28456: @2155679
     /* 2155679 */   GIM_Try, /*On fail goto*//*Label 28457*/ GIMT_Encode4(2155770), // Rule ID 17987 //
     /* 2155684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2155687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2155695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2155698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2155704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2155707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155730 */     // MIs[0] round
     /* 2155730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155733 */     // MIs[0] policy
     /* 2155733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155743 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2155746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155769 */     // GIR_Coverage, 17987,
     /* 2155769 */     GIR_EraseRootFromParent_Done,
     /* 2155770 */   // Label 28457: @2155770
     /* 2155770 */   GIM_Try, /*On fail goto*//*Label 28458*/ GIMT_Encode4(2155861), // Rule ID 17990 //
     /* 2155775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2155786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2155789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2155795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155821 */     // MIs[0] round
     /* 2155821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155824 */     // MIs[0] policy
     /* 2155824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155834 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2155837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155860 */     // GIR_Coverage, 17990,
     /* 2155860 */     GIR_EraseRootFromParent_Done,
     /* 2155861 */   // Label 28458: @2155861
     /* 2155861 */   GIM_Try, /*On fail goto*//*Label 28459*/ GIMT_Encode4(2155952), // Rule ID 17991 //
     /* 2155866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2155869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2155877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2155880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2155886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155912 */     // MIs[0] round
     /* 2155912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155915 */     // MIs[0] policy
     /* 2155915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155925 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2155928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155951 */     // GIR_Coverage, 17991,
     /* 2155951 */     GIR_EraseRootFromParent_Done,
     /* 2155952 */   // Label 28459: @2155952
     /* 2155952 */   GIM_Try, /*On fail goto*//*Label 28460*/ GIMT_Encode4(2156043), // Rule ID 17994 //
     /* 2155957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2155968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2155971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2155977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156003 */     // MIs[0] round
     /* 2156003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156006 */     // MIs[0] policy
     /* 2156006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156016 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2156019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156042 */     // GIR_Coverage, 17994,
     /* 2156042 */     GIR_EraseRootFromParent_Done,
     /* 2156043 */   // Label 28460: @2156043
     /* 2156043 */   GIM_Try, /*On fail goto*//*Label 28461*/ GIMT_Encode4(2156134), // Rule ID 17995 //
     /* 2156048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2156059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2156062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2156068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2156071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2156078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156094 */     // MIs[0] round
     /* 2156094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156097 */     // MIs[0] policy
     /* 2156097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156107 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2156110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156133 */     // GIR_Coverage, 17995,
     /* 2156133 */     GIR_EraseRootFromParent_Done,
     /* 2156134 */   // Label 28461: @2156134
     /* 2156134 */   GIM_Try, /*On fail goto*//*Label 28462*/ GIMT_Encode4(2156225), // Rule ID 17998 //
     /* 2156139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2156150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2156153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2156156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2156159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156185 */     // MIs[0] round
     /* 2156185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156188 */     // MIs[0] policy
     /* 2156188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156198 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2156201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156224 */     // GIR_Coverage, 17998,
     /* 2156224 */     GIR_EraseRootFromParent_Done,
     /* 2156225 */   // Label 28462: @2156225
     /* 2156225 */   GIM_Try, /*On fail goto*//*Label 28463*/ GIMT_Encode4(2156316), // Rule ID 17999 //
     /* 2156230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2156241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2156244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2156247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2156250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156276 */     // MIs[0] round
     /* 2156276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156279 */     // MIs[0] policy
     /* 2156279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156289 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2156292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156315 */     // GIR_Coverage, 17999,
     /* 2156315 */     GIR_EraseRootFromParent_Done,
     /* 2156316 */   // Label 28463: @2156316
     /* 2156316 */   GIM_Try, /*On fail goto*//*Label 28464*/ GIMT_Encode4(2156407), // Rule ID 18002 //
     /* 2156321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2156332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2156341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156367 */     // MIs[0] round
     /* 2156367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156370 */     // MIs[0] policy
     /* 2156370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156380 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2156383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156406 */     // GIR_Coverage, 18002,
     /* 2156406 */     GIR_EraseRootFromParent_Done,
     /* 2156407 */   // Label 28464: @2156407
     /* 2156407 */   GIM_Try, /*On fail goto*//*Label 28465*/ GIMT_Encode4(2156498), // Rule ID 18003 //
     /* 2156412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2156423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2156432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156458 */     // MIs[0] round
     /* 2156458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156461 */     // MIs[0] policy
     /* 2156461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156471 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2156474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156497 */     // GIR_Coverage, 18003,
     /* 2156497 */     GIR_EraseRootFromParent_Done,
     /* 2156498 */   // Label 28465: @2156498
     /* 2156498 */   GIM_Try, /*On fail goto*//*Label 28466*/ GIMT_Encode4(2156589), // Rule ID 18006 //
     /* 2156503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2156514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2156517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2156520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2156523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156549 */     // MIs[0] round
     /* 2156549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156552 */     // MIs[0] policy
     /* 2156552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156562 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2156565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156588 */     // GIR_Coverage, 18006,
     /* 2156588 */     GIR_EraseRootFromParent_Done,
     /* 2156589 */   // Label 28466: @2156589
     /* 2156589 */   GIM_Try, /*On fail goto*//*Label 28467*/ GIMT_Encode4(2156680), // Rule ID 18007 //
     /* 2156594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2156605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2156608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2156611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2156614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156640 */     // MIs[0] round
     /* 2156640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156643 */     // MIs[0] policy
     /* 2156643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156653 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2156656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156679 */     // GIR_Coverage, 18007,
     /* 2156679 */     GIR_EraseRootFromParent_Done,
     /* 2156680 */   // Label 28467: @2156680
     /* 2156680 */   GIM_Try, /*On fail goto*//*Label 28468*/ GIMT_Encode4(2156771), // Rule ID 18010 //
     /* 2156685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2156696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2156699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2156702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2156705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156731 */     // MIs[0] round
     /* 2156731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156734 */     // MIs[0] policy
     /* 2156734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156744 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2156747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156770 */     // GIR_Coverage, 18010,
     /* 2156770 */     GIR_EraseRootFromParent_Done,
     /* 2156771 */   // Label 28468: @2156771
     /* 2156771 */   GIM_Try, /*On fail goto*//*Label 28469*/ GIMT_Encode4(2156862), // Rule ID 18011 //
     /* 2156776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2156787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2156790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2156793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2156796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156822 */     // MIs[0] round
     /* 2156822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156825 */     // MIs[0] policy
     /* 2156825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156835 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2156838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156861 */     // GIR_Coverage, 18011,
     /* 2156861 */     GIR_EraseRootFromParent_Done,
     /* 2156862 */   // Label 28469: @2156862
     /* 2156862 */   GIM_Try, /*On fail goto*//*Label 28470*/ GIMT_Encode4(2156953), // Rule ID 18014 //
     /* 2156867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2156878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2156881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2156884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2156887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156913 */     // MIs[0] round
     /* 2156913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156916 */     // MIs[0] policy
     /* 2156916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156926 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2156929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156952 */     // GIR_Coverage, 18014,
     /* 2156952 */     GIR_EraseRootFromParent_Done,
     /* 2156953 */   // Label 28470: @2156953
     /* 2156953 */   GIM_Try, /*On fail goto*//*Label 28471*/ GIMT_Encode4(2157044), // Rule ID 18015 //
     /* 2156958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2156969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2156972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2156975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2156978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157004 */     // MIs[0] round
     /* 2157004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157007 */     // MIs[0] policy
     /* 2157007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157017 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2157020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157043 */     // GIR_Coverage, 18015,
     /* 2157043 */     GIR_EraseRootFromParent_Done,
     /* 2157044 */   // Label 28471: @2157044
     /* 2157044 */   GIM_Try, /*On fail goto*//*Label 28472*/ GIMT_Encode4(2157135), // Rule ID 18018 //
     /* 2157049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2157052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2157060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2157063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2157066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2157069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157095 */     // MIs[0] round
     /* 2157095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157098 */     // MIs[0] policy
     /* 2157098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157108 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2157111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157134 */     // GIR_Coverage, 18018,
     /* 2157134 */     GIR_EraseRootFromParent_Done,
     /* 2157135 */   // Label 28472: @2157135
     /* 2157135 */   GIM_Try, /*On fail goto*//*Label 28473*/ GIMT_Encode4(2157226), // Rule ID 18019 //
     /* 2157140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2157143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2157151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2157154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2157157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2157160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157186 */     // MIs[0] round
     /* 2157186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157189 */     // MIs[0] policy
     /* 2157189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157199 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2157202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157225 */     // GIR_Coverage, 18019,
     /* 2157225 */     GIR_EraseRootFromParent_Done,
     /* 2157226 */   // Label 28473: @2157226
     /* 2157226 */   GIM_Try, /*On fail goto*//*Label 28474*/ GIMT_Encode4(2157317), // Rule ID 18022 //
     /* 2157231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2157242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2157245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2157248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2157251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157277 */     // MIs[0] round
     /* 2157277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157280 */     // MIs[0] policy
     /* 2157280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157290 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2157293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157316 */     // GIR_Coverage, 18022,
     /* 2157316 */     GIR_EraseRootFromParent_Done,
     /* 2157317 */   // Label 28474: @2157317
     /* 2157317 */   GIM_Try, /*On fail goto*//*Label 28475*/ GIMT_Encode4(2157408), // Rule ID 18023 //
     /* 2157322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2157333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2157336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2157339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2157342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157368 */     // MIs[0] round
     /* 2157368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157371 */     // MIs[0] policy
     /* 2157371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157381 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2157384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157407 */     // GIR_Coverage, 18023,
     /* 2157407 */     GIR_EraseRootFromParent_Done,
     /* 2157408 */   // Label 28475: @2157408
     /* 2157408 */   GIM_Try, /*On fail goto*//*Label 28476*/ GIMT_Encode4(2157499), // Rule ID 18026 //
     /* 2157413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2157424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2157427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2157430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2157433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2157436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157459 */     // MIs[0] round
     /* 2157459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157462 */     // MIs[0] policy
     /* 2157462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157472 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2157475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157498 */     // GIR_Coverage, 18026,
     /* 2157498 */     GIR_EraseRootFromParent_Done,
     /* 2157499 */   // Label 28476: @2157499
     /* 2157499 */   GIM_Try, /*On fail goto*//*Label 28477*/ GIMT_Encode4(2157590), // Rule ID 18027 //
     /* 2157504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2157515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2157518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2157521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2157524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2157527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157550 */     // MIs[0] round
     /* 2157550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157553 */     // MIs[0] policy
     /* 2157553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157563 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2157566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157589 */     // GIR_Coverage, 18027,
     /* 2157589 */     GIR_EraseRootFromParent_Done,
     /* 2157590 */   // Label 28477: @2157590
     /* 2157590 */   GIM_Try, /*On fail goto*//*Label 28478*/ GIMT_Encode4(2157681), // Rule ID 18030 //
     /* 2157595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2157606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2157609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2157612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2157615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2157618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2157625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157641 */     // MIs[0] round
     /* 2157641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157644 */     // MIs[0] policy
     /* 2157644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157654 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2157657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157680 */     // GIR_Coverage, 18030,
     /* 2157680 */     GIR_EraseRootFromParent_Done,
     /* 2157681 */   // Label 28478: @2157681
     /* 2157681 */   GIM_Try, /*On fail goto*//*Label 28479*/ GIMT_Encode4(2157772), // Rule ID 18031 //
     /* 2157686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2157697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2157700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2157703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2157706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2157709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2157716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157732 */     // MIs[0] round
     /* 2157732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157735 */     // MIs[0] policy
     /* 2157735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157745 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2157748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157771 */     // GIR_Coverage, 18031,
     /* 2157771 */     GIR_EraseRootFromParent_Done,
     /* 2157772 */   // Label 28479: @2157772
     /* 2157772 */   GIM_Try, /*On fail goto*//*Label 28480*/ GIMT_Encode4(2157863), // Rule ID 18034 //
     /* 2157777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2157788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2157791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2157794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2157797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157823 */     // MIs[0] round
     /* 2157823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157826 */     // MIs[0] policy
     /* 2157826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157836 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2157839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157862 */     // GIR_Coverage, 18034,
     /* 2157862 */     GIR_EraseRootFromParent_Done,
     /* 2157863 */   // Label 28480: @2157863
     /* 2157863 */   GIM_Try, /*On fail goto*//*Label 28481*/ GIMT_Encode4(2157954), // Rule ID 18035 //
     /* 2157868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2157879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2157882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2157885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2157888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157914 */     // MIs[0] round
     /* 2157914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157917 */     // MIs[0] policy
     /* 2157917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157927 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2157930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157953 */     // GIR_Coverage, 18035,
     /* 2157953 */     GIR_EraseRootFromParent_Done,
     /* 2157954 */   // Label 28481: @2157954
     /* 2157954 */   GIM_Try, /*On fail goto*//*Label 28482*/ GIMT_Encode4(2158045), // Rule ID 18038 //
     /* 2157959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2157970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2157973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2157976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2157979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158005 */     // MIs[0] round
     /* 2158005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158008 */     // MIs[0] policy
     /* 2158008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158018 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2158021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158044 */     // GIR_Coverage, 18038,
     /* 2158044 */     GIR_EraseRootFromParent_Done,
     /* 2158045 */   // Label 28482: @2158045
     /* 2158045 */   GIM_Try, /*On fail goto*//*Label 28483*/ GIMT_Encode4(2158136), // Rule ID 18039 //
     /* 2158050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2158061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2158064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2158067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2158070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158096 */     // MIs[0] round
     /* 2158096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158099 */     // MIs[0] policy
     /* 2158099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158109 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2158112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158135 */     // GIR_Coverage, 18039,
     /* 2158135 */     GIR_EraseRootFromParent_Done,
     /* 2158136 */   // Label 28483: @2158136
     /* 2158136 */   GIM_Try, /*On fail goto*//*Label 28484*/ GIMT_Encode4(2158227), // Rule ID 18042 //
     /* 2158141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2158152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2158155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2158158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2158161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2158164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158187 */     // MIs[0] round
     /* 2158187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158190 */     // MIs[0] policy
     /* 2158190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158200 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2158203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158226 */     // GIR_Coverage, 18042,
     /* 2158226 */     GIR_EraseRootFromParent_Done,
     /* 2158227 */   // Label 28484: @2158227
     /* 2158227 */   GIM_Try, /*On fail goto*//*Label 28485*/ GIMT_Encode4(2158318), // Rule ID 18043 //
     /* 2158232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2158243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2158246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2158249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2158252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2158255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158278 */     // MIs[0] round
     /* 2158278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158281 */     // MIs[0] policy
     /* 2158281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158291 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2158294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158317 */     // GIR_Coverage, 18043,
     /* 2158317 */     GIR_EraseRootFromParent_Done,
     /* 2158318 */   // Label 28485: @2158318
     /* 2158318 */   GIM_Try, /*On fail goto*//*Label 28486*/ GIMT_Encode4(2158409), // Rule ID 18046 //
     /* 2158323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2158334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2158337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2158340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2158343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158369 */     // MIs[0] round
     /* 2158369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158372 */     // MIs[0] policy
     /* 2158372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158382 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2158385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158408 */     // GIR_Coverage, 18046,
     /* 2158408 */     GIR_EraseRootFromParent_Done,
     /* 2158409 */   // Label 28486: @2158409
     /* 2158409 */   GIM_Try, /*On fail goto*//*Label 28487*/ GIMT_Encode4(2158500), // Rule ID 18047 //
     /* 2158414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2158425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2158428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2158431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2158434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158460 */     // MIs[0] round
     /* 2158460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158463 */     // MIs[0] policy
     /* 2158463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158473 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2158476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158499 */     // GIR_Coverage, 18047,
     /* 2158499 */     GIR_EraseRootFromParent_Done,
     /* 2158500 */   // Label 28487: @2158500
     /* 2158500 */   GIM_Try, /*On fail goto*//*Label 28488*/ GIMT_Encode4(2158591), // Rule ID 18050 //
     /* 2158505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2158516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2158519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2158522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2158525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158551 */     // MIs[0] round
     /* 2158551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158554 */     // MIs[0] policy
     /* 2158554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158564 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2158567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158590 */     // GIR_Coverage, 18050,
     /* 2158590 */     GIR_EraseRootFromParent_Done,
     /* 2158591 */   // Label 28488: @2158591
     /* 2158591 */   GIM_Try, /*On fail goto*//*Label 28489*/ GIMT_Encode4(2158682), // Rule ID 18051 //
     /* 2158596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2158607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2158610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2158613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2158616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158642 */     // MIs[0] round
     /* 2158642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158645 */     // MIs[0] policy
     /* 2158645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158655 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2158658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158681 */     // GIR_Coverage, 18051,
     /* 2158681 */     GIR_EraseRootFromParent_Done,
     /* 2158682 */   // Label 28489: @2158682
     /* 2158682 */   GIM_Try, /*On fail goto*//*Label 28490*/ GIMT_Encode4(2158773), // Rule ID 18054 //
     /* 2158687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2158698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2158707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158733 */     // MIs[0] round
     /* 2158733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158736 */     // MIs[0] policy
     /* 2158736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158746 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2158749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158772 */     // GIR_Coverage, 18054,
     /* 2158772 */     GIR_EraseRootFromParent_Done,
     /* 2158773 */   // Label 28490: @2158773
     /* 2158773 */   GIM_Try, /*On fail goto*//*Label 28491*/ GIMT_Encode4(2158864), // Rule ID 18055 //
     /* 2158778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2158789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2158798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158824 */     // MIs[0] round
     /* 2158824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158827 */     // MIs[0] policy
     /* 2158827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158837 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2158840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158863 */     // GIR_Coverage, 18055,
     /* 2158863 */     GIR_EraseRootFromParent_Done,
     /* 2158864 */   // Label 28491: @2158864
     /* 2158864 */   GIM_Try, /*On fail goto*//*Label 28492*/ GIMT_Encode4(2158955), // Rule ID 18058 //
     /* 2158869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2158880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2158883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2158889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2158892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158915 */     // MIs[0] round
     /* 2158915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158918 */     // MIs[0] policy
     /* 2158918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158928 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2158931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158954 */     // GIR_Coverage, 18058,
     /* 2158954 */     GIR_EraseRootFromParent_Done,
     /* 2158955 */   // Label 28492: @2158955
     /* 2158955 */   GIM_Try, /*On fail goto*//*Label 28493*/ GIMT_Encode4(2159046), // Rule ID 18059 //
     /* 2158960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2158971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2158974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2158980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2158983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159006 */     // MIs[0] round
     /* 2159006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159009 */     // MIs[0] policy
     /* 2159009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159019 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2159022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159045 */     // GIR_Coverage, 18059,
     /* 2159045 */     GIR_EraseRootFromParent_Done,
     /* 2159046 */   // Label 28493: @2159046
     /* 2159046 */   GIM_Try, /*On fail goto*//*Label 28494*/ GIMT_Encode4(2159137), // Rule ID 18062 //
     /* 2159051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2159062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2159065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2159071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159097 */     // MIs[0] round
     /* 2159097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159100 */     // MIs[0] policy
     /* 2159100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159110 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2159113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159136 */     // GIR_Coverage, 18062,
     /* 2159136 */     GIR_EraseRootFromParent_Done,
     /* 2159137 */   // Label 28494: @2159137
     /* 2159137 */   GIM_Try, /*On fail goto*//*Label 28495*/ GIMT_Encode4(2159228), // Rule ID 18063 //
     /* 2159142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2159153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2159156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2159162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159188 */     // MIs[0] round
     /* 2159188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159191 */     // MIs[0] policy
     /* 2159191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159201 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2159204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159227 */     // GIR_Coverage, 18063,
     /* 2159227 */     GIR_EraseRootFromParent_Done,
     /* 2159228 */   // Label 28495: @2159228
     /* 2159228 */   GIM_Try, /*On fail goto*//*Label 28496*/ GIMT_Encode4(2159319), // Rule ID 18066 //
     /* 2159233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2159244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2159247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2159253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159279 */     // MIs[0] round
     /* 2159279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159282 */     // MIs[0] policy
     /* 2159282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159292 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2159295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159318 */     // GIR_Coverage, 18066,
     /* 2159318 */     GIR_EraseRootFromParent_Done,
     /* 2159319 */   // Label 28496: @2159319
     /* 2159319 */   GIM_Try, /*On fail goto*//*Label 28497*/ GIMT_Encode4(2159410), // Rule ID 18067 //
     /* 2159324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2159335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2159338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2159344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159370 */     // MIs[0] round
     /* 2159370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159373 */     // MIs[0] policy
     /* 2159373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159383 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2159386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159409 */     // GIR_Coverage, 18067,
     /* 2159409 */     GIR_EraseRootFromParent_Done,
     /* 2159410 */   // Label 28497: @2159410
     /* 2159410 */   GIM_Try, /*On fail goto*//*Label 28498*/ GIMT_Encode4(2159501), // Rule ID 18070 //
     /* 2159415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2159426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2159429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2159435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159461 */     // MIs[0] round
     /* 2159461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159464 */     // MIs[0] policy
     /* 2159464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159474 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2159477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159500 */     // GIR_Coverage, 18070,
     /* 2159500 */     GIR_EraseRootFromParent_Done,
     /* 2159501 */   // Label 28498: @2159501
     /* 2159501 */   GIM_Try, /*On fail goto*//*Label 28499*/ GIMT_Encode4(2159592), // Rule ID 18071 //
     /* 2159506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2159517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2159520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2159526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159552 */     // MIs[0] round
     /* 2159552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159555 */     // MIs[0] policy
     /* 2159555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159565 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2159568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159591 */     // GIR_Coverage, 18071,
     /* 2159591 */     GIR_EraseRootFromParent_Done,
     /* 2159592 */   // Label 28499: @2159592
     /* 2159592 */   GIM_Try, /*On fail goto*//*Label 28500*/ GIMT_Encode4(2159683), // Rule ID 18074 //
     /* 2159597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2159608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2159611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2159617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159643 */     // MIs[0] round
     /* 2159643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159646 */     // MIs[0] policy
     /* 2159646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159656 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2159659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159682 */     // GIR_Coverage, 18074,
     /* 2159682 */     GIR_EraseRootFromParent_Done,
     /* 2159683 */   // Label 28500: @2159683
     /* 2159683 */   GIM_Try, /*On fail goto*//*Label 28501*/ GIMT_Encode4(2159774), // Rule ID 18075 //
     /* 2159688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2159699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2159702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2159708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159734 */     // MIs[0] round
     /* 2159734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159737 */     // MIs[0] policy
     /* 2159737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159747 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2159750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159773 */     // GIR_Coverage, 18075,
     /* 2159773 */     GIR_EraseRootFromParent_Done,
     /* 2159774 */   // Label 28501: @2159774
     /* 2159774 */   GIM_Try, /*On fail goto*//*Label 28502*/ GIMT_Encode4(2159865), // Rule ID 18078 //
     /* 2159779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2159782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2159790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2159793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2159799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159825 */     // MIs[0] round
     /* 2159825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159828 */     // MIs[0] policy
     /* 2159828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159838 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2159841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159864 */     // GIR_Coverage, 18078,
     /* 2159864 */     GIR_EraseRootFromParent_Done,
     /* 2159865 */   // Label 28502: @2159865
     /* 2159865 */   GIM_Try, /*On fail goto*//*Label 28503*/ GIMT_Encode4(2159956), // Rule ID 18079 //
     /* 2159870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2159873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2159881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2159884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2159890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159916 */     // MIs[0] round
     /* 2159916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159919 */     // MIs[0] policy
     /* 2159919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159929 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2159932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159955 */     // GIR_Coverage, 18079,
     /* 2159955 */     GIR_EraseRootFromParent_Done,
     /* 2159956 */   // Label 28503: @2159956
     /* 2159956 */   GIM_Try, /*On fail goto*//*Label 28504*/ GIMT_Encode4(2160047), // Rule ID 18082 //
     /* 2159961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2159972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2159975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2159981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2159991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160007 */     // MIs[0] round
     /* 2160007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160010 */     // MIs[0] policy
     /* 2160010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160020 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2160023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160046 */     // GIR_Coverage, 18082,
     /* 2160046 */     GIR_EraseRootFromParent_Done,
     /* 2160047 */   // Label 28504: @2160047
     /* 2160047 */   GIM_Try, /*On fail goto*//*Label 28505*/ GIMT_Encode4(2160138), // Rule ID 18083 //
     /* 2160052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2160063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2160066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2160072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160098 */     // MIs[0] round
     /* 2160098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160101 */     // MIs[0] policy
     /* 2160101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160111 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2160114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160137 */     // GIR_Coverage, 18083,
     /* 2160137 */     GIR_EraseRootFromParent_Done,
     /* 2160138 */   // Label 28505: @2160138
     /* 2160138 */   GIM_Try, /*On fail goto*//*Label 28506*/ GIMT_Encode4(2160229), // Rule ID 18086 //
     /* 2160143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2160154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2160157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2160163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160189 */     // MIs[0] round
     /* 2160189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160192 */     // MIs[0] policy
     /* 2160192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160202 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2160205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160228 */     // GIR_Coverage, 18086,
     /* 2160228 */     GIR_EraseRootFromParent_Done,
     /* 2160229 */   // Label 28506: @2160229
     /* 2160229 */   GIM_Try, /*On fail goto*//*Label 28507*/ GIMT_Encode4(2160320), // Rule ID 18087 //
     /* 2160234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2160245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2160248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2160254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160280 */     // MIs[0] round
     /* 2160280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160283 */     // MIs[0] policy
     /* 2160283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160293 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2160296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160319 */     // GIR_Coverage, 18087,
     /* 2160319 */     GIR_EraseRootFromParent_Done,
     /* 2160320 */   // Label 28507: @2160320
     /* 2160320 */   GIM_Try, /*On fail goto*//*Label 28508*/ GIMT_Encode4(2160411), // Rule ID 18090 //
     /* 2160325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2160336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2160339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2160345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2160348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160371 */     // MIs[0] round
     /* 2160371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160374 */     // MIs[0] policy
     /* 2160374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160384 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2160387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160410 */     // GIR_Coverage, 18090,
     /* 2160410 */     GIR_EraseRootFromParent_Done,
     /* 2160411 */   // Label 28508: @2160411
     /* 2160411 */   GIM_Try, /*On fail goto*//*Label 28509*/ GIMT_Encode4(2160502), // Rule ID 18091 //
     /* 2160416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2160427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2160430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2160436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2160439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160462 */     // MIs[0] round
     /* 2160462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160465 */     // MIs[0] policy
     /* 2160465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160475 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2160478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160501 */     // GIR_Coverage, 18091,
     /* 2160501 */     GIR_EraseRootFromParent_Done,
     /* 2160502 */   // Label 28509: @2160502
     /* 2160502 */   GIM_Try, /*On fail goto*//*Label 28510*/ GIMT_Encode4(2160593), // Rule ID 18094 //
     /* 2160507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2160518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2160521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2160527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2160530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160553 */     // MIs[0] round
     /* 2160553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160556 */     // MIs[0] policy
     /* 2160556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160566 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2160569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160592 */     // GIR_Coverage, 18094,
     /* 2160592 */     GIR_EraseRootFromParent_Done,
     /* 2160593 */   // Label 28510: @2160593
     /* 2160593 */   GIM_Try, /*On fail goto*//*Label 28511*/ GIMT_Encode4(2160684), // Rule ID 18095 //
     /* 2160598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2160609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2160612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2160618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2160621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160644 */     // MIs[0] round
     /* 2160644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160647 */     // MIs[0] policy
     /* 2160647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160657 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2160660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160683 */     // GIR_Coverage, 18095,
     /* 2160683 */     GIR_EraseRootFromParent_Done,
     /* 2160684 */   // Label 28511: @2160684
     /* 2160684 */   GIM_Try, /*On fail goto*//*Label 28512*/ GIMT_Encode4(2160775), // Rule ID 18098 //
     /* 2160689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2160700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2160703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2160709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160735 */     // MIs[0] round
     /* 2160735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160738 */     // MIs[0] policy
     /* 2160738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160748 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2160751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160774 */     // GIR_Coverage, 18098,
     /* 2160774 */     GIR_EraseRootFromParent_Done,
     /* 2160775 */   // Label 28512: @2160775
     /* 2160775 */   GIM_Try, /*On fail goto*//*Label 28513*/ GIMT_Encode4(2160866), // Rule ID 18099 //
     /* 2160780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2160791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2160794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2160800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160826 */     // MIs[0] round
     /* 2160826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160829 */     // MIs[0] policy
     /* 2160829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160839 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2160842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160865 */     // GIR_Coverage, 18099,
     /* 2160865 */     GIR_EraseRootFromParent_Done,
     /* 2160866 */   // Label 28513: @2160866
     /* 2160866 */   GIM_Try, /*On fail goto*//*Label 28514*/ GIMT_Encode4(2160957), // Rule ID 18102 //
     /* 2160871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2160882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2160885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2160891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160917 */     // MIs[0] round
     /* 2160917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160920 */     // MIs[0] policy
     /* 2160920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160930 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2160933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160956 */     // GIR_Coverage, 18102,
     /* 2160956 */     GIR_EraseRootFromParent_Done,
     /* 2160957 */   // Label 28514: @2160957
     /* 2160957 */   GIM_Try, /*On fail goto*//*Label 28515*/ GIMT_Encode4(2161048), // Rule ID 18103 //
     /* 2160962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2160973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2160976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2160982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2161000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161008 */     // MIs[0] round
     /* 2161008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161011 */     // MIs[0] policy
     /* 2161011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161021 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2161024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161047 */     // GIR_Coverage, 18103,
     /* 2161047 */     GIR_EraseRootFromParent_Done,
     /* 2161048 */   // Label 28515: @2161048
     /* 2161048 */   GIM_Try, /*On fail goto*//*Label 28516*/ GIMT_Encode4(2161139), // Rule ID 18106 //
     /* 2161053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2161064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2161067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2161073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161099 */     // MIs[0] round
     /* 2161099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161102 */     // MIs[0] policy
     /* 2161102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161112 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2161115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161138 */     // GIR_Coverage, 18106,
     /* 2161138 */     GIR_EraseRootFromParent_Done,
     /* 2161139 */   // Label 28516: @2161139
     /* 2161139 */   GIM_Try, /*On fail goto*//*Label 28517*/ GIMT_Encode4(2161230), // Rule ID 18107 //
     /* 2161144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2161155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2161158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2161164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161190 */     // MIs[0] round
     /* 2161190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161193 */     // MIs[0] policy
     /* 2161193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161203 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2161206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161229 */     // GIR_Coverage, 18107,
     /* 2161229 */     GIR_EraseRootFromParent_Done,
     /* 2161230 */   // Label 28517: @2161230
     /* 2161230 */   GIM_Try, /*On fail goto*//*Label 28518*/ GIMT_Encode4(2161321), // Rule ID 18110 //
     /* 2161235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2161246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2161249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2161255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161281 */     // MIs[0] round
     /* 2161281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161284 */     // MIs[0] policy
     /* 2161284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161294 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2161297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161320 */     // GIR_Coverage, 18110,
     /* 2161320 */     GIR_EraseRootFromParent_Done,
     /* 2161321 */   // Label 28518: @2161321
     /* 2161321 */   GIM_Try, /*On fail goto*//*Label 28519*/ GIMT_Encode4(2161412), // Rule ID 18111 //
     /* 2161326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2161337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2161340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2161346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161372 */     // MIs[0] round
     /* 2161372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161375 */     // MIs[0] policy
     /* 2161375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161385 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2161388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161411 */     // GIR_Coverage, 18111,
     /* 2161411 */     GIR_EraseRootFromParent_Done,
     /* 2161412 */   // Label 28519: @2161412
     /* 2161412 */   GIM_Try, /*On fail goto*//*Label 28520*/ GIMT_Encode4(2161503), // Rule ID 18114 //
     /* 2161417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2161428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2161431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2161437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161463 */     // MIs[0] round
     /* 2161463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161466 */     // MIs[0] policy
     /* 2161466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161476 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2161479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161502 */     // GIR_Coverage, 18114,
     /* 2161502 */     GIR_EraseRootFromParent_Done,
     /* 2161503 */   // Label 28520: @2161503
     /* 2161503 */   GIM_Try, /*On fail goto*//*Label 28521*/ GIMT_Encode4(2161594), // Rule ID 18115 //
     /* 2161508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2161519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2161522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2161528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161554 */     // MIs[0] round
     /* 2161554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161557 */     // MIs[0] policy
     /* 2161557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161567 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2161570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161593 */     // GIR_Coverage, 18115,
     /* 2161593 */     GIR_EraseRootFromParent_Done,
     /* 2161594 */   // Label 28521: @2161594
     /* 2161594 */   GIM_Try, /*On fail goto*//*Label 28522*/ GIMT_Encode4(2161685), // Rule ID 18118 //
     /* 2161599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2161602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2161607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2161610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2161613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2161616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2161619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2161622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161645 */     // MIs[0] round
     /* 2161645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161648 */     // MIs[0] policy
     /* 2161648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161658 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2161661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161684 */     // GIR_Coverage, 18118,
     /* 2161684 */     GIR_EraseRootFromParent_Done,
     /* 2161685 */   // Label 28522: @2161685
     /* 2161685 */   GIM_Try, /*On fail goto*//*Label 28523*/ GIMT_Encode4(2161776), // Rule ID 18119 //
     /* 2161690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2161693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2161698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2161701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2161704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2161707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2161710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2161713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161736 */     // MIs[0] round
     /* 2161736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161739 */     // MIs[0] policy
     /* 2161739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161749 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2161752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161775 */     // GIR_Coverage, 18119,
     /* 2161775 */     GIR_EraseRootFromParent_Done,
     /* 2161776 */   // Label 28523: @2161776
     /* 2161776 */   GIM_Try, /*On fail goto*//*Label 28524*/ GIMT_Encode4(2161867), // Rule ID 18122 //
     /* 2161781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2161784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2161789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2161792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2161795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2161798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2161801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161827 */     // MIs[0] round
     /* 2161827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161830 */     // MIs[0] policy
     /* 2161830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161840 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2161843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161866 */     // GIR_Coverage, 18122,
     /* 2161866 */     GIR_EraseRootFromParent_Done,
     /* 2161867 */   // Label 28524: @2161867
     /* 2161867 */   GIM_Try, /*On fail goto*//*Label 28525*/ GIMT_Encode4(2161958), // Rule ID 18123 //
     /* 2161872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2161875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2161880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2161883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2161886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2161889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2161892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161918 */     // MIs[0] round
     /* 2161918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161921 */     // MIs[0] policy
     /* 2161921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161931 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2161934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161957 */     // GIR_Coverage, 18123,
     /* 2161957 */     GIR_EraseRootFromParent_Done,
     /* 2161958 */   // Label 28525: @2161958
     /* 2161958 */   GIM_Try, /*On fail goto*//*Label 28526*/ GIMT_Encode4(2162049), // Rule ID 18126 //
     /* 2161963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2161966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2161971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2161974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2161977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2161980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2161983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2161986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162009 */     // MIs[0] round
     /* 2162009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162012 */     // MIs[0] policy
     /* 2162012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162022 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2162025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162048 */     // GIR_Coverage, 18126,
     /* 2162048 */     GIR_EraseRootFromParent_Done,
     /* 2162049 */   // Label 28526: @2162049
     /* 2162049 */   GIM_Try, /*On fail goto*//*Label 28527*/ GIMT_Encode4(2162140), // Rule ID 18127 //
     /* 2162054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2162057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2162065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2162068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2162071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2162074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162100 */     // MIs[0] round
     /* 2162100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162103 */     // MIs[0] policy
     /* 2162103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162113 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2162116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162139 */     // GIR_Coverage, 18127,
     /* 2162139 */     GIR_EraseRootFromParent_Done,
     /* 2162140 */   // Label 28527: @2162140
     /* 2162140 */   GIM_Try, /*On fail goto*//*Label 28528*/ GIMT_Encode4(2162231), // Rule ID 18130 //
     /* 2162145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2162156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2162159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2162162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2162165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2162168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162191 */     // MIs[0] round
     /* 2162191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162194 */     // MIs[0] policy
     /* 2162194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162204 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2162207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162230 */     // GIR_Coverage, 18130,
     /* 2162230 */     GIR_EraseRootFromParent_Done,
     /* 2162231 */   // Label 28528: @2162231
     /* 2162231 */   GIM_Try, /*On fail goto*//*Label 28529*/ GIMT_Encode4(2162322), // Rule ID 18131 //
     /* 2162236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2162247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2162250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2162253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2162256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2162259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162282 */     // MIs[0] round
     /* 2162282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162285 */     // MIs[0] policy
     /* 2162285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162295 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2162298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162321 */     // GIR_Coverage, 18131,
     /* 2162321 */     GIR_EraseRootFromParent_Done,
     /* 2162322 */   // Label 28529: @2162322
     /* 2162322 */   GIM_Try, /*On fail goto*//*Label 28530*/ GIMT_Encode4(2162413), // Rule ID 18134 //
     /* 2162327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2162330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2162338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2162341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2162344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2162347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162373 */     // MIs[0] round
     /* 2162373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162376 */     // MIs[0] policy
     /* 2162376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162386 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2162389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162412 */     // GIR_Coverage, 18134,
     /* 2162412 */     GIR_EraseRootFromParent_Done,
     /* 2162413 */   // Label 28530: @2162413
     /* 2162413 */   GIM_Try, /*On fail goto*//*Label 28531*/ GIMT_Encode4(2162504), // Rule ID 18135 //
     /* 2162418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2162421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2162429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2162432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2162435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2162438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162464 */     // MIs[0] round
     /* 2162464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162467 */     // MIs[0] policy
     /* 2162467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162477 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2162480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162503 */     // GIR_Coverage, 18135,
     /* 2162503 */     GIR_EraseRootFromParent_Done,
     /* 2162504 */   // Label 28531: @2162504
     /* 2162504 */   GIM_Try, /*On fail goto*//*Label 28532*/ GIMT_Encode4(2162595), // Rule ID 18138 //
     /* 2162509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2162512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2162520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2162523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2162526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2162529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162555 */     // MIs[0] round
     /* 2162555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162558 */     // MIs[0] policy
     /* 2162558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162568 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2162571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162594 */     // GIR_Coverage, 18138,
     /* 2162594 */     GIR_EraseRootFromParent_Done,
     /* 2162595 */   // Label 28532: @2162595
     /* 2162595 */   GIM_Try, /*On fail goto*//*Label 28533*/ GIMT_Encode4(2162686), // Rule ID 18139 //
     /* 2162600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2162603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2162611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2162614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2162617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2162620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162646 */     // MIs[0] round
     /* 2162646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162649 */     // MIs[0] policy
     /* 2162649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162659 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2162662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162685 */     // GIR_Coverage, 18139,
     /* 2162685 */     GIR_EraseRootFromParent_Done,
     /* 2162686 */   // Label 28533: @2162686
     /* 2162686 */   GIM_Try, /*On fail goto*//*Label 28534*/ GIMT_Encode4(2162777), // Rule ID 18142 //
     /* 2162691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2162702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2162705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2162708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2162711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2162714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2162721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162737 */     // MIs[0] round
     /* 2162737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162740 */     // MIs[0] policy
     /* 2162740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162750 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2162753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162776 */     // GIR_Coverage, 18142,
     /* 2162776 */     GIR_EraseRootFromParent_Done,
     /* 2162777 */   // Label 28534: @2162777
     /* 2162777 */   GIM_Try, /*On fail goto*//*Label 28535*/ GIMT_Encode4(2162868), // Rule ID 18143 //
     /* 2162782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2162793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2162796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2162799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2162802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2162805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2162812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162828 */     // MIs[0] round
     /* 2162828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162831 */     // MIs[0] policy
     /* 2162831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162841 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2162844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162867 */     // GIR_Coverage, 18143,
     /* 2162867 */     GIR_EraseRootFromParent_Done,
     /* 2162868 */   // Label 28535: @2162868
     /* 2162868 */   GIM_Try, /*On fail goto*//*Label 28536*/ GIMT_Encode4(2162959), // Rule ID 18146 //
     /* 2162873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2162884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2162887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2162890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2162893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2162896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2162903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162919 */     // MIs[0] round
     /* 2162919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162922 */     // MIs[0] policy
     /* 2162922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162932 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2162935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162958 */     // GIR_Coverage, 18146,
     /* 2162958 */     GIR_EraseRootFromParent_Done,
     /* 2162959 */   // Label 28536: @2162959
     /* 2162959 */   GIM_Try, /*On fail goto*//*Label 28537*/ GIMT_Encode4(2163050), // Rule ID 18147 //
     /* 2162964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2162975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2162978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2162981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2162984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2162987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2162994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163010 */     // MIs[0] round
     /* 2163010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163013 */     // MIs[0] policy
     /* 2163013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163023 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2163026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163049 */     // GIR_Coverage, 18147,
     /* 2163049 */     GIR_EraseRootFromParent_Done,
     /* 2163050 */   // Label 28537: @2163050
     /* 2163050 */   GIM_Try, /*On fail goto*//*Label 28538*/ GIMT_Encode4(2163141), // Rule ID 18150 //
     /* 2163055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2163066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2163069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2163072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2163075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2163078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163101 */     // MIs[0] round
     /* 2163101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163104 */     // MIs[0] policy
     /* 2163104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163114 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2163117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163140 */     // GIR_Coverage, 18150,
     /* 2163140 */     GIR_EraseRootFromParent_Done,
     /* 2163141 */   // Label 28538: @2163141
     /* 2163141 */   GIM_Try, /*On fail goto*//*Label 28539*/ GIMT_Encode4(2163232), // Rule ID 18151 //
     /* 2163146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2163149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2163157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2163160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2163163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2163166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2163169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163192 */     // MIs[0] round
     /* 2163192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163195 */     // MIs[0] policy
     /* 2163195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163205 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2163208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163231 */     // GIR_Coverage, 18151,
     /* 2163231 */     GIR_EraseRootFromParent_Done,
     /* 2163232 */   // Label 28539: @2163232
     /* 2163232 */   GIM_Try, /*On fail goto*//*Label 28540*/ GIMT_Encode4(2163323), // Rule ID 18154 //
     /* 2163237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2163248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2163251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2163254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2163257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163283 */     // MIs[0] round
     /* 2163283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163286 */     // MIs[0] policy
     /* 2163286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163296 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2163299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163322 */     // GIR_Coverage, 18154,
     /* 2163322 */     GIR_EraseRootFromParent_Done,
     /* 2163323 */   // Label 28540: @2163323
     /* 2163323 */   GIM_Try, /*On fail goto*//*Label 28541*/ GIMT_Encode4(2163414), // Rule ID 18155 //
     /* 2163328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2163339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2163342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2163345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2163348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163374 */     // MIs[0] round
     /* 2163374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163377 */     // MIs[0] policy
     /* 2163377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163387 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2163390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163413 */     // GIR_Coverage, 18155,
     /* 2163413 */     GIR_EraseRootFromParent_Done,
     /* 2163414 */   // Label 28541: @2163414
     /* 2163414 */   GIM_Try, /*On fail goto*//*Label 28542*/ GIMT_Encode4(2163505), // Rule ID 18158 //
     /* 2163419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2163430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2163433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2163436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2163439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163465 */     // MIs[0] round
     /* 2163465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163468 */     // MIs[0] policy
     /* 2163468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163478 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2163481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163504 */     // GIR_Coverage, 18158,
     /* 2163504 */     GIR_EraseRootFromParent_Done,
     /* 2163505 */   // Label 28542: @2163505
     /* 2163505 */   GIM_Try, /*On fail goto*//*Label 28543*/ GIMT_Encode4(2163596), // Rule ID 18159 //
     /* 2163510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2163521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2163524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2163527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2163530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163556 */     // MIs[0] round
     /* 2163556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163559 */     // MIs[0] policy
     /* 2163559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163569 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2163572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163595 */     // GIR_Coverage, 18159,
     /* 2163595 */     GIR_EraseRootFromParent_Done,
     /* 2163596 */   // Label 28543: @2163596
     /* 2163596 */   GIM_Try, /*On fail goto*//*Label 28544*/ GIMT_Encode4(2163687), // Rule ID 18162 //
     /* 2163601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2163612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2163615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2163618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2163621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2163624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163647 */     // MIs[0] round
     /* 2163647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163650 */     // MIs[0] policy
     /* 2163650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163660 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2163663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163686 */     // GIR_Coverage, 18162,
     /* 2163686 */     GIR_EraseRootFromParent_Done,
     /* 2163687 */   // Label 28544: @2163687
     /* 2163687 */   GIM_Try, /*On fail goto*//*Label 28545*/ GIMT_Encode4(2163778), // Rule ID 18163 //
     /* 2163692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2163703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2163706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2163709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2163712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2163715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163738 */     // MIs[0] round
     /* 2163738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163741 */     // MIs[0] policy
     /* 2163741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163751 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2163754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163777 */     // GIR_Coverage, 18163,
     /* 2163777 */     GIR_EraseRootFromParent_Done,
     /* 2163778 */   // Label 28545: @2163778
     /* 2163778 */   GIM_Try, /*On fail goto*//*Label 28546*/ GIMT_Encode4(2163869), // Rule ID 18166 //
     /* 2163783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2163786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2163794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2163797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2163800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2163803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2163806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163829 */     // MIs[0] round
     /* 2163829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163832 */     // MIs[0] policy
     /* 2163832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163842 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2163845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163868 */     // GIR_Coverage, 18166,
     /* 2163868 */     GIR_EraseRootFromParent_Done,
     /* 2163869 */   // Label 28546: @2163869
     /* 2163869 */   GIM_Try, /*On fail goto*//*Label 28547*/ GIMT_Encode4(2163960), // Rule ID 18167 //
     /* 2163874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2163877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2163885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2163888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2163891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2163894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2163897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163920 */     // MIs[0] round
     /* 2163920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163923 */     // MIs[0] policy
     /* 2163923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163933 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2163936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163959 */     // GIR_Coverage, 18167,
     /* 2163959 */     GIR_EraseRootFromParent_Done,
     /* 2163960 */   // Label 28547: @2163960
     /* 2163960 */   GIM_Try, /*On fail goto*//*Label 28548*/ GIMT_Encode4(2164051), // Rule ID 18170 //
     /* 2163965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2163968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2163976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2163979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2163982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2163985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164011 */     // MIs[0] round
     /* 2164011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164014 */     // MIs[0] policy
     /* 2164014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164024 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2164027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164050 */     // GIR_Coverage, 18170,
     /* 2164050 */     GIR_EraseRootFromParent_Done,
     /* 2164051 */   // Label 28548: @2164051
     /* 2164051 */   GIM_Try, /*On fail goto*//*Label 28549*/ GIMT_Encode4(2164142), // Rule ID 18171 //
     /* 2164056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2164059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2164067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2164070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2164073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2164076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164102 */     // MIs[0] round
     /* 2164102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164105 */     // MIs[0] policy
     /* 2164105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164115 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2164118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164141 */     // GIR_Coverage, 18171,
     /* 2164141 */     GIR_EraseRootFromParent_Done,
     /* 2164142 */   // Label 28549: @2164142
     /* 2164142 */   GIM_Try, /*On fail goto*//*Label 28550*/ GIMT_Encode4(2164233), // Rule ID 18174 //
     /* 2164147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2164150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2164158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2164161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2164164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2164167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164193 */     // MIs[0] round
     /* 2164193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164196 */     // MIs[0] policy
     /* 2164196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164206 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2164209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164232 */     // GIR_Coverage, 18174,
     /* 2164232 */     GIR_EraseRootFromParent_Done,
     /* 2164233 */   // Label 28550: @2164233
     /* 2164233 */   GIM_Try, /*On fail goto*//*Label 28551*/ GIMT_Encode4(2164324), // Rule ID 18175 //
     /* 2164238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2164241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2164249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2164252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2164255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2164258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164284 */     // MIs[0] round
     /* 2164284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164287 */     // MIs[0] policy
     /* 2164287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164297 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2164300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164323 */     // GIR_Coverage, 18175,
     /* 2164323 */     GIR_EraseRootFromParent_Done,
     /* 2164324 */   // Label 28551: @2164324
     /* 2164324 */   GIM_Try, /*On fail goto*//*Label 28552*/ GIMT_Encode4(2164415), // Rule ID 18178 //
     /* 2164329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2164340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2164343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2164349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164375 */     // MIs[0] round
     /* 2164375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164378 */     // MIs[0] policy
     /* 2164378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164388 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2164391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164414 */     // GIR_Coverage, 18178,
     /* 2164414 */     GIR_EraseRootFromParent_Done,
     /* 2164415 */   // Label 28552: @2164415
     /* 2164415 */   GIM_Try, /*On fail goto*//*Label 28553*/ GIMT_Encode4(2164506), // Rule ID 18179 //
     /* 2164420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2164431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2164434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2164440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164466 */     // MIs[0] round
     /* 2164466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164469 */     // MIs[0] policy
     /* 2164469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164479 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2164482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164505 */     // GIR_Coverage, 18179,
     /* 2164505 */     GIR_EraseRootFromParent_Done,
     /* 2164506 */   // Label 28553: @2164506
     /* 2164506 */   GIM_Try, /*On fail goto*//*Label 28554*/ GIMT_Encode4(2164597), // Rule ID 18182 //
     /* 2164511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2164522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2164525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2164531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164557 */     // MIs[0] round
     /* 2164557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164560 */     // MIs[0] policy
     /* 2164560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164570 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2164573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164596 */     // GIR_Coverage, 18182,
     /* 2164596 */     GIR_EraseRootFromParent_Done,
     /* 2164597 */   // Label 28554: @2164597
     /* 2164597 */   GIM_Try, /*On fail goto*//*Label 28555*/ GIMT_Encode4(2164688), // Rule ID 18183 //
     /* 2164602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2164613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2164616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2164622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164648 */     // MIs[0] round
     /* 2164648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164651 */     // MIs[0] policy
     /* 2164651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164661 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2164664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164687 */     // GIR_Coverage, 18183,
     /* 2164687 */     GIR_EraseRootFromParent_Done,
     /* 2164688 */   // Label 28555: @2164688
     /* 2164688 */   GIM_Try, /*On fail goto*//*Label 28556*/ GIMT_Encode4(2164779), // Rule ID 18186 //
     /* 2164693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2164696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2164704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2164707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2164713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164739 */     // MIs[0] round
     /* 2164739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164742 */     // MIs[0] policy
     /* 2164742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164752 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2164755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164778 */     // GIR_Coverage, 18186,
     /* 2164778 */     GIR_EraseRootFromParent_Done,
     /* 2164779 */   // Label 28556: @2164779
     /* 2164779 */   GIM_Try, /*On fail goto*//*Label 28557*/ GIMT_Encode4(2164870), // Rule ID 18187 //
     /* 2164784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2164787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2164795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2164798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2164804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164830 */     // MIs[0] round
     /* 2164830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164833 */     // MIs[0] policy
     /* 2164833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164843 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2164846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164869 */     // GIR_Coverage, 18187,
     /* 2164869 */     GIR_EraseRootFromParent_Done,
     /* 2164870 */   // Label 28557: @2164870
     /* 2164870 */   GIM_Try, /*On fail goto*//*Label 28558*/ GIMT_Encode4(2164961), // Rule ID 18190 //
     /* 2164875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2164886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2164889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2164895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164921 */     // MIs[0] round
     /* 2164921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164924 */     // MIs[0] policy
     /* 2164924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164934 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2164937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164960 */     // GIR_Coverage, 18190,
     /* 2164960 */     GIR_EraseRootFromParent_Done,
     /* 2164961 */   // Label 28558: @2164961
     /* 2164961 */   GIM_Try, /*On fail goto*//*Label 28559*/ GIMT_Encode4(2165052), // Rule ID 18191 //
     /* 2164966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2164977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2164980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2164986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165012 */     // MIs[0] round
     /* 2165012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165015 */     // MIs[0] policy
     /* 2165015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165025 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2165028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165051 */     // GIR_Coverage, 18191,
     /* 2165051 */     GIR_EraseRootFromParent_Done,
     /* 2165052 */   // Label 28559: @2165052
     /* 2165052 */   GIM_Try, /*On fail goto*//*Label 28560*/ GIMT_Encode4(2165143), // Rule ID 18194 //
     /* 2165057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2165060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2165068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2165071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2165077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165103 */     // MIs[0] round
     /* 2165103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165106 */     // MIs[0] policy
     /* 2165106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165116 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2165119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165142 */     // GIR_Coverage, 18194,
     /* 2165142 */     GIR_EraseRootFromParent_Done,
     /* 2165143 */   // Label 28560: @2165143
     /* 2165143 */   GIM_Try, /*On fail goto*//*Label 28561*/ GIMT_Encode4(2165234), // Rule ID 18195 //
     /* 2165148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2165151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2165159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2165162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2165168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165194 */     // MIs[0] round
     /* 2165194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165197 */     // MIs[0] policy
     /* 2165197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165207 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2165210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165233 */     // GIR_Coverage, 18195,
     /* 2165233 */     GIR_EraseRootFromParent_Done,
     /* 2165234 */   // Label 28561: @2165234
     /* 2165234 */   GIM_Try, /*On fail goto*//*Label 28562*/ GIMT_Encode4(2165325), // Rule ID 18198 //
     /* 2165239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2165242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2165250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2165253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2165259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165285 */     // MIs[0] round
     /* 2165285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165288 */     // MIs[0] policy
     /* 2165288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165298 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2165301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165324 */     // GIR_Coverage, 18198,
     /* 2165324 */     GIR_EraseRootFromParent_Done,
     /* 2165325 */   // Label 28562: @2165325
     /* 2165325 */   GIM_Try, /*On fail goto*//*Label 28563*/ GIMT_Encode4(2165416), // Rule ID 18199 //
     /* 2165330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2165333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2165341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2165344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2165350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165376 */     // MIs[0] round
     /* 2165376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165379 */     // MIs[0] policy
     /* 2165379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165389 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2165392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165415 */     // GIR_Coverage, 18199,
     /* 2165415 */     GIR_EraseRootFromParent_Done,
     /* 2165416 */   // Label 28563: @2165416
     /* 2165416 */   GIM_Try, /*On fail goto*//*Label 28564*/ GIMT_Encode4(2165507), // Rule ID 18202 //
     /* 2165421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2165432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2165435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2165441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165467 */     // MIs[0] round
     /* 2165467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165470 */     // MIs[0] policy
     /* 2165470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165480 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2165483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165506 */     // GIR_Coverage, 18202,
     /* 2165506 */     GIR_EraseRootFromParent_Done,
     /* 2165507 */   // Label 28564: @2165507
     /* 2165507 */   GIM_Try, /*On fail goto*//*Label 28565*/ GIMT_Encode4(2165598), // Rule ID 18203 //
     /* 2165512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2165523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2165526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2165532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165558 */     // MIs[0] round
     /* 2165558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165561 */     // MIs[0] policy
     /* 2165561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165571 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2165574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165597 */     // GIR_Coverage, 18203,
     /* 2165597 */     GIR_EraseRootFromParent_Done,
     /* 2165598 */   // Label 28565: @2165598
     /* 2165598 */   GIM_Try, /*On fail goto*//*Label 28566*/ GIMT_Encode4(2165689), // Rule ID 18206 //
     /* 2165603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2165614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2165617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2165623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2165626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2165633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165649 */     // MIs[0] round
     /* 2165649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165652 */     // MIs[0] policy
     /* 2165652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165662 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2165665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165688 */     // GIR_Coverage, 18206,
     /* 2165688 */     GIR_EraseRootFromParent_Done,
     /* 2165689 */   // Label 28566: @2165689
     /* 2165689 */   GIM_Try, /*On fail goto*//*Label 28567*/ GIMT_Encode4(2165780), // Rule ID 18207 //
     /* 2165694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2165705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2165708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2165714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2165717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2165724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165740 */     // MIs[0] round
     /* 2165740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165743 */     // MIs[0] policy
     /* 2165743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165753 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2165756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165779 */     // GIR_Coverage, 18207,
     /* 2165779 */     GIR_EraseRootFromParent_Done,
     /* 2165780 */   // Label 28567: @2165780
     /* 2165780 */   GIM_Try, /*On fail goto*//*Label 28568*/ GIMT_Encode4(2165871), // Rule ID 18210 //
     /* 2165785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2165796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2165799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2165805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2165808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2165815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165831 */     // MIs[0] round
     /* 2165831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165834 */     // MIs[0] policy
     /* 2165834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165844 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2165847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165870 */     // GIR_Coverage, 18210,
     /* 2165870 */     GIR_EraseRootFromParent_Done,
     /* 2165871 */   // Label 28568: @2165871
     /* 2165871 */   GIM_Try, /*On fail goto*//*Label 28569*/ GIMT_Encode4(2165962), // Rule ID 18211 //
     /* 2165876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2165887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2165890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2165896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2165899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2165906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165922 */     // MIs[0] round
     /* 2165922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165925 */     // MIs[0] policy
     /* 2165925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165935 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2165938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165961 */     // GIR_Coverage, 18211,
     /* 2165961 */     GIR_EraseRootFromParent_Done,
     /* 2165962 */   // Label 28569: @2165962
     /* 2165962 */   GIM_Try, /*On fail goto*//*Label 28570*/ GIMT_Encode4(2166053), // Rule ID 18214 //
     /* 2165967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2165970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2165978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2165981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2165987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2165990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166013 */     // MIs[0] round
     /* 2166013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166016 */     // MIs[0] policy
     /* 2166016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166026 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2166029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166052 */     // GIR_Coverage, 18214,
     /* 2166052 */     GIR_EraseRootFromParent_Done,
     /* 2166053 */   // Label 28570: @2166053
     /* 2166053 */   GIM_Try, /*On fail goto*//*Label 28571*/ GIMT_Encode4(2166144), // Rule ID 18215 //
     /* 2166058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2166069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2166072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2166078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166104 */     // MIs[0] round
     /* 2166104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166107 */     // MIs[0] policy
     /* 2166107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166117 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2166120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166143 */     // GIR_Coverage, 18215,
     /* 2166143 */     GIR_EraseRootFromParent_Done,
     /* 2166144 */   // Label 28571: @2166144
     /* 2166144 */   GIM_Try, /*On fail goto*//*Label 28572*/ GIMT_Encode4(2166235), // Rule ID 18218 //
     /* 2166149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2166152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2166160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2166163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2166169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166195 */     // MIs[0] round
     /* 2166195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166198 */     // MIs[0] policy
     /* 2166198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166208 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2166211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166234 */     // GIR_Coverage, 18218,
     /* 2166234 */     GIR_EraseRootFromParent_Done,
     /* 2166235 */   // Label 28572: @2166235
     /* 2166235 */   GIM_Try, /*On fail goto*//*Label 28573*/ GIMT_Encode4(2166326), // Rule ID 18219 //
     /* 2166240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2166251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2166254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2166260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166286 */     // MIs[0] round
     /* 2166286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166289 */     // MIs[0] policy
     /* 2166289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166299 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2166302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166325 */     // GIR_Coverage, 18219,
     /* 2166325 */     GIR_EraseRootFromParent_Done,
     /* 2166326 */   // Label 28573: @2166326
     /* 2166326 */   GIM_Try, /*On fail goto*//*Label 28574*/ GIMT_Encode4(2166417), // Rule ID 18222 //
     /* 2166331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2166334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2166342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2166345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2166351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166377 */     // MIs[0] round
     /* 2166377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166380 */     // MIs[0] policy
     /* 2166380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166390 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2166393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166416 */     // GIR_Coverage, 18222,
     /* 2166416 */     GIR_EraseRootFromParent_Done,
     /* 2166417 */   // Label 28574: @2166417
     /* 2166417 */   GIM_Try, /*On fail goto*//*Label 28575*/ GIMT_Encode4(2166508), // Rule ID 18223 //
     /* 2166422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2166433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2166436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2166442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166468 */     // MIs[0] round
     /* 2166468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166471 */     // MIs[0] policy
     /* 2166471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166481 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2166484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166507 */     // GIR_Coverage, 18223,
     /* 2166507 */     GIR_EraseRootFromParent_Done,
     /* 2166508 */   // Label 28575: @2166508
     /* 2166508 */   GIM_Try, /*On fail goto*//*Label 28576*/ GIMT_Encode4(2166599), // Rule ID 18226 //
     /* 2166513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2166516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2166524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2166527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2166533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2166536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166559 */     // MIs[0] round
     /* 2166559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166562 */     // MIs[0] policy
     /* 2166562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166572 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2166575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166598 */     // GIR_Coverage, 18226,
     /* 2166598 */     GIR_EraseRootFromParent_Done,
     /* 2166599 */   // Label 28576: @2166599
     /* 2166599 */   GIM_Try, /*On fail goto*//*Label 28577*/ GIMT_Encode4(2166690), // Rule ID 18227 //
     /* 2166604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2166607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2166615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2166618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2166624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2166627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166650 */     // MIs[0] round
     /* 2166650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166653 */     // MIs[0] policy
     /* 2166653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166663 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2166666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166689 */     // GIR_Coverage, 18227,
     /* 2166689 */     GIR_EraseRootFromParent_Done,
     /* 2166690 */   // Label 28577: @2166690
     /* 2166690 */   GIM_Try, /*On fail goto*//*Label 28578*/ GIMT_Encode4(2166781), // Rule ID 18230 //
     /* 2166695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2166698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2166706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2166709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2166715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166741 */     // MIs[0] round
     /* 2166741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166744 */     // MIs[0] policy
     /* 2166744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166754 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2166757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166780 */     // GIR_Coverage, 18230,
     /* 2166780 */     GIR_EraseRootFromParent_Done,
     /* 2166781 */   // Label 28578: @2166781
     /* 2166781 */   GIM_Try, /*On fail goto*//*Label 28579*/ GIMT_Encode4(2166872), // Rule ID 18231 //
     /* 2166786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2166789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2166797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2166800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2166806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166832 */     // MIs[0] round
     /* 2166832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166835 */     // MIs[0] policy
     /* 2166835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166845 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2166848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166871 */     // GIR_Coverage, 18231,
     /* 2166871 */     GIR_EraseRootFromParent_Done,
     /* 2166872 */   // Label 28579: @2166872
     /* 2166872 */   GIM_Try, /*On fail goto*//*Label 28580*/ GIMT_Encode4(2166963), // Rule ID 18234 //
     /* 2166877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2166880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2166888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2166891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2166897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166923 */     // MIs[0] round
     /* 2166923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166926 */     // MIs[0] policy
     /* 2166926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166936 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2166939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166962 */     // GIR_Coverage, 18234,
     /* 2166962 */     GIR_EraseRootFromParent_Done,
     /* 2166963 */   // Label 28580: @2166963
     /* 2166963 */   GIM_Try, /*On fail goto*//*Label 28581*/ GIMT_Encode4(2167054), // Rule ID 18235 //
     /* 2166968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2166971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2166979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2166982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2166988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2167006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167014 */     // MIs[0] round
     /* 2167014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167017 */     // MIs[0] policy
     /* 2167017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167027 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2167030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167053 */     // GIR_Coverage, 18235,
     /* 2167053 */     GIR_EraseRootFromParent_Done,
     /* 2167054 */   // Label 28581: @2167054
     /* 2167054 */   GIM_Try, /*On fail goto*//*Label 28582*/ GIMT_Encode4(2167145), // Rule ID 18238 //
     /* 2167059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2167062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2167070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2167073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2167076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2167079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167105 */     // MIs[0] round
     /* 2167105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167108 */     // MIs[0] policy
     /* 2167108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167118 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2167121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167144 */     // GIR_Coverage, 18238,
     /* 2167144 */     GIR_EraseRootFromParent_Done,
     /* 2167145 */   // Label 28582: @2167145
     /* 2167145 */   GIM_Try, /*On fail goto*//*Label 28583*/ GIMT_Encode4(2167236), // Rule ID 18239 //
     /* 2167150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2167161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2167164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2167167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2167170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167196 */     // MIs[0] round
     /* 2167196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167199 */     // MIs[0] policy
     /* 2167199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167209 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2167212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167235 */     // GIR_Coverage, 18239,
     /* 2167235 */     GIR_EraseRootFromParent_Done,
     /* 2167236 */   // Label 28583: @2167236
     /* 2167236 */   GIM_Try, /*On fail goto*//*Label 28584*/ GIMT_Encode4(2167327), // Rule ID 18242 //
     /* 2167241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2167244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2167252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2167255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2167258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2167261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167287 */     // MIs[0] round
     /* 2167287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167290 */     // MIs[0] policy
     /* 2167290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167300 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2167303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167326 */     // GIR_Coverage, 18242,
     /* 2167326 */     GIR_EraseRootFromParent_Done,
     /* 2167327 */   // Label 28584: @2167327
     /* 2167327 */   GIM_Try, /*On fail goto*//*Label 28585*/ GIMT_Encode4(2167418), // Rule ID 18243 //
     /* 2167332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2167343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2167346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2167349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2167352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167378 */     // MIs[0] round
     /* 2167378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167381 */     // MIs[0] policy
     /* 2167381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167391 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2167394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167417 */     // GIR_Coverage, 18243,
     /* 2167417 */     GIR_EraseRootFromParent_Done,
     /* 2167418 */   // Label 28585: @2167418
     /* 2167418 */   GIM_Try, /*On fail goto*//*Label 28586*/ GIMT_Encode4(2167509), // Rule ID 18246 //
     /* 2167423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2167434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2167437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2167440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2167443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167469 */     // MIs[0] round
     /* 2167469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167472 */     // MIs[0] policy
     /* 2167472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167482 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2167485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167508 */     // GIR_Coverage, 18246,
     /* 2167508 */     GIR_EraseRootFromParent_Done,
     /* 2167509 */   // Label 28586: @2167509
     /* 2167509 */   GIM_Try, /*On fail goto*//*Label 28587*/ GIMT_Encode4(2167600), // Rule ID 18247 //
     /* 2167514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2167525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2167528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2167531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2167534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167560 */     // MIs[0] round
     /* 2167560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167563 */     // MIs[0] policy
     /* 2167563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167573 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2167576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167599 */     // GIR_Coverage, 18247,
     /* 2167599 */     GIR_EraseRootFromParent_Done,
     /* 2167600 */   // Label 28587: @2167600
     /* 2167600 */   GIM_Try, /*On fail goto*//*Label 28588*/ GIMT_Encode4(2167691), // Rule ID 18250 //
     /* 2167605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2167608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2167616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2167619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2167622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2167625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167651 */     // MIs[0] round
     /* 2167651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167654 */     // MIs[0] policy
     /* 2167654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167664 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2167667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167690 */     // GIR_Coverage, 18250,
     /* 2167690 */     GIR_EraseRootFromParent_Done,
     /* 2167691 */   // Label 28588: @2167691
     /* 2167691 */   GIM_Try, /*On fail goto*//*Label 28589*/ GIMT_Encode4(2167782), // Rule ID 18251 //
     /* 2167696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2167707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2167710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2167713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2167716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167742 */     // MIs[0] round
     /* 2167742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167745 */     // MIs[0] policy
     /* 2167745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167755 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2167758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167781 */     // GIR_Coverage, 18251,
     /* 2167781 */     GIR_EraseRootFromParent_Done,
     /* 2167782 */   // Label 28589: @2167782
     /* 2167782 */   GIM_Try, /*On fail goto*//*Label 28590*/ GIMT_Encode4(2167873), // Rule ID 18254 //
     /* 2167787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2167798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2167801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2167804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2167807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167833 */     // MIs[0] round
     /* 2167833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167836 */     // MIs[0] policy
     /* 2167836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167846 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2167849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167872 */     // GIR_Coverage, 18254,
     /* 2167872 */     GIR_EraseRootFromParent_Done,
     /* 2167873 */   // Label 28590: @2167873
     /* 2167873 */   GIM_Try, /*On fail goto*//*Label 28591*/ GIMT_Encode4(2167964), // Rule ID 18255 //
     /* 2167878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2167889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2167892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2167895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2167898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167924 */     // MIs[0] round
     /* 2167924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167927 */     // MIs[0] policy
     /* 2167927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167937 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2167940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167963 */     // GIR_Coverage, 18255,
     /* 2167963 */     GIR_EraseRootFromParent_Done,
     /* 2167964 */   // Label 28591: @2167964
     /* 2167964 */   GIM_Try, /*On fail goto*//*Label 28592*/ GIMT_Encode4(2168055), // Rule ID 18258 //
     /* 2167969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2167972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2167980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2167983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2167986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2167989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168015 */     // MIs[0] round
     /* 2168015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168018 */     // MIs[0] policy
     /* 2168018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168028 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2168031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168054 */     // GIR_Coverage, 18258,
     /* 2168054 */     GIR_EraseRootFromParent_Done,
     /* 2168055 */   // Label 28592: @2168055
     /* 2168055 */   GIM_Try, /*On fail goto*//*Label 28593*/ GIMT_Encode4(2168146), // Rule ID 18259 //
     /* 2168060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2168063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2168071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2168074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2168077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2168080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168106 */     // MIs[0] round
     /* 2168106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168109 */     // MIs[0] policy
     /* 2168109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168119 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2168122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168145 */     // GIR_Coverage, 18259,
     /* 2168145 */     GIR_EraseRootFromParent_Done,
     /* 2168146 */   // Label 28593: @2168146
     /* 2168146 */   GIM_Try, /*On fail goto*//*Label 28594*/ GIMT_Encode4(2168237), // Rule ID 18262 //
     /* 2168151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2168162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2168165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2168168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2168171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168197 */     // MIs[0] round
     /* 2168197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168200 */     // MIs[0] policy
     /* 2168200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168210 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2168213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168236 */     // GIR_Coverage, 18262,
     /* 2168236 */     GIR_EraseRootFromParent_Done,
     /* 2168237 */   // Label 28594: @2168237
     /* 2168237 */   GIM_Try, /*On fail goto*//*Label 28595*/ GIMT_Encode4(2168328), // Rule ID 18263 //
     /* 2168242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2168253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2168256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2168259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2168262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168288 */     // MIs[0] round
     /* 2168288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168291 */     // MIs[0] policy
     /* 2168291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168301 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2168304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168327 */     // GIR_Coverage, 18263,
     /* 2168327 */     GIR_EraseRootFromParent_Done,
     /* 2168328 */   // Label 28595: @2168328
     /* 2168328 */   GIM_Try, /*On fail goto*//*Label 28596*/ GIMT_Encode4(2168419), // Rule ID 18266 //
     /* 2168333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2168344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2168347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2168350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2168353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2168356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168379 */     // MIs[0] round
     /* 2168379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168382 */     // MIs[0] policy
     /* 2168382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168392 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2168395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168418 */     // GIR_Coverage, 18266,
     /* 2168418 */     GIR_EraseRootFromParent_Done,
     /* 2168419 */   // Label 28596: @2168419
     /* 2168419 */   GIM_Try, /*On fail goto*//*Label 28597*/ GIMT_Encode4(2168510), // Rule ID 18267 //
     /* 2168424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2168435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2168438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2168441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2168444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2168447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168470 */     // MIs[0] round
     /* 2168470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168473 */     // MIs[0] policy
     /* 2168473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168483 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2168486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168509 */     // GIR_Coverage, 18267,
     /* 2168509 */     GIR_EraseRootFromParent_Done,
     /* 2168510 */   // Label 28597: @2168510
     /* 2168510 */   GIM_Try, /*On fail goto*//*Label 28598*/ GIMT_Encode4(2168601), // Rule ID 18270 //
     /* 2168515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2168526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2168529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2168532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2168535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2168538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2168545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168561 */     // MIs[0] round
     /* 2168561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168564 */     // MIs[0] policy
     /* 2168564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168574 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2168577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168600 */     // GIR_Coverage, 18270,
     /* 2168600 */     GIR_EraseRootFromParent_Done,
     /* 2168601 */   // Label 28598: @2168601
     /* 2168601 */   GIM_Try, /*On fail goto*//*Label 28599*/ GIMT_Encode4(2168692), // Rule ID 18271 //
     /* 2168606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2168617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2168620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2168623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2168626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2168629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2168636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168652 */     // MIs[0] round
     /* 2168652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168655 */     // MIs[0] policy
     /* 2168655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168665 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2168668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168691 */     // GIR_Coverage, 18271,
     /* 2168691 */     GIR_EraseRootFromParent_Done,
     /* 2168692 */   // Label 28599: @2168692
     /* 2168692 */   GIM_Try, /*On fail goto*//*Label 28600*/ GIMT_Encode4(2168783), // Rule ID 18274 //
     /* 2168697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2168700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2168708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2168711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2168714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2168717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168743 */     // MIs[0] round
     /* 2168743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168746 */     // MIs[0] policy
     /* 2168746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168756 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2168759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168782 */     // GIR_Coverage, 18274,
     /* 2168782 */     GIR_EraseRootFromParent_Done,
     /* 2168783 */   // Label 28600: @2168783
     /* 2168783 */   GIM_Try, /*On fail goto*//*Label 28601*/ GIMT_Encode4(2168874), // Rule ID 18275 //
     /* 2168788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2168791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2168799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2168802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2168805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2168808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168834 */     // MIs[0] round
     /* 2168834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168837 */     // MIs[0] policy
     /* 2168837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168847 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2168850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168873 */     // GIR_Coverage, 18275,
     /* 2168873 */     GIR_EraseRootFromParent_Done,
     /* 2168874 */   // Label 28601: @2168874
     /* 2168874 */   GIM_Try, /*On fail goto*//*Label 28602*/ GIMT_Encode4(2168965), // Rule ID 18278 //
     /* 2168879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2168882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2168890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2168893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2168896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2168899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168925 */     // MIs[0] round
     /* 2168925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168928 */     // MIs[0] policy
     /* 2168928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168938 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2168941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168964 */     // GIR_Coverage, 18278,
     /* 2168964 */     GIR_EraseRootFromParent_Done,
     /* 2168965 */   // Label 28602: @2168965
     /* 2168965 */   GIM_Try, /*On fail goto*//*Label 28603*/ GIMT_Encode4(2169056), // Rule ID 18279 //
     /* 2168970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2168973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2168981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2168984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2168987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2168990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169016 */     // MIs[0] round
     /* 2169016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169019 */     // MIs[0] policy
     /* 2169019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169029 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2169032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169055 */     // GIR_Coverage, 18279,
     /* 2169055 */     GIR_EraseRootFromParent_Done,
     /* 2169056 */   // Label 28603: @2169056
     /* 2169056 */   GIM_Try, /*On fail goto*//*Label 28604*/ GIMT_Encode4(2169147), // Rule ID 18282 //
     /* 2169061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2169064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2169072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2169075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2169078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2169081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2169084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169107 */     // MIs[0] round
     /* 2169107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169110 */     // MIs[0] policy
     /* 2169110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169120 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2169123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169146 */     // GIR_Coverage, 18282,
     /* 2169146 */     GIR_EraseRootFromParent_Done,
     /* 2169147 */   // Label 28604: @2169147
     /* 2169147 */   GIM_Try, /*On fail goto*//*Label 28605*/ GIMT_Encode4(2169238), // Rule ID 18283 //
     /* 2169152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2169155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2169163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2169166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2169169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2169172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2169175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169198 */     // MIs[0] round
     /* 2169198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169201 */     // MIs[0] policy
     /* 2169201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169211 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2169214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169237 */     // GIR_Coverage, 18283,
     /* 2169237 */     GIR_EraseRootFromParent_Done,
     /* 2169238 */   // Label 28605: @2169238
     /* 2169238 */   GIM_Try, /*On fail goto*//*Label 28606*/ GIMT_Encode4(2169329), // Rule ID 18286 //
     /* 2169243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2169254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2169257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2169260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2169263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169289 */     // MIs[0] round
     /* 2169289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169292 */     // MIs[0] policy
     /* 2169292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169302 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2169305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169328 */     // GIR_Coverage, 18286,
     /* 2169328 */     GIR_EraseRootFromParent_Done,
     /* 2169329 */   // Label 28606: @2169329
     /* 2169329 */   GIM_Try, /*On fail goto*//*Label 28607*/ GIMT_Encode4(2169420), // Rule ID 18287 //
     /* 2169334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2169345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2169348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2169351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2169354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169380 */     // MIs[0] round
     /* 2169380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169383 */     // MIs[0] policy
     /* 2169383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169393 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2169396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169419 */     // GIR_Coverage, 18287,
     /* 2169419 */     GIR_EraseRootFromParent_Done,
     /* 2169420 */   // Label 28607: @2169420
     /* 2169420 */   GIM_Try, /*On fail goto*//*Label 28608*/ GIMT_Encode4(2169511), // Rule ID 18290 //
     /* 2169425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2169436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2169439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2169442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2169445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169471 */     // MIs[0] round
     /* 2169471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169474 */     // MIs[0] policy
     /* 2169474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169484 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2169487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169510 */     // GIR_Coverage, 18290,
     /* 2169510 */     GIR_EraseRootFromParent_Done,
     /* 2169511 */   // Label 28608: @2169511
     /* 2169511 */   GIM_Try, /*On fail goto*//*Label 28609*/ GIMT_Encode4(2169602), // Rule ID 18291 //
     /* 2169516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2169527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2169530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2169533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2169536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169562 */     // MIs[0] round
     /* 2169562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169565 */     // MIs[0] policy
     /* 2169565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169575 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2169578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169601 */     // GIR_Coverage, 18291,
     /* 2169601 */     GIR_EraseRootFromParent_Done,
     /* 2169602 */   // Label 28609: @2169602
     /* 2169602 */   GIM_Try, /*On fail goto*//*Label 28610*/ GIMT_Encode4(2169693), // Rule ID 18294 //
     /* 2169607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2169618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2169621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2169624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2169627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169653 */     // MIs[0] round
     /* 2169653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169656 */     // MIs[0] policy
     /* 2169656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169666 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2169669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169692 */     // GIR_Coverage, 18294,
     /* 2169692 */     GIR_EraseRootFromParent_Done,
     /* 2169693 */   // Label 28610: @2169693
     /* 2169693 */   GIM_Try, /*On fail goto*//*Label 28611*/ GIMT_Encode4(2169784), // Rule ID 18295 //
     /* 2169698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2169709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2169712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2169715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2169718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169744 */     // MIs[0] round
     /* 2169744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169747 */     // MIs[0] policy
     /* 2169747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169757 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2169760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169783 */     // GIR_Coverage, 18295,
     /* 2169783 */     GIR_EraseRootFromParent_Done,
     /* 2169784 */   // Label 28611: @2169784
     /* 2169784 */   GIM_Try, /*On fail goto*//*Label 28612*/ GIMT_Encode4(2169875), // Rule ID 18298 //
     /* 2169789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2169792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2169800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2169803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2169809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2169812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169835 */     // MIs[0] round
     /* 2169835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169838 */     // MIs[0] policy
     /* 2169838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169848 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2169851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169874 */     // GIR_Coverage, 18298,
     /* 2169874 */     GIR_EraseRootFromParent_Done,
     /* 2169875 */   // Label 28612: @2169875
     /* 2169875 */   GIM_Try, /*On fail goto*//*Label 28613*/ GIMT_Encode4(2169966), // Rule ID 18299 //
     /* 2169880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2169883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2169891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2169894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2169900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2169903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169926 */     // MIs[0] round
     /* 2169926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169929 */     // MIs[0] policy
     /* 2169929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169939 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2169942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169965 */     // GIR_Coverage, 18299,
     /* 2169965 */     GIR_EraseRootFromParent_Done,
     /* 2169966 */   // Label 28613: @2169966
     /* 2169966 */   GIM_Try, /*On fail goto*//*Label 28614*/ GIMT_Encode4(2170057), // Rule ID 18302 //
     /* 2169971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2169974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2169982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2169985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2169991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170017 */     // MIs[0] round
     /* 2170017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170020 */     // MIs[0] policy
     /* 2170020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170030 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2170033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170056 */     // GIR_Coverage, 18302,
     /* 2170056 */     GIR_EraseRootFromParent_Done,
     /* 2170057 */   // Label 28614: @2170057
     /* 2170057 */   GIM_Try, /*On fail goto*//*Label 28615*/ GIMT_Encode4(2170148), // Rule ID 18303 //
     /* 2170062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2170073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2170076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2170082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170108 */     // MIs[0] round
     /* 2170108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170111 */     // MIs[0] policy
     /* 2170111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170121 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2170124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170147 */     // GIR_Coverage, 18303,
     /* 2170147 */     GIR_EraseRootFromParent_Done,
     /* 2170148 */   // Label 28615: @2170148
     /* 2170148 */   GIM_Try, /*On fail goto*//*Label 28616*/ GIMT_Encode4(2170239), // Rule ID 18306 //
     /* 2170153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2170156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2170164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2170167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2170173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170199 */     // MIs[0] round
     /* 2170199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170202 */     // MIs[0] policy
     /* 2170202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170212 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2170215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170238 */     // GIR_Coverage, 18306,
     /* 2170238 */     GIR_EraseRootFromParent_Done,
     /* 2170239 */   // Label 28616: @2170239
     /* 2170239 */   GIM_Try, /*On fail goto*//*Label 28617*/ GIMT_Encode4(2170330), // Rule ID 18307 //
     /* 2170244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2170247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2170255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2170258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2170264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170290 */     // MIs[0] round
     /* 2170290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170293 */     // MIs[0] policy
     /* 2170293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170303 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2170306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170329 */     // GIR_Coverage, 18307,
     /* 2170329 */     GIR_EraseRootFromParent_Done,
     /* 2170330 */   // Label 28617: @2170330
     /* 2170330 */   GIM_Try, /*On fail goto*//*Label 28618*/ GIMT_Encode4(2170421), // Rule ID 18310 //
     /* 2170335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2170346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2170349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2170355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170381 */     // MIs[0] round
     /* 2170381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170384 */     // MIs[0] policy
     /* 2170384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170394 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2170397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170420 */     // GIR_Coverage, 18310,
     /* 2170420 */     GIR_EraseRootFromParent_Done,
     /* 2170421 */   // Label 28618: @2170421
     /* 2170421 */   GIM_Try, /*On fail goto*//*Label 28619*/ GIMT_Encode4(2170512), // Rule ID 18311 //
     /* 2170426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2170437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2170440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2170446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170472 */     // MIs[0] round
     /* 2170472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170475 */     // MIs[0] policy
     /* 2170475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170485 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2170488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170511 */     // GIR_Coverage, 18311,
     /* 2170511 */     GIR_EraseRootFromParent_Done,
     /* 2170512 */   // Label 28619: @2170512
     /* 2170512 */   GIM_Try, /*On fail goto*//*Label 28620*/ GIMT_Encode4(2170603), // Rule ID 18314 //
     /* 2170517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2170520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2170528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2170531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2170537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170563 */     // MIs[0] round
     /* 2170563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170566 */     // MIs[0] policy
     /* 2170566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170576 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2170579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170602 */     // GIR_Coverage, 18314,
     /* 2170602 */     GIR_EraseRootFromParent_Done,
     /* 2170603 */   // Label 28620: @2170603
     /* 2170603 */   GIM_Try, /*On fail goto*//*Label 28621*/ GIMT_Encode4(2170694), // Rule ID 18315 //
     /* 2170608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2170611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2170619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2170622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2170628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170654 */     // MIs[0] round
     /* 2170654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170657 */     // MIs[0] policy
     /* 2170657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170667 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2170670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170693 */     // GIR_Coverage, 18315,
     /* 2170693 */     GIR_EraseRootFromParent_Done,
     /* 2170694 */   // Label 28621: @2170694
     /* 2170694 */   GIM_Try, /*On fail goto*//*Label 28622*/ GIMT_Encode4(2170785), // Rule ID 18318 //
     /* 2170699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2170702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2170710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2170713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2170719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170745 */     // MIs[0] round
     /* 2170745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170748 */     // MIs[0] policy
     /* 2170748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170758 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2170761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170784 */     // GIR_Coverage, 18318,
     /* 2170784 */     GIR_EraseRootFromParent_Done,
     /* 2170785 */   // Label 28622: @2170785
     /* 2170785 */   GIM_Try, /*On fail goto*//*Label 28623*/ GIMT_Encode4(2170876), // Rule ID 18319 //
     /* 2170790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2170793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2170801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2170804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2170810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170836 */     // MIs[0] round
     /* 2170836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170839 */     // MIs[0] policy
     /* 2170839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170849 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2170852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170875 */     // GIR_Coverage, 18319,
     /* 2170875 */     GIR_EraseRootFromParent_Done,
     /* 2170876 */   // Label 28623: @2170876
     /* 2170876 */   GIM_Try, /*On fail goto*//*Label 28624*/ GIMT_Encode4(2170967), // Rule ID 18322 //
     /* 2170881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2170892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2170895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2170901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2170911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170927 */     // MIs[0] round
     /* 2170927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170930 */     // MIs[0] policy
     /* 2170930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170940 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2170943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170966 */     // GIR_Coverage, 18322,
     /* 2170966 */     GIR_EraseRootFromParent_Done,
     /* 2170967 */   // Label 28624: @2170967
     /* 2170967 */   GIM_Try, /*On fail goto*//*Label 28625*/ GIMT_Encode4(2171058), // Rule ID 18323 //
     /* 2170972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2170983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2170986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2170992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171018 */     // MIs[0] round
     /* 2171018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171021 */     // MIs[0] policy
     /* 2171021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171031 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2171034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171057 */     // GIR_Coverage, 18323,
     /* 2171057 */     GIR_EraseRootFromParent_Done,
     /* 2171058 */   // Label 28625: @2171058
     /* 2171058 */   GIM_Try, /*On fail goto*//*Label 28626*/ GIMT_Encode4(2171149), // Rule ID 18326 //
     /* 2171063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2171074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2171077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2171083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171109 */     // MIs[0] round
     /* 2171109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171112 */     // MIs[0] policy
     /* 2171112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171122 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2171125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171148 */     // GIR_Coverage, 18326,
     /* 2171148 */     GIR_EraseRootFromParent_Done,
     /* 2171149 */   // Label 28626: @2171149
     /* 2171149 */   GIM_Try, /*On fail goto*//*Label 28627*/ GIMT_Encode4(2171240), // Rule ID 18327 //
     /* 2171154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2171165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2171168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2171174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171200 */     // MIs[0] round
     /* 2171200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171203 */     // MIs[0] policy
     /* 2171203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171213 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2171216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171239 */     // GIR_Coverage, 18327,
     /* 2171239 */     GIR_EraseRootFromParent_Done,
     /* 2171240 */   // Label 28627: @2171240
     /* 2171240 */   GIM_Try, /*On fail goto*//*Label 28628*/ GIMT_Encode4(2171331), // Rule ID 18330 //
     /* 2171245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2171256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2171259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2171265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2171268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171291 */     // MIs[0] round
     /* 2171291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171294 */     // MIs[0] policy
     /* 2171294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171304 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2171307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171330 */     // GIR_Coverage, 18330,
     /* 2171330 */     GIR_EraseRootFromParent_Done,
     /* 2171331 */   // Label 28628: @2171331
     /* 2171331 */   GIM_Try, /*On fail goto*//*Label 28629*/ GIMT_Encode4(2171422), // Rule ID 18331 //
     /* 2171336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2171347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2171350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2171356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2171359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171382 */     // MIs[0] round
     /* 2171382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171385 */     // MIs[0] policy
     /* 2171385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171395 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2171398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171421 */     // GIR_Coverage, 18331,
     /* 2171421 */     GIR_EraseRootFromParent_Done,
     /* 2171422 */   // Label 28629: @2171422
     /* 2171422 */   GIM_Try, /*On fail goto*//*Label 28630*/ GIMT_Encode4(2171513), // Rule ID 18334 //
     /* 2171427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2171438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2171441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2171447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171473 */     // MIs[0] round
     /* 2171473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171476 */     // MIs[0] policy
     /* 2171476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171486 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2171489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171512 */     // GIR_Coverage, 18334,
     /* 2171512 */     GIR_EraseRootFromParent_Done,
     /* 2171513 */   // Label 28630: @2171513
     /* 2171513 */   GIM_Try, /*On fail goto*//*Label 28631*/ GIMT_Encode4(2171604), // Rule ID 18335 //
     /* 2171518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2171529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2171532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2171538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171564 */     // MIs[0] round
     /* 2171564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171567 */     // MIs[0] policy
     /* 2171567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171577 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2171580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171603 */     // GIR_Coverage, 18335,
     /* 2171603 */     GIR_EraseRootFromParent_Done,
     /* 2171604 */   // Label 28631: @2171604
     /* 2171604 */   GIM_Try, /*On fail goto*//*Label 28632*/ GIMT_Encode4(2171695), // Rule ID 18338 //
     /* 2171609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2171620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2171623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2171629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2171632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171655 */     // MIs[0] round
     /* 2171655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171658 */     // MIs[0] policy
     /* 2171658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171668 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2171671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171694 */     // GIR_Coverage, 18338,
     /* 2171694 */     GIR_EraseRootFromParent_Done,
     /* 2171695 */   // Label 28632: @2171695
     /* 2171695 */   GIM_Try, /*On fail goto*//*Label 28633*/ GIMT_Encode4(2171786), // Rule ID 18339 //
     /* 2171700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2171711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2171714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2171720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2171723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171746 */     // MIs[0] round
     /* 2171746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171749 */     // MIs[0] policy
     /* 2171749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171759 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2171762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171785 */     // GIR_Coverage, 18339,
     /* 2171785 */     GIR_EraseRootFromParent_Done,
     /* 2171786 */   // Label 28633: @2171786
     /* 2171786 */   GIM_Try, /*On fail goto*//*Label 28634*/ GIMT_Encode4(2171877), // Rule ID 18342 //
     /* 2171791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2171802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2171805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2171811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171837 */     // MIs[0] round
     /* 2171837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171840 */     // MIs[0] policy
     /* 2171840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171850 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2171853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171876 */     // GIR_Coverage, 18342,
     /* 2171876 */     GIR_EraseRootFromParent_Done,
     /* 2171877 */   // Label 28634: @2171877
     /* 2171877 */   GIM_Try, /*On fail goto*//*Label 28635*/ GIMT_Encode4(2171968), // Rule ID 18343 //
     /* 2171882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2171893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2171896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2171902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171928 */     // MIs[0] round
     /* 2171928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171931 */     // MIs[0] policy
     /* 2171931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171941 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2171944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171967 */     // GIR_Coverage, 18343,
     /* 2171967 */     GIR_EraseRootFromParent_Done,
     /* 2171968 */   // Label 28635: @2171968
     /* 2171968 */   GIM_Try, /*On fail goto*//*Label 28636*/ GIMT_Encode4(2172059), // Rule ID 18346 //
     /* 2171973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2171976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2171984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2171987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2171990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2171993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172019 */     // MIs[0] round
     /* 2172019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172022 */     // MIs[0] policy
     /* 2172022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172032 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2172035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172058 */     // GIR_Coverage, 18346,
     /* 2172058 */     GIR_EraseRootFromParent_Done,
     /* 2172059 */   // Label 28636: @2172059
     /* 2172059 */   GIM_Try, /*On fail goto*//*Label 28637*/ GIMT_Encode4(2172150), // Rule ID 18347 //
     /* 2172064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2172075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2172078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2172084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2172087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172110 */     // MIs[0] round
     /* 2172110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172113 */     // MIs[0] policy
     /* 2172113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172123 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2172126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172149 */     // GIR_Coverage, 18347,
     /* 2172149 */     GIR_EraseRootFromParent_Done,
     /* 2172150 */   // Label 28637: @2172150
     /* 2172150 */   GIM_Try, /*On fail goto*//*Label 28638*/ GIMT_Encode4(2172241), // Rule ID 18350 //
     /* 2172155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2172158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2172166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2172169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2172175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172201 */     // MIs[0] round
     /* 2172201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172204 */     // MIs[0] policy
     /* 2172204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172214 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2172217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172240 */     // GIR_Coverage, 18350,
     /* 2172240 */     GIR_EraseRootFromParent_Done,
     /* 2172241 */   // Label 28638: @2172241
     /* 2172241 */   GIM_Try, /*On fail goto*//*Label 28639*/ GIMT_Encode4(2172332), // Rule ID 18351 //
     /* 2172246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2172257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2172260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2172266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172292 */     // MIs[0] round
     /* 2172292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172295 */     // MIs[0] policy
     /* 2172295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172305 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2172308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172331 */     // GIR_Coverage, 18351,
     /* 2172331 */     GIR_EraseRootFromParent_Done,
     /* 2172332 */   // Label 28639: @2172332
     /* 2172332 */   GIM_Try, /*On fail goto*//*Label 28640*/ GIMT_Encode4(2172423), // Rule ID 18354 //
     /* 2172337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2172340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2172348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2172351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2172357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172383 */     // MIs[0] round
     /* 2172383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172386 */     // MIs[0] policy
     /* 2172386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172396 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2172399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172422 */     // GIR_Coverage, 18354,
     /* 2172422 */     GIR_EraseRootFromParent_Done,
     /* 2172423 */   // Label 28640: @2172423
     /* 2172423 */   GIM_Try, /*On fail goto*//*Label 28641*/ GIMT_Encode4(2172514), // Rule ID 18355 //
     /* 2172428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2172439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2172442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2172448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172474 */     // MIs[0] round
     /* 2172474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172477 */     // MIs[0] policy
     /* 2172477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172487 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2172490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172513 */     // GIR_Coverage, 18355,
     /* 2172513 */     GIR_EraseRootFromParent_Done,
     /* 2172514 */   // Label 28641: @2172514
     /* 2172514 */   GIM_Try, /*On fail goto*//*Label 28642*/ GIMT_Encode4(2172605), // Rule ID 18358 //
     /* 2172519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2172530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2172533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2172536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2172539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172565 */     // MIs[0] round
     /* 2172565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172568 */     // MIs[0] policy
     /* 2172568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172578 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2172581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172604 */     // GIR_Coverage, 18358,
     /* 2172604 */     GIR_EraseRootFromParent_Done,
     /* 2172605 */   // Label 28642: @2172605
     /* 2172605 */   GIM_Try, /*On fail goto*//*Label 28643*/ GIMT_Encode4(2172696), // Rule ID 18359 //
     /* 2172610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2172613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2172621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2172624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2172627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2172630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172656 */     // MIs[0] round
     /* 2172656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172659 */     // MIs[0] policy
     /* 2172659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172669 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2172672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172695 */     // GIR_Coverage, 18359,
     /* 2172695 */     GIR_EraseRootFromParent_Done,
     /* 2172696 */   // Label 28643: @2172696
     /* 2172696 */   GIM_Try, /*On fail goto*//*Label 28644*/ GIMT_Encode4(2172787), // Rule ID 18362 //
     /* 2172701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2172712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2172715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2172718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2172721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2172724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172747 */     // MIs[0] round
     /* 2172747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172750 */     // MIs[0] policy
     /* 2172750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172760 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2172763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172786 */     // GIR_Coverage, 18362,
     /* 2172786 */     GIR_EraseRootFromParent_Done,
     /* 2172787 */   // Label 28644: @2172787
     /* 2172787 */   GIM_Try, /*On fail goto*//*Label 28645*/ GIMT_Encode4(2172878), // Rule ID 18363 //
     /* 2172792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2172795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2172803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2172806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2172809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2172812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2172815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172838 */     // MIs[0] round
     /* 2172838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172841 */     // MIs[0] policy
     /* 2172841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172851 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2172854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172877 */     // GIR_Coverage, 18363,
     /* 2172877 */     GIR_EraseRootFromParent_Done,
     /* 2172878 */   // Label 28645: @2172878
     /* 2172878 */   GIM_Try, /*On fail goto*//*Label 28646*/ GIMT_Encode4(2172969), // Rule ID 18366 //
     /* 2172883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2172886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2172894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2172897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2172900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2172903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172929 */     // MIs[0] round
     /* 2172929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172932 */     // MIs[0] policy
     /* 2172932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172942 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2172945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172968 */     // GIR_Coverage, 18366,
     /* 2172968 */     GIR_EraseRootFromParent_Done,
     /* 2172969 */   // Label 28646: @2172969
     /* 2172969 */   GIM_Try, /*On fail goto*//*Label 28647*/ GIMT_Encode4(2173060), // Rule ID 18367 //
     /* 2172974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2172977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2172985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2172988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2172991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2172994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173020 */     // MIs[0] round
     /* 2173020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173023 */     // MIs[0] policy
     /* 2173023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173033 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2173036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173059 */     // GIR_Coverage, 18367,
     /* 2173059 */     GIR_EraseRootFromParent_Done,
     /* 2173060 */   // Label 28647: @2173060
     /* 2173060 */   GIM_Try, /*On fail goto*//*Label 28648*/ GIMT_Encode4(2173151), // Rule ID 18370 //
     /* 2173065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2173076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2173079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2173082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2173085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173111 */     // MIs[0] round
     /* 2173111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173114 */     // MIs[0] policy
     /* 2173114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173124 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2173127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173150 */     // GIR_Coverage, 18370,
     /* 2173150 */     GIR_EraseRootFromParent_Done,
     /* 2173151 */   // Label 28648: @2173151
     /* 2173151 */   GIM_Try, /*On fail goto*//*Label 28649*/ GIMT_Encode4(2173242), // Rule ID 18371 //
     /* 2173156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2173167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2173170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2173173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2173176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173202 */     // MIs[0] round
     /* 2173202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173205 */     // MIs[0] policy
     /* 2173205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173215 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2173218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173241 */     // GIR_Coverage, 18371,
     /* 2173241 */     GIR_EraseRootFromParent_Done,
     /* 2173242 */   // Label 28649: @2173242
     /* 2173242 */   GIM_Try, /*On fail goto*//*Label 28650*/ GIMT_Encode4(2173333), // Rule ID 18374 //
     /* 2173247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2173250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2173258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2173261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2173264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2173267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173293 */     // MIs[0] round
     /* 2173293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173296 */     // MIs[0] policy
     /* 2173296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173306 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2173309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173332 */     // GIR_Coverage, 18374,
     /* 2173332 */     GIR_EraseRootFromParent_Done,
     /* 2173333 */   // Label 28650: @2173333
     /* 2173333 */   GIM_Try, /*On fail goto*//*Label 28651*/ GIMT_Encode4(2173424), // Rule ID 18375 //
     /* 2173338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2173341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2173349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2173352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2173355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2173358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173384 */     // MIs[0] round
     /* 2173384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173387 */     // MIs[0] policy
     /* 2173387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173397 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2173400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173423 */     // GIR_Coverage, 18375,
     /* 2173423 */     GIR_EraseRootFromParent_Done,
     /* 2173424 */   // Label 28651: @2173424
     /* 2173424 */   GIM_Try, /*On fail goto*//*Label 28652*/ GIMT_Encode4(2173515), // Rule ID 18378 //
     /* 2173429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2173432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2173440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2173443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2173446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2173449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173475 */     // MIs[0] round
     /* 2173475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173478 */     // MIs[0] policy
     /* 2173478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173488 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2173491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173514 */     // GIR_Coverage, 18378,
     /* 2173514 */     GIR_EraseRootFromParent_Done,
     /* 2173515 */   // Label 28652: @2173515
     /* 2173515 */   GIM_Try, /*On fail goto*//*Label 28653*/ GIMT_Encode4(2173606), // Rule ID 18379 //
     /* 2173520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2173523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2173531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2173534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2173537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2173540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173566 */     // MIs[0] round
     /* 2173566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173569 */     // MIs[0] policy
     /* 2173569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173579 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2173582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173605 */     // GIR_Coverage, 18379,
     /* 2173605 */     GIR_EraseRootFromParent_Done,
     /* 2173606 */   // Label 28653: @2173606
     /* 2173606 */   GIM_Try, /*On fail goto*//*Label 28654*/ GIMT_Encode4(2173697), // Rule ID 18382 //
     /* 2173611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2173622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2173625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2173628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2173631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2173634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2173641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173657 */     // MIs[0] round
     /* 2173657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173660 */     // MIs[0] policy
     /* 2173660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173670 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2173673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173696 */     // GIR_Coverage, 18382,
     /* 2173696 */     GIR_EraseRootFromParent_Done,
     /* 2173697 */   // Label 28654: @2173697
     /* 2173697 */   GIM_Try, /*On fail goto*//*Label 28655*/ GIMT_Encode4(2173788), // Rule ID 18383 //
     /* 2173702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2173713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2173716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2173719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2173722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2173725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2173732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173748 */     // MIs[0] round
     /* 2173748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173751 */     // MIs[0] policy
     /* 2173751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173761 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2173764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173787 */     // GIR_Coverage, 18383,
     /* 2173787 */     GIR_EraseRootFromParent_Done,
     /* 2173788 */   // Label 28655: @2173788
     /* 2173788 */   GIM_Try, /*On fail goto*//*Label 28656*/ GIMT_Encode4(2173879), // Rule ID 18386 //
     /* 2173793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2173804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2173807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2173810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2173813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2173816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2173823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173839 */     // MIs[0] round
     /* 2173839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173842 */     // MIs[0] policy
     /* 2173842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173852 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2173855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173878 */     // GIR_Coverage, 18386,
     /* 2173878 */     GIR_EraseRootFromParent_Done,
     /* 2173879 */   // Label 28656: @2173879
     /* 2173879 */   GIM_Try, /*On fail goto*//*Label 28657*/ GIMT_Encode4(2173970), // Rule ID 18387 //
     /* 2173884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2173895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2173898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2173901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2173904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2173907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2173914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173930 */     // MIs[0] round
     /* 2173930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173933 */     // MIs[0] policy
     /* 2173933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173943 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2173946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173969 */     // GIR_Coverage, 18387,
     /* 2173969 */     GIR_EraseRootFromParent_Done,
     /* 2173970 */   // Label 28657: @2173970
     /* 2173970 */   GIM_Try, /*On fail goto*//*Label 28658*/ GIMT_Encode4(2174061), // Rule ID 18390 //
     /* 2173975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2173986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2173989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2173992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2173995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2173998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174021 */     // MIs[0] round
     /* 2174021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174024 */     // MIs[0] policy
     /* 2174024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174034 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2174037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174060 */     // GIR_Coverage, 18390,
     /* 2174060 */     GIR_EraseRootFromParent_Done,
     /* 2174061 */   // Label 28658: @2174061
     /* 2174061 */   GIM_Try, /*On fail goto*//*Label 28659*/ GIMT_Encode4(2174152), // Rule ID 18391 //
     /* 2174066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2174069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2174077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2174080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2174083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2174086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2174089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174112 */     // MIs[0] round
     /* 2174112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174115 */     // MIs[0] policy
     /* 2174115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174125 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2174128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174151 */     // GIR_Coverage, 18391,
     /* 2174151 */     GIR_EraseRootFromParent_Done,
     /* 2174152 */   // Label 28659: @2174152
     /* 2174152 */   GIM_Try, /*On fail goto*//*Label 28660*/ GIMT_Encode4(2174243), // Rule ID 18394 //
     /* 2174157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2174168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2174171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2174174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2174177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174203 */     // MIs[0] round
     /* 2174203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174206 */     // MIs[0] policy
     /* 2174206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174216 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2174219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174242 */     // GIR_Coverage, 18394,
     /* 2174242 */     GIR_EraseRootFromParent_Done,
     /* 2174243 */   // Label 28660: @2174243
     /* 2174243 */   GIM_Try, /*On fail goto*//*Label 28661*/ GIMT_Encode4(2174334), // Rule ID 18395 //
     /* 2174248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2174259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2174262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2174265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2174268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174294 */     // MIs[0] round
     /* 2174294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174297 */     // MIs[0] policy
     /* 2174297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174307 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2174310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174333 */     // GIR_Coverage, 18395,
     /* 2174333 */     GIR_EraseRootFromParent_Done,
     /* 2174334 */   // Label 28661: @2174334
     /* 2174334 */   GIM_Try, /*On fail goto*//*Label 28662*/ GIMT_Encode4(2174425), // Rule ID 18398 //
     /* 2174339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2174350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2174353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2174356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2174359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174385 */     // MIs[0] round
     /* 2174385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174388 */     // MIs[0] policy
     /* 2174388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174398 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2174401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174424 */     // GIR_Coverage, 18398,
     /* 2174424 */     GIR_EraseRootFromParent_Done,
     /* 2174425 */   // Label 28662: @2174425
     /* 2174425 */   GIM_Try, /*On fail goto*//*Label 28663*/ GIMT_Encode4(2174516), // Rule ID 18399 //
     /* 2174430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2174441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2174444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2174447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2174450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174476 */     // MIs[0] round
     /* 2174476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174479 */     // MIs[0] policy
     /* 2174479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174489 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2174492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174515 */     // GIR_Coverage, 18399,
     /* 2174515 */     GIR_EraseRootFromParent_Done,
     /* 2174516 */   // Label 28663: @2174516
     /* 2174516 */   GIM_Try, /*On fail goto*//*Label 28664*/ GIMT_Encode4(2174607), // Rule ID 18402 //
     /* 2174521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2174532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2174535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2174538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2174541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2174544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174567 */     // MIs[0] round
     /* 2174567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174570 */     // MIs[0] policy
     /* 2174570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174580 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2174583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174606 */     // GIR_Coverage, 18402,
     /* 2174606 */     GIR_EraseRootFromParent_Done,
     /* 2174607 */   // Label 28664: @2174607
     /* 2174607 */   GIM_Try, /*On fail goto*//*Label 28665*/ GIMT_Encode4(2174698), // Rule ID 18403 //
     /* 2174612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2174623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2174626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2174629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2174632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2174635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174658 */     // MIs[0] round
     /* 2174658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174661 */     // MIs[0] policy
     /* 2174661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174671 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2174674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174697 */     // GIR_Coverage, 18403,
     /* 2174697 */     GIR_EraseRootFromParent_Done,
     /* 2174698 */   // Label 28665: @2174698
     /* 2174698 */   GIM_Try, /*On fail goto*//*Label 28666*/ GIMT_Encode4(2174789), // Rule ID 18406 //
     /* 2174703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2174706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2174714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2174717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2174720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2174723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2174726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174749 */     // MIs[0] round
     /* 2174749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174752 */     // MIs[0] policy
     /* 2174752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174762 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2174765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174788 */     // GIR_Coverage, 18406,
     /* 2174788 */     GIR_EraseRootFromParent_Done,
     /* 2174789 */   // Label 28666: @2174789
     /* 2174789 */   GIM_Try, /*On fail goto*//*Label 28667*/ GIMT_Encode4(2174880), // Rule ID 18407 //
     /* 2174794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2174797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2174805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2174808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2174811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2174814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2174817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174840 */     // MIs[0] round
     /* 2174840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174843 */     // MIs[0] policy
     /* 2174843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174853 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2174856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174879 */     // GIR_Coverage, 18407,
     /* 2174879 */     GIR_EraseRootFromParent_Done,
     /* 2174880 */   // Label 28667: @2174880
     /* 2174880 */   GIM_Try, /*On fail goto*//*Label 28668*/ GIMT_Encode4(2174971), // Rule ID 18410 //
     /* 2174885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2174888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2174896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2174899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2174902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2174905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174931 */     // MIs[0] round
     /* 2174931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174934 */     // MIs[0] policy
     /* 2174934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174944 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2174947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174970 */     // GIR_Coverage, 18410,
     /* 2174970 */     GIR_EraseRootFromParent_Done,
     /* 2174971 */   // Label 28668: @2174971
     /* 2174971 */   GIM_Try, /*On fail goto*//*Label 28669*/ GIMT_Encode4(2175062), // Rule ID 18411 //
     /* 2174976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2174979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2174987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2174990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2174993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2174996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2175006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175022 */     // MIs[0] round
     /* 2175022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175025 */     // MIs[0] policy
     /* 2175025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175035 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2175038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175061 */     // GIR_Coverage, 18411,
     /* 2175061 */     GIR_EraseRootFromParent_Done,
     /* 2175062 */   // Label 28669: @2175062
     /* 2175062 */   GIM_Try, /*On fail goto*//*Label 28670*/ GIMT_Encode4(2175153), // Rule ID 18414 //
     /* 2175067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2175070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2175078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2175081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2175084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2175087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2175090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175113 */     // MIs[0] round
     /* 2175113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175116 */     // MIs[0] policy
     /* 2175116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175126 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2175129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175152 */     // GIR_Coverage, 18414,
     /* 2175152 */     GIR_EraseRootFromParent_Done,
     /* 2175153 */   // Label 28670: @2175153
     /* 2175153 */   GIM_Try, /*On fail goto*//*Label 28671*/ GIMT_Encode4(2175244), // Rule ID 18415 //
     /* 2175158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2175161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2175169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2175172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2175175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2175178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2175181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175204 */     // MIs[0] round
     /* 2175204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175207 */     // MIs[0] policy
     /* 2175207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175217 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2175220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175243 */     // GIR_Coverage, 18415,
     /* 2175243 */     GIR_EraseRootFromParent_Done,
     /* 2175244 */   // Label 28671: @2175244
     /* 2175244 */   GIM_Try, /*On fail goto*//*Label 28672*/ GIMT_Encode4(2175335), // Rule ID 18418 //
     /* 2175249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2175260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2175263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2175269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175295 */     // MIs[0] round
     /* 2175295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175298 */     // MIs[0] policy
     /* 2175298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175308 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2175311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175334 */     // GIR_Coverage, 18418,
     /* 2175334 */     GIR_EraseRootFromParent_Done,
     /* 2175335 */   // Label 28672: @2175335
     /* 2175335 */   GIM_Try, /*On fail goto*//*Label 28673*/ GIMT_Encode4(2175426), // Rule ID 18419 //
     /* 2175340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2175351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2175354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2175360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175386 */     // MIs[0] round
     /* 2175386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175389 */     // MIs[0] policy
     /* 2175389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175399 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2175402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175425 */     // GIR_Coverage, 18419,
     /* 2175425 */     GIR_EraseRootFromParent_Done,
     /* 2175426 */   // Label 28673: @2175426
     /* 2175426 */   GIM_Try, /*On fail goto*//*Label 28674*/ GIMT_Encode4(2175517), // Rule ID 18422 //
     /* 2175431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2175442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2175445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2175451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175477 */     // MIs[0] round
     /* 2175477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175480 */     // MIs[0] policy
     /* 2175480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175490 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2175493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175516 */     // GIR_Coverage, 18422,
     /* 2175516 */     GIR_EraseRootFromParent_Done,
     /* 2175517 */   // Label 28674: @2175517
     /* 2175517 */   GIM_Try, /*On fail goto*//*Label 28675*/ GIMT_Encode4(2175608), // Rule ID 18423 //
     /* 2175522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2175533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2175536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2175542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175568 */     // MIs[0] round
     /* 2175568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175571 */     // MIs[0] policy
     /* 2175571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175581 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2175584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175607 */     // GIR_Coverage, 18423,
     /* 2175607 */     GIR_EraseRootFromParent_Done,
     /* 2175608 */   // Label 28675: @2175608
     /* 2175608 */   GIM_Try, /*On fail goto*//*Label 28676*/ GIMT_Encode4(2175699), // Rule ID 18426 //
     /* 2175613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2175616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2175624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2175627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2175633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175659 */     // MIs[0] round
     /* 2175659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175662 */     // MIs[0] policy
     /* 2175662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175672 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2175675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175698 */     // GIR_Coverage, 18426,
     /* 2175698 */     GIR_EraseRootFromParent_Done,
     /* 2175699 */   // Label 28676: @2175699
     /* 2175699 */   GIM_Try, /*On fail goto*//*Label 28677*/ GIMT_Encode4(2175790), // Rule ID 18427 //
     /* 2175704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2175707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2175715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2175718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2175724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175750 */     // MIs[0] round
     /* 2175750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175753 */     // MIs[0] policy
     /* 2175753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175763 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2175766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175789 */     // GIR_Coverage, 18427,
     /* 2175789 */     GIR_EraseRootFromParent_Done,
     /* 2175790 */   // Label 28677: @2175790
     /* 2175790 */   GIM_Try, /*On fail goto*//*Label 28678*/ GIMT_Encode4(2175881), // Rule ID 18430 //
     /* 2175795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2175806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2175809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2175815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175841 */     // MIs[0] round
     /* 2175841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175844 */     // MIs[0] policy
     /* 2175844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175854 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2175857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175880 */     // GIR_Coverage, 18430,
     /* 2175880 */     GIR_EraseRootFromParent_Done,
     /* 2175881 */   // Label 28678: @2175881
     /* 2175881 */   GIM_Try, /*On fail goto*//*Label 28679*/ GIMT_Encode4(2175972), // Rule ID 18431 //
     /* 2175886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2175897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2175900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2175906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175932 */     // MIs[0] round
     /* 2175932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175935 */     // MIs[0] policy
     /* 2175935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175945 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2175948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175971 */     // GIR_Coverage, 18431,
     /* 2175971 */     GIR_EraseRootFromParent_Done,
     /* 2175972 */   // Label 28679: @2175972
     /* 2175972 */   GIM_Try, /*On fail goto*//*Label 28680*/ GIMT_Encode4(2176063), // Rule ID 18434 //
     /* 2175977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2175980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2175988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2175991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2175997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176023 */     // MIs[0] round
     /* 2176023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176026 */     // MIs[0] policy
     /* 2176026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176036 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2176039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176062 */     // GIR_Coverage, 18434,
     /* 2176062 */     GIR_EraseRootFromParent_Done,
     /* 2176063 */   // Label 28680: @2176063
     /* 2176063 */   GIM_Try, /*On fail goto*//*Label 28681*/ GIMT_Encode4(2176154), // Rule ID 18435 //
     /* 2176068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2176071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2176079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2176082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2176088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176114 */     // MIs[0] round
     /* 2176114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176117 */     // MIs[0] policy
     /* 2176117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176127 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2176130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176153 */     // GIR_Coverage, 18435,
     /* 2176153 */     GIR_EraseRootFromParent_Done,
     /* 2176154 */   // Label 28681: @2176154
     /* 2176154 */   GIM_Try, /*On fail goto*//*Label 28682*/ GIMT_Encode4(2176245), // Rule ID 18438 //
     /* 2176159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2176162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2176170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2176173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2176179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176205 */     // MIs[0] round
     /* 2176205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176208 */     // MIs[0] policy
     /* 2176208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176218 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2176221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176244 */     // GIR_Coverage, 18438,
     /* 2176244 */     GIR_EraseRootFromParent_Done,
     /* 2176245 */   // Label 28682: @2176245
     /* 2176245 */   GIM_Try, /*On fail goto*//*Label 28683*/ GIMT_Encode4(2176336), // Rule ID 18439 //
     /* 2176250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2176253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2176261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2176264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2176270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176296 */     // MIs[0] round
     /* 2176296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176299 */     // MIs[0] policy
     /* 2176299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176309 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2176312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176335 */     // GIR_Coverage, 18439,
     /* 2176335 */     GIR_EraseRootFromParent_Done,
     /* 2176336 */   // Label 28683: @2176336
     /* 2176336 */   GIM_Try, /*On fail goto*//*Label 28684*/ GIMT_Encode4(2176427), // Rule ID 18442 //
     /* 2176341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2176352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2176355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2176361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176387 */     // MIs[0] round
     /* 2176387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176390 */     // MIs[0] policy
     /* 2176390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176400 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2176403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176426 */     // GIR_Coverage, 18442,
     /* 2176426 */     GIR_EraseRootFromParent_Done,
     /* 2176427 */   // Label 28684: @2176427
     /* 2176427 */   GIM_Try, /*On fail goto*//*Label 28685*/ GIMT_Encode4(2176518), // Rule ID 18443 //
     /* 2176432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2176443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2176446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2176452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176478 */     // MIs[0] round
     /* 2176478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176481 */     // MIs[0] policy
     /* 2176481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176491 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2176494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176517 */     // GIR_Coverage, 18443,
     /* 2176517 */     GIR_EraseRootFromParent_Done,
     /* 2176518 */   // Label 28685: @2176518
     /* 2176518 */   GIM_Try, /*On fail goto*//*Label 28686*/ GIMT_Encode4(2176609), // Rule ID 18446 //
     /* 2176523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2176534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2176537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2176543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2176546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2176553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176569 */     // MIs[0] round
     /* 2176569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176572 */     // MIs[0] policy
     /* 2176572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176582 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2176585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176608 */     // GIR_Coverage, 18446,
     /* 2176608 */     GIR_EraseRootFromParent_Done,
     /* 2176609 */   // Label 28686: @2176609
     /* 2176609 */   GIM_Try, /*On fail goto*//*Label 28687*/ GIMT_Encode4(2176700), // Rule ID 18447 //
     /* 2176614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2176625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2176628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2176634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2176637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2176644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176660 */     // MIs[0] round
     /* 2176660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176663 */     // MIs[0] policy
     /* 2176663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176673 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2176676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176699 */     // GIR_Coverage, 18447,
     /* 2176699 */     GIR_EraseRootFromParent_Done,
     /* 2176700 */   // Label 28687: @2176700
     /* 2176700 */   GIM_Try, /*On fail goto*//*Label 28688*/ GIMT_Encode4(2176791), // Rule ID 18450 //
     /* 2176705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2176716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2176719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2176725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2176728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2176735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176751 */     // MIs[0] round
     /* 2176751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176754 */     // MIs[0] policy
     /* 2176754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176764 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2176767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176790 */     // GIR_Coverage, 18450,
     /* 2176790 */     GIR_EraseRootFromParent_Done,
     /* 2176791 */   // Label 28688: @2176791
     /* 2176791 */   GIM_Try, /*On fail goto*//*Label 28689*/ GIMT_Encode4(2176882), // Rule ID 18451 //
     /* 2176796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2176807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2176810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2176816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2176819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2176826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176842 */     // MIs[0] round
     /* 2176842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176845 */     // MIs[0] policy
     /* 2176845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176855 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2176858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176881 */     // GIR_Coverage, 18451,
     /* 2176881 */     GIR_EraseRootFromParent_Done,
     /* 2176882 */   // Label 28689: @2176882
     /* 2176882 */   GIM_Try, /*On fail goto*//*Label 28690*/ GIMT_Encode4(2176973), // Rule ID 18454 //
     /* 2176887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2176890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2176898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2176901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2176907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176933 */     // MIs[0] round
     /* 2176933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176936 */     // MIs[0] policy
     /* 2176936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176946 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2176949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176972 */     // GIR_Coverage, 18454,
     /* 2176972 */     GIR_EraseRootFromParent_Done,
     /* 2176973 */   // Label 28690: @2176973
     /* 2176973 */   GIM_Try, /*On fail goto*//*Label 28691*/ GIMT_Encode4(2177064), // Rule ID 18455 //
     /* 2176978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2176981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2176989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2176992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2176998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177024 */     // MIs[0] round
     /* 2177024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177027 */     // MIs[0] policy
     /* 2177027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177037 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2177040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177063 */     // GIR_Coverage, 18455,
     /* 2177063 */     GIR_EraseRootFromParent_Done,
     /* 2177064 */   // Label 28691: @2177064
     /* 2177064 */   GIM_Try, /*On fail goto*//*Label 28692*/ GIMT_Encode4(2177155), // Rule ID 18458 //
     /* 2177069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2177072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2177080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2177083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2177089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177115 */     // MIs[0] round
     /* 2177115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177118 */     // MIs[0] policy
     /* 2177118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177128 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2177131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177154 */     // GIR_Coverage, 18458,
     /* 2177154 */     GIR_EraseRootFromParent_Done,
     /* 2177155 */   // Label 28692: @2177155
     /* 2177155 */   GIM_Try, /*On fail goto*//*Label 28693*/ GIMT_Encode4(2177246), // Rule ID 18459 //
     /* 2177160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2177171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2177174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2177180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177206 */     // MIs[0] round
     /* 2177206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177209 */     // MIs[0] policy
     /* 2177209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177219 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2177222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177245 */     // GIR_Coverage, 18459,
     /* 2177245 */     GIR_EraseRootFromParent_Done,
     /* 2177246 */   // Label 28693: @2177246
     /* 2177246 */   GIM_Try, /*On fail goto*//*Label 28694*/ GIMT_Encode4(2177337), // Rule ID 18462 //
     /* 2177251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2177254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2177262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2177265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2177271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177297 */     // MIs[0] round
     /* 2177297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177300 */     // MIs[0] policy
     /* 2177300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177310 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2177313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177336 */     // GIR_Coverage, 18462,
     /* 2177336 */     GIR_EraseRootFromParent_Done,
     /* 2177337 */   // Label 28694: @2177337
     /* 2177337 */   GIM_Try, /*On fail goto*//*Label 28695*/ GIMT_Encode4(2177428), // Rule ID 18463 //
     /* 2177342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2177353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2177356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2177362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177388 */     // MIs[0] round
     /* 2177388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177391 */     // MIs[0] policy
     /* 2177391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177401 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2177404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177427 */     // GIR_Coverage, 18463,
     /* 2177427 */     GIR_EraseRootFromParent_Done,
     /* 2177428 */   // Label 28695: @2177428
     /* 2177428 */   GIM_Try, /*On fail goto*//*Label 28696*/ GIMT_Encode4(2177519), // Rule ID 18466 //
     /* 2177433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2177436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2177444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2177447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2177453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177479 */     // MIs[0] round
     /* 2177479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177482 */     // MIs[0] policy
     /* 2177482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177492 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2177495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177518 */     // GIR_Coverage, 18466,
     /* 2177518 */     GIR_EraseRootFromParent_Done,
     /* 2177519 */   // Label 28696: @2177519
     /* 2177519 */   GIM_Try, /*On fail goto*//*Label 28697*/ GIMT_Encode4(2177610), // Rule ID 18467 //
     /* 2177524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2177527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2177535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2177538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2177544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177570 */     // MIs[0] round
     /* 2177570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177573 */     // MIs[0] policy
     /* 2177573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177583 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2177586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177609 */     // GIR_Coverage, 18467,
     /* 2177609 */     GIR_EraseRootFromParent_Done,
     /* 2177610 */   // Label 28697: @2177610
     /* 2177610 */   GIM_Try, /*On fail goto*//*Label 28698*/ GIMT_Encode4(2177701), // Rule ID 18470 //
     /* 2177615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2177618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2177626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2177629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2177635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177661 */     // MIs[0] round
     /* 2177661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177664 */     // MIs[0] policy
     /* 2177664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177674 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2177677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177700 */     // GIR_Coverage, 18470,
     /* 2177700 */     GIR_EraseRootFromParent_Done,
     /* 2177701 */   // Label 28698: @2177701
     /* 2177701 */   GIM_Try, /*On fail goto*//*Label 28699*/ GIMT_Encode4(2177792), // Rule ID 18471 //
     /* 2177706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2177709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2177717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2177720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2177726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177752 */     // MIs[0] round
     /* 2177752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177755 */     // MIs[0] policy
     /* 2177755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177765 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2177768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177791 */     // GIR_Coverage, 18471,
     /* 2177791 */     GIR_EraseRootFromParent_Done,
     /* 2177792 */   // Label 28699: @2177792
     /* 2177792 */   GIM_Try, /*On fail goto*//*Label 28700*/ GIMT_Encode4(2177883), // Rule ID 18474 //
     /* 2177797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2177800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2177808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2177811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2177817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177843 */     // MIs[0] round
     /* 2177843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177846 */     // MIs[0] policy
     /* 2177846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177856 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2177859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177882 */     // GIR_Coverage, 18474,
     /* 2177882 */     GIR_EraseRootFromParent_Done,
     /* 2177883 */   // Label 28700: @2177883
     /* 2177883 */   GIM_Try, /*On fail goto*//*Label 28701*/ GIMT_Encode4(2177974), // Rule ID 18475 //
     /* 2177888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2177891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2177899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2177902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2177908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177934 */     // MIs[0] round
     /* 2177934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177937 */     // MIs[0] policy
     /* 2177937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177947 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2177950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177973 */     // GIR_Coverage, 18475,
     /* 2177973 */     GIR_EraseRootFromParent_Done,
     /* 2177974 */   // Label 28701: @2177974
     /* 2177974 */   GIM_Try, /*On fail goto*//*Label 28702*/ GIMT_Encode4(2178065), // Rule ID 18478 //
     /* 2177979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2177982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2177987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2177990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2177993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2177996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2177999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178025 */     // MIs[0] round
     /* 2178025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178028 */     // MIs[0] policy
     /* 2178028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178038 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2178041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178064 */     // GIR_Coverage, 18478,
     /* 2178064 */     GIR_EraseRootFromParent_Done,
     /* 2178065 */   // Label 28702: @2178065
     /* 2178065 */   GIM_Try, /*On fail goto*//*Label 28703*/ GIMT_Encode4(2178156), // Rule ID 18479 //
     /* 2178070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2178073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2178081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2178084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2178087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2178090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178116 */     // MIs[0] round
     /* 2178116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178119 */     // MIs[0] policy
     /* 2178119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178129 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2178132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178155 */     // GIR_Coverage, 18479,
     /* 2178155 */     GIR_EraseRootFromParent_Done,
     /* 2178156 */   // Label 28703: @2178156
     /* 2178156 */   GIM_Try, /*On fail goto*//*Label 28704*/ GIMT_Encode4(2178247), // Rule ID 18482 //
     /* 2178161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2178164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2178172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2178175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2178178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2178181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178207 */     // MIs[0] round
     /* 2178207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178210 */     // MIs[0] policy
     /* 2178210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178220 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2178223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178246 */     // GIR_Coverage, 18482,
     /* 2178246 */     GIR_EraseRootFromParent_Done,
     /* 2178247 */   // Label 28704: @2178247
     /* 2178247 */   GIM_Try, /*On fail goto*//*Label 28705*/ GIMT_Encode4(2178338), // Rule ID 18483 //
     /* 2178252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2178255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2178263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2178266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2178269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2178272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178298 */     // MIs[0] round
     /* 2178298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178301 */     // MIs[0] policy
     /* 2178301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178311 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2178314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178337 */     // GIR_Coverage, 18483,
     /* 2178337 */     GIR_EraseRootFromParent_Done,
     /* 2178338 */   // Label 28705: @2178338
     /* 2178338 */   GIM_Try, /*On fail goto*//*Label 28706*/ GIMT_Encode4(2178429), // Rule ID 18486 //
     /* 2178343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2178346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2178354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2178357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2178360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2178363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178389 */     // MIs[0] round
     /* 2178389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178392 */     // MIs[0] policy
     /* 2178392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178402 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2178405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178428 */     // GIR_Coverage, 18486,
     /* 2178428 */     GIR_EraseRootFromParent_Done,
     /* 2178429 */   // Label 28706: @2178429
     /* 2178429 */   GIM_Try, /*On fail goto*//*Label 28707*/ GIMT_Encode4(2178520), // Rule ID 18487 //
     /* 2178434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2178437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2178445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2178448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2178451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2178454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178480 */     // MIs[0] round
     /* 2178480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178483 */     // MIs[0] policy
     /* 2178483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178493 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2178496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178519 */     // GIR_Coverage, 18487,
     /* 2178519 */     GIR_EraseRootFromParent_Done,
     /* 2178520 */   // Label 28707: @2178520
     /* 2178520 */   GIM_Try, /*On fail goto*//*Label 28708*/ GIMT_Encode4(2178611), // Rule ID 18490 //
     /* 2178525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2178528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2178536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2178539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2178542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2178545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178571 */     // MIs[0] round
     /* 2178571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178574 */     // MIs[0] policy
     /* 2178574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178584 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2178587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178610 */     // GIR_Coverage, 18490,
     /* 2178610 */     GIR_EraseRootFromParent_Done,
     /* 2178611 */   // Label 28708: @2178611
     /* 2178611 */   GIM_Try, /*On fail goto*//*Label 28709*/ GIMT_Encode4(2178702), // Rule ID 18491 //
     /* 2178616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2178619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2178627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2178630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2178633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2178636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178662 */     // MIs[0] round
     /* 2178662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178665 */     // MIs[0] policy
     /* 2178665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178675 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2178678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178701 */     // GIR_Coverage, 18491,
     /* 2178701 */     GIR_EraseRootFromParent_Done,
     /* 2178702 */   // Label 28709: @2178702
     /* 2178702 */   GIM_Try, /*On fail goto*//*Label 28710*/ GIMT_Encode4(2178793), // Rule ID 18494 //
     /* 2178707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2178710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2178718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2178721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2178724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2178727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178753 */     // MIs[0] round
     /* 2178753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178756 */     // MIs[0] policy
     /* 2178756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178766 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2178769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178792 */     // GIR_Coverage, 18494,
     /* 2178792 */     GIR_EraseRootFromParent_Done,
     /* 2178793 */   // Label 28710: @2178793
     /* 2178793 */   GIM_Try, /*On fail goto*//*Label 28711*/ GIMT_Encode4(2178884), // Rule ID 18495 //
     /* 2178798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2178801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2178809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2178812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2178815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2178818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178844 */     // MIs[0] round
     /* 2178844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178847 */     // MIs[0] policy
     /* 2178847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178857 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2178860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178883 */     // GIR_Coverage, 18495,
     /* 2178883 */     GIR_EraseRootFromParent_Done,
     /* 2178884 */   // Label 28711: @2178884
     /* 2178884 */   GIM_Try, /*On fail goto*//*Label 28712*/ GIMT_Encode4(2178975), // Rule ID 18498 //
     /* 2178889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2178892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2178900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2178903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2178906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2178909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178935 */     // MIs[0] round
     /* 2178935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178938 */     // MIs[0] policy
     /* 2178938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178948 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2178951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178974 */     // GIR_Coverage, 18498,
     /* 2178974 */     GIR_EraseRootFromParent_Done,
     /* 2178975 */   // Label 28712: @2178975
     /* 2178975 */   GIM_Try, /*On fail goto*//*Label 28713*/ GIMT_Encode4(2179066), // Rule ID 18499 //
     /* 2178980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2178983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2178991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2178994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2178997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2179000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179026 */     // MIs[0] round
     /* 2179026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179029 */     // MIs[0] policy
     /* 2179029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179039 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2179042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179065 */     // GIR_Coverage, 18499,
     /* 2179065 */     GIR_EraseRootFromParent_Done,
     /* 2179066 */   // Label 28713: @2179066
     /* 2179066 */   GIM_Try, /*On fail goto*//*Label 28714*/ GIMT_Encode4(2179157), // Rule ID 18502 //
     /* 2179071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2179082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2179085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2179088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2179091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179117 */     // MIs[0] round
     /* 2179117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179120 */     // MIs[0] policy
     /* 2179120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179130 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2179133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179156 */     // GIR_Coverage, 18502,
     /* 2179156 */     GIR_EraseRootFromParent_Done,
     /* 2179157 */   // Label 28714: @2179157
     /* 2179157 */   GIM_Try, /*On fail goto*//*Label 28715*/ GIMT_Encode4(2179248), // Rule ID 18503 //
     /* 2179162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2179173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2179176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2179179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2179182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179208 */     // MIs[0] round
     /* 2179208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179211 */     // MIs[0] policy
     /* 2179211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179221 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2179224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179247 */     // GIR_Coverage, 18503,
     /* 2179247 */     GIR_EraseRootFromParent_Done,
     /* 2179248 */   // Label 28715: @2179248
     /* 2179248 */   GIM_Try, /*On fail goto*//*Label 28716*/ GIMT_Encode4(2179339), // Rule ID 18506 //
     /* 2179253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2179264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2179267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2179270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2179273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2179276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179299 */     // MIs[0] round
     /* 2179299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179302 */     // MIs[0] policy
     /* 2179302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179312 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2179315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179338 */     // GIR_Coverage, 18506,
     /* 2179338 */     GIR_EraseRootFromParent_Done,
     /* 2179339 */   // Label 28716: @2179339
     /* 2179339 */   GIM_Try, /*On fail goto*//*Label 28717*/ GIMT_Encode4(2179430), // Rule ID 18507 //
     /* 2179344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2179355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2179358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2179361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2179364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2179367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179390 */     // MIs[0] round
     /* 2179390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179393 */     // MIs[0] policy
     /* 2179393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179403 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2179406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179429 */     // GIR_Coverage, 18507,
     /* 2179429 */     GIR_EraseRootFromParent_Done,
     /* 2179430 */   // Label 28717: @2179430
     /* 2179430 */   GIM_Try, /*On fail goto*//*Label 28718*/ GIMT_Encode4(2179521), // Rule ID 18510 //
     /* 2179435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2179446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2179449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2179452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2179455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2179458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2179465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179481 */     // MIs[0] round
     /* 2179481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179484 */     // MIs[0] policy
     /* 2179484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179494 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2179497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179520 */     // GIR_Coverage, 18510,
     /* 2179520 */     GIR_EraseRootFromParent_Done,
     /* 2179521 */   // Label 28718: @2179521
     /* 2179521 */   GIM_Try, /*On fail goto*//*Label 28719*/ GIMT_Encode4(2179612), // Rule ID 18511 //
     /* 2179526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2179537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2179540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2179543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2179546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2179549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2179556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179572 */     // MIs[0] round
     /* 2179572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179575 */     // MIs[0] policy
     /* 2179575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179585 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2179588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179611 */     // GIR_Coverage, 18511,
     /* 2179611 */     GIR_EraseRootFromParent_Done,
     /* 2179612 */   // Label 28719: @2179612
     /* 2179612 */   GIM_Try, /*On fail goto*//*Label 28720*/ GIMT_Encode4(2179703), // Rule ID 18514 //
     /* 2179617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2179620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2179628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2179631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2179634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2179637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179663 */     // MIs[0] round
     /* 2179663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179666 */     // MIs[0] policy
     /* 2179666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179676 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2179679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179702 */     // GIR_Coverage, 18514,
     /* 2179702 */     GIR_EraseRootFromParent_Done,
     /* 2179703 */   // Label 28720: @2179703
     /* 2179703 */   GIM_Try, /*On fail goto*//*Label 28721*/ GIMT_Encode4(2179794), // Rule ID 18515 //
     /* 2179708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2179711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2179719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2179722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2179725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2179728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179754 */     // MIs[0] round
     /* 2179754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179757 */     // MIs[0] policy
     /* 2179757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179767 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2179770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179793 */     // GIR_Coverage, 18515,
     /* 2179793 */     GIR_EraseRootFromParent_Done,
     /* 2179794 */   // Label 28721: @2179794
     /* 2179794 */   GIM_Try, /*On fail goto*//*Label 28722*/ GIMT_Encode4(2179885), // Rule ID 18518 //
     /* 2179799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2179802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2179810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2179813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2179816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2179819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179845 */     // MIs[0] round
     /* 2179845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179848 */     // MIs[0] policy
     /* 2179848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179858 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2179861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179884 */     // GIR_Coverage, 18518,
     /* 2179884 */     GIR_EraseRootFromParent_Done,
     /* 2179885 */   // Label 28722: @2179885
     /* 2179885 */   GIM_Try, /*On fail goto*//*Label 28723*/ GIMT_Encode4(2179976), // Rule ID 18519 //
     /* 2179890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2179893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2179901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2179904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2179907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2179910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179936 */     // MIs[0] round
     /* 2179936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179939 */     // MIs[0] policy
     /* 2179939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179949 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2179952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179975 */     // GIR_Coverage, 18519,
     /* 2179975 */     GIR_EraseRootFromParent_Done,
     /* 2179976 */   // Label 28723: @2179976
     /* 2179976 */   GIM_Try, /*On fail goto*//*Label 28724*/ GIMT_Encode4(2180067), // Rule ID 18522 //
     /* 2179981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2179984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2179992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2179995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2179998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2180001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2180004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180027 */     // MIs[0] round
     /* 2180027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180030 */     // MIs[0] policy
     /* 2180030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180040 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2180043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180066 */     // GIR_Coverage, 18522,
     /* 2180066 */     GIR_EraseRootFromParent_Done,
     /* 2180067 */   // Label 28724: @2180067
     /* 2180067 */   GIM_Try, /*On fail goto*//*Label 28725*/ GIMT_Encode4(2180158), // Rule ID 18523 //
     /* 2180072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2180075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2180083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2180086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2180089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2180092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2180095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180118 */     // MIs[0] round
     /* 2180118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180121 */     // MIs[0] policy
     /* 2180121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180131 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2180134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180157 */     // GIR_Coverage, 18523,
     /* 2180157 */     GIR_EraseRootFromParent_Done,
     /* 2180158 */   // Label 28725: @2180158
     /* 2180158 */   GIM_Try, /*On fail goto*//*Label 28726*/ GIMT_Encode4(2180249), // Rule ID 18526 //
     /* 2180163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2180166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2180174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2180177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2180180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2180183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180209 */     // MIs[0] round
     /* 2180209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180212 */     // MIs[0] policy
     /* 2180212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180222 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2180225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180248 */     // GIR_Coverage, 18526,
     /* 2180248 */     GIR_EraseRootFromParent_Done,
     /* 2180249 */   // Label 28726: @2180249
     /* 2180249 */   GIM_Try, /*On fail goto*//*Label 28727*/ GIMT_Encode4(2180340), // Rule ID 18527 //
     /* 2180254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2180257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2180265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2180268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2180271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2180274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180300 */     // MIs[0] round
     /* 2180300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180303 */     // MIs[0] policy
     /* 2180303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180313 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2180316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180339 */     // GIR_Coverage, 18527,
     /* 2180339 */     GIR_EraseRootFromParent_Done,
     /* 2180340 */   // Label 28727: @2180340
     /* 2180340 */   GIM_Try, /*On fail goto*//*Label 28728*/ GIMT_Encode4(2180431), // Rule ID 18530 //
     /* 2180345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2180348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2180356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2180359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2180362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2180365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180391 */     // MIs[0] round
     /* 2180391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180394 */     // MIs[0] policy
     /* 2180394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180404 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2180407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180430 */     // GIR_Coverage, 18530,
     /* 2180430 */     GIR_EraseRootFromParent_Done,
     /* 2180431 */   // Label 28728: @2180431
     /* 2180431 */   GIM_Try, /*On fail goto*//*Label 28729*/ GIMT_Encode4(2180522), // Rule ID 18531 //
     /* 2180436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2180439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2180447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2180450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2180453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2180456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180482 */     // MIs[0] round
     /* 2180482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180485 */     // MIs[0] policy
     /* 2180485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180495 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2180498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180521 */     // GIR_Coverage, 18531,
     /* 2180521 */     GIR_EraseRootFromParent_Done,
     /* 2180522 */   // Label 28729: @2180522
     /* 2180522 */   GIM_Try, /*On fail goto*//*Label 28730*/ GIMT_Encode4(2180613), // Rule ID 18534 //
     /* 2180527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2180530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2180538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2180541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2180544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2180547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180573 */     // MIs[0] round
     /* 2180573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180576 */     // MIs[0] policy
     /* 2180576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180586 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2180589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180612 */     // GIR_Coverage, 18534,
     /* 2180612 */     GIR_EraseRootFromParent_Done,
     /* 2180613 */   // Label 28730: @2180613
     /* 2180613 */   GIM_Try, /*On fail goto*//*Label 28731*/ GIMT_Encode4(2180704), // Rule ID 18535 //
     /* 2180618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2180621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2180629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2180632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2180635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2180638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180664 */     // MIs[0] round
     /* 2180664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180667 */     // MIs[0] policy
     /* 2180667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180677 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2180680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180703 */     // GIR_Coverage, 18535,
     /* 2180703 */     GIR_EraseRootFromParent_Done,
     /* 2180704 */   // Label 28731: @2180704
     /* 2180704 */   GIM_Try, /*On fail goto*//*Label 28732*/ GIMT_Encode4(2180795), // Rule ID 18538 //
     /* 2180709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2180712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2180720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2180723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2180729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2180732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180755 */     // MIs[0] round
     /* 2180755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180758 */     // MIs[0] policy
     /* 2180758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180768 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2180771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180794 */     // GIR_Coverage, 18538,
     /* 2180794 */     GIR_EraseRootFromParent_Done,
     /* 2180795 */   // Label 28732: @2180795
     /* 2180795 */   GIM_Try, /*On fail goto*//*Label 28733*/ GIMT_Encode4(2180886), // Rule ID 18539 //
     /* 2180800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2180803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2180811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2180814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2180820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2180823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180846 */     // MIs[0] round
     /* 2180846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180849 */     // MIs[0] policy
     /* 2180849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180859 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2180862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180885 */     // GIR_Coverage, 18539,
     /* 2180885 */     GIR_EraseRootFromParent_Done,
     /* 2180886 */   // Label 28733: @2180886
     /* 2180886 */   GIM_Try, /*On fail goto*//*Label 28734*/ GIMT_Encode4(2180977), // Rule ID 18542 //
     /* 2180891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2180894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2180902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2180905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2180911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180937 */     // MIs[0] round
     /* 2180937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180940 */     // MIs[0] policy
     /* 2180940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180950 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2180953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180976 */     // GIR_Coverage, 18542,
     /* 2180976 */     GIR_EraseRootFromParent_Done,
     /* 2180977 */   // Label 28734: @2180977
     /* 2180977 */   GIM_Try, /*On fail goto*//*Label 28735*/ GIMT_Encode4(2181068), // Rule ID 18543 //
     /* 2180982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2180985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2180993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2180996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2181002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181028 */     // MIs[0] round
     /* 2181028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181031 */     // MIs[0] policy
     /* 2181031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181041 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2181044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181067 */     // GIR_Coverage, 18543,
     /* 2181067 */     GIR_EraseRootFromParent_Done,
     /* 2181068 */   // Label 28735: @2181068
     /* 2181068 */   GIM_Try, /*On fail goto*//*Label 28736*/ GIMT_Encode4(2181159), // Rule ID 18546 //
     /* 2181073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2181076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2181084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2181087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2181093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181119 */     // MIs[0] round
     /* 2181119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181122 */     // MIs[0] policy
     /* 2181122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181132 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2181135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181158 */     // GIR_Coverage, 18546,
     /* 2181158 */     GIR_EraseRootFromParent_Done,
     /* 2181159 */   // Label 28736: @2181159
     /* 2181159 */   GIM_Try, /*On fail goto*//*Label 28737*/ GIMT_Encode4(2181250), // Rule ID 18547 //
     /* 2181164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2181167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2181175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2181178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2181184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181210 */     // MIs[0] round
     /* 2181210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181213 */     // MIs[0] policy
     /* 2181213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181223 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2181226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181249 */     // GIR_Coverage, 18547,
     /* 2181249 */     GIR_EraseRootFromParent_Done,
     /* 2181250 */   // Label 28737: @2181250
     /* 2181250 */   GIM_Try, /*On fail goto*//*Label 28738*/ GIMT_Encode4(2181341), // Rule ID 18550 //
     /* 2181255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2181266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2181269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2181275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181301 */     // MIs[0] round
     /* 2181301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181304 */     // MIs[0] policy
     /* 2181304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181314 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2181317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181340 */     // GIR_Coverage, 18550,
     /* 2181340 */     GIR_EraseRootFromParent_Done,
     /* 2181341 */   // Label 28738: @2181341
     /* 2181341 */   GIM_Try, /*On fail goto*//*Label 28739*/ GIMT_Encode4(2181432), // Rule ID 18551 //
     /* 2181346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2181349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2181357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2181360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2181366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181392 */     // MIs[0] round
     /* 2181392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181395 */     // MIs[0] policy
     /* 2181395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181405 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2181408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181431 */     // GIR_Coverage, 18551,
     /* 2181431 */     GIR_EraseRootFromParent_Done,
     /* 2181432 */   // Label 28739: @2181432
     /* 2181432 */   GIM_Try, /*On fail goto*//*Label 28740*/ GIMT_Encode4(2181523), // Rule ID 18554 //
     /* 2181437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2181440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2181448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2181451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2181457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181483 */     // MIs[0] round
     /* 2181483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181486 */     // MIs[0] policy
     /* 2181486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181496 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2181499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181522 */     // GIR_Coverage, 18554,
     /* 2181522 */     GIR_EraseRootFromParent_Done,
     /* 2181523 */   // Label 28740: @2181523
     /* 2181523 */   GIM_Try, /*On fail goto*//*Label 28741*/ GIMT_Encode4(2181614), // Rule ID 18555 //
     /* 2181528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2181531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2181539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2181542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2181548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181574 */     // MIs[0] round
     /* 2181574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181577 */     // MIs[0] policy
     /* 2181577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181587 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2181590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181613 */     // GIR_Coverage, 18555,
     /* 2181613 */     GIR_EraseRootFromParent_Done,
     /* 2181614 */   // Label 28741: @2181614
     /* 2181614 */   GIM_Try, /*On fail goto*//*Label 28742*/ GIMT_Encode4(2181705), // Rule ID 18558 //
     /* 2181619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2181622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2181630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2181633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2181639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181665 */     // MIs[0] round
     /* 2181665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181668 */     // MIs[0] policy
     /* 2181668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181678 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2181681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181704 */     // GIR_Coverage, 18558,
     /* 2181704 */     GIR_EraseRootFromParent_Done,
     /* 2181705 */   // Label 28742: @2181705
     /* 2181705 */   GIM_Try, /*On fail goto*//*Label 28743*/ GIMT_Encode4(2181796), // Rule ID 18559 //
     /* 2181710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2181713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2181721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2181724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2181730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181756 */     // MIs[0] round
     /* 2181756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181759 */     // MIs[0] policy
     /* 2181759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181769 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2181772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181795 */     // GIR_Coverage, 18559,
     /* 2181795 */     GIR_EraseRootFromParent_Done,
     /* 2181796 */   // Label 28743: @2181796
     /* 2181796 */   GIM_Try, /*On fail goto*//*Label 28744*/ GIMT_Encode4(2181887), // Rule ID 18562 //
     /* 2181801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2181812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2181815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2181821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2181831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181847 */     // MIs[0] round
     /* 2181847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181850 */     // MIs[0] policy
     /* 2181850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181860 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2181863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181886 */     // GIR_Coverage, 18562,
     /* 2181886 */     GIR_EraseRootFromParent_Done,
     /* 2181887 */   // Label 28744: @2181887
     /* 2181887 */   GIM_Try, /*On fail goto*//*Label 28745*/ GIMT_Encode4(2181978), // Rule ID 18563 //
     /* 2181892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2181895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2181903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2181906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2181912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2181922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181938 */     // MIs[0] round
     /* 2181938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181941 */     // MIs[0] policy
     /* 2181941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181951 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2181954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181977 */     // GIR_Coverage, 18563,
     /* 2181977 */     GIR_EraseRootFromParent_Done,
     /* 2181978 */   // Label 28745: @2181978
     /* 2181978 */   GIM_Try, /*On fail goto*//*Label 28746*/ GIMT_Encode4(2182069), // Rule ID 18566 //
     /* 2181983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2181994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2181997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2182003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2182006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182029 */     // MIs[0] round
     /* 2182029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182032 */     // MIs[0] policy
     /* 2182032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182042 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2182045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182068 */     // GIR_Coverage, 18566,
     /* 2182068 */     GIR_EraseRootFromParent_Done,
     /* 2182069 */   // Label 28746: @2182069
     /* 2182069 */   GIM_Try, /*On fail goto*//*Label 28747*/ GIMT_Encode4(2182160), // Rule ID 18567 //
     /* 2182074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2182085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2182088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2182094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2182097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182120 */     // MIs[0] round
     /* 2182120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182123 */     // MIs[0] policy
     /* 2182123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182133 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2182136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182159 */     // GIR_Coverage, 18567,
     /* 2182159 */     GIR_EraseRootFromParent_Done,
     /* 2182160 */   // Label 28747: @2182160
     /* 2182160 */   GIM_Try, /*On fail goto*//*Label 28748*/ GIMT_Encode4(2182251), // Rule ID 18570 //
     /* 2182165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2182168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2182176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2182179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2182185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2182188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182211 */     // MIs[0] round
     /* 2182211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182214 */     // MIs[0] policy
     /* 2182214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182224 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2182227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182250 */     // GIR_Coverage, 18570,
     /* 2182250 */     GIR_EraseRootFromParent_Done,
     /* 2182251 */   // Label 28748: @2182251
     /* 2182251 */   GIM_Try, /*On fail goto*//*Label 28749*/ GIMT_Encode4(2182342), // Rule ID 18571 //
     /* 2182256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2182267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2182270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2182276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2182279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182302 */     // MIs[0] round
     /* 2182302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182305 */     // MIs[0] policy
     /* 2182305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182315 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2182318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182341 */     // GIR_Coverage, 18571,
     /* 2182341 */     GIR_EraseRootFromParent_Done,
     /* 2182342 */   // Label 28749: @2182342
     /* 2182342 */   GIM_Try, /*On fail goto*//*Label 28750*/ GIMT_Encode4(2182433), // Rule ID 18574 //
     /* 2182347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2182358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2182361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2182367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182393 */     // MIs[0] round
     /* 2182393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182396 */     // MIs[0] policy
     /* 2182396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182406 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2182409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182432 */     // GIR_Coverage, 18574,
     /* 2182432 */     GIR_EraseRootFromParent_Done,
     /* 2182433 */   // Label 28750: @2182433
     /* 2182433 */   GIM_Try, /*On fail goto*//*Label 28751*/ GIMT_Encode4(2182524), // Rule ID 18575 //
     /* 2182438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2182441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2182449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2182452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2182458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182484 */     // MIs[0] round
     /* 2182484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182487 */     // MIs[0] policy
     /* 2182487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182497 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2182500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182523 */     // GIR_Coverage, 18575,
     /* 2182523 */     GIR_EraseRootFromParent_Done,
     /* 2182524 */   // Label 28751: @2182524
     /* 2182524 */   GIM_Try, /*On fail goto*//*Label 28752*/ GIMT_Encode4(2182615), // Rule ID 18578 //
     /* 2182529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2182540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2182543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2182549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2182552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182575 */     // MIs[0] round
     /* 2182575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182578 */     // MIs[0] policy
     /* 2182578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182588 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2182591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182614 */     // GIR_Coverage, 18578,
     /* 2182614 */     GIR_EraseRootFromParent_Done,
     /* 2182615 */   // Label 28752: @2182615
     /* 2182615 */   GIM_Try, /*On fail goto*//*Label 28753*/ GIMT_Encode4(2182706), // Rule ID 18579 //
     /* 2182620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2182623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2182631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2182634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2182640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2182643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182666 */     // MIs[0] round
     /* 2182666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182669 */     // MIs[0] policy
     /* 2182669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182679 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2182682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182705 */     // GIR_Coverage, 18579,
     /* 2182705 */     GIR_EraseRootFromParent_Done,
     /* 2182706 */   // Label 28753: @2182706
     /* 2182706 */   GIM_Try, /*On fail goto*//*Label 28754*/ GIMT_Encode4(2182797), // Rule ID 18582 //
     /* 2182711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2182722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2182725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2182731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2182734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182757 */     // MIs[0] round
     /* 2182757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182760 */     // MIs[0] policy
     /* 2182760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182770 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2182773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182796 */     // GIR_Coverage, 18582,
     /* 2182796 */     GIR_EraseRootFromParent_Done,
     /* 2182797 */   // Label 28754: @2182797
     /* 2182797 */   GIM_Try, /*On fail goto*//*Label 28755*/ GIMT_Encode4(2182888), // Rule ID 18583 //
     /* 2182802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2182805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2182813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2182816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2182822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2182825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182848 */     // MIs[0] round
     /* 2182848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182851 */     // MIs[0] policy
     /* 2182851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182861 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2182864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182887 */     // GIR_Coverage, 18583,
     /* 2182887 */     GIR_EraseRootFromParent_Done,
     /* 2182888 */   // Label 28755: @2182888
     /* 2182888 */   GIM_Try, /*On fail goto*//*Label 28756*/ GIMT_Encode4(2182979), // Rule ID 18586 //
     /* 2182893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2182896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2182904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2182907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2182910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2182913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2182931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182939 */     // MIs[0] round
     /* 2182939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182942 */     // MIs[0] policy
     /* 2182942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2182955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182978 */     // GIR_Coverage, 18586,
     /* 2182978 */     GIR_EraseRootFromParent_Done,
     /* 2182979 */   // Label 28756: @2182979
     /* 2182979 */   GIM_Try, /*On fail goto*//*Label 28757*/ GIMT_Encode4(2183070), // Rule ID 18587 //
     /* 2182984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2182987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2182995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2182998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2183004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183030 */     // MIs[0] round
     /* 2183030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183033 */     // MIs[0] policy
     /* 2183033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183043 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2183046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183069 */     // GIR_Coverage, 18587,
     /* 2183069 */     GIR_EraseRootFromParent_Done,
     /* 2183070 */   // Label 28757: @2183070
     /* 2183070 */   GIM_Try, /*On fail goto*//*Label 28758*/ GIMT_Encode4(2183161), // Rule ID 18590 //
     /* 2183075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2183078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2183086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2183089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2183095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183121 */     // MIs[0] round
     /* 2183121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183124 */     // MIs[0] policy
     /* 2183124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183134 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2183137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183160 */     // GIR_Coverage, 18590,
     /* 2183160 */     GIR_EraseRootFromParent_Done,
     /* 2183161 */   // Label 28758: @2183161
     /* 2183161 */   GIM_Try, /*On fail goto*//*Label 28759*/ GIMT_Encode4(2183252), // Rule ID 18591 //
     /* 2183166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2183169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2183177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2183180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2183186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183212 */     // MIs[0] round
     /* 2183212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183215 */     // MIs[0] policy
     /* 2183215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183225 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2183228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183251 */     // GIR_Coverage, 18591,
     /* 2183251 */     GIR_EraseRootFromParent_Done,
     /* 2183252 */   // Label 28759: @2183252
     /* 2183252 */   GIM_Try, /*On fail goto*//*Label 28760*/ GIMT_Encode4(2183343), // Rule ID 18594 //
     /* 2183257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2183260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2183268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2183271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2183277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183303 */     // MIs[0] round
     /* 2183303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183306 */     // MIs[0] policy
     /* 2183306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183316 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2183319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183342 */     // GIR_Coverage, 18594,
     /* 2183342 */     GIR_EraseRootFromParent_Done,
     /* 2183343 */   // Label 28760: @2183343
     /* 2183343 */   GIM_Try, /*On fail goto*//*Label 28761*/ GIMT_Encode4(2183434), // Rule ID 18595 //
     /* 2183348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2183351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2183359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2183362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2183368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183394 */     // MIs[0] round
     /* 2183394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183397 */     // MIs[0] policy
     /* 2183397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183407 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2183410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183433 */     // GIR_Coverage, 18595,
     /* 2183433 */     GIR_EraseRootFromParent_Done,
     /* 2183434 */   // Label 28761: @2183434
     /* 2183434 */   GIM_Try, /*On fail goto*//*Label 28762*/ GIMT_Encode4(2183525), // Rule ID 18598 //
     /* 2183439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2183442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2183450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2183453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2183456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2183459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183485 */     // MIs[0] round
     /* 2183485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183488 */     // MIs[0] policy
     /* 2183488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183498 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2183501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183524 */     // GIR_Coverage, 18598,
     /* 2183524 */     GIR_EraseRootFromParent_Done,
     /* 2183525 */   // Label 28762: @2183525
     /* 2183525 */   GIM_Try, /*On fail goto*//*Label 28763*/ GIMT_Encode4(2183616), // Rule ID 18599 //
     /* 2183530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2183533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2183541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2183544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2183547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2183550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183576 */     // MIs[0] round
     /* 2183576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183579 */     // MIs[0] policy
     /* 2183579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183589 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2183592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183615 */     // GIR_Coverage, 18599,
     /* 2183615 */     GIR_EraseRootFromParent_Done,
     /* 2183616 */   // Label 28763: @2183616
     /* 2183616 */   GIM_Try, /*On fail goto*//*Label 28764*/ GIMT_Encode4(2183707), // Rule ID 18602 //
     /* 2183621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2183624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2183632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2183635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2183638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2183641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183667 */     // MIs[0] round
     /* 2183667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183670 */     // MIs[0] policy
     /* 2183670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183680 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2183683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183706 */     // GIR_Coverage, 18602,
     /* 2183706 */     GIR_EraseRootFromParent_Done,
     /* 2183707 */   // Label 28764: @2183707
     /* 2183707 */   GIM_Try, /*On fail goto*//*Label 28765*/ GIMT_Encode4(2183798), // Rule ID 18603 //
     /* 2183712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2183715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2183723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2183726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2183729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2183732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183758 */     // MIs[0] round
     /* 2183758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183761 */     // MIs[0] policy
     /* 2183761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183771 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2183774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183797 */     // GIR_Coverage, 18603,
     /* 2183797 */     GIR_EraseRootFromParent_Done,
     /* 2183798 */   // Label 28765: @2183798
     /* 2183798 */   GIM_Try, /*On fail goto*//*Label 28766*/ GIMT_Encode4(2183889), // Rule ID 18606 //
     /* 2183803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2183806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2183814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2183817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2183820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2183823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183849 */     // MIs[0] round
     /* 2183849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183852 */     // MIs[0] policy
     /* 2183852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183862 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2183865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183888 */     // GIR_Coverage, 18606,
     /* 2183888 */     GIR_EraseRootFromParent_Done,
     /* 2183889 */   // Label 28766: @2183889
     /* 2183889 */   GIM_Try, /*On fail goto*//*Label 28767*/ GIMT_Encode4(2183980), // Rule ID 18607 //
     /* 2183894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2183897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2183905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2183908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2183911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2183914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183940 */     // MIs[0] round
     /* 2183940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183943 */     // MIs[0] policy
     /* 2183943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183953 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2183956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183979 */     // GIR_Coverage, 18607,
     /* 2183979 */     GIR_EraseRootFromParent_Done,
     /* 2183980 */   // Label 28767: @2183980
     /* 2183980 */   GIM_Try, /*On fail goto*//*Label 28768*/ GIMT_Encode4(2184071), // Rule ID 18610 //
     /* 2183985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2183988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2183996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2183999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2184002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2184005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184031 */     // MIs[0] round
     /* 2184031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184034 */     // MIs[0] policy
     /* 2184034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184044 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2184047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184070 */     // GIR_Coverage, 18610,
     /* 2184070 */     GIR_EraseRootFromParent_Done,
     /* 2184071 */   // Label 28768: @2184071
     /* 2184071 */   GIM_Try, /*On fail goto*//*Label 28769*/ GIMT_Encode4(2184162), // Rule ID 18611 //
     /* 2184076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2184087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2184090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2184093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2184096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184122 */     // MIs[0] round
     /* 2184122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184125 */     // MIs[0] policy
     /* 2184125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184135 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2184138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184161 */     // GIR_Coverage, 18611,
     /* 2184161 */     GIR_EraseRootFromParent_Done,
     /* 2184162 */   // Label 28769: @2184162
     /* 2184162 */   GIM_Try, /*On fail goto*//*Label 28770*/ GIMT_Encode4(2184253), // Rule ID 18614 //
     /* 2184167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2184170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2184178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2184181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2184184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2184187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184213 */     // MIs[0] round
     /* 2184213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184216 */     // MIs[0] policy
     /* 2184216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184226 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2184229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184252 */     // GIR_Coverage, 18614,
     /* 2184252 */     GIR_EraseRootFromParent_Done,
     /* 2184253 */   // Label 28770: @2184253
     /* 2184253 */   GIM_Try, /*On fail goto*//*Label 28771*/ GIMT_Encode4(2184344), // Rule ID 18615 //
     /* 2184258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2184261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2184269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2184272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2184275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2184278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184304 */     // MIs[0] round
     /* 2184304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184307 */     // MIs[0] policy
     /* 2184307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184317 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2184320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184343 */     // GIR_Coverage, 18615,
     /* 2184343 */     GIR_EraseRootFromParent_Done,
     /* 2184344 */   // Label 28771: @2184344
     /* 2184344 */   GIM_Try, /*On fail goto*//*Label 28772*/ GIMT_Encode4(2184435), // Rule ID 18618 //
     /* 2184349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2184352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2184360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2184363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2184366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2184369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184395 */     // MIs[0] round
     /* 2184395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184398 */     // MIs[0] policy
     /* 2184398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184408 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2184411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184434 */     // GIR_Coverage, 18618,
     /* 2184434 */     GIR_EraseRootFromParent_Done,
     /* 2184435 */   // Label 28772: @2184435
     /* 2184435 */   GIM_Try, /*On fail goto*//*Label 28773*/ GIMT_Encode4(2184526), // Rule ID 18619 //
     /* 2184440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2184443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2184451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2184454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2184457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2184460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184486 */     // MIs[0] round
     /* 2184486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184489 */     // MIs[0] policy
     /* 2184489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184499 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2184502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184525 */     // GIR_Coverage, 18619,
     /* 2184525 */     GIR_EraseRootFromParent_Done,
     /* 2184526 */   // Label 28773: @2184526
     /* 2184526 */   GIM_Try, /*On fail goto*//*Label 28774*/ GIMT_Encode4(2184617), // Rule ID 18622 //
     /* 2184531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2184542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2184545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2184548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2184551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2184554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2184561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184577 */     // MIs[0] round
     /* 2184577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184580 */     // MIs[0] policy
     /* 2184580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184590 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2184593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184616 */     // GIR_Coverage, 18622,
     /* 2184616 */     GIR_EraseRootFromParent_Done,
     /* 2184617 */   // Label 28774: @2184617
     /* 2184617 */   GIM_Try, /*On fail goto*//*Label 28775*/ GIMT_Encode4(2184708), // Rule ID 18623 //
     /* 2184622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2184633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2184636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2184639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2184642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2184645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2184652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184668 */     // MIs[0] round
     /* 2184668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184671 */     // MIs[0] policy
     /* 2184671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184681 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2184684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184707 */     // GIR_Coverage, 18623,
     /* 2184707 */     GIR_EraseRootFromParent_Done,
     /* 2184708 */   // Label 28775: @2184708
     /* 2184708 */   GIM_Try, /*On fail goto*//*Label 28776*/ GIMT_Encode4(2184799), // Rule ID 18626 //
     /* 2184713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2184724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2184727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2184730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2184733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2184736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2184743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184759 */     // MIs[0] round
     /* 2184759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184762 */     // MIs[0] policy
     /* 2184762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184772 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2184775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184798 */     // GIR_Coverage, 18626,
     /* 2184798 */     GIR_EraseRootFromParent_Done,
     /* 2184799 */   // Label 28776: @2184799
     /* 2184799 */   GIM_Try, /*On fail goto*//*Label 28777*/ GIMT_Encode4(2184890), // Rule ID 18627 //
     /* 2184804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2184815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2184818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2184821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2184824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2184827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2184834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184850 */     // MIs[0] round
     /* 2184850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184853 */     // MIs[0] policy
     /* 2184853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184863 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2184866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184889 */     // GIR_Coverage, 18627,
     /* 2184889 */     GIR_EraseRootFromParent_Done,
     /* 2184890 */   // Label 28777: @2184890
     /* 2184890 */   GIM_Try, /*On fail goto*//*Label 28778*/ GIMT_Encode4(2184981), // Rule ID 18630 //
     /* 2184895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2184906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2184909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2184912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2184915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2184918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2184925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184941 */     // MIs[0] round
     /* 2184941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184944 */     // MIs[0] policy
     /* 2184944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184954 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2184957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184980 */     // GIR_Coverage, 18630,
     /* 2184980 */     GIR_EraseRootFromParent_Done,
     /* 2184981 */   // Label 28778: @2184981
     /* 2184981 */   GIM_Try, /*On fail goto*//*Label 28779*/ GIMT_Encode4(2185072), // Rule ID 18631 //
     /* 2184986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2184997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2185000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2185003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2185006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2185009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185032 */     // MIs[0] round
     /* 2185032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185035 */     // MIs[0] policy
     /* 2185035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185045 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2185048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185071 */     // GIR_Coverage, 18631,
     /* 2185071 */     GIR_EraseRootFromParent_Done,
     /* 2185072 */   // Label 28779: @2185072
     /* 2185072 */   GIM_Try, /*On fail goto*//*Label 28780*/ GIMT_Encode4(2185163), // Rule ID 18634 //
     /* 2185077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2185088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2185091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2185094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2185097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185123 */     // MIs[0] round
     /* 2185123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185126 */     // MIs[0] policy
     /* 2185126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185136 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2185139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185162 */     // GIR_Coverage, 18634,
     /* 2185162 */     GIR_EraseRootFromParent_Done,
     /* 2185163 */   // Label 28780: @2185163
     /* 2185163 */   GIM_Try, /*On fail goto*//*Label 28781*/ GIMT_Encode4(2185254), // Rule ID 18635 //
     /* 2185168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2185179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2185182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2185185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2185188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185214 */     // MIs[0] round
     /* 2185214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185217 */     // MIs[0] policy
     /* 2185217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185227 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2185230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185253 */     // GIR_Coverage, 18635,
     /* 2185253 */     GIR_EraseRootFromParent_Done,
     /* 2185254 */   // Label 28781: @2185254
     /* 2185254 */   GIM_Try, /*On fail goto*//*Label 28782*/ GIMT_Encode4(2185345), // Rule ID 18638 //
     /* 2185259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2185270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2185273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2185276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2185279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185305 */     // MIs[0] round
     /* 2185305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185308 */     // MIs[0] policy
     /* 2185308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185318 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2185321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185344 */     // GIR_Coverage, 18638,
     /* 2185344 */     GIR_EraseRootFromParent_Done,
     /* 2185345 */   // Label 28782: @2185345
     /* 2185345 */   GIM_Try, /*On fail goto*//*Label 28783*/ GIMT_Encode4(2185436), // Rule ID 18639 //
     /* 2185350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2185361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2185364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2185367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2185370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185396 */     // MIs[0] round
     /* 2185396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185399 */     // MIs[0] policy
     /* 2185399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185409 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2185412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185435 */     // GIR_Coverage, 18639,
     /* 2185435 */     GIR_EraseRootFromParent_Done,
     /* 2185436 */   // Label 28783: @2185436
     /* 2185436 */   GIM_Try, /*On fail goto*//*Label 28784*/ GIMT_Encode4(2185527), // Rule ID 18642 //
     /* 2185441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2185452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2185455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2185458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2185461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2185464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185487 */     // MIs[0] round
     /* 2185487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185490 */     // MIs[0] policy
     /* 2185490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185500 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2185503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185526 */     // GIR_Coverage, 18642,
     /* 2185526 */     GIR_EraseRootFromParent_Done,
     /* 2185527 */   // Label 28784: @2185527
     /* 2185527 */   GIM_Try, /*On fail goto*//*Label 28785*/ GIMT_Encode4(2185618), // Rule ID 18643 //
     /* 2185532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2185543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2185546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2185549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2185552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2185555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185578 */     // MIs[0] round
     /* 2185578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185581 */     // MIs[0] policy
     /* 2185581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185591 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2185594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185617 */     // GIR_Coverage, 18643,
     /* 2185617 */     GIR_EraseRootFromParent_Done,
     /* 2185618 */   // Label 28785: @2185618
     /* 2185618 */   GIM_Try, /*On fail goto*//*Label 28786*/ GIMT_Encode4(2185709), // Rule ID 18646 //
     /* 2185623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2185626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2185634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2185637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2185640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2185643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2185646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185669 */     // MIs[0] round
     /* 2185669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185672 */     // MIs[0] policy
     /* 2185672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185682 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2185685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185708 */     // GIR_Coverage, 18646,
     /* 2185708 */     GIR_EraseRootFromParent_Done,
     /* 2185709 */   // Label 28786: @2185709
     /* 2185709 */   GIM_Try, /*On fail goto*//*Label 28787*/ GIMT_Encode4(2185800), // Rule ID 18647 //
     /* 2185714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2185717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2185725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2185728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2185731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2185734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2185737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185760 */     // MIs[0] round
     /* 2185760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185763 */     // MIs[0] policy
     /* 2185763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185773 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2185776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185796 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185799 */     // GIR_Coverage, 18647,
     /* 2185799 */     GIR_EraseRootFromParent_Done,
     /* 2185800 */   // Label 28787: @2185800
     /* 2185800 */   GIM_Try, /*On fail goto*//*Label 28788*/ GIMT_Encode4(2185891), // Rule ID 18650 //
     /* 2185805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2185808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2185816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2185819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2185822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2185825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185851 */     // MIs[0] round
     /* 2185851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185854 */     // MIs[0] policy
     /* 2185854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185864 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2185867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185890 */     // GIR_Coverage, 18650,
     /* 2185890 */     GIR_EraseRootFromParent_Done,
     /* 2185891 */   // Label 28788: @2185891
     /* 2185891 */   GIM_Try, /*On fail goto*//*Label 28789*/ GIMT_Encode4(2185982), // Rule ID 18651 //
     /* 2185896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2185899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2185907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2185910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2185913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2185916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185942 */     // MIs[0] round
     /* 2185942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185945 */     // MIs[0] policy
     /* 2185945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185955 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2185958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185981 */     // GIR_Coverage, 18651,
     /* 2185981 */     GIR_EraseRootFromParent_Done,
     /* 2185982 */   // Label 28789: @2185982
     /* 2185982 */   GIM_Try, /*On fail goto*//*Label 28790*/ GIMT_Encode4(2186073), // Rule ID 18654 //
     /* 2185987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2185990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2185998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2186001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2186004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2186007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2186010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186033 */     // MIs[0] round
     /* 2186033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186036 */     // MIs[0] policy
     /* 2186036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186046 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2186049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186072 */     // GIR_Coverage, 18654,
     /* 2186072 */     GIR_EraseRootFromParent_Done,
     /* 2186073 */   // Label 28790: @2186073
     /* 2186073 */   GIM_Try, /*On fail goto*//*Label 28791*/ GIMT_Encode4(2186164), // Rule ID 18655 //
     /* 2186078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2186081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2186089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2186092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2186095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2186098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2186101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186124 */     // MIs[0] round
     /* 2186124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186127 */     // MIs[0] policy
     /* 2186127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186137 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2186140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186163 */     // GIR_Coverage, 18655,
     /* 2186163 */     GIR_EraseRootFromParent_Done,
     /* 2186164 */   // Label 28791: @2186164
     /* 2186164 */   GIM_Try, /*On fail goto*//*Label 28792*/ GIMT_Encode4(2186255), // Rule ID 18658 //
     /* 2186169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2186172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2186180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2186183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2186189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186215 */     // MIs[0] round
     /* 2186215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186218 */     // MIs[0] policy
     /* 2186218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186228 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2186231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186254 */     // GIR_Coverage, 18658,
     /* 2186254 */     GIR_EraseRootFromParent_Done,
     /* 2186255 */   // Label 28792: @2186255
     /* 2186255 */   GIM_Try, /*On fail goto*//*Label 28793*/ GIMT_Encode4(2186346), // Rule ID 18659 //
     /* 2186260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2186263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2186271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2186274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2186280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186306 */     // MIs[0] round
     /* 2186306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186309 */     // MIs[0] policy
     /* 2186309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186319 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2186322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186345 */     // GIR_Coverage, 18659,
     /* 2186345 */     GIR_EraseRootFromParent_Done,
     /* 2186346 */   // Label 28793: @2186346
     /* 2186346 */   GIM_Try, /*On fail goto*//*Label 28794*/ GIMT_Encode4(2186437), // Rule ID 18662 //
     /* 2186351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2186354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2186362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2186365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2186371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186397 */     // MIs[0] round
     /* 2186397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186400 */     // MIs[0] policy
     /* 2186400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186410 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2186413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186436 */     // GIR_Coverage, 18662,
     /* 2186436 */     GIR_EraseRootFromParent_Done,
     /* 2186437 */   // Label 28794: @2186437
     /* 2186437 */   GIM_Try, /*On fail goto*//*Label 28795*/ GIMT_Encode4(2186528), // Rule ID 18663 //
     /* 2186442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2186445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2186453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2186456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2186462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186488 */     // MIs[0] round
     /* 2186488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186491 */     // MIs[0] policy
     /* 2186491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186501 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2186504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186527 */     // GIR_Coverage, 18663,
     /* 2186527 */     GIR_EraseRootFromParent_Done,
     /* 2186528 */   // Label 28795: @2186528
     /* 2186528 */   GIM_Try, /*On fail goto*//*Label 28796*/ GIMT_Encode4(2186619), // Rule ID 18666 //
     /* 2186533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2186536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2186544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2186547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2186553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186579 */     // MIs[0] round
     /* 2186579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186582 */     // MIs[0] policy
     /* 2186582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186592 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2186595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186618 */     // GIR_Coverage, 18666,
     /* 2186618 */     GIR_EraseRootFromParent_Done,
     /* 2186619 */   // Label 28796: @2186619
     /* 2186619 */   GIM_Try, /*On fail goto*//*Label 28797*/ GIMT_Encode4(2186710), // Rule ID 18667 //
     /* 2186624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2186627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2186635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2186638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2186644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186670 */     // MIs[0] round
     /* 2186670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186673 */     // MIs[0] policy
     /* 2186673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186683 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2186686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186709 */     // GIR_Coverage, 18667,
     /* 2186709 */     GIR_EraseRootFromParent_Done,
     /* 2186710 */   // Label 28797: @2186710
     /* 2186710 */   GIM_Try, /*On fail goto*//*Label 28798*/ GIMT_Encode4(2186801), // Rule ID 18670 //
     /* 2186715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2186718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2186726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2186729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2186735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186761 */     // MIs[0] round
     /* 2186761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186764 */     // MIs[0] policy
     /* 2186764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186774 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2186777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186800 */     // GIR_Coverage, 18670,
     /* 2186800 */     GIR_EraseRootFromParent_Done,
     /* 2186801 */   // Label 28798: @2186801
     /* 2186801 */   GIM_Try, /*On fail goto*//*Label 28799*/ GIMT_Encode4(2186892), // Rule ID 18671 //
     /* 2186806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2186809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2186817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2186820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2186826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186852 */     // MIs[0] round
     /* 2186852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186855 */     // MIs[0] policy
     /* 2186855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186865 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2186868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186891 */     // GIR_Coverage, 18671,
     /* 2186891 */     GIR_EraseRootFromParent_Done,
     /* 2186892 */   // Label 28799: @2186892
     /* 2186892 */   GIM_Try, /*On fail goto*//*Label 28800*/ GIMT_Encode4(2186983), // Rule ID 18674 //
     /* 2186897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2186900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2186908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2186911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2186917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186943 */     // MIs[0] round
     /* 2186943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186946 */     // MIs[0] policy
     /* 2186946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186956 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2186959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186982 */     // GIR_Coverage, 18674,
     /* 2186982 */     GIR_EraseRootFromParent_Done,
     /* 2186983 */   // Label 28800: @2186983
     /* 2186983 */   GIM_Try, /*On fail goto*//*Label 28801*/ GIMT_Encode4(2187074), // Rule ID 18675 //
     /* 2186988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2186991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2186999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2187002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2187008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2187011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187034 */     // MIs[0] round
     /* 2187034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187037 */     // MIs[0] policy
     /* 2187037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187047 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2187050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187073 */     // GIR_Coverage, 18675,
     /* 2187073 */     GIR_EraseRootFromParent_Done,
     /* 2187074 */   // Label 28801: @2187074
     /* 2187074 */   GIM_Try, /*On fail goto*//*Label 28802*/ GIMT_Encode4(2187165), // Rule ID 18678 //
     /* 2187079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2187082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2187090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2187093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2187096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2187099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2187117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187125 */     // MIs[0] round
     /* 2187125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187128 */     // MIs[0] policy
     /* 2187128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187138 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2187141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187164 */     // GIR_Coverage, 18678,
     /* 2187164 */     GIR_EraseRootFromParent_Done,
     /* 2187165 */   // Label 28802: @2187165
     /* 2187165 */   GIM_Try, /*On fail goto*//*Label 28803*/ GIMT_Encode4(2187256), // Rule ID 18679 //
     /* 2187170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2187173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2187181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2187184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2187187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2187190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2187208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187216 */     // MIs[0] round
     /* 2187216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187219 */     // MIs[0] policy
     /* 2187219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187229 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2187232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187255 */     // GIR_Coverage, 18679,
     /* 2187255 */     GIR_EraseRootFromParent_Done,
     /* 2187256 */   // Label 28803: @2187256
     /* 2187256 */   GIM_Try, /*On fail goto*//*Label 28804*/ GIMT_Encode4(2187347), // Rule ID 18682 //
     /* 2187261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2187272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2187275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2187281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187307 */     // MIs[0] round
     /* 2187307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187310 */     // MIs[0] policy
     /* 2187310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187320 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2187323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187346 */     // GIR_Coverage, 18682,
     /* 2187346 */     GIR_EraseRootFromParent_Done,
     /* 2187347 */   // Label 28804: @2187347
     /* 2187347 */   GIM_Try, /*On fail goto*//*Label 28805*/ GIMT_Encode4(2187438), // Rule ID 18683 //
     /* 2187352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2187363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2187366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2187372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187398 */     // MIs[0] round
     /* 2187398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187401 */     // MIs[0] policy
     /* 2187401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187411 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2187414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187437 */     // GIR_Coverage, 18683,
     /* 2187437 */     GIR_EraseRootFromParent_Done,
     /* 2187438 */   // Label 28805: @2187438
     /* 2187438 */   GIM_Try, /*On fail goto*//*Label 28806*/ GIMT_Encode4(2187529), // Rule ID 18686 //
     /* 2187443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2187454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2187457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2187463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2187466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2187473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187489 */     // MIs[0] round
     /* 2187489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187492 */     // MIs[0] policy
     /* 2187492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187502 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2187505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187528 */     // GIR_Coverage, 18686,
     /* 2187528 */     GIR_EraseRootFromParent_Done,
     /* 2187529 */   // Label 28806: @2187529
     /* 2187529 */   GIM_Try, /*On fail goto*//*Label 28807*/ GIMT_Encode4(2187620), // Rule ID 18687 //
     /* 2187534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2187545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2187548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2187554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2187557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2187564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187580 */     // MIs[0] round
     /* 2187580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187583 */     // MIs[0] policy
     /* 2187583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187593 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2187596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187619 */     // GIR_Coverage, 18687,
     /* 2187619 */     GIR_EraseRootFromParent_Done,
     /* 2187620 */   // Label 28807: @2187620
     /* 2187620 */   GIM_Try, /*On fail goto*//*Label 28808*/ GIMT_Encode4(2187711), // Rule ID 18690 //
     /* 2187625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2187636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2187639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2187645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2187648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2187655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187671 */     // MIs[0] round
     /* 2187671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187674 */     // MIs[0] policy
     /* 2187674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187684 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2187687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187710 */     // GIR_Coverage, 18690,
     /* 2187710 */     GIR_EraseRootFromParent_Done,
     /* 2187711 */   // Label 28808: @2187711
     /* 2187711 */   GIM_Try, /*On fail goto*//*Label 28809*/ GIMT_Encode4(2187802), // Rule ID 18691 //
     /* 2187716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2187727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2187730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2187736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2187739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2187746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187762 */     // MIs[0] round
     /* 2187762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187765 */     // MIs[0] policy
     /* 2187765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187775 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2187778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187801 */     // GIR_Coverage, 18691,
     /* 2187801 */     GIR_EraseRootFromParent_Done,
     /* 2187802 */   // Label 28809: @2187802
     /* 2187802 */   GIM_Try, /*On fail goto*//*Label 28810*/ GIMT_Encode4(2187893), // Rule ID 18694 //
     /* 2187807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2187810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2187818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2187821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2187827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187853 */     // MIs[0] round
     /* 2187853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187856 */     // MIs[0] policy
     /* 2187856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187866 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2187869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187892 */     // GIR_Coverage, 18694,
     /* 2187892 */     GIR_EraseRootFromParent_Done,
     /* 2187893 */   // Label 28810: @2187893
     /* 2187893 */   GIM_Try, /*On fail goto*//*Label 28811*/ GIMT_Encode4(2187984), // Rule ID 18695 //
     /* 2187898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2187901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2187909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2187912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2187918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187944 */     // MIs[0] round
     /* 2187944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187947 */     // MIs[0] policy
     /* 2187947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187957 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2187960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187970 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187980 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187983 */     // GIR_Coverage, 18695,
     /* 2187983 */     GIR_EraseRootFromParent_Done,
     /* 2187984 */   // Label 28811: @2187984
     /* 2187984 */   GIM_Try, /*On fail goto*//*Label 28812*/ GIMT_Encode4(2188075), // Rule ID 18698 //
     /* 2187989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2187992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2188000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2188003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2188009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188035 */     // MIs[0] round
     /* 2188035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188038 */     // MIs[0] policy
     /* 2188038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188048 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2188051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188074 */     // GIR_Coverage, 18698,
     /* 2188074 */     GIR_EraseRootFromParent_Done,
     /* 2188075 */   // Label 28812: @2188075
     /* 2188075 */   GIM_Try, /*On fail goto*//*Label 28813*/ GIMT_Encode4(2188166), // Rule ID 18699 //
     /* 2188080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2188083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2188091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2188094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2188100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188126 */     // MIs[0] round
     /* 2188126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188129 */     // MIs[0] policy
     /* 2188129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188139 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2188142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188165 */     // GIR_Coverage, 18699,
     /* 2188165 */     GIR_EraseRootFromParent_Done,
     /* 2188166 */   // Label 28813: @2188166
     /* 2188166 */   GIM_Try, /*On fail goto*//*Label 28814*/ GIMT_Encode4(2188257), // Rule ID 18702 //
     /* 2188171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2188174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2188182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2188185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2188191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188217 */     // MIs[0] round
     /* 2188217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188220 */     // MIs[0] policy
     /* 2188220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188230 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2188233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188256 */     // GIR_Coverage, 18702,
     /* 2188256 */     GIR_EraseRootFromParent_Done,
     /* 2188257 */   // Label 28814: @2188257
     /* 2188257 */   GIM_Try, /*On fail goto*//*Label 28815*/ GIMT_Encode4(2188348), // Rule ID 18703 //
     /* 2188262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2188265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2188273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2188276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2188282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188308 */     // MIs[0] round
     /* 2188308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188311 */     // MIs[0] policy
     /* 2188311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188321 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2188324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188347 */     // GIR_Coverage, 18703,
     /* 2188347 */     GIR_EraseRootFromParent_Done,
     /* 2188348 */   // Label 28815: @2188348
     /* 2188348 */   GIM_Try, /*On fail goto*//*Label 28816*/ GIMT_Encode4(2188439), // Rule ID 18706 //
     /* 2188353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2188356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2188364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2188367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2188373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188399 */     // MIs[0] round
     /* 2188399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188402 */     // MIs[0] policy
     /* 2188402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188412 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2188415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188438 */     // GIR_Coverage, 18706,
     /* 2188438 */     GIR_EraseRootFromParent_Done,
     /* 2188439 */   // Label 28816: @2188439
     /* 2188439 */   GIM_Try, /*On fail goto*//*Label 28817*/ GIMT_Encode4(2188530), // Rule ID 18707 //
     /* 2188444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2188447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2188455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2188458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2188464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188490 */     // MIs[0] round
     /* 2188490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188493 */     // MIs[0] policy
     /* 2188493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188503 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2188506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188529 */     // GIR_Coverage, 18707,
     /* 2188529 */     GIR_EraseRootFromParent_Done,
     /* 2188530 */   // Label 28817: @2188530
     /* 2188530 */   GIM_Try, /*On fail goto*//*Label 28818*/ GIMT_Encode4(2188621), // Rule ID 18710 //
     /* 2188535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2188538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2188546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2188549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2188555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188581 */     // MIs[0] round
     /* 2188581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188584 */     // MIs[0] policy
     /* 2188584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188594 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2188597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188620 */     // GIR_Coverage, 18710,
     /* 2188620 */     GIR_EraseRootFromParent_Done,
     /* 2188621 */   // Label 28818: @2188621
     /* 2188621 */   GIM_Try, /*On fail goto*//*Label 28819*/ GIMT_Encode4(2188712), // Rule ID 18711 //
     /* 2188626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2188629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2188637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2188640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2188646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188672 */     // MIs[0] round
     /* 2188672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188675 */     // MIs[0] policy
     /* 2188675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188685 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2188688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188711 */     // GIR_Coverage, 18711,
     /* 2188711 */     GIR_EraseRootFromParent_Done,
     /* 2188712 */   // Label 28819: @2188712
     /* 2188712 */   GIM_Try, /*On fail goto*//*Label 28820*/ GIMT_Encode4(2188803), // Rule ID 18714 //
     /* 2188717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2188720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2188728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2188731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2188737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188763 */     // MIs[0] round
     /* 2188763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188766 */     // MIs[0] policy
     /* 2188766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188776 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2188779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188802 */     // GIR_Coverage, 18714,
     /* 2188802 */     GIR_EraseRootFromParent_Done,
     /* 2188803 */   // Label 28820: @2188803
     /* 2188803 */   GIM_Try, /*On fail goto*//*Label 28821*/ GIMT_Encode4(2188894), // Rule ID 18715 //
     /* 2188808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2188811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2188819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2188822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2188828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188854 */     // MIs[0] round
     /* 2188854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188857 */     // MIs[0] policy
     /* 2188857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188867 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2188870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188893 */     // GIR_Coverage, 18715,
     /* 2188893 */     GIR_EraseRootFromParent_Done,
     /* 2188894 */   // Label 28821: @2188894
     /* 2188894 */   GIM_Try, /*On fail goto*//*Label 28822*/ GIMT_Encode4(2188985), // Rule ID 18718 //
     /* 2188899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2188902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2188907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2188910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2188913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2188916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2188919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2188922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2188929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188945 */     // MIs[0] round
     /* 2188945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188948 */     // MIs[0] policy
     /* 2188948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188958 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2188961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188984 */     // GIR_Coverage, 18718,
     /* 2188984 */     GIR_EraseRootFromParent_Done,
     /* 2188985 */   // Label 28822: @2188985
     /* 2188985 */   GIM_Try, /*On fail goto*//*Label 28823*/ GIMT_Encode4(2189076), // Rule ID 18719 //
     /* 2188990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2188993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2188998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2189001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2189004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2189007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2189010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189036 */     // MIs[0] round
     /* 2189036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189039 */     // MIs[0] policy
     /* 2189039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189049 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2189052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189075 */     // GIR_Coverage, 18719,
     /* 2189075 */     GIR_EraseRootFromParent_Done,
     /* 2189076 */   // Label 28823: @2189076
     /* 2189076 */   GIM_Try, /*On fail goto*//*Label 28824*/ GIMT_Encode4(2189167), // Rule ID 18722 //
     /* 2189081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2189092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2189095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2189098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2189101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189127 */     // MIs[0] round
     /* 2189127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189130 */     // MIs[0] policy
     /* 2189130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189140 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2189143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189166 */     // GIR_Coverage, 18722,
     /* 2189166 */     GIR_EraseRootFromParent_Done,
     /* 2189167 */   // Label 28824: @2189167
     /* 2189167 */   GIM_Try, /*On fail goto*//*Label 28825*/ GIMT_Encode4(2189258), // Rule ID 18723 //
     /* 2189172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2189183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2189186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2189189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2189192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189218 */     // MIs[0] round
     /* 2189218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189221 */     // MIs[0] policy
     /* 2189221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189231 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2189234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189257 */     // GIR_Coverage, 18723,
     /* 2189257 */     GIR_EraseRootFromParent_Done,
     /* 2189258 */   // Label 28825: @2189258
     /* 2189258 */   GIM_Try, /*On fail goto*//*Label 28826*/ GIMT_Encode4(2189349), // Rule ID 18726 //
     /* 2189263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2189274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2189277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2189280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2189283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189309 */     // MIs[0] round
     /* 2189309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189312 */     // MIs[0] policy
     /* 2189312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189322 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11314:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2189325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189348 */     // GIR_Coverage, 18726,
     /* 2189348 */     GIR_EraseRootFromParent_Done,
     /* 2189349 */   // Label 28826: @2189349
     /* 2189349 */   GIM_Try, /*On fail goto*//*Label 28827*/ GIMT_Encode4(2189440), // Rule ID 18727 //
     /* 2189354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2189365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2189368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2189371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2189374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189400 */     // MIs[0] round
     /* 2189400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189403 */     // MIs[0] policy
     /* 2189403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189413 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11314:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2189416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189439 */     // GIR_Coverage, 18727,
     /* 2189439 */     GIR_EraseRootFromParent_Done,
     /* 2189440 */   // Label 28827: @2189440
     /* 2189440 */   GIM_Try, /*On fail goto*//*Label 28828*/ GIMT_Encode4(2189531), // Rule ID 18730 //
     /* 2189445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2189456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2189459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2189462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2189465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189491 */     // MIs[0] round
     /* 2189491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189494 */     // MIs[0] policy
     /* 2189494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189504 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11314:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2189507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189530 */     // GIR_Coverage, 18730,
     /* 2189530 */     GIR_EraseRootFromParent_Done,
     /* 2189531 */   // Label 28828: @2189531
     /* 2189531 */   GIM_Try, /*On fail goto*//*Label 28829*/ GIMT_Encode4(2189622), // Rule ID 18731 //
     /* 2189536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2189547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2189550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2189553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2189556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189582 */     // MIs[0] round
     /* 2189582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189585 */     // MIs[0] policy
     /* 2189585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189595 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11314:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2189598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189621 */     // GIR_Coverage, 18731,
     /* 2189621 */     GIR_EraseRootFromParent_Done,
     /* 2189622 */   // Label 28829: @2189622
     /* 2189622 */   GIM_Try, /*On fail goto*//*Label 28830*/ GIMT_Encode4(2189713), // Rule ID 18734 //
     /* 2189627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2189638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2189641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2189644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2189647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2189650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189673 */     // MIs[0] round
     /* 2189673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189676 */     // MIs[0] policy
     /* 2189676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189686 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11314:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2189689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189712 */     // GIR_Coverage, 18734,
     /* 2189712 */     GIR_EraseRootFromParent_Done,
     /* 2189713 */   // Label 28830: @2189713
     /* 2189713 */   GIM_Try, /*On fail goto*//*Label 28831*/ GIMT_Encode4(2189804), // Rule ID 18735 //
     /* 2189718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2189729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2189732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2189735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2189738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2189741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189764 */     // MIs[0] round
     /* 2189764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189767 */     // MIs[0] policy
     /* 2189767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189777 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11314:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2189780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189803 */     // GIR_Coverage, 18735,
     /* 2189803 */     GIR_EraseRootFromParent_Done,
     /* 2189804 */   // Label 28831: @2189804
     /* 2189804 */   GIM_Try, /*On fail goto*//*Label 28832*/ GIMT_Encode4(2189895), // Rule ID 18738 //
     /* 2189809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2189812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2189820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2189823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2189826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2189829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189855 */     // MIs[0] round
     /* 2189855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189858 */     // MIs[0] policy
     /* 2189858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189868 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2189871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189894 */     // GIR_Coverage, 18738,
     /* 2189894 */     GIR_EraseRootFromParent_Done,
     /* 2189895 */   // Label 28832: @2189895
     /* 2189895 */   GIM_Try, /*On fail goto*//*Label 28833*/ GIMT_Encode4(2189986), // Rule ID 18739 //
     /* 2189900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2189903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2189911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2189914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2189917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2189920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189946 */     // MIs[0] round
     /* 2189946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189949 */     // MIs[0] policy
     /* 2189949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189959 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2189962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189985 */     // GIR_Coverage, 18739,
     /* 2189985 */     GIR_EraseRootFromParent_Done,
     /* 2189986 */   // Label 28833: @2189986
     /* 2189986 */   GIM_Try, /*On fail goto*//*Label 28834*/ GIMT_Encode4(2190077), // Rule ID 18742 //
     /* 2189991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2189994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2190002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2190005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2190008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2190011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190037 */     // MIs[0] round
     /* 2190037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190040 */     // MIs[0] policy
     /* 2190040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190050 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11314:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2190053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190076 */     // GIR_Coverage, 18742,
     /* 2190076 */     GIR_EraseRootFromParent_Done,
     /* 2190077 */   // Label 28834: @2190077
     /* 2190077 */   GIM_Try, /*On fail goto*//*Label 28835*/ GIMT_Encode4(2190168), // Rule ID 18743 //
     /* 2190082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2190093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2190096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2190099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2190102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190128 */     // MIs[0] round
     /* 2190128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190131 */     // MIs[0] policy
     /* 2190131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190141 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11314:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2190144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190154 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190164 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190167 */     // GIR_Coverage, 18743,
     /* 2190167 */     GIR_EraseRootFromParent_Done,
     /* 2190168 */   // Label 28835: @2190168
     /* 2190168 */   GIM_Try, /*On fail goto*//*Label 28836*/ GIMT_Encode4(2190259), // Rule ID 18746 //
     /* 2190173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2190184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2190187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2190190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2190193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190219 */     // MIs[0] round
     /* 2190219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190222 */     // MIs[0] policy
     /* 2190222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190232 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11314:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2190235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190258 */     // GIR_Coverage, 18746,
     /* 2190258 */     GIR_EraseRootFromParent_Done,
     /* 2190259 */   // Label 28836: @2190259
     /* 2190259 */   GIM_Try, /*On fail goto*//*Label 28837*/ GIMT_Encode4(2190350), // Rule ID 18747 //
     /* 2190264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2190275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2190278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2190281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2190284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190310 */     // MIs[0] round
     /* 2190310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190313 */     // MIs[0] policy
     /* 2190313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190323 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11314:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2190326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190349 */     // GIR_Coverage, 18747,
     /* 2190349 */     GIR_EraseRootFromParent_Done,
     /* 2190350 */   // Label 28837: @2190350
     /* 2190350 */   GIM_Try, /*On fail goto*//*Label 28838*/ GIMT_Encode4(2190441), // Rule ID 18750 //
     /* 2190355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2190366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2190369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2190372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2190375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190401 */     // MIs[0] round
     /* 2190401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190404 */     // MIs[0] policy
     /* 2190404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190414 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11314:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2190417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190440 */     // GIR_Coverage, 18750,
     /* 2190440 */     GIR_EraseRootFromParent_Done,
     /* 2190441 */   // Label 28838: @2190441
     /* 2190441 */   GIM_Try, /*On fail goto*//*Label 28839*/ GIMT_Encode4(2190532), // Rule ID 18751 //
     /* 2190446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2190457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2190460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2190463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2190466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190492 */     // MIs[0] round
     /* 2190492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190495 */     // MIs[0] policy
     /* 2190495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190505 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11314:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2190508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190531 */     // GIR_Coverage, 18751,
     /* 2190531 */     GIR_EraseRootFromParent_Done,
     /* 2190532 */   // Label 28839: @2190532
     /* 2190532 */   GIM_Try, /*On fail goto*//*Label 28840*/ GIMT_Encode4(2190623), // Rule ID 18754 //
     /* 2190537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2190548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2190551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2190557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190583 */     // MIs[0] round
     /* 2190583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190586 */     // MIs[0] policy
     /* 2190586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190596 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2190599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190622 */     // GIR_Coverage, 18754,
     /* 2190622 */     GIR_EraseRootFromParent_Done,
     /* 2190623 */   // Label 28840: @2190623
     /* 2190623 */   GIM_Try, /*On fail goto*//*Label 28841*/ GIMT_Encode4(2190714), // Rule ID 18755 //
     /* 2190628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2190631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2190639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2190642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2190648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190674 */     // MIs[0] round
     /* 2190674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190677 */     // MIs[0] policy
     /* 2190677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190687 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2190690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190713 */     // GIR_Coverage, 18755,
     /* 2190713 */     GIR_EraseRootFromParent_Done,
     /* 2190714 */   // Label 28841: @2190714
     /* 2190714 */   GIM_Try, /*On fail goto*//*Label 28842*/ GIMT_Encode4(2190805), // Rule ID 18758 //
     /* 2190719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2190730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2190733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2190739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190765 */     // MIs[0] round
     /* 2190765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190768 */     // MIs[0] policy
     /* 2190768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190778 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2190781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190804 */     // GIR_Coverage, 18758,
     /* 2190804 */     GIR_EraseRootFromParent_Done,
     /* 2190805 */   // Label 28842: @2190805
     /* 2190805 */   GIM_Try, /*On fail goto*//*Label 28843*/ GIMT_Encode4(2190896), // Rule ID 18759 //
     /* 2190810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2190813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2190821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2190824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2190830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190856 */     // MIs[0] round
     /* 2190856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190859 */     // MIs[0] policy
     /* 2190859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190869 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2190872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190895 */     // GIR_Coverage, 18759,
     /* 2190895 */     GIR_EraseRootFromParent_Done,
     /* 2190896 */   // Label 28843: @2190896
     /* 2190896 */   GIM_Try, /*On fail goto*//*Label 28844*/ GIMT_Encode4(2190987), // Rule ID 18762 //
     /* 2190901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2190912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2190915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2190921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190947 */     // MIs[0] round
     /* 2190947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190950 */     // MIs[0] policy
     /* 2190950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190960 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11314:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2190963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190986 */     // GIR_Coverage, 18762,
     /* 2190986 */     GIR_EraseRootFromParent_Done,
     /* 2190987 */   // Label 28844: @2190987
     /* 2190987 */   GIM_Try, /*On fail goto*//*Label 28845*/ GIMT_Encode4(2191078), // Rule ID 18763 //
     /* 2190992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2190995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2191003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2191006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2191012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191038 */     // MIs[0] round
     /* 2191038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191041 */     // MIs[0] policy
     /* 2191041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191051 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11314:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2191054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191077 */     // GIR_Coverage, 18763,
     /* 2191077 */     GIR_EraseRootFromParent_Done,
     /* 2191078 */   // Label 28845: @2191078
     /* 2191078 */   GIM_Try, /*On fail goto*//*Label 28846*/ GIMT_Encode4(2191169), // Rule ID 18766 //
     /* 2191083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2191094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2191097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2191103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191129 */     // MIs[0] round
     /* 2191129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191132 */     // MIs[0] policy
     /* 2191132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191142 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11314:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2191145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191168 */     // GIR_Coverage, 18766,
     /* 2191168 */     GIR_EraseRootFromParent_Done,
     /* 2191169 */   // Label 28846: @2191169
     /* 2191169 */   GIM_Try, /*On fail goto*//*Label 28847*/ GIMT_Encode4(2191260), // Rule ID 18767 //
     /* 2191174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2191185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2191188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2191194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191220 */     // MIs[0] round
     /* 2191220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191223 */     // MIs[0] policy
     /* 2191223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191233 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11314:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2191236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191259 */     // GIR_Coverage, 18767,
     /* 2191259 */     GIR_EraseRootFromParent_Done,
     /* 2191260 */   // Label 28847: @2191260
     /* 2191260 */   GIM_Try, /*On fail goto*//*Label 28848*/ GIMT_Encode4(2191351), // Rule ID 18770 //
     /* 2191265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2191276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2191279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2191285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2191288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2191295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191311 */     // MIs[0] round
     /* 2191311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191314 */     // MIs[0] policy
     /* 2191314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191324 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11314:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2191327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191350 */     // GIR_Coverage, 18770,
     /* 2191350 */     GIR_EraseRootFromParent_Done,
     /* 2191351 */   // Label 28848: @2191351
     /* 2191351 */   GIM_Try, /*On fail goto*//*Label 28849*/ GIMT_Encode4(2191442), // Rule ID 18771 //
     /* 2191356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2191367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2191370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2191376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2191379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2191386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191402 */     // MIs[0] round
     /* 2191402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191405 */     // MIs[0] policy
     /* 2191405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191415 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11314:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2191418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191441 */     // GIR_Coverage, 18771,
     /* 2191441 */     GIR_EraseRootFromParent_Done,
     /* 2191442 */   // Label 28849: @2191442
     /* 2191442 */   GIM_Try, /*On fail goto*//*Label 28850*/ GIMT_Encode4(2191533), // Rule ID 18774 //
     /* 2191447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2191458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2191461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2191467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191493 */     // MIs[0] round
     /* 2191493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191496 */     // MIs[0] policy
     /* 2191496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191506 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2191509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191532 */     // GIR_Coverage, 18774,
     /* 2191532 */     GIR_EraseRootFromParent_Done,
     /* 2191533 */   // Label 28850: @2191533
     /* 2191533 */   GIM_Try, /*On fail goto*//*Label 28851*/ GIMT_Encode4(2191624), // Rule ID 18775 //
     /* 2191538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2191541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2191549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2191552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2191558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191584 */     // MIs[0] round
     /* 2191584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191587 */     // MIs[0] policy
     /* 2191587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191597 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2191600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191623 */     // GIR_Coverage, 18775,
     /* 2191623 */     GIR_EraseRootFromParent_Done,
     /* 2191624 */   // Label 28851: @2191624
     /* 2191624 */   GIM_Try, /*On fail goto*//*Label 28852*/ GIMT_Encode4(2191715), // Rule ID 18778 //
     /* 2191629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2191640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2191643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2191649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2191652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191675 */     // MIs[0] round
     /* 2191675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191678 */     // MIs[0] policy
     /* 2191678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191688 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11314:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2191691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191714 */     // GIR_Coverage, 18778,
     /* 2191714 */     GIR_EraseRootFromParent_Done,
     /* 2191715 */   // Label 28852: @2191715
     /* 2191715 */   GIM_Try, /*On fail goto*//*Label 28853*/ GIMT_Encode4(2191806), // Rule ID 18779 //
     /* 2191720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2191723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2191731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2191734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2191740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2191743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191766 */     // MIs[0] round
     /* 2191766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191769 */     // MIs[0] policy
     /* 2191769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191779 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11314:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2191782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191805 */     // GIR_Coverage, 18779,
     /* 2191805 */     GIR_EraseRootFromParent_Done,
     /* 2191806 */   // Label 28853: @2191806
     /* 2191806 */   GIM_Try, /*On fail goto*//*Label 28854*/ GIMT_Encode4(2191897), // Rule ID 18782 //
     /* 2191811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2191822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2191825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2191831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191857 */     // MIs[0] round
     /* 2191857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191860 */     // MIs[0] policy
     /* 2191860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191870 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11314:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2191873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191896 */     // GIR_Coverage, 18782,
     /* 2191896 */     GIR_EraseRootFromParent_Done,
     /* 2191897 */   // Label 28854: @2191897
     /* 2191897 */   GIM_Try, /*On fail goto*//*Label 28855*/ GIMT_Encode4(2191988), // Rule ID 18783 //
     /* 2191902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2191905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2191913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2191916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2191922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191948 */     // MIs[0] round
     /* 2191948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191951 */     // MIs[0] policy
     /* 2191951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191961 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11314:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2191964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191987 */     // GIR_Coverage, 18783,
     /* 2191987 */     GIR_EraseRootFromParent_Done,
     /* 2191988 */   // Label 28855: @2191988
     /* 2191988 */   GIM_Try, /*On fail goto*//*Label 28856*/ GIMT_Encode4(2192079), // Rule ID 18786 //
     /* 2191993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2192004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2192007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2192013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192039 */     // MIs[0] round
     /* 2192039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192042 */     // MIs[0] policy
     /* 2192042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192052 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11314:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2192055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192078 */     // GIR_Coverage, 18786,
     /* 2192078 */     GIR_EraseRootFromParent_Done,
     /* 2192079 */   // Label 28856: @2192079
     /* 2192079 */   GIM_Try, /*On fail goto*//*Label 28857*/ GIMT_Encode4(2192170), // Rule ID 18787 //
     /* 2192084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2192087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2192095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2192098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2192104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192130 */     // MIs[0] round
     /* 2192130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192133 */     // MIs[0] policy
     /* 2192133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192143 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11314:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2192146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192169 */     // GIR_Coverage, 18787,
     /* 2192169 */     GIR_EraseRootFromParent_Done,
     /* 2192170 */   // Label 28857: @2192170
     /* 2192170 */   GIM_Try, /*On fail goto*//*Label 28858*/ GIMT_Encode4(2192261), // Rule ID 18790 //
     /* 2192175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2192186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2192189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2192192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2192195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192221 */     // MIs[0] round
     /* 2192221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192224 */     // MIs[0] policy
     /* 2192224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192234 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2192237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192260 */     // GIR_Coverage, 18790,
     /* 2192260 */     GIR_EraseRootFromParent_Done,
     /* 2192261 */   // Label 28858: @2192261
     /* 2192261 */   GIM_Try, /*On fail goto*//*Label 28859*/ GIMT_Encode4(2192352), // Rule ID 18791 //
     /* 2192266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2192277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2192280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2192283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2192286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192312 */     // MIs[0] round
     /* 2192312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192315 */     // MIs[0] policy
     /* 2192315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192325 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2192328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192351 */     // GIR_Coverage, 18791,
     /* 2192351 */     GIR_EraseRootFromParent_Done,
     /* 2192352 */   // Label 28859: @2192352
     /* 2192352 */   GIM_Try, /*On fail goto*//*Label 28860*/ GIMT_Encode4(2192443), // Rule ID 18794 //
     /* 2192357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2192368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2192371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2192374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2192377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192403 */     // MIs[0] round
     /* 2192403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192406 */     // MIs[0] policy
     /* 2192406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192416 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2192419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192442 */     // GIR_Coverage, 18794,
     /* 2192442 */     GIR_EraseRootFromParent_Done,
     /* 2192443 */   // Label 28860: @2192443
     /* 2192443 */   GIM_Try, /*On fail goto*//*Label 28861*/ GIMT_Encode4(2192534), // Rule ID 18795 //
     /* 2192448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2192459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2192462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2192465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2192468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192494 */     // MIs[0] round
     /* 2192494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192497 */     // MIs[0] policy
     /* 2192497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192507 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2192510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192533 */     // GIR_Coverage, 18795,
     /* 2192533 */     GIR_EraseRootFromParent_Done,
     /* 2192534 */   // Label 28861: @2192534
     /* 2192534 */   GIM_Try, /*On fail goto*//*Label 28862*/ GIMT_Encode4(2192625), // Rule ID 18798 //
     /* 2192539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2192550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2192553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2192556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2192559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192585 */     // MIs[0] round
     /* 2192585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192588 */     // MIs[0] policy
     /* 2192588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192598 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2192601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192624 */     // GIR_Coverage, 18798,
     /* 2192624 */     GIR_EraseRootFromParent_Done,
     /* 2192625 */   // Label 28862: @2192625
     /* 2192625 */   GIM_Try, /*On fail goto*//*Label 28863*/ GIMT_Encode4(2192716), // Rule ID 18799 //
     /* 2192630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2192641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2192644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2192647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2192650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192676 */     // MIs[0] round
     /* 2192676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192679 */     // MIs[0] policy
     /* 2192679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192689 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2192692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192715 */     // GIR_Coverage, 18799,
     /* 2192715 */     GIR_EraseRootFromParent_Done,
     /* 2192716 */   // Label 28863: @2192716
     /* 2192716 */   GIM_Try, /*On fail goto*//*Label 28864*/ GIMT_Encode4(2192807), // Rule ID 18802 //
     /* 2192721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2192732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2192735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2192738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2192741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2192751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192767 */     // MIs[0] round
     /* 2192767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192770 */     // MIs[0] policy
     /* 2192770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192780 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2192783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192806 */     // GIR_Coverage, 18802,
     /* 2192806 */     GIR_EraseRootFromParent_Done,
     /* 2192807 */   // Label 28864: @2192807
     /* 2192807 */   GIM_Try, /*On fail goto*//*Label 28865*/ GIMT_Encode4(2192898), // Rule ID 18803 //
     /* 2192812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2192823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2192826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2192829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2192832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2192842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192858 */     // MIs[0] round
     /* 2192858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192861 */     // MIs[0] policy
     /* 2192861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192871 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2192874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192897 */     // GIR_Coverage, 18803,
     /* 2192897 */     GIR_EraseRootFromParent_Done,
     /* 2192898 */   // Label 28865: @2192898
     /* 2192898 */   GIM_Try, /*On fail goto*//*Label 28866*/ GIMT_Encode4(2192989), // Rule ID 18806 //
     /* 2192903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2192914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2192917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2192920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2192923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2192926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192949 */     // MIs[0] round
     /* 2192949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192952 */     // MIs[0] policy
     /* 2192952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192962 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2192965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192988 */     // GIR_Coverage, 18806,
     /* 2192988 */     GIR_EraseRootFromParent_Done,
     /* 2192989 */   // Label 28866: @2192989
     /* 2192989 */   GIM_Try, /*On fail goto*//*Label 28867*/ GIMT_Encode4(2193080), // Rule ID 18807 //
     /* 2192994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2193005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2193008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2193011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2193014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2193017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193040 */     // MIs[0] round
     /* 2193040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193043 */     // MIs[0] policy
     /* 2193043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193053 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2193056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193079 */     // GIR_Coverage, 18807,
     /* 2193079 */     GIR_EraseRootFromParent_Done,
     /* 2193080 */   // Label 28867: @2193080
     /* 2193080 */   GIM_Try, /*On fail goto*//*Label 28868*/ GIMT_Encode4(2193171), // Rule ID 18810 //
     /* 2193085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2193096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2193099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2193102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2193105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193131 */     // MIs[0] round
     /* 2193131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193134 */     // MIs[0] policy
     /* 2193134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193144 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2193147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193170 */     // GIR_Coverage, 18810,
     /* 2193170 */     GIR_EraseRootFromParent_Done,
     /* 2193171 */   // Label 28868: @2193171
     /* 2193171 */   GIM_Try, /*On fail goto*//*Label 28869*/ GIMT_Encode4(2193262), // Rule ID 18811 //
     /* 2193176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2193187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2193190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2193193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2193196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193222 */     // MIs[0] round
     /* 2193222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193225 */     // MIs[0] policy
     /* 2193225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193235 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2193238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193261 */     // GIR_Coverage, 18811,
     /* 2193261 */     GIR_EraseRootFromParent_Done,
     /* 2193262 */   // Label 28869: @2193262
     /* 2193262 */   GIM_Try, /*On fail goto*//*Label 28870*/ GIMT_Encode4(2193353), // Rule ID 18814 //
     /* 2193267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2193278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2193281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2193284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2193287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193313 */     // MIs[0] round
     /* 2193313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193316 */     // MIs[0] policy
     /* 2193316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193326 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2193329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193352 */     // GIR_Coverage, 18814,
     /* 2193352 */     GIR_EraseRootFromParent_Done,
     /* 2193353 */   // Label 28870: @2193353
     /* 2193353 */   GIM_Try, /*On fail goto*//*Label 28871*/ GIMT_Encode4(2193444), // Rule ID 18815 //
     /* 2193358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2193369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2193372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2193375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2193378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193404 */     // MIs[0] round
     /* 2193404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193407 */     // MIs[0] policy
     /* 2193407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193417 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2193420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193443 */     // GIR_Coverage, 18815,
     /* 2193443 */     GIR_EraseRootFromParent_Done,
     /* 2193444 */   // Label 28871: @2193444
     /* 2193444 */   GIM_Try, /*On fail goto*//*Label 28872*/ GIMT_Encode4(2193535), // Rule ID 18818 //
     /* 2193449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2193460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2193463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2193466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2193469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193495 */     // MIs[0] round
     /* 2193495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193498 */     // MIs[0] policy
     /* 2193498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193508 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2193511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193534 */     // GIR_Coverage, 18818,
     /* 2193534 */     GIR_EraseRootFromParent_Done,
     /* 2193535 */   // Label 28872: @2193535
     /* 2193535 */   GIM_Try, /*On fail goto*//*Label 28873*/ GIMT_Encode4(2193626), // Rule ID 18819 //
     /* 2193540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2193551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2193554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2193557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2193560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193586 */     // MIs[0] round
     /* 2193586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193589 */     // MIs[0] policy
     /* 2193589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193599 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2193602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193625 */     // GIR_Coverage, 18819,
     /* 2193625 */     GIR_EraseRootFromParent_Done,
     /* 2193626 */   // Label 28873: @2193626
     /* 2193626 */   GIM_Try, /*On fail goto*//*Label 28874*/ GIMT_Encode4(2193717), // Rule ID 18822 //
     /* 2193631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2193642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2193645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2193648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2193651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2193654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193677 */     // MIs[0] round
     /* 2193677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193680 */     // MIs[0] policy
     /* 2193680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193690 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2193693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193716 */     // GIR_Coverage, 18822,
     /* 2193716 */     GIR_EraseRootFromParent_Done,
     /* 2193717 */   // Label 28874: @2193717
     /* 2193717 */   GIM_Try, /*On fail goto*//*Label 28875*/ GIMT_Encode4(2193808), // Rule ID 18823 //
     /* 2193722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2193733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2193736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2193739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2193742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2193745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193768 */     // MIs[0] round
     /* 2193768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193771 */     // MIs[0] policy
     /* 2193771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193781 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2193784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193807 */     // GIR_Coverage, 18823,
     /* 2193807 */     GIR_EraseRootFromParent_Done,
     /* 2193808 */   // Label 28875: @2193808
     /* 2193808 */   GIM_Try, /*On fail goto*//*Label 28876*/ GIMT_Encode4(2193899), // Rule ID 18826 //
     /* 2193813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2193824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2193827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2193830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2193833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2193851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193859 */     // MIs[0] round
     /* 2193859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193862 */     // MIs[0] policy
     /* 2193862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193872 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2193875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193898 */     // GIR_Coverage, 18826,
     /* 2193898 */     GIR_EraseRootFromParent_Done,
     /* 2193899 */   // Label 28876: @2193899
     /* 2193899 */   GIM_Try, /*On fail goto*//*Label 28877*/ GIMT_Encode4(2193990), // Rule ID 18827 //
     /* 2193904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2193915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2193918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2193921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2193924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2193942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193950 */     // MIs[0] round
     /* 2193950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193953 */     // MIs[0] policy
     /* 2193953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193963 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2193966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193989 */     // GIR_Coverage, 18827,
     /* 2193989 */     GIR_EraseRootFromParent_Done,
     /* 2193990 */   // Label 28877: @2193990
     /* 2193990 */   GIM_Try, /*On fail goto*//*Label 28878*/ GIMT_Encode4(2194081), // Rule ID 18830 //
     /* 2193995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2194006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2194009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2194015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194041 */     // MIs[0] round
     /* 2194041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194044 */     // MIs[0] policy
     /* 2194044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194054 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2194057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194080 */     // GIR_Coverage, 18830,
     /* 2194080 */     GIR_EraseRootFromParent_Done,
     /* 2194081 */   // Label 28878: @2194081
     /* 2194081 */   GIM_Try, /*On fail goto*//*Label 28879*/ GIMT_Encode4(2194172), // Rule ID 18831 //
     /* 2194086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2194097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2194100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2194106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194132 */     // MIs[0] round
     /* 2194132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194135 */     // MIs[0] policy
     /* 2194135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194145 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2194148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194171 */     // GIR_Coverage, 18831,
     /* 2194171 */     GIR_EraseRootFromParent_Done,
     /* 2194172 */   // Label 28879: @2194172
     /* 2194172 */   GIM_Try, /*On fail goto*//*Label 28880*/ GIMT_Encode4(2194263), // Rule ID 18834 //
     /* 2194177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2194188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2194191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2194197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194223 */     // MIs[0] round
     /* 2194223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194226 */     // MIs[0] policy
     /* 2194226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194236 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2194239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194262 */     // GIR_Coverage, 18834,
     /* 2194262 */     GIR_EraseRootFromParent_Done,
     /* 2194263 */   // Label 28880: @2194263
     /* 2194263 */   GIM_Try, /*On fail goto*//*Label 28881*/ GIMT_Encode4(2194354), // Rule ID 18835 //
     /* 2194268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2194279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2194282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2194288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194314 */     // MIs[0] round
     /* 2194314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194317 */     // MIs[0] policy
     /* 2194317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194327 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2194330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194353 */     // GIR_Coverage, 18835,
     /* 2194353 */     GIR_EraseRootFromParent_Done,
     /* 2194354 */   // Label 28881: @2194354
     /* 2194354 */   GIM_Try, /*On fail goto*//*Label 28882*/ GIMT_Encode4(2194445), // Rule ID 18838 //
     /* 2194359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2194370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2194373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2194379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194405 */     // MIs[0] round
     /* 2194405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194408 */     // MIs[0] policy
     /* 2194408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194418 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2194421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194444 */     // GIR_Coverage, 18838,
     /* 2194444 */     GIR_EraseRootFromParent_Done,
     /* 2194445 */   // Label 28882: @2194445
     /* 2194445 */   GIM_Try, /*On fail goto*//*Label 28883*/ GIMT_Encode4(2194536), // Rule ID 18839 //
     /* 2194450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2194461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2194464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2194470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194496 */     // MIs[0] round
     /* 2194496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194499 */     // MIs[0] policy
     /* 2194499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194509 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2194512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194535 */     // GIR_Coverage, 18839,
     /* 2194535 */     GIR_EraseRootFromParent_Done,
     /* 2194536 */   // Label 28883: @2194536
     /* 2194536 */   GIM_Try, /*On fail goto*//*Label 28884*/ GIMT_Encode4(2194627), // Rule ID 18842 //
     /* 2194541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2194552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2194555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2194561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2194564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2194571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2194575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194587 */     // MIs[0] round
     /* 2194587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194590 */     // MIs[0] policy
     /* 2194590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194600 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2194603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194626 */     // GIR_Coverage, 18842,
     /* 2194626 */     GIR_EraseRootFromParent_Done,
     /* 2194627 */   // Label 28884: @2194627
     /* 2194627 */   GIM_Try, /*On fail goto*//*Label 28885*/ GIMT_Encode4(2194718), // Rule ID 18843 //
     /* 2194632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2194643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2194646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2194652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2194655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2194662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2194666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194678 */     // MIs[0] round
     /* 2194678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194681 */     // MIs[0] policy
     /* 2194681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194691 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2194694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194717 */     // GIR_Coverage, 18843,
     /* 2194717 */     GIR_EraseRootFromParent_Done,
     /* 2194718 */   // Label 28885: @2194718
     /* 2194718 */   GIM_Try, /*On fail goto*//*Label 28886*/ GIMT_Encode4(2194809), // Rule ID 18846 //
     /* 2194723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2194726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2194734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2194737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2194740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2194743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2194746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2194761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194769 */     // MIs[0] round
     /* 2194769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194772 */     // MIs[0] policy
     /* 2194772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194782 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2194785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194808 */     // GIR_Coverage, 18846,
     /* 2194808 */     GIR_EraseRootFromParent_Done,
     /* 2194809 */   // Label 28886: @2194809
     /* 2194809 */   GIM_Try, /*On fail goto*//*Label 28887*/ GIMT_Encode4(2194900), // Rule ID 18847 //
     /* 2194814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2194817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2194825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2194828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2194831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2194834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2194837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2194852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194860 */     // MIs[0] round
     /* 2194860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194863 */     // MIs[0] policy
     /* 2194863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194873 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2194876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194899 */     // GIR_Coverage, 18847,
     /* 2194899 */     GIR_EraseRootFromParent_Done,
     /* 2194900 */   // Label 28887: @2194900
     /* 2194900 */   GIM_Try, /*On fail goto*//*Label 28888*/ GIMT_Encode4(2194991), // Rule ID 18850 //
     /* 2194905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2194908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2194916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2194919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2194922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2194925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2194943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194951 */     // MIs[0] round
     /* 2194951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194954 */     // MIs[0] policy
     /* 2194954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194964 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2194967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194990 */     // GIR_Coverage, 18850,
     /* 2194990 */     GIR_EraseRootFromParent_Done,
     /* 2194991 */   // Label 28888: @2194991
     /* 2194991 */   GIM_Try, /*On fail goto*//*Label 28889*/ GIMT_Encode4(2195082), // Rule ID 18851 //
     /* 2194996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2194999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2195007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2195010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2195016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195042 */     // MIs[0] round
     /* 2195042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195045 */     // MIs[0] policy
     /* 2195045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195055 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2195058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195081 */     // GIR_Coverage, 18851,
     /* 2195081 */     GIR_EraseRootFromParent_Done,
     /* 2195082 */   // Label 28889: @2195082
     /* 2195082 */   GIM_Try, /*On fail goto*//*Label 28890*/ GIMT_Encode4(2195173), // Rule ID 18854 //
     /* 2195087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2195098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2195101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2195107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2195117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195133 */     // MIs[0] round
     /* 2195133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195136 */     // MIs[0] policy
     /* 2195136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195146 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2195149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195172 */     // GIR_Coverage, 18854,
     /* 2195172 */     GIR_EraseRootFromParent_Done,
     /* 2195173 */   // Label 28890: @2195173
     /* 2195173 */   GIM_Try, /*On fail goto*//*Label 28891*/ GIMT_Encode4(2195264), // Rule ID 18855 //
     /* 2195178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2195189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2195192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2195198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2195208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195224 */     // MIs[0] round
     /* 2195224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195227 */     // MIs[0] policy
     /* 2195227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195237 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2195240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195263 */     // GIR_Coverage, 18855,
     /* 2195263 */     GIR_EraseRootFromParent_Done,
     /* 2195264 */   // Label 28891: @2195264
     /* 2195264 */   GIM_Try, /*On fail goto*//*Label 28892*/ GIMT_Encode4(2195355), // Rule ID 18858 //
     /* 2195269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2195280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2195283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2195289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195315 */     // MIs[0] round
     /* 2195315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195318 */     // MIs[0] policy
     /* 2195318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195328 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2195331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195354 */     // GIR_Coverage, 18858,
     /* 2195354 */     GIR_EraseRootFromParent_Done,
     /* 2195355 */   // Label 28892: @2195355
     /* 2195355 */   GIM_Try, /*On fail goto*//*Label 28893*/ GIMT_Encode4(2195446), // Rule ID 18859 //
     /* 2195360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2195371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2195374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2195380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195406 */     // MIs[0] round
     /* 2195406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195409 */     // MIs[0] policy
     /* 2195409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195419 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2195422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195445 */     // GIR_Coverage, 18859,
     /* 2195445 */     GIR_EraseRootFromParent_Done,
     /* 2195446 */   // Label 28893: @2195446
     /* 2195446 */   GIM_Try, /*On fail goto*//*Label 28894*/ GIMT_Encode4(2195537), // Rule ID 18862 //
     /* 2195451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2195454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2195462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2195465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2195468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2195471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195497 */     // MIs[0] round
     /* 2195497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195500 */     // MIs[0] policy
     /* 2195500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195510 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2195513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195536 */     // GIR_Coverage, 18862,
     /* 2195536 */     GIR_EraseRootFromParent_Done,
     /* 2195537 */   // Label 28894: @2195537
     /* 2195537 */   GIM_Try, /*On fail goto*//*Label 28895*/ GIMT_Encode4(2195628), // Rule ID 18863 //
     /* 2195542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2195545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2195553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2195556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2195559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2195562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195588 */     // MIs[0] round
     /* 2195588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195591 */     // MIs[0] policy
     /* 2195591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195601 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2195604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195627 */     // GIR_Coverage, 18863,
     /* 2195627 */     GIR_EraseRootFromParent_Done,
     /* 2195628 */   // Label 28895: @2195628
     /* 2195628 */   GIM_Try, /*On fail goto*//*Label 28896*/ GIMT_Encode4(2195719), // Rule ID 18866 //
     /* 2195633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2195636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2195644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2195647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2195650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2195653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195679 */     // MIs[0] round
     /* 2195679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195682 */     // MIs[0] policy
     /* 2195682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195692 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2195695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195718 */     // GIR_Coverage, 18866,
     /* 2195718 */     GIR_EraseRootFromParent_Done,
     /* 2195719 */   // Label 28896: @2195719
     /* 2195719 */   GIM_Try, /*On fail goto*//*Label 28897*/ GIMT_Encode4(2195810), // Rule ID 18867 //
     /* 2195724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2195727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2195735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2195738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2195741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2195744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195770 */     // MIs[0] round
     /* 2195770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195773 */     // MIs[0] policy
     /* 2195773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195783 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2195786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195809 */     // GIR_Coverage, 18867,
     /* 2195809 */     GIR_EraseRootFromParent_Done,
     /* 2195810 */   // Label 28897: @2195810
     /* 2195810 */   GIM_Try, /*On fail goto*//*Label 28898*/ GIMT_Encode4(2195901), // Rule ID 18870 //
     /* 2195815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2195818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2195826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2195829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2195832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2195835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195861 */     // MIs[0] round
     /* 2195861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195864 */     // MIs[0] policy
     /* 2195864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195874 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2195877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195900 */     // GIR_Coverage, 18870,
     /* 2195900 */     GIR_EraseRootFromParent_Done,
     /* 2195901 */   // Label 28898: @2195901
     /* 2195901 */   GIM_Try, /*On fail goto*//*Label 28899*/ GIMT_Encode4(2195992), // Rule ID 18871 //
     /* 2195906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2195909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2195917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2195920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2195923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2195926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195952 */     // MIs[0] round
     /* 2195952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195955 */     // MIs[0] policy
     /* 2195955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195965 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2195968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195991 */     // GIR_Coverage, 18871,
     /* 2195991 */     GIR_EraseRootFromParent_Done,
     /* 2195992 */   // Label 28899: @2195992
     /* 2195992 */   GIM_Try, /*On fail goto*//*Label 28900*/ GIMT_Encode4(2196083), // Rule ID 18874 //
     /* 2195997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2196008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2196011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2196014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2196017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196043 */     // MIs[0] round
     /* 2196043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196046 */     // MIs[0] policy
     /* 2196046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196056 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2196059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196082 */     // GIR_Coverage, 18874,
     /* 2196082 */     GIR_EraseRootFromParent_Done,
     /* 2196083 */   // Label 28900: @2196083
     /* 2196083 */   GIM_Try, /*On fail goto*//*Label 28901*/ GIMT_Encode4(2196174), // Rule ID 18875 //
     /* 2196088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2196099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2196102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2196105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2196108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196134 */     // MIs[0] round
     /* 2196134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196137 */     // MIs[0] policy
     /* 2196137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196147 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2196150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196173 */     // GIR_Coverage, 18875,
     /* 2196173 */     GIR_EraseRootFromParent_Done,
     /* 2196174 */   // Label 28901: @2196174
     /* 2196174 */   GIM_Try, /*On fail goto*//*Label 28902*/ GIMT_Encode4(2196265), // Rule ID 18878 //
     /* 2196179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2196190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2196193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2196196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2196199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2196202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2196209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196225 */     // MIs[0] round
     /* 2196225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196228 */     // MIs[0] policy
     /* 2196228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196238 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2196241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196264 */     // GIR_Coverage, 18878,
     /* 2196264 */     GIR_EraseRootFromParent_Done,
     /* 2196265 */   // Label 28902: @2196265
     /* 2196265 */   GIM_Try, /*On fail goto*//*Label 28903*/ GIMT_Encode4(2196356), // Rule ID 18879 //
     /* 2196270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2196281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2196284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2196287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2196290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2196293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2196300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196316 */     // MIs[0] round
     /* 2196316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196319 */     // MIs[0] policy
     /* 2196319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196329 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2196332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196355 */     // GIR_Coverage, 18879,
     /* 2196355 */     GIR_EraseRootFromParent_Done,
     /* 2196356 */   // Label 28903: @2196356
     /* 2196356 */   GIM_Try, /*On fail goto*//*Label 28904*/ GIMT_Encode4(2196447), // Rule ID 18882 //
     /* 2196361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2196364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2196372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2196375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2196378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2196381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196407 */     // MIs[0] round
     /* 2196407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196410 */     // MIs[0] policy
     /* 2196410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196420 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2196423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196446 */     // GIR_Coverage, 18882,
     /* 2196446 */     GIR_EraseRootFromParent_Done,
     /* 2196447 */   // Label 28904: @2196447
     /* 2196447 */   GIM_Try, /*On fail goto*//*Label 28905*/ GIMT_Encode4(2196538), // Rule ID 18883 //
     /* 2196452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2196455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2196463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2196466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2196469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2196472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196498 */     // MIs[0] round
     /* 2196498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196501 */     // MIs[0] policy
     /* 2196501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196511 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2196514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196537 */     // GIR_Coverage, 18883,
     /* 2196537 */     GIR_EraseRootFromParent_Done,
     /* 2196538 */   // Label 28905: @2196538
     /* 2196538 */   GIM_Try, /*On fail goto*//*Label 28906*/ GIMT_Encode4(2196629), // Rule ID 18886 //
     /* 2196543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2196546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2196554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2196557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2196560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2196563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2196566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2196573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196589 */     // MIs[0] round
     /* 2196589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196592 */     // MIs[0] policy
     /* 2196592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196602 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2196605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196628 */     // GIR_Coverage, 18886,
     /* 2196628 */     GIR_EraseRootFromParent_Done,
     /* 2196629 */   // Label 28906: @2196629
     /* 2196629 */   GIM_Try, /*On fail goto*//*Label 28907*/ GIMT_Encode4(2196720), // Rule ID 18887 //
     /* 2196634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2196637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2196645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2196648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2196651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2196654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2196657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2196664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196680 */     // MIs[0] round
     /* 2196680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196683 */     // MIs[0] policy
     /* 2196683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196693 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2196696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196719 */     // GIR_Coverage, 18887,
     /* 2196719 */     GIR_EraseRootFromParent_Done,
     /* 2196720 */   // Label 28907: @2196720
     /* 2196720 */   GIM_Try, /*On fail goto*//*Label 28908*/ GIMT_Encode4(2196811), // Rule ID 18890 //
     /* 2196725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2196728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2196736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2196739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2196742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2196745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2196748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196771 */     // MIs[0] round
     /* 2196771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196774 */     // MIs[0] policy
     /* 2196774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196784 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2196787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196810 */     // GIR_Coverage, 18890,
     /* 2196810 */     GIR_EraseRootFromParent_Done,
     /* 2196811 */   // Label 28908: @2196811
     /* 2196811 */   GIM_Try, /*On fail goto*//*Label 28909*/ GIMT_Encode4(2196902), // Rule ID 18891 //
     /* 2196816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2196819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2196827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2196830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2196833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2196836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2196839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196862 */     // MIs[0] round
     /* 2196862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196865 */     // MIs[0] policy
     /* 2196865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196875 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2196878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196901 */     // GIR_Coverage, 18891,
     /* 2196901 */     GIR_EraseRootFromParent_Done,
     /* 2196902 */   // Label 28909: @2196902
     /* 2196902 */   GIM_Try, /*On fail goto*//*Label 28910*/ GIMT_Encode4(2196993), // Rule ID 18894 //
     /* 2196907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2196910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2196918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2196921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2196924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2196927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2196937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196953 */     // MIs[0] round
     /* 2196953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196956 */     // MIs[0] policy
     /* 2196956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196966 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2196969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196992 */     // GIR_Coverage, 18894,
     /* 2196992 */     GIR_EraseRootFromParent_Done,
     /* 2196993 */   // Label 28910: @2196993
     /* 2196993 */   GIM_Try, /*On fail goto*//*Label 28911*/ GIMT_Encode4(2197084), // Rule ID 18895 //
     /* 2196998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2197001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2197009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2197012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2197015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2197018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2197021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2197028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197044 */     // MIs[0] round
     /* 2197044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197047 */     // MIs[0] policy
     /* 2197047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197057 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2197060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197083 */     // GIR_Coverage, 18895,
     /* 2197083 */     GIR_EraseRootFromParent_Done,
     /* 2197084 */   // Label 28911: @2197084
     /* 2197084 */   GIM_Try, /*On fail goto*//*Label 28912*/ GIMT_Encode4(2197175), // Rule ID 18898 //
     /* 2197089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2197100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2197103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2197109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2197112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197135 */     // MIs[0] round
     /* 2197135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197138 */     // MIs[0] policy
     /* 2197138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197148 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2197151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197174 */     // GIR_Coverage, 18898,
     /* 2197174 */     GIR_EraseRootFromParent_Done,
     /* 2197175 */   // Label 28912: @2197175
     /* 2197175 */   GIM_Try, /*On fail goto*//*Label 28913*/ GIMT_Encode4(2197266), // Rule ID 18899 //
     /* 2197180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2197191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2197194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2197200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2197203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197226 */     // MIs[0] round
     /* 2197226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197229 */     // MIs[0] policy
     /* 2197229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197239 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2197242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197265 */     // GIR_Coverage, 18899,
     /* 2197265 */     GIR_EraseRootFromParent_Done,
     /* 2197266 */   // Label 28913: @2197266
     /* 2197266 */   GIM_Try, /*On fail goto*//*Label 28914*/ GIMT_Encode4(2197357), // Rule ID 18902 //
     /* 2197271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2197282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2197285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2197291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197317 */     // MIs[0] round
     /* 2197317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197320 */     // MIs[0] policy
     /* 2197320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197330 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2197333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197356 */     // GIR_Coverage, 18902,
     /* 2197356 */     GIR_EraseRootFromParent_Done,
     /* 2197357 */   // Label 28914: @2197357
     /* 2197357 */   GIM_Try, /*On fail goto*//*Label 28915*/ GIMT_Encode4(2197448), // Rule ID 18903 //
     /* 2197362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2197373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2197376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2197382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197408 */     // MIs[0] round
     /* 2197408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197411 */     // MIs[0] policy
     /* 2197411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197421 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2197424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197447 */     // GIR_Coverage, 18903,
     /* 2197447 */     GIR_EraseRootFromParent_Done,
     /* 2197448 */   // Label 28915: @2197448
     /* 2197448 */   GIM_Try, /*On fail goto*//*Label 28916*/ GIMT_Encode4(2197539), // Rule ID 18906 //
     /* 2197453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2197464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2197467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2197473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2197476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2197483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197499 */     // MIs[0] round
     /* 2197499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197502 */     // MIs[0] policy
     /* 2197502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197512 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2197515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197538 */     // GIR_Coverage, 18906,
     /* 2197538 */     GIR_EraseRootFromParent_Done,
     /* 2197539 */   // Label 28916: @2197539
     /* 2197539 */   GIM_Try, /*On fail goto*//*Label 28917*/ GIMT_Encode4(2197630), // Rule ID 18907 //
     /* 2197544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2197555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2197558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2197564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2197567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2197574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197590 */     // MIs[0] round
     /* 2197590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197593 */     // MIs[0] policy
     /* 2197593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197603 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2197606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197629 */     // GIR_Coverage, 18907,
     /* 2197629 */     GIR_EraseRootFromParent_Done,
     /* 2197630 */   // Label 28917: @2197630
     /* 2197630 */   GIM_Try, /*On fail goto*//*Label 28918*/ GIMT_Encode4(2197721), // Rule ID 18910 //
     /* 2197635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2197646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2197649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2197655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2197658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2197665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197681 */     // MIs[0] round
     /* 2197681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197684 */     // MIs[0] policy
     /* 2197684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197694 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2197697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197720 */     // GIR_Coverage, 18910,
     /* 2197720 */     GIR_EraseRootFromParent_Done,
     /* 2197721 */   // Label 28918: @2197721
     /* 2197721 */   GIM_Try, /*On fail goto*//*Label 28919*/ GIMT_Encode4(2197812), // Rule ID 18911 //
     /* 2197726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2197737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2197740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2197746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2197749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2197756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197772 */     // MIs[0] round
     /* 2197772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197775 */     // MIs[0] policy
     /* 2197775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197785 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2197788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197811 */     // GIR_Coverage, 18911,
     /* 2197811 */     GIR_EraseRootFromParent_Done,
     /* 2197812 */   // Label 28919: @2197812
     /* 2197812 */   GIM_Try, /*On fail goto*//*Label 28920*/ GIMT_Encode4(2197903), // Rule ID 18914 //
     /* 2197817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2197828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2197831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2197837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2197840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2197847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197863 */     // MIs[0] round
     /* 2197863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197866 */     // MIs[0] policy
     /* 2197866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197876 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2197879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197902 */     // GIR_Coverage, 18914,
     /* 2197902 */     GIR_EraseRootFromParent_Done,
     /* 2197903 */   // Label 28920: @2197903
     /* 2197903 */   GIM_Try, /*On fail goto*//*Label 28921*/ GIMT_Encode4(2197994), // Rule ID 18915 //
     /* 2197908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2197919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2197922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2197928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2197931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2197938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197954 */     // MIs[0] round
     /* 2197954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197957 */     // MIs[0] policy
     /* 2197957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197967 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2197970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197993 */     // GIR_Coverage, 18915,
     /* 2197993 */     GIR_EraseRootFromParent_Done,
     /* 2197994 */   // Label 28921: @2197994
     /* 2197994 */   GIM_Try, /*On fail goto*//*Label 28922*/ GIMT_Encode4(2198085), // Rule ID 18918 //
     /* 2197999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2198010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2198013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2198019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198045 */     // MIs[0] round
     /* 2198045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198048 */     // MIs[0] policy
     /* 2198048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198058 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2198061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198084 */     // GIR_Coverage, 18918,
     /* 2198084 */     GIR_EraseRootFromParent_Done,
     /* 2198085 */   // Label 28922: @2198085
     /* 2198085 */   GIM_Try, /*On fail goto*//*Label 28923*/ GIMT_Encode4(2198176), // Rule ID 18919 //
     /* 2198090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2198101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2198104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2198110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198136 */     // MIs[0] round
     /* 2198136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198139 */     // MIs[0] policy
     /* 2198139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198149 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2198152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198175 */     // GIR_Coverage, 18919,
     /* 2198175 */     GIR_EraseRootFromParent_Done,
     /* 2198176 */   // Label 28923: @2198176
     /* 2198176 */   GIM_Try, /*On fail goto*//*Label 28924*/ GIMT_Encode4(2198267), // Rule ID 18922 //
     /* 2198181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2198192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2198195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2198201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2198204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198227 */     // MIs[0] round
     /* 2198227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198230 */     // MIs[0] policy
     /* 2198230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198240 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2198243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198266 */     // GIR_Coverage, 18922,
     /* 2198266 */     GIR_EraseRootFromParent_Done,
     /* 2198267 */   // Label 28924: @2198267
     /* 2198267 */   GIM_Try, /*On fail goto*//*Label 28925*/ GIMT_Encode4(2198358), // Rule ID 18923 //
     /* 2198272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2198283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2198286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2198292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2198295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198318 */     // MIs[0] round
     /* 2198318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198321 */     // MIs[0] policy
     /* 2198321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198331 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2198334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198357 */     // GIR_Coverage, 18923,
     /* 2198357 */     GIR_EraseRootFromParent_Done,
     /* 2198358 */   // Label 28925: @2198358
     /* 2198358 */   GIM_Try, /*On fail goto*//*Label 28926*/ GIMT_Encode4(2198449), // Rule ID 18926 //
     /* 2198363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2198374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2198377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2198383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2198386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198409 */     // MIs[0] round
     /* 2198409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198412 */     // MIs[0] policy
     /* 2198412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198422 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2198425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198448 */     // GIR_Coverage, 18926,
     /* 2198448 */     GIR_EraseRootFromParent_Done,
     /* 2198449 */   // Label 28926: @2198449
     /* 2198449 */   GIM_Try, /*On fail goto*//*Label 28927*/ GIMT_Encode4(2198540), // Rule ID 18927 //
     /* 2198454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2198465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2198468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2198474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2198477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198500 */     // MIs[0] round
     /* 2198500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198503 */     // MIs[0] policy
     /* 2198503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198513 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2198516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198539 */     // GIR_Coverage, 18927,
     /* 2198539 */     GIR_EraseRootFromParent_Done,
     /* 2198540 */   // Label 28927: @2198540
     /* 2198540 */   GIM_Try, /*On fail goto*//*Label 28928*/ GIMT_Encode4(2198631), // Rule ID 18930 //
     /* 2198545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2198556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2198559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2198565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2198568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2198575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2198579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198591 */     // MIs[0] round
     /* 2198591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198594 */     // MIs[0] policy
     /* 2198594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198604 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2198607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198630 */     // GIR_Coverage, 18930,
     /* 2198630 */     GIR_EraseRootFromParent_Done,
     /* 2198631 */   // Label 28928: @2198631
     /* 2198631 */   GIM_Try, /*On fail goto*//*Label 28929*/ GIMT_Encode4(2198722), // Rule ID 18931 //
     /* 2198636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2198647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2198650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2198656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2198659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2198666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2198670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198682 */     // MIs[0] round
     /* 2198682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198685 */     // MIs[0] policy
     /* 2198685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198695 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2198698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198721 */     // GIR_Coverage, 18931,
     /* 2198721 */     GIR_EraseRootFromParent_Done,
     /* 2198722 */   // Label 28929: @2198722
     /* 2198722 */   GIM_Try, /*On fail goto*//*Label 28930*/ GIMT_Encode4(2198813), // Rule ID 18934 //
     /* 2198727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2198730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2198735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2198738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2198741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2198744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2198747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198773 */     // MIs[0] round
     /* 2198773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198776 */     // MIs[0] policy
     /* 2198776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198786 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2198789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198812 */     // GIR_Coverage, 18934,
     /* 2198812 */     GIR_EraseRootFromParent_Done,
     /* 2198813 */   // Label 28930: @2198813
     /* 2198813 */   GIM_Try, /*On fail goto*//*Label 28931*/ GIMT_Encode4(2198904), // Rule ID 18935 //
     /* 2198818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2198821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2198826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2198829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2198832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2198835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2198838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198864 */     // MIs[0] round
     /* 2198864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198867 */     // MIs[0] policy
     /* 2198867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198877 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2198880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198903 */     // GIR_Coverage, 18935,
     /* 2198903 */     GIR_EraseRootFromParent_Done,
     /* 2198904 */   // Label 28931: @2198904
     /* 2198904 */   GIM_Try, /*On fail goto*//*Label 28932*/ GIMT_Encode4(2198995), // Rule ID 18938 //
     /* 2198909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2198912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2198917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2198920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2198923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2198926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2198929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2198932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198955 */     // MIs[0] round
     /* 2198955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198958 */     // MIs[0] policy
     /* 2198958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198968 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2198971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198994 */     // GIR_Coverage, 18938,
     /* 2198994 */     GIR_EraseRootFromParent_Done,
     /* 2198995 */   // Label 28932: @2198995
     /* 2198995 */   GIM_Try, /*On fail goto*//*Label 28933*/ GIMT_Encode4(2199086), // Rule ID 18939 //
     /* 2199000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2199011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2199014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2199017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2199020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2199023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199046 */     // MIs[0] round
     /* 2199046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199049 */     // MIs[0] policy
     /* 2199049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199059 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2199062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199085 */     // GIR_Coverage, 18939,
     /* 2199085 */     GIR_EraseRootFromParent_Done,
     /* 2199086 */   // Label 28933: @2199086
     /* 2199086 */   GIM_Try, /*On fail goto*//*Label 28934*/ GIMT_Encode4(2199177), // Rule ID 18942 //
     /* 2199091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2199102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2199105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2199108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2199111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2199114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199137 */     // MIs[0] round
     /* 2199137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199140 */     // MIs[0] policy
     /* 2199140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199150 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2199153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199176 */     // GIR_Coverage, 18942,
     /* 2199176 */     GIR_EraseRootFromParent_Done,
     /* 2199177 */   // Label 28934: @2199177
     /* 2199177 */   GIM_Try, /*On fail goto*//*Label 28935*/ GIMT_Encode4(2199268), // Rule ID 18943 //
     /* 2199182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2199193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2199196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2199199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2199202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2199205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199228 */     // MIs[0] round
     /* 2199228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199231 */     // MIs[0] policy
     /* 2199231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199241 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2199244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199267 */     // GIR_Coverage, 18943,
     /* 2199267 */     GIR_EraseRootFromParent_Done,
     /* 2199268 */   // Label 28935: @2199268
     /* 2199268 */   GIM_Try, /*On fail goto*//*Label 28936*/ GIMT_Encode4(2199359), // Rule ID 18946 //
     /* 2199273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2199284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2199287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2199290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2199293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2199303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199319 */     // MIs[0] round
     /* 2199319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199322 */     // MIs[0] policy
     /* 2199322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199332 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2199335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199358 */     // GIR_Coverage, 18946,
     /* 2199358 */     GIR_EraseRootFromParent_Done,
     /* 2199359 */   // Label 28936: @2199359
     /* 2199359 */   GIM_Try, /*On fail goto*//*Label 28937*/ GIMT_Encode4(2199450), // Rule ID 18947 //
     /* 2199364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2199375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2199378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2199381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2199384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2199394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199410 */     // MIs[0] round
     /* 2199410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199413 */     // MIs[0] policy
     /* 2199413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199423 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2199426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199449 */     // GIR_Coverage, 18947,
     /* 2199449 */     GIR_EraseRootFromParent_Done,
     /* 2199450 */   // Label 28937: @2199450
     /* 2199450 */   GIM_Try, /*On fail goto*//*Label 28938*/ GIMT_Encode4(2199541), // Rule ID 18950 //
     /* 2199455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2199466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2199469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2199472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2199475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2199478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2199485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2199489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199501 */     // MIs[0] round
     /* 2199501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199504 */     // MIs[0] policy
     /* 2199504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199514 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2199517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199540 */     // GIR_Coverage, 18950,
     /* 2199540 */     GIR_EraseRootFromParent_Done,
     /* 2199541 */   // Label 28938: @2199541
     /* 2199541 */   GIM_Try, /*On fail goto*//*Label 28939*/ GIMT_Encode4(2199632), // Rule ID 18951 //
     /* 2199546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2199557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2199560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2199563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2199566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2199569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2199576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2199580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199592 */     // MIs[0] round
     /* 2199592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199595 */     // MIs[0] policy
     /* 2199595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199605 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2199608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199631 */     // GIR_Coverage, 18951,
     /* 2199631 */     GIR_EraseRootFromParent_Done,
     /* 2199632 */   // Label 28939: @2199632
     /* 2199632 */   GIM_Try, /*On fail goto*//*Label 28940*/ GIMT_Encode4(2199723), // Rule ID 18954 //
     /* 2199637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2199640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2199648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2199651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2199654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2199657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2199660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199683 */     // MIs[0] round
     /* 2199683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199686 */     // MIs[0] policy
     /* 2199686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199696 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2199699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199722 */     // GIR_Coverage, 18954,
     /* 2199722 */     GIR_EraseRootFromParent_Done,
     /* 2199723 */   // Label 28940: @2199723
     /* 2199723 */   GIM_Try, /*On fail goto*//*Label 28941*/ GIMT_Encode4(2199814), // Rule ID 18955 //
     /* 2199728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2199731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2199739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2199742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2199745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2199748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2199751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199774 */     // MIs[0] round
     /* 2199774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199777 */     // MIs[0] policy
     /* 2199777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199787 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2199790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199813 */     // GIR_Coverage, 18955,
     /* 2199813 */     GIR_EraseRootFromParent_Done,
     /* 2199814 */   // Label 28941: @2199814
     /* 2199814 */   GIM_Try, /*On fail goto*//*Label 28942*/ GIMT_Encode4(2199905), // Rule ID 18958 //
     /* 2199819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2199822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2199830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2199833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2199836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2199839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2199842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199865 */     // MIs[0] round
     /* 2199865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199868 */     // MIs[0] policy
     /* 2199868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199878 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2199881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199904 */     // GIR_Coverage, 18958,
     /* 2199904 */     GIR_EraseRootFromParent_Done,
     /* 2199905 */   // Label 28942: @2199905
     /* 2199905 */   GIM_Try, /*On fail goto*//*Label 28943*/ GIMT_Encode4(2199996), // Rule ID 18959 //
     /* 2199910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2199913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2199921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2199924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2199927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2199930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2199933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199956 */     // MIs[0] round
     /* 2199956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199959 */     // MIs[0] policy
     /* 2199959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199969 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2199972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199995 */     // GIR_Coverage, 18959,
     /* 2199995 */     GIR_EraseRootFromParent_Done,
     /* 2199996 */   // Label 28943: @2199996
     /* 2199996 */   GIM_Try, /*On fail goto*//*Label 28944*/ GIMT_Encode4(2200087), // Rule ID 18962 //
     /* 2200001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2200012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2200015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2200018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2200021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2200031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200047 */     // MIs[0] round
     /* 2200047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200050 */     // MIs[0] policy
     /* 2200050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200060 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2200063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200086 */     // GIR_Coverage, 18962,
     /* 2200086 */     GIR_EraseRootFromParent_Done,
     /* 2200087 */   // Label 28944: @2200087
     /* 2200087 */   GIM_Try, /*On fail goto*//*Label 28945*/ GIMT_Encode4(2200178), // Rule ID 18963 //
     /* 2200092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2200103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2200106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2200109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2200112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2200122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200138 */     // MIs[0] round
     /* 2200138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200141 */     // MIs[0] policy
     /* 2200141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200151 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2200154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200177 */     // GIR_Coverage, 18963,
     /* 2200177 */     GIR_EraseRootFromParent_Done,
     /* 2200178 */   // Label 28945: @2200178
     /* 2200178 */   GIM_Try, /*On fail goto*//*Label 28946*/ GIMT_Encode4(2200269), // Rule ID 18966 //
     /* 2200183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2200194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2200197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2200200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2200203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2200206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200229 */     // MIs[0] round
     /* 2200229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200232 */     // MIs[0] policy
     /* 2200232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200242 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2200245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200268 */     // GIR_Coverage, 18966,
     /* 2200268 */     GIR_EraseRootFromParent_Done,
     /* 2200269 */   // Label 28946: @2200269
     /* 2200269 */   GIM_Try, /*On fail goto*//*Label 28947*/ GIMT_Encode4(2200360), // Rule ID 18967 //
     /* 2200274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2200285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2200288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2200291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2200294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2200297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200320 */     // MIs[0] round
     /* 2200320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200323 */     // MIs[0] policy
     /* 2200323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200333 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2200336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200359 */     // GIR_Coverage, 18967,
     /* 2200359 */     GIR_EraseRootFromParent_Done,
     /* 2200360 */   // Label 28947: @2200360
     /* 2200360 */   GIM_Try, /*On fail goto*//*Label 28948*/ GIMT_Encode4(2200451), // Rule ID 18970 //
     /* 2200365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2200368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2200376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2200379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2200385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200411 */     // MIs[0] round
     /* 2200411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200414 */     // MIs[0] policy
     /* 2200414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200424 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2200427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200450 */     // GIR_Coverage, 18970,
     /* 2200450 */     GIR_EraseRootFromParent_Done,
     /* 2200451 */   // Label 28948: @2200451
     /* 2200451 */   GIM_Try, /*On fail goto*//*Label 28949*/ GIMT_Encode4(2200542), // Rule ID 18971 //
     /* 2200456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2200459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2200467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2200470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2200476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200502 */     // MIs[0] round
     /* 2200502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200505 */     // MIs[0] policy
     /* 2200505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200515 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2200518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200541 */     // GIR_Coverage, 18971,
     /* 2200541 */     GIR_EraseRootFromParent_Done,
     /* 2200542 */   // Label 28949: @2200542
     /* 2200542 */   GIM_Try, /*On fail goto*//*Label 28950*/ GIMT_Encode4(2200633), // Rule ID 18974 //
     /* 2200547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2200550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2200558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2200561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2200567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2200570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200593 */     // MIs[0] round
     /* 2200593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200596 */     // MIs[0] policy
     /* 2200596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200606 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2200609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200632 */     // GIR_Coverage, 18974,
     /* 2200632 */     GIR_EraseRootFromParent_Done,
     /* 2200633 */   // Label 28950: @2200633
     /* 2200633 */   GIM_Try, /*On fail goto*//*Label 28951*/ GIMT_Encode4(2200724), // Rule ID 18975 //
     /* 2200638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2200641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2200649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2200652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2200658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2200661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200684 */     // MIs[0] round
     /* 2200684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200687 */     // MIs[0] policy
     /* 2200687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200697 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2200700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200723 */     // GIR_Coverage, 18975,
     /* 2200723 */     GIR_EraseRootFromParent_Done,
     /* 2200724 */   // Label 28951: @2200724
     /* 2200724 */   GIM_Try, /*On fail goto*//*Label 28952*/ GIMT_Encode4(2200815), // Rule ID 18978 //
     /* 2200729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2200732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2200740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2200743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2200749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2200759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200775 */     // MIs[0] round
     /* 2200775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200778 */     // MIs[0] policy
     /* 2200778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200788 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2200791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200814 */     // GIR_Coverage, 18978,
     /* 2200814 */     GIR_EraseRootFromParent_Done,
     /* 2200815 */   // Label 28952: @2200815
     /* 2200815 */   GIM_Try, /*On fail goto*//*Label 28953*/ GIMT_Encode4(2200906), // Rule ID 18979 //
     /* 2200820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2200823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2200831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2200834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2200840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2200850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200866 */     // MIs[0] round
     /* 2200866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200869 */     // MIs[0] policy
     /* 2200869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200879 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2200882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200905 */     // GIR_Coverage, 18979,
     /* 2200905 */     GIR_EraseRootFromParent_Done,
     /* 2200906 */   // Label 28953: @2200906
     /* 2200906 */   GIM_Try, /*On fail goto*//*Label 28954*/ GIMT_Encode4(2200997), // Rule ID 18982 //
     /* 2200911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2200914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2200922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2200925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2200931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2200934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2200941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200957 */     // MIs[0] round
     /* 2200957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200960 */     // MIs[0] policy
     /* 2200960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200970 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2200973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200996 */     // GIR_Coverage, 18982,
     /* 2200996 */     GIR_EraseRootFromParent_Done,
     /* 2200997 */   // Label 28954: @2200997
     /* 2200997 */   GIM_Try, /*On fail goto*//*Label 28955*/ GIMT_Encode4(2201088), // Rule ID 18983 //
     /* 2201002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2201013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2201016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2201022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2201025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2201032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201048 */     // MIs[0] round
     /* 2201048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201051 */     // MIs[0] policy
     /* 2201051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201061 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2201064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201087 */     // GIR_Coverage, 18983,
     /* 2201087 */     GIR_EraseRootFromParent_Done,
     /* 2201088 */   // Label 28955: @2201088
     /* 2201088 */   GIM_Try, /*On fail goto*//*Label 28956*/ GIMT_Encode4(2201179), // Rule ID 18986 //
     /* 2201093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2201104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2201107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2201113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2201116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201139 */     // MIs[0] round
     /* 2201139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201142 */     // MIs[0] policy
     /* 2201142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201152 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2201155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201178 */     // GIR_Coverage, 18986,
     /* 2201178 */     GIR_EraseRootFromParent_Done,
     /* 2201179 */   // Label 28956: @2201179
     /* 2201179 */   GIM_Try, /*On fail goto*//*Label 28957*/ GIMT_Encode4(2201270), // Rule ID 18987 //
     /* 2201184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2201195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2201198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2201204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2201207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201230 */     // MIs[0] round
     /* 2201230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201233 */     // MIs[0] policy
     /* 2201233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201243 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2201246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201269 */     // GIR_Coverage, 18987,
     /* 2201269 */     GIR_EraseRootFromParent_Done,
     /* 2201270 */   // Label 28957: @2201270
     /* 2201270 */   GIM_Try, /*On fail goto*//*Label 28958*/ GIMT_Encode4(2201361), // Rule ID 18990 //
     /* 2201275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2201278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2201286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2201289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2201295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2201298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201321 */     // MIs[0] round
     /* 2201321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201324 */     // MIs[0] policy
     /* 2201324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201334 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2201337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201360 */     // GIR_Coverage, 18990,
     /* 2201360 */     GIR_EraseRootFromParent_Done,
     /* 2201361 */   // Label 28958: @2201361
     /* 2201361 */   GIM_Try, /*On fail goto*//*Label 28959*/ GIMT_Encode4(2201452), // Rule ID 18991 //
     /* 2201366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2201369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2201377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2201380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2201386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2201389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201412 */     // MIs[0] round
     /* 2201412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201415 */     // MIs[0] policy
     /* 2201415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201425 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2201428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201451 */     // GIR_Coverage, 18991,
     /* 2201451 */     GIR_EraseRootFromParent_Done,
     /* 2201452 */   // Label 28959: @2201452
     /* 2201452 */   GIM_Try, /*On fail goto*//*Label 28960*/ GIMT_Encode4(2201543), // Rule ID 18994 //
     /* 2201457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2201460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2201468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2201471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2201477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2201480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2201487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201503 */     // MIs[0] round
     /* 2201503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201506 */     // MIs[0] policy
     /* 2201506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201516 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2201519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201542 */     // GIR_Coverage, 18994,
     /* 2201542 */     GIR_EraseRootFromParent_Done,
     /* 2201543 */   // Label 28960: @2201543
     /* 2201543 */   GIM_Try, /*On fail goto*//*Label 28961*/ GIMT_Encode4(2201634), // Rule ID 18995 //
     /* 2201548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2201551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2201559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2201562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2201568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2201571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2201578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201594 */     // MIs[0] round
     /* 2201594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201597 */     // MIs[0] policy
     /* 2201597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201607 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2201610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201633 */     // GIR_Coverage, 18995,
     /* 2201633 */     GIR_EraseRootFromParent_Done,
     /* 2201634 */   // Label 28961: @2201634
     /* 2201634 */   GIM_Try, /*On fail goto*//*Label 28962*/ GIMT_Encode4(2201725), // Rule ID 18998 //
     /* 2201639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2201642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2201650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2201653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2201659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2201662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2201669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201685 */     // MIs[0] round
     /* 2201685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201688 */     // MIs[0] policy
     /* 2201688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201698 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2201701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201724 */     // GIR_Coverage, 18998,
     /* 2201724 */     GIR_EraseRootFromParent_Done,
     /* 2201725 */   // Label 28962: @2201725
     /* 2201725 */   GIM_Try, /*On fail goto*//*Label 28963*/ GIMT_Encode4(2201816), // Rule ID 18999 //
     /* 2201730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2201733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2201741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2201744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2201750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2201753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2201760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201776 */     // MIs[0] round
     /* 2201776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201779 */     // MIs[0] policy
     /* 2201779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201789 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2201792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201815 */     // GIR_Coverage, 18999,
     /* 2201815 */     GIR_EraseRootFromParent_Done,
     /* 2201816 */   // Label 28963: @2201816
     /* 2201816 */   GIM_Try, /*On fail goto*//*Label 28964*/ GIMT_Encode4(2201907), // Rule ID 19002 //
     /* 2201821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2201824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2201832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2201835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2201841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2201844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201867 */     // MIs[0] round
     /* 2201867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201870 */     // MIs[0] policy
     /* 2201870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201880 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2201883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201906 */     // GIR_Coverage, 19002,
     /* 2201906 */     GIR_EraseRootFromParent_Done,
     /* 2201907 */   // Label 28964: @2201907
     /* 2201907 */   GIM_Try, /*On fail goto*//*Label 28965*/ GIMT_Encode4(2201998), // Rule ID 19003 //
     /* 2201912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2201915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2201923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2201926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2201932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2201935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201958 */     // MIs[0] round
     /* 2201958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201961 */     // MIs[0] policy
     /* 2201961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201971 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2201974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201997 */     // GIR_Coverage, 19003,
     /* 2201997 */     GIR_EraseRootFromParent_Done,
     /* 2201998 */   // Label 28965: @2201998
     /* 2201998 */   GIM_Try, /*On fail goto*//*Label 28966*/ GIMT_Encode4(2202089), // Rule ID 64361 //
     /* 2202003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2202014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2202017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2202020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2202026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202049 */     // MIs[0] round
     /* 2202049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202052 */     // MIs[0] policy
     /* 2202052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202062 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2202065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202088 */     // GIR_Coverage, 64361,
     /* 2202088 */     GIR_EraseRootFromParent_Done,
     /* 2202089 */   // Label 28966: @2202089
     /* 2202089 */   GIM_Try, /*On fail goto*//*Label 28967*/ GIMT_Encode4(2202180), // Rule ID 64362 //
     /* 2202094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2202105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2202108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2202111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2202117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202140 */     // MIs[0] round
     /* 2202140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202143 */     // MIs[0] policy
     /* 2202143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202153 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2202156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202179 */     // GIR_Coverage, 64362,
     /* 2202179 */     GIR_EraseRootFromParent_Done,
     /* 2202180 */   // Label 28967: @2202180
     /* 2202180 */   GIM_Try, /*On fail goto*//*Label 28968*/ GIMT_Encode4(2202271), // Rule ID 64365 //
     /* 2202185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2202196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2202199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2202202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202231 */     // MIs[0] round
     /* 2202231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202234 */     // MIs[0] policy
     /* 2202234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202244 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2202247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202270 */     // GIR_Coverage, 64365,
     /* 2202270 */     GIR_EraseRootFromParent_Done,
     /* 2202271 */   // Label 28968: @2202271
     /* 2202271 */   GIM_Try, /*On fail goto*//*Label 28969*/ GIMT_Encode4(2202362), // Rule ID 64366 //
     /* 2202276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2202287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2202290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2202293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202322 */     // MIs[0] round
     /* 2202322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202325 */     // MIs[0] policy
     /* 2202325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202335 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2202338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202361 */     // GIR_Coverage, 64366,
     /* 2202361 */     GIR_EraseRootFromParent_Done,
     /* 2202362 */   // Label 28969: @2202362
     /* 2202362 */   GIM_Try, /*On fail goto*//*Label 28970*/ GIMT_Encode4(2202453), // Rule ID 64369 //
     /* 2202367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2202378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2202381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2202384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202413 */     // MIs[0] round
     /* 2202413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202416 */     // MIs[0] policy
     /* 2202416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202426 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2202429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202452 */     // GIR_Coverage, 64369,
     /* 2202452 */     GIR_EraseRootFromParent_Done,
     /* 2202453 */   // Label 28970: @2202453
     /* 2202453 */   GIM_Try, /*On fail goto*//*Label 28971*/ GIMT_Encode4(2202544), // Rule ID 64370 //
     /* 2202458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2202469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2202472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2202475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202504 */     // MIs[0] round
     /* 2202504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202507 */     // MIs[0] policy
     /* 2202507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202517 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2202520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202543 */     // GIR_Coverage, 64370,
     /* 2202543 */     GIR_EraseRootFromParent_Done,
     /* 2202544 */   // Label 28971: @2202544
     /* 2202544 */   GIM_Try, /*On fail goto*//*Label 28972*/ GIMT_Encode4(2202635), // Rule ID 64373 //
     /* 2202549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2202560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2202563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2202566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2202572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202595 */     // MIs[0] round
     /* 2202595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202598 */     // MIs[0] policy
     /* 2202598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202608 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M1_MASK),
     /* 2202611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202634 */     // GIR_Coverage, 64373,
     /* 2202634 */     GIR_EraseRootFromParent_Done,
     /* 2202635 */   // Label 28972: @2202635
     /* 2202635 */   GIM_Try, /*On fail goto*//*Label 28973*/ GIMT_Encode4(2202726), // Rule ID 64374 //
     /* 2202640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2202651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2202654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2202657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2202663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202686 */     // MIs[0] round
     /* 2202686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202689 */     // MIs[0] policy
     /* 2202689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202699 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M1_MASK),
     /* 2202702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202725 */     // GIR_Coverage, 64374,
     /* 2202725 */     GIR_EraseRootFromParent_Done,
     /* 2202726 */   // Label 28973: @2202726
     /* 2202726 */   GIM_Try, /*On fail goto*//*Label 28974*/ GIMT_Encode4(2202817), // Rule ID 64377 //
     /* 2202731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2202742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2202745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2202748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2202754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2202761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202777 */     // MIs[0] round
     /* 2202777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202780 */     // MIs[0] policy
     /* 2202780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202790 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M2_MASK),
     /* 2202793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202816 */     // GIR_Coverage, 64377,
     /* 2202816 */     GIR_EraseRootFromParent_Done,
     /* 2202817 */   // Label 28974: @2202817
     /* 2202817 */   GIM_Try, /*On fail goto*//*Label 28975*/ GIMT_Encode4(2202908), // Rule ID 64378 //
     /* 2202822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2202833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2202836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2202839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2202845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2202852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202868 */     // MIs[0] round
     /* 2202868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202871 */     // MIs[0] policy
     /* 2202871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202881 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M2_MASK),
     /* 2202884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202907 */     // GIR_Coverage, 64378,
     /* 2202907 */     GIR_EraseRootFromParent_Done,
     /* 2202908 */   // Label 28975: @2202908
     /* 2202908 */   GIM_Try, /*On fail goto*//*Label 28976*/ GIMT_Encode4(2202999), // Rule ID 64381 //
     /* 2202913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2202921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2202924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2202927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2202930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2202936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202959 */     // MIs[0] round
     /* 2202959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202962 */     // MIs[0] policy
     /* 2202962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202972 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF8_MASK),
     /* 2202975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202998 */     // GIR_Coverage, 64381,
     /* 2202998 */     GIR_EraseRootFromParent_Done,
     /* 2202999 */   // Label 28976: @2202999
     /* 2202999 */   GIM_Try, /*On fail goto*//*Label 28977*/ GIMT_Encode4(2203090), // Rule ID 64382 //
     /* 2203004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2203015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2203018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2203021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2203027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203050 */     // MIs[0] round
     /* 2203050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203053 */     // MIs[0] policy
     /* 2203053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203063 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF8_MASK),
     /* 2203066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203089 */     // GIR_Coverage, 64382,
     /* 2203089 */     GIR_EraseRootFromParent_Done,
     /* 2203090 */   // Label 28977: @2203090
     /* 2203090 */   GIM_Try, /*On fail goto*//*Label 28978*/ GIMT_Encode4(2203181), // Rule ID 64385 //
     /* 2203095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2203106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2203109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2203112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2203118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203141 */     // MIs[0] round
     /* 2203141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203144 */     // MIs[0] policy
     /* 2203144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203154 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF4_MASK),
     /* 2203157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203180 */     // GIR_Coverage, 64385,
     /* 2203180 */     GIR_EraseRootFromParent_Done,
     /* 2203181 */   // Label 28978: @2203181
     /* 2203181 */   GIM_Try, /*On fail goto*//*Label 28979*/ GIMT_Encode4(2203272), // Rule ID 64386 //
     /* 2203186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2203197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2203200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2203203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2203209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203232 */     // MIs[0] round
     /* 2203232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203235 */     // MIs[0] policy
     /* 2203235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203245 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF4_MASK),
     /* 2203248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203271 */     // GIR_Coverage, 64386,
     /* 2203271 */     GIR_EraseRootFromParent_Done,
     /* 2203272 */   // Label 28979: @2203272
     /* 2203272 */   GIM_Try, /*On fail goto*//*Label 28980*/ GIMT_Encode4(2203363), // Rule ID 64389 //
     /* 2203277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2203288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2203291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2203294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2203300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203323 */     // MIs[0] round
     /* 2203323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203326 */     // MIs[0] policy
     /* 2203326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203336 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF2_MASK),
     /* 2203339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203362 */     // GIR_Coverage, 64389,
     /* 2203362 */     GIR_EraseRootFromParent_Done,
     /* 2203363 */   // Label 28980: @2203363
     /* 2203363 */   GIM_Try, /*On fail goto*//*Label 28981*/ GIMT_Encode4(2203454), // Rule ID 64390 //
     /* 2203368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2203379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2203382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2203385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2203391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203414 */     // MIs[0] round
     /* 2203414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203417 */     // MIs[0] policy
     /* 2203417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203427 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF2_MASK),
     /* 2203430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203453 */     // GIR_Coverage, 64390,
     /* 2203453 */     GIR_EraseRootFromParent_Done,
     /* 2203454 */   // Label 28981: @2203454
     /* 2203454 */   GIM_Try, /*On fail goto*//*Label 28982*/ GIMT_Encode4(2203545), // Rule ID 64393 //
     /* 2203459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2203470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2203473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2203476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2203482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203505 */     // MIs[0] round
     /* 2203505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203508 */     // MIs[0] policy
     /* 2203508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203518 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M1_MASK),
     /* 2203521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203544 */     // GIR_Coverage, 64393,
     /* 2203544 */     GIR_EraseRootFromParent_Done,
     /* 2203545 */   // Label 28982: @2203545
     /* 2203545 */   GIM_Try, /*On fail goto*//*Label 28983*/ GIMT_Encode4(2203636), // Rule ID 64394 //
     /* 2203550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2203561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2203564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2203567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2203573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203596 */     // MIs[0] round
     /* 2203596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203599 */     // MIs[0] policy
     /* 2203599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203609 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M1_MASK),
     /* 2203612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203635 */     // GIR_Coverage, 64394,
     /* 2203635 */     GIR_EraseRootFromParent_Done,
     /* 2203636 */   // Label 28983: @2203636
     /* 2203636 */   GIM_Try, /*On fail goto*//*Label 28984*/ GIMT_Encode4(2203727), // Rule ID 64397 //
     /* 2203641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2203652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2203655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2203658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2203664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2203671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203687 */     // MIs[0] round
     /* 2203687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203690 */     // MIs[0] policy
     /* 2203690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203700 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M2_MASK),
     /* 2203703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203726 */     // GIR_Coverage, 64397,
     /* 2203726 */     GIR_EraseRootFromParent_Done,
     /* 2203727 */   // Label 28984: @2203727
     /* 2203727 */   GIM_Try, /*On fail goto*//*Label 28985*/ GIMT_Encode4(2203818), // Rule ID 64398 //
     /* 2203732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2203743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2203746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2203749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2203755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2203762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203778 */     // MIs[0] round
     /* 2203778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203781 */     // MIs[0] policy
     /* 2203781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203791 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M2_MASK),
     /* 2203794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203817 */     // GIR_Coverage, 64398,
     /* 2203817 */     GIR_EraseRootFromParent_Done,
     /* 2203818 */   // Label 28985: @2203818
     /* 2203818 */   GIM_Try, /*On fail goto*//*Label 28986*/ GIMT_Encode4(2203909), // Rule ID 65131 //
     /* 2203823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2203826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2203831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2203834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2203837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2203840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2203846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203869 */     // MIs[0] round
     /* 2203869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203872 */     // MIs[0] policy
     /* 2203872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203882 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11046:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4_MASK),
     /* 2203885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203908 */     // GIR_Coverage, 65131,
     /* 2203908 */     GIR_EraseRootFromParent_Done,
     /* 2203909 */   // Label 28986: @2203909
     /* 2203909 */   GIM_Try, /*On fail goto*//*Label 28987*/ GIMT_Encode4(2204000), // Rule ID 65132 //
     /* 2203914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2203917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2203922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2203925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2203928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2203931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2203937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203960 */     // MIs[0] round
     /* 2203960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203963 */     // MIs[0] policy
     /* 2203963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203973 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11046:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4_MASK),
     /* 2203976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203999 */     // GIR_Coverage, 65132,
     /* 2203999 */     GIR_EraseRootFromParent_Done,
     /* 2204000 */   // Label 28987: @2204000
     /* 2204000 */   GIM_Try, /*On fail goto*//*Label 28988*/ GIMT_Encode4(2204091), // Rule ID 65135 //
     /* 2204005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2204016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2204019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2204022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2204028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204051 */     // MIs[0] round
     /* 2204051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204054 */     // MIs[0] policy
     /* 2204054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204064 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11046:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2_MASK),
     /* 2204067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204090 */     // GIR_Coverage, 65135,
     /* 2204090 */     GIR_EraseRootFromParent_Done,
     /* 2204091 */   // Label 28988: @2204091
     /* 2204091 */   GIM_Try, /*On fail goto*//*Label 28989*/ GIMT_Encode4(2204182), // Rule ID 65136 //
     /* 2204096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2204107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2204110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2204113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2204119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204142 */     // MIs[0] round
     /* 2204142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204145 */     // MIs[0] policy
     /* 2204145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204155 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11046:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2_MASK),
     /* 2204158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204181 */     // GIR_Coverage, 65136,
     /* 2204181 */     GIR_EraseRootFromParent_Done,
     /* 2204182 */   // Label 28989: @2204182
     /* 2204182 */   GIM_Try, /*On fail goto*//*Label 28990*/ GIMT_Encode4(2204273), // Rule ID 65139 //
     /* 2204187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2204198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2204201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2204204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2204210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204233 */     // MIs[0] round
     /* 2204233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204236 */     // MIs[0] policy
     /* 2204236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204246 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11046:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1_MASK),
     /* 2204249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204272 */     // GIR_Coverage, 65139,
     /* 2204272 */     GIR_EraseRootFromParent_Done,
     /* 2204273 */   // Label 28990: @2204273
     /* 2204273 */   GIM_Try, /*On fail goto*//*Label 28991*/ GIMT_Encode4(2204364), // Rule ID 65140 //
     /* 2204278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2204289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2204292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2204295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2204301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204324 */     // MIs[0] round
     /* 2204324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204327 */     // MIs[0] policy
     /* 2204327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204337 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11046:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1_MASK),
     /* 2204340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204363 */     // GIR_Coverage, 65140,
     /* 2204363 */     GIR_EraseRootFromParent_Done,
     /* 2204364 */   // Label 28991: @2204364
     /* 2204364 */   GIM_Try, /*On fail goto*//*Label 28992*/ GIMT_Encode4(2204455), // Rule ID 65143 //
     /* 2204369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2204380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2204383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2204386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204415 */     // MIs[0] round
     /* 2204415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204418 */     // MIs[0] policy
     /* 2204418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204428 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11046:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2_MASK),
     /* 2204431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204454 */     // GIR_Coverage, 65143,
     /* 2204454 */     GIR_EraseRootFromParent_Done,
     /* 2204455 */   // Label 28992: @2204455
     /* 2204455 */   GIM_Try, /*On fail goto*//*Label 28993*/ GIMT_Encode4(2204546), // Rule ID 65144 //
     /* 2204460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2204471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2204474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2204477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204506 */     // MIs[0] round
     /* 2204506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204509 */     // MIs[0] policy
     /* 2204509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204519 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11046:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2_MASK),
     /* 2204522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204545 */     // GIR_Coverage, 65144,
     /* 2204545 */     GIR_EraseRootFromParent_Done,
     /* 2204546 */   // Label 28993: @2204546
     /* 2204546 */   GIM_Try, /*On fail goto*//*Label 28994*/ GIMT_Encode4(2204637), // Rule ID 65147 //
     /* 2204551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2204562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2204565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2204568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2204574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2204581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204597 */     // MIs[0] round
     /* 2204597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204600 */     // MIs[0] policy
     /* 2204600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204610 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11046:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4_MASK),
     /* 2204613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204636 */     // GIR_Coverage, 65147,
     /* 2204636 */     GIR_EraseRootFromParent_Done,
     /* 2204637 */   // Label 28994: @2204637
     /* 2204637 */   GIM_Try, /*On fail goto*//*Label 28995*/ GIMT_Encode4(2204728), // Rule ID 65148 //
     /* 2204642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2204653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2204656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2204659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2204665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2204672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204688 */     // MIs[0] round
     /* 2204688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204691 */     // MIs[0] policy
     /* 2204691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204701 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11046:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4_MASK),
     /* 2204704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204727 */     // GIR_Coverage, 65148,
     /* 2204727 */     GIR_EraseRootFromParent_Done,
     /* 2204728 */   // Label 28995: @2204728
     /* 2204728 */   GIM_Try, /*On fail goto*//*Label 28996*/ GIMT_Encode4(2204819), // Rule ID 65151 //
     /* 2204733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2204744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2204747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2204750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2204756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2204763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204779 */     // MIs[0] round
     /* 2204779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204782 */     // MIs[0] policy
     /* 2204782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204792 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11046:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8_MASK),
     /* 2204795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204818 */     // GIR_Coverage, 65151,
     /* 2204818 */     GIR_EraseRootFromParent_Done,
     /* 2204819 */   // Label 28996: @2204819
     /* 2204819 */   GIM_Try, /*On fail goto*//*Label 28997*/ GIMT_Encode4(2204910), // Rule ID 65152 //
     /* 2204824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2204835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2204838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2204841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2204847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2204854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204870 */     // MIs[0] round
     /* 2204870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204873 */     // MIs[0] policy
     /* 2204873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204883 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11046:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8_MASK),
     /* 2204886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204906 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204909 */     // GIR_Coverage, 65152,
     /* 2204909 */     GIR_EraseRootFromParent_Done,
     /* 2204910 */   // Label 28997: @2204910
     /* 2204910 */   GIM_Try, /*On fail goto*//*Label 28998*/ GIMT_Encode4(2205001), // Rule ID 65155 //
     /* 2204915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2204923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2204926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2204929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2204932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2204938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204961 */     // MIs[0] round
     /* 2204961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204964 */     // MIs[0] policy
     /* 2204964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204974 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11044:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4_MASK),
     /* 2204977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205000 */     // GIR_Coverage, 65155,
     /* 2205000 */     GIR_EraseRootFromParent_Done,
     /* 2205001 */   // Label 28998: @2205001
     /* 2205001 */   GIM_Try, /*On fail goto*//*Label 28999*/ GIMT_Encode4(2205092), // Rule ID 65156 //
     /* 2205006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2205017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2205020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2205023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2205029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205052 */     // MIs[0] round
     /* 2205052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205055 */     // MIs[0] policy
     /* 2205055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205065 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11044:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4_MASK),
     /* 2205068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205091 */     // GIR_Coverage, 65156,
     /* 2205091 */     GIR_EraseRootFromParent_Done,
     /* 2205092 */   // Label 28999: @2205092
     /* 2205092 */   GIM_Try, /*On fail goto*//*Label 29000*/ GIMT_Encode4(2205183), // Rule ID 65159 //
     /* 2205097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2205108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2205111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2205114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2205120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205143 */     // MIs[0] round
     /* 2205143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205146 */     // MIs[0] policy
     /* 2205146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205156 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11044:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2_MASK),
     /* 2205159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205182 */     // GIR_Coverage, 65159,
     /* 2205182 */     GIR_EraseRootFromParent_Done,
     /* 2205183 */   // Label 29000: @2205183
     /* 2205183 */   GIM_Try, /*On fail goto*//*Label 29001*/ GIMT_Encode4(2205274), // Rule ID 65160 //
     /* 2205188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2205199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2205202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2205205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2205211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205234 */     // MIs[0] round
     /* 2205234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205237 */     // MIs[0] policy
     /* 2205237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205247 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11044:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2_MASK),
     /* 2205250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205273 */     // GIR_Coverage, 65160,
     /* 2205273 */     GIR_EraseRootFromParent_Done,
     /* 2205274 */   // Label 29001: @2205274
     /* 2205274 */   GIM_Try, /*On fail goto*//*Label 29002*/ GIMT_Encode4(2205365), // Rule ID 65163 //
     /* 2205279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2205290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2205293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2205296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2205302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205325 */     // MIs[0] round
     /* 2205325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205328 */     // MIs[0] policy
     /* 2205328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205338 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11044:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1_MASK),
     /* 2205341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205364 */     // GIR_Coverage, 65163,
     /* 2205364 */     GIR_EraseRootFromParent_Done,
     /* 2205365 */   // Label 29002: @2205365
     /* 2205365 */   GIM_Try, /*On fail goto*//*Label 29003*/ GIMT_Encode4(2205456), // Rule ID 65164 //
     /* 2205370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2205381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2205384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2205387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2205393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205416 */     // MIs[0] round
     /* 2205416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205419 */     // MIs[0] policy
     /* 2205419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205429 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11044:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1_MASK),
     /* 2205432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205455 */     // GIR_Coverage, 65164,
     /* 2205455 */     GIR_EraseRootFromParent_Done,
     /* 2205456 */   // Label 29003: @2205456
     /* 2205456 */   GIM_Try, /*On fail goto*//*Label 29004*/ GIMT_Encode4(2205547), // Rule ID 65167 //
     /* 2205461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2205472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2205475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2205478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2205484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2205491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205507 */     // MIs[0] round
     /* 2205507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205510 */     // MIs[0] policy
     /* 2205510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205520 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11044:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2_MASK),
     /* 2205523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205546 */     // GIR_Coverage, 65167,
     /* 2205546 */     GIR_EraseRootFromParent_Done,
     /* 2205547 */   // Label 29004: @2205547
     /* 2205547 */   GIM_Try, /*On fail goto*//*Label 29005*/ GIMT_Encode4(2205638), // Rule ID 65168 //
     /* 2205552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2205563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2205566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2205569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2205575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2205582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205598 */     // MIs[0] round
     /* 2205598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205601 */     // MIs[0] policy
     /* 2205601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205611 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11044:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2_MASK),
     /* 2205614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205634 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205637 */     // GIR_Coverage, 65168,
     /* 2205637 */     GIR_EraseRootFromParent_Done,
     /* 2205638 */   // Label 29005: @2205638
     /* 2205638 */   GIM_Try, /*On fail goto*//*Label 29006*/ GIMT_Encode4(2205729), // Rule ID 65171 //
     /* 2205643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2205654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2205657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2205660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2205666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2205673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205689 */     // MIs[0] round
     /* 2205689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205692 */     // MIs[0] policy
     /* 2205692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205702 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11044:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4_MASK),
     /* 2205705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205728 */     // GIR_Coverage, 65171,
     /* 2205728 */     GIR_EraseRootFromParent_Done,
     /* 2205729 */   // Label 29006: @2205729
     /* 2205729 */   GIM_Try, /*On fail goto*//*Label 29007*/ GIMT_Encode4(2205820), // Rule ID 65172 //
     /* 2205734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2205745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2205748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2205751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2205757 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2205764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205780 */     // MIs[0] round
     /* 2205780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205783 */     // MIs[0] policy
     /* 2205783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205793 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11044:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4_MASK),
     /* 2205796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205819 */     // GIR_Coverage, 65172,
     /* 2205819 */     GIR_EraseRootFromParent_Done,
     /* 2205820 */   // Label 29007: @2205820
     /* 2205820 */   GIM_Try, /*On fail goto*//*Label 29008*/ GIMT_Encode4(2205911), // Rule ID 65175 //
     /* 2205825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2205836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2205839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2205842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2205848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2205855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205871 */     // MIs[0] round
     /* 2205871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205874 */     // MIs[0] policy
     /* 2205874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205884 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11044:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8_MASK),
     /* 2205887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205910 */     // GIR_Coverage, 65175,
     /* 2205910 */     GIR_EraseRootFromParent_Done,
     /* 2205911 */   // Label 29008: @2205911
     /* 2205911 */   GIM_Try, /*On fail goto*//*Label 29009*/ GIMT_Encode4(2206002), // Rule ID 65176 //
     /* 2205916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2205927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2205930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2205933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2205939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2205946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205962 */     // MIs[0] round
     /* 2205962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205965 */     // MIs[0] policy
     /* 2205965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205975 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11044:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8_MASK),
     /* 2205978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206001 */     // GIR_Coverage, 65176,
     /* 2206001 */     GIR_EraseRootFromParent_Done,
     /* 2206002 */   // Label 29009: @2206002
     /* 2206002 */   GIM_Reject,
     /* 2206003 */ // Label 26941: @2206003
     /* 2206003 */ GIM_Reject,
     /* 2206004 */ // Label 38: @2206004
     /* 2206004 */ GIM_Try, /*On fail goto*//*Label 29010*/ GIMT_Encode4(2206056),
     /* 2206009 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 2206012 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::riscv_pause),
     /* 2206017 */   GIM_Try, /*On fail goto*//*Label 29011*/ GIMT_Encode4(2206036), // Rule ID 299 //
     /* 2206022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZihintpause_HwMode0),
     /* 2206025 */     // (intrinsic_void 11053:{ *:[iPTR] })  =>  (FENCE 1:{ *:[i64] }, 0:{ *:[i64] })
     /* 2206025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /* 2206028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2206031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2206034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206035 */     // GIR_Coverage, 299,
     /* 2206035 */     GIR_EraseRootFromParent_Done,
     /* 2206036 */   // Label 29011: @2206036
     /* 2206036 */   GIM_Try, /*On fail goto*//*Label 29012*/ GIMT_Encode4(2206055), // Rule ID 300 //
     /* 2206041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZihintpause_HwMode1),
     /* 2206044 */     // (intrinsic_void 11053:{ *:[iPTR] })  =>  (FENCE 1:{ *:[i32] }, 0:{ *:[i32] })
     /* 2206044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /* 2206047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2206050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2206053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206054 */     // GIR_Coverage, 300,
     /* 2206054 */     GIR_EraseRootFromParent_Done,
     /* 2206055 */   // Label 29012: @2206055
     /* 2206055 */   GIM_Reject,
     /* 2206056 */ // Label 29010: @2206056
     /* 2206056 */ GIM_Try, /*On fail goto*//*Label 29013*/ GIMT_Encode4(2206139), // Rule ID 41 //
     /* 2206061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2206064 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 2206067 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 2206072 */   // MIs[0] Operand 1
     /* 2206072 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 2206076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRX5RegClassID),
     /* 2206080 */   // MIs[0] ptr
     /* 2206080 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRJALRRegClassID),
     /* 2206088 */   // MIs[0] accessinfo
     /* 2206088 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 2206091 */   // (intrinsic_void 195:{ *:[iPTR] }, X5:{ *:[i64] }, GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 2206091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 2206095 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X5), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206101 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X5
     /* 2206105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 2206108 */   GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 2206110 */   GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 2206112 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X1*/0,
     /* 2206115 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X6*/1,
     /* 2206118 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X7*/2,
     /* 2206121 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X28*/3,
     /* 2206124 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X29*/4,
     /* 2206127 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X30*/5,
     /* 2206130 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X31*/6,
     /* 2206133 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206137 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206138 */   // GIR_Coverage, 41,
     /* 2206138 */   GIR_EraseRootFromParent_Done,
     /* 2206139 */ // Label 29013: @2206139
     /* 2206139 */ GIM_Try, /*On fail goto*//*Label 29014*/ GIMT_Encode4(2207044),
     /* 2206144 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 2206147 */   GIM_Try, /*On fail goto*//*Label 29015*/ GIMT_Encode4(2206219), // Rule ID 633 //
     /* 2206152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i32),
     /* 2206160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206173 */     // MIs[0] addr
     /* 2206173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206189 */     // MIs[0] ordering
     /* 2206189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206192 */     // (intrinsic_w_chain:{ *:[i32] } 11030:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2206198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206200 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206205 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206207 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206209 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206211 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206218 */     // GIR_Coverage, 633,
     /* 2206218 */     GIR_EraseRootFromParent_Done,
     /* 2206219 */   // Label 29015: @2206219
     /* 2206219 */   GIM_Try, /*On fail goto*//*Label 29016*/ GIMT_Encode4(2206291), // Rule ID 634 //
     /* 2206224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i32),
     /* 2206232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206245 */     // MIs[0] addr
     /* 2206245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206261 */     // MIs[0] ordering
     /* 2206261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206264 */     // (intrinsic_w_chain:{ *:[i32] } 11016:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2206270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206272 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206277 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206279 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206281 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206283 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206290 */     // GIR_Coverage, 634,
     /* 2206290 */     GIR_EraseRootFromParent_Done,
     /* 2206291 */   // Label 29016: @2206291
     /* 2206291 */   GIM_Try, /*On fail goto*//*Label 29017*/ GIMT_Encode4(2206363), // Rule ID 635 //
     /* 2206296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i32),
     /* 2206304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206317 */     // MIs[0] addr
     /* 2206317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206333 */     // MIs[0] ordering
     /* 2206333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206336 */     // (intrinsic_w_chain:{ *:[i32] } 11024:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2206342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206344 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206349 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206351 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206353 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206355 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206362 */     // GIR_Coverage, 635,
     /* 2206362 */     GIR_EraseRootFromParent_Done,
     /* 2206363 */   // Label 29017: @2206363
     /* 2206363 */   GIM_Try, /*On fail goto*//*Label 29018*/ GIMT_Encode4(2206435), // Rule ID 636 //
     /* 2206368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i32),
     /* 2206376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206389 */     // MIs[0] addr
     /* 2206389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206405 */     // MIs[0] ordering
     /* 2206405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206408 */     // (intrinsic_w_chain:{ *:[i32] } 11022:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2206414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206416 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206421 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206423 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206425 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206427 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206434 */     // GIR_Coverage, 636,
     /* 2206434 */     GIR_EraseRootFromParent_Done,
     /* 2206435 */   // Label 29018: @2206435
     /* 2206435 */   GIM_Try, /*On fail goto*//*Label 29019*/ GIMT_Encode4(2206515), // Rule ID 639 //
     /* 2206440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i32),
     /* 2206448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206461 */     // MIs[0] addr
     /* 2206461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206477 */     // MIs[0] ordering
     /* 2206477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206480 */     // (intrinsic_w_chain:{ *:[i32] } 11026:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206480 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2206483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2206489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206491 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206496 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206501 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206503 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206505 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206507 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206514 */     // GIR_Coverage, 639,
     /* 2206514 */     GIR_EraseRootFromParent_Done,
     /* 2206515 */   // Label 29019: @2206515
     /* 2206515 */   GIM_Try, /*On fail goto*//*Label 29020*/ GIMT_Encode4(2206595), // Rule ID 640 //
     /* 2206520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i32),
     /* 2206528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206541 */     // MIs[0] addr
     /* 2206541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206557 */     // MIs[0] ordering
     /* 2206557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206560 */     // (intrinsic_w_chain:{ *:[i32] } 11028:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206560 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2206563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2206569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206571 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206576 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206581 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206583 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206585 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206587 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206594 */     // GIR_Coverage, 640,
     /* 2206594 */     GIR_EraseRootFromParent_Done,
     /* 2206595 */   // Label 29020: @2206595
     /* 2206595 */   GIM_Try, /*On fail goto*//*Label 29021*/ GIMT_Encode4(2206667), // Rule ID 646 //
     /* 2206600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2206603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i64),
     /* 2206608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2206611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2206614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2206617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206621 */     // MIs[0] addr
     /* 2206621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206637 */     // MIs[0] ordering
     /* 2206637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206640 */     // (intrinsic_w_chain:{ *:[i64] } 11031:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2206640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2206646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206648 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206653 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206655 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206657 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206659 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206666 */     // GIR_Coverage, 646,
     /* 2206666 */     GIR_EraseRootFromParent_Done,
     /* 2206667 */   // Label 29021: @2206667
     /* 2206667 */   GIM_Try, /*On fail goto*//*Label 29022*/ GIMT_Encode4(2206739), // Rule ID 647 //
     /* 2206672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2206675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i64),
     /* 2206680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2206683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2206686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2206689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206693 */     // MIs[0] addr
     /* 2206693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206709 */     // MIs[0] ordering
     /* 2206709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206712 */     // (intrinsic_w_chain:{ *:[i64] } 11017:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2206712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2206718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206720 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206725 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206727 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206729 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206731 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206738 */     // GIR_Coverage, 647,
     /* 2206738 */     GIR_EraseRootFromParent_Done,
     /* 2206739 */   // Label 29022: @2206739
     /* 2206739 */   GIM_Try, /*On fail goto*//*Label 29023*/ GIMT_Encode4(2206811), // Rule ID 648 //
     /* 2206744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2206747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i64),
     /* 2206752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2206755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2206758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2206761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206765 */     // MIs[0] addr
     /* 2206765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206781 */     // MIs[0] ordering
     /* 2206781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206784 */     // (intrinsic_w_chain:{ *:[i64] } 11025:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2206784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2206790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206792 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206797 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206799 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206801 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206803 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206810 */     // GIR_Coverage, 648,
     /* 2206810 */     GIR_EraseRootFromParent_Done,
     /* 2206811 */   // Label 29023: @2206811
     /* 2206811 */   GIM_Try, /*On fail goto*//*Label 29024*/ GIMT_Encode4(2206883), // Rule ID 649 //
     /* 2206816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2206819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i64),
     /* 2206824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2206827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2206830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2206833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206837 */     // MIs[0] addr
     /* 2206837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206853 */     // MIs[0] ordering
     /* 2206853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206856 */     // (intrinsic_w_chain:{ *:[i64] } 11023:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2206856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2206862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206864 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206869 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206871 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206873 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206875 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206882 */     // GIR_Coverage, 649,
     /* 2206882 */     GIR_EraseRootFromParent_Done,
     /* 2206883 */   // Label 29024: @2206883
     /* 2206883 */   GIM_Try, /*On fail goto*//*Label 29025*/ GIMT_Encode4(2206963), // Rule ID 652 //
     /* 2206888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2206891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i64),
     /* 2206896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2206899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2206902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2206905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206909 */     // MIs[0] addr
     /* 2206909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206925 */     // MIs[0] ordering
     /* 2206925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206928 */     // (intrinsic_w_chain:{ *:[i64] } 11027:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2206928 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2206931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2206937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206939 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206944 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206949 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206951 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206953 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206955 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206962 */     // GIR_Coverage, 652,
     /* 2206962 */     GIR_EraseRootFromParent_Done,
     /* 2206963 */   // Label 29025: @2206963
     /* 2206963 */   GIM_Try, /*On fail goto*//*Label 29026*/ GIMT_Encode4(2207043), // Rule ID 653 //
     /* 2206968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2206971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i64),
     /* 2206976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2206979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2206982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2206985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206989 */     // MIs[0] addr
     /* 2206989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207005 */     // MIs[0] ordering
     /* 2207005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207008 */     // (intrinsic_w_chain:{ *:[i64] } 11029:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207008 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2207017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207019 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207024 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207029 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207031 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207033 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207035 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207042 */     // GIR_Coverage, 653,
     /* 2207042 */     GIR_EraseRootFromParent_Done,
     /* 2207043 */   // Label 29026: @2207043
     /* 2207043 */   GIM_Reject,
     /* 2207044 */ // Label 29014: @2207044
     /* 2207044 */ GIM_Try, /*On fail goto*//*Label 29027*/ GIMT_Encode4(2207571),
     /* 2207049 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 2207052 */   GIM_Try, /*On fail goto*//*Label 29028*/ GIMT_Encode4(2207141), // Rule ID 637 //
     /* 2207057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2207060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i32),
     /* 2207065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2207068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2207071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2207077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207081 */     // MIs[0] addr
     /* 2207081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207101 */     // MIs[0] ordering
     /* 2207101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207104 */     // (intrinsic_w_chain:{ *:[i32] } 11018:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2207104 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2207113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207115 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207120 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207125 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207127 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207129 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207131 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207133 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207140 */     // GIR_Coverage, 637,
     /* 2207140 */     GIR_EraseRootFromParent_Done,
     /* 2207141 */   // Label 29028: @2207141
     /* 2207141 */   GIM_Try, /*On fail goto*//*Label 29029*/ GIMT_Encode4(2207230), // Rule ID 638 //
     /* 2207146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2207149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i32),
     /* 2207154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2207157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2207160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2207166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207170 */     // MIs[0] addr
     /* 2207170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207190 */     // MIs[0] ordering
     /* 2207190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207193 */     // (intrinsic_w_chain:{ *:[i32] } 11020:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2207193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2207202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207204 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207209 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207214 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207216 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207218 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207220 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207222 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207229 */     // GIR_Coverage, 638,
     /* 2207229 */     GIR_EraseRootFromParent_Done,
     /* 2207230 */   // Label 29029: @2207230
     /* 2207230 */   GIM_Try, /*On fail goto*//*Label 29030*/ GIMT_Encode4(2207319), // Rule ID 650 //
     /* 2207235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i64),
     /* 2207243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2207255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207259 */     // MIs[0] addr
     /* 2207259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207279 */     // MIs[0] ordering
     /* 2207279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207282 */     // (intrinsic_w_chain:{ *:[i64] } 11019:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2207282 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2207291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207293 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207298 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207303 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207305 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207307 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207309 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207311 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207318 */     // GIR_Coverage, 650,
     /* 2207318 */     GIR_EraseRootFromParent_Done,
     /* 2207319 */   // Label 29030: @2207319
     /* 2207319 */   GIM_Try, /*On fail goto*//*Label 29031*/ GIMT_Encode4(2207408), // Rule ID 651 //
     /* 2207324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i64),
     /* 2207332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2207344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207348 */     // MIs[0] addr
     /* 2207348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207368 */     // MIs[0] ordering
     /* 2207368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207371 */     // (intrinsic_w_chain:{ *:[i64] } 11021:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2207371 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2207380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207382 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207387 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207392 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207394 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207396 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207398 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207400 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207407 */     // GIR_Coverage, 651,
     /* 2207407 */     GIR_EraseRootFromParent_Done,
     /* 2207408 */   // Label 29031: @2207408
     /* 2207408 */   GIM_Try, /*On fail goto*//*Label 29032*/ GIMT_Encode4(2207489), // Rule ID 669 //
     /* 2207413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2207416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i32),
     /* 2207421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2207424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2207427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2207433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207437 */     // MIs[0] addr
     /* 2207437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207457 */     // MIs[0] ordering
     /* 2207457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207460 */     // (intrinsic_w_chain:{ *:[i32] } 11032:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2207460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2207466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207468 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207473 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207475 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2207477 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2207479 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2207481 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207488 */     // GIR_Coverage, 669,
     /* 2207488 */     GIR_EraseRootFromParent_Done,
     /* 2207489 */   // Label 29032: @2207489
     /* 2207489 */   GIM_Try, /*On fail goto*//*Label 29033*/ GIMT_Encode4(2207570), // Rule ID 670 //
     /* 2207494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i64),
     /* 2207502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2207514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207518 */     // MIs[0] addr
     /* 2207518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207538 */     // MIs[0] ordering
     /* 2207538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207541 */     // (intrinsic_w_chain:{ *:[i64] } 11033:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2207547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207549 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207554 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207556 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2207558 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2207560 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2207562 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207569 */     // GIR_Coverage, 670,
     /* 2207569 */     GIR_EraseRootFromParent_Done,
     /* 2207570 */   // Label 29033: @2207570
     /* 2207570 */   GIM_Reject,
     /* 2207571 */ // Label 29027: @2207571
     /* 2207571 */ GIM_Reject,
     /* 2207572 */ // Label 39: @2207572
     /* 2207572 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(32), /*)*//*default:*//*Label 29049*/ GIMT_Encode4(2210692),
     /* 2207583 */ /*GILLT_nxv1s16*//*Label 29034*/ GIMT_Encode4(2207683),
     /* 2207587 */ /*GILLT_nxv1s32*//*Label 29035*/ GIMT_Encode4(2207787),
     /* 2207591 */ /*GILLT_nxv1s64*//*Label 29036*/ GIMT_Encode4(2208004), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207603 */ /*GILLT_nxv2s16*//*Label 29037*/ GIMT_Encode4(2208329),
     /* 2207607 */ /*GILLT_nxv2s32*//*Label 29038*/ GIMT_Encode4(2208433),
     /* 2207611 */ /*GILLT_nxv2s64*//*Label 29039*/ GIMT_Encode4(2208650), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207623 */ /*GILLT_nxv4s16*//*Label 29040*/ GIMT_Encode4(2208975),
     /* 2207627 */ /*GILLT_nxv4s32*//*Label 29041*/ GIMT_Encode4(2209079),
     /* 2207631 */ /*GILLT_nxv4s64*//*Label 29042*/ GIMT_Encode4(2209296), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207643 */ /*GILLT_nxv8s16*//*Label 29043*/ GIMT_Encode4(2209621),
     /* 2207647 */ /*GILLT_nxv8s32*//*Label 29044*/ GIMT_Encode4(2209725),
     /* 2207651 */ /*GILLT_nxv8s64*//*Label 29045*/ GIMT_Encode4(2209942), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207663 */ /*GILLT_nxv16s16*//*Label 29046*/ GIMT_Encode4(2210267),
     /* 2207667 */ /*GILLT_nxv16s32*//*Label 29047*/ GIMT_Encode4(2210371), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207679 */ /*GILLT_nxv32s16*//*Label 29048*/ GIMT_Encode4(2210588),
     /* 2207683 */ // Label 29034: @2207683
     /* 2207683 */ GIM_Try, /*On fail goto*//*Label 29050*/ GIMT_Encode4(2207786),
     /* 2207688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2207691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207699 */   GIM_Try, /*On fail goto*//*Label 29051*/ GIMT_Encode4(2207742), // Rule ID 47490 //
     /* 2207704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2207707 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2207710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2207724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207741 */     // GIR_Coverage, 47490,
     /* 2207741 */     GIR_EraseRootFromParent_Done,
     /* 2207742 */   // Label 29051: @2207742
     /* 2207742 */   GIM_Try, /*On fail goto*//*Label 29052*/ GIMT_Encode4(2207785), // Rule ID 47491 //
     /* 2207747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2207750 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2207753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2207767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207784 */     // GIR_Coverage, 47491,
     /* 2207784 */     GIR_EraseRootFromParent_Done,
     /* 2207785 */   // Label 29052: @2207785
     /* 2207785 */   GIM_Reject,
     /* 2207786 */ // Label 29050: @2207786
     /* 2207786 */ GIM_Reject,
     /* 2207787 */ // Label 29035: @2207787
     /* 2207787 */ GIM_Try, /*On fail goto*//*Label 29053*/ GIMT_Encode4(2207841), // Rule ID 47514 //
     /* 2207792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2207795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2207798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207806 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207806 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2207809 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207813 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2207823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207825 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207828 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207839 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207840 */   // GIR_Coverage, 47514,
     /* 2207840 */   GIR_EraseRootFromParent_Done,
     /* 2207841 */ // Label 29053: @2207841
     /* 2207841 */ GIM_Try, /*On fail goto*//*Label 29054*/ GIMT_Encode4(2207895), // Rule ID 47515 //
     /* 2207846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2207849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2207852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207860 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2207863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2207877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207879 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207882 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207894 */   // GIR_Coverage, 47515,
     /* 2207894 */   GIR_EraseRootFromParent_Done,
     /* 2207895 */ // Label 29054: @2207895
     /* 2207895 */ GIM_Try, /*On fail goto*//*Label 29055*/ GIMT_Encode4(2207949), // Rule ID 47580 //
     /* 2207900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2207903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2207906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207914 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2207917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2207931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207936 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207947 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207948 */   // GIR_Coverage, 47580,
     /* 2207948 */   GIR_EraseRootFromParent_Done,
     /* 2207949 */ // Label 29055: @2207949
     /* 2207949 */ GIM_Try, /*On fail goto*//*Label 29056*/ GIMT_Encode4(2208003), // Rule ID 47581 //
     /* 2207954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2207957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2207960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207968 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2207971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2207985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207987 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207990 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208001 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208002 */   // GIR_Coverage, 47581,
     /* 2208002 */   GIR_EraseRootFromParent_Done,
     /* 2208003 */ // Label 29056: @2208003
     /* 2208003 */ GIM_Reject,
     /* 2208004 */ // Label 29036: @2208004
     /* 2208004 */ GIM_Try, /*On fail goto*//*Label 29057*/ GIMT_Encode4(2208058), // Rule ID 47534 //
     /* 2208009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2208015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208023 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208023 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208026 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208030 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208045 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208056 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208057 */   // GIR_Coverage, 47534,
     /* 2208057 */   GIR_EraseRootFromParent_Done,
     /* 2208058 */ // Label 29057: @2208058
     /* 2208058 */ GIM_Try, /*On fail goto*//*Label 29058*/ GIMT_Encode4(2208112), // Rule ID 47535 //
     /* 2208063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2208069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208077 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208099 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208111 */   // GIR_Coverage, 47535,
     /* 2208111 */   GIR_EraseRootFromParent_Done,
     /* 2208112 */ // Label 29058: @2208112
     /* 2208112 */ GIM_Try, /*On fail goto*//*Label 29059*/ GIMT_Encode4(2208166), // Rule ID 47600 //
     /* 2208117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2208123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208131 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208131 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208134 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208138 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2208148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208153 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208165 */   // GIR_Coverage, 47600,
     /* 2208165 */   GIR_EraseRootFromParent_Done,
     /* 2208166 */ // Label 29059: @2208166
     /* 2208166 */ GIM_Try, /*On fail goto*//*Label 29060*/ GIMT_Encode4(2208220), // Rule ID 47601 //
     /* 2208171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2208177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208185 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208185 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208188 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208192 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2208202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208204 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208207 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208218 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208219 */   // GIR_Coverage, 47601,
     /* 2208219 */   GIR_EraseRootFromParent_Done,
     /* 2208220 */ // Label 29060: @2208220
     /* 2208220 */ GIM_Try, /*On fail goto*//*Label 29061*/ GIMT_Encode4(2208274), // Rule ID 47634 //
     /* 2208225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208239 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208239 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208242 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208246 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2208256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208261 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208272 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208273 */   // GIR_Coverage, 47634,
     /* 2208273 */   GIR_EraseRootFromParent_Done,
     /* 2208274 */ // Label 29061: @2208274
     /* 2208274 */ GIM_Try, /*On fail goto*//*Label 29062*/ GIMT_Encode4(2208328), // Rule ID 47635 //
     /* 2208279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208293 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2208310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208315 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208326 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208327 */   // GIR_Coverage, 47635,
     /* 2208327 */   GIR_EraseRootFromParent_Done,
     /* 2208328 */ // Label 29062: @2208328
     /* 2208328 */ GIM_Reject,
     /* 2208329 */ // Label 29037: @2208329
     /* 2208329 */ GIM_Try, /*On fail goto*//*Label 29063*/ GIMT_Encode4(2208432),
     /* 2208334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2208337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208345 */   GIM_Try, /*On fail goto*//*Label 29064*/ GIMT_Encode4(2208388), // Rule ID 47494 //
     /* 2208350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208353 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2208356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2208370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208387 */     // GIR_Coverage, 47494,
     /* 2208387 */     GIR_EraseRootFromParent_Done,
     /* 2208388 */   // Label 29064: @2208388
     /* 2208388 */   GIM_Try, /*On fail goto*//*Label 29065*/ GIMT_Encode4(2208431), // Rule ID 47495 //
     /* 2208393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208396 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2208399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2208413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208430 */     // GIR_Coverage, 47495,
     /* 2208430 */     GIR_EraseRootFromParent_Done,
     /* 2208431 */   // Label 29065: @2208431
     /* 2208431 */   GIM_Reject,
     /* 2208432 */ // Label 29063: @2208432
     /* 2208432 */ GIM_Reject,
     /* 2208433 */ // Label 29038: @2208433
     /* 2208433 */ GIM_Try, /*On fail goto*//*Label 29066*/ GIMT_Encode4(2208487), // Rule ID 47518 //
     /* 2208438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2208444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208452 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208474 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208485 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208486 */   // GIR_Coverage, 47518,
     /* 2208486 */   GIR_EraseRootFromParent_Done,
     /* 2208487 */ // Label 29066: @2208487
     /* 2208487 */ GIM_Try, /*On fail goto*//*Label 29067*/ GIMT_Encode4(2208541), // Rule ID 47519 //
     /* 2208492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2208498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208506 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208528 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208539 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208540 */   // GIR_Coverage, 47519,
     /* 2208540 */   GIR_EraseRootFromParent_Done,
     /* 2208541 */ // Label 29067: @2208541
     /* 2208541 */ GIM_Try, /*On fail goto*//*Label 29068*/ GIMT_Encode4(2208595), // Rule ID 47584 //
     /* 2208546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2208552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208560 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2208577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208582 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208593 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208594 */   // GIR_Coverage, 47584,
     /* 2208594 */   GIR_EraseRootFromParent_Done,
     /* 2208595 */ // Label 29068: @2208595
     /* 2208595 */ GIM_Try, /*On fail goto*//*Label 29069*/ GIMT_Encode4(2208649), // Rule ID 47585 //
     /* 2208600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2208606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208614 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2208631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208633 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208636 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208647 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208648 */   // GIR_Coverage, 47585,
     /* 2208648 */   GIR_EraseRootFromParent_Done,
     /* 2208649 */ // Label 29069: @2208649
     /* 2208649 */ GIM_Reject,
     /* 2208650 */ // Label 29039: @2208650
     /* 2208650 */ GIM_Try, /*On fail goto*//*Label 29070*/ GIMT_Encode4(2208704), // Rule ID 47538 //
     /* 2208655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2208661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208669 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2208686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208691 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208703 */   // GIR_Coverage, 47538,
     /* 2208703 */   GIR_EraseRootFromParent_Done,
     /* 2208704 */ // Label 29070: @2208704
     /* 2208704 */ GIM_Try, /*On fail goto*//*Label 29071*/ GIMT_Encode4(2208758), // Rule ID 47539 //
     /* 2208709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2208715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208723 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2208740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208745 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208756 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208757 */   // GIR_Coverage, 47539,
     /* 2208757 */   GIR_EraseRootFromParent_Done,
     /* 2208758 */ // Label 29071: @2208758
     /* 2208758 */ GIM_Try, /*On fail goto*//*Label 29072*/ GIMT_Encode4(2208812), // Rule ID 47604 //
     /* 2208763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2208769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208777 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208777 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208780 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208784 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2208794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208796 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208799 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208811 */   // GIR_Coverage, 47604,
     /* 2208811 */   GIR_EraseRootFromParent_Done,
     /* 2208812 */ // Label 29072: @2208812
     /* 2208812 */ GIM_Try, /*On fail goto*//*Label 29073*/ GIMT_Encode4(2208866), // Rule ID 47605 //
     /* 2208817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2208823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208831 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2208848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208853 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208864 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208865 */   // GIR_Coverage, 47605,
     /* 2208865 */   GIR_EraseRootFromParent_Done,
     /* 2208866 */ // Label 29073: @2208866
     /* 2208866 */ GIM_Try, /*On fail goto*//*Label 29074*/ GIMT_Encode4(2208920), // Rule ID 47638 //
     /* 2208871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2208877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208885 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208885 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208888 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208892 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2208902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208904 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208907 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208919 */   // GIR_Coverage, 47638,
     /* 2208919 */   GIR_EraseRootFromParent_Done,
     /* 2208920 */ // Label 29074: @2208920
     /* 2208920 */ GIM_Try, /*On fail goto*//*Label 29075*/ GIMT_Encode4(2208974), // Rule ID 47639 //
     /* 2208925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2208931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208939 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208939 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208942 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208946 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2208956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208961 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208973 */   // GIR_Coverage, 47639,
     /* 2208973 */   GIR_EraseRootFromParent_Done,
     /* 2208974 */ // Label 29075: @2208974
     /* 2208974 */ GIM_Reject,
     /* 2208975 */ // Label 29040: @2208975
     /* 2208975 */ GIM_Try, /*On fail goto*//*Label 29076*/ GIMT_Encode4(2209078),
     /* 2208980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2208983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208991 */   GIM_Try, /*On fail goto*//*Label 29077*/ GIMT_Encode4(2209034), // Rule ID 47498 //
     /* 2208996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208999 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2209002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2209016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209033 */     // GIR_Coverage, 47498,
     /* 2209033 */     GIR_EraseRootFromParent_Done,
     /* 2209034 */   // Label 29077: @2209034
     /* 2209034 */   GIM_Try, /*On fail goto*//*Label 29078*/ GIMT_Encode4(2209077), // Rule ID 47499 //
     /* 2209039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209042 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2209045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2209059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209076 */     // GIR_Coverage, 47499,
     /* 2209076 */     GIR_EraseRootFromParent_Done,
     /* 2209077 */   // Label 29078: @2209077
     /* 2209077 */   GIM_Reject,
     /* 2209078 */ // Label 29076: @2209078
     /* 2209078 */ GIM_Reject,
     /* 2209079 */ // Label 29041: @2209079
     /* 2209079 */ GIM_Try, /*On fail goto*//*Label 29079*/ GIMT_Encode4(2209133), // Rule ID 47522 //
     /* 2209084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209098 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209098 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209101 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209105 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209120 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209131 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209132 */   // GIR_Coverage, 47522,
     /* 2209132 */   GIR_EraseRootFromParent_Done,
     /* 2209133 */ // Label 29079: @2209133
     /* 2209133 */ GIM_Try, /*On fail goto*//*Label 29080*/ GIMT_Encode4(2209187), // Rule ID 47523 //
     /* 2209138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209152 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209171 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209174 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209185 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209186 */   // GIR_Coverage, 47523,
     /* 2209186 */   GIR_EraseRootFromParent_Done,
     /* 2209187 */ // Label 29080: @2209187
     /* 2209187 */ GIM_Try, /*On fail goto*//*Label 29081*/ GIMT_Encode4(2209241), // Rule ID 47588 //
     /* 2209192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209206 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209206 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209209 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209213 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2209223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209228 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209239 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209240 */   // GIR_Coverage, 47588,
     /* 2209240 */   GIR_EraseRootFromParent_Done,
     /* 2209241 */ // Label 29081: @2209241
     /* 2209241 */ GIM_Try, /*On fail goto*//*Label 29082*/ GIMT_Encode4(2209295), // Rule ID 47589 //
     /* 2209246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209260 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209272 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2209277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209279 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209282 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209293 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209294 */   // GIR_Coverage, 47589,
     /* 2209294 */   GIR_EraseRootFromParent_Done,
     /* 2209295 */ // Label 29082: @2209295
     /* 2209295 */ GIM_Reject,
     /* 2209296 */ // Label 29042: @2209296
     /* 2209296 */ GIM_Try, /*On fail goto*//*Label 29083*/ GIMT_Encode4(2209350), // Rule ID 47542 //
     /* 2209301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209315 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209315 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209318 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209322 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2209332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209337 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209349 */   // GIR_Coverage, 47542,
     /* 2209349 */   GIR_EraseRootFromParent_Done,
     /* 2209350 */ // Label 29083: @2209350
     /* 2209350 */ GIM_Try, /*On fail goto*//*Label 29084*/ GIMT_Encode4(2209404), // Rule ID 47543 //
     /* 2209355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209369 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2209386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209388 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209391 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209402 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209403 */   // GIR_Coverage, 47543,
     /* 2209403 */   GIR_EraseRootFromParent_Done,
     /* 2209404 */ // Label 29084: @2209404
     /* 2209404 */ GIM_Try, /*On fail goto*//*Label 29085*/ GIMT_Encode4(2209458), // Rule ID 47608 //
     /* 2209409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209423 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2209440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209445 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209456 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209457 */   // GIR_Coverage, 47608,
     /* 2209457 */   GIR_EraseRootFromParent_Done,
     /* 2209458 */ // Label 29085: @2209458
     /* 2209458 */ GIM_Try, /*On fail goto*//*Label 29086*/ GIMT_Encode4(2209512), // Rule ID 47609 //
     /* 2209463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209477 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2209494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209499 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209510 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209511 */   // GIR_Coverage, 47609,
     /* 2209511 */   GIR_EraseRootFromParent_Done,
     /* 2209512 */ // Label 29086: @2209512
     /* 2209512 */ GIM_Try, /*On fail goto*//*Label 29087*/ GIMT_Encode4(2209566), // Rule ID 47642 //
     /* 2209517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209531 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209531 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209538 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2209548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209553 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209564 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209565 */   // GIR_Coverage, 47642,
     /* 2209565 */   GIR_EraseRootFromParent_Done,
     /* 2209566 */ // Label 29087: @2209566
     /* 2209566 */ GIM_Try, /*On fail goto*//*Label 29088*/ GIMT_Encode4(2209620), // Rule ID 47643 //
     /* 2209571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209585 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2209602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209607 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209618 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209619 */   // GIR_Coverage, 47643,
     /* 2209619 */   GIR_EraseRootFromParent_Done,
     /* 2209620 */ // Label 29088: @2209620
     /* 2209620 */ GIM_Reject,
     /* 2209621 */ // Label 29043: @2209621
     /* 2209621 */ GIM_Try, /*On fail goto*//*Label 29089*/ GIMT_Encode4(2209724),
     /* 2209626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2209629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209637 */   GIM_Try, /*On fail goto*//*Label 29090*/ GIMT_Encode4(2209680), // Rule ID 47502 //
     /* 2209642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209645 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2209648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209679 */     // GIR_Coverage, 47502,
     /* 2209679 */     GIR_EraseRootFromParent_Done,
     /* 2209680 */   // Label 29090: @2209680
     /* 2209680 */   GIM_Try, /*On fail goto*//*Label 29091*/ GIMT_Encode4(2209723), // Rule ID 47503 //
     /* 2209685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209688 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2209691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209722 */     // GIR_Coverage, 47503,
     /* 2209722 */     GIR_EraseRootFromParent_Done,
     /* 2209723 */   // Label 29091: @2209723
     /* 2209723 */   GIM_Reject,
     /* 2209724 */ // Label 29089: @2209724
     /* 2209724 */ GIM_Reject,
     /* 2209725 */ // Label 29044: @2209725
     /* 2209725 */ GIM_Try, /*On fail goto*//*Label 29092*/ GIMT_Encode4(2209779), // Rule ID 47526 //
     /* 2209730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2209736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209744 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2209747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2209761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209766 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209777 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209778 */   // GIR_Coverage, 47526,
     /* 2209778 */   GIR_EraseRootFromParent_Done,
     /* 2209779 */ // Label 29092: @2209779
     /* 2209779 */ GIM_Try, /*On fail goto*//*Label 29093*/ GIMT_Encode4(2209833), // Rule ID 47527 //
     /* 2209784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2209790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209798 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209798 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2209801 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209805 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2209815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209817 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209820 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209831 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209832 */   // GIR_Coverage, 47527,
     /* 2209832 */   GIR_EraseRootFromParent_Done,
     /* 2209833 */ // Label 29093: @2209833
     /* 2209833 */ GIM_Try, /*On fail goto*//*Label 29094*/ GIMT_Encode4(2209887), // Rule ID 47592 //
     /* 2209838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2209844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209852 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209852 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2209855 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209859 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2209869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209871 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209874 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209885 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209886 */   // GIR_Coverage, 47592,
     /* 2209886 */   GIR_EraseRootFromParent_Done,
     /* 2209887 */ // Label 29094: @2209887
     /* 2209887 */ GIM_Try, /*On fail goto*//*Label 29095*/ GIMT_Encode4(2209941), // Rule ID 47593 //
     /* 2209892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2209898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209906 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209906 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2209909 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209913 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2209923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209925 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209928 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209939 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209940 */   // GIR_Coverage, 47593,
     /* 2209940 */   GIR_EraseRootFromParent_Done,
     /* 2209941 */ // Label 29095: @2209941
     /* 2209941 */ GIM_Reject,
     /* 2209942 */ // Label 29045: @2209942
     /* 2209942 */ GIM_Try, /*On fail goto*//*Label 29096*/ GIMT_Encode4(2209996), // Rule ID 47546 //
     /* 2209947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2209953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209961 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209961 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2209964 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209968 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2209978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209983 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209994 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209995 */   // GIR_Coverage, 47546,
     /* 2209995 */   GIR_EraseRootFromParent_Done,
     /* 2209996 */ // Label 29096: @2209996
     /* 2209996 */ GIM_Try, /*On fail goto*//*Label 29097*/ GIMT_Encode4(2210050), // Rule ID 47547 //
     /* 2210001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2210004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2210007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210015 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210037 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210048 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210049 */   // GIR_Coverage, 47547,
     /* 2210049 */   GIR_EraseRootFromParent_Done,
     /* 2210050 */ // Label 29097: @2210050
     /* 2210050 */ GIM_Try, /*On fail goto*//*Label 29098*/ GIMT_Encode4(2210104), // Rule ID 47612 //
     /* 2210055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2210058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210069 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210069 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210072 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210076 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210081 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210088 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210091 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210102 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210103 */   // GIR_Coverage, 47612,
     /* 2210103 */   GIR_EraseRootFromParent_Done,
     /* 2210104 */ // Label 29098: @2210104
     /* 2210104 */ GIM_Try, /*On fail goto*//*Label 29099*/ GIMT_Encode4(2210158), // Rule ID 47613 //
     /* 2210109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2210112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210123 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210123 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210126 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210130 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210145 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210156 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210157 */   // GIR_Coverage, 47613,
     /* 2210157 */   GIR_EraseRootFromParent_Done,
     /* 2210158 */ // Label 29099: @2210158
     /* 2210158 */ GIM_Try, /*On fail goto*//*Label 29100*/ GIMT_Encode4(2210212), // Rule ID 47646 //
     /* 2210163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2210166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210177 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2210194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210199 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210210 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210211 */   // GIR_Coverage, 47646,
     /* 2210211 */   GIR_EraseRootFromParent_Done,
     /* 2210212 */ // Label 29100: @2210212
     /* 2210212 */ GIM_Try, /*On fail goto*//*Label 29101*/ GIMT_Encode4(2210266), // Rule ID 47647 //
     /* 2210217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2210220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210231 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210231 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210234 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210238 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2210248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210250 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210253 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210264 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210265 */   // GIR_Coverage, 47647,
     /* 2210265 */   GIR_EraseRootFromParent_Done,
     /* 2210266 */ // Label 29101: @2210266
     /* 2210266 */ GIM_Reject,
     /* 2210267 */ // Label 29046: @2210267
     /* 2210267 */ GIM_Try, /*On fail goto*//*Label 29102*/ GIMT_Encode4(2210370),
     /* 2210272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2210275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210283 */   GIM_Try, /*On fail goto*//*Label 29103*/ GIMT_Encode4(2210326), // Rule ID 47506 //
     /* 2210288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210291 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2210294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2210308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210325 */     // GIR_Coverage, 47506,
     /* 2210325 */     GIR_EraseRootFromParent_Done,
     /* 2210326 */   // Label 29103: @2210326
     /* 2210326 */   GIM_Try, /*On fail goto*//*Label 29104*/ GIMT_Encode4(2210369), // Rule ID 47507 //
     /* 2210331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210334 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2210337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2210351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210368 */     // GIR_Coverage, 47507,
     /* 2210368 */     GIR_EraseRootFromParent_Done,
     /* 2210369 */   // Label 29104: @2210369
     /* 2210369 */   GIM_Reject,
     /* 2210370 */ // Label 29102: @2210370
     /* 2210370 */ GIM_Reject,
     /* 2210371 */ // Label 29047: @2210371
     /* 2210371 */ GIM_Try, /*On fail goto*//*Label 29105*/ GIMT_Encode4(2210425), // Rule ID 47530 //
     /* 2210376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2210382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210390 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210390 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210393 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210397 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210412 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210423 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210424 */   // GIR_Coverage, 47530,
     /* 2210424 */   GIR_EraseRootFromParent_Done,
     /* 2210425 */ // Label 29105: @2210425
     /* 2210425 */ GIM_Try, /*On fail goto*//*Label 29106*/ GIMT_Encode4(2210479), // Rule ID 47531 //
     /* 2210430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2210436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210444 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210444 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210447 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210451 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210466 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210478 */   // GIR_Coverage, 47531,
     /* 2210478 */   GIR_EraseRootFromParent_Done,
     /* 2210479 */ // Label 29106: @2210479
     /* 2210479 */ GIM_Try, /*On fail goto*//*Label 29107*/ GIMT_Encode4(2210533), // Rule ID 47596 //
     /* 2210484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2210490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210498 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210517 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210520 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210531 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210532 */   // GIR_Coverage, 47596,
     /* 2210532 */   GIR_EraseRootFromParent_Done,
     /* 2210533 */ // Label 29107: @2210533
     /* 2210533 */ GIM_Try, /*On fail goto*//*Label 29108*/ GIMT_Encode4(2210587), // Rule ID 47597 //
     /* 2210538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2210544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210552 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210552 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210555 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210559 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210571 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210574 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210585 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210586 */   // GIR_Coverage, 47597,
     /* 2210586 */   GIR_EraseRootFromParent_Done,
     /* 2210587 */ // Label 29108: @2210587
     /* 2210587 */ GIM_Reject,
     /* 2210588 */ // Label 29048: @2210588
     /* 2210588 */ GIM_Try, /*On fail goto*//*Label 29109*/ GIMT_Encode4(2210691),
     /* 2210593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2210596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210604 */   GIM_Try, /*On fail goto*//*Label 29110*/ GIMT_Encode4(2210647), // Rule ID 47510 //
     /* 2210609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210612 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2210615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210646 */     // GIR_Coverage, 47510,
     /* 2210646 */     GIR_EraseRootFromParent_Done,
     /* 2210647 */   // Label 29110: @2210647
     /* 2210647 */   GIM_Try, /*On fail goto*//*Label 29111*/ GIMT_Encode4(2210690), // Rule ID 47511 //
     /* 2210652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210655 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2210658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210689 */     // GIR_Coverage, 47511,
     /* 2210689 */     GIR_EraseRootFromParent_Done,
     /* 2210690 */   // Label 29111: @2210690
     /* 2210690 */   GIM_Reject,
     /* 2210691 */ // Label 29109: @2210691
     /* 2210691 */ GIM_Reject,
     /* 2210692 */ // Label 29049: @2210692
     /* 2210692 */ GIM_Reject,
     /* 2210693 */ // Label 40: @2210693
     /* 2210693 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 29129*/ GIMT_Encode4(2214167),
     /* 2210704 */ /*GILLT_s32*//*Label 29112*/ GIMT_Encode4(2210820),
     /* 2210708 */ /*GILLT_s64*//*Label 29113*/ GIMT_Encode4(2210994), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2210720 */ /*GILLT_nxv1s16*//*Label 29114*/ GIMT_Encode4(2211158),
     /* 2210724 */ /*GILLT_nxv1s32*//*Label 29115*/ GIMT_Encode4(2211262),
     /* 2210728 */ /*GILLT_nxv1s64*//*Label 29116*/ GIMT_Encode4(2211479), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2210740 */ /*GILLT_nxv2s16*//*Label 29117*/ GIMT_Encode4(2211804),
     /* 2210744 */ /*GILLT_nxv2s32*//*Label 29118*/ GIMT_Encode4(2211908),
     /* 2210748 */ /*GILLT_nxv2s64*//*Label 29119*/ GIMT_Encode4(2212125), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2210760 */ /*GILLT_nxv4s16*//*Label 29120*/ GIMT_Encode4(2212450),
     /* 2210764 */ /*GILLT_nxv4s32*//*Label 29121*/ GIMT_Encode4(2212554),
     /* 2210768 */ /*GILLT_nxv4s64*//*Label 29122*/ GIMT_Encode4(2212771), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2210780 */ /*GILLT_nxv8s16*//*Label 29123*/ GIMT_Encode4(2213096),
     /* 2210784 */ /*GILLT_nxv8s32*//*Label 29124*/ GIMT_Encode4(2213200),
     /* 2210788 */ /*GILLT_nxv8s64*//*Label 29125*/ GIMT_Encode4(2213417), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2210800 */ /*GILLT_nxv16s16*//*Label 29126*/ GIMT_Encode4(2213742),
     /* 2210804 */ /*GILLT_nxv16s32*//*Label 29127*/ GIMT_Encode4(2213846), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2210816 */ /*GILLT_nxv32s16*//*Label 29128*/ GIMT_Encode4(2214063),
     /* 2210820 */ // Label 29112: @2210820
     /* 2210820 */ GIM_Try, /*On fail goto*//*Label 29130*/ GIMT_Encode4(2210993),
     /* 2210825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2210828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210836 */   GIM_Try, /*On fail goto*//*Label 29131*/ GIMT_Encode4(2210878), // Rule ID 65413 //
     /* 2210841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode1),
     /* 2210844 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2210844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2210847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2210851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2210860 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2210863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2210868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2210876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210877 */     // GIR_Coverage, 65413,
     /* 2210877 */     GIR_EraseRootFromParent_Done,
     /* 2210878 */   // Label 29131: @2210878
     /* 2210878 */   GIM_Try, /*On fail goto*//*Label 29132*/ GIMT_Encode4(2210920), // Rule ID 65415 //
     /* 2210883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2210886 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2210886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2210889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2210893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2210902 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2210905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2210910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2210918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210919 */     // GIR_Coverage, 65415,
     /* 2210919 */     GIR_EraseRootFromParent_Done,
     /* 2210920 */   // Label 29132: @2210920
     /* 2210920 */   GIM_Try, /*On fail goto*//*Label 29133*/ GIMT_Encode4(2210962), // Rule ID 65416 //
     /* 2210925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode1),
     /* 2210928 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2210928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2210931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2210935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210940 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2210944 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2210947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2210952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2210960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210961 */     // GIR_Coverage, 65416,
     /* 2210961 */     GIR_EraseRootFromParent_Done,
     /* 2210962 */   // Label 29133: @2210962
     /* 2210962 */   GIM_Try, /*On fail goto*//*Label 29134*/ GIMT_Encode4(2210977), // Rule ID 65418 //
     /* 2210967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2210970 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2210970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2210975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210976 */     // GIR_Coverage, 65418,
     /* 2210976 */     GIR_Done,
     /* 2210977 */   // Label 29134: @2210977
     /* 2210977 */   GIM_Try, /*On fail goto*//*Label 29135*/ GIMT_Encode4(2210992), // Rule ID 65419 //
     /* 2210982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2210985 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2210985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2210990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210991 */     // GIR_Coverage, 65419,
     /* 2210991 */     GIR_Done,
     /* 2210992 */   // Label 29135: @2210992
     /* 2210992 */   GIM_Reject,
     /* 2210993 */ // Label 29130: @2210993
     /* 2210993 */ GIM_Reject,
     /* 2210994 */ // Label 29113: @2210994
     /* 2210994 */ GIM_Try, /*On fail goto*//*Label 29136*/ GIMT_Encode4(2211025), // Rule ID 65403 //
     /* 2210999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2211002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2211005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211013 */   // (sext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i32] }:$src, 0:{ *:[i64] })
     /* 2211013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2211016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211018 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2211020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2211023 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211024 */   // GIR_Coverage, 65403,
     /* 2211024 */   GIR_EraseRootFromParent_Done,
     /* 2211025 */ // Label 29136: @2211025
     /* 2211025 */ GIM_Try, /*On fail goto*//*Label 29137*/ GIMT_Encode4(2211078), // Rule ID 65412 //
     /* 2211030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode0),
     /* 2211033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211044 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2211044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2211047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211056 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211060 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2211063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2211076 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211077 */   // GIR_Coverage, 65412,
     /* 2211077 */   GIR_EraseRootFromParent_Done,
     /* 2211078 */ // Label 29137: @2211078
     /* 2211078 */ GIM_Try, /*On fail goto*//*Label 29138*/ GIMT_Encode4(2211131), // Rule ID 65414 //
     /* 2211083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2211086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211097 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2211097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2211100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211109 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211113 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2211116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2211129 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211130 */   // GIR_Coverage, 65414,
     /* 2211130 */   GIR_EraseRootFromParent_Done,
     /* 2211131 */ // Label 29138: @2211131
     /* 2211131 */ GIM_Try, /*On fail goto*//*Label 29139*/ GIMT_Encode4(2211157), // Rule ID 65420 //
     /* 2211136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2211139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211150 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2211150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2211155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211156 */   // GIR_Coverage, 65420,
     /* 2211156 */   GIR_Done,
     /* 2211157 */ // Label 29139: @2211157
     /* 2211157 */ GIM_Reject,
     /* 2211158 */ // Label 29114: @2211158
     /* 2211158 */ GIM_Try, /*On fail goto*//*Label 29140*/ GIMT_Encode4(2211261),
     /* 2211163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211174 */   GIM_Try, /*On fail goto*//*Label 29141*/ GIMT_Encode4(2211217), // Rule ID 47548 //
     /* 2211179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211182 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2211185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2211199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211216 */     // GIR_Coverage, 47548,
     /* 2211216 */     GIR_EraseRootFromParent_Done,
     /* 2211217 */   // Label 29141: @2211217
     /* 2211217 */   GIM_Try, /*On fail goto*//*Label 29142*/ GIMT_Encode4(2211260), // Rule ID 47549 //
     /* 2211222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211225 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2211228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2211242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211259 */     // GIR_Coverage, 47549,
     /* 2211259 */     GIR_EraseRootFromParent_Done,
     /* 2211260 */   // Label 29142: @2211260
     /* 2211260 */   GIM_Reject,
     /* 2211261 */ // Label 29140: @2211261
     /* 2211261 */ GIM_Reject,
     /* 2211262 */ // Label 29115: @2211262
     /* 2211262 */ GIM_Try, /*On fail goto*//*Label 29143*/ GIMT_Encode4(2211316), // Rule ID 47560 //
     /* 2211267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211281 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2211298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211300 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211303 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211314 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211315 */   // GIR_Coverage, 47560,
     /* 2211315 */   GIR_EraseRootFromParent_Done,
     /* 2211316 */ // Label 29143: @2211316
     /* 2211316 */ GIM_Try, /*On fail goto*//*Label 29144*/ GIMT_Encode4(2211370), // Rule ID 47561 //
     /* 2211321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211335 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211335 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211338 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211342 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2211352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211357 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211368 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211369 */   // GIR_Coverage, 47561,
     /* 2211369 */   GIR_EraseRootFromParent_Done,
     /* 2211370 */ // Label 29144: @2211370
     /* 2211370 */ GIM_Try, /*On fail goto*//*Label 29145*/ GIMT_Encode4(2211424), // Rule ID 47614 //
     /* 2211375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211389 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211389 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211392 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211396 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2211406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211411 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211422 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211423 */   // GIR_Coverage, 47614,
     /* 2211423 */   GIR_EraseRootFromParent_Done,
     /* 2211424 */ // Label 29145: @2211424
     /* 2211424 */ GIM_Try, /*On fail goto*//*Label 29146*/ GIMT_Encode4(2211478), // Rule ID 47615 //
     /* 2211429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211443 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2211460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211465 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211476 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211477 */   // GIR_Coverage, 47615,
     /* 2211477 */   GIR_EraseRootFromParent_Done,
     /* 2211478 */ // Label 29146: @2211478
     /* 2211478 */ GIM_Reject,
     /* 2211479 */ // Label 29116: @2211479
     /* 2211479 */ GIM_Try, /*On fail goto*//*Label 29147*/ GIMT_Encode4(2211533), // Rule ID 47570 //
     /* 2211484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2211487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211498 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2211515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211517 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211520 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211531 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211532 */   // GIR_Coverage, 47570,
     /* 2211532 */   GIR_EraseRootFromParent_Done,
     /* 2211533 */ // Label 29147: @2211533
     /* 2211533 */ GIM_Try, /*On fail goto*//*Label 29148*/ GIMT_Encode4(2211587), // Rule ID 47571 //
     /* 2211538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2211541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211552 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211552 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211555 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211559 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2211569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211571 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211574 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211585 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211586 */   // GIR_Coverage, 47571,
     /* 2211586 */   GIR_EraseRootFromParent_Done,
     /* 2211587 */ // Label 29148: @2211587
     /* 2211587 */ GIM_Try, /*On fail goto*//*Label 29149*/ GIMT_Encode4(2211641), // Rule ID 47624 //
     /* 2211592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2211595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211606 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2211623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211628 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211639 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211640 */   // GIR_Coverage, 47624,
     /* 2211640 */   GIR_EraseRootFromParent_Done,
     /* 2211641 */ // Label 29149: @2211641
     /* 2211641 */ GIM_Try, /*On fail goto*//*Label 29150*/ GIMT_Encode4(2211695), // Rule ID 47625 //
     /* 2211646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2211649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211660 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211660 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211663 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211667 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2211677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211679 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211682 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211693 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211694 */   // GIR_Coverage, 47625,
     /* 2211694 */   GIR_EraseRootFromParent_Done,
     /* 2211695 */ // Label 29150: @2211695
     /* 2211695 */ GIM_Try, /*On fail goto*//*Label 29151*/ GIMT_Encode4(2211749), // Rule ID 47648 //
     /* 2211700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2211703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211714 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2211731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211736 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211747 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211748 */   // GIR_Coverage, 47648,
     /* 2211748 */   GIR_EraseRootFromParent_Done,
     /* 2211749 */ // Label 29151: @2211749
     /* 2211749 */ GIM_Try, /*On fail goto*//*Label 29152*/ GIMT_Encode4(2211803), // Rule ID 47649 //
     /* 2211754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2211757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211768 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2211785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211790 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211801 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211802 */   // GIR_Coverage, 47649,
     /* 2211802 */   GIR_EraseRootFromParent_Done,
     /* 2211803 */ // Label 29152: @2211803
     /* 2211803 */ GIM_Reject,
     /* 2211804 */ // Label 29117: @2211804
     /* 2211804 */ GIM_Try, /*On fail goto*//*Label 29153*/ GIMT_Encode4(2211907),
     /* 2211809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2211812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211820 */   GIM_Try, /*On fail goto*//*Label 29154*/ GIMT_Encode4(2211863), // Rule ID 47550 //
     /* 2211825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211828 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2211831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2211845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211862 */     // GIR_Coverage, 47550,
     /* 2211862 */     GIR_EraseRootFromParent_Done,
     /* 2211863 */   // Label 29154: @2211863
     /* 2211863 */   GIM_Try, /*On fail goto*//*Label 29155*/ GIMT_Encode4(2211906), // Rule ID 47551 //
     /* 2211868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211871 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2211874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2211888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211905 */     // GIR_Coverage, 47551,
     /* 2211905 */     GIR_EraseRootFromParent_Done,
     /* 2211906 */   // Label 29155: @2211906
     /* 2211906 */   GIM_Reject,
     /* 2211907 */ // Label 29153: @2211907
     /* 2211907 */ GIM_Reject,
     /* 2211908 */ // Label 29118: @2211908
     /* 2211908 */ GIM_Try, /*On fail goto*//*Label 29156*/ GIMT_Encode4(2211962), // Rule ID 47562 //
     /* 2211913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2211919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211927 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2211930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2211944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211949 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211960 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211961 */   // GIR_Coverage, 47562,
     /* 2211961 */   GIR_EraseRootFromParent_Done,
     /* 2211962 */ // Label 29156: @2211962
     /* 2211962 */ GIM_Try, /*On fail goto*//*Label 29157*/ GIMT_Encode4(2212016), // Rule ID 47563 //
     /* 2211967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2211973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211981 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211981 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2211984 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211988 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2211998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212000 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212003 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212014 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212015 */   // GIR_Coverage, 47563,
     /* 2212015 */   GIR_EraseRootFromParent_Done,
     /* 2212016 */ // Label 29157: @2212016
     /* 2212016 */ GIM_Try, /*On fail goto*//*Label 29158*/ GIMT_Encode4(2212070), // Rule ID 47616 //
     /* 2212021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212035 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212035 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212038 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212042 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2212052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212057 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212069 */   // GIR_Coverage, 47616,
     /* 2212069 */   GIR_EraseRootFromParent_Done,
     /* 2212070 */ // Label 29158: @2212070
     /* 2212070 */ GIM_Try, /*On fail goto*//*Label 29159*/ GIMT_Encode4(2212124), // Rule ID 47617 //
     /* 2212075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212089 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2212106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212111 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212122 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212123 */   // GIR_Coverage, 47617,
     /* 2212123 */   GIR_EraseRootFromParent_Done,
     /* 2212124 */ // Label 29159: @2212124
     /* 2212124 */ GIM_Reject,
     /* 2212125 */ // Label 29119: @2212125
     /* 2212125 */ GIM_Try, /*On fail goto*//*Label 29160*/ GIMT_Encode4(2212179), // Rule ID 47572 //
     /* 2212130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212144 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2212161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212166 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212177 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212178 */   // GIR_Coverage, 47572,
     /* 2212178 */   GIR_EraseRootFromParent_Done,
     /* 2212179 */ // Label 29160: @2212179
     /* 2212179 */ GIM_Try, /*On fail goto*//*Label 29161*/ GIMT_Encode4(2212233), // Rule ID 47573 //
     /* 2212184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212198 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212198 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212201 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212205 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2212215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212220 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212231 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212232 */   // GIR_Coverage, 47573,
     /* 2212232 */   GIR_EraseRootFromParent_Done,
     /* 2212233 */ // Label 29161: @2212233
     /* 2212233 */ GIM_Try, /*On fail goto*//*Label 29162*/ GIMT_Encode4(2212287), // Rule ID 47626 //
     /* 2212238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212252 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2212269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212274 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212286 */   // GIR_Coverage, 47626,
     /* 2212286 */   GIR_EraseRootFromParent_Done,
     /* 2212287 */ // Label 29162: @2212287
     /* 2212287 */ GIM_Try, /*On fail goto*//*Label 29163*/ GIMT_Encode4(2212341), // Rule ID 47627 //
     /* 2212292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212306 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2212323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212328 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212339 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212340 */   // GIR_Coverage, 47627,
     /* 2212340 */   GIR_EraseRootFromParent_Done,
     /* 2212341 */ // Label 29163: @2212341
     /* 2212341 */ GIM_Try, /*On fail goto*//*Label 29164*/ GIMT_Encode4(2212395), // Rule ID 47650 //
     /* 2212346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212360 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2212377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212379 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212382 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212393 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212394 */   // GIR_Coverage, 47650,
     /* 2212394 */   GIR_EraseRootFromParent_Done,
     /* 2212395 */ // Label 29164: @2212395
     /* 2212395 */ GIM_Try, /*On fail goto*//*Label 29165*/ GIMT_Encode4(2212449), // Rule ID 47651 //
     /* 2212400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212414 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2212431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212436 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212447 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212448 */   // GIR_Coverage, 47651,
     /* 2212448 */   GIR_EraseRootFromParent_Done,
     /* 2212449 */ // Label 29165: @2212449
     /* 2212449 */ GIM_Reject,
     /* 2212450 */ // Label 29120: @2212450
     /* 2212450 */ GIM_Try, /*On fail goto*//*Label 29166*/ GIMT_Encode4(2212553),
     /* 2212455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2212458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212466 */   GIM_Try, /*On fail goto*//*Label 29167*/ GIMT_Encode4(2212509), // Rule ID 47552 //
     /* 2212471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212474 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2212477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212508 */     // GIR_Coverage, 47552,
     /* 2212508 */     GIR_EraseRootFromParent_Done,
     /* 2212509 */   // Label 29167: @2212509
     /* 2212509 */   GIM_Try, /*On fail goto*//*Label 29168*/ GIMT_Encode4(2212552), // Rule ID 47553 //
     /* 2212514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212517 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2212520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212551 */     // GIR_Coverage, 47553,
     /* 2212551 */     GIR_EraseRootFromParent_Done,
     /* 2212552 */   // Label 29168: @2212552
     /* 2212552 */   GIM_Reject,
     /* 2212553 */ // Label 29166: @2212553
     /* 2212553 */ GIM_Reject,
     /* 2212554 */ // Label 29121: @2212554
     /* 2212554 */ GIM_Try, /*On fail goto*//*Label 29169*/ GIMT_Encode4(2212608), // Rule ID 47564 //
     /* 2212559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2212565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212573 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2212576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2212590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212595 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212606 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212607 */   // GIR_Coverage, 47564,
     /* 2212607 */   GIR_EraseRootFromParent_Done,
     /* 2212608 */ // Label 29169: @2212608
     /* 2212608 */ GIM_Try, /*On fail goto*//*Label 29170*/ GIMT_Encode4(2212662), // Rule ID 47565 //
     /* 2212613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2212619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212627 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212627 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2212630 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212634 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2212644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212649 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212660 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212661 */   // GIR_Coverage, 47565,
     /* 2212661 */   GIR_EraseRootFromParent_Done,
     /* 2212662 */ // Label 29170: @2212662
     /* 2212662 */ GIM_Try, /*On fail goto*//*Label 29171*/ GIMT_Encode4(2212716), // Rule ID 47618 //
     /* 2212667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2212673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212681 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2212684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2212698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212703 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212714 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212715 */   // GIR_Coverage, 47618,
     /* 2212715 */   GIR_EraseRootFromParent_Done,
     /* 2212716 */ // Label 29171: @2212716
     /* 2212716 */ GIM_Try, /*On fail goto*//*Label 29172*/ GIMT_Encode4(2212770), // Rule ID 47619 //
     /* 2212721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2212727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212735 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2212738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2212752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212757 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212768 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212769 */   // GIR_Coverage, 47619,
     /* 2212769 */   GIR_EraseRootFromParent_Done,
     /* 2212770 */ // Label 29172: @2212770
     /* 2212770 */ GIM_Reject,
     /* 2212771 */ // Label 29122: @2212771
     /* 2212771 */ GIM_Try, /*On fail goto*//*Label 29173*/ GIMT_Encode4(2212825), // Rule ID 47574 //
     /* 2212776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2212782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212790 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2212793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2212807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212812 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212823 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212824 */   // GIR_Coverage, 47574,
     /* 2212824 */   GIR_EraseRootFromParent_Done,
     /* 2212825 */ // Label 29173: @2212825
     /* 2212825 */ GIM_Try, /*On fail goto*//*Label 29174*/ GIMT_Encode4(2212879), // Rule ID 47575 //
     /* 2212830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2212836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212844 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212844 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2212847 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212851 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2212861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212863 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212866 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212877 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212878 */   // GIR_Coverage, 47575,
     /* 2212878 */   GIR_EraseRootFromParent_Done,
     /* 2212879 */ // Label 29174: @2212879
     /* 2212879 */ GIM_Try, /*On fail goto*//*Label 29175*/ GIMT_Encode4(2212933), // Rule ID 47628 //
     /* 2212884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2212890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212898 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2212901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2212915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212920 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212932 */   // GIR_Coverage, 47628,
     /* 2212932 */   GIR_EraseRootFromParent_Done,
     /* 2212933 */ // Label 29175: @2212933
     /* 2212933 */ GIM_Try, /*On fail goto*//*Label 29176*/ GIMT_Encode4(2212987), // Rule ID 47629 //
     /* 2212938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2212944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212952 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2212955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2212969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212974 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212986 */   // GIR_Coverage, 47629,
     /* 2212986 */   GIR_EraseRootFromParent_Done,
     /* 2212987 */ // Label 29176: @2212987
     /* 2212987 */ GIM_Try, /*On fail goto*//*Label 29177*/ GIMT_Encode4(2213041), // Rule ID 47652 //
     /* 2212992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2212998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213006 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2213023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213028 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213039 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213040 */   // GIR_Coverage, 47652,
     /* 2213040 */   GIR_EraseRootFromParent_Done,
     /* 2213041 */ // Label 29177: @2213041
     /* 2213041 */ GIM_Try, /*On fail goto*//*Label 29178*/ GIMT_Encode4(2213095), // Rule ID 47653 //
     /* 2213046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213060 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2213077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213082 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213094 */   // GIR_Coverage, 47653,
     /* 2213094 */   GIR_EraseRootFromParent_Done,
     /* 2213095 */ // Label 29178: @2213095
     /* 2213095 */ GIM_Reject,
     /* 2213096 */ // Label 29123: @2213096
     /* 2213096 */ GIM_Try, /*On fail goto*//*Label 29179*/ GIMT_Encode4(2213199),
     /* 2213101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213112 */   GIM_Try, /*On fail goto*//*Label 29180*/ GIMT_Encode4(2213155), // Rule ID 47554 //
     /* 2213117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213120 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2213123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2213137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213154 */     // GIR_Coverage, 47554,
     /* 2213154 */     GIR_EraseRootFromParent_Done,
     /* 2213155 */   // Label 29180: @2213155
     /* 2213155 */   GIM_Try, /*On fail goto*//*Label 29181*/ GIMT_Encode4(2213198), // Rule ID 47555 //
     /* 2213160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213163 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2213166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2213180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213197 */     // GIR_Coverage, 47555,
     /* 2213197 */     GIR_EraseRootFromParent_Done,
     /* 2213198 */   // Label 29181: @2213198
     /* 2213198 */   GIM_Reject,
     /* 2213199 */ // Label 29179: @2213199
     /* 2213199 */ GIM_Reject,
     /* 2213200 */ // Label 29124: @2213200
     /* 2213200 */ GIM_Try, /*On fail goto*//*Label 29182*/ GIMT_Encode4(2213254), // Rule ID 47566 //
     /* 2213205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213219 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213219 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213226 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213241 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213253 */   // GIR_Coverage, 47566,
     /* 2213253 */   GIR_EraseRootFromParent_Done,
     /* 2213254 */ // Label 29182: @2213254
     /* 2213254 */ GIM_Try, /*On fail goto*//*Label 29183*/ GIMT_Encode4(2213308), // Rule ID 47567 //
     /* 2213259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213273 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213295 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213306 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213307 */   // GIR_Coverage, 47567,
     /* 2213307 */   GIR_EraseRootFromParent_Done,
     /* 2213308 */ // Label 29183: @2213308
     /* 2213308 */ GIM_Try, /*On fail goto*//*Label 29184*/ GIMT_Encode4(2213362), // Rule ID 47620 //
     /* 2213313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213327 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2213344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213349 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213360 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213361 */   // GIR_Coverage, 47620,
     /* 2213361 */   GIR_EraseRootFromParent_Done,
     /* 2213362 */ // Label 29184: @2213362
     /* 2213362 */ GIM_Try, /*On fail goto*//*Label 29185*/ GIMT_Encode4(2213416), // Rule ID 47621 //
     /* 2213367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213381 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2213398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213403 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213415 */   // GIR_Coverage, 47621,
     /* 2213415 */   GIR_EraseRootFromParent_Done,
     /* 2213416 */ // Label 29185: @2213416
     /* 2213416 */ GIM_Reject,
     /* 2213417 */ // Label 29125: @2213417
     /* 2213417 */ GIM_Try, /*On fail goto*//*Label 29186*/ GIMT_Encode4(2213471), // Rule ID 47576 //
     /* 2213422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2213428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213436 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2213453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213458 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213470 */   // GIR_Coverage, 47576,
     /* 2213470 */   GIR_EraseRootFromParent_Done,
     /* 2213471 */ // Label 29186: @2213471
     /* 2213471 */ GIM_Try, /*On fail goto*//*Label 29187*/ GIMT_Encode4(2213525), // Rule ID 47577 //
     /* 2213476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2213482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213490 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2213507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213509 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213512 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213523 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213524 */   // GIR_Coverage, 47577,
     /* 2213524 */   GIR_EraseRootFromParent_Done,
     /* 2213525 */ // Label 29187: @2213525
     /* 2213525 */ GIM_Try, /*On fail goto*//*Label 29188*/ GIMT_Encode4(2213579), // Rule ID 47630 //
     /* 2213530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213544 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213544 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213547 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213551 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2213561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213563 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213566 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213577 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213578 */   // GIR_Coverage, 47630,
     /* 2213578 */   GIR_EraseRootFromParent_Done,
     /* 2213579 */ // Label 29188: @2213579
     /* 2213579 */ GIM_Try, /*On fail goto*//*Label 29189*/ GIMT_Encode4(2213633), // Rule ID 47631 //
     /* 2213584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213598 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2213615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213620 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213632 */   // GIR_Coverage, 47631,
     /* 2213632 */   GIR_EraseRootFromParent_Done,
     /* 2213633 */ // Label 29189: @2213633
     /* 2213633 */ GIM_Try, /*On fail goto*//*Label 29190*/ GIMT_Encode4(2213687), // Rule ID 47654 //
     /* 2213638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213652 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213652 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213655 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213659 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2213669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213671 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213674 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213685 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213686 */   // GIR_Coverage, 47654,
     /* 2213686 */   GIR_EraseRootFromParent_Done,
     /* 2213687 */ // Label 29190: @2213687
     /* 2213687 */ GIM_Try, /*On fail goto*//*Label 29191*/ GIMT_Encode4(2213741), // Rule ID 47655 //
     /* 2213692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213706 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2213723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213728 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213740 */   // GIR_Coverage, 47655,
     /* 2213740 */   GIR_EraseRootFromParent_Done,
     /* 2213741 */ // Label 29191: @2213741
     /* 2213741 */ GIM_Reject,
     /* 2213742 */ // Label 29126: @2213742
     /* 2213742 */ GIM_Try, /*On fail goto*//*Label 29192*/ GIMT_Encode4(2213845),
     /* 2213747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2213750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213758 */   GIM_Try, /*On fail goto*//*Label 29193*/ GIMT_Encode4(2213801), // Rule ID 47556 //
     /* 2213763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213766 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2213769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213800 */     // GIR_Coverage, 47556,
     /* 2213800 */     GIR_EraseRootFromParent_Done,
     /* 2213801 */   // Label 29193: @2213801
     /* 2213801 */   GIM_Try, /*On fail goto*//*Label 29194*/ GIMT_Encode4(2213844), // Rule ID 47557 //
     /* 2213806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213809 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2213812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213843 */     // GIR_Coverage, 47557,
     /* 2213843 */     GIR_EraseRootFromParent_Done,
     /* 2213844 */   // Label 29194: @2213844
     /* 2213844 */   GIM_Reject,
     /* 2213845 */ // Label 29192: @2213845
     /* 2213845 */ GIM_Reject,
     /* 2213846 */ // Label 29127: @2213846
     /* 2213846 */ GIM_Try, /*On fail goto*//*Label 29195*/ GIMT_Encode4(2213900), // Rule ID 47568 //
     /* 2213851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2213857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213865 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213865 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2213868 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213872 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2213882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213884 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213887 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213898 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213899 */   // GIR_Coverage, 47568,
     /* 2213899 */   GIR_EraseRootFromParent_Done,
     /* 2213900 */ // Label 29195: @2213900
     /* 2213900 */ GIM_Try, /*On fail goto*//*Label 29196*/ GIMT_Encode4(2213954), // Rule ID 47569 //
     /* 2213905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2213911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213919 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2213922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2213936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213941 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213952 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213953 */   // GIR_Coverage, 47569,
     /* 2213953 */   GIR_EraseRootFromParent_Done,
     /* 2213954 */ // Label 29196: @2213954
     /* 2213954 */ GIM_Try, /*On fail goto*//*Label 29197*/ GIMT_Encode4(2214008), // Rule ID 47622 //
     /* 2213959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2213965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213973 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2213976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2213990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213995 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214006 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214007 */   // GIR_Coverage, 47622,
     /* 2214007 */   GIR_EraseRootFromParent_Done,
     /* 2214008 */ // Label 29197: @2214008
     /* 2214008 */ GIM_Try, /*On fail goto*//*Label 29198*/ GIMT_Encode4(2214062), // Rule ID 47623 //
     /* 2214013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2214019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214027 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2214044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214049 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214061 */   // GIR_Coverage, 47623,
     /* 2214061 */   GIR_EraseRootFromParent_Done,
     /* 2214062 */ // Label 29198: @2214062
     /* 2214062 */ GIM_Reject,
     /* 2214063 */ // Label 29128: @2214063
     /* 2214063 */ GIM_Try, /*On fail goto*//*Label 29199*/ GIMT_Encode4(2214166),
     /* 2214068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2214071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214079 */   GIM_Try, /*On fail goto*//*Label 29200*/ GIMT_Encode4(2214122), // Rule ID 47558 //
     /* 2214084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214087 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2214090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2214104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214121 */     // GIR_Coverage, 47558,
     /* 2214121 */     GIR_EraseRootFromParent_Done,
     /* 2214122 */   // Label 29200: @2214122
     /* 2214122 */   GIM_Try, /*On fail goto*//*Label 29201*/ GIMT_Encode4(2214165), // Rule ID 47559 //
     /* 2214127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214130 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2214133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2214147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214164 */     // GIR_Coverage, 47559,
     /* 2214164 */     GIR_EraseRootFromParent_Done,
     /* 2214165 */   // Label 29201: @2214165
     /* 2214165 */   GIM_Reject,
     /* 2214166 */ // Label 29199: @2214166
     /* 2214166 */ GIM_Reject,
     /* 2214167 */ // Label 29129: @2214167
     /* 2214167 */ GIM_Reject,
     /* 2214168 */ // Label 41: @2214168
     /* 2214168 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 29204*/ GIMT_Encode4(2215210),
     /* 2214179 */ /*GILLT_s32*//*Label 29202*/ GIMT_Encode4(2214187),
     /* 2214183 */ /*GILLT_s64*//*Label 29203*/ GIMT_Encode4(2214845),
     /* 2214187 */ // Label 29202: @2214187
     /* 2214187 */ GIM_Try, /*On fail goto*//*Label 29205*/ GIMT_Encode4(2214844),
     /* 2214192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2214195 */   GIM_Try, /*On fail goto*//*Label 29206*/ GIMT_Encode4(2214231), // Rule ID 64474 //
     /* 2214200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2214203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214211 */     // MIs[0] Operand 2
     /* 2214211 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214222 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2214225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214230 */     // GIR_Coverage, 64474,
     /* 2214230 */     GIR_EraseRootFromParent_Done,
     /* 2214231 */   // Label 29206: @2214231
     /* 2214231 */   GIM_Try, /*On fail goto*//*Label 29207*/ GIMT_Encode4(2214267), // Rule ID 64476 //
     /* 2214236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2214239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214247 */     // MIs[0] Operand 2
     /* 2214247 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214258 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2214261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214266 */     // GIR_Coverage, 64476,
     /* 2214266 */     GIR_EraseRootFromParent_Done,
     /* 2214267 */   // Label 29207: @2214267
     /* 2214267 */   GIM_Try, /*On fail goto*//*Label 29208*/ GIMT_Encode4(2214303), // Rule ID 2527 //
     /* 2214272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2214275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214283 */     // MIs[0] Operand 2
     /* 2214283 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214294 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2214297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214302 */     // GIR_Coverage, 2527,
     /* 2214302 */     GIR_EraseRootFromParent_Done,
     /* 2214303 */   // Label 29208: @2214303
     /* 2214303 */   GIM_Try, /*On fail goto*//*Label 29209*/ GIMT_Encode4(2214339), // Rule ID 2529 //
     /* 2214308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2214311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214319 */     // MIs[0] Operand 2
     /* 2214319 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214330 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2214333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214338 */     // GIR_Coverage, 2529,
     /* 2214338 */     GIR_EraseRootFromParent_Done,
     /* 2214339 */   // Label 29209: @2214339
     /* 2214339 */   GIM_Try, /*On fail goto*//*Label 29210*/ GIMT_Encode4(2214381), // Rule ID 62560 //
     /* 2214344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2214347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214355 */     // MIs[0] Operand 2
     /* 2214355 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214366 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2214369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2214376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214380 */     // GIR_Coverage, 62560,
     /* 2214380 */     GIR_EraseRootFromParent_Done,
     /* 2214381 */   // Label 29210: @2214381
     /* 2214381 */   GIM_Try, /*On fail goto*//*Label 29211*/ GIMT_Encode4(2214423), // Rule ID 62562 //
     /* 2214386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2214389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214397 */     // MIs[0] Operand 2
     /* 2214397 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214408 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2214411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2214418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214422 */     // GIR_Coverage, 62562,
     /* 2214422 */     GIR_EraseRootFromParent_Done,
     /* 2214423 */   // Label 29211: @2214423
     /* 2214423 */   GIM_Try, /*On fail goto*//*Label 29212*/ GIMT_Encode4(2214465), // Rule ID 62564 //
     /* 2214428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2214431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214439 */     // MIs[0] Operand 2
     /* 2214439 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214450 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2214453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214464 */     // GIR_Coverage, 62564,
     /* 2214464 */     GIR_EraseRootFromParent_Done,
     /* 2214465 */   // Label 29212: @2214465
     /* 2214465 */   GIM_Try, /*On fail goto*//*Label 29213*/ GIMT_Encode4(2214507), // Rule ID 64626 //
     /* 2214470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2214473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214481 */     // MIs[0] Operand 2
     /* 2214481 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214492 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i64] }, 0:{ *:[i64] })
     /* 2214492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2214502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214506 */     // GIR_Coverage, 64626,
     /* 2214506 */     GIR_EraseRootFromParent_Done,
     /* 2214507 */   // Label 29213: @2214507
     /* 2214507 */   GIM_Try, /*On fail goto*//*Label 29214*/ GIMT_Encode4(2214549), // Rule ID 64627 //
     /* 2214512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2214515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214523 */     // MIs[0] Operand 2
     /* 2214523 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214534 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2214544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214548 */     // GIR_Coverage, 64627,
     /* 2214548 */     GIR_EraseRootFromParent_Done,
     /* 2214549 */   // Label 29214: @2214549
     /* 2214549 */   GIM_Try, /*On fail goto*//*Label 29215*/ GIMT_Encode4(2214591), // Rule ID 64642 //
     /* 2214554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode0),
     /* 2214557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214565 */     // MIs[0] Operand 2
     /* 2214565 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214576 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 16:{ *:[i64] }, 0:{ *:[i64] })
     /* 2214576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2214586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214590 */     // GIR_Coverage, 64642,
     /* 2214590 */     GIR_EraseRootFromParent_Done,
     /* 2214591 */   // Label 29215: @2214591
     /* 2214591 */   GIM_Try, /*On fail goto*//*Label 29216*/ GIMT_Encode4(2214633), // Rule ID 64643 //
     /* 2214596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode1),
     /* 2214599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214607 */     // MIs[0] Operand 2
     /* 2214607 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214618 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 16:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2214628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214632 */     // GIR_Coverage, 64643,
     /* 2214632 */     GIR_EraseRootFromParent_Done,
     /* 2214633 */   // Label 29216: @2214633
     /* 2214633 */   GIM_Try, /*On fail goto*//*Label 29217*/ GIMT_Encode4(2214675), // Rule ID 64644 //
     /* 2214638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode0),
     /* 2214641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214649 */     // MIs[0] Operand 2
     /* 2214649 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214660 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 8:{ *:[i64] }, 0:{ *:[i64] })
     /* 2214660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 2214670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214674 */     // GIR_Coverage, 64644,
     /* 2214674 */     GIR_EraseRootFromParent_Done,
     /* 2214675 */   // Label 29217: @2214675
     /* 2214675 */   GIM_Try, /*On fail goto*//*Label 29218*/ GIMT_Encode4(2214717), // Rule ID 64645 //
     /* 2214680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode1),
     /* 2214683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214691 */     // MIs[0] Operand 2
     /* 2214691 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214702 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 8:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 2214712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214716 */     // GIR_Coverage, 64645,
     /* 2214716 */     GIR_EraseRootFromParent_Done,
     /* 2214717 */   // Label 29218: @2214717
     /* 2214717 */   GIM_Try, /*On fail goto*//*Label 29219*/ GIMT_Encode4(2214759), // Rule ID 65048 //
     /* 2214722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2214725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214733 */     // MIs[0] Operand 2
     /* 2214733 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214744 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2214747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2214754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214758 */     // GIR_Coverage, 65048,
     /* 2214758 */     GIR_EraseRootFromParent_Done,
     /* 2214759 */   // Label 29219: @2214759
     /* 2214759 */   GIM_Try, /*On fail goto*//*Label 29220*/ GIMT_Encode4(2214801), // Rule ID 65050 //
     /* 2214764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2214767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214775 */     // MIs[0] Operand 2
     /* 2214775 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214786 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2214789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2214796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214800 */     // GIR_Coverage, 65050,
     /* 2214800 */     GIR_EraseRootFromParent_Done,
     /* 2214801 */   // Label 29220: @2214801
     /* 2214801 */   GIM_Try, /*On fail goto*//*Label 29221*/ GIMT_Encode4(2214843), // Rule ID 65052 //
     /* 2214806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2214809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214817 */     // MIs[0] Operand 2
     /* 2214817 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214828 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2214831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214842 */     // GIR_Coverage, 65052,
     /* 2214842 */     GIR_EraseRootFromParent_Done,
     /* 2214843 */   // Label 29221: @2214843
     /* 2214843 */   GIM_Reject,
     /* 2214844 */ // Label 29205: @2214844
     /* 2214844 */ GIM_Reject,
     /* 2214845 */ // Label 29203: @2214845
     /* 2214845 */ GIM_Try, /*On fail goto*//*Label 29222*/ GIMT_Encode4(2215209),
     /* 2214850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2214853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214861 */   GIM_Try, /*On fail goto*//*Label 29223*/ GIMT_Encode4(2214889), // Rule ID 64473 //
     /* 2214866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2214869 */     // MIs[0] Operand 2
     /* 2214869 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214880 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2214880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2214883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214888 */     // GIR_Coverage, 64473,
     /* 2214888 */     GIR_EraseRootFromParent_Done,
     /* 2214889 */   // Label 29223: @2214889
     /* 2214889 */   GIM_Try, /*On fail goto*//*Label 29224*/ GIMT_Encode4(2214917), // Rule ID 64475 //
     /* 2214894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2214897 */     // MIs[0] Operand 2
     /* 2214897 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214908 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2214908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2214911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214916 */     // GIR_Coverage, 64475,
     /* 2214916 */     GIR_EraseRootFromParent_Done,
     /* 2214917 */   // Label 29224: @2214917
     /* 2214917 */   GIM_Try, /*On fail goto*//*Label 29225*/ GIMT_Encode4(2214948), // Rule ID 266 //
     /* 2214922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2214925 */     // MIs[0] Operand 2
     /* 2214925 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2214936 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] })  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2214936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2214939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214947 */     // GIR_Coverage, 266,
     /* 2214947 */     GIR_EraseRootFromParent_Done,
     /* 2214948 */   // Label 29225: @2214948
     /* 2214948 */   GIM_Try, /*On fail goto*//*Label 29226*/ GIMT_Encode4(2214976), // Rule ID 2526 //
     /* 2214953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2214956 */     // MIs[0] Operand 2
     /* 2214956 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214967 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2214967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2214970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214975 */     // GIR_Coverage, 2526,
     /* 2214975 */     GIR_EraseRootFromParent_Done,
     /* 2214976 */   // Label 29226: @2214976
     /* 2214976 */   GIM_Try, /*On fail goto*//*Label 29227*/ GIMT_Encode4(2215004), // Rule ID 2528 //
     /* 2214981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2214984 */     // MIs[0] Operand 2
     /* 2214984 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214995 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2214995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2214998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215003 */     // GIR_Coverage, 2528,
     /* 2215003 */     GIR_EraseRootFromParent_Done,
     /* 2215004 */   // Label 29227: @2215004
     /* 2215004 */   GIM_Try, /*On fail goto*//*Label 29228*/ GIMT_Encode4(2215038), // Rule ID 62559 //
     /* 2215009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2215012 */     // MIs[0] Operand 2
     /* 2215012 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215023 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2215026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2215033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215037 */     // GIR_Coverage, 62559,
     /* 2215037 */     GIR_EraseRootFromParent_Done,
     /* 2215038 */   // Label 29228: @2215038
     /* 2215038 */   GIM_Try, /*On fail goto*//*Label 29229*/ GIMT_Encode4(2215072), // Rule ID 62561 //
     /* 2215043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2215046 */     // MIs[0] Operand 2
     /* 2215046 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215057 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2215060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2215067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215071 */     // GIR_Coverage, 62561,
     /* 2215071 */     GIR_EraseRootFromParent_Done,
     /* 2215072 */   // Label 29229: @2215072
     /* 2215072 */   GIM_Try, /*On fail goto*//*Label 29230*/ GIMT_Encode4(2215106), // Rule ID 62563 //
     /* 2215077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2215080 */     // MIs[0] Operand 2
     /* 2215080 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2215091 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2215094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215105 */     // GIR_Coverage, 62563,
     /* 2215105 */     GIR_EraseRootFromParent_Done,
     /* 2215106 */   // Label 29230: @2215106
     /* 2215106 */   GIM_Try, /*On fail goto*//*Label 29231*/ GIMT_Encode4(2215140), // Rule ID 65047 //
     /* 2215111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2215114 */     // MIs[0] Operand 2
     /* 2215114 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215125 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2215135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215139 */     // GIR_Coverage, 65047,
     /* 2215139 */     GIR_EraseRootFromParent_Done,
     /* 2215140 */   // Label 29231: @2215140
     /* 2215140 */   GIM_Try, /*On fail goto*//*Label 29232*/ GIMT_Encode4(2215174), // Rule ID 65049 //
     /* 2215145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2215148 */     // MIs[0] Operand 2
     /* 2215148 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215159 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2215169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215173 */     // GIR_Coverage, 65049,
     /* 2215173 */     GIR_EraseRootFromParent_Done,
     /* 2215174 */   // Label 29232: @2215174
     /* 2215174 */   GIM_Try, /*On fail goto*//*Label 29233*/ GIMT_Encode4(2215208), // Rule ID 65051 //
     /* 2215179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2215182 */     // MIs[0] Operand 2
     /* 2215182 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2215193 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215207 */     // GIR_Coverage, 65051,
     /* 2215207 */     GIR_EraseRootFromParent_Done,
     /* 2215208 */   // Label 29233: @2215208
     /* 2215208 */   GIM_Reject,
     /* 2215209 */ // Label 29222: @2215209
     /* 2215209 */ GIM_Reject,
     /* 2215210 */ // Label 29204: @2215210
     /* 2215210 */ GIM_Reject,
     /* 2215211 */ // Label 42: @2215211
     /* 2215211 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 29251*/ GIMT_Encode4(2218897),
     /* 2215222 */ /*GILLT_s32*//*Label 29234*/ GIMT_Encode4(2215338),
     /* 2215226 */ /*GILLT_s64*//*Label 29235*/ GIMT_Encode4(2215634), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215238 */ /*GILLT_nxv1s16*//*Label 29236*/ GIMT_Encode4(2215888),
     /* 2215242 */ /*GILLT_nxv1s32*//*Label 29237*/ GIMT_Encode4(2215992),
     /* 2215246 */ /*GILLT_nxv1s64*//*Label 29238*/ GIMT_Encode4(2216209), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215258 */ /*GILLT_nxv2s16*//*Label 29239*/ GIMT_Encode4(2216534),
     /* 2215262 */ /*GILLT_nxv2s32*//*Label 29240*/ GIMT_Encode4(2216638),
     /* 2215266 */ /*GILLT_nxv2s64*//*Label 29241*/ GIMT_Encode4(2216855), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215278 */ /*GILLT_nxv4s16*//*Label 29242*/ GIMT_Encode4(2217180),
     /* 2215282 */ /*GILLT_nxv4s32*//*Label 29243*/ GIMT_Encode4(2217284),
     /* 2215286 */ /*GILLT_nxv4s64*//*Label 29244*/ GIMT_Encode4(2217501), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215298 */ /*GILLT_nxv8s16*//*Label 29245*/ GIMT_Encode4(2217826),
     /* 2215302 */ /*GILLT_nxv8s32*//*Label 29246*/ GIMT_Encode4(2217930),
     /* 2215306 */ /*GILLT_nxv8s64*//*Label 29247*/ GIMT_Encode4(2218147), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215318 */ /*GILLT_nxv16s16*//*Label 29248*/ GIMT_Encode4(2218472),
     /* 2215322 */ /*GILLT_nxv16s32*//*Label 29249*/ GIMT_Encode4(2218576), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215334 */ /*GILLT_nxv32s16*//*Label 29250*/ GIMT_Encode4(2218793),
     /* 2215338 */ // Label 29234: @2215338
     /* 2215338 */ GIM_Try, /*On fail goto*//*Label 29252*/ GIMT_Encode4(2215633),
     /* 2215343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2215346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215354 */   GIM_Try, /*On fail goto*//*Label 29253*/ GIMT_Encode4(2215396), // Rule ID 65408 //
     /* 2215359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2215362 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2215362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2215365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215378 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2215381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2215394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215395 */     // GIR_Coverage, 65408,
     /* 2215395 */     GIR_EraseRootFromParent_Done,
     /* 2215396 */   // Label 29253: @2215396
     /* 2215396 */   GIM_Try, /*On fail goto*//*Label 29254*/ GIMT_Encode4(2215438), // Rule ID 65410 //
     /* 2215401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2215404 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2215404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2215407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215420 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2215423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2215436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215437 */     // GIR_Coverage, 65410,
     /* 2215437 */     GIR_EraseRootFromParent_Done,
     /* 2215438 */   // Label 29254: @2215438
     /* 2215438 */   GIM_Try, /*On fail goto*//*Label 29255*/ GIMT_Encode4(2215480), // Rule ID 65411 //
     /* 2215443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2215446 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2215446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2215449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215462 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2215465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2215478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215479 */     // GIR_Coverage, 65411,
     /* 2215479 */     GIR_EraseRootFromParent_Done,
     /* 2215480 */   // Label 29255: @2215480
     /* 2215480 */   GIM_Try, /*On fail goto*//*Label 29256*/ GIMT_Encode4(2215495), // Rule ID 65421 //
     /* 2215485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /* 2215488 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2215493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215494 */     // GIR_Coverage, 65421,
     /* 2215494 */     GIR_Done,
     /* 2215495 */   // Label 29256: @2215495
     /* 2215495 */   GIM_Try, /*On fail goto*//*Label 29257*/ GIMT_Encode4(2215510), // Rule ID 65422 //
     /* 2215500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /* 2215503 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2215508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215509 */     // GIR_Coverage, 65422,
     /* 2215509 */     GIR_Done,
     /* 2215510 */   // Label 29257: @2215510
     /* 2215510 */   GIM_Try, /*On fail goto*//*Label 29258*/ GIMT_Encode4(2215525), // Rule ID 65424 //
     /* 2215515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2215518 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2215523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215524 */     // GIR_Coverage, 65424,
     /* 2215524 */     GIR_Done,
     /* 2215525 */   // Label 29258: @2215525
     /* 2215525 */   GIM_Try, /*On fail goto*//*Label 29259*/ GIMT_Encode4(2215540), // Rule ID 65425 //
     /* 2215530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode1),
     /* 2215533 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2215538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215539 */     // GIR_Coverage, 65425,
     /* 2215539 */     GIR_Done,
     /* 2215540 */   // Label 29259: @2215540
     /* 2215540 */   GIM_Try, /*On fail goto*//*Label 29260*/ GIMT_Encode4(2215563), // Rule ID 65426 //
     /* 2215545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /* 2215548 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2215548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2215551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2215555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2215561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215562 */     // GIR_Coverage, 65426,
     /* 2215562 */     GIR_EraseRootFromParent_Done,
     /* 2215563 */   // Label 29260: @2215563
     /* 2215563 */   GIM_Try, /*On fail goto*//*Label 29261*/ GIMT_Encode4(2215586), // Rule ID 65427 //
     /* 2215568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /* 2215571 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2215571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2215574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2215578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2215584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215585 */     // GIR_Coverage, 65427,
     /* 2215585 */     GIR_EraseRootFromParent_Done,
     /* 2215586 */   // Label 29261: @2215586
     /* 2215586 */   GIM_Try, /*On fail goto*//*Label 29262*/ GIMT_Encode4(2215609), // Rule ID 65429 //
     /* 2215591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2215594 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2215594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2215597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2215601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2215607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215608 */     // GIR_Coverage, 65429,
     /* 2215608 */     GIR_EraseRootFromParent_Done,
     /* 2215609 */   // Label 29262: @2215609
     /* 2215609 */   GIM_Try, /*On fail goto*//*Label 29263*/ GIMT_Encode4(2215632), // Rule ID 65430 //
     /* 2215614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1),
     /* 2215617 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2215617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2215620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2215624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2215630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215631 */     // GIR_Coverage, 65430,
     /* 2215631 */     GIR_EraseRootFromParent_Done,
     /* 2215632 */   // Label 29263: @2215632
     /* 2215632 */   GIM_Reject,
     /* 2215633 */ // Label 29252: @2215633
     /* 2215633 */ GIM_Reject,
     /* 2215634 */ // Label 29235: @2215634
     /* 2215634 */ GIM_Try, /*On fail goto*//*Label 29264*/ GIMT_Encode4(2215687), // Rule ID 65406 //
     /* 2215639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2215642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2215645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215653 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i32] }:$src, 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 2215653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2215656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215665 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215669 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2215672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215679 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 2215685 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215686 */   // GIR_Coverage, 65406,
     /* 2215686 */   GIR_EraseRootFromParent_Done,
     /* 2215687 */ // Label 29264: @2215687
     /* 2215687 */ GIM_Try, /*On fail goto*//*Label 29265*/ GIMT_Encode4(2215740), // Rule ID 65407 //
     /* 2215692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2215695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2215698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215706 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2215706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2215709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215718 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215722 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2215725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215732 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2215738 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215739 */   // GIR_Coverage, 65407,
     /* 2215739 */   GIR_EraseRootFromParent_Done,
     /* 2215740 */ // Label 29265: @2215740
     /* 2215740 */ GIM_Try, /*On fail goto*//*Label 29266*/ GIMT_Encode4(2215793), // Rule ID 65409 //
     /* 2215745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2215748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2215751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215759 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2215759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2215762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215771 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215775 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2215778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2215791 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215792 */   // GIR_Coverage, 65409,
     /* 2215792 */   GIR_EraseRootFromParent_Done,
     /* 2215793 */ // Label 29266: @2215793
     /* 2215793 */ GIM_Try, /*On fail goto*//*Label 29267*/ GIMT_Encode4(2215827), // Rule ID 65417 //
     /* 2215798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2215801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2215804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215812 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i32] }:$src, X0:{ *:[i64] })
     /* 2215812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /* 2215815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2215819 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2215825 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215826 */   // GIR_Coverage, 65417,
     /* 2215826 */   GIR_EraseRootFromParent_Done,
     /* 2215827 */ // Label 29267: @2215827
     /* 2215827 */ GIM_Try, /*On fail goto*//*Label 29268*/ GIMT_Encode4(2215853), // Rule ID 65423 //
     /* 2215832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2215835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2215838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215846 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2215846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2215851 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215852 */   // GIR_Coverage, 65423,
     /* 2215852 */   GIR_Done,
     /* 2215853 */ // Label 29268: @2215853
     /* 2215853 */ GIM_Try, /*On fail goto*//*Label 29269*/ GIMT_Encode4(2215887), // Rule ID 65428 //
     /* 2215858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2215861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2215864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215872 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i64] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2215872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2215875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215877 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2215879 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2215885 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215886 */   // GIR_Coverage, 65428,
     /* 2215886 */   GIR_EraseRootFromParent_Done,
     /* 2215887 */ // Label 29269: @2215887
     /* 2215887 */ GIM_Reject,
     /* 2215888 */ // Label 29236: @2215888
     /* 2215888 */ GIM_Try, /*On fail goto*//*Label 29270*/ GIMT_Encode4(2215991),
     /* 2215893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2215896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215904 */   GIM_Try, /*On fail goto*//*Label 29271*/ GIMT_Encode4(2215947), // Rule ID 45800 //
     /* 2215909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215912 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2215915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2215929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215946 */     // GIR_Coverage, 45800,
     /* 2215946 */     GIR_EraseRootFromParent_Done,
     /* 2215947 */   // Label 29271: @2215947
     /* 2215947 */   GIM_Try, /*On fail goto*//*Label 29272*/ GIMT_Encode4(2215990), // Rule ID 45801 //
     /* 2215952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215955 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2215958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2215972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215989 */     // GIR_Coverage, 45801,
     /* 2215989 */     GIR_EraseRootFromParent_Done,
     /* 2215990 */   // Label 29272: @2215990
     /* 2215990 */   GIM_Reject,
     /* 2215991 */ // Label 29270: @2215991
     /* 2215991 */ GIM_Reject,
     /* 2215992 */ // Label 29237: @2215992
     /* 2215992 */ GIM_Try, /*On fail goto*//*Label 29273*/ GIMT_Encode4(2216046), // Rule ID 47512 //
     /* 2215997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216011 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2216028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216033 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216044 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216045 */   // GIR_Coverage, 47512,
     /* 2216045 */   GIR_EraseRootFromParent_Done,
     /* 2216046 */ // Label 29273: @2216046
     /* 2216046 */ GIM_Try, /*On fail goto*//*Label 29274*/ GIMT_Encode4(2216100), // Rule ID 47513 //
     /* 2216051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216065 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216065 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216068 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216072 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2216082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216084 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216087 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216099 */   // GIR_Coverage, 47513,
     /* 2216099 */   GIR_EraseRootFromParent_Done,
     /* 2216100 */ // Label 29274: @2216100
     /* 2216100 */ GIM_Try, /*On fail goto*//*Label 29275*/ GIMT_Encode4(2216154), // Rule ID 47578 //
     /* 2216105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216119 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2216136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216138 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216141 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216152 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216153 */   // GIR_Coverage, 47578,
     /* 2216153 */   GIR_EraseRootFromParent_Done,
     /* 2216154 */ // Label 29275: @2216154
     /* 2216154 */ GIM_Try, /*On fail goto*//*Label 29276*/ GIMT_Encode4(2216208), // Rule ID 47579 //
     /* 2216159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216173 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216173 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216176 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216180 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2216190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216192 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216195 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216207 */   // GIR_Coverage, 47579,
     /* 2216207 */   GIR_EraseRootFromParent_Done,
     /* 2216208 */ // Label 29276: @2216208
     /* 2216208 */ GIM_Reject,
     /* 2216209 */ // Label 29238: @2216209
     /* 2216209 */ GIM_Try, /*On fail goto*//*Label 29277*/ GIMT_Encode4(2216263), // Rule ID 47532 //
     /* 2216214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2216220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216228 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2216245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216247 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216250 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216261 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216262 */   // GIR_Coverage, 47532,
     /* 2216262 */   GIR_EraseRootFromParent_Done,
     /* 2216263 */ // Label 29277: @2216263
     /* 2216263 */ GIM_Try, /*On fail goto*//*Label 29278*/ GIMT_Encode4(2216317), // Rule ID 47533 //
     /* 2216268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2216274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216282 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2216299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216304 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216315 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216316 */   // GIR_Coverage, 47533,
     /* 2216316 */   GIR_EraseRootFromParent_Done,
     /* 2216317 */ // Label 29278: @2216317
     /* 2216317 */ GIM_Try, /*On fail goto*//*Label 29279*/ GIMT_Encode4(2216371), // Rule ID 47598 //
     /* 2216322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216336 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2216353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216355 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216358 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216369 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216370 */   // GIR_Coverage, 47598,
     /* 2216370 */   GIR_EraseRootFromParent_Done,
     /* 2216371 */ // Label 29279: @2216371
     /* 2216371 */ GIM_Try, /*On fail goto*//*Label 29280*/ GIMT_Encode4(2216425), // Rule ID 47599 //
     /* 2216376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216390 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216390 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216393 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216397 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2216407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216412 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216423 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216424 */   // GIR_Coverage, 47599,
     /* 2216424 */   GIR_EraseRootFromParent_Done,
     /* 2216425 */ // Label 29280: @2216425
     /* 2216425 */ GIM_Try, /*On fail goto*//*Label 29281*/ GIMT_Encode4(2216479), // Rule ID 47632 //
     /* 2216430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216444 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216444 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216447 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216451 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2216461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216466 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216478 */   // GIR_Coverage, 47632,
     /* 2216478 */   GIR_EraseRootFromParent_Done,
     /* 2216479 */ // Label 29281: @2216479
     /* 2216479 */ GIM_Try, /*On fail goto*//*Label 29282*/ GIMT_Encode4(2216533), // Rule ID 47633 //
     /* 2216484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216498 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2216515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216517 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216520 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216531 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216532 */   // GIR_Coverage, 47633,
     /* 2216532 */   GIR_EraseRootFromParent_Done,
     /* 2216533 */ // Label 29282: @2216533
     /* 2216533 */ GIM_Reject,
     /* 2216534 */ // Label 29239: @2216534
     /* 2216534 */ GIM_Try, /*On fail goto*//*Label 29283*/ GIMT_Encode4(2216637),
     /* 2216539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2216542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216550 */   GIM_Try, /*On fail goto*//*Label 29284*/ GIMT_Encode4(2216593), // Rule ID 47492 //
     /* 2216555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216558 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2216561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2216575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216592 */     // GIR_Coverage, 47492,
     /* 2216592 */     GIR_EraseRootFromParent_Done,
     /* 2216593 */   // Label 29284: @2216593
     /* 2216593 */   GIM_Try, /*On fail goto*//*Label 29285*/ GIMT_Encode4(2216636), // Rule ID 47493 //
     /* 2216598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216601 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2216604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2216618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216635 */     // GIR_Coverage, 47493,
     /* 2216635 */     GIR_EraseRootFromParent_Done,
     /* 2216636 */   // Label 29285: @2216636
     /* 2216636 */   GIM_Reject,
     /* 2216637 */ // Label 29283: @2216637
     /* 2216637 */ GIM_Reject,
     /* 2216638 */ // Label 29240: @2216638
     /* 2216638 */ GIM_Try, /*On fail goto*//*Label 29286*/ GIMT_Encode4(2216692), // Rule ID 47516 //
     /* 2216643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2216649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216657 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2216660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2216674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216676 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216679 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216690 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216691 */   // GIR_Coverage, 47516,
     /* 2216691 */   GIR_EraseRootFromParent_Done,
     /* 2216692 */ // Label 29286: @2216692
     /* 2216692 */ GIM_Try, /*On fail goto*//*Label 29287*/ GIMT_Encode4(2216746), // Rule ID 47517 //
     /* 2216697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2216703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216711 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216711 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2216714 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216718 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2216728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216733 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216744 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216745 */   // GIR_Coverage, 47517,
     /* 2216745 */   GIR_EraseRootFromParent_Done,
     /* 2216746 */ // Label 29287: @2216746
     /* 2216746 */ GIM_Try, /*On fail goto*//*Label 29288*/ GIMT_Encode4(2216800), // Rule ID 47582 //
     /* 2216751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2216757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216765 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216765 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2216768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216772 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2216782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216787 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216798 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216799 */   // GIR_Coverage, 47582,
     /* 2216799 */   GIR_EraseRootFromParent_Done,
     /* 2216800 */ // Label 29288: @2216800
     /* 2216800 */ GIM_Try, /*On fail goto*//*Label 29289*/ GIMT_Encode4(2216854), // Rule ID 47583 //
     /* 2216805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2216811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216819 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2216822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2216836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216838 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216841 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216852 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216853 */   // GIR_Coverage, 47583,
     /* 2216853 */   GIR_EraseRootFromParent_Done,
     /* 2216854 */ // Label 29289: @2216854
     /* 2216854 */ GIM_Reject,
     /* 2216855 */ // Label 29241: @2216855
     /* 2216855 */ GIM_Try, /*On fail goto*//*Label 29290*/ GIMT_Encode4(2216909), // Rule ID 47536 //
     /* 2216860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2216866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216874 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216874 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2216877 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216881 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2216891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216893 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216896 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216907 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216908 */   // GIR_Coverage, 47536,
     /* 2216908 */   GIR_EraseRootFromParent_Done,
     /* 2216909 */ // Label 29290: @2216909
     /* 2216909 */ GIM_Try, /*On fail goto*//*Label 29291*/ GIMT_Encode4(2216963), // Rule ID 47537 //
     /* 2216914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2216920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216928 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2216931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2216945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216950 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216961 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216962 */   // GIR_Coverage, 47537,
     /* 2216962 */   GIR_EraseRootFromParent_Done,
     /* 2216963 */ // Label 29291: @2216963
     /* 2216963 */ GIM_Try, /*On fail goto*//*Label 29292*/ GIMT_Encode4(2217017), // Rule ID 47602 //
     /* 2216968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2216974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216982 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216982 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2216985 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216989 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2216999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217001 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217004 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217015 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217016 */   // GIR_Coverage, 47602,
     /* 2217016 */   GIR_EraseRootFromParent_Done,
     /* 2217017 */ // Label 29292: @2217017
     /* 2217017 */ GIM_Try, /*On fail goto*//*Label 29293*/ GIMT_Encode4(2217071), // Rule ID 47603 //
     /* 2217022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2217028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217036 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217036 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217039 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217043 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217058 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217069 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217070 */   // GIR_Coverage, 47603,
     /* 2217070 */   GIR_EraseRootFromParent_Done,
     /* 2217071 */ // Label 29293: @2217071
     /* 2217071 */ GIM_Try, /*On fail goto*//*Label 29294*/ GIMT_Encode4(2217125), // Rule ID 47636 //
     /* 2217076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217090 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2217107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217112 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217123 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217124 */   // GIR_Coverage, 47636,
     /* 2217124 */   GIR_EraseRootFromParent_Done,
     /* 2217125 */ // Label 29294: @2217125
     /* 2217125 */ GIM_Try, /*On fail goto*//*Label 29295*/ GIMT_Encode4(2217179), // Rule ID 47637 //
     /* 2217130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217144 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2217161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217166 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217177 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217178 */   // GIR_Coverage, 47637,
     /* 2217178 */   GIR_EraseRootFromParent_Done,
     /* 2217179 */ // Label 29295: @2217179
     /* 2217179 */ GIM_Reject,
     /* 2217180 */ // Label 29242: @2217180
     /* 2217180 */ GIM_Try, /*On fail goto*//*Label 29296*/ GIMT_Encode4(2217283),
     /* 2217185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217196 */   GIM_Try, /*On fail goto*//*Label 29297*/ GIMT_Encode4(2217239), // Rule ID 47496 //
     /* 2217201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217204 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2217207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2217221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217238 */     // GIR_Coverage, 47496,
     /* 2217238 */     GIR_EraseRootFromParent_Done,
     /* 2217239 */   // Label 29297: @2217239
     /* 2217239 */   GIM_Try, /*On fail goto*//*Label 29298*/ GIMT_Encode4(2217282), // Rule ID 47497 //
     /* 2217244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217247 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2217250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2217264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217281 */     // GIR_Coverage, 47497,
     /* 2217281 */     GIR_EraseRootFromParent_Done,
     /* 2217282 */   // Label 29298: @2217282
     /* 2217282 */   GIM_Reject,
     /* 2217283 */ // Label 29296: @2217283
     /* 2217283 */ GIM_Reject,
     /* 2217284 */ // Label 29243: @2217284
     /* 2217284 */ GIM_Try, /*On fail goto*//*Label 29299*/ GIMT_Encode4(2217338), // Rule ID 47520 //
     /* 2217289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2217295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217303 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217325 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217336 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217337 */   // GIR_Coverage, 47520,
     /* 2217337 */   GIR_EraseRootFromParent_Done,
     /* 2217338 */ // Label 29299: @2217338
     /* 2217338 */ GIM_Try, /*On fail goto*//*Label 29300*/ GIMT_Encode4(2217392), // Rule ID 47521 //
     /* 2217343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2217349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217357 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217376 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217379 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217390 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217391 */   // GIR_Coverage, 47521,
     /* 2217391 */   GIR_EraseRootFromParent_Done,
     /* 2217392 */ // Label 29300: @2217392
     /* 2217392 */ GIM_Try, /*On fail goto*//*Label 29301*/ GIMT_Encode4(2217446), // Rule ID 47586 //
     /* 2217397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217411 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217433 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217445 */   // GIR_Coverage, 47586,
     /* 2217445 */   GIR_EraseRootFromParent_Done,
     /* 2217446 */ // Label 29301: @2217446
     /* 2217446 */ GIM_Try, /*On fail goto*//*Label 29302*/ GIMT_Encode4(2217500), // Rule ID 47587 //
     /* 2217451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217465 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217487 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217498 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217499 */   // GIR_Coverage, 47587,
     /* 2217499 */   GIR_EraseRootFromParent_Done,
     /* 2217500 */ // Label 29302: @2217500
     /* 2217500 */ GIM_Reject,
     /* 2217501 */ // Label 29244: @2217501
     /* 2217501 */ GIM_Try, /*On fail goto*//*Label 29303*/ GIMT_Encode4(2217555), // Rule ID 47540 //
     /* 2217506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2217512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217520 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217520 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217523 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217527 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2217537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217542 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217553 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217554 */   // GIR_Coverage, 47540,
     /* 2217554 */   GIR_EraseRootFromParent_Done,
     /* 2217555 */ // Label 29303: @2217555
     /* 2217555 */ GIM_Try, /*On fail goto*//*Label 29304*/ GIMT_Encode4(2217609), // Rule ID 47541 //
     /* 2217560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2217566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217574 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2217591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217593 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217596 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217607 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217608 */   // GIR_Coverage, 47541,
     /* 2217608 */   GIR_EraseRootFromParent_Done,
     /* 2217609 */ // Label 29304: @2217609
     /* 2217609 */ GIM_Try, /*On fail goto*//*Label 29305*/ GIMT_Encode4(2217663), // Rule ID 47606 //
     /* 2217614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2217620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217628 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2217645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217647 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217650 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217662 */   // GIR_Coverage, 47606,
     /* 2217662 */   GIR_EraseRootFromParent_Done,
     /* 2217663 */ // Label 29305: @2217663
     /* 2217663 */ GIM_Try, /*On fail goto*//*Label 29306*/ GIMT_Encode4(2217717), // Rule ID 47607 //
     /* 2217668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2217674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217682 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2217699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217704 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217716 */   // GIR_Coverage, 47607,
     /* 2217716 */   GIR_EraseRootFromParent_Done,
     /* 2217717 */ // Label 29306: @2217717
     /* 2217717 */ GIM_Try, /*On fail goto*//*Label 29307*/ GIMT_Encode4(2217771), // Rule ID 47640 //
     /* 2217722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217736 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217736 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217739 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217743 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2217753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217758 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217769 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217770 */   // GIR_Coverage, 47640,
     /* 2217770 */   GIR_EraseRootFromParent_Done,
     /* 2217771 */ // Label 29307: @2217771
     /* 2217771 */ GIM_Try, /*On fail goto*//*Label 29308*/ GIMT_Encode4(2217825), // Rule ID 47641 //
     /* 2217776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217790 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2217807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217812 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217823 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217824 */   // GIR_Coverage, 47641,
     /* 2217824 */   GIR_EraseRootFromParent_Done,
     /* 2217825 */ // Label 29308: @2217825
     /* 2217825 */ GIM_Reject,
     /* 2217826 */ // Label 29245: @2217826
     /* 2217826 */ GIM_Try, /*On fail goto*//*Label 29309*/ GIMT_Encode4(2217929),
     /* 2217831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2217834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217842 */   GIM_Try, /*On fail goto*//*Label 29310*/ GIMT_Encode4(2217885), // Rule ID 47500 //
     /* 2217847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217850 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2217853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217884 */     // GIR_Coverage, 47500,
     /* 2217884 */     GIR_EraseRootFromParent_Done,
     /* 2217885 */   // Label 29310: @2217885
     /* 2217885 */   GIM_Try, /*On fail goto*//*Label 29311*/ GIMT_Encode4(2217928), // Rule ID 47501 //
     /* 2217890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217893 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2217896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217927 */     // GIR_Coverage, 47501,
     /* 2217927 */     GIR_EraseRootFromParent_Done,
     /* 2217928 */   // Label 29311: @2217928
     /* 2217928 */   GIM_Reject,
     /* 2217929 */ // Label 29309: @2217929
     /* 2217929 */ GIM_Reject,
     /* 2217930 */ // Label 29246: @2217930
     /* 2217930 */ GIM_Try, /*On fail goto*//*Label 29312*/ GIMT_Encode4(2217984), // Rule ID 47524 //
     /* 2217935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2217941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217949 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2217952 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217956 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2217966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217971 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217982 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217983 */   // GIR_Coverage, 47524,
     /* 2217983 */   GIR_EraseRootFromParent_Done,
     /* 2217984 */ // Label 29312: @2217984
     /* 2217984 */ GIM_Try, /*On fail goto*//*Label 29313*/ GIMT_Encode4(2218038), // Rule ID 47525 //
     /* 2217989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2217995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218003 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218025 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218036 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218037 */   // GIR_Coverage, 47525,
     /* 2218037 */   GIR_EraseRootFromParent_Done,
     /* 2218038 */ // Label 29313: @2218038
     /* 2218038 */ GIM_Try, /*On fail goto*//*Label 29314*/ GIMT_Encode4(2218092), // Rule ID 47590 //
     /* 2218043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218057 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2218074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218076 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218079 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218090 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218091 */   // GIR_Coverage, 47590,
     /* 2218091 */   GIR_EraseRootFromParent_Done,
     /* 2218092 */ // Label 29314: @2218092
     /* 2218092 */ GIM_Try, /*On fail goto*//*Label 29315*/ GIMT_Encode4(2218146), // Rule ID 47591 //
     /* 2218097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218111 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2218128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218133 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218145 */   // GIR_Coverage, 47591,
     /* 2218145 */   GIR_EraseRootFromParent_Done,
     /* 2218146 */ // Label 29315: @2218146
     /* 2218146 */ GIM_Reject,
     /* 2218147 */ // Label 29247: @2218147
     /* 2218147 */ GIM_Try, /*On fail goto*//*Label 29316*/ GIMT_Encode4(2218201), // Rule ID 47544 //
     /* 2218152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2218158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218166 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218188 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218199 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218200 */   // GIR_Coverage, 47544,
     /* 2218200 */   GIR_EraseRootFromParent_Done,
     /* 2218201 */ // Label 29316: @2218201
     /* 2218201 */ GIM_Try, /*On fail goto*//*Label 29317*/ GIMT_Encode4(2218255), // Rule ID 47545 //
     /* 2218206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2218212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218220 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218220 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218223 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218227 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218242 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218253 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218254 */   // GIR_Coverage, 47545,
     /* 2218254 */   GIR_EraseRootFromParent_Done,
     /* 2218255 */ // Label 29317: @2218255
     /* 2218255 */ GIM_Try, /*On fail goto*//*Label 29318*/ GIMT_Encode4(2218309), // Rule ID 47610 //
     /* 2218260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2218266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218274 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218274 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218277 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218281 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2218291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218293 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218296 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218308 */   // GIR_Coverage, 47610,
     /* 2218308 */   GIR_EraseRootFromParent_Done,
     /* 2218309 */ // Label 29318: @2218309
     /* 2218309 */ GIM_Try, /*On fail goto*//*Label 29319*/ GIMT_Encode4(2218363), // Rule ID 47611 //
     /* 2218314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2218320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218328 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2218345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218350 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218361 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218362 */   // GIR_Coverage, 47611,
     /* 2218362 */   GIR_EraseRootFromParent_Done,
     /* 2218363 */ // Label 29319: @2218363
     /* 2218363 */ GIM_Try, /*On fail goto*//*Label 29320*/ GIMT_Encode4(2218417), // Rule ID 47644 //
     /* 2218368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218382 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2218399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218404 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218416 */   // GIR_Coverage, 47644,
     /* 2218416 */   GIR_EraseRootFromParent_Done,
     /* 2218417 */ // Label 29320: @2218417
     /* 2218417 */ GIM_Try, /*On fail goto*//*Label 29321*/ GIMT_Encode4(2218471), // Rule ID 47645 //
     /* 2218422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218436 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2218453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218458 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218470 */   // GIR_Coverage, 47645,
     /* 2218470 */   GIR_EraseRootFromParent_Done,
     /* 2218471 */ // Label 29321: @2218471
     /* 2218471 */ GIM_Reject,
     /* 2218472 */ // Label 29248: @2218472
     /* 2218472 */ GIM_Try, /*On fail goto*//*Label 29322*/ GIMT_Encode4(2218575),
     /* 2218477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2218480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218488 */   GIM_Try, /*On fail goto*//*Label 29323*/ GIMT_Encode4(2218531), // Rule ID 47504 //
     /* 2218493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218496 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2218499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218530 */     // GIR_Coverage, 47504,
     /* 2218530 */     GIR_EraseRootFromParent_Done,
     /* 2218531 */   // Label 29323: @2218531
     /* 2218531 */   GIM_Try, /*On fail goto*//*Label 29324*/ GIMT_Encode4(2218574), // Rule ID 47505 //
     /* 2218536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218539 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2218542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218573 */     // GIR_Coverage, 47505,
     /* 2218573 */     GIR_EraseRootFromParent_Done,
     /* 2218574 */   // Label 29324: @2218574
     /* 2218574 */   GIM_Reject,
     /* 2218575 */ // Label 29322: @2218575
     /* 2218575 */ GIM_Reject,
     /* 2218576 */ // Label 29249: @2218576
     /* 2218576 */ GIM_Try, /*On fail goto*//*Label 29325*/ GIMT_Encode4(2218630), // Rule ID 47528 //
     /* 2218581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2218587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218595 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2218598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218614 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218617 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218628 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218629 */   // GIR_Coverage, 47528,
     /* 2218629 */   GIR_EraseRootFromParent_Done,
     /* 2218630 */ // Label 29325: @2218630
     /* 2218630 */ GIM_Try, /*On fail goto*//*Label 29326*/ GIMT_Encode4(2218684), // Rule ID 47529 //
     /* 2218635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2218641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218649 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2218652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218671 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218682 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218683 */   // GIR_Coverage, 47529,
     /* 2218683 */   GIR_EraseRootFromParent_Done,
     /* 2218684 */ // Label 29326: @2218684
     /* 2218684 */ GIM_Try, /*On fail goto*//*Label 29327*/ GIMT_Encode4(2218738), // Rule ID 47594 //
     /* 2218689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2218695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218703 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2218706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2218720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218725 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218736 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218737 */   // GIR_Coverage, 47594,
     /* 2218737 */   GIR_EraseRootFromParent_Done,
     /* 2218738 */ // Label 29327: @2218738
     /* 2218738 */ GIM_Try, /*On fail goto*//*Label 29328*/ GIMT_Encode4(2218792), // Rule ID 47595 //
     /* 2218743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2218749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218757 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2218760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2218774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218779 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218791 */   // GIR_Coverage, 47595,
     /* 2218791 */   GIR_EraseRootFromParent_Done,
     /* 2218792 */ // Label 29328: @2218792
     /* 2218792 */ GIM_Reject,
     /* 2218793 */ // Label 29250: @2218793
     /* 2218793 */ GIM_Try, /*On fail goto*//*Label 29329*/ GIMT_Encode4(2218896),
     /* 2218798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2218801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218809 */   GIM_Try, /*On fail goto*//*Label 29330*/ GIMT_Encode4(2218852), // Rule ID 47508 //
     /* 2218814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218817 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2218820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218851 */     // GIR_Coverage, 47508,
     /* 2218851 */     GIR_EraseRootFromParent_Done,
     /* 2218852 */   // Label 29330: @2218852
     /* 2218852 */   GIM_Try, /*On fail goto*//*Label 29331*/ GIMT_Encode4(2218895), // Rule ID 47509 //
     /* 2218857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218860 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2218863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218894 */     // GIR_Coverage, 47509,
     /* 2218894 */     GIR_EraseRootFromParent_Done,
     /* 2218895 */   // Label 29331: @2218895
     /* 2218895 */   GIM_Reject,
     /* 2218896 */ // Label 29329: @2218896
     /* 2218896 */ GIM_Reject,
     /* 2218897 */ // Label 29251: @2218897
     /* 2218897 */ GIM_Reject,
     /* 2218898 */ // Label 43: @2218898
     /* 2218898 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29356*/ GIMT_Encode4(2227493),
     /* 2218909 */ /*GILLT_s32*//*Label 29332*/ GIMT_Encode4(2219033),
     /* 2218913 */ /*GILLT_s64*//*Label 29333*/ GIMT_Encode4(2219158), GIMT_Encode4(0),
     /* 2218921 */ /*GILLT_nxv1s8*//*Label 29334*/ GIMT_Encode4(2219503),
     /* 2218925 */ /*GILLT_nxv1s16*//*Label 29335*/ GIMT_Encode4(2219618),
     /* 2218929 */ /*GILLT_nxv1s32*//*Label 29336*/ GIMT_Encode4(2220097),
     /* 2218933 */ /*GILLT_nxv1s64*//*Label 29337*/ GIMT_Encode4(2220576), GIMT_Encode4(0),
     /* 2218941 */ /*GILLT_nxv2s8*//*Label 29338*/ GIMT_Encode4(2221055),
     /* 2218945 */ /*GILLT_nxv2s16*//*Label 29339*/ GIMT_Encode4(2221170),
     /* 2218949 */ /*GILLT_nxv2s32*//*Label 29340*/ GIMT_Encode4(2221649),
     /* 2218953 */ /*GILLT_nxv2s64*//*Label 29341*/ GIMT_Encode4(2222128), GIMT_Encode4(0),
     /* 2218961 */ /*GILLT_nxv4s8*//*Label 29342*/ GIMT_Encode4(2222607),
     /* 2218965 */ /*GILLT_nxv4s16*//*Label 29343*/ GIMT_Encode4(2222722),
     /* 2218969 */ /*GILLT_nxv4s32*//*Label 29344*/ GIMT_Encode4(2223201),
     /* 2218973 */ /*GILLT_nxv4s64*//*Label 29345*/ GIMT_Encode4(2223680), GIMT_Encode4(0),
     /* 2218981 */ /*GILLT_nxv8s8*//*Label 29346*/ GIMT_Encode4(2224159),
     /* 2218985 */ /*GILLT_nxv8s16*//*Label 29347*/ GIMT_Encode4(2224274),
     /* 2218989 */ /*GILLT_nxv8s32*//*Label 29348*/ GIMT_Encode4(2224753),
     /* 2218993 */ /*GILLT_nxv8s64*//*Label 29349*/ GIMT_Encode4(2225232), GIMT_Encode4(0),
     /* 2219001 */ /*GILLT_nxv16s8*//*Label 29350*/ GIMT_Encode4(2225711),
     /* 2219005 */ /*GILLT_nxv16s16*//*Label 29351*/ GIMT_Encode4(2225826),
     /* 2219009 */ /*GILLT_nxv16s32*//*Label 29352*/ GIMT_Encode4(2226305), GIMT_Encode4(0),
     /* 2219017 */ /*GILLT_nxv32s8*//*Label 29353*/ GIMT_Encode4(2226784),
     /* 2219021 */ /*GILLT_nxv32s16*//*Label 29354*/ GIMT_Encode4(2226899), GIMT_Encode4(0),
     /* 2219029 */ /*GILLT_nxv64s8*//*Label 29355*/ GIMT_Encode4(2227378),
     /* 2219033 */ // Label 29332: @2219033
     /* 2219033 */ GIM_Try, /*On fail goto*//*Label 29357*/ GIMT_Encode4(2219157),
     /* 2219038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2219041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2219044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219048 */   GIM_Try, /*On fail goto*//*Label 29358*/ GIMT_Encode4(2219085), // Rule ID 2483 //
     /* 2219053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /* 2219056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2219060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219067 */     // (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2)
     /* 2219067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2219070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219084 */     // GIR_Coverage, 2483,
     /* 2219084 */     GIR_EraseRootFromParent_Done,
     /* 2219085 */   // Label 29358: @2219085
     /* 2219085 */   GIM_Try, /*On fail goto*//*Label 29359*/ GIMT_Encode4(2219123), // Rule ID 97 //
     /* 2219090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2219093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2219109 */     // MIs[1] Operand 1
     /* 2219109 */     // No operand predicates
     /* 2219109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219111 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2219111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219122 */     // GIR_Coverage, 97,
     /* 2219122 */     GIR_EraseRootFromParent_Done,
     /* 2219123 */   // Label 29359: @2219123
     /* 2219123 */   GIM_Try, /*On fail goto*//*Label 29360*/ GIMT_Encode4(2219156), // Rule ID 111 //
     /* 2219128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2219131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219142 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SLL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2219142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2219145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219155 */     // GIR_Coverage, 111,
     /* 2219155 */     GIR_EraseRootFromParent_Done,
     /* 2219156 */   // Label 29360: @2219156
     /* 2219156 */   GIM_Reject,
     /* 2219157 */ // Label 29357: @2219157
     /* 2219157 */ GIM_Reject,
     /* 2219158 */ // Label 29333: @2219158
     /* 2219158 */ GIM_Try, /*On fail goto*//*Label 29361*/ GIMT_Encode4(2219502),
     /* 2219163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2219166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2219169 */   GIM_Try, /*On fail goto*//*Label 29362*/ GIMT_Encode4(2219263), // Rule ID 263 //
     /* 2219174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2219177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2219189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2219193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2219197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219202 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2219213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219221 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2219225 */     // MIs[2] Operand 1
     /* 2219225 */     // No operand predicates
     /* 2219225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219227 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt))
     /* 2219227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2219230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2219243 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2219246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2219251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219256 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // shamt
     /* 2219261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219262 */     // GIR_Coverage, 263,
     /* 2219262 */     GIR_EraseRootFromParent_Done,
     /* 2219263 */   // Label 29362: @2219263
     /* 2219263 */   GIM_Try, /*On fail goto*//*Label 29363*/ GIMT_Encode4(2219335), // Rule ID 2623 //
     /* 2219268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2219271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2219283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2219287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2219291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219296 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2219307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219315 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2219319 */     // MIs[2] Operand 1
     /* 2219319 */     // No operand predicates
     /* 2219319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219321 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SLLI_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2219321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /* 2219324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2219330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2219333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219334 */     // GIR_Coverage, 2623,
     /* 2219334 */     GIR_EraseRootFromParent_Done,
     /* 2219335 */   // Label 29363: @2219335
     /* 2219335 */   GIM_Try, /*On fail goto*//*Label 29364*/ GIMT_Encode4(2219376), // Rule ID 2482 //
     /* 2219340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /* 2219343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2219351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219358 */     // (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2)
     /* 2219358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2219361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219375 */     // GIR_Coverage, 2482,
     /* 2219375 */     GIR_EraseRootFromParent_Done,
     /* 2219376 */   // Label 29364: @2219376
     /* 2219376 */   GIM_Try, /*On fail goto*//*Label 29365*/ GIMT_Encode4(2219422), // Rule ID 278 //
     /* 2219381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2219384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2219404 */     // MIs[1] Operand 1
     /* 2219404 */     // No operand predicates
     /* 2219404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10047),
     /* 2219408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219410 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)<<P:Predicate_anonymous_10047>>  =>  (SLLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2219410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLIW),
     /* 2219413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219421 */     // GIR_Coverage, 278,
     /* 2219421 */     GIR_EraseRootFromParent_Done,
     /* 2219422 */   // Label 29365: @2219422
     /* 2219422 */   GIM_Try, /*On fail goto*//*Label 29366*/ GIMT_Encode4(2219464), // Rule ID 96 //
     /* 2219427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2219430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2219450 */     // MIs[1] Operand 1
     /* 2219450 */     // No operand predicates
     /* 2219450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219452 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2219452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219463 */     // GIR_Coverage, 96,
     /* 2219463 */     GIR_EraseRootFromParent_Done,
     /* 2219464 */   // Label 29366: @2219464
     /* 2219464 */   GIM_Try, /*On fail goto*//*Label 29367*/ GIMT_Encode4(2219501), // Rule ID 110 //
     /* 2219469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2219472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219487 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2219487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2219490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219500 */     // GIR_Coverage, 110,
     /* 2219500 */     GIR_EraseRootFromParent_Done,
     /* 2219501 */   // Label 29367: @2219501
     /* 2219501 */   GIM_Reject,
     /* 2219502 */ // Label 29361: @2219502
     /* 2219502 */ GIM_Reject,
     /* 2219503 */ // Label 29334: @2219503
     /* 2219503 */ GIM_Try, /*On fail goto*//*Label 29368*/ GIMT_Encode4(2219617),
     /* 2219508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2219514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219526 */   GIM_Try, /*On fail goto*//*Label 29369*/ GIMT_Encode4(2219571), // Rule ID 48052 //
     /* 2219531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219534 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2219537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2219551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219570 */     // GIR_Coverage, 48052,
     /* 2219570 */     GIR_EraseRootFromParent_Done,
     /* 2219571 */   // Label 29369: @2219571
     /* 2219571 */   GIM_Try, /*On fail goto*//*Label 29370*/ GIMT_Encode4(2219616), // Rule ID 48053 //
     /* 2219576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219579 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2219582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2219596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219615 */     // GIR_Coverage, 48053,
     /* 2219615 */     GIR_EraseRootFromParent_Done,
     /* 2219616 */   // Label 29370: @2219616
     /* 2219616 */   GIM_Reject,
     /* 2219617 */ // Label 29368: @2219617
     /* 2219617 */ GIM_Reject,
     /* 2219618 */ // Label 29335: @2219618
     /* 2219618 */ GIM_Try, /*On fail goto*//*Label 29371*/ GIMT_Encode4(2220096),
     /* 2219623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2219626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2219629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219633 */   GIM_Try, /*On fail goto*//*Label 29372*/ GIMT_Encode4(2219722), // Rule ID 59540 //
     /* 2219638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2219641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2219649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219653 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2219655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2219668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219672 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2219674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219681 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2219684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2219698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2219707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2219711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219721 */     // GIR_Coverage, 59540,
     /* 2219721 */     GIR_EraseRootFromParent_Done,
     /* 2219722 */   // Label 29372: @2219722
     /* 2219722 */   GIM_Try, /*On fail goto*//*Label 29373*/ GIMT_Encode4(2219811), // Rule ID 59541 //
     /* 2219727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2219730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2219738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219742 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2219744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2219757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219761 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2219763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219770 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2219773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2219787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2219796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2219800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219810 */     // GIR_Coverage, 59541,
     /* 2219810 */     GIR_EraseRootFromParent_Done,
     /* 2219811 */   // Label 29373: @2219811
     /* 2219811 */   GIM_Try, /*On fail goto*//*Label 29374*/ GIMT_Encode4(2219900), // Rule ID 59542 //
     /* 2219816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2219819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2219827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219831 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2219833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2219846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219850 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2219852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219859 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2219862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2219876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2219885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2219889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219899 */     // GIR_Coverage, 59542,
     /* 2219899 */     GIR_EraseRootFromParent_Done,
     /* 2219900 */   // Label 29374: @2219900
     /* 2219900 */   GIM_Try, /*On fail goto*//*Label 29375*/ GIMT_Encode4(2219989), // Rule ID 59543 //
     /* 2219905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2219908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2219916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219920 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2219922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2219935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219939 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2219941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219948 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2219951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2219965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2219974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2219978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219988 */     // GIR_Coverage, 59543,
     /* 2219988 */     GIR_EraseRootFromParent_Done,
     /* 2219989 */   // Label 29375: @2219989
     /* 2219989 */   GIM_Try, /*On fail goto*//*Label 29376*/ GIMT_Encode4(2220042), // Rule ID 48064 //
     /* 2219994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220005 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2220022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220041 */     // GIR_Coverage, 48064,
     /* 2220041 */     GIR_EraseRootFromParent_Done,
     /* 2220042 */   // Label 29376: @2220042
     /* 2220042 */   GIM_Try, /*On fail goto*//*Label 29377*/ GIMT_Encode4(2220095), // Rule ID 48065 //
     /* 2220047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220058 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2220075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220094 */     // GIR_Coverage, 48065,
     /* 2220094 */     GIR_EraseRootFromParent_Done,
     /* 2220095 */   // Label 29377: @2220095
     /* 2220095 */   GIM_Reject,
     /* 2220096 */ // Label 29371: @2220096
     /* 2220096 */ GIM_Reject,
     /* 2220097 */ // Label 29336: @2220097
     /* 2220097 */ GIM_Try, /*On fail goto*//*Label 29378*/ GIMT_Encode4(2220575),
     /* 2220102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2220108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220112 */   GIM_Try, /*On fail goto*//*Label 29379*/ GIMT_Encode4(2220201), // Rule ID 59588 //
     /* 2220117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2220120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220132 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220151 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220160 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220200 */     // GIR_Coverage, 59588,
     /* 2220200 */     GIR_EraseRootFromParent_Done,
     /* 2220201 */   // Label 29379: @2220201
     /* 2220201 */   GIM_Try, /*On fail goto*//*Label 29380*/ GIMT_Encode4(2220290), // Rule ID 59589 //
     /* 2220206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2220209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220221 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220240 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220249 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220289 */     // GIR_Coverage, 59589,
     /* 2220289 */     GIR_EraseRootFromParent_Done,
     /* 2220290 */   // Label 29380: @2220290
     /* 2220290 */   GIM_Try, /*On fail goto*//*Label 29381*/ GIMT_Encode4(2220379), // Rule ID 59590 //
     /* 2220295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2220298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220310 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220329 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220338 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220378 */     // GIR_Coverage, 59590,
     /* 2220378 */     GIR_EraseRootFromParent_Done,
     /* 2220379 */   // Label 29381: @2220379
     /* 2220379 */   GIM_Try, /*On fail goto*//*Label 29382*/ GIMT_Encode4(2220468), // Rule ID 59591 //
     /* 2220384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2220387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220399 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220418 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220427 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220467 */     // GIR_Coverage, 59591,
     /* 2220467 */     GIR_EraseRootFromParent_Done,
     /* 2220468 */   // Label 29382: @2220468
     /* 2220468 */   GIM_Try, /*On fail goto*//*Label 29383*/ GIMT_Encode4(2220521), // Rule ID 48072 //
     /* 2220473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220484 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2220501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220520 */     // GIR_Coverage, 48072,
     /* 2220520 */     GIR_EraseRootFromParent_Done,
     /* 2220521 */   // Label 29383: @2220521
     /* 2220521 */   GIM_Try, /*On fail goto*//*Label 29384*/ GIMT_Encode4(2220574), // Rule ID 48073 //
     /* 2220526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220537 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2220554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220573 */     // GIR_Coverage, 48073,
     /* 2220573 */     GIR_EraseRootFromParent_Done,
     /* 2220574 */   // Label 29384: @2220574
     /* 2220574 */   GIM_Reject,
     /* 2220575 */ // Label 29378: @2220575
     /* 2220575 */ GIM_Reject,
     /* 2220576 */ // Label 29337: @2220576
     /* 2220576 */ GIM_Try, /*On fail goto*//*Label 29385*/ GIMT_Encode4(2221054),
     /* 2220581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2220584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2220587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220591 */   GIM_Try, /*On fail goto*//*Label 29386*/ GIMT_Encode4(2220680), // Rule ID 59628 //
     /* 2220596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2220599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220611 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220630 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220639 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2220656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220679 */     // GIR_Coverage, 59628,
     /* 2220679 */     GIR_EraseRootFromParent_Done,
     /* 2220680 */   // Label 29386: @2220680
     /* 2220680 */   GIM_Try, /*On fail goto*//*Label 29387*/ GIMT_Encode4(2220769), // Rule ID 59629 //
     /* 2220685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2220688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220700 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220719 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220721 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220726 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220728 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2220745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220768 */     // GIR_Coverage, 59629,
     /* 2220768 */     GIR_EraseRootFromParent_Done,
     /* 2220769 */   // Label 29387: @2220769
     /* 2220769 */   GIM_Try, /*On fail goto*//*Label 29388*/ GIMT_Encode4(2220858), // Rule ID 59630 //
     /* 2220774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2220777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220789 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220808 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220817 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2220834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220857 */     // GIR_Coverage, 59630,
     /* 2220857 */     GIR_EraseRootFromParent_Done,
     /* 2220858 */   // Label 29388: @2220858
     /* 2220858 */   GIM_Try, /*On fail goto*//*Label 29389*/ GIMT_Encode4(2220947), // Rule ID 59631 //
     /* 2220863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2220866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220878 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220897 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220899 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220906 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2220923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220946 */     // GIR_Coverage, 59631,
     /* 2220946 */     GIR_EraseRootFromParent_Done,
     /* 2220947 */   // Label 29389: @2220947
     /* 2220947 */   GIM_Try, /*On fail goto*//*Label 29390*/ GIMT_Encode4(2221000), // Rule ID 48088 //
     /* 2220952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2220955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220963 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2220980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220999 */     // GIR_Coverage, 48088,
     /* 2220999 */     GIR_EraseRootFromParent_Done,
     /* 2221000 */   // Label 29390: @2221000
     /* 2221000 */   GIM_Try, /*On fail goto*//*Label 29391*/ GIMT_Encode4(2221053), // Rule ID 48089 //
     /* 2221005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2221008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221016 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2221033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221052 */     // GIR_Coverage, 48089,
     /* 2221052 */     GIR_EraseRootFromParent_Done,
     /* 2221053 */   // Label 29391: @2221053
     /* 2221053 */   GIM_Reject,
     /* 2221054 */ // Label 29385: @2221054
     /* 2221054 */ GIM_Reject,
     /* 2221055 */ // Label 29338: @2221055
     /* 2221055 */ GIM_Try, /*On fail goto*//*Label 29392*/ GIMT_Encode4(2221169),
     /* 2221060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2221066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221078 */   GIM_Try, /*On fail goto*//*Label 29393*/ GIMT_Encode4(2221123), // Rule ID 48056 //
     /* 2221083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221086 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2221089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2221103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221122 */     // GIR_Coverage, 48056,
     /* 2221122 */     GIR_EraseRootFromParent_Done,
     /* 2221123 */   // Label 29393: @2221123
     /* 2221123 */   GIM_Try, /*On fail goto*//*Label 29394*/ GIMT_Encode4(2221168), // Rule ID 48057 //
     /* 2221128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221131 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2221134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2221148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221167 */     // GIR_Coverage, 48057,
     /* 2221167 */     GIR_EraseRootFromParent_Done,
     /* 2221168 */   // Label 29394: @2221168
     /* 2221168 */   GIM_Reject,
     /* 2221169 */ // Label 29392: @2221169
     /* 2221169 */ GIM_Reject,
     /* 2221170 */ // Label 29339: @2221170
     /* 2221170 */ GIM_Try, /*On fail goto*//*Label 29395*/ GIMT_Encode4(2221648),
     /* 2221175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2221181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221185 */   GIM_Try, /*On fail goto*//*Label 29396*/ GIMT_Encode4(2221274), // Rule ID 59548 //
     /* 2221190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2221193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221205 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221224 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221233 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221273 */     // GIR_Coverage, 59548,
     /* 2221273 */     GIR_EraseRootFromParent_Done,
     /* 2221274 */   // Label 29396: @2221274
     /* 2221274 */   GIM_Try, /*On fail goto*//*Label 29397*/ GIMT_Encode4(2221363), // Rule ID 59549 //
     /* 2221279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2221282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221294 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221313 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221322 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221362 */     // GIR_Coverage, 59549,
     /* 2221362 */     GIR_EraseRootFromParent_Done,
     /* 2221363 */   // Label 29397: @2221363
     /* 2221363 */   GIM_Try, /*On fail goto*//*Label 29398*/ GIMT_Encode4(2221452), // Rule ID 59550 //
     /* 2221368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2221371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221383 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221402 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221411 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221451 */     // GIR_Coverage, 59550,
     /* 2221451 */     GIR_EraseRootFromParent_Done,
     /* 2221452 */   // Label 29398: @2221452
     /* 2221452 */   GIM_Try, /*On fail goto*//*Label 29399*/ GIMT_Encode4(2221541), // Rule ID 59551 //
     /* 2221457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2221460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221472 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221491 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221500 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221540 */     // GIR_Coverage, 59551,
     /* 2221540 */     GIR_EraseRootFromParent_Done,
     /* 2221541 */   // Label 29399: @2221541
     /* 2221541 */   GIM_Try, /*On fail goto*//*Label 29400*/ GIMT_Encode4(2221594), // Rule ID 48068 //
     /* 2221546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221557 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2221574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221593 */     // GIR_Coverage, 48068,
     /* 2221593 */     GIR_EraseRootFromParent_Done,
     /* 2221594 */   // Label 29400: @2221594
     /* 2221594 */   GIM_Try, /*On fail goto*//*Label 29401*/ GIMT_Encode4(2221647), // Rule ID 48069 //
     /* 2221599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221610 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2221627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221646 */     // GIR_Coverage, 48069,
     /* 2221646 */     GIR_EraseRootFromParent_Done,
     /* 2221647 */   // Label 29401: @2221647
     /* 2221647 */   GIM_Reject,
     /* 2221648 */ // Label 29395: @2221648
     /* 2221648 */ GIM_Reject,
     /* 2221649 */ // Label 29340: @2221649
     /* 2221649 */ GIM_Try, /*On fail goto*//*Label 29402*/ GIMT_Encode4(2222127),
     /* 2221654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2221657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2221660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221664 */   GIM_Try, /*On fail goto*//*Label 29403*/ GIMT_Encode4(2221753), // Rule ID 59596 //
     /* 2221669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2221672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221684 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221703 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221712 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2221715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221752 */     // GIR_Coverage, 59596,
     /* 2221752 */     GIR_EraseRootFromParent_Done,
     /* 2221753 */   // Label 29403: @2221753
     /* 2221753 */   GIM_Try, /*On fail goto*//*Label 29404*/ GIMT_Encode4(2221842), // Rule ID 59597 //
     /* 2221758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2221761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221773 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221792 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221801 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2221804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221841 */     // GIR_Coverage, 59597,
     /* 2221841 */     GIR_EraseRootFromParent_Done,
     /* 2221842 */   // Label 29404: @2221842
     /* 2221842 */   GIM_Try, /*On fail goto*//*Label 29405*/ GIMT_Encode4(2221931), // Rule ID 59598 //
     /* 2221847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2221850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221862 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221881 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221890 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2221893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221930 */     // GIR_Coverage, 59598,
     /* 2221930 */     GIR_EraseRootFromParent_Done,
     /* 2221931 */   // Label 29405: @2221931
     /* 2221931 */   GIM_Try, /*On fail goto*//*Label 29406*/ GIMT_Encode4(2222020), // Rule ID 59599 //
     /* 2221936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2221939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221951 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221970 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221979 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2221982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222019 */     // GIR_Coverage, 59599,
     /* 2222019 */     GIR_EraseRootFromParent_Done,
     /* 2222020 */   // Label 29406: @2222020
     /* 2222020 */   GIM_Try, /*On fail goto*//*Label 29407*/ GIMT_Encode4(2222073), // Rule ID 48084 //
     /* 2222025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222036 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2222053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222072 */     // GIR_Coverage, 48084,
     /* 2222072 */     GIR_EraseRootFromParent_Done,
     /* 2222073 */   // Label 29407: @2222073
     /* 2222073 */   GIM_Try, /*On fail goto*//*Label 29408*/ GIMT_Encode4(2222126), // Rule ID 48085 //
     /* 2222078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222089 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2222106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222125 */     // GIR_Coverage, 48085,
     /* 2222125 */     GIR_EraseRootFromParent_Done,
     /* 2222126 */   // Label 29408: @2222126
     /* 2222126 */   GIM_Reject,
     /* 2222127 */ // Label 29402: @2222127
     /* 2222127 */ GIM_Reject,
     /* 2222128 */ // Label 29341: @2222128
     /* 2222128 */ GIM_Try, /*On fail goto*//*Label 29409*/ GIMT_Encode4(2222606),
     /* 2222133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2222136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2222139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222143 */   GIM_Try, /*On fail goto*//*Label 29410*/ GIMT_Encode4(2222232), // Rule ID 59636 //
     /* 2222148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2222151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222163 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222182 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222191 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222231 */     // GIR_Coverage, 59636,
     /* 2222231 */     GIR_EraseRootFromParent_Done,
     /* 2222232 */   // Label 29410: @2222232
     /* 2222232 */   GIM_Try, /*On fail goto*//*Label 29411*/ GIMT_Encode4(2222321), // Rule ID 59637 //
     /* 2222237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2222240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222252 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222271 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222280 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222320 */     // GIR_Coverage, 59637,
     /* 2222320 */     GIR_EraseRootFromParent_Done,
     /* 2222321 */   // Label 29411: @2222321
     /* 2222321 */   GIM_Try, /*On fail goto*//*Label 29412*/ GIMT_Encode4(2222410), // Rule ID 59638 //
     /* 2222326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2222329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222341 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222360 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222369 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222409 */     // GIR_Coverage, 59638,
     /* 2222409 */     GIR_EraseRootFromParent_Done,
     /* 2222410 */   // Label 29412: @2222410
     /* 2222410 */   GIM_Try, /*On fail goto*//*Label 29413*/ GIMT_Encode4(2222499), // Rule ID 59639 //
     /* 2222415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2222418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222430 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222449 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222458 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222498 */     // GIR_Coverage, 59639,
     /* 2222498 */     GIR_EraseRootFromParent_Done,
     /* 2222499 */   // Label 29413: @2222499
     /* 2222499 */   GIM_Try, /*On fail goto*//*Label 29414*/ GIMT_Encode4(2222552), // Rule ID 48128 //
     /* 2222504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2222507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222515 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2222532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222551 */     // GIR_Coverage, 48128,
     /* 2222551 */     GIR_EraseRootFromParent_Done,
     /* 2222552 */   // Label 29414: @2222552
     /* 2222552 */   GIM_Try, /*On fail goto*//*Label 29415*/ GIMT_Encode4(2222605), // Rule ID 48129 //
     /* 2222557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2222560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222568 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2222585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222604 */     // GIR_Coverage, 48129,
     /* 2222604 */     GIR_EraseRootFromParent_Done,
     /* 2222605 */   // Label 29415: @2222605
     /* 2222605 */   GIM_Reject,
     /* 2222606 */ // Label 29409: @2222606
     /* 2222606 */ GIM_Reject,
     /* 2222607 */ // Label 29342: @2222607
     /* 2222607 */ GIM_Try, /*On fail goto*//*Label 29416*/ GIMT_Encode4(2222721),
     /* 2222612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2222618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222626 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222630 */   GIM_Try, /*On fail goto*//*Label 29417*/ GIMT_Encode4(2222675), // Rule ID 48060 //
     /* 2222635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222638 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2222641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2222655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222674 */     // GIR_Coverage, 48060,
     /* 2222674 */     GIR_EraseRootFromParent_Done,
     /* 2222675 */   // Label 29417: @2222675
     /* 2222675 */   GIM_Try, /*On fail goto*//*Label 29418*/ GIMT_Encode4(2222720), // Rule ID 48061 //
     /* 2222680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222683 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2222686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2222700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222719 */     // GIR_Coverage, 48061,
     /* 2222719 */     GIR_EraseRootFromParent_Done,
     /* 2222720 */   // Label 29418: @2222720
     /* 2222720 */   GIM_Reject,
     /* 2222721 */ // Label 29416: @2222721
     /* 2222721 */ GIM_Reject,
     /* 2222722 */ // Label 29343: @2222722
     /* 2222722 */ GIM_Try, /*On fail goto*//*Label 29419*/ GIMT_Encode4(2223200),
     /* 2222727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2222730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2222733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222737 */   GIM_Try, /*On fail goto*//*Label 29420*/ GIMT_Encode4(2222826), // Rule ID 59556 //
     /* 2222742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2222745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222757 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222776 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222785 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2222788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222825 */     // GIR_Coverage, 59556,
     /* 2222825 */     GIR_EraseRootFromParent_Done,
     /* 2222826 */   // Label 29420: @2222826
     /* 2222826 */   GIM_Try, /*On fail goto*//*Label 29421*/ GIMT_Encode4(2222915), // Rule ID 59557 //
     /* 2222831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2222834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222846 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222865 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222874 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2222877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222914 */     // GIR_Coverage, 59557,
     /* 2222914 */     GIR_EraseRootFromParent_Done,
     /* 2222915 */   // Label 29421: @2222915
     /* 2222915 */   GIM_Try, /*On fail goto*//*Label 29422*/ GIMT_Encode4(2223004), // Rule ID 59558 //
     /* 2222920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2222923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222935 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222954 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222963 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2222966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223003 */     // GIR_Coverage, 59558,
     /* 2223003 */     GIR_EraseRootFromParent_Done,
     /* 2223004 */   // Label 29422: @2223004
     /* 2223004 */   GIM_Try, /*On fail goto*//*Label 29423*/ GIMT_Encode4(2223093), // Rule ID 59559 //
     /* 2223009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223024 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223043 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223052 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2223069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223092 */     // GIR_Coverage, 59559,
     /* 2223092 */     GIR_EraseRootFromParent_Done,
     /* 2223093 */   // Label 29423: @2223093
     /* 2223093 */   GIM_Try, /*On fail goto*//*Label 29424*/ GIMT_Encode4(2223146), // Rule ID 48080 //
     /* 2223098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223109 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2223126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223145 */     // GIR_Coverage, 48080,
     /* 2223145 */     GIR_EraseRootFromParent_Done,
     /* 2223146 */   // Label 29424: @2223146
     /* 2223146 */   GIM_Try, /*On fail goto*//*Label 29425*/ GIMT_Encode4(2223199), // Rule ID 48081 //
     /* 2223151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223162 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2223179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223198 */     // GIR_Coverage, 48081,
     /* 2223198 */     GIR_EraseRootFromParent_Done,
     /* 2223199 */   // Label 29425: @2223199
     /* 2223199 */   GIM_Reject,
     /* 2223200 */ // Label 29419: @2223200
     /* 2223200 */ GIM_Reject,
     /* 2223201 */ // Label 29344: @2223201
     /* 2223201 */ GIM_Try, /*On fail goto*//*Label 29426*/ GIMT_Encode4(2223679),
     /* 2223206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2223212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223216 */   GIM_Try, /*On fail goto*//*Label 29427*/ GIMT_Encode4(2223305), // Rule ID 59604 //
     /* 2223221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223236 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223255 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223264 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223304 */     // GIR_Coverage, 59604,
     /* 2223304 */     GIR_EraseRootFromParent_Done,
     /* 2223305 */   // Label 29427: @2223305
     /* 2223305 */   GIM_Try, /*On fail goto*//*Label 29428*/ GIMT_Encode4(2223394), // Rule ID 59605 //
     /* 2223310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223325 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223344 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223353 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223393 */     // GIR_Coverage, 59605,
     /* 2223393 */     GIR_EraseRootFromParent_Done,
     /* 2223394 */   // Label 29428: @2223394
     /* 2223394 */   GIM_Try, /*On fail goto*//*Label 29429*/ GIMT_Encode4(2223483), // Rule ID 59606 //
     /* 2223399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223414 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223433 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223442 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223482 */     // GIR_Coverage, 59606,
     /* 2223482 */     GIR_EraseRootFromParent_Done,
     /* 2223483 */   // Label 29429: @2223483
     /* 2223483 */   GIM_Try, /*On fail goto*//*Label 29430*/ GIMT_Encode4(2223572), // Rule ID 59607 //
     /* 2223488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223503 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223522 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223531 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223571 */     // GIR_Coverage, 59607,
     /* 2223571 */     GIR_EraseRootFromParent_Done,
     /* 2223572 */   // Label 29430: @2223572
     /* 2223572 */   GIM_Try, /*On fail goto*//*Label 29431*/ GIMT_Encode4(2223625), // Rule ID 48116 //
     /* 2223577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223588 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2223605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223624 */     // GIR_Coverage, 48116,
     /* 2223624 */     GIR_EraseRootFromParent_Done,
     /* 2223625 */   // Label 29431: @2223625
     /* 2223625 */   GIM_Try, /*On fail goto*//*Label 29432*/ GIMT_Encode4(2223678), // Rule ID 48117 //
     /* 2223630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223641 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2223658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223677 */     // GIR_Coverage, 48117,
     /* 2223677 */     GIR_EraseRootFromParent_Done,
     /* 2223678 */   // Label 29432: @2223678
     /* 2223678 */   GIM_Reject,
     /* 2223679 */ // Label 29426: @2223679
     /* 2223679 */ GIM_Reject,
     /* 2223680 */ // Label 29345: @2223680
     /* 2223680 */ GIM_Try, /*On fail goto*//*Label 29433*/ GIMT_Encode4(2224158),
     /* 2223685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2223688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2223691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2223695 */   GIM_Try, /*On fail goto*//*Label 29434*/ GIMT_Encode4(2223784), // Rule ID 59644 //
     /* 2223700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2223703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223715 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223734 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223743 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2223746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2223760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223783 */     // GIR_Coverage, 59644,
     /* 2223783 */     GIR_EraseRootFromParent_Done,
     /* 2223784 */   // Label 29434: @2223784
     /* 2223784 */   GIM_Try, /*On fail goto*//*Label 29435*/ GIMT_Encode4(2223873), // Rule ID 59645 //
     /* 2223789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2223792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223804 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223823 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223832 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2223835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2223849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223872 */     // GIR_Coverage, 59645,
     /* 2223872 */     GIR_EraseRootFromParent_Done,
     /* 2223873 */   // Label 29435: @2223873
     /* 2223873 */   GIM_Try, /*On fail goto*//*Label 29436*/ GIMT_Encode4(2223962), // Rule ID 59646 //
     /* 2223878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2223881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223893 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223912 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223921 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2223924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2223938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223961 */     // GIR_Coverage, 59646,
     /* 2223961 */     GIR_EraseRootFromParent_Done,
     /* 2223962 */   // Label 29436: @2223962
     /* 2223962 */   GIM_Try, /*On fail goto*//*Label 29437*/ GIMT_Encode4(2224051), // Rule ID 59647 //
     /* 2223967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2223970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223982 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224001 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224010 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224050 */     // GIR_Coverage, 59647,
     /* 2224050 */     GIR_EraseRootFromParent_Done,
     /* 2224051 */   // Label 29437: @2224051
     /* 2224051 */   GIM_Try, /*On fail goto*//*Label 29438*/ GIMT_Encode4(2224104), // Rule ID 48132 //
     /* 2224056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2224059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224067 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2224084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224103 */     // GIR_Coverage, 48132,
     /* 2224103 */     GIR_EraseRootFromParent_Done,
     /* 2224104 */   // Label 29438: @2224104
     /* 2224104 */   GIM_Try, /*On fail goto*//*Label 29439*/ GIMT_Encode4(2224157), // Rule ID 48133 //
     /* 2224109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2224112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224120 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2224137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224156 */     // GIR_Coverage, 48133,
     /* 2224156 */     GIR_EraseRootFromParent_Done,
     /* 2224157 */   // Label 29439: @2224157
     /* 2224157 */   GIM_Reject,
     /* 2224158 */ // Label 29433: @2224158
     /* 2224158 */ GIM_Reject,
     /* 2224159 */ // Label 29346: @2224159
     /* 2224159 */ GIM_Try, /*On fail goto*//*Label 29440*/ GIMT_Encode4(2224273),
     /* 2224164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2224170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224182 */   GIM_Try, /*On fail goto*//*Label 29441*/ GIMT_Encode4(2224227), // Rule ID 48076 //
     /* 2224187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224190 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2224193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2224207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224226 */     // GIR_Coverage, 48076,
     /* 2224226 */     GIR_EraseRootFromParent_Done,
     /* 2224227 */   // Label 29441: @2224227
     /* 2224227 */   GIM_Try, /*On fail goto*//*Label 29442*/ GIMT_Encode4(2224272), // Rule ID 48077 //
     /* 2224232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224235 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2224238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2224252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224271 */     // GIR_Coverage, 48077,
     /* 2224271 */     GIR_EraseRootFromParent_Done,
     /* 2224272 */   // Label 29442: @2224272
     /* 2224272 */   GIM_Reject,
     /* 2224273 */ // Label 29440: @2224273
     /* 2224273 */ GIM_Reject,
     /* 2224274 */ // Label 29347: @2224274
     /* 2224274 */ GIM_Try, /*On fail goto*//*Label 29443*/ GIMT_Encode4(2224752),
     /* 2224279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2224285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224289 */   GIM_Try, /*On fail goto*//*Label 29444*/ GIMT_Encode4(2224378), // Rule ID 59564 //
     /* 2224294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2224297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224309 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224328 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224337 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224377 */     // GIR_Coverage, 59564,
     /* 2224377 */     GIR_EraseRootFromParent_Done,
     /* 2224378 */   // Label 29444: @2224378
     /* 2224378 */   GIM_Try, /*On fail goto*//*Label 29445*/ GIMT_Encode4(2224467), // Rule ID 59565 //
     /* 2224383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2224386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224398 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224417 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224426 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224466 */     // GIR_Coverage, 59565,
     /* 2224466 */     GIR_EraseRootFromParent_Done,
     /* 2224467 */   // Label 29445: @2224467
     /* 2224467 */   GIM_Try, /*On fail goto*//*Label 29446*/ GIMT_Encode4(2224556), // Rule ID 59566 //
     /* 2224472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2224475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224487 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224506 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224515 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224555 */     // GIR_Coverage, 59566,
     /* 2224555 */     GIR_EraseRootFromParent_Done,
     /* 2224556 */   // Label 29446: @2224556
     /* 2224556 */   GIM_Try, /*On fail goto*//*Label 29447*/ GIMT_Encode4(2224645), // Rule ID 59567 //
     /* 2224561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2224564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224576 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224595 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224604 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224644 */     // GIR_Coverage, 59567,
     /* 2224644 */     GIR_EraseRootFromParent_Done,
     /* 2224645 */   // Label 29447: @2224645
     /* 2224645 */   GIM_Try, /*On fail goto*//*Label 29448*/ GIMT_Encode4(2224698), // Rule ID 48104 //
     /* 2224650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224661 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2224678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224697 */     // GIR_Coverage, 48104,
     /* 2224697 */     GIR_EraseRootFromParent_Done,
     /* 2224698 */   // Label 29448: @2224698
     /* 2224698 */   GIM_Try, /*On fail goto*//*Label 29449*/ GIMT_Encode4(2224751), // Rule ID 48105 //
     /* 2224703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224714 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2224731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224750 */     // GIR_Coverage, 48105,
     /* 2224750 */     GIR_EraseRootFromParent_Done,
     /* 2224751 */   // Label 29449: @2224751
     /* 2224751 */   GIM_Reject,
     /* 2224752 */ // Label 29443: @2224752
     /* 2224752 */ GIM_Reject,
     /* 2224753 */ // Label 29348: @2224753
     /* 2224753 */ GIM_Try, /*On fail goto*//*Label 29450*/ GIMT_Encode4(2225231),
     /* 2224758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2224761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2224764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224768 */   GIM_Try, /*On fail goto*//*Label 29451*/ GIMT_Encode4(2224857), // Rule ID 59612 //
     /* 2224773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2224776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224788 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224807 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224816 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2224819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224856 */     // GIR_Coverage, 59612,
     /* 2224856 */     GIR_EraseRootFromParent_Done,
     /* 2224857 */   // Label 29451: @2224857
     /* 2224857 */   GIM_Try, /*On fail goto*//*Label 29452*/ GIMT_Encode4(2224946), // Rule ID 59613 //
     /* 2224862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2224865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224877 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224896 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224905 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2224908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224945 */     // GIR_Coverage, 59613,
     /* 2224945 */     GIR_EraseRootFromParent_Done,
     /* 2224946 */   // Label 29452: @2224946
     /* 2224946 */   GIM_Try, /*On fail goto*//*Label 29453*/ GIMT_Encode4(2225035), // Rule ID 59614 //
     /* 2224951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2224954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224966 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224985 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224994 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2224997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225034 */     // GIR_Coverage, 59614,
     /* 2225034 */     GIR_EraseRootFromParent_Done,
     /* 2225035 */   // Label 29453: @2225035
     /* 2225035 */   GIM_Try, /*On fail goto*//*Label 29454*/ GIMT_Encode4(2225124), // Rule ID 59615 //
     /* 2225040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225055 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225074 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225083 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225123 */     // GIR_Coverage, 59615,
     /* 2225123 */     GIR_EraseRootFromParent_Done,
     /* 2225124 */   // Label 29454: @2225124
     /* 2225124 */   GIM_Try, /*On fail goto*//*Label 29455*/ GIMT_Encode4(2225177), // Rule ID 48120 //
     /* 2225129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225140 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2225157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225176 */     // GIR_Coverage, 48120,
     /* 2225176 */     GIR_EraseRootFromParent_Done,
     /* 2225177 */   // Label 29455: @2225177
     /* 2225177 */   GIM_Try, /*On fail goto*//*Label 29456*/ GIMT_Encode4(2225230), // Rule ID 48121 //
     /* 2225182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225193 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2225210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225229 */     // GIR_Coverage, 48121,
     /* 2225229 */     GIR_EraseRootFromParent_Done,
     /* 2225230 */   // Label 29456: @2225230
     /* 2225230 */   GIM_Reject,
     /* 2225231 */ // Label 29450: @2225231
     /* 2225231 */ GIM_Reject,
     /* 2225232 */ // Label 29349: @2225232
     /* 2225232 */ GIM_Try, /*On fail goto*//*Label 29457*/ GIMT_Encode4(2225710),
     /* 2225237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2225240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2225243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225247 */   GIM_Try, /*On fail goto*//*Label 29458*/ GIMT_Encode4(2225336), // Rule ID 59652 //
     /* 2225252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2225255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225267 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225286 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225295 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225335 */     // GIR_Coverage, 59652,
     /* 2225335 */     GIR_EraseRootFromParent_Done,
     /* 2225336 */   // Label 29458: @2225336
     /* 2225336 */   GIM_Try, /*On fail goto*//*Label 29459*/ GIMT_Encode4(2225425), // Rule ID 59653 //
     /* 2225341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2225344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225356 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225375 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225384 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225424 */     // GIR_Coverage, 59653,
     /* 2225424 */     GIR_EraseRootFromParent_Done,
     /* 2225425 */   // Label 29459: @2225425
     /* 2225425 */   GIM_Try, /*On fail goto*//*Label 29460*/ GIMT_Encode4(2225514), // Rule ID 59654 //
     /* 2225430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2225433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225445 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225464 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225473 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225513 */     // GIR_Coverage, 59654,
     /* 2225513 */     GIR_EraseRootFromParent_Done,
     /* 2225514 */   // Label 29460: @2225514
     /* 2225514 */   GIM_Try, /*On fail goto*//*Label 29461*/ GIMT_Encode4(2225603), // Rule ID 59655 //
     /* 2225519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2225522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225534 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225553 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225562 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225602 */     // GIR_Coverage, 59655,
     /* 2225602 */     GIR_EraseRootFromParent_Done,
     /* 2225603 */   // Label 29461: @2225603
     /* 2225603 */   GIM_Try, /*On fail goto*//*Label 29462*/ GIMT_Encode4(2225656), // Rule ID 48136 //
     /* 2225608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2225611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225619 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2225636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2225651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225655 */     // GIR_Coverage, 48136,
     /* 2225655 */     GIR_EraseRootFromParent_Done,
     /* 2225656 */   // Label 29462: @2225656
     /* 2225656 */   GIM_Try, /*On fail goto*//*Label 29463*/ GIMT_Encode4(2225709), // Rule ID 48137 //
     /* 2225661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2225664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225672 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2225689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2225704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225708 */     // GIR_Coverage, 48137,
     /* 2225708 */     GIR_EraseRootFromParent_Done,
     /* 2225709 */   // Label 29463: @2225709
     /* 2225709 */   GIM_Reject,
     /* 2225710 */ // Label 29457: @2225710
     /* 2225710 */ GIM_Reject,
     /* 2225711 */ // Label 29350: @2225711
     /* 2225711 */ GIM_Try, /*On fail goto*//*Label 29464*/ GIMT_Encode4(2225825),
     /* 2225716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2225719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2225722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225734 */   GIM_Try, /*On fail goto*//*Label 29465*/ GIMT_Encode4(2225779), // Rule ID 48092 //
     /* 2225739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225742 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2225745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2225759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225778 */     // GIR_Coverage, 48092,
     /* 2225778 */     GIR_EraseRootFromParent_Done,
     /* 2225779 */   // Label 29465: @2225779
     /* 2225779 */   GIM_Try, /*On fail goto*//*Label 29466*/ GIMT_Encode4(2225824), // Rule ID 48093 //
     /* 2225784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225787 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2225790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2225804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225823 */     // GIR_Coverage, 48093,
     /* 2225823 */     GIR_EraseRootFromParent_Done,
     /* 2225824 */   // Label 29466: @2225824
     /* 2225824 */   GIM_Reject,
     /* 2225825 */ // Label 29464: @2225825
     /* 2225825 */ GIM_Reject,
     /* 2225826 */ // Label 29351: @2225826
     /* 2225826 */ GIM_Try, /*On fail goto*//*Label 29467*/ GIMT_Encode4(2226304),
     /* 2225831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2225834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2225837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225841 */   GIM_Try, /*On fail goto*//*Label 29468*/ GIMT_Encode4(2225930), // Rule ID 59572 //
     /* 2225846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2225849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2225861 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2225880 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225889 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2225892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225929 */     // GIR_Coverage, 59572,
     /* 2225929 */     GIR_EraseRootFromParent_Done,
     /* 2225930 */   // Label 29468: @2225930
     /* 2225930 */   GIM_Try, /*On fail goto*//*Label 29469*/ GIMT_Encode4(2226019), // Rule ID 59573 //
     /* 2225935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2225950 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2225969 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225971 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225978 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2225981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226018 */     // GIR_Coverage, 59573,
     /* 2226018 */     GIR_EraseRootFromParent_Done,
     /* 2226019 */   // Label 29469: @2226019
     /* 2226019 */   GIM_Try, /*On fail goto*//*Label 29470*/ GIMT_Encode4(2226108), // Rule ID 59574 //
     /* 2226024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226039 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226058 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226067 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2226084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226107 */     // GIR_Coverage, 59574,
     /* 2226107 */     GIR_EraseRootFromParent_Done,
     /* 2226108 */   // Label 29470: @2226108
     /* 2226108 */   GIM_Try, /*On fail goto*//*Label 29471*/ GIMT_Encode4(2226197), // Rule ID 59575 //
     /* 2226113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226128 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226147 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226149 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226156 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2226173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226196 */     // GIR_Coverage, 59575,
     /* 2226196 */     GIR_EraseRootFromParent_Done,
     /* 2226197 */   // Label 29471: @2226197
     /* 2226197 */   GIM_Try, /*On fail goto*//*Label 29472*/ GIMT_Encode4(2226250), // Rule ID 48108 //
     /* 2226202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226213 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2226230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226249 */     // GIR_Coverage, 48108,
     /* 2226249 */     GIR_EraseRootFromParent_Done,
     /* 2226250 */   // Label 29472: @2226250
     /* 2226250 */   GIM_Try, /*On fail goto*//*Label 29473*/ GIMT_Encode4(2226303), // Rule ID 48109 //
     /* 2226255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226266 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2226283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226302 */     // GIR_Coverage, 48109,
     /* 2226302 */     GIR_EraseRootFromParent_Done,
     /* 2226303 */   // Label 29473: @2226303
     /* 2226303 */   GIM_Reject,
     /* 2226304 */ // Label 29467: @2226304
     /* 2226304 */ GIM_Reject,
     /* 2226305 */ // Label 29352: @2226305
     /* 2226305 */ GIM_Try, /*On fail goto*//*Label 29474*/ GIMT_Encode4(2226783),
     /* 2226310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2226313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2226316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226320 */   GIM_Try, /*On fail goto*//*Label 29475*/ GIMT_Encode4(2226409), // Rule ID 59620 //
     /* 2226325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226340 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226359 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226368 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226408 */     // GIR_Coverage, 59620,
     /* 2226408 */     GIR_EraseRootFromParent_Done,
     /* 2226409 */   // Label 29475: @2226409
     /* 2226409 */   GIM_Try, /*On fail goto*//*Label 29476*/ GIMT_Encode4(2226498), // Rule ID 59621 //
     /* 2226414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226429 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226448 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226457 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226497 */     // GIR_Coverage, 59621,
     /* 2226497 */     GIR_EraseRootFromParent_Done,
     /* 2226498 */   // Label 29476: @2226498
     /* 2226498 */   GIM_Try, /*On fail goto*//*Label 29477*/ GIMT_Encode4(2226587), // Rule ID 59622 //
     /* 2226503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226518 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226537 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226546 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226586 */     // GIR_Coverage, 59622,
     /* 2226586 */     GIR_EraseRootFromParent_Done,
     /* 2226587 */   // Label 29477: @2226587
     /* 2226587 */   GIM_Try, /*On fail goto*//*Label 29478*/ GIMT_Encode4(2226676), // Rule ID 59623 //
     /* 2226592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226607 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226626 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226635 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226675 */     // GIR_Coverage, 59623,
     /* 2226675 */     GIR_EraseRootFromParent_Done,
     /* 2226676 */   // Label 29478: @2226676
     /* 2226676 */   GIM_Try, /*On fail goto*//*Label 29479*/ GIMT_Encode4(2226729), // Rule ID 48124 //
     /* 2226681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226692 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2226709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226728 */     // GIR_Coverage, 48124,
     /* 2226728 */     GIR_EraseRootFromParent_Done,
     /* 2226729 */   // Label 29479: @2226729
     /* 2226729 */   GIM_Try, /*On fail goto*//*Label 29480*/ GIMT_Encode4(2226782), // Rule ID 48125 //
     /* 2226734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226745 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2226762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226781 */     // GIR_Coverage, 48125,
     /* 2226781 */     GIR_EraseRootFromParent_Done,
     /* 2226782 */   // Label 29480: @2226782
     /* 2226782 */   GIM_Reject,
     /* 2226783 */ // Label 29474: @2226783
     /* 2226783 */ GIM_Reject,
     /* 2226784 */ // Label 29353: @2226784
     /* 2226784 */ GIM_Try, /*On fail goto*//*Label 29481*/ GIMT_Encode4(2226898),
     /* 2226789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2226792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2226795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226807 */   GIM_Try, /*On fail goto*//*Label 29482*/ GIMT_Encode4(2226852), // Rule ID 48096 //
     /* 2226812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226815 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2226818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2226832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226851 */     // GIR_Coverage, 48096,
     /* 2226851 */     GIR_EraseRootFromParent_Done,
     /* 2226852 */   // Label 29482: @2226852
     /* 2226852 */   GIM_Try, /*On fail goto*//*Label 29483*/ GIMT_Encode4(2226897), // Rule ID 48097 //
     /* 2226857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226860 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2226863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2226877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226896 */     // GIR_Coverage, 48097,
     /* 2226896 */     GIR_EraseRootFromParent_Done,
     /* 2226897 */   // Label 29483: @2226897
     /* 2226897 */   GIM_Reject,
     /* 2226898 */ // Label 29481: @2226898
     /* 2226898 */ GIM_Reject,
     /* 2226899 */ // Label 29354: @2226899
     /* 2226899 */ GIM_Try, /*On fail goto*//*Label 29484*/ GIMT_Encode4(2227377),
     /* 2226904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2226907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2226910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226914 */   GIM_Try, /*On fail goto*//*Label 29485*/ GIMT_Encode4(2227003), // Rule ID 59580 //
     /* 2226919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2226934 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2226953 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226962 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2226965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227002 */     // GIR_Coverage, 59580,
     /* 2227002 */     GIR_EraseRootFromParent_Done,
     /* 2227003 */   // Label 29485: @2227003
     /* 2227003 */   GIM_Try, /*On fail goto*//*Label 29486*/ GIMT_Encode4(2227092), // Rule ID 59581 //
     /* 2227008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2227011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227023 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2227038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227042 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227051 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227091 */     // GIR_Coverage, 59581,
     /* 2227091 */     GIR_EraseRootFromParent_Done,
     /* 2227092 */   // Label 29486: @2227092
     /* 2227092 */   GIM_Try, /*On fail goto*//*Label 29487*/ GIMT_Encode4(2227181), // Rule ID 59582 //
     /* 2227097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2227100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227112 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227131 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227140 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227180 */     // GIR_Coverage, 59582,
     /* 2227180 */     GIR_EraseRootFromParent_Done,
     /* 2227181 */   // Label 29487: @2227181
     /* 2227181 */   GIM_Try, /*On fail goto*//*Label 29488*/ GIMT_Encode4(2227270), // Rule ID 59583 //
     /* 2227186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2227189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227201 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227220 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227229 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227269 */     // GIR_Coverage, 59583,
     /* 2227269 */     GIR_EraseRootFromParent_Done,
     /* 2227270 */   // Label 29488: @2227270
     /* 2227270 */   GIM_Try, /*On fail goto*//*Label 29489*/ GIMT_Encode4(2227323), // Rule ID 48112 //
     /* 2227275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227286 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227322 */     // GIR_Coverage, 48112,
     /* 2227322 */     GIR_EraseRootFromParent_Done,
     /* 2227323 */   // Label 29489: @2227323
     /* 2227323 */   GIM_Try, /*On fail goto*//*Label 29490*/ GIMT_Encode4(2227376), // Rule ID 48113 //
     /* 2227328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227339 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227375 */     // GIR_Coverage, 48113,
     /* 2227375 */     GIR_EraseRootFromParent_Done,
     /* 2227376 */   // Label 29490: @2227376
     /* 2227376 */   GIM_Reject,
     /* 2227377 */ // Label 29484: @2227377
     /* 2227377 */ GIM_Reject,
     /* 2227378 */ // Label 29355: @2227378
     /* 2227378 */ GIM_Try, /*On fail goto*//*Label 29491*/ GIMT_Encode4(2227492),
     /* 2227383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2227386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2227389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227401 */   GIM_Try, /*On fail goto*//*Label 29492*/ GIMT_Encode4(2227446), // Rule ID 48100 //
     /* 2227406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227409 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2227412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227445 */     // GIR_Coverage, 48100,
     /* 2227445 */     GIR_EraseRootFromParent_Done,
     /* 2227446 */   // Label 29492: @2227446
     /* 2227446 */   GIM_Try, /*On fail goto*//*Label 29493*/ GIMT_Encode4(2227491), // Rule ID 48101 //
     /* 2227451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227454 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2227457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227490 */     // GIR_Coverage, 48101,
     /* 2227490 */     GIR_EraseRootFromParent_Done,
     /* 2227491 */   // Label 29493: @2227491
     /* 2227491 */   GIM_Reject,
     /* 2227492 */ // Label 29491: @2227492
     /* 2227492 */ GIM_Reject,
     /* 2227493 */ // Label 29356: @2227493
     /* 2227493 */ GIM_Reject,
     /* 2227494 */ // Label 44: @2227494
     /* 2227494 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29518*/ GIMT_Encode4(2230524),
     /* 2227505 */ /*GILLT_s32*//*Label 29494*/ GIMT_Encode4(2227629),
     /* 2227509 */ /*GILLT_s64*//*Label 29495*/ GIMT_Encode4(2227713), GIMT_Encode4(0),
     /* 2227517 */ /*GILLT_nxv1s8*//*Label 29496*/ GIMT_Encode4(2227994),
     /* 2227521 */ /*GILLT_nxv1s16*//*Label 29497*/ GIMT_Encode4(2228109),
     /* 2227525 */ /*GILLT_nxv1s32*//*Label 29498*/ GIMT_Encode4(2228224),
     /* 2227529 */ /*GILLT_nxv1s64*//*Label 29499*/ GIMT_Encode4(2228339), GIMT_Encode4(0),
     /* 2227537 */ /*GILLT_nxv2s8*//*Label 29500*/ GIMT_Encode4(2228454),
     /* 2227541 */ /*GILLT_nxv2s16*//*Label 29501*/ GIMT_Encode4(2228569),
     /* 2227545 */ /*GILLT_nxv2s32*//*Label 29502*/ GIMT_Encode4(2228684),
     /* 2227549 */ /*GILLT_nxv2s64*//*Label 29503*/ GIMT_Encode4(2228799), GIMT_Encode4(0),
     /* 2227557 */ /*GILLT_nxv4s8*//*Label 29504*/ GIMT_Encode4(2228914),
     /* 2227561 */ /*GILLT_nxv4s16*//*Label 29505*/ GIMT_Encode4(2229029),
     /* 2227565 */ /*GILLT_nxv4s32*//*Label 29506*/ GIMT_Encode4(2229144),
     /* 2227569 */ /*GILLT_nxv4s64*//*Label 29507*/ GIMT_Encode4(2229259), GIMT_Encode4(0),
     /* 2227577 */ /*GILLT_nxv8s8*//*Label 29508*/ GIMT_Encode4(2229374),
     /* 2227581 */ /*GILLT_nxv8s16*//*Label 29509*/ GIMT_Encode4(2229489),
     /* 2227585 */ /*GILLT_nxv8s32*//*Label 29510*/ GIMT_Encode4(2229604),
     /* 2227589 */ /*GILLT_nxv8s64*//*Label 29511*/ GIMT_Encode4(2229719), GIMT_Encode4(0),
     /* 2227597 */ /*GILLT_nxv16s8*//*Label 29512*/ GIMT_Encode4(2229834),
     /* 2227601 */ /*GILLT_nxv16s16*//*Label 29513*/ GIMT_Encode4(2229949),
     /* 2227605 */ /*GILLT_nxv16s32*//*Label 29514*/ GIMT_Encode4(2230064), GIMT_Encode4(0),
     /* 2227613 */ /*GILLT_nxv32s8*//*Label 29515*/ GIMT_Encode4(2230179),
     /* 2227617 */ /*GILLT_nxv32s16*//*Label 29516*/ GIMT_Encode4(2230294), GIMT_Encode4(0),
     /* 2227625 */ /*GILLT_nxv64s8*//*Label 29517*/ GIMT_Encode4(2230409),
     /* 2227629 */ // Label 29494: @2227629
     /* 2227629 */ GIM_Try, /*On fail goto*//*Label 29519*/ GIMT_Encode4(2227712),
     /* 2227634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2227637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2227640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227648 */   GIM_Try, /*On fail goto*//*Label 29520*/ GIMT_Encode4(2227682), // Rule ID 99 //
     /* 2227653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2227660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2227664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2227668 */     // MIs[1] Operand 1
     /* 2227668 */     // No operand predicates
     /* 2227668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2227670 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2227670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2227673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2227680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227681 */     // GIR_Coverage, 99,
     /* 2227681 */     GIR_EraseRootFromParent_Done,
     /* 2227682 */   // Label 29520: @2227682
     /* 2227682 */   GIM_Try, /*On fail goto*//*Label 29521*/ GIMT_Encode4(2227711), // Rule ID 113 //
     /* 2227687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2227697 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2227697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2227700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2227709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227710 */     // GIR_Coverage, 113,
     /* 2227710 */     GIR_EraseRootFromParent_Done,
     /* 2227711 */   // Label 29521: @2227711
     /* 2227711 */   GIM_Reject,
     /* 2227712 */ // Label 29519: @2227712
     /* 2227712 */ GIM_Reject,
     /* 2227713 */ // Label 29495: @2227713
     /* 2227713 */ GIM_Try, /*On fail goto*//*Label 29522*/ GIMT_Encode4(2227993),
     /* 2227718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2227724 */   GIM_Try, /*On fail goto*//*Label 29523*/ GIMT_Encode4(2227796), // Rule ID 267 //
     /* 2227729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2227732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2227744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2227752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227757 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2227768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2227776 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2227780 */     // MIs[2] Operand 1
     /* 2227780 */     // No operand predicates
     /* 2227780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227782 */     // (srl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2227782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /* 2227785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2227791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2227794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227795 */     // GIR_Coverage, 267,
     /* 2227795 */     GIR_EraseRootFromParent_Done,
     /* 2227796 */   // Label 29523: @2227796
     /* 2227796 */   GIM_Try, /*On fail goto*//*Label 29524*/ GIMT_Encode4(2227841), // Rule ID 62574 //
     /* 2227801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2227804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2227816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2227824 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10049),
     /* 2227828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2227830 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })<<P:Predicate_anonymous_10049>>  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2227830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2227833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2227839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227840 */     // GIR_Coverage, 62574,
     /* 2227840 */     GIR_EraseRootFromParent_Done,
     /* 2227841 */   // Label 29524: @2227841
     /* 2227841 */   GIM_Try, /*On fail goto*//*Label 29525*/ GIMT_Encode4(2227913), // Rule ID 279 //
     /* 2227846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2227849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2227861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227870 */     // MIs[1] Operand 2
     /* 2227870 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2227881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2227889 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2227893 */     // MIs[2] Operand 1
     /* 2227893 */     // No operand predicates
     /* 2227893 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10049),
     /* 2227897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227899 */     // (srl:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)<<P:Predicate_anonymous_10049>>  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2227899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2227902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2227908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2227911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227912 */     // GIR_Coverage, 279,
     /* 2227912 */     GIR_EraseRootFromParent_Done,
     /* 2227913 */   // Label 29525: @2227913
     /* 2227913 */   GIM_Try, /*On fail goto*//*Label 29526*/ GIMT_Encode4(2227955), // Rule ID 98 //
     /* 2227918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2227921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2227933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2227937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2227941 */     // MIs[1] Operand 1
     /* 2227941 */     // No operand predicates
     /* 2227941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2227943 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2227943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2227946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2227953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227954 */     // GIR_Coverage, 98,
     /* 2227954 */     GIR_EraseRootFromParent_Done,
     /* 2227955 */   // Label 29526: @2227955
     /* 2227955 */   GIM_Try, /*On fail goto*//*Label 29527*/ GIMT_Encode4(2227992), // Rule ID 112 //
     /* 2227960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2227963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2227978 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2227978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2227981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2227990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227991 */     // GIR_Coverage, 112,
     /* 2227991 */     GIR_EraseRootFromParent_Done,
     /* 2227992 */   // Label 29527: @2227992
     /* 2227992 */   GIM_Reject,
     /* 2227993 */ // Label 29522: @2227993
     /* 2227993 */ GIM_Reject,
     /* 2227994 */ // Label 29496: @2227994
     /* 2227994 */ GIM_Try, /*On fail goto*//*Label 29528*/ GIMT_Encode4(2228108),
     /* 2227999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2228002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2228005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228017 */   GIM_Try, /*On fail goto*//*Label 29529*/ GIMT_Encode4(2228062), // Rule ID 48184 //
     /* 2228022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228025 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2228028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2228042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228061 */     // GIR_Coverage, 48184,
     /* 2228061 */     GIR_EraseRootFromParent_Done,
     /* 2228062 */   // Label 29529: @2228062
     /* 2228062 */   GIM_Try, /*On fail goto*//*Label 29530*/ GIMT_Encode4(2228107), // Rule ID 48185 //
     /* 2228067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228070 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2228073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2228087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228106 */     // GIR_Coverage, 48185,
     /* 2228106 */     GIR_EraseRootFromParent_Done,
     /* 2228107 */   // Label 29530: @2228107
     /* 2228107 */   GIM_Reject,
     /* 2228108 */ // Label 29528: @2228108
     /* 2228108 */ GIM_Reject,
     /* 2228109 */ // Label 29497: @2228109
     /* 2228109 */ GIM_Try, /*On fail goto*//*Label 29531*/ GIMT_Encode4(2228223),
     /* 2228114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2228117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2228120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228132 */   GIM_Try, /*On fail goto*//*Label 29532*/ GIMT_Encode4(2228177), // Rule ID 48196 //
     /* 2228137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228140 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2228143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228176 */     // GIR_Coverage, 48196,
     /* 2228176 */     GIR_EraseRootFromParent_Done,
     /* 2228177 */   // Label 29532: @2228177
     /* 2228177 */   GIM_Try, /*On fail goto*//*Label 29533*/ GIMT_Encode4(2228222), // Rule ID 48197 //
     /* 2228182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228185 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2228188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228221 */     // GIR_Coverage, 48197,
     /* 2228221 */     GIR_EraseRootFromParent_Done,
     /* 2228222 */   // Label 29533: @2228222
     /* 2228222 */   GIM_Reject,
     /* 2228223 */ // Label 29531: @2228223
     /* 2228223 */ GIM_Reject,
     /* 2228224 */ // Label 29498: @2228224
     /* 2228224 */ GIM_Try, /*On fail goto*//*Label 29534*/ GIMT_Encode4(2228338),
     /* 2228229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2228232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2228235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228247 */   GIM_Try, /*On fail goto*//*Label 29535*/ GIMT_Encode4(2228292), // Rule ID 48204 //
     /* 2228252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228255 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2228258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228291 */     // GIR_Coverage, 48204,
     /* 2228291 */     GIR_EraseRootFromParent_Done,
     /* 2228292 */   // Label 29535: @2228292
     /* 2228292 */   GIM_Try, /*On fail goto*//*Label 29536*/ GIMT_Encode4(2228337), // Rule ID 48205 //
     /* 2228297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228300 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2228303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228336 */     // GIR_Coverage, 48205,
     /* 2228336 */     GIR_EraseRootFromParent_Done,
     /* 2228337 */   // Label 29536: @2228337
     /* 2228337 */   GIM_Reject,
     /* 2228338 */ // Label 29534: @2228338
     /* 2228338 */ GIM_Reject,
     /* 2228339 */ // Label 29499: @2228339
     /* 2228339 */ GIM_Try, /*On fail goto*//*Label 29537*/ GIMT_Encode4(2228453),
     /* 2228344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2228347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2228350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228362 */   GIM_Try, /*On fail goto*//*Label 29538*/ GIMT_Encode4(2228407), // Rule ID 48220 //
     /* 2228367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2228370 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2228373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2228387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228406 */     // GIR_Coverage, 48220,
     /* 2228406 */     GIR_EraseRootFromParent_Done,
     /* 2228407 */   // Label 29538: @2228407
     /* 2228407 */   GIM_Try, /*On fail goto*//*Label 29539*/ GIMT_Encode4(2228452), // Rule ID 48221 //
     /* 2228412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2228415 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2228418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2228432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228451 */     // GIR_Coverage, 48221,
     /* 2228451 */     GIR_EraseRootFromParent_Done,
     /* 2228452 */   // Label 29539: @2228452
     /* 2228452 */   GIM_Reject,
     /* 2228453 */ // Label 29537: @2228453
     /* 2228453 */ GIM_Reject,
     /* 2228454 */ // Label 29500: @2228454
     /* 2228454 */ GIM_Try, /*On fail goto*//*Label 29540*/ GIMT_Encode4(2228568),
     /* 2228459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2228462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2228465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228477 */   GIM_Try, /*On fail goto*//*Label 29541*/ GIMT_Encode4(2228522), // Rule ID 48188 //
     /* 2228482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228485 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2228488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228521 */     // GIR_Coverage, 48188,
     /* 2228521 */     GIR_EraseRootFromParent_Done,
     /* 2228522 */   // Label 29541: @2228522
     /* 2228522 */   GIM_Try, /*On fail goto*//*Label 29542*/ GIMT_Encode4(2228567), // Rule ID 48189 //
     /* 2228527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228530 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2228533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228566 */     // GIR_Coverage, 48189,
     /* 2228566 */     GIR_EraseRootFromParent_Done,
     /* 2228567 */   // Label 29542: @2228567
     /* 2228567 */   GIM_Reject,
     /* 2228568 */ // Label 29540: @2228568
     /* 2228568 */ GIM_Reject,
     /* 2228569 */ // Label 29501: @2228569
     /* 2228569 */ GIM_Try, /*On fail goto*//*Label 29543*/ GIMT_Encode4(2228683),
     /* 2228574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2228577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2228580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228592 */   GIM_Try, /*On fail goto*//*Label 29544*/ GIMT_Encode4(2228637), // Rule ID 48200 //
     /* 2228597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228600 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2228603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228636 */     // GIR_Coverage, 48200,
     /* 2228636 */     GIR_EraseRootFromParent_Done,
     /* 2228637 */   // Label 29544: @2228637
     /* 2228637 */   GIM_Try, /*On fail goto*//*Label 29545*/ GIMT_Encode4(2228682), // Rule ID 48201 //
     /* 2228642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228645 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2228648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228681 */     // GIR_Coverage, 48201,
     /* 2228681 */     GIR_EraseRootFromParent_Done,
     /* 2228682 */   // Label 29545: @2228682
     /* 2228682 */   GIM_Reject,
     /* 2228683 */ // Label 29543: @2228683
     /* 2228683 */ GIM_Reject,
     /* 2228684 */ // Label 29502: @2228684
     /* 2228684 */ GIM_Try, /*On fail goto*//*Label 29546*/ GIMT_Encode4(2228798),
     /* 2228689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2228692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2228695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228707 */   GIM_Try, /*On fail goto*//*Label 29547*/ GIMT_Encode4(2228752), // Rule ID 48216 //
     /* 2228712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228715 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2228718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2228732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228751 */     // GIR_Coverage, 48216,
     /* 2228751 */     GIR_EraseRootFromParent_Done,
     /* 2228752 */   // Label 29547: @2228752
     /* 2228752 */   GIM_Try, /*On fail goto*//*Label 29548*/ GIMT_Encode4(2228797), // Rule ID 48217 //
     /* 2228757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228760 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2228763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2228777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228796 */     // GIR_Coverage, 48217,
     /* 2228796 */     GIR_EraseRootFromParent_Done,
     /* 2228797 */   // Label 29548: @2228797
     /* 2228797 */   GIM_Reject,
     /* 2228798 */ // Label 29546: @2228798
     /* 2228798 */ GIM_Reject,
     /* 2228799 */ // Label 29503: @2228799
     /* 2228799 */ GIM_Try, /*On fail goto*//*Label 29549*/ GIMT_Encode4(2228913),
     /* 2228804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2228807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2228810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228822 */   GIM_Try, /*On fail goto*//*Label 29550*/ GIMT_Encode4(2228867), // Rule ID 48260 //
     /* 2228827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2228830 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2228833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2228847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228866 */     // GIR_Coverage, 48260,
     /* 2228866 */     GIR_EraseRootFromParent_Done,
     /* 2228867 */   // Label 29550: @2228867
     /* 2228867 */   GIM_Try, /*On fail goto*//*Label 29551*/ GIMT_Encode4(2228912), // Rule ID 48261 //
     /* 2228872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2228875 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2228878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2228892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228911 */     // GIR_Coverage, 48261,
     /* 2228911 */     GIR_EraseRootFromParent_Done,
     /* 2228912 */   // Label 29551: @2228912
     /* 2228912 */   GIM_Reject,
     /* 2228913 */ // Label 29549: @2228913
     /* 2228913 */ GIM_Reject,
     /* 2228914 */ // Label 29504: @2228914
     /* 2228914 */ GIM_Try, /*On fail goto*//*Label 29552*/ GIMT_Encode4(2229028),
     /* 2228919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2228922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2228925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228937 */   GIM_Try, /*On fail goto*//*Label 29553*/ GIMT_Encode4(2228982), // Rule ID 48192 //
     /* 2228942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228945 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2228948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228981 */     // GIR_Coverage, 48192,
     /* 2228981 */     GIR_EraseRootFromParent_Done,
     /* 2228982 */   // Label 29553: @2228982
     /* 2228982 */   GIM_Try, /*On fail goto*//*Label 29554*/ GIMT_Encode4(2229027), // Rule ID 48193 //
     /* 2228987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228990 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2228993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2229007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229026 */     // GIR_Coverage, 48193,
     /* 2229026 */     GIR_EraseRootFromParent_Done,
     /* 2229027 */   // Label 29554: @2229027
     /* 2229027 */   GIM_Reject,
     /* 2229028 */ // Label 29552: @2229028
     /* 2229028 */ GIM_Reject,
     /* 2229029 */ // Label 29505: @2229029
     /* 2229029 */ GIM_Try, /*On fail goto*//*Label 29555*/ GIMT_Encode4(2229143),
     /* 2229034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2229037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2229040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229052 */   GIM_Try, /*On fail goto*//*Label 29556*/ GIMT_Encode4(2229097), // Rule ID 48212 //
     /* 2229057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229060 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229096 */     // GIR_Coverage, 48212,
     /* 2229096 */     GIR_EraseRootFromParent_Done,
     /* 2229097 */   // Label 29556: @2229097
     /* 2229097 */   GIM_Try, /*On fail goto*//*Label 29557*/ GIMT_Encode4(2229142), // Rule ID 48213 //
     /* 2229102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229105 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229141 */     // GIR_Coverage, 48213,
     /* 2229141 */     GIR_EraseRootFromParent_Done,
     /* 2229142 */   // Label 29557: @2229142
     /* 2229142 */   GIM_Reject,
     /* 2229143 */ // Label 29555: @2229143
     /* 2229143 */ GIM_Reject,
     /* 2229144 */ // Label 29506: @2229144
     /* 2229144 */ GIM_Try, /*On fail goto*//*Label 29558*/ GIMT_Encode4(2229258),
     /* 2229149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2229152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2229155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229167 */   GIM_Try, /*On fail goto*//*Label 29559*/ GIMT_Encode4(2229212), // Rule ID 48248 //
     /* 2229172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229175 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229211 */     // GIR_Coverage, 48248,
     /* 2229211 */     GIR_EraseRootFromParent_Done,
     /* 2229212 */   // Label 29559: @2229212
     /* 2229212 */   GIM_Try, /*On fail goto*//*Label 29560*/ GIMT_Encode4(2229257), // Rule ID 48249 //
     /* 2229217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229220 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229256 */     // GIR_Coverage, 48249,
     /* 2229256 */     GIR_EraseRootFromParent_Done,
     /* 2229257 */   // Label 29560: @2229257
     /* 2229257 */   GIM_Reject,
     /* 2229258 */ // Label 29558: @2229258
     /* 2229258 */ GIM_Reject,
     /* 2229259 */ // Label 29507: @2229259
     /* 2229259 */ GIM_Try, /*On fail goto*//*Label 29561*/ GIMT_Encode4(2229373),
     /* 2229264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2229267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2229270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229282 */   GIM_Try, /*On fail goto*//*Label 29562*/ GIMT_Encode4(2229327), // Rule ID 48264 //
     /* 2229287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2229290 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2229293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229326 */     // GIR_Coverage, 48264,
     /* 2229326 */     GIR_EraseRootFromParent_Done,
     /* 2229327 */   // Label 29562: @2229327
     /* 2229327 */   GIM_Try, /*On fail goto*//*Label 29563*/ GIMT_Encode4(2229372), // Rule ID 48265 //
     /* 2229332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2229335 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2229338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229371 */     // GIR_Coverage, 48265,
     /* 2229371 */     GIR_EraseRootFromParent_Done,
     /* 2229372 */   // Label 29563: @2229372
     /* 2229372 */   GIM_Reject,
     /* 2229373 */ // Label 29561: @2229373
     /* 2229373 */ GIM_Reject,
     /* 2229374 */ // Label 29508: @2229374
     /* 2229374 */ GIM_Try, /*On fail goto*//*Label 29564*/ GIMT_Encode4(2229488),
     /* 2229379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2229382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2229385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229397 */   GIM_Try, /*On fail goto*//*Label 29565*/ GIMT_Encode4(2229442), // Rule ID 48208 //
     /* 2229402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229405 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2229408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229441 */     // GIR_Coverage, 48208,
     /* 2229441 */     GIR_EraseRootFromParent_Done,
     /* 2229442 */   // Label 29565: @2229442
     /* 2229442 */   GIM_Try, /*On fail goto*//*Label 29566*/ GIMT_Encode4(2229487), // Rule ID 48209 //
     /* 2229447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229450 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2229453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229486 */     // GIR_Coverage, 48209,
     /* 2229486 */     GIR_EraseRootFromParent_Done,
     /* 2229487 */   // Label 29566: @2229487
     /* 2229487 */   GIM_Reject,
     /* 2229488 */ // Label 29564: @2229488
     /* 2229488 */ GIM_Reject,
     /* 2229489 */ // Label 29509: @2229489
     /* 2229489 */ GIM_Try, /*On fail goto*//*Label 29567*/ GIMT_Encode4(2229603),
     /* 2229494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2229497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2229500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229512 */   GIM_Try, /*On fail goto*//*Label 29568*/ GIMT_Encode4(2229557), // Rule ID 48236 //
     /* 2229517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229520 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2229523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229556 */     // GIR_Coverage, 48236,
     /* 2229556 */     GIR_EraseRootFromParent_Done,
     /* 2229557 */   // Label 29568: @2229557
     /* 2229557 */   GIM_Try, /*On fail goto*//*Label 29569*/ GIMT_Encode4(2229602), // Rule ID 48237 //
     /* 2229562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229565 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2229568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229601 */     // GIR_Coverage, 48237,
     /* 2229601 */     GIR_EraseRootFromParent_Done,
     /* 2229602 */   // Label 29569: @2229602
     /* 2229602 */   GIM_Reject,
     /* 2229603 */ // Label 29567: @2229603
     /* 2229603 */ GIM_Reject,
     /* 2229604 */ // Label 29510: @2229604
     /* 2229604 */ GIM_Try, /*On fail goto*//*Label 29570*/ GIMT_Encode4(2229718),
     /* 2229609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2229612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2229615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229627 */   GIM_Try, /*On fail goto*//*Label 29571*/ GIMT_Encode4(2229672), // Rule ID 48252 //
     /* 2229632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229635 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2229638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229671 */     // GIR_Coverage, 48252,
     /* 2229671 */     GIR_EraseRootFromParent_Done,
     /* 2229672 */   // Label 29571: @2229672
     /* 2229672 */   GIM_Try, /*On fail goto*//*Label 29572*/ GIMT_Encode4(2229717), // Rule ID 48253 //
     /* 2229677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229680 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2229683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229716 */     // GIR_Coverage, 48253,
     /* 2229716 */     GIR_EraseRootFromParent_Done,
     /* 2229717 */   // Label 29572: @2229717
     /* 2229717 */   GIM_Reject,
     /* 2229718 */ // Label 29570: @2229718
     /* 2229718 */ GIM_Reject,
     /* 2229719 */ // Label 29511: @2229719
     /* 2229719 */ GIM_Try, /*On fail goto*//*Label 29573*/ GIMT_Encode4(2229833),
     /* 2229724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2229727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2229730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229738 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229742 */   GIM_Try, /*On fail goto*//*Label 29574*/ GIMT_Encode4(2229787), // Rule ID 48268 //
     /* 2229747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2229750 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2229753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2229767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229786 */     // GIR_Coverage, 48268,
     /* 2229786 */     GIR_EraseRootFromParent_Done,
     /* 2229787 */   // Label 29574: @2229787
     /* 2229787 */   GIM_Try, /*On fail goto*//*Label 29575*/ GIMT_Encode4(2229832), // Rule ID 48269 //
     /* 2229792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2229795 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2229798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2229812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229831 */     // GIR_Coverage, 48269,
     /* 2229831 */     GIR_EraseRootFromParent_Done,
     /* 2229832 */   // Label 29575: @2229832
     /* 2229832 */   GIM_Reject,
     /* 2229833 */ // Label 29573: @2229833
     /* 2229833 */ GIM_Reject,
     /* 2229834 */ // Label 29512: @2229834
     /* 2229834 */ GIM_Try, /*On fail goto*//*Label 29576*/ GIMT_Encode4(2229948),
     /* 2229839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2229842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2229845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229857 */   GIM_Try, /*On fail goto*//*Label 29577*/ GIMT_Encode4(2229902), // Rule ID 48224 //
     /* 2229862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229865 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2229868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229901 */     // GIR_Coverage, 48224,
     /* 2229901 */     GIR_EraseRootFromParent_Done,
     /* 2229902 */   // Label 29577: @2229902
     /* 2229902 */   GIM_Try, /*On fail goto*//*Label 29578*/ GIMT_Encode4(2229947), // Rule ID 48225 //
     /* 2229907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229910 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2229913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229946 */     // GIR_Coverage, 48225,
     /* 2229946 */     GIR_EraseRootFromParent_Done,
     /* 2229947 */   // Label 29578: @2229947
     /* 2229947 */   GIM_Reject,
     /* 2229948 */ // Label 29576: @2229948
     /* 2229948 */ GIM_Reject,
     /* 2229949 */ // Label 29513: @2229949
     /* 2229949 */ GIM_Try, /*On fail goto*//*Label 29579*/ GIMT_Encode4(2230063),
     /* 2229954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2229957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2229960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229972 */   GIM_Try, /*On fail goto*//*Label 29580*/ GIMT_Encode4(2230017), // Rule ID 48240 //
     /* 2229977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229980 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2229983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230016 */     // GIR_Coverage, 48240,
     /* 2230016 */     GIR_EraseRootFromParent_Done,
     /* 2230017 */   // Label 29580: @2230017
     /* 2230017 */   GIM_Try, /*On fail goto*//*Label 29581*/ GIMT_Encode4(2230062), // Rule ID 48241 //
     /* 2230022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230025 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2230028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230061 */     // GIR_Coverage, 48241,
     /* 2230061 */     GIR_EraseRootFromParent_Done,
     /* 2230062 */   // Label 29581: @2230062
     /* 2230062 */   GIM_Reject,
     /* 2230063 */ // Label 29579: @2230063
     /* 2230063 */ GIM_Reject,
     /* 2230064 */ // Label 29514: @2230064
     /* 2230064 */ GIM_Try, /*On fail goto*//*Label 29582*/ GIMT_Encode4(2230178),
     /* 2230069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2230072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2230075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230087 */   GIM_Try, /*On fail goto*//*Label 29583*/ GIMT_Encode4(2230132), // Rule ID 48256 //
     /* 2230092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230095 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230131 */     // GIR_Coverage, 48256,
     /* 2230131 */     GIR_EraseRootFromParent_Done,
     /* 2230132 */   // Label 29583: @2230132
     /* 2230132 */   GIM_Try, /*On fail goto*//*Label 29584*/ GIMT_Encode4(2230177), // Rule ID 48257 //
     /* 2230137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230140 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230176 */     // GIR_Coverage, 48257,
     /* 2230176 */     GIR_EraseRootFromParent_Done,
     /* 2230177 */   // Label 29584: @2230177
     /* 2230177 */   GIM_Reject,
     /* 2230178 */ // Label 29582: @2230178
     /* 2230178 */ GIM_Reject,
     /* 2230179 */ // Label 29515: @2230179
     /* 2230179 */ GIM_Try, /*On fail goto*//*Label 29585*/ GIMT_Encode4(2230293),
     /* 2230184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2230187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2230190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230202 */   GIM_Try, /*On fail goto*//*Label 29586*/ GIMT_Encode4(2230247), // Rule ID 48228 //
     /* 2230207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230210 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2230213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230246 */     // GIR_Coverage, 48228,
     /* 2230246 */     GIR_EraseRootFromParent_Done,
     /* 2230247 */   // Label 29586: @2230247
     /* 2230247 */   GIM_Try, /*On fail goto*//*Label 29587*/ GIMT_Encode4(2230292), // Rule ID 48229 //
     /* 2230252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230255 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2230258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230291 */     // GIR_Coverage, 48229,
     /* 2230291 */     GIR_EraseRootFromParent_Done,
     /* 2230292 */   // Label 29587: @2230292
     /* 2230292 */   GIM_Reject,
     /* 2230293 */ // Label 29585: @2230293
     /* 2230293 */ GIM_Reject,
     /* 2230294 */ // Label 29516: @2230294
     /* 2230294 */ GIM_Try, /*On fail goto*//*Label 29588*/ GIMT_Encode4(2230408),
     /* 2230299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2230302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2230305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230317 */   GIM_Try, /*On fail goto*//*Label 29589*/ GIMT_Encode4(2230362), // Rule ID 48244 //
     /* 2230322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230325 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2230328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230361 */     // GIR_Coverage, 48244,
     /* 2230361 */     GIR_EraseRootFromParent_Done,
     /* 2230362 */   // Label 29589: @2230362
     /* 2230362 */   GIM_Try, /*On fail goto*//*Label 29590*/ GIMT_Encode4(2230407), // Rule ID 48245 //
     /* 2230367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230370 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2230373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230406 */     // GIR_Coverage, 48245,
     /* 2230406 */     GIR_EraseRootFromParent_Done,
     /* 2230407 */   // Label 29590: @2230407
     /* 2230407 */   GIM_Reject,
     /* 2230408 */ // Label 29588: @2230408
     /* 2230408 */ GIM_Reject,
     /* 2230409 */ // Label 29517: @2230409
     /* 2230409 */ GIM_Try, /*On fail goto*//*Label 29591*/ GIMT_Encode4(2230523),
     /* 2230414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2230417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2230420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230432 */   GIM_Try, /*On fail goto*//*Label 29592*/ GIMT_Encode4(2230477), // Rule ID 48232 //
     /* 2230437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230440 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2230443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230476 */     // GIR_Coverage, 48232,
     /* 2230476 */     GIR_EraseRootFromParent_Done,
     /* 2230477 */   // Label 29592: @2230477
     /* 2230477 */   GIM_Try, /*On fail goto*//*Label 29593*/ GIMT_Encode4(2230522), // Rule ID 48233 //
     /* 2230482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230485 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2230488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230521 */     // GIR_Coverage, 48233,
     /* 2230521 */     GIR_EraseRootFromParent_Done,
     /* 2230522 */   // Label 29593: @2230522
     /* 2230522 */   GIM_Reject,
     /* 2230523 */ // Label 29591: @2230523
     /* 2230523 */ GIM_Reject,
     /* 2230524 */ // Label 29518: @2230524
     /* 2230524 */ GIM_Reject,
     /* 2230525 */ // Label 45: @2230525
     /* 2230525 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29618*/ GIMT_Encode4(2233463),
     /* 2230536 */ /*GILLT_s32*//*Label 29594*/ GIMT_Encode4(2230660),
     /* 2230540 */ /*GILLT_s64*//*Label 29595*/ GIMT_Encode4(2230744), GIMT_Encode4(0),
     /* 2230548 */ /*GILLT_nxv1s8*//*Label 29596*/ GIMT_Encode4(2230933),
     /* 2230552 */ /*GILLT_nxv1s16*//*Label 29597*/ GIMT_Encode4(2231048),
     /* 2230556 */ /*GILLT_nxv1s32*//*Label 29598*/ GIMT_Encode4(2231163),
     /* 2230560 */ /*GILLT_nxv1s64*//*Label 29599*/ GIMT_Encode4(2231278), GIMT_Encode4(0),
     /* 2230568 */ /*GILLT_nxv2s8*//*Label 29600*/ GIMT_Encode4(2231393),
     /* 2230572 */ /*GILLT_nxv2s16*//*Label 29601*/ GIMT_Encode4(2231508),
     /* 2230576 */ /*GILLT_nxv2s32*//*Label 29602*/ GIMT_Encode4(2231623),
     /* 2230580 */ /*GILLT_nxv2s64*//*Label 29603*/ GIMT_Encode4(2231738), GIMT_Encode4(0),
     /* 2230588 */ /*GILLT_nxv4s8*//*Label 29604*/ GIMT_Encode4(2231853),
     /* 2230592 */ /*GILLT_nxv4s16*//*Label 29605*/ GIMT_Encode4(2231968),
     /* 2230596 */ /*GILLT_nxv4s32*//*Label 29606*/ GIMT_Encode4(2232083),
     /* 2230600 */ /*GILLT_nxv4s64*//*Label 29607*/ GIMT_Encode4(2232198), GIMT_Encode4(0),
     /* 2230608 */ /*GILLT_nxv8s8*//*Label 29608*/ GIMT_Encode4(2232313),
     /* 2230612 */ /*GILLT_nxv8s16*//*Label 29609*/ GIMT_Encode4(2232428),
     /* 2230616 */ /*GILLT_nxv8s32*//*Label 29610*/ GIMT_Encode4(2232543),
     /* 2230620 */ /*GILLT_nxv8s64*//*Label 29611*/ GIMT_Encode4(2232658), GIMT_Encode4(0),
     /* 2230628 */ /*GILLT_nxv16s8*//*Label 29612*/ GIMT_Encode4(2232773),
     /* 2230632 */ /*GILLT_nxv16s16*//*Label 29613*/ GIMT_Encode4(2232888),
     /* 2230636 */ /*GILLT_nxv16s32*//*Label 29614*/ GIMT_Encode4(2233003), GIMT_Encode4(0),
     /* 2230644 */ /*GILLT_nxv32s8*//*Label 29615*/ GIMT_Encode4(2233118),
     /* 2230648 */ /*GILLT_nxv32s16*//*Label 29616*/ GIMT_Encode4(2233233), GIMT_Encode4(0),
     /* 2230656 */ /*GILLT_nxv64s8*//*Label 29617*/ GIMT_Encode4(2233348),
     /* 2230660 */ // Label 29594: @2230660
     /* 2230660 */ GIM_Try, /*On fail goto*//*Label 29619*/ GIMT_Encode4(2230743),
     /* 2230665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2230668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2230671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230679 */   GIM_Try, /*On fail goto*//*Label 29620*/ GIMT_Encode4(2230713), // Rule ID 101 //
     /* 2230684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2230691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2230699 */     // MIs[1] Operand 1
     /* 2230699 */     // No operand predicates
     /* 2230699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230701 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2230701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2230704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2230711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230712 */     // GIR_Coverage, 101,
     /* 2230712 */     GIR_EraseRootFromParent_Done,
     /* 2230713 */   // Label 29620: @2230713
     /* 2230713 */   GIM_Try, /*On fail goto*//*Label 29621*/ GIMT_Encode4(2230742), // Rule ID 115 //
     /* 2230718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2230728 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRA:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2230728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2230731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2230740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230741 */     // GIR_Coverage, 115,
     /* 2230741 */     GIR_EraseRootFromParent_Done,
     /* 2230742 */   // Label 29621: @2230742
     /* 2230742 */   GIM_Reject,
     /* 2230743 */ // Label 29619: @2230743
     /* 2230743 */ GIM_Reject,
     /* 2230744 */ // Label 29595: @2230744
     /* 2230744 */ GIM_Try, /*On fail goto*//*Label 29622*/ GIMT_Encode4(2230932),
     /* 2230749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2230752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2230755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230759 */   GIM_Try, /*On fail goto*//*Label 29623*/ GIMT_Encode4(2230796), // Rule ID 62573 //
     /* 2230764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2230767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2230771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2230775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2230779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2230783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230785 */     // (sra:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2230785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2230788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2230794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230795 */     // GIR_Coverage, 62573,
     /* 2230795 */     GIR_EraseRootFromParent_Done,
     /* 2230796 */   // Label 29623: @2230796
     /* 2230796 */   GIM_Try, /*On fail goto*//*Label 29624*/ GIMT_Encode4(2230860), // Rule ID 269 //
     /* 2230801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2230804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2230808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2230812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2230816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230821 */     // MIs[1] Operand 2
     /* 2230821 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2230832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2230836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230840 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2230844 */     // MIs[2] Operand 1
     /* 2230844 */     // No operand predicates
     /* 2230844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2230846 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2230846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2230849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2230855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2230858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230859 */     // GIR_Coverage, 269,
     /* 2230859 */     GIR_EraseRootFromParent_Done,
     /* 2230860 */   // Label 29624: @2230860
     /* 2230860 */   GIM_Try, /*On fail goto*//*Label 29625*/ GIMT_Encode4(2230898), // Rule ID 100 //
     /* 2230865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2230876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2230884 */     // MIs[1] Operand 1
     /* 2230884 */     // No operand predicates
     /* 2230884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230886 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2230886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2230889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2230896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230897 */     // GIR_Coverage, 100,
     /* 2230897 */     GIR_EraseRootFromParent_Done,
     /* 2230898 */   // Label 29625: @2230898
     /* 2230898 */   GIM_Try, /*On fail goto*//*Label 29626*/ GIMT_Encode4(2230931), // Rule ID 114 //
     /* 2230903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2230917 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRA:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2230917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2230920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2230929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230930 */     // GIR_Coverage, 114,
     /* 2230930 */     GIR_EraseRootFromParent_Done,
     /* 2230931 */   // Label 29626: @2230931
     /* 2230931 */   GIM_Reject,
     /* 2230932 */ // Label 29622: @2230932
     /* 2230932 */ GIM_Reject,
     /* 2230933 */ // Label 29596: @2230933
     /* 2230933 */ GIM_Try, /*On fail goto*//*Label 29627*/ GIMT_Encode4(2231047),
     /* 2230938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2230941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2230944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2230948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2230952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2230956 */   GIM_Try, /*On fail goto*//*Label 29628*/ GIMT_Encode4(2231001), // Rule ID 48316 //
     /* 2230961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230964 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2230967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2230981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231000 */     // GIR_Coverage, 48316,
     /* 2231000 */     GIR_EraseRootFromParent_Done,
     /* 2231001 */   // Label 29628: @2231001
     /* 2231001 */   GIM_Try, /*On fail goto*//*Label 29629*/ GIMT_Encode4(2231046), // Rule ID 48317 //
     /* 2231006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231009 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2231012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2231026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231045 */     // GIR_Coverage, 48317,
     /* 2231045 */     GIR_EraseRootFromParent_Done,
     /* 2231046 */   // Label 29629: @2231046
     /* 2231046 */   GIM_Reject,
     /* 2231047 */ // Label 29627: @2231047
     /* 2231047 */ GIM_Reject,
     /* 2231048 */ // Label 29597: @2231048
     /* 2231048 */ GIM_Try, /*On fail goto*//*Label 29630*/ GIMT_Encode4(2231162),
     /* 2231053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2231056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2231059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231067 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231071 */   GIM_Try, /*On fail goto*//*Label 29631*/ GIMT_Encode4(2231116), // Rule ID 48328 //
     /* 2231076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231079 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2231082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231115 */     // GIR_Coverage, 48328,
     /* 2231115 */     GIR_EraseRootFromParent_Done,
     /* 2231116 */   // Label 29631: @2231116
     /* 2231116 */   GIM_Try, /*On fail goto*//*Label 29632*/ GIMT_Encode4(2231161), // Rule ID 48329 //
     /* 2231121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231124 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2231127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231160 */     // GIR_Coverage, 48329,
     /* 2231160 */     GIR_EraseRootFromParent_Done,
     /* 2231161 */   // Label 29632: @2231161
     /* 2231161 */   GIM_Reject,
     /* 2231162 */ // Label 29630: @2231162
     /* 2231162 */ GIM_Reject,
     /* 2231163 */ // Label 29598: @2231163
     /* 2231163 */ GIM_Try, /*On fail goto*//*Label 29633*/ GIMT_Encode4(2231277),
     /* 2231168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2231171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2231174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231182 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231186 */   GIM_Try, /*On fail goto*//*Label 29634*/ GIMT_Encode4(2231231), // Rule ID 48336 //
     /* 2231191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231194 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2231197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231230 */     // GIR_Coverage, 48336,
     /* 2231230 */     GIR_EraseRootFromParent_Done,
     /* 2231231 */   // Label 29634: @2231231
     /* 2231231 */   GIM_Try, /*On fail goto*//*Label 29635*/ GIMT_Encode4(2231276), // Rule ID 48337 //
     /* 2231236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231239 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2231242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231275 */     // GIR_Coverage, 48337,
     /* 2231275 */     GIR_EraseRootFromParent_Done,
     /* 2231276 */   // Label 29635: @2231276
     /* 2231276 */   GIM_Reject,
     /* 2231277 */ // Label 29633: @2231277
     /* 2231277 */ GIM_Reject,
     /* 2231278 */ // Label 29599: @2231278
     /* 2231278 */ GIM_Try, /*On fail goto*//*Label 29636*/ GIMT_Encode4(2231392),
     /* 2231283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2231286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2231289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231297 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231301 */   GIM_Try, /*On fail goto*//*Label 29637*/ GIMT_Encode4(2231346), // Rule ID 48352 //
     /* 2231306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2231309 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2231312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2231326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231345 */     // GIR_Coverage, 48352,
     /* 2231345 */     GIR_EraseRootFromParent_Done,
     /* 2231346 */   // Label 29637: @2231346
     /* 2231346 */   GIM_Try, /*On fail goto*//*Label 29638*/ GIMT_Encode4(2231391), // Rule ID 48353 //
     /* 2231351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2231354 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2231357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2231371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231390 */     // GIR_Coverage, 48353,
     /* 2231390 */     GIR_EraseRootFromParent_Done,
     /* 2231391 */   // Label 29638: @2231391
     /* 2231391 */   GIM_Reject,
     /* 2231392 */ // Label 29636: @2231392
     /* 2231392 */ GIM_Reject,
     /* 2231393 */ // Label 29600: @2231393
     /* 2231393 */ GIM_Try, /*On fail goto*//*Label 29639*/ GIMT_Encode4(2231507),
     /* 2231398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2231401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2231404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231416 */   GIM_Try, /*On fail goto*//*Label 29640*/ GIMT_Encode4(2231461), // Rule ID 48320 //
     /* 2231421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231424 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2231427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231460 */     // GIR_Coverage, 48320,
     /* 2231460 */     GIR_EraseRootFromParent_Done,
     /* 2231461 */   // Label 29640: @2231461
     /* 2231461 */   GIM_Try, /*On fail goto*//*Label 29641*/ GIMT_Encode4(2231506), // Rule ID 48321 //
     /* 2231466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231469 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2231472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231505 */     // GIR_Coverage, 48321,
     /* 2231505 */     GIR_EraseRootFromParent_Done,
     /* 2231506 */   // Label 29641: @2231506
     /* 2231506 */   GIM_Reject,
     /* 2231507 */ // Label 29639: @2231507
     /* 2231507 */ GIM_Reject,
     /* 2231508 */ // Label 29601: @2231508
     /* 2231508 */ GIM_Try, /*On fail goto*//*Label 29642*/ GIMT_Encode4(2231622),
     /* 2231513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2231516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2231519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231531 */   GIM_Try, /*On fail goto*//*Label 29643*/ GIMT_Encode4(2231576), // Rule ID 48332 //
     /* 2231536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231539 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2231542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231575 */     // GIR_Coverage, 48332,
     /* 2231575 */     GIR_EraseRootFromParent_Done,
     /* 2231576 */   // Label 29643: @2231576
     /* 2231576 */   GIM_Try, /*On fail goto*//*Label 29644*/ GIMT_Encode4(2231621), // Rule ID 48333 //
     /* 2231581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231584 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2231587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231620 */     // GIR_Coverage, 48333,
     /* 2231620 */     GIR_EraseRootFromParent_Done,
     /* 2231621 */   // Label 29644: @2231621
     /* 2231621 */   GIM_Reject,
     /* 2231622 */ // Label 29642: @2231622
     /* 2231622 */ GIM_Reject,
     /* 2231623 */ // Label 29602: @2231623
     /* 2231623 */ GIM_Try, /*On fail goto*//*Label 29645*/ GIMT_Encode4(2231737),
     /* 2231628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2231631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2231634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231642 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231646 */   GIM_Try, /*On fail goto*//*Label 29646*/ GIMT_Encode4(2231691), // Rule ID 48348 //
     /* 2231651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231654 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2231657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2231671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231690 */     // GIR_Coverage, 48348,
     /* 2231690 */     GIR_EraseRootFromParent_Done,
     /* 2231691 */   // Label 29646: @2231691
     /* 2231691 */   GIM_Try, /*On fail goto*//*Label 29647*/ GIMT_Encode4(2231736), // Rule ID 48349 //
     /* 2231696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231699 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2231702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2231716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231735 */     // GIR_Coverage, 48349,
     /* 2231735 */     GIR_EraseRootFromParent_Done,
     /* 2231736 */   // Label 29647: @2231736
     /* 2231736 */   GIM_Reject,
     /* 2231737 */ // Label 29645: @2231737
     /* 2231737 */ GIM_Reject,
     /* 2231738 */ // Label 29603: @2231738
     /* 2231738 */ GIM_Try, /*On fail goto*//*Label 29648*/ GIMT_Encode4(2231852),
     /* 2231743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2231746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2231749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2231753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2231757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2231761 */   GIM_Try, /*On fail goto*//*Label 29649*/ GIMT_Encode4(2231806), // Rule ID 48392 //
     /* 2231766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2231769 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2231772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2231786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231805 */     // GIR_Coverage, 48392,
     /* 2231805 */     GIR_EraseRootFromParent_Done,
     /* 2231806 */   // Label 29649: @2231806
     /* 2231806 */   GIM_Try, /*On fail goto*//*Label 29650*/ GIMT_Encode4(2231851), // Rule ID 48393 //
     /* 2231811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2231814 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2231817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2231831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231850 */     // GIR_Coverage, 48393,
     /* 2231850 */     GIR_EraseRootFromParent_Done,
     /* 2231851 */   // Label 29650: @2231851
     /* 2231851 */   GIM_Reject,
     /* 2231852 */ // Label 29648: @2231852
     /* 2231852 */ GIM_Reject,
     /* 2231853 */ // Label 29604: @2231853
     /* 2231853 */ GIM_Try, /*On fail goto*//*Label 29651*/ GIMT_Encode4(2231967),
     /* 2231858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2231861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2231864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231876 */   GIM_Try, /*On fail goto*//*Label 29652*/ GIMT_Encode4(2231921), // Rule ID 48324 //
     /* 2231881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231884 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2231887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231920 */     // GIR_Coverage, 48324,
     /* 2231920 */     GIR_EraseRootFromParent_Done,
     /* 2231921 */   // Label 29652: @2231921
     /* 2231921 */   GIM_Try, /*On fail goto*//*Label 29653*/ GIMT_Encode4(2231966), // Rule ID 48325 //
     /* 2231926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231929 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2231932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231965 */     // GIR_Coverage, 48325,
     /* 2231965 */     GIR_EraseRootFromParent_Done,
     /* 2231966 */   // Label 29653: @2231966
     /* 2231966 */   GIM_Reject,
     /* 2231967 */ // Label 29651: @2231967
     /* 2231967 */ GIM_Reject,
     /* 2231968 */ // Label 29605: @2231968
     /* 2231968 */ GIM_Try, /*On fail goto*//*Label 29654*/ GIMT_Encode4(2232082),
     /* 2231973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2231976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2231979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231991 */   GIM_Try, /*On fail goto*//*Label 29655*/ GIMT_Encode4(2232036), // Rule ID 48344 //
     /* 2231996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231999 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2232002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232035 */     // GIR_Coverage, 48344,
     /* 2232035 */     GIR_EraseRootFromParent_Done,
     /* 2232036 */   // Label 29655: @2232036
     /* 2232036 */   GIM_Try, /*On fail goto*//*Label 29656*/ GIMT_Encode4(2232081), // Rule ID 48345 //
     /* 2232041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232044 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2232047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232080 */     // GIR_Coverage, 48345,
     /* 2232080 */     GIR_EraseRootFromParent_Done,
     /* 2232081 */   // Label 29656: @2232081
     /* 2232081 */   GIM_Reject,
     /* 2232082 */ // Label 29654: @2232082
     /* 2232082 */ GIM_Reject,
     /* 2232083 */ // Label 29606: @2232083
     /* 2232083 */ GIM_Try, /*On fail goto*//*Label 29657*/ GIMT_Encode4(2232197),
     /* 2232088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2232091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2232094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232106 */   GIM_Try, /*On fail goto*//*Label 29658*/ GIMT_Encode4(2232151), // Rule ID 48380 //
     /* 2232111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232114 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2232117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232150 */     // GIR_Coverage, 48380,
     /* 2232150 */     GIR_EraseRootFromParent_Done,
     /* 2232151 */   // Label 29658: @2232151
     /* 2232151 */   GIM_Try, /*On fail goto*//*Label 29659*/ GIMT_Encode4(2232196), // Rule ID 48381 //
     /* 2232156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232159 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2232162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232195 */     // GIR_Coverage, 48381,
     /* 2232195 */     GIR_EraseRootFromParent_Done,
     /* 2232196 */   // Label 29659: @2232196
     /* 2232196 */   GIM_Reject,
     /* 2232197 */ // Label 29657: @2232197
     /* 2232197 */ GIM_Reject,
     /* 2232198 */ // Label 29607: @2232198
     /* 2232198 */ GIM_Try, /*On fail goto*//*Label 29660*/ GIMT_Encode4(2232312),
     /* 2232203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2232206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2232209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232221 */   GIM_Try, /*On fail goto*//*Label 29661*/ GIMT_Encode4(2232266), // Rule ID 48396 //
     /* 2232226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2232229 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2232232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232265 */     // GIR_Coverage, 48396,
     /* 2232265 */     GIR_EraseRootFromParent_Done,
     /* 2232266 */   // Label 29661: @2232266
     /* 2232266 */   GIM_Try, /*On fail goto*//*Label 29662*/ GIMT_Encode4(2232311), // Rule ID 48397 //
     /* 2232271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2232274 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2232277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232310 */     // GIR_Coverage, 48397,
     /* 2232310 */     GIR_EraseRootFromParent_Done,
     /* 2232311 */   // Label 29662: @2232311
     /* 2232311 */   GIM_Reject,
     /* 2232312 */ // Label 29660: @2232312
     /* 2232312 */ GIM_Reject,
     /* 2232313 */ // Label 29608: @2232313
     /* 2232313 */ GIM_Try, /*On fail goto*//*Label 29663*/ GIMT_Encode4(2232427),
     /* 2232318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2232321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2232324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232336 */   GIM_Try, /*On fail goto*//*Label 29664*/ GIMT_Encode4(2232381), // Rule ID 48340 //
     /* 2232341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232344 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2232347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232380 */     // GIR_Coverage, 48340,
     /* 2232380 */     GIR_EraseRootFromParent_Done,
     /* 2232381 */   // Label 29664: @2232381
     /* 2232381 */   GIM_Try, /*On fail goto*//*Label 29665*/ GIMT_Encode4(2232426), // Rule ID 48341 //
     /* 2232386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232389 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2232392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232425 */     // GIR_Coverage, 48341,
     /* 2232425 */     GIR_EraseRootFromParent_Done,
     /* 2232426 */   // Label 29665: @2232426
     /* 2232426 */   GIM_Reject,
     /* 2232427 */ // Label 29663: @2232427
     /* 2232427 */ GIM_Reject,
     /* 2232428 */ // Label 29609: @2232428
     /* 2232428 */ GIM_Try, /*On fail goto*//*Label 29666*/ GIMT_Encode4(2232542),
     /* 2232433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2232436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2232439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232451 */   GIM_Try, /*On fail goto*//*Label 29667*/ GIMT_Encode4(2232496), // Rule ID 48368 //
     /* 2232456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232459 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2232462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232495 */     // GIR_Coverage, 48368,
     /* 2232495 */     GIR_EraseRootFromParent_Done,
     /* 2232496 */   // Label 29667: @2232496
     /* 2232496 */   GIM_Try, /*On fail goto*//*Label 29668*/ GIMT_Encode4(2232541), // Rule ID 48369 //
     /* 2232501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232504 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2232507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232540 */     // GIR_Coverage, 48369,
     /* 2232540 */     GIR_EraseRootFromParent_Done,
     /* 2232541 */   // Label 29668: @2232541
     /* 2232541 */   GIM_Reject,
     /* 2232542 */ // Label 29666: @2232542
     /* 2232542 */ GIM_Reject,
     /* 2232543 */ // Label 29610: @2232543
     /* 2232543 */ GIM_Try, /*On fail goto*//*Label 29669*/ GIMT_Encode4(2232657),
     /* 2232548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2232551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2232554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232566 */   GIM_Try, /*On fail goto*//*Label 29670*/ GIMT_Encode4(2232611), // Rule ID 48384 //
     /* 2232571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232574 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2232577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232610 */     // GIR_Coverage, 48384,
     /* 2232610 */     GIR_EraseRootFromParent_Done,
     /* 2232611 */   // Label 29670: @2232611
     /* 2232611 */   GIM_Try, /*On fail goto*//*Label 29671*/ GIMT_Encode4(2232656), // Rule ID 48385 //
     /* 2232616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232619 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2232622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232655 */     // GIR_Coverage, 48385,
     /* 2232655 */     GIR_EraseRootFromParent_Done,
     /* 2232656 */   // Label 29671: @2232656
     /* 2232656 */   GIM_Reject,
     /* 2232657 */ // Label 29669: @2232657
     /* 2232657 */ GIM_Reject,
     /* 2232658 */ // Label 29611: @2232658
     /* 2232658 */ GIM_Try, /*On fail goto*//*Label 29672*/ GIMT_Encode4(2232772),
     /* 2232663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2232666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2232669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2232673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2232677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2232681 */   GIM_Try, /*On fail goto*//*Label 29673*/ GIMT_Encode4(2232726), // Rule ID 48400 //
     /* 2232686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2232689 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2232692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2232706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232725 */     // GIR_Coverage, 48400,
     /* 2232725 */     GIR_EraseRootFromParent_Done,
     /* 2232726 */   // Label 29673: @2232726
     /* 2232726 */   GIM_Try, /*On fail goto*//*Label 29674*/ GIMT_Encode4(2232771), // Rule ID 48401 //
     /* 2232731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2232734 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2232737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2232751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232770 */     // GIR_Coverage, 48401,
     /* 2232770 */     GIR_EraseRootFromParent_Done,
     /* 2232771 */   // Label 29674: @2232771
     /* 2232771 */   GIM_Reject,
     /* 2232772 */ // Label 29672: @2232772
     /* 2232772 */ GIM_Reject,
     /* 2232773 */ // Label 29612: @2232773
     /* 2232773 */ GIM_Try, /*On fail goto*//*Label 29675*/ GIMT_Encode4(2232887),
     /* 2232778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2232781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2232784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232796 */   GIM_Try, /*On fail goto*//*Label 29676*/ GIMT_Encode4(2232841), // Rule ID 48356 //
     /* 2232801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232804 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2232807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232840 */     // GIR_Coverage, 48356,
     /* 2232840 */     GIR_EraseRootFromParent_Done,
     /* 2232841 */   // Label 29676: @2232841
     /* 2232841 */   GIM_Try, /*On fail goto*//*Label 29677*/ GIMT_Encode4(2232886), // Rule ID 48357 //
     /* 2232846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232849 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2232852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232885 */     // GIR_Coverage, 48357,
     /* 2232885 */     GIR_EraseRootFromParent_Done,
     /* 2232886 */   // Label 29677: @2232886
     /* 2232886 */   GIM_Reject,
     /* 2232887 */ // Label 29675: @2232887
     /* 2232887 */ GIM_Reject,
     /* 2232888 */ // Label 29613: @2232888
     /* 2232888 */ GIM_Try, /*On fail goto*//*Label 29678*/ GIMT_Encode4(2233002),
     /* 2232893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2232896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2232899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232907 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232911 */   GIM_Try, /*On fail goto*//*Label 29679*/ GIMT_Encode4(2232956), // Rule ID 48372 //
     /* 2232916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232919 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2232922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232955 */     // GIR_Coverage, 48372,
     /* 2232955 */     GIR_EraseRootFromParent_Done,
     /* 2232956 */   // Label 29679: @2232956
     /* 2232956 */   GIM_Try, /*On fail goto*//*Label 29680*/ GIMT_Encode4(2233001), // Rule ID 48373 //
     /* 2232961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232964 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2232967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233000 */     // GIR_Coverage, 48373,
     /* 2233000 */     GIR_EraseRootFromParent_Done,
     /* 2233001 */   // Label 29680: @2233001
     /* 2233001 */   GIM_Reject,
     /* 2233002 */ // Label 29678: @2233002
     /* 2233002 */ GIM_Reject,
     /* 2233003 */ // Label 29614: @2233003
     /* 2233003 */ GIM_Try, /*On fail goto*//*Label 29681*/ GIMT_Encode4(2233117),
     /* 2233008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2233011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2233014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233026 */   GIM_Try, /*On fail goto*//*Label 29682*/ GIMT_Encode4(2233071), // Rule ID 48388 //
     /* 2233031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233034 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2233037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233070 */     // GIR_Coverage, 48388,
     /* 2233070 */     GIR_EraseRootFromParent_Done,
     /* 2233071 */   // Label 29682: @2233071
     /* 2233071 */   GIM_Try, /*On fail goto*//*Label 29683*/ GIMT_Encode4(2233116), // Rule ID 48389 //
     /* 2233076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233079 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2233082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233115 */     // GIR_Coverage, 48389,
     /* 2233115 */     GIR_EraseRootFromParent_Done,
     /* 2233116 */   // Label 29683: @2233116
     /* 2233116 */   GIM_Reject,
     /* 2233117 */ // Label 29681: @2233117
     /* 2233117 */ GIM_Reject,
     /* 2233118 */ // Label 29615: @2233118
     /* 2233118 */ GIM_Try, /*On fail goto*//*Label 29684*/ GIMT_Encode4(2233232),
     /* 2233123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2233126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2233129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233141 */   GIM_Try, /*On fail goto*//*Label 29685*/ GIMT_Encode4(2233186), // Rule ID 48360 //
     /* 2233146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233149 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2233152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233185 */     // GIR_Coverage, 48360,
     /* 2233185 */     GIR_EraseRootFromParent_Done,
     /* 2233186 */   // Label 29685: @2233186
     /* 2233186 */   GIM_Try, /*On fail goto*//*Label 29686*/ GIMT_Encode4(2233231), // Rule ID 48361 //
     /* 2233191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233194 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2233197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233230 */     // GIR_Coverage, 48361,
     /* 2233230 */     GIR_EraseRootFromParent_Done,
     /* 2233231 */   // Label 29686: @2233231
     /* 2233231 */   GIM_Reject,
     /* 2233232 */ // Label 29684: @2233232
     /* 2233232 */ GIM_Reject,
     /* 2233233 */ // Label 29616: @2233233
     /* 2233233 */ GIM_Try, /*On fail goto*//*Label 29687*/ GIMT_Encode4(2233347),
     /* 2233238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2233241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2233244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233256 */   GIM_Try, /*On fail goto*//*Label 29688*/ GIMT_Encode4(2233301), // Rule ID 48376 //
     /* 2233261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233264 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2233267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233300 */     // GIR_Coverage, 48376,
     /* 2233300 */     GIR_EraseRootFromParent_Done,
     /* 2233301 */   // Label 29688: @2233301
     /* 2233301 */   GIM_Try, /*On fail goto*//*Label 29689*/ GIMT_Encode4(2233346), // Rule ID 48377 //
     /* 2233306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233309 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2233312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233345 */     // GIR_Coverage, 48377,
     /* 2233345 */     GIR_EraseRootFromParent_Done,
     /* 2233346 */   // Label 29689: @2233346
     /* 2233346 */   GIM_Reject,
     /* 2233347 */ // Label 29687: @2233347
     /* 2233347 */ GIM_Reject,
     /* 2233348 */ // Label 29617: @2233348
     /* 2233348 */ GIM_Try, /*On fail goto*//*Label 29690*/ GIMT_Encode4(2233462),
     /* 2233353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2233356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2233359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233367 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233371 */   GIM_Try, /*On fail goto*//*Label 29691*/ GIMT_Encode4(2233416), // Rule ID 48364 //
     /* 2233376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233379 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2233382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233415 */     // GIR_Coverage, 48364,
     /* 2233415 */     GIR_EraseRootFromParent_Done,
     /* 2233416 */   // Label 29691: @2233416
     /* 2233416 */   GIM_Try, /*On fail goto*//*Label 29692*/ GIMT_Encode4(2233461), // Rule ID 48365 //
     /* 2233421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233424 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2233427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233460 */     // GIR_Coverage, 48365,
     /* 2233460 */     GIR_EraseRootFromParent_Done,
     /* 2233461 */   // Label 29692: @2233461
     /* 2233461 */   GIM_Reject,
     /* 2233462 */ // Label 29690: @2233462
     /* 2233462 */ GIM_Reject,
     /* 2233463 */ // Label 29618: @2233463
     /* 2233463 */ GIM_Reject,
     /* 2233464 */ // Label 46: @2233464
     /* 2233464 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29717*/ GIMT_Encode4(2236403),
     /* 2233475 */ /*GILLT_s32*//*Label 29693*/ GIMT_Encode4(2233599),
     /* 2233479 */ /*GILLT_s64*//*Label 29694*/ GIMT_Encode4(2233736), GIMT_Encode4(0),
     /* 2233487 */ /*GILLT_nxv1s8*//*Label 29695*/ GIMT_Encode4(2233873),
     /* 2233491 */ /*GILLT_nxv1s16*//*Label 29696*/ GIMT_Encode4(2233988),
     /* 2233495 */ /*GILLT_nxv1s32*//*Label 29697*/ GIMT_Encode4(2234103),
     /* 2233499 */ /*GILLT_nxv1s64*//*Label 29698*/ GIMT_Encode4(2234218), GIMT_Encode4(0),
     /* 2233507 */ /*GILLT_nxv2s8*//*Label 29699*/ GIMT_Encode4(2234333),
     /* 2233511 */ /*GILLT_nxv2s16*//*Label 29700*/ GIMT_Encode4(2234448),
     /* 2233515 */ /*GILLT_nxv2s32*//*Label 29701*/ GIMT_Encode4(2234563),
     /* 2233519 */ /*GILLT_nxv2s64*//*Label 29702*/ GIMT_Encode4(2234678), GIMT_Encode4(0),
     /* 2233527 */ /*GILLT_nxv4s8*//*Label 29703*/ GIMT_Encode4(2234793),
     /* 2233531 */ /*GILLT_nxv4s16*//*Label 29704*/ GIMT_Encode4(2234908),
     /* 2233535 */ /*GILLT_nxv4s32*//*Label 29705*/ GIMT_Encode4(2235023),
     /* 2233539 */ /*GILLT_nxv4s64*//*Label 29706*/ GIMT_Encode4(2235138), GIMT_Encode4(0),
     /* 2233547 */ /*GILLT_nxv8s8*//*Label 29707*/ GIMT_Encode4(2235253),
     /* 2233551 */ /*GILLT_nxv8s16*//*Label 29708*/ GIMT_Encode4(2235368),
     /* 2233555 */ /*GILLT_nxv8s32*//*Label 29709*/ GIMT_Encode4(2235483),
     /* 2233559 */ /*GILLT_nxv8s64*//*Label 29710*/ GIMT_Encode4(2235598), GIMT_Encode4(0),
     /* 2233567 */ /*GILLT_nxv16s8*//*Label 29711*/ GIMT_Encode4(2235713),
     /* 2233571 */ /*GILLT_nxv16s16*//*Label 29712*/ GIMT_Encode4(2235828),
     /* 2233575 */ /*GILLT_nxv16s32*//*Label 29713*/ GIMT_Encode4(2235943), GIMT_Encode4(0),
     /* 2233583 */ /*GILLT_nxv32s8*//*Label 29714*/ GIMT_Encode4(2236058),
     /* 2233587 */ /*GILLT_nxv32s16*//*Label 29715*/ GIMT_Encode4(2236173), GIMT_Encode4(0),
     /* 2233595 */ /*GILLT_nxv64s8*//*Label 29716*/ GIMT_Encode4(2236288),
     /* 2233599 */ // Label 29693: @2233599
     /* 2233599 */ GIM_Try, /*On fail goto*//*Label 29718*/ GIMT_Encode4(2233735),
     /* 2233604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2233607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2233610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233618 */   GIM_Try, /*On fail goto*//*Label 29719*/ GIMT_Encode4(2233652), // Rule ID 2465 //
     /* 2233623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2233626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2233630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2233638 */     // MIs[1] Operand 1
     /* 2233638 */     // No operand predicates
     /* 2233638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233640 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2233640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2233643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2233650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233651 */     // GIR_Coverage, 2465,
     /* 2233651 */     GIR_EraseRootFromParent_Done,
     /* 2233652 */   // Label 29719: @2233652
     /* 2233652 */   GIM_Try, /*On fail goto*//*Label 29720*/ GIMT_Encode4(2233686), // Rule ID 62556 //
     /* 2233657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2233660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2233664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2233672 */     // MIs[1] Operand 1
     /* 2233672 */     // No operand predicates
     /* 2233672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233674 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2233674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2233677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2233684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233685 */     // GIR_Coverage, 62556,
     /* 2233685 */     GIR_EraseRootFromParent_Done,
     /* 2233686 */   // Label 29720: @2233686
     /* 2233686 */   GIM_Try, /*On fail goto*//*Label 29721*/ GIMT_Encode4(2233715), // Rule ID 2463 //
     /* 2233691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2233694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2233701 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2233701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2233704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2233713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233714 */     // GIR_Coverage, 2463,
     /* 2233714 */     GIR_EraseRootFromParent_Done,
     /* 2233715 */   // Label 29721: @2233715
     /* 2233715 */   GIM_Try, /*On fail goto*//*Label 29722*/ GIMT_Encode4(2233734), // Rule ID 64450 //
     /* 2233720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2233723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233727 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2233727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2233732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233733 */     // GIR_Coverage, 64450,
     /* 2233733 */     GIR_Done,
     /* 2233734 */   // Label 29722: @2233734
     /* 2233734 */   GIM_Reject,
     /* 2233735 */ // Label 29718: @2233735
     /* 2233735 */ GIM_Reject,
     /* 2233736 */ // Label 29694: @2233736
     /* 2233736 */ GIM_Try, /*On fail goto*//*Label 29723*/ GIMT_Encode4(2233872),
     /* 2233741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2233744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2233747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233755 */   GIM_Try, /*On fail goto*//*Label 29724*/ GIMT_Encode4(2233789), // Rule ID 2464 //
     /* 2233760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2233763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2233767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2233775 */     // MIs[1] Operand 1
     /* 2233775 */     // No operand predicates
     /* 2233775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233777 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2233777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2233780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2233787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233788 */     // GIR_Coverage, 2464,
     /* 2233788 */     GIR_EraseRootFromParent_Done,
     /* 2233789 */   // Label 29724: @2233789
     /* 2233789 */   GIM_Try, /*On fail goto*//*Label 29725*/ GIMT_Encode4(2233823), // Rule ID 62555 //
     /* 2233794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2233797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2233801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2233809 */     // MIs[1] Operand 1
     /* 2233809 */     // No operand predicates
     /* 2233809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233811 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2233811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2233814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2233821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233822 */     // GIR_Coverage, 62555,
     /* 2233822 */     GIR_EraseRootFromParent_Done,
     /* 2233823 */   // Label 29725: @2233823
     /* 2233823 */   GIM_Try, /*On fail goto*//*Label 29726*/ GIMT_Encode4(2233852), // Rule ID 2462 //
     /* 2233828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2233831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2233838 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2233838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2233841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2233850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233851 */     // GIR_Coverage, 2462,
     /* 2233851 */     GIR_EraseRootFromParent_Done,
     /* 2233852 */   // Label 29726: @2233852
     /* 2233852 */   GIM_Try, /*On fail goto*//*Label 29727*/ GIMT_Encode4(2233871), // Rule ID 64449 //
     /* 2233857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2233860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233864 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2233864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2233869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233870 */     // GIR_Coverage, 64449,
     /* 2233870 */     GIR_Done,
     /* 2233871 */   // Label 29727: @2233871
     /* 2233871 */   GIM_Reject,
     /* 2233872 */ // Label 29723: @2233872
     /* 2233872 */ GIM_Reject,
     /* 2233873 */ // Label 29695: @2233873
     /* 2233873 */ GIM_Try, /*On fail goto*//*Label 29728*/ GIMT_Encode4(2233987),
     /* 2233878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2233881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2233884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233896 */   GIM_Try, /*On fail goto*//*Label 29729*/ GIMT_Encode4(2233941), // Rule ID 59408 //
     /* 2233901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233904 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2233907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2233921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233940 */     // GIR_Coverage, 59408,
     /* 2233940 */     GIR_EraseRootFromParent_Done,
     /* 2233941 */   // Label 29729: @2233941
     /* 2233941 */   GIM_Try, /*On fail goto*//*Label 29730*/ GIMT_Encode4(2233986), // Rule ID 59409 //
     /* 2233946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233949 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2233952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2233966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233985 */     // GIR_Coverage, 59409,
     /* 2233985 */     GIR_EraseRootFromParent_Done,
     /* 2233986 */   // Label 29730: @2233986
     /* 2233986 */   GIM_Reject,
     /* 2233987 */ // Label 29728: @2233987
     /* 2233987 */ GIM_Reject,
     /* 2233988 */ // Label 29696: @2233988
     /* 2233988 */ GIM_Try, /*On fail goto*//*Label 29731*/ GIMT_Encode4(2234102),
     /* 2233993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2233996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2233999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234011 */   GIM_Try, /*On fail goto*//*Label 29732*/ GIMT_Encode4(2234056), // Rule ID 59420 //
     /* 2234016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234019 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2234022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234055 */     // GIR_Coverage, 59420,
     /* 2234055 */     GIR_EraseRootFromParent_Done,
     /* 2234056 */   // Label 29732: @2234056
     /* 2234056 */   GIM_Try, /*On fail goto*//*Label 29733*/ GIMT_Encode4(2234101), // Rule ID 59421 //
     /* 2234061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234064 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2234067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234100 */     // GIR_Coverage, 59421,
     /* 2234100 */     GIR_EraseRootFromParent_Done,
     /* 2234101 */   // Label 29733: @2234101
     /* 2234101 */   GIM_Reject,
     /* 2234102 */ // Label 29731: @2234102
     /* 2234102 */ GIM_Reject,
     /* 2234103 */ // Label 29697: @2234103
     /* 2234103 */ GIM_Try, /*On fail goto*//*Label 29734*/ GIMT_Encode4(2234217),
     /* 2234108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2234111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2234114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234126 */   GIM_Try, /*On fail goto*//*Label 29735*/ GIMT_Encode4(2234171), // Rule ID 59428 //
     /* 2234131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234134 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2234137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234170 */     // GIR_Coverage, 59428,
     /* 2234170 */     GIR_EraseRootFromParent_Done,
     /* 2234171 */   // Label 29735: @2234171
     /* 2234171 */   GIM_Try, /*On fail goto*//*Label 29736*/ GIMT_Encode4(2234216), // Rule ID 59429 //
     /* 2234176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234179 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2234182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234215 */     // GIR_Coverage, 59429,
     /* 2234215 */     GIR_EraseRootFromParent_Done,
     /* 2234216 */   // Label 29736: @2234216
     /* 2234216 */   GIM_Reject,
     /* 2234217 */ // Label 29734: @2234217
     /* 2234217 */ GIM_Reject,
     /* 2234218 */ // Label 29698: @2234218
     /* 2234218 */ GIM_Try, /*On fail goto*//*Label 29737*/ GIMT_Encode4(2234332),
     /* 2234223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2234226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2234229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234241 */   GIM_Try, /*On fail goto*//*Label 29738*/ GIMT_Encode4(2234286), // Rule ID 59444 //
     /* 2234246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2234249 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2234252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234285 */     // GIR_Coverage, 59444,
     /* 2234285 */     GIR_EraseRootFromParent_Done,
     /* 2234286 */   // Label 29738: @2234286
     /* 2234286 */   GIM_Try, /*On fail goto*//*Label 29739*/ GIMT_Encode4(2234331), // Rule ID 59445 //
     /* 2234291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2234294 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2234297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234330 */     // GIR_Coverage, 59445,
     /* 2234330 */     GIR_EraseRootFromParent_Done,
     /* 2234331 */   // Label 29739: @2234331
     /* 2234331 */   GIM_Reject,
     /* 2234332 */ // Label 29737: @2234332
     /* 2234332 */ GIM_Reject,
     /* 2234333 */ // Label 29699: @2234333
     /* 2234333 */ GIM_Try, /*On fail goto*//*Label 29740*/ GIMT_Encode4(2234447),
     /* 2234338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2234341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2234344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234356 */   GIM_Try, /*On fail goto*//*Label 29741*/ GIMT_Encode4(2234401), // Rule ID 59412 //
     /* 2234361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234364 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2234367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234400 */     // GIR_Coverage, 59412,
     /* 2234400 */     GIR_EraseRootFromParent_Done,
     /* 2234401 */   // Label 29741: @2234401
     /* 2234401 */   GIM_Try, /*On fail goto*//*Label 29742*/ GIMT_Encode4(2234446), // Rule ID 59413 //
     /* 2234406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234409 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2234412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234445 */     // GIR_Coverage, 59413,
     /* 2234445 */     GIR_EraseRootFromParent_Done,
     /* 2234446 */   // Label 29742: @2234446
     /* 2234446 */   GIM_Reject,
     /* 2234447 */ // Label 29740: @2234447
     /* 2234447 */ GIM_Reject,
     /* 2234448 */ // Label 29700: @2234448
     /* 2234448 */ GIM_Try, /*On fail goto*//*Label 29743*/ GIMT_Encode4(2234562),
     /* 2234453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2234456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2234459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234471 */   GIM_Try, /*On fail goto*//*Label 29744*/ GIMT_Encode4(2234516), // Rule ID 59424 //
     /* 2234476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234479 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2234482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234515 */     // GIR_Coverage, 59424,
     /* 2234515 */     GIR_EraseRootFromParent_Done,
     /* 2234516 */   // Label 29744: @2234516
     /* 2234516 */   GIM_Try, /*On fail goto*//*Label 29745*/ GIMT_Encode4(2234561), // Rule ID 59425 //
     /* 2234521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234524 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2234527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234560 */     // GIR_Coverage, 59425,
     /* 2234560 */     GIR_EraseRootFromParent_Done,
     /* 2234561 */   // Label 29745: @2234561
     /* 2234561 */   GIM_Reject,
     /* 2234562 */ // Label 29743: @2234562
     /* 2234562 */ GIM_Reject,
     /* 2234563 */ // Label 29701: @2234563
     /* 2234563 */ GIM_Try, /*On fail goto*//*Label 29746*/ GIMT_Encode4(2234677),
     /* 2234568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2234571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2234574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234586 */   GIM_Try, /*On fail goto*//*Label 29747*/ GIMT_Encode4(2234631), // Rule ID 59440 //
     /* 2234591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234594 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2234597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234630 */     // GIR_Coverage, 59440,
     /* 2234630 */     GIR_EraseRootFromParent_Done,
     /* 2234631 */   // Label 29747: @2234631
     /* 2234631 */   GIM_Try, /*On fail goto*//*Label 29748*/ GIMT_Encode4(2234676), // Rule ID 59441 //
     /* 2234636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234639 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2234642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234675 */     // GIR_Coverage, 59441,
     /* 2234675 */     GIR_EraseRootFromParent_Done,
     /* 2234676 */   // Label 29748: @2234676
     /* 2234676 */   GIM_Reject,
     /* 2234677 */ // Label 29746: @2234677
     /* 2234677 */ GIM_Reject,
     /* 2234678 */ // Label 29702: @2234678
     /* 2234678 */ GIM_Try, /*On fail goto*//*Label 29749*/ GIMT_Encode4(2234792),
     /* 2234683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2234686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2234689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2234693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2234697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2234701 */   GIM_Try, /*On fail goto*//*Label 29750*/ GIMT_Encode4(2234746), // Rule ID 59484 //
     /* 2234706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2234709 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2234712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2234726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234745 */     // GIR_Coverage, 59484,
     /* 2234745 */     GIR_EraseRootFromParent_Done,
     /* 2234746 */   // Label 29750: @2234746
     /* 2234746 */   GIM_Try, /*On fail goto*//*Label 29751*/ GIMT_Encode4(2234791), // Rule ID 59485 //
     /* 2234751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2234754 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2234757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2234771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234790 */     // GIR_Coverage, 59485,
     /* 2234790 */     GIR_EraseRootFromParent_Done,
     /* 2234791 */   // Label 29751: @2234791
     /* 2234791 */   GIM_Reject,
     /* 2234792 */ // Label 29749: @2234792
     /* 2234792 */ GIM_Reject,
     /* 2234793 */ // Label 29703: @2234793
     /* 2234793 */ GIM_Try, /*On fail goto*//*Label 29752*/ GIMT_Encode4(2234907),
     /* 2234798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2234801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2234804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234816 */   GIM_Try, /*On fail goto*//*Label 29753*/ GIMT_Encode4(2234861), // Rule ID 59416 //
     /* 2234821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234824 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2234827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234860 */     // GIR_Coverage, 59416,
     /* 2234860 */     GIR_EraseRootFromParent_Done,
     /* 2234861 */   // Label 29753: @2234861
     /* 2234861 */   GIM_Try, /*On fail goto*//*Label 29754*/ GIMT_Encode4(2234906), // Rule ID 59417 //
     /* 2234866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234869 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2234872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234905 */     // GIR_Coverage, 59417,
     /* 2234905 */     GIR_EraseRootFromParent_Done,
     /* 2234906 */   // Label 29754: @2234906
     /* 2234906 */   GIM_Reject,
     /* 2234907 */ // Label 29752: @2234907
     /* 2234907 */ GIM_Reject,
     /* 2234908 */ // Label 29704: @2234908
     /* 2234908 */ GIM_Try, /*On fail goto*//*Label 29755*/ GIMT_Encode4(2235022),
     /* 2234913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2234916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2234919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234931 */   GIM_Try, /*On fail goto*//*Label 29756*/ GIMT_Encode4(2234976), // Rule ID 59436 //
     /* 2234936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234939 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2234942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234975 */     // GIR_Coverage, 59436,
     /* 2234975 */     GIR_EraseRootFromParent_Done,
     /* 2234976 */   // Label 29756: @2234976
     /* 2234976 */   GIM_Try, /*On fail goto*//*Label 29757*/ GIMT_Encode4(2235021), // Rule ID 59437 //
     /* 2234981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234984 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2234987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235020 */     // GIR_Coverage, 59437,
     /* 2235020 */     GIR_EraseRootFromParent_Done,
     /* 2235021 */   // Label 29757: @2235021
     /* 2235021 */   GIM_Reject,
     /* 2235022 */ // Label 29755: @2235022
     /* 2235022 */ GIM_Reject,
     /* 2235023 */ // Label 29705: @2235023
     /* 2235023 */ GIM_Try, /*On fail goto*//*Label 29758*/ GIMT_Encode4(2235137),
     /* 2235028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2235031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2235034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235046 */   GIM_Try, /*On fail goto*//*Label 29759*/ GIMT_Encode4(2235091), // Rule ID 59472 //
     /* 2235051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235054 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2235057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235090 */     // GIR_Coverage, 59472,
     /* 2235090 */     GIR_EraseRootFromParent_Done,
     /* 2235091 */   // Label 29759: @2235091
     /* 2235091 */   GIM_Try, /*On fail goto*//*Label 29760*/ GIMT_Encode4(2235136), // Rule ID 59473 //
     /* 2235096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235099 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2235102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235135 */     // GIR_Coverage, 59473,
     /* 2235135 */     GIR_EraseRootFromParent_Done,
     /* 2235136 */   // Label 29760: @2235136
     /* 2235136 */   GIM_Reject,
     /* 2235137 */ // Label 29758: @2235137
     /* 2235137 */ GIM_Reject,
     /* 2235138 */ // Label 29706: @2235138
     /* 2235138 */ GIM_Try, /*On fail goto*//*Label 29761*/ GIMT_Encode4(2235252),
     /* 2235143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2235146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2235149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235161 */   GIM_Try, /*On fail goto*//*Label 29762*/ GIMT_Encode4(2235206), // Rule ID 59488 //
     /* 2235166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235169 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2235172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235205 */     // GIR_Coverage, 59488,
     /* 2235205 */     GIR_EraseRootFromParent_Done,
     /* 2235206 */   // Label 29762: @2235206
     /* 2235206 */   GIM_Try, /*On fail goto*//*Label 29763*/ GIMT_Encode4(2235251), // Rule ID 59489 //
     /* 2235211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2235214 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2235217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235250 */     // GIR_Coverage, 59489,
     /* 2235250 */     GIR_EraseRootFromParent_Done,
     /* 2235251 */   // Label 29763: @2235251
     /* 2235251 */   GIM_Reject,
     /* 2235252 */ // Label 29761: @2235252
     /* 2235252 */ GIM_Reject,
     /* 2235253 */ // Label 29707: @2235253
     /* 2235253 */ GIM_Try, /*On fail goto*//*Label 29764*/ GIMT_Encode4(2235367),
     /* 2235258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2235261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2235264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235276 */   GIM_Try, /*On fail goto*//*Label 29765*/ GIMT_Encode4(2235321), // Rule ID 59432 //
     /* 2235281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235284 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2235287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235320 */     // GIR_Coverage, 59432,
     /* 2235320 */     GIR_EraseRootFromParent_Done,
     /* 2235321 */   // Label 29765: @2235321
     /* 2235321 */   GIM_Try, /*On fail goto*//*Label 29766*/ GIMT_Encode4(2235366), // Rule ID 59433 //
     /* 2235326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235329 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2235332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235365 */     // GIR_Coverage, 59433,
     /* 2235365 */     GIR_EraseRootFromParent_Done,
     /* 2235366 */   // Label 29766: @2235366
     /* 2235366 */   GIM_Reject,
     /* 2235367 */ // Label 29764: @2235367
     /* 2235367 */ GIM_Reject,
     /* 2235368 */ // Label 29708: @2235368
     /* 2235368 */ GIM_Try, /*On fail goto*//*Label 29767*/ GIMT_Encode4(2235482),
     /* 2235373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2235376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2235379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235391 */   GIM_Try, /*On fail goto*//*Label 29768*/ GIMT_Encode4(2235436), // Rule ID 59460 //
     /* 2235396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235399 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2235402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235435 */     // GIR_Coverage, 59460,
     /* 2235435 */     GIR_EraseRootFromParent_Done,
     /* 2235436 */   // Label 29768: @2235436
     /* 2235436 */   GIM_Try, /*On fail goto*//*Label 29769*/ GIMT_Encode4(2235481), // Rule ID 59461 //
     /* 2235441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235444 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2235447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235480 */     // GIR_Coverage, 59461,
     /* 2235480 */     GIR_EraseRootFromParent_Done,
     /* 2235481 */   // Label 29769: @2235481
     /* 2235481 */   GIM_Reject,
     /* 2235482 */ // Label 29767: @2235482
     /* 2235482 */ GIM_Reject,
     /* 2235483 */ // Label 29709: @2235483
     /* 2235483 */ GIM_Try, /*On fail goto*//*Label 29770*/ GIMT_Encode4(2235597),
     /* 2235488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2235491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2235494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235506 */   GIM_Try, /*On fail goto*//*Label 29771*/ GIMT_Encode4(2235551), // Rule ID 59476 //
     /* 2235511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235514 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2235517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235550 */     // GIR_Coverage, 59476,
     /* 2235550 */     GIR_EraseRootFromParent_Done,
     /* 2235551 */   // Label 29771: @2235551
     /* 2235551 */   GIM_Try, /*On fail goto*//*Label 29772*/ GIMT_Encode4(2235596), // Rule ID 59477 //
     /* 2235556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235559 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2235562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235595 */     // GIR_Coverage, 59477,
     /* 2235595 */     GIR_EraseRootFromParent_Done,
     /* 2235596 */   // Label 29772: @2235596
     /* 2235596 */   GIM_Reject,
     /* 2235597 */ // Label 29770: @2235597
     /* 2235597 */ GIM_Reject,
     /* 2235598 */ // Label 29710: @2235598
     /* 2235598 */ GIM_Try, /*On fail goto*//*Label 29773*/ GIMT_Encode4(2235712),
     /* 2235603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2235606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2235609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2235613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2235617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2235621 */   GIM_Try, /*On fail goto*//*Label 29774*/ GIMT_Encode4(2235666), // Rule ID 59492 //
     /* 2235626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235629 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2235632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2235646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235665 */     // GIR_Coverage, 59492,
     /* 2235665 */     GIR_EraseRootFromParent_Done,
     /* 2235666 */   // Label 29774: @2235666
     /* 2235666 */   GIM_Try, /*On fail goto*//*Label 29775*/ GIMT_Encode4(2235711), // Rule ID 59493 //
     /* 2235671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2235674 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2235677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2235691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235710 */     // GIR_Coverage, 59493,
     /* 2235710 */     GIR_EraseRootFromParent_Done,
     /* 2235711 */   // Label 29775: @2235711
     /* 2235711 */   GIM_Reject,
     /* 2235712 */ // Label 29773: @2235712
     /* 2235712 */ GIM_Reject,
     /* 2235713 */ // Label 29711: @2235713
     /* 2235713 */ GIM_Try, /*On fail goto*//*Label 29776*/ GIMT_Encode4(2235827),
     /* 2235718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2235721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2235724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235736 */   GIM_Try, /*On fail goto*//*Label 29777*/ GIMT_Encode4(2235781), // Rule ID 59448 //
     /* 2235741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235744 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2235747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235780 */     // GIR_Coverage, 59448,
     /* 2235780 */     GIR_EraseRootFromParent_Done,
     /* 2235781 */   // Label 29777: @2235781
     /* 2235781 */   GIM_Try, /*On fail goto*//*Label 29778*/ GIMT_Encode4(2235826), // Rule ID 59449 //
     /* 2235786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235789 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2235792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235825 */     // GIR_Coverage, 59449,
     /* 2235825 */     GIR_EraseRootFromParent_Done,
     /* 2235826 */   // Label 29778: @2235826
     /* 2235826 */   GIM_Reject,
     /* 2235827 */ // Label 29776: @2235827
     /* 2235827 */ GIM_Reject,
     /* 2235828 */ // Label 29712: @2235828
     /* 2235828 */ GIM_Try, /*On fail goto*//*Label 29779*/ GIMT_Encode4(2235942),
     /* 2235833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2235836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2235839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235851 */   GIM_Try, /*On fail goto*//*Label 29780*/ GIMT_Encode4(2235896), // Rule ID 59464 //
     /* 2235856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235859 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2235862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235895 */     // GIR_Coverage, 59464,
     /* 2235895 */     GIR_EraseRootFromParent_Done,
     /* 2235896 */   // Label 29780: @2235896
     /* 2235896 */   GIM_Try, /*On fail goto*//*Label 29781*/ GIMT_Encode4(2235941), // Rule ID 59465 //
     /* 2235901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235904 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2235907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235940 */     // GIR_Coverage, 59465,
     /* 2235940 */     GIR_EraseRootFromParent_Done,
     /* 2235941 */   // Label 29781: @2235941
     /* 2235941 */   GIM_Reject,
     /* 2235942 */ // Label 29779: @2235942
     /* 2235942 */ GIM_Reject,
     /* 2235943 */ // Label 29713: @2235943
     /* 2235943 */ GIM_Try, /*On fail goto*//*Label 29782*/ GIMT_Encode4(2236057),
     /* 2235948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2235951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2235954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2235958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2235962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2235966 */   GIM_Try, /*On fail goto*//*Label 29783*/ GIMT_Encode4(2236011), // Rule ID 59480 //
     /* 2235971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235974 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2235977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2235991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236010 */     // GIR_Coverage, 59480,
     /* 2236010 */     GIR_EraseRootFromParent_Done,
     /* 2236011 */   // Label 29783: @2236011
     /* 2236011 */   GIM_Try, /*On fail goto*//*Label 29784*/ GIMT_Encode4(2236056), // Rule ID 59481 //
     /* 2236016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236019 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2236022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236055 */     // GIR_Coverage, 59481,
     /* 2236055 */     GIR_EraseRootFromParent_Done,
     /* 2236056 */   // Label 29784: @2236056
     /* 2236056 */   GIM_Reject,
     /* 2236057 */ // Label 29782: @2236057
     /* 2236057 */ GIM_Reject,
     /* 2236058 */ // Label 29714: @2236058
     /* 2236058 */ GIM_Try, /*On fail goto*//*Label 29785*/ GIMT_Encode4(2236172),
     /* 2236063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2236066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2236069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236081 */   GIM_Try, /*On fail goto*//*Label 29786*/ GIMT_Encode4(2236126), // Rule ID 59452 //
     /* 2236086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236089 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2236092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236125 */     // GIR_Coverage, 59452,
     /* 2236125 */     GIR_EraseRootFromParent_Done,
     /* 2236126 */   // Label 29786: @2236126
     /* 2236126 */   GIM_Try, /*On fail goto*//*Label 29787*/ GIMT_Encode4(2236171), // Rule ID 59453 //
     /* 2236131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236134 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2236137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236170 */     // GIR_Coverage, 59453,
     /* 2236170 */     GIR_EraseRootFromParent_Done,
     /* 2236171 */   // Label 29787: @2236171
     /* 2236171 */   GIM_Reject,
     /* 2236172 */ // Label 29785: @2236172
     /* 2236172 */ GIM_Reject,
     /* 2236173 */ // Label 29715: @2236173
     /* 2236173 */ GIM_Try, /*On fail goto*//*Label 29788*/ GIMT_Encode4(2236287),
     /* 2236178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2236181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2236184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236196 */   GIM_Try, /*On fail goto*//*Label 29789*/ GIMT_Encode4(2236241), // Rule ID 59468 //
     /* 2236201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236204 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2236207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236240 */     // GIR_Coverage, 59468,
     /* 2236240 */     GIR_EraseRootFromParent_Done,
     /* 2236241 */   // Label 29789: @2236241
     /* 2236241 */   GIM_Try, /*On fail goto*//*Label 29790*/ GIMT_Encode4(2236286), // Rule ID 59469 //
     /* 2236246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236249 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2236252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236285 */     // GIR_Coverage, 59469,
     /* 2236285 */     GIR_EraseRootFromParent_Done,
     /* 2236286 */   // Label 29790: @2236286
     /* 2236286 */   GIM_Reject,
     /* 2236287 */ // Label 29788: @2236287
     /* 2236287 */ GIM_Reject,
     /* 2236288 */ // Label 29716: @2236288
     /* 2236288 */ GIM_Try, /*On fail goto*//*Label 29791*/ GIMT_Encode4(2236402),
     /* 2236293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2236296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2236299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236311 */   GIM_Try, /*On fail goto*//*Label 29792*/ GIMT_Encode4(2236356), // Rule ID 59456 //
     /* 2236316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236319 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2236322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236355 */     // GIR_Coverage, 59456,
     /* 2236355 */     GIR_EraseRootFromParent_Done,
     /* 2236356 */   // Label 29792: @2236356
     /* 2236356 */   GIM_Try, /*On fail goto*//*Label 29793*/ GIMT_Encode4(2236401), // Rule ID 59457 //
     /* 2236361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236364 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2236367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236400 */     // GIR_Coverage, 59457,
     /* 2236400 */     GIR_EraseRootFromParent_Done,
     /* 2236401 */   // Label 29793: @2236401
     /* 2236401 */   GIM_Reject,
     /* 2236402 */ // Label 29791: @2236402
     /* 2236402 */ GIM_Reject,
     /* 2236403 */ // Label 29717: @2236403
     /* 2236403 */ GIM_Reject,
     /* 2236404 */ // Label 47: @2236404
     /* 2236404 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29818*/ GIMT_Encode4(2239313),
     /* 2236415 */ /*GILLT_s32*//*Label 29794*/ GIMT_Encode4(2236539),
     /* 2236419 */ /*GILLT_s64*//*Label 29795*/ GIMT_Encode4(2236661), GIMT_Encode4(0),
     /* 2236427 */ /*GILLT_nxv1s8*//*Label 29796*/ GIMT_Encode4(2236783),
     /* 2236431 */ /*GILLT_nxv1s16*//*Label 29797*/ GIMT_Encode4(2236898),
     /* 2236435 */ /*GILLT_nxv1s32*//*Label 29798*/ GIMT_Encode4(2237013),
     /* 2236439 */ /*GILLT_nxv1s64*//*Label 29799*/ GIMT_Encode4(2237128), GIMT_Encode4(0),
     /* 2236447 */ /*GILLT_nxv2s8*//*Label 29800*/ GIMT_Encode4(2237243),
     /* 2236451 */ /*GILLT_nxv2s16*//*Label 29801*/ GIMT_Encode4(2237358),
     /* 2236455 */ /*GILLT_nxv2s32*//*Label 29802*/ GIMT_Encode4(2237473),
     /* 2236459 */ /*GILLT_nxv2s64*//*Label 29803*/ GIMT_Encode4(2237588), GIMT_Encode4(0),
     /* 2236467 */ /*GILLT_nxv4s8*//*Label 29804*/ GIMT_Encode4(2237703),
     /* 2236471 */ /*GILLT_nxv4s16*//*Label 29805*/ GIMT_Encode4(2237818),
     /* 2236475 */ /*GILLT_nxv4s32*//*Label 29806*/ GIMT_Encode4(2237933),
     /* 2236479 */ /*GILLT_nxv4s64*//*Label 29807*/ GIMT_Encode4(2238048), GIMT_Encode4(0),
     /* 2236487 */ /*GILLT_nxv8s8*//*Label 29808*/ GIMT_Encode4(2238163),
     /* 2236491 */ /*GILLT_nxv8s16*//*Label 29809*/ GIMT_Encode4(2238278),
     /* 2236495 */ /*GILLT_nxv8s32*//*Label 29810*/ GIMT_Encode4(2238393),
     /* 2236499 */ /*GILLT_nxv8s64*//*Label 29811*/ GIMT_Encode4(2238508), GIMT_Encode4(0),
     /* 2236507 */ /*GILLT_nxv16s8*//*Label 29812*/ GIMT_Encode4(2238623),
     /* 2236511 */ /*GILLT_nxv16s16*//*Label 29813*/ GIMT_Encode4(2238738),
     /* 2236515 */ /*GILLT_nxv16s32*//*Label 29814*/ GIMT_Encode4(2238853), GIMT_Encode4(0),
     /* 2236523 */ /*GILLT_nxv32s8*//*Label 29815*/ GIMT_Encode4(2238968),
     /* 2236527 */ /*GILLT_nxv32s16*//*Label 29816*/ GIMT_Encode4(2239083), GIMT_Encode4(0),
     /* 2236535 */ /*GILLT_nxv64s8*//*Label 29817*/ GIMT_Encode4(2239198),
     /* 2236539 */ // Label 29794: @2236539
     /* 2236539 */ GIM_Try, /*On fail goto*//*Label 29819*/ GIMT_Encode4(2236660),
     /* 2236544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2236547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2236550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2236554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2236558 */   GIM_Try, /*On fail goto*//*Label 29820*/ GIMT_Encode4(2236594), // Rule ID 2467 //
     /* 2236563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2236566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2236574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2236578 */     // MIs[1] Operand 1
     /* 2236578 */     // No operand predicates
     /* 2236578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236580 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2236580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2236583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236587 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2236592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236593 */     // GIR_Coverage, 2467,
     /* 2236593 */     GIR_EraseRootFromParent_Done,
     /* 2236594 */   // Label 29820: @2236594
     /* 2236594 */   GIM_Try, /*On fail goto*//*Label 29821*/ GIMT_Encode4(2236630), // Rule ID 62558 //
     /* 2236599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2236602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2236610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2236614 */     // MIs[1] Operand 1
     /* 2236614 */     // No operand predicates
     /* 2236614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236616 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2236616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2236619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236623 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2236628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236629 */     // GIR_Coverage, 62558,
     /* 2236629 */     GIR_EraseRootFromParent_Done,
     /* 2236630 */   // Label 29821: @2236630
     /* 2236630 */   GIM_Try, /*On fail goto*//*Label 29822*/ GIMT_Encode4(2236659), // Rule ID 2461 //
     /* 2236635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2236638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2236645 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2236645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2236648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2236657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236658 */     // GIR_Coverage, 2461,
     /* 2236658 */     GIR_EraseRootFromParent_Done,
     /* 2236659 */   // Label 29822: @2236659
     /* 2236659 */   GIM_Reject,
     /* 2236660 */ // Label 29819: @2236660
     /* 2236660 */ GIM_Reject,
     /* 2236661 */ // Label 29795: @2236661
     /* 2236661 */ GIM_Try, /*On fail goto*//*Label 29823*/ GIMT_Encode4(2236782),
     /* 2236666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2236669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2236672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2236676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2236680 */   GIM_Try, /*On fail goto*//*Label 29824*/ GIMT_Encode4(2236716), // Rule ID 2466 //
     /* 2236685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2236688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2236696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2236700 */     // MIs[1] Operand 1
     /* 2236700 */     // No operand predicates
     /* 2236700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236702 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2236702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2236705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236709 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2236714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236715 */     // GIR_Coverage, 2466,
     /* 2236715 */     GIR_EraseRootFromParent_Done,
     /* 2236716 */   // Label 29824: @2236716
     /* 2236716 */   GIM_Try, /*On fail goto*//*Label 29825*/ GIMT_Encode4(2236752), // Rule ID 62557 //
     /* 2236721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2236724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2236732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2236736 */     // MIs[1] Operand 1
     /* 2236736 */     // No operand predicates
     /* 2236736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236738 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2236738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2236741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236745 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2236750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236751 */     // GIR_Coverage, 62557,
     /* 2236751 */     GIR_EraseRootFromParent_Done,
     /* 2236752 */   // Label 29825: @2236752
     /* 2236752 */   GIM_Try, /*On fail goto*//*Label 29826*/ GIMT_Encode4(2236781), // Rule ID 2460 //
     /* 2236757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2236760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2236767 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2236767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2236770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2236779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236780 */     // GIR_Coverage, 2460,
     /* 2236780 */     GIR_EraseRootFromParent_Done,
     /* 2236781 */   // Label 29826: @2236781
     /* 2236781 */   GIM_Reject,
     /* 2236782 */ // Label 29823: @2236782
     /* 2236782 */ GIM_Reject,
     /* 2236783 */ // Label 29796: @2236783
     /* 2236783 */ GIM_Try, /*On fail goto*//*Label 29827*/ GIMT_Encode4(2236897),
     /* 2236788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2236791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2236794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236806 */   GIM_Try, /*On fail goto*//*Label 29828*/ GIMT_Encode4(2236851), // Rule ID 59276 //
     /* 2236811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236814 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2236817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2236831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236850 */     // GIR_Coverage, 59276,
     /* 2236850 */     GIR_EraseRootFromParent_Done,
     /* 2236851 */   // Label 29828: @2236851
     /* 2236851 */   GIM_Try, /*On fail goto*//*Label 29829*/ GIMT_Encode4(2236896), // Rule ID 59277 //
     /* 2236856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236859 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2236862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2236876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236895 */     // GIR_Coverage, 59277,
     /* 2236895 */     GIR_EraseRootFromParent_Done,
     /* 2236896 */   // Label 29829: @2236896
     /* 2236896 */   GIM_Reject,
     /* 2236897 */ // Label 29827: @2236897
     /* 2236897 */ GIM_Reject,
     /* 2236898 */ // Label 29797: @2236898
     /* 2236898 */ GIM_Try, /*On fail goto*//*Label 29830*/ GIMT_Encode4(2237012),
     /* 2236903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2236906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2236909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236917 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236921 */   GIM_Try, /*On fail goto*//*Label 29831*/ GIMT_Encode4(2236966), // Rule ID 59288 //
     /* 2236926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236929 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2236932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2236946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236965 */     // GIR_Coverage, 59288,
     /* 2236965 */     GIR_EraseRootFromParent_Done,
     /* 2236966 */   // Label 29831: @2236966
     /* 2236966 */   GIM_Try, /*On fail goto*//*Label 29832*/ GIMT_Encode4(2237011), // Rule ID 59289 //
     /* 2236971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236974 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2236977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2236991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237010 */     // GIR_Coverage, 59289,
     /* 2237010 */     GIR_EraseRootFromParent_Done,
     /* 2237011 */   // Label 29832: @2237011
     /* 2237011 */   GIM_Reject,
     /* 2237012 */ // Label 29830: @2237012
     /* 2237012 */ GIM_Reject,
     /* 2237013 */ // Label 29798: @2237013
     /* 2237013 */ GIM_Try, /*On fail goto*//*Label 29833*/ GIMT_Encode4(2237127),
     /* 2237018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2237021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2237024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237036 */   GIM_Try, /*On fail goto*//*Label 29834*/ GIMT_Encode4(2237081), // Rule ID 59296 //
     /* 2237041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237044 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2237047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237080 */     // GIR_Coverage, 59296,
     /* 2237080 */     GIR_EraseRootFromParent_Done,
     /* 2237081 */   // Label 29834: @2237081
     /* 2237081 */   GIM_Try, /*On fail goto*//*Label 29835*/ GIMT_Encode4(2237126), // Rule ID 59297 //
     /* 2237086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237089 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2237092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237125 */     // GIR_Coverage, 59297,
     /* 2237125 */     GIR_EraseRootFromParent_Done,
     /* 2237126 */   // Label 29835: @2237126
     /* 2237126 */   GIM_Reject,
     /* 2237127 */ // Label 29833: @2237127
     /* 2237127 */ GIM_Reject,
     /* 2237128 */ // Label 29799: @2237128
     /* 2237128 */ GIM_Try, /*On fail goto*//*Label 29836*/ GIMT_Encode4(2237242),
     /* 2237133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2237136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2237139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237151 */   GIM_Try, /*On fail goto*//*Label 29837*/ GIMT_Encode4(2237196), // Rule ID 59312 //
     /* 2237156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2237159 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2237162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237195 */     // GIR_Coverage, 59312,
     /* 2237195 */     GIR_EraseRootFromParent_Done,
     /* 2237196 */   // Label 29837: @2237196
     /* 2237196 */   GIM_Try, /*On fail goto*//*Label 29838*/ GIMT_Encode4(2237241), // Rule ID 59313 //
     /* 2237201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2237204 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2237207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237240 */     // GIR_Coverage, 59313,
     /* 2237240 */     GIR_EraseRootFromParent_Done,
     /* 2237241 */   // Label 29838: @2237241
     /* 2237241 */   GIM_Reject,
     /* 2237242 */ // Label 29836: @2237242
     /* 2237242 */ GIM_Reject,
     /* 2237243 */ // Label 29800: @2237243
     /* 2237243 */ GIM_Try, /*On fail goto*//*Label 29839*/ GIMT_Encode4(2237357),
     /* 2237248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2237251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2237254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237266 */   GIM_Try, /*On fail goto*//*Label 29840*/ GIMT_Encode4(2237311), // Rule ID 59280 //
     /* 2237271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237274 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2237277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2237291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237310 */     // GIR_Coverage, 59280,
     /* 2237310 */     GIR_EraseRootFromParent_Done,
     /* 2237311 */   // Label 29840: @2237311
     /* 2237311 */   GIM_Try, /*On fail goto*//*Label 29841*/ GIMT_Encode4(2237356), // Rule ID 59281 //
     /* 2237316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237319 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2237322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2237336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237355 */     // GIR_Coverage, 59281,
     /* 2237355 */     GIR_EraseRootFromParent_Done,
     /* 2237356 */   // Label 29841: @2237356
     /* 2237356 */   GIM_Reject,
     /* 2237357 */ // Label 29839: @2237357
     /* 2237357 */ GIM_Reject,
     /* 2237358 */ // Label 29801: @2237358
     /* 2237358 */ GIM_Try, /*On fail goto*//*Label 29842*/ GIMT_Encode4(2237472),
     /* 2237363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2237366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2237369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237381 */   GIM_Try, /*On fail goto*//*Label 29843*/ GIMT_Encode4(2237426), // Rule ID 59292 //
     /* 2237386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237389 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2237392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237425 */     // GIR_Coverage, 59292,
     /* 2237425 */     GIR_EraseRootFromParent_Done,
     /* 2237426 */   // Label 29843: @2237426
     /* 2237426 */   GIM_Try, /*On fail goto*//*Label 29844*/ GIMT_Encode4(2237471), // Rule ID 59293 //
     /* 2237431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237434 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2237437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237470 */     // GIR_Coverage, 59293,
     /* 2237470 */     GIR_EraseRootFromParent_Done,
     /* 2237471 */   // Label 29844: @2237471
     /* 2237471 */   GIM_Reject,
     /* 2237472 */ // Label 29842: @2237472
     /* 2237472 */ GIM_Reject,
     /* 2237473 */ // Label 29802: @2237473
     /* 2237473 */ GIM_Try, /*On fail goto*//*Label 29845*/ GIMT_Encode4(2237587),
     /* 2237478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2237481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2237484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237496 */   GIM_Try, /*On fail goto*//*Label 29846*/ GIMT_Encode4(2237541), // Rule ID 59308 //
     /* 2237501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237504 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2237507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237540 */     // GIR_Coverage, 59308,
     /* 2237540 */     GIR_EraseRootFromParent_Done,
     /* 2237541 */   // Label 29846: @2237541
     /* 2237541 */   GIM_Try, /*On fail goto*//*Label 29847*/ GIMT_Encode4(2237586), // Rule ID 59309 //
     /* 2237546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237549 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2237552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237585 */     // GIR_Coverage, 59309,
     /* 2237585 */     GIR_EraseRootFromParent_Done,
     /* 2237586 */   // Label 29847: @2237586
     /* 2237586 */   GIM_Reject,
     /* 2237587 */ // Label 29845: @2237587
     /* 2237587 */ GIM_Reject,
     /* 2237588 */ // Label 29803: @2237588
     /* 2237588 */ GIM_Try, /*On fail goto*//*Label 29848*/ GIMT_Encode4(2237702),
     /* 2237593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2237596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2237599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237607 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237611 */   GIM_Try, /*On fail goto*//*Label 29849*/ GIMT_Encode4(2237656), // Rule ID 59352 //
     /* 2237616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2237619 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2237622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2237636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237655 */     // GIR_Coverage, 59352,
     /* 2237655 */     GIR_EraseRootFromParent_Done,
     /* 2237656 */   // Label 29849: @2237656
     /* 2237656 */   GIM_Try, /*On fail goto*//*Label 29850*/ GIMT_Encode4(2237701), // Rule ID 59353 //
     /* 2237661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2237664 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2237667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2237681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237700 */     // GIR_Coverage, 59353,
     /* 2237700 */     GIR_EraseRootFromParent_Done,
     /* 2237701 */   // Label 29850: @2237701
     /* 2237701 */   GIM_Reject,
     /* 2237702 */ // Label 29848: @2237702
     /* 2237702 */ GIM_Reject,
     /* 2237703 */ // Label 29804: @2237703
     /* 2237703 */ GIM_Try, /*On fail goto*//*Label 29851*/ GIMT_Encode4(2237817),
     /* 2237708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2237711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2237714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237722 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237726 */   GIM_Try, /*On fail goto*//*Label 29852*/ GIMT_Encode4(2237771), // Rule ID 59284 //
     /* 2237731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237734 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2237737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237770 */     // GIR_Coverage, 59284,
     /* 2237770 */     GIR_EraseRootFromParent_Done,
     /* 2237771 */   // Label 29852: @2237771
     /* 2237771 */   GIM_Try, /*On fail goto*//*Label 29853*/ GIMT_Encode4(2237816), // Rule ID 59285 //
     /* 2237776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237779 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2237782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237815 */     // GIR_Coverage, 59285,
     /* 2237815 */     GIR_EraseRootFromParent_Done,
     /* 2237816 */   // Label 29853: @2237816
     /* 2237816 */   GIM_Reject,
     /* 2237817 */ // Label 29851: @2237817
     /* 2237817 */ GIM_Reject,
     /* 2237818 */ // Label 29805: @2237818
     /* 2237818 */ GIM_Try, /*On fail goto*//*Label 29854*/ GIMT_Encode4(2237932),
     /* 2237823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2237826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2237829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237837 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237841 */   GIM_Try, /*On fail goto*//*Label 29855*/ GIMT_Encode4(2237886), // Rule ID 59304 //
     /* 2237846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237849 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2237852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237885 */     // GIR_Coverage, 59304,
     /* 2237885 */     GIR_EraseRootFromParent_Done,
     /* 2237886 */   // Label 29855: @2237886
     /* 2237886 */   GIM_Try, /*On fail goto*//*Label 29856*/ GIMT_Encode4(2237931), // Rule ID 59305 //
     /* 2237891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237894 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2237897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237930 */     // GIR_Coverage, 59305,
     /* 2237930 */     GIR_EraseRootFromParent_Done,
     /* 2237931 */   // Label 29856: @2237931
     /* 2237931 */   GIM_Reject,
     /* 2237932 */ // Label 29854: @2237932
     /* 2237932 */ GIM_Reject,
     /* 2237933 */ // Label 29806: @2237933
     /* 2237933 */ GIM_Try, /*On fail goto*//*Label 29857*/ GIMT_Encode4(2238047),
     /* 2237938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2237941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2237944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237956 */   GIM_Try, /*On fail goto*//*Label 29858*/ GIMT_Encode4(2238001), // Rule ID 59340 //
     /* 2237961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237964 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2237967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2237981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238000 */     // GIR_Coverage, 59340,
     /* 2238000 */     GIR_EraseRootFromParent_Done,
     /* 2238001 */   // Label 29858: @2238001
     /* 2238001 */   GIM_Try, /*On fail goto*//*Label 29859*/ GIMT_Encode4(2238046), // Rule ID 59341 //
     /* 2238006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238009 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2238012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238045 */     // GIR_Coverage, 59341,
     /* 2238045 */     GIR_EraseRootFromParent_Done,
     /* 2238046 */   // Label 29859: @2238046
     /* 2238046 */   GIM_Reject,
     /* 2238047 */ // Label 29857: @2238047
     /* 2238047 */ GIM_Reject,
     /* 2238048 */ // Label 29807: @2238048
     /* 2238048 */ GIM_Try, /*On fail goto*//*Label 29860*/ GIMT_Encode4(2238162),
     /* 2238053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2238056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2238059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238067 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238071 */   GIM_Try, /*On fail goto*//*Label 29861*/ GIMT_Encode4(2238116), // Rule ID 59356 //
     /* 2238076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238079 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2238082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238115 */     // GIR_Coverage, 59356,
     /* 2238115 */     GIR_EraseRootFromParent_Done,
     /* 2238116 */   // Label 29861: @2238116
     /* 2238116 */   GIM_Try, /*On fail goto*//*Label 29862*/ GIMT_Encode4(2238161), // Rule ID 59357 //
     /* 2238121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238124 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2238127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238160 */     // GIR_Coverage, 59357,
     /* 2238160 */     GIR_EraseRootFromParent_Done,
     /* 2238161 */   // Label 29862: @2238161
     /* 2238161 */   GIM_Reject,
     /* 2238162 */ // Label 29860: @2238162
     /* 2238162 */ GIM_Reject,
     /* 2238163 */ // Label 29808: @2238163
     /* 2238163 */ GIM_Try, /*On fail goto*//*Label 29863*/ GIMT_Encode4(2238277),
     /* 2238168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2238171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2238174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238182 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238186 */   GIM_Try, /*On fail goto*//*Label 29864*/ GIMT_Encode4(2238231), // Rule ID 59300 //
     /* 2238191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238194 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2238197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238230 */     // GIR_Coverage, 59300,
     /* 2238230 */     GIR_EraseRootFromParent_Done,
     /* 2238231 */   // Label 29864: @2238231
     /* 2238231 */   GIM_Try, /*On fail goto*//*Label 29865*/ GIMT_Encode4(2238276), // Rule ID 59301 //
     /* 2238236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238239 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2238242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238275 */     // GIR_Coverage, 59301,
     /* 2238275 */     GIR_EraseRootFromParent_Done,
     /* 2238276 */   // Label 29865: @2238276
     /* 2238276 */   GIM_Reject,
     /* 2238277 */ // Label 29863: @2238277
     /* 2238277 */ GIM_Reject,
     /* 2238278 */ // Label 29809: @2238278
     /* 2238278 */ GIM_Try, /*On fail goto*//*Label 29866*/ GIMT_Encode4(2238392),
     /* 2238283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2238286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2238289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238297 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238301 */   GIM_Try, /*On fail goto*//*Label 29867*/ GIMT_Encode4(2238346), // Rule ID 59328 //
     /* 2238306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238309 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2238312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238345 */     // GIR_Coverage, 59328,
     /* 2238345 */     GIR_EraseRootFromParent_Done,
     /* 2238346 */   // Label 29867: @2238346
     /* 2238346 */   GIM_Try, /*On fail goto*//*Label 29868*/ GIMT_Encode4(2238391), // Rule ID 59329 //
     /* 2238351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238354 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2238357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238390 */     // GIR_Coverage, 59329,
     /* 2238390 */     GIR_EraseRootFromParent_Done,
     /* 2238391 */   // Label 29868: @2238391
     /* 2238391 */   GIM_Reject,
     /* 2238392 */ // Label 29866: @2238392
     /* 2238392 */ GIM_Reject,
     /* 2238393 */ // Label 29810: @2238393
     /* 2238393 */ GIM_Try, /*On fail goto*//*Label 29869*/ GIMT_Encode4(2238507),
     /* 2238398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2238401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2238404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238416 */   GIM_Try, /*On fail goto*//*Label 29870*/ GIMT_Encode4(2238461), // Rule ID 59344 //
     /* 2238421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238424 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2238427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238460 */     // GIR_Coverage, 59344,
     /* 2238460 */     GIR_EraseRootFromParent_Done,
     /* 2238461 */   // Label 29870: @2238461
     /* 2238461 */   GIM_Try, /*On fail goto*//*Label 29871*/ GIMT_Encode4(2238506), // Rule ID 59345 //
     /* 2238466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238469 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2238472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238505 */     // GIR_Coverage, 59345,
     /* 2238505 */     GIR_EraseRootFromParent_Done,
     /* 2238506 */   // Label 29871: @2238506
     /* 2238506 */   GIM_Reject,
     /* 2238507 */ // Label 29869: @2238507
     /* 2238507 */ GIM_Reject,
     /* 2238508 */ // Label 29811: @2238508
     /* 2238508 */ GIM_Try, /*On fail goto*//*Label 29872*/ GIMT_Encode4(2238622),
     /* 2238513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2238516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2238519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238531 */   GIM_Try, /*On fail goto*//*Label 29873*/ GIMT_Encode4(2238576), // Rule ID 59360 //
     /* 2238536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238539 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2238542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2238556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238575 */     // GIR_Coverage, 59360,
     /* 2238575 */     GIR_EraseRootFromParent_Done,
     /* 2238576 */   // Label 29873: @2238576
     /* 2238576 */   GIM_Try, /*On fail goto*//*Label 29874*/ GIMT_Encode4(2238621), // Rule ID 59361 //
     /* 2238581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238584 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2238587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2238601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238620 */     // GIR_Coverage, 59361,
     /* 2238620 */     GIR_EraseRootFromParent_Done,
     /* 2238621 */   // Label 29874: @2238621
     /* 2238621 */   GIM_Reject,
     /* 2238622 */ // Label 29872: @2238622
     /* 2238622 */ GIM_Reject,
     /* 2238623 */ // Label 29812: @2238623
     /* 2238623 */ GIM_Try, /*On fail goto*//*Label 29875*/ GIMT_Encode4(2238737),
     /* 2238628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2238631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2238634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238642 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238646 */   GIM_Try, /*On fail goto*//*Label 29876*/ GIMT_Encode4(2238691), // Rule ID 59316 //
     /* 2238651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238654 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2238657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238690 */     // GIR_Coverage, 59316,
     /* 2238690 */     GIR_EraseRootFromParent_Done,
     /* 2238691 */   // Label 29876: @2238691
     /* 2238691 */   GIM_Try, /*On fail goto*//*Label 29877*/ GIMT_Encode4(2238736), // Rule ID 59317 //
     /* 2238696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238699 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2238702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238735 */     // GIR_Coverage, 59317,
     /* 2238735 */     GIR_EraseRootFromParent_Done,
     /* 2238736 */   // Label 29877: @2238736
     /* 2238736 */   GIM_Reject,
     /* 2238737 */ // Label 29875: @2238737
     /* 2238737 */ GIM_Reject,
     /* 2238738 */ // Label 29813: @2238738
     /* 2238738 */ GIM_Try, /*On fail goto*//*Label 29878*/ GIMT_Encode4(2238852),
     /* 2238743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2238746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2238749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238761 */   GIM_Try, /*On fail goto*//*Label 29879*/ GIMT_Encode4(2238806), // Rule ID 59332 //
     /* 2238766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238769 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2238772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238805 */     // GIR_Coverage, 59332,
     /* 2238805 */     GIR_EraseRootFromParent_Done,
     /* 2238806 */   // Label 29879: @2238806
     /* 2238806 */   GIM_Try, /*On fail goto*//*Label 29880*/ GIMT_Encode4(2238851), // Rule ID 59333 //
     /* 2238811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238814 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2238817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238850 */     // GIR_Coverage, 59333,
     /* 2238850 */     GIR_EraseRootFromParent_Done,
     /* 2238851 */   // Label 29880: @2238851
     /* 2238851 */   GIM_Reject,
     /* 2238852 */ // Label 29878: @2238852
     /* 2238852 */ GIM_Reject,
     /* 2238853 */ // Label 29814: @2238853
     /* 2238853 */ GIM_Try, /*On fail goto*//*Label 29881*/ GIMT_Encode4(2238967),
     /* 2238858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2238861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2238864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238876 */   GIM_Try, /*On fail goto*//*Label 29882*/ GIMT_Encode4(2238921), // Rule ID 59348 //
     /* 2238881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238884 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2238887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2238901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238920 */     // GIR_Coverage, 59348,
     /* 2238920 */     GIR_EraseRootFromParent_Done,
     /* 2238921 */   // Label 29882: @2238921
     /* 2238921 */   GIM_Try, /*On fail goto*//*Label 29883*/ GIMT_Encode4(2238966), // Rule ID 59349 //
     /* 2238926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238929 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2238932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2238946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238965 */     // GIR_Coverage, 59349,
     /* 2238965 */     GIR_EraseRootFromParent_Done,
     /* 2238966 */   // Label 29883: @2238966
     /* 2238966 */   GIM_Reject,
     /* 2238967 */ // Label 29881: @2238967
     /* 2238967 */ GIM_Reject,
     /* 2238968 */ // Label 29815: @2238968
     /* 2238968 */ GIM_Try, /*On fail goto*//*Label 29884*/ GIMT_Encode4(2239082),
     /* 2238973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2238976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2238979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238991 */   GIM_Try, /*On fail goto*//*Label 29885*/ GIMT_Encode4(2239036), // Rule ID 59320 //
     /* 2238996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238999 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2239002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2239016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239035 */     // GIR_Coverage, 59320,
     /* 2239035 */     GIR_EraseRootFromParent_Done,
     /* 2239036 */   // Label 29885: @2239036
     /* 2239036 */   GIM_Try, /*On fail goto*//*Label 29886*/ GIMT_Encode4(2239081), // Rule ID 59321 //
     /* 2239041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239044 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2239047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2239061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239080 */     // GIR_Coverage, 59321,
     /* 2239080 */     GIR_EraseRootFromParent_Done,
     /* 2239081 */   // Label 29886: @2239081
     /* 2239081 */   GIM_Reject,
     /* 2239082 */ // Label 29884: @2239082
     /* 2239082 */ GIM_Reject,
     /* 2239083 */ // Label 29816: @2239083
     /* 2239083 */ GIM_Try, /*On fail goto*//*Label 29887*/ GIMT_Encode4(2239197),
     /* 2239088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2239091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2239094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239106 */   GIM_Try, /*On fail goto*//*Label 29888*/ GIMT_Encode4(2239151), // Rule ID 59336 //
     /* 2239111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239114 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2239117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239150 */     // GIR_Coverage, 59336,
     /* 2239150 */     GIR_EraseRootFromParent_Done,
     /* 2239151 */   // Label 29888: @2239151
     /* 2239151 */   GIM_Try, /*On fail goto*//*Label 29889*/ GIMT_Encode4(2239196), // Rule ID 59337 //
     /* 2239156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239159 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2239162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239195 */     // GIR_Coverage, 59337,
     /* 2239195 */     GIR_EraseRootFromParent_Done,
     /* 2239196 */   // Label 29889: @2239196
     /* 2239196 */   GIM_Reject,
     /* 2239197 */ // Label 29887: @2239197
     /* 2239197 */ GIM_Reject,
     /* 2239198 */ // Label 29817: @2239198
     /* 2239198 */ GIM_Try, /*On fail goto*//*Label 29890*/ GIMT_Encode4(2239312),
     /* 2239203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2239206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2239209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239221 */   GIM_Try, /*On fail goto*//*Label 29891*/ GIMT_Encode4(2239266), // Rule ID 59324 //
     /* 2239226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239229 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2239232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239265 */     // GIR_Coverage, 59324,
     /* 2239265 */     GIR_EraseRootFromParent_Done,
     /* 2239266 */   // Label 29891: @2239266
     /* 2239266 */   GIM_Try, /*On fail goto*//*Label 29892*/ GIMT_Encode4(2239311), // Rule ID 59325 //
     /* 2239271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239274 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2239277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239310 */     // GIR_Coverage, 59325,
     /* 2239310 */     GIR_EraseRootFromParent_Done,
     /* 2239311 */   // Label 29892: @2239311
     /* 2239311 */   GIM_Reject,
     /* 2239312 */ // Label 29890: @2239312
     /* 2239312 */ GIM_Reject,
     /* 2239313 */ // Label 29818: @2239313
     /* 2239313 */ GIM_Reject,
     /* 2239314 */ // Label 48: @2239314
     /* 2239314 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(33), /*)*//*default:*//*Label 29902*/ GIMT_Encode4(2266390),
     /* 2239325 */ /*GILLT_s32*//*Label 29893*/ GIMT_Encode4(2239445),
     /* 2239329 */ /*GILLT_s64*//*Label 29894*/ GIMT_Encode4(2242446),
     /* 2239333 */ /*GILLT_nxv1s1*//*Label 29895*/ GIMT_Encode4(2245447), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239353 */ /*GILLT_nxv2s1*//*Label 29896*/ GIMT_Encode4(2249288), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239373 */ /*GILLT_nxv4s1*//*Label 29897*/ GIMT_Encode4(2253129), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239393 */ /*GILLT_nxv8s1*//*Label 29898*/ GIMT_Encode4(2256970), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239413 */ /*GILLT_nxv16s1*//*Label 29899*/ GIMT_Encode4(2260811), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239429 */ /*GILLT_nxv32s1*//*Label 29900*/ GIMT_Encode4(2263692), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239441 */ /*GILLT_nxv64s1*//*Label 29901*/ GIMT_Encode4(2265613),
     /* 2239445 */ // Label 29893: @2239445
     /* 2239445 */ GIM_Try, /*On fail goto*//*Label 29903*/ GIMT_Encode4(2239547), // Rule ID 167 //
     /* 2239450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239456 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239463 */   // MIs[0] Operand 1
     /* 2239463 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239468 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2239472 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2239476 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2239480 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239484 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239489 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2239493 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2239497 */   GIM_CheckAPIntImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /* 2239501 */   // MIs[2] Operand 1
     /* 2239501 */   // No operand predicates
     /* 2239501 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9937),
     /* 2239505 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2239509 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2239511 */   // (setcc:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9937>><<X:XLenSubTrailingOnes>>:$mask), 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)), 1:{ *:[i32] })
     /* 2239511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2239514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2239518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239523 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 2239527 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /* 2239532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2239537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2239545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239546 */   // GIR_Coverage, 167,
     /* 2239546 */   GIR_EraseRootFromParent_Done,
     /* 2239547 */ // Label 29903: @2239547
     /* 2239547 */ GIM_Try, /*On fail goto*//*Label 29904*/ GIMT_Encode4(2239652), // Rule ID 169 //
     /* 2239552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239558 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239565 */   // MIs[0] Operand 1
     /* 2239565 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239570 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2239574 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2239578 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2239582 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239586 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239591 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2239595 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2239599 */   GIM_CheckAPIntImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /* 2239603 */   // MIs[2] Operand 1
     /* 2239603 */   // No operand predicates
     /* 2239603 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9937),
     /* 2239607 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2239611 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2239613 */   // (setcc:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9937>><<X:XLenSubTrailingOnes>>:$mask), 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)))
     /* 2239613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2239616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2239620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239625 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 2239629 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /* 2239634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2239639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239641 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2239647 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239650 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239651 */   // GIR_Coverage, 169,
     /* 2239651 */   GIR_EraseRootFromParent_Done,
     /* 2239652 */ // Label 29904: @2239652
     /* 2239652 */ GIM_Try, /*On fail goto*//*Label 29905*/ GIMT_Encode4(2239695), // Rule ID 165 //
     /* 2239657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239663 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239670 */   // MIs[0] Operand 1
     /* 2239670 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239679 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2239683 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] })
     /* 2239683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2239686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239688 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239693 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239694 */   // GIR_Coverage, 165,
     /* 2239694 */   GIR_EraseRootFromParent_Done,
     /* 2239695 */ // Label 29905: @2239695
     /* 2239695 */ GIM_Try, /*On fail goto*//*Label 29906*/ GIMT_Encode4(2239738), // Rule ID 65294 //
     /* 2239700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2239706 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2239709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239713 */   // MIs[0] Operand 1
     /* 2239713 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239722 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2239726 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2239726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2239729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239731 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2239736 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239737 */   // GIR_Coverage, 65294,
     /* 2239737 */   GIR_EraseRootFromParent_Done,
     /* 2239738 */ // Label 29906: @2239738
     /* 2239738 */ GIM_Try, /*On fail goto*//*Label 29907*/ GIMT_Encode4(2239784), // Rule ID 65300 //
     /* 2239743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2239749 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2239752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239756 */   // MIs[0] Operand 1
     /* 2239756 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239765 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2239769 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2239769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2239772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239774 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2239780 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239782 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239783 */   // GIR_Coverage, 65300,
     /* 2239783 */   GIR_EraseRootFromParent_Done,
     /* 2239784 */ // Label 29907: @2239784
     /* 2239784 */ GIM_Try, /*On fail goto*//*Label 29908*/ GIMT_Encode4(2239827), // Rule ID 65330 //
     /* 2239789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239795 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239802 */   // MIs[0] Operand 1
     /* 2239802 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239811 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2239815 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2239815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2239818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239820 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2239825 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239826 */   // GIR_Coverage, 65330,
     /* 2239826 */   GIR_EraseRootFromParent_Done,
     /* 2239827 */ // Label 29908: @2239827
     /* 2239827 */ GIM_Try, /*On fail goto*//*Label 29909*/ GIMT_Encode4(2239873), // Rule ID 65336 //
     /* 2239832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239838 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239845 */   // MIs[0] Operand 1
     /* 2239845 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239854 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2239858 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2239858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2239861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239863 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2239869 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239871 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239872 */   // GIR_Coverage, 65336,
     /* 2239872 */   GIR_EraseRootFromParent_Done,
     /* 2239873 */ // Label 29909: @2239873
     /* 2239873 */ GIM_Try, /*On fail goto*//*Label 29910*/ GIMT_Encode4(2239926), // Rule ID 155 //
     /* 2239878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239884 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239891 */   // MIs[0] Operand 1
     /* 2239891 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2239896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2239904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2239908 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2239912 */   // MIs[1] Operand 1
     /* 2239912 */   // No operand predicates
     /* 2239912 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239914 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2239914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2239917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239919 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239921 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2239924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239925 */   // GIR_Coverage, 155,
     /* 2239925 */   GIR_EraseRootFromParent_Done,
     /* 2239926 */ // Label 29910: @2239926
     /* 2239926 */ GIM_Try, /*On fail goto*//*Label 29911*/ GIMT_Encode4(2239979), // Rule ID 159 //
     /* 2239931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239944 */   // MIs[0] Operand 1
     /* 2239944 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2239949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239953 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2239957 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2239961 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2239965 */   // MIs[1] Operand 1
     /* 2239965 */   // No operand predicates
     /* 2239965 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239967 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2239967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2239970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239972 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239974 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2239977 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239978 */   // GIR_Coverage, 159,
     /* 2239978 */   GIR_EraseRootFromParent_Done,
     /* 2239979 */ // Label 29911: @2239979
     /* 2239979 */ GIM_Try, /*On fail goto*//*Label 29912*/ GIMT_Encode4(2240032), // Rule ID 65286 //
     /* 2239984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2239990 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239997 */   // MIs[0] Operand 1
     /* 2239997 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240002 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240006 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240010 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240014 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240018 */   // MIs[1] Operand 1
     /* 2240018 */   // No operand predicates
     /* 2240018 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240020 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2240020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240025 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240027 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2240030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240031 */   // GIR_Coverage, 65286,
     /* 2240031 */   GIR_EraseRootFromParent_Done,
     /* 2240032 */ // Label 29912: @2240032
     /* 2240032 */ GIM_Try, /*On fail goto*//*Label 29913*/ GIMT_Encode4(2240085), // Rule ID 65290 //
     /* 2240037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240043 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240050 */   // MIs[0] Operand 1
     /* 2240050 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2240055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240059 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240067 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240071 */   // MIs[1] Operand 1
     /* 2240071 */   // No operand predicates
     /* 2240071 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240073 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2240073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240078 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240080 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2240083 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240084 */   // GIR_Coverage, 65290,
     /* 2240084 */   GIR_EraseRootFromParent_Done,
     /* 2240085 */ // Label 29913: @2240085
     /* 2240085 */ GIM_Try, /*On fail goto*//*Label 29914*/ GIMT_Encode4(2240162), // Rule ID 65296 //
     /* 2240090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240096 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240103 */   // MIs[0] Operand 1
     /* 2240103 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2240108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240112 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240116 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240120 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2240124 */   // MIs[1] Operand 1
     /* 2240124 */   // No operand predicates
     /* 2240124 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240126 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2240126 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240129 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2240133 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240138 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240142 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2240147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240160 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240161 */   // GIR_Coverage, 65296,
     /* 2240161 */   GIR_EraseRootFromParent_Done,
     /* 2240162 */ // Label 29914: @2240162
     /* 2240162 */ GIM_Try, /*On fail goto*//*Label 29915*/ GIMT_Encode4(2240242), // Rule ID 65302 //
     /* 2240167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240173 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240180 */   // MIs[0] Operand 1
     /* 2240180 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2240185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240189 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240193 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240197 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2240201 */   // MIs[1] Operand 1
     /* 2240201 */   // No operand predicates
     /* 2240201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240203 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2240203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2240210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240215 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240219 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2240224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2240229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240231 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2240237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240240 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240241 */   // GIR_Coverage, 65302,
     /* 2240241 */   GIR_EraseRootFromParent_Done,
     /* 2240242 */ // Label 29915: @2240242
     /* 2240242 */ GIM_Try, /*On fail goto*//*Label 29916*/ GIMT_Encode4(2240319), // Rule ID 65306 //
     /* 2240247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240253 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240260 */   // MIs[0] Operand 1
     /* 2240260 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2240265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240269 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240273 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240277 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2240281 */   // MIs[1] Operand 1
     /* 2240281 */   // No operand predicates
     /* 2240281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240283 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2240283 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240286 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240290 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240295 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240299 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240317 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240318 */   // GIR_Coverage, 65306,
     /* 2240318 */   GIR_EraseRootFromParent_Done,
     /* 2240319 */ // Label 29916: @2240319
     /* 2240319 */ GIM_Try, /*On fail goto*//*Label 29917*/ GIMT_Encode4(2240396), // Rule ID 65310 //
     /* 2240324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240330 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240337 */   // MIs[0] Operand 1
     /* 2240337 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240354 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2240358 */   // MIs[1] Operand 1
     /* 2240358 */   // No operand predicates
     /* 2240358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240360 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2240360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240372 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240376 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240388 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240394 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240395 */   // GIR_Coverage, 65310,
     /* 2240395 */   GIR_EraseRootFromParent_Done,
     /* 2240396 */ // Label 29917: @2240396
     /* 2240396 */ GIM_Try, /*On fail goto*//*Label 29918*/ GIMT_Encode4(2240471), // Rule ID 65314 //
     /* 2240401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240407 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240414 */   // MIs[0] Operand 1
     /* 2240414 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2240419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240423 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240427 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240431 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240435 */   // MIs[1] Operand 1
     /* 2240435 */   // No operand predicates
     /* 2240435 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240437 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2240437 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240440 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240444 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240449 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240453 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2240456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240470 */   // GIR_Coverage, 65314,
     /* 2240470 */   GIR_EraseRootFromParent_Done,
     /* 2240471 */ // Label 29918: @2240471
     /* 2240471 */ GIM_Try, /*On fail goto*//*Label 29919*/ GIMT_Encode4(2240546), // Rule ID 65318 //
     /* 2240476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240482 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240489 */   // MIs[0] Operand 1
     /* 2240489 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2240494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240498 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240502 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240506 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240510 */   // MIs[1] Operand 1
     /* 2240510 */   // No operand predicates
     /* 2240510 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240512 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2240512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240524 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240528 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2240531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240545 */   // GIR_Coverage, 65318,
     /* 2240545 */   GIR_EraseRootFromParent_Done,
     /* 2240546 */ // Label 29919: @2240546
     /* 2240546 */ GIM_Try, /*On fail goto*//*Label 29920*/ GIMT_Encode4(2240601), // Rule ID 65322 //
     /* 2240551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240557 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240564 */   // MIs[0] Operand 1
     /* 2240564 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2240569 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240573 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240581 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2240585 */   // MIs[1] Operand 1
     /* 2240585 */   // No operand predicates
     /* 2240585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240587 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2240587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240592 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240594 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240599 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240600 */   // GIR_Coverage, 65322,
     /* 2240600 */   GIR_EraseRootFromParent_Done,
     /* 2240601 */ // Label 29920: @2240601
     /* 2240601 */ GIM_Try, /*On fail goto*//*Label 29921*/ GIMT_Encode4(2240656), // Rule ID 65326 //
     /* 2240606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240612 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240619 */   // MIs[0] Operand 1
     /* 2240619 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2240624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240628 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240632 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240636 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2240640 */   // MIs[1] Operand 1
     /* 2240640 */   // No operand predicates
     /* 2240640 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240642 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2240642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240647 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240649 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240654 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240655 */   // GIR_Coverage, 65326,
     /* 2240655 */   GIR_EraseRootFromParent_Done,
     /* 2240656 */ // Label 29921: @2240656
     /* 2240656 */ GIM_Try, /*On fail goto*//*Label 29922*/ GIMT_Encode4(2240733), // Rule ID 65332 //
     /* 2240661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240667 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240674 */   // MIs[0] Operand 1
     /* 2240674 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2240679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240691 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2240695 */   // MIs[1] Operand 1
     /* 2240695 */   // No operand predicates
     /* 2240695 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240697 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2240697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2240704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240709 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240713 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2240718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240732 */   // GIR_Coverage, 65332,
     /* 2240732 */   GIR_EraseRootFromParent_Done,
     /* 2240733 */ // Label 29922: @2240733
     /* 2240733 */ GIM_Try, /*On fail goto*//*Label 29923*/ GIMT_Encode4(2240813), // Rule ID 65338 //
     /* 2240738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240751 */   // MIs[0] Operand 1
     /* 2240751 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2240756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240760 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240764 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240768 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2240772 */   // MIs[1] Operand 1
     /* 2240772 */   // No operand predicates
     /* 2240772 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240774 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2240774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2240781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240786 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240790 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2240795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2240800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240802 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2240808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240812 */   // GIR_Coverage, 65338,
     /* 2240812 */   GIR_EraseRootFromParent_Done,
     /* 2240813 */ // Label 29923: @2240813
     /* 2240813 */ GIM_Try, /*On fail goto*//*Label 29924*/ GIMT_Encode4(2240890), // Rule ID 65342 //
     /* 2240818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240831 */   // MIs[0] Operand 1
     /* 2240831 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2240836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240840 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240844 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240848 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2240852 */   // MIs[1] Operand 1
     /* 2240852 */   // No operand predicates
     /* 2240852 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240854 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2240854 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240857 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240861 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240866 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240870 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240882 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240888 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240889 */   // GIR_Coverage, 65342,
     /* 2240889 */   GIR_EraseRootFromParent_Done,
     /* 2240890 */ // Label 29924: @2240890
     /* 2240890 */ GIM_Try, /*On fail goto*//*Label 29925*/ GIMT_Encode4(2240967), // Rule ID 65346 //
     /* 2240895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240901 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240908 */   // MIs[0] Operand 1
     /* 2240908 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240917 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240925 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2240929 */   // MIs[1] Operand 1
     /* 2240929 */   // No operand predicates
     /* 2240929 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240931 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2240931 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240934 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240938 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240943 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240947 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240965 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240966 */   // GIR_Coverage, 65346,
     /* 2240966 */   GIR_EraseRootFromParent_Done,
     /* 2240967 */ // Label 29925: @2240967
     /* 2240967 */ GIM_Try, /*On fail goto*//*Label 29926*/ GIMT_Encode4(2241042), // Rule ID 65350 //
     /* 2240972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240978 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240985 */   // MIs[0] Operand 1
     /* 2240985 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2240990 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240994 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240998 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241002 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2241006 */   // MIs[1] Operand 1
     /* 2241006 */   // No operand predicates
     /* 2241006 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241008 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2241008 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241011 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241015 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241020 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241024 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2241027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241040 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241041 */   // GIR_Coverage, 65350,
     /* 2241041 */   GIR_EraseRootFromParent_Done,
     /* 2241042 */ // Label 29926: @2241042
     /* 2241042 */ GIM_Try, /*On fail goto*//*Label 29927*/ GIMT_Encode4(2241117), // Rule ID 65354 //
     /* 2241047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241053 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241060 */   // MIs[0] Operand 1
     /* 2241060 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241069 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241073 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241077 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2241081 */   // MIs[1] Operand 1
     /* 2241081 */   // No operand predicates
     /* 2241081 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241083 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2241083 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241086 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2241090 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241095 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241099 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2241102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241116 */   // GIR_Coverage, 65354,
     /* 2241116 */   GIR_EraseRootFromParent_Done,
     /* 2241117 */ // Label 29927: @2241117
     /* 2241117 */ GIM_Try, /*On fail goto*//*Label 29928*/ GIMT_Encode4(2241172), // Rule ID 65358 //
     /* 2241122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241135 */   // MIs[0] Operand 1
     /* 2241135 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241144 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241148 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241152 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2241156 */   // MIs[1] Operand 1
     /* 2241156 */   // No operand predicates
     /* 2241156 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241158 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2241158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241163 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241165 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241170 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241171 */   // GIR_Coverage, 65358,
     /* 2241171 */   GIR_EraseRootFromParent_Done,
     /* 2241172 */ // Label 29928: @2241172
     /* 2241172 */ GIM_Try, /*On fail goto*//*Label 29929*/ GIMT_Encode4(2241227), // Rule ID 65362 //
     /* 2241177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241183 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241190 */   // MIs[0] Operand 1
     /* 2241190 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241199 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241203 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241207 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2241211 */   // MIs[1] Operand 1
     /* 2241211 */   // No operand predicates
     /* 2241211 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241213 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2241213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2241216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241218 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241220 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241225 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241226 */   // GIR_Coverage, 65362,
     /* 2241226 */   GIR_EraseRootFromParent_Done,
     /* 2241227 */ // Label 29929: @2241227
     /* 2241227 */ GIM_Try, /*On fail goto*//*Label 29930*/ GIMT_Encode4(2241269), // Rule ID 64462 //
     /* 2241232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2241235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241238 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241245 */   // MIs[0] Operand 1
     /* 2241245 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241254 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241258 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2241261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241263 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241265 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241267 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241268 */   // GIR_Coverage, 64462,
     /* 2241268 */   GIR_EraseRootFromParent_Done,
     /* 2241269 */ // Label 29930: @2241269
     /* 2241269 */ GIM_Try, /*On fail goto*//*Label 29931*/ GIMT_Encode4(2241311), // Rule ID 64464 //
     /* 2241274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2241277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241280 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241287 */   // MIs[0] Operand 1
     /* 2241287 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241296 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241300 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2241303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241305 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241307 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241309 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241310 */   // GIR_Coverage, 64464,
     /* 2241310 */   GIR_EraseRootFromParent_Done,
     /* 2241311 */ // Label 29931: @2241311
     /* 2241311 */ GIM_Try, /*On fail goto*//*Label 29932*/ GIMT_Encode4(2241353), // Rule ID 153 //
     /* 2241316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241329 */   // MIs[0] Operand 1
     /* 2241329 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2241334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241338 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241342 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241347 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241349 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241351 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241352 */   // GIR_Coverage, 153,
     /* 2241352 */   GIR_EraseRootFromParent_Done,
     /* 2241353 */ // Label 29932: @2241353
     /* 2241353 */ GIM_Try, /*On fail goto*//*Label 29933*/ GIMT_Encode4(2241395), // Rule ID 157 //
     /* 2241358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241364 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241371 */   // MIs[0] Operand 1
     /* 2241371 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2241376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241380 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241384 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241389 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241391 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241393 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241394 */   // GIR_Coverage, 157,
     /* 2241394 */   GIR_EraseRootFromParent_Done,
     /* 2241395 */ // Label 29933: @2241395
     /* 2241395 */ GIM_Try, /*On fail goto*//*Label 29934*/ GIMT_Encode4(2241437), // Rule ID 65288 //
     /* 2241400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241406 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241413 */   // MIs[0] Operand 1
     /* 2241413 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2241418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241422 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241426 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241431 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241433 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241435 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241436 */   // GIR_Coverage, 65288,
     /* 2241436 */   GIR_EraseRootFromParent_Done,
     /* 2241437 */ // Label 29934: @2241437
     /* 2241437 */ GIM_Try, /*On fail goto*//*Label 29935*/ GIMT_Encode4(2241479), // Rule ID 65292 //
     /* 2241442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241448 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241455 */   // MIs[0] Operand 1
     /* 2241455 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2241460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241464 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241468 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241473 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241475 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241478 */   // GIR_Coverage, 65292,
     /* 2241478 */   GIR_EraseRootFromParent_Done,
     /* 2241479 */ // Label 29935: @2241479
     /* 2241479 */ GIM_Try, /*On fail goto*//*Label 29936*/ GIMT_Encode4(2241545), // Rule ID 65298 //
     /* 2241484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241490 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241497 */   // MIs[0] Operand 1
     /* 2241497 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2241502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241506 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241510 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2241510 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241513 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2241517 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241522 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241526 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241543 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241544 */   // GIR_Coverage, 65298,
     /* 2241544 */   GIR_EraseRootFromParent_Done,
     /* 2241545 */ // Label 29936: @2241545
     /* 2241545 */ GIM_Try, /*On fail goto*//*Label 29937*/ GIMT_Encode4(2241614), // Rule ID 65304 //
     /* 2241550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241556 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241563 */   // MIs[0] Operand 1
     /* 2241563 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2241568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241572 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241576 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2241576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2241583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241588 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241592 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241603 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2241609 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241612 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241613 */   // GIR_Coverage, 65304,
     /* 2241613 */   GIR_EraseRootFromParent_Done,
     /* 2241614 */ // Label 29937: @2241614
     /* 2241614 */ GIM_Try, /*On fail goto*//*Label 29938*/ GIMT_Encode4(2241656), // Rule ID 65308 //
     /* 2241619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241625 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241632 */   // MIs[0] Operand 1
     /* 2241632 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241641 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241645 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2241645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241650 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241652 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241654 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241655 */   // GIR_Coverage, 65308,
     /* 2241655 */   GIR_EraseRootFromParent_Done,
     /* 2241656 */ // Label 29938: @2241656
     /* 2241656 */ GIM_Try, /*On fail goto*//*Label 29939*/ GIMT_Encode4(2241698), // Rule ID 65312 //
     /* 2241661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241667 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241674 */   // MIs[0] Operand 1
     /* 2241674 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2241679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241683 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241687 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2241687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241692 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241694 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241696 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241697 */   // GIR_Coverage, 65312,
     /* 2241697 */   GIR_EraseRootFromParent_Done,
     /* 2241698 */ // Label 29939: @2241698
     /* 2241698 */ GIM_Try, /*On fail goto*//*Label 29940*/ GIMT_Encode4(2241764), // Rule ID 65316 //
     /* 2241703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241709 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241716 */   // MIs[0] Operand 1
     /* 2241716 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2241721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241725 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241729 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2241729 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241732 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241736 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241741 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241745 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241756 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241762 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241763 */   // GIR_Coverage, 65316,
     /* 2241763 */   GIR_EraseRootFromParent_Done,
     /* 2241764 */ // Label 29940: @2241764
     /* 2241764 */ GIM_Try, /*On fail goto*//*Label 29941*/ GIMT_Encode4(2241830), // Rule ID 65320 //
     /* 2241769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241775 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241782 */   // MIs[0] Operand 1
     /* 2241782 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241791 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241795 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2241795 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241798 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241802 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241807 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241811 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241822 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241829 */   // GIR_Coverage, 65320,
     /* 2241829 */   GIR_EraseRootFromParent_Done,
     /* 2241830 */ // Label 29941: @2241830
     /* 2241830 */ GIM_Try, /*On fail goto*//*Label 29942*/ GIMT_Encode4(2241896), // Rule ID 65324 //
     /* 2241835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241841 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241848 */   // MIs[0] Operand 1
     /* 2241848 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241857 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241861 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2241861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241873 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241877 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241894 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241895 */   // GIR_Coverage, 65324,
     /* 2241895 */   GIR_EraseRootFromParent_Done,
     /* 2241896 */ // Label 29942: @2241896
     /* 2241896 */ GIM_Try, /*On fail goto*//*Label 29943*/ GIMT_Encode4(2241962), // Rule ID 65328 //
     /* 2241901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241907 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241914 */   // MIs[0] Operand 1
     /* 2241914 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241923 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241927 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2241927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241939 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241943 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241960 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241961 */   // GIR_Coverage, 65328,
     /* 2241961 */   GIR_EraseRootFromParent_Done,
     /* 2241962 */ // Label 29943: @2241962
     /* 2241962 */ GIM_Try, /*On fail goto*//*Label 29944*/ GIMT_Encode4(2242028), // Rule ID 65334 //
     /* 2241967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241973 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241980 */   // MIs[0] Operand 1
     /* 2241980 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2241985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241989 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241993 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2241993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2242000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242005 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242009 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242026 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242027 */   // GIR_Coverage, 65334,
     /* 2242027 */   GIR_EraseRootFromParent_Done,
     /* 2242028 */ // Label 29944: @2242028
     /* 2242028 */ GIM_Try, /*On fail goto*//*Label 29945*/ GIMT_Encode4(2242097), // Rule ID 65340 //
     /* 2242033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242039 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242046 */   // MIs[0] Operand 1
     /* 2242046 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242055 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242059 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2242059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2242066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242071 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242075 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242086 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2242092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242095 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242096 */   // GIR_Coverage, 65340,
     /* 2242096 */   GIR_EraseRootFromParent_Done,
     /* 2242097 */ // Label 29945: @2242097
     /* 2242097 */ GIM_Try, /*On fail goto*//*Label 29946*/ GIMT_Encode4(2242139), // Rule ID 65344 //
     /* 2242102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242108 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242115 */   // MIs[0] Operand 1
     /* 2242115 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2242120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242124 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242128 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2242128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242133 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242135 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242137 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242138 */   // GIR_Coverage, 65344,
     /* 2242138 */   GIR_EraseRootFromParent_Done,
     /* 2242139 */ // Label 29946: @2242139
     /* 2242139 */ GIM_Try, /*On fail goto*//*Label 29947*/ GIMT_Encode4(2242181), // Rule ID 65348 //
     /* 2242144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242150 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242157 */   // MIs[0] Operand 1
     /* 2242157 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2242162 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242166 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242170 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2242170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242175 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242177 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242179 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242180 */   // GIR_Coverage, 65348,
     /* 2242180 */   GIR_EraseRootFromParent_Done,
     /* 2242181 */ // Label 29947: @2242181
     /* 2242181 */ GIM_Try, /*On fail goto*//*Label 29948*/ GIMT_Encode4(2242247), // Rule ID 65352 //
     /* 2242186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242192 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242199 */   // MIs[0] Operand 1
     /* 2242199 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242208 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242212 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2242212 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242215 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242219 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242224 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242228 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242245 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242246 */   // GIR_Coverage, 65352,
     /* 2242246 */   GIR_EraseRootFromParent_Done,
     /* 2242247 */ // Label 29948: @2242247
     /* 2242247 */ GIM_Try, /*On fail goto*//*Label 29949*/ GIMT_Encode4(2242313), // Rule ID 65356 //
     /* 2242252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242258 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242265 */   // MIs[0] Operand 1
     /* 2242265 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2242270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242274 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242278 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2242278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242290 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242294 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242311 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242312 */   // GIR_Coverage, 65356,
     /* 2242312 */   GIR_EraseRootFromParent_Done,
     /* 2242313 */ // Label 29949: @2242313
     /* 2242313 */ GIM_Try, /*On fail goto*//*Label 29950*/ GIMT_Encode4(2242379), // Rule ID 65360 //
     /* 2242318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242324 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242331 */   // MIs[0] Operand 1
     /* 2242331 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242336 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242340 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242344 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2242344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242356 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242360 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242377 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242378 */   // GIR_Coverage, 65360,
     /* 2242378 */   GIR_EraseRootFromParent_Done,
     /* 2242379 */ // Label 29950: @2242379
     /* 2242379 */ GIM_Try, /*On fail goto*//*Label 29951*/ GIMT_Encode4(2242445), // Rule ID 65364 //
     /* 2242384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242390 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242397 */   // MIs[0] Operand 1
     /* 2242397 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2242402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242406 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242410 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2242410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242422 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242426 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242437 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242444 */   // GIR_Coverage, 65364,
     /* 2242444 */   GIR_EraseRootFromParent_Done,
     /* 2242445 */ // Label 29951: @2242445
     /* 2242445 */ GIM_Reject,
     /* 2242446 */ // Label 29894: @2242446
     /* 2242446 */ GIM_Try, /*On fail goto*//*Label 29952*/ GIMT_Encode4(2242548), // Rule ID 166 //
     /* 2242451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242464 */   // MIs[0] Operand 1
     /* 2242464 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2242473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2242477 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2242481 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242485 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242490 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2242494 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242498 */   GIM_CheckAPIntImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /* 2242502 */   // MIs[2] Operand 1
     /* 2242502 */   // No operand predicates
     /* 2242502 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9937),
     /* 2242506 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2242510 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2242512 */   // (setcc:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9937>><<X:XLenSubTrailingOnes>>:$mask), 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)), 1:{ *:[i64] })
     /* 2242512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2242515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2242519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242524 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 2242528 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /* 2242533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242540 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242546 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242547 */   // GIR_Coverage, 166,
     /* 2242547 */   GIR_EraseRootFromParent_Done,
     /* 2242548 */ // Label 29952: @2242548
     /* 2242548 */ GIM_Try, /*On fail goto*//*Label 29953*/ GIMT_Encode4(2242653), // Rule ID 168 //
     /* 2242553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242559 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242566 */   // MIs[0] Operand 1
     /* 2242566 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242571 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2242575 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2242579 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2242583 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242587 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242592 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2242596 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242600 */   GIM_CheckAPIntImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /* 2242604 */   // MIs[2] Operand 1
     /* 2242604 */   // No operand predicates
     /* 2242604 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9937),
     /* 2242608 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2242612 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2242614 */   // (setcc:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9937>><<X:XLenSubTrailingOnes>>:$mask), 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)))
     /* 2242614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2242617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2242621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242626 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 2242630 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /* 2242635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242642 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2242648 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242651 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242652 */   // GIR_Coverage, 168,
     /* 2242652 */   GIR_EraseRootFromParent_Done,
     /* 2242653 */ // Label 29953: @2242653
     /* 2242653 */ GIM_Try, /*On fail goto*//*Label 29954*/ GIMT_Encode4(2242696), // Rule ID 164 //
     /* 2242658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242664 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242671 */   // MIs[0] Operand 1
     /* 2242671 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242676 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242680 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2242684 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] })
     /* 2242684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242689 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242694 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242695 */   // GIR_Coverage, 164,
     /* 2242695 */   GIR_EraseRootFromParent_Done,
     /* 2242696 */ // Label 29954: @2242696
     /* 2242696 */ GIM_Try, /*On fail goto*//*Label 29955*/ GIMT_Encode4(2242739), // Rule ID 65293 //
     /* 2242701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2242707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2242710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242714 */   // MIs[0] Operand 1
     /* 2242714 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242723 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2242727 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2242727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242732 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242737 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242738 */   // GIR_Coverage, 65293,
     /* 2242738 */   GIR_EraseRootFromParent_Done,
     /* 2242739 */ // Label 29955: @2242739
     /* 2242739 */ GIM_Try, /*On fail goto*//*Label 29956*/ GIMT_Encode4(2242785), // Rule ID 65299 //
     /* 2242744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2242750 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2242753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242757 */   // MIs[0] Operand 1
     /* 2242757 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242766 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2242770 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2242770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242775 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2242781 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242783 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242784 */   // GIR_Coverage, 65299,
     /* 2242784 */   GIR_EraseRootFromParent_Done,
     /* 2242785 */ // Label 29956: @2242785
     /* 2242785 */ GIM_Try, /*On fail goto*//*Label 29957*/ GIMT_Encode4(2242828), // Rule ID 65329 //
     /* 2242790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242796 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242803 */   // MIs[0] Operand 1
     /* 2242803 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242812 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2242816 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2242816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242821 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242826 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242827 */   // GIR_Coverage, 65329,
     /* 2242827 */   GIR_EraseRootFromParent_Done,
     /* 2242828 */ // Label 29957: @2242828
     /* 2242828 */ GIM_Try, /*On fail goto*//*Label 29958*/ GIMT_Encode4(2242874), // Rule ID 65335 //
     /* 2242833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242839 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242846 */   // MIs[0] Operand 1
     /* 2242846 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242855 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2242859 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2242859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242864 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2242870 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242872 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242873 */   // GIR_Coverage, 65335,
     /* 2242873 */   GIR_EraseRootFromParent_Done,
     /* 2242874 */ // Label 29958: @2242874
     /* 2242874 */ GIM_Try, /*On fail goto*//*Label 29959*/ GIMT_Encode4(2242927), // Rule ID 154 //
     /* 2242879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242885 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242892 */   // MIs[0] Operand 1
     /* 2242892 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2242897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242901 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2242905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242909 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2242913 */   // MIs[1] Operand 1
     /* 2242913 */   // No operand predicates
     /* 2242913 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2242915 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2242915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2242918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242920 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242922 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2242925 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242926 */   // GIR_Coverage, 154,
     /* 2242926 */   GIR_EraseRootFromParent_Done,
     /* 2242927 */ // Label 29959: @2242927
     /* 2242927 */ GIM_Try, /*On fail goto*//*Label 29960*/ GIMT_Encode4(2242980), // Rule ID 158 //
     /* 2242932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242945 */   // MIs[0] Operand 1
     /* 2242945 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2242950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2242958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242962 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2242966 */   // MIs[1] Operand 1
     /* 2242966 */   // No operand predicates
     /* 2242966 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2242968 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2242968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242973 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242975 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2242978 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242979 */   // GIR_Coverage, 158,
     /* 2242979 */   GIR_EraseRootFromParent_Done,
     /* 2242980 */ // Label 29960: @2242980
     /* 2242980 */ GIM_Try, /*On fail goto*//*Label 29961*/ GIMT_Encode4(2243033), // Rule ID 65285 //
     /* 2242985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2242991 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242998 */   // MIs[0] Operand 1
     /* 2242998 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2243003 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243007 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243011 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243015 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243019 */   // MIs[1] Operand 1
     /* 2243019 */   // No operand predicates
     /* 2243019 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243021 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2243021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243026 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243028 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2243031 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243032 */   // GIR_Coverage, 65285,
     /* 2243032 */   GIR_EraseRootFromParent_Done,
     /* 2243033 */ // Label 29961: @2243033
     /* 2243033 */ GIM_Try, /*On fail goto*//*Label 29962*/ GIMT_Encode4(2243086), // Rule ID 65289 //
     /* 2243038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243044 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243051 */   // MIs[0] Operand 1
     /* 2243051 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243060 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243064 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243068 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243072 */   // MIs[1] Operand 1
     /* 2243072 */   // No operand predicates
     /* 2243072 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243074 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2243074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243079 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243081 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2243084 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243085 */   // GIR_Coverage, 65289,
     /* 2243085 */   GIR_EraseRootFromParent_Done,
     /* 2243086 */ // Label 29962: @2243086
     /* 2243086 */ GIM_Try, /*On fail goto*//*Label 29963*/ GIMT_Encode4(2243163), // Rule ID 65295 //
     /* 2243091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243097 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243104 */   // MIs[0] Operand 1
     /* 2243104 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243113 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243117 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243121 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2243125 */   // MIs[1] Operand 1
     /* 2243125 */   // No operand predicates
     /* 2243125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243127 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2243127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2243134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243139 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243143 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2243148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243161 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243162 */   // GIR_Coverage, 65295,
     /* 2243162 */   GIR_EraseRootFromParent_Done,
     /* 2243163 */ // Label 29963: @2243163
     /* 2243163 */ GIM_Try, /*On fail goto*//*Label 29964*/ GIMT_Encode4(2243243), // Rule ID 65301 //
     /* 2243168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243174 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243181 */   // MIs[0] Operand 1
     /* 2243181 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243190 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243194 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243198 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2243202 */   // MIs[1] Operand 1
     /* 2243202 */   // No operand predicates
     /* 2243202 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243204 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2243204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2243211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243216 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243220 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2243225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243232 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243241 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243242 */   // GIR_Coverage, 65301,
     /* 2243242 */   GIR_EraseRootFromParent_Done,
     /* 2243243 */ // Label 29964: @2243243
     /* 2243243 */ GIM_Try, /*On fail goto*//*Label 29965*/ GIMT_Encode4(2243320), // Rule ID 65305 //
     /* 2243248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243254 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243261 */   // MIs[0] Operand 1
     /* 2243261 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2243266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243270 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243274 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243278 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2243282 */   // MIs[1] Operand 1
     /* 2243282 */   // No operand predicates
     /* 2243282 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243284 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2243284 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243287 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243291 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243296 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243300 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243319 */   // GIR_Coverage, 65305,
     /* 2243319 */   GIR_EraseRootFromParent_Done,
     /* 2243320 */ // Label 29965: @2243320
     /* 2243320 */ GIM_Try, /*On fail goto*//*Label 29966*/ GIMT_Encode4(2243397), // Rule ID 65309 //
     /* 2243325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243331 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243338 */   // MIs[0] Operand 1
     /* 2243338 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2243343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243347 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243351 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243355 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2243359 */   // MIs[1] Operand 1
     /* 2243359 */   // No operand predicates
     /* 2243359 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243361 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2243361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243373 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243377 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243395 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243396 */   // GIR_Coverage, 65309,
     /* 2243396 */   GIR_EraseRootFromParent_Done,
     /* 2243397 */ // Label 29966: @2243397
     /* 2243397 */ GIM_Try, /*On fail goto*//*Label 29967*/ GIMT_Encode4(2243472), // Rule ID 65313 //
     /* 2243402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243408 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243415 */   // MIs[0] Operand 1
     /* 2243415 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2243420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243424 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243428 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243432 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243436 */   // MIs[1] Operand 1
     /* 2243436 */   // No operand predicates
     /* 2243436 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243438 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2243438 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243441 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243445 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243450 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243454 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2243457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243470 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243471 */   // GIR_Coverage, 65313,
     /* 2243471 */   GIR_EraseRootFromParent_Done,
     /* 2243472 */ // Label 29967: @2243472
     /* 2243472 */ GIM_Try, /*On fail goto*//*Label 29968*/ GIMT_Encode4(2243547), // Rule ID 65317 //
     /* 2243477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243483 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243490 */   // MIs[0] Operand 1
     /* 2243490 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2243495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243507 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243511 */   // MIs[1] Operand 1
     /* 2243511 */   // No operand predicates
     /* 2243511 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243513 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2243513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243525 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243529 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2243532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243546 */   // GIR_Coverage, 65317,
     /* 2243546 */   GIR_EraseRootFromParent_Done,
     /* 2243547 */ // Label 29968: @2243547
     /* 2243547 */ GIM_Try, /*On fail goto*//*Label 29969*/ GIMT_Encode4(2243602), // Rule ID 65321 //
     /* 2243552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243558 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243565 */   // MIs[0] Operand 1
     /* 2243565 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2243570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243582 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2243586 */   // MIs[1] Operand 1
     /* 2243586 */   // No operand predicates
     /* 2243586 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243588 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2243588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243593 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243595 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243600 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243601 */   // GIR_Coverage, 65321,
     /* 2243601 */   GIR_EraseRootFromParent_Done,
     /* 2243602 */ // Label 29969: @2243602
     /* 2243602 */ GIM_Try, /*On fail goto*//*Label 29970*/ GIMT_Encode4(2243657), // Rule ID 65325 //
     /* 2243607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243613 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243620 */   // MIs[0] Operand 1
     /* 2243620 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2243625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243629 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243633 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243637 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2243641 */   // MIs[1] Operand 1
     /* 2243641 */   // No operand predicates
     /* 2243641 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243643 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2243643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243648 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243650 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243656 */   // GIR_Coverage, 65325,
     /* 2243656 */   GIR_EraseRootFromParent_Done,
     /* 2243657 */ // Label 29970: @2243657
     /* 2243657 */ GIM_Try, /*On fail goto*//*Label 29971*/ GIMT_Encode4(2243734), // Rule ID 65331 //
     /* 2243662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243675 */   // MIs[0] Operand 1
     /* 2243675 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243684 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243688 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243692 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2243696 */   // MIs[1] Operand 1
     /* 2243696 */   // No operand predicates
     /* 2243696 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243698 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2243698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2243705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243710 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243714 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2243719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243726 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243732 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243733 */   // GIR_Coverage, 65331,
     /* 2243733 */   GIR_EraseRootFromParent_Done,
     /* 2243734 */ // Label 29971: @2243734
     /* 2243734 */ GIM_Try, /*On fail goto*//*Label 29972*/ GIMT_Encode4(2243814), // Rule ID 65337 //
     /* 2243739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243745 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243752 */   // MIs[0] Operand 1
     /* 2243752 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243761 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243765 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243769 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2243773 */   // MIs[1] Operand 1
     /* 2243773 */   // No operand predicates
     /* 2243773 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243775 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2243775 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243778 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2243782 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243787 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243791 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2243796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243803 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243812 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243813 */   // GIR_Coverage, 65337,
     /* 2243813 */   GIR_EraseRootFromParent_Done,
     /* 2243814 */ // Label 29972: @2243814
     /* 2243814 */ GIM_Try, /*On fail goto*//*Label 29973*/ GIMT_Encode4(2243891), // Rule ID 65341 //
     /* 2243819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243825 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243832 */   // MIs[0] Operand 1
     /* 2243832 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2243837 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243841 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243845 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243849 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2243853 */   // MIs[1] Operand 1
     /* 2243853 */   // No operand predicates
     /* 2243853 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243855 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2243855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243867 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243871 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243876 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243889 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243890 */   // GIR_Coverage, 65341,
     /* 2243890 */   GIR_EraseRootFromParent_Done,
     /* 2243891 */ // Label 29973: @2243891
     /* 2243891 */ GIM_Try, /*On fail goto*//*Label 29974*/ GIMT_Encode4(2243968), // Rule ID 65345 //
     /* 2243896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243902 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243909 */   // MIs[0] Operand 1
     /* 2243909 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2243914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243918 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243922 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243926 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2243930 */   // MIs[1] Operand 1
     /* 2243930 */   // No operand predicates
     /* 2243930 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243932 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2243932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243944 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243948 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243960 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243966 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243967 */   // GIR_Coverage, 65345,
     /* 2243967 */   GIR_EraseRootFromParent_Done,
     /* 2243968 */ // Label 29974: @2243968
     /* 2243968 */ GIM_Try, /*On fail goto*//*Label 29975*/ GIMT_Encode4(2244043), // Rule ID 65349 //
     /* 2243973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243979 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243986 */   // MIs[0] Operand 1
     /* 2243986 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2243991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243995 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243999 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244003 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2244007 */   // MIs[1] Operand 1
     /* 2244007 */   // No operand predicates
     /* 2244007 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244009 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2244009 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244012 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244016 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244021 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244025 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2244028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244041 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244042 */   // GIR_Coverage, 65349,
     /* 2244042 */   GIR_EraseRootFromParent_Done,
     /* 2244043 */ // Label 29975: @2244043
     /* 2244043 */ GIM_Try, /*On fail goto*//*Label 29976*/ GIMT_Encode4(2244118), // Rule ID 65353 //
     /* 2244048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244054 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244061 */   // MIs[0] Operand 1
     /* 2244061 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2244066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244070 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244074 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244078 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2244082 */   // MIs[1] Operand 1
     /* 2244082 */   // No operand predicates
     /* 2244082 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244084 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2244084 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244091 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244096 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244100 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2244103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244116 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244117 */   // GIR_Coverage, 65353,
     /* 2244117 */   GIR_EraseRootFromParent_Done,
     /* 2244118 */ // Label 29976: @2244118
     /* 2244118 */ GIM_Try, /*On fail goto*//*Label 29977*/ GIMT_Encode4(2244173), // Rule ID 65357 //
     /* 2244123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244129 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244136 */   // MIs[0] Operand 1
     /* 2244136 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244145 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244149 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244153 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2244157 */   // MIs[1] Operand 1
     /* 2244157 */   // No operand predicates
     /* 2244157 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244159 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2244159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244164 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244166 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244171 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244172 */   // GIR_Coverage, 65357,
     /* 2244172 */   GIR_EraseRootFromParent_Done,
     /* 2244173 */ // Label 29977: @2244173
     /* 2244173 */ GIM_Try, /*On fail goto*//*Label 29978*/ GIMT_Encode4(2244228), // Rule ID 65361 //
     /* 2244178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244184 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244191 */   // MIs[0] Operand 1
     /* 2244191 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244200 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244204 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244208 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2244212 */   // MIs[1] Operand 1
     /* 2244212 */   // No operand predicates
     /* 2244212 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244214 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2244214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244219 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244221 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244227 */   // GIR_Coverage, 65361,
     /* 2244227 */   GIR_EraseRootFromParent_Done,
     /* 2244228 */ // Label 29978: @2244228
     /* 2244228 */ GIM_Try, /*On fail goto*//*Label 29979*/ GIMT_Encode4(2244270), // Rule ID 64461 //
     /* 2244233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2244236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244239 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244246 */   // MIs[0] Operand 1
     /* 2244246 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244255 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244259 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2244262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244264 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244266 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244268 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244269 */   // GIR_Coverage, 64461,
     /* 2244269 */   GIR_EraseRootFromParent_Done,
     /* 2244270 */ // Label 29979: @2244270
     /* 2244270 */ GIM_Try, /*On fail goto*//*Label 29980*/ GIMT_Encode4(2244312), // Rule ID 64463 //
     /* 2244275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2244278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244281 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244288 */   // MIs[0] Operand 1
     /* 2244288 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244297 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244301 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2244304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244306 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244308 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244310 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244311 */   // GIR_Coverage, 64463,
     /* 2244311 */   GIR_EraseRootFromParent_Done,
     /* 2244312 */ // Label 29980: @2244312
     /* 2244312 */ GIM_Try, /*On fail goto*//*Label 29981*/ GIMT_Encode4(2244354), // Rule ID 152 //
     /* 2244317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244330 */   // MIs[0] Operand 1
     /* 2244330 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2244335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244339 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244343 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244348 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244350 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244352 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244353 */   // GIR_Coverage, 152,
     /* 2244353 */   GIR_EraseRootFromParent_Done,
     /* 2244354 */ // Label 29981: @2244354
     /* 2244354 */ GIM_Try, /*On fail goto*//*Label 29982*/ GIMT_Encode4(2244396), // Rule ID 156 //
     /* 2244359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244365 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244372 */   // MIs[0] Operand 1
     /* 2244372 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244381 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244385 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244390 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244392 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244394 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244395 */   // GIR_Coverage, 156,
     /* 2244395 */   GIR_EraseRootFromParent_Done,
     /* 2244396 */ // Label 29982: @2244396
     /* 2244396 */ GIM_Try, /*On fail goto*//*Label 29983*/ GIMT_Encode4(2244438), // Rule ID 65287 //
     /* 2244401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244407 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244414 */   // MIs[0] Operand 1
     /* 2244414 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244423 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244427 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244432 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244434 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244437 */   // GIR_Coverage, 65287,
     /* 2244437 */   GIR_EraseRootFromParent_Done,
     /* 2244438 */ // Label 29983: @2244438
     /* 2244438 */ GIM_Try, /*On fail goto*//*Label 29984*/ GIMT_Encode4(2244480), // Rule ID 65291 //
     /* 2244443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244456 */   // MIs[0] Operand 1
     /* 2244456 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2244461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244465 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244469 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244474 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244476 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244478 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244479 */   // GIR_Coverage, 65291,
     /* 2244479 */   GIR_EraseRootFromParent_Done,
     /* 2244480 */ // Label 29984: @2244480
     /* 2244480 */ GIM_Try, /*On fail goto*//*Label 29985*/ GIMT_Encode4(2244546), // Rule ID 65297 //
     /* 2244485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244491 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244498 */   // MIs[0] Operand 1
     /* 2244498 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2244503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244507 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244511 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2244511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2244518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244523 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244527 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244545 */   // GIR_Coverage, 65297,
     /* 2244545 */   GIR_EraseRootFromParent_Done,
     /* 2244546 */ // Label 29985: @2244546
     /* 2244546 */ GIM_Try, /*On fail goto*//*Label 29986*/ GIMT_Encode4(2244615), // Rule ID 65303 //
     /* 2244551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244557 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244564 */   // MIs[0] Operand 1
     /* 2244564 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2244569 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244573 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244577 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2244577 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244580 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2244584 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244589 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244593 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244604 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2244610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244613 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244614 */   // GIR_Coverage, 65303,
     /* 2244614 */   GIR_EraseRootFromParent_Done,
     /* 2244615 */ // Label 29986: @2244615
     /* 2244615 */ GIM_Try, /*On fail goto*//*Label 29987*/ GIMT_Encode4(2244657), // Rule ID 65307 //
     /* 2244620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244633 */   // MIs[0] Operand 1
     /* 2244633 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244642 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244646 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2244646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244651 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244653 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244656 */   // GIR_Coverage, 65307,
     /* 2244656 */   GIR_EraseRootFromParent_Done,
     /* 2244657 */ // Label 29987: @2244657
     /* 2244657 */ GIM_Try, /*On fail goto*//*Label 29988*/ GIMT_Encode4(2244699), // Rule ID 65311 //
     /* 2244662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244675 */   // MIs[0] Operand 1
     /* 2244675 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244684 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244688 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2244688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244693 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244695 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244697 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244698 */   // GIR_Coverage, 65311,
     /* 2244698 */   GIR_EraseRootFromParent_Done,
     /* 2244699 */ // Label 29988: @2244699
     /* 2244699 */ GIM_Try, /*On fail goto*//*Label 29989*/ GIMT_Encode4(2244765), // Rule ID 65315 //
     /* 2244704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244710 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244717 */   // MIs[0] Operand 1
     /* 2244717 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2244722 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244726 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244730 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2244730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244742 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244746 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244763 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244764 */   // GIR_Coverage, 65315,
     /* 2244764 */   GIR_EraseRootFromParent_Done,
     /* 2244765 */ // Label 29989: @2244765
     /* 2244765 */ GIM_Try, /*On fail goto*//*Label 29990*/ GIMT_Encode4(2244831), // Rule ID 65319 //
     /* 2244770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244776 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244783 */   // MIs[0] Operand 1
     /* 2244783 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2244788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244792 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244796 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2244796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244808 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244812 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244823 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244830 */   // GIR_Coverage, 65319,
     /* 2244830 */   GIR_EraseRootFromParent_Done,
     /* 2244831 */ // Label 29990: @2244831
     /* 2244831 */ GIM_Try, /*On fail goto*//*Label 29991*/ GIMT_Encode4(2244897), // Rule ID 65323 //
     /* 2244836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244842 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244849 */   // MIs[0] Operand 1
     /* 2244849 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244858 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244862 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2244862 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244865 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244869 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244874 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244878 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244889 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244896 */   // GIR_Coverage, 65323,
     /* 2244896 */   GIR_EraseRootFromParent_Done,
     /* 2244897 */ // Label 29991: @2244897
     /* 2244897 */ GIM_Try, /*On fail goto*//*Label 29992*/ GIMT_Encode4(2244963), // Rule ID 65327 //
     /* 2244902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244908 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244915 */   // MIs[0] Operand 1
     /* 2244915 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244924 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244928 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2244928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244940 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244944 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244961 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244962 */   // GIR_Coverage, 65327,
     /* 2244962 */   GIR_EraseRootFromParent_Done,
     /* 2244963 */ // Label 29992: @2244963
     /* 2244963 */ GIM_Try, /*On fail goto*//*Label 29993*/ GIMT_Encode4(2245029), // Rule ID 65333 //
     /* 2244968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244974 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244981 */   // MIs[0] Operand 1
     /* 2244981 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2244986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244990 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244994 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2244994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2245001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245006 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245010 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2245019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245027 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245028 */   // GIR_Coverage, 65333,
     /* 2245028 */   GIR_EraseRootFromParent_Done,
     /* 2245029 */ // Label 29993: @2245029
     /* 2245029 */ GIM_Try, /*On fail goto*//*Label 29994*/ GIMT_Encode4(2245098), // Rule ID 65339 //
     /* 2245034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245040 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245047 */   // MIs[0] Operand 1
     /* 2245047 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245056 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245060 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2245060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2245067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245072 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245076 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245087 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2245093 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245096 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245097 */   // GIR_Coverage, 65339,
     /* 2245097 */   GIR_EraseRootFromParent_Done,
     /* 2245098 */ // Label 29994: @2245098
     /* 2245098 */ GIM_Try, /*On fail goto*//*Label 29995*/ GIMT_Encode4(2245140), // Rule ID 65343 //
     /* 2245103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245109 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245116 */   // MIs[0] Operand 1
     /* 2245116 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245125 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245129 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2245129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245134 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245136 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245138 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245139 */   // GIR_Coverage, 65343,
     /* 2245139 */   GIR_EraseRootFromParent_Done,
     /* 2245140 */ // Label 29995: @2245140
     /* 2245140 */ GIM_Try, /*On fail goto*//*Label 29996*/ GIMT_Encode4(2245182), // Rule ID 65347 //
     /* 2245145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245151 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245158 */   // MIs[0] Operand 1
     /* 2245158 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2245163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245167 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245171 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2245171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245176 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245178 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245180 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245181 */   // GIR_Coverage, 65347,
     /* 2245181 */   GIR_EraseRootFromParent_Done,
     /* 2245182 */ // Label 29996: @2245182
     /* 2245182 */ GIM_Try, /*On fail goto*//*Label 29997*/ GIMT_Encode4(2245248), // Rule ID 65351 //
     /* 2245187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245193 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245200 */   // MIs[0] Operand 1
     /* 2245200 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2245205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245209 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245213 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2245213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245225 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245229 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245240 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245246 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245247 */   // GIR_Coverage, 65351,
     /* 2245247 */   GIR_EraseRootFromParent_Done,
     /* 2245248 */ // Label 29997: @2245248
     /* 2245248 */ GIM_Try, /*On fail goto*//*Label 29998*/ GIMT_Encode4(2245314), // Rule ID 65355 //
     /* 2245253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245259 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245266 */   // MIs[0] Operand 1
     /* 2245266 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245275 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245279 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2245279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245291 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245295 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245306 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245312 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245313 */   // GIR_Coverage, 65355,
     /* 2245313 */   GIR_EraseRootFromParent_Done,
     /* 2245314 */ // Label 29998: @2245314
     /* 2245314 */ GIM_Try, /*On fail goto*//*Label 29999*/ GIMT_Encode4(2245380), // Rule ID 65359 //
     /* 2245319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245325 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245332 */   // MIs[0] Operand 1
     /* 2245332 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245341 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245345 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2245345 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245348 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245352 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245357 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245361 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245378 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245379 */   // GIR_Coverage, 65359,
     /* 2245379 */   GIR_EraseRootFromParent_Done,
     /* 2245380 */ // Label 29999: @2245380
     /* 2245380 */ GIM_Try, /*On fail goto*//*Label 30000*/ GIMT_Encode4(2245446), // Rule ID 65363 //
     /* 2245385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245391 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245398 */   // MIs[0] Operand 1
     /* 2245398 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245407 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245411 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2245411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245423 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245427 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245438 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245445 */   // GIR_Coverage, 65363,
     /* 2245445 */   GIR_EraseRootFromParent_Done,
     /* 2245446 */ // Label 30000: @2245446
     /* 2245446 */ GIM_Reject,
     /* 2245447 */ // Label 29895: @2245447
     /* 2245447 */ GIM_Try, /*On fail goto*//*Label 30001*/ GIMT_Encode4(2245495), // Rule ID 45782 //
     /* 2245452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245458 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245465 */   // MIs[0] Operand 1
     /* 2245465 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245474 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245478 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2245481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245483 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245485 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245493 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245494 */   // GIR_Coverage, 45782,
     /* 2245494 */   GIR_EraseRootFromParent_Done,
     /* 2245495 */ // Label 30001: @2245495
     /* 2245495 */ GIM_Try, /*On fail goto*//*Label 30002*/ GIMT_Encode4(2245543), // Rule ID 45783 //
     /* 2245500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245506 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245513 */   // MIs[0] Operand 1
     /* 2245513 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245522 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245526 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2245529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245531 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245533 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245541 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245542 */   // GIR_Coverage, 45783,
     /* 2245542 */   GIR_EraseRootFromParent_Done,
     /* 2245543 */ // Label 30002: @2245543
     /* 2245543 */ GIM_Try, /*On fail goto*//*Label 30003*/ GIMT_Encode4(2245591), // Rule ID 45784 //
     /* 2245548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245554 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245561 */   // MIs[0] Operand 1
     /* 2245561 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2245566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245570 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245574 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2245577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245579 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245581 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245589 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245590 */   // GIR_Coverage, 45784,
     /* 2245590 */   GIR_EraseRootFromParent_Done,
     /* 2245591 */ // Label 30003: @2245591
     /* 2245591 */ GIM_Try, /*On fail goto*//*Label 30004*/ GIMT_Encode4(2245639), // Rule ID 45785 //
     /* 2245596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245602 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245609 */   // MIs[0] Operand 1
     /* 2245609 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2245614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245618 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245622 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2245625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245627 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245629 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245637 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245638 */   // GIR_Coverage, 45785,
     /* 2245638 */   GIR_EraseRootFromParent_Done,
     /* 2245639 */ // Label 30004: @2245639
     /* 2245639 */ GIM_Try, /*On fail goto*//*Label 30005*/ GIMT_Encode4(2245687), // Rule ID 48496 //
     /* 2245644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2245650 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2245653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245657 */   // MIs[0] Operand 1
     /* 2245657 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245666 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245670 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2245670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2245673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245675 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245677 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245685 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245686 */   // GIR_Coverage, 48496,
     /* 2245686 */   GIR_EraseRootFromParent_Done,
     /* 2245687 */ // Label 30005: @2245687
     /* 2245687 */ GIM_Try, /*On fail goto*//*Label 30006*/ GIMT_Encode4(2245735), // Rule ID 48497 //
     /* 2245692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2245698 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2245701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245705 */   // MIs[0] Operand 1
     /* 2245705 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245714 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245718 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2245718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2245721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245723 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245725 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245733 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245734 */   // GIR_Coverage, 48497,
     /* 2245734 */   GIR_EraseRootFromParent_Done,
     /* 2245735 */ // Label 30006: @2245735
     /* 2245735 */ GIM_Try, /*On fail goto*//*Label 30007*/ GIMT_Encode4(2245783), // Rule ID 48500 //
     /* 2245740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2245746 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2245749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245753 */   // MIs[0] Operand 1
     /* 2245753 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245762 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245766 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2245766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2245769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245771 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245773 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245781 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245782 */   // GIR_Coverage, 48500,
     /* 2245782 */   GIR_EraseRootFromParent_Done,
     /* 2245783 */ // Label 30007: @2245783
     /* 2245783 */ GIM_Try, /*On fail goto*//*Label 30008*/ GIMT_Encode4(2245831), // Rule ID 48501 //
     /* 2245788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2245794 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2245797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245801 */   // MIs[0] Operand 1
     /* 2245801 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245810 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245814 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2245814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2245817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245819 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245821 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245830 */   // GIR_Coverage, 48501,
     /* 2245830 */   GIR_EraseRootFromParent_Done,
     /* 2245831 */ // Label 30008: @2245831
     /* 2245831 */ GIM_Try, /*On fail goto*//*Label 30009*/ GIMT_Encode4(2245879), // Rule ID 48508 //
     /* 2245836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2245839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2245842 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2245845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245849 */   // MIs[0] Operand 1
     /* 2245849 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245858 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245862 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2245862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2245865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245867 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245869 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245877 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245878 */   // GIR_Coverage, 48508,
     /* 2245878 */   GIR_EraseRootFromParent_Done,
     /* 2245879 */ // Label 30009: @2245879
     /* 2245879 */ GIM_Try, /*On fail goto*//*Label 30010*/ GIMT_Encode4(2245927), // Rule ID 48509 //
     /* 2245884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2245887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2245890 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2245893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245897 */   // MIs[0] Operand 1
     /* 2245897 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245906 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245910 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2245910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2245913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245915 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245917 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245925 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245926 */   // GIR_Coverage, 48509,
     /* 2245926 */   GIR_EraseRootFromParent_Done,
     /* 2245927 */ // Label 30010: @2245927
     /* 2245927 */ GIM_Try, /*On fail goto*//*Label 30011*/ GIMT_Encode4(2245975), // Rule ID 48534 //
     /* 2245932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245945 */   // MIs[0] Operand 1
     /* 2245945 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245954 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245958 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2245961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245963 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245965 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245973 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245974 */   // GIR_Coverage, 48534,
     /* 2245974 */   GIR_EraseRootFromParent_Done,
     /* 2245975 */ // Label 30011: @2245975
     /* 2245975 */ GIM_Try, /*On fail goto*//*Label 30012*/ GIMT_Encode4(2246023), // Rule ID 48535 //
     /* 2245980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245986 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245993 */   // MIs[0] Operand 1
     /* 2245993 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246002 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246006 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2246009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246011 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246013 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246022 */   // GIR_Coverage, 48535,
     /* 2246022 */   GIR_EraseRootFromParent_Done,
     /* 2246023 */ // Label 30012: @2246023
     /* 2246023 */ GIM_Try, /*On fail goto*//*Label 30013*/ GIMT_Encode4(2246071), // Rule ID 48540 //
     /* 2246028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246034 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246041 */   // MIs[0] Operand 1
     /* 2246041 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246050 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246054 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2246057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246059 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246061 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246069 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246070 */   // GIR_Coverage, 48540,
     /* 2246070 */   GIR_EraseRootFromParent_Done,
     /* 2246071 */ // Label 30013: @2246071
     /* 2246071 */ GIM_Try, /*On fail goto*//*Label 30014*/ GIMT_Encode4(2246119), // Rule ID 48541 //
     /* 2246076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246082 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246089 */   // MIs[0] Operand 1
     /* 2246089 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246098 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246102 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2246105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246107 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246109 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246118 */   // GIR_Coverage, 48541,
     /* 2246118 */   GIR_EraseRootFromParent_Done,
     /* 2246119 */ // Label 30014: @2246119
     /* 2246119 */ GIM_Try, /*On fail goto*//*Label 30015*/ GIMT_Encode4(2246167), // Rule ID 48544 //
     /* 2246124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246130 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246137 */   // MIs[0] Operand 1
     /* 2246137 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246146 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246150 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2246153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246155 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246157 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246166 */   // GIR_Coverage, 48544,
     /* 2246166 */   GIR_EraseRootFromParent_Done,
     /* 2246167 */ // Label 30015: @2246167
     /* 2246167 */ GIM_Try, /*On fail goto*//*Label 30016*/ GIMT_Encode4(2246215), // Rule ID 48545 //
     /* 2246172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246178 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246185 */   // MIs[0] Operand 1
     /* 2246185 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246194 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246198 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2246201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246203 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246205 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246213 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246214 */   // GIR_Coverage, 48545,
     /* 2246214 */   GIR_EraseRootFromParent_Done,
     /* 2246215 */ // Label 30016: @2246215
     /* 2246215 */ GIM_Try, /*On fail goto*//*Label 30017*/ GIMT_Encode4(2246263), // Rule ID 48552 //
     /* 2246220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246226 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246233 */   // MIs[0] Operand 1
     /* 2246233 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246238 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246242 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246246 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2246249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246251 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246253 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246261 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246262 */   // GIR_Coverage, 48552,
     /* 2246262 */   GIR_EraseRootFromParent_Done,
     /* 2246263 */ // Label 30017: @2246263
     /* 2246263 */ GIM_Try, /*On fail goto*//*Label 30018*/ GIMT_Encode4(2246311), // Rule ID 48553 //
     /* 2246268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246274 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246281 */   // MIs[0] Operand 1
     /* 2246281 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246290 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246294 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2246297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246299 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246301 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246309 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246310 */   // GIR_Coverage, 48553,
     /* 2246310 */   GIR_EraseRootFromParent_Done,
     /* 2246311 */ // Label 30018: @2246311
     /* 2246311 */ GIM_Try, /*On fail goto*//*Label 30019*/ GIMT_Encode4(2246359), // Rule ID 48578 //
     /* 2246316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246329 */   // MIs[0] Operand 1
     /* 2246329 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246338 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246342 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2246345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246347 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246349 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246357 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246358 */   // GIR_Coverage, 48578,
     /* 2246358 */   GIR_EraseRootFromParent_Done,
     /* 2246359 */ // Label 30019: @2246359
     /* 2246359 */ GIM_Try, /*On fail goto*//*Label 30020*/ GIMT_Encode4(2246407), // Rule ID 48579 //
     /* 2246364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246377 */   // MIs[0] Operand 1
     /* 2246377 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246386 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246390 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2246393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246395 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246397 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246405 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246406 */   // GIR_Coverage, 48579,
     /* 2246406 */   GIR_EraseRootFromParent_Done,
     /* 2246407 */ // Label 30020: @2246407
     /* 2246407 */ GIM_Try, /*On fail goto*//*Label 30021*/ GIMT_Encode4(2246455), // Rule ID 48584 //
     /* 2246412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246418 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246425 */   // MIs[0] Operand 1
     /* 2246425 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246434 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246438 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2246441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246443 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246445 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246454 */   // GIR_Coverage, 48584,
     /* 2246454 */   GIR_EraseRootFromParent_Done,
     /* 2246455 */ // Label 30021: @2246455
     /* 2246455 */ GIM_Try, /*On fail goto*//*Label 30022*/ GIMT_Encode4(2246503), // Rule ID 48585 //
     /* 2246460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246466 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246473 */   // MIs[0] Operand 1
     /* 2246473 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246482 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246486 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2246489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246491 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246493 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246501 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246502 */   // GIR_Coverage, 48585,
     /* 2246502 */   GIR_EraseRootFromParent_Done,
     /* 2246503 */ // Label 30022: @2246503
     /* 2246503 */ GIM_Try, /*On fail goto*//*Label 30023*/ GIMT_Encode4(2246551), // Rule ID 48588 //
     /* 2246508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246514 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246521 */   // MIs[0] Operand 1
     /* 2246521 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246530 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246534 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2246537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246539 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246541 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246549 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246550 */   // GIR_Coverage, 48588,
     /* 2246550 */   GIR_EraseRootFromParent_Done,
     /* 2246551 */ // Label 30023: @2246551
     /* 2246551 */ GIM_Try, /*On fail goto*//*Label 30024*/ GIMT_Encode4(2246599), // Rule ID 48589 //
     /* 2246556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246562 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246569 */   // MIs[0] Operand 1
     /* 2246569 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246578 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246582 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2246585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246587 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246589 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246597 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246598 */   // GIR_Coverage, 48589,
     /* 2246598 */   GIR_EraseRootFromParent_Done,
     /* 2246599 */ // Label 30024: @2246599
     /* 2246599 */ GIM_Try, /*On fail goto*//*Label 30025*/ GIMT_Encode4(2246647), // Rule ID 48596 //
     /* 2246604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246610 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246617 */   // MIs[0] Operand 1
     /* 2246617 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246626 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246630 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2246633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246635 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246637 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246645 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246646 */   // GIR_Coverage, 48596,
     /* 2246646 */   GIR_EraseRootFromParent_Done,
     /* 2246647 */ // Label 30025: @2246647
     /* 2246647 */ GIM_Try, /*On fail goto*//*Label 30026*/ GIMT_Encode4(2246695), // Rule ID 48597 //
     /* 2246652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246658 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246665 */   // MIs[0] Operand 1
     /* 2246665 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246674 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246678 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2246681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246683 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246685 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246693 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246694 */   // GIR_Coverage, 48597,
     /* 2246694 */   GIR_EraseRootFromParent_Done,
     /* 2246695 */ // Label 30026: @2246695
     /* 2246695 */ GIM_Try, /*On fail goto*//*Label 30027*/ GIMT_Encode4(2246743), // Rule ID 48626 //
     /* 2246700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246706 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246713 */   // MIs[0] Operand 1
     /* 2246713 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246722 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246726 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2246729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246731 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246733 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246741 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246742 */   // GIR_Coverage, 48626,
     /* 2246742 */   GIR_EraseRootFromParent_Done,
     /* 2246743 */ // Label 30027: @2246743
     /* 2246743 */ GIM_Try, /*On fail goto*//*Label 30028*/ GIMT_Encode4(2246791), // Rule ID 48627 //
     /* 2246748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246754 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246761 */   // MIs[0] Operand 1
     /* 2246761 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246770 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246774 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2246777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246779 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246781 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246789 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246790 */   // GIR_Coverage, 48627,
     /* 2246790 */   GIR_EraseRootFromParent_Done,
     /* 2246791 */ // Label 30028: @2246791
     /* 2246791 */ GIM_Try, /*On fail goto*//*Label 30029*/ GIMT_Encode4(2246839), // Rule ID 48630 //
     /* 2246796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246802 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246809 */   // MIs[0] Operand 1
     /* 2246809 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246818 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246822 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2246825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246827 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246829 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246837 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246838 */   // GIR_Coverage, 48630,
     /* 2246838 */   GIR_EraseRootFromParent_Done,
     /* 2246839 */ // Label 30029: @2246839
     /* 2246839 */ GIM_Try, /*On fail goto*//*Label 30030*/ GIMT_Encode4(2246887), // Rule ID 48631 //
     /* 2246844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246850 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246857 */   // MIs[0] Operand 1
     /* 2246857 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246866 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246870 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2246873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246875 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246877 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246885 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246886 */   // GIR_Coverage, 48631,
     /* 2246886 */   GIR_EraseRootFromParent_Done,
     /* 2246887 */ // Label 30030: @2246887
     /* 2246887 */ GIM_Try, /*On fail goto*//*Label 30031*/ GIMT_Encode4(2246935), // Rule ID 48638 //
     /* 2246892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246898 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246905 */   // MIs[0] Operand 1
     /* 2246905 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246914 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246918 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2246921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246923 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246925 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246933 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246934 */   // GIR_Coverage, 48638,
     /* 2246934 */   GIR_EraseRootFromParent_Done,
     /* 2246935 */ // Label 30031: @2246935
     /* 2246935 */ GIM_Try, /*On fail goto*//*Label 30032*/ GIMT_Encode4(2246983), // Rule ID 48639 //
     /* 2246940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246946 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246953 */   // MIs[0] Operand 1
     /* 2246953 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246962 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246966 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2246969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246971 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246973 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246981 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246982 */   // GIR_Coverage, 48639,
     /* 2246982 */   GIR_EraseRootFromParent_Done,
     /* 2246983 */ // Label 30032: @2246983
     /* 2246983 */ GIM_Try, /*On fail goto*//*Label 30033*/ GIMT_Encode4(2247031), // Rule ID 48664 //
     /* 2246988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246994 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247001 */   // MIs[0] Operand 1
     /* 2247001 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247010 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247014 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2247017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247019 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247021 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247029 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247030 */   // GIR_Coverage, 48664,
     /* 2247030 */   GIR_EraseRootFromParent_Done,
     /* 2247031 */ // Label 30033: @2247031
     /* 2247031 */ GIM_Try, /*On fail goto*//*Label 30034*/ GIMT_Encode4(2247079), // Rule ID 48665 //
     /* 2247036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247049 */   // MIs[0] Operand 1
     /* 2247049 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247058 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247062 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2247065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247067 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247069 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247077 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247078 */   // GIR_Coverage, 48665,
     /* 2247078 */   GIR_EraseRootFromParent_Done,
     /* 2247079 */ // Label 30034: @2247079
     /* 2247079 */ GIM_Try, /*On fail goto*//*Label 30035*/ GIMT_Encode4(2247127), // Rule ID 48670 //
     /* 2247084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247090 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247097 */   // MIs[0] Operand 1
     /* 2247097 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247106 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247110 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2247113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247115 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247117 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247125 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247126 */   // GIR_Coverage, 48670,
     /* 2247126 */   GIR_EraseRootFromParent_Done,
     /* 2247127 */ // Label 30035: @2247127
     /* 2247127 */ GIM_Try, /*On fail goto*//*Label 30036*/ GIMT_Encode4(2247175), // Rule ID 48671 //
     /* 2247132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247138 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247145 */   // MIs[0] Operand 1
     /* 2247145 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247154 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247158 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2247161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247163 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247165 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247174 */   // GIR_Coverage, 48671,
     /* 2247174 */   GIR_EraseRootFromParent_Done,
     /* 2247175 */ // Label 30036: @2247175
     /* 2247175 */ GIM_Try, /*On fail goto*//*Label 30037*/ GIMT_Encode4(2247223), // Rule ID 48674 //
     /* 2247180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247193 */   // MIs[0] Operand 1
     /* 2247193 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247202 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247206 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2247209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247211 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247213 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247221 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247222 */   // GIR_Coverage, 48674,
     /* 2247222 */   GIR_EraseRootFromParent_Done,
     /* 2247223 */ // Label 30037: @2247223
     /* 2247223 */ GIM_Try, /*On fail goto*//*Label 30038*/ GIMT_Encode4(2247271), // Rule ID 48675 //
     /* 2247228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247234 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247241 */   // MIs[0] Operand 1
     /* 2247241 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247250 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247254 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2247257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247259 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247261 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247270 */   // GIR_Coverage, 48675,
     /* 2247270 */   GIR_EraseRootFromParent_Done,
     /* 2247271 */ // Label 30038: @2247271
     /* 2247271 */ GIM_Try, /*On fail goto*//*Label 30039*/ GIMT_Encode4(2247319), // Rule ID 48682 //
     /* 2247276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247289 */   // MIs[0] Operand 1
     /* 2247289 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247298 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247302 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2247302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2247305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247307 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247309 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247317 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247318 */   // GIR_Coverage, 48682,
     /* 2247318 */   GIR_EraseRootFromParent_Done,
     /* 2247319 */ // Label 30039: @2247319
     /* 2247319 */ GIM_Try, /*On fail goto*//*Label 30040*/ GIMT_Encode4(2247367), // Rule ID 48683 //
     /* 2247324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2247327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247330 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247337 */   // MIs[0] Operand 1
     /* 2247337 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247346 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247350 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2247350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2247353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247355 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247357 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247365 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247366 */   // GIR_Coverage, 48683,
     /* 2247366 */   GIR_EraseRootFromParent_Done,
     /* 2247367 */ // Label 30040: @2247367
     /* 2247367 */ GIM_Try, /*On fail goto*//*Label 30041*/ GIMT_Encode4(2247415), // Rule ID 48708 //
     /* 2247372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247385 */   // MIs[0] Operand 1
     /* 2247385 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247394 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247398 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2247401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247403 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247405 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247413 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247414 */   // GIR_Coverage, 48708,
     /* 2247414 */   GIR_EraseRootFromParent_Done,
     /* 2247415 */ // Label 30041: @2247415
     /* 2247415 */ GIM_Try, /*On fail goto*//*Label 30042*/ GIMT_Encode4(2247463), // Rule ID 48709 //
     /* 2247420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247426 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247433 */   // MIs[0] Operand 1
     /* 2247433 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247442 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247446 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2247449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247451 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247453 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247461 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247462 */   // GIR_Coverage, 48709,
     /* 2247462 */   GIR_EraseRootFromParent_Done,
     /* 2247463 */ // Label 30042: @2247463
     /* 2247463 */ GIM_Try, /*On fail goto*//*Label 30043*/ GIMT_Encode4(2247511), // Rule ID 48714 //
     /* 2247468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247474 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247481 */   // MIs[0] Operand 1
     /* 2247481 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247490 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247494 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2247497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247499 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247501 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247509 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247510 */   // GIR_Coverage, 48714,
     /* 2247510 */   GIR_EraseRootFromParent_Done,
     /* 2247511 */ // Label 30043: @2247511
     /* 2247511 */ GIM_Try, /*On fail goto*//*Label 30044*/ GIMT_Encode4(2247559), // Rule ID 48715 //
     /* 2247516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247522 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247529 */   // MIs[0] Operand 1
     /* 2247529 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247538 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247542 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2247545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247547 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247549 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247558 */   // GIR_Coverage, 48715,
     /* 2247558 */   GIR_EraseRootFromParent_Done,
     /* 2247559 */ // Label 30044: @2247559
     /* 2247559 */ GIM_Try, /*On fail goto*//*Label 30045*/ GIMT_Encode4(2247607), // Rule ID 48718 //
     /* 2247564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247577 */   // MIs[0] Operand 1
     /* 2247577 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247586 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247590 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2247593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247595 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247597 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247605 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247606 */   // GIR_Coverage, 48718,
     /* 2247606 */   GIR_EraseRootFromParent_Done,
     /* 2247607 */ // Label 30045: @2247607
     /* 2247607 */ GIM_Try, /*On fail goto*//*Label 30046*/ GIMT_Encode4(2247655), // Rule ID 48719 //
     /* 2247612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247625 */   // MIs[0] Operand 1
     /* 2247625 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247634 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247638 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2247641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247643 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247645 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247654 */   // GIR_Coverage, 48719,
     /* 2247654 */   GIR_EraseRootFromParent_Done,
     /* 2247655 */ // Label 30046: @2247655
     /* 2247655 */ GIM_Try, /*On fail goto*//*Label 30047*/ GIMT_Encode4(2247703), // Rule ID 48726 //
     /* 2247660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247666 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247673 */   // MIs[0] Operand 1
     /* 2247673 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247682 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247686 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2247686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2247689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247691 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247693 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247701 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247702 */   // GIR_Coverage, 48726,
     /* 2247702 */   GIR_EraseRootFromParent_Done,
     /* 2247703 */ // Label 30047: @2247703
     /* 2247703 */ GIM_Try, /*On fail goto*//*Label 30048*/ GIMT_Encode4(2247751), // Rule ID 48727 //
     /* 2247708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2247711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247714 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247721 */   // MIs[0] Operand 1
     /* 2247721 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247730 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247734 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2247734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2247737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247739 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247741 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247750 */   // GIR_Coverage, 48727,
     /* 2247750 */   GIR_EraseRootFromParent_Done,
     /* 2247751 */ // Label 30048: @2247751
     /* 2247751 */ GIM_Try, /*On fail goto*//*Label 30049*/ GIMT_Encode4(2247799), // Rule ID 48752 //
     /* 2247756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247762 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247769 */   // MIs[0] Operand 1
     /* 2247769 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247778 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247782 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2247785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247787 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247789 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247797 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247798 */   // GIR_Coverage, 48752,
     /* 2247798 */   GIR_EraseRootFromParent_Done,
     /* 2247799 */ // Label 30049: @2247799
     /* 2247799 */ GIM_Try, /*On fail goto*//*Label 30050*/ GIMT_Encode4(2247847), // Rule ID 48753 //
     /* 2247804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247810 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247817 */   // MIs[0] Operand 1
     /* 2247817 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247826 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247830 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2247833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247835 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247837 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247845 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247846 */   // GIR_Coverage, 48753,
     /* 2247846 */   GIR_EraseRootFromParent_Done,
     /* 2247847 */ // Label 30050: @2247847
     /* 2247847 */ GIM_Try, /*On fail goto*//*Label 30051*/ GIMT_Encode4(2247895), // Rule ID 48758 //
     /* 2247852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247858 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247865 */   // MIs[0] Operand 1
     /* 2247865 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247874 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247878 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2247881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247883 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247885 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247894 */   // GIR_Coverage, 48758,
     /* 2247894 */   GIR_EraseRootFromParent_Done,
     /* 2247895 */ // Label 30051: @2247895
     /* 2247895 */ GIM_Try, /*On fail goto*//*Label 30052*/ GIMT_Encode4(2247943), // Rule ID 48759 //
     /* 2247900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247906 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247913 */   // MIs[0] Operand 1
     /* 2247913 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247922 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247926 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2247929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247931 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247933 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247941 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247942 */   // GIR_Coverage, 48759,
     /* 2247942 */   GIR_EraseRootFromParent_Done,
     /* 2247943 */ // Label 30052: @2247943
     /* 2247943 */ GIM_Try, /*On fail goto*//*Label 30053*/ GIMT_Encode4(2247991), // Rule ID 48762 //
     /* 2247948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247954 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247961 */   // MIs[0] Operand 1
     /* 2247961 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247970 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247974 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2247977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247979 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247981 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247989 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247990 */   // GIR_Coverage, 48762,
     /* 2247990 */   GIR_EraseRootFromParent_Done,
     /* 2247991 */ // Label 30053: @2247991
     /* 2247991 */ GIM_Try, /*On fail goto*//*Label 30054*/ GIMT_Encode4(2248039), // Rule ID 48763 //
     /* 2247996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248002 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248009 */   // MIs[0] Operand 1
     /* 2248009 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248018 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248022 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2248025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248027 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248029 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248038 */   // GIR_Coverage, 48763,
     /* 2248038 */   GIR_EraseRootFromParent_Done,
     /* 2248039 */ // Label 30054: @2248039
     /* 2248039 */ GIM_Try, /*On fail goto*//*Label 30055*/ GIMT_Encode4(2248087), // Rule ID 48770 //
     /* 2248044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248050 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248057 */   // MIs[0] Operand 1
     /* 2248057 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248066 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248070 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248075 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248077 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248086 */   // GIR_Coverage, 48770,
     /* 2248086 */   GIR_EraseRootFromParent_Done,
     /* 2248087 */ // Label 30055: @2248087
     /* 2248087 */ GIM_Try, /*On fail goto*//*Label 30056*/ GIMT_Encode4(2248135), // Rule ID 48771 //
     /* 2248092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248098 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248105 */   // MIs[0] Operand 1
     /* 2248105 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248114 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248118 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248123 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248125 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248133 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248134 */   // GIR_Coverage, 48771,
     /* 2248134 */   GIR_EraseRootFromParent_Done,
     /* 2248135 */ // Label 30056: @2248135
     /* 2248135 */ GIM_Try, /*On fail goto*//*Label 30057*/ GIMT_Encode4(2248183), // Rule ID 48796 //
     /* 2248140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248146 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248153 */   // MIs[0] Operand 1
     /* 2248153 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248162 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248166 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2248169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248171 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248173 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248181 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248182 */   // GIR_Coverage, 48796,
     /* 2248182 */   GIR_EraseRootFromParent_Done,
     /* 2248183 */ // Label 30057: @2248183
     /* 2248183 */ GIM_Try, /*On fail goto*//*Label 30058*/ GIMT_Encode4(2248231), // Rule ID 48797 //
     /* 2248188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248201 */   // MIs[0] Operand 1
     /* 2248201 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248210 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248214 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2248217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248219 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248221 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248230 */   // GIR_Coverage, 48797,
     /* 2248230 */   GIR_EraseRootFromParent_Done,
     /* 2248231 */ // Label 30058: @2248231
     /* 2248231 */ GIM_Try, /*On fail goto*//*Label 30059*/ GIMT_Encode4(2248279), // Rule ID 48802 //
     /* 2248236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248242 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248249 */   // MIs[0] Operand 1
     /* 2248249 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248258 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248262 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2248265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248267 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248269 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248278 */   // GIR_Coverage, 48802,
     /* 2248278 */   GIR_EraseRootFromParent_Done,
     /* 2248279 */ // Label 30059: @2248279
     /* 2248279 */ GIM_Try, /*On fail goto*//*Label 30060*/ GIMT_Encode4(2248327), // Rule ID 48803 //
     /* 2248284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248290 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248297 */   // MIs[0] Operand 1
     /* 2248297 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248306 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248310 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2248313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248315 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248317 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248325 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248326 */   // GIR_Coverage, 48803,
     /* 2248326 */   GIR_EraseRootFromParent_Done,
     /* 2248327 */ // Label 30060: @2248327
     /* 2248327 */ GIM_Try, /*On fail goto*//*Label 30061*/ GIMT_Encode4(2248375), // Rule ID 48806 //
     /* 2248332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248338 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248345 */   // MIs[0] Operand 1
     /* 2248345 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248354 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248358 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2248361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248363 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248365 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248373 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248374 */   // GIR_Coverage, 48806,
     /* 2248374 */   GIR_EraseRootFromParent_Done,
     /* 2248375 */ // Label 30061: @2248375
     /* 2248375 */ GIM_Try, /*On fail goto*//*Label 30062*/ GIMT_Encode4(2248423), // Rule ID 48807 //
     /* 2248380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248386 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248393 */   // MIs[0] Operand 1
     /* 2248393 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248402 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248406 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2248409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248411 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248413 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248421 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248422 */   // GIR_Coverage, 48807,
     /* 2248422 */   GIR_EraseRootFromParent_Done,
     /* 2248423 */ // Label 30062: @2248423
     /* 2248423 */ GIM_Try, /*On fail goto*//*Label 30063*/ GIMT_Encode4(2248471), // Rule ID 48814 //
     /* 2248428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248434 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248441 */   // MIs[0] Operand 1
     /* 2248441 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248450 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248454 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248459 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248461 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248470 */   // GIR_Coverage, 48814,
     /* 2248470 */   GIR_EraseRootFromParent_Done,
     /* 2248471 */ // Label 30063: @2248471
     /* 2248471 */ GIM_Try, /*On fail goto*//*Label 30064*/ GIMT_Encode4(2248519), // Rule ID 48815 //
     /* 2248476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248482 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248489 */   // MIs[0] Operand 1
     /* 2248489 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248498 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248502 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248507 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248509 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248518 */   // GIR_Coverage, 48815,
     /* 2248518 */   GIR_EraseRootFromParent_Done,
     /* 2248519 */ // Label 30064: @2248519
     /* 2248519 */ GIM_Try, /*On fail goto*//*Label 30065*/ GIMT_Encode4(2248567), // Rule ID 48840 //
     /* 2248524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248537 */   // MIs[0] Operand 1
     /* 2248537 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248546 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248550 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2248553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248555 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248557 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248565 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248566 */   // GIR_Coverage, 48840,
     /* 2248566 */   GIR_EraseRootFromParent_Done,
     /* 2248567 */ // Label 30065: @2248567
     /* 2248567 */ GIM_Try, /*On fail goto*//*Label 30066*/ GIMT_Encode4(2248615), // Rule ID 48841 //
     /* 2248572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248578 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248585 */   // MIs[0] Operand 1
     /* 2248585 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248594 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248598 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2248601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248603 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248605 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248613 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248614 */   // GIR_Coverage, 48841,
     /* 2248614 */   GIR_EraseRootFromParent_Done,
     /* 2248615 */ // Label 30066: @2248615
     /* 2248615 */ GIM_Try, /*On fail goto*//*Label 30067*/ GIMT_Encode4(2248663), // Rule ID 48846 //
     /* 2248620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248633 */   // MIs[0] Operand 1
     /* 2248633 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248642 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248646 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2248649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248651 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248653 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248662 */   // GIR_Coverage, 48846,
     /* 2248662 */   GIR_EraseRootFromParent_Done,
     /* 2248663 */ // Label 30067: @2248663
     /* 2248663 */ GIM_Try, /*On fail goto*//*Label 30068*/ GIMT_Encode4(2248711), // Rule ID 48847 //
     /* 2248668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248674 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248681 */   // MIs[0] Operand 1
     /* 2248681 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248690 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248694 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2248697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248699 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248701 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248710 */   // GIR_Coverage, 48847,
     /* 2248710 */   GIR_EraseRootFromParent_Done,
     /* 2248711 */ // Label 30068: @2248711
     /* 2248711 */ GIM_Try, /*On fail goto*//*Label 30069*/ GIMT_Encode4(2248759), // Rule ID 48850 //
     /* 2248716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248722 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248729 */   // MIs[0] Operand 1
     /* 2248729 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248738 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248742 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2248745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248747 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248749 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248757 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248758 */   // GIR_Coverage, 48850,
     /* 2248758 */   GIR_EraseRootFromParent_Done,
     /* 2248759 */ // Label 30069: @2248759
     /* 2248759 */ GIM_Try, /*On fail goto*//*Label 30070*/ GIMT_Encode4(2248807), // Rule ID 48851 //
     /* 2248764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248770 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248777 */   // MIs[0] Operand 1
     /* 2248777 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248786 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248790 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2248793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248795 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248797 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248805 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248806 */   // GIR_Coverage, 48851,
     /* 2248806 */   GIR_EraseRootFromParent_Done,
     /* 2248807 */ // Label 30070: @2248807
     /* 2248807 */ GIM_Try, /*On fail goto*//*Label 30071*/ GIMT_Encode4(2248855), // Rule ID 48858 //
     /* 2248812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248818 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248825 */   // MIs[0] Operand 1
     /* 2248825 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248834 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248838 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2248841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248843 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248845 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248853 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248854 */   // GIR_Coverage, 48858,
     /* 2248854 */   GIR_EraseRootFromParent_Done,
     /* 2248855 */ // Label 30071: @2248855
     /* 2248855 */ GIM_Try, /*On fail goto*//*Label 30072*/ GIMT_Encode4(2248903), // Rule ID 48859 //
     /* 2248860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248866 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248873 */   // MIs[0] Operand 1
     /* 2248873 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248882 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248886 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2248889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248891 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248893 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248901 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248902 */   // GIR_Coverage, 48859,
     /* 2248902 */   GIR_EraseRootFromParent_Done,
     /* 2248903 */ // Label 30072: @2248903
     /* 2248903 */ GIM_Try, /*On fail goto*//*Label 30073*/ GIMT_Encode4(2248951), // Rule ID 48884 //
     /* 2248908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248914 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248921 */   // MIs[0] Operand 1
     /* 2248921 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2248926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248930 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248934 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2248937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248939 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248941 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248949 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248950 */   // GIR_Coverage, 48884,
     /* 2248950 */   GIR_EraseRootFromParent_Done,
     /* 2248951 */ // Label 30073: @2248951
     /* 2248951 */ GIM_Try, /*On fail goto*//*Label 30074*/ GIMT_Encode4(2248999), // Rule ID 48885 //
     /* 2248956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248962 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248969 */   // MIs[0] Operand 1
     /* 2248969 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2248974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248978 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248982 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2248985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248987 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248989 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248997 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248998 */   // GIR_Coverage, 48885,
     /* 2248998 */   GIR_EraseRootFromParent_Done,
     /* 2248999 */ // Label 30074: @2248999
     /* 2248999 */ GIM_Try, /*On fail goto*//*Label 30075*/ GIMT_Encode4(2249047), // Rule ID 48890 //
     /* 2249004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249010 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249017 */   // MIs[0] Operand 1
     /* 2249017 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249026 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249030 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2249033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249035 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249037 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249045 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249046 */   // GIR_Coverage, 48890,
     /* 2249046 */   GIR_EraseRootFromParent_Done,
     /* 2249047 */ // Label 30075: @2249047
     /* 2249047 */ GIM_Try, /*On fail goto*//*Label 30076*/ GIMT_Encode4(2249095), // Rule ID 48891 //
     /* 2249052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249058 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249065 */   // MIs[0] Operand 1
     /* 2249065 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249074 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249078 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2249081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249083 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249085 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249094 */   // GIR_Coverage, 48891,
     /* 2249094 */   GIR_EraseRootFromParent_Done,
     /* 2249095 */ // Label 30076: @2249095
     /* 2249095 */ GIM_Try, /*On fail goto*//*Label 30077*/ GIMT_Encode4(2249143), // Rule ID 48894 //
     /* 2249100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249106 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249113 */   // MIs[0] Operand 1
     /* 2249113 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249122 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249126 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2249129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249131 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249133 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249141 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249142 */   // GIR_Coverage, 48894,
     /* 2249142 */   GIR_EraseRootFromParent_Done,
     /* 2249143 */ // Label 30077: @2249143
     /* 2249143 */ GIM_Try, /*On fail goto*//*Label 30078*/ GIMT_Encode4(2249191), // Rule ID 48895 //
     /* 2249148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249154 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249161 */   // MIs[0] Operand 1
     /* 2249161 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249170 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249174 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2249177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249179 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249181 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249189 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249190 */   // GIR_Coverage, 48895,
     /* 2249190 */   GIR_EraseRootFromParent_Done,
     /* 2249191 */ // Label 30078: @2249191
     /* 2249191 */ GIM_Try, /*On fail goto*//*Label 30079*/ GIMT_Encode4(2249239), // Rule ID 48902 //
     /* 2249196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249202 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249209 */   // MIs[0] Operand 1
     /* 2249209 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249214 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249218 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249222 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2249225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249227 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249229 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249237 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249238 */   // GIR_Coverage, 48902,
     /* 2249238 */   GIR_EraseRootFromParent_Done,
     /* 2249239 */ // Label 30079: @2249239
     /* 2249239 */ GIM_Try, /*On fail goto*//*Label 30080*/ GIMT_Encode4(2249287), // Rule ID 48903 //
     /* 2249244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249250 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249257 */   // MIs[0] Operand 1
     /* 2249257 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249266 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249270 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2249273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249275 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249277 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249286 */   // GIR_Coverage, 48903,
     /* 2249286 */   GIR_EraseRootFromParent_Done,
     /* 2249287 */ // Label 30080: @2249287
     /* 2249287 */ GIM_Reject,
     /* 2249288 */ // Label 29896: @2249288
     /* 2249288 */ GIM_Try, /*On fail goto*//*Label 30081*/ GIMT_Encode4(2249336), // Rule ID 48492 //
     /* 2249293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2249299 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2249302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249306 */   // MIs[0] Operand 1
     /* 2249306 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249315 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249319 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2249322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249324 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249326 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249334 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249335 */   // GIR_Coverage, 48492,
     /* 2249335 */   GIR_EraseRootFromParent_Done,
     /* 2249336 */ // Label 30081: @2249336
     /* 2249336 */ GIM_Try, /*On fail goto*//*Label 30082*/ GIMT_Encode4(2249384), // Rule ID 48493 //
     /* 2249341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2249347 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2249350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249354 */   // MIs[0] Operand 1
     /* 2249354 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249363 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249367 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2249370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249372 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249374 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249382 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249383 */   // GIR_Coverage, 48493,
     /* 2249383 */   GIR_EraseRootFromParent_Done,
     /* 2249384 */ // Label 30082: @2249384
     /* 2249384 */ GIM_Try, /*On fail goto*//*Label 30083*/ GIMT_Encode4(2249432), // Rule ID 48498 //
     /* 2249389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2249395 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2249398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249402 */   // MIs[0] Operand 1
     /* 2249402 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249411 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249415 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2249418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249420 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249422 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249430 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249431 */   // GIR_Coverage, 48498,
     /* 2249431 */   GIR_EraseRootFromParent_Done,
     /* 2249432 */ // Label 30083: @2249432
     /* 2249432 */ GIM_Try, /*On fail goto*//*Label 30084*/ GIMT_Encode4(2249480), // Rule ID 48499 //
     /* 2249437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2249443 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2249446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249450 */   // MIs[0] Operand 1
     /* 2249450 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249459 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249463 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2249466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249468 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249470 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249478 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249479 */   // GIR_Coverage, 48499,
     /* 2249479 */   GIR_EraseRootFromParent_Done,
     /* 2249480 */ // Label 30084: @2249480
     /* 2249480 */ GIM_Try, /*On fail goto*//*Label 30085*/ GIMT_Encode4(2249528), // Rule ID 48506 //
     /* 2249485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2249491 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2249494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249498 */   // MIs[0] Operand 1
     /* 2249498 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249507 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249511 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2249514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249516 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249518 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249526 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249527 */   // GIR_Coverage, 48506,
     /* 2249527 */   GIR_EraseRootFromParent_Done,
     /* 2249528 */ // Label 30085: @2249528
     /* 2249528 */ GIM_Try, /*On fail goto*//*Label 30086*/ GIMT_Encode4(2249576), // Rule ID 48507 //
     /* 2249533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2249539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2249542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249546 */   // MIs[0] Operand 1
     /* 2249546 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249551 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249555 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249559 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2249562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249564 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249566 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249574 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249575 */   // GIR_Coverage, 48507,
     /* 2249575 */   GIR_EraseRootFromParent_Done,
     /* 2249576 */ // Label 30086: @2249576
     /* 2249576 */ GIM_Try, /*On fail goto*//*Label 30087*/ GIMT_Encode4(2249624), // Rule ID 48528 //
     /* 2249581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2249587 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2249590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249594 */   // MIs[0] Operand 1
     /* 2249594 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249603 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249607 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2249610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249612 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249614 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249623 */   // GIR_Coverage, 48528,
     /* 2249623 */   GIR_EraseRootFromParent_Done,
     /* 2249624 */ // Label 30087: @2249624
     /* 2249624 */ GIM_Try, /*On fail goto*//*Label 30088*/ GIMT_Encode4(2249672), // Rule ID 48529 //
     /* 2249629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2249635 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2249638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249642 */   // MIs[0] Operand 1
     /* 2249642 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249651 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249655 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2249658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249660 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249662 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249670 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249671 */   // GIR_Coverage, 48529,
     /* 2249671 */   GIR_EraseRootFromParent_Done,
     /* 2249672 */ // Label 30088: @2249672
     /* 2249672 */ GIM_Try, /*On fail goto*//*Label 30089*/ GIMT_Encode4(2249720), // Rule ID 48536 //
     /* 2249677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2249683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2249686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249690 */   // MIs[0] Operand 1
     /* 2249690 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249699 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249703 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2249706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249708 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249710 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249719 */   // GIR_Coverage, 48536,
     /* 2249719 */   GIR_EraseRootFromParent_Done,
     /* 2249720 */ // Label 30089: @2249720
     /* 2249720 */ GIM_Try, /*On fail goto*//*Label 30090*/ GIMT_Encode4(2249768), // Rule ID 48537 //
     /* 2249725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2249731 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2249734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249738 */   // MIs[0] Operand 1
     /* 2249738 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249747 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249751 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2249754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249756 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249758 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249767 */   // GIR_Coverage, 48537,
     /* 2249767 */   GIR_EraseRootFromParent_Done,
     /* 2249768 */ // Label 30090: @2249768
     /* 2249768 */ GIM_Try, /*On fail goto*//*Label 30091*/ GIMT_Encode4(2249816), // Rule ID 48542 //
     /* 2249773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2249779 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2249782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249786 */   // MIs[0] Operand 1
     /* 2249786 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249795 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249799 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2249802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249804 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249806 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249815 */   // GIR_Coverage, 48542,
     /* 2249815 */   GIR_EraseRootFromParent_Done,
     /* 2249816 */ // Label 30091: @2249816
     /* 2249816 */ GIM_Try, /*On fail goto*//*Label 30092*/ GIMT_Encode4(2249864), // Rule ID 48543 //
     /* 2249821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2249827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2249830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249834 */   // MIs[0] Operand 1
     /* 2249834 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249843 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249847 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2249850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249852 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249854 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249862 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249863 */   // GIR_Coverage, 48543,
     /* 2249863 */   GIR_EraseRootFromParent_Done,
     /* 2249864 */ // Label 30092: @2249864
     /* 2249864 */ GIM_Try, /*On fail goto*//*Label 30093*/ GIMT_Encode4(2249912), // Rule ID 48550 //
     /* 2249869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2249875 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2249878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249882 */   // MIs[0] Operand 1
     /* 2249882 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249891 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249895 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2249898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249900 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249902 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249910 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249911 */   // GIR_Coverage, 48550,
     /* 2249911 */   GIR_EraseRootFromParent_Done,
     /* 2249912 */ // Label 30093: @2249912
     /* 2249912 */ GIM_Try, /*On fail goto*//*Label 30094*/ GIMT_Encode4(2249960), // Rule ID 48551 //
     /* 2249917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2249923 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2249926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249930 */   // MIs[0] Operand 1
     /* 2249930 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249939 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249943 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2249946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249948 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249950 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249958 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249959 */   // GIR_Coverage, 48551,
     /* 2249959 */   GIR_EraseRootFromParent_Done,
     /* 2249960 */ // Label 30094: @2249960
     /* 2249960 */ GIM_Try, /*On fail goto*//*Label 30095*/ GIMT_Encode4(2250008), // Rule ID 48572 //
     /* 2249965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2249971 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2249974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249978 */   // MIs[0] Operand 1
     /* 2249978 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249987 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249991 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2249994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249996 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249998 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250006 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250007 */   // GIR_Coverage, 48572,
     /* 2250007 */   GIR_EraseRootFromParent_Done,
     /* 2250008 */ // Label 30095: @2250008
     /* 2250008 */ GIM_Try, /*On fail goto*//*Label 30096*/ GIMT_Encode4(2250056), // Rule ID 48573 //
     /* 2250013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250026 */   // MIs[0] Operand 1
     /* 2250026 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250035 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250039 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2250042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250044 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250046 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250054 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250055 */   // GIR_Coverage, 48573,
     /* 2250055 */   GIR_EraseRootFromParent_Done,
     /* 2250056 */ // Label 30096: @2250056
     /* 2250056 */ GIM_Try, /*On fail goto*//*Label 30097*/ GIMT_Encode4(2250104), // Rule ID 48580 //
     /* 2250061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250067 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250074 */   // MIs[0] Operand 1
     /* 2250074 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250083 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250087 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250092 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250094 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250102 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250103 */   // GIR_Coverage, 48580,
     /* 2250103 */   GIR_EraseRootFromParent_Done,
     /* 2250104 */ // Label 30097: @2250104
     /* 2250104 */ GIM_Try, /*On fail goto*//*Label 30098*/ GIMT_Encode4(2250152), // Rule ID 48581 //
     /* 2250109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250115 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250122 */   // MIs[0] Operand 1
     /* 2250122 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250131 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250135 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250140 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250142 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250150 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250151 */   // GIR_Coverage, 48581,
     /* 2250151 */   GIR_EraseRootFromParent_Done,
     /* 2250152 */ // Label 30098: @2250152
     /* 2250152 */ GIM_Try, /*On fail goto*//*Label 30099*/ GIMT_Encode4(2250200), // Rule ID 48586 //
     /* 2250157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250163 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250170 */   // MIs[0] Operand 1
     /* 2250170 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250179 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250183 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2250186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250188 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250190 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250199 */   // GIR_Coverage, 48586,
     /* 2250199 */   GIR_EraseRootFromParent_Done,
     /* 2250200 */ // Label 30099: @2250200
     /* 2250200 */ GIM_Try, /*On fail goto*//*Label 30100*/ GIMT_Encode4(2250248), // Rule ID 48587 //
     /* 2250205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250211 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250218 */   // MIs[0] Operand 1
     /* 2250218 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250227 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250231 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2250234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250236 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250238 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250246 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250247 */   // GIR_Coverage, 48587,
     /* 2250247 */   GIR_EraseRootFromParent_Done,
     /* 2250248 */ // Label 30100: @2250248
     /* 2250248 */ GIM_Try, /*On fail goto*//*Label 30101*/ GIMT_Encode4(2250296), // Rule ID 48594 //
     /* 2250253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250259 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250266 */   // MIs[0] Operand 1
     /* 2250266 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250275 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250279 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2250279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250284 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250286 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250294 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250295 */   // GIR_Coverage, 48594,
     /* 2250295 */   GIR_EraseRootFromParent_Done,
     /* 2250296 */ // Label 30101: @2250296
     /* 2250296 */ GIM_Try, /*On fail goto*//*Label 30102*/ GIMT_Encode4(2250344), // Rule ID 48595 //
     /* 2250301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250307 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250314 */   // MIs[0] Operand 1
     /* 2250314 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250323 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250327 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250332 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250334 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250342 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250343 */   // GIR_Coverage, 48595,
     /* 2250343 */   GIR_EraseRootFromParent_Done,
     /* 2250344 */ // Label 30102: @2250344
     /* 2250344 */ GIM_Try, /*On fail goto*//*Label 30103*/ GIMT_Encode4(2250392), // Rule ID 48616 //
     /* 2250349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250355 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250362 */   // MIs[0] Operand 1
     /* 2250362 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250367 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250371 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250375 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2250378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250380 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250382 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250390 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250391 */   // GIR_Coverage, 48616,
     /* 2250391 */   GIR_EraseRootFromParent_Done,
     /* 2250392 */ // Label 30103: @2250392
     /* 2250392 */ GIM_Try, /*On fail goto*//*Label 30104*/ GIMT_Encode4(2250440), // Rule ID 48617 //
     /* 2250397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250403 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250410 */   // MIs[0] Operand 1
     /* 2250410 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250419 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250423 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2250426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250428 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250430 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250439 */   // GIR_Coverage, 48617,
     /* 2250439 */   GIR_EraseRootFromParent_Done,
     /* 2250440 */ // Label 30104: @2250440
     /* 2250440 */ GIM_Try, /*On fail goto*//*Label 30105*/ GIMT_Encode4(2250488), // Rule ID 48622 //
     /* 2250445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250451 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250458 */   // MIs[0] Operand 1
     /* 2250458 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250463 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250467 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250471 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250476 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250478 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250486 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250487 */   // GIR_Coverage, 48622,
     /* 2250487 */   GIR_EraseRootFromParent_Done,
     /* 2250488 */ // Label 30105: @2250488
     /* 2250488 */ GIM_Try, /*On fail goto*//*Label 30106*/ GIMT_Encode4(2250536), // Rule ID 48623 //
     /* 2250493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250499 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250506 */   // MIs[0] Operand 1
     /* 2250506 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250515 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250519 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250524 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250526 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250534 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250535 */   // GIR_Coverage, 48623,
     /* 2250535 */   GIR_EraseRootFromParent_Done,
     /* 2250536 */ // Label 30106: @2250536
     /* 2250536 */ GIM_Try, /*On fail goto*//*Label 30107*/ GIMT_Encode4(2250584), // Rule ID 48628 //
     /* 2250541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250554 */   // MIs[0] Operand 1
     /* 2250554 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250563 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250567 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2250570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250572 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250574 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250582 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250583 */   // GIR_Coverage, 48628,
     /* 2250583 */   GIR_EraseRootFromParent_Done,
     /* 2250584 */ // Label 30107: @2250584
     /* 2250584 */ GIM_Try, /*On fail goto*//*Label 30108*/ GIMT_Encode4(2250632), // Rule ID 48629 //
     /* 2250589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250595 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250602 */   // MIs[0] Operand 1
     /* 2250602 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250607 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250611 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250615 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2250618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250620 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250622 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250630 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250631 */   // GIR_Coverage, 48629,
     /* 2250631 */   GIR_EraseRootFromParent_Done,
     /* 2250632 */ // Label 30108: @2250632
     /* 2250632 */ GIM_Try, /*On fail goto*//*Label 30109*/ GIMT_Encode4(2250680), // Rule ID 48636 //
     /* 2250637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250643 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250650 */   // MIs[0] Operand 1
     /* 2250650 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250659 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250663 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2250663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250668 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250670 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250678 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250679 */   // GIR_Coverage, 48636,
     /* 2250679 */   GIR_EraseRootFromParent_Done,
     /* 2250680 */ // Label 30109: @2250680
     /* 2250680 */ GIM_Try, /*On fail goto*//*Label 30110*/ GIMT_Encode4(2250728), // Rule ID 48637 //
     /* 2250685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250691 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250698 */   // MIs[0] Operand 1
     /* 2250698 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250707 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250711 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250716 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250718 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250726 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250727 */   // GIR_Coverage, 48637,
     /* 2250727 */   GIR_EraseRootFromParent_Done,
     /* 2250728 */ // Label 30110: @2250728
     /* 2250728 */ GIM_Try, /*On fail goto*//*Label 30111*/ GIMT_Encode4(2250776), // Rule ID 48658 //
     /* 2250733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250739 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250746 */   // MIs[0] Operand 1
     /* 2250746 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250755 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250759 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2250762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250764 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250766 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250774 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250775 */   // GIR_Coverage, 48658,
     /* 2250775 */   GIR_EraseRootFromParent_Done,
     /* 2250776 */ // Label 30111: @2250776
     /* 2250776 */ GIM_Try, /*On fail goto*//*Label 30112*/ GIMT_Encode4(2250824), // Rule ID 48659 //
     /* 2250781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250787 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250794 */   // MIs[0] Operand 1
     /* 2250794 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250803 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250807 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2250810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250812 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250814 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250822 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250823 */   // GIR_Coverage, 48659,
     /* 2250823 */   GIR_EraseRootFromParent_Done,
     /* 2250824 */ // Label 30112: @2250824
     /* 2250824 */ GIM_Try, /*On fail goto*//*Label 30113*/ GIMT_Encode4(2250872), // Rule ID 48666 //
     /* 2250829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250835 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250842 */   // MIs[0] Operand 1
     /* 2250842 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250851 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250855 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2250858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250860 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250862 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250871 */   // GIR_Coverage, 48666,
     /* 2250871 */   GIR_EraseRootFromParent_Done,
     /* 2250872 */ // Label 30113: @2250872
     /* 2250872 */ GIM_Try, /*On fail goto*//*Label 30114*/ GIMT_Encode4(2250920), // Rule ID 48667 //
     /* 2250877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250883 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250890 */   // MIs[0] Operand 1
     /* 2250890 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250899 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250903 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2250906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250908 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250910 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250919 */   // GIR_Coverage, 48667,
     /* 2250919 */   GIR_EraseRootFromParent_Done,
     /* 2250920 */ // Label 30114: @2250920
     /* 2250920 */ GIM_Try, /*On fail goto*//*Label 30115*/ GIMT_Encode4(2250968), // Rule ID 48672 //
     /* 2250925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250931 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250938 */   // MIs[0] Operand 1
     /* 2250938 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250947 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250951 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2250954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250956 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250958 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250966 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250967 */   // GIR_Coverage, 48672,
     /* 2250967 */   GIR_EraseRootFromParent_Done,
     /* 2250968 */ // Label 30115: @2250968
     /* 2250968 */ GIM_Try, /*On fail goto*//*Label 30116*/ GIMT_Encode4(2251016), // Rule ID 48673 //
     /* 2250973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250979 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250986 */   // MIs[0] Operand 1
     /* 2250986 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250995 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250999 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2251002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251004 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251006 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251014 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251015 */   // GIR_Coverage, 48673,
     /* 2251015 */   GIR_EraseRootFromParent_Done,
     /* 2251016 */ // Label 30116: @2251016
     /* 2251016 */ GIM_Try, /*On fail goto*//*Label 30117*/ GIMT_Encode4(2251064), // Rule ID 48680 //
     /* 2251021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251027 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251034 */   // MIs[0] Operand 1
     /* 2251034 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251043 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251047 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251052 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251054 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251062 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251063 */   // GIR_Coverage, 48680,
     /* 2251063 */   GIR_EraseRootFromParent_Done,
     /* 2251064 */ // Label 30117: @2251064
     /* 2251064 */ GIM_Try, /*On fail goto*//*Label 30118*/ GIMT_Encode4(2251112), // Rule ID 48681 //
     /* 2251069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251075 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251082 */   // MIs[0] Operand 1
     /* 2251082 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251091 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251095 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251100 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251102 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251111 */   // GIR_Coverage, 48681,
     /* 2251111 */   GIR_EraseRootFromParent_Done,
     /* 2251112 */ // Label 30118: @2251112
     /* 2251112 */ GIM_Try, /*On fail goto*//*Label 30119*/ GIMT_Encode4(2251160), // Rule ID 48702 //
     /* 2251117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251123 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251130 */   // MIs[0] Operand 1
     /* 2251130 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251139 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251143 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251148 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251150 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251159 */   // GIR_Coverage, 48702,
     /* 2251159 */   GIR_EraseRootFromParent_Done,
     /* 2251160 */ // Label 30119: @2251160
     /* 2251160 */ GIM_Try, /*On fail goto*//*Label 30120*/ GIMT_Encode4(2251208), // Rule ID 48703 //
     /* 2251165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251178 */   // MIs[0] Operand 1
     /* 2251178 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251187 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251191 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2251191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251196 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251198 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251207 */   // GIR_Coverage, 48703,
     /* 2251207 */   GIR_EraseRootFromParent_Done,
     /* 2251208 */ // Label 30120: @2251208
     /* 2251208 */ GIM_Try, /*On fail goto*//*Label 30121*/ GIMT_Encode4(2251256), // Rule ID 48710 //
     /* 2251213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251219 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251226 */   // MIs[0] Operand 1
     /* 2251226 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251235 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251239 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2251242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251244 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251246 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251254 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251255 */   // GIR_Coverage, 48710,
     /* 2251255 */   GIR_EraseRootFromParent_Done,
     /* 2251256 */ // Label 30121: @2251256
     /* 2251256 */ GIM_Try, /*On fail goto*//*Label 30122*/ GIMT_Encode4(2251304), // Rule ID 48711 //
     /* 2251261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251267 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251274 */   // MIs[0] Operand 1
     /* 2251274 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251283 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251287 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2251290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251292 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251294 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251302 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251303 */   // GIR_Coverage, 48711,
     /* 2251303 */   GIR_EraseRootFromParent_Done,
     /* 2251304 */ // Label 30122: @2251304
     /* 2251304 */ GIM_Try, /*On fail goto*//*Label 30123*/ GIMT_Encode4(2251352), // Rule ID 48716 //
     /* 2251309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251315 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251322 */   // MIs[0] Operand 1
     /* 2251322 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251327 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251331 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251335 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2251338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251340 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251342 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251350 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251351 */   // GIR_Coverage, 48716,
     /* 2251351 */   GIR_EraseRootFromParent_Done,
     /* 2251352 */ // Label 30123: @2251352
     /* 2251352 */ GIM_Try, /*On fail goto*//*Label 30124*/ GIMT_Encode4(2251400), // Rule ID 48717 //
     /* 2251357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251363 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251370 */   // MIs[0] Operand 1
     /* 2251370 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251379 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251383 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2251386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251388 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251390 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251398 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251399 */   // GIR_Coverage, 48717,
     /* 2251399 */   GIR_EraseRootFromParent_Done,
     /* 2251400 */ // Label 30124: @2251400
     /* 2251400 */ GIM_Try, /*On fail goto*//*Label 30125*/ GIMT_Encode4(2251448), // Rule ID 48724 //
     /* 2251405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251411 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251418 */   // MIs[0] Operand 1
     /* 2251418 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251427 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251431 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251436 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251438 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251446 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251447 */   // GIR_Coverage, 48724,
     /* 2251447 */   GIR_EraseRootFromParent_Done,
     /* 2251448 */ // Label 30125: @2251448
     /* 2251448 */ GIM_Try, /*On fail goto*//*Label 30126*/ GIMT_Encode4(2251496), // Rule ID 48725 //
     /* 2251453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251459 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251466 */   // MIs[0] Operand 1
     /* 2251466 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251475 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251479 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251484 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251486 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251494 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251495 */   // GIR_Coverage, 48725,
     /* 2251495 */   GIR_EraseRootFromParent_Done,
     /* 2251496 */ // Label 30126: @2251496
     /* 2251496 */ GIM_Try, /*On fail goto*//*Label 30127*/ GIMT_Encode4(2251544), // Rule ID 48746 //
     /* 2251501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251507 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251514 */   // MIs[0] Operand 1
     /* 2251514 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251523 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251527 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251532 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251534 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251542 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251543 */   // GIR_Coverage, 48746,
     /* 2251543 */   GIR_EraseRootFromParent_Done,
     /* 2251544 */ // Label 30127: @2251544
     /* 2251544 */ GIM_Try, /*On fail goto*//*Label 30128*/ GIMT_Encode4(2251592), // Rule ID 48747 //
     /* 2251549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251562 */   // MIs[0] Operand 1
     /* 2251562 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251571 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251575 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2251575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251580 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251582 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251590 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251591 */   // GIR_Coverage, 48747,
     /* 2251591 */   GIR_EraseRootFromParent_Done,
     /* 2251592 */ // Label 30128: @2251592
     /* 2251592 */ GIM_Try, /*On fail goto*//*Label 30129*/ GIMT_Encode4(2251640), // Rule ID 48754 //
     /* 2251597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251603 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251610 */   // MIs[0] Operand 1
     /* 2251610 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251619 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251623 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2251626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251628 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251630 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251638 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251639 */   // GIR_Coverage, 48754,
     /* 2251639 */   GIR_EraseRootFromParent_Done,
     /* 2251640 */ // Label 30129: @2251640
     /* 2251640 */ GIM_Try, /*On fail goto*//*Label 30130*/ GIMT_Encode4(2251688), // Rule ID 48755 //
     /* 2251645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251651 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251658 */   // MIs[0] Operand 1
     /* 2251658 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251667 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251671 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2251674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251676 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251678 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251686 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251687 */   // GIR_Coverage, 48755,
     /* 2251687 */   GIR_EraseRootFromParent_Done,
     /* 2251688 */ // Label 30130: @2251688
     /* 2251688 */ GIM_Try, /*On fail goto*//*Label 30131*/ GIMT_Encode4(2251736), // Rule ID 48760 //
     /* 2251693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251699 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251706 */   // MIs[0] Operand 1
     /* 2251706 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251715 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251719 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2251722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251724 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251726 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251734 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251735 */   // GIR_Coverage, 48760,
     /* 2251735 */   GIR_EraseRootFromParent_Done,
     /* 2251736 */ // Label 30131: @2251736
     /* 2251736 */ GIM_Try, /*On fail goto*//*Label 30132*/ GIMT_Encode4(2251784), // Rule ID 48761 //
     /* 2251741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251747 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251754 */   // MIs[0] Operand 1
     /* 2251754 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251763 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251767 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2251770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251772 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251774 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251782 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251783 */   // GIR_Coverage, 48761,
     /* 2251783 */   GIR_EraseRootFromParent_Done,
     /* 2251784 */ // Label 30132: @2251784
     /* 2251784 */ GIM_Try, /*On fail goto*//*Label 30133*/ GIMT_Encode4(2251832), // Rule ID 48768 //
     /* 2251789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251795 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251802 */   // MIs[0] Operand 1
     /* 2251802 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251811 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251815 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2251818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251820 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251822 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251830 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251831 */   // GIR_Coverage, 48768,
     /* 2251831 */   GIR_EraseRootFromParent_Done,
     /* 2251832 */ // Label 30133: @2251832
     /* 2251832 */ GIM_Try, /*On fail goto*//*Label 30134*/ GIMT_Encode4(2251880), // Rule ID 48769 //
     /* 2251837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251843 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251850 */   // MIs[0] Operand 1
     /* 2251850 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251859 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251863 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2251866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251868 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251870 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251878 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251879 */   // GIR_Coverage, 48769,
     /* 2251879 */   GIR_EraseRootFromParent_Done,
     /* 2251880 */ // Label 30134: @2251880
     /* 2251880 */ GIM_Try, /*On fail goto*//*Label 30135*/ GIMT_Encode4(2251928), // Rule ID 48790 //
     /* 2251885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251891 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251898 */   // MIs[0] Operand 1
     /* 2251898 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251907 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251911 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2251914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251916 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251918 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251926 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251927 */   // GIR_Coverage, 48790,
     /* 2251927 */   GIR_EraseRootFromParent_Done,
     /* 2251928 */ // Label 30135: @2251928
     /* 2251928 */ GIM_Try, /*On fail goto*//*Label 30136*/ GIMT_Encode4(2251976), // Rule ID 48791 //
     /* 2251933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251946 */   // MIs[0] Operand 1
     /* 2251946 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251955 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251959 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2251959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2251962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251964 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251966 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251974 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251975 */   // GIR_Coverage, 48791,
     /* 2251975 */   GIR_EraseRootFromParent_Done,
     /* 2251976 */ // Label 30136: @2251976
     /* 2251976 */ GIM_Try, /*On fail goto*//*Label 30137*/ GIMT_Encode4(2252024), // Rule ID 48798 //
     /* 2251981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251987 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251994 */   // MIs[0] Operand 1
     /* 2251994 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252003 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252007 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2252010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252012 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252014 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252022 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252023 */   // GIR_Coverage, 48798,
     /* 2252023 */   GIR_EraseRootFromParent_Done,
     /* 2252024 */ // Label 30137: @2252024
     /* 2252024 */ GIM_Try, /*On fail goto*//*Label 30138*/ GIMT_Encode4(2252072), // Rule ID 48799 //
     /* 2252029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252035 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252042 */   // MIs[0] Operand 1
     /* 2252042 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252047 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252051 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252055 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2252058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252060 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252062 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252070 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252071 */   // GIR_Coverage, 48799,
     /* 2252071 */   GIR_EraseRootFromParent_Done,
     /* 2252072 */ // Label 30138: @2252072
     /* 2252072 */ GIM_Try, /*On fail goto*//*Label 30139*/ GIMT_Encode4(2252120), // Rule ID 48804 //
     /* 2252077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252083 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252090 */   // MIs[0] Operand 1
     /* 2252090 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252099 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252103 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2252106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252108 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252110 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252118 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252119 */   // GIR_Coverage, 48804,
     /* 2252119 */   GIR_EraseRootFromParent_Done,
     /* 2252120 */ // Label 30139: @2252120
     /* 2252120 */ GIM_Try, /*On fail goto*//*Label 30140*/ GIMT_Encode4(2252168), // Rule ID 48805 //
     /* 2252125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252131 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252138 */   // MIs[0] Operand 1
     /* 2252138 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252143 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252147 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252151 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2252154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252156 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252158 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252166 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252167 */   // GIR_Coverage, 48805,
     /* 2252167 */   GIR_EraseRootFromParent_Done,
     /* 2252168 */ // Label 30140: @2252168
     /* 2252168 */ GIM_Try, /*On fail goto*//*Label 30141*/ GIMT_Encode4(2252216), // Rule ID 48812 //
     /* 2252173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252179 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252186 */   // MIs[0] Operand 1
     /* 2252186 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252195 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252199 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2252202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252204 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252206 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252214 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252215 */   // GIR_Coverage, 48812,
     /* 2252215 */   GIR_EraseRootFromParent_Done,
     /* 2252216 */ // Label 30141: @2252216
     /* 2252216 */ GIM_Try, /*On fail goto*//*Label 30142*/ GIMT_Encode4(2252264), // Rule ID 48813 //
     /* 2252221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252227 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252234 */   // MIs[0] Operand 1
     /* 2252234 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252243 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252247 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2252250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252252 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252254 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252262 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252263 */   // GIR_Coverage, 48813,
     /* 2252263 */   GIR_EraseRootFromParent_Done,
     /* 2252264 */ // Label 30142: @2252264
     /* 2252264 */ GIM_Try, /*On fail goto*//*Label 30143*/ GIMT_Encode4(2252312), // Rule ID 48834 //
     /* 2252269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2252272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252275 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252282 */   // MIs[0] Operand 1
     /* 2252282 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252291 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252295 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2252295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252300 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252302 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252310 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252311 */   // GIR_Coverage, 48834,
     /* 2252311 */   GIR_EraseRootFromParent_Done,
     /* 2252312 */ // Label 30143: @2252312
     /* 2252312 */ GIM_Try, /*On fail goto*//*Label 30144*/ GIMT_Encode4(2252360), // Rule ID 48835 //
     /* 2252317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2252320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252330 */   // MIs[0] Operand 1
     /* 2252330 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252339 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252343 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2252343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252348 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252350 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252358 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252359 */   // GIR_Coverage, 48835,
     /* 2252359 */   GIR_EraseRootFromParent_Done,
     /* 2252360 */ // Label 30144: @2252360
     /* 2252360 */ GIM_Try, /*On fail goto*//*Label 30145*/ GIMT_Encode4(2252408), // Rule ID 48842 //
     /* 2252365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252371 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252378 */   // MIs[0] Operand 1
     /* 2252378 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252387 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252391 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252396 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252398 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252406 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252407 */   // GIR_Coverage, 48842,
     /* 2252407 */   GIR_EraseRootFromParent_Done,
     /* 2252408 */ // Label 30145: @2252408
     /* 2252408 */ GIM_Try, /*On fail goto*//*Label 30146*/ GIMT_Encode4(2252456), // Rule ID 48843 //
     /* 2252413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252419 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252426 */   // MIs[0] Operand 1
     /* 2252426 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252435 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252439 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252444 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252446 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252454 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252455 */   // GIR_Coverage, 48843,
     /* 2252455 */   GIR_EraseRootFromParent_Done,
     /* 2252456 */ // Label 30146: @2252456
     /* 2252456 */ GIM_Try, /*On fail goto*//*Label 30147*/ GIMT_Encode4(2252504), // Rule ID 48848 //
     /* 2252461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252467 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252474 */   // MIs[0] Operand 1
     /* 2252474 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252483 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252487 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252492 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252494 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252503 */   // GIR_Coverage, 48848,
     /* 2252503 */   GIR_EraseRootFromParent_Done,
     /* 2252504 */ // Label 30147: @2252504
     /* 2252504 */ GIM_Try, /*On fail goto*//*Label 30148*/ GIMT_Encode4(2252552), // Rule ID 48849 //
     /* 2252509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252515 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252522 */   // MIs[0] Operand 1
     /* 2252522 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252531 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252535 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252540 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252542 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252550 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252551 */   // GIR_Coverage, 48849,
     /* 2252551 */   GIR_EraseRootFromParent_Done,
     /* 2252552 */ // Label 30148: @2252552
     /* 2252552 */ GIM_Try, /*On fail goto*//*Label 30149*/ GIMT_Encode4(2252600), // Rule ID 48856 //
     /* 2252557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252563 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252570 */   // MIs[0] Operand 1
     /* 2252570 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252579 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252583 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2252586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252588 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252590 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252599 */   // GIR_Coverage, 48856,
     /* 2252599 */   GIR_EraseRootFromParent_Done,
     /* 2252600 */ // Label 30149: @2252600
     /* 2252600 */ GIM_Try, /*On fail goto*//*Label 30150*/ GIMT_Encode4(2252648), // Rule ID 48857 //
     /* 2252605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252611 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252618 */   // MIs[0] Operand 1
     /* 2252618 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252627 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252631 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2252634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252636 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252638 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252646 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252647 */   // GIR_Coverage, 48857,
     /* 2252647 */   GIR_EraseRootFromParent_Done,
     /* 2252648 */ // Label 30150: @2252648
     /* 2252648 */ GIM_Try, /*On fail goto*//*Label 30151*/ GIMT_Encode4(2252696), // Rule ID 48878 //
     /* 2252653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2252656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252659 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252666 */   // MIs[0] Operand 1
     /* 2252666 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252675 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252679 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2252679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2252682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252684 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252686 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252694 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252695 */   // GIR_Coverage, 48878,
     /* 2252695 */   GIR_EraseRootFromParent_Done,
     /* 2252696 */ // Label 30151: @2252696
     /* 2252696 */ GIM_Try, /*On fail goto*//*Label 30152*/ GIMT_Encode4(2252744), // Rule ID 48879 //
     /* 2252701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2252704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252714 */   // MIs[0] Operand 1
     /* 2252714 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252723 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252727 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2252727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2252730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252732 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252734 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252742 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252743 */   // GIR_Coverage, 48879,
     /* 2252743 */   GIR_EraseRootFromParent_Done,
     /* 2252744 */ // Label 30152: @2252744
     /* 2252744 */ GIM_Try, /*On fail goto*//*Label 30153*/ GIMT_Encode4(2252792), // Rule ID 48886 //
     /* 2252749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252755 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252762 */   // MIs[0] Operand 1
     /* 2252762 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252771 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252775 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252780 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252782 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252791 */   // GIR_Coverage, 48886,
     /* 2252791 */   GIR_EraseRootFromParent_Done,
     /* 2252792 */ // Label 30153: @2252792
     /* 2252792 */ GIM_Try, /*On fail goto*//*Label 30154*/ GIMT_Encode4(2252840), // Rule ID 48887 //
     /* 2252797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252803 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252810 */   // MIs[0] Operand 1
     /* 2252810 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252819 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252823 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252828 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252830 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252838 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252839 */   // GIR_Coverage, 48887,
     /* 2252839 */   GIR_EraseRootFromParent_Done,
     /* 2252840 */ // Label 30154: @2252840
     /* 2252840 */ GIM_Try, /*On fail goto*//*Label 30155*/ GIMT_Encode4(2252888), // Rule ID 48892 //
     /* 2252845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252851 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252858 */   // MIs[0] Operand 1
     /* 2252858 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252867 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252871 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252876 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252878 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252887 */   // GIR_Coverage, 48892,
     /* 2252887 */   GIR_EraseRootFromParent_Done,
     /* 2252888 */ // Label 30155: @2252888
     /* 2252888 */ GIM_Try, /*On fail goto*//*Label 30156*/ GIMT_Encode4(2252936), // Rule ID 48893 //
     /* 2252893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252899 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252906 */   // MIs[0] Operand 1
     /* 2252906 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252915 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252919 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252924 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252926 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252935 */   // GIR_Coverage, 48893,
     /* 2252935 */   GIR_EraseRootFromParent_Done,
     /* 2252936 */ // Label 30156: @2252936
     /* 2252936 */ GIM_Try, /*On fail goto*//*Label 30157*/ GIMT_Encode4(2252984), // Rule ID 48900 //
     /* 2252941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252947 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252954 */   // MIs[0] Operand 1
     /* 2252954 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252959 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252963 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252967 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2252970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252972 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252974 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252982 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252983 */   // GIR_Coverage, 48900,
     /* 2252983 */   GIR_EraseRootFromParent_Done,
     /* 2252984 */ // Label 30157: @2252984
     /* 2252984 */ GIM_Try, /*On fail goto*//*Label 30158*/ GIMT_Encode4(2253032), // Rule ID 48901 //
     /* 2252989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252995 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253002 */   // MIs[0] Operand 1
     /* 2253002 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253011 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253015 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2253018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253020 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253022 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253031 */   // GIR_Coverage, 48901,
     /* 2253031 */   GIR_EraseRootFromParent_Done,
     /* 2253032 */ // Label 30158: @2253032
     /* 2253032 */ GIM_Try, /*On fail goto*//*Label 30159*/ GIMT_Encode4(2253080), // Rule ID 48922 //
     /* 2253037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253043 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253050 */   // MIs[0] Operand 1
     /* 2253050 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253059 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253063 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253068 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253070 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253078 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253079 */   // GIR_Coverage, 48922,
     /* 2253079 */   GIR_EraseRootFromParent_Done,
     /* 2253080 */ // Label 30159: @2253080
     /* 2253080 */ GIM_Try, /*On fail goto*//*Label 30160*/ GIMT_Encode4(2253128), // Rule ID 48923 //
     /* 2253085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253091 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253098 */   // MIs[0] Operand 1
     /* 2253098 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253107 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253111 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253116 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253118 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253126 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253127 */   // GIR_Coverage, 48923,
     /* 2253127 */   GIR_EraseRootFromParent_Done,
     /* 2253128 */ // Label 30160: @2253128
     /* 2253128 */ GIM_Reject,
     /* 2253129 */ // Label 29897: @2253129
     /* 2253129 */ GIM_Try, /*On fail goto*//*Label 30161*/ GIMT_Encode4(2253177), // Rule ID 48494 //
     /* 2253134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253140 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253147 */   // MIs[0] Operand 1
     /* 2253147 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253152 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253156 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253160 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2253163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253165 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253167 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253175 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253176 */   // GIR_Coverage, 48494,
     /* 2253176 */   GIR_EraseRootFromParent_Done,
     /* 2253177 */ // Label 30161: @2253177
     /* 2253177 */ GIM_Try, /*On fail goto*//*Label 30162*/ GIMT_Encode4(2253225), // Rule ID 48495 //
     /* 2253182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253188 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253195 */   // MIs[0] Operand 1
     /* 2253195 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253204 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253208 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2253211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253213 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253215 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253223 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253224 */   // GIR_Coverage, 48495,
     /* 2253224 */   GIR_EraseRootFromParent_Done,
     /* 2253225 */ // Label 30162: @2253225
     /* 2253225 */ GIM_Try, /*On fail goto*//*Label 30163*/ GIMT_Encode4(2253273), // Rule ID 48504 //
     /* 2253230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2253236 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2253239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253243 */   // MIs[0] Operand 1
     /* 2253243 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253252 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253256 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2253259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253261 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253263 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253271 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253272 */   // GIR_Coverage, 48504,
     /* 2253272 */   GIR_EraseRootFromParent_Done,
     /* 2253273 */ // Label 30163: @2253273
     /* 2253273 */ GIM_Try, /*On fail goto*//*Label 30164*/ GIMT_Encode4(2253321), // Rule ID 48505 //
     /* 2253278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2253284 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2253287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253291 */   // MIs[0] Operand 1
     /* 2253291 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253300 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253304 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2253307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253309 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253311 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253319 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253320 */   // GIR_Coverage, 48505,
     /* 2253320 */   GIR_EraseRootFromParent_Done,
     /* 2253321 */ // Label 30164: @2253321
     /* 2253321 */ GIM_Try, /*On fail goto*//*Label 30165*/ GIMT_Encode4(2253369), // Rule ID 48522 //
     /* 2253326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2253332 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2253335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253339 */   // MIs[0] Operand 1
     /* 2253339 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253348 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253352 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2253355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253357 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253359 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253367 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253368 */   // GIR_Coverage, 48522,
     /* 2253368 */   GIR_EraseRootFromParent_Done,
     /* 2253369 */ // Label 30165: @2253369
     /* 2253369 */ GIM_Try, /*On fail goto*//*Label 30166*/ GIMT_Encode4(2253417), // Rule ID 48523 //
     /* 2253374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2253380 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2253383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253387 */   // MIs[0] Operand 1
     /* 2253387 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253396 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253400 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2253403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253405 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253407 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253416 */   // GIR_Coverage, 48523,
     /* 2253416 */   GIR_EraseRootFromParent_Done,
     /* 2253417 */ // Label 30166: @2253417
     /* 2253417 */ GIM_Try, /*On fail goto*//*Label 30167*/ GIMT_Encode4(2253465), // Rule ID 48530 //
     /* 2253422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253428 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253435 */   // MIs[0] Operand 1
     /* 2253435 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253444 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253448 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2253451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253453 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253455 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253463 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253464 */   // GIR_Coverage, 48530,
     /* 2253464 */   GIR_EraseRootFromParent_Done,
     /* 2253465 */ // Label 30167: @2253465
     /* 2253465 */ GIM_Try, /*On fail goto*//*Label 30168*/ GIMT_Encode4(2253513), // Rule ID 48531 //
     /* 2253470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253476 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253483 */   // MIs[0] Operand 1
     /* 2253483 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253492 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253496 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2253499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253501 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253503 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253511 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253512 */   // GIR_Coverage, 48531,
     /* 2253512 */   GIR_EraseRootFromParent_Done,
     /* 2253513 */ // Label 30168: @2253513
     /* 2253513 */ GIM_Try, /*On fail goto*//*Label 30169*/ GIMT_Encode4(2253561), // Rule ID 48538 //
     /* 2253518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253524 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253531 */   // MIs[0] Operand 1
     /* 2253531 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253540 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253544 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2253547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253549 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253551 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253559 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253560 */   // GIR_Coverage, 48538,
     /* 2253560 */   GIR_EraseRootFromParent_Done,
     /* 2253561 */ // Label 30169: @2253561
     /* 2253561 */ GIM_Try, /*On fail goto*//*Label 30170*/ GIMT_Encode4(2253609), // Rule ID 48539 //
     /* 2253566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253572 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253579 */   // MIs[0] Operand 1
     /* 2253579 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253588 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253592 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2253595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253597 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253599 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253607 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253608 */   // GIR_Coverage, 48539,
     /* 2253608 */   GIR_EraseRootFromParent_Done,
     /* 2253609 */ // Label 30170: @2253609
     /* 2253609 */ GIM_Try, /*On fail goto*//*Label 30171*/ GIMT_Encode4(2253657), // Rule ID 48548 //
     /* 2253614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2253620 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2253623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253627 */   // MIs[0] Operand 1
     /* 2253627 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253636 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253640 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2253643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253645 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253647 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253656 */   // GIR_Coverage, 48548,
     /* 2253656 */   GIR_EraseRootFromParent_Done,
     /* 2253657 */ // Label 30171: @2253657
     /* 2253657 */ GIM_Try, /*On fail goto*//*Label 30172*/ GIMT_Encode4(2253705), // Rule ID 48549 //
     /* 2253662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2253668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2253671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253675 */   // MIs[0] Operand 1
     /* 2253675 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253684 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253688 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2253691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253693 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253695 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253703 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253704 */   // GIR_Coverage, 48549,
     /* 2253704 */   GIR_EraseRootFromParent_Done,
     /* 2253705 */ // Label 30172: @2253705
     /* 2253705 */ GIM_Try, /*On fail goto*//*Label 30173*/ GIMT_Encode4(2253753), // Rule ID 48566 //
     /* 2253710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2253716 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2253719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253723 */   // MIs[0] Operand 1
     /* 2253723 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253732 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253736 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2253739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253741 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253743 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253751 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253752 */   // GIR_Coverage, 48566,
     /* 2253752 */   GIR_EraseRootFromParent_Done,
     /* 2253753 */ // Label 30173: @2253753
     /* 2253753 */ GIM_Try, /*On fail goto*//*Label 30174*/ GIMT_Encode4(2253801), // Rule ID 48567 //
     /* 2253758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2253764 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2253767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253771 */   // MIs[0] Operand 1
     /* 2253771 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253776 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253780 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253784 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2253787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253789 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253791 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253799 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253800 */   // GIR_Coverage, 48567,
     /* 2253800 */   GIR_EraseRootFromParent_Done,
     /* 2253801 */ // Label 30174: @2253801
     /* 2253801 */ GIM_Try, /*On fail goto*//*Label 30175*/ GIMT_Encode4(2253849), // Rule ID 48574 //
     /* 2253806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253812 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253819 */   // MIs[0] Operand 1
     /* 2253819 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253828 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253832 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2253835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253837 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253839 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253847 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253848 */   // GIR_Coverage, 48574,
     /* 2253848 */   GIR_EraseRootFromParent_Done,
     /* 2253849 */ // Label 30175: @2253849
     /* 2253849 */ GIM_Try, /*On fail goto*//*Label 30176*/ GIMT_Encode4(2253897), // Rule ID 48575 //
     /* 2253854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253860 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253867 */   // MIs[0] Operand 1
     /* 2253867 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253876 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253880 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2253883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253885 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253887 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253896 */   // GIR_Coverage, 48575,
     /* 2253896 */   GIR_EraseRootFromParent_Done,
     /* 2253897 */ // Label 30176: @2253897
     /* 2253897 */ GIM_Try, /*On fail goto*//*Label 30177*/ GIMT_Encode4(2253945), // Rule ID 48582 //
     /* 2253902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253908 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253915 */   // MIs[0] Operand 1
     /* 2253915 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253924 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253928 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2253931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253933 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253935 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253943 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253944 */   // GIR_Coverage, 48582,
     /* 2253944 */   GIR_EraseRootFromParent_Done,
     /* 2253945 */ // Label 30177: @2253945
     /* 2253945 */ GIM_Try, /*On fail goto*//*Label 30178*/ GIMT_Encode4(2253993), // Rule ID 48583 //
     /* 2253950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253956 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253963 */   // MIs[0] Operand 1
     /* 2253963 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253972 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253976 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2253979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253981 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253983 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253991 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253992 */   // GIR_Coverage, 48583,
     /* 2253992 */   GIR_EraseRootFromParent_Done,
     /* 2253993 */ // Label 30178: @2253993
     /* 2253993 */ GIM_Try, /*On fail goto*//*Label 30179*/ GIMT_Encode4(2254041), // Rule ID 48592 //
     /* 2253998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254004 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254011 */   // MIs[0] Operand 1
     /* 2254011 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254020 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254024 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254029 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254031 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254039 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254040 */   // GIR_Coverage, 48592,
     /* 2254040 */   GIR_EraseRootFromParent_Done,
     /* 2254041 */ // Label 30179: @2254041
     /* 2254041 */ GIM_Try, /*On fail goto*//*Label 30180*/ GIMT_Encode4(2254089), // Rule ID 48593 //
     /* 2254046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254052 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254059 */   // MIs[0] Operand 1
     /* 2254059 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254068 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254072 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254077 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254079 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254087 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254088 */   // GIR_Coverage, 48593,
     /* 2254088 */   GIR_EraseRootFromParent_Done,
     /* 2254089 */ // Label 30180: @2254089
     /* 2254089 */ GIM_Try, /*On fail goto*//*Label 30181*/ GIMT_Encode4(2254137), // Rule ID 48610 //
     /* 2254094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254100 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254107 */   // MIs[0] Operand 1
     /* 2254107 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254112 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254116 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254120 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254125 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254127 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254135 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254136 */   // GIR_Coverage, 48610,
     /* 2254136 */   GIR_EraseRootFromParent_Done,
     /* 2254137 */ // Label 30181: @2254137
     /* 2254137 */ GIM_Try, /*On fail goto*//*Label 30182*/ GIMT_Encode4(2254185), // Rule ID 48611 //
     /* 2254142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254148 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254155 */   // MIs[0] Operand 1
     /* 2254155 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254164 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254168 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254173 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254175 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254183 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254184 */   // GIR_Coverage, 48611,
     /* 2254184 */   GIR_EraseRootFromParent_Done,
     /* 2254185 */ // Label 30182: @2254185
     /* 2254185 */ GIM_Try, /*On fail goto*//*Label 30183*/ GIMT_Encode4(2254233), // Rule ID 48618 //
     /* 2254190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254196 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254203 */   // MIs[0] Operand 1
     /* 2254203 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254212 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254216 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254221 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254223 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254231 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254232 */   // GIR_Coverage, 48618,
     /* 2254232 */   GIR_EraseRootFromParent_Done,
     /* 2254233 */ // Label 30183: @2254233
     /* 2254233 */ GIM_Try, /*On fail goto*//*Label 30184*/ GIMT_Encode4(2254281), // Rule ID 48619 //
     /* 2254238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254244 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254251 */   // MIs[0] Operand 1
     /* 2254251 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254260 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254264 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254269 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254271 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254279 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254280 */   // GIR_Coverage, 48619,
     /* 2254280 */   GIR_EraseRootFromParent_Done,
     /* 2254281 */ // Label 30184: @2254281
     /* 2254281 */ GIM_Try, /*On fail goto*//*Label 30185*/ GIMT_Encode4(2254329), // Rule ID 48624 //
     /* 2254286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254292 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254299 */   // MIs[0] Operand 1
     /* 2254299 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254308 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254312 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2254315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254317 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254319 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254327 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254328 */   // GIR_Coverage, 48624,
     /* 2254328 */   GIR_EraseRootFromParent_Done,
     /* 2254329 */ // Label 30185: @2254329
     /* 2254329 */ GIM_Try, /*On fail goto*//*Label 30186*/ GIMT_Encode4(2254377), // Rule ID 48625 //
     /* 2254334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254340 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254347 */   // MIs[0] Operand 1
     /* 2254347 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254356 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254360 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2254363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254365 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254367 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254375 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254376 */   // GIR_Coverage, 48625,
     /* 2254376 */   GIR_EraseRootFromParent_Done,
     /* 2254377 */ // Label 30186: @2254377
     /* 2254377 */ GIM_Try, /*On fail goto*//*Label 30187*/ GIMT_Encode4(2254425), // Rule ID 48634 //
     /* 2254382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254388 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254395 */   // MIs[0] Operand 1
     /* 2254395 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254404 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254408 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254413 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254415 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254423 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254424 */   // GIR_Coverage, 48634,
     /* 2254424 */   GIR_EraseRootFromParent_Done,
     /* 2254425 */ // Label 30187: @2254425
     /* 2254425 */ GIM_Try, /*On fail goto*//*Label 30188*/ GIMT_Encode4(2254473), // Rule ID 48635 //
     /* 2254430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254436 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254443 */   // MIs[0] Operand 1
     /* 2254443 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254452 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254456 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254461 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254463 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254471 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254472 */   // GIR_Coverage, 48635,
     /* 2254472 */   GIR_EraseRootFromParent_Done,
     /* 2254473 */ // Label 30188: @2254473
     /* 2254473 */ GIM_Try, /*On fail goto*//*Label 30189*/ GIMT_Encode4(2254521), // Rule ID 48652 //
     /* 2254478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254484 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254491 */   // MIs[0] Operand 1
     /* 2254491 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254500 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254504 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254509 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254511 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254519 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254520 */   // GIR_Coverage, 48652,
     /* 2254520 */   GIR_EraseRootFromParent_Done,
     /* 2254521 */ // Label 30189: @2254521
     /* 2254521 */ GIM_Try, /*On fail goto*//*Label 30190*/ GIMT_Encode4(2254569), // Rule ID 48653 //
     /* 2254526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254532 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254539 */   // MIs[0] Operand 1
     /* 2254539 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254548 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254552 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254557 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254559 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254567 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254568 */   // GIR_Coverage, 48653,
     /* 2254568 */   GIR_EraseRootFromParent_Done,
     /* 2254569 */ // Label 30190: @2254569
     /* 2254569 */ GIM_Try, /*On fail goto*//*Label 30191*/ GIMT_Encode4(2254617), // Rule ID 48660 //
     /* 2254574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254580 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254587 */   // MIs[0] Operand 1
     /* 2254587 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254596 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254600 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254605 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254607 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254615 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254616 */   // GIR_Coverage, 48660,
     /* 2254616 */   GIR_EraseRootFromParent_Done,
     /* 2254617 */ // Label 30191: @2254617
     /* 2254617 */ GIM_Try, /*On fail goto*//*Label 30192*/ GIMT_Encode4(2254665), // Rule ID 48661 //
     /* 2254622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254628 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254635 */   // MIs[0] Operand 1
     /* 2254635 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254644 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254648 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254653 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254655 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254663 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254664 */   // GIR_Coverage, 48661,
     /* 2254664 */   GIR_EraseRootFromParent_Done,
     /* 2254665 */ // Label 30192: @2254665
     /* 2254665 */ GIM_Try, /*On fail goto*//*Label 30193*/ GIMT_Encode4(2254713), // Rule ID 48668 //
     /* 2254670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254676 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254683 */   // MIs[0] Operand 1
     /* 2254683 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254692 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254696 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2254699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254701 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254703 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254711 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254712 */   // GIR_Coverage, 48668,
     /* 2254712 */   GIR_EraseRootFromParent_Done,
     /* 2254713 */ // Label 30193: @2254713
     /* 2254713 */ GIM_Try, /*On fail goto*//*Label 30194*/ GIMT_Encode4(2254761), // Rule ID 48669 //
     /* 2254718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254724 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254731 */   // MIs[0] Operand 1
     /* 2254731 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254740 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254744 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2254747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254749 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254751 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254759 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254760 */   // GIR_Coverage, 48669,
     /* 2254760 */   GIR_EraseRootFromParent_Done,
     /* 2254761 */ // Label 30194: @2254761
     /* 2254761 */ GIM_Try, /*On fail goto*//*Label 30195*/ GIMT_Encode4(2254809), // Rule ID 48678 //
     /* 2254766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254772 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254779 */   // MIs[0] Operand 1
     /* 2254779 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254788 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254792 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2254795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254797 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254799 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254807 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254808 */   // GIR_Coverage, 48678,
     /* 2254808 */   GIR_EraseRootFromParent_Done,
     /* 2254809 */ // Label 30195: @2254809
     /* 2254809 */ GIM_Try, /*On fail goto*//*Label 30196*/ GIMT_Encode4(2254857), // Rule ID 48679 //
     /* 2254814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254820 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254827 */   // MIs[0] Operand 1
     /* 2254827 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254836 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254840 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2254843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254845 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254847 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254855 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254856 */   // GIR_Coverage, 48679,
     /* 2254856 */   GIR_EraseRootFromParent_Done,
     /* 2254857 */ // Label 30196: @2254857
     /* 2254857 */ GIM_Try, /*On fail goto*//*Label 30197*/ GIMT_Encode4(2254905), // Rule ID 48696 //
     /* 2254862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254868 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254875 */   // MIs[0] Operand 1
     /* 2254875 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254884 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254888 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2254891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254893 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254895 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254903 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254904 */   // GIR_Coverage, 48696,
     /* 2254904 */   GIR_EraseRootFromParent_Done,
     /* 2254905 */ // Label 30197: @2254905
     /* 2254905 */ GIM_Try, /*On fail goto*//*Label 30198*/ GIMT_Encode4(2254953), // Rule ID 48697 //
     /* 2254910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254916 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254923 */   // MIs[0] Operand 1
     /* 2254923 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254932 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254936 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2254939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254941 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254943 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254951 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254952 */   // GIR_Coverage, 48697,
     /* 2254952 */   GIR_EraseRootFromParent_Done,
     /* 2254953 */ // Label 30198: @2254953
     /* 2254953 */ GIM_Try, /*On fail goto*//*Label 30199*/ GIMT_Encode4(2255001), // Rule ID 48704 //
     /* 2254958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254964 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254971 */   // MIs[0] Operand 1
     /* 2254971 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254980 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254984 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2254987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254989 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254991 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254999 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255000 */   // GIR_Coverage, 48704,
     /* 2255000 */   GIR_EraseRootFromParent_Done,
     /* 2255001 */ // Label 30199: @2255001
     /* 2255001 */ GIM_Try, /*On fail goto*//*Label 30200*/ GIMT_Encode4(2255049), // Rule ID 48705 //
     /* 2255006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2255009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255012 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255019 */   // MIs[0] Operand 1
     /* 2255019 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255028 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255032 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2255035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255037 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255039 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255047 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255048 */   // GIR_Coverage, 48705,
     /* 2255048 */   GIR_EraseRootFromParent_Done,
     /* 2255049 */ // Label 30200: @2255049
     /* 2255049 */ GIM_Try, /*On fail goto*//*Label 30201*/ GIMT_Encode4(2255097), // Rule ID 48712 //
     /* 2255054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255060 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255067 */   // MIs[0] Operand 1
     /* 2255067 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255076 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255080 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2255083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255085 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255087 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255095 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255096 */   // GIR_Coverage, 48712,
     /* 2255096 */   GIR_EraseRootFromParent_Done,
     /* 2255097 */ // Label 30201: @2255097
     /* 2255097 */ GIM_Try, /*On fail goto*//*Label 30202*/ GIMT_Encode4(2255145), // Rule ID 48713 //
     /* 2255102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255108 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255115 */   // MIs[0] Operand 1
     /* 2255115 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255124 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255128 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2255131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255133 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255135 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255143 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255144 */   // GIR_Coverage, 48713,
     /* 2255144 */   GIR_EraseRootFromParent_Done,
     /* 2255145 */ // Label 30202: @2255145
     /* 2255145 */ GIM_Try, /*On fail goto*//*Label 30203*/ GIMT_Encode4(2255193), // Rule ID 48722 //
     /* 2255150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255156 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255163 */   // MIs[0] Operand 1
     /* 2255163 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255172 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255176 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2255179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255181 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255183 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255191 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255192 */   // GIR_Coverage, 48722,
     /* 2255192 */   GIR_EraseRootFromParent_Done,
     /* 2255193 */ // Label 30203: @2255193
     /* 2255193 */ GIM_Try, /*On fail goto*//*Label 30204*/ GIMT_Encode4(2255241), // Rule ID 48723 //
     /* 2255198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255204 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255211 */   // MIs[0] Operand 1
     /* 2255211 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255220 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255224 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2255227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255229 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255231 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255239 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255240 */   // GIR_Coverage, 48723,
     /* 2255240 */   GIR_EraseRootFromParent_Done,
     /* 2255241 */ // Label 30204: @2255241
     /* 2255241 */ GIM_Try, /*On fail goto*//*Label 30205*/ GIMT_Encode4(2255289), // Rule ID 48740 //
     /* 2255246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255252 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255259 */   // MIs[0] Operand 1
     /* 2255259 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255268 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255272 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2255275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255277 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255279 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255287 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255288 */   // GIR_Coverage, 48740,
     /* 2255288 */   GIR_EraseRootFromParent_Done,
     /* 2255289 */ // Label 30205: @2255289
     /* 2255289 */ GIM_Try, /*On fail goto*//*Label 30206*/ GIMT_Encode4(2255337), // Rule ID 48741 //
     /* 2255294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255300 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255307 */   // MIs[0] Operand 1
     /* 2255307 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255312 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255316 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255320 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2255323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255325 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255327 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255335 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255336 */   // GIR_Coverage, 48741,
     /* 2255336 */   GIR_EraseRootFromParent_Done,
     /* 2255337 */ // Label 30206: @2255337
     /* 2255337 */ GIM_Try, /*On fail goto*//*Label 30207*/ GIMT_Encode4(2255385), // Rule ID 48748 //
     /* 2255342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2255345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255348 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255355 */   // MIs[0] Operand 1
     /* 2255355 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255360 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255364 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255368 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2255371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255373 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255375 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255383 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255384 */   // GIR_Coverage, 48748,
     /* 2255384 */   GIR_EraseRootFromParent_Done,
     /* 2255385 */ // Label 30207: @2255385
     /* 2255385 */ GIM_Try, /*On fail goto*//*Label 30208*/ GIMT_Encode4(2255433), // Rule ID 48749 //
     /* 2255390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2255393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255396 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255403 */   // MIs[0] Operand 1
     /* 2255403 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255412 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255416 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2255419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255421 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255423 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255431 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255432 */   // GIR_Coverage, 48749,
     /* 2255432 */   GIR_EraseRootFromParent_Done,
     /* 2255433 */ // Label 30208: @2255433
     /* 2255433 */ GIM_Try, /*On fail goto*//*Label 30209*/ GIMT_Encode4(2255481), // Rule ID 48756 //
     /* 2255438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255444 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255451 */   // MIs[0] Operand 1
     /* 2255451 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255460 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255464 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255469 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255471 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255479 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255480 */   // GIR_Coverage, 48756,
     /* 2255480 */   GIR_EraseRootFromParent_Done,
     /* 2255481 */ // Label 30209: @2255481
     /* 2255481 */ GIM_Try, /*On fail goto*//*Label 30210*/ GIMT_Encode4(2255529), // Rule ID 48757 //
     /* 2255486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255492 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255499 */   // MIs[0] Operand 1
     /* 2255499 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255508 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255512 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255517 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255519 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255527 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255528 */   // GIR_Coverage, 48757,
     /* 2255528 */   GIR_EraseRootFromParent_Done,
     /* 2255529 */ // Label 30210: @2255529
     /* 2255529 */ GIM_Try, /*On fail goto*//*Label 30211*/ GIMT_Encode4(2255577), // Rule ID 48766 //
     /* 2255534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255540 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255547 */   // MIs[0] Operand 1
     /* 2255547 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255556 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255560 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2255563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255565 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255567 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255575 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255576 */   // GIR_Coverage, 48766,
     /* 2255576 */   GIR_EraseRootFromParent_Done,
     /* 2255577 */ // Label 30211: @2255577
     /* 2255577 */ GIM_Try, /*On fail goto*//*Label 30212*/ GIMT_Encode4(2255625), // Rule ID 48767 //
     /* 2255582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255588 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255595 */   // MIs[0] Operand 1
     /* 2255595 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255604 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255608 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2255611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255613 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255615 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255623 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255624 */   // GIR_Coverage, 48767,
     /* 2255624 */   GIR_EraseRootFromParent_Done,
     /* 2255625 */ // Label 30212: @2255625
     /* 2255625 */ GIM_Try, /*On fail goto*//*Label 30213*/ GIMT_Encode4(2255673), // Rule ID 48784 //
     /* 2255630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255636 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255643 */   // MIs[0] Operand 1
     /* 2255643 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255652 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255656 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2255659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255661 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255663 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255671 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255672 */   // GIR_Coverage, 48784,
     /* 2255672 */   GIR_EraseRootFromParent_Done,
     /* 2255673 */ // Label 30213: @2255673
     /* 2255673 */ GIM_Try, /*On fail goto*//*Label 30214*/ GIMT_Encode4(2255721), // Rule ID 48785 //
     /* 2255678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255684 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255691 */   // MIs[0] Operand 1
     /* 2255691 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255700 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255704 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2255707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255709 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255711 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255719 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255720 */   // GIR_Coverage, 48785,
     /* 2255720 */   GIR_EraseRootFromParent_Done,
     /* 2255721 */ // Label 30214: @2255721
     /* 2255721 */ GIM_Try, /*On fail goto*//*Label 30215*/ GIMT_Encode4(2255769), // Rule ID 48792 //
     /* 2255726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2255729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255732 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255739 */   // MIs[0] Operand 1
     /* 2255739 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255748 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255752 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2255755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255757 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255759 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255767 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255768 */   // GIR_Coverage, 48792,
     /* 2255768 */   GIR_EraseRootFromParent_Done,
     /* 2255769 */ // Label 30215: @2255769
     /* 2255769 */ GIM_Try, /*On fail goto*//*Label 30216*/ GIMT_Encode4(2255817), // Rule ID 48793 //
     /* 2255774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2255777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255780 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255787 */   // MIs[0] Operand 1
     /* 2255787 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255796 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255800 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2255803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255805 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255807 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255816 */   // GIR_Coverage, 48793,
     /* 2255816 */   GIR_EraseRootFromParent_Done,
     /* 2255817 */ // Label 30216: @2255817
     /* 2255817 */ GIM_Try, /*On fail goto*//*Label 30217*/ GIMT_Encode4(2255865), // Rule ID 48800 //
     /* 2255822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255828 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255835 */   // MIs[0] Operand 1
     /* 2255835 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255844 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255848 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255853 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255855 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255863 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255864 */   // GIR_Coverage, 48800,
     /* 2255864 */   GIR_EraseRootFromParent_Done,
     /* 2255865 */ // Label 30217: @2255865
     /* 2255865 */ GIM_Try, /*On fail goto*//*Label 30218*/ GIMT_Encode4(2255913), // Rule ID 48801 //
     /* 2255870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255876 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255883 */   // MIs[0] Operand 1
     /* 2255883 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255892 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255896 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255901 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255903 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255911 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255912 */   // GIR_Coverage, 48801,
     /* 2255912 */   GIR_EraseRootFromParent_Done,
     /* 2255913 */ // Label 30218: @2255913
     /* 2255913 */ GIM_Try, /*On fail goto*//*Label 30219*/ GIMT_Encode4(2255961), // Rule ID 48810 //
     /* 2255918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255924 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255931 */   // MIs[0] Operand 1
     /* 2255931 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255940 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255944 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2255947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255949 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255951 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255959 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255960 */   // GIR_Coverage, 48810,
     /* 2255960 */   GIR_EraseRootFromParent_Done,
     /* 2255961 */ // Label 30219: @2255961
     /* 2255961 */ GIM_Try, /*On fail goto*//*Label 30220*/ GIMT_Encode4(2256009), // Rule ID 48811 //
     /* 2255966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255972 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255979 */   // MIs[0] Operand 1
     /* 2255979 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255988 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255992 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2255995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255997 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255999 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256008 */   // GIR_Coverage, 48811,
     /* 2256008 */   GIR_EraseRootFromParent_Done,
     /* 2256009 */ // Label 30220: @2256009
     /* 2256009 */ GIM_Try, /*On fail goto*//*Label 30221*/ GIMT_Encode4(2256057), // Rule ID 48828 //
     /* 2256014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256020 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256027 */   // MIs[0] Operand 1
     /* 2256027 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256036 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256040 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2256043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256045 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256047 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256055 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256056 */   // GIR_Coverage, 48828,
     /* 2256056 */   GIR_EraseRootFromParent_Done,
     /* 2256057 */ // Label 30221: @2256057
     /* 2256057 */ GIM_Try, /*On fail goto*//*Label 30222*/ GIMT_Encode4(2256105), // Rule ID 48829 //
     /* 2256062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256075 */   // MIs[0] Operand 1
     /* 2256075 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256084 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256088 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2256091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256093 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256095 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256104 */   // GIR_Coverage, 48829,
     /* 2256104 */   GIR_EraseRootFromParent_Done,
     /* 2256105 */ // Label 30222: @2256105
     /* 2256105 */ GIM_Try, /*On fail goto*//*Label 30223*/ GIMT_Encode4(2256153), // Rule ID 48836 //
     /* 2256110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256116 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256123 */   // MIs[0] Operand 1
     /* 2256123 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256132 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256136 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2256139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256141 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256143 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256151 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256152 */   // GIR_Coverage, 48836,
     /* 2256152 */   GIR_EraseRootFromParent_Done,
     /* 2256153 */ // Label 30223: @2256153
     /* 2256153 */ GIM_Try, /*On fail goto*//*Label 30224*/ GIMT_Encode4(2256201), // Rule ID 48837 //
     /* 2256158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256164 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256171 */   // MIs[0] Operand 1
     /* 2256171 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256180 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256184 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2256187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256189 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256191 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256199 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256200 */   // GIR_Coverage, 48837,
     /* 2256200 */   GIR_EraseRootFromParent_Done,
     /* 2256201 */ // Label 30224: @2256201
     /* 2256201 */ GIM_Try, /*On fail goto*//*Label 30225*/ GIMT_Encode4(2256249), // Rule ID 48844 //
     /* 2256206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256212 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256219 */   // MIs[0] Operand 1
     /* 2256219 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256228 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256232 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2256235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256237 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256239 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256247 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256248 */   // GIR_Coverage, 48844,
     /* 2256248 */   GIR_EraseRootFromParent_Done,
     /* 2256249 */ // Label 30225: @2256249
     /* 2256249 */ GIM_Try, /*On fail goto*//*Label 30226*/ GIMT_Encode4(2256297), // Rule ID 48845 //
     /* 2256254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256267 */   // MIs[0] Operand 1
     /* 2256267 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256276 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256280 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2256283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256285 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256287 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256295 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256296 */   // GIR_Coverage, 48845,
     /* 2256296 */   GIR_EraseRootFromParent_Done,
     /* 2256297 */ // Label 30226: @2256297
     /* 2256297 */ GIM_Try, /*On fail goto*//*Label 30227*/ GIMT_Encode4(2256345), // Rule ID 48854 //
     /* 2256302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256308 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256315 */   // MIs[0] Operand 1
     /* 2256315 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256324 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256328 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256333 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256335 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256344 */   // GIR_Coverage, 48854,
     /* 2256344 */   GIR_EraseRootFromParent_Done,
     /* 2256345 */ // Label 30227: @2256345
     /* 2256345 */ GIM_Try, /*On fail goto*//*Label 30228*/ GIMT_Encode4(2256393), // Rule ID 48855 //
     /* 2256350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256356 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256363 */   // MIs[0] Operand 1
     /* 2256363 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256372 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256376 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256381 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256383 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256392 */   // GIR_Coverage, 48855,
     /* 2256392 */   GIR_EraseRootFromParent_Done,
     /* 2256393 */ // Label 30228: @2256393
     /* 2256393 */ GIM_Try, /*On fail goto*//*Label 30229*/ GIMT_Encode4(2256441), // Rule ID 48872 //
     /* 2256398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256404 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256411 */   // MIs[0] Operand 1
     /* 2256411 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256420 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256424 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256429 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256431 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256440 */   // GIR_Coverage, 48872,
     /* 2256440 */   GIR_EraseRootFromParent_Done,
     /* 2256441 */ // Label 30229: @2256441
     /* 2256441 */ GIM_Try, /*On fail goto*//*Label 30230*/ GIMT_Encode4(2256489), // Rule ID 48873 //
     /* 2256446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256452 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256459 */   // MIs[0] Operand 1
     /* 2256459 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256468 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256472 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256477 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256479 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256487 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256488 */   // GIR_Coverage, 48873,
     /* 2256488 */   GIR_EraseRootFromParent_Done,
     /* 2256489 */ // Label 30230: @2256489
     /* 2256489 */ GIM_Try, /*On fail goto*//*Label 30231*/ GIMT_Encode4(2256537), // Rule ID 48880 //
     /* 2256494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256500 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256507 */   // MIs[0] Operand 1
     /* 2256507 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256516 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256520 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2256523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256525 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256527 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256535 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256536 */   // GIR_Coverage, 48880,
     /* 2256536 */   GIR_EraseRootFromParent_Done,
     /* 2256537 */ // Label 30231: @2256537
     /* 2256537 */ GIM_Try, /*On fail goto*//*Label 30232*/ GIMT_Encode4(2256585), // Rule ID 48881 //
     /* 2256542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256548 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256555 */   // MIs[0] Operand 1
     /* 2256555 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256564 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256568 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2256571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256573 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256575 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256583 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256584 */   // GIR_Coverage, 48881,
     /* 2256584 */   GIR_EraseRootFromParent_Done,
     /* 2256585 */ // Label 30232: @2256585
     /* 2256585 */ GIM_Try, /*On fail goto*//*Label 30233*/ GIMT_Encode4(2256633), // Rule ID 48888 //
     /* 2256590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256596 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256603 */   // MIs[0] Operand 1
     /* 2256603 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256612 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256616 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2256619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256621 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256623 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256632 */   // GIR_Coverage, 48888,
     /* 2256632 */   GIR_EraseRootFromParent_Done,
     /* 2256633 */ // Label 30233: @2256633
     /* 2256633 */ GIM_Try, /*On fail goto*//*Label 30234*/ GIMT_Encode4(2256681), // Rule ID 48889 //
     /* 2256638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256644 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256651 */   // MIs[0] Operand 1
     /* 2256651 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256660 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256664 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2256667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256669 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256671 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256679 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256680 */   // GIR_Coverage, 48889,
     /* 2256680 */   GIR_EraseRootFromParent_Done,
     /* 2256681 */ // Label 30234: @2256681
     /* 2256681 */ GIM_Try, /*On fail goto*//*Label 30235*/ GIMT_Encode4(2256729), // Rule ID 48898 //
     /* 2256686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256699 */   // MIs[0] Operand 1
     /* 2256699 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256708 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256712 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256717 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256719 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256727 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256728 */   // GIR_Coverage, 48898,
     /* 2256728 */   GIR_EraseRootFromParent_Done,
     /* 2256729 */ // Label 30235: @2256729
     /* 2256729 */ GIM_Try, /*On fail goto*//*Label 30236*/ GIMT_Encode4(2256777), // Rule ID 48899 //
     /* 2256734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256740 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256747 */   // MIs[0] Operand 1
     /* 2256747 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256756 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256760 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256765 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256767 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256775 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256776 */   // GIR_Coverage, 48899,
     /* 2256776 */   GIR_EraseRootFromParent_Done,
     /* 2256777 */ // Label 30236: @2256777
     /* 2256777 */ GIM_Try, /*On fail goto*//*Label 30237*/ GIMT_Encode4(2256825), // Rule ID 48916 //
     /* 2256782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256788 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256795 */   // MIs[0] Operand 1
     /* 2256795 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256804 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256808 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256813 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256815 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256823 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256824 */   // GIR_Coverage, 48916,
     /* 2256824 */   GIR_EraseRootFromParent_Done,
     /* 2256825 */ // Label 30237: @2256825
     /* 2256825 */ GIM_Try, /*On fail goto*//*Label 30238*/ GIMT_Encode4(2256873), // Rule ID 48917 //
     /* 2256830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256836 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256843 */   // MIs[0] Operand 1
     /* 2256843 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256852 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256856 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256861 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256863 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256871 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256872 */   // GIR_Coverage, 48917,
     /* 2256872 */   GIR_EraseRootFromParent_Done,
     /* 2256873 */ // Label 30238: @2256873
     /* 2256873 */ GIM_Try, /*On fail goto*//*Label 30239*/ GIMT_Encode4(2256921), // Rule ID 48924 //
     /* 2256878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256884 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256891 */   // MIs[0] Operand 1
     /* 2256891 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256900 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256904 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2256907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256909 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256911 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256919 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256920 */   // GIR_Coverage, 48924,
     /* 2256920 */   GIR_EraseRootFromParent_Done,
     /* 2256921 */ // Label 30239: @2256921
     /* 2256921 */ GIM_Try, /*On fail goto*//*Label 30240*/ GIMT_Encode4(2256969), // Rule ID 48925 //
     /* 2256926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256932 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256939 */   // MIs[0] Operand 1
     /* 2256939 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256948 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256952 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2256955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256957 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256959 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256967 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256968 */   // GIR_Coverage, 48925,
     /* 2256968 */   GIR_EraseRootFromParent_Done,
     /* 2256969 */ // Label 30240: @2256969
     /* 2256969 */ GIM_Reject,
     /* 2256970 */ // Label 29898: @2256970
     /* 2256970 */ GIM_Try, /*On fail goto*//*Label 30241*/ GIMT_Encode4(2257018), // Rule ID 48502 //
     /* 2256975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2256981 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2256984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256988 */   // MIs[0] Operand 1
     /* 2256988 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256997 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257001 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2257004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257006 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257008 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257016 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257017 */   // GIR_Coverage, 48502,
     /* 2257017 */   GIR_EraseRootFromParent_Done,
     /* 2257018 */ // Label 30241: @2257018
     /* 2257018 */ GIM_Try, /*On fail goto*//*Label 30242*/ GIMT_Encode4(2257066), // Rule ID 48503 //
     /* 2257023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257029 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257036 */   // MIs[0] Operand 1
     /* 2257036 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257045 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257049 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2257052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257054 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257056 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257064 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257065 */   // GIR_Coverage, 48503,
     /* 2257065 */   GIR_EraseRootFromParent_Done,
     /* 2257066 */ // Label 30242: @2257066
     /* 2257066 */ GIM_Try, /*On fail goto*//*Label 30243*/ GIMT_Encode4(2257114), // Rule ID 48516 //
     /* 2257071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257077 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257084 */   // MIs[0] Operand 1
     /* 2257084 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257093 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257097 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2257100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257102 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257104 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257112 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257113 */   // GIR_Coverage, 48516,
     /* 2257113 */   GIR_EraseRootFromParent_Done,
     /* 2257114 */ // Label 30243: @2257114
     /* 2257114 */ GIM_Try, /*On fail goto*//*Label 30244*/ GIMT_Encode4(2257162), // Rule ID 48517 //
     /* 2257119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257125 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257132 */   // MIs[0] Operand 1
     /* 2257132 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257141 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257145 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2257148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257150 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257152 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257160 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257161 */   // GIR_Coverage, 48517,
     /* 2257161 */   GIR_EraseRootFromParent_Done,
     /* 2257162 */ // Label 30244: @2257162
     /* 2257162 */ GIM_Try, /*On fail goto*//*Label 30245*/ GIMT_Encode4(2257210), // Rule ID 48524 //
     /* 2257167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257173 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257180 */   // MIs[0] Operand 1
     /* 2257180 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257189 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257193 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2257196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257198 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257200 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257208 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257209 */   // GIR_Coverage, 48524,
     /* 2257209 */   GIR_EraseRootFromParent_Done,
     /* 2257210 */ // Label 30245: @2257210
     /* 2257210 */ GIM_Try, /*On fail goto*//*Label 30246*/ GIMT_Encode4(2257258), // Rule ID 48525 //
     /* 2257215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257221 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257228 */   // MIs[0] Operand 1
     /* 2257228 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257237 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257241 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2257244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257246 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257248 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257256 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257257 */   // GIR_Coverage, 48525,
     /* 2257257 */   GIR_EraseRootFromParent_Done,
     /* 2257258 */ // Label 30246: @2257258
     /* 2257258 */ GIM_Try, /*On fail goto*//*Label 30247*/ GIMT_Encode4(2257306), // Rule ID 48532 //
     /* 2257263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2257266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257269 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257276 */   // MIs[0] Operand 1
     /* 2257276 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257285 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257289 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2257289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2257292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257294 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257296 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257304 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257305 */   // GIR_Coverage, 48532,
     /* 2257305 */   GIR_EraseRootFromParent_Done,
     /* 2257306 */ // Label 30247: @2257306
     /* 2257306 */ GIM_Try, /*On fail goto*//*Label 30248*/ GIMT_Encode4(2257354), // Rule ID 48533 //
     /* 2257311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2257314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257324 */   // MIs[0] Operand 1
     /* 2257324 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257333 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257337 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2257340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257342 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257344 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257352 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257353 */   // GIR_Coverage, 48533,
     /* 2257353 */   GIR_EraseRootFromParent_Done,
     /* 2257354 */ // Label 30248: @2257354
     /* 2257354 */ GIM_Try, /*On fail goto*//*Label 30249*/ GIMT_Encode4(2257402), // Rule ID 48546 //
     /* 2257359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257365 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257372 */   // MIs[0] Operand 1
     /* 2257372 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257381 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257385 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2257388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257390 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257392 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257400 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257401 */   // GIR_Coverage, 48546,
     /* 2257401 */   GIR_EraseRootFromParent_Done,
     /* 2257402 */ // Label 30249: @2257402
     /* 2257402 */ GIM_Try, /*On fail goto*//*Label 30250*/ GIMT_Encode4(2257450), // Rule ID 48547 //
     /* 2257407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257413 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257420 */   // MIs[0] Operand 1
     /* 2257420 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257429 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257433 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2257436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257438 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257440 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257448 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257449 */   // GIR_Coverage, 48547,
     /* 2257449 */   GIR_EraseRootFromParent_Done,
     /* 2257450 */ // Label 30250: @2257450
     /* 2257450 */ GIM_Try, /*On fail goto*//*Label 30251*/ GIMT_Encode4(2257498), // Rule ID 48560 //
     /* 2257455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257461 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257468 */   // MIs[0] Operand 1
     /* 2257468 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257477 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257481 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2257484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257486 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257488 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257496 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257497 */   // GIR_Coverage, 48560,
     /* 2257497 */   GIR_EraseRootFromParent_Done,
     /* 2257498 */ // Label 30251: @2257498
     /* 2257498 */ GIM_Try, /*On fail goto*//*Label 30252*/ GIMT_Encode4(2257546), // Rule ID 48561 //
     /* 2257503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257509 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257516 */   // MIs[0] Operand 1
     /* 2257516 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257525 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257529 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2257532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257534 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257536 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257545 */   // GIR_Coverage, 48561,
     /* 2257545 */   GIR_EraseRootFromParent_Done,
     /* 2257546 */ // Label 30252: @2257546
     /* 2257546 */ GIM_Try, /*On fail goto*//*Label 30253*/ GIMT_Encode4(2257594), // Rule ID 48568 //
     /* 2257551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257557 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257564 */   // MIs[0] Operand 1
     /* 2257564 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257569 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257573 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257577 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2257580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257582 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257584 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257592 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257593 */   // GIR_Coverage, 48568,
     /* 2257593 */   GIR_EraseRootFromParent_Done,
     /* 2257594 */ // Label 30253: @2257594
     /* 2257594 */ GIM_Try, /*On fail goto*//*Label 30254*/ GIMT_Encode4(2257642), // Rule ID 48569 //
     /* 2257599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257605 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257612 */   // MIs[0] Operand 1
     /* 2257612 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257621 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257625 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2257628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257630 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257632 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257640 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257641 */   // GIR_Coverage, 48569,
     /* 2257641 */   GIR_EraseRootFromParent_Done,
     /* 2257642 */ // Label 30254: @2257642
     /* 2257642 */ GIM_Try, /*On fail goto*//*Label 30255*/ GIMT_Encode4(2257690), // Rule ID 48576 //
     /* 2257647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2257650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257653 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257660 */   // MIs[0] Operand 1
     /* 2257660 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257669 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257673 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2257673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2257676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257678 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257680 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257688 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257689 */   // GIR_Coverage, 48576,
     /* 2257689 */   GIR_EraseRootFromParent_Done,
     /* 2257690 */ // Label 30255: @2257690
     /* 2257690 */ GIM_Try, /*On fail goto*//*Label 30256*/ GIMT_Encode4(2257738), // Rule ID 48577 //
     /* 2257695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2257698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257701 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257708 */   // MIs[0] Operand 1
     /* 2257708 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257713 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257717 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257721 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2257724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257726 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257728 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257736 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257737 */   // GIR_Coverage, 48577,
     /* 2257737 */   GIR_EraseRootFromParent_Done,
     /* 2257738 */ // Label 30256: @2257738
     /* 2257738 */ GIM_Try, /*On fail goto*//*Label 30257*/ GIMT_Encode4(2257786), // Rule ID 48590 //
     /* 2257743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257749 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257756 */   // MIs[0] Operand 1
     /* 2257756 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257765 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257769 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2257772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257774 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257776 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257784 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257785 */   // GIR_Coverage, 48590,
     /* 2257785 */   GIR_EraseRootFromParent_Done,
     /* 2257786 */ // Label 30257: @2257786
     /* 2257786 */ GIM_Try, /*On fail goto*//*Label 30258*/ GIMT_Encode4(2257834), // Rule ID 48591 //
     /* 2257791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257797 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257804 */   // MIs[0] Operand 1
     /* 2257804 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257813 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257817 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2257820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257822 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257824 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257833 */   // GIR_Coverage, 48591,
     /* 2257833 */   GIR_EraseRootFromParent_Done,
     /* 2257834 */ // Label 30258: @2257834
     /* 2257834 */ GIM_Try, /*On fail goto*//*Label 30259*/ GIMT_Encode4(2257882), // Rule ID 48604 //
     /* 2257839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257845 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257852 */   // MIs[0] Operand 1
     /* 2257852 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257861 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257865 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2257868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257870 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257872 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257880 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257881 */   // GIR_Coverage, 48604,
     /* 2257881 */   GIR_EraseRootFromParent_Done,
     /* 2257882 */ // Label 30259: @2257882
     /* 2257882 */ GIM_Try, /*On fail goto*//*Label 30260*/ GIMT_Encode4(2257930), // Rule ID 48605 //
     /* 2257887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257893 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257900 */   // MIs[0] Operand 1
     /* 2257900 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257909 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257913 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2257916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257918 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257920 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257928 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257929 */   // GIR_Coverage, 48605,
     /* 2257929 */   GIR_EraseRootFromParent_Done,
     /* 2257930 */ // Label 30260: @2257930
     /* 2257930 */ GIM_Try, /*On fail goto*//*Label 30261*/ GIMT_Encode4(2257978), // Rule ID 48612 //
     /* 2257935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257941 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257948 */   // MIs[0] Operand 1
     /* 2257948 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257957 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257961 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2257964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257966 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257968 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257976 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257977 */   // GIR_Coverage, 48612,
     /* 2257977 */   GIR_EraseRootFromParent_Done,
     /* 2257978 */ // Label 30261: @2257978
     /* 2257978 */ GIM_Try, /*On fail goto*//*Label 30262*/ GIMT_Encode4(2258026), // Rule ID 48613 //
     /* 2257983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257989 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257996 */   // MIs[0] Operand 1
     /* 2257996 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258005 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258009 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2258012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258014 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258016 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258024 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258025 */   // GIR_Coverage, 48613,
     /* 2258025 */   GIR_EraseRootFromParent_Done,
     /* 2258026 */ // Label 30262: @2258026
     /* 2258026 */ GIM_Try, /*On fail goto*//*Label 30263*/ GIMT_Encode4(2258074), // Rule ID 48620 //
     /* 2258031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2258034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258037 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258044 */   // MIs[0] Operand 1
     /* 2258044 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258053 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258057 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258062 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258064 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258072 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258073 */   // GIR_Coverage, 48620,
     /* 2258073 */   GIR_EraseRootFromParent_Done,
     /* 2258074 */ // Label 30263: @2258074
     /* 2258074 */ GIM_Try, /*On fail goto*//*Label 30264*/ GIMT_Encode4(2258122), // Rule ID 48621 //
     /* 2258079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258085 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258092 */   // MIs[0] Operand 1
     /* 2258092 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258101 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258105 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258110 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258112 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258120 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258121 */   // GIR_Coverage, 48621,
     /* 2258121 */   GIR_EraseRootFromParent_Done,
     /* 2258122 */ // Label 30264: @2258122
     /* 2258122 */ GIM_Try, /*On fail goto*//*Label 30265*/ GIMT_Encode4(2258170), // Rule ID 48632 //
     /* 2258127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258133 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258140 */   // MIs[0] Operand 1
     /* 2258140 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258145 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258149 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258153 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2258156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258158 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258160 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258168 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258169 */   // GIR_Coverage, 48632,
     /* 2258169 */   GIR_EraseRootFromParent_Done,
     /* 2258170 */ // Label 30265: @2258170
     /* 2258170 */ GIM_Try, /*On fail goto*//*Label 30266*/ GIMT_Encode4(2258218), // Rule ID 48633 //
     /* 2258175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258181 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258188 */   // MIs[0] Operand 1
     /* 2258188 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258197 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258201 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2258204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258206 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258208 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258216 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258217 */   // GIR_Coverage, 48633,
     /* 2258217 */   GIR_EraseRootFromParent_Done,
     /* 2258218 */ // Label 30266: @2258218
     /* 2258218 */ GIM_Try, /*On fail goto*//*Label 30267*/ GIMT_Encode4(2258266), // Rule ID 48646 //
     /* 2258223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258229 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258236 */   // MIs[0] Operand 1
     /* 2258236 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258241 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258245 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258249 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2258252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258254 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258256 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258264 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258265 */   // GIR_Coverage, 48646,
     /* 2258265 */   GIR_EraseRootFromParent_Done,
     /* 2258266 */ // Label 30267: @2258266
     /* 2258266 */ GIM_Try, /*On fail goto*//*Label 30268*/ GIMT_Encode4(2258314), // Rule ID 48647 //
     /* 2258271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258277 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258284 */   // MIs[0] Operand 1
     /* 2258284 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258293 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258297 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2258300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258302 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258304 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258312 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258313 */   // GIR_Coverage, 48647,
     /* 2258313 */   GIR_EraseRootFromParent_Done,
     /* 2258314 */ // Label 30268: @2258314
     /* 2258314 */ GIM_Try, /*On fail goto*//*Label 30269*/ GIMT_Encode4(2258362), // Rule ID 48654 //
     /* 2258319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258325 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258332 */   // MIs[0] Operand 1
     /* 2258332 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258341 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258345 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2258348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258350 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258352 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258360 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258361 */   // GIR_Coverage, 48654,
     /* 2258361 */   GIR_EraseRootFromParent_Done,
     /* 2258362 */ // Label 30269: @2258362
     /* 2258362 */ GIM_Try, /*On fail goto*//*Label 30270*/ GIMT_Encode4(2258410), // Rule ID 48655 //
     /* 2258367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258373 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258380 */   // MIs[0] Operand 1
     /* 2258380 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258389 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258393 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2258396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258398 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258400 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258408 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258409 */   // GIR_Coverage, 48655,
     /* 2258409 */   GIR_EraseRootFromParent_Done,
     /* 2258410 */ // Label 30270: @2258410
     /* 2258410 */ GIM_Try, /*On fail goto*//*Label 30271*/ GIMT_Encode4(2258458), // Rule ID 48662 //
     /* 2258415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2258418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258421 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258428 */   // MIs[0] Operand 1
     /* 2258428 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258437 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258441 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258446 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258448 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258456 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258457 */   // GIR_Coverage, 48662,
     /* 2258457 */   GIR_EraseRootFromParent_Done,
     /* 2258458 */ // Label 30271: @2258458
     /* 2258458 */ GIM_Try, /*On fail goto*//*Label 30272*/ GIMT_Encode4(2258506), // Rule ID 48663 //
     /* 2258463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258469 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258476 */   // MIs[0] Operand 1
     /* 2258476 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258481 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258485 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258489 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258494 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258496 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258504 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258505 */   // GIR_Coverage, 48663,
     /* 2258505 */   GIR_EraseRootFromParent_Done,
     /* 2258506 */ // Label 30272: @2258506
     /* 2258506 */ GIM_Try, /*On fail goto*//*Label 30273*/ GIMT_Encode4(2258554), // Rule ID 48676 //
     /* 2258511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258517 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258524 */   // MIs[0] Operand 1
     /* 2258524 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258533 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258537 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2258540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258542 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258544 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258552 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258553 */   // GIR_Coverage, 48676,
     /* 2258553 */   GIR_EraseRootFromParent_Done,
     /* 2258554 */ // Label 30273: @2258554
     /* 2258554 */ GIM_Try, /*On fail goto*//*Label 30274*/ GIMT_Encode4(2258602), // Rule ID 48677 //
     /* 2258559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258565 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258572 */   // MIs[0] Operand 1
     /* 2258572 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258581 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258585 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2258588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258590 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258592 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258600 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258601 */   // GIR_Coverage, 48677,
     /* 2258601 */   GIR_EraseRootFromParent_Done,
     /* 2258602 */ // Label 30274: @2258602
     /* 2258602 */ GIM_Try, /*On fail goto*//*Label 30275*/ GIMT_Encode4(2258650), // Rule ID 48690 //
     /* 2258607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258613 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258620 */   // MIs[0] Operand 1
     /* 2258620 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258629 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258633 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2258636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258638 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258640 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258648 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258649 */   // GIR_Coverage, 48690,
     /* 2258649 */   GIR_EraseRootFromParent_Done,
     /* 2258650 */ // Label 30275: @2258650
     /* 2258650 */ GIM_Try, /*On fail goto*//*Label 30276*/ GIMT_Encode4(2258698), // Rule ID 48691 //
     /* 2258655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258661 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258668 */   // MIs[0] Operand 1
     /* 2258668 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258677 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258681 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2258684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258686 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258688 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258696 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258697 */   // GIR_Coverage, 48691,
     /* 2258697 */   GIR_EraseRootFromParent_Done,
     /* 2258698 */ // Label 30276: @2258698
     /* 2258698 */ GIM_Try, /*On fail goto*//*Label 30277*/ GIMT_Encode4(2258746), // Rule ID 48698 //
     /* 2258703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258709 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258716 */   // MIs[0] Operand 1
     /* 2258716 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258725 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258729 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2258732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258734 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258736 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258744 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258745 */   // GIR_Coverage, 48698,
     /* 2258745 */   GIR_EraseRootFromParent_Done,
     /* 2258746 */ // Label 30277: @2258746
     /* 2258746 */ GIM_Try, /*On fail goto*//*Label 30278*/ GIMT_Encode4(2258794), // Rule ID 48699 //
     /* 2258751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258757 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258764 */   // MIs[0] Operand 1
     /* 2258764 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258773 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258777 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2258780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258782 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258784 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258792 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258793 */   // GIR_Coverage, 48699,
     /* 2258793 */   GIR_EraseRootFromParent_Done,
     /* 2258794 */ // Label 30278: @2258794
     /* 2258794 */ GIM_Try, /*On fail goto*//*Label 30279*/ GIMT_Encode4(2258842), // Rule ID 48706 //
     /* 2258799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2258802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258805 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258812 */   // MIs[0] Operand 1
     /* 2258812 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258817 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258821 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258825 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2258828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258830 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258832 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258840 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258841 */   // GIR_Coverage, 48706,
     /* 2258841 */   GIR_EraseRootFromParent_Done,
     /* 2258842 */ // Label 30279: @2258842
     /* 2258842 */ GIM_Try, /*On fail goto*//*Label 30280*/ GIMT_Encode4(2258890), // Rule ID 48707 //
     /* 2258847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258853 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258860 */   // MIs[0] Operand 1
     /* 2258860 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258869 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258873 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2258876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258878 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258880 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258888 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258889 */   // GIR_Coverage, 48707,
     /* 2258889 */   GIR_EraseRootFromParent_Done,
     /* 2258890 */ // Label 30280: @2258890
     /* 2258890 */ GIM_Try, /*On fail goto*//*Label 30281*/ GIMT_Encode4(2258938), // Rule ID 48720 //
     /* 2258895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258901 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258908 */   // MIs[0] Operand 1
     /* 2258908 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258917 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258921 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2258924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258926 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258928 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258936 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258937 */   // GIR_Coverage, 48720,
     /* 2258937 */   GIR_EraseRootFromParent_Done,
     /* 2258938 */ // Label 30281: @2258938
     /* 2258938 */ GIM_Try, /*On fail goto*//*Label 30282*/ GIMT_Encode4(2258986), // Rule ID 48721 //
     /* 2258943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258949 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258956 */   // MIs[0] Operand 1
     /* 2258956 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258965 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258969 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2258972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258974 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258976 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258984 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258985 */   // GIR_Coverage, 48721,
     /* 2258985 */   GIR_EraseRootFromParent_Done,
     /* 2258986 */ // Label 30282: @2258986
     /* 2258986 */ GIM_Try, /*On fail goto*//*Label 30283*/ GIMT_Encode4(2259034), // Rule ID 48734 //
     /* 2258991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258997 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259004 */   // MIs[0] Operand 1
     /* 2259004 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259013 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259017 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2259020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259022 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259024 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259032 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259033 */   // GIR_Coverage, 48734,
     /* 2259033 */   GIR_EraseRootFromParent_Done,
     /* 2259034 */ // Label 30283: @2259034
     /* 2259034 */ GIM_Try, /*On fail goto*//*Label 30284*/ GIMT_Encode4(2259082), // Rule ID 48735 //
     /* 2259039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259045 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259052 */   // MIs[0] Operand 1
     /* 2259052 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259061 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259065 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2259068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259070 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259072 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259080 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259081 */   // GIR_Coverage, 48735,
     /* 2259081 */   GIR_EraseRootFromParent_Done,
     /* 2259082 */ // Label 30284: @2259082
     /* 2259082 */ GIM_Try, /*On fail goto*//*Label 30285*/ GIMT_Encode4(2259130), // Rule ID 48742 //
     /* 2259087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259093 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259100 */   // MIs[0] Operand 1
     /* 2259100 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259109 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259113 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2259116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259118 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259120 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259128 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259129 */   // GIR_Coverage, 48742,
     /* 2259129 */   GIR_EraseRootFromParent_Done,
     /* 2259130 */ // Label 30285: @2259130
     /* 2259130 */ GIM_Try, /*On fail goto*//*Label 30286*/ GIMT_Encode4(2259178), // Rule ID 48743 //
     /* 2259135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259141 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259148 */   // MIs[0] Operand 1
     /* 2259148 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259157 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259161 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2259164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259166 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259168 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259176 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259177 */   // GIR_Coverage, 48743,
     /* 2259177 */   GIR_EraseRootFromParent_Done,
     /* 2259178 */ // Label 30286: @2259178
     /* 2259178 */ GIM_Try, /*On fail goto*//*Label 30287*/ GIMT_Encode4(2259226), // Rule ID 48750 //
     /* 2259183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2259186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259189 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259196 */   // MIs[0] Operand 1
     /* 2259196 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259205 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259209 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2259212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259214 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259216 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259224 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259225 */   // GIR_Coverage, 48750,
     /* 2259225 */   GIR_EraseRootFromParent_Done,
     /* 2259226 */ // Label 30287: @2259226
     /* 2259226 */ GIM_Try, /*On fail goto*//*Label 30288*/ GIMT_Encode4(2259274), // Rule ID 48751 //
     /* 2259231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2259234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259237 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259244 */   // MIs[0] Operand 1
     /* 2259244 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259253 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259257 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2259260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259262 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259264 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259272 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259273 */   // GIR_Coverage, 48751,
     /* 2259273 */   GIR_EraseRootFromParent_Done,
     /* 2259274 */ // Label 30288: @2259274
     /* 2259274 */ GIM_Try, /*On fail goto*//*Label 30289*/ GIMT_Encode4(2259322), // Rule ID 48764 //
     /* 2259279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259292 */   // MIs[0] Operand 1
     /* 2259292 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259297 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259301 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259305 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2259308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259310 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259312 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259320 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259321 */   // GIR_Coverage, 48764,
     /* 2259321 */   GIR_EraseRootFromParent_Done,
     /* 2259322 */ // Label 30289: @2259322
     /* 2259322 */ GIM_Try, /*On fail goto*//*Label 30290*/ GIMT_Encode4(2259370), // Rule ID 48765 //
     /* 2259327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259333 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259340 */   // MIs[0] Operand 1
     /* 2259340 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259349 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259353 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2259356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259358 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259360 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259368 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259369 */   // GIR_Coverage, 48765,
     /* 2259369 */   GIR_EraseRootFromParent_Done,
     /* 2259370 */ // Label 30290: @2259370
     /* 2259370 */ GIM_Try, /*On fail goto*//*Label 30291*/ GIMT_Encode4(2259418), // Rule ID 48778 //
     /* 2259375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259381 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259388 */   // MIs[0] Operand 1
     /* 2259388 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259397 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259401 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259406 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259408 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259416 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259417 */   // GIR_Coverage, 48778,
     /* 2259417 */   GIR_EraseRootFromParent_Done,
     /* 2259418 */ // Label 30291: @2259418
     /* 2259418 */ GIM_Try, /*On fail goto*//*Label 30292*/ GIMT_Encode4(2259466), // Rule ID 48779 //
     /* 2259423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259429 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259436 */   // MIs[0] Operand 1
     /* 2259436 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259445 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259449 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259454 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259456 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259464 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259465 */   // GIR_Coverage, 48779,
     /* 2259465 */   GIR_EraseRootFromParent_Done,
     /* 2259466 */ // Label 30292: @2259466
     /* 2259466 */ GIM_Try, /*On fail goto*//*Label 30293*/ GIMT_Encode4(2259514), // Rule ID 48786 //
     /* 2259471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259477 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259484 */   // MIs[0] Operand 1
     /* 2259484 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259489 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259493 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259497 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259502 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259504 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259512 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259513 */   // GIR_Coverage, 48786,
     /* 2259513 */   GIR_EraseRootFromParent_Done,
     /* 2259514 */ // Label 30293: @2259514
     /* 2259514 */ GIM_Try, /*On fail goto*//*Label 30294*/ GIMT_Encode4(2259562), // Rule ID 48787 //
     /* 2259519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259525 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259532 */   // MIs[0] Operand 1
     /* 2259532 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259541 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259545 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259550 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259552 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259560 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259561 */   // GIR_Coverage, 48787,
     /* 2259561 */   GIR_EraseRootFromParent_Done,
     /* 2259562 */ // Label 30294: @2259562
     /* 2259562 */ GIM_Try, /*On fail goto*//*Label 30295*/ GIMT_Encode4(2259610), // Rule ID 48794 //
     /* 2259567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2259570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259573 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259580 */   // MIs[0] Operand 1
     /* 2259580 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259589 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259593 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2259596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259598 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259600 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259608 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259609 */   // GIR_Coverage, 48794,
     /* 2259609 */   GIR_EraseRootFromParent_Done,
     /* 2259610 */ // Label 30295: @2259610
     /* 2259610 */ GIM_Try, /*On fail goto*//*Label 30296*/ GIMT_Encode4(2259658), // Rule ID 48795 //
     /* 2259615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2259618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259621 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259628 */   // MIs[0] Operand 1
     /* 2259628 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259633 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259637 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259641 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2259644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259646 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259648 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259656 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259657 */   // GIR_Coverage, 48795,
     /* 2259657 */   GIR_EraseRootFromParent_Done,
     /* 2259658 */ // Label 30296: @2259658
     /* 2259658 */ GIM_Try, /*On fail goto*//*Label 30297*/ GIMT_Encode4(2259706), // Rule ID 48808 //
     /* 2259663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259669 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259676 */   // MIs[0] Operand 1
     /* 2259676 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259685 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259689 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2259692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259694 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259696 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259704 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259705 */   // GIR_Coverage, 48808,
     /* 2259705 */   GIR_EraseRootFromParent_Done,
     /* 2259706 */ // Label 30297: @2259706
     /* 2259706 */ GIM_Try, /*On fail goto*//*Label 30298*/ GIMT_Encode4(2259754), // Rule ID 48809 //
     /* 2259711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259717 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259724 */   // MIs[0] Operand 1
     /* 2259724 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259733 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259737 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2259740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259742 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259744 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259752 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259753 */   // GIR_Coverage, 48809,
     /* 2259753 */   GIR_EraseRootFromParent_Done,
     /* 2259754 */ // Label 30298: @2259754
     /* 2259754 */ GIM_Try, /*On fail goto*//*Label 30299*/ GIMT_Encode4(2259802), // Rule ID 48822 //
     /* 2259759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259772 */   // MIs[0] Operand 1
     /* 2259772 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259781 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259785 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259790 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259792 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259800 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259801 */   // GIR_Coverage, 48822,
     /* 2259801 */   GIR_EraseRootFromParent_Done,
     /* 2259802 */ // Label 30299: @2259802
     /* 2259802 */ GIM_Try, /*On fail goto*//*Label 30300*/ GIMT_Encode4(2259850), // Rule ID 48823 //
     /* 2259807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259813 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259820 */   // MIs[0] Operand 1
     /* 2259820 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259829 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259833 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259838 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259840 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259848 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259849 */   // GIR_Coverage, 48823,
     /* 2259849 */   GIR_EraseRootFromParent_Done,
     /* 2259850 */ // Label 30300: @2259850
     /* 2259850 */ GIM_Try, /*On fail goto*//*Label 30301*/ GIMT_Encode4(2259898), // Rule ID 48830 //
     /* 2259855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259861 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259868 */   // MIs[0] Operand 1
     /* 2259868 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259877 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259881 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259886 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259888 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259896 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259897 */   // GIR_Coverage, 48830,
     /* 2259897 */   GIR_EraseRootFromParent_Done,
     /* 2259898 */ // Label 30301: @2259898
     /* 2259898 */ GIM_Try, /*On fail goto*//*Label 30302*/ GIMT_Encode4(2259946), // Rule ID 48831 //
     /* 2259903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259909 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259916 */   // MIs[0] Operand 1
     /* 2259916 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259925 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259929 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259934 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259936 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259944 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259945 */   // GIR_Coverage, 48831,
     /* 2259945 */   GIR_EraseRootFromParent_Done,
     /* 2259946 */ // Label 30302: @2259946
     /* 2259946 */ GIM_Try, /*On fail goto*//*Label 30303*/ GIMT_Encode4(2259994), // Rule ID 48838 //
     /* 2259951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2259954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259957 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259964 */   // MIs[0] Operand 1
     /* 2259964 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259973 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259977 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2259980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259982 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259984 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259992 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259993 */   // GIR_Coverage, 48838,
     /* 2259993 */   GIR_EraseRootFromParent_Done,
     /* 2259994 */ // Label 30303: @2259994
     /* 2259994 */ GIM_Try, /*On fail goto*//*Label 30304*/ GIMT_Encode4(2260042), // Rule ID 48839 //
     /* 2259999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260005 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260012 */   // MIs[0] Operand 1
     /* 2260012 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260021 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260025 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2260028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260030 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260032 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260040 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260041 */   // GIR_Coverage, 48839,
     /* 2260041 */   GIR_EraseRootFromParent_Done,
     /* 2260042 */ // Label 30304: @2260042
     /* 2260042 */ GIM_Try, /*On fail goto*//*Label 30305*/ GIMT_Encode4(2260090), // Rule ID 48852 //
     /* 2260047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260053 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260060 */   // MIs[0] Operand 1
     /* 2260060 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260069 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260073 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260078 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260080 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260088 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260089 */   // GIR_Coverage, 48852,
     /* 2260089 */   GIR_EraseRootFromParent_Done,
     /* 2260090 */ // Label 30305: @2260090
     /* 2260090 */ GIM_Try, /*On fail goto*//*Label 30306*/ GIMT_Encode4(2260138), // Rule ID 48853 //
     /* 2260095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260101 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260108 */   // MIs[0] Operand 1
     /* 2260108 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260117 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260121 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260126 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260128 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260136 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260137 */   // GIR_Coverage, 48853,
     /* 2260137 */   GIR_EraseRootFromParent_Done,
     /* 2260138 */ // Label 30306: @2260138
     /* 2260138 */ GIM_Try, /*On fail goto*//*Label 30307*/ GIMT_Encode4(2260186), // Rule ID 48866 //
     /* 2260143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260149 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260156 */   // MIs[0] Operand 1
     /* 2260156 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260165 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260169 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2260172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260174 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260176 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260184 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260185 */   // GIR_Coverage, 48866,
     /* 2260185 */   GIR_EraseRootFromParent_Done,
     /* 2260186 */ // Label 30307: @2260186
     /* 2260186 */ GIM_Try, /*On fail goto*//*Label 30308*/ GIMT_Encode4(2260234), // Rule ID 48867 //
     /* 2260191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260197 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260204 */   // MIs[0] Operand 1
     /* 2260204 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260213 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260217 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2260220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260222 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260224 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260232 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260233 */   // GIR_Coverage, 48867,
     /* 2260233 */   GIR_EraseRootFromParent_Done,
     /* 2260234 */ // Label 30308: @2260234
     /* 2260234 */ GIM_Try, /*On fail goto*//*Label 30309*/ GIMT_Encode4(2260282), // Rule ID 48874 //
     /* 2260239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260245 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260252 */   // MIs[0] Operand 1
     /* 2260252 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260261 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260265 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2260268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260270 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260272 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260280 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260281 */   // GIR_Coverage, 48874,
     /* 2260281 */   GIR_EraseRootFromParent_Done,
     /* 2260282 */ // Label 30309: @2260282
     /* 2260282 */ GIM_Try, /*On fail goto*//*Label 30310*/ GIMT_Encode4(2260330), // Rule ID 48875 //
     /* 2260287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260293 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260300 */   // MIs[0] Operand 1
     /* 2260300 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260309 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260313 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2260316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260318 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260320 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260328 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260329 */   // GIR_Coverage, 48875,
     /* 2260329 */   GIR_EraseRootFromParent_Done,
     /* 2260330 */ // Label 30310: @2260330
     /* 2260330 */ GIM_Try, /*On fail goto*//*Label 30311*/ GIMT_Encode4(2260378), // Rule ID 48882 //
     /* 2260335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2260338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260341 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260348 */   // MIs[0] Operand 1
     /* 2260348 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260353 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260357 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260361 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2260364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260366 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260368 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260376 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260377 */   // GIR_Coverage, 48882,
     /* 2260377 */   GIR_EraseRootFromParent_Done,
     /* 2260378 */ // Label 30311: @2260378
     /* 2260378 */ GIM_Try, /*On fail goto*//*Label 30312*/ GIMT_Encode4(2260426), // Rule ID 48883 //
     /* 2260383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260389 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260396 */   // MIs[0] Operand 1
     /* 2260396 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260401 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260405 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260409 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2260412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260414 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260416 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260424 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260425 */   // GIR_Coverage, 48883,
     /* 2260425 */   GIR_EraseRootFromParent_Done,
     /* 2260426 */ // Label 30312: @2260426
     /* 2260426 */ GIM_Try, /*On fail goto*//*Label 30313*/ GIMT_Encode4(2260474), // Rule ID 48896 //
     /* 2260431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260437 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260444 */   // MIs[0] Operand 1
     /* 2260444 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260453 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260457 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260462 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260464 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260472 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260473 */   // GIR_Coverage, 48896,
     /* 2260473 */   GIR_EraseRootFromParent_Done,
     /* 2260474 */ // Label 30313: @2260474
     /* 2260474 */ GIM_Try, /*On fail goto*//*Label 30314*/ GIMT_Encode4(2260522), // Rule ID 48897 //
     /* 2260479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260485 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260492 */   // MIs[0] Operand 1
     /* 2260492 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260497 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260501 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260505 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260510 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260512 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260520 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260521 */   // GIR_Coverage, 48897,
     /* 2260521 */   GIR_EraseRootFromParent_Done,
     /* 2260522 */ // Label 30314: @2260522
     /* 2260522 */ GIM_Try, /*On fail goto*//*Label 30315*/ GIMT_Encode4(2260570), // Rule ID 48910 //
     /* 2260527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260533 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260540 */   // MIs[0] Operand 1
     /* 2260540 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260545 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260549 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260553 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2260556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260558 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260560 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260568 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260569 */   // GIR_Coverage, 48910,
     /* 2260569 */   GIR_EraseRootFromParent_Done,
     /* 2260570 */ // Label 30315: @2260570
     /* 2260570 */ GIM_Try, /*On fail goto*//*Label 30316*/ GIMT_Encode4(2260618), // Rule ID 48911 //
     /* 2260575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260581 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260588 */   // MIs[0] Operand 1
     /* 2260588 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260597 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260601 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2260604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260606 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260608 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260616 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260617 */   // GIR_Coverage, 48911,
     /* 2260617 */   GIR_EraseRootFromParent_Done,
     /* 2260618 */ // Label 30316: @2260618
     /* 2260618 */ GIM_Try, /*On fail goto*//*Label 30317*/ GIMT_Encode4(2260666), // Rule ID 48918 //
     /* 2260623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260629 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260636 */   // MIs[0] Operand 1
     /* 2260636 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260641 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260645 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260649 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2260652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260654 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260656 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260664 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260665 */   // GIR_Coverage, 48918,
     /* 2260665 */   GIR_EraseRootFromParent_Done,
     /* 2260666 */ // Label 30317: @2260666
     /* 2260666 */ GIM_Try, /*On fail goto*//*Label 30318*/ GIMT_Encode4(2260714), // Rule ID 48919 //
     /* 2260671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260677 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260684 */   // MIs[0] Operand 1
     /* 2260684 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260693 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260697 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2260700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260702 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260704 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260712 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260713 */   // GIR_Coverage, 48919,
     /* 2260713 */   GIR_EraseRootFromParent_Done,
     /* 2260714 */ // Label 30318: @2260714
     /* 2260714 */ GIM_Try, /*On fail goto*//*Label 30319*/ GIMT_Encode4(2260762), // Rule ID 48926 //
     /* 2260719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2260722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260725 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260732 */   // MIs[0] Operand 1
     /* 2260732 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260737 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260741 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260745 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2260748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260750 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260752 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260760 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260761 */   // GIR_Coverage, 48926,
     /* 2260761 */   GIR_EraseRootFromParent_Done,
     /* 2260762 */ // Label 30319: @2260762
     /* 2260762 */ GIM_Try, /*On fail goto*//*Label 30320*/ GIMT_Encode4(2260810), // Rule ID 48927 //
     /* 2260767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260773 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260780 */   // MIs[0] Operand 1
     /* 2260780 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260789 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260793 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2260796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260798 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260800 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260808 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260809 */   // GIR_Coverage, 48927,
     /* 2260809 */   GIR_EraseRootFromParent_Done,
     /* 2260810 */ // Label 30320: @2260810
     /* 2260810 */ GIM_Reject,
     /* 2260811 */ // Label 29899: @2260811
     /* 2260811 */ GIM_Try, /*On fail goto*//*Label 30321*/ GIMT_Encode4(2260859), // Rule ID 48510 //
     /* 2260816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2260822 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2260825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260829 */   // MIs[0] Operand 1
     /* 2260829 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260834 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260838 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260842 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2260845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260847 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260849 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260857 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260858 */   // GIR_Coverage, 48510,
     /* 2260858 */   GIR_EraseRootFromParent_Done,
     /* 2260859 */ // Label 30321: @2260859
     /* 2260859 */ GIM_Try, /*On fail goto*//*Label 30322*/ GIMT_Encode4(2260907), // Rule ID 48511 //
     /* 2260864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2260870 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2260873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260877 */   // MIs[0] Operand 1
     /* 2260877 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260882 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260886 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260890 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2260893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260895 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260897 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260905 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260906 */   // GIR_Coverage, 48511,
     /* 2260906 */   GIR_EraseRootFromParent_Done,
     /* 2260907 */ // Label 30322: @2260907
     /* 2260907 */ GIM_Try, /*On fail goto*//*Label 30323*/ GIMT_Encode4(2260955), // Rule ID 48518 //
     /* 2260912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2260918 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2260921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260925 */   // MIs[0] Operand 1
     /* 2260925 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260934 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260938 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2260941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260943 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260945 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260953 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260954 */   // GIR_Coverage, 48518,
     /* 2260954 */   GIR_EraseRootFromParent_Done,
     /* 2260955 */ // Label 30323: @2260955
     /* 2260955 */ GIM_Try, /*On fail goto*//*Label 30324*/ GIMT_Encode4(2261003), // Rule ID 48519 //
     /* 2260960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2260966 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2260969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260973 */   // MIs[0] Operand 1
     /* 2260973 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260982 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260986 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2260989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260991 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260993 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261001 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261002 */   // GIR_Coverage, 48519,
     /* 2261002 */   GIR_EraseRootFromParent_Done,
     /* 2261003 */ // Label 30324: @2261003
     /* 2261003 */ GIM_Try, /*On fail goto*//*Label 30325*/ GIMT_Encode4(2261051), // Rule ID 48526 //
     /* 2261008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261014 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261021 */   // MIs[0] Operand 1
     /* 2261021 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261030 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261034 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2261037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261039 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261041 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261049 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261050 */   // GIR_Coverage, 48526,
     /* 2261050 */   GIR_EraseRootFromParent_Done,
     /* 2261051 */ // Label 30325: @2261051
     /* 2261051 */ GIM_Try, /*On fail goto*//*Label 30326*/ GIMT_Encode4(2261099), // Rule ID 48527 //
     /* 2261056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261062 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261069 */   // MIs[0] Operand 1
     /* 2261069 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261078 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261082 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2261085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261087 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261089 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261097 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261098 */   // GIR_Coverage, 48527,
     /* 2261098 */   GIR_EraseRootFromParent_Done,
     /* 2261099 */ // Label 30326: @2261099
     /* 2261099 */ GIM_Try, /*On fail goto*//*Label 30327*/ GIMT_Encode4(2261147), // Rule ID 48554 //
     /* 2261104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261110 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261117 */   // MIs[0] Operand 1
     /* 2261117 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261126 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261130 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2261133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261135 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261137 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261145 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261146 */   // GIR_Coverage, 48554,
     /* 2261146 */   GIR_EraseRootFromParent_Done,
     /* 2261147 */ // Label 30327: @2261147
     /* 2261147 */ GIM_Try, /*On fail goto*//*Label 30328*/ GIMT_Encode4(2261195), // Rule ID 48555 //
     /* 2261152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261158 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261165 */   // MIs[0] Operand 1
     /* 2261165 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261174 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261178 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2261181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261183 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261185 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261193 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261194 */   // GIR_Coverage, 48555,
     /* 2261194 */   GIR_EraseRootFromParent_Done,
     /* 2261195 */ // Label 30328: @2261195
     /* 2261195 */ GIM_Try, /*On fail goto*//*Label 30329*/ GIMT_Encode4(2261243), // Rule ID 48562 //
     /* 2261200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261206 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261213 */   // MIs[0] Operand 1
     /* 2261213 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261222 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261226 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2261229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261231 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261233 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261241 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261242 */   // GIR_Coverage, 48562,
     /* 2261242 */   GIR_EraseRootFromParent_Done,
     /* 2261243 */ // Label 30329: @2261243
     /* 2261243 */ GIM_Try, /*On fail goto*//*Label 30330*/ GIMT_Encode4(2261291), // Rule ID 48563 //
     /* 2261248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261254 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261261 */   // MIs[0] Operand 1
     /* 2261261 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261270 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261274 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2261277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261279 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261281 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261289 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261290 */   // GIR_Coverage, 48563,
     /* 2261290 */   GIR_EraseRootFromParent_Done,
     /* 2261291 */ // Label 30330: @2261291
     /* 2261291 */ GIM_Try, /*On fail goto*//*Label 30331*/ GIMT_Encode4(2261339), // Rule ID 48570 //
     /* 2261296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261302 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261309 */   // MIs[0] Operand 1
     /* 2261309 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261318 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261322 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2261325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261327 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261329 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261337 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261338 */   // GIR_Coverage, 48570,
     /* 2261338 */   GIR_EraseRootFromParent_Done,
     /* 2261339 */ // Label 30331: @2261339
     /* 2261339 */ GIM_Try, /*On fail goto*//*Label 30332*/ GIMT_Encode4(2261387), // Rule ID 48571 //
     /* 2261344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261350 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261357 */   // MIs[0] Operand 1
     /* 2261357 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261366 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261370 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2261373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261375 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261377 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261385 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261386 */   // GIR_Coverage, 48571,
     /* 2261386 */   GIR_EraseRootFromParent_Done,
     /* 2261387 */ // Label 30332: @2261387
     /* 2261387 */ GIM_Try, /*On fail goto*//*Label 30333*/ GIMT_Encode4(2261435), // Rule ID 48598 //
     /* 2261392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261398 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261405 */   // MIs[0] Operand 1
     /* 2261405 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261414 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261418 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261423 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261425 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261433 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261434 */   // GIR_Coverage, 48598,
     /* 2261434 */   GIR_EraseRootFromParent_Done,
     /* 2261435 */ // Label 30333: @2261435
     /* 2261435 */ GIM_Try, /*On fail goto*//*Label 30334*/ GIMT_Encode4(2261483), // Rule ID 48599 //
     /* 2261440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261446 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261453 */   // MIs[0] Operand 1
     /* 2261453 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261462 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261466 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261471 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261473 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261481 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261482 */   // GIR_Coverage, 48599,
     /* 2261482 */   GIR_EraseRootFromParent_Done,
     /* 2261483 */ // Label 30334: @2261483
     /* 2261483 */ GIM_Try, /*On fail goto*//*Label 30335*/ GIMT_Encode4(2261531), // Rule ID 48606 //
     /* 2261488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261494 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261501 */   // MIs[0] Operand 1
     /* 2261501 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261510 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261514 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261519 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261521 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261529 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261530 */   // GIR_Coverage, 48606,
     /* 2261530 */   GIR_EraseRootFromParent_Done,
     /* 2261531 */ // Label 30335: @2261531
     /* 2261531 */ GIM_Try, /*On fail goto*//*Label 30336*/ GIMT_Encode4(2261579), // Rule ID 48607 //
     /* 2261536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261542 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261549 */   // MIs[0] Operand 1
     /* 2261549 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261554 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261558 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261562 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261567 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261569 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261577 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261578 */   // GIR_Coverage, 48607,
     /* 2261578 */   GIR_EraseRootFromParent_Done,
     /* 2261579 */ // Label 30336: @2261579
     /* 2261579 */ GIM_Try, /*On fail goto*//*Label 30337*/ GIMT_Encode4(2261627), // Rule ID 48614 //
     /* 2261584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261590 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261597 */   // MIs[0] Operand 1
     /* 2261597 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261602 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261606 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261610 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2261613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261615 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261617 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261625 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261626 */   // GIR_Coverage, 48614,
     /* 2261626 */   GIR_EraseRootFromParent_Done,
     /* 2261627 */ // Label 30337: @2261627
     /* 2261627 */ GIM_Try, /*On fail goto*//*Label 30338*/ GIMT_Encode4(2261675), // Rule ID 48615 //
     /* 2261632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261638 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261645 */   // MIs[0] Operand 1
     /* 2261645 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261650 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261654 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261658 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2261661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261663 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261665 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261673 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261674 */   // GIR_Coverage, 48615,
     /* 2261674 */   GIR_EraseRootFromParent_Done,
     /* 2261675 */ // Label 30338: @2261675
     /* 2261675 */ GIM_Try, /*On fail goto*//*Label 30339*/ GIMT_Encode4(2261723), // Rule ID 48640 //
     /* 2261680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261686 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261693 */   // MIs[0] Operand 1
     /* 2261693 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261698 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261702 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261706 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261711 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261713 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261721 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261722 */   // GIR_Coverage, 48640,
     /* 2261722 */   GIR_EraseRootFromParent_Done,
     /* 2261723 */ // Label 30339: @2261723
     /* 2261723 */ GIM_Try, /*On fail goto*//*Label 30340*/ GIMT_Encode4(2261771), // Rule ID 48641 //
     /* 2261728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261734 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261741 */   // MIs[0] Operand 1
     /* 2261741 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261746 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261750 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261754 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261759 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261761 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261769 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261770 */   // GIR_Coverage, 48641,
     /* 2261770 */   GIR_EraseRootFromParent_Done,
     /* 2261771 */ // Label 30340: @2261771
     /* 2261771 */ GIM_Try, /*On fail goto*//*Label 30341*/ GIMT_Encode4(2261819), // Rule ID 48648 //
     /* 2261776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261782 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261789 */   // MIs[0] Operand 1
     /* 2261789 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261798 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261802 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261807 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261809 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261817 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261818 */   // GIR_Coverage, 48648,
     /* 2261818 */   GIR_EraseRootFromParent_Done,
     /* 2261819 */ // Label 30341: @2261819
     /* 2261819 */ GIM_Try, /*On fail goto*//*Label 30342*/ GIMT_Encode4(2261867), // Rule ID 48649 //
     /* 2261824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261830 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261837 */   // MIs[0] Operand 1
     /* 2261837 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261842 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261846 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261850 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261855 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261857 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261865 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261866 */   // GIR_Coverage, 48649,
     /* 2261866 */   GIR_EraseRootFromParent_Done,
     /* 2261867 */ // Label 30342: @2261867
     /* 2261867 */ GIM_Try, /*On fail goto*//*Label 30343*/ GIMT_Encode4(2261915), // Rule ID 48656 //
     /* 2261872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261878 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261885 */   // MIs[0] Operand 1
     /* 2261885 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261890 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261894 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261898 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2261901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261903 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261905 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261913 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261914 */   // GIR_Coverage, 48656,
     /* 2261914 */   GIR_EraseRootFromParent_Done,
     /* 2261915 */ // Label 30343: @2261915
     /* 2261915 */ GIM_Try, /*On fail goto*//*Label 30344*/ GIMT_Encode4(2261963), // Rule ID 48657 //
     /* 2261920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261926 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261933 */   // MIs[0] Operand 1
     /* 2261933 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261942 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261946 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2261949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261951 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261953 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261961 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261962 */   // GIR_Coverage, 48657,
     /* 2261962 */   GIR_EraseRootFromParent_Done,
     /* 2261963 */ // Label 30344: @2261963
     /* 2261963 */ GIM_Try, /*On fail goto*//*Label 30345*/ GIMT_Encode4(2262011), // Rule ID 48684 //
     /* 2261968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261974 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261981 */   // MIs[0] Operand 1
     /* 2261981 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2261986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261990 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261994 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2261997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261999 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262001 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262009 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262010 */   // GIR_Coverage, 48684,
     /* 2262010 */   GIR_EraseRootFromParent_Done,
     /* 2262011 */ // Label 30345: @2262011
     /* 2262011 */ GIM_Try, /*On fail goto*//*Label 30346*/ GIMT_Encode4(2262059), // Rule ID 48685 //
     /* 2262016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262022 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262029 */   // MIs[0] Operand 1
     /* 2262029 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262038 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262042 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262047 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262049 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262057 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262058 */   // GIR_Coverage, 48685,
     /* 2262058 */   GIR_EraseRootFromParent_Done,
     /* 2262059 */ // Label 30346: @2262059
     /* 2262059 */ GIM_Try, /*On fail goto*//*Label 30347*/ GIMT_Encode4(2262107), // Rule ID 48692 //
     /* 2262064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262070 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262077 */   // MIs[0] Operand 1
     /* 2262077 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262082 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262086 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262090 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262095 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262097 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262105 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262106 */   // GIR_Coverage, 48692,
     /* 2262106 */   GIR_EraseRootFromParent_Done,
     /* 2262107 */ // Label 30347: @2262107
     /* 2262107 */ GIM_Try, /*On fail goto*//*Label 30348*/ GIMT_Encode4(2262155), // Rule ID 48693 //
     /* 2262112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262118 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262125 */   // MIs[0] Operand 1
     /* 2262125 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262134 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262138 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262143 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262145 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262153 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262154 */   // GIR_Coverage, 48693,
     /* 2262154 */   GIR_EraseRootFromParent_Done,
     /* 2262155 */ // Label 30348: @2262155
     /* 2262155 */ GIM_Try, /*On fail goto*//*Label 30349*/ GIMT_Encode4(2262203), // Rule ID 48700 //
     /* 2262160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262166 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262173 */   // MIs[0] Operand 1
     /* 2262173 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262182 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262186 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262191 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262193 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262201 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262202 */   // GIR_Coverage, 48700,
     /* 2262202 */   GIR_EraseRootFromParent_Done,
     /* 2262203 */ // Label 30349: @2262203
     /* 2262203 */ GIM_Try, /*On fail goto*//*Label 30350*/ GIMT_Encode4(2262251), // Rule ID 48701 //
     /* 2262208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262214 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262221 */   // MIs[0] Operand 1
     /* 2262221 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262230 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262234 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262239 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262241 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262249 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262250 */   // GIR_Coverage, 48701,
     /* 2262250 */   GIR_EraseRootFromParent_Done,
     /* 2262251 */ // Label 30350: @2262251
     /* 2262251 */ GIM_Try, /*On fail goto*//*Label 30351*/ GIMT_Encode4(2262299), // Rule ID 48728 //
     /* 2262256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262262 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262269 */   // MIs[0] Operand 1
     /* 2262269 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262278 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262282 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262287 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262289 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262297 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262298 */   // GIR_Coverage, 48728,
     /* 2262298 */   GIR_EraseRootFromParent_Done,
     /* 2262299 */ // Label 30351: @2262299
     /* 2262299 */ GIM_Try, /*On fail goto*//*Label 30352*/ GIMT_Encode4(2262347), // Rule ID 48729 //
     /* 2262304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262310 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262317 */   // MIs[0] Operand 1
     /* 2262317 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262326 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262330 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262335 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262337 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262345 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262346 */   // GIR_Coverage, 48729,
     /* 2262346 */   GIR_EraseRootFromParent_Done,
     /* 2262347 */ // Label 30352: @2262347
     /* 2262347 */ GIM_Try, /*On fail goto*//*Label 30353*/ GIMT_Encode4(2262395), // Rule ID 48736 //
     /* 2262352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262358 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262365 */   // MIs[0] Operand 1
     /* 2262365 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262370 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262374 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262378 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262383 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262385 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262393 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262394 */   // GIR_Coverage, 48736,
     /* 2262394 */   GIR_EraseRootFromParent_Done,
     /* 2262395 */ // Label 30353: @2262395
     /* 2262395 */ GIM_Try, /*On fail goto*//*Label 30354*/ GIMT_Encode4(2262443), // Rule ID 48737 //
     /* 2262400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262406 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262413 */   // MIs[0] Operand 1
     /* 2262413 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262422 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262426 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262431 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262433 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262441 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262442 */   // GIR_Coverage, 48737,
     /* 2262442 */   GIR_EraseRootFromParent_Done,
     /* 2262443 */ // Label 30354: @2262443
     /* 2262443 */ GIM_Try, /*On fail goto*//*Label 30355*/ GIMT_Encode4(2262491), // Rule ID 48744 //
     /* 2262448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262454 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262461 */   // MIs[0] Operand 1
     /* 2262461 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262470 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262474 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262479 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262481 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262489 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262490 */   // GIR_Coverage, 48744,
     /* 2262490 */   GIR_EraseRootFromParent_Done,
     /* 2262491 */ // Label 30355: @2262491
     /* 2262491 */ GIM_Try, /*On fail goto*//*Label 30356*/ GIMT_Encode4(2262539), // Rule ID 48745 //
     /* 2262496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262502 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262509 */   // MIs[0] Operand 1
     /* 2262509 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262518 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262522 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262527 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262529 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262537 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262538 */   // GIR_Coverage, 48745,
     /* 2262538 */   GIR_EraseRootFromParent_Done,
     /* 2262539 */ // Label 30356: @2262539
     /* 2262539 */ GIM_Try, /*On fail goto*//*Label 30357*/ GIMT_Encode4(2262587), // Rule ID 48772 //
     /* 2262544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262550 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262557 */   // MIs[0] Operand 1
     /* 2262557 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262566 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262570 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2262573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262575 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262577 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262585 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262586 */   // GIR_Coverage, 48772,
     /* 2262586 */   GIR_EraseRootFromParent_Done,
     /* 2262587 */ // Label 30357: @2262587
     /* 2262587 */ GIM_Try, /*On fail goto*//*Label 30358*/ GIMT_Encode4(2262635), // Rule ID 48773 //
     /* 2262592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262598 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262605 */   // MIs[0] Operand 1
     /* 2262605 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262614 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262618 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2262621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262623 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262625 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262633 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262634 */   // GIR_Coverage, 48773,
     /* 2262634 */   GIR_EraseRootFromParent_Done,
     /* 2262635 */ // Label 30358: @2262635
     /* 2262635 */ GIM_Try, /*On fail goto*//*Label 30359*/ GIMT_Encode4(2262683), // Rule ID 48780 //
     /* 2262640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262646 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262653 */   // MIs[0] Operand 1
     /* 2262653 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262662 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262666 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2262669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262671 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262673 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262681 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262682 */   // GIR_Coverage, 48780,
     /* 2262682 */   GIR_EraseRootFromParent_Done,
     /* 2262683 */ // Label 30359: @2262683
     /* 2262683 */ GIM_Try, /*On fail goto*//*Label 30360*/ GIMT_Encode4(2262731), // Rule ID 48781 //
     /* 2262688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262694 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262701 */   // MIs[0] Operand 1
     /* 2262701 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262710 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262714 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2262717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262719 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262721 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262729 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262730 */   // GIR_Coverage, 48781,
     /* 2262730 */   GIR_EraseRootFromParent_Done,
     /* 2262731 */ // Label 30360: @2262731
     /* 2262731 */ GIM_Try, /*On fail goto*//*Label 30361*/ GIMT_Encode4(2262779), // Rule ID 48788 //
     /* 2262736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262742 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262749 */   // MIs[0] Operand 1
     /* 2262749 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262758 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262762 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2262765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262767 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262769 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262777 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262778 */   // GIR_Coverage, 48788,
     /* 2262778 */   GIR_EraseRootFromParent_Done,
     /* 2262779 */ // Label 30361: @2262779
     /* 2262779 */ GIM_Try, /*On fail goto*//*Label 30362*/ GIMT_Encode4(2262827), // Rule ID 48789 //
     /* 2262784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262790 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262797 */   // MIs[0] Operand 1
     /* 2262797 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262806 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262810 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2262813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262815 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262817 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262825 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262826 */   // GIR_Coverage, 48789,
     /* 2262826 */   GIR_EraseRootFromParent_Done,
     /* 2262827 */ // Label 30362: @2262827
     /* 2262827 */ GIM_Try, /*On fail goto*//*Label 30363*/ GIMT_Encode4(2262875), // Rule ID 48816 //
     /* 2262832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262838 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262845 */   // MIs[0] Operand 1
     /* 2262845 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2262850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262854 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262858 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2262861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262863 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262865 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262873 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262874 */   // GIR_Coverage, 48816,
     /* 2262874 */   GIR_EraseRootFromParent_Done,
     /* 2262875 */ // Label 30363: @2262875
     /* 2262875 */ GIM_Try, /*On fail goto*//*Label 30364*/ GIMT_Encode4(2262923), // Rule ID 48817 //
     /* 2262880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262886 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262893 */   // MIs[0] Operand 1
     /* 2262893 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2262898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262902 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262906 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2262909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262911 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262913 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262921 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262922 */   // GIR_Coverage, 48817,
     /* 2262922 */   GIR_EraseRootFromParent_Done,
     /* 2262923 */ // Label 30364: @2262923
     /* 2262923 */ GIM_Try, /*On fail goto*//*Label 30365*/ GIMT_Encode4(2262971), // Rule ID 48824 //
     /* 2262928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262934 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262941 */   // MIs[0] Operand 1
     /* 2262941 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2262946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262950 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262954 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2262957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262959 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262961 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262969 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262970 */   // GIR_Coverage, 48824,
     /* 2262970 */   GIR_EraseRootFromParent_Done,
     /* 2262971 */ // Label 30365: @2262971
     /* 2262971 */ GIM_Try, /*On fail goto*//*Label 30366*/ GIMT_Encode4(2263019), // Rule ID 48825 //
     /* 2262976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262982 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262989 */   // MIs[0] Operand 1
     /* 2262989 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2262994 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262998 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263002 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2263005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263007 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263009 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263017 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263018 */   // GIR_Coverage, 48825,
     /* 2263018 */   GIR_EraseRootFromParent_Done,
     /* 2263019 */ // Label 30366: @2263019
     /* 2263019 */ GIM_Try, /*On fail goto*//*Label 30367*/ GIMT_Encode4(2263067), // Rule ID 48832 //
     /* 2263024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263030 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263037 */   // MIs[0] Operand 1
     /* 2263037 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263046 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263050 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263055 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263057 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263065 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263066 */   // GIR_Coverage, 48832,
     /* 2263066 */   GIR_EraseRootFromParent_Done,
     /* 2263067 */ // Label 30367: @2263067
     /* 2263067 */ GIM_Try, /*On fail goto*//*Label 30368*/ GIMT_Encode4(2263115), // Rule ID 48833 //
     /* 2263072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263078 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263085 */   // MIs[0] Operand 1
     /* 2263085 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263094 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263098 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263103 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263105 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263113 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263114 */   // GIR_Coverage, 48833,
     /* 2263114 */   GIR_EraseRootFromParent_Done,
     /* 2263115 */ // Label 30368: @2263115
     /* 2263115 */ GIM_Try, /*On fail goto*//*Label 30369*/ GIMT_Encode4(2263163), // Rule ID 48860 //
     /* 2263120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263126 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263133 */   // MIs[0] Operand 1
     /* 2263133 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263142 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263146 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263151 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263153 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263161 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263162 */   // GIR_Coverage, 48860,
     /* 2263162 */   GIR_EraseRootFromParent_Done,
     /* 2263163 */ // Label 30369: @2263163
     /* 2263163 */ GIM_Try, /*On fail goto*//*Label 30370*/ GIMT_Encode4(2263211), // Rule ID 48861 //
     /* 2263168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263174 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263181 */   // MIs[0] Operand 1
     /* 2263181 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263190 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263194 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263199 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263201 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263209 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263210 */   // GIR_Coverage, 48861,
     /* 2263210 */   GIR_EraseRootFromParent_Done,
     /* 2263211 */ // Label 30370: @2263211
     /* 2263211 */ GIM_Try, /*On fail goto*//*Label 30371*/ GIMT_Encode4(2263259), // Rule ID 48868 //
     /* 2263216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263222 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263229 */   // MIs[0] Operand 1
     /* 2263229 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263238 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263242 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263247 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263249 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263257 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263258 */   // GIR_Coverage, 48868,
     /* 2263258 */   GIR_EraseRootFromParent_Done,
     /* 2263259 */ // Label 30371: @2263259
     /* 2263259 */ GIM_Try, /*On fail goto*//*Label 30372*/ GIMT_Encode4(2263307), // Rule ID 48869 //
     /* 2263264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263270 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263277 */   // MIs[0] Operand 1
     /* 2263277 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263286 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263290 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263295 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263297 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263305 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263306 */   // GIR_Coverage, 48869,
     /* 2263306 */   GIR_EraseRootFromParent_Done,
     /* 2263307 */ // Label 30372: @2263307
     /* 2263307 */ GIM_Try, /*On fail goto*//*Label 30373*/ GIMT_Encode4(2263355), // Rule ID 48876 //
     /* 2263312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263318 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263325 */   // MIs[0] Operand 1
     /* 2263325 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263334 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263338 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2263341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263343 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263345 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263353 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263354 */   // GIR_Coverage, 48876,
     /* 2263354 */   GIR_EraseRootFromParent_Done,
     /* 2263355 */ // Label 30373: @2263355
     /* 2263355 */ GIM_Try, /*On fail goto*//*Label 30374*/ GIMT_Encode4(2263403), // Rule ID 48877 //
     /* 2263360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263366 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263373 */   // MIs[0] Operand 1
     /* 2263373 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263382 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263386 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2263389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263391 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263393 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263401 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263402 */   // GIR_Coverage, 48877,
     /* 2263402 */   GIR_EraseRootFromParent_Done,
     /* 2263403 */ // Label 30374: @2263403
     /* 2263403 */ GIM_Try, /*On fail goto*//*Label 30375*/ GIMT_Encode4(2263451), // Rule ID 48904 //
     /* 2263408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263414 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263421 */   // MIs[0] Operand 1
     /* 2263421 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263430 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263434 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263439 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263441 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263449 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263450 */   // GIR_Coverage, 48904,
     /* 2263450 */   GIR_EraseRootFromParent_Done,
     /* 2263451 */ // Label 30375: @2263451
     /* 2263451 */ GIM_Try, /*On fail goto*//*Label 30376*/ GIMT_Encode4(2263499), // Rule ID 48905 //
     /* 2263456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263462 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263469 */   // MIs[0] Operand 1
     /* 2263469 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263478 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263482 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263487 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263489 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263497 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263498 */   // GIR_Coverage, 48905,
     /* 2263498 */   GIR_EraseRootFromParent_Done,
     /* 2263499 */ // Label 30376: @2263499
     /* 2263499 */ GIM_Try, /*On fail goto*//*Label 30377*/ GIMT_Encode4(2263547), // Rule ID 48912 //
     /* 2263504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263510 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263517 */   // MIs[0] Operand 1
     /* 2263517 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263526 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263530 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263535 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263537 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263546 */   // GIR_Coverage, 48912,
     /* 2263546 */   GIR_EraseRootFromParent_Done,
     /* 2263547 */ // Label 30377: @2263547
     /* 2263547 */ GIM_Try, /*On fail goto*//*Label 30378*/ GIMT_Encode4(2263595), // Rule ID 48913 //
     /* 2263552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263558 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263565 */   // MIs[0] Operand 1
     /* 2263565 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263574 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263578 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263583 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263585 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263593 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263594 */   // GIR_Coverage, 48913,
     /* 2263594 */   GIR_EraseRootFromParent_Done,
     /* 2263595 */ // Label 30378: @2263595
     /* 2263595 */ GIM_Try, /*On fail goto*//*Label 30379*/ GIMT_Encode4(2263643), // Rule ID 48920 //
     /* 2263600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263606 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263613 */   // MIs[0] Operand 1
     /* 2263613 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263618 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263622 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263626 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2263629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263631 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263633 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263641 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263642 */   // GIR_Coverage, 48920,
     /* 2263642 */   GIR_EraseRootFromParent_Done,
     /* 2263643 */ // Label 30379: @2263643
     /* 2263643 */ GIM_Try, /*On fail goto*//*Label 30380*/ GIMT_Encode4(2263691), // Rule ID 48921 //
     /* 2263648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263654 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263661 */   // MIs[0] Operand 1
     /* 2263661 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263670 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263674 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2263677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263679 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263681 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263689 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263690 */   // GIR_Coverage, 48921,
     /* 2263690 */   GIR_EraseRootFromParent_Done,
     /* 2263691 */ // Label 30380: @2263691
     /* 2263691 */ GIM_Reject,
     /* 2263692 */ // Label 29900: @2263692
     /* 2263692 */ GIM_Try, /*On fail goto*//*Label 30381*/ GIMT_Encode4(2263740), // Rule ID 48512 //
     /* 2263697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2263703 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2263706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263710 */   // MIs[0] Operand 1
     /* 2263710 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2263715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263719 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263723 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2263726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263728 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263730 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263738 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263739 */   // GIR_Coverage, 48512,
     /* 2263739 */   GIR_EraseRootFromParent_Done,
     /* 2263740 */ // Label 30381: @2263740
     /* 2263740 */ GIM_Try, /*On fail goto*//*Label 30382*/ GIMT_Encode4(2263788), // Rule ID 48513 //
     /* 2263745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2263751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2263754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263758 */   // MIs[0] Operand 1
     /* 2263758 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2263763 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263767 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263771 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2263774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263776 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263778 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263787 */   // GIR_Coverage, 48513,
     /* 2263787 */   GIR_EraseRootFromParent_Done,
     /* 2263788 */ // Label 30382: @2263788
     /* 2263788 */ GIM_Try, /*On fail goto*//*Label 30383*/ GIMT_Encode4(2263836), // Rule ID 48520 //
     /* 2263793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2263799 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2263802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263806 */   // MIs[0] Operand 1
     /* 2263806 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2263811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263815 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263819 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2263822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263824 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263826 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263834 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263835 */   // GIR_Coverage, 48520,
     /* 2263835 */   GIR_EraseRootFromParent_Done,
     /* 2263836 */ // Label 30383: @2263836
     /* 2263836 */ GIM_Try, /*On fail goto*//*Label 30384*/ GIMT_Encode4(2263884), // Rule ID 48521 //
     /* 2263841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2263847 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2263850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263854 */   // MIs[0] Operand 1
     /* 2263854 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2263859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263863 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263867 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2263870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263872 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263874 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263882 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263883 */   // GIR_Coverage, 48521,
     /* 2263883 */   GIR_EraseRootFromParent_Done,
     /* 2263884 */ // Label 30384: @2263884
     /* 2263884 */ GIM_Try, /*On fail goto*//*Label 30385*/ GIMT_Encode4(2263932), // Rule ID 48556 //
     /* 2263889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2263895 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2263898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263902 */   // MIs[0] Operand 1
     /* 2263902 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2263907 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263911 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263915 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2263918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263920 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263922 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263930 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263931 */   // GIR_Coverage, 48556,
     /* 2263931 */   GIR_EraseRootFromParent_Done,
     /* 2263932 */ // Label 30385: @2263932
     /* 2263932 */ GIM_Try, /*On fail goto*//*Label 30386*/ GIMT_Encode4(2263980), // Rule ID 48557 //
     /* 2263937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2263943 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2263946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263950 */   // MIs[0] Operand 1
     /* 2263950 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2263955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263959 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263963 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2263966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263968 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263970 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263978 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263979 */   // GIR_Coverage, 48557,
     /* 2263979 */   GIR_EraseRootFromParent_Done,
     /* 2263980 */ // Label 30386: @2263980
     /* 2263980 */ GIM_Try, /*On fail goto*//*Label 30387*/ GIMT_Encode4(2264028), // Rule ID 48564 //
     /* 2263985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2263991 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2263994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263998 */   // MIs[0] Operand 1
     /* 2263998 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264003 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264007 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264011 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2264014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264016 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264018 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264026 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264027 */   // GIR_Coverage, 48564,
     /* 2264027 */   GIR_EraseRootFromParent_Done,
     /* 2264028 */ // Label 30387: @2264028
     /* 2264028 */ GIM_Try, /*On fail goto*//*Label 30388*/ GIMT_Encode4(2264076), // Rule ID 48565 //
     /* 2264033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264039 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264046 */   // MIs[0] Operand 1
     /* 2264046 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264055 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264059 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2264062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264064 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264066 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264074 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264075 */   // GIR_Coverage, 48565,
     /* 2264075 */   GIR_EraseRootFromParent_Done,
     /* 2264076 */ // Label 30388: @2264076
     /* 2264076 */ GIM_Try, /*On fail goto*//*Label 30389*/ GIMT_Encode4(2264124), // Rule ID 48600 //
     /* 2264081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264087 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264094 */   // MIs[0] Operand 1
     /* 2264094 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264103 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264107 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264112 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264114 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264122 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264123 */   // GIR_Coverage, 48600,
     /* 2264123 */   GIR_EraseRootFromParent_Done,
     /* 2264124 */ // Label 30389: @2264124
     /* 2264124 */ GIM_Try, /*On fail goto*//*Label 30390*/ GIMT_Encode4(2264172), // Rule ID 48601 //
     /* 2264129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264135 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264142 */   // MIs[0] Operand 1
     /* 2264142 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264151 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264155 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264160 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264162 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264170 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264171 */   // GIR_Coverage, 48601,
     /* 2264171 */   GIR_EraseRootFromParent_Done,
     /* 2264172 */ // Label 30390: @2264172
     /* 2264172 */ GIM_Try, /*On fail goto*//*Label 30391*/ GIMT_Encode4(2264220), // Rule ID 48608 //
     /* 2264177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264183 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264190 */   // MIs[0] Operand 1
     /* 2264190 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264199 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264203 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2264206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264208 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264210 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264218 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264219 */   // GIR_Coverage, 48608,
     /* 2264219 */   GIR_EraseRootFromParent_Done,
     /* 2264220 */ // Label 30391: @2264220
     /* 2264220 */ GIM_Try, /*On fail goto*//*Label 30392*/ GIMT_Encode4(2264268), // Rule ID 48609 //
     /* 2264225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264231 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264238 */   // MIs[0] Operand 1
     /* 2264238 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264247 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264251 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2264254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264256 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264258 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264266 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264267 */   // GIR_Coverage, 48609,
     /* 2264267 */   GIR_EraseRootFromParent_Done,
     /* 2264268 */ // Label 30392: @2264268
     /* 2264268 */ GIM_Try, /*On fail goto*//*Label 30393*/ GIMT_Encode4(2264316), // Rule ID 48642 //
     /* 2264273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264279 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264286 */   // MIs[0] Operand 1
     /* 2264286 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2264291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264295 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264299 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264304 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264306 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264314 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264315 */   // GIR_Coverage, 48642,
     /* 2264315 */   GIR_EraseRootFromParent_Done,
     /* 2264316 */ // Label 30393: @2264316
     /* 2264316 */ GIM_Try, /*On fail goto*//*Label 30394*/ GIMT_Encode4(2264364), // Rule ID 48643 //
     /* 2264321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264327 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264334 */   // MIs[0] Operand 1
     /* 2264334 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2264339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264343 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264347 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264352 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264354 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264362 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264363 */   // GIR_Coverage, 48643,
     /* 2264363 */   GIR_EraseRootFromParent_Done,
     /* 2264364 */ // Label 30394: @2264364
     /* 2264364 */ GIM_Try, /*On fail goto*//*Label 30395*/ GIMT_Encode4(2264412), // Rule ID 48650 //
     /* 2264369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264375 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264382 */   // MIs[0] Operand 1
     /* 2264382 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2264387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264391 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264395 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2264398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264400 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264402 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264410 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264411 */   // GIR_Coverage, 48650,
     /* 2264411 */   GIR_EraseRootFromParent_Done,
     /* 2264412 */ // Label 30395: @2264412
     /* 2264412 */ GIM_Try, /*On fail goto*//*Label 30396*/ GIMT_Encode4(2264460), // Rule ID 48651 //
     /* 2264417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264423 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264430 */   // MIs[0] Operand 1
     /* 2264430 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2264435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264439 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264443 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2264446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264448 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264450 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264458 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264459 */   // GIR_Coverage, 48651,
     /* 2264459 */   GIR_EraseRootFromParent_Done,
     /* 2264460 */ // Label 30396: @2264460
     /* 2264460 */ GIM_Try, /*On fail goto*//*Label 30397*/ GIMT_Encode4(2264508), // Rule ID 48686 //
     /* 2264465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264471 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264478 */   // MIs[0] Operand 1
     /* 2264478 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2264483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264487 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264491 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2264494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264496 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264498 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264506 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264507 */   // GIR_Coverage, 48686,
     /* 2264507 */   GIR_EraseRootFromParent_Done,
     /* 2264508 */ // Label 30397: @2264508
     /* 2264508 */ GIM_Try, /*On fail goto*//*Label 30398*/ GIMT_Encode4(2264556), // Rule ID 48687 //
     /* 2264513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264519 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264526 */   // MIs[0] Operand 1
     /* 2264526 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2264531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264535 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264539 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2264542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264544 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264546 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264554 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264555 */   // GIR_Coverage, 48687,
     /* 2264555 */   GIR_EraseRootFromParent_Done,
     /* 2264556 */ // Label 30398: @2264556
     /* 2264556 */ GIM_Try, /*On fail goto*//*Label 30399*/ GIMT_Encode4(2264604), // Rule ID 48694 //
     /* 2264561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264567 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264574 */   // MIs[0] Operand 1
     /* 2264574 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2264579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264583 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264587 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2264590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264592 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264594 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264602 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264603 */   // GIR_Coverage, 48694,
     /* 2264603 */   GIR_EraseRootFromParent_Done,
     /* 2264604 */ // Label 30399: @2264604
     /* 2264604 */ GIM_Try, /*On fail goto*//*Label 30400*/ GIMT_Encode4(2264652), // Rule ID 48695 //
     /* 2264609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264615 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264622 */   // MIs[0] Operand 1
     /* 2264622 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2264627 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264631 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264635 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2264638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264640 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264642 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264650 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264651 */   // GIR_Coverage, 48695,
     /* 2264651 */   GIR_EraseRootFromParent_Done,
     /* 2264652 */ // Label 30400: @2264652
     /* 2264652 */ GIM_Try, /*On fail goto*//*Label 30401*/ GIMT_Encode4(2264700), // Rule ID 48730 //
     /* 2264657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264663 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264670 */   // MIs[0] Operand 1
     /* 2264670 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2264675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264679 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264683 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2264686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264688 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264690 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264698 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264699 */   // GIR_Coverage, 48730,
     /* 2264699 */   GIR_EraseRootFromParent_Done,
     /* 2264700 */ // Label 30401: @2264700
     /* 2264700 */ GIM_Try, /*On fail goto*//*Label 30402*/ GIMT_Encode4(2264748), // Rule ID 48731 //
     /* 2264705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264711 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264718 */   // MIs[0] Operand 1
     /* 2264718 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2264723 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264727 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264731 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2264734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264736 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264738 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264746 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264747 */   // GIR_Coverage, 48731,
     /* 2264747 */   GIR_EraseRootFromParent_Done,
     /* 2264748 */ // Label 30402: @2264748
     /* 2264748 */ GIM_Try, /*On fail goto*//*Label 30403*/ GIMT_Encode4(2264796), // Rule ID 48738 //
     /* 2264753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264759 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264766 */   // MIs[0] Operand 1
     /* 2264766 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2264771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264775 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264779 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2264782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264784 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264786 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264794 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264795 */   // GIR_Coverage, 48738,
     /* 2264795 */   GIR_EraseRootFromParent_Done,
     /* 2264796 */ // Label 30403: @2264796
     /* 2264796 */ GIM_Try, /*On fail goto*//*Label 30404*/ GIMT_Encode4(2264844), // Rule ID 48739 //
     /* 2264801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264807 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264814 */   // MIs[0] Operand 1
     /* 2264814 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2264819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264823 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264827 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2264830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264832 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264834 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264842 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264843 */   // GIR_Coverage, 48739,
     /* 2264843 */   GIR_EraseRootFromParent_Done,
     /* 2264844 */ // Label 30404: @2264844
     /* 2264844 */ GIM_Try, /*On fail goto*//*Label 30405*/ GIMT_Encode4(2264892), // Rule ID 48774 //
     /* 2264849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264855 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264862 */   // MIs[0] Operand 1
     /* 2264862 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2264867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264871 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264875 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2264878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264880 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264882 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264890 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264891 */   // GIR_Coverage, 48774,
     /* 2264891 */   GIR_EraseRootFromParent_Done,
     /* 2264892 */ // Label 30405: @2264892
     /* 2264892 */ GIM_Try, /*On fail goto*//*Label 30406*/ GIMT_Encode4(2264940), // Rule ID 48775 //
     /* 2264897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264903 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264910 */   // MIs[0] Operand 1
     /* 2264910 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2264915 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264919 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264923 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2264926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264928 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264930 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264938 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264939 */   // GIR_Coverage, 48775,
     /* 2264939 */   GIR_EraseRootFromParent_Done,
     /* 2264940 */ // Label 30406: @2264940
     /* 2264940 */ GIM_Try, /*On fail goto*//*Label 30407*/ GIMT_Encode4(2264988), // Rule ID 48782 //
     /* 2264945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264951 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264958 */   // MIs[0] Operand 1
     /* 2264958 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2264963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264967 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264971 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2264974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264976 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264978 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264987 */   // GIR_Coverage, 48782,
     /* 2264987 */   GIR_EraseRootFromParent_Done,
     /* 2264988 */ // Label 30407: @2264988
     /* 2264988 */ GIM_Try, /*On fail goto*//*Label 30408*/ GIMT_Encode4(2265036), // Rule ID 48783 //
     /* 2264993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264999 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265006 */   // MIs[0] Operand 1
     /* 2265006 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2265011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265015 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265019 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265024 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265026 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265034 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265035 */   // GIR_Coverage, 48783,
     /* 2265035 */   GIR_EraseRootFromParent_Done,
     /* 2265036 */ // Label 30408: @2265036
     /* 2265036 */ GIM_Try, /*On fail goto*//*Label 30409*/ GIMT_Encode4(2265084), // Rule ID 48818 //
     /* 2265041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265047 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265054 */   // MIs[0] Operand 1
     /* 2265054 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265059 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265063 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265067 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2265070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265072 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265074 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265083 */   // GIR_Coverage, 48818,
     /* 2265083 */   GIR_EraseRootFromParent_Done,
     /* 2265084 */ // Label 30409: @2265084
     /* 2265084 */ GIM_Try, /*On fail goto*//*Label 30410*/ GIMT_Encode4(2265132), // Rule ID 48819 //
     /* 2265089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265095 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265102 */   // MIs[0] Operand 1
     /* 2265102 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265111 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265115 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2265118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265120 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265122 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265130 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265131 */   // GIR_Coverage, 48819,
     /* 2265131 */   GIR_EraseRootFromParent_Done,
     /* 2265132 */ // Label 30410: @2265132
     /* 2265132 */ GIM_Try, /*On fail goto*//*Label 30411*/ GIMT_Encode4(2265180), // Rule ID 48826 //
     /* 2265137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265150 */   // MIs[0] Operand 1
     /* 2265150 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265159 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265163 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265168 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265170 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265178 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265179 */   // GIR_Coverage, 48826,
     /* 2265179 */   GIR_EraseRootFromParent_Done,
     /* 2265180 */ // Label 30411: @2265180
     /* 2265180 */ GIM_Try, /*On fail goto*//*Label 30412*/ GIMT_Encode4(2265228), // Rule ID 48827 //
     /* 2265185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265191 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265198 */   // MIs[0] Operand 1
     /* 2265198 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265207 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265211 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265216 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265218 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265227 */   // GIR_Coverage, 48827,
     /* 2265227 */   GIR_EraseRootFromParent_Done,
     /* 2265228 */ // Label 30412: @2265228
     /* 2265228 */ GIM_Try, /*On fail goto*//*Label 30413*/ GIMT_Encode4(2265276), // Rule ID 48862 //
     /* 2265233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265239 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265246 */   // MIs[0] Operand 1
     /* 2265246 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265255 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265259 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265264 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265266 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265274 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265275 */   // GIR_Coverage, 48862,
     /* 2265275 */   GIR_EraseRootFromParent_Done,
     /* 2265276 */ // Label 30413: @2265276
     /* 2265276 */ GIM_Try, /*On fail goto*//*Label 30414*/ GIMT_Encode4(2265324), // Rule ID 48863 //
     /* 2265281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265287 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265294 */   // MIs[0] Operand 1
     /* 2265294 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265303 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265307 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265312 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265314 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265322 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265323 */   // GIR_Coverage, 48863,
     /* 2265323 */   GIR_EraseRootFromParent_Done,
     /* 2265324 */ // Label 30414: @2265324
     /* 2265324 */ GIM_Try, /*On fail goto*//*Label 30415*/ GIMT_Encode4(2265372), // Rule ID 48870 //
     /* 2265329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265335 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265342 */   // MIs[0] Operand 1
     /* 2265342 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265351 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265355 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265360 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265362 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265370 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265371 */   // GIR_Coverage, 48870,
     /* 2265371 */   GIR_EraseRootFromParent_Done,
     /* 2265372 */ // Label 30415: @2265372
     /* 2265372 */ GIM_Try, /*On fail goto*//*Label 30416*/ GIMT_Encode4(2265420), // Rule ID 48871 //
     /* 2265377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265383 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265390 */   // MIs[0] Operand 1
     /* 2265390 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265399 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265403 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265408 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265410 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265418 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265419 */   // GIR_Coverage, 48871,
     /* 2265419 */   GIR_EraseRootFromParent_Done,
     /* 2265420 */ // Label 30416: @2265420
     /* 2265420 */ GIM_Try, /*On fail goto*//*Label 30417*/ GIMT_Encode4(2265468), // Rule ID 48906 //
     /* 2265425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265431 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265438 */   // MIs[0] Operand 1
     /* 2265438 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265443 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265447 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265451 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265456 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265458 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265466 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265467 */   // GIR_Coverage, 48906,
     /* 2265467 */   GIR_EraseRootFromParent_Done,
     /* 2265468 */ // Label 30417: @2265468
     /* 2265468 */ GIM_Try, /*On fail goto*//*Label 30418*/ GIMT_Encode4(2265516), // Rule ID 48907 //
     /* 2265473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265479 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265486 */   // MIs[0] Operand 1
     /* 2265486 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265495 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265499 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265504 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265506 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265515 */   // GIR_Coverage, 48907,
     /* 2265515 */   GIR_EraseRootFromParent_Done,
     /* 2265516 */ // Label 30418: @2265516
     /* 2265516 */ GIM_Try, /*On fail goto*//*Label 30419*/ GIMT_Encode4(2265564), // Rule ID 48914 //
     /* 2265521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265527 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265534 */   // MIs[0] Operand 1
     /* 2265534 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265543 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265547 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265552 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265554 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265562 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265563 */   // GIR_Coverage, 48914,
     /* 2265563 */   GIR_EraseRootFromParent_Done,
     /* 2265564 */ // Label 30419: @2265564
     /* 2265564 */ GIM_Try, /*On fail goto*//*Label 30420*/ GIMT_Encode4(2265612), // Rule ID 48915 //
     /* 2265569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265575 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265582 */   // MIs[0] Operand 1
     /* 2265582 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265591 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265595 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265600 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265602 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265610 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265611 */   // GIR_Coverage, 48915,
     /* 2265611 */   GIR_EraseRootFromParent_Done,
     /* 2265612 */ // Label 30420: @2265612
     /* 2265612 */ GIM_Reject,
     /* 2265613 */ // Label 29901: @2265613
     /* 2265613 */ GIM_Try, /*On fail goto*//*Label 30421*/ GIMT_Encode4(2266389),
     /* 2265618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2265621 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2265624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265628 */   GIM_Try, /*On fail goto*//*Label 30422*/ GIMT_Encode4(2265666), // Rule ID 48514 //
     /* 2265633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265636 */     // MIs[0] Operand 1
     /* 2265636 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2265641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265649 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2265652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265665 */     // GIR_Coverage, 48514,
     /* 2265665 */     GIR_EraseRootFromParent_Done,
     /* 2265666 */   // Label 30422: @2265666
     /* 2265666 */   GIM_Try, /*On fail goto*//*Label 30423*/ GIMT_Encode4(2265704), // Rule ID 48515 //
     /* 2265671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265674 */     // MIs[0] Operand 1
     /* 2265674 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2265679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265687 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2265690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265703 */     // GIR_Coverage, 48515,
     /* 2265703 */     GIR_EraseRootFromParent_Done,
     /* 2265704 */   // Label 30423: @2265704
     /* 2265704 */   GIM_Try, /*On fail goto*//*Label 30424*/ GIMT_Encode4(2265742), // Rule ID 48558 //
     /* 2265709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265712 */     // MIs[0] Operand 1
     /* 2265712 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2265717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265725 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2265728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265741 */     // GIR_Coverage, 48558,
     /* 2265741 */     GIR_EraseRootFromParent_Done,
     /* 2265742 */   // Label 30424: @2265742
     /* 2265742 */   GIM_Try, /*On fail goto*//*Label 30425*/ GIMT_Encode4(2265780), // Rule ID 48559 //
     /* 2265747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265750 */     // MIs[0] Operand 1
     /* 2265750 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2265755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265763 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2265766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265779 */     // GIR_Coverage, 48559,
     /* 2265779 */     GIR_EraseRootFromParent_Done,
     /* 2265780 */   // Label 30425: @2265780
     /* 2265780 */   GIM_Try, /*On fail goto*//*Label 30426*/ GIMT_Encode4(2265818), // Rule ID 48602 //
     /* 2265785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265788 */     // MIs[0] Operand 1
     /* 2265788 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2265793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265801 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2265804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265817 */     // GIR_Coverage, 48602,
     /* 2265817 */     GIR_EraseRootFromParent_Done,
     /* 2265818 */   // Label 30426: @2265818
     /* 2265818 */   GIM_Try, /*On fail goto*//*Label 30427*/ GIMT_Encode4(2265856), // Rule ID 48603 //
     /* 2265823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265826 */     // MIs[0] Operand 1
     /* 2265826 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2265831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265839 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2265842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265855 */     // GIR_Coverage, 48603,
     /* 2265855 */     GIR_EraseRootFromParent_Done,
     /* 2265856 */   // Label 30427: @2265856
     /* 2265856 */   GIM_Try, /*On fail goto*//*Label 30428*/ GIMT_Encode4(2265894), // Rule ID 48644 //
     /* 2265861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265864 */     // MIs[0] Operand 1
     /* 2265864 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2265869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265877 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2265880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265893 */     // GIR_Coverage, 48644,
     /* 2265893 */     GIR_EraseRootFromParent_Done,
     /* 2265894 */   // Label 30428: @2265894
     /* 2265894 */   GIM_Try, /*On fail goto*//*Label 30429*/ GIMT_Encode4(2265932), // Rule ID 48645 //
     /* 2265899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265902 */     // MIs[0] Operand 1
     /* 2265902 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2265907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265915 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2265918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265931 */     // GIR_Coverage, 48645,
     /* 2265931 */     GIR_EraseRootFromParent_Done,
     /* 2265932 */   // Label 30429: @2265932
     /* 2265932 */   GIM_Try, /*On fail goto*//*Label 30430*/ GIMT_Encode4(2265970), // Rule ID 48688 //
     /* 2265937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265940 */     // MIs[0] Operand 1
     /* 2265940 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265953 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265969 */     // GIR_Coverage, 48688,
     /* 2265969 */     GIR_EraseRootFromParent_Done,
     /* 2265970 */   // Label 30430: @2265970
     /* 2265970 */   GIM_Try, /*On fail goto*//*Label 30431*/ GIMT_Encode4(2266008), // Rule ID 48689 //
     /* 2265975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265978 */     // MIs[0] Operand 1
     /* 2265978 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265991 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266007 */     // GIR_Coverage, 48689,
     /* 2266007 */     GIR_EraseRootFromParent_Done,
     /* 2266008 */   // Label 30431: @2266008
     /* 2266008 */   GIM_Try, /*On fail goto*//*Label 30432*/ GIMT_Encode4(2266046), // Rule ID 48732 //
     /* 2266013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266016 */     // MIs[0] Operand 1
     /* 2266016 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2266021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266029 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2266032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266045 */     // GIR_Coverage, 48732,
     /* 2266045 */     GIR_EraseRootFromParent_Done,
     /* 2266046 */   // Label 30432: @2266046
     /* 2266046 */   GIM_Try, /*On fail goto*//*Label 30433*/ GIMT_Encode4(2266084), // Rule ID 48733 //
     /* 2266051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266054 */     // MIs[0] Operand 1
     /* 2266054 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2266059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266067 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2266070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266083 */     // GIR_Coverage, 48733,
     /* 2266083 */     GIR_EraseRootFromParent_Done,
     /* 2266084 */   // Label 30433: @2266084
     /* 2266084 */   GIM_Try, /*On fail goto*//*Label 30434*/ GIMT_Encode4(2266122), // Rule ID 48776 //
     /* 2266089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266092 */     // MIs[0] Operand 1
     /* 2266092 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2266097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266105 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266121 */     // GIR_Coverage, 48776,
     /* 2266121 */     GIR_EraseRootFromParent_Done,
     /* 2266122 */   // Label 30434: @2266122
     /* 2266122 */   GIM_Try, /*On fail goto*//*Label 30435*/ GIMT_Encode4(2266160), // Rule ID 48777 //
     /* 2266127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266130 */     // MIs[0] Operand 1
     /* 2266130 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2266135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266143 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266159 */     // GIR_Coverage, 48777,
     /* 2266159 */     GIR_EraseRootFromParent_Done,
     /* 2266160 */   // Label 30435: @2266160
     /* 2266160 */   GIM_Try, /*On fail goto*//*Label 30436*/ GIMT_Encode4(2266198), // Rule ID 48820 //
     /* 2266165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266168 */     // MIs[0] Operand 1
     /* 2266168 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2266173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266181 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266197 */     // GIR_Coverage, 48820,
     /* 2266197 */     GIR_EraseRootFromParent_Done,
     /* 2266198 */   // Label 30436: @2266198
     /* 2266198 */   GIM_Try, /*On fail goto*//*Label 30437*/ GIMT_Encode4(2266236), // Rule ID 48821 //
     /* 2266203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266206 */     // MIs[0] Operand 1
     /* 2266206 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2266211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266219 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266235 */     // GIR_Coverage, 48821,
     /* 2266235 */     GIR_EraseRootFromParent_Done,
     /* 2266236 */   // Label 30437: @2266236
     /* 2266236 */   GIM_Try, /*On fail goto*//*Label 30438*/ GIMT_Encode4(2266274), // Rule ID 48864 //
     /* 2266241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266244 */     // MIs[0] Operand 1
     /* 2266244 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2266249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266257 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266273 */     // GIR_Coverage, 48864,
     /* 2266273 */     GIR_EraseRootFromParent_Done,
     /* 2266274 */   // Label 30438: @2266274
     /* 2266274 */   GIM_Try, /*On fail goto*//*Label 30439*/ GIMT_Encode4(2266312), // Rule ID 48865 //
     /* 2266279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266282 */     // MIs[0] Operand 1
     /* 2266282 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2266287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266295 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266311 */     // GIR_Coverage, 48865,
     /* 2266311 */     GIR_EraseRootFromParent_Done,
     /* 2266312 */   // Label 30439: @2266312
     /* 2266312 */   GIM_Try, /*On fail goto*//*Label 30440*/ GIMT_Encode4(2266350), // Rule ID 48908 //
     /* 2266317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266320 */     // MIs[0] Operand 1
     /* 2266320 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2266325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266333 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266349 */     // GIR_Coverage, 48908,
     /* 2266349 */     GIR_EraseRootFromParent_Done,
     /* 2266350 */   // Label 30440: @2266350
     /* 2266350 */   GIM_Try, /*On fail goto*//*Label 30441*/ GIMT_Encode4(2266388), // Rule ID 48909 //
     /* 2266355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266358 */     // MIs[0] Operand 1
     /* 2266358 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2266363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266371 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266387 */     // GIR_Coverage, 48909,
     /* 2266387 */     GIR_EraseRootFromParent_Done,
     /* 2266388 */   // Label 30441: @2266388
     /* 2266388 */   GIM_Reject,
     /* 2266389 */ // Label 30421: @2266389
     /* 2266389 */ GIM_Reject,
     /* 2266390 */ // Label 29902: @2266390
     /* 2266390 */ GIM_Reject,
     /* 2266391 */ // Label 49: @2266391
     /* 2266391 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(30), /*)*//*default:*//*Label 30450*/ GIMT_Encode4(2273852),
     /* 2266402 */ /*GILLT_s32*//*Label 30442*/ GIMT_Encode4(2266510),
     /* 2266406 */ /*GILLT_s64*//*Label 30443*/ GIMT_Encode4(2267267),
     /* 2266410 */ /*GILLT_nxv1s1*//*Label 30444*/ GIMT_Encode4(2268150), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266430 */ /*GILLT_nxv2s1*//*Label 30445*/ GIMT_Encode4(2269303), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266450 */ /*GILLT_nxv4s1*//*Label 30446*/ GIMT_Encode4(2270456), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266470 */ /*GILLT_nxv8s1*//*Label 30447*/ GIMT_Encode4(2271609), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266490 */ /*GILLT_nxv16s1*//*Label 30448*/ GIMT_Encode4(2272762), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266506 */ /*GILLT_nxv32s1*//*Label 30449*/ GIMT_Encode4(2273531),
     /* 2266510 */ // Label 30442: @2266510
     /* 2266510 */ GIM_Try, /*On fail goto*//*Label 30451*/ GIMT_Encode4(2266552), // Rule ID 1366 //
     /* 2266515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2266518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266521 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266528 */   // MIs[0] Operand 1
     /* 2266528 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266537 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266541 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2266544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266546 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266548 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266550 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266551 */   // GIR_Coverage, 1366,
     /* 2266551 */   GIR_EraseRootFromParent_Done,
     /* 2266552 */ // Label 30451: @2266552
     /* 2266552 */ GIM_Try, /*On fail goto*//*Label 30452*/ GIMT_Encode4(2266594), // Rule ID 1370 //
     /* 2266557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2266560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266563 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266570 */   // MIs[0] Operand 1
     /* 2266570 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266579 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266583 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2266586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266588 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266590 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266592 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266593 */   // GIR_Coverage, 1370,
     /* 2266593 */   GIR_EraseRootFromParent_Done,
     /* 2266594 */ // Label 30452: @2266594
     /* 2266594 */ GIM_Try, /*On fail goto*//*Label 30453*/ GIMT_Encode4(2266636), // Rule ID 1414 //
     /* 2266599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2266602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266605 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266612 */   // MIs[0] Operand 1
     /* 2266612 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2266617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266621 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266625 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2266628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266630 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266632 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266634 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266635 */   // GIR_Coverage, 1414,
     /* 2266635 */   GIR_EraseRootFromParent_Done,
     /* 2266636 */ // Label 30453: @2266636
     /* 2266636 */ GIM_Try, /*On fail goto*//*Label 30454*/ GIMT_Encode4(2266678), // Rule ID 1418 //
     /* 2266641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2266644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266647 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266654 */   // MIs[0] Operand 1
     /* 2266654 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2266659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266663 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266667 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2266670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266672 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266674 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266676 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266677 */   // GIR_Coverage, 1418,
     /* 2266677 */   GIR_EraseRootFromParent_Done,
     /* 2266678 */ // Label 30454: @2266678
     /* 2266678 */ GIM_Try, /*On fail goto*//*Label 30455*/ GIMT_Encode4(2266720), // Rule ID 1430 //
     /* 2266683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2266686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266689 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266696 */   // MIs[0] Operand 1
     /* 2266696 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2266701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266705 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266709 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2266712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266714 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266716 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266719 */   // GIR_Coverage, 1430,
     /* 2266719 */   GIR_EraseRootFromParent_Done,
     /* 2266720 */ // Label 30455: @2266720
     /* 2266720 */ GIM_Try, /*On fail goto*//*Label 30456*/ GIMT_Encode4(2266762), // Rule ID 1434 //
     /* 2266725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2266728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266731 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266738 */   // MIs[0] Operand 1
     /* 2266738 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2266743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266747 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266751 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2266754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266756 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266758 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266760 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266761 */   // GIR_Coverage, 1434,
     /* 2266761 */   GIR_EraseRootFromParent_Done,
     /* 2266762 */ // Label 30456: @2266762
     /* 2266762 */ GIM_Try, /*On fail goto*//*Label 30457*/ GIMT_Encode4(2266804), // Rule ID 1746 //
     /* 2266767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2266770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2266773 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2266776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266780 */   // MIs[0] Operand 1
     /* 2266780 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2266789 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2266793 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2266793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2266796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266798 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266800 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266802 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266803 */   // GIR_Coverage, 1746,
     /* 2266803 */   GIR_EraseRootFromParent_Done,
     /* 2266804 */ // Label 30457: @2266804
     /* 2266804 */ GIM_Try, /*On fail goto*//*Label 30458*/ GIMT_Encode4(2266846), // Rule ID 1750 //
     /* 2266809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2266812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2266815 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2266818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266822 */   // MIs[0] Operand 1
     /* 2266822 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2266831 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2266835 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2266835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2266838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266840 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266842 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266844 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266845 */   // GIR_Coverage, 1750,
     /* 2266845 */   GIR_EraseRootFromParent_Done,
     /* 2266846 */ // Label 30458: @2266846
     /* 2266846 */ GIM_Try, /*On fail goto*//*Label 30459*/ GIMT_Encode4(2266888), // Rule ID 1788 //
     /* 2266851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2266854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2266857 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2266860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266864 */   // MIs[0] Operand 1
     /* 2266864 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2266869 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2266873 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2266877 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2266877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2266880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266882 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266884 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266887 */   // GIR_Coverage, 1788,
     /* 2266887 */   GIR_EraseRootFromParent_Done,
     /* 2266888 */ // Label 30459: @2266888
     /* 2266888 */ GIM_Try, /*On fail goto*//*Label 30460*/ GIMT_Encode4(2266930), // Rule ID 1796 //
     /* 2266893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2266896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2266899 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2266902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266906 */   // MIs[0] Operand 1
     /* 2266906 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2266911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2266915 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2266919 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2266919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2266922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266924 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266926 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266928 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266929 */   // GIR_Coverage, 1796,
     /* 2266929 */   GIR_EraseRootFromParent_Done,
     /* 2266930 */ // Label 30460: @2266930
     /* 2266930 */ GIM_Try, /*On fail goto*//*Label 30461*/ GIMT_Encode4(2266972), // Rule ID 1824 //
     /* 2266935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2266938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2266941 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2266944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266948 */   // MIs[0] Operand 1
     /* 2266948 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2266953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2266957 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2266961 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2266961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2266964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266966 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266968 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266970 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266971 */   // GIR_Coverage, 1824,
     /* 2266971 */   GIR_EraseRootFromParent_Done,
     /* 2266972 */ // Label 30461: @2266972
     /* 2266972 */ GIM_Try, /*On fail goto*//*Label 30462*/ GIMT_Encode4(2267014), // Rule ID 1832 //
     /* 2266977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2266980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2266983 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2266986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266990 */   // MIs[0] Operand 1
     /* 2266990 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2266995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2266999 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267003 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2267006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267008 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267010 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267013 */   // GIR_Coverage, 1832,
     /* 2267013 */   GIR_EraseRootFromParent_Done,
     /* 2267014 */ // Label 30462: @2267014
     /* 2267014 */ GIM_Try, /*On fail goto*//*Label 30463*/ GIMT_Encode4(2267056), // Rule ID 2079 //
     /* 2267019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2267022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267032 */   // MIs[0] Operand 1
     /* 2267032 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267041 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267045 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2267048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267050 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267052 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267054 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267055 */   // GIR_Coverage, 2079,
     /* 2267055 */   GIR_EraseRootFromParent_Done,
     /* 2267056 */ // Label 30463: @2267056
     /* 2267056 */ GIM_Try, /*On fail goto*//*Label 30464*/ GIMT_Encode4(2267098), // Rule ID 2083 //
     /* 2267061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2267064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267067 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267074 */   // MIs[0] Operand 1
     /* 2267074 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267083 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267087 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2267090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267092 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267094 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267096 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267097 */   // GIR_Coverage, 2083,
     /* 2267097 */   GIR_EraseRootFromParent_Done,
     /* 2267098 */ // Label 30464: @2267098
     /* 2267098 */ GIM_Try, /*On fail goto*//*Label 30465*/ GIMT_Encode4(2267140), // Rule ID 2127 //
     /* 2267103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2267106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267109 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267116 */   // MIs[0] Operand 1
     /* 2267116 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267125 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267129 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2267132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267134 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267136 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267138 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267139 */   // GIR_Coverage, 2127,
     /* 2267139 */   GIR_EraseRootFromParent_Done,
     /* 2267140 */ // Label 30465: @2267140
     /* 2267140 */ GIM_Try, /*On fail goto*//*Label 30466*/ GIMT_Encode4(2267182), // Rule ID 2131 //
     /* 2267145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2267148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267151 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267158 */   // MIs[0] Operand 1
     /* 2267158 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267167 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267171 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2267174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267176 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267178 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267180 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267181 */   // GIR_Coverage, 2131,
     /* 2267181 */   GIR_EraseRootFromParent_Done,
     /* 2267182 */ // Label 30466: @2267182
     /* 2267182 */ GIM_Try, /*On fail goto*//*Label 30467*/ GIMT_Encode4(2267224), // Rule ID 2143 //
     /* 2267187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2267190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267193 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267200 */   // MIs[0] Operand 1
     /* 2267200 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267209 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267213 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2267216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267218 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267220 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267223 */   // GIR_Coverage, 2143,
     /* 2267223 */   GIR_EraseRootFromParent_Done,
     /* 2267224 */ // Label 30467: @2267224
     /* 2267224 */ GIM_Try, /*On fail goto*//*Label 30468*/ GIMT_Encode4(2267266), // Rule ID 2147 //
     /* 2267229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2267232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267235 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267242 */   // MIs[0] Operand 1
     /* 2267242 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267251 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267255 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2267258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267260 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267262 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267264 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267265 */   // GIR_Coverage, 2147,
     /* 2267265 */   GIR_EraseRootFromParent_Done,
     /* 2267266 */ // Label 30468: @2267266
     /* 2267266 */ GIM_Reject,
     /* 2267267 */ // Label 30443: @2267267
     /* 2267267 */ GIM_Try, /*On fail goto*//*Label 30469*/ GIMT_Encode4(2267309), // Rule ID 1365 //
     /* 2267272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2267275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267278 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267285 */   // MIs[0] Operand 1
     /* 2267285 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267294 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267298 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2267301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267303 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267305 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267308 */   // GIR_Coverage, 1365,
     /* 2267308 */   GIR_EraseRootFromParent_Done,
     /* 2267309 */ // Label 30469: @2267309
     /* 2267309 */ GIM_Try, /*On fail goto*//*Label 30470*/ GIMT_Encode4(2267351), // Rule ID 1369 //
     /* 2267314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2267317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267327 */   // MIs[0] Operand 1
     /* 2267327 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267336 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267340 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2267343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267345 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267347 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267350 */   // GIR_Coverage, 1369,
     /* 2267350 */   GIR_EraseRootFromParent_Done,
     /* 2267351 */ // Label 30470: @2267351
     /* 2267351 */ GIM_Try, /*On fail goto*//*Label 30471*/ GIMT_Encode4(2267393), // Rule ID 1413 //
     /* 2267356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2267359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267362 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267369 */   // MIs[0] Operand 1
     /* 2267369 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267374 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267378 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267382 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2267385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267387 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267389 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267392 */   // GIR_Coverage, 1413,
     /* 2267392 */   GIR_EraseRootFromParent_Done,
     /* 2267393 */ // Label 30471: @2267393
     /* 2267393 */ GIM_Try, /*On fail goto*//*Label 30472*/ GIMT_Encode4(2267435), // Rule ID 1417 //
     /* 2267398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2267401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267404 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267411 */   // MIs[0] Operand 1
     /* 2267411 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267420 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267424 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2267427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267429 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267431 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267433 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267434 */   // GIR_Coverage, 1417,
     /* 2267434 */   GIR_EraseRootFromParent_Done,
     /* 2267435 */ // Label 30472: @2267435
     /* 2267435 */ GIM_Try, /*On fail goto*//*Label 30473*/ GIMT_Encode4(2267477), // Rule ID 1429 //
     /* 2267440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2267443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267446 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267453 */   // MIs[0] Operand 1
     /* 2267453 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267462 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267466 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2267469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267471 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267473 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267475 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267476 */   // GIR_Coverage, 1429,
     /* 2267476 */   GIR_EraseRootFromParent_Done,
     /* 2267477 */ // Label 30473: @2267477
     /* 2267477 */ GIM_Try, /*On fail goto*//*Label 30474*/ GIMT_Encode4(2267519), // Rule ID 1433 //
     /* 2267482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2267485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267488 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267495 */   // MIs[0] Operand 1
     /* 2267495 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267504 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267508 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2267511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267513 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267515 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267518 */   // GIR_Coverage, 1433,
     /* 2267518 */   GIR_EraseRootFromParent_Done,
     /* 2267519 */ // Label 30474: @2267519
     /* 2267519 */ GIM_Try, /*On fail goto*//*Label 30475*/ GIMT_Encode4(2267561), // Rule ID 1745 //
     /* 2267524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2267527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267537 */   // MIs[0] Operand 1
     /* 2267537 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267546 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267550 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2267553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267555 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267557 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267559 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267560 */   // GIR_Coverage, 1745,
     /* 2267560 */   GIR_EraseRootFromParent_Done,
     /* 2267561 */ // Label 30475: @2267561
     /* 2267561 */ GIM_Try, /*On fail goto*//*Label 30476*/ GIMT_Encode4(2267603), // Rule ID 1749 //
     /* 2267566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2267569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267572 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267579 */   // MIs[0] Operand 1
     /* 2267579 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267588 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267592 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2267595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267597 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267599 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267601 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267602 */   // GIR_Coverage, 1749,
     /* 2267602 */   GIR_EraseRootFromParent_Done,
     /* 2267603 */ // Label 30476: @2267603
     /* 2267603 */ GIM_Try, /*On fail goto*//*Label 30477*/ GIMT_Encode4(2267645), // Rule ID 1752 //
     /* 2267608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2267611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267614 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267621 */   // MIs[0] Operand 1
     /* 2267621 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267626 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267630 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267634 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_INX),
     /* 2267637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267639 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267641 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267643 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267644 */   // GIR_Coverage, 1752,
     /* 2267644 */   GIR_EraseRootFromParent_Done,
     /* 2267645 */ // Label 30477: @2267645
     /* 2267645 */ GIM_Try, /*On fail goto*//*Label 30478*/ GIMT_Encode4(2267687), // Rule ID 1787 //
     /* 2267650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2267653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267656 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267663 */   // MIs[0] Operand 1
     /* 2267663 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267672 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267676 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2267679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267681 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267683 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267685 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267686 */   // GIR_Coverage, 1787,
     /* 2267686 */   GIR_EraseRootFromParent_Done,
     /* 2267687 */ // Label 30478: @2267687
     /* 2267687 */ GIM_Try, /*On fail goto*//*Label 30479*/ GIMT_Encode4(2267729), // Rule ID 1795 //
     /* 2267692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2267695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267698 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267705 */   // MIs[0] Operand 1
     /* 2267705 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267714 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267718 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2267721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267723 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267725 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267727 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267728 */   // GIR_Coverage, 1795,
     /* 2267728 */   GIR_EraseRootFromParent_Done,
     /* 2267729 */ // Label 30479: @2267729
     /* 2267729 */ GIM_Try, /*On fail goto*//*Label 30480*/ GIMT_Encode4(2267771), // Rule ID 1804 //
     /* 2267734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2267737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267740 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267747 */   // MIs[0] Operand 1
     /* 2267747 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267756 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267760 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_INX),
     /* 2267763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267765 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267767 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267769 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267770 */   // GIR_Coverage, 1804,
     /* 2267770 */   GIR_EraseRootFromParent_Done,
     /* 2267771 */ // Label 30480: @2267771
     /* 2267771 */ GIM_Try, /*On fail goto*//*Label 30481*/ GIMT_Encode4(2267813), // Rule ID 1808 //
     /* 2267776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2267779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267782 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267789 */   // MIs[0] Operand 1
     /* 2267789 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267798 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267802 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_INX),
     /* 2267805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267807 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267809 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267812 */   // GIR_Coverage, 1808,
     /* 2267812 */   GIR_EraseRootFromParent_Done,
     /* 2267813 */ // Label 30481: @2267813
     /* 2267813 */ GIM_Try, /*On fail goto*//*Label 30482*/ GIMT_Encode4(2267855), // Rule ID 1823 //
     /* 2267818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2267821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267831 */   // MIs[0] Operand 1
     /* 2267831 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267840 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267844 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2267847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267849 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267851 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267853 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267854 */   // GIR_Coverage, 1823,
     /* 2267854 */   GIR_EraseRootFromParent_Done,
     /* 2267855 */ // Label 30482: @2267855
     /* 2267855 */ GIM_Try, /*On fail goto*//*Label 30483*/ GIMT_Encode4(2267897), // Rule ID 1831 //
     /* 2267860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2267863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267866 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267873 */   // MIs[0] Operand 1
     /* 2267873 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267882 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267886 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2267889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267891 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267893 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267896 */   // GIR_Coverage, 1831,
     /* 2267896 */   GIR_EraseRootFromParent_Done,
     /* 2267897 */ // Label 30483: @2267897
     /* 2267897 */ GIM_Try, /*On fail goto*//*Label 30484*/ GIMT_Encode4(2267939), // Rule ID 2078 //
     /* 2267902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2267905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267908 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267915 */   // MIs[0] Operand 1
     /* 2267915 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267924 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267928 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2267931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267933 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267935 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267937 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267938 */   // GIR_Coverage, 2078,
     /* 2267938 */   GIR_EraseRootFromParent_Done,
     /* 2267939 */ // Label 30484: @2267939
     /* 2267939 */ GIM_Try, /*On fail goto*//*Label 30485*/ GIMT_Encode4(2267981), // Rule ID 2082 //
     /* 2267944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2267947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267950 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267957 */   // MIs[0] Operand 1
     /* 2267957 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267966 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267970 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2267973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267975 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267977 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267979 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267980 */   // GIR_Coverage, 2082,
     /* 2267980 */   GIR_EraseRootFromParent_Done,
     /* 2267981 */ // Label 30485: @2267981
     /* 2267981 */ GIM_Try, /*On fail goto*//*Label 30486*/ GIMT_Encode4(2268023), // Rule ID 2126 //
     /* 2267986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2267989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267992 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267999 */   // MIs[0] Operand 1
     /* 2267999 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268008 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268012 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2268015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268017 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268019 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268022 */   // GIR_Coverage, 2126,
     /* 2268022 */   GIR_EraseRootFromParent_Done,
     /* 2268023 */ // Label 30486: @2268023
     /* 2268023 */ GIM_Try, /*On fail goto*//*Label 30487*/ GIMT_Encode4(2268065), // Rule ID 2130 //
     /* 2268028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2268031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268034 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268041 */   // MIs[0] Operand 1
     /* 2268041 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268050 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268054 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2268057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268059 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268061 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268063 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268064 */   // GIR_Coverage, 2130,
     /* 2268064 */   GIR_EraseRootFromParent_Done,
     /* 2268065 */ // Label 30487: @2268065
     /* 2268065 */ GIM_Try, /*On fail goto*//*Label 30488*/ GIMT_Encode4(2268107), // Rule ID 2142 //
     /* 2268070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2268073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268076 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268083 */   // MIs[0] Operand 1
     /* 2268083 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268092 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268096 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2268099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268101 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268103 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268105 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268106 */   // GIR_Coverage, 2142,
     /* 2268106 */   GIR_EraseRootFromParent_Done,
     /* 2268107 */ // Label 30488: @2268107
     /* 2268107 */ GIM_Try, /*On fail goto*//*Label 30489*/ GIMT_Encode4(2268149), // Rule ID 2146 //
     /* 2268112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2268115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268118 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268125 */   // MIs[0] Operand 1
     /* 2268125 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268134 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268138 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2268141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268143 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268145 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268148 */   // GIR_Coverage, 2146,
     /* 2268148 */   GIR_EraseRootFromParent_Done,
     /* 2268149 */ // Label 30489: @2268149
     /* 2268149 */ GIM_Reject,
     /* 2268150 */ // Label 30444: @2268150
     /* 2268150 */ GIM_Try, /*On fail goto*//*Label 30490*/ GIMT_Encode4(2268198), // Rule ID 57034 //
     /* 2268155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2268158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268161 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268168 */   // MIs[0] Operand 1
     /* 2268168 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268177 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268181 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2268184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268186 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268188 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268196 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268197 */   // GIR_Coverage, 57034,
     /* 2268197 */   GIR_EraseRootFromParent_Done,
     /* 2268198 */ // Label 30490: @2268198
     /* 2268198 */ GIM_Try, /*On fail goto*//*Label 30491*/ GIMT_Encode4(2268246), // Rule ID 57035 //
     /* 2268203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2268206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268209 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268216 */   // MIs[0] Operand 1
     /* 2268216 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268225 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268229 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2268232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268234 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268236 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268245 */   // GIR_Coverage, 57035,
     /* 2268245 */   GIR_EraseRootFromParent_Done,
     /* 2268246 */ // Label 30491: @2268246
     /* 2268246 */ GIM_Try, /*On fail goto*//*Label 30492*/ GIMT_Encode4(2268294), // Rule ID 57054 //
     /* 2268251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2268254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268257 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268264 */   // MIs[0] Operand 1
     /* 2268264 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268273 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268277 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2268277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2268280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268282 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268284 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268292 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268293 */   // GIR_Coverage, 57054,
     /* 2268293 */   GIR_EraseRootFromParent_Done,
     /* 2268294 */ // Label 30492: @2268294
     /* 2268294 */ GIM_Try, /*On fail goto*//*Label 30493*/ GIMT_Encode4(2268342), // Rule ID 57055 //
     /* 2268299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2268302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268305 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268312 */   // MIs[0] Operand 1
     /* 2268312 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268321 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268325 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2268325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2268328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268330 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268332 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268340 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268341 */   // GIR_Coverage, 57055,
     /* 2268341 */   GIR_EraseRootFromParent_Done,
     /* 2268342 */ // Label 30493: @2268342
     /* 2268342 */ GIM_Try, /*On fail goto*//*Label 30494*/ GIMT_Encode4(2268390), // Rule ID 57084 //
     /* 2268347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2268350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268353 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268360 */   // MIs[0] Operand 1
     /* 2268360 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268365 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268369 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268373 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2268373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2268376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268378 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268380 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268388 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268389 */   // GIR_Coverage, 57084,
     /* 2268389 */   GIR_EraseRootFromParent_Done,
     /* 2268390 */ // Label 30494: @2268390
     /* 2268390 */ GIM_Try, /*On fail goto*//*Label 30495*/ GIMT_Encode4(2268438), // Rule ID 57085 //
     /* 2268395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2268398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268401 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268408 */   // MIs[0] Operand 1
     /* 2268408 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268417 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268421 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2268421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2268424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268426 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268428 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268437 */   // GIR_Coverage, 57085,
     /* 2268437 */   GIR_EraseRootFromParent_Done,
     /* 2268438 */ // Label 30495: @2268438
     /* 2268438 */ GIM_Try, /*On fail goto*//*Label 30496*/ GIMT_Encode4(2268486), // Rule ID 57334 //
     /* 2268443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2268446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268456 */   // MIs[0] Operand 1
     /* 2268456 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268465 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268469 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2268472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268474 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268476 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268484 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268485 */   // GIR_Coverage, 57334,
     /* 2268485 */   GIR_EraseRootFromParent_Done,
     /* 2268486 */ // Label 30496: @2268486
     /* 2268486 */ GIM_Try, /*On fail goto*//*Label 30497*/ GIMT_Encode4(2268534), // Rule ID 57335 //
     /* 2268491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2268494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268497 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268504 */   // MIs[0] Operand 1
     /* 2268504 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268513 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268517 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2268520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268522 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268524 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268533 */   // GIR_Coverage, 57335,
     /* 2268533 */   GIR_EraseRootFromParent_Done,
     /* 2268534 */ // Label 30497: @2268534
     /* 2268534 */ GIM_Try, /*On fail goto*//*Label 30498*/ GIMT_Encode4(2268582), // Rule ID 57354 //
     /* 2268539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2268542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268552 */   // MIs[0] Operand 1
     /* 2268552 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268561 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268565 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2268565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2268568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268570 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268572 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268580 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268581 */   // GIR_Coverage, 57354,
     /* 2268581 */   GIR_EraseRootFromParent_Done,
     /* 2268582 */ // Label 30498: @2268582
     /* 2268582 */ GIM_Try, /*On fail goto*//*Label 30499*/ GIMT_Encode4(2268630), // Rule ID 57355 //
     /* 2268587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2268590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268593 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268600 */   // MIs[0] Operand 1
     /* 2268600 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268609 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268613 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2268613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2268616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268618 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268620 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268628 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268629 */   // GIR_Coverage, 57355,
     /* 2268629 */   GIR_EraseRootFromParent_Done,
     /* 2268630 */ // Label 30499: @2268630
     /* 2268630 */ GIM_Try, /*On fail goto*//*Label 30500*/ GIMT_Encode4(2268678), // Rule ID 57384 //
     /* 2268635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2268638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268641 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268648 */   // MIs[0] Operand 1
     /* 2268648 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268657 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268661 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2268661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2268664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268666 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268668 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268676 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268677 */   // GIR_Coverage, 57384,
     /* 2268677 */   GIR_EraseRootFromParent_Done,
     /* 2268678 */ // Label 30500: @2268678
     /* 2268678 */ GIM_Try, /*On fail goto*//*Label 30501*/ GIMT_Encode4(2268726), // Rule ID 57385 //
     /* 2268683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2268686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268689 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268696 */   // MIs[0] Operand 1
     /* 2268696 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268705 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268709 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2268709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2268712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268714 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268716 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268724 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268725 */   // GIR_Coverage, 57385,
     /* 2268725 */   GIR_EraseRootFromParent_Done,
     /* 2268726 */ // Label 30501: @2268726
     /* 2268726 */ GIM_Try, /*On fail goto*//*Label 30502*/ GIMT_Encode4(2268774), // Rule ID 57634 //
     /* 2268731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2268734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268737 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268744 */   // MIs[0] Operand 1
     /* 2268744 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268753 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268757 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2268760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268762 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268764 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268773 */   // GIR_Coverage, 57634,
     /* 2268773 */   GIR_EraseRootFromParent_Done,
     /* 2268774 */ // Label 30502: @2268774
     /* 2268774 */ GIM_Try, /*On fail goto*//*Label 30503*/ GIMT_Encode4(2268822), // Rule ID 57635 //
     /* 2268779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2268782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268785 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268792 */   // MIs[0] Operand 1
     /* 2268792 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268801 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268805 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2268808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268810 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268812 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268820 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268821 */   // GIR_Coverage, 57635,
     /* 2268821 */   GIR_EraseRootFromParent_Done,
     /* 2268822 */ // Label 30503: @2268822
     /* 2268822 */ GIM_Try, /*On fail goto*//*Label 30504*/ GIMT_Encode4(2268870), // Rule ID 57654 //
     /* 2268827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2268830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268833 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268840 */   // MIs[0] Operand 1
     /* 2268840 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268849 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268853 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2268853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2268856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268858 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268860 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268868 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268869 */   // GIR_Coverage, 57654,
     /* 2268869 */   GIR_EraseRootFromParent_Done,
     /* 2268870 */ // Label 30504: @2268870
     /* 2268870 */ GIM_Try, /*On fail goto*//*Label 30505*/ GIMT_Encode4(2268918), // Rule ID 57655 //
     /* 2268875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2268878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268881 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268888 */   // MIs[0] Operand 1
     /* 2268888 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268897 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268901 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2268901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2268904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268906 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268908 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268916 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268917 */   // GIR_Coverage, 57655,
     /* 2268917 */   GIR_EraseRootFromParent_Done,
     /* 2268918 */ // Label 30505: @2268918
     /* 2268918 */ GIM_Try, /*On fail goto*//*Label 30506*/ GIMT_Encode4(2268966), // Rule ID 57684 //
     /* 2268923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2268926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268929 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268936 */   // MIs[0] Operand 1
     /* 2268936 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268945 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268949 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2268949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2268952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268954 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268956 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268964 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268965 */   // GIR_Coverage, 57684,
     /* 2268965 */   GIR_EraseRootFromParent_Done,
     /* 2268966 */ // Label 30506: @2268966
     /* 2268966 */ GIM_Try, /*On fail goto*//*Label 30507*/ GIMT_Encode4(2269014), // Rule ID 57685 //
     /* 2268971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2268974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268977 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268984 */   // MIs[0] Operand 1
     /* 2268984 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268993 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268997 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2268997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2269000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269002 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269004 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269013 */   // GIR_Coverage, 57685,
     /* 2269013 */   GIR_EraseRootFromParent_Done,
     /* 2269014 */ // Label 30507: @2269014
     /* 2269014 */ GIM_Try, /*On fail goto*//*Label 30508*/ GIMT_Encode4(2269062), // Rule ID 57934 //
     /* 2269019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2269022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2269025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2269028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269032 */   // MIs[0] Operand 1
     /* 2269032 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269041 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269045 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2269045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2269048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269050 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269052 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269061 */   // GIR_Coverage, 57934,
     /* 2269061 */   GIR_EraseRootFromParent_Done,
     /* 2269062 */ // Label 30508: @2269062
     /* 2269062 */ GIM_Try, /*On fail goto*//*Label 30509*/ GIMT_Encode4(2269110), // Rule ID 57935 //
     /* 2269067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2269070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2269073 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2269076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269080 */   // MIs[0] Operand 1
     /* 2269080 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269089 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269093 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2269096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269098 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269100 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269108 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269109 */   // GIR_Coverage, 57935,
     /* 2269109 */   GIR_EraseRootFromParent_Done,
     /* 2269110 */ // Label 30509: @2269110
     /* 2269110 */ GIM_Try, /*On fail goto*//*Label 30510*/ GIMT_Encode4(2269158), // Rule ID 57954 //
     /* 2269115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269121 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269128 */   // MIs[0] Operand 1
     /* 2269128 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269137 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269141 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2269144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269146 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269148 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269156 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269157 */   // GIR_Coverage, 57954,
     /* 2269157 */   GIR_EraseRootFromParent_Done,
     /* 2269158 */ // Label 30510: @2269158
     /* 2269158 */ GIM_Try, /*On fail goto*//*Label 30511*/ GIMT_Encode4(2269206), // Rule ID 57955 //
     /* 2269163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269169 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269176 */   // MIs[0] Operand 1
     /* 2269176 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269185 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269189 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2269192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269194 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269196 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269204 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269205 */   // GIR_Coverage, 57955,
     /* 2269205 */   GIR_EraseRootFromParent_Done,
     /* 2269206 */ // Label 30511: @2269206
     /* 2269206 */ GIM_Try, /*On fail goto*//*Label 30512*/ GIMT_Encode4(2269254), // Rule ID 57984 //
     /* 2269211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269217 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269224 */   // MIs[0] Operand 1
     /* 2269224 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269233 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269237 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2269240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269242 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269244 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269253 */   // GIR_Coverage, 57984,
     /* 2269253 */   GIR_EraseRootFromParent_Done,
     /* 2269254 */ // Label 30512: @2269254
     /* 2269254 */ GIM_Try, /*On fail goto*//*Label 30513*/ GIMT_Encode4(2269302), // Rule ID 57985 //
     /* 2269259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2269262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269265 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269272 */   // MIs[0] Operand 1
     /* 2269272 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269281 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269285 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2269285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2269288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269290 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269292 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269300 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269301 */   // GIR_Coverage, 57985,
     /* 2269301 */   GIR_EraseRootFromParent_Done,
     /* 2269302 */ // Label 30513: @2269302
     /* 2269302 */ GIM_Reject,
     /* 2269303 */ // Label 30445: @2269303
     /* 2269303 */ GIM_Try, /*On fail goto*//*Label 30514*/ GIMT_Encode4(2269351), // Rule ID 57044 //
     /* 2269308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2269311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269314 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269321 */   // MIs[0] Operand 1
     /* 2269321 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269330 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269334 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2269334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2269337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269339 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269341 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269350 */   // GIR_Coverage, 57044,
     /* 2269350 */   GIR_EraseRootFromParent_Done,
     /* 2269351 */ // Label 30514: @2269351
     /* 2269351 */ GIM_Try, /*On fail goto*//*Label 30515*/ GIMT_Encode4(2269399), // Rule ID 57045 //
     /* 2269356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2269359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269362 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269369 */   // MIs[0] Operand 1
     /* 2269369 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269374 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269378 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269382 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2269385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269387 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269389 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269397 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269398 */   // GIR_Coverage, 57045,
     /* 2269398 */   GIR_EraseRootFromParent_Done,
     /* 2269399 */ // Label 30515: @2269399
     /* 2269399 */ GIM_Try, /*On fail goto*//*Label 30516*/ GIMT_Encode4(2269447), // Rule ID 57074 //
     /* 2269404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269410 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269417 */   // MIs[0] Operand 1
     /* 2269417 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269426 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269430 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2269433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269435 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269437 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269445 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269446 */   // GIR_Coverage, 57074,
     /* 2269446 */   GIR_EraseRootFromParent_Done,
     /* 2269447 */ // Label 30516: @2269447
     /* 2269447 */ GIM_Try, /*On fail goto*//*Label 30517*/ GIMT_Encode4(2269495), // Rule ID 57075 //
     /* 2269452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269458 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269465 */   // MIs[0] Operand 1
     /* 2269465 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269474 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269478 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2269481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269483 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269485 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269493 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269494 */   // GIR_Coverage, 57075,
     /* 2269494 */   GIR_EraseRootFromParent_Done,
     /* 2269495 */ // Label 30517: @2269495
     /* 2269495 */ GIM_Try, /*On fail goto*//*Label 30518*/ GIMT_Encode4(2269543), // Rule ID 57154 //
     /* 2269500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269506 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269513 */   // MIs[0] Operand 1
     /* 2269513 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269522 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269526 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2269529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269531 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269533 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269541 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269542 */   // GIR_Coverage, 57154,
     /* 2269542 */   GIR_EraseRootFromParent_Done,
     /* 2269543 */ // Label 30518: @2269543
     /* 2269543 */ GIM_Try, /*On fail goto*//*Label 30519*/ GIMT_Encode4(2269591), // Rule ID 57155 //
     /* 2269548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2269551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269554 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269561 */   // MIs[0] Operand 1
     /* 2269561 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269570 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269574 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2269574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2269577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269579 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269581 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269589 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269590 */   // GIR_Coverage, 57155,
     /* 2269590 */   GIR_EraseRootFromParent_Done,
     /* 2269591 */ // Label 30519: @2269591
     /* 2269591 */ GIM_Try, /*On fail goto*//*Label 30520*/ GIMT_Encode4(2269639), // Rule ID 57344 //
     /* 2269596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2269599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269602 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269609 */   // MIs[0] Operand 1
     /* 2269609 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269618 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269622 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2269622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2269625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269627 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269629 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269637 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269638 */   // GIR_Coverage, 57344,
     /* 2269638 */   GIR_EraseRootFromParent_Done,
     /* 2269639 */ // Label 30520: @2269639
     /* 2269639 */ GIM_Try, /*On fail goto*//*Label 30521*/ GIMT_Encode4(2269687), // Rule ID 57345 //
     /* 2269644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2269647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269650 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269657 */   // MIs[0] Operand 1
     /* 2269657 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269666 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269670 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2269673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269675 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269677 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269685 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269686 */   // GIR_Coverage, 57345,
     /* 2269686 */   GIR_EraseRootFromParent_Done,
     /* 2269687 */ // Label 30521: @2269687
     /* 2269687 */ GIM_Try, /*On fail goto*//*Label 30522*/ GIMT_Encode4(2269735), // Rule ID 57374 //
     /* 2269692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269698 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269705 */   // MIs[0] Operand 1
     /* 2269705 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269714 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269718 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2269721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269723 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269725 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269733 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269734 */   // GIR_Coverage, 57374,
     /* 2269734 */   GIR_EraseRootFromParent_Done,
     /* 2269735 */ // Label 30522: @2269735
     /* 2269735 */ GIM_Try, /*On fail goto*//*Label 30523*/ GIMT_Encode4(2269783), // Rule ID 57375 //
     /* 2269740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269746 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269753 */   // MIs[0] Operand 1
     /* 2269753 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269762 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269766 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2269769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269771 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269773 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269781 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269782 */   // GIR_Coverage, 57375,
     /* 2269782 */   GIR_EraseRootFromParent_Done,
     /* 2269783 */ // Label 30523: @2269783
     /* 2269783 */ GIM_Try, /*On fail goto*//*Label 30524*/ GIMT_Encode4(2269831), // Rule ID 57454 //
     /* 2269788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269794 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269801 */   // MIs[0] Operand 1
     /* 2269801 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269810 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269814 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2269817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269819 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269821 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269830 */   // GIR_Coverage, 57454,
     /* 2269830 */   GIR_EraseRootFromParent_Done,
     /* 2269831 */ // Label 30524: @2269831
     /* 2269831 */ GIM_Try, /*On fail goto*//*Label 30525*/ GIMT_Encode4(2269879), // Rule ID 57455 //
     /* 2269836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2269839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269842 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269849 */   // MIs[0] Operand 1
     /* 2269849 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269858 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269862 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2269862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2269865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269867 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269869 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269877 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269878 */   // GIR_Coverage, 57455,
     /* 2269878 */   GIR_EraseRootFromParent_Done,
     /* 2269879 */ // Label 30525: @2269879
     /* 2269879 */ GIM_Try, /*On fail goto*//*Label 30526*/ GIMT_Encode4(2269927), // Rule ID 57644 //
     /* 2269884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2269887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269890 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269897 */   // MIs[0] Operand 1
     /* 2269897 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269906 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269910 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2269910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2269913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269915 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269917 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269925 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269926 */   // GIR_Coverage, 57644,
     /* 2269926 */   GIR_EraseRootFromParent_Done,
     /* 2269927 */ // Label 30526: @2269927
     /* 2269927 */ GIM_Try, /*On fail goto*//*Label 30527*/ GIMT_Encode4(2269975), // Rule ID 57645 //
     /* 2269932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2269935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269945 */   // MIs[0] Operand 1
     /* 2269945 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269954 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269958 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2269961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269963 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269965 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269973 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269974 */   // GIR_Coverage, 57645,
     /* 2269974 */   GIR_EraseRootFromParent_Done,
     /* 2269975 */ // Label 30527: @2269975
     /* 2269975 */ GIM_Try, /*On fail goto*//*Label 30528*/ GIMT_Encode4(2270023), // Rule ID 57674 //
     /* 2269980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269986 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269993 */   // MIs[0] Operand 1
     /* 2269993 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270002 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270006 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2270006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2270009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270011 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270013 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270022 */   // GIR_Coverage, 57674,
     /* 2270022 */   GIR_EraseRootFromParent_Done,
     /* 2270023 */ // Label 30528: @2270023
     /* 2270023 */ GIM_Try, /*On fail goto*//*Label 30529*/ GIMT_Encode4(2270071), // Rule ID 57675 //
     /* 2270028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270034 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270041 */   // MIs[0] Operand 1
     /* 2270041 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270050 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270054 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2270054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2270057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270059 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270061 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270069 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270070 */   // GIR_Coverage, 57675,
     /* 2270070 */   GIR_EraseRootFromParent_Done,
     /* 2270071 */ // Label 30529: @2270071
     /* 2270071 */ GIM_Try, /*On fail goto*//*Label 30530*/ GIMT_Encode4(2270119), // Rule ID 57754 //
     /* 2270076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270082 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270089 */   // MIs[0] Operand 1
     /* 2270089 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270098 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270102 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2270102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2270105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270107 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270109 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270118 */   // GIR_Coverage, 57754,
     /* 2270118 */   GIR_EraseRootFromParent_Done,
     /* 2270119 */ // Label 30530: @2270119
     /* 2270119 */ GIM_Try, /*On fail goto*//*Label 30531*/ GIMT_Encode4(2270167), // Rule ID 57755 //
     /* 2270124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270130 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270137 */   // MIs[0] Operand 1
     /* 2270137 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270146 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270150 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2270153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270155 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270157 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270166 */   // GIR_Coverage, 57755,
     /* 2270166 */   GIR_EraseRootFromParent_Done,
     /* 2270167 */ // Label 30531: @2270167
     /* 2270167 */ GIM_Try, /*On fail goto*//*Label 30532*/ GIMT_Encode4(2270215), // Rule ID 57944 //
     /* 2270172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270178 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270185 */   // MIs[0] Operand 1
     /* 2270185 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270194 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270198 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2270201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270203 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270205 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270213 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270214 */   // GIR_Coverage, 57944,
     /* 2270214 */   GIR_EraseRootFromParent_Done,
     /* 2270215 */ // Label 30532: @2270215
     /* 2270215 */ GIM_Try, /*On fail goto*//*Label 30533*/ GIMT_Encode4(2270263), // Rule ID 57945 //
     /* 2270220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270226 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270233 */   // MIs[0] Operand 1
     /* 2270233 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270238 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270242 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270246 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2270249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270251 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270253 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270261 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270262 */   // GIR_Coverage, 57945,
     /* 2270262 */   GIR_EraseRootFromParent_Done,
     /* 2270263 */ // Label 30533: @2270263
     /* 2270263 */ GIM_Try, /*On fail goto*//*Label 30534*/ GIMT_Encode4(2270311), // Rule ID 57974 //
     /* 2270268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270274 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270281 */   // MIs[0] Operand 1
     /* 2270281 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270290 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270294 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2270294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2270297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270299 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270301 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270309 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270310 */   // GIR_Coverage, 57974,
     /* 2270310 */   GIR_EraseRootFromParent_Done,
     /* 2270311 */ // Label 30534: @2270311
     /* 2270311 */ GIM_Try, /*On fail goto*//*Label 30535*/ GIMT_Encode4(2270359), // Rule ID 57975 //
     /* 2270316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270329 */   // MIs[0] Operand 1
     /* 2270329 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270338 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270342 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2270342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2270345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270347 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270349 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270357 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270358 */   // GIR_Coverage, 57975,
     /* 2270358 */   GIR_EraseRootFromParent_Done,
     /* 2270359 */ // Label 30535: @2270359
     /* 2270359 */ GIM_Try, /*On fail goto*//*Label 30536*/ GIMT_Encode4(2270407), // Rule ID 58054 //
     /* 2270364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270377 */   // MIs[0] Operand 1
     /* 2270377 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270386 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270390 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2270390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2270393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270395 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270397 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270405 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270406 */   // GIR_Coverage, 58054,
     /* 2270406 */   GIR_EraseRootFromParent_Done,
     /* 2270407 */ // Label 30536: @2270407
     /* 2270407 */ GIM_Try, /*On fail goto*//*Label 30537*/ GIMT_Encode4(2270455), // Rule ID 58055 //
     /* 2270412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270418 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270425 */   // MIs[0] Operand 1
     /* 2270425 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270434 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270438 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2270441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270443 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270445 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270454 */   // GIR_Coverage, 58055,
     /* 2270454 */   GIR_EraseRootFromParent_Done,
     /* 2270455 */ // Label 30537: @2270455
     /* 2270455 */ GIM_Reject,
     /* 2270456 */ // Label 30446: @2270456
     /* 2270456 */ GIM_Try, /*On fail goto*//*Label 30538*/ GIMT_Encode4(2270504), // Rule ID 57064 //
     /* 2270461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270467 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270474 */   // MIs[0] Operand 1
     /* 2270474 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270483 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270487 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2270490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270492 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270494 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270503 */   // GIR_Coverage, 57064,
     /* 2270503 */   GIR_EraseRootFromParent_Done,
     /* 2270504 */ // Label 30538: @2270504
     /* 2270504 */ GIM_Try, /*On fail goto*//*Label 30539*/ GIMT_Encode4(2270552), // Rule ID 57065 //
     /* 2270509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270515 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270522 */   // MIs[0] Operand 1
     /* 2270522 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270531 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270535 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2270538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270540 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270542 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270550 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270551 */   // GIR_Coverage, 57065,
     /* 2270551 */   GIR_EraseRootFromParent_Done,
     /* 2270552 */ // Label 30539: @2270552
     /* 2270552 */ GIM_Try, /*On fail goto*//*Label 30540*/ GIMT_Encode4(2270600), // Rule ID 57124 //
     /* 2270557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2270563 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2270566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270570 */   // MIs[0] Operand 1
     /* 2270570 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270579 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270583 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2270583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2270586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270588 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270590 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270599 */   // GIR_Coverage, 57124,
     /* 2270599 */   GIR_EraseRootFromParent_Done,
     /* 2270600 */ // Label 30540: @2270600
     /* 2270600 */ GIM_Try, /*On fail goto*//*Label 30541*/ GIMT_Encode4(2270648), // Rule ID 57125 //
     /* 2270605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2270611 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2270614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270618 */   // MIs[0] Operand 1
     /* 2270618 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270627 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270631 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2270631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2270634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270636 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270638 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270646 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270647 */   // GIR_Coverage, 57125,
     /* 2270647 */   GIR_EraseRootFromParent_Done,
     /* 2270648 */ // Label 30541: @2270648
     /* 2270648 */ GIM_Try, /*On fail goto*//*Label 30542*/ GIMT_Encode4(2270696), // Rule ID 57164 //
     /* 2270653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2270659 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2270662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270666 */   // MIs[0] Operand 1
     /* 2270666 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270675 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270679 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2270679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2270682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270684 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270686 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270694 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270695 */   // GIR_Coverage, 57164,
     /* 2270695 */   GIR_EraseRootFromParent_Done,
     /* 2270696 */ // Label 30542: @2270696
     /* 2270696 */ GIM_Try, /*On fail goto*//*Label 30543*/ GIMT_Encode4(2270744), // Rule ID 57165 //
     /* 2270701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2270707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2270710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270714 */   // MIs[0] Operand 1
     /* 2270714 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270723 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270727 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2270730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270732 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270734 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270742 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270743 */   // GIR_Coverage, 57165,
     /* 2270743 */   GIR_EraseRootFromParent_Done,
     /* 2270744 */ // Label 30543: @2270744
     /* 2270744 */ GIM_Try, /*On fail goto*//*Label 30544*/ GIMT_Encode4(2270792), // Rule ID 57364 //
     /* 2270749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270755 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270762 */   // MIs[0] Operand 1
     /* 2270762 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270771 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270775 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2270778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270780 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270782 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270791 */   // GIR_Coverage, 57364,
     /* 2270791 */   GIR_EraseRootFromParent_Done,
     /* 2270792 */ // Label 30544: @2270792
     /* 2270792 */ GIM_Try, /*On fail goto*//*Label 30545*/ GIMT_Encode4(2270840), // Rule ID 57365 //
     /* 2270797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270803 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270810 */   // MIs[0] Operand 1
     /* 2270810 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270819 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270823 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2270826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270828 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270830 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270838 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270839 */   // GIR_Coverage, 57365,
     /* 2270839 */   GIR_EraseRootFromParent_Done,
     /* 2270840 */ // Label 30545: @2270840
     /* 2270840 */ GIM_Try, /*On fail goto*//*Label 30546*/ GIMT_Encode4(2270888), // Rule ID 57424 //
     /* 2270845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2270851 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2270854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270858 */   // MIs[0] Operand 1
     /* 2270858 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270867 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270871 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2270871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2270874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270876 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270878 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270887 */   // GIR_Coverage, 57424,
     /* 2270887 */   GIR_EraseRootFromParent_Done,
     /* 2270888 */ // Label 30546: @2270888
     /* 2270888 */ GIM_Try, /*On fail goto*//*Label 30547*/ GIMT_Encode4(2270936), // Rule ID 57425 //
     /* 2270893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2270899 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2270902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270906 */   // MIs[0] Operand 1
     /* 2270906 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270915 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270919 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2270919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2270922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270924 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270926 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270935 */   // GIR_Coverage, 57425,
     /* 2270935 */   GIR_EraseRootFromParent_Done,
     /* 2270936 */ // Label 30547: @2270936
     /* 2270936 */ GIM_Try, /*On fail goto*//*Label 30548*/ GIMT_Encode4(2270984), // Rule ID 57464 //
     /* 2270941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2270947 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2270950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270954 */   // MIs[0] Operand 1
     /* 2270954 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270959 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270963 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270967 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2270967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2270970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270972 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270974 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270982 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270983 */   // GIR_Coverage, 57464,
     /* 2270983 */   GIR_EraseRootFromParent_Done,
     /* 2270984 */ // Label 30548: @2270984
     /* 2270984 */ GIM_Try, /*On fail goto*//*Label 30549*/ GIMT_Encode4(2271032), // Rule ID 57465 //
     /* 2270989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2270995 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2270998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271002 */   // MIs[0] Operand 1
     /* 2271002 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271011 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271015 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2271018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271020 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271022 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271031 */   // GIR_Coverage, 57465,
     /* 2271031 */   GIR_EraseRootFromParent_Done,
     /* 2271032 */ // Label 30549: @2271032
     /* 2271032 */ GIM_Try, /*On fail goto*//*Label 30550*/ GIMT_Encode4(2271080), // Rule ID 57664 //
     /* 2271037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271043 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271050 */   // MIs[0] Operand 1
     /* 2271050 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271059 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271063 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2271066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271068 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271070 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271078 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271079 */   // GIR_Coverage, 57664,
     /* 2271079 */   GIR_EraseRootFromParent_Done,
     /* 2271080 */ // Label 30550: @2271080
     /* 2271080 */ GIM_Try, /*On fail goto*//*Label 30551*/ GIMT_Encode4(2271128), // Rule ID 57665 //
     /* 2271085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271091 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271098 */   // MIs[0] Operand 1
     /* 2271098 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271107 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271111 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2271114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271116 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271118 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271126 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271127 */   // GIR_Coverage, 57665,
     /* 2271127 */   GIR_EraseRootFromParent_Done,
     /* 2271128 */ // Label 30551: @2271128
     /* 2271128 */ GIM_Try, /*On fail goto*//*Label 30552*/ GIMT_Encode4(2271176), // Rule ID 57724 //
     /* 2271133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271139 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271146 */   // MIs[0] Operand 1
     /* 2271146 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271155 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271159 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2271162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271164 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271166 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271174 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271175 */   // GIR_Coverage, 57724,
     /* 2271175 */   GIR_EraseRootFromParent_Done,
     /* 2271176 */ // Label 30552: @2271176
     /* 2271176 */ GIM_Try, /*On fail goto*//*Label 30553*/ GIMT_Encode4(2271224), // Rule ID 57725 //
     /* 2271181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271187 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271194 */   // MIs[0] Operand 1
     /* 2271194 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271203 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271207 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2271210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271212 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271214 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271223 */   // GIR_Coverage, 57725,
     /* 2271223 */   GIR_EraseRootFromParent_Done,
     /* 2271224 */ // Label 30553: @2271224
     /* 2271224 */ GIM_Try, /*On fail goto*//*Label 30554*/ GIMT_Encode4(2271272), // Rule ID 57764 //
     /* 2271229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271235 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271242 */   // MIs[0] Operand 1
     /* 2271242 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271251 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271255 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2271258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271260 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271262 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271270 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271271 */   // GIR_Coverage, 57764,
     /* 2271271 */   GIR_EraseRootFromParent_Done,
     /* 2271272 */ // Label 30554: @2271272
     /* 2271272 */ GIM_Try, /*On fail goto*//*Label 30555*/ GIMT_Encode4(2271320), // Rule ID 57765 //
     /* 2271277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271283 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271290 */   // MIs[0] Operand 1
     /* 2271290 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271299 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271303 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2271306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271308 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271310 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271319 */   // GIR_Coverage, 57765,
     /* 2271319 */   GIR_EraseRootFromParent_Done,
     /* 2271320 */ // Label 30555: @2271320
     /* 2271320 */ GIM_Try, /*On fail goto*//*Label 30556*/ GIMT_Encode4(2271368), // Rule ID 57964 //
     /* 2271325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271331 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271338 */   // MIs[0] Operand 1
     /* 2271338 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271347 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271351 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2271354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271356 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271358 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271366 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271367 */   // GIR_Coverage, 57964,
     /* 2271367 */   GIR_EraseRootFromParent_Done,
     /* 2271368 */ // Label 30556: @2271368
     /* 2271368 */ GIM_Try, /*On fail goto*//*Label 30557*/ GIMT_Encode4(2271416), // Rule ID 57965 //
     /* 2271373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271379 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271386 */   // MIs[0] Operand 1
     /* 2271386 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271395 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271399 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2271402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271404 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271406 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271415 */   // GIR_Coverage, 57965,
     /* 2271415 */   GIR_EraseRootFromParent_Done,
     /* 2271416 */ // Label 30557: @2271416
     /* 2271416 */ GIM_Try, /*On fail goto*//*Label 30558*/ GIMT_Encode4(2271464), // Rule ID 58024 //
     /* 2271421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271427 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271434 */   // MIs[0] Operand 1
     /* 2271434 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271443 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271447 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2271450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271452 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271454 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271462 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271463 */   // GIR_Coverage, 58024,
     /* 2271463 */   GIR_EraseRootFromParent_Done,
     /* 2271464 */ // Label 30558: @2271464
     /* 2271464 */ GIM_Try, /*On fail goto*//*Label 30559*/ GIMT_Encode4(2271512), // Rule ID 58025 //
     /* 2271469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271475 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271482 */   // MIs[0] Operand 1
     /* 2271482 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271491 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271495 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2271498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271500 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271502 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271510 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271511 */   // GIR_Coverage, 58025,
     /* 2271511 */   GIR_EraseRootFromParent_Done,
     /* 2271512 */ // Label 30559: @2271512
     /* 2271512 */ GIM_Try, /*On fail goto*//*Label 30560*/ GIMT_Encode4(2271560), // Rule ID 58064 //
     /* 2271517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271523 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271530 */   // MIs[0] Operand 1
     /* 2271530 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271539 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271543 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2271546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271548 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271550 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271558 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271559 */   // GIR_Coverage, 58064,
     /* 2271559 */   GIR_EraseRootFromParent_Done,
     /* 2271560 */ // Label 30560: @2271560
     /* 2271560 */ GIM_Try, /*On fail goto*//*Label 30561*/ GIMT_Encode4(2271608), // Rule ID 58065 //
     /* 2271565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271571 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271578 */   // MIs[0] Operand 1
     /* 2271578 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271587 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271591 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2271594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271596 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271598 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271606 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271607 */   // GIR_Coverage, 58065,
     /* 2271607 */   GIR_EraseRootFromParent_Done,
     /* 2271608 */ // Label 30561: @2271608
     /* 2271608 */ GIM_Reject,
     /* 2271609 */ // Label 30447: @2271609
     /* 2271609 */ GIM_Try, /*On fail goto*//*Label 30562*/ GIMT_Encode4(2271657), // Rule ID 57094 //
     /* 2271614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2271620 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2271623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271627 */   // MIs[0] Operand 1
     /* 2271627 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271636 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271640 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2271643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271645 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271647 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271656 */   // GIR_Coverage, 57094,
     /* 2271656 */   GIR_EraseRootFromParent_Done,
     /* 2271657 */ // Label 30562: @2271657
     /* 2271657 */ GIM_Try, /*On fail goto*//*Label 30563*/ GIMT_Encode4(2271705), // Rule ID 57095 //
     /* 2271662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2271668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2271671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271675 */   // MIs[0] Operand 1
     /* 2271675 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271684 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271688 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2271691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271693 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271695 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271703 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271704 */   // GIR_Coverage, 57095,
     /* 2271704 */   GIR_EraseRootFromParent_Done,
     /* 2271705 */ // Label 30563: @2271705
     /* 2271705 */ GIM_Try, /*On fail goto*//*Label 30564*/ GIMT_Encode4(2271753), // Rule ID 57134 //
     /* 2271710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2271716 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2271719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271723 */   // MIs[0] Operand 1
     /* 2271723 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271732 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271736 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2271739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271741 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271743 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271751 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271752 */   // GIR_Coverage, 57134,
     /* 2271752 */   GIR_EraseRootFromParent_Done,
     /* 2271753 */ // Label 30564: @2271753
     /* 2271753 */ GIM_Try, /*On fail goto*//*Label 30565*/ GIMT_Encode4(2271801), // Rule ID 57135 //
     /* 2271758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2271764 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2271767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271771 */   // MIs[0] Operand 1
     /* 2271771 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271776 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271780 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271784 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2271787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271789 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271791 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271799 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271800 */   // GIR_Coverage, 57135,
     /* 2271800 */   GIR_EraseRootFromParent_Done,
     /* 2271801 */ // Label 30565: @2271801
     /* 2271801 */ GIM_Try, /*On fail goto*//*Label 30566*/ GIMT_Encode4(2271849), // Rule ID 57174 //
     /* 2271806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2271812 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2271815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271819 */   // MIs[0] Operand 1
     /* 2271819 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271828 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271832 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2271835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271837 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271839 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271847 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271848 */   // GIR_Coverage, 57174,
     /* 2271848 */   GIR_EraseRootFromParent_Done,
     /* 2271849 */ // Label 30566: @2271849
     /* 2271849 */ GIM_Try, /*On fail goto*//*Label 30567*/ GIMT_Encode4(2271897), // Rule ID 57175 //
     /* 2271854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2271860 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2271863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271867 */   // MIs[0] Operand 1
     /* 2271867 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271876 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271880 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2271883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271885 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271887 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271896 */   // GIR_Coverage, 57175,
     /* 2271896 */   GIR_EraseRootFromParent_Done,
     /* 2271897 */ // Label 30567: @2271897
     /* 2271897 */ GIM_Try, /*On fail goto*//*Label 30568*/ GIMT_Encode4(2271945), // Rule ID 57394 //
     /* 2271902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2271908 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2271911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271915 */   // MIs[0] Operand 1
     /* 2271915 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271924 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271928 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2271931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271933 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271935 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271943 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271944 */   // GIR_Coverage, 57394,
     /* 2271944 */   GIR_EraseRootFromParent_Done,
     /* 2271945 */ // Label 30568: @2271945
     /* 2271945 */ GIM_Try, /*On fail goto*//*Label 30569*/ GIMT_Encode4(2271993), // Rule ID 57395 //
     /* 2271950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2271956 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2271959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271963 */   // MIs[0] Operand 1
     /* 2271963 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271972 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271976 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2271979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271981 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271983 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271991 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271992 */   // GIR_Coverage, 57395,
     /* 2271992 */   GIR_EraseRootFromParent_Done,
     /* 2271993 */ // Label 30569: @2271993
     /* 2271993 */ GIM_Try, /*On fail goto*//*Label 30570*/ GIMT_Encode4(2272041), // Rule ID 57434 //
     /* 2271998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272004 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272011 */   // MIs[0] Operand 1
     /* 2272011 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272020 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272024 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2272027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272029 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272031 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272039 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272040 */   // GIR_Coverage, 57434,
     /* 2272040 */   GIR_EraseRootFromParent_Done,
     /* 2272041 */ // Label 30570: @2272041
     /* 2272041 */ GIM_Try, /*On fail goto*//*Label 30571*/ GIMT_Encode4(2272089), // Rule ID 57435 //
     /* 2272046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272052 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272059 */   // MIs[0] Operand 1
     /* 2272059 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272068 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272072 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2272075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272077 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272079 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272087 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272088 */   // GIR_Coverage, 57435,
     /* 2272088 */   GIR_EraseRootFromParent_Done,
     /* 2272089 */ // Label 30571: @2272089
     /* 2272089 */ GIM_Try, /*On fail goto*//*Label 30572*/ GIMT_Encode4(2272137), // Rule ID 57474 //
     /* 2272094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272100 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272107 */   // MIs[0] Operand 1
     /* 2272107 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272112 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272116 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272120 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2272123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272125 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272127 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272135 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272136 */   // GIR_Coverage, 57474,
     /* 2272136 */   GIR_EraseRootFromParent_Done,
     /* 2272137 */ // Label 30572: @2272137
     /* 2272137 */ GIM_Try, /*On fail goto*//*Label 30573*/ GIMT_Encode4(2272185), // Rule ID 57475 //
     /* 2272142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272148 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272155 */   // MIs[0] Operand 1
     /* 2272155 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272164 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272168 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2272171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272173 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272175 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272183 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272184 */   // GIR_Coverage, 57475,
     /* 2272184 */   GIR_EraseRootFromParent_Done,
     /* 2272185 */ // Label 30573: @2272185
     /* 2272185 */ GIM_Try, /*On fail goto*//*Label 30574*/ GIMT_Encode4(2272233), // Rule ID 57694 //
     /* 2272190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272196 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272203 */   // MIs[0] Operand 1
     /* 2272203 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272212 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272216 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2272219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272221 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272223 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272231 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272232 */   // GIR_Coverage, 57694,
     /* 2272232 */   GIR_EraseRootFromParent_Done,
     /* 2272233 */ // Label 30574: @2272233
     /* 2272233 */ GIM_Try, /*On fail goto*//*Label 30575*/ GIMT_Encode4(2272281), // Rule ID 57695 //
     /* 2272238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272244 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272251 */   // MIs[0] Operand 1
     /* 2272251 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272260 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272264 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2272267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272269 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272271 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272279 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272280 */   // GIR_Coverage, 57695,
     /* 2272280 */   GIR_EraseRootFromParent_Done,
     /* 2272281 */ // Label 30575: @2272281
     /* 2272281 */ GIM_Try, /*On fail goto*//*Label 30576*/ GIMT_Encode4(2272329), // Rule ID 57734 //
     /* 2272286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272292 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272299 */   // MIs[0] Operand 1
     /* 2272299 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272308 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272312 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2272315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272317 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272319 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272327 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272328 */   // GIR_Coverage, 57734,
     /* 2272328 */   GIR_EraseRootFromParent_Done,
     /* 2272329 */ // Label 30576: @2272329
     /* 2272329 */ GIM_Try, /*On fail goto*//*Label 30577*/ GIMT_Encode4(2272377), // Rule ID 57735 //
     /* 2272334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272340 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272347 */   // MIs[0] Operand 1
     /* 2272347 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272356 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272360 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2272363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272365 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272367 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272375 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272376 */   // GIR_Coverage, 57735,
     /* 2272376 */   GIR_EraseRootFromParent_Done,
     /* 2272377 */ // Label 30577: @2272377
     /* 2272377 */ GIM_Try, /*On fail goto*//*Label 30578*/ GIMT_Encode4(2272425), // Rule ID 57774 //
     /* 2272382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272388 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272395 */   // MIs[0] Operand 1
     /* 2272395 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272404 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272408 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2272411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272413 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272415 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272423 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272424 */   // GIR_Coverage, 57774,
     /* 2272424 */   GIR_EraseRootFromParent_Done,
     /* 2272425 */ // Label 30578: @2272425
     /* 2272425 */ GIM_Try, /*On fail goto*//*Label 30579*/ GIMT_Encode4(2272473), // Rule ID 57775 //
     /* 2272430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272436 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272443 */   // MIs[0] Operand 1
     /* 2272443 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272452 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272456 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2272459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272461 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272463 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272471 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272472 */   // GIR_Coverage, 57775,
     /* 2272472 */   GIR_EraseRootFromParent_Done,
     /* 2272473 */ // Label 30579: @2272473
     /* 2272473 */ GIM_Try, /*On fail goto*//*Label 30580*/ GIMT_Encode4(2272521), // Rule ID 57994 //
     /* 2272478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272484 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272491 */   // MIs[0] Operand 1
     /* 2272491 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272500 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272504 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2272507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272509 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272511 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272519 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272520 */   // GIR_Coverage, 57994,
     /* 2272520 */   GIR_EraseRootFromParent_Done,
     /* 2272521 */ // Label 30580: @2272521
     /* 2272521 */ GIM_Try, /*On fail goto*//*Label 30581*/ GIMT_Encode4(2272569), // Rule ID 57995 //
     /* 2272526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272532 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272539 */   // MIs[0] Operand 1
     /* 2272539 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272548 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272552 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2272555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272557 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272559 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272567 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272568 */   // GIR_Coverage, 57995,
     /* 2272568 */   GIR_EraseRootFromParent_Done,
     /* 2272569 */ // Label 30581: @2272569
     /* 2272569 */ GIM_Try, /*On fail goto*//*Label 30582*/ GIMT_Encode4(2272617), // Rule ID 58034 //
     /* 2272574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272580 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272587 */   // MIs[0] Operand 1
     /* 2272587 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272596 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272600 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2272603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272605 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272607 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272615 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272616 */   // GIR_Coverage, 58034,
     /* 2272616 */   GIR_EraseRootFromParent_Done,
     /* 2272617 */ // Label 30582: @2272617
     /* 2272617 */ GIM_Try, /*On fail goto*//*Label 30583*/ GIMT_Encode4(2272665), // Rule ID 58035 //
     /* 2272622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272628 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272635 */   // MIs[0] Operand 1
     /* 2272635 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272644 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272648 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2272651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272653 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272655 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272663 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272664 */   // GIR_Coverage, 58035,
     /* 2272664 */   GIR_EraseRootFromParent_Done,
     /* 2272665 */ // Label 30583: @2272665
     /* 2272665 */ GIM_Try, /*On fail goto*//*Label 30584*/ GIMT_Encode4(2272713), // Rule ID 58074 //
     /* 2272670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272676 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272683 */   // MIs[0] Operand 1
     /* 2272683 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272692 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272696 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2272699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272701 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272703 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272711 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272712 */   // GIR_Coverage, 58074,
     /* 2272712 */   GIR_EraseRootFromParent_Done,
     /* 2272713 */ // Label 30584: @2272713
     /* 2272713 */ GIM_Try, /*On fail goto*//*Label 30585*/ GIMT_Encode4(2272761), // Rule ID 58075 //
     /* 2272718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272724 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272731 */   // MIs[0] Operand 1
     /* 2272731 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272740 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272744 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2272747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272749 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272751 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272759 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272760 */   // GIR_Coverage, 58075,
     /* 2272760 */   GIR_EraseRootFromParent_Done,
     /* 2272761 */ // Label 30585: @2272761
     /* 2272761 */ GIM_Reject,
     /* 2272762 */ // Label 30448: @2272762
     /* 2272762 */ GIM_Try, /*On fail goto*//*Label 30586*/ GIMT_Encode4(2272810), // Rule ID 57104 //
     /* 2272767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2272773 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2272776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272780 */   // MIs[0] Operand 1
     /* 2272780 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272789 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272793 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2272796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272798 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272800 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272808 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272809 */   // GIR_Coverage, 57104,
     /* 2272809 */   GIR_EraseRootFromParent_Done,
     /* 2272810 */ // Label 30586: @2272810
     /* 2272810 */ GIM_Try, /*On fail goto*//*Label 30587*/ GIMT_Encode4(2272858), // Rule ID 57105 //
     /* 2272815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2272821 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2272824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272828 */   // MIs[0] Operand 1
     /* 2272828 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272837 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272841 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2272844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272846 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272848 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272856 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272857 */   // GIR_Coverage, 57105,
     /* 2272857 */   GIR_EraseRootFromParent_Done,
     /* 2272858 */ // Label 30587: @2272858
     /* 2272858 */ GIM_Try, /*On fail goto*//*Label 30588*/ GIMT_Encode4(2272906), // Rule ID 57144 //
     /* 2272863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2272869 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2272872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272876 */   // MIs[0] Operand 1
     /* 2272876 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272885 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272889 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2272892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272894 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272896 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272904 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272905 */   // GIR_Coverage, 57144,
     /* 2272905 */   GIR_EraseRootFromParent_Done,
     /* 2272906 */ // Label 30588: @2272906
     /* 2272906 */ GIM_Try, /*On fail goto*//*Label 30589*/ GIMT_Encode4(2272954), // Rule ID 57145 //
     /* 2272911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2272917 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2272920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272924 */   // MIs[0] Operand 1
     /* 2272924 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272933 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272937 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2272940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272942 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272944 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272952 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272953 */   // GIR_Coverage, 57145,
     /* 2272953 */   GIR_EraseRootFromParent_Done,
     /* 2272954 */ // Label 30589: @2272954
     /* 2272954 */ GIM_Try, /*On fail goto*//*Label 30590*/ GIMT_Encode4(2273002), // Rule ID 57404 //
     /* 2272959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2272965 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2272968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272972 */   // MIs[0] Operand 1
     /* 2272972 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272981 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272985 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2272988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272990 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272992 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273000 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273001 */   // GIR_Coverage, 57404,
     /* 2273001 */   GIR_EraseRootFromParent_Done,
     /* 2273002 */ // Label 30590: @2273002
     /* 2273002 */ GIM_Try, /*On fail goto*//*Label 30591*/ GIMT_Encode4(2273050), // Rule ID 57405 //
     /* 2273007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273013 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273020 */   // MIs[0] Operand 1
     /* 2273020 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273025 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273029 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273033 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2273036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273038 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273040 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273048 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273049 */   // GIR_Coverage, 57405,
     /* 2273049 */   GIR_EraseRootFromParent_Done,
     /* 2273050 */ // Label 30591: @2273050
     /* 2273050 */ GIM_Try, /*On fail goto*//*Label 30592*/ GIMT_Encode4(2273098), // Rule ID 57444 //
     /* 2273055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273061 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273068 */   // MIs[0] Operand 1
     /* 2273068 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273073 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273077 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273081 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2273084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273086 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273088 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273096 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273097 */   // GIR_Coverage, 57444,
     /* 2273097 */   GIR_EraseRootFromParent_Done,
     /* 2273098 */ // Label 30592: @2273098
     /* 2273098 */ GIM_Try, /*On fail goto*//*Label 30593*/ GIMT_Encode4(2273146), // Rule ID 57445 //
     /* 2273103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273109 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273116 */   // MIs[0] Operand 1
     /* 2273116 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273125 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273129 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2273132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273134 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273136 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273145 */   // GIR_Coverage, 57445,
     /* 2273145 */   GIR_EraseRootFromParent_Done,
     /* 2273146 */ // Label 30593: @2273146
     /* 2273146 */ GIM_Try, /*On fail goto*//*Label 30594*/ GIMT_Encode4(2273194), // Rule ID 57704 //
     /* 2273151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273157 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273164 */   // MIs[0] Operand 1
     /* 2273164 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273169 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273173 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273177 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2273180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273182 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273184 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273192 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273193 */   // GIR_Coverage, 57704,
     /* 2273193 */   GIR_EraseRootFromParent_Done,
     /* 2273194 */ // Label 30594: @2273194
     /* 2273194 */ GIM_Try, /*On fail goto*//*Label 30595*/ GIMT_Encode4(2273242), // Rule ID 57705 //
     /* 2273199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273205 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273212 */   // MIs[0] Operand 1
     /* 2273212 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273221 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273225 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2273228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273230 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273232 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273240 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273241 */   // GIR_Coverage, 57705,
     /* 2273241 */   GIR_EraseRootFromParent_Done,
     /* 2273242 */ // Label 30595: @2273242
     /* 2273242 */ GIM_Try, /*On fail goto*//*Label 30596*/ GIMT_Encode4(2273290), // Rule ID 57744 //
     /* 2273247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273253 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273260 */   // MIs[0] Operand 1
     /* 2273260 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273269 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273273 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2273276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273278 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273280 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273288 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273289 */   // GIR_Coverage, 57744,
     /* 2273289 */   GIR_EraseRootFromParent_Done,
     /* 2273290 */ // Label 30596: @2273290
     /* 2273290 */ GIM_Try, /*On fail goto*//*Label 30597*/ GIMT_Encode4(2273338), // Rule ID 57745 //
     /* 2273295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273301 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273308 */   // MIs[0] Operand 1
     /* 2273308 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273317 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273321 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2273324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273326 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273328 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273336 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273337 */   // GIR_Coverage, 57745,
     /* 2273337 */   GIR_EraseRootFromParent_Done,
     /* 2273338 */ // Label 30597: @2273338
     /* 2273338 */ GIM_Try, /*On fail goto*//*Label 30598*/ GIMT_Encode4(2273386), // Rule ID 58004 //
     /* 2273343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273349 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273356 */   // MIs[0] Operand 1
     /* 2273356 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273365 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273369 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2273372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273374 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273376 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273384 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273385 */   // GIR_Coverage, 58004,
     /* 2273385 */   GIR_EraseRootFromParent_Done,
     /* 2273386 */ // Label 30598: @2273386
     /* 2273386 */ GIM_Try, /*On fail goto*//*Label 30599*/ GIMT_Encode4(2273434), // Rule ID 58005 //
     /* 2273391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273397 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273404 */   // MIs[0] Operand 1
     /* 2273404 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273413 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273417 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2273420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273422 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273424 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273432 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273433 */   // GIR_Coverage, 58005,
     /* 2273433 */   GIR_EraseRootFromParent_Done,
     /* 2273434 */ // Label 30599: @2273434
     /* 2273434 */ GIM_Try, /*On fail goto*//*Label 30600*/ GIMT_Encode4(2273482), // Rule ID 58044 //
     /* 2273439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273445 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273452 */   // MIs[0] Operand 1
     /* 2273452 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273461 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273465 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273470 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273472 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273480 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273481 */   // GIR_Coverage, 58044,
     /* 2273481 */   GIR_EraseRootFromParent_Done,
     /* 2273482 */ // Label 30600: @2273482
     /* 2273482 */ GIM_Try, /*On fail goto*//*Label 30601*/ GIMT_Encode4(2273530), // Rule ID 58045 //
     /* 2273487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273493 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273500 */   // MIs[0] Operand 1
     /* 2273500 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273509 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273513 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273518 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273520 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273528 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273529 */   // GIR_Coverage, 58045,
     /* 2273529 */   GIR_EraseRootFromParent_Done,
     /* 2273530 */ // Label 30601: @2273530
     /* 2273530 */ GIM_Reject,
     /* 2273531 */ // Label 30449: @2273531
     /* 2273531 */ GIM_Try, /*On fail goto*//*Label 30602*/ GIMT_Encode4(2273851),
     /* 2273536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2273539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2273542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273546 */   GIM_Try, /*On fail goto*//*Label 30603*/ GIMT_Encode4(2273584), // Rule ID 57114 //
     /* 2273551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273554 */     // MIs[0] Operand 1
     /* 2273554 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273567 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2273570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273583 */     // GIR_Coverage, 57114,
     /* 2273583 */     GIR_EraseRootFromParent_Done,
     /* 2273584 */   // Label 30603: @2273584
     /* 2273584 */   GIM_Try, /*On fail goto*//*Label 30604*/ GIMT_Encode4(2273622), // Rule ID 57115 //
     /* 2273589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273592 */     // MIs[0] Operand 1
     /* 2273592 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273605 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2273608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273621 */     // GIR_Coverage, 57115,
     /* 2273621 */     GIR_EraseRootFromParent_Done,
     /* 2273622 */   // Label 30604: @2273622
     /* 2273622 */   GIM_Try, /*On fail goto*//*Label 30605*/ GIMT_Encode4(2273660), // Rule ID 57414 //
     /* 2273627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273630 */     // MIs[0] Operand 1
     /* 2273630 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273643 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2273646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273659 */     // GIR_Coverage, 57414,
     /* 2273659 */     GIR_EraseRootFromParent_Done,
     /* 2273660 */   // Label 30605: @2273660
     /* 2273660 */   GIM_Try, /*On fail goto*//*Label 30606*/ GIMT_Encode4(2273698), // Rule ID 57415 //
     /* 2273665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273668 */     // MIs[0] Operand 1
     /* 2273668 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273681 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2273684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273697 */     // GIR_Coverage, 57415,
     /* 2273697 */     GIR_EraseRootFromParent_Done,
     /* 2273698 */   // Label 30606: @2273698
     /* 2273698 */   GIM_Try, /*On fail goto*//*Label 30607*/ GIMT_Encode4(2273736), // Rule ID 57714 //
     /* 2273703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273706 */     // MIs[0] Operand 1
     /* 2273706 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273719 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2273722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273735 */     // GIR_Coverage, 57714,
     /* 2273735 */     GIR_EraseRootFromParent_Done,
     /* 2273736 */   // Label 30607: @2273736
     /* 2273736 */   GIM_Try, /*On fail goto*//*Label 30608*/ GIMT_Encode4(2273774), // Rule ID 57715 //
     /* 2273741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273744 */     // MIs[0] Operand 1
     /* 2273744 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273757 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2273760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273773 */     // GIR_Coverage, 57715,
     /* 2273773 */     GIR_EraseRootFromParent_Done,
     /* 2273774 */   // Label 30608: @2273774
     /* 2273774 */   GIM_Try, /*On fail goto*//*Label 30609*/ GIMT_Encode4(2273812), // Rule ID 58014 //
     /* 2273779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273782 */     // MIs[0] Operand 1
     /* 2273782 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273795 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273811 */     // GIR_Coverage, 58014,
     /* 2273811 */     GIR_EraseRootFromParent_Done,
     /* 2273812 */   // Label 30609: @2273812
     /* 2273812 */   GIM_Try, /*On fail goto*//*Label 30610*/ GIMT_Encode4(2273850), // Rule ID 58015 //
     /* 2273817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273820 */     // MIs[0] Operand 1
     /* 2273820 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273833 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273849 */     // GIR_Coverage, 58015,
     /* 2273849 */     GIR_EraseRootFromParent_Done,
     /* 2273850 */   // Label 30610: @2273850
     /* 2273850 */   GIM_Reject,
     /* 2273851 */ // Label 30602: @2273851
     /* 2273851 */ GIM_Reject,
     /* 2273852 */ // Label 30450: @2273852
     /* 2273852 */ GIM_Reject,
     /* 2273853 */ // Label 50: @2273853
     /* 2273853 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30635*/ GIMT_Encode4(2279572),
     /* 2273864 */ /*GILLT_s32*//*Label 30611*/ GIMT_Encode4(2273988),
     /* 2273868 */ /*GILLT_s64*//*Label 30612*/ GIMT_Encode4(2274800), GIMT_Encode4(0),
     /* 2273876 */ /*GILLT_nxv1s8*//*Label 30613*/ GIMT_Encode4(2275612),
     /* 2273880 */ /*GILLT_nxv1s16*//*Label 30614*/ GIMT_Encode4(2275732),
     /* 2273884 */ /*GILLT_nxv1s32*//*Label 30615*/ GIMT_Encode4(2275940),
     /* 2273888 */ /*GILLT_nxv1s64*//*Label 30616*/ GIMT_Encode4(2276148), GIMT_Encode4(0),
     /* 2273896 */ /*GILLT_nxv2s8*//*Label 30617*/ GIMT_Encode4(2276356),
     /* 2273900 */ /*GILLT_nxv2s16*//*Label 30618*/ GIMT_Encode4(2276476),
     /* 2273904 */ /*GILLT_nxv2s32*//*Label 30619*/ GIMT_Encode4(2276684),
     /* 2273908 */ /*GILLT_nxv2s64*//*Label 30620*/ GIMT_Encode4(2276892), GIMT_Encode4(0),
     /* 2273916 */ /*GILLT_nxv4s8*//*Label 30621*/ GIMT_Encode4(2277100),
     /* 2273920 */ /*GILLT_nxv4s16*//*Label 30622*/ GIMT_Encode4(2277220),
     /* 2273924 */ /*GILLT_nxv4s32*//*Label 30623*/ GIMT_Encode4(2277428),
     /* 2273928 */ /*GILLT_nxv4s64*//*Label 30624*/ GIMT_Encode4(2277636), GIMT_Encode4(0),
     /* 2273936 */ /*GILLT_nxv8s8*//*Label 30625*/ GIMT_Encode4(2277844),
     /* 2273940 */ /*GILLT_nxv8s16*//*Label 30626*/ GIMT_Encode4(2277964),
     /* 2273944 */ /*GILLT_nxv8s32*//*Label 30627*/ GIMT_Encode4(2278172),
     /* 2273948 */ /*GILLT_nxv8s64*//*Label 30628*/ GIMT_Encode4(2278380), GIMT_Encode4(0),
     /* 2273956 */ /*GILLT_nxv16s8*//*Label 30629*/ GIMT_Encode4(2278588),
     /* 2273960 */ /*GILLT_nxv16s16*//*Label 30630*/ GIMT_Encode4(2278708),
     /* 2273964 */ /*GILLT_nxv16s32*//*Label 30631*/ GIMT_Encode4(2278916), GIMT_Encode4(0),
     /* 2273972 */ /*GILLT_nxv32s8*//*Label 30632*/ GIMT_Encode4(2279124),
     /* 2273976 */ /*GILLT_nxv32s16*//*Label 30633*/ GIMT_Encode4(2279244), GIMT_Encode4(0),
     /* 2273984 */ /*GILLT_nxv64s8*//*Label 30634*/ GIMT_Encode4(2279452),
     /* 2273988 */ // Label 30611: @2273988
     /* 2273988 */ GIM_Try, /*On fail goto*//*Label 30636*/ GIMT_Encode4(2274799),
     /* 2273993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2273996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2273999 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274002 */   GIM_Try, /*On fail goto*//*Label 30637*/ GIMT_Encode4(2274080), // Rule ID 64662 //
     /* 2274007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2274010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274026 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274030 */     // MIs[1] Operand 1
     /* 2274030 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2274035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274048 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274052 */     // MIs[2] Operand 1
     /* 2274052 */     // No operand predicates
     /* 2274052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2274062 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQI),
     /* 2274065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274079 */     // GIR_Coverage, 64662,
     /* 2274079 */     GIR_EraseRootFromParent_Done,
     /* 2274080 */   // Label 30637: @2274080
     /* 2274080 */   GIM_Try, /*On fail goto*//*Label 30638*/ GIMT_Encode4(2274158), // Rule ID 64664 //
     /* 2274085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2274088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274104 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274108 */     // MIs[1] Operand 1
     /* 2274108 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2274113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274126 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274130 */     // MIs[2] Operand 1
     /* 2274130 */     // No operand predicates
     /* 2274130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2274140 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVNEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNEI),
     /* 2274143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274157 */     // GIR_Coverage, 64664,
     /* 2274157 */     GIR_EraseRootFromParent_Done,
     /* 2274158 */   // Label 30638: @2274158
     /* 2274158 */   GIM_Try, /*On fail goto*//*Label 30639*/ GIMT_Encode4(2274236), // Rule ID 64666 //
     /* 2274163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2274166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274182 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274186 */     // MIs[1] Operand 1
     /* 2274186 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2274191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274204 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274208 */     // MIs[2] Operand 1
     /* 2274208 */     // No operand predicates
     /* 2274208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2274218 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTI),
     /* 2274221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274235 */     // GIR_Coverage, 64666,
     /* 2274235 */     GIR_EraseRootFromParent_Done,
     /* 2274236 */   // Label 30639: @2274236
     /* 2274236 */   GIM_Try, /*On fail goto*//*Label 30640*/ GIMT_Encode4(2274314), // Rule ID 64668 //
     /* 2274241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2274244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274260 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274264 */     // MIs[1] Operand 1
     /* 2274264 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2274269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274282 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2274286 */     // MIs[2] Operand 1
     /* 2274286 */     // No operand predicates
     /* 2274286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2274296 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTUI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTUI),
     /* 2274299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274313 */     // GIR_Coverage, 64668,
     /* 2274313 */     GIR_EraseRootFromParent_Done,
     /* 2274314 */   // Label 30640: @2274314
     /* 2274314 */   GIM_Try, /*On fail goto*//*Label 30641*/ GIMT_Encode4(2274355), // Rule ID 62585 //
     /* 2274319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2274322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2274334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274338 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, 0:{ *:[i32] }, GPR:{ *:[i32] }:$b)  =>  (TH_MVNEZ:{ *:[i32] } GPR:{ *:[i32] }:$b, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2274338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2274341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274343 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2274345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2274351 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2274353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274354 */     // GIR_Coverage, 62585,
     /* 2274354 */     GIR_EraseRootFromParent_Done,
     /* 2274355 */   // Label 30641: @2274355
     /* 2274355 */   GIM_Try, /*On fail goto*//*Label 30642*/ GIMT_Encode4(2274396), // Rule ID 62583 //
     /* 2274360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2274363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2274379 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2274379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2274382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274384 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2274386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2274392 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2274394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274395 */     // GIR_Coverage, 62583,
     /* 2274395 */     GIR_EraseRootFromParent_Done,
     /* 2274396 */   // Label 30642: @2274396
     /* 2274396 */   GIM_Try, /*On fail goto*//*Label 30643*/ GIMT_Encode4(2274468), // Rule ID 64654 //
     /* 2274401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2274404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274420 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274424 */     // MIs[1] Operand 1
     /* 2274424 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2274429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2274449 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQ),
     /* 2274452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2274464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274467 */     // GIR_Coverage, 64654,
     /* 2274467 */     GIR_EraseRootFromParent_Done,
     /* 2274468 */   // Label 30643: @2274468
     /* 2274468 */   GIM_Try, /*On fail goto*//*Label 30644*/ GIMT_Encode4(2274540), // Rule ID 64656 //
     /* 2274473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2274476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274492 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274496 */     // MIs[1] Operand 1
     /* 2274496 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2274501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2274521 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVNE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNE),
     /* 2274524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2274536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274539 */     // GIR_Coverage, 64656,
     /* 2274539 */     GIR_EraseRootFromParent_Done,
     /* 2274540 */   // Label 30644: @2274540
     /* 2274540 */   GIM_Try, /*On fail goto*//*Label 30645*/ GIMT_Encode4(2274612), // Rule ID 64658 //
     /* 2274545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2274548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274564 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274568 */     // MIs[1] Operand 1
     /* 2274568 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2274573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2274593 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLT),
     /* 2274596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2274608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274611 */     // GIR_Coverage, 64658,
     /* 2274611 */     GIR_EraseRootFromParent_Done,
     /* 2274612 */   // Label 30645: @2274612
     /* 2274612 */   GIM_Try, /*On fail goto*//*Label 30646*/ GIMT_Encode4(2274684), // Rule ID 64660 //
     /* 2274617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2274620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274636 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274640 */     // MIs[1] Operand 1
     /* 2274640 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2274645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2274665 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTU),
     /* 2274668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2274680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274683 */     // GIR_Coverage, 64660,
     /* 2274683 */     GIR_EraseRootFromParent_Done,
     /* 2274684 */   // Label 30646: @2274684
     /* 2274684 */   GIM_Try, /*On fail goto*//*Label 30647*/ GIMT_Encode4(2274721), // Rule ID 62581 //
     /* 2274689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2274692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274708 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$cond)
     /* 2274708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2274711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274713 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2274715 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2274717 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2274719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274720 */     // GIR_Coverage, 62581,
     /* 2274720 */     GIR_EraseRootFromParent_Done,
     /* 2274721 */   // Label 30647: @2274721
     /* 2274721 */   GIM_Try, /*On fail goto*//*Label 30648*/ GIMT_Encode4(2274761), // Rule ID 64652 //
     /* 2274726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2274729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274745 */     // (select:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs3)  =>  (QC_MVEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, 0:{ *:[i32] }, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQI),
     /* 2274748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2274752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2274757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2274759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274760 */     // GIR_Coverage, 64652,
     /* 2274760 */     GIR_EraseRootFromParent_Done,
     /* 2274761 */   // Label 30648: @2274761
     /* 2274761 */   GIM_Try, /*On fail goto*//*Label 30649*/ GIMT_Encode4(2274798), // Rule ID 64678 //
     /* 2274766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
     /* 2274769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274785 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /* 2274785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2274788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2274794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2274796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274797 */     // GIR_Coverage, 64678,
     /* 2274797 */     GIR_EraseRootFromParent_Done,
     /* 2274798 */   // Label 30649: @2274798
     /* 2274798 */   GIM_Reject,
     /* 2274799 */ // Label 30636: @2274799
     /* 2274799 */ GIM_Reject,
     /* 2274800 */ // Label 30612: @2274800
     /* 2274800 */ GIM_Try, /*On fail goto*//*Label 30650*/ GIMT_Encode4(2275611),
     /* 2274805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2274808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2274811 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2274814 */   GIM_Try, /*On fail goto*//*Label 30651*/ GIMT_Encode4(2274892), // Rule ID 64661 //
     /* 2274819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2274822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2274838 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2274842 */     // MIs[1] Operand 1
     /* 2274842 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2274847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274860 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274864 */     // MIs[2] Operand 1
     /* 2274864 */     // No operand predicates
     /* 2274864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2274874 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVEQI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2274874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQI),
     /* 2274877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274891 */     // GIR_Coverage, 64661,
     /* 2274891 */     GIR_EraseRootFromParent_Done,
     /* 2274892 */   // Label 30651: @2274892
     /* 2274892 */   GIM_Try, /*On fail goto*//*Label 30652*/ GIMT_Encode4(2274970), // Rule ID 64663 //
     /* 2274897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2274900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2274916 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2274920 */     // MIs[1] Operand 1
     /* 2274920 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2274925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274938 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274942 */     // MIs[2] Operand 1
     /* 2274942 */     // No operand predicates
     /* 2274942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2274952 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVNEI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2274952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNEI),
     /* 2274955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274969 */     // GIR_Coverage, 64663,
     /* 2274969 */     GIR_EraseRootFromParent_Done,
     /* 2274970 */   // Label 30652: @2274970
     /* 2274970 */   GIM_Try, /*On fail goto*//*Label 30653*/ GIMT_Encode4(2275048), // Rule ID 64665 //
     /* 2274975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2274978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2274994 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2274998 */     // MIs[1] Operand 1
     /* 2274998 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2275003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275016 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275020 */     // MIs[2] Operand 1
     /* 2275020 */     // No operand predicates
     /* 2275020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2275030 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVLTI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2275030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTI),
     /* 2275033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2275037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2275046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275047 */     // GIR_Coverage, 64665,
     /* 2275047 */     GIR_EraseRootFromParent_Done,
     /* 2275048 */   // Label 30653: @2275048
     /* 2275048 */   GIM_Try, /*On fail goto*//*Label 30654*/ GIMT_Encode4(2275126), // Rule ID 64667 //
     /* 2275053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2275056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2275072 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2275076 */     // MIs[1] Operand 1
     /* 2275076 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2275081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275094 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2275098 */     // MIs[2] Operand 1
     /* 2275098 */     // No operand predicates
     /* 2275098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2275108 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVLTUI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2275108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTUI),
     /* 2275111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2275115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2275124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275125 */     // GIR_Coverage, 64667,
     /* 2275125 */     GIR_EraseRootFromParent_Done,
     /* 2275126 */   // Label 30654: @2275126
     /* 2275126 */   GIM_Try, /*On fail goto*//*Label 30655*/ GIMT_Encode4(2275167), // Rule ID 62584 //
     /* 2275131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2275134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2275146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275150 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, 0:{ *:[i64] }, GPR:{ *:[i64] }:$b)  =>  (TH_MVNEZ:{ *:[i64] } GPR:{ *:[i64] }:$b, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2275150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2275153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275155 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2275157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2275163 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2275165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275166 */     // GIR_Coverage, 62584,
     /* 2275166 */     GIR_EraseRootFromParent_Done,
     /* 2275167 */   // Label 30655: @2275167
     /* 2275167 */   GIM_Try, /*On fail goto*//*Label 30656*/ GIMT_Encode4(2275208), // Rule ID 62582 //
     /* 2275172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2275175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2275191 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, 0:{ *:[i64] })  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2275191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2275194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275196 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2275198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2275204 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2275206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275207 */     // GIR_Coverage, 62582,
     /* 2275207 */     GIR_EraseRootFromParent_Done,
     /* 2275208 */   // Label 30656: @2275208
     /* 2275208 */   GIM_Try, /*On fail goto*//*Label 30657*/ GIMT_Encode4(2275280), // Rule ID 64653 //
     /* 2275213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2275216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2275232 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2275236 */     // MIs[1] Operand 1
     /* 2275236 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2275241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2275261 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVEQ:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2275261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQ),
     /* 2275264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2275268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2275276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2275278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275279 */     // GIR_Coverage, 64653,
     /* 2275279 */     GIR_EraseRootFromParent_Done,
     /* 2275280 */   // Label 30657: @2275280
     /* 2275280 */   GIM_Try, /*On fail goto*//*Label 30658*/ GIMT_Encode4(2275352), // Rule ID 64655 //
     /* 2275285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2275288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2275304 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2275308 */     // MIs[1] Operand 1
     /* 2275308 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2275313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2275333 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVNE:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2275333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNE),
     /* 2275336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2275340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2275348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2275350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275351 */     // GIR_Coverage, 64655,
     /* 2275351 */     GIR_EraseRootFromParent_Done,
     /* 2275352 */   // Label 30658: @2275352
     /* 2275352 */   GIM_Try, /*On fail goto*//*Label 30659*/ GIMT_Encode4(2275424), // Rule ID 64657 //
     /* 2275357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2275360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2275376 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2275380 */     // MIs[1] Operand 1
     /* 2275380 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2275385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2275405 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVLT:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2275405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLT),
     /* 2275408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2275412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2275420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2275422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275423 */     // GIR_Coverage, 64657,
     /* 2275423 */     GIR_EraseRootFromParent_Done,
     /* 2275424 */   // Label 30659: @2275424
     /* 2275424 */   GIM_Try, /*On fail goto*//*Label 30660*/ GIMT_Encode4(2275496), // Rule ID 64659 //
     /* 2275429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2275432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2275448 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2275452 */     // MIs[1] Operand 1
     /* 2275452 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2275457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2275477 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVLTU:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2275477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTU),
     /* 2275480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2275484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2275492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2275494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275495 */     // GIR_Coverage, 64659,
     /* 2275495 */     GIR_EraseRootFromParent_Done,
     /* 2275496 */   // Label 30660: @2275496
     /* 2275496 */   GIM_Try, /*On fail goto*//*Label 30661*/ GIMT_Encode4(2275533), // Rule ID 62580 //
     /* 2275501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2275504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275520 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b)  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b, GPR:{ *:[i64] }:$cond)
     /* 2275520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2275523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275525 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2275527 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2275529 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2275531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275532 */     // GIR_Coverage, 62580,
     /* 2275532 */     GIR_EraseRootFromParent_Done,
     /* 2275533 */   // Label 30661: @2275533
     /* 2275533 */   GIM_Try, /*On fail goto*//*Label 30662*/ GIMT_Encode4(2275573), // Rule ID 64651 //
     /* 2275538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2275541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275557 */     // (select:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs3)  =>  (QC_MVEQI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, 0:{ *:[i64] }, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2275557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQI),
     /* 2275560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2275569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2275571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275572 */     // GIR_Coverage, 64651,
     /* 2275572 */     GIR_EraseRootFromParent_Done,
     /* 2275573 */   // Label 30662: @2275573
     /* 2275573 */   GIM_Try, /*On fail goto*//*Label 30663*/ GIMT_Encode4(2275610), // Rule ID 64677 //
     /* 2275578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
     /* 2275581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275597 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs3)
     /* 2275597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2275600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2275606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2275608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275609 */     // GIR_Coverage, 64677,
     /* 2275609 */     GIR_EraseRootFromParent_Done,
     /* 2275610 */   // Label 30663: @2275610
     /* 2275610 */   GIM_Reject,
     /* 2275611 */ // Label 30650: @2275611
     /* 2275611 */ GIM_Reject,
     /* 2275612 */ // Label 30613: @2275612
     /* 2275612 */ GIM_Try, /*On fail goto*//*Label 30664*/ GIMT_Encode4(2275731),
     /* 2275617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2275620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2275623 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2275626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2275630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2275634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275638 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275642 */   GIM_Try, /*On fail goto*//*Label 30665*/ GIMT_Encode4(2275686), // Rule ID 52244 //
     /* 2275647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275650 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2275653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2275667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275676 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275685 */     // GIR_Coverage, 52244,
     /* 2275685 */     GIR_EraseRootFromParent_Done,
     /* 2275686 */   // Label 30665: @2275686
     /* 2275686 */   GIM_Try, /*On fail goto*//*Label 30666*/ GIMT_Encode4(2275730), // Rule ID 52245 //
     /* 2275691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275694 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2275697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2275711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275720 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275729 */     // GIR_Coverage, 52245,
     /* 2275729 */     GIR_EraseRootFromParent_Done,
     /* 2275730 */   // Label 30666: @2275730
     /* 2275730 */   GIM_Reject,
     /* 2275731 */ // Label 30664: @2275731
     /* 2275731 */ GIM_Reject,
     /* 2275732 */ // Label 30614: @2275732
     /* 2275732 */ GIM_Try, /*On fail goto*//*Label 30667*/ GIMT_Encode4(2275939),
     /* 2275737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2275740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2275743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2275746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2275750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2275754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275758 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275762 */   GIM_Try, /*On fail goto*//*Label 30668*/ GIMT_Encode4(2275806), // Rule ID 52262 //
     /* 2275767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275770 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2275770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2275773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2275787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275796 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275805 */     // GIR_Coverage, 52262,
     /* 2275805 */     GIR_EraseRootFromParent_Done,
     /* 2275806 */   // Label 30668: @2275806
     /* 2275806 */   GIM_Try, /*On fail goto*//*Label 30669*/ GIMT_Encode4(2275850), // Rule ID 52263 //
     /* 2275811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275814 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2275814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2275817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2275831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275840 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275849 */     // GIR_Coverage, 52263,
     /* 2275849 */     GIR_EraseRootFromParent_Done,
     /* 2275850 */   // Label 30669: @2275850
     /* 2275850 */   GIM_Try, /*On fail goto*//*Label 30670*/ GIMT_Encode4(2275894), // Rule ID 58084 //
     /* 2275855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275858 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2275858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2275861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2275875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275884 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275893 */     // GIR_Coverage, 58084,
     /* 2275893 */     GIR_EraseRootFromParent_Done,
     /* 2275894 */   // Label 30670: @2275894
     /* 2275894 */   GIM_Try, /*On fail goto*//*Label 30671*/ GIMT_Encode4(2275938), // Rule ID 58085 //
     /* 2275899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275902 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2275902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2275905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2275919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275928 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275937 */     // GIR_Coverage, 58085,
     /* 2275937 */     GIR_EraseRootFromParent_Done,
     /* 2275938 */   // Label 30671: @2275938
     /* 2275938 */   GIM_Reject,
     /* 2275939 */ // Label 30667: @2275939
     /* 2275939 */ GIM_Reject,
     /* 2275940 */ // Label 30615: @2275940
     /* 2275940 */ GIM_Try, /*On fail goto*//*Label 30672*/ GIMT_Encode4(2276147),
     /* 2275945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2275948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2275951 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2275954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2275958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2275962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275966 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275970 */   GIM_Try, /*On fail goto*//*Label 30673*/ GIMT_Encode4(2276014), // Rule ID 52274 //
     /* 2275975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275978 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2275978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2275981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2275995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276004 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276013 */     // GIR_Coverage, 52274,
     /* 2276013 */     GIR_EraseRootFromParent_Done,
     /* 2276014 */   // Label 30673: @2276014
     /* 2276014 */   GIM_Try, /*On fail goto*//*Label 30674*/ GIMT_Encode4(2276058), // Rule ID 52275 //
     /* 2276019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276022 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2276022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2276025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2276039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276048 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276057 */     // GIR_Coverage, 52275,
     /* 2276057 */     GIR_EraseRootFromParent_Done,
     /* 2276058 */   // Label 30674: @2276058
     /* 2276058 */   GIM_Try, /*On fail goto*//*Label 30675*/ GIMT_Encode4(2276102), // Rule ID 58104 //
     /* 2276063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276066 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2276066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2276069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2276083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276092 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276101 */     // GIR_Coverage, 58104,
     /* 2276101 */     GIR_EraseRootFromParent_Done,
     /* 2276102 */   // Label 30675: @2276102
     /* 2276102 */   GIM_Try, /*On fail goto*//*Label 30676*/ GIMT_Encode4(2276146), // Rule ID 58105 //
     /* 2276107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276110 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2276110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2276113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2276127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276136 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276145 */     // GIR_Coverage, 58105,
     /* 2276145 */     GIR_EraseRootFromParent_Done,
     /* 2276146 */   // Label 30676: @2276146
     /* 2276146 */   GIM_Reject,
     /* 2276147 */ // Label 30672: @2276147
     /* 2276147 */ GIM_Reject,
     /* 2276148 */ // Label 30616: @2276148
     /* 2276148 */ GIM_Try, /*On fail goto*//*Label 30677*/ GIMT_Encode4(2276355),
     /* 2276153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2276156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2276159 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2276162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2276166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2276170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276174 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276178 */   GIM_Try, /*On fail goto*//*Label 30678*/ GIMT_Encode4(2276222), // Rule ID 52298 //
     /* 2276183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2276186 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2276186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2276189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276212 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276221 */     // GIR_Coverage, 52298,
     /* 2276221 */     GIR_EraseRootFromParent_Done,
     /* 2276222 */   // Label 30678: @2276222
     /* 2276222 */   GIM_Try, /*On fail goto*//*Label 30679*/ GIMT_Encode4(2276266), // Rule ID 52299 //
     /* 2276227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2276230 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2276230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2276233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276256 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276265 */     // GIR_Coverage, 52299,
     /* 2276265 */     GIR_EraseRootFromParent_Done,
     /* 2276266 */   // Label 30679: @2276266
     /* 2276266 */   GIM_Try, /*On fail goto*//*Label 30680*/ GIMT_Encode4(2276310), // Rule ID 58134 //
     /* 2276271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2276274 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2276274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2276277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276300 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276309 */     // GIR_Coverage, 58134,
     /* 2276309 */     GIR_EraseRootFromParent_Done,
     /* 2276310 */   // Label 30680: @2276310
     /* 2276310 */   GIM_Try, /*On fail goto*//*Label 30681*/ GIMT_Encode4(2276354), // Rule ID 58135 //
     /* 2276315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2276318 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2276318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2276321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276344 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276353 */     // GIR_Coverage, 58135,
     /* 2276353 */     GIR_EraseRootFromParent_Done,
     /* 2276354 */   // Label 30681: @2276354
     /* 2276354 */   GIM_Reject,
     /* 2276355 */ // Label 30677: @2276355
     /* 2276355 */ GIM_Reject,
     /* 2276356 */ // Label 30617: @2276356
     /* 2276356 */ GIM_Try, /*On fail goto*//*Label 30682*/ GIMT_Encode4(2276475),
     /* 2276361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2276364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2276367 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2276370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2276374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2276378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276382 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276386 */   GIM_Try, /*On fail goto*//*Label 30683*/ GIMT_Encode4(2276430), // Rule ID 52250 //
     /* 2276391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276394 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2276397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2276411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276420 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276429 */     // GIR_Coverage, 52250,
     /* 2276429 */     GIR_EraseRootFromParent_Done,
     /* 2276430 */   // Label 30683: @2276430
     /* 2276430 */   GIM_Try, /*On fail goto*//*Label 30684*/ GIMT_Encode4(2276474), // Rule ID 52251 //
     /* 2276435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276438 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2276441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2276455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276464 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276473 */     // GIR_Coverage, 52251,
     /* 2276473 */     GIR_EraseRootFromParent_Done,
     /* 2276474 */   // Label 30684: @2276474
     /* 2276474 */   GIM_Reject,
     /* 2276475 */ // Label 30682: @2276475
     /* 2276475 */ GIM_Reject,
     /* 2276476 */ // Label 30618: @2276476
     /* 2276476 */ GIM_Try, /*On fail goto*//*Label 30685*/ GIMT_Encode4(2276683),
     /* 2276481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2276484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2276487 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2276490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2276494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2276498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276502 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276506 */   GIM_Try, /*On fail goto*//*Label 30686*/ GIMT_Encode4(2276550), // Rule ID 52268 //
     /* 2276511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276514 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2276514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2276517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2276531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276540 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276549 */     // GIR_Coverage, 52268,
     /* 2276549 */     GIR_EraseRootFromParent_Done,
     /* 2276550 */   // Label 30686: @2276550
     /* 2276550 */   GIM_Try, /*On fail goto*//*Label 30687*/ GIMT_Encode4(2276594), // Rule ID 52269 //
     /* 2276555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276558 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2276558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2276561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2276575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276584 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276593 */     // GIR_Coverage, 52269,
     /* 2276593 */     GIR_EraseRootFromParent_Done,
     /* 2276594 */   // Label 30687: @2276594
     /* 2276594 */   GIM_Try, /*On fail goto*//*Label 30688*/ GIMT_Encode4(2276638), // Rule ID 58094 //
     /* 2276599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276602 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2276602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2276605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2276619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276628 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276637 */     // GIR_Coverage, 58094,
     /* 2276637 */     GIR_EraseRootFromParent_Done,
     /* 2276638 */   // Label 30688: @2276638
     /* 2276638 */   GIM_Try, /*On fail goto*//*Label 30689*/ GIMT_Encode4(2276682), // Rule ID 58095 //
     /* 2276643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276646 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2276646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2276649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2276663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276672 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276681 */     // GIR_Coverage, 58095,
     /* 2276681 */     GIR_EraseRootFromParent_Done,
     /* 2276682 */   // Label 30689: @2276682
     /* 2276682 */   GIM_Reject,
     /* 2276683 */ // Label 30685: @2276683
     /* 2276683 */ GIM_Reject,
     /* 2276684 */ // Label 30619: @2276684
     /* 2276684 */ GIM_Try, /*On fail goto*//*Label 30690*/ GIMT_Encode4(2276891),
     /* 2276689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2276692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2276695 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2276698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2276702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2276706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276710 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276714 */   GIM_Try, /*On fail goto*//*Label 30691*/ GIMT_Encode4(2276758), // Rule ID 52292 //
     /* 2276719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276722 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2276722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2276725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276748 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276757 */     // GIR_Coverage, 52292,
     /* 2276757 */     GIR_EraseRootFromParent_Done,
     /* 2276758 */   // Label 30691: @2276758
     /* 2276758 */   GIM_Try, /*On fail goto*//*Label 30692*/ GIMT_Encode4(2276802), // Rule ID 52293 //
     /* 2276763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276766 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2276766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2276769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276792 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276801 */     // GIR_Coverage, 52293,
     /* 2276801 */     GIR_EraseRootFromParent_Done,
     /* 2276802 */   // Label 30692: @2276802
     /* 2276802 */   GIM_Try, /*On fail goto*//*Label 30693*/ GIMT_Encode4(2276846), // Rule ID 58124 //
     /* 2276807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276810 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2276810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2276813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276836 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276845 */     // GIR_Coverage, 58124,
     /* 2276845 */     GIR_EraseRootFromParent_Done,
     /* 2276846 */   // Label 30693: @2276846
     /* 2276846 */   GIM_Try, /*On fail goto*//*Label 30694*/ GIMT_Encode4(2276890), // Rule ID 58125 //
     /* 2276851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276854 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2276854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2276857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276880 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276889 */     // GIR_Coverage, 58125,
     /* 2276889 */     GIR_EraseRootFromParent_Done,
     /* 2276890 */   // Label 30694: @2276890
     /* 2276890 */   GIM_Reject,
     /* 2276891 */ // Label 30690: @2276891
     /* 2276891 */ GIM_Reject,
     /* 2276892 */ // Label 30620: @2276892
     /* 2276892 */ GIM_Try, /*On fail goto*//*Label 30695*/ GIMT_Encode4(2277099),
     /* 2276897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2276900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2276903 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2276906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2276910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2276914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276918 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276922 */   GIM_Try, /*On fail goto*//*Label 30696*/ GIMT_Encode4(2276966), // Rule ID 52358 //
     /* 2276927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2276930 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2276930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2276933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2276947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276956 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276965 */     // GIR_Coverage, 52358,
     /* 2276965 */     GIR_EraseRootFromParent_Done,
     /* 2276966 */   // Label 30696: @2276966
     /* 2276966 */   GIM_Try, /*On fail goto*//*Label 30697*/ GIMT_Encode4(2277010), // Rule ID 52359 //
     /* 2276971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2276974 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2276974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2276977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2276991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277000 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277009 */     // GIR_Coverage, 52359,
     /* 2277009 */     GIR_EraseRootFromParent_Done,
     /* 2277010 */   // Label 30697: @2277010
     /* 2277010 */   GIM_Try, /*On fail goto*//*Label 30698*/ GIMT_Encode4(2277054), // Rule ID 58204 //
     /* 2277015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2277018 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2277018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2277021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277044 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277053 */     // GIR_Coverage, 58204,
     /* 2277053 */     GIR_EraseRootFromParent_Done,
     /* 2277054 */   // Label 30698: @2277054
     /* 2277054 */   GIM_Try, /*On fail goto*//*Label 30699*/ GIMT_Encode4(2277098), // Rule ID 58205 //
     /* 2277059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2277062 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2277062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2277065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277088 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277097 */     // GIR_Coverage, 58205,
     /* 2277097 */     GIR_EraseRootFromParent_Done,
     /* 2277098 */   // Label 30699: @2277098
     /* 2277098 */   GIM_Reject,
     /* 2277099 */ // Label 30695: @2277099
     /* 2277099 */ GIM_Reject,
     /* 2277100 */ // Label 30621: @2277100
     /* 2277100 */ GIM_Try, /*On fail goto*//*Label 30700*/ GIMT_Encode4(2277219),
     /* 2277105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2277108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2277111 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2277114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2277118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277126 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277130 */   GIM_Try, /*On fail goto*//*Label 30701*/ GIMT_Encode4(2277174), // Rule ID 52256 //
     /* 2277135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277138 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2277141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2277155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277164 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277173 */     // GIR_Coverage, 52256,
     /* 2277173 */     GIR_EraseRootFromParent_Done,
     /* 2277174 */   // Label 30701: @2277174
     /* 2277174 */   GIM_Try, /*On fail goto*//*Label 30702*/ GIMT_Encode4(2277218), // Rule ID 52257 //
     /* 2277179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277182 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2277185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2277199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277208 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277217 */     // GIR_Coverage, 52257,
     /* 2277217 */     GIR_EraseRootFromParent_Done,
     /* 2277218 */   // Label 30702: @2277218
     /* 2277218 */   GIM_Reject,
     /* 2277219 */ // Label 30700: @2277219
     /* 2277219 */ GIM_Reject,
     /* 2277220 */ // Label 30622: @2277220
     /* 2277220 */ GIM_Try, /*On fail goto*//*Label 30703*/ GIMT_Encode4(2277427),
     /* 2277225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2277228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2277231 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2277234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2277238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277246 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277250 */   GIM_Try, /*On fail goto*//*Label 30704*/ GIMT_Encode4(2277294), // Rule ID 52286 //
     /* 2277255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277258 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2277258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2277261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2277275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277284 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277293 */     // GIR_Coverage, 52286,
     /* 2277293 */     GIR_EraseRootFromParent_Done,
     /* 2277294 */   // Label 30704: @2277294
     /* 2277294 */   GIM_Try, /*On fail goto*//*Label 30705*/ GIMT_Encode4(2277338), // Rule ID 52287 //
     /* 2277299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277302 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2277302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2277305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2277319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277328 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277337 */     // GIR_Coverage, 52287,
     /* 2277337 */     GIR_EraseRootFromParent_Done,
     /* 2277338 */   // Label 30705: @2277338
     /* 2277338 */   GIM_Try, /*On fail goto*//*Label 30706*/ GIMT_Encode4(2277382), // Rule ID 58114 //
     /* 2277343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277346 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2277346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2277349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2277363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277372 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277381 */     // GIR_Coverage, 58114,
     /* 2277381 */     GIR_EraseRootFromParent_Done,
     /* 2277382 */   // Label 30706: @2277382
     /* 2277382 */   GIM_Try, /*On fail goto*//*Label 30707*/ GIMT_Encode4(2277426), // Rule ID 58115 //
     /* 2277387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277390 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2277390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2277393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2277407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277416 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277425 */     // GIR_Coverage, 58115,
     /* 2277425 */     GIR_EraseRootFromParent_Done,
     /* 2277426 */   // Label 30707: @2277426
     /* 2277426 */   GIM_Reject,
     /* 2277427 */ // Label 30703: @2277427
     /* 2277427 */ GIM_Reject,
     /* 2277428 */ // Label 30623: @2277428
     /* 2277428 */ GIM_Try, /*On fail goto*//*Label 30708*/ GIMT_Encode4(2277635),
     /* 2277433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2277436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2277439 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2277442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2277446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277454 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277458 */   GIM_Try, /*On fail goto*//*Label 30709*/ GIMT_Encode4(2277502), // Rule ID 52340 //
     /* 2277463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277466 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2277466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2277469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277492 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277501 */     // GIR_Coverage, 52340,
     /* 2277501 */     GIR_EraseRootFromParent_Done,
     /* 2277502 */   // Label 30709: @2277502
     /* 2277502 */   GIM_Try, /*On fail goto*//*Label 30710*/ GIMT_Encode4(2277546), // Rule ID 52341 //
     /* 2277507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277510 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2277510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2277513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277536 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277545 */     // GIR_Coverage, 52341,
     /* 2277545 */     GIR_EraseRootFromParent_Done,
     /* 2277546 */   // Label 30710: @2277546
     /* 2277546 */   GIM_Try, /*On fail goto*//*Label 30711*/ GIMT_Encode4(2277590), // Rule ID 58174 //
     /* 2277551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277554 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2277554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2277557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277580 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277589 */     // GIR_Coverage, 58174,
     /* 2277589 */     GIR_EraseRootFromParent_Done,
     /* 2277590 */   // Label 30711: @2277590
     /* 2277590 */   GIM_Try, /*On fail goto*//*Label 30712*/ GIMT_Encode4(2277634), // Rule ID 58175 //
     /* 2277595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277598 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2277598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2277601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277624 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277633 */     // GIR_Coverage, 58175,
     /* 2277633 */     GIR_EraseRootFromParent_Done,
     /* 2277634 */   // Label 30712: @2277634
     /* 2277634 */   GIM_Reject,
     /* 2277635 */ // Label 30708: @2277635
     /* 2277635 */ GIM_Reject,
     /* 2277636 */ // Label 30624: @2277636
     /* 2277636 */ GIM_Try, /*On fail goto*//*Label 30713*/ GIMT_Encode4(2277843),
     /* 2277641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2277644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2277647 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2277650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2277654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2277662 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2277666 */   GIM_Try, /*On fail goto*//*Label 30714*/ GIMT_Encode4(2277710), // Rule ID 52364 //
     /* 2277671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2277674 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2277674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2277677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2277691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277700 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277709 */     // GIR_Coverage, 52364,
     /* 2277709 */     GIR_EraseRootFromParent_Done,
     /* 2277710 */   // Label 30714: @2277710
     /* 2277710 */   GIM_Try, /*On fail goto*//*Label 30715*/ GIMT_Encode4(2277754), // Rule ID 52365 //
     /* 2277715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2277718 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2277718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2277721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2277735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277744 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277753 */     // GIR_Coverage, 52365,
     /* 2277753 */     GIR_EraseRootFromParent_Done,
     /* 2277754 */   // Label 30715: @2277754
     /* 2277754 */   GIM_Try, /*On fail goto*//*Label 30716*/ GIMT_Encode4(2277798), // Rule ID 58214 //
     /* 2277759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2277762 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2277762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2277765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2277779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277788 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277797 */     // GIR_Coverage, 58214,
     /* 2277797 */     GIR_EraseRootFromParent_Done,
     /* 2277798 */   // Label 30716: @2277798
     /* 2277798 */   GIM_Try, /*On fail goto*//*Label 30717*/ GIMT_Encode4(2277842), // Rule ID 58215 //
     /* 2277803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2277806 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2277806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2277809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2277823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277832 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277841 */     // GIR_Coverage, 58215,
     /* 2277841 */     GIR_EraseRootFromParent_Done,
     /* 2277842 */   // Label 30717: @2277842
     /* 2277842 */   GIM_Reject,
     /* 2277843 */ // Label 30713: @2277843
     /* 2277843 */ GIM_Reject,
     /* 2277844 */ // Label 30625: @2277844
     /* 2277844 */ GIM_Try, /*On fail goto*//*Label 30718*/ GIMT_Encode4(2277963),
     /* 2277849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2277852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2277855 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2277858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2277862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277870 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277874 */   GIM_Try, /*On fail goto*//*Label 30719*/ GIMT_Encode4(2277918), // Rule ID 52280 //
     /* 2277879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277882 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2277885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2277899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277908 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277917 */     // GIR_Coverage, 52280,
     /* 2277917 */     GIR_EraseRootFromParent_Done,
     /* 2277918 */   // Label 30719: @2277918
     /* 2277918 */   GIM_Try, /*On fail goto*//*Label 30720*/ GIMT_Encode4(2277962), // Rule ID 52281 //
     /* 2277923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277926 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2277929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2277943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277952 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277961 */     // GIR_Coverage, 52281,
     /* 2277961 */     GIR_EraseRootFromParent_Done,
     /* 2277962 */   // Label 30720: @2277962
     /* 2277962 */   GIM_Reject,
     /* 2277963 */ // Label 30718: @2277963
     /* 2277963 */ GIM_Reject,
     /* 2277964 */ // Label 30626: @2277964
     /* 2277964 */ GIM_Try, /*On fail goto*//*Label 30721*/ GIMT_Encode4(2278171),
     /* 2277969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2277972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2277975 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2277978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2277982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277990 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277994 */   GIM_Try, /*On fail goto*//*Label 30722*/ GIMT_Encode4(2278038), // Rule ID 52322 //
     /* 2277999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278002 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2278002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2278005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2278019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278028 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278037 */     // GIR_Coverage, 52322,
     /* 2278037 */     GIR_EraseRootFromParent_Done,
     /* 2278038 */   // Label 30722: @2278038
     /* 2278038 */   GIM_Try, /*On fail goto*//*Label 30723*/ GIMT_Encode4(2278082), // Rule ID 52323 //
     /* 2278043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278046 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2278046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2278049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2278063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278072 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278081 */     // GIR_Coverage, 52323,
     /* 2278081 */     GIR_EraseRootFromParent_Done,
     /* 2278082 */   // Label 30723: @2278082
     /* 2278082 */   GIM_Try, /*On fail goto*//*Label 30724*/ GIMT_Encode4(2278126), // Rule ID 58144 //
     /* 2278087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278090 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2278090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2278093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2278107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278116 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278125 */     // GIR_Coverage, 58144,
     /* 2278125 */     GIR_EraseRootFromParent_Done,
     /* 2278126 */   // Label 30724: @2278126
     /* 2278126 */   GIM_Try, /*On fail goto*//*Label 30725*/ GIMT_Encode4(2278170), // Rule ID 58145 //
     /* 2278131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278134 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2278134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2278137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2278151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278160 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278169 */     // GIR_Coverage, 58145,
     /* 2278169 */     GIR_EraseRootFromParent_Done,
     /* 2278170 */   // Label 30725: @2278170
     /* 2278170 */   GIM_Reject,
     /* 2278171 */ // Label 30721: @2278171
     /* 2278171 */ GIM_Reject,
     /* 2278172 */ // Label 30627: @2278172
     /* 2278172 */ GIM_Try, /*On fail goto*//*Label 30726*/ GIMT_Encode4(2278379),
     /* 2278177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2278180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2278183 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2278186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2278190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278198 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278202 */   GIM_Try, /*On fail goto*//*Label 30727*/ GIMT_Encode4(2278246), // Rule ID 52346 //
     /* 2278207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278210 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2278210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2278213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278236 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278245 */     // GIR_Coverage, 52346,
     /* 2278245 */     GIR_EraseRootFromParent_Done,
     /* 2278246 */   // Label 30727: @2278246
     /* 2278246 */   GIM_Try, /*On fail goto*//*Label 30728*/ GIMT_Encode4(2278290), // Rule ID 52347 //
     /* 2278251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278254 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2278254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2278257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278280 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278289 */     // GIR_Coverage, 52347,
     /* 2278289 */     GIR_EraseRootFromParent_Done,
     /* 2278290 */   // Label 30728: @2278290
     /* 2278290 */   GIM_Try, /*On fail goto*//*Label 30729*/ GIMT_Encode4(2278334), // Rule ID 58184 //
     /* 2278295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278298 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2278298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2278301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278324 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278333 */     // GIR_Coverage, 58184,
     /* 2278333 */     GIR_EraseRootFromParent_Done,
     /* 2278334 */   // Label 30729: @2278334
     /* 2278334 */   GIM_Try, /*On fail goto*//*Label 30730*/ GIMT_Encode4(2278378), // Rule ID 58185 //
     /* 2278339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278342 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2278342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2278345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278368 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278377 */     // GIR_Coverage, 58185,
     /* 2278377 */     GIR_EraseRootFromParent_Done,
     /* 2278378 */   // Label 30730: @2278378
     /* 2278378 */   GIM_Reject,
     /* 2278379 */ // Label 30726: @2278379
     /* 2278379 */ GIM_Reject,
     /* 2278380 */ // Label 30628: @2278380
     /* 2278380 */ GIM_Try, /*On fail goto*//*Label 30731*/ GIMT_Encode4(2278587),
     /* 2278385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2278388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2278391 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2278394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2278398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278406 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278410 */   GIM_Try, /*On fail goto*//*Label 30732*/ GIMT_Encode4(2278454), // Rule ID 52370 //
     /* 2278415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2278418 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2278418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2278421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278444 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278453 */     // GIR_Coverage, 52370,
     /* 2278453 */     GIR_EraseRootFromParent_Done,
     /* 2278454 */   // Label 30732: @2278454
     /* 2278454 */   GIM_Try, /*On fail goto*//*Label 30733*/ GIMT_Encode4(2278498), // Rule ID 52371 //
     /* 2278459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2278462 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2278462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2278465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278488 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278497 */     // GIR_Coverage, 52371,
     /* 2278497 */     GIR_EraseRootFromParent_Done,
     /* 2278498 */   // Label 30733: @2278498
     /* 2278498 */   GIM_Try, /*On fail goto*//*Label 30734*/ GIMT_Encode4(2278542), // Rule ID 58224 //
     /* 2278503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2278506 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2278506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2278509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278532 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278541 */     // GIR_Coverage, 58224,
     /* 2278541 */     GIR_EraseRootFromParent_Done,
     /* 2278542 */   // Label 30734: @2278542
     /* 2278542 */   GIM_Try, /*On fail goto*//*Label 30735*/ GIMT_Encode4(2278586), // Rule ID 58225 //
     /* 2278547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2278550 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2278550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2278553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278576 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278585 */     // GIR_Coverage, 58225,
     /* 2278585 */     GIR_EraseRootFromParent_Done,
     /* 2278586 */   // Label 30735: @2278586
     /* 2278586 */   GIM_Reject,
     /* 2278587 */ // Label 30731: @2278587
     /* 2278587 */ GIM_Reject,
     /* 2278588 */ // Label 30629: @2278588
     /* 2278588 */ GIM_Try, /*On fail goto*//*Label 30736*/ GIMT_Encode4(2278707),
     /* 2278593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2278596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2278599 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2278602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2278606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278614 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278618 */   GIM_Try, /*On fail goto*//*Label 30737*/ GIMT_Encode4(2278662), // Rule ID 52304 //
     /* 2278623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278626 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2278629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2278643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278652 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278661 */     // GIR_Coverage, 52304,
     /* 2278661 */     GIR_EraseRootFromParent_Done,
     /* 2278662 */   // Label 30737: @2278662
     /* 2278662 */   GIM_Try, /*On fail goto*//*Label 30738*/ GIMT_Encode4(2278706), // Rule ID 52305 //
     /* 2278667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278670 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2278673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2278687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278696 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278705 */     // GIR_Coverage, 52305,
     /* 2278705 */     GIR_EraseRootFromParent_Done,
     /* 2278706 */   // Label 30738: @2278706
     /* 2278706 */   GIM_Reject,
     /* 2278707 */ // Label 30736: @2278707
     /* 2278707 */ GIM_Reject,
     /* 2278708 */ // Label 30630: @2278708
     /* 2278708 */ GIM_Try, /*On fail goto*//*Label 30739*/ GIMT_Encode4(2278915),
     /* 2278713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2278716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2278719 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2278722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2278726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278734 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278738 */   GIM_Try, /*On fail goto*//*Label 30740*/ GIMT_Encode4(2278782), // Rule ID 52328 //
     /* 2278743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278746 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2278746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2278749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278772 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278781 */     // GIR_Coverage, 52328,
     /* 2278781 */     GIR_EraseRootFromParent_Done,
     /* 2278782 */   // Label 30740: @2278782
     /* 2278782 */   GIM_Try, /*On fail goto*//*Label 30741*/ GIMT_Encode4(2278826), // Rule ID 52329 //
     /* 2278787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278790 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2278790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2278793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278816 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278825 */     // GIR_Coverage, 52329,
     /* 2278825 */     GIR_EraseRootFromParent_Done,
     /* 2278826 */   // Label 30741: @2278826
     /* 2278826 */   GIM_Try, /*On fail goto*//*Label 30742*/ GIMT_Encode4(2278870), // Rule ID 58154 //
     /* 2278831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278834 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2278834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2278837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278860 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278869 */     // GIR_Coverage, 58154,
     /* 2278869 */     GIR_EraseRootFromParent_Done,
     /* 2278870 */   // Label 30742: @2278870
     /* 2278870 */   GIM_Try, /*On fail goto*//*Label 30743*/ GIMT_Encode4(2278914), // Rule ID 58155 //
     /* 2278875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278878 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2278878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2278881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278904 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278913 */     // GIR_Coverage, 58155,
     /* 2278913 */     GIR_EraseRootFromParent_Done,
     /* 2278914 */   // Label 30743: @2278914
     /* 2278914 */   GIM_Reject,
     /* 2278915 */ // Label 30739: @2278915
     /* 2278915 */ GIM_Reject,
     /* 2278916 */ // Label 30631: @2278916
     /* 2278916 */ GIM_Try, /*On fail goto*//*Label 30744*/ GIMT_Encode4(2279123),
     /* 2278921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2278924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2278927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2278930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2278934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278942 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278946 */   GIM_Try, /*On fail goto*//*Label 30745*/ GIMT_Encode4(2278990), // Rule ID 52352 //
     /* 2278951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278954 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2278954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2278957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278980 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278989 */     // GIR_Coverage, 52352,
     /* 2278989 */     GIR_EraseRootFromParent_Done,
     /* 2278990 */   // Label 30745: @2278990
     /* 2278990 */   GIM_Try, /*On fail goto*//*Label 30746*/ GIMT_Encode4(2279034), // Rule ID 52353 //
     /* 2278995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278998 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2278998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2279001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2279015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279024 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279033 */     // GIR_Coverage, 52353,
     /* 2279033 */     GIR_EraseRootFromParent_Done,
     /* 2279034 */   // Label 30746: @2279034
     /* 2279034 */   GIM_Try, /*On fail goto*//*Label 30747*/ GIMT_Encode4(2279078), // Rule ID 58194 //
     /* 2279039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279042 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2279042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2279045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2279059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279068 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279077 */     // GIR_Coverage, 58194,
     /* 2279077 */     GIR_EraseRootFromParent_Done,
     /* 2279078 */   // Label 30747: @2279078
     /* 2279078 */   GIM_Try, /*On fail goto*//*Label 30748*/ GIMT_Encode4(2279122), // Rule ID 58195 //
     /* 2279083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279086 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2279086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2279089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2279103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279112 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279121 */     // GIR_Coverage, 58195,
     /* 2279121 */     GIR_EraseRootFromParent_Done,
     /* 2279122 */   // Label 30748: @2279122
     /* 2279122 */   GIM_Reject,
     /* 2279123 */ // Label 30744: @2279123
     /* 2279123 */ GIM_Reject,
     /* 2279124 */ // Label 30632: @2279124
     /* 2279124 */ GIM_Try, /*On fail goto*//*Label 30749*/ GIMT_Encode4(2279243),
     /* 2279129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2279132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2279135 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2279138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2279142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2279146 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279150 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279154 */   GIM_Try, /*On fail goto*//*Label 30750*/ GIMT_Encode4(2279198), // Rule ID 52310 //
     /* 2279159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279162 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2279165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2279179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279188 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279197 */     // GIR_Coverage, 52310,
     /* 2279197 */     GIR_EraseRootFromParent_Done,
     /* 2279198 */   // Label 30750: @2279198
     /* 2279198 */   GIM_Try, /*On fail goto*//*Label 30751*/ GIMT_Encode4(2279242), // Rule ID 52311 //
     /* 2279203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279206 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2279209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2279223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279232 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279241 */     // GIR_Coverage, 52311,
     /* 2279241 */     GIR_EraseRootFromParent_Done,
     /* 2279242 */   // Label 30751: @2279242
     /* 2279242 */   GIM_Reject,
     /* 2279243 */ // Label 30749: @2279243
     /* 2279243 */ GIM_Reject,
     /* 2279244 */ // Label 30633: @2279244
     /* 2279244 */ GIM_Try, /*On fail goto*//*Label 30752*/ GIMT_Encode4(2279451),
     /* 2279249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2279252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2279255 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2279258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2279262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2279266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279270 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279274 */   GIM_Try, /*On fail goto*//*Label 30753*/ GIMT_Encode4(2279318), // Rule ID 52334 //
     /* 2279279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279282 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2279282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2279285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2279299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279308 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279317 */     // GIR_Coverage, 52334,
     /* 2279317 */     GIR_EraseRootFromParent_Done,
     /* 2279318 */   // Label 30753: @2279318
     /* 2279318 */   GIM_Try, /*On fail goto*//*Label 30754*/ GIMT_Encode4(2279362), // Rule ID 52335 //
     /* 2279323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279326 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2279326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2279329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2279343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279352 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279361 */     // GIR_Coverage, 52335,
     /* 2279361 */     GIR_EraseRootFromParent_Done,
     /* 2279362 */   // Label 30754: @2279362
     /* 2279362 */   GIM_Try, /*On fail goto*//*Label 30755*/ GIMT_Encode4(2279406), // Rule ID 58164 //
     /* 2279367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279370 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2279370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2279373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2279387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279396 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279405 */     // GIR_Coverage, 58164,
     /* 2279405 */     GIR_EraseRootFromParent_Done,
     /* 2279406 */   // Label 30755: @2279406
     /* 2279406 */   GIM_Try, /*On fail goto*//*Label 30756*/ GIMT_Encode4(2279450), // Rule ID 58165 //
     /* 2279411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279414 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2279414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2279417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2279431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279440 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279449 */     // GIR_Coverage, 58165,
     /* 2279449 */     GIR_EraseRootFromParent_Done,
     /* 2279450 */   // Label 30756: @2279450
     /* 2279450 */   GIM_Reject,
     /* 2279451 */ // Label 30752: @2279451
     /* 2279451 */ GIM_Reject,
     /* 2279452 */ // Label 30634: @2279452
     /* 2279452 */ GIM_Try, /*On fail goto*//*Label 30757*/ GIMT_Encode4(2279571),
     /* 2279457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /* 2279460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2279463 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2279466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2279470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2279474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279478 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279482 */   GIM_Try, /*On fail goto*//*Label 30758*/ GIMT_Encode4(2279526), // Rule ID 52316 //
     /* 2279487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279490 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2279493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2279507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279516 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279525 */     // GIR_Coverage, 52316,
     /* 2279525 */     GIR_EraseRootFromParent_Done,
     /* 2279526 */   // Label 30758: @2279526
     /* 2279526 */   GIM_Try, /*On fail goto*//*Label 30759*/ GIMT_Encode4(2279570), // Rule ID 52317 //
     /* 2279531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279534 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2279537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2279551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279560 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279569 */     // GIR_Coverage, 52317,
     /* 2279569 */     GIR_EraseRootFromParent_Done,
     /* 2279570 */   // Label 30759: @2279570
     /* 2279570 */   GIM_Reject,
     /* 2279571 */ // Label 30757: @2279571
     /* 2279571 */ GIM_Reject,
     /* 2279572 */ // Label 30635: @2279572
     /* 2279572 */ GIM_Reject,
     /* 2279573 */ // Label 51: @2279573
     /* 2279573 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30784*/ GIMT_Encode4(2282306),
     /* 2279584 */ /*GILLT_s32*//*Label 30760*/ GIMT_Encode4(2279708),
     /* 2279588 */ /*GILLT_s64*//*Label 30761*/ GIMT_Encode4(2279742), GIMT_Encode4(0),
     /* 2279596 */ /*GILLT_nxv1s8*//*Label 30762*/ GIMT_Encode4(2279776),
     /* 2279600 */ /*GILLT_nxv1s16*//*Label 30763*/ GIMT_Encode4(2279891),
     /* 2279604 */ /*GILLT_nxv1s32*//*Label 30764*/ GIMT_Encode4(2280006),
     /* 2279608 */ /*GILLT_nxv1s64*//*Label 30765*/ GIMT_Encode4(2280121), GIMT_Encode4(0),
     /* 2279616 */ /*GILLT_nxv2s8*//*Label 30766*/ GIMT_Encode4(2280236),
     /* 2279620 */ /*GILLT_nxv2s16*//*Label 30767*/ GIMT_Encode4(2280351),
     /* 2279624 */ /*GILLT_nxv2s32*//*Label 30768*/ GIMT_Encode4(2280466),
     /* 2279628 */ /*GILLT_nxv2s64*//*Label 30769*/ GIMT_Encode4(2280581), GIMT_Encode4(0),
     /* 2279636 */ /*GILLT_nxv4s8*//*Label 30770*/ GIMT_Encode4(2280696),
     /* 2279640 */ /*GILLT_nxv4s16*//*Label 30771*/ GIMT_Encode4(2280811),
     /* 2279644 */ /*GILLT_nxv4s32*//*Label 30772*/ GIMT_Encode4(2280926),
     /* 2279648 */ /*GILLT_nxv4s64*//*Label 30773*/ GIMT_Encode4(2281041), GIMT_Encode4(0),
     /* 2279656 */ /*GILLT_nxv8s8*//*Label 30774*/ GIMT_Encode4(2281156),
     /* 2279660 */ /*GILLT_nxv8s16*//*Label 30775*/ GIMT_Encode4(2281271),
     /* 2279664 */ /*GILLT_nxv8s32*//*Label 30776*/ GIMT_Encode4(2281386),
     /* 2279668 */ /*GILLT_nxv8s64*//*Label 30777*/ GIMT_Encode4(2281501), GIMT_Encode4(0),
     /* 2279676 */ /*GILLT_nxv16s8*//*Label 30778*/ GIMT_Encode4(2281616),
     /* 2279680 */ /*GILLT_nxv16s16*//*Label 30779*/ GIMT_Encode4(2281731),
     /* 2279684 */ /*GILLT_nxv16s32*//*Label 30780*/ GIMT_Encode4(2281846), GIMT_Encode4(0),
     /* 2279692 */ /*GILLT_nxv32s8*//*Label 30781*/ GIMT_Encode4(2281961),
     /* 2279696 */ /*GILLT_nxv32s16*//*Label 30782*/ GIMT_Encode4(2282076), GIMT_Encode4(0),
     /* 2279704 */ /*GILLT_nxv64s8*//*Label 30783*/ GIMT_Encode4(2282191),
     /* 2279708 */ // Label 30760: @2279708
     /* 2279708 */ GIM_Try, /*On fail goto*//*Label 30785*/ GIMT_Encode4(2279741), // Rule ID 306 //
     /* 2279713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2279716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2279719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2279722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2279726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2279730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2279734 */   // (mulhu:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULHU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2279734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2279739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279740 */   // GIR_Coverage, 306,
     /* 2279740 */   GIR_Done,
     /* 2279741 */ // Label 30785: @2279741
     /* 2279741 */ GIM_Reject,
     /* 2279742 */ // Label 30761: @2279742
     /* 2279742 */ GIM_Try, /*On fail goto*//*Label 30786*/ GIMT_Encode4(2279775), // Rule ID 305 //
     /* 2279747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2279750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2279760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2279764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2279768 */   // (mulhu:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULHU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2279768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2279773 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279774 */   // GIR_Coverage, 305,
     /* 2279774 */   GIR_Done,
     /* 2279775 */ // Label 30786: @2279775
     /* 2279775 */ GIM_Reject,
     /* 2279776 */ // Label 30762: @2279776
     /* 2279776 */ GIM_Try, /*On fail goto*//*Label 30787*/ GIMT_Encode4(2279890),
     /* 2279781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2279784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2279787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279795 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279799 */   GIM_Try, /*On fail goto*//*Label 30788*/ GIMT_Encode4(2279844), // Rule ID 51020 //
     /* 2279804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279807 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2279810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2279824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279843 */     // GIR_Coverage, 51020,
     /* 2279843 */     GIR_EraseRootFromParent_Done,
     /* 2279844 */   // Label 30788: @2279844
     /* 2279844 */   GIM_Try, /*On fail goto*//*Label 30789*/ GIMT_Encode4(2279889), // Rule ID 51021 //
     /* 2279849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279852 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2279855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2279869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279888 */     // GIR_Coverage, 51021,
     /* 2279888 */     GIR_EraseRootFromParent_Done,
     /* 2279889 */   // Label 30789: @2279889
     /* 2279889 */   GIM_Reject,
     /* 2279890 */ // Label 30787: @2279890
     /* 2279890 */ GIM_Reject,
     /* 2279891 */ // Label 30763: @2279891
     /* 2279891 */ GIM_Try, /*On fail goto*//*Label 30790*/ GIMT_Encode4(2280005),
     /* 2279896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2279899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2279902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279914 */   GIM_Try, /*On fail goto*//*Label 30791*/ GIMT_Encode4(2279959), // Rule ID 51032 //
     /* 2279919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279922 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2279925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2279939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279958 */     // GIR_Coverage, 51032,
     /* 2279958 */     GIR_EraseRootFromParent_Done,
     /* 2279959 */   // Label 30791: @2279959
     /* 2279959 */   GIM_Try, /*On fail goto*//*Label 30792*/ GIMT_Encode4(2280004), // Rule ID 51033 //
     /* 2279964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279967 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2279970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2279984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280003 */     // GIR_Coverage, 51033,
     /* 2280003 */     GIR_EraseRootFromParent_Done,
     /* 2280004 */   // Label 30792: @2280004
     /* 2280004 */   GIM_Reject,
     /* 2280005 */ // Label 30790: @2280005
     /* 2280005 */ GIM_Reject,
     /* 2280006 */ // Label 30764: @2280006
     /* 2280006 */ GIM_Try, /*On fail goto*//*Label 30793*/ GIMT_Encode4(2280120),
     /* 2280011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2280014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2280017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280025 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280029 */   GIM_Try, /*On fail goto*//*Label 30794*/ GIMT_Encode4(2280074), // Rule ID 51040 //
     /* 2280034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280037 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2280040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2280054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280073 */     // GIR_Coverage, 51040,
     /* 2280073 */     GIR_EraseRootFromParent_Done,
     /* 2280074 */   // Label 30794: @2280074
     /* 2280074 */   GIM_Try, /*On fail goto*//*Label 30795*/ GIMT_Encode4(2280119), // Rule ID 51041 //
     /* 2280079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280082 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2280085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2280099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280118 */     // GIR_Coverage, 51041,
     /* 2280118 */     GIR_EraseRootFromParent_Done,
     /* 2280119 */   // Label 30795: @2280119
     /* 2280119 */   GIM_Reject,
     /* 2280120 */ // Label 30793: @2280120
     /* 2280120 */ GIM_Reject,
     /* 2280121 */ // Label 30765: @2280121
     /* 2280121 */ GIM_Try, /*On fail goto*//*Label 30796*/ GIMT_Encode4(2280235),
     /* 2280126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2280129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2280132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280144 */   GIM_Try, /*On fail goto*//*Label 30797*/ GIMT_Encode4(2280189), // Rule ID 51108 //
     /* 2280149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2280152 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2280155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2280169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280188 */     // GIR_Coverage, 51108,
     /* 2280188 */     GIR_EraseRootFromParent_Done,
     /* 2280189 */   // Label 30797: @2280189
     /* 2280189 */   GIM_Try, /*On fail goto*//*Label 30798*/ GIMT_Encode4(2280234), // Rule ID 51109 //
     /* 2280194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2280197 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2280200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2280214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280233 */     // GIR_Coverage, 51109,
     /* 2280233 */     GIR_EraseRootFromParent_Done,
     /* 2280234 */   // Label 30798: @2280234
     /* 2280234 */   GIM_Reject,
     /* 2280235 */ // Label 30796: @2280235
     /* 2280235 */ GIM_Reject,
     /* 2280236 */ // Label 30766: @2280236
     /* 2280236 */ GIM_Try, /*On fail goto*//*Label 30799*/ GIMT_Encode4(2280350),
     /* 2280241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2280244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2280247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280259 */   GIM_Try, /*On fail goto*//*Label 30800*/ GIMT_Encode4(2280304), // Rule ID 51024 //
     /* 2280264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280267 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2280270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2280284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280303 */     // GIR_Coverage, 51024,
     /* 2280303 */     GIR_EraseRootFromParent_Done,
     /* 2280304 */   // Label 30800: @2280304
     /* 2280304 */   GIM_Try, /*On fail goto*//*Label 30801*/ GIMT_Encode4(2280349), // Rule ID 51025 //
     /* 2280309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280312 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2280315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2280329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280348 */     // GIR_Coverage, 51025,
     /* 2280348 */     GIR_EraseRootFromParent_Done,
     /* 2280349 */   // Label 30801: @2280349
     /* 2280349 */   GIM_Reject,
     /* 2280350 */ // Label 30799: @2280350
     /* 2280350 */ GIM_Reject,
     /* 2280351 */ // Label 30767: @2280351
     /* 2280351 */ GIM_Try, /*On fail goto*//*Label 30802*/ GIMT_Encode4(2280465),
     /* 2280356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2280359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2280362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280370 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280374 */   GIM_Try, /*On fail goto*//*Label 30803*/ GIMT_Encode4(2280419), // Rule ID 51036 //
     /* 2280379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280382 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2280385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2280399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280418 */     // GIR_Coverage, 51036,
     /* 2280418 */     GIR_EraseRootFromParent_Done,
     /* 2280419 */   // Label 30803: @2280419
     /* 2280419 */   GIM_Try, /*On fail goto*//*Label 30804*/ GIMT_Encode4(2280464), // Rule ID 51037 //
     /* 2280424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280427 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2280430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2280444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280463 */     // GIR_Coverage, 51037,
     /* 2280463 */     GIR_EraseRootFromParent_Done,
     /* 2280464 */   // Label 30804: @2280464
     /* 2280464 */   GIM_Reject,
     /* 2280465 */ // Label 30802: @2280465
     /* 2280465 */ GIM_Reject,
     /* 2280466 */ // Label 30768: @2280466
     /* 2280466 */ GIM_Try, /*On fail goto*//*Label 30805*/ GIMT_Encode4(2280580),
     /* 2280471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2280474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2280477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280489 */   GIM_Try, /*On fail goto*//*Label 30806*/ GIMT_Encode4(2280534), // Rule ID 51052 //
     /* 2280494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280497 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2280500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2280514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280533 */     // GIR_Coverage, 51052,
     /* 2280533 */     GIR_EraseRootFromParent_Done,
     /* 2280534 */   // Label 30806: @2280534
     /* 2280534 */   GIM_Try, /*On fail goto*//*Label 30807*/ GIMT_Encode4(2280579), // Rule ID 51053 //
     /* 2280539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280542 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2280545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2280559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280578 */     // GIR_Coverage, 51053,
     /* 2280578 */     GIR_EraseRootFromParent_Done,
     /* 2280579 */   // Label 30807: @2280579
     /* 2280579 */   GIM_Reject,
     /* 2280580 */ // Label 30805: @2280580
     /* 2280580 */ GIM_Reject,
     /* 2280581 */ // Label 30769: @2280581
     /* 2280581 */ GIM_Try, /*On fail goto*//*Label 30808*/ GIMT_Encode4(2280695),
     /* 2280586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2280589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2280592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280604 */   GIM_Try, /*On fail goto*//*Label 30809*/ GIMT_Encode4(2280649), // Rule ID 51112 //
     /* 2280609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2280612 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2280615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2280629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280648 */     // GIR_Coverage, 51112,
     /* 2280648 */     GIR_EraseRootFromParent_Done,
     /* 2280649 */   // Label 30809: @2280649
     /* 2280649 */   GIM_Try, /*On fail goto*//*Label 30810*/ GIMT_Encode4(2280694), // Rule ID 51113 //
     /* 2280654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2280657 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2280660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2280674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280693 */     // GIR_Coverage, 51113,
     /* 2280693 */     GIR_EraseRootFromParent_Done,
     /* 2280694 */   // Label 30810: @2280694
     /* 2280694 */   GIM_Reject,
     /* 2280695 */ // Label 30808: @2280695
     /* 2280695 */ GIM_Reject,
     /* 2280696 */ // Label 30770: @2280696
     /* 2280696 */ GIM_Try, /*On fail goto*//*Label 30811*/ GIMT_Encode4(2280810),
     /* 2280701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2280704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2280707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280719 */   GIM_Try, /*On fail goto*//*Label 30812*/ GIMT_Encode4(2280764), // Rule ID 51028 //
     /* 2280724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280727 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2280730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2280744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280763 */     // GIR_Coverage, 51028,
     /* 2280763 */     GIR_EraseRootFromParent_Done,
     /* 2280764 */   // Label 30812: @2280764
     /* 2280764 */   GIM_Try, /*On fail goto*//*Label 30813*/ GIMT_Encode4(2280809), // Rule ID 51029 //
     /* 2280769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280772 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2280775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2280789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280808 */     // GIR_Coverage, 51029,
     /* 2280808 */     GIR_EraseRootFromParent_Done,
     /* 2280809 */   // Label 30813: @2280809
     /* 2280809 */   GIM_Reject,
     /* 2280810 */ // Label 30811: @2280810
     /* 2280810 */ GIM_Reject,
     /* 2280811 */ // Label 30771: @2280811
     /* 2280811 */ GIM_Try, /*On fail goto*//*Label 30814*/ GIMT_Encode4(2280925),
     /* 2280816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2280819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2280822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280834 */   GIM_Try, /*On fail goto*//*Label 30815*/ GIMT_Encode4(2280879), // Rule ID 51048 //
     /* 2280839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280842 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2280845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2280859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280878 */     // GIR_Coverage, 51048,
     /* 2280878 */     GIR_EraseRootFromParent_Done,
     /* 2280879 */   // Label 30815: @2280879
     /* 2280879 */   GIM_Try, /*On fail goto*//*Label 30816*/ GIMT_Encode4(2280924), // Rule ID 51049 //
     /* 2280884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280887 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2280890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2280904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280923 */     // GIR_Coverage, 51049,
     /* 2280923 */     GIR_EraseRootFromParent_Done,
     /* 2280924 */   // Label 30816: @2280924
     /* 2280924 */   GIM_Reject,
     /* 2280925 */ // Label 30814: @2280925
     /* 2280925 */ GIM_Reject,
     /* 2280926 */ // Label 30772: @2280926
     /* 2280926 */ GIM_Try, /*On fail goto*//*Label 30817*/ GIMT_Encode4(2281040),
     /* 2280931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2280934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2280937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280949 */   GIM_Try, /*On fail goto*//*Label 30818*/ GIMT_Encode4(2280994), // Rule ID 51080 //
     /* 2280954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280957 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2280960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2280974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280993 */     // GIR_Coverage, 51080,
     /* 2280993 */     GIR_EraseRootFromParent_Done,
     /* 2280994 */   // Label 30818: @2280994
     /* 2280994 */   GIM_Try, /*On fail goto*//*Label 30819*/ GIMT_Encode4(2281039), // Rule ID 51081 //
     /* 2280999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281002 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2281005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2281019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281038 */     // GIR_Coverage, 51081,
     /* 2281038 */     GIR_EraseRootFromParent_Done,
     /* 2281039 */   // Label 30819: @2281039
     /* 2281039 */   GIM_Reject,
     /* 2281040 */ // Label 30817: @2281040
     /* 2281040 */ GIM_Reject,
     /* 2281041 */ // Label 30773: @2281041
     /* 2281041 */ GIM_Try, /*On fail goto*//*Label 30820*/ GIMT_Encode4(2281155),
     /* 2281046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2281049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2281052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281064 */   GIM_Try, /*On fail goto*//*Label 30821*/ GIMT_Encode4(2281109), // Rule ID 51116 //
     /* 2281069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2281072 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2281075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2281089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281108 */     // GIR_Coverage, 51116,
     /* 2281108 */     GIR_EraseRootFromParent_Done,
     /* 2281109 */   // Label 30821: @2281109
     /* 2281109 */   GIM_Try, /*On fail goto*//*Label 30822*/ GIMT_Encode4(2281154), // Rule ID 51117 //
     /* 2281114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2281117 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2281120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2281134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281153 */     // GIR_Coverage, 51117,
     /* 2281153 */     GIR_EraseRootFromParent_Done,
     /* 2281154 */   // Label 30822: @2281154
     /* 2281154 */   GIM_Reject,
     /* 2281155 */ // Label 30820: @2281155
     /* 2281155 */ GIM_Reject,
     /* 2281156 */ // Label 30774: @2281156
     /* 2281156 */ GIM_Try, /*On fail goto*//*Label 30823*/ GIMT_Encode4(2281270),
     /* 2281161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2281164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2281167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281179 */   GIM_Try, /*On fail goto*//*Label 30824*/ GIMT_Encode4(2281224), // Rule ID 51044 //
     /* 2281184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281187 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2281190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2281204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281223 */     // GIR_Coverage, 51044,
     /* 2281223 */     GIR_EraseRootFromParent_Done,
     /* 2281224 */   // Label 30824: @2281224
     /* 2281224 */   GIM_Try, /*On fail goto*//*Label 30825*/ GIMT_Encode4(2281269), // Rule ID 51045 //
     /* 2281229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281232 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2281235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2281249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281268 */     // GIR_Coverage, 51045,
     /* 2281268 */     GIR_EraseRootFromParent_Done,
     /* 2281269 */   // Label 30825: @2281269
     /* 2281269 */   GIM_Reject,
     /* 2281270 */ // Label 30823: @2281270
     /* 2281270 */ GIM_Reject,
     /* 2281271 */ // Label 30775: @2281271
     /* 2281271 */ GIM_Try, /*On fail goto*//*Label 30826*/ GIMT_Encode4(2281385),
     /* 2281276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2281279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2281282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281294 */   GIM_Try, /*On fail goto*//*Label 30827*/ GIMT_Encode4(2281339), // Rule ID 51068 //
     /* 2281299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281302 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2281305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2281319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281338 */     // GIR_Coverage, 51068,
     /* 2281338 */     GIR_EraseRootFromParent_Done,
     /* 2281339 */   // Label 30827: @2281339
     /* 2281339 */   GIM_Try, /*On fail goto*//*Label 30828*/ GIMT_Encode4(2281384), // Rule ID 51069 //
     /* 2281344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281347 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2281350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2281364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281383 */     // GIR_Coverage, 51069,
     /* 2281383 */     GIR_EraseRootFromParent_Done,
     /* 2281384 */   // Label 30828: @2281384
     /* 2281384 */   GIM_Reject,
     /* 2281385 */ // Label 30826: @2281385
     /* 2281385 */ GIM_Reject,
     /* 2281386 */ // Label 30776: @2281386
     /* 2281386 */ GIM_Try, /*On fail goto*//*Label 30829*/ GIMT_Encode4(2281500),
     /* 2281391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2281394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2281397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281409 */   GIM_Try, /*On fail goto*//*Label 30830*/ GIMT_Encode4(2281454), // Rule ID 51084 //
     /* 2281414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281417 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2281420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2281434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281453 */     // GIR_Coverage, 51084,
     /* 2281453 */     GIR_EraseRootFromParent_Done,
     /* 2281454 */   // Label 30830: @2281454
     /* 2281454 */   GIM_Try, /*On fail goto*//*Label 30831*/ GIMT_Encode4(2281499), // Rule ID 51085 //
     /* 2281459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281462 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2281465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2281479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281498 */     // GIR_Coverage, 51085,
     /* 2281498 */     GIR_EraseRootFromParent_Done,
     /* 2281499 */   // Label 30831: @2281499
     /* 2281499 */   GIM_Reject,
     /* 2281500 */ // Label 30829: @2281500
     /* 2281500 */ GIM_Reject,
     /* 2281501 */ // Label 30777: @2281501
     /* 2281501 */ GIM_Try, /*On fail goto*//*Label 30832*/ GIMT_Encode4(2281615),
     /* 2281506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2281509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2281512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281524 */   GIM_Try, /*On fail goto*//*Label 30833*/ GIMT_Encode4(2281569), // Rule ID 51120 //
     /* 2281529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2281532 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2281535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2281549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281568 */     // GIR_Coverage, 51120,
     /* 2281568 */     GIR_EraseRootFromParent_Done,
     /* 2281569 */   // Label 30833: @2281569
     /* 2281569 */   GIM_Try, /*On fail goto*//*Label 30834*/ GIMT_Encode4(2281614), // Rule ID 51121 //
     /* 2281574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2281577 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2281580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2281594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281613 */     // GIR_Coverage, 51121,
     /* 2281613 */     GIR_EraseRootFromParent_Done,
     /* 2281614 */   // Label 30834: @2281614
     /* 2281614 */   GIM_Reject,
     /* 2281615 */ // Label 30832: @2281615
     /* 2281615 */ GIM_Reject,
     /* 2281616 */ // Label 30778: @2281616
     /* 2281616 */ GIM_Try, /*On fail goto*//*Label 30835*/ GIMT_Encode4(2281730),
     /* 2281621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2281624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2281627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281639 */   GIM_Try, /*On fail goto*//*Label 30836*/ GIMT_Encode4(2281684), // Rule ID 51056 //
     /* 2281644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281647 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2281650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2281664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281683 */     // GIR_Coverage, 51056,
     /* 2281683 */     GIR_EraseRootFromParent_Done,
     /* 2281684 */   // Label 30836: @2281684
     /* 2281684 */   GIM_Try, /*On fail goto*//*Label 30837*/ GIMT_Encode4(2281729), // Rule ID 51057 //
     /* 2281689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281692 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2281695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2281709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281728 */     // GIR_Coverage, 51057,
     /* 2281728 */     GIR_EraseRootFromParent_Done,
     /* 2281729 */   // Label 30837: @2281729
     /* 2281729 */   GIM_Reject,
     /* 2281730 */ // Label 30835: @2281730
     /* 2281730 */ GIM_Reject,
     /* 2281731 */ // Label 30779: @2281731
     /* 2281731 */ GIM_Try, /*On fail goto*//*Label 30838*/ GIMT_Encode4(2281845),
     /* 2281736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2281739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2281742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281754 */   GIM_Try, /*On fail goto*//*Label 30839*/ GIMT_Encode4(2281799), // Rule ID 51072 //
     /* 2281759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281762 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2281765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2281779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281798 */     // GIR_Coverage, 51072,
     /* 2281798 */     GIR_EraseRootFromParent_Done,
     /* 2281799 */   // Label 30839: @2281799
     /* 2281799 */   GIM_Try, /*On fail goto*//*Label 30840*/ GIMT_Encode4(2281844), // Rule ID 51073 //
     /* 2281804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281807 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2281810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2281824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281843 */     // GIR_Coverage, 51073,
     /* 2281843 */     GIR_EraseRootFromParent_Done,
     /* 2281844 */   // Label 30840: @2281844
     /* 2281844 */   GIM_Reject,
     /* 2281845 */ // Label 30838: @2281845
     /* 2281845 */ GIM_Reject,
     /* 2281846 */ // Label 30780: @2281846
     /* 2281846 */ GIM_Try, /*On fail goto*//*Label 30841*/ GIMT_Encode4(2281960),
     /* 2281851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2281854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2281857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281869 */   GIM_Try, /*On fail goto*//*Label 30842*/ GIMT_Encode4(2281914), // Rule ID 51088 //
     /* 2281874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281877 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2281880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2281894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281913 */     // GIR_Coverage, 51088,
     /* 2281913 */     GIR_EraseRootFromParent_Done,
     /* 2281914 */   // Label 30842: @2281914
     /* 2281914 */   GIM_Try, /*On fail goto*//*Label 30843*/ GIMT_Encode4(2281959), // Rule ID 51089 //
     /* 2281919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281922 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2281925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2281939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281958 */     // GIR_Coverage, 51089,
     /* 2281958 */     GIR_EraseRootFromParent_Done,
     /* 2281959 */   // Label 30843: @2281959
     /* 2281959 */   GIM_Reject,
     /* 2281960 */ // Label 30841: @2281960
     /* 2281960 */ GIM_Reject,
     /* 2281961 */ // Label 30781: @2281961
     /* 2281961 */ GIM_Try, /*On fail goto*//*Label 30844*/ GIMT_Encode4(2282075),
     /* 2281966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2281969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2281972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281984 */   GIM_Try, /*On fail goto*//*Label 30845*/ GIMT_Encode4(2282029), // Rule ID 51060 //
     /* 2281989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281992 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2281995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2282009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282028 */     // GIR_Coverage, 51060,
     /* 2282028 */     GIR_EraseRootFromParent_Done,
     /* 2282029 */   // Label 30845: @2282029
     /* 2282029 */   GIM_Try, /*On fail goto*//*Label 30846*/ GIMT_Encode4(2282074), // Rule ID 51061 //
     /* 2282034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282037 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2282040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2282054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282073 */     // GIR_Coverage, 51061,
     /* 2282073 */     GIR_EraseRootFromParent_Done,
     /* 2282074 */   // Label 30846: @2282074
     /* 2282074 */   GIM_Reject,
     /* 2282075 */ // Label 30844: @2282075
     /* 2282075 */ GIM_Reject,
     /* 2282076 */ // Label 30782: @2282076
     /* 2282076 */ GIM_Try, /*On fail goto*//*Label 30847*/ GIMT_Encode4(2282190),
     /* 2282081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2282084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2282087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2282091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2282095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2282099 */   GIM_Try, /*On fail goto*//*Label 30848*/ GIMT_Encode4(2282144), // Rule ID 51076 //
     /* 2282104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282107 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2282110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2282124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282143 */     // GIR_Coverage, 51076,
     /* 2282143 */     GIR_EraseRootFromParent_Done,
     /* 2282144 */   // Label 30848: @2282144
     /* 2282144 */   GIM_Try, /*On fail goto*//*Label 30849*/ GIMT_Encode4(2282189), // Rule ID 51077 //
     /* 2282149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282152 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2282155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2282169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282188 */     // GIR_Coverage, 51077,
     /* 2282188 */     GIR_EraseRootFromParent_Done,
     /* 2282189 */   // Label 30849: @2282189
     /* 2282189 */   GIM_Reject,
     /* 2282190 */ // Label 30847: @2282190
     /* 2282190 */ GIM_Reject,
     /* 2282191 */ // Label 30783: @2282191
     /* 2282191 */ GIM_Try, /*On fail goto*//*Label 30850*/ GIMT_Encode4(2282305),
     /* 2282196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2282199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2282202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2282206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2282210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2282214 */   GIM_Try, /*On fail goto*//*Label 30851*/ GIMT_Encode4(2282259), // Rule ID 51064 //
     /* 2282219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282222 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2282225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2282239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282258 */     // GIR_Coverage, 51064,
     /* 2282258 */     GIR_EraseRootFromParent_Done,
     /* 2282259 */   // Label 30851: @2282259
     /* 2282259 */   GIM_Try, /*On fail goto*//*Label 30852*/ GIMT_Encode4(2282304), // Rule ID 51065 //
     /* 2282264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282267 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2282270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2282284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282303 */     // GIR_Coverage, 51065,
     /* 2282303 */     GIR_EraseRootFromParent_Done,
     /* 2282304 */   // Label 30852: @2282304
     /* 2282304 */   GIM_Reject,
     /* 2282305 */ // Label 30850: @2282305
     /* 2282305 */ GIM_Reject,
     /* 2282306 */ // Label 30784: @2282306
     /* 2282306 */ GIM_Reject,
     /* 2282307 */ // Label 52: @2282307
     /* 2282307 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30877*/ GIMT_Encode4(2285040),
     /* 2282318 */ /*GILLT_s32*//*Label 30853*/ GIMT_Encode4(2282442),
     /* 2282322 */ /*GILLT_s64*//*Label 30854*/ GIMT_Encode4(2282476), GIMT_Encode4(0),
     /* 2282330 */ /*GILLT_nxv1s8*//*Label 30855*/ GIMT_Encode4(2282510),
     /* 2282334 */ /*GILLT_nxv1s16*//*Label 30856*/ GIMT_Encode4(2282625),
     /* 2282338 */ /*GILLT_nxv1s32*//*Label 30857*/ GIMT_Encode4(2282740),
     /* 2282342 */ /*GILLT_nxv1s64*//*Label 30858*/ GIMT_Encode4(2282855), GIMT_Encode4(0),
     /* 2282350 */ /*GILLT_nxv2s8*//*Label 30859*/ GIMT_Encode4(2282970),
     /* 2282354 */ /*GILLT_nxv2s16*//*Label 30860*/ GIMT_Encode4(2283085),
     /* 2282358 */ /*GILLT_nxv2s32*//*Label 30861*/ GIMT_Encode4(2283200),
     /* 2282362 */ /*GILLT_nxv2s64*//*Label 30862*/ GIMT_Encode4(2283315), GIMT_Encode4(0),
     /* 2282370 */ /*GILLT_nxv4s8*//*Label 30863*/ GIMT_Encode4(2283430),
     /* 2282374 */ /*GILLT_nxv4s16*//*Label 30864*/ GIMT_Encode4(2283545),
     /* 2282378 */ /*GILLT_nxv4s32*//*Label 30865*/ GIMT_Encode4(2283660),
     /* 2282382 */ /*GILLT_nxv4s64*//*Label 30866*/ GIMT_Encode4(2283775), GIMT_Encode4(0),
     /* 2282390 */ /*GILLT_nxv8s8*//*Label 30867*/ GIMT_Encode4(2283890),
     /* 2282394 */ /*GILLT_nxv8s16*//*Label 30868*/ GIMT_Encode4(2284005),
     /* 2282398 */ /*GILLT_nxv8s32*//*Label 30869*/ GIMT_Encode4(2284120),
     /* 2282402 */ /*GILLT_nxv8s64*//*Label 30870*/ GIMT_Encode4(2284235), GIMT_Encode4(0),
     /* 2282410 */ /*GILLT_nxv16s8*//*Label 30871*/ GIMT_Encode4(2284350),
     /* 2282414 */ /*GILLT_nxv16s16*//*Label 30872*/ GIMT_Encode4(2284465),
     /* 2282418 */ /*GILLT_nxv16s32*//*Label 30873*/ GIMT_Encode4(2284580), GIMT_Encode4(0),
     /* 2282426 */ /*GILLT_nxv32s8*//*Label 30874*/ GIMT_Encode4(2284695),
     /* 2282430 */ /*GILLT_nxv32s16*//*Label 30875*/ GIMT_Encode4(2284810), GIMT_Encode4(0),
     /* 2282438 */ /*GILLT_nxv64s8*//*Label 30876*/ GIMT_Encode4(2284925),
     /* 2282442 */ // Label 30853: @2282442
     /* 2282442 */ GIM_Try, /*On fail goto*//*Label 30878*/ GIMT_Encode4(2282475), // Rule ID 304 //
     /* 2282447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2282450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2282453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2282456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2282460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2282464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2282468 */   // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2282468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2282473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2282474 */   // GIR_Coverage, 304,
     /* 2282474 */   GIR_Done,
     /* 2282475 */ // Label 30878: @2282475
     /* 2282475 */ GIM_Reject,
     /* 2282476 */ // Label 30854: @2282476
     /* 2282476 */ GIM_Try, /*On fail goto*//*Label 30879*/ GIMT_Encode4(2282509), // Rule ID 303 //
     /* 2282481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2282484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2282487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2282490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2282494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2282498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2282502 */   // (mulhs:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2282502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2282507 */   GIR_RootConstrainSelectedInstOperands,
     /* 2282508 */   // GIR_Coverage, 303,
     /* 2282508 */   GIR_Done,
     /* 2282509 */ // Label 30879: @2282509
     /* 2282509 */ GIM_Reject,
     /* 2282510 */ // Label 30855: @2282510
     /* 2282510 */ GIM_Try, /*On fail goto*//*Label 30880*/ GIMT_Encode4(2282624),
     /* 2282515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2282518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2282521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282533 */   GIM_Try, /*On fail goto*//*Label 30881*/ GIMT_Encode4(2282578), // Rule ID 50948 //
     /* 2282538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282541 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2282544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2282558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282577 */     // GIR_Coverage, 50948,
     /* 2282577 */     GIR_EraseRootFromParent_Done,
     /* 2282578 */   // Label 30881: @2282578
     /* 2282578 */   GIM_Try, /*On fail goto*//*Label 30882*/ GIMT_Encode4(2282623), // Rule ID 50949 //
     /* 2282583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282586 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2282589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2282603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282622 */     // GIR_Coverage, 50949,
     /* 2282622 */     GIR_EraseRootFromParent_Done,
     /* 2282623 */   // Label 30882: @2282623
     /* 2282623 */   GIM_Reject,
     /* 2282624 */ // Label 30880: @2282624
     /* 2282624 */ GIM_Reject,
     /* 2282625 */ // Label 30856: @2282625
     /* 2282625 */ GIM_Try, /*On fail goto*//*Label 30883*/ GIMT_Encode4(2282739),
     /* 2282630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2282633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2282636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282648 */   GIM_Try, /*On fail goto*//*Label 30884*/ GIMT_Encode4(2282693), // Rule ID 50960 //
     /* 2282653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282656 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2282659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2282673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282692 */     // GIR_Coverage, 50960,
     /* 2282692 */     GIR_EraseRootFromParent_Done,
     /* 2282693 */   // Label 30884: @2282693
     /* 2282693 */   GIM_Try, /*On fail goto*//*Label 30885*/ GIMT_Encode4(2282738), // Rule ID 50961 //
     /* 2282698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282701 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2282704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2282718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282737 */     // GIR_Coverage, 50961,
     /* 2282737 */     GIR_EraseRootFromParent_Done,
     /* 2282738 */   // Label 30885: @2282738
     /* 2282738 */   GIM_Reject,
     /* 2282739 */ // Label 30883: @2282739
     /* 2282739 */ GIM_Reject,
     /* 2282740 */ // Label 30857: @2282740
     /* 2282740 */ GIM_Try, /*On fail goto*//*Label 30886*/ GIMT_Encode4(2282854),
     /* 2282745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2282748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2282751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282763 */   GIM_Try, /*On fail goto*//*Label 30887*/ GIMT_Encode4(2282808), // Rule ID 50968 //
     /* 2282768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282771 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2282774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2282788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282807 */     // GIR_Coverage, 50968,
     /* 2282807 */     GIR_EraseRootFromParent_Done,
     /* 2282808 */   // Label 30887: @2282808
     /* 2282808 */   GIM_Try, /*On fail goto*//*Label 30888*/ GIMT_Encode4(2282853), // Rule ID 50969 //
     /* 2282813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282816 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2282819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2282833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282852 */     // GIR_Coverage, 50969,
     /* 2282852 */     GIR_EraseRootFromParent_Done,
     /* 2282853 */   // Label 30888: @2282853
     /* 2282853 */   GIM_Reject,
     /* 2282854 */ // Label 30886: @2282854
     /* 2282854 */ GIM_Reject,
     /* 2282855 */ // Label 30858: @2282855
     /* 2282855 */ GIM_Try, /*On fail goto*//*Label 30889*/ GIMT_Encode4(2282969),
     /* 2282860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2282863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2282866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282878 */   GIM_Try, /*On fail goto*//*Label 30890*/ GIMT_Encode4(2282923), // Rule ID 51092 //
     /* 2282883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2282886 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2282889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2282903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282922 */     // GIR_Coverage, 51092,
     /* 2282922 */     GIR_EraseRootFromParent_Done,
     /* 2282923 */   // Label 30890: @2282923
     /* 2282923 */   GIM_Try, /*On fail goto*//*Label 30891*/ GIMT_Encode4(2282968), // Rule ID 51093 //
     /* 2282928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2282931 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2282934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2282948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282967 */     // GIR_Coverage, 51093,
     /* 2282967 */     GIR_EraseRootFromParent_Done,
     /* 2282968 */   // Label 30891: @2282968
     /* 2282968 */   GIM_Reject,
     /* 2282969 */ // Label 30889: @2282969
     /* 2282969 */ GIM_Reject,
     /* 2282970 */ // Label 30859: @2282970
     /* 2282970 */ GIM_Try, /*On fail goto*//*Label 30892*/ GIMT_Encode4(2283084),
     /* 2282975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2282978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2282981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282993 */   GIM_Try, /*On fail goto*//*Label 30893*/ GIMT_Encode4(2283038), // Rule ID 50952 //
     /* 2282998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283001 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2283004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2283018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283037 */     // GIR_Coverage, 50952,
     /* 2283037 */     GIR_EraseRootFromParent_Done,
     /* 2283038 */   // Label 30893: @2283038
     /* 2283038 */   GIM_Try, /*On fail goto*//*Label 30894*/ GIMT_Encode4(2283083), // Rule ID 50953 //
     /* 2283043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283046 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2283049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2283063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283082 */     // GIR_Coverage, 50953,
     /* 2283082 */     GIR_EraseRootFromParent_Done,
     /* 2283083 */   // Label 30894: @2283083
     /* 2283083 */   GIM_Reject,
     /* 2283084 */ // Label 30892: @2283084
     /* 2283084 */ GIM_Reject,
     /* 2283085 */ // Label 30860: @2283085
     /* 2283085 */ GIM_Try, /*On fail goto*//*Label 30895*/ GIMT_Encode4(2283199),
     /* 2283090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2283093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2283096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283108 */   GIM_Try, /*On fail goto*//*Label 30896*/ GIMT_Encode4(2283153), // Rule ID 50964 //
     /* 2283113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283116 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2283119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2283133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283152 */     // GIR_Coverage, 50964,
     /* 2283152 */     GIR_EraseRootFromParent_Done,
     /* 2283153 */   // Label 30896: @2283153
     /* 2283153 */   GIM_Try, /*On fail goto*//*Label 30897*/ GIMT_Encode4(2283198), // Rule ID 50965 //
     /* 2283158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283161 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2283164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2283178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283197 */     // GIR_Coverage, 50965,
     /* 2283197 */     GIR_EraseRootFromParent_Done,
     /* 2283198 */   // Label 30897: @2283198
     /* 2283198 */   GIM_Reject,
     /* 2283199 */ // Label 30895: @2283199
     /* 2283199 */ GIM_Reject,
     /* 2283200 */ // Label 30861: @2283200
     /* 2283200 */ GIM_Try, /*On fail goto*//*Label 30898*/ GIMT_Encode4(2283314),
     /* 2283205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2283208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2283211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283223 */   GIM_Try, /*On fail goto*//*Label 30899*/ GIMT_Encode4(2283268), // Rule ID 50980 //
     /* 2283228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283231 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2283234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2283248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283267 */     // GIR_Coverage, 50980,
     /* 2283267 */     GIR_EraseRootFromParent_Done,
     /* 2283268 */   // Label 30899: @2283268
     /* 2283268 */   GIM_Try, /*On fail goto*//*Label 30900*/ GIMT_Encode4(2283313), // Rule ID 50981 //
     /* 2283273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283276 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2283279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2283293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283312 */     // GIR_Coverage, 50981,
     /* 2283312 */     GIR_EraseRootFromParent_Done,
     /* 2283313 */   // Label 30900: @2283313
     /* 2283313 */   GIM_Reject,
     /* 2283314 */ // Label 30898: @2283314
     /* 2283314 */ GIM_Reject,
     /* 2283315 */ // Label 30862: @2283315
     /* 2283315 */ GIM_Try, /*On fail goto*//*Label 30901*/ GIMT_Encode4(2283429),
     /* 2283320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2283323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2283326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283338 */   GIM_Try, /*On fail goto*//*Label 30902*/ GIMT_Encode4(2283383), // Rule ID 51096 //
     /* 2283343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2283346 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2283349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2283363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283382 */     // GIR_Coverage, 51096,
     /* 2283382 */     GIR_EraseRootFromParent_Done,
     /* 2283383 */   // Label 30902: @2283383
     /* 2283383 */   GIM_Try, /*On fail goto*//*Label 30903*/ GIMT_Encode4(2283428), // Rule ID 51097 //
     /* 2283388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2283391 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2283394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2283408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283427 */     // GIR_Coverage, 51097,
     /* 2283427 */     GIR_EraseRootFromParent_Done,
     /* 2283428 */   // Label 30903: @2283428
     /* 2283428 */   GIM_Reject,
     /* 2283429 */ // Label 30901: @2283429
     /* 2283429 */ GIM_Reject,
     /* 2283430 */ // Label 30863: @2283430
     /* 2283430 */ GIM_Try, /*On fail goto*//*Label 30904*/ GIMT_Encode4(2283544),
     /* 2283435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2283438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2283441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283453 */   GIM_Try, /*On fail goto*//*Label 30905*/ GIMT_Encode4(2283498), // Rule ID 50956 //
     /* 2283458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283461 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2283464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2283478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283497 */     // GIR_Coverage, 50956,
     /* 2283497 */     GIR_EraseRootFromParent_Done,
     /* 2283498 */   // Label 30905: @2283498
     /* 2283498 */   GIM_Try, /*On fail goto*//*Label 30906*/ GIMT_Encode4(2283543), // Rule ID 50957 //
     /* 2283503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283506 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2283509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2283523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283542 */     // GIR_Coverage, 50957,
     /* 2283542 */     GIR_EraseRootFromParent_Done,
     /* 2283543 */   // Label 30906: @2283543
     /* 2283543 */   GIM_Reject,
     /* 2283544 */ // Label 30904: @2283544
     /* 2283544 */ GIM_Reject,
     /* 2283545 */ // Label 30864: @2283545
     /* 2283545 */ GIM_Try, /*On fail goto*//*Label 30907*/ GIMT_Encode4(2283659),
     /* 2283550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2283553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2283556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283568 */   GIM_Try, /*On fail goto*//*Label 30908*/ GIMT_Encode4(2283613), // Rule ID 50976 //
     /* 2283573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283576 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2283579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2283593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283612 */     // GIR_Coverage, 50976,
     /* 2283612 */     GIR_EraseRootFromParent_Done,
     /* 2283613 */   // Label 30908: @2283613
     /* 2283613 */   GIM_Try, /*On fail goto*//*Label 30909*/ GIMT_Encode4(2283658), // Rule ID 50977 //
     /* 2283618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283621 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2283624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2283638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283657 */     // GIR_Coverage, 50977,
     /* 2283657 */     GIR_EraseRootFromParent_Done,
     /* 2283658 */   // Label 30909: @2283658
     /* 2283658 */   GIM_Reject,
     /* 2283659 */ // Label 30907: @2283659
     /* 2283659 */ GIM_Reject,
     /* 2283660 */ // Label 30865: @2283660
     /* 2283660 */ GIM_Try, /*On fail goto*//*Label 30910*/ GIMT_Encode4(2283774),
     /* 2283665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2283668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2283671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283683 */   GIM_Try, /*On fail goto*//*Label 30911*/ GIMT_Encode4(2283728), // Rule ID 51008 //
     /* 2283688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283691 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2283708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283727 */     // GIR_Coverage, 51008,
     /* 2283727 */     GIR_EraseRootFromParent_Done,
     /* 2283728 */   // Label 30911: @2283728
     /* 2283728 */   GIM_Try, /*On fail goto*//*Label 30912*/ GIMT_Encode4(2283773), // Rule ID 51009 //
     /* 2283733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283736 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2283753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283772 */     // GIR_Coverage, 51009,
     /* 2283772 */     GIR_EraseRootFromParent_Done,
     /* 2283773 */   // Label 30912: @2283773
     /* 2283773 */   GIM_Reject,
     /* 2283774 */ // Label 30910: @2283774
     /* 2283774 */ GIM_Reject,
     /* 2283775 */ // Label 30866: @2283775
     /* 2283775 */ GIM_Try, /*On fail goto*//*Label 30913*/ GIMT_Encode4(2283889),
     /* 2283780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2283783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2283786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283798 */   GIM_Try, /*On fail goto*//*Label 30914*/ GIMT_Encode4(2283843), // Rule ID 51100 //
     /* 2283803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2283806 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2283823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283842 */     // GIR_Coverage, 51100,
     /* 2283842 */     GIR_EraseRootFromParent_Done,
     /* 2283843 */   // Label 30914: @2283843
     /* 2283843 */   GIM_Try, /*On fail goto*//*Label 30915*/ GIMT_Encode4(2283888), // Rule ID 51101 //
     /* 2283848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2283851 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2283868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283887 */     // GIR_Coverage, 51101,
     /* 2283887 */     GIR_EraseRootFromParent_Done,
     /* 2283888 */   // Label 30915: @2283888
     /* 2283888 */   GIM_Reject,
     /* 2283889 */ // Label 30913: @2283889
     /* 2283889 */ GIM_Reject,
     /* 2283890 */ // Label 30867: @2283890
     /* 2283890 */ GIM_Try, /*On fail goto*//*Label 30916*/ GIMT_Encode4(2284004),
     /* 2283895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2283898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2283901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283913 */   GIM_Try, /*On fail goto*//*Label 30917*/ GIMT_Encode4(2283958), // Rule ID 50972 //
     /* 2283918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283921 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2283924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2283938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283957 */     // GIR_Coverage, 50972,
     /* 2283957 */     GIR_EraseRootFromParent_Done,
     /* 2283958 */   // Label 30917: @2283958
     /* 2283958 */   GIM_Try, /*On fail goto*//*Label 30918*/ GIMT_Encode4(2284003), // Rule ID 50973 //
     /* 2283963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283966 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2283969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2283983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284002 */     // GIR_Coverage, 50973,
     /* 2284002 */     GIR_EraseRootFromParent_Done,
     /* 2284003 */   // Label 30918: @2284003
     /* 2284003 */   GIM_Reject,
     /* 2284004 */ // Label 30916: @2284004
     /* 2284004 */ GIM_Reject,
     /* 2284005 */ // Label 30868: @2284005
     /* 2284005 */ GIM_Try, /*On fail goto*//*Label 30919*/ GIMT_Encode4(2284119),
     /* 2284010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2284013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2284016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284028 */   GIM_Try, /*On fail goto*//*Label 30920*/ GIMT_Encode4(2284073), // Rule ID 50996 //
     /* 2284033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284036 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2284039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2284053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284072 */     // GIR_Coverage, 50996,
     /* 2284072 */     GIR_EraseRootFromParent_Done,
     /* 2284073 */   // Label 30920: @2284073
     /* 2284073 */   GIM_Try, /*On fail goto*//*Label 30921*/ GIMT_Encode4(2284118), // Rule ID 50997 //
     /* 2284078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284081 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2284084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2284098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284117 */     // GIR_Coverage, 50997,
     /* 2284117 */     GIR_EraseRootFromParent_Done,
     /* 2284118 */   // Label 30921: @2284118
     /* 2284118 */   GIM_Reject,
     /* 2284119 */ // Label 30919: @2284119
     /* 2284119 */ GIM_Reject,
     /* 2284120 */ // Label 30869: @2284120
     /* 2284120 */ GIM_Try, /*On fail goto*//*Label 30922*/ GIMT_Encode4(2284234),
     /* 2284125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2284128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2284131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284143 */   GIM_Try, /*On fail goto*//*Label 30923*/ GIMT_Encode4(2284188), // Rule ID 51012 //
     /* 2284148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284151 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2284154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2284168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284187 */     // GIR_Coverage, 51012,
     /* 2284187 */     GIR_EraseRootFromParent_Done,
     /* 2284188 */   // Label 30923: @2284188
     /* 2284188 */   GIM_Try, /*On fail goto*//*Label 30924*/ GIMT_Encode4(2284233), // Rule ID 51013 //
     /* 2284193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284196 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2284199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2284213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284232 */     // GIR_Coverage, 51013,
     /* 2284232 */     GIR_EraseRootFromParent_Done,
     /* 2284233 */   // Label 30924: @2284233
     /* 2284233 */   GIM_Reject,
     /* 2284234 */ // Label 30922: @2284234
     /* 2284234 */ GIM_Reject,
     /* 2284235 */ // Label 30870: @2284235
     /* 2284235 */ GIM_Try, /*On fail goto*//*Label 30925*/ GIMT_Encode4(2284349),
     /* 2284240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2284243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2284246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284258 */   GIM_Try, /*On fail goto*//*Label 30926*/ GIMT_Encode4(2284303), // Rule ID 51104 //
     /* 2284263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2284266 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2284269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2284283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284302 */     // GIR_Coverage, 51104,
     /* 2284302 */     GIR_EraseRootFromParent_Done,
     /* 2284303 */   // Label 30926: @2284303
     /* 2284303 */   GIM_Try, /*On fail goto*//*Label 30927*/ GIMT_Encode4(2284348), // Rule ID 51105 //
     /* 2284308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2284311 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2284314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2284328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284347 */     // GIR_Coverage, 51105,
     /* 2284347 */     GIR_EraseRootFromParent_Done,
     /* 2284348 */   // Label 30927: @2284348
     /* 2284348 */   GIM_Reject,
     /* 2284349 */ // Label 30925: @2284349
     /* 2284349 */ GIM_Reject,
     /* 2284350 */ // Label 30871: @2284350
     /* 2284350 */ GIM_Try, /*On fail goto*//*Label 30928*/ GIMT_Encode4(2284464),
     /* 2284355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2284358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2284361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284373 */   GIM_Try, /*On fail goto*//*Label 30929*/ GIMT_Encode4(2284418), // Rule ID 50984 //
     /* 2284378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284381 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2284384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2284398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284417 */     // GIR_Coverage, 50984,
     /* 2284417 */     GIR_EraseRootFromParent_Done,
     /* 2284418 */   // Label 30929: @2284418
     /* 2284418 */   GIM_Try, /*On fail goto*//*Label 30930*/ GIMT_Encode4(2284463), // Rule ID 50985 //
     /* 2284423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284426 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2284429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2284443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284462 */     // GIR_Coverage, 50985,
     /* 2284462 */     GIR_EraseRootFromParent_Done,
     /* 2284463 */   // Label 30930: @2284463
     /* 2284463 */   GIM_Reject,
     /* 2284464 */ // Label 30928: @2284464
     /* 2284464 */ GIM_Reject,
     /* 2284465 */ // Label 30872: @2284465
     /* 2284465 */ GIM_Try, /*On fail goto*//*Label 30931*/ GIMT_Encode4(2284579),
     /* 2284470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2284473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2284476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284484 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284488 */   GIM_Try, /*On fail goto*//*Label 30932*/ GIMT_Encode4(2284533), // Rule ID 51000 //
     /* 2284493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284496 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2284513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284532 */     // GIR_Coverage, 51000,
     /* 2284532 */     GIR_EraseRootFromParent_Done,
     /* 2284533 */   // Label 30932: @2284533
     /* 2284533 */   GIM_Try, /*On fail goto*//*Label 30933*/ GIMT_Encode4(2284578), // Rule ID 51001 //
     /* 2284538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284541 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2284558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284577 */     // GIR_Coverage, 51001,
     /* 2284577 */     GIR_EraseRootFromParent_Done,
     /* 2284578 */   // Label 30933: @2284578
     /* 2284578 */   GIM_Reject,
     /* 2284579 */ // Label 30931: @2284579
     /* 2284579 */ GIM_Reject,
     /* 2284580 */ // Label 30873: @2284580
     /* 2284580 */ GIM_Try, /*On fail goto*//*Label 30934*/ GIMT_Encode4(2284694),
     /* 2284585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2284588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2284591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284603 */   GIM_Try, /*On fail goto*//*Label 30935*/ GIMT_Encode4(2284648), // Rule ID 51016 //
     /* 2284608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284611 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2284628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284647 */     // GIR_Coverage, 51016,
     /* 2284647 */     GIR_EraseRootFromParent_Done,
     /* 2284648 */   // Label 30935: @2284648
     /* 2284648 */   GIM_Try, /*On fail goto*//*Label 30936*/ GIMT_Encode4(2284693), // Rule ID 51017 //
     /* 2284653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284656 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2284673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284692 */     // GIR_Coverage, 51017,
     /* 2284692 */     GIR_EraseRootFromParent_Done,
     /* 2284693 */   // Label 30936: @2284693
     /* 2284693 */   GIM_Reject,
     /* 2284694 */ // Label 30934: @2284694
     /* 2284694 */ GIM_Reject,
     /* 2284695 */ // Label 30874: @2284695
     /* 2284695 */ GIM_Try, /*On fail goto*//*Label 30937*/ GIMT_Encode4(2284809),
     /* 2284700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2284703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2284706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284718 */   GIM_Try, /*On fail goto*//*Label 30938*/ GIMT_Encode4(2284763), // Rule ID 50988 //
     /* 2284723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284726 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2284729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2284743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284762 */     // GIR_Coverage, 50988,
     /* 2284762 */     GIR_EraseRootFromParent_Done,
     /* 2284763 */   // Label 30938: @2284763
     /* 2284763 */   GIM_Try, /*On fail goto*//*Label 30939*/ GIMT_Encode4(2284808), // Rule ID 50989 //
     /* 2284768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284771 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2284774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2284788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284807 */     // GIR_Coverage, 50989,
     /* 2284807 */     GIR_EraseRootFromParent_Done,
     /* 2284808 */   // Label 30939: @2284808
     /* 2284808 */   GIM_Reject,
     /* 2284809 */ // Label 30937: @2284809
     /* 2284809 */ GIM_Reject,
     /* 2284810 */ // Label 30875: @2284810
     /* 2284810 */ GIM_Try, /*On fail goto*//*Label 30940*/ GIMT_Encode4(2284924),
     /* 2284815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2284818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2284821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284833 */   GIM_Try, /*On fail goto*//*Label 30941*/ GIMT_Encode4(2284878), // Rule ID 51004 //
     /* 2284838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284841 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2284844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2284858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284877 */     // GIR_Coverage, 51004,
     /* 2284877 */     GIR_EraseRootFromParent_Done,
     /* 2284878 */   // Label 30941: @2284878
     /* 2284878 */   GIM_Try, /*On fail goto*//*Label 30942*/ GIMT_Encode4(2284923), // Rule ID 51005 //
     /* 2284883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284886 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2284889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2284903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284922 */     // GIR_Coverage, 51005,
     /* 2284922 */     GIR_EraseRootFromParent_Done,
     /* 2284923 */   // Label 30942: @2284923
     /* 2284923 */   GIM_Reject,
     /* 2284924 */ // Label 30940: @2284924
     /* 2284924 */ GIM_Reject,
     /* 2284925 */ // Label 30876: @2284925
     /* 2284925 */ GIM_Try, /*On fail goto*//*Label 30943*/ GIMT_Encode4(2285039),
     /* 2284930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2284933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2284936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284948 */   GIM_Try, /*On fail goto*//*Label 30944*/ GIMT_Encode4(2284993), // Rule ID 50992 //
     /* 2284953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284956 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2284959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2284973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284992 */     // GIR_Coverage, 50992,
     /* 2284992 */     GIR_EraseRootFromParent_Done,
     /* 2284993 */   // Label 30944: @2284993
     /* 2284993 */   GIM_Try, /*On fail goto*//*Label 30945*/ GIMT_Encode4(2285038), // Rule ID 50993 //
     /* 2284998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285001 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2285004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2285018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285037 */     // GIR_Coverage, 50993,
     /* 2285037 */     GIR_EraseRootFromParent_Done,
     /* 2285038 */   // Label 30945: @2285038
     /* 2285038 */   GIM_Reject,
     /* 2285039 */ // Label 30943: @2285039
     /* 2285039 */ GIM_Reject,
     /* 2285040 */ // Label 30877: @2285040
     /* 2285040 */ GIM_Reject,
     /* 2285041 */ // Label 53: @2285041
     /* 2285041 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30969*/ GIMT_Encode4(2287893),
     /* 2285052 */ /*GILLT_s32*//*Label 30946*/ GIMT_Encode4(2285176), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2285064 */ /*GILLT_nxv1s8*//*Label 30947*/ GIMT_Encode4(2285231),
     /* 2285068 */ /*GILLT_nxv1s16*//*Label 30948*/ GIMT_Encode4(2285352),
     /* 2285072 */ /*GILLT_nxv1s32*//*Label 30949*/ GIMT_Encode4(2285473),
     /* 2285076 */ /*GILLT_nxv1s64*//*Label 30950*/ GIMT_Encode4(2285594), GIMT_Encode4(0),
     /* 2285084 */ /*GILLT_nxv2s8*//*Label 30951*/ GIMT_Encode4(2285715),
     /* 2285088 */ /*GILLT_nxv2s16*//*Label 30952*/ GIMT_Encode4(2285836),
     /* 2285092 */ /*GILLT_nxv2s32*//*Label 30953*/ GIMT_Encode4(2285957),
     /* 2285096 */ /*GILLT_nxv2s64*//*Label 30954*/ GIMT_Encode4(2286078), GIMT_Encode4(0),
     /* 2285104 */ /*GILLT_nxv4s8*//*Label 30955*/ GIMT_Encode4(2286199),
     /* 2285108 */ /*GILLT_nxv4s16*//*Label 30956*/ GIMT_Encode4(2286320),
     /* 2285112 */ /*GILLT_nxv4s32*//*Label 30957*/ GIMT_Encode4(2286441),
     /* 2285116 */ /*GILLT_nxv4s64*//*Label 30958*/ GIMT_Encode4(2286562), GIMT_Encode4(0),
     /* 2285124 */ /*GILLT_nxv8s8*//*Label 30959*/ GIMT_Encode4(2286683),
     /* 2285128 */ /*GILLT_nxv8s16*//*Label 30960*/ GIMT_Encode4(2286804),
     /* 2285132 */ /*GILLT_nxv8s32*//*Label 30961*/ GIMT_Encode4(2286925),
     /* 2285136 */ /*GILLT_nxv8s64*//*Label 30962*/ GIMT_Encode4(2287046), GIMT_Encode4(0),
     /* 2285144 */ /*GILLT_nxv16s8*//*Label 30963*/ GIMT_Encode4(2287167),
     /* 2285148 */ /*GILLT_nxv16s16*//*Label 30964*/ GIMT_Encode4(2287288),
     /* 2285152 */ /*GILLT_nxv16s32*//*Label 30965*/ GIMT_Encode4(2287409), GIMT_Encode4(0),
     /* 2285160 */ /*GILLT_nxv32s8*//*Label 30966*/ GIMT_Encode4(2287530),
     /* 2285164 */ /*GILLT_nxv32s16*//*Label 30967*/ GIMT_Encode4(2287651), GIMT_Encode4(0),
     /* 2285172 */ /*GILLT_nxv64s8*//*Label 30968*/ GIMT_Encode4(2287772),
     /* 2285176 */ // Label 30946: @2285176
     /* 2285176 */ GIM_Try, /*On fail goto*//*Label 30970*/ GIMT_Encode4(2285230),
     /* 2285181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2285184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2285187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2285191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2285195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2285199 */   GIM_Try, /*On fail goto*//*Label 30971*/ GIMT_Encode4(2285214), // Rule ID 64580 //
     /* 2285204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2285207 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2285207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2285212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285213 */     // GIR_Coverage, 64580,
     /* 2285213 */     GIR_Done,
     /* 2285214 */   // Label 30971: @2285214
     /* 2285214 */   GIM_Try, /*On fail goto*//*Label 30972*/ GIMT_Encode4(2285229), // Rule ID 64581 //
     /* 2285219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2285222 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2285222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2285227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285228 */     // GIR_Coverage, 64581,
     /* 2285228 */     GIR_Done,
     /* 2285229 */   // Label 30972: @2285229
     /* 2285229 */   GIM_Reject,
     /* 2285230 */ // Label 30970: @2285230
     /* 2285230 */ GIM_Reject,
     /* 2285231 */ // Label 30947: @2285231
     /* 2285231 */ GIM_Try, /*On fail goto*//*Label 30973*/ GIMT_Encode4(2285351),
     /* 2285236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2285239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2285242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285254 */   GIM_Try, /*On fail goto*//*Label 30974*/ GIMT_Encode4(2285302), // Rule ID 52508 //
     /* 2285259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285262 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2285265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2285279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285301 */     // GIR_Coverage, 52508,
     /* 2285301 */     GIR_EraseRootFromParent_Done,
     /* 2285302 */   // Label 30974: @2285302
     /* 2285302 */   GIM_Try, /*On fail goto*//*Label 30975*/ GIMT_Encode4(2285350), // Rule ID 52509 //
     /* 2285307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285310 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2285313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2285327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285349 */     // GIR_Coverage, 52509,
     /* 2285349 */     GIR_EraseRootFromParent_Done,
     /* 2285350 */   // Label 30975: @2285350
     /* 2285350 */   GIM_Reject,
     /* 2285351 */ // Label 30973: @2285351
     /* 2285351 */ GIM_Reject,
     /* 2285352 */ // Label 30948: @2285352
     /* 2285352 */ GIM_Try, /*On fail goto*//*Label 30976*/ GIMT_Encode4(2285472),
     /* 2285357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2285360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2285363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285375 */   GIM_Try, /*On fail goto*//*Label 30977*/ GIMT_Encode4(2285423), // Rule ID 52520 //
     /* 2285380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285383 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2285386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2285400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285422 */     // GIR_Coverage, 52520,
     /* 2285422 */     GIR_EraseRootFromParent_Done,
     /* 2285423 */   // Label 30977: @2285423
     /* 2285423 */   GIM_Try, /*On fail goto*//*Label 30978*/ GIMT_Encode4(2285471), // Rule ID 52521 //
     /* 2285428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285431 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2285434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2285448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285470 */     // GIR_Coverage, 52521,
     /* 2285470 */     GIR_EraseRootFromParent_Done,
     /* 2285471 */   // Label 30978: @2285471
     /* 2285471 */   GIM_Reject,
     /* 2285472 */ // Label 30976: @2285472
     /* 2285472 */ GIM_Reject,
     /* 2285473 */ // Label 30949: @2285473
     /* 2285473 */ GIM_Try, /*On fail goto*//*Label 30979*/ GIMT_Encode4(2285593),
     /* 2285478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2285481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2285484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285496 */   GIM_Try, /*On fail goto*//*Label 30980*/ GIMT_Encode4(2285544), // Rule ID 52528 //
     /* 2285501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285504 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2285507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2285521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285543 */     // GIR_Coverage, 52528,
     /* 2285543 */     GIR_EraseRootFromParent_Done,
     /* 2285544 */   // Label 30980: @2285544
     /* 2285544 */   GIM_Try, /*On fail goto*//*Label 30981*/ GIMT_Encode4(2285592), // Rule ID 52529 //
     /* 2285549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285552 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2285555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2285569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285591 */     // GIR_Coverage, 52529,
     /* 2285591 */     GIR_EraseRootFromParent_Done,
     /* 2285592 */   // Label 30981: @2285592
     /* 2285592 */   GIM_Reject,
     /* 2285593 */ // Label 30979: @2285593
     /* 2285593 */ GIM_Reject,
     /* 2285594 */ // Label 30950: @2285594
     /* 2285594 */ GIM_Try, /*On fail goto*//*Label 30982*/ GIMT_Encode4(2285714),
     /* 2285599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2285602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2285605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285617 */   GIM_Try, /*On fail goto*//*Label 30983*/ GIMT_Encode4(2285665), // Rule ID 52544 //
     /* 2285622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2285625 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2285628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2285642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285664 */     // GIR_Coverage, 52544,
     /* 2285664 */     GIR_EraseRootFromParent_Done,
     /* 2285665 */   // Label 30983: @2285665
     /* 2285665 */   GIM_Try, /*On fail goto*//*Label 30984*/ GIMT_Encode4(2285713), // Rule ID 52545 //
     /* 2285670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2285673 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2285676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2285690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285712 */     // GIR_Coverage, 52545,
     /* 2285712 */     GIR_EraseRootFromParent_Done,
     /* 2285713 */   // Label 30984: @2285713
     /* 2285713 */   GIM_Reject,
     /* 2285714 */ // Label 30982: @2285714
     /* 2285714 */ GIM_Reject,
     /* 2285715 */ // Label 30951: @2285715
     /* 2285715 */ GIM_Try, /*On fail goto*//*Label 30985*/ GIMT_Encode4(2285835),
     /* 2285720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2285723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2285726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285738 */   GIM_Try, /*On fail goto*//*Label 30986*/ GIMT_Encode4(2285786), // Rule ID 52512 //
     /* 2285743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285746 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2285749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2285763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285785 */     // GIR_Coverage, 52512,
     /* 2285785 */     GIR_EraseRootFromParent_Done,
     /* 2285786 */   // Label 30986: @2285786
     /* 2285786 */   GIM_Try, /*On fail goto*//*Label 30987*/ GIMT_Encode4(2285834), // Rule ID 52513 //
     /* 2285791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285794 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2285797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2285811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285833 */     // GIR_Coverage, 52513,
     /* 2285833 */     GIR_EraseRootFromParent_Done,
     /* 2285834 */   // Label 30987: @2285834
     /* 2285834 */   GIM_Reject,
     /* 2285835 */ // Label 30985: @2285835
     /* 2285835 */ GIM_Reject,
     /* 2285836 */ // Label 30952: @2285836
     /* 2285836 */ GIM_Try, /*On fail goto*//*Label 30988*/ GIMT_Encode4(2285956),
     /* 2285841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2285844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2285847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285859 */   GIM_Try, /*On fail goto*//*Label 30989*/ GIMT_Encode4(2285907), // Rule ID 52524 //
     /* 2285864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285867 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2285870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2285884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285902 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285906 */     // GIR_Coverage, 52524,
     /* 2285906 */     GIR_EraseRootFromParent_Done,
     /* 2285907 */   // Label 30989: @2285907
     /* 2285907 */   GIM_Try, /*On fail goto*//*Label 30990*/ GIMT_Encode4(2285955), // Rule ID 52525 //
     /* 2285912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285915 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2285918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2285932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285954 */     // GIR_Coverage, 52525,
     /* 2285954 */     GIR_EraseRootFromParent_Done,
     /* 2285955 */   // Label 30990: @2285955
     /* 2285955 */   GIM_Reject,
     /* 2285956 */ // Label 30988: @2285956
     /* 2285956 */ GIM_Reject,
     /* 2285957 */ // Label 30953: @2285957
     /* 2285957 */ GIM_Try, /*On fail goto*//*Label 30991*/ GIMT_Encode4(2286077),
     /* 2285962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2285965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2285968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285980 */   GIM_Try, /*On fail goto*//*Label 30992*/ GIMT_Encode4(2286028), // Rule ID 52540 //
     /* 2285985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285988 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2285991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2286005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286027 */     // GIR_Coverage, 52540,
     /* 2286027 */     GIR_EraseRootFromParent_Done,
     /* 2286028 */   // Label 30992: @2286028
     /* 2286028 */   GIM_Try, /*On fail goto*//*Label 30993*/ GIMT_Encode4(2286076), // Rule ID 52541 //
     /* 2286033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286036 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2286039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2286053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286075 */     // GIR_Coverage, 52541,
     /* 2286075 */     GIR_EraseRootFromParent_Done,
     /* 2286076 */   // Label 30993: @2286076
     /* 2286076 */   GIM_Reject,
     /* 2286077 */ // Label 30991: @2286077
     /* 2286077 */ GIM_Reject,
     /* 2286078 */ // Label 30954: @2286078
     /* 2286078 */ GIM_Try, /*On fail goto*//*Label 30994*/ GIMT_Encode4(2286198),
     /* 2286083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2286086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2286089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286101 */   GIM_Try, /*On fail goto*//*Label 30995*/ GIMT_Encode4(2286149), // Rule ID 52584 //
     /* 2286106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2286109 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2286112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2286126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286148 */     // GIR_Coverage, 52584,
     /* 2286148 */     GIR_EraseRootFromParent_Done,
     /* 2286149 */   // Label 30995: @2286149
     /* 2286149 */   GIM_Try, /*On fail goto*//*Label 30996*/ GIMT_Encode4(2286197), // Rule ID 52585 //
     /* 2286154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2286157 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2286160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2286174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286196 */     // GIR_Coverage, 52585,
     /* 2286196 */     GIR_EraseRootFromParent_Done,
     /* 2286197 */   // Label 30996: @2286197
     /* 2286197 */   GIM_Reject,
     /* 2286198 */ // Label 30994: @2286198
     /* 2286198 */ GIM_Reject,
     /* 2286199 */ // Label 30955: @2286199
     /* 2286199 */ GIM_Try, /*On fail goto*//*Label 30997*/ GIMT_Encode4(2286319),
     /* 2286204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2286207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2286210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286222 */   GIM_Try, /*On fail goto*//*Label 30998*/ GIMT_Encode4(2286270), // Rule ID 52516 //
     /* 2286227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286230 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2286233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2286247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286269 */     // GIR_Coverage, 52516,
     /* 2286269 */     GIR_EraseRootFromParent_Done,
     /* 2286270 */   // Label 30998: @2286270
     /* 2286270 */   GIM_Try, /*On fail goto*//*Label 30999*/ GIMT_Encode4(2286318), // Rule ID 52517 //
     /* 2286275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286278 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2286281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2286295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286317 */     // GIR_Coverage, 52517,
     /* 2286317 */     GIR_EraseRootFromParent_Done,
     /* 2286318 */   // Label 30999: @2286318
     /* 2286318 */   GIM_Reject,
     /* 2286319 */ // Label 30997: @2286319
     /* 2286319 */ GIM_Reject,
     /* 2286320 */ // Label 30956: @2286320
     /* 2286320 */ GIM_Try, /*On fail goto*//*Label 31000*/ GIMT_Encode4(2286440),
     /* 2286325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2286328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2286331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286343 */   GIM_Try, /*On fail goto*//*Label 31001*/ GIMT_Encode4(2286391), // Rule ID 52536 //
     /* 2286348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286351 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2286354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2286368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286390 */     // GIR_Coverage, 52536,
     /* 2286390 */     GIR_EraseRootFromParent_Done,
     /* 2286391 */   // Label 31001: @2286391
     /* 2286391 */   GIM_Try, /*On fail goto*//*Label 31002*/ GIMT_Encode4(2286439), // Rule ID 52537 //
     /* 2286396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286399 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2286402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2286416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286438 */     // GIR_Coverage, 52537,
     /* 2286438 */     GIR_EraseRootFromParent_Done,
     /* 2286439 */   // Label 31002: @2286439
     /* 2286439 */   GIM_Reject,
     /* 2286440 */ // Label 31000: @2286440
     /* 2286440 */ GIM_Reject,
     /* 2286441 */ // Label 30957: @2286441
     /* 2286441 */ GIM_Try, /*On fail goto*//*Label 31003*/ GIMT_Encode4(2286561),
     /* 2286446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2286449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2286452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286464 */   GIM_Try, /*On fail goto*//*Label 31004*/ GIMT_Encode4(2286512), // Rule ID 52572 //
     /* 2286469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286472 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2286475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2286489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286511 */     // GIR_Coverage, 52572,
     /* 2286511 */     GIR_EraseRootFromParent_Done,
     /* 2286512 */   // Label 31004: @2286512
     /* 2286512 */   GIM_Try, /*On fail goto*//*Label 31005*/ GIMT_Encode4(2286560), // Rule ID 52573 //
     /* 2286517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286520 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2286523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2286537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286559 */     // GIR_Coverage, 52573,
     /* 2286559 */     GIR_EraseRootFromParent_Done,
     /* 2286560 */   // Label 31005: @2286560
     /* 2286560 */   GIM_Reject,
     /* 2286561 */ // Label 31003: @2286561
     /* 2286561 */ GIM_Reject,
     /* 2286562 */ // Label 30958: @2286562
     /* 2286562 */ GIM_Try, /*On fail goto*//*Label 31006*/ GIMT_Encode4(2286682),
     /* 2286567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2286570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2286573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286585 */   GIM_Try, /*On fail goto*//*Label 31007*/ GIMT_Encode4(2286633), // Rule ID 52588 //
     /* 2286590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2286593 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2286596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2286610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286632 */     // GIR_Coverage, 52588,
     /* 2286632 */     GIR_EraseRootFromParent_Done,
     /* 2286633 */   // Label 31007: @2286633
     /* 2286633 */   GIM_Try, /*On fail goto*//*Label 31008*/ GIMT_Encode4(2286681), // Rule ID 52589 //
     /* 2286638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2286641 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2286644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2286658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286680 */     // GIR_Coverage, 52589,
     /* 2286680 */     GIR_EraseRootFromParent_Done,
     /* 2286681 */   // Label 31008: @2286681
     /* 2286681 */   GIM_Reject,
     /* 2286682 */ // Label 31006: @2286682
     /* 2286682 */ GIM_Reject,
     /* 2286683 */ // Label 30959: @2286683
     /* 2286683 */ GIM_Try, /*On fail goto*//*Label 31009*/ GIMT_Encode4(2286803),
     /* 2286688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2286691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2286694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286706 */   GIM_Try, /*On fail goto*//*Label 31010*/ GIMT_Encode4(2286754), // Rule ID 52532 //
     /* 2286711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286714 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2286717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2286731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286753 */     // GIR_Coverage, 52532,
     /* 2286753 */     GIR_EraseRootFromParent_Done,
     /* 2286754 */   // Label 31010: @2286754
     /* 2286754 */   GIM_Try, /*On fail goto*//*Label 31011*/ GIMT_Encode4(2286802), // Rule ID 52533 //
     /* 2286759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286762 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2286765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2286779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286801 */     // GIR_Coverage, 52533,
     /* 2286801 */     GIR_EraseRootFromParent_Done,
     /* 2286802 */   // Label 31011: @2286802
     /* 2286802 */   GIM_Reject,
     /* 2286803 */ // Label 31009: @2286803
     /* 2286803 */ GIM_Reject,
     /* 2286804 */ // Label 30960: @2286804
     /* 2286804 */ GIM_Try, /*On fail goto*//*Label 31012*/ GIMT_Encode4(2286924),
     /* 2286809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2286812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2286815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286827 */   GIM_Try, /*On fail goto*//*Label 31013*/ GIMT_Encode4(2286875), // Rule ID 52560 //
     /* 2286832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286835 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2286838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2286852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286870 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286874 */     // GIR_Coverage, 52560,
     /* 2286874 */     GIR_EraseRootFromParent_Done,
     /* 2286875 */   // Label 31013: @2286875
     /* 2286875 */   GIM_Try, /*On fail goto*//*Label 31014*/ GIMT_Encode4(2286923), // Rule ID 52561 //
     /* 2286880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286883 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2286886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2286900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286922 */     // GIR_Coverage, 52561,
     /* 2286922 */     GIR_EraseRootFromParent_Done,
     /* 2286923 */   // Label 31014: @2286923
     /* 2286923 */   GIM_Reject,
     /* 2286924 */ // Label 31012: @2286924
     /* 2286924 */ GIM_Reject,
     /* 2286925 */ // Label 30961: @2286925
     /* 2286925 */ GIM_Try, /*On fail goto*//*Label 31015*/ GIMT_Encode4(2287045),
     /* 2286930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2286933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2286936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286948 */   GIM_Try, /*On fail goto*//*Label 31016*/ GIMT_Encode4(2286996), // Rule ID 52576 //
     /* 2286953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286956 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2286959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2286973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286995 */     // GIR_Coverage, 52576,
     /* 2286995 */     GIR_EraseRootFromParent_Done,
     /* 2286996 */   // Label 31016: @2286996
     /* 2286996 */   GIM_Try, /*On fail goto*//*Label 31017*/ GIMT_Encode4(2287044), // Rule ID 52577 //
     /* 2287001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287004 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2287007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2287021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287043 */     // GIR_Coverage, 52577,
     /* 2287043 */     GIR_EraseRootFromParent_Done,
     /* 2287044 */   // Label 31017: @2287044
     /* 2287044 */   GIM_Reject,
     /* 2287045 */ // Label 31015: @2287045
     /* 2287045 */ GIM_Reject,
     /* 2287046 */ // Label 30962: @2287046
     /* 2287046 */ GIM_Try, /*On fail goto*//*Label 31018*/ GIMT_Encode4(2287166),
     /* 2287051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2287054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2287057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287069 */   GIM_Try, /*On fail goto*//*Label 31019*/ GIMT_Encode4(2287117), // Rule ID 52592 //
     /* 2287074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2287077 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2287080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287116 */     // GIR_Coverage, 52592,
     /* 2287116 */     GIR_EraseRootFromParent_Done,
     /* 2287117 */   // Label 31019: @2287117
     /* 2287117 */   GIM_Try, /*On fail goto*//*Label 31020*/ GIMT_Encode4(2287165), // Rule ID 52593 //
     /* 2287122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2287125 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2287128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287164 */     // GIR_Coverage, 52593,
     /* 2287164 */     GIR_EraseRootFromParent_Done,
     /* 2287165 */   // Label 31020: @2287165
     /* 2287165 */   GIM_Reject,
     /* 2287166 */ // Label 31018: @2287166
     /* 2287166 */ GIM_Reject,
     /* 2287167 */ // Label 30963: @2287167
     /* 2287167 */ GIM_Try, /*On fail goto*//*Label 31021*/ GIMT_Encode4(2287287),
     /* 2287172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2287175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2287178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287190 */   GIM_Try, /*On fail goto*//*Label 31022*/ GIMT_Encode4(2287238), // Rule ID 52548 //
     /* 2287195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287198 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2287201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2287215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287237 */     // GIR_Coverage, 52548,
     /* 2287237 */     GIR_EraseRootFromParent_Done,
     /* 2287238 */   // Label 31022: @2287238
     /* 2287238 */   GIM_Try, /*On fail goto*//*Label 31023*/ GIMT_Encode4(2287286), // Rule ID 52549 //
     /* 2287243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287246 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2287249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2287263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287285 */     // GIR_Coverage, 52549,
     /* 2287285 */     GIR_EraseRootFromParent_Done,
     /* 2287286 */   // Label 31023: @2287286
     /* 2287286 */   GIM_Reject,
     /* 2287287 */ // Label 31021: @2287287
     /* 2287287 */ GIM_Reject,
     /* 2287288 */ // Label 30964: @2287288
     /* 2287288 */ GIM_Try, /*On fail goto*//*Label 31024*/ GIMT_Encode4(2287408),
     /* 2287293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2287296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2287299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287311 */   GIM_Try, /*On fail goto*//*Label 31025*/ GIMT_Encode4(2287359), // Rule ID 52564 //
     /* 2287316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287319 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2287322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2287336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287358 */     // GIR_Coverage, 52564,
     /* 2287358 */     GIR_EraseRootFromParent_Done,
     /* 2287359 */   // Label 31025: @2287359
     /* 2287359 */   GIM_Try, /*On fail goto*//*Label 31026*/ GIMT_Encode4(2287407), // Rule ID 52565 //
     /* 2287364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287367 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2287370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2287384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287406 */     // GIR_Coverage, 52565,
     /* 2287406 */     GIR_EraseRootFromParent_Done,
     /* 2287407 */   // Label 31026: @2287407
     /* 2287407 */   GIM_Reject,
     /* 2287408 */ // Label 31024: @2287408
     /* 2287408 */ GIM_Reject,
     /* 2287409 */ // Label 30965: @2287409
     /* 2287409 */ GIM_Try, /*On fail goto*//*Label 31027*/ GIMT_Encode4(2287529),
     /* 2287414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2287417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2287420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287432 */   GIM_Try, /*On fail goto*//*Label 31028*/ GIMT_Encode4(2287480), // Rule ID 52580 //
     /* 2287437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287440 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2287443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287479 */     // GIR_Coverage, 52580,
     /* 2287479 */     GIR_EraseRootFromParent_Done,
     /* 2287480 */   // Label 31028: @2287480
     /* 2287480 */   GIM_Try, /*On fail goto*//*Label 31029*/ GIMT_Encode4(2287528), // Rule ID 52581 //
     /* 2287485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287488 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2287491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287527 */     // GIR_Coverage, 52581,
     /* 2287527 */     GIR_EraseRootFromParent_Done,
     /* 2287528 */   // Label 31029: @2287528
     /* 2287528 */   GIM_Reject,
     /* 2287529 */ // Label 31027: @2287529
     /* 2287529 */ GIM_Reject,
     /* 2287530 */ // Label 30966: @2287530
     /* 2287530 */ GIM_Try, /*On fail goto*//*Label 31030*/ GIMT_Encode4(2287650),
     /* 2287535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2287538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2287541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287553 */   GIM_Try, /*On fail goto*//*Label 31031*/ GIMT_Encode4(2287601), // Rule ID 52552 //
     /* 2287558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287561 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2287564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2287578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287600 */     // GIR_Coverage, 52552,
     /* 2287600 */     GIR_EraseRootFromParent_Done,
     /* 2287601 */   // Label 31031: @2287601
     /* 2287601 */   GIM_Try, /*On fail goto*//*Label 31032*/ GIMT_Encode4(2287649), // Rule ID 52553 //
     /* 2287606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287609 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2287612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2287626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287648 */     // GIR_Coverage, 52553,
     /* 2287648 */     GIR_EraseRootFromParent_Done,
     /* 2287649 */   // Label 31032: @2287649
     /* 2287649 */   GIM_Reject,
     /* 2287650 */ // Label 31030: @2287650
     /* 2287650 */ GIM_Reject,
     /* 2287651 */ // Label 30967: @2287651
     /* 2287651 */ GIM_Try, /*On fail goto*//*Label 31033*/ GIMT_Encode4(2287771),
     /* 2287656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2287659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2287662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287674 */   GIM_Try, /*On fail goto*//*Label 31034*/ GIMT_Encode4(2287722), // Rule ID 52568 //
     /* 2287679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287682 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2287685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287721 */     // GIR_Coverage, 52568,
     /* 2287721 */     GIR_EraseRootFromParent_Done,
     /* 2287722 */   // Label 31034: @2287722
     /* 2287722 */   GIM_Try, /*On fail goto*//*Label 31035*/ GIMT_Encode4(2287770), // Rule ID 52569 //
     /* 2287727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287730 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2287733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287769 */     // GIR_Coverage, 52569,
     /* 2287769 */     GIR_EraseRootFromParent_Done,
     /* 2287770 */   // Label 31035: @2287770
     /* 2287770 */   GIM_Reject,
     /* 2287771 */ // Label 31033: @2287771
     /* 2287771 */ GIM_Reject,
     /* 2287772 */ // Label 30968: @2287772
     /* 2287772 */ GIM_Try, /*On fail goto*//*Label 31036*/ GIMT_Encode4(2287892),
     /* 2287777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2287780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2287783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287795 */   GIM_Try, /*On fail goto*//*Label 31037*/ GIMT_Encode4(2287843), // Rule ID 52556 //
     /* 2287800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287803 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2287806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287842 */     // GIR_Coverage, 52556,
     /* 2287842 */     GIR_EraseRootFromParent_Done,
     /* 2287843 */   // Label 31037: @2287843
     /* 2287843 */   GIM_Try, /*On fail goto*//*Label 31038*/ GIMT_Encode4(2287891), // Rule ID 52557 //
     /* 2287848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287851 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2287854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287890 */     // GIR_Coverage, 52557,
     /* 2287890 */     GIR_EraseRootFromParent_Done,
     /* 2287891 */   // Label 31038: @2287891
     /* 2287891 */   GIM_Reject,
     /* 2287892 */ // Label 31036: @2287892
     /* 2287892 */ GIM_Reject,
     /* 2287893 */ // Label 30969: @2287893
     /* 2287893 */ GIM_Reject,
     /* 2287894 */ // Label 54: @2287894
     /* 2287894 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31062*/ GIMT_Encode4(2290746),
     /* 2287905 */ /*GILLT_s32*//*Label 31039*/ GIMT_Encode4(2288029), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2287917 */ /*GILLT_nxv1s8*//*Label 31040*/ GIMT_Encode4(2288084),
     /* 2287921 */ /*GILLT_nxv1s16*//*Label 31041*/ GIMT_Encode4(2288205),
     /* 2287925 */ /*GILLT_nxv1s32*//*Label 31042*/ GIMT_Encode4(2288326),
     /* 2287929 */ /*GILLT_nxv1s64*//*Label 31043*/ GIMT_Encode4(2288447), GIMT_Encode4(0),
     /* 2287937 */ /*GILLT_nxv2s8*//*Label 31044*/ GIMT_Encode4(2288568),
     /* 2287941 */ /*GILLT_nxv2s16*//*Label 31045*/ GIMT_Encode4(2288689),
     /* 2287945 */ /*GILLT_nxv2s32*//*Label 31046*/ GIMT_Encode4(2288810),
     /* 2287949 */ /*GILLT_nxv2s64*//*Label 31047*/ GIMT_Encode4(2288931), GIMT_Encode4(0),
     /* 2287957 */ /*GILLT_nxv4s8*//*Label 31048*/ GIMT_Encode4(2289052),
     /* 2287961 */ /*GILLT_nxv4s16*//*Label 31049*/ GIMT_Encode4(2289173),
     /* 2287965 */ /*GILLT_nxv4s32*//*Label 31050*/ GIMT_Encode4(2289294),
     /* 2287969 */ /*GILLT_nxv4s64*//*Label 31051*/ GIMT_Encode4(2289415), GIMT_Encode4(0),
     /* 2287977 */ /*GILLT_nxv8s8*//*Label 31052*/ GIMT_Encode4(2289536),
     /* 2287981 */ /*GILLT_nxv8s16*//*Label 31053*/ GIMT_Encode4(2289657),
     /* 2287985 */ /*GILLT_nxv8s32*//*Label 31054*/ GIMT_Encode4(2289778),
     /* 2287989 */ /*GILLT_nxv8s64*//*Label 31055*/ GIMT_Encode4(2289899), GIMT_Encode4(0),
     /* 2287997 */ /*GILLT_nxv16s8*//*Label 31056*/ GIMT_Encode4(2290020),
     /* 2288001 */ /*GILLT_nxv16s16*//*Label 31057*/ GIMT_Encode4(2290141),
     /* 2288005 */ /*GILLT_nxv16s32*//*Label 31058*/ GIMT_Encode4(2290262), GIMT_Encode4(0),
     /* 2288013 */ /*GILLT_nxv32s8*//*Label 31059*/ GIMT_Encode4(2290383),
     /* 2288017 */ /*GILLT_nxv32s16*//*Label 31060*/ GIMT_Encode4(2290504), GIMT_Encode4(0),
     /* 2288025 */ /*GILLT_nxv64s8*//*Label 31061*/ GIMT_Encode4(2290625),
     /* 2288029 */ // Label 31039: @2288029
     /* 2288029 */ GIM_Try, /*On fail goto*//*Label 31063*/ GIMT_Encode4(2288083),
     /* 2288034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2288037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2288040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2288044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2288048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2288052 */   GIM_Try, /*On fail goto*//*Label 31064*/ GIMT_Encode4(2288067), // Rule ID 64578 //
     /* 2288057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2288060 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2288060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2288065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288066 */     // GIR_Coverage, 64578,
     /* 2288066 */     GIR_Done,
     /* 2288067 */   // Label 31064: @2288067
     /* 2288067 */   GIM_Try, /*On fail goto*//*Label 31065*/ GIMT_Encode4(2288082), // Rule ID 64579 //
     /* 2288072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2288075 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2288075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2288080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288081 */     // GIR_Coverage, 64579,
     /* 2288081 */     GIR_Done,
     /* 2288082 */   // Label 31065: @2288082
     /* 2288082 */   GIM_Reject,
     /* 2288083 */ // Label 31063: @2288083
     /* 2288083 */ GIM_Reject,
     /* 2288084 */ // Label 31040: @2288084
     /* 2288084 */ GIM_Try, /*On fail goto*//*Label 31066*/ GIMT_Encode4(2288204),
     /* 2288089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2288092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2288095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288107 */   GIM_Try, /*On fail goto*//*Label 31067*/ GIMT_Encode4(2288155), // Rule ID 52376 //
     /* 2288112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288115 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2288118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2288132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288154 */     // GIR_Coverage, 52376,
     /* 2288154 */     GIR_EraseRootFromParent_Done,
     /* 2288155 */   // Label 31067: @2288155
     /* 2288155 */   GIM_Try, /*On fail goto*//*Label 31068*/ GIMT_Encode4(2288203), // Rule ID 52377 //
     /* 2288160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288163 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2288166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2288180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288202 */     // GIR_Coverage, 52377,
     /* 2288202 */     GIR_EraseRootFromParent_Done,
     /* 2288203 */   // Label 31068: @2288203
     /* 2288203 */   GIM_Reject,
     /* 2288204 */ // Label 31066: @2288204
     /* 2288204 */ GIM_Reject,
     /* 2288205 */ // Label 31041: @2288205
     /* 2288205 */ GIM_Try, /*On fail goto*//*Label 31069*/ GIMT_Encode4(2288325),
     /* 2288210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2288213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2288216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288228 */   GIM_Try, /*On fail goto*//*Label 31070*/ GIMT_Encode4(2288276), // Rule ID 52388 //
     /* 2288233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288236 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2288239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2288253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288275 */     // GIR_Coverage, 52388,
     /* 2288275 */     GIR_EraseRootFromParent_Done,
     /* 2288276 */   // Label 31070: @2288276
     /* 2288276 */   GIM_Try, /*On fail goto*//*Label 31071*/ GIMT_Encode4(2288324), // Rule ID 52389 //
     /* 2288281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288284 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2288287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2288301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288323 */     // GIR_Coverage, 52389,
     /* 2288323 */     GIR_EraseRootFromParent_Done,
     /* 2288324 */   // Label 31071: @2288324
     /* 2288324 */   GIM_Reject,
     /* 2288325 */ // Label 31069: @2288325
     /* 2288325 */ GIM_Reject,
     /* 2288326 */ // Label 31042: @2288326
     /* 2288326 */ GIM_Try, /*On fail goto*//*Label 31072*/ GIMT_Encode4(2288446),
     /* 2288331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2288334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2288337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288349 */   GIM_Try, /*On fail goto*//*Label 31073*/ GIMT_Encode4(2288397), // Rule ID 52396 //
     /* 2288354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288357 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2288360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2288374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288396 */     // GIR_Coverage, 52396,
     /* 2288396 */     GIR_EraseRootFromParent_Done,
     /* 2288397 */   // Label 31073: @2288397
     /* 2288397 */   GIM_Try, /*On fail goto*//*Label 31074*/ GIMT_Encode4(2288445), // Rule ID 52397 //
     /* 2288402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288405 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2288408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2288422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288444 */     // GIR_Coverage, 52397,
     /* 2288444 */     GIR_EraseRootFromParent_Done,
     /* 2288445 */   // Label 31074: @2288445
     /* 2288445 */   GIM_Reject,
     /* 2288446 */ // Label 31072: @2288446
     /* 2288446 */ GIM_Reject,
     /* 2288447 */ // Label 31043: @2288447
     /* 2288447 */ GIM_Try, /*On fail goto*//*Label 31075*/ GIMT_Encode4(2288567),
     /* 2288452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2288458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288470 */   GIM_Try, /*On fail goto*//*Label 31076*/ GIMT_Encode4(2288518), // Rule ID 52412 //
     /* 2288475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2288478 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2288481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2288495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288517 */     // GIR_Coverage, 52412,
     /* 2288517 */     GIR_EraseRootFromParent_Done,
     /* 2288518 */   // Label 31076: @2288518
     /* 2288518 */   GIM_Try, /*On fail goto*//*Label 31077*/ GIMT_Encode4(2288566), // Rule ID 52413 //
     /* 2288523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2288526 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2288529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2288543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288565 */     // GIR_Coverage, 52413,
     /* 2288565 */     GIR_EraseRootFromParent_Done,
     /* 2288566 */   // Label 31077: @2288566
     /* 2288566 */   GIM_Reject,
     /* 2288567 */ // Label 31075: @2288567
     /* 2288567 */ GIM_Reject,
     /* 2288568 */ // Label 31044: @2288568
     /* 2288568 */ GIM_Try, /*On fail goto*//*Label 31078*/ GIMT_Encode4(2288688),
     /* 2288573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2288576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2288579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288591 */   GIM_Try, /*On fail goto*//*Label 31079*/ GIMT_Encode4(2288639), // Rule ID 52380 //
     /* 2288596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288599 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2288602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2288616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288638 */     // GIR_Coverage, 52380,
     /* 2288638 */     GIR_EraseRootFromParent_Done,
     /* 2288639 */   // Label 31079: @2288639
     /* 2288639 */   GIM_Try, /*On fail goto*//*Label 31080*/ GIMT_Encode4(2288687), // Rule ID 52381 //
     /* 2288644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288647 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2288650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2288664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288686 */     // GIR_Coverage, 52381,
     /* 2288686 */     GIR_EraseRootFromParent_Done,
     /* 2288687 */   // Label 31080: @2288687
     /* 2288687 */   GIM_Reject,
     /* 2288688 */ // Label 31078: @2288688
     /* 2288688 */ GIM_Reject,
     /* 2288689 */ // Label 31045: @2288689
     /* 2288689 */ GIM_Try, /*On fail goto*//*Label 31081*/ GIMT_Encode4(2288809),
     /* 2288694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2288697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2288700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288712 */   GIM_Try, /*On fail goto*//*Label 31082*/ GIMT_Encode4(2288760), // Rule ID 52392 //
     /* 2288717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288720 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2288723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2288737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288759 */     // GIR_Coverage, 52392,
     /* 2288759 */     GIR_EraseRootFromParent_Done,
     /* 2288760 */   // Label 31082: @2288760
     /* 2288760 */   GIM_Try, /*On fail goto*//*Label 31083*/ GIMT_Encode4(2288808), // Rule ID 52393 //
     /* 2288765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288768 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2288771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2288785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288807 */     // GIR_Coverage, 52393,
     /* 2288807 */     GIR_EraseRootFromParent_Done,
     /* 2288808 */   // Label 31083: @2288808
     /* 2288808 */   GIM_Reject,
     /* 2288809 */ // Label 31081: @2288809
     /* 2288809 */ GIM_Reject,
     /* 2288810 */ // Label 31046: @2288810
     /* 2288810 */ GIM_Try, /*On fail goto*//*Label 31084*/ GIMT_Encode4(2288930),
     /* 2288815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2288818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2288821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288833 */   GIM_Try, /*On fail goto*//*Label 31085*/ GIMT_Encode4(2288881), // Rule ID 52408 //
     /* 2288838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288841 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2288844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2288858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288880 */     // GIR_Coverage, 52408,
     /* 2288880 */     GIR_EraseRootFromParent_Done,
     /* 2288881 */   // Label 31085: @2288881
     /* 2288881 */   GIM_Try, /*On fail goto*//*Label 31086*/ GIMT_Encode4(2288929), // Rule ID 52409 //
     /* 2288886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288889 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2288892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2288906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288928 */     // GIR_Coverage, 52409,
     /* 2288928 */     GIR_EraseRootFromParent_Done,
     /* 2288929 */   // Label 31086: @2288929
     /* 2288929 */   GIM_Reject,
     /* 2288930 */ // Label 31084: @2288930
     /* 2288930 */ GIM_Reject,
     /* 2288931 */ // Label 31047: @2288931
     /* 2288931 */ GIM_Try, /*On fail goto*//*Label 31087*/ GIMT_Encode4(2289051),
     /* 2288936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2288939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2288942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288954 */   GIM_Try, /*On fail goto*//*Label 31088*/ GIMT_Encode4(2289002), // Rule ID 52452 //
     /* 2288959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2288962 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2288965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2288979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289001 */     // GIR_Coverage, 52452,
     /* 2289001 */     GIR_EraseRootFromParent_Done,
     /* 2289002 */   // Label 31088: @2289002
     /* 2289002 */   GIM_Try, /*On fail goto*//*Label 31089*/ GIMT_Encode4(2289050), // Rule ID 52453 //
     /* 2289007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2289010 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2289013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2289027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289049 */     // GIR_Coverage, 52453,
     /* 2289049 */     GIR_EraseRootFromParent_Done,
     /* 2289050 */   // Label 31089: @2289050
     /* 2289050 */   GIM_Reject,
     /* 2289051 */ // Label 31087: @2289051
     /* 2289051 */ GIM_Reject,
     /* 2289052 */ // Label 31048: @2289052
     /* 2289052 */ GIM_Try, /*On fail goto*//*Label 31090*/ GIMT_Encode4(2289172),
     /* 2289057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2289060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2289063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289075 */   GIM_Try, /*On fail goto*//*Label 31091*/ GIMT_Encode4(2289123), // Rule ID 52384 //
     /* 2289080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289083 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2289086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2289100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289122 */     // GIR_Coverage, 52384,
     /* 2289122 */     GIR_EraseRootFromParent_Done,
     /* 2289123 */   // Label 31091: @2289123
     /* 2289123 */   GIM_Try, /*On fail goto*//*Label 31092*/ GIMT_Encode4(2289171), // Rule ID 52385 //
     /* 2289128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289131 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2289134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2289148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289170 */     // GIR_Coverage, 52385,
     /* 2289170 */     GIR_EraseRootFromParent_Done,
     /* 2289171 */   // Label 31092: @2289171
     /* 2289171 */   GIM_Reject,
     /* 2289172 */ // Label 31090: @2289172
     /* 2289172 */ GIM_Reject,
     /* 2289173 */ // Label 31049: @2289173
     /* 2289173 */ GIM_Try, /*On fail goto*//*Label 31093*/ GIMT_Encode4(2289293),
     /* 2289178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2289181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2289184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289196 */   GIM_Try, /*On fail goto*//*Label 31094*/ GIMT_Encode4(2289244), // Rule ID 52404 //
     /* 2289201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289204 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2289207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2289221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289243 */     // GIR_Coverage, 52404,
     /* 2289243 */     GIR_EraseRootFromParent_Done,
     /* 2289244 */   // Label 31094: @2289244
     /* 2289244 */   GIM_Try, /*On fail goto*//*Label 31095*/ GIMT_Encode4(2289292), // Rule ID 52405 //
     /* 2289249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289252 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2289255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2289269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289291 */     // GIR_Coverage, 52405,
     /* 2289291 */     GIR_EraseRootFromParent_Done,
     /* 2289292 */   // Label 31095: @2289292
     /* 2289292 */   GIM_Reject,
     /* 2289293 */ // Label 31093: @2289293
     /* 2289293 */ GIM_Reject,
     /* 2289294 */ // Label 31050: @2289294
     /* 2289294 */ GIM_Try, /*On fail goto*//*Label 31096*/ GIMT_Encode4(2289414),
     /* 2289299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2289302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2289305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289317 */   GIM_Try, /*On fail goto*//*Label 31097*/ GIMT_Encode4(2289365), // Rule ID 52440 //
     /* 2289322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289325 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2289328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2289342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289364 */     // GIR_Coverage, 52440,
     /* 2289364 */     GIR_EraseRootFromParent_Done,
     /* 2289365 */   // Label 31097: @2289365
     /* 2289365 */   GIM_Try, /*On fail goto*//*Label 31098*/ GIMT_Encode4(2289413), // Rule ID 52441 //
     /* 2289370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289373 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2289376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2289390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289412 */     // GIR_Coverage, 52441,
     /* 2289412 */     GIR_EraseRootFromParent_Done,
     /* 2289413 */   // Label 31098: @2289413
     /* 2289413 */   GIM_Reject,
     /* 2289414 */ // Label 31096: @2289414
     /* 2289414 */ GIM_Reject,
     /* 2289415 */ // Label 31051: @2289415
     /* 2289415 */ GIM_Try, /*On fail goto*//*Label 31099*/ GIMT_Encode4(2289535),
     /* 2289420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2289423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2289426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289438 */   GIM_Try, /*On fail goto*//*Label 31100*/ GIMT_Encode4(2289486), // Rule ID 52456 //
     /* 2289443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2289446 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2289449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2289463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289485 */     // GIR_Coverage, 52456,
     /* 2289485 */     GIR_EraseRootFromParent_Done,
     /* 2289486 */   // Label 31100: @2289486
     /* 2289486 */   GIM_Try, /*On fail goto*//*Label 31101*/ GIMT_Encode4(2289534), // Rule ID 52457 //
     /* 2289491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2289494 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2289497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2289511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289533 */     // GIR_Coverage, 52457,
     /* 2289533 */     GIR_EraseRootFromParent_Done,
     /* 2289534 */   // Label 31101: @2289534
     /* 2289534 */   GIM_Reject,
     /* 2289535 */ // Label 31099: @2289535
     /* 2289535 */ GIM_Reject,
     /* 2289536 */ // Label 31052: @2289536
     /* 2289536 */ GIM_Try, /*On fail goto*//*Label 31102*/ GIMT_Encode4(2289656),
     /* 2289541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2289544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2289547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289559 */   GIM_Try, /*On fail goto*//*Label 31103*/ GIMT_Encode4(2289607), // Rule ID 52400 //
     /* 2289564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289567 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2289570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2289584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289606 */     // GIR_Coverage, 52400,
     /* 2289606 */     GIR_EraseRootFromParent_Done,
     /* 2289607 */   // Label 31103: @2289607
     /* 2289607 */   GIM_Try, /*On fail goto*//*Label 31104*/ GIMT_Encode4(2289655), // Rule ID 52401 //
     /* 2289612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289615 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2289618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2289632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289654 */     // GIR_Coverage, 52401,
     /* 2289654 */     GIR_EraseRootFromParent_Done,
     /* 2289655 */   // Label 31104: @2289655
     /* 2289655 */   GIM_Reject,
     /* 2289656 */ // Label 31102: @2289656
     /* 2289656 */ GIM_Reject,
     /* 2289657 */ // Label 31053: @2289657
     /* 2289657 */ GIM_Try, /*On fail goto*//*Label 31105*/ GIMT_Encode4(2289777),
     /* 2289662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2289665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2289668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289676 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289680 */   GIM_Try, /*On fail goto*//*Label 31106*/ GIMT_Encode4(2289728), // Rule ID 52428 //
     /* 2289685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289688 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2289691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2289705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289727 */     // GIR_Coverage, 52428,
     /* 2289727 */     GIR_EraseRootFromParent_Done,
     /* 2289728 */   // Label 31106: @2289728
     /* 2289728 */   GIM_Try, /*On fail goto*//*Label 31107*/ GIMT_Encode4(2289776), // Rule ID 52429 //
     /* 2289733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289736 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2289739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2289753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289775 */     // GIR_Coverage, 52429,
     /* 2289775 */     GIR_EraseRootFromParent_Done,
     /* 2289776 */   // Label 31107: @2289776
     /* 2289776 */   GIM_Reject,
     /* 2289777 */ // Label 31105: @2289777
     /* 2289777 */ GIM_Reject,
     /* 2289778 */ // Label 31054: @2289778
     /* 2289778 */ GIM_Try, /*On fail goto*//*Label 31108*/ GIMT_Encode4(2289898),
     /* 2289783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2289786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2289789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289801 */   GIM_Try, /*On fail goto*//*Label 31109*/ GIMT_Encode4(2289849), // Rule ID 52444 //
     /* 2289806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289809 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2289812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2289826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289848 */     // GIR_Coverage, 52444,
     /* 2289848 */     GIR_EraseRootFromParent_Done,
     /* 2289849 */   // Label 31109: @2289849
     /* 2289849 */   GIM_Try, /*On fail goto*//*Label 31110*/ GIMT_Encode4(2289897), // Rule ID 52445 //
     /* 2289854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289857 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2289860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2289874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289896 */     // GIR_Coverage, 52445,
     /* 2289896 */     GIR_EraseRootFromParent_Done,
     /* 2289897 */   // Label 31110: @2289897
     /* 2289897 */   GIM_Reject,
     /* 2289898 */ // Label 31108: @2289898
     /* 2289898 */ GIM_Reject,
     /* 2289899 */ // Label 31055: @2289899
     /* 2289899 */ GIM_Try, /*On fail goto*//*Label 31111*/ GIMT_Encode4(2290019),
     /* 2289904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2289907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2289910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289922 */   GIM_Try, /*On fail goto*//*Label 31112*/ GIMT_Encode4(2289970), // Rule ID 52460 //
     /* 2289927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2289930 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2289933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2289947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289969 */     // GIR_Coverage, 52460,
     /* 2289969 */     GIR_EraseRootFromParent_Done,
     /* 2289970 */   // Label 31112: @2289970
     /* 2289970 */   GIM_Try, /*On fail goto*//*Label 31113*/ GIMT_Encode4(2290018), // Rule ID 52461 //
     /* 2289975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2289978 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2289981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2289995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290013 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290017 */     // GIR_Coverage, 52461,
     /* 2290017 */     GIR_EraseRootFromParent_Done,
     /* 2290018 */   // Label 31113: @2290018
     /* 2290018 */   GIM_Reject,
     /* 2290019 */ // Label 31111: @2290019
     /* 2290019 */ GIM_Reject,
     /* 2290020 */ // Label 31056: @2290020
     /* 2290020 */ GIM_Try, /*On fail goto*//*Label 31114*/ GIMT_Encode4(2290140),
     /* 2290025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2290028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2290031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290043 */   GIM_Try, /*On fail goto*//*Label 31115*/ GIMT_Encode4(2290091), // Rule ID 52416 //
     /* 2290048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290051 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2290054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2290068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290090 */     // GIR_Coverage, 52416,
     /* 2290090 */     GIR_EraseRootFromParent_Done,
     /* 2290091 */   // Label 31115: @2290091
     /* 2290091 */   GIM_Try, /*On fail goto*//*Label 31116*/ GIMT_Encode4(2290139), // Rule ID 52417 //
     /* 2290096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290099 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2290102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2290116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290138 */     // GIR_Coverage, 52417,
     /* 2290138 */     GIR_EraseRootFromParent_Done,
     /* 2290139 */   // Label 31116: @2290139
     /* 2290139 */   GIM_Reject,
     /* 2290140 */ // Label 31114: @2290140
     /* 2290140 */ GIM_Reject,
     /* 2290141 */ // Label 31057: @2290141
     /* 2290141 */ GIM_Try, /*On fail goto*//*Label 31117*/ GIMT_Encode4(2290261),
     /* 2290146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2290149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2290152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290164 */   GIM_Try, /*On fail goto*//*Label 31118*/ GIMT_Encode4(2290212), // Rule ID 52432 //
     /* 2290169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290172 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2290175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2290189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290211 */     // GIR_Coverage, 52432,
     /* 2290211 */     GIR_EraseRootFromParent_Done,
     /* 2290212 */   // Label 31118: @2290212
     /* 2290212 */   GIM_Try, /*On fail goto*//*Label 31119*/ GIMT_Encode4(2290260), // Rule ID 52433 //
     /* 2290217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290220 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2290223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2290237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290259 */     // GIR_Coverage, 52433,
     /* 2290259 */     GIR_EraseRootFromParent_Done,
     /* 2290260 */   // Label 31119: @2290260
     /* 2290260 */   GIM_Reject,
     /* 2290261 */ // Label 31117: @2290261
     /* 2290261 */ GIM_Reject,
     /* 2290262 */ // Label 31058: @2290262
     /* 2290262 */ GIM_Try, /*On fail goto*//*Label 31120*/ GIMT_Encode4(2290382),
     /* 2290267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2290270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2290273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290285 */   GIM_Try, /*On fail goto*//*Label 31121*/ GIMT_Encode4(2290333), // Rule ID 52448 //
     /* 2290290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290293 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2290296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2290310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290332 */     // GIR_Coverage, 52448,
     /* 2290332 */     GIR_EraseRootFromParent_Done,
     /* 2290333 */   // Label 31121: @2290333
     /* 2290333 */   GIM_Try, /*On fail goto*//*Label 31122*/ GIMT_Encode4(2290381), // Rule ID 52449 //
     /* 2290338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290341 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2290344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2290358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290380 */     // GIR_Coverage, 52449,
     /* 2290380 */     GIR_EraseRootFromParent_Done,
     /* 2290381 */   // Label 31122: @2290381
     /* 2290381 */   GIM_Reject,
     /* 2290382 */ // Label 31120: @2290382
     /* 2290382 */ GIM_Reject,
     /* 2290383 */ // Label 31059: @2290383
     /* 2290383 */ GIM_Try, /*On fail goto*//*Label 31123*/ GIMT_Encode4(2290503),
     /* 2290388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2290391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2290394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290406 */   GIM_Try, /*On fail goto*//*Label 31124*/ GIMT_Encode4(2290454), // Rule ID 52420 //
     /* 2290411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290414 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2290417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2290431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290453 */     // GIR_Coverage, 52420,
     /* 2290453 */     GIR_EraseRootFromParent_Done,
     /* 2290454 */   // Label 31124: @2290454
     /* 2290454 */   GIM_Try, /*On fail goto*//*Label 31125*/ GIMT_Encode4(2290502), // Rule ID 52421 //
     /* 2290459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290462 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2290465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2290479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290501 */     // GIR_Coverage, 52421,
     /* 2290501 */     GIR_EraseRootFromParent_Done,
     /* 2290502 */   // Label 31125: @2290502
     /* 2290502 */   GIM_Reject,
     /* 2290503 */ // Label 31123: @2290503
     /* 2290503 */ GIM_Reject,
     /* 2290504 */ // Label 31060: @2290504
     /* 2290504 */ GIM_Try, /*On fail goto*//*Label 31126*/ GIMT_Encode4(2290624),
     /* 2290509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2290512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2290515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290523 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290527 */   GIM_Try, /*On fail goto*//*Label 31127*/ GIMT_Encode4(2290575), // Rule ID 52436 //
     /* 2290532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290535 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2290538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2290552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290574 */     // GIR_Coverage, 52436,
     /* 2290574 */     GIR_EraseRootFromParent_Done,
     /* 2290575 */   // Label 31127: @2290575
     /* 2290575 */   GIM_Try, /*On fail goto*//*Label 31128*/ GIMT_Encode4(2290623), // Rule ID 52437 //
     /* 2290580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290583 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2290586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2290600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290622 */     // GIR_Coverage, 52437,
     /* 2290622 */     GIR_EraseRootFromParent_Done,
     /* 2290623 */   // Label 31128: @2290623
     /* 2290623 */   GIM_Reject,
     /* 2290624 */ // Label 31126: @2290624
     /* 2290624 */ GIM_Reject,
     /* 2290625 */ // Label 31061: @2290625
     /* 2290625 */ GIM_Try, /*On fail goto*//*Label 31129*/ GIMT_Encode4(2290745),
     /* 2290630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2290633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2290636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290648 */   GIM_Try, /*On fail goto*//*Label 31130*/ GIMT_Encode4(2290696), // Rule ID 52424 //
     /* 2290653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290656 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2290659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2290673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290695 */     // GIR_Coverage, 52424,
     /* 2290695 */     GIR_EraseRootFromParent_Done,
     /* 2290696 */   // Label 31130: @2290696
     /* 2290696 */   GIM_Try, /*On fail goto*//*Label 31131*/ GIMT_Encode4(2290744), // Rule ID 52425 //
     /* 2290701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290704 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2290707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2290721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290743 */     // GIR_Coverage, 52425,
     /* 2290743 */     GIR_EraseRootFromParent_Done,
     /* 2290744 */   // Label 31131: @2290744
     /* 2290744 */   GIM_Reject,
     /* 2290745 */ // Label 31129: @2290745
     /* 2290745 */ GIM_Reject,
     /* 2290746 */ // Label 31062: @2290746
     /* 2290746 */ GIM_Reject,
     /* 2290747 */ // Label 55: @2290747
     /* 2290747 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31155*/ GIMT_Encode4(2293599),
     /* 2290758 */ /*GILLT_s32*//*Label 31132*/ GIMT_Encode4(2290882), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2290770 */ /*GILLT_nxv1s8*//*Label 31133*/ GIMT_Encode4(2290937),
     /* 2290774 */ /*GILLT_nxv1s16*//*Label 31134*/ GIMT_Encode4(2291058),
     /* 2290778 */ /*GILLT_nxv1s32*//*Label 31135*/ GIMT_Encode4(2291179),
     /* 2290782 */ /*GILLT_nxv1s64*//*Label 31136*/ GIMT_Encode4(2291300), GIMT_Encode4(0),
     /* 2290790 */ /*GILLT_nxv2s8*//*Label 31137*/ GIMT_Encode4(2291421),
     /* 2290794 */ /*GILLT_nxv2s16*//*Label 31138*/ GIMT_Encode4(2291542),
     /* 2290798 */ /*GILLT_nxv2s32*//*Label 31139*/ GIMT_Encode4(2291663),
     /* 2290802 */ /*GILLT_nxv2s64*//*Label 31140*/ GIMT_Encode4(2291784), GIMT_Encode4(0),
     /* 2290810 */ /*GILLT_nxv4s8*//*Label 31141*/ GIMT_Encode4(2291905),
     /* 2290814 */ /*GILLT_nxv4s16*//*Label 31142*/ GIMT_Encode4(2292026),
     /* 2290818 */ /*GILLT_nxv4s32*//*Label 31143*/ GIMT_Encode4(2292147),
     /* 2290822 */ /*GILLT_nxv4s64*//*Label 31144*/ GIMT_Encode4(2292268), GIMT_Encode4(0),
     /* 2290830 */ /*GILLT_nxv8s8*//*Label 31145*/ GIMT_Encode4(2292389),
     /* 2290834 */ /*GILLT_nxv8s16*//*Label 31146*/ GIMT_Encode4(2292510),
     /* 2290838 */ /*GILLT_nxv8s32*//*Label 31147*/ GIMT_Encode4(2292631),
     /* 2290842 */ /*GILLT_nxv8s64*//*Label 31148*/ GIMT_Encode4(2292752), GIMT_Encode4(0),
     /* 2290850 */ /*GILLT_nxv16s8*//*Label 31149*/ GIMT_Encode4(2292873),
     /* 2290854 */ /*GILLT_nxv16s16*//*Label 31150*/ GIMT_Encode4(2292994),
     /* 2290858 */ /*GILLT_nxv16s32*//*Label 31151*/ GIMT_Encode4(2293115), GIMT_Encode4(0),
     /* 2290866 */ /*GILLT_nxv32s8*//*Label 31152*/ GIMT_Encode4(2293236),
     /* 2290870 */ /*GILLT_nxv32s16*//*Label 31153*/ GIMT_Encode4(2293357), GIMT_Encode4(0),
     /* 2290878 */ /*GILLT_nxv64s8*//*Label 31154*/ GIMT_Encode4(2293478),
     /* 2290882 */ // Label 31132: @2290882
     /* 2290882 */ GIM_Try, /*On fail goto*//*Label 31156*/ GIMT_Encode4(2290936),
     /* 2290887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2290893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290905 */   GIM_Try, /*On fail goto*//*Label 31157*/ GIMT_Encode4(2290920), // Rule ID 64584 //
     /* 2290910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2290913 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2290913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2290918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290919 */     // GIR_Coverage, 64584,
     /* 2290919 */     GIR_Done,
     /* 2290920 */   // Label 31157: @2290920
     /* 2290920 */   GIM_Try, /*On fail goto*//*Label 31158*/ GIMT_Encode4(2290935), // Rule ID 64585 //
     /* 2290925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2290928 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2290928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2290933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290934 */     // GIR_Coverage, 64585,
     /* 2290934 */     GIR_Done,
     /* 2290935 */   // Label 31158: @2290935
     /* 2290935 */   GIM_Reject,
     /* 2290936 */ // Label 31156: @2290936
     /* 2290936 */ GIM_Reject,
     /* 2290937 */ // Label 31133: @2290937
     /* 2290937 */ GIM_Try, /*On fail goto*//*Label 31159*/ GIMT_Encode4(2291057),
     /* 2290942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2290945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2290948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290960 */   GIM_Try, /*On fail goto*//*Label 31160*/ GIMT_Encode4(2291008), // Rule ID 52728 //
     /* 2290965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290968 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2290971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2290985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291007 */     // GIR_Coverage, 52728,
     /* 2291007 */     GIR_EraseRootFromParent_Done,
     /* 2291008 */   // Label 31160: @2291008
     /* 2291008 */   GIM_Try, /*On fail goto*//*Label 31161*/ GIMT_Encode4(2291056), // Rule ID 52729 //
     /* 2291013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291016 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2291019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2291033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291055 */     // GIR_Coverage, 52729,
     /* 2291055 */     GIR_EraseRootFromParent_Done,
     /* 2291056 */   // Label 31161: @2291056
     /* 2291056 */   GIM_Reject,
     /* 2291057 */ // Label 31159: @2291057
     /* 2291057 */ GIM_Reject,
     /* 2291058 */ // Label 31134: @2291058
     /* 2291058 */ GIM_Try, /*On fail goto*//*Label 31162*/ GIMT_Encode4(2291178),
     /* 2291063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2291066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2291069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291081 */   GIM_Try, /*On fail goto*//*Label 31163*/ GIMT_Encode4(2291129), // Rule ID 52740 //
     /* 2291086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291089 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2291092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2291106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291128 */     // GIR_Coverage, 52740,
     /* 2291128 */     GIR_EraseRootFromParent_Done,
     /* 2291129 */   // Label 31163: @2291129
     /* 2291129 */   GIM_Try, /*On fail goto*//*Label 31164*/ GIMT_Encode4(2291177), // Rule ID 52741 //
     /* 2291134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291137 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2291140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2291154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291176 */     // GIR_Coverage, 52741,
     /* 2291176 */     GIR_EraseRootFromParent_Done,
     /* 2291177 */   // Label 31164: @2291177
     /* 2291177 */   GIM_Reject,
     /* 2291178 */ // Label 31162: @2291178
     /* 2291178 */ GIM_Reject,
     /* 2291179 */ // Label 31135: @2291179
     /* 2291179 */ GIM_Try, /*On fail goto*//*Label 31165*/ GIMT_Encode4(2291299),
     /* 2291184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2291187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2291190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291202 */   GIM_Try, /*On fail goto*//*Label 31166*/ GIMT_Encode4(2291250), // Rule ID 52748 //
     /* 2291207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291210 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2291213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2291227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291249 */     // GIR_Coverage, 52748,
     /* 2291249 */     GIR_EraseRootFromParent_Done,
     /* 2291250 */   // Label 31166: @2291250
     /* 2291250 */   GIM_Try, /*On fail goto*//*Label 31167*/ GIMT_Encode4(2291298), // Rule ID 52749 //
     /* 2291255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291258 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2291261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2291275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291297 */     // GIR_Coverage, 52749,
     /* 2291297 */     GIR_EraseRootFromParent_Done,
     /* 2291298 */   // Label 31167: @2291298
     /* 2291298 */   GIM_Reject,
     /* 2291299 */ // Label 31165: @2291299
     /* 2291299 */ GIM_Reject,
     /* 2291300 */ // Label 31136: @2291300
     /* 2291300 */ GIM_Try, /*On fail goto*//*Label 31168*/ GIMT_Encode4(2291420),
     /* 2291305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2291308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2291311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291323 */   GIM_Try, /*On fail goto*//*Label 31169*/ GIMT_Encode4(2291371), // Rule ID 52764 //
     /* 2291328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2291331 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2291334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2291348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291370 */     // GIR_Coverage, 52764,
     /* 2291370 */     GIR_EraseRootFromParent_Done,
     /* 2291371 */   // Label 31169: @2291371
     /* 2291371 */   GIM_Try, /*On fail goto*//*Label 31170*/ GIMT_Encode4(2291419), // Rule ID 52765 //
     /* 2291376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2291379 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2291382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2291396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291418 */     // GIR_Coverage, 52765,
     /* 2291418 */     GIR_EraseRootFromParent_Done,
     /* 2291419 */   // Label 31170: @2291419
     /* 2291419 */   GIM_Reject,
     /* 2291420 */ // Label 31168: @2291420
     /* 2291420 */ GIM_Reject,
     /* 2291421 */ // Label 31137: @2291421
     /* 2291421 */ GIM_Try, /*On fail goto*//*Label 31171*/ GIMT_Encode4(2291541),
     /* 2291426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2291429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2291432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291444 */   GIM_Try, /*On fail goto*//*Label 31172*/ GIMT_Encode4(2291492), // Rule ID 52732 //
     /* 2291449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291452 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2291455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2291469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291491 */     // GIR_Coverage, 52732,
     /* 2291491 */     GIR_EraseRootFromParent_Done,
     /* 2291492 */   // Label 31172: @2291492
     /* 2291492 */   GIM_Try, /*On fail goto*//*Label 31173*/ GIMT_Encode4(2291540), // Rule ID 52733 //
     /* 2291497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291500 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2291503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2291517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291539 */     // GIR_Coverage, 52733,
     /* 2291539 */     GIR_EraseRootFromParent_Done,
     /* 2291540 */   // Label 31173: @2291540
     /* 2291540 */   GIM_Reject,
     /* 2291541 */ // Label 31171: @2291541
     /* 2291541 */ GIM_Reject,
     /* 2291542 */ // Label 31138: @2291542
     /* 2291542 */ GIM_Try, /*On fail goto*//*Label 31174*/ GIMT_Encode4(2291662),
     /* 2291547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2291550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2291553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291565 */   GIM_Try, /*On fail goto*//*Label 31175*/ GIMT_Encode4(2291613), // Rule ID 52744 //
     /* 2291570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291573 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2291576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2291590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291612 */     // GIR_Coverage, 52744,
     /* 2291612 */     GIR_EraseRootFromParent_Done,
     /* 2291613 */   // Label 31175: @2291613
     /* 2291613 */   GIM_Try, /*On fail goto*//*Label 31176*/ GIMT_Encode4(2291661), // Rule ID 52745 //
     /* 2291618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291621 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2291624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2291638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291660 */     // GIR_Coverage, 52745,
     /* 2291660 */     GIR_EraseRootFromParent_Done,
     /* 2291661 */   // Label 31176: @2291661
     /* 2291661 */   GIM_Reject,
     /* 2291662 */ // Label 31174: @2291662
     /* 2291662 */ GIM_Reject,
     /* 2291663 */ // Label 31139: @2291663
     /* 2291663 */ GIM_Try, /*On fail goto*//*Label 31177*/ GIMT_Encode4(2291783),
     /* 2291668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2291671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2291674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291682 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291686 */   GIM_Try, /*On fail goto*//*Label 31178*/ GIMT_Encode4(2291734), // Rule ID 52760 //
     /* 2291691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291694 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2291697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2291711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291733 */     // GIR_Coverage, 52760,
     /* 2291733 */     GIR_EraseRootFromParent_Done,
     /* 2291734 */   // Label 31178: @2291734
     /* 2291734 */   GIM_Try, /*On fail goto*//*Label 31179*/ GIMT_Encode4(2291782), // Rule ID 52761 //
     /* 2291739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291742 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2291745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2291759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291781 */     // GIR_Coverage, 52761,
     /* 2291781 */     GIR_EraseRootFromParent_Done,
     /* 2291782 */   // Label 31179: @2291782
     /* 2291782 */   GIM_Reject,
     /* 2291783 */ // Label 31177: @2291783
     /* 2291783 */ GIM_Reject,
     /* 2291784 */ // Label 31140: @2291784
     /* 2291784 */ GIM_Try, /*On fail goto*//*Label 31180*/ GIMT_Encode4(2291904),
     /* 2291789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2291792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2291795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291807 */   GIM_Try, /*On fail goto*//*Label 31181*/ GIMT_Encode4(2291855), // Rule ID 52804 //
     /* 2291812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2291815 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2291818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2291832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291854 */     // GIR_Coverage, 52804,
     /* 2291854 */     GIR_EraseRootFromParent_Done,
     /* 2291855 */   // Label 31181: @2291855
     /* 2291855 */   GIM_Try, /*On fail goto*//*Label 31182*/ GIMT_Encode4(2291903), // Rule ID 52805 //
     /* 2291860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2291863 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2291866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2291880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291902 */     // GIR_Coverage, 52805,
     /* 2291902 */     GIR_EraseRootFromParent_Done,
     /* 2291903 */   // Label 31182: @2291903
     /* 2291903 */   GIM_Reject,
     /* 2291904 */ // Label 31180: @2291904
     /* 2291904 */ GIM_Reject,
     /* 2291905 */ // Label 31141: @2291905
     /* 2291905 */ GIM_Try, /*On fail goto*//*Label 31183*/ GIMT_Encode4(2292025),
     /* 2291910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2291913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2291916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291928 */   GIM_Try, /*On fail goto*//*Label 31184*/ GIMT_Encode4(2291976), // Rule ID 52736 //
     /* 2291933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291936 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2291939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2291953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291975 */     // GIR_Coverage, 52736,
     /* 2291975 */     GIR_EraseRootFromParent_Done,
     /* 2291976 */   // Label 31184: @2291976
     /* 2291976 */   GIM_Try, /*On fail goto*//*Label 31185*/ GIMT_Encode4(2292024), // Rule ID 52737 //
     /* 2291981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291984 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2291987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2292001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292023 */     // GIR_Coverage, 52737,
     /* 2292023 */     GIR_EraseRootFromParent_Done,
     /* 2292024 */   // Label 31185: @2292024
     /* 2292024 */   GIM_Reject,
     /* 2292025 */ // Label 31183: @2292025
     /* 2292025 */ GIM_Reject,
     /* 2292026 */ // Label 31142: @2292026
     /* 2292026 */ GIM_Try, /*On fail goto*//*Label 31186*/ GIMT_Encode4(2292146),
     /* 2292031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2292034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2292037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292049 */   GIM_Try, /*On fail goto*//*Label 31187*/ GIMT_Encode4(2292097), // Rule ID 52756 //
     /* 2292054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292057 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2292060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2292074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292096 */     // GIR_Coverage, 52756,
     /* 2292096 */     GIR_EraseRootFromParent_Done,
     /* 2292097 */   // Label 31187: @2292097
     /* 2292097 */   GIM_Try, /*On fail goto*//*Label 31188*/ GIMT_Encode4(2292145), // Rule ID 52757 //
     /* 2292102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292105 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2292108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2292122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292144 */     // GIR_Coverage, 52757,
     /* 2292144 */     GIR_EraseRootFromParent_Done,
     /* 2292145 */   // Label 31188: @2292145
     /* 2292145 */   GIM_Reject,
     /* 2292146 */ // Label 31186: @2292146
     /* 2292146 */ GIM_Reject,
     /* 2292147 */ // Label 31143: @2292147
     /* 2292147 */ GIM_Try, /*On fail goto*//*Label 31189*/ GIMT_Encode4(2292267),
     /* 2292152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2292158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292170 */   GIM_Try, /*On fail goto*//*Label 31190*/ GIMT_Encode4(2292218), // Rule ID 52792 //
     /* 2292175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292178 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2292181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2292195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292217 */     // GIR_Coverage, 52792,
     /* 2292217 */     GIR_EraseRootFromParent_Done,
     /* 2292218 */   // Label 31190: @2292218
     /* 2292218 */   GIM_Try, /*On fail goto*//*Label 31191*/ GIMT_Encode4(2292266), // Rule ID 52793 //
     /* 2292223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292226 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2292229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2292243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292265 */     // GIR_Coverage, 52793,
     /* 2292265 */     GIR_EraseRootFromParent_Done,
     /* 2292266 */   // Label 31191: @2292266
     /* 2292266 */   GIM_Reject,
     /* 2292267 */ // Label 31189: @2292267
     /* 2292267 */ GIM_Reject,
     /* 2292268 */ // Label 31144: @2292268
     /* 2292268 */ GIM_Try, /*On fail goto*//*Label 31192*/ GIMT_Encode4(2292388),
     /* 2292273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2292276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2292279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292291 */   GIM_Try, /*On fail goto*//*Label 31193*/ GIMT_Encode4(2292339), // Rule ID 52808 //
     /* 2292296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2292299 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2292302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2292316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292338 */     // GIR_Coverage, 52808,
     /* 2292338 */     GIR_EraseRootFromParent_Done,
     /* 2292339 */   // Label 31193: @2292339
     /* 2292339 */   GIM_Try, /*On fail goto*//*Label 31194*/ GIMT_Encode4(2292387), // Rule ID 52809 //
     /* 2292344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2292347 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2292350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2292364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292386 */     // GIR_Coverage, 52809,
     /* 2292386 */     GIR_EraseRootFromParent_Done,
     /* 2292387 */   // Label 31194: @2292387
     /* 2292387 */   GIM_Reject,
     /* 2292388 */ // Label 31192: @2292388
     /* 2292388 */ GIM_Reject,
     /* 2292389 */ // Label 31145: @2292389
     /* 2292389 */ GIM_Try, /*On fail goto*//*Label 31195*/ GIMT_Encode4(2292509),
     /* 2292394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2292397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2292400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292412 */   GIM_Try, /*On fail goto*//*Label 31196*/ GIMT_Encode4(2292460), // Rule ID 52752 //
     /* 2292417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292420 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2292423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2292437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292459 */     // GIR_Coverage, 52752,
     /* 2292459 */     GIR_EraseRootFromParent_Done,
     /* 2292460 */   // Label 31196: @2292460
     /* 2292460 */   GIM_Try, /*On fail goto*//*Label 31197*/ GIMT_Encode4(2292508), // Rule ID 52753 //
     /* 2292465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292468 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2292471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2292485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292507 */     // GIR_Coverage, 52753,
     /* 2292507 */     GIR_EraseRootFromParent_Done,
     /* 2292508 */   // Label 31197: @2292508
     /* 2292508 */   GIM_Reject,
     /* 2292509 */ // Label 31195: @2292509
     /* 2292509 */ GIM_Reject,
     /* 2292510 */ // Label 31146: @2292510
     /* 2292510 */ GIM_Try, /*On fail goto*//*Label 31198*/ GIMT_Encode4(2292630),
     /* 2292515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2292518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2292521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292533 */   GIM_Try, /*On fail goto*//*Label 31199*/ GIMT_Encode4(2292581), // Rule ID 52780 //
     /* 2292538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292541 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2292544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2292558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292580 */     // GIR_Coverage, 52780,
     /* 2292580 */     GIR_EraseRootFromParent_Done,
     /* 2292581 */   // Label 31199: @2292581
     /* 2292581 */   GIM_Try, /*On fail goto*//*Label 31200*/ GIMT_Encode4(2292629), // Rule ID 52781 //
     /* 2292586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292589 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2292592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2292606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292628 */     // GIR_Coverage, 52781,
     /* 2292628 */     GIR_EraseRootFromParent_Done,
     /* 2292629 */   // Label 31200: @2292629
     /* 2292629 */   GIM_Reject,
     /* 2292630 */ // Label 31198: @2292630
     /* 2292630 */ GIM_Reject,
     /* 2292631 */ // Label 31147: @2292631
     /* 2292631 */ GIM_Try, /*On fail goto*//*Label 31201*/ GIMT_Encode4(2292751),
     /* 2292636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2292639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2292642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292650 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292654 */   GIM_Try, /*On fail goto*//*Label 31202*/ GIMT_Encode4(2292702), // Rule ID 52796 //
     /* 2292659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292662 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2292665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2292679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292701 */     // GIR_Coverage, 52796,
     /* 2292701 */     GIR_EraseRootFromParent_Done,
     /* 2292702 */   // Label 31202: @2292702
     /* 2292702 */   GIM_Try, /*On fail goto*//*Label 31203*/ GIMT_Encode4(2292750), // Rule ID 52797 //
     /* 2292707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292710 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2292713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2292727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292745 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292749 */     // GIR_Coverage, 52797,
     /* 2292749 */     GIR_EraseRootFromParent_Done,
     /* 2292750 */   // Label 31203: @2292750
     /* 2292750 */   GIM_Reject,
     /* 2292751 */ // Label 31201: @2292751
     /* 2292751 */ GIM_Reject,
     /* 2292752 */ // Label 31148: @2292752
     /* 2292752 */ GIM_Try, /*On fail goto*//*Label 31204*/ GIMT_Encode4(2292872),
     /* 2292757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2292760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2292763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292775 */   GIM_Try, /*On fail goto*//*Label 31205*/ GIMT_Encode4(2292823), // Rule ID 52812 //
     /* 2292780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2292783 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2292786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2292800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292822 */     // GIR_Coverage, 52812,
     /* 2292822 */     GIR_EraseRootFromParent_Done,
     /* 2292823 */   // Label 31205: @2292823
     /* 2292823 */   GIM_Try, /*On fail goto*//*Label 31206*/ GIMT_Encode4(2292871), // Rule ID 52813 //
     /* 2292828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2292831 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2292834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2292848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292870 */     // GIR_Coverage, 52813,
     /* 2292870 */     GIR_EraseRootFromParent_Done,
     /* 2292871 */   // Label 31206: @2292871
     /* 2292871 */   GIM_Reject,
     /* 2292872 */ // Label 31204: @2292872
     /* 2292872 */ GIM_Reject,
     /* 2292873 */ // Label 31149: @2292873
     /* 2292873 */ GIM_Try, /*On fail goto*//*Label 31207*/ GIMT_Encode4(2292993),
     /* 2292878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2292881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2292884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292896 */   GIM_Try, /*On fail goto*//*Label 31208*/ GIMT_Encode4(2292944), // Rule ID 52768 //
     /* 2292901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292904 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2292907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2292921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292943 */     // GIR_Coverage, 52768,
     /* 2292943 */     GIR_EraseRootFromParent_Done,
     /* 2292944 */   // Label 31208: @2292944
     /* 2292944 */   GIM_Try, /*On fail goto*//*Label 31209*/ GIMT_Encode4(2292992), // Rule ID 52769 //
     /* 2292949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292952 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2292955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2292969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292991 */     // GIR_Coverage, 52769,
     /* 2292991 */     GIR_EraseRootFromParent_Done,
     /* 2292992 */   // Label 31209: @2292992
     /* 2292992 */   GIM_Reject,
     /* 2292993 */ // Label 31207: @2292993
     /* 2292993 */ GIM_Reject,
     /* 2292994 */ // Label 31150: @2292994
     /* 2292994 */ GIM_Try, /*On fail goto*//*Label 31210*/ GIMT_Encode4(2293114),
     /* 2292999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2293002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2293005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293017 */   GIM_Try, /*On fail goto*//*Label 31211*/ GIMT_Encode4(2293065), // Rule ID 52784 //
     /* 2293022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293025 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2293028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2293042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293064 */     // GIR_Coverage, 52784,
     /* 2293064 */     GIR_EraseRootFromParent_Done,
     /* 2293065 */   // Label 31211: @2293065
     /* 2293065 */   GIM_Try, /*On fail goto*//*Label 31212*/ GIMT_Encode4(2293113), // Rule ID 52785 //
     /* 2293070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293073 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2293076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2293090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293112 */     // GIR_Coverage, 52785,
     /* 2293112 */     GIR_EraseRootFromParent_Done,
     /* 2293113 */   // Label 31212: @2293113
     /* 2293113 */   GIM_Reject,
     /* 2293114 */ // Label 31210: @2293114
     /* 2293114 */ GIM_Reject,
     /* 2293115 */ // Label 31151: @2293115
     /* 2293115 */ GIM_Try, /*On fail goto*//*Label 31213*/ GIMT_Encode4(2293235),
     /* 2293120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2293123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2293126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293138 */   GIM_Try, /*On fail goto*//*Label 31214*/ GIMT_Encode4(2293186), // Rule ID 52800 //
     /* 2293143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293146 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2293149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2293163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293185 */     // GIR_Coverage, 52800,
     /* 2293185 */     GIR_EraseRootFromParent_Done,
     /* 2293186 */   // Label 31214: @2293186
     /* 2293186 */   GIM_Try, /*On fail goto*//*Label 31215*/ GIMT_Encode4(2293234), // Rule ID 52801 //
     /* 2293191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293194 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2293197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2293211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293233 */     // GIR_Coverage, 52801,
     /* 2293233 */     GIR_EraseRootFromParent_Done,
     /* 2293234 */   // Label 31215: @2293234
     /* 2293234 */   GIM_Reject,
     /* 2293235 */ // Label 31213: @2293235
     /* 2293235 */ GIM_Reject,
     /* 2293236 */ // Label 31152: @2293236
     /* 2293236 */ GIM_Try, /*On fail goto*//*Label 31216*/ GIMT_Encode4(2293356),
     /* 2293241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2293244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2293247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293259 */   GIM_Try, /*On fail goto*//*Label 31217*/ GIMT_Encode4(2293307), // Rule ID 52772 //
     /* 2293264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293267 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2293270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2293284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293306 */     // GIR_Coverage, 52772,
     /* 2293306 */     GIR_EraseRootFromParent_Done,
     /* 2293307 */   // Label 31217: @2293307
     /* 2293307 */   GIM_Try, /*On fail goto*//*Label 31218*/ GIMT_Encode4(2293355), // Rule ID 52773 //
     /* 2293312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293315 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2293318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2293332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293354 */     // GIR_Coverage, 52773,
     /* 2293354 */     GIR_EraseRootFromParent_Done,
     /* 2293355 */   // Label 31218: @2293355
     /* 2293355 */   GIM_Reject,
     /* 2293356 */ // Label 31216: @2293356
     /* 2293356 */ GIM_Reject,
     /* 2293357 */ // Label 31153: @2293357
     /* 2293357 */ GIM_Try, /*On fail goto*//*Label 31219*/ GIMT_Encode4(2293477),
     /* 2293362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2293365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2293368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293380 */   GIM_Try, /*On fail goto*//*Label 31220*/ GIMT_Encode4(2293428), // Rule ID 52788 //
     /* 2293385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293388 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2293391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2293405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293427 */     // GIR_Coverage, 52788,
     /* 2293427 */     GIR_EraseRootFromParent_Done,
     /* 2293428 */   // Label 31220: @2293428
     /* 2293428 */   GIM_Try, /*On fail goto*//*Label 31221*/ GIMT_Encode4(2293476), // Rule ID 52789 //
     /* 2293433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293436 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2293439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2293453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293475 */     // GIR_Coverage, 52789,
     /* 2293475 */     GIR_EraseRootFromParent_Done,
     /* 2293476 */   // Label 31221: @2293476
     /* 2293476 */   GIM_Reject,
     /* 2293477 */ // Label 31219: @2293477
     /* 2293477 */ GIM_Reject,
     /* 2293478 */ // Label 31154: @2293478
     /* 2293478 */ GIM_Try, /*On fail goto*//*Label 31222*/ GIMT_Encode4(2293598),
     /* 2293483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2293486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2293489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293497 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293501 */   GIM_Try, /*On fail goto*//*Label 31223*/ GIMT_Encode4(2293549), // Rule ID 52776 //
     /* 2293506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293509 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2293512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2293526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293548 */     // GIR_Coverage, 52776,
     /* 2293548 */     GIR_EraseRootFromParent_Done,
     /* 2293549 */   // Label 31223: @2293549
     /* 2293549 */   GIM_Try, /*On fail goto*//*Label 31224*/ GIMT_Encode4(2293597), // Rule ID 52777 //
     /* 2293554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293557 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2293560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2293574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293596 */     // GIR_Coverage, 52777,
     /* 2293596 */     GIR_EraseRootFromParent_Done,
     /* 2293597 */   // Label 31224: @2293597
     /* 2293597 */   GIM_Reject,
     /* 2293598 */ // Label 31222: @2293598
     /* 2293598 */ GIM_Reject,
     /* 2293599 */ // Label 31155: @2293599
     /* 2293599 */ GIM_Reject,
     /* 2293600 */ // Label 56: @2293600
     /* 2293600 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31248*/ GIMT_Encode4(2296452),
     /* 2293611 */ /*GILLT_s32*//*Label 31225*/ GIMT_Encode4(2293735), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2293623 */ /*GILLT_nxv1s8*//*Label 31226*/ GIMT_Encode4(2293790),
     /* 2293627 */ /*GILLT_nxv1s16*//*Label 31227*/ GIMT_Encode4(2293911),
     /* 2293631 */ /*GILLT_nxv1s32*//*Label 31228*/ GIMT_Encode4(2294032),
     /* 2293635 */ /*GILLT_nxv1s64*//*Label 31229*/ GIMT_Encode4(2294153), GIMT_Encode4(0),
     /* 2293643 */ /*GILLT_nxv2s8*//*Label 31230*/ GIMT_Encode4(2294274),
     /* 2293647 */ /*GILLT_nxv2s16*//*Label 31231*/ GIMT_Encode4(2294395),
     /* 2293651 */ /*GILLT_nxv2s32*//*Label 31232*/ GIMT_Encode4(2294516),
     /* 2293655 */ /*GILLT_nxv2s64*//*Label 31233*/ GIMT_Encode4(2294637), GIMT_Encode4(0),
     /* 2293663 */ /*GILLT_nxv4s8*//*Label 31234*/ GIMT_Encode4(2294758),
     /* 2293667 */ /*GILLT_nxv4s16*//*Label 31235*/ GIMT_Encode4(2294879),
     /* 2293671 */ /*GILLT_nxv4s32*//*Label 31236*/ GIMT_Encode4(2295000),
     /* 2293675 */ /*GILLT_nxv4s64*//*Label 31237*/ GIMT_Encode4(2295121), GIMT_Encode4(0),
     /* 2293683 */ /*GILLT_nxv8s8*//*Label 31238*/ GIMT_Encode4(2295242),
     /* 2293687 */ /*GILLT_nxv8s16*//*Label 31239*/ GIMT_Encode4(2295363),
     /* 2293691 */ /*GILLT_nxv8s32*//*Label 31240*/ GIMT_Encode4(2295484),
     /* 2293695 */ /*GILLT_nxv8s64*//*Label 31241*/ GIMT_Encode4(2295605), GIMT_Encode4(0),
     /* 2293703 */ /*GILLT_nxv16s8*//*Label 31242*/ GIMT_Encode4(2295726),
     /* 2293707 */ /*GILLT_nxv16s16*//*Label 31243*/ GIMT_Encode4(2295847),
     /* 2293711 */ /*GILLT_nxv16s32*//*Label 31244*/ GIMT_Encode4(2295968), GIMT_Encode4(0),
     /* 2293719 */ /*GILLT_nxv32s8*//*Label 31245*/ GIMT_Encode4(2296089),
     /* 2293723 */ /*GILLT_nxv32s16*//*Label 31246*/ GIMT_Encode4(2296210), GIMT_Encode4(0),
     /* 2293731 */ /*GILLT_nxv64s8*//*Label 31247*/ GIMT_Encode4(2296331),
     /* 2293735 */ // Label 31225: @2293735
     /* 2293735 */ GIM_Try, /*On fail goto*//*Label 31249*/ GIMT_Encode4(2293789),
     /* 2293740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2293743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2293746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2293750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2293754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2293758 */   GIM_Try, /*On fail goto*//*Label 31250*/ GIMT_Encode4(2293773), // Rule ID 64582 //
     /* 2293763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2293766 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2293766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2293771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293772 */     // GIR_Coverage, 64582,
     /* 2293772 */     GIR_Done,
     /* 2293773 */   // Label 31250: @2293773
     /* 2293773 */   GIM_Try, /*On fail goto*//*Label 31251*/ GIMT_Encode4(2293788), // Rule ID 64583 //
     /* 2293778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2293781 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2293781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2293786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293787 */     // GIR_Coverage, 64583,
     /* 2293787 */     GIR_Done,
     /* 2293788 */   // Label 31251: @2293788
     /* 2293788 */   GIM_Reject,
     /* 2293789 */ // Label 31249: @2293789
     /* 2293789 */ GIM_Reject,
     /* 2293790 */ // Label 31226: @2293790
     /* 2293790 */ GIM_Try, /*On fail goto*//*Label 31252*/ GIMT_Encode4(2293910),
     /* 2293795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2293798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2293801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293813 */   GIM_Try, /*On fail goto*//*Label 31253*/ GIMT_Encode4(2293861), // Rule ID 52640 //
     /* 2293818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293821 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2293824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2293838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293860 */     // GIR_Coverage, 52640,
     /* 2293860 */     GIR_EraseRootFromParent_Done,
     /* 2293861 */   // Label 31253: @2293861
     /* 2293861 */   GIM_Try, /*On fail goto*//*Label 31254*/ GIMT_Encode4(2293909), // Rule ID 52641 //
     /* 2293866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293869 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2293872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2293886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293908 */     // GIR_Coverage, 52641,
     /* 2293908 */     GIR_EraseRootFromParent_Done,
     /* 2293909 */   // Label 31254: @2293909
     /* 2293909 */   GIM_Reject,
     /* 2293910 */ // Label 31252: @2293910
     /* 2293910 */ GIM_Reject,
     /* 2293911 */ // Label 31227: @2293911
     /* 2293911 */ GIM_Try, /*On fail goto*//*Label 31255*/ GIMT_Encode4(2294031),
     /* 2293916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2293922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293934 */   GIM_Try, /*On fail goto*//*Label 31256*/ GIMT_Encode4(2293982), // Rule ID 52652 //
     /* 2293939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293942 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2293945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2293959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293981 */     // GIR_Coverage, 52652,
     /* 2293981 */     GIR_EraseRootFromParent_Done,
     /* 2293982 */   // Label 31256: @2293982
     /* 2293982 */   GIM_Try, /*On fail goto*//*Label 31257*/ GIMT_Encode4(2294030), // Rule ID 52653 //
     /* 2293987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293990 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2293993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2294007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294029 */     // GIR_Coverage, 52653,
     /* 2294029 */     GIR_EraseRootFromParent_Done,
     /* 2294030 */   // Label 31257: @2294030
     /* 2294030 */   GIM_Reject,
     /* 2294031 */ // Label 31255: @2294031
     /* 2294031 */ GIM_Reject,
     /* 2294032 */ // Label 31228: @2294032
     /* 2294032 */ GIM_Try, /*On fail goto*//*Label 31258*/ GIMT_Encode4(2294152),
     /* 2294037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2294040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2294043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294055 */   GIM_Try, /*On fail goto*//*Label 31259*/ GIMT_Encode4(2294103), // Rule ID 52660 //
     /* 2294060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294063 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2294066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2294080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294102 */     // GIR_Coverage, 52660,
     /* 2294102 */     GIR_EraseRootFromParent_Done,
     /* 2294103 */   // Label 31259: @2294103
     /* 2294103 */   GIM_Try, /*On fail goto*//*Label 31260*/ GIMT_Encode4(2294151), // Rule ID 52661 //
     /* 2294108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294111 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2294114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2294128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294150 */     // GIR_Coverage, 52661,
     /* 2294150 */     GIR_EraseRootFromParent_Done,
     /* 2294151 */   // Label 31260: @2294151
     /* 2294151 */   GIM_Reject,
     /* 2294152 */ // Label 31258: @2294152
     /* 2294152 */ GIM_Reject,
     /* 2294153 */ // Label 31229: @2294153
     /* 2294153 */ GIM_Try, /*On fail goto*//*Label 31261*/ GIMT_Encode4(2294273),
     /* 2294158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2294164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294176 */   GIM_Try, /*On fail goto*//*Label 31262*/ GIMT_Encode4(2294224), // Rule ID 52676 //
     /* 2294181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2294184 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2294187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2294201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294223 */     // GIR_Coverage, 52676,
     /* 2294223 */     GIR_EraseRootFromParent_Done,
     /* 2294224 */   // Label 31262: @2294224
     /* 2294224 */   GIM_Try, /*On fail goto*//*Label 31263*/ GIMT_Encode4(2294272), // Rule ID 52677 //
     /* 2294229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2294232 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2294235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2294249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294271 */     // GIR_Coverage, 52677,
     /* 2294271 */     GIR_EraseRootFromParent_Done,
     /* 2294272 */   // Label 31263: @2294272
     /* 2294272 */   GIM_Reject,
     /* 2294273 */ // Label 31261: @2294273
     /* 2294273 */ GIM_Reject,
     /* 2294274 */ // Label 31230: @2294274
     /* 2294274 */ GIM_Try, /*On fail goto*//*Label 31264*/ GIMT_Encode4(2294394),
     /* 2294279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2294282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2294285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294297 */   GIM_Try, /*On fail goto*//*Label 31265*/ GIMT_Encode4(2294345), // Rule ID 52644 //
     /* 2294302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294305 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2294308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2294322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294344 */     // GIR_Coverage, 52644,
     /* 2294344 */     GIR_EraseRootFromParent_Done,
     /* 2294345 */   // Label 31265: @2294345
     /* 2294345 */   GIM_Try, /*On fail goto*//*Label 31266*/ GIMT_Encode4(2294393), // Rule ID 52645 //
     /* 2294350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294353 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2294356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2294370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294392 */     // GIR_Coverage, 52645,
     /* 2294392 */     GIR_EraseRootFromParent_Done,
     /* 2294393 */   // Label 31266: @2294393
     /* 2294393 */   GIM_Reject,
     /* 2294394 */ // Label 31264: @2294394
     /* 2294394 */ GIM_Reject,
     /* 2294395 */ // Label 31231: @2294395
     /* 2294395 */ GIM_Try, /*On fail goto*//*Label 31267*/ GIMT_Encode4(2294515),
     /* 2294400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2294403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2294406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294418 */   GIM_Try, /*On fail goto*//*Label 31268*/ GIMT_Encode4(2294466), // Rule ID 52656 //
     /* 2294423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294426 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2294429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2294443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294465 */     // GIR_Coverage, 52656,
     /* 2294465 */     GIR_EraseRootFromParent_Done,
     /* 2294466 */   // Label 31268: @2294466
     /* 2294466 */   GIM_Try, /*On fail goto*//*Label 31269*/ GIMT_Encode4(2294514), // Rule ID 52657 //
     /* 2294471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294474 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2294477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2294491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294513 */     // GIR_Coverage, 52657,
     /* 2294513 */     GIR_EraseRootFromParent_Done,
     /* 2294514 */   // Label 31269: @2294514
     /* 2294514 */   GIM_Reject,
     /* 2294515 */ // Label 31267: @2294515
     /* 2294515 */ GIM_Reject,
     /* 2294516 */ // Label 31232: @2294516
     /* 2294516 */ GIM_Try, /*On fail goto*//*Label 31270*/ GIMT_Encode4(2294636),
     /* 2294521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2294524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2294527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294539 */   GIM_Try, /*On fail goto*//*Label 31271*/ GIMT_Encode4(2294587), // Rule ID 52672 //
     /* 2294544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294547 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2294550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2294564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294586 */     // GIR_Coverage, 52672,
     /* 2294586 */     GIR_EraseRootFromParent_Done,
     /* 2294587 */   // Label 31271: @2294587
     /* 2294587 */   GIM_Try, /*On fail goto*//*Label 31272*/ GIMT_Encode4(2294635), // Rule ID 52673 //
     /* 2294592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294595 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2294598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2294612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294634 */     // GIR_Coverage, 52673,
     /* 2294634 */     GIR_EraseRootFromParent_Done,
     /* 2294635 */   // Label 31272: @2294635
     /* 2294635 */   GIM_Reject,
     /* 2294636 */ // Label 31270: @2294636
     /* 2294636 */ GIM_Reject,
     /* 2294637 */ // Label 31233: @2294637
     /* 2294637 */ GIM_Try, /*On fail goto*//*Label 31273*/ GIMT_Encode4(2294757),
     /* 2294642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2294645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2294648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294660 */   GIM_Try, /*On fail goto*//*Label 31274*/ GIMT_Encode4(2294708), // Rule ID 52716 //
     /* 2294665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2294668 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2294671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2294685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294703 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294707 */     // GIR_Coverage, 52716,
     /* 2294707 */     GIR_EraseRootFromParent_Done,
     /* 2294708 */   // Label 31274: @2294708
     /* 2294708 */   GIM_Try, /*On fail goto*//*Label 31275*/ GIMT_Encode4(2294756), // Rule ID 52717 //
     /* 2294713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2294716 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2294719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2294733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294755 */     // GIR_Coverage, 52717,
     /* 2294755 */     GIR_EraseRootFromParent_Done,
     /* 2294756 */   // Label 31275: @2294756
     /* 2294756 */   GIM_Reject,
     /* 2294757 */ // Label 31273: @2294757
     /* 2294757 */ GIM_Reject,
     /* 2294758 */ // Label 31234: @2294758
     /* 2294758 */ GIM_Try, /*On fail goto*//*Label 31276*/ GIMT_Encode4(2294878),
     /* 2294763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2294766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2294769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294781 */   GIM_Try, /*On fail goto*//*Label 31277*/ GIMT_Encode4(2294829), // Rule ID 52648 //
     /* 2294786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294789 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2294792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2294806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294828 */     // GIR_Coverage, 52648,
     /* 2294828 */     GIR_EraseRootFromParent_Done,
     /* 2294829 */   // Label 31277: @2294829
     /* 2294829 */   GIM_Try, /*On fail goto*//*Label 31278*/ GIMT_Encode4(2294877), // Rule ID 52649 //
     /* 2294834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294837 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2294840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2294854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294876 */     // GIR_Coverage, 52649,
     /* 2294876 */     GIR_EraseRootFromParent_Done,
     /* 2294877 */   // Label 31278: @2294877
     /* 2294877 */   GIM_Reject,
     /* 2294878 */ // Label 31276: @2294878
     /* 2294878 */ GIM_Reject,
     /* 2294879 */ // Label 31235: @2294879
     /* 2294879 */ GIM_Try, /*On fail goto*//*Label 31279*/ GIMT_Encode4(2294999),
     /* 2294884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2294887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2294890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294902 */   GIM_Try, /*On fail goto*//*Label 31280*/ GIMT_Encode4(2294950), // Rule ID 52668 //
     /* 2294907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294910 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2294913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2294927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294949 */     // GIR_Coverage, 52668,
     /* 2294949 */     GIR_EraseRootFromParent_Done,
     /* 2294950 */   // Label 31280: @2294950
     /* 2294950 */   GIM_Try, /*On fail goto*//*Label 31281*/ GIMT_Encode4(2294998), // Rule ID 52669 //
     /* 2294955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294958 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2294961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2294975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294997 */     // GIR_Coverage, 52669,
     /* 2294997 */     GIR_EraseRootFromParent_Done,
     /* 2294998 */   // Label 31281: @2294998
     /* 2294998 */   GIM_Reject,
     /* 2294999 */ // Label 31279: @2294999
     /* 2294999 */ GIM_Reject,
     /* 2295000 */ // Label 31236: @2295000
     /* 2295000 */ GIM_Try, /*On fail goto*//*Label 31282*/ GIMT_Encode4(2295120),
     /* 2295005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2295008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2295011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295023 */   GIM_Try, /*On fail goto*//*Label 31283*/ GIMT_Encode4(2295071), // Rule ID 52704 //
     /* 2295028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295031 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2295034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2295048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295070 */     // GIR_Coverage, 52704,
     /* 2295070 */     GIR_EraseRootFromParent_Done,
     /* 2295071 */   // Label 31283: @2295071
     /* 2295071 */   GIM_Try, /*On fail goto*//*Label 31284*/ GIMT_Encode4(2295119), // Rule ID 52705 //
     /* 2295076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295079 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2295082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2295096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295118 */     // GIR_Coverage, 52705,
     /* 2295118 */     GIR_EraseRootFromParent_Done,
     /* 2295119 */   // Label 31284: @2295119
     /* 2295119 */   GIM_Reject,
     /* 2295120 */ // Label 31282: @2295120
     /* 2295120 */ GIM_Reject,
     /* 2295121 */ // Label 31237: @2295121
     /* 2295121 */ GIM_Try, /*On fail goto*//*Label 31285*/ GIMT_Encode4(2295241),
     /* 2295126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2295129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2295132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295144 */   GIM_Try, /*On fail goto*//*Label 31286*/ GIMT_Encode4(2295192), // Rule ID 52720 //
     /* 2295149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2295152 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2295155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2295169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295191 */     // GIR_Coverage, 52720,
     /* 2295191 */     GIR_EraseRootFromParent_Done,
     /* 2295192 */   // Label 31286: @2295192
     /* 2295192 */   GIM_Try, /*On fail goto*//*Label 31287*/ GIMT_Encode4(2295240), // Rule ID 52721 //
     /* 2295197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2295200 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2295203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2295217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295239 */     // GIR_Coverage, 52721,
     /* 2295239 */     GIR_EraseRootFromParent_Done,
     /* 2295240 */   // Label 31287: @2295240
     /* 2295240 */   GIM_Reject,
     /* 2295241 */ // Label 31285: @2295241
     /* 2295241 */ GIM_Reject,
     /* 2295242 */ // Label 31238: @2295242
     /* 2295242 */ GIM_Try, /*On fail goto*//*Label 31288*/ GIMT_Encode4(2295362),
     /* 2295247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2295250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2295253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295265 */   GIM_Try, /*On fail goto*//*Label 31289*/ GIMT_Encode4(2295313), // Rule ID 52664 //
     /* 2295270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295273 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2295276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2295290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295312 */     // GIR_Coverage, 52664,
     /* 2295312 */     GIR_EraseRootFromParent_Done,
     /* 2295313 */   // Label 31289: @2295313
     /* 2295313 */   GIM_Try, /*On fail goto*//*Label 31290*/ GIMT_Encode4(2295361), // Rule ID 52665 //
     /* 2295318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295321 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2295324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2295338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295360 */     // GIR_Coverage, 52665,
     /* 2295360 */     GIR_EraseRootFromParent_Done,
     /* 2295361 */   // Label 31290: @2295361
     /* 2295361 */   GIM_Reject,
     /* 2295362 */ // Label 31288: @2295362
     /* 2295362 */ GIM_Reject,
     /* 2295363 */ // Label 31239: @2295363
     /* 2295363 */ GIM_Try, /*On fail goto*//*Label 31291*/ GIMT_Encode4(2295483),
     /* 2295368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2295371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2295374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295386 */   GIM_Try, /*On fail goto*//*Label 31292*/ GIMT_Encode4(2295434), // Rule ID 52692 //
     /* 2295391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295394 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2295397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2295411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295433 */     // GIR_Coverage, 52692,
     /* 2295433 */     GIR_EraseRootFromParent_Done,
     /* 2295434 */   // Label 31292: @2295434
     /* 2295434 */   GIM_Try, /*On fail goto*//*Label 31293*/ GIMT_Encode4(2295482), // Rule ID 52693 //
     /* 2295439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295442 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2295445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2295459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295481 */     // GIR_Coverage, 52693,
     /* 2295481 */     GIR_EraseRootFromParent_Done,
     /* 2295482 */   // Label 31293: @2295482
     /* 2295482 */   GIM_Reject,
     /* 2295483 */ // Label 31291: @2295483
     /* 2295483 */ GIM_Reject,
     /* 2295484 */ // Label 31240: @2295484
     /* 2295484 */ GIM_Try, /*On fail goto*//*Label 31294*/ GIMT_Encode4(2295604),
     /* 2295489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2295492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2295495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295507 */   GIM_Try, /*On fail goto*//*Label 31295*/ GIMT_Encode4(2295555), // Rule ID 52708 //
     /* 2295512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295515 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2295518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2295532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295554 */     // GIR_Coverage, 52708,
     /* 2295554 */     GIR_EraseRootFromParent_Done,
     /* 2295555 */   // Label 31295: @2295555
     /* 2295555 */   GIM_Try, /*On fail goto*//*Label 31296*/ GIMT_Encode4(2295603), // Rule ID 52709 //
     /* 2295560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295563 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2295566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2295580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295602 */     // GIR_Coverage, 52709,
     /* 2295602 */     GIR_EraseRootFromParent_Done,
     /* 2295603 */   // Label 31296: @2295603
     /* 2295603 */   GIM_Reject,
     /* 2295604 */ // Label 31294: @2295604
     /* 2295604 */ GIM_Reject,
     /* 2295605 */ // Label 31241: @2295605
     /* 2295605 */ GIM_Try, /*On fail goto*//*Label 31297*/ GIMT_Encode4(2295725),
     /* 2295610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2295616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295628 */   GIM_Try, /*On fail goto*//*Label 31298*/ GIMT_Encode4(2295676), // Rule ID 52724 //
     /* 2295633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2295636 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2295639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2295653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295675 */     // GIR_Coverage, 52724,
     /* 2295675 */     GIR_EraseRootFromParent_Done,
     /* 2295676 */   // Label 31298: @2295676
     /* 2295676 */   GIM_Try, /*On fail goto*//*Label 31299*/ GIMT_Encode4(2295724), // Rule ID 52725 //
     /* 2295681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2295684 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2295687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2295701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295719 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295723 */     // GIR_Coverage, 52725,
     /* 2295723 */     GIR_EraseRootFromParent_Done,
     /* 2295724 */   // Label 31299: @2295724
     /* 2295724 */   GIM_Reject,
     /* 2295725 */ // Label 31297: @2295725
     /* 2295725 */ GIM_Reject,
     /* 2295726 */ // Label 31242: @2295726
     /* 2295726 */ GIM_Try, /*On fail goto*//*Label 31300*/ GIMT_Encode4(2295846),
     /* 2295731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2295734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2295737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295749 */   GIM_Try, /*On fail goto*//*Label 31301*/ GIMT_Encode4(2295797), // Rule ID 52680 //
     /* 2295754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295757 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2295760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2295774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295796 */     // GIR_Coverage, 52680,
     /* 2295796 */     GIR_EraseRootFromParent_Done,
     /* 2295797 */   // Label 31301: @2295797
     /* 2295797 */   GIM_Try, /*On fail goto*//*Label 31302*/ GIMT_Encode4(2295845), // Rule ID 52681 //
     /* 2295802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295805 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2295808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2295822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295844 */     // GIR_Coverage, 52681,
     /* 2295844 */     GIR_EraseRootFromParent_Done,
     /* 2295845 */   // Label 31302: @2295845
     /* 2295845 */   GIM_Reject,
     /* 2295846 */ // Label 31300: @2295846
     /* 2295846 */ GIM_Reject,
     /* 2295847 */ // Label 31243: @2295847
     /* 2295847 */ GIM_Try, /*On fail goto*//*Label 31303*/ GIMT_Encode4(2295967),
     /* 2295852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2295855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2295858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295870 */   GIM_Try, /*On fail goto*//*Label 31304*/ GIMT_Encode4(2295918), // Rule ID 52696 //
     /* 2295875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295878 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2295881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2295895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295917 */     // GIR_Coverage, 52696,
     /* 2295917 */     GIR_EraseRootFromParent_Done,
     /* 2295918 */   // Label 31304: @2295918
     /* 2295918 */   GIM_Try, /*On fail goto*//*Label 31305*/ GIMT_Encode4(2295966), // Rule ID 52697 //
     /* 2295923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295926 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2295929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2295943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295965 */     // GIR_Coverage, 52697,
     /* 2295965 */     GIR_EraseRootFromParent_Done,
     /* 2295966 */   // Label 31305: @2295966
     /* 2295966 */   GIM_Reject,
     /* 2295967 */ // Label 31303: @2295967
     /* 2295967 */ GIM_Reject,
     /* 2295968 */ // Label 31244: @2295968
     /* 2295968 */ GIM_Try, /*On fail goto*//*Label 31306*/ GIMT_Encode4(2296088),
     /* 2295973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2295976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2295979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295991 */   GIM_Try, /*On fail goto*//*Label 31307*/ GIMT_Encode4(2296039), // Rule ID 52712 //
     /* 2295996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295999 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2296002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2296016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296038 */     // GIR_Coverage, 52712,
     /* 2296038 */     GIR_EraseRootFromParent_Done,
     /* 2296039 */   // Label 31307: @2296039
     /* 2296039 */   GIM_Try, /*On fail goto*//*Label 31308*/ GIMT_Encode4(2296087), // Rule ID 52713 //
     /* 2296044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296047 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2296050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2296064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296086 */     // GIR_Coverage, 52713,
     /* 2296086 */     GIR_EraseRootFromParent_Done,
     /* 2296087 */   // Label 31308: @2296087
     /* 2296087 */   GIM_Reject,
     /* 2296088 */ // Label 31306: @2296088
     /* 2296088 */ GIM_Reject,
     /* 2296089 */ // Label 31245: @2296089
     /* 2296089 */ GIM_Try, /*On fail goto*//*Label 31309*/ GIMT_Encode4(2296209),
     /* 2296094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2296097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2296100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296112 */   GIM_Try, /*On fail goto*//*Label 31310*/ GIMT_Encode4(2296160), // Rule ID 52684 //
     /* 2296117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296120 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2296123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2296137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296159 */     // GIR_Coverage, 52684,
     /* 2296159 */     GIR_EraseRootFromParent_Done,
     /* 2296160 */   // Label 31310: @2296160
     /* 2296160 */   GIM_Try, /*On fail goto*//*Label 31311*/ GIMT_Encode4(2296208), // Rule ID 52685 //
     /* 2296165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296168 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2296171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2296185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296207 */     // GIR_Coverage, 52685,
     /* 2296207 */     GIR_EraseRootFromParent_Done,
     /* 2296208 */   // Label 31311: @2296208
     /* 2296208 */   GIM_Reject,
     /* 2296209 */ // Label 31309: @2296209
     /* 2296209 */ GIM_Reject,
     /* 2296210 */ // Label 31246: @2296210
     /* 2296210 */ GIM_Try, /*On fail goto*//*Label 31312*/ GIMT_Encode4(2296330),
     /* 2296215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2296218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2296221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296233 */   GIM_Try, /*On fail goto*//*Label 31313*/ GIMT_Encode4(2296281), // Rule ID 52700 //
     /* 2296238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296241 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2296244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2296258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296280 */     // GIR_Coverage, 52700,
     /* 2296280 */     GIR_EraseRootFromParent_Done,
     /* 2296281 */   // Label 31313: @2296281
     /* 2296281 */   GIM_Try, /*On fail goto*//*Label 31314*/ GIMT_Encode4(2296329), // Rule ID 52701 //
     /* 2296286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296289 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2296292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2296306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296328 */     // GIR_Coverage, 52701,
     /* 2296328 */     GIR_EraseRootFromParent_Done,
     /* 2296329 */   // Label 31314: @2296329
     /* 2296329 */   GIM_Reject,
     /* 2296330 */ // Label 31312: @2296330
     /* 2296330 */ GIM_Reject,
     /* 2296331 */ // Label 31247: @2296331
     /* 2296331 */ GIM_Try, /*On fail goto*//*Label 31315*/ GIMT_Encode4(2296451),
     /* 2296336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2296339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2296342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296354 */   GIM_Try, /*On fail goto*//*Label 31316*/ GIMT_Encode4(2296402), // Rule ID 52688 //
     /* 2296359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296362 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2296365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2296379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296401 */     // GIR_Coverage, 52688,
     /* 2296401 */     GIR_EraseRootFromParent_Done,
     /* 2296402 */   // Label 31316: @2296402
     /* 2296402 */   GIM_Try, /*On fail goto*//*Label 31317*/ GIMT_Encode4(2296450), // Rule ID 52689 //
     /* 2296407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296410 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2296413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2296427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296449 */     // GIR_Coverage, 52689,
     /* 2296449 */     GIR_EraseRootFromParent_Done,
     /* 2296450 */   // Label 31317: @2296450
     /* 2296450 */   GIM_Reject,
     /* 2296451 */ // Label 31315: @2296451
     /* 2296451 */ GIM_Reject,
     /* 2296452 */ // Label 31248: @2296452
     /* 2296452 */ GIM_Reject,
     /* 2296453 */ // Label 57: @2296453
     /* 2296453 */ GIM_Try, /*On fail goto*//*Label 31318*/ GIMT_Encode4(2296510),
     /* 2296458 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2296461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2296464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2296467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296479 */   GIM_Try, /*On fail goto*//*Label 31319*/ GIMT_Encode4(2296494), // Rule ID 64586 //
     /* 2296484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2296487 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2296487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2296492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296493 */     // GIR_Coverage, 64586,
     /* 2296493 */     GIR_Done,
     /* 2296494 */   // Label 31319: @2296494
     /* 2296494 */   GIM_Try, /*On fail goto*//*Label 31320*/ GIMT_Encode4(2296509), // Rule ID 64587 //
     /* 2296499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2296502 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2296502 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2296507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296508 */     // GIR_Coverage, 64587,
     /* 2296508 */     GIR_Done,
     /* 2296509 */   // Label 31320: @2296509
     /* 2296509 */   GIM_Reject,
     /* 2296510 */ // Label 31318: @2296510
     /* 2296510 */ GIM_Reject,
     /* 2296511 */ // Label 58: @2296511
     /* 2296511 */ GIM_Try, /*On fail goto*//*Label 31321*/ GIMT_Encode4(2296568),
     /* 2296516 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2296519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2296522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2296525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296537 */   GIM_Try, /*On fail goto*//*Label 31322*/ GIMT_Encode4(2296552), // Rule ID 64588 //
     /* 2296542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2296545 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2296545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2296550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296551 */     // GIR_Coverage, 64588,
     /* 2296551 */     GIR_Done,
     /* 2296552 */   // Label 31322: @2296552
     /* 2296552 */   GIM_Try, /*On fail goto*//*Label 31323*/ GIMT_Encode4(2296567), // Rule ID 64589 //
     /* 2296557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2296560 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2296560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2296565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296566 */     // GIR_Coverage, 64589,
     /* 2296566 */     GIR_Done,
     /* 2296567 */   // Label 31323: @2296567
     /* 2296567 */   GIM_Reject,
     /* 2296568 */ // Label 31321: @2296568
     /* 2296568 */ GIM_Reject,
     /* 2296569 */ // Label 59: @2296569
     /* 2296569 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31342*/ GIMT_Encode4(2298996),
     /* 2296580 */ /*GILLT_s16*//*Label 31324*/ GIMT_Encode4(2296700),
     /* 2296584 */ /*GILLT_s32*//*Label 31325*/ GIMT_Encode4(2296849),
     /* 2296588 */ /*GILLT_s64*//*Label 31326*/ GIMT_Encode4(2296998), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296600 */ /*GILLT_nxv1s16*//*Label 31327*/ GIMT_Encode4(2297181),
     /* 2296604 */ /*GILLT_nxv1s32*//*Label 31328*/ GIMT_Encode4(2297302),
     /* 2296608 */ /*GILLT_nxv1s64*//*Label 31329*/ GIMT_Encode4(2297423), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296620 */ /*GILLT_nxv2s16*//*Label 31330*/ GIMT_Encode4(2297544),
     /* 2296624 */ /*GILLT_nxv2s32*//*Label 31331*/ GIMT_Encode4(2297665),
     /* 2296628 */ /*GILLT_nxv2s64*//*Label 31332*/ GIMT_Encode4(2297786), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296640 */ /*GILLT_nxv4s16*//*Label 31333*/ GIMT_Encode4(2297907),
     /* 2296644 */ /*GILLT_nxv4s32*//*Label 31334*/ GIMT_Encode4(2298028),
     /* 2296648 */ /*GILLT_nxv4s64*//*Label 31335*/ GIMT_Encode4(2298149), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296660 */ /*GILLT_nxv8s16*//*Label 31336*/ GIMT_Encode4(2298270),
     /* 2296664 */ /*GILLT_nxv8s32*//*Label 31337*/ GIMT_Encode4(2298391),
     /* 2296668 */ /*GILLT_nxv8s64*//*Label 31338*/ GIMT_Encode4(2298512), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296680 */ /*GILLT_nxv16s16*//*Label 31339*/ GIMT_Encode4(2298633),
     /* 2296684 */ /*GILLT_nxv16s32*//*Label 31340*/ GIMT_Encode4(2298754), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296696 */ /*GILLT_nxv32s16*//*Label 31341*/ GIMT_Encode4(2298875),
     /* 2296700 */ // Label 31324: @2296700
     /* 2296700 */ GIM_Try, /*On fail goto*//*Label 31343*/ GIMT_Encode4(2296848),
     /* 2296705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2296708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2296711 */   GIM_Try, /*On fail goto*//*Label 31344*/ GIMT_Encode4(2296745), // Rule ID 1958 //
     /* 2296716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2296719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2296723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2296727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2296731 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2296731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2296734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296744 */     // GIR_Coverage, 1958,
     /* 2296744 */     GIR_EraseRootFromParent_Done,
     /* 2296745 */   // Label 31344: @2296745
     /* 2296745 */   GIM_Try, /*On fail goto*//*Label 31345*/ GIMT_Encode4(2296779), // Rule ID 1959 //
     /* 2296750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2296753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2296757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2296761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2296765 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2296765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2296768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296778 */     // GIR_Coverage, 1959,
     /* 2296778 */     GIR_EraseRootFromParent_Done,
     /* 2296779 */   // Label 31345: @2296779
     /* 2296779 */   GIM_Try, /*On fail goto*//*Label 31346*/ GIMT_Encode4(2296813), // Rule ID 1962 //
     /* 2296784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2296787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2296791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2296795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2296799 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2296799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2296802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296812 */     // GIR_Coverage, 1962,
     /* 2296812 */     GIR_EraseRootFromParent_Done,
     /* 2296813 */   // Label 31346: @2296813
     /* 2296813 */   GIM_Try, /*On fail goto*//*Label 31347*/ GIMT_Encode4(2296847), // Rule ID 1963 //
     /* 2296818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2296821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2296825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2296829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2296833 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2296833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2296836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296846 */     // GIR_Coverage, 1963,
     /* 2296846 */     GIR_EraseRootFromParent_Done,
     /* 2296847 */   // Label 31347: @2296847
     /* 2296847 */   GIM_Reject,
     /* 2296848 */ // Label 31343: @2296848
     /* 2296848 */ GIM_Reject,
     /* 2296849 */ // Label 31325: @2296849
     /* 2296849 */ GIM_Try, /*On fail goto*//*Label 31348*/ GIMT_Encode4(2296997),
     /* 2296854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2296857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2296860 */   GIM_Try, /*On fail goto*//*Label 31349*/ GIMT_Encode4(2296894), // Rule ID 1249 //
     /* 2296865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2296868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2296872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2296876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2296880 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2296880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2296883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296893 */     // GIR_Coverage, 1249,
     /* 2296893 */     GIR_EraseRootFromParent_Done,
     /* 2296894 */   // Label 31349: @2296894
     /* 2296894 */   GIM_Try, /*On fail goto*//*Label 31350*/ GIMT_Encode4(2296928), // Rule ID 1250 //
     /* 2296899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2296902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2296906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2296910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2296914 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2296914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2296917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296927 */     // GIR_Coverage, 1250,
     /* 2296927 */     GIR_EraseRootFromParent_Done,
     /* 2296928 */   // Label 31350: @2296928
     /* 2296928 */   GIM_Try, /*On fail goto*//*Label 31351*/ GIMT_Encode4(2296962), // Rule ID 1253 //
     /* 2296933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2296936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2296940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2296944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2296948 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2296948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2296951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296961 */     // GIR_Coverage, 1253,
     /* 2296961 */     GIR_EraseRootFromParent_Done,
     /* 2296962 */   // Label 31351: @2296962
     /* 2296962 */   GIM_Try, /*On fail goto*//*Label 31352*/ GIMT_Encode4(2296996), // Rule ID 1254 //
     /* 2296967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2296970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2296974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2296978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2296982 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2296982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2296985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296995 */     // GIR_Coverage, 1254,
     /* 2296995 */     GIR_EraseRootFromParent_Done,
     /* 2296996 */   // Label 31352: @2296996
     /* 2296996 */   GIM_Reject,
     /* 2296997 */ // Label 31348: @2296997
     /* 2296997 */ GIM_Reject,
     /* 2296998 */ // Label 31326: @2296998
     /* 2296998 */ GIM_Try, /*On fail goto*//*Label 31353*/ GIMT_Encode4(2297180),
     /* 2297003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2297006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2297009 */   GIM_Try, /*On fail goto*//*Label 31354*/ GIMT_Encode4(2297043), // Rule ID 1584 //
     /* 2297014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2297017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297029 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2297029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2297032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297042 */     // GIR_Coverage, 1584,
     /* 2297042 */     GIR_EraseRootFromParent_Done,
     /* 2297043 */   // Label 31354: @2297043
     /* 2297043 */   GIM_Try, /*On fail goto*//*Label 31355*/ GIMT_Encode4(2297077), // Rule ID 1585 //
     /* 2297048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2297051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297063 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2297063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2297066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297076 */     // GIR_Coverage, 1585,
     /* 2297076 */     GIR_EraseRootFromParent_Done,
     /* 2297077 */   // Label 31355: @2297077
     /* 2297077 */   GIM_Try, /*On fail goto*//*Label 31356*/ GIMT_Encode4(2297111), // Rule ID 1588 //
     /* 2297082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2297085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297097 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2297097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2297100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297110 */     // GIR_Coverage, 1588,
     /* 2297110 */     GIR_EraseRootFromParent_Done,
     /* 2297111 */   // Label 31356: @2297111
     /* 2297111 */   GIM_Try, /*On fail goto*//*Label 31357*/ GIMT_Encode4(2297145), // Rule ID 1589 //
     /* 2297116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2297119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297131 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2297131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2297134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297144 */     // GIR_Coverage, 1589,
     /* 2297144 */     GIR_EraseRootFromParent_Done,
     /* 2297145 */   // Label 31357: @2297145
     /* 2297145 */   GIM_Try, /*On fail goto*//*Label 31358*/ GIMT_Encode4(2297179), // Rule ID 1591 //
     /* 2297150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2297153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2297157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2297161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2297165 */     // (fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2297165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2297168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297178 */     // GIR_Coverage, 1591,
     /* 2297178 */     GIR_EraseRootFromParent_Done,
     /* 2297179 */   // Label 31358: @2297179
     /* 2297179 */   GIM_Reject,
     /* 2297180 */ // Label 31353: @2297180
     /* 2297180 */ GIM_Reject,
     /* 2297181 */ // Label 31327: @2297181
     /* 2297181 */ GIM_Try, /*On fail goto*//*Label 31359*/ GIMT_Encode4(2297301),
     /* 2297186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2297192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297204 */   GIM_Try, /*On fail goto*//*Label 31360*/ GIMT_Encode4(2297252), // Rule ID 45764 //
     /* 2297209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297212 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2297215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2297229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297251 */     // GIR_Coverage, 45764,
     /* 2297251 */     GIR_EraseRootFromParent_Done,
     /* 2297252 */   // Label 31360: @2297252
     /* 2297252 */   GIM_Try, /*On fail goto*//*Label 31361*/ GIMT_Encode4(2297300), // Rule ID 45765 //
     /* 2297257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297260 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2297263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2297277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297299 */     // GIR_Coverage, 45765,
     /* 2297299 */     GIR_EraseRootFromParent_Done,
     /* 2297300 */   // Label 31361: @2297300
     /* 2297300 */   GIM_Reject,
     /* 2297301 */ // Label 31359: @2297301
     /* 2297301 */ GIM_Reject,
     /* 2297302 */ // Label 31328: @2297302
     /* 2297302 */ GIM_Try, /*On fail goto*//*Label 31362*/ GIMT_Encode4(2297422),
     /* 2297307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2297310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2297313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297321 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297325 */   GIM_Try, /*On fail goto*//*Label 31363*/ GIMT_Encode4(2297373), // Rule ID 53304 //
     /* 2297330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2297333 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2297336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2297350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297372 */     // GIR_Coverage, 53304,
     /* 2297372 */     GIR_EraseRootFromParent_Done,
     /* 2297373 */   // Label 31363: @2297373
     /* 2297373 */   GIM_Try, /*On fail goto*//*Label 31364*/ GIMT_Encode4(2297421), // Rule ID 53305 //
     /* 2297378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2297381 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2297384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2297398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297420 */     // GIR_Coverage, 53305,
     /* 2297420 */     GIR_EraseRootFromParent_Done,
     /* 2297421 */   // Label 31364: @2297421
     /* 2297421 */   GIM_Reject,
     /* 2297422 */ // Label 31362: @2297422
     /* 2297422 */ GIM_Reject,
     /* 2297423 */ // Label 31329: @2297423
     /* 2297423 */ GIM_Try, /*On fail goto*//*Label 31365*/ GIMT_Encode4(2297543),
     /* 2297428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2297431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2297434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297442 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297446 */   GIM_Try, /*On fail goto*//*Label 31366*/ GIMT_Encode4(2297494), // Rule ID 53340 //
     /* 2297451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2297454 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2297457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2297471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297493 */     // GIR_Coverage, 53340,
     /* 2297493 */     GIR_EraseRootFromParent_Done,
     /* 2297494 */   // Label 31366: @2297494
     /* 2297494 */   GIM_Try, /*On fail goto*//*Label 31367*/ GIMT_Encode4(2297542), // Rule ID 53341 //
     /* 2297499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2297502 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2297505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2297519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297541 */     // GIR_Coverage, 53341,
     /* 2297541 */     GIR_EraseRootFromParent_Done,
     /* 2297542 */   // Label 31367: @2297542
     /* 2297542 */   GIM_Reject,
     /* 2297543 */ // Label 31365: @2297543
     /* 2297543 */ GIM_Reject,
     /* 2297544 */ // Label 31330: @2297544
     /* 2297544 */ GIM_Try, /*On fail goto*//*Label 31368*/ GIMT_Encode4(2297664),
     /* 2297549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2297552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2297555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297567 */   GIM_Try, /*On fail goto*//*Label 31369*/ GIMT_Encode4(2297615), // Rule ID 53292 //
     /* 2297572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297575 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2297578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2297592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297614 */     // GIR_Coverage, 53292,
     /* 2297614 */     GIR_EraseRootFromParent_Done,
     /* 2297615 */   // Label 31369: @2297615
     /* 2297615 */   GIM_Try, /*On fail goto*//*Label 31370*/ GIMT_Encode4(2297663), // Rule ID 53293 //
     /* 2297620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297623 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2297626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2297640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297662 */     // GIR_Coverage, 53293,
     /* 2297662 */     GIR_EraseRootFromParent_Done,
     /* 2297663 */   // Label 31370: @2297663
     /* 2297663 */   GIM_Reject,
     /* 2297664 */ // Label 31368: @2297664
     /* 2297664 */ GIM_Reject,
     /* 2297665 */ // Label 31331: @2297665
     /* 2297665 */ GIM_Try, /*On fail goto*//*Label 31371*/ GIMT_Encode4(2297785),
     /* 2297670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2297673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2297676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297688 */   GIM_Try, /*On fail goto*//*Label 31372*/ GIMT_Encode4(2297736), // Rule ID 53328 //
     /* 2297693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2297696 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2297699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2297713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297735 */     // GIR_Coverage, 53328,
     /* 2297735 */     GIR_EraseRootFromParent_Done,
     /* 2297736 */   // Label 31372: @2297736
     /* 2297736 */   GIM_Try, /*On fail goto*//*Label 31373*/ GIMT_Encode4(2297784), // Rule ID 53329 //
     /* 2297741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2297744 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2297747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2297761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297783 */     // GIR_Coverage, 53329,
     /* 2297783 */     GIR_EraseRootFromParent_Done,
     /* 2297784 */   // Label 31373: @2297784
     /* 2297784 */   GIM_Reject,
     /* 2297785 */ // Label 31371: @2297785
     /* 2297785 */ GIM_Reject,
     /* 2297786 */ // Label 31332: @2297786
     /* 2297786 */ GIM_Try, /*On fail goto*//*Label 31374*/ GIMT_Encode4(2297906),
     /* 2297791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2297797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297809 */   GIM_Try, /*On fail goto*//*Label 31375*/ GIMT_Encode4(2297857), // Rule ID 53424 //
     /* 2297814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2297817 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2297820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2297834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297856 */     // GIR_Coverage, 53424,
     /* 2297856 */     GIR_EraseRootFromParent_Done,
     /* 2297857 */   // Label 31375: @2297857
     /* 2297857 */   GIM_Try, /*On fail goto*//*Label 31376*/ GIMT_Encode4(2297905), // Rule ID 53425 //
     /* 2297862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2297865 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2297868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2297882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297904 */     // GIR_Coverage, 53425,
     /* 2297904 */     GIR_EraseRootFromParent_Done,
     /* 2297905 */   // Label 31376: @2297905
     /* 2297905 */   GIM_Reject,
     /* 2297906 */ // Label 31374: @2297906
     /* 2297906 */ GIM_Reject,
     /* 2297907 */ // Label 31333: @2297907
     /* 2297907 */ GIM_Try, /*On fail goto*//*Label 31377*/ GIMT_Encode4(2298027),
     /* 2297912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2297915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2297918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297930 */   GIM_Try, /*On fail goto*//*Label 31378*/ GIMT_Encode4(2297978), // Rule ID 53316 //
     /* 2297935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297938 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2297941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2297955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297977 */     // GIR_Coverage, 53316,
     /* 2297977 */     GIR_EraseRootFromParent_Done,
     /* 2297978 */   // Label 31378: @2297978
     /* 2297978 */   GIM_Try, /*On fail goto*//*Label 31379*/ GIMT_Encode4(2298026), // Rule ID 53317 //
     /* 2297983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297986 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2297989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2298003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298025 */     // GIR_Coverage, 53317,
     /* 2298025 */     GIR_EraseRootFromParent_Done,
     /* 2298026 */   // Label 31379: @2298026
     /* 2298026 */   GIM_Reject,
     /* 2298027 */ // Label 31377: @2298027
     /* 2298027 */ GIM_Reject,
     /* 2298028 */ // Label 31334: @2298028
     /* 2298028 */ GIM_Try, /*On fail goto*//*Label 31380*/ GIMT_Encode4(2298148),
     /* 2298033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2298039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298047 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298051 */   GIM_Try, /*On fail goto*//*Label 31381*/ GIMT_Encode4(2298099), // Rule ID 53388 //
     /* 2298056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298059 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2298062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2298076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298098 */     // GIR_Coverage, 53388,
     /* 2298098 */     GIR_EraseRootFromParent_Done,
     /* 2298099 */   // Label 31381: @2298099
     /* 2298099 */   GIM_Try, /*On fail goto*//*Label 31382*/ GIMT_Encode4(2298147), // Rule ID 53389 //
     /* 2298104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298107 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2298110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2298124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298146 */     // GIR_Coverage, 53389,
     /* 2298146 */     GIR_EraseRootFromParent_Done,
     /* 2298147 */   // Label 31382: @2298147
     /* 2298147 */   GIM_Reject,
     /* 2298148 */ // Label 31380: @2298148
     /* 2298148 */ GIM_Reject,
     /* 2298149 */ // Label 31335: @2298149
     /* 2298149 */ GIM_Try, /*On fail goto*//*Label 31383*/ GIMT_Encode4(2298269),
     /* 2298154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2298157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2298160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298172 */   GIM_Try, /*On fail goto*//*Label 31384*/ GIMT_Encode4(2298220), // Rule ID 53436 //
     /* 2298177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2298180 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2298183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2298197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298219 */     // GIR_Coverage, 53436,
     /* 2298219 */     GIR_EraseRootFromParent_Done,
     /* 2298220 */   // Label 31384: @2298220
     /* 2298220 */   GIM_Try, /*On fail goto*//*Label 31385*/ GIMT_Encode4(2298268), // Rule ID 53437 //
     /* 2298225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2298228 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2298231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2298245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298267 */     // GIR_Coverage, 53437,
     /* 2298267 */     GIR_EraseRootFromParent_Done,
     /* 2298268 */   // Label 31385: @2298268
     /* 2298268 */   GIM_Reject,
     /* 2298269 */ // Label 31383: @2298269
     /* 2298269 */ GIM_Reject,
     /* 2298270 */ // Label 31336: @2298270
     /* 2298270 */ GIM_Try, /*On fail goto*//*Label 31386*/ GIMT_Encode4(2298390),
     /* 2298275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2298278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2298281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298293 */   GIM_Try, /*On fail goto*//*Label 31387*/ GIMT_Encode4(2298341), // Rule ID 53352 //
     /* 2298298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2298301 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2298304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2298318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298340 */     // GIR_Coverage, 53352,
     /* 2298340 */     GIR_EraseRootFromParent_Done,
     /* 2298341 */   // Label 31387: @2298341
     /* 2298341 */   GIM_Try, /*On fail goto*//*Label 31388*/ GIMT_Encode4(2298389), // Rule ID 53353 //
     /* 2298346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298349 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2298352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2298366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298388 */     // GIR_Coverage, 53353,
     /* 2298388 */     GIR_EraseRootFromParent_Done,
     /* 2298389 */   // Label 31388: @2298389
     /* 2298389 */   GIM_Reject,
     /* 2298390 */ // Label 31386: @2298390
     /* 2298390 */ GIM_Reject,
     /* 2298391 */ // Label 31337: @2298391
     /* 2298391 */ GIM_Try, /*On fail goto*//*Label 31389*/ GIMT_Encode4(2298511),
     /* 2298396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2298399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2298402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298414 */   GIM_Try, /*On fail goto*//*Label 31390*/ GIMT_Encode4(2298462), // Rule ID 53400 //
     /* 2298419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298422 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2298425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2298439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298461 */     // GIR_Coverage, 53400,
     /* 2298461 */     GIR_EraseRootFromParent_Done,
     /* 2298462 */   // Label 31390: @2298462
     /* 2298462 */   GIM_Try, /*On fail goto*//*Label 31391*/ GIMT_Encode4(2298510), // Rule ID 53401 //
     /* 2298467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298470 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2298473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2298487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298509 */     // GIR_Coverage, 53401,
     /* 2298509 */     GIR_EraseRootFromParent_Done,
     /* 2298510 */   // Label 31391: @2298510
     /* 2298510 */   GIM_Reject,
     /* 2298511 */ // Label 31389: @2298511
     /* 2298511 */ GIM_Reject,
     /* 2298512 */ // Label 31338: @2298512
     /* 2298512 */ GIM_Try, /*On fail goto*//*Label 31392*/ GIMT_Encode4(2298632),
     /* 2298517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2298520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2298523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298535 */   GIM_Try, /*On fail goto*//*Label 31393*/ GIMT_Encode4(2298583), // Rule ID 53448 //
     /* 2298540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2298543 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2298546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2298560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298582 */     // GIR_Coverage, 53448,
     /* 2298582 */     GIR_EraseRootFromParent_Done,
     /* 2298583 */   // Label 31393: @2298583
     /* 2298583 */   GIM_Try, /*On fail goto*//*Label 31394*/ GIMT_Encode4(2298631), // Rule ID 53449 //
     /* 2298588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2298591 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2298594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2298608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298630 */     // GIR_Coverage, 53449,
     /* 2298630 */     GIR_EraseRootFromParent_Done,
     /* 2298631 */   // Label 31394: @2298631
     /* 2298631 */   GIM_Reject,
     /* 2298632 */ // Label 31392: @2298632
     /* 2298632 */ GIM_Reject,
     /* 2298633 */ // Label 31339: @2298633
     /* 2298633 */ GIM_Try, /*On fail goto*//*Label 31395*/ GIMT_Encode4(2298753),
     /* 2298638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2298641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2298644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298656 */   GIM_Try, /*On fail goto*//*Label 31396*/ GIMT_Encode4(2298704), // Rule ID 53364 //
     /* 2298661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2298664 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2298667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2298681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298703 */     // GIR_Coverage, 53364,
     /* 2298703 */     GIR_EraseRootFromParent_Done,
     /* 2298704 */   // Label 31396: @2298704
     /* 2298704 */   GIM_Try, /*On fail goto*//*Label 31397*/ GIMT_Encode4(2298752), // Rule ID 53365 //
     /* 2298709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298712 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2298715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2298729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298751 */     // GIR_Coverage, 53365,
     /* 2298751 */     GIR_EraseRootFromParent_Done,
     /* 2298752 */   // Label 31397: @2298752
     /* 2298752 */   GIM_Reject,
     /* 2298753 */ // Label 31395: @2298753
     /* 2298753 */ GIM_Reject,
     /* 2298754 */ // Label 31340: @2298754
     /* 2298754 */ GIM_Try, /*On fail goto*//*Label 31398*/ GIMT_Encode4(2298874),
     /* 2298759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2298762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2298765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298777 */   GIM_Try, /*On fail goto*//*Label 31399*/ GIMT_Encode4(2298825), // Rule ID 53412 //
     /* 2298782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298785 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2298788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2298802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298824 */     // GIR_Coverage, 53412,
     /* 2298824 */     GIR_EraseRootFromParent_Done,
     /* 2298825 */   // Label 31399: @2298825
     /* 2298825 */   GIM_Try, /*On fail goto*//*Label 31400*/ GIMT_Encode4(2298873), // Rule ID 53413 //
     /* 2298830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298833 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2298836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2298850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298872 */     // GIR_Coverage, 53413,
     /* 2298872 */     GIR_EraseRootFromParent_Done,
     /* 2298873 */   // Label 31400: @2298873
     /* 2298873 */   GIM_Reject,
     /* 2298874 */ // Label 31398: @2298874
     /* 2298874 */ GIM_Reject,
     /* 2298875 */ // Label 31341: @2298875
     /* 2298875 */ GIM_Try, /*On fail goto*//*Label 31401*/ GIMT_Encode4(2298995),
     /* 2298880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2298883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2298886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298898 */   GIM_Try, /*On fail goto*//*Label 31402*/ GIMT_Encode4(2298946), // Rule ID 53376 //
     /* 2298903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2298906 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2298909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2298923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298945 */     // GIR_Coverage, 53376,
     /* 2298945 */     GIR_EraseRootFromParent_Done,
     /* 2298946 */   // Label 31402: @2298946
     /* 2298946 */   GIM_Try, /*On fail goto*//*Label 31403*/ GIMT_Encode4(2298994), // Rule ID 53377 //
     /* 2298951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298954 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2298957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2298971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298993 */     // GIR_Coverage, 53377,
     /* 2298993 */     GIR_EraseRootFromParent_Done,
     /* 2298994 */   // Label 31403: @2298994
     /* 2298994 */   GIM_Reject,
     /* 2298995 */ // Label 31401: @2298995
     /* 2298995 */ GIM_Reject,
     /* 2298996 */ // Label 31342: @2298996
     /* 2298996 */ GIM_Reject,
     /* 2298997 */ // Label 60: @2298997
     /* 2298997 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31422*/ GIMT_Encode4(2301424),
     /* 2299008 */ /*GILLT_s16*//*Label 31404*/ GIMT_Encode4(2299128),
     /* 2299012 */ /*GILLT_s32*//*Label 31405*/ GIMT_Encode4(2299277),
     /* 2299016 */ /*GILLT_s64*//*Label 31406*/ GIMT_Encode4(2299426), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2299028 */ /*GILLT_nxv1s16*//*Label 31407*/ GIMT_Encode4(2299609),
     /* 2299032 */ /*GILLT_nxv1s32*//*Label 31408*/ GIMT_Encode4(2299730),
     /* 2299036 */ /*GILLT_nxv1s64*//*Label 31409*/ GIMT_Encode4(2299851), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2299048 */ /*GILLT_nxv2s16*//*Label 31410*/ GIMT_Encode4(2299972),
     /* 2299052 */ /*GILLT_nxv2s32*//*Label 31411*/ GIMT_Encode4(2300093),
     /* 2299056 */ /*GILLT_nxv2s64*//*Label 31412*/ GIMT_Encode4(2300214), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2299068 */ /*GILLT_nxv4s16*//*Label 31413*/ GIMT_Encode4(2300335),
     /* 2299072 */ /*GILLT_nxv4s32*//*Label 31414*/ GIMT_Encode4(2300456),
     /* 2299076 */ /*GILLT_nxv4s64*//*Label 31415*/ GIMT_Encode4(2300577), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2299088 */ /*GILLT_nxv8s16*//*Label 31416*/ GIMT_Encode4(2300698),
     /* 2299092 */ /*GILLT_nxv8s32*//*Label 31417*/ GIMT_Encode4(2300819),
     /* 2299096 */ /*GILLT_nxv8s64*//*Label 31418*/ GIMT_Encode4(2300940), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2299108 */ /*GILLT_nxv16s16*//*Label 31419*/ GIMT_Encode4(2301061),
     /* 2299112 */ /*GILLT_nxv16s32*//*Label 31420*/ GIMT_Encode4(2301182), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2299124 */ /*GILLT_nxv32s16*//*Label 31421*/ GIMT_Encode4(2301303),
     /* 2299128 */ // Label 31404: @2299128
     /* 2299128 */ GIM_Try, /*On fail goto*//*Label 31423*/ GIMT_Encode4(2299276),
     /* 2299133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2299136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2299139 */   GIM_Try, /*On fail goto*//*Label 31424*/ GIMT_Encode4(2299173), // Rule ID 1966 //
     /* 2299144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2299147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2299151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2299155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2299159 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2299159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2299162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299172 */     // GIR_Coverage, 1966,
     /* 2299172 */     GIR_EraseRootFromParent_Done,
     /* 2299173 */   // Label 31424: @2299173
     /* 2299173 */   GIM_Try, /*On fail goto*//*Label 31425*/ GIMT_Encode4(2299207), // Rule ID 1967 //
     /* 2299178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2299181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2299185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2299189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2299193 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2299193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2299196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299206 */     // GIR_Coverage, 1967,
     /* 2299206 */     GIR_EraseRootFromParent_Done,
     /* 2299207 */   // Label 31425: @2299207
     /* 2299207 */   GIM_Try, /*On fail goto*//*Label 31426*/ GIMT_Encode4(2299241), // Rule ID 1970 //
     /* 2299212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2299215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2299219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2299223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2299227 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2299227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2299230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299240 */     // GIR_Coverage, 1970,
     /* 2299240 */     GIR_EraseRootFromParent_Done,
     /* 2299241 */   // Label 31426: @2299241
     /* 2299241 */   GIM_Try, /*On fail goto*//*Label 31427*/ GIMT_Encode4(2299275), // Rule ID 1971 //
     /* 2299246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2299249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2299253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2299257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2299261 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2299261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2299264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299274 */     // GIR_Coverage, 1971,
     /* 2299274 */     GIR_EraseRootFromParent_Done,
     /* 2299275 */   // Label 31427: @2299275
     /* 2299275 */   GIM_Reject,
     /* 2299276 */ // Label 31423: @2299276
     /* 2299276 */ GIM_Reject,
     /* 2299277 */ // Label 31405: @2299277
     /* 2299277 */ GIM_Try, /*On fail goto*//*Label 31428*/ GIMT_Encode4(2299425),
     /* 2299282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2299285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2299288 */   GIM_Try, /*On fail goto*//*Label 31429*/ GIMT_Encode4(2299322), // Rule ID 1257 //
     /* 2299293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2299296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2299300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2299304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2299308 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2299308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2299311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299321 */     // GIR_Coverage, 1257,
     /* 2299321 */     GIR_EraseRootFromParent_Done,
     /* 2299322 */   // Label 31429: @2299322
     /* 2299322 */   GIM_Try, /*On fail goto*//*Label 31430*/ GIMT_Encode4(2299356), // Rule ID 1258 //
     /* 2299327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2299330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2299334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2299338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2299342 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2299342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2299345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299355 */     // GIR_Coverage, 1258,
     /* 2299355 */     GIR_EraseRootFromParent_Done,
     /* 2299356 */   // Label 31430: @2299356
     /* 2299356 */   GIM_Try, /*On fail goto*//*Label 31431*/ GIMT_Encode4(2299390), // Rule ID 1261 //
     /* 2299361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2299364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2299368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2299372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2299376 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2299376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2299379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299389 */     // GIR_Coverage, 1261,
     /* 2299389 */     GIR_EraseRootFromParent_Done,
     /* 2299390 */   // Label 31431: @2299390
     /* 2299390 */   GIM_Try, /*On fail goto*//*Label 31432*/ GIMT_Encode4(2299424), // Rule ID 1262 //
     /* 2299395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2299398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2299402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2299406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2299410 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2299410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2299413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299423 */     // GIR_Coverage, 1262,
     /* 2299423 */     GIR_EraseRootFromParent_Done,
     /* 2299424 */   // Label 31432: @2299424
     /* 2299424 */   GIM_Reject,
     /* 2299425 */ // Label 31428: @2299425
     /* 2299425 */ GIM_Reject,
     /* 2299426 */ // Label 31406: @2299426
     /* 2299426 */ GIM_Try, /*On fail goto*//*Label 31433*/ GIMT_Encode4(2299608),
     /* 2299431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2299434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2299437 */   GIM_Try, /*On fail goto*//*Label 31434*/ GIMT_Encode4(2299471), // Rule ID 1594 //
     /* 2299442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2299445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299457 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2299457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2299460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299470 */     // GIR_Coverage, 1594,
     /* 2299470 */     GIR_EraseRootFromParent_Done,
     /* 2299471 */   // Label 31434: @2299471
     /* 2299471 */   GIM_Try, /*On fail goto*//*Label 31435*/ GIMT_Encode4(2299505), // Rule ID 1595 //
     /* 2299476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2299479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299491 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2299491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2299494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299504 */     // GIR_Coverage, 1595,
     /* 2299504 */     GIR_EraseRootFromParent_Done,
     /* 2299505 */   // Label 31435: @2299505
     /* 2299505 */   GIM_Try, /*On fail goto*//*Label 31436*/ GIMT_Encode4(2299539), // Rule ID 1598 //
     /* 2299510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2299513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299525 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2299525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2299528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299538 */     // GIR_Coverage, 1598,
     /* 2299538 */     GIR_EraseRootFromParent_Done,
     /* 2299539 */   // Label 31436: @2299539
     /* 2299539 */   GIM_Try, /*On fail goto*//*Label 31437*/ GIMT_Encode4(2299573), // Rule ID 1599 //
     /* 2299544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2299547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299559 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2299559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2299562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299572 */     // GIR_Coverage, 1599,
     /* 2299572 */     GIR_EraseRootFromParent_Done,
     /* 2299573 */   // Label 31437: @2299573
     /* 2299573 */   GIM_Try, /*On fail goto*//*Label 31438*/ GIMT_Encode4(2299607), // Rule ID 1601 //
     /* 2299578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2299581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2299585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2299589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2299593 */     // (fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2299593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2299596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299606 */     // GIR_Coverage, 1601,
     /* 2299606 */     GIR_EraseRootFromParent_Done,
     /* 2299607 */   // Label 31438: @2299607
     /* 2299607 */   GIM_Reject,
     /* 2299608 */ // Label 31433: @2299608
     /* 2299608 */ GIM_Reject,
     /* 2299609 */ // Label 31407: @2299609
     /* 2299609 */ GIM_Try, /*On fail goto*//*Label 31439*/ GIMT_Encode4(2299729),
     /* 2299614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2299617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2299620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299632 */   GIM_Try, /*On fail goto*//*Label 31440*/ GIMT_Encode4(2299680), // Rule ID 53460 //
     /* 2299637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2299640 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2299643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2299657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299679 */     // GIR_Coverage, 53460,
     /* 2299679 */     GIR_EraseRootFromParent_Done,
     /* 2299680 */   // Label 31440: @2299680
     /* 2299680 */   GIM_Try, /*On fail goto*//*Label 31441*/ GIMT_Encode4(2299728), // Rule ID 53461 //
     /* 2299685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2299688 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2299691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2299705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299727 */     // GIR_Coverage, 53461,
     /* 2299727 */     GIR_EraseRootFromParent_Done,
     /* 2299728 */   // Label 31441: @2299728
     /* 2299728 */   GIM_Reject,
     /* 2299729 */ // Label 31439: @2299729
     /* 2299729 */ GIM_Reject,
     /* 2299730 */ // Label 31408: @2299730
     /* 2299730 */ GIM_Try, /*On fail goto*//*Label 31442*/ GIMT_Encode4(2299850),
     /* 2299735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2299738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2299741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299753 */   GIM_Try, /*On fail goto*//*Label 31443*/ GIMT_Encode4(2299801), // Rule ID 53484 //
     /* 2299758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2299761 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2299764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2299778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299800 */     // GIR_Coverage, 53484,
     /* 2299800 */     GIR_EraseRootFromParent_Done,
     /* 2299801 */   // Label 31443: @2299801
     /* 2299801 */   GIM_Try, /*On fail goto*//*Label 31444*/ GIMT_Encode4(2299849), // Rule ID 53485 //
     /* 2299806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2299809 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2299812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2299826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299848 */     // GIR_Coverage, 53485,
     /* 2299848 */     GIR_EraseRootFromParent_Done,
     /* 2299849 */   // Label 31444: @2299849
     /* 2299849 */   GIM_Reject,
     /* 2299850 */ // Label 31442: @2299850
     /* 2299850 */ GIM_Reject,
     /* 2299851 */ // Label 31409: @2299851
     /* 2299851 */ GIM_Try, /*On fail goto*//*Label 31445*/ GIMT_Encode4(2299971),
     /* 2299856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2299862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299874 */   GIM_Try, /*On fail goto*//*Label 31446*/ GIMT_Encode4(2299922), // Rule ID 53520 //
     /* 2299879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299882 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2299885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2299899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299921 */     // GIR_Coverage, 53520,
     /* 2299921 */     GIR_EraseRootFromParent_Done,
     /* 2299922 */   // Label 31446: @2299922
     /* 2299922 */   GIM_Try, /*On fail goto*//*Label 31447*/ GIMT_Encode4(2299970), // Rule ID 53521 //
     /* 2299927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299930 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2299933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2299947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299969 */     // GIR_Coverage, 53521,
     /* 2299969 */     GIR_EraseRootFromParent_Done,
     /* 2299970 */   // Label 31447: @2299970
     /* 2299970 */   GIM_Reject,
     /* 2299971 */ // Label 31445: @2299971
     /* 2299971 */ GIM_Reject,
     /* 2299972 */ // Label 31410: @2299972
     /* 2299972 */ GIM_Try, /*On fail goto*//*Label 31448*/ GIMT_Encode4(2300092),
     /* 2299977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2299983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299995 */   GIM_Try, /*On fail goto*//*Label 31449*/ GIMT_Encode4(2300043), // Rule ID 53472 //
     /* 2300000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300003 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2300006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2300020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300042 */     // GIR_Coverage, 53472,
     /* 2300042 */     GIR_EraseRootFromParent_Done,
     /* 2300043 */   // Label 31449: @2300043
     /* 2300043 */   GIM_Try, /*On fail goto*//*Label 31450*/ GIMT_Encode4(2300091), // Rule ID 53473 //
     /* 2300048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300051 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2300054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2300068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300090 */     // GIR_Coverage, 53473,
     /* 2300090 */     GIR_EraseRootFromParent_Done,
     /* 2300091 */   // Label 31450: @2300091
     /* 2300091 */   GIM_Reject,
     /* 2300092 */ // Label 31448: @2300092
     /* 2300092 */ GIM_Reject,
     /* 2300093 */ // Label 31411: @2300093
     /* 2300093 */ GIM_Try, /*On fail goto*//*Label 31451*/ GIMT_Encode4(2300213),
     /* 2300098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2300104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300112 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300116 */   GIM_Try, /*On fail goto*//*Label 31452*/ GIMT_Encode4(2300164), // Rule ID 53508 //
     /* 2300121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300124 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2300127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2300141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300163 */     // GIR_Coverage, 53508,
     /* 2300163 */     GIR_EraseRootFromParent_Done,
     /* 2300164 */   // Label 31452: @2300164
     /* 2300164 */   GIM_Try, /*On fail goto*//*Label 31453*/ GIMT_Encode4(2300212), // Rule ID 53509 //
     /* 2300169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300172 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2300175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2300189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300211 */     // GIR_Coverage, 53509,
     /* 2300211 */     GIR_EraseRootFromParent_Done,
     /* 2300212 */   // Label 31453: @2300212
     /* 2300212 */   GIM_Reject,
     /* 2300213 */ // Label 31451: @2300213
     /* 2300213 */ GIM_Reject,
     /* 2300214 */ // Label 31412: @2300214
     /* 2300214 */ GIM_Try, /*On fail goto*//*Label 31454*/ GIMT_Encode4(2300334),
     /* 2300219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2300222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2300225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300237 */   GIM_Try, /*On fail goto*//*Label 31455*/ GIMT_Encode4(2300285), // Rule ID 53604 //
     /* 2300242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2300245 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2300248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2300262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300284 */     // GIR_Coverage, 53604,
     /* 2300284 */     GIR_EraseRootFromParent_Done,
     /* 2300285 */   // Label 31455: @2300285
     /* 2300285 */   GIM_Try, /*On fail goto*//*Label 31456*/ GIMT_Encode4(2300333), // Rule ID 53605 //
     /* 2300290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2300293 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2300296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2300310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300332 */     // GIR_Coverage, 53605,
     /* 2300332 */     GIR_EraseRootFromParent_Done,
     /* 2300333 */   // Label 31456: @2300333
     /* 2300333 */   GIM_Reject,
     /* 2300334 */ // Label 31454: @2300334
     /* 2300334 */ GIM_Reject,
     /* 2300335 */ // Label 31413: @2300335
     /* 2300335 */ GIM_Try, /*On fail goto*//*Label 31457*/ GIMT_Encode4(2300455),
     /* 2300340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2300343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2300346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300358 */   GIM_Try, /*On fail goto*//*Label 31458*/ GIMT_Encode4(2300406), // Rule ID 53496 //
     /* 2300363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300366 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2300369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2300383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300405 */     // GIR_Coverage, 53496,
     /* 2300405 */     GIR_EraseRootFromParent_Done,
     /* 2300406 */   // Label 31458: @2300406
     /* 2300406 */   GIM_Try, /*On fail goto*//*Label 31459*/ GIMT_Encode4(2300454), // Rule ID 53497 //
     /* 2300411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300414 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2300417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2300431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300453 */     // GIR_Coverage, 53497,
     /* 2300453 */     GIR_EraseRootFromParent_Done,
     /* 2300454 */   // Label 31459: @2300454
     /* 2300454 */   GIM_Reject,
     /* 2300455 */ // Label 31457: @2300455
     /* 2300455 */ GIM_Reject,
     /* 2300456 */ // Label 31414: @2300456
     /* 2300456 */ GIM_Try, /*On fail goto*//*Label 31460*/ GIMT_Encode4(2300576),
     /* 2300461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2300464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2300467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300479 */   GIM_Try, /*On fail goto*//*Label 31461*/ GIMT_Encode4(2300527), // Rule ID 53568 //
     /* 2300484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300487 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2300490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2300504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300526 */     // GIR_Coverage, 53568,
     /* 2300526 */     GIR_EraseRootFromParent_Done,
     /* 2300527 */   // Label 31461: @2300527
     /* 2300527 */   GIM_Try, /*On fail goto*//*Label 31462*/ GIMT_Encode4(2300575), // Rule ID 53569 //
     /* 2300532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300535 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2300538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2300552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300574 */     // GIR_Coverage, 53569,
     /* 2300574 */     GIR_EraseRootFromParent_Done,
     /* 2300575 */   // Label 31462: @2300575
     /* 2300575 */   GIM_Reject,
     /* 2300576 */ // Label 31460: @2300576
     /* 2300576 */ GIM_Reject,
     /* 2300577 */ // Label 31415: @2300577
     /* 2300577 */ GIM_Try, /*On fail goto*//*Label 31463*/ GIMT_Encode4(2300697),
     /* 2300582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2300585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2300588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300600 */   GIM_Try, /*On fail goto*//*Label 31464*/ GIMT_Encode4(2300648), // Rule ID 53616 //
     /* 2300605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2300608 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2300611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2300625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300647 */     // GIR_Coverage, 53616,
     /* 2300647 */     GIR_EraseRootFromParent_Done,
     /* 2300648 */   // Label 31464: @2300648
     /* 2300648 */   GIM_Try, /*On fail goto*//*Label 31465*/ GIMT_Encode4(2300696), // Rule ID 53617 //
     /* 2300653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2300656 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2300659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2300673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300695 */     // GIR_Coverage, 53617,
     /* 2300695 */     GIR_EraseRootFromParent_Done,
     /* 2300696 */   // Label 31465: @2300696
     /* 2300696 */   GIM_Reject,
     /* 2300697 */ // Label 31463: @2300697
     /* 2300697 */ GIM_Reject,
     /* 2300698 */ // Label 31416: @2300698
     /* 2300698 */ GIM_Try, /*On fail goto*//*Label 31466*/ GIMT_Encode4(2300818),
     /* 2300703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2300709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300721 */   GIM_Try, /*On fail goto*//*Label 31467*/ GIMT_Encode4(2300769), // Rule ID 53532 //
     /* 2300726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300729 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2300732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2300746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300768 */     // GIR_Coverage, 53532,
     /* 2300768 */     GIR_EraseRootFromParent_Done,
     /* 2300769 */   // Label 31467: @2300769
     /* 2300769 */   GIM_Try, /*On fail goto*//*Label 31468*/ GIMT_Encode4(2300817), // Rule ID 53533 //
     /* 2300774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300777 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2300780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2300794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300816 */     // GIR_Coverage, 53533,
     /* 2300816 */     GIR_EraseRootFromParent_Done,
     /* 2300817 */   // Label 31468: @2300817
     /* 2300817 */   GIM_Reject,
     /* 2300818 */ // Label 31466: @2300818
     /* 2300818 */ GIM_Reject,
     /* 2300819 */ // Label 31417: @2300819
     /* 2300819 */ GIM_Try, /*On fail goto*//*Label 31469*/ GIMT_Encode4(2300939),
     /* 2300824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2300827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2300830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300842 */   GIM_Try, /*On fail goto*//*Label 31470*/ GIMT_Encode4(2300890), // Rule ID 53580 //
     /* 2300847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300850 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2300853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2300867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300889 */     // GIR_Coverage, 53580,
     /* 2300889 */     GIR_EraseRootFromParent_Done,
     /* 2300890 */   // Label 31470: @2300890
     /* 2300890 */   GIM_Try, /*On fail goto*//*Label 31471*/ GIMT_Encode4(2300938), // Rule ID 53581 //
     /* 2300895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300898 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2300901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2300915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300937 */     // GIR_Coverage, 53581,
     /* 2300937 */     GIR_EraseRootFromParent_Done,
     /* 2300938 */   // Label 31471: @2300938
     /* 2300938 */   GIM_Reject,
     /* 2300939 */ // Label 31469: @2300939
     /* 2300939 */ GIM_Reject,
     /* 2300940 */ // Label 31418: @2300940
     /* 2300940 */ GIM_Try, /*On fail goto*//*Label 31472*/ GIMT_Encode4(2301060),
     /* 2300945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2300948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2300951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300959 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300963 */   GIM_Try, /*On fail goto*//*Label 31473*/ GIMT_Encode4(2301011), // Rule ID 53628 //
     /* 2300968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2300971 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2300974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2300988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301010 */     // GIR_Coverage, 53628,
     /* 2301010 */     GIR_EraseRootFromParent_Done,
     /* 2301011 */   // Label 31473: @2301011
     /* 2301011 */   GIM_Try, /*On fail goto*//*Label 31474*/ GIMT_Encode4(2301059), // Rule ID 53629 //
     /* 2301016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2301019 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2301022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2301036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301058 */     // GIR_Coverage, 53629,
     /* 2301058 */     GIR_EraseRootFromParent_Done,
     /* 2301059 */   // Label 31474: @2301059
     /* 2301059 */   GIM_Reject,
     /* 2301060 */ // Label 31472: @2301060
     /* 2301060 */ GIM_Reject,
     /* 2301061 */ // Label 31419: @2301061
     /* 2301061 */ GIM_Try, /*On fail goto*//*Label 31475*/ GIMT_Encode4(2301181),
     /* 2301066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2301069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2301072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301084 */   GIM_Try, /*On fail goto*//*Label 31476*/ GIMT_Encode4(2301132), // Rule ID 53544 //
     /* 2301089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2301092 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2301095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2301109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301131 */     // GIR_Coverage, 53544,
     /* 2301131 */     GIR_EraseRootFromParent_Done,
     /* 2301132 */   // Label 31476: @2301132
     /* 2301132 */   GIM_Try, /*On fail goto*//*Label 31477*/ GIMT_Encode4(2301180), // Rule ID 53545 //
     /* 2301137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2301140 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2301143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2301157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301179 */     // GIR_Coverage, 53545,
     /* 2301179 */     GIR_EraseRootFromParent_Done,
     /* 2301180 */   // Label 31477: @2301180
     /* 2301180 */   GIM_Reject,
     /* 2301181 */ // Label 31475: @2301181
     /* 2301181 */ GIM_Reject,
     /* 2301182 */ // Label 31420: @2301182
     /* 2301182 */ GIM_Try, /*On fail goto*//*Label 31478*/ GIMT_Encode4(2301302),
     /* 2301187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2301190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2301193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301205 */   GIM_Try, /*On fail goto*//*Label 31479*/ GIMT_Encode4(2301253), // Rule ID 53592 //
     /* 2301210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2301213 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2301216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2301230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301252 */     // GIR_Coverage, 53592,
     /* 2301252 */     GIR_EraseRootFromParent_Done,
     /* 2301253 */   // Label 31479: @2301253
     /* 2301253 */   GIM_Try, /*On fail goto*//*Label 31480*/ GIMT_Encode4(2301301), // Rule ID 53593 //
     /* 2301258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2301261 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2301264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2301278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301300 */     // GIR_Coverage, 53593,
     /* 2301300 */     GIR_EraseRootFromParent_Done,
     /* 2301301 */   // Label 31480: @2301301
     /* 2301301 */   GIM_Reject,
     /* 2301302 */ // Label 31478: @2301302
     /* 2301302 */ GIM_Reject,
     /* 2301303 */ // Label 31421: @2301303
     /* 2301303 */ GIM_Try, /*On fail goto*//*Label 31481*/ GIMT_Encode4(2301423),
     /* 2301308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2301311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2301314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301326 */   GIM_Try, /*On fail goto*//*Label 31482*/ GIMT_Encode4(2301374), // Rule ID 53556 //
     /* 2301331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2301334 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2301337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2301351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301373 */     // GIR_Coverage, 53556,
     /* 2301373 */     GIR_EraseRootFromParent_Done,
     /* 2301374 */   // Label 31482: @2301374
     /* 2301374 */   GIM_Try, /*On fail goto*//*Label 31483*/ GIMT_Encode4(2301422), // Rule ID 53557 //
     /* 2301379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2301382 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2301385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2301399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301421 */     // GIR_Coverage, 53557,
     /* 2301421 */     GIR_EraseRootFromParent_Done,
     /* 2301422 */   // Label 31483: @2301422
     /* 2301422 */   GIM_Reject,
     /* 2301423 */ // Label 31481: @2301423
     /* 2301423 */ GIM_Reject,
     /* 2301424 */ // Label 31422: @2301424
     /* 2301424 */ GIM_Reject,
     /* 2301425 */ // Label 61: @2301425
     /* 2301425 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31502*/ GIMT_Encode4(2303852),
     /* 2301436 */ /*GILLT_s16*//*Label 31484*/ GIMT_Encode4(2301556),
     /* 2301440 */ /*GILLT_s32*//*Label 31485*/ GIMT_Encode4(2301705),
     /* 2301444 */ /*GILLT_s64*//*Label 31486*/ GIMT_Encode4(2301854), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301456 */ /*GILLT_nxv1s16*//*Label 31487*/ GIMT_Encode4(2302037),
     /* 2301460 */ /*GILLT_nxv1s32*//*Label 31488*/ GIMT_Encode4(2302158),
     /* 2301464 */ /*GILLT_nxv1s64*//*Label 31489*/ GIMT_Encode4(2302279), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301476 */ /*GILLT_nxv2s16*//*Label 31490*/ GIMT_Encode4(2302400),
     /* 2301480 */ /*GILLT_nxv2s32*//*Label 31491*/ GIMT_Encode4(2302521),
     /* 2301484 */ /*GILLT_nxv2s64*//*Label 31492*/ GIMT_Encode4(2302642), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301496 */ /*GILLT_nxv4s16*//*Label 31493*/ GIMT_Encode4(2302763),
     /* 2301500 */ /*GILLT_nxv4s32*//*Label 31494*/ GIMT_Encode4(2302884),
     /* 2301504 */ /*GILLT_nxv4s64*//*Label 31495*/ GIMT_Encode4(2303005), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301516 */ /*GILLT_nxv8s16*//*Label 31496*/ GIMT_Encode4(2303126),
     /* 2301520 */ /*GILLT_nxv8s32*//*Label 31497*/ GIMT_Encode4(2303247),
     /* 2301524 */ /*GILLT_nxv8s64*//*Label 31498*/ GIMT_Encode4(2303368), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301536 */ /*GILLT_nxv16s16*//*Label 31499*/ GIMT_Encode4(2303489),
     /* 2301540 */ /*GILLT_nxv16s32*//*Label 31500*/ GIMT_Encode4(2303610), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301552 */ /*GILLT_nxv32s16*//*Label 31501*/ GIMT_Encode4(2303731),
     /* 2301556 */ // Label 31484: @2301556
     /* 2301556 */ GIM_Try, /*On fail goto*//*Label 31503*/ GIMT_Encode4(2301704),
     /* 2301561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2301564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2301567 */   GIM_Try, /*On fail goto*//*Label 31504*/ GIMT_Encode4(2301601), // Rule ID 1974 //
     /* 2301572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2301575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301587 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2301587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2301590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301600 */     // GIR_Coverage, 1974,
     /* 2301600 */     GIR_EraseRootFromParent_Done,
     /* 2301601 */   // Label 31504: @2301601
     /* 2301601 */   GIM_Try, /*On fail goto*//*Label 31505*/ GIMT_Encode4(2301635), // Rule ID 1975 //
     /* 2301606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2301609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301621 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2301621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2301624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301634 */     // GIR_Coverage, 1975,
     /* 2301634 */     GIR_EraseRootFromParent_Done,
     /* 2301635 */   // Label 31505: @2301635
     /* 2301635 */   GIM_Try, /*On fail goto*//*Label 31506*/ GIMT_Encode4(2301669), // Rule ID 1978 //
     /* 2301640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2301643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301655 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2301655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2301658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301668 */     // GIR_Coverage, 1978,
     /* 2301668 */     GIR_EraseRootFromParent_Done,
     /* 2301669 */   // Label 31506: @2301669
     /* 2301669 */   GIM_Try, /*On fail goto*//*Label 31507*/ GIMT_Encode4(2301703), // Rule ID 1979 //
     /* 2301674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2301677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301689 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2301689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2301692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301702 */     // GIR_Coverage, 1979,
     /* 2301702 */     GIR_EraseRootFromParent_Done,
     /* 2301703 */   // Label 31507: @2301703
     /* 2301703 */   GIM_Reject,
     /* 2301704 */ // Label 31503: @2301704
     /* 2301704 */ GIM_Reject,
     /* 2301705 */ // Label 31485: @2301705
     /* 2301705 */ GIM_Try, /*On fail goto*//*Label 31508*/ GIMT_Encode4(2301853),
     /* 2301710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2301713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2301716 */   GIM_Try, /*On fail goto*//*Label 31509*/ GIMT_Encode4(2301750), // Rule ID 1265 //
     /* 2301721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2301724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301736 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2301736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2301739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301749 */     // GIR_Coverage, 1265,
     /* 2301749 */     GIR_EraseRootFromParent_Done,
     /* 2301750 */   // Label 31509: @2301750
     /* 2301750 */   GIM_Try, /*On fail goto*//*Label 31510*/ GIMT_Encode4(2301784), // Rule ID 1266 //
     /* 2301755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2301758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301770 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2301770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2301773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301783 */     // GIR_Coverage, 1266,
     /* 2301783 */     GIR_EraseRootFromParent_Done,
     /* 2301784 */   // Label 31510: @2301784
     /* 2301784 */   GIM_Try, /*On fail goto*//*Label 31511*/ GIMT_Encode4(2301818), // Rule ID 1269 //
     /* 2301789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2301792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301804 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2301804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2301807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301817 */     // GIR_Coverage, 1269,
     /* 2301817 */     GIR_EraseRootFromParent_Done,
     /* 2301818 */   // Label 31511: @2301818
     /* 2301818 */   GIM_Try, /*On fail goto*//*Label 31512*/ GIMT_Encode4(2301852), // Rule ID 1270 //
     /* 2301823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2301826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301838 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2301838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2301841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301851 */     // GIR_Coverage, 1270,
     /* 2301851 */     GIR_EraseRootFromParent_Done,
     /* 2301852 */   // Label 31512: @2301852
     /* 2301852 */   GIM_Reject,
     /* 2301853 */ // Label 31508: @2301853
     /* 2301853 */ GIM_Reject,
     /* 2301854 */ // Label 31486: @2301854
     /* 2301854 */ GIM_Try, /*On fail goto*//*Label 31513*/ GIMT_Encode4(2302036),
     /* 2301859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2301862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2301865 */   GIM_Try, /*On fail goto*//*Label 31514*/ GIMT_Encode4(2301899), // Rule ID 1604 //
     /* 2301870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2301873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301885 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2301885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2301888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301898 */     // GIR_Coverage, 1604,
     /* 2301898 */     GIR_EraseRootFromParent_Done,
     /* 2301899 */   // Label 31514: @2301899
     /* 2301899 */   GIM_Try, /*On fail goto*//*Label 31515*/ GIMT_Encode4(2301933), // Rule ID 1605 //
     /* 2301904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2301907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301919 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2301919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2301922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301932 */     // GIR_Coverage, 1605,
     /* 2301932 */     GIR_EraseRootFromParent_Done,
     /* 2301933 */   // Label 31515: @2301933
     /* 2301933 */   GIM_Try, /*On fail goto*//*Label 31516*/ GIMT_Encode4(2301967), // Rule ID 1608 //
     /* 2301938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2301941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301953 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2301953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2301956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301966 */     // GIR_Coverage, 1608,
     /* 2301966 */     GIR_EraseRootFromParent_Done,
     /* 2301967 */   // Label 31516: @2301967
     /* 2301967 */   GIM_Try, /*On fail goto*//*Label 31517*/ GIMT_Encode4(2302001), // Rule ID 1609 //
     /* 2301972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2301975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301987 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2301987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2301990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302000 */     // GIR_Coverage, 1609,
     /* 2302000 */     GIR_EraseRootFromParent_Done,
     /* 2302001 */   // Label 31517: @2302001
     /* 2302001 */   GIM_Try, /*On fail goto*//*Label 31518*/ GIMT_Encode4(2302035), // Rule ID 1611 //
     /* 2302006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2302009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302021 */     // (fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2302021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2302024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302034 */     // GIR_Coverage, 1611,
     /* 2302034 */     GIR_EraseRootFromParent_Done,
     /* 2302035 */   // Label 31518: @2302035
     /* 2302035 */   GIM_Reject,
     /* 2302036 */ // Label 31513: @2302036
     /* 2302036 */ GIM_Reject,
     /* 2302037 */ // Label 31487: @2302037
     /* 2302037 */ GIM_Try, /*On fail goto*//*Label 31519*/ GIMT_Encode4(2302157),
     /* 2302042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2302045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2302048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302060 */   GIM_Try, /*On fail goto*//*Label 31520*/ GIMT_Encode4(2302108), // Rule ID 54228 //
     /* 2302065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302068 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2302071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2302085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302107 */     // GIR_Coverage, 54228,
     /* 2302107 */     GIR_EraseRootFromParent_Done,
     /* 2302108 */   // Label 31520: @2302108
     /* 2302108 */   GIM_Try, /*On fail goto*//*Label 31521*/ GIMT_Encode4(2302156), // Rule ID 54229 //
     /* 2302113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302116 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2302119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2302133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302155 */     // GIR_Coverage, 54229,
     /* 2302155 */     GIR_EraseRootFromParent_Done,
     /* 2302156 */   // Label 31521: @2302156
     /* 2302156 */   GIM_Reject,
     /* 2302157 */ // Label 31519: @2302157
     /* 2302157 */ GIM_Reject,
     /* 2302158 */ // Label 31488: @2302158
     /* 2302158 */ GIM_Try, /*On fail goto*//*Label 31522*/ GIMT_Encode4(2302278),
     /* 2302163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2302166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2302169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302181 */   GIM_Try, /*On fail goto*//*Label 31523*/ GIMT_Encode4(2302229), // Rule ID 54252 //
     /* 2302186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2302189 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2302192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2302206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302228 */     // GIR_Coverage, 54252,
     /* 2302228 */     GIR_EraseRootFromParent_Done,
     /* 2302229 */   // Label 31523: @2302229
     /* 2302229 */   GIM_Try, /*On fail goto*//*Label 31524*/ GIMT_Encode4(2302277), // Rule ID 54253 //
     /* 2302234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2302237 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2302240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2302254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302276 */     // GIR_Coverage, 54253,
     /* 2302276 */     GIR_EraseRootFromParent_Done,
     /* 2302277 */   // Label 31524: @2302277
     /* 2302277 */   GIM_Reject,
     /* 2302278 */ // Label 31522: @2302278
     /* 2302278 */ GIM_Reject,
     /* 2302279 */ // Label 31489: @2302279
     /* 2302279 */ GIM_Try, /*On fail goto*//*Label 31525*/ GIMT_Encode4(2302399),
     /* 2302284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2302287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2302290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302302 */   GIM_Try, /*On fail goto*//*Label 31526*/ GIMT_Encode4(2302350), // Rule ID 54288 //
     /* 2302307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2302310 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2302313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2302327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302349 */     // GIR_Coverage, 54288,
     /* 2302349 */     GIR_EraseRootFromParent_Done,
     /* 2302350 */   // Label 31526: @2302350
     /* 2302350 */   GIM_Try, /*On fail goto*//*Label 31527*/ GIMT_Encode4(2302398), // Rule ID 54289 //
     /* 2302355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2302358 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2302361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2302375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302397 */     // GIR_Coverage, 54289,
     /* 2302397 */     GIR_EraseRootFromParent_Done,
     /* 2302398 */   // Label 31527: @2302398
     /* 2302398 */   GIM_Reject,
     /* 2302399 */ // Label 31525: @2302399
     /* 2302399 */ GIM_Reject,
     /* 2302400 */ // Label 31490: @2302400
     /* 2302400 */ GIM_Try, /*On fail goto*//*Label 31528*/ GIMT_Encode4(2302520),
     /* 2302405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2302408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2302411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302423 */   GIM_Try, /*On fail goto*//*Label 31529*/ GIMT_Encode4(2302471), // Rule ID 54240 //
     /* 2302428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302431 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2302434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2302448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302470 */     // GIR_Coverage, 54240,
     /* 2302470 */     GIR_EraseRootFromParent_Done,
     /* 2302471 */   // Label 31529: @2302471
     /* 2302471 */   GIM_Try, /*On fail goto*//*Label 31530*/ GIMT_Encode4(2302519), // Rule ID 54241 //
     /* 2302476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302479 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2302482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2302496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302518 */     // GIR_Coverage, 54241,
     /* 2302518 */     GIR_EraseRootFromParent_Done,
     /* 2302519 */   // Label 31530: @2302519
     /* 2302519 */   GIM_Reject,
     /* 2302520 */ // Label 31528: @2302520
     /* 2302520 */ GIM_Reject,
     /* 2302521 */ // Label 31491: @2302521
     /* 2302521 */ GIM_Try, /*On fail goto*//*Label 31531*/ GIMT_Encode4(2302641),
     /* 2302526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2302529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2302532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302544 */   GIM_Try, /*On fail goto*//*Label 31532*/ GIMT_Encode4(2302592), // Rule ID 54276 //
     /* 2302549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2302552 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2302555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2302569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302591 */     // GIR_Coverage, 54276,
     /* 2302591 */     GIR_EraseRootFromParent_Done,
     /* 2302592 */   // Label 31532: @2302592
     /* 2302592 */   GIM_Try, /*On fail goto*//*Label 31533*/ GIMT_Encode4(2302640), // Rule ID 54277 //
     /* 2302597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2302600 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2302603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2302617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302639 */     // GIR_Coverage, 54277,
     /* 2302639 */     GIR_EraseRootFromParent_Done,
     /* 2302640 */   // Label 31533: @2302640
     /* 2302640 */   GIM_Reject,
     /* 2302641 */ // Label 31531: @2302641
     /* 2302641 */ GIM_Reject,
     /* 2302642 */ // Label 31492: @2302642
     /* 2302642 */ GIM_Try, /*On fail goto*//*Label 31534*/ GIMT_Encode4(2302762),
     /* 2302647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2302650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2302653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302665 */   GIM_Try, /*On fail goto*//*Label 31535*/ GIMT_Encode4(2302713), // Rule ID 54372 //
     /* 2302670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2302673 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2302676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2302690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302712 */     // GIR_Coverage, 54372,
     /* 2302712 */     GIR_EraseRootFromParent_Done,
     /* 2302713 */   // Label 31535: @2302713
     /* 2302713 */   GIM_Try, /*On fail goto*//*Label 31536*/ GIMT_Encode4(2302761), // Rule ID 54373 //
     /* 2302718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2302721 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2302724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2302738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302760 */     // GIR_Coverage, 54373,
     /* 2302760 */     GIR_EraseRootFromParent_Done,
     /* 2302761 */   // Label 31536: @2302761
     /* 2302761 */   GIM_Reject,
     /* 2302762 */ // Label 31534: @2302762
     /* 2302762 */ GIM_Reject,
     /* 2302763 */ // Label 31493: @2302763
     /* 2302763 */ GIM_Try, /*On fail goto*//*Label 31537*/ GIMT_Encode4(2302883),
     /* 2302768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2302774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302786 */   GIM_Try, /*On fail goto*//*Label 31538*/ GIMT_Encode4(2302834), // Rule ID 54264 //
     /* 2302791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302794 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2302797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2302811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302833 */     // GIR_Coverage, 54264,
     /* 2302833 */     GIR_EraseRootFromParent_Done,
     /* 2302834 */   // Label 31538: @2302834
     /* 2302834 */   GIM_Try, /*On fail goto*//*Label 31539*/ GIMT_Encode4(2302882), // Rule ID 54265 //
     /* 2302839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302842 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2302845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2302859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302881 */     // GIR_Coverage, 54265,
     /* 2302881 */     GIR_EraseRootFromParent_Done,
     /* 2302882 */   // Label 31539: @2302882
     /* 2302882 */   GIM_Reject,
     /* 2302883 */ // Label 31537: @2302883
     /* 2302883 */ GIM_Reject,
     /* 2302884 */ // Label 31494: @2302884
     /* 2302884 */ GIM_Try, /*On fail goto*//*Label 31540*/ GIMT_Encode4(2303004),
     /* 2302889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2302892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2302895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302907 */   GIM_Try, /*On fail goto*//*Label 31541*/ GIMT_Encode4(2302955), // Rule ID 54336 //
     /* 2302912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2302915 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2302918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2302932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302954 */     // GIR_Coverage, 54336,
     /* 2302954 */     GIR_EraseRootFromParent_Done,
     /* 2302955 */   // Label 31541: @2302955
     /* 2302955 */   GIM_Try, /*On fail goto*//*Label 31542*/ GIMT_Encode4(2303003), // Rule ID 54337 //
     /* 2302960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2302963 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2302966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2302980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303002 */     // GIR_Coverage, 54337,
     /* 2303002 */     GIR_EraseRootFromParent_Done,
     /* 2303003 */   // Label 31542: @2303003
     /* 2303003 */   GIM_Reject,
     /* 2303004 */ // Label 31540: @2303004
     /* 2303004 */ GIM_Reject,
     /* 2303005 */ // Label 31495: @2303005
     /* 2303005 */ GIM_Try, /*On fail goto*//*Label 31543*/ GIMT_Encode4(2303125),
     /* 2303010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2303016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303028 */   GIM_Try, /*On fail goto*//*Label 31544*/ GIMT_Encode4(2303076), // Rule ID 54384 //
     /* 2303033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2303036 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2303039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2303053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303075 */     // GIR_Coverage, 54384,
     /* 2303075 */     GIR_EraseRootFromParent_Done,
     /* 2303076 */   // Label 31544: @2303076
     /* 2303076 */   GIM_Try, /*On fail goto*//*Label 31545*/ GIMT_Encode4(2303124), // Rule ID 54385 //
     /* 2303081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2303084 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2303087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2303101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303123 */     // GIR_Coverage, 54385,
     /* 2303123 */     GIR_EraseRootFromParent_Done,
     /* 2303124 */   // Label 31545: @2303124
     /* 2303124 */   GIM_Reject,
     /* 2303125 */ // Label 31543: @2303125
     /* 2303125 */ GIM_Reject,
     /* 2303126 */ // Label 31496: @2303126
     /* 2303126 */ GIM_Try, /*On fail goto*//*Label 31546*/ GIMT_Encode4(2303246),
     /* 2303131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2303134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2303137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303145 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303149 */   GIM_Try, /*On fail goto*//*Label 31547*/ GIMT_Encode4(2303197), // Rule ID 54300 //
     /* 2303154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2303157 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2303160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2303174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303196 */     // GIR_Coverage, 54300,
     /* 2303196 */     GIR_EraseRootFromParent_Done,
     /* 2303197 */   // Label 31547: @2303197
     /* 2303197 */   GIM_Try, /*On fail goto*//*Label 31548*/ GIMT_Encode4(2303245), // Rule ID 54301 //
     /* 2303202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2303205 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2303208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2303222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303244 */     // GIR_Coverage, 54301,
     /* 2303244 */     GIR_EraseRootFromParent_Done,
     /* 2303245 */   // Label 31548: @2303245
     /* 2303245 */   GIM_Reject,
     /* 2303246 */ // Label 31546: @2303246
     /* 2303246 */ GIM_Reject,
     /* 2303247 */ // Label 31497: @2303247
     /* 2303247 */ GIM_Try, /*On fail goto*//*Label 31549*/ GIMT_Encode4(2303367),
     /* 2303252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2303255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2303258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303270 */   GIM_Try, /*On fail goto*//*Label 31550*/ GIMT_Encode4(2303318), // Rule ID 54348 //
     /* 2303275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303278 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2303281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2303295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303317 */     // GIR_Coverage, 54348,
     /* 2303317 */     GIR_EraseRootFromParent_Done,
     /* 2303318 */   // Label 31550: @2303318
     /* 2303318 */   GIM_Try, /*On fail goto*//*Label 31551*/ GIMT_Encode4(2303366), // Rule ID 54349 //
     /* 2303323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303326 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2303329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2303343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303365 */     // GIR_Coverage, 54349,
     /* 2303365 */     GIR_EraseRootFromParent_Done,
     /* 2303366 */   // Label 31551: @2303366
     /* 2303366 */   GIM_Reject,
     /* 2303367 */ // Label 31549: @2303367
     /* 2303367 */ GIM_Reject,
     /* 2303368 */ // Label 31498: @2303368
     /* 2303368 */ GIM_Try, /*On fail goto*//*Label 31552*/ GIMT_Encode4(2303488),
     /* 2303373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2303376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2303379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303391 */   GIM_Try, /*On fail goto*//*Label 31553*/ GIMT_Encode4(2303439), // Rule ID 54396 //
     /* 2303396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2303399 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2303402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2303416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303438 */     // GIR_Coverage, 54396,
     /* 2303438 */     GIR_EraseRootFromParent_Done,
     /* 2303439 */   // Label 31553: @2303439
     /* 2303439 */   GIM_Try, /*On fail goto*//*Label 31554*/ GIMT_Encode4(2303487), // Rule ID 54397 //
     /* 2303444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2303447 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2303450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2303464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303486 */     // GIR_Coverage, 54397,
     /* 2303486 */     GIR_EraseRootFromParent_Done,
     /* 2303487 */   // Label 31554: @2303487
     /* 2303487 */   GIM_Reject,
     /* 2303488 */ // Label 31552: @2303488
     /* 2303488 */ GIM_Reject,
     /* 2303489 */ // Label 31499: @2303489
     /* 2303489 */ GIM_Try, /*On fail goto*//*Label 31555*/ GIMT_Encode4(2303609),
     /* 2303494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2303497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2303500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303512 */   GIM_Try, /*On fail goto*//*Label 31556*/ GIMT_Encode4(2303560), // Rule ID 54312 //
     /* 2303517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2303520 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2303523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2303537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303559 */     // GIR_Coverage, 54312,
     /* 2303559 */     GIR_EraseRootFromParent_Done,
     /* 2303560 */   // Label 31556: @2303560
     /* 2303560 */   GIM_Try, /*On fail goto*//*Label 31557*/ GIMT_Encode4(2303608), // Rule ID 54313 //
     /* 2303565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2303568 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2303571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2303585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303607 */     // GIR_Coverage, 54313,
     /* 2303607 */     GIR_EraseRootFromParent_Done,
     /* 2303608 */   // Label 31557: @2303608
     /* 2303608 */   GIM_Reject,
     /* 2303609 */ // Label 31555: @2303609
     /* 2303609 */ GIM_Reject,
     /* 2303610 */ // Label 31500: @2303610
     /* 2303610 */ GIM_Try, /*On fail goto*//*Label 31558*/ GIMT_Encode4(2303730),
     /* 2303615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2303621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303633 */   GIM_Try, /*On fail goto*//*Label 31559*/ GIMT_Encode4(2303681), // Rule ID 54360 //
     /* 2303638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303641 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2303644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2303658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303680 */     // GIR_Coverage, 54360,
     /* 2303680 */     GIR_EraseRootFromParent_Done,
     /* 2303681 */   // Label 31559: @2303681
     /* 2303681 */   GIM_Try, /*On fail goto*//*Label 31560*/ GIMT_Encode4(2303729), // Rule ID 54361 //
     /* 2303686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303689 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2303692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2303706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303728 */     // GIR_Coverage, 54361,
     /* 2303728 */     GIR_EraseRootFromParent_Done,
     /* 2303729 */   // Label 31560: @2303729
     /* 2303729 */   GIM_Reject,
     /* 2303730 */ // Label 31558: @2303730
     /* 2303730 */ GIM_Reject,
     /* 2303731 */ // Label 31501: @2303731
     /* 2303731 */ GIM_Try, /*On fail goto*//*Label 31561*/ GIMT_Encode4(2303851),
     /* 2303736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2303739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2303742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303754 */   GIM_Try, /*On fail goto*//*Label 31562*/ GIMT_Encode4(2303802), // Rule ID 54324 //
     /* 2303759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2303762 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2303765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2303779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303801 */     // GIR_Coverage, 54324,
     /* 2303801 */     GIR_EraseRootFromParent_Done,
     /* 2303802 */   // Label 31562: @2303802
     /* 2303802 */   GIM_Try, /*On fail goto*//*Label 31563*/ GIMT_Encode4(2303850), // Rule ID 54325 //
     /* 2303807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2303810 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2303813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2303827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303849 */     // GIR_Coverage, 54325,
     /* 2303849 */     GIR_EraseRootFromParent_Done,
     /* 2303850 */   // Label 31563: @2303850
     /* 2303850 */   GIM_Reject,
     /* 2303851 */ // Label 31561: @2303851
     /* 2303851 */ GIM_Reject,
     /* 2303852 */ // Label 31502: @2303852
     /* 2303852 */ GIM_Reject,
     /* 2303853 */ // Label 62: @2303853
     /* 2303853 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31582*/ GIMT_Encode4(2320497),
     /* 2303864 */ /*GILLT_s16*//*Label 31564*/ GIMT_Encode4(2303984),
     /* 2303868 */ /*GILLT_s32*//*Label 31565*/ GIMT_Encode4(2305420),
     /* 2303872 */ /*GILLT_s64*//*Label 31566*/ GIMT_Encode4(2306856), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303884 */ /*GILLT_nxv1s16*//*Label 31567*/ GIMT_Encode4(2308647),
     /* 2303888 */ /*GILLT_nxv1s32*//*Label 31568*/ GIMT_Encode4(2309437),
     /* 2303892 */ /*GILLT_nxv1s64*//*Label 31569*/ GIMT_Encode4(2310227), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303904 */ /*GILLT_nxv2s16*//*Label 31570*/ GIMT_Encode4(2311017),
     /* 2303908 */ /*GILLT_nxv2s32*//*Label 31571*/ GIMT_Encode4(2311807),
     /* 2303912 */ /*GILLT_nxv2s64*//*Label 31572*/ GIMT_Encode4(2312597), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303924 */ /*GILLT_nxv4s16*//*Label 31573*/ GIMT_Encode4(2313387),
     /* 2303928 */ /*GILLT_nxv4s32*//*Label 31574*/ GIMT_Encode4(2314177),
     /* 2303932 */ /*GILLT_nxv4s64*//*Label 31575*/ GIMT_Encode4(2314967), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303944 */ /*GILLT_nxv8s16*//*Label 31576*/ GIMT_Encode4(2315757),
     /* 2303948 */ /*GILLT_nxv8s32*//*Label 31577*/ GIMT_Encode4(2316547),
     /* 2303952 */ /*GILLT_nxv8s64*//*Label 31578*/ GIMT_Encode4(2317337), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303964 */ /*GILLT_nxv16s16*//*Label 31579*/ GIMT_Encode4(2318127),
     /* 2303968 */ /*GILLT_nxv16s32*//*Label 31580*/ GIMT_Encode4(2318917), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303980 */ /*GILLT_nxv32s16*//*Label 31581*/ GIMT_Encode4(2319707),
     /* 2303984 */ // Label 31564: @2303984
     /* 2303984 */ GIM_Try, /*On fail goto*//*Label 31583*/ GIMT_Encode4(2305419),
     /* 2303989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2303995 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2303998 */   GIM_Try, /*On fail goto*//*Label 31584*/ GIMT_Encode4(2304070), // Rule ID 2015 //
     /* 2304003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2304006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304050 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2304053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2304065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304069 */     // GIR_Coverage, 2015,
     /* 2304069 */     GIR_EraseRootFromParent_Done,
     /* 2304070 */   // Label 31584: @2304070
     /* 2304070 */   GIM_Try, /*On fail goto*//*Label 31585*/ GIMT_Encode4(2304142), // Rule ID 2016 //
     /* 2304075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2304078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304122 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2304125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2304137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304141 */     // GIR_Coverage, 2016,
     /* 2304141 */     GIR_EraseRootFromParent_Done,
     /* 2304142 */   // Label 31585: @2304142
     /* 2304142 */   GIM_Try, /*On fail goto*//*Label 31586*/ GIMT_Encode4(2304214), // Rule ID 2048 //
     /* 2304147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2304150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304194 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2304197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2304209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304213 */     // GIR_Coverage, 2048,
     /* 2304213 */     GIR_EraseRootFromParent_Done,
     /* 2304214 */   // Label 31586: @2304214
     /* 2304214 */   GIM_Try, /*On fail goto*//*Label 31587*/ GIMT_Encode4(2304286), // Rule ID 2049 //
     /* 2304219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2304222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304266 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2304269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2304281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304285 */     // GIR_Coverage, 2049,
     /* 2304285 */     GIR_EraseRootFromParent_Done,
     /* 2304286 */   // Label 31587: @2304286
     /* 2304286 */   GIM_Try, /*On fail goto*//*Label 31588*/ GIMT_Encode4(2304358), // Rule ID 65474 //
     /* 2304291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2304294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304338 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2304341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2304349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2304353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304357 */     // GIR_Coverage, 65474,
     /* 2304357 */     GIR_EraseRootFromParent_Done,
     /* 2304358 */   // Label 31588: @2304358
     /* 2304358 */   GIM_Try, /*On fail goto*//*Label 31589*/ GIMT_Encode4(2304430), // Rule ID 65475 //
     /* 2304363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2304366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304410 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2304413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2304421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2304425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304429 */     // GIR_Coverage, 65475,
     /* 2304429 */     GIR_EraseRootFromParent_Done,
     /* 2304430 */   // Label 31589: @2304430
     /* 2304430 */   GIM_Try, /*On fail goto*//*Label 31590*/ GIMT_Encode4(2304502), // Rule ID 65482 //
     /* 2304435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2304438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304482 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2304485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2304493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2304497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304501 */     // GIR_Coverage, 65482,
     /* 2304501 */     GIR_EraseRootFromParent_Done,
     /* 2304502 */   // Label 31590: @2304502
     /* 2304502 */   GIM_Try, /*On fail goto*//*Label 31591*/ GIMT_Encode4(2304574), // Rule ID 65483 //
     /* 2304507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2304510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304554 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2304557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2304565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2304569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304573 */     // GIR_Coverage, 65483,
     /* 2304573 */     GIR_EraseRootFromParent_Done,
     /* 2304574 */   // Label 31591: @2304574
     /* 2304574 */   GIM_Try, /*On fail goto*//*Label 31592*/ GIMT_Encode4(2304631), // Rule ID 2011 //
     /* 2304579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2304582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304613 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2304616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304630 */     // GIR_Coverage, 2011,
     /* 2304630 */     GIR_EraseRootFromParent_Done,
     /* 2304631 */   // Label 31592: @2304631
     /* 2304631 */   GIM_Try, /*On fail goto*//*Label 31593*/ GIMT_Encode4(2304688), // Rule ID 2012 //
     /* 2304636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2304639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304670 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2304673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304687 */     // GIR_Coverage, 2012,
     /* 2304687 */     GIR_EraseRootFromParent_Done,
     /* 2304688 */   // Label 31593: @2304688
     /* 2304688 */   GIM_Try, /*On fail goto*//*Label 31594*/ GIMT_Encode4(2304745), // Rule ID 2044 //
     /* 2304693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2304696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304727 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2304730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304744 */     // GIR_Coverage, 2044,
     /* 2304744 */     GIR_EraseRootFromParent_Done,
     /* 2304745 */   // Label 31594: @2304745
     /* 2304745 */   GIM_Try, /*On fail goto*//*Label 31595*/ GIMT_Encode4(2304802), // Rule ID 2045 //
     /* 2304750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2304753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304784 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2304787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304801 */     // GIR_Coverage, 2045,
     /* 2304801 */     GIR_EraseRootFromParent_Done,
     /* 2304802 */   // Label 31595: @2304802
     /* 2304802 */   GIM_Try, /*On fail goto*//*Label 31596*/ GIMT_Encode4(2304859), // Rule ID 65470 //
     /* 2304807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2304810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304841 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2304844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2304852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304858 */     // GIR_Coverage, 65470,
     /* 2304858 */     GIR_EraseRootFromParent_Done,
     /* 2304859 */   // Label 31596: @2304859
     /* 2304859 */   GIM_Try, /*On fail goto*//*Label 31597*/ GIMT_Encode4(2304916), // Rule ID 65471 //
     /* 2304864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2304867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304898 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2304901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2304909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304915 */     // GIR_Coverage, 65471,
     /* 2304915 */     GIR_EraseRootFromParent_Done,
     /* 2304916 */   // Label 31597: @2304916
     /* 2304916 */   GIM_Try, /*On fail goto*//*Label 31598*/ GIMT_Encode4(2304973), // Rule ID 65478 //
     /* 2304921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2304924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304955 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2304958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2304966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304972 */     // GIR_Coverage, 65478,
     /* 2304972 */     GIR_EraseRootFromParent_Done,
     /* 2304973 */   // Label 31598: @2304973
     /* 2304973 */   GIM_Try, /*On fail goto*//*Label 31599*/ GIMT_Encode4(2305030), // Rule ID 65479 //
     /* 2304978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2304981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2305001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305012 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2305012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2305015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2305023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2305025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305029 */     // GIR_Coverage, 65479,
     /* 2305029 */     GIR_EraseRootFromParent_Done,
     /* 2305030 */   // Label 31599: @2305030
     /* 2305030 */   GIM_Try, /*On fail goto*//*Label 31600*/ GIMT_Encode4(2305087), // Rule ID 2007 //
     /* 2305035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2305038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2305054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2305062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305069 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2305069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2305072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2305082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305086 */     // GIR_Coverage, 2007,
     /* 2305086 */     GIR_EraseRootFromParent_Done,
     /* 2305087 */   // Label 31600: @2305087
     /* 2305087 */   GIM_Try, /*On fail goto*//*Label 31601*/ GIMT_Encode4(2305144), // Rule ID 2008 //
     /* 2305092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2305095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2305111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2305119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305126 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2305126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2305129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2305139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305143 */     // GIR_Coverage, 2008,
     /* 2305143 */     GIR_EraseRootFromParent_Done,
     /* 2305144 */   // Label 31601: @2305144
     /* 2305144 */   GIM_Try, /*On fail goto*//*Label 31602*/ GIMT_Encode4(2305201), // Rule ID 2040 //
     /* 2305149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2305152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2305168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2305176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305183 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2305183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2305186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2305196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305200 */     // GIR_Coverage, 2040,
     /* 2305200 */     GIR_EraseRootFromParent_Done,
     /* 2305201 */   // Label 31602: @2305201
     /* 2305201 */   GIM_Try, /*On fail goto*//*Label 31603*/ GIMT_Encode4(2305258), // Rule ID 2041 //
     /* 2305206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2305209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2305225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2305233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305240 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2305240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2305243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2305253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305257 */     // GIR_Coverage, 2041,
     /* 2305257 */     GIR_EraseRootFromParent_Done,
     /* 2305258 */   // Label 31603: @2305258
     /* 2305258 */   GIM_Try, /*On fail goto*//*Label 31604*/ GIMT_Encode4(2305298), // Rule ID 2003 //
     /* 2305263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2305266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305282 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2305282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2305285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2305293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305297 */     // GIR_Coverage, 2003,
     /* 2305297 */     GIR_EraseRootFromParent_Done,
     /* 2305298 */   // Label 31604: @2305298
     /* 2305298 */   GIM_Try, /*On fail goto*//*Label 31605*/ GIMT_Encode4(2305338), // Rule ID 2004 //
     /* 2305303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2305306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2305322 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2305322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2305325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2305333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305337 */     // GIR_Coverage, 2004,
     /* 2305337 */     GIR_EraseRootFromParent_Done,
     /* 2305338 */   // Label 31605: @2305338
     /* 2305338 */   GIM_Try, /*On fail goto*//*Label 31606*/ GIMT_Encode4(2305378), // Rule ID 2036 //
     /* 2305343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2305346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305362 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2305362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2305365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2305373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305377 */     // GIR_Coverage, 2036,
     /* 2305377 */     GIR_EraseRootFromParent_Done,
     /* 2305378 */   // Label 31606: @2305378
     /* 2305378 */   GIM_Try, /*On fail goto*//*Label 31607*/ GIMT_Encode4(2305418), // Rule ID 2037 //
     /* 2305383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2305386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305402 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2305402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2305405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2305413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305417 */     // GIR_Coverage, 2037,
     /* 2305417 */     GIR_EraseRootFromParent_Done,
     /* 2305418 */   // Label 31607: @2305418
     /* 2305418 */   GIM_Reject,
     /* 2305419 */ // Label 31583: @2305419
     /* 2305419 */ GIM_Reject,
     /* 2305420 */ // Label 31565: @2305420
     /* 2305420 */ GIM_Try, /*On fail goto*//*Label 31608*/ GIMT_Encode4(2306855),
     /* 2305425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2305431 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2305434 */   GIM_Try, /*On fail goto*//*Label 31609*/ GIMT_Encode4(2305506), // Rule ID 1314 //
     /* 2305439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2305442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305486 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2305486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2305489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305505 */     // GIR_Coverage, 1314,
     /* 2305505 */     GIR_EraseRootFromParent_Done,
     /* 2305506 */   // Label 31609: @2305506
     /* 2305506 */   GIM_Try, /*On fail goto*//*Label 31610*/ GIMT_Encode4(2305578), // Rule ID 1315 //
     /* 2305511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2305514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305551 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305558 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2305558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2305561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305577 */     // GIR_Coverage, 1315,
     /* 2305577 */     GIR_EraseRootFromParent_Done,
     /* 2305578 */   // Label 31610: @2305578
     /* 2305578 */   GIM_Try, /*On fail goto*//*Label 31611*/ GIMT_Encode4(2305650), // Rule ID 1335 //
     /* 2305583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2305586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305630 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2305630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2305633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305649 */     // GIR_Coverage, 1335,
     /* 2305649 */     GIR_EraseRootFromParent_Done,
     /* 2305650 */   // Label 31611: @2305650
     /* 2305650 */   GIM_Try, /*On fail goto*//*Label 31612*/ GIMT_Encode4(2305722), // Rule ID 1336 //
     /* 2305655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2305658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305702 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2305702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2305705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305721 */     // GIR_Coverage, 1336,
     /* 2305721 */     GIR_EraseRootFromParent_Done,
     /* 2305722 */   // Label 31612: @2305722
     /* 2305722 */   GIM_Try, /*On fail goto*//*Label 31613*/ GIMT_Encode4(2305794), // Rule ID 65438 //
     /* 2305727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2305730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305774 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2305774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2305777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2305785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305793 */     // GIR_Coverage, 65438,
     /* 2305793 */     GIR_EraseRootFromParent_Done,
     /* 2305794 */   // Label 31613: @2305794
     /* 2305794 */   GIM_Try, /*On fail goto*//*Label 31614*/ GIMT_Encode4(2305866), // Rule ID 65439 //
     /* 2305799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2305802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305839 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305846 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2305846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2305849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2305857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305865 */     // GIR_Coverage, 65439,
     /* 2305865 */     GIR_EraseRootFromParent_Done,
     /* 2305866 */   // Label 31614: @2305866
     /* 2305866 */   GIM_Try, /*On fail goto*//*Label 31615*/ GIMT_Encode4(2305938), // Rule ID 65446 //
     /* 2305871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2305874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305918 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2305918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2305921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2305929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305937 */     // GIR_Coverage, 65446,
     /* 2305937 */     GIR_EraseRootFromParent_Done,
     /* 2305938 */   // Label 31615: @2305938
     /* 2305938 */   GIM_Try, /*On fail goto*//*Label 31616*/ GIMT_Encode4(2306010), // Rule ID 65447 //
     /* 2305943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2305946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305990 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2305990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2305993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306009 */     // GIR_Coverage, 65447,
     /* 2306009 */     GIR_EraseRootFromParent_Done,
     /* 2306010 */   // Label 31616: @2306010
     /* 2306010 */   GIM_Try, /*On fail goto*//*Label 31617*/ GIMT_Encode4(2306067), // Rule ID 1310 //
     /* 2306015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2306018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306049 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2306049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2306052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306066 */     // GIR_Coverage, 1310,
     /* 2306066 */     GIR_EraseRootFromParent_Done,
     /* 2306067 */   // Label 31617: @2306067
     /* 2306067 */   GIM_Try, /*On fail goto*//*Label 31618*/ GIMT_Encode4(2306124), // Rule ID 1311 //
     /* 2306072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2306075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306106 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2306106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2306109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306123 */     // GIR_Coverage, 1311,
     /* 2306123 */     GIR_EraseRootFromParent_Done,
     /* 2306124 */   // Label 31618: @2306124
     /* 2306124 */   GIM_Try, /*On fail goto*//*Label 31619*/ GIMT_Encode4(2306181), // Rule ID 1331 //
     /* 2306129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2306132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306163 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2306163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2306166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306180 */     // GIR_Coverage, 1331,
     /* 2306180 */     GIR_EraseRootFromParent_Done,
     /* 2306181 */   // Label 31619: @2306181
     /* 2306181 */   GIM_Try, /*On fail goto*//*Label 31620*/ GIMT_Encode4(2306238), // Rule ID 1332 //
     /* 2306186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2306189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306220 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2306220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2306223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306237 */     // GIR_Coverage, 1332,
     /* 2306237 */     GIR_EraseRootFromParent_Done,
     /* 2306238 */   // Label 31620: @2306238
     /* 2306238 */   GIM_Try, /*On fail goto*//*Label 31621*/ GIMT_Encode4(2306295), // Rule ID 65434 //
     /* 2306243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2306246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306277 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2306277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2306280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306294 */     // GIR_Coverage, 65434,
     /* 2306294 */     GIR_EraseRootFromParent_Done,
     /* 2306295 */   // Label 31621: @2306295
     /* 2306295 */   GIM_Try, /*On fail goto*//*Label 31622*/ GIMT_Encode4(2306352), // Rule ID 65435 //
     /* 2306300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2306303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306334 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2306334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2306337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306351 */     // GIR_Coverage, 65435,
     /* 2306351 */     GIR_EraseRootFromParent_Done,
     /* 2306352 */   // Label 31622: @2306352
     /* 2306352 */   GIM_Try, /*On fail goto*//*Label 31623*/ GIMT_Encode4(2306409), // Rule ID 65442 //
     /* 2306357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2306360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306391 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2306391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2306394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306408 */     // GIR_Coverage, 65442,
     /* 2306408 */     GIR_EraseRootFromParent_Done,
     /* 2306409 */   // Label 31623: @2306409
     /* 2306409 */   GIM_Try, /*On fail goto*//*Label 31624*/ GIMT_Encode4(2306466), // Rule ID 65443 //
     /* 2306414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2306417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306448 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2306448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2306451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306465 */     // GIR_Coverage, 65443,
     /* 2306465 */     GIR_EraseRootFromParent_Done,
     /* 2306466 */   // Label 31624: @2306466
     /* 2306466 */   GIM_Try, /*On fail goto*//*Label 31625*/ GIMT_Encode4(2306523), // Rule ID 1306 //
     /* 2306471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2306474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2306490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306505 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2306505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2306508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2306518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306522 */     // GIR_Coverage, 1306,
     /* 2306522 */     GIR_EraseRootFromParent_Done,
     /* 2306523 */   // Label 31625: @2306523
     /* 2306523 */   GIM_Try, /*On fail goto*//*Label 31626*/ GIMT_Encode4(2306580), // Rule ID 1307 //
     /* 2306528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2306531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2306547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306562 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2306562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2306565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2306575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306579 */     // GIR_Coverage, 1307,
     /* 2306579 */     GIR_EraseRootFromParent_Done,
     /* 2306580 */   // Label 31626: @2306580
     /* 2306580 */   GIM_Try, /*On fail goto*//*Label 31627*/ GIMT_Encode4(2306637), // Rule ID 1327 //
     /* 2306585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2306588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2306604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306619 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2306619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2306622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2306632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306636 */     // GIR_Coverage, 1327,
     /* 2306636 */     GIR_EraseRootFromParent_Done,
     /* 2306637 */   // Label 31627: @2306637
     /* 2306637 */   GIM_Try, /*On fail goto*//*Label 31628*/ GIMT_Encode4(2306694), // Rule ID 1328 //
     /* 2306642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2306645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2306661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306676 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2306676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2306679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2306689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306693 */     // GIR_Coverage, 1328,
     /* 2306693 */     GIR_EraseRootFromParent_Done,
     /* 2306694 */   // Label 31628: @2306694
     /* 2306694 */   GIM_Try, /*On fail goto*//*Label 31629*/ GIMT_Encode4(2306734), // Rule ID 1302 //
     /* 2306699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2306702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306718 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2306718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2306721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306733 */     // GIR_Coverage, 1302,
     /* 2306733 */     GIR_EraseRootFromParent_Done,
     /* 2306734 */   // Label 31629: @2306734
     /* 2306734 */   GIM_Try, /*On fail goto*//*Label 31630*/ GIMT_Encode4(2306774), // Rule ID 1303 //
     /* 2306739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2306742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306758 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2306758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2306761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306773 */     // GIR_Coverage, 1303,
     /* 2306773 */     GIR_EraseRootFromParent_Done,
     /* 2306774 */   // Label 31630: @2306774
     /* 2306774 */   GIM_Try, /*On fail goto*//*Label 31631*/ GIMT_Encode4(2306814), // Rule ID 1323 //
     /* 2306779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2306782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306798 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2306798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2306801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306813 */     // GIR_Coverage, 1323,
     /* 2306813 */     GIR_EraseRootFromParent_Done,
     /* 2306814 */   // Label 31631: @2306814
     /* 2306814 */   GIM_Try, /*On fail goto*//*Label 31632*/ GIMT_Encode4(2306854), // Rule ID 1324 //
     /* 2306819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2306822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306838 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2306838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2306841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306853 */     // GIR_Coverage, 1324,
     /* 2306853 */     GIR_EraseRootFromParent_Done,
     /* 2306854 */   // Label 31632: @2306854
     /* 2306854 */   GIM_Reject,
     /* 2306855 */ // Label 31608: @2306855
     /* 2306855 */ GIM_Reject,
     /* 2306856 */ // Label 31566: @2306856
     /* 2306856 */ GIM_Try, /*On fail goto*//*Label 31633*/ GIMT_Encode4(2308646),
     /* 2306861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2306867 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2306870 */   GIM_Try, /*On fail goto*//*Label 31634*/ GIMT_Encode4(2306942), // Rule ID 1651 //
     /* 2306875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2306878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306922 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2306922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2306925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306941 */     // GIR_Coverage, 1651,
     /* 2306941 */     GIR_EraseRootFromParent_Done,
     /* 2306942 */   // Label 31634: @2306942
     /* 2306942 */   GIM_Try, /*On fail goto*//*Label 31635*/ GIMT_Encode4(2307014), // Rule ID 1652 //
     /* 2306947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2306950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306994 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2306994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2306997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307013 */     // GIR_Coverage, 1652,
     /* 2307013 */     GIR_EraseRootFromParent_Done,
     /* 2307014 */   // Label 31635: @2307014
     /* 2307014 */   GIM_Try, /*On fail goto*//*Label 31636*/ GIMT_Encode4(2307086), // Rule ID 1674 //
     /* 2307019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2307022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307066 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2307069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307085 */     // GIR_Coverage, 1674,
     /* 2307085 */     GIR_EraseRootFromParent_Done,
     /* 2307086 */   // Label 31636: @2307086
     /* 2307086 */   GIM_Try, /*On fail goto*//*Label 31637*/ GIMT_Encode4(2307158), // Rule ID 1706 //
     /* 2307091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2307094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307138 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2307141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307157 */     // GIR_Coverage, 1706,
     /* 2307157 */     GIR_EraseRootFromParent_Done,
     /* 2307158 */   // Label 31637: @2307158
     /* 2307158 */   GIM_Try, /*On fail goto*//*Label 31638*/ GIMT_Encode4(2307230), // Rule ID 1707 //
     /* 2307163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2307166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307210 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2307210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2307213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307229 */     // GIR_Coverage, 1707,
     /* 2307229 */     GIR_EraseRootFromParent_Done,
     /* 2307230 */   // Label 31638: @2307230
     /* 2307230 */   GIM_Try, /*On fail goto*//*Label 31639*/ GIMT_Encode4(2307302), // Rule ID 65454 //
     /* 2307235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2307238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307282 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2307285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307301 */     // GIR_Coverage, 65454,
     /* 2307301 */     GIR_EraseRootFromParent_Done,
     /* 2307302 */   // Label 31639: @2307302
     /* 2307302 */   GIM_Try, /*On fail goto*//*Label 31640*/ GIMT_Encode4(2307374), // Rule ID 65455 //
     /* 2307307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2307310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307354 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2307354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2307357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307373 */     // GIR_Coverage, 65455,
     /* 2307373 */     GIR_EraseRootFromParent_Done,
     /* 2307374 */   // Label 31640: @2307374
     /* 2307374 */   GIM_Try, /*On fail goto*//*Label 31641*/ GIMT_Encode4(2307446), // Rule ID 65459 //
     /* 2307379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2307382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307426 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2307429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307445 */     // GIR_Coverage, 65459,
     /* 2307445 */     GIR_EraseRootFromParent_Done,
     /* 2307446 */   // Label 31641: @2307446
     /* 2307446 */   GIM_Try, /*On fail goto*//*Label 31642*/ GIMT_Encode4(2307518), // Rule ID 65466 //
     /* 2307451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2307454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307498 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2307501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307517 */     // GIR_Coverage, 65466,
     /* 2307517 */     GIR_EraseRootFromParent_Done,
     /* 2307518 */   // Label 31642: @2307518
     /* 2307518 */   GIM_Try, /*On fail goto*//*Label 31643*/ GIMT_Encode4(2307590), // Rule ID 65467 //
     /* 2307523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2307526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307570 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2307570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2307573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307589 */     // GIR_Coverage, 65467,
     /* 2307589 */     GIR_EraseRootFromParent_Done,
     /* 2307590 */   // Label 31643: @2307590
     /* 2307590 */   GIM_Try, /*On fail goto*//*Label 31644*/ GIMT_Encode4(2307647), // Rule ID 1647 //
     /* 2307595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2307598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307629 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2307632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307646 */     // GIR_Coverage, 1647,
     /* 2307646 */     GIR_EraseRootFromParent_Done,
     /* 2307647 */   // Label 31644: @2307647
     /* 2307647 */   GIM_Try, /*On fail goto*//*Label 31645*/ GIMT_Encode4(2307704), // Rule ID 1648 //
     /* 2307652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2307655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307686 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2307686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2307689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307703 */     // GIR_Coverage, 1648,
     /* 2307703 */     GIR_EraseRootFromParent_Done,
     /* 2307704 */   // Label 31645: @2307704
     /* 2307704 */   GIM_Try, /*On fail goto*//*Label 31646*/ GIMT_Encode4(2307761), // Rule ID 1672 //
     /* 2307709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2307712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307743 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2307746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307760 */     // GIR_Coverage, 1672,
     /* 2307760 */     GIR_EraseRootFromParent_Done,
     /* 2307761 */   // Label 31646: @2307761
     /* 2307761 */   GIM_Try, /*On fail goto*//*Label 31647*/ GIMT_Encode4(2307818), // Rule ID 1702 //
     /* 2307766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2307769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307800 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2307803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307817 */     // GIR_Coverage, 1702,
     /* 2307817 */     GIR_EraseRootFromParent_Done,
     /* 2307818 */   // Label 31647: @2307818
     /* 2307818 */   GIM_Try, /*On fail goto*//*Label 31648*/ GIMT_Encode4(2307875), // Rule ID 1703 //
     /* 2307823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2307826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307857 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2307857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2307860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307874 */     // GIR_Coverage, 1703,
     /* 2307874 */     GIR_EraseRootFromParent_Done,
     /* 2307875 */   // Label 31648: @2307875
     /* 2307875 */   GIM_Try, /*On fail goto*//*Label 31649*/ GIMT_Encode4(2307932), // Rule ID 65450 //
     /* 2307880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2307883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307914 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2307917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307931 */     // GIR_Coverage, 65450,
     /* 2307931 */     GIR_EraseRootFromParent_Done,
     /* 2307932 */   // Label 31649: @2307932
     /* 2307932 */   GIM_Try, /*On fail goto*//*Label 31650*/ GIMT_Encode4(2307989), // Rule ID 65451 //
     /* 2307937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2307940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307971 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2307971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2307974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307988 */     // GIR_Coverage, 65451,
     /* 2307988 */     GIR_EraseRootFromParent_Done,
     /* 2307989 */   // Label 31650: @2307989
     /* 2307989 */   GIM_Try, /*On fail goto*//*Label 31651*/ GIMT_Encode4(2308046), // Rule ID 65457 //
     /* 2307994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2307997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2308017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308028 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2308028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2308031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2308039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308045 */     // GIR_Coverage, 65457,
     /* 2308045 */     GIR_EraseRootFromParent_Done,
     /* 2308046 */   // Label 31651: @2308046
     /* 2308046 */   GIM_Try, /*On fail goto*//*Label 31652*/ GIMT_Encode4(2308103), // Rule ID 65462 //
     /* 2308051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2308054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2308074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308085 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2308085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2308088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2308096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308102 */     // GIR_Coverage, 65462,
     /* 2308102 */     GIR_EraseRootFromParent_Done,
     /* 2308103 */   // Label 31652: @2308103
     /* 2308103 */   GIM_Try, /*On fail goto*//*Label 31653*/ GIMT_Encode4(2308160), // Rule ID 65463 //
     /* 2308108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2308111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2308131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308142 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2308142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2308145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2308153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308159 */     // GIR_Coverage, 65463,
     /* 2308159 */     GIR_EraseRootFromParent_Done,
     /* 2308160 */   // Label 31653: @2308160
     /* 2308160 */   GIM_Try, /*On fail goto*//*Label 31654*/ GIMT_Encode4(2308217), // Rule ID 1643 //
     /* 2308165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2308168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2308192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308199 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2308199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2308202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2308212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308216 */     // GIR_Coverage, 1643,
     /* 2308216 */     GIR_EraseRootFromParent_Done,
     /* 2308217 */   // Label 31654: @2308217
     /* 2308217 */   GIM_Try, /*On fail goto*//*Label 31655*/ GIMT_Encode4(2308274), // Rule ID 1644 //
     /* 2308222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2308225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2308249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308256 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2308256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2308259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2308269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308273 */     // GIR_Coverage, 1644,
     /* 2308273 */     GIR_EraseRootFromParent_Done,
     /* 2308274 */   // Label 31655: @2308274
     /* 2308274 */   GIM_Try, /*On fail goto*//*Label 31656*/ GIMT_Encode4(2308331), // Rule ID 1670 //
     /* 2308279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2308282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2308306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308313 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2308313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2308316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2308326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308330 */     // GIR_Coverage, 1670,
     /* 2308330 */     GIR_EraseRootFromParent_Done,
     /* 2308331 */   // Label 31656: @2308331
     /* 2308331 */   GIM_Try, /*On fail goto*//*Label 31657*/ GIMT_Encode4(2308388), // Rule ID 1698 //
     /* 2308336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2308339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2308363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308370 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2308370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2308373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2308383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308387 */     // GIR_Coverage, 1698,
     /* 2308387 */     GIR_EraseRootFromParent_Done,
     /* 2308388 */   // Label 31657: @2308388
     /* 2308388 */   GIM_Try, /*On fail goto*//*Label 31658*/ GIMT_Encode4(2308445), // Rule ID 1699 //
     /* 2308393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2308396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2308420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308427 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2308427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2308430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2308440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308444 */     // GIR_Coverage, 1699,
     /* 2308444 */     GIR_EraseRootFromParent_Done,
     /* 2308445 */   // Label 31658: @2308445
     /* 2308445 */   GIM_Try, /*On fail goto*//*Label 31659*/ GIMT_Encode4(2308485), // Rule ID 1639 //
     /* 2308450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2308453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308469 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2308469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2308472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308484 */     // GIR_Coverage, 1639,
     /* 2308484 */     GIR_EraseRootFromParent_Done,
     /* 2308485 */   // Label 31659: @2308485
     /* 2308485 */   GIM_Try, /*On fail goto*//*Label 31660*/ GIMT_Encode4(2308525), // Rule ID 1640 //
     /* 2308490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2308493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308509 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2308509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2308512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308524 */     // GIR_Coverage, 1640,
     /* 2308524 */     GIR_EraseRootFromParent_Done,
     /* 2308525 */   // Label 31660: @2308525
     /* 2308525 */   GIM_Try, /*On fail goto*//*Label 31661*/ GIMT_Encode4(2308565), // Rule ID 1668 //
     /* 2308530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2308533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308549 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2308549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2308552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308564 */     // GIR_Coverage, 1668,
     /* 2308564 */     GIR_EraseRootFromParent_Done,
     /* 2308565 */   // Label 31661: @2308565
     /* 2308565 */   GIM_Try, /*On fail goto*//*Label 31662*/ GIMT_Encode4(2308605), // Rule ID 1694 //
     /* 2308570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2308573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308589 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2308589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2308592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308604 */     // GIR_Coverage, 1694,
     /* 2308604 */     GIR_EraseRootFromParent_Done,
     /* 2308605 */   // Label 31662: @2308605
     /* 2308605 */   GIM_Try, /*On fail goto*//*Label 31663*/ GIMT_Encode4(2308645), // Rule ID 1695 //
     /* 2308610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2308613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308629 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2308629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2308632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308644 */     // GIR_Coverage, 1695,
     /* 2308644 */     GIR_EraseRootFromParent_Done,
     /* 2308645 */   // Label 31663: @2308645
     /* 2308645 */   GIM_Reject,
     /* 2308646 */ // Label 31633: @2308646
     /* 2308646 */ GIM_Reject,
     /* 2308647 */ // Label 31567: @2308647
     /* 2308647 */ GIM_Try, /*On fail goto*//*Label 31664*/ GIMT_Encode4(2309436),
     /* 2308652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2308658 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2308661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308665 */   GIM_Try, /*On fail goto*//*Label 31665*/ GIMT_Encode4(2308742), // Rule ID 54842 //
     /* 2308670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308713 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2308716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2308728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308741 */     // GIR_Coverage, 54842,
     /* 2308741 */     GIR_EraseRootFromParent_Done,
     /* 2308742 */   // Label 31665: @2308742
     /* 2308742 */   GIM_Try, /*On fail goto*//*Label 31666*/ GIMT_Encode4(2308819), // Rule ID 54843 //
     /* 2308747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308790 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2308793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2308805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308818 */     // GIR_Coverage, 54843,
     /* 2308818 */     GIR_EraseRootFromParent_Done,
     /* 2308819 */   // Label 31666: @2308819
     /* 2308819 */   GIM_Try, /*On fail goto*//*Label 31667*/ GIMT_Encode4(2308896), // Rule ID 72438 //
     /* 2308824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308867 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2308870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2308882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308895 */     // GIR_Coverage, 72438,
     /* 2308895 */     GIR_EraseRootFromParent_Done,
     /* 2308896 */   // Label 31667: @2308896
     /* 2308896 */   GIM_Try, /*On fail goto*//*Label 31668*/ GIMT_Encode4(2308973), // Rule ID 72439 //
     /* 2308901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308944 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2308947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2308959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308972 */     // GIR_Coverage, 72439,
     /* 2308972 */     GIR_EraseRootFromParent_Done,
     /* 2308973 */   // Label 31668: @2308973
     /* 2308973 */   GIM_Try, /*On fail goto*//*Label 31669*/ GIMT_Encode4(2309035), // Rule ID 54846 //
     /* 2308978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309008 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2309011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309034 */     // GIR_Coverage, 54846,
     /* 2309034 */     GIR_EraseRootFromParent_Done,
     /* 2309035 */   // Label 31669: @2309035
     /* 2309035 */   GIM_Try, /*On fail goto*//*Label 31670*/ GIMT_Encode4(2309097), // Rule ID 54847 //
     /* 2309040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2309043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2309055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309070 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2309073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309096 */     // GIR_Coverage, 54847,
     /* 2309096 */     GIR_EraseRootFromParent_Done,
     /* 2309097 */   // Label 31670: @2309097
     /* 2309097 */   GIM_Try, /*On fail goto*//*Label 31671*/ GIMT_Encode4(2309159), // Rule ID 72442 //
     /* 2309102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2309105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2309121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309132 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2309135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309158 */     // GIR_Coverage, 72442,
     /* 2309158 */     GIR_EraseRootFromParent_Done,
     /* 2309159 */   // Label 31671: @2309159
     /* 2309159 */   GIM_Try, /*On fail goto*//*Label 31672*/ GIMT_Encode4(2309221), // Rule ID 72443 //
     /* 2309164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2309167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2309183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309194 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2309197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309220 */     // GIR_Coverage, 72443,
     /* 2309220 */     GIR_EraseRootFromParent_Done,
     /* 2309221 */   // Label 31672: @2309221
     /* 2309221 */   GIM_Try, /*On fail goto*//*Label 31673*/ GIMT_Encode4(2309283), // Rule ID 54838 //
     /* 2309226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2309229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2309241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2309249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309256 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2309259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2309269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309282 */     // GIR_Coverage, 54838,
     /* 2309282 */     GIR_EraseRootFromParent_Done,
     /* 2309283 */   // Label 31673: @2309283
     /* 2309283 */   GIM_Try, /*On fail goto*//*Label 31674*/ GIMT_Encode4(2309345), // Rule ID 54839 //
     /* 2309288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2309291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2309303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2309311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309318 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2309321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2309331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309344 */     // GIR_Coverage, 54839,
     /* 2309344 */     GIR_EraseRootFromParent_Done,
     /* 2309345 */   // Label 31674: @2309345
     /* 2309345 */   GIM_Try, /*On fail goto*//*Label 31675*/ GIMT_Encode4(2309390), // Rule ID 54834 //
     /* 2309350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2309353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309365 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2309368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309389 */     // GIR_Coverage, 54834,
     /* 2309389 */     GIR_EraseRootFromParent_Done,
     /* 2309390 */   // Label 31675: @2309390
     /* 2309390 */   GIM_Try, /*On fail goto*//*Label 31676*/ GIMT_Encode4(2309435), // Rule ID 54835 //
     /* 2309395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2309398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309410 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2309413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309434 */     // GIR_Coverage, 54835,
     /* 2309434 */     GIR_EraseRootFromParent_Done,
     /* 2309435 */   // Label 31676: @2309435
     /* 2309435 */   GIM_Reject,
     /* 2309436 */ // Label 31664: @2309436
     /* 2309436 */ GIM_Reject,
     /* 2309437 */ // Label 31568: @2309437
     /* 2309437 */ GIM_Try, /*On fail goto*//*Label 31677*/ GIMT_Encode4(2310226),
     /* 2309442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2309448 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2309451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309455 */   GIM_Try, /*On fail goto*//*Label 31678*/ GIMT_Encode4(2309532), // Rule ID 54970 //
     /* 2309460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309503 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2309506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2309518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309531 */     // GIR_Coverage, 54970,
     /* 2309531 */     GIR_EraseRootFromParent_Done,
     /* 2309532 */   // Label 31678: @2309532
     /* 2309532 */   GIM_Try, /*On fail goto*//*Label 31679*/ GIMT_Encode4(2309609), // Rule ID 54971 //
     /* 2309537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309580 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2309583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2309595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309608 */     // GIR_Coverage, 54971,
     /* 2309608 */     GIR_EraseRootFromParent_Done,
     /* 2309609 */   // Label 31679: @2309609
     /* 2309609 */   GIM_Try, /*On fail goto*//*Label 31680*/ GIMT_Encode4(2309686), // Rule ID 72550 //
     /* 2309614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309657 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2309660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2309672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309685 */     // GIR_Coverage, 72550,
     /* 2309685 */     GIR_EraseRootFromParent_Done,
     /* 2309686 */   // Label 31680: @2309686
     /* 2309686 */   GIM_Try, /*On fail goto*//*Label 31681*/ GIMT_Encode4(2309763), // Rule ID 72551 //
     /* 2309691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309734 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2309737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2309749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309762 */     // GIR_Coverage, 72551,
     /* 2309762 */     GIR_EraseRootFromParent_Done,
     /* 2309763 */   // Label 31681: @2309763
     /* 2309763 */   GIM_Try, /*On fail goto*//*Label 31682*/ GIMT_Encode4(2309825), // Rule ID 54974 //
     /* 2309768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309798 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2309801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309824 */     // GIR_Coverage, 54974,
     /* 2309824 */     GIR_EraseRootFromParent_Done,
     /* 2309825 */   // Label 31682: @2309825
     /* 2309825 */   GIM_Try, /*On fail goto*//*Label 31683*/ GIMT_Encode4(2309887), // Rule ID 54975 //
     /* 2309830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309860 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2309863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309886 */     // GIR_Coverage, 54975,
     /* 2309886 */     GIR_EraseRootFromParent_Done,
     /* 2309887 */   // Label 31683: @2309887
     /* 2309887 */   GIM_Try, /*On fail goto*//*Label 31684*/ GIMT_Encode4(2309949), // Rule ID 72554 //
     /* 2309892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309922 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2309925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309948 */     // GIR_Coverage, 72554,
     /* 2309948 */     GIR_EraseRootFromParent_Done,
     /* 2309949 */   // Label 31684: @2309949
     /* 2309949 */   GIM_Try, /*On fail goto*//*Label 31685*/ GIMT_Encode4(2310011), // Rule ID 72555 //
     /* 2309954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309984 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2309987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310010 */     // GIR_Coverage, 72555,
     /* 2310010 */     GIR_EraseRootFromParent_Done,
     /* 2310011 */   // Label 31685: @2310011
     /* 2310011 */   GIM_Try, /*On fail goto*//*Label 31686*/ GIMT_Encode4(2310073), // Rule ID 54966 //
     /* 2310016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2310019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2310039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310046 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2310049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2310059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310072 */     // GIR_Coverage, 54966,
     /* 2310072 */     GIR_EraseRootFromParent_Done,
     /* 2310073 */   // Label 31686: @2310073
     /* 2310073 */   GIM_Try, /*On fail goto*//*Label 31687*/ GIMT_Encode4(2310135), // Rule ID 54967 //
     /* 2310078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2310081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2310101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310108 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2310111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2310121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310134 */     // GIR_Coverage, 54967,
     /* 2310134 */     GIR_EraseRootFromParent_Done,
     /* 2310135 */   // Label 31687: @2310135
     /* 2310135 */   GIM_Try, /*On fail goto*//*Label 31688*/ GIMT_Encode4(2310180), // Rule ID 54962 //
     /* 2310140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2310143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310155 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2310158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310179 */     // GIR_Coverage, 54962,
     /* 2310179 */     GIR_EraseRootFromParent_Done,
     /* 2310180 */   // Label 31688: @2310180
     /* 2310180 */   GIM_Try, /*On fail goto*//*Label 31689*/ GIMT_Encode4(2310225), // Rule ID 54963 //
     /* 2310185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2310188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310200 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2310203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310224 */     // GIR_Coverage, 54963,
     /* 2310224 */     GIR_EraseRootFromParent_Done,
     /* 2310225 */   // Label 31689: @2310225
     /* 2310225 */   GIM_Reject,
     /* 2310226 */ // Label 31677: @2310226
     /* 2310226 */ GIM_Reject,
     /* 2310227 */ // Label 31569: @2310227
     /* 2310227 */ GIM_Try, /*On fail goto*//*Label 31690*/ GIMT_Encode4(2311016),
     /* 2310232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2310238 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2310241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310245 */   GIM_Try, /*On fail goto*//*Label 31691*/ GIMT_Encode4(2310322), // Rule ID 55162 //
     /* 2310250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2310253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310293 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2310296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2310308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310321 */     // GIR_Coverage, 55162,
     /* 2310321 */     GIR_EraseRootFromParent_Done,
     /* 2310322 */   // Label 31691: @2310322
     /* 2310322 */   GIM_Try, /*On fail goto*//*Label 31692*/ GIMT_Encode4(2310399), // Rule ID 55163 //
     /* 2310327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310363 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310370 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2310373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2310385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310398 */     // GIR_Coverage, 55163,
     /* 2310398 */     GIR_EraseRootFromParent_Done,
     /* 2310399 */   // Label 31692: @2310399
     /* 2310399 */   GIM_Try, /*On fail goto*//*Label 31693*/ GIMT_Encode4(2310476), // Rule ID 72718 //
     /* 2310404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2310407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310447 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2310450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2310462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310475 */     // GIR_Coverage, 72718,
     /* 2310475 */     GIR_EraseRootFromParent_Done,
     /* 2310476 */   // Label 31693: @2310476
     /* 2310476 */   GIM_Try, /*On fail goto*//*Label 31694*/ GIMT_Encode4(2310553), // Rule ID 72719 //
     /* 2310481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310524 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2310527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2310539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310552 */     // GIR_Coverage, 72719,
     /* 2310552 */     GIR_EraseRootFromParent_Done,
     /* 2310553 */   // Label 31694: @2310553
     /* 2310553 */   GIM_Try, /*On fail goto*//*Label 31695*/ GIMT_Encode4(2310615), // Rule ID 55166 //
     /* 2310558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2310561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310588 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2310591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310614 */     // GIR_Coverage, 55166,
     /* 2310614 */     GIR_EraseRootFromParent_Done,
     /* 2310615 */   // Label 31695: @2310615
     /* 2310615 */   GIM_Try, /*On fail goto*//*Label 31696*/ GIMT_Encode4(2310677), // Rule ID 55167 //
     /* 2310620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310650 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2310653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310676 */     // GIR_Coverage, 55167,
     /* 2310676 */     GIR_EraseRootFromParent_Done,
     /* 2310677 */   // Label 31696: @2310677
     /* 2310677 */   GIM_Try, /*On fail goto*//*Label 31697*/ GIMT_Encode4(2310739), // Rule ID 72722 //
     /* 2310682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2310685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310712 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2310715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310738 */     // GIR_Coverage, 72722,
     /* 2310738 */     GIR_EraseRootFromParent_Done,
     /* 2310739 */   // Label 31697: @2310739
     /* 2310739 */   GIM_Try, /*On fail goto*//*Label 31698*/ GIMT_Encode4(2310801), // Rule ID 72723 //
     /* 2310744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310774 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2310777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310800 */     // GIR_Coverage, 72723,
     /* 2310800 */     GIR_EraseRootFromParent_Done,
     /* 2310801 */   // Label 31698: @2310801
     /* 2310801 */   GIM_Try, /*On fail goto*//*Label 31699*/ GIMT_Encode4(2310863), // Rule ID 55158 //
     /* 2310806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2310809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310836 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2310839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2310849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310862 */     // GIR_Coverage, 55158,
     /* 2310862 */     GIR_EraseRootFromParent_Done,
     /* 2310863 */   // Label 31699: @2310863
     /* 2310863 */   GIM_Try, /*On fail goto*//*Label 31700*/ GIMT_Encode4(2310925), // Rule ID 55159 //
     /* 2310868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310898 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2310901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2310911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310924 */     // GIR_Coverage, 55159,
     /* 2310924 */     GIR_EraseRootFromParent_Done,
     /* 2310925 */   // Label 31700: @2310925
     /* 2310925 */   GIM_Try, /*On fail goto*//*Label 31701*/ GIMT_Encode4(2310970), // Rule ID 55154 //
     /* 2310930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2310933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310945 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2310948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310969 */     // GIR_Coverage, 55154,
     /* 2310969 */     GIR_EraseRootFromParent_Done,
     /* 2310970 */   // Label 31701: @2310970
     /* 2310970 */   GIM_Try, /*On fail goto*//*Label 31702*/ GIMT_Encode4(2311015), // Rule ID 55155 //
     /* 2310975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310990 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2310993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2311010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311014 */     // GIR_Coverage, 55155,
     /* 2311014 */     GIR_EraseRootFromParent_Done,
     /* 2311015 */   // Label 31702: @2311015
     /* 2311015 */   GIM_Reject,
     /* 2311016 */ // Label 31690: @2311016
     /* 2311016 */ GIM_Reject,
     /* 2311017 */ // Label 31570: @2311017
     /* 2311017 */ GIM_Try, /*On fail goto*//*Label 31703*/ GIMT_Encode4(2311806),
     /* 2311022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2311028 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2311031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311035 */   GIM_Try, /*On fail goto*//*Label 31704*/ GIMT_Encode4(2311112), // Rule ID 54906 //
     /* 2311040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311083 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2311086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311111 */     // GIR_Coverage, 54906,
     /* 2311111 */     GIR_EraseRootFromParent_Done,
     /* 2311112 */   // Label 31704: @2311112
     /* 2311112 */   GIM_Try, /*On fail goto*//*Label 31705*/ GIMT_Encode4(2311189), // Rule ID 54907 //
     /* 2311117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311160 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2311163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311188 */     // GIR_Coverage, 54907,
     /* 2311188 */     GIR_EraseRootFromParent_Done,
     /* 2311189 */   // Label 31705: @2311189
     /* 2311189 */   GIM_Try, /*On fail goto*//*Label 31706*/ GIMT_Encode4(2311266), // Rule ID 72494 //
     /* 2311194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311237 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2311240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311265 */     // GIR_Coverage, 72494,
     /* 2311265 */     GIR_EraseRootFromParent_Done,
     /* 2311266 */   // Label 31706: @2311266
     /* 2311266 */   GIM_Try, /*On fail goto*//*Label 31707*/ GIMT_Encode4(2311343), // Rule ID 72495 //
     /* 2311271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311314 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2311317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311342 */     // GIR_Coverage, 72495,
     /* 2311342 */     GIR_EraseRootFromParent_Done,
     /* 2311343 */   // Label 31707: @2311343
     /* 2311343 */   GIM_Try, /*On fail goto*//*Label 31708*/ GIMT_Encode4(2311405), // Rule ID 54910 //
     /* 2311348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311378 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2311381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311404 */     // GIR_Coverage, 54910,
     /* 2311404 */     GIR_EraseRootFromParent_Done,
     /* 2311405 */   // Label 31708: @2311405
     /* 2311405 */   GIM_Try, /*On fail goto*//*Label 31709*/ GIMT_Encode4(2311467), // Rule ID 54911 //
     /* 2311410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311440 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2311443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311466 */     // GIR_Coverage, 54911,
     /* 2311466 */     GIR_EraseRootFromParent_Done,
     /* 2311467 */   // Label 31709: @2311467
     /* 2311467 */   GIM_Try, /*On fail goto*//*Label 31710*/ GIMT_Encode4(2311529), // Rule ID 72498 //
     /* 2311472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311502 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2311505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311528 */     // GIR_Coverage, 72498,
     /* 2311528 */     GIR_EraseRootFromParent_Done,
     /* 2311529 */   // Label 31710: @2311529
     /* 2311529 */   GIM_Try, /*On fail goto*//*Label 31711*/ GIMT_Encode4(2311591), // Rule ID 72499 //
     /* 2311534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311564 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2311567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311590 */     // GIR_Coverage, 72499,
     /* 2311590 */     GIR_EraseRootFromParent_Done,
     /* 2311591 */   // Label 31711: @2311591
     /* 2311591 */   GIM_Try, /*On fail goto*//*Label 31712*/ GIMT_Encode4(2311653), // Rule ID 54902 //
     /* 2311596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311626 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2311629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2311639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311652 */     // GIR_Coverage, 54902,
     /* 2311652 */     GIR_EraseRootFromParent_Done,
     /* 2311653 */   // Label 31712: @2311653
     /* 2311653 */   GIM_Try, /*On fail goto*//*Label 31713*/ GIMT_Encode4(2311715), // Rule ID 54903 //
     /* 2311658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311688 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2311691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2311701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311714 */     // GIR_Coverage, 54903,
     /* 2311714 */     GIR_EraseRootFromParent_Done,
     /* 2311715 */   // Label 31713: @2311715
     /* 2311715 */   GIM_Try, /*On fail goto*//*Label 31714*/ GIMT_Encode4(2311760), // Rule ID 54898 //
     /* 2311720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311735 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2311738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311759 */     // GIR_Coverage, 54898,
     /* 2311759 */     GIR_EraseRootFromParent_Done,
     /* 2311760 */   // Label 31714: @2311760
     /* 2311760 */   GIM_Try, /*On fail goto*//*Label 31715*/ GIMT_Encode4(2311805), // Rule ID 54899 //
     /* 2311765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311780 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2311783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311804 */     // GIR_Coverage, 54899,
     /* 2311804 */     GIR_EraseRootFromParent_Done,
     /* 2311805 */   // Label 31715: @2311805
     /* 2311805 */   GIM_Reject,
     /* 2311806 */ // Label 31703: @2311806
     /* 2311806 */ GIM_Reject,
     /* 2311807 */ // Label 31571: @2311807
     /* 2311807 */ GIM_Try, /*On fail goto*//*Label 31716*/ GIMT_Encode4(2312596),
     /* 2311812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2311818 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2311821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311825 */   GIM_Try, /*On fail goto*//*Label 31717*/ GIMT_Encode4(2311902), // Rule ID 55098 //
     /* 2311830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2311833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311873 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2311876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311901 */     // GIR_Coverage, 55098,
     /* 2311901 */     GIR_EraseRootFromParent_Done,
     /* 2311902 */   // Label 31717: @2311902
     /* 2311902 */   GIM_Try, /*On fail goto*//*Label 31718*/ GIMT_Encode4(2311979), // Rule ID 55099 //
     /* 2311907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2311910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311950 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2311953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311978 */     // GIR_Coverage, 55099,
     /* 2311978 */     GIR_EraseRootFromParent_Done,
     /* 2311979 */   // Label 31718: @2311979
     /* 2311979 */   GIM_Try, /*On fail goto*//*Label 31719*/ GIMT_Encode4(2312056), // Rule ID 72662 //
     /* 2311984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2311987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312027 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2312030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312055 */     // GIR_Coverage, 72662,
     /* 2312055 */     GIR_EraseRootFromParent_Done,
     /* 2312056 */   // Label 31719: @2312056
     /* 2312056 */   GIM_Try, /*On fail goto*//*Label 31720*/ GIMT_Encode4(2312133), // Rule ID 72663 //
     /* 2312061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2312064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312104 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2312107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312132 */     // GIR_Coverage, 72663,
     /* 2312132 */     GIR_EraseRootFromParent_Done,
     /* 2312133 */   // Label 31720: @2312133
     /* 2312133 */   GIM_Try, /*On fail goto*//*Label 31721*/ GIMT_Encode4(2312195), // Rule ID 55102 //
     /* 2312138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2312141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312168 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2312171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312194 */     // GIR_Coverage, 55102,
     /* 2312194 */     GIR_EraseRootFromParent_Done,
     /* 2312195 */   // Label 31721: @2312195
     /* 2312195 */   GIM_Try, /*On fail goto*//*Label 31722*/ GIMT_Encode4(2312257), // Rule ID 55103 //
     /* 2312200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2312203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312230 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2312233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312256 */     // GIR_Coverage, 55103,
     /* 2312256 */     GIR_EraseRootFromParent_Done,
     /* 2312257 */   // Label 31722: @2312257
     /* 2312257 */   GIM_Try, /*On fail goto*//*Label 31723*/ GIMT_Encode4(2312319), // Rule ID 72666 //
     /* 2312262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2312265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312292 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2312295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312318 */     // GIR_Coverage, 72666,
     /* 2312318 */     GIR_EraseRootFromParent_Done,
     /* 2312319 */   // Label 31723: @2312319
     /* 2312319 */   GIM_Try, /*On fail goto*//*Label 31724*/ GIMT_Encode4(2312381), // Rule ID 72667 //
     /* 2312324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2312327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312354 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2312357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312380 */     // GIR_Coverage, 72667,
     /* 2312380 */     GIR_EraseRootFromParent_Done,
     /* 2312381 */   // Label 31724: @2312381
     /* 2312381 */   GIM_Try, /*On fail goto*//*Label 31725*/ GIMT_Encode4(2312443), // Rule ID 55094 //
     /* 2312386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2312389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312416 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2312419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2312429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312442 */     // GIR_Coverage, 55094,
     /* 2312442 */     GIR_EraseRootFromParent_Done,
     /* 2312443 */   // Label 31725: @2312443
     /* 2312443 */   GIM_Try, /*On fail goto*//*Label 31726*/ GIMT_Encode4(2312505), // Rule ID 55095 //
     /* 2312448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2312451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312478 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2312481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2312491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312504 */     // GIR_Coverage, 55095,
     /* 2312504 */     GIR_EraseRootFromParent_Done,
     /* 2312505 */   // Label 31726: @2312505
     /* 2312505 */   GIM_Try, /*On fail goto*//*Label 31727*/ GIMT_Encode4(2312550), // Rule ID 55090 //
     /* 2312510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2312513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312525 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2312528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312549 */     // GIR_Coverage, 55090,
     /* 2312549 */     GIR_EraseRootFromParent_Done,
     /* 2312550 */   // Label 31727: @2312550
     /* 2312550 */   GIM_Try, /*On fail goto*//*Label 31728*/ GIMT_Encode4(2312595), // Rule ID 55091 //
     /* 2312555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2312558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312570 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2312573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312594 */     // GIR_Coverage, 55091,
     /* 2312594 */     GIR_EraseRootFromParent_Done,
     /* 2312595 */   // Label 31728: @2312595
     /* 2312595 */   GIM_Reject,
     /* 2312596 */ // Label 31716: @2312596
     /* 2312596 */ GIM_Reject,
     /* 2312597 */ // Label 31572: @2312597
     /* 2312597 */ GIM_Try, /*On fail goto*//*Label 31729*/ GIMT_Encode4(2313386),
     /* 2312602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2312608 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2312611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312615 */   GIM_Try, /*On fail goto*//*Label 31730*/ GIMT_Encode4(2312692), // Rule ID 55610 //
     /* 2312620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312663 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2312666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312691 */     // GIR_Coverage, 55610,
     /* 2312691 */     GIR_EraseRootFromParent_Done,
     /* 2312692 */   // Label 31730: @2312692
     /* 2312692 */   GIM_Try, /*On fail goto*//*Label 31731*/ GIMT_Encode4(2312769), // Rule ID 55611 //
     /* 2312697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312740 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2312743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312768 */     // GIR_Coverage, 55611,
     /* 2312768 */     GIR_EraseRootFromParent_Done,
     /* 2312769 */   // Label 31731: @2312769
     /* 2312769 */   GIM_Try, /*On fail goto*//*Label 31732*/ GIMT_Encode4(2312846), // Rule ID 73110 //
     /* 2312774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312817 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2312820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312845 */     // GIR_Coverage, 73110,
     /* 2312845 */     GIR_EraseRootFromParent_Done,
     /* 2312846 */   // Label 31732: @2312846
     /* 2312846 */   GIM_Try, /*On fail goto*//*Label 31733*/ GIMT_Encode4(2312923), // Rule ID 73111 //
     /* 2312851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312894 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2312897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312922 */     // GIR_Coverage, 73111,
     /* 2312922 */     GIR_EraseRootFromParent_Done,
     /* 2312923 */   // Label 31733: @2312923
     /* 2312923 */   GIM_Try, /*On fail goto*//*Label 31734*/ GIMT_Encode4(2312985), // Rule ID 55614 //
     /* 2312928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312958 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2312961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312984 */     // GIR_Coverage, 55614,
     /* 2312984 */     GIR_EraseRootFromParent_Done,
     /* 2312985 */   // Label 31734: @2312985
     /* 2312985 */   GIM_Try, /*On fail goto*//*Label 31735*/ GIMT_Encode4(2313047), // Rule ID 55615 //
     /* 2312990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2313005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313020 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2313023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313046 */     // GIR_Coverage, 55615,
     /* 2313046 */     GIR_EraseRootFromParent_Done,
     /* 2313047 */   // Label 31735: @2313047
     /* 2313047 */   GIM_Try, /*On fail goto*//*Label 31736*/ GIMT_Encode4(2313109), // Rule ID 73114 //
     /* 2313052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2313055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2313071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313082 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2313085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313108 */     // GIR_Coverage, 73114,
     /* 2313108 */     GIR_EraseRootFromParent_Done,
     /* 2313109 */   // Label 31736: @2313109
     /* 2313109 */   GIM_Try, /*On fail goto*//*Label 31737*/ GIMT_Encode4(2313171), // Rule ID 73115 //
     /* 2313114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2313117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2313133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313144 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2313147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313170 */     // GIR_Coverage, 73115,
     /* 2313170 */     GIR_EraseRootFromParent_Done,
     /* 2313171 */   // Label 31737: @2313171
     /* 2313171 */   GIM_Try, /*On fail goto*//*Label 31738*/ GIMT_Encode4(2313233), // Rule ID 55606 //
     /* 2313176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2313179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2313199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313206 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2313209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2313219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313232 */     // GIR_Coverage, 55606,
     /* 2313232 */     GIR_EraseRootFromParent_Done,
     /* 2313233 */   // Label 31738: @2313233
     /* 2313233 */   GIM_Try, /*On fail goto*//*Label 31739*/ GIMT_Encode4(2313295), // Rule ID 55607 //
     /* 2313238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2313241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2313261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313268 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2313271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2313281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313294 */     // GIR_Coverage, 55607,
     /* 2313294 */     GIR_EraseRootFromParent_Done,
     /* 2313295 */   // Label 31739: @2313295
     /* 2313295 */   GIM_Try, /*On fail goto*//*Label 31740*/ GIMT_Encode4(2313340), // Rule ID 55602 //
     /* 2313300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2313303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313315 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2313318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313339 */     // GIR_Coverage, 55602,
     /* 2313339 */     GIR_EraseRootFromParent_Done,
     /* 2313340 */   // Label 31740: @2313340
     /* 2313340 */   GIM_Try, /*On fail goto*//*Label 31741*/ GIMT_Encode4(2313385), // Rule ID 55603 //
     /* 2313345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2313348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313360 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2313363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313384 */     // GIR_Coverage, 55603,
     /* 2313384 */     GIR_EraseRootFromParent_Done,
     /* 2313385 */   // Label 31741: @2313385
     /* 2313385 */   GIM_Reject,
     /* 2313386 */ // Label 31729: @2313386
     /* 2313386 */ GIM_Reject,
     /* 2313387 */ // Label 31573: @2313387
     /* 2313387 */ GIM_Try, /*On fail goto*//*Label 31742*/ GIMT_Encode4(2314176),
     /* 2313392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2313398 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2313401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313405 */   GIM_Try, /*On fail goto*//*Label 31743*/ GIMT_Encode4(2313482), // Rule ID 55034 //
     /* 2313410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313453 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2313456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313481 */     // GIR_Coverage, 55034,
     /* 2313481 */     GIR_EraseRootFromParent_Done,
     /* 2313482 */   // Label 31743: @2313482
     /* 2313482 */   GIM_Try, /*On fail goto*//*Label 31744*/ GIMT_Encode4(2313559), // Rule ID 55035 //
     /* 2313487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313523 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313530 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2313533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313558 */     // GIR_Coverage, 55035,
     /* 2313558 */     GIR_EraseRootFromParent_Done,
     /* 2313559 */   // Label 31744: @2313559
     /* 2313559 */   GIM_Try, /*On fail goto*//*Label 31745*/ GIMT_Encode4(2313636), // Rule ID 72606 //
     /* 2313564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313607 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2313610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313635 */     // GIR_Coverage, 72606,
     /* 2313635 */     GIR_EraseRootFromParent_Done,
     /* 2313636 */   // Label 31745: @2313636
     /* 2313636 */   GIM_Try, /*On fail goto*//*Label 31746*/ GIMT_Encode4(2313713), // Rule ID 72607 //
     /* 2313641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313684 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2313687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313712 */     // GIR_Coverage, 72607,
     /* 2313712 */     GIR_EraseRootFromParent_Done,
     /* 2313713 */   // Label 31746: @2313713
     /* 2313713 */   GIM_Try, /*On fail goto*//*Label 31747*/ GIMT_Encode4(2313775), // Rule ID 55038 //
     /* 2313718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313748 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2313751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313774 */     // GIR_Coverage, 55038,
     /* 2313774 */     GIR_EraseRootFromParent_Done,
     /* 2313775 */   // Label 31747: @2313775
     /* 2313775 */   GIM_Try, /*On fail goto*//*Label 31748*/ GIMT_Encode4(2313837), // Rule ID 55039 //
     /* 2313780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313810 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2313813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313836 */     // GIR_Coverage, 55039,
     /* 2313836 */     GIR_EraseRootFromParent_Done,
     /* 2313837 */   // Label 31748: @2313837
     /* 2313837 */   GIM_Try, /*On fail goto*//*Label 31749*/ GIMT_Encode4(2313899), // Rule ID 72610 //
     /* 2313842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313872 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2313875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313898 */     // GIR_Coverage, 72610,
     /* 2313898 */     GIR_EraseRootFromParent_Done,
     /* 2313899 */   // Label 31749: @2313899
     /* 2313899 */   GIM_Try, /*On fail goto*//*Label 31750*/ GIMT_Encode4(2313961), // Rule ID 72611 //
     /* 2313904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313934 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2313937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313960 */     // GIR_Coverage, 72611,
     /* 2313960 */     GIR_EraseRootFromParent_Done,
     /* 2313961 */   // Label 31750: @2313961
     /* 2313961 */   GIM_Try, /*On fail goto*//*Label 31751*/ GIMT_Encode4(2314023), // Rule ID 55030 //
     /* 2313966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313996 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2313999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2314009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314022 */     // GIR_Coverage, 55030,
     /* 2314022 */     GIR_EraseRootFromParent_Done,
     /* 2314023 */   // Label 31751: @2314023
     /* 2314023 */   GIM_Try, /*On fail goto*//*Label 31752*/ GIMT_Encode4(2314085), // Rule ID 55031 //
     /* 2314028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2314031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2314051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314058 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2314061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2314071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314084 */     // GIR_Coverage, 55031,
     /* 2314084 */     GIR_EraseRootFromParent_Done,
     /* 2314085 */   // Label 31752: @2314085
     /* 2314085 */   GIM_Try, /*On fail goto*//*Label 31753*/ GIMT_Encode4(2314130), // Rule ID 55026 //
     /* 2314090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2314093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314105 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2314108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314129 */     // GIR_Coverage, 55026,
     /* 2314129 */     GIR_EraseRootFromParent_Done,
     /* 2314130 */   // Label 31753: @2314130
     /* 2314130 */   GIM_Try, /*On fail goto*//*Label 31754*/ GIMT_Encode4(2314175), // Rule ID 55027 //
     /* 2314135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2314138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314150 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2314153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314174 */     // GIR_Coverage, 55027,
     /* 2314174 */     GIR_EraseRootFromParent_Done,
     /* 2314175 */   // Label 31754: @2314175
     /* 2314175 */   GIM_Reject,
     /* 2314176 */ // Label 31742: @2314176
     /* 2314176 */ GIM_Reject,
     /* 2314177 */ // Label 31574: @2314177
     /* 2314177 */ GIM_Try, /*On fail goto*//*Label 31755*/ GIMT_Encode4(2314966),
     /* 2314182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2314188 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2314191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314195 */   GIM_Try, /*On fail goto*//*Label 31756*/ GIMT_Encode4(2314272), // Rule ID 55418 //
     /* 2314200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314243 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2314246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314271 */     // GIR_Coverage, 55418,
     /* 2314271 */     GIR_EraseRootFromParent_Done,
     /* 2314272 */   // Label 31756: @2314272
     /* 2314272 */   GIM_Try, /*On fail goto*//*Label 31757*/ GIMT_Encode4(2314349), // Rule ID 55419 //
     /* 2314277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314320 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2314323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314348 */     // GIR_Coverage, 55419,
     /* 2314348 */     GIR_EraseRootFromParent_Done,
     /* 2314349 */   // Label 31757: @2314349
     /* 2314349 */   GIM_Try, /*On fail goto*//*Label 31758*/ GIMT_Encode4(2314426), // Rule ID 72942 //
     /* 2314354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314397 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2314400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314425 */     // GIR_Coverage, 72942,
     /* 2314425 */     GIR_EraseRootFromParent_Done,
     /* 2314426 */   // Label 31758: @2314426
     /* 2314426 */   GIM_Try, /*On fail goto*//*Label 31759*/ GIMT_Encode4(2314503), // Rule ID 72943 //
     /* 2314431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314474 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2314477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314502 */     // GIR_Coverage, 72943,
     /* 2314502 */     GIR_EraseRootFromParent_Done,
     /* 2314503 */   // Label 31759: @2314503
     /* 2314503 */   GIM_Try, /*On fail goto*//*Label 31760*/ GIMT_Encode4(2314565), // Rule ID 55422 //
     /* 2314508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314538 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2314541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314564 */     // GIR_Coverage, 55422,
     /* 2314564 */     GIR_EraseRootFromParent_Done,
     /* 2314565 */   // Label 31760: @2314565
     /* 2314565 */   GIM_Try, /*On fail goto*//*Label 31761*/ GIMT_Encode4(2314627), // Rule ID 55423 //
     /* 2314570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314600 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2314603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314626 */     // GIR_Coverage, 55423,
     /* 2314626 */     GIR_EraseRootFromParent_Done,
     /* 2314627 */   // Label 31761: @2314627
     /* 2314627 */   GIM_Try, /*On fail goto*//*Label 31762*/ GIMT_Encode4(2314689), // Rule ID 72946 //
     /* 2314632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314662 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2314665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314688 */     // GIR_Coverage, 72946,
     /* 2314688 */     GIR_EraseRootFromParent_Done,
     /* 2314689 */   // Label 31762: @2314689
     /* 2314689 */   GIM_Try, /*On fail goto*//*Label 31763*/ GIMT_Encode4(2314751), // Rule ID 72947 //
     /* 2314694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314724 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2314727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314750 */     // GIR_Coverage, 72947,
     /* 2314750 */     GIR_EraseRootFromParent_Done,
     /* 2314751 */   // Label 31763: @2314751
     /* 2314751 */   GIM_Try, /*On fail goto*//*Label 31764*/ GIMT_Encode4(2314813), // Rule ID 55414 //
     /* 2314756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314786 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2314789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2314799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314812 */     // GIR_Coverage, 55414,
     /* 2314812 */     GIR_EraseRootFromParent_Done,
     /* 2314813 */   // Label 31764: @2314813
     /* 2314813 */   GIM_Try, /*On fail goto*//*Label 31765*/ GIMT_Encode4(2314875), // Rule ID 55415 //
     /* 2314818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314848 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2314851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2314861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314874 */     // GIR_Coverage, 55415,
     /* 2314874 */     GIR_EraseRootFromParent_Done,
     /* 2314875 */   // Label 31765: @2314875
     /* 2314875 */   GIM_Try, /*On fail goto*//*Label 31766*/ GIMT_Encode4(2314920), // Rule ID 55410 //
     /* 2314880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314895 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2314898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314919 */     // GIR_Coverage, 55410,
     /* 2314919 */     GIR_EraseRootFromParent_Done,
     /* 2314920 */   // Label 31766: @2314920
     /* 2314920 */   GIM_Try, /*On fail goto*//*Label 31767*/ GIMT_Encode4(2314965), // Rule ID 55411 //
     /* 2314925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314940 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2314943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314964 */     // GIR_Coverage, 55411,
     /* 2314964 */     GIR_EraseRootFromParent_Done,
     /* 2314965 */   // Label 31767: @2314965
     /* 2314965 */   GIM_Reject,
     /* 2314966 */ // Label 31755: @2314966
     /* 2314966 */ GIM_Reject,
     /* 2314967 */ // Label 31575: @2314967
     /* 2314967 */ GIM_Try, /*On fail goto*//*Label 31768*/ GIMT_Encode4(2315756),
     /* 2314972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2314978 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2314981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314985 */   GIM_Try, /*On fail goto*//*Label 31769*/ GIMT_Encode4(2315062), // Rule ID 55674 //
     /* 2314990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2314993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315033 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2315036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315061 */     // GIR_Coverage, 55674,
     /* 2315061 */     GIR_EraseRootFromParent_Done,
     /* 2315062 */   // Label 31769: @2315062
     /* 2315062 */   GIM_Try, /*On fail goto*//*Label 31770*/ GIMT_Encode4(2315139), // Rule ID 55675 //
     /* 2315067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2315070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315110 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2315113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315138 */     // GIR_Coverage, 55675,
     /* 2315138 */     GIR_EraseRootFromParent_Done,
     /* 2315139 */   // Label 31770: @2315139
     /* 2315139 */   GIM_Try, /*On fail goto*//*Label 31771*/ GIMT_Encode4(2315216), // Rule ID 73166 //
     /* 2315144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2315147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315187 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2315190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315215 */     // GIR_Coverage, 73166,
     /* 2315215 */     GIR_EraseRootFromParent_Done,
     /* 2315216 */   // Label 31771: @2315216
     /* 2315216 */   GIM_Try, /*On fail goto*//*Label 31772*/ GIMT_Encode4(2315293), // Rule ID 73167 //
     /* 2315221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2315224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315264 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2315267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315292 */     // GIR_Coverage, 73167,
     /* 2315292 */     GIR_EraseRootFromParent_Done,
     /* 2315293 */   // Label 31772: @2315293
     /* 2315293 */   GIM_Try, /*On fail goto*//*Label 31773*/ GIMT_Encode4(2315355), // Rule ID 55678 //
     /* 2315298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2315301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315328 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2315331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315354 */     // GIR_Coverage, 55678,
     /* 2315354 */     GIR_EraseRootFromParent_Done,
     /* 2315355 */   // Label 31773: @2315355
     /* 2315355 */   GIM_Try, /*On fail goto*//*Label 31774*/ GIMT_Encode4(2315417), // Rule ID 55679 //
     /* 2315360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2315363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315390 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2315393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315416 */     // GIR_Coverage, 55679,
     /* 2315416 */     GIR_EraseRootFromParent_Done,
     /* 2315417 */   // Label 31774: @2315417
     /* 2315417 */   GIM_Try, /*On fail goto*//*Label 31775*/ GIMT_Encode4(2315479), // Rule ID 73170 //
     /* 2315422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2315425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315452 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2315455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315478 */     // GIR_Coverage, 73170,
     /* 2315478 */     GIR_EraseRootFromParent_Done,
     /* 2315479 */   // Label 31775: @2315479
     /* 2315479 */   GIM_Try, /*On fail goto*//*Label 31776*/ GIMT_Encode4(2315541), // Rule ID 73171 //
     /* 2315484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2315487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315514 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2315517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315540 */     // GIR_Coverage, 73171,
     /* 2315540 */     GIR_EraseRootFromParent_Done,
     /* 2315541 */   // Label 31776: @2315541
     /* 2315541 */   GIM_Try, /*On fail goto*//*Label 31777*/ GIMT_Encode4(2315603), // Rule ID 55670 //
     /* 2315546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2315549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315576 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2315579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2315589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315602 */     // GIR_Coverage, 55670,
     /* 2315602 */     GIR_EraseRootFromParent_Done,
     /* 2315603 */   // Label 31777: @2315603
     /* 2315603 */   GIM_Try, /*On fail goto*//*Label 31778*/ GIMT_Encode4(2315665), // Rule ID 55671 //
     /* 2315608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2315611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315638 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2315641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2315651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315664 */     // GIR_Coverage, 55671,
     /* 2315664 */     GIR_EraseRootFromParent_Done,
     /* 2315665 */   // Label 31778: @2315665
     /* 2315665 */   GIM_Try, /*On fail goto*//*Label 31779*/ GIMT_Encode4(2315710), // Rule ID 55666 //
     /* 2315670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2315673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315685 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2315688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315709 */     // GIR_Coverage, 55666,
     /* 2315709 */     GIR_EraseRootFromParent_Done,
     /* 2315710 */   // Label 31779: @2315710
     /* 2315710 */   GIM_Try, /*On fail goto*//*Label 31780*/ GIMT_Encode4(2315755), // Rule ID 55667 //
     /* 2315715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2315718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315730 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2315733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315754 */     // GIR_Coverage, 55667,
     /* 2315754 */     GIR_EraseRootFromParent_Done,
     /* 2315755 */   // Label 31780: @2315755
     /* 2315755 */   GIM_Reject,
     /* 2315756 */ // Label 31768: @2315756
     /* 2315756 */ GIM_Reject,
     /* 2315757 */ // Label 31576: @2315757
     /* 2315757 */ GIM_Try, /*On fail goto*//*Label 31781*/ GIMT_Encode4(2316546),
     /* 2315762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2315768 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2315771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315775 */   GIM_Try, /*On fail goto*//*Label 31782*/ GIMT_Encode4(2315852), // Rule ID 55226 //
     /* 2315780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2315783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315823 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2315826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315851 */     // GIR_Coverage, 55226,
     /* 2315851 */     GIR_EraseRootFromParent_Done,
     /* 2315852 */   // Label 31782: @2315852
     /* 2315852 */   GIM_Try, /*On fail goto*//*Label 31783*/ GIMT_Encode4(2315929), // Rule ID 55227 //
     /* 2315857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315900 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2315903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315928 */     // GIR_Coverage, 55227,
     /* 2315928 */     GIR_EraseRootFromParent_Done,
     /* 2315929 */   // Label 31783: @2315929
     /* 2315929 */   GIM_Try, /*On fail goto*//*Label 31784*/ GIMT_Encode4(2316006), // Rule ID 72774 //
     /* 2315934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2315937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315977 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2315980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316005 */     // GIR_Coverage, 72774,
     /* 2316005 */     GIR_EraseRootFromParent_Done,
     /* 2316006 */   // Label 31784: @2316006
     /* 2316006 */   GIM_Try, /*On fail goto*//*Label 31785*/ GIMT_Encode4(2316083), // Rule ID 72775 //
     /* 2316011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2316014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2316030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2316047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316054 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2316057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316082 */     // GIR_Coverage, 72775,
     /* 2316082 */     GIR_EraseRootFromParent_Done,
     /* 2316083 */   // Label 31785: @2316083
     /* 2316083 */   GIM_Try, /*On fail goto*//*Label 31786*/ GIMT_Encode4(2316145), // Rule ID 55230 //
     /* 2316088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2316091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2316103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316118 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2316121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316144 */     // GIR_Coverage, 55230,
     /* 2316144 */     GIR_EraseRootFromParent_Done,
     /* 2316145 */   // Label 31786: @2316145
     /* 2316145 */   GIM_Try, /*On fail goto*//*Label 31787*/ GIMT_Encode4(2316207), // Rule ID 55231 //
     /* 2316150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2316153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2316165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316180 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2316183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316206 */     // GIR_Coverage, 55231,
     /* 2316206 */     GIR_EraseRootFromParent_Done,
     /* 2316207 */   // Label 31787: @2316207
     /* 2316207 */   GIM_Try, /*On fail goto*//*Label 31788*/ GIMT_Encode4(2316269), // Rule ID 72778 //
     /* 2316212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2316215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2316231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316242 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2316245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316268 */     // GIR_Coverage, 72778,
     /* 2316268 */     GIR_EraseRootFromParent_Done,
     /* 2316269 */   // Label 31788: @2316269
     /* 2316269 */   GIM_Try, /*On fail goto*//*Label 31789*/ GIMT_Encode4(2316331), // Rule ID 72779 //
     /* 2316274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2316277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2316293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316304 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2316307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316330 */     // GIR_Coverage, 72779,
     /* 2316330 */     GIR_EraseRootFromParent_Done,
     /* 2316331 */   // Label 31789: @2316331
     /* 2316331 */   GIM_Try, /*On fail goto*//*Label 31790*/ GIMT_Encode4(2316393), // Rule ID 55222 //
     /* 2316336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2316339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2316359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316366 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2316369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2316379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316392 */     // GIR_Coverage, 55222,
     /* 2316392 */     GIR_EraseRootFromParent_Done,
     /* 2316393 */   // Label 31790: @2316393
     /* 2316393 */   GIM_Try, /*On fail goto*//*Label 31791*/ GIMT_Encode4(2316455), // Rule ID 55223 //
     /* 2316398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2316401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2316421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316428 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2316431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2316441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316454 */     // GIR_Coverage, 55223,
     /* 2316454 */     GIR_EraseRootFromParent_Done,
     /* 2316455 */   // Label 31791: @2316455
     /* 2316455 */   GIM_Try, /*On fail goto*//*Label 31792*/ GIMT_Encode4(2316500), // Rule ID 55218 //
     /* 2316460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2316463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316475 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2316478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316499 */     // GIR_Coverage, 55218,
     /* 2316499 */     GIR_EraseRootFromParent_Done,
     /* 2316500 */   // Label 31792: @2316500
     /* 2316500 */   GIM_Try, /*On fail goto*//*Label 31793*/ GIMT_Encode4(2316545), // Rule ID 55219 //
     /* 2316505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2316508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316520 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2316523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316544 */     // GIR_Coverage, 55219,
     /* 2316544 */     GIR_EraseRootFromParent_Done,
     /* 2316545 */   // Label 31793: @2316545
     /* 2316545 */   GIM_Reject,
     /* 2316546 */ // Label 31781: @2316546
     /* 2316546 */ GIM_Reject,
     /* 2316547 */ // Label 31577: @2316547
     /* 2316547 */ GIM_Try, /*On fail goto*//*Label 31794*/ GIMT_Encode4(2317336),
     /* 2316552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2316558 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2316561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316565 */   GIM_Try, /*On fail goto*//*Label 31795*/ GIMT_Encode4(2316642), // Rule ID 55482 //
     /* 2316570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316613 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2316616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316641 */     // GIR_Coverage, 55482,
     /* 2316641 */     GIR_EraseRootFromParent_Done,
     /* 2316642 */   // Label 31795: @2316642
     /* 2316642 */   GIM_Try, /*On fail goto*//*Label 31796*/ GIMT_Encode4(2316719), // Rule ID 55483 //
     /* 2316647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316683 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316690 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2316693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316718 */     // GIR_Coverage, 55483,
     /* 2316718 */     GIR_EraseRootFromParent_Done,
     /* 2316719 */   // Label 31796: @2316719
     /* 2316719 */   GIM_Try, /*On fail goto*//*Label 31797*/ GIMT_Encode4(2316796), // Rule ID 72998 //
     /* 2316724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316767 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2316770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316795 */     // GIR_Coverage, 72998,
     /* 2316795 */     GIR_EraseRootFromParent_Done,
     /* 2316796 */   // Label 31797: @2316796
     /* 2316796 */   GIM_Try, /*On fail goto*//*Label 31798*/ GIMT_Encode4(2316873), // Rule ID 72999 //
     /* 2316801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316837 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316844 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2316847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316872 */     // GIR_Coverage, 72999,
     /* 2316872 */     GIR_EraseRootFromParent_Done,
     /* 2316873 */   // Label 31798: @2316873
     /* 2316873 */   GIM_Try, /*On fail goto*//*Label 31799*/ GIMT_Encode4(2316935), // Rule ID 55486 //
     /* 2316878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316908 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2316911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316934 */     // GIR_Coverage, 55486,
     /* 2316934 */     GIR_EraseRootFromParent_Done,
     /* 2316935 */   // Label 31799: @2316935
     /* 2316935 */   GIM_Try, /*On fail goto*//*Label 31800*/ GIMT_Encode4(2316997), // Rule ID 55487 //
     /* 2316940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316970 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2316973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316996 */     // GIR_Coverage, 55487,
     /* 2316996 */     GIR_EraseRootFromParent_Done,
     /* 2316997 */   // Label 31800: @2316997
     /* 2316997 */   GIM_Try, /*On fail goto*//*Label 31801*/ GIMT_Encode4(2317059), // Rule ID 73002 //
     /* 2317002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2317005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2317021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317032 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2317035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317058 */     // GIR_Coverage, 73002,
     /* 2317058 */     GIR_EraseRootFromParent_Done,
     /* 2317059 */   // Label 31801: @2317059
     /* 2317059 */   GIM_Try, /*On fail goto*//*Label 31802*/ GIMT_Encode4(2317121), // Rule ID 73003 //
     /* 2317064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2317067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2317083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317094 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2317097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317120 */     // GIR_Coverage, 73003,
     /* 2317120 */     GIR_EraseRootFromParent_Done,
     /* 2317121 */   // Label 31802: @2317121
     /* 2317121 */   GIM_Try, /*On fail goto*//*Label 31803*/ GIMT_Encode4(2317183), // Rule ID 55478 //
     /* 2317126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2317129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2317149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317156 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2317159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2317169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317182 */     // GIR_Coverage, 55478,
     /* 2317182 */     GIR_EraseRootFromParent_Done,
     /* 2317183 */   // Label 31803: @2317183
     /* 2317183 */   GIM_Try, /*On fail goto*//*Label 31804*/ GIMT_Encode4(2317245), // Rule ID 55479 //
     /* 2317188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2317191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2317211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317218 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2317221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2317231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317244 */     // GIR_Coverage, 55479,
     /* 2317244 */     GIR_EraseRootFromParent_Done,
     /* 2317245 */   // Label 31804: @2317245
     /* 2317245 */   GIM_Try, /*On fail goto*//*Label 31805*/ GIMT_Encode4(2317290), // Rule ID 55474 //
     /* 2317250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2317253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317265 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2317268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317289 */     // GIR_Coverage, 55474,
     /* 2317289 */     GIR_EraseRootFromParent_Done,
     /* 2317290 */   // Label 31805: @2317290
     /* 2317290 */   GIM_Try, /*On fail goto*//*Label 31806*/ GIMT_Encode4(2317335), // Rule ID 55475 //
     /* 2317295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2317298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317310 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2317313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317334 */     // GIR_Coverage, 55475,
     /* 2317334 */     GIR_EraseRootFromParent_Done,
     /* 2317335 */   // Label 31806: @2317335
     /* 2317335 */   GIM_Reject,
     /* 2317336 */ // Label 31794: @2317336
     /* 2317336 */ GIM_Reject,
     /* 2317337 */ // Label 31578: @2317337
     /* 2317337 */ GIM_Try, /*On fail goto*//*Label 31807*/ GIMT_Encode4(2318126),
     /* 2317342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2317348 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2317351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317355 */   GIM_Try, /*On fail goto*//*Label 31808*/ GIMT_Encode4(2317432), // Rule ID 55738 //
     /* 2317360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317396 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317403 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2317406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317431 */     // GIR_Coverage, 55738,
     /* 2317431 */     GIR_EraseRootFromParent_Done,
     /* 2317432 */   // Label 31808: @2317432
     /* 2317432 */   GIM_Try, /*On fail goto*//*Label 31809*/ GIMT_Encode4(2317509), // Rule ID 55739 //
     /* 2317437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317473 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317480 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2317483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317508 */     // GIR_Coverage, 55739,
     /* 2317508 */     GIR_EraseRootFromParent_Done,
     /* 2317509 */   // Label 31809: @2317509
     /* 2317509 */   GIM_Try, /*On fail goto*//*Label 31810*/ GIMT_Encode4(2317586), // Rule ID 73222 //
     /* 2317514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317557 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2317560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317585 */     // GIR_Coverage, 73222,
     /* 2317585 */     GIR_EraseRootFromParent_Done,
     /* 2317586 */   // Label 31810: @2317586
     /* 2317586 */   GIM_Try, /*On fail goto*//*Label 31811*/ GIMT_Encode4(2317663), // Rule ID 73223 //
     /* 2317591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317634 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2317637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317662 */     // GIR_Coverage, 73223,
     /* 2317662 */     GIR_EraseRootFromParent_Done,
     /* 2317663 */   // Label 31811: @2317663
     /* 2317663 */   GIM_Try, /*On fail goto*//*Label 31812*/ GIMT_Encode4(2317725), // Rule ID 55742 //
     /* 2317668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317698 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2317701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317724 */     // GIR_Coverage, 55742,
     /* 2317724 */     GIR_EraseRootFromParent_Done,
     /* 2317725 */   // Label 31812: @2317725
     /* 2317725 */   GIM_Try, /*On fail goto*//*Label 31813*/ GIMT_Encode4(2317787), // Rule ID 55743 //
     /* 2317730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317760 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2317763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317786 */     // GIR_Coverage, 55743,
     /* 2317786 */     GIR_EraseRootFromParent_Done,
     /* 2317787 */   // Label 31813: @2317787
     /* 2317787 */   GIM_Try, /*On fail goto*//*Label 31814*/ GIMT_Encode4(2317849), // Rule ID 73226 //
     /* 2317792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317822 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2317825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317848 */     // GIR_Coverage, 73226,
     /* 2317848 */     GIR_EraseRootFromParent_Done,
     /* 2317849 */   // Label 31814: @2317849
     /* 2317849 */   GIM_Try, /*On fail goto*//*Label 31815*/ GIMT_Encode4(2317911), // Rule ID 73227 //
     /* 2317854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317884 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2317887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317910 */     // GIR_Coverage, 73227,
     /* 2317910 */     GIR_EraseRootFromParent_Done,
     /* 2317911 */   // Label 31815: @2317911
     /* 2317911 */   GIM_Try, /*On fail goto*//*Label 31816*/ GIMT_Encode4(2317973), // Rule ID 55734 //
     /* 2317916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317946 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2317949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2317959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317972 */     // GIR_Coverage, 55734,
     /* 2317972 */     GIR_EraseRootFromParent_Done,
     /* 2317973 */   // Label 31816: @2317973
     /* 2317973 */   GIM_Try, /*On fail goto*//*Label 31817*/ GIMT_Encode4(2318035), // Rule ID 55735 //
     /* 2317978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2318001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318008 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2318011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2318021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318034 */     // GIR_Coverage, 55735,
     /* 2318034 */     GIR_EraseRootFromParent_Done,
     /* 2318035 */   // Label 31817: @2318035
     /* 2318035 */   GIM_Try, /*On fail goto*//*Label 31818*/ GIMT_Encode4(2318080), // Rule ID 55730 //
     /* 2318040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2318043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318055 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2318058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318079 */     // GIR_Coverage, 55730,
     /* 2318079 */     GIR_EraseRootFromParent_Done,
     /* 2318080 */   // Label 31818: @2318080
     /* 2318080 */   GIM_Try, /*On fail goto*//*Label 31819*/ GIMT_Encode4(2318125), // Rule ID 55731 //
     /* 2318085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2318088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318100 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2318103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318124 */     // GIR_Coverage, 55731,
     /* 2318124 */     GIR_EraseRootFromParent_Done,
     /* 2318125 */   // Label 31819: @2318125
     /* 2318125 */   GIM_Reject,
     /* 2318126 */ // Label 31807: @2318126
     /* 2318126 */ GIM_Reject,
     /* 2318127 */ // Label 31579: @2318127
     /* 2318127 */ GIM_Try, /*On fail goto*//*Label 31820*/ GIMT_Encode4(2318916),
     /* 2318132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2318138 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2318141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318145 */   GIM_Try, /*On fail goto*//*Label 31821*/ GIMT_Encode4(2318222), // Rule ID 55290 //
     /* 2318150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318193 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2318196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318221 */     // GIR_Coverage, 55290,
     /* 2318221 */     GIR_EraseRootFromParent_Done,
     /* 2318222 */   // Label 31821: @2318222
     /* 2318222 */   GIM_Try, /*On fail goto*//*Label 31822*/ GIMT_Encode4(2318299), // Rule ID 55291 //
     /* 2318227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318270 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2318273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318298 */     // GIR_Coverage, 55291,
     /* 2318298 */     GIR_EraseRootFromParent_Done,
     /* 2318299 */   // Label 31822: @2318299
     /* 2318299 */   GIM_Try, /*On fail goto*//*Label 31823*/ GIMT_Encode4(2318376), // Rule ID 72830 //
     /* 2318304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318347 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2318350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318375 */     // GIR_Coverage, 72830,
     /* 2318375 */     GIR_EraseRootFromParent_Done,
     /* 2318376 */   // Label 31823: @2318376
     /* 2318376 */   GIM_Try, /*On fail goto*//*Label 31824*/ GIMT_Encode4(2318453), // Rule ID 72831 //
     /* 2318381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318424 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2318427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318452 */     // GIR_Coverage, 72831,
     /* 2318452 */     GIR_EraseRootFromParent_Done,
     /* 2318453 */   // Label 31824: @2318453
     /* 2318453 */   GIM_Try, /*On fail goto*//*Label 31825*/ GIMT_Encode4(2318515), // Rule ID 55294 //
     /* 2318458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318488 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2318491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318514 */     // GIR_Coverage, 55294,
     /* 2318514 */     GIR_EraseRootFromParent_Done,
     /* 2318515 */   // Label 31825: @2318515
     /* 2318515 */   GIM_Try, /*On fail goto*//*Label 31826*/ GIMT_Encode4(2318577), // Rule ID 55295 //
     /* 2318520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318550 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2318553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318576 */     // GIR_Coverage, 55295,
     /* 2318576 */     GIR_EraseRootFromParent_Done,
     /* 2318577 */   // Label 31826: @2318577
     /* 2318577 */   GIM_Try, /*On fail goto*//*Label 31827*/ GIMT_Encode4(2318639), // Rule ID 72834 //
     /* 2318582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318612 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2318615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318638 */     // GIR_Coverage, 72834,
     /* 2318638 */     GIR_EraseRootFromParent_Done,
     /* 2318639 */   // Label 31827: @2318639
     /* 2318639 */   GIM_Try, /*On fail goto*//*Label 31828*/ GIMT_Encode4(2318701), // Rule ID 72835 //
     /* 2318644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318674 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2318677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318700 */     // GIR_Coverage, 72835,
     /* 2318700 */     GIR_EraseRootFromParent_Done,
     /* 2318701 */   // Label 31828: @2318701
     /* 2318701 */   GIM_Try, /*On fail goto*//*Label 31829*/ GIMT_Encode4(2318763), // Rule ID 55286 //
     /* 2318706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318736 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2318739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2318749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318762 */     // GIR_Coverage, 55286,
     /* 2318762 */     GIR_EraseRootFromParent_Done,
     /* 2318763 */   // Label 31829: @2318763
     /* 2318763 */   GIM_Try, /*On fail goto*//*Label 31830*/ GIMT_Encode4(2318825), // Rule ID 55287 //
     /* 2318768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318798 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2318801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2318811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318824 */     // GIR_Coverage, 55287,
     /* 2318824 */     GIR_EraseRootFromParent_Done,
     /* 2318825 */   // Label 31830: @2318825
     /* 2318825 */   GIM_Try, /*On fail goto*//*Label 31831*/ GIMT_Encode4(2318870), // Rule ID 55282 //
     /* 2318830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318845 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2318848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318869 */     // GIR_Coverage, 55282,
     /* 2318869 */     GIR_EraseRootFromParent_Done,
     /* 2318870 */   // Label 31831: @2318870
     /* 2318870 */   GIM_Try, /*On fail goto*//*Label 31832*/ GIMT_Encode4(2318915), // Rule ID 55283 //
     /* 2318875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318890 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2318893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318914 */     // GIR_Coverage, 55283,
     /* 2318914 */     GIR_EraseRootFromParent_Done,
     /* 2318915 */   // Label 31832: @2318915
     /* 2318915 */   GIM_Reject,
     /* 2318916 */ // Label 31820: @2318916
     /* 2318916 */ GIM_Reject,
     /* 2318917 */ // Label 31580: @2318917
     /* 2318917 */ GIM_Try, /*On fail goto*//*Label 31833*/ GIMT_Encode4(2319706),
     /* 2318922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2318928 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2318931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318935 */   GIM_Try, /*On fail goto*//*Label 31834*/ GIMT_Encode4(2319012), // Rule ID 55546 //
     /* 2318940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2318943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318983 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2318986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319011 */     // GIR_Coverage, 55546,
     /* 2319011 */     GIR_EraseRootFromParent_Done,
     /* 2319012 */   // Label 31834: @2319012
     /* 2319012 */   GIM_Try, /*On fail goto*//*Label 31835*/ GIMT_Encode4(2319089), // Rule ID 55547 //
     /* 2319017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319060 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2319063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319088 */     // GIR_Coverage, 55547,
     /* 2319088 */     GIR_EraseRootFromParent_Done,
     /* 2319089 */   // Label 31835: @2319089
     /* 2319089 */   GIM_Try, /*On fail goto*//*Label 31836*/ GIMT_Encode4(2319166), // Rule ID 73054 //
     /* 2319094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2319097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319137 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2319140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319165 */     // GIR_Coverage, 73054,
     /* 2319165 */     GIR_EraseRootFromParent_Done,
     /* 2319166 */   // Label 31836: @2319166
     /* 2319166 */   GIM_Try, /*On fail goto*//*Label 31837*/ GIMT_Encode4(2319243), // Rule ID 73055 //
     /* 2319171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319214 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2319217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319242 */     // GIR_Coverage, 73055,
     /* 2319242 */     GIR_EraseRootFromParent_Done,
     /* 2319243 */   // Label 31837: @2319243
     /* 2319243 */   GIM_Try, /*On fail goto*//*Label 31838*/ GIMT_Encode4(2319305), // Rule ID 55550 //
     /* 2319248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2319251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319278 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2319281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319304 */     // GIR_Coverage, 55550,
     /* 2319304 */     GIR_EraseRootFromParent_Done,
     /* 2319305 */   // Label 31838: @2319305
     /* 2319305 */   GIM_Try, /*On fail goto*//*Label 31839*/ GIMT_Encode4(2319367), // Rule ID 55551 //
     /* 2319310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319340 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2319343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319366 */     // GIR_Coverage, 55551,
     /* 2319366 */     GIR_EraseRootFromParent_Done,
     /* 2319367 */   // Label 31839: @2319367
     /* 2319367 */   GIM_Try, /*On fail goto*//*Label 31840*/ GIMT_Encode4(2319429), // Rule ID 73058 //
     /* 2319372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2319375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319402 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2319405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319428 */     // GIR_Coverage, 73058,
     /* 2319428 */     GIR_EraseRootFromParent_Done,
     /* 2319429 */   // Label 31840: @2319429
     /* 2319429 */   GIM_Try, /*On fail goto*//*Label 31841*/ GIMT_Encode4(2319491), // Rule ID 73059 //
     /* 2319434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319464 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2319467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319490 */     // GIR_Coverage, 73059,
     /* 2319490 */     GIR_EraseRootFromParent_Done,
     /* 2319491 */   // Label 31841: @2319491
     /* 2319491 */   GIM_Try, /*On fail goto*//*Label 31842*/ GIMT_Encode4(2319553), // Rule ID 55542 //
     /* 2319496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2319499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319526 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2319529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319552 */     // GIR_Coverage, 55542,
     /* 2319552 */     GIR_EraseRootFromParent_Done,
     /* 2319553 */   // Label 31842: @2319553
     /* 2319553 */   GIM_Try, /*On fail goto*//*Label 31843*/ GIMT_Encode4(2319615), // Rule ID 55543 //
     /* 2319558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319588 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2319591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319614 */     // GIR_Coverage, 55543,
     /* 2319614 */     GIR_EraseRootFromParent_Done,
     /* 2319615 */   // Label 31843: @2319615
     /* 2319615 */   GIM_Try, /*On fail goto*//*Label 31844*/ GIMT_Encode4(2319660), // Rule ID 55538 //
     /* 2319620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2319623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319635 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2319638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319659 */     // GIR_Coverage, 55538,
     /* 2319659 */     GIR_EraseRootFromParent_Done,
     /* 2319660 */   // Label 31844: @2319660
     /* 2319660 */   GIM_Try, /*On fail goto*//*Label 31845*/ GIMT_Encode4(2319705), // Rule ID 55539 //
     /* 2319665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319680 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2319683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319704 */     // GIR_Coverage, 55539,
     /* 2319704 */     GIR_EraseRootFromParent_Done,
     /* 2319705 */   // Label 31845: @2319705
     /* 2319705 */   GIM_Reject,
     /* 2319706 */ // Label 31833: @2319706
     /* 2319706 */ GIM_Reject,
     /* 2319707 */ // Label 31581: @2319707
     /* 2319707 */ GIM_Try, /*On fail goto*//*Label 31846*/ GIMT_Encode4(2320496),
     /* 2319712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2319718 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2319721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319725 */   GIM_Try, /*On fail goto*//*Label 31847*/ GIMT_Encode4(2319802), // Rule ID 55354 //
     /* 2319730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319773 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2319776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319801 */     // GIR_Coverage, 55354,
     /* 2319801 */     GIR_EraseRootFromParent_Done,
     /* 2319802 */   // Label 31847: @2319802
     /* 2319802 */   GIM_Try, /*On fail goto*//*Label 31848*/ GIMT_Encode4(2319879), // Rule ID 55355 //
     /* 2319807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319850 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2319853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319878 */     // GIR_Coverage, 55355,
     /* 2319878 */     GIR_EraseRootFromParent_Done,
     /* 2319879 */   // Label 31848: @2319879
     /* 2319879 */   GIM_Try, /*On fail goto*//*Label 31849*/ GIMT_Encode4(2319956), // Rule ID 72886 //
     /* 2319884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319927 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2319930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319955 */     // GIR_Coverage, 72886,
     /* 2319955 */     GIR_EraseRootFromParent_Done,
     /* 2319956 */   // Label 31849: @2319956
     /* 2319956 */   GIM_Try, /*On fail goto*//*Label 31850*/ GIMT_Encode4(2320033), // Rule ID 72887 //
     /* 2319961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320004 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2320007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320032 */     // GIR_Coverage, 72887,
     /* 2320032 */     GIR_EraseRootFromParent_Done,
     /* 2320033 */   // Label 31850: @2320033
     /* 2320033 */   GIM_Try, /*On fail goto*//*Label 31851*/ GIMT_Encode4(2320095), // Rule ID 55358 //
     /* 2320038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2320041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2320053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320068 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2320071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320094 */     // GIR_Coverage, 55358,
     /* 2320094 */     GIR_EraseRootFromParent_Done,
     /* 2320095 */   // Label 31851: @2320095
     /* 2320095 */   GIM_Try, /*On fail goto*//*Label 31852*/ GIMT_Encode4(2320157), // Rule ID 55359 //
     /* 2320100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2320103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2320115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320130 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2320133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320156 */     // GIR_Coverage, 55359,
     /* 2320156 */     GIR_EraseRootFromParent_Done,
     /* 2320157 */   // Label 31852: @2320157
     /* 2320157 */   GIM_Try, /*On fail goto*//*Label 31853*/ GIMT_Encode4(2320219), // Rule ID 72890 //
     /* 2320162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2320165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2320181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320192 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2320195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320218 */     // GIR_Coverage, 72890,
     /* 2320218 */     GIR_EraseRootFromParent_Done,
     /* 2320219 */   // Label 31853: @2320219
     /* 2320219 */   GIM_Try, /*On fail goto*//*Label 31854*/ GIMT_Encode4(2320281), // Rule ID 72891 //
     /* 2320224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2320227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2320243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320254 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2320257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320280 */     // GIR_Coverage, 72891,
     /* 2320280 */     GIR_EraseRootFromParent_Done,
     /* 2320281 */   // Label 31854: @2320281
     /* 2320281 */   GIM_Try, /*On fail goto*//*Label 31855*/ GIMT_Encode4(2320343), // Rule ID 55350 //
     /* 2320286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2320289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2320309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320316 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2320319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2320329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320342 */     // GIR_Coverage, 55350,
     /* 2320342 */     GIR_EraseRootFromParent_Done,
     /* 2320343 */   // Label 31855: @2320343
     /* 2320343 */   GIM_Try, /*On fail goto*//*Label 31856*/ GIMT_Encode4(2320405), // Rule ID 55351 //
     /* 2320348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2320351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2320371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320378 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2320381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2320391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320404 */     // GIR_Coverage, 55351,
     /* 2320404 */     GIR_EraseRootFromParent_Done,
     /* 2320405 */   // Label 31856: @2320405
     /* 2320405 */   GIM_Try, /*On fail goto*//*Label 31857*/ GIMT_Encode4(2320450), // Rule ID 55346 //
     /* 2320410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2320413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320425 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2320428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320449 */     // GIR_Coverage, 55346,
     /* 2320449 */     GIR_EraseRootFromParent_Done,
     /* 2320450 */   // Label 31857: @2320450
     /* 2320450 */   GIM_Try, /*On fail goto*//*Label 31858*/ GIMT_Encode4(2320495), // Rule ID 55347 //
     /* 2320455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2320458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320470 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2320473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320494 */     // GIR_Coverage, 55347,
     /* 2320494 */     GIR_EraseRootFromParent_Done,
     /* 2320495 */   // Label 31858: @2320495
     /* 2320495 */   GIM_Reject,
     /* 2320496 */ // Label 31846: @2320496
     /* 2320496 */ GIM_Reject,
     /* 2320497 */ // Label 31582: @2320497
     /* 2320497 */ GIM_Reject,
     /* 2320498 */ // Label 63: @2320498
     /* 2320498 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31877*/ GIMT_Encode4(2322925),
     /* 2320509 */ /*GILLT_s16*//*Label 31859*/ GIMT_Encode4(2320629),
     /* 2320513 */ /*GILLT_s32*//*Label 31860*/ GIMT_Encode4(2320778),
     /* 2320517 */ /*GILLT_s64*//*Label 31861*/ GIMT_Encode4(2320927), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320529 */ /*GILLT_nxv1s16*//*Label 31862*/ GIMT_Encode4(2321110),
     /* 2320533 */ /*GILLT_nxv1s32*//*Label 31863*/ GIMT_Encode4(2321231),
     /* 2320537 */ /*GILLT_nxv1s64*//*Label 31864*/ GIMT_Encode4(2321352), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320549 */ /*GILLT_nxv2s16*//*Label 31865*/ GIMT_Encode4(2321473),
     /* 2320553 */ /*GILLT_nxv2s32*//*Label 31866*/ GIMT_Encode4(2321594),
     /* 2320557 */ /*GILLT_nxv2s64*//*Label 31867*/ GIMT_Encode4(2321715), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320569 */ /*GILLT_nxv4s16*//*Label 31868*/ GIMT_Encode4(2321836),
     /* 2320573 */ /*GILLT_nxv4s32*//*Label 31869*/ GIMT_Encode4(2321957),
     /* 2320577 */ /*GILLT_nxv4s64*//*Label 31870*/ GIMT_Encode4(2322078), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320589 */ /*GILLT_nxv8s16*//*Label 31871*/ GIMT_Encode4(2322199),
     /* 2320593 */ /*GILLT_nxv8s32*//*Label 31872*/ GIMT_Encode4(2322320),
     /* 2320597 */ /*GILLT_nxv8s64*//*Label 31873*/ GIMT_Encode4(2322441), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320609 */ /*GILLT_nxv16s16*//*Label 31874*/ GIMT_Encode4(2322562),
     /* 2320613 */ /*GILLT_nxv16s32*//*Label 31875*/ GIMT_Encode4(2322683), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320625 */ /*GILLT_nxv32s16*//*Label 31876*/ GIMT_Encode4(2322804),
     /* 2320629 */ // Label 31859: @2320629
     /* 2320629 */ GIM_Try, /*On fail goto*//*Label 31878*/ GIMT_Encode4(2320777),
     /* 2320634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2320637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2320640 */   GIM_Try, /*On fail goto*//*Label 31879*/ GIMT_Encode4(2320674), // Rule ID 1982 //
     /* 2320645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2320648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320660 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2320660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2320663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320673 */     // GIR_Coverage, 1982,
     /* 2320673 */     GIR_EraseRootFromParent_Done,
     /* 2320674 */   // Label 31879: @2320674
     /* 2320674 */   GIM_Try, /*On fail goto*//*Label 31880*/ GIMT_Encode4(2320708), // Rule ID 1983 //
     /* 2320679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2320682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320694 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2320694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2320697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320707 */     // GIR_Coverage, 1983,
     /* 2320707 */     GIR_EraseRootFromParent_Done,
     /* 2320708 */   // Label 31880: @2320708
     /* 2320708 */   GIM_Try, /*On fail goto*//*Label 31881*/ GIMT_Encode4(2320742), // Rule ID 1986 //
     /* 2320713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2320716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320728 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2320728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2320731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320741 */     // GIR_Coverage, 1986,
     /* 2320741 */     GIR_EraseRootFromParent_Done,
     /* 2320742 */   // Label 31881: @2320742
     /* 2320742 */   GIM_Try, /*On fail goto*//*Label 31882*/ GIMT_Encode4(2320776), // Rule ID 1987 //
     /* 2320747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2320750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320762 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2320762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2320765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320775 */     // GIR_Coverage, 1987,
     /* 2320775 */     GIR_EraseRootFromParent_Done,
     /* 2320776 */   // Label 31882: @2320776
     /* 2320776 */   GIM_Reject,
     /* 2320777 */ // Label 31878: @2320777
     /* 2320777 */ GIM_Reject,
     /* 2320778 */ // Label 31860: @2320778
     /* 2320778 */ GIM_Try, /*On fail goto*//*Label 31883*/ GIMT_Encode4(2320926),
     /* 2320783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2320786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2320789 */   GIM_Try, /*On fail goto*//*Label 31884*/ GIMT_Encode4(2320823), // Rule ID 1273 //
     /* 2320794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2320797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320809 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2320809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2320812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320822 */     // GIR_Coverage, 1273,
     /* 2320822 */     GIR_EraseRootFromParent_Done,
     /* 2320823 */   // Label 31884: @2320823
     /* 2320823 */   GIM_Try, /*On fail goto*//*Label 31885*/ GIMT_Encode4(2320857), // Rule ID 1274 //
     /* 2320828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2320831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320843 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2320843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2320846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320856 */     // GIR_Coverage, 1274,
     /* 2320856 */     GIR_EraseRootFromParent_Done,
     /* 2320857 */   // Label 31885: @2320857
     /* 2320857 */   GIM_Try, /*On fail goto*//*Label 31886*/ GIMT_Encode4(2320891), // Rule ID 1277 //
     /* 2320862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2320865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320877 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2320877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2320880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320890 */     // GIR_Coverage, 1277,
     /* 2320890 */     GIR_EraseRootFromParent_Done,
     /* 2320891 */   // Label 31886: @2320891
     /* 2320891 */   GIM_Try, /*On fail goto*//*Label 31887*/ GIMT_Encode4(2320925), // Rule ID 1278 //
     /* 2320896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2320899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320911 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2320911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2320914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320924 */     // GIR_Coverage, 1278,
     /* 2320924 */     GIR_EraseRootFromParent_Done,
     /* 2320925 */   // Label 31887: @2320925
     /* 2320925 */   GIM_Reject,
     /* 2320926 */ // Label 31883: @2320926
     /* 2320926 */ GIM_Reject,
     /* 2320927 */ // Label 31861: @2320927
     /* 2320927 */ GIM_Try, /*On fail goto*//*Label 31888*/ GIMT_Encode4(2321109),
     /* 2320932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2320935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2320938 */   GIM_Try, /*On fail goto*//*Label 31889*/ GIMT_Encode4(2320972), // Rule ID 1614 //
     /* 2320943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2320946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320958 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2320958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2320961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320971 */     // GIR_Coverage, 1614,
     /* 2320971 */     GIR_EraseRootFromParent_Done,
     /* 2320972 */   // Label 31889: @2320972
     /* 2320972 */   GIM_Try, /*On fail goto*//*Label 31890*/ GIMT_Encode4(2321006), // Rule ID 1615 //
     /* 2320977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2320980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320992 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2320992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2320995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321005 */     // GIR_Coverage, 1615,
     /* 2321005 */     GIR_EraseRootFromParent_Done,
     /* 2321006 */   // Label 31890: @2321006
     /* 2321006 */   GIM_Try, /*On fail goto*//*Label 31891*/ GIMT_Encode4(2321040), // Rule ID 1618 //
     /* 2321011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2321014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2321018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2321022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2321026 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2321026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2321029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321039 */     // GIR_Coverage, 1618,
     /* 2321039 */     GIR_EraseRootFromParent_Done,
     /* 2321040 */   // Label 31891: @2321040
     /* 2321040 */   GIM_Try, /*On fail goto*//*Label 31892*/ GIMT_Encode4(2321074), // Rule ID 1619 //
     /* 2321045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2321048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2321052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2321056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2321060 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2321060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2321063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321073 */     // GIR_Coverage, 1619,
     /* 2321073 */     GIR_EraseRootFromParent_Done,
     /* 2321074 */   // Label 31892: @2321074
     /* 2321074 */   GIM_Try, /*On fail goto*//*Label 31893*/ GIMT_Encode4(2321108), // Rule ID 1621 //
     /* 2321079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2321082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321094 */     // (fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2321094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2321097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321107 */     // GIR_Coverage, 1621,
     /* 2321107 */     GIR_EraseRootFromParent_Done,
     /* 2321108 */   // Label 31893: @2321108
     /* 2321108 */   GIM_Reject,
     /* 2321109 */ // Label 31888: @2321109
     /* 2321109 */ GIM_Reject,
     /* 2321110 */ // Label 31862: @2321110
     /* 2321110 */ GIM_Try, /*On fail goto*//*Label 31894*/ GIMT_Encode4(2321230),
     /* 2321115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2321118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2321121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321133 */   GIM_Try, /*On fail goto*//*Label 31895*/ GIMT_Encode4(2321181), // Rule ID 54408 //
     /* 2321138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321141 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2321144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2321158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321180 */     // GIR_Coverage, 54408,
     /* 2321180 */     GIR_EraseRootFromParent_Done,
     /* 2321181 */   // Label 31895: @2321181
     /* 2321181 */   GIM_Try, /*On fail goto*//*Label 31896*/ GIMT_Encode4(2321229), // Rule ID 54409 //
     /* 2321186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321189 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2321192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2321206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321228 */     // GIR_Coverage, 54409,
     /* 2321228 */     GIR_EraseRootFromParent_Done,
     /* 2321229 */   // Label 31896: @2321229
     /* 2321229 */   GIM_Reject,
     /* 2321230 */ // Label 31894: @2321230
     /* 2321230 */ GIM_Reject,
     /* 2321231 */ // Label 31863: @2321231
     /* 2321231 */ GIM_Try, /*On fail goto*//*Label 31897*/ GIMT_Encode4(2321351),
     /* 2321236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2321239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2321242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321254 */   GIM_Try, /*On fail goto*//*Label 31898*/ GIMT_Encode4(2321302), // Rule ID 54432 //
     /* 2321259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2321262 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2321265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2321279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321301 */     // GIR_Coverage, 54432,
     /* 2321301 */     GIR_EraseRootFromParent_Done,
     /* 2321302 */   // Label 31898: @2321302
     /* 2321302 */   GIM_Try, /*On fail goto*//*Label 31899*/ GIMT_Encode4(2321350), // Rule ID 54433 //
     /* 2321307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2321310 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2321313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2321327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321349 */     // GIR_Coverage, 54433,
     /* 2321349 */     GIR_EraseRootFromParent_Done,
     /* 2321350 */   // Label 31899: @2321350
     /* 2321350 */   GIM_Reject,
     /* 2321351 */ // Label 31897: @2321351
     /* 2321351 */ GIM_Reject,
     /* 2321352 */ // Label 31864: @2321352
     /* 2321352 */ GIM_Try, /*On fail goto*//*Label 31900*/ GIMT_Encode4(2321472),
     /* 2321357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2321360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2321363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321375 */   GIM_Try, /*On fail goto*//*Label 31901*/ GIMT_Encode4(2321423), // Rule ID 54468 //
     /* 2321380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2321383 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2321386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2321400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321422 */     // GIR_Coverage, 54468,
     /* 2321422 */     GIR_EraseRootFromParent_Done,
     /* 2321423 */   // Label 31901: @2321423
     /* 2321423 */   GIM_Try, /*On fail goto*//*Label 31902*/ GIMT_Encode4(2321471), // Rule ID 54469 //
     /* 2321428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2321431 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2321434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2321448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321470 */     // GIR_Coverage, 54469,
     /* 2321470 */     GIR_EraseRootFromParent_Done,
     /* 2321471 */   // Label 31902: @2321471
     /* 2321471 */   GIM_Reject,
     /* 2321472 */ // Label 31900: @2321472
     /* 2321472 */ GIM_Reject,
     /* 2321473 */ // Label 31865: @2321473
     /* 2321473 */ GIM_Try, /*On fail goto*//*Label 31903*/ GIMT_Encode4(2321593),
     /* 2321478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2321481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2321484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321496 */   GIM_Try, /*On fail goto*//*Label 31904*/ GIMT_Encode4(2321544), // Rule ID 54420 //
     /* 2321501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321504 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2321507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2321521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321543 */     // GIR_Coverage, 54420,
     /* 2321543 */     GIR_EraseRootFromParent_Done,
     /* 2321544 */   // Label 31904: @2321544
     /* 2321544 */   GIM_Try, /*On fail goto*//*Label 31905*/ GIMT_Encode4(2321592), // Rule ID 54421 //
     /* 2321549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321552 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2321555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2321569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321591 */     // GIR_Coverage, 54421,
     /* 2321591 */     GIR_EraseRootFromParent_Done,
     /* 2321592 */   // Label 31905: @2321592
     /* 2321592 */   GIM_Reject,
     /* 2321593 */ // Label 31903: @2321593
     /* 2321593 */ GIM_Reject,
     /* 2321594 */ // Label 31866: @2321594
     /* 2321594 */ GIM_Try, /*On fail goto*//*Label 31906*/ GIMT_Encode4(2321714),
     /* 2321599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2321602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2321605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321617 */   GIM_Try, /*On fail goto*//*Label 31907*/ GIMT_Encode4(2321665), // Rule ID 54456 //
     /* 2321622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2321625 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2321628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2321642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321664 */     // GIR_Coverage, 54456,
     /* 2321664 */     GIR_EraseRootFromParent_Done,
     /* 2321665 */   // Label 31907: @2321665
     /* 2321665 */   GIM_Try, /*On fail goto*//*Label 31908*/ GIMT_Encode4(2321713), // Rule ID 54457 //
     /* 2321670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2321673 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2321676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2321690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321712 */     // GIR_Coverage, 54457,
     /* 2321712 */     GIR_EraseRootFromParent_Done,
     /* 2321713 */   // Label 31908: @2321713
     /* 2321713 */   GIM_Reject,
     /* 2321714 */ // Label 31906: @2321714
     /* 2321714 */ GIM_Reject,
     /* 2321715 */ // Label 31867: @2321715
     /* 2321715 */ GIM_Try, /*On fail goto*//*Label 31909*/ GIMT_Encode4(2321835),
     /* 2321720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2321723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2321726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321738 */   GIM_Try, /*On fail goto*//*Label 31910*/ GIMT_Encode4(2321786), // Rule ID 54552 //
     /* 2321743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2321746 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2321749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2321763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321785 */     // GIR_Coverage, 54552,
     /* 2321785 */     GIR_EraseRootFromParent_Done,
     /* 2321786 */   // Label 31910: @2321786
     /* 2321786 */   GIM_Try, /*On fail goto*//*Label 31911*/ GIMT_Encode4(2321834), // Rule ID 54553 //
     /* 2321791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2321794 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2321797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2321811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321833 */     // GIR_Coverage, 54553,
     /* 2321833 */     GIR_EraseRootFromParent_Done,
     /* 2321834 */   // Label 31911: @2321834
     /* 2321834 */   GIM_Reject,
     /* 2321835 */ // Label 31909: @2321835
     /* 2321835 */ GIM_Reject,
     /* 2321836 */ // Label 31868: @2321836
     /* 2321836 */ GIM_Try, /*On fail goto*//*Label 31912*/ GIMT_Encode4(2321956),
     /* 2321841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2321844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2321847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321859 */   GIM_Try, /*On fail goto*//*Label 31913*/ GIMT_Encode4(2321907), // Rule ID 54444 //
     /* 2321864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321867 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2321870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2321884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321906 */     // GIR_Coverage, 54444,
     /* 2321906 */     GIR_EraseRootFromParent_Done,
     /* 2321907 */   // Label 31913: @2321907
     /* 2321907 */   GIM_Try, /*On fail goto*//*Label 31914*/ GIMT_Encode4(2321955), // Rule ID 54445 //
     /* 2321912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321915 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2321918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2321932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321954 */     // GIR_Coverage, 54445,
     /* 2321954 */     GIR_EraseRootFromParent_Done,
     /* 2321955 */   // Label 31914: @2321955
     /* 2321955 */   GIM_Reject,
     /* 2321956 */ // Label 31912: @2321956
     /* 2321956 */ GIM_Reject,
     /* 2321957 */ // Label 31869: @2321957
     /* 2321957 */ GIM_Try, /*On fail goto*//*Label 31915*/ GIMT_Encode4(2322077),
     /* 2321962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2321965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2321968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321980 */   GIM_Try, /*On fail goto*//*Label 31916*/ GIMT_Encode4(2322028), // Rule ID 54516 //
     /* 2321985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2321988 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2321991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2322005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322027 */     // GIR_Coverage, 54516,
     /* 2322027 */     GIR_EraseRootFromParent_Done,
     /* 2322028 */   // Label 31916: @2322028
     /* 2322028 */   GIM_Try, /*On fail goto*//*Label 31917*/ GIMT_Encode4(2322076), // Rule ID 54517 //
     /* 2322033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322036 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2322039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2322053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322075 */     // GIR_Coverage, 54517,
     /* 2322075 */     GIR_EraseRootFromParent_Done,
     /* 2322076 */   // Label 31917: @2322076
     /* 2322076 */   GIM_Reject,
     /* 2322077 */ // Label 31915: @2322077
     /* 2322077 */ GIM_Reject,
     /* 2322078 */ // Label 31870: @2322078
     /* 2322078 */ GIM_Try, /*On fail goto*//*Label 31918*/ GIMT_Encode4(2322198),
     /* 2322083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2322086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2322089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322101 */   GIM_Try, /*On fail goto*//*Label 31919*/ GIMT_Encode4(2322149), // Rule ID 54564 //
     /* 2322106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2322109 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2322112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2322126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2322144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322148 */     // GIR_Coverage, 54564,
     /* 2322148 */     GIR_EraseRootFromParent_Done,
     /* 2322149 */   // Label 31919: @2322149
     /* 2322149 */   GIM_Try, /*On fail goto*//*Label 31920*/ GIMT_Encode4(2322197), // Rule ID 54565 //
     /* 2322154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2322157 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2322160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2322174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2322192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322196 */     // GIR_Coverage, 54565,
     /* 2322196 */     GIR_EraseRootFromParent_Done,
     /* 2322197 */   // Label 31920: @2322197
     /* 2322197 */   GIM_Reject,
     /* 2322198 */ // Label 31918: @2322198
     /* 2322198 */ GIM_Reject,
     /* 2322199 */ // Label 31871: @2322199
     /* 2322199 */ GIM_Try, /*On fail goto*//*Label 31921*/ GIMT_Encode4(2322319),
     /* 2322204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2322207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2322210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322222 */   GIM_Try, /*On fail goto*//*Label 31922*/ GIMT_Encode4(2322270), // Rule ID 54480 //
     /* 2322227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322230 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2322233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2322247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322269 */     // GIR_Coverage, 54480,
     /* 2322269 */     GIR_EraseRootFromParent_Done,
     /* 2322270 */   // Label 31922: @2322270
     /* 2322270 */   GIM_Try, /*On fail goto*//*Label 31923*/ GIMT_Encode4(2322318), // Rule ID 54481 //
     /* 2322275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322278 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2322281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2322295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322317 */     // GIR_Coverage, 54481,
     /* 2322317 */     GIR_EraseRootFromParent_Done,
     /* 2322318 */   // Label 31923: @2322318
     /* 2322318 */   GIM_Reject,
     /* 2322319 */ // Label 31921: @2322319
     /* 2322319 */ GIM_Reject,
     /* 2322320 */ // Label 31872: @2322320
     /* 2322320 */ GIM_Try, /*On fail goto*//*Label 31924*/ GIMT_Encode4(2322440),
     /* 2322325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2322331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322343 */   GIM_Try, /*On fail goto*//*Label 31925*/ GIMT_Encode4(2322391), // Rule ID 54528 //
     /* 2322348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322351 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2322354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2322368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322390 */     // GIR_Coverage, 54528,
     /* 2322390 */     GIR_EraseRootFromParent_Done,
     /* 2322391 */   // Label 31925: @2322391
     /* 2322391 */   GIM_Try, /*On fail goto*//*Label 31926*/ GIMT_Encode4(2322439), // Rule ID 54529 //
     /* 2322396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322399 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2322402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2322416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322438 */     // GIR_Coverage, 54529,
     /* 2322438 */     GIR_EraseRootFromParent_Done,
     /* 2322439 */   // Label 31926: @2322439
     /* 2322439 */   GIM_Reject,
     /* 2322440 */ // Label 31924: @2322440
     /* 2322440 */ GIM_Reject,
     /* 2322441 */ // Label 31873: @2322441
     /* 2322441 */ GIM_Try, /*On fail goto*//*Label 31927*/ GIMT_Encode4(2322561),
     /* 2322446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2322449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2322452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322464 */   GIM_Try, /*On fail goto*//*Label 31928*/ GIMT_Encode4(2322512), // Rule ID 54576 //
     /* 2322469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2322472 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2322475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2322489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2322507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322511 */     // GIR_Coverage, 54576,
     /* 2322511 */     GIR_EraseRootFromParent_Done,
     /* 2322512 */   // Label 31928: @2322512
     /* 2322512 */   GIM_Try, /*On fail goto*//*Label 31929*/ GIMT_Encode4(2322560), // Rule ID 54577 //
     /* 2322517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2322520 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2322523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2322537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2322555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322559 */     // GIR_Coverage, 54577,
     /* 2322559 */     GIR_EraseRootFromParent_Done,
     /* 2322560 */   // Label 31929: @2322560
     /* 2322560 */   GIM_Reject,
     /* 2322561 */ // Label 31927: @2322561
     /* 2322561 */ GIM_Reject,
     /* 2322562 */ // Label 31874: @2322562
     /* 2322562 */ GIM_Try, /*On fail goto*//*Label 31930*/ GIMT_Encode4(2322682),
     /* 2322567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2322570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2322573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322585 */   GIM_Try, /*On fail goto*//*Label 31931*/ GIMT_Encode4(2322633), // Rule ID 54492 //
     /* 2322590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322593 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2322596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2322610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322632 */     // GIR_Coverage, 54492,
     /* 2322632 */     GIR_EraseRootFromParent_Done,
     /* 2322633 */   // Label 31931: @2322633
     /* 2322633 */   GIM_Try, /*On fail goto*//*Label 31932*/ GIMT_Encode4(2322681), // Rule ID 54493 //
     /* 2322638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322641 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2322644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2322658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322680 */     // GIR_Coverage, 54493,
     /* 2322680 */     GIR_EraseRootFromParent_Done,
     /* 2322681 */   // Label 31932: @2322681
     /* 2322681 */   GIM_Reject,
     /* 2322682 */ // Label 31930: @2322682
     /* 2322682 */ GIM_Reject,
     /* 2322683 */ // Label 31875: @2322683
     /* 2322683 */ GIM_Try, /*On fail goto*//*Label 31933*/ GIMT_Encode4(2322803),
     /* 2322688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2322691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2322694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322706 */   GIM_Try, /*On fail goto*//*Label 31934*/ GIMT_Encode4(2322754), // Rule ID 54540 //
     /* 2322711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322714 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2322717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2322731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322753 */     // GIR_Coverage, 54540,
     /* 2322753 */     GIR_EraseRootFromParent_Done,
     /* 2322754 */   // Label 31934: @2322754
     /* 2322754 */   GIM_Try, /*On fail goto*//*Label 31935*/ GIMT_Encode4(2322802), // Rule ID 54541 //
     /* 2322759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322762 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2322765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2322779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322801 */     // GIR_Coverage, 54541,
     /* 2322801 */     GIR_EraseRootFromParent_Done,
     /* 2322802 */   // Label 31935: @2322802
     /* 2322802 */   GIM_Reject,
     /* 2322803 */ // Label 31933: @2322803
     /* 2322803 */ GIM_Reject,
     /* 2322804 */ // Label 31876: @2322804
     /* 2322804 */ GIM_Try, /*On fail goto*//*Label 31936*/ GIMT_Encode4(2322924),
     /* 2322809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2322812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2322815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322827 */   GIM_Try, /*On fail goto*//*Label 31937*/ GIMT_Encode4(2322875), // Rule ID 54504 //
     /* 2322832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322835 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2322838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2322852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322874 */     // GIR_Coverage, 54504,
     /* 2322874 */     GIR_EraseRootFromParent_Done,
     /* 2322875 */   // Label 31937: @2322875
     /* 2322875 */   GIM_Try, /*On fail goto*//*Label 31938*/ GIMT_Encode4(2322923), // Rule ID 54505 //
     /* 2322880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322883 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2322886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2322900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322922 */     // GIR_Coverage, 54505,
     /* 2322922 */     GIR_EraseRootFromParent_Done,
     /* 2322923 */   // Label 31938: @2322923
     /* 2322923 */   GIM_Reject,
     /* 2322924 */ // Label 31936: @2322924
     /* 2322924 */ GIM_Reject,
     /* 2322925 */ // Label 31877: @2322925
     /* 2322925 */ GIM_Reject,
     /* 2322926 */ // Label 64: @2322926
     /* 2322926 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31957*/ GIMT_Encode4(2324896),
     /* 2322937 */ /*GILLT_s16*//*Label 31939*/ GIMT_Encode4(2323057),
     /* 2322941 */ /*GILLT_s32*//*Label 31940*/ GIMT_Encode4(2323121),
     /* 2322945 */ /*GILLT_s64*//*Label 31941*/ GIMT_Encode4(2323185), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322957 */ /*GILLT_nxv1s16*//*Label 31942*/ GIMT_Encode4(2323276),
     /* 2322961 */ /*GILLT_nxv1s32*//*Label 31943*/ GIMT_Encode4(2323384),
     /* 2322965 */ /*GILLT_nxv1s64*//*Label 31944*/ GIMT_Encode4(2323492), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322977 */ /*GILLT_nxv2s16*//*Label 31945*/ GIMT_Encode4(2323600),
     /* 2322981 */ /*GILLT_nxv2s32*//*Label 31946*/ GIMT_Encode4(2323708),
     /* 2322985 */ /*GILLT_nxv2s64*//*Label 31947*/ GIMT_Encode4(2323816), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322997 */ /*GILLT_nxv4s16*//*Label 31948*/ GIMT_Encode4(2323924),
     /* 2323001 */ /*GILLT_nxv4s32*//*Label 31949*/ GIMT_Encode4(2324032),
     /* 2323005 */ /*GILLT_nxv4s64*//*Label 31950*/ GIMT_Encode4(2324140), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2323017 */ /*GILLT_nxv8s16*//*Label 31951*/ GIMT_Encode4(2324248),
     /* 2323021 */ /*GILLT_nxv8s32*//*Label 31952*/ GIMT_Encode4(2324356),
     /* 2323025 */ /*GILLT_nxv8s64*//*Label 31953*/ GIMT_Encode4(2324464), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2323037 */ /*GILLT_nxv16s16*//*Label 31954*/ GIMT_Encode4(2324572),
     /* 2323041 */ /*GILLT_nxv16s32*//*Label 31955*/ GIMT_Encode4(2324680), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2323053 */ /*GILLT_nxv32s16*//*Label 31956*/ GIMT_Encode4(2324788),
     /* 2323057 */ // Label 31939: @2323057
     /* 2323057 */ GIM_Try, /*On fail goto*//*Label 31958*/ GIMT_Encode4(2323120),
     /* 2323062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2323065 */   GIM_Try, /*On fail goto*//*Label 31959*/ GIMT_Encode4(2323092), // Rule ID 1992 //
     /* 2323070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2323073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2323077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2323081 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2323081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2323084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323091 */     // GIR_Coverage, 1992,
     /* 2323091 */     GIR_EraseRootFromParent_Done,
     /* 2323092 */   // Label 31959: @2323092
     /* 2323092 */   GIM_Try, /*On fail goto*//*Label 31960*/ GIMT_Encode4(2323119), // Rule ID 2025 //
     /* 2323097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2323100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2323104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2323108 */     // (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2323108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2323111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323118 */     // GIR_Coverage, 2025,
     /* 2323118 */     GIR_EraseRootFromParent_Done,
     /* 2323119 */   // Label 31960: @2323119
     /* 2323119 */   GIM_Reject,
     /* 2323120 */ // Label 31958: @2323120
     /* 2323120 */ GIM_Reject,
     /* 2323121 */ // Label 31940: @2323121
     /* 2323121 */ GIM_Try, /*On fail goto*//*Label 31961*/ GIMT_Encode4(2323184),
     /* 2323126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2323129 */   GIM_Try, /*On fail goto*//*Label 31962*/ GIMT_Encode4(2323156), // Rule ID 1283 //
     /* 2323134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2323137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2323141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2323145 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2323145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2323148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323155 */     // GIR_Coverage, 1283,
     /* 2323155 */     GIR_EraseRootFromParent_Done,
     /* 2323156 */   // Label 31962: @2323156
     /* 2323156 */   GIM_Try, /*On fail goto*//*Label 31963*/ GIMT_Encode4(2323183), // Rule ID 1291 //
     /* 2323161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2323164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2323168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2323172 */     // (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2323172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2323175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323182 */     // GIR_Coverage, 1291,
     /* 2323182 */     GIR_EraseRootFromParent_Done,
     /* 2323183 */   // Label 31963: @2323183
     /* 2323183 */   GIM_Reject,
     /* 2323184 */ // Label 31961: @2323184
     /* 2323184 */ GIM_Reject,
     /* 2323185 */ // Label 31941: @2323185
     /* 2323185 */ GIM_Try, /*On fail goto*//*Label 31964*/ GIMT_Encode4(2323275),
     /* 2323190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2323193 */   GIM_Try, /*On fail goto*//*Label 31965*/ GIMT_Encode4(2323220), // Rule ID 1626 //
     /* 2323198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2323201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2323205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2323209 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2323209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2323212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323219 */     // GIR_Coverage, 1626,
     /* 2323219 */     GIR_EraseRootFromParent_Done,
     /* 2323220 */   // Label 31965: @2323220
     /* 2323220 */   GIM_Try, /*On fail goto*//*Label 31966*/ GIMT_Encode4(2323247), // Rule ID 1659 //
     /* 2323225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2323228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2323232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2323236 */     // (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2323236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2323239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323246 */     // GIR_Coverage, 1659,
     /* 2323246 */     GIR_EraseRootFromParent_Done,
     /* 2323247 */   // Label 31966: @2323247
     /* 2323247 */   GIM_Try, /*On fail goto*//*Label 31967*/ GIMT_Encode4(2323274), // Rule ID 1681 //
     /* 2323252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2323255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2323259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2323263 */     // (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2323263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2323266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323273 */     // GIR_Coverage, 1681,
     /* 2323273 */     GIR_EraseRootFromParent_Done,
     /* 2323274 */   // Label 31967: @2323274
     /* 2323274 */   GIM_Reject,
     /* 2323275 */ // Label 31964: @2323275
     /* 2323275 */ GIM_Reject,
     /* 2323276 */ // Label 31942: @2323276
     /* 2323276 */ GIM_Try, /*On fail goto*//*Label 31968*/ GIMT_Encode4(2323383),
     /* 2323281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2323284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323292 */   GIM_Try, /*On fail goto*//*Label 31969*/ GIMT_Encode4(2323337), // Rule ID 56246 //
     /* 2323297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2323300 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2323303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2323317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323336 */     // GIR_Coverage, 56246,
     /* 2323336 */     GIR_EraseRootFromParent_Done,
     /* 2323337 */   // Label 31969: @2323337
     /* 2323337 */   GIM_Try, /*On fail goto*//*Label 31970*/ GIMT_Encode4(2323382), // Rule ID 56247 //
     /* 2323342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2323345 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2323348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2323362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323381 */     // GIR_Coverage, 56247,
     /* 2323381 */     GIR_EraseRootFromParent_Done,
     /* 2323382 */   // Label 31970: @2323382
     /* 2323382 */   GIM_Reject,
     /* 2323383 */ // Label 31968: @2323383
     /* 2323383 */ GIM_Reject,
     /* 2323384 */ // Label 31943: @2323384
     /* 2323384 */ GIM_Try, /*On fail goto*//*Label 31971*/ GIMT_Encode4(2323491),
     /* 2323389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2323392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323400 */   GIM_Try, /*On fail goto*//*Label 31972*/ GIMT_Encode4(2323445), // Rule ID 56286 //
     /* 2323405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2323408 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2323411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2323425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323444 */     // GIR_Coverage, 56286,
     /* 2323444 */     GIR_EraseRootFromParent_Done,
     /* 2323445 */   // Label 31972: @2323445
     /* 2323445 */   GIM_Try, /*On fail goto*//*Label 31973*/ GIMT_Encode4(2323490), // Rule ID 56287 //
     /* 2323450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2323453 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2323456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2323470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323489 */     // GIR_Coverage, 56287,
     /* 2323489 */     GIR_EraseRootFromParent_Done,
     /* 2323490 */   // Label 31973: @2323490
     /* 2323490 */   GIM_Reject,
     /* 2323491 */ // Label 31971: @2323491
     /* 2323491 */ GIM_Reject,
     /* 2323492 */ // Label 31944: @2323492
     /* 2323492 */ GIM_Try, /*On fail goto*//*Label 31974*/ GIMT_Encode4(2323599),
     /* 2323497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2323500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323508 */   GIM_Try, /*On fail goto*//*Label 31975*/ GIMT_Encode4(2323553), // Rule ID 56346 //
     /* 2323513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323516 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2323519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2323533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323552 */     // GIR_Coverage, 56346,
     /* 2323552 */     GIR_EraseRootFromParent_Done,
     /* 2323553 */   // Label 31975: @2323553
     /* 2323553 */   GIM_Try, /*On fail goto*//*Label 31976*/ GIMT_Encode4(2323598), // Rule ID 56347 //
     /* 2323558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323561 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2323564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2323578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323597 */     // GIR_Coverage, 56347,
     /* 2323597 */     GIR_EraseRootFromParent_Done,
     /* 2323598 */   // Label 31976: @2323598
     /* 2323598 */   GIM_Reject,
     /* 2323599 */ // Label 31974: @2323599
     /* 2323599 */ GIM_Reject,
     /* 2323600 */ // Label 31945: @2323600
     /* 2323600 */ GIM_Try, /*On fail goto*//*Label 31977*/ GIMT_Encode4(2323707),
     /* 2323605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2323608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323616 */   GIM_Try, /*On fail goto*//*Label 31978*/ GIMT_Encode4(2323661), // Rule ID 56266 //
     /* 2323621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2323624 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2323627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2323641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323660 */     // GIR_Coverage, 56266,
     /* 2323660 */     GIR_EraseRootFromParent_Done,
     /* 2323661 */   // Label 31978: @2323661
     /* 2323661 */   GIM_Try, /*On fail goto*//*Label 31979*/ GIMT_Encode4(2323706), // Rule ID 56267 //
     /* 2323666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2323669 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2323672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2323686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323705 */     // GIR_Coverage, 56267,
     /* 2323705 */     GIR_EraseRootFromParent_Done,
     /* 2323706 */   // Label 31979: @2323706
     /* 2323706 */   GIM_Reject,
     /* 2323707 */ // Label 31977: @2323707
     /* 2323707 */ GIM_Reject,
     /* 2323708 */ // Label 31946: @2323708
     /* 2323708 */ GIM_Try, /*On fail goto*//*Label 31980*/ GIMT_Encode4(2323815),
     /* 2323713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2323716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323724 */   GIM_Try, /*On fail goto*//*Label 31981*/ GIMT_Encode4(2323769), // Rule ID 56326 //
     /* 2323729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2323732 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2323735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2323749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323768 */     // GIR_Coverage, 56326,
     /* 2323768 */     GIR_EraseRootFromParent_Done,
     /* 2323769 */   // Label 31981: @2323769
     /* 2323769 */   GIM_Try, /*On fail goto*//*Label 31982*/ GIMT_Encode4(2323814), // Rule ID 56327 //
     /* 2323774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2323777 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2323780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2323794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323813 */     // GIR_Coverage, 56327,
     /* 2323813 */     GIR_EraseRootFromParent_Done,
     /* 2323814 */   // Label 31982: @2323814
     /* 2323814 */   GIM_Reject,
     /* 2323815 */ // Label 31980: @2323815
     /* 2323815 */ GIM_Reject,
     /* 2323816 */ // Label 31947: @2323816
     /* 2323816 */ GIM_Try, /*On fail goto*//*Label 31983*/ GIMT_Encode4(2323923),
     /* 2323821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2323824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323832 */   GIM_Try, /*On fail goto*//*Label 31984*/ GIMT_Encode4(2323877), // Rule ID 56486 //
     /* 2323837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323840 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2323843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2323857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323876 */     // GIR_Coverage, 56486,
     /* 2323876 */     GIR_EraseRootFromParent_Done,
     /* 2323877 */   // Label 31984: @2323877
     /* 2323877 */   GIM_Try, /*On fail goto*//*Label 31985*/ GIMT_Encode4(2323922), // Rule ID 56487 //
     /* 2323882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323885 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2323888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2323902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323921 */     // GIR_Coverage, 56487,
     /* 2323921 */     GIR_EraseRootFromParent_Done,
     /* 2323922 */   // Label 31985: @2323922
     /* 2323922 */   GIM_Reject,
     /* 2323923 */ // Label 31983: @2323923
     /* 2323923 */ GIM_Reject,
     /* 2323924 */ // Label 31948: @2323924
     /* 2323924 */ GIM_Try, /*On fail goto*//*Label 31986*/ GIMT_Encode4(2324031),
     /* 2323929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2323932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323940 */   GIM_Try, /*On fail goto*//*Label 31987*/ GIMT_Encode4(2323985), // Rule ID 56306 //
     /* 2323945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2323948 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2323951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2323965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323984 */     // GIR_Coverage, 56306,
     /* 2323984 */     GIR_EraseRootFromParent_Done,
     /* 2323985 */   // Label 31987: @2323985
     /* 2323985 */   GIM_Try, /*On fail goto*//*Label 31988*/ GIMT_Encode4(2324030), // Rule ID 56307 //
     /* 2323990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2323993 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2323996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2324010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324029 */     // GIR_Coverage, 56307,
     /* 2324029 */     GIR_EraseRootFromParent_Done,
     /* 2324030 */   // Label 31988: @2324030
     /* 2324030 */   GIM_Reject,
     /* 2324031 */ // Label 31986: @2324031
     /* 2324031 */ GIM_Reject,
     /* 2324032 */ // Label 31949: @2324032
     /* 2324032 */ GIM_Try, /*On fail goto*//*Label 31989*/ GIMT_Encode4(2324139),
     /* 2324037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2324040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324048 */   GIM_Try, /*On fail goto*//*Label 31990*/ GIMT_Encode4(2324093), // Rule ID 56426 //
     /* 2324053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2324056 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2324059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2324073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324092 */     // GIR_Coverage, 56426,
     /* 2324092 */     GIR_EraseRootFromParent_Done,
     /* 2324093 */   // Label 31990: @2324093
     /* 2324093 */   GIM_Try, /*On fail goto*//*Label 31991*/ GIMT_Encode4(2324138), // Rule ID 56427 //
     /* 2324098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2324101 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2324104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2324118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324137 */     // GIR_Coverage, 56427,
     /* 2324137 */     GIR_EraseRootFromParent_Done,
     /* 2324138 */   // Label 31991: @2324138
     /* 2324138 */   GIM_Reject,
     /* 2324139 */ // Label 31989: @2324139
     /* 2324139 */ GIM_Reject,
     /* 2324140 */ // Label 31950: @2324140
     /* 2324140 */ GIM_Try, /*On fail goto*//*Label 31992*/ GIMT_Encode4(2324247),
     /* 2324145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2324148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324156 */   GIM_Try, /*On fail goto*//*Label 31993*/ GIMT_Encode4(2324201), // Rule ID 56506 //
     /* 2324161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2324164 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2324167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2324181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324200 */     // GIR_Coverage, 56506,
     /* 2324200 */     GIR_EraseRootFromParent_Done,
     /* 2324201 */   // Label 31993: @2324201
     /* 2324201 */   GIM_Try, /*On fail goto*//*Label 31994*/ GIMT_Encode4(2324246), // Rule ID 56507 //
     /* 2324206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2324209 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2324212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2324226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324245 */     // GIR_Coverage, 56507,
     /* 2324245 */     GIR_EraseRootFromParent_Done,
     /* 2324246 */   // Label 31994: @2324246
     /* 2324246 */   GIM_Reject,
     /* 2324247 */ // Label 31992: @2324247
     /* 2324247 */ GIM_Reject,
     /* 2324248 */ // Label 31951: @2324248
     /* 2324248 */ GIM_Try, /*On fail goto*//*Label 31995*/ GIMT_Encode4(2324355),
     /* 2324253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2324256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324264 */   GIM_Try, /*On fail goto*//*Label 31996*/ GIMT_Encode4(2324309), // Rule ID 56366 //
     /* 2324269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324272 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2324275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2324289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324308 */     // GIR_Coverage, 56366,
     /* 2324308 */     GIR_EraseRootFromParent_Done,
     /* 2324309 */   // Label 31996: @2324309
     /* 2324309 */   GIM_Try, /*On fail goto*//*Label 31997*/ GIMT_Encode4(2324354), // Rule ID 56367 //
     /* 2324314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324317 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2324320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2324334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324353 */     // GIR_Coverage, 56367,
     /* 2324353 */     GIR_EraseRootFromParent_Done,
     /* 2324354 */   // Label 31997: @2324354
     /* 2324354 */   GIM_Reject,
     /* 2324355 */ // Label 31995: @2324355
     /* 2324355 */ GIM_Reject,
     /* 2324356 */ // Label 31952: @2324356
     /* 2324356 */ GIM_Try, /*On fail goto*//*Label 31998*/ GIMT_Encode4(2324463),
     /* 2324361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2324364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324372 */   GIM_Try, /*On fail goto*//*Label 31999*/ GIMT_Encode4(2324417), // Rule ID 56446 //
     /* 2324377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2324380 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2324383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2324397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324416 */     // GIR_Coverage, 56446,
     /* 2324416 */     GIR_EraseRootFromParent_Done,
     /* 2324417 */   // Label 31999: @2324417
     /* 2324417 */   GIM_Try, /*On fail goto*//*Label 32000*/ GIMT_Encode4(2324462), // Rule ID 56447 //
     /* 2324422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2324425 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2324428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2324442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324461 */     // GIR_Coverage, 56447,
     /* 2324461 */     GIR_EraseRootFromParent_Done,
     /* 2324462 */   // Label 32000: @2324462
     /* 2324462 */   GIM_Reject,
     /* 2324463 */ // Label 31998: @2324463
     /* 2324463 */ GIM_Reject,
     /* 2324464 */ // Label 31953: @2324464
     /* 2324464 */ GIM_Try, /*On fail goto*//*Label 32001*/ GIMT_Encode4(2324571),
     /* 2324469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2324472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324480 */   GIM_Try, /*On fail goto*//*Label 32002*/ GIMT_Encode4(2324525), // Rule ID 56526 //
     /* 2324485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2324488 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2324491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2324505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324524 */     // GIR_Coverage, 56526,
     /* 2324524 */     GIR_EraseRootFromParent_Done,
     /* 2324525 */   // Label 32002: @2324525
     /* 2324525 */   GIM_Try, /*On fail goto*//*Label 32003*/ GIMT_Encode4(2324570), // Rule ID 56527 //
     /* 2324530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2324533 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2324536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2324550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324569 */     // GIR_Coverage, 56527,
     /* 2324569 */     GIR_EraseRootFromParent_Done,
     /* 2324570 */   // Label 32003: @2324570
     /* 2324570 */   GIM_Reject,
     /* 2324571 */ // Label 32001: @2324571
     /* 2324571 */ GIM_Reject,
     /* 2324572 */ // Label 31954: @2324572
     /* 2324572 */ GIM_Try, /*On fail goto*//*Label 32004*/ GIMT_Encode4(2324679),
     /* 2324577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324588 */   GIM_Try, /*On fail goto*//*Label 32005*/ GIMT_Encode4(2324633), // Rule ID 56386 //
     /* 2324593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324596 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2324599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2324613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324632 */     // GIR_Coverage, 56386,
     /* 2324632 */     GIR_EraseRootFromParent_Done,
     /* 2324633 */   // Label 32005: @2324633
     /* 2324633 */   GIM_Try, /*On fail goto*//*Label 32006*/ GIMT_Encode4(2324678), // Rule ID 56387 //
     /* 2324638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324641 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2324644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2324658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324677 */     // GIR_Coverage, 56387,
     /* 2324677 */     GIR_EraseRootFromParent_Done,
     /* 2324678 */   // Label 32006: @2324678
     /* 2324678 */   GIM_Reject,
     /* 2324679 */ // Label 32004: @2324679
     /* 2324679 */ GIM_Reject,
     /* 2324680 */ // Label 31955: @2324680
     /* 2324680 */ GIM_Try, /*On fail goto*//*Label 32007*/ GIMT_Encode4(2324787),
     /* 2324685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324696 */   GIM_Try, /*On fail goto*//*Label 32008*/ GIMT_Encode4(2324741), // Rule ID 56466 //
     /* 2324701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2324704 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2324707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2324721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324740 */     // GIR_Coverage, 56466,
     /* 2324740 */     GIR_EraseRootFromParent_Done,
     /* 2324741 */   // Label 32008: @2324741
     /* 2324741 */   GIM_Try, /*On fail goto*//*Label 32009*/ GIMT_Encode4(2324786), // Rule ID 56467 //
     /* 2324746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2324749 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2324752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2324766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324785 */     // GIR_Coverage, 56467,
     /* 2324785 */     GIR_EraseRootFromParent_Done,
     /* 2324786 */   // Label 32009: @2324786
     /* 2324786 */   GIM_Reject,
     /* 2324787 */ // Label 32007: @2324787
     /* 2324787 */ GIM_Reject,
     /* 2324788 */ // Label 31956: @2324788
     /* 2324788 */ GIM_Try, /*On fail goto*//*Label 32010*/ GIMT_Encode4(2324895),
     /* 2324793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2324796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324804 */   GIM_Try, /*On fail goto*//*Label 32011*/ GIMT_Encode4(2324849), // Rule ID 56406 //
     /* 2324809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324812 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2324815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2324829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324848 */     // GIR_Coverage, 56406,
     /* 2324848 */     GIR_EraseRootFromParent_Done,
     /* 2324849 */   // Label 32011: @2324849
     /* 2324849 */   GIM_Try, /*On fail goto*//*Label 32012*/ GIMT_Encode4(2324894), // Rule ID 56407 //
     /* 2324854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324857 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2324860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2324874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324893 */     // GIR_Coverage, 56407,
     /* 2324893 */     GIR_EraseRootFromParent_Done,
     /* 2324894 */   // Label 32012: @2324894
     /* 2324894 */   GIM_Reject,
     /* 2324895 */ // Label 32010: @2324895
     /* 2324895 */ GIM_Reject,
     /* 2324896 */ // Label 31957: @2324896
     /* 2324896 */ GIM_Reject,
     /* 2324897 */ // Label 65: @2324897
     /* 2324897 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 32015*/ GIMT_Encode4(2325349),
     /* 2324908 */ /*GILLT_s32*//*Label 32013*/ GIMT_Encode4(2324916),
     /* 2324912 */ /*GILLT_s64*//*Label 32014*/ GIMT_Encode4(2325038),
     /* 2324916 */ // Label 32013: @2324916
     /* 2324916 */ GIM_Try, /*On fail goto*//*Label 32016*/ GIMT_Encode4(2325037),
     /* 2324921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2324924 */   GIM_Try, /*On fail goto*//*Label 32017*/ GIMT_Encode4(2324952), // Rule ID 2166 //
     /* 2324929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2324932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2324936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2324940 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2324940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2324943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324951 */     // GIR_Coverage, 2166,
     /* 2324951 */     GIR_EraseRootFromParent_Done,
     /* 2324952 */   // Label 32017: @2324952
     /* 2324952 */   GIM_Try, /*On fail goto*//*Label 32018*/ GIMT_Encode4(2324980), // Rule ID 2167 //
     /* 2324957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2324960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2324964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2324968 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2324968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2324971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324979 */     // GIR_Coverage, 2167,
     /* 2324979 */     GIR_EraseRootFromParent_Done,
     /* 2324980 */   // Label 32018: @2324980
     /* 2324980 */   GIM_Try, /*On fail goto*//*Label 32019*/ GIMT_Encode4(2325008), // Rule ID 2182 //
     /* 2324985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2324988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2324992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2324996 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2324996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2324999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325007 */     // GIR_Coverage, 2182,
     /* 2325007 */     GIR_EraseRootFromParent_Done,
     /* 2325008 */   // Label 32019: @2325008
     /* 2325008 */   GIM_Try, /*On fail goto*//*Label 32020*/ GIMT_Encode4(2325036), // Rule ID 2183 //
     /* 2325013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2325016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325024 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2325024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2325027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325035 */     // GIR_Coverage, 2183,
     /* 2325035 */     GIR_EraseRootFromParent_Done,
     /* 2325036 */   // Label 32020: @2325036
     /* 2325036 */   GIM_Reject,
     /* 2325037 */ // Label 32016: @2325037
     /* 2325037 */ GIM_Reject,
     /* 2325038 */ // Label 32014: @2325038
     /* 2325038 */ GIM_Try, /*On fail goto*//*Label 32021*/ GIMT_Encode4(2325069), // Rule ID 1568 //
     /* 2325043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2325046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325057 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2325057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2325060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325062 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325067 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325068 */   // GIR_Coverage, 1568,
     /* 2325068 */   GIR_EraseRootFromParent_Done,
     /* 2325069 */ // Label 32021: @2325069
     /* 2325069 */ GIM_Try, /*On fail goto*//*Label 32022*/ GIMT_Encode4(2325100), // Rule ID 1569 //
     /* 2325074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2325077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325088 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2325088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2325091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325093 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325099 */   // GIR_Coverage, 1569,
     /* 2325099 */   GIR_EraseRootFromParent_Done,
     /* 2325100 */ // Label 32022: @2325100
     /* 2325100 */ GIM_Try, /*On fail goto*//*Label 32023*/ GIMT_Encode4(2325131), // Rule ID 1573 //
     /* 2325105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2325108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325119 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_INX:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2325119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2325122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325124 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325129 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325130 */   // GIR_Coverage, 1573,
     /* 2325130 */   GIR_EraseRootFromParent_Done,
     /* 2325131 */ // Label 32023: @2325131
     /* 2325131 */ GIM_Try, /*On fail goto*//*Label 32024*/ GIMT_Encode4(2325162), // Rule ID 1580 //
     /* 2325136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2325139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325150 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2325150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2325153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325155 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325160 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325161 */   // GIR_Coverage, 1580,
     /* 2325161 */   GIR_EraseRootFromParent_Done,
     /* 2325162 */ // Label 32024: @2325162
     /* 2325162 */ GIM_Try, /*On fail goto*//*Label 32025*/ GIMT_Encode4(2325193), // Rule ID 1581 //
     /* 2325167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2325170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325181 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2325181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2325184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325186 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325191 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325192 */   // GIR_Coverage, 1581,
     /* 2325192 */   GIR_EraseRootFromParent_Done,
     /* 2325193 */ // Label 32025: @2325193
     /* 2325193 */ GIM_Try, /*On fail goto*//*Label 32026*/ GIMT_Encode4(2325224), // Rule ID 2300 //
     /* 2325198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2325201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2325204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325212 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2325212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2325215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325217 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325223 */   // GIR_Coverage, 2300,
     /* 2325223 */   GIR_EraseRootFromParent_Done,
     /* 2325224 */ // Label 32026: @2325224
     /* 2325224 */ GIM_Try, /*On fail goto*//*Label 32027*/ GIMT_Encode4(2325255), // Rule ID 2301 //
     /* 2325229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2325232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2325235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325243 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2325243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2325246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325248 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325253 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325254 */   // GIR_Coverage, 2301,
     /* 2325254 */   GIR_EraseRootFromParent_Done,
     /* 2325255 */ // Label 32027: @2325255
     /* 2325255 */ GIM_Try, /*On fail goto*//*Label 32028*/ GIMT_Encode4(2325286), // Rule ID 2312 //
     /* 2325260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2325263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2325266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325274 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2325274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2325277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325279 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325284 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325285 */   // GIR_Coverage, 2312,
     /* 2325285 */   GIR_EraseRootFromParent_Done,
     /* 2325286 */ // Label 32028: @2325286
     /* 2325286 */ GIM_Try, /*On fail goto*//*Label 32029*/ GIMT_Encode4(2325317), // Rule ID 2313 //
     /* 2325291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2325294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2325297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325305 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2325305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2325308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325310 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325315 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325316 */   // GIR_Coverage, 2313,
     /* 2325316 */   GIR_EraseRootFromParent_Done,
     /* 2325317 */ // Label 32029: @2325317
     /* 2325317 */ GIM_Try, /*On fail goto*//*Label 32030*/ GIMT_Encode4(2325348), // Rule ID 2321 //
     /* 2325322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2325325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2325328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325336 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_INX:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2325336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2325339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325341 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325346 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325347 */   // GIR_Coverage, 2321,
     /* 2325347 */   GIR_EraseRootFromParent_Done,
     /* 2325348 */ // Label 32030: @2325348
     /* 2325348 */ GIM_Reject,
     /* 2325349 */ // Label 32015: @2325349
     /* 2325349 */ GIM_Reject,
     /* 2325350 */ // Label 66: @2325350
     /* 2325350 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(28), /*)*//*default:*//*Label 32042*/ GIMT_Encode4(2326885),
     /* 2325361 */ /*GILLT_s16*//*Label 32031*/ GIMT_Encode4(2325465),
     /* 2325365 */ /*GILLT_s32*//*Label 32032*/ GIMT_Encode4(2325745), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325381 */ /*GILLT_nxv1s16*//*Label 32033*/ GIMT_Encode4(2325895),
     /* 2325385 */ /*GILLT_nxv1s32*//*Label 32034*/ GIMT_Encode4(2326005), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325401 */ /*GILLT_nxv2s16*//*Label 32035*/ GIMT_Encode4(2326115),
     /* 2325405 */ /*GILLT_nxv2s32*//*Label 32036*/ GIMT_Encode4(2326225), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325421 */ /*GILLT_nxv4s16*//*Label 32037*/ GIMT_Encode4(2326335),
     /* 2325425 */ /*GILLT_nxv4s32*//*Label 32038*/ GIMT_Encode4(2326445), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325441 */ /*GILLT_nxv8s16*//*Label 32039*/ GIMT_Encode4(2326555),
     /* 2325445 */ /*GILLT_nxv8s32*//*Label 32040*/ GIMT_Encode4(2326665), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325461 */ /*GILLT_nxv16s16*//*Label 32041*/ GIMT_Encode4(2326775),
     /* 2325465 */ // Label 32031: @2325465
     /* 2325465 */ GIM_Try, /*On fail goto*//*Label 32043*/ GIMT_Encode4(2325496), // Rule ID 2162 //
     /* 2325470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2325473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325484 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2325484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2325487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325489 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325494 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325495 */   // GIR_Coverage, 2162,
     /* 2325495 */   GIR_EraseRootFromParent_Done,
     /* 2325496 */ // Label 32043: @2325496
     /* 2325496 */ GIM_Try, /*On fail goto*//*Label 32044*/ GIMT_Encode4(2325527), // Rule ID 2163 //
     /* 2325501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2325504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325515 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2325515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2325518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325520 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325525 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325526 */   // GIR_Coverage, 2163,
     /* 2325526 */   GIR_EraseRootFromParent_Done,
     /* 2325527 */ // Label 32044: @2325527
     /* 2325527 */ GIM_Try, /*On fail goto*//*Label 32045*/ GIMT_Encode4(2325558), // Rule ID 2178 //
     /* 2325532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2325535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325546 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2325546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2325549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325551 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325556 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325557 */   // GIR_Coverage, 2178,
     /* 2325557 */   GIR_EraseRootFromParent_Done,
     /* 2325558 */ // Label 32045: @2325558
     /* 2325558 */ GIM_Try, /*On fail goto*//*Label 32046*/ GIMT_Encode4(2325589), // Rule ID 2179 //
     /* 2325563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2325566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325577 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2325577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2325580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325582 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325588 */   // GIR_Coverage, 2179,
     /* 2325588 */   GIR_EraseRootFromParent_Done,
     /* 2325589 */ // Label 32046: @2325589
     /* 2325589 */ GIM_Try, /*On fail goto*//*Label 32047*/ GIMT_Encode4(2325620), // Rule ID 2296 //
     /* 2325594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2325597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325608 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2325608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2325611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325613 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325618 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325619 */   // GIR_Coverage, 2296,
     /* 2325619 */   GIR_EraseRootFromParent_Done,
     /* 2325620 */ // Label 32047: @2325620
     /* 2325620 */ GIM_Try, /*On fail goto*//*Label 32048*/ GIMT_Encode4(2325651), // Rule ID 2297 //
     /* 2325625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2325628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325639 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2325639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2325642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325644 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325649 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325650 */   // GIR_Coverage, 2297,
     /* 2325650 */   GIR_EraseRootFromParent_Done,
     /* 2325651 */ // Label 32048: @2325651
     /* 2325651 */ GIM_Try, /*On fail goto*//*Label 32049*/ GIMT_Encode4(2325682), // Rule ID 2308 //
     /* 2325656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2325659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325670 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2325670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2325673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325675 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325680 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325681 */   // GIR_Coverage, 2308,
     /* 2325681 */   GIR_EraseRootFromParent_Done,
     /* 2325682 */ // Label 32049: @2325682
     /* 2325682 */ GIM_Try, /*On fail goto*//*Label 32050*/ GIMT_Encode4(2325713), // Rule ID 2309 //
     /* 2325687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2325690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325701 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2325701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2325704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325706 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325711 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325712 */   // GIR_Coverage, 2309,
     /* 2325712 */   GIR_EraseRootFromParent_Done,
     /* 2325713 */ // Label 32050: @2325713
     /* 2325713 */ GIM_Try, /*On fail goto*//*Label 32051*/ GIMT_Encode4(2325744), // Rule ID 2319 //
     /* 2325718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2325721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325732 */   // (fpround:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_INX:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2325732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2325735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325737 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325742 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325743 */   // GIR_Coverage, 2319,
     /* 2325743 */   GIR_EraseRootFromParent_Done,
     /* 2325744 */ // Label 32051: @2325744
     /* 2325744 */ GIM_Reject,
     /* 2325745 */ // Label 32032: @2325745
     /* 2325745 */ GIM_Try, /*On fail goto*//*Label 32052*/ GIMT_Encode4(2325894),
     /* 2325750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325753 */   GIM_Try, /*On fail goto*//*Label 32053*/ GIMT_Encode4(2325781), // Rule ID 1564 //
     /* 2325758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2325761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325769 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2325769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2325772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325780 */     // GIR_Coverage, 1564,
     /* 2325780 */     GIR_EraseRootFromParent_Done,
     /* 2325781 */   // Label 32053: @2325781
     /* 2325781 */   GIM_Try, /*On fail goto*//*Label 32054*/ GIMT_Encode4(2325809), // Rule ID 1565 //
     /* 2325786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2325789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325797 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2325797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2325800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325808 */     // GIR_Coverage, 1565,
     /* 2325808 */     GIR_EraseRootFromParent_Done,
     /* 2325809 */   // Label 32054: @2325809
     /* 2325809 */   GIM_Try, /*On fail goto*//*Label 32055*/ GIMT_Encode4(2325837), // Rule ID 1571 //
     /* 2325814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2325817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325825 */     // (fpround:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_INX:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2325825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2325828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325836 */     // GIR_Coverage, 1571,
     /* 2325836 */     GIR_EraseRootFromParent_Done,
     /* 2325837 */   // Label 32055: @2325837
     /* 2325837 */   GIM_Try, /*On fail goto*//*Label 32056*/ GIMT_Encode4(2325865), // Rule ID 1576 //
     /* 2325842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2325845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325853 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2325853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2325856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325864 */     // GIR_Coverage, 1576,
     /* 2325864 */     GIR_EraseRootFromParent_Done,
     /* 2325865 */   // Label 32056: @2325865
     /* 2325865 */   GIM_Try, /*On fail goto*//*Label 32057*/ GIMT_Encode4(2325893), // Rule ID 1577 //
     /* 2325870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2325873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325881 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2325881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2325884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325892 */     // GIR_Coverage, 1577,
     /* 2325892 */     GIR_EraseRootFromParent_Done,
     /* 2325893 */   // Label 32057: @2325893
     /* 2325893 */   GIM_Reject,
     /* 2325894 */ // Label 32052: @2325894
     /* 2325894 */ GIM_Reject,
     /* 2325895 */ // Label 32033: @2325895
     /* 2325895 */ GIM_Try, /*On fail goto*//*Label 32058*/ GIMT_Encode4(2326004),
     /* 2325900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2325903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325911 */   GIM_Try, /*On fail goto*//*Label 32059*/ GIMT_Encode4(2325957), // Rule ID 58894 //
     /* 2325916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2325919 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2325922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2325936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325956 */     // GIR_Coverage, 58894,
     /* 2325956 */     GIR_EraseRootFromParent_Done,
     /* 2325957 */   // Label 32059: @2325957
     /* 2325957 */   GIM_Try, /*On fail goto*//*Label 32060*/ GIMT_Encode4(2326003), // Rule ID 58895 //
     /* 2325962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2325965 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2325968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2325982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326002 */     // GIR_Coverage, 58895,
     /* 2326002 */     GIR_EraseRootFromParent_Done,
     /* 2326003 */   // Label 32060: @2326003
     /* 2326003 */   GIM_Reject,
     /* 2326004 */ // Label 32058: @2326004
     /* 2326004 */ GIM_Reject,
     /* 2326005 */ // Label 32034: @2326005
     /* 2326005 */ GIM_Try, /*On fail goto*//*Label 32061*/ GIMT_Encode4(2326114),
     /* 2326010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2326013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326021 */   GIM_Try, /*On fail goto*//*Label 32062*/ GIMT_Encode4(2326067), // Rule ID 58904 //
     /* 2326026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2326029 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2326032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2326046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326066 */     // GIR_Coverage, 58904,
     /* 2326066 */     GIR_EraseRootFromParent_Done,
     /* 2326067 */   // Label 32062: @2326067
     /* 2326067 */   GIM_Try, /*On fail goto*//*Label 32063*/ GIMT_Encode4(2326113), // Rule ID 58905 //
     /* 2326072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2326075 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2326078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2326092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326112 */     // GIR_Coverage, 58905,
     /* 2326112 */     GIR_EraseRootFromParent_Done,
     /* 2326113 */   // Label 32063: @2326113
     /* 2326113 */   GIM_Reject,
     /* 2326114 */ // Label 32061: @2326114
     /* 2326114 */ GIM_Reject,
     /* 2326115 */ // Label 32035: @2326115
     /* 2326115 */ GIM_Try, /*On fail goto*//*Label 32064*/ GIMT_Encode4(2326224),
     /* 2326120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2326123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326131 */   GIM_Try, /*On fail goto*//*Label 32065*/ GIMT_Encode4(2326177), // Rule ID 58896 //
     /* 2326136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2326139 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2326142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2326156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326176 */     // GIR_Coverage, 58896,
     /* 2326176 */     GIR_EraseRootFromParent_Done,
     /* 2326177 */   // Label 32065: @2326177
     /* 2326177 */   GIM_Try, /*On fail goto*//*Label 32066*/ GIMT_Encode4(2326223), // Rule ID 58897 //
     /* 2326182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2326185 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2326188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2326202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326222 */     // GIR_Coverage, 58897,
     /* 2326222 */     GIR_EraseRootFromParent_Done,
     /* 2326223 */   // Label 32066: @2326223
     /* 2326223 */   GIM_Reject,
     /* 2326224 */ // Label 32064: @2326224
     /* 2326224 */ GIM_Reject,
     /* 2326225 */ // Label 32036: @2326225
     /* 2326225 */ GIM_Try, /*On fail goto*//*Label 32067*/ GIMT_Encode4(2326334),
     /* 2326230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2326233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326241 */   GIM_Try, /*On fail goto*//*Label 32068*/ GIMT_Encode4(2326287), // Rule ID 58906 //
     /* 2326246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2326249 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2326252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2326266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326286 */     // GIR_Coverage, 58906,
     /* 2326286 */     GIR_EraseRootFromParent_Done,
     /* 2326287 */   // Label 32068: @2326287
     /* 2326287 */   GIM_Try, /*On fail goto*//*Label 32069*/ GIMT_Encode4(2326333), // Rule ID 58907 //
     /* 2326292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2326295 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2326298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2326312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326332 */     // GIR_Coverage, 58907,
     /* 2326332 */     GIR_EraseRootFromParent_Done,
     /* 2326333 */   // Label 32069: @2326333
     /* 2326333 */   GIM_Reject,
     /* 2326334 */ // Label 32067: @2326334
     /* 2326334 */ GIM_Reject,
     /* 2326335 */ // Label 32037: @2326335
     /* 2326335 */ GIM_Try, /*On fail goto*//*Label 32070*/ GIMT_Encode4(2326444),
     /* 2326340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2326343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326351 */   GIM_Try, /*On fail goto*//*Label 32071*/ GIMT_Encode4(2326397), // Rule ID 58898 //
     /* 2326356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2326359 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2326362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2326376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326396 */     // GIR_Coverage, 58898,
     /* 2326396 */     GIR_EraseRootFromParent_Done,
     /* 2326397 */   // Label 32071: @2326397
     /* 2326397 */   GIM_Try, /*On fail goto*//*Label 32072*/ GIMT_Encode4(2326443), // Rule ID 58899 //
     /* 2326402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2326405 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2326408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2326422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326442 */     // GIR_Coverage, 58899,
     /* 2326442 */     GIR_EraseRootFromParent_Done,
     /* 2326443 */   // Label 32072: @2326443
     /* 2326443 */   GIM_Reject,
     /* 2326444 */ // Label 32070: @2326444
     /* 2326444 */ GIM_Reject,
     /* 2326445 */ // Label 32038: @2326445
     /* 2326445 */ GIM_Try, /*On fail goto*//*Label 32073*/ GIMT_Encode4(2326554),
     /* 2326450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2326453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326461 */   GIM_Try, /*On fail goto*//*Label 32074*/ GIMT_Encode4(2326507), // Rule ID 58908 //
     /* 2326466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2326469 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2326472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2326486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326506 */     // GIR_Coverage, 58908,
     /* 2326506 */     GIR_EraseRootFromParent_Done,
     /* 2326507 */   // Label 32074: @2326507
     /* 2326507 */   GIM_Try, /*On fail goto*//*Label 32075*/ GIMT_Encode4(2326553), // Rule ID 58909 //
     /* 2326512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2326515 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2326518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2326532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326552 */     // GIR_Coverage, 58909,
     /* 2326552 */     GIR_EraseRootFromParent_Done,
     /* 2326553 */   // Label 32075: @2326553
     /* 2326553 */   GIM_Reject,
     /* 2326554 */ // Label 32073: @2326554
     /* 2326554 */ GIM_Reject,
     /* 2326555 */ // Label 32039: @2326555
     /* 2326555 */ GIM_Try, /*On fail goto*//*Label 32076*/ GIMT_Encode4(2326664),
     /* 2326560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2326563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326571 */   GIM_Try, /*On fail goto*//*Label 32077*/ GIMT_Encode4(2326617), // Rule ID 58900 //
     /* 2326576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2326579 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2326582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2326596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326616 */     // GIR_Coverage, 58900,
     /* 2326616 */     GIR_EraseRootFromParent_Done,
     /* 2326617 */   // Label 32077: @2326617
     /* 2326617 */   GIM_Try, /*On fail goto*//*Label 32078*/ GIMT_Encode4(2326663), // Rule ID 58901 //
     /* 2326622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2326625 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2326628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2326642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326662 */     // GIR_Coverage, 58901,
     /* 2326662 */     GIR_EraseRootFromParent_Done,
     /* 2326663 */   // Label 32078: @2326663
     /* 2326663 */   GIM_Reject,
     /* 2326664 */ // Label 32076: @2326664
     /* 2326664 */ GIM_Reject,
     /* 2326665 */ // Label 32040: @2326665
     /* 2326665 */ GIM_Try, /*On fail goto*//*Label 32079*/ GIMT_Encode4(2326774),
     /* 2326670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2326673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326681 */   GIM_Try, /*On fail goto*//*Label 32080*/ GIMT_Encode4(2326727), // Rule ID 58910 //
     /* 2326686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2326689 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2326692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2326706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326726 */     // GIR_Coverage, 58910,
     /* 2326726 */     GIR_EraseRootFromParent_Done,
     /* 2326727 */   // Label 32080: @2326727
     /* 2326727 */   GIM_Try, /*On fail goto*//*Label 32081*/ GIMT_Encode4(2326773), // Rule ID 58911 //
     /* 2326732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2326735 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2326738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2326752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326772 */     // GIR_Coverage, 58911,
     /* 2326772 */     GIR_EraseRootFromParent_Done,
     /* 2326773 */   // Label 32081: @2326773
     /* 2326773 */   GIM_Reject,
     /* 2326774 */ // Label 32079: @2326774
     /* 2326774 */ GIM_Reject,
     /* 2326775 */ // Label 32041: @2326775
     /* 2326775 */ GIM_Try, /*On fail goto*//*Label 32082*/ GIMT_Encode4(2326884),
     /* 2326780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2326783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326791 */   GIM_Try, /*On fail goto*//*Label 32083*/ GIMT_Encode4(2326837), // Rule ID 58902 //
     /* 2326796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2326799 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2326802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2326816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326836 */     // GIR_Coverage, 58902,
     /* 2326836 */     GIR_EraseRootFromParent_Done,
     /* 2326837 */   // Label 32083: @2326837
     /* 2326837 */   GIM_Try, /*On fail goto*//*Label 32084*/ GIMT_Encode4(2326883), // Rule ID 58903 //
     /* 2326842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2326845 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2326848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2326862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326882 */     // GIR_Coverage, 58903,
     /* 2326882 */     GIR_EraseRootFromParent_Done,
     /* 2326883 */   // Label 32084: @2326883
     /* 2326883 */   GIM_Reject,
     /* 2326884 */ // Label 32082: @2326884
     /* 2326884 */ GIM_Reject,
     /* 2326885 */ // Label 32042: @2326885
     /* 2326885 */ GIM_Reject,
     /* 2326886 */ // Label 67: @2326886
     /* 2326886 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 32108*/ GIMT_Encode4(2331771),
     /* 2326897 */ /*GILLT_s32*//*Label 32085*/ GIMT_Encode4(2327013),
     /* 2326901 */ /*GILLT_s64*//*Label 32086*/ GIMT_Encode4(2327386), GIMT_Encode4(0),
     /* 2326909 */ /*GILLT_nxv1s8*//*Label 32087*/ GIMT_Encode4(2327573),
     /* 2326913 */ /*GILLT_nxv1s16*//*Label 32088*/ GIMT_Encode4(2327677),
     /* 2326917 */ /*GILLT_nxv1s32*//*Label 32089*/ GIMT_Encode4(2327894),
     /* 2326921 */ /*GILLT_nxv1s64*//*Label 32090*/ GIMT_Encode4(2328219), GIMT_Encode4(0),
     /* 2326929 */ /*GILLT_nxv2s8*//*Label 32091*/ GIMT_Encode4(2328436),
     /* 2326933 */ /*GILLT_nxv2s16*//*Label 32092*/ GIMT_Encode4(2328540),
     /* 2326937 */ /*GILLT_nxv2s32*//*Label 32093*/ GIMT_Encode4(2328757),
     /* 2326941 */ /*GILLT_nxv2s64*//*Label 32094*/ GIMT_Encode4(2329082), GIMT_Encode4(0),
     /* 2326949 */ /*GILLT_nxv4s8*//*Label 32095*/ GIMT_Encode4(2329299),
     /* 2326953 */ /*GILLT_nxv4s16*//*Label 32096*/ GIMT_Encode4(2329403),
     /* 2326957 */ /*GILLT_nxv4s32*//*Label 32097*/ GIMT_Encode4(2329620),
     /* 2326961 */ /*GILLT_nxv4s64*//*Label 32098*/ GIMT_Encode4(2329945), GIMT_Encode4(0),
     /* 2326969 */ /*GILLT_nxv8s8*//*Label 32099*/ GIMT_Encode4(2330162),
     /* 2326973 */ /*GILLT_nxv8s16*//*Label 32100*/ GIMT_Encode4(2330266),
     /* 2326977 */ /*GILLT_nxv8s32*//*Label 32101*/ GIMT_Encode4(2330483),
     /* 2326981 */ /*GILLT_nxv8s64*//*Label 32102*/ GIMT_Encode4(2330808), GIMT_Encode4(0),
     /* 2326989 */ /*GILLT_nxv16s8*//*Label 32103*/ GIMT_Encode4(2331025),
     /* 2326993 */ /*GILLT_nxv16s16*//*Label 32104*/ GIMT_Encode4(2331129),
     /* 2326997 */ /*GILLT_nxv16s32*//*Label 32105*/ GIMT_Encode4(2331346), GIMT_Encode4(0),
     /* 2327005 */ /*GILLT_nxv32s8*//*Label 32106*/ GIMT_Encode4(2331563),
     /* 2327009 */ /*GILLT_nxv32s16*//*Label 32107*/ GIMT_Encode4(2331667),
     /* 2327013 */ // Label 32085: @2327013
     /* 2327013 */ GIM_Try, /*On fail goto*//*Label 32109*/ GIMT_Encode4(2327044), // Rule ID 1456 //
     /* 2327018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2327021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2327032 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2327032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2327035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327037 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327042 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327043 */   // GIR_Coverage, 1456,
     /* 2327043 */   GIR_EraseRootFromParent_Done,
     /* 2327044 */ // Label 32109: @2327044
     /* 2327044 */ GIM_Try, /*On fail goto*//*Label 32110*/ GIMT_Encode4(2327075), // Rule ID 1457 //
     /* 2327049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2327052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2327063 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2327063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2327066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327068 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327073 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327074 */   // GIR_Coverage, 1457,
     /* 2327074 */   GIR_EraseRootFromParent_Done,
     /* 2327075 */ // Label 32110: @2327075
     /* 2327075 */ GIM_Try, /*On fail goto*//*Label 32111*/ GIMT_Encode4(2327106), // Rule ID 1482 //
     /* 2327080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2327083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327094 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2327094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2327097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327099 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327104 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327105 */   // GIR_Coverage, 1482,
     /* 2327105 */   GIR_EraseRootFromParent_Done,
     /* 2327106 */ // Label 32111: @2327106
     /* 2327106 */ GIM_Try, /*On fail goto*//*Label 32112*/ GIMT_Encode4(2327137), // Rule ID 1483 //
     /* 2327111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2327114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327125 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2327125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2327128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327130 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327135 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327136 */   // GIR_Coverage, 1483,
     /* 2327136 */   GIR_EraseRootFromParent_Done,
     /* 2327137 */ // Label 32112: @2327137
     /* 2327137 */ GIM_Try, /*On fail goto*//*Label 32113*/ GIMT_Encode4(2327168), // Rule ID 1850 //
     /* 2327142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2327145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327156 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2327156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2327159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327161 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327166 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327167 */   // GIR_Coverage, 1850,
     /* 2327167 */   GIR_EraseRootFromParent_Done,
     /* 2327168 */ // Label 32113: @2327168
     /* 2327168 */ GIM_Try, /*On fail goto*//*Label 32114*/ GIMT_Encode4(2327199), // Rule ID 1851 //
     /* 2327173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2327176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327187 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2327187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2327190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327192 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327197 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327198 */   // GIR_Coverage, 1851,
     /* 2327198 */   GIR_EraseRootFromParent_Done,
     /* 2327199 */ // Label 32114: @2327199
     /* 2327199 */ GIM_Try, /*On fail goto*//*Label 32115*/ GIMT_Encode4(2327230), // Rule ID 1876 //
     /* 2327204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2327207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2327218 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2327218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2327221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327223 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327228 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327229 */   // GIR_Coverage, 1876,
     /* 2327229 */   GIR_EraseRootFromParent_Done,
     /* 2327230 */ // Label 32115: @2327230
     /* 2327230 */ GIM_Try, /*On fail goto*//*Label 32116*/ GIMT_Encode4(2327261), // Rule ID 1877 //
     /* 2327235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2327238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2327249 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2327249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2327252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327254 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327260 */   // GIR_Coverage, 1877,
     /* 2327260 */   GIR_EraseRootFromParent_Done,
     /* 2327261 */ // Label 32116: @2327261
     /* 2327261 */ GIM_Try, /*On fail goto*//*Label 32117*/ GIMT_Encode4(2327292), // Rule ID 2192 //
     /* 2327266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2327269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2327280 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2327280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2327283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327285 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327291 */   // GIR_Coverage, 2192,
     /* 2327291 */   GIR_EraseRootFromParent_Done,
     /* 2327292 */ // Label 32117: @2327292
     /* 2327292 */ GIM_Try, /*On fail goto*//*Label 32118*/ GIMT_Encode4(2327323), // Rule ID 2193 //
     /* 2327297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2327300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2327311 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2327311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2327314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327316 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327321 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327322 */   // GIR_Coverage, 2193,
     /* 2327322 */   GIR_EraseRootFromParent_Done,
     /* 2327323 */ // Label 32118: @2327323
     /* 2327323 */ GIM_Try, /*On fail goto*//*Label 32119*/ GIMT_Encode4(2327354), // Rule ID 2218 //
     /* 2327328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2327331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327342 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2327342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2327345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327347 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327352 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327353 */   // GIR_Coverage, 2218,
     /* 2327353 */   GIR_EraseRootFromParent_Done,
     /* 2327354 */ // Label 32119: @2327354
     /* 2327354 */ GIM_Try, /*On fail goto*//*Label 32120*/ GIMT_Encode4(2327385), // Rule ID 2219 //
     /* 2327359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2327362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327373 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2327373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2327376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327378 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327383 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327384 */   // GIR_Coverage, 2219,
     /* 2327384 */   GIR_EraseRootFromParent_Done,
     /* 2327385 */ // Label 32120: @2327385
     /* 2327385 */ GIM_Reject,
     /* 2327386 */ // Label 32086: @2327386
     /* 2327386 */ GIM_Try, /*On fail goto*//*Label 32121*/ GIMT_Encode4(2327417), // Rule ID 1513 //
     /* 2327391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2327394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2327405 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2327405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2327408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327410 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327416 */   // GIR_Coverage, 1513,
     /* 2327416 */   GIR_EraseRootFromParent_Done,
     /* 2327417 */ // Label 32121: @2327417
     /* 2327417 */ GIM_Try, /*On fail goto*//*Label 32122*/ GIMT_Encode4(2327448), // Rule ID 1541 //
     /* 2327422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2327425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327436 */   // (fp_to_sint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2327436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2327439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327441 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327446 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327447 */   // GIR_Coverage, 1541,
     /* 2327447 */   GIR_EraseRootFromParent_Done,
     /* 2327448 */ // Label 32122: @2327448
     /* 2327448 */ GIM_Try, /*On fail goto*//*Label 32123*/ GIMT_Encode4(2327479), // Rule ID 1913 //
     /* 2327453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2327456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327467 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2327467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2327470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327472 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327478 */   // GIR_Coverage, 1913,
     /* 2327478 */   GIR_EraseRootFromParent_Done,
     /* 2327479 */ // Label 32123: @2327479
     /* 2327479 */ GIM_Try, /*On fail goto*//*Label 32124*/ GIMT_Encode4(2327510), // Rule ID 1941 //
     /* 2327484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2327487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327498 */   // (fp_to_sint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2327498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2327501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327503 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327508 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327509 */   // GIR_Coverage, 1941,
     /* 2327509 */   GIR_EraseRootFromParent_Done,
     /* 2327510 */ // Label 32124: @2327510
     /* 2327510 */ GIM_Try, /*On fail goto*//*Label 32125*/ GIMT_Encode4(2327541), // Rule ID 2247 //
     /* 2327515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2327518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2327529 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2327529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2327532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327534 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327539 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327540 */   // GIR_Coverage, 2247,
     /* 2327540 */   GIR_EraseRootFromParent_Done,
     /* 2327541 */ // Label 32125: @2327541
     /* 2327541 */ GIM_Try, /*On fail goto*//*Label 32126*/ GIMT_Encode4(2327572), // Rule ID 2273 //
     /* 2327546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2327549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327560 */   // (fp_to_sint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2327560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2327563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327565 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327570 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327571 */   // GIR_Coverage, 2273,
     /* 2327571 */   GIR_EraseRootFromParent_Done,
     /* 2327572 */ // Label 32126: @2327572
     /* 2327572 */ GIM_Reject,
     /* 2327573 */ // Label 32087: @2327573
     /* 2327573 */ GIM_Try, /*On fail goto*//*Label 32127*/ GIMT_Encode4(2327676),
     /* 2327578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327589 */   GIM_Try, /*On fail goto*//*Label 32128*/ GIMT_Encode4(2327632), // Rule ID 45824 //
     /* 2327594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2327597 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2327600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2327614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327631 */     // GIR_Coverage, 45824,
     /* 2327631 */     GIR_EraseRootFromParent_Done,
     /* 2327632 */   // Label 32128: @2327632
     /* 2327632 */   GIM_Try, /*On fail goto*//*Label 32129*/ GIMT_Encode4(2327675), // Rule ID 45825 //
     /* 2327637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2327640 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2327643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2327657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327674 */     // GIR_Coverage, 45825,
     /* 2327674 */     GIR_EraseRootFromParent_Done,
     /* 2327675 */   // Label 32129: @2327675
     /* 2327675 */   GIM_Reject,
     /* 2327676 */ // Label 32127: @2327676
     /* 2327676 */ GIM_Reject,
     /* 2327677 */ // Label 32088: @2327677
     /* 2327677 */ GIM_Try, /*On fail goto*//*Label 32130*/ GIMT_Encode4(2327731), // Rule ID 45808 //
     /* 2327682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2327685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327696 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327696 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327699 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327703 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2327713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327718 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327729 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327730 */   // GIR_Coverage, 45808,
     /* 2327730 */   GIR_EraseRootFromParent_Done,
     /* 2327731 */ // Label 32130: @2327731
     /* 2327731 */ GIM_Try, /*On fail goto*//*Label 32131*/ GIMT_Encode4(2327785), // Rule ID 45809 //
     /* 2327736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2327739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327750 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327750 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327753 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327757 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2327767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327772 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327783 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327784 */   // GIR_Coverage, 45809,
     /* 2327784 */   GIR_EraseRootFromParent_Done,
     /* 2327785 */ // Label 32131: @2327785
     /* 2327785 */ GIM_Try, /*On fail goto*//*Label 32132*/ GIMT_Encode4(2327839), // Rule ID 58732 //
     /* 2327790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2327793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327804 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2327821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327823 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327826 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327837 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327838 */   // GIR_Coverage, 58732,
     /* 2327838 */   GIR_EraseRootFromParent_Done,
     /* 2327839 */ // Label 32132: @2327839
     /* 2327839 */ GIM_Try, /*On fail goto*//*Label 32133*/ GIMT_Encode4(2327893), // Rule ID 58733 //
     /* 2327844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2327847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327858 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2327875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327880 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327891 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327892 */   // GIR_Coverage, 58733,
     /* 2327892 */   GIR_EraseRootFromParent_Done,
     /* 2327893 */ // Label 32133: @2327893
     /* 2327893 */ GIM_Reject,
     /* 2327894 */ // Label 32089: @2327894
     /* 2327894 */ GIM_Try, /*On fail goto*//*Label 32134*/ GIMT_Encode4(2327948), // Rule ID 45816 //
     /* 2327899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2327902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327913 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2327930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327932 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327935 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327946 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327947 */   // GIR_Coverage, 45816,
     /* 2327947 */   GIR_EraseRootFromParent_Done,
     /* 2327948 */ // Label 32134: @2327948
     /* 2327948 */ GIM_Try, /*On fail goto*//*Label 32135*/ GIMT_Encode4(2328002), // Rule ID 45817 //
     /* 2327953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2327956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327967 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327967 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327970 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327974 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2327984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327989 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328000 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328001 */   // GIR_Coverage, 45817,
     /* 2328001 */   GIR_EraseRootFromParent_Done,
     /* 2328002 */ // Label 32135: @2328002
     /* 2328002 */ GIM_Try, /*On fail goto*//*Label 32136*/ GIMT_Encode4(2328056), // Rule ID 58300 //
     /* 2328007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2328010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2328013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328021 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328021 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2328024 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328028 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2328038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328040 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328043 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328054 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328055 */   // GIR_Coverage, 58300,
     /* 2328055 */   GIR_EraseRootFromParent_Done,
     /* 2328056 */ // Label 32136: @2328056
     /* 2328056 */ GIM_Try, /*On fail goto*//*Label 32137*/ GIMT_Encode4(2328110), // Rule ID 58301 //
     /* 2328061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2328064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2328067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328075 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328075 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2328078 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328082 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2328092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328097 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328108 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328109 */   // GIR_Coverage, 58301,
     /* 2328109 */   GIR_EraseRootFromParent_Done,
     /* 2328110 */ // Label 32137: @2328110
     /* 2328110 */ GIM_Try, /*On fail goto*//*Label 32138*/ GIMT_Encode4(2328164), // Rule ID 58752 //
     /* 2328115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2328118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2328121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328129 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328129 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2328132 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328136 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2328146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328148 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328151 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328162 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328163 */   // GIR_Coverage, 58752,
     /* 2328163 */   GIR_EraseRootFromParent_Done,
     /* 2328164 */ // Label 32138: @2328164
     /* 2328164 */ GIM_Try, /*On fail goto*//*Label 32139*/ GIMT_Encode4(2328218), // Rule ID 58753 //
     /* 2328169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2328172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2328175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328183 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2328186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2328200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328202 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328205 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328216 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328217 */   // GIR_Coverage, 58753,
     /* 2328217 */   GIR_EraseRootFromParent_Done,
     /* 2328218 */ // Label 32139: @2328218
     /* 2328218 */ GIM_Reject,
     /* 2328219 */ // Label 32090: @2328219
     /* 2328219 */ GIM_Try, /*On fail goto*//*Label 32140*/ GIMT_Encode4(2328273), // Rule ID 58312 //
     /* 2328224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2328227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2328230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328238 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2328241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2328255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328260 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328271 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328272 */   // GIR_Coverage, 58312,
     /* 2328272 */   GIR_EraseRootFromParent_Done,
     /* 2328273 */ // Label 32140: @2328273
     /* 2328273 */ GIM_Try, /*On fail goto*//*Label 32141*/ GIMT_Encode4(2328327), // Rule ID 58313 //
     /* 2328278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2328281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2328284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328292 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328292 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2328295 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328299 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2328309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328314 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328325 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328326 */   // GIR_Coverage, 58313,
     /* 2328326 */   GIR_EraseRootFromParent_Done,
     /* 2328327 */ // Label 32141: @2328327
     /* 2328327 */ GIM_Try, /*On fail goto*//*Label 32142*/ GIMT_Encode4(2328381), // Rule ID 58544 //
     /* 2328332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2328335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2328338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328346 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2328349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2328363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328368 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328379 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328380 */   // GIR_Coverage, 58544,
     /* 2328380 */   GIR_EraseRootFromParent_Done,
     /* 2328381 */ // Label 32142: @2328381
     /* 2328381 */ GIM_Try, /*On fail goto*//*Label 32143*/ GIMT_Encode4(2328435), // Rule ID 58545 //
     /* 2328386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2328389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2328392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328400 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328400 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2328403 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328407 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2328417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328419 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328422 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328433 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328434 */   // GIR_Coverage, 58545,
     /* 2328434 */   GIR_EraseRootFromParent_Done,
     /* 2328435 */ // Label 32143: @2328435
     /* 2328435 */ GIM_Reject,
     /* 2328436 */ // Label 32091: @2328436
     /* 2328436 */ GIM_Try, /*On fail goto*//*Label 32144*/ GIMT_Encode4(2328539),
     /* 2328441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328452 */   GIM_Try, /*On fail goto*//*Label 32145*/ GIMT_Encode4(2328495), // Rule ID 58712 //
     /* 2328457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328460 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2328463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2328477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328494 */     // GIR_Coverage, 58712,
     /* 2328494 */     GIR_EraseRootFromParent_Done,
     /* 2328495 */   // Label 32145: @2328495
     /* 2328495 */   GIM_Try, /*On fail goto*//*Label 32146*/ GIMT_Encode4(2328538), // Rule ID 58713 //
     /* 2328500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328503 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2328506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2328520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328537 */     // GIR_Coverage, 58713,
     /* 2328537 */     GIR_EraseRootFromParent_Done,
     /* 2328538 */   // Label 32146: @2328538
     /* 2328538 */   GIM_Reject,
     /* 2328539 */ // Label 32144: @2328539
     /* 2328539 */ GIM_Reject,
     /* 2328540 */ // Label 32092: @2328540
     /* 2328540 */ GIM_Try, /*On fail goto*//*Label 32147*/ GIMT_Encode4(2328594), // Rule ID 58296 //
     /* 2328545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328559 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2328576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328578 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328581 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328592 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328593 */   // GIR_Coverage, 58296,
     /* 2328593 */   GIR_EraseRootFromParent_Done,
     /* 2328594 */ // Label 32147: @2328594
     /* 2328594 */ GIM_Try, /*On fail goto*//*Label 32148*/ GIMT_Encode4(2328648), // Rule ID 58297 //
     /* 2328599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328613 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2328630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328635 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328646 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328647 */   // GIR_Coverage, 58297,
     /* 2328647 */   GIR_EraseRootFromParent_Done,
     /* 2328648 */ // Label 32148: @2328648
     /* 2328648 */ GIM_Try, /*On fail goto*//*Label 32149*/ GIMT_Encode4(2328702), // Rule ID 58736 //
     /* 2328653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2328656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328667 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328667 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328670 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328674 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2328684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328686 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328689 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328700 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328701 */   // GIR_Coverage, 58736,
     /* 2328701 */   GIR_EraseRootFromParent_Done,
     /* 2328702 */ // Label 32149: @2328702
     /* 2328702 */ GIM_Try, /*On fail goto*//*Label 32150*/ GIMT_Encode4(2328756), // Rule ID 58737 //
     /* 2328707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2328710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328721 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328721 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328724 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328728 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2328738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328743 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328754 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328755 */   // GIR_Coverage, 58737,
     /* 2328755 */   GIR_EraseRootFromParent_Done,
     /* 2328756 */ // Label 32150: @2328756
     /* 2328756 */ GIM_Reject,
     /* 2328757 */ // Label 32093: @2328757
     /* 2328757 */ GIM_Try, /*On fail goto*//*Label 32151*/ GIMT_Encode4(2328811), // Rule ID 58308 //
     /* 2328762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2328765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328776 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2328793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328795 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328798 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328809 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328810 */   // GIR_Coverage, 58308,
     /* 2328810 */   GIR_EraseRootFromParent_Done,
     /* 2328811 */ // Label 32151: @2328811
     /* 2328811 */ GIM_Try, /*On fail goto*//*Label 32152*/ GIMT_Encode4(2328865), // Rule ID 58309 //
     /* 2328816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2328819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328830 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328830 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328833 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328837 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2328847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328849 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328852 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328863 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328864 */   // GIR_Coverage, 58309,
     /* 2328864 */   GIR_EraseRootFromParent_Done,
     /* 2328865 */ // Label 32152: @2328865
     /* 2328865 */ GIM_Try, /*On fail goto*//*Label 32153*/ GIMT_Encode4(2328919), // Rule ID 58528 //
     /* 2328870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328884 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2328901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328903 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328906 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328917 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328918 */   // GIR_Coverage, 58528,
     /* 2328918 */   GIR_EraseRootFromParent_Done,
     /* 2328919 */ // Label 32153: @2328919
     /* 2328919 */ GIM_Try, /*On fail goto*//*Label 32154*/ GIMT_Encode4(2328973), // Rule ID 58529 //
     /* 2328924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328938 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328938 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328941 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328945 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2328955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328957 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328960 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328971 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328972 */   // GIR_Coverage, 58529,
     /* 2328972 */   GIR_EraseRootFromParent_Done,
     /* 2328973 */ // Label 32154: @2328973
     /* 2328973 */ GIM_Try, /*On fail goto*//*Label 32155*/ GIMT_Encode4(2329027), // Rule ID 58756 //
     /* 2328978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2328981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2328984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328992 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328995 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328999 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2329009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329014 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329025 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329026 */   // GIR_Coverage, 58756,
     /* 2329026 */   GIR_EraseRootFromParent_Done,
     /* 2329027 */ // Label 32155: @2329027
     /* 2329027 */ GIM_Try, /*On fail goto*//*Label 32156*/ GIMT_Encode4(2329081), // Rule ID 58757 //
     /* 2329032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2329035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2329038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329046 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2329049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2329063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329068 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329079 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329080 */   // GIR_Coverage, 58757,
     /* 2329080 */   GIR_EraseRootFromParent_Done,
     /* 2329081 */ // Label 32156: @2329081
     /* 2329081 */ GIM_Reject,
     /* 2329082 */ // Label 32094: @2329082
     /* 2329082 */ GIM_Try, /*On fail goto*//*Label 32157*/ GIMT_Encode4(2329136), // Rule ID 58340 //
     /* 2329087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2329090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2329093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329101 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329101 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2329104 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329108 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2329118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329120 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329123 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329134 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329135 */   // GIR_Coverage, 58340,
     /* 2329135 */   GIR_EraseRootFromParent_Done,
     /* 2329136 */ // Label 32157: @2329136
     /* 2329136 */ GIM_Try, /*On fail goto*//*Label 32158*/ GIMT_Encode4(2329190), // Rule ID 58341 //
     /* 2329141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2329144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2329147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329155 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329155 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2329158 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329162 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2329172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329177 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329188 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329189 */   // GIR_Coverage, 58341,
     /* 2329189 */   GIR_EraseRootFromParent_Done,
     /* 2329190 */ // Label 32158: @2329190
     /* 2329190 */ GIM_Try, /*On fail goto*//*Label 32159*/ GIMT_Encode4(2329244), // Rule ID 58548 //
     /* 2329195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2329198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2329201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329209 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329209 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2329212 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329216 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2329226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329228 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329231 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329242 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329243 */   // GIR_Coverage, 58548,
     /* 2329243 */   GIR_EraseRootFromParent_Done,
     /* 2329244 */ // Label 32159: @2329244
     /* 2329244 */ GIM_Try, /*On fail goto*//*Label 32160*/ GIMT_Encode4(2329298), // Rule ID 58549 //
     /* 2329249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2329252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2329255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329263 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2329266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2329280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329282 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329285 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329296 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329297 */   // GIR_Coverage, 58549,
     /* 2329297 */   GIR_EraseRootFromParent_Done,
     /* 2329298 */ // Label 32160: @2329298
     /* 2329298 */ GIM_Reject,
     /* 2329299 */ // Label 32095: @2329299
     /* 2329299 */ GIM_Try, /*On fail goto*//*Label 32161*/ GIMT_Encode4(2329402),
     /* 2329304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2329307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329315 */   GIM_Try, /*On fail goto*//*Label 32162*/ GIMT_Encode4(2329358), // Rule ID 58716 //
     /* 2329320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329323 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2329326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2329340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329357 */     // GIR_Coverage, 58716,
     /* 2329357 */     GIR_EraseRootFromParent_Done,
     /* 2329358 */   // Label 32162: @2329358
     /* 2329358 */   GIM_Try, /*On fail goto*//*Label 32163*/ GIMT_Encode4(2329401), // Rule ID 58717 //
     /* 2329363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329366 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2329369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2329383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329400 */     // GIR_Coverage, 58717,
     /* 2329400 */     GIR_EraseRootFromParent_Done,
     /* 2329401 */   // Label 32163: @2329401
     /* 2329401 */   GIM_Reject,
     /* 2329402 */ // Label 32161: @2329402
     /* 2329402 */ GIM_Reject,
     /* 2329403 */ // Label 32096: @2329403
     /* 2329403 */ GIM_Try, /*On fail goto*//*Label 32164*/ GIMT_Encode4(2329457), // Rule ID 58304 //
     /* 2329408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2329414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329422 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329422 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329425 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329429 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2329439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329444 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329455 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329456 */   // GIR_Coverage, 58304,
     /* 2329456 */   GIR_EraseRootFromParent_Done,
     /* 2329457 */ // Label 32164: @2329457
     /* 2329457 */ GIM_Try, /*On fail goto*//*Label 32165*/ GIMT_Encode4(2329511), // Rule ID 58305 //
     /* 2329462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2329468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329476 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329476 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329479 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329483 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2329493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329498 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329509 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329510 */   // GIR_Coverage, 58305,
     /* 2329510 */   GIR_EraseRootFromParent_Done,
     /* 2329511 */ // Label 32165: @2329511
     /* 2329511 */ GIM_Try, /*On fail goto*//*Label 32166*/ GIMT_Encode4(2329565), // Rule ID 58740 //
     /* 2329516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2329519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329530 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329530 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329533 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329537 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329542 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2329547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329549 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329552 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329563 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329564 */   // GIR_Coverage, 58740,
     /* 2329564 */   GIR_EraseRootFromParent_Done,
     /* 2329565 */ // Label 32166: @2329565
     /* 2329565 */ GIM_Try, /*On fail goto*//*Label 32167*/ GIMT_Encode4(2329619), // Rule ID 58741 //
     /* 2329570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2329573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329584 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2329601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329603 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329606 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329617 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329618 */   // GIR_Coverage, 58741,
     /* 2329618 */   GIR_EraseRootFromParent_Done,
     /* 2329619 */ // Label 32167: @2329619
     /* 2329619 */ GIM_Reject,
     /* 2329620 */ // Label 32097: @2329620
     /* 2329620 */ GIM_Try, /*On fail goto*//*Label 32168*/ GIMT_Encode4(2329674), // Rule ID 58328 //
     /* 2329625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2329628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329639 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2329656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329658 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329661 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329672 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329673 */   // GIR_Coverage, 58328,
     /* 2329673 */   GIR_EraseRootFromParent_Done,
     /* 2329674 */ // Label 32168: @2329674
     /* 2329674 */ GIM_Try, /*On fail goto*//*Label 32169*/ GIMT_Encode4(2329728), // Rule ID 58329 //
     /* 2329679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2329682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329693 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2329710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329712 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329715 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329726 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329727 */   // GIR_Coverage, 58329,
     /* 2329727 */   GIR_EraseRootFromParent_Done,
     /* 2329728 */ // Label 32169: @2329728
     /* 2329728 */ GIM_Try, /*On fail goto*//*Label 32170*/ GIMT_Encode4(2329782), // Rule ID 58532 //
     /* 2329733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2329739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329747 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329747 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329750 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329754 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2329764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329769 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329781 */   // GIR_Coverage, 58532,
     /* 2329781 */   GIR_EraseRootFromParent_Done,
     /* 2329782 */ // Label 32170: @2329782
     /* 2329782 */ GIM_Try, /*On fail goto*//*Label 32171*/ GIMT_Encode4(2329836), // Rule ID 58533 //
     /* 2329787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2329793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329801 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2329818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329823 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329834 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329835 */   // GIR_Coverage, 58533,
     /* 2329835 */   GIR_EraseRootFromParent_Done,
     /* 2329836 */ // Label 32171: @2329836
     /* 2329836 */ GIM_Try, /*On fail goto*//*Label 32172*/ GIMT_Encode4(2329890), // Rule ID 58760 //
     /* 2329841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2329844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2329847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329855 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2329872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329877 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329888 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329889 */   // GIR_Coverage, 58760,
     /* 2329889 */   GIR_EraseRootFromParent_Done,
     /* 2329890 */ // Label 32172: @2329890
     /* 2329890 */ GIM_Try, /*On fail goto*//*Label 32173*/ GIMT_Encode4(2329944), // Rule ID 58761 //
     /* 2329895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2329898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2329901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329909 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329909 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329912 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329916 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2329926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329928 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329931 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329942 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329943 */   // GIR_Coverage, 58761,
     /* 2329943 */   GIR_EraseRootFromParent_Done,
     /* 2329944 */ // Label 32173: @2329944
     /* 2329944 */ GIM_Reject,
     /* 2329945 */ // Label 32098: @2329945
     /* 2329945 */ GIM_Try, /*On fail goto*//*Label 32174*/ GIMT_Encode4(2329999), // Rule ID 58344 //
     /* 2329950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2329953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2329956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329964 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329964 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2329967 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329971 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2329981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329986 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329997 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329998 */   // GIR_Coverage, 58344,
     /* 2329998 */   GIR_EraseRootFromParent_Done,
     /* 2329999 */ // Label 32174: @2329999
     /* 2329999 */ GIM_Try, /*On fail goto*//*Label 32175*/ GIMT_Encode4(2330053), // Rule ID 58345 //
     /* 2330004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2330007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2330010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330018 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2330021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2330035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330040 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2330048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330051 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330052 */   // GIR_Coverage, 58345,
     /* 2330052 */   GIR_EraseRootFromParent_Done,
     /* 2330053 */ // Label 32175: @2330053
     /* 2330053 */ GIM_Try, /*On fail goto*//*Label 32176*/ GIMT_Encode4(2330107), // Rule ID 58552 //
     /* 2330058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2330061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2330064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330072 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2330075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330084 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2330089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330094 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330105 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330106 */   // GIR_Coverage, 58552,
     /* 2330106 */   GIR_EraseRootFromParent_Done,
     /* 2330107 */ // Label 32176: @2330107
     /* 2330107 */ GIM_Try, /*On fail goto*//*Label 32177*/ GIMT_Encode4(2330161), // Rule ID 58553 //
     /* 2330112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2330115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2330118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330126 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330126 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2330129 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330133 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2330143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330145 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330148 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330159 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330160 */   // GIR_Coverage, 58553,
     /* 2330160 */   GIR_EraseRootFromParent_Done,
     /* 2330161 */ // Label 32177: @2330161
     /* 2330161 */ GIM_Reject,
     /* 2330162 */ // Label 32099: @2330162
     /* 2330162 */ GIM_Try, /*On fail goto*//*Label 32178*/ GIMT_Encode4(2330265),
     /* 2330167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2330170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330178 */   GIM_Try, /*On fail goto*//*Label 32179*/ GIMT_Encode4(2330221), // Rule ID 58720 //
     /* 2330183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330186 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2330189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2330203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330220 */     // GIR_Coverage, 58720,
     /* 2330220 */     GIR_EraseRootFromParent_Done,
     /* 2330221 */   // Label 32179: @2330221
     /* 2330221 */   GIM_Try, /*On fail goto*//*Label 32180*/ GIMT_Encode4(2330264), // Rule ID 58721 //
     /* 2330226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330229 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2330232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2330246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330263 */     // GIR_Coverage, 58721,
     /* 2330263 */     GIR_EraseRootFromParent_Done,
     /* 2330264 */   // Label 32180: @2330264
     /* 2330264 */   GIM_Reject,
     /* 2330265 */ // Label 32178: @2330265
     /* 2330265 */ GIM_Reject,
     /* 2330266 */ // Label 32100: @2330266
     /* 2330266 */ GIM_Try, /*On fail goto*//*Label 32181*/ GIMT_Encode4(2330320), // Rule ID 58316 //
     /* 2330271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2330277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330285 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330285 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2330288 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330292 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2330302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330304 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330307 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330319 */   // GIR_Coverage, 58316,
     /* 2330319 */   GIR_EraseRootFromParent_Done,
     /* 2330320 */ // Label 32181: @2330320
     /* 2330320 */ GIM_Try, /*On fail goto*//*Label 32182*/ GIMT_Encode4(2330374), // Rule ID 58317 //
     /* 2330325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2330331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330339 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2330342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2330356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330361 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330372 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330373 */   // GIR_Coverage, 58317,
     /* 2330373 */   GIR_EraseRootFromParent_Done,
     /* 2330374 */ // Label 32182: @2330374
     /* 2330374 */ GIM_Try, /*On fail goto*//*Label 32183*/ GIMT_Encode4(2330428), // Rule ID 58744 //
     /* 2330379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2330382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330393 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330393 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2330396 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330400 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2330410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330412 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330415 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330426 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330427 */   // GIR_Coverage, 58744,
     /* 2330427 */   GIR_EraseRootFromParent_Done,
     /* 2330428 */ // Label 32183: @2330428
     /* 2330428 */ GIM_Try, /*On fail goto*//*Label 32184*/ GIMT_Encode4(2330482), // Rule ID 58745 //
     /* 2330433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2330436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330447 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330447 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2330450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330454 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2330464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330469 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330480 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330481 */   // GIR_Coverage, 58745,
     /* 2330481 */   GIR_EraseRootFromParent_Done,
     /* 2330482 */ // Label 32184: @2330482
     /* 2330482 */ GIM_Reject,
     /* 2330483 */ // Label 32101: @2330483
     /* 2330483 */ GIM_Try, /*On fail goto*//*Label 32185*/ GIMT_Encode4(2330537), // Rule ID 58332 //
     /* 2330488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2330491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330502 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2330519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330521 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330524 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330535 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330536 */   // GIR_Coverage, 58332,
     /* 2330536 */   GIR_EraseRootFromParent_Done,
     /* 2330537 */ // Label 32185: @2330537
     /* 2330537 */ GIM_Try, /*On fail goto*//*Label 32186*/ GIMT_Encode4(2330591), // Rule ID 58333 //
     /* 2330542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2330545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330556 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2330573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330578 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330589 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330590 */   // GIR_Coverage, 58333,
     /* 2330590 */   GIR_EraseRootFromParent_Done,
     /* 2330591 */ // Label 32186: @2330591
     /* 2330591 */ GIM_Try, /*On fail goto*//*Label 32187*/ GIMT_Encode4(2330645), // Rule ID 58536 //
     /* 2330596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2330602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330610 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330610 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330613 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330617 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2330627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330629 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330632 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330643 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330644 */   // GIR_Coverage, 58536,
     /* 2330644 */   GIR_EraseRootFromParent_Done,
     /* 2330645 */ // Label 32187: @2330645
     /* 2330645 */ GIM_Try, /*On fail goto*//*Label 32188*/ GIMT_Encode4(2330699), // Rule ID 58537 //
     /* 2330650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2330656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330664 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2330681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330683 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330686 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330697 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330698 */   // GIR_Coverage, 58537,
     /* 2330698 */   GIR_EraseRootFromParent_Done,
     /* 2330699 */ // Label 32188: @2330699
     /* 2330699 */ GIM_Try, /*On fail goto*//*Label 32189*/ GIMT_Encode4(2330753), // Rule ID 58764 //
     /* 2330704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2330707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330718 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330718 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330721 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330725 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2330735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330737 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330740 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330751 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330752 */   // GIR_Coverage, 58764,
     /* 2330752 */   GIR_EraseRootFromParent_Done,
     /* 2330753 */ // Label 32189: @2330753
     /* 2330753 */ GIM_Try, /*On fail goto*//*Label 32190*/ GIMT_Encode4(2330807), // Rule ID 58765 //
     /* 2330758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2330761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330772 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330775 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330779 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2330789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330794 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330805 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330806 */   // GIR_Coverage, 58765,
     /* 2330806 */   GIR_EraseRootFromParent_Done,
     /* 2330807 */ // Label 32190: @2330807
     /* 2330807 */ GIM_Reject,
     /* 2330808 */ // Label 32102: @2330808
     /* 2330808 */ GIM_Try, /*On fail goto*//*Label 32191*/ GIMT_Encode4(2330862), // Rule ID 58348 //
     /* 2330813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2330816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330827 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2330844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330849 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2330857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330860 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330861 */   // GIR_Coverage, 58348,
     /* 2330861 */   GIR_EraseRootFromParent_Done,
     /* 2330862 */ // Label 32191: @2330862
     /* 2330862 */ GIM_Try, /*On fail goto*//*Label 32192*/ GIMT_Encode4(2330916), // Rule ID 58349 //
     /* 2330867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2330870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330881 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2330898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330903 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2330911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330914 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330915 */   // GIR_Coverage, 58349,
     /* 2330915 */   GIR_EraseRootFromParent_Done,
     /* 2330916 */ // Label 32192: @2330916
     /* 2330916 */ GIM_Try, /*On fail goto*//*Label 32193*/ GIMT_Encode4(2330970), // Rule ID 58556 //
     /* 2330921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2330924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330935 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330935 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330938 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330942 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2330952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330957 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330968 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330969 */   // GIR_Coverage, 58556,
     /* 2330969 */   GIR_EraseRootFromParent_Done,
     /* 2330970 */ // Label 32193: @2330970
     /* 2330970 */ GIM_Try, /*On fail goto*//*Label 32194*/ GIMT_Encode4(2331024), // Rule ID 58557 //
     /* 2330975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2330978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330989 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330989 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330992 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330996 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2331006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331011 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331022 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331023 */   // GIR_Coverage, 58557,
     /* 2331023 */   GIR_EraseRootFromParent_Done,
     /* 2331024 */ // Label 32194: @2331024
     /* 2331024 */ GIM_Reject,
     /* 2331025 */ // Label 32103: @2331025
     /* 2331025 */ GIM_Try, /*On fail goto*//*Label 32195*/ GIMT_Encode4(2331128),
     /* 2331030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2331033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331041 */   GIM_Try, /*On fail goto*//*Label 32196*/ GIMT_Encode4(2331084), // Rule ID 58724 //
     /* 2331046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331049 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2331052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2331066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331083 */     // GIR_Coverage, 58724,
     /* 2331083 */     GIR_EraseRootFromParent_Done,
     /* 2331084 */   // Label 32196: @2331084
     /* 2331084 */   GIM_Try, /*On fail goto*//*Label 32197*/ GIMT_Encode4(2331127), // Rule ID 58725 //
     /* 2331089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331092 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2331095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2331109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331126 */     // GIR_Coverage, 58725,
     /* 2331126 */     GIR_EraseRootFromParent_Done,
     /* 2331127 */   // Label 32197: @2331127
     /* 2331127 */   GIM_Reject,
     /* 2331128 */ // Label 32195: @2331128
     /* 2331128 */ GIM_Reject,
     /* 2331129 */ // Label 32104: @2331129
     /* 2331129 */ GIM_Try, /*On fail goto*//*Label 32198*/ GIMT_Encode4(2331183), // Rule ID 58320 //
     /* 2331134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2331140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331148 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331148 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2331151 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331155 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2331165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331167 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331170 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331181 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331182 */   // GIR_Coverage, 58320,
     /* 2331182 */   GIR_EraseRootFromParent_Done,
     /* 2331183 */ // Label 32198: @2331183
     /* 2331183 */ GIM_Try, /*On fail goto*//*Label 32199*/ GIMT_Encode4(2331237), // Rule ID 58321 //
     /* 2331188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2331194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331202 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2331205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2331219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331221 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331224 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331235 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331236 */   // GIR_Coverage, 58321,
     /* 2331236 */   GIR_EraseRootFromParent_Done,
     /* 2331237 */ // Label 32199: @2331237
     /* 2331237 */ GIM_Try, /*On fail goto*//*Label 32200*/ GIMT_Encode4(2331291), // Rule ID 58748 //
     /* 2331242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2331245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2331248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331256 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331256 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2331259 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331263 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2331273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331275 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331278 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331289 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331290 */   // GIR_Coverage, 58748,
     /* 2331290 */   GIR_EraseRootFromParent_Done,
     /* 2331291 */ // Label 32200: @2331291
     /* 2331291 */ GIM_Try, /*On fail goto*//*Label 32201*/ GIMT_Encode4(2331345), // Rule ID 58749 //
     /* 2331296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2331299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2331302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331310 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2331313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2331327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331329 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331332 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331344 */   // GIR_Coverage, 58749,
     /* 2331344 */   GIR_EraseRootFromParent_Done,
     /* 2331345 */ // Label 32201: @2331345
     /* 2331345 */ GIM_Reject,
     /* 2331346 */ // Label 32105: @2331346
     /* 2331346 */ GIM_Try, /*On fail goto*//*Label 32202*/ GIMT_Encode4(2331400), // Rule ID 58336 //
     /* 2331351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2331354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2331357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331365 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2331368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2331382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331384 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331387 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331398 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331399 */   // GIR_Coverage, 58336,
     /* 2331399 */   GIR_EraseRootFromParent_Done,
     /* 2331400 */ // Label 32202: @2331400
     /* 2331400 */ GIM_Try, /*On fail goto*//*Label 32203*/ GIMT_Encode4(2331454), // Rule ID 58337 //
     /* 2331405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2331408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2331411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331419 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331419 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2331422 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331426 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2331436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331438 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331441 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331452 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331453 */   // GIR_Coverage, 58337,
     /* 2331453 */   GIR_EraseRootFromParent_Done,
     /* 2331454 */ // Label 32203: @2331454
     /* 2331454 */ GIM_Try, /*On fail goto*//*Label 32204*/ GIMT_Encode4(2331508), // Rule ID 58540 //
     /* 2331459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2331465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331473 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331473 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2331476 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331480 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2331490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331492 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331495 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331506 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331507 */   // GIR_Coverage, 58540,
     /* 2331507 */   GIR_EraseRootFromParent_Done,
     /* 2331508 */ // Label 32204: @2331508
     /* 2331508 */ GIM_Try, /*On fail goto*//*Label 32205*/ GIMT_Encode4(2331562), // Rule ID 58541 //
     /* 2331513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2331519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331527 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331527 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2331530 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331534 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2331544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331549 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331560 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331561 */   // GIR_Coverage, 58541,
     /* 2331561 */   GIR_EraseRootFromParent_Done,
     /* 2331562 */ // Label 32205: @2331562
     /* 2331562 */ GIM_Reject,
     /* 2331563 */ // Label 32106: @2331563
     /* 2331563 */ GIM_Try, /*On fail goto*//*Label 32206*/ GIMT_Encode4(2331666),
     /* 2331568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2331571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331579 */   GIM_Try, /*On fail goto*//*Label 32207*/ GIMT_Encode4(2331622), // Rule ID 58728 //
     /* 2331584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331587 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2331590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2331604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331621 */     // GIR_Coverage, 58728,
     /* 2331621 */     GIR_EraseRootFromParent_Done,
     /* 2331622 */   // Label 32207: @2331622
     /* 2331622 */   GIM_Try, /*On fail goto*//*Label 32208*/ GIMT_Encode4(2331665), // Rule ID 58729 //
     /* 2331627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331630 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2331633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2331647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331664 */     // GIR_Coverage, 58729,
     /* 2331664 */     GIR_EraseRootFromParent_Done,
     /* 2331665 */   // Label 32208: @2331665
     /* 2331665 */   GIM_Reject,
     /* 2331666 */ // Label 32206: @2331666
     /* 2331666 */ GIM_Reject,
     /* 2331667 */ // Label 32107: @2331667
     /* 2331667 */ GIM_Try, /*On fail goto*//*Label 32209*/ GIMT_Encode4(2331770),
     /* 2331672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2331675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331683 */   GIM_Try, /*On fail goto*//*Label 32210*/ GIMT_Encode4(2331726), // Rule ID 58324 //
     /* 2331688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331691 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2331694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2331708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331725 */     // GIR_Coverage, 58324,
     /* 2331725 */     GIR_EraseRootFromParent_Done,
     /* 2331726 */   // Label 32210: @2331726
     /* 2331726 */   GIM_Try, /*On fail goto*//*Label 32211*/ GIMT_Encode4(2331769), // Rule ID 58325 //
     /* 2331731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331734 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2331737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2331751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331768 */     // GIR_Coverage, 58325,
     /* 2331768 */     GIR_EraseRootFromParent_Done,
     /* 2331769 */   // Label 32211: @2331769
     /* 2331769 */   GIM_Reject,
     /* 2331770 */ // Label 32209: @2331770
     /* 2331770 */ GIM_Reject,
     /* 2331771 */ // Label 32108: @2331771
     /* 2331771 */ GIM_Reject,
     /* 2331772 */ // Label 68: @2331772
     /* 2331772 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 32235*/ GIMT_Encode4(2336657),
     /* 2331783 */ /*GILLT_s32*//*Label 32212*/ GIMT_Encode4(2331899),
     /* 2331787 */ /*GILLT_s64*//*Label 32213*/ GIMT_Encode4(2332272), GIMT_Encode4(0),
     /* 2331795 */ /*GILLT_nxv1s8*//*Label 32214*/ GIMT_Encode4(2332459),
     /* 2331799 */ /*GILLT_nxv1s16*//*Label 32215*/ GIMT_Encode4(2332563),
     /* 2331803 */ /*GILLT_nxv1s32*//*Label 32216*/ GIMT_Encode4(2332780),
     /* 2331807 */ /*GILLT_nxv1s64*//*Label 32217*/ GIMT_Encode4(2333105), GIMT_Encode4(0),
     /* 2331815 */ /*GILLT_nxv2s8*//*Label 32218*/ GIMT_Encode4(2333322),
     /* 2331819 */ /*GILLT_nxv2s16*//*Label 32219*/ GIMT_Encode4(2333426),
     /* 2331823 */ /*GILLT_nxv2s32*//*Label 32220*/ GIMT_Encode4(2333643),
     /* 2331827 */ /*GILLT_nxv2s64*//*Label 32221*/ GIMT_Encode4(2333968), GIMT_Encode4(0),
     /* 2331835 */ /*GILLT_nxv4s8*//*Label 32222*/ GIMT_Encode4(2334185),
     /* 2331839 */ /*GILLT_nxv4s16*//*Label 32223*/ GIMT_Encode4(2334289),
     /* 2331843 */ /*GILLT_nxv4s32*//*Label 32224*/ GIMT_Encode4(2334506),
     /* 2331847 */ /*GILLT_nxv4s64*//*Label 32225*/ GIMT_Encode4(2334831), GIMT_Encode4(0),
     /* 2331855 */ /*GILLT_nxv8s8*//*Label 32226*/ GIMT_Encode4(2335048),
     /* 2331859 */ /*GILLT_nxv8s16*//*Label 32227*/ GIMT_Encode4(2335152),
     /* 2331863 */ /*GILLT_nxv8s32*//*Label 32228*/ GIMT_Encode4(2335369),
     /* 2331867 */ /*GILLT_nxv8s64*//*Label 32229*/ GIMT_Encode4(2335694), GIMT_Encode4(0),
     /* 2331875 */ /*GILLT_nxv16s8*//*Label 32230*/ GIMT_Encode4(2335911),
     /* 2331879 */ /*GILLT_nxv16s16*//*Label 32231*/ GIMT_Encode4(2336015),
     /* 2331883 */ /*GILLT_nxv16s32*//*Label 32232*/ GIMT_Encode4(2336232), GIMT_Encode4(0),
     /* 2331891 */ /*GILLT_nxv32s8*//*Label 32233*/ GIMT_Encode4(2336449),
     /* 2331895 */ /*GILLT_nxv32s16*//*Label 32234*/ GIMT_Encode4(2336553),
     /* 2331899 */ // Label 32212: @2331899
     /* 2331899 */ GIM_Try, /*On fail goto*//*Label 32236*/ GIMT_Encode4(2331930), // Rule ID 1460 //
     /* 2331904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2331907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331918 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2331918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2331921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331923 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331928 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331929 */   // GIR_Coverage, 1460,
     /* 2331929 */   GIR_EraseRootFromParent_Done,
     /* 2331930 */ // Label 32236: @2331930
     /* 2331930 */ GIM_Try, /*On fail goto*//*Label 32237*/ GIMT_Encode4(2331961), // Rule ID 1461 //
     /* 2331935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2331938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331949 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2331949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2331952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331954 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331959 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331960 */   // GIR_Coverage, 1461,
     /* 2331960 */   GIR_EraseRootFromParent_Done,
     /* 2331961 */ // Label 32237: @2331961
     /* 2331961 */ GIM_Try, /*On fail goto*//*Label 32238*/ GIMT_Encode4(2331992), // Rule ID 1486 //
     /* 2331966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2331969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331980 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2331980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2331983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331985 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331990 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331991 */   // GIR_Coverage, 1486,
     /* 2331991 */   GIR_EraseRootFromParent_Done,
     /* 2331992 */ // Label 32238: @2331992
     /* 2331992 */ GIM_Try, /*On fail goto*//*Label 32239*/ GIMT_Encode4(2332023), // Rule ID 1487 //
     /* 2331997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2332000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2332003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2332011 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2332011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2332014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332016 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332022 */   // GIR_Coverage, 1487,
     /* 2332022 */   GIR_EraseRootFromParent_Done,
     /* 2332023 */ // Label 32239: @2332023
     /* 2332023 */ GIM_Try, /*On fail goto*//*Label 32240*/ GIMT_Encode4(2332054), // Rule ID 1854 //
     /* 2332028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2332031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2332042 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2332042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2332045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332047 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332053 */   // GIR_Coverage, 1854,
     /* 2332053 */   GIR_EraseRootFromParent_Done,
     /* 2332054 */ // Label 32240: @2332054
     /* 2332054 */ GIM_Try, /*On fail goto*//*Label 32241*/ GIMT_Encode4(2332085), // Rule ID 1855 //
     /* 2332059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2332062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2332073 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2332073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2332076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332078 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332083 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332084 */   // GIR_Coverage, 1855,
     /* 2332084 */   GIR_EraseRootFromParent_Done,
     /* 2332085 */ // Label 32241: @2332085
     /* 2332085 */ GIM_Try, /*On fail goto*//*Label 32242*/ GIMT_Encode4(2332116), // Rule ID 1880 //
     /* 2332090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2332093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2332104 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2332104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2332107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332109 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332114 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332115 */   // GIR_Coverage, 1880,
     /* 2332115 */   GIR_EraseRootFromParent_Done,
     /* 2332116 */ // Label 32242: @2332116
     /* 2332116 */ GIM_Try, /*On fail goto*//*Label 32243*/ GIMT_Encode4(2332147), // Rule ID 1881 //
     /* 2332121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2332124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2332135 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2332135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2332138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332140 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332145 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332146 */   // GIR_Coverage, 1881,
     /* 2332146 */   GIR_EraseRootFromParent_Done,
     /* 2332147 */ // Label 32243: @2332147
     /* 2332147 */ GIM_Try, /*On fail goto*//*Label 32244*/ GIMT_Encode4(2332178), // Rule ID 2196 //
     /* 2332152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2332155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2332158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2332166 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2332166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2332169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332171 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332176 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332177 */   // GIR_Coverage, 2196,
     /* 2332177 */   GIR_EraseRootFromParent_Done,
     /* 2332178 */ // Label 32244: @2332178
     /* 2332178 */ GIM_Try, /*On fail goto*//*Label 32245*/ GIMT_Encode4(2332209), // Rule ID 2197 //
     /* 2332183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2332186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2332189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2332197 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2332197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2332200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332202 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332207 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332208 */   // GIR_Coverage, 2197,
     /* 2332208 */   GIR_EraseRootFromParent_Done,
     /* 2332209 */ // Label 32245: @2332209
     /* 2332209 */ GIM_Try, /*On fail goto*//*Label 32246*/ GIMT_Encode4(2332240), // Rule ID 2222 //
     /* 2332214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2332217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2332220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2332228 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2332228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2332231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332233 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332238 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332239 */   // GIR_Coverage, 2222,
     /* 2332239 */   GIR_EraseRootFromParent_Done,
     /* 2332240 */ // Label 32246: @2332240
     /* 2332240 */ GIM_Try, /*On fail goto*//*Label 32247*/ GIMT_Encode4(2332271), // Rule ID 2223 //
     /* 2332245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2332248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2332251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2332259 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2332259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2332262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332264 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332270 */   // GIR_Coverage, 2223,
     /* 2332270 */   GIR_EraseRootFromParent_Done,
     /* 2332271 */ // Label 32247: @2332271
     /* 2332271 */ GIM_Reject,
     /* 2332272 */ // Label 32213: @2332272
     /* 2332272 */ GIM_Try, /*On fail goto*//*Label 32248*/ GIMT_Encode4(2332303), // Rule ID 1515 //
     /* 2332277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2332280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2332283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2332291 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2332291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S),
     /* 2332294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332296 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332301 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332302 */   // GIR_Coverage, 1515,
     /* 2332302 */   GIR_EraseRootFromParent_Done,
     /* 2332303 */ // Label 32248: @2332303
     /* 2332303 */ GIM_Try, /*On fail goto*//*Label 32249*/ GIMT_Encode4(2332334), // Rule ID 1543 //
     /* 2332308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2332311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2332314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2332322 */   // (fp_to_uint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2332322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S_INX),
     /* 2332325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332327 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332332 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332333 */   // GIR_Coverage, 1543,
     /* 2332333 */   GIR_EraseRootFromParent_Done,
     /* 2332334 */ // Label 32249: @2332334
     /* 2332334 */ GIM_Try, /*On fail goto*//*Label 32250*/ GIMT_Encode4(2332365), // Rule ID 1915 //
     /* 2332339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2332342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2332353 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2332353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D),
     /* 2332356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332358 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332363 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332364 */   // GIR_Coverage, 1915,
     /* 2332364 */   GIR_EraseRootFromParent_Done,
     /* 2332365 */ // Label 32250: @2332365
     /* 2332365 */ GIM_Try, /*On fail goto*//*Label 32251*/ GIMT_Encode4(2332396), // Rule ID 1943 //
     /* 2332370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2332373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332384 */   // (fp_to_uint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2332384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D_INX),
     /* 2332387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332389 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332394 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332395 */   // GIR_Coverage, 1943,
     /* 2332395 */   GIR_EraseRootFromParent_Done,
     /* 2332396 */ // Label 32251: @2332396
     /* 2332396 */ GIM_Try, /*On fail goto*//*Label 32252*/ GIMT_Encode4(2332427), // Rule ID 2249 //
     /* 2332401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2332404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2332407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2332415 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2332415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H),
     /* 2332418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332420 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332425 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332426 */   // GIR_Coverage, 2249,
     /* 2332426 */   GIR_EraseRootFromParent_Done,
     /* 2332427 */ // Label 32252: @2332427
     /* 2332427 */ GIM_Try, /*On fail goto*//*Label 32253*/ GIMT_Encode4(2332458), // Rule ID 2275 //
     /* 2332432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2332435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2332438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2332446 */   // (fp_to_uint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2332446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H_INX),
     /* 2332449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332451 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332456 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332457 */   // GIR_Coverage, 2275,
     /* 2332457 */   GIR_EraseRootFromParent_Done,
     /* 2332458 */ // Label 32253: @2332458
     /* 2332458 */ GIM_Reject,
     /* 2332459 */ // Label 32214: @2332459
     /* 2332459 */ GIM_Try, /*On fail goto*//*Label 32254*/ GIMT_Encode4(2332562),
     /* 2332464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2332467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332475 */   GIM_Try, /*On fail goto*//*Label 32255*/ GIMT_Encode4(2332518), // Rule ID 58768 //
     /* 2332480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2332483 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2332486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2332500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332517 */     // GIR_Coverage, 58768,
     /* 2332517 */     GIR_EraseRootFromParent_Done,
     /* 2332518 */   // Label 32255: @2332518
     /* 2332518 */   GIM_Try, /*On fail goto*//*Label 32256*/ GIMT_Encode4(2332561), // Rule ID 58769 //
     /* 2332523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2332526 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2332529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2332543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332560 */     // GIR_Coverage, 58769,
     /* 2332560 */     GIR_EraseRootFromParent_Done,
     /* 2332561 */   // Label 32256: @2332561
     /* 2332561 */   GIM_Reject,
     /* 2332562 */ // Label 32254: @2332562
     /* 2332562 */ GIM_Reject,
     /* 2332563 */ // Label 32215: @2332563
     /* 2332563 */ GIM_Try, /*On fail goto*//*Label 32257*/ GIMT_Encode4(2332617), // Rule ID 58352 //
     /* 2332568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2332571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2332574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332582 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332582 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2332585 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332589 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2332599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332604 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332615 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332616 */   // GIR_Coverage, 58352,
     /* 2332616 */   GIR_EraseRootFromParent_Done,
     /* 2332617 */ // Label 32257: @2332617
     /* 2332617 */ GIM_Try, /*On fail goto*//*Label 32258*/ GIMT_Encode4(2332671), // Rule ID 58353 //
     /* 2332622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2332625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2332628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332636 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332636 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2332639 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332643 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2332653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332655 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332658 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332669 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332670 */   // GIR_Coverage, 58353,
     /* 2332670 */   GIR_EraseRootFromParent_Done,
     /* 2332671 */ // Label 32258: @2332671
     /* 2332671 */ GIM_Try, /*On fail goto*//*Label 32259*/ GIMT_Encode4(2332725), // Rule ID 58792 //
     /* 2332676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2332679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2332682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332690 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332690 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2332693 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332697 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2332707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332712 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332723 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332724 */   // GIR_Coverage, 58792,
     /* 2332724 */   GIR_EraseRootFromParent_Done,
     /* 2332725 */ // Label 32259: @2332725
     /* 2332725 */ GIM_Try, /*On fail goto*//*Label 32260*/ GIMT_Encode4(2332779), // Rule ID 58793 //
     /* 2332730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2332733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2332736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332744 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2332747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2332761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332766 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332777 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332778 */   // GIR_Coverage, 58793,
     /* 2332778 */   GIR_EraseRootFromParent_Done,
     /* 2332779 */ // Label 32260: @2332779
     /* 2332779 */ GIM_Reject,
     /* 2332780 */ // Label 32216: @2332780
     /* 2332780 */ GIM_Try, /*On fail goto*//*Label 32261*/ GIMT_Encode4(2332834), // Rule ID 58360 //
     /* 2332785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2332788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2332791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332799 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2332816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332818 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332821 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332833 */   // GIR_Coverage, 58360,
     /* 2332833 */   GIR_EraseRootFromParent_Done,
     /* 2332834 */ // Label 32261: @2332834
     /* 2332834 */ GIM_Try, /*On fail goto*//*Label 32262*/ GIMT_Encode4(2332888), // Rule ID 58361 //
     /* 2332839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2332842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2332845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332853 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2332870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332875 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332887 */   // GIR_Coverage, 58361,
     /* 2332887 */   GIR_EraseRootFromParent_Done,
     /* 2332888 */ // Label 32262: @2332888
     /* 2332888 */ GIM_Try, /*On fail goto*//*Label 32263*/ GIMT_Encode4(2332942), // Rule ID 58560 //
     /* 2332893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2332896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2332899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332907 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2332924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332929 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332940 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332941 */   // GIR_Coverage, 58560,
     /* 2332941 */   GIR_EraseRootFromParent_Done,
     /* 2332942 */ // Label 32263: @2332942
     /* 2332942 */ GIM_Try, /*On fail goto*//*Label 32264*/ GIMT_Encode4(2332996), // Rule ID 58561 //
     /* 2332947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2332950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2332953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332961 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332961 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332964 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332968 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2332978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332983 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332994 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332995 */   // GIR_Coverage, 58561,
     /* 2332995 */   GIR_EraseRootFromParent_Done,
     /* 2332996 */ // Label 32264: @2332996
     /* 2332996 */ GIM_Try, /*On fail goto*//*Label 32265*/ GIMT_Encode4(2333050), // Rule ID 58812 //
     /* 2333001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2333004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2333007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333015 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2333032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333037 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333048 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333049 */   // GIR_Coverage, 58812,
     /* 2333049 */   GIR_EraseRootFromParent_Done,
     /* 2333050 */ // Label 32265: @2333050
     /* 2333050 */ GIM_Try, /*On fail goto*//*Label 32266*/ GIMT_Encode4(2333104), // Rule ID 58813 //
     /* 2333055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2333058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2333061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333069 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333069 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333072 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333076 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333081 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2333086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333088 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333091 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333102 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333103 */   // GIR_Coverage, 58813,
     /* 2333103 */   GIR_EraseRootFromParent_Done,
     /* 2333104 */ // Label 32266: @2333104
     /* 2333104 */ GIM_Reject,
     /* 2333105 */ // Label 32217: @2333105
     /* 2333105 */ GIM_Try, /*On fail goto*//*Label 32267*/ GIMT_Encode4(2333159), // Rule ID 58372 //
     /* 2333110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2333113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2333116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333124 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2333127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2333141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333146 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2333154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333157 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333158 */   // GIR_Coverage, 58372,
     /* 2333158 */   GIR_EraseRootFromParent_Done,
     /* 2333159 */ // Label 32267: @2333159
     /* 2333159 */ GIM_Try, /*On fail goto*//*Label 32268*/ GIMT_Encode4(2333213), // Rule ID 58373 //
     /* 2333164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2333167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2333170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333178 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2333181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2333195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333200 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2333208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333211 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333212 */   // GIR_Coverage, 58373,
     /* 2333212 */   GIR_EraseRootFromParent_Done,
     /* 2333213 */ // Label 32268: @2333213
     /* 2333213 */ GIM_Try, /*On fail goto*//*Label 32269*/ GIMT_Encode4(2333267), // Rule ID 58580 //
     /* 2333218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2333221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2333224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333232 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333232 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2333235 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333239 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2333249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333254 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333265 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333266 */   // GIR_Coverage, 58580,
     /* 2333266 */   GIR_EraseRootFromParent_Done,
     /* 2333267 */ // Label 32269: @2333267
     /* 2333267 */ GIM_Try, /*On fail goto*//*Label 32270*/ GIMT_Encode4(2333321), // Rule ID 58581 //
     /* 2333272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2333275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2333278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333286 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2333289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2333303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333308 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333319 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333320 */   // GIR_Coverage, 58581,
     /* 2333320 */   GIR_EraseRootFromParent_Done,
     /* 2333321 */ // Label 32270: @2333321
     /* 2333321 */ GIM_Reject,
     /* 2333322 */ // Label 32218: @2333322
     /* 2333322 */ GIM_Try, /*On fail goto*//*Label 32271*/ GIMT_Encode4(2333425),
     /* 2333327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2333330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333338 */   GIM_Try, /*On fail goto*//*Label 32272*/ GIMT_Encode4(2333381), // Rule ID 58772 //
     /* 2333343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333346 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2333349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2333363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333380 */     // GIR_Coverage, 58772,
     /* 2333380 */     GIR_EraseRootFromParent_Done,
     /* 2333381 */   // Label 32272: @2333381
     /* 2333381 */   GIM_Try, /*On fail goto*//*Label 32273*/ GIMT_Encode4(2333424), // Rule ID 58773 //
     /* 2333386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333389 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2333392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2333406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333423 */     // GIR_Coverage, 58773,
     /* 2333423 */     GIR_EraseRootFromParent_Done,
     /* 2333424 */   // Label 32273: @2333424
     /* 2333424 */   GIM_Reject,
     /* 2333425 */ // Label 32271: @2333425
     /* 2333425 */ GIM_Reject,
     /* 2333426 */ // Label 32219: @2333426
     /* 2333426 */ GIM_Try, /*On fail goto*//*Label 32274*/ GIMT_Encode4(2333480), // Rule ID 58356 //
     /* 2333431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2333437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333445 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333445 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2333448 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333452 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2333462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333467 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333478 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333479 */   // GIR_Coverage, 58356,
     /* 2333479 */   GIR_EraseRootFromParent_Done,
     /* 2333480 */ // Label 32274: @2333480
     /* 2333480 */ GIM_Try, /*On fail goto*//*Label 32275*/ GIMT_Encode4(2333534), // Rule ID 58357 //
     /* 2333485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2333491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333499 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2333502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2333516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333518 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333521 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333533 */   // GIR_Coverage, 58357,
     /* 2333533 */   GIR_EraseRootFromParent_Done,
     /* 2333534 */ // Label 32275: @2333534
     /* 2333534 */ GIM_Try, /*On fail goto*//*Label 32276*/ GIMT_Encode4(2333588), // Rule ID 58796 //
     /* 2333539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2333542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2333545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333553 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333553 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2333556 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333560 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2333570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333575 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333586 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333587 */   // GIR_Coverage, 58796,
     /* 2333587 */   GIR_EraseRootFromParent_Done,
     /* 2333588 */ // Label 32276: @2333588
     /* 2333588 */ GIM_Try, /*On fail goto*//*Label 32277*/ GIMT_Encode4(2333642), // Rule ID 58797 //
     /* 2333593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2333596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2333599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333607 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333607 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2333610 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333614 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2333624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333629 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333640 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333641 */   // GIR_Coverage, 58797,
     /* 2333641 */   GIR_EraseRootFromParent_Done,
     /* 2333642 */ // Label 32277: @2333642
     /* 2333642 */ GIM_Reject,
     /* 2333643 */ // Label 32220: @2333643
     /* 2333643 */ GIM_Try, /*On fail goto*//*Label 32278*/ GIMT_Encode4(2333697), // Rule ID 58368 //
     /* 2333648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2333651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2333654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333662 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2333665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2333679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333681 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333684 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333695 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333696 */   // GIR_Coverage, 58368,
     /* 2333696 */   GIR_EraseRootFromParent_Done,
     /* 2333697 */ // Label 32278: @2333697
     /* 2333697 */ GIM_Try, /*On fail goto*//*Label 32279*/ GIMT_Encode4(2333751), // Rule ID 58369 //
     /* 2333702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2333705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2333708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333716 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333716 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2333719 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333723 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2333733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333735 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333738 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333750 */   // GIR_Coverage, 58369,
     /* 2333750 */   GIR_EraseRootFromParent_Done,
     /* 2333751 */ // Label 32279: @2333751
     /* 2333751 */ GIM_Try, /*On fail goto*//*Label 32280*/ GIMT_Encode4(2333805), // Rule ID 58564 //
     /* 2333756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2333762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333770 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333770 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2333773 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333777 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2333787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333792 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333803 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333804 */   // GIR_Coverage, 58564,
     /* 2333804 */   GIR_EraseRootFromParent_Done,
     /* 2333805 */ // Label 32280: @2333805
     /* 2333805 */ GIM_Try, /*On fail goto*//*Label 32281*/ GIMT_Encode4(2333859), // Rule ID 58565 //
     /* 2333810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2333816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333824 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333824 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2333827 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333831 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2333841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333843 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333846 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333857 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333858 */   // GIR_Coverage, 58565,
     /* 2333858 */   GIR_EraseRootFromParent_Done,
     /* 2333859 */ // Label 32281: @2333859
     /* 2333859 */ GIM_Try, /*On fail goto*//*Label 32282*/ GIMT_Encode4(2333913), // Rule ID 58816 //
     /* 2333864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2333867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2333870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333878 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2333881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2333895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333897 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333900 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333911 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333912 */   // GIR_Coverage, 58816,
     /* 2333912 */   GIR_EraseRootFromParent_Done,
     /* 2333913 */ // Label 32282: @2333913
     /* 2333913 */ GIM_Try, /*On fail goto*//*Label 32283*/ GIMT_Encode4(2333967), // Rule ID 58817 //
     /* 2333918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2333921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2333924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333932 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2333935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2333949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333951 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333954 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333965 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333966 */   // GIR_Coverage, 58817,
     /* 2333966 */   GIR_EraseRootFromParent_Done,
     /* 2333967 */ // Label 32283: @2333967
     /* 2333967 */ GIM_Reject,
     /* 2333968 */ // Label 32221: @2333968
     /* 2333968 */ GIM_Try, /*On fail goto*//*Label 32284*/ GIMT_Encode4(2334022), // Rule ID 58400 //
     /* 2333973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2333976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2333979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333987 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333987 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2333990 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333994 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2334004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334009 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334020 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334021 */   // GIR_Coverage, 58400,
     /* 2334021 */   GIR_EraseRootFromParent_Done,
     /* 2334022 */ // Label 32284: @2334022
     /* 2334022 */ GIM_Try, /*On fail goto*//*Label 32285*/ GIMT_Encode4(2334076), // Rule ID 58401 //
     /* 2334027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2334030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2334033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334041 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334041 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2334044 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334048 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2334058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334060 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334063 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334074 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334075 */   // GIR_Coverage, 58401,
     /* 2334075 */   GIR_EraseRootFromParent_Done,
     /* 2334076 */ // Label 32285: @2334076
     /* 2334076 */ GIM_Try, /*On fail goto*//*Label 32286*/ GIMT_Encode4(2334130), // Rule ID 58584 //
     /* 2334081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2334084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334095 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334095 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2334098 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334102 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2334112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334117 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334128 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334129 */   // GIR_Coverage, 58584,
     /* 2334129 */   GIR_EraseRootFromParent_Done,
     /* 2334130 */ // Label 32286: @2334130
     /* 2334130 */ GIM_Try, /*On fail goto*//*Label 32287*/ GIMT_Encode4(2334184), // Rule ID 58585 //
     /* 2334135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2334138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334149 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334149 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2334152 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334156 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2334166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334171 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334182 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334183 */   // GIR_Coverage, 58585,
     /* 2334183 */   GIR_EraseRootFromParent_Done,
     /* 2334184 */ // Label 32287: @2334184
     /* 2334184 */ GIM_Reject,
     /* 2334185 */ // Label 32222: @2334185
     /* 2334185 */ GIM_Try, /*On fail goto*//*Label 32288*/ GIMT_Encode4(2334288),
     /* 2334190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2334193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334201 */   GIM_Try, /*On fail goto*//*Label 32289*/ GIMT_Encode4(2334244), // Rule ID 58776 //
     /* 2334206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334209 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2334212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2334226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334243 */     // GIR_Coverage, 58776,
     /* 2334243 */     GIR_EraseRootFromParent_Done,
     /* 2334244 */   // Label 32289: @2334244
     /* 2334244 */   GIM_Try, /*On fail goto*//*Label 32290*/ GIMT_Encode4(2334287), // Rule ID 58777 //
     /* 2334249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334252 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2334255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2334269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334286 */     // GIR_Coverage, 58777,
     /* 2334286 */     GIR_EraseRootFromParent_Done,
     /* 2334287 */   // Label 32290: @2334287
     /* 2334287 */   GIM_Reject,
     /* 2334288 */ // Label 32288: @2334288
     /* 2334288 */ GIM_Reject,
     /* 2334289 */ // Label 32223: @2334289
     /* 2334289 */ GIM_Try, /*On fail goto*//*Label 32291*/ GIMT_Encode4(2334343), // Rule ID 58364 //
     /* 2334294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2334300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334308 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334308 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2334311 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334315 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2334325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334327 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334330 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334341 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334342 */   // GIR_Coverage, 58364,
     /* 2334342 */   GIR_EraseRootFromParent_Done,
     /* 2334343 */ // Label 32291: @2334343
     /* 2334343 */ GIM_Try, /*On fail goto*//*Label 32292*/ GIMT_Encode4(2334397), // Rule ID 58365 //
     /* 2334348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2334354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334362 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2334365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2334379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334384 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334395 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334396 */   // GIR_Coverage, 58365,
     /* 2334396 */   GIR_EraseRootFromParent_Done,
     /* 2334397 */ // Label 32292: @2334397
     /* 2334397 */ GIM_Try, /*On fail goto*//*Label 32293*/ GIMT_Encode4(2334451), // Rule ID 58800 //
     /* 2334402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2334405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2334408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334416 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334416 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2334419 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334423 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2334433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334435 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334438 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334449 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334450 */   // GIR_Coverage, 58800,
     /* 2334450 */   GIR_EraseRootFromParent_Done,
     /* 2334451 */ // Label 32293: @2334451
     /* 2334451 */ GIM_Try, /*On fail goto*//*Label 32294*/ GIMT_Encode4(2334505), // Rule ID 58801 //
     /* 2334456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2334459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2334462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334470 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2334473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2334487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334492 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334503 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334504 */   // GIR_Coverage, 58801,
     /* 2334504 */   GIR_EraseRootFromParent_Done,
     /* 2334505 */ // Label 32294: @2334505
     /* 2334505 */ GIM_Reject,
     /* 2334506 */ // Label 32224: @2334506
     /* 2334506 */ GIM_Try, /*On fail goto*//*Label 32295*/ GIMT_Encode4(2334560), // Rule ID 58388 //
     /* 2334511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2334514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2334517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334525 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2334528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2334542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334544 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334547 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334558 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334559 */   // GIR_Coverage, 58388,
     /* 2334559 */   GIR_EraseRootFromParent_Done,
     /* 2334560 */ // Label 32295: @2334560
     /* 2334560 */ GIM_Try, /*On fail goto*//*Label 32296*/ GIMT_Encode4(2334614), // Rule ID 58389 //
     /* 2334565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2334568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2334571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334579 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334579 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2334582 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334586 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2334596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334598 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334601 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334612 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334613 */   // GIR_Coverage, 58389,
     /* 2334613 */   GIR_EraseRootFromParent_Done,
     /* 2334614 */ // Label 32296: @2334614
     /* 2334614 */ GIM_Try, /*On fail goto*//*Label 32297*/ GIMT_Encode4(2334668), // Rule ID 58568 //
     /* 2334619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2334625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334633 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2334636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2334650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334655 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334666 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334667 */   // GIR_Coverage, 58568,
     /* 2334667 */   GIR_EraseRootFromParent_Done,
     /* 2334668 */ // Label 32297: @2334668
     /* 2334668 */ GIM_Try, /*On fail goto*//*Label 32298*/ GIMT_Encode4(2334722), // Rule ID 58569 //
     /* 2334673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2334679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334687 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2334690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2334704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334709 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334720 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334721 */   // GIR_Coverage, 58569,
     /* 2334721 */   GIR_EraseRootFromParent_Done,
     /* 2334722 */ // Label 32298: @2334722
     /* 2334722 */ GIM_Try, /*On fail goto*//*Label 32299*/ GIMT_Encode4(2334776), // Rule ID 58820 //
     /* 2334727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2334730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2334733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334741 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2334744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2334758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334763 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334774 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334775 */   // GIR_Coverage, 58820,
     /* 2334775 */   GIR_EraseRootFromParent_Done,
     /* 2334776 */ // Label 32299: @2334776
     /* 2334776 */ GIM_Try, /*On fail goto*//*Label 32300*/ GIMT_Encode4(2334830), // Rule ID 58821 //
     /* 2334781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2334784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2334787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334795 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334795 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2334798 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334802 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2334812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334814 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334817 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334829 */   // GIR_Coverage, 58821,
     /* 2334829 */   GIR_EraseRootFromParent_Done,
     /* 2334830 */ // Label 32300: @2334830
     /* 2334830 */ GIM_Reject,
     /* 2334831 */ // Label 32225: @2334831
     /* 2334831 */ GIM_Try, /*On fail goto*//*Label 32301*/ GIMT_Encode4(2334885), // Rule ID 58404 //
     /* 2334836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2334839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2334842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334850 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334850 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2334853 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334857 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2334867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334872 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334883 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334884 */   // GIR_Coverage, 58404,
     /* 2334884 */   GIR_EraseRootFromParent_Done,
     /* 2334885 */ // Label 32301: @2334885
     /* 2334885 */ GIM_Try, /*On fail goto*//*Label 32302*/ GIMT_Encode4(2334939), // Rule ID 58405 //
     /* 2334890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2334893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2334896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334904 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334904 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2334907 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334911 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2334921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334923 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334926 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334937 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334938 */   // GIR_Coverage, 58405,
     /* 2334938 */   GIR_EraseRootFromParent_Done,
     /* 2334939 */ // Label 32302: @2334939
     /* 2334939 */ GIM_Try, /*On fail goto*//*Label 32303*/ GIMT_Encode4(2334993), // Rule ID 58588 //
     /* 2334944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2334947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2334950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334958 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2334961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2334975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334980 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334991 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334992 */   // GIR_Coverage, 58588,
     /* 2334992 */   GIR_EraseRootFromParent_Done,
     /* 2334993 */ // Label 32303: @2334993
     /* 2334993 */ GIM_Try, /*On fail goto*//*Label 32304*/ GIMT_Encode4(2335047), // Rule ID 58589 //
     /* 2334998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2335001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2335004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335012 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2335015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2335029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335034 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335045 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335046 */   // GIR_Coverage, 58589,
     /* 2335046 */   GIR_EraseRootFromParent_Done,
     /* 2335047 */ // Label 32304: @2335047
     /* 2335047 */ GIM_Reject,
     /* 2335048 */ // Label 32226: @2335048
     /* 2335048 */ GIM_Try, /*On fail goto*//*Label 32305*/ GIMT_Encode4(2335151),
     /* 2335053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2335056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335064 */   GIM_Try, /*On fail goto*//*Label 32306*/ GIMT_Encode4(2335107), // Rule ID 58780 //
     /* 2335069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335072 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2335075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2335089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335106 */     // GIR_Coverage, 58780,
     /* 2335106 */     GIR_EraseRootFromParent_Done,
     /* 2335107 */   // Label 32306: @2335107
     /* 2335107 */   GIM_Try, /*On fail goto*//*Label 32307*/ GIMT_Encode4(2335150), // Rule ID 58781 //
     /* 2335112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335115 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2335118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2335132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335149 */     // GIR_Coverage, 58781,
     /* 2335149 */     GIR_EraseRootFromParent_Done,
     /* 2335150 */   // Label 32307: @2335150
     /* 2335150 */   GIM_Reject,
     /* 2335151 */ // Label 32305: @2335151
     /* 2335151 */ GIM_Reject,
     /* 2335152 */ // Label 32227: @2335152
     /* 2335152 */ GIM_Try, /*On fail goto*//*Label 32308*/ GIMT_Encode4(2335206), // Rule ID 58376 //
     /* 2335157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2335163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335171 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335171 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2335174 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335178 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2335188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335190 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335193 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335204 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335205 */   // GIR_Coverage, 58376,
     /* 2335205 */   GIR_EraseRootFromParent_Done,
     /* 2335206 */ // Label 32308: @2335206
     /* 2335206 */ GIM_Try, /*On fail goto*//*Label 32309*/ GIMT_Encode4(2335260), // Rule ID 58377 //
     /* 2335211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2335217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335225 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335225 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2335228 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335232 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2335242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335247 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335258 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335259 */   // GIR_Coverage, 58377,
     /* 2335259 */   GIR_EraseRootFromParent_Done,
     /* 2335260 */ // Label 32309: @2335260
     /* 2335260 */ GIM_Try, /*On fail goto*//*Label 32310*/ GIMT_Encode4(2335314), // Rule ID 58804 //
     /* 2335265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2335268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2335271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335279 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2335282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2335296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335301 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335312 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335313 */   // GIR_Coverage, 58804,
     /* 2335313 */   GIR_EraseRootFromParent_Done,
     /* 2335314 */ // Label 32310: @2335314
     /* 2335314 */ GIM_Try, /*On fail goto*//*Label 32311*/ GIMT_Encode4(2335368), // Rule ID 58805 //
     /* 2335319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2335322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2335325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335333 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2335336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2335350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335355 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335366 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335367 */   // GIR_Coverage, 58805,
     /* 2335367 */   GIR_EraseRootFromParent_Done,
     /* 2335368 */ // Label 32311: @2335368
     /* 2335368 */ GIM_Reject,
     /* 2335369 */ // Label 32228: @2335369
     /* 2335369 */ GIM_Try, /*On fail goto*//*Label 32312*/ GIMT_Encode4(2335423), // Rule ID 58392 //
     /* 2335374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2335377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2335380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335388 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2335391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2335405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335407 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335410 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335421 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335422 */   // GIR_Coverage, 58392,
     /* 2335422 */   GIR_EraseRootFromParent_Done,
     /* 2335423 */ // Label 32312: @2335423
     /* 2335423 */ GIM_Try, /*On fail goto*//*Label 32313*/ GIMT_Encode4(2335477), // Rule ID 58393 //
     /* 2335428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2335431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2335434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335442 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2335445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2335459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335464 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335475 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335476 */   // GIR_Coverage, 58393,
     /* 2335476 */   GIR_EraseRootFromParent_Done,
     /* 2335477 */ // Label 32313: @2335477
     /* 2335477 */ GIM_Try, /*On fail goto*//*Label 32314*/ GIMT_Encode4(2335531), // Rule ID 58572 //
     /* 2335482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2335488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335496 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335496 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2335499 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335503 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2335513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335518 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335529 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335530 */   // GIR_Coverage, 58572,
     /* 2335530 */   GIR_EraseRootFromParent_Done,
     /* 2335531 */ // Label 32314: @2335531
     /* 2335531 */ GIM_Try, /*On fail goto*//*Label 32315*/ GIMT_Encode4(2335585), // Rule ID 58573 //
     /* 2335536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2335542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335550 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335550 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2335553 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335557 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2335567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335569 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335572 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335583 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335584 */   // GIR_Coverage, 58573,
     /* 2335584 */   GIR_EraseRootFromParent_Done,
     /* 2335585 */ // Label 32315: @2335585
     /* 2335585 */ GIM_Try, /*On fail goto*//*Label 32316*/ GIMT_Encode4(2335639), // Rule ID 58824 //
     /* 2335590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2335593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2335596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335604 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335604 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2335607 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335611 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2335621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335626 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335637 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335638 */   // GIR_Coverage, 58824,
     /* 2335638 */   GIR_EraseRootFromParent_Done,
     /* 2335639 */ // Label 32316: @2335639
     /* 2335639 */ GIM_Try, /*On fail goto*//*Label 32317*/ GIMT_Encode4(2335693), // Rule ID 58825 //
     /* 2335644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2335647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2335650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335658 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2335661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2335675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335680 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335691 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335692 */   // GIR_Coverage, 58825,
     /* 2335692 */   GIR_EraseRootFromParent_Done,
     /* 2335693 */ // Label 32317: @2335693
     /* 2335693 */ GIM_Reject,
     /* 2335694 */ // Label 32229: @2335694
     /* 2335694 */ GIM_Try, /*On fail goto*//*Label 32318*/ GIMT_Encode4(2335748), // Rule ID 58408 //
     /* 2335699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2335702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2335705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335713 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335713 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2335716 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335720 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2335730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335732 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335735 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2335743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335746 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335747 */   // GIR_Coverage, 58408,
     /* 2335747 */   GIR_EraseRootFromParent_Done,
     /* 2335748 */ // Label 32318: @2335748
     /* 2335748 */ GIM_Try, /*On fail goto*//*Label 32319*/ GIMT_Encode4(2335802), // Rule ID 58409 //
     /* 2335753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2335756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2335759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335767 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335767 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2335770 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335774 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2335784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335786 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335789 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2335797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335800 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335801 */   // GIR_Coverage, 58409,
     /* 2335801 */   GIR_EraseRootFromParent_Done,
     /* 2335802 */ // Label 32319: @2335802
     /* 2335802 */ GIM_Try, /*On fail goto*//*Label 32320*/ GIMT_Encode4(2335856), // Rule ID 58592 //
     /* 2335807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2335810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2335813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335821 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335821 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2335824 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335828 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2335838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335843 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335854 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335855 */   // GIR_Coverage, 58592,
     /* 2335855 */   GIR_EraseRootFromParent_Done,
     /* 2335856 */ // Label 32320: @2335856
     /* 2335856 */ GIM_Try, /*On fail goto*//*Label 32321*/ GIMT_Encode4(2335910), // Rule ID 58593 //
     /* 2335861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2335864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2335867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335875 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2335878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2335892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335897 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335908 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335909 */   // GIR_Coverage, 58593,
     /* 2335909 */   GIR_EraseRootFromParent_Done,
     /* 2335910 */ // Label 32321: @2335910
     /* 2335910 */ GIM_Reject,
     /* 2335911 */ // Label 32230: @2335911
     /* 2335911 */ GIM_Try, /*On fail goto*//*Label 32322*/ GIMT_Encode4(2336014),
     /* 2335916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2335919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335927 */   GIM_Try, /*On fail goto*//*Label 32323*/ GIMT_Encode4(2335970), // Rule ID 58784 //
     /* 2335932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335935 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2335938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2335952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335969 */     // GIR_Coverage, 58784,
     /* 2335969 */     GIR_EraseRootFromParent_Done,
     /* 2335970 */   // Label 32323: @2335970
     /* 2335970 */   GIM_Try, /*On fail goto*//*Label 32324*/ GIMT_Encode4(2336013), // Rule ID 58785 //
     /* 2335975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335978 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2335981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2335995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336012 */     // GIR_Coverage, 58785,
     /* 2336012 */     GIR_EraseRootFromParent_Done,
     /* 2336013 */   // Label 32324: @2336013
     /* 2336013 */   GIM_Reject,
     /* 2336014 */ // Label 32322: @2336014
     /* 2336014 */ GIM_Reject,
     /* 2336015 */ // Label 32231: @2336015
     /* 2336015 */ GIM_Try, /*On fail goto*//*Label 32325*/ GIMT_Encode4(2336069), // Rule ID 58380 //
     /* 2336020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2336026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336034 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336034 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2336037 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336041 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2336051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336053 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336056 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336067 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336068 */   // GIR_Coverage, 58380,
     /* 2336068 */   GIR_EraseRootFromParent_Done,
     /* 2336069 */ // Label 32325: @2336069
     /* 2336069 */ GIM_Try, /*On fail goto*//*Label 32326*/ GIMT_Encode4(2336123), // Rule ID 58381 //
     /* 2336074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2336080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336088 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336088 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2336091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336095 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2336105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336107 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336110 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336121 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336122 */   // GIR_Coverage, 58381,
     /* 2336122 */   GIR_EraseRootFromParent_Done,
     /* 2336123 */ // Label 32326: @2336123
     /* 2336123 */ GIM_Try, /*On fail goto*//*Label 32327*/ GIMT_Encode4(2336177), // Rule ID 58808 //
     /* 2336128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2336131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2336134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336142 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336142 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2336145 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336149 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336154 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2336159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336161 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336164 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336175 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336176 */   // GIR_Coverage, 58808,
     /* 2336176 */   GIR_EraseRootFromParent_Done,
     /* 2336177 */ // Label 32327: @2336177
     /* 2336177 */ GIM_Try, /*On fail goto*//*Label 32328*/ GIMT_Encode4(2336231), // Rule ID 58809 //
     /* 2336182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2336185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2336188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336196 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336196 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2336199 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336203 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336208 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2336213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336218 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336230 */   // GIR_Coverage, 58809,
     /* 2336230 */   GIR_EraseRootFromParent_Done,
     /* 2336231 */ // Label 32328: @2336231
     /* 2336231 */ GIM_Reject,
     /* 2336232 */ // Label 32232: @2336232
     /* 2336232 */ GIM_Try, /*On fail goto*//*Label 32329*/ GIMT_Encode4(2336286), // Rule ID 58396 //
     /* 2336237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2336240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2336243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336251 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336251 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2336254 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336258 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2336268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336273 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336284 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336285 */   // GIR_Coverage, 58396,
     /* 2336285 */   GIR_EraseRootFromParent_Done,
     /* 2336286 */ // Label 32329: @2336286
     /* 2336286 */ GIM_Try, /*On fail goto*//*Label 32330*/ GIMT_Encode4(2336340), // Rule ID 58397 //
     /* 2336291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2336294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2336297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336305 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336305 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2336308 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336312 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2336322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336324 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336327 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336338 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336339 */   // GIR_Coverage, 58397,
     /* 2336339 */   GIR_EraseRootFromParent_Done,
     /* 2336340 */ // Label 32330: @2336340
     /* 2336340 */ GIM_Try, /*On fail goto*//*Label 32331*/ GIMT_Encode4(2336394), // Rule ID 58576 //
     /* 2336345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2336351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336359 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2336362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2336376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336381 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336392 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336393 */   // GIR_Coverage, 58576,
     /* 2336393 */   GIR_EraseRootFromParent_Done,
     /* 2336394 */ // Label 32331: @2336394
     /* 2336394 */ GIM_Try, /*On fail goto*//*Label 32332*/ GIMT_Encode4(2336448), // Rule ID 58577 //
     /* 2336399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2336405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336413 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336413 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2336416 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336420 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2336430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336435 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336446 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336447 */   // GIR_Coverage, 58577,
     /* 2336447 */   GIR_EraseRootFromParent_Done,
     /* 2336448 */ // Label 32332: @2336448
     /* 2336448 */ GIM_Reject,
     /* 2336449 */ // Label 32233: @2336449
     /* 2336449 */ GIM_Try, /*On fail goto*//*Label 32333*/ GIMT_Encode4(2336552),
     /* 2336454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2336457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336465 */   GIM_Try, /*On fail goto*//*Label 32334*/ GIMT_Encode4(2336508), // Rule ID 58788 //
     /* 2336470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336473 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2336476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2336490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336507 */     // GIR_Coverage, 58788,
     /* 2336507 */     GIR_EraseRootFromParent_Done,
     /* 2336508 */   // Label 32334: @2336508
     /* 2336508 */   GIM_Try, /*On fail goto*//*Label 32335*/ GIMT_Encode4(2336551), // Rule ID 58789 //
     /* 2336513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336516 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2336519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2336533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336550 */     // GIR_Coverage, 58789,
     /* 2336550 */     GIR_EraseRootFromParent_Done,
     /* 2336551 */   // Label 32335: @2336551
     /* 2336551 */   GIM_Reject,
     /* 2336552 */ // Label 32333: @2336552
     /* 2336552 */ GIM_Reject,
     /* 2336553 */ // Label 32234: @2336553
     /* 2336553 */ GIM_Try, /*On fail goto*//*Label 32336*/ GIMT_Encode4(2336656),
     /* 2336558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2336561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336569 */   GIM_Try, /*On fail goto*//*Label 32337*/ GIMT_Encode4(2336612), // Rule ID 58384 //
     /* 2336574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336577 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2336580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2336594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336611 */     // GIR_Coverage, 58384,
     /* 2336611 */     GIR_EraseRootFromParent_Done,
     /* 2336612 */   // Label 32337: @2336612
     /* 2336612 */   GIM_Try, /*On fail goto*//*Label 32338*/ GIMT_Encode4(2336655), // Rule ID 58385 //
     /* 2336617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336620 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2336623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2336637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336654 */     // GIR_Coverage, 58385,
     /* 2336654 */     GIR_EraseRootFromParent_Done,
     /* 2336655 */   // Label 32338: @2336655
     /* 2336655 */   GIM_Reject,
     /* 2336656 */ // Label 32336: @2336656
     /* 2336656 */ GIM_Reject,
     /* 2336657 */ // Label 32235: @2336657
     /* 2336657 */ GIM_Reject,
     /* 2336658 */ // Label 69: @2336658
     /* 2336658 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32357*/ GIMT_Encode4(2341943),
     /* 2336669 */ /*GILLT_s16*//*Label 32339*/ GIMT_Encode4(2336789),
     /* 2336673 */ /*GILLT_s32*//*Label 32340*/ GIMT_Encode4(2337050),
     /* 2336677 */ /*GILLT_s64*//*Label 32341*/ GIMT_Encode4(2337311), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2336689 */ /*GILLT_nxv1s16*//*Label 32342*/ GIMT_Encode4(2337572),
     /* 2336693 */ /*GILLT_nxv1s32*//*Label 32343*/ GIMT_Encode4(2337909),
     /* 2336697 */ /*GILLT_nxv1s64*//*Label 32344*/ GIMT_Encode4(2338246), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2336709 */ /*GILLT_nxv2s16*//*Label 32345*/ GIMT_Encode4(2338469),
     /* 2336713 */ /*GILLT_nxv2s32*//*Label 32346*/ GIMT_Encode4(2338806),
     /* 2336717 */ /*GILLT_nxv2s64*//*Label 32347*/ GIMT_Encode4(2339143), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2336729 */ /*GILLT_nxv4s16*//*Label 32348*/ GIMT_Encode4(2339366),
     /* 2336733 */ /*GILLT_nxv4s32*//*Label 32349*/ GIMT_Encode4(2339703),
     /* 2336737 */ /*GILLT_nxv4s64*//*Label 32350*/ GIMT_Encode4(2340040), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2336749 */ /*GILLT_nxv8s16*//*Label 32351*/ GIMT_Encode4(2340263),
     /* 2336753 */ /*GILLT_nxv8s32*//*Label 32352*/ GIMT_Encode4(2340600),
     /* 2336757 */ /*GILLT_nxv8s64*//*Label 32353*/ GIMT_Encode4(2340937), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2336769 */ /*GILLT_nxv16s16*//*Label 32354*/ GIMT_Encode4(2341160),
     /* 2336773 */ /*GILLT_nxv16s32*//*Label 32355*/ GIMT_Encode4(2341497), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2336785 */ /*GILLT_nxv32s16*//*Label 32356*/ GIMT_Encode4(2341720),
     /* 2336789 */ // Label 32339: @2336789
     /* 2336789 */ GIM_Try, /*On fail goto*//*Label 32358*/ GIMT_Encode4(2336826), // Rule ID 2261 //
     /* 2336794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2336797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2336804 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2336811 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2336811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2336814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2336821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336824 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336825 */   // GIR_Coverage, 2261,
     /* 2336825 */   GIR_EraseRootFromParent_Done,
     /* 2336826 */ // Label 32358: @2336826
     /* 2336826 */ GIM_Try, /*On fail goto*//*Label 32359*/ GIMT_Encode4(2336863), // Rule ID 2287 //
     /* 2336831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2336834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2336841 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2336848 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2336848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2336851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2336858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336861 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336862 */   // GIR_Coverage, 2287,
     /* 2336862 */   GIR_EraseRootFromParent_Done,
     /* 2336863 */ // Label 32359: @2336863
     /* 2336863 */ GIM_Try, /*On fail goto*//*Label 32360*/ GIMT_Encode4(2336894), // Rule ID 2210 //
     /* 2336868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2336871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2336878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336882 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2336882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2336885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336887 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336892 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336893 */   // GIR_Coverage, 2210,
     /* 2336893 */   GIR_EraseRootFromParent_Done,
     /* 2336894 */ // Label 32360: @2336894
     /* 2336894 */ GIM_Try, /*On fail goto*//*Label 32361*/ GIMT_Encode4(2336925), // Rule ID 2211 //
     /* 2336899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2336902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2336909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336913 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2336913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2336916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336918 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336924 */   // GIR_Coverage, 2211,
     /* 2336924 */   GIR_EraseRootFromParent_Done,
     /* 2336925 */ // Label 32361: @2336925
     /* 2336925 */ GIM_Try, /*On fail goto*//*Label 32362*/ GIMT_Encode4(2336956), // Rule ID 2236 //
     /* 2336930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2336933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2336940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336944 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2336944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2336947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336949 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336954 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336955 */   // GIR_Coverage, 2236,
     /* 2336955 */   GIR_EraseRootFromParent_Done,
     /* 2336956 */ // Label 32362: @2336956
     /* 2336956 */ GIM_Try, /*On fail goto*//*Label 32363*/ GIMT_Encode4(2336987), // Rule ID 2237 //
     /* 2336961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2336964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2336971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336975 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2336975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2336978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336980 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336986 */   // GIR_Coverage, 2237,
     /* 2336986 */   GIR_EraseRootFromParent_Done,
     /* 2336987 */ // Label 32363: @2336987
     /* 2336987 */ GIM_Try, /*On fail goto*//*Label 32364*/ GIMT_Encode4(2337018), // Rule ID 2265 //
     /* 2336992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2336995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2337002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337006 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2337006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L),
     /* 2337009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337011 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337016 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337017 */   // GIR_Coverage, 2265,
     /* 2337017 */   GIR_EraseRootFromParent_Done,
     /* 2337018 */ // Label 32364: @2337018
     /* 2337018 */ GIM_Try, /*On fail goto*//*Label 32365*/ GIMT_Encode4(2337049), // Rule ID 2291 //
     /* 2337023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2337026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2337033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337037 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2337037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L_INX),
     /* 2337040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337042 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337047 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337048 */   // GIR_Coverage, 2291,
     /* 2337048 */   GIR_EraseRootFromParent_Done,
     /* 2337049 */ // Label 32365: @2337049
     /* 2337049 */ GIM_Reject,
     /* 2337050 */ // Label 32340: @2337050
     /* 2337050 */ GIM_Try, /*On fail goto*//*Label 32366*/ GIMT_Encode4(2337087), // Rule ID 1527 //
     /* 2337055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2337058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2337065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2337072 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2337072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2337075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2337082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337086 */   // GIR_Coverage, 1527,
     /* 2337086 */   GIR_EraseRootFromParent_Done,
     /* 2337087 */ // Label 32366: @2337087
     /* 2337087 */ GIM_Try, /*On fail goto*//*Label 32367*/ GIMT_Encode4(2337124), // Rule ID 1555 //
     /* 2337092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2337095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2337102 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2337109 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2337109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2337112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2337119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337122 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337123 */   // GIR_Coverage, 1555,
     /* 2337123 */   GIR_EraseRootFromParent_Done,
     /* 2337124 */ // Label 32367: @2337124
     /* 2337124 */ GIM_Try, /*On fail goto*//*Label 32368*/ GIMT_Encode4(2337155), // Rule ID 1474 //
     /* 2337129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2337132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2337139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337143 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2337143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2337146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337148 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337153 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337154 */   // GIR_Coverage, 1474,
     /* 2337154 */   GIR_EraseRootFromParent_Done,
     /* 2337155 */ // Label 32368: @2337155
     /* 2337155 */ GIM_Try, /*On fail goto*//*Label 32369*/ GIMT_Encode4(2337186), // Rule ID 1475 //
     /* 2337160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2337163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2337170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337174 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2337174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2337177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337179 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337184 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337185 */   // GIR_Coverage, 1475,
     /* 2337185 */   GIR_EraseRootFromParent_Done,
     /* 2337186 */ // Label 32369: @2337186
     /* 2337186 */ GIM_Try, /*On fail goto*//*Label 32370*/ GIMT_Encode4(2337217), // Rule ID 1500 //
     /* 2337191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2337194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2337201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337205 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2337205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2337208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337210 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337215 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337216 */   // GIR_Coverage, 1500,
     /* 2337216 */   GIR_EraseRootFromParent_Done,
     /* 2337217 */ // Label 32370: @2337217
     /* 2337217 */ GIM_Try, /*On fail goto*//*Label 32371*/ GIMT_Encode4(2337248), // Rule ID 1501 //
     /* 2337222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2337225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2337232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337236 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2337236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2337239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337241 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337246 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337247 */   // GIR_Coverage, 1501,
     /* 2337247 */   GIR_EraseRootFromParent_Done,
     /* 2337248 */ // Label 32371: @2337248
     /* 2337248 */ GIM_Try, /*On fail goto*//*Label 32372*/ GIMT_Encode4(2337279), // Rule ID 1531 //
     /* 2337253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2337256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2337263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337267 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2337267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L),
     /* 2337270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337272 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337278 */   // GIR_Coverage, 1531,
     /* 2337278 */   GIR_EraseRootFromParent_Done,
     /* 2337279 */ // Label 32372: @2337279
     /* 2337279 */ GIM_Try, /*On fail goto*//*Label 32373*/ GIMT_Encode4(2337310), // Rule ID 1559 //
     /* 2337284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2337287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2337294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337298 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2337298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L_INX),
     /* 2337301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337303 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337309 */   // GIR_Coverage, 1559,
     /* 2337309 */   GIR_EraseRootFromParent_Done,
     /* 2337310 */ // Label 32373: @2337310
     /* 2337310 */ GIM_Reject,
     /* 2337311 */ // Label 32341: @2337311
     /* 2337311 */ GIM_Try, /*On fail goto*//*Label 32374*/ GIMT_Encode4(2337348), // Rule ID 1907 //
     /* 2337316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2337319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2337326 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2337333 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2337333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2337336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2337343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2337346 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337347 */   // GIR_Coverage, 1907,
     /* 2337347 */   GIR_EraseRootFromParent_Done,
     /* 2337348 */ // Label 32374: @2337348
     /* 2337348 */ GIM_Try, /*On fail goto*//*Label 32375*/ GIMT_Encode4(2337385), // Rule ID 1935 //
     /* 2337353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2337356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337363 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2337370 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2337370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_INX),
     /* 2337373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2337380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2337383 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337384 */   // GIR_Coverage, 1935,
     /* 2337384 */   GIR_EraseRootFromParent_Done,
     /* 2337385 */ // Label 32375: @2337385
     /* 2337385 */ GIM_Try, /*On fail goto*//*Label 32376*/ GIMT_Encode4(2337416), // Rule ID 1868 //
     /* 2337390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2337393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2337400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337404 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2337404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2337407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337409 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2337414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337415 */   // GIR_Coverage, 1868,
     /* 2337415 */   GIR_EraseRootFromParent_Done,
     /* 2337416 */ // Label 32376: @2337416
     /* 2337416 */ GIM_Try, /*On fail goto*//*Label 32377*/ GIMT_Encode4(2337447), // Rule ID 1869 //
     /* 2337421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2337424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2337431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337435 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2337435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2337438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337440 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2337445 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337446 */   // GIR_Coverage, 1869,
     /* 2337446 */   GIR_EraseRootFromParent_Done,
     /* 2337447 */ // Label 32377: @2337447
     /* 2337447 */ GIM_Try, /*On fail goto*//*Label 32378*/ GIMT_Encode4(2337478), // Rule ID 1894 //
     /* 2337452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2337455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2337462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337466 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2337466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2337469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337471 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2337476 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337477 */   // GIR_Coverage, 1894,
     /* 2337477 */   GIR_EraseRootFromParent_Done,
     /* 2337478 */ // Label 32378: @2337478
     /* 2337478 */ GIM_Try, /*On fail goto*//*Label 32379*/ GIMT_Encode4(2337509), // Rule ID 1895 //
     /* 2337483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2337486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2337493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337497 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2337497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2337500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337502 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2337507 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337508 */   // GIR_Coverage, 1895,
     /* 2337508 */   GIR_EraseRootFromParent_Done,
     /* 2337509 */ // Label 32379: @2337509
     /* 2337509 */ GIM_Try, /*On fail goto*//*Label 32380*/ GIMT_Encode4(2337540), // Rule ID 1925 //
     /* 2337514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2337517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2337524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337528 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2337528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L),
     /* 2337531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337533 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337538 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337539 */   // GIR_Coverage, 1925,
     /* 2337539 */   GIR_EraseRootFromParent_Done,
     /* 2337540 */ // Label 32380: @2337540
     /* 2337540 */ GIM_Try, /*On fail goto*//*Label 32381*/ GIMT_Encode4(2337571), // Rule ID 1953 //
     /* 2337545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2337548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337559 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2337559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L_INX),
     /* 2337562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337564 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337569 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337570 */   // GIR_Coverage, 1953,
     /* 2337570 */   GIR_EraseRootFromParent_Done,
     /* 2337571 */ // Label 32381: @2337571
     /* 2337571 */ GIM_Reject,
     /* 2337572 */ // Label 32342: @2337572
     /* 2337572 */ GIM_Try, /*On fail goto*//*Label 32382*/ GIMT_Encode4(2337629), // Rule ID 45804 //
     /* 2337577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2337583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337591 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2337594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2337608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337613 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337627 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337628 */   // GIR_Coverage, 45804,
     /* 2337628 */   GIR_EraseRootFromParent_Done,
     /* 2337629 */ // Label 32382: @2337629
     /* 2337629 */ GIM_Try, /*On fail goto*//*Label 32383*/ GIMT_Encode4(2337686), // Rule ID 45805 //
     /* 2337634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2337640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337648 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337648 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2337651 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337655 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2337665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337670 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337685 */   // GIR_Coverage, 45805,
     /* 2337685 */   GIR_EraseRootFromParent_Done,
     /* 2337686 */ // Label 32383: @2337686
     /* 2337686 */ GIM_Try, /*On fail goto*//*Label 32384*/ GIMT_Encode4(2337740), // Rule ID 45812 //
     /* 2337691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2337697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337705 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2337708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2337722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337727 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337738 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337739 */   // GIR_Coverage, 45812,
     /* 2337739 */   GIR_EraseRootFromParent_Done,
     /* 2337740 */ // Label 32384: @2337740
     /* 2337740 */ GIM_Try, /*On fail goto*//*Label 32385*/ GIMT_Encode4(2337794), // Rule ID 45813 //
     /* 2337745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2337751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337759 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2337762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2337776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337781 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337792 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337793 */   // GIR_Coverage, 45813,
     /* 2337793 */   GIR_EraseRootFromParent_Done,
     /* 2337794 */ // Label 32385: @2337794
     /* 2337794 */ GIM_Try, /*On fail goto*//*Label 32386*/ GIMT_Encode4(2337851), // Rule ID 45820 //
     /* 2337799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2337805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337813 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337813 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2337816 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337820 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2337830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337835 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337849 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337850 */   // GIR_Coverage, 45820,
     /* 2337850 */   GIR_EraseRootFromParent_Done,
     /* 2337851 */ // Label 32386: @2337851
     /* 2337851 */ GIM_Try, /*On fail goto*//*Label 32387*/ GIMT_Encode4(2337908), // Rule ID 45821 //
     /* 2337856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2337862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337870 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337870 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2337873 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337877 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2337887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337889 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337892 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337906 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337907 */   // GIR_Coverage, 45821,
     /* 2337907 */   GIR_EraseRootFromParent_Done,
     /* 2337908 */ // Label 32387: @2337908
     /* 2337908 */ GIM_Reject,
     /* 2337909 */ // Label 32343: @2337909
     /* 2337909 */ GIM_Try, /*On fail goto*//*Label 32388*/ GIMT_Encode4(2337966), // Rule ID 58416 //
     /* 2337914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2337917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2337920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337928 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2337931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2337945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337950 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337964 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337965 */   // GIR_Coverage, 58416,
     /* 2337965 */   GIR_EraseRootFromParent_Done,
     /* 2337966 */ // Label 32388: @2337966
     /* 2337966 */ GIM_Try, /*On fail goto*//*Label 32389*/ GIMT_Encode4(2338023), // Rule ID 58417 //
     /* 2337971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2337974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2337977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337985 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337985 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2337988 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337992 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2338002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338004 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338007 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338022 */   // GIR_Coverage, 58417,
     /* 2338022 */   GIR_EraseRootFromParent_Done,
     /* 2338023 */ // Label 32389: @2338023
     /* 2338023 */ GIM_Try, /*On fail goto*//*Label 32390*/ GIMT_Encode4(2338077), // Rule ID 58616 //
     /* 2338028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2338031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2338034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338042 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2338059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338064 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338075 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338076 */   // GIR_Coverage, 58616,
     /* 2338076 */   GIR_EraseRootFromParent_Done,
     /* 2338077 */ // Label 32390: @2338077
     /* 2338077 */ GIM_Try, /*On fail goto*//*Label 32391*/ GIMT_Encode4(2338131), // Rule ID 58617 //
     /* 2338082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2338085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2338088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338096 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338096 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338099 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338103 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2338113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338115 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338118 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338129 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338130 */   // GIR_Coverage, 58617,
     /* 2338130 */   GIR_EraseRootFromParent_Done,
     /* 2338131 */ // Label 32391: @2338131
     /* 2338131 */ GIM_Try, /*On fail goto*//*Label 32392*/ GIMT_Encode4(2338188), // Rule ID 58844 //
     /* 2338136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2338139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2338142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338150 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2338167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338169 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338172 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338186 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338187 */   // GIR_Coverage, 58844,
     /* 2338187 */   GIR_EraseRootFromParent_Done,
     /* 2338188 */ // Label 32392: @2338188
     /* 2338188 */ GIM_Try, /*On fail goto*//*Label 32393*/ GIMT_Encode4(2338245), // Rule ID 58845 //
     /* 2338193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2338196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2338199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338207 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2338224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338229 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338243 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338244 */   // GIR_Coverage, 58845,
     /* 2338244 */   GIR_EraseRootFromParent_Done,
     /* 2338245 */ // Label 32393: @2338245
     /* 2338245 */ GIM_Reject,
     /* 2338246 */ // Label 32344: @2338246
     /* 2338246 */ GIM_Try, /*On fail goto*//*Label 32394*/ GIMT_Encode4(2338303), // Rule ID 58428 //
     /* 2338251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2338254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2338257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338265 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338265 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2338268 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338272 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2338282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338287 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2338298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338301 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338302 */   // GIR_Coverage, 58428,
     /* 2338302 */   GIR_EraseRootFromParent_Done,
     /* 2338303 */ // Label 32394: @2338303
     /* 2338303 */ GIM_Try, /*On fail goto*//*Label 32395*/ GIMT_Encode4(2338360), // Rule ID 58429 //
     /* 2338308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2338311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2338314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338322 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2338325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2338339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338344 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2338355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338358 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338359 */   // GIR_Coverage, 58429,
     /* 2338359 */   GIR_EraseRootFromParent_Done,
     /* 2338360 */ // Label 32395: @2338360
     /* 2338360 */ GIM_Try, /*On fail goto*//*Label 32396*/ GIMT_Encode4(2338414), // Rule ID 58636 //
     /* 2338365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2338368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2338371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338379 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338379 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2338382 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338386 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338391 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2338396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338398 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338401 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338412 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338413 */   // GIR_Coverage, 58636,
     /* 2338413 */   GIR_EraseRootFromParent_Done,
     /* 2338414 */ // Label 32396: @2338414
     /* 2338414 */ GIM_Try, /*On fail goto*//*Label 32397*/ GIMT_Encode4(2338468), // Rule ID 58637 //
     /* 2338419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2338422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2338425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338433 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338433 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2338436 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338440 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2338450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338455 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338466 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338467 */   // GIR_Coverage, 58637,
     /* 2338467 */   GIR_EraseRootFromParent_Done,
     /* 2338468 */ // Label 32397: @2338468
     /* 2338468 */ GIM_Reject,
     /* 2338469 */ // Label 32345: @2338469
     /* 2338469 */ GIM_Try, /*On fail goto*//*Label 32398*/ GIMT_Encode4(2338526), // Rule ID 58412 //
     /* 2338474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2338480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338488 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338488 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2338491 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338495 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2338505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338510 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338524 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338525 */   // GIR_Coverage, 58412,
     /* 2338525 */   GIR_EraseRootFromParent_Done,
     /* 2338526 */ // Label 32398: @2338526
     /* 2338526 */ GIM_Try, /*On fail goto*//*Label 32399*/ GIMT_Encode4(2338583), // Rule ID 58413 //
     /* 2338531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2338537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338545 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338545 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2338548 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338552 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2338562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338567 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338581 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338582 */   // GIR_Coverage, 58413,
     /* 2338582 */   GIR_EraseRootFromParent_Done,
     /* 2338583 */ // Label 32399: @2338583
     /* 2338583 */ GIM_Try, /*On fail goto*//*Label 32400*/ GIMT_Encode4(2338637), // Rule ID 58596 //
     /* 2338588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2338594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338602 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338602 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2338605 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338609 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2338619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338621 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338624 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338636 */   // GIR_Coverage, 58596,
     /* 2338636 */   GIR_EraseRootFromParent_Done,
     /* 2338637 */ // Label 32400: @2338637
     /* 2338637 */ GIM_Try, /*On fail goto*//*Label 32401*/ GIMT_Encode4(2338691), // Rule ID 58597 //
     /* 2338642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2338648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338656 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338656 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2338659 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338663 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2338673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338675 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338678 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338689 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338690 */   // GIR_Coverage, 58597,
     /* 2338690 */   GIR_EraseRootFromParent_Done,
     /* 2338691 */ // Label 32401: @2338691
     /* 2338691 */ GIM_Try, /*On fail goto*//*Label 32402*/ GIMT_Encode4(2338748), // Rule ID 58828 //
     /* 2338696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2338702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338710 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338710 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2338713 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338717 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2338727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338732 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338746 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338747 */   // GIR_Coverage, 58828,
     /* 2338747 */   GIR_EraseRootFromParent_Done,
     /* 2338748 */ // Label 32402: @2338748
     /* 2338748 */ GIM_Try, /*On fail goto*//*Label 32403*/ GIMT_Encode4(2338805), // Rule ID 58829 //
     /* 2338753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2338759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338767 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338767 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2338770 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338774 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2338784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338786 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338789 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338803 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338804 */   // GIR_Coverage, 58829,
     /* 2338804 */   GIR_EraseRootFromParent_Done,
     /* 2338805 */ // Label 32403: @2338805
     /* 2338805 */ GIM_Reject,
     /* 2338806 */ // Label 32346: @2338806
     /* 2338806 */ GIM_Try, /*On fail goto*//*Label 32404*/ GIMT_Encode4(2338863), // Rule ID 58424 //
     /* 2338811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2338814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2338817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338825 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338825 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2338828 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338832 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2338842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338844 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338847 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338861 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338862 */   // GIR_Coverage, 58424,
     /* 2338862 */   GIR_EraseRootFromParent_Done,
     /* 2338863 */ // Label 32404: @2338863
     /* 2338863 */ GIM_Try, /*On fail goto*//*Label 32405*/ GIMT_Encode4(2338920), // Rule ID 58425 //
     /* 2338868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2338871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2338874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338882 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338882 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2338885 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338889 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2338899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338904 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338919 */   // GIR_Coverage, 58425,
     /* 2338919 */   GIR_EraseRootFromParent_Done,
     /* 2338920 */ // Label 32405: @2338920
     /* 2338920 */ GIM_Try, /*On fail goto*//*Label 32406*/ GIMT_Encode4(2338974), // Rule ID 58620 //
     /* 2338925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2338928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2338931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338939 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338939 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2338942 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338946 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2338956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338961 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338973 */   // GIR_Coverage, 58620,
     /* 2338973 */   GIR_EraseRootFromParent_Done,
     /* 2338974 */ // Label 32406: @2338974
     /* 2338974 */ GIM_Try, /*On fail goto*//*Label 32407*/ GIMT_Encode4(2339028), // Rule ID 58621 //
     /* 2338979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2338982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2338985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338993 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2338996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2339010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339012 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339015 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339026 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339027 */   // GIR_Coverage, 58621,
     /* 2339027 */   GIR_EraseRootFromParent_Done,
     /* 2339028 */ // Label 32407: @2339028
     /* 2339028 */ GIM_Try, /*On fail goto*//*Label 32408*/ GIMT_Encode4(2339085), // Rule ID 58848 //
     /* 2339033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2339036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2339039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339047 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339047 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339054 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2339064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339066 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339069 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339083 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339084 */   // GIR_Coverage, 58848,
     /* 2339084 */   GIR_EraseRootFromParent_Done,
     /* 2339085 */ // Label 32408: @2339085
     /* 2339085 */ GIM_Try, /*On fail goto*//*Label 32409*/ GIMT_Encode4(2339142), // Rule ID 58849 //
     /* 2339090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2339093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2339096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339104 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2339121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339126 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339140 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339141 */   // GIR_Coverage, 58849,
     /* 2339141 */   GIR_EraseRootFromParent_Done,
     /* 2339142 */ // Label 32409: @2339142
     /* 2339142 */ GIM_Reject,
     /* 2339143 */ // Label 32347: @2339143
     /* 2339143 */ GIM_Try, /*On fail goto*//*Label 32410*/ GIMT_Encode4(2339200), // Rule ID 58456 //
     /* 2339148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2339151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2339154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339162 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2339165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339174 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2339179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339181 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339184 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2339195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339199 */   // GIR_Coverage, 58456,
     /* 2339199 */   GIR_EraseRootFromParent_Done,
     /* 2339200 */ // Label 32410: @2339200
     /* 2339200 */ GIM_Try, /*On fail goto*//*Label 32411*/ GIMT_Encode4(2339257), // Rule ID 58457 //
     /* 2339205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2339208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2339211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339219 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339219 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2339222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339226 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2339236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339241 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2339252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339255 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339256 */   // GIR_Coverage, 58457,
     /* 2339256 */   GIR_EraseRootFromParent_Done,
     /* 2339257 */ // Label 32411: @2339257
     /* 2339257 */ GIM_Try, /*On fail goto*//*Label 32412*/ GIMT_Encode4(2339311), // Rule ID 58640 //
     /* 2339262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2339265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339276 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2339279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2339293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339298 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339309 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339310 */   // GIR_Coverage, 58640,
     /* 2339310 */   GIR_EraseRootFromParent_Done,
     /* 2339311 */ // Label 32412: @2339311
     /* 2339311 */ GIM_Try, /*On fail goto*//*Label 32413*/ GIMT_Encode4(2339365), // Rule ID 58641 //
     /* 2339316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2339319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339330 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2339333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339342 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2339347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339349 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339352 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339363 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339364 */   // GIR_Coverage, 58641,
     /* 2339364 */   GIR_EraseRootFromParent_Done,
     /* 2339365 */ // Label 32413: @2339365
     /* 2339365 */ GIM_Reject,
     /* 2339366 */ // Label 32348: @2339366
     /* 2339366 */ GIM_Try, /*On fail goto*//*Label 32414*/ GIMT_Encode4(2339423), // Rule ID 58420 //
     /* 2339371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2339377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339385 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2339388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2339402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339404 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339407 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339421 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339422 */   // GIR_Coverage, 58420,
     /* 2339422 */   GIR_EraseRootFromParent_Done,
     /* 2339423 */ // Label 32414: @2339423
     /* 2339423 */ GIM_Try, /*On fail goto*//*Label 32415*/ GIMT_Encode4(2339480), // Rule ID 58421 //
     /* 2339428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2339434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339442 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2339445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2339459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339464 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339478 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339479 */   // GIR_Coverage, 58421,
     /* 2339479 */   GIR_EraseRootFromParent_Done,
     /* 2339480 */ // Label 32415: @2339480
     /* 2339480 */ GIM_Try, /*On fail goto*//*Label 32416*/ GIMT_Encode4(2339534), // Rule ID 58600 //
     /* 2339485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2339491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339499 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2339502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2339516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339518 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339521 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339533 */   // GIR_Coverage, 58600,
     /* 2339533 */   GIR_EraseRootFromParent_Done,
     /* 2339534 */ // Label 32416: @2339534
     /* 2339534 */ GIM_Try, /*On fail goto*//*Label 32417*/ GIMT_Encode4(2339588), // Rule ID 58601 //
     /* 2339539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2339545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339553 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339553 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2339556 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339560 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2339570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339575 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339586 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339587 */   // GIR_Coverage, 58601,
     /* 2339587 */   GIR_EraseRootFromParent_Done,
     /* 2339588 */ // Label 32417: @2339588
     /* 2339588 */ GIM_Try, /*On fail goto*//*Label 32418*/ GIMT_Encode4(2339645), // Rule ID 58832 //
     /* 2339593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2339599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339607 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339607 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2339610 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339614 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2339624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339629 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339643 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339644 */   // GIR_Coverage, 58832,
     /* 2339644 */   GIR_EraseRootFromParent_Done,
     /* 2339645 */ // Label 32418: @2339645
     /* 2339645 */ GIM_Try, /*On fail goto*//*Label 32419*/ GIMT_Encode4(2339702), // Rule ID 58833 //
     /* 2339650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2339656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339664 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2339667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2339681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339683 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339686 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339700 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339701 */   // GIR_Coverage, 58833,
     /* 2339701 */   GIR_EraseRootFromParent_Done,
     /* 2339702 */ // Label 32419: @2339702
     /* 2339702 */ GIM_Reject,
     /* 2339703 */ // Label 32349: @2339703
     /* 2339703 */ GIM_Try, /*On fail goto*//*Label 32420*/ GIMT_Encode4(2339760), // Rule ID 58444 //
     /* 2339708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2339711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2339714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339722 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339722 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2339725 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339729 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2339739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339744 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339758 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339759 */   // GIR_Coverage, 58444,
     /* 2339759 */   GIR_EraseRootFromParent_Done,
     /* 2339760 */ // Label 32420: @2339760
     /* 2339760 */ GIM_Try, /*On fail goto*//*Label 32421*/ GIMT_Encode4(2339817), // Rule ID 58445 //
     /* 2339765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2339768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2339771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339779 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2339782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2339796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339801 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339816 */   // GIR_Coverage, 58445,
     /* 2339816 */   GIR_EraseRootFromParent_Done,
     /* 2339817 */ // Label 32421: @2339817
     /* 2339817 */ GIM_Try, /*On fail goto*//*Label 32422*/ GIMT_Encode4(2339871), // Rule ID 58624 //
     /* 2339822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2339825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2339828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339836 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2339839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2339853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339858 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339869 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339870 */   // GIR_Coverage, 58624,
     /* 2339870 */   GIR_EraseRootFromParent_Done,
     /* 2339871 */ // Label 32422: @2339871
     /* 2339871 */ GIM_Try, /*On fail goto*//*Label 32423*/ GIMT_Encode4(2339925), // Rule ID 58625 //
     /* 2339876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2339879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2339882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339890 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2339893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2339907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339912 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339924 */   // GIR_Coverage, 58625,
     /* 2339924 */   GIR_EraseRootFromParent_Done,
     /* 2339925 */ // Label 32423: @2339925
     /* 2339925 */ GIM_Try, /*On fail goto*//*Label 32424*/ GIMT_Encode4(2339982), // Rule ID 58852 //
     /* 2339930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2339933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2339936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2339944 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2339947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2339961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339963 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339966 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339980 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339981 */   // GIR_Coverage, 58852,
     /* 2339981 */   GIR_EraseRootFromParent_Done,
     /* 2339982 */ // Label 32424: @2339982
     /* 2339982 */ GIM_Try, /*On fail goto*//*Label 32425*/ GIMT_Encode4(2340039), // Rule ID 58853 //
     /* 2339987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2339990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2339993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340001 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340001 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340004 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340008 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2340018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340023 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340038 */   // GIR_Coverage, 58853,
     /* 2340038 */   GIR_EraseRootFromParent_Done,
     /* 2340039 */ // Label 32425: @2340039
     /* 2340039 */ GIM_Reject,
     /* 2340040 */ // Label 32350: @2340040
     /* 2340040 */ GIM_Try, /*On fail goto*//*Label 32426*/ GIMT_Encode4(2340097), // Rule ID 58460 //
     /* 2340045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2340048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2340051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340059 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2340062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340071 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2340076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340081 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340095 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340096 */   // GIR_Coverage, 58460,
     /* 2340096 */   GIR_EraseRootFromParent_Done,
     /* 2340097 */ // Label 32426: @2340097
     /* 2340097 */ GIM_Try, /*On fail goto*//*Label 32427*/ GIMT_Encode4(2340154), // Rule ID 58461 //
     /* 2340102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2340105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2340108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340116 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340116 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2340119 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340123 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340128 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2340133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340138 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340152 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340153 */   // GIR_Coverage, 58461,
     /* 2340153 */   GIR_EraseRootFromParent_Done,
     /* 2340154 */ // Label 32427: @2340154
     /* 2340154 */ GIM_Try, /*On fail goto*//*Label 32428*/ GIMT_Encode4(2340208), // Rule ID 58644 //
     /* 2340159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2340162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340173 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340173 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2340176 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340180 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2340190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340192 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340195 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340207 */   // GIR_Coverage, 58644,
     /* 2340207 */   GIR_EraseRootFromParent_Done,
     /* 2340208 */ // Label 32428: @2340208
     /* 2340208 */ GIM_Try, /*On fail goto*//*Label 32429*/ GIMT_Encode4(2340262), // Rule ID 58645 //
     /* 2340213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2340216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340227 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2340230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2340244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340246 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340249 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340260 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340261 */   // GIR_Coverage, 58645,
     /* 2340261 */   GIR_EraseRootFromParent_Done,
     /* 2340262 */ // Label 32429: @2340262
     /* 2340262 */ GIM_Reject,
     /* 2340263 */ // Label 32351: @2340263
     /* 2340263 */ GIM_Try, /*On fail goto*//*Label 32430*/ GIMT_Encode4(2340320), // Rule ID 58432 //
     /* 2340268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2340274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340282 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2340285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2340299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340304 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340319 */   // GIR_Coverage, 58432,
     /* 2340319 */   GIR_EraseRootFromParent_Done,
     /* 2340320 */ // Label 32430: @2340320
     /* 2340320 */ GIM_Try, /*On fail goto*//*Label 32431*/ GIMT_Encode4(2340377), // Rule ID 58433 //
     /* 2340325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2340331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340339 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2340342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2340356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340361 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340375 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340376 */   // GIR_Coverage, 58433,
     /* 2340376 */   GIR_EraseRootFromParent_Done,
     /* 2340377 */ // Label 32431: @2340377
     /* 2340377 */ GIM_Try, /*On fail goto*//*Label 32432*/ GIMT_Encode4(2340431), // Rule ID 58604 //
     /* 2340382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2340388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340396 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340396 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2340399 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340403 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2340413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340415 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340418 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340429 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340430 */   // GIR_Coverage, 58604,
     /* 2340430 */   GIR_EraseRootFromParent_Done,
     /* 2340431 */ // Label 32432: @2340431
     /* 2340431 */ GIM_Try, /*On fail goto*//*Label 32433*/ GIMT_Encode4(2340485), // Rule ID 58605 //
     /* 2340436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2340442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340450 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2340453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2340467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340469 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340472 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340483 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340484 */   // GIR_Coverage, 58605,
     /* 2340484 */   GIR_EraseRootFromParent_Done,
     /* 2340485 */ // Label 32433: @2340485
     /* 2340485 */ GIM_Try, /*On fail goto*//*Label 32434*/ GIMT_Encode4(2340542), // Rule ID 58836 //
     /* 2340490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2340496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340504 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340504 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2340507 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340511 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2340521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340526 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340540 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340541 */   // GIR_Coverage, 58836,
     /* 2340541 */   GIR_EraseRootFromParent_Done,
     /* 2340542 */ // Label 32434: @2340542
     /* 2340542 */ GIM_Try, /*On fail goto*//*Label 32435*/ GIMT_Encode4(2340599), // Rule ID 58837 //
     /* 2340547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2340553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340561 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340561 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2340564 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340568 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2340578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340580 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340583 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340597 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340598 */   // GIR_Coverage, 58837,
     /* 2340598 */   GIR_EraseRootFromParent_Done,
     /* 2340599 */ // Label 32435: @2340599
     /* 2340599 */ GIM_Reject,
     /* 2340600 */ // Label 32352: @2340600
     /* 2340600 */ GIM_Try, /*On fail goto*//*Label 32436*/ GIMT_Encode4(2340657), // Rule ID 58448 //
     /* 2340605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2340608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2340611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340619 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340619 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2340622 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340626 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2340636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340638 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340641 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340656 */   // GIR_Coverage, 58448,
     /* 2340656 */   GIR_EraseRootFromParent_Done,
     /* 2340657 */ // Label 32436: @2340657
     /* 2340657 */ GIM_Try, /*On fail goto*//*Label 32437*/ GIMT_Encode4(2340714), // Rule ID 58449 //
     /* 2340662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2340665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2340668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340676 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340676 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2340679 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340683 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2340693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340698 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340712 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340713 */   // GIR_Coverage, 58449,
     /* 2340713 */   GIR_EraseRootFromParent_Done,
     /* 2340714 */ // Label 32437: @2340714
     /* 2340714 */ GIM_Try, /*On fail goto*//*Label 32438*/ GIMT_Encode4(2340768), // Rule ID 58628 //
     /* 2340719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2340722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2340725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340733 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2340736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2340750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340755 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340767 */   // GIR_Coverage, 58628,
     /* 2340767 */   GIR_EraseRootFromParent_Done,
     /* 2340768 */ // Label 32438: @2340768
     /* 2340768 */ GIM_Try, /*On fail goto*//*Label 32439*/ GIMT_Encode4(2340822), // Rule ID 58629 //
     /* 2340773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2340776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2340779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340787 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2340790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2340804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340806 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340809 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340820 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340821 */   // GIR_Coverage, 58629,
     /* 2340821 */   GIR_EraseRootFromParent_Done,
     /* 2340822 */ // Label 32439: @2340822
     /* 2340822 */ GIM_Try, /*On fail goto*//*Label 32440*/ GIMT_Encode4(2340879), // Rule ID 58856 //
     /* 2340827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2340830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2340833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2340841 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340841 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2340844 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340848 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2340858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340860 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340863 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340877 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340878 */   // GIR_Coverage, 58856,
     /* 2340878 */   GIR_EraseRootFromParent_Done,
     /* 2340879 */ // Label 32440: @2340879
     /* 2340879 */ GIM_Try, /*On fail goto*//*Label 32441*/ GIMT_Encode4(2340936), // Rule ID 58857 //
     /* 2340884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2340887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2340890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2340898 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2340901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2340915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340920 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340935 */   // GIR_Coverage, 58857,
     /* 2340935 */   GIR_EraseRootFromParent_Done,
     /* 2340936 */ // Label 32441: @2340936
     /* 2340936 */ GIM_Reject,
     /* 2340937 */ // Label 32353: @2340937
     /* 2340937 */ GIM_Try, /*On fail goto*//*Label 32442*/ GIMT_Encode4(2340994), // Rule ID 58464 //
     /* 2340942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2340945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2340948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2340952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2340956 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2340959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2340973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340978 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340992 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340993 */   // GIR_Coverage, 58464,
     /* 2340993 */   GIR_EraseRootFromParent_Done,
     /* 2340994 */ // Label 32442: @2340994
     /* 2340994 */ GIM_Try, /*On fail goto*//*Label 32443*/ GIMT_Encode4(2341051), // Rule ID 58465 //
     /* 2340999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2341002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2341005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341013 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341013 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2341016 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341020 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2341030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341032 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341035 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341049 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341050 */   // GIR_Coverage, 58465,
     /* 2341050 */   GIR_EraseRootFromParent_Done,
     /* 2341051 */ // Label 32443: @2341051
     /* 2341051 */ GIM_Try, /*On fail goto*//*Label 32444*/ GIMT_Encode4(2341105), // Rule ID 58648 //
     /* 2341056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2341059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2341062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341070 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341070 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2341073 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341077 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2341087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341092 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341104 */   // GIR_Coverage, 58648,
     /* 2341104 */   GIR_EraseRootFromParent_Done,
     /* 2341105 */ // Label 32444: @2341105
     /* 2341105 */ GIM_Try, /*On fail goto*//*Label 32445*/ GIMT_Encode4(2341159), // Rule ID 58649 //
     /* 2341110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2341113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2341116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341124 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2341127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2341141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341146 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341157 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341158 */   // GIR_Coverage, 58649,
     /* 2341158 */   GIR_EraseRootFromParent_Done,
     /* 2341159 */ // Label 32445: @2341159
     /* 2341159 */ GIM_Reject,
     /* 2341160 */ // Label 32354: @2341160
     /* 2341160 */ GIM_Try, /*On fail goto*//*Label 32446*/ GIMT_Encode4(2341217), // Rule ID 58436 //
     /* 2341165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2341171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341179 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341191 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2341196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341198 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341201 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341215 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341216 */   // GIR_Coverage, 58436,
     /* 2341216 */   GIR_EraseRootFromParent_Done,
     /* 2341217 */ // Label 32446: @2341217
     /* 2341217 */ GIM_Try, /*On fail goto*//*Label 32447*/ GIMT_Encode4(2341274), // Rule ID 58437 //
     /* 2341222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2341228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341236 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2341253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341258 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341272 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341273 */   // GIR_Coverage, 58437,
     /* 2341273 */   GIR_EraseRootFromParent_Done,
     /* 2341274 */ // Label 32447: @2341274
     /* 2341274 */ GIM_Try, /*On fail goto*//*Label 32448*/ GIMT_Encode4(2341328), // Rule ID 58608 //
     /* 2341279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2341285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341293 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2341310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341315 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341326 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341327 */   // GIR_Coverage, 58608,
     /* 2341327 */   GIR_EraseRootFromParent_Done,
     /* 2341328 */ // Label 32448: @2341328
     /* 2341328 */ GIM_Try, /*On fail goto*//*Label 32449*/ GIMT_Encode4(2341382), // Rule ID 58609 //
     /* 2341333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2341339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341347 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341347 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341350 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341354 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2341364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341366 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341369 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341380 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341381 */   // GIR_Coverage, 58609,
     /* 2341381 */   GIR_EraseRootFromParent_Done,
     /* 2341382 */ // Label 32449: @2341382
     /* 2341382 */ GIM_Try, /*On fail goto*//*Label 32450*/ GIMT_Encode4(2341439), // Rule ID 58840 //
     /* 2341387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341401 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341401 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341404 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341408 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341413 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2341418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341420 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341423 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341437 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341438 */   // GIR_Coverage, 58840,
     /* 2341438 */   GIR_EraseRootFromParent_Done,
     /* 2341439 */ // Label 32450: @2341439
     /* 2341439 */ GIM_Try, /*On fail goto*//*Label 32451*/ GIMT_Encode4(2341496), // Rule ID 58841 //
     /* 2341444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341458 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2341475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341480 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341494 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341495 */   // GIR_Coverage, 58841,
     /* 2341495 */   GIR_EraseRootFromParent_Done,
     /* 2341496 */ // Label 32451: @2341496
     /* 2341496 */ GIM_Reject,
     /* 2341497 */ // Label 32355: @2341497
     /* 2341497 */ GIM_Try, /*On fail goto*//*Label 32452*/ GIMT_Encode4(2341554), // Rule ID 58452 //
     /* 2341502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2341505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341516 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341516 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2341519 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341523 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341528 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2341533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341538 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341552 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341553 */   // GIR_Coverage, 58452,
     /* 2341553 */   GIR_EraseRootFromParent_Done,
     /* 2341554 */ // Label 32452: @2341554
     /* 2341554 */ GIM_Try, /*On fail goto*//*Label 32453*/ GIMT_Encode4(2341611), // Rule ID 58453 //
     /* 2341559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2341562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341573 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2341576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2341590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341595 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341609 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341610 */   // GIR_Coverage, 58453,
     /* 2341610 */   GIR_EraseRootFromParent_Done,
     /* 2341611 */ // Label 32453: @2341611
     /* 2341611 */ GIM_Try, /*On fail goto*//*Label 32454*/ GIMT_Encode4(2341665), // Rule ID 58632 //
     /* 2341616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2341619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2341622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341630 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341630 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2341633 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341637 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2341647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341649 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341652 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341663 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341664 */   // GIR_Coverage, 58632,
     /* 2341664 */   GIR_EraseRootFromParent_Done,
     /* 2341665 */ // Label 32454: @2341665
     /* 2341665 */ GIM_Try, /*On fail goto*//*Label 32455*/ GIMT_Encode4(2341719), // Rule ID 58633 //
     /* 2341670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2341673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2341676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341684 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341684 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2341687 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341691 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2341701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341703 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341706 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341717 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341718 */   // GIR_Coverage, 58633,
     /* 2341718 */   GIR_EraseRootFromParent_Done,
     /* 2341719 */ // Label 32455: @2341719
     /* 2341719 */ GIM_Reject,
     /* 2341720 */ // Label 32356: @2341720
     /* 2341720 */ GIM_Try, /*On fail goto*//*Label 32456*/ GIMT_Encode4(2341777), // Rule ID 58440 //
     /* 2341725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2341731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341739 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2341742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2341756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341761 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341775 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341776 */   // GIR_Coverage, 58440,
     /* 2341776 */   GIR_EraseRootFromParent_Done,
     /* 2341777 */ // Label 32456: @2341777
     /* 2341777 */ GIM_Try, /*On fail goto*//*Label 32457*/ GIMT_Encode4(2341834), // Rule ID 58441 //
     /* 2341782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2341788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341796 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2341799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2341813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341815 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341818 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341833 */   // GIR_Coverage, 58441,
     /* 2341833 */   GIR_EraseRootFromParent_Done,
     /* 2341834 */ // Label 32457: @2341834
     /* 2341834 */ GIM_Try, /*On fail goto*//*Label 32458*/ GIMT_Encode4(2341888), // Rule ID 58612 //
     /* 2341839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2341845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341853 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2341856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2341870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341875 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341887 */   // GIR_Coverage, 58612,
     /* 2341887 */   GIR_EraseRootFromParent_Done,
     /* 2341888 */ // Label 32458: @2341888
     /* 2341888 */ GIM_Try, /*On fail goto*//*Label 32459*/ GIMT_Encode4(2341942), // Rule ID 58613 //
     /* 2341893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2341899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341907 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2341910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2341924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341929 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341940 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341941 */   // GIR_Coverage, 58613,
     /* 2341941 */   GIR_EraseRootFromParent_Done,
     /* 2341942 */ // Label 32459: @2341942
     /* 2341942 */ GIM_Reject,
     /* 2341943 */ // Label 32357: @2341943
     /* 2341943 */ GIM_Reject,
     /* 2341944 */ // Label 70: @2341944
     /* 2341944 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32478*/ GIMT_Encode4(2347229),
     /* 2341955 */ /*GILLT_s16*//*Label 32460*/ GIMT_Encode4(2342075),
     /* 2341959 */ /*GILLT_s32*//*Label 32461*/ GIMT_Encode4(2342336),
     /* 2341963 */ /*GILLT_s64*//*Label 32462*/ GIMT_Encode4(2342597), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341975 */ /*GILLT_nxv1s16*//*Label 32463*/ GIMT_Encode4(2342858),
     /* 2341979 */ /*GILLT_nxv1s32*//*Label 32464*/ GIMT_Encode4(2343195),
     /* 2341983 */ /*GILLT_nxv1s64*//*Label 32465*/ GIMT_Encode4(2343532), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341995 */ /*GILLT_nxv2s16*//*Label 32466*/ GIMT_Encode4(2343755),
     /* 2341999 */ /*GILLT_nxv2s32*//*Label 32467*/ GIMT_Encode4(2344092),
     /* 2342003 */ /*GILLT_nxv2s64*//*Label 32468*/ GIMT_Encode4(2344429), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342015 */ /*GILLT_nxv4s16*//*Label 32469*/ GIMT_Encode4(2344652),
     /* 2342019 */ /*GILLT_nxv4s32*//*Label 32470*/ GIMT_Encode4(2344989),
     /* 2342023 */ /*GILLT_nxv4s64*//*Label 32471*/ GIMT_Encode4(2345326), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342035 */ /*GILLT_nxv8s16*//*Label 32472*/ GIMT_Encode4(2345549),
     /* 2342039 */ /*GILLT_nxv8s32*//*Label 32473*/ GIMT_Encode4(2345886),
     /* 2342043 */ /*GILLT_nxv8s64*//*Label 32474*/ GIMT_Encode4(2346223), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342055 */ /*GILLT_nxv16s16*//*Label 32475*/ GIMT_Encode4(2346446),
     /* 2342059 */ /*GILLT_nxv16s32*//*Label 32476*/ GIMT_Encode4(2346783), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342071 */ /*GILLT_nxv32s16*//*Label 32477*/ GIMT_Encode4(2347006),
     /* 2342075 */ // Label 32460: @2342075
     /* 2342075 */ GIM_Try, /*On fail goto*//*Label 32479*/ GIMT_Encode4(2342112), // Rule ID 2263 //
     /* 2342080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2342083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2342090 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2342097 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2342100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342111 */   // GIR_Coverage, 2263,
     /* 2342111 */   GIR_EraseRootFromParent_Done,
     /* 2342112 */ // Label 32479: @2342112
     /* 2342112 */ GIM_Try, /*On fail goto*//*Label 32480*/ GIMT_Encode4(2342149), // Rule ID 2289 //
     /* 2342117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2342120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342127 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2342134 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2342137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342148 */   // GIR_Coverage, 2289,
     /* 2342148 */   GIR_EraseRootFromParent_Done,
     /* 2342149 */ // Label 32480: @2342149
     /* 2342149 */ GIM_Try, /*On fail goto*//*Label 32481*/ GIMT_Encode4(2342180), // Rule ID 2214 //
     /* 2342154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2342157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2342164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342168 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2342171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342173 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342178 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342179 */   // GIR_Coverage, 2214,
     /* 2342179 */   GIR_EraseRootFromParent_Done,
     /* 2342180 */ // Label 32481: @2342180
     /* 2342180 */ GIM_Try, /*On fail goto*//*Label 32482*/ GIMT_Encode4(2342211), // Rule ID 2215 //
     /* 2342185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2342188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2342195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342199 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2342202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342204 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342209 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342210 */   // GIR_Coverage, 2215,
     /* 2342210 */   GIR_EraseRootFromParent_Done,
     /* 2342211 */ // Label 32482: @2342211
     /* 2342211 */ GIM_Try, /*On fail goto*//*Label 32483*/ GIMT_Encode4(2342242), // Rule ID 2240 //
     /* 2342216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2342219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342230 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2342233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342235 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342240 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342241 */   // GIR_Coverage, 2240,
     /* 2342241 */   GIR_EraseRootFromParent_Done,
     /* 2342242 */ // Label 32483: @2342242
     /* 2342242 */ GIM_Try, /*On fail goto*//*Label 32484*/ GIMT_Encode4(2342273), // Rule ID 2241 //
     /* 2342247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2342250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342261 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2342264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342266 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342271 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342272 */   // GIR_Coverage, 2241,
     /* 2342272 */   GIR_EraseRootFromParent_Done,
     /* 2342273 */ // Label 32484: @2342273
     /* 2342273 */ GIM_Try, /*On fail goto*//*Label 32485*/ GIMT_Encode4(2342304), // Rule ID 2267 //
     /* 2342278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2342281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2342288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342292 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU),
     /* 2342295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342297 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342302 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342303 */   // GIR_Coverage, 2267,
     /* 2342303 */   GIR_EraseRootFromParent_Done,
     /* 2342304 */ // Label 32485: @2342304
     /* 2342304 */ GIM_Try, /*On fail goto*//*Label 32486*/ GIMT_Encode4(2342335), // Rule ID 2293 //
     /* 2342309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2342312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342323 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU_INX),
     /* 2342326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342328 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342333 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342334 */   // GIR_Coverage, 2293,
     /* 2342334 */   GIR_EraseRootFromParent_Done,
     /* 2342335 */ // Label 32486: @2342335
     /* 2342335 */ GIM_Reject,
     /* 2342336 */ // Label 32461: @2342336
     /* 2342336 */ GIM_Try, /*On fail goto*//*Label 32487*/ GIMT_Encode4(2342373), // Rule ID 1529 //
     /* 2342341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2342344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2342358 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2342361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342371 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342372 */   // GIR_Coverage, 1529,
     /* 2342372 */   GIR_EraseRootFromParent_Done,
     /* 2342373 */ // Label 32487: @2342373
     /* 2342373 */ GIM_Try, /*On fail goto*//*Label 32488*/ GIMT_Encode4(2342410), // Rule ID 1557 //
     /* 2342378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2342381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342388 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2342395 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2342398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342408 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342409 */   // GIR_Coverage, 1557,
     /* 2342409 */   GIR_EraseRootFromParent_Done,
     /* 2342410 */ // Label 32488: @2342410
     /* 2342410 */ GIM_Try, /*On fail goto*//*Label 32489*/ GIMT_Encode4(2342441), // Rule ID 1478 //
     /* 2342415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2342418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342429 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2342432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342434 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342440 */   // GIR_Coverage, 1478,
     /* 2342440 */   GIR_EraseRootFromParent_Done,
     /* 2342441 */ // Label 32489: @2342441
     /* 2342441 */ GIM_Try, /*On fail goto*//*Label 32490*/ GIMT_Encode4(2342472), // Rule ID 1479 //
     /* 2342446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2342449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342460 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2342463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342465 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342470 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342471 */   // GIR_Coverage, 1479,
     /* 2342471 */   GIR_EraseRootFromParent_Done,
     /* 2342472 */ // Label 32490: @2342472
     /* 2342472 */ GIM_Try, /*On fail goto*//*Label 32491*/ GIMT_Encode4(2342503), // Rule ID 1504 //
     /* 2342477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2342480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342491 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2342494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342496 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342501 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342502 */   // GIR_Coverage, 1504,
     /* 2342502 */   GIR_EraseRootFromParent_Done,
     /* 2342503 */ // Label 32491: @2342503
     /* 2342503 */ GIM_Try, /*On fail goto*//*Label 32492*/ GIMT_Encode4(2342534), // Rule ID 1505 //
     /* 2342508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2342511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342522 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2342525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342527 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342533 */   // GIR_Coverage, 1505,
     /* 2342533 */   GIR_EraseRootFromParent_Done,
     /* 2342534 */ // Label 32492: @2342534
     /* 2342534 */ GIM_Try, /*On fail goto*//*Label 32493*/ GIMT_Encode4(2342565), // Rule ID 1533 //
     /* 2342539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2342542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342553 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU),
     /* 2342556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342558 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342563 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342564 */   // GIR_Coverage, 1533,
     /* 2342564 */   GIR_EraseRootFromParent_Done,
     /* 2342565 */ // Label 32493: @2342565
     /* 2342565 */ GIM_Try, /*On fail goto*//*Label 32494*/ GIMT_Encode4(2342596), // Rule ID 1561 //
     /* 2342570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2342573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342584 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU_INX),
     /* 2342587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342589 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342594 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342595 */   // GIR_Coverage, 1561,
     /* 2342595 */   GIR_EraseRootFromParent_Done,
     /* 2342596 */ // Label 32494: @2342596
     /* 2342596 */ GIM_Reject,
     /* 2342597 */ // Label 32462: @2342597
     /* 2342597 */ GIM_Try, /*On fail goto*//*Label 32495*/ GIMT_Encode4(2342634), // Rule ID 1909 //
     /* 2342602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2342605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2342612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2342619 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2342619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2342622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2342632 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342633 */   // GIR_Coverage, 1909,
     /* 2342633 */   GIR_EraseRootFromParent_Done,
     /* 2342634 */ // Label 32495: @2342634
     /* 2342634 */ GIM_Try, /*On fail goto*//*Label 32496*/ GIMT_Encode4(2342671), // Rule ID 1937 //
     /* 2342639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2342642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342649 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2342656 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2342656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_INX),
     /* 2342659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2342669 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342670 */   // GIR_Coverage, 1937,
     /* 2342670 */   GIR_EraseRootFromParent_Done,
     /* 2342671 */ // Label 32496: @2342671
     /* 2342671 */ GIM_Try, /*On fail goto*//*Label 32497*/ GIMT_Encode4(2342702), // Rule ID 1872 //
     /* 2342676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2342679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2342686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342690 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2342690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2342693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342695 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2342700 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342701 */   // GIR_Coverage, 1872,
     /* 2342701 */   GIR_EraseRootFromParent_Done,
     /* 2342702 */ // Label 32497: @2342702
     /* 2342702 */ GIM_Try, /*On fail goto*//*Label 32498*/ GIMT_Encode4(2342733), // Rule ID 1873 //
     /* 2342707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2342710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2342717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342721 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2342721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2342724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342726 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2342731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342732 */   // GIR_Coverage, 1873,
     /* 2342732 */   GIR_EraseRootFromParent_Done,
     /* 2342733 */ // Label 32498: @2342733
     /* 2342733 */ GIM_Try, /*On fail goto*//*Label 32499*/ GIMT_Encode4(2342764), // Rule ID 1898 //
     /* 2342738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2342741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2342748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342752 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2342752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2342755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342757 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2342762 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342763 */   // GIR_Coverage, 1898,
     /* 2342763 */   GIR_EraseRootFromParent_Done,
     /* 2342764 */ // Label 32499: @2342764
     /* 2342764 */ GIM_Try, /*On fail goto*//*Label 32500*/ GIMT_Encode4(2342795), // Rule ID 1899 //
     /* 2342769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2342772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2342779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342783 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2342783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2342786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342788 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2342793 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342794 */   // GIR_Coverage, 1899,
     /* 2342794 */   GIR_EraseRootFromParent_Done,
     /* 2342795 */ // Label 32500: @2342795
     /* 2342795 */ GIM_Try, /*On fail goto*//*Label 32501*/ GIMT_Encode4(2342826), // Rule ID 1927 //
     /* 2342800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2342803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2342810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342814 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU),
     /* 2342817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342819 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342824 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342825 */   // GIR_Coverage, 1927,
     /* 2342825 */   GIR_EraseRootFromParent_Done,
     /* 2342826 */ // Label 32501: @2342826
     /* 2342826 */ GIM_Try, /*On fail goto*//*Label 32502*/ GIMT_Encode4(2342857), // Rule ID 1955 //
     /* 2342831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2342834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342845 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU_INX),
     /* 2342848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342850 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342855 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342856 */   // GIR_Coverage, 1955,
     /* 2342856 */   GIR_EraseRootFromParent_Done,
     /* 2342857 */ // Label 32502: @2342857
     /* 2342857 */ GIM_Reject,
     /* 2342858 */ // Label 32463: @2342858
     /* 2342858 */ GIM_Try, /*On fail goto*//*Label 32503*/ GIMT_Encode4(2342915), // Rule ID 58468 //
     /* 2342863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2342869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342877 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2342880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2342894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342899 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342913 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342914 */   // GIR_Coverage, 58468,
     /* 2342914 */   GIR_EraseRootFromParent_Done,
     /* 2342915 */ // Label 32503: @2342915
     /* 2342915 */ GIM_Try, /*On fail goto*//*Label 32504*/ GIMT_Encode4(2342972), // Rule ID 58469 //
     /* 2342920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2342923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2342926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342934 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2342937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2342951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342953 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342956 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342970 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342971 */   // GIR_Coverage, 58469,
     /* 2342971 */   GIR_EraseRootFromParent_Done,
     /* 2342972 */ // Label 32504: @2342972
     /* 2342972 */ GIM_Try, /*On fail goto*//*Label 32505*/ GIMT_Encode4(2343026), // Rule ID 58652 //
     /* 2342977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2342983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342991 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342991 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2342994 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342998 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2343008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343013 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343024 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343025 */   // GIR_Coverage, 58652,
     /* 2343025 */   GIR_EraseRootFromParent_Done,
     /* 2343026 */ // Label 32505: @2343026
     /* 2343026 */ GIM_Try, /*On fail goto*//*Label 32506*/ GIMT_Encode4(2343080), // Rule ID 58653 //
     /* 2343031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2343037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343045 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343045 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343048 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343052 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2343062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343064 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343067 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343078 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343079 */   // GIR_Coverage, 58653,
     /* 2343079 */   GIR_EraseRootFromParent_Done,
     /* 2343080 */ // Label 32506: @2343080
     /* 2343080 */ GIM_Try, /*On fail goto*//*Label 32507*/ GIMT_Encode4(2343137), // Rule ID 58860 //
     /* 2343085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343099 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2343116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343121 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343135 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343136 */   // GIR_Coverage, 58860,
     /* 2343136 */   GIR_EraseRootFromParent_Done,
     /* 2343137 */ // Label 32507: @2343137
     /* 2343137 */ GIM_Try, /*On fail goto*//*Label 32508*/ GIMT_Encode4(2343194), // Rule ID 58861 //
     /* 2343142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343156 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343156 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343159 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343163 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2343173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343178 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343192 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343193 */   // GIR_Coverage, 58861,
     /* 2343193 */   GIR_EraseRootFromParent_Done,
     /* 2343194 */ // Label 32508: @2343194
     /* 2343194 */ GIM_Reject,
     /* 2343195 */ // Label 32464: @2343195
     /* 2343195 */ GIM_Try, /*On fail goto*//*Label 32509*/ GIMT_Encode4(2343252), // Rule ID 58476 //
     /* 2343200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2343203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343214 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2343231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343236 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343250 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343251 */   // GIR_Coverage, 58476,
     /* 2343251 */   GIR_EraseRootFromParent_Done,
     /* 2343252 */ // Label 32509: @2343252
     /* 2343252 */ GIM_Try, /*On fail goto*//*Label 32510*/ GIMT_Encode4(2343309), // Rule ID 58477 //
     /* 2343257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2343260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343271 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343271 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343274 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343278 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2343288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343290 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343293 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343308 */   // GIR_Coverage, 58477,
     /* 2343308 */   GIR_EraseRootFromParent_Done,
     /* 2343309 */ // Label 32510: @2343309
     /* 2343309 */ GIM_Try, /*On fail goto*//*Label 32511*/ GIMT_Encode4(2343363), // Rule ID 58676 //
     /* 2343314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2343317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2343320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343328 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2343345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343350 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343361 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343362 */   // GIR_Coverage, 58676,
     /* 2343362 */   GIR_EraseRootFromParent_Done,
     /* 2343363 */ // Label 32511: @2343363
     /* 2343363 */ GIM_Try, /*On fail goto*//*Label 32512*/ GIMT_Encode4(2343417), // Rule ID 58677 //
     /* 2343368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2343371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2343374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343382 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2343399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343404 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343416 */   // GIR_Coverage, 58677,
     /* 2343416 */   GIR_EraseRootFromParent_Done,
     /* 2343417 */ // Label 32512: @2343417
     /* 2343417 */ GIM_Try, /*On fail goto*//*Label 32513*/ GIMT_Encode4(2343474), // Rule ID 58880 //
     /* 2343422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2343425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343436 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2343453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343458 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343472 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343473 */   // GIR_Coverage, 58880,
     /* 2343473 */   GIR_EraseRootFromParent_Done,
     /* 2343474 */ // Label 32513: @2343474
     /* 2343474 */ GIM_Try, /*On fail goto*//*Label 32514*/ GIMT_Encode4(2343531), // Rule ID 58881 //
     /* 2343479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2343482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343493 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343493 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343496 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343500 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2343510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343515 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343529 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343530 */   // GIR_Coverage, 58881,
     /* 2343530 */   GIR_EraseRootFromParent_Done,
     /* 2343531 */ // Label 32514: @2343531
     /* 2343531 */ GIM_Reject,
     /* 2343532 */ // Label 32465: @2343532
     /* 2343532 */ GIM_Try, /*On fail goto*//*Label 32515*/ GIMT_Encode4(2343589), // Rule ID 58488 //
     /* 2343537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2343540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343551 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2343554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2343568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343570 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343573 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2343584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343588 */   // GIR_Coverage, 58488,
     /* 2343588 */   GIR_EraseRootFromParent_Done,
     /* 2343589 */ // Label 32515: @2343589
     /* 2343589 */ GIM_Try, /*On fail goto*//*Label 32516*/ GIMT_Encode4(2343646), // Rule ID 58489 //
     /* 2343594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2343597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343608 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343608 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2343611 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343615 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2343625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343627 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343630 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2343641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343644 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343645 */   // GIR_Coverage, 58489,
     /* 2343645 */   GIR_EraseRootFromParent_Done,
     /* 2343646 */ // Label 32516: @2343646
     /* 2343646 */ GIM_Try, /*On fail goto*//*Label 32517*/ GIMT_Encode4(2343700), // Rule ID 58696 //
     /* 2343651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2343654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343665 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343665 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2343668 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343672 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2343682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343687 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343698 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343699 */   // GIR_Coverage, 58696,
     /* 2343699 */   GIR_EraseRootFromParent_Done,
     /* 2343700 */ // Label 32517: @2343700
     /* 2343700 */ GIM_Try, /*On fail goto*//*Label 32518*/ GIMT_Encode4(2343754), // Rule ID 58697 //
     /* 2343705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2343708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343719 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343719 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2343722 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343726 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2343736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343741 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343752 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343753 */   // GIR_Coverage, 58697,
     /* 2343753 */   GIR_EraseRootFromParent_Done,
     /* 2343754 */ // Label 32518: @2343754
     /* 2343754 */ GIM_Reject,
     /* 2343755 */ // Label 32466: @2343755
     /* 2343755 */ GIM_Try, /*On fail goto*//*Label 32519*/ GIMT_Encode4(2343812), // Rule ID 58472 //
     /* 2343760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2343766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343774 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2343777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2343791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343796 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343811 */   // GIR_Coverage, 58472,
     /* 2343811 */   GIR_EraseRootFromParent_Done,
     /* 2343812 */ // Label 32519: @2343812
     /* 2343812 */ GIM_Try, /*On fail goto*//*Label 32520*/ GIMT_Encode4(2343869), // Rule ID 58473 //
     /* 2343817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2343823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343831 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2343834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2343848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343853 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343867 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343868 */   // GIR_Coverage, 58473,
     /* 2343868 */   GIR_EraseRootFromParent_Done,
     /* 2343869 */ // Label 32520: @2343869
     /* 2343869 */ GIM_Try, /*On fail goto*//*Label 32521*/ GIMT_Encode4(2343923), // Rule ID 58656 //
     /* 2343874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2343880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343888 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343888 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2343891 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343895 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2343905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343910 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343921 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343922 */   // GIR_Coverage, 58656,
     /* 2343922 */   GIR_EraseRootFromParent_Done,
     /* 2343923 */ // Label 32521: @2343923
     /* 2343923 */ GIM_Try, /*On fail goto*//*Label 32522*/ GIMT_Encode4(2343977), // Rule ID 58657 //
     /* 2343928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2343934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343942 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343942 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2343945 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343949 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2343959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343964 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343975 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343976 */   // GIR_Coverage, 58657,
     /* 2343976 */   GIR_EraseRootFromParent_Done,
     /* 2343977 */ // Label 32522: @2343977
     /* 2343977 */ GIM_Try, /*On fail goto*//*Label 32523*/ GIMT_Encode4(2344034), // Rule ID 58864 //
     /* 2343982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2343988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343996 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343996 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2343999 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344003 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2344013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344015 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344018 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344032 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344033 */   // GIR_Coverage, 58864,
     /* 2344033 */   GIR_EraseRootFromParent_Done,
     /* 2344034 */ // Label 32523: @2344034
     /* 2344034 */ GIM_Try, /*On fail goto*//*Label 32524*/ GIMT_Encode4(2344091), // Rule ID 58865 //
     /* 2344039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2344042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344053 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344053 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344056 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344060 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2344070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344075 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344089 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344090 */   // GIR_Coverage, 58865,
     /* 2344090 */   GIR_EraseRootFromParent_Done,
     /* 2344091 */ // Label 32524: @2344091
     /* 2344091 */ GIM_Reject,
     /* 2344092 */ // Label 32467: @2344092
     /* 2344092 */ GIM_Try, /*On fail goto*//*Label 32525*/ GIMT_Encode4(2344149), // Rule ID 58484 //
     /* 2344097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2344100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344111 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2344128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344133 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344148 */   // GIR_Coverage, 58484,
     /* 2344148 */   GIR_EraseRootFromParent_Done,
     /* 2344149 */ // Label 32525: @2344149
     /* 2344149 */ GIM_Try, /*On fail goto*//*Label 32526*/ GIMT_Encode4(2344206), // Rule ID 58485 //
     /* 2344154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2344157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344168 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344168 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344171 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344175 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2344185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344187 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344190 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344204 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344205 */   // GIR_Coverage, 58485,
     /* 2344205 */   GIR_EraseRootFromParent_Done,
     /* 2344206 */ // Label 32526: @2344206
     /* 2344206 */ GIM_Try, /*On fail goto*//*Label 32527*/ GIMT_Encode4(2344260), // Rule ID 58680 //
     /* 2344211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2344214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2344217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344225 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344225 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344228 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344232 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2344242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344247 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344258 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344259 */   // GIR_Coverage, 58680,
     /* 2344259 */   GIR_EraseRootFromParent_Done,
     /* 2344260 */ // Label 32527: @2344260
     /* 2344260 */ GIM_Try, /*On fail goto*//*Label 32528*/ GIMT_Encode4(2344314), // Rule ID 58681 //
     /* 2344265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2344268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2344271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344279 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2344296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344301 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344312 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344313 */   // GIR_Coverage, 58681,
     /* 2344313 */   GIR_EraseRootFromParent_Done,
     /* 2344314 */ // Label 32528: @2344314
     /* 2344314 */ GIM_Try, /*On fail goto*//*Label 32529*/ GIMT_Encode4(2344371), // Rule ID 58884 //
     /* 2344319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2344322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344333 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2344350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344355 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344369 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344370 */   // GIR_Coverage, 58884,
     /* 2344370 */   GIR_EraseRootFromParent_Done,
     /* 2344371 */ // Label 32529: @2344371
     /* 2344371 */ GIM_Try, /*On fail goto*//*Label 32530*/ GIMT_Encode4(2344428), // Rule ID 58885 //
     /* 2344376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2344379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344390 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344390 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344393 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344397 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2344407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344412 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344426 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344427 */   // GIR_Coverage, 58885,
     /* 2344427 */   GIR_EraseRootFromParent_Done,
     /* 2344428 */ // Label 32530: @2344428
     /* 2344428 */ GIM_Reject,
     /* 2344429 */ // Label 32468: @2344429
     /* 2344429 */ GIM_Try, /*On fail goto*//*Label 32531*/ GIMT_Encode4(2344486), // Rule ID 58516 //
     /* 2344434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2344437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344448 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344448 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2344451 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344455 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2344465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344467 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344470 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344484 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344485 */   // GIR_Coverage, 58516,
     /* 2344485 */   GIR_EraseRootFromParent_Done,
     /* 2344486 */ // Label 32531: @2344486
     /* 2344486 */ GIM_Try, /*On fail goto*//*Label 32532*/ GIMT_Encode4(2344543), // Rule ID 58517 //
     /* 2344491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2344494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344505 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2344508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2344522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344527 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344541 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344542 */   // GIR_Coverage, 58517,
     /* 2344542 */   GIR_EraseRootFromParent_Done,
     /* 2344543 */ // Label 32532: @2344543
     /* 2344543 */ GIM_Try, /*On fail goto*//*Label 32533*/ GIMT_Encode4(2344597), // Rule ID 58700 //
     /* 2344548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2344551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344562 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344562 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2344565 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344569 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2344579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344584 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344596 */   // GIR_Coverage, 58700,
     /* 2344596 */   GIR_EraseRootFromParent_Done,
     /* 2344597 */ // Label 32533: @2344597
     /* 2344597 */ GIM_Try, /*On fail goto*//*Label 32534*/ GIMT_Encode4(2344651), // Rule ID 58701 //
     /* 2344602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2344605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344616 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2344619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2344633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344638 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344649 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344650 */   // GIR_Coverage, 58701,
     /* 2344650 */   GIR_EraseRootFromParent_Done,
     /* 2344651 */ // Label 32534: @2344651
     /* 2344651 */ GIM_Reject,
     /* 2344652 */ // Label 32469: @2344652
     /* 2344652 */ GIM_Try, /*On fail goto*//*Label 32535*/ GIMT_Encode4(2344709), // Rule ID 58480 //
     /* 2344657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2344660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2344663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344671 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344671 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2344674 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344678 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2344688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344690 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344693 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344708 */   // GIR_Coverage, 58480,
     /* 2344708 */   GIR_EraseRootFromParent_Done,
     /* 2344709 */ // Label 32535: @2344709
     /* 2344709 */ GIM_Try, /*On fail goto*//*Label 32536*/ GIMT_Encode4(2344766), // Rule ID 58481 //
     /* 2344714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2344717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2344720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344728 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2344731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2344745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344750 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344764 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344765 */   // GIR_Coverage, 58481,
     /* 2344765 */   GIR_EraseRootFromParent_Done,
     /* 2344766 */ // Label 32536: @2344766
     /* 2344766 */ GIM_Try, /*On fail goto*//*Label 32537*/ GIMT_Encode4(2344820), // Rule ID 58660 //
     /* 2344771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2344774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2344777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344785 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2344788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2344802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344807 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344818 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344819 */   // GIR_Coverage, 58660,
     /* 2344819 */   GIR_EraseRootFromParent_Done,
     /* 2344820 */ // Label 32537: @2344820
     /* 2344820 */ GIM_Try, /*On fail goto*//*Label 32538*/ GIMT_Encode4(2344874), // Rule ID 58661 //
     /* 2344825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2344828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2344831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344839 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344839 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2344842 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344846 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2344856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344861 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344872 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344873 */   // GIR_Coverage, 58661,
     /* 2344873 */   GIR_EraseRootFromParent_Done,
     /* 2344874 */ // Label 32538: @2344874
     /* 2344874 */ GIM_Try, /*On fail goto*//*Label 32539*/ GIMT_Encode4(2344931), // Rule ID 58868 //
     /* 2344879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2344882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2344885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344893 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2344896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2344910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344912 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344915 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344929 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344930 */   // GIR_Coverage, 58868,
     /* 2344930 */   GIR_EraseRootFromParent_Done,
     /* 2344931 */ // Label 32539: @2344931
     /* 2344931 */ GIM_Try, /*On fail goto*//*Label 32540*/ GIMT_Encode4(2344988), // Rule ID 58869 //
     /* 2344936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2344939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2344942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344950 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344950 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2344953 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344957 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2344967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344972 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344987 */   // GIR_Coverage, 58869,
     /* 2344987 */   GIR_EraseRootFromParent_Done,
     /* 2344988 */ // Label 32540: @2344988
     /* 2344988 */ GIM_Reject,
     /* 2344989 */ // Label 32470: @2344989
     /* 2344989 */ GIM_Try, /*On fail goto*//*Label 32541*/ GIMT_Encode4(2345046), // Rule ID 58504 //
     /* 2344994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2344997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345008 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345008 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345011 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345015 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2345025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345030 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345044 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345045 */   // GIR_Coverage, 58504,
     /* 2345045 */   GIR_EraseRootFromParent_Done,
     /* 2345046 */ // Label 32541: @2345046
     /* 2345046 */ GIM_Try, /*On fail goto*//*Label 32542*/ GIMT_Encode4(2345103), // Rule ID 58505 //
     /* 2345051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2345054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345065 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345065 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345068 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345072 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2345082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345084 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345087 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345101 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345102 */   // GIR_Coverage, 58505,
     /* 2345102 */   GIR_EraseRootFromParent_Done,
     /* 2345103 */ // Label 32542: @2345103
     /* 2345103 */ GIM_Try, /*On fail goto*//*Label 32543*/ GIMT_Encode4(2345157), // Rule ID 58684 //
     /* 2345108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2345111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2345114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345122 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345122 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345125 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345129 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2345139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345144 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345156 */   // GIR_Coverage, 58684,
     /* 2345156 */   GIR_EraseRootFromParent_Done,
     /* 2345157 */ // Label 32543: @2345157
     /* 2345157 */ GIM_Try, /*On fail goto*//*Label 32544*/ GIMT_Encode4(2345211), // Rule ID 58685 //
     /* 2345162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2345165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2345168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345176 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2345193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345198 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345209 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345210 */   // GIR_Coverage, 58685,
     /* 2345210 */   GIR_EraseRootFromParent_Done,
     /* 2345211 */ // Label 32544: @2345211
     /* 2345211 */ GIM_Try, /*On fail goto*//*Label 32545*/ GIMT_Encode4(2345268), // Rule ID 58888 //
     /* 2345216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2345219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345230 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2345247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345249 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345252 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345266 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345267 */   // GIR_Coverage, 58888,
     /* 2345267 */   GIR_EraseRootFromParent_Done,
     /* 2345268 */ // Label 32545: @2345268
     /* 2345268 */ GIM_Try, /*On fail goto*//*Label 32546*/ GIMT_Encode4(2345325), // Rule ID 58889 //
     /* 2345273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2345276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345287 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345287 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345290 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345294 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2345304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345306 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345309 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345324 */   // GIR_Coverage, 58889,
     /* 2345324 */   GIR_EraseRootFromParent_Done,
     /* 2345325 */ // Label 32546: @2345325
     /* 2345325 */ GIM_Reject,
     /* 2345326 */ // Label 32471: @2345326
     /* 2345326 */ GIM_Try, /*On fail goto*//*Label 32547*/ GIMT_Encode4(2345383), // Rule ID 58520 //
     /* 2345331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2345334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345345 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345345 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345348 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345352 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2345362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345364 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345367 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345381 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345382 */   // GIR_Coverage, 58520,
     /* 2345382 */   GIR_EraseRootFromParent_Done,
     /* 2345383 */ // Label 32547: @2345383
     /* 2345383 */ GIM_Try, /*On fail goto*//*Label 32548*/ GIMT_Encode4(2345440), // Rule ID 58521 //
     /* 2345388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2345391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345402 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345402 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345405 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345409 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2345419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345424 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345439 */   // GIR_Coverage, 58521,
     /* 2345439 */   GIR_EraseRootFromParent_Done,
     /* 2345440 */ // Label 32548: @2345440
     /* 2345440 */ GIM_Try, /*On fail goto*//*Label 32549*/ GIMT_Encode4(2345494), // Rule ID 58704 //
     /* 2345445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2345448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345459 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2345476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345478 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345481 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345493 */   // GIR_Coverage, 58704,
     /* 2345493 */   GIR_EraseRootFromParent_Done,
     /* 2345494 */ // Label 32549: @2345494
     /* 2345494 */ GIM_Try, /*On fail goto*//*Label 32550*/ GIMT_Encode4(2345548), // Rule ID 58705 //
     /* 2345499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2345502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345513 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2345530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345535 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345546 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345547 */   // GIR_Coverage, 58705,
     /* 2345547 */   GIR_EraseRootFromParent_Done,
     /* 2345548 */ // Label 32550: @2345548
     /* 2345548 */ GIM_Reject,
     /* 2345549 */ // Label 32472: @2345549
     /* 2345549 */ GIM_Try, /*On fail goto*//*Label 32551*/ GIMT_Encode4(2345606), // Rule ID 58492 //
     /* 2345554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2345560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345568 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2345585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345590 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345604 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345605 */   // GIR_Coverage, 58492,
     /* 2345605 */   GIR_EraseRootFromParent_Done,
     /* 2345606 */ // Label 32551: @2345606
     /* 2345606 */ GIM_Try, /*On fail goto*//*Label 32552*/ GIMT_Encode4(2345663), // Rule ID 58493 //
     /* 2345611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2345617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345625 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345625 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345628 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345632 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2345642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345647 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345662 */   // GIR_Coverage, 58493,
     /* 2345662 */   GIR_EraseRootFromParent_Done,
     /* 2345663 */ // Label 32552: @2345663
     /* 2345663 */ GIM_Try, /*On fail goto*//*Label 32553*/ GIMT_Encode4(2345717), // Rule ID 58664 //
     /* 2345668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2345674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345682 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2345699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345704 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345716 */   // GIR_Coverage, 58664,
     /* 2345716 */   GIR_EraseRootFromParent_Done,
     /* 2345717 */ // Label 32553: @2345717
     /* 2345717 */ GIM_Try, /*On fail goto*//*Label 32554*/ GIMT_Encode4(2345771), // Rule ID 58665 //
     /* 2345722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2345728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345736 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345736 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345739 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345743 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2345753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345758 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345769 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345770 */   // GIR_Coverage, 58665,
     /* 2345770 */   GIR_EraseRootFromParent_Done,
     /* 2345771 */ // Label 32554: @2345771
     /* 2345771 */ GIM_Try, /*On fail goto*//*Label 32555*/ GIMT_Encode4(2345828), // Rule ID 58872 //
     /* 2345776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2345782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345790 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2345807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345812 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345826 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345827 */   // GIR_Coverage, 58872,
     /* 2345827 */   GIR_EraseRootFromParent_Done,
     /* 2345828 */ // Label 32555: @2345828
     /* 2345828 */ GIM_Try, /*On fail goto*//*Label 32556*/ GIMT_Encode4(2345885), // Rule ID 58873 //
     /* 2345833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2345839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345847 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345847 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345850 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345854 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2345864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345869 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345883 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345884 */   // GIR_Coverage, 58873,
     /* 2345884 */   GIR_EraseRootFromParent_Done,
     /* 2345885 */ // Label 32556: @2345885
     /* 2345885 */ GIM_Reject,
     /* 2345886 */ // Label 32473: @2345886
     /* 2345886 */ GIM_Try, /*On fail goto*//*Label 32557*/ GIMT_Encode4(2345943), // Rule ID 58508 //
     /* 2345891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2345894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2345897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345905 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345905 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2345908 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345912 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2345922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345924 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345927 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345941 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345942 */   // GIR_Coverage, 58508,
     /* 2345942 */   GIR_EraseRootFromParent_Done,
     /* 2345943 */ // Label 32557: @2345943
     /* 2345943 */ GIM_Try, /*On fail goto*//*Label 32558*/ GIMT_Encode4(2346000), // Rule ID 58509 //
     /* 2345948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2345951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2345954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345962 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345962 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2345965 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345969 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2345979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345981 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345984 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345999 */   // GIR_Coverage, 58509,
     /* 2345999 */   GIR_EraseRootFromParent_Done,
     /* 2346000 */ // Label 32558: @2346000
     /* 2346000 */ GIM_Try, /*On fail goto*//*Label 32559*/ GIMT_Encode4(2346054), // Rule ID 58688 //
     /* 2346005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2346008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2346011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346019 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2346036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346041 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346053 */   // GIR_Coverage, 58688,
     /* 2346053 */   GIR_EraseRootFromParent_Done,
     /* 2346054 */ // Label 32559: @2346054
     /* 2346054 */ GIM_Try, /*On fail goto*//*Label 32560*/ GIMT_Encode4(2346108), // Rule ID 58689 //
     /* 2346059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2346062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2346065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346073 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346073 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346076 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346080 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2346090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346095 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346107 */   // GIR_Coverage, 58689,
     /* 2346107 */   GIR_EraseRootFromParent_Done,
     /* 2346108 */ // Label 32560: @2346108
     /* 2346108 */ GIM_Try, /*On fail goto*//*Label 32561*/ GIMT_Encode4(2346165), // Rule ID 58892 //
     /* 2346113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2346116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2346119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346127 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2346144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346146 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346149 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346163 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346164 */   // GIR_Coverage, 58892,
     /* 2346164 */   GIR_EraseRootFromParent_Done,
     /* 2346165 */ // Label 32561: @2346165
     /* 2346165 */ GIM_Try, /*On fail goto*//*Label 32562*/ GIMT_Encode4(2346222), // Rule ID 58893 //
     /* 2346170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2346173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2346176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346184 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2346201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346206 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346220 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346221 */   // GIR_Coverage, 58893,
     /* 2346221 */   GIR_EraseRootFromParent_Done,
     /* 2346222 */ // Label 32562: @2346222
     /* 2346222 */ GIM_Reject,
     /* 2346223 */ // Label 32474: @2346223
     /* 2346223 */ GIM_Try, /*On fail goto*//*Label 32563*/ GIMT_Encode4(2346280), // Rule ID 58524 //
     /* 2346228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2346231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2346234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346242 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2346245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2346259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346261 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346264 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2346275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346278 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346279 */   // GIR_Coverage, 58524,
     /* 2346279 */   GIR_EraseRootFromParent_Done,
     /* 2346280 */ // Label 32563: @2346280
     /* 2346280 */ GIM_Try, /*On fail goto*//*Label 32564*/ GIMT_Encode4(2346337), // Rule ID 58525 //
     /* 2346285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2346288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2346291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346299 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346299 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2346302 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346306 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2346316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346321 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2346332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346335 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346336 */   // GIR_Coverage, 58525,
     /* 2346336 */   GIR_EraseRootFromParent_Done,
     /* 2346337 */ // Label 32564: @2346337
     /* 2346337 */ GIM_Try, /*On fail goto*//*Label 32565*/ GIMT_Encode4(2346391), // Rule ID 58708 //
     /* 2346342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2346345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346356 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346356 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2346359 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346363 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2346373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346378 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346389 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346390 */   // GIR_Coverage, 58708,
     /* 2346390 */   GIR_EraseRootFromParent_Done,
     /* 2346391 */ // Label 32565: @2346391
     /* 2346391 */ GIM_Try, /*On fail goto*//*Label 32566*/ GIMT_Encode4(2346445), // Rule ID 58709 //
     /* 2346396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2346399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346410 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2346413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2346427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346432 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346444 */   // GIR_Coverage, 58709,
     /* 2346444 */   GIR_EraseRootFromParent_Done,
     /* 2346445 */ // Label 32566: @2346445
     /* 2346445 */ GIM_Reject,
     /* 2346446 */ // Label 32475: @2346446
     /* 2346446 */ GIM_Try, /*On fail goto*//*Label 32567*/ GIMT_Encode4(2346503), // Rule ID 58496 //
     /* 2346451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2346457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346465 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2346482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346487 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346501 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346502 */   // GIR_Coverage, 58496,
     /* 2346502 */   GIR_EraseRootFromParent_Done,
     /* 2346503 */ // Label 32567: @2346503
     /* 2346503 */ GIM_Try, /*On fail goto*//*Label 32568*/ GIMT_Encode4(2346560), // Rule ID 58497 //
     /* 2346508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2346514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346522 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346522 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346525 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346529 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2346539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346544 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346558 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346559 */   // GIR_Coverage, 58497,
     /* 2346559 */   GIR_EraseRootFromParent_Done,
     /* 2346560 */ // Label 32568: @2346560
     /* 2346560 */ GIM_Try, /*On fail goto*//*Label 32569*/ GIMT_Encode4(2346614), // Rule ID 58668 //
     /* 2346565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2346571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346579 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346579 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346582 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346586 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2346596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346598 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346601 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346612 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346613 */   // GIR_Coverage, 58668,
     /* 2346613 */   GIR_EraseRootFromParent_Done,
     /* 2346614 */ // Label 32569: @2346614
     /* 2346614 */ GIM_Try, /*On fail goto*//*Label 32570*/ GIMT_Encode4(2346668), // Rule ID 58669 //
     /* 2346619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2346625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346633 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2346650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346655 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346666 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346667 */   // GIR_Coverage, 58669,
     /* 2346667 */   GIR_EraseRootFromParent_Done,
     /* 2346668 */ // Label 32570: @2346668
     /* 2346668 */ GIM_Try, /*On fail goto*//*Label 32571*/ GIMT_Encode4(2346725), // Rule ID 58876 //
     /* 2346673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2346679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346687 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2346704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346709 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346723 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346724 */   // GIR_Coverage, 58876,
     /* 2346724 */   GIR_EraseRootFromParent_Done,
     /* 2346725 */ // Label 32571: @2346725
     /* 2346725 */ GIM_Try, /*On fail goto*//*Label 32572*/ GIMT_Encode4(2346782), // Rule ID 58877 //
     /* 2346730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2346736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346744 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2346761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346766 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346781 */   // GIR_Coverage, 58877,
     /* 2346781 */   GIR_EraseRootFromParent_Done,
     /* 2346782 */ // Label 32572: @2346782
     /* 2346782 */ GIM_Reject,
     /* 2346783 */ // Label 32476: @2346783
     /* 2346783 */ GIM_Try, /*On fail goto*//*Label 32573*/ GIMT_Encode4(2346840), // Rule ID 58512 //
     /* 2346788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2346791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2346794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346802 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2346805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346814 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2346819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346824 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346838 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346839 */   // GIR_Coverage, 58512,
     /* 2346839 */   GIR_EraseRootFromParent_Done,
     /* 2346840 */ // Label 32573: @2346840
     /* 2346840 */ GIM_Try, /*On fail goto*//*Label 32574*/ GIMT_Encode4(2346897), // Rule ID 58513 //
     /* 2346845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2346848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2346851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346859 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2346862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2346876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346878 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346881 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346896 */   // GIR_Coverage, 58513,
     /* 2346896 */   GIR_EraseRootFromParent_Done,
     /* 2346897 */ // Label 32574: @2346897
     /* 2346897 */ GIM_Try, /*On fail goto*//*Label 32575*/ GIMT_Encode4(2346951), // Rule ID 58692 //
     /* 2346902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2346905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2346908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346916 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346916 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2346919 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346923 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2346933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346938 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346949 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346950 */   // GIR_Coverage, 58692,
     /* 2346950 */   GIR_EraseRootFromParent_Done,
     /* 2346951 */ // Label 32575: @2346951
     /* 2346951 */ GIM_Try, /*On fail goto*//*Label 32576*/ GIMT_Encode4(2347005), // Rule ID 58693 //
     /* 2346956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2346959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2346962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346970 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2346973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2346987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346992 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347004 */   // GIR_Coverage, 58693,
     /* 2347004 */   GIR_EraseRootFromParent_Done,
     /* 2347005 */ // Label 32576: @2347005
     /* 2347005 */ GIM_Reject,
     /* 2347006 */ // Label 32477: @2347006
     /* 2347006 */ GIM_Try, /*On fail goto*//*Label 32577*/ GIMT_Encode4(2347063), // Rule ID 58500 //
     /* 2347011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2347014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2347017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347025 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2347028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2347042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347047 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347061 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347062 */   // GIR_Coverage, 58500,
     /* 2347062 */   GIR_EraseRootFromParent_Done,
     /* 2347063 */ // Label 32577: @2347063
     /* 2347063 */ GIM_Try, /*On fail goto*//*Label 32578*/ GIMT_Encode4(2347120), // Rule ID 58501 //
     /* 2347068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2347074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347082 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2347085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2347099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347101 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347104 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347118 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347119 */   // GIR_Coverage, 58501,
     /* 2347119 */   GIR_EraseRootFromParent_Done,
     /* 2347120 */ // Label 32578: @2347120
     /* 2347120 */ GIM_Try, /*On fail goto*//*Label 32579*/ GIMT_Encode4(2347174), // Rule ID 58672 //
     /* 2347125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2347128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2347131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347139 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347139 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2347142 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347146 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2347156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347161 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347173 */   // GIR_Coverage, 58672,
     /* 2347173 */   GIR_EraseRootFromParent_Done,
     /* 2347174 */ // Label 32579: @2347174
     /* 2347174 */ GIM_Try, /*On fail goto*//*Label 32580*/ GIMT_Encode4(2347228), // Rule ID 58673 //
     /* 2347179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2347185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347193 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347193 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2347196 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347200 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2347210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347215 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347227 */   // GIR_Coverage, 58673,
     /* 2347227 */   GIR_EraseRootFromParent_Done,
     /* 2347228 */ // Label 32580: @2347228
     /* 2347228 */ GIM_Reject,
     /* 2347229 */ // Label 32478: @2347229
     /* 2347229 */ GIM_Reject,
     /* 2347230 */ // Label 71: @2347230
     /* 2347230 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32599*/ GIMT_Encode4(2349200),
     /* 2347241 */ /*GILLT_s16*//*Label 32581*/ GIMT_Encode4(2347361),
     /* 2347245 */ /*GILLT_s32*//*Label 32582*/ GIMT_Encode4(2347425),
     /* 2347249 */ /*GILLT_s64*//*Label 32583*/ GIMT_Encode4(2347489), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347261 */ /*GILLT_nxv1s16*//*Label 32584*/ GIMT_Encode4(2347580),
     /* 2347265 */ /*GILLT_nxv1s32*//*Label 32585*/ GIMT_Encode4(2347688),
     /* 2347269 */ /*GILLT_nxv1s64*//*Label 32586*/ GIMT_Encode4(2347796), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347281 */ /*GILLT_nxv2s16*//*Label 32587*/ GIMT_Encode4(2347904),
     /* 2347285 */ /*GILLT_nxv2s32*//*Label 32588*/ GIMT_Encode4(2348012),
     /* 2347289 */ /*GILLT_nxv2s64*//*Label 32589*/ GIMT_Encode4(2348120), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347301 */ /*GILLT_nxv4s16*//*Label 32590*/ GIMT_Encode4(2348228),
     /* 2347305 */ /*GILLT_nxv4s32*//*Label 32591*/ GIMT_Encode4(2348336),
     /* 2347309 */ /*GILLT_nxv4s64*//*Label 32592*/ GIMT_Encode4(2348444), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347321 */ /*GILLT_nxv8s16*//*Label 32593*/ GIMT_Encode4(2348552),
     /* 2347325 */ /*GILLT_nxv8s32*//*Label 32594*/ GIMT_Encode4(2348660),
     /* 2347329 */ /*GILLT_nxv8s64*//*Label 32595*/ GIMT_Encode4(2348768), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347341 */ /*GILLT_nxv16s16*//*Label 32596*/ GIMT_Encode4(2348876),
     /* 2347345 */ /*GILLT_nxv16s32*//*Label 32597*/ GIMT_Encode4(2348984), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347357 */ /*GILLT_nxv32s16*//*Label 32598*/ GIMT_Encode4(2349092),
     /* 2347361 */ // Label 32581: @2347361
     /* 2347361 */ GIM_Try, /*On fail goto*//*Label 32600*/ GIMT_Encode4(2347424),
     /* 2347366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2347369 */   GIM_Try, /*On fail goto*//*Label 32601*/ GIMT_Encode4(2347396), // Rule ID 1993 //
     /* 2347374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2347377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2347381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2347385 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2347385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H),
     /* 2347388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347395 */     // GIR_Coverage, 1993,
     /* 2347395 */     GIR_EraseRootFromParent_Done,
     /* 2347396 */   // Label 32601: @2347396
     /* 2347396 */   GIM_Try, /*On fail goto*//*Label 32602*/ GIMT_Encode4(2347423), // Rule ID 2026 //
     /* 2347401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2347404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2347408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2347412 */     // (fabs:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2347412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H_INX),
     /* 2347415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347422 */     // GIR_Coverage, 2026,
     /* 2347422 */     GIR_EraseRootFromParent_Done,
     /* 2347423 */   // Label 32602: @2347423
     /* 2347423 */   GIM_Reject,
     /* 2347424 */ // Label 32600: @2347424
     /* 2347424 */ GIM_Reject,
     /* 2347425 */ // Label 32582: @2347425
     /* 2347425 */ GIM_Try, /*On fail goto*//*Label 32603*/ GIMT_Encode4(2347488),
     /* 2347430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2347433 */   GIM_Try, /*On fail goto*//*Label 32604*/ GIMT_Encode4(2347460), // Rule ID 1284 //
     /* 2347438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2347441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2347445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2347449 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2347449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S),
     /* 2347452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347459 */     // GIR_Coverage, 1284,
     /* 2347459 */     GIR_EraseRootFromParent_Done,
     /* 2347460 */   // Label 32604: @2347460
     /* 2347460 */   GIM_Try, /*On fail goto*//*Label 32605*/ GIMT_Encode4(2347487), // Rule ID 1292 //
     /* 2347465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2347468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2347472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2347476 */     // (fabs:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2347476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S_INX),
     /* 2347479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347486 */     // GIR_Coverage, 1292,
     /* 2347486 */     GIR_EraseRootFromParent_Done,
     /* 2347487 */   // Label 32605: @2347487
     /* 2347487 */   GIM_Reject,
     /* 2347488 */ // Label 32603: @2347488
     /* 2347488 */ GIM_Reject,
     /* 2347489 */ // Label 32583: @2347489
     /* 2347489 */ GIM_Try, /*On fail goto*//*Label 32606*/ GIMT_Encode4(2347579),
     /* 2347494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2347497 */   GIM_Try, /*On fail goto*//*Label 32607*/ GIMT_Encode4(2347524), // Rule ID 1627 //
     /* 2347502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2347505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2347509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2347513 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2347513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D),
     /* 2347516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347523 */     // GIR_Coverage, 1627,
     /* 2347523 */     GIR_EraseRootFromParent_Done,
     /* 2347524 */   // Label 32607: @2347524
     /* 2347524 */   GIM_Try, /*On fail goto*//*Label 32608*/ GIMT_Encode4(2347551), // Rule ID 1660 //
     /* 2347529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2347532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2347536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2347540 */     // (fabs:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2347540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_INX),
     /* 2347543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347550 */     // GIR_Coverage, 1660,
     /* 2347550 */     GIR_EraseRootFromParent_Done,
     /* 2347551 */   // Label 32608: @2347551
     /* 2347551 */   GIM_Try, /*On fail goto*//*Label 32609*/ GIMT_Encode4(2347578), // Rule ID 1682 //
     /* 2347556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2347559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2347563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2347567 */     // (fabs:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2347567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_IN32X),
     /* 2347570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347577 */     // GIR_Coverage, 1682,
     /* 2347577 */     GIR_EraseRootFromParent_Done,
     /* 2347578 */   // Label 32609: @2347578
     /* 2347578 */   GIM_Reject,
     /* 2347579 */ // Label 32606: @2347579
     /* 2347579 */ GIM_Reject,
     /* 2347580 */ // Label 32584: @2347580
     /* 2347580 */ GIM_Try, /*On fail goto*//*Label 32610*/ GIMT_Encode4(2347687),
     /* 2347585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2347588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347596 */   GIM_Try, /*On fail goto*//*Label 32611*/ GIMT_Encode4(2347641), // Rule ID 56244 //
     /* 2347601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2347604 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2347607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2347621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347640 */     // GIR_Coverage, 56244,
     /* 2347640 */     GIR_EraseRootFromParent_Done,
     /* 2347641 */   // Label 32611: @2347641
     /* 2347641 */   GIM_Try, /*On fail goto*//*Label 32612*/ GIMT_Encode4(2347686), // Rule ID 56245 //
     /* 2347646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2347649 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2347652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2347666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347685 */     // GIR_Coverage, 56245,
     /* 2347685 */     GIR_EraseRootFromParent_Done,
     /* 2347686 */   // Label 32612: @2347686
     /* 2347686 */   GIM_Reject,
     /* 2347687 */ // Label 32610: @2347687
     /* 2347687 */ GIM_Reject,
     /* 2347688 */ // Label 32585: @2347688
     /* 2347688 */ GIM_Try, /*On fail goto*//*Label 32613*/ GIMT_Encode4(2347795),
     /* 2347693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2347696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347704 */   GIM_Try, /*On fail goto*//*Label 32614*/ GIMT_Encode4(2347749), // Rule ID 56284 //
     /* 2347709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2347712 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2347715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2347729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347748 */     // GIR_Coverage, 56284,
     /* 2347748 */     GIR_EraseRootFromParent_Done,
     /* 2347749 */   // Label 32614: @2347749
     /* 2347749 */   GIM_Try, /*On fail goto*//*Label 32615*/ GIMT_Encode4(2347794), // Rule ID 56285 //
     /* 2347754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2347757 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2347760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2347774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347793 */     // GIR_Coverage, 56285,
     /* 2347793 */     GIR_EraseRootFromParent_Done,
     /* 2347794 */   // Label 32615: @2347794
     /* 2347794 */   GIM_Reject,
     /* 2347795 */ // Label 32613: @2347795
     /* 2347795 */ GIM_Reject,
     /* 2347796 */ // Label 32586: @2347796
     /* 2347796 */ GIM_Try, /*On fail goto*//*Label 32616*/ GIMT_Encode4(2347903),
     /* 2347801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2347804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347812 */   GIM_Try, /*On fail goto*//*Label 32617*/ GIMT_Encode4(2347857), // Rule ID 56344 //
     /* 2347817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2347820 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2347823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2347837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347856 */     // GIR_Coverage, 56344,
     /* 2347856 */     GIR_EraseRootFromParent_Done,
     /* 2347857 */   // Label 32617: @2347857
     /* 2347857 */   GIM_Try, /*On fail goto*//*Label 32618*/ GIMT_Encode4(2347902), // Rule ID 56345 //
     /* 2347862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2347865 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2347868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2347882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347901 */     // GIR_Coverage, 56345,
     /* 2347901 */     GIR_EraseRootFromParent_Done,
     /* 2347902 */   // Label 32618: @2347902
     /* 2347902 */   GIM_Reject,
     /* 2347903 */ // Label 32616: @2347903
     /* 2347903 */ GIM_Reject,
     /* 2347904 */ // Label 32587: @2347904
     /* 2347904 */ GIM_Try, /*On fail goto*//*Label 32619*/ GIMT_Encode4(2348011),
     /* 2347909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2347912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347920 */   GIM_Try, /*On fail goto*//*Label 32620*/ GIMT_Encode4(2347965), // Rule ID 56264 //
     /* 2347925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2347928 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2347931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2347945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347964 */     // GIR_Coverage, 56264,
     /* 2347964 */     GIR_EraseRootFromParent_Done,
     /* 2347965 */   // Label 32620: @2347965
     /* 2347965 */   GIM_Try, /*On fail goto*//*Label 32621*/ GIMT_Encode4(2348010), // Rule ID 56265 //
     /* 2347970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2347973 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2347976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2347990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348009 */     // GIR_Coverage, 56265,
     /* 2348009 */     GIR_EraseRootFromParent_Done,
     /* 2348010 */   // Label 32621: @2348010
     /* 2348010 */   GIM_Reject,
     /* 2348011 */ // Label 32619: @2348011
     /* 2348011 */ GIM_Reject,
     /* 2348012 */ // Label 32588: @2348012
     /* 2348012 */ GIM_Try, /*On fail goto*//*Label 32622*/ GIMT_Encode4(2348119),
     /* 2348017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2348020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348028 */   GIM_Try, /*On fail goto*//*Label 32623*/ GIMT_Encode4(2348073), // Rule ID 56324 //
     /* 2348033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2348036 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2348039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2348053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348072 */     // GIR_Coverage, 56324,
     /* 2348072 */     GIR_EraseRootFromParent_Done,
     /* 2348073 */   // Label 32623: @2348073
     /* 2348073 */   GIM_Try, /*On fail goto*//*Label 32624*/ GIMT_Encode4(2348118), // Rule ID 56325 //
     /* 2348078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2348081 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2348084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2348098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348117 */     // GIR_Coverage, 56325,
     /* 2348117 */     GIR_EraseRootFromParent_Done,
     /* 2348118 */   // Label 32624: @2348118
     /* 2348118 */   GIM_Reject,
     /* 2348119 */ // Label 32622: @2348119
     /* 2348119 */ GIM_Reject,
     /* 2348120 */ // Label 32589: @2348120
     /* 2348120 */ GIM_Try, /*On fail goto*//*Label 32625*/ GIMT_Encode4(2348227),
     /* 2348125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2348128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2348132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2348136 */   GIM_Try, /*On fail goto*//*Label 32626*/ GIMT_Encode4(2348181), // Rule ID 56484 //
     /* 2348141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2348144 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2348147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2348161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2348176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348180 */     // GIR_Coverage, 56484,
     /* 2348180 */     GIR_EraseRootFromParent_Done,
     /* 2348181 */   // Label 32626: @2348181
     /* 2348181 */   GIM_Try, /*On fail goto*//*Label 32627*/ GIMT_Encode4(2348226), // Rule ID 56485 //
     /* 2348186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2348189 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2348192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2348206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2348221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348225 */     // GIR_Coverage, 56485,
     /* 2348225 */     GIR_EraseRootFromParent_Done,
     /* 2348226 */   // Label 32627: @2348226
     /* 2348226 */   GIM_Reject,
     /* 2348227 */ // Label 32625: @2348227
     /* 2348227 */ GIM_Reject,
     /* 2348228 */ // Label 32590: @2348228
     /* 2348228 */ GIM_Try, /*On fail goto*//*Label 32628*/ GIMT_Encode4(2348335),
     /* 2348233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2348236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348244 */   GIM_Try, /*On fail goto*//*Label 32629*/ GIMT_Encode4(2348289), // Rule ID 56304 //
     /* 2348249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2348252 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2348255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2348269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348288 */     // GIR_Coverage, 56304,
     /* 2348288 */     GIR_EraseRootFromParent_Done,
     /* 2348289 */   // Label 32629: @2348289
     /* 2348289 */   GIM_Try, /*On fail goto*//*Label 32630*/ GIMT_Encode4(2348334), // Rule ID 56305 //
     /* 2348294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2348297 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2348300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2348314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348333 */     // GIR_Coverage, 56305,
     /* 2348333 */     GIR_EraseRootFromParent_Done,
     /* 2348334 */   // Label 32630: @2348334
     /* 2348334 */   GIM_Reject,
     /* 2348335 */ // Label 32628: @2348335
     /* 2348335 */ GIM_Reject,
     /* 2348336 */ // Label 32591: @2348336
     /* 2348336 */ GIM_Try, /*On fail goto*//*Label 32631*/ GIMT_Encode4(2348443),
     /* 2348341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2348344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2348348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2348352 */   GIM_Try, /*On fail goto*//*Label 32632*/ GIMT_Encode4(2348397), // Rule ID 56424 //
     /* 2348357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2348360 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2348363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2348377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348396 */     // GIR_Coverage, 56424,
     /* 2348396 */     GIR_EraseRootFromParent_Done,
     /* 2348397 */   // Label 32632: @2348397
     /* 2348397 */   GIM_Try, /*On fail goto*//*Label 32633*/ GIMT_Encode4(2348442), // Rule ID 56425 //
     /* 2348402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2348405 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2348408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2348422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348441 */     // GIR_Coverage, 56425,
     /* 2348441 */     GIR_EraseRootFromParent_Done,
     /* 2348442 */   // Label 32633: @2348442
     /* 2348442 */   GIM_Reject,
     /* 2348443 */ // Label 32631: @2348443
     /* 2348443 */ GIM_Reject,
     /* 2348444 */ // Label 32592: @2348444
     /* 2348444 */ GIM_Try, /*On fail goto*//*Label 32634*/ GIMT_Encode4(2348551),
     /* 2348449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2348452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348460 */   GIM_Try, /*On fail goto*//*Label 32635*/ GIMT_Encode4(2348505), // Rule ID 56504 //
     /* 2348465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2348468 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2348471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2348485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2348500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348504 */     // GIR_Coverage, 56504,
     /* 2348504 */     GIR_EraseRootFromParent_Done,
     /* 2348505 */   // Label 32635: @2348505
     /* 2348505 */   GIM_Try, /*On fail goto*//*Label 32636*/ GIMT_Encode4(2348550), // Rule ID 56505 //
     /* 2348510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2348513 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2348516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2348530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2348545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348549 */     // GIR_Coverage, 56505,
     /* 2348549 */     GIR_EraseRootFromParent_Done,
     /* 2348550 */   // Label 32636: @2348550
     /* 2348550 */   GIM_Reject,
     /* 2348551 */ // Label 32634: @2348551
     /* 2348551 */ GIM_Reject,
     /* 2348552 */ // Label 32593: @2348552
     /* 2348552 */ GIM_Try, /*On fail goto*//*Label 32637*/ GIMT_Encode4(2348659),
     /* 2348557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2348560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2348564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2348568 */   GIM_Try, /*On fail goto*//*Label 32638*/ GIMT_Encode4(2348613), // Rule ID 56364 //
     /* 2348573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2348576 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2348579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2348593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348612 */     // GIR_Coverage, 56364,
     /* 2348612 */     GIR_EraseRootFromParent_Done,
     /* 2348613 */   // Label 32638: @2348613
     /* 2348613 */   GIM_Try, /*On fail goto*//*Label 32639*/ GIMT_Encode4(2348658), // Rule ID 56365 //
     /* 2348618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2348621 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2348624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2348638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348657 */     // GIR_Coverage, 56365,
     /* 2348657 */     GIR_EraseRootFromParent_Done,
     /* 2348658 */   // Label 32639: @2348658
     /* 2348658 */   GIM_Reject,
     /* 2348659 */ // Label 32637: @2348659
     /* 2348659 */ GIM_Reject,
     /* 2348660 */ // Label 32594: @2348660
     /* 2348660 */ GIM_Try, /*On fail goto*//*Label 32640*/ GIMT_Encode4(2348767),
     /* 2348665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2348668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348676 */   GIM_Try, /*On fail goto*//*Label 32641*/ GIMT_Encode4(2348721), // Rule ID 56444 //
     /* 2348681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2348684 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2348687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2348701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348720 */     // GIR_Coverage, 56444,
     /* 2348720 */     GIR_EraseRootFromParent_Done,
     /* 2348721 */   // Label 32641: @2348721
     /* 2348721 */   GIM_Try, /*On fail goto*//*Label 32642*/ GIMT_Encode4(2348766), // Rule ID 56445 //
     /* 2348726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2348729 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2348732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2348746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348765 */     // GIR_Coverage, 56445,
     /* 2348765 */     GIR_EraseRootFromParent_Done,
     /* 2348766 */   // Label 32642: @2348766
     /* 2348766 */   GIM_Reject,
     /* 2348767 */ // Label 32640: @2348767
     /* 2348767 */ GIM_Reject,
     /* 2348768 */ // Label 32595: @2348768
     /* 2348768 */ GIM_Try, /*On fail goto*//*Label 32643*/ GIMT_Encode4(2348875),
     /* 2348773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2348776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348784 */   GIM_Try, /*On fail goto*//*Label 32644*/ GIMT_Encode4(2348829), // Rule ID 56524 //
     /* 2348789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2348792 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2348795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2348809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2348824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348828 */     // GIR_Coverage, 56524,
     /* 2348828 */     GIR_EraseRootFromParent_Done,
     /* 2348829 */   // Label 32644: @2348829
     /* 2348829 */   GIM_Try, /*On fail goto*//*Label 32645*/ GIMT_Encode4(2348874), // Rule ID 56525 //
     /* 2348834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2348837 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2348840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2348854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2348869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348873 */     // GIR_Coverage, 56525,
     /* 2348873 */     GIR_EraseRootFromParent_Done,
     /* 2348874 */   // Label 32645: @2348874
     /* 2348874 */   GIM_Reject,
     /* 2348875 */ // Label 32643: @2348875
     /* 2348875 */ GIM_Reject,
     /* 2348876 */ // Label 32596: @2348876
     /* 2348876 */ GIM_Try, /*On fail goto*//*Label 32646*/ GIMT_Encode4(2348983),
     /* 2348881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2348884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348892 */   GIM_Try, /*On fail goto*//*Label 32647*/ GIMT_Encode4(2348937), // Rule ID 56384 //
     /* 2348897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2348900 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2348903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2348917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348936 */     // GIR_Coverage, 56384,
     /* 2348936 */     GIR_EraseRootFromParent_Done,
     /* 2348937 */   // Label 32647: @2348937
     /* 2348937 */   GIM_Try, /*On fail goto*//*Label 32648*/ GIMT_Encode4(2348982), // Rule ID 56385 //
     /* 2348942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2348945 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2348948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2348962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348981 */     // GIR_Coverage, 56385,
     /* 2348981 */     GIR_EraseRootFromParent_Done,
     /* 2348982 */   // Label 32648: @2348982
     /* 2348982 */   GIM_Reject,
     /* 2348983 */ // Label 32646: @2348983
     /* 2348983 */ GIM_Reject,
     /* 2348984 */ // Label 32597: @2348984
     /* 2348984 */ GIM_Try, /*On fail goto*//*Label 32649*/ GIMT_Encode4(2349091),
     /* 2348989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2348992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2349000 */   GIM_Try, /*On fail goto*//*Label 32650*/ GIMT_Encode4(2349045), // Rule ID 56464 //
     /* 2349005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2349008 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2349011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2349025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349044 */     // GIR_Coverage, 56464,
     /* 2349044 */     GIR_EraseRootFromParent_Done,
     /* 2349045 */   // Label 32650: @2349045
     /* 2349045 */   GIM_Try, /*On fail goto*//*Label 32651*/ GIMT_Encode4(2349090), // Rule ID 56465 //
     /* 2349050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2349053 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2349056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2349070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349089 */     // GIR_Coverage, 56465,
     /* 2349089 */     GIR_EraseRootFromParent_Done,
     /* 2349090 */   // Label 32651: @2349090
     /* 2349090 */   GIM_Reject,
     /* 2349091 */ // Label 32649: @2349091
     /* 2349091 */ GIM_Reject,
     /* 2349092 */ // Label 32598: @2349092
     /* 2349092 */ GIM_Try, /*On fail goto*//*Label 32652*/ GIMT_Encode4(2349199),
     /* 2349097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2349100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2349104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2349108 */   GIM_Try, /*On fail goto*//*Label 32653*/ GIMT_Encode4(2349153), // Rule ID 56404 //
     /* 2349113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2349116 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2349119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2349133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349152 */     // GIR_Coverage, 56404,
     /* 2349152 */     GIR_EraseRootFromParent_Done,
     /* 2349153 */   // Label 32653: @2349153
     /* 2349153 */   GIM_Try, /*On fail goto*//*Label 32654*/ GIMT_Encode4(2349198), // Rule ID 56405 //
     /* 2349158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2349161 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2349164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2349178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349197 */     // GIR_Coverage, 56405,
     /* 2349197 */     GIR_EraseRootFromParent_Done,
     /* 2349198 */   // Label 32654: @2349198
     /* 2349198 */   GIM_Reject,
     /* 2349199 */ // Label 32652: @2349199
     /* 2349199 */ GIM_Reject,
     /* 2349200 */ // Label 32599: @2349200
     /* 2349200 */ GIM_Reject,
     /* 2349201 */ // Label 72: @2349201
     /* 2349201 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32673*/ GIMT_Encode4(2355262),
     /* 2349212 */ /*GILLT_s16*//*Label 32655*/ GIMT_Encode4(2349332),
     /* 2349216 */ /*GILLT_s32*//*Label 32656*/ GIMT_Encode4(2350008),
     /* 2349220 */ /*GILLT_s64*//*Label 32657*/ GIMT_Encode4(2350684), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2349232 */ /*GILLT_nxv1s16*//*Label 32658*/ GIMT_Encode4(2351497),
     /* 2349236 */ /*GILLT_nxv1s32*//*Label 32659*/ GIMT_Encode4(2351748),
     /* 2349240 */ /*GILLT_nxv1s64*//*Label 32660*/ GIMT_Encode4(2351999), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2349252 */ /*GILLT_nxv2s16*//*Label 32661*/ GIMT_Encode4(2352250),
     /* 2349256 */ /*GILLT_nxv2s32*//*Label 32662*/ GIMT_Encode4(2352501),
     /* 2349260 */ /*GILLT_nxv2s64*//*Label 32663*/ GIMT_Encode4(2352752), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2349272 */ /*GILLT_nxv4s16*//*Label 32664*/ GIMT_Encode4(2353003),
     /* 2349276 */ /*GILLT_nxv4s32*//*Label 32665*/ GIMT_Encode4(2353254),
     /* 2349280 */ /*GILLT_nxv4s64*//*Label 32666*/ GIMT_Encode4(2353505), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2349292 */ /*GILLT_nxv8s16*//*Label 32667*/ GIMT_Encode4(2353756),
     /* 2349296 */ /*GILLT_nxv8s32*//*Label 32668*/ GIMT_Encode4(2354007),
     /* 2349300 */ /*GILLT_nxv8s64*//*Label 32669*/ GIMT_Encode4(2354258), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2349312 */ /*GILLT_nxv16s16*//*Label 32670*/ GIMT_Encode4(2354509),
     /* 2349316 */ /*GILLT_nxv16s32*//*Label 32671*/ GIMT_Encode4(2354760), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2349328 */ /*GILLT_nxv32s16*//*Label 32672*/ GIMT_Encode4(2355011),
     /* 2349332 */ // Label 32655: @2349332
     /* 2349332 */ GIM_Try, /*On fail goto*//*Label 32674*/ GIMT_Encode4(2350007),
     /* 2349337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2349340 */   GIM_Try, /*On fail goto*//*Label 32675*/ GIMT_Encode4(2349391), // Rule ID 1998 //
     /* 2349345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2349348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2349351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2349363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2349367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2349371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2349378 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs2))  =>  (FSGNJN_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)
     /* 2349378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2349381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2349389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349390 */     // GIR_Coverage, 1998,
     /* 2349390 */     GIR_EraseRootFromParent_Done,
     /* 2349391 */   // Label 32675: @2349391
     /* 2349391 */   GIM_Try, /*On fail goto*//*Label 32676*/ GIMT_Encode4(2349442), // Rule ID 2031 //
     /* 2349396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2349399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2349402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2349414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2349418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2349422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2349429 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2))  =>  (FSGNJN_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)
     /* 2349429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2349432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2349440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349441 */     // GIR_Coverage, 2031,
     /* 2349441 */     GIR_EraseRootFromParent_Done,
     /* 2349442 */   // Label 32676: @2349442
     /* 2349442 */   GIM_Try, /*On fail goto*//*Label 32677*/ GIMT_Encode4(2349472), // Rule ID 1996 //
     /* 2349447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2349450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2349453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349465 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2349465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2349470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349471 */     // GIR_Coverage, 1996,
     /* 2349471 */     GIR_Done,
     /* 2349472 */   // Label 32677: @2349472
     /* 2349472 */   GIM_Try, /*On fail goto*//*Label 32678*/ GIMT_Encode4(2349528), // Rule ID 1999 //
     /* 2349477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2349480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2349483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349495 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2349495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2349502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349507 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349511 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2349519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349527 */     // GIR_Coverage, 1999,
     /* 2349527 */     GIR_EraseRootFromParent_Done,
     /* 2349528 */   // Label 32678: @2349528
     /* 2349528 */   GIM_Try, /*On fail goto*//*Label 32679*/ GIMT_Encode4(2349584), // Rule ID 2000 //
     /* 2349533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2349536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2349539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349551 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2349551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2349558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349567 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2349575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349583 */     // GIR_Coverage, 2000,
     /* 2349583 */     GIR_EraseRootFromParent_Done,
     /* 2349584 */   // Label 32679: @2349584
     /* 2349584 */   GIM_Try, /*On fail goto*//*Label 32680*/ GIMT_Encode4(2349614), // Rule ID 2029 //
     /* 2349589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2349592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2349595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349607 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2349607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2349612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349613 */     // GIR_Coverage, 2029,
     /* 2349613 */     GIR_Done,
     /* 2349614 */   // Label 32680: @2349614
     /* 2349614 */   GIM_Try, /*On fail goto*//*Label 32681*/ GIMT_Encode4(2349670), // Rule ID 2032 //
     /* 2349619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2349622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2349625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349637 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2349637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2349644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349649 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349653 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2349661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349669 */     // GIR_Coverage, 2032,
     /* 2349669 */     GIR_EraseRootFromParent_Done,
     /* 2349670 */   // Label 32681: @2349670
     /* 2349670 */   GIM_Try, /*On fail goto*//*Label 32682*/ GIMT_Encode4(2349726), // Rule ID 2033 //
     /* 2349675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2349678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2349681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349693 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2349693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2349700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349709 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2349717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349725 */     // GIR_Coverage, 2033,
     /* 2349725 */     GIR_EraseRootFromParent_Done,
     /* 2349726 */   // Label 32682: @2349726
     /* 2349726 */   GIM_Try, /*On fail goto*//*Label 32683*/ GIMT_Encode4(2349782), // Rule ID 2302 //
     /* 2349731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2349734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2349749 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2349749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2349756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349761 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349765 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2349773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349781 */     // GIR_Coverage, 2302,
     /* 2349781 */     GIR_EraseRootFromParent_Done,
     /* 2349782 */   // Label 32683: @2349782
     /* 2349782 */   GIM_Try, /*On fail goto*//*Label 32684*/ GIMT_Encode4(2349838), // Rule ID 2303 //
     /* 2349787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2349790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2349805 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2349805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2349812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349821 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2349829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349837 */     // GIR_Coverage, 2303,
     /* 2349837 */     GIR_EraseRootFromParent_Done,
     /* 2349838 */   // Label 32684: @2349838
     /* 2349838 */   GIM_Try, /*On fail goto*//*Label 32685*/ GIMT_Encode4(2349894), // Rule ID 2314 //
     /* 2349843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2349846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2349861 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2349861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2349868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349873 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349877 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2349885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349893 */     // GIR_Coverage, 2314,
     /* 2349893 */     GIR_EraseRootFromParent_Done,
     /* 2349894 */   // Label 32685: @2349894
     /* 2349894 */   GIM_Try, /*On fail goto*//*Label 32686*/ GIMT_Encode4(2349950), // Rule ID 2315 //
     /* 2349899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2349902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2349917 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2349917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2349924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349929 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349933 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2349941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349949 */     // GIR_Coverage, 2315,
     /* 2349949 */     GIR_EraseRootFromParent_Done,
     /* 2349950 */   // Label 32686: @2349950
     /* 2349950 */   GIM_Try, /*On fail goto*//*Label 32687*/ GIMT_Encode4(2350006), // Rule ID 2322 //
     /* 2349955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2349958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2349973 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_INX:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2349973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2349980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349989 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2349997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350005 */     // GIR_Coverage, 2322,
     /* 2350005 */     GIR_EraseRootFromParent_Done,
     /* 2350006 */   // Label 32687: @2350006
     /* 2350006 */   GIM_Reject,
     /* 2350007 */ // Label 32674: @2350007
     /* 2350007 */ GIM_Reject,
     /* 2350008 */ // Label 32656: @2350008
     /* 2350008 */ GIM_Try, /*On fail goto*//*Label 32688*/ GIMT_Encode4(2350683),
     /* 2350013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2350016 */   GIM_Try, /*On fail goto*//*Label 32689*/ GIMT_Encode4(2350067), // Rule ID 1299 //
     /* 2350021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2350024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2350027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2350039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2350043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2350047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2350054 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs2))  =>  (FSGNJN_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)
     /* 2350054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2350057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2350065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350066 */     // GIR_Coverage, 1299,
     /* 2350066 */     GIR_EraseRootFromParent_Done,
     /* 2350067 */   // Label 32689: @2350067
     /* 2350067 */   GIM_Try, /*On fail goto*//*Label 32690*/ GIMT_Encode4(2350118), // Rule ID 1320 //
     /* 2350072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2350075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2350078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2350090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2350094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2350098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2350105 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2))  =>  (FSGNJN_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)
     /* 2350105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2350108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2350116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350117 */     // GIR_Coverage, 1320,
     /* 2350117 */     GIR_EraseRootFromParent_Done,
     /* 2350118 */   // Label 32690: @2350118
     /* 2350118 */   GIM_Try, /*On fail goto*//*Label 32691*/ GIMT_Encode4(2350148), // Rule ID 1295 //
     /* 2350123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2350126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2350129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350141 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2350141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2350146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350147 */     // GIR_Coverage, 1295,
     /* 2350147 */     GIR_Done,
     /* 2350148 */   // Label 32691: @2350148
     /* 2350148 */   GIM_Try, /*On fail goto*//*Label 32692*/ GIMT_Encode4(2350178), // Rule ID 1296 //
     /* 2350153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2350156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2350159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350171 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2350171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2350176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350177 */     // GIR_Coverage, 1296,
     /* 2350177 */     GIR_Done,
     /* 2350178 */   // Label 32692: @2350178
     /* 2350178 */   GIM_Try, /*On fail goto*//*Label 32693*/ GIMT_Encode4(2350234), // Rule ID 1635 //
     /* 2350183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2350186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350201 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2350201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2350208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350217 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2350220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2350225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350233 */     // GIR_Coverage, 1635,
     /* 2350233 */     GIR_EraseRootFromParent_Done,
     /* 2350234 */   // Label 32693: @2350234
     /* 2350234 */   GIM_Try, /*On fail goto*//*Label 32694*/ GIMT_Encode4(2350290), // Rule ID 1636 //
     /* 2350239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2350242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350257 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2350257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2350264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350273 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2350276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2350281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350289 */     // GIR_Coverage, 1636,
     /* 2350289 */     GIR_EraseRootFromParent_Done,
     /* 2350290 */   // Label 32694: @2350290
     /* 2350290 */   GIM_Try, /*On fail goto*//*Label 32695*/ GIMT_Encode4(2350346), // Rule ID 1666 //
     /* 2350295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2350298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350313 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_INX:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2350313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2350320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350329 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2350332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2350337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350345 */     // GIR_Coverage, 1666,
     /* 2350345 */     GIR_EraseRootFromParent_Done,
     /* 2350346 */   // Label 32695: @2350346
     /* 2350346 */   GIM_Try, /*On fail goto*//*Label 32696*/ GIMT_Encode4(2350402), // Rule ID 1690 //
     /* 2350351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2350354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350369 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2350369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2350376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350381 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350385 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2350388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2350393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350401 */     // GIR_Coverage, 1690,
     /* 2350401 */     GIR_EraseRootFromParent_Done,
     /* 2350402 */   // Label 32696: @2350402
     /* 2350402 */   GIM_Try, /*On fail goto*//*Label 32697*/ GIMT_Encode4(2350458), // Rule ID 1691 //
     /* 2350407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2350410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350425 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2350425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2350432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350437 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350441 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2350444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2350449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350457 */     // GIR_Coverage, 1691,
     /* 2350457 */     GIR_EraseRootFromParent_Done,
     /* 2350458 */   // Label 32697: @2350458
     /* 2350458 */   GIM_Try, /*On fail goto*//*Label 32698*/ GIMT_Encode4(2350514), // Rule ID 2174 //
     /* 2350463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2350466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2350469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2350481 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2350481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2350488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350497 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2350505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350513 */     // GIR_Coverage, 2174,
     /* 2350513 */     GIR_EraseRootFromParent_Done,
     /* 2350514 */   // Label 32698: @2350514
     /* 2350514 */   GIM_Try, /*On fail goto*//*Label 32699*/ GIMT_Encode4(2350570), // Rule ID 2175 //
     /* 2350519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2350522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2350525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2350537 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2350537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2350544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350553 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2350561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350569 */     // GIR_Coverage, 2175,
     /* 2350569 */     GIR_EraseRootFromParent_Done,
     /* 2350570 */   // Label 32699: @2350570
     /* 2350570 */   GIM_Try, /*On fail goto*//*Label 32700*/ GIMT_Encode4(2350626), // Rule ID 2188 //
     /* 2350575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2350578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2350581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2350593 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2350593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2350600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350609 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2350617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350625 */     // GIR_Coverage, 2188,
     /* 2350625 */     GIR_EraseRootFromParent_Done,
     /* 2350626 */   // Label 32700: @2350626
     /* 2350626 */   GIM_Try, /*On fail goto*//*Label 32701*/ GIMT_Encode4(2350682), // Rule ID 2189 //
     /* 2350631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2350634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2350637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2350649 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2350649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2350656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350661 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350665 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2350673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350681 */     // GIR_Coverage, 2189,
     /* 2350681 */     GIR_EraseRootFromParent_Done,
     /* 2350682 */   // Label 32701: @2350682
     /* 2350682 */   GIM_Reject,
     /* 2350683 */ // Label 32688: @2350683
     /* 2350683 */ GIM_Reject,
     /* 2350684 */ // Label 32657: @2350684
     /* 2350684 */ GIM_Try, /*On fail goto*//*Label 32702*/ GIMT_Encode4(2351496),
     /* 2350689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2350692 */   GIM_Try, /*On fail goto*//*Label 32703*/ GIMT_Encode4(2350743), // Rule ID 1632 //
     /* 2350697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2350700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2350715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2350719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2350723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2350730 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs2))  =>  (FSGNJN_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)
     /* 2350730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2350733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2350741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350742 */     // GIR_Coverage, 1632,
     /* 2350742 */     GIR_EraseRootFromParent_Done,
     /* 2350743 */   // Label 32703: @2350743
     /* 2350743 */   GIM_Try, /*On fail goto*//*Label 32704*/ GIMT_Encode4(2350794), // Rule ID 1664 //
     /* 2350748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2350751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2350766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2350770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2350774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2350781 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)
     /* 2350781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2350784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2350792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350793 */     // GIR_Coverage, 1664,
     /* 2350793 */     GIR_EraseRootFromParent_Done,
     /* 2350794 */   // Label 32704: @2350794
     /* 2350794 */   GIM_Try, /*On fail goto*//*Label 32705*/ GIMT_Encode4(2350845), // Rule ID 1687 //
     /* 2350799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2350802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2350817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2350821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2350825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2350832 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)
     /* 2350832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2350835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2350843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350844 */     // GIR_Coverage, 1687,
     /* 2350844 */     GIR_EraseRootFromParent_Done,
     /* 2350845 */   // Label 32705: @2350845
     /* 2350845 */   GIM_Try, /*On fail goto*//*Label 32706*/ GIMT_Encode4(2350875), // Rule ID 1630 //
     /* 2350850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2350853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350868 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2350868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2350873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350874 */     // GIR_Coverage, 1630,
     /* 2350874 */     GIR_Done,
     /* 2350875 */   // Label 32706: @2350875
     /* 2350875 */   GIM_Try, /*On fail goto*//*Label 32707*/ GIMT_Encode4(2350931), // Rule ID 1633 //
     /* 2350880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2350883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2350886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350898 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2350898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2350901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2350905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350914 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2350922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350930 */     // GIR_Coverage, 1633,
     /* 2350930 */     GIR_EraseRootFromParent_Done,
     /* 2350931 */   // Label 32707: @2350931
     /* 2350931 */   GIM_Try, /*On fail goto*//*Label 32708*/ GIMT_Encode4(2350987), // Rule ID 1634 //
     /* 2350936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2350939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2350942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350954 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2350954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2350957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2350961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350970 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2350978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350986 */     // GIR_Coverage, 1634,
     /* 2350986 */     GIR_EraseRootFromParent_Done,
     /* 2350987 */   // Label 32708: @2350987
     /* 2350987 */   GIM_Try, /*On fail goto*//*Label 32709*/ GIMT_Encode4(2351017), // Rule ID 1662 //
     /* 2350992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2350995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351010 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2351010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2351015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351016 */     // GIR_Coverage, 1662,
     /* 2351016 */     GIR_Done,
     /* 2351017 */   // Label 32709: @2351017
     /* 2351017 */   GIM_Try, /*On fail goto*//*Label 32710*/ GIMT_Encode4(2351073), // Rule ID 1665 //
     /* 2351022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2351025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2351028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2351040 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_INX:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2351040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2351043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2351047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351052 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351056 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2351059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2351064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351072 */     // GIR_Coverage, 1665,
     /* 2351072 */     GIR_EraseRootFromParent_Done,
     /* 2351073 */   // Label 32710: @2351073
     /* 2351073 */   GIM_Try, /*On fail goto*//*Label 32711*/ GIMT_Encode4(2351103), // Rule ID 1685 //
     /* 2351078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2351081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2351084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2351088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2351092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2351096 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2351096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2351101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351102 */     // GIR_Coverage, 1685,
     /* 2351102 */     GIR_Done,
     /* 2351103 */   // Label 32711: @2351103
     /* 2351103 */   GIM_Try, /*On fail goto*//*Label 32712*/ GIMT_Encode4(2351159), // Rule ID 1688 //
     /* 2351108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2351111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2351114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2351118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2351122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2351126 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2351126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2351129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2351133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351138 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351142 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2351145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2351150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351158 */     // GIR_Coverage, 1688,
     /* 2351158 */     GIR_EraseRootFromParent_Done,
     /* 2351159 */   // Label 32712: @2351159
     /* 2351159 */   GIM_Try, /*On fail goto*//*Label 32713*/ GIMT_Encode4(2351215), // Rule ID 1689 //
     /* 2351164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2351167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2351170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2351174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2351178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2351182 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2351182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2351185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2351189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351194 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351198 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2351201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2351206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351214 */     // GIR_Coverage, 1689,
     /* 2351214 */     GIR_EraseRootFromParent_Done,
     /* 2351215 */   // Label 32713: @2351215
     /* 2351215 */   GIM_Try, /*On fail goto*//*Label 32714*/ GIMT_Encode4(2351271), // Rule ID 2304 //
     /* 2351220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2351223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2351226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2351230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2351234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351238 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2351238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2351241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2351245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351254 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2351257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2351262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351270 */     // GIR_Coverage, 2304,
     /* 2351270 */     GIR_EraseRootFromParent_Done,
     /* 2351271 */   // Label 32714: @2351271
     /* 2351271 */   GIM_Try, /*On fail goto*//*Label 32715*/ GIMT_Encode4(2351327), // Rule ID 2305 //
     /* 2351276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2351279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2351282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2351286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2351290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351294 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2351294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2351297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2351301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351310 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2351313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2351318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351326 */     // GIR_Coverage, 2305,
     /* 2351326 */     GIR_EraseRootFromParent_Done,
     /* 2351327 */   // Label 32715: @2351327
     /* 2351327 */   GIM_Try, /*On fail goto*//*Label 32716*/ GIMT_Encode4(2351383), // Rule ID 2316 //
     /* 2351332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2351335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2351338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2351342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2351346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351350 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2351350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2351353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2351357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351366 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2351369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2351374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351382 */     // GIR_Coverage, 2316,
     /* 2351382 */     GIR_EraseRootFromParent_Done,
     /* 2351383 */   // Label 32716: @2351383
     /* 2351383 */   GIM_Try, /*On fail goto*//*Label 32717*/ GIMT_Encode4(2351439), // Rule ID 2317 //
     /* 2351388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2351391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2351394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2351398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2351402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351406 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2351406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2351409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2351413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351422 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2351425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2351430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351438 */     // GIR_Coverage, 2317,
     /* 2351438 */     GIR_EraseRootFromParent_Done,
     /* 2351439 */   // Label 32717: @2351439
     /* 2351439 */   GIM_Try, /*On fail goto*//*Label 32718*/ GIMT_Encode4(2351495), // Rule ID 2323 //
     /* 2351444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2351447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2351450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351462 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_INX:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2351462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2351465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2351469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351474 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351478 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2351481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2351486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351494 */     // GIR_Coverage, 2323,
     /* 2351494 */     GIR_EraseRootFromParent_Done,
     /* 2351495 */   // Label 32718: @2351495
     /* 2351495 */   GIM_Reject,
     /* 2351496 */ // Label 32702: @2351496
     /* 2351496 */ GIM_Reject,
     /* 2351497 */ // Label 32658: @2351497
     /* 2351497 */ GIM_Try, /*On fail goto*//*Label 32719*/ GIMT_Encode4(2351747),
     /* 2351502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2351505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2351508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351516 */   GIM_Try, /*On fail goto*//*Label 32720*/ GIMT_Encode4(2351582), // Rule ID 56254 //
     /* 2351521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2351524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2351536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351543 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2351546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2351560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351581 */     // GIR_Coverage, 56254,
     /* 2351581 */     GIR_EraseRootFromParent_Done,
     /* 2351582 */   // Label 32720: @2351582
     /* 2351582 */   GIM_Try, /*On fail goto*//*Label 32721*/ GIMT_Encode4(2351648), // Rule ID 56255 //
     /* 2351587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2351590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2351602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351609 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2351612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2351626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351647 */     // GIR_Coverage, 56255,
     /* 2351647 */     GIR_EraseRootFromParent_Done,
     /* 2351648 */   // Label 32721: @2351648
     /* 2351648 */   GIM_Try, /*On fail goto*//*Label 32722*/ GIMT_Encode4(2351697), // Rule ID 56248 //
     /* 2351653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2351656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351660 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2351663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2351677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351696 */     // GIR_Coverage, 56248,
     /* 2351696 */     GIR_EraseRootFromParent_Done,
     /* 2351697 */   // Label 32722: @2351697
     /* 2351697 */   GIM_Try, /*On fail goto*//*Label 32723*/ GIMT_Encode4(2351746), // Rule ID 56249 //
     /* 2351702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2351705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351709 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2351712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2351726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351745 */     // GIR_Coverage, 56249,
     /* 2351745 */     GIR_EraseRootFromParent_Done,
     /* 2351746 */   // Label 32723: @2351746
     /* 2351746 */   GIM_Reject,
     /* 2351747 */ // Label 32719: @2351747
     /* 2351747 */ GIM_Reject,
     /* 2351748 */ // Label 32659: @2351748
     /* 2351748 */ GIM_Try, /*On fail goto*//*Label 32724*/ GIMT_Encode4(2351998),
     /* 2351753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2351756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2351759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351767 */   GIM_Try, /*On fail goto*//*Label 32725*/ GIMT_Encode4(2351833), // Rule ID 56294 //
     /* 2351772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2351775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2351787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351794 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2351797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2351811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351832 */     // GIR_Coverage, 56294,
     /* 2351832 */     GIR_EraseRootFromParent_Done,
     /* 2351833 */   // Label 32725: @2351833
     /* 2351833 */   GIM_Try, /*On fail goto*//*Label 32726*/ GIMT_Encode4(2351899), // Rule ID 56295 //
     /* 2351838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2351841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2351853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351860 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2351863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2351877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351898 */     // GIR_Coverage, 56295,
     /* 2351898 */     GIR_EraseRootFromParent_Done,
     /* 2351899 */   // Label 32726: @2351899
     /* 2351899 */   GIM_Try, /*On fail goto*//*Label 32727*/ GIMT_Encode4(2351948), // Rule ID 56288 //
     /* 2351904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2351907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351911 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2351914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2351928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351947 */     // GIR_Coverage, 56288,
     /* 2351947 */     GIR_EraseRootFromParent_Done,
     /* 2351948 */   // Label 32727: @2351948
     /* 2351948 */   GIM_Try, /*On fail goto*//*Label 32728*/ GIMT_Encode4(2351997), // Rule ID 56289 //
     /* 2351953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2351956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351960 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2351963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2351977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351996 */     // GIR_Coverage, 56289,
     /* 2351996 */     GIR_EraseRootFromParent_Done,
     /* 2351997 */   // Label 32728: @2351997
     /* 2351997 */   GIM_Reject,
     /* 2351998 */ // Label 32724: @2351998
     /* 2351998 */ GIM_Reject,
     /* 2351999 */ // Label 32660: @2351999
     /* 2351999 */ GIM_Try, /*On fail goto*//*Label 32729*/ GIMT_Encode4(2352249),
     /* 2352004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2352007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2352010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352018 */   GIM_Try, /*On fail goto*//*Label 32730*/ GIMT_Encode4(2352084), // Rule ID 56354 //
     /* 2352023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2352026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2352038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352045 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2352048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2352062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352083 */     // GIR_Coverage, 56354,
     /* 2352083 */     GIR_EraseRootFromParent_Done,
     /* 2352084 */   // Label 32730: @2352084
     /* 2352084 */   GIM_Try, /*On fail goto*//*Label 32731*/ GIMT_Encode4(2352150), // Rule ID 56355 //
     /* 2352089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2352092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2352104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352111 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2352114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2352128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352149 */     // GIR_Coverage, 56355,
     /* 2352149 */     GIR_EraseRootFromParent_Done,
     /* 2352150 */   // Label 32731: @2352150
     /* 2352150 */   GIM_Try, /*On fail goto*//*Label 32732*/ GIMT_Encode4(2352199), // Rule ID 56348 //
     /* 2352155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2352158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352162 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2352165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2352179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352198 */     // GIR_Coverage, 56348,
     /* 2352198 */     GIR_EraseRootFromParent_Done,
     /* 2352199 */   // Label 32732: @2352199
     /* 2352199 */   GIM_Try, /*On fail goto*//*Label 32733*/ GIMT_Encode4(2352248), // Rule ID 56349 //
     /* 2352204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2352207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352211 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2352214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2352228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352247 */     // GIR_Coverage, 56349,
     /* 2352247 */     GIR_EraseRootFromParent_Done,
     /* 2352248 */   // Label 32733: @2352248
     /* 2352248 */   GIM_Reject,
     /* 2352249 */ // Label 32729: @2352249
     /* 2352249 */ GIM_Reject,
     /* 2352250 */ // Label 32661: @2352250
     /* 2352250 */ GIM_Try, /*On fail goto*//*Label 32734*/ GIMT_Encode4(2352500),
     /* 2352255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2352258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2352261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352269 */   GIM_Try, /*On fail goto*//*Label 32735*/ GIMT_Encode4(2352335), // Rule ID 56274 //
     /* 2352274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2352277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2352289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352296 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2352299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2352313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352334 */     // GIR_Coverage, 56274,
     /* 2352334 */     GIR_EraseRootFromParent_Done,
     /* 2352335 */   // Label 32735: @2352335
     /* 2352335 */   GIM_Try, /*On fail goto*//*Label 32736*/ GIMT_Encode4(2352401), // Rule ID 56275 //
     /* 2352340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2352343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2352355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352362 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2352365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2352379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352400 */     // GIR_Coverage, 56275,
     /* 2352400 */     GIR_EraseRootFromParent_Done,
     /* 2352401 */   // Label 32736: @2352401
     /* 2352401 */   GIM_Try, /*On fail goto*//*Label 32737*/ GIMT_Encode4(2352450), // Rule ID 56268 //
     /* 2352406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2352409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352413 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2352416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2352430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352449 */     // GIR_Coverage, 56268,
     /* 2352449 */     GIR_EraseRootFromParent_Done,
     /* 2352450 */   // Label 32737: @2352450
     /* 2352450 */   GIM_Try, /*On fail goto*//*Label 32738*/ GIMT_Encode4(2352499), // Rule ID 56269 //
     /* 2352455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2352458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352462 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2352465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2352479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352498 */     // GIR_Coverage, 56269,
     /* 2352498 */     GIR_EraseRootFromParent_Done,
     /* 2352499 */   // Label 32738: @2352499
     /* 2352499 */   GIM_Reject,
     /* 2352500 */ // Label 32734: @2352500
     /* 2352500 */ GIM_Reject,
     /* 2352501 */ // Label 32662: @2352501
     /* 2352501 */ GIM_Try, /*On fail goto*//*Label 32739*/ GIMT_Encode4(2352751),
     /* 2352506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2352509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2352512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352520 */   GIM_Try, /*On fail goto*//*Label 32740*/ GIMT_Encode4(2352586), // Rule ID 56334 //
     /* 2352525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2352528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2352540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352547 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2352550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2352564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352585 */     // GIR_Coverage, 56334,
     /* 2352585 */     GIR_EraseRootFromParent_Done,
     /* 2352586 */   // Label 32740: @2352586
     /* 2352586 */   GIM_Try, /*On fail goto*//*Label 32741*/ GIMT_Encode4(2352652), // Rule ID 56335 //
     /* 2352591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2352594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2352606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352613 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2352616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2352630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352651 */     // GIR_Coverage, 56335,
     /* 2352651 */     GIR_EraseRootFromParent_Done,
     /* 2352652 */   // Label 32741: @2352652
     /* 2352652 */   GIM_Try, /*On fail goto*//*Label 32742*/ GIMT_Encode4(2352701), // Rule ID 56328 //
     /* 2352657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2352660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352664 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2352667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2352681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352700 */     // GIR_Coverage, 56328,
     /* 2352700 */     GIR_EraseRootFromParent_Done,
     /* 2352701 */   // Label 32742: @2352701
     /* 2352701 */   GIM_Try, /*On fail goto*//*Label 32743*/ GIMT_Encode4(2352750), // Rule ID 56329 //
     /* 2352706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2352709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352713 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2352716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2352730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352749 */     // GIR_Coverage, 56329,
     /* 2352749 */     GIR_EraseRootFromParent_Done,
     /* 2352750 */   // Label 32743: @2352750
     /* 2352750 */   GIM_Reject,
     /* 2352751 */ // Label 32739: @2352751
     /* 2352751 */ GIM_Reject,
     /* 2352752 */ // Label 32663: @2352752
     /* 2352752 */ GIM_Try, /*On fail goto*//*Label 32744*/ GIMT_Encode4(2353002),
     /* 2352757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2352760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2352763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352771 */   GIM_Try, /*On fail goto*//*Label 32745*/ GIMT_Encode4(2352837), // Rule ID 56494 //
     /* 2352776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2352779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2352791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352798 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2352801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2352815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352836 */     // GIR_Coverage, 56494,
     /* 2352836 */     GIR_EraseRootFromParent_Done,
     /* 2352837 */   // Label 32745: @2352837
     /* 2352837 */   GIM_Try, /*On fail goto*//*Label 32746*/ GIMT_Encode4(2352903), // Rule ID 56495 //
     /* 2352842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2352845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2352857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352864 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2352867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2352881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352902 */     // GIR_Coverage, 56495,
     /* 2352902 */     GIR_EraseRootFromParent_Done,
     /* 2352903 */   // Label 32746: @2352903
     /* 2352903 */   GIM_Try, /*On fail goto*//*Label 32747*/ GIMT_Encode4(2352952), // Rule ID 56488 //
     /* 2352908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2352911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352915 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2352918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2352932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352951 */     // GIR_Coverage, 56488,
     /* 2352951 */     GIR_EraseRootFromParent_Done,
     /* 2352952 */   // Label 32747: @2352952
     /* 2352952 */   GIM_Try, /*On fail goto*//*Label 32748*/ GIMT_Encode4(2353001), // Rule ID 56489 //
     /* 2352957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2352960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352964 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2352967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2352981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353000 */     // GIR_Coverage, 56489,
     /* 2353000 */     GIR_EraseRootFromParent_Done,
     /* 2353001 */   // Label 32748: @2353001
     /* 2353001 */   GIM_Reject,
     /* 2353002 */ // Label 32744: @2353002
     /* 2353002 */ GIM_Reject,
     /* 2353003 */ // Label 32664: @2353003
     /* 2353003 */ GIM_Try, /*On fail goto*//*Label 32749*/ GIMT_Encode4(2353253),
     /* 2353008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2353011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2353014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353022 */   GIM_Try, /*On fail goto*//*Label 32750*/ GIMT_Encode4(2353088), // Rule ID 56314 //
     /* 2353027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2353042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353049 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2353052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2353066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353087 */     // GIR_Coverage, 56314,
     /* 2353087 */     GIR_EraseRootFromParent_Done,
     /* 2353088 */   // Label 32750: @2353088
     /* 2353088 */   GIM_Try, /*On fail goto*//*Label 32751*/ GIMT_Encode4(2353154), // Rule ID 56315 //
     /* 2353093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2353096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2353108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353115 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2353118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2353132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353153 */     // GIR_Coverage, 56315,
     /* 2353153 */     GIR_EraseRootFromParent_Done,
     /* 2353154 */   // Label 32751: @2353154
     /* 2353154 */   GIM_Try, /*On fail goto*//*Label 32752*/ GIMT_Encode4(2353203), // Rule ID 56308 //
     /* 2353159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353166 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2353169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2353183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353202 */     // GIR_Coverage, 56308,
     /* 2353202 */     GIR_EraseRootFromParent_Done,
     /* 2353203 */   // Label 32752: @2353203
     /* 2353203 */   GIM_Try, /*On fail goto*//*Label 32753*/ GIMT_Encode4(2353252), // Rule ID 56309 //
     /* 2353208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2353211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353215 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2353218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2353232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353251 */     // GIR_Coverage, 56309,
     /* 2353251 */     GIR_EraseRootFromParent_Done,
     /* 2353252 */   // Label 32753: @2353252
     /* 2353252 */   GIM_Reject,
     /* 2353253 */ // Label 32749: @2353253
     /* 2353253 */ GIM_Reject,
     /* 2353254 */ // Label 32665: @2353254
     /* 2353254 */ GIM_Try, /*On fail goto*//*Label 32754*/ GIMT_Encode4(2353504),
     /* 2353259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2353262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2353265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353273 */   GIM_Try, /*On fail goto*//*Label 32755*/ GIMT_Encode4(2353339), // Rule ID 56434 //
     /* 2353278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2353281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2353293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353300 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2353303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2353317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353338 */     // GIR_Coverage, 56434,
     /* 2353338 */     GIR_EraseRootFromParent_Done,
     /* 2353339 */   // Label 32755: @2353339
     /* 2353339 */   GIM_Try, /*On fail goto*//*Label 32756*/ GIMT_Encode4(2353405), // Rule ID 56435 //
     /* 2353344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2353347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2353359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353366 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2353369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2353383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353404 */     // GIR_Coverage, 56435,
     /* 2353404 */     GIR_EraseRootFromParent_Done,
     /* 2353405 */   // Label 32756: @2353405
     /* 2353405 */   GIM_Try, /*On fail goto*//*Label 32757*/ GIMT_Encode4(2353454), // Rule ID 56428 //
     /* 2353410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2353413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353417 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2353420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2353434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353453 */     // GIR_Coverage, 56428,
     /* 2353453 */     GIR_EraseRootFromParent_Done,
     /* 2353454 */   // Label 32757: @2353454
     /* 2353454 */   GIM_Try, /*On fail goto*//*Label 32758*/ GIMT_Encode4(2353503), // Rule ID 56429 //
     /* 2353459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2353462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353466 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2353469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2353483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353502 */     // GIR_Coverage, 56429,
     /* 2353502 */     GIR_EraseRootFromParent_Done,
     /* 2353503 */   // Label 32758: @2353503
     /* 2353503 */   GIM_Reject,
     /* 2353504 */ // Label 32754: @2353504
     /* 2353504 */ GIM_Reject,
     /* 2353505 */ // Label 32666: @2353505
     /* 2353505 */ GIM_Try, /*On fail goto*//*Label 32759*/ GIMT_Encode4(2353755),
     /* 2353510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2353513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2353516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353524 */   GIM_Try, /*On fail goto*//*Label 32760*/ GIMT_Encode4(2353590), // Rule ID 56514 //
     /* 2353529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2353532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2353544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353551 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2353554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2353568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353589 */     // GIR_Coverage, 56514,
     /* 2353589 */     GIR_EraseRootFromParent_Done,
     /* 2353590 */   // Label 32760: @2353590
     /* 2353590 */   GIM_Try, /*On fail goto*//*Label 32761*/ GIMT_Encode4(2353656), // Rule ID 56515 //
     /* 2353595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2353598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2353610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353617 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2353620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2353634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353655 */     // GIR_Coverage, 56515,
     /* 2353655 */     GIR_EraseRootFromParent_Done,
     /* 2353656 */   // Label 32761: @2353656
     /* 2353656 */   GIM_Try, /*On fail goto*//*Label 32762*/ GIMT_Encode4(2353705), // Rule ID 56508 //
     /* 2353661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2353664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353668 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2353671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2353685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353704 */     // GIR_Coverage, 56508,
     /* 2353704 */     GIR_EraseRootFromParent_Done,
     /* 2353705 */   // Label 32762: @2353705
     /* 2353705 */   GIM_Try, /*On fail goto*//*Label 32763*/ GIMT_Encode4(2353754), // Rule ID 56509 //
     /* 2353710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2353713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353717 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2353720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2353734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353753 */     // GIR_Coverage, 56509,
     /* 2353753 */     GIR_EraseRootFromParent_Done,
     /* 2353754 */   // Label 32763: @2353754
     /* 2353754 */   GIM_Reject,
     /* 2353755 */ // Label 32759: @2353755
     /* 2353755 */ GIM_Reject,
     /* 2353756 */ // Label 32667: @2353756
     /* 2353756 */ GIM_Try, /*On fail goto*//*Label 32764*/ GIMT_Encode4(2354006),
     /* 2353761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2353764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2353767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353775 */   GIM_Try, /*On fail goto*//*Label 32765*/ GIMT_Encode4(2353841), // Rule ID 56374 //
     /* 2353780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2353795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353802 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2353805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2353819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353840 */     // GIR_Coverage, 56374,
     /* 2353840 */     GIR_EraseRootFromParent_Done,
     /* 2353841 */   // Label 32765: @2353841
     /* 2353841 */   GIM_Try, /*On fail goto*//*Label 32766*/ GIMT_Encode4(2353907), // Rule ID 56375 //
     /* 2353846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2353849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2353861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353868 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2353871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2353885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353906 */     // GIR_Coverage, 56375,
     /* 2353906 */     GIR_EraseRootFromParent_Done,
     /* 2353907 */   // Label 32766: @2353907
     /* 2353907 */   GIM_Try, /*On fail goto*//*Label 32767*/ GIMT_Encode4(2353956), // Rule ID 56368 //
     /* 2353912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353919 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2353922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2353936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353955 */     // GIR_Coverage, 56368,
     /* 2353955 */     GIR_EraseRootFromParent_Done,
     /* 2353956 */   // Label 32767: @2353956
     /* 2353956 */   GIM_Try, /*On fail goto*//*Label 32768*/ GIMT_Encode4(2354005), // Rule ID 56369 //
     /* 2353961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2353964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353968 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2353971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2353985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354004 */     // GIR_Coverage, 56369,
     /* 2354004 */     GIR_EraseRootFromParent_Done,
     /* 2354005 */   // Label 32768: @2354005
     /* 2354005 */   GIM_Reject,
     /* 2354006 */ // Label 32764: @2354006
     /* 2354006 */ GIM_Reject,
     /* 2354007 */ // Label 32668: @2354007
     /* 2354007 */ GIM_Try, /*On fail goto*//*Label 32769*/ GIMT_Encode4(2354257),
     /* 2354012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2354015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2354018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354026 */   GIM_Try, /*On fail goto*//*Label 32770*/ GIMT_Encode4(2354092), // Rule ID 56454 //
     /* 2354031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2354046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354053 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2354056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2354070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354091 */     // GIR_Coverage, 56454,
     /* 2354091 */     GIR_EraseRootFromParent_Done,
     /* 2354092 */   // Label 32770: @2354092
     /* 2354092 */   GIM_Try, /*On fail goto*//*Label 32771*/ GIMT_Encode4(2354158), // Rule ID 56455 //
     /* 2354097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2354112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354119 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2354122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2354136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354157 */     // GIR_Coverage, 56455,
     /* 2354157 */     GIR_EraseRootFromParent_Done,
     /* 2354158 */   // Label 32771: @2354158
     /* 2354158 */   GIM_Try, /*On fail goto*//*Label 32772*/ GIMT_Encode4(2354207), // Rule ID 56448 //
     /* 2354163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354170 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2354173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2354187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354206 */     // GIR_Coverage, 56448,
     /* 2354206 */     GIR_EraseRootFromParent_Done,
     /* 2354207 */   // Label 32772: @2354207
     /* 2354207 */   GIM_Try, /*On fail goto*//*Label 32773*/ GIMT_Encode4(2354256), // Rule ID 56449 //
     /* 2354212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354219 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2354222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2354236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354255 */     // GIR_Coverage, 56449,
     /* 2354255 */     GIR_EraseRootFromParent_Done,
     /* 2354256 */   // Label 32773: @2354256
     /* 2354256 */   GIM_Reject,
     /* 2354257 */ // Label 32769: @2354257
     /* 2354257 */ GIM_Reject,
     /* 2354258 */ // Label 32669: @2354258
     /* 2354258 */ GIM_Try, /*On fail goto*//*Label 32774*/ GIMT_Encode4(2354508),
     /* 2354263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2354266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2354269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354277 */   GIM_Try, /*On fail goto*//*Label 32775*/ GIMT_Encode4(2354343), // Rule ID 56534 //
     /* 2354282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2354285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2354297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354304 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2354307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2354321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354342 */     // GIR_Coverage, 56534,
     /* 2354342 */     GIR_EraseRootFromParent_Done,
     /* 2354343 */   // Label 32775: @2354343
     /* 2354343 */   GIM_Try, /*On fail goto*//*Label 32776*/ GIMT_Encode4(2354409), // Rule ID 56535 //
     /* 2354348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2354351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2354363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354370 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2354373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2354387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354408 */     // GIR_Coverage, 56535,
     /* 2354408 */     GIR_EraseRootFromParent_Done,
     /* 2354409 */   // Label 32776: @2354409
     /* 2354409 */   GIM_Try, /*On fail goto*//*Label 32777*/ GIMT_Encode4(2354458), // Rule ID 56528 //
     /* 2354414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2354417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354421 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2354424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2354438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354457 */     // GIR_Coverage, 56528,
     /* 2354457 */     GIR_EraseRootFromParent_Done,
     /* 2354458 */   // Label 32777: @2354458
     /* 2354458 */   GIM_Try, /*On fail goto*//*Label 32778*/ GIMT_Encode4(2354507), // Rule ID 56529 //
     /* 2354463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2354466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354470 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2354473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2354487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354506 */     // GIR_Coverage, 56529,
     /* 2354506 */     GIR_EraseRootFromParent_Done,
     /* 2354507 */   // Label 32778: @2354507
     /* 2354507 */   GIM_Reject,
     /* 2354508 */ // Label 32774: @2354508
     /* 2354508 */ GIM_Reject,
     /* 2354509 */ // Label 32670: @2354509
     /* 2354509 */ GIM_Try, /*On fail goto*//*Label 32779*/ GIMT_Encode4(2354759),
     /* 2354514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2354517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2354520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354528 */   GIM_Try, /*On fail goto*//*Label 32780*/ GIMT_Encode4(2354594), // Rule ID 56394 //
     /* 2354533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2354548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354555 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2354572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354593 */     // GIR_Coverage, 56394,
     /* 2354593 */     GIR_EraseRootFromParent_Done,
     /* 2354594 */   // Label 32780: @2354594
     /* 2354594 */   GIM_Try, /*On fail goto*//*Label 32781*/ GIMT_Encode4(2354660), // Rule ID 56395 //
     /* 2354599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2354614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354621 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2354638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354659 */     // GIR_Coverage, 56395,
     /* 2354659 */     GIR_EraseRootFromParent_Done,
     /* 2354660 */   // Label 32781: @2354660
     /* 2354660 */   GIM_Try, /*On fail goto*//*Label 32782*/ GIMT_Encode4(2354709), // Rule ID 56388 //
     /* 2354665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354672 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2354689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354708 */     // GIR_Coverage, 56388,
     /* 2354708 */     GIR_EraseRootFromParent_Done,
     /* 2354709 */   // Label 32782: @2354709
     /* 2354709 */   GIM_Try, /*On fail goto*//*Label 32783*/ GIMT_Encode4(2354758), // Rule ID 56389 //
     /* 2354714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354721 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2354738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354757 */     // GIR_Coverage, 56389,
     /* 2354757 */     GIR_EraseRootFromParent_Done,
     /* 2354758 */   // Label 32783: @2354758
     /* 2354758 */   GIM_Reject,
     /* 2354759 */ // Label 32779: @2354759
     /* 2354759 */ GIM_Reject,
     /* 2354760 */ // Label 32671: @2354760
     /* 2354760 */ GIM_Try, /*On fail goto*//*Label 32784*/ GIMT_Encode4(2355010),
     /* 2354765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2354768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2354771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354779 */   GIM_Try, /*On fail goto*//*Label 32785*/ GIMT_Encode4(2354845), // Rule ID 56474 //
     /* 2354784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2354799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354806 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2354809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2354823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354844 */     // GIR_Coverage, 56474,
     /* 2354844 */     GIR_EraseRootFromParent_Done,
     /* 2354845 */   // Label 32785: @2354845
     /* 2354845 */   GIM_Try, /*On fail goto*//*Label 32786*/ GIMT_Encode4(2354911), // Rule ID 56475 //
     /* 2354850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2354865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354872 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2354875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2354889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354910 */     // GIR_Coverage, 56475,
     /* 2354910 */     GIR_EraseRootFromParent_Done,
     /* 2354911 */   // Label 32786: @2354911
     /* 2354911 */   GIM_Try, /*On fail goto*//*Label 32787*/ GIMT_Encode4(2354960), // Rule ID 56468 //
     /* 2354916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354923 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2354926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2354940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354959 */     // GIR_Coverage, 56468,
     /* 2354959 */     GIR_EraseRootFromParent_Done,
     /* 2354960 */   // Label 32787: @2354960
     /* 2354960 */   GIM_Try, /*On fail goto*//*Label 32788*/ GIMT_Encode4(2355009), // Rule ID 56469 //
     /* 2354965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354972 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2354975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2354989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355008 */     // GIR_Coverage, 56469,
     /* 2355008 */     GIR_EraseRootFromParent_Done,
     /* 2355009 */   // Label 32788: @2355009
     /* 2355009 */   GIM_Reject,
     /* 2355010 */ // Label 32784: @2355010
     /* 2355010 */ GIM_Reject,
     /* 2355011 */ // Label 32672: @2355011
     /* 2355011 */ GIM_Try, /*On fail goto*//*Label 32789*/ GIMT_Encode4(2355261),
     /* 2355016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2355019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2355022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355030 */   GIM_Try, /*On fail goto*//*Label 32790*/ GIMT_Encode4(2355096), // Rule ID 56414 //
     /* 2355035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2355038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2355050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355057 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2355060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2355074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355095 */     // GIR_Coverage, 56414,
     /* 2355095 */     GIR_EraseRootFromParent_Done,
     /* 2355096 */   // Label 32790: @2355096
     /* 2355096 */   GIM_Try, /*On fail goto*//*Label 32791*/ GIMT_Encode4(2355162), // Rule ID 56415 //
     /* 2355101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2355104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2355116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355123 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2355126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2355140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355161 */     // GIR_Coverage, 56415,
     /* 2355161 */     GIR_EraseRootFromParent_Done,
     /* 2355162 */   // Label 32791: @2355162
     /* 2355162 */   GIM_Try, /*On fail goto*//*Label 32792*/ GIMT_Encode4(2355211), // Rule ID 56408 //
     /* 2355167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2355170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355174 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2355177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2355191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355210 */     // GIR_Coverage, 56408,
     /* 2355210 */     GIR_EraseRootFromParent_Done,
     /* 2355211 */   // Label 32792: @2355211
     /* 2355211 */   GIM_Try, /*On fail goto*//*Label 32793*/ GIMT_Encode4(2355260), // Rule ID 56409 //
     /* 2355216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2355219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355223 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2355226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2355240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355259 */     // GIR_Coverage, 56409,
     /* 2355259 */     GIR_EraseRootFromParent_Done,
     /* 2355260 */   // Label 32793: @2355260
     /* 2355260 */   GIM_Reject,
     /* 2355261 */ // Label 32789: @2355261
     /* 2355261 */ GIM_Reject,
     /* 2355262 */ // Label 32673: @2355262
     /* 2355262 */ GIM_Reject,
     /* 2355263 */ // Label 73: @2355263
     /* 2355263 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32797*/ GIMT_Encode4(2355452),
     /* 2355274 */ /*GILLT_s16*//*Label 32794*/ GIMT_Encode4(2355286),
     /* 2355278 */ /*GILLT_s32*//*Label 32795*/ GIMT_Encode4(2355336),
     /* 2355282 */ /*GILLT_s64*//*Label 32796*/ GIMT_Encode4(2355386),
     /* 2355286 */ // Label 32794: @2355286
     /* 2355286 */ GIM_Try, /*On fail goto*//*Label 32798*/ GIMT_Encode4(2355335),
     /* 2355291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2355294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355302 */   GIM_Try, /*On fail goto*//*Label 32799*/ GIMT_Encode4(2355318), // Rule ID 2066 //
     /* 2355307 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2355307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2355310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355317 */     // GIR_Coverage, 2066,
     /* 2355317 */     GIR_EraseRootFromParent_Done,
     /* 2355318 */   // Label 32799: @2355318
     /* 2355318 */   GIM_Try, /*On fail goto*//*Label 32800*/ GIMT_Encode4(2355334), // Rule ID 2067 //
     /* 2355323 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2355323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2355326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355333 */     // GIR_Coverage, 2067,
     /* 2355333 */     GIR_EraseRootFromParent_Done,
     /* 2355334 */   // Label 32800: @2355334
     /* 2355334 */   GIM_Reject,
     /* 2355335 */ // Label 32798: @2355335
     /* 2355335 */ GIM_Reject,
     /* 2355336 */ // Label 32795: @2355336
     /* 2355336 */ GIM_Try, /*On fail goto*//*Label 32801*/ GIMT_Encode4(2355385),
     /* 2355341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2355344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355352 */   GIM_Try, /*On fail goto*//*Label 32802*/ GIMT_Encode4(2355368), // Rule ID 1353 //
     /* 2355357 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2355357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2355360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355367 */     // GIR_Coverage, 1353,
     /* 2355367 */     GIR_EraseRootFromParent_Done,
     /* 2355368 */   // Label 32802: @2355368
     /* 2355368 */   GIM_Try, /*On fail goto*//*Label 32803*/ GIMT_Encode4(2355384), // Rule ID 1354 //
     /* 2355373 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2355373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2355376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355383 */     // GIR_Coverage, 1354,
     /* 2355383 */     GIR_EraseRootFromParent_Done,
     /* 2355384 */   // Label 32803: @2355384
     /* 2355384 */   GIM_Reject,
     /* 2355385 */ // Label 32801: @2355385
     /* 2355385 */ GIM_Reject,
     /* 2355386 */ // Label 32796: @2355386
     /* 2355386 */ GIM_Try, /*On fail goto*//*Label 32804*/ GIMT_Encode4(2355451),
     /* 2355391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2355394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355402 */   GIM_Try, /*On fail goto*//*Label 32805*/ GIMT_Encode4(2355418), // Rule ID 1730 //
     /* 2355407 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2355407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2355410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355417 */     // GIR_Coverage, 1730,
     /* 2355417 */     GIR_EraseRootFromParent_Done,
     /* 2355418 */   // Label 32805: @2355418
     /* 2355418 */   GIM_Try, /*On fail goto*//*Label 32806*/ GIMT_Encode4(2355434), // Rule ID 1731 //
     /* 2355423 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2355423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2355426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355433 */     // GIR_Coverage, 1731,
     /* 2355433 */     GIR_EraseRootFromParent_Done,
     /* 2355434 */   // Label 32806: @2355434
     /* 2355434 */   GIM_Try, /*On fail goto*//*Label 32807*/ GIMT_Encode4(2355450), // Rule ID 1732 //
     /* 2355439 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2355439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2355442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355449 */     // GIR_Coverage, 1732,
     /* 2355449 */     GIR_EraseRootFromParent_Done,
     /* 2355450 */   // Label 32807: @2355450
     /* 2355450 */   GIM_Reject,
     /* 2355451 */ // Label 32804: @2355451
     /* 2355451 */ GIM_Reject,
     /* 2355452 */ // Label 32797: @2355452
     /* 2355452 */ GIM_Reject,
     /* 2355453 */ // Label 74: @2355453
     /* 2355453 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32826*/ GIMT_Encode4(2357537),
     /* 2355464 */ /*GILLT_s16*//*Label 32808*/ GIMT_Encode4(2355584),
     /* 2355468 */ /*GILLT_s32*//*Label 32809*/ GIMT_Encode4(2355651),
     /* 2355472 */ /*GILLT_s64*//*Label 32810*/ GIMT_Encode4(2355718), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355484 */ /*GILLT_nxv1s16*//*Label 32811*/ GIMT_Encode4(2355812),
     /* 2355488 */ /*GILLT_nxv1s32*//*Label 32812*/ GIMT_Encode4(2355927),
     /* 2355492 */ /*GILLT_nxv1s64*//*Label 32813*/ GIMT_Encode4(2356042), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355504 */ /*GILLT_nxv2s16*//*Label 32814*/ GIMT_Encode4(2356157),
     /* 2355508 */ /*GILLT_nxv2s32*//*Label 32815*/ GIMT_Encode4(2356272),
     /* 2355512 */ /*GILLT_nxv2s64*//*Label 32816*/ GIMT_Encode4(2356387), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355524 */ /*GILLT_nxv4s16*//*Label 32817*/ GIMT_Encode4(2356502),
     /* 2355528 */ /*GILLT_nxv4s32*//*Label 32818*/ GIMT_Encode4(2356617),
     /* 2355532 */ /*GILLT_nxv4s64*//*Label 32819*/ GIMT_Encode4(2356732), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355544 */ /*GILLT_nxv8s16*//*Label 32820*/ GIMT_Encode4(2356847),
     /* 2355548 */ /*GILLT_nxv8s32*//*Label 32821*/ GIMT_Encode4(2356962),
     /* 2355552 */ /*GILLT_nxv8s64*//*Label 32822*/ GIMT_Encode4(2357077), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355564 */ /*GILLT_nxv16s16*//*Label 32823*/ GIMT_Encode4(2357192),
     /* 2355568 */ /*GILLT_nxv16s32*//*Label 32824*/ GIMT_Encode4(2357307), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355580 */ /*GILLT_nxv32s16*//*Label 32825*/ GIMT_Encode4(2357422),
     /* 2355584 */ // Label 32808: @2355584
     /* 2355584 */ GIM_Try, /*On fail goto*//*Label 32827*/ GIMT_Encode4(2355650),
     /* 2355589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2355592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2355595 */   GIM_Try, /*On fail goto*//*Label 32828*/ GIMT_Encode4(2355622), // Rule ID 2054 //
     /* 2355600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2355603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355615 */     // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2355615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2355620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355621 */     // GIR_Coverage, 2054,
     /* 2355621 */     GIR_Done,
     /* 2355622 */   // Label 32828: @2355622
     /* 2355622 */   GIM_Try, /*On fail goto*//*Label 32829*/ GIMT_Encode4(2355649), // Rule ID 2055 //
     /* 2355627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2355630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355642 */     // (fminnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2355642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2355647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355648 */     // GIR_Coverage, 2055,
     /* 2355648 */     GIR_Done,
     /* 2355649 */   // Label 32829: @2355649
     /* 2355649 */   GIM_Reject,
     /* 2355650 */ // Label 32827: @2355650
     /* 2355650 */ GIM_Reject,
     /* 2355651 */ // Label 32809: @2355651
     /* 2355651 */ GIM_Try, /*On fail goto*//*Label 32830*/ GIMT_Encode4(2355717),
     /* 2355656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2355659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355662 */   GIM_Try, /*On fail goto*//*Label 32831*/ GIMT_Encode4(2355689), // Rule ID 1341 //
     /* 2355667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2355670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355682 */     // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2355682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2355687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355688 */     // GIR_Coverage, 1341,
     /* 2355688 */     GIR_Done,
     /* 2355689 */   // Label 32831: @2355689
     /* 2355689 */   GIM_Try, /*On fail goto*//*Label 32832*/ GIMT_Encode4(2355716), // Rule ID 1342 //
     /* 2355694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2355697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355709 */     // (fminnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2355709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2355714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355715 */     // GIR_Coverage, 1342,
     /* 2355715 */     GIR_Done,
     /* 2355716 */   // Label 32832: @2355716
     /* 2355716 */   GIM_Reject,
     /* 2355717 */ // Label 32830: @2355717
     /* 2355717 */ GIM_Reject,
     /* 2355718 */ // Label 32810: @2355718
     /* 2355718 */ GIM_Try, /*On fail goto*//*Label 32833*/ GIMT_Encode4(2355811),
     /* 2355723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2355726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355729 */   GIM_Try, /*On fail goto*//*Label 32834*/ GIMT_Encode4(2355756), // Rule ID 1712 //
     /* 2355734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2355737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355749 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2355749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2355754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355755 */     // GIR_Coverage, 1712,
     /* 2355755 */     GIR_Done,
     /* 2355756 */   // Label 32834: @2355756
     /* 2355756 */   GIM_Try, /*On fail goto*//*Label 32835*/ GIMT_Encode4(2355783), // Rule ID 1713 //
     /* 2355761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2355764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2355768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2355772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2355776 */     // (fminnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2355776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2355781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355782 */     // GIR_Coverage, 1713,
     /* 2355782 */     GIR_Done,
     /* 2355783 */   // Label 32835: @2355783
     /* 2355783 */   GIM_Try, /*On fail goto*//*Label 32836*/ GIMT_Encode4(2355810), // Rule ID 1714 //
     /* 2355788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2355791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355803 */     // (fminnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2355803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2355808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355809 */     // GIR_Coverage, 1714,
     /* 2355809 */     GIR_Done,
     /* 2355810 */   // Label 32836: @2355810
     /* 2355810 */   GIM_Reject,
     /* 2355811 */ // Label 32833: @2355811
     /* 2355811 */ GIM_Reject,
     /* 2355812 */ // Label 32811: @2355812
     /* 2355812 */ GIM_Try, /*On fail goto*//*Label 32837*/ GIMT_Encode4(2355926),
     /* 2355817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2355820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2355823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355835 */   GIM_Try, /*On fail goto*//*Label 32838*/ GIMT_Encode4(2355880), // Rule ID 45756 //
     /* 2355840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2355843 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2355846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2355860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355879 */     // GIR_Coverage, 45756,
     /* 2355879 */     GIR_EraseRootFromParent_Done,
     /* 2355880 */   // Label 32838: @2355880
     /* 2355880 */   GIM_Try, /*On fail goto*//*Label 32839*/ GIMT_Encode4(2355925), // Rule ID 45757 //
     /* 2355885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2355888 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2355891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2355905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355924 */     // GIR_Coverage, 45757,
     /* 2355924 */     GIR_EraseRootFromParent_Done,
     /* 2355925 */   // Label 32839: @2355925
     /* 2355925 */   GIM_Reject,
     /* 2355926 */ // Label 32837: @2355926
     /* 2355926 */ GIM_Reject,
     /* 2355927 */ // Label 32812: @2355927
     /* 2355927 */ GIM_Try, /*On fail goto*//*Label 32840*/ GIMT_Encode4(2356041),
     /* 2355932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2355935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2355938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355950 */   GIM_Try, /*On fail goto*//*Label 32841*/ GIMT_Encode4(2355995), // Rule ID 56546 //
     /* 2355955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2355958 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2355961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2355975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355994 */     // GIR_Coverage, 56546,
     /* 2355994 */     GIR_EraseRootFromParent_Done,
     /* 2355995 */   // Label 32841: @2355995
     /* 2355995 */   GIM_Try, /*On fail goto*//*Label 32842*/ GIMT_Encode4(2356040), // Rule ID 56547 //
     /* 2356000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2356003 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2356006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2356020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356039 */     // GIR_Coverage, 56547,
     /* 2356039 */     GIR_EraseRootFromParent_Done,
     /* 2356040 */   // Label 32842: @2356040
     /* 2356040 */   GIM_Reject,
     /* 2356041 */ // Label 32840: @2356041
     /* 2356041 */ GIM_Reject,
     /* 2356042 */ // Label 32813: @2356042
     /* 2356042 */ GIM_Try, /*On fail goto*//*Label 32843*/ GIMT_Encode4(2356156),
     /* 2356047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2356050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2356053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356065 */   GIM_Try, /*On fail goto*//*Label 32844*/ GIMT_Encode4(2356110), // Rule ID 56564 //
     /* 2356070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2356073 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2356076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2356090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356109 */     // GIR_Coverage, 56564,
     /* 2356109 */     GIR_EraseRootFromParent_Done,
     /* 2356110 */   // Label 32844: @2356110
     /* 2356110 */   GIM_Try, /*On fail goto*//*Label 32845*/ GIMT_Encode4(2356155), // Rule ID 56565 //
     /* 2356115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2356118 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2356121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2356135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356154 */     // GIR_Coverage, 56565,
     /* 2356154 */     GIR_EraseRootFromParent_Done,
     /* 2356155 */   // Label 32845: @2356155
     /* 2356155 */   GIM_Reject,
     /* 2356156 */ // Label 32843: @2356156
     /* 2356156 */ GIM_Reject,
     /* 2356157 */ // Label 32814: @2356157
     /* 2356157 */ GIM_Try, /*On fail goto*//*Label 32846*/ GIMT_Encode4(2356271),
     /* 2356162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2356165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2356168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356180 */   GIM_Try, /*On fail goto*//*Label 32847*/ GIMT_Encode4(2356225), // Rule ID 56540 //
     /* 2356185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2356188 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2356191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2356205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356224 */     // GIR_Coverage, 56540,
     /* 2356224 */     GIR_EraseRootFromParent_Done,
     /* 2356225 */   // Label 32847: @2356225
     /* 2356225 */   GIM_Try, /*On fail goto*//*Label 32848*/ GIMT_Encode4(2356270), // Rule ID 56541 //
     /* 2356230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2356233 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2356236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2356250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356269 */     // GIR_Coverage, 56541,
     /* 2356269 */     GIR_EraseRootFromParent_Done,
     /* 2356270 */   // Label 32848: @2356270
     /* 2356270 */   GIM_Reject,
     /* 2356271 */ // Label 32846: @2356271
     /* 2356271 */ GIM_Reject,
     /* 2356272 */ // Label 32815: @2356272
     /* 2356272 */ GIM_Try, /*On fail goto*//*Label 32849*/ GIMT_Encode4(2356386),
     /* 2356277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2356280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2356283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356295 */   GIM_Try, /*On fail goto*//*Label 32850*/ GIMT_Encode4(2356340), // Rule ID 56558 //
     /* 2356300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2356303 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2356306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2356320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356339 */     // GIR_Coverage, 56558,
     /* 2356339 */     GIR_EraseRootFromParent_Done,
     /* 2356340 */   // Label 32850: @2356340
     /* 2356340 */   GIM_Try, /*On fail goto*//*Label 32851*/ GIMT_Encode4(2356385), // Rule ID 56559 //
     /* 2356345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2356348 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2356351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2356365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356384 */     // GIR_Coverage, 56559,
     /* 2356384 */     GIR_EraseRootFromParent_Done,
     /* 2356385 */   // Label 32851: @2356385
     /* 2356385 */   GIM_Reject,
     /* 2356386 */ // Label 32849: @2356386
     /* 2356386 */ GIM_Reject,
     /* 2356387 */ // Label 32816: @2356387
     /* 2356387 */ GIM_Try, /*On fail goto*//*Label 32852*/ GIMT_Encode4(2356501),
     /* 2356392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2356395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2356398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356410 */   GIM_Try, /*On fail goto*//*Label 32853*/ GIMT_Encode4(2356455), // Rule ID 56606 //
     /* 2356415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2356418 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2356421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2356435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356454 */     // GIR_Coverage, 56606,
     /* 2356454 */     GIR_EraseRootFromParent_Done,
     /* 2356455 */   // Label 32853: @2356455
     /* 2356455 */   GIM_Try, /*On fail goto*//*Label 32854*/ GIMT_Encode4(2356500), // Rule ID 56607 //
     /* 2356460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2356463 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2356466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2356480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356499 */     // GIR_Coverage, 56607,
     /* 2356499 */     GIR_EraseRootFromParent_Done,
     /* 2356500 */   // Label 32854: @2356500
     /* 2356500 */   GIM_Reject,
     /* 2356501 */ // Label 32852: @2356501
     /* 2356501 */ GIM_Reject,
     /* 2356502 */ // Label 32817: @2356502
     /* 2356502 */ GIM_Try, /*On fail goto*//*Label 32855*/ GIMT_Encode4(2356616),
     /* 2356507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2356510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2356513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356525 */   GIM_Try, /*On fail goto*//*Label 32856*/ GIMT_Encode4(2356570), // Rule ID 56552 //
     /* 2356530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2356533 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2356536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2356550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356569 */     // GIR_Coverage, 56552,
     /* 2356569 */     GIR_EraseRootFromParent_Done,
     /* 2356570 */   // Label 32856: @2356570
     /* 2356570 */   GIM_Try, /*On fail goto*//*Label 32857*/ GIMT_Encode4(2356615), // Rule ID 56553 //
     /* 2356575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2356578 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2356581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2356595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356614 */     // GIR_Coverage, 56553,
     /* 2356614 */     GIR_EraseRootFromParent_Done,
     /* 2356615 */   // Label 32857: @2356615
     /* 2356615 */   GIM_Reject,
     /* 2356616 */ // Label 32855: @2356616
     /* 2356616 */ GIM_Reject,
     /* 2356617 */ // Label 32818: @2356617
     /* 2356617 */ GIM_Try, /*On fail goto*//*Label 32858*/ GIMT_Encode4(2356731),
     /* 2356622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2356625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2356628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356640 */   GIM_Try, /*On fail goto*//*Label 32859*/ GIMT_Encode4(2356685), // Rule ID 56588 //
     /* 2356645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2356648 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2356651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2356665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356684 */     // GIR_Coverage, 56588,
     /* 2356684 */     GIR_EraseRootFromParent_Done,
     /* 2356685 */   // Label 32859: @2356685
     /* 2356685 */   GIM_Try, /*On fail goto*//*Label 32860*/ GIMT_Encode4(2356730), // Rule ID 56589 //
     /* 2356690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2356693 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2356696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2356710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356729 */     // GIR_Coverage, 56589,
     /* 2356729 */     GIR_EraseRootFromParent_Done,
     /* 2356730 */   // Label 32860: @2356730
     /* 2356730 */   GIM_Reject,
     /* 2356731 */ // Label 32858: @2356731
     /* 2356731 */ GIM_Reject,
     /* 2356732 */ // Label 32819: @2356732
     /* 2356732 */ GIM_Try, /*On fail goto*//*Label 32861*/ GIMT_Encode4(2356846),
     /* 2356737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2356740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2356743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356755 */   GIM_Try, /*On fail goto*//*Label 32862*/ GIMT_Encode4(2356800), // Rule ID 56612 //
     /* 2356760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2356763 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2356766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2356780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356799 */     // GIR_Coverage, 56612,
     /* 2356799 */     GIR_EraseRootFromParent_Done,
     /* 2356800 */   // Label 32862: @2356800
     /* 2356800 */   GIM_Try, /*On fail goto*//*Label 32863*/ GIMT_Encode4(2356845), // Rule ID 56613 //
     /* 2356805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2356808 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2356811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2356825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356844 */     // GIR_Coverage, 56613,
     /* 2356844 */     GIR_EraseRootFromParent_Done,
     /* 2356845 */   // Label 32863: @2356845
     /* 2356845 */   GIM_Reject,
     /* 2356846 */ // Label 32861: @2356846
     /* 2356846 */ GIM_Reject,
     /* 2356847 */ // Label 32820: @2356847
     /* 2356847 */ GIM_Try, /*On fail goto*//*Label 32864*/ GIMT_Encode4(2356961),
     /* 2356852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2356855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2356858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356870 */   GIM_Try, /*On fail goto*//*Label 32865*/ GIMT_Encode4(2356915), // Rule ID 56570 //
     /* 2356875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2356878 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2356881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2356895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356914 */     // GIR_Coverage, 56570,
     /* 2356914 */     GIR_EraseRootFromParent_Done,
     /* 2356915 */   // Label 32865: @2356915
     /* 2356915 */   GIM_Try, /*On fail goto*//*Label 32866*/ GIMT_Encode4(2356960), // Rule ID 56571 //
     /* 2356920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2356923 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2356926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2356940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356959 */     // GIR_Coverage, 56571,
     /* 2356959 */     GIR_EraseRootFromParent_Done,
     /* 2356960 */   // Label 32866: @2356960
     /* 2356960 */   GIM_Reject,
     /* 2356961 */ // Label 32864: @2356961
     /* 2356961 */ GIM_Reject,
     /* 2356962 */ // Label 32821: @2356962
     /* 2356962 */ GIM_Try, /*On fail goto*//*Label 32867*/ GIMT_Encode4(2357076),
     /* 2356967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2356970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2356973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356985 */   GIM_Try, /*On fail goto*//*Label 32868*/ GIMT_Encode4(2357030), // Rule ID 56594 //
     /* 2356990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2356993 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2356996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2357010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357029 */     // GIR_Coverage, 56594,
     /* 2357029 */     GIR_EraseRootFromParent_Done,
     /* 2357030 */   // Label 32868: @2357030
     /* 2357030 */   GIM_Try, /*On fail goto*//*Label 32869*/ GIMT_Encode4(2357075), // Rule ID 56595 //
     /* 2357035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2357038 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2357041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2357055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357074 */     // GIR_Coverage, 56595,
     /* 2357074 */     GIR_EraseRootFromParent_Done,
     /* 2357075 */   // Label 32869: @2357075
     /* 2357075 */   GIM_Reject,
     /* 2357076 */ // Label 32867: @2357076
     /* 2357076 */ GIM_Reject,
     /* 2357077 */ // Label 32822: @2357077
     /* 2357077 */ GIM_Try, /*On fail goto*//*Label 32870*/ GIMT_Encode4(2357191),
     /* 2357082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2357085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2357088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357096 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357100 */   GIM_Try, /*On fail goto*//*Label 32871*/ GIMT_Encode4(2357145), // Rule ID 56618 //
     /* 2357105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2357108 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2357111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2357125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357144 */     // GIR_Coverage, 56618,
     /* 2357144 */     GIR_EraseRootFromParent_Done,
     /* 2357145 */   // Label 32871: @2357145
     /* 2357145 */   GIM_Try, /*On fail goto*//*Label 32872*/ GIMT_Encode4(2357190), // Rule ID 56619 //
     /* 2357150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2357153 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2357156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2357170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357189 */     // GIR_Coverage, 56619,
     /* 2357189 */     GIR_EraseRootFromParent_Done,
     /* 2357190 */   // Label 32872: @2357190
     /* 2357190 */   GIM_Reject,
     /* 2357191 */ // Label 32870: @2357191
     /* 2357191 */ GIM_Reject,
     /* 2357192 */ // Label 32823: @2357192
     /* 2357192 */ GIM_Try, /*On fail goto*//*Label 32873*/ GIMT_Encode4(2357306),
     /* 2357197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2357200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2357203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2357207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2357211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2357215 */   GIM_Try, /*On fail goto*//*Label 32874*/ GIMT_Encode4(2357260), // Rule ID 56576 //
     /* 2357220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357223 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2357226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2357240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357259 */     // GIR_Coverage, 56576,
     /* 2357259 */     GIR_EraseRootFromParent_Done,
     /* 2357260 */   // Label 32874: @2357260
     /* 2357260 */   GIM_Try, /*On fail goto*//*Label 32875*/ GIMT_Encode4(2357305), // Rule ID 56577 //
     /* 2357265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2357268 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2357271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2357285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357304 */     // GIR_Coverage, 56577,
     /* 2357304 */     GIR_EraseRootFromParent_Done,
     /* 2357305 */   // Label 32875: @2357305
     /* 2357305 */   GIM_Reject,
     /* 2357306 */ // Label 32873: @2357306
     /* 2357306 */ GIM_Reject,
     /* 2357307 */ // Label 32824: @2357307
     /* 2357307 */ GIM_Try, /*On fail goto*//*Label 32876*/ GIMT_Encode4(2357421),
     /* 2357312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2357315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2357318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357330 */   GIM_Try, /*On fail goto*//*Label 32877*/ GIMT_Encode4(2357375), // Rule ID 56600 //
     /* 2357335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2357338 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2357341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2357355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357374 */     // GIR_Coverage, 56600,
     /* 2357374 */     GIR_EraseRootFromParent_Done,
     /* 2357375 */   // Label 32877: @2357375
     /* 2357375 */   GIM_Try, /*On fail goto*//*Label 32878*/ GIMT_Encode4(2357420), // Rule ID 56601 //
     /* 2357380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2357383 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2357386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2357400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357419 */     // GIR_Coverage, 56601,
     /* 2357419 */     GIR_EraseRootFromParent_Done,
     /* 2357420 */   // Label 32878: @2357420
     /* 2357420 */   GIM_Reject,
     /* 2357421 */ // Label 32876: @2357421
     /* 2357421 */ GIM_Reject,
     /* 2357422 */ // Label 32825: @2357422
     /* 2357422 */ GIM_Try, /*On fail goto*//*Label 32879*/ GIMT_Encode4(2357536),
     /* 2357427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2357430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2357433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357445 */   GIM_Try, /*On fail goto*//*Label 32880*/ GIMT_Encode4(2357490), // Rule ID 56582 //
     /* 2357450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357453 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2357456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2357470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357489 */     // GIR_Coverage, 56582,
     /* 2357489 */     GIR_EraseRootFromParent_Done,
     /* 2357490 */   // Label 32880: @2357490
     /* 2357490 */   GIM_Try, /*On fail goto*//*Label 32881*/ GIMT_Encode4(2357535), // Rule ID 56583 //
     /* 2357495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2357498 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2357501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2357515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357534 */     // GIR_Coverage, 56583,
     /* 2357534 */     GIR_EraseRootFromParent_Done,
     /* 2357535 */   // Label 32881: @2357535
     /* 2357535 */   GIM_Reject,
     /* 2357536 */ // Label 32879: @2357536
     /* 2357536 */ GIM_Reject,
     /* 2357537 */ // Label 32826: @2357537
     /* 2357537 */ GIM_Reject,
     /* 2357538 */ // Label 75: @2357538
     /* 2357538 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32900*/ GIMT_Encode4(2359622),
     /* 2357549 */ /*GILLT_s16*//*Label 32882*/ GIMT_Encode4(2357669),
     /* 2357553 */ /*GILLT_s32*//*Label 32883*/ GIMT_Encode4(2357736),
     /* 2357557 */ /*GILLT_s64*//*Label 32884*/ GIMT_Encode4(2357803), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357569 */ /*GILLT_nxv1s16*//*Label 32885*/ GIMT_Encode4(2357897),
     /* 2357573 */ /*GILLT_nxv1s32*//*Label 32886*/ GIMT_Encode4(2358012),
     /* 2357577 */ /*GILLT_nxv1s64*//*Label 32887*/ GIMT_Encode4(2358127), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357589 */ /*GILLT_nxv2s16*//*Label 32888*/ GIMT_Encode4(2358242),
     /* 2357593 */ /*GILLT_nxv2s32*//*Label 32889*/ GIMT_Encode4(2358357),
     /* 2357597 */ /*GILLT_nxv2s64*//*Label 32890*/ GIMT_Encode4(2358472), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357609 */ /*GILLT_nxv4s16*//*Label 32891*/ GIMT_Encode4(2358587),
     /* 2357613 */ /*GILLT_nxv4s32*//*Label 32892*/ GIMT_Encode4(2358702),
     /* 2357617 */ /*GILLT_nxv4s64*//*Label 32893*/ GIMT_Encode4(2358817), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357629 */ /*GILLT_nxv8s16*//*Label 32894*/ GIMT_Encode4(2358932),
     /* 2357633 */ /*GILLT_nxv8s32*//*Label 32895*/ GIMT_Encode4(2359047),
     /* 2357637 */ /*GILLT_nxv8s64*//*Label 32896*/ GIMT_Encode4(2359162), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357649 */ /*GILLT_nxv16s16*//*Label 32897*/ GIMT_Encode4(2359277),
     /* 2357653 */ /*GILLT_nxv16s32*//*Label 32898*/ GIMT_Encode4(2359392), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357665 */ /*GILLT_nxv32s16*//*Label 32899*/ GIMT_Encode4(2359507),
     /* 2357669 */ // Label 32882: @2357669
     /* 2357669 */ GIM_Try, /*On fail goto*//*Label 32901*/ GIMT_Encode4(2357735),
     /* 2357674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2357677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2357680 */   GIM_Try, /*On fail goto*//*Label 32902*/ GIMT_Encode4(2357707), // Rule ID 2056 //
     /* 2357685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2357688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2357692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2357696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2357700 */     // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2357700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2357705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357706 */     // GIR_Coverage, 2056,
     /* 2357706 */     GIR_Done,
     /* 2357707 */   // Label 32902: @2357707
     /* 2357707 */   GIM_Try, /*On fail goto*//*Label 32903*/ GIMT_Encode4(2357734), // Rule ID 2057 //
     /* 2357712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2357715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357727 */     // (fmaxnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2357727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2357732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357733 */     // GIR_Coverage, 2057,
     /* 2357733 */     GIR_Done,
     /* 2357734 */   // Label 32903: @2357734
     /* 2357734 */   GIM_Reject,
     /* 2357735 */ // Label 32901: @2357735
     /* 2357735 */ GIM_Reject,
     /* 2357736 */ // Label 32883: @2357736
     /* 2357736 */ GIM_Try, /*On fail goto*//*Label 32904*/ GIMT_Encode4(2357802),
     /* 2357741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2357744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2357747 */   GIM_Try, /*On fail goto*//*Label 32905*/ GIMT_Encode4(2357774), // Rule ID 1343 //
     /* 2357752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2357755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2357759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2357763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2357767 */     // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2357767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2357772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357773 */     // GIR_Coverage, 1343,
     /* 2357773 */     GIR_Done,
     /* 2357774 */   // Label 32905: @2357774
     /* 2357774 */   GIM_Try, /*On fail goto*//*Label 32906*/ GIMT_Encode4(2357801), // Rule ID 1344 //
     /* 2357779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2357782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2357786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2357790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2357794 */     // (fmaxnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2357794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2357799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357800 */     // GIR_Coverage, 1344,
     /* 2357800 */     GIR_Done,
     /* 2357801 */   // Label 32906: @2357801
     /* 2357801 */   GIM_Reject,
     /* 2357802 */ // Label 32904: @2357802
     /* 2357802 */ GIM_Reject,
     /* 2357803 */ // Label 32884: @2357803
     /* 2357803 */ GIM_Try, /*On fail goto*//*Label 32907*/ GIMT_Encode4(2357896),
     /* 2357808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2357811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2357814 */   GIM_Try, /*On fail goto*//*Label 32908*/ GIMT_Encode4(2357841), // Rule ID 1715 //
     /* 2357819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2357822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357834 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2357834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2357839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357840 */     // GIR_Coverage, 1715,
     /* 2357840 */     GIR_Done,
     /* 2357841 */   // Label 32908: @2357841
     /* 2357841 */   GIM_Try, /*On fail goto*//*Label 32909*/ GIMT_Encode4(2357868), // Rule ID 1716 //
     /* 2357846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2357849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357861 */     // (fmaxnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2357861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2357866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357867 */     // GIR_Coverage, 1716,
     /* 2357867 */     GIR_Done,
     /* 2357868 */   // Label 32909: @2357868
     /* 2357868 */   GIM_Try, /*On fail goto*//*Label 32910*/ GIMT_Encode4(2357895), // Rule ID 1717 //
     /* 2357873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2357876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2357880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2357884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2357888 */     // (fmaxnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2357888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2357893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357894 */     // GIR_Coverage, 1717,
     /* 2357894 */     GIR_Done,
     /* 2357895 */   // Label 32910: @2357895
     /* 2357895 */   GIM_Reject,
     /* 2357896 */ // Label 32907: @2357896
     /* 2357896 */ GIM_Reject,
     /* 2357897 */ // Label 32885: @2357897
     /* 2357897 */ GIM_Try, /*On fail goto*//*Label 32911*/ GIMT_Encode4(2358011),
     /* 2357902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2357905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2357908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357916 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357920 */   GIM_Try, /*On fail goto*//*Label 32912*/ GIMT_Encode4(2357965), // Rule ID 56624 //
     /* 2357925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357928 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2357945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357964 */     // GIR_Coverage, 56624,
     /* 2357964 */     GIR_EraseRootFromParent_Done,
     /* 2357965 */   // Label 32912: @2357965
     /* 2357965 */   GIM_Try, /*On fail goto*//*Label 32913*/ GIMT_Encode4(2358010), // Rule ID 56625 //
     /* 2357970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2357973 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2357990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358009 */     // GIR_Coverage, 56625,
     /* 2358009 */     GIR_EraseRootFromParent_Done,
     /* 2358010 */   // Label 32913: @2358010
     /* 2358010 */   GIM_Reject,
     /* 2358011 */ // Label 32911: @2358011
     /* 2358011 */ GIM_Reject,
     /* 2358012 */ // Label 32886: @2358012
     /* 2358012 */ GIM_Try, /*On fail goto*//*Label 32914*/ GIMT_Encode4(2358126),
     /* 2358017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2358020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2358023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358035 */   GIM_Try, /*On fail goto*//*Label 32915*/ GIMT_Encode4(2358080), // Rule ID 56636 //
     /* 2358040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2358043 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2358046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2358060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358079 */     // GIR_Coverage, 56636,
     /* 2358079 */     GIR_EraseRootFromParent_Done,
     /* 2358080 */   // Label 32915: @2358080
     /* 2358080 */   GIM_Try, /*On fail goto*//*Label 32916*/ GIMT_Encode4(2358125), // Rule ID 56637 //
     /* 2358085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2358088 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2358091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2358105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358124 */     // GIR_Coverage, 56637,
     /* 2358124 */     GIR_EraseRootFromParent_Done,
     /* 2358125 */   // Label 32916: @2358125
     /* 2358125 */   GIM_Reject,
     /* 2358126 */ // Label 32914: @2358126
     /* 2358126 */ GIM_Reject,
     /* 2358127 */ // Label 32887: @2358127
     /* 2358127 */ GIM_Try, /*On fail goto*//*Label 32917*/ GIMT_Encode4(2358241),
     /* 2358132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2358135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2358138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358146 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358150 */   GIM_Try, /*On fail goto*//*Label 32918*/ GIMT_Encode4(2358195), // Rule ID 56654 //
     /* 2358155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2358158 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2358161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2358175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358194 */     // GIR_Coverage, 56654,
     /* 2358194 */     GIR_EraseRootFromParent_Done,
     /* 2358195 */   // Label 32918: @2358195
     /* 2358195 */   GIM_Try, /*On fail goto*//*Label 32919*/ GIMT_Encode4(2358240), // Rule ID 56655 //
     /* 2358200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2358203 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2358206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2358220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358239 */     // GIR_Coverage, 56655,
     /* 2358239 */     GIR_EraseRootFromParent_Done,
     /* 2358240 */   // Label 32919: @2358240
     /* 2358240 */   GIM_Reject,
     /* 2358241 */ // Label 32917: @2358241
     /* 2358241 */ GIM_Reject,
     /* 2358242 */ // Label 32888: @2358242
     /* 2358242 */ GIM_Try, /*On fail goto*//*Label 32920*/ GIMT_Encode4(2358356),
     /* 2358247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2358250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2358253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358265 */   GIM_Try, /*On fail goto*//*Label 32921*/ GIMT_Encode4(2358310), // Rule ID 56630 //
     /* 2358270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358273 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2358276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2358290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358309 */     // GIR_Coverage, 56630,
     /* 2358309 */     GIR_EraseRootFromParent_Done,
     /* 2358310 */   // Label 32921: @2358310
     /* 2358310 */   GIM_Try, /*On fail goto*//*Label 32922*/ GIMT_Encode4(2358355), // Rule ID 56631 //
     /* 2358315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358318 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2358321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2358335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358354 */     // GIR_Coverage, 56631,
     /* 2358354 */     GIR_EraseRootFromParent_Done,
     /* 2358355 */   // Label 32922: @2358355
     /* 2358355 */   GIM_Reject,
     /* 2358356 */ // Label 32920: @2358356
     /* 2358356 */ GIM_Reject,
     /* 2358357 */ // Label 32889: @2358357
     /* 2358357 */ GIM_Try, /*On fail goto*//*Label 32923*/ GIMT_Encode4(2358471),
     /* 2358362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2358365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2358368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358380 */   GIM_Try, /*On fail goto*//*Label 32924*/ GIMT_Encode4(2358425), // Rule ID 56648 //
     /* 2358385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2358388 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2358391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2358405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358424 */     // GIR_Coverage, 56648,
     /* 2358424 */     GIR_EraseRootFromParent_Done,
     /* 2358425 */   // Label 32924: @2358425
     /* 2358425 */   GIM_Try, /*On fail goto*//*Label 32925*/ GIMT_Encode4(2358470), // Rule ID 56649 //
     /* 2358430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2358433 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2358436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2358450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358469 */     // GIR_Coverage, 56649,
     /* 2358469 */     GIR_EraseRootFromParent_Done,
     /* 2358470 */   // Label 32925: @2358470
     /* 2358470 */   GIM_Reject,
     /* 2358471 */ // Label 32923: @2358471
     /* 2358471 */ GIM_Reject,
     /* 2358472 */ // Label 32890: @2358472
     /* 2358472 */ GIM_Try, /*On fail goto*//*Label 32926*/ GIMT_Encode4(2358586),
     /* 2358477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2358480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2358483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358495 */   GIM_Try, /*On fail goto*//*Label 32927*/ GIMT_Encode4(2358540), // Rule ID 56696 //
     /* 2358500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2358503 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2358520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358539 */     // GIR_Coverage, 56696,
     /* 2358539 */     GIR_EraseRootFromParent_Done,
     /* 2358540 */   // Label 32927: @2358540
     /* 2358540 */   GIM_Try, /*On fail goto*//*Label 32928*/ GIMT_Encode4(2358585), // Rule ID 56697 //
     /* 2358545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2358548 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2358565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358584 */     // GIR_Coverage, 56697,
     /* 2358584 */     GIR_EraseRootFromParent_Done,
     /* 2358585 */   // Label 32928: @2358585
     /* 2358585 */   GIM_Reject,
     /* 2358586 */ // Label 32926: @2358586
     /* 2358586 */ GIM_Reject,
     /* 2358587 */ // Label 32891: @2358587
     /* 2358587 */ GIM_Try, /*On fail goto*//*Label 32929*/ GIMT_Encode4(2358701),
     /* 2358592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2358595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2358598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358610 */   GIM_Try, /*On fail goto*//*Label 32930*/ GIMT_Encode4(2358655), // Rule ID 56642 //
     /* 2358615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358618 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2358635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358654 */     // GIR_Coverage, 56642,
     /* 2358654 */     GIR_EraseRootFromParent_Done,
     /* 2358655 */   // Label 32930: @2358655
     /* 2358655 */   GIM_Try, /*On fail goto*//*Label 32931*/ GIMT_Encode4(2358700), // Rule ID 56643 //
     /* 2358660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358663 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2358680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358699 */     // GIR_Coverage, 56643,
     /* 2358699 */     GIR_EraseRootFromParent_Done,
     /* 2358700 */   // Label 32931: @2358700
     /* 2358700 */   GIM_Reject,
     /* 2358701 */ // Label 32929: @2358701
     /* 2358701 */ GIM_Reject,
     /* 2358702 */ // Label 32892: @2358702
     /* 2358702 */ GIM_Try, /*On fail goto*//*Label 32932*/ GIMT_Encode4(2358816),
     /* 2358707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2358710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2358713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358725 */   GIM_Try, /*On fail goto*//*Label 32933*/ GIMT_Encode4(2358770), // Rule ID 56678 //
     /* 2358730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2358733 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2358736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2358750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358769 */     // GIR_Coverage, 56678,
     /* 2358769 */     GIR_EraseRootFromParent_Done,
     /* 2358770 */   // Label 32933: @2358770
     /* 2358770 */   GIM_Try, /*On fail goto*//*Label 32934*/ GIMT_Encode4(2358815), // Rule ID 56679 //
     /* 2358775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2358778 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2358781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2358795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358814 */     // GIR_Coverage, 56679,
     /* 2358814 */     GIR_EraseRootFromParent_Done,
     /* 2358815 */   // Label 32934: @2358815
     /* 2358815 */   GIM_Reject,
     /* 2358816 */ // Label 32932: @2358816
     /* 2358816 */ GIM_Reject,
     /* 2358817 */ // Label 32893: @2358817
     /* 2358817 */ GIM_Try, /*On fail goto*//*Label 32935*/ GIMT_Encode4(2358931),
     /* 2358822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2358825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2358828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358840 */   GIM_Try, /*On fail goto*//*Label 32936*/ GIMT_Encode4(2358885), // Rule ID 56702 //
     /* 2358845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2358848 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2358851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2358865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358884 */     // GIR_Coverage, 56702,
     /* 2358884 */     GIR_EraseRootFromParent_Done,
     /* 2358885 */   // Label 32936: @2358885
     /* 2358885 */   GIM_Try, /*On fail goto*//*Label 32937*/ GIMT_Encode4(2358930), // Rule ID 56703 //
     /* 2358890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2358893 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2358896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2358910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358929 */     // GIR_Coverage, 56703,
     /* 2358929 */     GIR_EraseRootFromParent_Done,
     /* 2358930 */   // Label 32937: @2358930
     /* 2358930 */   GIM_Reject,
     /* 2358931 */ // Label 32935: @2358931
     /* 2358931 */ GIM_Reject,
     /* 2358932 */ // Label 32894: @2358932
     /* 2358932 */ GIM_Try, /*On fail goto*//*Label 32938*/ GIMT_Encode4(2359046),
     /* 2358937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2358940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2358943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358955 */   GIM_Try, /*On fail goto*//*Label 32939*/ GIMT_Encode4(2359000), // Rule ID 56660 //
     /* 2358960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358963 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2358966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2358980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358999 */     // GIR_Coverage, 56660,
     /* 2358999 */     GIR_EraseRootFromParent_Done,
     /* 2359000 */   // Label 32939: @2359000
     /* 2359000 */   GIM_Try, /*On fail goto*//*Label 32940*/ GIMT_Encode4(2359045), // Rule ID 56661 //
     /* 2359005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2359008 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2359011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2359025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359044 */     // GIR_Coverage, 56661,
     /* 2359044 */     GIR_EraseRootFromParent_Done,
     /* 2359045 */   // Label 32940: @2359045
     /* 2359045 */   GIM_Reject,
     /* 2359046 */ // Label 32938: @2359046
     /* 2359046 */ GIM_Reject,
     /* 2359047 */ // Label 32895: @2359047
     /* 2359047 */ GIM_Try, /*On fail goto*//*Label 32941*/ GIMT_Encode4(2359161),
     /* 2359052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2359055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2359058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359070 */   GIM_Try, /*On fail goto*//*Label 32942*/ GIMT_Encode4(2359115), // Rule ID 56684 //
     /* 2359075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2359078 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2359081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2359095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359114 */     // GIR_Coverage, 56684,
     /* 2359114 */     GIR_EraseRootFromParent_Done,
     /* 2359115 */   // Label 32942: @2359115
     /* 2359115 */   GIM_Try, /*On fail goto*//*Label 32943*/ GIMT_Encode4(2359160), // Rule ID 56685 //
     /* 2359120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359123 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2359126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2359140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359159 */     // GIR_Coverage, 56685,
     /* 2359159 */     GIR_EraseRootFromParent_Done,
     /* 2359160 */   // Label 32943: @2359160
     /* 2359160 */   GIM_Reject,
     /* 2359161 */ // Label 32941: @2359161
     /* 2359161 */ GIM_Reject,
     /* 2359162 */ // Label 32896: @2359162
     /* 2359162 */ GIM_Try, /*On fail goto*//*Label 32944*/ GIMT_Encode4(2359276),
     /* 2359167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2359170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2359173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359185 */   GIM_Try, /*On fail goto*//*Label 32945*/ GIMT_Encode4(2359230), // Rule ID 56708 //
     /* 2359190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2359193 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2359196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2359210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359229 */     // GIR_Coverage, 56708,
     /* 2359229 */     GIR_EraseRootFromParent_Done,
     /* 2359230 */   // Label 32945: @2359230
     /* 2359230 */   GIM_Try, /*On fail goto*//*Label 32946*/ GIMT_Encode4(2359275), // Rule ID 56709 //
     /* 2359235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2359238 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2359241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2359255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359274 */     // GIR_Coverage, 56709,
     /* 2359274 */     GIR_EraseRootFromParent_Done,
     /* 2359275 */   // Label 32946: @2359275
     /* 2359275 */   GIM_Reject,
     /* 2359276 */ // Label 32944: @2359276
     /* 2359276 */ GIM_Reject,
     /* 2359277 */ // Label 32897: @2359277
     /* 2359277 */ GIM_Try, /*On fail goto*//*Label 32947*/ GIMT_Encode4(2359391),
     /* 2359282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2359285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2359288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359300 */   GIM_Try, /*On fail goto*//*Label 32948*/ GIMT_Encode4(2359345), // Rule ID 56666 //
     /* 2359305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2359308 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2359311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2359325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359344 */     // GIR_Coverage, 56666,
     /* 2359344 */     GIR_EraseRootFromParent_Done,
     /* 2359345 */   // Label 32948: @2359345
     /* 2359345 */   GIM_Try, /*On fail goto*//*Label 32949*/ GIMT_Encode4(2359390), // Rule ID 56667 //
     /* 2359350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2359353 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2359356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2359370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359389 */     // GIR_Coverage, 56667,
     /* 2359389 */     GIR_EraseRootFromParent_Done,
     /* 2359390 */   // Label 32949: @2359390
     /* 2359390 */   GIM_Reject,
     /* 2359391 */ // Label 32947: @2359391
     /* 2359391 */ GIM_Reject,
     /* 2359392 */ // Label 32898: @2359392
     /* 2359392 */ GIM_Try, /*On fail goto*//*Label 32950*/ GIMT_Encode4(2359506),
     /* 2359397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2359400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2359403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359415 */   GIM_Try, /*On fail goto*//*Label 32951*/ GIMT_Encode4(2359460), // Rule ID 56690 //
     /* 2359420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2359423 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2359426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2359440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359459 */     // GIR_Coverage, 56690,
     /* 2359459 */     GIR_EraseRootFromParent_Done,
     /* 2359460 */   // Label 32951: @2359460
     /* 2359460 */   GIM_Try, /*On fail goto*//*Label 32952*/ GIMT_Encode4(2359505), // Rule ID 56691 //
     /* 2359465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359468 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2359471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2359485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359504 */     // GIR_Coverage, 56691,
     /* 2359504 */     GIR_EraseRootFromParent_Done,
     /* 2359505 */   // Label 32952: @2359505
     /* 2359505 */   GIM_Reject,
     /* 2359506 */ // Label 32950: @2359506
     /* 2359506 */ GIM_Reject,
     /* 2359507 */ // Label 32899: @2359507
     /* 2359507 */ GIM_Try, /*On fail goto*//*Label 32953*/ GIMT_Encode4(2359621),
     /* 2359512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2359515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2359518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359530 */   GIM_Try, /*On fail goto*//*Label 32954*/ GIMT_Encode4(2359575), // Rule ID 56672 //
     /* 2359535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2359538 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2359541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2359555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359574 */     // GIR_Coverage, 56672,
     /* 2359574 */     GIR_EraseRootFromParent_Done,
     /* 2359575 */   // Label 32954: @2359575
     /* 2359575 */   GIM_Try, /*On fail goto*//*Label 32955*/ GIMT_Encode4(2359620), // Rule ID 56673 //
     /* 2359580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2359583 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2359586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2359600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359619 */     // GIR_Coverage, 56673,
     /* 2359619 */     GIR_EraseRootFromParent_Done,
     /* 2359620 */   // Label 32955: @2359620
     /* 2359620 */   GIM_Reject,
     /* 2359621 */ // Label 32953: @2359621
     /* 2359621 */ GIM_Reject,
     /* 2359622 */ // Label 32900: @2359622
     /* 2359622 */ GIM_Reject,
     /* 2359623 */ // Label 76: @2359623
     /* 2359623 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32959*/ GIMT_Encode4(2359748),
     /* 2359634 */ /*GILLT_s16*//*Label 32956*/ GIMT_Encode4(2359646),
     /* 2359638 */ /*GILLT_s32*//*Label 32957*/ GIMT_Encode4(2359680),
     /* 2359642 */ /*GILLT_s64*//*Label 32958*/ GIMT_Encode4(2359714),
     /* 2359646 */ // Label 32956: @2359646
     /* 2359646 */ GIM_Try, /*On fail goto*//*Label 32960*/ GIMT_Encode4(2359679), // Rule ID 2408 //
     /* 2359651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2359654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2359657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2359660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359672 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMINM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2359672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_H),
     /* 2359677 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359678 */   // GIR_Coverage, 2408,
     /* 2359678 */   GIR_Done,
     /* 2359679 */ // Label 32960: @2359679
     /* 2359679 */ GIM_Reject,
     /* 2359680 */ // Label 32957: @2359680
     /* 2359680 */ GIM_Try, /*On fail goto*//*Label 32961*/ GIMT_Encode4(2359713), // Rule ID 2326 //
     /* 2359685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2359688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2359691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2359694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359706 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMINM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2359706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_S),
     /* 2359711 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359712 */   // GIR_Coverage, 2326,
     /* 2359712 */   GIR_Done,
     /* 2359713 */ // Label 32961: @2359713
     /* 2359713 */ GIM_Reject,
     /* 2359714 */ // Label 32958: @2359714
     /* 2359714 */ GIM_Try, /*On fail goto*//*Label 32962*/ GIMT_Encode4(2359747), // Rule ID 2366 //
     /* 2359719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2359722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2359725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2359728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359740 */   // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMINM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2359740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_D),
     /* 2359745 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359746 */   // GIR_Coverage, 2366,
     /* 2359746 */   GIR_Done,
     /* 2359747 */ // Label 32962: @2359747
     /* 2359747 */ GIM_Reject,
     /* 2359748 */ // Label 32959: @2359748
     /* 2359748 */ GIM_Reject,
     /* 2359749 */ // Label 77: @2359749
     /* 2359749 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32966*/ GIMT_Encode4(2359874),
     /* 2359760 */ /*GILLT_s16*//*Label 32963*/ GIMT_Encode4(2359772),
     /* 2359764 */ /*GILLT_s32*//*Label 32964*/ GIMT_Encode4(2359806),
     /* 2359768 */ /*GILLT_s64*//*Label 32965*/ GIMT_Encode4(2359840),
     /* 2359772 */ // Label 32963: @2359772
     /* 2359772 */ GIM_Try, /*On fail goto*//*Label 32967*/ GIMT_Encode4(2359805), // Rule ID 2409 //
     /* 2359777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2359780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2359783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2359786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359798 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAXM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2359798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_H),
     /* 2359803 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359804 */   // GIR_Coverage, 2409,
     /* 2359804 */   GIR_Done,
     /* 2359805 */ // Label 32967: @2359805
     /* 2359805 */ GIM_Reject,
     /* 2359806 */ // Label 32964: @2359806
     /* 2359806 */ GIM_Try, /*On fail goto*//*Label 32968*/ GIMT_Encode4(2359839), // Rule ID 2327 //
     /* 2359811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2359814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2359817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2359820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359832 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAXM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2359832 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_S),
     /* 2359837 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359838 */   // GIR_Coverage, 2327,
     /* 2359838 */   GIR_Done,
     /* 2359839 */ // Label 32968: @2359839
     /* 2359839 */ GIM_Reject,
     /* 2359840 */ // Label 32965: @2359840
     /* 2359840 */ GIM_Try, /*On fail goto*//*Label 32969*/ GIMT_Encode4(2359873), // Rule ID 2367 //
     /* 2359845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2359848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2359851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2359854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359866 */   // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAXM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2359866 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_D),
     /* 2359871 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359872 */   // GIR_Coverage, 2367,
     /* 2359872 */   GIR_Done,
     /* 2359873 */ // Label 32969: @2359873
     /* 2359873 */ GIM_Reject,
     /* 2359874 */ // Label 32966: @2359874
     /* 2359874 */ GIM_Reject,
     /* 2359875 */ // Label 78: @2359875
     /* 2359875 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32988*/ GIMT_Encode4(2361959),
     /* 2359886 */ /*GILLT_s16*//*Label 32970*/ GIMT_Encode4(2360006),
     /* 2359890 */ /*GILLT_s32*//*Label 32971*/ GIMT_Encode4(2360073),
     /* 2359894 */ /*GILLT_s64*//*Label 32972*/ GIMT_Encode4(2360140), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359906 */ /*GILLT_nxv1s16*//*Label 32973*/ GIMT_Encode4(2360234),
     /* 2359910 */ /*GILLT_nxv1s32*//*Label 32974*/ GIMT_Encode4(2360349),
     /* 2359914 */ /*GILLT_nxv1s64*//*Label 32975*/ GIMT_Encode4(2360464), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359926 */ /*GILLT_nxv2s16*//*Label 32976*/ GIMT_Encode4(2360579),
     /* 2359930 */ /*GILLT_nxv2s32*//*Label 32977*/ GIMT_Encode4(2360694),
     /* 2359934 */ /*GILLT_nxv2s64*//*Label 32978*/ GIMT_Encode4(2360809), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359946 */ /*GILLT_nxv4s16*//*Label 32979*/ GIMT_Encode4(2360924),
     /* 2359950 */ /*GILLT_nxv4s32*//*Label 32980*/ GIMT_Encode4(2361039),
     /* 2359954 */ /*GILLT_nxv4s64*//*Label 32981*/ GIMT_Encode4(2361154), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359966 */ /*GILLT_nxv8s16*//*Label 32982*/ GIMT_Encode4(2361269),
     /* 2359970 */ /*GILLT_nxv8s32*//*Label 32983*/ GIMT_Encode4(2361384),
     /* 2359974 */ /*GILLT_nxv8s64*//*Label 32984*/ GIMT_Encode4(2361499), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359986 */ /*GILLT_nxv16s16*//*Label 32985*/ GIMT_Encode4(2361614),
     /* 2359990 */ /*GILLT_nxv16s32*//*Label 32986*/ GIMT_Encode4(2361729), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2360002 */ /*GILLT_nxv32s16*//*Label 32987*/ GIMT_Encode4(2361844),
     /* 2360006 */ // Label 32970: @2360006
     /* 2360006 */ GIM_Try, /*On fail goto*//*Label 32989*/ GIMT_Encode4(2360072),
     /* 2360011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2360014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2360017 */   GIM_Try, /*On fail goto*//*Label 32990*/ GIMT_Encode4(2360044), // Rule ID 2058 //
     /* 2360022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2360025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2360029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2360033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2360037 */     // (fminimumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2360037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2360042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360043 */     // GIR_Coverage, 2058,
     /* 2360043 */     GIR_Done,
     /* 2360044 */   // Label 32990: @2360044
     /* 2360044 */   GIM_Try, /*On fail goto*//*Label 32991*/ GIMT_Encode4(2360071), // Rule ID 2059 //
     /* 2360049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2360052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2360056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2360060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2360064 */     // (fminimumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2360064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2360069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360070 */     // GIR_Coverage, 2059,
     /* 2360070 */     GIR_Done,
     /* 2360071 */   // Label 32991: @2360071
     /* 2360071 */   GIM_Reject,
     /* 2360072 */ // Label 32989: @2360072
     /* 2360072 */ GIM_Reject,
     /* 2360073 */ // Label 32971: @2360073
     /* 2360073 */ GIM_Try, /*On fail goto*//*Label 32992*/ GIMT_Encode4(2360139),
     /* 2360078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2360081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2360084 */   GIM_Try, /*On fail goto*//*Label 32993*/ GIMT_Encode4(2360111), // Rule ID 1345 //
     /* 2360089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2360092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2360096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2360100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2360104 */     // (fminimumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2360104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2360109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360110 */     // GIR_Coverage, 1345,
     /* 2360110 */     GIR_Done,
     /* 2360111 */   // Label 32993: @2360111
     /* 2360111 */   GIM_Try, /*On fail goto*//*Label 32994*/ GIMT_Encode4(2360138), // Rule ID 1346 //
     /* 2360116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2360119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2360123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2360127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2360131 */     // (fminimumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2360131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2360136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360137 */     // GIR_Coverage, 1346,
     /* 2360137 */     GIR_Done,
     /* 2360138 */   // Label 32994: @2360138
     /* 2360138 */   GIM_Reject,
     /* 2360139 */ // Label 32992: @2360139
     /* 2360139 */ GIM_Reject,
     /* 2360140 */ // Label 32972: @2360140
     /* 2360140 */ GIM_Try, /*On fail goto*//*Label 32995*/ GIMT_Encode4(2360233),
     /* 2360145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2360148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2360151 */   GIM_Try, /*On fail goto*//*Label 32996*/ GIMT_Encode4(2360178), // Rule ID 1718 //
     /* 2360156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2360159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2360163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2360167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2360171 */     // (fminimumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2360171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2360176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360177 */     // GIR_Coverage, 1718,
     /* 2360177 */     GIR_Done,
     /* 2360178 */   // Label 32996: @2360178
     /* 2360178 */   GIM_Try, /*On fail goto*//*Label 32997*/ GIMT_Encode4(2360205), // Rule ID 1719 //
     /* 2360183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2360186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2360190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2360194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2360198 */     // (fminimumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2360198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2360203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360204 */     // GIR_Coverage, 1719,
     /* 2360204 */     GIR_Done,
     /* 2360205 */   // Label 32997: @2360205
     /* 2360205 */   GIM_Try, /*On fail goto*//*Label 32998*/ GIMT_Encode4(2360232), // Rule ID 1720 //
     /* 2360210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2360213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360225 */     // (fminimumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2360225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2360230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360231 */     // GIR_Coverage, 1720,
     /* 2360231 */     GIR_Done,
     /* 2360232 */   // Label 32998: @2360232
     /* 2360232 */   GIM_Reject,
     /* 2360233 */ // Label 32995: @2360233
     /* 2360233 */ GIM_Reject,
     /* 2360234 */ // Label 32973: @2360234
     /* 2360234 */ GIM_Try, /*On fail goto*//*Label 32999*/ GIMT_Encode4(2360348),
     /* 2360239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2360242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2360245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360257 */   GIM_Try, /*On fail goto*//*Label 33000*/ GIMT_Encode4(2360302), // Rule ID 56714 //
     /* 2360262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360265 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2360268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2360282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360301 */     // GIR_Coverage, 56714,
     /* 2360301 */     GIR_EraseRootFromParent_Done,
     /* 2360302 */   // Label 33000: @2360302
     /* 2360302 */   GIM_Try, /*On fail goto*//*Label 33001*/ GIMT_Encode4(2360347), // Rule ID 56715 //
     /* 2360307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360310 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2360313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2360327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360346 */     // GIR_Coverage, 56715,
     /* 2360346 */     GIR_EraseRootFromParent_Done,
     /* 2360347 */   // Label 33001: @2360347
     /* 2360347 */   GIM_Reject,
     /* 2360348 */ // Label 32999: @2360348
     /* 2360348 */ GIM_Reject,
     /* 2360349 */ // Label 32974: @2360349
     /* 2360349 */ GIM_Try, /*On fail goto*//*Label 33002*/ GIMT_Encode4(2360463),
     /* 2360354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2360357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2360360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360372 */   GIM_Try, /*On fail goto*//*Label 33003*/ GIMT_Encode4(2360417), // Rule ID 56726 //
     /* 2360377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2360380 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2360383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2360397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360416 */     // GIR_Coverage, 56726,
     /* 2360416 */     GIR_EraseRootFromParent_Done,
     /* 2360417 */   // Label 33003: @2360417
     /* 2360417 */   GIM_Try, /*On fail goto*//*Label 33004*/ GIMT_Encode4(2360462), // Rule ID 56727 //
     /* 2360422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2360425 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2360428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2360442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360461 */     // GIR_Coverage, 56727,
     /* 2360461 */     GIR_EraseRootFromParent_Done,
     /* 2360462 */   // Label 33004: @2360462
     /* 2360462 */   GIM_Reject,
     /* 2360463 */ // Label 33002: @2360463
     /* 2360463 */ GIM_Reject,
     /* 2360464 */ // Label 32975: @2360464
     /* 2360464 */ GIM_Try, /*On fail goto*//*Label 33005*/ GIMT_Encode4(2360578),
     /* 2360469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2360472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2360475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360487 */   GIM_Try, /*On fail goto*//*Label 33006*/ GIMT_Encode4(2360532), // Rule ID 56744 //
     /* 2360492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2360495 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2360498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2360512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360531 */     // GIR_Coverage, 56744,
     /* 2360531 */     GIR_EraseRootFromParent_Done,
     /* 2360532 */   // Label 33006: @2360532
     /* 2360532 */   GIM_Try, /*On fail goto*//*Label 33007*/ GIMT_Encode4(2360577), // Rule ID 56745 //
     /* 2360537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2360540 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2360543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2360557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360576 */     // GIR_Coverage, 56745,
     /* 2360576 */     GIR_EraseRootFromParent_Done,
     /* 2360577 */   // Label 33007: @2360577
     /* 2360577 */   GIM_Reject,
     /* 2360578 */ // Label 33005: @2360578
     /* 2360578 */ GIM_Reject,
     /* 2360579 */ // Label 32976: @2360579
     /* 2360579 */ GIM_Try, /*On fail goto*//*Label 33008*/ GIMT_Encode4(2360693),
     /* 2360584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2360587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2360590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360602 */   GIM_Try, /*On fail goto*//*Label 33009*/ GIMT_Encode4(2360647), // Rule ID 56720 //
     /* 2360607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360610 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2360613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2360627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360646 */     // GIR_Coverage, 56720,
     /* 2360646 */     GIR_EraseRootFromParent_Done,
     /* 2360647 */   // Label 33009: @2360647
     /* 2360647 */   GIM_Try, /*On fail goto*//*Label 33010*/ GIMT_Encode4(2360692), // Rule ID 56721 //
     /* 2360652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360655 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2360658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2360672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360691 */     // GIR_Coverage, 56721,
     /* 2360691 */     GIR_EraseRootFromParent_Done,
     /* 2360692 */   // Label 33010: @2360692
     /* 2360692 */   GIM_Reject,
     /* 2360693 */ // Label 33008: @2360693
     /* 2360693 */ GIM_Reject,
     /* 2360694 */ // Label 32977: @2360694
     /* 2360694 */ GIM_Try, /*On fail goto*//*Label 33011*/ GIMT_Encode4(2360808),
     /* 2360699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2360702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2360705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360713 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360717 */   GIM_Try, /*On fail goto*//*Label 33012*/ GIMT_Encode4(2360762), // Rule ID 56738 //
     /* 2360722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2360725 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2360728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2360742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360761 */     // GIR_Coverage, 56738,
     /* 2360761 */     GIR_EraseRootFromParent_Done,
     /* 2360762 */   // Label 33012: @2360762
     /* 2360762 */   GIM_Try, /*On fail goto*//*Label 33013*/ GIMT_Encode4(2360807), // Rule ID 56739 //
     /* 2360767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2360770 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2360773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2360787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360806 */     // GIR_Coverage, 56739,
     /* 2360806 */     GIR_EraseRootFromParent_Done,
     /* 2360807 */   // Label 33013: @2360807
     /* 2360807 */   GIM_Reject,
     /* 2360808 */ // Label 33011: @2360808
     /* 2360808 */ GIM_Reject,
     /* 2360809 */ // Label 32978: @2360809
     /* 2360809 */ GIM_Try, /*On fail goto*//*Label 33014*/ GIMT_Encode4(2360923),
     /* 2360814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2360817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2360820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360832 */   GIM_Try, /*On fail goto*//*Label 33015*/ GIMT_Encode4(2360877), // Rule ID 56786 //
     /* 2360837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2360840 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2360843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2360857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360876 */     // GIR_Coverage, 56786,
     /* 2360876 */     GIR_EraseRootFromParent_Done,
     /* 2360877 */   // Label 33015: @2360877
     /* 2360877 */   GIM_Try, /*On fail goto*//*Label 33016*/ GIMT_Encode4(2360922), // Rule ID 56787 //
     /* 2360882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2360885 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2360888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2360902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360921 */     // GIR_Coverage, 56787,
     /* 2360921 */     GIR_EraseRootFromParent_Done,
     /* 2360922 */   // Label 33016: @2360922
     /* 2360922 */   GIM_Reject,
     /* 2360923 */ // Label 33014: @2360923
     /* 2360923 */ GIM_Reject,
     /* 2360924 */ // Label 32979: @2360924
     /* 2360924 */ GIM_Try, /*On fail goto*//*Label 33017*/ GIMT_Encode4(2361038),
     /* 2360929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2360932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2360935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360947 */   GIM_Try, /*On fail goto*//*Label 33018*/ GIMT_Encode4(2360992), // Rule ID 56732 //
     /* 2360952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360955 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2360958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2360972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360991 */     // GIR_Coverage, 56732,
     /* 2360991 */     GIR_EraseRootFromParent_Done,
     /* 2360992 */   // Label 33018: @2360992
     /* 2360992 */   GIM_Try, /*On fail goto*//*Label 33019*/ GIMT_Encode4(2361037), // Rule ID 56733 //
     /* 2360997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361000 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2361003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2361017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361036 */     // GIR_Coverage, 56733,
     /* 2361036 */     GIR_EraseRootFromParent_Done,
     /* 2361037 */   // Label 33019: @2361037
     /* 2361037 */   GIM_Reject,
     /* 2361038 */ // Label 33017: @2361038
     /* 2361038 */ GIM_Reject,
     /* 2361039 */ // Label 32980: @2361039
     /* 2361039 */ GIM_Try, /*On fail goto*//*Label 33020*/ GIMT_Encode4(2361153),
     /* 2361044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2361047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2361050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361062 */   GIM_Try, /*On fail goto*//*Label 33021*/ GIMT_Encode4(2361107), // Rule ID 56768 //
     /* 2361067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2361070 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2361073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2361087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361106 */     // GIR_Coverage, 56768,
     /* 2361106 */     GIR_EraseRootFromParent_Done,
     /* 2361107 */   // Label 33021: @2361107
     /* 2361107 */   GIM_Try, /*On fail goto*//*Label 33022*/ GIMT_Encode4(2361152), // Rule ID 56769 //
     /* 2361112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2361115 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2361118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2361132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361151 */     // GIR_Coverage, 56769,
     /* 2361151 */     GIR_EraseRootFromParent_Done,
     /* 2361152 */   // Label 33022: @2361152
     /* 2361152 */   GIM_Reject,
     /* 2361153 */ // Label 33020: @2361153
     /* 2361153 */ GIM_Reject,
     /* 2361154 */ // Label 32981: @2361154
     /* 2361154 */ GIM_Try, /*On fail goto*//*Label 33023*/ GIMT_Encode4(2361268),
     /* 2361159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2361162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2361165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361177 */   GIM_Try, /*On fail goto*//*Label 33024*/ GIMT_Encode4(2361222), // Rule ID 56792 //
     /* 2361182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2361185 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2361188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2361202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361221 */     // GIR_Coverage, 56792,
     /* 2361221 */     GIR_EraseRootFromParent_Done,
     /* 2361222 */   // Label 33024: @2361222
     /* 2361222 */   GIM_Try, /*On fail goto*//*Label 33025*/ GIMT_Encode4(2361267), // Rule ID 56793 //
     /* 2361227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2361230 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2361233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2361247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361266 */     // GIR_Coverage, 56793,
     /* 2361266 */     GIR_EraseRootFromParent_Done,
     /* 2361267 */   // Label 33025: @2361267
     /* 2361267 */   GIM_Reject,
     /* 2361268 */ // Label 33023: @2361268
     /* 2361268 */ GIM_Reject,
     /* 2361269 */ // Label 32982: @2361269
     /* 2361269 */ GIM_Try, /*On fail goto*//*Label 33026*/ GIMT_Encode4(2361383),
     /* 2361274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2361277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2361280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361292 */   GIM_Try, /*On fail goto*//*Label 33027*/ GIMT_Encode4(2361337), // Rule ID 56750 //
     /* 2361297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2361300 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2361303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2361317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361336 */     // GIR_Coverage, 56750,
     /* 2361336 */     GIR_EraseRootFromParent_Done,
     /* 2361337 */   // Label 33027: @2361337
     /* 2361337 */   GIM_Try, /*On fail goto*//*Label 33028*/ GIMT_Encode4(2361382), // Rule ID 56751 //
     /* 2361342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361345 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2361348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2361362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361381 */     // GIR_Coverage, 56751,
     /* 2361381 */     GIR_EraseRootFromParent_Done,
     /* 2361382 */   // Label 33028: @2361382
     /* 2361382 */   GIM_Reject,
     /* 2361383 */ // Label 33026: @2361383
     /* 2361383 */ GIM_Reject,
     /* 2361384 */ // Label 32983: @2361384
     /* 2361384 */ GIM_Try, /*On fail goto*//*Label 33029*/ GIMT_Encode4(2361498),
     /* 2361389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2361392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2361395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361407 */   GIM_Try, /*On fail goto*//*Label 33030*/ GIMT_Encode4(2361452), // Rule ID 56774 //
     /* 2361412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2361415 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2361418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2361432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361451 */     // GIR_Coverage, 56774,
     /* 2361451 */     GIR_EraseRootFromParent_Done,
     /* 2361452 */   // Label 33030: @2361452
     /* 2361452 */   GIM_Try, /*On fail goto*//*Label 33031*/ GIMT_Encode4(2361497), // Rule ID 56775 //
     /* 2361457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2361460 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2361463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2361477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361496 */     // GIR_Coverage, 56775,
     /* 2361496 */     GIR_EraseRootFromParent_Done,
     /* 2361497 */   // Label 33031: @2361497
     /* 2361497 */   GIM_Reject,
     /* 2361498 */ // Label 33029: @2361498
     /* 2361498 */ GIM_Reject,
     /* 2361499 */ // Label 32984: @2361499
     /* 2361499 */ GIM_Try, /*On fail goto*//*Label 33032*/ GIMT_Encode4(2361613),
     /* 2361504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2361507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2361510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361522 */   GIM_Try, /*On fail goto*//*Label 33033*/ GIMT_Encode4(2361567), // Rule ID 56798 //
     /* 2361527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2361530 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2361533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2361547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361566 */     // GIR_Coverage, 56798,
     /* 2361566 */     GIR_EraseRootFromParent_Done,
     /* 2361567 */   // Label 33033: @2361567
     /* 2361567 */   GIM_Try, /*On fail goto*//*Label 33034*/ GIMT_Encode4(2361612), // Rule ID 56799 //
     /* 2361572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2361575 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2361578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2361592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361611 */     // GIR_Coverage, 56799,
     /* 2361611 */     GIR_EraseRootFromParent_Done,
     /* 2361612 */   // Label 33034: @2361612
     /* 2361612 */   GIM_Reject,
     /* 2361613 */ // Label 33032: @2361613
     /* 2361613 */ GIM_Reject,
     /* 2361614 */ // Label 32985: @2361614
     /* 2361614 */ GIM_Try, /*On fail goto*//*Label 33035*/ GIMT_Encode4(2361728),
     /* 2361619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2361622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2361625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361633 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361637 */   GIM_Try, /*On fail goto*//*Label 33036*/ GIMT_Encode4(2361682), // Rule ID 56756 //
     /* 2361642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2361645 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2361648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2361662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361681 */     // GIR_Coverage, 56756,
     /* 2361681 */     GIR_EraseRootFromParent_Done,
     /* 2361682 */   // Label 33036: @2361682
     /* 2361682 */   GIM_Try, /*On fail goto*//*Label 33037*/ GIMT_Encode4(2361727), // Rule ID 56757 //
     /* 2361687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361690 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2361693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2361707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361726 */     // GIR_Coverage, 56757,
     /* 2361726 */     GIR_EraseRootFromParent_Done,
     /* 2361727 */   // Label 33037: @2361727
     /* 2361727 */   GIM_Reject,
     /* 2361728 */ // Label 33035: @2361728
     /* 2361728 */ GIM_Reject,
     /* 2361729 */ // Label 32986: @2361729
     /* 2361729 */ GIM_Try, /*On fail goto*//*Label 33038*/ GIMT_Encode4(2361843),
     /* 2361734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2361737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2361740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361752 */   GIM_Try, /*On fail goto*//*Label 33039*/ GIMT_Encode4(2361797), // Rule ID 56780 //
     /* 2361757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2361760 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2361763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2361777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361796 */     // GIR_Coverage, 56780,
     /* 2361796 */     GIR_EraseRootFromParent_Done,
     /* 2361797 */   // Label 33039: @2361797
     /* 2361797 */   GIM_Try, /*On fail goto*//*Label 33040*/ GIMT_Encode4(2361842), // Rule ID 56781 //
     /* 2361802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2361805 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2361808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2361822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361841 */     // GIR_Coverage, 56781,
     /* 2361841 */     GIR_EraseRootFromParent_Done,
     /* 2361842 */   // Label 33040: @2361842
     /* 2361842 */   GIM_Reject,
     /* 2361843 */ // Label 33038: @2361843
     /* 2361843 */ GIM_Reject,
     /* 2361844 */ // Label 32987: @2361844
     /* 2361844 */ GIM_Try, /*On fail goto*//*Label 33041*/ GIMT_Encode4(2361958),
     /* 2361849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2361852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2361855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361867 */   GIM_Try, /*On fail goto*//*Label 33042*/ GIMT_Encode4(2361912), // Rule ID 56762 //
     /* 2361872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2361875 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2361878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2361892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361911 */     // GIR_Coverage, 56762,
     /* 2361911 */     GIR_EraseRootFromParent_Done,
     /* 2361912 */   // Label 33042: @2361912
     /* 2361912 */   GIM_Try, /*On fail goto*//*Label 33043*/ GIMT_Encode4(2361957), // Rule ID 56763 //
     /* 2361917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361920 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2361923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2361937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361956 */     // GIR_Coverage, 56763,
     /* 2361956 */     GIR_EraseRootFromParent_Done,
     /* 2361957 */   // Label 33043: @2361957
     /* 2361957 */   GIM_Reject,
     /* 2361958 */ // Label 33041: @2361958
     /* 2361958 */ GIM_Reject,
     /* 2361959 */ // Label 32988: @2361959
     /* 2361959 */ GIM_Reject,
     /* 2361960 */ // Label 79: @2361960
     /* 2361960 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 33062*/ GIMT_Encode4(2364044),
     /* 2361971 */ /*GILLT_s16*//*Label 33044*/ GIMT_Encode4(2362091),
     /* 2361975 */ /*GILLT_s32*//*Label 33045*/ GIMT_Encode4(2362158),
     /* 2361979 */ /*GILLT_s64*//*Label 33046*/ GIMT_Encode4(2362225), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361991 */ /*GILLT_nxv1s16*//*Label 33047*/ GIMT_Encode4(2362319),
     /* 2361995 */ /*GILLT_nxv1s32*//*Label 33048*/ GIMT_Encode4(2362434),
     /* 2361999 */ /*GILLT_nxv1s64*//*Label 33049*/ GIMT_Encode4(2362549), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2362011 */ /*GILLT_nxv2s16*//*Label 33050*/ GIMT_Encode4(2362664),
     /* 2362015 */ /*GILLT_nxv2s32*//*Label 33051*/ GIMT_Encode4(2362779),
     /* 2362019 */ /*GILLT_nxv2s64*//*Label 33052*/ GIMT_Encode4(2362894), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2362031 */ /*GILLT_nxv4s16*//*Label 33053*/ GIMT_Encode4(2363009),
     /* 2362035 */ /*GILLT_nxv4s32*//*Label 33054*/ GIMT_Encode4(2363124),
     /* 2362039 */ /*GILLT_nxv4s64*//*Label 33055*/ GIMT_Encode4(2363239), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2362051 */ /*GILLT_nxv8s16*//*Label 33056*/ GIMT_Encode4(2363354),
     /* 2362055 */ /*GILLT_nxv8s32*//*Label 33057*/ GIMT_Encode4(2363469),
     /* 2362059 */ /*GILLT_nxv8s64*//*Label 33058*/ GIMT_Encode4(2363584), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2362071 */ /*GILLT_nxv16s16*//*Label 33059*/ GIMT_Encode4(2363699),
     /* 2362075 */ /*GILLT_nxv16s32*//*Label 33060*/ GIMT_Encode4(2363814), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2362087 */ /*GILLT_nxv32s16*//*Label 33061*/ GIMT_Encode4(2363929),
     /* 2362091 */ // Label 33044: @2362091
     /* 2362091 */ GIM_Try, /*On fail goto*//*Label 33063*/ GIMT_Encode4(2362157),
     /* 2362096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2362099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2362102 */   GIM_Try, /*On fail goto*//*Label 33064*/ GIMT_Encode4(2362129), // Rule ID 2060 //
     /* 2362107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2362110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2362114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2362118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2362122 */     // (fmaximumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2362122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2362127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362128 */     // GIR_Coverage, 2060,
     /* 2362128 */     GIR_Done,
     /* 2362129 */   // Label 33064: @2362129
     /* 2362129 */   GIM_Try, /*On fail goto*//*Label 33065*/ GIMT_Encode4(2362156), // Rule ID 2061 //
     /* 2362134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2362137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2362141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2362145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2362149 */     // (fmaximumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2362149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2362154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362155 */     // GIR_Coverage, 2061,
     /* 2362155 */     GIR_Done,
     /* 2362156 */   // Label 33065: @2362156
     /* 2362156 */   GIM_Reject,
     /* 2362157 */ // Label 33063: @2362157
     /* 2362157 */ GIM_Reject,
     /* 2362158 */ // Label 33045: @2362158
     /* 2362158 */ GIM_Try, /*On fail goto*//*Label 33066*/ GIMT_Encode4(2362224),
     /* 2362163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2362166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2362169 */   GIM_Try, /*On fail goto*//*Label 33067*/ GIMT_Encode4(2362196), // Rule ID 1347 //
     /* 2362174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2362177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2362181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2362185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2362189 */     // (fmaximumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2362189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2362194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362195 */     // GIR_Coverage, 1347,
     /* 2362195 */     GIR_Done,
     /* 2362196 */   // Label 33067: @2362196
     /* 2362196 */   GIM_Try, /*On fail goto*//*Label 33068*/ GIMT_Encode4(2362223), // Rule ID 1348 //
     /* 2362201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2362204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2362208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2362212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2362216 */     // (fmaximumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2362216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2362221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362222 */     // GIR_Coverage, 1348,
     /* 2362222 */     GIR_Done,
     /* 2362223 */   // Label 33068: @2362223
     /* 2362223 */   GIM_Reject,
     /* 2362224 */ // Label 33066: @2362224
     /* 2362224 */ GIM_Reject,
     /* 2362225 */ // Label 33046: @2362225
     /* 2362225 */ GIM_Try, /*On fail goto*//*Label 33069*/ GIMT_Encode4(2362318),
     /* 2362230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2362233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2362236 */   GIM_Try, /*On fail goto*//*Label 33070*/ GIMT_Encode4(2362263), // Rule ID 1721 //
     /* 2362241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2362244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2362248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2362252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2362256 */     // (fmaximumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2362256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2362261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362262 */     // GIR_Coverage, 1721,
     /* 2362262 */     GIR_Done,
     /* 2362263 */   // Label 33070: @2362263
     /* 2362263 */   GIM_Try, /*On fail goto*//*Label 33071*/ GIMT_Encode4(2362290), // Rule ID 1722 //
     /* 2362268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2362271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2362275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2362279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2362283 */     // (fmaximumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2362283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2362288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362289 */     // GIR_Coverage, 1722,
     /* 2362289 */     GIR_Done,
     /* 2362290 */   // Label 33071: @2362290
     /* 2362290 */   GIM_Try, /*On fail goto*//*Label 33072*/ GIMT_Encode4(2362317), // Rule ID 1723 //
     /* 2362295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2362298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2362302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2362306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2362310 */     // (fmaximumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2362310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2362315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362316 */     // GIR_Coverage, 1723,
     /* 2362316 */     GIR_Done,
     /* 2362317 */   // Label 33072: @2362317
     /* 2362317 */   GIM_Reject,
     /* 2362318 */ // Label 33069: @2362318
     /* 2362318 */ GIM_Reject,
     /* 2362319 */ // Label 33047: @2362319
     /* 2362319 */ GIM_Try, /*On fail goto*//*Label 33073*/ GIMT_Encode4(2362433),
     /* 2362324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2362327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2362330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362342 */   GIM_Try, /*On fail goto*//*Label 33074*/ GIMT_Encode4(2362387), // Rule ID 56804 //
     /* 2362347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2362350 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2362353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2362367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362386 */     // GIR_Coverage, 56804,
     /* 2362386 */     GIR_EraseRootFromParent_Done,
     /* 2362387 */   // Label 33074: @2362387
     /* 2362387 */   GIM_Try, /*On fail goto*//*Label 33075*/ GIMT_Encode4(2362432), // Rule ID 56805 //
     /* 2362392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2362395 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2362398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2362412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362431 */     // GIR_Coverage, 56805,
     /* 2362431 */     GIR_EraseRootFromParent_Done,
     /* 2362432 */   // Label 33075: @2362432
     /* 2362432 */   GIM_Reject,
     /* 2362433 */ // Label 33073: @2362433
     /* 2362433 */ GIM_Reject,
     /* 2362434 */ // Label 33048: @2362434
     /* 2362434 */ GIM_Try, /*On fail goto*//*Label 33076*/ GIMT_Encode4(2362548),
     /* 2362439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2362442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2362445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362457 */   GIM_Try, /*On fail goto*//*Label 33077*/ GIMT_Encode4(2362502), // Rule ID 56816 //
     /* 2362462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2362465 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2362468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2362482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362501 */     // GIR_Coverage, 56816,
     /* 2362501 */     GIR_EraseRootFromParent_Done,
     /* 2362502 */   // Label 33077: @2362502
     /* 2362502 */   GIM_Try, /*On fail goto*//*Label 33078*/ GIMT_Encode4(2362547), // Rule ID 56817 //
     /* 2362507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2362510 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2362513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2362527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362546 */     // GIR_Coverage, 56817,
     /* 2362546 */     GIR_EraseRootFromParent_Done,
     /* 2362547 */   // Label 33078: @2362547
     /* 2362547 */   GIM_Reject,
     /* 2362548 */ // Label 33076: @2362548
     /* 2362548 */ GIM_Reject,
     /* 2362549 */ // Label 33049: @2362549
     /* 2362549 */ GIM_Try, /*On fail goto*//*Label 33079*/ GIMT_Encode4(2362663),
     /* 2362554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2362557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2362560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362572 */   GIM_Try, /*On fail goto*//*Label 33080*/ GIMT_Encode4(2362617), // Rule ID 56834 //
     /* 2362577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2362580 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2362583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2362597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362616 */     // GIR_Coverage, 56834,
     /* 2362616 */     GIR_EraseRootFromParent_Done,
     /* 2362617 */   // Label 33080: @2362617
     /* 2362617 */   GIM_Try, /*On fail goto*//*Label 33081*/ GIMT_Encode4(2362662), // Rule ID 56835 //
     /* 2362622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2362625 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2362628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2362642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362661 */     // GIR_Coverage, 56835,
     /* 2362661 */     GIR_EraseRootFromParent_Done,
     /* 2362662 */   // Label 33081: @2362662
     /* 2362662 */   GIM_Reject,
     /* 2362663 */ // Label 33079: @2362663
     /* 2362663 */ GIM_Reject,
     /* 2362664 */ // Label 33050: @2362664
     /* 2362664 */ GIM_Try, /*On fail goto*//*Label 33082*/ GIMT_Encode4(2362778),
     /* 2362669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2362672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2362675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362687 */   GIM_Try, /*On fail goto*//*Label 33083*/ GIMT_Encode4(2362732), // Rule ID 56810 //
     /* 2362692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2362695 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2362698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2362712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362731 */     // GIR_Coverage, 56810,
     /* 2362731 */     GIR_EraseRootFromParent_Done,
     /* 2362732 */   // Label 33083: @2362732
     /* 2362732 */   GIM_Try, /*On fail goto*//*Label 33084*/ GIMT_Encode4(2362777), // Rule ID 56811 //
     /* 2362737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2362740 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2362743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2362757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362776 */     // GIR_Coverage, 56811,
     /* 2362776 */     GIR_EraseRootFromParent_Done,
     /* 2362777 */   // Label 33084: @2362777
     /* 2362777 */   GIM_Reject,
     /* 2362778 */ // Label 33082: @2362778
     /* 2362778 */ GIM_Reject,
     /* 2362779 */ // Label 33051: @2362779
     /* 2362779 */ GIM_Try, /*On fail goto*//*Label 33085*/ GIMT_Encode4(2362893),
     /* 2362784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2362787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2362790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362802 */   GIM_Try, /*On fail goto*//*Label 33086*/ GIMT_Encode4(2362847), // Rule ID 56828 //
     /* 2362807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2362810 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2362813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2362827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362846 */     // GIR_Coverage, 56828,
     /* 2362846 */     GIR_EraseRootFromParent_Done,
     /* 2362847 */   // Label 33086: @2362847
     /* 2362847 */   GIM_Try, /*On fail goto*//*Label 33087*/ GIMT_Encode4(2362892), // Rule ID 56829 //
     /* 2362852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2362855 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2362858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2362872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362891 */     // GIR_Coverage, 56829,
     /* 2362891 */     GIR_EraseRootFromParent_Done,
     /* 2362892 */   // Label 33087: @2362892
     /* 2362892 */   GIM_Reject,
     /* 2362893 */ // Label 33085: @2362893
     /* 2362893 */ GIM_Reject,
     /* 2362894 */ // Label 33052: @2362894
     /* 2362894 */ GIM_Try, /*On fail goto*//*Label 33088*/ GIMT_Encode4(2363008),
     /* 2362899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2362902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2362905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362917 */   GIM_Try, /*On fail goto*//*Label 33089*/ GIMT_Encode4(2362962), // Rule ID 56876 //
     /* 2362922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2362925 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2362928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2362942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362961 */     // GIR_Coverage, 56876,
     /* 2362961 */     GIR_EraseRootFromParent_Done,
     /* 2362962 */   // Label 33089: @2362962
     /* 2362962 */   GIM_Try, /*On fail goto*//*Label 33090*/ GIMT_Encode4(2363007), // Rule ID 56877 //
     /* 2362967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2362970 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2362973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2362987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363006 */     // GIR_Coverage, 56877,
     /* 2363006 */     GIR_EraseRootFromParent_Done,
     /* 2363007 */   // Label 33090: @2363007
     /* 2363007 */   GIM_Reject,
     /* 2363008 */ // Label 33088: @2363008
     /* 2363008 */ GIM_Reject,
     /* 2363009 */ // Label 33053: @2363009
     /* 2363009 */ GIM_Try, /*On fail goto*//*Label 33091*/ GIMT_Encode4(2363123),
     /* 2363014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2363017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2363020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363032 */   GIM_Try, /*On fail goto*//*Label 33092*/ GIMT_Encode4(2363077), // Rule ID 56822 //
     /* 2363037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363040 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2363043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2363057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363076 */     // GIR_Coverage, 56822,
     /* 2363076 */     GIR_EraseRootFromParent_Done,
     /* 2363077 */   // Label 33092: @2363077
     /* 2363077 */   GIM_Try, /*On fail goto*//*Label 33093*/ GIMT_Encode4(2363122), // Rule ID 56823 //
     /* 2363082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2363085 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2363088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2363102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363121 */     // GIR_Coverage, 56823,
     /* 2363121 */     GIR_EraseRootFromParent_Done,
     /* 2363122 */   // Label 33093: @2363122
     /* 2363122 */   GIM_Reject,
     /* 2363123 */ // Label 33091: @2363123
     /* 2363123 */ GIM_Reject,
     /* 2363124 */ // Label 33054: @2363124
     /* 2363124 */ GIM_Try, /*On fail goto*//*Label 33094*/ GIMT_Encode4(2363238),
     /* 2363129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2363132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2363135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363143 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363147 */   GIM_Try, /*On fail goto*//*Label 33095*/ GIMT_Encode4(2363192), // Rule ID 56858 //
     /* 2363152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2363155 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2363158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2363172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363191 */     // GIR_Coverage, 56858,
     /* 2363191 */     GIR_EraseRootFromParent_Done,
     /* 2363192 */   // Label 33095: @2363192
     /* 2363192 */   GIM_Try, /*On fail goto*//*Label 33096*/ GIMT_Encode4(2363237), // Rule ID 56859 //
     /* 2363197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2363200 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2363203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2363217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363236 */     // GIR_Coverage, 56859,
     /* 2363236 */     GIR_EraseRootFromParent_Done,
     /* 2363237 */   // Label 33096: @2363237
     /* 2363237 */   GIM_Reject,
     /* 2363238 */ // Label 33094: @2363238
     /* 2363238 */ GIM_Reject,
     /* 2363239 */ // Label 33055: @2363239
     /* 2363239 */ GIM_Try, /*On fail goto*//*Label 33097*/ GIMT_Encode4(2363353),
     /* 2363244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2363247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2363250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363262 */   GIM_Try, /*On fail goto*//*Label 33098*/ GIMT_Encode4(2363307), // Rule ID 56882 //
     /* 2363267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2363270 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2363273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2363287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363306 */     // GIR_Coverage, 56882,
     /* 2363306 */     GIR_EraseRootFromParent_Done,
     /* 2363307 */   // Label 33098: @2363307
     /* 2363307 */   GIM_Try, /*On fail goto*//*Label 33099*/ GIMT_Encode4(2363352), // Rule ID 56883 //
     /* 2363312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2363315 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2363318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2363332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363351 */     // GIR_Coverage, 56883,
     /* 2363351 */     GIR_EraseRootFromParent_Done,
     /* 2363352 */   // Label 33099: @2363352
     /* 2363352 */   GIM_Reject,
     /* 2363353 */ // Label 33097: @2363353
     /* 2363353 */ GIM_Reject,
     /* 2363354 */ // Label 33056: @2363354
     /* 2363354 */ GIM_Try, /*On fail goto*//*Label 33100*/ GIMT_Encode4(2363468),
     /* 2363359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2363362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2363365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363377 */   GIM_Try, /*On fail goto*//*Label 33101*/ GIMT_Encode4(2363422), // Rule ID 56840 //
     /* 2363382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363385 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2363388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2363402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363421 */     // GIR_Coverage, 56840,
     /* 2363421 */     GIR_EraseRootFromParent_Done,
     /* 2363422 */   // Label 33101: @2363422
     /* 2363422 */   GIM_Try, /*On fail goto*//*Label 33102*/ GIMT_Encode4(2363467), // Rule ID 56841 //
     /* 2363427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2363430 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2363433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2363447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363466 */     // GIR_Coverage, 56841,
     /* 2363466 */     GIR_EraseRootFromParent_Done,
     /* 2363467 */   // Label 33102: @2363467
     /* 2363467 */   GIM_Reject,
     /* 2363468 */ // Label 33100: @2363468
     /* 2363468 */ GIM_Reject,
     /* 2363469 */ // Label 33057: @2363469
     /* 2363469 */ GIM_Try, /*On fail goto*//*Label 33103*/ GIMT_Encode4(2363583),
     /* 2363474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2363477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2363480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363492 */   GIM_Try, /*On fail goto*//*Label 33104*/ GIMT_Encode4(2363537), // Rule ID 56864 //
     /* 2363497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2363500 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2363503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2363517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363536 */     // GIR_Coverage, 56864,
     /* 2363536 */     GIR_EraseRootFromParent_Done,
     /* 2363537 */   // Label 33104: @2363537
     /* 2363537 */   GIM_Try, /*On fail goto*//*Label 33105*/ GIMT_Encode4(2363582), // Rule ID 56865 //
     /* 2363542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2363545 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2363548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2363562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363581 */     // GIR_Coverage, 56865,
     /* 2363581 */     GIR_EraseRootFromParent_Done,
     /* 2363582 */   // Label 33105: @2363582
     /* 2363582 */   GIM_Reject,
     /* 2363583 */ // Label 33103: @2363583
     /* 2363583 */ GIM_Reject,
     /* 2363584 */ // Label 33058: @2363584
     /* 2363584 */ GIM_Try, /*On fail goto*//*Label 33106*/ GIMT_Encode4(2363698),
     /* 2363589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2363592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2363595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363607 */   GIM_Try, /*On fail goto*//*Label 33107*/ GIMT_Encode4(2363652), // Rule ID 56888 //
     /* 2363612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2363615 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2363618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2363632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363651 */     // GIR_Coverage, 56888,
     /* 2363651 */     GIR_EraseRootFromParent_Done,
     /* 2363652 */   // Label 33107: @2363652
     /* 2363652 */   GIM_Try, /*On fail goto*//*Label 33108*/ GIMT_Encode4(2363697), // Rule ID 56889 //
     /* 2363657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2363660 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2363663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2363677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363696 */     // GIR_Coverage, 56889,
     /* 2363696 */     GIR_EraseRootFromParent_Done,
     /* 2363697 */   // Label 33108: @2363697
     /* 2363697 */   GIM_Reject,
     /* 2363698 */ // Label 33106: @2363698
     /* 2363698 */ GIM_Reject,
     /* 2363699 */ // Label 33059: @2363699
     /* 2363699 */ GIM_Try, /*On fail goto*//*Label 33109*/ GIMT_Encode4(2363813),
     /* 2363704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2363707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2363710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363722 */   GIM_Try, /*On fail goto*//*Label 33110*/ GIMT_Encode4(2363767), // Rule ID 56846 //
     /* 2363727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363730 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2363733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2363747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363766 */     // GIR_Coverage, 56846,
     /* 2363766 */     GIR_EraseRootFromParent_Done,
     /* 2363767 */   // Label 33110: @2363767
     /* 2363767 */   GIM_Try, /*On fail goto*//*Label 33111*/ GIMT_Encode4(2363812), // Rule ID 56847 //
     /* 2363772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2363775 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2363778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2363792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363811 */     // GIR_Coverage, 56847,
     /* 2363811 */     GIR_EraseRootFromParent_Done,
     /* 2363812 */   // Label 33111: @2363812
     /* 2363812 */   GIM_Reject,
     /* 2363813 */ // Label 33109: @2363813
     /* 2363813 */ GIM_Reject,
     /* 2363814 */ // Label 33060: @2363814
     /* 2363814 */ GIM_Try, /*On fail goto*//*Label 33112*/ GIMT_Encode4(2363928),
     /* 2363819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2363822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2363825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363837 */   GIM_Try, /*On fail goto*//*Label 33113*/ GIMT_Encode4(2363882), // Rule ID 56870 //
     /* 2363842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2363845 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2363848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2363862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363881 */     // GIR_Coverage, 56870,
     /* 2363881 */     GIR_EraseRootFromParent_Done,
     /* 2363882 */   // Label 33113: @2363882
     /* 2363882 */   GIM_Try, /*On fail goto*//*Label 33114*/ GIMT_Encode4(2363927), // Rule ID 56871 //
     /* 2363887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2363890 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2363893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2363907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363926 */     // GIR_Coverage, 56871,
     /* 2363926 */     GIR_EraseRootFromParent_Done,
     /* 2363927 */   // Label 33114: @2363927
     /* 2363927 */   GIM_Reject,
     /* 2363928 */ // Label 33112: @2363928
     /* 2363928 */ GIM_Reject,
     /* 2363929 */ // Label 33061: @2363929
     /* 2363929 */ GIM_Try, /*On fail goto*//*Label 33115*/ GIMT_Encode4(2364043),
     /* 2363934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2363937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2363940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363952 */   GIM_Try, /*On fail goto*//*Label 33116*/ GIMT_Encode4(2363997), // Rule ID 56852 //
     /* 2363957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363960 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2363963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2363977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363996 */     // GIR_Coverage, 56852,
     /* 2363996 */     GIR_EraseRootFromParent_Done,
     /* 2363997 */   // Label 33116: @2363997
     /* 2363997 */   GIM_Try, /*On fail goto*//*Label 33117*/ GIMT_Encode4(2364042), // Rule ID 56853 //
     /* 2364002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2364005 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2364008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2364022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364041 */     // GIR_Coverage, 56853,
     /* 2364041 */     GIR_EraseRootFromParent_Done,
     /* 2364042 */   // Label 33117: @2364042
     /* 2364042 */   GIM_Reject,
     /* 2364043 */ // Label 33115: @2364043
     /* 2364043 */ GIM_Reject,
     /* 2364044 */ // Label 33062: @2364044
     /* 2364044 */ GIM_Reject,
     /* 2364045 */ // Label 80: @2364045
     /* 2364045 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33142*/ GIMT_Encode4(2366820),
     /* 2364056 */ /*GILLT_s32*//*Label 33118*/ GIMT_Encode4(2364180),
     /* 2364060 */ /*GILLT_s64*//*Label 33119*/ GIMT_Encode4(2364235), GIMT_Encode4(0),
     /* 2364068 */ /*GILLT_nxv1s8*//*Label 33120*/ GIMT_Encode4(2364290),
     /* 2364072 */ /*GILLT_nxv1s16*//*Label 33121*/ GIMT_Encode4(2364405),
     /* 2364076 */ /*GILLT_nxv1s32*//*Label 33122*/ GIMT_Encode4(2364520),
     /* 2364080 */ /*GILLT_nxv1s64*//*Label 33123*/ GIMT_Encode4(2364635), GIMT_Encode4(0),
     /* 2364088 */ /*GILLT_nxv2s8*//*Label 33124*/ GIMT_Encode4(2364750),
     /* 2364092 */ /*GILLT_nxv2s16*//*Label 33125*/ GIMT_Encode4(2364865),
     /* 2364096 */ /*GILLT_nxv2s32*//*Label 33126*/ GIMT_Encode4(2364980),
     /* 2364100 */ /*GILLT_nxv2s64*//*Label 33127*/ GIMT_Encode4(2365095), GIMT_Encode4(0),
     /* 2364108 */ /*GILLT_nxv4s8*//*Label 33128*/ GIMT_Encode4(2365210),
     /* 2364112 */ /*GILLT_nxv4s16*//*Label 33129*/ GIMT_Encode4(2365325),
     /* 2364116 */ /*GILLT_nxv4s32*//*Label 33130*/ GIMT_Encode4(2365440),
     /* 2364120 */ /*GILLT_nxv4s64*//*Label 33131*/ GIMT_Encode4(2365555), GIMT_Encode4(0),
     /* 2364128 */ /*GILLT_nxv8s8*//*Label 33132*/ GIMT_Encode4(2365670),
     /* 2364132 */ /*GILLT_nxv8s16*//*Label 33133*/ GIMT_Encode4(2365785),
     /* 2364136 */ /*GILLT_nxv8s32*//*Label 33134*/ GIMT_Encode4(2365900),
     /* 2364140 */ /*GILLT_nxv8s64*//*Label 33135*/ GIMT_Encode4(2366015), GIMT_Encode4(0),
     /* 2364148 */ /*GILLT_nxv16s8*//*Label 33136*/ GIMT_Encode4(2366130),
     /* 2364152 */ /*GILLT_nxv16s16*//*Label 33137*/ GIMT_Encode4(2366245),
     /* 2364156 */ /*GILLT_nxv16s32*//*Label 33138*/ GIMT_Encode4(2366360), GIMT_Encode4(0),
     /* 2364164 */ /*GILLT_nxv32s8*//*Label 33139*/ GIMT_Encode4(2366475),
     /* 2364168 */ /*GILLT_nxv32s16*//*Label 33140*/ GIMT_Encode4(2366590), GIMT_Encode4(0),
     /* 2364176 */ /*GILLT_nxv64s8*//*Label 33141*/ GIMT_Encode4(2366705),
     /* 2364180 */ // Label 33118: @2364180
     /* 2364180 */ GIM_Try, /*On fail goto*//*Label 33143*/ GIMT_Encode4(2364234),
     /* 2364185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2364188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2364191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364203 */   GIM_Try, /*On fail goto*//*Label 33144*/ GIMT_Encode4(2364218), // Rule ID 64466 //
     /* 2364208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2364211 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2364211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2364216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364217 */     // GIR_Coverage, 64466,
     /* 2364217 */     GIR_Done,
     /* 2364218 */   // Label 33144: @2364218
     /* 2364218 */   GIM_Try, /*On fail goto*//*Label 33145*/ GIMT_Encode4(2364233), // Rule ID 2531 //
     /* 2364223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2364226 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2364226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2364231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364232 */     // GIR_Coverage, 2531,
     /* 2364232 */     GIR_Done,
     /* 2364233 */   // Label 33145: @2364233
     /* 2364233 */   GIM_Reject,
     /* 2364234 */ // Label 33143: @2364234
     /* 2364234 */ GIM_Reject,
     /* 2364235 */ // Label 33119: @2364235
     /* 2364235 */ GIM_Try, /*On fail goto*//*Label 33146*/ GIMT_Encode4(2364289),
     /* 2364240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2364243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2364246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364258 */   GIM_Try, /*On fail goto*//*Label 33147*/ GIMT_Encode4(2364273), // Rule ID 64465 //
     /* 2364263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2364266 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2364266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2364271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364272 */     // GIR_Coverage, 64465,
     /* 2364272 */     GIR_Done,
     /* 2364273 */   // Label 33147: @2364273
     /* 2364273 */   GIM_Try, /*On fail goto*//*Label 33148*/ GIMT_Encode4(2364288), // Rule ID 2530 //
     /* 2364278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2364281 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2364281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2364286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364287 */     // GIR_Coverage, 2530,
     /* 2364287 */     GIR_Done,
     /* 2364288 */   // Label 33148: @2364288
     /* 2364288 */   GIM_Reject,
     /* 2364289 */ // Label 33146: @2364289
     /* 2364289 */ GIM_Reject,
     /* 2364290 */ // Label 33120: @2364290
     /* 2364290 */ GIM_Try, /*On fail goto*//*Label 33149*/ GIMT_Encode4(2364404),
     /* 2364295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2364298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2364301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364313 */   GIM_Try, /*On fail goto*//*Label 33150*/ GIMT_Encode4(2364358), // Rule ID 50596 //
     /* 2364318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2364321 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2364324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2364338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364357 */     // GIR_Coverage, 50596,
     /* 2364357 */     GIR_EraseRootFromParent_Done,
     /* 2364358 */   // Label 33150: @2364358
     /* 2364358 */   GIM_Try, /*On fail goto*//*Label 33151*/ GIMT_Encode4(2364403), // Rule ID 50597 //
     /* 2364363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2364366 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2364369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2364383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364402 */     // GIR_Coverage, 50597,
     /* 2364402 */     GIR_EraseRootFromParent_Done,
     /* 2364403 */   // Label 33151: @2364403
     /* 2364403 */   GIM_Reject,
     /* 2364404 */ // Label 33149: @2364404
     /* 2364404 */ GIM_Reject,
     /* 2364405 */ // Label 33121: @2364405
     /* 2364405 */ GIM_Try, /*On fail goto*//*Label 33152*/ GIMT_Encode4(2364519),
     /* 2364410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2364413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2364416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364428 */   GIM_Try, /*On fail goto*//*Label 33153*/ GIMT_Encode4(2364473), // Rule ID 50608 //
     /* 2364433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2364436 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2364439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2364453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364472 */     // GIR_Coverage, 50608,
     /* 2364472 */     GIR_EraseRootFromParent_Done,
     /* 2364473 */   // Label 33153: @2364473
     /* 2364473 */   GIM_Try, /*On fail goto*//*Label 33154*/ GIMT_Encode4(2364518), // Rule ID 50609 //
     /* 2364478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2364481 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2364484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2364498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364517 */     // GIR_Coverage, 50609,
     /* 2364517 */     GIR_EraseRootFromParent_Done,
     /* 2364518 */   // Label 33154: @2364518
     /* 2364518 */   GIM_Reject,
     /* 2364519 */ // Label 33152: @2364519
     /* 2364519 */ GIM_Reject,
     /* 2364520 */ // Label 33122: @2364520
     /* 2364520 */ GIM_Try, /*On fail goto*//*Label 33155*/ GIMT_Encode4(2364634),
     /* 2364525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2364528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2364531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364543 */   GIM_Try, /*On fail goto*//*Label 33156*/ GIMT_Encode4(2364588), // Rule ID 50616 //
     /* 2364548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2364551 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2364554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2364568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364587 */     // GIR_Coverage, 50616,
     /* 2364587 */     GIR_EraseRootFromParent_Done,
     /* 2364588 */   // Label 33156: @2364588
     /* 2364588 */   GIM_Try, /*On fail goto*//*Label 33157*/ GIMT_Encode4(2364633), // Rule ID 50617 //
     /* 2364593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2364596 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2364599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2364613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364632 */     // GIR_Coverage, 50617,
     /* 2364632 */     GIR_EraseRootFromParent_Done,
     /* 2364633 */   // Label 33157: @2364633
     /* 2364633 */   GIM_Reject,
     /* 2364634 */ // Label 33155: @2364634
     /* 2364634 */ GIM_Reject,
     /* 2364635 */ // Label 33123: @2364635
     /* 2364635 */ GIM_Try, /*On fail goto*//*Label 33158*/ GIMT_Encode4(2364749),
     /* 2364640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2364643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2364646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364658 */   GIM_Try, /*On fail goto*//*Label 33159*/ GIMT_Encode4(2364703), // Rule ID 50632 //
     /* 2364663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2364666 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2364669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2364683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364702 */     // GIR_Coverage, 50632,
     /* 2364702 */     GIR_EraseRootFromParent_Done,
     /* 2364703 */   // Label 33159: @2364703
     /* 2364703 */   GIM_Try, /*On fail goto*//*Label 33160*/ GIMT_Encode4(2364748), // Rule ID 50633 //
     /* 2364708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2364711 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2364714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2364728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364747 */     // GIR_Coverage, 50633,
     /* 2364747 */     GIR_EraseRootFromParent_Done,
     /* 2364748 */   // Label 33160: @2364748
     /* 2364748 */   GIM_Reject,
     /* 2364749 */ // Label 33158: @2364749
     /* 2364749 */ GIM_Reject,
     /* 2364750 */ // Label 33124: @2364750
     /* 2364750 */ GIM_Try, /*On fail goto*//*Label 33161*/ GIMT_Encode4(2364864),
     /* 2364755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2364758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2364761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364773 */   GIM_Try, /*On fail goto*//*Label 33162*/ GIMT_Encode4(2364818), // Rule ID 50600 //
     /* 2364778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2364781 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2364784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2364798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364817 */     // GIR_Coverage, 50600,
     /* 2364817 */     GIR_EraseRootFromParent_Done,
     /* 2364818 */   // Label 33162: @2364818
     /* 2364818 */   GIM_Try, /*On fail goto*//*Label 33163*/ GIMT_Encode4(2364863), // Rule ID 50601 //
     /* 2364823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2364826 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2364829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2364843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364862 */     // GIR_Coverage, 50601,
     /* 2364862 */     GIR_EraseRootFromParent_Done,
     /* 2364863 */   // Label 33163: @2364863
     /* 2364863 */   GIM_Reject,
     /* 2364864 */ // Label 33161: @2364864
     /* 2364864 */ GIM_Reject,
     /* 2364865 */ // Label 33125: @2364865
     /* 2364865 */ GIM_Try, /*On fail goto*//*Label 33164*/ GIMT_Encode4(2364979),
     /* 2364870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2364873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2364876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364884 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364888 */   GIM_Try, /*On fail goto*//*Label 33165*/ GIMT_Encode4(2364933), // Rule ID 50612 //
     /* 2364893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2364896 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2364899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2364913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364932 */     // GIR_Coverage, 50612,
     /* 2364932 */     GIR_EraseRootFromParent_Done,
     /* 2364933 */   // Label 33165: @2364933
     /* 2364933 */   GIM_Try, /*On fail goto*//*Label 33166*/ GIMT_Encode4(2364978), // Rule ID 50613 //
     /* 2364938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2364941 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2364944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2364958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364977 */     // GIR_Coverage, 50613,
     /* 2364977 */     GIR_EraseRootFromParent_Done,
     /* 2364978 */   // Label 33166: @2364978
     /* 2364978 */   GIM_Reject,
     /* 2364979 */ // Label 33164: @2364979
     /* 2364979 */ GIM_Reject,
     /* 2364980 */ // Label 33126: @2364980
     /* 2364980 */ GIM_Try, /*On fail goto*//*Label 33167*/ GIMT_Encode4(2365094),
     /* 2364985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2364988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2364991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365003 */   GIM_Try, /*On fail goto*//*Label 33168*/ GIMT_Encode4(2365048), // Rule ID 50628 //
     /* 2365008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365011 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2365014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2365028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365047 */     // GIR_Coverage, 50628,
     /* 2365047 */     GIR_EraseRootFromParent_Done,
     /* 2365048 */   // Label 33168: @2365048
     /* 2365048 */   GIM_Try, /*On fail goto*//*Label 33169*/ GIMT_Encode4(2365093), // Rule ID 50629 //
     /* 2365053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2365056 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2365059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2365073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365092 */     // GIR_Coverage, 50629,
     /* 2365092 */     GIR_EraseRootFromParent_Done,
     /* 2365093 */   // Label 33169: @2365093
     /* 2365093 */   GIM_Reject,
     /* 2365094 */ // Label 33167: @2365094
     /* 2365094 */ GIM_Reject,
     /* 2365095 */ // Label 33127: @2365095
     /* 2365095 */ GIM_Try, /*On fail goto*//*Label 33170*/ GIMT_Encode4(2365209),
     /* 2365100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2365103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2365106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365118 */   GIM_Try, /*On fail goto*//*Label 33171*/ GIMT_Encode4(2365163), // Rule ID 50672 //
     /* 2365123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2365126 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2365129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2365143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365162 */     // GIR_Coverage, 50672,
     /* 2365162 */     GIR_EraseRootFromParent_Done,
     /* 2365163 */   // Label 33171: @2365163
     /* 2365163 */   GIM_Try, /*On fail goto*//*Label 33172*/ GIMT_Encode4(2365208), // Rule ID 50673 //
     /* 2365168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2365171 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2365174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2365188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365207 */     // GIR_Coverage, 50673,
     /* 2365207 */     GIR_EraseRootFromParent_Done,
     /* 2365208 */   // Label 33172: @2365208
     /* 2365208 */   GIM_Reject,
     /* 2365209 */ // Label 33170: @2365209
     /* 2365209 */ GIM_Reject,
     /* 2365210 */ // Label 33128: @2365210
     /* 2365210 */ GIM_Try, /*On fail goto*//*Label 33173*/ GIMT_Encode4(2365324),
     /* 2365215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2365218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2365221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365233 */   GIM_Try, /*On fail goto*//*Label 33174*/ GIMT_Encode4(2365278), // Rule ID 50604 //
     /* 2365238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365241 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2365244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2365258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365277 */     // GIR_Coverage, 50604,
     /* 2365277 */     GIR_EraseRootFromParent_Done,
     /* 2365278 */   // Label 33174: @2365278
     /* 2365278 */   GIM_Try, /*On fail goto*//*Label 33175*/ GIMT_Encode4(2365323), // Rule ID 50605 //
     /* 2365283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2365286 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2365289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2365303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365322 */     // GIR_Coverage, 50605,
     /* 2365322 */     GIR_EraseRootFromParent_Done,
     /* 2365323 */   // Label 33175: @2365323
     /* 2365323 */   GIM_Reject,
     /* 2365324 */ // Label 33173: @2365324
     /* 2365324 */ GIM_Reject,
     /* 2365325 */ // Label 33129: @2365325
     /* 2365325 */ GIM_Try, /*On fail goto*//*Label 33176*/ GIMT_Encode4(2365439),
     /* 2365330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2365333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2365336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365348 */   GIM_Try, /*On fail goto*//*Label 33177*/ GIMT_Encode4(2365393), // Rule ID 50624 //
     /* 2365353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365356 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2365359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2365373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365392 */     // GIR_Coverage, 50624,
     /* 2365392 */     GIR_EraseRootFromParent_Done,
     /* 2365393 */   // Label 33177: @2365393
     /* 2365393 */   GIM_Try, /*On fail goto*//*Label 33178*/ GIMT_Encode4(2365438), // Rule ID 50625 //
     /* 2365398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2365401 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2365404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2365418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365437 */     // GIR_Coverage, 50625,
     /* 2365437 */     GIR_EraseRootFromParent_Done,
     /* 2365438 */   // Label 33178: @2365438
     /* 2365438 */   GIM_Reject,
     /* 2365439 */ // Label 33176: @2365439
     /* 2365439 */ GIM_Reject,
     /* 2365440 */ // Label 33130: @2365440
     /* 2365440 */ GIM_Try, /*On fail goto*//*Label 33179*/ GIMT_Encode4(2365554),
     /* 2365445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2365448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2365451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365463 */   GIM_Try, /*On fail goto*//*Label 33180*/ GIMT_Encode4(2365508), // Rule ID 50660 //
     /* 2365468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365471 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2365474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2365488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365507 */     // GIR_Coverage, 50660,
     /* 2365507 */     GIR_EraseRootFromParent_Done,
     /* 2365508 */   // Label 33180: @2365508
     /* 2365508 */   GIM_Try, /*On fail goto*//*Label 33181*/ GIMT_Encode4(2365553), // Rule ID 50661 //
     /* 2365513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2365516 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2365519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2365533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365552 */     // GIR_Coverage, 50661,
     /* 2365552 */     GIR_EraseRootFromParent_Done,
     /* 2365553 */   // Label 33181: @2365553
     /* 2365553 */   GIM_Reject,
     /* 2365554 */ // Label 33179: @2365554
     /* 2365554 */ GIM_Reject,
     /* 2365555 */ // Label 33131: @2365555
     /* 2365555 */ GIM_Try, /*On fail goto*//*Label 33182*/ GIMT_Encode4(2365669),
     /* 2365560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2365563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2365566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365578 */   GIM_Try, /*On fail goto*//*Label 33183*/ GIMT_Encode4(2365623), // Rule ID 50676 //
     /* 2365583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2365586 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2365589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2365603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365622 */     // GIR_Coverage, 50676,
     /* 2365622 */     GIR_EraseRootFromParent_Done,
     /* 2365623 */   // Label 33183: @2365623
     /* 2365623 */   GIM_Try, /*On fail goto*//*Label 33184*/ GIMT_Encode4(2365668), // Rule ID 50677 //
     /* 2365628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2365631 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2365634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2365648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365667 */     // GIR_Coverage, 50677,
     /* 2365667 */     GIR_EraseRootFromParent_Done,
     /* 2365668 */   // Label 33184: @2365668
     /* 2365668 */   GIM_Reject,
     /* 2365669 */ // Label 33182: @2365669
     /* 2365669 */ GIM_Reject,
     /* 2365670 */ // Label 33132: @2365670
     /* 2365670 */ GIM_Try, /*On fail goto*//*Label 33185*/ GIMT_Encode4(2365784),
     /* 2365675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2365678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2365681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365693 */   GIM_Try, /*On fail goto*//*Label 33186*/ GIMT_Encode4(2365738), // Rule ID 50620 //
     /* 2365698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365701 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2365704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2365718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365737 */     // GIR_Coverage, 50620,
     /* 2365737 */     GIR_EraseRootFromParent_Done,
     /* 2365738 */   // Label 33186: @2365738
     /* 2365738 */   GIM_Try, /*On fail goto*//*Label 33187*/ GIMT_Encode4(2365783), // Rule ID 50621 //
     /* 2365743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2365746 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2365749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2365763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365782 */     // GIR_Coverage, 50621,
     /* 2365782 */     GIR_EraseRootFromParent_Done,
     /* 2365783 */   // Label 33187: @2365783
     /* 2365783 */   GIM_Reject,
     /* 2365784 */ // Label 33185: @2365784
     /* 2365784 */ GIM_Reject,
     /* 2365785 */ // Label 33133: @2365785
     /* 2365785 */ GIM_Try, /*On fail goto*//*Label 33188*/ GIMT_Encode4(2365899),
     /* 2365790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2365793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2365796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365808 */   GIM_Try, /*On fail goto*//*Label 33189*/ GIMT_Encode4(2365853), // Rule ID 50648 //
     /* 2365813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365816 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2365819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2365833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365852 */     // GIR_Coverage, 50648,
     /* 2365852 */     GIR_EraseRootFromParent_Done,
     /* 2365853 */   // Label 33189: @2365853
     /* 2365853 */   GIM_Try, /*On fail goto*//*Label 33190*/ GIMT_Encode4(2365898), // Rule ID 50649 //
     /* 2365858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2365861 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2365864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2365878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365897 */     // GIR_Coverage, 50649,
     /* 2365897 */     GIR_EraseRootFromParent_Done,
     /* 2365898 */   // Label 33190: @2365898
     /* 2365898 */   GIM_Reject,
     /* 2365899 */ // Label 33188: @2365899
     /* 2365899 */ GIM_Reject,
     /* 2365900 */ // Label 33134: @2365900
     /* 2365900 */ GIM_Try, /*On fail goto*//*Label 33191*/ GIMT_Encode4(2366014),
     /* 2365905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2365908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2365911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365923 */   GIM_Try, /*On fail goto*//*Label 33192*/ GIMT_Encode4(2365968), // Rule ID 50664 //
     /* 2365928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365931 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2365934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2365948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365967 */     // GIR_Coverage, 50664,
     /* 2365967 */     GIR_EraseRootFromParent_Done,
     /* 2365968 */   // Label 33192: @2365968
     /* 2365968 */   GIM_Try, /*On fail goto*//*Label 33193*/ GIMT_Encode4(2366013), // Rule ID 50665 //
     /* 2365973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2365976 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2365979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2365993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366012 */     // GIR_Coverage, 50665,
     /* 2366012 */     GIR_EraseRootFromParent_Done,
     /* 2366013 */   // Label 33193: @2366013
     /* 2366013 */   GIM_Reject,
     /* 2366014 */ // Label 33191: @2366014
     /* 2366014 */ GIM_Reject,
     /* 2366015 */ // Label 33135: @2366015
     /* 2366015 */ GIM_Try, /*On fail goto*//*Label 33194*/ GIMT_Encode4(2366129),
     /* 2366020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2366023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2366026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366038 */   GIM_Try, /*On fail goto*//*Label 33195*/ GIMT_Encode4(2366083), // Rule ID 50680 //
     /* 2366043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2366046 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2366049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2366063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366082 */     // GIR_Coverage, 50680,
     /* 2366082 */     GIR_EraseRootFromParent_Done,
     /* 2366083 */   // Label 33195: @2366083
     /* 2366083 */   GIM_Try, /*On fail goto*//*Label 33196*/ GIMT_Encode4(2366128), // Rule ID 50681 //
     /* 2366088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2366091 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2366094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2366108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366127 */     // GIR_Coverage, 50681,
     /* 2366127 */     GIR_EraseRootFromParent_Done,
     /* 2366128 */   // Label 33196: @2366128
     /* 2366128 */   GIM_Reject,
     /* 2366129 */ // Label 33194: @2366129
     /* 2366129 */ GIM_Reject,
     /* 2366130 */ // Label 33136: @2366130
     /* 2366130 */ GIM_Try, /*On fail goto*//*Label 33197*/ GIMT_Encode4(2366244),
     /* 2366135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2366138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2366141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366153 */   GIM_Try, /*On fail goto*//*Label 33198*/ GIMT_Encode4(2366198), // Rule ID 50636 //
     /* 2366158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366161 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2366164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2366178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366197 */     // GIR_Coverage, 50636,
     /* 2366197 */     GIR_EraseRootFromParent_Done,
     /* 2366198 */   // Label 33198: @2366198
     /* 2366198 */   GIM_Try, /*On fail goto*//*Label 33199*/ GIMT_Encode4(2366243), // Rule ID 50637 //
     /* 2366203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366206 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2366209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2366223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366242 */     // GIR_Coverage, 50637,
     /* 2366242 */     GIR_EraseRootFromParent_Done,
     /* 2366243 */   // Label 33199: @2366243
     /* 2366243 */   GIM_Reject,
     /* 2366244 */ // Label 33197: @2366244
     /* 2366244 */ GIM_Reject,
     /* 2366245 */ // Label 33137: @2366245
     /* 2366245 */ GIM_Try, /*On fail goto*//*Label 33200*/ GIMT_Encode4(2366359),
     /* 2366250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2366253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2366256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366268 */   GIM_Try, /*On fail goto*//*Label 33201*/ GIMT_Encode4(2366313), // Rule ID 50652 //
     /* 2366273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366276 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2366279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2366293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366312 */     // GIR_Coverage, 50652,
     /* 2366312 */     GIR_EraseRootFromParent_Done,
     /* 2366313 */   // Label 33201: @2366313
     /* 2366313 */   GIM_Try, /*On fail goto*//*Label 33202*/ GIMT_Encode4(2366358), // Rule ID 50653 //
     /* 2366318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366321 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2366324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2366338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366357 */     // GIR_Coverage, 50653,
     /* 2366357 */     GIR_EraseRootFromParent_Done,
     /* 2366358 */   // Label 33202: @2366358
     /* 2366358 */   GIM_Reject,
     /* 2366359 */ // Label 33200: @2366359
     /* 2366359 */ GIM_Reject,
     /* 2366360 */ // Label 33138: @2366360
     /* 2366360 */ GIM_Try, /*On fail goto*//*Label 33203*/ GIMT_Encode4(2366474),
     /* 2366365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2366368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2366371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366383 */   GIM_Try, /*On fail goto*//*Label 33204*/ GIMT_Encode4(2366428), // Rule ID 50668 //
     /* 2366388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366391 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2366394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2366408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366427 */     // GIR_Coverage, 50668,
     /* 2366427 */     GIR_EraseRootFromParent_Done,
     /* 2366428 */   // Label 33204: @2366428
     /* 2366428 */   GIM_Try, /*On fail goto*//*Label 33205*/ GIMT_Encode4(2366473), // Rule ID 50669 //
     /* 2366433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366436 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2366439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2366453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366472 */     // GIR_Coverage, 50669,
     /* 2366472 */     GIR_EraseRootFromParent_Done,
     /* 2366473 */   // Label 33205: @2366473
     /* 2366473 */   GIM_Reject,
     /* 2366474 */ // Label 33203: @2366474
     /* 2366474 */ GIM_Reject,
     /* 2366475 */ // Label 33139: @2366475
     /* 2366475 */ GIM_Try, /*On fail goto*//*Label 33206*/ GIMT_Encode4(2366589),
     /* 2366480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2366483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2366486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366498 */   GIM_Try, /*On fail goto*//*Label 33207*/ GIMT_Encode4(2366543), // Rule ID 50640 //
     /* 2366503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366506 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2366509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2366523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366542 */     // GIR_Coverage, 50640,
     /* 2366542 */     GIR_EraseRootFromParent_Done,
     /* 2366543 */   // Label 33207: @2366543
     /* 2366543 */   GIM_Try, /*On fail goto*//*Label 33208*/ GIMT_Encode4(2366588), // Rule ID 50641 //
     /* 2366548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366551 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2366554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2366568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366587 */     // GIR_Coverage, 50641,
     /* 2366587 */     GIR_EraseRootFromParent_Done,
     /* 2366588 */   // Label 33208: @2366588
     /* 2366588 */   GIM_Reject,
     /* 2366589 */ // Label 33206: @2366589
     /* 2366589 */ GIM_Reject,
     /* 2366590 */ // Label 33140: @2366590
     /* 2366590 */ GIM_Try, /*On fail goto*//*Label 33209*/ GIMT_Encode4(2366704),
     /* 2366595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2366598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2366601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366613 */   GIM_Try, /*On fail goto*//*Label 33210*/ GIMT_Encode4(2366658), // Rule ID 50656 //
     /* 2366618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366621 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2366624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2366638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366657 */     // GIR_Coverage, 50656,
     /* 2366657 */     GIR_EraseRootFromParent_Done,
     /* 2366658 */   // Label 33210: @2366658
     /* 2366658 */   GIM_Try, /*On fail goto*//*Label 33211*/ GIMT_Encode4(2366703), // Rule ID 50657 //
     /* 2366663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366666 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2366669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2366683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366702 */     // GIR_Coverage, 50657,
     /* 2366702 */     GIR_EraseRootFromParent_Done,
     /* 2366703 */   // Label 33211: @2366703
     /* 2366703 */   GIM_Reject,
     /* 2366704 */ // Label 33209: @2366704
     /* 2366704 */ GIM_Reject,
     /* 2366705 */ // Label 33141: @2366705
     /* 2366705 */ GIM_Try, /*On fail goto*//*Label 33212*/ GIMT_Encode4(2366819),
     /* 2366710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2366713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2366716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366728 */   GIM_Try, /*On fail goto*//*Label 33213*/ GIMT_Encode4(2366773), // Rule ID 50644 //
     /* 2366733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366736 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2366739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2366753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366772 */     // GIR_Coverage, 50644,
     /* 2366772 */     GIR_EraseRootFromParent_Done,
     /* 2366773 */   // Label 33213: @2366773
     /* 2366773 */   GIM_Try, /*On fail goto*//*Label 33214*/ GIMT_Encode4(2366818), // Rule ID 50645 //
     /* 2366778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366781 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2366784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2366798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366817 */     // GIR_Coverage, 50645,
     /* 2366817 */     GIR_EraseRootFromParent_Done,
     /* 2366818 */   // Label 33214: @2366818
     /* 2366818 */   GIM_Reject,
     /* 2366819 */ // Label 33212: @2366819
     /* 2366819 */ GIM_Reject,
     /* 2366820 */ // Label 33142: @2366820
     /* 2366820 */ GIM_Reject,
     /* 2366821 */ // Label 81: @2366821
     /* 2366821 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33239*/ GIMT_Encode4(2369596),
     /* 2366832 */ /*GILLT_s32*//*Label 33215*/ GIMT_Encode4(2366956),
     /* 2366836 */ /*GILLT_s64*//*Label 33216*/ GIMT_Encode4(2367011), GIMT_Encode4(0),
     /* 2366844 */ /*GILLT_nxv1s8*//*Label 33217*/ GIMT_Encode4(2367066),
     /* 2366848 */ /*GILLT_nxv1s16*//*Label 33218*/ GIMT_Encode4(2367181),
     /* 2366852 */ /*GILLT_nxv1s32*//*Label 33219*/ GIMT_Encode4(2367296),
     /* 2366856 */ /*GILLT_nxv1s64*//*Label 33220*/ GIMT_Encode4(2367411), GIMT_Encode4(0),
     /* 2366864 */ /*GILLT_nxv2s8*//*Label 33221*/ GIMT_Encode4(2367526),
     /* 2366868 */ /*GILLT_nxv2s16*//*Label 33222*/ GIMT_Encode4(2367641),
     /* 2366872 */ /*GILLT_nxv2s32*//*Label 33223*/ GIMT_Encode4(2367756),
     /* 2366876 */ /*GILLT_nxv2s64*//*Label 33224*/ GIMT_Encode4(2367871), GIMT_Encode4(0),
     /* 2366884 */ /*GILLT_nxv4s8*//*Label 33225*/ GIMT_Encode4(2367986),
     /* 2366888 */ /*GILLT_nxv4s16*//*Label 33226*/ GIMT_Encode4(2368101),
     /* 2366892 */ /*GILLT_nxv4s32*//*Label 33227*/ GIMT_Encode4(2368216),
     /* 2366896 */ /*GILLT_nxv4s64*//*Label 33228*/ GIMT_Encode4(2368331), GIMT_Encode4(0),
     /* 2366904 */ /*GILLT_nxv8s8*//*Label 33229*/ GIMT_Encode4(2368446),
     /* 2366908 */ /*GILLT_nxv8s16*//*Label 33230*/ GIMT_Encode4(2368561),
     /* 2366912 */ /*GILLT_nxv8s32*//*Label 33231*/ GIMT_Encode4(2368676),
     /* 2366916 */ /*GILLT_nxv8s64*//*Label 33232*/ GIMT_Encode4(2368791), GIMT_Encode4(0),
     /* 2366924 */ /*GILLT_nxv16s8*//*Label 33233*/ GIMT_Encode4(2368906),
     /* 2366928 */ /*GILLT_nxv16s16*//*Label 33234*/ GIMT_Encode4(2369021),
     /* 2366932 */ /*GILLT_nxv16s32*//*Label 33235*/ GIMT_Encode4(2369136), GIMT_Encode4(0),
     /* 2366940 */ /*GILLT_nxv32s8*//*Label 33236*/ GIMT_Encode4(2369251),
     /* 2366944 */ /*GILLT_nxv32s16*//*Label 33237*/ GIMT_Encode4(2369366), GIMT_Encode4(0),
     /* 2366952 */ /*GILLT_nxv64s8*//*Label 33238*/ GIMT_Encode4(2369481),
     /* 2366956 */ // Label 33215: @2366956
     /* 2366956 */ GIM_Try, /*On fail goto*//*Label 33240*/ GIMT_Encode4(2367010),
     /* 2366961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2366964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2366967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366979 */   GIM_Try, /*On fail goto*//*Label 33241*/ GIMT_Encode4(2366994), // Rule ID 64470 //
     /* 2366984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2366987 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2366987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2366992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366993 */     // GIR_Coverage, 64470,
     /* 2366993 */     GIR_Done,
     /* 2366994 */   // Label 33241: @2366994
     /* 2366994 */   GIM_Try, /*On fail goto*//*Label 33242*/ GIMT_Encode4(2367009), // Rule ID 2533 //
     /* 2366999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2367002 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2367002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2367007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367008 */     // GIR_Coverage, 2533,
     /* 2367008 */     GIR_Done,
     /* 2367009 */   // Label 33242: @2367009
     /* 2367009 */   GIM_Reject,
     /* 2367010 */ // Label 33240: @2367010
     /* 2367010 */ GIM_Reject,
     /* 2367011 */ // Label 33216: @2367011
     /* 2367011 */ GIM_Try, /*On fail goto*//*Label 33243*/ GIMT_Encode4(2367065),
     /* 2367016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2367019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2367022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2367026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2367030 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2367034 */   GIM_Try, /*On fail goto*//*Label 33244*/ GIMT_Encode4(2367049), // Rule ID 64469 //
     /* 2367039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2367042 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2367042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2367047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367048 */     // GIR_Coverage, 64469,
     /* 2367048 */     GIR_Done,
     /* 2367049 */   // Label 33244: @2367049
     /* 2367049 */   GIM_Try, /*On fail goto*//*Label 33245*/ GIMT_Encode4(2367064), // Rule ID 2532 //
     /* 2367054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2367057 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2367057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2367062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367063 */     // GIR_Coverage, 2532,
     /* 2367063 */     GIR_Done,
     /* 2367064 */   // Label 33245: @2367064
     /* 2367064 */   GIM_Reject,
     /* 2367065 */ // Label 33243: @2367065
     /* 2367065 */ GIM_Reject,
     /* 2367066 */ // Label 33217: @2367066
     /* 2367066 */ GIM_Try, /*On fail goto*//*Label 33246*/ GIMT_Encode4(2367180),
     /* 2367071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2367074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2367077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367089 */   GIM_Try, /*On fail goto*//*Label 33247*/ GIMT_Encode4(2367134), // Rule ID 50772 //
     /* 2367094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367097 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2367100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2367114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367133 */     // GIR_Coverage, 50772,
     /* 2367133 */     GIR_EraseRootFromParent_Done,
     /* 2367134 */   // Label 33247: @2367134
     /* 2367134 */   GIM_Try, /*On fail goto*//*Label 33248*/ GIMT_Encode4(2367179), // Rule ID 50773 //
     /* 2367139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367142 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2367145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2367159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367178 */     // GIR_Coverage, 50773,
     /* 2367178 */     GIR_EraseRootFromParent_Done,
     /* 2367179 */   // Label 33248: @2367179
     /* 2367179 */   GIM_Reject,
     /* 2367180 */ // Label 33246: @2367180
     /* 2367180 */ GIM_Reject,
     /* 2367181 */ // Label 33218: @2367181
     /* 2367181 */ GIM_Try, /*On fail goto*//*Label 33249*/ GIMT_Encode4(2367295),
     /* 2367186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2367189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2367192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367204 */   GIM_Try, /*On fail goto*//*Label 33250*/ GIMT_Encode4(2367249), // Rule ID 50784 //
     /* 2367209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367212 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2367215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2367229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367248 */     // GIR_Coverage, 50784,
     /* 2367248 */     GIR_EraseRootFromParent_Done,
     /* 2367249 */   // Label 33250: @2367249
     /* 2367249 */   GIM_Try, /*On fail goto*//*Label 33251*/ GIMT_Encode4(2367294), // Rule ID 50785 //
     /* 2367254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367257 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2367260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2367274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367293 */     // GIR_Coverage, 50785,
     /* 2367293 */     GIR_EraseRootFromParent_Done,
     /* 2367294 */   // Label 33251: @2367294
     /* 2367294 */   GIM_Reject,
     /* 2367295 */ // Label 33249: @2367295
     /* 2367295 */ GIM_Reject,
     /* 2367296 */ // Label 33219: @2367296
     /* 2367296 */ GIM_Try, /*On fail goto*//*Label 33252*/ GIMT_Encode4(2367410),
     /* 2367301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2367304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2367307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367319 */   GIM_Try, /*On fail goto*//*Label 33253*/ GIMT_Encode4(2367364), // Rule ID 50792 //
     /* 2367324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367327 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2367330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2367344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367363 */     // GIR_Coverage, 50792,
     /* 2367363 */     GIR_EraseRootFromParent_Done,
     /* 2367364 */   // Label 33253: @2367364
     /* 2367364 */   GIM_Try, /*On fail goto*//*Label 33254*/ GIMT_Encode4(2367409), // Rule ID 50793 //
     /* 2367369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367372 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2367375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2367389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367408 */     // GIR_Coverage, 50793,
     /* 2367408 */     GIR_EraseRootFromParent_Done,
     /* 2367409 */   // Label 33254: @2367409
     /* 2367409 */   GIM_Reject,
     /* 2367410 */ // Label 33252: @2367410
     /* 2367410 */ GIM_Reject,
     /* 2367411 */ // Label 33220: @2367411
     /* 2367411 */ GIM_Try, /*On fail goto*//*Label 33255*/ GIMT_Encode4(2367525),
     /* 2367416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2367419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2367422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367434 */   GIM_Try, /*On fail goto*//*Label 33256*/ GIMT_Encode4(2367479), // Rule ID 50808 //
     /* 2367439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2367442 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2367445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2367459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367478 */     // GIR_Coverage, 50808,
     /* 2367478 */     GIR_EraseRootFromParent_Done,
     /* 2367479 */   // Label 33256: @2367479
     /* 2367479 */   GIM_Try, /*On fail goto*//*Label 33257*/ GIMT_Encode4(2367524), // Rule ID 50809 //
     /* 2367484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2367487 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2367490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2367504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367523 */     // GIR_Coverage, 50809,
     /* 2367523 */     GIR_EraseRootFromParent_Done,
     /* 2367524 */   // Label 33257: @2367524
     /* 2367524 */   GIM_Reject,
     /* 2367525 */ // Label 33255: @2367525
     /* 2367525 */ GIM_Reject,
     /* 2367526 */ // Label 33221: @2367526
     /* 2367526 */ GIM_Try, /*On fail goto*//*Label 33258*/ GIMT_Encode4(2367640),
     /* 2367531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2367534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2367537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367545 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367549 */   GIM_Try, /*On fail goto*//*Label 33259*/ GIMT_Encode4(2367594), // Rule ID 50776 //
     /* 2367554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367557 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2367560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2367574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367593 */     // GIR_Coverage, 50776,
     /* 2367593 */     GIR_EraseRootFromParent_Done,
     /* 2367594 */   // Label 33259: @2367594
     /* 2367594 */   GIM_Try, /*On fail goto*//*Label 33260*/ GIMT_Encode4(2367639), // Rule ID 50777 //
     /* 2367599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367602 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2367605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2367619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367638 */     // GIR_Coverage, 50777,
     /* 2367638 */     GIR_EraseRootFromParent_Done,
     /* 2367639 */   // Label 33260: @2367639
     /* 2367639 */   GIM_Reject,
     /* 2367640 */ // Label 33258: @2367640
     /* 2367640 */ GIM_Reject,
     /* 2367641 */ // Label 33222: @2367641
     /* 2367641 */ GIM_Try, /*On fail goto*//*Label 33261*/ GIMT_Encode4(2367755),
     /* 2367646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2367649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2367652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367664 */   GIM_Try, /*On fail goto*//*Label 33262*/ GIMT_Encode4(2367709), // Rule ID 50788 //
     /* 2367669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367672 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2367675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2367689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367708 */     // GIR_Coverage, 50788,
     /* 2367708 */     GIR_EraseRootFromParent_Done,
     /* 2367709 */   // Label 33262: @2367709
     /* 2367709 */   GIM_Try, /*On fail goto*//*Label 33263*/ GIMT_Encode4(2367754), // Rule ID 50789 //
     /* 2367714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367717 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2367720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2367734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367753 */     // GIR_Coverage, 50789,
     /* 2367753 */     GIR_EraseRootFromParent_Done,
     /* 2367754 */   // Label 33263: @2367754
     /* 2367754 */   GIM_Reject,
     /* 2367755 */ // Label 33261: @2367755
     /* 2367755 */ GIM_Reject,
     /* 2367756 */ // Label 33223: @2367756
     /* 2367756 */ GIM_Try, /*On fail goto*//*Label 33264*/ GIMT_Encode4(2367870),
     /* 2367761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2367764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2367767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367779 */   GIM_Try, /*On fail goto*//*Label 33265*/ GIMT_Encode4(2367824), // Rule ID 50804 //
     /* 2367784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367787 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2367790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2367804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367823 */     // GIR_Coverage, 50804,
     /* 2367823 */     GIR_EraseRootFromParent_Done,
     /* 2367824 */   // Label 33265: @2367824
     /* 2367824 */   GIM_Try, /*On fail goto*//*Label 33266*/ GIMT_Encode4(2367869), // Rule ID 50805 //
     /* 2367829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367832 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2367835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2367849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367868 */     // GIR_Coverage, 50805,
     /* 2367868 */     GIR_EraseRootFromParent_Done,
     /* 2367869 */   // Label 33266: @2367869
     /* 2367869 */   GIM_Reject,
     /* 2367870 */ // Label 33264: @2367870
     /* 2367870 */ GIM_Reject,
     /* 2367871 */ // Label 33224: @2367871
     /* 2367871 */ GIM_Try, /*On fail goto*//*Label 33267*/ GIMT_Encode4(2367985),
     /* 2367876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2367879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2367882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367890 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367894 */   GIM_Try, /*On fail goto*//*Label 33268*/ GIMT_Encode4(2367939), // Rule ID 50848 //
     /* 2367899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2367902 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2367905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2367919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367938 */     // GIR_Coverage, 50848,
     /* 2367938 */     GIR_EraseRootFromParent_Done,
     /* 2367939 */   // Label 33268: @2367939
     /* 2367939 */   GIM_Try, /*On fail goto*//*Label 33269*/ GIMT_Encode4(2367984), // Rule ID 50849 //
     /* 2367944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2367947 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2367950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2367964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367983 */     // GIR_Coverage, 50849,
     /* 2367983 */     GIR_EraseRootFromParent_Done,
     /* 2367984 */   // Label 33269: @2367984
     /* 2367984 */   GIM_Reject,
     /* 2367985 */ // Label 33267: @2367985
     /* 2367985 */ GIM_Reject,
     /* 2367986 */ // Label 33225: @2367986
     /* 2367986 */ GIM_Try, /*On fail goto*//*Label 33270*/ GIMT_Encode4(2368100),
     /* 2367991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2367994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2367997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368009 */   GIM_Try, /*On fail goto*//*Label 33271*/ GIMT_Encode4(2368054), // Rule ID 50780 //
     /* 2368014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368017 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2368020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2368034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368053 */     // GIR_Coverage, 50780,
     /* 2368053 */     GIR_EraseRootFromParent_Done,
     /* 2368054 */   // Label 33271: @2368054
     /* 2368054 */   GIM_Try, /*On fail goto*//*Label 33272*/ GIMT_Encode4(2368099), // Rule ID 50781 //
     /* 2368059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368062 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2368065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2368079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368098 */     // GIR_Coverage, 50781,
     /* 2368098 */     GIR_EraseRootFromParent_Done,
     /* 2368099 */   // Label 33272: @2368099
     /* 2368099 */   GIM_Reject,
     /* 2368100 */ // Label 33270: @2368100
     /* 2368100 */ GIM_Reject,
     /* 2368101 */ // Label 33226: @2368101
     /* 2368101 */ GIM_Try, /*On fail goto*//*Label 33273*/ GIMT_Encode4(2368215),
     /* 2368106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2368109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2368112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368124 */   GIM_Try, /*On fail goto*//*Label 33274*/ GIMT_Encode4(2368169), // Rule ID 50800 //
     /* 2368129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368132 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2368135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2368149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368168 */     // GIR_Coverage, 50800,
     /* 2368168 */     GIR_EraseRootFromParent_Done,
     /* 2368169 */   // Label 33274: @2368169
     /* 2368169 */   GIM_Try, /*On fail goto*//*Label 33275*/ GIMT_Encode4(2368214), // Rule ID 50801 //
     /* 2368174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368177 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2368180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2368194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368213 */     // GIR_Coverage, 50801,
     /* 2368213 */     GIR_EraseRootFromParent_Done,
     /* 2368214 */   // Label 33275: @2368214
     /* 2368214 */   GIM_Reject,
     /* 2368215 */ // Label 33273: @2368215
     /* 2368215 */ GIM_Reject,
     /* 2368216 */ // Label 33227: @2368216
     /* 2368216 */ GIM_Try, /*On fail goto*//*Label 33276*/ GIMT_Encode4(2368330),
     /* 2368221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2368224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2368227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368239 */   GIM_Try, /*On fail goto*//*Label 33277*/ GIMT_Encode4(2368284), // Rule ID 50836 //
     /* 2368244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368247 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2368250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2368264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368283 */     // GIR_Coverage, 50836,
     /* 2368283 */     GIR_EraseRootFromParent_Done,
     /* 2368284 */   // Label 33277: @2368284
     /* 2368284 */   GIM_Try, /*On fail goto*//*Label 33278*/ GIMT_Encode4(2368329), // Rule ID 50837 //
     /* 2368289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368292 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2368295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2368309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368328 */     // GIR_Coverage, 50837,
     /* 2368328 */     GIR_EraseRootFromParent_Done,
     /* 2368329 */   // Label 33278: @2368329
     /* 2368329 */   GIM_Reject,
     /* 2368330 */ // Label 33276: @2368330
     /* 2368330 */ GIM_Reject,
     /* 2368331 */ // Label 33228: @2368331
     /* 2368331 */ GIM_Try, /*On fail goto*//*Label 33279*/ GIMT_Encode4(2368445),
     /* 2368336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2368339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2368342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368354 */   GIM_Try, /*On fail goto*//*Label 33280*/ GIMT_Encode4(2368399), // Rule ID 50852 //
     /* 2368359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2368362 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2368365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2368379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368398 */     // GIR_Coverage, 50852,
     /* 2368398 */     GIR_EraseRootFromParent_Done,
     /* 2368399 */   // Label 33280: @2368399
     /* 2368399 */   GIM_Try, /*On fail goto*//*Label 33281*/ GIMT_Encode4(2368444), // Rule ID 50853 //
     /* 2368404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2368407 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2368410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2368424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368443 */     // GIR_Coverage, 50853,
     /* 2368443 */     GIR_EraseRootFromParent_Done,
     /* 2368444 */   // Label 33281: @2368444
     /* 2368444 */   GIM_Reject,
     /* 2368445 */ // Label 33279: @2368445
     /* 2368445 */ GIM_Reject,
     /* 2368446 */ // Label 33229: @2368446
     /* 2368446 */ GIM_Try, /*On fail goto*//*Label 33282*/ GIMT_Encode4(2368560),
     /* 2368451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2368454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2368457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368469 */   GIM_Try, /*On fail goto*//*Label 33283*/ GIMT_Encode4(2368514), // Rule ID 50796 //
     /* 2368474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368477 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2368480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2368494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368513 */     // GIR_Coverage, 50796,
     /* 2368513 */     GIR_EraseRootFromParent_Done,
     /* 2368514 */   // Label 33283: @2368514
     /* 2368514 */   GIM_Try, /*On fail goto*//*Label 33284*/ GIMT_Encode4(2368559), // Rule ID 50797 //
     /* 2368519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368522 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2368525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2368539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368558 */     // GIR_Coverage, 50797,
     /* 2368558 */     GIR_EraseRootFromParent_Done,
     /* 2368559 */   // Label 33284: @2368559
     /* 2368559 */   GIM_Reject,
     /* 2368560 */ // Label 33282: @2368560
     /* 2368560 */ GIM_Reject,
     /* 2368561 */ // Label 33230: @2368561
     /* 2368561 */ GIM_Try, /*On fail goto*//*Label 33285*/ GIMT_Encode4(2368675),
     /* 2368566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2368569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2368572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368584 */   GIM_Try, /*On fail goto*//*Label 33286*/ GIMT_Encode4(2368629), // Rule ID 50824 //
     /* 2368589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368592 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2368595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2368609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368628 */     // GIR_Coverage, 50824,
     /* 2368628 */     GIR_EraseRootFromParent_Done,
     /* 2368629 */   // Label 33286: @2368629
     /* 2368629 */   GIM_Try, /*On fail goto*//*Label 33287*/ GIMT_Encode4(2368674), // Rule ID 50825 //
     /* 2368634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368637 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2368640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2368654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368673 */     // GIR_Coverage, 50825,
     /* 2368673 */     GIR_EraseRootFromParent_Done,
     /* 2368674 */   // Label 33287: @2368674
     /* 2368674 */   GIM_Reject,
     /* 2368675 */ // Label 33285: @2368675
     /* 2368675 */ GIM_Reject,
     /* 2368676 */ // Label 33231: @2368676
     /* 2368676 */ GIM_Try, /*On fail goto*//*Label 33288*/ GIMT_Encode4(2368790),
     /* 2368681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2368684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2368687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368699 */   GIM_Try, /*On fail goto*//*Label 33289*/ GIMT_Encode4(2368744), // Rule ID 50840 //
     /* 2368704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368707 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2368710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2368724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368743 */     // GIR_Coverage, 50840,
     /* 2368743 */     GIR_EraseRootFromParent_Done,
     /* 2368744 */   // Label 33289: @2368744
     /* 2368744 */   GIM_Try, /*On fail goto*//*Label 33290*/ GIMT_Encode4(2368789), // Rule ID 50841 //
     /* 2368749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368752 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2368755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2368769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368788 */     // GIR_Coverage, 50841,
     /* 2368788 */     GIR_EraseRootFromParent_Done,
     /* 2368789 */   // Label 33290: @2368789
     /* 2368789 */   GIM_Reject,
     /* 2368790 */ // Label 33288: @2368790
     /* 2368790 */ GIM_Reject,
     /* 2368791 */ // Label 33232: @2368791
     /* 2368791 */ GIM_Try, /*On fail goto*//*Label 33291*/ GIMT_Encode4(2368905),
     /* 2368796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2368799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2368802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368814 */   GIM_Try, /*On fail goto*//*Label 33292*/ GIMT_Encode4(2368859), // Rule ID 50856 //
     /* 2368819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2368822 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2368825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2368839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368858 */     // GIR_Coverage, 50856,
     /* 2368858 */     GIR_EraseRootFromParent_Done,
     /* 2368859 */   // Label 33292: @2368859
     /* 2368859 */   GIM_Try, /*On fail goto*//*Label 33293*/ GIMT_Encode4(2368904), // Rule ID 50857 //
     /* 2368864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2368867 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2368870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2368884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368903 */     // GIR_Coverage, 50857,
     /* 2368903 */     GIR_EraseRootFromParent_Done,
     /* 2368904 */   // Label 33293: @2368904
     /* 2368904 */   GIM_Reject,
     /* 2368905 */ // Label 33291: @2368905
     /* 2368905 */ GIM_Reject,
     /* 2368906 */ // Label 33233: @2368906
     /* 2368906 */ GIM_Try, /*On fail goto*//*Label 33294*/ GIMT_Encode4(2369020),
     /* 2368911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2368914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2368917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368929 */   GIM_Try, /*On fail goto*//*Label 33295*/ GIMT_Encode4(2368974), // Rule ID 50812 //
     /* 2368934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368937 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2368940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2368954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368973 */     // GIR_Coverage, 50812,
     /* 2368973 */     GIR_EraseRootFromParent_Done,
     /* 2368974 */   // Label 33295: @2368974
     /* 2368974 */   GIM_Try, /*On fail goto*//*Label 33296*/ GIMT_Encode4(2369019), // Rule ID 50813 //
     /* 2368979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368982 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2368985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2368999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369018 */     // GIR_Coverage, 50813,
     /* 2369018 */     GIR_EraseRootFromParent_Done,
     /* 2369019 */   // Label 33296: @2369019
     /* 2369019 */   GIM_Reject,
     /* 2369020 */ // Label 33294: @2369020
     /* 2369020 */ GIM_Reject,
     /* 2369021 */ // Label 33234: @2369021
     /* 2369021 */ GIM_Try, /*On fail goto*//*Label 33297*/ GIMT_Encode4(2369135),
     /* 2369026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2369029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2369032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369044 */   GIM_Try, /*On fail goto*//*Label 33298*/ GIMT_Encode4(2369089), // Rule ID 50828 //
     /* 2369049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369052 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2369055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2369069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369088 */     // GIR_Coverage, 50828,
     /* 2369088 */     GIR_EraseRootFromParent_Done,
     /* 2369089 */   // Label 33298: @2369089
     /* 2369089 */   GIM_Try, /*On fail goto*//*Label 33299*/ GIMT_Encode4(2369134), // Rule ID 50829 //
     /* 2369094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369097 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2369100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2369114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369133 */     // GIR_Coverage, 50829,
     /* 2369133 */     GIR_EraseRootFromParent_Done,
     /* 2369134 */   // Label 33299: @2369134
     /* 2369134 */   GIM_Reject,
     /* 2369135 */ // Label 33297: @2369135
     /* 2369135 */ GIM_Reject,
     /* 2369136 */ // Label 33235: @2369136
     /* 2369136 */ GIM_Try, /*On fail goto*//*Label 33300*/ GIMT_Encode4(2369250),
     /* 2369141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2369144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2369147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369159 */   GIM_Try, /*On fail goto*//*Label 33301*/ GIMT_Encode4(2369204), // Rule ID 50844 //
     /* 2369164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369167 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2369170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2369184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369203 */     // GIR_Coverage, 50844,
     /* 2369203 */     GIR_EraseRootFromParent_Done,
     /* 2369204 */   // Label 33301: @2369204
     /* 2369204 */   GIM_Try, /*On fail goto*//*Label 33302*/ GIMT_Encode4(2369249), // Rule ID 50845 //
     /* 2369209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369212 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2369215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2369229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369248 */     // GIR_Coverage, 50845,
     /* 2369248 */     GIR_EraseRootFromParent_Done,
     /* 2369249 */   // Label 33302: @2369249
     /* 2369249 */   GIM_Reject,
     /* 2369250 */ // Label 33300: @2369250
     /* 2369250 */ GIM_Reject,
     /* 2369251 */ // Label 33236: @2369251
     /* 2369251 */ GIM_Try, /*On fail goto*//*Label 33303*/ GIMT_Encode4(2369365),
     /* 2369256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2369259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2369262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369274 */   GIM_Try, /*On fail goto*//*Label 33304*/ GIMT_Encode4(2369319), // Rule ID 50816 //
     /* 2369279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369282 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2369285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2369299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369318 */     // GIR_Coverage, 50816,
     /* 2369318 */     GIR_EraseRootFromParent_Done,
     /* 2369319 */   // Label 33304: @2369319
     /* 2369319 */   GIM_Try, /*On fail goto*//*Label 33305*/ GIMT_Encode4(2369364), // Rule ID 50817 //
     /* 2369324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369327 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2369330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2369344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369363 */     // GIR_Coverage, 50817,
     /* 2369363 */     GIR_EraseRootFromParent_Done,
     /* 2369364 */   // Label 33305: @2369364
     /* 2369364 */   GIM_Reject,
     /* 2369365 */ // Label 33303: @2369365
     /* 2369365 */ GIM_Reject,
     /* 2369366 */ // Label 33237: @2369366
     /* 2369366 */ GIM_Try, /*On fail goto*//*Label 33306*/ GIMT_Encode4(2369480),
     /* 2369371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2369374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2369377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369389 */   GIM_Try, /*On fail goto*//*Label 33307*/ GIMT_Encode4(2369434), // Rule ID 50832 //
     /* 2369394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369397 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2369400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2369414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369433 */     // GIR_Coverage, 50832,
     /* 2369433 */     GIR_EraseRootFromParent_Done,
     /* 2369434 */   // Label 33307: @2369434
     /* 2369434 */   GIM_Try, /*On fail goto*//*Label 33308*/ GIMT_Encode4(2369479), // Rule ID 50833 //
     /* 2369439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369442 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2369445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2369459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369478 */     // GIR_Coverage, 50833,
     /* 2369478 */     GIR_EraseRootFromParent_Done,
     /* 2369479 */   // Label 33308: @2369479
     /* 2369479 */   GIM_Reject,
     /* 2369480 */ // Label 33306: @2369480
     /* 2369480 */ GIM_Reject,
     /* 2369481 */ // Label 33238: @2369481
     /* 2369481 */ GIM_Try, /*On fail goto*//*Label 33309*/ GIMT_Encode4(2369595),
     /* 2369486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2369489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2369492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369504 */   GIM_Try, /*On fail goto*//*Label 33310*/ GIMT_Encode4(2369549), // Rule ID 50820 //
     /* 2369509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369512 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2369515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2369529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369548 */     // GIR_Coverage, 50820,
     /* 2369548 */     GIR_EraseRootFromParent_Done,
     /* 2369549 */   // Label 33310: @2369549
     /* 2369549 */   GIM_Try, /*On fail goto*//*Label 33311*/ GIMT_Encode4(2369594), // Rule ID 50821 //
     /* 2369554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369557 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2369560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2369574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369593 */     // GIR_Coverage, 50821,
     /* 2369593 */     GIR_EraseRootFromParent_Done,
     /* 2369594 */   // Label 33311: @2369594
     /* 2369594 */   GIM_Reject,
     /* 2369595 */ // Label 33309: @2369595
     /* 2369595 */ GIM_Reject,
     /* 2369596 */ // Label 33239: @2369596
     /* 2369596 */ GIM_Reject,
     /* 2369597 */ // Label 82: @2369597
     /* 2369597 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33336*/ GIMT_Encode4(2372372),
     /* 2369608 */ /*GILLT_s32*//*Label 33312*/ GIMT_Encode4(2369732),
     /* 2369612 */ /*GILLT_s64*//*Label 33313*/ GIMT_Encode4(2369787), GIMT_Encode4(0),
     /* 2369620 */ /*GILLT_nxv1s8*//*Label 33314*/ GIMT_Encode4(2369842),
     /* 2369624 */ /*GILLT_nxv1s16*//*Label 33315*/ GIMT_Encode4(2369957),
     /* 2369628 */ /*GILLT_nxv1s32*//*Label 33316*/ GIMT_Encode4(2370072),
     /* 2369632 */ /*GILLT_nxv1s64*//*Label 33317*/ GIMT_Encode4(2370187), GIMT_Encode4(0),
     /* 2369640 */ /*GILLT_nxv2s8*//*Label 33318*/ GIMT_Encode4(2370302),
     /* 2369644 */ /*GILLT_nxv2s16*//*Label 33319*/ GIMT_Encode4(2370417),
     /* 2369648 */ /*GILLT_nxv2s32*//*Label 33320*/ GIMT_Encode4(2370532),
     /* 2369652 */ /*GILLT_nxv2s64*//*Label 33321*/ GIMT_Encode4(2370647), GIMT_Encode4(0),
     /* 2369660 */ /*GILLT_nxv4s8*//*Label 33322*/ GIMT_Encode4(2370762),
     /* 2369664 */ /*GILLT_nxv4s16*//*Label 33323*/ GIMT_Encode4(2370877),
     /* 2369668 */ /*GILLT_nxv4s32*//*Label 33324*/ GIMT_Encode4(2370992),
     /* 2369672 */ /*GILLT_nxv4s64*//*Label 33325*/ GIMT_Encode4(2371107), GIMT_Encode4(0),
     /* 2369680 */ /*GILLT_nxv8s8*//*Label 33326*/ GIMT_Encode4(2371222),
     /* 2369684 */ /*GILLT_nxv8s16*//*Label 33327*/ GIMT_Encode4(2371337),
     /* 2369688 */ /*GILLT_nxv8s32*//*Label 33328*/ GIMT_Encode4(2371452),
     /* 2369692 */ /*GILLT_nxv8s64*//*Label 33329*/ GIMT_Encode4(2371567), GIMT_Encode4(0),
     /* 2369700 */ /*GILLT_nxv16s8*//*Label 33330*/ GIMT_Encode4(2371682),
     /* 2369704 */ /*GILLT_nxv16s16*//*Label 33331*/ GIMT_Encode4(2371797),
     /* 2369708 */ /*GILLT_nxv16s32*//*Label 33332*/ GIMT_Encode4(2371912), GIMT_Encode4(0),
     /* 2369716 */ /*GILLT_nxv32s8*//*Label 33333*/ GIMT_Encode4(2372027),
     /* 2369720 */ /*GILLT_nxv32s16*//*Label 33334*/ GIMT_Encode4(2372142), GIMT_Encode4(0),
     /* 2369728 */ /*GILLT_nxv64s8*//*Label 33335*/ GIMT_Encode4(2372257),
     /* 2369732 */ // Label 33312: @2369732
     /* 2369732 */ GIM_Try, /*On fail goto*//*Label 33337*/ GIMT_Encode4(2369786),
     /* 2369737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2369740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2369743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369755 */   GIM_Try, /*On fail goto*//*Label 33338*/ GIMT_Encode4(2369770), // Rule ID 64468 //
     /* 2369760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2369763 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2369763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2369768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369769 */     // GIR_Coverage, 64468,
     /* 2369769 */     GIR_Done,
     /* 2369770 */   // Label 33338: @2369770
     /* 2369770 */   GIM_Try, /*On fail goto*//*Label 33339*/ GIMT_Encode4(2369785), // Rule ID 2535 //
     /* 2369775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2369778 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2369778 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2369783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369784 */     // GIR_Coverage, 2535,
     /* 2369784 */     GIR_Done,
     /* 2369785 */   // Label 33339: @2369785
     /* 2369785 */   GIM_Reject,
     /* 2369786 */ // Label 33337: @2369786
     /* 2369786 */ GIM_Reject,
     /* 2369787 */ // Label 33313: @2369787
     /* 2369787 */ GIM_Try, /*On fail goto*//*Label 33340*/ GIMT_Encode4(2369841),
     /* 2369792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2369795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2369798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369810 */   GIM_Try, /*On fail goto*//*Label 33341*/ GIMT_Encode4(2369825), // Rule ID 64467 //
     /* 2369815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2369818 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2369818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2369823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369824 */     // GIR_Coverage, 64467,
     /* 2369824 */     GIR_Done,
     /* 2369825 */   // Label 33341: @2369825
     /* 2369825 */   GIM_Try, /*On fail goto*//*Label 33342*/ GIMT_Encode4(2369840), // Rule ID 2534 //
     /* 2369830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2369833 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2369833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2369838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369839 */     // GIR_Coverage, 2534,
     /* 2369839 */     GIR_Done,
     /* 2369840 */   // Label 33342: @2369840
     /* 2369840 */   GIM_Reject,
     /* 2369841 */ // Label 33340: @2369841
     /* 2369841 */ GIM_Reject,
     /* 2369842 */ // Label 33314: @2369842
     /* 2369842 */ GIM_Try, /*On fail goto*//*Label 33343*/ GIMT_Encode4(2369956),
     /* 2369847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2369850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2369853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369865 */   GIM_Try, /*On fail goto*//*Label 33344*/ GIMT_Encode4(2369910), // Rule ID 50508 //
     /* 2369870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369873 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2369876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2369890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369909 */     // GIR_Coverage, 50508,
     /* 2369909 */     GIR_EraseRootFromParent_Done,
     /* 2369910 */   // Label 33344: @2369910
     /* 2369910 */   GIM_Try, /*On fail goto*//*Label 33345*/ GIMT_Encode4(2369955), // Rule ID 50509 //
     /* 2369915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369918 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2369921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2369935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369954 */     // GIR_Coverage, 50509,
     /* 2369954 */     GIR_EraseRootFromParent_Done,
     /* 2369955 */   // Label 33345: @2369955
     /* 2369955 */   GIM_Reject,
     /* 2369956 */ // Label 33343: @2369956
     /* 2369956 */ GIM_Reject,
     /* 2369957 */ // Label 33315: @2369957
     /* 2369957 */ GIM_Try, /*On fail goto*//*Label 33346*/ GIMT_Encode4(2370071),
     /* 2369962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2369965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2369968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369980 */   GIM_Try, /*On fail goto*//*Label 33347*/ GIMT_Encode4(2370025), // Rule ID 50520 //
     /* 2369985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369988 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2369991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2370005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370024 */     // GIR_Coverage, 50520,
     /* 2370024 */     GIR_EraseRootFromParent_Done,
     /* 2370025 */   // Label 33347: @2370025
     /* 2370025 */   GIM_Try, /*On fail goto*//*Label 33348*/ GIMT_Encode4(2370070), // Rule ID 50521 //
     /* 2370030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370033 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2370036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2370050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370069 */     // GIR_Coverage, 50521,
     /* 2370069 */     GIR_EraseRootFromParent_Done,
     /* 2370070 */   // Label 33348: @2370070
     /* 2370070 */   GIM_Reject,
     /* 2370071 */ // Label 33346: @2370071
     /* 2370071 */ GIM_Reject,
     /* 2370072 */ // Label 33316: @2370072
     /* 2370072 */ GIM_Try, /*On fail goto*//*Label 33349*/ GIMT_Encode4(2370186),
     /* 2370077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2370080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2370083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370091 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370095 */   GIM_Try, /*On fail goto*//*Label 33350*/ GIMT_Encode4(2370140), // Rule ID 50528 //
     /* 2370100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370103 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2370106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2370120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370139 */     // GIR_Coverage, 50528,
     /* 2370139 */     GIR_EraseRootFromParent_Done,
     /* 2370140 */   // Label 33350: @2370140
     /* 2370140 */   GIM_Try, /*On fail goto*//*Label 33351*/ GIMT_Encode4(2370185), // Rule ID 50529 //
     /* 2370145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370148 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2370151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2370165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370184 */     // GIR_Coverage, 50529,
     /* 2370184 */     GIR_EraseRootFromParent_Done,
     /* 2370185 */   // Label 33351: @2370185
     /* 2370185 */   GIM_Reject,
     /* 2370186 */ // Label 33349: @2370186
     /* 2370186 */ GIM_Reject,
     /* 2370187 */ // Label 33317: @2370187
     /* 2370187 */ GIM_Try, /*On fail goto*//*Label 33352*/ GIMT_Encode4(2370301),
     /* 2370192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2370195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2370198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370210 */   GIM_Try, /*On fail goto*//*Label 33353*/ GIMT_Encode4(2370255), // Rule ID 50544 //
     /* 2370215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2370218 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2370221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2370235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370254 */     // GIR_Coverage, 50544,
     /* 2370254 */     GIR_EraseRootFromParent_Done,
     /* 2370255 */   // Label 33353: @2370255
     /* 2370255 */   GIM_Try, /*On fail goto*//*Label 33354*/ GIMT_Encode4(2370300), // Rule ID 50545 //
     /* 2370260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2370263 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2370266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2370280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370299 */     // GIR_Coverage, 50545,
     /* 2370299 */     GIR_EraseRootFromParent_Done,
     /* 2370300 */   // Label 33354: @2370300
     /* 2370300 */   GIM_Reject,
     /* 2370301 */ // Label 33352: @2370301
     /* 2370301 */ GIM_Reject,
     /* 2370302 */ // Label 33318: @2370302
     /* 2370302 */ GIM_Try, /*On fail goto*//*Label 33355*/ GIMT_Encode4(2370416),
     /* 2370307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2370310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2370313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370321 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370325 */   GIM_Try, /*On fail goto*//*Label 33356*/ GIMT_Encode4(2370370), // Rule ID 50512 //
     /* 2370330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370333 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2370336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2370350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370369 */     // GIR_Coverage, 50512,
     /* 2370369 */     GIR_EraseRootFromParent_Done,
     /* 2370370 */   // Label 33356: @2370370
     /* 2370370 */   GIM_Try, /*On fail goto*//*Label 33357*/ GIMT_Encode4(2370415), // Rule ID 50513 //
     /* 2370375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370378 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2370381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2370395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370414 */     // GIR_Coverage, 50513,
     /* 2370414 */     GIR_EraseRootFromParent_Done,
     /* 2370415 */   // Label 33357: @2370415
     /* 2370415 */   GIM_Reject,
     /* 2370416 */ // Label 33355: @2370416
     /* 2370416 */ GIM_Reject,
     /* 2370417 */ // Label 33319: @2370417
     /* 2370417 */ GIM_Try, /*On fail goto*//*Label 33358*/ GIMT_Encode4(2370531),
     /* 2370422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2370425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2370428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370440 */   GIM_Try, /*On fail goto*//*Label 33359*/ GIMT_Encode4(2370485), // Rule ID 50524 //
     /* 2370445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370448 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2370451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2370465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370484 */     // GIR_Coverage, 50524,
     /* 2370484 */     GIR_EraseRootFromParent_Done,
     /* 2370485 */   // Label 33359: @2370485
     /* 2370485 */   GIM_Try, /*On fail goto*//*Label 33360*/ GIMT_Encode4(2370530), // Rule ID 50525 //
     /* 2370490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370493 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2370496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2370510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370529 */     // GIR_Coverage, 50525,
     /* 2370529 */     GIR_EraseRootFromParent_Done,
     /* 2370530 */   // Label 33360: @2370530
     /* 2370530 */   GIM_Reject,
     /* 2370531 */ // Label 33358: @2370531
     /* 2370531 */ GIM_Reject,
     /* 2370532 */ // Label 33320: @2370532
     /* 2370532 */ GIM_Try, /*On fail goto*//*Label 33361*/ GIMT_Encode4(2370646),
     /* 2370537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2370540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2370543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370551 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370555 */   GIM_Try, /*On fail goto*//*Label 33362*/ GIMT_Encode4(2370600), // Rule ID 50540 //
     /* 2370560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370563 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2370566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2370580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370599 */     // GIR_Coverage, 50540,
     /* 2370599 */     GIR_EraseRootFromParent_Done,
     /* 2370600 */   // Label 33362: @2370600
     /* 2370600 */   GIM_Try, /*On fail goto*//*Label 33363*/ GIMT_Encode4(2370645), // Rule ID 50541 //
     /* 2370605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370608 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2370611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2370625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370644 */     // GIR_Coverage, 50541,
     /* 2370644 */     GIR_EraseRootFromParent_Done,
     /* 2370645 */   // Label 33363: @2370645
     /* 2370645 */   GIM_Reject,
     /* 2370646 */ // Label 33361: @2370646
     /* 2370646 */ GIM_Reject,
     /* 2370647 */ // Label 33321: @2370647
     /* 2370647 */ GIM_Try, /*On fail goto*//*Label 33364*/ GIMT_Encode4(2370761),
     /* 2370652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2370655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2370658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370670 */   GIM_Try, /*On fail goto*//*Label 33365*/ GIMT_Encode4(2370715), // Rule ID 50584 //
     /* 2370675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2370678 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2370681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2370695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370714 */     // GIR_Coverage, 50584,
     /* 2370714 */     GIR_EraseRootFromParent_Done,
     /* 2370715 */   // Label 33365: @2370715
     /* 2370715 */   GIM_Try, /*On fail goto*//*Label 33366*/ GIMT_Encode4(2370760), // Rule ID 50585 //
     /* 2370720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2370723 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2370726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2370740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370759 */     // GIR_Coverage, 50585,
     /* 2370759 */     GIR_EraseRootFromParent_Done,
     /* 2370760 */   // Label 33366: @2370760
     /* 2370760 */   GIM_Reject,
     /* 2370761 */ // Label 33364: @2370761
     /* 2370761 */ GIM_Reject,
     /* 2370762 */ // Label 33322: @2370762
     /* 2370762 */ GIM_Try, /*On fail goto*//*Label 33367*/ GIMT_Encode4(2370876),
     /* 2370767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2370770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2370773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370781 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370785 */   GIM_Try, /*On fail goto*//*Label 33368*/ GIMT_Encode4(2370830), // Rule ID 50516 //
     /* 2370790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370793 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2370796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2370810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370829 */     // GIR_Coverage, 50516,
     /* 2370829 */     GIR_EraseRootFromParent_Done,
     /* 2370830 */   // Label 33368: @2370830
     /* 2370830 */   GIM_Try, /*On fail goto*//*Label 33369*/ GIMT_Encode4(2370875), // Rule ID 50517 //
     /* 2370835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370838 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2370841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2370855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370874 */     // GIR_Coverage, 50517,
     /* 2370874 */     GIR_EraseRootFromParent_Done,
     /* 2370875 */   // Label 33369: @2370875
     /* 2370875 */   GIM_Reject,
     /* 2370876 */ // Label 33367: @2370876
     /* 2370876 */ GIM_Reject,
     /* 2370877 */ // Label 33323: @2370877
     /* 2370877 */ GIM_Try, /*On fail goto*//*Label 33370*/ GIMT_Encode4(2370991),
     /* 2370882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2370885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2370888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370900 */   GIM_Try, /*On fail goto*//*Label 33371*/ GIMT_Encode4(2370945), // Rule ID 50536 //
     /* 2370905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370908 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2370911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2370925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370944 */     // GIR_Coverage, 50536,
     /* 2370944 */     GIR_EraseRootFromParent_Done,
     /* 2370945 */   // Label 33371: @2370945
     /* 2370945 */   GIM_Try, /*On fail goto*//*Label 33372*/ GIMT_Encode4(2370990), // Rule ID 50537 //
     /* 2370950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370953 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2370956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2370970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370989 */     // GIR_Coverage, 50537,
     /* 2370989 */     GIR_EraseRootFromParent_Done,
     /* 2370990 */   // Label 33372: @2370990
     /* 2370990 */   GIM_Reject,
     /* 2370991 */ // Label 33370: @2370991
     /* 2370991 */ GIM_Reject,
     /* 2370992 */ // Label 33324: @2370992
     /* 2370992 */ GIM_Try, /*On fail goto*//*Label 33373*/ GIMT_Encode4(2371106),
     /* 2370997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2371000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2371003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371015 */   GIM_Try, /*On fail goto*//*Label 33374*/ GIMT_Encode4(2371060), // Rule ID 50572 //
     /* 2371020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371023 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2371026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2371040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371059 */     // GIR_Coverage, 50572,
     /* 2371059 */     GIR_EraseRootFromParent_Done,
     /* 2371060 */   // Label 33374: @2371060
     /* 2371060 */   GIM_Try, /*On fail goto*//*Label 33375*/ GIMT_Encode4(2371105), // Rule ID 50573 //
     /* 2371065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371068 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2371071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2371085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371104 */     // GIR_Coverage, 50573,
     /* 2371104 */     GIR_EraseRootFromParent_Done,
     /* 2371105 */   // Label 33375: @2371105
     /* 2371105 */   GIM_Reject,
     /* 2371106 */ // Label 33373: @2371106
     /* 2371106 */ GIM_Reject,
     /* 2371107 */ // Label 33325: @2371107
     /* 2371107 */ GIM_Try, /*On fail goto*//*Label 33376*/ GIMT_Encode4(2371221),
     /* 2371112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2371115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2371118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371126 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371130 */   GIM_Try, /*On fail goto*//*Label 33377*/ GIMT_Encode4(2371175), // Rule ID 50588 //
     /* 2371135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2371138 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2371141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2371155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371174 */     // GIR_Coverage, 50588,
     /* 2371174 */     GIR_EraseRootFromParent_Done,
     /* 2371175 */   // Label 33377: @2371175
     /* 2371175 */   GIM_Try, /*On fail goto*//*Label 33378*/ GIMT_Encode4(2371220), // Rule ID 50589 //
     /* 2371180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2371183 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2371186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2371200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371219 */     // GIR_Coverage, 50589,
     /* 2371219 */     GIR_EraseRootFromParent_Done,
     /* 2371220 */   // Label 33378: @2371220
     /* 2371220 */   GIM_Reject,
     /* 2371221 */ // Label 33376: @2371221
     /* 2371221 */ GIM_Reject,
     /* 2371222 */ // Label 33326: @2371222
     /* 2371222 */ GIM_Try, /*On fail goto*//*Label 33379*/ GIMT_Encode4(2371336),
     /* 2371227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2371230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2371233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371241 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371245 */   GIM_Try, /*On fail goto*//*Label 33380*/ GIMT_Encode4(2371290), // Rule ID 50532 //
     /* 2371250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371253 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2371256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2371270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371289 */     // GIR_Coverage, 50532,
     /* 2371289 */     GIR_EraseRootFromParent_Done,
     /* 2371290 */   // Label 33380: @2371290
     /* 2371290 */   GIM_Try, /*On fail goto*//*Label 33381*/ GIMT_Encode4(2371335), // Rule ID 50533 //
     /* 2371295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371298 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2371301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2371315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371334 */     // GIR_Coverage, 50533,
     /* 2371334 */     GIR_EraseRootFromParent_Done,
     /* 2371335 */   // Label 33381: @2371335
     /* 2371335 */   GIM_Reject,
     /* 2371336 */ // Label 33379: @2371336
     /* 2371336 */ GIM_Reject,
     /* 2371337 */ // Label 33327: @2371337
     /* 2371337 */ GIM_Try, /*On fail goto*//*Label 33382*/ GIMT_Encode4(2371451),
     /* 2371342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2371345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2371348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371360 */   GIM_Try, /*On fail goto*//*Label 33383*/ GIMT_Encode4(2371405), // Rule ID 50560 //
     /* 2371365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371368 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2371371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2371385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371404 */     // GIR_Coverage, 50560,
     /* 2371404 */     GIR_EraseRootFromParent_Done,
     /* 2371405 */   // Label 33383: @2371405
     /* 2371405 */   GIM_Try, /*On fail goto*//*Label 33384*/ GIMT_Encode4(2371450), // Rule ID 50561 //
     /* 2371410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371413 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2371416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2371430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371449 */     // GIR_Coverage, 50561,
     /* 2371449 */     GIR_EraseRootFromParent_Done,
     /* 2371450 */   // Label 33384: @2371450
     /* 2371450 */   GIM_Reject,
     /* 2371451 */ // Label 33382: @2371451
     /* 2371451 */ GIM_Reject,
     /* 2371452 */ // Label 33328: @2371452
     /* 2371452 */ GIM_Try, /*On fail goto*//*Label 33385*/ GIMT_Encode4(2371566),
     /* 2371457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2371460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2371463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371475 */   GIM_Try, /*On fail goto*//*Label 33386*/ GIMT_Encode4(2371520), // Rule ID 50576 //
     /* 2371480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371483 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2371486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2371500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371519 */     // GIR_Coverage, 50576,
     /* 2371519 */     GIR_EraseRootFromParent_Done,
     /* 2371520 */   // Label 33386: @2371520
     /* 2371520 */   GIM_Try, /*On fail goto*//*Label 33387*/ GIMT_Encode4(2371565), // Rule ID 50577 //
     /* 2371525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371528 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2371531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2371545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371564 */     // GIR_Coverage, 50577,
     /* 2371564 */     GIR_EraseRootFromParent_Done,
     /* 2371565 */   // Label 33387: @2371565
     /* 2371565 */   GIM_Reject,
     /* 2371566 */ // Label 33385: @2371566
     /* 2371566 */ GIM_Reject,
     /* 2371567 */ // Label 33329: @2371567
     /* 2371567 */ GIM_Try, /*On fail goto*//*Label 33388*/ GIMT_Encode4(2371681),
     /* 2371572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2371575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2371578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371586 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371590 */   GIM_Try, /*On fail goto*//*Label 33389*/ GIMT_Encode4(2371635), // Rule ID 50592 //
     /* 2371595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2371598 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2371601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2371615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371634 */     // GIR_Coverage, 50592,
     /* 2371634 */     GIR_EraseRootFromParent_Done,
     /* 2371635 */   // Label 33389: @2371635
     /* 2371635 */   GIM_Try, /*On fail goto*//*Label 33390*/ GIMT_Encode4(2371680), // Rule ID 50593 //
     /* 2371640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2371643 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2371646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2371660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371679 */     // GIR_Coverage, 50593,
     /* 2371679 */     GIR_EraseRootFromParent_Done,
     /* 2371680 */   // Label 33390: @2371680
     /* 2371680 */   GIM_Reject,
     /* 2371681 */ // Label 33388: @2371681
     /* 2371681 */ GIM_Reject,
     /* 2371682 */ // Label 33330: @2371682
     /* 2371682 */ GIM_Try, /*On fail goto*//*Label 33391*/ GIMT_Encode4(2371796),
     /* 2371687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2371690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2371693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371705 */   GIM_Try, /*On fail goto*//*Label 33392*/ GIMT_Encode4(2371750), // Rule ID 50548 //
     /* 2371710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371713 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2371716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2371730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371749 */     // GIR_Coverage, 50548,
     /* 2371749 */     GIR_EraseRootFromParent_Done,
     /* 2371750 */   // Label 33392: @2371750
     /* 2371750 */   GIM_Try, /*On fail goto*//*Label 33393*/ GIMT_Encode4(2371795), // Rule ID 50549 //
     /* 2371755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371758 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2371761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2371775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371794 */     // GIR_Coverage, 50549,
     /* 2371794 */     GIR_EraseRootFromParent_Done,
     /* 2371795 */   // Label 33393: @2371795
     /* 2371795 */   GIM_Reject,
     /* 2371796 */ // Label 33391: @2371796
     /* 2371796 */ GIM_Reject,
     /* 2371797 */ // Label 33331: @2371797
     /* 2371797 */ GIM_Try, /*On fail goto*//*Label 33394*/ GIMT_Encode4(2371911),
     /* 2371802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2371805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2371808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371820 */   GIM_Try, /*On fail goto*//*Label 33395*/ GIMT_Encode4(2371865), // Rule ID 50564 //
     /* 2371825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371828 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2371831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2371845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371864 */     // GIR_Coverage, 50564,
     /* 2371864 */     GIR_EraseRootFromParent_Done,
     /* 2371865 */   // Label 33395: @2371865
     /* 2371865 */   GIM_Try, /*On fail goto*//*Label 33396*/ GIMT_Encode4(2371910), // Rule ID 50565 //
     /* 2371870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371873 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2371876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2371890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371909 */     // GIR_Coverage, 50565,
     /* 2371909 */     GIR_EraseRootFromParent_Done,
     /* 2371910 */   // Label 33396: @2371910
     /* 2371910 */   GIM_Reject,
     /* 2371911 */ // Label 33394: @2371911
     /* 2371911 */ GIM_Reject,
     /* 2371912 */ // Label 33332: @2371912
     /* 2371912 */ GIM_Try, /*On fail goto*//*Label 33397*/ GIMT_Encode4(2372026),
     /* 2371917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2371920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2371923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371935 */   GIM_Try, /*On fail goto*//*Label 33398*/ GIMT_Encode4(2371980), // Rule ID 50580 //
     /* 2371940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371943 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2371946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2371960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371979 */     // GIR_Coverage, 50580,
     /* 2371979 */     GIR_EraseRootFromParent_Done,
     /* 2371980 */   // Label 33398: @2371980
     /* 2371980 */   GIM_Try, /*On fail goto*//*Label 33399*/ GIMT_Encode4(2372025), // Rule ID 50581 //
     /* 2371985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371988 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2371991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2372005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372024 */     // GIR_Coverage, 50581,
     /* 2372024 */     GIR_EraseRootFromParent_Done,
     /* 2372025 */   // Label 33399: @2372025
     /* 2372025 */   GIM_Reject,
     /* 2372026 */ // Label 33397: @2372026
     /* 2372026 */ GIM_Reject,
     /* 2372027 */ // Label 33333: @2372027
     /* 2372027 */ GIM_Try, /*On fail goto*//*Label 33400*/ GIMT_Encode4(2372141),
     /* 2372032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2372035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2372038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372050 */   GIM_Try, /*On fail goto*//*Label 33401*/ GIMT_Encode4(2372095), // Rule ID 50552 //
     /* 2372055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372058 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2372061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2372075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372094 */     // GIR_Coverage, 50552,
     /* 2372094 */     GIR_EraseRootFromParent_Done,
     /* 2372095 */   // Label 33401: @2372095
     /* 2372095 */   GIM_Try, /*On fail goto*//*Label 33402*/ GIMT_Encode4(2372140), // Rule ID 50553 //
     /* 2372100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372103 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2372106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2372120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372139 */     // GIR_Coverage, 50553,
     /* 2372139 */     GIR_EraseRootFromParent_Done,
     /* 2372140 */   // Label 33402: @2372140
     /* 2372140 */   GIM_Reject,
     /* 2372141 */ // Label 33400: @2372141
     /* 2372141 */ GIM_Reject,
     /* 2372142 */ // Label 33334: @2372142
     /* 2372142 */ GIM_Try, /*On fail goto*//*Label 33403*/ GIMT_Encode4(2372256),
     /* 2372147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2372150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2372153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372165 */   GIM_Try, /*On fail goto*//*Label 33404*/ GIMT_Encode4(2372210), // Rule ID 50568 //
     /* 2372170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372173 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2372176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2372190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372209 */     // GIR_Coverage, 50568,
     /* 2372209 */     GIR_EraseRootFromParent_Done,
     /* 2372210 */   // Label 33404: @2372210
     /* 2372210 */   GIM_Try, /*On fail goto*//*Label 33405*/ GIMT_Encode4(2372255), // Rule ID 50569 //
     /* 2372215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372218 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2372221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2372235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372254 */     // GIR_Coverage, 50569,
     /* 2372254 */     GIR_EraseRootFromParent_Done,
     /* 2372255 */   // Label 33405: @2372255
     /* 2372255 */   GIM_Reject,
     /* 2372256 */ // Label 33403: @2372256
     /* 2372256 */ GIM_Reject,
     /* 2372257 */ // Label 33335: @2372257
     /* 2372257 */ GIM_Try, /*On fail goto*//*Label 33406*/ GIMT_Encode4(2372371),
     /* 2372262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2372265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2372268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372280 */   GIM_Try, /*On fail goto*//*Label 33407*/ GIMT_Encode4(2372325), // Rule ID 50556 //
     /* 2372285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372288 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2372291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2372305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372324 */     // GIR_Coverage, 50556,
     /* 2372324 */     GIR_EraseRootFromParent_Done,
     /* 2372325 */   // Label 33407: @2372325
     /* 2372325 */   GIM_Try, /*On fail goto*//*Label 33408*/ GIMT_Encode4(2372370), // Rule ID 50557 //
     /* 2372330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372333 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2372336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2372350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372369 */     // GIR_Coverage, 50557,
     /* 2372369 */     GIR_EraseRootFromParent_Done,
     /* 2372370 */   // Label 33408: @2372370
     /* 2372370 */   GIM_Reject,
     /* 2372371 */ // Label 33406: @2372371
     /* 2372371 */ GIM_Reject,
     /* 2372372 */ // Label 33336: @2372372
     /* 2372372 */ GIM_Reject,
     /* 2372373 */ // Label 83: @2372373
     /* 2372373 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33433*/ GIMT_Encode4(2375148),
     /* 2372384 */ /*GILLT_s32*//*Label 33409*/ GIMT_Encode4(2372508),
     /* 2372388 */ /*GILLT_s64*//*Label 33410*/ GIMT_Encode4(2372563), GIMT_Encode4(0),
     /* 2372396 */ /*GILLT_nxv1s8*//*Label 33411*/ GIMT_Encode4(2372618),
     /* 2372400 */ /*GILLT_nxv1s16*//*Label 33412*/ GIMT_Encode4(2372733),
     /* 2372404 */ /*GILLT_nxv1s32*//*Label 33413*/ GIMT_Encode4(2372848),
     /* 2372408 */ /*GILLT_nxv1s64*//*Label 33414*/ GIMT_Encode4(2372963), GIMT_Encode4(0),
     /* 2372416 */ /*GILLT_nxv2s8*//*Label 33415*/ GIMT_Encode4(2373078),
     /* 2372420 */ /*GILLT_nxv2s16*//*Label 33416*/ GIMT_Encode4(2373193),
     /* 2372424 */ /*GILLT_nxv2s32*//*Label 33417*/ GIMT_Encode4(2373308),
     /* 2372428 */ /*GILLT_nxv2s64*//*Label 33418*/ GIMT_Encode4(2373423), GIMT_Encode4(0),
     /* 2372436 */ /*GILLT_nxv4s8*//*Label 33419*/ GIMT_Encode4(2373538),
     /* 2372440 */ /*GILLT_nxv4s16*//*Label 33420*/ GIMT_Encode4(2373653),
     /* 2372444 */ /*GILLT_nxv4s32*//*Label 33421*/ GIMT_Encode4(2373768),
     /* 2372448 */ /*GILLT_nxv4s64*//*Label 33422*/ GIMT_Encode4(2373883), GIMT_Encode4(0),
     /* 2372456 */ /*GILLT_nxv8s8*//*Label 33423*/ GIMT_Encode4(2373998),
     /* 2372460 */ /*GILLT_nxv8s16*//*Label 33424*/ GIMT_Encode4(2374113),
     /* 2372464 */ /*GILLT_nxv8s32*//*Label 33425*/ GIMT_Encode4(2374228),
     /* 2372468 */ /*GILLT_nxv8s64*//*Label 33426*/ GIMT_Encode4(2374343), GIMT_Encode4(0),
     /* 2372476 */ /*GILLT_nxv16s8*//*Label 33427*/ GIMT_Encode4(2374458),
     /* 2372480 */ /*GILLT_nxv16s16*//*Label 33428*/ GIMT_Encode4(2374573),
     /* 2372484 */ /*GILLT_nxv16s32*//*Label 33429*/ GIMT_Encode4(2374688), GIMT_Encode4(0),
     /* 2372492 */ /*GILLT_nxv32s8*//*Label 33430*/ GIMT_Encode4(2374803),
     /* 2372496 */ /*GILLT_nxv32s16*//*Label 33431*/ GIMT_Encode4(2374918), GIMT_Encode4(0),
     /* 2372504 */ /*GILLT_nxv64s8*//*Label 33432*/ GIMT_Encode4(2375033),
     /* 2372508 */ // Label 33409: @2372508
     /* 2372508 */ GIM_Try, /*On fail goto*//*Label 33434*/ GIMT_Encode4(2372562),
     /* 2372513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2372516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2372519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372531 */   GIM_Try, /*On fail goto*//*Label 33435*/ GIMT_Encode4(2372546), // Rule ID 64472 //
     /* 2372536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2372539 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2372539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2372544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372545 */     // GIR_Coverage, 64472,
     /* 2372545 */     GIR_Done,
     /* 2372546 */   // Label 33435: @2372546
     /* 2372546 */   GIM_Try, /*On fail goto*//*Label 33436*/ GIMT_Encode4(2372561), // Rule ID 2537 //
     /* 2372551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2372554 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2372554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2372559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372560 */     // GIR_Coverage, 2537,
     /* 2372560 */     GIR_Done,
     /* 2372561 */   // Label 33436: @2372561
     /* 2372561 */   GIM_Reject,
     /* 2372562 */ // Label 33434: @2372562
     /* 2372562 */ GIM_Reject,
     /* 2372563 */ // Label 33410: @2372563
     /* 2372563 */ GIM_Try, /*On fail goto*//*Label 33437*/ GIMT_Encode4(2372617),
     /* 2372568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2372571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2372574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372586 */   GIM_Try, /*On fail goto*//*Label 33438*/ GIMT_Encode4(2372601), // Rule ID 64471 //
     /* 2372591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2372594 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2372594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2372599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372600 */     // GIR_Coverage, 64471,
     /* 2372600 */     GIR_Done,
     /* 2372601 */   // Label 33438: @2372601
     /* 2372601 */   GIM_Try, /*On fail goto*//*Label 33439*/ GIMT_Encode4(2372616), // Rule ID 2536 //
     /* 2372606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2372609 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2372609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2372614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372615 */     // GIR_Coverage, 2536,
     /* 2372615 */     GIR_Done,
     /* 2372616 */   // Label 33439: @2372616
     /* 2372616 */   GIM_Reject,
     /* 2372617 */ // Label 33437: @2372617
     /* 2372617 */ GIM_Reject,
     /* 2372618 */ // Label 33411: @2372618
     /* 2372618 */ GIM_Try, /*On fail goto*//*Label 33440*/ GIMT_Encode4(2372732),
     /* 2372623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2372626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2372629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372641 */   GIM_Try, /*On fail goto*//*Label 33441*/ GIMT_Encode4(2372686), // Rule ID 50684 //
     /* 2372646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372649 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2372652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2372666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372685 */     // GIR_Coverage, 50684,
     /* 2372685 */     GIR_EraseRootFromParent_Done,
     /* 2372686 */   // Label 33441: @2372686
     /* 2372686 */   GIM_Try, /*On fail goto*//*Label 33442*/ GIMT_Encode4(2372731), // Rule ID 50685 //
     /* 2372691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372694 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2372697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2372711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372730 */     // GIR_Coverage, 50685,
     /* 2372730 */     GIR_EraseRootFromParent_Done,
     /* 2372731 */   // Label 33442: @2372731
     /* 2372731 */   GIM_Reject,
     /* 2372732 */ // Label 33440: @2372732
     /* 2372732 */ GIM_Reject,
     /* 2372733 */ // Label 33412: @2372733
     /* 2372733 */ GIM_Try, /*On fail goto*//*Label 33443*/ GIMT_Encode4(2372847),
     /* 2372738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2372741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2372744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372756 */   GIM_Try, /*On fail goto*//*Label 33444*/ GIMT_Encode4(2372801), // Rule ID 50696 //
     /* 2372761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372764 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2372767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2372781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372800 */     // GIR_Coverage, 50696,
     /* 2372800 */     GIR_EraseRootFromParent_Done,
     /* 2372801 */   // Label 33444: @2372801
     /* 2372801 */   GIM_Try, /*On fail goto*//*Label 33445*/ GIMT_Encode4(2372846), // Rule ID 50697 //
     /* 2372806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372809 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2372812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2372826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372845 */     // GIR_Coverage, 50697,
     /* 2372845 */     GIR_EraseRootFromParent_Done,
     /* 2372846 */   // Label 33445: @2372846
     /* 2372846 */   GIM_Reject,
     /* 2372847 */ // Label 33443: @2372847
     /* 2372847 */ GIM_Reject,
     /* 2372848 */ // Label 33413: @2372848
     /* 2372848 */ GIM_Try, /*On fail goto*//*Label 33446*/ GIMT_Encode4(2372962),
     /* 2372853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2372856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2372859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372871 */   GIM_Try, /*On fail goto*//*Label 33447*/ GIMT_Encode4(2372916), // Rule ID 50704 //
     /* 2372876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372879 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2372882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2372896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372915 */     // GIR_Coverage, 50704,
     /* 2372915 */     GIR_EraseRootFromParent_Done,
     /* 2372916 */   // Label 33447: @2372916
     /* 2372916 */   GIM_Try, /*On fail goto*//*Label 33448*/ GIMT_Encode4(2372961), // Rule ID 50705 //
     /* 2372921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372924 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2372927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2372941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372960 */     // GIR_Coverage, 50705,
     /* 2372960 */     GIR_EraseRootFromParent_Done,
     /* 2372961 */   // Label 33448: @2372961
     /* 2372961 */   GIM_Reject,
     /* 2372962 */ // Label 33446: @2372962
     /* 2372962 */ GIM_Reject,
     /* 2372963 */ // Label 33414: @2372963
     /* 2372963 */ GIM_Try, /*On fail goto*//*Label 33449*/ GIMT_Encode4(2373077),
     /* 2372968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2372971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2372974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372986 */   GIM_Try, /*On fail goto*//*Label 33450*/ GIMT_Encode4(2373031), // Rule ID 50720 //
     /* 2372991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2372994 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2372997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2373011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373030 */     // GIR_Coverage, 50720,
     /* 2373030 */     GIR_EraseRootFromParent_Done,
     /* 2373031 */   // Label 33450: @2373031
     /* 2373031 */   GIM_Try, /*On fail goto*//*Label 33451*/ GIMT_Encode4(2373076), // Rule ID 50721 //
     /* 2373036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2373039 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2373042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2373056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373075 */     // GIR_Coverage, 50721,
     /* 2373075 */     GIR_EraseRootFromParent_Done,
     /* 2373076 */   // Label 33451: @2373076
     /* 2373076 */   GIM_Reject,
     /* 2373077 */ // Label 33449: @2373077
     /* 2373077 */ GIM_Reject,
     /* 2373078 */ // Label 33415: @2373078
     /* 2373078 */ GIM_Try, /*On fail goto*//*Label 33452*/ GIMT_Encode4(2373192),
     /* 2373083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2373086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2373089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373101 */   GIM_Try, /*On fail goto*//*Label 33453*/ GIMT_Encode4(2373146), // Rule ID 50688 //
     /* 2373106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373109 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2373112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2373126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373145 */     // GIR_Coverage, 50688,
     /* 2373145 */     GIR_EraseRootFromParent_Done,
     /* 2373146 */   // Label 33453: @2373146
     /* 2373146 */   GIM_Try, /*On fail goto*//*Label 33454*/ GIMT_Encode4(2373191), // Rule ID 50689 //
     /* 2373151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373154 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2373157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2373171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373190 */     // GIR_Coverage, 50689,
     /* 2373190 */     GIR_EraseRootFromParent_Done,
     /* 2373191 */   // Label 33454: @2373191
     /* 2373191 */   GIM_Reject,
     /* 2373192 */ // Label 33452: @2373192
     /* 2373192 */ GIM_Reject,
     /* 2373193 */ // Label 33416: @2373193
     /* 2373193 */ GIM_Try, /*On fail goto*//*Label 33455*/ GIMT_Encode4(2373307),
     /* 2373198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2373201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2373204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373216 */   GIM_Try, /*On fail goto*//*Label 33456*/ GIMT_Encode4(2373261), // Rule ID 50700 //
     /* 2373221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373224 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2373227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2373241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373260 */     // GIR_Coverage, 50700,
     /* 2373260 */     GIR_EraseRootFromParent_Done,
     /* 2373261 */   // Label 33456: @2373261
     /* 2373261 */   GIM_Try, /*On fail goto*//*Label 33457*/ GIMT_Encode4(2373306), // Rule ID 50701 //
     /* 2373266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373269 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2373272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2373286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373305 */     // GIR_Coverage, 50701,
     /* 2373305 */     GIR_EraseRootFromParent_Done,
     /* 2373306 */   // Label 33457: @2373306
     /* 2373306 */   GIM_Reject,
     /* 2373307 */ // Label 33455: @2373307
     /* 2373307 */ GIM_Reject,
     /* 2373308 */ // Label 33417: @2373308
     /* 2373308 */ GIM_Try, /*On fail goto*//*Label 33458*/ GIMT_Encode4(2373422),
     /* 2373313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2373316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2373319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373327 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373331 */   GIM_Try, /*On fail goto*//*Label 33459*/ GIMT_Encode4(2373376), // Rule ID 50716 //
     /* 2373336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373339 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2373342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2373356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373375 */     // GIR_Coverage, 50716,
     /* 2373375 */     GIR_EraseRootFromParent_Done,
     /* 2373376 */   // Label 33459: @2373376
     /* 2373376 */   GIM_Try, /*On fail goto*//*Label 33460*/ GIMT_Encode4(2373421), // Rule ID 50717 //
     /* 2373381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373384 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2373387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2373401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373420 */     // GIR_Coverage, 50717,
     /* 2373420 */     GIR_EraseRootFromParent_Done,
     /* 2373421 */   // Label 33460: @2373421
     /* 2373421 */   GIM_Reject,
     /* 2373422 */ // Label 33458: @2373422
     /* 2373422 */ GIM_Reject,
     /* 2373423 */ // Label 33418: @2373423
     /* 2373423 */ GIM_Try, /*On fail goto*//*Label 33461*/ GIMT_Encode4(2373537),
     /* 2373428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2373431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2373434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373442 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373446 */   GIM_Try, /*On fail goto*//*Label 33462*/ GIMT_Encode4(2373491), // Rule ID 50760 //
     /* 2373451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2373454 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2373457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2373471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373490 */     // GIR_Coverage, 50760,
     /* 2373490 */     GIR_EraseRootFromParent_Done,
     /* 2373491 */   // Label 33462: @2373491
     /* 2373491 */   GIM_Try, /*On fail goto*//*Label 33463*/ GIMT_Encode4(2373536), // Rule ID 50761 //
     /* 2373496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2373499 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2373502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2373516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373535 */     // GIR_Coverage, 50761,
     /* 2373535 */     GIR_EraseRootFromParent_Done,
     /* 2373536 */   // Label 33463: @2373536
     /* 2373536 */   GIM_Reject,
     /* 2373537 */ // Label 33461: @2373537
     /* 2373537 */ GIM_Reject,
     /* 2373538 */ // Label 33419: @2373538
     /* 2373538 */ GIM_Try, /*On fail goto*//*Label 33464*/ GIMT_Encode4(2373652),
     /* 2373543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2373546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2373549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373561 */   GIM_Try, /*On fail goto*//*Label 33465*/ GIMT_Encode4(2373606), // Rule ID 50692 //
     /* 2373566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373569 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2373572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2373586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373605 */     // GIR_Coverage, 50692,
     /* 2373605 */     GIR_EraseRootFromParent_Done,
     /* 2373606 */   // Label 33465: @2373606
     /* 2373606 */   GIM_Try, /*On fail goto*//*Label 33466*/ GIMT_Encode4(2373651), // Rule ID 50693 //
     /* 2373611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373614 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2373617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2373631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373650 */     // GIR_Coverage, 50693,
     /* 2373650 */     GIR_EraseRootFromParent_Done,
     /* 2373651 */   // Label 33466: @2373651
     /* 2373651 */   GIM_Reject,
     /* 2373652 */ // Label 33464: @2373652
     /* 2373652 */ GIM_Reject,
     /* 2373653 */ // Label 33420: @2373653
     /* 2373653 */ GIM_Try, /*On fail goto*//*Label 33467*/ GIMT_Encode4(2373767),
     /* 2373658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2373661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2373664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373676 */   GIM_Try, /*On fail goto*//*Label 33468*/ GIMT_Encode4(2373721), // Rule ID 50712 //
     /* 2373681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373684 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2373687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2373701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373720 */     // GIR_Coverage, 50712,
     /* 2373720 */     GIR_EraseRootFromParent_Done,
     /* 2373721 */   // Label 33468: @2373721
     /* 2373721 */   GIM_Try, /*On fail goto*//*Label 33469*/ GIMT_Encode4(2373766), // Rule ID 50713 //
     /* 2373726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373729 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2373732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2373746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373765 */     // GIR_Coverage, 50713,
     /* 2373765 */     GIR_EraseRootFromParent_Done,
     /* 2373766 */   // Label 33469: @2373766
     /* 2373766 */   GIM_Reject,
     /* 2373767 */ // Label 33467: @2373767
     /* 2373767 */ GIM_Reject,
     /* 2373768 */ // Label 33421: @2373768
     /* 2373768 */ GIM_Try, /*On fail goto*//*Label 33470*/ GIMT_Encode4(2373882),
     /* 2373773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2373776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2373779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373791 */   GIM_Try, /*On fail goto*//*Label 33471*/ GIMT_Encode4(2373836), // Rule ID 50748 //
     /* 2373796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373799 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2373802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2373816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373835 */     // GIR_Coverage, 50748,
     /* 2373835 */     GIR_EraseRootFromParent_Done,
     /* 2373836 */   // Label 33471: @2373836
     /* 2373836 */   GIM_Try, /*On fail goto*//*Label 33472*/ GIMT_Encode4(2373881), // Rule ID 50749 //
     /* 2373841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373844 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2373847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2373861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373880 */     // GIR_Coverage, 50749,
     /* 2373880 */     GIR_EraseRootFromParent_Done,
     /* 2373881 */   // Label 33472: @2373881
     /* 2373881 */   GIM_Reject,
     /* 2373882 */ // Label 33470: @2373882
     /* 2373882 */ GIM_Reject,
     /* 2373883 */ // Label 33422: @2373883
     /* 2373883 */ GIM_Try, /*On fail goto*//*Label 33473*/ GIMT_Encode4(2373997),
     /* 2373888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2373891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2373894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373906 */   GIM_Try, /*On fail goto*//*Label 33474*/ GIMT_Encode4(2373951), // Rule ID 50764 //
     /* 2373911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2373914 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2373917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2373931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373950 */     // GIR_Coverage, 50764,
     /* 2373950 */     GIR_EraseRootFromParent_Done,
     /* 2373951 */   // Label 33474: @2373951
     /* 2373951 */   GIM_Try, /*On fail goto*//*Label 33475*/ GIMT_Encode4(2373996), // Rule ID 50765 //
     /* 2373956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2373959 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2373962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2373976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373995 */     // GIR_Coverage, 50765,
     /* 2373995 */     GIR_EraseRootFromParent_Done,
     /* 2373996 */   // Label 33475: @2373996
     /* 2373996 */   GIM_Reject,
     /* 2373997 */ // Label 33473: @2373997
     /* 2373997 */ GIM_Reject,
     /* 2373998 */ // Label 33423: @2373998
     /* 2373998 */ GIM_Try, /*On fail goto*//*Label 33476*/ GIMT_Encode4(2374112),
     /* 2374003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2374006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2374009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374021 */   GIM_Try, /*On fail goto*//*Label 33477*/ GIMT_Encode4(2374066), // Rule ID 50708 //
     /* 2374026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374029 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2374032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2374046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374065 */     // GIR_Coverage, 50708,
     /* 2374065 */     GIR_EraseRootFromParent_Done,
     /* 2374066 */   // Label 33477: @2374066
     /* 2374066 */   GIM_Try, /*On fail goto*//*Label 33478*/ GIMT_Encode4(2374111), // Rule ID 50709 //
     /* 2374071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374074 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2374077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2374091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374110 */     // GIR_Coverage, 50709,
     /* 2374110 */     GIR_EraseRootFromParent_Done,
     /* 2374111 */   // Label 33478: @2374111
     /* 2374111 */   GIM_Reject,
     /* 2374112 */ // Label 33476: @2374112
     /* 2374112 */ GIM_Reject,
     /* 2374113 */ // Label 33424: @2374113
     /* 2374113 */ GIM_Try, /*On fail goto*//*Label 33479*/ GIMT_Encode4(2374227),
     /* 2374118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2374121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2374124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374136 */   GIM_Try, /*On fail goto*//*Label 33480*/ GIMT_Encode4(2374181), // Rule ID 50736 //
     /* 2374141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374144 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2374147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2374161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374180 */     // GIR_Coverage, 50736,
     /* 2374180 */     GIR_EraseRootFromParent_Done,
     /* 2374181 */   // Label 33480: @2374181
     /* 2374181 */   GIM_Try, /*On fail goto*//*Label 33481*/ GIMT_Encode4(2374226), // Rule ID 50737 //
     /* 2374186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374189 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2374192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2374206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374225 */     // GIR_Coverage, 50737,
     /* 2374225 */     GIR_EraseRootFromParent_Done,
     /* 2374226 */   // Label 33481: @2374226
     /* 2374226 */   GIM_Reject,
     /* 2374227 */ // Label 33479: @2374227
     /* 2374227 */ GIM_Reject,
     /* 2374228 */ // Label 33425: @2374228
     /* 2374228 */ GIM_Try, /*On fail goto*//*Label 33482*/ GIMT_Encode4(2374342),
     /* 2374233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2374236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2374239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374251 */   GIM_Try, /*On fail goto*//*Label 33483*/ GIMT_Encode4(2374296), // Rule ID 50752 //
     /* 2374256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374259 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2374262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2374276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374295 */     // GIR_Coverage, 50752,
     /* 2374295 */     GIR_EraseRootFromParent_Done,
     /* 2374296 */   // Label 33483: @2374296
     /* 2374296 */   GIM_Try, /*On fail goto*//*Label 33484*/ GIMT_Encode4(2374341), // Rule ID 50753 //
     /* 2374301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374304 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2374307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2374321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374340 */     // GIR_Coverage, 50753,
     /* 2374340 */     GIR_EraseRootFromParent_Done,
     /* 2374341 */   // Label 33484: @2374341
     /* 2374341 */   GIM_Reject,
     /* 2374342 */ // Label 33482: @2374342
     /* 2374342 */ GIM_Reject,
     /* 2374343 */ // Label 33426: @2374343
     /* 2374343 */ GIM_Try, /*On fail goto*//*Label 33485*/ GIMT_Encode4(2374457),
     /* 2374348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2374351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2374354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374366 */   GIM_Try, /*On fail goto*//*Label 33486*/ GIMT_Encode4(2374411), // Rule ID 50768 //
     /* 2374371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2374374 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2374377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2374391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374410 */     // GIR_Coverage, 50768,
     /* 2374410 */     GIR_EraseRootFromParent_Done,
     /* 2374411 */   // Label 33486: @2374411
     /* 2374411 */   GIM_Try, /*On fail goto*//*Label 33487*/ GIMT_Encode4(2374456), // Rule ID 50769 //
     /* 2374416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2374419 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2374422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2374436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374455 */     // GIR_Coverage, 50769,
     /* 2374455 */     GIR_EraseRootFromParent_Done,
     /* 2374456 */   // Label 33487: @2374456
     /* 2374456 */   GIM_Reject,
     /* 2374457 */ // Label 33485: @2374457
     /* 2374457 */ GIM_Reject,
     /* 2374458 */ // Label 33427: @2374458
     /* 2374458 */ GIM_Try, /*On fail goto*//*Label 33488*/ GIMT_Encode4(2374572),
     /* 2374463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2374466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2374469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374481 */   GIM_Try, /*On fail goto*//*Label 33489*/ GIMT_Encode4(2374526), // Rule ID 50724 //
     /* 2374486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374489 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2374492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2374506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374525 */     // GIR_Coverage, 50724,
     /* 2374525 */     GIR_EraseRootFromParent_Done,
     /* 2374526 */   // Label 33489: @2374526
     /* 2374526 */   GIM_Try, /*On fail goto*//*Label 33490*/ GIMT_Encode4(2374571), // Rule ID 50725 //
     /* 2374531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374534 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2374537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2374551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374570 */     // GIR_Coverage, 50725,
     /* 2374570 */     GIR_EraseRootFromParent_Done,
     /* 2374571 */   // Label 33490: @2374571
     /* 2374571 */   GIM_Reject,
     /* 2374572 */ // Label 33488: @2374572
     /* 2374572 */ GIM_Reject,
     /* 2374573 */ // Label 33428: @2374573
     /* 2374573 */ GIM_Try, /*On fail goto*//*Label 33491*/ GIMT_Encode4(2374687),
     /* 2374578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2374581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2374584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374596 */   GIM_Try, /*On fail goto*//*Label 33492*/ GIMT_Encode4(2374641), // Rule ID 50740 //
     /* 2374601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374604 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2374607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2374621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374640 */     // GIR_Coverage, 50740,
     /* 2374640 */     GIR_EraseRootFromParent_Done,
     /* 2374641 */   // Label 33492: @2374641
     /* 2374641 */   GIM_Try, /*On fail goto*//*Label 33493*/ GIMT_Encode4(2374686), // Rule ID 50741 //
     /* 2374646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374649 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2374652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2374666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374685 */     // GIR_Coverage, 50741,
     /* 2374685 */     GIR_EraseRootFromParent_Done,
     /* 2374686 */   // Label 33493: @2374686
     /* 2374686 */   GIM_Reject,
     /* 2374687 */ // Label 33491: @2374687
     /* 2374687 */ GIM_Reject,
     /* 2374688 */ // Label 33429: @2374688
     /* 2374688 */ GIM_Try, /*On fail goto*//*Label 33494*/ GIMT_Encode4(2374802),
     /* 2374693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2374696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2374699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374711 */   GIM_Try, /*On fail goto*//*Label 33495*/ GIMT_Encode4(2374756), // Rule ID 50756 //
     /* 2374716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374719 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2374722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2374736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374755 */     // GIR_Coverage, 50756,
     /* 2374755 */     GIR_EraseRootFromParent_Done,
     /* 2374756 */   // Label 33495: @2374756
     /* 2374756 */   GIM_Try, /*On fail goto*//*Label 33496*/ GIMT_Encode4(2374801), // Rule ID 50757 //
     /* 2374761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374764 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2374767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2374781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374800 */     // GIR_Coverage, 50757,
     /* 2374800 */     GIR_EraseRootFromParent_Done,
     /* 2374801 */   // Label 33496: @2374801
     /* 2374801 */   GIM_Reject,
     /* 2374802 */ // Label 33494: @2374802
     /* 2374802 */ GIM_Reject,
     /* 2374803 */ // Label 33430: @2374803
     /* 2374803 */ GIM_Try, /*On fail goto*//*Label 33497*/ GIMT_Encode4(2374917),
     /* 2374808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2374811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2374814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374826 */   GIM_Try, /*On fail goto*//*Label 33498*/ GIMT_Encode4(2374871), // Rule ID 50728 //
     /* 2374831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374834 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2374837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2374851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374870 */     // GIR_Coverage, 50728,
     /* 2374870 */     GIR_EraseRootFromParent_Done,
     /* 2374871 */   // Label 33498: @2374871
     /* 2374871 */   GIM_Try, /*On fail goto*//*Label 33499*/ GIMT_Encode4(2374916), // Rule ID 50729 //
     /* 2374876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374879 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2374882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2374896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374915 */     // GIR_Coverage, 50729,
     /* 2374915 */     GIR_EraseRootFromParent_Done,
     /* 2374916 */   // Label 33499: @2374916
     /* 2374916 */   GIM_Reject,
     /* 2374917 */ // Label 33497: @2374917
     /* 2374917 */ GIM_Reject,
     /* 2374918 */ // Label 33431: @2374918
     /* 2374918 */ GIM_Try, /*On fail goto*//*Label 33500*/ GIMT_Encode4(2375032),
     /* 2374923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2374926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2374929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374941 */   GIM_Try, /*On fail goto*//*Label 33501*/ GIMT_Encode4(2374986), // Rule ID 50744 //
     /* 2374946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374949 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2374952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2374966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374985 */     // GIR_Coverage, 50744,
     /* 2374985 */     GIR_EraseRootFromParent_Done,
     /* 2374986 */   // Label 33501: @2374986
     /* 2374986 */   GIM_Try, /*On fail goto*//*Label 33502*/ GIMT_Encode4(2375031), // Rule ID 50745 //
     /* 2374991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374994 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2374997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2375011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375030 */     // GIR_Coverage, 50745,
     /* 2375030 */     GIR_EraseRootFromParent_Done,
     /* 2375031 */   // Label 33502: @2375031
     /* 2375031 */   GIM_Reject,
     /* 2375032 */ // Label 33500: @2375032
     /* 2375032 */ GIM_Reject,
     /* 2375033 */ // Label 33432: @2375033
     /* 2375033 */ GIM_Try, /*On fail goto*//*Label 33503*/ GIMT_Encode4(2375147),
     /* 2375038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2375041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2375044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375056 */   GIM_Try, /*On fail goto*//*Label 33504*/ GIMT_Encode4(2375101), // Rule ID 50732 //
     /* 2375061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375064 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2375067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2375081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375100 */     // GIR_Coverage, 50732,
     /* 2375100 */     GIR_EraseRootFromParent_Done,
     /* 2375101 */   // Label 33504: @2375101
     /* 2375101 */   GIM_Try, /*On fail goto*//*Label 33505*/ GIMT_Encode4(2375146), // Rule ID 50733 //
     /* 2375106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375109 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2375112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2375126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375145 */     // GIR_Coverage, 50733,
     /* 2375145 */     GIR_EraseRootFromParent_Done,
     /* 2375146 */   // Label 33505: @2375146
     /* 2375146 */   GIM_Reject,
     /* 2375147 */ // Label 33503: @2375147
     /* 2375147 */ GIM_Reject,
     /* 2375148 */ // Label 33433: @2375148
     /* 2375148 */ GIM_Reject,
     /* 2375149 */ // Label 84: @2375149
     /* 2375149 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33508*/ GIMT_Encode4(2375306),
     /* 2375160 */ /*GILLT_s32*//*Label 33506*/ GIMT_Encode4(2375168),
     /* 2375164 */ /*GILLT_s64*//*Label 33507*/ GIMT_Encode4(2375237),
     /* 2375168 */ // Label 33506: @2375168
     /* 2375168 */ GIM_Try, /*On fail goto*//*Label 33509*/ GIMT_Encode4(2375236),
     /* 2375173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375184 */   GIM_Try, /*On fail goto*//*Label 33510*/ GIMT_Encode4(2375199), // Rule ID 64460 //
     /* 2375189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2375192 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_ABS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2375192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2375197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375198 */     // GIR_Coverage, 64460,
     /* 2375198 */     GIR_Done,
     /* 2375199 */   // Label 33510: @2375199
     /* 2375199 */   GIM_Try, /*On fail goto*//*Label 33511*/ GIMT_Encode4(2375235), // Rule ID 62515 //
     /* 2375204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode1),
     /* 2375207 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (PseudoCCSUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, 2:{ *:[i32] }, GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2375207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2375210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2375212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2375220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2375223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2375231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375234 */     // GIR_Coverage, 62515,
     /* 2375234 */     GIR_EraseRootFromParent_Done,
     /* 2375235 */   // Label 33511: @2375235
     /* 2375235 */   GIM_Reject,
     /* 2375236 */ // Label 33509: @2375236
     /* 2375236 */ GIM_Reject,
     /* 2375237 */ // Label 33507: @2375237
     /* 2375237 */ GIM_Try, /*On fail goto*//*Label 33512*/ GIMT_Encode4(2375305),
     /* 2375242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375253 */   GIM_Try, /*On fail goto*//*Label 33513*/ GIMT_Encode4(2375268), // Rule ID 64459 //
     /* 2375258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2375261 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_ABS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2375261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2375266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375267 */     // GIR_Coverage, 64459,
     /* 2375267 */     GIR_Done,
     /* 2375268 */   // Label 33513: @2375268
     /* 2375268 */   GIM_Try, /*On fail goto*//*Label 33514*/ GIMT_Encode4(2375304), // Rule ID 62514 //
     /* 2375273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode0),
     /* 2375276 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (PseudoCCSUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, 2:{ *:[i64] }, GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2375276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2375279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2375281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2375289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2375292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2375300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375303 */     // GIR_Coverage, 62514,
     /* 2375303 */     GIR_EraseRootFromParent_Done,
     /* 2375304 */   // Label 33514: @2375304
     /* 2375304 */   GIM_Reject,
     /* 2375305 */ // Label 33512: @2375305
     /* 2375305 */ GIM_Reject,
     /* 2375306 */ // Label 33508: @2375306
     /* 2375306 */ GIM_Reject,
     /* 2375307 */ // Label 85: @2375307
     /* 2375307 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33517*/ GIMT_Encode4(2375886),
     /* 2375318 */ /*GILLT_s32*//*Label 33515*/ GIMT_Encode4(2375326),
     /* 2375322 */ /*GILLT_s64*//*Label 33516*/ GIMT_Encode4(2375699),
     /* 2375326 */ // Label 33515: @2375326
     /* 2375326 */ GIM_Try, /*On fail goto*//*Label 33518*/ GIMT_Encode4(2375357), // Rule ID 1470 //
     /* 2375331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2375334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2375345 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2375345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2375348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375350 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375355 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375356 */   // GIR_Coverage, 1470,
     /* 2375356 */   GIR_EraseRootFromParent_Done,
     /* 2375357 */ // Label 33518: @2375357
     /* 2375357 */ GIM_Try, /*On fail goto*//*Label 33519*/ GIMT_Encode4(2375388), // Rule ID 1471 //
     /* 2375362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2375365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2375376 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2375376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2375379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375381 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375386 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375387 */   // GIR_Coverage, 1471,
     /* 2375387 */   GIR_EraseRootFromParent_Done,
     /* 2375388 */ // Label 33519: @2375388
     /* 2375388 */ GIM_Try, /*On fail goto*//*Label 33520*/ GIMT_Encode4(2375419), // Rule ID 1496 //
     /* 2375393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2375396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2375407 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2375407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2375410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375412 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375417 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375418 */   // GIR_Coverage, 1496,
     /* 2375418 */   GIR_EraseRootFromParent_Done,
     /* 2375419 */ // Label 33520: @2375419
     /* 2375419 */ GIM_Try, /*On fail goto*//*Label 33521*/ GIMT_Encode4(2375450), // Rule ID 1497 //
     /* 2375424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2375427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2375438 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2375438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2375441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375443 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375448 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375449 */   // GIR_Coverage, 1497,
     /* 2375449 */   GIR_EraseRootFromParent_Done,
     /* 2375450 */ // Label 33521: @2375450
     /* 2375450 */ GIM_Try, /*On fail goto*//*Label 33522*/ GIMT_Encode4(2375481), // Rule ID 1864 //
     /* 2375455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2375458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2375469 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2375469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2375472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375474 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375479 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375480 */   // GIR_Coverage, 1864,
     /* 2375480 */   GIR_EraseRootFromParent_Done,
     /* 2375481 */ // Label 33522: @2375481
     /* 2375481 */ GIM_Try, /*On fail goto*//*Label 33523*/ GIMT_Encode4(2375512), // Rule ID 1865 //
     /* 2375486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2375489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2375500 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2375500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2375503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375505 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375510 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375511 */   // GIR_Coverage, 1865,
     /* 2375511 */   GIR_EraseRootFromParent_Done,
     /* 2375512 */ // Label 33523: @2375512
     /* 2375512 */ GIM_Try, /*On fail goto*//*Label 33524*/ GIMT_Encode4(2375543), // Rule ID 1890 //
     /* 2375517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2375520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2375531 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2375531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2375534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375536 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375541 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375542 */   // GIR_Coverage, 1890,
     /* 2375542 */   GIR_EraseRootFromParent_Done,
     /* 2375543 */ // Label 33524: @2375543
     /* 2375543 */ GIM_Try, /*On fail goto*//*Label 33525*/ GIMT_Encode4(2375574), // Rule ID 1891 //
     /* 2375548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2375551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2375562 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2375562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2375565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375567 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375572 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375573 */   // GIR_Coverage, 1891,
     /* 2375573 */   GIR_EraseRootFromParent_Done,
     /* 2375574 */ // Label 33525: @2375574
     /* 2375574 */ GIM_Try, /*On fail goto*//*Label 33526*/ GIMT_Encode4(2375605), // Rule ID 2206 //
     /* 2375579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2375582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375593 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2375593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2375596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375598 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375603 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375604 */   // GIR_Coverage, 2206,
     /* 2375604 */   GIR_EraseRootFromParent_Done,
     /* 2375605 */ // Label 33526: @2375605
     /* 2375605 */ GIM_Try, /*On fail goto*//*Label 33527*/ GIMT_Encode4(2375636), // Rule ID 2207 //
     /* 2375610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2375613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375624 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2375624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2375627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375629 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375634 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375635 */   // GIR_Coverage, 2207,
     /* 2375635 */   GIR_EraseRootFromParent_Done,
     /* 2375636 */ // Label 33527: @2375636
     /* 2375636 */ GIM_Try, /*On fail goto*//*Label 33528*/ GIMT_Encode4(2375667), // Rule ID 2232 //
     /* 2375641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2375644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2375655 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2375655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2375658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375660 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375665 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375666 */   // GIR_Coverage, 2232,
     /* 2375666 */   GIR_EraseRootFromParent_Done,
     /* 2375667 */ // Label 33528: @2375667
     /* 2375667 */ GIM_Try, /*On fail goto*//*Label 33529*/ GIMT_Encode4(2375698), // Rule ID 2233 //
     /* 2375672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2375675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2375686 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2375686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2375689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375691 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375696 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375697 */   // GIR_Coverage, 2233,
     /* 2375697 */   GIR_EraseRootFromParent_Done,
     /* 2375698 */ // Label 33529: @2375698
     /* 2375698 */ GIM_Reject,
     /* 2375699 */ // Label 33516: @2375699
     /* 2375699 */ GIM_Try, /*On fail goto*//*Label 33530*/ GIMT_Encode4(2375730), // Rule ID 1523 //
     /* 2375704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2375707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2375718 */   // (lround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2375718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2375721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375723 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375728 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375729 */   // GIR_Coverage, 1523,
     /* 2375729 */   GIR_EraseRootFromParent_Done,
     /* 2375730 */ // Label 33530: @2375730
     /* 2375730 */ GIM_Try, /*On fail goto*//*Label 33531*/ GIMT_Encode4(2375761), // Rule ID 1551 //
     /* 2375735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2375738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2375749 */   // (lround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2375749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2375752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375754 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375759 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375760 */   // GIR_Coverage, 1551,
     /* 2375760 */   GIR_EraseRootFromParent_Done,
     /* 2375761 */ // Label 33531: @2375761
     /* 2375761 */ GIM_Try, /*On fail goto*//*Label 33532*/ GIMT_Encode4(2375792), // Rule ID 1921 //
     /* 2375766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2375769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2375780 */   // (lround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2375780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2375783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375785 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375791 */   // GIR_Coverage, 1921,
     /* 2375791 */   GIR_EraseRootFromParent_Done,
     /* 2375792 */ // Label 33532: @2375792
     /* 2375792 */ GIM_Try, /*On fail goto*//*Label 33533*/ GIMT_Encode4(2375823), // Rule ID 1949 //
     /* 2375797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2375800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375811 */   // (lround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2375811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2375814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375816 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375821 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375822 */   // GIR_Coverage, 1949,
     /* 2375822 */   GIR_EraseRootFromParent_Done,
     /* 2375823 */ // Label 33533: @2375823
     /* 2375823 */ GIM_Try, /*On fail goto*//*Label 33534*/ GIMT_Encode4(2375854), // Rule ID 2257 //
     /* 2375828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2375831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375842 */   // (lround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2375842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2375845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375847 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375852 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375853 */   // GIR_Coverage, 2257,
     /* 2375853 */   GIR_EraseRootFromParent_Done,
     /* 2375854 */ // Label 33534: @2375854
     /* 2375854 */ GIM_Try, /*On fail goto*//*Label 33535*/ GIMT_Encode4(2375885), // Rule ID 2283 //
     /* 2375859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2375862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2375873 */   // (lround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2375873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2375876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375878 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375883 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375884 */   // GIR_Coverage, 2283,
     /* 2375884 */   GIR_EraseRootFromParent_Done,
     /* 2375885 */ // Label 33535: @2375885
     /* 2375885 */ GIM_Reject,
     /* 2375886 */ // Label 33517: @2375886
     /* 2375886 */ GIM_Reject,
     /* 2375887 */ // Label 86: @2375887
     /* 2375887 */ GIM_Try, /*On fail goto*//*Label 33536*/ GIMT_Encode4(2376096),
     /* 2375892 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2375895 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33540*/ GIMT_Encode4(2376095),
     /* 2375906 */   /*GILLT_s16*//*Label 33537*/ GIMT_Encode4(2375918),
     /* 2375910 */   /*GILLT_s32*//*Label 33538*/ GIMT_Encode4(2375977),
     /* 2375914 */   /*GILLT_s64*//*Label 33539*/ GIMT_Encode4(2376036),
     /* 2375918 */   // Label 33537: @2375918
     /* 2375918 */   GIM_Try, /*On fail goto*//*Label 33541*/ GIMT_Encode4(2375976),
     /* 2375923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375927 */     GIM_Try, /*On fail goto*//*Label 33542*/ GIMT_Encode4(2375951), // Rule ID 2259 //
     /* 2375932 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2375935 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375939 */       // (llround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2375939 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2375942 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375944 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375946 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375949 */       GIR_RootConstrainSelectedInstOperands,
     /* 2375950 */       // GIR_Coverage, 2259,
     /* 2375950 */       GIR_EraseRootFromParent_Done,
     /* 2375951 */     // Label 33542: @2375951
     /* 2375951 */     GIM_Try, /*On fail goto*//*Label 33543*/ GIMT_Encode4(2375975), // Rule ID 2285 //
     /* 2375956 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2375959 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2375963 */       // (llround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2375963 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2375966 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375968 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375970 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375973 */       GIR_RootConstrainSelectedInstOperands,
     /* 2375974 */       // GIR_Coverage, 2285,
     /* 2375974 */       GIR_EraseRootFromParent_Done,
     /* 2375975 */     // Label 33543: @2375975
     /* 2375975 */     GIM_Reject,
     /* 2375976 */   // Label 33541: @2375976
     /* 2375976 */   GIM_Reject,
     /* 2375977 */   // Label 33538: @2375977
     /* 2375977 */   GIM_Try, /*On fail goto*//*Label 33544*/ GIMT_Encode4(2376035),
     /* 2375982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375986 */     GIM_Try, /*On fail goto*//*Label 33545*/ GIMT_Encode4(2376010), // Rule ID 1525 //
     /* 2375991 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2375994 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2375998 */       // (llround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2375998 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2376001 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376003 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376005 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376008 */       GIR_RootConstrainSelectedInstOperands,
     /* 2376009 */       // GIR_Coverage, 1525,
     /* 2376009 */       GIR_EraseRootFromParent_Done,
     /* 2376010 */     // Label 33545: @2376010
     /* 2376010 */     GIM_Try, /*On fail goto*//*Label 33546*/ GIMT_Encode4(2376034), // Rule ID 1553 //
     /* 2376015 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2376018 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2376022 */       // (llround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2376022 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2376025 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376027 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376029 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376032 */       GIR_RootConstrainSelectedInstOperands,
     /* 2376033 */       // GIR_Coverage, 1553,
     /* 2376033 */       GIR_EraseRootFromParent_Done,
     /* 2376034 */     // Label 33546: @2376034
     /* 2376034 */     GIM_Reject,
     /* 2376035 */   // Label 33544: @2376035
     /* 2376035 */   GIM_Reject,
     /* 2376036 */   // Label 33539: @2376036
     /* 2376036 */   GIM_Try, /*On fail goto*//*Label 33547*/ GIMT_Encode4(2376094),
     /* 2376041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2376045 */     GIM_Try, /*On fail goto*//*Label 33548*/ GIMT_Encode4(2376069), // Rule ID 1923 //
     /* 2376050 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2376053 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2376057 */       // (llround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2376057 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2376060 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376062 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376064 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376067 */       GIR_RootConstrainSelectedInstOperands,
     /* 2376068 */       // GIR_Coverage, 1923,
     /* 2376068 */       GIR_EraseRootFromParent_Done,
     /* 2376069 */     // Label 33548: @2376069
     /* 2376069 */     GIM_Try, /*On fail goto*//*Label 33549*/ GIMT_Encode4(2376093), // Rule ID 1951 //
     /* 2376074 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2376077 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2376081 */       // (llround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2376081 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2376084 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376086 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376088 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376091 */       GIR_RootConstrainSelectedInstOperands,
     /* 2376092 */       // GIR_Coverage, 1951,
     /* 2376092 */       GIR_EraseRootFromParent_Done,
     /* 2376093 */     // Label 33549: @2376093
     /* 2376093 */     GIM_Reject,
     /* 2376094 */   // Label 33547: @2376094
     /* 2376094 */   GIM_Reject,
     /* 2376095 */   // Label 33540: @2376095
     /* 2376095 */   GIM_Reject,
     /* 2376096 */ // Label 33536: @2376096
     /* 2376096 */ GIM_Reject,
     /* 2376097 */ // Label 87: @2376097
     /* 2376097 */ GIM_Try, /*On fail goto*//*Label 33550*/ GIMT_Encode4(2376112), // Rule ID 4 //
     /* 2376102 */   // MIs[0] imm20
     /* 2376102 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 2376105 */   // (br (bb:{ *:[Other] }):$imm20)  =>  (PseudoBR (bb:{ *:[Other] }):$imm20)
     /* 2376105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoBR),
     /* 2376110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2376111 */   // GIR_Coverage, 4,
     /* 2376111 */   GIR_Done,
     /* 2376112 */ // Label 33550: @2376112
     /* 2376112 */ GIM_Reject,
     /* 2376113 */ // Label 88: @2376113
     /* 2376113 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33575*/ GIMT_Encode4(2378740),
     /* 2376124 */ /*GILLT_s32*//*Label 33551*/ GIMT_Encode4(2376248),
     /* 2376128 */ /*GILLT_s64*//*Label 33552*/ GIMT_Encode4(2376404), GIMT_Encode4(0),
     /* 2376136 */ /*GILLT_nxv1s8*//*Label 33553*/ GIMT_Encode4(2376452),
     /* 2376140 */ /*GILLT_nxv1s16*//*Label 33554*/ GIMT_Encode4(2376556),
     /* 2376144 */ /*GILLT_nxv1s32*//*Label 33555*/ GIMT_Encode4(2376660),
     /* 2376148 */ /*GILLT_nxv1s64*//*Label 33556*/ GIMT_Encode4(2376764), GIMT_Encode4(0),
     /* 2376156 */ /*GILLT_nxv2s8*//*Label 33557*/ GIMT_Encode4(2376868),
     /* 2376160 */ /*GILLT_nxv2s16*//*Label 33558*/ GIMT_Encode4(2376972),
     /* 2376164 */ /*GILLT_nxv2s32*//*Label 33559*/ GIMT_Encode4(2377076),
     /* 2376168 */ /*GILLT_nxv2s64*//*Label 33560*/ GIMT_Encode4(2377180), GIMT_Encode4(0),
     /* 2376176 */ /*GILLT_nxv4s8*//*Label 33561*/ GIMT_Encode4(2377284),
     /* 2376180 */ /*GILLT_nxv4s16*//*Label 33562*/ GIMT_Encode4(2377388),
     /* 2376184 */ /*GILLT_nxv4s32*//*Label 33563*/ GIMT_Encode4(2377492),
     /* 2376188 */ /*GILLT_nxv4s64*//*Label 33564*/ GIMT_Encode4(2377596), GIMT_Encode4(0),
     /* 2376196 */ /*GILLT_nxv8s8*//*Label 33565*/ GIMT_Encode4(2377700),
     /* 2376200 */ /*GILLT_nxv8s16*//*Label 33566*/ GIMT_Encode4(2377804),
     /* 2376204 */ /*GILLT_nxv8s32*//*Label 33567*/ GIMT_Encode4(2377908),
     /* 2376208 */ /*GILLT_nxv8s64*//*Label 33568*/ GIMT_Encode4(2378012), GIMT_Encode4(0),
     /* 2376216 */ /*GILLT_nxv16s8*//*Label 33569*/ GIMT_Encode4(2378116),
     /* 2376220 */ /*GILLT_nxv16s16*//*Label 33570*/ GIMT_Encode4(2378220),
     /* 2376224 */ /*GILLT_nxv16s32*//*Label 33571*/ GIMT_Encode4(2378324), GIMT_Encode4(0),
     /* 2376232 */ /*GILLT_nxv32s8*//*Label 33572*/ GIMT_Encode4(2378428),
     /* 2376236 */ /*GILLT_nxv32s16*//*Label 33573*/ GIMT_Encode4(2378532), GIMT_Encode4(0),
     /* 2376244 */ /*GILLT_nxv64s8*//*Label 33574*/ GIMT_Encode4(2378636),
     /* 2376248 */ // Label 33551: @2376248
     /* 2376248 */ GIM_Try, /*On fail goto*//*Label 33576*/ GIMT_Encode4(2376403),
     /* 2376253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2376256 */   GIM_Try, /*On fail goto*//*Label 33577*/ GIMT_Encode4(2376306), // Rule ID 64646 //
     /* 2376261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2376264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2376268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2376272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2376276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2376280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2376284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2376289 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2376293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2376295 */     // (cttz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CTO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2376295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CTO),
     /* 2376298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2376304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376305 */     // GIR_Coverage, 64646,
     /* 2376305 */     GIR_EraseRootFromParent_Done,
     /* 2376306 */   // Label 33577: @2376306
     /* 2376306 */   GIM_Try, /*On fail goto*//*Label 33578*/ GIMT_Encode4(2376356), // Rule ID 64647 //
     /* 2376311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2376314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2376318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2376322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2376326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2376330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2376334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2376339 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2376343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2376345 */     // (cttz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CTO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2376345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CTO),
     /* 2376348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2376354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376355 */     // GIR_Coverage, 64647,
     /* 2376355 */     GIR_EraseRootFromParent_Done,
     /* 2376356 */   // Label 33578: @2376356
     /* 2376356 */   GIM_Try, /*On fail goto*//*Label 33579*/ GIMT_Encode4(2376379), // Rule ID 2519 //
     /* 2376361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2376364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2376368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2376372 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CTZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2376372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2376377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376378 */     // GIR_Coverage, 2519,
     /* 2376378 */     GIR_Done,
     /* 2376379 */   // Label 33579: @2376379
     /* 2376379 */   GIM_Try, /*On fail goto*//*Label 33580*/ GIMT_Encode4(2376402), // Rule ID 64443 //
     /* 2376384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2376387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2376391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2376395 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2376395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2376400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376401 */     // GIR_Coverage, 64443,
     /* 2376401 */     GIR_Done,
     /* 2376402 */   // Label 33580: @2376402
     /* 2376402 */   GIM_Reject,
     /* 2376403 */ // Label 33576: @2376403
     /* 2376403 */ GIM_Reject,
     /* 2376404 */ // Label 33552: @2376404
     /* 2376404 */ GIM_Try, /*On fail goto*//*Label 33581*/ GIMT_Encode4(2376451),
     /* 2376409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2376412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2376416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2376420 */   GIM_Try, /*On fail goto*//*Label 33582*/ GIMT_Encode4(2376435), // Rule ID 2518 //
     /* 2376425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2376428 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2376428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2376433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376434 */     // GIR_Coverage, 2518,
     /* 2376434 */     GIR_Done,
     /* 2376435 */   // Label 33582: @2376435
     /* 2376435 */   GIM_Try, /*On fail goto*//*Label 33583*/ GIMT_Encode4(2376450), // Rule ID 64442 //
     /* 2376440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2376443 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2376443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2376448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376449 */     // GIR_Coverage, 64442,
     /* 2376449 */     GIR_Done,
     /* 2376450 */   // Label 33583: @2376450
     /* 2376450 */   GIM_Reject,
     /* 2376451 */ // Label 33581: @2376451
     /* 2376451 */ GIM_Reject,
     /* 2376452 */ // Label 33553: @2376452
     /* 2376452 */ GIM_Try, /*On fail goto*//*Label 33584*/ GIMT_Encode4(2376555),
     /* 2376457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2376460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376468 */   GIM_Try, /*On fail goto*//*Label 33585*/ GIMT_Encode4(2376511), // Rule ID 59188 //
     /* 2376473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376476 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2376479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2376493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376510 */     // GIR_Coverage, 59188,
     /* 2376510 */     GIR_EraseRootFromParent_Done,
     /* 2376511 */   // Label 33585: @2376511
     /* 2376511 */   GIM_Try, /*On fail goto*//*Label 33586*/ GIMT_Encode4(2376554), // Rule ID 59189 //
     /* 2376516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376519 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2376522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2376536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376553 */     // GIR_Coverage, 59189,
     /* 2376553 */     GIR_EraseRootFromParent_Done,
     /* 2376554 */   // Label 33586: @2376554
     /* 2376554 */   GIM_Reject,
     /* 2376555 */ // Label 33584: @2376555
     /* 2376555 */ GIM_Reject,
     /* 2376556 */ // Label 33554: @2376556
     /* 2376556 */ GIM_Try, /*On fail goto*//*Label 33587*/ GIMT_Encode4(2376659),
     /* 2376561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2376564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376572 */   GIM_Try, /*On fail goto*//*Label 33588*/ GIMT_Encode4(2376615), // Rule ID 59194 //
     /* 2376577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376580 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2376583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2376597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376614 */     // GIR_Coverage, 59194,
     /* 2376614 */     GIR_EraseRootFromParent_Done,
     /* 2376615 */   // Label 33588: @2376615
     /* 2376615 */   GIM_Try, /*On fail goto*//*Label 33589*/ GIMT_Encode4(2376658), // Rule ID 59195 //
     /* 2376620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376623 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2376626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2376640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376657 */     // GIR_Coverage, 59195,
     /* 2376657 */     GIR_EraseRootFromParent_Done,
     /* 2376658 */   // Label 33589: @2376658
     /* 2376658 */   GIM_Reject,
     /* 2376659 */ // Label 33587: @2376659
     /* 2376659 */ GIM_Reject,
     /* 2376660 */ // Label 33555: @2376660
     /* 2376660 */ GIM_Try, /*On fail goto*//*Label 33590*/ GIMT_Encode4(2376763),
     /* 2376665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2376668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376676 */   GIM_Try, /*On fail goto*//*Label 33591*/ GIMT_Encode4(2376719), // Rule ID 59198 //
     /* 2376681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376684 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2376687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2376701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376718 */     // GIR_Coverage, 59198,
     /* 2376718 */     GIR_EraseRootFromParent_Done,
     /* 2376719 */   // Label 33591: @2376719
     /* 2376719 */   GIM_Try, /*On fail goto*//*Label 33592*/ GIMT_Encode4(2376762), // Rule ID 59199 //
     /* 2376724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376727 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2376730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2376744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376761 */     // GIR_Coverage, 59199,
     /* 2376761 */     GIR_EraseRootFromParent_Done,
     /* 2376762 */   // Label 33592: @2376762
     /* 2376762 */   GIM_Reject,
     /* 2376763 */ // Label 33590: @2376763
     /* 2376763 */ GIM_Reject,
     /* 2376764 */ // Label 33556: @2376764
     /* 2376764 */ GIM_Try, /*On fail goto*//*Label 33593*/ GIMT_Encode4(2376867),
     /* 2376769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2376772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376780 */   GIM_Try, /*On fail goto*//*Label 33594*/ GIMT_Encode4(2376823), // Rule ID 59206 //
     /* 2376785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2376788 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2376791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2376805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376822 */     // GIR_Coverage, 59206,
     /* 2376822 */     GIR_EraseRootFromParent_Done,
     /* 2376823 */   // Label 33594: @2376823
     /* 2376823 */   GIM_Try, /*On fail goto*//*Label 33595*/ GIMT_Encode4(2376866), // Rule ID 59207 //
     /* 2376828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2376831 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2376834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2376848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376865 */     // GIR_Coverage, 59207,
     /* 2376865 */     GIR_EraseRootFromParent_Done,
     /* 2376866 */   // Label 33595: @2376866
     /* 2376866 */   GIM_Reject,
     /* 2376867 */ // Label 33593: @2376867
     /* 2376867 */ GIM_Reject,
     /* 2376868 */ // Label 33557: @2376868
     /* 2376868 */ GIM_Try, /*On fail goto*//*Label 33596*/ GIMT_Encode4(2376971),
     /* 2376873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2376876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376884 */   GIM_Try, /*On fail goto*//*Label 33597*/ GIMT_Encode4(2376927), // Rule ID 59190 //
     /* 2376889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376892 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2376895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2376909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376926 */     // GIR_Coverage, 59190,
     /* 2376926 */     GIR_EraseRootFromParent_Done,
     /* 2376927 */   // Label 33597: @2376927
     /* 2376927 */   GIM_Try, /*On fail goto*//*Label 33598*/ GIMT_Encode4(2376970), // Rule ID 59191 //
     /* 2376932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376935 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2376938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2376952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376969 */     // GIR_Coverage, 59191,
     /* 2376969 */     GIR_EraseRootFromParent_Done,
     /* 2376970 */   // Label 33598: @2376970
     /* 2376970 */   GIM_Reject,
     /* 2376971 */ // Label 33596: @2376971
     /* 2376971 */ GIM_Reject,
     /* 2376972 */ // Label 33558: @2376972
     /* 2376972 */ GIM_Try, /*On fail goto*//*Label 33599*/ GIMT_Encode4(2377075),
     /* 2376977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2376980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376988 */   GIM_Try, /*On fail goto*//*Label 33600*/ GIMT_Encode4(2377031), // Rule ID 59196 //
     /* 2376993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376996 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2376999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2377013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377030 */     // GIR_Coverage, 59196,
     /* 2377030 */     GIR_EraseRootFromParent_Done,
     /* 2377031 */   // Label 33600: @2377031
     /* 2377031 */   GIM_Try, /*On fail goto*//*Label 33601*/ GIMT_Encode4(2377074), // Rule ID 59197 //
     /* 2377036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377039 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2377042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2377056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377073 */     // GIR_Coverage, 59197,
     /* 2377073 */     GIR_EraseRootFromParent_Done,
     /* 2377074 */   // Label 33601: @2377074
     /* 2377074 */   GIM_Reject,
     /* 2377075 */ // Label 33599: @2377075
     /* 2377075 */ GIM_Reject,
     /* 2377076 */ // Label 33559: @2377076
     /* 2377076 */ GIM_Try, /*On fail goto*//*Label 33602*/ GIMT_Encode4(2377179),
     /* 2377081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2377084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377092 */   GIM_Try, /*On fail goto*//*Label 33603*/ GIMT_Encode4(2377135), // Rule ID 59204 //
     /* 2377097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377100 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2377103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2377117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377134 */     // GIR_Coverage, 59204,
     /* 2377134 */     GIR_EraseRootFromParent_Done,
     /* 2377135 */   // Label 33603: @2377135
     /* 2377135 */   GIM_Try, /*On fail goto*//*Label 33604*/ GIMT_Encode4(2377178), // Rule ID 59205 //
     /* 2377140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377143 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2377146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2377160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377177 */     // GIR_Coverage, 59205,
     /* 2377177 */     GIR_EraseRootFromParent_Done,
     /* 2377178 */   // Label 33604: @2377178
     /* 2377178 */   GIM_Reject,
     /* 2377179 */ // Label 33602: @2377179
     /* 2377179 */ GIM_Reject,
     /* 2377180 */ // Label 33560: @2377180
     /* 2377180 */ GIM_Try, /*On fail goto*//*Label 33605*/ GIMT_Encode4(2377283),
     /* 2377185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2377188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377196 */   GIM_Try, /*On fail goto*//*Label 33606*/ GIMT_Encode4(2377239), // Rule ID 59226 //
     /* 2377201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2377204 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2377207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2377221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377238 */     // GIR_Coverage, 59226,
     /* 2377238 */     GIR_EraseRootFromParent_Done,
     /* 2377239 */   // Label 33606: @2377239
     /* 2377239 */   GIM_Try, /*On fail goto*//*Label 33607*/ GIMT_Encode4(2377282), // Rule ID 59227 //
     /* 2377244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2377247 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2377250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2377264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377281 */     // GIR_Coverage, 59227,
     /* 2377281 */     GIR_EraseRootFromParent_Done,
     /* 2377282 */   // Label 33607: @2377282
     /* 2377282 */   GIM_Reject,
     /* 2377283 */ // Label 33605: @2377283
     /* 2377283 */ GIM_Reject,
     /* 2377284 */ // Label 33561: @2377284
     /* 2377284 */ GIM_Try, /*On fail goto*//*Label 33608*/ GIMT_Encode4(2377387),
     /* 2377289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2377292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377300 */   GIM_Try, /*On fail goto*//*Label 33609*/ GIMT_Encode4(2377343), // Rule ID 59192 //
     /* 2377305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377308 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2377311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2377325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377342 */     // GIR_Coverage, 59192,
     /* 2377342 */     GIR_EraseRootFromParent_Done,
     /* 2377343 */   // Label 33609: @2377343
     /* 2377343 */   GIM_Try, /*On fail goto*//*Label 33610*/ GIMT_Encode4(2377386), // Rule ID 59193 //
     /* 2377348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377351 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2377354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2377368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377385 */     // GIR_Coverage, 59193,
     /* 2377385 */     GIR_EraseRootFromParent_Done,
     /* 2377386 */   // Label 33610: @2377386
     /* 2377386 */   GIM_Reject,
     /* 2377387 */ // Label 33608: @2377387
     /* 2377387 */ GIM_Reject,
     /* 2377388 */ // Label 33562: @2377388
     /* 2377388 */ GIM_Try, /*On fail goto*//*Label 33611*/ GIMT_Encode4(2377491),
     /* 2377393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2377396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377404 */   GIM_Try, /*On fail goto*//*Label 33612*/ GIMT_Encode4(2377447), // Rule ID 59202 //
     /* 2377409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377412 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2377415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2377429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377446 */     // GIR_Coverage, 59202,
     /* 2377446 */     GIR_EraseRootFromParent_Done,
     /* 2377447 */   // Label 33612: @2377447
     /* 2377447 */   GIM_Try, /*On fail goto*//*Label 33613*/ GIMT_Encode4(2377490), // Rule ID 59203 //
     /* 2377452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377455 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2377458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2377472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377489 */     // GIR_Coverage, 59203,
     /* 2377489 */     GIR_EraseRootFromParent_Done,
     /* 2377490 */   // Label 33613: @2377490
     /* 2377490 */   GIM_Reject,
     /* 2377491 */ // Label 33611: @2377491
     /* 2377491 */ GIM_Reject,
     /* 2377492 */ // Label 33563: @2377492
     /* 2377492 */ GIM_Try, /*On fail goto*//*Label 33614*/ GIMT_Encode4(2377595),
     /* 2377497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2377500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377508 */   GIM_Try, /*On fail goto*//*Label 33615*/ GIMT_Encode4(2377551), // Rule ID 59220 //
     /* 2377513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377516 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2377519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2377533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377550 */     // GIR_Coverage, 59220,
     /* 2377550 */     GIR_EraseRootFromParent_Done,
     /* 2377551 */   // Label 33615: @2377551
     /* 2377551 */   GIM_Try, /*On fail goto*//*Label 33616*/ GIMT_Encode4(2377594), // Rule ID 59221 //
     /* 2377556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377559 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2377562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2377576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377593 */     // GIR_Coverage, 59221,
     /* 2377593 */     GIR_EraseRootFromParent_Done,
     /* 2377594 */   // Label 33616: @2377594
     /* 2377594 */   GIM_Reject,
     /* 2377595 */ // Label 33614: @2377595
     /* 2377595 */ GIM_Reject,
     /* 2377596 */ // Label 33564: @2377596
     /* 2377596 */ GIM_Try, /*On fail goto*//*Label 33617*/ GIMT_Encode4(2377699),
     /* 2377601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2377604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377612 */   GIM_Try, /*On fail goto*//*Label 33618*/ GIMT_Encode4(2377655), // Rule ID 59228 //
     /* 2377617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2377620 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2377623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2377637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377654 */     // GIR_Coverage, 59228,
     /* 2377654 */     GIR_EraseRootFromParent_Done,
     /* 2377655 */   // Label 33618: @2377655
     /* 2377655 */   GIM_Try, /*On fail goto*//*Label 33619*/ GIMT_Encode4(2377698), // Rule ID 59229 //
     /* 2377660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2377663 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2377666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2377680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377697 */     // GIR_Coverage, 59229,
     /* 2377697 */     GIR_EraseRootFromParent_Done,
     /* 2377698 */   // Label 33619: @2377698
     /* 2377698 */   GIM_Reject,
     /* 2377699 */ // Label 33617: @2377699
     /* 2377699 */ GIM_Reject,
     /* 2377700 */ // Label 33565: @2377700
     /* 2377700 */ GIM_Try, /*On fail goto*//*Label 33620*/ GIMT_Encode4(2377803),
     /* 2377705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2377708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377716 */   GIM_Try, /*On fail goto*//*Label 33621*/ GIMT_Encode4(2377759), // Rule ID 59200 //
     /* 2377721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377724 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2377727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2377741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377758 */     // GIR_Coverage, 59200,
     /* 2377758 */     GIR_EraseRootFromParent_Done,
     /* 2377759 */   // Label 33621: @2377759
     /* 2377759 */   GIM_Try, /*On fail goto*//*Label 33622*/ GIMT_Encode4(2377802), // Rule ID 59201 //
     /* 2377764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377767 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2377770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2377784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377801 */     // GIR_Coverage, 59201,
     /* 2377801 */     GIR_EraseRootFromParent_Done,
     /* 2377802 */   // Label 33622: @2377802
     /* 2377802 */   GIM_Reject,
     /* 2377803 */ // Label 33620: @2377803
     /* 2377803 */ GIM_Reject,
     /* 2377804 */ // Label 33566: @2377804
     /* 2377804 */ GIM_Try, /*On fail goto*//*Label 33623*/ GIMT_Encode4(2377907),
     /* 2377809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2377812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377820 */   GIM_Try, /*On fail goto*//*Label 33624*/ GIMT_Encode4(2377863), // Rule ID 59214 //
     /* 2377825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377828 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2377831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2377845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377862 */     // GIR_Coverage, 59214,
     /* 2377862 */     GIR_EraseRootFromParent_Done,
     /* 2377863 */   // Label 33624: @2377863
     /* 2377863 */   GIM_Try, /*On fail goto*//*Label 33625*/ GIMT_Encode4(2377906), // Rule ID 59215 //
     /* 2377868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377871 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2377874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2377888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377905 */     // GIR_Coverage, 59215,
     /* 2377905 */     GIR_EraseRootFromParent_Done,
     /* 2377906 */   // Label 33625: @2377906
     /* 2377906 */   GIM_Reject,
     /* 2377907 */ // Label 33623: @2377907
     /* 2377907 */ GIM_Reject,
     /* 2377908 */ // Label 33567: @2377908
     /* 2377908 */ GIM_Try, /*On fail goto*//*Label 33626*/ GIMT_Encode4(2378011),
     /* 2377913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2377916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377924 */   GIM_Try, /*On fail goto*//*Label 33627*/ GIMT_Encode4(2377967), // Rule ID 59222 //
     /* 2377929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377932 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2377935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2377949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377966 */     // GIR_Coverage, 59222,
     /* 2377966 */     GIR_EraseRootFromParent_Done,
     /* 2377967 */   // Label 33627: @2377967
     /* 2377967 */   GIM_Try, /*On fail goto*//*Label 33628*/ GIMT_Encode4(2378010), // Rule ID 59223 //
     /* 2377972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377975 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2377978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2377992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378009 */     // GIR_Coverage, 59223,
     /* 2378009 */     GIR_EraseRootFromParent_Done,
     /* 2378010 */   // Label 33628: @2378010
     /* 2378010 */   GIM_Reject,
     /* 2378011 */ // Label 33626: @2378011
     /* 2378011 */ GIM_Reject,
     /* 2378012 */ // Label 33568: @2378012
     /* 2378012 */ GIM_Try, /*On fail goto*//*Label 33629*/ GIMT_Encode4(2378115),
     /* 2378017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2378020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378028 */   GIM_Try, /*On fail goto*//*Label 33630*/ GIMT_Encode4(2378071), // Rule ID 59230 //
     /* 2378033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2378036 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2378039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2378053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378070 */     // GIR_Coverage, 59230,
     /* 2378070 */     GIR_EraseRootFromParent_Done,
     /* 2378071 */   // Label 33630: @2378071
     /* 2378071 */   GIM_Try, /*On fail goto*//*Label 33631*/ GIMT_Encode4(2378114), // Rule ID 59231 //
     /* 2378076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2378079 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2378082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2378096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378113 */     // GIR_Coverage, 59231,
     /* 2378113 */     GIR_EraseRootFromParent_Done,
     /* 2378114 */   // Label 33631: @2378114
     /* 2378114 */   GIM_Reject,
     /* 2378115 */ // Label 33629: @2378115
     /* 2378115 */ GIM_Reject,
     /* 2378116 */ // Label 33569: @2378116
     /* 2378116 */ GIM_Try, /*On fail goto*//*Label 33632*/ GIMT_Encode4(2378219),
     /* 2378121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2378124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2378128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2378132 */   GIM_Try, /*On fail goto*//*Label 33633*/ GIMT_Encode4(2378175), // Rule ID 59208 //
     /* 2378137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378140 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2378143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2378157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378174 */     // GIR_Coverage, 59208,
     /* 2378174 */     GIR_EraseRootFromParent_Done,
     /* 2378175 */   // Label 33633: @2378175
     /* 2378175 */   GIM_Try, /*On fail goto*//*Label 33634*/ GIMT_Encode4(2378218), // Rule ID 59209 //
     /* 2378180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378183 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2378186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2378200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378217 */     // GIR_Coverage, 59209,
     /* 2378217 */     GIR_EraseRootFromParent_Done,
     /* 2378218 */   // Label 33634: @2378218
     /* 2378218 */   GIM_Reject,
     /* 2378219 */ // Label 33632: @2378219
     /* 2378219 */ GIM_Reject,
     /* 2378220 */ // Label 33570: @2378220
     /* 2378220 */ GIM_Try, /*On fail goto*//*Label 33635*/ GIMT_Encode4(2378323),
     /* 2378225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2378228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2378232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2378236 */   GIM_Try, /*On fail goto*//*Label 33636*/ GIMT_Encode4(2378279), // Rule ID 59216 //
     /* 2378241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378244 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2378247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2378261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378278 */     // GIR_Coverage, 59216,
     /* 2378278 */     GIR_EraseRootFromParent_Done,
     /* 2378279 */   // Label 33636: @2378279
     /* 2378279 */   GIM_Try, /*On fail goto*//*Label 33637*/ GIMT_Encode4(2378322), // Rule ID 59217 //
     /* 2378284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378287 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2378290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2378304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378321 */     // GIR_Coverage, 59217,
     /* 2378321 */     GIR_EraseRootFromParent_Done,
     /* 2378322 */   // Label 33637: @2378322
     /* 2378322 */   GIM_Reject,
     /* 2378323 */ // Label 33635: @2378323
     /* 2378323 */ GIM_Reject,
     /* 2378324 */ // Label 33571: @2378324
     /* 2378324 */ GIM_Try, /*On fail goto*//*Label 33638*/ GIMT_Encode4(2378427),
     /* 2378329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2378332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378340 */   GIM_Try, /*On fail goto*//*Label 33639*/ GIMT_Encode4(2378383), // Rule ID 59224 //
     /* 2378345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378348 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2378351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2378365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378382 */     // GIR_Coverage, 59224,
     /* 2378382 */     GIR_EraseRootFromParent_Done,
     /* 2378383 */   // Label 33639: @2378383
     /* 2378383 */   GIM_Try, /*On fail goto*//*Label 33640*/ GIMT_Encode4(2378426), // Rule ID 59225 //
     /* 2378388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378391 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2378394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2378408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378425 */     // GIR_Coverage, 59225,
     /* 2378425 */     GIR_EraseRootFromParent_Done,
     /* 2378426 */   // Label 33640: @2378426
     /* 2378426 */   GIM_Reject,
     /* 2378427 */ // Label 33638: @2378427
     /* 2378427 */ GIM_Reject,
     /* 2378428 */ // Label 33572: @2378428
     /* 2378428 */ GIM_Try, /*On fail goto*//*Label 33641*/ GIMT_Encode4(2378531),
     /* 2378433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2378436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2378440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2378444 */   GIM_Try, /*On fail goto*//*Label 33642*/ GIMT_Encode4(2378487), // Rule ID 59210 //
     /* 2378449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378452 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2378455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2378469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378486 */     // GIR_Coverage, 59210,
     /* 2378486 */     GIR_EraseRootFromParent_Done,
     /* 2378487 */   // Label 33642: @2378487
     /* 2378487 */   GIM_Try, /*On fail goto*//*Label 33643*/ GIMT_Encode4(2378530), // Rule ID 59211 //
     /* 2378492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378495 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2378498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2378512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378529 */     // GIR_Coverage, 59211,
     /* 2378529 */     GIR_EraseRootFromParent_Done,
     /* 2378530 */   // Label 33643: @2378530
     /* 2378530 */   GIM_Reject,
     /* 2378531 */ // Label 33641: @2378531
     /* 2378531 */ GIM_Reject,
     /* 2378532 */ // Label 33573: @2378532
     /* 2378532 */ GIM_Try, /*On fail goto*//*Label 33644*/ GIMT_Encode4(2378635),
     /* 2378537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2378540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378548 */   GIM_Try, /*On fail goto*//*Label 33645*/ GIMT_Encode4(2378591), // Rule ID 59218 //
     /* 2378553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378556 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2378559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2378573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378590 */     // GIR_Coverage, 59218,
     /* 2378590 */     GIR_EraseRootFromParent_Done,
     /* 2378591 */   // Label 33645: @2378591
     /* 2378591 */   GIM_Try, /*On fail goto*//*Label 33646*/ GIMT_Encode4(2378634), // Rule ID 59219 //
     /* 2378596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378599 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2378602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2378616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378633 */     // GIR_Coverage, 59219,
     /* 2378633 */     GIR_EraseRootFromParent_Done,
     /* 2378634 */   // Label 33646: @2378634
     /* 2378634 */   GIM_Reject,
     /* 2378635 */ // Label 33644: @2378635
     /* 2378635 */ GIM_Reject,
     /* 2378636 */ // Label 33574: @2378636
     /* 2378636 */ GIM_Try, /*On fail goto*//*Label 33647*/ GIMT_Encode4(2378739),
     /* 2378641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2378644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378652 */   GIM_Try, /*On fail goto*//*Label 33648*/ GIMT_Encode4(2378695), // Rule ID 59212 //
     /* 2378657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378660 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2378663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2378677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378694 */     // GIR_Coverage, 59212,
     /* 2378694 */     GIR_EraseRootFromParent_Done,
     /* 2378695 */   // Label 33648: @2378695
     /* 2378695 */   GIM_Try, /*On fail goto*//*Label 33649*/ GIMT_Encode4(2378738), // Rule ID 59213 //
     /* 2378700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378703 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2378706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2378720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378737 */     // GIR_Coverage, 59213,
     /* 2378737 */     GIR_EraseRootFromParent_Done,
     /* 2378738 */   // Label 33649: @2378738
     /* 2378738 */   GIM_Reject,
     /* 2378739 */ // Label 33647: @2378739
     /* 2378739 */ GIM_Reject,
     /* 2378740 */ // Label 33575: @2378740
     /* 2378740 */ GIM_Reject,
     /* 2378741 */ // Label 89: @2378741
     /* 2378741 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33674*/ GIMT_Encode4(2381510),
     /* 2378752 */ /*GILLT_s32*//*Label 33650*/ GIMT_Encode4(2378876),
     /* 2378756 */ /*GILLT_s64*//*Label 33651*/ GIMT_Encode4(2379105), GIMT_Encode4(0),
     /* 2378764 */ /*GILLT_nxv1s8*//*Label 33652*/ GIMT_Encode4(2379222),
     /* 2378768 */ /*GILLT_nxv1s16*//*Label 33653*/ GIMT_Encode4(2379326),
     /* 2378772 */ /*GILLT_nxv1s32*//*Label 33654*/ GIMT_Encode4(2379430),
     /* 2378776 */ /*GILLT_nxv1s64*//*Label 33655*/ GIMT_Encode4(2379534), GIMT_Encode4(0),
     /* 2378784 */ /*GILLT_nxv2s8*//*Label 33656*/ GIMT_Encode4(2379638),
     /* 2378788 */ /*GILLT_nxv2s16*//*Label 33657*/ GIMT_Encode4(2379742),
     /* 2378792 */ /*GILLT_nxv2s32*//*Label 33658*/ GIMT_Encode4(2379846),
     /* 2378796 */ /*GILLT_nxv2s64*//*Label 33659*/ GIMT_Encode4(2379950), GIMT_Encode4(0),
     /* 2378804 */ /*GILLT_nxv4s8*//*Label 33660*/ GIMT_Encode4(2380054),
     /* 2378808 */ /*GILLT_nxv4s16*//*Label 33661*/ GIMT_Encode4(2380158),
     /* 2378812 */ /*GILLT_nxv4s32*//*Label 33662*/ GIMT_Encode4(2380262),
     /* 2378816 */ /*GILLT_nxv4s64*//*Label 33663*/ GIMT_Encode4(2380366), GIMT_Encode4(0),
     /* 2378824 */ /*GILLT_nxv8s8*//*Label 33664*/ GIMT_Encode4(2380470),
     /* 2378828 */ /*GILLT_nxv8s16*//*Label 33665*/ GIMT_Encode4(2380574),
     /* 2378832 */ /*GILLT_nxv8s32*//*Label 33666*/ GIMT_Encode4(2380678),
     /* 2378836 */ /*GILLT_nxv8s64*//*Label 33667*/ GIMT_Encode4(2380782), GIMT_Encode4(0),
     /* 2378844 */ /*GILLT_nxv16s8*//*Label 33668*/ GIMT_Encode4(2380886),
     /* 2378848 */ /*GILLT_nxv16s16*//*Label 33669*/ GIMT_Encode4(2380990),
     /* 2378852 */ /*GILLT_nxv16s32*//*Label 33670*/ GIMT_Encode4(2381094), GIMT_Encode4(0),
     /* 2378860 */ /*GILLT_nxv32s8*//*Label 33671*/ GIMT_Encode4(2381198),
     /* 2378864 */ /*GILLT_nxv32s16*//*Label 33672*/ GIMT_Encode4(2381302), GIMT_Encode4(0),
     /* 2378872 */ /*GILLT_nxv64s8*//*Label 33673*/ GIMT_Encode4(2381406),
     /* 2378876 */ // Label 33650: @2378876
     /* 2378876 */ GIM_Try, /*On fail goto*//*Label 33675*/ GIMT_Encode4(2379104),
     /* 2378881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2378884 */   GIM_Try, /*On fail goto*//*Label 33676*/ GIMT_Encode4(2378934), // Rule ID 62568 //
     /* 2378889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2378892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2378900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2378904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2378908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2378912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378917 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2378921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2378923 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (TH_FF0:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2378923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2378926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2378932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378933 */     // GIR_Coverage, 62568,
     /* 2378933 */     GIR_EraseRootFromParent_Done,
     /* 2378934 */   // Label 33676: @2378934
     /* 2378934 */   GIM_Try, /*On fail goto*//*Label 33677*/ GIMT_Encode4(2378984), // Rule ID 64648 //
     /* 2378939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2378942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2378946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2378950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2378954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2378958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2378962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378967 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2378971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2378973 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CLO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2378973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CLO),
     /* 2378976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2378982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378983 */     // GIR_Coverage, 64648,
     /* 2378983 */     GIR_EraseRootFromParent_Done,
     /* 2378984 */   // Label 33677: @2378984
     /* 2378984 */   GIM_Try, /*On fail goto*//*Label 33678*/ GIMT_Encode4(2379034), // Rule ID 64649 //
     /* 2378989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2378992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2378996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2379000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2379004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2379008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2379012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379017 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2379021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2379023 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CLO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2379023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CLO),
     /* 2379026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2379032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379033 */     // GIR_Coverage, 64649,
     /* 2379033 */     GIR_EraseRootFromParent_Done,
     /* 2379034 */   // Label 33678: @2379034
     /* 2379034 */   GIM_Try, /*On fail goto*//*Label 33679*/ GIMT_Encode4(2379057), // Rule ID 2517 //
     /* 2379039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2379042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379050 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2379050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2379055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379056 */     // GIR_Coverage, 2517,
     /* 2379056 */     GIR_Done,
     /* 2379057 */   // Label 33679: @2379057
     /* 2379057 */   GIM_Try, /*On fail goto*//*Label 33680*/ GIMT_Encode4(2379080), // Rule ID 62566 //
     /* 2379062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2379065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379073 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2379073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2379078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379079 */     // GIR_Coverage, 62566,
     /* 2379079 */     GIR_Done,
     /* 2379080 */   // Label 33680: @2379080
     /* 2379080 */   GIM_Try, /*On fail goto*//*Label 33681*/ GIMT_Encode4(2379103), // Rule ID 64445 //
     /* 2379085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2379088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379096 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FL1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2379096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2379101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379102 */     // GIR_Coverage, 64445,
     /* 2379102 */     GIR_Done,
     /* 2379103 */   // Label 33681: @2379103
     /* 2379103 */   GIM_Reject,
     /* 2379104 */ // Label 33675: @2379104
     /* 2379104 */ GIM_Reject,
     /* 2379105 */ // Label 33651: @2379105
     /* 2379105 */ GIM_Try, /*On fail goto*//*Label 33682*/ GIMT_Encode4(2379221),
     /* 2379110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2379113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379117 */   GIM_Try, /*On fail goto*//*Label 33683*/ GIMT_Encode4(2379163), // Rule ID 62567 //
     /* 2379122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2379125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2379129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2379133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2379137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2379141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379146 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2379150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2379152 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }))  =>  (TH_FF0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2379152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2379155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2379161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379162 */     // GIR_Coverage, 62567,
     /* 2379162 */     GIR_EraseRootFromParent_Done,
     /* 2379163 */   // Label 33683: @2379163
     /* 2379163 */   GIM_Try, /*On fail goto*//*Label 33684*/ GIMT_Encode4(2379182), // Rule ID 2516 //
     /* 2379168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2379171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379175 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2379175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2379180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379181 */     // GIR_Coverage, 2516,
     /* 2379181 */     GIR_Done,
     /* 2379182 */   // Label 33684: @2379182
     /* 2379182 */   GIM_Try, /*On fail goto*//*Label 33685*/ GIMT_Encode4(2379201), // Rule ID 62565 //
     /* 2379187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2379190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379194 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2379194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2379199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379200 */     // GIR_Coverage, 62565,
     /* 2379200 */     GIR_Done,
     /* 2379201 */   // Label 33685: @2379201
     /* 2379201 */   GIM_Try, /*On fail goto*//*Label 33686*/ GIMT_Encode4(2379220), // Rule ID 64444 //
     /* 2379206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2379209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379213 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FL1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2379213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2379218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379219 */     // GIR_Coverage, 64444,
     /* 2379219 */     GIR_Done,
     /* 2379220 */   // Label 33686: @2379220
     /* 2379220 */   GIM_Reject,
     /* 2379221 */ // Label 33682: @2379221
     /* 2379221 */ GIM_Reject,
     /* 2379222 */ // Label 33652: @2379222
     /* 2379222 */ GIM_Try, /*On fail goto*//*Label 33687*/ GIMT_Encode4(2379325),
     /* 2379227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2379230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379238 */   GIM_Try, /*On fail goto*//*Label 33688*/ GIMT_Encode4(2379281), // Rule ID 59144 //
     /* 2379243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379246 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2379249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2379263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379280 */     // GIR_Coverage, 59144,
     /* 2379280 */     GIR_EraseRootFromParent_Done,
     /* 2379281 */   // Label 33688: @2379281
     /* 2379281 */   GIM_Try, /*On fail goto*//*Label 33689*/ GIMT_Encode4(2379324), // Rule ID 59145 //
     /* 2379286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379289 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2379292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2379306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379323 */     // GIR_Coverage, 59145,
     /* 2379323 */     GIR_EraseRootFromParent_Done,
     /* 2379324 */   // Label 33689: @2379324
     /* 2379324 */   GIM_Reject,
     /* 2379325 */ // Label 33687: @2379325
     /* 2379325 */ GIM_Reject,
     /* 2379326 */ // Label 33653: @2379326
     /* 2379326 */ GIM_Try, /*On fail goto*//*Label 33690*/ GIMT_Encode4(2379429),
     /* 2379331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2379334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379342 */   GIM_Try, /*On fail goto*//*Label 33691*/ GIMT_Encode4(2379385), // Rule ID 59150 //
     /* 2379347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379350 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2379353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2379367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379384 */     // GIR_Coverage, 59150,
     /* 2379384 */     GIR_EraseRootFromParent_Done,
     /* 2379385 */   // Label 33691: @2379385
     /* 2379385 */   GIM_Try, /*On fail goto*//*Label 33692*/ GIMT_Encode4(2379428), // Rule ID 59151 //
     /* 2379390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379393 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2379396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2379410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379427 */     // GIR_Coverage, 59151,
     /* 2379427 */     GIR_EraseRootFromParent_Done,
     /* 2379428 */   // Label 33692: @2379428
     /* 2379428 */   GIM_Reject,
     /* 2379429 */ // Label 33690: @2379429
     /* 2379429 */ GIM_Reject,
     /* 2379430 */ // Label 33654: @2379430
     /* 2379430 */ GIM_Try, /*On fail goto*//*Label 33693*/ GIMT_Encode4(2379533),
     /* 2379435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2379438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379446 */   GIM_Try, /*On fail goto*//*Label 33694*/ GIMT_Encode4(2379489), // Rule ID 59154 //
     /* 2379451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379454 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2379457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2379471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379488 */     // GIR_Coverage, 59154,
     /* 2379488 */     GIR_EraseRootFromParent_Done,
     /* 2379489 */   // Label 33694: @2379489
     /* 2379489 */   GIM_Try, /*On fail goto*//*Label 33695*/ GIMT_Encode4(2379532), // Rule ID 59155 //
     /* 2379494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379497 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2379500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2379514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379531 */     // GIR_Coverage, 59155,
     /* 2379531 */     GIR_EraseRootFromParent_Done,
     /* 2379532 */   // Label 33695: @2379532
     /* 2379532 */   GIM_Reject,
     /* 2379533 */ // Label 33693: @2379533
     /* 2379533 */ GIM_Reject,
     /* 2379534 */ // Label 33655: @2379534
     /* 2379534 */ GIM_Try, /*On fail goto*//*Label 33696*/ GIMT_Encode4(2379637),
     /* 2379539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2379542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379550 */   GIM_Try, /*On fail goto*//*Label 33697*/ GIMT_Encode4(2379593), // Rule ID 59162 //
     /* 2379555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2379558 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2379561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2379575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379592 */     // GIR_Coverage, 59162,
     /* 2379592 */     GIR_EraseRootFromParent_Done,
     /* 2379593 */   // Label 33697: @2379593
     /* 2379593 */   GIM_Try, /*On fail goto*//*Label 33698*/ GIMT_Encode4(2379636), // Rule ID 59163 //
     /* 2379598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2379601 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2379604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2379618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379635 */     // GIR_Coverage, 59163,
     /* 2379635 */     GIR_EraseRootFromParent_Done,
     /* 2379636 */   // Label 33698: @2379636
     /* 2379636 */   GIM_Reject,
     /* 2379637 */ // Label 33696: @2379637
     /* 2379637 */ GIM_Reject,
     /* 2379638 */ // Label 33656: @2379638
     /* 2379638 */ GIM_Try, /*On fail goto*//*Label 33699*/ GIMT_Encode4(2379741),
     /* 2379643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2379646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379654 */   GIM_Try, /*On fail goto*//*Label 33700*/ GIMT_Encode4(2379697), // Rule ID 59146 //
     /* 2379659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379662 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2379665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2379679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379696 */     // GIR_Coverage, 59146,
     /* 2379696 */     GIR_EraseRootFromParent_Done,
     /* 2379697 */   // Label 33700: @2379697
     /* 2379697 */   GIM_Try, /*On fail goto*//*Label 33701*/ GIMT_Encode4(2379740), // Rule ID 59147 //
     /* 2379702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379705 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2379708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2379722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379739 */     // GIR_Coverage, 59147,
     /* 2379739 */     GIR_EraseRootFromParent_Done,
     /* 2379740 */   // Label 33701: @2379740
     /* 2379740 */   GIM_Reject,
     /* 2379741 */ // Label 33699: @2379741
     /* 2379741 */ GIM_Reject,
     /* 2379742 */ // Label 33657: @2379742
     /* 2379742 */ GIM_Try, /*On fail goto*//*Label 33702*/ GIMT_Encode4(2379845),
     /* 2379747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2379750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379758 */   GIM_Try, /*On fail goto*//*Label 33703*/ GIMT_Encode4(2379801), // Rule ID 59152 //
     /* 2379763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379766 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2379769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2379783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379800 */     // GIR_Coverage, 59152,
     /* 2379800 */     GIR_EraseRootFromParent_Done,
     /* 2379801 */   // Label 33703: @2379801
     /* 2379801 */   GIM_Try, /*On fail goto*//*Label 33704*/ GIMT_Encode4(2379844), // Rule ID 59153 //
     /* 2379806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379809 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2379812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2379826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379843 */     // GIR_Coverage, 59153,
     /* 2379843 */     GIR_EraseRootFromParent_Done,
     /* 2379844 */   // Label 33704: @2379844
     /* 2379844 */   GIM_Reject,
     /* 2379845 */ // Label 33702: @2379845
     /* 2379845 */ GIM_Reject,
     /* 2379846 */ // Label 33658: @2379846
     /* 2379846 */ GIM_Try, /*On fail goto*//*Label 33705*/ GIMT_Encode4(2379949),
     /* 2379851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2379854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379862 */   GIM_Try, /*On fail goto*//*Label 33706*/ GIMT_Encode4(2379905), // Rule ID 59160 //
     /* 2379867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379870 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2379873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2379887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379904 */     // GIR_Coverage, 59160,
     /* 2379904 */     GIR_EraseRootFromParent_Done,
     /* 2379905 */   // Label 33706: @2379905
     /* 2379905 */   GIM_Try, /*On fail goto*//*Label 33707*/ GIMT_Encode4(2379948), // Rule ID 59161 //
     /* 2379910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379913 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2379916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2379930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379947 */     // GIR_Coverage, 59161,
     /* 2379947 */     GIR_EraseRootFromParent_Done,
     /* 2379948 */   // Label 33707: @2379948
     /* 2379948 */   GIM_Reject,
     /* 2379949 */ // Label 33705: @2379949
     /* 2379949 */ GIM_Reject,
     /* 2379950 */ // Label 33659: @2379950
     /* 2379950 */ GIM_Try, /*On fail goto*//*Label 33708*/ GIMT_Encode4(2380053),
     /* 2379955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2379958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379966 */   GIM_Try, /*On fail goto*//*Label 33709*/ GIMT_Encode4(2380009), // Rule ID 59182 //
     /* 2379971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2379974 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2379977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2379991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380008 */     // GIR_Coverage, 59182,
     /* 2380008 */     GIR_EraseRootFromParent_Done,
     /* 2380009 */   // Label 33709: @2380009
     /* 2380009 */   GIM_Try, /*On fail goto*//*Label 33710*/ GIMT_Encode4(2380052), // Rule ID 59183 //
     /* 2380014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2380017 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2380020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2380034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380051 */     // GIR_Coverage, 59183,
     /* 2380051 */     GIR_EraseRootFromParent_Done,
     /* 2380052 */   // Label 33710: @2380052
     /* 2380052 */   GIM_Reject,
     /* 2380053 */ // Label 33708: @2380053
     /* 2380053 */ GIM_Reject,
     /* 2380054 */ // Label 33660: @2380054
     /* 2380054 */ GIM_Try, /*On fail goto*//*Label 33711*/ GIMT_Encode4(2380157),
     /* 2380059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2380062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2380066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2380070 */   GIM_Try, /*On fail goto*//*Label 33712*/ GIMT_Encode4(2380113), // Rule ID 59148 //
     /* 2380075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380078 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2380081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2380095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380112 */     // GIR_Coverage, 59148,
     /* 2380112 */     GIR_EraseRootFromParent_Done,
     /* 2380113 */   // Label 33712: @2380113
     /* 2380113 */   GIM_Try, /*On fail goto*//*Label 33713*/ GIMT_Encode4(2380156), // Rule ID 59149 //
     /* 2380118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380121 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2380124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2380138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380155 */     // GIR_Coverage, 59149,
     /* 2380155 */     GIR_EraseRootFromParent_Done,
     /* 2380156 */   // Label 33713: @2380156
     /* 2380156 */   GIM_Reject,
     /* 2380157 */ // Label 33711: @2380157
     /* 2380157 */ GIM_Reject,
     /* 2380158 */ // Label 33661: @2380158
     /* 2380158 */ GIM_Try, /*On fail goto*//*Label 33714*/ GIMT_Encode4(2380261),
     /* 2380163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2380166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2380170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2380174 */   GIM_Try, /*On fail goto*//*Label 33715*/ GIMT_Encode4(2380217), // Rule ID 59158 //
     /* 2380179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380182 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2380185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2380199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380216 */     // GIR_Coverage, 59158,
     /* 2380216 */     GIR_EraseRootFromParent_Done,
     /* 2380217 */   // Label 33715: @2380217
     /* 2380217 */   GIM_Try, /*On fail goto*//*Label 33716*/ GIMT_Encode4(2380260), // Rule ID 59159 //
     /* 2380222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380225 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2380228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2380242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380259 */     // GIR_Coverage, 59159,
     /* 2380259 */     GIR_EraseRootFromParent_Done,
     /* 2380260 */   // Label 33716: @2380260
     /* 2380260 */   GIM_Reject,
     /* 2380261 */ // Label 33714: @2380261
     /* 2380261 */ GIM_Reject,
     /* 2380262 */ // Label 33662: @2380262
     /* 2380262 */ GIM_Try, /*On fail goto*//*Label 33717*/ GIMT_Encode4(2380365),
     /* 2380267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2380270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380278 */   GIM_Try, /*On fail goto*//*Label 33718*/ GIMT_Encode4(2380321), // Rule ID 59176 //
     /* 2380283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380286 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2380289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2380303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380320 */     // GIR_Coverage, 59176,
     /* 2380320 */     GIR_EraseRootFromParent_Done,
     /* 2380321 */   // Label 33718: @2380321
     /* 2380321 */   GIM_Try, /*On fail goto*//*Label 33719*/ GIMT_Encode4(2380364), // Rule ID 59177 //
     /* 2380326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380329 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2380332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2380346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380363 */     // GIR_Coverage, 59177,
     /* 2380363 */     GIR_EraseRootFromParent_Done,
     /* 2380364 */   // Label 33719: @2380364
     /* 2380364 */   GIM_Reject,
     /* 2380365 */ // Label 33717: @2380365
     /* 2380365 */ GIM_Reject,
     /* 2380366 */ // Label 33663: @2380366
     /* 2380366 */ GIM_Try, /*On fail goto*//*Label 33720*/ GIMT_Encode4(2380469),
     /* 2380371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2380374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380382 */   GIM_Try, /*On fail goto*//*Label 33721*/ GIMT_Encode4(2380425), // Rule ID 59184 //
     /* 2380387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2380390 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2380393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2380407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380424 */     // GIR_Coverage, 59184,
     /* 2380424 */     GIR_EraseRootFromParent_Done,
     /* 2380425 */   // Label 33721: @2380425
     /* 2380425 */   GIM_Try, /*On fail goto*//*Label 33722*/ GIMT_Encode4(2380468), // Rule ID 59185 //
     /* 2380430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2380433 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2380436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2380450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380467 */     // GIR_Coverage, 59185,
     /* 2380467 */     GIR_EraseRootFromParent_Done,
     /* 2380468 */   // Label 33722: @2380468
     /* 2380468 */   GIM_Reject,
     /* 2380469 */ // Label 33720: @2380469
     /* 2380469 */ GIM_Reject,
     /* 2380470 */ // Label 33664: @2380470
     /* 2380470 */ GIM_Try, /*On fail goto*//*Label 33723*/ GIMT_Encode4(2380573),
     /* 2380475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2380478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2380482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2380486 */   GIM_Try, /*On fail goto*//*Label 33724*/ GIMT_Encode4(2380529), // Rule ID 59156 //
     /* 2380491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380494 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2380497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2380511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380528 */     // GIR_Coverage, 59156,
     /* 2380528 */     GIR_EraseRootFromParent_Done,
     /* 2380529 */   // Label 33724: @2380529
     /* 2380529 */   GIM_Try, /*On fail goto*//*Label 33725*/ GIMT_Encode4(2380572), // Rule ID 59157 //
     /* 2380534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380537 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2380540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2380554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380571 */     // GIR_Coverage, 59157,
     /* 2380571 */     GIR_EraseRootFromParent_Done,
     /* 2380572 */   // Label 33725: @2380572
     /* 2380572 */   GIM_Reject,
     /* 2380573 */ // Label 33723: @2380573
     /* 2380573 */ GIM_Reject,
     /* 2380574 */ // Label 33665: @2380574
     /* 2380574 */ GIM_Try, /*On fail goto*//*Label 33726*/ GIMT_Encode4(2380677),
     /* 2380579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2380582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380590 */   GIM_Try, /*On fail goto*//*Label 33727*/ GIMT_Encode4(2380633), // Rule ID 59170 //
     /* 2380595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380598 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2380601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2380615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380632 */     // GIR_Coverage, 59170,
     /* 2380632 */     GIR_EraseRootFromParent_Done,
     /* 2380633 */   // Label 33727: @2380633
     /* 2380633 */   GIM_Try, /*On fail goto*//*Label 33728*/ GIMT_Encode4(2380676), // Rule ID 59171 //
     /* 2380638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380641 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2380644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2380658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380675 */     // GIR_Coverage, 59171,
     /* 2380675 */     GIR_EraseRootFromParent_Done,
     /* 2380676 */   // Label 33728: @2380676
     /* 2380676 */   GIM_Reject,
     /* 2380677 */ // Label 33726: @2380677
     /* 2380677 */ GIM_Reject,
     /* 2380678 */ // Label 33666: @2380678
     /* 2380678 */ GIM_Try, /*On fail goto*//*Label 33729*/ GIMT_Encode4(2380781),
     /* 2380683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2380686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380694 */   GIM_Try, /*On fail goto*//*Label 33730*/ GIMT_Encode4(2380737), // Rule ID 59178 //
     /* 2380699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380702 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2380705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2380719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380736 */     // GIR_Coverage, 59178,
     /* 2380736 */     GIR_EraseRootFromParent_Done,
     /* 2380737 */   // Label 33730: @2380737
     /* 2380737 */   GIM_Try, /*On fail goto*//*Label 33731*/ GIMT_Encode4(2380780), // Rule ID 59179 //
     /* 2380742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380745 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2380748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2380762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380779 */     // GIR_Coverage, 59179,
     /* 2380779 */     GIR_EraseRootFromParent_Done,
     /* 2380780 */   // Label 33731: @2380780
     /* 2380780 */   GIM_Reject,
     /* 2380781 */ // Label 33729: @2380781
     /* 2380781 */ GIM_Reject,
     /* 2380782 */ // Label 33667: @2380782
     /* 2380782 */ GIM_Try, /*On fail goto*//*Label 33732*/ GIMT_Encode4(2380885),
     /* 2380787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2380790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380798 */   GIM_Try, /*On fail goto*//*Label 33733*/ GIMT_Encode4(2380841), // Rule ID 59186 //
     /* 2380803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2380806 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2380809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2380823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380840 */     // GIR_Coverage, 59186,
     /* 2380840 */     GIR_EraseRootFromParent_Done,
     /* 2380841 */   // Label 33733: @2380841
     /* 2380841 */   GIM_Try, /*On fail goto*//*Label 33734*/ GIMT_Encode4(2380884), // Rule ID 59187 //
     /* 2380846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2380849 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2380852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2380866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380883 */     // GIR_Coverage, 59187,
     /* 2380883 */     GIR_EraseRootFromParent_Done,
     /* 2380884 */   // Label 33734: @2380884
     /* 2380884 */   GIM_Reject,
     /* 2380885 */ // Label 33732: @2380885
     /* 2380885 */ GIM_Reject,
     /* 2380886 */ // Label 33668: @2380886
     /* 2380886 */ GIM_Try, /*On fail goto*//*Label 33735*/ GIMT_Encode4(2380989),
     /* 2380891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2380894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380902 */   GIM_Try, /*On fail goto*//*Label 33736*/ GIMT_Encode4(2380945), // Rule ID 59164 //
     /* 2380907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380910 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2380913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2380927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380944 */     // GIR_Coverage, 59164,
     /* 2380944 */     GIR_EraseRootFromParent_Done,
     /* 2380945 */   // Label 33736: @2380945
     /* 2380945 */   GIM_Try, /*On fail goto*//*Label 33737*/ GIMT_Encode4(2380988), // Rule ID 59165 //
     /* 2380950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380953 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2380956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2380970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380987 */     // GIR_Coverage, 59165,
     /* 2380987 */     GIR_EraseRootFromParent_Done,
     /* 2380988 */   // Label 33737: @2380988
     /* 2380988 */   GIM_Reject,
     /* 2380989 */ // Label 33735: @2380989
     /* 2380989 */ GIM_Reject,
     /* 2380990 */ // Label 33669: @2380990
     /* 2380990 */ GIM_Try, /*On fail goto*//*Label 33738*/ GIMT_Encode4(2381093),
     /* 2380995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2380998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2381002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2381006 */   GIM_Try, /*On fail goto*//*Label 33739*/ GIMT_Encode4(2381049), // Rule ID 59172 //
     /* 2381011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381014 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2381017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2381031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381048 */     // GIR_Coverage, 59172,
     /* 2381048 */     GIR_EraseRootFromParent_Done,
     /* 2381049 */   // Label 33739: @2381049
     /* 2381049 */   GIM_Try, /*On fail goto*//*Label 33740*/ GIMT_Encode4(2381092), // Rule ID 59173 //
     /* 2381054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381057 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2381060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2381074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381091 */     // GIR_Coverage, 59173,
     /* 2381091 */     GIR_EraseRootFromParent_Done,
     /* 2381092 */   // Label 33740: @2381092
     /* 2381092 */   GIM_Reject,
     /* 2381093 */ // Label 33738: @2381093
     /* 2381093 */ GIM_Reject,
     /* 2381094 */ // Label 33670: @2381094
     /* 2381094 */ GIM_Try, /*On fail goto*//*Label 33741*/ GIMT_Encode4(2381197),
     /* 2381099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2381102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2381106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2381110 */   GIM_Try, /*On fail goto*//*Label 33742*/ GIMT_Encode4(2381153), // Rule ID 59180 //
     /* 2381115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381118 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2381121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2381135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381152 */     // GIR_Coverage, 59180,
     /* 2381152 */     GIR_EraseRootFromParent_Done,
     /* 2381153 */   // Label 33742: @2381153
     /* 2381153 */   GIM_Try, /*On fail goto*//*Label 33743*/ GIMT_Encode4(2381196), // Rule ID 59181 //
     /* 2381158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381161 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2381164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2381178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381195 */     // GIR_Coverage, 59181,
     /* 2381195 */     GIR_EraseRootFromParent_Done,
     /* 2381196 */   // Label 33743: @2381196
     /* 2381196 */   GIM_Reject,
     /* 2381197 */ // Label 33741: @2381197
     /* 2381197 */ GIM_Reject,
     /* 2381198 */ // Label 33671: @2381198
     /* 2381198 */ GIM_Try, /*On fail goto*//*Label 33744*/ GIMT_Encode4(2381301),
     /* 2381203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2381206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2381210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2381214 */   GIM_Try, /*On fail goto*//*Label 33745*/ GIMT_Encode4(2381257), // Rule ID 59166 //
     /* 2381219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381222 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2381225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2381239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381256 */     // GIR_Coverage, 59166,
     /* 2381256 */     GIR_EraseRootFromParent_Done,
     /* 2381257 */   // Label 33745: @2381257
     /* 2381257 */   GIM_Try, /*On fail goto*//*Label 33746*/ GIMT_Encode4(2381300), // Rule ID 59167 //
     /* 2381262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381265 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2381268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2381282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381299 */     // GIR_Coverage, 59167,
     /* 2381299 */     GIR_EraseRootFromParent_Done,
     /* 2381300 */   // Label 33746: @2381300
     /* 2381300 */   GIM_Reject,
     /* 2381301 */ // Label 33744: @2381301
     /* 2381301 */ GIM_Reject,
     /* 2381302 */ // Label 33672: @2381302
     /* 2381302 */ GIM_Try, /*On fail goto*//*Label 33747*/ GIMT_Encode4(2381405),
     /* 2381307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2381310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2381314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2381318 */   GIM_Try, /*On fail goto*//*Label 33748*/ GIMT_Encode4(2381361), // Rule ID 59174 //
     /* 2381323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381326 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2381329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2381343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381360 */     // GIR_Coverage, 59174,
     /* 2381360 */     GIR_EraseRootFromParent_Done,
     /* 2381361 */   // Label 33748: @2381361
     /* 2381361 */   GIM_Try, /*On fail goto*//*Label 33749*/ GIMT_Encode4(2381404), // Rule ID 59175 //
     /* 2381366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381369 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2381372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2381386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381403 */     // GIR_Coverage, 59175,
     /* 2381403 */     GIR_EraseRootFromParent_Done,
     /* 2381404 */   // Label 33749: @2381404
     /* 2381404 */   GIM_Reject,
     /* 2381405 */ // Label 33747: @2381405
     /* 2381405 */ GIM_Reject,
     /* 2381406 */ // Label 33673: @2381406
     /* 2381406 */ GIM_Try, /*On fail goto*//*Label 33750*/ GIMT_Encode4(2381509),
     /* 2381411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2381414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2381418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2381422 */   GIM_Try, /*On fail goto*//*Label 33751*/ GIMT_Encode4(2381465), // Rule ID 59168 //
     /* 2381427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381430 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2381433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2381447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381464 */     // GIR_Coverage, 59168,
     /* 2381464 */     GIR_EraseRootFromParent_Done,
     /* 2381465 */   // Label 33751: @2381465
     /* 2381465 */   GIM_Try, /*On fail goto*//*Label 33752*/ GIMT_Encode4(2381508), // Rule ID 59169 //
     /* 2381470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381473 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2381476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2381490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381507 */     // GIR_Coverage, 59169,
     /* 2381507 */     GIR_EraseRootFromParent_Done,
     /* 2381508 */   // Label 33752: @2381508
     /* 2381508 */   GIM_Reject,
     /* 2381509 */ // Label 33750: @2381509
     /* 2381509 */ GIM_Reject,
     /* 2381510 */ // Label 33674: @2381510
     /* 2381510 */ GIM_Reject,
     /* 2381511 */ // Label 90: @2381511
     /* 2381511 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33777*/ GIMT_Encode4(2384061),
     /* 2381522 */ /*GILLT_s32*//*Label 33753*/ GIMT_Encode4(2381646),
     /* 2381526 */ /*GILLT_s64*//*Label 33754*/ GIMT_Encode4(2381694), GIMT_Encode4(0),
     /* 2381534 */ /*GILLT_nxv1s8*//*Label 33755*/ GIMT_Encode4(2381773),
     /* 2381538 */ /*GILLT_nxv1s16*//*Label 33756*/ GIMT_Encode4(2381877),
     /* 2381542 */ /*GILLT_nxv1s32*//*Label 33757*/ GIMT_Encode4(2381981),
     /* 2381546 */ /*GILLT_nxv1s64*//*Label 33758*/ GIMT_Encode4(2382085), GIMT_Encode4(0),
     /* 2381554 */ /*GILLT_nxv2s8*//*Label 33759*/ GIMT_Encode4(2382189),
     /* 2381558 */ /*GILLT_nxv2s16*//*Label 33760*/ GIMT_Encode4(2382293),
     /* 2381562 */ /*GILLT_nxv2s32*//*Label 33761*/ GIMT_Encode4(2382397),
     /* 2381566 */ /*GILLT_nxv2s64*//*Label 33762*/ GIMT_Encode4(2382501), GIMT_Encode4(0),
     /* 2381574 */ /*GILLT_nxv4s8*//*Label 33763*/ GIMT_Encode4(2382605),
     /* 2381578 */ /*GILLT_nxv4s16*//*Label 33764*/ GIMT_Encode4(2382709),
     /* 2381582 */ /*GILLT_nxv4s32*//*Label 33765*/ GIMT_Encode4(2382813),
     /* 2381586 */ /*GILLT_nxv4s64*//*Label 33766*/ GIMT_Encode4(2382917), GIMT_Encode4(0),
     /* 2381594 */ /*GILLT_nxv8s8*//*Label 33767*/ GIMT_Encode4(2383021),
     /* 2381598 */ /*GILLT_nxv8s16*//*Label 33768*/ GIMT_Encode4(2383125),
     /* 2381602 */ /*GILLT_nxv8s32*//*Label 33769*/ GIMT_Encode4(2383229),
     /* 2381606 */ /*GILLT_nxv8s64*//*Label 33770*/ GIMT_Encode4(2383333), GIMT_Encode4(0),
     /* 2381614 */ /*GILLT_nxv16s8*//*Label 33771*/ GIMT_Encode4(2383437),
     /* 2381618 */ /*GILLT_nxv16s16*//*Label 33772*/ GIMT_Encode4(2383541),
     /* 2381622 */ /*GILLT_nxv16s32*//*Label 33773*/ GIMT_Encode4(2383645), GIMT_Encode4(0),
     /* 2381630 */ /*GILLT_nxv32s8*//*Label 33774*/ GIMT_Encode4(2383749),
     /* 2381634 */ /*GILLT_nxv32s16*//*Label 33775*/ GIMT_Encode4(2383853), GIMT_Encode4(0),
     /* 2381642 */ /*GILLT_nxv64s8*//*Label 33776*/ GIMT_Encode4(2383957),
     /* 2381646 */ // Label 33753: @2381646
     /* 2381646 */ GIM_Try, /*On fail goto*//*Label 33778*/ GIMT_Encode4(2381693),
     /* 2381651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381662 */   GIM_Try, /*On fail goto*//*Label 33779*/ GIMT_Encode4(2381677), // Rule ID 2521 //
     /* 2381667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2381670 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CPOP:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2381670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2381675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381676 */     // GIR_Coverage, 2521,
     /* 2381676 */     GIR_Done,
     /* 2381677 */   // Label 33779: @2381677
     /* 2381677 */   GIM_Try, /*On fail goto*//*Label 33780*/ GIMT_Encode4(2381692), // Rule ID 64448 //
     /* 2381682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2381685 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_CNT:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2381685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2381690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381691 */     // GIR_Coverage, 64448,
     /* 2381691 */     GIR_Done,
     /* 2381692 */   // Label 33780: @2381692
     /* 2381692 */   GIM_Reject,
     /* 2381693 */ // Label 33778: @2381693
     /* 2381693 */ GIM_Reject,
     /* 2381694 */ // Label 33754: @2381694
     /* 2381694 */ GIM_Try, /*On fail goto*//*Label 33781*/ GIMT_Encode4(2381772),
     /* 2381699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381706 */   GIM_Try, /*On fail goto*//*Label 33782*/ GIMT_Encode4(2381733), // Rule ID 2524 //
     /* 2381711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2381714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2381721 */     // (ctpop:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (CPOPW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2381721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CPOPW),
     /* 2381724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2381731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381732 */     // GIR_Coverage, 2524,
     /* 2381732 */     GIR_EraseRootFromParent_Done,
     /* 2381733 */   // Label 33782: @2381733
     /* 2381733 */   GIM_Try, /*On fail goto*//*Label 33783*/ GIMT_Encode4(2381752), // Rule ID 2520 //
     /* 2381738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2381741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381745 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CPOP:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2381745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2381750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381751 */     // GIR_Coverage, 2520,
     /* 2381751 */     GIR_Done,
     /* 2381752 */   // Label 33783: @2381752
     /* 2381752 */   GIM_Try, /*On fail goto*//*Label 33784*/ GIMT_Encode4(2381771), // Rule ID 64447 //
     /* 2381757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2381760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381764 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_CNT:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2381764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2381769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381770 */     // GIR_Coverage, 64447,
     /* 2381770 */     GIR_Done,
     /* 2381771 */   // Label 33784: @2381771
     /* 2381771 */   GIM_Reject,
     /* 2381772 */ // Label 33781: @2381772
     /* 2381772 */ GIM_Reject,
     /* 2381773 */ // Label 33755: @2381773
     /* 2381773 */ GIM_Try, /*On fail goto*//*Label 33785*/ GIMT_Encode4(2381876),
     /* 2381778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2381781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381789 */   GIM_Try, /*On fail goto*//*Label 33786*/ GIMT_Encode4(2381832), // Rule ID 59232 //
     /* 2381794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381797 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2381800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2381814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381831 */     // GIR_Coverage, 59232,
     /* 2381831 */     GIR_EraseRootFromParent_Done,
     /* 2381832 */   // Label 33786: @2381832
     /* 2381832 */   GIM_Try, /*On fail goto*//*Label 33787*/ GIMT_Encode4(2381875), // Rule ID 59233 //
     /* 2381837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381840 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2381843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2381857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381874 */     // GIR_Coverage, 59233,
     /* 2381874 */     GIR_EraseRootFromParent_Done,
     /* 2381875 */   // Label 33787: @2381875
     /* 2381875 */   GIM_Reject,
     /* 2381876 */ // Label 33785: @2381876
     /* 2381876 */ GIM_Reject,
     /* 2381877 */ // Label 33756: @2381877
     /* 2381877 */ GIM_Try, /*On fail goto*//*Label 33788*/ GIMT_Encode4(2381980),
     /* 2381882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2381885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381893 */   GIM_Try, /*On fail goto*//*Label 33789*/ GIMT_Encode4(2381936), // Rule ID 59238 //
     /* 2381898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381901 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2381904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2381918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381935 */     // GIR_Coverage, 59238,
     /* 2381935 */     GIR_EraseRootFromParent_Done,
     /* 2381936 */   // Label 33789: @2381936
     /* 2381936 */   GIM_Try, /*On fail goto*//*Label 33790*/ GIMT_Encode4(2381979), // Rule ID 59239 //
     /* 2381941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381944 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2381947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2381961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381978 */     // GIR_Coverage, 59239,
     /* 2381978 */     GIR_EraseRootFromParent_Done,
     /* 2381979 */   // Label 33790: @2381979
     /* 2381979 */   GIM_Reject,
     /* 2381980 */ // Label 33788: @2381980
     /* 2381980 */ GIM_Reject,
     /* 2381981 */ // Label 33757: @2381981
     /* 2381981 */ GIM_Try, /*On fail goto*//*Label 33791*/ GIMT_Encode4(2382084),
     /* 2381986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2381989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381997 */   GIM_Try, /*On fail goto*//*Label 33792*/ GIMT_Encode4(2382040), // Rule ID 59242 //
     /* 2382002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382005 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2382008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2382022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382039 */     // GIR_Coverage, 59242,
     /* 2382039 */     GIR_EraseRootFromParent_Done,
     /* 2382040 */   // Label 33792: @2382040
     /* 2382040 */   GIM_Try, /*On fail goto*//*Label 33793*/ GIMT_Encode4(2382083), // Rule ID 59243 //
     /* 2382045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382048 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2382051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2382065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382082 */     // GIR_Coverage, 59243,
     /* 2382082 */     GIR_EraseRootFromParent_Done,
     /* 2382083 */   // Label 33793: @2382083
     /* 2382083 */   GIM_Reject,
     /* 2382084 */ // Label 33791: @2382084
     /* 2382084 */ GIM_Reject,
     /* 2382085 */ // Label 33758: @2382085
     /* 2382085 */ GIM_Try, /*On fail goto*//*Label 33794*/ GIMT_Encode4(2382188),
     /* 2382090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2382093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382101 */   GIM_Try, /*On fail goto*//*Label 33795*/ GIMT_Encode4(2382144), // Rule ID 59250 //
     /* 2382106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2382109 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2382112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2382126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382143 */     // GIR_Coverage, 59250,
     /* 2382143 */     GIR_EraseRootFromParent_Done,
     /* 2382144 */   // Label 33795: @2382144
     /* 2382144 */   GIM_Try, /*On fail goto*//*Label 33796*/ GIMT_Encode4(2382187), // Rule ID 59251 //
     /* 2382149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2382152 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2382155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2382169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382186 */     // GIR_Coverage, 59251,
     /* 2382186 */     GIR_EraseRootFromParent_Done,
     /* 2382187 */   // Label 33796: @2382187
     /* 2382187 */   GIM_Reject,
     /* 2382188 */ // Label 33794: @2382188
     /* 2382188 */ GIM_Reject,
     /* 2382189 */ // Label 33759: @2382189
     /* 2382189 */ GIM_Try, /*On fail goto*//*Label 33797*/ GIMT_Encode4(2382292),
     /* 2382194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2382197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382205 */   GIM_Try, /*On fail goto*//*Label 33798*/ GIMT_Encode4(2382248), // Rule ID 59234 //
     /* 2382210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382213 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2382216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2382230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382247 */     // GIR_Coverage, 59234,
     /* 2382247 */     GIR_EraseRootFromParent_Done,
     /* 2382248 */   // Label 33798: @2382248
     /* 2382248 */   GIM_Try, /*On fail goto*//*Label 33799*/ GIMT_Encode4(2382291), // Rule ID 59235 //
     /* 2382253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382256 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2382259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2382273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382290 */     // GIR_Coverage, 59235,
     /* 2382290 */     GIR_EraseRootFromParent_Done,
     /* 2382291 */   // Label 33799: @2382291
     /* 2382291 */   GIM_Reject,
     /* 2382292 */ // Label 33797: @2382292
     /* 2382292 */ GIM_Reject,
     /* 2382293 */ // Label 33760: @2382293
     /* 2382293 */ GIM_Try, /*On fail goto*//*Label 33800*/ GIMT_Encode4(2382396),
     /* 2382298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2382301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382309 */   GIM_Try, /*On fail goto*//*Label 33801*/ GIMT_Encode4(2382352), // Rule ID 59240 //
     /* 2382314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382317 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2382320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2382334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382351 */     // GIR_Coverage, 59240,
     /* 2382351 */     GIR_EraseRootFromParent_Done,
     /* 2382352 */   // Label 33801: @2382352
     /* 2382352 */   GIM_Try, /*On fail goto*//*Label 33802*/ GIMT_Encode4(2382395), // Rule ID 59241 //
     /* 2382357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382360 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2382363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2382377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382394 */     // GIR_Coverage, 59241,
     /* 2382394 */     GIR_EraseRootFromParent_Done,
     /* 2382395 */   // Label 33802: @2382395
     /* 2382395 */   GIM_Reject,
     /* 2382396 */ // Label 33800: @2382396
     /* 2382396 */ GIM_Reject,
     /* 2382397 */ // Label 33761: @2382397
     /* 2382397 */ GIM_Try, /*On fail goto*//*Label 33803*/ GIMT_Encode4(2382500),
     /* 2382402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2382405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382413 */   GIM_Try, /*On fail goto*//*Label 33804*/ GIMT_Encode4(2382456), // Rule ID 59248 //
     /* 2382418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382421 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2382424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2382438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382455 */     // GIR_Coverage, 59248,
     /* 2382455 */     GIR_EraseRootFromParent_Done,
     /* 2382456 */   // Label 33804: @2382456
     /* 2382456 */   GIM_Try, /*On fail goto*//*Label 33805*/ GIMT_Encode4(2382499), // Rule ID 59249 //
     /* 2382461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382464 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2382467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2382481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382498 */     // GIR_Coverage, 59249,
     /* 2382498 */     GIR_EraseRootFromParent_Done,
     /* 2382499 */   // Label 33805: @2382499
     /* 2382499 */   GIM_Reject,
     /* 2382500 */ // Label 33803: @2382500
     /* 2382500 */ GIM_Reject,
     /* 2382501 */ // Label 33762: @2382501
     /* 2382501 */ GIM_Try, /*On fail goto*//*Label 33806*/ GIMT_Encode4(2382604),
     /* 2382506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2382509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382517 */   GIM_Try, /*On fail goto*//*Label 33807*/ GIMT_Encode4(2382560), // Rule ID 59270 //
     /* 2382522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2382525 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2382528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2382542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382559 */     // GIR_Coverage, 59270,
     /* 2382559 */     GIR_EraseRootFromParent_Done,
     /* 2382560 */   // Label 33807: @2382560
     /* 2382560 */   GIM_Try, /*On fail goto*//*Label 33808*/ GIMT_Encode4(2382603), // Rule ID 59271 //
     /* 2382565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2382568 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2382571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2382585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382602 */     // GIR_Coverage, 59271,
     /* 2382602 */     GIR_EraseRootFromParent_Done,
     /* 2382603 */   // Label 33808: @2382603
     /* 2382603 */   GIM_Reject,
     /* 2382604 */ // Label 33806: @2382604
     /* 2382604 */ GIM_Reject,
     /* 2382605 */ // Label 33763: @2382605
     /* 2382605 */ GIM_Try, /*On fail goto*//*Label 33809*/ GIMT_Encode4(2382708),
     /* 2382610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2382613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382621 */   GIM_Try, /*On fail goto*//*Label 33810*/ GIMT_Encode4(2382664), // Rule ID 59236 //
     /* 2382626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382629 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2382632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2382646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382663 */     // GIR_Coverage, 59236,
     /* 2382663 */     GIR_EraseRootFromParent_Done,
     /* 2382664 */   // Label 33810: @2382664
     /* 2382664 */   GIM_Try, /*On fail goto*//*Label 33811*/ GIMT_Encode4(2382707), // Rule ID 59237 //
     /* 2382669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382672 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2382675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2382689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382706 */     // GIR_Coverage, 59237,
     /* 2382706 */     GIR_EraseRootFromParent_Done,
     /* 2382707 */   // Label 33811: @2382707
     /* 2382707 */   GIM_Reject,
     /* 2382708 */ // Label 33809: @2382708
     /* 2382708 */ GIM_Reject,
     /* 2382709 */ // Label 33764: @2382709
     /* 2382709 */ GIM_Try, /*On fail goto*//*Label 33812*/ GIMT_Encode4(2382812),
     /* 2382714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2382717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382725 */   GIM_Try, /*On fail goto*//*Label 33813*/ GIMT_Encode4(2382768), // Rule ID 59246 //
     /* 2382730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382733 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2382736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2382750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382767 */     // GIR_Coverage, 59246,
     /* 2382767 */     GIR_EraseRootFromParent_Done,
     /* 2382768 */   // Label 33813: @2382768
     /* 2382768 */   GIM_Try, /*On fail goto*//*Label 33814*/ GIMT_Encode4(2382811), // Rule ID 59247 //
     /* 2382773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382776 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2382779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2382793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382810 */     // GIR_Coverage, 59247,
     /* 2382810 */     GIR_EraseRootFromParent_Done,
     /* 2382811 */   // Label 33814: @2382811
     /* 2382811 */   GIM_Reject,
     /* 2382812 */ // Label 33812: @2382812
     /* 2382812 */ GIM_Reject,
     /* 2382813 */ // Label 33765: @2382813
     /* 2382813 */ GIM_Try, /*On fail goto*//*Label 33815*/ GIMT_Encode4(2382916),
     /* 2382818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2382821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382829 */   GIM_Try, /*On fail goto*//*Label 33816*/ GIMT_Encode4(2382872), // Rule ID 59264 //
     /* 2382834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382837 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2382840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2382854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382871 */     // GIR_Coverage, 59264,
     /* 2382871 */     GIR_EraseRootFromParent_Done,
     /* 2382872 */   // Label 33816: @2382872
     /* 2382872 */   GIM_Try, /*On fail goto*//*Label 33817*/ GIMT_Encode4(2382915), // Rule ID 59265 //
     /* 2382877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382880 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2382883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2382897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382914 */     // GIR_Coverage, 59265,
     /* 2382914 */     GIR_EraseRootFromParent_Done,
     /* 2382915 */   // Label 33817: @2382915
     /* 2382915 */   GIM_Reject,
     /* 2382916 */ // Label 33815: @2382916
     /* 2382916 */ GIM_Reject,
     /* 2382917 */ // Label 33766: @2382917
     /* 2382917 */ GIM_Try, /*On fail goto*//*Label 33818*/ GIMT_Encode4(2383020),
     /* 2382922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2382925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382933 */   GIM_Try, /*On fail goto*//*Label 33819*/ GIMT_Encode4(2382976), // Rule ID 59272 //
     /* 2382938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2382941 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2382944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2382958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382975 */     // GIR_Coverage, 59272,
     /* 2382975 */     GIR_EraseRootFromParent_Done,
     /* 2382976 */   // Label 33819: @2382976
     /* 2382976 */   GIM_Try, /*On fail goto*//*Label 33820*/ GIMT_Encode4(2383019), // Rule ID 59273 //
     /* 2382981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2382984 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2382987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2383001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383018 */     // GIR_Coverage, 59273,
     /* 2383018 */     GIR_EraseRootFromParent_Done,
     /* 2383019 */   // Label 33820: @2383019
     /* 2383019 */   GIM_Reject,
     /* 2383020 */ // Label 33818: @2383020
     /* 2383020 */ GIM_Reject,
     /* 2383021 */ // Label 33767: @2383021
     /* 2383021 */ GIM_Try, /*On fail goto*//*Label 33821*/ GIMT_Encode4(2383124),
     /* 2383026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2383029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383037 */   GIM_Try, /*On fail goto*//*Label 33822*/ GIMT_Encode4(2383080), // Rule ID 59244 //
     /* 2383042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383045 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2383048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2383062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383079 */     // GIR_Coverage, 59244,
     /* 2383079 */     GIR_EraseRootFromParent_Done,
     /* 2383080 */   // Label 33822: @2383080
     /* 2383080 */   GIM_Try, /*On fail goto*//*Label 33823*/ GIMT_Encode4(2383123), // Rule ID 59245 //
     /* 2383085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383088 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2383091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2383105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383122 */     // GIR_Coverage, 59245,
     /* 2383122 */     GIR_EraseRootFromParent_Done,
     /* 2383123 */   // Label 33823: @2383123
     /* 2383123 */   GIM_Reject,
     /* 2383124 */ // Label 33821: @2383124
     /* 2383124 */ GIM_Reject,
     /* 2383125 */ // Label 33768: @2383125
     /* 2383125 */ GIM_Try, /*On fail goto*//*Label 33824*/ GIMT_Encode4(2383228),
     /* 2383130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2383133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383141 */   GIM_Try, /*On fail goto*//*Label 33825*/ GIMT_Encode4(2383184), // Rule ID 59258 //
     /* 2383146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383149 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2383152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2383166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383183 */     // GIR_Coverage, 59258,
     /* 2383183 */     GIR_EraseRootFromParent_Done,
     /* 2383184 */   // Label 33825: @2383184
     /* 2383184 */   GIM_Try, /*On fail goto*//*Label 33826*/ GIMT_Encode4(2383227), // Rule ID 59259 //
     /* 2383189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383192 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2383195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2383209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383226 */     // GIR_Coverage, 59259,
     /* 2383226 */     GIR_EraseRootFromParent_Done,
     /* 2383227 */   // Label 33826: @2383227
     /* 2383227 */   GIM_Reject,
     /* 2383228 */ // Label 33824: @2383228
     /* 2383228 */ GIM_Reject,
     /* 2383229 */ // Label 33769: @2383229
     /* 2383229 */ GIM_Try, /*On fail goto*//*Label 33827*/ GIMT_Encode4(2383332),
     /* 2383234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2383237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383245 */   GIM_Try, /*On fail goto*//*Label 33828*/ GIMT_Encode4(2383288), // Rule ID 59266 //
     /* 2383250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383253 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2383256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2383270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383287 */     // GIR_Coverage, 59266,
     /* 2383287 */     GIR_EraseRootFromParent_Done,
     /* 2383288 */   // Label 33828: @2383288
     /* 2383288 */   GIM_Try, /*On fail goto*//*Label 33829*/ GIMT_Encode4(2383331), // Rule ID 59267 //
     /* 2383293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383296 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2383299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2383313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383330 */     // GIR_Coverage, 59267,
     /* 2383330 */     GIR_EraseRootFromParent_Done,
     /* 2383331 */   // Label 33829: @2383331
     /* 2383331 */   GIM_Reject,
     /* 2383332 */ // Label 33827: @2383332
     /* 2383332 */ GIM_Reject,
     /* 2383333 */ // Label 33770: @2383333
     /* 2383333 */ GIM_Try, /*On fail goto*//*Label 33830*/ GIMT_Encode4(2383436),
     /* 2383338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2383341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383349 */   GIM_Try, /*On fail goto*//*Label 33831*/ GIMT_Encode4(2383392), // Rule ID 59274 //
     /* 2383354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2383357 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2383360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2383374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383391 */     // GIR_Coverage, 59274,
     /* 2383391 */     GIR_EraseRootFromParent_Done,
     /* 2383392 */   // Label 33831: @2383392
     /* 2383392 */   GIM_Try, /*On fail goto*//*Label 33832*/ GIMT_Encode4(2383435), // Rule ID 59275 //
     /* 2383397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2383400 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2383403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2383417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383434 */     // GIR_Coverage, 59275,
     /* 2383434 */     GIR_EraseRootFromParent_Done,
     /* 2383435 */   // Label 33832: @2383435
     /* 2383435 */   GIM_Reject,
     /* 2383436 */ // Label 33830: @2383436
     /* 2383436 */ GIM_Reject,
     /* 2383437 */ // Label 33771: @2383437
     /* 2383437 */ GIM_Try, /*On fail goto*//*Label 33833*/ GIMT_Encode4(2383540),
     /* 2383442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2383445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383453 */   GIM_Try, /*On fail goto*//*Label 33834*/ GIMT_Encode4(2383496), // Rule ID 59252 //
     /* 2383458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383461 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2383464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2383478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383495 */     // GIR_Coverage, 59252,
     /* 2383495 */     GIR_EraseRootFromParent_Done,
     /* 2383496 */   // Label 33834: @2383496
     /* 2383496 */   GIM_Try, /*On fail goto*//*Label 33835*/ GIMT_Encode4(2383539), // Rule ID 59253 //
     /* 2383501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383504 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2383507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2383521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383538 */     // GIR_Coverage, 59253,
     /* 2383538 */     GIR_EraseRootFromParent_Done,
     /* 2383539 */   // Label 33835: @2383539
     /* 2383539 */   GIM_Reject,
     /* 2383540 */ // Label 33833: @2383540
     /* 2383540 */ GIM_Reject,
     /* 2383541 */ // Label 33772: @2383541
     /* 2383541 */ GIM_Try, /*On fail goto*//*Label 33836*/ GIMT_Encode4(2383644),
     /* 2383546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2383549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383557 */   GIM_Try, /*On fail goto*//*Label 33837*/ GIMT_Encode4(2383600), // Rule ID 59260 //
     /* 2383562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383565 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2383568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2383582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383599 */     // GIR_Coverage, 59260,
     /* 2383599 */     GIR_EraseRootFromParent_Done,
     /* 2383600 */   // Label 33837: @2383600
     /* 2383600 */   GIM_Try, /*On fail goto*//*Label 33838*/ GIMT_Encode4(2383643), // Rule ID 59261 //
     /* 2383605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383608 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2383611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2383625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383642 */     // GIR_Coverage, 59261,
     /* 2383642 */     GIR_EraseRootFromParent_Done,
     /* 2383643 */   // Label 33838: @2383643
     /* 2383643 */   GIM_Reject,
     /* 2383644 */ // Label 33836: @2383644
     /* 2383644 */ GIM_Reject,
     /* 2383645 */ // Label 33773: @2383645
     /* 2383645 */ GIM_Try, /*On fail goto*//*Label 33839*/ GIMT_Encode4(2383748),
     /* 2383650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2383653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383661 */   GIM_Try, /*On fail goto*//*Label 33840*/ GIMT_Encode4(2383704), // Rule ID 59268 //
     /* 2383666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383669 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2383672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2383686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383703 */     // GIR_Coverage, 59268,
     /* 2383703 */     GIR_EraseRootFromParent_Done,
     /* 2383704 */   // Label 33840: @2383704
     /* 2383704 */   GIM_Try, /*On fail goto*//*Label 33841*/ GIMT_Encode4(2383747), // Rule ID 59269 //
     /* 2383709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383712 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2383715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2383729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383746 */     // GIR_Coverage, 59269,
     /* 2383746 */     GIR_EraseRootFromParent_Done,
     /* 2383747 */   // Label 33841: @2383747
     /* 2383747 */   GIM_Reject,
     /* 2383748 */ // Label 33839: @2383748
     /* 2383748 */ GIM_Reject,
     /* 2383749 */ // Label 33774: @2383749
     /* 2383749 */ GIM_Try, /*On fail goto*//*Label 33842*/ GIMT_Encode4(2383852),
     /* 2383754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2383757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383765 */   GIM_Try, /*On fail goto*//*Label 33843*/ GIMT_Encode4(2383808), // Rule ID 59254 //
     /* 2383770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383773 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2383776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2383790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383807 */     // GIR_Coverage, 59254,
     /* 2383807 */     GIR_EraseRootFromParent_Done,
     /* 2383808 */   // Label 33843: @2383808
     /* 2383808 */   GIM_Try, /*On fail goto*//*Label 33844*/ GIMT_Encode4(2383851), // Rule ID 59255 //
     /* 2383813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383816 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2383819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2383833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383850 */     // GIR_Coverage, 59255,
     /* 2383850 */     GIR_EraseRootFromParent_Done,
     /* 2383851 */   // Label 33844: @2383851
     /* 2383851 */   GIM_Reject,
     /* 2383852 */ // Label 33842: @2383852
     /* 2383852 */ GIM_Reject,
     /* 2383853 */ // Label 33775: @2383853
     /* 2383853 */ GIM_Try, /*On fail goto*//*Label 33845*/ GIMT_Encode4(2383956),
     /* 2383858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2383861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383869 */   GIM_Try, /*On fail goto*//*Label 33846*/ GIMT_Encode4(2383912), // Rule ID 59262 //
     /* 2383874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383877 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2383880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2383894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383911 */     // GIR_Coverage, 59262,
     /* 2383911 */     GIR_EraseRootFromParent_Done,
     /* 2383912 */   // Label 33846: @2383912
     /* 2383912 */   GIM_Try, /*On fail goto*//*Label 33847*/ GIMT_Encode4(2383955), // Rule ID 59263 //
     /* 2383917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383920 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2383923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2383937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383954 */     // GIR_Coverage, 59263,
     /* 2383954 */     GIR_EraseRootFromParent_Done,
     /* 2383955 */   // Label 33847: @2383955
     /* 2383955 */   GIM_Reject,
     /* 2383956 */ // Label 33845: @2383956
     /* 2383956 */ GIM_Reject,
     /* 2383957 */ // Label 33776: @2383957
     /* 2383957 */ GIM_Try, /*On fail goto*//*Label 33848*/ GIMT_Encode4(2384060),
     /* 2383962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2383965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383973 */   GIM_Try, /*On fail goto*//*Label 33849*/ GIMT_Encode4(2384016), // Rule ID 59256 //
     /* 2383978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383981 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2383984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2383998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384015 */     // GIR_Coverage, 59256,
     /* 2384015 */     GIR_EraseRootFromParent_Done,
     /* 2384016 */   // Label 33849: @2384016
     /* 2384016 */   GIM_Try, /*On fail goto*//*Label 33850*/ GIMT_Encode4(2384059), // Rule ID 59257 //
     /* 2384021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384024 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2384027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2384041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384058 */     // GIR_Coverage, 59257,
     /* 2384058 */     GIR_EraseRootFromParent_Done,
     /* 2384059 */   // Label 33850: @2384059
     /* 2384059 */   GIM_Reject,
     /* 2384060 */ // Label 33848: @2384060
     /* 2384060 */ GIM_Reject,
     /* 2384061 */ // Label 33777: @2384061
     /* 2384061 */ GIM_Reject,
     /* 2384062 */ // Label 91: @2384062
     /* 2384062 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33875*/ GIMT_Encode4(2386596),
     /* 2384073 */ /*GILLT_s32*//*Label 33851*/ GIMT_Encode4(2384197),
     /* 2384077 */ /*GILLT_s64*//*Label 33852*/ GIMT_Encode4(2384260), GIMT_Encode4(0),
     /* 2384085 */ /*GILLT_nxv1s8*//*Label 33853*/ GIMT_Encode4(2384308),
     /* 2384089 */ /*GILLT_nxv1s16*//*Label 33854*/ GIMT_Encode4(2384412),
     /* 2384093 */ /*GILLT_nxv1s32*//*Label 33855*/ GIMT_Encode4(2384516),
     /* 2384097 */ /*GILLT_nxv1s64*//*Label 33856*/ GIMT_Encode4(2384620), GIMT_Encode4(0),
     /* 2384105 */ /*GILLT_nxv2s8*//*Label 33857*/ GIMT_Encode4(2384724),
     /* 2384109 */ /*GILLT_nxv2s16*//*Label 33858*/ GIMT_Encode4(2384828),
     /* 2384113 */ /*GILLT_nxv2s32*//*Label 33859*/ GIMT_Encode4(2384932),
     /* 2384117 */ /*GILLT_nxv2s64*//*Label 33860*/ GIMT_Encode4(2385036), GIMT_Encode4(0),
     /* 2384125 */ /*GILLT_nxv4s8*//*Label 33861*/ GIMT_Encode4(2385140),
     /* 2384129 */ /*GILLT_nxv4s16*//*Label 33862*/ GIMT_Encode4(2385244),
     /* 2384133 */ /*GILLT_nxv4s32*//*Label 33863*/ GIMT_Encode4(2385348),
     /* 2384137 */ /*GILLT_nxv4s64*//*Label 33864*/ GIMT_Encode4(2385452), GIMT_Encode4(0),
     /* 2384145 */ /*GILLT_nxv8s8*//*Label 33865*/ GIMT_Encode4(2385556),
     /* 2384149 */ /*GILLT_nxv8s16*//*Label 33866*/ GIMT_Encode4(2385660),
     /* 2384153 */ /*GILLT_nxv8s32*//*Label 33867*/ GIMT_Encode4(2385764),
     /* 2384157 */ /*GILLT_nxv8s64*//*Label 33868*/ GIMT_Encode4(2385868), GIMT_Encode4(0),
     /* 2384165 */ /*GILLT_nxv16s8*//*Label 33869*/ GIMT_Encode4(2385972),
     /* 2384169 */ /*GILLT_nxv16s16*//*Label 33870*/ GIMT_Encode4(2386076),
     /* 2384173 */ /*GILLT_nxv16s32*//*Label 33871*/ GIMT_Encode4(2386180), GIMT_Encode4(0),
     /* 2384181 */ /*GILLT_nxv32s8*//*Label 33872*/ GIMT_Encode4(2386284),
     /* 2384185 */ /*GILLT_nxv32s16*//*Label 33873*/ GIMT_Encode4(2386388), GIMT_Encode4(0),
     /* 2384193 */ /*GILLT_nxv64s8*//*Label 33874*/ GIMT_Encode4(2386492),
     /* 2384197 */ // Label 33851: @2384197
     /* 2384197 */ GIM_Try, /*On fail goto*//*Label 33876*/ GIMT_Encode4(2384259),
     /* 2384202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2384205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384213 */   GIM_Try, /*On fail goto*//*Label 33877*/ GIMT_Encode4(2384228), // Rule ID 2538 //
     /* 2384218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0),
     /* 2384221 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2384226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384227 */     // GIR_Coverage, 2538,
     /* 2384227 */     GIR_Done,
     /* 2384228 */   // Label 33877: @2384228
     /* 2384228 */   GIM_Try, /*On fail goto*//*Label 33878*/ GIMT_Encode4(2384243), // Rule ID 2539 //
     /* 2384233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1),
     /* 2384236 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2384241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384242 */     // GIR_Coverage, 2539,
     /* 2384242 */     GIR_Done,
     /* 2384243 */   // Label 33878: @2384243
     /* 2384243 */   GIM_Try, /*On fail goto*//*Label 33879*/ GIMT_Encode4(2384258), // Rule ID 62570 //
     /* 2384248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2384251 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_REV:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384251 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2384256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384257 */     // GIR_Coverage, 62570,
     /* 2384257 */     GIR_Done,
     /* 2384258 */   // Label 33879: @2384258
     /* 2384258 */   GIM_Reject,
     /* 2384259 */ // Label 33876: @2384259
     /* 2384259 */ GIM_Reject,
     /* 2384260 */ // Label 33852: @2384260
     /* 2384260 */ GIM_Try, /*On fail goto*//*Label 33880*/ GIMT_Encode4(2384307),
     /* 2384265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2384268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384276 */   GIM_Try, /*On fail goto*//*Label 33881*/ GIMT_Encode4(2384291), // Rule ID 2540 //
     /* 2384281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2384284 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (REV8_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2384284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV64),
     /* 2384289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384290 */     // GIR_Coverage, 2540,
     /* 2384290 */     GIR_Done,
     /* 2384291 */   // Label 33881: @2384291
     /* 2384291 */   GIM_Try, /*On fail goto*//*Label 33882*/ GIMT_Encode4(2384306), // Rule ID 62569 //
     /* 2384296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2384299 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_REV:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2384299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2384304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384305 */     // GIR_Coverage, 62569,
     /* 2384305 */     GIR_Done,
     /* 2384306 */   // Label 33882: @2384306
     /* 2384306 */   GIM_Reject,
     /* 2384307 */ // Label 33880: @2384307
     /* 2384307 */ GIM_Reject,
     /* 2384308 */ // Label 33853: @2384308
     /* 2384308 */ GIM_Try, /*On fail goto*//*Label 33883*/ GIMT_Encode4(2384411),
     /* 2384313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2384316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384324 */   GIM_Try, /*On fail goto*//*Label 33884*/ GIMT_Encode4(2384367), // Rule ID 59100 //
     /* 2384329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384332 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2384335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2384349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384366 */     // GIR_Coverage, 59100,
     /* 2384366 */     GIR_EraseRootFromParent_Done,
     /* 2384367 */   // Label 33884: @2384367
     /* 2384367 */   GIM_Try, /*On fail goto*//*Label 33885*/ GIMT_Encode4(2384410), // Rule ID 59101 //
     /* 2384372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384375 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2384378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2384392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384409 */     // GIR_Coverage, 59101,
     /* 2384409 */     GIR_EraseRootFromParent_Done,
     /* 2384410 */   // Label 33885: @2384410
     /* 2384410 */   GIM_Reject,
     /* 2384411 */ // Label 33883: @2384411
     /* 2384411 */ GIM_Reject,
     /* 2384412 */ // Label 33854: @2384412
     /* 2384412 */ GIM_Try, /*On fail goto*//*Label 33886*/ GIMT_Encode4(2384515),
     /* 2384417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2384420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384428 */   GIM_Try, /*On fail goto*//*Label 33887*/ GIMT_Encode4(2384471), // Rule ID 59106 //
     /* 2384433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384436 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2384439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2384453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384470 */     // GIR_Coverage, 59106,
     /* 2384470 */     GIR_EraseRootFromParent_Done,
     /* 2384471 */   // Label 33887: @2384471
     /* 2384471 */   GIM_Try, /*On fail goto*//*Label 33888*/ GIMT_Encode4(2384514), // Rule ID 59107 //
     /* 2384476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384479 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2384482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2384496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384513 */     // GIR_Coverage, 59107,
     /* 2384513 */     GIR_EraseRootFromParent_Done,
     /* 2384514 */   // Label 33888: @2384514
     /* 2384514 */   GIM_Reject,
     /* 2384515 */ // Label 33886: @2384515
     /* 2384515 */ GIM_Reject,
     /* 2384516 */ // Label 33855: @2384516
     /* 2384516 */ GIM_Try, /*On fail goto*//*Label 33889*/ GIMT_Encode4(2384619),
     /* 2384521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2384524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384532 */   GIM_Try, /*On fail goto*//*Label 33890*/ GIMT_Encode4(2384575), // Rule ID 59110 //
     /* 2384537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384540 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2384543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2384557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384574 */     // GIR_Coverage, 59110,
     /* 2384574 */     GIR_EraseRootFromParent_Done,
     /* 2384575 */   // Label 33890: @2384575
     /* 2384575 */   GIM_Try, /*On fail goto*//*Label 33891*/ GIMT_Encode4(2384618), // Rule ID 59111 //
     /* 2384580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384583 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2384586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2384600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384617 */     // GIR_Coverage, 59111,
     /* 2384617 */     GIR_EraseRootFromParent_Done,
     /* 2384618 */   // Label 33891: @2384618
     /* 2384618 */   GIM_Reject,
     /* 2384619 */ // Label 33889: @2384619
     /* 2384619 */ GIM_Reject,
     /* 2384620 */ // Label 33856: @2384620
     /* 2384620 */ GIM_Try, /*On fail goto*//*Label 33892*/ GIMT_Encode4(2384723),
     /* 2384625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2384628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384636 */   GIM_Try, /*On fail goto*//*Label 33893*/ GIMT_Encode4(2384679), // Rule ID 59118 //
     /* 2384641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2384644 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2384647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2384661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384678 */     // GIR_Coverage, 59118,
     /* 2384678 */     GIR_EraseRootFromParent_Done,
     /* 2384679 */   // Label 33893: @2384679
     /* 2384679 */   GIM_Try, /*On fail goto*//*Label 33894*/ GIMT_Encode4(2384722), // Rule ID 59119 //
     /* 2384684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2384687 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2384690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2384704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384721 */     // GIR_Coverage, 59119,
     /* 2384721 */     GIR_EraseRootFromParent_Done,
     /* 2384722 */   // Label 33894: @2384722
     /* 2384722 */   GIM_Reject,
     /* 2384723 */ // Label 33892: @2384723
     /* 2384723 */ GIM_Reject,
     /* 2384724 */ // Label 33857: @2384724
     /* 2384724 */ GIM_Try, /*On fail goto*//*Label 33895*/ GIMT_Encode4(2384827),
     /* 2384729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2384732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384740 */   GIM_Try, /*On fail goto*//*Label 33896*/ GIMT_Encode4(2384783), // Rule ID 59102 //
     /* 2384745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384748 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2384751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2384765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384782 */     // GIR_Coverage, 59102,
     /* 2384782 */     GIR_EraseRootFromParent_Done,
     /* 2384783 */   // Label 33896: @2384783
     /* 2384783 */   GIM_Try, /*On fail goto*//*Label 33897*/ GIMT_Encode4(2384826), // Rule ID 59103 //
     /* 2384788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384791 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2384794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2384808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384825 */     // GIR_Coverage, 59103,
     /* 2384825 */     GIR_EraseRootFromParent_Done,
     /* 2384826 */   // Label 33897: @2384826
     /* 2384826 */   GIM_Reject,
     /* 2384827 */ // Label 33895: @2384827
     /* 2384827 */ GIM_Reject,
     /* 2384828 */ // Label 33858: @2384828
     /* 2384828 */ GIM_Try, /*On fail goto*//*Label 33898*/ GIMT_Encode4(2384931),
     /* 2384833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2384836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384844 */   GIM_Try, /*On fail goto*//*Label 33899*/ GIMT_Encode4(2384887), // Rule ID 59108 //
     /* 2384849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384852 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2384855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2384869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384886 */     // GIR_Coverage, 59108,
     /* 2384886 */     GIR_EraseRootFromParent_Done,
     /* 2384887 */   // Label 33899: @2384887
     /* 2384887 */   GIM_Try, /*On fail goto*//*Label 33900*/ GIMT_Encode4(2384930), // Rule ID 59109 //
     /* 2384892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384895 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2384898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2384912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384929 */     // GIR_Coverage, 59109,
     /* 2384929 */     GIR_EraseRootFromParent_Done,
     /* 2384930 */   // Label 33900: @2384930
     /* 2384930 */   GIM_Reject,
     /* 2384931 */ // Label 33898: @2384931
     /* 2384931 */ GIM_Reject,
     /* 2384932 */ // Label 33859: @2384932
     /* 2384932 */ GIM_Try, /*On fail goto*//*Label 33901*/ GIMT_Encode4(2385035),
     /* 2384937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2384940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384948 */   GIM_Try, /*On fail goto*//*Label 33902*/ GIMT_Encode4(2384991), // Rule ID 59116 //
     /* 2384953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384956 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2384959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2384973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384990 */     // GIR_Coverage, 59116,
     /* 2384990 */     GIR_EraseRootFromParent_Done,
     /* 2384991 */   // Label 33902: @2384991
     /* 2384991 */   GIM_Try, /*On fail goto*//*Label 33903*/ GIMT_Encode4(2385034), // Rule ID 59117 //
     /* 2384996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384999 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2385002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2385016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385033 */     // GIR_Coverage, 59117,
     /* 2385033 */     GIR_EraseRootFromParent_Done,
     /* 2385034 */   // Label 33903: @2385034
     /* 2385034 */   GIM_Reject,
     /* 2385035 */ // Label 33901: @2385035
     /* 2385035 */ GIM_Reject,
     /* 2385036 */ // Label 33860: @2385036
     /* 2385036 */ GIM_Try, /*On fail goto*//*Label 33904*/ GIMT_Encode4(2385139),
     /* 2385041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2385044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385052 */   GIM_Try, /*On fail goto*//*Label 33905*/ GIMT_Encode4(2385095), // Rule ID 59138 //
     /* 2385057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2385060 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2385063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2385077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385094 */     // GIR_Coverage, 59138,
     /* 2385094 */     GIR_EraseRootFromParent_Done,
     /* 2385095 */   // Label 33905: @2385095
     /* 2385095 */   GIM_Try, /*On fail goto*//*Label 33906*/ GIMT_Encode4(2385138), // Rule ID 59139 //
     /* 2385100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2385103 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2385106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2385120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385137 */     // GIR_Coverage, 59139,
     /* 2385137 */     GIR_EraseRootFromParent_Done,
     /* 2385138 */   // Label 33906: @2385138
     /* 2385138 */   GIM_Reject,
     /* 2385139 */ // Label 33904: @2385139
     /* 2385139 */ GIM_Reject,
     /* 2385140 */ // Label 33861: @2385140
     /* 2385140 */ GIM_Try, /*On fail goto*//*Label 33907*/ GIMT_Encode4(2385243),
     /* 2385145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2385148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385156 */   GIM_Try, /*On fail goto*//*Label 33908*/ GIMT_Encode4(2385199), // Rule ID 59104 //
     /* 2385161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385164 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2385167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2385181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385198 */     // GIR_Coverage, 59104,
     /* 2385198 */     GIR_EraseRootFromParent_Done,
     /* 2385199 */   // Label 33908: @2385199
     /* 2385199 */   GIM_Try, /*On fail goto*//*Label 33909*/ GIMT_Encode4(2385242), // Rule ID 59105 //
     /* 2385204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2385207 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2385210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2385224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385241 */     // GIR_Coverage, 59105,
     /* 2385241 */     GIR_EraseRootFromParent_Done,
     /* 2385242 */   // Label 33909: @2385242
     /* 2385242 */   GIM_Reject,
     /* 2385243 */ // Label 33907: @2385243
     /* 2385243 */ GIM_Reject,
     /* 2385244 */ // Label 33862: @2385244
     /* 2385244 */ GIM_Try, /*On fail goto*//*Label 33910*/ GIMT_Encode4(2385347),
     /* 2385249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2385252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385260 */   GIM_Try, /*On fail goto*//*Label 33911*/ GIMT_Encode4(2385303), // Rule ID 59114 //
     /* 2385265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385268 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2385271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2385285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385302 */     // GIR_Coverage, 59114,
     /* 2385302 */     GIR_EraseRootFromParent_Done,
     /* 2385303 */   // Label 33911: @2385303
     /* 2385303 */   GIM_Try, /*On fail goto*//*Label 33912*/ GIMT_Encode4(2385346), // Rule ID 59115 //
     /* 2385308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2385311 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2385314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2385328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385345 */     // GIR_Coverage, 59115,
     /* 2385345 */     GIR_EraseRootFromParent_Done,
     /* 2385346 */   // Label 33912: @2385346
     /* 2385346 */   GIM_Reject,
     /* 2385347 */ // Label 33910: @2385347
     /* 2385347 */ GIM_Reject,
     /* 2385348 */ // Label 33863: @2385348
     /* 2385348 */ GIM_Try, /*On fail goto*//*Label 33913*/ GIMT_Encode4(2385451),
     /* 2385353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2385356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385364 */   GIM_Try, /*On fail goto*//*Label 33914*/ GIMT_Encode4(2385407), // Rule ID 59132 //
     /* 2385369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385372 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2385375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2385389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385406 */     // GIR_Coverage, 59132,
     /* 2385406 */     GIR_EraseRootFromParent_Done,
     /* 2385407 */   // Label 33914: @2385407
     /* 2385407 */   GIM_Try, /*On fail goto*//*Label 33915*/ GIMT_Encode4(2385450), // Rule ID 59133 //
     /* 2385412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2385415 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2385418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2385432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385449 */     // GIR_Coverage, 59133,
     /* 2385449 */     GIR_EraseRootFromParent_Done,
     /* 2385450 */   // Label 33915: @2385450
     /* 2385450 */   GIM_Reject,
     /* 2385451 */ // Label 33913: @2385451
     /* 2385451 */ GIM_Reject,
     /* 2385452 */ // Label 33864: @2385452
     /* 2385452 */ GIM_Try, /*On fail goto*//*Label 33916*/ GIMT_Encode4(2385555),
     /* 2385457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2385460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385468 */   GIM_Try, /*On fail goto*//*Label 33917*/ GIMT_Encode4(2385511), // Rule ID 59140 //
     /* 2385473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2385476 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2385479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2385493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385510 */     // GIR_Coverage, 59140,
     /* 2385510 */     GIR_EraseRootFromParent_Done,
     /* 2385511 */   // Label 33917: @2385511
     /* 2385511 */   GIM_Try, /*On fail goto*//*Label 33918*/ GIMT_Encode4(2385554), // Rule ID 59141 //
     /* 2385516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2385519 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2385522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2385536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385553 */     // GIR_Coverage, 59141,
     /* 2385553 */     GIR_EraseRootFromParent_Done,
     /* 2385554 */   // Label 33918: @2385554
     /* 2385554 */   GIM_Reject,
     /* 2385555 */ // Label 33916: @2385555
     /* 2385555 */ GIM_Reject,
     /* 2385556 */ // Label 33865: @2385556
     /* 2385556 */ GIM_Try, /*On fail goto*//*Label 33919*/ GIMT_Encode4(2385659),
     /* 2385561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2385564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385572 */   GIM_Try, /*On fail goto*//*Label 33920*/ GIMT_Encode4(2385615), // Rule ID 59112 //
     /* 2385577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385580 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2385583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2385597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385614 */     // GIR_Coverage, 59112,
     /* 2385614 */     GIR_EraseRootFromParent_Done,
     /* 2385615 */   // Label 33920: @2385615
     /* 2385615 */   GIM_Try, /*On fail goto*//*Label 33921*/ GIMT_Encode4(2385658), // Rule ID 59113 //
     /* 2385620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2385623 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2385626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2385640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385657 */     // GIR_Coverage, 59113,
     /* 2385657 */     GIR_EraseRootFromParent_Done,
     /* 2385658 */   // Label 33921: @2385658
     /* 2385658 */   GIM_Reject,
     /* 2385659 */ // Label 33919: @2385659
     /* 2385659 */ GIM_Reject,
     /* 2385660 */ // Label 33866: @2385660
     /* 2385660 */ GIM_Try, /*On fail goto*//*Label 33922*/ GIMT_Encode4(2385763),
     /* 2385665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2385668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385676 */   GIM_Try, /*On fail goto*//*Label 33923*/ GIMT_Encode4(2385719), // Rule ID 59126 //
     /* 2385681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385684 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2385687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2385701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385718 */     // GIR_Coverage, 59126,
     /* 2385718 */     GIR_EraseRootFromParent_Done,
     /* 2385719 */   // Label 33923: @2385719
     /* 2385719 */   GIM_Try, /*On fail goto*//*Label 33924*/ GIMT_Encode4(2385762), // Rule ID 59127 //
     /* 2385724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2385727 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2385730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2385744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385761 */     // GIR_Coverage, 59127,
     /* 2385761 */     GIR_EraseRootFromParent_Done,
     /* 2385762 */   // Label 33924: @2385762
     /* 2385762 */   GIM_Reject,
     /* 2385763 */ // Label 33922: @2385763
     /* 2385763 */ GIM_Reject,
     /* 2385764 */ // Label 33867: @2385764
     /* 2385764 */ GIM_Try, /*On fail goto*//*Label 33925*/ GIMT_Encode4(2385867),
     /* 2385769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2385772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385780 */   GIM_Try, /*On fail goto*//*Label 33926*/ GIMT_Encode4(2385823), // Rule ID 59134 //
     /* 2385785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385788 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2385791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2385805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385822 */     // GIR_Coverage, 59134,
     /* 2385822 */     GIR_EraseRootFromParent_Done,
     /* 2385823 */   // Label 33926: @2385823
     /* 2385823 */   GIM_Try, /*On fail goto*//*Label 33927*/ GIMT_Encode4(2385866), // Rule ID 59135 //
     /* 2385828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2385831 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2385834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2385848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385865 */     // GIR_Coverage, 59135,
     /* 2385865 */     GIR_EraseRootFromParent_Done,
     /* 2385866 */   // Label 33927: @2385866
     /* 2385866 */   GIM_Reject,
     /* 2385867 */ // Label 33925: @2385867
     /* 2385867 */ GIM_Reject,
     /* 2385868 */ // Label 33868: @2385868
     /* 2385868 */ GIM_Try, /*On fail goto*//*Label 33928*/ GIMT_Encode4(2385971),
     /* 2385873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2385876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385884 */   GIM_Try, /*On fail goto*//*Label 33929*/ GIMT_Encode4(2385927), // Rule ID 59142 //
     /* 2385889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2385892 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2385895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2385909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385926 */     // GIR_Coverage, 59142,
     /* 2385926 */     GIR_EraseRootFromParent_Done,
     /* 2385927 */   // Label 33929: @2385927
     /* 2385927 */   GIM_Try, /*On fail goto*//*Label 33930*/ GIMT_Encode4(2385970), // Rule ID 59143 //
     /* 2385932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2385935 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2385938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2385952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385969 */     // GIR_Coverage, 59143,
     /* 2385969 */     GIR_EraseRootFromParent_Done,
     /* 2385970 */   // Label 33930: @2385970
     /* 2385970 */   GIM_Reject,
     /* 2385971 */ // Label 33928: @2385971
     /* 2385971 */ GIM_Reject,
     /* 2385972 */ // Label 33869: @2385972
     /* 2385972 */ GIM_Try, /*On fail goto*//*Label 33931*/ GIMT_Encode4(2386075),
     /* 2385977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2385980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385988 */   GIM_Try, /*On fail goto*//*Label 33932*/ GIMT_Encode4(2386031), // Rule ID 59120 //
     /* 2385993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385996 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2385999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2386013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386030 */     // GIR_Coverage, 59120,
     /* 2386030 */     GIR_EraseRootFromParent_Done,
     /* 2386031 */   // Label 33932: @2386031
     /* 2386031 */   GIM_Try, /*On fail goto*//*Label 33933*/ GIMT_Encode4(2386074), // Rule ID 59121 //
     /* 2386036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386039 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2386042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2386056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386073 */     // GIR_Coverage, 59121,
     /* 2386073 */     GIR_EraseRootFromParent_Done,
     /* 2386074 */   // Label 33933: @2386074
     /* 2386074 */   GIM_Reject,
     /* 2386075 */ // Label 33931: @2386075
     /* 2386075 */ GIM_Reject,
     /* 2386076 */ // Label 33870: @2386076
     /* 2386076 */ GIM_Try, /*On fail goto*//*Label 33934*/ GIMT_Encode4(2386179),
     /* 2386081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2386084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386092 */   GIM_Try, /*On fail goto*//*Label 33935*/ GIMT_Encode4(2386135), // Rule ID 59128 //
     /* 2386097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2386100 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2386103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2386117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386134 */     // GIR_Coverage, 59128,
     /* 2386134 */     GIR_EraseRootFromParent_Done,
     /* 2386135 */   // Label 33935: @2386135
     /* 2386135 */   GIM_Try, /*On fail goto*//*Label 33936*/ GIMT_Encode4(2386178), // Rule ID 59129 //
     /* 2386140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386143 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2386146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2386160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386177 */     // GIR_Coverage, 59129,
     /* 2386177 */     GIR_EraseRootFromParent_Done,
     /* 2386178 */   // Label 33936: @2386178
     /* 2386178 */   GIM_Reject,
     /* 2386179 */ // Label 33934: @2386179
     /* 2386179 */ GIM_Reject,
     /* 2386180 */ // Label 33871: @2386180
     /* 2386180 */ GIM_Try, /*On fail goto*//*Label 33937*/ GIMT_Encode4(2386283),
     /* 2386185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2386188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386196 */   GIM_Try, /*On fail goto*//*Label 33938*/ GIMT_Encode4(2386239), // Rule ID 59136 //
     /* 2386201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2386204 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2386207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2386221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386238 */     // GIR_Coverage, 59136,
     /* 2386238 */     GIR_EraseRootFromParent_Done,
     /* 2386239 */   // Label 33938: @2386239
     /* 2386239 */   GIM_Try, /*On fail goto*//*Label 33939*/ GIMT_Encode4(2386282), // Rule ID 59137 //
     /* 2386244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386247 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2386250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2386264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386281 */     // GIR_Coverage, 59137,
     /* 2386281 */     GIR_EraseRootFromParent_Done,
     /* 2386282 */   // Label 33939: @2386282
     /* 2386282 */   GIM_Reject,
     /* 2386283 */ // Label 33937: @2386283
     /* 2386283 */ GIM_Reject,
     /* 2386284 */ // Label 33872: @2386284
     /* 2386284 */ GIM_Try, /*On fail goto*//*Label 33940*/ GIMT_Encode4(2386387),
     /* 2386289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2386292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386300 */   GIM_Try, /*On fail goto*//*Label 33941*/ GIMT_Encode4(2386343), // Rule ID 59122 //
     /* 2386305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2386308 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2386311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2386325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386342 */     // GIR_Coverage, 59122,
     /* 2386342 */     GIR_EraseRootFromParent_Done,
     /* 2386343 */   // Label 33941: @2386343
     /* 2386343 */   GIM_Try, /*On fail goto*//*Label 33942*/ GIMT_Encode4(2386386), // Rule ID 59123 //
     /* 2386348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386351 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2386354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2386368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386385 */     // GIR_Coverage, 59123,
     /* 2386385 */     GIR_EraseRootFromParent_Done,
     /* 2386386 */   // Label 33942: @2386386
     /* 2386386 */   GIM_Reject,
     /* 2386387 */ // Label 33940: @2386387
     /* 2386387 */ GIM_Reject,
     /* 2386388 */ // Label 33873: @2386388
     /* 2386388 */ GIM_Try, /*On fail goto*//*Label 33943*/ GIMT_Encode4(2386491),
     /* 2386393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2386396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386404 */   GIM_Try, /*On fail goto*//*Label 33944*/ GIMT_Encode4(2386447), // Rule ID 59130 //
     /* 2386409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2386412 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2386415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2386429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386446 */     // GIR_Coverage, 59130,
     /* 2386446 */     GIR_EraseRootFromParent_Done,
     /* 2386447 */   // Label 33944: @2386447
     /* 2386447 */   GIM_Try, /*On fail goto*//*Label 33945*/ GIMT_Encode4(2386490), // Rule ID 59131 //
     /* 2386452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386455 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2386458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2386472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386489 */     // GIR_Coverage, 59131,
     /* 2386489 */     GIR_EraseRootFromParent_Done,
     /* 2386490 */   // Label 33945: @2386490
     /* 2386490 */   GIM_Reject,
     /* 2386491 */ // Label 33943: @2386491
     /* 2386491 */ GIM_Reject,
     /* 2386492 */ // Label 33874: @2386492
     /* 2386492 */ GIM_Try, /*On fail goto*//*Label 33946*/ GIMT_Encode4(2386595),
     /* 2386497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2386500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386508 */   GIM_Try, /*On fail goto*//*Label 33947*/ GIMT_Encode4(2386551), // Rule ID 59124 //
     /* 2386513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2386516 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2386519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2386533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386550 */     // GIR_Coverage, 59124,
     /* 2386550 */     GIR_EraseRootFromParent_Done,
     /* 2386551 */   // Label 33947: @2386551
     /* 2386551 */   GIM_Try, /*On fail goto*//*Label 33948*/ GIMT_Encode4(2386594), // Rule ID 59125 //
     /* 2386556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386559 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2386562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2386576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386593 */     // GIR_Coverage, 59125,
     /* 2386593 */     GIR_EraseRootFromParent_Done,
     /* 2386594 */   // Label 33948: @2386594
     /* 2386594 */   GIM_Reject,
     /* 2386595 */ // Label 33946: @2386595
     /* 2386595 */ GIM_Reject,
     /* 2386596 */ // Label 33875: @2386596
     /* 2386596 */ GIM_Reject,
     /* 2386597 */ // Label 92: @2386597
     /* 2386597 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33973*/ GIMT_Encode4(2389142),
     /* 2386608 */ /*GILLT_s32*//*Label 33949*/ GIMT_Encode4(2386732),
     /* 2386612 */ /*GILLT_s64*//*Label 33950*/ GIMT_Encode4(2386819), GIMT_Encode4(0),
     /* 2386620 */ /*GILLT_nxv1s8*//*Label 33951*/ GIMT_Encode4(2386854),
     /* 2386624 */ /*GILLT_nxv1s16*//*Label 33952*/ GIMT_Encode4(2386958),
     /* 2386628 */ /*GILLT_nxv1s32*//*Label 33953*/ GIMT_Encode4(2387062),
     /* 2386632 */ /*GILLT_nxv1s64*//*Label 33954*/ GIMT_Encode4(2387166), GIMT_Encode4(0),
     /* 2386640 */ /*GILLT_nxv2s8*//*Label 33955*/ GIMT_Encode4(2387270),
     /* 2386644 */ /*GILLT_nxv2s16*//*Label 33956*/ GIMT_Encode4(2387374),
     /* 2386648 */ /*GILLT_nxv2s32*//*Label 33957*/ GIMT_Encode4(2387478),
     /* 2386652 */ /*GILLT_nxv2s64*//*Label 33958*/ GIMT_Encode4(2387582), GIMT_Encode4(0),
     /* 2386660 */ /*GILLT_nxv4s8*//*Label 33959*/ GIMT_Encode4(2387686),
     /* 2386664 */ /*GILLT_nxv4s16*//*Label 33960*/ GIMT_Encode4(2387790),
     /* 2386668 */ /*GILLT_nxv4s32*//*Label 33961*/ GIMT_Encode4(2387894),
     /* 2386672 */ /*GILLT_nxv4s64*//*Label 33962*/ GIMT_Encode4(2387998), GIMT_Encode4(0),
     /* 2386680 */ /*GILLT_nxv8s8*//*Label 33963*/ GIMT_Encode4(2388102),
     /* 2386684 */ /*GILLT_nxv8s16*//*Label 33964*/ GIMT_Encode4(2388206),
     /* 2386688 */ /*GILLT_nxv8s32*//*Label 33965*/ GIMT_Encode4(2388310),
     /* 2386692 */ /*GILLT_nxv8s64*//*Label 33966*/ GIMT_Encode4(2388414), GIMT_Encode4(0),
     /* 2386700 */ /*GILLT_nxv16s8*//*Label 33967*/ GIMT_Encode4(2388518),
     /* 2386704 */ /*GILLT_nxv16s16*//*Label 33968*/ GIMT_Encode4(2388622),
     /* 2386708 */ /*GILLT_nxv16s32*//*Label 33969*/ GIMT_Encode4(2388726), GIMT_Encode4(0),
     /* 2386716 */ /*GILLT_nxv32s8*//*Label 33970*/ GIMT_Encode4(2388830),
     /* 2386720 */ /*GILLT_nxv32s16*//*Label 33971*/ GIMT_Encode4(2388934), GIMT_Encode4(0),
     /* 2386728 */ /*GILLT_nxv64s8*//*Label 33972*/ GIMT_Encode4(2389038),
     /* 2386732 */ // Label 33949: @2386732
     /* 2386732 */ GIM_Try, /*On fail goto*//*Label 33974*/ GIMT_Encode4(2386818),
     /* 2386737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2386740 */   GIM_Try, /*On fail goto*//*Label 33975*/ GIMT_Encode4(2386771), // Rule ID 64453 //
     /* 2386745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2386748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2386752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2386756 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$rs)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2386756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2386759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2386763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2386766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2386769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386770 */     // GIR_Coverage, 64453,
     /* 2386770 */     GIR_EraseRootFromParent_Done,
     /* 2386771 */   // Label 33975: @2386771
     /* 2386771 */   GIM_Try, /*On fail goto*//*Label 33976*/ GIMT_Encode4(2386794), // Rule ID 64640 //
     /* 2386776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2386779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2386783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2386787 */     // (bitreverse:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)  =>  (QC_BREV32:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)
     /* 2386787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_BREV32),
     /* 2386792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386793 */     // GIR_Coverage, 64640,
     /* 2386793 */     GIR_Done,
     /* 2386794 */   // Label 33976: @2386794
     /* 2386794 */   GIM_Try, /*On fail goto*//*Label 33977*/ GIMT_Encode4(2386817), // Rule ID 64641 //
     /* 2386799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2386802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2386806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2386810 */     // (bitreverse:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)  =>  (QC_BREV32:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)
     /* 2386810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_BREV32),
     /* 2386815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386816 */     // GIR_Coverage, 64641,
     /* 2386816 */     GIR_Done,
     /* 2386817 */   // Label 33977: @2386817
     /* 2386817 */   GIM_Reject,
     /* 2386818 */ // Label 33974: @2386818
     /* 2386818 */ GIM_Reject,
     /* 2386819 */ // Label 33950: @2386819
     /* 2386819 */ GIM_Try, /*On fail goto*//*Label 33978*/ GIMT_Encode4(2386853), // Rule ID 64452 //
     /* 2386824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2386827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2386830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2386834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2386838 */   // (bitreverse:{ *:[i64] } GPR:{ *:[i64] }:$rs)  =>  (CV_BITREV:{ *:[i64] } GPR:{ *:[i64] }:$rs, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2386838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2386841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386843 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2386845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2386848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2386851 */   GIR_RootConstrainSelectedInstOperands,
     /* 2386852 */   // GIR_Coverage, 64452,
     /* 2386852 */   GIR_EraseRootFromParent_Done,
     /* 2386853 */ // Label 33978: @2386853
     /* 2386853 */ GIM_Reject,
     /* 2386854 */ // Label 33951: @2386854
     /* 2386854 */ GIM_Try, /*On fail goto*//*Label 33979*/ GIMT_Encode4(2386957),
     /* 2386859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2386862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386870 */   GIM_Try, /*On fail goto*//*Label 33980*/ GIMT_Encode4(2386913), // Rule ID 58924 //
     /* 2386875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386878 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2386881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2386895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386912 */     // GIR_Coverage, 58924,
     /* 2386912 */     GIR_EraseRootFromParent_Done,
     /* 2386913 */   // Label 33980: @2386913
     /* 2386913 */   GIM_Try, /*On fail goto*//*Label 33981*/ GIMT_Encode4(2386956), // Rule ID 58925 //
     /* 2386918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386921 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2386924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2386938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386955 */     // GIR_Coverage, 58925,
     /* 2386955 */     GIR_EraseRootFromParent_Done,
     /* 2386956 */   // Label 33981: @2386956
     /* 2386956 */   GIM_Reject,
     /* 2386957 */ // Label 33979: @2386957
     /* 2386957 */ GIM_Reject,
     /* 2386958 */ // Label 33952: @2386958
     /* 2386958 */ GIM_Try, /*On fail goto*//*Label 33982*/ GIMT_Encode4(2387061),
     /* 2386963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2386966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386974 */   GIM_Try, /*On fail goto*//*Label 33983*/ GIMT_Encode4(2387017), // Rule ID 59062 //
     /* 2386979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386982 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2386985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2386999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387016 */     // GIR_Coverage, 59062,
     /* 2387016 */     GIR_EraseRootFromParent_Done,
     /* 2387017 */   // Label 33983: @2387017
     /* 2387017 */   GIM_Try, /*On fail goto*//*Label 33984*/ GIMT_Encode4(2387060), // Rule ID 59063 //
     /* 2387022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387025 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2387028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2387042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387059 */     // GIR_Coverage, 59063,
     /* 2387059 */     GIR_EraseRootFromParent_Done,
     /* 2387060 */   // Label 33984: @2387060
     /* 2387060 */   GIM_Reject,
     /* 2387061 */ // Label 33982: @2387061
     /* 2387061 */ GIM_Reject,
     /* 2387062 */ // Label 33953: @2387062
     /* 2387062 */ GIM_Try, /*On fail goto*//*Label 33985*/ GIMT_Encode4(2387165),
     /* 2387067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2387070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387078 */   GIM_Try, /*On fail goto*//*Label 33986*/ GIMT_Encode4(2387121), // Rule ID 59066 //
     /* 2387083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387086 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2387089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2387103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387120 */     // GIR_Coverage, 59066,
     /* 2387120 */     GIR_EraseRootFromParent_Done,
     /* 2387121 */   // Label 33986: @2387121
     /* 2387121 */   GIM_Try, /*On fail goto*//*Label 33987*/ GIMT_Encode4(2387164), // Rule ID 59067 //
     /* 2387126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387129 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2387132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2387146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387163 */     // GIR_Coverage, 59067,
     /* 2387163 */     GIR_EraseRootFromParent_Done,
     /* 2387164 */   // Label 33987: @2387164
     /* 2387164 */   GIM_Reject,
     /* 2387165 */ // Label 33985: @2387165
     /* 2387165 */ GIM_Reject,
     /* 2387166 */ // Label 33954: @2387166
     /* 2387166 */ GIM_Try, /*On fail goto*//*Label 33988*/ GIMT_Encode4(2387269),
     /* 2387171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2387174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387182 */   GIM_Try, /*On fail goto*//*Label 33989*/ GIMT_Encode4(2387225), // Rule ID 59074 //
     /* 2387187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2387190 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2387193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2387207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387224 */     // GIR_Coverage, 59074,
     /* 2387224 */     GIR_EraseRootFromParent_Done,
     /* 2387225 */   // Label 33989: @2387225
     /* 2387225 */   GIM_Try, /*On fail goto*//*Label 33990*/ GIMT_Encode4(2387268), // Rule ID 59075 //
     /* 2387230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2387233 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2387236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2387250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387267 */     // GIR_Coverage, 59075,
     /* 2387267 */     GIR_EraseRootFromParent_Done,
     /* 2387268 */   // Label 33990: @2387268
     /* 2387268 */   GIM_Reject,
     /* 2387269 */ // Label 33988: @2387269
     /* 2387269 */ GIM_Reject,
     /* 2387270 */ // Label 33955: @2387270
     /* 2387270 */ GIM_Try, /*On fail goto*//*Label 33991*/ GIMT_Encode4(2387373),
     /* 2387275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2387278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387286 */   GIM_Try, /*On fail goto*//*Label 33992*/ GIMT_Encode4(2387329), // Rule ID 59058 //
     /* 2387291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387294 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2387297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2387311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387328 */     // GIR_Coverage, 59058,
     /* 2387328 */     GIR_EraseRootFromParent_Done,
     /* 2387329 */   // Label 33992: @2387329
     /* 2387329 */   GIM_Try, /*On fail goto*//*Label 33993*/ GIMT_Encode4(2387372), // Rule ID 59059 //
     /* 2387334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387337 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2387340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2387354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387371 */     // GIR_Coverage, 59059,
     /* 2387371 */     GIR_EraseRootFromParent_Done,
     /* 2387372 */   // Label 33993: @2387372
     /* 2387372 */   GIM_Reject,
     /* 2387373 */ // Label 33991: @2387373
     /* 2387373 */ GIM_Reject,
     /* 2387374 */ // Label 33956: @2387374
     /* 2387374 */ GIM_Try, /*On fail goto*//*Label 33994*/ GIMT_Encode4(2387477),
     /* 2387379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2387382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387390 */   GIM_Try, /*On fail goto*//*Label 33995*/ GIMT_Encode4(2387433), // Rule ID 59064 //
     /* 2387395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387398 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2387401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2387415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387432 */     // GIR_Coverage, 59064,
     /* 2387432 */     GIR_EraseRootFromParent_Done,
     /* 2387433 */   // Label 33995: @2387433
     /* 2387433 */   GIM_Try, /*On fail goto*//*Label 33996*/ GIMT_Encode4(2387476), // Rule ID 59065 //
     /* 2387438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387441 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2387444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2387458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387475 */     // GIR_Coverage, 59065,
     /* 2387475 */     GIR_EraseRootFromParent_Done,
     /* 2387476 */   // Label 33996: @2387476
     /* 2387476 */   GIM_Reject,
     /* 2387477 */ // Label 33994: @2387477
     /* 2387477 */ GIM_Reject,
     /* 2387478 */ // Label 33957: @2387478
     /* 2387478 */ GIM_Try, /*On fail goto*//*Label 33997*/ GIMT_Encode4(2387581),
     /* 2387483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2387486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387494 */   GIM_Try, /*On fail goto*//*Label 33998*/ GIMT_Encode4(2387537), // Rule ID 59072 //
     /* 2387499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387502 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2387505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2387519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387536 */     // GIR_Coverage, 59072,
     /* 2387536 */     GIR_EraseRootFromParent_Done,
     /* 2387537 */   // Label 33998: @2387537
     /* 2387537 */   GIM_Try, /*On fail goto*//*Label 33999*/ GIMT_Encode4(2387580), // Rule ID 59073 //
     /* 2387542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387545 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2387548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2387562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387579 */     // GIR_Coverage, 59073,
     /* 2387579 */     GIR_EraseRootFromParent_Done,
     /* 2387580 */   // Label 33999: @2387580
     /* 2387580 */   GIM_Reject,
     /* 2387581 */ // Label 33997: @2387581
     /* 2387581 */ GIM_Reject,
     /* 2387582 */ // Label 33958: @2387582
     /* 2387582 */ GIM_Try, /*On fail goto*//*Label 34000*/ GIMT_Encode4(2387685),
     /* 2387587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2387590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387598 */   GIM_Try, /*On fail goto*//*Label 34001*/ GIMT_Encode4(2387641), // Rule ID 59094 //
     /* 2387603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2387606 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2387609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2387623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387640 */     // GIR_Coverage, 59094,
     /* 2387640 */     GIR_EraseRootFromParent_Done,
     /* 2387641 */   // Label 34001: @2387641
     /* 2387641 */   GIM_Try, /*On fail goto*//*Label 34002*/ GIMT_Encode4(2387684), // Rule ID 59095 //
     /* 2387646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2387649 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2387652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2387666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387683 */     // GIR_Coverage, 59095,
     /* 2387683 */     GIR_EraseRootFromParent_Done,
     /* 2387684 */   // Label 34002: @2387684
     /* 2387684 */   GIM_Reject,
     /* 2387685 */ // Label 34000: @2387685
     /* 2387685 */ GIM_Reject,
     /* 2387686 */ // Label 33959: @2387686
     /* 2387686 */ GIM_Try, /*On fail goto*//*Label 34003*/ GIMT_Encode4(2387789),
     /* 2387691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2387694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387702 */   GIM_Try, /*On fail goto*//*Label 34004*/ GIMT_Encode4(2387745), // Rule ID 59060 //
     /* 2387707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387710 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2387713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2387727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387744 */     // GIR_Coverage, 59060,
     /* 2387744 */     GIR_EraseRootFromParent_Done,
     /* 2387745 */   // Label 34004: @2387745
     /* 2387745 */   GIM_Try, /*On fail goto*//*Label 34005*/ GIMT_Encode4(2387788), // Rule ID 59061 //
     /* 2387750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387753 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2387756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2387770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387787 */     // GIR_Coverage, 59061,
     /* 2387787 */     GIR_EraseRootFromParent_Done,
     /* 2387788 */   // Label 34005: @2387788
     /* 2387788 */   GIM_Reject,
     /* 2387789 */ // Label 34003: @2387789
     /* 2387789 */ GIM_Reject,
     /* 2387790 */ // Label 33960: @2387790
     /* 2387790 */ GIM_Try, /*On fail goto*//*Label 34006*/ GIMT_Encode4(2387893),
     /* 2387795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2387798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387806 */   GIM_Try, /*On fail goto*//*Label 34007*/ GIMT_Encode4(2387849), // Rule ID 59070 //
     /* 2387811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387814 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2387817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2387831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387848 */     // GIR_Coverage, 59070,
     /* 2387848 */     GIR_EraseRootFromParent_Done,
     /* 2387849 */   // Label 34007: @2387849
     /* 2387849 */   GIM_Try, /*On fail goto*//*Label 34008*/ GIMT_Encode4(2387892), // Rule ID 59071 //
     /* 2387854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387857 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2387860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2387874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387891 */     // GIR_Coverage, 59071,
     /* 2387891 */     GIR_EraseRootFromParent_Done,
     /* 2387892 */   // Label 34008: @2387892
     /* 2387892 */   GIM_Reject,
     /* 2387893 */ // Label 34006: @2387893
     /* 2387893 */ GIM_Reject,
     /* 2387894 */ // Label 33961: @2387894
     /* 2387894 */ GIM_Try, /*On fail goto*//*Label 34009*/ GIMT_Encode4(2387997),
     /* 2387899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2387902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387910 */   GIM_Try, /*On fail goto*//*Label 34010*/ GIMT_Encode4(2387953), // Rule ID 59088 //
     /* 2387915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387918 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2387921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2387935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387952 */     // GIR_Coverage, 59088,
     /* 2387952 */     GIR_EraseRootFromParent_Done,
     /* 2387953 */   // Label 34010: @2387953
     /* 2387953 */   GIM_Try, /*On fail goto*//*Label 34011*/ GIMT_Encode4(2387996), // Rule ID 59089 //
     /* 2387958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387961 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2387964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2387978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387995 */     // GIR_Coverage, 59089,
     /* 2387995 */     GIR_EraseRootFromParent_Done,
     /* 2387996 */   // Label 34011: @2387996
     /* 2387996 */   GIM_Reject,
     /* 2387997 */ // Label 34009: @2387997
     /* 2387997 */ GIM_Reject,
     /* 2387998 */ // Label 33962: @2387998
     /* 2387998 */ GIM_Try, /*On fail goto*//*Label 34012*/ GIMT_Encode4(2388101),
     /* 2388003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2388006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388014 */   GIM_Try, /*On fail goto*//*Label 34013*/ GIMT_Encode4(2388057), // Rule ID 59096 //
     /* 2388019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2388022 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2388025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2388039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388056 */     // GIR_Coverage, 59096,
     /* 2388056 */     GIR_EraseRootFromParent_Done,
     /* 2388057 */   // Label 34013: @2388057
     /* 2388057 */   GIM_Try, /*On fail goto*//*Label 34014*/ GIMT_Encode4(2388100), // Rule ID 59097 //
     /* 2388062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2388065 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2388068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2388082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388099 */     // GIR_Coverage, 59097,
     /* 2388099 */     GIR_EraseRootFromParent_Done,
     /* 2388100 */   // Label 34014: @2388100
     /* 2388100 */   GIM_Reject,
     /* 2388101 */ // Label 34012: @2388101
     /* 2388101 */ GIM_Reject,
     /* 2388102 */ // Label 33963: @2388102
     /* 2388102 */ GIM_Try, /*On fail goto*//*Label 34015*/ GIMT_Encode4(2388205),
     /* 2388107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2388110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388118 */   GIM_Try, /*On fail goto*//*Label 34016*/ GIMT_Encode4(2388161), // Rule ID 59068 //
     /* 2388123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388126 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2388129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2388143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388160 */     // GIR_Coverage, 59068,
     /* 2388160 */     GIR_EraseRootFromParent_Done,
     /* 2388161 */   // Label 34016: @2388161
     /* 2388161 */   GIM_Try, /*On fail goto*//*Label 34017*/ GIMT_Encode4(2388204), // Rule ID 59069 //
     /* 2388166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388169 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2388172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2388186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388203 */     // GIR_Coverage, 59069,
     /* 2388203 */     GIR_EraseRootFromParent_Done,
     /* 2388204 */   // Label 34017: @2388204
     /* 2388204 */   GIM_Reject,
     /* 2388205 */ // Label 34015: @2388205
     /* 2388205 */ GIM_Reject,
     /* 2388206 */ // Label 33964: @2388206
     /* 2388206 */ GIM_Try, /*On fail goto*//*Label 34018*/ GIMT_Encode4(2388309),
     /* 2388211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2388214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388222 */   GIM_Try, /*On fail goto*//*Label 34019*/ GIMT_Encode4(2388265), // Rule ID 59082 //
     /* 2388227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388230 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2388233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2388247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388264 */     // GIR_Coverage, 59082,
     /* 2388264 */     GIR_EraseRootFromParent_Done,
     /* 2388265 */   // Label 34019: @2388265
     /* 2388265 */   GIM_Try, /*On fail goto*//*Label 34020*/ GIMT_Encode4(2388308), // Rule ID 59083 //
     /* 2388270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388273 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2388276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2388290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388307 */     // GIR_Coverage, 59083,
     /* 2388307 */     GIR_EraseRootFromParent_Done,
     /* 2388308 */   // Label 34020: @2388308
     /* 2388308 */   GIM_Reject,
     /* 2388309 */ // Label 34018: @2388309
     /* 2388309 */ GIM_Reject,
     /* 2388310 */ // Label 33965: @2388310
     /* 2388310 */ GIM_Try, /*On fail goto*//*Label 34021*/ GIMT_Encode4(2388413),
     /* 2388315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2388318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388326 */   GIM_Try, /*On fail goto*//*Label 34022*/ GIMT_Encode4(2388369), // Rule ID 59090 //
     /* 2388331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388334 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2388337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2388351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388368 */     // GIR_Coverage, 59090,
     /* 2388368 */     GIR_EraseRootFromParent_Done,
     /* 2388369 */   // Label 34022: @2388369
     /* 2388369 */   GIM_Try, /*On fail goto*//*Label 34023*/ GIMT_Encode4(2388412), // Rule ID 59091 //
     /* 2388374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388377 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2388380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2388394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388411 */     // GIR_Coverage, 59091,
     /* 2388411 */     GIR_EraseRootFromParent_Done,
     /* 2388412 */   // Label 34023: @2388412
     /* 2388412 */   GIM_Reject,
     /* 2388413 */ // Label 34021: @2388413
     /* 2388413 */ GIM_Reject,
     /* 2388414 */ // Label 33966: @2388414
     /* 2388414 */ GIM_Try, /*On fail goto*//*Label 34024*/ GIMT_Encode4(2388517),
     /* 2388419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2388422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388430 */   GIM_Try, /*On fail goto*//*Label 34025*/ GIMT_Encode4(2388473), // Rule ID 59098 //
     /* 2388435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2388438 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2388441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2388455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388472 */     // GIR_Coverage, 59098,
     /* 2388472 */     GIR_EraseRootFromParent_Done,
     /* 2388473 */   // Label 34025: @2388473
     /* 2388473 */   GIM_Try, /*On fail goto*//*Label 34026*/ GIMT_Encode4(2388516), // Rule ID 59099 //
     /* 2388478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2388481 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2388484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2388498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388515 */     // GIR_Coverage, 59099,
     /* 2388515 */     GIR_EraseRootFromParent_Done,
     /* 2388516 */   // Label 34026: @2388516
     /* 2388516 */   GIM_Reject,
     /* 2388517 */ // Label 34024: @2388517
     /* 2388517 */ GIM_Reject,
     /* 2388518 */ // Label 33967: @2388518
     /* 2388518 */ GIM_Try, /*On fail goto*//*Label 34027*/ GIMT_Encode4(2388621),
     /* 2388523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2388526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388534 */   GIM_Try, /*On fail goto*//*Label 34028*/ GIMT_Encode4(2388577), // Rule ID 59076 //
     /* 2388539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388542 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2388545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2388559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388576 */     // GIR_Coverage, 59076,
     /* 2388576 */     GIR_EraseRootFromParent_Done,
     /* 2388577 */   // Label 34028: @2388577
     /* 2388577 */   GIM_Try, /*On fail goto*//*Label 34029*/ GIMT_Encode4(2388620), // Rule ID 59077 //
     /* 2388582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388585 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2388588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2388602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388619 */     // GIR_Coverage, 59077,
     /* 2388619 */     GIR_EraseRootFromParent_Done,
     /* 2388620 */   // Label 34029: @2388620
     /* 2388620 */   GIM_Reject,
     /* 2388621 */ // Label 34027: @2388621
     /* 2388621 */ GIM_Reject,
     /* 2388622 */ // Label 33968: @2388622
     /* 2388622 */ GIM_Try, /*On fail goto*//*Label 34030*/ GIMT_Encode4(2388725),
     /* 2388627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2388630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388638 */   GIM_Try, /*On fail goto*//*Label 34031*/ GIMT_Encode4(2388681), // Rule ID 59084 //
     /* 2388643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388646 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2388649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2388663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388680 */     // GIR_Coverage, 59084,
     /* 2388680 */     GIR_EraseRootFromParent_Done,
     /* 2388681 */   // Label 34031: @2388681
     /* 2388681 */   GIM_Try, /*On fail goto*//*Label 34032*/ GIMT_Encode4(2388724), // Rule ID 59085 //
     /* 2388686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388689 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2388692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2388706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388723 */     // GIR_Coverage, 59085,
     /* 2388723 */     GIR_EraseRootFromParent_Done,
     /* 2388724 */   // Label 34032: @2388724
     /* 2388724 */   GIM_Reject,
     /* 2388725 */ // Label 34030: @2388725
     /* 2388725 */ GIM_Reject,
     /* 2388726 */ // Label 33969: @2388726
     /* 2388726 */ GIM_Try, /*On fail goto*//*Label 34033*/ GIMT_Encode4(2388829),
     /* 2388731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2388734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388742 */   GIM_Try, /*On fail goto*//*Label 34034*/ GIMT_Encode4(2388785), // Rule ID 59092 //
     /* 2388747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388750 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2388753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2388767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388784 */     // GIR_Coverage, 59092,
     /* 2388784 */     GIR_EraseRootFromParent_Done,
     /* 2388785 */   // Label 34034: @2388785
     /* 2388785 */   GIM_Try, /*On fail goto*//*Label 34035*/ GIMT_Encode4(2388828), // Rule ID 59093 //
     /* 2388790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388793 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2388796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2388810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388827 */     // GIR_Coverage, 59093,
     /* 2388827 */     GIR_EraseRootFromParent_Done,
     /* 2388828 */   // Label 34035: @2388828
     /* 2388828 */   GIM_Reject,
     /* 2388829 */ // Label 34033: @2388829
     /* 2388829 */ GIM_Reject,
     /* 2388830 */ // Label 33970: @2388830
     /* 2388830 */ GIM_Try, /*On fail goto*//*Label 34036*/ GIMT_Encode4(2388933),
     /* 2388835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2388838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388846 */   GIM_Try, /*On fail goto*//*Label 34037*/ GIMT_Encode4(2388889), // Rule ID 59078 //
     /* 2388851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388854 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2388857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2388871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388888 */     // GIR_Coverage, 59078,
     /* 2388888 */     GIR_EraseRootFromParent_Done,
     /* 2388889 */   // Label 34037: @2388889
     /* 2388889 */   GIM_Try, /*On fail goto*//*Label 34038*/ GIMT_Encode4(2388932), // Rule ID 59079 //
     /* 2388894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388897 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2388900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2388914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388931 */     // GIR_Coverage, 59079,
     /* 2388931 */     GIR_EraseRootFromParent_Done,
     /* 2388932 */   // Label 34038: @2388932
     /* 2388932 */   GIM_Reject,
     /* 2388933 */ // Label 34036: @2388933
     /* 2388933 */ GIM_Reject,
     /* 2388934 */ // Label 33971: @2388934
     /* 2388934 */ GIM_Try, /*On fail goto*//*Label 34039*/ GIMT_Encode4(2389037),
     /* 2388939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2388942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388950 */   GIM_Try, /*On fail goto*//*Label 34040*/ GIMT_Encode4(2388993), // Rule ID 59086 //
     /* 2388955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388958 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2388961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2388975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388992 */     // GIR_Coverage, 59086,
     /* 2388992 */     GIR_EraseRootFromParent_Done,
     /* 2388993 */   // Label 34040: @2388993
     /* 2388993 */   GIM_Try, /*On fail goto*//*Label 34041*/ GIMT_Encode4(2389036), // Rule ID 59087 //
     /* 2388998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389001 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2389004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2389018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389035 */     // GIR_Coverage, 59087,
     /* 2389035 */     GIR_EraseRootFromParent_Done,
     /* 2389036 */   // Label 34041: @2389036
     /* 2389036 */   GIM_Reject,
     /* 2389037 */ // Label 34039: @2389037
     /* 2389037 */ GIM_Reject,
     /* 2389038 */ // Label 33972: @2389038
     /* 2389038 */ GIM_Try, /*On fail goto*//*Label 34042*/ GIMT_Encode4(2389141),
     /* 2389043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2389046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389054 */   GIM_Try, /*On fail goto*//*Label 34043*/ GIMT_Encode4(2389097), // Rule ID 59080 //
     /* 2389059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389062 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2389065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2389079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389096 */     // GIR_Coverage, 59080,
     /* 2389096 */     GIR_EraseRootFromParent_Done,
     /* 2389097 */   // Label 34043: @2389097
     /* 2389097 */   GIM_Try, /*On fail goto*//*Label 34044*/ GIMT_Encode4(2389140), // Rule ID 59081 //
     /* 2389102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389105 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2389108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2389122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389139 */     // GIR_Coverage, 59081,
     /* 2389139 */     GIR_EraseRootFromParent_Done,
     /* 2389140 */   // Label 34044: @2389140
     /* 2389140 */   GIM_Reject,
     /* 2389141 */ // Label 34042: @2389141
     /* 2389141 */ GIM_Reject,
     /* 2389142 */ // Label 33973: @2389142
     /* 2389142 */ GIM_Reject,
     /* 2389143 */ // Label 93: @2389143
     /* 2389143 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34048*/ GIMT_Encode4(2389340),
     /* 2389154 */ /*GILLT_s16*//*Label 34045*/ GIMT_Encode4(2389166),
     /* 2389158 */ /*GILLT_s32*//*Label 34046*/ GIMT_Encode4(2389224),
     /* 2389162 */ /*GILLT_s64*//*Label 34047*/ GIMT_Encode4(2389282),
     /* 2389166 */ // Label 34045: @2389166
     /* 2389166 */ GIM_Try, /*On fail goto*//*Label 34049*/ GIMT_Encode4(2389223),
     /* 2389171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2389174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2389178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2389182 */   GIM_Try, /*On fail goto*//*Label 34050*/ GIMT_Encode4(2389202), // Rule ID 2432 //
     /* 2389187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2389190 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i64] })
     /* 2389190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2389193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389201 */     // GIR_Coverage, 2432,
     /* 2389201 */     GIR_EraseRootFromParent_Done,
     /* 2389202 */   // Label 34050: @2389202
     /* 2389202 */   GIM_Try, /*On fail goto*//*Label 34051*/ GIMT_Encode4(2389222), // Rule ID 2433 //
     /* 2389207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2389210 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i32] })
     /* 2389210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2389213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389221 */     // GIR_Coverage, 2433,
     /* 2389221 */     GIR_EraseRootFromParent_Done,
     /* 2389222 */   // Label 34051: @2389222
     /* 2389222 */   GIM_Reject,
     /* 2389223 */ // Label 34049: @2389223
     /* 2389223 */ GIM_Reject,
     /* 2389224 */ // Label 34046: @2389224
     /* 2389224 */ GIM_Try, /*On fail goto*//*Label 34052*/ GIMT_Encode4(2389281),
     /* 2389229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2389232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2389236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2389240 */   GIM_Try, /*On fail goto*//*Label 34053*/ GIMT_Encode4(2389260), // Rule ID 2350 //
     /* 2389245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2389248 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i64] })
     /* 2389248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2389251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389259 */     // GIR_Coverage, 2350,
     /* 2389259 */     GIR_EraseRootFromParent_Done,
     /* 2389260 */   // Label 34053: @2389260
     /* 2389260 */   GIM_Try, /*On fail goto*//*Label 34054*/ GIMT_Encode4(2389280), // Rule ID 2351 //
     /* 2389265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2389268 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i32] })
     /* 2389268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2389271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389279 */     // GIR_Coverage, 2351,
     /* 2389279 */     GIR_EraseRootFromParent_Done,
     /* 2389280 */   // Label 34054: @2389280
     /* 2389280 */   GIM_Reject,
     /* 2389281 */ // Label 34052: @2389281
     /* 2389281 */ GIM_Reject,
     /* 2389282 */ // Label 34047: @2389282
     /* 2389282 */ GIM_Try, /*On fail goto*//*Label 34055*/ GIMT_Encode4(2389339),
     /* 2389287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389298 */   GIM_Try, /*On fail goto*//*Label 34056*/ GIMT_Encode4(2389318), // Rule ID 2390 //
     /* 2389303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2389306 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i64] })
     /* 2389306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2389309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389317 */     // GIR_Coverage, 2390,
     /* 2389317 */     GIR_EraseRootFromParent_Done,
     /* 2389318 */   // Label 34056: @2389318
     /* 2389318 */   GIM_Try, /*On fail goto*//*Label 34057*/ GIMT_Encode4(2389338), // Rule ID 2391 //
     /* 2389323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2389326 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i32] })
     /* 2389326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2389329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389337 */     // GIR_Coverage, 2391,
     /* 2389337 */     GIR_EraseRootFromParent_Done,
     /* 2389338 */   // Label 34057: @2389338
     /* 2389338 */   GIM_Reject,
     /* 2389339 */ // Label 34055: @2389339
     /* 2389339 */ GIM_Reject,
     /* 2389340 */ // Label 34048: @2389340
     /* 2389340 */ GIM_Reject,
     /* 2389341 */ // Label 94: @2389341
     /* 2389341 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34076*/ GIMT_Encode4(2391516),
     /* 2389352 */ /*GILLT_s16*//*Label 34058*/ GIMT_Encode4(2389472),
     /* 2389356 */ /*GILLT_s32*//*Label 34059*/ GIMT_Encode4(2389594),
     /* 2389360 */ /*GILLT_s64*//*Label 34060*/ GIMT_Encode4(2389716), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2389372 */ /*GILLT_nxv1s16*//*Label 34061*/ GIMT_Encode4(2389866),
     /* 2389376 */ /*GILLT_nxv1s32*//*Label 34062*/ GIMT_Encode4(2389976),
     /* 2389380 */ /*GILLT_nxv1s64*//*Label 34063*/ GIMT_Encode4(2390086), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2389392 */ /*GILLT_nxv2s16*//*Label 34064*/ GIMT_Encode4(2390196),
     /* 2389396 */ /*GILLT_nxv2s32*//*Label 34065*/ GIMT_Encode4(2390306),
     /* 2389400 */ /*GILLT_nxv2s64*//*Label 34066*/ GIMT_Encode4(2390416), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2389412 */ /*GILLT_nxv4s16*//*Label 34067*/ GIMT_Encode4(2390526),
     /* 2389416 */ /*GILLT_nxv4s32*//*Label 34068*/ GIMT_Encode4(2390636),
     /* 2389420 */ /*GILLT_nxv4s64*//*Label 34069*/ GIMT_Encode4(2390746), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2389432 */ /*GILLT_nxv8s16*//*Label 34070*/ GIMT_Encode4(2390856),
     /* 2389436 */ /*GILLT_nxv8s32*//*Label 34071*/ GIMT_Encode4(2390966),
     /* 2389440 */ /*GILLT_nxv8s64*//*Label 34072*/ GIMT_Encode4(2391076), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2389452 */ /*GILLT_nxv16s16*//*Label 34073*/ GIMT_Encode4(2391186),
     /* 2389456 */ /*GILLT_nxv16s32*//*Label 34074*/ GIMT_Encode4(2391296), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2389468 */ /*GILLT_nxv32s16*//*Label 34075*/ GIMT_Encode4(2391406),
     /* 2389472 */ // Label 34058: @2389472
     /* 2389472 */ GIM_Try, /*On fail goto*//*Label 34077*/ GIMT_Encode4(2389593),
     /* 2389477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2389480 */   GIM_Try, /*On fail goto*//*Label 34078*/ GIMT_Encode4(2389508), // Rule ID 1990 //
     /* 2389485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2389488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2389492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2389496 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2389496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2389499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389507 */     // GIR_Coverage, 1990,
     /* 2389507 */     GIR_EraseRootFromParent_Done,
     /* 2389508 */   // Label 34078: @2389508
     /* 2389508 */   GIM_Try, /*On fail goto*//*Label 34079*/ GIMT_Encode4(2389536), // Rule ID 1991 //
     /* 2389513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2389516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2389520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2389524 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2389524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2389527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389535 */     // GIR_Coverage, 1991,
     /* 2389535 */     GIR_EraseRootFromParent_Done,
     /* 2389536 */   // Label 34079: @2389536
     /* 2389536 */   GIM_Try, /*On fail goto*//*Label 34080*/ GIMT_Encode4(2389564), // Rule ID 2023 //
     /* 2389541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2389544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2389548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2389552 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2389552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2389555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389563 */     // GIR_Coverage, 2023,
     /* 2389563 */     GIR_EraseRootFromParent_Done,
     /* 2389564 */   // Label 34080: @2389564
     /* 2389564 */   GIM_Try, /*On fail goto*//*Label 34081*/ GIMT_Encode4(2389592), // Rule ID 2024 //
     /* 2389569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2389572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2389576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2389580 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2389580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2389583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389591 */     // GIR_Coverage, 2024,
     /* 2389591 */     GIR_EraseRootFromParent_Done,
     /* 2389592 */   // Label 34081: @2389592
     /* 2389592 */   GIM_Reject,
     /* 2389593 */ // Label 34077: @2389593
     /* 2389593 */ GIM_Reject,
     /* 2389594 */ // Label 34059: @2389594
     /* 2389594 */ GIM_Try, /*On fail goto*//*Label 34082*/ GIMT_Encode4(2389715),
     /* 2389599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2389602 */   GIM_Try, /*On fail goto*//*Label 34083*/ GIMT_Encode4(2389630), // Rule ID 1281 //
     /* 2389607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2389610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2389614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2389618 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2389618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2389621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389629 */     // GIR_Coverage, 1281,
     /* 2389629 */     GIR_EraseRootFromParent_Done,
     /* 2389630 */   // Label 34083: @2389630
     /* 2389630 */   GIM_Try, /*On fail goto*//*Label 34084*/ GIMT_Encode4(2389658), // Rule ID 1282 //
     /* 2389635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2389638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2389642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2389646 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2389646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2389649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389657 */     // GIR_Coverage, 1282,
     /* 2389657 */     GIR_EraseRootFromParent_Done,
     /* 2389658 */   // Label 34084: @2389658
     /* 2389658 */   GIM_Try, /*On fail goto*//*Label 34085*/ GIMT_Encode4(2389686), // Rule ID 1289 //
     /* 2389663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2389666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2389670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2389674 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2389674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2389677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389685 */     // GIR_Coverage, 1289,
     /* 2389685 */     GIR_EraseRootFromParent_Done,
     /* 2389686 */   // Label 34085: @2389686
     /* 2389686 */   GIM_Try, /*On fail goto*//*Label 34086*/ GIMT_Encode4(2389714), // Rule ID 1290 //
     /* 2389691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2389694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2389698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2389702 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2389702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2389705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389713 */     // GIR_Coverage, 1290,
     /* 2389713 */     GIR_EraseRootFromParent_Done,
     /* 2389714 */   // Label 34086: @2389714
     /* 2389714 */   GIM_Reject,
     /* 2389715 */ // Label 34082: @2389715
     /* 2389715 */ GIM_Reject,
     /* 2389716 */ // Label 34060: @2389716
     /* 2389716 */ GIM_Try, /*On fail goto*//*Label 34087*/ GIMT_Encode4(2389865),
     /* 2389721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389724 */   GIM_Try, /*On fail goto*//*Label 34088*/ GIMT_Encode4(2389752), // Rule ID 1624 //
     /* 2389729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2389732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389740 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2389740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2389743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389751 */     // GIR_Coverage, 1624,
     /* 2389751 */     GIR_EraseRootFromParent_Done,
     /* 2389752 */   // Label 34088: @2389752
     /* 2389752 */   GIM_Try, /*On fail goto*//*Label 34089*/ GIMT_Encode4(2389780), // Rule ID 1625 //
     /* 2389757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2389760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389768 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2389768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2389771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389779 */     // GIR_Coverage, 1625,
     /* 2389779 */     GIR_EraseRootFromParent_Done,
     /* 2389780 */   // Label 34089: @2389780
     /* 2389780 */   GIM_Try, /*On fail goto*//*Label 34090*/ GIMT_Encode4(2389808), // Rule ID 1658 //
     /* 2389785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2389788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389796 */     // (fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2389796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2389799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389807 */     // GIR_Coverage, 1658,
     /* 2389807 */     GIR_EraseRootFromParent_Done,
     /* 2389808 */   // Label 34090: @2389808
     /* 2389808 */   GIM_Try, /*On fail goto*//*Label 34091*/ GIMT_Encode4(2389836), // Rule ID 1679 //
     /* 2389813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2389816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389824 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2389824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2389827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389835 */     // GIR_Coverage, 1679,
     /* 2389835 */     GIR_EraseRootFromParent_Done,
     /* 2389836 */   // Label 34091: @2389836
     /* 2389836 */   GIM_Try, /*On fail goto*//*Label 34092*/ GIMT_Encode4(2389864), // Rule ID 1680 //
     /* 2389841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2389844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389852 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2389852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2389855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389863 */     // GIR_Coverage, 1680,
     /* 2389863 */     GIR_EraseRootFromParent_Done,
     /* 2389864 */   // Label 34092: @2389864
     /* 2389864 */   GIM_Reject,
     /* 2389865 */ // Label 34087: @2389865
     /* 2389865 */ GIM_Reject,
     /* 2389866 */ // Label 34061: @2389866
     /* 2389866 */ GIM_Try, /*On fail goto*//*Label 34093*/ GIMT_Encode4(2389975),
     /* 2389871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2389874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389882 */   GIM_Try, /*On fail goto*//*Label 34094*/ GIMT_Encode4(2389928), // Rule ID 56242 //
     /* 2389887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2389890 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2389893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2389907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389927 */     // GIR_Coverage, 56242,
     /* 2389927 */     GIR_EraseRootFromParent_Done,
     /* 2389928 */   // Label 34094: @2389928
     /* 2389928 */   GIM_Try, /*On fail goto*//*Label 34095*/ GIMT_Encode4(2389974), // Rule ID 56243 //
     /* 2389933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2389936 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2389939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2389953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389973 */     // GIR_Coverage, 56243,
     /* 2389973 */     GIR_EraseRootFromParent_Done,
     /* 2389974 */   // Label 34095: @2389974
     /* 2389974 */   GIM_Reject,
     /* 2389975 */ // Label 34093: @2389975
     /* 2389975 */ GIM_Reject,
     /* 2389976 */ // Label 34062: @2389976
     /* 2389976 */ GIM_Try, /*On fail goto*//*Label 34096*/ GIMT_Encode4(2390085),
     /* 2389981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2389984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389992 */   GIM_Try, /*On fail goto*//*Label 34097*/ GIMT_Encode4(2390038), // Rule ID 56282 //
     /* 2389997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2390000 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2390003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2390017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390037 */     // GIR_Coverage, 56282,
     /* 2390037 */     GIR_EraseRootFromParent_Done,
     /* 2390038 */   // Label 34097: @2390038
     /* 2390038 */   GIM_Try, /*On fail goto*//*Label 34098*/ GIMT_Encode4(2390084), // Rule ID 56283 //
     /* 2390043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2390046 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2390049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2390063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390083 */     // GIR_Coverage, 56283,
     /* 2390083 */     GIR_EraseRootFromParent_Done,
     /* 2390084 */   // Label 34098: @2390084
     /* 2390084 */   GIM_Reject,
     /* 2390085 */ // Label 34096: @2390085
     /* 2390085 */ GIM_Reject,
     /* 2390086 */ // Label 34063: @2390086
     /* 2390086 */ GIM_Try, /*On fail goto*//*Label 34099*/ GIMT_Encode4(2390195),
     /* 2390091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2390094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390102 */   GIM_Try, /*On fail goto*//*Label 34100*/ GIMT_Encode4(2390148), // Rule ID 56342 //
     /* 2390107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2390110 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2390113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2390127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390147 */     // GIR_Coverage, 56342,
     /* 2390147 */     GIR_EraseRootFromParent_Done,
     /* 2390148 */   // Label 34100: @2390148
     /* 2390148 */   GIM_Try, /*On fail goto*//*Label 34101*/ GIMT_Encode4(2390194), // Rule ID 56343 //
     /* 2390153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2390156 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2390159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2390173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390193 */     // GIR_Coverage, 56343,
     /* 2390193 */     GIR_EraseRootFromParent_Done,
     /* 2390194 */   // Label 34101: @2390194
     /* 2390194 */   GIM_Reject,
     /* 2390195 */ // Label 34099: @2390195
     /* 2390195 */ GIM_Reject,
     /* 2390196 */ // Label 34064: @2390196
     /* 2390196 */ GIM_Try, /*On fail goto*//*Label 34102*/ GIMT_Encode4(2390305),
     /* 2390201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2390204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390212 */   GIM_Try, /*On fail goto*//*Label 34103*/ GIMT_Encode4(2390258), // Rule ID 56262 //
     /* 2390217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2390220 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2390223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2390237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390257 */     // GIR_Coverage, 56262,
     /* 2390257 */     GIR_EraseRootFromParent_Done,
     /* 2390258 */   // Label 34103: @2390258
     /* 2390258 */   GIM_Try, /*On fail goto*//*Label 34104*/ GIMT_Encode4(2390304), // Rule ID 56263 //
     /* 2390263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2390266 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2390269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2390283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390303 */     // GIR_Coverage, 56263,
     /* 2390303 */     GIR_EraseRootFromParent_Done,
     /* 2390304 */   // Label 34104: @2390304
     /* 2390304 */   GIM_Reject,
     /* 2390305 */ // Label 34102: @2390305
     /* 2390305 */ GIM_Reject,
     /* 2390306 */ // Label 34065: @2390306
     /* 2390306 */ GIM_Try, /*On fail goto*//*Label 34105*/ GIMT_Encode4(2390415),
     /* 2390311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2390314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390322 */   GIM_Try, /*On fail goto*//*Label 34106*/ GIMT_Encode4(2390368), // Rule ID 56322 //
     /* 2390327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2390330 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2390333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2390347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390367 */     // GIR_Coverage, 56322,
     /* 2390367 */     GIR_EraseRootFromParent_Done,
     /* 2390368 */   // Label 34106: @2390368
     /* 2390368 */   GIM_Try, /*On fail goto*//*Label 34107*/ GIMT_Encode4(2390414), // Rule ID 56323 //
     /* 2390373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2390376 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2390379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2390393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390413 */     // GIR_Coverage, 56323,
     /* 2390413 */     GIR_EraseRootFromParent_Done,
     /* 2390414 */   // Label 34107: @2390414
     /* 2390414 */   GIM_Reject,
     /* 2390415 */ // Label 34105: @2390415
     /* 2390415 */ GIM_Reject,
     /* 2390416 */ // Label 34066: @2390416
     /* 2390416 */ GIM_Try, /*On fail goto*//*Label 34108*/ GIMT_Encode4(2390525),
     /* 2390421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2390424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390432 */   GIM_Try, /*On fail goto*//*Label 34109*/ GIMT_Encode4(2390478), // Rule ID 56482 //
     /* 2390437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2390440 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2390443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2390457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390477 */     // GIR_Coverage, 56482,
     /* 2390477 */     GIR_EraseRootFromParent_Done,
     /* 2390478 */   // Label 34109: @2390478
     /* 2390478 */   GIM_Try, /*On fail goto*//*Label 34110*/ GIMT_Encode4(2390524), // Rule ID 56483 //
     /* 2390483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2390486 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2390489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2390503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390523 */     // GIR_Coverage, 56483,
     /* 2390523 */     GIR_EraseRootFromParent_Done,
     /* 2390524 */   // Label 34110: @2390524
     /* 2390524 */   GIM_Reject,
     /* 2390525 */ // Label 34108: @2390525
     /* 2390525 */ GIM_Reject,
     /* 2390526 */ // Label 34067: @2390526
     /* 2390526 */ GIM_Try, /*On fail goto*//*Label 34111*/ GIMT_Encode4(2390635),
     /* 2390531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2390534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390542 */   GIM_Try, /*On fail goto*//*Label 34112*/ GIMT_Encode4(2390588), // Rule ID 56302 //
     /* 2390547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2390550 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2390553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2390567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390587 */     // GIR_Coverage, 56302,
     /* 2390587 */     GIR_EraseRootFromParent_Done,
     /* 2390588 */   // Label 34112: @2390588
     /* 2390588 */   GIM_Try, /*On fail goto*//*Label 34113*/ GIMT_Encode4(2390634), // Rule ID 56303 //
     /* 2390593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2390596 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2390599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2390613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390633 */     // GIR_Coverage, 56303,
     /* 2390633 */     GIR_EraseRootFromParent_Done,
     /* 2390634 */   // Label 34113: @2390634
     /* 2390634 */   GIM_Reject,
     /* 2390635 */ // Label 34111: @2390635
     /* 2390635 */ GIM_Reject,
     /* 2390636 */ // Label 34068: @2390636
     /* 2390636 */ GIM_Try, /*On fail goto*//*Label 34114*/ GIMT_Encode4(2390745),
     /* 2390641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2390644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390652 */   GIM_Try, /*On fail goto*//*Label 34115*/ GIMT_Encode4(2390698), // Rule ID 56422 //
     /* 2390657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2390660 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2390663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2390677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390697 */     // GIR_Coverage, 56422,
     /* 2390697 */     GIR_EraseRootFromParent_Done,
     /* 2390698 */   // Label 34115: @2390698
     /* 2390698 */   GIM_Try, /*On fail goto*//*Label 34116*/ GIMT_Encode4(2390744), // Rule ID 56423 //
     /* 2390703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2390706 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2390709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2390723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390743 */     // GIR_Coverage, 56423,
     /* 2390743 */     GIR_EraseRootFromParent_Done,
     /* 2390744 */   // Label 34116: @2390744
     /* 2390744 */   GIM_Reject,
     /* 2390745 */ // Label 34114: @2390745
     /* 2390745 */ GIM_Reject,
     /* 2390746 */ // Label 34069: @2390746
     /* 2390746 */ GIM_Try, /*On fail goto*//*Label 34117*/ GIMT_Encode4(2390855),
     /* 2390751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2390754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390762 */   GIM_Try, /*On fail goto*//*Label 34118*/ GIMT_Encode4(2390808), // Rule ID 56502 //
     /* 2390767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2390770 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2390773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2390787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390807 */     // GIR_Coverage, 56502,
     /* 2390807 */     GIR_EraseRootFromParent_Done,
     /* 2390808 */   // Label 34118: @2390808
     /* 2390808 */   GIM_Try, /*On fail goto*//*Label 34119*/ GIMT_Encode4(2390854), // Rule ID 56503 //
     /* 2390813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2390816 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2390819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2390833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390853 */     // GIR_Coverage, 56503,
     /* 2390853 */     GIR_EraseRootFromParent_Done,
     /* 2390854 */   // Label 34119: @2390854
     /* 2390854 */   GIM_Reject,
     /* 2390855 */ // Label 34117: @2390855
     /* 2390855 */ GIM_Reject,
     /* 2390856 */ // Label 34070: @2390856
     /* 2390856 */ GIM_Try, /*On fail goto*//*Label 34120*/ GIMT_Encode4(2390965),
     /* 2390861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2390864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390872 */   GIM_Try, /*On fail goto*//*Label 34121*/ GIMT_Encode4(2390918), // Rule ID 56362 //
     /* 2390877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2390880 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2390883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2390897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390917 */     // GIR_Coverage, 56362,
     /* 2390917 */     GIR_EraseRootFromParent_Done,
     /* 2390918 */   // Label 34121: @2390918
     /* 2390918 */   GIM_Try, /*On fail goto*//*Label 34122*/ GIMT_Encode4(2390964), // Rule ID 56363 //
     /* 2390923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2390926 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2390929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2390943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390963 */     // GIR_Coverage, 56363,
     /* 2390963 */     GIR_EraseRootFromParent_Done,
     /* 2390964 */   // Label 34122: @2390964
     /* 2390964 */   GIM_Reject,
     /* 2390965 */ // Label 34120: @2390965
     /* 2390965 */ GIM_Reject,
     /* 2390966 */ // Label 34071: @2390966
     /* 2390966 */ GIM_Try, /*On fail goto*//*Label 34123*/ GIMT_Encode4(2391075),
     /* 2390971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2390974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390982 */   GIM_Try, /*On fail goto*//*Label 34124*/ GIMT_Encode4(2391028), // Rule ID 56442 //
     /* 2390987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2390990 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2390993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2391007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391027 */     // GIR_Coverage, 56442,
     /* 2391027 */     GIR_EraseRootFromParent_Done,
     /* 2391028 */   // Label 34124: @2391028
     /* 2391028 */   GIM_Try, /*On fail goto*//*Label 34125*/ GIMT_Encode4(2391074), // Rule ID 56443 //
     /* 2391033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2391036 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2391039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2391053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391073 */     // GIR_Coverage, 56443,
     /* 2391073 */     GIR_EraseRootFromParent_Done,
     /* 2391074 */   // Label 34125: @2391074
     /* 2391074 */   GIM_Reject,
     /* 2391075 */ // Label 34123: @2391075
     /* 2391075 */ GIM_Reject,
     /* 2391076 */ // Label 34072: @2391076
     /* 2391076 */ GIM_Try, /*On fail goto*//*Label 34126*/ GIMT_Encode4(2391185),
     /* 2391081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2391084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391092 */   GIM_Try, /*On fail goto*//*Label 34127*/ GIMT_Encode4(2391138), // Rule ID 56522 //
     /* 2391097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2391100 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2391103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2391117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2391133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391137 */     // GIR_Coverage, 56522,
     /* 2391137 */     GIR_EraseRootFromParent_Done,
     /* 2391138 */   // Label 34127: @2391138
     /* 2391138 */   GIM_Try, /*On fail goto*//*Label 34128*/ GIMT_Encode4(2391184), // Rule ID 56523 //
     /* 2391143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2391146 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2391149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2391163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2391179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391183 */     // GIR_Coverage, 56523,
     /* 2391183 */     GIR_EraseRootFromParent_Done,
     /* 2391184 */   // Label 34128: @2391184
     /* 2391184 */   GIM_Reject,
     /* 2391185 */ // Label 34126: @2391185
     /* 2391185 */ GIM_Reject,
     /* 2391186 */ // Label 34073: @2391186
     /* 2391186 */ GIM_Try, /*On fail goto*//*Label 34129*/ GIMT_Encode4(2391295),
     /* 2391191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2391194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391202 */   GIM_Try, /*On fail goto*//*Label 34130*/ GIMT_Encode4(2391248), // Rule ID 56382 //
     /* 2391207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2391210 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2391213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2391227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391247 */     // GIR_Coverage, 56382,
     /* 2391247 */     GIR_EraseRootFromParent_Done,
     /* 2391248 */   // Label 34130: @2391248
     /* 2391248 */   GIM_Try, /*On fail goto*//*Label 34131*/ GIMT_Encode4(2391294), // Rule ID 56383 //
     /* 2391253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2391256 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2391259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2391273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391293 */     // GIR_Coverage, 56383,
     /* 2391293 */     GIR_EraseRootFromParent_Done,
     /* 2391294 */   // Label 34131: @2391294
     /* 2391294 */   GIM_Reject,
     /* 2391295 */ // Label 34129: @2391295
     /* 2391295 */ GIM_Reject,
     /* 2391296 */ // Label 34074: @2391296
     /* 2391296 */ GIM_Try, /*On fail goto*//*Label 34132*/ GIMT_Encode4(2391405),
     /* 2391301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2391304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391312 */   GIM_Try, /*On fail goto*//*Label 34133*/ GIMT_Encode4(2391358), // Rule ID 56462 //
     /* 2391317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2391320 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2391323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2391337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391357 */     // GIR_Coverage, 56462,
     /* 2391357 */     GIR_EraseRootFromParent_Done,
     /* 2391358 */   // Label 34133: @2391358
     /* 2391358 */   GIM_Try, /*On fail goto*//*Label 34134*/ GIMT_Encode4(2391404), // Rule ID 56463 //
     /* 2391363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2391366 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2391369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2391383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391403 */     // GIR_Coverage, 56463,
     /* 2391403 */     GIR_EraseRootFromParent_Done,
     /* 2391404 */   // Label 34134: @2391404
     /* 2391404 */   GIM_Reject,
     /* 2391405 */ // Label 34132: @2391405
     /* 2391405 */ GIM_Reject,
     /* 2391406 */ // Label 34075: @2391406
     /* 2391406 */ GIM_Try, /*On fail goto*//*Label 34135*/ GIMT_Encode4(2391515),
     /* 2391411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2391414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391422 */   GIM_Try, /*On fail goto*//*Label 34136*/ GIMT_Encode4(2391468), // Rule ID 56402 //
     /* 2391427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2391430 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2391433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2391447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391467 */     // GIR_Coverage, 56402,
     /* 2391467 */     GIR_EraseRootFromParent_Done,
     /* 2391468 */   // Label 34136: @2391468
     /* 2391468 */   GIM_Try, /*On fail goto*//*Label 34137*/ GIMT_Encode4(2391514), // Rule ID 56403 //
     /* 2391473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2391476 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2391479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2391493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391513 */     // GIR_Coverage, 56403,
     /* 2391513 */     GIR_EraseRootFromParent_Done,
     /* 2391514 */   // Label 34137: @2391514
     /* 2391514 */   GIM_Reject,
     /* 2391515 */ // Label 34135: @2391515
     /* 2391515 */ GIM_Reject,
     /* 2391516 */ // Label 34076: @2391516
     /* 2391516 */ GIM_Reject,
     /* 2391517 */ // Label 95: @2391517
     /* 2391517 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34141*/ GIMT_Encode4(2391714),
     /* 2391528 */ /*GILLT_s16*//*Label 34138*/ GIMT_Encode4(2391540),
     /* 2391532 */ /*GILLT_s32*//*Label 34139*/ GIMT_Encode4(2391598),
     /* 2391536 */ /*GILLT_s64*//*Label 34140*/ GIMT_Encode4(2391656),
     /* 2391540 */ // Label 34138: @2391540
     /* 2391540 */ GIM_Try, /*On fail goto*//*Label 34142*/ GIMT_Encode4(2391597),
     /* 2391545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391556 */   GIM_Try, /*On fail goto*//*Label 34143*/ GIMT_Encode4(2391576), // Rule ID 2428 //
     /* 2391561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2391564 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i64] })
     /* 2391564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2391567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2391574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391575 */     // GIR_Coverage, 2428,
     /* 2391575 */     GIR_EraseRootFromParent_Done,
     /* 2391576 */   // Label 34143: @2391576
     /* 2391576 */   GIM_Try, /*On fail goto*//*Label 34144*/ GIMT_Encode4(2391596), // Rule ID 2429 //
     /* 2391581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2391584 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i32] })
     /* 2391584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2391587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2391594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391595 */     // GIR_Coverage, 2429,
     /* 2391595 */     GIR_EraseRootFromParent_Done,
     /* 2391596 */   // Label 34144: @2391596
     /* 2391596 */   GIM_Reject,
     /* 2391597 */ // Label 34142: @2391597
     /* 2391597 */ GIM_Reject,
     /* 2391598 */ // Label 34139: @2391598
     /* 2391598 */ GIM_Try, /*On fail goto*//*Label 34145*/ GIMT_Encode4(2391655),
     /* 2391603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391614 */   GIM_Try, /*On fail goto*//*Label 34146*/ GIMT_Encode4(2391634), // Rule ID 2346 //
     /* 2391619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2391622 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i64] })
     /* 2391622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2391625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2391632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391633 */     // GIR_Coverage, 2346,
     /* 2391633 */     GIR_EraseRootFromParent_Done,
     /* 2391634 */   // Label 34146: @2391634
     /* 2391634 */   GIM_Try, /*On fail goto*//*Label 34147*/ GIMT_Encode4(2391654), // Rule ID 2347 //
     /* 2391639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2391642 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i32] })
     /* 2391642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2391645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2391652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391653 */     // GIR_Coverage, 2347,
     /* 2391653 */     GIR_EraseRootFromParent_Done,
     /* 2391654 */   // Label 34147: @2391654
     /* 2391654 */   GIM_Reject,
     /* 2391655 */ // Label 34145: @2391655
     /* 2391655 */ GIM_Reject,
     /* 2391656 */ // Label 34140: @2391656
     /* 2391656 */ GIM_Try, /*On fail goto*//*Label 34148*/ GIMT_Encode4(2391713),
     /* 2391661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2391664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391672 */   GIM_Try, /*On fail goto*//*Label 34149*/ GIMT_Encode4(2391692), // Rule ID 2386 //
     /* 2391677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2391680 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i64] })
     /* 2391680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2391683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2391690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391691 */     // GIR_Coverage, 2386,
     /* 2391691 */     GIR_EraseRootFromParent_Done,
     /* 2391692 */   // Label 34149: @2391692
     /* 2391692 */   GIM_Try, /*On fail goto*//*Label 34150*/ GIMT_Encode4(2391712), // Rule ID 2387 //
     /* 2391697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2391700 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i32] })
     /* 2391700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2391703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2391710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391711 */     // GIR_Coverage, 2387,
     /* 2391711 */     GIR_EraseRootFromParent_Done,
     /* 2391712 */   // Label 34150: @2391712
     /* 2391712 */   GIM_Reject,
     /* 2391713 */ // Label 34148: @2391713
     /* 2391713 */ GIM_Reject,
     /* 2391714 */ // Label 34141: @2391714
     /* 2391714 */ GIM_Reject,
     /* 2391715 */ // Label 96: @2391715
     /* 2391715 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34154*/ GIMT_Encode4(2391912),
     /* 2391726 */ /*GILLT_s16*//*Label 34151*/ GIMT_Encode4(2391738),
     /* 2391730 */ /*GILLT_s32*//*Label 34152*/ GIMT_Encode4(2391796),
     /* 2391734 */ /*GILLT_s64*//*Label 34153*/ GIMT_Encode4(2391854),
     /* 2391738 */ // Label 34151: @2391738
     /* 2391738 */ GIM_Try, /*On fail goto*//*Label 34155*/ GIMT_Encode4(2391795),
     /* 2391743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391754 */   GIM_Try, /*On fail goto*//*Label 34156*/ GIMT_Encode4(2391774), // Rule ID 2412 //
     /* 2391759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2391762 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2391762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2391765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391773 */     // GIR_Coverage, 2412,
     /* 2391773 */     GIR_EraseRootFromParent_Done,
     /* 2391774 */   // Label 34156: @2391774
     /* 2391774 */   GIM_Try, /*On fail goto*//*Label 34157*/ GIMT_Encode4(2391794), // Rule ID 2413 //
     /* 2391779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2391782 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2391782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2391785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391793 */     // GIR_Coverage, 2413,
     /* 2391793 */     GIR_EraseRootFromParent_Done,
     /* 2391794 */   // Label 34157: @2391794
     /* 2391794 */   GIM_Reject,
     /* 2391795 */ // Label 34155: @2391795
     /* 2391795 */ GIM_Reject,
     /* 2391796 */ // Label 34152: @2391796
     /* 2391796 */ GIM_Try, /*On fail goto*//*Label 34158*/ GIMT_Encode4(2391853),
     /* 2391801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391812 */   GIM_Try, /*On fail goto*//*Label 34159*/ GIMT_Encode4(2391832), // Rule ID 2330 //
     /* 2391817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2391820 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2391820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2391823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391831 */     // GIR_Coverage, 2330,
     /* 2391831 */     GIR_EraseRootFromParent_Done,
     /* 2391832 */   // Label 34159: @2391832
     /* 2391832 */   GIM_Try, /*On fail goto*//*Label 34160*/ GIMT_Encode4(2391852), // Rule ID 2331 //
     /* 2391837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2391840 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2391840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2391843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391851 */     // GIR_Coverage, 2331,
     /* 2391851 */     GIR_EraseRootFromParent_Done,
     /* 2391852 */   // Label 34160: @2391852
     /* 2391852 */   GIM_Reject,
     /* 2391853 */ // Label 34158: @2391853
     /* 2391853 */ GIM_Reject,
     /* 2391854 */ // Label 34153: @2391854
     /* 2391854 */ GIM_Try, /*On fail goto*//*Label 34161*/ GIMT_Encode4(2391911),
     /* 2391859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2391862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391870 */   GIM_Try, /*On fail goto*//*Label 34162*/ GIMT_Encode4(2391890), // Rule ID 2370 //
     /* 2391875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2391878 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2391878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2391881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391889 */     // GIR_Coverage, 2370,
     /* 2391889 */     GIR_EraseRootFromParent_Done,
     /* 2391890 */   // Label 34162: @2391890
     /* 2391890 */   GIM_Try, /*On fail goto*//*Label 34163*/ GIMT_Encode4(2391910), // Rule ID 2371 //
     /* 2391895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2391898 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2391898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2391901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391909 */     // GIR_Coverage, 2371,
     /* 2391909 */     GIR_EraseRootFromParent_Done,
     /* 2391910 */   // Label 34163: @2391910
     /* 2391910 */   GIM_Reject,
     /* 2391911 */ // Label 34161: @2391911
     /* 2391911 */ GIM_Reject,
     /* 2391912 */ // Label 34154: @2391912
     /* 2391912 */ GIM_Reject,
     /* 2391913 */ // Label 97: @2391913
     /* 2391913 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34167*/ GIMT_Encode4(2392110),
     /* 2391924 */ /*GILLT_s16*//*Label 34164*/ GIMT_Encode4(2391936),
     /* 2391928 */ /*GILLT_s32*//*Label 34165*/ GIMT_Encode4(2391994),
     /* 2391932 */ /*GILLT_s64*//*Label 34166*/ GIMT_Encode4(2392052),
     /* 2391936 */ // Label 34164: @2391936
     /* 2391936 */ GIM_Try, /*On fail goto*//*Label 34168*/ GIMT_Encode4(2391993),
     /* 2391941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391952 */   GIM_Try, /*On fail goto*//*Label 34169*/ GIMT_Encode4(2391972), // Rule ID 2416 //
     /* 2391957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2391960 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2391960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2391963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391971 */     // GIR_Coverage, 2416,
     /* 2391971 */     GIR_EraseRootFromParent_Done,
     /* 2391972 */   // Label 34169: @2391972
     /* 2391972 */   GIM_Try, /*On fail goto*//*Label 34170*/ GIMT_Encode4(2391992), // Rule ID 2417 //
     /* 2391977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2391980 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2391980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2391983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391991 */     // GIR_Coverage, 2417,
     /* 2391991 */     GIR_EraseRootFromParent_Done,
     /* 2391992 */   // Label 34170: @2391992
     /* 2391992 */   GIM_Reject,
     /* 2391993 */ // Label 34168: @2391993
     /* 2391993 */ GIM_Reject,
     /* 2391994 */ // Label 34165: @2391994
     /* 2391994 */ GIM_Try, /*On fail goto*//*Label 34171*/ GIMT_Encode4(2392051),
     /* 2391999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392010 */   GIM_Try, /*On fail goto*//*Label 34172*/ GIMT_Encode4(2392030), // Rule ID 2334 //
     /* 2392015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2392018 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2392018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2392021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392029 */     // GIR_Coverage, 2334,
     /* 2392029 */     GIR_EraseRootFromParent_Done,
     /* 2392030 */   // Label 34172: @2392030
     /* 2392030 */   GIM_Try, /*On fail goto*//*Label 34173*/ GIMT_Encode4(2392050), // Rule ID 2335 //
     /* 2392035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2392038 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2392038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2392041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392049 */     // GIR_Coverage, 2335,
     /* 2392049 */     GIR_EraseRootFromParent_Done,
     /* 2392050 */   // Label 34173: @2392050
     /* 2392050 */   GIM_Reject,
     /* 2392051 */ // Label 34171: @2392051
     /* 2392051 */ GIM_Reject,
     /* 2392052 */ // Label 34166: @2392052
     /* 2392052 */ GIM_Try, /*On fail goto*//*Label 34174*/ GIMT_Encode4(2392109),
     /* 2392057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2392060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392068 */   GIM_Try, /*On fail goto*//*Label 34175*/ GIMT_Encode4(2392088), // Rule ID 2374 //
     /* 2392073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2392076 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2392076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2392079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392087 */     // GIR_Coverage, 2374,
     /* 2392087 */     GIR_EraseRootFromParent_Done,
     /* 2392088 */   // Label 34175: @2392088
     /* 2392088 */   GIM_Try, /*On fail goto*//*Label 34176*/ GIMT_Encode4(2392108), // Rule ID 2375 //
     /* 2392093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2392096 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2392096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2392099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392107 */     // GIR_Coverage, 2375,
     /* 2392107 */     GIR_EraseRootFromParent_Done,
     /* 2392108 */   // Label 34176: @2392108
     /* 2392108 */   GIM_Reject,
     /* 2392109 */ // Label 34174: @2392109
     /* 2392109 */ GIM_Reject,
     /* 2392110 */ // Label 34167: @2392110
     /* 2392110 */ GIM_Reject,
     /* 2392111 */ // Label 98: @2392111
     /* 2392111 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34195*/ GIMT_Encode4(2394538),
     /* 2392122 */ /*GILLT_s16*//*Label 34177*/ GIMT_Encode4(2392242),
     /* 2392126 */ /*GILLT_s32*//*Label 34178*/ GIMT_Encode4(2392391),
     /* 2392130 */ /*GILLT_s64*//*Label 34179*/ GIMT_Encode4(2392540), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2392142 */ /*GILLT_nxv1s16*//*Label 34180*/ GIMT_Encode4(2392723),
     /* 2392146 */ /*GILLT_nxv1s32*//*Label 34181*/ GIMT_Encode4(2392844),
     /* 2392150 */ /*GILLT_nxv1s64*//*Label 34182*/ GIMT_Encode4(2392965), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2392162 */ /*GILLT_nxv2s16*//*Label 34183*/ GIMT_Encode4(2393086),
     /* 2392166 */ /*GILLT_nxv2s32*//*Label 34184*/ GIMT_Encode4(2393207),
     /* 2392170 */ /*GILLT_nxv2s64*//*Label 34185*/ GIMT_Encode4(2393328), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2392182 */ /*GILLT_nxv4s16*//*Label 34186*/ GIMT_Encode4(2393449),
     /* 2392186 */ /*GILLT_nxv4s32*//*Label 34187*/ GIMT_Encode4(2393570),
     /* 2392190 */ /*GILLT_nxv4s64*//*Label 34188*/ GIMT_Encode4(2393691), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2392202 */ /*GILLT_nxv8s16*//*Label 34189*/ GIMT_Encode4(2393812),
     /* 2392206 */ /*GILLT_nxv8s32*//*Label 34190*/ GIMT_Encode4(2393933),
     /* 2392210 */ /*GILLT_nxv8s64*//*Label 34191*/ GIMT_Encode4(2394054), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2392222 */ /*GILLT_nxv16s16*//*Label 34192*/ GIMT_Encode4(2394175),
     /* 2392226 */ /*GILLT_nxv16s32*//*Label 34193*/ GIMT_Encode4(2394296), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2392238 */ /*GILLT_nxv32s16*//*Label 34194*/ GIMT_Encode4(2394417),
     /* 2392242 */ // Label 34177: @2392242
     /* 2392242 */ GIM_Try, /*On fail goto*//*Label 34196*/ GIMT_Encode4(2392390),
     /* 2392247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2392250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2392253 */   GIM_Try, /*On fail goto*//*Label 34197*/ GIMT_Encode4(2392287), // Rule ID 1956 //
     /* 2392258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2392261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2392265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2392269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2392273 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2392273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2392276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392286 */     // GIR_Coverage, 1956,
     /* 2392286 */     GIR_EraseRootFromParent_Done,
     /* 2392287 */   // Label 34197: @2392287
     /* 2392287 */   GIM_Try, /*On fail goto*//*Label 34198*/ GIMT_Encode4(2392321), // Rule ID 1957 //
     /* 2392292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2392295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2392299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2392303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2392307 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2392307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2392310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392320 */     // GIR_Coverage, 1957,
     /* 2392320 */     GIR_EraseRootFromParent_Done,
     /* 2392321 */   // Label 34198: @2392321
     /* 2392321 */   GIM_Try, /*On fail goto*//*Label 34199*/ GIMT_Encode4(2392355), // Rule ID 1960 //
     /* 2392326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2392329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2392333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2392337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2392341 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2392341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2392344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392354 */     // GIR_Coverage, 1960,
     /* 2392354 */     GIR_EraseRootFromParent_Done,
     /* 2392355 */   // Label 34199: @2392355
     /* 2392355 */   GIM_Try, /*On fail goto*//*Label 34200*/ GIMT_Encode4(2392389), // Rule ID 1961 //
     /* 2392360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2392363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2392367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2392371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2392375 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2392375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2392378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392388 */     // GIR_Coverage, 1961,
     /* 2392388 */     GIR_EraseRootFromParent_Done,
     /* 2392389 */   // Label 34200: @2392389
     /* 2392389 */   GIM_Reject,
     /* 2392390 */ // Label 34196: @2392390
     /* 2392390 */ GIM_Reject,
     /* 2392391 */ // Label 34178: @2392391
     /* 2392391 */ GIM_Try, /*On fail goto*//*Label 34201*/ GIMT_Encode4(2392539),
     /* 2392396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2392402 */   GIM_Try, /*On fail goto*//*Label 34202*/ GIMT_Encode4(2392436), // Rule ID 1247 //
     /* 2392407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2392410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392422 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2392422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2392425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392435 */     // GIR_Coverage, 1247,
     /* 2392435 */     GIR_EraseRootFromParent_Done,
     /* 2392436 */   // Label 34202: @2392436
     /* 2392436 */   GIM_Try, /*On fail goto*//*Label 34203*/ GIMT_Encode4(2392470), // Rule ID 1248 //
     /* 2392441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2392444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392456 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2392456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2392459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392469 */     // GIR_Coverage, 1248,
     /* 2392469 */     GIR_EraseRootFromParent_Done,
     /* 2392470 */   // Label 34203: @2392470
     /* 2392470 */   GIM_Try, /*On fail goto*//*Label 34204*/ GIMT_Encode4(2392504), // Rule ID 1251 //
     /* 2392475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2392478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392490 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2392490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2392493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392503 */     // GIR_Coverage, 1251,
     /* 2392503 */     GIR_EraseRootFromParent_Done,
     /* 2392504 */   // Label 34204: @2392504
     /* 2392504 */   GIM_Try, /*On fail goto*//*Label 34205*/ GIMT_Encode4(2392538), // Rule ID 1252 //
     /* 2392509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2392512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392524 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2392524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2392527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392537 */     // GIR_Coverage, 1252,
     /* 2392537 */     GIR_EraseRootFromParent_Done,
     /* 2392538 */   // Label 34205: @2392538
     /* 2392538 */   GIM_Reject,
     /* 2392539 */ // Label 34201: @2392539
     /* 2392539 */ GIM_Reject,
     /* 2392540 */ // Label 34179: @2392540
     /* 2392540 */ GIM_Try, /*On fail goto*//*Label 34206*/ GIMT_Encode4(2392722),
     /* 2392545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2392548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2392551 */   GIM_Try, /*On fail goto*//*Label 34207*/ GIMT_Encode4(2392585), // Rule ID 1582 //
     /* 2392556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2392559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392571 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2392571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2392574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392584 */     // GIR_Coverage, 1582,
     /* 2392584 */     GIR_EraseRootFromParent_Done,
     /* 2392585 */   // Label 34207: @2392585
     /* 2392585 */   GIM_Try, /*On fail goto*//*Label 34208*/ GIMT_Encode4(2392619), // Rule ID 1583 //
     /* 2392590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2392593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392605 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2392605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2392608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392618 */     // GIR_Coverage, 1583,
     /* 2392618 */     GIR_EraseRootFromParent_Done,
     /* 2392619 */   // Label 34208: @2392619
     /* 2392619 */   GIM_Try, /*On fail goto*//*Label 34209*/ GIMT_Encode4(2392653), // Rule ID 1586 //
     /* 2392624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2392627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2392631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2392635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2392639 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2392639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2392642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392652 */     // GIR_Coverage, 1586,
     /* 2392652 */     GIR_EraseRootFromParent_Done,
     /* 2392653 */   // Label 34209: @2392653
     /* 2392653 */   GIM_Try, /*On fail goto*//*Label 34210*/ GIMT_Encode4(2392687), // Rule ID 1587 //
     /* 2392658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2392661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2392665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2392669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2392673 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2392673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2392676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392686 */     // GIR_Coverage, 1587,
     /* 2392686 */     GIR_EraseRootFromParent_Done,
     /* 2392687 */   // Label 34210: @2392687
     /* 2392687 */   GIM_Try, /*On fail goto*//*Label 34211*/ GIMT_Encode4(2392721), // Rule ID 1590 //
     /* 2392692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2392695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392707 */     // (strict_fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2392707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2392710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392720 */     // GIR_Coverage, 1590,
     /* 2392720 */     GIR_EraseRootFromParent_Done,
     /* 2392721 */   // Label 34211: @2392721
     /* 2392721 */   GIM_Reject,
     /* 2392722 */ // Label 34206: @2392722
     /* 2392722 */ GIM_Reject,
     /* 2392723 */ // Label 34180: @2392723
     /* 2392723 */ GIM_Try, /*On fail goto*//*Label 34212*/ GIMT_Encode4(2392843),
     /* 2392728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2392731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2392734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392746 */   GIM_Try, /*On fail goto*//*Label 34213*/ GIMT_Encode4(2392794), // Rule ID 45762 //
     /* 2392751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2392754 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2392757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2392771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392793 */     // GIR_Coverage, 45762,
     /* 2392793 */     GIR_EraseRootFromParent_Done,
     /* 2392794 */   // Label 34213: @2392794
     /* 2392794 */   GIM_Try, /*On fail goto*//*Label 34214*/ GIMT_Encode4(2392842), // Rule ID 45763 //
     /* 2392799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2392802 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2392805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2392819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392841 */     // GIR_Coverage, 45763,
     /* 2392841 */     GIR_EraseRootFromParent_Done,
     /* 2392842 */   // Label 34214: @2392842
     /* 2392842 */   GIM_Reject,
     /* 2392843 */ // Label 34212: @2392843
     /* 2392843 */ GIM_Reject,
     /* 2392844 */ // Label 34181: @2392844
     /* 2392844 */ GIM_Try, /*On fail goto*//*Label 34215*/ GIMT_Encode4(2392964),
     /* 2392849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2392852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2392855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392867 */   GIM_Try, /*On fail goto*//*Label 34216*/ GIMT_Encode4(2392915), // Rule ID 53302 //
     /* 2392872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2392875 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2392878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2392892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392914 */     // GIR_Coverage, 53302,
     /* 2392914 */     GIR_EraseRootFromParent_Done,
     /* 2392915 */   // Label 34216: @2392915
     /* 2392915 */   GIM_Try, /*On fail goto*//*Label 34217*/ GIMT_Encode4(2392963), // Rule ID 53303 //
     /* 2392920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2392923 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2392926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2392940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392962 */     // GIR_Coverage, 53303,
     /* 2392962 */     GIR_EraseRootFromParent_Done,
     /* 2392963 */   // Label 34217: @2392963
     /* 2392963 */   GIM_Reject,
     /* 2392964 */ // Label 34215: @2392964
     /* 2392964 */ GIM_Reject,
     /* 2392965 */ // Label 34182: @2392965
     /* 2392965 */ GIM_Try, /*On fail goto*//*Label 34218*/ GIMT_Encode4(2393085),
     /* 2392970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2392976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392988 */   GIM_Try, /*On fail goto*//*Label 34219*/ GIMT_Encode4(2393036), // Rule ID 53338 //
     /* 2392993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2392996 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2392999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2393013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393035 */     // GIR_Coverage, 53338,
     /* 2393035 */     GIR_EraseRootFromParent_Done,
     /* 2393036 */   // Label 34219: @2393036
     /* 2393036 */   GIM_Try, /*On fail goto*//*Label 34220*/ GIMT_Encode4(2393084), // Rule ID 53339 //
     /* 2393041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2393044 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2393047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2393061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393083 */     // GIR_Coverage, 53339,
     /* 2393083 */     GIR_EraseRootFromParent_Done,
     /* 2393084 */   // Label 34220: @2393084
     /* 2393084 */   GIM_Reject,
     /* 2393085 */ // Label 34218: @2393085
     /* 2393085 */ GIM_Reject,
     /* 2393086 */ // Label 34183: @2393086
     /* 2393086 */ GIM_Try, /*On fail goto*//*Label 34221*/ GIMT_Encode4(2393206),
     /* 2393091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2393097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393109 */   GIM_Try, /*On fail goto*//*Label 34222*/ GIMT_Encode4(2393157), // Rule ID 53290 //
     /* 2393114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393117 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2393120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2393134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393156 */     // GIR_Coverage, 53290,
     /* 2393156 */     GIR_EraseRootFromParent_Done,
     /* 2393157 */   // Label 34222: @2393157
     /* 2393157 */   GIM_Try, /*On fail goto*//*Label 34223*/ GIMT_Encode4(2393205), // Rule ID 53291 //
     /* 2393162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393165 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2393168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2393182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393204 */     // GIR_Coverage, 53291,
     /* 2393204 */     GIR_EraseRootFromParent_Done,
     /* 2393205 */   // Label 34223: @2393205
     /* 2393205 */   GIM_Reject,
     /* 2393206 */ // Label 34221: @2393206
     /* 2393206 */ GIM_Reject,
     /* 2393207 */ // Label 34184: @2393207
     /* 2393207 */ GIM_Try, /*On fail goto*//*Label 34224*/ GIMT_Encode4(2393327),
     /* 2393212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2393215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2393218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393230 */   GIM_Try, /*On fail goto*//*Label 34225*/ GIMT_Encode4(2393278), // Rule ID 53326 //
     /* 2393235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2393238 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2393241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2393255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393277 */     // GIR_Coverage, 53326,
     /* 2393277 */     GIR_EraseRootFromParent_Done,
     /* 2393278 */   // Label 34225: @2393278
     /* 2393278 */   GIM_Try, /*On fail goto*//*Label 34226*/ GIMT_Encode4(2393326), // Rule ID 53327 //
     /* 2393283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2393286 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2393289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2393303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393325 */     // GIR_Coverage, 53327,
     /* 2393325 */     GIR_EraseRootFromParent_Done,
     /* 2393326 */   // Label 34226: @2393326
     /* 2393326 */   GIM_Reject,
     /* 2393327 */ // Label 34224: @2393327
     /* 2393327 */ GIM_Reject,
     /* 2393328 */ // Label 34185: @2393328
     /* 2393328 */ GIM_Try, /*On fail goto*//*Label 34227*/ GIMT_Encode4(2393448),
     /* 2393333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2393336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2393339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393351 */   GIM_Try, /*On fail goto*//*Label 34228*/ GIMT_Encode4(2393399), // Rule ID 53422 //
     /* 2393356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2393359 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2393362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2393376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393398 */     // GIR_Coverage, 53422,
     /* 2393398 */     GIR_EraseRootFromParent_Done,
     /* 2393399 */   // Label 34228: @2393399
     /* 2393399 */   GIM_Try, /*On fail goto*//*Label 34229*/ GIMT_Encode4(2393447), // Rule ID 53423 //
     /* 2393404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2393407 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2393410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2393424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393446 */     // GIR_Coverage, 53423,
     /* 2393446 */     GIR_EraseRootFromParent_Done,
     /* 2393447 */   // Label 34229: @2393447
     /* 2393447 */   GIM_Reject,
     /* 2393448 */ // Label 34227: @2393448
     /* 2393448 */ GIM_Reject,
     /* 2393449 */ // Label 34186: @2393449
     /* 2393449 */ GIM_Try, /*On fail goto*//*Label 34230*/ GIMT_Encode4(2393569),
     /* 2393454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2393457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2393460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393472 */   GIM_Try, /*On fail goto*//*Label 34231*/ GIMT_Encode4(2393520), // Rule ID 53314 //
     /* 2393477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393480 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2393483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2393497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393519 */     // GIR_Coverage, 53314,
     /* 2393519 */     GIR_EraseRootFromParent_Done,
     /* 2393520 */   // Label 34231: @2393520
     /* 2393520 */   GIM_Try, /*On fail goto*//*Label 34232*/ GIMT_Encode4(2393568), // Rule ID 53315 //
     /* 2393525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393528 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2393531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2393545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393567 */     // GIR_Coverage, 53315,
     /* 2393567 */     GIR_EraseRootFromParent_Done,
     /* 2393568 */   // Label 34232: @2393568
     /* 2393568 */   GIM_Reject,
     /* 2393569 */ // Label 34230: @2393569
     /* 2393569 */ GIM_Reject,
     /* 2393570 */ // Label 34187: @2393570
     /* 2393570 */ GIM_Try, /*On fail goto*//*Label 34233*/ GIMT_Encode4(2393690),
     /* 2393575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2393578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2393581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393593 */   GIM_Try, /*On fail goto*//*Label 34234*/ GIMT_Encode4(2393641), // Rule ID 53386 //
     /* 2393598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2393601 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2393604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2393618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393640 */     // GIR_Coverage, 53386,
     /* 2393640 */     GIR_EraseRootFromParent_Done,
     /* 2393641 */   // Label 34234: @2393641
     /* 2393641 */   GIM_Try, /*On fail goto*//*Label 34235*/ GIMT_Encode4(2393689), // Rule ID 53387 //
     /* 2393646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2393649 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2393652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2393666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393688 */     // GIR_Coverage, 53387,
     /* 2393688 */     GIR_EraseRootFromParent_Done,
     /* 2393689 */   // Label 34235: @2393689
     /* 2393689 */   GIM_Reject,
     /* 2393690 */ // Label 34233: @2393690
     /* 2393690 */ GIM_Reject,
     /* 2393691 */ // Label 34188: @2393691
     /* 2393691 */ GIM_Try, /*On fail goto*//*Label 34236*/ GIMT_Encode4(2393811),
     /* 2393696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2393699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2393702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393714 */   GIM_Try, /*On fail goto*//*Label 34237*/ GIMT_Encode4(2393762), // Rule ID 53434 //
     /* 2393719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2393722 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2393725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2393739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393761 */     // GIR_Coverage, 53434,
     /* 2393761 */     GIR_EraseRootFromParent_Done,
     /* 2393762 */   // Label 34237: @2393762
     /* 2393762 */   GIM_Try, /*On fail goto*//*Label 34238*/ GIMT_Encode4(2393810), // Rule ID 53435 //
     /* 2393767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2393770 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2393773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2393787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393809 */     // GIR_Coverage, 53435,
     /* 2393809 */     GIR_EraseRootFromParent_Done,
     /* 2393810 */   // Label 34238: @2393810
     /* 2393810 */   GIM_Reject,
     /* 2393811 */ // Label 34236: @2393811
     /* 2393811 */ GIM_Reject,
     /* 2393812 */ // Label 34189: @2393812
     /* 2393812 */ GIM_Try, /*On fail goto*//*Label 34239*/ GIMT_Encode4(2393932),
     /* 2393817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2393820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2393823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393835 */   GIM_Try, /*On fail goto*//*Label 34240*/ GIMT_Encode4(2393883), // Rule ID 53350 //
     /* 2393840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393843 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2393846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2393860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393882 */     // GIR_Coverage, 53350,
     /* 2393882 */     GIR_EraseRootFromParent_Done,
     /* 2393883 */   // Label 34240: @2393883
     /* 2393883 */   GIM_Try, /*On fail goto*//*Label 34241*/ GIMT_Encode4(2393931), // Rule ID 53351 //
     /* 2393888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393891 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2393894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2393908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393930 */     // GIR_Coverage, 53351,
     /* 2393930 */     GIR_EraseRootFromParent_Done,
     /* 2393931 */   // Label 34241: @2393931
     /* 2393931 */   GIM_Reject,
     /* 2393932 */ // Label 34239: @2393932
     /* 2393932 */ GIM_Reject,
     /* 2393933 */ // Label 34190: @2393933
     /* 2393933 */ GIM_Try, /*On fail goto*//*Label 34242*/ GIMT_Encode4(2394053),
     /* 2393938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2393941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2393944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393956 */   GIM_Try, /*On fail goto*//*Label 34243*/ GIMT_Encode4(2394004), // Rule ID 53398 //
     /* 2393961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2393964 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2393967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2393981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394003 */     // GIR_Coverage, 53398,
     /* 2394003 */     GIR_EraseRootFromParent_Done,
     /* 2394004 */   // Label 34243: @2394004
     /* 2394004 */   GIM_Try, /*On fail goto*//*Label 34244*/ GIMT_Encode4(2394052), // Rule ID 53399 //
     /* 2394009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2394012 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2394015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2394029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394051 */     // GIR_Coverage, 53399,
     /* 2394051 */     GIR_EraseRootFromParent_Done,
     /* 2394052 */   // Label 34244: @2394052
     /* 2394052 */   GIM_Reject,
     /* 2394053 */ // Label 34242: @2394053
     /* 2394053 */ GIM_Reject,
     /* 2394054 */ // Label 34191: @2394054
     /* 2394054 */ GIM_Try, /*On fail goto*//*Label 34245*/ GIMT_Encode4(2394174),
     /* 2394059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2394062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2394065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394073 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394077 */   GIM_Try, /*On fail goto*//*Label 34246*/ GIMT_Encode4(2394125), // Rule ID 53446 //
     /* 2394082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2394085 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2394088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2394102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2394120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394124 */     // GIR_Coverage, 53446,
     /* 2394124 */     GIR_EraseRootFromParent_Done,
     /* 2394125 */   // Label 34246: @2394125
     /* 2394125 */   GIM_Try, /*On fail goto*//*Label 34247*/ GIMT_Encode4(2394173), // Rule ID 53447 //
     /* 2394130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2394133 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2394136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2394150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2394168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394172 */     // GIR_Coverage, 53447,
     /* 2394172 */     GIR_EraseRootFromParent_Done,
     /* 2394173 */   // Label 34247: @2394173
     /* 2394173 */   GIM_Reject,
     /* 2394174 */ // Label 34245: @2394174
     /* 2394174 */ GIM_Reject,
     /* 2394175 */ // Label 34192: @2394175
     /* 2394175 */ GIM_Try, /*On fail goto*//*Label 34248*/ GIMT_Encode4(2394295),
     /* 2394180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2394183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2394186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394198 */   GIM_Try, /*On fail goto*//*Label 34249*/ GIMT_Encode4(2394246), // Rule ID 53362 //
     /* 2394203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2394206 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2394209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2394223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394245 */     // GIR_Coverage, 53362,
     /* 2394245 */     GIR_EraseRootFromParent_Done,
     /* 2394246 */   // Label 34249: @2394246
     /* 2394246 */   GIM_Try, /*On fail goto*//*Label 34250*/ GIMT_Encode4(2394294), // Rule ID 53363 //
     /* 2394251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2394254 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2394257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2394271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394293 */     // GIR_Coverage, 53363,
     /* 2394293 */     GIR_EraseRootFromParent_Done,
     /* 2394294 */   // Label 34250: @2394294
     /* 2394294 */   GIM_Reject,
     /* 2394295 */ // Label 34248: @2394295
     /* 2394295 */ GIM_Reject,
     /* 2394296 */ // Label 34193: @2394296
     /* 2394296 */ GIM_Try, /*On fail goto*//*Label 34251*/ GIMT_Encode4(2394416),
     /* 2394301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2394304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2394307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394319 */   GIM_Try, /*On fail goto*//*Label 34252*/ GIMT_Encode4(2394367), // Rule ID 53410 //
     /* 2394324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2394327 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2394330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2394344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394366 */     // GIR_Coverage, 53410,
     /* 2394366 */     GIR_EraseRootFromParent_Done,
     /* 2394367 */   // Label 34252: @2394367
     /* 2394367 */   GIM_Try, /*On fail goto*//*Label 34253*/ GIMT_Encode4(2394415), // Rule ID 53411 //
     /* 2394372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2394375 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2394378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2394392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394414 */     // GIR_Coverage, 53411,
     /* 2394414 */     GIR_EraseRootFromParent_Done,
     /* 2394415 */   // Label 34253: @2394415
     /* 2394415 */   GIM_Reject,
     /* 2394416 */ // Label 34251: @2394416
     /* 2394416 */ GIM_Reject,
     /* 2394417 */ // Label 34194: @2394417
     /* 2394417 */ GIM_Try, /*On fail goto*//*Label 34254*/ GIMT_Encode4(2394537),
     /* 2394422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2394425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2394428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394440 */   GIM_Try, /*On fail goto*//*Label 34255*/ GIMT_Encode4(2394488), // Rule ID 53374 //
     /* 2394445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2394448 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2394451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2394465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394487 */     // GIR_Coverage, 53374,
     /* 2394487 */     GIR_EraseRootFromParent_Done,
     /* 2394488 */   // Label 34255: @2394488
     /* 2394488 */   GIM_Try, /*On fail goto*//*Label 34256*/ GIMT_Encode4(2394536), // Rule ID 53375 //
     /* 2394493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2394496 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2394499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2394513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394535 */     // GIR_Coverage, 53375,
     /* 2394535 */     GIR_EraseRootFromParent_Done,
     /* 2394536 */   // Label 34256: @2394536
     /* 2394536 */   GIM_Reject,
     /* 2394537 */ // Label 34254: @2394537
     /* 2394537 */ GIM_Reject,
     /* 2394538 */ // Label 34195: @2394538
     /* 2394538 */ GIM_Reject,
     /* 2394539 */ // Label 99: @2394539
     /* 2394539 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34275*/ GIMT_Encode4(2396966),
     /* 2394550 */ /*GILLT_s16*//*Label 34257*/ GIMT_Encode4(2394670),
     /* 2394554 */ /*GILLT_s32*//*Label 34258*/ GIMT_Encode4(2394819),
     /* 2394558 */ /*GILLT_s64*//*Label 34259*/ GIMT_Encode4(2394968), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394570 */ /*GILLT_nxv1s16*//*Label 34260*/ GIMT_Encode4(2395151),
     /* 2394574 */ /*GILLT_nxv1s32*//*Label 34261*/ GIMT_Encode4(2395272),
     /* 2394578 */ /*GILLT_nxv1s64*//*Label 34262*/ GIMT_Encode4(2395393), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394590 */ /*GILLT_nxv2s16*//*Label 34263*/ GIMT_Encode4(2395514),
     /* 2394594 */ /*GILLT_nxv2s32*//*Label 34264*/ GIMT_Encode4(2395635),
     /* 2394598 */ /*GILLT_nxv2s64*//*Label 34265*/ GIMT_Encode4(2395756), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394610 */ /*GILLT_nxv4s16*//*Label 34266*/ GIMT_Encode4(2395877),
     /* 2394614 */ /*GILLT_nxv4s32*//*Label 34267*/ GIMT_Encode4(2395998),
     /* 2394618 */ /*GILLT_nxv4s64*//*Label 34268*/ GIMT_Encode4(2396119), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394630 */ /*GILLT_nxv8s16*//*Label 34269*/ GIMT_Encode4(2396240),
     /* 2394634 */ /*GILLT_nxv8s32*//*Label 34270*/ GIMT_Encode4(2396361),
     /* 2394638 */ /*GILLT_nxv8s64*//*Label 34271*/ GIMT_Encode4(2396482), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394650 */ /*GILLT_nxv16s16*//*Label 34272*/ GIMT_Encode4(2396603),
     /* 2394654 */ /*GILLT_nxv16s32*//*Label 34273*/ GIMT_Encode4(2396724), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394666 */ /*GILLT_nxv32s16*//*Label 34274*/ GIMT_Encode4(2396845),
     /* 2394670 */ // Label 34257: @2394670
     /* 2394670 */ GIM_Try, /*On fail goto*//*Label 34276*/ GIMT_Encode4(2394818),
     /* 2394675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2394678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2394681 */   GIM_Try, /*On fail goto*//*Label 34277*/ GIMT_Encode4(2394715), // Rule ID 1964 //
     /* 2394686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2394689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394701 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2394701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2394704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394714 */     // GIR_Coverage, 1964,
     /* 2394714 */     GIR_EraseRootFromParent_Done,
     /* 2394715 */   // Label 34277: @2394715
     /* 2394715 */   GIM_Try, /*On fail goto*//*Label 34278*/ GIMT_Encode4(2394749), // Rule ID 1965 //
     /* 2394720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2394723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394735 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2394735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2394738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394748 */     // GIR_Coverage, 1965,
     /* 2394748 */     GIR_EraseRootFromParent_Done,
     /* 2394749 */   // Label 34278: @2394749
     /* 2394749 */   GIM_Try, /*On fail goto*//*Label 34279*/ GIMT_Encode4(2394783), // Rule ID 1968 //
     /* 2394754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2394757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394769 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2394769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2394772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394782 */     // GIR_Coverage, 1968,
     /* 2394782 */     GIR_EraseRootFromParent_Done,
     /* 2394783 */   // Label 34279: @2394783
     /* 2394783 */   GIM_Try, /*On fail goto*//*Label 34280*/ GIMT_Encode4(2394817), // Rule ID 1969 //
     /* 2394788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2394791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394803 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2394803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2394806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394816 */     // GIR_Coverage, 1969,
     /* 2394816 */     GIR_EraseRootFromParent_Done,
     /* 2394817 */   // Label 34280: @2394817
     /* 2394817 */   GIM_Reject,
     /* 2394818 */ // Label 34276: @2394818
     /* 2394818 */ GIM_Reject,
     /* 2394819 */ // Label 34258: @2394819
     /* 2394819 */ GIM_Try, /*On fail goto*//*Label 34281*/ GIMT_Encode4(2394967),
     /* 2394824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2394827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2394830 */   GIM_Try, /*On fail goto*//*Label 34282*/ GIMT_Encode4(2394864), // Rule ID 1255 //
     /* 2394835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2394838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394850 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2394850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2394853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394863 */     // GIR_Coverage, 1255,
     /* 2394863 */     GIR_EraseRootFromParent_Done,
     /* 2394864 */   // Label 34282: @2394864
     /* 2394864 */   GIM_Try, /*On fail goto*//*Label 34283*/ GIMT_Encode4(2394898), // Rule ID 1256 //
     /* 2394869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2394872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394884 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2394884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2394887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394897 */     // GIR_Coverage, 1256,
     /* 2394897 */     GIR_EraseRootFromParent_Done,
     /* 2394898 */   // Label 34283: @2394898
     /* 2394898 */   GIM_Try, /*On fail goto*//*Label 34284*/ GIMT_Encode4(2394932), // Rule ID 1259 //
     /* 2394903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2394906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394918 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2394918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2394921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394931 */     // GIR_Coverage, 1259,
     /* 2394931 */     GIR_EraseRootFromParent_Done,
     /* 2394932 */   // Label 34284: @2394932
     /* 2394932 */   GIM_Try, /*On fail goto*//*Label 34285*/ GIMT_Encode4(2394966), // Rule ID 1260 //
     /* 2394937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2394940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394952 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2394952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2394955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394965 */     // GIR_Coverage, 1260,
     /* 2394965 */     GIR_EraseRootFromParent_Done,
     /* 2394966 */   // Label 34285: @2394966
     /* 2394966 */   GIM_Reject,
     /* 2394967 */ // Label 34281: @2394967
     /* 2394967 */ GIM_Reject,
     /* 2394968 */ // Label 34259: @2394968
     /* 2394968 */ GIM_Try, /*On fail goto*//*Label 34286*/ GIMT_Encode4(2395150),
     /* 2394973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2394979 */   GIM_Try, /*On fail goto*//*Label 34287*/ GIMT_Encode4(2395013), // Rule ID 1592 //
     /* 2394984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2394987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394999 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2394999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2395002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395012 */     // GIR_Coverage, 1592,
     /* 2395012 */     GIR_EraseRootFromParent_Done,
     /* 2395013 */   // Label 34287: @2395013
     /* 2395013 */   GIM_Try, /*On fail goto*//*Label 34288*/ GIMT_Encode4(2395047), // Rule ID 1593 //
     /* 2395018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2395021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395033 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2395033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2395036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395046 */     // GIR_Coverage, 1593,
     /* 2395046 */     GIR_EraseRootFromParent_Done,
     /* 2395047 */   // Label 34288: @2395047
     /* 2395047 */   GIM_Try, /*On fail goto*//*Label 34289*/ GIMT_Encode4(2395081), // Rule ID 1596 //
     /* 2395052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2395055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395067 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2395067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2395070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395080 */     // GIR_Coverage, 1596,
     /* 2395080 */     GIR_EraseRootFromParent_Done,
     /* 2395081 */   // Label 34289: @2395081
     /* 2395081 */   GIM_Try, /*On fail goto*//*Label 34290*/ GIMT_Encode4(2395115), // Rule ID 1597 //
     /* 2395086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2395089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395101 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2395101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2395104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395114 */     // GIR_Coverage, 1597,
     /* 2395114 */     GIR_EraseRootFromParent_Done,
     /* 2395115 */   // Label 34290: @2395115
     /* 2395115 */   GIM_Try, /*On fail goto*//*Label 34291*/ GIMT_Encode4(2395149), // Rule ID 1600 //
     /* 2395120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2395123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2395127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2395131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2395135 */     // (strict_fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2395135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2395138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395148 */     // GIR_Coverage, 1600,
     /* 2395148 */     GIR_EraseRootFromParent_Done,
     /* 2395149 */   // Label 34291: @2395149
     /* 2395149 */   GIM_Reject,
     /* 2395150 */ // Label 34286: @2395150
     /* 2395150 */ GIM_Reject,
     /* 2395151 */ // Label 34260: @2395151
     /* 2395151 */ GIM_Try, /*On fail goto*//*Label 34292*/ GIMT_Encode4(2395271),
     /* 2395156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2395162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395174 */   GIM_Try, /*On fail goto*//*Label 34293*/ GIMT_Encode4(2395222), // Rule ID 53458 //
     /* 2395179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395182 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2395185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2395199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395221 */     // GIR_Coverage, 53458,
     /* 2395221 */     GIR_EraseRootFromParent_Done,
     /* 2395222 */   // Label 34293: @2395222
     /* 2395222 */   GIM_Try, /*On fail goto*//*Label 34294*/ GIMT_Encode4(2395270), // Rule ID 53459 //
     /* 2395227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395230 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2395233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2395247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395269 */     // GIR_Coverage, 53459,
     /* 2395269 */     GIR_EraseRootFromParent_Done,
     /* 2395270 */   // Label 34294: @2395270
     /* 2395270 */   GIM_Reject,
     /* 2395271 */ // Label 34292: @2395271
     /* 2395271 */ GIM_Reject,
     /* 2395272 */ // Label 34261: @2395272
     /* 2395272 */ GIM_Try, /*On fail goto*//*Label 34295*/ GIMT_Encode4(2395392),
     /* 2395277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2395280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2395283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395295 */   GIM_Try, /*On fail goto*//*Label 34296*/ GIMT_Encode4(2395343), // Rule ID 53482 //
     /* 2395300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2395303 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2395306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2395320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395342 */     // GIR_Coverage, 53482,
     /* 2395342 */     GIR_EraseRootFromParent_Done,
     /* 2395343 */   // Label 34296: @2395343
     /* 2395343 */   GIM_Try, /*On fail goto*//*Label 34297*/ GIMT_Encode4(2395391), // Rule ID 53483 //
     /* 2395348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2395351 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2395354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2395368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395390 */     // GIR_Coverage, 53483,
     /* 2395390 */     GIR_EraseRootFromParent_Done,
     /* 2395391 */   // Label 34297: @2395391
     /* 2395391 */   GIM_Reject,
     /* 2395392 */ // Label 34295: @2395392
     /* 2395392 */ GIM_Reject,
     /* 2395393 */ // Label 34262: @2395393
     /* 2395393 */ GIM_Try, /*On fail goto*//*Label 34298*/ GIMT_Encode4(2395513),
     /* 2395398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2395401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2395404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395416 */   GIM_Try, /*On fail goto*//*Label 34299*/ GIMT_Encode4(2395464), // Rule ID 53518 //
     /* 2395421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2395424 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2395427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2395441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395463 */     // GIR_Coverage, 53518,
     /* 2395463 */     GIR_EraseRootFromParent_Done,
     /* 2395464 */   // Label 34299: @2395464
     /* 2395464 */   GIM_Try, /*On fail goto*//*Label 34300*/ GIMT_Encode4(2395512), // Rule ID 53519 //
     /* 2395469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2395472 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2395475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2395489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395511 */     // GIR_Coverage, 53519,
     /* 2395511 */     GIR_EraseRootFromParent_Done,
     /* 2395512 */   // Label 34300: @2395512
     /* 2395512 */   GIM_Reject,
     /* 2395513 */ // Label 34298: @2395513
     /* 2395513 */ GIM_Reject,
     /* 2395514 */ // Label 34263: @2395514
     /* 2395514 */ GIM_Try, /*On fail goto*//*Label 34301*/ GIMT_Encode4(2395634),
     /* 2395519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2395522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2395525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395537 */   GIM_Try, /*On fail goto*//*Label 34302*/ GIMT_Encode4(2395585), // Rule ID 53470 //
     /* 2395542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395545 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2395548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2395562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395584 */     // GIR_Coverage, 53470,
     /* 2395584 */     GIR_EraseRootFromParent_Done,
     /* 2395585 */   // Label 34302: @2395585
     /* 2395585 */   GIM_Try, /*On fail goto*//*Label 34303*/ GIMT_Encode4(2395633), // Rule ID 53471 //
     /* 2395590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395593 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2395596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2395610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395632 */     // GIR_Coverage, 53471,
     /* 2395632 */     GIR_EraseRootFromParent_Done,
     /* 2395633 */   // Label 34303: @2395633
     /* 2395633 */   GIM_Reject,
     /* 2395634 */ // Label 34301: @2395634
     /* 2395634 */ GIM_Reject,
     /* 2395635 */ // Label 34264: @2395635
     /* 2395635 */ GIM_Try, /*On fail goto*//*Label 34304*/ GIMT_Encode4(2395755),
     /* 2395640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2395643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2395646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395658 */   GIM_Try, /*On fail goto*//*Label 34305*/ GIMT_Encode4(2395706), // Rule ID 53506 //
     /* 2395663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2395666 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2395669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2395683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395705 */     // GIR_Coverage, 53506,
     /* 2395705 */     GIR_EraseRootFromParent_Done,
     /* 2395706 */   // Label 34305: @2395706
     /* 2395706 */   GIM_Try, /*On fail goto*//*Label 34306*/ GIMT_Encode4(2395754), // Rule ID 53507 //
     /* 2395711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2395714 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2395717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2395731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395753 */     // GIR_Coverage, 53507,
     /* 2395753 */     GIR_EraseRootFromParent_Done,
     /* 2395754 */   // Label 34306: @2395754
     /* 2395754 */   GIM_Reject,
     /* 2395755 */ // Label 34304: @2395755
     /* 2395755 */ GIM_Reject,
     /* 2395756 */ // Label 34265: @2395756
     /* 2395756 */ GIM_Try, /*On fail goto*//*Label 34307*/ GIMT_Encode4(2395876),
     /* 2395761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2395764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2395767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395779 */   GIM_Try, /*On fail goto*//*Label 34308*/ GIMT_Encode4(2395827), // Rule ID 53602 //
     /* 2395784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2395787 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2395790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2395804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395826 */     // GIR_Coverage, 53602,
     /* 2395826 */     GIR_EraseRootFromParent_Done,
     /* 2395827 */   // Label 34308: @2395827
     /* 2395827 */   GIM_Try, /*On fail goto*//*Label 34309*/ GIMT_Encode4(2395875), // Rule ID 53603 //
     /* 2395832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2395835 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2395838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2395852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395874 */     // GIR_Coverage, 53603,
     /* 2395874 */     GIR_EraseRootFromParent_Done,
     /* 2395875 */   // Label 34309: @2395875
     /* 2395875 */   GIM_Reject,
     /* 2395876 */ // Label 34307: @2395876
     /* 2395876 */ GIM_Reject,
     /* 2395877 */ // Label 34266: @2395877
     /* 2395877 */ GIM_Try, /*On fail goto*//*Label 34310*/ GIMT_Encode4(2395997),
     /* 2395882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2395888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395900 */   GIM_Try, /*On fail goto*//*Label 34311*/ GIMT_Encode4(2395948), // Rule ID 53494 //
     /* 2395905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395908 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2395911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2395925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395947 */     // GIR_Coverage, 53494,
     /* 2395947 */     GIR_EraseRootFromParent_Done,
     /* 2395948 */   // Label 34311: @2395948
     /* 2395948 */   GIM_Try, /*On fail goto*//*Label 34312*/ GIMT_Encode4(2395996), // Rule ID 53495 //
     /* 2395953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395956 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2395959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2395973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395995 */     // GIR_Coverage, 53495,
     /* 2395995 */     GIR_EraseRootFromParent_Done,
     /* 2395996 */   // Label 34312: @2395996
     /* 2395996 */   GIM_Reject,
     /* 2395997 */ // Label 34310: @2395997
     /* 2395997 */ GIM_Reject,
     /* 2395998 */ // Label 34267: @2395998
     /* 2395998 */ GIM_Try, /*On fail goto*//*Label 34313*/ GIMT_Encode4(2396118),
     /* 2396003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2396009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396021 */   GIM_Try, /*On fail goto*//*Label 34314*/ GIMT_Encode4(2396069), // Rule ID 53566 //
     /* 2396026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396029 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2396032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2396046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396068 */     // GIR_Coverage, 53566,
     /* 2396068 */     GIR_EraseRootFromParent_Done,
     /* 2396069 */   // Label 34314: @2396069
     /* 2396069 */   GIM_Try, /*On fail goto*//*Label 34315*/ GIMT_Encode4(2396117), // Rule ID 53567 //
     /* 2396074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396077 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2396080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2396094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396116 */     // GIR_Coverage, 53567,
     /* 2396116 */     GIR_EraseRootFromParent_Done,
     /* 2396117 */   // Label 34315: @2396117
     /* 2396117 */   GIM_Reject,
     /* 2396118 */ // Label 34313: @2396118
     /* 2396118 */ GIM_Reject,
     /* 2396119 */ // Label 34268: @2396119
     /* 2396119 */ GIM_Try, /*On fail goto*//*Label 34316*/ GIMT_Encode4(2396239),
     /* 2396124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2396127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2396130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396142 */   GIM_Try, /*On fail goto*//*Label 34317*/ GIMT_Encode4(2396190), // Rule ID 53614 //
     /* 2396147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396150 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2396153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2396167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396189 */     // GIR_Coverage, 53614,
     /* 2396189 */     GIR_EraseRootFromParent_Done,
     /* 2396190 */   // Label 34317: @2396190
     /* 2396190 */   GIM_Try, /*On fail goto*//*Label 34318*/ GIMT_Encode4(2396238), // Rule ID 53615 //
     /* 2396195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2396198 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2396201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2396215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396237 */     // GIR_Coverage, 53615,
     /* 2396237 */     GIR_EraseRootFromParent_Done,
     /* 2396238 */   // Label 34318: @2396238
     /* 2396238 */   GIM_Reject,
     /* 2396239 */ // Label 34316: @2396239
     /* 2396239 */ GIM_Reject,
     /* 2396240 */ // Label 34269: @2396240
     /* 2396240 */ GIM_Try, /*On fail goto*//*Label 34319*/ GIMT_Encode4(2396360),
     /* 2396245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2396248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2396251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396263 */   GIM_Try, /*On fail goto*//*Label 34320*/ GIMT_Encode4(2396311), // Rule ID 53530 //
     /* 2396268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396271 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2396274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2396288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396310 */     // GIR_Coverage, 53530,
     /* 2396310 */     GIR_EraseRootFromParent_Done,
     /* 2396311 */   // Label 34320: @2396311
     /* 2396311 */   GIM_Try, /*On fail goto*//*Label 34321*/ GIMT_Encode4(2396359), // Rule ID 53531 //
     /* 2396316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396319 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2396322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2396336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396358 */     // GIR_Coverage, 53531,
     /* 2396358 */     GIR_EraseRootFromParent_Done,
     /* 2396359 */   // Label 34321: @2396359
     /* 2396359 */   GIM_Reject,
     /* 2396360 */ // Label 34319: @2396360
     /* 2396360 */ GIM_Reject,
     /* 2396361 */ // Label 34270: @2396361
     /* 2396361 */ GIM_Try, /*On fail goto*//*Label 34322*/ GIMT_Encode4(2396481),
     /* 2396366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2396369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2396372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396384 */   GIM_Try, /*On fail goto*//*Label 34323*/ GIMT_Encode4(2396432), // Rule ID 53578 //
     /* 2396389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396392 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2396395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2396409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396431 */     // GIR_Coverage, 53578,
     /* 2396431 */     GIR_EraseRootFromParent_Done,
     /* 2396432 */   // Label 34323: @2396432
     /* 2396432 */   GIM_Try, /*On fail goto*//*Label 34324*/ GIMT_Encode4(2396480), // Rule ID 53579 //
     /* 2396437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396440 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2396443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2396457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396479 */     // GIR_Coverage, 53579,
     /* 2396479 */     GIR_EraseRootFromParent_Done,
     /* 2396480 */   // Label 34324: @2396480
     /* 2396480 */   GIM_Reject,
     /* 2396481 */ // Label 34322: @2396481
     /* 2396481 */ GIM_Reject,
     /* 2396482 */ // Label 34271: @2396482
     /* 2396482 */ GIM_Try, /*On fail goto*//*Label 34325*/ GIMT_Encode4(2396602),
     /* 2396487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2396490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2396493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396505 */   GIM_Try, /*On fail goto*//*Label 34326*/ GIMT_Encode4(2396553), // Rule ID 53626 //
     /* 2396510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396513 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2396516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2396530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396552 */     // GIR_Coverage, 53626,
     /* 2396552 */     GIR_EraseRootFromParent_Done,
     /* 2396553 */   // Label 34326: @2396553
     /* 2396553 */   GIM_Try, /*On fail goto*//*Label 34327*/ GIMT_Encode4(2396601), // Rule ID 53627 //
     /* 2396558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2396561 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2396564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2396578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396600 */     // GIR_Coverage, 53627,
     /* 2396600 */     GIR_EraseRootFromParent_Done,
     /* 2396601 */   // Label 34327: @2396601
     /* 2396601 */   GIM_Reject,
     /* 2396602 */ // Label 34325: @2396602
     /* 2396602 */ GIM_Reject,
     /* 2396603 */ // Label 34272: @2396603
     /* 2396603 */ GIM_Try, /*On fail goto*//*Label 34328*/ GIMT_Encode4(2396723),
     /* 2396608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2396611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2396614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396626 */   GIM_Try, /*On fail goto*//*Label 34329*/ GIMT_Encode4(2396674), // Rule ID 53542 //
     /* 2396631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396634 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2396637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2396651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396673 */     // GIR_Coverage, 53542,
     /* 2396673 */     GIR_EraseRootFromParent_Done,
     /* 2396674 */   // Label 34329: @2396674
     /* 2396674 */   GIM_Try, /*On fail goto*//*Label 34330*/ GIMT_Encode4(2396722), // Rule ID 53543 //
     /* 2396679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396682 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2396685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2396699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396721 */     // GIR_Coverage, 53543,
     /* 2396721 */     GIR_EraseRootFromParent_Done,
     /* 2396722 */   // Label 34330: @2396722
     /* 2396722 */   GIM_Reject,
     /* 2396723 */ // Label 34328: @2396723
     /* 2396723 */ GIM_Reject,
     /* 2396724 */ // Label 34273: @2396724
     /* 2396724 */ GIM_Try, /*On fail goto*//*Label 34331*/ GIMT_Encode4(2396844),
     /* 2396729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2396732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2396735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396747 */   GIM_Try, /*On fail goto*//*Label 34332*/ GIMT_Encode4(2396795), // Rule ID 53590 //
     /* 2396752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396755 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2396758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2396772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396794 */     // GIR_Coverage, 53590,
     /* 2396794 */     GIR_EraseRootFromParent_Done,
     /* 2396795 */   // Label 34332: @2396795
     /* 2396795 */   GIM_Try, /*On fail goto*//*Label 34333*/ GIMT_Encode4(2396843), // Rule ID 53591 //
     /* 2396800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396803 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2396806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2396820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396842 */     // GIR_Coverage, 53591,
     /* 2396842 */     GIR_EraseRootFromParent_Done,
     /* 2396843 */   // Label 34333: @2396843
     /* 2396843 */   GIM_Reject,
     /* 2396844 */ // Label 34331: @2396844
     /* 2396844 */ GIM_Reject,
     /* 2396845 */ // Label 34274: @2396845
     /* 2396845 */ GIM_Try, /*On fail goto*//*Label 34334*/ GIMT_Encode4(2396965),
     /* 2396850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2396853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2396856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396868 */   GIM_Try, /*On fail goto*//*Label 34335*/ GIMT_Encode4(2396916), // Rule ID 53554 //
     /* 2396873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396876 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2396879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2396893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396915 */     // GIR_Coverage, 53554,
     /* 2396915 */     GIR_EraseRootFromParent_Done,
     /* 2396916 */   // Label 34335: @2396916
     /* 2396916 */   GIM_Try, /*On fail goto*//*Label 34336*/ GIMT_Encode4(2396964), // Rule ID 53555 //
     /* 2396921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396924 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2396927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2396941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396963 */     // GIR_Coverage, 53555,
     /* 2396963 */     GIR_EraseRootFromParent_Done,
     /* 2396964 */   // Label 34336: @2396964
     /* 2396964 */   GIM_Reject,
     /* 2396965 */ // Label 34334: @2396965
     /* 2396965 */ GIM_Reject,
     /* 2396966 */ // Label 34275: @2396966
     /* 2396966 */ GIM_Reject,
     /* 2396967 */ // Label 100: @2396967
     /* 2396967 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34355*/ GIMT_Encode4(2399394),
     /* 2396978 */ /*GILLT_s16*//*Label 34337*/ GIMT_Encode4(2397098),
     /* 2396982 */ /*GILLT_s32*//*Label 34338*/ GIMT_Encode4(2397247),
     /* 2396986 */ /*GILLT_s64*//*Label 34339*/ GIMT_Encode4(2397396), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2396998 */ /*GILLT_nxv1s16*//*Label 34340*/ GIMT_Encode4(2397579),
     /* 2397002 */ /*GILLT_nxv1s32*//*Label 34341*/ GIMT_Encode4(2397700),
     /* 2397006 */ /*GILLT_nxv1s64*//*Label 34342*/ GIMT_Encode4(2397821), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397018 */ /*GILLT_nxv2s16*//*Label 34343*/ GIMT_Encode4(2397942),
     /* 2397022 */ /*GILLT_nxv2s32*//*Label 34344*/ GIMT_Encode4(2398063),
     /* 2397026 */ /*GILLT_nxv2s64*//*Label 34345*/ GIMT_Encode4(2398184), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397038 */ /*GILLT_nxv4s16*//*Label 34346*/ GIMT_Encode4(2398305),
     /* 2397042 */ /*GILLT_nxv4s32*//*Label 34347*/ GIMT_Encode4(2398426),
     /* 2397046 */ /*GILLT_nxv4s64*//*Label 34348*/ GIMT_Encode4(2398547), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397058 */ /*GILLT_nxv8s16*//*Label 34349*/ GIMT_Encode4(2398668),
     /* 2397062 */ /*GILLT_nxv8s32*//*Label 34350*/ GIMT_Encode4(2398789),
     /* 2397066 */ /*GILLT_nxv8s64*//*Label 34351*/ GIMT_Encode4(2398910), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397078 */ /*GILLT_nxv16s16*//*Label 34352*/ GIMT_Encode4(2399031),
     /* 2397082 */ /*GILLT_nxv16s32*//*Label 34353*/ GIMT_Encode4(2399152), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397094 */ /*GILLT_nxv32s16*//*Label 34354*/ GIMT_Encode4(2399273),
     /* 2397098 */ // Label 34337: @2397098
     /* 2397098 */ GIM_Try, /*On fail goto*//*Label 34356*/ GIMT_Encode4(2397246),
     /* 2397103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2397106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2397109 */   GIM_Try, /*On fail goto*//*Label 34357*/ GIMT_Encode4(2397143), // Rule ID 1972 //
     /* 2397114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2397117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397129 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2397129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2397132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397142 */     // GIR_Coverage, 1972,
     /* 2397142 */     GIR_EraseRootFromParent_Done,
     /* 2397143 */   // Label 34357: @2397143
     /* 2397143 */   GIM_Try, /*On fail goto*//*Label 34358*/ GIMT_Encode4(2397177), // Rule ID 1973 //
     /* 2397148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2397151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397163 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2397163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2397166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397176 */     // GIR_Coverage, 1973,
     /* 2397176 */     GIR_EraseRootFromParent_Done,
     /* 2397177 */   // Label 34358: @2397177
     /* 2397177 */   GIM_Try, /*On fail goto*//*Label 34359*/ GIMT_Encode4(2397211), // Rule ID 1976 //
     /* 2397182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2397185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2397189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2397193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2397197 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2397197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2397200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397210 */     // GIR_Coverage, 1976,
     /* 2397210 */     GIR_EraseRootFromParent_Done,
     /* 2397211 */   // Label 34359: @2397211
     /* 2397211 */   GIM_Try, /*On fail goto*//*Label 34360*/ GIMT_Encode4(2397245), // Rule ID 1977 //
     /* 2397216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2397219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2397223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2397227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2397231 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2397231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2397234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397244 */     // GIR_Coverage, 1977,
     /* 2397244 */     GIR_EraseRootFromParent_Done,
     /* 2397245 */   // Label 34360: @2397245
     /* 2397245 */   GIM_Reject,
     /* 2397246 */ // Label 34356: @2397246
     /* 2397246 */ GIM_Reject,
     /* 2397247 */ // Label 34338: @2397247
     /* 2397247 */ GIM_Try, /*On fail goto*//*Label 34361*/ GIMT_Encode4(2397395),
     /* 2397252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2397255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2397258 */   GIM_Try, /*On fail goto*//*Label 34362*/ GIMT_Encode4(2397292), // Rule ID 1263 //
     /* 2397263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2397266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397278 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2397278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2397281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397291 */     // GIR_Coverage, 1263,
     /* 2397291 */     GIR_EraseRootFromParent_Done,
     /* 2397292 */   // Label 34362: @2397292
     /* 2397292 */   GIM_Try, /*On fail goto*//*Label 34363*/ GIMT_Encode4(2397326), // Rule ID 1264 //
     /* 2397297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2397300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397312 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2397312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2397315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397325 */     // GIR_Coverage, 1264,
     /* 2397325 */     GIR_EraseRootFromParent_Done,
     /* 2397326 */   // Label 34363: @2397326
     /* 2397326 */   GIM_Try, /*On fail goto*//*Label 34364*/ GIMT_Encode4(2397360), // Rule ID 1267 //
     /* 2397331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2397334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2397338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2397342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2397346 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2397346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2397349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397359 */     // GIR_Coverage, 1267,
     /* 2397359 */     GIR_EraseRootFromParent_Done,
     /* 2397360 */   // Label 34364: @2397360
     /* 2397360 */   GIM_Try, /*On fail goto*//*Label 34365*/ GIMT_Encode4(2397394), // Rule ID 1268 //
     /* 2397365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2397368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2397372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2397376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2397380 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2397380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2397383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397393 */     // GIR_Coverage, 1268,
     /* 2397393 */     GIR_EraseRootFromParent_Done,
     /* 2397394 */   // Label 34365: @2397394
     /* 2397394 */   GIM_Reject,
     /* 2397395 */ // Label 34361: @2397395
     /* 2397395 */ GIM_Reject,
     /* 2397396 */ // Label 34339: @2397396
     /* 2397396 */ GIM_Try, /*On fail goto*//*Label 34366*/ GIMT_Encode4(2397578),
     /* 2397401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2397404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2397407 */   GIM_Try, /*On fail goto*//*Label 34367*/ GIMT_Encode4(2397441), // Rule ID 1602 //
     /* 2397412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2397415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397427 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2397427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2397430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397440 */     // GIR_Coverage, 1602,
     /* 2397440 */     GIR_EraseRootFromParent_Done,
     /* 2397441 */   // Label 34367: @2397441
     /* 2397441 */   GIM_Try, /*On fail goto*//*Label 34368*/ GIMT_Encode4(2397475), // Rule ID 1603 //
     /* 2397446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2397449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397461 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2397461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2397464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397474 */     // GIR_Coverage, 1603,
     /* 2397474 */     GIR_EraseRootFromParent_Done,
     /* 2397475 */   // Label 34368: @2397475
     /* 2397475 */   GIM_Try, /*On fail goto*//*Label 34369*/ GIMT_Encode4(2397509), // Rule ID 1606 //
     /* 2397480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2397483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2397487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2397491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2397495 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2397495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2397498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397508 */     // GIR_Coverage, 1606,
     /* 2397508 */     GIR_EraseRootFromParent_Done,
     /* 2397509 */   // Label 34369: @2397509
     /* 2397509 */   GIM_Try, /*On fail goto*//*Label 34370*/ GIMT_Encode4(2397543), // Rule ID 1607 //
     /* 2397514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2397517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2397521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2397525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2397529 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2397529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2397532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397542 */     // GIR_Coverage, 1607,
     /* 2397542 */     GIR_EraseRootFromParent_Done,
     /* 2397543 */   // Label 34370: @2397543
     /* 2397543 */   GIM_Try, /*On fail goto*//*Label 34371*/ GIMT_Encode4(2397577), // Rule ID 1610 //
     /* 2397548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2397551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2397555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2397559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2397563 */     // (strict_fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2397563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2397566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397576 */     // GIR_Coverage, 1610,
     /* 2397576 */     GIR_EraseRootFromParent_Done,
     /* 2397577 */   // Label 34371: @2397577
     /* 2397577 */   GIM_Reject,
     /* 2397578 */ // Label 34366: @2397578
     /* 2397578 */ GIM_Reject,
     /* 2397579 */ // Label 34340: @2397579
     /* 2397579 */ GIM_Try, /*On fail goto*//*Label 34372*/ GIMT_Encode4(2397699),
     /* 2397584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2397587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2397590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397602 */   GIM_Try, /*On fail goto*//*Label 34373*/ GIMT_Encode4(2397650), // Rule ID 54226 //
     /* 2397607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397610 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2397613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2397627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397649 */     // GIR_Coverage, 54226,
     /* 2397649 */     GIR_EraseRootFromParent_Done,
     /* 2397650 */   // Label 34373: @2397650
     /* 2397650 */   GIM_Try, /*On fail goto*//*Label 34374*/ GIMT_Encode4(2397698), // Rule ID 54227 //
     /* 2397655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397658 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2397661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2397675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397697 */     // GIR_Coverage, 54227,
     /* 2397697 */     GIR_EraseRootFromParent_Done,
     /* 2397698 */   // Label 34374: @2397698
     /* 2397698 */   GIM_Reject,
     /* 2397699 */ // Label 34372: @2397699
     /* 2397699 */ GIM_Reject,
     /* 2397700 */ // Label 34341: @2397700
     /* 2397700 */ GIM_Try, /*On fail goto*//*Label 34375*/ GIMT_Encode4(2397820),
     /* 2397705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2397708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2397711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397723 */   GIM_Try, /*On fail goto*//*Label 34376*/ GIMT_Encode4(2397771), // Rule ID 54250 //
     /* 2397728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2397731 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2397734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2397748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397770 */     // GIR_Coverage, 54250,
     /* 2397770 */     GIR_EraseRootFromParent_Done,
     /* 2397771 */   // Label 34376: @2397771
     /* 2397771 */   GIM_Try, /*On fail goto*//*Label 34377*/ GIMT_Encode4(2397819), // Rule ID 54251 //
     /* 2397776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2397779 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2397782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2397796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397818 */     // GIR_Coverage, 54251,
     /* 2397818 */     GIR_EraseRootFromParent_Done,
     /* 2397819 */   // Label 34377: @2397819
     /* 2397819 */   GIM_Reject,
     /* 2397820 */ // Label 34375: @2397820
     /* 2397820 */ GIM_Reject,
     /* 2397821 */ // Label 34342: @2397821
     /* 2397821 */ GIM_Try, /*On fail goto*//*Label 34378*/ GIMT_Encode4(2397941),
     /* 2397826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2397829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2397832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397844 */   GIM_Try, /*On fail goto*//*Label 34379*/ GIMT_Encode4(2397892), // Rule ID 54286 //
     /* 2397849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2397852 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2397855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2397869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397891 */     // GIR_Coverage, 54286,
     /* 2397891 */     GIR_EraseRootFromParent_Done,
     /* 2397892 */   // Label 34379: @2397892
     /* 2397892 */   GIM_Try, /*On fail goto*//*Label 34380*/ GIMT_Encode4(2397940), // Rule ID 54287 //
     /* 2397897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397900 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2397903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2397917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397939 */     // GIR_Coverage, 54287,
     /* 2397939 */     GIR_EraseRootFromParent_Done,
     /* 2397940 */   // Label 34380: @2397940
     /* 2397940 */   GIM_Reject,
     /* 2397941 */ // Label 34378: @2397941
     /* 2397941 */ GIM_Reject,
     /* 2397942 */ // Label 34343: @2397942
     /* 2397942 */ GIM_Try, /*On fail goto*//*Label 34381*/ GIMT_Encode4(2398062),
     /* 2397947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2397953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397965 */   GIM_Try, /*On fail goto*//*Label 34382*/ GIMT_Encode4(2398013), // Rule ID 54238 //
     /* 2397970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397973 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2397976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2397990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398012 */     // GIR_Coverage, 54238,
     /* 2398012 */     GIR_EraseRootFromParent_Done,
     /* 2398013 */   // Label 34382: @2398013
     /* 2398013 */   GIM_Try, /*On fail goto*//*Label 34383*/ GIMT_Encode4(2398061), // Rule ID 54239 //
     /* 2398018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398021 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2398024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2398038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398060 */     // GIR_Coverage, 54239,
     /* 2398060 */     GIR_EraseRootFromParent_Done,
     /* 2398061 */   // Label 34383: @2398061
     /* 2398061 */   GIM_Reject,
     /* 2398062 */ // Label 34381: @2398062
     /* 2398062 */ GIM_Reject,
     /* 2398063 */ // Label 34344: @2398063
     /* 2398063 */ GIM_Try, /*On fail goto*//*Label 34384*/ GIMT_Encode4(2398183),
     /* 2398068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2398074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398082 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398086 */   GIM_Try, /*On fail goto*//*Label 34385*/ GIMT_Encode4(2398134), // Rule ID 54274 //
     /* 2398091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398094 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2398097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2398111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398133 */     // GIR_Coverage, 54274,
     /* 2398133 */     GIR_EraseRootFromParent_Done,
     /* 2398134 */   // Label 34385: @2398134
     /* 2398134 */   GIM_Try, /*On fail goto*//*Label 34386*/ GIMT_Encode4(2398182), // Rule ID 54275 //
     /* 2398139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398142 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2398145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2398159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398181 */     // GIR_Coverage, 54275,
     /* 2398181 */     GIR_EraseRootFromParent_Done,
     /* 2398182 */   // Label 34386: @2398182
     /* 2398182 */   GIM_Reject,
     /* 2398183 */ // Label 34384: @2398183
     /* 2398183 */ GIM_Reject,
     /* 2398184 */ // Label 34345: @2398184
     /* 2398184 */ GIM_Try, /*On fail goto*//*Label 34387*/ GIMT_Encode4(2398304),
     /* 2398189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2398192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2398195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398207 */   GIM_Try, /*On fail goto*//*Label 34388*/ GIMT_Encode4(2398255), // Rule ID 54370 //
     /* 2398212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2398215 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2398218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2398232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398254 */     // GIR_Coverage, 54370,
     /* 2398254 */     GIR_EraseRootFromParent_Done,
     /* 2398255 */   // Label 34388: @2398255
     /* 2398255 */   GIM_Try, /*On fail goto*//*Label 34389*/ GIMT_Encode4(2398303), // Rule ID 54371 //
     /* 2398260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2398263 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2398266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2398280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398302 */     // GIR_Coverage, 54371,
     /* 2398302 */     GIR_EraseRootFromParent_Done,
     /* 2398303 */   // Label 34389: @2398303
     /* 2398303 */   GIM_Reject,
     /* 2398304 */ // Label 34387: @2398304
     /* 2398304 */ GIM_Reject,
     /* 2398305 */ // Label 34346: @2398305
     /* 2398305 */ GIM_Try, /*On fail goto*//*Label 34390*/ GIMT_Encode4(2398425),
     /* 2398310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2398313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2398316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398328 */   GIM_Try, /*On fail goto*//*Label 34391*/ GIMT_Encode4(2398376), // Rule ID 54262 //
     /* 2398333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398336 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2398339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2398353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398375 */     // GIR_Coverage, 54262,
     /* 2398375 */     GIR_EraseRootFromParent_Done,
     /* 2398376 */   // Label 34391: @2398376
     /* 2398376 */   GIM_Try, /*On fail goto*//*Label 34392*/ GIMT_Encode4(2398424), // Rule ID 54263 //
     /* 2398381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398384 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2398387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2398401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398423 */     // GIR_Coverage, 54263,
     /* 2398423 */     GIR_EraseRootFromParent_Done,
     /* 2398424 */   // Label 34392: @2398424
     /* 2398424 */   GIM_Reject,
     /* 2398425 */ // Label 34390: @2398425
     /* 2398425 */ GIM_Reject,
     /* 2398426 */ // Label 34347: @2398426
     /* 2398426 */ GIM_Try, /*On fail goto*//*Label 34393*/ GIMT_Encode4(2398546),
     /* 2398431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2398434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2398437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398449 */   GIM_Try, /*On fail goto*//*Label 34394*/ GIMT_Encode4(2398497), // Rule ID 54334 //
     /* 2398454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398457 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2398460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2398474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398496 */     // GIR_Coverage, 54334,
     /* 2398496 */     GIR_EraseRootFromParent_Done,
     /* 2398497 */   // Label 34394: @2398497
     /* 2398497 */   GIM_Try, /*On fail goto*//*Label 34395*/ GIMT_Encode4(2398545), // Rule ID 54335 //
     /* 2398502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398505 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2398508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2398522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398544 */     // GIR_Coverage, 54335,
     /* 2398544 */     GIR_EraseRootFromParent_Done,
     /* 2398545 */   // Label 34395: @2398545
     /* 2398545 */   GIM_Reject,
     /* 2398546 */ // Label 34393: @2398546
     /* 2398546 */ GIM_Reject,
     /* 2398547 */ // Label 34348: @2398547
     /* 2398547 */ GIM_Try, /*On fail goto*//*Label 34396*/ GIMT_Encode4(2398667),
     /* 2398552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2398555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2398558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398570 */   GIM_Try, /*On fail goto*//*Label 34397*/ GIMT_Encode4(2398618), // Rule ID 54382 //
     /* 2398575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2398578 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2398581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2398595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398617 */     // GIR_Coverage, 54382,
     /* 2398617 */     GIR_EraseRootFromParent_Done,
     /* 2398618 */   // Label 34397: @2398618
     /* 2398618 */   GIM_Try, /*On fail goto*//*Label 34398*/ GIMT_Encode4(2398666), // Rule ID 54383 //
     /* 2398623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2398626 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2398629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2398643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398665 */     // GIR_Coverage, 54383,
     /* 2398665 */     GIR_EraseRootFromParent_Done,
     /* 2398666 */   // Label 34398: @2398666
     /* 2398666 */   GIM_Reject,
     /* 2398667 */ // Label 34396: @2398667
     /* 2398667 */ GIM_Reject,
     /* 2398668 */ // Label 34349: @2398668
     /* 2398668 */ GIM_Try, /*On fail goto*//*Label 34399*/ GIMT_Encode4(2398788),
     /* 2398673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2398676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2398679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398691 */   GIM_Try, /*On fail goto*//*Label 34400*/ GIMT_Encode4(2398739), // Rule ID 54298 //
     /* 2398696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398699 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2398702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2398716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398738 */     // GIR_Coverage, 54298,
     /* 2398738 */     GIR_EraseRootFromParent_Done,
     /* 2398739 */   // Label 34400: @2398739
     /* 2398739 */   GIM_Try, /*On fail goto*//*Label 34401*/ GIMT_Encode4(2398787), // Rule ID 54299 //
     /* 2398744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398747 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2398750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2398764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398786 */     // GIR_Coverage, 54299,
     /* 2398786 */     GIR_EraseRootFromParent_Done,
     /* 2398787 */   // Label 34401: @2398787
     /* 2398787 */   GIM_Reject,
     /* 2398788 */ // Label 34399: @2398788
     /* 2398788 */ GIM_Reject,
     /* 2398789 */ // Label 34350: @2398789
     /* 2398789 */ GIM_Try, /*On fail goto*//*Label 34402*/ GIMT_Encode4(2398909),
     /* 2398794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2398800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398812 */   GIM_Try, /*On fail goto*//*Label 34403*/ GIMT_Encode4(2398860), // Rule ID 54346 //
     /* 2398817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398820 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2398823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2398837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398859 */     // GIR_Coverage, 54346,
     /* 2398859 */     GIR_EraseRootFromParent_Done,
     /* 2398860 */   // Label 34403: @2398860
     /* 2398860 */   GIM_Try, /*On fail goto*//*Label 34404*/ GIMT_Encode4(2398908), // Rule ID 54347 //
     /* 2398865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398868 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2398871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2398885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398907 */     // GIR_Coverage, 54347,
     /* 2398907 */     GIR_EraseRootFromParent_Done,
     /* 2398908 */   // Label 34404: @2398908
     /* 2398908 */   GIM_Reject,
     /* 2398909 */ // Label 34402: @2398909
     /* 2398909 */ GIM_Reject,
     /* 2398910 */ // Label 34351: @2398910
     /* 2398910 */ GIM_Try, /*On fail goto*//*Label 34405*/ GIMT_Encode4(2399030),
     /* 2398915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2398918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2398921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398933 */   GIM_Try, /*On fail goto*//*Label 34406*/ GIMT_Encode4(2398981), // Rule ID 54394 //
     /* 2398938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2398941 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2398944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2398958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398980 */     // GIR_Coverage, 54394,
     /* 2398980 */     GIR_EraseRootFromParent_Done,
     /* 2398981 */   // Label 34406: @2398981
     /* 2398981 */   GIM_Try, /*On fail goto*//*Label 34407*/ GIMT_Encode4(2399029), // Rule ID 54395 //
     /* 2398986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2398989 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2398992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2399006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399028 */     // GIR_Coverage, 54395,
     /* 2399028 */     GIR_EraseRootFromParent_Done,
     /* 2399029 */   // Label 34407: @2399029
     /* 2399029 */   GIM_Reject,
     /* 2399030 */ // Label 34405: @2399030
     /* 2399030 */ GIM_Reject,
     /* 2399031 */ // Label 34352: @2399031
     /* 2399031 */ GIM_Try, /*On fail goto*//*Label 34408*/ GIMT_Encode4(2399151),
     /* 2399036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2399039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2399042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399050 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399054 */   GIM_Try, /*On fail goto*//*Label 34409*/ GIMT_Encode4(2399102), // Rule ID 54310 //
     /* 2399059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399062 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2399065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2399079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399101 */     // GIR_Coverage, 54310,
     /* 2399101 */     GIR_EraseRootFromParent_Done,
     /* 2399102 */   // Label 34409: @2399102
     /* 2399102 */   GIM_Try, /*On fail goto*//*Label 34410*/ GIMT_Encode4(2399150), // Rule ID 54311 //
     /* 2399107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2399110 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2399113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2399127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399149 */     // GIR_Coverage, 54311,
     /* 2399149 */     GIR_EraseRootFromParent_Done,
     /* 2399150 */   // Label 34410: @2399150
     /* 2399150 */   GIM_Reject,
     /* 2399151 */ // Label 34408: @2399151
     /* 2399151 */ GIM_Reject,
     /* 2399152 */ // Label 34353: @2399152
     /* 2399152 */ GIM_Try, /*On fail goto*//*Label 34411*/ GIMT_Encode4(2399272),
     /* 2399157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2399160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2399163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399171 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399175 */   GIM_Try, /*On fail goto*//*Label 34412*/ GIMT_Encode4(2399223), // Rule ID 54358 //
     /* 2399180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2399183 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2399186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2399200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399222 */     // GIR_Coverage, 54358,
     /* 2399222 */     GIR_EraseRootFromParent_Done,
     /* 2399223 */   // Label 34412: @2399223
     /* 2399223 */   GIM_Try, /*On fail goto*//*Label 34413*/ GIMT_Encode4(2399271), // Rule ID 54359 //
     /* 2399228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2399231 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2399234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2399248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399270 */     // GIR_Coverage, 54359,
     /* 2399270 */     GIR_EraseRootFromParent_Done,
     /* 2399271 */   // Label 34413: @2399271
     /* 2399271 */   GIM_Reject,
     /* 2399272 */ // Label 34411: @2399272
     /* 2399272 */ GIM_Reject,
     /* 2399273 */ // Label 34354: @2399273
     /* 2399273 */ GIM_Try, /*On fail goto*//*Label 34414*/ GIMT_Encode4(2399393),
     /* 2399278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2399281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2399284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399296 */   GIM_Try, /*On fail goto*//*Label 34415*/ GIMT_Encode4(2399344), // Rule ID 54322 //
     /* 2399301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399304 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2399307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2399321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399343 */     // GIR_Coverage, 54322,
     /* 2399343 */     GIR_EraseRootFromParent_Done,
     /* 2399344 */   // Label 34415: @2399344
     /* 2399344 */   GIM_Try, /*On fail goto*//*Label 34416*/ GIMT_Encode4(2399392), // Rule ID 54323 //
     /* 2399349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2399352 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2399355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2399369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399391 */     // GIR_Coverage, 54323,
     /* 2399391 */     GIR_EraseRootFromParent_Done,
     /* 2399392 */   // Label 34416: @2399392
     /* 2399392 */   GIM_Reject,
     /* 2399393 */ // Label 34414: @2399393
     /* 2399393 */ GIM_Reject,
     /* 2399394 */ // Label 34355: @2399394
     /* 2399394 */ GIM_Reject,
     /* 2399395 */ // Label 101: @2399395
     /* 2399395 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34435*/ GIMT_Encode4(2401822),
     /* 2399406 */ /*GILLT_s16*//*Label 34417*/ GIMT_Encode4(2399526),
     /* 2399410 */ /*GILLT_s32*//*Label 34418*/ GIMT_Encode4(2399675),
     /* 2399414 */ /*GILLT_s64*//*Label 34419*/ GIMT_Encode4(2399824), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2399426 */ /*GILLT_nxv1s16*//*Label 34420*/ GIMT_Encode4(2400007),
     /* 2399430 */ /*GILLT_nxv1s32*//*Label 34421*/ GIMT_Encode4(2400128),
     /* 2399434 */ /*GILLT_nxv1s64*//*Label 34422*/ GIMT_Encode4(2400249), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2399446 */ /*GILLT_nxv2s16*//*Label 34423*/ GIMT_Encode4(2400370),
     /* 2399450 */ /*GILLT_nxv2s32*//*Label 34424*/ GIMT_Encode4(2400491),
     /* 2399454 */ /*GILLT_nxv2s64*//*Label 34425*/ GIMT_Encode4(2400612), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2399466 */ /*GILLT_nxv4s16*//*Label 34426*/ GIMT_Encode4(2400733),
     /* 2399470 */ /*GILLT_nxv4s32*//*Label 34427*/ GIMT_Encode4(2400854),
     /* 2399474 */ /*GILLT_nxv4s64*//*Label 34428*/ GIMT_Encode4(2400975), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2399486 */ /*GILLT_nxv8s16*//*Label 34429*/ GIMT_Encode4(2401096),
     /* 2399490 */ /*GILLT_nxv8s32*//*Label 34430*/ GIMT_Encode4(2401217),
     /* 2399494 */ /*GILLT_nxv8s64*//*Label 34431*/ GIMT_Encode4(2401338), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2399506 */ /*GILLT_nxv16s16*//*Label 34432*/ GIMT_Encode4(2401459),
     /* 2399510 */ /*GILLT_nxv16s32*//*Label 34433*/ GIMT_Encode4(2401580), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2399522 */ /*GILLT_nxv32s16*//*Label 34434*/ GIMT_Encode4(2401701),
     /* 2399526 */ // Label 34417: @2399526
     /* 2399526 */ GIM_Try, /*On fail goto*//*Label 34436*/ GIMT_Encode4(2399674),
     /* 2399531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2399534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2399537 */   GIM_Try, /*On fail goto*//*Label 34437*/ GIMT_Encode4(2399571), // Rule ID 1980 //
     /* 2399542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2399545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2399549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2399553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2399557 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2399557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2399560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399570 */     // GIR_Coverage, 1980,
     /* 2399570 */     GIR_EraseRootFromParent_Done,
     /* 2399571 */   // Label 34437: @2399571
     /* 2399571 */   GIM_Try, /*On fail goto*//*Label 34438*/ GIMT_Encode4(2399605), // Rule ID 1981 //
     /* 2399576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2399579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2399583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2399587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2399591 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2399591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2399594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399604 */     // GIR_Coverage, 1981,
     /* 2399604 */     GIR_EraseRootFromParent_Done,
     /* 2399605 */   // Label 34438: @2399605
     /* 2399605 */   GIM_Try, /*On fail goto*//*Label 34439*/ GIMT_Encode4(2399639), // Rule ID 1984 //
     /* 2399610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2399613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399625 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2399625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2399628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399638 */     // GIR_Coverage, 1984,
     /* 2399638 */     GIR_EraseRootFromParent_Done,
     /* 2399639 */   // Label 34439: @2399639
     /* 2399639 */   GIM_Try, /*On fail goto*//*Label 34440*/ GIMT_Encode4(2399673), // Rule ID 1985 //
     /* 2399644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2399647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399659 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2399659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2399662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399672 */     // GIR_Coverage, 1985,
     /* 2399672 */     GIR_EraseRootFromParent_Done,
     /* 2399673 */   // Label 34440: @2399673
     /* 2399673 */   GIM_Reject,
     /* 2399674 */ // Label 34436: @2399674
     /* 2399674 */ GIM_Reject,
     /* 2399675 */ // Label 34418: @2399675
     /* 2399675 */ GIM_Try, /*On fail goto*//*Label 34441*/ GIMT_Encode4(2399823),
     /* 2399680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2399683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2399686 */   GIM_Try, /*On fail goto*//*Label 34442*/ GIMT_Encode4(2399720), // Rule ID 1271 //
     /* 2399691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2399694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399706 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2399706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2399709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399719 */     // GIR_Coverage, 1271,
     /* 2399719 */     GIR_EraseRootFromParent_Done,
     /* 2399720 */   // Label 34442: @2399720
     /* 2399720 */   GIM_Try, /*On fail goto*//*Label 34443*/ GIMT_Encode4(2399754), // Rule ID 1272 //
     /* 2399725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2399728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399740 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2399740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2399743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399753 */     // GIR_Coverage, 1272,
     /* 2399753 */     GIR_EraseRootFromParent_Done,
     /* 2399754 */   // Label 34443: @2399754
     /* 2399754 */   GIM_Try, /*On fail goto*//*Label 34444*/ GIMT_Encode4(2399788), // Rule ID 1275 //
     /* 2399759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2399762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399774 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2399774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2399777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399787 */     // GIR_Coverage, 1275,
     /* 2399787 */     GIR_EraseRootFromParent_Done,
     /* 2399788 */   // Label 34444: @2399788
     /* 2399788 */   GIM_Try, /*On fail goto*//*Label 34445*/ GIMT_Encode4(2399822), // Rule ID 1276 //
     /* 2399793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2399796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399808 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2399808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2399811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399821 */     // GIR_Coverage, 1276,
     /* 2399821 */     GIR_EraseRootFromParent_Done,
     /* 2399822 */   // Label 34445: @2399822
     /* 2399822 */   GIM_Reject,
     /* 2399823 */ // Label 34441: @2399823
     /* 2399823 */ GIM_Reject,
     /* 2399824 */ // Label 34419: @2399824
     /* 2399824 */ GIM_Try, /*On fail goto*//*Label 34446*/ GIMT_Encode4(2400006),
     /* 2399829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2399832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2399835 */   GIM_Try, /*On fail goto*//*Label 34447*/ GIMT_Encode4(2399869), // Rule ID 1612 //
     /* 2399840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2399843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399855 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2399855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2399858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399868 */     // GIR_Coverage, 1612,
     /* 2399868 */     GIR_EraseRootFromParent_Done,
     /* 2399869 */   // Label 34447: @2399869
     /* 2399869 */   GIM_Try, /*On fail goto*//*Label 34448*/ GIMT_Encode4(2399903), // Rule ID 1613 //
     /* 2399874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2399877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399889 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2399889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2399892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399902 */     // GIR_Coverage, 1613,
     /* 2399902 */     GIR_EraseRootFromParent_Done,
     /* 2399903 */   // Label 34448: @2399903
     /* 2399903 */   GIM_Try, /*On fail goto*//*Label 34449*/ GIMT_Encode4(2399937), // Rule ID 1616 //
     /* 2399908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2399911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399923 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2399923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2399926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399936 */     // GIR_Coverage, 1616,
     /* 2399936 */     GIR_EraseRootFromParent_Done,
     /* 2399937 */   // Label 34449: @2399937
     /* 2399937 */   GIM_Try, /*On fail goto*//*Label 34450*/ GIMT_Encode4(2399971), // Rule ID 1617 //
     /* 2399942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2399945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399957 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2399957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2399960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399970 */     // GIR_Coverage, 1617,
     /* 2399970 */     GIR_EraseRootFromParent_Done,
     /* 2399971 */   // Label 34450: @2399971
     /* 2399971 */   GIM_Try, /*On fail goto*//*Label 34451*/ GIMT_Encode4(2400005), // Rule ID 1620 //
     /* 2399976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2399979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2399983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2399987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2399991 */     // (strict_fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2399991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2399994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400004 */     // GIR_Coverage, 1620,
     /* 2400004 */     GIR_EraseRootFromParent_Done,
     /* 2400005 */   // Label 34451: @2400005
     /* 2400005 */   GIM_Reject,
     /* 2400006 */ // Label 34446: @2400006
     /* 2400006 */ GIM_Reject,
     /* 2400007 */ // Label 34420: @2400007
     /* 2400007 */ GIM_Try, /*On fail goto*//*Label 34452*/ GIMT_Encode4(2400127),
     /* 2400012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2400015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2400018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400030 */   GIM_Try, /*On fail goto*//*Label 34453*/ GIMT_Encode4(2400078), // Rule ID 54406 //
     /* 2400035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400038 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2400041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2400055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400077 */     // GIR_Coverage, 54406,
     /* 2400077 */     GIR_EraseRootFromParent_Done,
     /* 2400078 */   // Label 34453: @2400078
     /* 2400078 */   GIM_Try, /*On fail goto*//*Label 34454*/ GIMT_Encode4(2400126), // Rule ID 54407 //
     /* 2400083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400086 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2400089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2400103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400125 */     // GIR_Coverage, 54407,
     /* 2400125 */     GIR_EraseRootFromParent_Done,
     /* 2400126 */   // Label 34454: @2400126
     /* 2400126 */   GIM_Reject,
     /* 2400127 */ // Label 34452: @2400127
     /* 2400127 */ GIM_Reject,
     /* 2400128 */ // Label 34421: @2400128
     /* 2400128 */ GIM_Try, /*On fail goto*//*Label 34455*/ GIMT_Encode4(2400248),
     /* 2400133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2400136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2400139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400151 */   GIM_Try, /*On fail goto*//*Label 34456*/ GIMT_Encode4(2400199), // Rule ID 54430 //
     /* 2400156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400159 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2400162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2400176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400198 */     // GIR_Coverage, 54430,
     /* 2400198 */     GIR_EraseRootFromParent_Done,
     /* 2400199 */   // Label 34456: @2400199
     /* 2400199 */   GIM_Try, /*On fail goto*//*Label 34457*/ GIMT_Encode4(2400247), // Rule ID 54431 //
     /* 2400204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400207 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2400210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2400224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400246 */     // GIR_Coverage, 54431,
     /* 2400246 */     GIR_EraseRootFromParent_Done,
     /* 2400247 */   // Label 34457: @2400247
     /* 2400247 */   GIM_Reject,
     /* 2400248 */ // Label 34455: @2400248
     /* 2400248 */ GIM_Reject,
     /* 2400249 */ // Label 34422: @2400249
     /* 2400249 */ GIM_Try, /*On fail goto*//*Label 34458*/ GIMT_Encode4(2400369),
     /* 2400254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2400257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2400260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400272 */   GIM_Try, /*On fail goto*//*Label 34459*/ GIMT_Encode4(2400320), // Rule ID 54466 //
     /* 2400277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2400280 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2400283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2400297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400319 */     // GIR_Coverage, 54466,
     /* 2400319 */     GIR_EraseRootFromParent_Done,
     /* 2400320 */   // Label 34459: @2400320
     /* 2400320 */   GIM_Try, /*On fail goto*//*Label 34460*/ GIMT_Encode4(2400368), // Rule ID 54467 //
     /* 2400325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2400328 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2400331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2400345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400367 */     // GIR_Coverage, 54467,
     /* 2400367 */     GIR_EraseRootFromParent_Done,
     /* 2400368 */   // Label 34460: @2400368
     /* 2400368 */   GIM_Reject,
     /* 2400369 */ // Label 34458: @2400369
     /* 2400369 */ GIM_Reject,
     /* 2400370 */ // Label 34423: @2400370
     /* 2400370 */ GIM_Try, /*On fail goto*//*Label 34461*/ GIMT_Encode4(2400490),
     /* 2400375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2400378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2400381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400393 */   GIM_Try, /*On fail goto*//*Label 34462*/ GIMT_Encode4(2400441), // Rule ID 54418 //
     /* 2400398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400401 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2400404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2400418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400440 */     // GIR_Coverage, 54418,
     /* 2400440 */     GIR_EraseRootFromParent_Done,
     /* 2400441 */   // Label 34462: @2400441
     /* 2400441 */   GIM_Try, /*On fail goto*//*Label 34463*/ GIMT_Encode4(2400489), // Rule ID 54419 //
     /* 2400446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400449 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2400452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2400466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400488 */     // GIR_Coverage, 54419,
     /* 2400488 */     GIR_EraseRootFromParent_Done,
     /* 2400489 */   // Label 34463: @2400489
     /* 2400489 */   GIM_Reject,
     /* 2400490 */ // Label 34461: @2400490
     /* 2400490 */ GIM_Reject,
     /* 2400491 */ // Label 34424: @2400491
     /* 2400491 */ GIM_Try, /*On fail goto*//*Label 34464*/ GIMT_Encode4(2400611),
     /* 2400496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2400499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2400502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400514 */   GIM_Try, /*On fail goto*//*Label 34465*/ GIMT_Encode4(2400562), // Rule ID 54454 //
     /* 2400519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400522 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2400525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2400539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400561 */     // GIR_Coverage, 54454,
     /* 2400561 */     GIR_EraseRootFromParent_Done,
     /* 2400562 */   // Label 34465: @2400562
     /* 2400562 */   GIM_Try, /*On fail goto*//*Label 34466*/ GIMT_Encode4(2400610), // Rule ID 54455 //
     /* 2400567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400570 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2400573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2400587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400609 */     // GIR_Coverage, 54455,
     /* 2400609 */     GIR_EraseRootFromParent_Done,
     /* 2400610 */   // Label 34466: @2400610
     /* 2400610 */   GIM_Reject,
     /* 2400611 */ // Label 34464: @2400611
     /* 2400611 */ GIM_Reject,
     /* 2400612 */ // Label 34425: @2400612
     /* 2400612 */ GIM_Try, /*On fail goto*//*Label 34467*/ GIMT_Encode4(2400732),
     /* 2400617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2400620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2400623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400635 */   GIM_Try, /*On fail goto*//*Label 34468*/ GIMT_Encode4(2400683), // Rule ID 54550 //
     /* 2400640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2400643 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2400646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2400660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400682 */     // GIR_Coverage, 54550,
     /* 2400682 */     GIR_EraseRootFromParent_Done,
     /* 2400683 */   // Label 34468: @2400683
     /* 2400683 */   GIM_Try, /*On fail goto*//*Label 34469*/ GIMT_Encode4(2400731), // Rule ID 54551 //
     /* 2400688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2400691 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2400694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2400708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400730 */     // GIR_Coverage, 54551,
     /* 2400730 */     GIR_EraseRootFromParent_Done,
     /* 2400731 */   // Label 34469: @2400731
     /* 2400731 */   GIM_Reject,
     /* 2400732 */ // Label 34467: @2400732
     /* 2400732 */ GIM_Reject,
     /* 2400733 */ // Label 34426: @2400733
     /* 2400733 */ GIM_Try, /*On fail goto*//*Label 34470*/ GIMT_Encode4(2400853),
     /* 2400738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2400741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2400744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400756 */   GIM_Try, /*On fail goto*//*Label 34471*/ GIMT_Encode4(2400804), // Rule ID 54442 //
     /* 2400761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400764 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2400767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2400781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400803 */     // GIR_Coverage, 54442,
     /* 2400803 */     GIR_EraseRootFromParent_Done,
     /* 2400804 */   // Label 34471: @2400804
     /* 2400804 */   GIM_Try, /*On fail goto*//*Label 34472*/ GIMT_Encode4(2400852), // Rule ID 54443 //
     /* 2400809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400812 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2400815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2400829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400851 */     // GIR_Coverage, 54443,
     /* 2400851 */     GIR_EraseRootFromParent_Done,
     /* 2400852 */   // Label 34472: @2400852
     /* 2400852 */   GIM_Reject,
     /* 2400853 */ // Label 34470: @2400853
     /* 2400853 */ GIM_Reject,
     /* 2400854 */ // Label 34427: @2400854
     /* 2400854 */ GIM_Try, /*On fail goto*//*Label 34473*/ GIMT_Encode4(2400974),
     /* 2400859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2400865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400877 */   GIM_Try, /*On fail goto*//*Label 34474*/ GIMT_Encode4(2400925), // Rule ID 54514 //
     /* 2400882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400885 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2400888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2400902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400924 */     // GIR_Coverage, 54514,
     /* 2400924 */     GIR_EraseRootFromParent_Done,
     /* 2400925 */   // Label 34474: @2400925
     /* 2400925 */   GIM_Try, /*On fail goto*//*Label 34475*/ GIMT_Encode4(2400973), // Rule ID 54515 //
     /* 2400930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400933 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2400936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2400950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400972 */     // GIR_Coverage, 54515,
     /* 2400972 */     GIR_EraseRootFromParent_Done,
     /* 2400973 */   // Label 34475: @2400973
     /* 2400973 */   GIM_Reject,
     /* 2400974 */ // Label 34473: @2400974
     /* 2400974 */ GIM_Reject,
     /* 2400975 */ // Label 34428: @2400975
     /* 2400975 */ GIM_Try, /*On fail goto*//*Label 34476*/ GIMT_Encode4(2401095),
     /* 2400980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2400983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2400986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400994 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400998 */   GIM_Try, /*On fail goto*//*Label 34477*/ GIMT_Encode4(2401046), // Rule ID 54562 //
     /* 2401003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401006 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2401009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2401023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401045 */     // GIR_Coverage, 54562,
     /* 2401045 */     GIR_EraseRootFromParent_Done,
     /* 2401046 */   // Label 34477: @2401046
     /* 2401046 */   GIM_Try, /*On fail goto*//*Label 34478*/ GIMT_Encode4(2401094), // Rule ID 54563 //
     /* 2401051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2401054 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2401057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2401071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401093 */     // GIR_Coverage, 54563,
     /* 2401093 */     GIR_EraseRootFromParent_Done,
     /* 2401094 */   // Label 34478: @2401094
     /* 2401094 */   GIM_Reject,
     /* 2401095 */ // Label 34476: @2401095
     /* 2401095 */ GIM_Reject,
     /* 2401096 */ // Label 34429: @2401096
     /* 2401096 */ GIM_Try, /*On fail goto*//*Label 34479*/ GIMT_Encode4(2401216),
     /* 2401101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2401104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2401107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401119 */   GIM_Try, /*On fail goto*//*Label 34480*/ GIMT_Encode4(2401167), // Rule ID 54478 //
     /* 2401124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401127 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2401130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2401144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401166 */     // GIR_Coverage, 54478,
     /* 2401166 */     GIR_EraseRootFromParent_Done,
     /* 2401167 */   // Label 34480: @2401167
     /* 2401167 */   GIM_Try, /*On fail goto*//*Label 34481*/ GIMT_Encode4(2401215), // Rule ID 54479 //
     /* 2401172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2401175 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2401178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2401192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401214 */     // GIR_Coverage, 54479,
     /* 2401214 */     GIR_EraseRootFromParent_Done,
     /* 2401215 */   // Label 34481: @2401215
     /* 2401215 */   GIM_Reject,
     /* 2401216 */ // Label 34479: @2401216
     /* 2401216 */ GIM_Reject,
     /* 2401217 */ // Label 34430: @2401217
     /* 2401217 */ GIM_Try, /*On fail goto*//*Label 34482*/ GIMT_Encode4(2401337),
     /* 2401222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2401225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2401228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401240 */   GIM_Try, /*On fail goto*//*Label 34483*/ GIMT_Encode4(2401288), // Rule ID 54526 //
     /* 2401245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401248 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2401251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2401265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401287 */     // GIR_Coverage, 54526,
     /* 2401287 */     GIR_EraseRootFromParent_Done,
     /* 2401288 */   // Label 34483: @2401288
     /* 2401288 */   GIM_Try, /*On fail goto*//*Label 34484*/ GIMT_Encode4(2401336), // Rule ID 54527 //
     /* 2401293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401296 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2401299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2401313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401335 */     // GIR_Coverage, 54527,
     /* 2401335 */     GIR_EraseRootFromParent_Done,
     /* 2401336 */   // Label 34484: @2401336
     /* 2401336 */   GIM_Reject,
     /* 2401337 */ // Label 34482: @2401337
     /* 2401337 */ GIM_Reject,
     /* 2401338 */ // Label 34431: @2401338
     /* 2401338 */ GIM_Try, /*On fail goto*//*Label 34485*/ GIMT_Encode4(2401458),
     /* 2401343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2401346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2401349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401361 */   GIM_Try, /*On fail goto*//*Label 34486*/ GIMT_Encode4(2401409), // Rule ID 54574 //
     /* 2401366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401369 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2401372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2401386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401408 */     // GIR_Coverage, 54574,
     /* 2401408 */     GIR_EraseRootFromParent_Done,
     /* 2401409 */   // Label 34486: @2401409
     /* 2401409 */   GIM_Try, /*On fail goto*//*Label 34487*/ GIMT_Encode4(2401457), // Rule ID 54575 //
     /* 2401414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2401417 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2401420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2401434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401456 */     // GIR_Coverage, 54575,
     /* 2401456 */     GIR_EraseRootFromParent_Done,
     /* 2401457 */   // Label 34487: @2401457
     /* 2401457 */   GIM_Reject,
     /* 2401458 */ // Label 34485: @2401458
     /* 2401458 */ GIM_Reject,
     /* 2401459 */ // Label 34432: @2401459
     /* 2401459 */ GIM_Try, /*On fail goto*//*Label 34488*/ GIMT_Encode4(2401579),
     /* 2401464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2401467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2401470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401482 */   GIM_Try, /*On fail goto*//*Label 34489*/ GIMT_Encode4(2401530), // Rule ID 54490 //
     /* 2401487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401490 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2401493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2401507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401529 */     // GIR_Coverage, 54490,
     /* 2401529 */     GIR_EraseRootFromParent_Done,
     /* 2401530 */   // Label 34489: @2401530
     /* 2401530 */   GIM_Try, /*On fail goto*//*Label 34490*/ GIMT_Encode4(2401578), // Rule ID 54491 //
     /* 2401535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2401538 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2401541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2401555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401577 */     // GIR_Coverage, 54491,
     /* 2401577 */     GIR_EraseRootFromParent_Done,
     /* 2401578 */   // Label 34490: @2401578
     /* 2401578 */   GIM_Reject,
     /* 2401579 */ // Label 34488: @2401579
     /* 2401579 */ GIM_Reject,
     /* 2401580 */ // Label 34433: @2401580
     /* 2401580 */ GIM_Try, /*On fail goto*//*Label 34491*/ GIMT_Encode4(2401700),
     /* 2401585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2401591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401603 */   GIM_Try, /*On fail goto*//*Label 34492*/ GIMT_Encode4(2401651), // Rule ID 54538 //
     /* 2401608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401611 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2401614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2401628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401650 */     // GIR_Coverage, 54538,
     /* 2401650 */     GIR_EraseRootFromParent_Done,
     /* 2401651 */   // Label 34492: @2401651
     /* 2401651 */   GIM_Try, /*On fail goto*//*Label 34493*/ GIMT_Encode4(2401699), // Rule ID 54539 //
     /* 2401656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401659 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2401662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2401676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401698 */     // GIR_Coverage, 54539,
     /* 2401698 */     GIR_EraseRootFromParent_Done,
     /* 2401699 */   // Label 34493: @2401699
     /* 2401699 */   GIM_Reject,
     /* 2401700 */ // Label 34491: @2401700
     /* 2401700 */ GIM_Reject,
     /* 2401701 */ // Label 34434: @2401701
     /* 2401701 */ GIM_Try, /*On fail goto*//*Label 34494*/ GIMT_Encode4(2401821),
     /* 2401706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2401709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2401712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401724 */   GIM_Try, /*On fail goto*//*Label 34495*/ GIMT_Encode4(2401772), // Rule ID 54502 //
     /* 2401729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401732 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2401735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2401749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401771 */     // GIR_Coverage, 54502,
     /* 2401771 */     GIR_EraseRootFromParent_Done,
     /* 2401772 */   // Label 34495: @2401772
     /* 2401772 */   GIM_Try, /*On fail goto*//*Label 34496*/ GIMT_Encode4(2401820), // Rule ID 54503 //
     /* 2401777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2401780 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2401783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2401797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401819 */     // GIR_Coverage, 54503,
     /* 2401819 */     GIR_EraseRootFromParent_Done,
     /* 2401820 */   // Label 34496: @2401820
     /* 2401820 */   GIM_Reject,
     /* 2401821 */ // Label 34494: @2401821
     /* 2401821 */ GIM_Reject,
     /* 2401822 */ // Label 34435: @2401822
     /* 2401822 */ GIM_Reject,
     /* 2401823 */ // Label 102: @2401823
     /* 2401823 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34515*/ GIMT_Encode4(2418467),
     /* 2401834 */ /*GILLT_s16*//*Label 34497*/ GIMT_Encode4(2401954),
     /* 2401838 */ /*GILLT_s32*//*Label 34498*/ GIMT_Encode4(2403390),
     /* 2401842 */ /*GILLT_s64*//*Label 34499*/ GIMT_Encode4(2404826), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401854 */ /*GILLT_nxv1s16*//*Label 34500*/ GIMT_Encode4(2406617),
     /* 2401858 */ /*GILLT_nxv1s32*//*Label 34501*/ GIMT_Encode4(2407407),
     /* 2401862 */ /*GILLT_nxv1s64*//*Label 34502*/ GIMT_Encode4(2408197), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401874 */ /*GILLT_nxv2s16*//*Label 34503*/ GIMT_Encode4(2408987),
     /* 2401878 */ /*GILLT_nxv2s32*//*Label 34504*/ GIMT_Encode4(2409777),
     /* 2401882 */ /*GILLT_nxv2s64*//*Label 34505*/ GIMT_Encode4(2410567), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401894 */ /*GILLT_nxv4s16*//*Label 34506*/ GIMT_Encode4(2411357),
     /* 2401898 */ /*GILLT_nxv4s32*//*Label 34507*/ GIMT_Encode4(2412147),
     /* 2401902 */ /*GILLT_nxv4s64*//*Label 34508*/ GIMT_Encode4(2412937), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401914 */ /*GILLT_nxv8s16*//*Label 34509*/ GIMT_Encode4(2413727),
     /* 2401918 */ /*GILLT_nxv8s32*//*Label 34510*/ GIMT_Encode4(2414517),
     /* 2401922 */ /*GILLT_nxv8s64*//*Label 34511*/ GIMT_Encode4(2415307), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401934 */ /*GILLT_nxv16s16*//*Label 34512*/ GIMT_Encode4(2416097),
     /* 2401938 */ /*GILLT_nxv16s32*//*Label 34513*/ GIMT_Encode4(2416887), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401950 */ /*GILLT_nxv32s16*//*Label 34514*/ GIMT_Encode4(2417677),
     /* 2401954 */ // Label 34497: @2401954
     /* 2401954 */ GIM_Try, /*On fail goto*//*Label 34516*/ GIMT_Encode4(2403389),
     /* 2401959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2401965 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2401968 */   GIM_Try, /*On fail goto*//*Label 34517*/ GIMT_Encode4(2402040), // Rule ID 2013 //
     /* 2401973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2401976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402020 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2402023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2402035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402039 */     // GIR_Coverage, 2013,
     /* 2402039 */     GIR_EraseRootFromParent_Done,
     /* 2402040 */   // Label 34517: @2402040
     /* 2402040 */   GIM_Try, /*On fail goto*//*Label 34518*/ GIMT_Encode4(2402112), // Rule ID 2014 //
     /* 2402045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2402048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402092 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2402095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2402107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402111 */     // GIR_Coverage, 2014,
     /* 2402111 */     GIR_EraseRootFromParent_Done,
     /* 2402112 */   // Label 34518: @2402112
     /* 2402112 */   GIM_Try, /*On fail goto*//*Label 34519*/ GIMT_Encode4(2402184), // Rule ID 2046 //
     /* 2402117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2402120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402164 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2402167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2402179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402183 */     // GIR_Coverage, 2046,
     /* 2402183 */     GIR_EraseRootFromParent_Done,
     /* 2402184 */   // Label 34519: @2402184
     /* 2402184 */   GIM_Try, /*On fail goto*//*Label 34520*/ GIMT_Encode4(2402256), // Rule ID 2047 //
     /* 2402189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2402192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402236 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2402239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2402251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402255 */     // GIR_Coverage, 2047,
     /* 2402255 */     GIR_EraseRootFromParent_Done,
     /* 2402256 */   // Label 34520: @2402256
     /* 2402256 */   GIM_Try, /*On fail goto*//*Label 34521*/ GIMT_Encode4(2402328), // Rule ID 65472 //
     /* 2402261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2402264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402308 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2402311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2402323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402327 */     // GIR_Coverage, 65472,
     /* 2402327 */     GIR_EraseRootFromParent_Done,
     /* 2402328 */   // Label 34521: @2402328
     /* 2402328 */   GIM_Try, /*On fail goto*//*Label 34522*/ GIMT_Encode4(2402400), // Rule ID 65473 //
     /* 2402333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2402336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402380 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2402383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2402395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402399 */     // GIR_Coverage, 65473,
     /* 2402399 */     GIR_EraseRootFromParent_Done,
     /* 2402400 */   // Label 34522: @2402400
     /* 2402400 */   GIM_Try, /*On fail goto*//*Label 34523*/ GIMT_Encode4(2402472), // Rule ID 65480 //
     /* 2402405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2402408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402452 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2402455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2402467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402471 */     // GIR_Coverage, 65480,
     /* 2402471 */     GIR_EraseRootFromParent_Done,
     /* 2402472 */   // Label 34523: @2402472
     /* 2402472 */   GIM_Try, /*On fail goto*//*Label 34524*/ GIMT_Encode4(2402544), // Rule ID 65481 //
     /* 2402477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2402480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402524 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2402527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2402539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402543 */     // GIR_Coverage, 65481,
     /* 2402543 */     GIR_EraseRootFromParent_Done,
     /* 2402544 */   // Label 34524: @2402544
     /* 2402544 */   GIM_Try, /*On fail goto*//*Label 34525*/ GIMT_Encode4(2402601), // Rule ID 2009 //
     /* 2402549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2402552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402583 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2402586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402600 */     // GIR_Coverage, 2009,
     /* 2402600 */     GIR_EraseRootFromParent_Done,
     /* 2402601 */   // Label 34525: @2402601
     /* 2402601 */   GIM_Try, /*On fail goto*//*Label 34526*/ GIMT_Encode4(2402658), // Rule ID 2010 //
     /* 2402606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2402609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402640 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2402643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402657 */     // GIR_Coverage, 2010,
     /* 2402657 */     GIR_EraseRootFromParent_Done,
     /* 2402658 */   // Label 34526: @2402658
     /* 2402658 */   GIM_Try, /*On fail goto*//*Label 34527*/ GIMT_Encode4(2402715), // Rule ID 2042 //
     /* 2402663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2402666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402697 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2402700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402714 */     // GIR_Coverage, 2042,
     /* 2402714 */     GIR_EraseRootFromParent_Done,
     /* 2402715 */   // Label 34527: @2402715
     /* 2402715 */   GIM_Try, /*On fail goto*//*Label 34528*/ GIMT_Encode4(2402772), // Rule ID 2043 //
     /* 2402720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2402723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402754 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2402757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402771 */     // GIR_Coverage, 2043,
     /* 2402771 */     GIR_EraseRootFromParent_Done,
     /* 2402772 */   // Label 34528: @2402772
     /* 2402772 */   GIM_Try, /*On fail goto*//*Label 34529*/ GIMT_Encode4(2402829), // Rule ID 65468 //
     /* 2402777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2402780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402811 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2402814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402828 */     // GIR_Coverage, 65468,
     /* 2402828 */     GIR_EraseRootFromParent_Done,
     /* 2402829 */   // Label 34529: @2402829
     /* 2402829 */   GIM_Try, /*On fail goto*//*Label 34530*/ GIMT_Encode4(2402886), // Rule ID 65469 //
     /* 2402834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2402837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402868 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2402871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402885 */     // GIR_Coverage, 65469,
     /* 2402885 */     GIR_EraseRootFromParent_Done,
     /* 2402886 */   // Label 34530: @2402886
     /* 2402886 */   GIM_Try, /*On fail goto*//*Label 34531*/ GIMT_Encode4(2402943), // Rule ID 65476 //
     /* 2402891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2402894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402925 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2402928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402942 */     // GIR_Coverage, 65476,
     /* 2402942 */     GIR_EraseRootFromParent_Done,
     /* 2402943 */   // Label 34531: @2402943
     /* 2402943 */   GIM_Try, /*On fail goto*//*Label 34532*/ GIMT_Encode4(2403000), // Rule ID 65477 //
     /* 2402948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2402951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402982 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2402985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402999 */     // GIR_Coverage, 65477,
     /* 2402999 */     GIR_EraseRootFromParent_Done,
     /* 2403000 */   // Label 34532: @2403000
     /* 2403000 */   GIM_Try, /*On fail goto*//*Label 34533*/ GIMT_Encode4(2403057), // Rule ID 2005 //
     /* 2403005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2403008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2403024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2403032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403039 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2403039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2403042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2403052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403056 */     // GIR_Coverage, 2005,
     /* 2403056 */     GIR_EraseRootFromParent_Done,
     /* 2403057 */   // Label 34533: @2403057
     /* 2403057 */   GIM_Try, /*On fail goto*//*Label 34534*/ GIMT_Encode4(2403114), // Rule ID 2006 //
     /* 2403062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2403065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2403081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2403089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403096 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2403096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2403099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2403109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403113 */     // GIR_Coverage, 2006,
     /* 2403113 */     GIR_EraseRootFromParent_Done,
     /* 2403114 */   // Label 34534: @2403114
     /* 2403114 */   GIM_Try, /*On fail goto*//*Label 34535*/ GIMT_Encode4(2403171), // Rule ID 2038 //
     /* 2403119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2403122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2403138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2403146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403153 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2403153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2403156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2403166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403170 */     // GIR_Coverage, 2038,
     /* 2403170 */     GIR_EraseRootFromParent_Done,
     /* 2403171 */   // Label 34535: @2403171
     /* 2403171 */   GIM_Try, /*On fail goto*//*Label 34536*/ GIMT_Encode4(2403228), // Rule ID 2039 //
     /* 2403176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2403179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2403195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2403203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403210 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2403210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2403213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2403223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403227 */     // GIR_Coverage, 2039,
     /* 2403227 */     GIR_EraseRootFromParent_Done,
     /* 2403228 */   // Label 34536: @2403228
     /* 2403228 */   GIM_Try, /*On fail goto*//*Label 34537*/ GIMT_Encode4(2403268), // Rule ID 2001 //
     /* 2403233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2403236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403252 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2403252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2403255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2403263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403267 */     // GIR_Coverage, 2001,
     /* 2403267 */     GIR_EraseRootFromParent_Done,
     /* 2403268 */   // Label 34537: @2403268
     /* 2403268 */   GIM_Try, /*On fail goto*//*Label 34538*/ GIMT_Encode4(2403308), // Rule ID 2002 //
     /* 2403273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2403276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403292 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2403292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2403295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2403303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403307 */     // GIR_Coverage, 2002,
     /* 2403307 */     GIR_EraseRootFromParent_Done,
     /* 2403308 */   // Label 34538: @2403308
     /* 2403308 */   GIM_Try, /*On fail goto*//*Label 34539*/ GIMT_Encode4(2403348), // Rule ID 2034 //
     /* 2403313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2403316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403332 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2403332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2403335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2403343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403347 */     // GIR_Coverage, 2034,
     /* 2403347 */     GIR_EraseRootFromParent_Done,
     /* 2403348 */   // Label 34539: @2403348
     /* 2403348 */   GIM_Try, /*On fail goto*//*Label 34540*/ GIMT_Encode4(2403388), // Rule ID 2035 //
     /* 2403353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2403356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403372 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2403372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2403375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2403383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403387 */     // GIR_Coverage, 2035,
     /* 2403387 */     GIR_EraseRootFromParent_Done,
     /* 2403388 */   // Label 34540: @2403388
     /* 2403388 */   GIM_Reject,
     /* 2403389 */ // Label 34516: @2403389
     /* 2403389 */ GIM_Reject,
     /* 2403390 */ // Label 34498: @2403390
     /* 2403390 */ GIM_Try, /*On fail goto*//*Label 34541*/ GIMT_Encode4(2404825),
     /* 2403395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2403401 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2403404 */   GIM_Try, /*On fail goto*//*Label 34542*/ GIMT_Encode4(2403476), // Rule ID 1312 //
     /* 2403409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2403412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403456 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2403456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2403459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403475 */     // GIR_Coverage, 1312,
     /* 2403475 */     GIR_EraseRootFromParent_Done,
     /* 2403476 */   // Label 34542: @2403476
     /* 2403476 */   GIM_Try, /*On fail goto*//*Label 34543*/ GIMT_Encode4(2403548), // Rule ID 1313 //
     /* 2403481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2403484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403528 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2403528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2403531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403547 */     // GIR_Coverage, 1313,
     /* 2403547 */     GIR_EraseRootFromParent_Done,
     /* 2403548 */   // Label 34543: @2403548
     /* 2403548 */   GIM_Try, /*On fail goto*//*Label 34544*/ GIMT_Encode4(2403620), // Rule ID 1333 //
     /* 2403553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2403556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403600 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2403600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2403603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403619 */     // GIR_Coverage, 1333,
     /* 2403619 */     GIR_EraseRootFromParent_Done,
     /* 2403620 */   // Label 34544: @2403620
     /* 2403620 */   GIM_Try, /*On fail goto*//*Label 34545*/ GIMT_Encode4(2403692), // Rule ID 1334 //
     /* 2403625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2403628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403672 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2403672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2403675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403691 */     // GIR_Coverage, 1334,
     /* 2403691 */     GIR_EraseRootFromParent_Done,
     /* 2403692 */   // Label 34545: @2403692
     /* 2403692 */   GIM_Try, /*On fail goto*//*Label 34546*/ GIMT_Encode4(2403764), // Rule ID 65436 //
     /* 2403697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2403700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403744 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2403744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2403747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403763 */     // GIR_Coverage, 65436,
     /* 2403763 */     GIR_EraseRootFromParent_Done,
     /* 2403764 */   // Label 34546: @2403764
     /* 2403764 */   GIM_Try, /*On fail goto*//*Label 34547*/ GIMT_Encode4(2403836), // Rule ID 65437 //
     /* 2403769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2403772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403816 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2403816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2403819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403835 */     // GIR_Coverage, 65437,
     /* 2403835 */     GIR_EraseRootFromParent_Done,
     /* 2403836 */   // Label 34547: @2403836
     /* 2403836 */   GIM_Try, /*On fail goto*//*Label 34548*/ GIMT_Encode4(2403908), // Rule ID 65444 //
     /* 2403841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2403844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403888 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2403888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2403891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403907 */     // GIR_Coverage, 65444,
     /* 2403907 */     GIR_EraseRootFromParent_Done,
     /* 2403908 */   // Label 34548: @2403908
     /* 2403908 */   GIM_Try, /*On fail goto*//*Label 34549*/ GIMT_Encode4(2403980), // Rule ID 65445 //
     /* 2403913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2403916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403960 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2403960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2403963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403979 */     // GIR_Coverage, 65445,
     /* 2403979 */     GIR_EraseRootFromParent_Done,
     /* 2403980 */   // Label 34549: @2403980
     /* 2403980 */   GIM_Try, /*On fail goto*//*Label 34550*/ GIMT_Encode4(2404037), // Rule ID 1308 //
     /* 2403985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2403988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404019 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2404019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2404022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404036 */     // GIR_Coverage, 1308,
     /* 2404036 */     GIR_EraseRootFromParent_Done,
     /* 2404037 */   // Label 34550: @2404037
     /* 2404037 */   GIM_Try, /*On fail goto*//*Label 34551*/ GIMT_Encode4(2404094), // Rule ID 1309 //
     /* 2404042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2404045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404076 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2404076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2404079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404093 */     // GIR_Coverage, 1309,
     /* 2404093 */     GIR_EraseRootFromParent_Done,
     /* 2404094 */   // Label 34551: @2404094
     /* 2404094 */   GIM_Try, /*On fail goto*//*Label 34552*/ GIMT_Encode4(2404151), // Rule ID 1329 //
     /* 2404099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2404102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404133 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2404133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2404136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404150 */     // GIR_Coverage, 1329,
     /* 2404150 */     GIR_EraseRootFromParent_Done,
     /* 2404151 */   // Label 34552: @2404151
     /* 2404151 */   GIM_Try, /*On fail goto*//*Label 34553*/ GIMT_Encode4(2404208), // Rule ID 1330 //
     /* 2404156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2404159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404190 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2404190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2404193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404207 */     // GIR_Coverage, 1330,
     /* 2404207 */     GIR_EraseRootFromParent_Done,
     /* 2404208 */   // Label 34553: @2404208
     /* 2404208 */   GIM_Try, /*On fail goto*//*Label 34554*/ GIMT_Encode4(2404265), // Rule ID 65432 //
     /* 2404213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2404216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404247 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2404247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2404250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404264 */     // GIR_Coverage, 65432,
     /* 2404264 */     GIR_EraseRootFromParent_Done,
     /* 2404265 */   // Label 34554: @2404265
     /* 2404265 */   GIM_Try, /*On fail goto*//*Label 34555*/ GIMT_Encode4(2404322), // Rule ID 65433 //
     /* 2404270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2404273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404304 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2404304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2404307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404321 */     // GIR_Coverage, 65433,
     /* 2404321 */     GIR_EraseRootFromParent_Done,
     /* 2404322 */   // Label 34555: @2404322
     /* 2404322 */   GIM_Try, /*On fail goto*//*Label 34556*/ GIMT_Encode4(2404379), // Rule ID 65440 //
     /* 2404327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2404330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404361 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2404361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2404364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404378 */     // GIR_Coverage, 65440,
     /* 2404378 */     GIR_EraseRootFromParent_Done,
     /* 2404379 */   // Label 34556: @2404379
     /* 2404379 */   GIM_Try, /*On fail goto*//*Label 34557*/ GIMT_Encode4(2404436), // Rule ID 65441 //
     /* 2404384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2404387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404418 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2404418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2404421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404435 */     // GIR_Coverage, 65441,
     /* 2404435 */     GIR_EraseRootFromParent_Done,
     /* 2404436 */   // Label 34557: @2404436
     /* 2404436 */   GIM_Try, /*On fail goto*//*Label 34558*/ GIMT_Encode4(2404493), // Rule ID 1304 //
     /* 2404441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2404444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2404460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404475 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2404475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2404478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2404488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404492 */     // GIR_Coverage, 1304,
     /* 2404492 */     GIR_EraseRootFromParent_Done,
     /* 2404493 */   // Label 34558: @2404493
     /* 2404493 */   GIM_Try, /*On fail goto*//*Label 34559*/ GIMT_Encode4(2404550), // Rule ID 1305 //
     /* 2404498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2404501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2404517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404532 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2404532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2404535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2404545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404549 */     // GIR_Coverage, 1305,
     /* 2404549 */     GIR_EraseRootFromParent_Done,
     /* 2404550 */   // Label 34559: @2404550
     /* 2404550 */   GIM_Try, /*On fail goto*//*Label 34560*/ GIMT_Encode4(2404607), // Rule ID 1325 //
     /* 2404555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2404558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2404574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404589 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2404589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2404592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2404602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404606 */     // GIR_Coverage, 1325,
     /* 2404606 */     GIR_EraseRootFromParent_Done,
     /* 2404607 */   // Label 34560: @2404607
     /* 2404607 */   GIM_Try, /*On fail goto*//*Label 34561*/ GIMT_Encode4(2404664), // Rule ID 1326 //
     /* 2404612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2404615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2404631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404646 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2404646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2404649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2404659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404663 */     // GIR_Coverage, 1326,
     /* 2404663 */     GIR_EraseRootFromParent_Done,
     /* 2404664 */   // Label 34561: @2404664
     /* 2404664 */   GIM_Try, /*On fail goto*//*Label 34562*/ GIMT_Encode4(2404704), // Rule ID 1300 //
     /* 2404669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2404672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404688 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2404688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2404691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404703 */     // GIR_Coverage, 1300,
     /* 2404703 */     GIR_EraseRootFromParent_Done,
     /* 2404704 */   // Label 34562: @2404704
     /* 2404704 */   GIM_Try, /*On fail goto*//*Label 34563*/ GIMT_Encode4(2404744), // Rule ID 1301 //
     /* 2404709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2404712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404728 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2404728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2404731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404743 */     // GIR_Coverage, 1301,
     /* 2404743 */     GIR_EraseRootFromParent_Done,
     /* 2404744 */   // Label 34563: @2404744
     /* 2404744 */   GIM_Try, /*On fail goto*//*Label 34564*/ GIMT_Encode4(2404784), // Rule ID 1321 //
     /* 2404749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2404752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404768 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2404768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2404771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404783 */     // GIR_Coverage, 1321,
     /* 2404783 */     GIR_EraseRootFromParent_Done,
     /* 2404784 */   // Label 34564: @2404784
     /* 2404784 */   GIM_Try, /*On fail goto*//*Label 34565*/ GIMT_Encode4(2404824), // Rule ID 1322 //
     /* 2404789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2404792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404808 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2404808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2404811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404823 */     // GIR_Coverage, 1322,
     /* 2404823 */     GIR_EraseRootFromParent_Done,
     /* 2404824 */   // Label 34565: @2404824
     /* 2404824 */   GIM_Reject,
     /* 2404825 */ // Label 34541: @2404825
     /* 2404825 */ GIM_Reject,
     /* 2404826 */ // Label 34499: @2404826
     /* 2404826 */ GIM_Try, /*On fail goto*//*Label 34566*/ GIMT_Encode4(2406616),
     /* 2404831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2404837 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2404840 */   GIM_Try, /*On fail goto*//*Label 34567*/ GIMT_Encode4(2404912), // Rule ID 1649 //
     /* 2404845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2404848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404885 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404892 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2404892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2404895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404911 */     // GIR_Coverage, 1649,
     /* 2404911 */     GIR_EraseRootFromParent_Done,
     /* 2404912 */   // Label 34567: @2404912
     /* 2404912 */   GIM_Try, /*On fail goto*//*Label 34568*/ GIMT_Encode4(2404984), // Rule ID 1650 //
     /* 2404917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2404920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404964 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2404964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2404967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404983 */     // GIR_Coverage, 1650,
     /* 2404983 */     GIR_EraseRootFromParent_Done,
     /* 2404984 */   // Label 34568: @2404984
     /* 2404984 */   GIM_Try, /*On fail goto*//*Label 34569*/ GIMT_Encode4(2405056), // Rule ID 1673 //
     /* 2404989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2404992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405036 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2405039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405055 */     // GIR_Coverage, 1673,
     /* 2405055 */     GIR_EraseRootFromParent_Done,
     /* 2405056 */   // Label 34569: @2405056
     /* 2405056 */   GIM_Try, /*On fail goto*//*Label 34570*/ GIMT_Encode4(2405128), // Rule ID 1704 //
     /* 2405061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2405064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405108 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2405111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405127 */     // GIR_Coverage, 1704,
     /* 2405127 */     GIR_EraseRootFromParent_Done,
     /* 2405128 */   // Label 34570: @2405128
     /* 2405128 */   GIM_Try, /*On fail goto*//*Label 34571*/ GIMT_Encode4(2405200), // Rule ID 1705 //
     /* 2405133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2405136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405180 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2405180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2405183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405199 */     // GIR_Coverage, 1705,
     /* 2405199 */     GIR_EraseRootFromParent_Done,
     /* 2405200 */   // Label 34571: @2405200
     /* 2405200 */   GIM_Try, /*On fail goto*//*Label 34572*/ GIMT_Encode4(2405272), // Rule ID 65452 //
     /* 2405205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2405208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405252 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2405255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405271 */     // GIR_Coverage, 65452,
     /* 2405271 */     GIR_EraseRootFromParent_Done,
     /* 2405272 */   // Label 34572: @2405272
     /* 2405272 */   GIM_Try, /*On fail goto*//*Label 34573*/ GIMT_Encode4(2405344), // Rule ID 65453 //
     /* 2405277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2405280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405317 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405324 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2405324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2405327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405343 */     // GIR_Coverage, 65453,
     /* 2405343 */     GIR_EraseRootFromParent_Done,
     /* 2405344 */   // Label 34573: @2405344
     /* 2405344 */   GIM_Try, /*On fail goto*//*Label 34574*/ GIMT_Encode4(2405416), // Rule ID 65458 //
     /* 2405349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2405352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405396 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2405399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405415 */     // GIR_Coverage, 65458,
     /* 2405415 */     GIR_EraseRootFromParent_Done,
     /* 2405416 */   // Label 34574: @2405416
     /* 2405416 */   GIM_Try, /*On fail goto*//*Label 34575*/ GIMT_Encode4(2405488), // Rule ID 65464 //
     /* 2405421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2405424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405468 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2405471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405487 */     // GIR_Coverage, 65464,
     /* 2405487 */     GIR_EraseRootFromParent_Done,
     /* 2405488 */   // Label 34575: @2405488
     /* 2405488 */   GIM_Try, /*On fail goto*//*Label 34576*/ GIMT_Encode4(2405560), // Rule ID 65465 //
     /* 2405493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2405496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405540 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2405540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2405543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405559 */     // GIR_Coverage, 65465,
     /* 2405559 */     GIR_EraseRootFromParent_Done,
     /* 2405560 */   // Label 34576: @2405560
     /* 2405560 */   GIM_Try, /*On fail goto*//*Label 34577*/ GIMT_Encode4(2405617), // Rule ID 1645 //
     /* 2405565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2405568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405599 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2405602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405616 */     // GIR_Coverage, 1645,
     /* 2405616 */     GIR_EraseRootFromParent_Done,
     /* 2405617 */   // Label 34577: @2405617
     /* 2405617 */   GIM_Try, /*On fail goto*//*Label 34578*/ GIMT_Encode4(2405674), // Rule ID 1646 //
     /* 2405622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2405625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405656 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2405656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2405659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405673 */     // GIR_Coverage, 1646,
     /* 2405673 */     GIR_EraseRootFromParent_Done,
     /* 2405674 */   // Label 34578: @2405674
     /* 2405674 */   GIM_Try, /*On fail goto*//*Label 34579*/ GIMT_Encode4(2405731), // Rule ID 1671 //
     /* 2405679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2405682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405713 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2405716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405730 */     // GIR_Coverage, 1671,
     /* 2405730 */     GIR_EraseRootFromParent_Done,
     /* 2405731 */   // Label 34579: @2405731
     /* 2405731 */   GIM_Try, /*On fail goto*//*Label 34580*/ GIMT_Encode4(2405788), // Rule ID 1700 //
     /* 2405736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2405739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405770 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2405773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405787 */     // GIR_Coverage, 1700,
     /* 2405787 */     GIR_EraseRootFromParent_Done,
     /* 2405788 */   // Label 34580: @2405788
     /* 2405788 */   GIM_Try, /*On fail goto*//*Label 34581*/ GIMT_Encode4(2405845), // Rule ID 1701 //
     /* 2405793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2405796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405827 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2405827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2405830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405844 */     // GIR_Coverage, 1701,
     /* 2405844 */     GIR_EraseRootFromParent_Done,
     /* 2405845 */   // Label 34581: @2405845
     /* 2405845 */   GIM_Try, /*On fail goto*//*Label 34582*/ GIMT_Encode4(2405902), // Rule ID 65448 //
     /* 2405850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2405853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405884 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2405887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405901 */     // GIR_Coverage, 65448,
     /* 2405901 */     GIR_EraseRootFromParent_Done,
     /* 2405902 */   // Label 34582: @2405902
     /* 2405902 */   GIM_Try, /*On fail goto*//*Label 34583*/ GIMT_Encode4(2405959), // Rule ID 65449 //
     /* 2405907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2405910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405941 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2405941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2405944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405958 */     // GIR_Coverage, 65449,
     /* 2405958 */     GIR_EraseRootFromParent_Done,
     /* 2405959 */   // Label 34583: @2405959
     /* 2405959 */   GIM_Try, /*On fail goto*//*Label 34584*/ GIMT_Encode4(2406016), // Rule ID 65456 //
     /* 2405964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2405967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405998 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2406001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2406009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406015 */     // GIR_Coverage, 65456,
     /* 2406015 */     GIR_EraseRootFromParent_Done,
     /* 2406016 */   // Label 34584: @2406016
     /* 2406016 */   GIM_Try, /*On fail goto*//*Label 34585*/ GIMT_Encode4(2406073), // Rule ID 65460 //
     /* 2406021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2406024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406055 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2406055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2406058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2406066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406072 */     // GIR_Coverage, 65460,
     /* 2406072 */     GIR_EraseRootFromParent_Done,
     /* 2406073 */   // Label 34585: @2406073
     /* 2406073 */   GIM_Try, /*On fail goto*//*Label 34586*/ GIMT_Encode4(2406130), // Rule ID 65461 //
     /* 2406078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2406081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406112 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2406112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2406115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2406123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406129 */     // GIR_Coverage, 65461,
     /* 2406129 */     GIR_EraseRootFromParent_Done,
     /* 2406130 */   // Label 34586: @2406130
     /* 2406130 */   GIM_Try, /*On fail goto*//*Label 34587*/ GIMT_Encode4(2406187), // Rule ID 1641 //
     /* 2406135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2406138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2406154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406169 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2406169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2406172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2406182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406186 */     // GIR_Coverage, 1641,
     /* 2406186 */     GIR_EraseRootFromParent_Done,
     /* 2406187 */   // Label 34587: @2406187
     /* 2406187 */   GIM_Try, /*On fail goto*//*Label 34588*/ GIMT_Encode4(2406244), // Rule ID 1642 //
     /* 2406192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2406195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2406211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406226 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2406226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2406229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2406239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406243 */     // GIR_Coverage, 1642,
     /* 2406243 */     GIR_EraseRootFromParent_Done,
     /* 2406244 */   // Label 34588: @2406244
     /* 2406244 */   GIM_Try, /*On fail goto*//*Label 34589*/ GIMT_Encode4(2406301), // Rule ID 1669 //
     /* 2406249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2406252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2406268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406283 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2406283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2406286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2406296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406300 */     // GIR_Coverage, 1669,
     /* 2406300 */     GIR_EraseRootFromParent_Done,
     /* 2406301 */   // Label 34589: @2406301
     /* 2406301 */   GIM_Try, /*On fail goto*//*Label 34590*/ GIMT_Encode4(2406358), // Rule ID 1696 //
     /* 2406306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2406309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2406325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406340 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2406340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2406343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2406353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406357 */     // GIR_Coverage, 1696,
     /* 2406357 */     GIR_EraseRootFromParent_Done,
     /* 2406358 */   // Label 34590: @2406358
     /* 2406358 */   GIM_Try, /*On fail goto*//*Label 34591*/ GIMT_Encode4(2406415), // Rule ID 1697 //
     /* 2406363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2406366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2406382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406397 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2406397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2406400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2406410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406414 */     // GIR_Coverage, 1697,
     /* 2406414 */     GIR_EraseRootFromParent_Done,
     /* 2406415 */   // Label 34591: @2406415
     /* 2406415 */   GIM_Try, /*On fail goto*//*Label 34592*/ GIMT_Encode4(2406455), // Rule ID 1637 //
     /* 2406420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2406423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406439 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2406439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2406442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406454 */     // GIR_Coverage, 1637,
     /* 2406454 */     GIR_EraseRootFromParent_Done,
     /* 2406455 */   // Label 34592: @2406455
     /* 2406455 */   GIM_Try, /*On fail goto*//*Label 34593*/ GIMT_Encode4(2406495), // Rule ID 1638 //
     /* 2406460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2406463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406479 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2406479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2406482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406494 */     // GIR_Coverage, 1638,
     /* 2406494 */     GIR_EraseRootFromParent_Done,
     /* 2406495 */   // Label 34593: @2406495
     /* 2406495 */   GIM_Try, /*On fail goto*//*Label 34594*/ GIMT_Encode4(2406535), // Rule ID 1667 //
     /* 2406500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2406503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406519 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2406519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2406522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406534 */     // GIR_Coverage, 1667,
     /* 2406534 */     GIR_EraseRootFromParent_Done,
     /* 2406535 */   // Label 34594: @2406535
     /* 2406535 */   GIM_Try, /*On fail goto*//*Label 34595*/ GIMT_Encode4(2406575), // Rule ID 1692 //
     /* 2406540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2406543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406559 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2406559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2406562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406574 */     // GIR_Coverage, 1692,
     /* 2406574 */     GIR_EraseRootFromParent_Done,
     /* 2406575 */   // Label 34595: @2406575
     /* 2406575 */   GIM_Try, /*On fail goto*//*Label 34596*/ GIMT_Encode4(2406615), // Rule ID 1693 //
     /* 2406580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2406583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406599 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2406599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2406602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406614 */     // GIR_Coverage, 1693,
     /* 2406614 */     GIR_EraseRootFromParent_Done,
     /* 2406615 */   // Label 34596: @2406615
     /* 2406615 */   GIM_Reject,
     /* 2406616 */ // Label 34566: @2406616
     /* 2406616 */ GIM_Reject,
     /* 2406617 */ // Label 34500: @2406617
     /* 2406617 */ GIM_Try, /*On fail goto*//*Label 34597*/ GIMT_Encode4(2407406),
     /* 2406622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2406628 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2406631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406635 */   GIM_Try, /*On fail goto*//*Label 34598*/ GIMT_Encode4(2406712), // Rule ID 54840 //
     /* 2406640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406683 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2406686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2406698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406711 */     // GIR_Coverage, 54840,
     /* 2406711 */     GIR_EraseRootFromParent_Done,
     /* 2406712 */   // Label 34598: @2406712
     /* 2406712 */   GIM_Try, /*On fail goto*//*Label 34599*/ GIMT_Encode4(2406789), // Rule ID 54841 //
     /* 2406717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406760 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2406763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2406775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406788 */     // GIR_Coverage, 54841,
     /* 2406788 */     GIR_EraseRootFromParent_Done,
     /* 2406789 */   // Label 34599: @2406789
     /* 2406789 */   GIM_Try, /*On fail goto*//*Label 34600*/ GIMT_Encode4(2406866), // Rule ID 72436 //
     /* 2406794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406837 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2406840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2406844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2406852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406865 */     // GIR_Coverage, 72436,
     /* 2406865 */     GIR_EraseRootFromParent_Done,
     /* 2406866 */   // Label 34600: @2406866
     /* 2406866 */   GIM_Try, /*On fail goto*//*Label 34601*/ GIMT_Encode4(2406943), // Rule ID 72437 //
     /* 2406871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406914 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2406917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2406921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2406929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406942 */     // GIR_Coverage, 72437,
     /* 2406942 */     GIR_EraseRootFromParent_Done,
     /* 2406943 */   // Label 34601: @2406943
     /* 2406943 */   GIM_Try, /*On fail goto*//*Label 34602*/ GIMT_Encode4(2407005), // Rule ID 54844 //
     /* 2406948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406978 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2406981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2406991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407004 */     // GIR_Coverage, 54844,
     /* 2407004 */     GIR_EraseRootFromParent_Done,
     /* 2407005 */   // Label 34602: @2407005
     /* 2407005 */   GIM_Try, /*On fail goto*//*Label 34603*/ GIMT_Encode4(2407067), // Rule ID 54845 //
     /* 2407010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2407013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2407025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407040 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2407043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407066 */     // GIR_Coverage, 54845,
     /* 2407066 */     GIR_EraseRootFromParent_Done,
     /* 2407067 */   // Label 34603: @2407067
     /* 2407067 */   GIM_Try, /*On fail goto*//*Label 34604*/ GIMT_Encode4(2407129), // Rule ID 72440 //
     /* 2407072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2407075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2407091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407102 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2407105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2407109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407128 */     // GIR_Coverage, 72440,
     /* 2407128 */     GIR_EraseRootFromParent_Done,
     /* 2407129 */   // Label 34604: @2407129
     /* 2407129 */   GIM_Try, /*On fail goto*//*Label 34605*/ GIMT_Encode4(2407191), // Rule ID 72441 //
     /* 2407134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2407137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2407153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407164 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2407167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2407171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407190 */     // GIR_Coverage, 72441,
     /* 2407190 */     GIR_EraseRootFromParent_Done,
     /* 2407191 */   // Label 34605: @2407191
     /* 2407191 */   GIM_Try, /*On fail goto*//*Label 34606*/ GIMT_Encode4(2407253), // Rule ID 54836 //
     /* 2407196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2407199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2407211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2407219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407226 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2407229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2407239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407252 */     // GIR_Coverage, 54836,
     /* 2407252 */     GIR_EraseRootFromParent_Done,
     /* 2407253 */   // Label 34606: @2407253
     /* 2407253 */   GIM_Try, /*On fail goto*//*Label 34607*/ GIMT_Encode4(2407315), // Rule ID 54837 //
     /* 2407258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2407261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2407273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2407281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407288 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2407291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2407301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407314 */     // GIR_Coverage, 54837,
     /* 2407314 */     GIR_EraseRootFromParent_Done,
     /* 2407315 */   // Label 34607: @2407315
     /* 2407315 */   GIM_Try, /*On fail goto*//*Label 34608*/ GIMT_Encode4(2407360), // Rule ID 54832 //
     /* 2407320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2407323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407335 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2407338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407359 */     // GIR_Coverage, 54832,
     /* 2407359 */     GIR_EraseRootFromParent_Done,
     /* 2407360 */   // Label 34608: @2407360
     /* 2407360 */   GIM_Try, /*On fail goto*//*Label 34609*/ GIMT_Encode4(2407405), // Rule ID 54833 //
     /* 2407365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2407368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407380 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2407383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407404 */     // GIR_Coverage, 54833,
     /* 2407404 */     GIR_EraseRootFromParent_Done,
     /* 2407405 */   // Label 34609: @2407405
     /* 2407405 */   GIM_Reject,
     /* 2407406 */ // Label 34597: @2407406
     /* 2407406 */ GIM_Reject,
     /* 2407407 */ // Label 34501: @2407407
     /* 2407407 */ GIM_Try, /*On fail goto*//*Label 34610*/ GIMT_Encode4(2408196),
     /* 2407412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2407418 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2407421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407425 */   GIM_Try, /*On fail goto*//*Label 34611*/ GIMT_Encode4(2407502), // Rule ID 54968 //
     /* 2407430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407473 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2407476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2407488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407501 */     // GIR_Coverage, 54968,
     /* 2407501 */     GIR_EraseRootFromParent_Done,
     /* 2407502 */   // Label 34611: @2407502
     /* 2407502 */   GIM_Try, /*On fail goto*//*Label 34612*/ GIMT_Encode4(2407579), // Rule ID 54969 //
     /* 2407507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407550 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2407553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2407565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407578 */     // GIR_Coverage, 54969,
     /* 2407578 */     GIR_EraseRootFromParent_Done,
     /* 2407579 */   // Label 34612: @2407579
     /* 2407579 */   GIM_Try, /*On fail goto*//*Label 34613*/ GIMT_Encode4(2407656), // Rule ID 72548 //
     /* 2407584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407627 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2407630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2407634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2407642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407655 */     // GIR_Coverage, 72548,
     /* 2407655 */     GIR_EraseRootFromParent_Done,
     /* 2407656 */   // Label 34613: @2407656
     /* 2407656 */   GIM_Try, /*On fail goto*//*Label 34614*/ GIMT_Encode4(2407733), // Rule ID 72549 //
     /* 2407661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407704 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2407707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2407711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2407719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407732 */     // GIR_Coverage, 72549,
     /* 2407732 */     GIR_EraseRootFromParent_Done,
     /* 2407733 */   // Label 34614: @2407733
     /* 2407733 */   GIM_Try, /*On fail goto*//*Label 34615*/ GIMT_Encode4(2407795), // Rule ID 54972 //
     /* 2407738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407768 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2407771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407794 */     // GIR_Coverage, 54972,
     /* 2407794 */     GIR_EraseRootFromParent_Done,
     /* 2407795 */   // Label 34615: @2407795
     /* 2407795 */   GIM_Try, /*On fail goto*//*Label 34616*/ GIMT_Encode4(2407857), // Rule ID 54973 //
     /* 2407800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407830 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2407833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407856 */     // GIR_Coverage, 54973,
     /* 2407856 */     GIR_EraseRootFromParent_Done,
     /* 2407857 */   // Label 34616: @2407857
     /* 2407857 */   GIM_Try, /*On fail goto*//*Label 34617*/ GIMT_Encode4(2407919), // Rule ID 72552 //
     /* 2407862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407892 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2407895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2407899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407918 */     // GIR_Coverage, 72552,
     /* 2407918 */     GIR_EraseRootFromParent_Done,
     /* 2407919 */   // Label 34617: @2407919
     /* 2407919 */   GIM_Try, /*On fail goto*//*Label 34618*/ GIMT_Encode4(2407981), // Rule ID 72553 //
     /* 2407924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407954 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2407957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2407961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407980 */     // GIR_Coverage, 72553,
     /* 2407980 */     GIR_EraseRootFromParent_Done,
     /* 2407981 */   // Label 34618: @2407981
     /* 2407981 */   GIM_Try, /*On fail goto*//*Label 34619*/ GIMT_Encode4(2408043), // Rule ID 54964 //
     /* 2407986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2408009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408016 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2408019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2408029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408042 */     // GIR_Coverage, 54964,
     /* 2408042 */     GIR_EraseRootFromParent_Done,
     /* 2408043 */   // Label 34619: @2408043
     /* 2408043 */   GIM_Try, /*On fail goto*//*Label 34620*/ GIMT_Encode4(2408105), // Rule ID 54965 //
     /* 2408048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2408051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2408071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408078 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2408081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2408091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408104 */     // GIR_Coverage, 54965,
     /* 2408104 */     GIR_EraseRootFromParent_Done,
     /* 2408105 */   // Label 34620: @2408105
     /* 2408105 */   GIM_Try, /*On fail goto*//*Label 34621*/ GIMT_Encode4(2408150), // Rule ID 54960 //
     /* 2408110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2408113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408125 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2408128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408149 */     // GIR_Coverage, 54960,
     /* 2408149 */     GIR_EraseRootFromParent_Done,
     /* 2408150 */   // Label 34621: @2408150
     /* 2408150 */   GIM_Try, /*On fail goto*//*Label 34622*/ GIMT_Encode4(2408195), // Rule ID 54961 //
     /* 2408155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2408158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408170 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2408173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408194 */     // GIR_Coverage, 54961,
     /* 2408194 */     GIR_EraseRootFromParent_Done,
     /* 2408195 */   // Label 34622: @2408195
     /* 2408195 */   GIM_Reject,
     /* 2408196 */ // Label 34610: @2408196
     /* 2408196 */ GIM_Reject,
     /* 2408197 */ // Label 34502: @2408197
     /* 2408197 */ GIM_Try, /*On fail goto*//*Label 34623*/ GIMT_Encode4(2408986),
     /* 2408202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2408208 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2408211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408215 */   GIM_Try, /*On fail goto*//*Label 34624*/ GIMT_Encode4(2408292), // Rule ID 55160 //
     /* 2408220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2408223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408263 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2408266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408291 */     // GIR_Coverage, 55160,
     /* 2408291 */     GIR_EraseRootFromParent_Done,
     /* 2408292 */   // Label 34624: @2408292
     /* 2408292 */   GIM_Try, /*On fail goto*//*Label 34625*/ GIMT_Encode4(2408369), // Rule ID 55161 //
     /* 2408297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2408300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408340 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2408343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408368 */     // GIR_Coverage, 55161,
     /* 2408368 */     GIR_EraseRootFromParent_Done,
     /* 2408369 */   // Label 34625: @2408369
     /* 2408369 */   GIM_Try, /*On fail goto*//*Label 34626*/ GIMT_Encode4(2408446), // Rule ID 72716 //
     /* 2408374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2408377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408417 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2408420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2408424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408445 */     // GIR_Coverage, 72716,
     /* 2408445 */     GIR_EraseRootFromParent_Done,
     /* 2408446 */   // Label 34626: @2408446
     /* 2408446 */   GIM_Try, /*On fail goto*//*Label 34627*/ GIMT_Encode4(2408523), // Rule ID 72717 //
     /* 2408451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2408454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408494 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2408497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2408501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408522 */     // GIR_Coverage, 72717,
     /* 2408522 */     GIR_EraseRootFromParent_Done,
     /* 2408523 */   // Label 34627: @2408523
     /* 2408523 */   GIM_Try, /*On fail goto*//*Label 34628*/ GIMT_Encode4(2408585), // Rule ID 55164 //
     /* 2408528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2408531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408558 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2408561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408584 */     // GIR_Coverage, 55164,
     /* 2408584 */     GIR_EraseRootFromParent_Done,
     /* 2408585 */   // Label 34628: @2408585
     /* 2408585 */   GIM_Try, /*On fail goto*//*Label 34629*/ GIMT_Encode4(2408647), // Rule ID 55165 //
     /* 2408590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2408593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408620 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2408623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408646 */     // GIR_Coverage, 55165,
     /* 2408646 */     GIR_EraseRootFromParent_Done,
     /* 2408647 */   // Label 34629: @2408647
     /* 2408647 */   GIM_Try, /*On fail goto*//*Label 34630*/ GIMT_Encode4(2408709), // Rule ID 72720 //
     /* 2408652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2408655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408682 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2408685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2408689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408708 */     // GIR_Coverage, 72720,
     /* 2408708 */     GIR_EraseRootFromParent_Done,
     /* 2408709 */   // Label 34630: @2408709
     /* 2408709 */   GIM_Try, /*On fail goto*//*Label 34631*/ GIMT_Encode4(2408771), // Rule ID 72721 //
     /* 2408714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2408717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408744 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2408747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2408751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408770 */     // GIR_Coverage, 72721,
     /* 2408770 */     GIR_EraseRootFromParent_Done,
     /* 2408771 */   // Label 34631: @2408771
     /* 2408771 */   GIM_Try, /*On fail goto*//*Label 34632*/ GIMT_Encode4(2408833), // Rule ID 55156 //
     /* 2408776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2408779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408806 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2408809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2408819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408832 */     // GIR_Coverage, 55156,
     /* 2408832 */     GIR_EraseRootFromParent_Done,
     /* 2408833 */   // Label 34632: @2408833
     /* 2408833 */   GIM_Try, /*On fail goto*//*Label 34633*/ GIMT_Encode4(2408895), // Rule ID 55157 //
     /* 2408838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2408841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408868 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2408871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2408881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408894 */     // GIR_Coverage, 55157,
     /* 2408894 */     GIR_EraseRootFromParent_Done,
     /* 2408895 */   // Label 34633: @2408895
     /* 2408895 */   GIM_Try, /*On fail goto*//*Label 34634*/ GIMT_Encode4(2408940), // Rule ID 55152 //
     /* 2408900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2408903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408915 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2408918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408939 */     // GIR_Coverage, 55152,
     /* 2408939 */     GIR_EraseRootFromParent_Done,
     /* 2408940 */   // Label 34634: @2408940
     /* 2408940 */   GIM_Try, /*On fail goto*//*Label 34635*/ GIMT_Encode4(2408985), // Rule ID 55153 //
     /* 2408945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2408948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408960 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2408963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408984 */     // GIR_Coverage, 55153,
     /* 2408984 */     GIR_EraseRootFromParent_Done,
     /* 2408985 */   // Label 34635: @2408985
     /* 2408985 */   GIM_Reject,
     /* 2408986 */ // Label 34623: @2408986
     /* 2408986 */ GIM_Reject,
     /* 2408987 */ // Label 34503: @2408987
     /* 2408987 */ GIM_Try, /*On fail goto*//*Label 34636*/ GIMT_Encode4(2409776),
     /* 2408992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2408995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2408998 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2409001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409005 */   GIM_Try, /*On fail goto*//*Label 34637*/ GIMT_Encode4(2409082), // Rule ID 54904 //
     /* 2409010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2409013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409053 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2409056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409081 */     // GIR_Coverage, 54904,
     /* 2409081 */     GIR_EraseRootFromParent_Done,
     /* 2409082 */   // Label 34637: @2409082
     /* 2409082 */   GIM_Try, /*On fail goto*//*Label 34638*/ GIMT_Encode4(2409159), // Rule ID 54905 //
     /* 2409087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2409090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409130 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2409133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409158 */     // GIR_Coverage, 54905,
     /* 2409158 */     GIR_EraseRootFromParent_Done,
     /* 2409159 */   // Label 34638: @2409159
     /* 2409159 */   GIM_Try, /*On fail goto*//*Label 34639*/ GIMT_Encode4(2409236), // Rule ID 72492 //
     /* 2409164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2409167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409207 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2409210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409235 */     // GIR_Coverage, 72492,
     /* 2409235 */     GIR_EraseRootFromParent_Done,
     /* 2409236 */   // Label 34639: @2409236
     /* 2409236 */   GIM_Try, /*On fail goto*//*Label 34640*/ GIMT_Encode4(2409313), // Rule ID 72493 //
     /* 2409241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2409244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409284 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2409287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409312 */     // GIR_Coverage, 72493,
     /* 2409312 */     GIR_EraseRootFromParent_Done,
     /* 2409313 */   // Label 34640: @2409313
     /* 2409313 */   GIM_Try, /*On fail goto*//*Label 34641*/ GIMT_Encode4(2409375), // Rule ID 54908 //
     /* 2409318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2409321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409348 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2409351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409374 */     // GIR_Coverage, 54908,
     /* 2409374 */     GIR_EraseRootFromParent_Done,
     /* 2409375 */   // Label 34641: @2409375
     /* 2409375 */   GIM_Try, /*On fail goto*//*Label 34642*/ GIMT_Encode4(2409437), // Rule ID 54909 //
     /* 2409380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2409383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409410 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2409413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409436 */     // GIR_Coverage, 54909,
     /* 2409436 */     GIR_EraseRootFromParent_Done,
     /* 2409437 */   // Label 34642: @2409437
     /* 2409437 */   GIM_Try, /*On fail goto*//*Label 34643*/ GIMT_Encode4(2409499), // Rule ID 72496 //
     /* 2409442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2409445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409472 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2409475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409498 */     // GIR_Coverage, 72496,
     /* 2409498 */     GIR_EraseRootFromParent_Done,
     /* 2409499 */   // Label 34643: @2409499
     /* 2409499 */   GIM_Try, /*On fail goto*//*Label 34644*/ GIMT_Encode4(2409561), // Rule ID 72497 //
     /* 2409504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2409507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409534 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2409537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409560 */     // GIR_Coverage, 72497,
     /* 2409560 */     GIR_EraseRootFromParent_Done,
     /* 2409561 */   // Label 34644: @2409561
     /* 2409561 */   GIM_Try, /*On fail goto*//*Label 34645*/ GIMT_Encode4(2409623), // Rule ID 54900 //
     /* 2409566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2409569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2409581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409596 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2409599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2409609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409622 */     // GIR_Coverage, 54900,
     /* 2409622 */     GIR_EraseRootFromParent_Done,
     /* 2409623 */   // Label 34645: @2409623
     /* 2409623 */   GIM_Try, /*On fail goto*//*Label 34646*/ GIMT_Encode4(2409685), // Rule ID 54901 //
     /* 2409628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2409631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2409643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409658 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2409661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2409671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409684 */     // GIR_Coverage, 54901,
     /* 2409684 */     GIR_EraseRootFromParent_Done,
     /* 2409685 */   // Label 34646: @2409685
     /* 2409685 */   GIM_Try, /*On fail goto*//*Label 34647*/ GIMT_Encode4(2409730), // Rule ID 54896 //
     /* 2409690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2409693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409705 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2409708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409729 */     // GIR_Coverage, 54896,
     /* 2409729 */     GIR_EraseRootFromParent_Done,
     /* 2409730 */   // Label 34647: @2409730
     /* 2409730 */   GIM_Try, /*On fail goto*//*Label 34648*/ GIMT_Encode4(2409775), // Rule ID 54897 //
     /* 2409735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2409738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409750 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2409753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409774 */     // GIR_Coverage, 54897,
     /* 2409774 */     GIR_EraseRootFromParent_Done,
     /* 2409775 */   // Label 34648: @2409775
     /* 2409775 */   GIM_Reject,
     /* 2409776 */ // Label 34636: @2409776
     /* 2409776 */ GIM_Reject,
     /* 2409777 */ // Label 34504: @2409777
     /* 2409777 */ GIM_Try, /*On fail goto*//*Label 34649*/ GIMT_Encode4(2410566),
     /* 2409782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2409788 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2409791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409795 */   GIM_Try, /*On fail goto*//*Label 34650*/ GIMT_Encode4(2409872), // Rule ID 55096 //
     /* 2409800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2409803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409843 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2409846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409871 */     // GIR_Coverage, 55096,
     /* 2409871 */     GIR_EraseRootFromParent_Done,
     /* 2409872 */   // Label 34650: @2409872
     /* 2409872 */   GIM_Try, /*On fail goto*//*Label 34651*/ GIMT_Encode4(2409949), // Rule ID 55097 //
     /* 2409877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2409880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409920 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2409923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409948 */     // GIR_Coverage, 55097,
     /* 2409948 */     GIR_EraseRootFromParent_Done,
     /* 2409949 */   // Label 34651: @2409949
     /* 2409949 */   GIM_Try, /*On fail goto*//*Label 34652*/ GIMT_Encode4(2410026), // Rule ID 72660 //
     /* 2409954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2409957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409997 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2410000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410025 */     // GIR_Coverage, 72660,
     /* 2410025 */     GIR_EraseRootFromParent_Done,
     /* 2410026 */   // Label 34652: @2410026
     /* 2410026 */   GIM_Try, /*On fail goto*//*Label 34653*/ GIMT_Encode4(2410103), // Rule ID 72661 //
     /* 2410031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2410034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2410050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2410067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410074 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2410077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410102 */     // GIR_Coverage, 72661,
     /* 2410102 */     GIR_EraseRootFromParent_Done,
     /* 2410103 */   // Label 34653: @2410103
     /* 2410103 */   GIM_Try, /*On fail goto*//*Label 34654*/ GIMT_Encode4(2410165), // Rule ID 55100 //
     /* 2410108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2410111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2410123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410138 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2410141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410164 */     // GIR_Coverage, 55100,
     /* 2410164 */     GIR_EraseRootFromParent_Done,
     /* 2410165 */   // Label 34654: @2410165
     /* 2410165 */   GIM_Try, /*On fail goto*//*Label 34655*/ GIMT_Encode4(2410227), // Rule ID 55101 //
     /* 2410170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2410173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2410185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410200 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2410203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410226 */     // GIR_Coverage, 55101,
     /* 2410226 */     GIR_EraseRootFromParent_Done,
     /* 2410227 */   // Label 34655: @2410227
     /* 2410227 */   GIM_Try, /*On fail goto*//*Label 34656*/ GIMT_Encode4(2410289), // Rule ID 72664 //
     /* 2410232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2410235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2410251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410262 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2410265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410288 */     // GIR_Coverage, 72664,
     /* 2410288 */     GIR_EraseRootFromParent_Done,
     /* 2410289 */   // Label 34656: @2410289
     /* 2410289 */   GIM_Try, /*On fail goto*//*Label 34657*/ GIMT_Encode4(2410351), // Rule ID 72665 //
     /* 2410294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2410297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2410313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410324 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2410327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410350 */     // GIR_Coverage, 72665,
     /* 2410350 */     GIR_EraseRootFromParent_Done,
     /* 2410351 */   // Label 34657: @2410351
     /* 2410351 */   GIM_Try, /*On fail goto*//*Label 34658*/ GIMT_Encode4(2410413), // Rule ID 55092 //
     /* 2410356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2410359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2410379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410386 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2410389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2410399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410412 */     // GIR_Coverage, 55092,
     /* 2410412 */     GIR_EraseRootFromParent_Done,
     /* 2410413 */   // Label 34658: @2410413
     /* 2410413 */   GIM_Try, /*On fail goto*//*Label 34659*/ GIMT_Encode4(2410475), // Rule ID 55093 //
     /* 2410418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2410421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2410441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410448 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2410451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2410461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410474 */     // GIR_Coverage, 55093,
     /* 2410474 */     GIR_EraseRootFromParent_Done,
     /* 2410475 */   // Label 34659: @2410475
     /* 2410475 */   GIM_Try, /*On fail goto*//*Label 34660*/ GIMT_Encode4(2410520), // Rule ID 55088 //
     /* 2410480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2410483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410495 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2410498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410519 */     // GIR_Coverage, 55088,
     /* 2410519 */     GIR_EraseRootFromParent_Done,
     /* 2410520 */   // Label 34660: @2410520
     /* 2410520 */   GIM_Try, /*On fail goto*//*Label 34661*/ GIMT_Encode4(2410565), // Rule ID 55089 //
     /* 2410525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2410528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410540 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2410543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410564 */     // GIR_Coverage, 55089,
     /* 2410564 */     GIR_EraseRootFromParent_Done,
     /* 2410565 */   // Label 34661: @2410565
     /* 2410565 */   GIM_Reject,
     /* 2410566 */ // Label 34649: @2410566
     /* 2410566 */ GIM_Reject,
     /* 2410567 */ // Label 34505: @2410567
     /* 2410567 */ GIM_Try, /*On fail goto*//*Label 34662*/ GIMT_Encode4(2411356),
     /* 2410572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2410578 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2410581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410585 */   GIM_Try, /*On fail goto*//*Label 34663*/ GIMT_Encode4(2410662), // Rule ID 55608 //
     /* 2410590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410633 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2410636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410661 */     // GIR_Coverage, 55608,
     /* 2410661 */     GIR_EraseRootFromParent_Done,
     /* 2410662 */   // Label 34663: @2410662
     /* 2410662 */   GIM_Try, /*On fail goto*//*Label 34664*/ GIMT_Encode4(2410739), // Rule ID 55609 //
     /* 2410667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410710 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2410713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410738 */     // GIR_Coverage, 55609,
     /* 2410738 */     GIR_EraseRootFromParent_Done,
     /* 2410739 */   // Label 34664: @2410739
     /* 2410739 */   GIM_Try, /*On fail goto*//*Label 34665*/ GIMT_Encode4(2410816), // Rule ID 73108 //
     /* 2410744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410787 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2410790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410815 */     // GIR_Coverage, 73108,
     /* 2410815 */     GIR_EraseRootFromParent_Done,
     /* 2410816 */   // Label 34665: @2410816
     /* 2410816 */   GIM_Try, /*On fail goto*//*Label 34666*/ GIMT_Encode4(2410893), // Rule ID 73109 //
     /* 2410821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410864 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2410867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410892 */     // GIR_Coverage, 73109,
     /* 2410892 */     GIR_EraseRootFromParent_Done,
     /* 2410893 */   // Label 34666: @2410893
     /* 2410893 */   GIM_Try, /*On fail goto*//*Label 34667*/ GIMT_Encode4(2410955), // Rule ID 55612 //
     /* 2410898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410928 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2410931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410954 */     // GIR_Coverage, 55612,
     /* 2410954 */     GIR_EraseRootFromParent_Done,
     /* 2410955 */   // Label 34667: @2410955
     /* 2410955 */   GIM_Try, /*On fail goto*//*Label 34668*/ GIMT_Encode4(2411017), // Rule ID 55613 //
     /* 2410960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410990 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2410993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2411012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411016 */     // GIR_Coverage, 55613,
     /* 2411016 */     GIR_EraseRootFromParent_Done,
     /* 2411017 */   // Label 34668: @2411017
     /* 2411017 */   GIM_Try, /*On fail goto*//*Label 34669*/ GIMT_Encode4(2411079), // Rule ID 73112 //
     /* 2411022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2411025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2411041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411052 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2411055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2411074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411078 */     // GIR_Coverage, 73112,
     /* 2411078 */     GIR_EraseRootFromParent_Done,
     /* 2411079 */   // Label 34669: @2411079
     /* 2411079 */   GIM_Try, /*On fail goto*//*Label 34670*/ GIMT_Encode4(2411141), // Rule ID 73113 //
     /* 2411084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2411087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2411103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411114 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2411117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2411136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411140 */     // GIR_Coverage, 73113,
     /* 2411140 */     GIR_EraseRootFromParent_Done,
     /* 2411141 */   // Label 34670: @2411141
     /* 2411141 */   GIM_Try, /*On fail goto*//*Label 34671*/ GIMT_Encode4(2411203), // Rule ID 55604 //
     /* 2411146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2411149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2411169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411176 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2411179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2411189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2411198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411202 */     // GIR_Coverage, 55604,
     /* 2411202 */     GIR_EraseRootFromParent_Done,
     /* 2411203 */   // Label 34671: @2411203
     /* 2411203 */   GIM_Try, /*On fail goto*//*Label 34672*/ GIMT_Encode4(2411265), // Rule ID 55605 //
     /* 2411208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2411211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2411231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411238 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2411241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2411251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2411260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411264 */     // GIR_Coverage, 55605,
     /* 2411264 */     GIR_EraseRootFromParent_Done,
     /* 2411265 */   // Label 34672: @2411265
     /* 2411265 */   GIM_Try, /*On fail goto*//*Label 34673*/ GIMT_Encode4(2411310), // Rule ID 55600 //
     /* 2411270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2411273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411285 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2411288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2411305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411309 */     // GIR_Coverage, 55600,
     /* 2411309 */     GIR_EraseRootFromParent_Done,
     /* 2411310 */   // Label 34673: @2411310
     /* 2411310 */   GIM_Try, /*On fail goto*//*Label 34674*/ GIMT_Encode4(2411355), // Rule ID 55601 //
     /* 2411315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2411318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411330 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2411333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2411350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411354 */     // GIR_Coverage, 55601,
     /* 2411354 */     GIR_EraseRootFromParent_Done,
     /* 2411355 */   // Label 34674: @2411355
     /* 2411355 */   GIM_Reject,
     /* 2411356 */ // Label 34662: @2411356
     /* 2411356 */ GIM_Reject,
     /* 2411357 */ // Label 34506: @2411357
     /* 2411357 */ GIM_Try, /*On fail goto*//*Label 34675*/ GIMT_Encode4(2412146),
     /* 2411362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2411368 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2411371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411375 */   GIM_Try, /*On fail goto*//*Label 34676*/ GIMT_Encode4(2411452), // Rule ID 55032 //
     /* 2411380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411423 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2411426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411451 */     // GIR_Coverage, 55032,
     /* 2411451 */     GIR_EraseRootFromParent_Done,
     /* 2411452 */   // Label 34676: @2411452
     /* 2411452 */   GIM_Try, /*On fail goto*//*Label 34677*/ GIMT_Encode4(2411529), // Rule ID 55033 //
     /* 2411457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411500 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2411503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411528 */     // GIR_Coverage, 55033,
     /* 2411528 */     GIR_EraseRootFromParent_Done,
     /* 2411529 */   // Label 34677: @2411529
     /* 2411529 */   GIM_Try, /*On fail goto*//*Label 34678*/ GIMT_Encode4(2411606), // Rule ID 72604 //
     /* 2411534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411577 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2411580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411605 */     // GIR_Coverage, 72604,
     /* 2411605 */     GIR_EraseRootFromParent_Done,
     /* 2411606 */   // Label 34678: @2411606
     /* 2411606 */   GIM_Try, /*On fail goto*//*Label 34679*/ GIMT_Encode4(2411683), // Rule ID 72605 //
     /* 2411611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411654 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2411657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411682 */     // GIR_Coverage, 72605,
     /* 2411682 */     GIR_EraseRootFromParent_Done,
     /* 2411683 */   // Label 34679: @2411683
     /* 2411683 */   GIM_Try, /*On fail goto*//*Label 34680*/ GIMT_Encode4(2411745), // Rule ID 55036 //
     /* 2411688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411718 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2411721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411744 */     // GIR_Coverage, 55036,
     /* 2411744 */     GIR_EraseRootFromParent_Done,
     /* 2411745 */   // Label 34680: @2411745
     /* 2411745 */   GIM_Try, /*On fail goto*//*Label 34681*/ GIMT_Encode4(2411807), // Rule ID 55037 //
     /* 2411750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411780 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2411783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411806 */     // GIR_Coverage, 55037,
     /* 2411806 */     GIR_EraseRootFromParent_Done,
     /* 2411807 */   // Label 34681: @2411807
     /* 2411807 */   GIM_Try, /*On fail goto*//*Label 34682*/ GIMT_Encode4(2411869), // Rule ID 72608 //
     /* 2411812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411842 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2411845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411868 */     // GIR_Coverage, 72608,
     /* 2411868 */     GIR_EraseRootFromParent_Done,
     /* 2411869 */   // Label 34682: @2411869
     /* 2411869 */   GIM_Try, /*On fail goto*//*Label 34683*/ GIMT_Encode4(2411931), // Rule ID 72609 //
     /* 2411874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411904 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2411907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411930 */     // GIR_Coverage, 72609,
     /* 2411930 */     GIR_EraseRootFromParent_Done,
     /* 2411931 */   // Label 34683: @2411931
     /* 2411931 */   GIM_Try, /*On fail goto*//*Label 34684*/ GIMT_Encode4(2411993), // Rule ID 55028 //
     /* 2411936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411966 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2411969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2411979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411992 */     // GIR_Coverage, 55028,
     /* 2411992 */     GIR_EraseRootFromParent_Done,
     /* 2411993 */   // Label 34684: @2411993
     /* 2411993 */   GIM_Try, /*On fail goto*//*Label 34685*/ GIMT_Encode4(2412055), // Rule ID 55029 //
     /* 2411998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2412001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2412021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412028 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2412031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2412041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412054 */     // GIR_Coverage, 55029,
     /* 2412054 */     GIR_EraseRootFromParent_Done,
     /* 2412055 */   // Label 34685: @2412055
     /* 2412055 */   GIM_Try, /*On fail goto*//*Label 34686*/ GIMT_Encode4(2412100), // Rule ID 55024 //
     /* 2412060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2412063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412075 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2412078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412099 */     // GIR_Coverage, 55024,
     /* 2412099 */     GIR_EraseRootFromParent_Done,
     /* 2412100 */   // Label 34686: @2412100
     /* 2412100 */   GIM_Try, /*On fail goto*//*Label 34687*/ GIMT_Encode4(2412145), // Rule ID 55025 //
     /* 2412105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2412108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412120 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2412123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412144 */     // GIR_Coverage, 55025,
     /* 2412144 */     GIR_EraseRootFromParent_Done,
     /* 2412145 */   // Label 34687: @2412145
     /* 2412145 */   GIM_Reject,
     /* 2412146 */ // Label 34675: @2412146
     /* 2412146 */ GIM_Reject,
     /* 2412147 */ // Label 34507: @2412147
     /* 2412147 */ GIM_Try, /*On fail goto*//*Label 34688*/ GIMT_Encode4(2412936),
     /* 2412152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2412158 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2412161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412165 */   GIM_Try, /*On fail goto*//*Label 34689*/ GIMT_Encode4(2412242), // Rule ID 55416 //
     /* 2412170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2412173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412213 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2412216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412241 */     // GIR_Coverage, 55416,
     /* 2412241 */     GIR_EraseRootFromParent_Done,
     /* 2412242 */   // Label 34689: @2412242
     /* 2412242 */   GIM_Try, /*On fail goto*//*Label 34690*/ GIMT_Encode4(2412319), // Rule ID 55417 //
     /* 2412247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2412250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412290 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2412293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412318 */     // GIR_Coverage, 55417,
     /* 2412318 */     GIR_EraseRootFromParent_Done,
     /* 2412319 */   // Label 34690: @2412319
     /* 2412319 */   GIM_Try, /*On fail goto*//*Label 34691*/ GIMT_Encode4(2412396), // Rule ID 72940 //
     /* 2412324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2412327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412367 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2412370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412395 */     // GIR_Coverage, 72940,
     /* 2412395 */     GIR_EraseRootFromParent_Done,
     /* 2412396 */   // Label 34691: @2412396
     /* 2412396 */   GIM_Try, /*On fail goto*//*Label 34692*/ GIMT_Encode4(2412473), // Rule ID 72941 //
     /* 2412401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2412404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412444 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2412447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412472 */     // GIR_Coverage, 72941,
     /* 2412472 */     GIR_EraseRootFromParent_Done,
     /* 2412473 */   // Label 34692: @2412473
     /* 2412473 */   GIM_Try, /*On fail goto*//*Label 34693*/ GIMT_Encode4(2412535), // Rule ID 55420 //
     /* 2412478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2412481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412508 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2412511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412534 */     // GIR_Coverage, 55420,
     /* 2412534 */     GIR_EraseRootFromParent_Done,
     /* 2412535 */   // Label 34693: @2412535
     /* 2412535 */   GIM_Try, /*On fail goto*//*Label 34694*/ GIMT_Encode4(2412597), // Rule ID 55421 //
     /* 2412540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2412543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412570 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2412573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412596 */     // GIR_Coverage, 55421,
     /* 2412596 */     GIR_EraseRootFromParent_Done,
     /* 2412597 */   // Label 34694: @2412597
     /* 2412597 */   GIM_Try, /*On fail goto*//*Label 34695*/ GIMT_Encode4(2412659), // Rule ID 72944 //
     /* 2412602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2412605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412632 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2412635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412658 */     // GIR_Coverage, 72944,
     /* 2412658 */     GIR_EraseRootFromParent_Done,
     /* 2412659 */   // Label 34695: @2412659
     /* 2412659 */   GIM_Try, /*On fail goto*//*Label 34696*/ GIMT_Encode4(2412721), // Rule ID 72945 //
     /* 2412664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2412667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412694 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2412697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412720 */     // GIR_Coverage, 72945,
     /* 2412720 */     GIR_EraseRootFromParent_Done,
     /* 2412721 */   // Label 34696: @2412721
     /* 2412721 */   GIM_Try, /*On fail goto*//*Label 34697*/ GIMT_Encode4(2412783), // Rule ID 55412 //
     /* 2412726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2412729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412756 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2412759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2412769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412782 */     // GIR_Coverage, 55412,
     /* 2412782 */     GIR_EraseRootFromParent_Done,
     /* 2412783 */   // Label 34697: @2412783
     /* 2412783 */   GIM_Try, /*On fail goto*//*Label 34698*/ GIMT_Encode4(2412845), // Rule ID 55413 //
     /* 2412788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2412791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412818 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2412821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2412831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412844 */     // GIR_Coverage, 55413,
     /* 2412844 */     GIR_EraseRootFromParent_Done,
     /* 2412845 */   // Label 34698: @2412845
     /* 2412845 */   GIM_Try, /*On fail goto*//*Label 34699*/ GIMT_Encode4(2412890), // Rule ID 55408 //
     /* 2412850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2412853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412865 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2412868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412889 */     // GIR_Coverage, 55408,
     /* 2412889 */     GIR_EraseRootFromParent_Done,
     /* 2412890 */   // Label 34699: @2412890
     /* 2412890 */   GIM_Try, /*On fail goto*//*Label 34700*/ GIMT_Encode4(2412935), // Rule ID 55409 //
     /* 2412895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2412898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412910 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2412913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412934 */     // GIR_Coverage, 55409,
     /* 2412934 */     GIR_EraseRootFromParent_Done,
     /* 2412935 */   // Label 34700: @2412935
     /* 2412935 */   GIM_Reject,
     /* 2412936 */ // Label 34688: @2412936
     /* 2412936 */ GIM_Reject,
     /* 2412937 */ // Label 34508: @2412937
     /* 2412937 */ GIM_Try, /*On fail goto*//*Label 34701*/ GIMT_Encode4(2413726),
     /* 2412942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2412948 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2412951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412955 */   GIM_Try, /*On fail goto*//*Label 34702*/ GIMT_Encode4(2413032), // Rule ID 55672 //
     /* 2412960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2412963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413003 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2413006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413031 */     // GIR_Coverage, 55672,
     /* 2413031 */     GIR_EraseRootFromParent_Done,
     /* 2413032 */   // Label 34702: @2413032
     /* 2413032 */   GIM_Try, /*On fail goto*//*Label 34703*/ GIMT_Encode4(2413109), // Rule ID 55673 //
     /* 2413037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2413040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413080 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2413083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413108 */     // GIR_Coverage, 55673,
     /* 2413108 */     GIR_EraseRootFromParent_Done,
     /* 2413109 */   // Label 34703: @2413109
     /* 2413109 */   GIM_Try, /*On fail goto*//*Label 34704*/ GIMT_Encode4(2413186), // Rule ID 73164 //
     /* 2413114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2413117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413157 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2413160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413185 */     // GIR_Coverage, 73164,
     /* 2413185 */     GIR_EraseRootFromParent_Done,
     /* 2413186 */   // Label 34704: @2413186
     /* 2413186 */   GIM_Try, /*On fail goto*//*Label 34705*/ GIMT_Encode4(2413263), // Rule ID 73165 //
     /* 2413191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2413194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413234 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2413237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413262 */     // GIR_Coverage, 73165,
     /* 2413262 */     GIR_EraseRootFromParent_Done,
     /* 2413263 */   // Label 34705: @2413263
     /* 2413263 */   GIM_Try, /*On fail goto*//*Label 34706*/ GIMT_Encode4(2413325), // Rule ID 55676 //
     /* 2413268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2413271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413298 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2413301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413324 */     // GIR_Coverage, 55676,
     /* 2413324 */     GIR_EraseRootFromParent_Done,
     /* 2413325 */   // Label 34706: @2413325
     /* 2413325 */   GIM_Try, /*On fail goto*//*Label 34707*/ GIMT_Encode4(2413387), // Rule ID 55677 //
     /* 2413330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2413333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413360 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2413363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413386 */     // GIR_Coverage, 55677,
     /* 2413386 */     GIR_EraseRootFromParent_Done,
     /* 2413387 */   // Label 34707: @2413387
     /* 2413387 */   GIM_Try, /*On fail goto*//*Label 34708*/ GIMT_Encode4(2413449), // Rule ID 73168 //
     /* 2413392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2413395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413422 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2413425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413448 */     // GIR_Coverage, 73168,
     /* 2413448 */     GIR_EraseRootFromParent_Done,
     /* 2413449 */   // Label 34708: @2413449
     /* 2413449 */   GIM_Try, /*On fail goto*//*Label 34709*/ GIMT_Encode4(2413511), // Rule ID 73169 //
     /* 2413454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2413457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413484 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2413487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413510 */     // GIR_Coverage, 73169,
     /* 2413510 */     GIR_EraseRootFromParent_Done,
     /* 2413511 */   // Label 34709: @2413511
     /* 2413511 */   GIM_Try, /*On fail goto*//*Label 34710*/ GIMT_Encode4(2413573), // Rule ID 55668 //
     /* 2413516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2413519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413546 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2413549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413572 */     // GIR_Coverage, 55668,
     /* 2413572 */     GIR_EraseRootFromParent_Done,
     /* 2413573 */   // Label 34710: @2413573
     /* 2413573 */   GIM_Try, /*On fail goto*//*Label 34711*/ GIMT_Encode4(2413635), // Rule ID 55669 //
     /* 2413578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2413581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413608 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2413611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413634 */     // GIR_Coverage, 55669,
     /* 2413634 */     GIR_EraseRootFromParent_Done,
     /* 2413635 */   // Label 34711: @2413635
     /* 2413635 */   GIM_Try, /*On fail goto*//*Label 34712*/ GIMT_Encode4(2413680), // Rule ID 55664 //
     /* 2413640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2413643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413655 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2413658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413679 */     // GIR_Coverage, 55664,
     /* 2413679 */     GIR_EraseRootFromParent_Done,
     /* 2413680 */   // Label 34712: @2413680
     /* 2413680 */   GIM_Try, /*On fail goto*//*Label 34713*/ GIMT_Encode4(2413725), // Rule ID 55665 //
     /* 2413685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2413688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413700 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2413703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413724 */     // GIR_Coverage, 55665,
     /* 2413724 */     GIR_EraseRootFromParent_Done,
     /* 2413725 */   // Label 34713: @2413725
     /* 2413725 */   GIM_Reject,
     /* 2413726 */ // Label 34701: @2413726
     /* 2413726 */ GIM_Reject,
     /* 2413727 */ // Label 34509: @2413727
     /* 2413727 */ GIM_Try, /*On fail goto*//*Label 34714*/ GIMT_Encode4(2414516),
     /* 2413732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2413738 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2413741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413745 */   GIM_Try, /*On fail goto*//*Label 34715*/ GIMT_Encode4(2413822), // Rule ID 55224 //
     /* 2413750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413793 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2413796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413821 */     // GIR_Coverage, 55224,
     /* 2413821 */     GIR_EraseRootFromParent_Done,
     /* 2413822 */   // Label 34715: @2413822
     /* 2413822 */   GIM_Try, /*On fail goto*//*Label 34716*/ GIMT_Encode4(2413899), // Rule ID 55225 //
     /* 2413827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413870 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2413873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413898 */     // GIR_Coverage, 55225,
     /* 2413898 */     GIR_EraseRootFromParent_Done,
     /* 2413899 */   // Label 34716: @2413899
     /* 2413899 */   GIM_Try, /*On fail goto*//*Label 34717*/ GIMT_Encode4(2413976), // Rule ID 72772 //
     /* 2413904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413947 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2413950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413975 */     // GIR_Coverage, 72772,
     /* 2413975 */     GIR_EraseRootFromParent_Done,
     /* 2413976 */   // Label 34717: @2413976
     /* 2413976 */   GIM_Try, /*On fail goto*//*Label 34718*/ GIMT_Encode4(2414053), // Rule ID 72773 //
     /* 2413981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2414000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2414017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414024 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2414027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414052 */     // GIR_Coverage, 72773,
     /* 2414052 */     GIR_EraseRootFromParent_Done,
     /* 2414053 */   // Label 34718: @2414053
     /* 2414053 */   GIM_Try, /*On fail goto*//*Label 34719*/ GIMT_Encode4(2414115), // Rule ID 55228 //
     /* 2414058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2414061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2414073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414088 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2414091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414114 */     // GIR_Coverage, 55228,
     /* 2414114 */     GIR_EraseRootFromParent_Done,
     /* 2414115 */   // Label 34719: @2414115
     /* 2414115 */   GIM_Try, /*On fail goto*//*Label 34720*/ GIMT_Encode4(2414177), // Rule ID 55229 //
     /* 2414120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2414123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2414135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414150 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2414153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414176 */     // GIR_Coverage, 55229,
     /* 2414176 */     GIR_EraseRootFromParent_Done,
     /* 2414177 */   // Label 34720: @2414177
     /* 2414177 */   GIM_Try, /*On fail goto*//*Label 34721*/ GIMT_Encode4(2414239), // Rule ID 72776 //
     /* 2414182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2414185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2414201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414212 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2414215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414238 */     // GIR_Coverage, 72776,
     /* 2414238 */     GIR_EraseRootFromParent_Done,
     /* 2414239 */   // Label 34721: @2414239
     /* 2414239 */   GIM_Try, /*On fail goto*//*Label 34722*/ GIMT_Encode4(2414301), // Rule ID 72777 //
     /* 2414244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2414247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2414263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414274 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2414277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414300 */     // GIR_Coverage, 72777,
     /* 2414300 */     GIR_EraseRootFromParent_Done,
     /* 2414301 */   // Label 34722: @2414301
     /* 2414301 */   GIM_Try, /*On fail goto*//*Label 34723*/ GIMT_Encode4(2414363), // Rule ID 55220 //
     /* 2414306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2414309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2414329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414336 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2414339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2414349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414362 */     // GIR_Coverage, 55220,
     /* 2414362 */     GIR_EraseRootFromParent_Done,
     /* 2414363 */   // Label 34723: @2414363
     /* 2414363 */   GIM_Try, /*On fail goto*//*Label 34724*/ GIMT_Encode4(2414425), // Rule ID 55221 //
     /* 2414368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2414371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2414391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414398 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2414401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2414411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414424 */     // GIR_Coverage, 55221,
     /* 2414424 */     GIR_EraseRootFromParent_Done,
     /* 2414425 */   // Label 34724: @2414425
     /* 2414425 */   GIM_Try, /*On fail goto*//*Label 34725*/ GIMT_Encode4(2414470), // Rule ID 55216 //
     /* 2414430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2414433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414445 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2414448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414469 */     // GIR_Coverage, 55216,
     /* 2414469 */     GIR_EraseRootFromParent_Done,
     /* 2414470 */   // Label 34725: @2414470
     /* 2414470 */   GIM_Try, /*On fail goto*//*Label 34726*/ GIMT_Encode4(2414515), // Rule ID 55217 //
     /* 2414475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2414478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414490 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2414493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414514 */     // GIR_Coverage, 55217,
     /* 2414514 */     GIR_EraseRootFromParent_Done,
     /* 2414515 */   // Label 34726: @2414515
     /* 2414515 */   GIM_Reject,
     /* 2414516 */ // Label 34714: @2414516
     /* 2414516 */ GIM_Reject,
     /* 2414517 */ // Label 34510: @2414517
     /* 2414517 */ GIM_Try, /*On fail goto*//*Label 34727*/ GIMT_Encode4(2415306),
     /* 2414522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2414528 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2414531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414535 */   GIM_Try, /*On fail goto*//*Label 34728*/ GIMT_Encode4(2414612), // Rule ID 55480 //
     /* 2414540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414583 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2414586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414611 */     // GIR_Coverage, 55480,
     /* 2414611 */     GIR_EraseRootFromParent_Done,
     /* 2414612 */   // Label 34728: @2414612
     /* 2414612 */   GIM_Try, /*On fail goto*//*Label 34729*/ GIMT_Encode4(2414689), // Rule ID 55481 //
     /* 2414617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414660 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2414663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414688 */     // GIR_Coverage, 55481,
     /* 2414688 */     GIR_EraseRootFromParent_Done,
     /* 2414689 */   // Label 34729: @2414689
     /* 2414689 */   GIM_Try, /*On fail goto*//*Label 34730*/ GIMT_Encode4(2414766), // Rule ID 72996 //
     /* 2414694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414737 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2414740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414765 */     // GIR_Coverage, 72996,
     /* 2414765 */     GIR_EraseRootFromParent_Done,
     /* 2414766 */   // Label 34730: @2414766
     /* 2414766 */   GIM_Try, /*On fail goto*//*Label 34731*/ GIMT_Encode4(2414843), // Rule ID 72997 //
     /* 2414771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414814 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2414817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414842 */     // GIR_Coverage, 72997,
     /* 2414842 */     GIR_EraseRootFromParent_Done,
     /* 2414843 */   // Label 34731: @2414843
     /* 2414843 */   GIM_Try, /*On fail goto*//*Label 34732*/ GIMT_Encode4(2414905), // Rule ID 55484 //
     /* 2414848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414878 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2414881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414904 */     // GIR_Coverage, 55484,
     /* 2414904 */     GIR_EraseRootFromParent_Done,
     /* 2414905 */   // Label 34732: @2414905
     /* 2414905 */   GIM_Try, /*On fail goto*//*Label 34733*/ GIMT_Encode4(2414967), // Rule ID 55485 //
     /* 2414910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414940 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2414943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414966 */     // GIR_Coverage, 55485,
     /* 2414966 */     GIR_EraseRootFromParent_Done,
     /* 2414967 */   // Label 34733: @2414967
     /* 2414967 */   GIM_Try, /*On fail goto*//*Label 34734*/ GIMT_Encode4(2415029), // Rule ID 73000 //
     /* 2414972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415002 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2415005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415028 */     // GIR_Coverage, 73000,
     /* 2415028 */     GIR_EraseRootFromParent_Done,
     /* 2415029 */   // Label 34734: @2415029
     /* 2415029 */   GIM_Try, /*On fail goto*//*Label 34735*/ GIMT_Encode4(2415091), // Rule ID 73001 //
     /* 2415034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2415037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2415053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415064 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2415067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415090 */     // GIR_Coverage, 73001,
     /* 2415090 */     GIR_EraseRootFromParent_Done,
     /* 2415091 */   // Label 34735: @2415091
     /* 2415091 */   GIM_Try, /*On fail goto*//*Label 34736*/ GIMT_Encode4(2415153), // Rule ID 55476 //
     /* 2415096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2415099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2415119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415126 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2415129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2415139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415152 */     // GIR_Coverage, 55476,
     /* 2415152 */     GIR_EraseRootFromParent_Done,
     /* 2415153 */   // Label 34736: @2415153
     /* 2415153 */   GIM_Try, /*On fail goto*//*Label 34737*/ GIMT_Encode4(2415215), // Rule ID 55477 //
     /* 2415158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2415161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2415181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415188 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2415191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2415201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415214 */     // GIR_Coverage, 55477,
     /* 2415214 */     GIR_EraseRootFromParent_Done,
     /* 2415215 */   // Label 34737: @2415215
     /* 2415215 */   GIM_Try, /*On fail goto*//*Label 34738*/ GIMT_Encode4(2415260), // Rule ID 55472 //
     /* 2415220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2415223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415235 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2415238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415259 */     // GIR_Coverage, 55472,
     /* 2415259 */     GIR_EraseRootFromParent_Done,
     /* 2415260 */   // Label 34738: @2415260
     /* 2415260 */   GIM_Try, /*On fail goto*//*Label 34739*/ GIMT_Encode4(2415305), // Rule ID 55473 //
     /* 2415265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2415268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415280 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2415283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415304 */     // GIR_Coverage, 55473,
     /* 2415304 */     GIR_EraseRootFromParent_Done,
     /* 2415305 */   // Label 34739: @2415305
     /* 2415305 */   GIM_Reject,
     /* 2415306 */ // Label 34727: @2415306
     /* 2415306 */ GIM_Reject,
     /* 2415307 */ // Label 34511: @2415307
     /* 2415307 */ GIM_Try, /*On fail goto*//*Label 34740*/ GIMT_Encode4(2416096),
     /* 2415312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2415318 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2415321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415325 */   GIM_Try, /*On fail goto*//*Label 34741*/ GIMT_Encode4(2415402), // Rule ID 55736 //
     /* 2415330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415373 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2415376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415401 */     // GIR_Coverage, 55736,
     /* 2415401 */     GIR_EraseRootFromParent_Done,
     /* 2415402 */   // Label 34741: @2415402
     /* 2415402 */   GIM_Try, /*On fail goto*//*Label 34742*/ GIMT_Encode4(2415479), // Rule ID 55737 //
     /* 2415407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415450 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2415453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415478 */     // GIR_Coverage, 55737,
     /* 2415478 */     GIR_EraseRootFromParent_Done,
     /* 2415479 */   // Label 34742: @2415479
     /* 2415479 */   GIM_Try, /*On fail goto*//*Label 34743*/ GIMT_Encode4(2415556), // Rule ID 73220 //
     /* 2415484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415527 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2415530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415555 */     // GIR_Coverage, 73220,
     /* 2415555 */     GIR_EraseRootFromParent_Done,
     /* 2415556 */   // Label 34743: @2415556
     /* 2415556 */   GIM_Try, /*On fail goto*//*Label 34744*/ GIMT_Encode4(2415633), // Rule ID 73221 //
     /* 2415561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415604 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2415607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415632 */     // GIR_Coverage, 73221,
     /* 2415632 */     GIR_EraseRootFromParent_Done,
     /* 2415633 */   // Label 34744: @2415633
     /* 2415633 */   GIM_Try, /*On fail goto*//*Label 34745*/ GIMT_Encode4(2415695), // Rule ID 55740 //
     /* 2415638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415668 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2415671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415694 */     // GIR_Coverage, 55740,
     /* 2415694 */     GIR_EraseRootFromParent_Done,
     /* 2415695 */   // Label 34745: @2415695
     /* 2415695 */   GIM_Try, /*On fail goto*//*Label 34746*/ GIMT_Encode4(2415757), // Rule ID 55741 //
     /* 2415700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415730 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2415733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415756 */     // GIR_Coverage, 55741,
     /* 2415756 */     GIR_EraseRootFromParent_Done,
     /* 2415757 */   // Label 34746: @2415757
     /* 2415757 */   GIM_Try, /*On fail goto*//*Label 34747*/ GIMT_Encode4(2415819), // Rule ID 73224 //
     /* 2415762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415792 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2415795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415818 */     // GIR_Coverage, 73224,
     /* 2415818 */     GIR_EraseRootFromParent_Done,
     /* 2415819 */   // Label 34747: @2415819
     /* 2415819 */   GIM_Try, /*On fail goto*//*Label 34748*/ GIMT_Encode4(2415881), // Rule ID 73225 //
     /* 2415824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415854 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2415857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415880 */     // GIR_Coverage, 73225,
     /* 2415880 */     GIR_EraseRootFromParent_Done,
     /* 2415881 */   // Label 34748: @2415881
     /* 2415881 */   GIM_Try, /*On fail goto*//*Label 34749*/ GIMT_Encode4(2415943), // Rule ID 55732 //
     /* 2415886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415916 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2415919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2415929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415942 */     // GIR_Coverage, 55732,
     /* 2415942 */     GIR_EraseRootFromParent_Done,
     /* 2415943 */   // Label 34749: @2415943
     /* 2415943 */   GIM_Try, /*On fail goto*//*Label 34750*/ GIMT_Encode4(2416005), // Rule ID 55733 //
     /* 2415948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415978 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2415981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2415991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416004 */     // GIR_Coverage, 55733,
     /* 2416004 */     GIR_EraseRootFromParent_Done,
     /* 2416005 */   // Label 34750: @2416005
     /* 2416005 */   GIM_Try, /*On fail goto*//*Label 34751*/ GIMT_Encode4(2416050), // Rule ID 55728 //
     /* 2416010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2416013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416025 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2416028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416049 */     // GIR_Coverage, 55728,
     /* 2416049 */     GIR_EraseRootFromParent_Done,
     /* 2416050 */   // Label 34751: @2416050
     /* 2416050 */   GIM_Try, /*On fail goto*//*Label 34752*/ GIMT_Encode4(2416095), // Rule ID 55729 //
     /* 2416055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2416058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416070 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2416073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416094 */     // GIR_Coverage, 55729,
     /* 2416094 */     GIR_EraseRootFromParent_Done,
     /* 2416095 */   // Label 34752: @2416095
     /* 2416095 */   GIM_Reject,
     /* 2416096 */ // Label 34740: @2416096
     /* 2416096 */ GIM_Reject,
     /* 2416097 */ // Label 34512: @2416097
     /* 2416097 */ GIM_Try, /*On fail goto*//*Label 34753*/ GIMT_Encode4(2416886),
     /* 2416102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2416108 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2416111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416115 */   GIM_Try, /*On fail goto*//*Label 34754*/ GIMT_Encode4(2416192), // Rule ID 55288 //
     /* 2416120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2416123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416156 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416163 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2416166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416191 */     // GIR_Coverage, 55288,
     /* 2416191 */     GIR_EraseRootFromParent_Done,
     /* 2416192 */   // Label 34754: @2416192
     /* 2416192 */   GIM_Try, /*On fail goto*//*Label 34755*/ GIMT_Encode4(2416269), // Rule ID 55289 //
     /* 2416197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2416200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416233 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416240 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2416243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416268 */     // GIR_Coverage, 55289,
     /* 2416268 */     GIR_EraseRootFromParent_Done,
     /* 2416269 */   // Label 34755: @2416269
     /* 2416269 */   GIM_Try, /*On fail goto*//*Label 34756*/ GIMT_Encode4(2416346), // Rule ID 72828 //
     /* 2416274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2416277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416317 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2416320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416345 */     // GIR_Coverage, 72828,
     /* 2416345 */     GIR_EraseRootFromParent_Done,
     /* 2416346 */   // Label 34756: @2416346
     /* 2416346 */   GIM_Try, /*On fail goto*//*Label 34757*/ GIMT_Encode4(2416423), // Rule ID 72829 //
     /* 2416351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2416354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416394 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2416397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416422 */     // GIR_Coverage, 72829,
     /* 2416422 */     GIR_EraseRootFromParent_Done,
     /* 2416423 */   // Label 34757: @2416423
     /* 2416423 */   GIM_Try, /*On fail goto*//*Label 34758*/ GIMT_Encode4(2416485), // Rule ID 55292 //
     /* 2416428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2416431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416458 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2416461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416484 */     // GIR_Coverage, 55292,
     /* 2416484 */     GIR_EraseRootFromParent_Done,
     /* 2416485 */   // Label 34758: @2416485
     /* 2416485 */   GIM_Try, /*On fail goto*//*Label 34759*/ GIMT_Encode4(2416547), // Rule ID 55293 //
     /* 2416490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2416493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416520 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2416523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416546 */     // GIR_Coverage, 55293,
     /* 2416546 */     GIR_EraseRootFromParent_Done,
     /* 2416547 */   // Label 34759: @2416547
     /* 2416547 */   GIM_Try, /*On fail goto*//*Label 34760*/ GIMT_Encode4(2416609), // Rule ID 72832 //
     /* 2416552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2416555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416582 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2416585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416608 */     // GIR_Coverage, 72832,
     /* 2416608 */     GIR_EraseRootFromParent_Done,
     /* 2416609 */   // Label 34760: @2416609
     /* 2416609 */   GIM_Try, /*On fail goto*//*Label 34761*/ GIMT_Encode4(2416671), // Rule ID 72833 //
     /* 2416614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2416617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416644 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2416647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416670 */     // GIR_Coverage, 72833,
     /* 2416670 */     GIR_EraseRootFromParent_Done,
     /* 2416671 */   // Label 34761: @2416671
     /* 2416671 */   GIM_Try, /*On fail goto*//*Label 34762*/ GIMT_Encode4(2416733), // Rule ID 55284 //
     /* 2416676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2416679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416706 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2416709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416732 */     // GIR_Coverage, 55284,
     /* 2416732 */     GIR_EraseRootFromParent_Done,
     /* 2416733 */   // Label 34762: @2416733
     /* 2416733 */   GIM_Try, /*On fail goto*//*Label 34763*/ GIMT_Encode4(2416795), // Rule ID 55285 //
     /* 2416738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2416741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416768 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2416771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416794 */     // GIR_Coverage, 55285,
     /* 2416794 */     GIR_EraseRootFromParent_Done,
     /* 2416795 */   // Label 34763: @2416795
     /* 2416795 */   GIM_Try, /*On fail goto*//*Label 34764*/ GIMT_Encode4(2416840), // Rule ID 55280 //
     /* 2416800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2416803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416815 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2416818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416839 */     // GIR_Coverage, 55280,
     /* 2416839 */     GIR_EraseRootFromParent_Done,
     /* 2416840 */   // Label 34764: @2416840
     /* 2416840 */   GIM_Try, /*On fail goto*//*Label 34765*/ GIMT_Encode4(2416885), // Rule ID 55281 //
     /* 2416845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2416848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416860 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2416863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416884 */     // GIR_Coverage, 55281,
     /* 2416884 */     GIR_EraseRootFromParent_Done,
     /* 2416885 */   // Label 34765: @2416885
     /* 2416885 */   GIM_Reject,
     /* 2416886 */ // Label 34753: @2416886
     /* 2416886 */ GIM_Reject,
     /* 2416887 */ // Label 34513: @2416887
     /* 2416887 */ GIM_Try, /*On fail goto*//*Label 34766*/ GIMT_Encode4(2417676),
     /* 2416892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2416898 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2416901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416905 */   GIM_Try, /*On fail goto*//*Label 34767*/ GIMT_Encode4(2416982), // Rule ID 55544 //
     /* 2416910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416953 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2416956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416981 */     // GIR_Coverage, 55544,
     /* 2416981 */     GIR_EraseRootFromParent_Done,
     /* 2416982 */   // Label 34767: @2416982
     /* 2416982 */   GIM_Try, /*On fail goto*//*Label 34768*/ GIMT_Encode4(2417059), // Rule ID 55545 //
     /* 2416987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417030 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2417033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417058 */     // GIR_Coverage, 55545,
     /* 2417058 */     GIR_EraseRootFromParent_Done,
     /* 2417059 */   // Label 34768: @2417059
     /* 2417059 */   GIM_Try, /*On fail goto*//*Label 34769*/ GIMT_Encode4(2417136), // Rule ID 73052 //
     /* 2417064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2417067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417107 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2417110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417135 */     // GIR_Coverage, 73052,
     /* 2417135 */     GIR_EraseRootFromParent_Done,
     /* 2417136 */   // Label 34769: @2417136
     /* 2417136 */   GIM_Try, /*On fail goto*//*Label 34770*/ GIMT_Encode4(2417213), // Rule ID 73053 //
     /* 2417141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2417144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417184 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2417187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417212 */     // GIR_Coverage, 73053,
     /* 2417212 */     GIR_EraseRootFromParent_Done,
     /* 2417213 */   // Label 34770: @2417213
     /* 2417213 */   GIM_Try, /*On fail goto*//*Label 34771*/ GIMT_Encode4(2417275), // Rule ID 55548 //
     /* 2417218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2417221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417248 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2417251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417274 */     // GIR_Coverage, 55548,
     /* 2417274 */     GIR_EraseRootFromParent_Done,
     /* 2417275 */   // Label 34771: @2417275
     /* 2417275 */   GIM_Try, /*On fail goto*//*Label 34772*/ GIMT_Encode4(2417337), // Rule ID 55549 //
     /* 2417280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2417283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417310 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2417313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417336 */     // GIR_Coverage, 55549,
     /* 2417336 */     GIR_EraseRootFromParent_Done,
     /* 2417337 */   // Label 34772: @2417337
     /* 2417337 */   GIM_Try, /*On fail goto*//*Label 34773*/ GIMT_Encode4(2417399), // Rule ID 73056 //
     /* 2417342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2417345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417372 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2417375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417398 */     // GIR_Coverage, 73056,
     /* 2417398 */     GIR_EraseRootFromParent_Done,
     /* 2417399 */   // Label 34773: @2417399
     /* 2417399 */   GIM_Try, /*On fail goto*//*Label 34774*/ GIMT_Encode4(2417461), // Rule ID 73057 //
     /* 2417404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2417407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417434 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2417437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417460 */     // GIR_Coverage, 73057,
     /* 2417460 */     GIR_EraseRootFromParent_Done,
     /* 2417461 */   // Label 34774: @2417461
     /* 2417461 */   GIM_Try, /*On fail goto*//*Label 34775*/ GIMT_Encode4(2417523), // Rule ID 55540 //
     /* 2417466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2417469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417496 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2417499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2417509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417522 */     // GIR_Coverage, 55540,
     /* 2417522 */     GIR_EraseRootFromParent_Done,
     /* 2417523 */   // Label 34775: @2417523
     /* 2417523 */   GIM_Try, /*On fail goto*//*Label 34776*/ GIMT_Encode4(2417585), // Rule ID 55541 //
     /* 2417528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2417531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417558 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2417561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2417571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417584 */     // GIR_Coverage, 55541,
     /* 2417584 */     GIR_EraseRootFromParent_Done,
     /* 2417585 */   // Label 34776: @2417585
     /* 2417585 */   GIM_Try, /*On fail goto*//*Label 34777*/ GIMT_Encode4(2417630), // Rule ID 55536 //
     /* 2417590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2417593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417605 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2417608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417629 */     // GIR_Coverage, 55536,
     /* 2417629 */     GIR_EraseRootFromParent_Done,
     /* 2417630 */   // Label 34777: @2417630
     /* 2417630 */   GIM_Try, /*On fail goto*//*Label 34778*/ GIMT_Encode4(2417675), // Rule ID 55537 //
     /* 2417635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2417638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417650 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2417653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417674 */     // GIR_Coverage, 55537,
     /* 2417674 */     GIR_EraseRootFromParent_Done,
     /* 2417675 */   // Label 34778: @2417675
     /* 2417675 */   GIM_Reject,
     /* 2417676 */ // Label 34766: @2417676
     /* 2417676 */ GIM_Reject,
     /* 2417677 */ // Label 34514: @2417677
     /* 2417677 */ GIM_Try, /*On fail goto*//*Label 34779*/ GIMT_Encode4(2418466),
     /* 2417682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2417688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2417691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417695 */   GIM_Try, /*On fail goto*//*Label 34780*/ GIMT_Encode4(2417772), // Rule ID 55352 //
     /* 2417700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417743 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2417746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417771 */     // GIR_Coverage, 55352,
     /* 2417771 */     GIR_EraseRootFromParent_Done,
     /* 2417772 */   // Label 34780: @2417772
     /* 2417772 */   GIM_Try, /*On fail goto*//*Label 34781*/ GIMT_Encode4(2417849), // Rule ID 55353 //
     /* 2417777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417813 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417820 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2417823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417848 */     // GIR_Coverage, 55353,
     /* 2417848 */     GIR_EraseRootFromParent_Done,
     /* 2417849 */   // Label 34781: @2417849
     /* 2417849 */   GIM_Try, /*On fail goto*//*Label 34782*/ GIMT_Encode4(2417926), // Rule ID 72884 //
     /* 2417854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417897 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2417900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417925 */     // GIR_Coverage, 72884,
     /* 2417925 */     GIR_EraseRootFromParent_Done,
     /* 2417926 */   // Label 34782: @2417926
     /* 2417926 */   GIM_Try, /*On fail goto*//*Label 34783*/ GIMT_Encode4(2418003), // Rule ID 72885 //
     /* 2417931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417974 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2417977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418002 */     // GIR_Coverage, 72885,
     /* 2418002 */     GIR_EraseRootFromParent_Done,
     /* 2418003 */   // Label 34783: @2418003
     /* 2418003 */   GIM_Try, /*On fail goto*//*Label 34784*/ GIMT_Encode4(2418065), // Rule ID 55356 //
     /* 2418008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2418011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2418023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418038 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2418041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418064 */     // GIR_Coverage, 55356,
     /* 2418064 */     GIR_EraseRootFromParent_Done,
     /* 2418065 */   // Label 34784: @2418065
     /* 2418065 */   GIM_Try, /*On fail goto*//*Label 34785*/ GIMT_Encode4(2418127), // Rule ID 55357 //
     /* 2418070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2418073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2418085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418100 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2418103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418126 */     // GIR_Coverage, 55357,
     /* 2418126 */     GIR_EraseRootFromParent_Done,
     /* 2418127 */   // Label 34785: @2418127
     /* 2418127 */   GIM_Try, /*On fail goto*//*Label 34786*/ GIMT_Encode4(2418189), // Rule ID 72888 //
     /* 2418132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2418135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2418151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418162 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2418165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418188 */     // GIR_Coverage, 72888,
     /* 2418188 */     GIR_EraseRootFromParent_Done,
     /* 2418189 */   // Label 34786: @2418189
     /* 2418189 */   GIM_Try, /*On fail goto*//*Label 34787*/ GIMT_Encode4(2418251), // Rule ID 72889 //
     /* 2418194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2418197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2418213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418224 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2418227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418250 */     // GIR_Coverage, 72889,
     /* 2418250 */     GIR_EraseRootFromParent_Done,
     /* 2418251 */   // Label 34787: @2418251
     /* 2418251 */   GIM_Try, /*On fail goto*//*Label 34788*/ GIMT_Encode4(2418313), // Rule ID 55348 //
     /* 2418256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2418259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2418279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418286 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2418289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2418299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418312 */     // GIR_Coverage, 55348,
     /* 2418312 */     GIR_EraseRootFromParent_Done,
     /* 2418313 */   // Label 34788: @2418313
     /* 2418313 */   GIM_Try, /*On fail goto*//*Label 34789*/ GIMT_Encode4(2418375), // Rule ID 55349 //
     /* 2418318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2418321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2418341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418348 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2418351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2418361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418374 */     // GIR_Coverage, 55349,
     /* 2418374 */     GIR_EraseRootFromParent_Done,
     /* 2418375 */   // Label 34789: @2418375
     /* 2418375 */   GIM_Try, /*On fail goto*//*Label 34790*/ GIMT_Encode4(2418420), // Rule ID 55344 //
     /* 2418380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2418383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418395 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2418398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418419 */     // GIR_Coverage, 55344,
     /* 2418419 */     GIR_EraseRootFromParent_Done,
     /* 2418420 */   // Label 34790: @2418420
     /* 2418420 */   GIM_Try, /*On fail goto*//*Label 34791*/ GIMT_Encode4(2418465), // Rule ID 55345 //
     /* 2418425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2418428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418440 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2418443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418464 */     // GIR_Coverage, 55345,
     /* 2418464 */     GIR_EraseRootFromParent_Done,
     /* 2418465 */   // Label 34791: @2418465
     /* 2418465 */   GIM_Reject,
     /* 2418466 */ // Label 34779: @2418466
     /* 2418466 */ GIM_Reject,
     /* 2418467 */ // Label 34515: @2418467
     /* 2418467 */ GIM_Reject,
     /* 2418468 */ // Label 103: @2418468
     /* 2418468 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34810*/ GIMT_Encode4(2420643),
     /* 2418479 */ /*GILLT_s16*//*Label 34792*/ GIMT_Encode4(2418599),
     /* 2418483 */ /*GILLT_s32*//*Label 34793*/ GIMT_Encode4(2418721),
     /* 2418487 */ /*GILLT_s64*//*Label 34794*/ GIMT_Encode4(2418843), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2418499 */ /*GILLT_nxv1s16*//*Label 34795*/ GIMT_Encode4(2418993),
     /* 2418503 */ /*GILLT_nxv1s32*//*Label 34796*/ GIMT_Encode4(2419103),
     /* 2418507 */ /*GILLT_nxv1s64*//*Label 34797*/ GIMT_Encode4(2419213), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2418519 */ /*GILLT_nxv2s16*//*Label 34798*/ GIMT_Encode4(2419323),
     /* 2418523 */ /*GILLT_nxv2s32*//*Label 34799*/ GIMT_Encode4(2419433),
     /* 2418527 */ /*GILLT_nxv2s64*//*Label 34800*/ GIMT_Encode4(2419543), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2418539 */ /*GILLT_nxv4s16*//*Label 34801*/ GIMT_Encode4(2419653),
     /* 2418543 */ /*GILLT_nxv4s32*//*Label 34802*/ GIMT_Encode4(2419763),
     /* 2418547 */ /*GILLT_nxv4s64*//*Label 34803*/ GIMT_Encode4(2419873), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2418559 */ /*GILLT_nxv8s16*//*Label 34804*/ GIMT_Encode4(2419983),
     /* 2418563 */ /*GILLT_nxv8s32*//*Label 34805*/ GIMT_Encode4(2420093),
     /* 2418567 */ /*GILLT_nxv8s64*//*Label 34806*/ GIMT_Encode4(2420203), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2418579 */ /*GILLT_nxv16s16*//*Label 34807*/ GIMT_Encode4(2420313),
     /* 2418583 */ /*GILLT_nxv16s32*//*Label 34808*/ GIMT_Encode4(2420423), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2418595 */ /*GILLT_nxv32s16*//*Label 34809*/ GIMT_Encode4(2420533),
     /* 2418599 */ // Label 34792: @2418599
     /* 2418599 */ GIM_Try, /*On fail goto*//*Label 34811*/ GIMT_Encode4(2418720),
     /* 2418604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2418607 */   GIM_Try, /*On fail goto*//*Label 34812*/ GIMT_Encode4(2418635), // Rule ID 1988 //
     /* 2418612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2418615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2418619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2418623 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2418623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2418626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418634 */     // GIR_Coverage, 1988,
     /* 2418634 */     GIR_EraseRootFromParent_Done,
     /* 2418635 */   // Label 34812: @2418635
     /* 2418635 */   GIM_Try, /*On fail goto*//*Label 34813*/ GIMT_Encode4(2418663), // Rule ID 1989 //
     /* 2418640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2418643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2418647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2418651 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2418651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2418654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418662 */     // GIR_Coverage, 1989,
     /* 2418662 */     GIR_EraseRootFromParent_Done,
     /* 2418663 */   // Label 34813: @2418663
     /* 2418663 */   GIM_Try, /*On fail goto*//*Label 34814*/ GIMT_Encode4(2418691), // Rule ID 2021 //
     /* 2418668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2418671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2418675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2418679 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2418679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2418682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418690 */     // GIR_Coverage, 2021,
     /* 2418690 */     GIR_EraseRootFromParent_Done,
     /* 2418691 */   // Label 34814: @2418691
     /* 2418691 */   GIM_Try, /*On fail goto*//*Label 34815*/ GIMT_Encode4(2418719), // Rule ID 2022 //
     /* 2418696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2418699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2418703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2418707 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2418707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2418710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418718 */     // GIR_Coverage, 2022,
     /* 2418718 */     GIR_EraseRootFromParent_Done,
     /* 2418719 */   // Label 34815: @2418719
     /* 2418719 */   GIM_Reject,
     /* 2418720 */ // Label 34811: @2418720
     /* 2418720 */ GIM_Reject,
     /* 2418721 */ // Label 34793: @2418721
     /* 2418721 */ GIM_Try, /*On fail goto*//*Label 34816*/ GIMT_Encode4(2418842),
     /* 2418726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2418729 */   GIM_Try, /*On fail goto*//*Label 34817*/ GIMT_Encode4(2418757), // Rule ID 1279 //
     /* 2418734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2418737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2418741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2418745 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2418745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2418748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418756 */     // GIR_Coverage, 1279,
     /* 2418756 */     GIR_EraseRootFromParent_Done,
     /* 2418757 */   // Label 34817: @2418757
     /* 2418757 */   GIM_Try, /*On fail goto*//*Label 34818*/ GIMT_Encode4(2418785), // Rule ID 1280 //
     /* 2418762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2418765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2418769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2418773 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2418773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2418776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418784 */     // GIR_Coverage, 1280,
     /* 2418784 */     GIR_EraseRootFromParent_Done,
     /* 2418785 */   // Label 34818: @2418785
     /* 2418785 */   GIM_Try, /*On fail goto*//*Label 34819*/ GIMT_Encode4(2418813), // Rule ID 1287 //
     /* 2418790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2418793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2418797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2418801 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2418801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2418804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418812 */     // GIR_Coverage, 1287,
     /* 2418812 */     GIR_EraseRootFromParent_Done,
     /* 2418813 */   // Label 34819: @2418813
     /* 2418813 */   GIM_Try, /*On fail goto*//*Label 34820*/ GIMT_Encode4(2418841), // Rule ID 1288 //
     /* 2418818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2418821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2418825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2418829 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2418829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2418832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418840 */     // GIR_Coverage, 1288,
     /* 2418840 */     GIR_EraseRootFromParent_Done,
     /* 2418841 */   // Label 34820: @2418841
     /* 2418841 */   GIM_Reject,
     /* 2418842 */ // Label 34816: @2418842
     /* 2418842 */ GIM_Reject,
     /* 2418843 */ // Label 34794: @2418843
     /* 2418843 */ GIM_Try, /*On fail goto*//*Label 34821*/ GIMT_Encode4(2418992),
     /* 2418848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2418851 */   GIM_Try, /*On fail goto*//*Label 34822*/ GIMT_Encode4(2418879), // Rule ID 1622 //
     /* 2418856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2418859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2418863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2418867 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2418867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2418870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418878 */     // GIR_Coverage, 1622,
     /* 2418878 */     GIR_EraseRootFromParent_Done,
     /* 2418879 */   // Label 34822: @2418879
     /* 2418879 */   GIM_Try, /*On fail goto*//*Label 34823*/ GIMT_Encode4(2418907), // Rule ID 1623 //
     /* 2418884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2418887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2418891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2418895 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2418895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2418898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418906 */     // GIR_Coverage, 1623,
     /* 2418906 */     GIR_EraseRootFromParent_Done,
     /* 2418907 */   // Label 34823: @2418907
     /* 2418907 */   GIM_Try, /*On fail goto*//*Label 34824*/ GIMT_Encode4(2418935), // Rule ID 1657 //
     /* 2418912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2418915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418923 */     // (strict_fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2418923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2418926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418934 */     // GIR_Coverage, 1657,
     /* 2418934 */     GIR_EraseRootFromParent_Done,
     /* 2418935 */   // Label 34824: @2418935
     /* 2418935 */   GIM_Try, /*On fail goto*//*Label 34825*/ GIMT_Encode4(2418963), // Rule ID 1677 //
     /* 2418940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2418943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2418947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2418951 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2418951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2418954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418962 */     // GIR_Coverage, 1677,
     /* 2418962 */     GIR_EraseRootFromParent_Done,
     /* 2418963 */   // Label 34825: @2418963
     /* 2418963 */   GIM_Try, /*On fail goto*//*Label 34826*/ GIMT_Encode4(2418991), // Rule ID 1678 //
     /* 2418968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2418971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2418975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2418979 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2418979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2418982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418990 */     // GIR_Coverage, 1678,
     /* 2418990 */     GIR_EraseRootFromParent_Done,
     /* 2418991 */   // Label 34826: @2418991
     /* 2418991 */   GIM_Reject,
     /* 2418992 */ // Label 34821: @2418992
     /* 2418992 */ GIM_Reject,
     /* 2418993 */ // Label 34795: @2418993
     /* 2418993 */ GIM_Try, /*On fail goto*//*Label 34827*/ GIMT_Encode4(2419102),
     /* 2418998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2419001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419009 */   GIM_Try, /*On fail goto*//*Label 34828*/ GIMT_Encode4(2419055), // Rule ID 56240 //
     /* 2419014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419017 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2419020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2419034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419054 */     // GIR_Coverage, 56240,
     /* 2419054 */     GIR_EraseRootFromParent_Done,
     /* 2419055 */   // Label 34828: @2419055
     /* 2419055 */   GIM_Try, /*On fail goto*//*Label 34829*/ GIMT_Encode4(2419101), // Rule ID 56241 //
     /* 2419060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419063 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2419066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2419080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419100 */     // GIR_Coverage, 56241,
     /* 2419100 */     GIR_EraseRootFromParent_Done,
     /* 2419101 */   // Label 34829: @2419101
     /* 2419101 */   GIM_Reject,
     /* 2419102 */ // Label 34827: @2419102
     /* 2419102 */ GIM_Reject,
     /* 2419103 */ // Label 34796: @2419103
     /* 2419103 */ GIM_Try, /*On fail goto*//*Label 34830*/ GIMT_Encode4(2419212),
     /* 2419108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2419111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419119 */   GIM_Try, /*On fail goto*//*Label 34831*/ GIMT_Encode4(2419165), // Rule ID 56280 //
     /* 2419124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2419127 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2419130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2419144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419164 */     // GIR_Coverage, 56280,
     /* 2419164 */     GIR_EraseRootFromParent_Done,
     /* 2419165 */   // Label 34831: @2419165
     /* 2419165 */   GIM_Try, /*On fail goto*//*Label 34832*/ GIMT_Encode4(2419211), // Rule ID 56281 //
     /* 2419170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2419173 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2419176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2419190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419210 */     // GIR_Coverage, 56281,
     /* 2419210 */     GIR_EraseRootFromParent_Done,
     /* 2419211 */   // Label 34832: @2419211
     /* 2419211 */   GIM_Reject,
     /* 2419212 */ // Label 34830: @2419212
     /* 2419212 */ GIM_Reject,
     /* 2419213 */ // Label 34797: @2419213
     /* 2419213 */ GIM_Try, /*On fail goto*//*Label 34833*/ GIMT_Encode4(2419322),
     /* 2419218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2419221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419229 */   GIM_Try, /*On fail goto*//*Label 34834*/ GIMT_Encode4(2419275), // Rule ID 56340 //
     /* 2419234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2419237 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2419240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2419254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419274 */     // GIR_Coverage, 56340,
     /* 2419274 */     GIR_EraseRootFromParent_Done,
     /* 2419275 */   // Label 34834: @2419275
     /* 2419275 */   GIM_Try, /*On fail goto*//*Label 34835*/ GIMT_Encode4(2419321), // Rule ID 56341 //
     /* 2419280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419283 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2419286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2419300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419320 */     // GIR_Coverage, 56341,
     /* 2419320 */     GIR_EraseRootFromParent_Done,
     /* 2419321 */   // Label 34835: @2419321
     /* 2419321 */   GIM_Reject,
     /* 2419322 */ // Label 34833: @2419322
     /* 2419322 */ GIM_Reject,
     /* 2419323 */ // Label 34798: @2419323
     /* 2419323 */ GIM_Try, /*On fail goto*//*Label 34836*/ GIMT_Encode4(2419432),
     /* 2419328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2419331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419339 */   GIM_Try, /*On fail goto*//*Label 34837*/ GIMT_Encode4(2419385), // Rule ID 56260 //
     /* 2419344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419347 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2419350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2419364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419384 */     // GIR_Coverage, 56260,
     /* 2419384 */     GIR_EraseRootFromParent_Done,
     /* 2419385 */   // Label 34837: @2419385
     /* 2419385 */   GIM_Try, /*On fail goto*//*Label 34838*/ GIMT_Encode4(2419431), // Rule ID 56261 //
     /* 2419390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419393 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2419396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2419410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419430 */     // GIR_Coverage, 56261,
     /* 2419430 */     GIR_EraseRootFromParent_Done,
     /* 2419431 */   // Label 34838: @2419431
     /* 2419431 */   GIM_Reject,
     /* 2419432 */ // Label 34836: @2419432
     /* 2419432 */ GIM_Reject,
     /* 2419433 */ // Label 34799: @2419433
     /* 2419433 */ GIM_Try, /*On fail goto*//*Label 34839*/ GIMT_Encode4(2419542),
     /* 2419438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2419441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419449 */   GIM_Try, /*On fail goto*//*Label 34840*/ GIMT_Encode4(2419495), // Rule ID 56320 //
     /* 2419454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2419457 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2419460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2419474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419494 */     // GIR_Coverage, 56320,
     /* 2419494 */     GIR_EraseRootFromParent_Done,
     /* 2419495 */   // Label 34840: @2419495
     /* 2419495 */   GIM_Try, /*On fail goto*//*Label 34841*/ GIMT_Encode4(2419541), // Rule ID 56321 //
     /* 2419500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2419503 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2419506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2419520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419540 */     // GIR_Coverage, 56321,
     /* 2419540 */     GIR_EraseRootFromParent_Done,
     /* 2419541 */   // Label 34841: @2419541
     /* 2419541 */   GIM_Reject,
     /* 2419542 */ // Label 34839: @2419542
     /* 2419542 */ GIM_Reject,
     /* 2419543 */ // Label 34800: @2419543
     /* 2419543 */ GIM_Try, /*On fail goto*//*Label 34842*/ GIMT_Encode4(2419652),
     /* 2419548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2419551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419559 */   GIM_Try, /*On fail goto*//*Label 34843*/ GIMT_Encode4(2419605), // Rule ID 56480 //
     /* 2419564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2419567 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2419570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2419584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419604 */     // GIR_Coverage, 56480,
     /* 2419604 */     GIR_EraseRootFromParent_Done,
     /* 2419605 */   // Label 34843: @2419605
     /* 2419605 */   GIM_Try, /*On fail goto*//*Label 34844*/ GIMT_Encode4(2419651), // Rule ID 56481 //
     /* 2419610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419613 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2419616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2419630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419650 */     // GIR_Coverage, 56481,
     /* 2419650 */     GIR_EraseRootFromParent_Done,
     /* 2419651 */   // Label 34844: @2419651
     /* 2419651 */   GIM_Reject,
     /* 2419652 */ // Label 34842: @2419652
     /* 2419652 */ GIM_Reject,
     /* 2419653 */ // Label 34801: @2419653
     /* 2419653 */ GIM_Try, /*On fail goto*//*Label 34845*/ GIMT_Encode4(2419762),
     /* 2419658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2419661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419669 */   GIM_Try, /*On fail goto*//*Label 34846*/ GIMT_Encode4(2419715), // Rule ID 56300 //
     /* 2419674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419677 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2419680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2419694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419714 */     // GIR_Coverage, 56300,
     /* 2419714 */     GIR_EraseRootFromParent_Done,
     /* 2419715 */   // Label 34846: @2419715
     /* 2419715 */   GIM_Try, /*On fail goto*//*Label 34847*/ GIMT_Encode4(2419761), // Rule ID 56301 //
     /* 2419720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419723 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2419726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2419740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419760 */     // GIR_Coverage, 56301,
     /* 2419760 */     GIR_EraseRootFromParent_Done,
     /* 2419761 */   // Label 34847: @2419761
     /* 2419761 */   GIM_Reject,
     /* 2419762 */ // Label 34845: @2419762
     /* 2419762 */ GIM_Reject,
     /* 2419763 */ // Label 34802: @2419763
     /* 2419763 */ GIM_Try, /*On fail goto*//*Label 34848*/ GIMT_Encode4(2419872),
     /* 2419768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2419771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419779 */   GIM_Try, /*On fail goto*//*Label 34849*/ GIMT_Encode4(2419825), // Rule ID 56420 //
     /* 2419784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2419787 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2419790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2419804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419824 */     // GIR_Coverage, 56420,
     /* 2419824 */     GIR_EraseRootFromParent_Done,
     /* 2419825 */   // Label 34849: @2419825
     /* 2419825 */   GIM_Try, /*On fail goto*//*Label 34850*/ GIMT_Encode4(2419871), // Rule ID 56421 //
     /* 2419830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2419833 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2419836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2419850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419870 */     // GIR_Coverage, 56421,
     /* 2419870 */     GIR_EraseRootFromParent_Done,
     /* 2419871 */   // Label 34850: @2419871
     /* 2419871 */   GIM_Reject,
     /* 2419872 */ // Label 34848: @2419872
     /* 2419872 */ GIM_Reject,
     /* 2419873 */ // Label 34803: @2419873
     /* 2419873 */ GIM_Try, /*On fail goto*//*Label 34851*/ GIMT_Encode4(2419982),
     /* 2419878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419889 */   GIM_Try, /*On fail goto*//*Label 34852*/ GIMT_Encode4(2419935), // Rule ID 56500 //
     /* 2419894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2419897 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2419900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2419914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419934 */     // GIR_Coverage, 56500,
     /* 2419934 */     GIR_EraseRootFromParent_Done,
     /* 2419935 */   // Label 34852: @2419935
     /* 2419935 */   GIM_Try, /*On fail goto*//*Label 34853*/ GIMT_Encode4(2419981), // Rule ID 56501 //
     /* 2419940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419943 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2419946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2419960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419980 */     // GIR_Coverage, 56501,
     /* 2419980 */     GIR_EraseRootFromParent_Done,
     /* 2419981 */   // Label 34853: @2419981
     /* 2419981 */   GIM_Reject,
     /* 2419982 */ // Label 34851: @2419982
     /* 2419982 */ GIM_Reject,
     /* 2419983 */ // Label 34804: @2419983
     /* 2419983 */ GIM_Try, /*On fail goto*//*Label 34854*/ GIMT_Encode4(2420092),
     /* 2419988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419999 */   GIM_Try, /*On fail goto*//*Label 34855*/ GIMT_Encode4(2420045), // Rule ID 56360 //
     /* 2420004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2420007 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2420007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2420010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2420024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420044 */     // GIR_Coverage, 56360,
     /* 2420044 */     GIR_EraseRootFromParent_Done,
     /* 2420045 */   // Label 34855: @2420045
     /* 2420045 */   GIM_Try, /*On fail goto*//*Label 34856*/ GIMT_Encode4(2420091), // Rule ID 56361 //
     /* 2420050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2420053 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2420053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2420056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2420070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420090 */     // GIR_Coverage, 56361,
     /* 2420090 */     GIR_EraseRootFromParent_Done,
     /* 2420091 */   // Label 34856: @2420091
     /* 2420091 */   GIM_Reject,
     /* 2420092 */ // Label 34854: @2420092
     /* 2420092 */ GIM_Reject,
     /* 2420093 */ // Label 34805: @2420093
     /* 2420093 */ GIM_Try, /*On fail goto*//*Label 34857*/ GIMT_Encode4(2420202),
     /* 2420098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420109 */   GIM_Try, /*On fail goto*//*Label 34858*/ GIMT_Encode4(2420155), // Rule ID 56440 //
     /* 2420114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420117 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2420117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2420120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2420134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420154 */     // GIR_Coverage, 56440,
     /* 2420154 */     GIR_EraseRootFromParent_Done,
     /* 2420155 */   // Label 34858: @2420155
     /* 2420155 */   GIM_Try, /*On fail goto*//*Label 34859*/ GIMT_Encode4(2420201), // Rule ID 56441 //
     /* 2420160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420163 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2420163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2420166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2420180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420200 */     // GIR_Coverage, 56441,
     /* 2420200 */     GIR_EraseRootFromParent_Done,
     /* 2420201 */   // Label 34859: @2420201
     /* 2420201 */   GIM_Reject,
     /* 2420202 */ // Label 34857: @2420202
     /* 2420202 */ GIM_Reject,
     /* 2420203 */ // Label 34806: @2420203
     /* 2420203 */ GIM_Try, /*On fail goto*//*Label 34860*/ GIMT_Encode4(2420312),
     /* 2420208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2420211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420219 */   GIM_Try, /*On fail goto*//*Label 34861*/ GIMT_Encode4(2420265), // Rule ID 56520 //
     /* 2420224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2420227 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2420227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2420230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2420244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420264 */     // GIR_Coverage, 56520,
     /* 2420264 */     GIR_EraseRootFromParent_Done,
     /* 2420265 */   // Label 34861: @2420265
     /* 2420265 */   GIM_Try, /*On fail goto*//*Label 34862*/ GIMT_Encode4(2420311), // Rule ID 56521 //
     /* 2420270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2420273 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2420273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2420276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2420290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420310 */     // GIR_Coverage, 56521,
     /* 2420310 */     GIR_EraseRootFromParent_Done,
     /* 2420311 */   // Label 34862: @2420311
     /* 2420311 */   GIM_Reject,
     /* 2420312 */ // Label 34860: @2420312
     /* 2420312 */ GIM_Reject,
     /* 2420313 */ // Label 34807: @2420313
     /* 2420313 */ GIM_Try, /*On fail goto*//*Label 34863*/ GIMT_Encode4(2420422),
     /* 2420318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2420321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420329 */   GIM_Try, /*On fail goto*//*Label 34864*/ GIMT_Encode4(2420375), // Rule ID 56380 //
     /* 2420334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2420337 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2420337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2420340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2420354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420374 */     // GIR_Coverage, 56380,
     /* 2420374 */     GIR_EraseRootFromParent_Done,
     /* 2420375 */   // Label 34864: @2420375
     /* 2420375 */   GIM_Try, /*On fail goto*//*Label 34865*/ GIMT_Encode4(2420421), // Rule ID 56381 //
     /* 2420380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2420383 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2420383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2420386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2420400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420420 */     // GIR_Coverage, 56381,
     /* 2420420 */     GIR_EraseRootFromParent_Done,
     /* 2420421 */   // Label 34865: @2420421
     /* 2420421 */   GIM_Reject,
     /* 2420422 */ // Label 34863: @2420422
     /* 2420422 */ GIM_Reject,
     /* 2420423 */ // Label 34808: @2420423
     /* 2420423 */ GIM_Try, /*On fail goto*//*Label 34866*/ GIMT_Encode4(2420532),
     /* 2420428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2420431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420439 */   GIM_Try, /*On fail goto*//*Label 34867*/ GIMT_Encode4(2420485), // Rule ID 56460 //
     /* 2420444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420447 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2420447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2420450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2420464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420484 */     // GIR_Coverage, 56460,
     /* 2420484 */     GIR_EraseRootFromParent_Done,
     /* 2420485 */   // Label 34867: @2420485
     /* 2420485 */   GIM_Try, /*On fail goto*//*Label 34868*/ GIMT_Encode4(2420531), // Rule ID 56461 //
     /* 2420490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420493 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2420493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2420496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2420510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420530 */     // GIR_Coverage, 56461,
     /* 2420530 */     GIR_EraseRootFromParent_Done,
     /* 2420531 */   // Label 34868: @2420531
     /* 2420531 */   GIM_Reject,
     /* 2420532 */ // Label 34866: @2420532
     /* 2420532 */ GIM_Reject,
     /* 2420533 */ // Label 34809: @2420533
     /* 2420533 */ GIM_Try, /*On fail goto*//*Label 34869*/ GIMT_Encode4(2420642),
     /* 2420538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2420541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420549 */   GIM_Try, /*On fail goto*//*Label 34870*/ GIMT_Encode4(2420595), // Rule ID 56400 //
     /* 2420554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2420557 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2420557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2420560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2420574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420594 */     // GIR_Coverage, 56400,
     /* 2420594 */     GIR_EraseRootFromParent_Done,
     /* 2420595 */   // Label 34870: @2420595
     /* 2420595 */   GIM_Try, /*On fail goto*//*Label 34871*/ GIMT_Encode4(2420641), // Rule ID 56401 //
     /* 2420600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2420603 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2420603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2420606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2420620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420640 */     // GIR_Coverage, 56401,
     /* 2420640 */     GIR_EraseRootFromParent_Done,
     /* 2420641 */   // Label 34871: @2420641
     /* 2420641 */   GIM_Reject,
     /* 2420642 */ // Label 34869: @2420642
     /* 2420642 */ GIM_Reject,
     /* 2420643 */ // Label 34810: @2420643
     /* 2420643 */ GIM_Reject,
     /* 2420644 */ // Label 104: @2420644
     /* 2420644 */ GIM_Try, /*On fail goto*//*Label 34872*/ GIMT_Encode4(2420656), // Rule ID 293 //
     /* 2420649 */   // (trap)  =>  (UNIMP)
     /* 2420649 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::UNIMP),
     /* 2420654 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420655 */   // GIR_Coverage, 293,
     /* 2420655 */   GIR_Done,
     /* 2420656 */ // Label 34872: @2420656
     /* 2420656 */ GIM_Reject,
     /* 2420657 */ // Label 105: @2420657
     /* 2420657 */ GIM_Try, /*On fail goto*//*Label 34873*/ GIMT_Encode4(2420669), // Rule ID 294 //
     /* 2420662 */   // (debugtrap)  =>  (EBREAK)
     /* 2420662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::EBREAK),
     /* 2420667 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420668 */   // GIR_Coverage, 294,
     /* 2420668 */   GIR_Done,
     /* 2420669 */ // Label 34873: @2420669
     /* 2420669 */ GIM_Reject,
     /* 2420670 */ // Label 106: @2420670
     /* 2420670 */ GIM_Try, /*On fail goto*//*Label 34874*/ GIMT_Encode4(2420764),
     /* 2420675 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2420678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420685 */   GIM_Try, /*On fail goto*//*Label 34875*/ GIMT_Encode4(2420704), // Rule ID 2522 //
     /* 2420690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2420693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420697 */     // (riscv_clzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2420697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZW),
     /* 2420702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420703 */     // GIR_Coverage, 2522,
     /* 2420703 */     GIR_Done,
     /* 2420704 */   // Label 34875: @2420704
     /* 2420704 */   GIM_Try, /*On fail goto*//*Label 34876*/ GIMT_Encode4(2420763), // Rule ID 62575 //
     /* 2420709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2420712 */     // (riscv_clzw:{ *:[i64] } i64:{ *:[i64] }:$rs1)  =>  (TH_FF0:{ *:[i64] } (SLLI:{ *:[i64] } (XORI:{ *:[i64] } i64:{ *:[i64] }:$rs1, -1:{ *:[i64] }), 32:{ *:[i64] }))
     /* 2420712 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 2420715 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2420719 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420724 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /* 2420728 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/uint8_t(-1),
     /* 2420731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 2420733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2420736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2420740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420745 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2420748 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2420751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2420756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420762 */     // GIR_Coverage, 62575,
     /* 2420762 */     GIR_EraseRootFromParent_Done,
     /* 2420763 */   // Label 34876: @2420763
     /* 2420763 */   GIM_Reject,
     /* 2420764 */ // Label 34874: @2420764
     /* 2420764 */ GIM_Reject,
     /* 2420765 */ // Label 107: @2420765
     /* 2420765 */ GIM_Try, /*On fail goto*//*Label 34877*/ GIMT_Encode4(2420794), // Rule ID 2523 //
     /* 2420770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2420773 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2420776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420787 */   // (riscv_ctzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2420787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZW),
     /* 2420792 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420793 */   // GIR_Coverage, 2523,
     /* 2420793 */   GIR_Done,
     /* 2420794 */ // Label 34877: @2420794
     /* 2420794 */ GIM_Reject,
     /* 2420795 */ // Label 108: @2420795
     /* 2420795 */ GIM_Try, /*On fail goto*//*Label 34878*/ GIMT_Encode4(2420831), // Rule ID 319 //
     /* 2420800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2420803 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2420806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2420812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420824 */   // (riscv_divuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2420824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVUW),
     /* 2420829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420830 */   // GIR_Coverage, 319,
     /* 2420830 */   GIR_Done,
     /* 2420831 */ // Label 34878: @2420831
     /* 2420831 */ GIM_Reject,
     /* 2420832 */ // Label 109: @2420832
     /* 2420832 */ GIM_Try, /*On fail goto*//*Label 34879*/ GIMT_Encode4(2420868), // Rule ID 318 //
     /* 2420837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2420840 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2420843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2420849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420861 */   // (riscv_divw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2420861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVW),
     /* 2420866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420867 */   // GIR_Coverage, 318,
     /* 2420867 */   GIR_Done,
     /* 2420868 */ // Label 34879: @2420868
     /* 2420868 */ GIM_Reject,
     /* 2420869 */ // Label 110: @2420869
     /* 2420869 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34882*/ GIMT_Encode4(2421228),
     /* 2420880 */ /*GILLT_s32*//*Label 34880*/ GIMT_Encode4(2420888),
     /* 2420884 */ /*GILLT_s64*//*Label 34881*/ GIMT_Encode4(2421045),
     /* 2420888 */ // Label 34880: @2420888
     /* 2420888 */ GIM_Try, /*On fail goto*//*Label 34883*/ GIMT_Encode4(2420914), // Rule ID 1286 //
     /* 2420893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2420896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2420899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2420907 */   // (riscv_fclass:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2420907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2420912 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420913 */   // GIR_Coverage, 1286,
     /* 2420913 */   GIR_Done,
     /* 2420914 */ // Label 34883: @2420914
     /* 2420914 */ GIM_Try, /*On fail goto*//*Label 34884*/ GIMT_Encode4(2420940), // Rule ID 1294 //
     /* 2420919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2420922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2420925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2420933 */   // (riscv_fclass:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2420933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2420938 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420939 */   // GIR_Coverage, 1294,
     /* 2420939 */   GIR_Done,
     /* 2420940 */ // Label 34884: @2420940
     /* 2420940 */ GIM_Try, /*On fail goto*//*Label 34885*/ GIMT_Encode4(2420966), // Rule ID 1629 //
     /* 2420945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2420948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2420959 */   // (riscv_fclass:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2420959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2420964 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420965 */   // GIR_Coverage, 1629,
     /* 2420965 */   GIR_Done,
     /* 2420966 */ // Label 34885: @2420966
     /* 2420966 */ GIM_Try, /*On fail goto*//*Label 34886*/ GIMT_Encode4(2420992), // Rule ID 1684 //
     /* 2420971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2420974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2420985 */   // (riscv_fclass:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2420985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2420990 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420991 */   // GIR_Coverage, 1684,
     /* 2420991 */   GIR_Done,
     /* 2420992 */ // Label 34886: @2420992
     /* 2420992 */ GIM_Try, /*On fail goto*//*Label 34887*/ GIMT_Encode4(2421018), // Rule ID 1995 //
     /* 2420997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2421000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2421003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2421011 */   // (riscv_fclass:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2421011 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2421016 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421017 */   // GIR_Coverage, 1995,
     /* 2421017 */   GIR_Done,
     /* 2421018 */ // Label 34887: @2421018
     /* 2421018 */ GIM_Try, /*On fail goto*//*Label 34888*/ GIMT_Encode4(2421044), // Rule ID 2028 //
     /* 2421023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2421026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2421029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2421037 */   // (riscv_fclass:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2421037 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2421042 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421043 */   // GIR_Coverage, 2028,
     /* 2421043 */   GIR_Done,
     /* 2421044 */ // Label 34888: @2421044
     /* 2421044 */ GIM_Reject,
     /* 2421045 */ // Label 34881: @2421045
     /* 2421045 */ GIM_Try, /*On fail goto*//*Label 34889*/ GIMT_Encode4(2421071), // Rule ID 1285 //
     /* 2421050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2421053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2421056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2421064 */   // (riscv_fclass:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2421064 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2421069 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421070 */   // GIR_Coverage, 1285,
     /* 2421070 */   GIR_Done,
     /* 2421071 */ // Label 34889: @2421071
     /* 2421071 */ GIM_Try, /*On fail goto*//*Label 34890*/ GIMT_Encode4(2421097), // Rule ID 1293 //
     /* 2421076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2421079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2421082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2421090 */   // (riscv_fclass:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2421090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2421095 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421096 */   // GIR_Coverage, 1293,
     /* 2421096 */   GIR_Done,
     /* 2421097 */ // Label 34890: @2421097
     /* 2421097 */ GIM_Try, /*On fail goto*//*Label 34891*/ GIMT_Encode4(2421123), // Rule ID 1628 //
     /* 2421102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2421105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2421116 */   // (riscv_fclass:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2421116 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2421121 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421122 */   // GIR_Coverage, 1628,
     /* 2421122 */   GIR_Done,
     /* 2421123 */ // Label 34891: @2421123
     /* 2421123 */ GIM_Try, /*On fail goto*//*Label 34892*/ GIMT_Encode4(2421149), // Rule ID 1661 //
     /* 2421128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2421131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421142 */   // (riscv_fclass:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCLASS_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2421142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_INX),
     /* 2421147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421148 */   // GIR_Coverage, 1661,
     /* 2421148 */   GIR_Done,
     /* 2421149 */ // Label 34892: @2421149
     /* 2421149 */ GIM_Try, /*On fail goto*//*Label 34893*/ GIMT_Encode4(2421175), // Rule ID 1683 //
     /* 2421154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2421157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2421168 */   // (riscv_fclass:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2421168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2421173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421174 */   // GIR_Coverage, 1683,
     /* 2421174 */   GIR_Done,
     /* 2421175 */ // Label 34893: @2421175
     /* 2421175 */ GIM_Try, /*On fail goto*//*Label 34894*/ GIMT_Encode4(2421201), // Rule ID 1994 //
     /* 2421180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2421183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2421186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2421194 */   // (riscv_fclass:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2421194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2421199 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421200 */   // GIR_Coverage, 1994,
     /* 2421200 */   GIR_Done,
     /* 2421201 */ // Label 34894: @2421201
     /* 2421201 */ GIM_Try, /*On fail goto*//*Label 34895*/ GIMT_Encode4(2421227), // Rule ID 2027 //
     /* 2421206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2421209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2421212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2421220 */   // (riscv_fclass:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2421220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2421225 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421226 */   // GIR_Coverage, 2027,
     /* 2421226 */   GIR_Done,
     /* 2421227 */ // Label 34895: @2421227
     /* 2421227 */ GIM_Reject,
     /* 2421228 */ // Label 34882: @2421228
     /* 2421228 */ GIM_Reject,
     /* 2421229 */ // Label 111: @2421229
     /* 2421229 */ GIM_Try, /*On fail goto*//*Label 34896*/ GIMT_Encode4(2421426),
     /* 2421234 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2421237 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34900*/ GIMT_Encode4(2421425),
     /* 2421248 */   /*GILLT_s16*//*Label 34897*/ GIMT_Encode4(2421260),
     /* 2421252 */   /*GILLT_s32*//*Label 34898*/ GIMT_Encode4(2421315),
     /* 2421256 */   /*GILLT_s64*//*Label 34899*/ GIMT_Encode4(2421370),
     /* 2421260 */   // Label 34897: @2421260
     /* 2421260 */   GIM_Try, /*On fail goto*//*Label 34901*/ GIMT_Encode4(2421314),
     /* 2421265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421269 */     GIM_Try, /*On fail goto*//*Label 34902*/ GIMT_Encode4(2421291), // Rule ID 2245 //
     /* 2421274 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2421277 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2421281 */       // MIs[0] frm
     /* 2421281 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421284 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421284 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2421289 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421290 */       // GIR_Coverage, 2245,
     /* 2421290 */       GIR_Done,
     /* 2421291 */     // Label 34902: @2421291
     /* 2421291 */     GIM_Try, /*On fail goto*//*Label 34903*/ GIMT_Encode4(2421313), // Rule ID 2271 //
     /* 2421296 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2421299 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2421303 */       // MIs[0] frm
     /* 2421303 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421306 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421306 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2421311 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421312 */       // GIR_Coverage, 2271,
     /* 2421312 */       GIR_Done,
     /* 2421313 */     // Label 34903: @2421313
     /* 2421313 */     GIM_Reject,
     /* 2421314 */   // Label 34901: @2421314
     /* 2421314 */   GIM_Reject,
     /* 2421315 */   // Label 34898: @2421315
     /* 2421315 */   GIM_Try, /*On fail goto*//*Label 34904*/ GIMT_Encode4(2421369),
     /* 2421320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421324 */     GIM_Try, /*On fail goto*//*Label 34905*/ GIMT_Encode4(2421346), // Rule ID 1511 //
     /* 2421329 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2421332 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2421336 */       // MIs[0] frm
     /* 2421336 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421339 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421339 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2421344 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421345 */       // GIR_Coverage, 1511,
     /* 2421345 */       GIR_Done,
     /* 2421346 */     // Label 34905: @2421346
     /* 2421346 */     GIM_Try, /*On fail goto*//*Label 34906*/ GIMT_Encode4(2421368), // Rule ID 1539 //
     /* 2421351 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2421354 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2421358 */       // MIs[0] frm
     /* 2421358 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421361 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421361 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2421366 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421367 */       // GIR_Coverage, 1539,
     /* 2421367 */       GIR_Done,
     /* 2421368 */     // Label 34906: @2421368
     /* 2421368 */     GIM_Reject,
     /* 2421369 */   // Label 34904: @2421369
     /* 2421369 */   GIM_Reject,
     /* 2421370 */   // Label 34899: @2421370
     /* 2421370 */   GIM_Try, /*On fail goto*//*Label 34907*/ GIMT_Encode4(2421424),
     /* 2421375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421379 */     GIM_Try, /*On fail goto*//*Label 34908*/ GIMT_Encode4(2421401), // Rule ID 1905 //
     /* 2421384 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2421387 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2421391 */       // MIs[0] frm
     /* 2421391 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421394 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421394 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2421399 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421400 */       // GIR_Coverage, 1905,
     /* 2421400 */       GIR_Done,
     /* 2421401 */     // Label 34908: @2421401
     /* 2421401 */     GIM_Try, /*On fail goto*//*Label 34909*/ GIMT_Encode4(2421423), // Rule ID 1933 //
     /* 2421406 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2421409 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421413 */       // MIs[0] frm
     /* 2421413 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421416 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421416 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_INX),
     /* 2421421 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421422 */       // GIR_Coverage, 1933,
     /* 2421422 */       GIR_Done,
     /* 2421423 */     // Label 34909: @2421423
     /* 2421423 */     GIM_Reject,
     /* 2421424 */   // Label 34907: @2421424
     /* 2421424 */   GIM_Reject,
     /* 2421425 */   // Label 34900: @2421425
     /* 2421425 */   GIM_Reject,
     /* 2421426 */ // Label 34896: @2421426
     /* 2421426 */ GIM_Reject,
     /* 2421427 */ // Label 112: @2421427
     /* 2421427 */ GIM_Try, /*On fail goto*//*Label 34910*/ GIMT_Encode4(2421624),
     /* 2421432 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2421435 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34914*/ GIMT_Encode4(2421623),
     /* 2421446 */   /*GILLT_s16*//*Label 34911*/ GIMT_Encode4(2421458),
     /* 2421450 */   /*GILLT_s32*//*Label 34912*/ GIMT_Encode4(2421513),
     /* 2421454 */   /*GILLT_s64*//*Label 34913*/ GIMT_Encode4(2421568),
     /* 2421458 */   // Label 34911: @2421458
     /* 2421458 */   GIM_Try, /*On fail goto*//*Label 34915*/ GIMT_Encode4(2421512),
     /* 2421463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421467 */     GIM_Try, /*On fail goto*//*Label 34916*/ GIMT_Encode4(2421489), // Rule ID 2243 //
     /* 2421472 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2421475 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2421479 */       // MIs[0] frm
     /* 2421479 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421482 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421482 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2421487 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421488 */       // GIR_Coverage, 2243,
     /* 2421488 */       GIR_Done,
     /* 2421489 */     // Label 34916: @2421489
     /* 2421489 */     GIM_Try, /*On fail goto*//*Label 34917*/ GIMT_Encode4(2421511), // Rule ID 2269 //
     /* 2421494 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2421497 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2421501 */       // MIs[0] frm
     /* 2421501 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421504 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421504 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2421509 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421510 */       // GIR_Coverage, 2269,
     /* 2421510 */       GIR_Done,
     /* 2421511 */     // Label 34917: @2421511
     /* 2421511 */     GIM_Reject,
     /* 2421512 */   // Label 34915: @2421512
     /* 2421512 */   GIM_Reject,
     /* 2421513 */   // Label 34912: @2421513
     /* 2421513 */   GIM_Try, /*On fail goto*//*Label 34918*/ GIMT_Encode4(2421567),
     /* 2421518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421522 */     GIM_Try, /*On fail goto*//*Label 34919*/ GIMT_Encode4(2421544), // Rule ID 1509 //
     /* 2421527 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2421530 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2421534 */       // MIs[0] frm
     /* 2421534 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421537 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421537 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2421542 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421543 */       // GIR_Coverage, 1509,
     /* 2421543 */       GIR_Done,
     /* 2421544 */     // Label 34919: @2421544
     /* 2421544 */     GIM_Try, /*On fail goto*//*Label 34920*/ GIMT_Encode4(2421566), // Rule ID 1537 //
     /* 2421549 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2421552 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2421556 */       // MIs[0] frm
     /* 2421556 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421559 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421559 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2421564 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421565 */       // GIR_Coverage, 1537,
     /* 2421565 */       GIR_Done,
     /* 2421566 */     // Label 34920: @2421566
     /* 2421566 */     GIM_Reject,
     /* 2421567 */   // Label 34918: @2421567
     /* 2421567 */   GIM_Reject,
     /* 2421568 */   // Label 34913: @2421568
     /* 2421568 */   GIM_Try, /*On fail goto*//*Label 34921*/ GIMT_Encode4(2421622),
     /* 2421573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421577 */     GIM_Try, /*On fail goto*//*Label 34922*/ GIMT_Encode4(2421599), // Rule ID 1903 //
     /* 2421582 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2421585 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2421589 */       // MIs[0] frm
     /* 2421589 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421592 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421592 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2421597 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421598 */       // GIR_Coverage, 1903,
     /* 2421598 */       GIR_Done,
     /* 2421599 */     // Label 34922: @2421599
     /* 2421599 */     GIM_Try, /*On fail goto*//*Label 34923*/ GIMT_Encode4(2421621), // Rule ID 1931 //
     /* 2421604 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2421607 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421611 */       // MIs[0] frm
     /* 2421611 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421614 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421614 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_INX),
     /* 2421619 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421620 */       // GIR_Coverage, 1931,
     /* 2421620 */       GIR_Done,
     /* 2421621 */     // Label 34923: @2421621
     /* 2421621 */     GIM_Reject,
     /* 2421622 */   // Label 34921: @2421622
     /* 2421622 */   GIM_Reject,
     /* 2421623 */   // Label 34914: @2421623
     /* 2421623 */   GIM_Reject,
     /* 2421624 */ // Label 34910: @2421624
     /* 2421624 */ GIM_Reject,
     /* 2421625 */ // Label 113: @2421625
     /* 2421625 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34926*/ GIMT_Encode4(2421684),
     /* 2421636 */ /*GILLT_s32*//*Label 34924*/ GIMT_Encode4(2421644),
     /* 2421640 */ /*GILLT_s64*//*Label 34925*/ GIMT_Encode4(2421664),
     /* 2421644 */ // Label 34924: @2421644
     /* 2421644 */ GIM_Try, /*On fail goto*//*Label 34927*/ GIMT_Encode4(2421663), // Rule ID 73 //
     /* 2421649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421656 */   // (riscv_read_vlenb:{ *:[i32] })  =>  (PseudoReadVLENB:{ *:[i32] })
     /* 2421656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2421661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421662 */   // GIR_Coverage, 73,
     /* 2421662 */   GIR_Done,
     /* 2421663 */ // Label 34927: @2421663
     /* 2421663 */ GIM_Reject,
     /* 2421664 */ // Label 34925: @2421664
     /* 2421664 */ GIM_Try, /*On fail goto*//*Label 34928*/ GIMT_Encode4(2421683), // Rule ID 72 //
     /* 2421669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421676 */   // (riscv_read_vlenb:{ *:[i64] })  =>  (PseudoReadVLENB:{ *:[i64] })
     /* 2421676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2421681 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421682 */   // GIR_Coverage, 72,
     /* 2421682 */   GIR_Done,
     /* 2421683 */ // Label 34928: @2421683
     /* 2421683 */ GIM_Reject,
     /* 2421684 */ // Label 34926: @2421684
     /* 2421684 */ GIM_Reject,
     /* 2421685 */ // Label 114: @2421685
     /* 2421685 */ GIM_Try, /*On fail goto*//*Label 34929*/ GIMT_Encode4(2421721), // Rule ID 320 //
     /* 2421690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2421693 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2421696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2421702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421714 */   // (riscv_remuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2421714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMUW),
     /* 2421719 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421720 */   // GIR_Coverage, 320,
     /* 2421720 */   GIR_Done,
     /* 2421721 */ // Label 34929: @2421721
     /* 2421721 */ GIM_Reject,
     /* 2421722 */ // Label 115: @2421722
     /* 2421722 */ GIM_Try, /*On fail goto*//*Label 34930*/ GIMT_Encode4(2421846),
     /* 2421727 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2421730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2421736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421744 */   GIM_Try, /*On fail goto*//*Label 34931*/ GIMT_Encode4(2421780), // Rule ID 2471 //
     /* 2421749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2421752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421764 */     // MIs[1] Operand 1
     /* 2421764 */     // No operand predicates
     /* 2421764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421766 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2421766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2421769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421773 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2421778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421779 */     // GIR_Coverage, 2471,
     /* 2421779 */     GIR_EraseRootFromParent_Done,
     /* 2421780 */   // Label 34931: @2421780
     /* 2421780 */   GIM_Try, /*On fail goto*//*Label 34932*/ GIMT_Encode4(2421816), // Rule ID 62572 //
     /* 2421785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2421788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421800 */     // MIs[1] Operand 1
     /* 2421800 */     // No operand predicates
     /* 2421800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421802 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2421802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2421805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421809 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2421814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421815 */     // GIR_Coverage, 62572,
     /* 2421815 */     GIR_EraseRootFromParent_Done,
     /* 2421816 */   // Label 34932: @2421816
     /* 2421816 */   GIM_Try, /*On fail goto*//*Label 34933*/ GIMT_Encode4(2421845), // Rule ID 2468 //
     /* 2421821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2421824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2421831 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2421831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROLW),
     /* 2421834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2421843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421844 */     // GIR_Coverage, 2468,
     /* 2421844 */     GIR_EraseRootFromParent_Done,
     /* 2421845 */   // Label 34933: @2421845
     /* 2421845 */   GIM_Reject,
     /* 2421846 */ // Label 34930: @2421846
     /* 2421846 */ GIM_Reject,
     /* 2421847 */ // Label 116: @2421847
     /* 2421847 */ GIM_Try, /*On fail goto*//*Label 34934*/ GIMT_Encode4(2421967),
     /* 2421852 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2421855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2421861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421869 */   GIM_Try, /*On fail goto*//*Label 34935*/ GIMT_Encode4(2421903), // Rule ID 2470 //
     /* 2421874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2421877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421889 */     // MIs[1] Operand 1
     /* 2421889 */     // No operand predicates
     /* 2421889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421891 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2421891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2421894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2421901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421902 */     // GIR_Coverage, 2470,
     /* 2421902 */     GIR_EraseRootFromParent_Done,
     /* 2421903 */   // Label 34935: @2421903
     /* 2421903 */   GIM_Try, /*On fail goto*//*Label 34936*/ GIMT_Encode4(2421937), // Rule ID 62571 //
     /* 2421908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2421911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421923 */     // MIs[1] Operand 1
     /* 2421923 */     // No operand predicates
     /* 2421923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421925 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2421925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2421928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2421935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421936 */     // GIR_Coverage, 62571,
     /* 2421936 */     GIR_EraseRootFromParent_Done,
     /* 2421937 */   // Label 34936: @2421937
     /* 2421937 */   GIM_Try, /*On fail goto*//*Label 34937*/ GIMT_Encode4(2421966), // Rule ID 2469 //
     /* 2421942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2421945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2421952 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (RORW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2421952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORW),
     /* 2421955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2421964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421965 */     // GIR_Coverage, 2469,
     /* 2421965 */     GIR_EraseRootFromParent_Done,
     /* 2421966 */   // Label 34937: @2421966
     /* 2421966 */   GIM_Reject,
     /* 2421967 */ // Label 34934: @2421967
     /* 2421967 */ GIM_Reject,
     /* 2421968 */ // Label 117: @2421968
     /* 2421968 */ GIM_Try, /*On fail goto*//*Label 34938*/ GIMT_Encode4(2422014), // Rule ID 271 //
     /* 2421973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2421976 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2421979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2421985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421993 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2422000 */   // (riscv_sllw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2422000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLW),
     /* 2422003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422005 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2422007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2422012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422013 */   // GIR_Coverage, 271,
     /* 2422013 */   GIR_EraseRootFromParent_Done,
     /* 2422014 */ // Label 34938: @2422014
     /* 2422014 */ GIM_Reject,
     /* 2422015 */ // Label 118: @2422015
     /* 2422015 */ GIM_Try, /*On fail goto*//*Label 34939*/ GIMT_Encode4(2422061), // Rule ID 273 //
     /* 2422020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2422023 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2422026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2422032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422040 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2422047 */   // (riscv_sraw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRAW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2422047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAW),
     /* 2422050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422052 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2422054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2422059 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422060 */   // GIR_Coverage, 273,
     /* 2422060 */   GIR_EraseRootFromParent_Done,
     /* 2422061 */ // Label 34939: @2422061
     /* 2422061 */ GIM_Reject,
     /* 2422062 */ // Label 119: @2422062
     /* 2422062 */ GIM_Try, /*On fail goto*//*Label 34940*/ GIMT_Encode4(2422108), // Rule ID 272 //
     /* 2422067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2422070 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2422073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2422079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422087 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2422094 */   // (riscv_srlw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2422094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLW),
     /* 2422097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422099 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2422101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2422106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422107 */   // GIR_Coverage, 272,
     /* 2422107 */   GIR_EraseRootFromParent_Done,
     /* 2422108 */ // Label 34940: @2422108
     /* 2422108 */ GIM_Reject,
     /* 2422109 */ // Label 120: @2422109
     /* 2422109 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 34948*/ GIMT_Encode4(2422757),
     /* 2422120 */ /*GILLT_nxv1s1*//*Label 34941*/ GIMT_Encode4(2422232), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422140 */ /*GILLT_nxv2s1*//*Label 34942*/ GIMT_Encode4(2422307), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422160 */ /*GILLT_nxv4s1*//*Label 34943*/ GIMT_Encode4(2422382), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422180 */ /*GILLT_nxv8s1*//*Label 34944*/ GIMT_Encode4(2422457), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422200 */ /*GILLT_nxv16s1*//*Label 34945*/ GIMT_Encode4(2422532), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422216 */ /*GILLT_nxv32s1*//*Label 34946*/ GIMT_Encode4(2422607), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422228 */ /*GILLT_nxv64s1*//*Label 34947*/ GIMT_Encode4(2422682),
     /* 2422232 */ // Label 34941: @2422232
     /* 2422232 */ GIM_Try, /*On fail goto*//*Label 34949*/ GIMT_Encode4(2422269), // Rule ID 44718 //
     /* 2422237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422247 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422254 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2422257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422267 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422268 */   // GIR_Coverage, 44718,
     /* 2422268 */   GIR_EraseRootFromParent_Done,
     /* 2422269 */ // Label 34949: @2422269
     /* 2422269 */ GIM_Try, /*On fail goto*//*Label 34950*/ GIMT_Encode4(2422306), // Rule ID 44719 //
     /* 2422274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422284 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422291 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2422294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422304 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422305 */   // GIR_Coverage, 44719,
     /* 2422305 */   GIR_EraseRootFromParent_Done,
     /* 2422306 */ // Label 34950: @2422306
     /* 2422306 */ GIM_Reject,
     /* 2422307 */ // Label 34942: @2422307
     /* 2422307 */ GIM_Try, /*On fail goto*//*Label 34951*/ GIMT_Encode4(2422344), // Rule ID 44746 //
     /* 2422312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422322 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422329 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2422332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422342 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422343 */   // GIR_Coverage, 44746,
     /* 2422343 */   GIR_EraseRootFromParent_Done,
     /* 2422344 */ // Label 34951: @2422344
     /* 2422344 */ GIM_Try, /*On fail goto*//*Label 34952*/ GIMT_Encode4(2422381), // Rule ID 44747 //
     /* 2422349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422359 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422366 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2422369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422379 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422380 */   // GIR_Coverage, 44747,
     /* 2422380 */   GIR_EraseRootFromParent_Done,
     /* 2422381 */ // Label 34952: @2422381
     /* 2422381 */ GIM_Reject,
     /* 2422382 */ // Label 34943: @2422382
     /* 2422382 */ GIM_Try, /*On fail goto*//*Label 34953*/ GIMT_Encode4(2422419), // Rule ID 44774 //
     /* 2422387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422397 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422404 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2422407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422417 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422418 */   // GIR_Coverage, 44774,
     /* 2422418 */   GIR_EraseRootFromParent_Done,
     /* 2422419 */ // Label 34953: @2422419
     /* 2422419 */ GIM_Try, /*On fail goto*//*Label 34954*/ GIMT_Encode4(2422456), // Rule ID 44775 //
     /* 2422424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422434 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422441 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2422444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422454 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422455 */   // GIR_Coverage, 44775,
     /* 2422455 */   GIR_EraseRootFromParent_Done,
     /* 2422456 */ // Label 34954: @2422456
     /* 2422456 */ GIM_Reject,
     /* 2422457 */ // Label 34944: @2422457
     /* 2422457 */ GIM_Try, /*On fail goto*//*Label 34955*/ GIMT_Encode4(2422494), // Rule ID 44802 //
     /* 2422462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422479 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2422482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422493 */   // GIR_Coverage, 44802,
     /* 2422493 */   GIR_EraseRootFromParent_Done,
     /* 2422494 */ // Label 34955: @2422494
     /* 2422494 */ GIM_Try, /*On fail goto*//*Label 34956*/ GIMT_Encode4(2422531), // Rule ID 44803 //
     /* 2422499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422509 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422516 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2422519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422529 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422530 */   // GIR_Coverage, 44803,
     /* 2422530 */   GIR_EraseRootFromParent_Done,
     /* 2422531 */ // Label 34956: @2422531
     /* 2422531 */ GIM_Reject,
     /* 2422532 */ // Label 34945: @2422532
     /* 2422532 */ GIM_Try, /*On fail goto*//*Label 34957*/ GIMT_Encode4(2422569), // Rule ID 44830 //
     /* 2422537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422547 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422554 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2422557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422567 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422568 */   // GIR_Coverage, 44830,
     /* 2422568 */   GIR_EraseRootFromParent_Done,
     /* 2422569 */ // Label 34957: @2422569
     /* 2422569 */ GIM_Try, /*On fail goto*//*Label 34958*/ GIMT_Encode4(2422606), // Rule ID 44831 //
     /* 2422574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422584 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422591 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2422594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422604 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422605 */   // GIR_Coverage, 44831,
     /* 2422605 */   GIR_EraseRootFromParent_Done,
     /* 2422606 */ // Label 34958: @2422606
     /* 2422606 */ GIM_Reject,
     /* 2422607 */ // Label 34946: @2422607
     /* 2422607 */ GIM_Try, /*On fail goto*//*Label 34959*/ GIMT_Encode4(2422644), // Rule ID 44858 //
     /* 2422612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422629 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2422632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422642 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422643 */   // GIR_Coverage, 44858,
     /* 2422643 */   GIR_EraseRootFromParent_Done,
     /* 2422644 */ // Label 34959: @2422644
     /* 2422644 */ GIM_Try, /*On fail goto*//*Label 34960*/ GIMT_Encode4(2422681), // Rule ID 44859 //
     /* 2422649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422659 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422666 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2422669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422679 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422680 */   // GIR_Coverage, 44859,
     /* 2422680 */   GIR_EraseRootFromParent_Done,
     /* 2422681 */ // Label 34960: @2422681
     /* 2422681 */ GIM_Reject,
     /* 2422682 */ // Label 34947: @2422682
     /* 2422682 */ GIM_Try, /*On fail goto*//*Label 34961*/ GIMT_Encode4(2422719), // Rule ID 44886 //
     /* 2422687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422697 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422704 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2422707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422717 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422718 */   // GIR_Coverage, 44886,
     /* 2422718 */   GIR_EraseRootFromParent_Done,
     /* 2422719 */ // Label 34961: @2422719
     /* 2422719 */ GIM_Try, /*On fail goto*//*Label 34962*/ GIMT_Encode4(2422756), // Rule ID 44887 //
     /* 2422724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422734 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422741 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2422744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422746 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422754 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422755 */   // GIR_Coverage, 44887,
     /* 2422755 */   GIR_EraseRootFromParent_Done,
     /* 2422756 */ // Label 34962: @2422756
     /* 2422756 */ GIM_Reject,
     /* 2422757 */ // Label 34948: @2422757
     /* 2422757 */ GIM_Reject,
     /* 2422758 */ // Label 121: @2422758
     /* 2422758 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 34970*/ GIMT_Encode4(2423406),
     /* 2422769 */ /*GILLT_nxv1s1*//*Label 34963*/ GIMT_Encode4(2422881), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422789 */ /*GILLT_nxv2s1*//*Label 34964*/ GIMT_Encode4(2422956), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422809 */ /*GILLT_nxv4s1*//*Label 34965*/ GIMT_Encode4(2423031), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422829 */ /*GILLT_nxv8s1*//*Label 34966*/ GIMT_Encode4(2423106), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422849 */ /*GILLT_nxv16s1*//*Label 34967*/ GIMT_Encode4(2423181), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422865 */ /*GILLT_nxv32s1*//*Label 34968*/ GIMT_Encode4(2423256), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422877 */ /*GILLT_nxv64s1*//*Label 34969*/ GIMT_Encode4(2423331),
     /* 2422881 */ // Label 34963: @2422881
     /* 2422881 */ GIM_Try, /*On fail goto*//*Label 34971*/ GIMT_Encode4(2422918), // Rule ID 44716 //
     /* 2422886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422896 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422903 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2422906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422916 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422917 */   // GIR_Coverage, 44716,
     /* 2422917 */   GIR_EraseRootFromParent_Done,
     /* 2422918 */ // Label 34971: @2422918
     /* 2422918 */ GIM_Try, /*On fail goto*//*Label 34972*/ GIMT_Encode4(2422955), // Rule ID 44717 //
     /* 2422923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422933 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422940 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2422943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422953 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422954 */   // GIR_Coverage, 44717,
     /* 2422954 */   GIR_EraseRootFromParent_Done,
     /* 2422955 */ // Label 34972: @2422955
     /* 2422955 */ GIM_Reject,
     /* 2422956 */ // Label 34964: @2422956
     /* 2422956 */ GIM_Try, /*On fail goto*//*Label 34973*/ GIMT_Encode4(2422993), // Rule ID 44744 //
     /* 2422961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422971 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422978 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2422981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422991 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422992 */   // GIR_Coverage, 44744,
     /* 2422992 */   GIR_EraseRootFromParent_Done,
     /* 2422993 */ // Label 34973: @2422993
     /* 2422993 */ GIM_Try, /*On fail goto*//*Label 34974*/ GIMT_Encode4(2423030), // Rule ID 44745 //
     /* 2422998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2423004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423015 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2423015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2423018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423029 */   // GIR_Coverage, 44745,
     /* 2423029 */   GIR_EraseRootFromParent_Done,
     /* 2423030 */ // Label 34974: @2423030
     /* 2423030 */ GIM_Reject,
     /* 2423031 */ // Label 34965: @2423031
     /* 2423031 */ GIM_Try, /*On fail goto*//*Label 34975*/ GIMT_Encode4(2423068), // Rule ID 44772 //
     /* 2423036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2423042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423046 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423053 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2423053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2423056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423066 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423067 */   // GIR_Coverage, 44772,
     /* 2423067 */   GIR_EraseRootFromParent_Done,
     /* 2423068 */ // Label 34975: @2423068
     /* 2423068 */ GIM_Try, /*On fail goto*//*Label 34976*/ GIMT_Encode4(2423105), // Rule ID 44773 //
     /* 2423073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2423079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423083 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423090 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2423090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2423093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423104 */   // GIR_Coverage, 44773,
     /* 2423104 */   GIR_EraseRootFromParent_Done,
     /* 2423105 */ // Label 34976: @2423105
     /* 2423105 */ GIM_Reject,
     /* 2423106 */ // Label 34966: @2423106
     /* 2423106 */ GIM_Try, /*On fail goto*//*Label 34977*/ GIMT_Encode4(2423143), // Rule ID 44800 //
     /* 2423111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2423117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423121 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423128 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2423128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2423131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423141 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423142 */   // GIR_Coverage, 44800,
     /* 2423142 */   GIR_EraseRootFromParent_Done,
     /* 2423143 */ // Label 34977: @2423143
     /* 2423143 */ GIM_Try, /*On fail goto*//*Label 34978*/ GIMT_Encode4(2423180), // Rule ID 44801 //
     /* 2423148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2423154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423158 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423165 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2423165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2423168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423178 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423179 */   // GIR_Coverage, 44801,
     /* 2423179 */   GIR_EraseRootFromParent_Done,
     /* 2423180 */ // Label 34978: @2423180
     /* 2423180 */ GIM_Reject,
     /* 2423181 */ // Label 34967: @2423181
     /* 2423181 */ GIM_Try, /*On fail goto*//*Label 34979*/ GIMT_Encode4(2423218), // Rule ID 44828 //
     /* 2423186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2423192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423196 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423203 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2423203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2423206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423216 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423217 */   // GIR_Coverage, 44828,
     /* 2423217 */   GIR_EraseRootFromParent_Done,
     /* 2423218 */ // Label 34979: @2423218
     /* 2423218 */ GIM_Try, /*On fail goto*//*Label 34980*/ GIMT_Encode4(2423255), // Rule ID 44829 //
     /* 2423223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2423229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423233 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423240 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2423240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2423243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423253 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423254 */   // GIR_Coverage, 44829,
     /* 2423254 */   GIR_EraseRootFromParent_Done,
     /* 2423255 */ // Label 34980: @2423255
     /* 2423255 */ GIM_Reject,
     /* 2423256 */ // Label 34968: @2423256
     /* 2423256 */ GIM_Try, /*On fail goto*//*Label 34981*/ GIMT_Encode4(2423293), // Rule ID 44856 //
     /* 2423261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2423267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423271 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423278 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2423278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2423281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423291 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423292 */   // GIR_Coverage, 44856,
     /* 2423292 */   GIR_EraseRootFromParent_Done,
     /* 2423293 */ // Label 34981: @2423293
     /* 2423293 */ GIM_Try, /*On fail goto*//*Label 34982*/ GIMT_Encode4(2423330), // Rule ID 44857 //
     /* 2423298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2423304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423308 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423315 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2423315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2423318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423328 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423329 */   // GIR_Coverage, 44857,
     /* 2423329 */   GIR_EraseRootFromParent_Done,
     /* 2423330 */ // Label 34982: @2423330
     /* 2423330 */ GIM_Reject,
     /* 2423331 */ // Label 34969: @2423331
     /* 2423331 */ GIM_Try, /*On fail goto*//*Label 34983*/ GIMT_Encode4(2423368), // Rule ID 44884 //
     /* 2423336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2423342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423346 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423353 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2423353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2423356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423366 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423367 */   // GIR_Coverage, 44884,
     /* 2423367 */   GIR_EraseRootFromParent_Done,
     /* 2423368 */ // Label 34983: @2423368
     /* 2423368 */ GIM_Try, /*On fail goto*//*Label 34984*/ GIMT_Encode4(2423405), // Rule ID 44885 //
     /* 2423373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2423379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423383 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423390 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2423390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2423393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423403 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423404 */   // GIR_Coverage, 44885,
     /* 2423404 */   GIR_EraseRootFromParent_Done,
     /* 2423405 */ // Label 34984: @2423405
     /* 2423405 */ GIM_Reject,
     /* 2423406 */ // Label 34970: @2423406
     /* 2423406 */ GIM_Reject,
     /* 2423407 */ // Label 122: @2423407
     /* 2423407 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35007*/ GIMT_Encode4(2427664),
     /* 2423418 */ /*GILLT_nxv1s8*//*Label 34985*/ GIMT_Encode4(2423530),
     /* 2423422 */ /*GILLT_nxv1s16*//*Label 34986*/ GIMT_Encode4(2423647),
     /* 2423426 */ /*GILLT_nxv1s32*//*Label 34987*/ GIMT_Encode4(2423868),
     /* 2423430 */ /*GILLT_nxv1s64*//*Label 34988*/ GIMT_Encode4(2424089), GIMT_Encode4(0),
     /* 2423438 */ /*GILLT_nxv2s8*//*Label 34989*/ GIMT_Encode4(2424310),
     /* 2423442 */ /*GILLT_nxv2s16*//*Label 34990*/ GIMT_Encode4(2424427),
     /* 2423446 */ /*GILLT_nxv2s32*//*Label 34991*/ GIMT_Encode4(2424648),
     /* 2423450 */ /*GILLT_nxv2s64*//*Label 34992*/ GIMT_Encode4(2424869), GIMT_Encode4(0),
     /* 2423458 */ /*GILLT_nxv4s8*//*Label 34993*/ GIMT_Encode4(2425090),
     /* 2423462 */ /*GILLT_nxv4s16*//*Label 34994*/ GIMT_Encode4(2425207),
     /* 2423466 */ /*GILLT_nxv4s32*//*Label 34995*/ GIMT_Encode4(2425428),
     /* 2423470 */ /*GILLT_nxv4s64*//*Label 34996*/ GIMT_Encode4(2425649), GIMT_Encode4(0),
     /* 2423478 */ /*GILLT_nxv8s8*//*Label 34997*/ GIMT_Encode4(2425870),
     /* 2423482 */ /*GILLT_nxv8s16*//*Label 34998*/ GIMT_Encode4(2425987),
     /* 2423486 */ /*GILLT_nxv8s32*//*Label 34999*/ GIMT_Encode4(2426208),
     /* 2423490 */ /*GILLT_nxv8s64*//*Label 35000*/ GIMT_Encode4(2426429), GIMT_Encode4(0),
     /* 2423498 */ /*GILLT_nxv16s8*//*Label 35001*/ GIMT_Encode4(2426650),
     /* 2423502 */ /*GILLT_nxv16s16*//*Label 35002*/ GIMT_Encode4(2426767),
     /* 2423506 */ /*GILLT_nxv16s32*//*Label 35003*/ GIMT_Encode4(2426988), GIMT_Encode4(0),
     /* 2423514 */ /*GILLT_nxv32s8*//*Label 35004*/ GIMT_Encode4(2427209),
     /* 2423518 */ /*GILLT_nxv32s16*//*Label 35005*/ GIMT_Encode4(2427326), GIMT_Encode4(0),
     /* 2423526 */ /*GILLT_nxv64s8*//*Label 35006*/ GIMT_Encode4(2427547),
     /* 2423530 */ // Label 34985: @2423530
     /* 2423530 */ GIM_Try, /*On fail goto*//*Label 35008*/ GIMT_Encode4(2423646),
     /* 2423535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2423538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2423541 */   GIM_Try, /*On fail goto*//*Label 35009*/ GIMT_Encode4(2423593), // Rule ID 32306 //
     /* 2423546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423571 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2423571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2423574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423576 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423592 */     // GIR_Coverage, 32306,
     /* 2423592 */     GIR_EraseRootFromParent_Done,
     /* 2423593 */   // Label 35009: @2423593
     /* 2423593 */   GIM_Try, /*On fail goto*//*Label 35010*/ GIMT_Encode4(2423645), // Rule ID 32307 //
     /* 2423598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423623 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2423623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2423626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423628 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423644 */     // GIR_Coverage, 32307,
     /* 2423644 */     GIR_EraseRootFromParent_Done,
     /* 2423645 */   // Label 35010: @2423645
     /* 2423645 */   GIM_Reject,
     /* 2423646 */ // Label 35008: @2423646
     /* 2423646 */ GIM_Reject,
     /* 2423647 */ // Label 34986: @2423647
     /* 2423647 */ GIM_Try, /*On fail goto*//*Label 35011*/ GIMT_Encode4(2423867),
     /* 2423652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2423655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2423658 */   GIM_Try, /*On fail goto*//*Label 35012*/ GIMT_Encode4(2423710), // Rule ID 32576 //
     /* 2423663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423688 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2423688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2423691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423693 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423709 */     // GIR_Coverage, 32576,
     /* 2423709 */     GIR_EraseRootFromParent_Done,
     /* 2423710 */   // Label 35012: @2423710
     /* 2423710 */   GIM_Try, /*On fail goto*//*Label 35013*/ GIMT_Encode4(2423762), // Rule ID 32577 //
     /* 2423715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423740 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2423740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2423743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423745 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423761 */     // GIR_Coverage, 32577,
     /* 2423761 */     GIR_EraseRootFromParent_Done,
     /* 2423762 */   // Label 35013: @2423762
     /* 2423762 */   GIM_Try, /*On fail goto*//*Label 35014*/ GIMT_Encode4(2423814), // Rule ID 34286 //
     /* 2423767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423792 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2423792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2423795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423797 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423813 */     // GIR_Coverage, 34286,
     /* 2423813 */     GIR_EraseRootFromParent_Done,
     /* 2423814 */   // Label 35014: @2423814
     /* 2423814 */   GIM_Try, /*On fail goto*//*Label 35015*/ GIMT_Encode4(2423866), // Rule ID 34287 //
     /* 2423819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423844 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2423844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2423847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423849 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423865 */     // GIR_Coverage, 34287,
     /* 2423865 */     GIR_EraseRootFromParent_Done,
     /* 2423866 */   // Label 35015: @2423866
     /* 2423866 */   GIM_Reject,
     /* 2423867 */ // Label 35011: @2423867
     /* 2423867 */ GIM_Reject,
     /* 2423868 */ // Label 34987: @2423868
     /* 2423868 */ GIM_Try, /*On fail goto*//*Label 35016*/ GIMT_Encode4(2424088),
     /* 2423873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2423876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2423879 */   GIM_Try, /*On fail goto*//*Label 35017*/ GIMT_Encode4(2423931), // Rule ID 32756 //
     /* 2423884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423909 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2423909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2423912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423914 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423930 */     // GIR_Coverage, 32756,
     /* 2423930 */     GIR_EraseRootFromParent_Done,
     /* 2423931 */   // Label 35017: @2423931
     /* 2423931 */   GIM_Try, /*On fail goto*//*Label 35018*/ GIMT_Encode4(2423983), // Rule ID 32757 //
     /* 2423936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423961 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2423961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2423964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423966 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423982 */     // GIR_Coverage, 32757,
     /* 2423982 */     GIR_EraseRootFromParent_Done,
     /* 2423983 */   // Label 35018: @2423983
     /* 2423983 */   GIM_Try, /*On fail goto*//*Label 35019*/ GIMT_Encode4(2424035), // Rule ID 34466 //
     /* 2423988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424013 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2424016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424018 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424034 */     // GIR_Coverage, 34466,
     /* 2424034 */     GIR_EraseRootFromParent_Done,
     /* 2424035 */   // Label 35019: @2424035
     /* 2424035 */   GIM_Try, /*On fail goto*//*Label 35020*/ GIMT_Encode4(2424087), // Rule ID 34467 //
     /* 2424040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424065 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2424068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424070 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424086 */     // GIR_Coverage, 34467,
     /* 2424086 */     GIR_EraseRootFromParent_Done,
     /* 2424087 */   // Label 35020: @2424087
     /* 2424087 */   GIM_Reject,
     /* 2424088 */ // Label 35016: @2424088
     /* 2424088 */ GIM_Reject,
     /* 2424089 */ // Label 34988: @2424089
     /* 2424089 */ GIM_Try, /*On fail goto*//*Label 35021*/ GIMT_Encode4(2424309),
     /* 2424094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2424097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2424100 */   GIM_Try, /*On fail goto*//*Label 35022*/ GIMT_Encode4(2424152), // Rule ID 33116 //
     /* 2424105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2424108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424130 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424135 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424151 */     // GIR_Coverage, 33116,
     /* 2424151 */     GIR_EraseRootFromParent_Done,
     /* 2424152 */   // Label 35022: @2424152
     /* 2424152 */   GIM_Try, /*On fail goto*//*Label 35023*/ GIMT_Encode4(2424204), // Rule ID 33117 //
     /* 2424157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2424160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424182 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424187 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424203 */     // GIR_Coverage, 33117,
     /* 2424203 */     GIR_EraseRootFromParent_Done,
     /* 2424204 */   // Label 35023: @2424204
     /* 2424204 */   GIM_Try, /*On fail goto*//*Label 35024*/ GIMT_Encode4(2424256), // Rule ID 34912 //
     /* 2424209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2424212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424234 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424239 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424255 */     // GIR_Coverage, 34912,
     /* 2424255 */     GIR_EraseRootFromParent_Done,
     /* 2424256 */   // Label 35024: @2424256
     /* 2424256 */   GIM_Try, /*On fail goto*//*Label 35025*/ GIMT_Encode4(2424308), // Rule ID 34913 //
     /* 2424261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2424264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424286 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424291 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424307 */     // GIR_Coverage, 34913,
     /* 2424307 */     GIR_EraseRootFromParent_Done,
     /* 2424308 */   // Label 35025: @2424308
     /* 2424308 */   GIM_Reject,
     /* 2424309 */ // Label 35021: @2424309
     /* 2424309 */ GIM_Reject,
     /* 2424310 */ // Label 34989: @2424310
     /* 2424310 */ GIM_Try, /*On fail goto*//*Label 35026*/ GIMT_Encode4(2424426),
     /* 2424315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2424318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2424321 */   GIM_Try, /*On fail goto*//*Label 35027*/ GIMT_Encode4(2424373), // Rule ID 32396 //
     /* 2424326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424351 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2424354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424356 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2424368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424372 */     // GIR_Coverage, 32396,
     /* 2424372 */     GIR_EraseRootFromParent_Done,
     /* 2424373 */   // Label 35027: @2424373
     /* 2424373 */   GIM_Try, /*On fail goto*//*Label 35028*/ GIMT_Encode4(2424425), // Rule ID 32397 //
     /* 2424378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424403 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2424406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424408 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2424420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424424 */     // GIR_Coverage, 32397,
     /* 2424424 */     GIR_EraseRootFromParent_Done,
     /* 2424425 */   // Label 35028: @2424425
     /* 2424425 */   GIM_Reject,
     /* 2424426 */ // Label 35026: @2424426
     /* 2424426 */ GIM_Reject,
     /* 2424427 */ // Label 34990: @2424427
     /* 2424427 */ GIM_Try, /*On fail goto*//*Label 35029*/ GIMT_Encode4(2424647),
     /* 2424432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2424435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2424438 */   GIM_Try, /*On fail goto*//*Label 35030*/ GIMT_Encode4(2424490), // Rule ID 32666 //
     /* 2424443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424468 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2424471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424473 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424489 */     // GIR_Coverage, 32666,
     /* 2424489 */     GIR_EraseRootFromParent_Done,
     /* 2424490 */   // Label 35030: @2424490
     /* 2424490 */   GIM_Try, /*On fail goto*//*Label 35031*/ GIMT_Encode4(2424542), // Rule ID 32667 //
     /* 2424495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424520 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2424523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424525 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424541 */     // GIR_Coverage, 32667,
     /* 2424541 */     GIR_EraseRootFromParent_Done,
     /* 2424542 */   // Label 35031: @2424542
     /* 2424542 */   GIM_Try, /*On fail goto*//*Label 35032*/ GIMT_Encode4(2424594), // Rule ID 34376 //
     /* 2424547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424572 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2424575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424577 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424593 */     // GIR_Coverage, 34376,
     /* 2424593 */     GIR_EraseRootFromParent_Done,
     /* 2424594 */   // Label 35032: @2424594
     /* 2424594 */   GIM_Try, /*On fail goto*//*Label 35033*/ GIMT_Encode4(2424646), // Rule ID 34377 //
     /* 2424599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424624 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2424627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424629 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424645 */     // GIR_Coverage, 34377,
     /* 2424645 */     GIR_EraseRootFromParent_Done,
     /* 2424646 */   // Label 35033: @2424646
     /* 2424646 */   GIM_Reject,
     /* 2424647 */ // Label 35029: @2424647
     /* 2424647 */ GIM_Reject,
     /* 2424648 */ // Label 34991: @2424648
     /* 2424648 */ GIM_Try, /*On fail goto*//*Label 35034*/ GIMT_Encode4(2424868),
     /* 2424653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2424656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2424659 */   GIM_Try, /*On fail goto*//*Label 35035*/ GIMT_Encode4(2424711), // Rule ID 33026 //
     /* 2424664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424689 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424694 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424710 */     // GIR_Coverage, 33026,
     /* 2424710 */     GIR_EraseRootFromParent_Done,
     /* 2424711 */   // Label 35035: @2424711
     /* 2424711 */   GIM_Try, /*On fail goto*//*Label 35036*/ GIMT_Encode4(2424763), // Rule ID 33027 //
     /* 2424716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424741 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424746 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424762 */     // GIR_Coverage, 33027,
     /* 2424762 */     GIR_EraseRootFromParent_Done,
     /* 2424763 */   // Label 35036: @2424763
     /* 2424763 */   GIM_Try, /*On fail goto*//*Label 35037*/ GIMT_Encode4(2424815), // Rule ID 34822 //
     /* 2424768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424793 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424798 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424814 */     // GIR_Coverage, 34822,
     /* 2424814 */     GIR_EraseRootFromParent_Done,
     /* 2424815 */   // Label 35037: @2424815
     /* 2424815 */   GIM_Try, /*On fail goto*//*Label 35038*/ GIMT_Encode4(2424867), // Rule ID 34823 //
     /* 2424820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424845 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424850 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424866 */     // GIR_Coverage, 34823,
     /* 2424866 */     GIR_EraseRootFromParent_Done,
     /* 2424867 */   // Label 35038: @2424867
     /* 2424867 */   GIM_Reject,
     /* 2424868 */ // Label 35034: @2424868
     /* 2424868 */ GIM_Reject,
     /* 2424869 */ // Label 34992: @2424869
     /* 2424869 */ GIM_Try, /*On fail goto*//*Label 35039*/ GIMT_Encode4(2425089),
     /* 2424874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2424877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2424880 */   GIM_Try, /*On fail goto*//*Label 35040*/ GIMT_Encode4(2424932), // Rule ID 34016 //
     /* 2424885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2424888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424910 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2424913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424915 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424931 */     // GIR_Coverage, 34016,
     /* 2424931 */     GIR_EraseRootFromParent_Done,
     /* 2424932 */   // Label 35040: @2424932
     /* 2424932 */   GIM_Try, /*On fail goto*//*Label 35041*/ GIMT_Encode4(2424984), // Rule ID 34017 //
     /* 2424937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2424940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424962 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2424965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424967 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424983 */     // GIR_Coverage, 34017,
     /* 2424983 */     GIR_EraseRootFromParent_Done,
     /* 2424984 */   // Label 35041: @2424984
     /* 2424984 */   GIM_Try, /*On fail goto*//*Label 35042*/ GIMT_Encode4(2425036), // Rule ID 35630 //
     /* 2424989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2424992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425014 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425019 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425035 */     // GIR_Coverage, 35630,
     /* 2425035 */     GIR_EraseRootFromParent_Done,
     /* 2425036 */   // Label 35042: @2425036
     /* 2425036 */   GIM_Try, /*On fail goto*//*Label 35043*/ GIMT_Encode4(2425088), // Rule ID 35631 //
     /* 2425041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2425044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425066 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425071 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425087 */     // GIR_Coverage, 35631,
     /* 2425087 */     GIR_EraseRootFromParent_Done,
     /* 2425088 */   // Label 35043: @2425088
     /* 2425088 */   GIM_Reject,
     /* 2425089 */ // Label 35039: @2425089
     /* 2425089 */ GIM_Reject,
     /* 2425090 */ // Label 34993: @2425090
     /* 2425090 */ GIM_Try, /*On fail goto*//*Label 35044*/ GIMT_Encode4(2425206),
     /* 2425095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2425098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2425101 */   GIM_Try, /*On fail goto*//*Label 35045*/ GIMT_Encode4(2425153), // Rule ID 32486 //
     /* 2425106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425131 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2425134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425136 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425152 */     // GIR_Coverage, 32486,
     /* 2425152 */     GIR_EraseRootFromParent_Done,
     /* 2425153 */   // Label 35045: @2425153
     /* 2425153 */   GIM_Try, /*On fail goto*//*Label 35046*/ GIMT_Encode4(2425205), // Rule ID 32487 //
     /* 2425158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425183 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2425186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425188 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425204 */     // GIR_Coverage, 32487,
     /* 2425204 */     GIR_EraseRootFromParent_Done,
     /* 2425205 */   // Label 35046: @2425205
     /* 2425205 */   GIM_Reject,
     /* 2425206 */ // Label 35044: @2425206
     /* 2425206 */ GIM_Reject,
     /* 2425207 */ // Label 34994: @2425207
     /* 2425207 */ GIM_Try, /*On fail goto*//*Label 35047*/ GIMT_Encode4(2425427),
     /* 2425212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2425215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2425218 */   GIM_Try, /*On fail goto*//*Label 35048*/ GIMT_Encode4(2425270), // Rule ID 32936 //
     /* 2425223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425248 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2425251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425253 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425269 */     // GIR_Coverage, 32936,
     /* 2425269 */     GIR_EraseRootFromParent_Done,
     /* 2425270 */   // Label 35048: @2425270
     /* 2425270 */   GIM_Try, /*On fail goto*//*Label 35049*/ GIMT_Encode4(2425322), // Rule ID 32937 //
     /* 2425275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425300 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2425303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425305 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425321 */     // GIR_Coverage, 32937,
     /* 2425321 */     GIR_EraseRootFromParent_Done,
     /* 2425322 */   // Label 35049: @2425322
     /* 2425322 */   GIM_Try, /*On fail goto*//*Label 35050*/ GIMT_Encode4(2425374), // Rule ID 34732 //
     /* 2425327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425352 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2425355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425357 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425373 */     // GIR_Coverage, 34732,
     /* 2425373 */     GIR_EraseRootFromParent_Done,
     /* 2425374 */   // Label 35050: @2425374
     /* 2425374 */   GIM_Try, /*On fail goto*//*Label 35051*/ GIMT_Encode4(2425426), // Rule ID 34733 //
     /* 2425379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425404 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2425407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425409 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425425 */     // GIR_Coverage, 34733,
     /* 2425425 */     GIR_EraseRootFromParent_Done,
     /* 2425426 */   // Label 35051: @2425426
     /* 2425426 */   GIM_Reject,
     /* 2425427 */ // Label 35047: @2425427
     /* 2425427 */ GIM_Reject,
     /* 2425428 */ // Label 34995: @2425428
     /* 2425428 */ GIM_Try, /*On fail goto*//*Label 35052*/ GIMT_Encode4(2425648),
     /* 2425433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2425436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2425439 */   GIM_Try, /*On fail goto*//*Label 35053*/ GIMT_Encode4(2425491), // Rule ID 33746 //
     /* 2425444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425469 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425474 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425490 */     // GIR_Coverage, 33746,
     /* 2425490 */     GIR_EraseRootFromParent_Done,
     /* 2425491 */   // Label 35053: @2425491
     /* 2425491 */   GIM_Try, /*On fail goto*//*Label 35054*/ GIMT_Encode4(2425543), // Rule ID 33747 //
     /* 2425496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425521 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425526 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425542 */     // GIR_Coverage, 33747,
     /* 2425542 */     GIR_EraseRootFromParent_Done,
     /* 2425543 */   // Label 35054: @2425543
     /* 2425543 */   GIM_Try, /*On fail goto*//*Label 35055*/ GIMT_Encode4(2425595), // Rule ID 35360 //
     /* 2425548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425573 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425578 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425594 */     // GIR_Coverage, 35360,
     /* 2425594 */     GIR_EraseRootFromParent_Done,
     /* 2425595 */   // Label 35055: @2425595
     /* 2425595 */   GIM_Try, /*On fail goto*//*Label 35056*/ GIMT_Encode4(2425647), // Rule ID 35361 //
     /* 2425600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425625 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425630 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425646 */     // GIR_Coverage, 35361,
     /* 2425646 */     GIR_EraseRootFromParent_Done,
     /* 2425647 */   // Label 35056: @2425647
     /* 2425647 */   GIM_Reject,
     /* 2425648 */ // Label 35052: @2425648
     /* 2425648 */ GIM_Reject,
     /* 2425649 */ // Label 34996: @2425649
     /* 2425649 */ GIM_Try, /*On fail goto*//*Label 35057*/ GIMT_Encode4(2425869),
     /* 2425654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2425657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2425660 */   GIM_Try, /*On fail goto*//*Label 35058*/ GIMT_Encode4(2425712), // Rule ID 34106 //
     /* 2425665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2425668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425690 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2425693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425695 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425711 */     // GIR_Coverage, 34106,
     /* 2425711 */     GIR_EraseRootFromParent_Done,
     /* 2425712 */   // Label 35058: @2425712
     /* 2425712 */   GIM_Try, /*On fail goto*//*Label 35059*/ GIMT_Encode4(2425764), // Rule ID 34107 //
     /* 2425717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2425720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425742 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2425745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425747 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425763 */     // GIR_Coverage, 34107,
     /* 2425763 */     GIR_EraseRootFromParent_Done,
     /* 2425764 */   // Label 35059: @2425764
     /* 2425764 */   GIM_Try, /*On fail goto*//*Label 35060*/ GIMT_Encode4(2425816), // Rule ID 35720 //
     /* 2425769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2425772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425794 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2425797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425799 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425815 */     // GIR_Coverage, 35720,
     /* 2425815 */     GIR_EraseRootFromParent_Done,
     /* 2425816 */   // Label 35060: @2425816
     /* 2425816 */   GIM_Try, /*On fail goto*//*Label 35061*/ GIMT_Encode4(2425868), // Rule ID 35721 //
     /* 2425821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2425824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425846 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2425849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425851 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425867 */     // GIR_Coverage, 35721,
     /* 2425867 */     GIR_EraseRootFromParent_Done,
     /* 2425868 */   // Label 35061: @2425868
     /* 2425868 */   GIM_Reject,
     /* 2425869 */ // Label 35057: @2425869
     /* 2425869 */ GIM_Reject,
     /* 2425870 */ // Label 34997: @2425870
     /* 2425870 */ GIM_Try, /*On fail goto*//*Label 35062*/ GIMT_Encode4(2425986),
     /* 2425875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2425878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2425881 */   GIM_Try, /*On fail goto*//*Label 35063*/ GIMT_Encode4(2425933), // Rule ID 32846 //
     /* 2425886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425911 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2425914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425916 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425932 */     // GIR_Coverage, 32846,
     /* 2425932 */     GIR_EraseRootFromParent_Done,
     /* 2425933 */   // Label 35063: @2425933
     /* 2425933 */   GIM_Try, /*On fail goto*//*Label 35064*/ GIMT_Encode4(2425985), // Rule ID 32847 //
     /* 2425938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425963 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2425966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425968 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425984 */     // GIR_Coverage, 32847,
     /* 2425984 */     GIR_EraseRootFromParent_Done,
     /* 2425985 */   // Label 35064: @2425985
     /* 2425985 */   GIM_Reject,
     /* 2425986 */ // Label 35062: @2425986
     /* 2425986 */ GIM_Reject,
     /* 2425987 */ // Label 34998: @2425987
     /* 2425987 */ GIM_Try, /*On fail goto*//*Label 35065*/ GIMT_Encode4(2426207),
     /* 2425992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2425995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2425998 */   GIM_Try, /*On fail goto*//*Label 35066*/ GIMT_Encode4(2426050), // Rule ID 33476 //
     /* 2426003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426028 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2426031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426033 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426049 */     // GIR_Coverage, 33476,
     /* 2426049 */     GIR_EraseRootFromParent_Done,
     /* 2426050 */   // Label 35066: @2426050
     /* 2426050 */   GIM_Try, /*On fail goto*//*Label 35067*/ GIMT_Encode4(2426102), // Rule ID 33477 //
     /* 2426055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426080 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2426083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426085 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426101 */     // GIR_Coverage, 33477,
     /* 2426101 */     GIR_EraseRootFromParent_Done,
     /* 2426102 */   // Label 35067: @2426102
     /* 2426102 */   GIM_Try, /*On fail goto*//*Label 35068*/ GIMT_Encode4(2426154), // Rule ID 35090 //
     /* 2426107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426132 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2426135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426137 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426153 */     // GIR_Coverage, 35090,
     /* 2426153 */     GIR_EraseRootFromParent_Done,
     /* 2426154 */   // Label 35068: @2426154
     /* 2426154 */   GIM_Try, /*On fail goto*//*Label 35069*/ GIMT_Encode4(2426206), // Rule ID 35091 //
     /* 2426159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426184 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2426187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426189 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426205 */     // GIR_Coverage, 35091,
     /* 2426205 */     GIR_EraseRootFromParent_Done,
     /* 2426206 */   // Label 35069: @2426206
     /* 2426206 */   GIM_Reject,
     /* 2426207 */ // Label 35065: @2426207
     /* 2426207 */ GIM_Reject,
     /* 2426208 */ // Label 34999: @2426208
     /* 2426208 */ GIM_Try, /*On fail goto*//*Label 35070*/ GIMT_Encode4(2426428),
     /* 2426213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2426216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2426219 */   GIM_Try, /*On fail goto*//*Label 35071*/ GIMT_Encode4(2426271), // Rule ID 33836 //
     /* 2426224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426249 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426254 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426270 */     // GIR_Coverage, 33836,
     /* 2426270 */     GIR_EraseRootFromParent_Done,
     /* 2426271 */   // Label 35071: @2426271
     /* 2426271 */   GIM_Try, /*On fail goto*//*Label 35072*/ GIMT_Encode4(2426323), // Rule ID 33837 //
     /* 2426276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426301 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426306 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426322 */     // GIR_Coverage, 33837,
     /* 2426322 */     GIR_EraseRootFromParent_Done,
     /* 2426323 */   // Label 35072: @2426323
     /* 2426323 */   GIM_Try, /*On fail goto*//*Label 35073*/ GIMT_Encode4(2426375), // Rule ID 35450 //
     /* 2426328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426353 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426358 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426374 */     // GIR_Coverage, 35450,
     /* 2426374 */     GIR_EraseRootFromParent_Done,
     /* 2426375 */   // Label 35073: @2426375
     /* 2426375 */   GIM_Try, /*On fail goto*//*Label 35074*/ GIMT_Encode4(2426427), // Rule ID 35451 //
     /* 2426380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426405 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426410 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426426 */     // GIR_Coverage, 35451,
     /* 2426426 */     GIR_EraseRootFromParent_Done,
     /* 2426427 */   // Label 35074: @2426427
     /* 2426427 */   GIM_Reject,
     /* 2426428 */ // Label 35070: @2426428
     /* 2426428 */ GIM_Reject,
     /* 2426429 */ // Label 35000: @2426429
     /* 2426429 */ GIM_Try, /*On fail goto*//*Label 35075*/ GIMT_Encode4(2426649),
     /* 2426434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2426437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2426440 */   GIM_Try, /*On fail goto*//*Label 35076*/ GIMT_Encode4(2426492), // Rule ID 34196 //
     /* 2426445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2426448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426470 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426475 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426491 */     // GIR_Coverage, 34196,
     /* 2426491 */     GIR_EraseRootFromParent_Done,
     /* 2426492 */   // Label 35076: @2426492
     /* 2426492 */   GIM_Try, /*On fail goto*//*Label 35077*/ GIMT_Encode4(2426544), // Rule ID 34197 //
     /* 2426497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2426500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426522 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426527 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426543 */     // GIR_Coverage, 34197,
     /* 2426543 */     GIR_EraseRootFromParent_Done,
     /* 2426544 */   // Label 35077: @2426544
     /* 2426544 */   GIM_Try, /*On fail goto*//*Label 35078*/ GIMT_Encode4(2426596), // Rule ID 35810 //
     /* 2426549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2426552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426574 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426579 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426595 */     // GIR_Coverage, 35810,
     /* 2426595 */     GIR_EraseRootFromParent_Done,
     /* 2426596 */   // Label 35078: @2426596
     /* 2426596 */   GIM_Try, /*On fail goto*//*Label 35079*/ GIMT_Encode4(2426648), // Rule ID 35811 //
     /* 2426601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2426604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426626 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426631 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426647 */     // GIR_Coverage, 35811,
     /* 2426647 */     GIR_EraseRootFromParent_Done,
     /* 2426648 */   // Label 35079: @2426648
     /* 2426648 */   GIM_Reject,
     /* 2426649 */ // Label 35075: @2426649
     /* 2426649 */ GIM_Reject,
     /* 2426650 */ // Label 35001: @2426650
     /* 2426650 */ GIM_Try, /*On fail goto*//*Label 35080*/ GIMT_Encode4(2426766),
     /* 2426655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2426658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2426661 */   GIM_Try, /*On fail goto*//*Label 35081*/ GIMT_Encode4(2426713), // Rule ID 33206 //
     /* 2426666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426691 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2426694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426696 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426712 */     // GIR_Coverage, 33206,
     /* 2426712 */     GIR_EraseRootFromParent_Done,
     /* 2426713 */   // Label 35081: @2426713
     /* 2426713 */   GIM_Try, /*On fail goto*//*Label 35082*/ GIMT_Encode4(2426765), // Rule ID 33207 //
     /* 2426718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426743 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2426746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426748 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426764 */     // GIR_Coverage, 33207,
     /* 2426764 */     GIR_EraseRootFromParent_Done,
     /* 2426765 */   // Label 35082: @2426765
     /* 2426765 */   GIM_Reject,
     /* 2426766 */ // Label 35080: @2426766
     /* 2426766 */ GIM_Reject,
     /* 2426767 */ // Label 35002: @2426767
     /* 2426767 */ GIM_Try, /*On fail goto*//*Label 35083*/ GIMT_Encode4(2426987),
     /* 2426772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2426775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2426778 */   GIM_Try, /*On fail goto*//*Label 35084*/ GIMT_Encode4(2426830), // Rule ID 33566 //
     /* 2426783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426808 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426813 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426829 */     // GIR_Coverage, 33566,
     /* 2426829 */     GIR_EraseRootFromParent_Done,
     /* 2426830 */   // Label 35084: @2426830
     /* 2426830 */   GIM_Try, /*On fail goto*//*Label 35085*/ GIMT_Encode4(2426882), // Rule ID 33567 //
     /* 2426835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426860 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426865 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426881 */     // GIR_Coverage, 33567,
     /* 2426881 */     GIR_EraseRootFromParent_Done,
     /* 2426882 */   // Label 35085: @2426882
     /* 2426882 */   GIM_Try, /*On fail goto*//*Label 35086*/ GIMT_Encode4(2426934), // Rule ID 35180 //
     /* 2426887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426912 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426917 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426933 */     // GIR_Coverage, 35180,
     /* 2426933 */     GIR_EraseRootFromParent_Done,
     /* 2426934 */   // Label 35086: @2426934
     /* 2426934 */   GIM_Try, /*On fail goto*//*Label 35087*/ GIMT_Encode4(2426986), // Rule ID 35181 //
     /* 2426939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426964 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426969 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426985 */     // GIR_Coverage, 35181,
     /* 2426985 */     GIR_EraseRootFromParent_Done,
     /* 2426986 */   // Label 35087: @2426986
     /* 2426986 */   GIM_Reject,
     /* 2426987 */ // Label 35083: @2426987
     /* 2426987 */ GIM_Reject,
     /* 2426988 */ // Label 35003: @2426988
     /* 2426988 */ GIM_Try, /*On fail goto*//*Label 35088*/ GIMT_Encode4(2427208),
     /* 2426993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2426996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2426999 */   GIM_Try, /*On fail goto*//*Label 35089*/ GIMT_Encode4(2427051), // Rule ID 33926 //
     /* 2427004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427029 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427034 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427050 */     // GIR_Coverage, 33926,
     /* 2427050 */     GIR_EraseRootFromParent_Done,
     /* 2427051 */   // Label 35089: @2427051
     /* 2427051 */   GIM_Try, /*On fail goto*//*Label 35090*/ GIMT_Encode4(2427103), // Rule ID 33927 //
     /* 2427056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427081 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427086 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427102 */     // GIR_Coverage, 33927,
     /* 2427102 */     GIR_EraseRootFromParent_Done,
     /* 2427103 */   // Label 35090: @2427103
     /* 2427103 */   GIM_Try, /*On fail goto*//*Label 35091*/ GIMT_Encode4(2427155), // Rule ID 35540 //
     /* 2427108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427133 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427138 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427154 */     // GIR_Coverage, 35540,
     /* 2427154 */     GIR_EraseRootFromParent_Done,
     /* 2427155 */   // Label 35091: @2427155
     /* 2427155 */   GIM_Try, /*On fail goto*//*Label 35092*/ GIMT_Encode4(2427207), // Rule ID 35541 //
     /* 2427160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427185 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427190 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427206 */     // GIR_Coverage, 35541,
     /* 2427206 */     GIR_EraseRootFromParent_Done,
     /* 2427207 */   // Label 35092: @2427207
     /* 2427207 */   GIM_Reject,
     /* 2427208 */ // Label 35088: @2427208
     /* 2427208 */ GIM_Reject,
     /* 2427209 */ // Label 35004: @2427209
     /* 2427209 */ GIM_Try, /*On fail goto*//*Label 35093*/ GIMT_Encode4(2427325),
     /* 2427214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2427217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2427220 */   GIM_Try, /*On fail goto*//*Label 35094*/ GIMT_Encode4(2427272), // Rule ID 33296 //
     /* 2427225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427250 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2427253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427255 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427271 */     // GIR_Coverage, 33296,
     /* 2427271 */     GIR_EraseRootFromParent_Done,
     /* 2427272 */   // Label 35094: @2427272
     /* 2427272 */   GIM_Try, /*On fail goto*//*Label 35095*/ GIMT_Encode4(2427324), // Rule ID 33297 //
     /* 2427277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427302 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2427305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427307 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427323 */     // GIR_Coverage, 33297,
     /* 2427323 */     GIR_EraseRootFromParent_Done,
     /* 2427324 */   // Label 35095: @2427324
     /* 2427324 */   GIM_Reject,
     /* 2427325 */ // Label 35093: @2427325
     /* 2427325 */ GIM_Reject,
     /* 2427326 */ // Label 35005: @2427326
     /* 2427326 */ GIM_Try, /*On fail goto*//*Label 35096*/ GIMT_Encode4(2427546),
     /* 2427331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2427334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2427337 */   GIM_Try, /*On fail goto*//*Label 35097*/ GIMT_Encode4(2427389), // Rule ID 33656 //
     /* 2427342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427367 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427372 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427388 */     // GIR_Coverage, 33656,
     /* 2427388 */     GIR_EraseRootFromParent_Done,
     /* 2427389 */   // Label 35097: @2427389
     /* 2427389 */   GIM_Try, /*On fail goto*//*Label 35098*/ GIMT_Encode4(2427441), // Rule ID 33657 //
     /* 2427394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427419 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427424 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427440 */     // GIR_Coverage, 33657,
     /* 2427440 */     GIR_EraseRootFromParent_Done,
     /* 2427441 */   // Label 35098: @2427441
     /* 2427441 */   GIM_Try, /*On fail goto*//*Label 35099*/ GIMT_Encode4(2427493), // Rule ID 35270 //
     /* 2427446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427471 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427476 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427492 */     // GIR_Coverage, 35270,
     /* 2427492 */     GIR_EraseRootFromParent_Done,
     /* 2427493 */   // Label 35099: @2427493
     /* 2427493 */   GIM_Try, /*On fail goto*//*Label 35100*/ GIMT_Encode4(2427545), // Rule ID 35271 //
     /* 2427498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427523 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427528 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427544 */     // GIR_Coverage, 35271,
     /* 2427544 */     GIR_EraseRootFromParent_Done,
     /* 2427545 */   // Label 35100: @2427545
     /* 2427545 */   GIM_Reject,
     /* 2427546 */ // Label 35096: @2427546
     /* 2427546 */ GIM_Reject,
     /* 2427547 */ // Label 35006: @2427547
     /* 2427547 */ GIM_Try, /*On fail goto*//*Label 35101*/ GIMT_Encode4(2427663),
     /* 2427552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2427555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2427558 */   GIM_Try, /*On fail goto*//*Label 35102*/ GIMT_Encode4(2427610), // Rule ID 33386 //
     /* 2427563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427588 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427593 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427609 */     // GIR_Coverage, 33386,
     /* 2427609 */     GIR_EraseRootFromParent_Done,
     /* 2427610 */   // Label 35102: @2427610
     /* 2427610 */   GIM_Try, /*On fail goto*//*Label 35103*/ GIMT_Encode4(2427662), // Rule ID 33387 //
     /* 2427615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427640 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427645 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427661 */     // GIR_Coverage, 33387,
     /* 2427661 */     GIR_EraseRootFromParent_Done,
     /* 2427662 */   // Label 35103: @2427662
     /* 2427662 */   GIM_Reject,
     /* 2427663 */ // Label 35101: @2427663
     /* 2427663 */ GIM_Reject,
     /* 2427664 */ // Label 35007: @2427664
     /* 2427664 */ GIM_Reject,
     /* 2427665 */ // Label 123: @2427665
     /* 2427665 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35126*/ GIMT_Encode4(2439544),
     /* 2427676 */ /*GILLT_nxv1s8*//*Label 35104*/ GIMT_Encode4(2427788),
     /* 2427680 */ /*GILLT_nxv1s16*//*Label 35105*/ GIMT_Encode4(2428111),
     /* 2427684 */ /*GILLT_nxv1s32*//*Label 35106*/ GIMT_Encode4(2428744),
     /* 2427688 */ /*GILLT_nxv1s64*//*Label 35107*/ GIMT_Encode4(2429377), GIMT_Encode4(0),
     /* 2427696 */ /*GILLT_nxv2s8*//*Label 35108*/ GIMT_Encode4(2430010),
     /* 2427700 */ /*GILLT_nxv2s16*//*Label 35109*/ GIMT_Encode4(2430333),
     /* 2427704 */ /*GILLT_nxv2s32*//*Label 35110*/ GIMT_Encode4(2430966),
     /* 2427708 */ /*GILLT_nxv2s64*//*Label 35111*/ GIMT_Encode4(2431599), GIMT_Encode4(0),
     /* 2427716 */ /*GILLT_nxv4s8*//*Label 35112*/ GIMT_Encode4(2432232),
     /* 2427720 */ /*GILLT_nxv4s16*//*Label 35113*/ GIMT_Encode4(2432555),
     /* 2427724 */ /*GILLT_nxv4s32*//*Label 35114*/ GIMT_Encode4(2433188),
     /* 2427728 */ /*GILLT_nxv4s64*//*Label 35115*/ GIMT_Encode4(2433821), GIMT_Encode4(0),
     /* 2427736 */ /*GILLT_nxv8s8*//*Label 35116*/ GIMT_Encode4(2434454),
     /* 2427740 */ /*GILLT_nxv8s16*//*Label 35117*/ GIMT_Encode4(2434777),
     /* 2427744 */ /*GILLT_nxv8s32*//*Label 35118*/ GIMT_Encode4(2435410),
     /* 2427748 */ /*GILLT_nxv8s64*//*Label 35119*/ GIMT_Encode4(2436043), GIMT_Encode4(0),
     /* 2427756 */ /*GILLT_nxv16s8*//*Label 35120*/ GIMT_Encode4(2436676),
     /* 2427760 */ /*GILLT_nxv16s16*//*Label 35121*/ GIMT_Encode4(2436999),
     /* 2427764 */ /*GILLT_nxv16s32*//*Label 35122*/ GIMT_Encode4(2437632), GIMT_Encode4(0),
     /* 2427772 */ /*GILLT_nxv32s8*//*Label 35123*/ GIMT_Encode4(2438265),
     /* 2427776 */ /*GILLT_nxv32s16*//*Label 35124*/ GIMT_Encode4(2438588), GIMT_Encode4(0),
     /* 2427784 */ /*GILLT_nxv64s8*//*Label 35125*/ GIMT_Encode4(2439221),
     /* 2427788 */ // Label 35104: @2427788
     /* 2427788 */ GIM_Try, /*On fail goto*//*Label 35127*/ GIMT_Encode4(2428110),
     /* 2427793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2427796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2427799 */   GIM_Try, /*On fail goto*//*Label 35128*/ GIMT_Encode4(2427882), // Rule ID 45450 //
     /* 2427804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2427813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427840 */     // MIs[1] Operand 1
     /* 2427840 */     // No operand predicates
     /* 2427840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427844 */     // MIs[0] policy
     /* 2427844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427856 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2427859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427881 */     // GIR_Coverage, 45450,
     /* 2427881 */     GIR_EraseRootFromParent_Done,
     /* 2427882 */   // Label 35128: @2427882
     /* 2427882 */   GIM_Try, /*On fail goto*//*Label 35129*/ GIMT_Encode4(2427965), // Rule ID 45451 //
     /* 2427887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2427896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427923 */     // MIs[1] Operand 1
     /* 2427923 */     // No operand predicates
     /* 2427923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427927 */     // MIs[0] policy
     /* 2427927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427939 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2427942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427964 */     // GIR_Coverage, 45451,
     /* 2427964 */     GIR_EraseRootFromParent_Done,
     /* 2427965 */   // Label 35129: @2427965
     /* 2427965 */   GIM_Try, /*On fail goto*//*Label 35130*/ GIMT_Encode4(2428037), // Rule ID 45452 //
     /* 2427970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2427979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428002 */     // MIs[0] policy
     /* 2428002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428012 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2428015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2428033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428036 */     // GIR_Coverage, 45452,
     /* 2428036 */     GIR_EraseRootFromParent_Done,
     /* 2428037 */   // Label 35130: @2428037
     /* 2428037 */   GIM_Try, /*On fail goto*//*Label 35131*/ GIMT_Encode4(2428109), // Rule ID 45453 //
     /* 2428042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428074 */     // MIs[0] policy
     /* 2428074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428084 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2428087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2428105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428108 */     // GIR_Coverage, 45453,
     /* 2428108 */     GIR_EraseRootFromParent_Done,
     /* 2428109 */   // Label 35131: @2428109
     /* 2428109 */   GIM_Reject,
     /* 2428110 */ // Label 35127: @2428110
     /* 2428110 */ GIM_Reject,
     /* 2428111 */ // Label 35105: @2428111
     /* 2428111 */ GIM_Try, /*On fail goto*//*Label 35132*/ GIMT_Encode4(2428743),
     /* 2428116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2428119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2428122 */   GIM_Try, /*On fail goto*//*Label 35133*/ GIMT_Encode4(2428205), // Rule ID 45462 //
     /* 2428127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428163 */     // MIs[1] Operand 1
     /* 2428163 */     // No operand predicates
     /* 2428163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428167 */     // MIs[0] policy
     /* 2428167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428179 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2428182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428204 */     // GIR_Coverage, 45462,
     /* 2428204 */     GIR_EraseRootFromParent_Done,
     /* 2428205 */   // Label 35133: @2428205
     /* 2428205 */   GIM_Try, /*On fail goto*//*Label 35134*/ GIMT_Encode4(2428288), // Rule ID 45463 //
     /* 2428210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428246 */     // MIs[1] Operand 1
     /* 2428246 */     // No operand predicates
     /* 2428246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428250 */     // MIs[0] policy
     /* 2428250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428262 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2428265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428274 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428287 */     // GIR_Coverage, 45463,
     /* 2428287 */     GIR_EraseRootFromParent_Done,
     /* 2428288 */   // Label 35134: @2428288
     /* 2428288 */   GIM_Try, /*On fail goto*//*Label 35135*/ GIMT_Encode4(2428371), // Rule ID 45538 //
     /* 2428293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428329 */     // MIs[1] Operand 1
     /* 2428329 */     // No operand predicates
     /* 2428329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428333 */     // MIs[0] policy
     /* 2428333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428345 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2428348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428370 */     // GIR_Coverage, 45538,
     /* 2428370 */     GIR_EraseRootFromParent_Done,
     /* 2428371 */   // Label 35135: @2428371
     /* 2428371 */   GIM_Try, /*On fail goto*//*Label 35136*/ GIMT_Encode4(2428454), // Rule ID 45539 //
     /* 2428376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428412 */     // MIs[1] Operand 1
     /* 2428412 */     // No operand predicates
     /* 2428412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428416 */     // MIs[0] policy
     /* 2428416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428428 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2428431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428440 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428450 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428453 */     // GIR_Coverage, 45539,
     /* 2428453 */     GIR_EraseRootFromParent_Done,
     /* 2428454 */   // Label 35136: @2428454
     /* 2428454 */   GIM_Try, /*On fail goto*//*Label 35137*/ GIMT_Encode4(2428526), // Rule ID 45464 //
     /* 2428459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428491 */     // MIs[0] policy
     /* 2428491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428501 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2428504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428512 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428525 */     // GIR_Coverage, 45464,
     /* 2428525 */     GIR_EraseRootFromParent_Done,
     /* 2428526 */   // Label 35137: @2428526
     /* 2428526 */   GIM_Try, /*On fail goto*//*Label 35138*/ GIMT_Encode4(2428598), // Rule ID 45465 //
     /* 2428531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428563 */     // MIs[0] policy
     /* 2428563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428573 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2428576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428584 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428597 */     // GIR_Coverage, 45465,
     /* 2428597 */     GIR_EraseRootFromParent_Done,
     /* 2428598 */   // Label 35138: @2428598
     /* 2428598 */   GIM_Try, /*On fail goto*//*Label 35139*/ GIMT_Encode4(2428670), // Rule ID 45540 //
     /* 2428603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428635 */     // MIs[0] policy
     /* 2428635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428645 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2428648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428656 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428669 */     // GIR_Coverage, 45540,
     /* 2428669 */     GIR_EraseRootFromParent_Done,
     /* 2428670 */   // Label 35139: @2428670
     /* 2428670 */   GIM_Try, /*On fail goto*//*Label 35140*/ GIMT_Encode4(2428742), // Rule ID 45541 //
     /* 2428675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428707 */     // MIs[0] policy
     /* 2428707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428717 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2428720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428728 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428741 */     // GIR_Coverage, 45541,
     /* 2428741 */     GIR_EraseRootFromParent_Done,
     /* 2428742 */   // Label 35140: @2428742
     /* 2428742 */   GIM_Reject,
     /* 2428743 */ // Label 35132: @2428743
     /* 2428743 */ GIM_Reject,
     /* 2428744 */ // Label 35106: @2428744
     /* 2428744 */ GIM_Try, /*On fail goto*//*Label 35141*/ GIMT_Encode4(2429376),
     /* 2428749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2428752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2428755 */   GIM_Try, /*On fail goto*//*Label 35142*/ GIMT_Encode4(2428838), // Rule ID 45470 //
     /* 2428760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428796 */     // MIs[1] Operand 1
     /* 2428796 */     // No operand predicates
     /* 2428796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428800 */     // MIs[0] policy
     /* 2428800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428812 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2428815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428824 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428837 */     // GIR_Coverage, 45470,
     /* 2428837 */     GIR_EraseRootFromParent_Done,
     /* 2428838 */   // Label 35142: @2428838
     /* 2428838 */   GIM_Try, /*On fail goto*//*Label 35143*/ GIMT_Encode4(2428921), // Rule ID 45471 //
     /* 2428843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428879 */     // MIs[1] Operand 1
     /* 2428879 */     // No operand predicates
     /* 2428879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428883 */     // MIs[0] policy
     /* 2428883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428895 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2428898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428917 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428920 */     // GIR_Coverage, 45471,
     /* 2428920 */     GIR_EraseRootFromParent_Done,
     /* 2428921 */   // Label 35143: @2428921
     /* 2428921 */   GIM_Try, /*On fail goto*//*Label 35144*/ GIMT_Encode4(2429004), // Rule ID 45546 //
     /* 2428926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428962 */     // MIs[1] Operand 1
     /* 2428962 */     // No operand predicates
     /* 2428962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428966 */     // MIs[0] policy
     /* 2428966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428978 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2428981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428990 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429003 */     // GIR_Coverage, 45546,
     /* 2429003 */     GIR_EraseRootFromParent_Done,
     /* 2429004 */   // Label 35144: @2429004
     /* 2429004 */   GIM_Try, /*On fail goto*//*Label 35145*/ GIMT_Encode4(2429087), // Rule ID 45547 //
     /* 2429009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429045 */     // MIs[1] Operand 1
     /* 2429045 */     // No operand predicates
     /* 2429045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429049 */     // MIs[0] policy
     /* 2429049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429061 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2429064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429086 */     // GIR_Coverage, 45547,
     /* 2429086 */     GIR_EraseRootFromParent_Done,
     /* 2429087 */   // Label 35145: @2429087
     /* 2429087 */   GIM_Try, /*On fail goto*//*Label 35146*/ GIMT_Encode4(2429159), // Rule ID 45472 //
     /* 2429092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429124 */     // MIs[0] policy
     /* 2429124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429134 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2429137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429158 */     // GIR_Coverage, 45472,
     /* 2429158 */     GIR_EraseRootFromParent_Done,
     /* 2429159 */   // Label 35146: @2429159
     /* 2429159 */   GIM_Try, /*On fail goto*//*Label 35147*/ GIMT_Encode4(2429231), // Rule ID 45473 //
     /* 2429164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429196 */     // MIs[0] policy
     /* 2429196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429206 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2429209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429230 */     // GIR_Coverage, 45473,
     /* 2429230 */     GIR_EraseRootFromParent_Done,
     /* 2429231 */   // Label 35147: @2429231
     /* 2429231 */   GIM_Try, /*On fail goto*//*Label 35148*/ GIMT_Encode4(2429303), // Rule ID 45548 //
     /* 2429236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429268 */     // MIs[0] policy
     /* 2429268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429278 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2429281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429302 */     // GIR_Coverage, 45548,
     /* 2429302 */     GIR_EraseRootFromParent_Done,
     /* 2429303 */   // Label 35148: @2429303
     /* 2429303 */   GIM_Try, /*On fail goto*//*Label 35149*/ GIMT_Encode4(2429375), // Rule ID 45549 //
     /* 2429308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429340 */     // MIs[0] policy
     /* 2429340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429350 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2429353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429374 */     // GIR_Coverage, 45549,
     /* 2429374 */     GIR_EraseRootFromParent_Done,
     /* 2429375 */   // Label 35149: @2429375
     /* 2429375 */   GIM_Reject,
     /* 2429376 */ // Label 35141: @2429376
     /* 2429376 */ GIM_Reject,
     /* 2429377 */ // Label 35107: @2429377
     /* 2429377 */ GIM_Try, /*On fail goto*//*Label 35150*/ GIMT_Encode4(2430009),
     /* 2429382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2429385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2429388 */   GIM_Try, /*On fail goto*//*Label 35151*/ GIMT_Encode4(2429471), // Rule ID 45486 //
     /* 2429393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429429 */     // MIs[1] Operand 1
     /* 2429429 */     // No operand predicates
     /* 2429429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429433 */     // MIs[0] policy
     /* 2429433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429445 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2429448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429470 */     // GIR_Coverage, 45486,
     /* 2429470 */     GIR_EraseRootFromParent_Done,
     /* 2429471 */   // Label 35151: @2429471
     /* 2429471 */   GIM_Try, /*On fail goto*//*Label 35152*/ GIMT_Encode4(2429554), // Rule ID 45487 //
     /* 2429476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429512 */     // MIs[1] Operand 1
     /* 2429512 */     // No operand predicates
     /* 2429512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429516 */     // MIs[0] policy
     /* 2429516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429528 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2429531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429540 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429553 */     // GIR_Coverage, 45487,
     /* 2429553 */     GIR_EraseRootFromParent_Done,
     /* 2429554 */   // Label 35152: @2429554
     /* 2429554 */   GIM_Try, /*On fail goto*//*Label 35153*/ GIMT_Encode4(2429637), // Rule ID 45558 //
     /* 2429559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429595 */     // MIs[1] Operand 1
     /* 2429595 */     // No operand predicates
     /* 2429595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429599 */     // MIs[0] policy
     /* 2429599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429611 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2429614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429636 */     // GIR_Coverage, 45558,
     /* 2429636 */     GIR_EraseRootFromParent_Done,
     /* 2429637 */   // Label 35153: @2429637
     /* 2429637 */   GIM_Try, /*On fail goto*//*Label 35154*/ GIMT_Encode4(2429720), // Rule ID 45559 //
     /* 2429642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429678 */     // MIs[1] Operand 1
     /* 2429678 */     // No operand predicates
     /* 2429678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429682 */     // MIs[0] policy
     /* 2429682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429694 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2429697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429706 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429719 */     // GIR_Coverage, 45559,
     /* 2429719 */     GIR_EraseRootFromParent_Done,
     /* 2429720 */   // Label 35154: @2429720
     /* 2429720 */   GIM_Try, /*On fail goto*//*Label 35155*/ GIMT_Encode4(2429792), // Rule ID 45488 //
     /* 2429725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429757 */     // MIs[0] policy
     /* 2429757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429767 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2429770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429778 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429791 */     // GIR_Coverage, 45488,
     /* 2429791 */     GIR_EraseRootFromParent_Done,
     /* 2429792 */   // Label 35155: @2429792
     /* 2429792 */   GIM_Try, /*On fail goto*//*Label 35156*/ GIMT_Encode4(2429864), // Rule ID 45489 //
     /* 2429797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429829 */     // MIs[0] policy
     /* 2429829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429839 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2429842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429850 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429863 */     // GIR_Coverage, 45489,
     /* 2429863 */     GIR_EraseRootFromParent_Done,
     /* 2429864 */   // Label 35156: @2429864
     /* 2429864 */   GIM_Try, /*On fail goto*//*Label 35157*/ GIMT_Encode4(2429936), // Rule ID 45560 //
     /* 2429869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429901 */     // MIs[0] policy
     /* 2429901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429911 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2429914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429922 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429935 */     // GIR_Coverage, 45560,
     /* 2429935 */     GIR_EraseRootFromParent_Done,
     /* 2429936 */   // Label 35157: @2429936
     /* 2429936 */   GIM_Try, /*On fail goto*//*Label 35158*/ GIMT_Encode4(2430008), // Rule ID 45561 //
     /* 2429941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429973 */     // MIs[0] policy
     /* 2429973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429983 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2429986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429994 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430007 */     // GIR_Coverage, 45561,
     /* 2430007 */     GIR_EraseRootFromParent_Done,
     /* 2430008 */   // Label 35158: @2430008
     /* 2430008 */   GIM_Reject,
     /* 2430009 */ // Label 35150: @2430009
     /* 2430009 */ GIM_Reject,
     /* 2430010 */ // Label 35108: @2430010
     /* 2430010 */ GIM_Try, /*On fail goto*//*Label 35159*/ GIMT_Encode4(2430332),
     /* 2430015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2430018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2430021 */   GIM_Try, /*On fail goto*//*Label 35160*/ GIMT_Encode4(2430104), // Rule ID 45454 //
     /* 2430026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430062 */     // MIs[1] Operand 1
     /* 2430062 */     // No operand predicates
     /* 2430062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430066 */     // MIs[0] policy
     /* 2430066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430078 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2430081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430090 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430103 */     // GIR_Coverage, 45454,
     /* 2430103 */     GIR_EraseRootFromParent_Done,
     /* 2430104 */   // Label 35160: @2430104
     /* 2430104 */   GIM_Try, /*On fail goto*//*Label 35161*/ GIMT_Encode4(2430187), // Rule ID 45455 //
     /* 2430109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430145 */     // MIs[1] Operand 1
     /* 2430145 */     // No operand predicates
     /* 2430145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430149 */     // MIs[0] policy
     /* 2430149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430161 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2430164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430186 */     // GIR_Coverage, 45455,
     /* 2430186 */     GIR_EraseRootFromParent_Done,
     /* 2430187 */   // Label 35161: @2430187
     /* 2430187 */   GIM_Try, /*On fail goto*//*Label 35162*/ GIMT_Encode4(2430259), // Rule ID 45456 //
     /* 2430192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430224 */     // MIs[0] policy
     /* 2430224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430234 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2430237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430258 */     // GIR_Coverage, 45456,
     /* 2430258 */     GIR_EraseRootFromParent_Done,
     /* 2430259 */   // Label 35162: @2430259
     /* 2430259 */   GIM_Try, /*On fail goto*//*Label 35163*/ GIMT_Encode4(2430331), // Rule ID 45457 //
     /* 2430264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430296 */     // MIs[0] policy
     /* 2430296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430306 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2430309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430330 */     // GIR_Coverage, 45457,
     /* 2430330 */     GIR_EraseRootFromParent_Done,
     /* 2430331 */   // Label 35163: @2430331
     /* 2430331 */   GIM_Reject,
     /* 2430332 */ // Label 35159: @2430332
     /* 2430332 */ GIM_Reject,
     /* 2430333 */ // Label 35109: @2430333
     /* 2430333 */ GIM_Try, /*On fail goto*//*Label 35164*/ GIMT_Encode4(2430965),
     /* 2430338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2430341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2430344 */   GIM_Try, /*On fail goto*//*Label 35165*/ GIMT_Encode4(2430427), // Rule ID 45466 //
     /* 2430349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430385 */     // MIs[1] Operand 1
     /* 2430385 */     // No operand predicates
     /* 2430385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430389 */     // MIs[0] policy
     /* 2430389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430401 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2430404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430426 */     // GIR_Coverage, 45466,
     /* 2430426 */     GIR_EraseRootFromParent_Done,
     /* 2430427 */   // Label 35165: @2430427
     /* 2430427 */   GIM_Try, /*On fail goto*//*Label 35166*/ GIMT_Encode4(2430510), // Rule ID 45467 //
     /* 2430432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430464 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430468 */     // MIs[1] Operand 1
     /* 2430468 */     // No operand predicates
     /* 2430468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430472 */     // MIs[0] policy
     /* 2430472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430484 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2430487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430496 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430509 */     // GIR_Coverage, 45467,
     /* 2430509 */     GIR_EraseRootFromParent_Done,
     /* 2430510 */   // Label 35166: @2430510
     /* 2430510 */   GIM_Try, /*On fail goto*//*Label 35167*/ GIMT_Encode4(2430593), // Rule ID 45542 //
     /* 2430515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430551 */     // MIs[1] Operand 1
     /* 2430551 */     // No operand predicates
     /* 2430551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430555 */     // MIs[0] policy
     /* 2430555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430567 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2430570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430579 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430592 */     // GIR_Coverage, 45542,
     /* 2430592 */     GIR_EraseRootFromParent_Done,
     /* 2430593 */   // Label 35167: @2430593
     /* 2430593 */   GIM_Try, /*On fail goto*//*Label 35168*/ GIMT_Encode4(2430676), // Rule ID 45543 //
     /* 2430598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430634 */     // MIs[1] Operand 1
     /* 2430634 */     // No operand predicates
     /* 2430634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430638 */     // MIs[0] policy
     /* 2430638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430650 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2430653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430662 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430675 */     // GIR_Coverage, 45543,
     /* 2430675 */     GIR_EraseRootFromParent_Done,
     /* 2430676 */   // Label 35168: @2430676
     /* 2430676 */   GIM_Try, /*On fail goto*//*Label 35169*/ GIMT_Encode4(2430748), // Rule ID 45468 //
     /* 2430681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430713 */     // MIs[0] policy
     /* 2430713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430723 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2430726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430734 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430747 */     // GIR_Coverage, 45468,
     /* 2430747 */     GIR_EraseRootFromParent_Done,
     /* 2430748 */   // Label 35169: @2430748
     /* 2430748 */   GIM_Try, /*On fail goto*//*Label 35170*/ GIMT_Encode4(2430820), // Rule ID 45469 //
     /* 2430753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430785 */     // MIs[0] policy
     /* 2430785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430795 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2430798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430806 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430819 */     // GIR_Coverage, 45469,
     /* 2430819 */     GIR_EraseRootFromParent_Done,
     /* 2430820 */   // Label 35170: @2430820
     /* 2430820 */   GIM_Try, /*On fail goto*//*Label 35171*/ GIMT_Encode4(2430892), // Rule ID 45544 //
     /* 2430825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430857 */     // MIs[0] policy
     /* 2430857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430867 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2430870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430878 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430891 */     // GIR_Coverage, 45544,
     /* 2430891 */     GIR_EraseRootFromParent_Done,
     /* 2430892 */   // Label 35171: @2430892
     /* 2430892 */   GIM_Try, /*On fail goto*//*Label 35172*/ GIMT_Encode4(2430964), // Rule ID 45545 //
     /* 2430897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430929 */     // MIs[0] policy
     /* 2430929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430939 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2430942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430950 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430963 */     // GIR_Coverage, 45545,
     /* 2430963 */     GIR_EraseRootFromParent_Done,
     /* 2430964 */   // Label 35172: @2430964
     /* 2430964 */   GIM_Reject,
     /* 2430965 */ // Label 35164: @2430965
     /* 2430965 */ GIM_Reject,
     /* 2430966 */ // Label 35110: @2430966
     /* 2430966 */ GIM_Try, /*On fail goto*//*Label 35173*/ GIMT_Encode4(2431598),
     /* 2430971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2430974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2430977 */   GIM_Try, /*On fail goto*//*Label 35174*/ GIMT_Encode4(2431060), // Rule ID 45482 //
     /* 2430982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431018 */     // MIs[1] Operand 1
     /* 2431018 */     // No operand predicates
     /* 2431018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431022 */     // MIs[0] policy
     /* 2431022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431034 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2431037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431046 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431059 */     // GIR_Coverage, 45482,
     /* 2431059 */     GIR_EraseRootFromParent_Done,
     /* 2431060 */   // Label 35174: @2431060
     /* 2431060 */   GIM_Try, /*On fail goto*//*Label 35175*/ GIMT_Encode4(2431143), // Rule ID 45483 //
     /* 2431065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431101 */     // MIs[1] Operand 1
     /* 2431101 */     // No operand predicates
     /* 2431101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431105 */     // MIs[0] policy
     /* 2431105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431117 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2431120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431142 */     // GIR_Coverage, 45483,
     /* 2431142 */     GIR_EraseRootFromParent_Done,
     /* 2431143 */   // Label 35175: @2431143
     /* 2431143 */   GIM_Try, /*On fail goto*//*Label 35176*/ GIMT_Encode4(2431226), // Rule ID 45554 //
     /* 2431148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431184 */     // MIs[1] Operand 1
     /* 2431184 */     // No operand predicates
     /* 2431184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431188 */     // MIs[0] policy
     /* 2431188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431200 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2431203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431225 */     // GIR_Coverage, 45554,
     /* 2431225 */     GIR_EraseRootFromParent_Done,
     /* 2431226 */   // Label 35176: @2431226
     /* 2431226 */   GIM_Try, /*On fail goto*//*Label 35177*/ GIMT_Encode4(2431309), // Rule ID 45555 //
     /* 2431231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431267 */     // MIs[1] Operand 1
     /* 2431267 */     // No operand predicates
     /* 2431267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431271 */     // MIs[0] policy
     /* 2431271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431283 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2431286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431305 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431308 */     // GIR_Coverage, 45555,
     /* 2431308 */     GIR_EraseRootFromParent_Done,
     /* 2431309 */   // Label 35177: @2431309
     /* 2431309 */   GIM_Try, /*On fail goto*//*Label 35178*/ GIMT_Encode4(2431381), // Rule ID 45484 //
     /* 2431314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431346 */     // MIs[0] policy
     /* 2431346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431356 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2431359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431377 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431380 */     // GIR_Coverage, 45484,
     /* 2431380 */     GIR_EraseRootFromParent_Done,
     /* 2431381 */   // Label 35178: @2431381
     /* 2431381 */   GIM_Try, /*On fail goto*//*Label 35179*/ GIMT_Encode4(2431453), // Rule ID 45485 //
     /* 2431386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431418 */     // MIs[0] policy
     /* 2431418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431428 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2431431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431452 */     // GIR_Coverage, 45485,
     /* 2431452 */     GIR_EraseRootFromParent_Done,
     /* 2431453 */   // Label 35179: @2431453
     /* 2431453 */   GIM_Try, /*On fail goto*//*Label 35180*/ GIMT_Encode4(2431525), // Rule ID 45556 //
     /* 2431458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431490 */     // MIs[0] policy
     /* 2431490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431500 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2431503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431524 */     // GIR_Coverage, 45556,
     /* 2431524 */     GIR_EraseRootFromParent_Done,
     /* 2431525 */   // Label 35180: @2431525
     /* 2431525 */   GIM_Try, /*On fail goto*//*Label 35181*/ GIMT_Encode4(2431597), // Rule ID 45557 //
     /* 2431530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431562 */     // MIs[0] policy
     /* 2431562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431572 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2431575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431596 */     // GIR_Coverage, 45557,
     /* 2431596 */     GIR_EraseRootFromParent_Done,
     /* 2431597 */   // Label 35181: @2431597
     /* 2431597 */   GIM_Reject,
     /* 2431598 */ // Label 35173: @2431598
     /* 2431598 */ GIM_Reject,
     /* 2431599 */ // Label 35111: @2431599
     /* 2431599 */ GIM_Try, /*On fail goto*//*Label 35182*/ GIMT_Encode4(2432231),
     /* 2431604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2431607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2431610 */   GIM_Try, /*On fail goto*//*Label 35183*/ GIMT_Encode4(2431693), // Rule ID 45526 //
     /* 2431615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431651 */     // MIs[1] Operand 1
     /* 2431651 */     // No operand predicates
     /* 2431651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431655 */     // MIs[0] policy
     /* 2431655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431667 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2431670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431692 */     // GIR_Coverage, 45526,
     /* 2431692 */     GIR_EraseRootFromParent_Done,
     /* 2431693 */   // Label 35183: @2431693
     /* 2431693 */   GIM_Try, /*On fail goto*//*Label 35184*/ GIMT_Encode4(2431776), // Rule ID 45527 //
     /* 2431698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431734 */     // MIs[1] Operand 1
     /* 2431734 */     // No operand predicates
     /* 2431734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431738 */     // MIs[0] policy
     /* 2431738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431750 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2431753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431762 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431775 */     // GIR_Coverage, 45527,
     /* 2431775 */     GIR_EraseRootFromParent_Done,
     /* 2431776 */   // Label 35184: @2431776
     /* 2431776 */   GIM_Try, /*On fail goto*//*Label 35185*/ GIMT_Encode4(2431859), // Rule ID 45586 //
     /* 2431781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431817 */     // MIs[1] Operand 1
     /* 2431817 */     // No operand predicates
     /* 2431817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431821 */     // MIs[0] policy
     /* 2431821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431833 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2431836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431858 */     // GIR_Coverage, 45586,
     /* 2431858 */     GIR_EraseRootFromParent_Done,
     /* 2431859 */   // Label 35185: @2431859
     /* 2431859 */   GIM_Try, /*On fail goto*//*Label 35186*/ GIMT_Encode4(2431942), // Rule ID 45587 //
     /* 2431864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431900 */     // MIs[1] Operand 1
     /* 2431900 */     // No operand predicates
     /* 2431900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431904 */     // MIs[0] policy
     /* 2431904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431916 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2431919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431928 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431941 */     // GIR_Coverage, 45587,
     /* 2431941 */     GIR_EraseRootFromParent_Done,
     /* 2431942 */   // Label 35186: @2431942
     /* 2431942 */   GIM_Try, /*On fail goto*//*Label 35187*/ GIMT_Encode4(2432014), // Rule ID 45528 //
     /* 2431947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431979 */     // MIs[0] policy
     /* 2431979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431989 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2431992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432000 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432013 */     // GIR_Coverage, 45528,
     /* 2432013 */     GIR_EraseRootFromParent_Done,
     /* 2432014 */   // Label 35187: @2432014
     /* 2432014 */   GIM_Try, /*On fail goto*//*Label 35188*/ GIMT_Encode4(2432086), // Rule ID 45529 //
     /* 2432019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2432022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432051 */     // MIs[0] policy
     /* 2432051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432061 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2432064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432072 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432085 */     // GIR_Coverage, 45529,
     /* 2432085 */     GIR_EraseRootFromParent_Done,
     /* 2432086 */   // Label 35188: @2432086
     /* 2432086 */   GIM_Try, /*On fail goto*//*Label 35189*/ GIMT_Encode4(2432158), // Rule ID 45588 //
     /* 2432091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2432094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432123 */     // MIs[0] policy
     /* 2432123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432133 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2432136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432144 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432157 */     // GIR_Coverage, 45588,
     /* 2432157 */     GIR_EraseRootFromParent_Done,
     /* 2432158 */   // Label 35189: @2432158
     /* 2432158 */   GIM_Try, /*On fail goto*//*Label 35190*/ GIMT_Encode4(2432230), // Rule ID 45589 //
     /* 2432163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2432166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432195 */     // MIs[0] policy
     /* 2432195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432205 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2432208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432229 */     // GIR_Coverage, 45589,
     /* 2432229 */     GIR_EraseRootFromParent_Done,
     /* 2432230 */   // Label 35190: @2432230
     /* 2432230 */   GIM_Reject,
     /* 2432231 */ // Label 35182: @2432231
     /* 2432231 */ GIM_Reject,
     /* 2432232 */ // Label 35112: @2432232
     /* 2432232 */ GIM_Try, /*On fail goto*//*Label 35191*/ GIMT_Encode4(2432554),
     /* 2432237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2432240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2432243 */   GIM_Try, /*On fail goto*//*Label 35192*/ GIMT_Encode4(2432326), // Rule ID 45458 //
     /* 2432248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432284 */     // MIs[1] Operand 1
     /* 2432284 */     // No operand predicates
     /* 2432284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432288 */     // MIs[0] policy
     /* 2432288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432300 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2432303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432312 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432325 */     // GIR_Coverage, 45458,
     /* 2432325 */     GIR_EraseRootFromParent_Done,
     /* 2432326 */   // Label 35192: @2432326
     /* 2432326 */   GIM_Try, /*On fail goto*//*Label 35193*/ GIMT_Encode4(2432409), // Rule ID 45459 //
     /* 2432331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432367 */     // MIs[1] Operand 1
     /* 2432367 */     // No operand predicates
     /* 2432367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432371 */     // MIs[0] policy
     /* 2432371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432383 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2432386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432408 */     // GIR_Coverage, 45459,
     /* 2432408 */     GIR_EraseRootFromParent_Done,
     /* 2432409 */   // Label 35193: @2432409
     /* 2432409 */   GIM_Try, /*On fail goto*//*Label 35194*/ GIMT_Encode4(2432481), // Rule ID 45460 //
     /* 2432414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432446 */     // MIs[0] policy
     /* 2432446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432456 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2432459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432480 */     // GIR_Coverage, 45460,
     /* 2432480 */     GIR_EraseRootFromParent_Done,
     /* 2432481 */   // Label 35194: @2432481
     /* 2432481 */   GIM_Try, /*On fail goto*//*Label 35195*/ GIMT_Encode4(2432553), // Rule ID 45461 //
     /* 2432486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432518 */     // MIs[0] policy
     /* 2432518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432528 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2432531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432552 */     // GIR_Coverage, 45461,
     /* 2432552 */     GIR_EraseRootFromParent_Done,
     /* 2432553 */   // Label 35195: @2432553
     /* 2432553 */   GIM_Reject,
     /* 2432554 */ // Label 35191: @2432554
     /* 2432554 */ GIM_Reject,
     /* 2432555 */ // Label 35113: @2432555
     /* 2432555 */ GIM_Try, /*On fail goto*//*Label 35196*/ GIMT_Encode4(2433187),
     /* 2432560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2432563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2432566 */   GIM_Try, /*On fail goto*//*Label 35197*/ GIMT_Encode4(2432649), // Rule ID 45478 //
     /* 2432571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432607 */     // MIs[1] Operand 1
     /* 2432607 */     // No operand predicates
     /* 2432607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432611 */     // MIs[0] policy
     /* 2432611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432623 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2432626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432648 */     // GIR_Coverage, 45478,
     /* 2432648 */     GIR_EraseRootFromParent_Done,
     /* 2432649 */   // Label 35197: @2432649
     /* 2432649 */   GIM_Try, /*On fail goto*//*Label 35198*/ GIMT_Encode4(2432732), // Rule ID 45479 //
     /* 2432654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432690 */     // MIs[1] Operand 1
     /* 2432690 */     // No operand predicates
     /* 2432690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432694 */     // MIs[0] policy
     /* 2432694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432706 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2432709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432718 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432731 */     // GIR_Coverage, 45479,
     /* 2432731 */     GIR_EraseRootFromParent_Done,
     /* 2432732 */   // Label 35198: @2432732
     /* 2432732 */   GIM_Try, /*On fail goto*//*Label 35199*/ GIMT_Encode4(2432815), // Rule ID 45550 //
     /* 2432737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432773 */     // MIs[1] Operand 1
     /* 2432773 */     // No operand predicates
     /* 2432773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432777 */     // MIs[0] policy
     /* 2432777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432789 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2432792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432814 */     // GIR_Coverage, 45550,
     /* 2432814 */     GIR_EraseRootFromParent_Done,
     /* 2432815 */   // Label 35199: @2432815
     /* 2432815 */   GIM_Try, /*On fail goto*//*Label 35200*/ GIMT_Encode4(2432898), // Rule ID 45551 //
     /* 2432820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432856 */     // MIs[1] Operand 1
     /* 2432856 */     // No operand predicates
     /* 2432856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432860 */     // MIs[0] policy
     /* 2432860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432872 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2432875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432884 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432897 */     // GIR_Coverage, 45551,
     /* 2432897 */     GIR_EraseRootFromParent_Done,
     /* 2432898 */   // Label 35200: @2432898
     /* 2432898 */   GIM_Try, /*On fail goto*//*Label 35201*/ GIMT_Encode4(2432970), // Rule ID 45480 //
     /* 2432903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432935 */     // MIs[0] policy
     /* 2432935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432945 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2432948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432956 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432969 */     // GIR_Coverage, 45480,
     /* 2432969 */     GIR_EraseRootFromParent_Done,
     /* 2432970 */   // Label 35201: @2432970
     /* 2432970 */   GIM_Try, /*On fail goto*//*Label 35202*/ GIMT_Encode4(2433042), // Rule ID 45481 //
     /* 2432975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433007 */     // MIs[0] policy
     /* 2433007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433017 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2433020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433028 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433041 */     // GIR_Coverage, 45481,
     /* 2433041 */     GIR_EraseRootFromParent_Done,
     /* 2433042 */   // Label 35202: @2433042
     /* 2433042 */   GIM_Try, /*On fail goto*//*Label 35203*/ GIMT_Encode4(2433114), // Rule ID 45552 //
     /* 2433047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433079 */     // MIs[0] policy
     /* 2433079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433089 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2433092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433113 */     // GIR_Coverage, 45552,
     /* 2433113 */     GIR_EraseRootFromParent_Done,
     /* 2433114 */   // Label 35203: @2433114
     /* 2433114 */   GIM_Try, /*On fail goto*//*Label 35204*/ GIMT_Encode4(2433186), // Rule ID 45553 //
     /* 2433119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433151 */     // MIs[0] policy
     /* 2433151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433161 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2433164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433185 */     // GIR_Coverage, 45553,
     /* 2433185 */     GIR_EraseRootFromParent_Done,
     /* 2433186 */   // Label 35204: @2433186
     /* 2433186 */   GIM_Reject,
     /* 2433187 */ // Label 35196: @2433187
     /* 2433187 */ GIM_Reject,
     /* 2433188 */ // Label 35114: @2433188
     /* 2433188 */ GIM_Try, /*On fail goto*//*Label 35205*/ GIMT_Encode4(2433820),
     /* 2433193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2433196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2433199 */   GIM_Try, /*On fail goto*//*Label 35206*/ GIMT_Encode4(2433282), // Rule ID 45514 //
     /* 2433204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433240 */     // MIs[1] Operand 1
     /* 2433240 */     // No operand predicates
     /* 2433240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433244 */     // MIs[0] policy
     /* 2433244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433256 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2433259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433268 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433281 */     // GIR_Coverage, 45514,
     /* 2433281 */     GIR_EraseRootFromParent_Done,
     /* 2433282 */   // Label 35206: @2433282
     /* 2433282 */   GIM_Try, /*On fail goto*//*Label 35207*/ GIMT_Encode4(2433365), // Rule ID 45515 //
     /* 2433287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433323 */     // MIs[1] Operand 1
     /* 2433323 */     // No operand predicates
     /* 2433323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433327 */     // MIs[0] policy
     /* 2433327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433339 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2433342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433364 */     // GIR_Coverage, 45515,
     /* 2433364 */     GIR_EraseRootFromParent_Done,
     /* 2433365 */   // Label 35207: @2433365
     /* 2433365 */   GIM_Try, /*On fail goto*//*Label 35208*/ GIMT_Encode4(2433448), // Rule ID 45574 //
     /* 2433370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433406 */     // MIs[1] Operand 1
     /* 2433406 */     // No operand predicates
     /* 2433406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433410 */     // MIs[0] policy
     /* 2433410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433422 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2433425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433434 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433447 */     // GIR_Coverage, 45574,
     /* 2433447 */     GIR_EraseRootFromParent_Done,
     /* 2433448 */   // Label 35208: @2433448
     /* 2433448 */   GIM_Try, /*On fail goto*//*Label 35209*/ GIMT_Encode4(2433531), // Rule ID 45575 //
     /* 2433453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433489 */     // MIs[1] Operand 1
     /* 2433489 */     // No operand predicates
     /* 2433489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433493 */     // MIs[0] policy
     /* 2433493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433505 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2433508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433527 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433530 */     // GIR_Coverage, 45575,
     /* 2433530 */     GIR_EraseRootFromParent_Done,
     /* 2433531 */   // Label 35209: @2433531
     /* 2433531 */   GIM_Try, /*On fail goto*//*Label 35210*/ GIMT_Encode4(2433603), // Rule ID 45516 //
     /* 2433536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433568 */     // MIs[0] policy
     /* 2433568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433578 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2433581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433602 */     // GIR_Coverage, 45516,
     /* 2433602 */     GIR_EraseRootFromParent_Done,
     /* 2433603 */   // Label 35210: @2433603
     /* 2433603 */   GIM_Try, /*On fail goto*//*Label 35211*/ GIMT_Encode4(2433675), // Rule ID 45517 //
     /* 2433608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433640 */     // MIs[0] policy
     /* 2433640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433650 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2433653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433674 */     // GIR_Coverage, 45517,
     /* 2433674 */     GIR_EraseRootFromParent_Done,
     /* 2433675 */   // Label 35211: @2433675
     /* 2433675 */   GIM_Try, /*On fail goto*//*Label 35212*/ GIMT_Encode4(2433747), // Rule ID 45576 //
     /* 2433680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433712 */     // MIs[0] policy
     /* 2433712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433722 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2433725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433733 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433746 */     // GIR_Coverage, 45576,
     /* 2433746 */     GIR_EraseRootFromParent_Done,
     /* 2433747 */   // Label 35212: @2433747
     /* 2433747 */   GIM_Try, /*On fail goto*//*Label 35213*/ GIMT_Encode4(2433819), // Rule ID 45577 //
     /* 2433752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433784 */     // MIs[0] policy
     /* 2433784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433794 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2433797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433818 */     // GIR_Coverage, 45577,
     /* 2433818 */     GIR_EraseRootFromParent_Done,
     /* 2433819 */   // Label 35213: @2433819
     /* 2433819 */   GIM_Reject,
     /* 2433820 */ // Label 35205: @2433820
     /* 2433820 */ GIM_Reject,
     /* 2433821 */ // Label 35115: @2433821
     /* 2433821 */ GIM_Try, /*On fail goto*//*Label 35214*/ GIMT_Encode4(2434453),
     /* 2433826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2433829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2433832 */   GIM_Try, /*On fail goto*//*Label 35215*/ GIMT_Encode4(2433915), // Rule ID 45530 //
     /* 2433837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2433840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433873 */     // MIs[1] Operand 1
     /* 2433873 */     // No operand predicates
     /* 2433873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433877 */     // MIs[0] policy
     /* 2433877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433889 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2433892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433914 */     // GIR_Coverage, 45530,
     /* 2433914 */     GIR_EraseRootFromParent_Done,
     /* 2433915 */   // Label 35215: @2433915
     /* 2433915 */   GIM_Try, /*On fail goto*//*Label 35216*/ GIMT_Encode4(2433998), // Rule ID 45531 //
     /* 2433920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2433923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433956 */     // MIs[1] Operand 1
     /* 2433956 */     // No operand predicates
     /* 2433956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433960 */     // MIs[0] policy
     /* 2433960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433972 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2433975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433984 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433994 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433997 */     // GIR_Coverage, 45531,
     /* 2433997 */     GIR_EraseRootFromParent_Done,
     /* 2433998 */   // Label 35216: @2433998
     /* 2433998 */   GIM_Try, /*On fail goto*//*Label 35217*/ GIMT_Encode4(2434081), // Rule ID 45590 //
     /* 2434003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2434006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434039 */     // MIs[1] Operand 1
     /* 2434039 */     // No operand predicates
     /* 2434039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434043 */     // MIs[0] policy
     /* 2434043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434055 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2434058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434080 */     // GIR_Coverage, 45590,
     /* 2434080 */     GIR_EraseRootFromParent_Done,
     /* 2434081 */   // Label 35217: @2434081
     /* 2434081 */   GIM_Try, /*On fail goto*//*Label 35218*/ GIMT_Encode4(2434164), // Rule ID 45591 //
     /* 2434086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2434089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434122 */     // MIs[1] Operand 1
     /* 2434122 */     // No operand predicates
     /* 2434122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434126 */     // MIs[0] policy
     /* 2434126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434138 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2434141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434150 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434163 */     // GIR_Coverage, 45591,
     /* 2434163 */     GIR_EraseRootFromParent_Done,
     /* 2434164 */   // Label 35218: @2434164
     /* 2434164 */   GIM_Try, /*On fail goto*//*Label 35219*/ GIMT_Encode4(2434236), // Rule ID 45532 //
     /* 2434169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2434172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434201 */     // MIs[0] policy
     /* 2434201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434211 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2434214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434222 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434235 */     // GIR_Coverage, 45532,
     /* 2434235 */     GIR_EraseRootFromParent_Done,
     /* 2434236 */   // Label 35219: @2434236
     /* 2434236 */   GIM_Try, /*On fail goto*//*Label 35220*/ GIMT_Encode4(2434308), // Rule ID 45533 //
     /* 2434241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2434244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434273 */     // MIs[0] policy
     /* 2434273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434283 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2434286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434294 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434307 */     // GIR_Coverage, 45533,
     /* 2434307 */     GIR_EraseRootFromParent_Done,
     /* 2434308 */   // Label 35220: @2434308
     /* 2434308 */   GIM_Try, /*On fail goto*//*Label 35221*/ GIMT_Encode4(2434380), // Rule ID 45592 //
     /* 2434313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2434316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434345 */     // MIs[0] policy
     /* 2434345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434355 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2434358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434379 */     // GIR_Coverage, 45592,
     /* 2434379 */     GIR_EraseRootFromParent_Done,
     /* 2434380 */   // Label 35221: @2434380
     /* 2434380 */   GIM_Try, /*On fail goto*//*Label 35222*/ GIMT_Encode4(2434452), // Rule ID 45593 //
     /* 2434385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2434388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434417 */     // MIs[0] policy
     /* 2434417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434427 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2434430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434438 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434451 */     // GIR_Coverage, 45593,
     /* 2434451 */     GIR_EraseRootFromParent_Done,
     /* 2434452 */   // Label 35222: @2434452
     /* 2434452 */   GIM_Reject,
     /* 2434453 */ // Label 35214: @2434453
     /* 2434453 */ GIM_Reject,
     /* 2434454 */ // Label 35116: @2434454
     /* 2434454 */ GIM_Try, /*On fail goto*//*Label 35223*/ GIMT_Encode4(2434776),
     /* 2434459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2434462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2434465 */   GIM_Try, /*On fail goto*//*Label 35224*/ GIMT_Encode4(2434548), // Rule ID 45474 //
     /* 2434470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434502 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434506 */     // MIs[1] Operand 1
     /* 2434506 */     // No operand predicates
     /* 2434506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434510 */     // MIs[0] policy
     /* 2434510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434522 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2434525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434534 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434547 */     // GIR_Coverage, 45474,
     /* 2434547 */     GIR_EraseRootFromParent_Done,
     /* 2434548 */   // Label 35224: @2434548
     /* 2434548 */   GIM_Try, /*On fail goto*//*Label 35225*/ GIMT_Encode4(2434631), // Rule ID 45475 //
     /* 2434553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434589 */     // MIs[1] Operand 1
     /* 2434589 */     // No operand predicates
     /* 2434589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434593 */     // MIs[0] policy
     /* 2434593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434605 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2434608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434630 */     // GIR_Coverage, 45475,
     /* 2434630 */     GIR_EraseRootFromParent_Done,
     /* 2434631 */   // Label 35225: @2434631
     /* 2434631 */   GIM_Try, /*On fail goto*//*Label 35226*/ GIMT_Encode4(2434703), // Rule ID 45476 //
     /* 2434636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434668 */     // MIs[0] policy
     /* 2434668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434678 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2434681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434702 */     // GIR_Coverage, 45476,
     /* 2434702 */     GIR_EraseRootFromParent_Done,
     /* 2434703 */   // Label 35226: @2434703
     /* 2434703 */   GIM_Try, /*On fail goto*//*Label 35227*/ GIMT_Encode4(2434775), // Rule ID 45477 //
     /* 2434708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434740 */     // MIs[0] policy
     /* 2434740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434750 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2434753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434774 */     // GIR_Coverage, 45477,
     /* 2434774 */     GIR_EraseRootFromParent_Done,
     /* 2434775 */   // Label 35227: @2434775
     /* 2434775 */   GIM_Reject,
     /* 2434776 */ // Label 35223: @2434776
     /* 2434776 */ GIM_Reject,
     /* 2434777 */ // Label 35117: @2434777
     /* 2434777 */ GIM_Try, /*On fail goto*//*Label 35228*/ GIMT_Encode4(2435409),
     /* 2434782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2434785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2434788 */   GIM_Try, /*On fail goto*//*Label 35229*/ GIMT_Encode4(2434871), // Rule ID 45502 //
     /* 2434793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2434809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434829 */     // MIs[1] Operand 1
     /* 2434829 */     // No operand predicates
     /* 2434829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434833 */     // MIs[0] policy
     /* 2434833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434845 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2434848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434870 */     // GIR_Coverage, 45502,
     /* 2434870 */     GIR_EraseRootFromParent_Done,
     /* 2434871 */   // Label 35229: @2434871
     /* 2434871 */   GIM_Try, /*On fail goto*//*Label 35230*/ GIMT_Encode4(2434954), // Rule ID 45503 //
     /* 2434876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2434892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434912 */     // MIs[1] Operand 1
     /* 2434912 */     // No operand predicates
     /* 2434912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434916 */     // MIs[0] policy
     /* 2434916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434928 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2434931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434953 */     // GIR_Coverage, 45503,
     /* 2434953 */     GIR_EraseRootFromParent_Done,
     /* 2434954 */   // Label 35230: @2434954
     /* 2434954 */   GIM_Try, /*On fail goto*//*Label 35231*/ GIMT_Encode4(2435037), // Rule ID 45562 //
     /* 2434959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2434975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434995 */     // MIs[1] Operand 1
     /* 2434995 */     // No operand predicates
     /* 2434995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434999 */     // MIs[0] policy
     /* 2434999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435011 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2435014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435036 */     // GIR_Coverage, 45562,
     /* 2435036 */     GIR_EraseRootFromParent_Done,
     /* 2435037 */   // Label 35231: @2435037
     /* 2435037 */   GIM_Try, /*On fail goto*//*Label 35232*/ GIMT_Encode4(2435120), // Rule ID 45563 //
     /* 2435042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435078 */     // MIs[1] Operand 1
     /* 2435078 */     // No operand predicates
     /* 2435078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435082 */     // MIs[0] policy
     /* 2435082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435094 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2435097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435106 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435119 */     // GIR_Coverage, 45563,
     /* 2435119 */     GIR_EraseRootFromParent_Done,
     /* 2435120 */   // Label 35232: @2435120
     /* 2435120 */   GIM_Try, /*On fail goto*//*Label 35233*/ GIMT_Encode4(2435192), // Rule ID 45504 //
     /* 2435125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435157 */     // MIs[0] policy
     /* 2435157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435167 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2435170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435178 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435191 */     // GIR_Coverage, 45504,
     /* 2435191 */     GIR_EraseRootFromParent_Done,
     /* 2435192 */   // Label 35233: @2435192
     /* 2435192 */   GIM_Try, /*On fail goto*//*Label 35234*/ GIMT_Encode4(2435264), // Rule ID 45505 //
     /* 2435197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435229 */     // MIs[0] policy
     /* 2435229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435239 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2435242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435250 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435263 */     // GIR_Coverage, 45505,
     /* 2435263 */     GIR_EraseRootFromParent_Done,
     /* 2435264 */   // Label 35234: @2435264
     /* 2435264 */   GIM_Try, /*On fail goto*//*Label 35235*/ GIMT_Encode4(2435336), // Rule ID 45564 //
     /* 2435269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435301 */     // MIs[0] policy
     /* 2435301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435311 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2435314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435322 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435335 */     // GIR_Coverage, 45564,
     /* 2435335 */     GIR_EraseRootFromParent_Done,
     /* 2435336 */   // Label 35235: @2435336
     /* 2435336 */   GIM_Try, /*On fail goto*//*Label 35236*/ GIMT_Encode4(2435408), // Rule ID 45565 //
     /* 2435341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435373 */     // MIs[0] policy
     /* 2435373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435383 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2435386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435394 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435407 */     // GIR_Coverage, 45565,
     /* 2435407 */     GIR_EraseRootFromParent_Done,
     /* 2435408 */   // Label 35236: @2435408
     /* 2435408 */   GIM_Reject,
     /* 2435409 */ // Label 35228: @2435409
     /* 2435409 */ GIM_Reject,
     /* 2435410 */ // Label 35118: @2435410
     /* 2435410 */ GIM_Try, /*On fail goto*//*Label 35237*/ GIMT_Encode4(2436042),
     /* 2435415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2435418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2435421 */   GIM_Try, /*On fail goto*//*Label 35238*/ GIMT_Encode4(2435504), // Rule ID 45518 //
     /* 2435426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435462 */     // MIs[1] Operand 1
     /* 2435462 */     // No operand predicates
     /* 2435462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435466 */     // MIs[0] policy
     /* 2435466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435478 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2435481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435490 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435503 */     // GIR_Coverage, 45518,
     /* 2435503 */     GIR_EraseRootFromParent_Done,
     /* 2435504 */   // Label 35238: @2435504
     /* 2435504 */   GIM_Try, /*On fail goto*//*Label 35239*/ GIMT_Encode4(2435587), // Rule ID 45519 //
     /* 2435509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435545 */     // MIs[1] Operand 1
     /* 2435545 */     // No operand predicates
     /* 2435545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435549 */     // MIs[0] policy
     /* 2435549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435561 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2435564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435586 */     // GIR_Coverage, 45519,
     /* 2435586 */     GIR_EraseRootFromParent_Done,
     /* 2435587 */   // Label 35239: @2435587
     /* 2435587 */   GIM_Try, /*On fail goto*//*Label 35240*/ GIMT_Encode4(2435670), // Rule ID 45578 //
     /* 2435592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435628 */     // MIs[1] Operand 1
     /* 2435628 */     // No operand predicates
     /* 2435628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435632 */     // MIs[0] policy
     /* 2435632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435644 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2435647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435656 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435669 */     // GIR_Coverage, 45578,
     /* 2435669 */     GIR_EraseRootFromParent_Done,
     /* 2435670 */   // Label 35240: @2435670
     /* 2435670 */   GIM_Try, /*On fail goto*//*Label 35241*/ GIMT_Encode4(2435753), // Rule ID 45579 //
     /* 2435675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435711 */     // MIs[1] Operand 1
     /* 2435711 */     // No operand predicates
     /* 2435711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435715 */     // MIs[0] policy
     /* 2435715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435727 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2435730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435752 */     // GIR_Coverage, 45579,
     /* 2435752 */     GIR_EraseRootFromParent_Done,
     /* 2435753 */   // Label 35241: @2435753
     /* 2435753 */   GIM_Try, /*On fail goto*//*Label 35242*/ GIMT_Encode4(2435825), // Rule ID 45520 //
     /* 2435758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435790 */     // MIs[0] policy
     /* 2435790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435800 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2435803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435824 */     // GIR_Coverage, 45520,
     /* 2435824 */     GIR_EraseRootFromParent_Done,
     /* 2435825 */   // Label 35242: @2435825
     /* 2435825 */   GIM_Try, /*On fail goto*//*Label 35243*/ GIMT_Encode4(2435897), // Rule ID 45521 //
     /* 2435830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435862 */     // MIs[0] policy
     /* 2435862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435872 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2435875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435883 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435896 */     // GIR_Coverage, 45521,
     /* 2435896 */     GIR_EraseRootFromParent_Done,
     /* 2435897 */   // Label 35243: @2435897
     /* 2435897 */   GIM_Try, /*On fail goto*//*Label 35244*/ GIMT_Encode4(2435969), // Rule ID 45580 //
     /* 2435902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435934 */     // MIs[0] policy
     /* 2435934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435944 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2435947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435955 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435968 */     // GIR_Coverage, 45580,
     /* 2435968 */     GIR_EraseRootFromParent_Done,
     /* 2435969 */   // Label 35244: @2435969
     /* 2435969 */   GIM_Try, /*On fail goto*//*Label 35245*/ GIMT_Encode4(2436041), // Rule ID 45581 //
     /* 2435974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436006 */     // MIs[0] policy
     /* 2436006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436016 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2436019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2436037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436040 */     // GIR_Coverage, 45581,
     /* 2436040 */     GIR_EraseRootFromParent_Done,
     /* 2436041 */   // Label 35245: @2436041
     /* 2436041 */   GIM_Reject,
     /* 2436042 */ // Label 35237: @2436042
     /* 2436042 */ GIM_Reject,
     /* 2436043 */ // Label 35119: @2436043
     /* 2436043 */ GIM_Try, /*On fail goto*//*Label 35246*/ GIMT_Encode4(2436675),
     /* 2436048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2436051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2436054 */   GIM_Try, /*On fail goto*//*Label 35247*/ GIMT_Encode4(2436137), // Rule ID 45534 //
     /* 2436059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2436062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436095 */     // MIs[1] Operand 1
     /* 2436095 */     // No operand predicates
     /* 2436095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436099 */     // MIs[0] policy
     /* 2436099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436111 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2436114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436136 */     // GIR_Coverage, 45534,
     /* 2436136 */     GIR_EraseRootFromParent_Done,
     /* 2436137 */   // Label 35247: @2436137
     /* 2436137 */   GIM_Try, /*On fail goto*//*Label 35248*/ GIMT_Encode4(2436220), // Rule ID 45535 //
     /* 2436142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2436145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436174 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436178 */     // MIs[1] Operand 1
     /* 2436178 */     // No operand predicates
     /* 2436178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436182 */     // MIs[0] policy
     /* 2436182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436194 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2436197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436206 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436219 */     // GIR_Coverage, 45535,
     /* 2436219 */     GIR_EraseRootFromParent_Done,
     /* 2436220 */   // Label 35248: @2436220
     /* 2436220 */   GIM_Try, /*On fail goto*//*Label 35249*/ GIMT_Encode4(2436303), // Rule ID 45594 //
     /* 2436225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2436228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436261 */     // MIs[1] Operand 1
     /* 2436261 */     // No operand predicates
     /* 2436261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436265 */     // MIs[0] policy
     /* 2436265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436277 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2436280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436302 */     // GIR_Coverage, 45594,
     /* 2436302 */     GIR_EraseRootFromParent_Done,
     /* 2436303 */   // Label 35249: @2436303
     /* 2436303 */   GIM_Try, /*On fail goto*//*Label 35250*/ GIMT_Encode4(2436386), // Rule ID 45595 //
     /* 2436308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2436311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436344 */     // MIs[1] Operand 1
     /* 2436344 */     // No operand predicates
     /* 2436344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436348 */     // MIs[0] policy
     /* 2436348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436360 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2436363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436372 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436385 */     // GIR_Coverage, 45595,
     /* 2436385 */     GIR_EraseRootFromParent_Done,
     /* 2436386 */   // Label 35250: @2436386
     /* 2436386 */   GIM_Try, /*On fail goto*//*Label 35251*/ GIMT_Encode4(2436458), // Rule ID 45536 //
     /* 2436391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2436394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436423 */     // MIs[0] policy
     /* 2436423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436433 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2436436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436457 */     // GIR_Coverage, 45536,
     /* 2436457 */     GIR_EraseRootFromParent_Done,
     /* 2436458 */   // Label 35251: @2436458
     /* 2436458 */   GIM_Try, /*On fail goto*//*Label 35252*/ GIMT_Encode4(2436530), // Rule ID 45537 //
     /* 2436463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2436466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436495 */     // MIs[0] policy
     /* 2436495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436505 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2436508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436529 */     // GIR_Coverage, 45537,
     /* 2436529 */     GIR_EraseRootFromParent_Done,
     /* 2436530 */   // Label 35252: @2436530
     /* 2436530 */   GIM_Try, /*On fail goto*//*Label 35253*/ GIMT_Encode4(2436602), // Rule ID 45596 //
     /* 2436535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2436538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436567 */     // MIs[0] policy
     /* 2436567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436577 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2436580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436588 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436601 */     // GIR_Coverage, 45596,
     /* 2436601 */     GIR_EraseRootFromParent_Done,
     /* 2436602 */   // Label 35253: @2436602
     /* 2436602 */   GIM_Try, /*On fail goto*//*Label 35254*/ GIMT_Encode4(2436674), // Rule ID 45597 //
     /* 2436607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2436610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436639 */     // MIs[0] policy
     /* 2436639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436649 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2436652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436673 */     // GIR_Coverage, 45597,
     /* 2436673 */     GIR_EraseRootFromParent_Done,
     /* 2436674 */   // Label 35254: @2436674
     /* 2436674 */   GIM_Reject,
     /* 2436675 */ // Label 35246: @2436675
     /* 2436675 */ GIM_Reject,
     /* 2436676 */ // Label 35120: @2436676
     /* 2436676 */ GIM_Try, /*On fail goto*//*Label 35255*/ GIMT_Encode4(2436998),
     /* 2436681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2436684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2436687 */   GIM_Try, /*On fail goto*//*Label 35256*/ GIMT_Encode4(2436770), // Rule ID 45490 //
     /* 2436692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436728 */     // MIs[1] Operand 1
     /* 2436728 */     // No operand predicates
     /* 2436728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436732 */     // MIs[0] policy
     /* 2436732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436744 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2436747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436756 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436769 */     // GIR_Coverage, 45490,
     /* 2436769 */     GIR_EraseRootFromParent_Done,
     /* 2436770 */   // Label 35256: @2436770
     /* 2436770 */   GIM_Try, /*On fail goto*//*Label 35257*/ GIMT_Encode4(2436853), // Rule ID 45491 //
     /* 2436775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436811 */     // MIs[1] Operand 1
     /* 2436811 */     // No operand predicates
     /* 2436811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436815 */     // MIs[0] policy
     /* 2436815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436827 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2436830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436852 */     // GIR_Coverage, 45491,
     /* 2436852 */     GIR_EraseRootFromParent_Done,
     /* 2436853 */   // Label 35257: @2436853
     /* 2436853 */   GIM_Try, /*On fail goto*//*Label 35258*/ GIMT_Encode4(2436925), // Rule ID 45492 //
     /* 2436858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436890 */     // MIs[0] policy
     /* 2436890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436900 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2436903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436924 */     // GIR_Coverage, 45492,
     /* 2436924 */     GIR_EraseRootFromParent_Done,
     /* 2436925 */   // Label 35258: @2436925
     /* 2436925 */   GIM_Try, /*On fail goto*//*Label 35259*/ GIMT_Encode4(2436997), // Rule ID 45493 //
     /* 2436930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436962 */     // MIs[0] policy
     /* 2436962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436972 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2436975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436993 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436996 */     // GIR_Coverage, 45493,
     /* 2436996 */     GIR_EraseRootFromParent_Done,
     /* 2436997 */   // Label 35259: @2436997
     /* 2436997 */   GIM_Reject,
     /* 2436998 */ // Label 35255: @2436998
     /* 2436998 */ GIM_Reject,
     /* 2436999 */ // Label 35121: @2436999
     /* 2436999 */ GIM_Try, /*On fail goto*//*Label 35260*/ GIMT_Encode4(2437631),
     /* 2437004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2437007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2437010 */   GIM_Try, /*On fail goto*//*Label 35261*/ GIMT_Encode4(2437093), // Rule ID 45506 //
     /* 2437015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437051 */     // MIs[1] Operand 1
     /* 2437051 */     // No operand predicates
     /* 2437051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437055 */     // MIs[0] policy
     /* 2437055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437067 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2437070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437092 */     // GIR_Coverage, 45506,
     /* 2437092 */     GIR_EraseRootFromParent_Done,
     /* 2437093 */   // Label 35261: @2437093
     /* 2437093 */   GIM_Try, /*On fail goto*//*Label 35262*/ GIMT_Encode4(2437176), // Rule ID 45507 //
     /* 2437098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437134 */     // MIs[1] Operand 1
     /* 2437134 */     // No operand predicates
     /* 2437134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437138 */     // MIs[0] policy
     /* 2437138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437150 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2437153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437162 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437175 */     // GIR_Coverage, 45507,
     /* 2437175 */     GIR_EraseRootFromParent_Done,
     /* 2437176 */   // Label 35262: @2437176
     /* 2437176 */   GIM_Try, /*On fail goto*//*Label 35263*/ GIMT_Encode4(2437259), // Rule ID 45566 //
     /* 2437181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437217 */     // MIs[1] Operand 1
     /* 2437217 */     // No operand predicates
     /* 2437217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437221 */     // MIs[0] policy
     /* 2437221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437233 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2437236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437258 */     // GIR_Coverage, 45566,
     /* 2437258 */     GIR_EraseRootFromParent_Done,
     /* 2437259 */   // Label 35263: @2437259
     /* 2437259 */   GIM_Try, /*On fail goto*//*Label 35264*/ GIMT_Encode4(2437342), // Rule ID 45567 //
     /* 2437264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437300 */     // MIs[1] Operand 1
     /* 2437300 */     // No operand predicates
     /* 2437300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437304 */     // MIs[0] policy
     /* 2437304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437316 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2437319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437328 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437341 */     // GIR_Coverage, 45567,
     /* 2437341 */     GIR_EraseRootFromParent_Done,
     /* 2437342 */   // Label 35264: @2437342
     /* 2437342 */   GIM_Try, /*On fail goto*//*Label 35265*/ GIMT_Encode4(2437414), // Rule ID 45508 //
     /* 2437347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437379 */     // MIs[0] policy
     /* 2437379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437389 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2437392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437400 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437413 */     // GIR_Coverage, 45508,
     /* 2437413 */     GIR_EraseRootFromParent_Done,
     /* 2437414 */   // Label 35265: @2437414
     /* 2437414 */   GIM_Try, /*On fail goto*//*Label 35266*/ GIMT_Encode4(2437486), // Rule ID 45509 //
     /* 2437419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437451 */     // MIs[0] policy
     /* 2437451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437461 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2437464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437472 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437485 */     // GIR_Coverage, 45509,
     /* 2437485 */     GIR_EraseRootFromParent_Done,
     /* 2437486 */   // Label 35266: @2437486
     /* 2437486 */   GIM_Try, /*On fail goto*//*Label 35267*/ GIMT_Encode4(2437558), // Rule ID 45568 //
     /* 2437491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437523 */     // MIs[0] policy
     /* 2437523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437533 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2437536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437557 */     // GIR_Coverage, 45568,
     /* 2437557 */     GIR_EraseRootFromParent_Done,
     /* 2437558 */   // Label 35267: @2437558
     /* 2437558 */   GIM_Try, /*On fail goto*//*Label 35268*/ GIMT_Encode4(2437630), // Rule ID 45569 //
     /* 2437563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437595 */     // MIs[0] policy
     /* 2437595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437605 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2437608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437616 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437629 */     // GIR_Coverage, 45569,
     /* 2437629 */     GIR_EraseRootFromParent_Done,
     /* 2437630 */   // Label 35268: @2437630
     /* 2437630 */   GIM_Reject,
     /* 2437631 */ // Label 35260: @2437631
     /* 2437631 */ GIM_Reject,
     /* 2437632 */ // Label 35122: @2437632
     /* 2437632 */ GIM_Try, /*On fail goto*//*Label 35269*/ GIMT_Encode4(2438264),
     /* 2437637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2437640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2437643 */   GIM_Try, /*On fail goto*//*Label 35270*/ GIMT_Encode4(2437726), // Rule ID 45522 //
     /* 2437648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437684 */     // MIs[1] Operand 1
     /* 2437684 */     // No operand predicates
     /* 2437684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437688 */     // MIs[0] policy
     /* 2437688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437700 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2437703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437712 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437725 */     // GIR_Coverage, 45522,
     /* 2437725 */     GIR_EraseRootFromParent_Done,
     /* 2437726 */   // Label 35270: @2437726
     /* 2437726 */   GIM_Try, /*On fail goto*//*Label 35271*/ GIMT_Encode4(2437809), // Rule ID 45523 //
     /* 2437731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437767 */     // MIs[1] Operand 1
     /* 2437767 */     // No operand predicates
     /* 2437767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437771 */     // MIs[0] policy
     /* 2437771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437783 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2437786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437795 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437808 */     // GIR_Coverage, 45523,
     /* 2437808 */     GIR_EraseRootFromParent_Done,
     /* 2437809 */   // Label 35271: @2437809
     /* 2437809 */   GIM_Try, /*On fail goto*//*Label 35272*/ GIMT_Encode4(2437892), // Rule ID 45582 //
     /* 2437814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437850 */     // MIs[1] Operand 1
     /* 2437850 */     // No operand predicates
     /* 2437850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437854 */     // MIs[0] policy
     /* 2437854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437866 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2437869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437878 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437891 */     // GIR_Coverage, 45582,
     /* 2437891 */     GIR_EraseRootFromParent_Done,
     /* 2437892 */   // Label 35272: @2437892
     /* 2437892 */   GIM_Try, /*On fail goto*//*Label 35273*/ GIMT_Encode4(2437975), // Rule ID 45583 //
     /* 2437897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437933 */     // MIs[1] Operand 1
     /* 2437933 */     // No operand predicates
     /* 2437933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437937 */     // MIs[0] policy
     /* 2437937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437949 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2437952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437974 */     // GIR_Coverage, 45583,
     /* 2437974 */     GIR_EraseRootFromParent_Done,
     /* 2437975 */   // Label 35273: @2437975
     /* 2437975 */   GIM_Try, /*On fail goto*//*Label 35274*/ GIMT_Encode4(2438047), // Rule ID 45524 //
     /* 2437980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438012 */     // MIs[0] policy
     /* 2438012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438022 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2438025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2438043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438046 */     // GIR_Coverage, 45524,
     /* 2438046 */     GIR_EraseRootFromParent_Done,
     /* 2438047 */   // Label 35274: @2438047
     /* 2438047 */   GIM_Try, /*On fail goto*//*Label 35275*/ GIMT_Encode4(2438119), // Rule ID 45525 //
     /* 2438052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438084 */     // MIs[0] policy
     /* 2438084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438094 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2438097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2438115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438118 */     // GIR_Coverage, 45525,
     /* 2438118 */     GIR_EraseRootFromParent_Done,
     /* 2438119 */   // Label 35275: @2438119
     /* 2438119 */   GIM_Try, /*On fail goto*//*Label 35276*/ GIMT_Encode4(2438191), // Rule ID 45584 //
     /* 2438124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438156 */     // MIs[0] policy
     /* 2438156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438166 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2438169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2438187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438190 */     // GIR_Coverage, 45584,
     /* 2438190 */     GIR_EraseRootFromParent_Done,
     /* 2438191 */   // Label 35276: @2438191
     /* 2438191 */   GIM_Try, /*On fail goto*//*Label 35277*/ GIMT_Encode4(2438263), // Rule ID 45585 //
     /* 2438196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438228 */     // MIs[0] policy
     /* 2438228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438238 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2438241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2438259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438262 */     // GIR_Coverage, 45585,
     /* 2438262 */     GIR_EraseRootFromParent_Done,
     /* 2438263 */   // Label 35277: @2438263
     /* 2438263 */   GIM_Reject,
     /* 2438264 */ // Label 35269: @2438264
     /* 2438264 */ GIM_Reject,
     /* 2438265 */ // Label 35123: @2438265
     /* 2438265 */ GIM_Try, /*On fail goto*//*Label 35278*/ GIMT_Encode4(2438587),
     /* 2438270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2438273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2438276 */   GIM_Try, /*On fail goto*//*Label 35279*/ GIMT_Encode4(2438359), // Rule ID 45494 //
     /* 2438281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2438297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438317 */     // MIs[1] Operand 1
     /* 2438317 */     // No operand predicates
     /* 2438317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438321 */     // MIs[0] policy
     /* 2438321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438333 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2438336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438358 */     // GIR_Coverage, 45494,
     /* 2438358 */     GIR_EraseRootFromParent_Done,
     /* 2438359 */   // Label 35279: @2438359
     /* 2438359 */   GIM_Try, /*On fail goto*//*Label 35280*/ GIMT_Encode4(2438442), // Rule ID 45495 //
     /* 2438364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2438380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438400 */     // MIs[1] Operand 1
     /* 2438400 */     // No operand predicates
     /* 2438400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438404 */     // MIs[0] policy
     /* 2438404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438416 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2438419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438428 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438441 */     // GIR_Coverage, 45495,
     /* 2438441 */     GIR_EraseRootFromParent_Done,
     /* 2438442 */   // Label 35280: @2438442
     /* 2438442 */   GIM_Try, /*On fail goto*//*Label 35281*/ GIMT_Encode4(2438514), // Rule ID 45496 //
     /* 2438447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2438463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438479 */     // MIs[0] policy
     /* 2438479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438489 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2438492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438500 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438513 */     // GIR_Coverage, 45496,
     /* 2438513 */     GIR_EraseRootFromParent_Done,
     /* 2438514 */   // Label 35281: @2438514
     /* 2438514 */   GIM_Try, /*On fail goto*//*Label 35282*/ GIMT_Encode4(2438586), // Rule ID 45497 //
     /* 2438519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2438535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438551 */     // MIs[0] policy
     /* 2438551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438561 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2438564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438572 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438585 */     // GIR_Coverage, 45497,
     /* 2438585 */     GIR_EraseRootFromParent_Done,
     /* 2438586 */   // Label 35282: @2438586
     /* 2438586 */   GIM_Reject,
     /* 2438587 */ // Label 35278: @2438587
     /* 2438587 */ GIM_Reject,
     /* 2438588 */ // Label 35124: @2438588
     /* 2438588 */ GIM_Try, /*On fail goto*//*Label 35283*/ GIMT_Encode4(2439220),
     /* 2438593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2438596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2438599 */   GIM_Try, /*On fail goto*//*Label 35284*/ GIMT_Encode4(2438682), // Rule ID 45510 //
     /* 2438604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438640 */     // MIs[1] Operand 1
     /* 2438640 */     // No operand predicates
     /* 2438640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438644 */     // MIs[0] policy
     /* 2438644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438656 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2438659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438668 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438681 */     // GIR_Coverage, 45510,
     /* 2438681 */     GIR_EraseRootFromParent_Done,
     /* 2438682 */   // Label 35284: @2438682
     /* 2438682 */   GIM_Try, /*On fail goto*//*Label 35285*/ GIMT_Encode4(2438765), // Rule ID 45511 //
     /* 2438687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438723 */     // MIs[1] Operand 1
     /* 2438723 */     // No operand predicates
     /* 2438723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438727 */     // MIs[0] policy
     /* 2438727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438739 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2438742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438764 */     // GIR_Coverage, 45511,
     /* 2438764 */     GIR_EraseRootFromParent_Done,
     /* 2438765 */   // Label 35285: @2438765
     /* 2438765 */   GIM_Try, /*On fail goto*//*Label 35286*/ GIMT_Encode4(2438848), // Rule ID 45570 //
     /* 2438770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438806 */     // MIs[1] Operand 1
     /* 2438806 */     // No operand predicates
     /* 2438806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438810 */     // MIs[0] policy
     /* 2438810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438822 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2438825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438834 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438847 */     // GIR_Coverage, 45570,
     /* 2438847 */     GIR_EraseRootFromParent_Done,
     /* 2438848 */   // Label 35286: @2438848
     /* 2438848 */   GIM_Try, /*On fail goto*//*Label 35287*/ GIMT_Encode4(2438931), // Rule ID 45571 //
     /* 2438853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438889 */     // MIs[1] Operand 1
     /* 2438889 */     // No operand predicates
     /* 2438889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438893 */     // MIs[0] policy
     /* 2438893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438905 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2438908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438930 */     // GIR_Coverage, 45571,
     /* 2438930 */     GIR_EraseRootFromParent_Done,
     /* 2438931 */   // Label 35287: @2438931
     /* 2438931 */   GIM_Try, /*On fail goto*//*Label 35288*/ GIMT_Encode4(2439003), // Rule ID 45512 //
     /* 2438936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438968 */     // MIs[0] policy
     /* 2438968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438978 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2438981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439002 */     // GIR_Coverage, 45512,
     /* 2439002 */     GIR_EraseRootFromParent_Done,
     /* 2439003 */   // Label 35288: @2439003
     /* 2439003 */   GIM_Try, /*On fail goto*//*Label 35289*/ GIMT_Encode4(2439075), // Rule ID 45513 //
     /* 2439008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2439017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439040 */     // MIs[0] policy
     /* 2439040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439050 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2439053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439071 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439074 */     // GIR_Coverage, 45513,
     /* 2439074 */     GIR_EraseRootFromParent_Done,
     /* 2439075 */   // Label 35289: @2439075
     /* 2439075 */   GIM_Try, /*On fail goto*//*Label 35290*/ GIMT_Encode4(2439147), // Rule ID 45572 //
     /* 2439080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2439089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439112 */     // MIs[0] policy
     /* 2439112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439122 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2439125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439146 */     // GIR_Coverage, 45572,
     /* 2439146 */     GIR_EraseRootFromParent_Done,
     /* 2439147 */   // Label 35290: @2439147
     /* 2439147 */   GIM_Try, /*On fail goto*//*Label 35291*/ GIMT_Encode4(2439219), // Rule ID 45573 //
     /* 2439152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2439161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439184 */     // MIs[0] policy
     /* 2439184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439194 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2439197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439218 */     // GIR_Coverage, 45573,
     /* 2439218 */     GIR_EraseRootFromParent_Done,
     /* 2439219 */   // Label 35291: @2439219
     /* 2439219 */   GIM_Reject,
     /* 2439220 */ // Label 35283: @2439220
     /* 2439220 */ GIM_Reject,
     /* 2439221 */ // Label 35125: @2439221
     /* 2439221 */ GIM_Try, /*On fail goto*//*Label 35292*/ GIMT_Encode4(2439543),
     /* 2439226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2439229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2439232 */   GIM_Try, /*On fail goto*//*Label 35293*/ GIMT_Encode4(2439315), // Rule ID 45498 //
     /* 2439237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2439246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439273 */     // MIs[1] Operand 1
     /* 2439273 */     // No operand predicates
     /* 2439273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439277 */     // MIs[0] policy
     /* 2439277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439289 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2439292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439314 */     // GIR_Coverage, 45498,
     /* 2439314 */     GIR_EraseRootFromParent_Done,
     /* 2439315 */   // Label 35293: @2439315
     /* 2439315 */   GIM_Try, /*On fail goto*//*Label 35294*/ GIMT_Encode4(2439398), // Rule ID 45499 //
     /* 2439320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2439329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439356 */     // MIs[1] Operand 1
     /* 2439356 */     // No operand predicates
     /* 2439356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439360 */     // MIs[0] policy
     /* 2439360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439372 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2439375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439384 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439397 */     // GIR_Coverage, 45499,
     /* 2439397 */     GIR_EraseRootFromParent_Done,
     /* 2439398 */   // Label 35294: @2439398
     /* 2439398 */   GIM_Try, /*On fail goto*//*Label 35295*/ GIMT_Encode4(2439470), // Rule ID 45500 //
     /* 2439403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2439412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439435 */     // MIs[0] policy
     /* 2439435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439445 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2439448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439456 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439469 */     // GIR_Coverage, 45500,
     /* 2439469 */     GIR_EraseRootFromParent_Done,
     /* 2439470 */   // Label 35295: @2439470
     /* 2439470 */   GIM_Try, /*On fail goto*//*Label 35296*/ GIMT_Encode4(2439542), // Rule ID 45501 //
     /* 2439475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2439484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439507 */     // MIs[0] policy
     /* 2439507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439517 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2439520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439541 */     // GIR_Coverage, 45501,
     /* 2439541 */     GIR_EraseRootFromParent_Done,
     /* 2439542 */   // Label 35296: @2439542
     /* 2439542 */   GIM_Reject,
     /* 2439543 */ // Label 35292: @2439543
     /* 2439543 */ GIM_Reject,
     /* 2439544 */ // Label 35126: @2439544
     /* 2439544 */ GIM_Reject,
     /* 2439545 */ // Label 124: @2439545
     /* 2439545 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35319*/ GIMT_Encode4(2451424),
     /* 2439556 */ /*GILLT_nxv1s8*//*Label 35297*/ GIMT_Encode4(2439668),
     /* 2439560 */ /*GILLT_nxv1s16*//*Label 35298*/ GIMT_Encode4(2439991),
     /* 2439564 */ /*GILLT_nxv1s32*//*Label 35299*/ GIMT_Encode4(2440624),
     /* 2439568 */ /*GILLT_nxv1s64*//*Label 35300*/ GIMT_Encode4(2441257), GIMT_Encode4(0),
     /* 2439576 */ /*GILLT_nxv2s8*//*Label 35301*/ GIMT_Encode4(2441890),
     /* 2439580 */ /*GILLT_nxv2s16*//*Label 35302*/ GIMT_Encode4(2442213),
     /* 2439584 */ /*GILLT_nxv2s32*//*Label 35303*/ GIMT_Encode4(2442846),
     /* 2439588 */ /*GILLT_nxv2s64*//*Label 35304*/ GIMT_Encode4(2443479), GIMT_Encode4(0),
     /* 2439596 */ /*GILLT_nxv4s8*//*Label 35305*/ GIMT_Encode4(2444112),
     /* 2439600 */ /*GILLT_nxv4s16*//*Label 35306*/ GIMT_Encode4(2444435),
     /* 2439604 */ /*GILLT_nxv4s32*//*Label 35307*/ GIMT_Encode4(2445068),
     /* 2439608 */ /*GILLT_nxv4s64*//*Label 35308*/ GIMT_Encode4(2445701), GIMT_Encode4(0),
     /* 2439616 */ /*GILLT_nxv8s8*//*Label 35309*/ GIMT_Encode4(2446334),
     /* 2439620 */ /*GILLT_nxv8s16*//*Label 35310*/ GIMT_Encode4(2446657),
     /* 2439624 */ /*GILLT_nxv8s32*//*Label 35311*/ GIMT_Encode4(2447290),
     /* 2439628 */ /*GILLT_nxv8s64*//*Label 35312*/ GIMT_Encode4(2447923), GIMT_Encode4(0),
     /* 2439636 */ /*GILLT_nxv16s8*//*Label 35313*/ GIMT_Encode4(2448556),
     /* 2439640 */ /*GILLT_nxv16s16*//*Label 35314*/ GIMT_Encode4(2448879),
     /* 2439644 */ /*GILLT_nxv16s32*//*Label 35315*/ GIMT_Encode4(2449512), GIMT_Encode4(0),
     /* 2439652 */ /*GILLT_nxv32s8*//*Label 35316*/ GIMT_Encode4(2450145),
     /* 2439656 */ /*GILLT_nxv32s16*//*Label 35317*/ GIMT_Encode4(2450468), GIMT_Encode4(0),
     /* 2439664 */ /*GILLT_nxv64s8*//*Label 35318*/ GIMT_Encode4(2451101),
     /* 2439668 */ // Label 35297: @2439668
     /* 2439668 */ GIM_Try, /*On fail goto*//*Label 35320*/ GIMT_Encode4(2439990),
     /* 2439673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2439676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2439679 */   GIM_Try, /*On fail goto*//*Label 35321*/ GIMT_Encode4(2439762), // Rule ID 25364 //
     /* 2439684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2439700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439720 */     // MIs[1] Operand 1
     /* 2439720 */     // No operand predicates
     /* 2439720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439724 */     // MIs[0] policy
     /* 2439724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439736 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2439739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439748 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439761 */     // GIR_Coverage, 25364,
     /* 2439761 */     GIR_EraseRootFromParent_Done,
     /* 2439762 */   // Label 35321: @2439762
     /* 2439762 */   GIM_Try, /*On fail goto*//*Label 35322*/ GIMT_Encode4(2439845), // Rule ID 25365 //
     /* 2439767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2439783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439803 */     // MIs[1] Operand 1
     /* 2439803 */     // No operand predicates
     /* 2439803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439807 */     // MIs[0] policy
     /* 2439807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439819 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2439822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439841 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439844 */     // GIR_Coverage, 25365,
     /* 2439844 */     GIR_EraseRootFromParent_Done,
     /* 2439845 */   // Label 35322: @2439845
     /* 2439845 */   GIM_Try, /*On fail goto*//*Label 35323*/ GIMT_Encode4(2439917), // Rule ID 25366 //
     /* 2439850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2439866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439882 */     // MIs[0] policy
     /* 2439882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439892 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2439895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439916 */     // GIR_Coverage, 25366,
     /* 2439916 */     GIR_EraseRootFromParent_Done,
     /* 2439917 */   // Label 35323: @2439917
     /* 2439917 */   GIM_Try, /*On fail goto*//*Label 35324*/ GIMT_Encode4(2439989), // Rule ID 25367 //
     /* 2439922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2439938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439954 */     // MIs[0] policy
     /* 2439954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439964 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2439967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439988 */     // GIR_Coverage, 25367,
     /* 2439988 */     GIR_EraseRootFromParent_Done,
     /* 2439989 */   // Label 35324: @2439989
     /* 2439989 */   GIM_Reject,
     /* 2439990 */ // Label 35320: @2439990
     /* 2439990 */ GIM_Reject,
     /* 2439991 */ // Label 35298: @2439991
     /* 2439991 */ GIM_Try, /*On fail goto*//*Label 35325*/ GIMT_Encode4(2440623),
     /* 2439996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2439999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2440002 */   GIM_Try, /*On fail goto*//*Label 35326*/ GIMT_Encode4(2440085), // Rule ID 45314 //
     /* 2440007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440043 */     // MIs[1] Operand 1
     /* 2440043 */     // No operand predicates
     /* 2440043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440047 */     // MIs[0] policy
     /* 2440047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440059 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2440062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440084 */     // GIR_Coverage, 45314,
     /* 2440084 */     GIR_EraseRootFromParent_Done,
     /* 2440085 */   // Label 35326: @2440085
     /* 2440085 */   GIM_Try, /*On fail goto*//*Label 35327*/ GIMT_Encode4(2440168), // Rule ID 45315 //
     /* 2440090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440126 */     // MIs[1] Operand 1
     /* 2440126 */     // No operand predicates
     /* 2440126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440130 */     // MIs[0] policy
     /* 2440130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440142 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2440145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440154 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440167 */     // GIR_Coverage, 45315,
     /* 2440167 */     GIR_EraseRootFromParent_Done,
     /* 2440168 */   // Label 35327: @2440168
     /* 2440168 */   GIM_Try, /*On fail goto*//*Label 35328*/ GIMT_Encode4(2440251), // Rule ID 45390 //
     /* 2440173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440209 */     // MIs[1] Operand 1
     /* 2440209 */     // No operand predicates
     /* 2440209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440213 */     // MIs[0] policy
     /* 2440213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440225 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2440228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440250 */     // GIR_Coverage, 45390,
     /* 2440250 */     GIR_EraseRootFromParent_Done,
     /* 2440251 */   // Label 35328: @2440251
     /* 2440251 */   GIM_Try, /*On fail goto*//*Label 35329*/ GIMT_Encode4(2440334), // Rule ID 45391 //
     /* 2440256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440292 */     // MIs[1] Operand 1
     /* 2440292 */     // No operand predicates
     /* 2440292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440296 */     // MIs[0] policy
     /* 2440296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440308 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2440311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440320 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440333 */     // GIR_Coverage, 45391,
     /* 2440333 */     GIR_EraseRootFromParent_Done,
     /* 2440334 */   // Label 35329: @2440334
     /* 2440334 */   GIM_Try, /*On fail goto*//*Label 35330*/ GIMT_Encode4(2440406), // Rule ID 45316 //
     /* 2440339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440371 */     // MIs[0] policy
     /* 2440371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440381 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2440384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440392 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440405 */     // GIR_Coverage, 45316,
     /* 2440405 */     GIR_EraseRootFromParent_Done,
     /* 2440406 */   // Label 35330: @2440406
     /* 2440406 */   GIM_Try, /*On fail goto*//*Label 35331*/ GIMT_Encode4(2440478), // Rule ID 45317 //
     /* 2440411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440443 */     // MIs[0] policy
     /* 2440443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440453 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2440456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440464 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440477 */     // GIR_Coverage, 45317,
     /* 2440477 */     GIR_EraseRootFromParent_Done,
     /* 2440478 */   // Label 35331: @2440478
     /* 2440478 */   GIM_Try, /*On fail goto*//*Label 35332*/ GIMT_Encode4(2440550), // Rule ID 45392 //
     /* 2440483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440515 */     // MIs[0] policy
     /* 2440515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440525 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2440528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440549 */     // GIR_Coverage, 45392,
     /* 2440549 */     GIR_EraseRootFromParent_Done,
     /* 2440550 */   // Label 35332: @2440550
     /* 2440550 */   GIM_Try, /*On fail goto*//*Label 35333*/ GIMT_Encode4(2440622), // Rule ID 45393 //
     /* 2440555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440587 */     // MIs[0] policy
     /* 2440587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440597 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2440600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440608 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440621 */     // GIR_Coverage, 45393,
     /* 2440621 */     GIR_EraseRootFromParent_Done,
     /* 2440622 */   // Label 35333: @2440622
     /* 2440622 */   GIM_Reject,
     /* 2440623 */ // Label 35325: @2440623
     /* 2440623 */ GIM_Reject,
     /* 2440624 */ // Label 35299: @2440624
     /* 2440624 */ GIM_Try, /*On fail goto*//*Label 35334*/ GIMT_Encode4(2441256),
     /* 2440629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2440632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2440635 */   GIM_Try, /*On fail goto*//*Label 35335*/ GIMT_Encode4(2440718), // Rule ID 45322 //
     /* 2440640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440676 */     // MIs[1] Operand 1
     /* 2440676 */     // No operand predicates
     /* 2440676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440680 */     // MIs[0] policy
     /* 2440680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440692 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2440695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440717 */     // GIR_Coverage, 45322,
     /* 2440717 */     GIR_EraseRootFromParent_Done,
     /* 2440718 */   // Label 35335: @2440718
     /* 2440718 */   GIM_Try, /*On fail goto*//*Label 35336*/ GIMT_Encode4(2440801), // Rule ID 45323 //
     /* 2440723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440759 */     // MIs[1] Operand 1
     /* 2440759 */     // No operand predicates
     /* 2440759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440763 */     // MIs[0] policy
     /* 2440763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440775 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2440778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440787 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440800 */     // GIR_Coverage, 45323,
     /* 2440800 */     GIR_EraseRootFromParent_Done,
     /* 2440801 */   // Label 35336: @2440801
     /* 2440801 */   GIM_Try, /*On fail goto*//*Label 35337*/ GIMT_Encode4(2440884), // Rule ID 45398 //
     /* 2440806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440842 */     // MIs[1] Operand 1
     /* 2440842 */     // No operand predicates
     /* 2440842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440846 */     // MIs[0] policy
     /* 2440846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440858 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2440861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440870 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440883 */     // GIR_Coverage, 45398,
     /* 2440883 */     GIR_EraseRootFromParent_Done,
     /* 2440884 */   // Label 35337: @2440884
     /* 2440884 */   GIM_Try, /*On fail goto*//*Label 35338*/ GIMT_Encode4(2440967), // Rule ID 45399 //
     /* 2440889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440925 */     // MIs[1] Operand 1
     /* 2440925 */     // No operand predicates
     /* 2440925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440929 */     // MIs[0] policy
     /* 2440929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440941 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2440944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440966 */     // GIR_Coverage, 45399,
     /* 2440966 */     GIR_EraseRootFromParent_Done,
     /* 2440967 */   // Label 35338: @2440967
     /* 2440967 */   GIM_Try, /*On fail goto*//*Label 35339*/ GIMT_Encode4(2441039), // Rule ID 45324 //
     /* 2440972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441004 */     // MIs[0] policy
     /* 2441004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441014 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2441017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441038 */     // GIR_Coverage, 45324,
     /* 2441038 */     GIR_EraseRootFromParent_Done,
     /* 2441039 */   // Label 35339: @2441039
     /* 2441039 */   GIM_Try, /*On fail goto*//*Label 35340*/ GIMT_Encode4(2441111), // Rule ID 45325 //
     /* 2441044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441076 */     // MIs[0] policy
     /* 2441076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441086 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2441089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441110 */     // GIR_Coverage, 45325,
     /* 2441110 */     GIR_EraseRootFromParent_Done,
     /* 2441111 */   // Label 35340: @2441111
     /* 2441111 */   GIM_Try, /*On fail goto*//*Label 35341*/ GIMT_Encode4(2441183), // Rule ID 45400 //
     /* 2441116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441148 */     // MIs[0] policy
     /* 2441148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441158 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2441161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441182 */     // GIR_Coverage, 45400,
     /* 2441182 */     GIR_EraseRootFromParent_Done,
     /* 2441183 */   // Label 35341: @2441183
     /* 2441183 */   GIM_Try, /*On fail goto*//*Label 35342*/ GIMT_Encode4(2441255), // Rule ID 45401 //
     /* 2441188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441220 */     // MIs[0] policy
     /* 2441220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441230 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2441233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441254 */     // GIR_Coverage, 45401,
     /* 2441254 */     GIR_EraseRootFromParent_Done,
     /* 2441255 */   // Label 35342: @2441255
     /* 2441255 */   GIM_Reject,
     /* 2441256 */ // Label 35334: @2441256
     /* 2441256 */ GIM_Reject,
     /* 2441257 */ // Label 35300: @2441257
     /* 2441257 */ GIM_Try, /*On fail goto*//*Label 35343*/ GIMT_Encode4(2441889),
     /* 2441262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2441265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2441268 */   GIM_Try, /*On fail goto*//*Label 35344*/ GIMT_Encode4(2441351), // Rule ID 45338 //
     /* 2441273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2441276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441309 */     // MIs[1] Operand 1
     /* 2441309 */     // No operand predicates
     /* 2441309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441313 */     // MIs[0] policy
     /* 2441313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441325 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2441328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441350 */     // GIR_Coverage, 45338,
     /* 2441350 */     GIR_EraseRootFromParent_Done,
     /* 2441351 */   // Label 35344: @2441351
     /* 2441351 */   GIM_Try, /*On fail goto*//*Label 35345*/ GIMT_Encode4(2441434), // Rule ID 45339 //
     /* 2441356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2441359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441392 */     // MIs[1] Operand 1
     /* 2441392 */     // No operand predicates
     /* 2441392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441396 */     // MIs[0] policy
     /* 2441396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441408 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2441411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441420 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441433 */     // GIR_Coverage, 45339,
     /* 2441433 */     GIR_EraseRootFromParent_Done,
     /* 2441434 */   // Label 35345: @2441434
     /* 2441434 */   GIM_Try, /*On fail goto*//*Label 35346*/ GIMT_Encode4(2441517), // Rule ID 45410 //
     /* 2441439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2441442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441475 */     // MIs[1] Operand 1
     /* 2441475 */     // No operand predicates
     /* 2441475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441479 */     // MIs[0] policy
     /* 2441479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441491 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2441494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441516 */     // GIR_Coverage, 45410,
     /* 2441516 */     GIR_EraseRootFromParent_Done,
     /* 2441517 */   // Label 35346: @2441517
     /* 2441517 */   GIM_Try, /*On fail goto*//*Label 35347*/ GIMT_Encode4(2441600), // Rule ID 45411 //
     /* 2441522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2441525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441558 */     // MIs[1] Operand 1
     /* 2441558 */     // No operand predicates
     /* 2441558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441562 */     // MIs[0] policy
     /* 2441562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441574 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2441577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441586 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441599 */     // GIR_Coverage, 45411,
     /* 2441599 */     GIR_EraseRootFromParent_Done,
     /* 2441600 */   // Label 35347: @2441600
     /* 2441600 */   GIM_Try, /*On fail goto*//*Label 35348*/ GIMT_Encode4(2441672), // Rule ID 45340 //
     /* 2441605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2441608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441637 */     // MIs[0] policy
     /* 2441637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441647 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2441650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441658 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441671 */     // GIR_Coverage, 45340,
     /* 2441671 */     GIR_EraseRootFromParent_Done,
     /* 2441672 */   // Label 35348: @2441672
     /* 2441672 */   GIM_Try, /*On fail goto*//*Label 35349*/ GIMT_Encode4(2441744), // Rule ID 45341 //
     /* 2441677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2441680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441709 */     // MIs[0] policy
     /* 2441709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441719 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2441722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441730 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441743 */     // GIR_Coverage, 45341,
     /* 2441743 */     GIR_EraseRootFromParent_Done,
     /* 2441744 */   // Label 35349: @2441744
     /* 2441744 */   GIM_Try, /*On fail goto*//*Label 35350*/ GIMT_Encode4(2441816), // Rule ID 45412 //
     /* 2441749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2441752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441781 */     // MIs[0] policy
     /* 2441781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441791 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2441794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441802 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441815 */     // GIR_Coverage, 45412,
     /* 2441815 */     GIR_EraseRootFromParent_Done,
     /* 2441816 */   // Label 35350: @2441816
     /* 2441816 */   GIM_Try, /*On fail goto*//*Label 35351*/ GIMT_Encode4(2441888), // Rule ID 45413 //
     /* 2441821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2441824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441853 */     // MIs[0] policy
     /* 2441853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441863 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2441866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441874 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441887 */     // GIR_Coverage, 45413,
     /* 2441887 */     GIR_EraseRootFromParent_Done,
     /* 2441888 */   // Label 35351: @2441888
     /* 2441888 */   GIM_Reject,
     /* 2441889 */ // Label 35343: @2441889
     /* 2441889 */ GIM_Reject,
     /* 2441890 */ // Label 35301: @2441890
     /* 2441890 */ GIM_Try, /*On fail goto*//*Label 35352*/ GIMT_Encode4(2442212),
     /* 2441895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2441898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2441901 */   GIM_Try, /*On fail goto*//*Label 35353*/ GIMT_Encode4(2441984), // Rule ID 45306 //
     /* 2441906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2441915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441942 */     // MIs[1] Operand 1
     /* 2441942 */     // No operand predicates
     /* 2441942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441946 */     // MIs[0] policy
     /* 2441946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441958 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2441961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441970 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2441980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441983 */     // GIR_Coverage, 45306,
     /* 2441983 */     GIR_EraseRootFromParent_Done,
     /* 2441984 */   // Label 35353: @2441984
     /* 2441984 */   GIM_Try, /*On fail goto*//*Label 35354*/ GIMT_Encode4(2442067), // Rule ID 45307 //
     /* 2441989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2441998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442025 */     // MIs[1] Operand 1
     /* 2442025 */     // No operand predicates
     /* 2442025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442029 */     // MIs[0] policy
     /* 2442029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442041 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2442044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2442063 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442066 */     // GIR_Coverage, 45307,
     /* 2442066 */     GIR_EraseRootFromParent_Done,
     /* 2442067 */   // Label 35354: @2442067
     /* 2442067 */   GIM_Try, /*On fail goto*//*Label 35355*/ GIMT_Encode4(2442139), // Rule ID 45308 //
     /* 2442072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442104 */     // MIs[0] policy
     /* 2442104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442114 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2442117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2442135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442138 */     // GIR_Coverage, 45308,
     /* 2442138 */     GIR_EraseRootFromParent_Done,
     /* 2442139 */   // Label 35355: @2442139
     /* 2442139 */   GIM_Try, /*On fail goto*//*Label 35356*/ GIMT_Encode4(2442211), // Rule ID 45309 //
     /* 2442144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442176 */     // MIs[0] policy
     /* 2442176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442186 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2442189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2442207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442210 */     // GIR_Coverage, 45309,
     /* 2442210 */     GIR_EraseRootFromParent_Done,
     /* 2442211 */   // Label 35356: @2442211
     /* 2442211 */   GIM_Reject,
     /* 2442212 */ // Label 35352: @2442212
     /* 2442212 */ GIM_Reject,
     /* 2442213 */ // Label 35302: @2442213
     /* 2442213 */ GIM_Try, /*On fail goto*//*Label 35357*/ GIMT_Encode4(2442845),
     /* 2442218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2442221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2442224 */   GIM_Try, /*On fail goto*//*Label 35358*/ GIMT_Encode4(2442307), // Rule ID 45318 //
     /* 2442229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442265 */     // MIs[1] Operand 1
     /* 2442265 */     // No operand predicates
     /* 2442265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442269 */     // MIs[0] policy
     /* 2442269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442281 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2442284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442306 */     // GIR_Coverage, 45318,
     /* 2442306 */     GIR_EraseRootFromParent_Done,
     /* 2442307 */   // Label 35358: @2442307
     /* 2442307 */   GIM_Try, /*On fail goto*//*Label 35359*/ GIMT_Encode4(2442390), // Rule ID 45319 //
     /* 2442312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442348 */     // MIs[1] Operand 1
     /* 2442348 */     // No operand predicates
     /* 2442348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442352 */     // MIs[0] policy
     /* 2442352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442364 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2442367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442376 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442389 */     // GIR_Coverage, 45319,
     /* 2442389 */     GIR_EraseRootFromParent_Done,
     /* 2442390 */   // Label 35359: @2442390
     /* 2442390 */   GIM_Try, /*On fail goto*//*Label 35360*/ GIMT_Encode4(2442473), // Rule ID 45394 //
     /* 2442395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442431 */     // MIs[1] Operand 1
     /* 2442431 */     // No operand predicates
     /* 2442431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442435 */     // MIs[0] policy
     /* 2442435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442447 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2442450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442472 */     // GIR_Coverage, 45394,
     /* 2442472 */     GIR_EraseRootFromParent_Done,
     /* 2442473 */   // Label 35360: @2442473
     /* 2442473 */   GIM_Try, /*On fail goto*//*Label 35361*/ GIMT_Encode4(2442556), // Rule ID 45395 //
     /* 2442478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442514 */     // MIs[1] Operand 1
     /* 2442514 */     // No operand predicates
     /* 2442514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442518 */     // MIs[0] policy
     /* 2442518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442530 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2442533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442542 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442555 */     // GIR_Coverage, 45395,
     /* 2442555 */     GIR_EraseRootFromParent_Done,
     /* 2442556 */   // Label 35361: @2442556
     /* 2442556 */   GIM_Try, /*On fail goto*//*Label 35362*/ GIMT_Encode4(2442628), // Rule ID 45320 //
     /* 2442561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442593 */     // MIs[0] policy
     /* 2442593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442603 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2442606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442614 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442627 */     // GIR_Coverage, 45320,
     /* 2442627 */     GIR_EraseRootFromParent_Done,
     /* 2442628 */   // Label 35362: @2442628
     /* 2442628 */   GIM_Try, /*On fail goto*//*Label 35363*/ GIMT_Encode4(2442700), // Rule ID 45321 //
     /* 2442633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442665 */     // MIs[0] policy
     /* 2442665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442675 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2442678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442686 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442699 */     // GIR_Coverage, 45321,
     /* 2442699 */     GIR_EraseRootFromParent_Done,
     /* 2442700 */   // Label 35363: @2442700
     /* 2442700 */   GIM_Try, /*On fail goto*//*Label 35364*/ GIMT_Encode4(2442772), // Rule ID 45396 //
     /* 2442705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442737 */     // MIs[0] policy
     /* 2442737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442747 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2442750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442758 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442771 */     // GIR_Coverage, 45396,
     /* 2442771 */     GIR_EraseRootFromParent_Done,
     /* 2442772 */   // Label 35364: @2442772
     /* 2442772 */   GIM_Try, /*On fail goto*//*Label 35365*/ GIMT_Encode4(2442844), // Rule ID 45397 //
     /* 2442777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442809 */     // MIs[0] policy
     /* 2442809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442819 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2442822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442830 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442843 */     // GIR_Coverage, 45397,
     /* 2442843 */     GIR_EraseRootFromParent_Done,
     /* 2442844 */   // Label 35365: @2442844
     /* 2442844 */   GIM_Reject,
     /* 2442845 */ // Label 35357: @2442845
     /* 2442845 */ GIM_Reject,
     /* 2442846 */ // Label 35303: @2442846
     /* 2442846 */ GIM_Try, /*On fail goto*//*Label 35366*/ GIMT_Encode4(2443478),
     /* 2442851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2442854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2442857 */   GIM_Try, /*On fail goto*//*Label 35367*/ GIMT_Encode4(2442940), // Rule ID 45334 //
     /* 2442862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442898 */     // MIs[1] Operand 1
     /* 2442898 */     // No operand predicates
     /* 2442898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442902 */     // MIs[0] policy
     /* 2442902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442914 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2442917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442926 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442939 */     // GIR_Coverage, 45334,
     /* 2442939 */     GIR_EraseRootFromParent_Done,
     /* 2442940 */   // Label 35367: @2442940
     /* 2442940 */   GIM_Try, /*On fail goto*//*Label 35368*/ GIMT_Encode4(2443023), // Rule ID 45335 //
     /* 2442945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442981 */     // MIs[1] Operand 1
     /* 2442981 */     // No operand predicates
     /* 2442981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442985 */     // MIs[0] policy
     /* 2442985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442997 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2443000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443022 */     // GIR_Coverage, 45335,
     /* 2443022 */     GIR_EraseRootFromParent_Done,
     /* 2443023 */   // Label 35368: @2443023
     /* 2443023 */   GIM_Try, /*On fail goto*//*Label 35369*/ GIMT_Encode4(2443106), // Rule ID 45406 //
     /* 2443028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443064 */     // MIs[1] Operand 1
     /* 2443064 */     // No operand predicates
     /* 2443064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443068 */     // MIs[0] policy
     /* 2443068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443080 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2443083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443105 */     // GIR_Coverage, 45406,
     /* 2443105 */     GIR_EraseRootFromParent_Done,
     /* 2443106 */   // Label 35369: @2443106
     /* 2443106 */   GIM_Try, /*On fail goto*//*Label 35370*/ GIMT_Encode4(2443189), // Rule ID 45407 //
     /* 2443111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443147 */     // MIs[1] Operand 1
     /* 2443147 */     // No operand predicates
     /* 2443147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443151 */     // MIs[0] policy
     /* 2443151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443163 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2443166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443188 */     // GIR_Coverage, 45407,
     /* 2443188 */     GIR_EraseRootFromParent_Done,
     /* 2443189 */   // Label 35370: @2443189
     /* 2443189 */   GIM_Try, /*On fail goto*//*Label 35371*/ GIMT_Encode4(2443261), // Rule ID 45336 //
     /* 2443194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443226 */     // MIs[0] policy
     /* 2443226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443236 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2443239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443260 */     // GIR_Coverage, 45336,
     /* 2443260 */     GIR_EraseRootFromParent_Done,
     /* 2443261 */   // Label 35371: @2443261
     /* 2443261 */   GIM_Try, /*On fail goto*//*Label 35372*/ GIMT_Encode4(2443333), // Rule ID 45337 //
     /* 2443266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443298 */     // MIs[0] policy
     /* 2443298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443308 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2443311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443332 */     // GIR_Coverage, 45337,
     /* 2443332 */     GIR_EraseRootFromParent_Done,
     /* 2443333 */   // Label 35372: @2443333
     /* 2443333 */   GIM_Try, /*On fail goto*//*Label 35373*/ GIMT_Encode4(2443405), // Rule ID 45408 //
     /* 2443338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443370 */     // MIs[0] policy
     /* 2443370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443380 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2443383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443404 */     // GIR_Coverage, 45408,
     /* 2443404 */     GIR_EraseRootFromParent_Done,
     /* 2443405 */   // Label 35373: @2443405
     /* 2443405 */   GIM_Try, /*On fail goto*//*Label 35374*/ GIMT_Encode4(2443477), // Rule ID 45409 //
     /* 2443410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443442 */     // MIs[0] policy
     /* 2443442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443452 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2443455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443476 */     // GIR_Coverage, 45409,
     /* 2443476 */     GIR_EraseRootFromParent_Done,
     /* 2443477 */   // Label 35374: @2443477
     /* 2443477 */   GIM_Reject,
     /* 2443478 */ // Label 35366: @2443478
     /* 2443478 */ GIM_Reject,
     /* 2443479 */ // Label 35304: @2443479
     /* 2443479 */ GIM_Try, /*On fail goto*//*Label 35375*/ GIMT_Encode4(2444111),
     /* 2443484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2443487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2443490 */   GIM_Try, /*On fail goto*//*Label 35376*/ GIMT_Encode4(2443573), // Rule ID 45378 //
     /* 2443495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2443498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443531 */     // MIs[1] Operand 1
     /* 2443531 */     // No operand predicates
     /* 2443531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443535 */     // MIs[0] policy
     /* 2443535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443547 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2443550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443572 */     // GIR_Coverage, 45378,
     /* 2443572 */     GIR_EraseRootFromParent_Done,
     /* 2443573 */   // Label 35376: @2443573
     /* 2443573 */   GIM_Try, /*On fail goto*//*Label 35377*/ GIMT_Encode4(2443656), // Rule ID 45379 //
     /* 2443578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2443581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443614 */     // MIs[1] Operand 1
     /* 2443614 */     // No operand predicates
     /* 2443614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443618 */     // MIs[0] policy
     /* 2443618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443630 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2443633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443642 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443655 */     // GIR_Coverage, 45379,
     /* 2443655 */     GIR_EraseRootFromParent_Done,
     /* 2443656 */   // Label 35377: @2443656
     /* 2443656 */   GIM_Try, /*On fail goto*//*Label 35378*/ GIMT_Encode4(2443739), // Rule ID 45438 //
     /* 2443661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2443664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443697 */     // MIs[1] Operand 1
     /* 2443697 */     // No operand predicates
     /* 2443697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443701 */     // MIs[0] policy
     /* 2443701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443713 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2443716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443725 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443738 */     // GIR_Coverage, 45438,
     /* 2443738 */     GIR_EraseRootFromParent_Done,
     /* 2443739 */   // Label 35378: @2443739
     /* 2443739 */   GIM_Try, /*On fail goto*//*Label 35379*/ GIMT_Encode4(2443822), // Rule ID 45439 //
     /* 2443744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2443747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443780 */     // MIs[1] Operand 1
     /* 2443780 */     // No operand predicates
     /* 2443780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443784 */     // MIs[0] policy
     /* 2443784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443796 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2443799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443808 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443821 */     // GIR_Coverage, 45439,
     /* 2443821 */     GIR_EraseRootFromParent_Done,
     /* 2443822 */   // Label 35379: @2443822
     /* 2443822 */   GIM_Try, /*On fail goto*//*Label 35380*/ GIMT_Encode4(2443894), // Rule ID 45380 //
     /* 2443827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2443830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443859 */     // MIs[0] policy
     /* 2443859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443869 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2443872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443880 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443893 */     // GIR_Coverage, 45380,
     /* 2443893 */     GIR_EraseRootFromParent_Done,
     /* 2443894 */   // Label 35380: @2443894
     /* 2443894 */   GIM_Try, /*On fail goto*//*Label 35381*/ GIMT_Encode4(2443966), // Rule ID 45381 //
     /* 2443899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2443902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443931 */     // MIs[0] policy
     /* 2443931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443941 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2443944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443952 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443965 */     // GIR_Coverage, 45381,
     /* 2443965 */     GIR_EraseRootFromParent_Done,
     /* 2443966 */   // Label 35381: @2443966
     /* 2443966 */   GIM_Try, /*On fail goto*//*Label 35382*/ GIMT_Encode4(2444038), // Rule ID 45440 //
     /* 2443971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2443974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444003 */     // MIs[0] policy
     /* 2444003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444013 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2444016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444024 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2444034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444037 */     // GIR_Coverage, 45440,
     /* 2444037 */     GIR_EraseRootFromParent_Done,
     /* 2444038 */   // Label 35382: @2444038
     /* 2444038 */   GIM_Try, /*On fail goto*//*Label 35383*/ GIMT_Encode4(2444110), // Rule ID 45441 //
     /* 2444043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2444046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2444052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2444059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2444063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2444067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444075 */     // MIs[0] policy
     /* 2444075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444085 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2444088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444096 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2444106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444109 */     // GIR_Coverage, 45441,
     /* 2444109 */     GIR_EraseRootFromParent_Done,
     /* 2444110 */   // Label 35383: @2444110
     /* 2444110 */   GIM_Reject,
     /* 2444111 */ // Label 35375: @2444111
     /* 2444111 */ GIM_Reject,
     /* 2444112 */ // Label 35305: @2444112
     /* 2444112 */ GIM_Try, /*On fail goto*//*Label 35384*/ GIMT_Encode4(2444434),
     /* 2444117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2444120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2444123 */   GIM_Try, /*On fail goto*//*Label 35385*/ GIMT_Encode4(2444206), // Rule ID 45310 //
     /* 2444128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444164 */     // MIs[1] Operand 1
     /* 2444164 */     // No operand predicates
     /* 2444164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444168 */     // MIs[0] policy
     /* 2444168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444180 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2444183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444192 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444205 */     // GIR_Coverage, 45310,
     /* 2444205 */     GIR_EraseRootFromParent_Done,
     /* 2444206 */   // Label 35385: @2444206
     /* 2444206 */   GIM_Try, /*On fail goto*//*Label 35386*/ GIMT_Encode4(2444289), // Rule ID 45311 //
     /* 2444211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444247 */     // MIs[1] Operand 1
     /* 2444247 */     // No operand predicates
     /* 2444247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444251 */     // MIs[0] policy
     /* 2444251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444263 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2444266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444288 */     // GIR_Coverage, 45311,
     /* 2444288 */     GIR_EraseRootFromParent_Done,
     /* 2444289 */   // Label 35386: @2444289
     /* 2444289 */   GIM_Try, /*On fail goto*//*Label 35387*/ GIMT_Encode4(2444361), // Rule ID 45312 //
     /* 2444294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444326 */     // MIs[0] policy
     /* 2444326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444336 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2444339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444347 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444360 */     // GIR_Coverage, 45312,
     /* 2444360 */     GIR_EraseRootFromParent_Done,
     /* 2444361 */   // Label 35387: @2444361
     /* 2444361 */   GIM_Try, /*On fail goto*//*Label 35388*/ GIMT_Encode4(2444433), // Rule ID 45313 //
     /* 2444366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444398 */     // MIs[0] policy
     /* 2444398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444408 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2444411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444419 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444432 */     // GIR_Coverage, 45313,
     /* 2444432 */     GIR_EraseRootFromParent_Done,
     /* 2444433 */   // Label 35388: @2444433
     /* 2444433 */   GIM_Reject,
     /* 2444434 */ // Label 35384: @2444434
     /* 2444434 */ GIM_Reject,
     /* 2444435 */ // Label 35306: @2444435
     /* 2444435 */ GIM_Try, /*On fail goto*//*Label 35389*/ GIMT_Encode4(2445067),
     /* 2444440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2444443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2444446 */   GIM_Try, /*On fail goto*//*Label 35390*/ GIMT_Encode4(2444529), // Rule ID 45330 //
     /* 2444451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444487 */     // MIs[1] Operand 1
     /* 2444487 */     // No operand predicates
     /* 2444487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444491 */     // MIs[0] policy
     /* 2444491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444503 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2444506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444515 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444528 */     // GIR_Coverage, 45330,
     /* 2444528 */     GIR_EraseRootFromParent_Done,
     /* 2444529 */   // Label 35390: @2444529
     /* 2444529 */   GIM_Try, /*On fail goto*//*Label 35391*/ GIMT_Encode4(2444612), // Rule ID 45331 //
     /* 2444534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444570 */     // MIs[1] Operand 1
     /* 2444570 */     // No operand predicates
     /* 2444570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444574 */     // MIs[0] policy
     /* 2444574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444586 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2444589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444598 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444611 */     // GIR_Coverage, 45331,
     /* 2444611 */     GIR_EraseRootFromParent_Done,
     /* 2444612 */   // Label 35391: @2444612
     /* 2444612 */   GIM_Try, /*On fail goto*//*Label 35392*/ GIMT_Encode4(2444695), // Rule ID 45402 //
     /* 2444617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444653 */     // MIs[1] Operand 1
     /* 2444653 */     // No operand predicates
     /* 2444653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444657 */     // MIs[0] policy
     /* 2444657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444669 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2444672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444691 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444694 */     // GIR_Coverage, 45402,
     /* 2444694 */     GIR_EraseRootFromParent_Done,
     /* 2444695 */   // Label 35392: @2444695
     /* 2444695 */   GIM_Try, /*On fail goto*//*Label 35393*/ GIMT_Encode4(2444778), // Rule ID 45403 //
     /* 2444700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444736 */     // MIs[1] Operand 1
     /* 2444736 */     // No operand predicates
     /* 2444736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444740 */     // MIs[0] policy
     /* 2444740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444752 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2444755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444764 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444777 */     // GIR_Coverage, 45403,
     /* 2444777 */     GIR_EraseRootFromParent_Done,
     /* 2444778 */   // Label 35393: @2444778
     /* 2444778 */   GIM_Try, /*On fail goto*//*Label 35394*/ GIMT_Encode4(2444850), // Rule ID 45332 //
     /* 2444783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444815 */     // MIs[0] policy
     /* 2444815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444825 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2444828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444849 */     // GIR_Coverage, 45332,
     /* 2444849 */     GIR_EraseRootFromParent_Done,
     /* 2444850 */   // Label 35394: @2444850
     /* 2444850 */   GIM_Try, /*On fail goto*//*Label 35395*/ GIMT_Encode4(2444922), // Rule ID 45333 //
     /* 2444855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444887 */     // MIs[0] policy
     /* 2444887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444897 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2444900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444921 */     // GIR_Coverage, 45333,
     /* 2444921 */     GIR_EraseRootFromParent_Done,
     /* 2444922 */   // Label 35395: @2444922
     /* 2444922 */   GIM_Try, /*On fail goto*//*Label 35396*/ GIMT_Encode4(2444994), // Rule ID 45404 //
     /* 2444927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444959 */     // MIs[0] policy
     /* 2444959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444969 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2444972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444980 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444993 */     // GIR_Coverage, 45404,
     /* 2444993 */     GIR_EraseRootFromParent_Done,
     /* 2444994 */   // Label 35396: @2444994
     /* 2444994 */   GIM_Try, /*On fail goto*//*Label 35397*/ GIMT_Encode4(2445066), // Rule ID 45405 //
     /* 2444999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445031 */     // MIs[0] policy
     /* 2445031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445041 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2445044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445052 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2445062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445065 */     // GIR_Coverage, 45405,
     /* 2445065 */     GIR_EraseRootFromParent_Done,
     /* 2445066 */   // Label 35397: @2445066
     /* 2445066 */   GIM_Reject,
     /* 2445067 */ // Label 35389: @2445067
     /* 2445067 */ GIM_Reject,
     /* 2445068 */ // Label 35307: @2445068
     /* 2445068 */ GIM_Try, /*On fail goto*//*Label 35398*/ GIMT_Encode4(2445700),
     /* 2445073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2445076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2445079 */   GIM_Try, /*On fail goto*//*Label 35399*/ GIMT_Encode4(2445162), // Rule ID 45366 //
     /* 2445084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445120 */     // MIs[1] Operand 1
     /* 2445120 */     // No operand predicates
     /* 2445120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445124 */     // MIs[0] policy
     /* 2445124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445136 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2445139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445148 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445161 */     // GIR_Coverage, 45366,
     /* 2445161 */     GIR_EraseRootFromParent_Done,
     /* 2445162 */   // Label 35399: @2445162
     /* 2445162 */   GIM_Try, /*On fail goto*//*Label 35400*/ GIMT_Encode4(2445245), // Rule ID 45367 //
     /* 2445167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445203 */     // MIs[1] Operand 1
     /* 2445203 */     // No operand predicates
     /* 2445203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445207 */     // MIs[0] policy
     /* 2445207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445219 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2445222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445244 */     // GIR_Coverage, 45367,
     /* 2445244 */     GIR_EraseRootFromParent_Done,
     /* 2445245 */   // Label 35400: @2445245
     /* 2445245 */   GIM_Try, /*On fail goto*//*Label 35401*/ GIMT_Encode4(2445328), // Rule ID 45426 //
     /* 2445250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445286 */     // MIs[1] Operand 1
     /* 2445286 */     // No operand predicates
     /* 2445286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445290 */     // MIs[0] policy
     /* 2445290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445302 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2445305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445314 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445327 */     // GIR_Coverage, 45426,
     /* 2445327 */     GIR_EraseRootFromParent_Done,
     /* 2445328 */   // Label 35401: @2445328
     /* 2445328 */   GIM_Try, /*On fail goto*//*Label 35402*/ GIMT_Encode4(2445411), // Rule ID 45427 //
     /* 2445333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445369 */     // MIs[1] Operand 1
     /* 2445369 */     // No operand predicates
     /* 2445369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445373 */     // MIs[0] policy
     /* 2445373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445385 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2445388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445410 */     // GIR_Coverage, 45427,
     /* 2445410 */     GIR_EraseRootFromParent_Done,
     /* 2445411 */   // Label 35402: @2445411
     /* 2445411 */   GIM_Try, /*On fail goto*//*Label 35403*/ GIMT_Encode4(2445483), // Rule ID 45368 //
     /* 2445416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445448 */     // MIs[0] policy
     /* 2445448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445458 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2445461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445482 */     // GIR_Coverage, 45368,
     /* 2445482 */     GIR_EraseRootFromParent_Done,
     /* 2445483 */   // Label 35403: @2445483
     /* 2445483 */   GIM_Try, /*On fail goto*//*Label 35404*/ GIMT_Encode4(2445555), // Rule ID 45369 //
     /* 2445488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445520 */     // MIs[0] policy
     /* 2445520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445530 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2445533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445554 */     // GIR_Coverage, 45369,
     /* 2445554 */     GIR_EraseRootFromParent_Done,
     /* 2445555 */   // Label 35404: @2445555
     /* 2445555 */   GIM_Try, /*On fail goto*//*Label 35405*/ GIMT_Encode4(2445627), // Rule ID 45428 //
     /* 2445560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445592 */     // MIs[0] policy
     /* 2445592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445602 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2445605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445626 */     // GIR_Coverage, 45428,
     /* 2445626 */     GIR_EraseRootFromParent_Done,
     /* 2445627 */   // Label 35405: @2445627
     /* 2445627 */   GIM_Try, /*On fail goto*//*Label 35406*/ GIMT_Encode4(2445699), // Rule ID 45429 //
     /* 2445632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445664 */     // MIs[0] policy
     /* 2445664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445674 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2445677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445698 */     // GIR_Coverage, 45429,
     /* 2445698 */     GIR_EraseRootFromParent_Done,
     /* 2445699 */   // Label 35406: @2445699
     /* 2445699 */   GIM_Reject,
     /* 2445700 */ // Label 35398: @2445700
     /* 2445700 */ GIM_Reject,
     /* 2445701 */ // Label 35308: @2445701
     /* 2445701 */ GIM_Try, /*On fail goto*//*Label 35407*/ GIMT_Encode4(2446333),
     /* 2445706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2445709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2445712 */   GIM_Try, /*On fail goto*//*Label 35408*/ GIMT_Encode4(2445795), // Rule ID 45382 //
     /* 2445717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2445720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2445733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445753 */     // MIs[1] Operand 1
     /* 2445753 */     // No operand predicates
     /* 2445753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445757 */     // MIs[0] policy
     /* 2445757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445769 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2445772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445794 */     // GIR_Coverage, 45382,
     /* 2445794 */     GIR_EraseRootFromParent_Done,
     /* 2445795 */   // Label 35408: @2445795
     /* 2445795 */   GIM_Try, /*On fail goto*//*Label 35409*/ GIMT_Encode4(2445878), // Rule ID 45383 //
     /* 2445800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2445803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2445816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445836 */     // MIs[1] Operand 1
     /* 2445836 */     // No operand predicates
     /* 2445836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445840 */     // MIs[0] policy
     /* 2445840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445852 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2445855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445864 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445877 */     // GIR_Coverage, 45383,
     /* 2445877 */     GIR_EraseRootFromParent_Done,
     /* 2445878 */   // Label 35409: @2445878
     /* 2445878 */   GIM_Try, /*On fail goto*//*Label 35410*/ GIMT_Encode4(2445961), // Rule ID 45442 //
     /* 2445883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2445886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2445899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445919 */     // MIs[1] Operand 1
     /* 2445919 */     // No operand predicates
     /* 2445919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445923 */     // MIs[0] policy
     /* 2445923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445935 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2445938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445960 */     // GIR_Coverage, 45442,
     /* 2445960 */     GIR_EraseRootFromParent_Done,
     /* 2445961 */   // Label 35410: @2445961
     /* 2445961 */   GIM_Try, /*On fail goto*//*Label 35411*/ GIMT_Encode4(2446044), // Rule ID 45443 //
     /* 2445966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2445969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2445982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446002 */     // MIs[1] Operand 1
     /* 2446002 */     // No operand predicates
     /* 2446002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446006 */     // MIs[0] policy
     /* 2446006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446018 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2446021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446030 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2446040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446043 */     // GIR_Coverage, 45443,
     /* 2446043 */     GIR_EraseRootFromParent_Done,
     /* 2446044 */   // Label 35411: @2446044
     /* 2446044 */   GIM_Try, /*On fail goto*//*Label 35412*/ GIMT_Encode4(2446116), // Rule ID 45384 //
     /* 2446049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2446052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2446065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2446069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2446073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446081 */     // MIs[0] policy
     /* 2446081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446091 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2446094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446102 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2446112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446115 */     // GIR_Coverage, 45384,
     /* 2446115 */     GIR_EraseRootFromParent_Done,
     /* 2446116 */   // Label 35412: @2446116
     /* 2446116 */   GIM_Try, /*On fail goto*//*Label 35413*/ GIMT_Encode4(2446188), // Rule ID 45385 //
     /* 2446121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2446124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2446137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2446141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2446145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446153 */     // MIs[0] policy
     /* 2446153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446163 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2446166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446174 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2446184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446187 */     // GIR_Coverage, 45385,
     /* 2446187 */     GIR_EraseRootFromParent_Done,
     /* 2446188 */   // Label 35413: @2446188
     /* 2446188 */   GIM_Try, /*On fail goto*//*Label 35414*/ GIMT_Encode4(2446260), // Rule ID 45444 //
     /* 2446193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2446196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2446209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2446213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2446217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446225 */     // MIs[0] policy
     /* 2446225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446235 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2446238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446246 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2446256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446259 */     // GIR_Coverage, 45444,
     /* 2446259 */     GIR_EraseRootFromParent_Done,
     /* 2446260 */   // Label 35414: @2446260
     /* 2446260 */   GIM_Try, /*On fail goto*//*Label 35415*/ GIMT_Encode4(2446332), // Rule ID 45445 //
     /* 2446265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2446268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2446281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2446285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2446289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446297 */     // MIs[0] policy
     /* 2446297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446307 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2446310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446318 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2446328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446331 */     // GIR_Coverage, 45445,
     /* 2446331 */     GIR_EraseRootFromParent_Done,
     /* 2446332 */   // Label 35415: @2446332
     /* 2446332 */   GIM_Reject,
     /* 2446333 */ // Label 35407: @2446333
     /* 2446333 */ GIM_Reject,
     /* 2446334 */ // Label 35309: @2446334
     /* 2446334 */ GIM_Try, /*On fail goto*//*Label 35416*/ GIMT_Encode4(2446656),
     /* 2446339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2446342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2446345 */   GIM_Try, /*On fail goto*//*Label 35417*/ GIMT_Encode4(2446428), // Rule ID 45326 //
     /* 2446350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446386 */     // MIs[1] Operand 1
     /* 2446386 */     // No operand predicates
     /* 2446386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446390 */     // MIs[0] policy
     /* 2446390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446402 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2446405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446414 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2446424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446427 */     // GIR_Coverage, 45326,
     /* 2446427 */     GIR_EraseRootFromParent_Done,
     /* 2446428 */   // Label 35417: @2446428
     /* 2446428 */   GIM_Try, /*On fail goto*//*Label 35418*/ GIMT_Encode4(2446511), // Rule ID 45327 //
     /* 2446433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446469 */     // MIs[1] Operand 1
     /* 2446469 */     // No operand predicates
     /* 2446469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446473 */     // MIs[0] policy
     /* 2446473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446485 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2446488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2446507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446510 */     // GIR_Coverage, 45327,
     /* 2446510 */     GIR_EraseRootFromParent_Done,
     /* 2446511 */   // Label 35418: @2446511
     /* 2446511 */   GIM_Try, /*On fail goto*//*Label 35419*/ GIMT_Encode4(2446583), // Rule ID 45328 //
     /* 2446516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446548 */     // MIs[0] policy
     /* 2446548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446558 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2446561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2446579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446582 */     // GIR_Coverage, 45328,
     /* 2446582 */     GIR_EraseRootFromParent_Done,
     /* 2446583 */   // Label 35419: @2446583
     /* 2446583 */   GIM_Try, /*On fail goto*//*Label 35420*/ GIMT_Encode4(2446655), // Rule ID 45329 //
     /* 2446588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446620 */     // MIs[0] policy
     /* 2446620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446630 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2446633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2446651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446654 */     // GIR_Coverage, 45329,
     /* 2446654 */     GIR_EraseRootFromParent_Done,
     /* 2446655 */   // Label 35420: @2446655
     /* 2446655 */   GIM_Reject,
     /* 2446656 */ // Label 35416: @2446656
     /* 2446656 */ GIM_Reject,
     /* 2446657 */ // Label 35310: @2446657
     /* 2446657 */ GIM_Try, /*On fail goto*//*Label 35421*/ GIMT_Encode4(2447289),
     /* 2446662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2446665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2446668 */   GIM_Try, /*On fail goto*//*Label 35422*/ GIMT_Encode4(2446751), // Rule ID 45354 //
     /* 2446673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2446689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446709 */     // MIs[1] Operand 1
     /* 2446709 */     // No operand predicates
     /* 2446709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446713 */     // MIs[0] policy
     /* 2446713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446725 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2446728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446750 */     // GIR_Coverage, 45354,
     /* 2446750 */     GIR_EraseRootFromParent_Done,
     /* 2446751 */   // Label 35422: @2446751
     /* 2446751 */   GIM_Try, /*On fail goto*//*Label 35423*/ GIMT_Encode4(2446834), // Rule ID 45355 //
     /* 2446756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2446772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446792 */     // MIs[1] Operand 1
     /* 2446792 */     // No operand predicates
     /* 2446792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446796 */     // MIs[0] policy
     /* 2446796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446808 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2446811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446820 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446833 */     // GIR_Coverage, 45355,
     /* 2446833 */     GIR_EraseRootFromParent_Done,
     /* 2446834 */   // Label 35423: @2446834
     /* 2446834 */   GIM_Try, /*On fail goto*//*Label 35424*/ GIMT_Encode4(2446917), // Rule ID 45414 //
     /* 2446839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2446855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446875 */     // MIs[1] Operand 1
     /* 2446875 */     // No operand predicates
     /* 2446875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446879 */     // MIs[0] policy
     /* 2446879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446891 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2446894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446916 */     // GIR_Coverage, 45414,
     /* 2446916 */     GIR_EraseRootFromParent_Done,
     /* 2446917 */   // Label 35424: @2446917
     /* 2446917 */   GIM_Try, /*On fail goto*//*Label 35425*/ GIMT_Encode4(2447000), // Rule ID 45415 //
     /* 2446922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2446938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446958 */     // MIs[1] Operand 1
     /* 2446958 */     // No operand predicates
     /* 2446958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446962 */     // MIs[0] policy
     /* 2446962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446974 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2446977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446986 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446996 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446999 */     // GIR_Coverage, 45415,
     /* 2446999 */     GIR_EraseRootFromParent_Done,
     /* 2447000 */   // Label 35425: @2447000
     /* 2447000 */   GIM_Try, /*On fail goto*//*Label 35426*/ GIMT_Encode4(2447072), // Rule ID 45356 //
     /* 2447005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2447021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447037 */     // MIs[0] policy
     /* 2447037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447047 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2447050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447058 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2447068 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447071 */     // GIR_Coverage, 45356,
     /* 2447071 */     GIR_EraseRootFromParent_Done,
     /* 2447072 */   // Label 35426: @2447072
     /* 2447072 */   GIM_Try, /*On fail goto*//*Label 35427*/ GIMT_Encode4(2447144), // Rule ID 45357 //
     /* 2447077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2447093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447109 */     // MIs[0] policy
     /* 2447109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447119 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2447122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447130 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2447140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447143 */     // GIR_Coverage, 45357,
     /* 2447143 */     GIR_EraseRootFromParent_Done,
     /* 2447144 */   // Label 35427: @2447144
     /* 2447144 */   GIM_Try, /*On fail goto*//*Label 35428*/ GIMT_Encode4(2447216), // Rule ID 45416 //
     /* 2447149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2447165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447181 */     // MIs[0] policy
     /* 2447181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447191 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2447194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447202 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2447212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447215 */     // GIR_Coverage, 45416,
     /* 2447215 */     GIR_EraseRootFromParent_Done,
     /* 2447216 */   // Label 35428: @2447216
     /* 2447216 */   GIM_Try, /*On fail goto*//*Label 35429*/ GIMT_Encode4(2447288), // Rule ID 45417 //
     /* 2447221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2447237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447253 */     // MIs[0] policy
     /* 2447253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447263 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2447266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447274 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2447284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447287 */     // GIR_Coverage, 45417,
     /* 2447287 */     GIR_EraseRootFromParent_Done,
     /* 2447288 */   // Label 35429: @2447288
     /* 2447288 */   GIM_Reject,
     /* 2447289 */ // Label 35421: @2447289
     /* 2447289 */ GIM_Reject,
     /* 2447290 */ // Label 35311: @2447290
     /* 2447290 */ GIM_Try, /*On fail goto*//*Label 35430*/ GIMT_Encode4(2447922),
     /* 2447295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2447298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2447301 */   GIM_Try, /*On fail goto*//*Label 35431*/ GIMT_Encode4(2447384), // Rule ID 45370 //
     /* 2447306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447342 */     // MIs[1] Operand 1
     /* 2447342 */     // No operand predicates
     /* 2447342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447346 */     // MIs[0] policy
     /* 2447346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447358 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2447361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447370 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447380 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447383 */     // GIR_Coverage, 45370,
     /* 2447383 */     GIR_EraseRootFromParent_Done,
     /* 2447384 */   // Label 35431: @2447384
     /* 2447384 */   GIM_Try, /*On fail goto*//*Label 35432*/ GIMT_Encode4(2447467), // Rule ID 45371 //
     /* 2447389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447425 */     // MIs[1] Operand 1
     /* 2447425 */     // No operand predicates
     /* 2447425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447429 */     // MIs[0] policy
     /* 2447429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447441 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2447444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447466 */     // GIR_Coverage, 45371,
     /* 2447466 */     GIR_EraseRootFromParent_Done,
     /* 2447467 */   // Label 35432: @2447467
     /* 2447467 */   GIM_Try, /*On fail goto*//*Label 35433*/ GIMT_Encode4(2447550), // Rule ID 45430 //
     /* 2447472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447508 */     // MIs[1] Operand 1
     /* 2447508 */     // No operand predicates
     /* 2447508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447512 */     // MIs[0] policy
     /* 2447512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447524 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2447527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447549 */     // GIR_Coverage, 45430,
     /* 2447549 */     GIR_EraseRootFromParent_Done,
     /* 2447550 */   // Label 35433: @2447550
     /* 2447550 */   GIM_Try, /*On fail goto*//*Label 35434*/ GIMT_Encode4(2447633), // Rule ID 45431 //
     /* 2447555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447591 */     // MIs[1] Operand 1
     /* 2447591 */     // No operand predicates
     /* 2447591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447595 */     // MIs[0] policy
     /* 2447595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447607 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2447610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447632 */     // GIR_Coverage, 45431,
     /* 2447632 */     GIR_EraseRootFromParent_Done,
     /* 2447633 */   // Label 35434: @2447633
     /* 2447633 */   GIM_Try, /*On fail goto*//*Label 35435*/ GIMT_Encode4(2447705), // Rule ID 45372 //
     /* 2447638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447670 */     // MIs[0] policy
     /* 2447670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447680 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2447683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447691 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447704 */     // GIR_Coverage, 45372,
     /* 2447704 */     GIR_EraseRootFromParent_Done,
     /* 2447705 */   // Label 35435: @2447705
     /* 2447705 */   GIM_Try, /*On fail goto*//*Label 35436*/ GIMT_Encode4(2447777), // Rule ID 45373 //
     /* 2447710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447742 */     // MIs[0] policy
     /* 2447742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447752 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2447755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447776 */     // GIR_Coverage, 45373,
     /* 2447776 */     GIR_EraseRootFromParent_Done,
     /* 2447777 */   // Label 35436: @2447777
     /* 2447777 */   GIM_Try, /*On fail goto*//*Label 35437*/ GIMT_Encode4(2447849), // Rule ID 45432 //
     /* 2447782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447814 */     // MIs[0] policy
     /* 2447814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447824 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2447827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447845 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447848 */     // GIR_Coverage, 45432,
     /* 2447848 */     GIR_EraseRootFromParent_Done,
     /* 2447849 */   // Label 35437: @2447849
     /* 2447849 */   GIM_Try, /*On fail goto*//*Label 35438*/ GIMT_Encode4(2447921), // Rule ID 45433 //
     /* 2447854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447886 */     // MIs[0] policy
     /* 2447886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447896 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2447899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447917 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447920 */     // GIR_Coverage, 45433,
     /* 2447920 */     GIR_EraseRootFromParent_Done,
     /* 2447921 */   // Label 35438: @2447921
     /* 2447921 */   GIM_Reject,
     /* 2447922 */ // Label 35430: @2447922
     /* 2447922 */ GIM_Reject,
     /* 2447923 */ // Label 35312: @2447923
     /* 2447923 */ GIM_Try, /*On fail goto*//*Label 35439*/ GIMT_Encode4(2448555),
     /* 2447928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2447931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2447934 */   GIM_Try, /*On fail goto*//*Label 35440*/ GIMT_Encode4(2448017), // Rule ID 45386 //
     /* 2447939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2447955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447975 */     // MIs[1] Operand 1
     /* 2447975 */     // No operand predicates
     /* 2447975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447979 */     // MIs[0] policy
     /* 2447979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447991 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2447994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448003 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2448013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448016 */     // GIR_Coverage, 45386,
     /* 2448016 */     GIR_EraseRootFromParent_Done,
     /* 2448017 */   // Label 35440: @2448017
     /* 2448017 */   GIM_Try, /*On fail goto*//*Label 35441*/ GIMT_Encode4(2448100), // Rule ID 45387 //
     /* 2448022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2448025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2448038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448058 */     // MIs[1] Operand 1
     /* 2448058 */     // No operand predicates
     /* 2448058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448062 */     // MIs[0] policy
     /* 2448062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448074 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2448077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2448096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448099 */     // GIR_Coverage, 45387,
     /* 2448099 */     GIR_EraseRootFromParent_Done,
     /* 2448100 */   // Label 35441: @2448100
     /* 2448100 */   GIM_Try, /*On fail goto*//*Label 35442*/ GIMT_Encode4(2448183), // Rule ID 45446 //
     /* 2448105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2448108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2448121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448141 */     // MIs[1] Operand 1
     /* 2448141 */     // No operand predicates
     /* 2448141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448145 */     // MIs[0] policy
     /* 2448145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448157 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2448160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2448179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448182 */     // GIR_Coverage, 45446,
     /* 2448182 */     GIR_EraseRootFromParent_Done,
     /* 2448183 */   // Label 35442: @2448183
     /* 2448183 */   GIM_Try, /*On fail goto*//*Label 35443*/ GIMT_Encode4(2448266), // Rule ID 45447 //
     /* 2448188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2448191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2448204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448224 */     // MIs[1] Operand 1
     /* 2448224 */     // No operand predicates
     /* 2448224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448228 */     // MIs[0] policy
     /* 2448228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448240 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2448243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448252 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2448262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448265 */     // GIR_Coverage, 45447,
     /* 2448265 */     GIR_EraseRootFromParent_Done,
     /* 2448266 */   // Label 35443: @2448266
     /* 2448266 */   GIM_Try, /*On fail goto*//*Label 35444*/ GIMT_Encode4(2448338), // Rule ID 45388 //
     /* 2448271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2448274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2448287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448303 */     // MIs[0] policy
     /* 2448303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448313 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2448316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448324 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2448334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448337 */     // GIR_Coverage, 45388,
     /* 2448337 */     GIR_EraseRootFromParent_Done,
     /* 2448338 */   // Label 35444: @2448338
     /* 2448338 */   GIM_Try, /*On fail goto*//*Label 35445*/ GIMT_Encode4(2448410), // Rule ID 45389 //
     /* 2448343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2448346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2448359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448375 */     // MIs[0] policy
     /* 2448375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448385 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2448388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448396 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2448406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448409 */     // GIR_Coverage, 45389,
     /* 2448409 */     GIR_EraseRootFromParent_Done,
     /* 2448410 */   // Label 35445: @2448410
     /* 2448410 */   GIM_Try, /*On fail goto*//*Label 35446*/ GIMT_Encode4(2448482), // Rule ID 45448 //
     /* 2448415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2448418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2448431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448447 */     // MIs[0] policy
     /* 2448447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448457 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2448460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448468 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2448478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448481 */     // GIR_Coverage, 45448,
     /* 2448481 */     GIR_EraseRootFromParent_Done,
     /* 2448482 */   // Label 35446: @2448482
     /* 2448482 */   GIM_Try, /*On fail goto*//*Label 35447*/ GIMT_Encode4(2448554), // Rule ID 45449 //
     /* 2448487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2448490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2448503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448519 */     // MIs[0] policy
     /* 2448519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448529 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2448532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448540 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2448550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448553 */     // GIR_Coverage, 45449,
     /* 2448553 */     GIR_EraseRootFromParent_Done,
     /* 2448554 */   // Label 35447: @2448554
     /* 2448554 */   GIM_Reject,
     /* 2448555 */ // Label 35439: @2448555
     /* 2448555 */ GIM_Reject,
     /* 2448556 */ // Label 35313: @2448556
     /* 2448556 */ GIM_Try, /*On fail goto*//*Label 35448*/ GIMT_Encode4(2448878),
     /* 2448561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2448564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2448567 */   GIM_Try, /*On fail goto*//*Label 35449*/ GIMT_Encode4(2448650), // Rule ID 45342 //
     /* 2448572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448608 */     // MIs[1] Operand 1
     /* 2448608 */     // No operand predicates
     /* 2448608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448612 */     // MIs[0] policy
     /* 2448612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448624 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2448627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448636 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2448646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448649 */     // GIR_Coverage, 45342,
     /* 2448649 */     GIR_EraseRootFromParent_Done,
     /* 2448650 */   // Label 35449: @2448650
     /* 2448650 */   GIM_Try, /*On fail goto*//*Label 35450*/ GIMT_Encode4(2448733), // Rule ID 45343 //
     /* 2448655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448691 */     // MIs[1] Operand 1
     /* 2448691 */     // No operand predicates
     /* 2448691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448695 */     // MIs[0] policy
     /* 2448695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448707 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2448710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2448729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448732 */     // GIR_Coverage, 45343,
     /* 2448732 */     GIR_EraseRootFromParent_Done,
     /* 2448733 */   // Label 35450: @2448733
     /* 2448733 */   GIM_Try, /*On fail goto*//*Label 35451*/ GIMT_Encode4(2448805), // Rule ID 45344 //
     /* 2448738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448770 */     // MIs[0] policy
     /* 2448770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448780 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2448783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2448801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448804 */     // GIR_Coverage, 45344,
     /* 2448804 */     GIR_EraseRootFromParent_Done,
     /* 2448805 */   // Label 35451: @2448805
     /* 2448805 */   GIM_Try, /*On fail goto*//*Label 35452*/ GIMT_Encode4(2448877), // Rule ID 45345 //
     /* 2448810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448842 */     // MIs[0] policy
     /* 2448842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448852 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2448855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2448873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448876 */     // GIR_Coverage, 45345,
     /* 2448876 */     GIR_EraseRootFromParent_Done,
     /* 2448877 */   // Label 35452: @2448877
     /* 2448877 */   GIM_Reject,
     /* 2448878 */ // Label 35448: @2448878
     /* 2448878 */ GIM_Reject,
     /* 2448879 */ // Label 35314: @2448879
     /* 2448879 */ GIM_Try, /*On fail goto*//*Label 35453*/ GIMT_Encode4(2449511),
     /* 2448884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2448887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2448890 */   GIM_Try, /*On fail goto*//*Label 35454*/ GIMT_Encode4(2448973), // Rule ID 45358 //
     /* 2448895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2448911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448931 */     // MIs[1] Operand 1
     /* 2448931 */     // No operand predicates
     /* 2448931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448935 */     // MIs[0] policy
     /* 2448935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448947 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2448950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448972 */     // GIR_Coverage, 45358,
     /* 2448972 */     GIR_EraseRootFromParent_Done,
     /* 2448973 */   // Label 35454: @2448973
     /* 2448973 */   GIM_Try, /*On fail goto*//*Label 35455*/ GIMT_Encode4(2449056), // Rule ID 45359 //
     /* 2448978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2448994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449014 */     // MIs[1] Operand 1
     /* 2449014 */     // No operand predicates
     /* 2449014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449018 */     // MIs[0] policy
     /* 2449018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449030 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2449033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449042 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2449052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449055 */     // GIR_Coverage, 45359,
     /* 2449055 */     GIR_EraseRootFromParent_Done,
     /* 2449056 */   // Label 35455: @2449056
     /* 2449056 */   GIM_Try, /*On fail goto*//*Label 35456*/ GIMT_Encode4(2449139), // Rule ID 45418 //
     /* 2449061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449097 */     // MIs[1] Operand 1
     /* 2449097 */     // No operand predicates
     /* 2449097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449101 */     // MIs[0] policy
     /* 2449101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449113 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2449116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2449135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449138 */     // GIR_Coverage, 45418,
     /* 2449138 */     GIR_EraseRootFromParent_Done,
     /* 2449139 */   // Label 35456: @2449139
     /* 2449139 */   GIM_Try, /*On fail goto*//*Label 35457*/ GIMT_Encode4(2449222), // Rule ID 45419 //
     /* 2449144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449176 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449180 */     // MIs[1] Operand 1
     /* 2449180 */     // No operand predicates
     /* 2449180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449184 */     // MIs[0] policy
     /* 2449184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449196 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2449199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449208 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2449218 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449221 */     // GIR_Coverage, 45419,
     /* 2449221 */     GIR_EraseRootFromParent_Done,
     /* 2449222 */   // Label 35457: @2449222
     /* 2449222 */   GIM_Try, /*On fail goto*//*Label 35458*/ GIMT_Encode4(2449294), // Rule ID 45360 //
     /* 2449227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449259 */     // MIs[0] policy
     /* 2449259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449269 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2449272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449280 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2449290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449293 */     // GIR_Coverage, 45360,
     /* 2449293 */     GIR_EraseRootFromParent_Done,
     /* 2449294 */   // Label 35458: @2449294
     /* 2449294 */   GIM_Try, /*On fail goto*//*Label 35459*/ GIMT_Encode4(2449366), // Rule ID 45361 //
     /* 2449299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449331 */     // MIs[0] policy
     /* 2449331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449341 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2449344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449352 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2449362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449365 */     // GIR_Coverage, 45361,
     /* 2449365 */     GIR_EraseRootFromParent_Done,
     /* 2449366 */   // Label 35459: @2449366
     /* 2449366 */   GIM_Try, /*On fail goto*//*Label 35460*/ GIMT_Encode4(2449438), // Rule ID 45420 //
     /* 2449371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449403 */     // MIs[0] policy
     /* 2449403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449413 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2449416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449424 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2449434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449437 */     // GIR_Coverage, 45420,
     /* 2449437 */     GIR_EraseRootFromParent_Done,
     /* 2449438 */   // Label 35460: @2449438
     /* 2449438 */   GIM_Try, /*On fail goto*//*Label 35461*/ GIMT_Encode4(2449510), // Rule ID 45421 //
     /* 2449443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449475 */     // MIs[0] policy
     /* 2449475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449485 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2449488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449496 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2449506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449509 */     // GIR_Coverage, 45421,
     /* 2449509 */     GIR_EraseRootFromParent_Done,
     /* 2449510 */   // Label 35461: @2449510
     /* 2449510 */   GIM_Reject,
     /* 2449511 */ // Label 35453: @2449511
     /* 2449511 */ GIM_Reject,
     /* 2449512 */ // Label 35315: @2449512
     /* 2449512 */ GIM_Try, /*On fail goto*//*Label 35462*/ GIMT_Encode4(2450144),
     /* 2449517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2449520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2449523 */   GIM_Try, /*On fail goto*//*Label 35463*/ GIMT_Encode4(2449606), // Rule ID 45374 //
     /* 2449528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449564 */     // MIs[1] Operand 1
     /* 2449564 */     // No operand predicates
     /* 2449564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449568 */     // MIs[0] policy
     /* 2449568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449580 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2449583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449592 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449602 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449605 */     // GIR_Coverage, 45374,
     /* 2449605 */     GIR_EraseRootFromParent_Done,
     /* 2449606 */   // Label 35463: @2449606
     /* 2449606 */   GIM_Try, /*On fail goto*//*Label 35464*/ GIMT_Encode4(2449689), // Rule ID 45375 //
     /* 2449611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449647 */     // MIs[1] Operand 1
     /* 2449647 */     // No operand predicates
     /* 2449647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449651 */     // MIs[0] policy
     /* 2449651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449663 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2449666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449688 */     // GIR_Coverage, 45375,
     /* 2449688 */     GIR_EraseRootFromParent_Done,
     /* 2449689 */   // Label 35464: @2449689
     /* 2449689 */   GIM_Try, /*On fail goto*//*Label 35465*/ GIMT_Encode4(2449772), // Rule ID 45434 //
     /* 2449694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449730 */     // MIs[1] Operand 1
     /* 2449730 */     // No operand predicates
     /* 2449730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449734 */     // MIs[0] policy
     /* 2449734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449746 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2449749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449758 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449771 */     // GIR_Coverage, 45434,
     /* 2449771 */     GIR_EraseRootFromParent_Done,
     /* 2449772 */   // Label 35465: @2449772
     /* 2449772 */   GIM_Try, /*On fail goto*//*Label 35466*/ GIMT_Encode4(2449855), // Rule ID 45435 //
     /* 2449777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449813 */     // MIs[1] Operand 1
     /* 2449813 */     // No operand predicates
     /* 2449813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449817 */     // MIs[0] policy
     /* 2449817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449829 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2449832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449854 */     // GIR_Coverage, 45435,
     /* 2449854 */     GIR_EraseRootFromParent_Done,
     /* 2449855 */   // Label 35466: @2449855
     /* 2449855 */   GIM_Try, /*On fail goto*//*Label 35467*/ GIMT_Encode4(2449927), // Rule ID 45376 //
     /* 2449860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449892 */     // MIs[0] policy
     /* 2449892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449902 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2449905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449926 */     // GIR_Coverage, 45376,
     /* 2449926 */     GIR_EraseRootFromParent_Done,
     /* 2449927 */   // Label 35467: @2449927
     /* 2449927 */   GIM_Try, /*On fail goto*//*Label 35468*/ GIMT_Encode4(2449999), // Rule ID 45377 //
     /* 2449932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449964 */     // MIs[0] policy
     /* 2449964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449974 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2449977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449998 */     // GIR_Coverage, 45377,
     /* 2449998 */     GIR_EraseRootFromParent_Done,
     /* 2449999 */   // Label 35468: @2449999
     /* 2449999 */   GIM_Try, /*On fail goto*//*Label 35469*/ GIMT_Encode4(2450071), // Rule ID 45436 //
     /* 2450004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2450013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450036 */     // MIs[0] policy
     /* 2450036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450046 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2450067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450070 */     // GIR_Coverage, 45436,
     /* 2450070 */     GIR_EraseRootFromParent_Done,
     /* 2450071 */   // Label 35469: @2450071
     /* 2450071 */   GIM_Try, /*On fail goto*//*Label 35470*/ GIMT_Encode4(2450143), // Rule ID 45437 //
     /* 2450076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2450085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450108 */     // MIs[0] policy
     /* 2450108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450118 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2450139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450142 */     // GIR_Coverage, 45437,
     /* 2450142 */     GIR_EraseRootFromParent_Done,
     /* 2450143 */   // Label 35470: @2450143
     /* 2450143 */   GIM_Reject,
     /* 2450144 */ // Label 35462: @2450144
     /* 2450144 */ GIM_Reject,
     /* 2450145 */ // Label 35316: @2450145
     /* 2450145 */ GIM_Try, /*On fail goto*//*Label 35471*/ GIMT_Encode4(2450467),
     /* 2450150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2450153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2450156 */   GIM_Try, /*On fail goto*//*Label 35472*/ GIMT_Encode4(2450239), // Rule ID 45346 //
     /* 2450161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2450177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450197 */     // MIs[1] Operand 1
     /* 2450197 */     // No operand predicates
     /* 2450197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450201 */     // MIs[0] policy
     /* 2450201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450213 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2450216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450238 */     // GIR_Coverage, 45346,
     /* 2450238 */     GIR_EraseRootFromParent_Done,
     /* 2450239 */   // Label 35472: @2450239
     /* 2450239 */   GIM_Try, /*On fail goto*//*Label 35473*/ GIMT_Encode4(2450322), // Rule ID 45347 //
     /* 2450244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2450260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450280 */     // MIs[1] Operand 1
     /* 2450280 */     // No operand predicates
     /* 2450280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450284 */     // MIs[0] policy
     /* 2450284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450296 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2450299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450321 */     // GIR_Coverage, 45347,
     /* 2450321 */     GIR_EraseRootFromParent_Done,
     /* 2450322 */   // Label 35473: @2450322
     /* 2450322 */   GIM_Try, /*On fail goto*//*Label 35474*/ GIMT_Encode4(2450394), // Rule ID 45348 //
     /* 2450327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2450343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450359 */     // MIs[0] policy
     /* 2450359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450369 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2450372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450393 */     // GIR_Coverage, 45348,
     /* 2450393 */     GIR_EraseRootFromParent_Done,
     /* 2450394 */   // Label 35474: @2450394
     /* 2450394 */   GIM_Try, /*On fail goto*//*Label 35475*/ GIMT_Encode4(2450466), // Rule ID 45349 //
     /* 2450399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2450415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450431 */     // MIs[0] policy
     /* 2450431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450441 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2450444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450465 */     // GIR_Coverage, 45349,
     /* 2450465 */     GIR_EraseRootFromParent_Done,
     /* 2450466 */   // Label 35475: @2450466
     /* 2450466 */   GIM_Reject,
     /* 2450467 */ // Label 35471: @2450467
     /* 2450467 */ GIM_Reject,
     /* 2450468 */ // Label 35317: @2450468
     /* 2450468 */ GIM_Try, /*On fail goto*//*Label 35476*/ GIMT_Encode4(2451100),
     /* 2450473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2450476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2450479 */   GIM_Try, /*On fail goto*//*Label 35477*/ GIMT_Encode4(2450562), // Rule ID 45362 //
     /* 2450484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450520 */     // MIs[1] Operand 1
     /* 2450520 */     // No operand predicates
     /* 2450520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450524 */     // MIs[0] policy
     /* 2450524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450536 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2450539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450561 */     // GIR_Coverage, 45362,
     /* 2450561 */     GIR_EraseRootFromParent_Done,
     /* 2450562 */   // Label 35477: @2450562
     /* 2450562 */   GIM_Try, /*On fail goto*//*Label 35478*/ GIMT_Encode4(2450645), // Rule ID 45363 //
     /* 2450567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450603 */     // MIs[1] Operand 1
     /* 2450603 */     // No operand predicates
     /* 2450603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450607 */     // MIs[0] policy
     /* 2450607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450619 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2450622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450644 */     // GIR_Coverage, 45363,
     /* 2450644 */     GIR_EraseRootFromParent_Done,
     /* 2450645 */   // Label 35478: @2450645
     /* 2450645 */   GIM_Try, /*On fail goto*//*Label 35479*/ GIMT_Encode4(2450728), // Rule ID 45422 //
     /* 2450650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450686 */     // MIs[1] Operand 1
     /* 2450686 */     // No operand predicates
     /* 2450686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450690 */     // MIs[0] policy
     /* 2450690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450702 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2450705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450714 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450727 */     // GIR_Coverage, 45422,
     /* 2450727 */     GIR_EraseRootFromParent_Done,
     /* 2450728 */   // Label 35479: @2450728
     /* 2450728 */   GIM_Try, /*On fail goto*//*Label 35480*/ GIMT_Encode4(2450811), // Rule ID 45423 //
     /* 2450733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450769 */     // MIs[1] Operand 1
     /* 2450769 */     // No operand predicates
     /* 2450769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450773 */     // MIs[0] policy
     /* 2450773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450785 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2450788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450810 */     // GIR_Coverage, 45423,
     /* 2450810 */     GIR_EraseRootFromParent_Done,
     /* 2450811 */   // Label 35480: @2450811
     /* 2450811 */   GIM_Try, /*On fail goto*//*Label 35481*/ GIMT_Encode4(2450883), // Rule ID 45364 //
     /* 2450816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450848 */     // MIs[0] policy
     /* 2450848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450858 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450882 */     // GIR_Coverage, 45364,
     /* 2450882 */     GIR_EraseRootFromParent_Done,
     /* 2450883 */   // Label 35481: @2450883
     /* 2450883 */   GIM_Try, /*On fail goto*//*Label 35482*/ GIMT_Encode4(2450955), // Rule ID 45365 //
     /* 2450888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450920 */     // MIs[0] policy
     /* 2450920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450930 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450954 */     // GIR_Coverage, 45365,
     /* 2450954 */     GIR_EraseRootFromParent_Done,
     /* 2450955 */   // Label 35482: @2450955
     /* 2450955 */   GIM_Try, /*On fail goto*//*Label 35483*/ GIMT_Encode4(2451027), // Rule ID 45424 //
     /* 2450960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450992 */     // MIs[0] policy
     /* 2450992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451002 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2451005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2451023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451026 */     // GIR_Coverage, 45424,
     /* 2451026 */     GIR_EraseRootFromParent_Done,
     /* 2451027 */   // Label 35483: @2451027
     /* 2451027 */   GIM_Try, /*On fail goto*//*Label 35484*/ GIMT_Encode4(2451099), // Rule ID 45425 //
     /* 2451032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2451041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2451048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451064 */     // MIs[0] policy
     /* 2451064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451074 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2451077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2451095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451098 */     // GIR_Coverage, 45425,
     /* 2451098 */     GIR_EraseRootFromParent_Done,
     /* 2451099 */   // Label 35484: @2451099
     /* 2451099 */   GIM_Reject,
     /* 2451100 */ // Label 35476: @2451100
     /* 2451100 */ GIM_Reject,
     /* 2451101 */ // Label 35318: @2451101
     /* 2451101 */ GIM_Try, /*On fail goto*//*Label 35485*/ GIMT_Encode4(2451423),
     /* 2451106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2451109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2451112 */   GIM_Try, /*On fail goto*//*Label 35486*/ GIMT_Encode4(2451195), // Rule ID 45350 //
     /* 2451117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2451120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2451126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2451133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451153 */     // MIs[1] Operand 1
     /* 2451153 */     // No operand predicates
     /* 2451153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451157 */     // MIs[0] policy
     /* 2451157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451169 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2451172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2451191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451194 */     // GIR_Coverage, 45350,
     /* 2451194 */     GIR_EraseRootFromParent_Done,
     /* 2451195 */   // Label 35486: @2451195
     /* 2451195 */   GIM_Try, /*On fail goto*//*Label 35487*/ GIMT_Encode4(2451278), // Rule ID 45351 //
     /* 2451200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2451209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2451216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451236 */     // MIs[1] Operand 1
     /* 2451236 */     // No operand predicates
     /* 2451236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451240 */     // MIs[0] policy
     /* 2451240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451252 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2451255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451264 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2451274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451277 */     // GIR_Coverage, 45351,
     /* 2451277 */     GIR_EraseRootFromParent_Done,
     /* 2451278 */   // Label 35487: @2451278
     /* 2451278 */   GIM_Try, /*On fail goto*//*Label 35488*/ GIMT_Encode4(2451350), // Rule ID 45352 //
     /* 2451283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2451286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2451292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2451299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451315 */     // MIs[0] policy
     /* 2451315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451325 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2451328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451336 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2451346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451349 */     // GIR_Coverage, 45352,
     /* 2451349 */     GIR_EraseRootFromParent_Done,
     /* 2451350 */   // Label 35488: @2451350
     /* 2451350 */   GIM_Try, /*On fail goto*//*Label 35489*/ GIMT_Encode4(2451422), // Rule ID 45353 //
     /* 2451355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2451364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2451371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451387 */     // MIs[0] policy
     /* 2451387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451397 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2451400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2451418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451421 */     // GIR_Coverage, 45353,
     /* 2451421 */     GIR_EraseRootFromParent_Done,
     /* 2451422 */   // Label 35489: @2451422
     /* 2451422 */   GIM_Reject,
     /* 2451423 */ // Label 35485: @2451423
     /* 2451423 */ GIM_Reject,
     /* 2451424 */ // Label 35319: @2451424
     /* 2451424 */ GIM_Reject,
     /* 2451425 */ // Label 125: @2451425
     /* 2451425 */ GIM_Reject,
     /* 2451426 */ }; // Size: 2451426 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
